USE test;
CREATE TABLE IF NOT EXISTS `changesets` (  `id` bigint(20) NOT NULL auto_increment,  `user_id` bigint(20) NOT NULL,  `created_at` datetime NOT NULL,  `min_lat` int(11) default NULL,  `max_lat` int(11) default NULL,  `min_lon` int(11) default NULL,  `max_lon` int(11) default NULL,  `closed_at` datetime NOT NULL,  `num_changes` int(11) NOT NULL default '0',  PRIMARY KEY  (`id`))  DEFAULT CHARSET=utf8 ;
CREATE TABLE IF NOT EXISTS `changeset_tags` (  `id` bigint(64) NOT NULL,  `k` varchar(255) NOT NULL default '',  `v` varchar(255) NOT NULL default '',  KEY `changeset_tags_id_idx` (`id`)) DEFAULT CHARSET=utf8;
CREATE TABLE IF NOT EXISTS `current_nodes` (  `id` bigint(64) NOT NULL auto_increment,  `latitude` int(11) NOT NULL,  `longitude` int(11) NOT NULL,  `changeset_id` bigint(20) NOT NULL,  `visible` tinyint(1) NOT NULL,  `timestamp` datetime NOT NULL,  `tile` int(10) unsigned NOT NULL,  `version` bigint(20) NOT NULL,  PRIMARY KEY  (`id`),  KEY `current_nodes_timestamp_idx` (`timestamp`),  KEY `current_nodes_tile_idx` (`tile`),  KEY `changeset_id` (`changeset_id`))  DEFAULT CHARSET=utf8 ;
CREATE TABLE IF NOT EXISTS `current_node_tags` (  `id` bigint(64) NOT NULL,  `k` varchar(255) NOT NULL default '',  `v` varchar(255) NOT NULL default '',  PRIMARY KEY  (`id`,`k`)) DEFAULT CHARSET=utf8;
CREATE TABLE IF NOT EXISTS `current_relations` (  `id` bigint(64) NOT NULL auto_increment,  `changeset_id` bigint(20) NOT NULL,  `timestamp` datetime NOT NULL,  `visible` tinyint(1) NOT NULL,  `version` bigint(20) NOT NULL,  PRIMARY KEY  (`id`),  KEY `current_relations_timestamp_idx` (`timestamp`),  KEY `changeset_id` (`changeset_id`))  DEFAULT CHARSET=utf8 ;
CREATE TABLE IF NOT EXISTS `current_relation_members` (  `id` bigint(64) NOT NULL,  `member_type` enum('node','way','relation') NOT NULL default 'node',  `member_id` bigint(11) NOT NULL,  `member_role` varchar(255) NOT NULL default '',  `sequence_id` int(11) NOT NULL default '0',  PRIMARY KEY  (`id`,`member_type`,`member_id`,`member_role`,`sequence_id`),  KEY `current_relation_members_member_idx` (`member_type`,`member_id`)) DEFAULT CHARSET=utf8;
CREATE TABLE IF NOT EXISTS `current_relation_tags` (  `id` bigint(64) NOT NULL,  `k` varchar(255) NOT NULL default '',  `v` varchar(255) NOT NULL default '',  PRIMARY KEY  (`id`,`k`)) DEFAULT CHARSET=utf8;
CREATE TABLE IF NOT EXISTS `current_ways` (  `id` bigint(64) NOT NULL auto_increment,  `changeset_id` bigint(20) NOT NULL,  `timestamp` datetime NOT NULL,  `visible` tinyint(1) NOT NULL,  `version` bigint(20) NOT NULL,  PRIMARY KEY  (`id`),  KEY `current_ways_timestamp_idx` (`timestamp`),  KEY `changeset_id` (`changeset_id`))  DEFAULT CHARSET=utf8 ;
CREATE TABLE IF NOT EXISTS `current_way_nodes` (  `id` bigint(64) NOT NULL,  `node_id` bigint(64) NOT NULL,  `sequence_id` bigint(11) NOT NULL,  PRIMARY KEY  (`id`,`sequence_id`),  KEY `current_way_nodes_node_idx` (`node_id`)) DEFAULT CHARSET=utf8;
CREATE TABLE IF NOT EXISTS `current_way_tags` (  `id` bigint(64) NOT NULL,  `k` varchar(255) NOT NULL default '',  `v` varchar(255) NOT NULL default '',  PRIMARY KEY  (`id`,`k`)) DEFAULT CHARSET=utf8;
CREATE TABLE IF NOT EXISTS `diary_comments` (  `id` bigint(20) NOT NULL auto_increment,  `diary_entry_id` bigint(20) NOT NULL,  `user_id` bigint(20) NOT NULL,  `body` text NOT NULL,  `created_at` datetime NOT NULL,  `updated_at` datetime NOT NULL,  PRIMARY KEY  (`id`),  UNIQUE KEY `diary_comments_entry_id_idx` (`diary_entry_id`,`id`)) DEFAULT CHARSET=utf8 ;
CREATE TABLE IF NOT EXISTS `diary_entries` (  `id` bigint(20) NOT NULL auto_increment,  `user_id` bigint(20) NOT NULL,  `title` varchar(255) NOT NULL,  `body` text NOT NULL,  `created_at` datetime NOT NULL,  `updated_at` datetime NOT NULL,  `latitude` double default NULL,  `longitude` double default NULL,  `language` varchar(3) default NULL,  PRIMARY KEY  (`id`)) DEFAULT CHARSET=utf8 ;
CREATE TABLE IF NOT EXISTS `friends` (  `id` bigint(20) NOT NULL auto_increment,  `user_id` bigint(20) NOT NULL,  `friend_user_id` bigint(20) NOT NULL,  PRIMARY KEY  (`id`),  KEY `user_id_idx` (`friend_user_id`),  KEY `friends_user_id_idx` (`user_id`)) DEFAULT CHARSET=utf8 ;
CREATE TABLE IF NOT EXISTS `gps_points` (  `altitude` float default NULL,  `trackid` int(11) NOT NULL,  `latitude` int(11) NOT NULL,  `longitude` int(11) NOT NULL,  `gpx_id` bigint(64) NOT NULL,  `timestamp` datetime default NULL,  `tile` int(10) unsigned NOT NULL,  KEY `points_gpxid_idx` (`gpx_id`),  KEY `points_tile_idx` (`tile`)) DEFAULT CHARSET=utf8;
CREATE TABLE IF NOT EXISTS `gpx_files` (  `id` bigint(64) NOT NULL auto_increment,  `user_id` bigint(20) NOT NULL,  `visible` tinyint(1) NOT NULL default '1',  `name` varchar(255) NOT NULL default '',  `size` bigint(20) default NULL,  `latitude` double default NULL,  `longitude` double default NULL,  `timestamp` datetime NOT NULL,  `public` tinyint(1) NOT NULL default '1',  `description` varchar(255) NOT NULL default '',  `inserted` tinyint(1) NOT NULL,  PRIMARY KEY  (`id`),  KEY `gpx_files_timestamp_idx` (`timestamp`),  KEY `gpx_files_visible_public_idx` (`visible`,`public`),  KEY `gpx_files_user_id_idx` (`user_id`)) DEFAULT CHARSET=utf8 ;
CREATE TABLE IF NOT EXISTS `gpx_file_tags` (  `gpx_id` bigint(64) NOT NULL default '0',  `tag` varchar(255) NOT NULL,  `id` bigint(20) NOT NULL auto_increment,  PRIMARY KEY  (`id`),  KEY `gpx_file_tags_gpxid_idx` (`gpx_id`),  KEY `gpx_file_tags_tag_idx` (`tag`)) DEFAULT CHARSET=utf8 ;
CREATE TABLE IF NOT EXISTS `messages` (  `id` bigint(20) NOT NULL auto_increment,  `from_user_id` bigint(20) NOT NULL,  `title` varchar(255) NOT NULL,  `body` text NOT NULL,  `sent_on` datetime NOT NULL,  `message_read` tinyint(1) NOT NULL default '0',  `to_user_id` bigint(20) NOT NULL,  PRIMARY KEY  (`id`),  KEY `messages_to_user_id_idx` (`to_user_id`)) DEFAULT CHARSET=utf8 ;
CREATE TABLE IF NOT EXISTS `nodes` (  `id` bigint(64) NOT NULL,  `latitude` int(11) NOT NULL,  `longitude` int(11) NOT NULL,  `changeset_id` bigint(20) NOT NULL,  `visible` tinyint(1) NOT NULL,  `timestamp` datetime NOT NULL,  `tile` int(10) unsigned NOT NULL,  `version` bigint(20) NOT NULL,  PRIMARY KEY  (`id`,`version`),  KEY `nodes_timestamp_idx` (`timestamp`),  KEY `nodes_tile_idx` (`tile`),  KEY `changeset_id` (`changeset_id`)) DEFAULT CHARSET=utf8;
CREATE TABLE IF NOT EXISTS `node_tags` (  `id` bigint(64) NOT NULL,  `version` bigint(20) NOT NULL,  `k` varchar(255) NOT NULL default '',  `v` varchar(255) NOT NULL default '',  PRIMARY KEY  (`id`,`version`,`k`)) DEFAULT CHARSET=utf8;
CREATE TABLE IF NOT EXISTS `relations` (  `id` bigint(64) NOT NULL default '0',  `changeset_id` bigint(20) NOT NULL,  `timestamp` datetime NOT NULL,  `version` bigint(20) NOT NULL,  `visible` tinyint(1) NOT NULL default '1',  PRIMARY KEY  (`id`,`version`),  KEY `relations_timestamp_idx` (`timestamp`),  KEY `changeset_id` (`changeset_id`)) DEFAULT CHARSET=utf8;
CREATE TABLE IF NOT EXISTS `relation_members` (  `id` bigint(64) NOT NULL default '0',  `member_type` enum('node','way','relation') NOT NULL default 'node',  `member_id` bigint(11) NOT NULL,  `member_role` varchar(255) NOT NULL default '',  `version` bigint(20) NOT NULL default '0',  `sequence_id` int(11) NOT NULL default '0',  PRIMARY KEY  (`id`,`version`,`member_type`,`member_id`,`member_role`,`sequence_id`),  KEY `relation_members_member_idx` (`member_type`,`member_id`)) DEFAULT CHARSET=utf8;
CREATE TABLE IF NOT EXISTS `relation_tags` (  `id` bigint(64) NOT NULL default '0',  `k` varchar(255) NOT NULL default '',  `v` varchar(255) NOT NULL default '',  `version` bigint(20) NOT NULL,  PRIMARY KEY  (`id`,`version`,`k`)) DEFAULT CHARSET=utf8;
CREATE TABLE IF NOT EXISTS `schema_migrations` (  `version` varchar(255) NOT NULL,  UNIQUE KEY `unique_schema_migrations` (`version`)) DEFAULT CHARSET=utf8;
CREATE TABLE IF NOT EXISTS `sessions` (  `id` int(11) NOT NULL auto_increment,  `session_id` varchar(255) default NULL,  `data` text,  `created_at` datetime default NULL,  `updated_at` datetime default NULL,  PRIMARY KEY  (`id`),  UNIQUE KEY `sessions_session_id_idx` (`session_id`))  DEFAULT CHARSET=utf8 ;
CREATE TABLE IF NOT EXISTS `users` (  `email` varchar(255) NOT NULL,  `id` bigint(20) NOT NULL auto_increment,  `active` int(11) NOT NULL default '0',  `pass_crypt` varchar(255) NOT NULL,  `creation_time` datetime NOT NULL,  `display_name` varchar(255) NOT NULL default '',  `data_public` tinyint(1) NOT NULL default '0',  `description` text NOT NULL,  `home_lat` double default NULL,  `home_lon` double default NULL,  `home_zoom` smallint(6) default '3',  `nearby` int(11) default '50',  `pass_salt` varchar(255) default NULL,  `image` text,  `administrator` tinyint(1) NOT NULL default '0',  `email_valid` tinyint(1) NOT NULL default '0',  `new_email` varchar(255) default NULL,  `visible` tinyint(1) NOT NULL default '1',  `creation_ip` varchar(255) default NULL,  PRIMARY KEY  (`id`),  UNIQUE KEY `users_email_idx` (`email`),  UNIQUE KEY `users_display_name_idx` (`display_name`))  DEFAULT CHARSET=utf8 ;
CREATE TABLE IF NOT EXISTS `user_preferences` (  `user_id` bigint(20) NOT NULL,  `k` varchar(255) NOT NULL,  `v` varchar(255) NOT NULL,  PRIMARY KEY  (`user_id`,`k`)) DEFAULT CHARSET=utf8;
CREATE TABLE IF NOT EXISTS `user_tokens` (  `id` bigint(20) NOT NULL auto_increment,  `user_id` bigint(20) NOT NULL,  `token` varchar(255) NOT NULL,  `expiry` datetime NOT NULL,  PRIMARY KEY  (`id`),  UNIQUE KEY `user_tokens_token_idx` (`token`),  KEY `user_tokens_user_id_idx` (`user_id`)) DEFAULT CHARSET=utf8 ;
CREATE TABLE IF NOT EXISTS `ways` (  `id` bigint(64) NOT NULL default '0',  `changeset_id` bigint(20) NOT NULL,  `timestamp` datetime NOT NULL,  `version` bigint(20) NOT NULL,  `visible` tinyint(1) NOT NULL default '1',  PRIMARY KEY  (`id`,`version`),  KEY `ways_timestamp_idx` (`timestamp`),  KEY `changeset_id` (`changeset_id`)) DEFAULT CHARSET=utf8;
CREATE TABLE IF NOT EXISTS `way_nodes` (  `id` bigint(64) NOT NULL,  `node_id` bigint(64) NOT NULL,  `version` bigint(20) NOT NULL,  `sequence_id` bigint(11) NOT NULL,  PRIMARY KEY  (`id`,`version`,`sequence_id`),  KEY `way_nodes_node_idx` (`node_id`)) DEFAULT CHARSET=utf8;
CREATE TABLE IF NOT EXISTS `way_tags` (  `id` bigint(64) NOT NULL default '0',  `k` varchar(255) NOT NULL,  `v` varchar(255) NOT NULL,  `version` bigint(20) NOT NULL,  PRIMARY KEY  (`id`,`version`,`k`)) DEFAULT CHARSET=utf8;
INSERT INTO `changeset_tags` VALUES (0,'created_by','Osmosis 0.36'),(0,'replication','true'),(232546,'created_by','Osmosis 0.36'),(232546,'replication','true'),(427965,'created_by','Osmosis 0.36'),(427965,'replication','true'),(2762,'created_by','Osmosis 0.36'),(2762,'replication','true'),(2895121,'created_by','Osmosis 0.36'),(2895121,'replication','true'),(188228,'created_by','Osmosis 0.36'),(188228,'replication','true'),(5671401,'created_by','Osmosis 0.36'),(5671401,'replication','true'),(2774,'created_by','Osmosis 0.36'),(2774,'replication','true'),(426786,'created_by','Osmosis 0.36'),(426786,'replication','true'),(454632,'created_by','Osmosis 0.36'),(454632,'replication','true'),(495907,'created_by','Osmosis 0.36'),(495907,'replication','true'),(434787,'created_by','Osmosis 0.36'),(434787,'replication','true'),(110477,'created_by','Osmosis 0.36'),(110477,'replication','true'),(784366,'created_by','Osmosis 0.36'),(784366,'replication','true'),(4133451,'created_by','Osmosis 0.36'),(4133451,'replication','true'),(592895,'created_by','Osmosis 0.36'),(592895,'replication','true'),(508959,'created_by','Osmosis 0.36'),(508959,'replication','true'),(206510,'created_by','Osmosis 0.36'),(206510,'replication','true'),(198831,'created_by','Osmosis 0.36'),(198831,'replication','true'),(443749,'created_by','Osmosis 0.36'),(443749,'replication','true'),(4963967,'created_by','Osmosis 0.36'),(4963967,'replication','true'),(4963942,'created_by','Osmosis 0.36'),(4963942,'replication','true'),(5107412,'created_by','Osmosis 0.36'),(5107412,'replication','true'),(437032,'created_by','Osmosis 0.36'),(437032,'replication','true'),(840745,'created_by','Osmosis 0.36'),(840745,'replication','true'),(3916355,'created_by','Osmosis 0.36'),(3916355,'replication','true'),(462689,'created_by','Osmosis 0.36'),(462689,'replication','true'),(439281,'created_by','Osmosis 0.36'),(439281,'replication','true'),(305941,'created_by','Osmosis 0.36'),(305941,'replication','true'),(443527,'created_by','Osmosis 0.36'),(443527,'replication','true'),(104780,'created_by','Osmosis 0.36'),(104780,'replication','true'),(820251,'created_by','Osmosis 0.36'),(820251,'replication','true'),(56648,'created_by','Osmosis 0.36'),(56648,'replication','true'),(462438,'created_by','Osmosis 0.36'),(462438,'replication','true'),(432736,'created_by','Osmosis 0.36'),(432736,'replication','true'),(258874,'created_by','Osmosis 0.36'),(258874,'replication','true'),(697263,'created_by','Osmosis 0.36'),(697263,'replication','true'),(978767,'created_by','Osmosis 0.36'),(978767,'replication','true'),(91018,'created_by','Osmosis 0.36'),(91018,'replication','true'),(981792,'created_by','Osmosis 0.36'),(981792,'replication','true'),(461502,'created_by','Osmosis 0.36'),(461502,'replication','true'),(463410,'created_by','Osmosis 0.36'),(463410,'replication','true'),(370566,'created_by','Osmosis 0.36'),(370566,'replication','true'),(435967,'created_by','Osmosis 0.36'),(435967,'replication','true'),(174860,'created_by','Osmosis 0.36'),(174860,'replication','true'),(210114,'created_by','Osmosis 0.36'),(210114,'replication','true'),(448710,'created_by','Osmosis 0.36'),(448710,'replication','true'),(306164,'created_by','Osmosis 0.36'),(306164,'replication','true'),(183661,'created_by','Osmosis 0.36'),(183661,'replication','true'),(501202,'created_by','Osmosis 0.36'),(501202,'replication','true'),(498434,'created_by','Osmosis 0.36'),(498434,'replication','true'),(4804396,'created_by','Osmosis 0.36'),(4804396,'replication','true'),(725665,'created_by','Osmosis 0.36'),(725665,'replication','true'),(1684788,'created_by','Osmosis 0.36'),(1684788,'replication','true'),(615859,'created_by','Osmosis 0.36'),(615859,'replication','true'),(440632,'created_by','Osmosis 0.36'),(440632,'replication','true'),(513066,'created_by','Osmosis 0.36'),(513066,'replication','true'),(352026,'created_by','Osmosis 0.36'),(352026,'replication','true'),(864892,'created_by','Osmosis 0.36'),(864892,'replication','true'),(1258067,'created_by','Osmosis 0.36'),(1258067,'replication','true'),(538211,'created_by','Osmosis 0.36'),(538211,'replication','true'),(1882243,'created_by','Osmosis 0.36'),(1882243,'replication','true'),(72964,'created_by','Osmosis 0.36'),(72964,'replication','true'),(2836771,'created_by','Osmosis 0.36'),(2836771,'replication','true'),(373445,'created_by','Osmosis 0.36'),(373445,'replication','true'),(446582,'created_by','Osmosis 0.36'),(446582,'replication','true'),(19873,'created_by','Osmosis 0.36'),(19873,'replication','true'),(501218,'created_by','Osmosis 0.36'),(501218,'replication','true'),(25362,'created_by','Osmosis 0.36'),(25362,'replication','true'),(21109,'created_by','Osmosis 0.36'),(21109,'replication','true'),(863220,'created_by','Osmosis 0.36'),(863220,'replication','true'),(27626,'created_by','Osmosis 0.36'),(27626,'replication','true'),(372139,'created_by','Osmosis 0.36'),(372139,'replication','true'),(1165666,'created_by','Osmosis 0.36'),(1165666,'replication','true'),(1165813,'created_by','Osmosis 0.36'),(1165813,'replication','true'),(557925,'created_by','Osmosis 0.36'),(557925,'replication','true'),(4652669,'created_by','Osmosis 0.36'),(4652669,'replication','true'),(363778,'created_by','Osmosis 0.36'),(363778,'replication','true'),(4106774,'created_by','Osmosis 0.36'),(4106774,'replication','true'),(320551,'created_by','Osmosis 0.36'),(320551,'replication','true'),(502899,'created_by','Osmosis 0.36'),(502899,'replication','true'),(327248,'created_by','Osmosis 0.36'),(327248,'replication','true'),(226881,'created_by','Osmosis 0.36'),(226881,'replication','true'),(1074615,'created_by','Osmosis 0.36'),(1074615,'replication','true'),(423843,'created_by','Osmosis 0.36'),(423843,'replication','true'),(427200,'created_by','Osmosis 0.36'),(427200,'replication','true'),(439103,'created_by','Osmosis 0.36'),(439103,'replication','true'),(844916,'created_by','Osmosis 0.36'),(844916,'replication','true'),(787878,'created_by','Osmosis 0.36'),(787878,'replication','true'),(181856,'created_by','Osmosis 0.36'),(181856,'replication','true'),(708302,'created_by','Osmosis 0.36'),(708302,'replication','true'),(494030,'created_by','Osmosis 0.36'),(494030,'replication','true'),(2395774,'created_by','Osmosis 0.36'),(2395774,'replication','true'),(225225,'created_by','Osmosis 0.36'),(225225,'replication','true'),(104599,'created_by','Osmosis 0.36'),(104599,'replication','true'),(263367,'created_by','Osmosis 0.36'),(263367,'replication','true'),(312325,'created_by','Osmosis 0.36'),(312325,'replication','true'),(2191272,'created_by','Osmosis 0.36'),(2191272,'replication','true'),(653218,'created_by','Osmosis 0.36'),(653218,'replication','true'),(5077512,'created_by','Osmosis 0.36'),(5077512,'replication','true'),(4055320,'created_by','Osmosis 0.36'),(4055320,'replication','true'),(197512,'created_by','Osmosis 0.36'),(197512,'replication','true'),(91631,'created_by','Osmosis 0.36'),(91631,'replication','true'),(239859,'created_by','Osmosis 0.36'),(239859,'replication','true'),(1075389,'created_by','Osmosis 0.36'),(1075389,'replication','true'),(329152,'created_by','Osmosis 0.36'),(329152,'replication','true'),(441038,'created_by','Osmosis 0.36'),(441038,'replication','true'),(362976,'created_by','Osmosis 0.36'),(362976,'replication','true'),(1293006,'created_by','Osmosis 0.36'),(1293006,'replication','true'),(426052,'created_by','Osmosis 0.36'),(426052,'replication','true'),(459604,'created_by','Osmosis 0.36'),(459604,'replication','true'),(862435,'created_by','Osmosis 0.36'),(862435,'replication','true'),(470312,'created_by','Osmosis 0.36'),(470312,'replication','true'),(2369737,'created_by','Osmosis 0.36'),(2369737,'replication','true'),(675187,'created_by','Osmosis 0.36'),(675187,'replication','true'),(2369619,'created_by','Osmosis 0.36'),(2369619,'replication','true'),(33354,'created_by','Osmosis 0.36'),(33354,'replication','true'),(2191328,'created_by','Osmosis 0.36'),(2191328,'replication','true'),(258909,'created_by','Osmosis 0.36'),(258909,'replication','true'),(3475126,'created_by','Osmosis 0.36'),(3475126,'replication','true'),(4114763,'created_by','Osmosis 0.36'),(4114763,'replication','true'),(404186,'created_by','Osmosis 0.36'),(404186,'replication','true'),(478731,'created_by','Osmosis 0.36'),(478731,'replication','true'),(437534,'created_by','Osmosis 0.36'),(437534,'replication','true'),(599374,'created_by','Osmosis 0.36'),(599374,'replication','true'),(621592,'created_by','Osmosis 0.36'),(621592,'replication','true'),(4161539,'created_by','Osmosis 0.36'),(4161539,'replication','true'),(854025,'created_by','Osmosis 0.36'),(854025,'replication','true'),(609884,'created_by','Osmosis 0.36'),(609884,'replication','true'),(837556,'created_by','Osmosis 0.36'),(837556,'replication','true'),(216961,'created_by','Osmosis 0.36'),(216961,'replication','true'),(870814,'created_by','Osmosis 0.36'),(870814,'replication','true'),(1111251,'created_by','Osmosis 0.36'),(1111251,'replication','true'),(986514,'created_by','Osmosis 0.36'),(986514,'replication','true'),(1075282,'created_by','Osmosis 0.36'),(1075282,'replication','true'),(1423654,'created_by','Osmosis 0.36'),(1423654,'replication','true'),(1074360,'created_by','Osmosis 0.36'),(1074360,'replication','true'),(1074995,'created_by','Osmosis 0.36'),(1074995,'replication','true'),(1075171,'created_by','Osmosis 0.36'),(1075171,'replication','true'),(1075235,'created_by','Osmosis 0.36'),(1075235,'replication','true'),(1165753,'created_by','Osmosis 0.36'),(1165753,'replication','true'),(1166143,'created_by','Osmosis 0.36'),(1166143,'replication','true'),(1166091,'created_by','Osmosis 0.36'),(1166091,'replication','true'),(1166268,'created_by','Osmosis 0.36'),(1166268,'replication','true'),(2138435,'created_by','Osmosis 0.36'),(2138435,'replication','true'),(1166650,'created_by','Osmosis 0.36'),(1166650,'replication','true'),(1166792,'created_by','Osmosis 0.36'),(1166792,'replication','true'),(1276166,'created_by','Osmosis 0.36'),(1276166,'replication','true'),(1816099,'created_by','Osmosis 0.36'),(1816099,'replication','true'),(1816161,'created_by','Osmosis 0.36'),(1816161,'replication','true'),(1816208,'created_by','Osmosis 0.36'),(1816208,'replication','true'),(1851615,'created_by','Osmosis 0.36'),(1851615,'replication','true'),(2074125,'created_by','Osmosis 0.36'),(2074125,'replication','true'),(2190495,'created_by','Osmosis 0.36'),(2190495,'replication','true'),(2074345,'created_by','Osmosis 0.36'),(2074345,'replication','true'),(2074369,'created_by','Osmosis 0.36'),(2074369,'replication','true'),(2190404,'created_by','Osmosis 0.36'),(2190404,'replication','true'),(2190594,'created_by','Osmosis 0.36'),(2190594,'replication','true'),(2190782,'created_by','Osmosis 0.36'),(2190782,'replication','true'),(2190826,'created_by','Osmosis 0.36'),(2190826,'replication','true'),(2191053,'created_by','Osmosis 0.36'),(2191053,'replication','true'),(2191112,'created_by','Osmosis 0.36'),(2191112,'replication','true'),(2357704,'created_by','Osmosis 0.36'),(2357704,'replication','true'),(2357182,'created_by','Osmosis 0.36'),(2357182,'replication','true'),(2357481,'created_by','Osmosis 0.36'),(2357481,'replication','true'),(2387382,'created_by','Osmosis 0.36'),(2387382,'replication','true'),(2695454,'created_by','Osmosis 0.36'),(2695454,'replication','true'),(2730324,'created_by','Osmosis 0.36'),(2730324,'replication','true'),(2746094,'created_by','Osmosis 0.36'),(2746094,'replication','true'),(2746135,'created_by','Osmosis 0.36'),(2746135,'replication','true'),(4101446,'created_by','Osmosis 0.36'),(4101446,'replication','true'),(2747796,'created_by','Osmosis 0.36'),(2747796,'replication','true'),(2756081,'created_by','Osmosis 0.36'),(2756081,'replication','true'),(2756091,'created_by','Osmosis 0.36'),(2756091,'replication','true'),(2759915,'created_by','Osmosis 0.36'),(2759915,'replication','true'),(3388565,'created_by','Osmosis 0.36'),(3388565,'replication','true'),(2760016,'created_by','Osmosis 0.36'),(2760016,'replication','true'),(2788590,'created_by','Osmosis 0.36'),(2788590,'replication','true'),(2788599,'created_by','Osmosis 0.36'),(2788599,'replication','true'),(2788603,'created_by','Osmosis 0.36'),(2788603,'replication','true'),(2788608,'created_by','Osmosis 0.36'),(2788608,'replication','true'),(2788613,'created_by','Osmosis 0.36'),(2788613,'replication','true'),(2788623,'created_by','Osmosis 0.36'),(2788623,'replication','true'),(2788624,'created_by','Osmosis 0.36'),(2788624,'replication','true'),(2791232,'created_by','Osmosis 0.36'),(2791232,'replication','true'),(2791237,'created_by','Osmosis 0.36'),(2791237,'replication','true'),(2791248,'created_by','Osmosis 0.36'),(2791248,'replication','true'),(5709666,'created_by','Osmosis 0.36'),(5709666,'replication','true'),(2791251,'created_by','Osmosis 0.36'),(2791251,'replication','true'),(2791253,'created_by','Osmosis 0.36'),(2791253,'replication','true'),(2791257,'created_by','Osmosis 0.36'),(2791257,'replication','true'),(2791267,'created_by','Osmosis 0.36'),(2791267,'replication','true'),(4108069,'created_by','Osmosis 0.36'),(4108069,'replication','true'),(3283462,'created_by','Osmosis 0.36'),(3283462,'replication','true'),(3373117,'created_by','Osmosis 0.36'),(3373117,'replication','true'),(3373535,'created_by','Osmosis 0.36'),(3373535,'replication','true'),(3373181,'created_by','Osmosis 0.36'),(3373181,'replication','true'),(5833623,'created_by','Osmosis 0.36'),(5833623,'replication','true'),(4092807,'created_by','Osmosis 0.36'),(4092807,'replication','true'),(4161868,'created_by','Osmosis 0.36'),(4161868,'replication','true'),(4092743,'created_by','Osmosis 0.36'),(4092743,'replication','true'),(4083024,'created_by','Osmosis 0.36'),(4083024,'replication','true'),(3724172,'created_by','Osmosis 0.36'),(3724172,'replication','true'),(4107810,'created_by','Osmosis 0.36'),(4107810,'replication','true'),(4133447,'created_by','Osmosis 0.36'),(4133447,'replication','true'),(3731851,'created_by','Osmosis 0.36'),(3731851,'replication','true'),(3727238,'created_by','Osmosis 0.36'),(3727238,'replication','true'),(3730430,'created_by','Osmosis 0.36'),(3730430,'replication','true'),(3731738,'created_by','Osmosis 0.36'),(3731738,'replication','true'),(4763364,'created_by','Osmosis 0.36'),(4763364,'replication','true'),(3903073,'created_by','Osmosis 0.36'),(3903073,'replication','true'),(4076773,'created_by','Osmosis 0.36'),(4076773,'replication','true'),(4099383,'created_by','Osmosis 0.36'),(4099383,'replication','true'),(4076872,'created_by','Osmosis 0.36'),(4076872,'replication','true'),(4076934,'created_by','Osmosis 0.36'),(4076934,'replication','true'),(4077060,'created_by','Osmosis 0.36'),(4077060,'replication','true'),(4077132,'created_by','Osmosis 0.36'),(4077132,'replication','true'),(4161911,'created_by','Osmosis 0.36'),(4161911,'replication','true'),(4077213,'created_by','Osmosis 0.36'),(4077213,'replication','true'),(4082908,'created_by','Osmosis 0.36'),(4082908,'replication','true'),(4083006,'created_by','Osmosis 0.36'),(4083006,'replication','true'),(4101592,'created_by','Osmosis 0.36'),(4101592,'replication','true'),(4092770,'created_by','Osmosis 0.36'),(4092770,'replication','true'),(4092963,'created_by','Osmosis 0.36'),(4092963,'replication','true'),(4096040,'created_by','Osmosis 0.36'),(4096040,'replication','true'),(4096072,'created_by','Osmosis 0.36'),(4096072,'replication','true'),(4096095,'created_by','Osmosis 0.36'),(4096095,'replication','true'),(4096166,'created_by','Osmosis 0.36'),(4096166,'replication','true'),(4096186,'created_by','Osmosis 0.36'),(4096186,'replication','true'),(4096227,'created_by','Osmosis 0.36'),(4096227,'replication','true'),(4098619,'created_by','Osmosis 0.36'),(4098619,'replication','true'),(4098931,'created_by','Osmosis 0.36'),(4098931,'replication','true'),(4100909,'created_by','Osmosis 0.36'),(4100909,'replication','true'),(4100978,'created_by','Osmosis 0.36'),(4100978,'replication','true'),(4101078,'created_by','Osmosis 0.36'),(4101078,'replication','true'),(4101245,'created_by','Osmosis 0.36'),(4101245,'replication','true'),(4101313,'created_by','Osmosis 0.36'),(4101313,'replication','true'),(4108991,'created_by','Osmosis 0.36'),(4108991,'replication','true'),(4115604,'created_by','Osmosis 0.36'),(4115604,'replication','true'),(4115657,'created_by','Osmosis 0.36'),(4115657,'replication','true'),(4159615,'created_by','Osmosis 0.36'),(4159615,'replication','true'),(4184201,'created_by','Osmosis 0.36'),(4184201,'replication','true'),(4174714,'created_by','Osmosis 0.36'),(4174714,'replication','true'),(4375683,'created_by','Osmosis 0.36'),(4375683,'replication','true'),(5043123,'created_by','Osmosis 0.36'),(5043123,'replication','true'),(5107450,'created_by','Osmosis 0.36'),(5107450,'replication','true'),(5236475,'created_by','Osmosis 0.36'),(5236475,'replication','true'),(5236785,'created_by','Osmosis 0.36'),(5236785,'replication','true'),(5363414,'created_by','Osmosis 0.36'),(5363414,'replication','true'),(5671193,'created_by','Osmosis 0.36'),(5671193,'replication','true'),(5678739,'created_by','Osmosis 0.36'),(5678739,'replication','true'),(5671416,'created_by','Osmosis 0.36'),(5671416,'replication','true'),(5674807,'created_by','Osmosis 0.36'),(5674807,'replication','true'),(5689624,'created_by','Osmosis 0.36'),(5689624,'replication','true'),(5678757,'created_by','Osmosis 0.36'),(5678757,'replication','true'),(5702328,'created_by','Osmosis 0.36'),(5702328,'replication','true'),(5710014,'created_by','Osmosis 0.36'),(5710014,'replication','true'),(5806005,'created_by','Osmosis 0.36'),(5806005,'replication','true'),(5866082,'created_by','Osmosis 0.36'),(5866082,'replication','true'),(531541,'created_by','Osmosis 0.36'),(531541,'replication','true'),(189418,'created_by','Osmosis 0.36'),(189418,'replication','true'),(553642,'created_by','Osmosis 0.36'),(553642,'replication','true'),(3878347,'created_by','Osmosis 0.36'),(3878347,'replication','true'),(3100730,'created_by','Osmosis 0.36'),(3100730,'replication','true'),(981922,'created_by','Osmosis 0.36'),(981922,'replication','true'),(2369688,'created_by','Osmosis 0.36'),(2369688,'replication','true'),(951833,'created_by','Osmosis 0.36'),(951833,'replication','true'),(5025308,'created_by','Osmosis 0.36'),(5025308,'replication','true'),(433922,'created_by','Osmosis 0.36'),(433922,'replication','true'),(3132766,'created_by','Osmosis 0.36'),(3132766,'replication','true'),(4312140,'created_by','Osmosis 0.36'),(4312140,'replication','true'),(307506,'created_by','Osmosis 0.36'),(307506,'replication','true'),(3936411,'created_by','Osmosis 0.36'),(3936411,'replication','true'),(353783,'created_by','Osmosis 0.36'),(353783,'replication','true'),(369842,'created_by','Osmosis 0.36'),(369842,'replication','true'),(441677,'created_by','Osmosis 0.36'),(441677,'replication','true'),(5694915,'created_by','Osmosis 0.36'),(5694915,'replication','true'),(3882859,'created_by','Osmosis 0.36'),(3882859,'replication','true'),(3916410,'created_by','Osmosis 0.36'),(3916410,'replication','true'),(73843,'created_by','Osmosis 0.36'),(73843,'replication','true'),(3124867,'created_by','Osmosis 0.36'),(3124867,'replication','true'),(4159744,'created_by','Osmosis 0.36'),(4159744,'replication','true'),(3373175,'created_by','Osmosis 0.36'),(3373175,'replication','true'),(412437,'created_by','Osmosis 0.36'),(412437,'replication','true'),(5025265,'created_by','Osmosis 0.36'),(5025265,'replication','true'),(5430086,'created_by','Osmosis 0.36'),(5430086,'replication','true'),(3956455,'created_by','Osmosis 0.36'),(3956455,'replication','true'),(2736717,'created_by','Osmosis 0.36'),(2736717,'replication','true'),(502306,'created_by','Osmosis 0.36'),(502306,'replication','true'),(508355,'created_by','Osmosis 0.36'),(508355,'replication','true'),(2213421,'created_by','Osmosis 0.36'),(2213421,'replication','true'),(2191249,'created_by','Osmosis 0.36'),(2191249,'replication','true'),(2191215,'created_by','Osmosis 0.36'),(2191215,'replication','true'),(2318266,'created_by','Osmosis 0.36'),(2318266,'replication','true'),(3933161,'created_by','Osmosis 0.36'),(3933161,'replication','true'),(565034,'created_by','Osmosis 0.36'),(565034,'replication','true'),(537461,'created_by','Osmosis 0.36'),(537461,'replication','true'),(4099888,'created_by','Osmosis 0.36'),(4099888,'replication','true'),(4083396,'created_by','Osmosis 0.36'),(4083396,'replication','true'),(2688289,'created_by','Osmosis 0.36'),(2688289,'replication','true'),(2788592,'created_by','Osmosis 0.36'),(2788592,'replication','true'),(2788617,'created_by','Osmosis 0.36'),(2788617,'replication','true'),(4083044,'created_by','Osmosis 0.36'),(4083044,'replication','true'),(4138831,'created_by','Osmosis 0.36'),(4138831,'replication','true'),(3831437,'created_by','Osmosis 0.36'),(3831437,'replication','true'),(4077244,'created_by','Osmosis 0.36'),(4077244,'replication','true'),(4077310,'created_by','Osmosis 0.36'),(4077310,'replication','true'),(4083737,'created_by','Osmosis 0.36'),(4083737,'replication','true'),(4083476,'created_by','Osmosis 0.36'),(4083476,'replication','true'),(5866046,'created_by','Osmosis 0.36'),(5866046,'replication','true'),(4091122,'created_by','Osmosis 0.36'),(4091122,'replication','true'),(5860604,'created_by','Osmosis 0.36'),(5860604,'replication','true'),(5061350,'created_by','Osmosis 0.36'),(5061350,'replication','true'),(5641978,'created_by','Osmosis 0.36'),(5641978,'replication','true'),(3612902,'created_by','Osmosis 0.36'),(3612902,'replication','true'),(4072906,'created_by','Osmosis 0.36'),(4072906,'replication','true'),(5636480,'created_by','Osmosis 0.36'),(5636480,'replication','true'),(4475595,'created_by','Osmosis 0.36'),(4475595,'replication','true'),(5808039,'created_by','Osmosis 0.36'),(5808039,'replication','true');
INSERT INTO `changesets` VALUES (1,-1,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(232546,10927,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(427965,10927,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(2762,1297,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(2895121,34536,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(188228,34536,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(5671401,213594,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(2774,1297,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(426786,10927,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(454632,10927,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(495907,34536,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(434787,10927,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(110477,29084,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(784366,10927,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(4133451,246989,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(592895,34536,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(508959,10927,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(206510,34536,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(198831,10927,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(443749,10927,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(4963967,93506,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(4963942,93506,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(5107412,93506,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(437032,34536,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(840745,34536,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(3916355,93506,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(462689,10927,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(439281,10927,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(305941,34536,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(443527,10927,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(104780,34536,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(820251,34536,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(56648,34536,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(462438,34536,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(432736,10927,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(258874,25804,'2010-09-28 10:22:40',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:40',0),(697263,84859,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(978767,119803,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(91018,43280,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(981792,119803,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(461502,34536,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(463410,10927,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(370566,10927,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(435967,10927,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(174860,34536,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(210114,34536,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(448710,34536,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(306164,34536,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(183661,34536,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(501202,34536,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(498434,34536,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(4804396,275821,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(725665,34536,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(1684788,90394,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(615859,34536,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(440632,34536,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(513066,34536,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(352026,34536,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(864892,22398,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(1258067,70696,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(538211,10927,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(1882243,34536,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(72964,34536,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(2836771,34536,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(373445,4363,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(446582,10091,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(19873,34536,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(501218,10927,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(25362,34536,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(21109,34536,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(863220,22398,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(27626,34536,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(372139,22398,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(1165666,34536,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(1165813,34536,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(557925,10927,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(4652669,56597,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(363778,10927,'2010-09-28 10:22:41',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:41',0),(4106774,241566,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(320551,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(502899,10927,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(327248,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(226881,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(1074615,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(423843,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(427200,10091,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(439103,10091,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(844916,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(787878,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(181856,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(708302,10927,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(494030,10927,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(2395774,24965,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(225225,10927,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(104599,10927,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(263367,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(312325,70696,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(2191272,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(653218,20502,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(5077512,210115,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(4055320,6975,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(197512,10927,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(91631,10927,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(239859,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(1075389,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(329152,10927,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(441038,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(362976,10927,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(1293006,70696,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(426052,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(459604,10927,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(862435,22398,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(470312,10927,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(2369737,115019,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(675187,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(2369619,115019,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(33354,10927,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(2191328,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(258909,29717,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(3475126,5657,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(4114763,25762,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(404186,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(478731,53957,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(437534,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(599374,86654,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(621592,86654,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(4161539,241566,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(854025,17497,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(609884,22398,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(837556,91785,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(216961,22398,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(870814,86654,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(1111251,70696,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(986514,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(1075282,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(1423654,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(1074360,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(1074995,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(1075171,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(1075235,34536,'2010-09-28 10:22:42',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:42',0),(1165753,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(1166143,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(1166091,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(1166268,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2138435,152289,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(1166650,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(1166792,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(1276166,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(1816099,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(1816161,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(1816208,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(1851615,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2074125,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2190495,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2074345,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2074369,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2190404,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2190594,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2190782,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2190826,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2191053,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2191112,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2357704,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2357182,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2357481,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2387382,26868,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2695454,143308,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2730324,143308,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2746094,18149,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2746135,18149,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4101446,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2747796,143308,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2756081,143308,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2756091,143308,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2759915,18149,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(3388565,6367,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2760016,18149,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2788590,143308,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2788599,143308,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2788603,143308,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2788608,143308,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2788613,143308,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2788623,143308,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2788624,143308,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2791232,143308,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2791237,143308,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2791248,143308,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(5709666,306172,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2791251,143308,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2791253,143308,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2791257,143308,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2791267,143308,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4108069,241566,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(3283462,10927,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(3373117,6367,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(3373535,6367,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(3373181,6367,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(5833623,65148,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4092807,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4161868,241566,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4092743,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4083024,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(3724172,148173,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4107810,241566,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4133447,241566,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(3731851,148173,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(3727238,148173,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(3730430,148173,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(3731738,148173,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4763364,6975,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(3903073,90394,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4076773,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4099383,241566,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4076872,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4076934,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4077060,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4077132,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4161911,241566,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4077213,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4082908,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4083006,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4101592,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4092770,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4092963,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4096040,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4096072,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4096095,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4096166,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4096186,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4096227,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4098619,241566,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4098931,241566,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4100909,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4100978,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4101078,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4101245,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4101313,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4108991,241566,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4115604,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4115657,103244,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4159615,241566,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4184201,70696,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4174714,45284,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4375683,13409,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(5043123,93506,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(5107450,93506,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(5236475,682,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(5236785,682,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(5363414,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(5671193,213594,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(5678739,213594,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(5671416,213594,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(5674807,213594,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(5689624,213594,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(5678757,213594,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(5702328,306172,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(5710014,306172,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(5806005,120406,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(5866082,213594,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(531541,10927,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(189418,10927,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(553642,10927,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(3878347,233341,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(3100730,6367,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(981922,119803,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(2369688,115019,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(951833,13324,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(5025308,93506,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(433922,12841,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(3132766,6367,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(4312140,33377,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(307506,45027,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(3936411,134812,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(353783,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(369842,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(441677,34536,'2010-09-28 10:22:43',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:43',0),(5694915,231539,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(3882859,10927,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(3916410,93506,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(73843,3234,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(3124867,45027,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(4159744,247520,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(3373175,6367,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(412437,26299,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(5025265,93506,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(5430086,115995,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(3956455,185976,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(2736717,118014,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(502306,10927,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(508355,10927,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(2213421,34536,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(2191249,34536,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(2191215,34536,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(2318266,61891,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(3933161,134812,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(565034,29084,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(537461,86654,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(4099888,241566,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(4083396,103244,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(2688289,97036,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(2788592,143308,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(2788617,143308,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(4083044,103244,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(4138831,83365,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(3831437,148173,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(4077244,103244,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(4077310,103244,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(4083737,103244,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(4083476,103244,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(5866046,213594,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(4091122,92075,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(5860604,4363,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(5061350,276785,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(5641978,5265,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(3612902,107257,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(4072906,35074,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(5636480,5265,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(4475595,183561,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0),(5808039,235264,'2010-09-28 10:22:44',-900000000,900000000,-1800000000,1800000000,'2010-09-28 10:22:44',0);
INSERT INTO `current_node_tags` VALUES (625039,'highway','mini_roundabout'),(26609114,'aeroway','helipad'),(26609114,'created_by','Potlatch alpha'),(26609114,'iata','ALV'),(26609114,'icao','----'),(26609114,'is_in','Andorra la Vella,,Andorra'),(26609114,'place','airport'),(26609114,'source','Gagravarr_Airports'),(26609114,'type','civil'),(51344677,'barrier','toll_booth'),(51366154,'highway','speed_camera'),(51404282,'highway','traffic_signals'),(51448830,'source','yahoo'),(51552405,'created_by','JOSM'),(51552408,'created_by','JOSM'),(51552410,'created_by','JOSM'),(51552413,'created_by','JOSM'),(51552416,'created_by','JOSM'),(51552419,'created_by','JOSM'),(51552422,'created_by','JOSM'),(51552429,'created_by','JOSM'),(51552432,'created_by','JOSM'),(51552434,'created_by','JOSM'),(51552437,'created_by','JOSM'),(51552440,'created_by','JOSM'),(51552442,'created_by','JOSM'),(51552444,'created_by','JOSM'),(51552445,'created_by','JOSM'),(51552447,'created_by','JOSM'),(51552451,'created_by','JOSM'),(51552453,'created_by','JOSM'),(51552456,'created_by','JOSM'),(51552459,'created_by','JOSM'),(51552462,'created_by','JOSM'),(51552468,'created_by','JOSM'),(51552471,'created_by','JOSM'),(51552483,'highway','speed_camera'),(51552504,'created_by','JOSM'),(51552507,'created_by','JOSM'),(51552509,'created_by','JOSM'),(51552513,'created_by','JOSM'),(51552516,'created_by','JOSM'),(51552518,'created_by','JOSM'),(51552546,'created_by','JOSM'),(51552549,'created_by','JOSM'),(51552550,'created_by','JOSM'),(51552553,'created_by','JOSM'),(51552555,'created_by','JOSM'),(51552557,'created_by','JOSM'),(51552559,'created_by','JOSM'),(51552562,'created_by','JOSM'),(51552565,'created_by','JOSM'),(51552569,'created_by','JOSM'),(51552572,'created_by','JOSM'),(51552575,'created_by','JOSM'),(51552589,'created_by','JOSM'),(51552592,'created_by','JOSM'),(51552602,'created_by','JOSM'),(51552608,'created_by','JOSM'),(51552651,'created_by','JOSM'),(51552651,'highway','mini_roundabout'),(51552736,'created_by','JOSM'),(51552737,'created_by','JOSM'),(51552740,'created_by','JOSM'),(51552744,'created_by','JOSM'),(51552747,'created_by','JOSM'),(51552750,'created_by','JOSM'),(51552755,'created_by','JOSM'),(51552758,'created_by','JOSM'),(51552761,'created_by','JOSM'),(51552762,'created_by','JOSM'),(51552764,'created_by','JOSM'),(51552766,'created_by','JOSM'),(51552768,'created_by','JOSM'),(51552770,'created_by','JOSM'),(51552773,'created_by','JOSM'),(51552774,'created_by','JOSM'),(51552777,'created_by','JOSM'),(51552779,'created_by','JOSM'),(51552782,'created_by','JOSM'),(51552785,'created_by','JOSM'),(51552787,'created_by','JOSM'),(51552789,'created_by','JOSM'),(51552791,'created_by','JOSM'),(51552793,'created_by','JOSM'),(51552797,'created_by','JOSM'),(51552800,'created_by','JOSM'),(51552802,'created_by','JOSM'),(51552806,'created_by','JOSM'),(51552807,'created_by','JOSM'),(51552811,'created_by','JOSM'),(51552814,'created_by','JOSM'),(51552815,'created_by','JOSM'),(51552818,'created_by','JOSM'),(51552821,'created_by','JOSM'),(51552823,'created_by','JOSM'),(51552824,'created_by','JOSM'),(51552825,'created_by','JOSM'),(51552828,'created_by','JOSM'),(51552830,'created_by','JOSM'),(51552832,'created_by','JOSM'),(51552835,'created_by','JOSM'),(51552838,'created_by','JOSM'),(51552841,'created_by','JOSM'),(51552844,'created_by','JOSM'),(51552847,'created_by','JOSM'),(51552849,'created_by','JOSM'),(51552851,'created_by','JOSM'),(51552852,'created_by','JOSM'),(51552854,'created_by','JOSM'),(51552856,'created_by','JOSM'),(51552859,'created_by','JOSM'),(51552861,'created_by','JOSM'),(51552863,'created_by','JOSM'),(51552865,'created_by','JOSM'),(51552868,'created_by','JOSM'),(51552871,'created_by','JOSM'),(51552873,'created_by','JOSM'),(51552875,'created_by','JOSM'),(51554685,'created_by','JOSM'),(51554688,'created_by','JOSM'),(51554691,'created_by','JOSM'),(51554693,'created_by','JOSM'),(51554694,'created_by','JOSM'),(51554697,'created_by','JOSM'),(51554700,'created_by','JOSM'),(51554703,'created_by','JOSM'),(51554705,'created_by','JOSM'),(51554707,'created_by','JOSM'),(51554710,'created_by','JOSM'),(51554712,'created_by','JOSM'),(51554715,'created_by','JOSM'),(51554716,'created_by','JOSM'),(51557999,'created_by','JOSM'),(51558001,'created_by','JOSM'),(51558003,'created_by','JOSM'),(51558005,'created_by','JOSM'),(51558007,'created_by','JOSM'),(51558010,'created_by','JOSM'),(51558014,'created_by','JOSM'),(51558017,'created_by','JOSM'),(51558021,'created_by','JOSM'),(51558024,'created_by','JOSM'),(51558026,'created_by','JOSM'),(51558029,'created_by','JOSM'),(51558031,'created_by','JOSM'),(51558033,'created_by','JOSM'),(51558036,'created_by','JOSM'),(51558038,'created_by','JOSM'),(51558040,'created_by','JOSM'),(51558041,'created_by','JOSM'),(51558043,'created_by','JOSM'),(51558045,'created_by','JOSM'),(51558047,'created_by','JOSM'),(51558051,'created_by','JOSM'),(51558054,'created_by','JOSM'),(51558057,'created_by','JOSM'),(51558059,'created_by','JOSM'),(51558060,'created_by','JOSM'),(51558063,'created_by','JOSM'),(51558064,'created_by','JOSM'),(51558067,'created_by','JOSM'),(51558070,'created_by','JOSM'),(51558071,'created_by','JOSM'),(51558074,'created_by','JOSM'),(51558075,'created_by','JOSM'),(51558078,'created_by','JOSM'),(51558083,'created_by','JOSM'),(51558085,'created_by','JOSM'),(51558086,'created_by','JOSM'),(51558089,'created_by','JOSM'),(51558091,'created_by','JOSM'),(51558093,'created_by','JOSM'),(51558095,'created_by','JOSM'),(51558097,'created_by','JOSM'),(51558099,'created_by','JOSM'),(51558103,'created_by','JOSM'),(51558105,'created_by','JOSM'),(51558108,'created_by','JOSM'),(51558111,'created_by','JOSM'),(51558113,'created_by','JOSM'),(51558115,'created_by','JOSM'),(51558118,'created_by','JOSM'),(51558121,'created_by','JOSM'),(51558124,'created_by','JOSM'),(51558125,'created_by','JOSM'),(51558128,'created_by','JOSM'),(51558131,'created_by','JOSM'),(51558246,'created_by','JOSM'),(51558248,'created_by','JOSM'),(51558253,'created_by','JOSM'),(51558257,'created_by','JOSM'),(51558260,'created_by','JOSM'),(51558262,'created_by','JOSM'),(51558265,'created_by','JOSM'),(51558268,'created_by','JOSM'),(51558271,'created_by','JOSM'),(51558273,'created_by','JOSM'),(51558276,'created_by','JOSM'),(51558279,'created_by','JOSM'),(51558282,'created_by','JOSM'),(51558284,'created_by','JOSM'),(51558287,'created_by','JOSM'),(51558293,'created_by','JOSM'),(51558295,'created_by','JOSM'),(51558298,'created_by','JOSM'),(51558301,'created_by','JOSM'),(51558304,'created_by','JOSM'),(51558305,'created_by','JOSM'),(51563059,'created_by','JOSM'),(51563061,'created_by','JOSM'),(51563063,'created_by','JOSM'),(51563066,'created_by','JOSM'),(51563071,'created_by','JOSM'),(51563075,'created_by','JOSM'),(51563076,'created_by','JOSM'),(51563080,'created_by','JOSM'),(51563083,'created_by','JOSM'),(51563087,'created_by','JOSM'),(51563090,'created_by','JOSM'),(51563094,'created_by','JOSM'),(51563098,'created_by','JOSM'),(51563100,'created_by','JOSM'),(51563103,'created_by','JOSM'),(51563105,'created_by','JOSM'),(51563108,'created_by','JOSM'),(51563110,'created_by','JOSM'),(51563113,'created_by','JOSM'),(51563115,'created_by','JOSM'),(51563118,'created_by','JOSM'),(51563120,'created_by','JOSM'),(51563122,'created_by','JOSM'),(51563124,'created_by','JOSM'),(51563127,'created_by','JOSM'),(51563130,'created_by','JOSM'),(51563134,'created_by','JOSM'),(51563137,'created_by','JOSM'),(51563140,'created_by','JOSM'),(51563141,'created_by','JOSM'),(51563145,'created_by','JOSM'),(51563148,'created_by','JOSM'),(51563152,'created_by','JOSM'),(51563155,'created_by','JOSM'),(51563159,'created_by','JOSM'),(51563162,'created_by','JOSM'),(51563164,'created_by','JOSM'),(51563168,'created_by','JOSM'),(51563170,'created_by','JOSM'),(51563173,'created_by','JOSM'),(51563176,'created_by','JOSM'),(51563177,'created_by','JOSM'),(51563179,'created_by','JOSM'),(51563181,'created_by','JOSM'),(51563185,'created_by','JOSM'),(51563189,'created_by','JOSM'),(51563192,'created_by','JOSM'),(51563195,'created_by','JOSM'),(51563197,'created_by','JOSM'),(51563199,'created_by','JOSM'),(51563200,'created_by','JOSM'),(51563202,'created_by','JOSM'),(51563205,'created_by','JOSM'),(51563210,'created_by','JOSM'),(51563214,'created_by','JOSM'),(51563216,'created_by','JOSM'),(51563224,'created_by','JOSM'),(51563226,'created_by','JOSM'),(51563230,'created_by','JOSM'),(51563233,'created_by','JOSM'),(51563236,'created_by','JOSM'),(51563238,'created_by','JOSM'),(51563242,'created_by','JOSM'),(51563244,'created_by','JOSM'),(51563247,'created_by','JOSM'),(51563252,'created_by','JOSM'),(51563255,'created_by','JOSM'),(51563257,'created_by','JOSM'),(51563261,'created_by','JOSM'),(51563266,'created_by','JOSM'),(51563268,'created_by','JOSM'),(51563272,'created_by','JOSM'),(51563276,'created_by','JOSM'),(51563279,'created_by','JOSM'),(51563281,'created_by','JOSM'),(51563284,'created_by','JOSM'),(51563374,'created_by','JOSM'),(51563375,'created_by','JOSM'),(51563437,'created_by','JOSM'),(51563439,'created_by','JOSM'),(51563440,'created_by','JOSM'),(51563441,'created_by','JOSM'),(51563442,'created_by','JOSM'),(51563443,'created_by','JOSM'),(51563447,'created_by','JOSM'),(51563450,'created_by','JOSM'),(51563451,'created_by','JOSM'),(51563453,'created_by','JOSM'),(51563454,'created_by','JOSM'),(51563456,'created_by','JOSM'),(51563458,'created_by','JOSM'),(51563460,'created_by','JOSM'),(51563462,'created_by','JOSM'),(51563463,'created_by','JOSM'),(51563466,'created_by','JOSM'),(51563470,'created_by','JOSM'),(51563472,'created_by','JOSM'),(51563474,'created_by','JOSM'),(51563477,'created_by','JOSM'),(51563480,'created_by','JOSM'),(51563481,'created_by','JOSM'),(51563484,'created_by','JOSM'),(51563485,'created_by','JOSM'),(51563488,'created_by','JOSM'),(51563490,'created_by','JOSM'),(51563492,'created_by','JOSM'),(51563494,'created_by','JOSM'),(51563496,'created_by','JOSM'),(51563499,'created_by','JOSM'),(51581574,'created_by','JOSM'),(51581577,'created_by','JOSM'),(51581580,'created_by','JOSM'),(51581582,'created_by','JOSM'),(51581587,'created_by','JOSM'),(51581590,'created_by','JOSM'),(51581593,'created_by','JOSM'),(51581596,'created_by','JOSM'),(51581598,'created_by','JOSM'),(51581602,'created_by','JOSM'),(51581607,'created_by','JOSM'),(51581611,'created_by','JOSM'),(51581613,'created_by','JOSM'),(51581617,'created_by','JOSM'),(51581620,'created_by','JOSM'),(51581622,'created_by','JOSM'),(51581625,'created_by','JOSM'),(51581628,'created_by','JOSM'),(51581633,'created_by','JOSM'),(51581643,'created_by','JOSM'),(51581645,'created_by','JOSM'),(51581650,'created_by','JOSM'),(51581654,'created_by','JOSM'),(51581657,'created_by','JOSM'),(51581661,'created_by','JOSM'),(51581663,'created_by','JOSM'),(51581667,'created_by','JOSM'),(51581670,'created_by','JOSM'),(51581751,'created_by','JOSM'),(51581754,'created_by','JOSM'),(51581757,'created_by','JOSM'),(51581759,'created_by','JOSM'),(51581762,'created_by','JOSM'),(51581766,'created_by','JOSM'),(51581769,'created_by','JOSM'),(51581772,'created_by','JOSM'),(51581776,'created_by','JOSM'),(51581783,'created_by','JOSM'),(51581786,'created_by','JOSM'),(51581788,'created_by','JOSM'),(51581791,'created_by','JOSM'),(51581795,'created_by','JOSM'),(51581796,'created_by','JOSM'),(51581799,'created_by','JOSM'),(51581803,'created_by','JOSM'),(51581807,'created_by','JOSM'),(51581810,'created_by','JOSM'),(51581813,'created_by','JOSM'),(51581814,'created_by','JOSM'),(51581818,'created_by','JOSM'),(51581821,'created_by','JOSM'),(51581823,'created_by','JOSM'),(51581826,'created_by','JOSM'),(51581828,'created_by','JOSM'),(51581829,'created_by','JOSM'),(51581832,'created_by','JOSM'),(51581835,'created_by','JOSM'),(51581837,'created_by','JOSM'),(51581840,'created_by','JOSM'),(51581843,'created_by','JOSM'),(51581846,'created_by','JOSM'),(51581849,'created_by','JOSM'),(51581852,'created_by','JOSM'),(51581854,'created_by','JOSM'),(51581857,'created_by','JOSM'),(51581861,'created_by','JOSM'),(51581863,'created_by','JOSM'),(51581868,'created_by','JOSM'),(51581874,'created_by','JOSM'),(51581876,'created_by','JOSM'),(51581877,'created_by','JOSM'),(51581881,'created_by','JOSM'),(51581883,'created_by','JOSM'),(51581886,'created_by','JOSM'),(51581888,'created_by','JOSM'),(51581890,'created_by','JOSM'),(51581895,'created_by','JOSM'),(51581898,'created_by','JOSM'),(51581902,'created_by','JOSM'),(51581904,'created_by','JOSM'),(51581906,'created_by','JOSM'),(51581910,'created_by','JOSM'),(51581912,'created_by','JOSM'),(51581914,'created_by','JOSM'),(51581916,'created_by','JOSM'),(51581922,'created_by','JOSM'),(51581923,'created_by','JOSM'),(51581926,'created_by','JOSM'),(51581928,'created_by','JOSM'),(51581931,'created_by','JOSM'),(51581932,'created_by','JOSM'),(51581936,'created_by','JOSM'),(51581939,'created_by','JOSM'),(51581941,'created_by','JOSM'),(51581944,'created_by','JOSM'),(51581946,'created_by','JOSM'),(51581951,'created_by','JOSM'),(51581955,'created_by','JOSM'),(51581958,'created_by','JOSM'),(51581960,'created_by','JOSM'),(51581962,'created_by','JOSM'),(51581964,'created_by','JOSM'),(51581967,'created_by','JOSM'),(51581970,'created_by','JOSM'),(51581973,'created_by','JOSM'),(51581976,'created_by','JOSM'),(51581979,'created_by','JOSM'),(51581980,'created_by','JOSM'),(51581983,'created_by','JOSM'),(51581986,'created_by','JOSM'),(51581990,'created_by','JOSM'),(51581993,'created_by','JOSM'),(51581995,'created_by','JOSM'),(51581997,'created_by','JOSM'),(51582003,'created_by','JOSM'),(51582007,'created_by','JOSM'),(51582009,'created_by','JOSM'),(51582013,'created_by','JOSM'),(51582019,'created_by','JOSM'),(51582023,'created_by','JOSM'),(51582027,'created_by','JOSM'),(51582031,'created_by','JOSM'),(51582034,'created_by','JOSM'),(51582038,'created_by','JOSM'),(51582045,'created_by','JOSM'),(51582060,'created_by','JOSM'),(51582066,'created_by','JOSM'),(51582074,'created_by','JOSM'),(51582077,'created_by','JOSM'),(51582082,'created_by','JOSM'),(51582085,'created_by','JOSM'),(51582086,'created_by','JOSM'),(51582089,'created_by','JOSM'),(51582090,'created_by','JOSM'),(51582091,'created_by','JOSM'),(51582093,'created_by','JOSM'),(51582096,'created_by','JOSM'),(51582098,'created_by','JOSM'),(51582101,'created_by','JOSM'),(51582102,'created_by','JOSM'),(51582105,'created_by','JOSM'),(51582107,'created_by','JOSM'),(51582110,'created_by','JOSM'),(51582111,'created_by','JOSM'),(51582113,'created_by','JOSM'),(51582116,'created_by','JOSM'),(51582118,'created_by','JOSM'),(51582121,'created_by','JOSM'),(51582123,'created_by','JOSM'),(51582125,'created_by','JOSM'),(51582128,'created_by','JOSM'),(51582132,'created_by','JOSM'),(51582133,'created_by','JOSM'),(51582135,'created_by','JOSM'),(51582137,'created_by','JOSM'),(51582139,'created_by','JOSM'),(51582143,'created_by','JOSM'),(51582146,'created_by','JOSM'),(51582148,'created_by','JOSM'),(51582150,'created_by','JOSM'),(51582153,'created_by','JOSM'),(51582156,'created_by','JOSM'),(51582159,'created_by','JOSM'),(51582162,'created_by','JOSM'),(51582166,'created_by','JOSM'),(51582167,'created_by','JOSM'),(51582170,'created_by','JOSM'),(51582173,'created_by','JOSM'),(51582175,'created_by','JOSM'),(51582178,'created_by','JOSM'),(51582181,'created_by','JOSM'),(51582184,'created_by','JOSM'),(51582186,'created_by','JOSM'),(51582188,'created_by','JOSM'),(51582191,'created_by','JOSM'),(51582194,'created_by','JOSM'),(51582198,'created_by','JOSM'),(51582201,'created_by','JOSM'),(51582204,'created_by','JOSM'),(51582207,'created_by','JOSM'),(51582209,'created_by','JOSM'),(51582211,'created_by','JOSM'),(51587693,'created_by','JOSM'),(51587703,'created_by','JOSM'),(51587705,'created_by','JOSM'),(51587707,'created_by','JOSM'),(51587715,'created_by','JOSM'),(51587721,'created_by','JOSM'),(51587723,'created_by','JOSM'),(51587729,'created_by','JOSM'),(51587732,'created_by','JOSM'),(51589112,'created_by','JOSM'),(51589115,'created_by','JOSM'),(51589117,'created_by','JOSM'),(51589119,'created_by','JOSM'),(51589122,'created_by','JOSM'),(51589125,'created_by','JOSM'),(51589128,'created_by','JOSM'),(51589130,'created_by','JOSM'),(51589133,'created_by','JOSM'),(51589136,'created_by','JOSM'),(51589138,'created_by','JOSM'),(51589142,'created_by','JOSM'),(51589144,'created_by','JOSM'),(51589146,'created_by','JOSM'),(51589149,'created_by','JOSM'),(51589152,'created_by','JOSM'),(51589155,'created_by','JOSM'),(51589157,'created_by','JOSM'),(51589158,'created_by','JOSM'),(51589160,'created_by','JOSM'),(51589161,'created_by','JOSM'),(51589162,'created_by','JOSM'),(51589163,'created_by','JOSM'),(51589165,'created_by','JOSM'),(51589169,'created_by','JOSM'),(51589172,'created_by','JOSM'),(51589174,'created_by','JOSM'),(51589177,'created_by','JOSM'),(51589180,'created_by','JOSM'),(51589183,'created_by','JOSM'),(51589185,'created_by','JOSM'),(51589187,'created_by','JOSM'),(51589190,'created_by','JOSM'),(51589192,'created_by','JOSM'),(51589194,'created_by','JOSM'),(51589196,'created_by','JOSM'),(51589198,'created_by','JOSM'),(51589201,'created_by','JOSM'),(51589203,'created_by','JOSM'),(51589205,'created_by','JOSM'),(51589208,'created_by','JOSM'),(51589210,'created_by','JOSM'),(51589213,'created_by','JOSM'),(51589215,'created_by','JOSM'),(51589217,'created_by','JOSM'),(51589220,'created_by','JOSM'),(51589223,'created_by','JOSM'),(51589226,'created_by','JOSM'),(51589229,'created_by','JOSM'),(51589230,'created_by','JOSM'),(51589233,'created_by','JOSM'),(51589236,'created_by','JOSM'),(51589238,'created_by','JOSM'),(51589243,'created_by','JOSM'),(51589247,'created_by','JOSM'),(51589249,'created_by','JOSM'),(51589252,'created_by','JOSM'),(51589254,'created_by','JOSM'),(51589256,'created_by','JOSM'),(51589259,'created_by','JOSM'),(51589262,'created_by','JOSM'),(51589263,'created_by','JOSM'),(51589267,'created_by','JOSM'),(51589270,'created_by','JOSM'),(51589273,'created_by','JOSM'),(51589275,'created_by','JOSM'),(51589278,'created_by','JOSM'),(51589281,'created_by','JOSM'),(51589284,'created_by','JOSM'),(51589288,'created_by','JOSM'),(51589290,'created_by','JOSM'),(51589293,'created_by','JOSM'),(51589296,'created_by','JOSM'),(51589297,'created_by','JOSM'),(51589299,'created_by','JOSM'),(51589302,'created_by','JOSM'),(51589304,'created_by','JOSM'),(51589307,'created_by','JOSM'),(51589310,'created_by','JOSM'),(51589313,'created_by','JOSM'),(51589315,'created_by','JOSM'),(51589320,'created_by','JOSM'),(51589325,'created_by','JOSM'),(51589328,'created_by','JOSM'),(51589334,'created_by','JOSM'),(51589337,'created_by','JOSM'),(51589338,'created_by','JOSM'),(51589340,'created_by','JOSM'),(51589342,'created_by','JOSM'),(51589344,'created_by','JOSM'),(51589348,'created_by','JOSM'),(51589352,'created_by','JOSM'),(51589354,'created_by','JOSM'),(51589357,'created_by','JOSM'),(51589360,'created_by','JOSM'),(51589363,'created_by','JOSM'),(51589366,'created_by','JOSM'),(51589368,'created_by','JOSM'),(51589370,'created_by','JOSM'),(51590535,'created_by','JOSM'),(51590538,'created_by','JOSM'),(51590542,'created_by','JOSM'),(51590544,'created_by','JOSM'),(51590546,'created_by','JOSM'),(51590549,'created_by','JOSM'),(51590551,'created_by','JOSM'),(51590553,'created_by','JOSM'),(51590557,'created_by','JOSM'),(51590560,'created_by','JOSM'),(51590563,'created_by','JOSM'),(51590564,'created_by','JOSM'),(51590567,'created_by','JOSM'),(51590572,'created_by','JOSM'),(51590575,'created_by','JOSM'),(51590578,'created_by','JOSM'),(51590580,'created_by','JOSM'),(51590582,'created_by','JOSM'),(51590585,'created_by','JOSM'),(51590588,'created_by','JOSM'),(51590589,'created_by','JOSM'),(51590592,'created_by','JOSM'),(51590595,'created_by','JOSM'),(51590598,'created_by','JOSM'),(51590600,'created_by','JOSM'),(51590603,'created_by','JOSM'),(51590606,'created_by','JOSM'),(51590608,'created_by','JOSM'),(51590611,'created_by','JOSM'),(51590613,'created_by','JOSM'),(51590616,'created_by','JOSM'),(51590619,'created_by','JOSM'),(51590622,'created_by','JOSM'),(51590623,'created_by','JOSM'),(51590626,'created_by','JOSM'),(51590630,'created_by','JOSM'),(51590631,'created_by','JOSM'),(51590633,'created_by','JOSM'),(51590634,'created_by','JOSM'),(51590635,'created_by','JOSM'),(51590636,'created_by','JOSM'),(51590637,'created_by','JOSM'),(51590638,'created_by','JOSM'),(51590643,'created_by','JOSM'),(51590645,'created_by','JOSM'),(51590646,'created_by','JOSM'),(51590648,'created_by','JOSM'),(51590650,'created_by','JOSM'),(51590653,'created_by','JOSM'),(51590654,'created_by','JOSM'),(51590657,'created_by','JOSM'),(51590660,'created_by','JOSM'),(51590663,'created_by','JOSM'),(51590665,'created_by','JOSM'),(51590668,'created_by','JOSM'),(51590669,'created_by','JOSM'),(51590671,'created_by','JOSM'),(51590673,'created_by','JOSM'),(51590676,'created_by','JOSM'),(51590679,'created_by','JOSM'),(51590680,'created_by','JOSM'),(51590683,'created_by','JOSM'),(51590686,'created_by','JOSM'),(51590687,'created_by','JOSM'),(51590690,'created_by','JOSM'),(51590691,'created_by','JOSM'),(51590693,'created_by','JOSM'),(51590695,'created_by','JOSM'),(51590699,'created_by','JOSM'),(51590702,'created_by','JOSM'),(51590705,'created_by','JOSM'),(51590707,'created_by','JOSM'),(51590708,'created_by','JOSM'),(51590711,'created_by','JOSM'),(51590714,'created_by','JOSM'),(51590716,'created_by','JOSM'),(51590719,'created_by','JOSM'),(51590722,'created_by','JOSM'),(51590725,'created_by','JOSM'),(51590728,'created_by','JOSM'),(51590730,'created_by','JOSM'),(51929590,'created_by','JOSM'),(51929593,'created_by','JOSM'),(51929595,'created_by','JOSM'),(51929598,'created_by','JOSM'),(51929600,'created_by','JOSM'),(51929603,'created_by','JOSM'),(51929607,'created_by','JOSM'),(51929610,'created_by','JOSM'),(51929614,'created_by','JOSM'),(51929617,'created_by','JOSM'),(51929619,'created_by','JOSM'),(51929620,'created_by','JOSM'),(51929623,'created_by','JOSM'),(51929625,'created_by','JOSM'),(51929626,'created_by','JOSM'),(51929628,'created_by','JOSM'),(51929630,'created_by','JOSM'),(51929632,'created_by','JOSM'),(51929634,'created_by','JOSM'),(51929636,'created_by','JOSM'),(51929638,'created_by','JOSM'),(51929640,'created_by','JOSM'),(51929642,'created_by','JOSM'),(51929644,'created_by','JOSM'),(51929645,'created_by','JOSM'),(51929647,'created_by','JOSM'),(51929649,'created_by','JOSM'),(51929650,'created_by','JOSM'),(51929653,'created_by','JOSM'),(51929656,'created_by','JOSM'),(51929657,'created_by','JOSM'),(51929660,'created_by','JOSM'),(51929661,'created_by','JOSM'),(51929663,'created_by','JOSM'),(51929665,'created_by','JOSM'),(51929667,'created_by','JOSM'),(51929670,'created_by','JOSM'),(51929671,'created_by','JOSM'),(51929673,'created_by','JOSM'),(51929675,'created_by','JOSM'),(51929677,'created_by','JOSM'),(51929678,'created_by','JOSM'),(51929680,'created_by','JOSM'),(51929682,'created_by','JOSM'),(51929684,'created_by','JOSM'),(51929687,'created_by','JOSM'),(51929689,'created_by','JOSM'),(51929690,'created_by','JOSM'),(51929693,'created_by','JOSM'),(51929696,'created_by','JOSM'),(51929700,'created_by','JOSM'),(51929702,'created_by','JOSM'),(51929704,'created_by','JOSM'),(51929707,'created_by','JOSM'),(51929709,'created_by','JOSM'),(51929711,'created_by','JOSM'),(51929713,'created_by','JOSM'),(51929715,'created_by','JOSM'),(51929717,'created_by','JOSM'),(51929720,'created_by','JOSM'),(51929722,'created_by','JOSM'),(51929725,'created_by','JOSM'),(51929728,'created_by','JOSM'),(51929731,'created_by','JOSM'),(51929734,'created_by','JOSM'),(51929736,'created_by','JOSM'),(51929739,'created_by','JOSM'),(51929741,'created_by','JOSM'),(51929743,'created_by','JOSM'),(51929746,'created_by','JOSM'),(51929749,'created_by','JOSM'),(51929752,'created_by','JOSM'),(51929754,'created_by','JOSM'),(51929757,'created_by','JOSM'),(51929760,'created_by','JOSM'),(51929762,'created_by','JOSM'),(51929764,'created_by','JOSM'),(51929767,'created_by','JOSM'),(51929770,'created_by','JOSM'),(51929771,'created_by','JOSM'),(51929773,'created_by','JOSM'),(51929775,'created_by','JOSM'),(51929777,'created_by','JOSM'),(51929780,'created_by','JOSM'),(51929782,'created_by','JOSM'),(51929784,'created_by','JOSM'),(51929785,'created_by','JOSM'),(51929786,'created_by','JOSM'),(51929788,'created_by','JOSM'),(51929790,'created_by','JOSM'),(51929793,'created_by','JOSM'),(51929796,'created_by','JOSM'),(51929797,'created_by','JOSM'),(51929800,'created_by','JOSM'),(51929802,'created_by','JOSM'),(51929805,'created_by','JOSM'),(51929807,'created_by','JOSM'),(51929810,'created_by','JOSM'),(51929812,'created_by','JOSM'),(51929814,'created_by','JOSM'),(51929818,'created_by','JOSM'),(51929820,'created_by','JOSM'),(51929823,'created_by','JOSM'),(51929825,'created_by','JOSM'),(51929827,'created_by','JOSM'),(51929829,'created_by','JOSM'),(51929833,'created_by','JOSM'),(51929834,'created_by','JOSM'),(51929837,'created_by','JOSM'),(51929840,'created_by','JOSM'),(51929842,'created_by','JOSM'),(51929844,'created_by','JOSM'),(51929846,'created_by','JOSM'),(51929848,'created_by','JOSM'),(51929852,'created_by','JOSM'),(51929854,'created_by','JOSM'),(51929858,'created_by','JOSM'),(51929860,'created_by','JOSM'),(51929862,'created_by','JOSM'),(51929864,'created_by','JOSM'),(51929866,'created_by','JOSM'),(51929869,'created_by','JOSM'),(51929872,'created_by','JOSM'),(51929873,'created_by','JOSM'),(51929875,'created_by','JOSM'),(51929878,'created_by','JOSM'),(51929880,'created_by','JOSM'),(51929883,'created_by','JOSM'),(51929886,'created_by','JOSM'),(51929889,'created_by','JOSM'),(51929892,'created_by','JOSM'),(51929893,'created_by','JOSM'),(51929896,'created_by','JOSM'),(51929899,'created_by','JOSM'),(51929902,'created_by','JOSM'),(51929905,'created_by','JOSM'),(51929907,'created_by','JOSM'),(51929909,'created_by','JOSM'),(51929910,'created_by','JOSM'),(51929913,'created_by','JOSM'),(51929915,'created_by','JOSM'),(51929916,'created_by','JOSM'),(51929918,'created_by','JOSM'),(51929920,'created_by','JOSM'),(51929922,'created_by','JOSM'),(51929923,'created_by','JOSM'),(51929925,'created_by','JOSM'),(51929927,'created_by','JOSM'),(51929930,'created_by','JOSM'),(51929933,'created_by','JOSM'),(51929936,'created_by','JOSM'),(51929938,'created_by','JOSM'),(51929939,'created_by','JOSM'),(51929942,'created_by','JOSM'),(51929943,'created_by','JOSM'),(51929946,'created_by','JOSM'),(51929949,'created_by','JOSM'),(51929950,'created_by','JOSM'),(51929953,'created_by','JOSM'),(51929955,'created_by','JOSM'),(51929957,'created_by','JOSM'),(51929960,'created_by','JOSM'),(51929964,'created_by','JOSM'),(51929966,'created_by','JOSM'),(51929968,'created_by','JOSM'),(51929971,'created_by','JOSM'),(51929974,'created_by','JOSM'),(51929975,'created_by','JOSM'),(51929978,'created_by','JOSM'),(51929980,'created_by','JOSM'),(51929983,'created_by','JOSM'),(51929986,'created_by','JOSM'),(51929988,'created_by','JOSM'),(51929990,'created_by','JOSM'),(51929993,'created_by','JOSM'),(51929999,'created_by','JOSM'),(51930002,'created_by','JOSM'),(51930009,'created_by','JOSM'),(51930014,'created_by','JOSM'),(51930018,'created_by','JOSM'),(51930020,'created_by','JOSM'),(51930022,'created_by','JOSM'),(51930024,'created_by','JOSM'),(51930026,'created_by','JOSM'),(51930029,'created_by','JOSM'),(51930031,'created_by','JOSM'),(51930033,'created_by','JOSM'),(51930035,'created_by','JOSM'),(51930037,'created_by','JOSM'),(51930040,'created_by','JOSM'),(51930043,'created_by','JOSM'),(51930044,'created_by','JOSM'),(51930047,'created_by','JOSM'),(51930048,'created_by','JOSM'),(51930050,'created_by','JOSM'),(51930052,'created_by','JOSM'),(51930053,'created_by','JOSM'),(51930055,'created_by','JOSM'),(51930058,'created_by','JOSM'),(51930062,'created_by','JOSM'),(51930063,'created_by','JOSM'),(51930066,'created_by','JOSM'),(51930068,'created_by','JOSM'),(51930071,'created_by','JOSM'),(51930073,'created_by','JOSM'),(51930076,'created_by','JOSM'),(51930079,'created_by','JOSM'),(51930080,'created_by','JOSM'),(51930082,'created_by','JOSM'),(51930085,'created_by','JOSM'),(51930088,'created_by','JOSM'),(51930092,'created_by','JOSM'),(51930094,'created_by','JOSM'),(51930096,'created_by','JOSM'),(51930098,'created_by','JOSM'),(51930099,'created_by','JOSM'),(51930102,'created_by','JOSM'),(51930104,'created_by','JOSM'),(51930107,'created_by','JOSM'),(51930108,'created_by','JOSM'),(51930110,'created_by','JOSM'),(51930112,'created_by','JOSM'),(51930113,'created_by','JOSM'),(51930115,'created_by','JOSM'),(51930118,'created_by','JOSM'),(51930119,'created_by','JOSM'),(51930121,'created_by','JOSM'),(51930124,'created_by','JOSM'),(51930125,'created_by','JOSM'),(51930127,'created_by','JOSM'),(51930129,'created_by','JOSM'),(51930132,'created_by','JOSM'),(51930134,'created_by','JOSM'),(51930136,'created_by','JOSM'),(51930138,'created_by','JOSM'),(51930141,'created_by','JOSM'),(51930143,'created_by','JOSM'),(51930145,'created_by','JOSM'),(51930148,'created_by','JOSM'),(51930149,'created_by','JOSM'),(51930152,'created_by','JOSM'),(51930153,'created_by','JOSM'),(51930156,'created_by','JOSM'),(51930158,'created_by','JOSM'),(51930160,'created_by','JOSM'),(51930163,'created_by','JOSM'),(51930165,'created_by','JOSM'),(51930167,'created_by','JOSM'),(51930171,'created_by','JOSM'),(51930173,'created_by','JOSM'),(51930175,'created_by','JOSM'),(51930178,'created_by','JOSM'),(51930181,'created_by','JOSM'),(51930184,'created_by','JOSM'),(51930186,'ele','1987'),(51930186,'mountain_pass','yes'),(51930186,'name','Col d\'Ordino'),(51930188,'created_by','JOSM'),(51930191,'created_by','JOSM'),(51930193,'created_by','JOSM'),(51930195,'created_by','JOSM'),(51930198,'created_by','JOSM'),(51930199,'created_by','JOSM'),(51930202,'created_by','JOSM'),(51930206,'created_by','JOSM'),(51930208,'created_by','JOSM'),(51930211,'created_by','JOSM'),(51930213,'created_by','JOSM'),(51930216,'created_by','JOSM'),(51930219,'created_by','JOSM'),(51930222,'created_by','JOSM'),(51930223,'created_by','JOSM'),(51930226,'created_by','JOSM'),(51930228,'created_by','JOSM'),(51930230,'created_by','JOSM'),(51930232,'created_by','JOSM'),(51930235,'created_by','JOSM'),(51930238,'created_by','JOSM'),(51930241,'created_by','JOSM'),(51930242,'created_by','JOSM'),(51930245,'created_by','JOSM'),(51930247,'created_by','JOSM'),(51930250,'created_by','JOSM'),(51930252,'created_by','JOSM'),(51930253,'created_by','JOSM'),(51930255,'created_by','JOSM'),(51930257,'created_by','JOSM'),(51930259,'created_by','JOSM'),(51930262,'created_by','JOSM'),(51930264,'created_by','JOSM'),(51930267,'created_by','JOSM'),(51930270,'created_by','JOSM'),(51930272,'created_by','JOSM'),(51930275,'created_by','JOSM'),(51930278,'created_by','JOSM'),(51930280,'created_by','JOSM'),(51930282,'created_by','JOSM'),(51930284,'created_by','JOSM'),(51930288,'created_by','JOSM'),(51930291,'created_by','JOSM'),(51930293,'created_by','JOSM'),(51930297,'created_by','JOSM'),(51930299,'created_by','JOSM'),(51930302,'created_by','JOSM'),(51930305,'created_by','JOSM'),(51930307,'created_by','JOSM'),(51930309,'created_by','JOSM'),(51930311,'created_by','JOSM'),(51930312,'created_by','JOSM'),(51930313,'created_by','JOSM'),(51930314,'created_by','JOSM'),(51930315,'created_by','JOSM'),(51930319,'created_by','JOSM'),(51930321,'created_by','JOSM'),(51930324,'created_by','JOSM'),(51930326,'created_by','JOSM'),(51930328,'created_by','JOSM'),(51930331,'created_by','JOSM'),(51930332,'created_by','JOSM'),(51930334,'created_by','JOSM'),(51930336,'created_by','JOSM'),(51930338,'created_by','JOSM'),(51930340,'created_by','JOSM'),(51930343,'created_by','JOSM'),(51930345,'created_by','JOSM'),(51930348,'created_by','JOSM'),(51930349,'created_by','JOSM'),(51930352,'created_by','JOSM'),(51930354,'created_by','JOSM'),(51930357,'created_by','JOSM'),(51930359,'created_by','JOSM'),(51930360,'created_by','JOSM'),(51930362,'created_by','JOSM'),(51930364,'created_by','JOSM'),(51930365,'created_by','JOSM'),(51930368,'created_by','JOSM'),(51930371,'created_by','JOSM'),(51930373,'created_by','JOSM'),(51930376,'created_by','JOSM'),(51930378,'created_by','JOSM'),(51930380,'created_by','JOSM'),(51930382,'created_by','JOSM'),(51930384,'created_by','JOSM'),(51930386,'created_by','JOSM'),(51930388,'created_by','JOSM'),(51930390,'created_by','JOSM'),(51930396,'created_by','JOSM'),(51930403,'created_by','JOSM'),(51930405,'created_by','JOSM'),(51930408,'created_by','JOSM'),(51930410,'created_by','JOSM'),(51930412,'created_by','JOSM'),(51930413,'created_by','JOSM'),(51930415,'created_by','JOSM'),(51930416,'created_by','JOSM'),(51930417,'created_by','JOSM'),(51930418,'created_by','JOSM'),(51930420,'created_by','JOSM'),(51930422,'created_by','JOSM'),(51930424,'created_by','JOSM'),(51930426,'created_by','JOSM'),(51930428,'created_by','JOSM'),(51930429,'created_by','JOSM'),(51930433,'created_by','JOSM'),(51930437,'created_by','JOSM'),(51930439,'created_by','JOSM'),(51930441,'created_by','JOSM'),(51930443,'created_by','JOSM'),(51930445,'created_by','JOSM'),(51930447,'created_by','JOSM'),(51930447,'ele','1952'),(51930447,'mountain_pass','yes'),(51930447,'name','Collet de Montaup'),(51930448,'created_by','JOSM'),(51930449,'created_by','JOSM'),(51930450,'created_by','JOSM'),(51930453,'created_by','JOSM'),(51930455,'created_by','JOSM'),(51930457,'created_by','JOSM'),(51930458,'created_by','JOSM'),(51930461,'created_by','JOSM'),(51930462,'created_by','JOSM'),(51930465,'created_by','JOSM'),(51930467,'created_by','JOSM'),(51930469,'created_by','JOSM'),(51930470,'created_by','JOSM'),(51930473,'created_by','JOSM'),(51930475,'created_by','JOSM'),(51930478,'created_by','JOSM'),(51930481,'created_by','JOSM'),(51930483,'created_by','JOSM'),(51930485,'created_by','JOSM'),(51930488,'created_by','JOSM'),(51930492,'created_by','JOSM'),(51930495,'created_by','JOSM'),(51930497,'created_by','JOSM'),(51930500,'created_by','JOSM'),(51930503,'created_by','JOSM'),(51930505,'created_by','JOSM'),(51930507,'created_by','JOSM'),(51930509,'created_by','JOSM'),(51930511,'created_by','JOSM'),(51930513,'created_by','JOSM'),(51930517,'created_by','JOSM'),(51930519,'created_by','JOSM'),(51930521,'created_by','JOSM'),(51930524,'created_by','JOSM'),(51930527,'created_by','JOSM'),(51930531,'created_by','JOSM'),(51930534,'created_by','JOSM'),(51930537,'created_by','JOSM'),(51930540,'created_by','JOSM'),(51930542,'created_by','JOSM'),(51930544,'created_by','JOSM'),(51930548,'created_by','JOSM'),(51930553,'created_by','JOSM'),(51930556,'created_by','JOSM'),(51930560,'created_by','JOSM'),(51930563,'created_by','JOSM'),(51930565,'created_by','JOSM'),(51930567,'created_by','JOSM'),(51930569,'created_by','JOSM'),(51930572,'created_by','JOSM'),(51930573,'created_by','JOSM'),(51930576,'created_by','JOSM'),(51930579,'created_by','JOSM'),(51930582,'created_by','JOSM'),(51930583,'created_by','JOSM'),(51930586,'created_by','JOSM'),(51930588,'created_by','JOSM'),(51930590,'created_by','JOSM'),(51930593,'created_by','JOSM'),(51930595,'created_by','JOSM'),(51930597,'created_by','JOSM'),(51930599,'created_by','JOSM'),(51930602,'created_by','JOSM'),(51930604,'created_by','JOSM'),(51930606,'created_by','JOSM'),(51930609,'created_by','JOSM'),(51930611,'created_by','JOSM'),(51930614,'created_by','JOSM'),(51930616,'created_by','JOSM'),(51930619,'created_by','JOSM'),(51930621,'created_by','JOSM'),(51930623,'created_by','JOSM'),(51930626,'created_by','JOSM'),(51930628,'created_by','JOSM'),(51930630,'created_by','JOSM'),(51930633,'created_by','JOSM'),(51930636,'created_by','JOSM'),(51930638,'created_by','JOSM'),(51930640,'created_by','JOSM'),(51930641,'created_by','JOSM'),(51930643,'created_by','JOSM'),(51930645,'created_by','JOSM'),(51930648,'created_by','JOSM'),(51930650,'created_by','JOSM'),(51930652,'created_by','JOSM'),(51930653,'created_by','JOSM'),(51930656,'created_by','JOSM'),(51930657,'created_by','JOSM'),(51930661,'created_by','JOSM'),(51930663,'created_by','JOSM'),(51930665,'created_by','JOSM'),(51930668,'created_by','JOSM'),(51930671,'created_by','JOSM'),(51930674,'created_by','JOSM'),(51930676,'created_by','JOSM'),(51930680,'created_by','JOSM'),(51930682,'created_by','JOSM'),(51930684,'created_by','JOSM'),(51930686,'created_by','JOSM'),(51930687,'created_by','JOSM'),(51930689,'created_by','JOSM'),(51930691,'created_by','JOSM'),(51930692,'created_by','JOSM'),(51930695,'created_by','JOSM'),(51930697,'created_by','JOSM'),(51930699,'created_by','JOSM'),(51930702,'created_by','JOSM'),(51930705,'created_by','JOSM'),(51930706,'created_by','JOSM'),(51930709,'created_by','JOSM'),(51930712,'created_by','JOSM'),(51930713,'created_by','JOSM'),(51930716,'created_by','JOSM'),(51930718,'created_by','JOSM'),(51930721,'created_by','JOSM'),(51930723,'created_by','JOSM'),(51930726,'created_by','JOSM'),(51930727,'created_by','JOSM'),(51930729,'created_by','JOSM'),(51930731,'created_by','JOSM'),(51930732,'created_by','JOSM'),(51930734,'created_by','JOSM'),(51930736,'created_by','JOSM'),(51930738,'created_by','JOSM'),(51930741,'created_by','JOSM'),(51930743,'created_by','JOSM'),(51930745,'created_by','JOSM'),(51930748,'created_by','JOSM'),(51930750,'created_by','JOSM'),(51930751,'created_by','JOSM'),(51930754,'created_by','JOSM'),(51930756,'created_by','JOSM'),(51930758,'created_by','JOSM'),(51930761,'created_by','JOSM'),(51930762,'created_by','JOSM'),(51930765,'created_by','JOSM'),(51930768,'created_by','JOSM'),(51930769,'created_by','JOSM'),(51930771,'created_by','JOSM'),(51930775,'created_by','JOSM'),(51930777,'created_by','JOSM'),(51930779,'created_by','JOSM'),(51930781,'created_by','JOSM'),(51930783,'created_by','JOSM'),(51930786,'created_by','JOSM'),(51930788,'created_by','JOSM'),(51930790,'created_by','JOSM'),(51930793,'created_by','JOSM'),(51930794,'created_by','JOSM'),(51930797,'created_by','JOSM'),(51930800,'created_by','JOSM'),(51930802,'created_by','JOSM'),(51930806,'created_by','JOSM'),(51930807,'created_by','JOSM'),(51930808,'created_by','JOSM'),(51930809,'created_by','JOSM'),(51930812,'created_by','JOSM'),(51930814,'created_by','JOSM'),(51930815,'created_by','JOSM'),(51930816,'created_by','JOSM'),(51930818,'created_by','JOSM'),(51930821,'created_by','JOSM'),(51930823,'created_by','JOSM'),(51930826,'created_by','JOSM'),(51930828,'created_by','JOSM'),(51930830,'created_by','JOSM'),(51930831,'created_by','JOSM'),(51930834,'created_by','JOSM'),(51930836,'created_by','JOSM'),(51930839,'created_by','JOSM'),(51930840,'created_by','JOSM'),(51930843,'created_by','JOSM'),(51930844,'created_by','JOSM'),(51930847,'created_by','JOSM'),(51930850,'created_by','JOSM'),(51930851,'created_by','JOSM'),(51930854,'created_by','JOSM'),(51930855,'created_by','JOSM'),(51930858,'created_by','JOSM'),(51930859,'created_by','JOSM'),(51930862,'created_by','JOSM'),(51930864,'created_by','JOSM'),(51930865,'created_by','JOSM'),(51930866,'created_by','JOSM'),(51930867,'created_by','JOSM'),(51930869,'created_by','JOSM'),(51930871,'created_by','JOSM'),(51930873,'created_by','JOSM'),(51930876,'created_by','JOSM'),(51930879,'created_by','JOSM'),(51930882,'created_by','JOSM'),(51930883,'created_by','JOSM'),(51930885,'created_by','JOSM'),(51930887,'created_by','JOSM'),(51930889,'created_by','JOSM'),(51930891,'created_by','JOSM'),(51930893,'created_by','JOSM'),(51930895,'created_by','JOSM'),(51930896,'created_by','JOSM'),(51930898,'created_by','JOSM'),(51930900,'created_by','JOSM'),(51930901,'created_by','JOSM'),(51930905,'created_by','JOSM'),(51930907,'created_by','JOSM'),(51930908,'created_by','JOSM'),(51930909,'created_by','JOSM'),(51930911,'created_by','JOSM'),(51930913,'created_by','JOSM'),(51930915,'created_by','JOSM'),(51930918,'created_by','JOSM'),(51930920,'created_by','JOSM'),(51930923,'created_by','JOSM'),(51930926,'created_by','JOSM'),(51930928,'created_by','JOSM'),(51930930,'created_by','JOSM'),(51930932,'created_by','JOSM'),(51930935,'created_by','JOSM'),(51930937,'created_by','JOSM'),(51930940,'created_by','JOSM'),(51930942,'created_by','JOSM'),(51930944,'created_by','JOSM'),(51930947,'created_by','JOSM'),(51930950,'created_by','JOSM'),(51930952,'created_by','JOSM'),(51930953,'created_by','JOSM'),(51930954,'created_by','JOSM'),(51930956,'created_by','JOSM'),(51930958,'created_by','JOSM'),(51930961,'created_by','JOSM'),(51930962,'created_by','JOSM'),(51930965,'created_by','JOSM'),(51930967,'created_by','JOSM'),(51930968,'created_by','JOSM'),(51930971,'created_by','JOSM'),(51930973,'created_by','JOSM'),(51930974,'created_by','JOSM'),(51930975,'created_by','JOSM'),(51930976,'created_by','JOSM'),(51930978,'created_by','JOSM'),(51930981,'created_by','JOSM'),(51930983,'created_by','JOSM'),(51930984,'created_by','JOSM'),(51930985,'created_by','JOSM'),(51930986,'created_by','JOSM'),(51930987,'created_by','JOSM'),(51930990,'created_by','JOSM'),(51930992,'created_by','JOSM'),(51930995,'created_by','JOSM'),(51930998,'created_by','JOSM'),(51930999,'created_by','JOSM'),(51931002,'created_by','JOSM'),(51931005,'created_by','JOSM'),(51931006,'created_by','JOSM'),(51931009,'created_by','JOSM'),(51931012,'created_by','JOSM'),(51931014,'created_by','JOSM'),(51931018,'created_by','JOSM'),(51931020,'created_by','JOSM'),(51931023,'created_by','JOSM'),(51931025,'created_by','JOSM'),(51931026,'created_by','JOSM'),(51931029,'created_by','JOSM'),(51931032,'created_by','JOSM'),(51931036,'created_by','JOSM'),(51931037,'created_by','JOSM'),(51931040,'created_by','JOSM'),(51931043,'created_by','JOSM'),(51931045,'created_by','JOSM'),(51931047,'created_by','JOSM'),(51931050,'created_by','JOSM'),(51931053,'created_by','JOSM'),(51931055,'created_by','JOSM'),(51931057,'created_by','JOSM'),(51931060,'created_by','JOSM'),(51931062,'created_by','JOSM'),(51931065,'created_by','JOSM'),(51931066,'created_by','JOSM'),(51931069,'created_by','JOSM'),(51931070,'created_by','JOSM'),(51931073,'created_by','JOSM'),(51931076,'created_by','JOSM'),(51931077,'created_by','JOSM'),(51931080,'created_by','JOSM'),(51931084,'created_by','JOSM'),(51931087,'created_by','JOSM'),(51931090,'created_by','JOSM'),(51931093,'created_by','JOSM'),(51931095,'created_by','JOSM'),(51931097,'created_by','JOSM'),(51931099,'created_by','JOSM'),(51931101,'created_by','JOSM'),(51931103,'created_by','JOSM'),(51931105,'created_by','JOSM'),(51951640,'created_by','JOSM'),(51951645,'created_by','JOSM'),(51951647,'created_by','JOSM'),(51951648,'created_by','JOSM'),(51951650,'created_by','JOSM'),(51951652,'created_by','JOSM'),(51951654,'created_by','JOSM'),(51951657,'created_by','JOSM'),(51951658,'created_by','JOSM'),(51951661,'created_by','JOSM'),(51951665,'created_by','JOSM'),(51951667,'created_by','JOSM'),(51951670,'created_by','JOSM'),(51951673,'created_by','JOSM'),(51951676,'created_by','JOSM'),(51951678,'created_by','JOSM'),(51951680,'created_by','JOSM'),(51951682,'created_by','JOSM'),(51951684,'created_by','JOSM'),(51951686,'created_by','JOSM'),(51951689,'created_by','JOSM'),(51951690,'created_by','JOSM'),(51951692,'created_by','JOSM'),(51951694,'created_by','JOSM'),(51951696,'created_by','JOSM'),(51951700,'created_by','JOSM'),(51951701,'created_by','JOSM'),(51951703,'created_by','JOSM'),(51951706,'created_by','JOSM'),(51951709,'created_by','JOSM'),(51951711,'created_by','JOSM'),(51951713,'created_by','JOSM'),(51951716,'created_by','JOSM'),(51951719,'created_by','JOSM'),(51951723,'created_by','JOSM'),(51951726,'created_by','JOSM'),(51951729,'created_by','JOSM'),(51951731,'created_by','JOSM'),(51951734,'created_by','JOSM'),(51951736,'created_by','JOSM'),(51951739,'created_by','JOSM'),(51951741,'created_by','JOSM'),(51951744,'created_by','JOSM'),(51951747,'created_by','JOSM'),(51951748,'created_by','JOSM'),(51951751,'created_by','JOSM'),(51951755,'created_by','JOSM'),(51951758,'created_by','JOSM'),(51951761,'created_by','JOSM'),(51951763,'created_by','JOSM'),(51951766,'created_by','JOSM'),(51951769,'created_by','JOSM'),(51951772,'created_by','JOSM'),(51951775,'created_by','JOSM'),(51951777,'created_by','JOSM'),(51951780,'created_by','JOSM'),(51951784,'created_by','JOSM'),(51951785,'created_by','JOSM'),(51951788,'created_by','JOSM'),(51951790,'created_by','JOSM'),(51951793,'created_by','JOSM'),(51951796,'created_by','JOSM'),(51951799,'created_by','JOSM'),(51951801,'created_by','JOSM'),(51951805,'created_by','JOSM'),(51951808,'created_by','JOSM'),(51951810,'created_by','JOSM'),(51951813,'created_by','JOSM'),(51951816,'created_by','JOSM'),(51951817,'created_by','JOSM'),(51951819,'created_by','JOSM'),(51951821,'created_by','JOSM'),(51951824,'created_by','JOSM'),(51951827,'created_by','JOSM'),(51951830,'created_by','JOSM'),(51951833,'created_by','JOSM'),(51951836,'created_by','JOSM'),(51951838,'created_by','JOSM'),(51951840,'created_by','JOSM'),(51951843,'created_by','JOSM'),(51951846,'created_by','JOSM'),(51951848,'created_by','JOSM'),(51951851,'created_by','JOSM'),(51951854,'created_by','JOSM'),(51951857,'created_by','JOSM'),(51951858,'created_by','JOSM'),(51951859,'created_by','JOSM'),(51951861,'created_by','JOSM'),(51951864,'created_by','JOSM'),(51951865,'created_by','JOSM'),(51951868,'created_by','JOSM'),(51951872,'created_by','JOSM'),(51951874,'created_by','JOSM'),(51951876,'created_by','JOSM'),(51951879,'created_by','JOSM'),(51951882,'created_by','JOSM'),(51951885,'created_by','JOSM'),(51951886,'created_by','JOSM'),(51951889,'created_by','JOSM'),(51951892,'created_by','JOSM'),(51951895,'created_by','JOSM'),(51951898,'created_by','JOSM'),(51951900,'created_by','JOSM'),(51951903,'created_by','JOSM'),(51951905,'created_by','JOSM'),(51951908,'created_by','JOSM'),(51951911,'created_by','JOSM'),(51951914,'created_by','JOSM'),(51951917,'created_by','JOSM'),(51951920,'created_by','JOSM'),(51951922,'created_by','JOSM'),(51951924,'created_by','JOSM'),(51951927,'created_by','JOSM'),(51951930,'created_by','JOSM'),(51951933,'created_by','JOSM'),(51951935,'created_by','JOSM'),(51951937,'created_by','JOSM'),(51951938,'created_by','JOSM'),(51951941,'created_by','JOSM'),(51951944,'created_by','JOSM'),(51951947,'created_by','JOSM'),(51951950,'created_by','JOSM'),(51951953,'created_by','JOSM'),(51951956,'created_by','JOSM'),(51951957,'created_by','JOSM'),(51951960,'created_by','JOSM'),(51951963,'created_by','JOSM'),(51951965,'created_by','JOSM'),(51951966,'created_by','JOSM'),(51951969,'created_by','JOSM'),(51951970,'created_by','JOSM'),(51951973,'created_by','JOSM'),(51951975,'created_by','JOSM'),(51951978,'created_by','JOSM'),(51951980,'created_by','JOSM'),(51951983,'created_by','JOSM'),(51951985,'created_by','JOSM'),(51951988,'created_by','JOSM'),(51951989,'created_by','JOSM'),(51951992,'created_by','JOSM'),(51951995,'created_by','JOSM'),(51951999,'created_by','JOSM'),(51952002,'created_by','JOSM'),(51952005,'created_by','JOSM'),(51952009,'created_by','JOSM'),(51952013,'created_by','JOSM'),(51952014,'created_by','JOSM'),(51952017,'created_by','JOSM'),(51952019,'created_by','JOSM'),(51952022,'created_by','JOSM'),(51952025,'created_by','JOSM'),(51952028,'created_by','JOSM'),(51952029,'created_by','JOSM'),(51952031,'created_by','JOSM'),(51952034,'created_by','JOSM'),(51952037,'created_by','JOSM'),(51952039,'created_by','JOSM'),(51952042,'created_by','JOSM'),(51952045,'created_by','JOSM'),(51952046,'created_by','JOSM'),(51952048,'created_by','JOSM'),(51952050,'created_by','JOSM'),(51952053,'created_by','JOSM'),(51952055,'created_by','JOSM'),(51952058,'created_by','JOSM'),(51952060,'created_by','JOSM'),(51952063,'created_by','JOSM'),(51952065,'created_by','JOSM'),(51952068,'created_by','JOSM'),(51952069,'created_by','JOSM'),(51952073,'created_by','JOSM'),(51952075,'created_by','JOSM'),(51952078,'created_by','JOSM'),(51952080,'created_by','JOSM'),(51952083,'created_by','JOSM'),(51952084,'created_by','JOSM'),(51952087,'created_by','JOSM'),(51952090,'created_by','JOSM'),(51952093,'created_by','JOSM'),(51952096,'created_by','JOSM'),(51952099,'created_by','JOSM'),(51952101,'created_by','JOSM'),(51952103,'created_by','JOSM'),(51952105,'created_by','JOSM'),(51952107,'created_by','JOSM'),(51952110,'created_by','JOSM'),(51952111,'created_by','JOSM'),(51952113,'created_by','JOSM'),(51952115,'created_by','JOSM'),(51952118,'created_by','JOSM'),(51952120,'created_by','JOSM'),(51952122,'created_by','JOSM'),(51952125,'created_by','JOSM'),(51952126,'created_by','JOSM'),(51952128,'created_by','JOSM'),(51952132,'created_by','JOSM'),(51952136,'created_by','JOSM'),(51952139,'created_by','JOSM'),(51952141,'created_by','JOSM'),(51952145,'created_by','JOSM'),(51952148,'created_by','JOSM'),(51952150,'created_by','JOSM'),(51952152,'created_by','JOSM'),(51952155,'created_by','JOSM'),(51952157,'created_by','JOSM'),(51952159,'created_by','JOSM'),(51952161,'created_by','JOSM'),(51952163,'created_by','JOSM'),(51952167,'created_by','JOSM'),(51952170,'created_by','JOSM'),(51952172,'created_by','JOSM'),(51952176,'created_by','JOSM'),(51952177,'created_by','JOSM'),(51952180,'created_by','JOSM'),(51952183,'created_by','JOSM'),(51952185,'created_by','JOSM'),(51952187,'created_by','JOSM'),(51952190,'created_by','JOSM'),(51952192,'created_by','JOSM'),(51952193,'created_by','JOSM'),(51952195,'created_by','JOSM'),(51952196,'created_by','JOSM'),(51952199,'created_by','JOSM'),(51952201,'created_by','JOSM'),(51952204,'created_by','JOSM'),(51952205,'created_by','JOSM'),(51952207,'created_by','JOSM'),(51952210,'created_by','JOSM'),(51952213,'created_by','JOSM'),(51952215,'created_by','JOSM'),(51952217,'created_by','JOSM'),(51952220,'created_by','JOSM'),(51952223,'created_by','JOSM'),(51952226,'created_by','JOSM'),(51952230,'created_by','JOSM'),(51952233,'created_by','JOSM'),(51952236,'created_by','JOSM'),(51952238,'created_by','JOSM'),(51952240,'created_by','JOSM'),(51952243,'created_by','JOSM'),(51952246,'created_by','JOSM'),(51952248,'created_by','JOSM'),(51952250,'created_by','JOSM'),(51952252,'created_by','JOSM'),(51952255,'created_by','JOSM'),(51952256,'created_by','JOSM'),(51952259,'created_by','JOSM'),(51952530,'created_by','JOSM'),(51952532,'created_by','JOSM'),(51952534,'created_by','JOSM'),(51952536,'created_by','JOSM'),(51952539,'created_by','JOSM'),(51952542,'created_by','JOSM'),(51952545,'created_by','JOSM'),(51952546,'created_by','JOSM'),(51952549,'created_by','JOSM'),(51952552,'created_by','JOSM'),(51952556,'created_by','JOSM'),(51952559,'created_by','JOSM'),(51952562,'created_by','JOSM'),(51952566,'created_by','JOSM'),(51952570,'created_by','JOSM'),(51952573,'created_by','JOSM'),(51952575,'created_by','JOSM'),(51952578,'created_by','JOSM'),(51952580,'created_by','JOSM'),(51952583,'created_by','JOSM'),(51952584,'created_by','JOSM'),(51952586,'created_by','JOSM'),(51952590,'created_by','JOSM'),(51952594,'created_by','JOSM'),(51952597,'created_by','JOSM'),(51952599,'created_by','JOSM'),(51952601,'created_by','JOSM'),(51952604,'created_by','JOSM'),(51952605,'created_by','JOSM'),(51952608,'created_by','JOSM'),(51952610,'created_by','JOSM'),(51952613,'created_by','JOSM'),(51952615,'created_by','JOSM'),(51952618,'created_by','JOSM'),(51952620,'created_by','JOSM'),(51952623,'created_by','JOSM'),(51952627,'created_by','JOSM'),(51952630,'created_by','JOSM'),(51952632,'created_by','JOSM'),(51952634,'created_by','JOSM'),(51952635,'created_by','JOSM'),(51952638,'created_by','JOSM'),(51952640,'created_by','JOSM'),(51952643,'created_by','JOSM'),(51952647,'created_by','JOSM'),(51952649,'created_by','JOSM'),(51952652,'created_by','JOSM'),(51952653,'created_by','JOSM'),(51952656,'created_by','JOSM'),(51952659,'created_by','JOSM'),(51952662,'created_by','JOSM'),(51952665,'created_by','JOSM'),(51952667,'created_by','JOSM'),(51952668,'created_by','JOSM'),(51952671,'created_by','JOSM'),(51952672,'created_by','JOSM'),(51952675,'created_by','JOSM'),(51952677,'created_by','JOSM'),(51952682,'created_by','JOSM'),(51952684,'created_by','JOSM'),(51952686,'created_by','JOSM'),(51952689,'created_by','JOSM'),(51952690,'created_by','JOSM'),(51952692,'created_by','JOSM'),(51952694,'created_by','JOSM'),(51952695,'created_by','JOSM'),(51952699,'created_by','JOSM'),(51952701,'created_by','JOSM'),(51952702,'created_by','JOSM'),(51952705,'created_by','JOSM'),(51952706,'created_by','JOSM'),(51952709,'created_by','JOSM'),(51952712,'created_by','JOSM'),(51952714,'created_by','JOSM'),(51952715,'created_by','JOSM'),(51952717,'created_by','JOSM'),(51952719,'created_by','JOSM'),(51952722,'created_by','JOSM'),(51952724,'created_by','JOSM'),(51952727,'created_by','JOSM'),(51952729,'created_by','JOSM'),(51952732,'created_by','JOSM'),(51952733,'created_by','JOSM'),(51952737,'created_by','JOSM'),(51952740,'created_by','JOSM'),(51952742,'created_by','JOSM'),(51952745,'created_by','JOSM'),(51952748,'created_by','JOSM'),(51952751,'created_by','JOSM'),(51952754,'created_by','JOSM'),(51952756,'created_by','JOSM'),(51952758,'created_by','JOSM'),(51952761,'created_by','JOSM'),(51952764,'created_by','JOSM'),(51952767,'created_by','JOSM'),(51952770,'created_by','JOSM'),(51952772,'created_by','JOSM'),(51952775,'created_by','JOSM'),(51952777,'created_by','JOSM'),(51952780,'created_by','JOSM'),(51952782,'created_by','JOSM'),(51952784,'created_by','JOSM'),(51952786,'created_by','JOSM'),(51952788,'created_by','JOSM'),(51952790,'created_by','JOSM'),(51952792,'created_by','JOSM'),(51952795,'created_by','JOSM'),(51952797,'created_by','JOSM'),(51952800,'created_by','JOSM'),(51952802,'created_by','JOSM'),(51952804,'created_by','JOSM'),(51952807,'created_by','JOSM'),(51952811,'created_by','JOSM'),(51952813,'created_by','JOSM'),(51952815,'created_by','JOSM'),(51952818,'created_by','JOSM'),(51952820,'created_by','JOSM'),(51952824,'created_by','JOSM'),(51952827,'created_by','JOSM'),(51952829,'created_by','JOSM'),(51952831,'created_by','JOSM'),(51952832,'created_by','JOSM'),(51952834,'created_by','JOSM'),(51952837,'created_by','JOSM'),(51952840,'created_by','JOSM'),(51952842,'created_by','JOSM'),(51956993,'created_by','JOSM'),(51956997,'created_by','JOSM'),(51956999,'created_by','JOSM'),(51957002,'created_by','JOSM'),(51957005,'created_by','JOSM'),(51957008,'created_by','JOSM'),(51957009,'created_by','JOSM'),(51957013,'created_by','JOSM'),(51957016,'created_by','JOSM'),(51957020,'created_by','JOSM'),(51957022,'created_by','JOSM'),(51957024,'created_by','JOSM'),(51957025,'created_by','JOSM'),(51957027,'created_by','JOSM'),(51957030,'created_by','JOSM'),(51957031,'created_by','JOSM'),(51957034,'created_by','JOSM'),(51957037,'created_by','JOSM'),(51957040,'created_by','JOSM'),(51957042,'created_by','JOSM'),(51957045,'created_by','JOSM'),(51957048,'created_by','JOSM'),(51957050,'created_by','JOSM'),(51957052,'created_by','JOSM'),(51957055,'created_by','JOSM'),(51957057,'created_by','JOSM'),(51957060,'created_by','JOSM'),(51957063,'created_by','JOSM'),(51957064,'created_by','JOSM'),(51957066,'created_by','JOSM'),(51957069,'created_by','JOSM'),(51957072,'created_by','JOSM'),(51957075,'created_by','JOSM'),(51957077,'created_by','JOSM'),(51957080,'created_by','JOSM'),(51957082,'created_by','JOSM'),(51957085,'created_by','JOSM'),(51957087,'created_by','JOSM'),(51957090,'created_by','JOSM'),(51957092,'created_by','JOSM'),(51957094,'created_by','JOSM'),(51957098,'created_by','JOSM'),(51957101,'created_by','JOSM'),(51957103,'created_by','JOSM'),(51957105,'created_by','JOSM'),(51957110,'created_by','JOSM'),(51957112,'created_by','JOSM'),(51957115,'created_by','JOSM'),(51957117,'created_by','JOSM'),(51957119,'created_by','JOSM'),(51957121,'created_by','JOSM'),(51957125,'created_by','JOSM'),(51957128,'created_by','JOSM'),(51957131,'created_by','JOSM'),(51957134,'created_by','JOSM'),(51957135,'created_by','JOSM'),(51957138,'created_by','JOSM'),(51957141,'created_by','JOSM'),(51957143,'created_by','JOSM'),(51957144,'created_by','JOSM'),(51957146,'created_by','JOSM'),(51957147,'created_by','JOSM'),(51957151,'created_by','JOSM'),(51957153,'created_by','JOSM'),(51957155,'created_by','JOSM'),(51957157,'created_by','JOSM'),(51957160,'created_by','JOSM'),(51957162,'created_by','JOSM'),(51957164,'created_by','JOSM'),(51957166,'created_by','JOSM'),(51957168,'created_by','JOSM'),(51957170,'created_by','JOSM'),(51957172,'created_by','JOSM'),(51957174,'created_by','JOSM'),(51972980,'created_by','JOSM'),(51972984,'created_by','JOSM'),(51972990,'created_by','JOSM'),(51972993,'created_by','JOSM'),(51972999,'created_by','JOSM'),(51973000,'created_by','JOSM'),(51973004,'created_by','JOSM'),(51973007,'created_by','JOSM'),(51973010,'created_by','JOSM'),(51973014,'created_by','JOSM'),(51973017,'created_by','JOSM'),(51973021,'created_by','JOSM'),(51973026,'created_by','JOSM'),(51973027,'created_by','JOSM'),(51973030,'created_by','JOSM'),(51973033,'created_by','JOSM'),(51973038,'created_by','JOSM'),(51973045,'created_by','JOSM'),(51973049,'created_by','JOSM'),(51973052,'created_by','JOSM'),(51973055,'created_by','JOSM'),(51973058,'created_by','JOSM'),(51973061,'created_by','JOSM'),(51973066,'created_by','JOSM'),(51973069,'created_by','JOSM'),(51973073,'created_by','JOSM'),(51973078,'created_by','JOSM'),(51973082,'created_by','JOSM'),(51973084,'created_by','JOSM'),(51973088,'created_by','JOSM'),(51973091,'created_by','JOSM'),(51973096,'created_by','JOSM'),(51973099,'created_by','JOSM'),(51973102,'created_by','JOSM'),(51973105,'created_by','JOSM'),(51973108,'created_by','JOSM'),(51973112,'created_by','JOSM'),(51973113,'created_by','JOSM'),(51973117,'created_by','JOSM'),(51973120,'created_by','JOSM'),(51973122,'created_by','JOSM'),(51973128,'created_by','JOSM'),(51973131,'created_by','JOSM'),(51973135,'created_by','JOSM'),(51973138,'created_by','JOSM'),(51973141,'created_by','JOSM'),(51973144,'created_by','JOSM'),(51973147,'created_by','JOSM'),(51973150,'created_by','JOSM'),(51973154,'created_by','JOSM'),(51973156,'created_by','JOSM'),(51973158,'created_by','JOSM'),(51973161,'created_by','JOSM'),(51973163,'created_by','JOSM'),(51973166,'created_by','JOSM'),(51973170,'created_by','JOSM'),(51973172,'created_by','JOSM'),(51973175,'created_by','JOSM'),(51973177,'created_by','JOSM'),(51973179,'created_by','JOSM'),(51973183,'created_by','JOSM'),(51973186,'created_by','JOSM'),(51973190,'created_by','JOSM'),(51973193,'created_by','JOSM'),(51973196,'created_by','JOSM'),(51973198,'created_by','JOSM'),(51973201,'created_by','JOSM'),(51973203,'created_by','JOSM'),(51973206,'created_by','JOSM'),(51973208,'created_by','JOSM'),(51973210,'created_by','JOSM'),(51973213,'created_by','JOSM'),(51973215,'created_by','JOSM'),(51973219,'created_by','JOSM'),(51973221,'created_by','JOSM'),(51973223,'created_by','JOSM'),(51973225,'created_by','JOSM'),(51973228,'created_by','JOSM'),(51973234,'created_by','JOSM'),(51973237,'created_by','JOSM'),(51973241,'created_by','JOSM'),(51973243,'created_by','JOSM'),(51973247,'created_by','JOSM'),(51973249,'created_by','JOSM'),(51973253,'created_by','JOSM'),(51973256,'created_by','JOSM'),(51973260,'created_by','JOSM'),(51973264,'created_by','JOSM'),(51973268,'created_by','JOSM'),(51973269,'created_by','JOSM'),(51973273,'created_by','JOSM'),(51973276,'created_by','JOSM'),(51973278,'created_by','JOSM'),(51973281,'created_by','JOSM'),(51973284,'created_by','JOSM'),(51973287,'created_by','JOSM'),(51973290,'created_by','JOSM'),(51973293,'created_by','JOSM'),(51973296,'created_by','JOSM'),(51973300,'created_by','JOSM'),(51973302,'created_by','JOSM'),(51973306,'created_by','JOSM'),(51973310,'created_by','JOSM'),(51973313,'created_by','JOSM'),(51973316,'created_by','JOSM'),(51973320,'created_by','JOSM'),(51973324,'created_by','JOSM'),(51973326,'created_by','JOSM'),(51973327,'created_by','JOSM'),(51973329,'created_by','JOSM'),(51973334,'created_by','JOSM'),(51973336,'created_by','JOSM'),(51973339,'created_by','JOSM'),(51973341,'created_by','JOSM'),(51973344,'created_by','JOSM'),(51973346,'created_by','JOSM'),(51973348,'created_by','JOSM'),(51973351,'created_by','JOSM'),(51973352,'created_by','JOSM'),(51973353,'created_by','JOSM'),(51973354,'created_by','JOSM'),(51973356,'created_by','JOSM'),(51973357,'created_by','JOSM'),(51973359,'created_by','JOSM'),(51973361,'created_by','JOSM'),(51973362,'created_by','JOSM'),(51973363,'created_by','JOSM'),(51973364,'created_by','JOSM'),(51973366,'created_by','JOSM'),(51973369,'created_by','JOSM'),(51973370,'created_by','JOSM'),(51973373,'created_by','JOSM'),(51973375,'created_by','JOSM'),(51973378,'created_by','JOSM'),(51973380,'created_by','JOSM'),(51973384,'created_by','JOSM'),(51973387,'created_by','JOSM'),(51973390,'created_by','JOSM'),(51973394,'created_by','JOSM'),(51973396,'created_by','JOSM'),(51973398,'created_by','JOSM'),(51973400,'created_by','JOSM'),(51973403,'created_by','JOSM'),(51973405,'created_by','JOSM'),(51973407,'created_by','JOSM'),(51973409,'created_by','JOSM'),(51973413,'created_by','JOSM'),(51973416,'created_by','JOSM'),(51973417,'created_by','JOSM'),(51973419,'created_by','JOSM'),(51973424,'created_by','JOSM'),(51973426,'created_by','JOSM'),(51973428,'created_by','JOSM'),(51973430,'created_by','JOSM'),(51973432,'created_by','JOSM'),(51973436,'created_by','JOSM'),(51973439,'created_by','JOSM'),(51973441,'created_by','JOSM'),(51973444,'created_by','JOSM'),(51973448,'created_by','JOSM'),(51973451,'created_by','JOSM'),(51973454,'created_by','JOSM'),(51973456,'created_by','JOSM'),(51973459,'created_by','JOSM'),(51973462,'created_by','JOSM'),(51973467,'created_by','JOSM'),(51973470,'created_by','JOSM'),(51973471,'created_by','JOSM'),(51973475,'created_by','JOSM'),(51973478,'created_by','JOSM'),(51973481,'created_by','JOSM'),(51973484,'created_by','JOSM'),(51973487,'created_by','JOSM'),(51973489,'created_by','JOSM'),(51973491,'created_by','JOSM'),(51973494,'created_by','JOSM'),(51973497,'created_by','JOSM'),(51973499,'created_by','JOSM'),(51973504,'created_by','JOSM'),(51973507,'created_by','JOSM'),(51973511,'created_by','JOSM'),(51973514,'created_by','JOSM'),(51973516,'created_by','JOSM'),(51973519,'created_by','JOSM'),(51973521,'created_by','JOSM'),(51973523,'created_by','JOSM'),(51973526,'created_by','JOSM'),(51973528,'created_by','JOSM'),(51973529,'created_by','JOSM'),(51973532,'created_by','JOSM'),(51973534,'created_by','JOSM'),(51973538,'created_by','JOSM'),(51973541,'created_by','JOSM'),(51973544,'created_by','JOSM'),(51973546,'created_by','JOSM'),(51973548,'created_by','JOSM'),(51973550,'created_by','JOSM'),(51973554,'created_by','JOSM'),(51973557,'created_by','JOSM'),(51973559,'created_by','JOSM'),(51973561,'created_by','JOSM'),(51973562,'created_by','JOSM'),(51973564,'created_by','JOSM'),(51973567,'created_by','JOSM'),(51973570,'created_by','JOSM'),(51973571,'created_by','JOSM'),(51973575,'created_by','JOSM'),(51973577,'created_by','JOSM'),(51973579,'created_by','JOSM'),(51973582,'created_by','JOSM'),(51973587,'created_by','JOSM'),(51973590,'created_by','JOSM'),(51973591,'created_by','JOSM'),(51973594,'created_by','JOSM'),(51973596,'created_by','JOSM'),(51973598,'created_by','JOSM'),(51973599,'created_by','JOSM'),(51973602,'created_by','JOSM'),(51973604,'created_by','JOSM'),(51973606,'created_by','JOSM'),(51973608,'created_by','JOSM'),(51973611,'created_by','JOSM'),(51973614,'created_by','JOSM'),(51973617,'created_by','JOSM'),(51973619,'created_by','JOSM'),(51973621,'created_by','JOSM'),(51973622,'created_by','JOSM'),(51973624,'created_by','JOSM'),(51973627,'created_by','JOSM'),(51973631,'created_by','JOSM'),(51973633,'created_by','JOSM'),(51973636,'created_by','JOSM'),(51973639,'created_by','JOSM'),(51973643,'created_by','JOSM'),(51973646,'created_by','JOSM'),(51973648,'created_by','JOSM'),(51973651,'created_by','JOSM'),(51973653,'created_by','JOSM'),(51973657,'created_by','JOSM'),(51973660,'created_by','JOSM'),(51973663,'created_by','JOSM'),(51973667,'created_by','JOSM'),(51973669,'created_by','JOSM');
INSERT INTO `current_node_tags` VALUES (51973673,'created_by','JOSM'),(51973676,'created_by','JOSM'),(51973679,'created_by','JOSM'),(51973681,'created_by','JOSM'),(51973683,'created_by','JOSM'),(51973686,'created_by','JOSM'),(51973688,'created_by','JOSM'),(51973691,'created_by','JOSM'),(51973694,'created_by','JOSM'),(51973696,'created_by','JOSM'),(51973699,'created_by','JOSM'),(51973703,'created_by','JOSM'),(51973705,'created_by','JOSM'),(51973708,'created_by','JOSM'),(51973711,'created_by','JOSM'),(51973714,'created_by','JOSM'),(51973717,'created_by','JOSM'),(51973720,'created_by','JOSM'),(51973722,'created_by','JOSM'),(51973725,'created_by','JOSM'),(51973728,'created_by','JOSM'),(51973730,'created_by','JOSM'),(51973731,'created_by','JOSM'),(51973733,'created_by','JOSM'),(51973736,'created_by','JOSM'),(51973739,'created_by','JOSM'),(51973741,'created_by','JOSM'),(51973744,'created_by','JOSM'),(51973747,'created_by','JOSM'),(51973749,'created_by','JOSM'),(51973751,'created_by','JOSM'),(51973753,'created_by','JOSM'),(51973755,'created_by','JOSM'),(51973757,'created_by','JOSM'),(51973759,'created_by','JOSM'),(51973764,'created_by','JOSM'),(51973766,'created_by','JOSM'),(51973769,'created_by','JOSM'),(51973770,'created_by','JOSM'),(51973771,'created_by','JOSM'),(51973777,'created_by','JOSM'),(51973782,'created_by','JOSM'),(51973784,'created_by','JOSM'),(51973786,'created_by','JOSM'),(51973790,'created_by','JOSM'),(51973792,'created_by','JOSM'),(51973796,'created_by','JOSM'),(51973799,'created_by','JOSM'),(51973802,'created_by','JOSM'),(51973803,'created_by','JOSM'),(51973807,'created_by','JOSM'),(51973809,'created_by','JOSM'),(51973812,'created_by','JOSM'),(51973815,'created_by','JOSM'),(51973817,'created_by','JOSM'),(51973818,'created_by','JOSM'),(51973820,'created_by','JOSM'),(51973831,'created_by','JOSM'),(51973834,'created_by','JOSM'),(51973836,'created_by','JOSM'),(51973839,'created_by','JOSM'),(51973842,'created_by','JOSM'),(51973844,'created_by','JOSM'),(51973846,'created_by','JOSM'),(51973848,'created_by','JOSM'),(51973849,'created_by','JOSM'),(51973851,'created_by','JOSM'),(51973852,'created_by','JOSM'),(51973855,'created_by','JOSM'),(51973858,'created_by','JOSM'),(51973860,'created_by','JOSM'),(51973862,'created_by','JOSM'),(51973865,'created_by','JOSM'),(51973868,'created_by','JOSM'),(51973871,'created_by','JOSM'),(51973874,'created_by','JOSM'),(51973877,'created_by','JOSM'),(51973878,'created_by','JOSM'),(51973881,'created_by','JOSM'),(51973883,'created_by','JOSM'),(51973884,'created_by','JOSM'),(51973887,'created_by','JOSM'),(51973890,'created_by','JOSM'),(51973891,'created_by','JOSM'),(51973894,'created_by','JOSM'),(51973897,'created_by','JOSM'),(51973898,'created_by','JOSM'),(51973901,'created_by','JOSM'),(51973903,'created_by','JOSM'),(51973905,'created_by','JOSM'),(51973907,'created_by','JOSM'),(51973910,'created_by','JOSM'),(51973913,'created_by','JOSM'),(51973915,'created_by','JOSM'),(51973917,'created_by','JOSM'),(51973920,'created_by','JOSM'),(51973922,'created_by','JOSM'),(51973924,'created_by','JOSM'),(51973927,'created_by','JOSM'),(51973929,'created_by','JOSM'),(51973931,'created_by','JOSM'),(51973934,'created_by','JOSM'),(51973937,'created_by','JOSM'),(51973939,'created_by','JOSM'),(51973941,'created_by','JOSM'),(51973942,'created_by','JOSM'),(51973947,'created_by','JOSM'),(51973950,'created_by','JOSM'),(51973952,'created_by','JOSM'),(51973953,'created_by','JOSM'),(51973955,'created_by','JOSM'),(51973958,'created_by','JOSM'),(51973962,'created_by','JOSM'),(51973963,'created_by','JOSM'),(51973967,'created_by','JOSM'),(51973968,'created_by','JOSM'),(51973972,'created_by','JOSM'),(51973975,'created_by','JOSM'),(51973977,'created_by','JOSM'),(51973981,'created_by','JOSM'),(51973983,'created_by','JOSM'),(51973986,'created_by','JOSM'),(51973989,'created_by','JOSM'),(51973992,'created_by','JOSM'),(51973995,'created_by','JOSM'),(51973998,'created_by','JOSM'),(51974002,'created_by','JOSM'),(51974005,'created_by','JOSM'),(51974008,'created_by','JOSM'),(51974011,'created_by','JOSM'),(51974013,'created_by','JOSM'),(51974015,'created_by','JOSM'),(51974019,'created_by','JOSM'),(51974023,'created_by','JOSM'),(51974024,'created_by','JOSM'),(51974028,'created_by','JOSM'),(51974031,'created_by','JOSM'),(51974035,'created_by','JOSM'),(51974039,'created_by','JOSM'),(51974040,'created_by','JOSM'),(51974042,'created_by','JOSM'),(51974044,'created_by','JOSM'),(51974046,'created_by','JOSM'),(51974049,'created_by','JOSM'),(51974050,'created_by','JOSM'),(51974053,'created_by','JOSM'),(51974055,'created_by','JOSM'),(51974057,'created_by','JOSM'),(51974059,'created_by','JOSM'),(51974060,'created_by','JOSM'),(51974065,'created_by','JOSM'),(51974068,'created_by','JOSM'),(51974072,'created_by','JOSM'),(51974074,'created_by','JOSM'),(51974078,'created_by','JOSM'),(51974083,'created_by','JOSM'),(51974085,'created_by','JOSM'),(51974086,'created_by','JOSM'),(51974088,'created_by','JOSM'),(51974089,'created_by','JOSM'),(51974090,'created_by','JOSM'),(51974095,'created_by','JOSM'),(51974097,'created_by','JOSM'),(51974100,'created_by','JOSM'),(51974103,'created_by','JOSM'),(51974107,'created_by','JOSM'),(51974108,'created_by','JOSM'),(51974112,'created_by','JOSM'),(51974115,'created_by','JOSM'),(51974119,'created_by','JOSM'),(51974122,'created_by','JOSM'),(51974126,'created_by','JOSM'),(51974129,'created_by','JOSM'),(51974131,'created_by','JOSM'),(51974133,'created_by','JOSM'),(51974134,'created_by','JOSM'),(51974137,'created_by','JOSM'),(51974140,'created_by','JOSM'),(51974143,'created_by','JOSM'),(51974147,'created_by','JOSM'),(51974149,'created_by','JOSM'),(51974152,'created_by','JOSM'),(51974153,'created_by','JOSM'),(51974155,'created_by','JOSM'),(51974158,'created_by','JOSM'),(51974161,'created_by','JOSM'),(51974164,'created_by','JOSM'),(51974165,'created_by','JOSM'),(51974167,'created_by','JOSM'),(51974169,'created_by','JOSM'),(51974172,'created_by','JOSM'),(51974174,'created_by','JOSM'),(51974176,'created_by','JOSM'),(51974181,'created_by','JOSM'),(51974183,'created_by','JOSM'),(51974185,'created_by','JOSM'),(51974187,'created_by','JOSM'),(51974190,'created_by','JOSM'),(51974191,'created_by','JOSM'),(51974193,'created_by','JOSM'),(51974195,'created_by','JOSM'),(51974197,'created_by','JOSM'),(51974199,'created_by','JOSM'),(51974202,'created_by','JOSM'),(51974204,'created_by','JOSM'),(51974206,'created_by','JOSM'),(51974208,'created_by','JOSM'),(51974211,'created_by','JOSM'),(51974213,'created_by','JOSM'),(51974215,'created_by','JOSM'),(51974217,'created_by','JOSM'),(51974220,'created_by','JOSM'),(51974223,'created_by','JOSM'),(51974226,'created_by','JOSM'),(51974229,'created_by','JOSM'),(51974231,'created_by','JOSM'),(51974233,'created_by','JOSM'),(51974236,'created_by','JOSM'),(51974239,'created_by','JOSM'),(51974242,'created_by','JOSM'),(51974244,'created_by','JOSM'),(51974247,'created_by','JOSM'),(51974249,'created_by','JOSM'),(51974251,'created_by','JOSM'),(51974253,'created_by','JOSM'),(51974256,'created_by','JOSM'),(51974258,'created_by','JOSM'),(51974261,'created_by','JOSM'),(51974264,'created_by','JOSM'),(51974266,'created_by','JOSM'),(51974275,'created_by','JOSM'),(51974278,'created_by','JOSM'),(51974279,'created_by','JOSM'),(51974281,'created_by','JOSM'),(51974284,'created_by','JOSM'),(51974286,'created_by','JOSM'),(51974289,'created_by','JOSM'),(51974291,'created_by','JOSM'),(51974292,'created_by','JOSM'),(51974293,'created_by','JOSM'),(51974296,'created_by','JOSM'),(51974298,'created_by','JOSM'),(51974300,'created_by','JOSM'),(51974301,'created_by','JOSM'),(51974305,'created_by','JOSM'),(51974308,'created_by','JOSM'),(51974309,'created_by','JOSM'),(51974313,'created_by','JOSM'),(51974316,'created_by','JOSM'),(51974319,'created_by','JOSM'),(51974321,'created_by','JOSM'),(51974323,'created_by','JOSM'),(51974326,'created_by','JOSM'),(51974328,'created_by','JOSM'),(51974331,'created_by','JOSM'),(51974334,'created_by','JOSM'),(51974337,'created_by','JOSM'),(51974339,'created_by','JOSM'),(51974341,'created_by','JOSM'),(51974345,'created_by','JOSM'),(51974349,'created_by','JOSM'),(51974353,'created_by','JOSM'),(51974357,'created_by','JOSM'),(51974360,'created_by','JOSM'),(51974363,'created_by','JOSM'),(51974365,'created_by','JOSM'),(51974368,'created_by','JOSM'),(51974371,'created_by','JOSM'),(51974373,'created_by','JOSM'),(51974374,'created_by','JOSM'),(51974376,'created_by','JOSM'),(51974378,'created_by','JOSM'),(51974383,'created_by','JOSM'),(51974385,'created_by','JOSM'),(51974388,'created_by','JOSM'),(51974391,'created_by','JOSM'),(51974394,'created_by','JOSM'),(51974395,'created_by','JOSM'),(51974397,'created_by','JOSM'),(51974400,'created_by','JOSM'),(51974402,'created_by','JOSM'),(51974404,'created_by','JOSM'),(51974405,'created_by','JOSM'),(51974408,'created_by','JOSM'),(51974411,'created_by','JOSM'),(51974414,'created_by','JOSM'),(51974416,'created_by','JOSM'),(51974419,'created_by','JOSM'),(51974422,'created_by','JOSM'),(51974424,'created_by','JOSM'),(51974428,'created_by','JOSM'),(51974430,'created_by','JOSM'),(51974432,'created_by','JOSM'),(51974436,'created_by','JOSM'),(51974439,'created_by','JOSM'),(51974442,'created_by','JOSM'),(51974445,'created_by','JOSM'),(51974446,'created_by','JOSM'),(51974451,'created_by','JOSM'),(51974452,'created_by','JOSM'),(51974454,'created_by','JOSM'),(51974455,'created_by','JOSM'),(51974456,'created_by','JOSM'),(51974458,'created_by','JOSM'),(51974462,'created_by','JOSM'),(51974466,'created_by','JOSM'),(51974469,'created_by','JOSM'),(51974472,'created_by','JOSM'),(51974475,'created_by','JOSM'),(51974478,'created_by','JOSM'),(51974481,'created_by','JOSM'),(51974484,'created_by','JOSM'),(52002189,'created_by','JOSM'),(52002192,'created_by','JOSM'),(52002196,'created_by','JOSM'),(52002198,'created_by','JOSM'),(52002202,'created_by','JOSM'),(52002204,'created_by','JOSM'),(52002206,'created_by','JOSM'),(52002209,'created_by','JOSM'),(52002211,'created_by','JOSM'),(52002212,'created_by','JOSM'),(52002214,'created_by','JOSM'),(52002216,'created_by','JOSM'),(52002219,'created_by','JOSM'),(52002220,'created_by','JOSM'),(52002222,'created_by','JOSM'),(52002223,'created_by','JOSM'),(52002226,'created_by','JOSM'),(52002229,'created_by','JOSM'),(52002231,'created_by','JOSM'),(52002235,'created_by','JOSM'),(52002238,'created_by','JOSM'),(52002241,'created_by','JOSM'),(52002244,'created_by','JOSM'),(52002247,'created_by','JOSM'),(52002248,'created_by','JOSM'),(52002251,'created_by','JOSM'),(52002253,'created_by','JOSM'),(52002256,'created_by','JOSM'),(52002258,'created_by','JOSM'),(52002259,'created_by','JOSM'),(52002261,'created_by','JOSM'),(52002264,'created_by','JOSM'),(52002266,'created_by','JOSM'),(52002269,'created_by','JOSM'),(52002272,'created_by','JOSM'),(52002275,'created_by','JOSM'),(52002278,'created_by','JOSM'),(52002281,'created_by','JOSM'),(52009103,'created_by','JOSM'),(52009105,'created_by','JOSM'),(52009107,'created_by','JOSM'),(52009108,'created_by','JOSM'),(52009109,'created_by','JOSM'),(52009111,'created_by','JOSM'),(52009114,'created_by','JOSM'),(52009117,'created_by','JOSM'),(52009118,'created_by','JOSM'),(52009120,'created_by','JOSM'),(52009122,'created_by','JOSM'),(52009124,'created_by','JOSM'),(52009126,'created_by','JOSM'),(52009127,'created_by','JOSM'),(52009129,'created_by','JOSM'),(52009130,'created_by','JOSM'),(52009134,'created_by','JOSM'),(52009137,'created_by','JOSM'),(52009140,'created_by','JOSM'),(52009143,'created_by','JOSM'),(52009144,'created_by','JOSM'),(52009147,'created_by','JOSM'),(52009150,'created_by','JOSM'),(52009151,'created_by','JOSM'),(52009154,'created_by','JOSM'),(52009156,'created_by','JOSM'),(52009157,'created_by','JOSM'),(52009159,'created_by','JOSM'),(52009161,'created_by','JOSM'),(52009164,'created_by','JOSM'),(52009168,'created_by','JOSM'),(52009171,'created_by','JOSM'),(52009174,'created_by','JOSM'),(52009176,'created_by','JOSM'),(52009179,'created_by','JOSM'),(52009182,'created_by','JOSM'),(52009184,'created_by','JOSM'),(52009186,'created_by','JOSM'),(52009189,'created_by','JOSM'),(52009192,'created_by','JOSM'),(52009194,'created_by','JOSM'),(52009196,'created_by','JOSM'),(52009197,'created_by','JOSM'),(52011225,'created_by','JOSM'),(52011227,'created_by','JOSM'),(52011231,'created_by','JOSM'),(52011234,'created_by','JOSM'),(52011238,'created_by','JOSM'),(52011242,'created_by','JOSM'),(52011244,'created_by','JOSM'),(52011249,'created_by','JOSM'),(52011253,'created_by','JOSM'),(52011256,'created_by','JOSM'),(52011259,'created_by','JOSM'),(52031003,'created_by','JOSM'),(52031013,'created_by','JOSM'),(52031030,'created_by','JOSM'),(52031034,'created_by','JOSM'),(52031036,'created_by','JOSM'),(52031039,'created_by','JOSM'),(52031041,'created_by','JOSM'),(52031043,'created_by','JOSM'),(52031046,'created_by','JOSM'),(52031050,'created_by','JOSM'),(52031054,'created_by','JOSM'),(52031056,'created_by','JOSM'),(52031059,'created_by','JOSM'),(52031076,'created_by','JOSM'),(52031077,'created_by','JOSM'),(52031080,'created_by','JOSM'),(52031082,'created_by','JOSM'),(52031084,'created_by','JOSM'),(52031086,'created_by','JOSM'),(52031089,'created_by','JOSM'),(52031092,'created_by','JOSM'),(52031095,'created_by','JOSM'),(52031099,'created_by','JOSM'),(52031100,'created_by','JOSM'),(52031105,'created_by','JOSM'),(52031109,'created_by','JOSM'),(52031114,'created_by','JOSM'),(52031117,'created_by','JOSM'),(52031121,'created_by','JOSM'),(52031125,'created_by','JOSM'),(52031129,'created_by','JOSM'),(52031131,'created_by','JOSM'),(52031136,'created_by','JOSM'),(52031141,'created_by','JOSM'),(52031147,'created_by','JOSM'),(52031151,'created_by','JOSM'),(52031153,'created_by','JOSM'),(52031156,'created_by','JOSM'),(52031158,'created_by','JOSM'),(52031164,'created_by','JOSM'),(52031171,'created_by','JOSM'),(52031174,'created_by','JOSM'),(52031178,'created_by','JOSM'),(52031186,'created_by','JOSM'),(52031190,'created_by','JOSM'),(52031198,'created_by','JOSM'),(52031205,'created_by','JOSM'),(52031212,'created_by','JOSM'),(52031218,'created_by','JOSM'),(52031221,'created_by','JOSM'),(52031224,'created_by','JOSM'),(52031227,'created_by','JOSM'),(52031232,'created_by','JOSM'),(52031235,'created_by','JOSM'),(52031240,'created_by','JOSM'),(52031244,'created_by','JOSM'),(52031247,'created_by','JOSM'),(52031250,'created_by','JOSM'),(52031255,'created_by','JOSM'),(52031260,'created_by','JOSM'),(52031262,'created_by','JOSM'),(52031267,'created_by','JOSM'),(52031272,'created_by','JOSM'),(52031275,'created_by','JOSM'),(52031281,'created_by','JOSM'),(52031285,'created_by','JOSM'),(52031290,'created_by','JOSM'),(52031295,'created_by','JOSM'),(52031299,'created_by','JOSM'),(52031307,'created_by','JOSM'),(52031309,'created_by','JOSM'),(52031314,'created_by','JOSM'),(52031320,'created_by','JOSM'),(52031325,'created_by','JOSM'),(52031329,'created_by','JOSM'),(52031335,'created_by','JOSM'),(52031340,'created_by','JOSM'),(52031346,'created_by','JOSM'),(52031351,'created_by','JOSM'),(52031355,'created_by','JOSM'),(52031357,'created_by','JOSM'),(52031361,'created_by','JOSM'),(52031364,'created_by','JOSM'),(52031367,'created_by','JOSM'),(52031369,'created_by','JOSM'),(52031373,'created_by','JOSM'),(52031381,'created_by','JOSM'),(52031384,'created_by','JOSM'),(52031410,'created_by','JOSM'),(52031414,'created_by','JOSM'),(52031418,'created_by','JOSM'),(52031424,'created_by','JOSM'),(52031426,'created_by','JOSM'),(52031429,'created_by','JOSM'),(52031433,'created_by','JOSM'),(52031438,'created_by','JOSM'),(52031441,'created_by','JOSM'),(52031446,'created_by','JOSM'),(52031449,'created_by','JOSM'),(52031456,'created_by','JOSM'),(52031461,'created_by','JOSM'),(52031464,'created_by','JOSM'),(52031467,'created_by','JOSM'),(52031471,'created_by','JOSM'),(52031477,'created_by','JOSM'),(52031481,'created_by','JOSM'),(52031483,'created_by','JOSM'),(52031486,'created_by','JOSM'),(52031491,'created_by','JOSM'),(52031494,'created_by','JOSM'),(52031498,'created_by','JOSM'),(52031500,'created_by','JOSM'),(52031504,'created_by','JOSM'),(52031507,'created_by','JOSM'),(52031512,'created_by','JOSM'),(52031514,'created_by','JOSM'),(52031517,'created_by','JOSM'),(52031521,'created_by','JOSM'),(52031523,'created_by','JOSM'),(52031527,'created_by','JOSM'),(52031529,'created_by','JOSM'),(52031532,'created_by','JOSM'),(52031535,'created_by','JOSM'),(52031540,'created_by','JOSM'),(52031545,'created_by','JOSM'),(52031550,'created_by','JOSM'),(52031552,'created_by','JOSM'),(52031554,'created_by','JOSM'),(52031560,'created_by','JOSM'),(52031562,'created_by','JOSM'),(52031567,'created_by','JOSM'),(52031572,'created_by','JOSM'),(52031576,'created_by','JOSM'),(52031580,'created_by','JOSM'),(52031581,'created_by','JOSM'),(52031587,'created_by','JOSM'),(52031590,'created_by','JOSM'),(52031592,'created_by','JOSM'),(52031595,'created_by','JOSM'),(52031600,'created_by','JOSM'),(52031604,'created_by','JOSM'),(52031608,'created_by','JOSM'),(52031611,'created_by','JOSM'),(52031614,'created_by','JOSM'),(52031616,'created_by','JOSM'),(52031617,'created_by','JOSM'),(52031620,'created_by','JOSM'),(52031621,'created_by','JOSM'),(52031626,'created_by','JOSM'),(52031627,'created_by','JOSM'),(52031631,'created_by','JOSM'),(52031634,'created_by','JOSM'),(52031636,'created_by','JOSM'),(52031642,'created_by','JOSM'),(52031645,'created_by','JOSM'),(52031648,'created_by','JOSM'),(52031652,'created_by','JOSM'),(52031656,'created_by','JOSM'),(52031658,'created_by','JOSM'),(52031660,'created_by','JOSM'),(52031665,'created_by','JOSM'),(52031668,'created_by','JOSM'),(52031671,'created_by','JOSM'),(52031676,'created_by','JOSM'),(52031678,'created_by','JOSM'),(52031681,'created_by','JOSM'),(52031686,'created_by','JOSM'),(52031688,'created_by','JOSM'),(52031691,'created_by','JOSM'),(52031695,'created_by','JOSM'),(52031700,'created_by','JOSM'),(52031702,'created_by','JOSM'),(52031705,'created_by','JOSM'),(52031709,'created_by','JOSM'),(52031712,'created_by','JOSM'),(52031715,'created_by','JOSM'),(52031717,'created_by','JOSM'),(52031720,'created_by','JOSM'),(52031723,'created_by','JOSM'),(52031726,'created_by','JOSM'),(52031730,'created_by','JOSM'),(52031732,'created_by','JOSM'),(52031736,'created_by','JOSM'),(52031739,'created_by','JOSM'),(52031742,'created_by','JOSM'),(52031744,'created_by','JOSM'),(52031746,'created_by','JOSM'),(52031747,'created_by','JOSM'),(52031749,'created_by','JOSM'),(52031751,'created_by','JOSM'),(52031756,'created_by','JOSM'),(52031758,'created_by','JOSM'),(52031761,'created_by','JOSM'),(52031764,'created_by','JOSM'),(52031767,'created_by','JOSM'),(52031771,'created_by','JOSM'),(52031774,'created_by','JOSM'),(52031777,'created_by','JOSM'),(52031782,'created_by','JOSM'),(52031785,'created_by','JOSM'),(52031789,'created_by','JOSM'),(52031794,'created_by','JOSM'),(52031798,'created_by','JOSM'),(52031803,'created_by','JOSM'),(52031805,'created_by','JOSM'),(52031809,'created_by','JOSM'),(52031811,'created_by','JOSM'),(52031813,'created_by','JOSM'),(52031815,'created_by','JOSM'),(52031821,'created_by','JOSM'),(52031823,'created_by','JOSM'),(52031827,'created_by','JOSM'),(52031830,'created_by','JOSM'),(52031832,'created_by','JOSM'),(52031834,'created_by','JOSM'),(52031838,'created_by','JOSM'),(52031840,'created_by','JOSM'),(52031844,'created_by','JOSM'),(52031847,'created_by','JOSM'),(52031850,'created_by','JOSM'),(52031855,'created_by','JOSM'),(52031858,'created_by','JOSM'),(52031861,'created_by','JOSM'),(52031865,'created_by','JOSM'),(52031866,'created_by','JOSM'),(52031868,'created_by','JOSM'),(52031871,'created_by','JOSM'),(52031872,'created_by','JOSM'),(52031874,'created_by','JOSM'),(52031876,'created_by','JOSM'),(52031881,'created_by','JOSM'),(52031884,'created_by','JOSM'),(52031886,'created_by','JOSM'),(52031888,'created_by','JOSM'),(52031889,'created_by','JOSM'),(52031893,'created_by','JOSM'),(52031894,'created_by','JOSM'),(52031899,'created_by','JOSM'),(52031901,'created_by','JOSM'),(52031906,'created_by','JOSM'),(52031908,'created_by','JOSM'),(52031911,'created_by','JOSM'),(52031913,'created_by','JOSM'),(52031915,'created_by','JOSM'),(52031919,'created_by','JOSM'),(52031921,'created_by','JOSM'),(52031925,'created_by','JOSM'),(52031927,'created_by','JOSM'),(52031930,'created_by','JOSM'),(52031933,'created_by','JOSM'),(52031936,'created_by','JOSM'),(52031938,'created_by','JOSM'),(52031943,'created_by','JOSM'),(52031946,'created_by','JOSM'),(52031948,'created_by','JOSM'),(52031953,'created_by','JOSM'),(52031956,'created_by','JOSM'),(52031958,'created_by','JOSM'),(52031962,'created_by','JOSM'),(52031966,'created_by','JOSM'),(52031968,'created_by','JOSM'),(52031973,'created_by','JOSM'),(52031976,'created_by','JOSM'),(52031980,'created_by','JOSM'),(52031984,'created_by','JOSM'),(52031987,'created_by','JOSM'),(52031990,'created_by','JOSM'),(52031992,'created_by','JOSM'),(52031995,'created_by','JOSM'),(52031998,'created_by','JOSM'),(52032000,'created_by','JOSM'),(52032003,'created_by','JOSM'),(52032007,'created_by','JOSM'),(52032010,'created_by','JOSM'),(52032012,'created_by','JOSM'),(52032017,'created_by','JOSM'),(52032018,'created_by','JOSM'),(52032021,'created_by','JOSM'),(52032022,'created_by','JOSM'),(52032026,'created_by','JOSM'),(52032029,'created_by','JOSM'),(52032033,'created_by','JOSM'),(52032035,'created_by','JOSM'),(52032039,'created_by','JOSM'),(52032041,'created_by','JOSM'),(52032044,'created_by','JOSM'),(52032047,'created_by','JOSM'),(52032048,'created_by','JOSM'),(52032051,'created_by','JOSM'),(52032054,'created_by','JOSM'),(52032057,'created_by','JOSM'),(52032060,'created_by','JOSM'),(52032064,'created_by','JOSM'),(52032067,'created_by','JOSM'),(52032070,'created_by','JOSM'),(52032071,'created_by','JOSM'),(52032075,'created_by','JOSM'),(52032076,'created_by','JOSM'),(52032078,'created_by','JOSM'),(52032081,'created_by','JOSM'),(52032085,'created_by','JOSM'),(52032087,'created_by','JOSM'),(52032090,'created_by','JOSM'),(52032092,'created_by','JOSM'),(52032093,'created_by','JOSM'),(52032098,'created_by','JOSM'),(52032100,'created_by','JOSM'),(52032103,'created_by','JOSM'),(52032107,'created_by','JOSM'),(52032109,'created_by','JOSM'),(52032112,'created_by','JOSM'),(52032113,'created_by','JOSM'),(52032116,'created_by','JOSM'),(52032119,'created_by','JOSM'),(52032122,'created_by','JOSM'),(52032125,'created_by','JOSM'),(52032127,'created_by','JOSM'),(52032130,'created_by','JOSM'),(52032133,'created_by','JOSM'),(52032135,'created_by','JOSM'),(52032137,'created_by','JOSM'),(52032141,'created_by','JOSM'),(52032145,'created_by','JOSM'),(52032147,'created_by','JOSM'),(52032150,'created_by','JOSM'),(52032153,'created_by','JOSM'),(52032158,'created_by','JOSM'),(52032160,'created_by','JOSM'),(52032162,'created_by','JOSM'),(52032165,'created_by','JOSM'),(52032168,'created_by','JOSM'),(52032171,'created_by','JOSM'),(52032174,'created_by','JOSM'),(52032176,'created_by','JOSM'),(52032179,'created_by','JOSM'),(52032182,'created_by','JOSM'),(52032183,'created_by','JOSM'),(52032186,'created_by','JOSM'),(52032187,'created_by','JOSM'),(52032190,'created_by','JOSM'),(52032192,'created_by','JOSM'),(52032195,'created_by','JOSM'),(52032197,'created_by','JOSM'),(52032200,'created_by','JOSM'),(52032204,'created_by','JOSM'),(52032205,'created_by','JOSM'),(52032208,'created_by','JOSM'),(52032211,'created_by','JOSM'),(52032212,'created_by','JOSM'),(52032216,'created_by','JOSM'),(52032219,'created_by','JOSM'),(52032222,'created_by','JOSM'),(52032225,'created_by','JOSM'),(52032228,'created_by','JOSM'),(52032233,'created_by','JOSM'),(52032238,'created_by','JOSM'),(52032241,'created_by','JOSM'),(52032243,'created_by','JOSM'),(52032246,'created_by','JOSM'),(52032249,'created_by','JOSM'),(52032250,'created_by','JOSM'),(52163550,'created_by','JOSM'),(52163556,'created_by','JOSM'),(52163563,'created_by','JOSM'),(52163574,'created_by','JOSM'),(52163581,'created_by','JOSM'),(52163588,'created_by','JOSM'),(52163595,'created_by','JOSM'),(52163602,'created_by','JOSM'),(52163609,'created_by','JOSM'),(52163613,'created_by','JOSM'),(52163621,'created_by','JOSM'),(52163631,'created_by','JOSM'),(52163644,'created_by','JOSM'),(52163664,'created_by','JOSM'),(52164958,'created_by','JOSM'),(52166749,'created_by','JOSM'),(52166950,'highway','mini_roundabout'),(52166959,'created_by','JOSM'),(52166976,'created_by','JOSM'),(52166980,'created_by','JOSM'),(52167010,'created_by','JOSM'),(52167017,'created_by','JOSM'),(52167025,'created_by','JOSM'),(52167030,'created_by','JOSM'),(52167039,'created_by','JOSM'),(52167045,'created_by','JOSM'),(52167049,'created_by','JOSM'),(52167052,'created_by','JOSM'),(52167062,'created_by','JOSM'),(52167066,'created_by','JOSM'),(52167070,'created_by','JOSM'),(52167076,'created_by','JOSM'),(52167082,'created_by','JOSM'),(52167086,'created_by','JOSM'),(52167105,'created_by','JOSM'),(52167111,'created_by','JOSM'),(52167122,'created_by','JOSM'),(52167128,'created_by','JOSM'),(52167136,'created_by','JOSM'),(52167142,'created_by','JOSM'),(52167150,'created_by','JOSM'),(52167155,'created_by','JOSM'),(52167165,'created_by','JOSM'),(52167175,'created_by','JOSM'),(52167179,'created_by','JOSM'),(52167183,'created_by','JOSM'),(52167190,'created_by','JOSM'),(52167198,'created_by','JOSM'),(52167208,'created_by','JOSM'),(52167211,'created_by','JOSM'),(52167218,'created_by','JOSM'),(52167223,'created_by','JOSM'),(52167232,'created_by','JOSM'),(52167248,'created_by','JOSM'),(52167254,'created_by','JOSM'),(52167257,'created_by','JOSM'),(52167262,'created_by','JOSM'),(52167277,'created_by','JOSM'),(52167279,'created_by','JOSM'),(52167284,'created_by','JOSM'),(52167289,'created_by','JOSM'),(52167293,'created_by','JOSM'),(52167300,'created_by','JOSM'),(52167307,'created_by','JOSM'),(52167309,'created_by','JOSM'),(52167315,'created_by','JOSM'),(52167320,'created_by','JOSM'),(52167323,'created_by','JOSM'),(52167329,'created_by','JOSM'),(52167336,'created_by','JOSM'),(52167345,'created_by','JOSM'),(52167349,'created_by','JOSM'),(52167353,'created_by','JOSM'),(52167358,'created_by','JOSM'),(52167363,'created_by','JOSM'),(52167368,'created_by','JOSM'),(52167372,'created_by','JOSM'),(52167380,'created_by','JOSM'),(52167387,'created_by','JOSM'),(52167389,'created_by','JOSM'),(52167390,'created_by','JOSM'),(52167393,'created_by','JOSM'),(52167396,'created_by','JOSM'),(52167398,'created_by','JOSM'),(52167402,'created_by','JOSM'),(52167406,'created_by','JOSM'),(52167421,'created_by','JOSM'),(52167425,'created_by','JOSM'),(52167428,'created_by','JOSM'),(52167430,'created_by','JOSM'),(52167433,'created_by','JOSM'),(52167436,'created_by','JOSM'),(52167438,'created_by','JOSM'),(52167439,'created_by','JOSM'),(52167444,'created_by','JOSM'),(52167446,'created_by','JOSM'),(52167453,'created_by','JOSM'),(52167457,'created_by','JOSM'),(52167470,'created_by','JOSM'),(52167473,'created_by','JOSM'),(52167477,'created_by','JOSM'),(52167484,'created_by','JOSM'),(52167487,'created_by','JOSM'),(52167490,'created_by','JOSM'),(52167496,'created_by','JOSM'),(52167500,'created_by','JOSM'),(52167503,'created_by','JOSM'),(52167507,'created_by','JOSM'),(52167511,'created_by','JOSM'),(52167513,'created_by','JOSM'),(52167517,'created_by','JOSM'),(52167521,'created_by','JOSM'),(52167525,'created_by','JOSM'),(52167528,'created_by','JOSM'),(52167530,'created_by','JOSM'),(52167534,'created_by','JOSM'),(52167535,'created_by','JOSM'),(52167538,'created_by','JOSM'),(52167540,'created_by','JOSM'),(52167544,'created_by','JOSM'),(52167547,'created_by','JOSM'),(52167551,'created_by','JOSM'),(52167557,'created_by','JOSM'),(52167562,'created_by','JOSM'),(52167568,'created_by','JOSM'),(52167574,'created_by','JOSM'),(52167579,'created_by','JOSM'),(52167581,'created_by','JOSM'),(52167585,'created_by','JOSM'),(52167590,'created_by','JOSM'),(52167593,'created_by','JOSM'),(52167599,'created_by','JOSM'),(52167604,'created_by','JOSM'),(52167607,'created_by','JOSM'),(52167614,'created_by','JOSM'),(52167615,'created_by','JOSM'),(52167619,'created_by','JOSM'),(52167622,'created_by','JOSM'),(52167627,'created_by','JOSM'),(52167632,'created_by','JOSM'),(52167636,'created_by','JOSM'),(52167641,'created_by','JOSM'),(52167645,'created_by','JOSM'),(52167650,'created_by','JOSM'),(52167655,'created_by','JOSM'),(52167660,'created_by','JOSM'),(52167664,'created_by','JOSM'),(52167666,'created_by','JOSM'),(52167669,'created_by','JOSM'),(52167673,'created_by','JOSM'),(52167677,'created_by','JOSM'),(52167683,'created_by','JOSM'),(52167687,'created_by','JOSM'),(52167691,'created_by','JOSM'),(52167695,'created_by','JOSM'),(52167700,'created_by','JOSM'),(52167702,'created_by','JOSM'),(52167707,'created_by','JOSM'),(52167710,'created_by','JOSM'),(52167713,'created_by','JOSM'),(52167714,'created_by','JOSM'),(52167718,'created_by','JOSM'),(52167721,'created_by','JOSM'),(52167725,'created_by','JOSM'),(52167727,'created_by','JOSM'),(52167732,'created_by','JOSM'),(52167736,'created_by','JOSM'),(52167740,'created_by','JOSM'),(52167744,'created_by','JOSM'),(52167747,'created_by','JOSM'),(52167752,'created_by','JOSM'),(52167756,'created_by','JOSM'),(52167758,'created_by','JOSM'),(52167761,'created_by','JOSM'),(52167765,'created_by','JOSM'),(52167769,'created_by','JOSM'),(52167773,'created_by','JOSM'),(52167777,'created_by','JOSM'),(52167781,'created_by','JOSM'),(52167784,'created_by','JOSM'),(52167787,'created_by','JOSM'),(52167790,'created_by','JOSM'),(52167795,'created_by','JOSM'),(52167796,'created_by','JOSM'),(52167799,'created_by','JOSM'),(52167802,'created_by','JOSM'),(52167805,'created_by','JOSM'),(52167807,'created_by','JOSM'),(52167811,'created_by','JOSM'),(52167812,'created_by','JOSM'),(52167815,'created_by','JOSM'),(52167820,'created_by','JOSM'),(52167825,'created_by','JOSM'),(52167828,'created_by','JOSM'),(52167834,'created_by','JOSM'),(52167836,'created_by','JOSM'),(52167839,'created_by','JOSM'),(52167843,'created_by','JOSM'),(52167847,'created_by','JOSM'),(52167849,'created_by','JOSM'),(52167853,'created_by','JOSM'),(52167859,'created_by','JOSM'),(52167860,'created_by','JOSM'),(52167867,'created_by','JOSM'),(52167872,'created_by','JOSM'),(52167883,'created_by','JOSM'),(52167887,'created_by','JOSM'),(52167891,'created_by','JOSM'),(52167896,'created_by','JOSM'),(52167900,'created_by','JOSM'),(52167906,'created_by','JOSM'),(52167911,'created_by','JOSM'),(52167916,'created_by','JOSM'),(52167922,'created_by','JOSM'),(52167924,'created_by','JOSM'),(52167927,'created_by','JOSM'),(52167930,'created_by','JOSM'),(52167932,'created_by','JOSM'),(52167937,'created_by','JOSM'),(52167944,'created_by','JOSM'),(52167948,'created_by','JOSM'),(52167953,'created_by','JOSM'),(52167958,'created_by','JOSM'),(52167963,'created_by','JOSM'),(52167967,'created_by','JOSM'),(52167969,'created_by','JOSM'),(52167970,'created_by','JOSM'),(52167973,'created_by','JOSM'),(52167977,'created_by','JOSM'),(52167981,'created_by','JOSM'),(52167986,'created_by','JOSM'),(52167991,'created_by','JOSM'),(52167995,'created_by','JOSM'),(52168000,'created_by','JOSM'),(52168004,'created_by','JOSM'),(52168009,'created_by','JOSM'),(52168013,'created_by','JOSM'),(52168015,'created_by','JOSM'),(52168018,'created_by','JOSM'),(52168021,'created_by','JOSM'),(52168025,'created_by','JOSM'),(52168028,'created_by','JOSM'),(52168033,'created_by','JOSM'),(52168034,'created_by','JOSM'),(52168038,'created_by','JOSM'),(52168039,'created_by','JOSM'),(52168043,'created_by','JOSM'),(52168046,'created_by','JOSM'),(52168049,'created_by','JOSM'),(52168053,'created_by','JOSM'),(52168055,'created_by','JOSM'),(52168056,'created_by','JOSM'),(52168060,'created_by','JOSM'),(52168063,'created_by','JOSM'),(52168065,'created_by','JOSM'),(52168070,'created_by','JOSM'),(52168071,'created_by','JOSM'),(52168073,'created_by','JOSM'),(52168077,'created_by','JOSM'),(52168080,'created_by','JOSM'),(52168084,'created_by','JOSM'),(52168086,'created_by','JOSM'),(52168090,'created_by','JOSM'),(52168094,'created_by','JOSM'),(52168096,'created_by','JOSM'),(52168100,'created_by','JOSM'),(52168101,'created_by','JOSM'),(52168104,'created_by','JOSM'),(52168108,'created_by','JOSM'),(52168111,'created_by','JOSM'),(52168115,'created_by','JOSM'),(52168118,'created_by','JOSM'),(52168121,'created_by','JOSM'),(52168124,'created_by','JOSM'),(52168127,'created_by','JOSM'),(52168130,'created_by','JOSM'),(52168135,'created_by','JOSM'),(52168138,'created_by','JOSM'),(52168143,'created_by','JOSM'),(52168146,'created_by','JOSM'),(52168149,'created_by','JOSM'),(52168152,'created_by','JOSM'),(52168156,'created_by','JOSM'),(52168160,'created_by','JOSM'),(52168163,'created_by','JOSM'),(52168167,'created_by','JOSM'),(52168171,'created_by','JOSM'),(52168175,'created_by','JOSM'),(52168178,'created_by','JOSM'),(52168181,'created_by','JOSM'),(52168186,'created_by','JOSM'),(52168188,'created_by','JOSM'),(52168191,'created_by','JOSM'),(52168195,'created_by','JOSM'),(52168198,'created_by','JOSM'),(52168203,'created_by','JOSM'),(52168207,'created_by','JOSM'),(52168214,'created_by','JOSM'),(52168217,'created_by','JOSM'),(52168220,'created_by','JOSM'),(52168225,'created_by','JOSM'),(52168231,'created_by','JOSM'),(52168235,'created_by','JOSM'),(52168237,'created_by','JOSM'),(52168240,'created_by','JOSM'),(52168243,'created_by','JOSM'),(52168247,'created_by','JOSM'),(52168248,'created_by','JOSM'),(52168249,'created_by','JOSM'),(52168251,'created_by','JOSM'),(52168254,'created_by','JOSM'),(52168256,'created_by','JOSM'),(52168258,'created_by','JOSM'),(52168261,'created_by','JOSM'),(52168265,'created_by','JOSM'),(52168270,'created_by','JOSM'),(52168274,'created_by','JOSM'),(52168278,'created_by','JOSM'),(52168283,'created_by','JOSM'),(52168286,'created_by','JOSM'),(52168287,'created_by','JOSM'),(52168291,'created_by','JOSM'),(52168296,'created_by','JOSM'),(52168298,'created_by','JOSM'),(52168302,'created_by','JOSM'),(52168305,'created_by','JOSM'),(52168308,'created_by','JOSM'),(52168309,'created_by','JOSM'),(52168314,'created_by','JOSM'),(52168316,'created_by','JOSM'),(52168318,'created_by','JOSM'),(52168321,'created_by','JOSM'),(52168325,'created_by','JOSM'),(52168326,'created_by','JOSM'),(52168329,'created_by','JOSM'),(52168333,'created_by','JOSM'),(52168336,'created_by','JOSM'),(52168338,'created_by','JOSM'),(52168342,'created_by','JOSM'),(52168346,'created_by','JOSM'),(52168347,'created_by','JOSM'),(52168348,'created_by','JOSM'),(52168350,'created_by','JOSM'),(52168356,'created_by','JOSM'),(52168360,'created_by','JOSM'),(52168362,'created_by','JOSM'),(52168414,'created_by','JOSM'),(52168416,'created_by','JOSM'),(52168419,'created_by','JOSM'),(52168423,'created_by','JOSM'),(52168427,'created_by','JOSM'),(52168429,'created_by','JOSM'),(52168432,'created_by','JOSM'),(52168436,'created_by','JOSM'),(52168440,'created_by','JOSM'),(52168442,'created_by','JOSM'),(52168445,'created_by','JOSM'),(52168447,'created_by','JOSM'),(52168452,'created_by','JOSM'),(52168455,'created_by','JOSM'),(52168459,'created_by','JOSM'),(52168461,'created_by','JOSM'),(52168464,'created_by','JOSM'),(52168468,'created_by','JOSM'),(52168470,'created_by','JOSM'),(52168474,'created_by','JOSM'),(52168476,'created_by','JOSM'),(52168479,'created_by','JOSM'),(52168481,'created_by','JOSM'),(52168484,'created_by','JOSM'),(52168486,'created_by','JOSM'),(52168489,'created_by','JOSM'),(52168492,'created_by','JOSM'),(52168495,'created_by','JOSM'),(52168497,'created_by','JOSM'),(52168502,'created_by','JOSM'),(52168506,'created_by','JOSM'),(52168509,'created_by','JOSM'),(52168512,'created_by','JOSM'),(52168516,'created_by','JOSM'),(52168519,'created_by','JOSM'),(52168521,'created_by','JOSM'),(52168523,'created_by','JOSM'),(52168529,'created_by','JOSM'),(52168531,'created_by','JOSM'),(52168534,'created_by','JOSM'),(52168537,'created_by','JOSM'),(52168541,'created_by','JOSM'),(52168543,'created_by','JOSM'),(52168547,'created_by','JOSM'),(52168549,'created_by','JOSM'),(52168553,'created_by','JOSM'),(52168555,'created_by','JOSM'),(52168558,'created_by','JOSM'),(52168561,'created_by','JOSM'),(52168565,'created_by','JOSM'),(52168568,'created_by','JOSM'),(52168569,'created_by','JOSM'),(52168572,'created_by','JOSM'),(52168576,'created_by','JOSM'),(52168579,'created_by','JOSM'),(52168582,'created_by','JOSM'),(52168586,'created_by','JOSM'),(52168589,'created_by','JOSM'),(52168592,'created_by','JOSM'),(52168595,'created_by','JOSM'),(52168596,'created_by','JOSM'),(52168600,'created_by','JOSM'),(52168604,'created_by','JOSM'),(52168607,'created_by','JOSM'),(52168612,'created_by','JOSM'),(52168613,'created_by','JOSM'),(52168616,'created_by','JOSM'),(52168622,'created_by','JOSM'),(52168626,'created_by','JOSM'),(52168631,'created_by','JOSM'),(52168635,'created_by','JOSM'),(52168638,'created_by','JOSM'),(52168640,'created_by','JOSM'),(52168644,'created_by','JOSM'),(52168648,'created_by','JOSM'),(52168654,'created_by','JOSM'),(52168657,'created_by','JOSM'),(52168660,'created_by','JOSM'),(52168663,'created_by','JOSM'),(52168665,'created_by','JOSM'),(52168668,'created_by','JOSM'),(52168671,'created_by','JOSM'),(52168674,'created_by','JOSM'),(52168676,'created_by','JOSM'),(52168679,'created_by','JOSM'),(52168682,'created_by','JOSM'),(52168686,'created_by','JOSM'),(52168687,'created_by','JOSM'),(52168690,'created_by','JOSM'),(52168693,'created_by','JOSM'),(52168695,'created_by','JOSM'),(52168698,'created_by','JOSM'),(52168700,'created_by','JOSM'),(52168702,'created_by','JOSM'),(52168703,'created_by','JOSM'),(52168705,'created_by','JOSM'),(52168708,'created_by','JOSM'),(52168710,'created_by','JOSM'),(52168712,'created_by','JOSM'),(52168714,'created_by','JOSM'),(52168717,'created_by','JOSM'),(52168720,'created_by','JOSM'),(52168722,'created_by','JOSM'),(52168725,'created_by','JOSM'),(52168727,'created_by','JOSM'),(52168729,'created_by','JOSM'),(52168732,'created_by','JOSM'),(52168734,'created_by','JOSM'),(52168736,'created_by','JOSM'),(52168739,'created_by','JOSM'),(52168741,'created_by','JOSM'),(52168744,'created_by','JOSM'),(52168745,'created_by','JOSM'),(52168747,'created_by','JOSM'),(52168750,'created_by','JOSM'),(52168770,'created_by','JOSM'),(52168772,'created_by','JOSM'),(52168773,'created_by','JOSM'),(52168774,'created_by','JOSM'),(52168777,'created_by','JOSM'),(52168779,'created_by','JOSM'),(52168782,'created_by','JOSM'),(52168786,'created_by','JOSM'),(52168788,'created_by','JOSM'),(52168789,'created_by','JOSM'),(52168790,'created_by','JOSM'),(52168794,'created_by','JOSM'),(52168796,'created_by','JOSM'),(52168799,'created_by','JOSM'),(52168802,'created_by','JOSM'),(52168805,'created_by','JOSM'),(52168808,'created_by','JOSM'),(52168810,'created_by','JOSM'),(52168813,'created_by','JOSM'),(52168816,'created_by','JOSM'),(52168819,'created_by','JOSM'),(52168821,'created_by','JOSM'),(52168824,'created_by','JOSM'),(52168828,'created_by','JOSM'),(52168829,'created_by','JOSM'),(52168830,'created_by','JOSM'),(52168834,'created_by','JOSM'),(52168836,'created_by','JOSM'),(52168838,'created_by','JOSM'),(52168842,'created_by','JOSM'),(52168845,'created_by','JOSM'),(52168846,'created_by','JOSM'),(52168849,'created_by','JOSM'),(52168851,'created_by','JOSM'),(52168854,'created_by','JOSM'),(52168856,'created_by','JOSM'),(52168858,'created_by','JOSM'),(52168859,'created_by','JOSM'),(52168862,'created_by','JOSM'),(52168865,'created_by','JOSM'),(52168866,'created_by','JOSM'),(52168867,'created_by','JOSM'),(52168870,'created_by','JOSM'),(52168873,'created_by','JOSM'),(52168875,'created_by','JOSM'),(52168878,'created_by','JOSM'),(52168881,'created_by','JOSM'),(52168883,'created_by','JOSM'),(52168886,'created_by','JOSM'),(52168889,'created_by','JOSM'),(52168892,'created_by','JOSM'),(52168895,'created_by','JOSM'),(52168899,'created_by','JOSM'),(52168901,'created_by','JOSM'),(52168904,'created_by','JOSM'),(52168905,'created_by','JOSM'),(52168909,'created_by','JOSM'),(52168912,'created_by','JOSM'),(52168914,'created_by','JOSM'),(52168917,'created_by','JOSM'),(52168919,'created_by','JOSM'),(52168920,'created_by','JOSM'),(52168921,'created_by','JOSM'),(52168924,'created_by','JOSM'),(52168926,'created_by','JOSM'),(52168929,'created_by','JOSM'),(52168931,'created_by','JOSM'),(52168933,'created_by','JOSM'),(52168936,'created_by','JOSM'),(52168939,'created_by','JOSM'),(52168943,'created_by','JOSM'),(52168945,'created_by','JOSM'),(52168946,'created_by','JOSM'),(52168948,'created_by','JOSM'),(52168952,'created_by','JOSM'),(52168955,'created_by','JOSM'),(52168959,'created_by','JOSM'),(52168961,'created_by','JOSM'),(52168964,'created_by','JOSM'),(52168965,'created_by','JOSM'),(52168967,'created_by','JOSM'),(52168969,'created_by','JOSM'),(52168972,'created_by','JOSM'),(52168974,'created_by','JOSM'),(52168976,'created_by','JOSM'),(52168981,'created_by','JOSM'),(52168984,'created_by','JOSM'),(52168987,'created_by','JOSM'),(52168989,'created_by','JOSM'),(52168992,'created_by','JOSM'),(52168995,'created_by','JOSM'),(52169000,'created_by','JOSM'),(52169003,'created_by','JOSM'),(52169006,'created_by','JOSM'),(52169008,'created_by','JOSM'),(52169011,'created_by','JOSM'),(52169014,'created_by','JOSM'),(52169016,'created_by','JOSM'),(52169018,'created_by','JOSM'),(52169021,'created_by','JOSM'),(52169022,'created_by','JOSM'),(52169024,'created_by','JOSM'),(52169028,'created_by','JOSM'),(52169032,'created_by','JOSM'),(52169034,'created_by','JOSM'),(52169036,'created_by','JOSM'),(52169041,'created_by','JOSM'),(52169044,'created_by','JOSM'),(52169045,'created_by','JOSM'),(52169048,'created_by','JOSM'),(52169052,'created_by','JOSM'),(52169054,'created_by','JOSM'),(52169055,'created_by','JOSM'),(52169058,'created_by','JOSM'),(52169060,'created_by','JOSM'),(52169061,'created_by','JOSM'),(52169064,'created_by','JOSM'),(52169067,'created_by','JOSM'),(52169070,'created_by','JOSM'),(52169073,'created_by','JOSM'),(52169075,'created_by','JOSM'),(52169076,'created_by','JOSM'),(52169078,'created_by','JOSM'),(52169080,'created_by','JOSM'),(52169083,'created_by','JOSM'),(52169088,'created_by','JOSM'),(52169089,'created_by','JOSM'),(52169092,'created_by','JOSM'),(52169094,'created_by','JOSM'),(52169097,'created_by','JOSM'),(52169100,'created_by','JOSM'),(52169103,'created_by','JOSM'),(52169105,'created_by','JOSM'),(52169109,'created_by','JOSM'),(52169111,'created_by','JOSM'),(52169113,'created_by','JOSM'),(52169115,'created_by','JOSM'),(52169117,'created_by','JOSM'),(52169119,'created_by','JOSM'),(52169121,'created_by','JOSM'),(52169123,'created_by','JOSM'),(52169124,'created_by','JOSM'),(52169125,'created_by','JOSM'),(52169126,'created_by','JOSM'),(52169127,'created_by','JOSM'),(52170031,'created_by','JOSM'),(52170032,'created_by','JOSM'),(52170036,'created_by','JOSM'),(52170040,'created_by','JOSM'),(52170042,'created_by','JOSM'),(52170044,'created_by','JOSM'),(52170048,'created_by','JOSM'),(52170056,'created_by','JOSM'),(52170061,'created_by','JOSM'),(52170065,'created_by','JOSM'),(52170071,'created_by','JOSM'),(52170076,'created_by','JOSM'),(52170080,'created_by','JOSM'),(52170088,'created_by','JOSM'),(52170090,'created_by','JOSM'),(52170096,'created_by','JOSM'),(52170099,'created_by','JOSM'),(52170371,'created_by','JOSM'),(52170374,'created_by','JOSM'),(52170377,'created_by','JOSM'),(52170378,'created_by','JOSM'),(52170381,'created_by','JOSM'),(52170384,'created_by','JOSM'),(52170386,'created_by','JOSM'),(52170388,'created_by','JOSM'),(52170391,'created_by','JOSM'),(52170394,'created_by','JOSM'),(52170397,'created_by','JOSM'),(52170400,'created_by','JOSM'),(52170401,'created_by','JOSM'),(52170406,'created_by','JOSM'),(52170410,'created_by','JOSM'),(52170411,'created_by','JOSM'),(52170415,'created_by','JOSM'),(52170416,'created_by','JOSM'),(52170417,'created_by','JOSM'),(52170418,'created_by','JOSM'),(52170423,'created_by','JOSM'),(52170440,'created_by','JOSM'),(52170441,'created_by','JOSM'),(52170496,'created_by','JOSM'),(52170512,'created_by','JOSM'),(52170525,'created_by','JOSM'),(52170533,'created_by','JOSM'),(52170540,'created_by','JOSM'),(52170544,'created_by','JOSM'),(52170561,'created_by','JOSM'),(52171046,'created_by','JOSM'),(52171050,'created_by','JOSM'),(52171054,'created_by','JOSM'),(52171057,'created_by','JOSM'),(52171060,'created_by','JOSM'),(52171070,'created_by','JOSM'),(52171073,'created_by','JOSM'),(52171075,'created_by','JOSM'),(52171078,'created_by','JOSM'),(52171081,'created_by','JOSM'),(52171084,'created_by','JOSM'),(52171088,'created_by','JOSM'),(52171092,'created_by','JOSM'),(52171100,'created_by','JOSM'),(52171107,'created_by','JOSM'),(52171112,'created_by','JOSM'),(52171114,'created_by','JOSM'),(52171118,'created_by','JOSM'),(52171120,'created_by','JOSM'),(52171121,'created_by','JOSM'),(52171125,'created_by','JOSM'),(52171127,'created_by','JOSM'),(52171129,'created_by','JOSM'),(52171131,'created_by','JOSM'),(52171136,'created_by','JOSM'),(52171140,'created_by','JOSM'),(52171146,'created_by','JOSM'),(52171151,'created_by','JOSM'),(52171156,'created_by','JOSM'),(52171165,'created_by','JOSM'),(52171167,'created_by','JOSM'),(52171173,'created_by','JOSM'),(52171179,'created_by','JOSM'),(52171184,'created_by','JOSM'),(52171188,'created_by','JOSM'),(52171247,'created_by','JOSM'),(52171251,'created_by','JOSM'),(52171256,'created_by','JOSM'),(52171259,'created_by','JOSM'),(52171263,'created_by','JOSM'),(52171280,'created_by','JOSM'),(52171284,'created_by','JOSM'),(52171289,'created_by','JOSM'),(52171295,'created_by','JOSM'),(52171297,'created_by','JOSM'),(52171300,'created_by','JOSM'),(52171305,'created_by','JOSM'),(52171307,'created_by','JOSM'),(52171311,'created_by','JOSM'),(52171317,'created_by','JOSM'),(52171321,'created_by','JOSM'),(52171324,'created_by','JOSM'),(52171330,'created_by','JOSM'),(52171338,'created_by','JOSM'),(52171344,'created_by','JOSM'),(52171351,'created_by','JOSM'),(52171364,'created_by','JOSM'),(52171370,'created_by','JOSM'),(52171373,'created_by','JOSM'),(52171378,'created_by','JOSM'),(52171382,'created_by','JOSM'),(52171385,'created_by','JOSM'),(52171391,'created_by','JOSM'),(52171407,'created_by','JOSM'),(52171413,'created_by','JOSM'),(52171417,'created_by','JOSM'),(52171422,'created_by','JOSM'),(52171426,'created_by','JOSM'),(52171432,'created_by','JOSM'),(52171437,'created_by','JOSM'),(52171443,'created_by','JOSM'),(52171444,'created_by','JOSM'),(52171447,'created_by','JOSM'),(52171449,'created_by','JOSM'),(52171451,'created_by','JOSM'),(52171454,'created_by','JOSM'),(52171458,'created_by','JOSM'),(52171465,'created_by','JOSM'),(52171467,'created_by','JOSM'),(52171474,'created_by','JOSM'),(52171479,'created_by','JOSM'),(52171481,'created_by','JOSM'),(52171485,'created_by','JOSM'),(52171487,'created_by','JOSM'),(52171491,'created_by','JOSM'),(52171494,'created_by','JOSM'),(52171498,'created_by','JOSM'),(52171503,'created_by','JOSM'),(52171506,'created_by','JOSM'),(52171511,'created_by','JOSM'),(52171515,'created_by','JOSM'),(52171521,'created_by','JOSM'),(52171525,'created_by','JOSM'),(52171528,'created_by','JOSM'),(52171531,'created_by','JOSM'),(52171534,'created_by','JOSM'),(52171537,'created_by','JOSM'),(52171542,'created_by','JOSM'),(52171547,'created_by','JOSM'),(52171553,'created_by','JOSM'),(52171557,'created_by','JOSM'),(52171562,'created_by','JOSM'),(52171569,'created_by','JOSM'),(52171574,'created_by','JOSM'),(52171579,'created_by','JOSM'),(52171585,'created_by','JOSM'),(52171590,'created_by','JOSM'),(52171594,'created_by','JOSM'),(52171595,'created_by','JOSM'),(52171601,'created_by','JOSM'),(52171606,'created_by','JOSM'),(52171610,'created_by','JOSM'),(52171616,'created_by','JOSM'),(52171622,'created_by','JOSM'),(52171628,'created_by','JOSM'),(52171633,'created_by','JOSM'),(52171636,'created_by','JOSM'),(52171644,'created_by','JOSM'),(52171649,'created_by','JOSM'),(52171653,'created_by','JOSM'),(52171656,'created_by','JOSM'),(52171659,'created_by','JOSM'),(52171662,'created_by','JOSM'),(52171665,'created_by','JOSM'),(52171764,'created_by','JOSM'),(52171771,'created_by','JOSM'),(52171775,'created_by','JOSM'),(52171777,'created_by','JOSM'),(52171781,'created_by','JOSM'),(52171785,'created_by','JOSM'),(52171787,'created_by','JOSM'),(52171790,'created_by','JOSM'),(52171795,'created_by','JOSM'),(52171797,'created_by','JOSM'),(52171801,'created_by','JOSM'),(52171805,'created_by','JOSM'),(52171808,'created_by','JOSM'),(52171810,'created_by','JOSM'),(52171811,'created_by','JOSM'),(52171814,'created_by','JOSM'),(52171815,'created_by','JOSM'),(52171818,'created_by','JOSM'),(52171820,'created_by','JOSM'),(52171822,'created_by','JOSM'),(52171825,'created_by','JOSM'),(52171858,'created_by','JOSM'),(52171863,'created_by','JOSM'),(52171867,'created_by','JOSM'),(52171885,'created_by','JOSM'),(52171888,'created_by','JOSM'),(52171892,'created_by','JOSM'),(52171895,'created_by','JOSM'),(52171932,'created_by','JOSM'),(52171934,'created_by','JOSM'),(52171940,'created_by','JOSM'),(52171942,'created_by','JOSM'),(52171945,'created_by','JOSM'),(52171948,'created_by','JOSM'),(52171949,'created_by','JOSM'),(52171952,'created_by','JOSM'),(52171963,'created_by','JOSM'),(52171972,'created_by','JOSM'),(52171975,'created_by','JOSM'),(52171977,'created_by','JOSM'),(52171979,'created_by','JOSM'),(52171981,'created_by','JOSM'),(52171985,'created_by','JOSM'),(52171988,'created_by','JOSM'),(52171989,'created_by','JOSM'),(52171991,'created_by','JOSM'),(52171995,'created_by','JOSM'),(52171996,'created_by','JOSM'),(52171997,'created_by','JOSM'),(52172001,'created_by','JOSM'),(52172006,'created_by','JOSM'),(52172008,'created_by','JOSM'),(52172012,'created_by','JOSM'),(52172014,'created_by','JOSM'),(52172016,'created_by','JOSM'),(52172033,'created_by','JOSM'),(52172036,'created_by','JOSM'),(52172049,'created_by','JOSM'),(52172050,'created_by','JOSM'),(52172086,'created_by','JOSM'),(52172090,'created_by','JOSM'),(52172092,'created_by','JOSM'),(52172096,'created_by','JOSM'),(52172099,'created_by','JOSM'),(52172102,'created_by','JOSM'),(52172104,'created_by','JOSM'),(52172105,'created_by','JOSM'),(52172106,'created_by','JOSM'),(52172107,'created_by','JOSM'),(52172109,'created_by','JOSM'),(52172111,'created_by','JOSM'),(52172122,'created_by','JOSM'),(52172124,'created_by','JOSM'),(52172128,'created_by','JOSM'),(52172129,'created_by','JOSM'),(52172131,'created_by','JOSM'),(52172133,'created_by','JOSM'),(52172135,'created_by','JOSM'),(52172139,'created_by','JOSM'),(52172141,'created_by','JOSM'),(52172144,'created_by','JOSM'),(52172147,'created_by','JOSM'),(52172150,'created_by','JOSM'),(52172153,'created_by','JOSM'),(52172156,'created_by','JOSM'),(52172158,'created_by','JOSM'),(52172161,'created_by','JOSM'),(52172164,'created_by','JOSM'),(52172166,'created_by','JOSM'),(52172168,'created_by','JOSM'),(52172170,'created_by','JOSM'),(52172172,'created_by','JOSM'),(52172175,'created_by','JOSM'),(52172178,'created_by','JOSM'),(52172181,'created_by','JOSM'),(52202283,'created_by','JOSM'),(52202293,'created_by','JOSM'),(52202298,'created_by','JOSM'),(52202362,'created_by','JOSM'),(52202389,'created_by','JOSM'),(52202451,'created_by','JOSM'),(52202455,'created_by','JOSM'),(52202460,'created_by','JOSM'),(52202465,'created_by','JOSM'),(52202468,'created_by','JOSM'),(52202473,'created_by','JOSM'),(52202476,'created_by','JOSM'),(52202485,'created_by','JOSM'),(52202488,'created_by','JOSM'),(52202493,'created_by','JOSM'),(52202499,'created_by','JOSM'),(52202507,'created_by','JOSM'),(52202511,'created_by','JOSM'),(52202517,'created_by','JOSM'),(52202521,'created_by','JOSM'),(52202523,'created_by','JOSM'),(52202526,'created_by','JOSM'),(52202528,'created_by','JOSM'),(52202533,'created_by','JOSM'),(52202534,'created_by','JOSM'),(52202539,'created_by','JOSM'),(52202541,'created_by','JOSM'),(52202545,'created_by','JOSM'),(52202549,'created_by','JOSM'),(52202552,'created_by','JOSM'),(52202553,'created_by','JOSM'),(52202560,'created_by','JOSM'),(52202566,'created_by','JOSM'),(52202571,'created_by','JOSM'),(52202579,'created_by','JOSM'),(52203066,'created_by','JOSM'),(52204239,'created_by','JOSM'),(52204243,'created_by','JOSM'),(52204246,'created_by','JOSM'),(52204248,'created_by','JOSM'),(52204251,'created_by','JOSM'),(52204254,'created_by','JOSM'),(52204258,'created_by','JOSM'),(52204261,'created_by','JOSM'),(52204265,'created_by','JOSM'),(52204267,'created_by','JOSM'),(52204269,'created_by','JOSM'),(52204275,'created_by','JOSM'),(52204280,'created_by','JOSM'),(52204284,'created_by','JOSM'),(52204288,'created_by','JOSM'),(52204292,'created_by','JOSM'),(52204294,'created_by','JOSM'),(52204296,'created_by','JOSM'),(52204307,'created_by','JOSM'),(52204324,'created_by','JOSM'),(52204328,'created_by','JOSM'),(52204344,'created_by','JOSM'),(52204350,'created_by','JOSM'),(52204353,'created_by','JOSM'),(52204354,'created_by','JOSM'),(52204363,'created_by','JOSM'),(52204366,'created_by','JOSM'),(52204368,'created_by','JOSM'),(52204371,'created_by','JOSM'),(52204375,'created_by','JOSM'),(52204377,'created_by','JOSM'),(52204380,'created_by','JOSM'),(52204383,'created_by','JOSM'),(52204386,'created_by','JOSM'),(52204388,'created_by','JOSM'),(52204391,'created_by','JOSM'),(52204394,'created_by','JOSM'),(52204397,'created_by','JOSM'),(52204401,'created_by','JOSM'),(52204404,'created_by','JOSM'),(52204407,'created_by','JOSM'),(52204415,'created_by','JOSM'),(52204417,'created_by','JOSM'),(52204420,'created_by','JOSM'),(52204423,'created_by','JOSM'),(52204425,'created_by','JOSM'),(52204428,'created_by','JOSM'),(52204431,'created_by','JOSM'),(52204434,'created_by','JOSM'),(52204436,'created_by','JOSM'),(52204439,'created_by','JOSM'),(52204442,'created_by','JOSM'),(52204445,'created_by','JOSM'),(52204446,'created_by','JOSM'),(52204450,'created_by','JOSM'),(52204453,'created_by','JOSM'),(52204456,'created_by','JOSM'),(52204459,'created_by','JOSM'),(52204462,'created_by','JOSM'),(52204465,'created_by','JOSM'),(52204467,'created_by','JOSM'),(52204470,'created_by','JOSM'),(52204473,'created_by','JOSM'),(52204476,'created_by','JOSM'),(52204478,'created_by','JOSM'),(52204480,'created_by','JOSM'),(52204483,'created_by','JOSM'),(52204485,'created_by','JOSM'),(52204488,'created_by','JOSM'),(52204492,'created_by','JOSM'),(52204495,'created_by','JOSM'),(52204498,'created_by','JOSM'),(52204501,'created_by','JOSM'),(52204504,'created_by','JOSM'),(52204505,'created_by','JOSM'),(52204513,'created_by','JOSM'),(52204516,'created_by','JOSM'),(52204520,'created_by','JOSM'),(52204523,'created_by','JOSM'),(52204525,'created_by','JOSM'),(52204528,'created_by','JOSM'),(52204531,'created_by','JOSM'),(52204534,'created_by','JOSM'),(52204536,'created_by','JOSM'),(52204541,'created_by','JOSM'),(52204544,'created_by','JOSM'),(52204547,'created_by','JOSM'),(52204549,'created_by','JOSM'),(52204553,'created_by','JOSM'),(52204565,'created_by','JOSM'),(52204568,'created_by','JOSM'),(52204624,'created_by','JOSM'),(52204627,'created_by','JOSM'),(52204664,'created_by','JOSM'),(52204665,'created_by','JOSM'),(52204668,'created_by','JOSM'),(52204669,'created_by','JOSM'),(52204670,'created_by','JOSM'),(52204747,'created_by','JOSM'),(52204750,'created_by','JOSM'),(52204798,'created_by','JOSM'),(52204800,'created_by','JOSM'),(52204903,'created_by','JOSM'),(52204912,'created_by','JOSM'),(52204916,'created_by','JOSM'),(52204922,'created_by','JOSM'),(52204983,'created_by','JOSM'),(52205002,'created_by','JOSM'),(52205008,'created_by','JOSM'),(52205014,'created_by','JOSM'),(52205020,'created_by','JOSM'),(52205022,'created_by','JOSM'),(52205029,'created_by','JOSM'),(52205032,'created_by','JOSM'),(52205035,'created_by','JOSM'),(52205038,'created_by','JOSM'),(52205041,'created_by','JOSM'),(52205043,'created_by','JOSM'),(52205046,'created_by','JOSM'),(52205050,'created_by','JOSM'),(52205053,'created_by','JOSM'),(52205055,'created_by','JOSM'),(52205059,'created_by','JOSM'),(52205063,'created_by','JOSM'),(52205065,'created_by','JOSM'),(52205070,'created_by','JOSM'),(52205073,'created_by','JOSM'),(52205075,'created_by','JOSM'),(52205077,'created_by','JOSM'),(52205079,'created_by','JOSM'),(52205080,'created_by','JOSM'),(52205082,'created_by','JOSM'),(52205084,'created_by','JOSM'),(52205086,'created_by','JOSM'),(52205087,'created_by','JOSM'),(52205089,'created_by','JOSM'),(52205090,'created_by','JOSM'),(52205091,'created_by','JOSM'),(52205092,'created_by','JOSM'),(52205093,'created_by','JOSM'),(52205094,'created_by','JOSM'),(52205095,'created_by','JOSM'),(52205096,'created_by','JOSM'),(52205099,'created_by','JOSM'),(52205101,'created_by','JOSM'),(52205105,'created_by','JOSM'),(52205107,'created_by','JOSM'),(52205110,'created_by','JOSM'),(52205113,'created_by','JOSM'),(52205116,'created_by','JOSM'),(52205122,'created_by','JOSM'),(52205123,'created_by','JOSM'),(52205126,'created_by','JOSM'),(52205131,'created_by','JOSM'),(52205132,'created_by','JOSM'),(52205135,'created_by','JOSM'),(52205138,'created_by','JOSM'),(52205141,'created_by','JOSM'),(52205144,'created_by','JOSM'),(52205148,'created_by','JOSM'),(52205150,'created_by','JOSM'),(52205154,'created_by','JOSM'),(52205161,'created_by','JOSM'),(52205166,'created_by','JOSM'),(52205171,'created_by','JOSM'),(52205175,'created_by','JOSM'),(52205176,'created_by','JOSM'),(52205177,'created_by','JOSM'),(52205182,'created_by','JOSM'),(52205186,'created_by','JOSM'),(52205188,'created_by','JOSM'),(52205196,'created_by','JOSM'),(52205200,'created_by','JOSM'),(52205206,'created_by','JOSM'),(52205212,'created_by','JOSM'),(52205218,'created_by','JOSM'),(52205222,'created_by','JOSM'),(52205225,'created_by','JOSM'),(52205230,'created_by','JOSM'),(52205232,'created_by','JOSM'),(52205239,'created_by','JOSM'),(52205242,'created_by','JOSM'),(52205244,'created_by','JOSM'),(52205248,'created_by','JOSM'),(52205252,'created_by','JOSM'),(52205257,'created_by','JOSM'),(52205261,'created_by','JOSM'),(52205266,'created_by','JOSM'),(52205269,'created_by','JOSM'),(52205274,'created_by','JOSM'),(52205280,'created_by','JOSM'),(52205284,'created_by','JOSM'),(52205286,'created_by','JOSM'),(52205290,'created_by','JOSM'),(52205296,'created_by','JOSM'),(52205298,'created_by','JOSM'),(52205301,'created_by','JOSM'),(52205304,'created_by','JOSM'),(52205306,'created_by','JOSM'),(52205309,'created_by','JOSM'),(52205311,'created_by','JOSM'),(52205317,'created_by','JOSM'),(52205404,'created_by','JOSM'),(52205416,'created_by','JOSM'),(52205422,'created_by','JOSM'),(52205427,'created_by','JOSM'),(52205431,'created_by','JOSM'),(52205434,'created_by','JOSM'),(52205438,'created_by','JOSM'),(52205450,'created_by','JOSM'),(52205456,'created_by','JOSM'),(52205461,'created_by','JOSM'),(52205464,'created_by','JOSM'),(52205469,'created_by','JOSM'),(52205473,'created_by','JOSM'),(52205475,'created_by','JOSM'),(52205480,'created_by','JOSM'),(52205485,'created_by','JOSM'),(52205489,'created_by','JOSM'),(52205492,'created_by','JOSM'),(52205496,'created_by','JOSM'),(52205622,'created_by','JOSM'),(52205637,'created_by','JOSM'),(52205641,'created_by','JOSM'),(52205671,'created_by','JOSM'),(52205676,'created_by','JOSM'),(52205678,'created_by','JOSM'),(52205679,'created_by','JOSM'),(52205681,'created_by','JOSM'),(52205685,'created_by','JOSM'),(52205687,'created_by','JOSM'),(52205690,'created_by','JOSM'),(52205693,'created_by','JOSM'),(52205695,'created_by','JOSM'),(52205699,'created_by','JOSM'),(52205703,'created_by','JOSM'),(52205707,'created_by','JOSM'),(52205709,'created_by','JOSM'),(52205712,'created_by','JOSM'),(52205713,'created_by','JOSM'),(52205715,'created_by','JOSM'),(52205774,'created_by','JOSM'),(52205782,'created_by','JOSM'),(52205785,'created_by','JOSM'),(52205813,'created_by','JOSM'),(52205820,'created_by','JOSM'),(52205823,'created_by','JOSM'),(52205828,'created_by','JOSM'),(52205830,'created_by','JOSM'),(52205836,'created_by','JOSM'),(52205839,'created_by','JOSM'),(52205843,'created_by','JOSM'),(52205846,'created_by','JOSM'),(52205849,'created_by','JOSM'),(52205852,'created_by','JOSM'),(52205855,'created_by','JOSM'),(52205859,'created_by','JOSM'),(52205863,'created_by','JOSM'),(52205865,'created_by','JOSM'),(52205869,'created_by','JOSM'),(52205873,'created_by','JOSM'),(52205876,'created_by','JOSM'),(52205880,'created_by','JOSM'),(52205882,'created_by','JOSM'),(52205885,'created_by','JOSM'),(52205888,'created_by','JOSM'),(52205891,'created_by','JOSM'),(52205893,'created_by','JOSM'),(52205896,'created_by','JOSM'),(52205898,'created_by','JOSM'),(52205901,'created_by','JOSM'),(52205904,'created_by','JOSM'),(52205907,'created_by','JOSM'),(52205910,'created_by','JOSM'),(52205913,'created_by','JOSM'),(52205915,'created_by','JOSM'),(52205924,'created_by','JOSM'),(52205929,'created_by','JOSM'),(52205930,'created_by','JOSM'),(52205935,'created_by','JOSM'),(52205937,'created_by','JOSM'),(52205938,'created_by','JOSM'),(52205941,'created_by','JOSM'),(52205945,'created_by','JOSM'),(52205948,'created_by','JOSM'),(52205951,'created_by','JOSM'),(52205955,'created_by','JOSM'),(52205959,'created_by','JOSM'),(52205964,'created_by','JOSM'),(52205967,'created_by','JOSM'),(52205972,'created_by','JOSM'),(52205973,'created_by','JOSM'),(52205977,'created_by','JOSM'),(52205980,'created_by','JOSM'),(52205983,'created_by','JOSM'),(52205985,'created_by','JOSM'),(52205987,'created_by','JOSM'),(52205990,'created_by','JOSM'),(52205992,'created_by','JOSM'),(52205994,'created_by','JOSM'),(52205996,'created_by','JOSM'),(52205998,'created_by','JOSM'),(52206000,'created_by','JOSM'),(52206003,'created_by','JOSM'),(52206005,'created_by','JOSM'),(52206007,'created_by','JOSM'),(52206009,'created_by','JOSM'),(52206010,'created_by','JOSM'),(52206014,'created_by','JOSM'),(52206016,'created_by','JOSM'),(52206018,'created_by','JOSM'),(52206020,'created_by','JOSM'),(52206023,'created_by','JOSM'),(52206025,'created_by','JOSM'),(52206031,'created_by','JOSM'),(52206033,'created_by','JOSM'),(52206036,'created_by','JOSM'),(52206040,'created_by','JOSM'),(52206041,'created_by','JOSM'),(52206044,'created_by','JOSM'),(52206048,'created_by','JOSM'),(52206051,'created_by','JOSM'),(52206054,'created_by','JOSM'),(52206057,'created_by','JOSM'),(52206060,'created_by','JOSM'),(52206063,'created_by','JOSM'),(52206068,'created_by','JOSM'),(52206069,'created_by','JOSM'),(52206072,'created_by','JOSM'),(52206076,'created_by','JOSM'),(52206078,'created_by','JOSM'),(52206165,'created_by','JOSM'),(52206177,'created_by','JOSM'),(52206181,'created_by','JOSM'),(52206185,'created_by','JOSM'),(52206187,'created_by','JOSM'),(52206189,'created_by','JOSM'),(52206193,'created_by','JOSM'),(52206195,'created_by','JOSM'),(52206198,'created_by','JOSM'),(52206202,'created_by','JOSM'),(52206203,'created_by','JOSM'),(52206207,'created_by','JOSM'),(52206209,'created_by','JOSM'),(52206212,'created_by','JOSM'),(52206215,'created_by','JOSM'),(52206218,'created_by','JOSM'),(52206221,'created_by','JOSM'),(52206225,'created_by','JOSM'),(52206228,'created_by','JOSM'),(52206231,'created_by','JOSM'),(52206234,'created_by','JOSM'),(52206238,'created_by','JOSM'),(52206240,'created_by','JOSM'),(52206242,'created_by','JOSM'),(52206244,'created_by','JOSM'),(52206250,'created_by','JOSM'),(52206252,'created_by','JOSM'),(52206254,'created_by','JOSM'),(52206256,'created_by','JOSM'),(52206259,'created_by','JOSM'),(52206262,'created_by','JOSM'),(52206266,'created_by','JOSM'),(52206268,'created_by','JOSM'),(52206271,'created_by','JOSM'),(52206274,'created_by','JOSM'),(52206277,'created_by','JOSM'),(52206280,'created_by','JOSM'),(52206283,'created_by','JOSM'),(52206286,'created_by','JOSM'),(52206290,'created_by','JOSM'),(52206293,'created_by','JOSM'),(52206294,'created_by','JOSM');
INSERT INTO `current_node_tags` VALUES (52206299,'created_by','JOSM'),(52206302,'created_by','JOSM'),(52206304,'created_by','JOSM'),(52206306,'created_by','JOSM'),(52206310,'created_by','JOSM'),(52206312,'created_by','JOSM'),(52206315,'created_by','JOSM'),(52206317,'created_by','JOSM'),(52206320,'created_by','JOSM'),(52206321,'created_by','JOSM'),(52206324,'created_by','JOSM'),(52206327,'created_by','JOSM'),(52206333,'created_by','JOSM'),(52206336,'created_by','JOSM'),(52206337,'created_by','JOSM'),(52206340,'created_by','JOSM'),(52206343,'created_by','JOSM'),(52206344,'created_by','JOSM'),(52206347,'created_by','JOSM'),(52206349,'created_by','JOSM'),(52206352,'created_by','JOSM'),(52206354,'created_by','JOSM'),(52206356,'created_by','JOSM'),(52206358,'created_by','JOSM'),(52206359,'created_by','JOSM'),(52206360,'created_by','JOSM'),(52206364,'created_by','JOSM'),(52206366,'created_by','JOSM'),(52206374,'created_by','JOSM'),(52206379,'created_by','JOSM'),(52206383,'created_by','JOSM'),(52206385,'created_by','JOSM'),(52206389,'created_by','JOSM'),(52206395,'created_by','JOSM'),(52206400,'created_by','JOSM'),(52206404,'created_by','JOSM'),(52206407,'created_by','JOSM'),(52206410,'created_by','JOSM'),(52206414,'created_by','JOSM'),(52206419,'created_by','JOSM'),(52206420,'created_by','JOSM'),(52206422,'created_by','JOSM'),(52206425,'created_by','JOSM'),(52206429,'created_by','JOSM'),(52206433,'created_by','JOSM'),(52206435,'created_by','JOSM'),(52206439,'created_by','JOSM'),(52206442,'created_by','JOSM'),(52206446,'created_by','JOSM'),(52206447,'created_by','JOSM'),(52206449,'created_by','JOSM'),(52206453,'created_by','JOSM'),(52206457,'created_by','JOSM'),(52206461,'created_by','JOSM'),(52206468,'created_by','JOSM'),(52206471,'created_by','JOSM'),(52206472,'created_by','JOSM'),(52206476,'created_by','JOSM'),(52206479,'created_by','JOSM'),(52206483,'created_by','JOSM'),(52206486,'created_by','JOSM'),(52206488,'created_by','JOSM'),(52206491,'created_by','JOSM'),(52206495,'created_by','JOSM'),(52206498,'created_by','JOSM'),(52206502,'created_by','JOSM'),(52206505,'created_by','JOSM'),(52206508,'created_by','JOSM'),(52206512,'created_by','JOSM'),(52206580,'created_by','JOSM'),(52206583,'created_by','JOSM'),(52206585,'created_by','JOSM'),(52206588,'created_by','JOSM'),(52206591,'created_by','JOSM'),(52206601,'created_by','JOSM'),(52206604,'created_by','JOSM'),(52206607,'created_by','JOSM'),(52206609,'created_by','JOSM'),(52206611,'created_by','JOSM'),(52206615,'created_by','JOSM'),(52206617,'created_by','JOSM'),(52206619,'created_by','JOSM'),(52206620,'created_by','JOSM'),(52206622,'created_by','JOSM'),(52206625,'created_by','JOSM'),(52206627,'created_by','JOSM'),(52206628,'created_by','JOSM'),(52206632,'created_by','JOSM'),(52206635,'created_by','JOSM'),(52206639,'created_by','JOSM'),(52206643,'created_by','JOSM'),(52206645,'created_by','JOSM'),(52206647,'created_by','JOSM'),(52206650,'created_by','JOSM'),(52206653,'created_by','JOSM'),(52206655,'created_by','JOSM'),(52206657,'created_by','JOSM'),(52206661,'created_by','JOSM'),(52206663,'created_by','JOSM'),(52206666,'created_by','JOSM'),(52206669,'created_by','JOSM'),(52206671,'created_by','JOSM'),(52206673,'created_by','JOSM'),(52206676,'created_by','JOSM'),(52206679,'created_by','JOSM'),(52206681,'created_by','JOSM'),(52206684,'created_by','JOSM'),(52206686,'created_by','JOSM'),(52206688,'created_by','JOSM'),(52206694,'created_by','JOSM'),(52206698,'created_by','JOSM'),(52206701,'created_by','JOSM'),(52206703,'created_by','JOSM'),(52206706,'created_by','JOSM'),(52206708,'created_by','JOSM'),(52206710,'created_by','JOSM'),(52206714,'created_by','JOSM'),(52212234,'created_by','JOSM'),(52212307,'created_by','JOSM'),(52212628,'created_by','JOSM'),(52212746,'created_by','JOSM'),(52212871,'created_by','JOSM'),(52212893,'created_by','JOSM'),(52212906,'created_by','JOSM'),(52212916,'created_by','JOSM'),(52212920,'created_by','JOSM'),(52252247,'created_by','JOSM'),(52252315,'created_by','JOSM'),(52252320,'created_by','JOSM'),(52252322,'created_by','JOSM'),(52252325,'created_by','JOSM'),(52252326,'created_by','JOSM'),(52252328,'created_by','JOSM'),(52252330,'created_by','JOSM'),(52252331,'created_by','JOSM'),(52252333,'created_by','JOSM'),(52252336,'created_by','JOSM'),(52252404,'created_by','JOSM'),(52252405,'created_by','JOSM'),(52252407,'created_by','JOSM'),(52252411,'created_by','JOSM'),(52252412,'created_by','JOSM'),(52252414,'created_by','JOSM'),(52252416,'created_by','JOSM'),(52252417,'created_by','JOSM'),(52252420,'created_by','JOSM'),(52252422,'created_by','JOSM'),(52252423,'created_by','JOSM'),(52252424,'created_by','JOSM'),(52252426,'created_by','JOSM'),(52252427,'created_by','JOSM'),(52252429,'created_by','JOSM'),(52252430,'created_by','JOSM'),(52252431,'created_by','JOSM'),(52252433,'created_by','JOSM'),(52252434,'created_by','JOSM'),(52252435,'created_by','JOSM'),(52252437,'created_by','JOSM'),(52252452,'created_by','JOSM'),(52252472,'created_by','JOSM'),(52252473,'created_by','JOSM'),(52252474,'created_by','JOSM'),(52252475,'created_by','JOSM'),(52252476,'created_by','JOSM'),(52252477,'created_by','JOSM'),(52252478,'created_by','JOSM'),(52252479,'created_by','JOSM'),(52252480,'created_by','JOSM'),(52261829,'created_by','JOSM'),(52261834,'created_by','JOSM'),(52261835,'created_by','JOSM'),(52261839,'created_by','JOSM'),(52261842,'created_by','JOSM'),(52261846,'created_by','JOSM'),(52261850,'created_by','JOSM'),(52261853,'created_by','JOSM'),(52261857,'created_by','JOSM'),(52261860,'created_by','JOSM'),(52261864,'created_by','JOSM'),(52261866,'created_by','JOSM'),(52261869,'created_by','JOSM'),(52261872,'created_by','JOSM'),(52261874,'created_by','JOSM'),(52261878,'created_by','JOSM'),(52261880,'created_by','JOSM'),(52261883,'created_by','JOSM'),(52261999,'created_by','JOSM'),(52262003,'created_by','JOSM'),(52262006,'created_by','JOSM'),(52262010,'created_by','JOSM'),(52262016,'created_by','JOSM'),(52262020,'created_by','JOSM'),(52262166,'name','Pont de Faucellers'),(52262538,'created_by','JOSM'),(52262541,'created_by','JOSM'),(52262544,'created_by','JOSM'),(52262546,'created_by','JOSM'),(52262550,'created_by','JOSM'),(52262552,'created_by','JOSM'),(52262556,'created_by','JOSM'),(52262560,'created_by','JOSM'),(52262563,'created_by','JOSM'),(52262910,'created_by','JOSM'),(52262913,'created_by','JOSM'),(52262916,'created_by','JOSM'),(52262919,'created_by','JOSM'),(52262921,'created_by','JOSM'),(52262925,'created_by','JOSM'),(52262930,'created_by','JOSM'),(52262934,'created_by','JOSM'),(52262941,'created_by','JOSM'),(52262944,'created_by','JOSM'),(52262946,'created_by','JOSM'),(52262949,'created_by','JOSM'),(52262954,'created_by','JOSM'),(52262957,'created_by','JOSM'),(52262961,'created_by','JOSM'),(52262963,'created_by','JOSM'),(52262970,'created_by','JOSM'),(52262973,'created_by','JOSM'),(52262977,'created_by','JOSM'),(52262979,'created_by','JOSM'),(52262981,'created_by','JOSM'),(52263076,'created_by','JOSM'),(52263079,'created_by','JOSM'),(52263083,'created_by','JOSM'),(52263091,'created_by','JOSM'),(52263095,'created_by','JOSM'),(52263098,'created_by','JOSM'),(52263100,'created_by','JOSM'),(52263106,'created_by','JOSM'),(52263109,'created_by','JOSM'),(52263111,'created_by','JOSM'),(52263113,'created_by','JOSM'),(52263117,'created_by','JOSM'),(52263119,'created_by','JOSM'),(52263162,'created_by','JOSM'),(52263166,'created_by','JOSM'),(52263168,'created_by','JOSM'),(52263171,'created_by','JOSM'),(52263173,'created_by','JOSM'),(52263177,'created_by','JOSM'),(52263180,'created_by','JOSM'),(52263183,'created_by','JOSM'),(52263186,'created_by','JOSM'),(52263190,'created_by','JOSM'),(52263191,'created_by','JOSM'),(52263549,'created_by','JOSM'),(52263553,'created_by','JOSM'),(52263554,'created_by','JOSM'),(52263556,'created_by','JOSM'),(52263559,'created_by','JOSM'),(52263560,'created_by','JOSM'),(52263563,'created_by','JOSM'),(52263566,'created_by','JOSM'),(52263570,'created_by','JOSM'),(52263573,'created_by','JOSM'),(52263575,'created_by','JOSM'),(52263577,'created_by','JOSM'),(52263579,'created_by','JOSM'),(52263581,'created_by','JOSM'),(52263584,'created_by','JOSM'),(52263586,'created_by','JOSM'),(52263588,'created_by','JOSM'),(52263593,'created_by','JOSM'),(52263595,'created_by','JOSM'),(52263598,'created_by','JOSM'),(52263602,'created_by','JOSM'),(52263605,'created_by','JOSM'),(52263608,'created_by','JOSM'),(52263611,'created_by','JOSM'),(52263615,'created_by','JOSM'),(52263617,'created_by','JOSM'),(52263618,'created_by','JOSM'),(52263623,'created_by','JOSM'),(52263625,'created_by','JOSM'),(52263628,'created_by','JOSM'),(52263629,'created_by','JOSM'),(52263632,'created_by','JOSM'),(52263634,'created_by','JOSM'),(52263637,'created_by','JOSM'),(52263639,'created_by','JOSM'),(52263641,'created_by','JOSM'),(52263644,'created_by','JOSM'),(52263646,'created_by','JOSM'),(52263649,'created_by','JOSM'),(52263650,'created_by','JOSM'),(52263652,'created_by','JOSM'),(52263655,'created_by','JOSM'),(52263657,'created_by','JOSM'),(52263660,'created_by','JOSM'),(52263662,'created_by','JOSM'),(52263665,'created_by','JOSM'),(52263667,'created_by','JOSM'),(52263669,'created_by','JOSM'),(52263670,'created_by','JOSM'),(52263672,'created_by','JOSM'),(52263674,'created_by','JOSM'),(52263677,'created_by','JOSM'),(52263678,'created_by','JOSM'),(52263681,'created_by','JOSM'),(52263683,'created_by','JOSM'),(52263686,'created_by','JOSM'),(52263687,'created_by','JOSM'),(52263688,'created_by','JOSM'),(52263691,'created_by','JOSM'),(52263693,'created_by','JOSM'),(52263696,'created_by','JOSM'),(52263698,'created_by','JOSM'),(52263700,'created_by','JOSM'),(52263702,'created_by','JOSM'),(52263704,'created_by','JOSM'),(52263706,'created_by','JOSM'),(52263708,'created_by','JOSM'),(52263711,'created_by','JOSM'),(52263712,'created_by','JOSM'),(52263713,'created_by','JOSM'),(52263716,'created_by','JOSM'),(52263717,'created_by','JOSM'),(52263718,'created_by','JOSM'),(52263721,'created_by','JOSM'),(52263722,'created_by','JOSM'),(52263724,'created_by','JOSM'),(52263726,'created_by','JOSM'),(52263727,'created_by','JOSM'),(52263854,'created_by','JOSM'),(52263857,'created_by','JOSM'),(52263858,'created_by','JOSM'),(52263860,'created_by','JOSM'),(52263863,'created_by','JOSM'),(52263865,'created_by','JOSM'),(52263870,'created_by','JOSM'),(52263873,'created_by','JOSM'),(52263875,'created_by','JOSM'),(52263876,'created_by','JOSM'),(52263877,'created_by','JOSM'),(52286947,'created_by','JOSM'),(52286950,'created_by','JOSM'),(52286951,'created_by','JOSM'),(52286954,'created_by','JOSM'),(52286967,'created_by','JOSM'),(52286970,'created_by','JOSM'),(52286971,'created_by','JOSM'),(52286973,'created_by','JOSM'),(52286974,'created_by','JOSM'),(52287059,'created_by','JOSM'),(52287062,'created_by','JOSM'),(52287063,'created_by','JOSM'),(52296455,'created_by','JOSM'),(52296457,'created_by','JOSM'),(52296459,'created_by','JOSM'),(52296460,'created_by','JOSM'),(52296461,'created_by','JOSM'),(52296462,'created_by','JOSM'),(52296464,'created_by','JOSM'),(52296465,'created_by','JOSM'),(52296467,'created_by','JOSM'),(52296469,'created_by','JOSM'),(52296471,'created_by','JOSM'),(52296472,'created_by','JOSM'),(52296476,'created_by','JOSM'),(52296478,'created_by','JOSM'),(52296481,'created_by','JOSM'),(52296483,'created_by','JOSM'),(52296485,'created_by','JOSM'),(52296486,'created_by','JOSM'),(52296489,'created_by','JOSM'),(52296490,'created_by','JOSM'),(52296492,'created_by','JOSM'),(52296494,'created_by','JOSM'),(52296495,'created_by','JOSM'),(52296497,'created_by','JOSM'),(52296975,'created_by','JOSM'),(52296977,'created_by','JOSM'),(52296978,'created_by','JOSM'),(52296979,'created_by','JOSM'),(52296981,'created_by','JOSM'),(52296982,'created_by','JOSM'),(52296984,'created_by','JOSM'),(52296985,'created_by','JOSM'),(52296987,'created_by','JOSM'),(52296990,'created_by','JOSM'),(52296992,'created_by','JOSM'),(52296994,'created_by','JOSM'),(52296996,'created_by','JOSM'),(52296999,'created_by','JOSM'),(52297002,'created_by','JOSM'),(52297004,'created_by','JOSM'),(52297007,'created_by','JOSM'),(52297010,'created_by','JOSM'),(52297013,'created_by','JOSM'),(52297015,'created_by','JOSM'),(52297018,'created_by','JOSM'),(52297038,'created_by','JOSM'),(52297041,'created_by','JOSM'),(52297063,'created_by','JOSM'),(52297071,'created_by','JOSM'),(52297255,'created_by','JOSM'),(52297266,'created_by','JOSM'),(52297268,'created_by','JOSM'),(52297272,'created_by','JOSM'),(52297276,'created_by','JOSM'),(52297279,'created_by','JOSM'),(52297281,'created_by','JOSM'),(52297285,'created_by','JOSM'),(52297288,'created_by','JOSM'),(52297290,'created_by','JOSM'),(52297294,'created_by','JOSM'),(52297297,'created_by','JOSM'),(52297300,'created_by','JOSM'),(52297305,'created_by','JOSM'),(52297309,'created_by','JOSM'),(52297312,'created_by','JOSM'),(52297314,'created_by','JOSM'),(52297317,'created_by','JOSM'),(52297320,'created_by','JOSM'),(52297324,'created_by','JOSM'),(52297328,'created_by','JOSM'),(52297333,'created_by','JOSM'),(52297339,'created_by','JOSM'),(52297344,'created_by','JOSM'),(52297349,'created_by','JOSM'),(52297354,'created_by','JOSM'),(52297358,'created_by','JOSM'),(52297362,'created_by','JOSM'),(52297366,'created_by','JOSM'),(52297369,'created_by','JOSM'),(52297373,'created_by','JOSM'),(52297375,'created_by','JOSM'),(52297380,'created_by','JOSM'),(52297383,'created_by','JOSM'),(52297386,'created_by','JOSM'),(52297390,'created_by','JOSM'),(52297393,'created_by','JOSM'),(52297402,'created_by','JOSM'),(52297405,'created_by','JOSM'),(52297410,'created_by','JOSM'),(52297412,'created_by','JOSM'),(52297418,'created_by','JOSM'),(52297422,'created_by','JOSM'),(52297424,'created_by','JOSM'),(52297427,'created_by','JOSM'),(52297432,'created_by','JOSM'),(52297435,'created_by','JOSM'),(52297437,'created_by','JOSM'),(52297440,'created_by','JOSM'),(52297442,'created_by','JOSM'),(52297447,'created_by','JOSM'),(52297450,'created_by','JOSM'),(52297455,'created_by','JOSM'),(52297459,'created_by','JOSM'),(52297462,'created_by','JOSM'),(52297465,'created_by','JOSM'),(52297469,'created_by','JOSM'),(52297470,'created_by','JOSM'),(52297474,'created_by','JOSM'),(52297478,'created_by','JOSM'),(52297482,'created_by','JOSM'),(52297484,'created_by','JOSM'),(52297488,'created_by','JOSM'),(52297492,'created_by','JOSM'),(52297494,'created_by','JOSM'),(52297498,'created_by','JOSM'),(52297507,'created_by','JOSM'),(52297509,'created_by','JOSM'),(52297515,'created_by','JOSM'),(52297517,'created_by','JOSM'),(52297520,'created_by','JOSM'),(52297521,'created_by','JOSM'),(52297525,'created_by','JOSM'),(52297528,'created_by','JOSM'),(52297532,'created_by','JOSM'),(52297535,'created_by','JOSM'),(52297537,'created_by','JOSM'),(52297540,'created_by','JOSM'),(52297542,'created_by','JOSM'),(52297545,'created_by','JOSM'),(52297547,'created_by','JOSM'),(52297550,'created_by','JOSM'),(52297554,'created_by','JOSM'),(52297558,'created_by','JOSM'),(52297560,'created_by','JOSM'),(52297563,'created_by','JOSM'),(52297565,'created_by','JOSM'),(52297567,'created_by','JOSM'),(52297571,'created_by','JOSM'),(52297573,'created_by','JOSM'),(52297576,'created_by','JOSM'),(52297580,'created_by','JOSM'),(52297584,'created_by','JOSM'),(52297587,'created_by','JOSM'),(52297590,'created_by','JOSM'),(52297592,'created_by','JOSM'),(52297595,'created_by','JOSM'),(52297599,'created_by','JOSM'),(52297602,'created_by','JOSM'),(52297606,'created_by','JOSM'),(52297609,'created_by','JOSM'),(52297612,'created_by','JOSM'),(52297615,'created_by','JOSM'),(52297617,'created_by','JOSM'),(52297621,'created_by','JOSM'),(52297623,'created_by','JOSM'),(52297626,'created_by','JOSM'),(52297629,'created_by','JOSM'),(52297633,'created_by','JOSM'),(52297638,'created_by','JOSM'),(52297640,'created_by','JOSM'),(52297643,'created_by','JOSM'),(52297646,'created_by','JOSM'),(52322112,'created_by','JOSM'),(52322115,'created_by','JOSM'),(52322119,'created_by','JOSM'),(52322122,'created_by','JOSM'),(52322125,'created_by','JOSM'),(52322137,'created_by','JOSM'),(52322143,'created_by','JOSM'),(52322151,'created_by','JOSM'),(52322153,'created_by','JOSM'),(52322155,'created_by','JOSM'),(52322156,'created_by','JOSM'),(52322157,'created_by','JOSM'),(52322159,'created_by','JOSM'),(52322163,'created_by','JOSM'),(52322165,'created_by','JOSM'),(52322167,'created_by','JOSM'),(52322170,'created_by','JOSM'),(52322171,'created_by','JOSM'),(52322174,'created_by','JOSM'),(52322177,'created_by','JOSM'),(52322180,'created_by','JOSM'),(52322184,'created_by','JOSM'),(52322185,'created_by','JOSM'),(52322190,'created_by','JOSM'),(52322193,'created_by','JOSM'),(52322196,'created_by','JOSM'),(52322198,'created_by','JOSM'),(52322200,'created_by','JOSM'),(52322203,'created_by','JOSM'),(52322207,'created_by','JOSM'),(52322210,'created_by','JOSM'),(52322213,'created_by','JOSM'),(52322216,'created_by','JOSM'),(52322219,'created_by','JOSM'),(52322222,'created_by','JOSM'),(52322223,'created_by','JOSM'),(52322225,'created_by','JOSM'),(52322228,'created_by','JOSM'),(52322231,'created_by','JOSM'),(52322235,'created_by','JOSM'),(52322237,'created_by','JOSM'),(52322240,'created_by','JOSM'),(52322242,'created_by','JOSM'),(52322244,'created_by','JOSM'),(52322245,'created_by','JOSM'),(52322247,'created_by','JOSM'),(52322249,'created_by','JOSM'),(52322252,'created_by','JOSM'),(52322255,'created_by','JOSM'),(52322256,'created_by','JOSM'),(52322259,'created_by','JOSM'),(52322262,'created_by','JOSM'),(52322266,'created_by','JOSM'),(52322268,'created_by','JOSM'),(52322271,'created_by','JOSM'),(52322273,'created_by','JOSM'),(52322277,'created_by','JOSM'),(52322278,'created_by','JOSM'),(52322279,'created_by','JOSM'),(52322282,'created_by','JOSM'),(52322285,'created_by','JOSM'),(52322286,'created_by','JOSM'),(52322289,'created_by','JOSM'),(52322292,'created_by','JOSM'),(52322293,'created_by','JOSM'),(52322295,'created_by','JOSM'),(52322298,'created_by','JOSM'),(52322299,'created_by','JOSM'),(52322302,'created_by','JOSM'),(52322305,'created_by','JOSM'),(52322308,'created_by','JOSM'),(52322309,'created_by','JOSM'),(52322311,'created_by','JOSM'),(52322313,'created_by','JOSM'),(52322315,'created_by','JOSM'),(52322316,'created_by','JOSM'),(52322318,'created_by','JOSM'),(52322320,'created_by','JOSM'),(52322322,'created_by','JOSM'),(52322324,'created_by','JOSM'),(52322327,'created_by','JOSM'),(52322329,'created_by','JOSM'),(52322331,'created_by','JOSM'),(52322333,'created_by','JOSM'),(52322335,'created_by','JOSM'),(52322336,'created_by','JOSM'),(52322337,'created_by','JOSM'),(52322339,'created_by','JOSM'),(52322341,'created_by','JOSM'),(52322342,'created_by','JOSM'),(52322344,'created_by','JOSM'),(52322345,'created_by','JOSM'),(52322347,'created_by','JOSM'),(52322349,'created_by','JOSM'),(52322351,'created_by','JOSM'),(52322353,'created_by','JOSM'),(52322355,'created_by','JOSM'),(52322357,'created_by','JOSM'),(52322358,'created_by','JOSM'),(52322359,'created_by','JOSM'),(52322361,'created_by','JOSM'),(52322363,'created_by','JOSM'),(52322364,'created_by','JOSM'),(52322365,'created_by','JOSM'),(52322366,'created_by','JOSM'),(52322368,'created_by','JOSM'),(52322370,'created_by','JOSM'),(52322372,'created_by','JOSM'),(52322374,'created_by','JOSM'),(52322376,'created_by','JOSM'),(52322378,'created_by','JOSM'),(52322380,'created_by','JOSM'),(52322382,'created_by','JOSM'),(52322384,'created_by','JOSM'),(52322386,'created_by','JOSM'),(52322388,'created_by','JOSM'),(52322390,'created_by','JOSM'),(52322392,'created_by','JOSM'),(52322395,'created_by','JOSM'),(52322398,'created_by','JOSM'),(52322400,'created_by','JOSM'),(52322402,'created_by','JOSM'),(52322405,'created_by','JOSM'),(52322408,'created_by','JOSM'),(52322411,'created_by','JOSM'),(52322413,'created_by','JOSM'),(52322415,'created_by','JOSM'),(52322419,'created_by','JOSM'),(52322422,'created_by','JOSM'),(52322424,'created_by','JOSM'),(52322429,'created_by','JOSM'),(52322432,'created_by','JOSM'),(52322434,'created_by','JOSM'),(52322437,'created_by','JOSM'),(52322440,'created_by','JOSM'),(52322441,'created_by','JOSM'),(52322443,'created_by','JOSM'),(52322446,'created_by','JOSM'),(52322449,'created_by','JOSM'),(52322451,'created_by','JOSM'),(52322453,'created_by','JOSM'),(52322455,'created_by','JOSM'),(52322458,'created_by','JOSM'),(52322461,'created_by','JOSM'),(52322463,'created_by','JOSM'),(52322465,'created_by','JOSM'),(52322467,'created_by','JOSM'),(52322470,'created_by','JOSM'),(52322473,'created_by','JOSM'),(52322475,'created_by','JOSM'),(52322478,'created_by','JOSM'),(52322481,'created_by','JOSM'),(52322484,'created_by','JOSM'),(52322486,'created_by','JOSM'),(52322488,'created_by','JOSM'),(52322492,'created_by','JOSM'),(52322493,'created_by','JOSM'),(52322496,'created_by','JOSM'),(52322497,'created_by','JOSM'),(52322500,'created_by','JOSM'),(52322502,'created_by','JOSM'),(52322504,'created_by','JOSM'),(52322508,'created_by','JOSM'),(52322510,'created_by','JOSM'),(52322512,'created_by','JOSM'),(52322515,'created_by','JOSM'),(52322516,'created_by','JOSM'),(52322518,'created_by','JOSM'),(52322520,'created_by','JOSM'),(52322523,'created_by','JOSM'),(52322526,'created_by','JOSM'),(52322528,'created_by','JOSM'),(52322530,'created_by','JOSM'),(52322533,'created_by','JOSM'),(52322534,'created_by','JOSM'),(52322537,'created_by','JOSM'),(52322540,'created_by','JOSM'),(52322542,'created_by','JOSM'),(52322544,'created_by','JOSM'),(52322545,'created_by','JOSM'),(52322548,'created_by','JOSM'),(52322551,'created_by','JOSM'),(52322552,'created_by','JOSM'),(52322554,'created_by','JOSM'),(52322557,'created_by','JOSM'),(52322558,'created_by','JOSM'),(52322561,'created_by','JOSM'),(52322562,'created_by','JOSM'),(52322564,'created_by','JOSM'),(52322567,'created_by','JOSM'),(52322570,'created_by','JOSM'),(52322571,'created_by','JOSM'),(52322574,'created_by','JOSM'),(52322578,'created_by','JOSM'),(52322579,'created_by','JOSM'),(52322581,'created_by','JOSM'),(52322583,'created_by','JOSM'),(52322585,'created_by','JOSM'),(52322587,'created_by','JOSM'),(52322589,'created_by','JOSM'),(52322591,'created_by','JOSM'),(52322593,'created_by','JOSM'),(52322595,'created_by','JOSM'),(52322598,'created_by','JOSM'),(52322601,'created_by','JOSM'),(52322602,'created_by','JOSM'),(52322604,'created_by','JOSM'),(52322606,'created_by','JOSM'),(52322611,'created_by','JOSM'),(52322613,'created_by','JOSM'),(52322615,'created_by','JOSM'),(52322617,'created_by','JOSM'),(52322618,'created_by','JOSM'),(52322623,'created_by','JOSM'),(52322626,'created_by','JOSM'),(52322627,'created_by','JOSM'),(52322630,'created_by','JOSM'),(52322632,'created_by','JOSM'),(52322634,'created_by','JOSM'),(52322636,'created_by','JOSM'),(52322639,'created_by','JOSM'),(52322641,'created_by','JOSM'),(52322644,'created_by','JOSM'),(52322646,'created_by','JOSM'),(52322648,'created_by','JOSM'),(52322651,'created_by','JOSM'),(52322654,'created_by','JOSM'),(52322656,'created_by','JOSM'),(52322657,'created_by','JOSM'),(52322660,'created_by','JOSM'),(52322663,'created_by','JOSM'),(52322665,'created_by','JOSM'),(52322667,'created_by','JOSM'),(52322670,'created_by','JOSM'),(52322673,'created_by','JOSM'),(52322675,'created_by','JOSM'),(52322677,'created_by','JOSM'),(52322678,'created_by','JOSM'),(52322681,'created_by','JOSM'),(52322684,'created_by','JOSM'),(52322685,'created_by','JOSM'),(52322687,'created_by','JOSM'),(52322690,'created_by','JOSM'),(52322692,'created_by','JOSM'),(52322695,'created_by','JOSM'),(52322697,'created_by','JOSM'),(52322698,'created_by','JOSM'),(52322700,'created_by','JOSM'),(52322701,'created_by','JOSM'),(52322704,'created_by','JOSM'),(52322706,'created_by','JOSM'),(52322709,'created_by','JOSM'),(52322712,'created_by','JOSM'),(52322713,'created_by','JOSM'),(52322716,'created_by','JOSM'),(52322719,'created_by','JOSM'),(52322722,'created_by','JOSM'),(52322725,'created_by','JOSM'),(52322727,'created_by','JOSM'),(52322729,'created_by','JOSM'),(52322731,'created_by','JOSM'),(52322733,'created_by','JOSM'),(52322736,'created_by','JOSM'),(52322738,'created_by','JOSM'),(52322739,'created_by','JOSM'),(52322741,'created_by','JOSM'),(52322753,'created_by','JOSM'),(52322755,'created_by','JOSM'),(52322758,'created_by','JOSM'),(52322761,'created_by','JOSM'),(52322764,'created_by','JOSM'),(52322765,'created_by','JOSM'),(52322768,'created_by','JOSM'),(52322770,'created_by','JOSM'),(52322773,'created_by','JOSM'),(52322774,'created_by','JOSM'),(52322777,'created_by','JOSM'),(52322780,'created_by','JOSM'),(52322782,'created_by','JOSM'),(52322785,'created_by','JOSM'),(52322787,'created_by','JOSM'),(52322789,'created_by','JOSM'),(52322791,'created_by','JOSM'),(52322793,'created_by','JOSM'),(52322795,'created_by','JOSM'),(52322796,'created_by','JOSM'),(52322799,'created_by','JOSM'),(52322800,'created_by','JOSM'),(52322802,'created_by','JOSM'),(52322804,'created_by','JOSM'),(52322806,'created_by','JOSM'),(52322809,'created_by','JOSM'),(52322810,'created_by','JOSM'),(52322815,'created_by','JOSM'),(52322816,'created_by','JOSM'),(52322819,'created_by','JOSM'),(52322823,'created_by','JOSM'),(52322826,'created_by','JOSM'),(52322827,'created_by','JOSM'),(52322830,'created_by','JOSM'),(52322833,'created_by','JOSM'),(52322836,'created_by','JOSM'),(52322837,'created_by','JOSM'),(52322840,'created_by','JOSM'),(52322842,'created_by','JOSM'),(52322844,'created_by','JOSM'),(52322846,'created_by','JOSM'),(52322847,'created_by','JOSM'),(52322850,'created_by','JOSM'),(52322851,'created_by','JOSM'),(52322855,'created_by','JOSM'),(52322858,'created_by','JOSM'),(52322859,'created_by','JOSM'),(52322863,'created_by','JOSM'),(52322865,'created_by','JOSM'),(52322867,'created_by','JOSM'),(52322871,'created_by','JOSM'),(52322874,'created_by','JOSM'),(52322877,'created_by','JOSM'),(52322879,'created_by','JOSM'),(52322880,'created_by','JOSM'),(52322883,'created_by','JOSM'),(52322887,'created_by','JOSM'),(52322889,'created_by','JOSM'),(52322891,'created_by','JOSM'),(52322893,'created_by','JOSM'),(52322896,'created_by','JOSM'),(52322898,'created_by','JOSM'),(52322902,'created_by','JOSM'),(52322903,'created_by','JOSM'),(52322904,'created_by','JOSM'),(52322907,'created_by','JOSM'),(52322910,'created_by','JOSM'),(52322911,'created_by','JOSM'),(52322915,'created_by','JOSM'),(52322917,'created_by','JOSM'),(52322919,'created_by','JOSM'),(52322921,'created_by','JOSM'),(52322924,'created_by','JOSM'),(52322927,'created_by','JOSM'),(52322929,'created_by','JOSM'),(52322931,'created_by','JOSM'),(52322934,'created_by','JOSM'),(52322937,'created_by','JOSM'),(52322940,'created_by','JOSM'),(52322942,'created_by','JOSM'),(52322945,'created_by','JOSM'),(52322947,'created_by','JOSM'),(52322950,'created_by','JOSM'),(52322953,'created_by','JOSM'),(52322955,'created_by','JOSM'),(52322957,'created_by','JOSM'),(52322959,'created_by','JOSM'),(52322962,'created_by','JOSM'),(52322964,'created_by','JOSM'),(52322966,'created_by','JOSM'),(52322969,'created_by','JOSM'),(52322972,'created_by','JOSM'),(52322974,'created_by','JOSM'),(52322976,'created_by','JOSM'),(52322977,'created_by','JOSM'),(52322979,'created_by','JOSM'),(52322982,'created_by','JOSM'),(52327233,'created_by','JOSM'),(52327235,'created_by','JOSM'),(52327238,'created_by','JOSM'),(52327241,'created_by','JOSM'),(52327243,'created_by','JOSM'),(52327246,'created_by','JOSM'),(52327247,'created_by','JOSM'),(52327250,'created_by','JOSM'),(52327252,'created_by','JOSM'),(52327263,'created_by','JOSM'),(52327265,'created_by','JOSM'),(52327268,'created_by','JOSM'),(52327271,'created_by','JOSM'),(52327274,'created_by','JOSM'),(52327277,'created_by','JOSM'),(52327279,'created_by','JOSM'),(52327281,'created_by','JOSM'),(52327282,'created_by','JOSM'),(52327285,'created_by','JOSM'),(52327287,'created_by','JOSM'),(52327288,'created_by','JOSM'),(52327290,'created_by','JOSM'),(52327292,'created_by','JOSM'),(52327295,'created_by','JOSM'),(52327298,'created_by','JOSM'),(52327300,'created_by','JOSM'),(52327302,'created_by','JOSM'),(52327303,'created_by','JOSM'),(52327306,'created_by','JOSM'),(52327309,'created_by','JOSM'),(52327310,'created_by','JOSM'),(52327313,'created_by','JOSM'),(52327316,'created_by','JOSM'),(52327317,'created_by','JOSM'),(52327321,'created_by','JOSM'),(52327325,'created_by','JOSM'),(52327328,'created_by','JOSM'),(52327329,'created_by','JOSM'),(52327331,'created_by','JOSM'),(52327333,'created_by','JOSM'),(52327337,'created_by','JOSM'),(52327339,'created_by','JOSM'),(52327341,'created_by','JOSM'),(52327342,'created_by','JOSM'),(52327345,'created_by','JOSM'),(52327347,'created_by','JOSM'),(52327351,'created_by','JOSM'),(52327354,'created_by','JOSM'),(52327358,'created_by','JOSM'),(52327359,'created_by','JOSM'),(52327361,'created_by','JOSM'),(52327362,'created_by','JOSM'),(52327365,'created_by','JOSM'),(52327368,'created_by','JOSM'),(52327371,'created_by','JOSM'),(52327372,'created_by','JOSM'),(52327375,'created_by','JOSM'),(52327378,'created_by','JOSM'),(52327379,'created_by','JOSM'),(52327381,'created_by','JOSM'),(52327383,'created_by','JOSM'),(52327384,'created_by','JOSM'),(52327387,'created_by','JOSM'),(52327388,'created_by','JOSM'),(52327390,'created_by','JOSM'),(52327392,'created_by','JOSM'),(52327393,'created_by','JOSM'),(52327398,'created_by','JOSM'),(52327401,'created_by','JOSM'),(52327403,'created_by','JOSM'),(52327406,'created_by','JOSM'),(52327408,'created_by','JOSM'),(52327411,'created_by','JOSM'),(52327413,'created_by','JOSM'),(52327417,'created_by','JOSM'),(52327418,'created_by','JOSM'),(52327421,'created_by','JOSM'),(52327423,'created_by','JOSM'),(52327427,'created_by','JOSM'),(52327429,'created_by','JOSM'),(52327432,'created_by','JOSM'),(52327434,'created_by','JOSM'),(52328346,'created_by','JOSM'),(52328347,'created_by','JOSM'),(52328348,'created_by','JOSM'),(52328350,'created_by','JOSM'),(52328353,'created_by','JOSM'),(52328354,'created_by','JOSM'),(52328357,'created_by','JOSM'),(52328358,'created_by','JOSM'),(52328360,'created_by','JOSM'),(52328362,'created_by','JOSM'),(52328364,'created_by','JOSM'),(52328365,'created_by','JOSM'),(52328367,'created_by','JOSM'),(52328370,'created_by','JOSM'),(52328373,'created_by','JOSM'),(52329934,'created_by','JOSM'),(52329937,'created_by','JOSM'),(52329940,'created_by','JOSM'),(52329942,'created_by','JOSM'),(52329943,'created_by','JOSM'),(52329946,'created_by','JOSM'),(52329948,'created_by','JOSM'),(52329951,'created_by','JOSM'),(52329953,'created_by','JOSM'),(52329956,'created_by','JOSM'),(52329957,'created_by','JOSM'),(52329960,'created_by','JOSM'),(52329962,'created_by','JOSM'),(52329964,'created_by','JOSM'),(52329967,'created_by','JOSM'),(52329968,'created_by','JOSM'),(52329970,'created_by','JOSM'),(52329972,'created_by','JOSM'),(52329974,'created_by','JOSM'),(52329978,'created_by','JOSM'),(52329981,'created_by','JOSM'),(52330668,'created_by','JOSM'),(52330669,'created_by','JOSM'),(52330670,'created_by','JOSM'),(52330671,'created_by','JOSM'),(52330672,'created_by','JOSM'),(52330673,'created_by','JOSM'),(52330674,'created_by','JOSM'),(52330675,'created_by','JOSM'),(52330676,'created_by','JOSM'),(52330677,'created_by','JOSM'),(52330678,'created_by','JOSM'),(52578637,'created_by','JOSM'),(52578801,'created_by','JOSM'),(52578802,'created_by','JOSM'),(52578805,'created_by','JOSM'),(52596149,'created_by','JOSM'),(52596154,'created_by','JOSM'),(52596158,'created_by','JOSM'),(52596161,'created_by','JOSM'),(52596163,'created_by','JOSM'),(52596167,'created_by','JOSM'),(52596171,'created_by','JOSM'),(52596178,'created_by','JOSM'),(52596180,'created_by','JOSM'),(52596184,'created_by','JOSM'),(52596186,'created_by','JOSM'),(52596191,'created_by','JOSM'),(52596195,'created_by','JOSM'),(52596197,'created_by','JOSM'),(52596200,'created_by','JOSM'),(52596204,'created_by','JOSM'),(52596208,'created_by','JOSM'),(52596212,'created_by','JOSM'),(52596213,'created_by','JOSM'),(52596216,'created_by','JOSM'),(52596219,'created_by','JOSM'),(52596222,'created_by','JOSM'),(52596226,'created_by','JOSM'),(52596228,'created_by','JOSM'),(52596231,'created_by','JOSM'),(52596234,'created_by','JOSM'),(52596236,'created_by','JOSM'),(52596238,'created_by','JOSM'),(52596241,'created_by','JOSM'),(52596243,'created_by','JOSM'),(52596246,'created_by','JOSM'),(52596249,'created_by','JOSM'),(52596271,'created_by','JOSM'),(52596274,'created_by','JOSM'),(52596277,'created_by','JOSM'),(52596280,'created_by','JOSM'),(52596283,'created_by','JOSM'),(52596285,'created_by','JOSM'),(52596288,'created_by','JOSM'),(52596291,'created_by','JOSM'),(52596295,'created_by','JOSM'),(52596297,'created_by','JOSM'),(52596299,'created_by','JOSM'),(52596300,'created_by','JOSM'),(52596303,'created_by','JOSM'),(52596305,'created_by','JOSM'),(52596308,'created_by','JOSM'),(52596310,'created_by','JOSM'),(52596312,'created_by','JOSM'),(52596314,'created_by','JOSM'),(52596318,'created_by','JOSM'),(52596320,'created_by','JOSM'),(52596326,'created_by','JOSM'),(52596331,'created_by','JOSM'),(52596335,'created_by','JOSM'),(52596339,'created_by','JOSM'),(52596343,'created_by','JOSM'),(52596346,'created_by','JOSM'),(52596351,'created_by','JOSM'),(52603531,'created_by','JOSM'),(52603533,'created_by','JOSM'),(52603536,'created_by','JOSM'),(52603537,'created_by','JOSM'),(52603540,'created_by','JOSM'),(52603542,'created_by','JOSM'),(52612605,'created_by','JOSM'),(52612609,'created_by','JOSM'),(52612612,'created_by','JOSM'),(52612615,'created_by','JOSM'),(52612616,'created_by','JOSM'),(52612619,'created_by','JOSM'),(52612622,'created_by','JOSM'),(52612624,'created_by','JOSM'),(52612626,'created_by','JOSM'),(52612629,'created_by','JOSM'),(52612634,'created_by','JOSM'),(52612635,'created_by','JOSM'),(52612638,'created_by','JOSM'),(52612640,'created_by','JOSM'),(52612642,'created_by','JOSM'),(52612645,'created_by','JOSM'),(52612646,'created_by','JOSM'),(52612649,'created_by','JOSM'),(52612651,'created_by','JOSM'),(52612653,'created_by','JOSM'),(52612656,'created_by','JOSM'),(52612658,'created_by','JOSM'),(52612660,'created_by','JOSM'),(52612661,'created_by','JOSM'),(52612664,'created_by','JOSM'),(52612665,'created_by','JOSM'),(52612667,'created_by','JOSM'),(52612670,'created_by','JOSM'),(52612672,'created_by','JOSM'),(52612675,'created_by','JOSM'),(52612677,'created_by','JOSM'),(52612678,'created_by','JOSM'),(52612681,'created_by','JOSM'),(52612684,'created_by','JOSM'),(52612686,'created_by','JOSM'),(52612688,'created_by','JOSM'),(52612691,'created_by','JOSM'),(52612692,'created_by','JOSM'),(52612694,'created_by','JOSM'),(52612696,'created_by','JOSM'),(52612699,'created_by','JOSM'),(52612701,'created_by','JOSM'),(52612704,'created_by','JOSM'),(52612708,'created_by','JOSM'),(52612710,'created_by','JOSM'),(52612712,'created_by','JOSM'),(52612716,'created_by','JOSM'),(52612717,'created_by','JOSM'),(52612719,'created_by','JOSM'),(52612720,'created_by','JOSM'),(52612722,'created_by','JOSM'),(52612725,'created_by','JOSM'),(52612728,'created_by','JOSM'),(52612732,'created_by','JOSM'),(52612735,'created_by','JOSM'),(52612738,'created_by','JOSM'),(52612740,'created_by','JOSM'),(52612742,'created_by','JOSM'),(52612744,'created_by','JOSM'),(52612746,'created_by','JOSM'),(52612748,'created_by','JOSM'),(52612750,'created_by','JOSM'),(52612752,'created_by','JOSM'),(52612754,'created_by','JOSM'),(52612756,'created_by','JOSM'),(52612758,'created_by','JOSM'),(52612760,'created_by','JOSM'),(52612761,'created_by','JOSM'),(52612763,'created_by','JOSM'),(52612765,'created_by','JOSM'),(52612768,'created_by','JOSM'),(52612770,'created_by','JOSM'),(52612773,'created_by','JOSM'),(52612776,'created_by','JOSM'),(52612779,'created_by','JOSM'),(52612782,'created_by','JOSM'),(52612786,'created_by','JOSM'),(52612789,'created_by','JOSM'),(52612791,'created_by','JOSM'),(52612794,'created_by','JOSM'),(52612796,'created_by','JOSM'),(52612800,'created_by','JOSM'),(52612803,'created_by','JOSM'),(52612804,'created_by','JOSM'),(52612807,'created_by','JOSM'),(52612810,'created_by','JOSM'),(52612813,'created_by','JOSM'),(52612815,'created_by','JOSM'),(52612817,'created_by','JOSM'),(52612820,'created_by','JOSM'),(52612824,'created_by','JOSM'),(52612827,'created_by','JOSM'),(52612831,'created_by','JOSM'),(52612835,'created_by','JOSM'),(52612840,'created_by','JOSM'),(52612843,'created_by','JOSM'),(52612845,'created_by','JOSM'),(52612849,'created_by','JOSM'),(52612853,'created_by','JOSM'),(52612855,'created_by','JOSM'),(52612859,'created_by','JOSM'),(52612862,'created_by','JOSM'),(52612864,'created_by','JOSM'),(52612867,'created_by','JOSM'),(52612870,'created_by','JOSM'),(52612873,'created_by','JOSM'),(52612877,'created_by','JOSM'),(52612882,'created_by','JOSM'),(52612885,'created_by','JOSM'),(52612888,'created_by','JOSM'),(52612892,'created_by','JOSM'),(52612893,'created_by','JOSM'),(52612895,'created_by','JOSM'),(52612897,'created_by','JOSM'),(52612899,'created_by','JOSM'),(52612900,'created_by','JOSM'),(52612902,'created_by','JOSM'),(52612907,'created_by','JOSM'),(52612909,'created_by','JOSM'),(52612911,'created_by','JOSM'),(52612913,'created_by','JOSM'),(52612916,'created_by','JOSM'),(52612918,'created_by','JOSM'),(52612920,'created_by','JOSM'),(52612923,'created_by','JOSM'),(52612927,'created_by','JOSM'),(52612929,'created_by','JOSM'),(52612932,'created_by','JOSM'),(52612935,'created_by','JOSM'),(52612936,'created_by','JOSM'),(52612939,'created_by','JOSM'),(52612941,'created_by','JOSM'),(52612943,'created_by','JOSM'),(52612946,'created_by','JOSM'),(52612948,'created_by','JOSM'),(52612951,'created_by','JOSM'),(52612954,'created_by','JOSM'),(52612957,'created_by','JOSM'),(52612958,'created_by','JOSM'),(52612962,'created_by','JOSM'),(52612967,'created_by','JOSM'),(52612973,'created_by','JOSM'),(52612976,'created_by','JOSM'),(52612978,'created_by','JOSM'),(52612981,'created_by','JOSM'),(52612983,'created_by','JOSM'),(52612986,'created_by','JOSM'),(52612989,'created_by','JOSM'),(52612992,'created_by','JOSM'),(52612994,'created_by','JOSM'),(52612996,'created_by','JOSM'),(52612998,'created_by','JOSM'),(52613000,'created_by','JOSM'),(52613003,'created_by','JOSM'),(52613006,'created_by','JOSM'),(52613008,'created_by','JOSM'),(52613010,'created_by','JOSM'),(52613013,'created_by','JOSM'),(52613016,'created_by','JOSM'),(52613017,'created_by','JOSM'),(52613020,'created_by','JOSM'),(52613021,'created_by','JOSM'),(52613024,'created_by','JOSM'),(52613027,'created_by','JOSM'),(52613030,'created_by','JOSM'),(52613032,'created_by','JOSM'),(52613034,'created_by','JOSM'),(52613037,'created_by','JOSM'),(52613039,'created_by','JOSM'),(52613041,'created_by','JOSM'),(52613044,'created_by','JOSM'),(52613047,'created_by','JOSM'),(52613049,'created_by','JOSM'),(52613052,'created_by','JOSM'),(52613054,'created_by','JOSM'),(52613056,'created_by','JOSM'),(52613058,'created_by','JOSM'),(52613061,'created_by','JOSM'),(52613062,'created_by','JOSM'),(52613065,'created_by','JOSM'),(52613067,'created_by','JOSM'),(52613070,'created_by','JOSM'),(52613072,'created_by','JOSM'),(52613074,'created_by','JOSM'),(52613076,'created_by','JOSM'),(52613080,'created_by','JOSM'),(52613083,'created_by','JOSM'),(52613086,'created_by','JOSM'),(52613088,'created_by','JOSM'),(52613091,'created_by','JOSM'),(52613092,'created_by','JOSM'),(52613094,'created_by','JOSM'),(52613097,'created_by','JOSM'),(52613099,'created_by','JOSM'),(52613101,'created_by','JOSM'),(52613104,'created_by','JOSM'),(52613107,'created_by','JOSM'),(52613110,'created_by','JOSM'),(52613113,'created_by','JOSM'),(52613115,'created_by','JOSM'),(52613117,'created_by','JOSM'),(52613119,'created_by','JOSM'),(52613121,'created_by','JOSM'),(52613124,'created_by','JOSM'),(52613126,'created_by','JOSM'),(52613129,'created_by','JOSM'),(52613132,'created_by','JOSM'),(52613135,'created_by','JOSM'),(52613139,'created_by','JOSM'),(52613142,'created_by','JOSM'),(52613145,'created_by','JOSM'),(52613148,'created_by','JOSM'),(52613149,'created_by','JOSM'),(52613151,'created_by','JOSM'),(52613154,'created_by','JOSM'),(52613157,'created_by','JOSM'),(52613159,'created_by','JOSM'),(52613162,'created_by','JOSM'),(52613163,'created_by','JOSM'),(52613166,'created_by','JOSM'),(52613167,'created_by','JOSM'),(52613170,'created_by','JOSM'),(52613172,'created_by','JOSM'),(52613173,'created_by','JOSM'),(52613175,'created_by','JOSM'),(52613176,'created_by','JOSM'),(52613178,'created_by','JOSM'),(52613179,'created_by','JOSM'),(52613182,'created_by','JOSM'),(52613184,'created_by','JOSM'),(52613186,'created_by','JOSM'),(52613189,'created_by','JOSM'),(52613192,'created_by','JOSM'),(52613196,'created_by','JOSM'),(52613199,'created_by','JOSM'),(52613201,'created_by','JOSM'),(52613204,'created_by','JOSM'),(52613212,'created_by','JOSM'),(52613214,'created_by','JOSM'),(52613217,'created_by','JOSM'),(52613221,'created_by','JOSM'),(52613223,'created_by','JOSM'),(52613224,'created_by','JOSM'),(52613226,'created_by','JOSM'),(52613228,'created_by','JOSM'),(52613231,'created_by','JOSM'),(52613233,'created_by','JOSM'),(52613235,'created_by','JOSM'),(52613237,'created_by','JOSM'),(52613238,'created_by','JOSM'),(52613244,'created_by','JOSM'),(52613246,'created_by','JOSM'),(52613249,'created_by','JOSM'),(52613252,'created_by','JOSM'),(52613256,'created_by','JOSM'),(52613258,'created_by','JOSM'),(52613260,'created_by','JOSM'),(52613262,'created_by','JOSM'),(52613264,'created_by','JOSM'),(52613267,'created_by','JOSM'),(52613270,'created_by','JOSM'),(52613272,'created_by','JOSM'),(52613274,'created_by','JOSM'),(52613277,'created_by','JOSM'),(52613279,'created_by','JOSM'),(52613282,'created_by','JOSM'),(52613285,'created_by','JOSM'),(52613288,'created_by','JOSM'),(52613289,'created_by','JOSM'),(52613292,'created_by','JOSM'),(52613295,'created_by','JOSM'),(52613297,'created_by','JOSM'),(52613300,'created_by','JOSM'),(52613301,'created_by','JOSM'),(52613303,'created_by','JOSM'),(52613304,'created_by','JOSM'),(52613306,'created_by','JOSM'),(52613309,'created_by','JOSM'),(52613310,'created_by','JOSM'),(52613312,'created_by','JOSM'),(52613314,'created_by','JOSM'),(52613317,'created_by','JOSM'),(52613318,'created_by','JOSM'),(52613320,'created_by','JOSM'),(52613323,'created_by','JOSM'),(52613325,'created_by','JOSM'),(52613330,'created_by','JOSM'),(52613332,'created_by','JOSM'),(52623167,'created_by','JOSM'),(52623169,'created_by','JOSM'),(52623170,'created_by','JOSM'),(52623173,'created_by','JOSM'),(52623176,'created_by','JOSM'),(52623178,'created_by','JOSM'),(52623180,'created_by','JOSM'),(52623182,'created_by','JOSM'),(52623185,'created_by','JOSM'),(52623187,'created_by','JOSM'),(52623190,'created_by','JOSM'),(52623193,'created_by','JOSM'),(52623196,'created_by','JOSM'),(52623199,'created_by','JOSM'),(52623201,'created_by','JOSM'),(52623203,'created_by','JOSM'),(52623205,'created_by','JOSM'),(52623207,'created_by','JOSM'),(52623209,'created_by','JOSM'),(52623212,'created_by','JOSM'),(52623215,'created_by','JOSM'),(52623218,'created_by','JOSM'),(52623226,'created_by','JOSM'),(52623229,'created_by','JOSM'),(52623231,'created_by','JOSM'),(52623233,'created_by','JOSM'),(52623236,'created_by','JOSM'),(52623240,'created_by','JOSM'),(52623242,'created_by','JOSM'),(52623245,'created_by','JOSM'),(52623247,'created_by','JOSM'),(52623250,'created_by','JOSM'),(52623252,'created_by','JOSM'),(52623255,'created_by','JOSM'),(52623259,'created_by','JOSM'),(52623261,'created_by','JOSM'),(52623265,'created_by','JOSM'),(52623268,'created_by','JOSM'),(52623273,'created_by','JOSM'),(52623276,'created_by','JOSM'),(52623278,'created_by','JOSM'),(52623282,'created_by','JOSM'),(52623285,'created_by','JOSM'),(52623287,'created_by','JOSM'),(52623290,'created_by','JOSM'),(52623294,'created_by','JOSM'),(52623296,'created_by','JOSM'),(52623299,'created_by','JOSM'),(52623301,'created_by','JOSM'),(52623303,'created_by','JOSM'),(52623305,'created_by','JOSM'),(52623308,'created_by','JOSM'),(52623310,'created_by','JOSM'),(52623315,'created_by','JOSM'),(52623317,'created_by','JOSM'),(52623321,'created_by','JOSM'),(52623324,'created_by','JOSM'),(52623329,'created_by','JOSM'),(52623333,'created_by','JOSM'),(52623334,'created_by','JOSM'),(52623339,'created_by','JOSM'),(52623344,'created_by','JOSM'),(52623348,'created_by','JOSM'),(52623351,'created_by','JOSM'),(52623354,'created_by','JOSM'),(52623358,'created_by','JOSM'),(52623360,'created_by','JOSM'),(52623363,'created_by','JOSM'),(52623364,'created_by','JOSM'),(52623367,'created_by','JOSM'),(52623371,'created_by','JOSM'),(52623373,'created_by','JOSM'),(52623375,'created_by','JOSM'),(52623378,'created_by','JOSM'),(52623383,'created_by','JOSM'),(52623385,'created_by','JOSM'),(52623389,'created_by','JOSM'),(52623392,'created_by','JOSM'),(52623394,'created_by','JOSM'),(52623398,'created_by','JOSM'),(52623402,'created_by','JOSM'),(52623403,'created_by','JOSM'),(52623407,'created_by','JOSM'),(52623413,'created_by','JOSM'),(52623416,'created_by','JOSM'),(52623417,'created_by','JOSM'),(52623420,'created_by','JOSM'),(52623424,'created_by','JOSM'),(52623427,'created_by','JOSM'),(52623431,'created_by','JOSM'),(52623434,'created_by','JOSM'),(52623436,'created_by','JOSM'),(52623438,'created_by','JOSM'),(52623441,'created_by','JOSM'),(52623444,'created_by','JOSM'),(52623446,'created_by','JOSM'),(52623449,'created_by','JOSM'),(52623453,'created_by','JOSM'),(52623457,'created_by','JOSM'),(52623463,'created_by','JOSM'),(52623465,'created_by','JOSM'),(52623471,'created_by','JOSM'),(52623475,'created_by','JOSM'),(52623478,'created_by','JOSM'),(52623482,'created_by','JOSM'),(52623485,'created_by','JOSM'),(52623487,'created_by','JOSM'),(52623489,'created_by','JOSM'),(52623492,'created_by','JOSM'),(52623494,'created_by','JOSM'),(52623497,'created_by','JOSM'),(52623500,'created_by','JOSM'),(52623503,'created_by','JOSM'),(52623506,'created_by','JOSM'),(52623509,'created_by','JOSM'),(52623513,'created_by','JOSM'),(52623516,'created_by','JOSM'),(52623517,'created_by','JOSM'),(52623522,'created_by','JOSM'),(52623526,'created_by','JOSM'),(52623530,'created_by','JOSM'),(52623533,'created_by','JOSM'),(52623535,'created_by','JOSM'),(52623538,'created_by','JOSM'),(52623541,'created_by','JOSM'),(52623543,'created_by','JOSM'),(52623545,'created_by','JOSM'),(52623548,'created_by','JOSM'),(52623550,'created_by','JOSM'),(52623553,'created_by','JOSM'),(52623556,'created_by','JOSM'),(52623559,'created_by','JOSM'),(52623562,'created_by','JOSM'),(52623565,'created_by','JOSM'),(52623567,'created_by','JOSM'),(52623570,'created_by','JOSM'),(52623573,'created_by','JOSM'),(52623576,'created_by','JOSM'),(52623578,'created_by','JOSM'),(52623581,'created_by','JOSM'),(52623584,'created_by','JOSM'),(52623587,'created_by','JOSM'),(52623589,'created_by','JOSM'),(52623590,'created_by','JOSM'),(52623593,'created_by','JOSM'),(52623597,'created_by','JOSM'),(52623599,'created_by','JOSM'),(52623602,'created_by','JOSM'),(52623605,'created_by','JOSM'),(52623610,'created_by','JOSM'),(52623613,'created_by','JOSM'),(52623617,'created_by','JOSM'),(52623618,'created_by','JOSM'),(52623621,'created_by','JOSM'),(52623624,'created_by','JOSM'),(52623627,'created_by','JOSM'),(52623630,'created_by','JOSM'),(52623633,'created_by','JOSM'),(52623636,'created_by','JOSM'),(52623638,'created_by','JOSM'),(52623641,'created_by','JOSM'),(52623644,'created_by','JOSM'),(52623647,'created_by','JOSM'),(52623649,'created_by','JOSM'),(52623653,'created_by','JOSM'),(52623655,'created_by','JOSM'),(52623657,'created_by','JOSM'),(52623660,'created_by','JOSM'),(52623664,'created_by','JOSM'),(52623667,'created_by','JOSM'),(52623670,'created_by','JOSM'),(52623674,'created_by','JOSM'),(52623675,'created_by','JOSM'),(52623679,'created_by','JOSM'),(52623684,'created_by','JOSM'),(52623687,'created_by','JOSM'),(52623690,'created_by','JOSM'),(52623692,'created_by','JOSM'),(52623694,'created_by','JOSM'),(52623698,'created_by','JOSM'),(52623701,'created_by','JOSM'),(52623702,'created_by','JOSM'),(52623705,'created_by','JOSM'),(52623707,'created_by','JOSM'),(52623712,'created_by','JOSM'),(52623713,'created_by','JOSM'),(52623715,'created_by','JOSM'),(52623717,'created_by','JOSM'),(52623719,'created_by','JOSM'),(52623720,'created_by','JOSM'),(52623722,'created_by','JOSM'),(52623725,'created_by','JOSM'),(52623726,'created_by','JOSM'),(52623728,'created_by','JOSM'),(52623730,'created_by','JOSM'),(52623732,'created_by','JOSM'),(52623733,'created_by','JOSM'),(52623736,'created_by','JOSM'),(52623739,'created_by','JOSM'),(52623741,'created_by','JOSM'),(52623743,'created_by','JOSM'),(52623746,'created_by','JOSM'),(52623749,'created_by','JOSM'),(52623750,'created_by','JOSM'),(52623752,'created_by','JOSM'),(52623753,'created_by','JOSM'),(52623755,'created_by','JOSM'),(52623757,'created_by','JOSM'),(52623758,'created_by','JOSM'),(52623759,'created_by','JOSM'),(52623760,'created_by','JOSM'),(52623762,'created_by','JOSM'),(52623763,'created_by','JOSM'),(52623765,'created_by','JOSM'),(52623767,'created_by','JOSM'),(52623768,'created_by','JOSM'),(52623769,'created_by','JOSM'),(52623771,'created_by','JOSM'),(52623772,'created_by','JOSM'),(52623773,'created_by','JOSM'),(52623776,'created_by','JOSM'),(52623777,'created_by','JOSM'),(52623778,'created_by','JOSM'),(52623779,'created_by','JOSM'),(52623780,'created_by','JOSM'),(52623781,'created_by','JOSM'),(52623782,'created_by','JOSM'),(52623783,'created_by','JOSM'),(52623784,'created_by','JOSM'),(52623785,'created_by','JOSM'),(52623786,'created_by','JOSM'),(52623788,'created_by','JOSM'),(52623791,'created_by','JOSM'),(52623792,'created_by','JOSM'),(52623795,'created_by','JOSM'),(52623798,'created_by','JOSM'),(52623800,'created_by','JOSM'),(52623802,'created_by','JOSM'),(52623805,'created_by','JOSM'),(52623806,'created_by','JOSM'),(52623808,'created_by','JOSM'),(52623809,'created_by','JOSM'),(52623811,'created_by','JOSM'),(52623814,'created_by','JOSM'),(52623816,'created_by','JOSM'),(52623819,'created_by','JOSM'),(52623823,'created_by','JOSM'),(52623844,'created_by','JOSM'),(52623846,'created_by','JOSM'),(52623849,'created_by','JOSM'),(52648095,'created_by','JOSM'),(52648138,'created_by','JOSM'),(52648149,'created_by','JOSM'),(52648164,'created_by','JOSM'),(52650158,'source','yahoo'),(52650659,'source','yahoo'),(52652127,'source','yahoo'),(52652273,'source','yahoo'),(52652319,'created_by','JOSM'),(52652351,'created_by','JOSM'),(52652477,'created_by','JOSM'),(52652555,'created_by','JOSM'),(52661498,'created_by','JOSM'),(52672004,'created_by','JOSM'),(52672499,'created_by','JOSM'),(52675912,'created_by','JOSM'),(52676235,'created_by','JOSM'),(52676253,'created_by','JOSM'),(52676260,'created_by','JOSM'),(52676267,'created_by','JOSM'),(52676295,'created_by','JOSM'),(52676338,'created_by','JOSM'),(52676349,'created_by','JOSM'),(52676434,'created_by','JOSM'),(52676891,'created_by','JOSM'),(52676911,'created_by','JOSM'),(52677089,'created_by','JOSM'),(52677154,'created_by','JOSM'),(52677211,'created_by','JOSM'),(52677635,'created_by','JOSM'),(52677662,'created_by','JOSM'),(52677757,'created_by','JOSM'),(52677811,'created_by','JOSM'),(52677844,'created_by','JOSM'),(52677862,'created_by','JOSM'),(52677872,'created_by','JOSM'),(52677878,'created_by','JOSM'),(52677908,'created_by','JOSM'),(52677912,'created_by','JOSM'),(52677918,'created_by','JOSM'),(52677922,'created_by','JOSM'),(52677929,'created_by','JOSM'),(52677934,'created_by','JOSM'),(52677939,'created_by','JOSM'),(52677945,'created_by','JOSM'),(52677993,'created_by','JOSM'),(52678005,'created_by','JOSM'),(52678200,'created_by','JOSM'),(52678225,'created_by','JOSM'),(52678243,'created_by','JOSM'),(52678266,'created_by','JOSM'),(52678278,'created_by','JOSM'),(52678285,'created_by','JOSM'),(52678294,'created_by','JOSM'),(52678450,'created_by','JOSM'),(52678519,'created_by','JOSM'),(52678582,'created_by','JOSM'),(52678634,'created_by','JOSM'),(52678741,'created_by','JOSM'),(52678786,'created_by','JOSM'),(52678860,'created_by','JOSM'),(52679237,'created_by','JOSM'),(52679255,'created_by','JOSM'),(52679261,'created_by','JOSM'),(52679265,'created_by','JOSM'),(52679271,'created_by','JOSM'),(52679365,'created_by','JOSM'),(52679445,'created_by','JOSM'),(52679499,'created_by','JOSM'),(52679531,'created_by','JOSM'),(52679731,'created_by','JOSM'),(52679744,'created_by','JOSM'),(52679804,'created_by','JOSM'),(52679809,'created_by','JOSM'),(52679815,'created_by','JOSM'),(52679821,'created_by','JOSM'),(52679879,'created_by','JOSM'),(52679882,'created_by','JOSM'),(52679888,'created_by','JOSM'),(52679894,'created_by','JOSM'),(52679900,'created_by','JOSM'),(52679906,'created_by','JOSM'),(52679911,'created_by','JOSM'),(52679979,'created_by','JOSM'),(52679994,'created_by','JOSM'),(52680005,'created_by','JOSM'),(52680012,'created_by','JOSM'),(52680017,'created_by','JOSM'),(52680024,'created_by','JOSM'),(52680029,'created_by','JOSM'),(52680039,'created_by','JOSM'),(52680048,'created_by','JOSM'),(52680059,'created_by','JOSM'),(52680077,'created_by','JOSM'),(52680086,'created_by','JOSM'),(52680095,'created_by','JOSM'),(52680105,'created_by','JOSM'),(52680117,'created_by','JOSM'),(52680128,'created_by','JOSM'),(52680141,'created_by','JOSM'),(52680157,'created_by','JOSM'),(52680171,'created_by','JOSM'),(52680195,'created_by','JOSM'),(52680202,'created_by','JOSM'),(52680255,'created_by','JOSM'),(52680269,'created_by','JOSM'),(52680280,'created_by','JOSM'),(52680289,'created_by','JOSM'),(52680402,'created_by','JOSM'),(52680426,'created_by','JOSM'),(52680437,'created_by','JOSM'),(52680448,'created_by','JOSM'),(52680465,'created_by','JOSM'),(52680561,'created_by','JOSM'),(52680566,'created_by','JOSM'),(52680570,'created_by','JOSM'),(52680574,'created_by','JOSM'),(52680577,'created_by','JOSM'),(52680579,'created_by','JOSM'),(52680583,'created_by','JOSM'),(52680592,'created_by','JOSM'),(52680597,'created_by','JOSM'),(52680599,'created_by','JOSM'),(52680606,'created_by','JOSM'),(52680610,'created_by','JOSM'),(52680616,'created_by','JOSM'),(52680618,'created_by','JOSM'),(52680624,'created_by','JOSM'),(52680637,'created_by','JOSM'),(52680643,'created_by','JOSM'),(52680648,'created_by','JOSM'),(52680653,'created_by','JOSM'),(52680657,'created_by','JOSM'),(52680660,'created_by','JOSM'),(52680663,'created_by','JOSM'),(52680674,'created_by','JOSM'),(52680676,'created_by','JOSM'),(52680679,'created_by','JOSM'),(52680683,'created_by','JOSM'),(52680692,'created_by','JOSM'),(52680695,'created_by','JOSM'),(52680698,'created_by','JOSM'),(52680703,'created_by','JOSM'),(52680706,'created_by','JOSM'),(52680712,'created_by','JOSM'),(52680715,'created_by','JOSM'),(52680717,'created_by','JOSM'),(52680719,'created_by','JOSM'),(52680722,'created_by','JOSM'),(52680727,'created_by','JOSM'),(52680731,'created_by','JOSM'),(52680735,'created_by','JOSM'),(52680736,'created_by','JOSM'),(52680739,'created_by','JOSM'),(52680744,'created_by','JOSM'),(52680747,'created_by','JOSM'),(52680751,'created_by','JOSM'),(52680753,'created_by','JOSM'),(52680755,'created_by','JOSM'),(52680757,'created_by','JOSM'),(52680759,'created_by','JOSM'),(52680760,'created_by','JOSM'),(52680763,'created_by','JOSM'),(52680767,'created_by','JOSM'),(52680769,'created_by','JOSM'),(52680773,'created_by','JOSM'),(52680776,'created_by','JOSM'),(52680780,'created_by','JOSM'),(52680782,'created_by','JOSM'),(52680784,'created_by','JOSM'),(52680787,'created_by','JOSM'),(52680789,'created_by','JOSM'),(52680794,'created_by','JOSM'),(52680797,'created_by','JOSM'),(52680799,'created_by','JOSM'),(52680803,'created_by','JOSM'),(52680806,'created_by','JOSM'),(52680810,'created_by','JOSM'),(52680813,'created_by','JOSM'),(52680815,'created_by','JOSM'),(52680818,'created_by','JOSM'),(52680820,'created_by','JOSM'),(52680823,'created_by','JOSM'),(52680825,'created_by','JOSM'),(52680828,'created_by','JOSM'),(52680830,'created_by','JOSM'),(52680832,'created_by','JOSM'),(52680836,'created_by','JOSM'),(52680838,'created_by','JOSM'),(52680839,'created_by','JOSM'),(52680842,'created_by','JOSM'),(52680844,'created_by','JOSM'),(52680847,'created_by','JOSM'),(52680850,'created_by','JOSM'),(52680852,'created_by','JOSM'),(52680855,'created_by','JOSM'),(52680858,'created_by','JOSM'),(52680860,'created_by','JOSM'),(52680866,'created_by','JOSM'),(52680869,'created_by','JOSM'),(52680871,'created_by','JOSM'),(52680874,'created_by','JOSM'),(52680877,'created_by','JOSM'),(52680879,'created_by','JOSM'),(52680883,'created_by','JOSM'),(52680913,'created_by','JOSM'),(52680960,'created_by','JOSM'),(52681009,'created_by','JOSM'),(52681026,'created_by','JOSM'),(52681028,'created_by','JOSM'),(52681343,'created_by','JOSM'),(52681347,'created_by','JOSM'),(52681350,'created_by','JOSM'),(52681355,'created_by','JOSM'),(52681357,'created_by','JOSM'),(52681361,'created_by','JOSM'),(52681362,'created_by','JOSM'),(52681366,'created_by','JOSM'),(52681368,'created_by','JOSM'),(52681372,'created_by','JOSM'),(52681374,'created_by','JOSM'),(52681375,'created_by','JOSM'),(52681378,'created_by','JOSM'),(52681380,'created_by','JOSM'),(52681382,'created_by','JOSM'),(52681384,'created_by','JOSM'),(52681386,'created_by','JOSM'),(52681390,'created_by','JOSM'),(52681392,'created_by','JOSM'),(52681393,'created_by','JOSM'),(52681394,'created_by','JOSM'),(52681395,'created_by','JOSM'),(52681398,'created_by','JOSM'),(52681400,'created_by','JOSM'),(52681405,'created_by','JOSM'),(52681407,'created_by','JOSM'),(52681409,'created_by','JOSM'),(52681412,'created_by','JOSM'),(52681414,'created_by','JOSM'),(52681416,'created_by','JOSM'),(52681417,'created_by','JOSM'),(52681420,'created_by','JOSM'),(52681422,'created_by','JOSM'),(52681423,'created_by','JOSM'),(52681425,'created_by','JOSM'),(52681427,'created_by','JOSM'),(52681429,'created_by','JOSM'),(52681431,'created_by','JOSM'),(52681432,'created_by','JOSM'),(52681434,'created_by','JOSM'),(52681439,'created_by','JOSM'),(52681462,'created_by','JOSM'),(52681464,'created_by','JOSM'),(52681465,'created_by','JOSM'),(52681466,'created_by','JOSM'),(52681468,'created_by','JOSM'),(52681471,'created_by','JOSM'),(52681474,'created_by','JOSM'),(52681476,'created_by','JOSM'),(52681478,'created_by','JOSM'),(52681481,'created_by','JOSM'),(52681484,'created_by','JOSM'),(52681487,'created_by','JOSM'),(52681492,'created_by','JOSM'),(52681493,'created_by','JOSM'),(52681496,'created_by','JOSM'),(52681499,'created_by','JOSM'),(52681500,'created_by','JOSM'),(52681503,'created_by','JOSM'),(52681508,'created_by','JOSM'),(52681510,'created_by','JOSM'),(52681511,'created_by','JOSM'),(52681514,'created_by','JOSM'),(52681516,'created_by','JOSM'),(52681518,'created_by','JOSM'),(52681521,'created_by','JOSM'),(52681526,'created_by','JOSM'),(52681528,'created_by','JOSM'),(52681531,'created_by','JOSM'),(52681533,'created_by','JOSM'),(52681535,'created_by','JOSM'),(52681537,'created_by','JOSM'),(52681539,'created_by','JOSM'),(52681541,'created_by','JOSM'),(52681544,'created_by','JOSM'),(52681547,'created_by','JOSM'),(52681551,'created_by','JOSM'),(52681553,'created_by','JOSM'),(52681557,'created_by','JOSM'),(52681568,'created_by','JOSM'),(52681571,'created_by','JOSM'),(52681576,'created_by','JOSM'),(52681578,'created_by','JOSM'),(52681582,'created_by','JOSM'),(52681586,'created_by','JOSM'),(52681589,'created_by','JOSM'),(52681593,'created_by','JOSM'),(52681596,'created_by','JOSM'),(52681598,'created_by','JOSM'),(52681600,'created_by','JOSM'),(52681603,'created_by','JOSM'),(52681605,'created_by','JOSM'),(52681608,'created_by','JOSM'),(52681610,'created_by','JOSM'),(52681613,'created_by','JOSM'),(52681615,'created_by','JOSM'),(52681619,'created_by','JOSM'),(52681648,'created_by','JOSM'),(52681683,'created_by','JOSM'),(52681949,'created_by','JOSM'),(52682039,'created_by','JOSM'),(52682044,'created_by','JOSM'),(52682047,'created_by','JOSM'),(52682050,'created_by','JOSM'),(52682055,'created_by','JOSM'),(52682060,'created_by','JOSM'),(52682065,'created_by','JOSM'),(52682068,'created_by','JOSM'),(52682070,'created_by','JOSM'),(52682072,'created_by','JOSM'),(52682091,'created_by','JOSM'),(52682096,'created_by','JOSM'),(52682101,'created_by','JOSM'),(52682123,'created_by','JOSM'),(52682126,'created_by','JOSM'),(52682128,'created_by','JOSM'),(52682132,'created_by','JOSM'),(52682135,'created_by','JOSM'),(52682140,'created_by','JOSM'),(52682143,'created_by','JOSM'),(52682146,'created_by','JOSM'),(52682150,'created_by','JOSM'),(52682152,'created_by','JOSM'),(52682156,'created_by','JOSM'),(52682160,'created_by','JOSM'),(52682164,'created_by','JOSM'),(52682168,'created_by','JOSM'),(52682170,'created_by','JOSM'),(52682174,'created_by','JOSM'),(52682178,'created_by','JOSM'),(52682180,'created_by','JOSM'),(52682184,'created_by','JOSM'),(52682186,'created_by','JOSM'),(52682190,'created_by','JOSM'),(52682195,'created_by','JOSM'),(52682197,'created_by','JOSM'),(52682200,'created_by','JOSM'),(52682202,'created_by','JOSM'),(52682204,'created_by','JOSM'),(52682207,'created_by','JOSM'),(52682210,'created_by','JOSM'),(52682212,'created_by','JOSM'),(52682215,'created_by','JOSM'),(52682216,'created_by','JOSM'),(52682221,'created_by','JOSM'),(52682224,'created_by','JOSM'),(52682227,'created_by','JOSM'),(52682231,'created_by','JOSM'),(52682235,'created_by','JOSM'),(52682238,'created_by','JOSM'),(52682240,'created_by','JOSM'),(52682243,'created_by','JOSM'),(52682244,'created_by','JOSM'),(52682247,'created_by','JOSM'),(52682250,'created_by','JOSM'),(52682253,'created_by','JOSM'),(52682255,'created_by','JOSM'),(52682257,'created_by','JOSM'),(52682259,'created_by','JOSM'),(52682262,'created_by','JOSM'),(52682265,'created_by','JOSM'),(52682270,'created_by','JOSM'),(52682272,'created_by','JOSM'),(52682274,'created_by','JOSM'),(52682277,'created_by','JOSM'),(52682524,'created_by','JOSM'),(52682546,'created_by','JOSM'),(52682558,'created_by','JOSM'),(52682617,'created_by','JOSM'),(52682663,'created_by','JOSM'),(52682673,'created_by','JOSM'),(52685135,'created_by','JOSM'),(52685138,'created_by','JOSM'),(52685142,'created_by','JOSM'),(52685145,'created_by','JOSM'),(52685147,'created_by','JOSM'),(52685151,'created_by','JOSM'),(52685154,'created_by','JOSM'),(52685157,'created_by','JOSM'),(52685160,'created_by','JOSM'),(52685162,'created_by','JOSM'),(52685166,'created_by','JOSM'),(52685169,'created_by','JOSM'),(52685171,'created_by','JOSM'),(52685184,'created_by','JOSM'),(52685190,'created_by','JOSM'),(52685195,'created_by','JOSM'),(52685199,'created_by','JOSM'),(52685202,'created_by','JOSM'),(52685204,'created_by','JOSM'),(52685207,'created_by','JOSM'),(52685211,'created_by','JOSM'),(52685217,'created_by','JOSM'),(52685220,'created_by','JOSM'),(52685226,'created_by','JOSM'),(52685229,'created_by','JOSM'),(52685232,'created_by','JOSM'),(52685236,'created_by','JOSM'),(52685238,'created_by','JOSM'),(52685243,'created_by','JOSM'),(52685247,'created_by','JOSM'),(52685258,'created_by','JOSM'),(52685262,'created_by','JOSM'),(52685269,'created_by','JOSM'),(52685275,'created_by','JOSM'),(52685277,'created_by','JOSM'),(52685282,'created_by','JOSM'),(52685296,'created_by','JOSM'),(52685299,'created_by','JOSM'),(52685307,'created_by','JOSM'),(52685313,'created_by','JOSM'),(52685696,'created_by','JOSM'),(52685701,'created_by','JOSM'),(52685707,'created_by','JOSM'),(52685710,'created_by','JOSM'),(52685714,'created_by','JOSM'),(52685717,'created_by','JOSM'),(52685723,'created_by','JOSM'),(52685727,'created_by','JOSM'),(52685732,'created_by','JOSM'),(52685739,'created_by','JOSM'),(52685761,'created_by','JOSM'),(52685764,'created_by','JOSM'),(52685771,'created_by','JOSM'),(52685779,'created_by','JOSM'),(52685789,'created_by','JOSM'),(52685802,'created_by','JOSM');
INSERT INTO `current_node_tags` VALUES (52685814,'created_by','JOSM'),(52685832,'created_by','JOSM'),(52685840,'created_by','JOSM'),(52685847,'created_by','JOSM'),(52685851,'created_by','JOSM'),(52685859,'created_by','JOSM'),(52685862,'created_by','JOSM'),(52685869,'created_by','JOSM'),(52685873,'created_by','JOSM'),(52685877,'created_by','JOSM'),(52685881,'created_by','JOSM'),(52685886,'created_by','JOSM'),(52685894,'created_by','JOSM'),(52685905,'created_by','JOSM'),(52685911,'created_by','JOSM'),(52685917,'created_by','JOSM'),(52685920,'created_by','JOSM'),(52685923,'created_by','JOSM'),(52685926,'created_by','JOSM'),(52685929,'created_by','JOSM'),(52685931,'created_by','JOSM'),(52685934,'created_by','JOSM'),(52685939,'created_by','JOSM'),(52685943,'created_by','JOSM'),(52685946,'created_by','JOSM'),(52685950,'created_by','JOSM'),(52685966,'created_by','JOSM'),(52685971,'created_by','JOSM'),(52685975,'created_by','JOSM'),(52685978,'created_by','JOSM'),(52685980,'created_by','JOSM'),(52685982,'created_by','JOSM'),(52685986,'created_by','JOSM'),(52685990,'created_by','JOSM'),(52685993,'created_by','JOSM'),(52685996,'created_by','JOSM'),(52686002,'created_by','JOSM'),(52686474,'created_by','JOSM'),(52686478,'created_by','JOSM'),(52686480,'created_by','JOSM'),(52686486,'created_by','JOSM'),(52686490,'created_by','JOSM'),(52686495,'created_by','JOSM'),(52686501,'created_by','JOSM'),(52686505,'created_by','JOSM'),(52686510,'created_by','JOSM'),(52686511,'created_by','JOSM'),(52686514,'created_by','JOSM'),(52686517,'created_by','JOSM'),(52686518,'created_by','JOSM'),(52686521,'created_by','JOSM'),(52686524,'created_by','JOSM'),(52686527,'created_by','JOSM'),(52686533,'created_by','JOSM'),(52686537,'created_by','JOSM'),(52686542,'created_by','JOSM'),(52686544,'created_by','JOSM'),(52686547,'created_by','JOSM'),(52686551,'created_by','JOSM'),(52686555,'created_by','JOSM'),(52686561,'created_by','JOSM'),(52686569,'created_by','JOSM'),(52686574,'created_by','JOSM'),(52686579,'created_by','JOSM'),(52686586,'created_by','JOSM'),(52686593,'created_by','JOSM'),(52686598,'created_by','JOSM'),(52686601,'created_by','JOSM'),(52686604,'created_by','JOSM'),(52686607,'created_by','JOSM'),(52686610,'created_by','JOSM'),(52686622,'created_by','JOSM'),(52686626,'created_by','JOSM'),(52686632,'created_by','JOSM'),(52686637,'created_by','JOSM'),(52686639,'created_by','JOSM'),(52686644,'created_by','JOSM'),(52686648,'created_by','JOSM'),(52686651,'created_by','JOSM'),(52686654,'created_by','JOSM'),(52686655,'created_by','JOSM'),(52686659,'created_by','JOSM'),(52686660,'created_by','JOSM'),(52686663,'created_by','JOSM'),(52686666,'created_by','JOSM'),(52686668,'created_by','JOSM'),(52686674,'created_by','JOSM'),(52686680,'created_by','JOSM'),(52686682,'created_by','JOSM'),(52686683,'created_by','JOSM'),(52686687,'created_by','JOSM'),(52688384,'created_by','JOSM'),(52688387,'created_by','JOSM'),(52688389,'created_by','JOSM'),(52688391,'created_by','JOSM'),(52688393,'created_by','JOSM'),(52688398,'created_by','JOSM'),(52688401,'created_by','JOSM'),(52688431,'created_by','JOSM'),(52688438,'created_by','JOSM'),(52688454,'created_by','JOSM'),(52688455,'created_by','JOSM'),(52688458,'created_by','JOSM'),(52688531,'created_by','JOSM'),(52688570,'created_by','JOSM'),(52688574,'created_by','JOSM'),(52688576,'created_by','JOSM'),(52688577,'created_by','JOSM'),(52688580,'created_by','JOSM'),(52688582,'created_by','JOSM'),(52688584,'created_by','JOSM'),(52688608,'created_by','JOSM'),(52688609,'created_by','JOSM'),(52688628,'created_by','JOSM'),(52688632,'created_by','JOSM'),(52688633,'created_by','JOSM'),(52688637,'created_by','JOSM'),(52688639,'created_by','JOSM'),(52688642,'created_by','JOSM'),(52688644,'created_by','JOSM'),(52688646,'created_by','JOSM'),(52688648,'created_by','JOSM'),(52688652,'created_by','JOSM'),(52688654,'created_by','JOSM'),(52688655,'created_by','JOSM'),(52688662,'created_by','JOSM'),(52688663,'created_by','JOSM'),(52688667,'created_by','JOSM'),(52688669,'created_by','JOSM'),(52688876,'created_by','JOSM'),(52688936,'created_by','JOSM'),(52688938,'created_by','JOSM'),(52688942,'created_by','JOSM'),(52688945,'created_by','JOSM'),(52688948,'created_by','JOSM'),(52688951,'created_by','JOSM'),(52688953,'created_by','JOSM'),(52688956,'created_by','JOSM'),(52688958,'created_by','JOSM'),(52688962,'created_by','JOSM'),(52688963,'created_by','JOSM'),(52688967,'created_by','JOSM'),(52688969,'created_by','JOSM'),(52688973,'created_by','JOSM'),(52688975,'created_by','JOSM'),(52688978,'created_by','JOSM'),(52688981,'created_by','JOSM'),(52689010,'created_by','JOSM'),(52689011,'created_by','JOSM'),(52689013,'created_by','JOSM'),(52689016,'created_by','JOSM'),(52689017,'created_by','JOSM'),(52689019,'created_by','JOSM'),(52689020,'created_by','JOSM'),(52689024,'created_by','JOSM'),(52689026,'created_by','JOSM'),(52689028,'created_by','JOSM'),(52689032,'created_by','JOSM'),(52689035,'created_by','JOSM'),(52689036,'created_by','JOSM'),(52689039,'created_by','JOSM'),(52689041,'created_by','JOSM'),(52689048,'created_by','JOSM'),(52689081,'created_by','JOSM'),(52689083,'created_by','JOSM'),(52689086,'created_by','JOSM'),(52689090,'created_by','JOSM'),(52689092,'created_by','JOSM'),(52689094,'created_by','JOSM'),(52689095,'created_by','JOSM'),(52689097,'created_by','JOSM'),(52689102,'created_by','JOSM'),(52689104,'created_by','JOSM'),(52689106,'created_by','JOSM'),(52689107,'created_by','JOSM'),(52689110,'created_by','JOSM'),(52689111,'created_by','JOSM'),(52689114,'created_by','JOSM'),(52689115,'created_by','JOSM'),(52689118,'created_by','JOSM'),(52689120,'created_by','JOSM'),(52689141,'created_by','JOSM'),(52689142,'created_by','JOSM'),(52689145,'created_by','JOSM'),(52689148,'created_by','JOSM'),(52689150,'created_by','JOSM'),(52689154,'created_by','JOSM'),(52689156,'created_by','JOSM'),(52689157,'created_by','JOSM'),(52689160,'created_by','JOSM'),(52689162,'created_by','JOSM'),(52689165,'created_by','JOSM'),(52689167,'created_by','JOSM'),(52689173,'created_by','JOSM'),(52689178,'created_by','JOSM'),(52689180,'created_by','JOSM'),(52689184,'created_by','JOSM'),(52689187,'created_by','JOSM'),(52689189,'created_by','JOSM'),(52689194,'created_by','JOSM'),(52689197,'created_by','JOSM'),(52689201,'created_by','JOSM'),(52689204,'created_by','JOSM'),(52689208,'created_by','JOSM'),(52689210,'created_by','JOSM'),(52689214,'created_by','JOSM'),(52689217,'created_by','JOSM'),(52689218,'created_by','JOSM'),(52689230,'created_by','JOSM'),(52689232,'created_by','JOSM'),(52689236,'created_by','JOSM'),(52689239,'created_by','JOSM'),(52689242,'created_by','JOSM'),(52689243,'created_by','JOSM'),(52689245,'created_by','JOSM'),(52689248,'created_by','JOSM'),(52689249,'created_by','JOSM'),(52689251,'created_by','JOSM'),(52689253,'created_by','JOSM'),(52689255,'created_by','JOSM'),(52689257,'created_by','JOSM'),(52689259,'created_by','JOSM'),(52689262,'created_by','JOSM'),(52689263,'created_by','JOSM'),(52689265,'created_by','JOSM'),(52689267,'created_by','JOSM'),(52689270,'created_by','JOSM'),(52689273,'created_by','JOSM'),(52689275,'created_by','JOSM'),(52689278,'created_by','JOSM'),(52689279,'created_by','JOSM'),(52689280,'created_by','JOSM'),(52689282,'created_by','JOSM'),(52689285,'created_by','JOSM'),(52689288,'created_by','JOSM'),(52689290,'created_by','JOSM'),(52689292,'created_by','JOSM'),(52689294,'created_by','JOSM'),(52689295,'created_by','JOSM'),(52689303,'created_by','JOSM'),(52689304,'created_by','JOSM'),(52689308,'created_by','JOSM'),(52689311,'created_by','JOSM'),(52689316,'created_by','JOSM'),(52689319,'created_by','JOSM'),(52689321,'created_by','JOSM'),(52689323,'created_by','JOSM'),(52689326,'created_by','JOSM'),(52689328,'created_by','JOSM'),(52689330,'created_by','JOSM'),(52689333,'created_by','JOSM'),(52689336,'created_by','JOSM'),(52689338,'created_by','JOSM'),(52689340,'created_by','JOSM'),(52689343,'created_by','JOSM'),(52689345,'created_by','JOSM'),(52689348,'created_by','JOSM'),(52689350,'created_by','JOSM'),(52689351,'created_by','JOSM'),(52689353,'created_by','JOSM'),(52689355,'created_by','JOSM'),(52689358,'created_by','JOSM'),(52689359,'created_by','JOSM'),(52689361,'created_by','JOSM'),(52689363,'created_by','JOSM'),(52689365,'created_by','JOSM'),(52689366,'created_by','JOSM'),(52689367,'created_by','JOSM'),(52689371,'created_by','JOSM'),(52689372,'created_by','JOSM'),(52689375,'created_by','JOSM'),(52689377,'created_by','JOSM'),(52689379,'created_by','JOSM'),(52689382,'created_by','JOSM'),(52689385,'created_by','JOSM'),(52689387,'created_by','JOSM'),(52689390,'created_by','JOSM'),(52689392,'created_by','JOSM'),(52689394,'created_by','JOSM'),(52689396,'created_by','JOSM'),(52689398,'created_by','JOSM'),(52689402,'created_by','JOSM'),(52689405,'created_by','JOSM'),(52689406,'created_by','JOSM'),(52689409,'created_by','JOSM'),(52689410,'created_by','JOSM'),(52689412,'created_by','JOSM'),(52689414,'created_by','JOSM'),(52689416,'created_by','JOSM'),(52689419,'created_by','JOSM'),(52689420,'created_by','JOSM'),(52689423,'created_by','JOSM'),(52689425,'created_by','JOSM'),(52689427,'created_by','JOSM'),(52689429,'created_by','JOSM'),(52689432,'created_by','JOSM'),(52689433,'created_by','JOSM'),(52689436,'created_by','JOSM'),(52689437,'created_by','JOSM'),(52689440,'created_by','JOSM'),(52689443,'created_by','JOSM'),(52689445,'created_by','JOSM'),(52689447,'created_by','JOSM'),(52689450,'created_by','JOSM'),(52689451,'created_by','JOSM'),(52689452,'created_by','JOSM'),(52689455,'created_by','JOSM'),(52689456,'created_by','JOSM'),(52689459,'created_by','JOSM'),(52689461,'created_by','JOSM'),(52689464,'created_by','JOSM'),(52689484,'created_by','JOSM'),(52689486,'created_by','JOSM'),(52689488,'created_by','JOSM'),(52689491,'created_by','JOSM'),(52689493,'created_by','JOSM'),(52689494,'created_by','JOSM'),(52689496,'created_by','JOSM'),(52689497,'created_by','JOSM'),(52689499,'created_by','JOSM'),(52689501,'created_by','JOSM'),(52689503,'created_by','JOSM'),(52689505,'created_by','JOSM'),(52689508,'created_by','JOSM'),(52689513,'created_by','JOSM'),(52689516,'created_by','JOSM'),(52689518,'created_by','JOSM'),(52689522,'created_by','JOSM'),(52689524,'created_by','JOSM'),(52689527,'created_by','JOSM'),(52689528,'created_by','JOSM'),(52689532,'created_by','JOSM'),(52689534,'created_by','JOSM'),(52689537,'created_by','JOSM'),(52689538,'created_by','JOSM'),(52689540,'created_by','JOSM'),(52689545,'created_by','JOSM'),(52689549,'created_by','JOSM'),(52689552,'created_by','JOSM'),(52689553,'created_by','JOSM'),(52689556,'created_by','JOSM'),(52689558,'created_by','JOSM'),(52689560,'created_by','JOSM'),(52689562,'created_by','JOSM'),(52689565,'created_by','JOSM'),(52689567,'created_by','JOSM'),(52689570,'created_by','JOSM'),(52689572,'created_by','JOSM'),(52689573,'created_by','JOSM'),(52689576,'created_by','JOSM'),(52689579,'created_by','JOSM'),(52689580,'created_by','JOSM'),(52689583,'created_by','JOSM'),(52689584,'created_by','JOSM'),(52689585,'created_by','JOSM'),(52689586,'created_by','JOSM'),(52689589,'created_by','JOSM'),(52689591,'created_by','JOSM'),(52689593,'created_by','JOSM'),(52689594,'created_by','JOSM'),(52689596,'created_by','JOSM'),(52689600,'created_by','JOSM'),(52689603,'created_by','JOSM'),(52689604,'created_by','JOSM'),(52689607,'created_by','JOSM'),(52689608,'created_by','JOSM'),(52689609,'created_by','JOSM'),(52689610,'created_by','JOSM'),(52689612,'created_by','JOSM'),(52689613,'created_by','JOSM'),(52689615,'created_by','JOSM'),(52689617,'created_by','JOSM'),(52689618,'created_by','JOSM'),(52689619,'created_by','JOSM'),(52689621,'created_by','JOSM'),(52689624,'created_by','JOSM'),(52689627,'created_by','JOSM'),(52689629,'created_by','JOSM'),(52689631,'created_by','JOSM'),(52689635,'created_by','JOSM'),(52689639,'created_by','JOSM'),(52689643,'created_by','JOSM'),(52689647,'created_by','JOSM'),(52689650,'created_by','JOSM'),(52689653,'created_by','JOSM'),(52689656,'created_by','JOSM'),(52689659,'created_by','JOSM'),(52689661,'created_by','JOSM'),(52689663,'created_by','JOSM'),(52689665,'created_by','JOSM'),(52689666,'created_by','JOSM'),(52689670,'created_by','JOSM'),(52689673,'created_by','JOSM'),(52689676,'created_by','JOSM'),(52689679,'created_by','JOSM'),(52689681,'created_by','JOSM'),(52689684,'created_by','JOSM'),(52689687,'created_by','JOSM'),(52689689,'created_by','JOSM'),(52689692,'created_by','JOSM'),(52689696,'created_by','JOSM'),(52689699,'created_by','JOSM'),(52689701,'created_by','JOSM'),(52689705,'created_by','JOSM'),(52689707,'created_by','JOSM'),(52689709,'created_by','JOSM'),(52689713,'created_by','JOSM'),(52689714,'created_by','JOSM'),(52689718,'created_by','JOSM'),(52689720,'created_by','JOSM'),(52689723,'created_by','JOSM'),(52689724,'created_by','JOSM'),(52689728,'created_by','JOSM'),(52689731,'created_by','JOSM'),(52689733,'created_by','JOSM'),(52689737,'created_by','JOSM'),(52689739,'created_by','JOSM'),(52689742,'created_by','JOSM'),(52689743,'created_by','JOSM'),(52689747,'created_by','JOSM'),(52689748,'created_by','JOSM'),(52689751,'created_by','JOSM'),(52689755,'created_by','JOSM'),(52733171,'created_by','JOSM'),(52733173,'created_by','JOSM'),(52733177,'created_by','JOSM'),(52733181,'created_by','JOSM'),(52733186,'created_by','JOSM'),(52733193,'created_by','JOSM'),(52733201,'created_by','JOSM'),(52733204,'created_by','JOSM'),(52733206,'created_by','JOSM'),(52733209,'created_by','JOSM'),(52733212,'created_by','JOSM'),(52733215,'created_by','JOSM'),(52733218,'created_by','JOSM'),(52733223,'created_by','JOSM'),(52743859,'created_by','JOSM'),(52743862,'created_by','JOSM'),(52743866,'created_by','JOSM'),(52743871,'created_by','JOSM'),(52743874,'created_by','JOSM'),(52743875,'created_by','JOSM'),(52743878,'created_by','JOSM'),(52743880,'created_by','JOSM'),(52743882,'created_by','JOSM'),(52743884,'created_by','JOSM'),(52743887,'created_by','JOSM'),(52743889,'created_by','JOSM'),(52743892,'created_by','JOSM'),(52743895,'created_by','JOSM'),(52743896,'created_by','JOSM'),(52743899,'created_by','JOSM'),(52743900,'created_by','JOSM'),(52743901,'created_by','JOSM'),(52743902,'created_by','JOSM'),(52743904,'created_by','JOSM'),(52743907,'created_by','JOSM'),(52743909,'created_by','JOSM'),(52743910,'created_by','JOSM'),(52743913,'created_by','JOSM'),(52743916,'created_by','JOSM'),(52743919,'created_by','JOSM'),(52743921,'created_by','JOSM'),(52743924,'created_by','JOSM'),(52743925,'created_by','JOSM'),(52743927,'created_by','JOSM'),(52743928,'created_by','JOSM'),(52743930,'created_by','JOSM'),(52743933,'created_by','JOSM'),(52743936,'created_by','JOSM'),(52743937,'created_by','JOSM'),(52743940,'created_by','JOSM'),(52743941,'created_by','JOSM'),(52743943,'created_by','JOSM'),(52743946,'created_by','JOSM'),(52743947,'created_by','JOSM'),(52743950,'created_by','JOSM'),(52743951,'created_by','JOSM'),(52743954,'created_by','JOSM'),(52743955,'created_by','JOSM'),(52743958,'created_by','JOSM'),(52743959,'created_by','JOSM'),(52743961,'created_by','JOSM'),(52743964,'created_by','JOSM'),(52743966,'created_by','JOSM'),(52743967,'created_by','JOSM'),(52743969,'created_by','JOSM'),(52743971,'created_by','JOSM'),(52743972,'created_by','JOSM'),(52743973,'created_by','JOSM'),(52743976,'created_by','JOSM'),(52743980,'created_by','JOSM'),(52743981,'created_by','JOSM'),(52743984,'created_by','JOSM'),(52743986,'created_by','JOSM'),(52743987,'created_by','JOSM'),(52743988,'created_by','JOSM'),(52743991,'created_by','JOSM'),(52743992,'created_by','JOSM'),(52743995,'created_by','JOSM'),(52743997,'created_by','JOSM'),(52744001,'created_by','JOSM'),(52744002,'created_by','JOSM'),(52744005,'created_by','JOSM'),(52744007,'created_by','JOSM'),(52744009,'created_by','JOSM'),(52744012,'created_by','JOSM'),(52744014,'created_by','JOSM'),(52744016,'created_by','JOSM'),(52744019,'created_by','JOSM'),(52744021,'created_by','JOSM'),(52744022,'created_by','JOSM'),(52744025,'created_by','JOSM'),(52744028,'created_by','JOSM'),(52744030,'created_by','JOSM'),(52744032,'created_by','JOSM'),(52744035,'created_by','JOSM'),(52744036,'created_by','JOSM'),(52744038,'created_by','JOSM'),(52744042,'created_by','JOSM'),(52744043,'created_by','JOSM'),(52744046,'created_by','JOSM'),(52744049,'created_by','JOSM'),(52744050,'created_by','JOSM'),(52744052,'created_by','JOSM'),(52744053,'created_by','JOSM'),(52744054,'created_by','JOSM'),(52744056,'created_by','JOSM'),(52744057,'created_by','JOSM'),(52744059,'created_by','JOSM'),(52744062,'created_by','JOSM'),(52744064,'created_by','JOSM'),(52744066,'created_by','JOSM'),(52744067,'created_by','JOSM'),(52744070,'created_by','JOSM'),(52744072,'created_by','JOSM'),(52744073,'created_by','JOSM'),(52744074,'created_by','JOSM'),(52744075,'created_by','JOSM'),(52744078,'created_by','JOSM'),(52744081,'created_by','JOSM'),(52744082,'created_by','JOSM'),(52744084,'created_by','JOSM'),(52744086,'created_by','JOSM'),(52744087,'created_by','JOSM'),(52744089,'created_by','JOSM'),(52744091,'created_by','JOSM'),(52744093,'created_by','JOSM'),(52744094,'created_by','JOSM'),(52744096,'created_by','JOSM'),(52744097,'created_by','JOSM'),(52744099,'created_by','JOSM'),(52744100,'created_by','JOSM'),(52744101,'created_by','JOSM'),(52744102,'created_by','JOSM'),(52744104,'created_by','JOSM'),(52744106,'created_by','JOSM'),(52744108,'created_by','JOSM'),(52744110,'created_by','JOSM'),(52744111,'created_by','JOSM'),(52744114,'created_by','JOSM'),(52744116,'created_by','JOSM'),(52744118,'created_by','JOSM'),(52744120,'created_by','JOSM'),(52744122,'created_by','JOSM'),(52744124,'created_by','JOSM'),(52744126,'created_by','JOSM'),(52744128,'created_by','JOSM'),(52744130,'created_by','JOSM'),(52744133,'created_by','JOSM'),(52744134,'created_by','JOSM'),(52744136,'created_by','JOSM'),(52744138,'created_by','JOSM'),(52744141,'created_by','JOSM'),(52744144,'created_by','JOSM'),(52744147,'created_by','JOSM'),(52744149,'created_by','JOSM'),(52744152,'created_by','JOSM'),(52744155,'created_by','JOSM'),(52744158,'created_by','JOSM'),(52744159,'created_by','JOSM'),(52744161,'created_by','JOSM'),(52744163,'created_by','JOSM'),(52744165,'created_by','JOSM'),(52744166,'created_by','JOSM'),(52744172,'created_by','JOSM'),(52744174,'created_by','JOSM'),(52744177,'created_by','JOSM'),(52744180,'created_by','JOSM'),(52744181,'created_by','JOSM'),(52744184,'created_by','JOSM'),(52744187,'created_by','JOSM'),(52744189,'created_by','JOSM'),(52744190,'created_by','JOSM'),(52744193,'created_by','JOSM'),(52744196,'created_by','JOSM'),(52744198,'created_by','JOSM'),(52744201,'created_by','JOSM'),(52744202,'created_by','JOSM'),(52744205,'created_by','JOSM'),(52744206,'created_by','JOSM'),(52744209,'created_by','JOSM'),(52744212,'created_by','JOSM'),(52744213,'created_by','JOSM'),(52744214,'created_by','JOSM'),(52744218,'created_by','JOSM'),(52744219,'created_by','JOSM'),(52744222,'created_by','JOSM'),(52744223,'created_by','JOSM'),(52744227,'created_by','JOSM'),(52744228,'created_by','JOSM'),(52744231,'created_by','JOSM'),(52744232,'created_by','JOSM'),(52744236,'created_by','JOSM'),(52744237,'created_by','JOSM'),(52744238,'created_by','JOSM'),(52744240,'created_by','JOSM'),(52744241,'created_by','JOSM'),(52744245,'created_by','JOSM'),(52744246,'created_by','JOSM'),(52744249,'created_by','JOSM'),(52744250,'created_by','JOSM'),(52744253,'created_by','JOSM'),(52744254,'created_by','JOSM'),(52744257,'created_by','JOSM'),(52744259,'created_by','JOSM'),(52744260,'created_by','JOSM'),(52744262,'created_by','JOSM'),(52744264,'created_by','JOSM'),(52744265,'created_by','JOSM'),(52744268,'created_by','JOSM'),(52744270,'created_by','JOSM'),(52744272,'created_by','JOSM'),(52744274,'created_by','JOSM'),(52744277,'created_by','JOSM'),(52744279,'created_by','JOSM'),(52744281,'created_by','JOSM'),(52744284,'created_by','JOSM'),(52744286,'created_by','JOSM'),(52744289,'created_by','JOSM'),(52744292,'created_by','JOSM'),(52744294,'created_by','JOSM'),(52744296,'created_by','JOSM'),(52744298,'created_by','JOSM'),(52744301,'created_by','JOSM'),(52744303,'created_by','JOSM'),(52744306,'created_by','JOSM'),(52744308,'created_by','JOSM'),(52744309,'created_by','JOSM'),(52744312,'created_by','JOSM'),(52744313,'created_by','JOSM'),(52744315,'created_by','JOSM'),(52744318,'created_by','JOSM'),(52744320,'created_by','JOSM'),(52744323,'created_by','JOSM'),(52744326,'created_by','JOSM'),(52744329,'created_by','JOSM'),(52744330,'created_by','JOSM'),(52744333,'created_by','JOSM'),(52744334,'created_by','JOSM'),(52744337,'created_by','JOSM'),(52744339,'created_by','JOSM'),(52744342,'created_by','JOSM'),(52744344,'created_by','JOSM'),(52744346,'created_by','JOSM'),(52744349,'created_by','JOSM'),(52744350,'created_by','JOSM'),(52744352,'created_by','JOSM'),(52744356,'created_by','JOSM'),(52744359,'created_by','JOSM'),(52744360,'created_by','JOSM'),(52744364,'created_by','JOSM'),(52744365,'created_by','JOSM'),(52744368,'created_by','JOSM'),(52744370,'created_by','JOSM'),(52744372,'created_by','JOSM'),(52744375,'created_by','JOSM'),(52744378,'created_by','JOSM'),(52744379,'created_by','JOSM'),(52744383,'created_by','JOSM'),(52744385,'created_by','JOSM'),(52744387,'created_by','JOSM'),(52744390,'created_by','JOSM'),(52744392,'created_by','JOSM'),(52744394,'created_by','JOSM'),(52744396,'created_by','JOSM'),(52744399,'created_by','JOSM'),(52744400,'created_by','JOSM'),(52744402,'created_by','JOSM'),(52744405,'created_by','JOSM'),(52744409,'created_by','JOSM'),(52744411,'created_by','JOSM'),(52744413,'created_by','JOSM'),(52744416,'created_by','JOSM'),(52744418,'created_by','JOSM'),(52744420,'created_by','JOSM'),(52744423,'created_by','JOSM'),(52744426,'created_by','JOSM'),(52744429,'created_by','JOSM'),(52744432,'created_by','JOSM'),(52744434,'created_by','JOSM'),(52744437,'created_by','JOSM'),(52744439,'created_by','JOSM'),(52744440,'created_by','JOSM'),(52744443,'created_by','JOSM'),(52744446,'created_by','JOSM'),(52744447,'created_by','JOSM'),(52744450,'created_by','JOSM'),(52744452,'created_by','JOSM'),(52744455,'created_by','JOSM'),(52744457,'created_by','JOSM'),(52744460,'created_by','JOSM'),(52744462,'created_by','JOSM'),(52744464,'created_by','JOSM'),(52744468,'created_by','JOSM'),(52744471,'created_by','JOSM'),(52744473,'created_by','JOSM'),(52744475,'created_by','JOSM'),(52747815,'created_by','JOSM'),(52747820,'created_by','JOSM'),(52747826,'created_by','JOSM'),(52747832,'created_by','JOSM'),(52747838,'created_by','JOSM'),(52747841,'created_by','JOSM'),(52747846,'created_by','JOSM'),(52747849,'created_by','JOSM'),(52747852,'created_by','JOSM'),(52747855,'created_by','JOSM'),(52747857,'created_by','JOSM'),(52747861,'created_by','JOSM'),(52747863,'created_by','JOSM'),(52747865,'created_by','JOSM'),(52747867,'created_by','JOSM'),(52747869,'created_by','JOSM'),(52747872,'created_by','JOSM'),(52747876,'created_by','JOSM'),(52747878,'created_by','JOSM'),(52747881,'created_by','JOSM'),(52747884,'created_by','JOSM'),(52747885,'created_by','JOSM'),(52747888,'created_by','JOSM'),(52747890,'created_by','JOSM'),(52747893,'created_by','JOSM'),(52747898,'created_by','JOSM'),(52747901,'created_by','JOSM'),(52748785,'created_by','JOSM'),(52748790,'created_by','JOSM'),(52748831,'created_by','JOSM'),(52748833,'created_by','JOSM'),(52748835,'created_by','JOSM'),(52748837,'created_by','JOSM'),(52749087,'created_by','JOSM'),(52749143,'created_by','JOSM'),(52749145,'created_by','JOSM'),(52749150,'created_by','JOSM'),(52749155,'created_by','JOSM'),(52749158,'created_by','JOSM'),(52749159,'created_by','JOSM'),(52749162,'created_by','JOSM'),(52749165,'created_by','JOSM'),(52749169,'created_by','JOSM'),(52749171,'created_by','JOSM'),(52749174,'created_by','JOSM'),(52749175,'created_by','JOSM'),(52749183,'created_by','JOSM'),(52749184,'created_by','JOSM'),(52749185,'created_by','JOSM'),(52749189,'created_by','JOSM'),(52749191,'created_by','JOSM'),(52749208,'created_by','JOSM'),(52749211,'created_by','JOSM'),(52749214,'created_by','JOSM'),(52749218,'created_by','JOSM'),(52749220,'created_by','JOSM'),(52749224,'created_by','JOSM'),(52749225,'created_by','JOSM'),(52749228,'created_by','JOSM'),(52749231,'created_by','JOSM'),(52749233,'created_by','JOSM'),(52749238,'created_by','JOSM'),(52749240,'created_by','JOSM'),(52749243,'created_by','JOSM'),(52749244,'created_by','JOSM'),(52749247,'created_by','JOSM'),(52749251,'created_by','JOSM'),(52749255,'created_by','JOSM'),(52749256,'created_by','JOSM'),(52749259,'created_by','JOSM'),(52749261,'created_by','JOSM'),(52749263,'created_by','JOSM'),(52749266,'created_by','JOSM'),(52749268,'created_by','JOSM'),(52749271,'created_by','JOSM'),(52749275,'created_by','JOSM'),(52749276,'created_by','JOSM'),(52749280,'created_by','JOSM'),(52749282,'created_by','JOSM'),(52749284,'created_by','JOSM'),(52749285,'created_by','JOSM'),(52749288,'created_by','JOSM'),(52749289,'created_by','JOSM'),(52749309,'created_by','JOSM'),(52749310,'created_by','JOSM'),(52749312,'created_by','JOSM'),(52749314,'created_by','JOSM'),(52749316,'created_by','JOSM'),(52749321,'created_by','JOSM'),(52749324,'created_by','JOSM'),(52749326,'created_by','JOSM'),(52749328,'created_by','JOSM'),(52749331,'created_by','JOSM'),(52749334,'created_by','JOSM'),(52749340,'created_by','JOSM'),(52749341,'created_by','JOSM'),(52749343,'created_by','JOSM'),(52749347,'created_by','JOSM'),(52749349,'created_by','JOSM'),(52749352,'created_by','JOSM'),(52749354,'created_by','JOSM'),(52749357,'created_by','JOSM'),(52749359,'created_by','JOSM'),(52749363,'created_by','JOSM'),(52749366,'created_by','JOSM'),(52749368,'created_by','JOSM'),(52749371,'created_by','JOSM'),(52749376,'created_by','JOSM'),(52749379,'created_by','JOSM'),(52749381,'created_by','JOSM'),(52749385,'created_by','JOSM'),(52749386,'created_by','JOSM'),(52749387,'created_by','JOSM'),(52749389,'created_by','JOSM'),(52749391,'created_by','JOSM'),(52749393,'created_by','JOSM'),(52749396,'created_by','JOSM'),(52749398,'created_by','JOSM'),(52749400,'created_by','JOSM'),(52749402,'created_by','JOSM'),(52749404,'created_by','JOSM'),(52749407,'created_by','JOSM'),(52749410,'created_by','JOSM'),(52749412,'created_by','JOSM'),(52749414,'created_by','JOSM'),(52749416,'created_by','JOSM'),(52749419,'created_by','JOSM'),(52749421,'created_by','JOSM'),(52749424,'created_by','JOSM'),(52749428,'created_by','JOSM'),(52749430,'created_by','JOSM'),(52749433,'created_by','JOSM'),(52749436,'created_by','JOSM'),(52749439,'created_by','JOSM'),(52749441,'created_by','JOSM'),(52749443,'created_by','JOSM'),(52749448,'created_by','JOSM'),(52749451,'created_by','JOSM'),(52749455,'created_by','JOSM'),(52749458,'created_by','JOSM'),(52749460,'created_by','JOSM'),(52749462,'created_by','JOSM'),(52749465,'created_by','JOSM'),(52749469,'created_by','JOSM'),(52749472,'created_by','JOSM'),(52749474,'created_by','JOSM'),(52749475,'created_by','JOSM'),(52749479,'created_by','JOSM'),(52749482,'created_by','JOSM'),(52749485,'created_by','JOSM'),(52749487,'created_by','JOSM'),(52749490,'created_by','JOSM'),(52749491,'created_by','JOSM'),(52749492,'created_by','JOSM'),(52749496,'created_by','JOSM'),(52749497,'created_by','JOSM'),(52749499,'created_by','JOSM'),(52749502,'created_by','JOSM'),(52749503,'created_by','JOSM'),(52749505,'created_by','JOSM'),(52749508,'created_by','JOSM'),(52749509,'created_by','JOSM'),(52749511,'created_by','JOSM'),(52749514,'created_by','JOSM'),(52749517,'created_by','JOSM'),(52769332,'created_by','JOSM'),(52769338,'created_by','JOSM'),(52769340,'created_by','JOSM'),(52769343,'created_by','JOSM'),(52769346,'created_by','JOSM'),(52769349,'created_by','JOSM'),(52769352,'created_by','JOSM'),(52769355,'created_by','JOSM'),(52769357,'created_by','JOSM'),(52769358,'created_by','JOSM'),(52769361,'created_by','JOSM'),(52769364,'created_by','JOSM'),(52769366,'created_by','JOSM'),(52769367,'created_by','JOSM'),(52769369,'created_by','JOSM'),(52769371,'created_by','JOSM'),(52769373,'created_by','JOSM'),(52769374,'created_by','JOSM'),(52769377,'created_by','JOSM'),(52769380,'created_by','JOSM'),(52769381,'created_by','JOSM'),(52769384,'created_by','JOSM'),(52769387,'created_by','JOSM'),(52769389,'created_by','JOSM'),(52769392,'created_by','JOSM'),(52769395,'created_by','JOSM'),(52769397,'created_by','JOSM'),(52769401,'created_by','JOSM'),(52769406,'created_by','JOSM'),(52769411,'created_by','JOSM'),(52769413,'created_by','JOSM'),(52769415,'created_by','JOSM'),(52769418,'created_by','JOSM'),(52769419,'created_by','JOSM'),(52769420,'created_by','JOSM'),(52769423,'created_by','JOSM'),(52769425,'created_by','JOSM'),(52769427,'created_by','JOSM'),(52769431,'created_by','JOSM'),(52769436,'created_by','JOSM'),(52769439,'created_by','JOSM'),(52769441,'created_by','JOSM'),(52769444,'created_by','JOSM'),(52769447,'created_by','JOSM'),(52769450,'created_by','JOSM'),(52769452,'created_by','JOSM'),(52769456,'created_by','JOSM'),(52769457,'created_by','JOSM'),(52769460,'created_by','JOSM'),(52769465,'created_by','JOSM'),(52769471,'created_by','JOSM'),(52769477,'created_by','JOSM'),(52769479,'created_by','JOSM'),(52769482,'created_by','JOSM'),(52769485,'created_by','JOSM'),(52769488,'created_by','JOSM'),(52769491,'created_by','JOSM'),(52769493,'created_by','JOSM'),(52792095,'created_by','JOSM'),(52792098,'created_by','JOSM'),(52792102,'created_by','JOSM'),(52792111,'created_by','JOSM'),(52792113,'created_by','JOSM'),(52792114,'created_by','JOSM'),(52792117,'created_by','JOSM'),(52792122,'created_by','JOSM'),(52792158,'created_by','JOSM'),(52792159,'created_by','JOSM'),(52792177,'created_by','JOSM'),(52792180,'created_by','JOSM'),(52792182,'created_by','JOSM'),(52792185,'created_by','JOSM'),(52792187,'created_by','JOSM'),(52792189,'created_by','JOSM'),(52792192,'created_by','JOSM'),(52792194,'created_by','JOSM'),(52792196,'created_by','JOSM'),(52792199,'created_by','JOSM'),(52792202,'created_by','JOSM'),(52792205,'created_by','JOSM'),(52792210,'created_by','JOSM'),(52796991,'created_by','JOSM'),(52797049,'created_by','JOSM'),(52797051,'created_by','JOSM'),(52797069,'created_by','JOSM'),(52797105,'created_by','JOSM'),(52797267,'created_by','JOSM'),(52797268,'created_by','JOSM'),(52797269,'created_by','JOSM'),(52797270,'created_by','JOSM'),(52797275,'created_by','JOSM'),(52797278,'created_by','JOSM'),(52797286,'created_by','JOSM'),(52797303,'created_by','JOSM'),(52797555,'created_by','JOSM'),(52798676,'created_by','JOSM'),(52799709,'created_by','JOSM'),(52799985,'created_by','JOSM'),(52800033,'created_by','JOSM'),(52800211,'created_by','JOSM'),(52800388,'created_by','JOSM'),(52800400,'created_by','JOSM'),(52800405,'created_by','JOSM'),(52800416,'created_by','JOSM'),(52800529,'created_by','JOSM'),(52800536,'created_by','JOSM'),(52800580,'created_by','JOSM'),(52800584,'created_by','JOSM'),(52800586,'created_by','JOSM'),(52800590,'created_by','JOSM'),(52800592,'created_by','JOSM'),(52800596,'created_by','JOSM'),(52800599,'created_by','JOSM'),(52800602,'created_by','JOSM'),(52800606,'created_by','JOSM'),(52800608,'created_by','JOSM'),(52800610,'created_by','JOSM'),(52800614,'created_by','JOSM'),(52800618,'created_by','JOSM'),(52800619,'created_by','JOSM'),(52800622,'created_by','JOSM'),(52800623,'created_by','JOSM'),(52800625,'created_by','JOSM'),(52800626,'created_by','JOSM'),(52800628,'created_by','JOSM'),(52800630,'created_by','JOSM'),(52800634,'created_by','JOSM'),(52800638,'created_by','JOSM'),(52800642,'created_by','JOSM'),(52800645,'created_by','JOSM'),(52800647,'created_by','JOSM'),(52800651,'created_by','JOSM'),(52800652,'created_by','JOSM'),(52800656,'created_by','JOSM'),(52800661,'created_by','JOSM'),(52800664,'created_by','JOSM'),(52800665,'created_by','JOSM'),(52800667,'created_by','JOSM'),(52800668,'created_by','JOSM'),(52800670,'created_by','JOSM'),(52800673,'created_by','JOSM'),(52800677,'created_by','JOSM'),(52800681,'created_by','JOSM'),(52800683,'created_by','JOSM'),(52800686,'created_by','JOSM'),(52800691,'created_by','JOSM'),(52800794,'created_by','JOSM'),(52800813,'created_by','JOSM'),(52800821,'created_by','JOSM'),(52800828,'created_by','JOSM'),(52800845,'created_by','JOSM'),(52800909,'created_by','JOSM'),(52800938,'created_by','JOSM'),(52800944,'created_by','JOSM'),(52800948,'created_by','JOSM'),(52800952,'created_by','JOSM'),(52800957,'created_by','JOSM'),(52800960,'created_by','JOSM'),(52800964,'created_by','JOSM'),(52800967,'created_by','JOSM'),(52800970,'created_by','JOSM'),(52800974,'created_by','JOSM'),(52800978,'created_by','JOSM'),(52800981,'created_by','JOSM'),(52800985,'created_by','JOSM'),(52800987,'created_by','JOSM'),(52800990,'created_by','JOSM'),(52800993,'created_by','JOSM'),(52800995,'created_by','JOSM'),(52800998,'created_by','JOSM'),(52801001,'created_by','JOSM'),(52801004,'created_by','JOSM'),(52801007,'created_by','JOSM'),(52801010,'created_by','JOSM'),(52801153,'created_by','JOSM'),(52801157,'created_by','JOSM'),(52801158,'created_by','JOSM'),(52801164,'created_by','JOSM'),(52801166,'created_by','JOSM'),(52801167,'created_by','JOSM'),(52801168,'created_by','JOSM'),(52801170,'created_by','JOSM'),(52801172,'created_by','JOSM'),(52801173,'created_by','JOSM'),(52801175,'created_by','JOSM'),(52801176,'created_by','JOSM'),(52801178,'created_by','JOSM'),(52801181,'created_by','JOSM'),(52801182,'created_by','JOSM'),(52801184,'created_by','JOSM'),(52801190,'created_by','JOSM'),(52801192,'created_by','JOSM'),(52801195,'created_by','JOSM'),(52801198,'created_by','JOSM'),(52801203,'created_by','JOSM'),(52801207,'created_by','JOSM'),(52801209,'created_by','JOSM'),(52801212,'created_by','JOSM'),(52801215,'created_by','JOSM'),(52801217,'created_by','JOSM'),(52801218,'created_by','JOSM'),(52801220,'created_by','JOSM'),(52801221,'created_by','JOSM'),(52801223,'created_by','JOSM'),(52801226,'created_by','JOSM'),(52801228,'created_by','JOSM'),(52801231,'created_by','JOSM'),(52801233,'created_by','JOSM'),(52801234,'created_by','JOSM'),(52801247,'created_by','JOSM'),(52801248,'created_by','JOSM'),(52801251,'created_by','JOSM'),(52801254,'created_by','JOSM'),(52801258,'created_by','JOSM'),(52801262,'created_by','JOSM'),(52801265,'created_by','JOSM'),(52801269,'created_by','JOSM'),(52801273,'created_by','JOSM'),(52801274,'created_by','JOSM'),(52801279,'created_by','JOSM'),(52801283,'created_by','JOSM'),(52801284,'created_by','JOSM'),(52801287,'created_by','JOSM'),(52801289,'created_by','JOSM'),(52801291,'created_by','JOSM'),(52801293,'created_by','JOSM'),(52801295,'created_by','JOSM'),(52801298,'created_by','JOSM'),(52801299,'created_by','JOSM'),(52801301,'created_by','JOSM'),(52801303,'created_by','JOSM'),(52801305,'created_by','JOSM'),(52801307,'created_by','JOSM'),(52801309,'created_by','JOSM'),(52801311,'created_by','JOSM'),(52801313,'created_by','JOSM'),(52801314,'created_by','JOSM'),(52801316,'created_by','JOSM'),(52801317,'created_by','JOSM'),(52801319,'created_by','JOSM'),(52801321,'created_by','JOSM'),(52801323,'created_by','JOSM'),(52801324,'created_by','JOSM'),(52801326,'created_by','JOSM'),(52801328,'created_by','JOSM'),(52801330,'created_by','JOSM'),(52801331,'created_by','JOSM'),(52801333,'created_by','JOSM'),(52801336,'created_by','JOSM'),(52801339,'created_by','JOSM'),(52801341,'created_by','JOSM'),(52801344,'created_by','JOSM'),(52801345,'created_by','JOSM'),(52801348,'created_by','JOSM'),(52801350,'created_by','JOSM'),(52801352,'created_by','JOSM'),(52801353,'created_by','JOSM'),(52801354,'created_by','JOSM'),(52801355,'created_by','JOSM'),(52801356,'created_by','JOSM'),(52801357,'created_by','JOSM'),(52801358,'created_by','JOSM'),(52801359,'created_by','JOSM'),(52801360,'created_by','JOSM'),(52801361,'created_by','JOSM'),(52801362,'created_by','JOSM'),(52801363,'created_by','JOSM'),(52801364,'created_by','JOSM'),(52801366,'created_by','JOSM'),(52801368,'created_by','JOSM'),(52801370,'created_by','JOSM'),(52801372,'created_by','JOSM'),(52801374,'created_by','JOSM'),(52801376,'created_by','JOSM'),(52801380,'created_by','JOSM'),(52801384,'created_by','JOSM'),(52801389,'created_by','JOSM'),(52801392,'created_by','JOSM'),(52801396,'created_by','JOSM'),(52801397,'created_by','JOSM'),(52801402,'created_by','JOSM'),(52801404,'created_by','JOSM'),(52801407,'created_by','JOSM'),(52801413,'created_by','JOSM'),(52801417,'created_by','JOSM'),(52801418,'created_by','JOSM'),(52801422,'created_by','JOSM'),(52801425,'created_by','JOSM'),(52801427,'created_by','JOSM'),(52801429,'created_by','JOSM'),(52801431,'created_by','JOSM'),(52801433,'created_by','JOSM'),(52801435,'created_by','JOSM'),(52801437,'created_by','JOSM'),(52801439,'created_by','JOSM'),(52801441,'created_by','JOSM'),(52801444,'created_by','JOSM'),(52801446,'created_by','JOSM'),(52801447,'created_by','JOSM'),(52801451,'created_by','JOSM'),(52801453,'created_by','JOSM'),(52801456,'created_by','JOSM'),(52801461,'created_by','JOSM'),(52801462,'created_by','JOSM'),(52801465,'created_by','JOSM'),(52801468,'created_by','JOSM'),(52801469,'created_by','JOSM'),(52801475,'created_by','JOSM'),(52801477,'created_by','JOSM'),(52801480,'created_by','JOSM'),(52801487,'created_by','JOSM'),(52801494,'created_by','JOSM'),(52801506,'created_by','JOSM'),(52801514,'created_by','JOSM'),(52801516,'created_by','JOSM'),(52801518,'created_by','JOSM'),(52801520,'created_by','JOSM'),(52801522,'created_by','JOSM'),(52801524,'created_by','JOSM'),(52801526,'created_by','JOSM'),(52801527,'created_by','JOSM'),(52801531,'created_by','JOSM'),(52801534,'created_by','JOSM'),(52801538,'created_by','JOSM'),(52801542,'created_by','JOSM'),(52801545,'created_by','JOSM'),(52801548,'created_by','JOSM'),(52801551,'created_by','JOSM'),(52801555,'created_by','JOSM'),(52801558,'created_by','JOSM'),(52801561,'created_by','JOSM'),(52801566,'created_by','JOSM'),(52801569,'created_by','JOSM'),(52801571,'created_by','JOSM'),(52801573,'created_by','JOSM'),(52801576,'created_by','JOSM'),(52801578,'created_by','JOSM'),(52801581,'created_by','JOSM'),(52801584,'created_by','JOSM'),(52801585,'created_by','JOSM'),(52801587,'created_by','JOSM'),(52801618,'created_by','JOSM'),(52801640,'created_by','JOSM'),(52801643,'created_by','JOSM'),(52801648,'created_by','JOSM'),(52801652,'created_by','JOSM'),(52801654,'created_by','JOSM'),(52801657,'created_by','JOSM'),(52801660,'created_by','JOSM'),(52801663,'created_by','JOSM'),(52801664,'created_by','JOSM'),(52801668,'created_by','JOSM'),(52801672,'created_by','JOSM'),(52801674,'created_by','JOSM'),(52801679,'created_by','JOSM'),(52801683,'created_by','JOSM'),(52801684,'created_by','JOSM'),(52801688,'created_by','JOSM'),(52801691,'created_by','JOSM'),(52801695,'created_by','JOSM'),(52801699,'created_by','JOSM'),(52801701,'created_by','JOSM'),(52801704,'created_by','JOSM'),(52801707,'created_by','JOSM'),(52801710,'created_by','JOSM'),(52801715,'created_by','JOSM'),(52801719,'created_by','JOSM'),(52801722,'created_by','JOSM'),(52801725,'created_by','JOSM'),(52801729,'created_by','JOSM'),(52801733,'created_by','JOSM'),(52801737,'created_by','JOSM'),(52801741,'created_by','JOSM'),(52801744,'created_by','JOSM'),(52801747,'created_by','JOSM'),(52801749,'created_by','JOSM'),(52801750,'created_by','JOSM'),(52801752,'created_by','JOSM'),(52801754,'created_by','JOSM'),(52801756,'created_by','JOSM'),(52801757,'created_by','JOSM'),(52801758,'created_by','JOSM'),(52801759,'created_by','JOSM'),(52801760,'created_by','JOSM'),(52801761,'created_by','JOSM'),(52801762,'created_by','JOSM'),(52801764,'created_by','JOSM'),(52801765,'created_by','JOSM'),(52801768,'created_by','JOSM'),(52801769,'created_by','JOSM'),(52801771,'created_by','JOSM'),(52801772,'created_by','JOSM'),(52801774,'created_by','JOSM'),(52801776,'created_by','JOSM'),(52801777,'created_by','JOSM'),(52801780,'created_by','JOSM'),(52801781,'created_by','JOSM'),(52801783,'created_by','JOSM'),(52801785,'created_by','JOSM'),(52801787,'created_by','JOSM'),(52801788,'created_by','JOSM'),(52801791,'created_by','JOSM'),(52801792,'created_by','JOSM'),(52801794,'created_by','JOSM'),(52801796,'created_by','JOSM'),(52801807,'created_by','JOSM'),(52801809,'created_by','JOSM'),(52801813,'created_by','JOSM'),(52801816,'created_by','JOSM'),(52801819,'created_by','JOSM'),(52801824,'created_by','JOSM'),(52801827,'created_by','JOSM'),(52801876,'created_by','JOSM'),(52802034,'created_by','JOSM'),(52802158,'created_by','JOSM'),(52802159,'created_by','JOSM'),(52802160,'created_by','JOSM'),(52802161,'created_by','JOSM'),(52802162,'created_by','JOSM'),(52802163,'created_by','JOSM'),(52802164,'created_by','JOSM'),(52802165,'created_by','JOSM'),(52802166,'created_by','JOSM'),(52802167,'created_by','JOSM'),(52802168,'created_by','JOSM'),(52802169,'created_by','JOSM'),(52802170,'created_by','JOSM'),(52802171,'created_by','JOSM'),(52802172,'created_by','JOSM'),(52802173,'created_by','JOSM'),(52802183,'created_by','JOSM'),(52802197,'created_by','JOSM'),(52802210,'created_by','JOSM'),(52802216,'created_by','JOSM'),(52802218,'created_by','JOSM'),(52802229,'created_by','JOSM'),(52802260,'created_by','JOSM'),(52803163,'created_by','JOSM'),(52803175,'created_by','JOSM'),(52803179,'created_by','JOSM'),(52803182,'created_by','JOSM'),(52803183,'created_by','JOSM'),(52803186,'created_by','JOSM'),(52803189,'created_by','JOSM'),(52803191,'created_by','JOSM'),(52803194,'created_by','JOSM'),(52803195,'created_by','JOSM'),(52803196,'created_by','JOSM'),(52803197,'created_by','JOSM'),(52803198,'created_by','JOSM'),(52803200,'created_by','JOSM'),(52803201,'created_by','JOSM'),(52803202,'created_by','JOSM'),(52803205,'created_by','JOSM'),(52803207,'created_by','JOSM'),(52803211,'created_by','JOSM'),(52803214,'created_by','JOSM'),(52803216,'created_by','JOSM'),(52803218,'created_by','JOSM'),(52803220,'created_by','JOSM'),(52803222,'created_by','JOSM'),(52803224,'created_by','JOSM'),(52803225,'created_by','JOSM'),(52803228,'created_by','JOSM'),(52803229,'created_by','JOSM'),(52803233,'created_by','JOSM'),(52803235,'created_by','JOSM'),(52803237,'created_by','JOSM'),(52803239,'created_by','JOSM'),(52803241,'created_by','JOSM'),(52803243,'created_by','JOSM'),(52803247,'created_by','JOSM'),(52803251,'created_by','JOSM'),(52803254,'created_by','JOSM'),(52803255,'created_by','JOSM'),(52803259,'created_by','JOSM'),(52803263,'created_by','JOSM'),(52803266,'created_by','JOSM'),(52803269,'created_by','JOSM'),(52803271,'created_by','JOSM'),(52803273,'created_by','JOSM'),(52803277,'created_by','JOSM'),(52803280,'created_by','JOSM'),(52803283,'created_by','JOSM'),(52803285,'created_by','JOSM'),(52803289,'created_by','JOSM'),(52803297,'created_by','JOSM'),(52803300,'created_by','JOSM'),(52803304,'created_by','JOSM'),(52803309,'created_by','JOSM'),(52803311,'created_by','JOSM'),(52803313,'created_by','JOSM'),(52803316,'created_by','JOSM'),(52803319,'created_by','JOSM'),(52803320,'created_by','JOSM'),(52803323,'created_by','JOSM'),(52803325,'created_by','JOSM'),(52803327,'created_by','JOSM'),(52803328,'created_by','JOSM'),(52803331,'created_by','JOSM'),(52803333,'created_by','JOSM'),(52803336,'created_by','JOSM'),(52803337,'created_by','JOSM'),(52803338,'created_by','JOSM'),(52803340,'created_by','JOSM'),(52803343,'created_by','JOSM'),(52803346,'created_by','JOSM'),(52803349,'created_by','JOSM'),(52803351,'created_by','JOSM'),(52803353,'created_by','JOSM'),(52803358,'created_by','JOSM'),(52803363,'created_by','JOSM'),(52803365,'created_by','JOSM'),(52803368,'created_by','JOSM'),(52803370,'created_by','JOSM'),(52803372,'created_by','JOSM'),(52803374,'created_by','JOSM'),(52803378,'created_by','JOSM'),(52803382,'created_by','JOSM'),(52803385,'created_by','JOSM'),(52803388,'created_by','JOSM'),(52803391,'created_by','JOSM'),(52803393,'created_by','JOSM'),(52803396,'created_by','JOSM'),(52803399,'created_by','JOSM'),(52803402,'created_by','JOSM'),(52803405,'created_by','JOSM'),(52803937,'created_by','JOSM'),(52803938,'created_by','JOSM'),(52803940,'created_by','JOSM'),(52803941,'created_by','JOSM'),(52803943,'created_by','JOSM'),(52803944,'created_by','JOSM'),(52803954,'created_by','JOSM'),(52803955,'created_by','JOSM'),(52803956,'created_by','JOSM'),(52803958,'created_by','JOSM'),(52803959,'created_by','JOSM'),(52803961,'created_by','JOSM'),(52803962,'created_by','JOSM'),(52803965,'created_by','JOSM'),(52803969,'created_by','JOSM'),(52803973,'created_by','JOSM'),(52803976,'created_by','JOSM'),(52803980,'created_by','JOSM'),(52803983,'created_by','JOSM'),(52803988,'created_by','JOSM'),(52803992,'created_by','JOSM'),(52803995,'created_by','JOSM'),(52803998,'created_by','JOSM'),(52804002,'created_by','JOSM'),(52804005,'created_by','JOSM'),(52804010,'created_by','JOSM'),(52804014,'created_by','JOSM'),(52804018,'created_by','JOSM'),(52804021,'created_by','JOSM'),(52804024,'created_by','JOSM'),(52804026,'created_by','JOSM'),(52804028,'created_by','JOSM'),(52804030,'created_by','JOSM'),(52804033,'created_by','JOSM'),(52804036,'created_by','JOSM'),(52804038,'created_by','JOSM'),(52804041,'created_by','JOSM'),(52804043,'created_by','JOSM'),(52804046,'created_by','JOSM'),(52804050,'created_by','JOSM'),(52804052,'created_by','JOSM'),(52804055,'created_by','JOSM'),(52804060,'created_by','JOSM'),(52804062,'created_by','JOSM'),(52804065,'created_by','JOSM'),(52804069,'created_by','JOSM'),(52804073,'created_by','JOSM'),(52804077,'created_by','JOSM'),(52804081,'created_by','JOSM'),(52804084,'created_by','JOSM'),(52804087,'created_by','JOSM'),(52804090,'created_by','JOSM'),(52804091,'created_by','JOSM'),(52804093,'created_by','JOSM'),(52804096,'created_by','JOSM'),(52804100,'created_by','JOSM'),(52804101,'created_by','JOSM'),(52804106,'created_by','JOSM'),(52804109,'created_by','JOSM'),(52804112,'created_by','JOSM'),(52804114,'created_by','JOSM'),(52804117,'created_by','JOSM'),(52804118,'created_by','JOSM'),(52804119,'created_by','JOSM'),(52804120,'created_by','JOSM'),(52804121,'created_by','JOSM'),(52804122,'created_by','JOSM'),(52804123,'created_by','JOSM'),(52804124,'created_by','JOSM'),(52804125,'created_by','JOSM'),(52804126,'created_by','JOSM'),(52804127,'created_by','JOSM'),(52804128,'created_by','JOSM'),(52804129,'created_by','JOSM'),(52804130,'created_by','JOSM'),(52804131,'created_by','JOSM'),(52804132,'created_by','JOSM'),(52804133,'created_by','JOSM'),(52804134,'created_by','JOSM'),(52804135,'created_by','JOSM'),(52804136,'created_by','JOSM'),(52804137,'created_by','JOSM'),(52804138,'created_by','JOSM'),(52804139,'created_by','JOSM'),(52804140,'created_by','JOSM'),(52804141,'created_by','JOSM'),(52804142,'created_by','JOSM'),(52804143,'created_by','JOSM'),(52804145,'created_by','JOSM'),(52804150,'created_by','JOSM'),(52804160,'created_by','JOSM'),(52804163,'created_by','JOSM'),(52804167,'created_by','JOSM'),(52804172,'created_by','JOSM'),(52804173,'created_by','JOSM'),(52804176,'created_by','JOSM'),(52804216,'created_by','JOSM'),(52804228,'created_by','JOSM'),(52804233,'created_by','JOSM'),(52804235,'created_by','JOSM'),(52804237,'created_by','JOSM'),(52804272,'created_by','JOSM'),(52804275,'created_by','JOSM'),(52804279,'created_by','JOSM'),(52804292,'created_by','JOSM'),(52804295,'created_by','JOSM'),(52804297,'created_by','JOSM'),(52804298,'created_by','JOSM'),(52804299,'created_by','JOSM'),(52804736,'created_by','JOSM'),(52804739,'created_by','JOSM'),(52804766,'created_by','JOSM'),(52804772,'created_by','JOSM'),(52804776,'created_by','JOSM'),(52804777,'created_by','JOSM'),(52804778,'created_by','JOSM'),(52804779,'created_by','JOSM'),(52804780,'created_by','JOSM'),(52804788,'created_by','JOSM'),(52804791,'created_by','JOSM'),(52804795,'created_by','JOSM'),(52804796,'created_by','JOSM'),(52804798,'created_by','JOSM'),(52804801,'created_by','JOSM'),(52804803,'created_by','JOSM'),(52804805,'created_by','JOSM'),(52804807,'created_by','JOSM'),(52804809,'created_by','JOSM'),(52804811,'created_by','JOSM'),(52804813,'created_by','JOSM'),(52804815,'created_by','JOSM'),(52812261,'created_by','JOSM'),(52812263,'created_by','JOSM'),(52812266,'created_by','JOSM'),(52812268,'created_by','JOSM'),(52812270,'created_by','JOSM'),(52812274,'created_by','JOSM'),(52812277,'created_by','JOSM'),(52812281,'created_by','JOSM'),(52812284,'created_by','JOSM'),(52812288,'created_by','JOSM'),(52812291,'created_by','JOSM'),(52812295,'created_by','JOSM'),(52812296,'created_by','JOSM'),(52812299,'created_by','JOSM'),(52812303,'created_by','JOSM'),(52812305,'created_by','JOSM'),(52812309,'created_by','JOSM'),(52812311,'created_by','JOSM'),(52812315,'created_by','JOSM'),(52812318,'created_by','JOSM'),(52812321,'created_by','JOSM'),(52812323,'created_by','JOSM'),(52812326,'created_by','JOSM'),(52812329,'created_by','JOSM'),(52812331,'created_by','JOSM'),(52812333,'created_by','JOSM'),(52812335,'created_by','JOSM'),(52812338,'created_by','JOSM'),(52812341,'created_by','JOSM'),(52812343,'created_by','JOSM'),(52812347,'created_by','JOSM'),(52812350,'created_by','JOSM'),(52812353,'created_by','JOSM'),(52812356,'created_by','JOSM'),(52812360,'created_by','JOSM'),(52812363,'created_by','JOSM'),(52812365,'created_by','JOSM'),(52812366,'created_by','JOSM'),(52812367,'created_by','JOSM'),(52812369,'created_by','JOSM'),(52812372,'created_by','JOSM'),(52812376,'created_by','JOSM'),(52812379,'created_by','JOSM'),(52812380,'created_by','JOSM'),(52812383,'created_by','JOSM'),(52812385,'created_by','JOSM'),(52812387,'created_by','JOSM'),(52812389,'created_by','JOSM'),(52812391,'created_by','JOSM'),(52812395,'created_by','JOSM'),(52812397,'created_by','JOSM'),(52812399,'created_by','JOSM'),(52812403,'created_by','JOSM'),(52812405,'created_by','JOSM'),(52812406,'created_by','JOSM'),(52812407,'created_by','JOSM'),(52812409,'created_by','JOSM'),(52812410,'created_by','JOSM'),(52812411,'created_by','JOSM'),(52812413,'created_by','JOSM'),(52812414,'created_by','JOSM'),(52812415,'created_by','JOSM'),(52812417,'created_by','JOSM'),(52812418,'created_by','JOSM'),(52812421,'created_by','JOSM'),(52812425,'created_by','JOSM'),(52812428,'created_by','JOSM'),(52812440,'created_by','JOSM'),(52812444,'created_by','JOSM'),(52812447,'created_by','JOSM'),(52812450,'created_by','JOSM'),(52812453,'created_by','JOSM'),(52812457,'created_by','JOSM'),(52812460,'created_by','JOSM'),(52812464,'created_by','JOSM'),(52812468,'created_by','JOSM'),(52812472,'created_by','JOSM'),(52812475,'created_by','JOSM'),(52812478,'created_by','JOSM'),(52812481,'created_by','JOSM'),(52812485,'created_by','JOSM'),(52812487,'created_by','JOSM'),(52812491,'created_by','JOSM'),(52812494,'created_by','JOSM'),(52812497,'created_by','JOSM'),(52812501,'created_by','JOSM'),(52812505,'created_by','JOSM'),(52812507,'created_by','JOSM'),(52812511,'created_by','JOSM'),(52812514,'created_by','JOSM'),(52812517,'created_by','JOSM'),(52812520,'created_by','JOSM'),(52812522,'created_by','JOSM'),(52812526,'created_by','JOSM'),(52812530,'created_by','JOSM'),(52812531,'created_by','JOSM'),(52812534,'created_by','JOSM'),(52812536,'created_by','JOSM'),(52812537,'created_by','JOSM'),(52812540,'created_by','JOSM'),(52812541,'created_by','JOSM'),(52812543,'created_by','JOSM'),(52812545,'created_by','JOSM'),(52812547,'created_by','JOSM'),(52812549,'created_by','JOSM'),(52812551,'created_by','JOSM'),(52812553,'created_by','JOSM'),(52812555,'created_by','JOSM'),(52812558,'created_by','JOSM'),(52812562,'created_by','JOSM'),(52812564,'created_by','JOSM'),(52812566,'created_by','JOSM'),(52812569,'created_by','JOSM'),(52812572,'created_by','JOSM'),(52812574,'created_by','JOSM'),(52812577,'created_by','JOSM'),(52812580,'created_by','JOSM'),(52812582,'created_by','JOSM'),(52812585,'created_by','JOSM'),(52812587,'created_by','JOSM'),(52812590,'created_by','JOSM'),(52812592,'created_by','JOSM'),(52812595,'created_by','JOSM'),(52812597,'created_by','JOSM'),(52812598,'created_by','JOSM'),(52818308,'created_by','JOSM'),(52818311,'created_by','JOSM'),(52818312,'created_by','JOSM'),(52818315,'created_by','JOSM'),(52818317,'created_by','JOSM'),(52818320,'created_by','JOSM'),(52818322,'created_by','JOSM'),(52818324,'created_by','JOSM'),(52818326,'created_by','JOSM'),(52818330,'created_by','JOSM'),(52818332,'created_by','JOSM'),(52818334,'created_by','JOSM'),(52818337,'created_by','JOSM'),(52818340,'created_by','JOSM'),(52818343,'created_by','JOSM'),(52818346,'created_by','JOSM'),(52818348,'created_by','JOSM'),(52818350,'created_by','JOSM'),(52818352,'created_by','JOSM'),(52818355,'created_by','JOSM'),(52818358,'created_by','JOSM'),(52818362,'created_by','JOSM'),(52818365,'created_by','JOSM'),(52818368,'created_by','JOSM'),(52818370,'created_by','JOSM'),(52818373,'created_by','JOSM'),(52818377,'created_by','JOSM'),(52818379,'created_by','JOSM'),(52818382,'created_by','JOSM'),(52818384,'created_by','JOSM'),(52818385,'created_by','JOSM'),(52818387,'created_by','JOSM'),(52818389,'created_by','JOSM'),(52818390,'created_by','JOSM'),(52818391,'created_by','JOSM'),(52818392,'created_by','JOSM'),(52818393,'created_by','JOSM'),(52818394,'created_by','JOSM'),(52818396,'created_by','JOSM'),(52818397,'created_by','JOSM'),(52818398,'created_by','JOSM'),(52818399,'created_by','JOSM'),(52818402,'created_by','JOSM'),(52818404,'created_by','JOSM'),(52818405,'created_by','JOSM'),(52818406,'created_by','JOSM'),(52818407,'created_by','JOSM'),(52818409,'created_by','JOSM'),(52818413,'created_by','JOSM'),(52818415,'created_by','JOSM'),(52818417,'created_by','JOSM'),(52818420,'created_by','JOSM'),(52818424,'created_by','JOSM'),(52818427,'created_by','JOSM'),(52818428,'created_by','JOSM'),(52818432,'created_by','JOSM'),(52818434,'created_by','JOSM'),(52818437,'created_by','JOSM'),(52818440,'created_by','JOSM'),(52818441,'created_by','JOSM'),(52818445,'created_by','JOSM'),(52818446,'created_by','JOSM'),(52818448,'created_by','JOSM'),(52818450,'created_by','JOSM'),(52818451,'created_by','JOSM'),(52818452,'created_by','JOSM'),(52818453,'created_by','JOSM'),(52818454,'created_by','JOSM'),(52818455,'created_by','JOSM'),(52818456,'created_by','JOSM'),(52818457,'created_by','JOSM'),(52818458,'created_by','JOSM'),(52818461,'created_by','JOSM'),(52818463,'created_by','JOSM'),(52818465,'created_by','JOSM'),(52818470,'created_by','JOSM'),(52818472,'created_by','JOSM'),(52818475,'created_by','JOSM'),(52818478,'created_by','JOSM'),(52818479,'created_by','JOSM'),(52818483,'created_by','JOSM'),(52818485,'created_by','JOSM'),(52818487,'created_by','JOSM'),(52818489,'created_by','JOSM'),(52818490,'created_by','JOSM'),(52818491,'created_by','JOSM'),(52818493,'created_by','JOSM'),(52818495,'created_by','JOSM'),(52818498,'created_by','JOSM'),(52818501,'created_by','JOSM'),(52818503,'created_by','JOSM'),(52818505,'created_by','JOSM'),(52818508,'created_by','JOSM'),(52818511,'created_by','JOSM'),(52818514,'created_by','JOSM'),(52818516,'created_by','JOSM'),(52818518,'created_by','JOSM'),(52818520,'created_by','JOSM'),(52818522,'created_by','JOSM'),(52818524,'created_by','JOSM'),(52818527,'created_by','JOSM'),(52818529,'created_by','JOSM'),(52818533,'created_by','JOSM'),(52818536,'created_by','JOSM'),(52818538,'created_by','JOSM'),(52818539,'created_by','JOSM'),(52818542,'created_by','JOSM'),(52818550,'created_by','JOSM'),(52818553,'created_by','JOSM'),(52818555,'created_by','JOSM'),(52818557,'created_by','JOSM'),(52818561,'created_by','JOSM'),(52818563,'created_by','JOSM'),(52818564,'created_by','JOSM'),(52818566,'created_by','JOSM'),(52818567,'created_by','JOSM'),(52818569,'created_by','JOSM'),(52818572,'created_by','JOSM'),(52818574,'created_by','JOSM'),(52818577,'created_by','JOSM'),(52818581,'created_by','JOSM'),(52818582,'created_by','JOSM'),(52818585,'created_by','JOSM'),(52818587,'created_by','JOSM'),(52818590,'created_by','JOSM'),(52818592,'created_by','JOSM'),(52818594,'created_by','JOSM'),(52818598,'created_by','JOSM'),(52818600,'created_by','JOSM'),(52818603,'created_by','JOSM'),(52818605,'created_by','JOSM'),(52818609,'created_by','JOSM'),(52818612,'created_by','JOSM'),(52818615,'created_by','JOSM'),(52818618,'created_by','JOSM'),(52818620,'created_by','JOSM'),(52818622,'created_by','JOSM'),(52818623,'created_by','JOSM'),(52818627,'created_by','JOSM'),(52818629,'created_by','JOSM'),(52818631,'created_by','JOSM'),(52818633,'created_by','JOSM'),(52818635,'created_by','JOSM'),(52818636,'created_by','JOSM'),(52818639,'created_by','JOSM'),(52818641,'created_by','JOSM'),(52818642,'created_by','JOSM'),(52818644,'created_by','JOSM'),(52818647,'created_by','JOSM'),(52818648,'created_by','JOSM'),(52818651,'created_by','JOSM'),(52818652,'created_by','JOSM'),(52818655,'created_by','JOSM'),(52818657,'created_by','JOSM'),(52818659,'created_by','JOSM'),(52818661,'created_by','JOSM'),(52818663,'created_by','JOSM'),(52818669,'created_by','JOSM'),(52818671,'created_by','JOSM'),(52818673,'created_by','JOSM'),(52818675,'created_by','JOSM'),(52818677,'created_by','JOSM'),(52818679,'created_by','JOSM'),(52818681,'created_by','JOSM'),(52818685,'created_by','JOSM'),(52818687,'created_by','JOSM'),(52818690,'created_by','JOSM'),(52818692,'created_by','JOSM'),(52818694,'created_by','JOSM'),(52818720,'created_by','JOSM'),(52818722,'created_by','JOSM'),(52818724,'created_by','JOSM'),(52818727,'created_by','JOSM'),(52818729,'created_by','JOSM'),(52818731,'created_by','JOSM'),(52818733,'created_by','JOSM'),(52818747,'created_by','JOSM'),(52818757,'created_by','JOSM'),(52818771,'created_by','JOSM'),(52818775,'created_by','JOSM'),(52818781,'created_by','JOSM'),(52818791,'created_by','JOSM'),(52818794,'created_by','JOSM'),(52818796,'created_by','JOSM'),(52818800,'created_by','JOSM'),(52818803,'created_by','JOSM'),(52818808,'created_by','JOSM'),(52818809,'created_by','JOSM'),(52818810,'created_by','JOSM'),(52818812,'created_by','JOSM'),(52818813,'created_by','JOSM'),(52818824,'created_by','JOSM'),(52818840,'created_by','JOSM'),(52818846,'created_by','JOSM'),(52818850,'created_by','JOSM'),(52818853,'created_by','JOSM'),(52818857,'created_by','JOSM'),(52818862,'created_by','JOSM'),(52818864,'created_by','JOSM'),(52818867,'created_by','JOSM'),(52818870,'created_by','JOSM'),(52818872,'created_by','JOSM'),(52818874,'created_by','JOSM'),(52818876,'created_by','JOSM'),(52818878,'created_by','JOSM'),(52818879,'created_by','JOSM'),(52818881,'created_by','JOSM'),(52818884,'created_by','JOSM'),(52824397,'created_by','JOSM'),(52824401,'created_by','JOSM'),(52824404,'created_by','JOSM'),(52824407,'created_by','JOSM'),(52824410,'created_by','JOSM'),(52824414,'created_by','JOSM'),(52824418,'created_by','JOSM'),(52824420,'created_by','JOSM'),(52824423,'created_by','JOSM'),(52824433,'created_by','JOSM'),(52824446,'created_by','JOSM'),(52824449,'created_by','JOSM'),(52824464,'created_by','JOSM'),(52824474,'created_by','JOSM'),(52824478,'created_by','JOSM'),(52824483,'created_by','JOSM'),(52824486,'created_by','JOSM'),(52824489,'created_by','JOSM'),(52824491,'created_by','JOSM'),(52824494,'created_by','JOSM'),(52824496,'created_by','JOSM'),(52824499,'created_by','JOSM'),(52824502,'created_by','JOSM'),(52824509,'created_by','JOSM'),(52824529,'created_by','JOSM'),(52824530,'created_by','JOSM'),(52824533,'created_by','JOSM'),(52824535,'created_by','JOSM'),(52824538,'created_by','JOSM'),(52824541,'created_by','JOSM'),(52824544,'created_by','JOSM'),(52824546,'created_by','JOSM'),(52824548,'created_by','JOSM'),(52824552,'created_by','JOSM'),(52824553,'created_by','JOSM'),(52824558,'created_by','JOSM'),(52824561,'created_by','JOSM'),(52824564,'created_by','JOSM'),(52824567,'created_by','JOSM'),(52824569,'created_by','JOSM'),(52824574,'created_by','JOSM'),(52824576,'created_by','JOSM'),(52824579,'created_by','JOSM'),(52824581,'created_by','JOSM'),(52824584,'created_by','JOSM'),(52824586,'created_by','JOSM'),(52824949,'created_by','JOSM'),(52824952,'created_by','JOSM'),(52824953,'created_by','JOSM'),(52824954,'created_by','JOSM'),(52824955,'created_by','JOSM'),(52831541,'created_by','JOSM'),(52831545,'created_by','JOSM'),(52831548,'created_by','JOSM'),(52831550,'created_by','JOSM'),(52831552,'created_by','JOSM'),(52831554,'created_by','JOSM'),(52831559,'created_by','JOSM'),(52831563,'created_by','JOSM'),(52831566,'created_by','JOSM'),(52831569,'created_by','JOSM'),(52831574,'created_by','JOSM'),(52831577,'created_by','JOSM'),(52831582,'created_by','JOSM'),(52831585,'created_by','JOSM'),(52831588,'created_by','JOSM'),(52831590,'created_by','JOSM'),(52831593,'created_by','JOSM'),(52831595,'created_by','JOSM'),(52831598,'created_by','JOSM'),(52831601,'created_by','JOSM'),(52831603,'created_by','JOSM'),(52831605,'created_by','JOSM'),(52831608,'created_by','JOSM'),(52831611,'created_by','JOSM'),(52831613,'created_by','JOSM'),(52831614,'created_by','JOSM'),(52831615,'created_by','JOSM'),(52831616,'created_by','JOSM'),(52831617,'created_by','JOSM'),(52831618,'created_by','JOSM'),(52831619,'created_by','JOSM'),(52831621,'created_by','JOSM'),(52831641,'created_by','JOSM'),(52831644,'created_by','JOSM'),(52832041,'created_by','JOSM'),(52832042,'created_by','JOSM'),(52832043,'created_by','JOSM'),(52832044,'created_by','JOSM'),(52832045,'created_by','JOSM'),(52832046,'created_by','JOSM'),(52832047,'created_by','JOSM'),(52832471,'created_by','JOSM'),(52834371,'created_by','JOSM'),(52834531,'created_by','JOSM'),(52834678,'created_by','JOSM'),(52834735,'created_by','JOSM'),(52834737,'created_by','JOSM'),(52834749,'created_by','JOSM'),(52834758,'created_by','JOSM'),(52834763,'created_by','JOSM'),(52834768,'created_by','JOSM'),(52834775,'created_by','JOSM'),(52834778,'created_by','JOSM'),(52834779,'created_by','JOSM'),(52834783,'created_by','JOSM'),(52834784,'created_by','JOSM'),(52834785,'created_by','JOSM'),(52834786,'created_by','JOSM'),(52834787,'created_by','JOSM'),(52834788,'created_by','JOSM'),(52834790,'created_by','JOSM'),(52834792,'created_by','JOSM'),(52834794,'created_by','JOSM'),(52834795,'created_by','JOSM'),(52834797,'created_by','JOSM'),(52834799,'created_by','JOSM'),(52834802,'created_by','JOSM'),(52834805,'created_by','JOSM'),(52834808,'created_by','JOSM'),(52834811,'created_by','JOSM'),(52834813,'created_by','JOSM'),(52834816,'created_by','JOSM'),(52834819,'created_by','JOSM'),(52834822,'created_by','JOSM'),(52834825,'created_by','JOSM'),(52835977,'created_by','JOSM'),(52835980,'created_by','JOSM'),(52835984,'created_by','JOSM'),(52835987,'created_by','JOSM'),(52836001,'created_by','JOSM'),(52836004,'created_by','JOSM'),(52836007,'created_by','JOSM'),(52836010,'created_by','JOSM'),(52836012,'created_by','JOSM'),(52836016,'created_by','JOSM'),(52836020,'created_by','JOSM'),(52836023,'created_by','JOSM'),(52836027,'created_by','JOSM'),(52836030,'created_by','JOSM'),(52836034,'created_by','JOSM'),(52836036,'created_by','JOSM'),(52836038,'created_by','JOSM'),(52836042,'created_by','JOSM'),(52836044,'created_by','JOSM'),(52836048,'created_by','JOSM'),(52836052,'created_by','JOSM'),(52836056,'created_by','JOSM'),(52836058,'created_by','JOSM'),(52836061,'created_by','JOSM'),(52836065,'created_by','JOSM'),(52836069,'created_by','JOSM'),(52836073,'created_by','JOSM'),(53273667,'created_by','JOSM'),(53273668,'created_by','JOSM'),(53273669,'created_by','JOSM'),(53273670,'created_by','JOSM'),(53273671,'created_by','JOSM'),(53273672,'created_by','JOSM'),(53273673,'created_by','JOSM'),(53273674,'created_by','JOSM'),(53273675,'created_by','JOSM'),(53273676,'created_by','JOSM'),(53273677,'created_by','JOSM'),(53273678,'created_by','JOSM'),(53273679,'created_by','JOSM'),(53273680,'created_by','JOSM'),(53273681,'created_by','JOSM'),(53273682,'created_by','JOSM'),(53273683,'created_by','JOSM'),(53273684,'created_by','JOSM');
INSERT INTO `current_node_tags` VALUES (53273685,'created_by','JOSM'),(53273686,'created_by','JOSM'),(53273687,'created_by','JOSM'),(53273688,'created_by','JOSM'),(53273689,'created_by','JOSM'),(53273690,'created_by','JOSM'),(53273691,'created_by','JOSM'),(53273692,'created_by','JOSM'),(53273693,'created_by','JOSM'),(53273694,'created_by','JOSM'),(53273695,'created_by','JOSM'),(53273696,'created_by','JOSM'),(53273697,'created_by','JOSM'),(53273698,'created_by','JOSM'),(53273699,'created_by','JOSM'),(53273700,'created_by','JOSM'),(53273701,'created_by','JOSM'),(53273702,'created_by','JOSM'),(53273703,'created_by','JOSM'),(53273704,'created_by','JOSM'),(53273705,'created_by','JOSM'),(53273706,'created_by','JOSM'),(53273707,'created_by','JOSM'),(53273708,'created_by','JOSM'),(53273709,'created_by','JOSM'),(53273710,'created_by','JOSM'),(53273711,'created_by','JOSM'),(53273712,'created_by','JOSM'),(53273713,'created_by','JOSM'),(53273714,'created_by','JOSM'),(53273715,'created_by','JOSM'),(53273716,'created_by','JOSM'),(53273719,'created_by','JOSM'),(53273723,'created_by','JOSM'),(53273724,'created_by','JOSM'),(53273725,'created_by','JOSM'),(53273726,'created_by','JOSM'),(53273727,'created_by','JOSM'),(53273728,'created_by','JOSM'),(53273729,'created_by','JOSM'),(53273730,'created_by','JOSM'),(53273731,'created_by','JOSM'),(53273732,'created_by','JOSM'),(53273733,'created_by','JOSM'),(53273734,'created_by','JOSM'),(53273735,'created_by','JOSM'),(53273736,'created_by','JOSM'),(53273737,'created_by','JOSM'),(53273738,'created_by','JOSM'),(53273739,'created_by','JOSM'),(53273740,'created_by','JOSM'),(53273741,'created_by','JOSM'),(53273742,'created_by','JOSM'),(53273743,'created_by','JOSM'),(53273744,'created_by','JOSM'),(53273745,'created_by','JOSM'),(53273746,'created_by','JOSM'),(53273747,'created_by','JOSM'),(53273748,'created_by','JOSM'),(53273749,'created_by','JOSM'),(53273750,'created_by','JOSM'),(53273751,'created_by','JOSM'),(53273752,'created_by','JOSM'),(53273753,'created_by','JOSM'),(53273754,'created_by','JOSM'),(53273755,'created_by','JOSM'),(53273756,'created_by','JOSM'),(53273757,'created_by','JOSM'),(53273758,'created_by','JOSM'),(53273759,'created_by','JOSM'),(53273760,'created_by','JOSM'),(53273761,'created_by','JOSM'),(53273762,'created_by','JOSM'),(53273763,'created_by','JOSM'),(53273764,'created_by','JOSM'),(53273765,'created_by','JOSM'),(53273766,'created_by','JOSM'),(53273767,'created_by','JOSM'),(53273768,'created_by','JOSM'),(53273769,'created_by','JOSM'),(53273770,'created_by','JOSM'),(53273771,'created_by','JOSM'),(53273772,'created_by','JOSM'),(53273773,'created_by','JOSM'),(53273774,'created_by','JOSM'),(53273775,'created_by','JOSM'),(53273776,'created_by','JOSM'),(53273777,'created_by','JOSM'),(53273778,'created_by','JOSM'),(53273779,'created_by','JOSM'),(53273780,'created_by','JOSM'),(53273781,'created_by','JOSM'),(53273782,'created_by','JOSM'),(53273783,'created_by','JOSM'),(53273784,'created_by','JOSM'),(53273785,'created_by','JOSM'),(53273786,'created_by','JOSM'),(53273787,'created_by','JOSM'),(53273788,'created_by','JOSM'),(53273789,'created_by','JOSM'),(53273790,'created_by','JOSM'),(53273791,'created_by','JOSM'),(53273792,'created_by','JOSM'),(53273793,'created_by','JOSM'),(53273794,'created_by','JOSM'),(53273795,'created_by','JOSM'),(53273796,'created_by','JOSM'),(53273797,'created_by','JOSM'),(53273798,'created_by','JOSM'),(53273799,'created_by','JOSM'),(53273800,'created_by','JOSM'),(53273801,'created_by','JOSM'),(53273802,'created_by','JOSM'),(53273803,'created_by','JOSM'),(53273804,'created_by','JOSM'),(53273805,'created_by','JOSM'),(53273806,'created_by','JOSM'),(53273807,'created_by','JOSM'),(53273808,'created_by','JOSM'),(53273810,'created_by','JOSM'),(53273811,'created_by','JOSM'),(53273812,'created_by','JOSM'),(53273813,'created_by','JOSM'),(53273814,'created_by','JOSM'),(53273815,'created_by','JOSM'),(53273816,'created_by','JOSM'),(53273817,'created_by','JOSM'),(53273818,'created_by','JOSM'),(53273819,'created_by','JOSM'),(53273820,'created_by','JOSM'),(53273821,'created_by','JOSM'),(53273822,'created_by','JOSM'),(53273823,'created_by','JOSM'),(53273824,'created_by','JOSM'),(53273825,'created_by','JOSM'),(53273826,'created_by','JOSM'),(53273827,'created_by','JOSM'),(53273828,'created_by','JOSM'),(53273829,'created_by','JOSM'),(53273830,'created_by','JOSM'),(53273831,'created_by','JOSM'),(53273832,'created_by','JOSM'),(53273833,'created_by','JOSM'),(53273834,'created_by','JOSM'),(53273836,'created_by','JOSM'),(53273838,'created_by','JOSM'),(53273839,'created_by','JOSM'),(53273841,'created_by','JOSM'),(53273843,'created_by','JOSM'),(53273844,'created_by','JOSM'),(53273846,'created_by','JOSM'),(53273848,'created_by','JOSM'),(53273849,'created_by','JOSM'),(53273851,'created_by','JOSM'),(53273852,'created_by','JOSM'),(53273853,'created_by','JOSM'),(53273854,'created_by','JOSM'),(53273855,'created_by','JOSM'),(53273856,'created_by','JOSM'),(53273857,'created_by','JOSM'),(53273858,'created_by','JOSM'),(53273859,'created_by','JOSM'),(53273860,'created_by','JOSM'),(53273861,'created_by','JOSM'),(53273862,'created_by','JOSM'),(53273863,'created_by','JOSM'),(53273864,'created_by','JOSM'),(53273865,'created_by','JOSM'),(53273866,'created_by','JOSM'),(53273867,'created_by','JOSM'),(53273868,'created_by','JOSM'),(53273869,'created_by','JOSM'),(53273870,'created_by','JOSM'),(53273871,'created_by','JOSM'),(53273872,'created_by','JOSM'),(53273873,'created_by','JOSM'),(53273874,'created_by','JOSM'),(53273875,'created_by','JOSM'),(53273876,'created_by','JOSM'),(53273877,'created_by','JOSM'),(53273878,'created_by','JOSM'),(53273879,'created_by','JOSM'),(53273880,'created_by','JOSM'),(53273881,'created_by','JOSM'),(53273882,'created_by','JOSM'),(53273883,'created_by','JOSM'),(53273884,'created_by','JOSM'),(53273885,'created_by','JOSM'),(53273886,'created_by','JOSM'),(53273887,'created_by','JOSM'),(53273888,'created_by','JOSM'),(53273889,'created_by','JOSM'),(53273890,'created_by','JOSM'),(53273891,'created_by','JOSM'),(53273892,'created_by','JOSM'),(53273893,'created_by','JOSM'),(53273894,'created_by','JOSM'),(53273895,'created_by','JOSM'),(53273896,'created_by','JOSM'),(53273897,'created_by','JOSM'),(53273898,'created_by','JOSM'),(53273899,'created_by','JOSM'),(53273900,'created_by','JOSM'),(53273901,'created_by','JOSM'),(53273902,'created_by','JOSM'),(53273903,'created_by','JOSM'),(53273904,'created_by','JOSM'),(53273905,'created_by','JOSM'),(53273906,'created_by','JOSM'),(53273907,'created_by','JOSM'),(53273908,'created_by','JOSM'),(53273909,'created_by','JOSM'),(53273910,'created_by','JOSM'),(53273911,'created_by','JOSM'),(53273912,'created_by','JOSM'),(53273913,'created_by','JOSM'),(53273914,'created_by','JOSM'),(53273915,'created_by','JOSM'),(53273916,'created_by','JOSM'),(53273917,'created_by','JOSM'),(53273918,'created_by','JOSM'),(53273919,'created_by','JOSM'),(53273920,'created_by','JOSM'),(53273921,'created_by','JOSM'),(53273922,'created_by','JOSM'),(53273923,'created_by','JOSM'),(53273924,'created_by','JOSM'),(53273925,'created_by','JOSM'),(53273926,'created_by','JOSM'),(53273927,'created_by','JOSM'),(53273928,'created_by','JOSM'),(53273929,'created_by','JOSM'),(53273930,'created_by','JOSM'),(53273931,'created_by','JOSM'),(53273932,'created_by','JOSM'),(53273933,'created_by','JOSM'),(53273934,'created_by','JOSM'),(53273935,'created_by','JOSM'),(53273936,'created_by','JOSM'),(53273937,'created_by','JOSM'),(53273938,'created_by','JOSM'),(53273939,'created_by','JOSM'),(53273940,'created_by','JOSM'),(53273941,'created_by','JOSM'),(53273942,'created_by','JOSM'),(53273943,'created_by','JOSM'),(53273944,'created_by','JOSM'),(53273945,'created_by','JOSM'),(53273946,'created_by','JOSM'),(53273947,'created_by','JOSM'),(53273948,'created_by','JOSM'),(53273949,'created_by','JOSM'),(53273950,'created_by','JOSM'),(53273951,'created_by','JOSM'),(53273952,'created_by','JOSM'),(53273953,'created_by','JOSM'),(53273954,'created_by','JOSM'),(53273955,'created_by','JOSM'),(53273956,'created_by','JOSM'),(53273957,'created_by','JOSM'),(53273958,'created_by','JOSM'),(53273959,'created_by','JOSM'),(53273960,'created_by','JOSM'),(53273961,'created_by','JOSM'),(53273962,'created_by','JOSM'),(53273963,'created_by','JOSM'),(53273964,'created_by','JOSM'),(53273965,'created_by','JOSM'),(53273966,'created_by','JOSM'),(53273967,'created_by','JOSM'),(53273968,'created_by','JOSM'),(53273969,'created_by','JOSM'),(53273970,'created_by','JOSM'),(53273971,'created_by','JOSM'),(53273972,'created_by','JOSM'),(53273973,'created_by','JOSM'),(53273974,'created_by','JOSM'),(53273975,'created_by','JOSM'),(53273976,'created_by','JOSM'),(53273977,'created_by','JOSM'),(53273978,'created_by','JOSM'),(53273979,'created_by','JOSM'),(53273980,'created_by','JOSM'),(53273981,'created_by','JOSM'),(53273982,'created_by','JOSM'),(53273983,'created_by','JOSM'),(53273984,'created_by','JOSM'),(53273985,'created_by','JOSM'),(53273986,'created_by','JOSM'),(53273987,'created_by','JOSM'),(53273988,'created_by','JOSM'),(53273989,'created_by','JOSM'),(53273990,'created_by','JOSM'),(53273991,'created_by','JOSM'),(53273992,'created_by','JOSM'),(53273993,'created_by','JOSM'),(53273994,'created_by','JOSM'),(53273995,'created_by','JOSM'),(53273996,'created_by','JOSM'),(53273997,'created_by','JOSM'),(53273998,'created_by','JOSM'),(53274000,'created_by','JOSM'),(53274002,'created_by','JOSM'),(53274003,'created_by','JOSM'),(53274004,'created_by','JOSM'),(53274005,'created_by','JOSM'),(53274006,'created_by','JOSM'),(53274007,'created_by','JOSM'),(53274008,'created_by','JOSM'),(53274009,'created_by','JOSM'),(53274010,'created_by','JOSM'),(53274011,'created_by','JOSM'),(53274012,'created_by','JOSM'),(53274013,'created_by','JOSM'),(53274014,'created_by','JOSM'),(53274015,'created_by','JOSM'),(53274016,'created_by','JOSM'),(53274017,'created_by','JOSM'),(53274018,'created_by','JOSM'),(53274019,'created_by','JOSM'),(53274020,'created_by','JOSM'),(53274021,'created_by','JOSM'),(53274022,'created_by','JOSM'),(53274023,'created_by','JOSM'),(53274024,'created_by','JOSM'),(53274025,'created_by','JOSM'),(53274026,'created_by','JOSM'),(53274027,'created_by','JOSM'),(53274028,'created_by','JOSM'),(53274029,'created_by','JOSM'),(53274030,'created_by','JOSM'),(53274031,'created_by','JOSM'),(53274883,'created_by','JOSM'),(53274884,'created_by','JOSM'),(53274885,'created_by','JOSM'),(53274886,'created_by','JOSM'),(53274888,'created_by','JOSM'),(53274890,'created_by','JOSM'),(53274891,'created_by','JOSM'),(53274892,'created_by','JOSM'),(53274893,'created_by','JOSM'),(53274894,'created_by','JOSM'),(53274895,'created_by','JOSM'),(53274896,'created_by','JOSM'),(53274898,'created_by','JOSM'),(53274899,'created_by','JOSM'),(53274900,'created_by','JOSM'),(53274901,'created_by','JOSM'),(53274902,'created_by','JOSM'),(53274903,'created_by','JOSM'),(53274904,'created_by','JOSM'),(53274906,'created_by','JOSM'),(53274907,'created_by','JOSM'),(53274908,'created_by','JOSM'),(53274909,'created_by','JOSM'),(53274910,'created_by','JOSM'),(53274911,'created_by','JOSM'),(53274912,'created_by','JOSM'),(53274913,'created_by','JOSM'),(53274915,'created_by','JOSM'),(53274916,'created_by','JOSM'),(53274917,'created_by','JOSM'),(53274918,'created_by','JOSM'),(53274919,'created_by','JOSM'),(53274920,'created_by','JOSM'),(53274921,'created_by','JOSM'),(53274922,'created_by','JOSM'),(53274924,'created_by','JOSM'),(53274925,'created_by','JOSM'),(53274926,'created_by','JOSM'),(53274927,'created_by','JOSM'),(53274928,'created_by','JOSM'),(53274929,'created_by','JOSM'),(53274931,'created_by','JOSM'),(53274932,'created_by','JOSM'),(53274933,'created_by','JOSM'),(53274934,'created_by','JOSM'),(53274935,'created_by','JOSM'),(53274936,'created_by','JOSM'),(53274937,'created_by','JOSM'),(53274939,'created_by','JOSM'),(53274940,'created_by','JOSM'),(53274941,'created_by','JOSM'),(53274942,'created_by','JOSM'),(53274943,'created_by','JOSM'),(53274944,'created_by','JOSM'),(53274946,'created_by','JOSM'),(53274947,'created_by','JOSM'),(53274948,'created_by','JOSM'),(53274949,'created_by','JOSM'),(53274950,'created_by','JOSM'),(53274951,'created_by','JOSM'),(53274952,'created_by','JOSM'),(53274954,'created_by','JOSM'),(53274955,'created_by','JOSM'),(53274956,'created_by','JOSM'),(53274957,'created_by','JOSM'),(53274958,'created_by','JOSM'),(53274959,'created_by','JOSM'),(53274960,'created_by','JOSM'),(53274961,'created_by','JOSM'),(53274963,'created_by','JOSM'),(53274964,'created_by','JOSM'),(53274965,'created_by','JOSM'),(53274966,'created_by','JOSM'),(53274967,'created_by','JOSM'),(53274972,'created_by','JOSM'),(53274973,'created_by','JOSM'),(53274974,'created_by','JOSM'),(53274976,'created_by','JOSM'),(53274977,'created_by','JOSM'),(53274978,'created_by','JOSM'),(53274979,'created_by','JOSM'),(53274980,'created_by','JOSM'),(53274981,'created_by','JOSM'),(53274983,'created_by','JOSM'),(53274984,'created_by','JOSM'),(53274985,'created_by','JOSM'),(53274986,'created_by','JOSM'),(53274987,'created_by','JOSM'),(53274988,'created_by','JOSM'),(53274989,'created_by','JOSM'),(53274990,'created_by','JOSM'),(53274991,'created_by','JOSM'),(53274992,'created_by','JOSM'),(53274993,'created_by','JOSM'),(53274995,'created_by','JOSM'),(53274996,'created_by','JOSM'),(53274997,'created_by','JOSM'),(53274998,'created_by','JOSM'),(53274999,'created_by','JOSM'),(53275001,'created_by','JOSM'),(53275002,'created_by','JOSM'),(53275003,'created_by','JOSM'),(53275004,'created_by','JOSM'),(53275005,'created_by','JOSM'),(53275006,'created_by','JOSM'),(53275008,'created_by','JOSM'),(53275009,'created_by','JOSM'),(53275010,'created_by','JOSM'),(53275011,'created_by','JOSM'),(53275012,'created_by','JOSM'),(53275014,'created_by','JOSM'),(53275015,'created_by','JOSM'),(53275016,'created_by','JOSM'),(53275017,'created_by','JOSM'),(53275018,'created_by','JOSM'),(53275019,'created_by','JOSM'),(53275020,'created_by','JOSM'),(53275022,'created_by','JOSM'),(53275023,'created_by','JOSM'),(53275024,'created_by','JOSM'),(53275034,'created_by','JOSM'),(53275035,'created_by','JOSM'),(53275036,'created_by','JOSM'),(53275038,'created_by','JOSM'),(53275039,'created_by','JOSM'),(53275040,'created_by','JOSM'),(53275506,'created_by','JOSM'),(53275507,'created_by','JOSM'),(53275508,'created_by','JOSM'),(53275510,'created_by','JOSM'),(53275511,'created_by','JOSM'),(53275512,'created_by','JOSM'),(53275514,'created_by','JOSM'),(53275515,'created_by','JOSM'),(53275516,'created_by','JOSM'),(53275517,'created_by','JOSM'),(53275518,'created_by','JOSM'),(53275519,'created_by','JOSM'),(53275520,'created_by','JOSM'),(53275521,'created_by','JOSM'),(53275522,'created_by','JOSM'),(53275523,'created_by','JOSM'),(53275524,'created_by','JOSM'),(53275525,'created_by','JOSM'),(53275526,'created_by','JOSM'),(53275527,'created_by','JOSM'),(53275528,'created_by','JOSM'),(53275529,'created_by','JOSM'),(53275530,'created_by','JOSM'),(53275531,'created_by','JOSM'),(53275533,'created_by','JOSM'),(53275534,'created_by','JOSM'),(53275535,'created_by','JOSM'),(53275536,'created_by','JOSM'),(53275537,'created_by','JOSM'),(53275538,'created_by','JOSM'),(53275539,'created_by','JOSM'),(53275540,'created_by','JOSM'),(53275541,'created_by','JOSM'),(53275542,'created_by','JOSM'),(53275543,'created_by','JOSM'),(53275544,'created_by','JOSM'),(53275545,'created_by','JOSM'),(53275546,'created_by','JOSM'),(53275547,'created_by','JOSM'),(53275548,'created_by','JOSM'),(53275549,'created_by','JOSM'),(53275550,'created_by','JOSM'),(53275551,'created_by','JOSM'),(53275552,'created_by','JOSM'),(53275554,'created_by','JOSM'),(53275555,'created_by','JOSM'),(53275556,'created_by','JOSM'),(53275557,'created_by','JOSM'),(53275558,'created_by','JOSM'),(53275559,'created_by','JOSM'),(53275560,'created_by','JOSM'),(53275561,'created_by','JOSM'),(53275562,'created_by','JOSM'),(53275563,'created_by','JOSM'),(53275565,'created_by','JOSM'),(53275567,'created_by','JOSM'),(53275568,'created_by','JOSM'),(53275569,'created_by','JOSM'),(53275570,'created_by','JOSM'),(53275572,'created_by','JOSM'),(53275573,'created_by','JOSM'),(53275574,'created_by','JOSM'),(53275575,'created_by','JOSM'),(53275576,'created_by','JOSM'),(53275577,'created_by','JOSM'),(53275578,'created_by','JOSM'),(53275579,'created_by','JOSM'),(53275580,'created_by','JOSM'),(53275581,'created_by','JOSM'),(53275582,'created_by','JOSM'),(53275583,'created_by','JOSM'),(53275584,'created_by','JOSM'),(53275585,'created_by','JOSM'),(53275586,'created_by','JOSM'),(53275587,'created_by','JOSM'),(53275588,'created_by','JOSM'),(53275589,'created_by','JOSM'),(53275590,'created_by','JOSM'),(53275591,'created_by','JOSM'),(53275592,'created_by','JOSM'),(53275593,'created_by','JOSM'),(53275594,'created_by','JOSM'),(53275595,'created_by','JOSM'),(53275596,'created_by','JOSM'),(53275597,'created_by','JOSM'),(53275598,'created_by','JOSM'),(53275599,'created_by','JOSM'),(53275600,'created_by','JOSM'),(53275601,'created_by','JOSM'),(53275602,'created_by','JOSM'),(53275603,'created_by','JOSM'),(53275604,'created_by','JOSM'),(53275605,'created_by','JOSM'),(53275606,'created_by','JOSM'),(53275607,'created_by','JOSM'),(53275608,'created_by','JOSM'),(53275609,'created_by','JOSM'),(53275610,'created_by','JOSM'),(53275611,'created_by','JOSM'),(53275612,'created_by','JOSM'),(53275613,'created_by','JOSM'),(53275614,'created_by','JOSM'),(53275615,'created_by','JOSM'),(53275616,'created_by','JOSM'),(53275617,'created_by','JOSM'),(53275618,'created_by','JOSM'),(53275619,'created_by','JOSM'),(53275620,'created_by','JOSM'),(53275621,'created_by','JOSM'),(53275622,'created_by','JOSM'),(53275623,'created_by','JOSM'),(53275624,'created_by','JOSM'),(53275625,'created_by','JOSM'),(53275626,'created_by','JOSM'),(53275627,'created_by','JOSM'),(53275628,'created_by','JOSM'),(53275629,'created_by','JOSM'),(53275630,'created_by','JOSM'),(53275631,'created_by','JOSM'),(53275632,'created_by','JOSM'),(53275633,'created_by','JOSM'),(53275634,'created_by','JOSM'),(53275635,'created_by','JOSM'),(53275636,'created_by','JOSM'),(53275637,'created_by','JOSM'),(53275638,'created_by','JOSM'),(53275639,'created_by','JOSM'),(53275640,'created_by','JOSM'),(53275642,'created_by','JOSM'),(53275643,'created_by','JOSM'),(53275644,'created_by','JOSM'),(53275645,'created_by','JOSM'),(53275646,'created_by','JOSM'),(53275647,'created_by','JOSM'),(53275648,'created_by','JOSM'),(53275649,'created_by','JOSM'),(53275650,'created_by','JOSM'),(53275651,'created_by','JOSM'),(53275652,'created_by','JOSM'),(53275653,'created_by','JOSM'),(53275654,'created_by','JOSM'),(53275655,'created_by','JOSM'),(53275656,'created_by','JOSM'),(53275657,'created_by','JOSM'),(53275658,'created_by','JOSM'),(53275659,'created_by','JOSM'),(53275660,'created_by','JOSM'),(53275661,'created_by','JOSM'),(53275662,'created_by','JOSM'),(53275663,'created_by','JOSM'),(53275664,'created_by','JOSM'),(53275665,'created_by','JOSM'),(53275666,'created_by','JOSM'),(53275667,'created_by','JOSM'),(53275668,'created_by','JOSM'),(53275669,'created_by','JOSM'),(53275670,'created_by','JOSM'),(53277160,'created_by','JOSM'),(53277161,'created_by','JOSM'),(53277162,'created_by','JOSM'),(53277163,'created_by','JOSM'),(53277164,'created_by','JOSM'),(53277165,'created_by','JOSM'),(53277166,'created_by','JOSM'),(53277167,'created_by','JOSM'),(53277168,'created_by','JOSM'),(53277169,'created_by','JOSM'),(53277170,'created_by','JOSM'),(53277171,'created_by','JOSM'),(53277172,'created_by','JOSM'),(53277173,'created_by','JOSM'),(53277174,'created_by','JOSM'),(53277175,'created_by','JOSM'),(53277176,'created_by','JOSM'),(53277177,'created_by','JOSM'),(53277178,'created_by','JOSM'),(53277179,'created_by','JOSM'),(53277180,'created_by','JOSM'),(53277181,'created_by','JOSM'),(53277182,'created_by','JOSM'),(53277183,'created_by','JOSM'),(53277184,'created_by','JOSM'),(53277185,'created_by','JOSM'),(53277186,'created_by','JOSM'),(53277187,'created_by','JOSM'),(53277189,'created_by','JOSM'),(53277190,'created_by','JOSM'),(53277191,'created_by','JOSM'),(53277192,'created_by','JOSM'),(53277193,'created_by','JOSM'),(53277194,'created_by','JOSM'),(53277195,'created_by','JOSM'),(53277196,'created_by','JOSM'),(53277197,'created_by','JOSM'),(53277198,'created_by','JOSM'),(53277199,'created_by','JOSM'),(53277200,'created_by','JOSM'),(53277201,'created_by','JOSM'),(53277202,'created_by','JOSM'),(53277203,'created_by','JOSM'),(53277204,'created_by','JOSM'),(53277205,'created_by','JOSM'),(53277206,'created_by','JOSM'),(53277207,'created_by','JOSM'),(53277208,'created_by','JOSM'),(53277209,'created_by','JOSM'),(53277210,'created_by','JOSM'),(53277211,'created_by','JOSM'),(53277212,'created_by','JOSM'),(53277213,'created_by','JOSM'),(53277214,'created_by','JOSM'),(53277215,'created_by','JOSM'),(53277216,'created_by','JOSM'),(53277217,'created_by','JOSM'),(53277218,'created_by','JOSM'),(53277219,'created_by','JOSM'),(53277220,'created_by','JOSM'),(53277221,'created_by','JOSM'),(53277222,'created_by','JOSM'),(53277223,'created_by','JOSM'),(53277224,'created_by','JOSM'),(53277225,'created_by','JOSM'),(53277226,'created_by','JOSM'),(53277227,'created_by','JOSM'),(53277228,'created_by','JOSM'),(53277229,'created_by','JOSM'),(53277230,'created_by','JOSM'),(53277231,'created_by','JOSM'),(53277232,'created_by','JOSM'),(53277233,'created_by','JOSM'),(53277234,'created_by','JOSM'),(53277235,'created_by','JOSM'),(53277236,'created_by','JOSM'),(53277237,'created_by','JOSM'),(53277238,'created_by','JOSM'),(53277239,'created_by','JOSM'),(53277240,'created_by','JOSM'),(53277241,'created_by','JOSM'),(53277242,'created_by','JOSM'),(53277243,'created_by','JOSM'),(53277244,'created_by','JOSM'),(53277245,'created_by','JOSM'),(53277246,'created_by','JOSM'),(53277247,'created_by','JOSM'),(53277248,'created_by','JOSM'),(53277249,'created_by','JOSM'),(53277250,'created_by','JOSM'),(53277251,'created_by','JOSM'),(53277252,'created_by','JOSM'),(53277253,'created_by','JOSM'),(53277254,'created_by','JOSM'),(53277255,'created_by','JOSM'),(53277256,'created_by','JOSM'),(53277257,'created_by','JOSM'),(53277258,'created_by','JOSM'),(53277259,'created_by','JOSM'),(53277260,'created_by','JOSM'),(53277261,'created_by','JOSM'),(53277262,'created_by','JOSM'),(53277263,'created_by','JOSM'),(53277264,'created_by','JOSM'),(53277265,'created_by','JOSM'),(53277266,'created_by','JOSM'),(53277267,'created_by','JOSM'),(53277268,'created_by','JOSM'),(53277269,'created_by','JOSM'),(53277270,'created_by','JOSM'),(53277271,'created_by','JOSM'),(53277272,'created_by','JOSM'),(53277273,'created_by','JOSM'),(53277274,'created_by','JOSM'),(53277275,'created_by','JOSM'),(53277276,'created_by','JOSM'),(53277277,'created_by','JOSM'),(53277278,'created_by','JOSM'),(53277279,'created_by','JOSM'),(53277280,'created_by','JOSM'),(53277281,'created_by','JOSM'),(53277282,'created_by','JOSM'),(53277283,'created_by','JOSM'),(53277284,'created_by','JOSM'),(53277285,'created_by','JOSM'),(53277286,'created_by','JOSM'),(53277287,'created_by','JOSM'),(53277288,'created_by','JOSM'),(53277289,'created_by','JOSM'),(53277290,'created_by','JOSM'),(53277291,'created_by','JOSM'),(53277292,'created_by','JOSM'),(53277293,'created_by','JOSM'),(53277294,'created_by','JOSM'),(53277295,'created_by','JOSM'),(53277296,'created_by','JOSM'),(53277297,'created_by','JOSM'),(53277298,'created_by','JOSM'),(53277299,'created_by','JOSM'),(53277300,'created_by','JOSM'),(53277301,'created_by','JOSM'),(53277302,'created_by','JOSM'),(53277303,'created_by','JOSM'),(53277304,'created_by','JOSM'),(53277305,'created_by','JOSM'),(53277306,'created_by','JOSM'),(53277307,'created_by','JOSM'),(53277308,'created_by','JOSM'),(53277309,'created_by','JOSM'),(53277310,'created_by','JOSM'),(53277311,'created_by','JOSM'),(53277312,'created_by','JOSM'),(53277313,'created_by','JOSM'),(53278142,'created_by','JOSM'),(53278144,'created_by','JOSM'),(53278146,'created_by','JOSM'),(53278147,'created_by','JOSM'),(53278148,'created_by','JOSM'),(53278149,'created_by','JOSM'),(53278150,'created_by','JOSM'),(53278151,'created_by','JOSM'),(53278152,'created_by','JOSM'),(53278153,'created_by','JOSM'),(53278154,'created_by','JOSM'),(53278155,'created_by','JOSM'),(53278156,'created_by','JOSM'),(53278157,'created_by','JOSM'),(53278158,'created_by','JOSM'),(53278159,'created_by','JOSM'),(53278160,'created_by','JOSM'),(53278161,'created_by','JOSM'),(53278162,'created_by','JOSM'),(53278163,'created_by','JOSM'),(53278164,'created_by','JOSM'),(53278165,'created_by','JOSM'),(53278166,'created_by','JOSM'),(53278167,'created_by','JOSM'),(53278168,'created_by','JOSM'),(53278173,'created_by','JOSM'),(53278175,'aerialway','station'),(53278176,'created_by','JOSM'),(53278177,'created_by','JOSM'),(53278178,'created_by','JOSM'),(53278179,'created_by','JOSM'),(53278180,'created_by','JOSM'),(53278181,'created_by','JOSM'),(53278182,'created_by','JOSM'),(53278183,'created_by','JOSM'),(53278185,'created_by','JOSM'),(53278186,'created_by','JOSM'),(53278188,'created_by','JOSM'),(53278190,'created_by','JOSM'),(53278192,'created_by','JOSM'),(53278194,'created_by','JOSM'),(53278196,'created_by','JOSM'),(53278197,'created_by','JOSM'),(53278199,'created_by','JOSM'),(53278200,'created_by','JOSM'),(53278201,'created_by','JOSM'),(53278202,'created_by','JOSM'),(53278203,'created_by','JOSM'),(53278204,'created_by','JOSM'),(53278205,'created_by','JOSM'),(53278206,'created_by','JOSM'),(53278207,'created_by','JOSM'),(53278208,'created_by','JOSM'),(53278210,'created_by','JOSM'),(53278211,'created_by','JOSM'),(53278212,'created_by','JOSM'),(53278213,'created_by','JOSM'),(53278214,'created_by','JOSM'),(53278215,'created_by','JOSM'),(53278216,'created_by','JOSM'),(53278217,'created_by','JOSM'),(53278218,'created_by','JOSM'),(53278219,'created_by','JOSM'),(53278220,'created_by','JOSM'),(53278221,'created_by','JOSM'),(53278222,'created_by','JOSM'),(53278223,'created_by','JOSM'),(53278224,'created_by','JOSM'),(53278226,'created_by','JOSM'),(53278232,'created_by','JOSM'),(53278233,'created_by','JOSM'),(53278234,'created_by','JOSM'),(53278235,'created_by','JOSM'),(53278236,'created_by','JOSM'),(53278237,'created_by','JOSM'),(53278238,'created_by','JOSM'),(53278239,'created_by','JOSM'),(53278240,'created_by','JOSM'),(53278241,'created_by','JOSM'),(53278242,'created_by','JOSM'),(53278252,'created_by','JOSM'),(53278253,'created_by','JOSM'),(53278255,'created_by','JOSM'),(53278256,'created_by','JOSM'),(53278257,'created_by','JOSM'),(53278258,'created_by','JOSM'),(53278259,'created_by','JOSM'),(53278261,'created_by','JOSM'),(53278263,'created_by','JOSM'),(53278264,'created_by','JOSM'),(53278265,'created_by','JOSM'),(53278267,'created_by','JOSM'),(53278268,'created_by','JOSM'),(53278269,'created_by','JOSM'),(53278271,'created_by','JOSM'),(53278272,'created_by','JOSM'),(53278273,'created_by','JOSM'),(53278274,'created_by','JOSM'),(53278275,'created_by','JOSM'),(53278276,'created_by','JOSM'),(53278277,'created_by','JOSM'),(53278278,'created_by','JOSM'),(53278280,'created_by','JOSM'),(53278282,'created_by','JOSM'),(53278283,'created_by','JOSM'),(53278285,'created_by','JOSM'),(53278286,'created_by','JOSM'),(53278287,'created_by','JOSM'),(53278289,'created_by','JOSM'),(53278290,'created_by','JOSM'),(53278291,'created_by','JOSM'),(53278292,'created_by','JOSM'),(53278293,'created_by','JOSM'),(53278294,'created_by','JOSM'),(53278296,'created_by','JOSM'),(53278298,'created_by','JOSM'),(53278299,'created_by','JOSM'),(53278301,'created_by','JOSM'),(53278302,'created_by','JOSM'),(53278304,'created_by','JOSM'),(53278305,'created_by','JOSM'),(53278306,'created_by','JOSM'),(53278308,'created_by','JOSM'),(53278309,'created_by','JOSM'),(53278311,'created_by','JOSM'),(53278312,'created_by','JOSM'),(53278314,'created_by','JOSM'),(53278315,'created_by','JOSM'),(53278316,'created_by','JOSM'),(53278317,'created_by','JOSM'),(53278319,'created_by','JOSM'),(53278321,'created_by','JOSM'),(53278324,'created_by','JOSM'),(53278327,'created_by','JOSM'),(53278328,'created_by','JOSM'),(53278330,'created_by','JOSM'),(53278332,'created_by','JOSM'),(53278333,'created_by','JOSM'),(53278336,'created_by','JOSM'),(53278337,'created_by','JOSM'),(53278338,'created_by','JOSM'),(53278341,'created_by','JOSM'),(53278342,'created_by','JOSM'),(53278343,'created_by','JOSM'),(53278346,'created_by','JOSM'),(53278347,'created_by','JOSM'),(53278348,'created_by','JOSM'),(53278350,'created_by','JOSM'),(53278351,'created_by','JOSM'),(53278353,'created_by','JOSM'),(53278355,'created_by','JOSM'),(53278356,'created_by','JOSM'),(53278358,'created_by','JOSM'),(53278360,'created_by','JOSM'),(53278361,'created_by','JOSM'),(53278362,'created_by','JOSM'),(53278364,'created_by','JOSM'),(53278366,'created_by','JOSM'),(53278367,'created_by','JOSM'),(53278368,'created_by','JOSM'),(53278369,'created_by','JOSM'),(53278371,'created_by','JOSM'),(53278374,'created_by','JOSM'),(53278375,'created_by','JOSM'),(53278376,'created_by','JOSM'),(53278377,'created_by','JOSM'),(53278379,'created_by','JOSM'),(53278383,'created_by','JOSM'),(53278387,'created_by','JOSM'),(53278390,'created_by','JOSM'),(53278395,'created_by','JOSM'),(53278401,'created_by','JOSM'),(53278404,'created_by','JOSM'),(53278409,'created_by','JOSM'),(53278412,'created_by','JOSM'),(53278418,'created_by','JOSM'),(53278420,'created_by','JOSM'),(53278423,'created_by','JOSM'),(53278426,'created_by','JOSM'),(53278429,'created_by','JOSM'),(53281369,'created_by','JOSM'),(53281374,'created_by','JOSM'),(53281378,'created_by','JOSM'),(53281382,'created_by','JOSM'),(53281386,'created_by','JOSM'),(53281388,'created_by','JOSM'),(53281393,'created_by','JOSM'),(53281395,'created_by','JOSM'),(53281399,'created_by','JOSM'),(53281402,'created_by','JOSM'),(53281403,'created_by','JOSM'),(53282932,'created_by','JOSM'),(53282936,'created_by','JOSM'),(53282940,'created_by','JOSM'),(53282941,'created_by','JOSM'),(53282943,'created_by','JOSM'),(53282946,'created_by','JOSM'),(53282948,'created_by','JOSM'),(53282950,'created_by','JOSM'),(53282952,'created_by','JOSM'),(53282953,'created_by','JOSM'),(53282957,'created_by','JOSM'),(53282958,'created_by','JOSM'),(53282959,'created_by','JOSM'),(53282960,'created_by','JOSM'),(53282963,'created_by','JOSM'),(53282966,'created_by','JOSM'),(53282968,'created_by','JOSM'),(53282970,'created_by','JOSM'),(53282972,'created_by','JOSM'),(53282974,'created_by','JOSM'),(53282976,'created_by','JOSM'),(53282979,'created_by','JOSM'),(53282983,'created_by','JOSM'),(53282985,'created_by','JOSM'),(53282987,'created_by','JOSM'),(53282989,'created_by','JOSM'),(53282991,'created_by','JOSM'),(53282996,'created_by','JOSM'),(53282998,'created_by','JOSM'),(53283003,'created_by','JOSM'),(53283007,'created_by','JOSM'),(53283011,'created_by','JOSM'),(53288119,'created_by','JOSM'),(53288123,'created_by','JOSM'),(53288126,'created_by','JOSM'),(53288128,'created_by','JOSM'),(53288129,'created_by','JOSM'),(53288131,'created_by','JOSM'),(53288134,'created_by','JOSM'),(53288136,'created_by','JOSM'),(53288138,'created_by','JOSM'),(53288140,'created_by','JOSM'),(53288141,'created_by','JOSM'),(53288143,'created_by','JOSM'),(53288147,'created_by','JOSM'),(53288148,'created_by','JOSM'),(53288150,'created_by','JOSM'),(53288152,'created_by','JOSM'),(53288157,'created_by','JOSM'),(53288160,'created_by','JOSM'),(53288161,'created_by','JOSM'),(53288164,'created_by','JOSM'),(53288166,'created_by','JOSM'),(53288168,'created_by','JOSM'),(53288171,'created_by','JOSM'),(53288173,'created_by','JOSM'),(53288174,'created_by','JOSM'),(53288176,'created_by','JOSM'),(53288178,'created_by','JOSM'),(53288180,'created_by','JOSM'),(53288182,'created_by','JOSM'),(53288184,'created_by','JOSM'),(53288187,'created_by','JOSM'),(53288189,'created_by','JOSM'),(53288191,'created_by','JOSM'),(53288194,'created_by','JOSM'),(53288196,'created_by','JOSM'),(53288198,'created_by','JOSM'),(53288199,'created_by','JOSM'),(53288201,'created_by','JOSM'),(53288203,'created_by','JOSM'),(53288206,'created_by','JOSM'),(53288209,'created_by','JOSM'),(53288210,'created_by','JOSM'),(53288213,'created_by','JOSM'),(53288216,'created_by','JOSM'),(53288219,'created_by','JOSM'),(53288220,'created_by','JOSM'),(53288223,'created_by','JOSM'),(53288225,'created_by','JOSM'),(53288227,'created_by','JOSM'),(53288228,'created_by','JOSM'),(53288229,'created_by','JOSM'),(53288231,'created_by','JOSM'),(53288235,'created_by','JOSM'),(53288238,'created_by','JOSM'),(53288239,'created_by','JOSM'),(53288242,'created_by','JOSM'),(53288245,'created_by','JOSM'),(53288247,'created_by','JOSM'),(53288250,'created_by','JOSM'),(53288253,'created_by','JOSM'),(53288255,'created_by','JOSM'),(53288257,'created_by','JOSM'),(53288259,'created_by','JOSM'),(53288261,'created_by','JOSM'),(53288262,'created_by','JOSM'),(53288263,'created_by','JOSM'),(53288266,'created_by','JOSM'),(53288269,'created_by','JOSM'),(53288271,'created_by','JOSM'),(53288273,'created_by','JOSM'),(53288276,'created_by','JOSM'),(53288278,'created_by','JOSM'),(53288280,'created_by','JOSM'),(53288281,'created_by','JOSM'),(53288282,'created_by','JOSM'),(53288286,'created_by','JOSM'),(53288290,'created_by','JOSM'),(53288292,'created_by','JOSM'),(53288294,'created_by','JOSM'),(53288296,'created_by','JOSM'),(53288298,'created_by','JOSM'),(53288300,'created_by','JOSM'),(53288302,'created_by','JOSM'),(53288303,'created_by','JOSM'),(53288305,'created_by','JOSM'),(53288308,'created_by','JOSM'),(53288309,'created_by','JOSM'),(53288310,'created_by','JOSM'),(53288313,'created_by','JOSM'),(53288317,'created_by','JOSM'),(53288318,'created_by','JOSM'),(53288321,'created_by','JOSM'),(53288323,'created_by','JOSM'),(53288326,'created_by','JOSM'),(53288329,'created_by','JOSM'),(53288332,'created_by','JOSM'),(53288334,'created_by','JOSM'),(53288336,'created_by','JOSM'),(53288338,'created_by','JOSM'),(53288339,'created_by','JOSM'),(53288343,'created_by','JOSM'),(53288346,'created_by','JOSM'),(53288348,'created_by','JOSM'),(53288349,'created_by','JOSM'),(53288350,'created_by','JOSM'),(53288351,'created_by','JOSM'),(53288352,'created_by','JOSM'),(53288353,'created_by','JOSM'),(53288354,'created_by','JOSM'),(53288355,'created_by','JOSM'),(53288356,'created_by','JOSM'),(53288357,'created_by','JOSM'),(53288358,'created_by','JOSM'),(53288360,'created_by','JOSM'),(53288364,'created_by','JOSM'),(53288366,'created_by','JOSM'),(53288368,'created_by','JOSM'),(53288370,'created_by','JOSM'),(53288373,'created_by','JOSM'),(53288375,'created_by','JOSM'),(53288378,'created_by','JOSM'),(53288381,'created_by','JOSM'),(53288383,'created_by','JOSM'),(53288388,'created_by','JOSM'),(53288391,'created_by','JOSM'),(53288393,'created_by','JOSM'),(53288394,'created_by','JOSM'),(53288396,'created_by','JOSM'),(53288399,'created_by','JOSM'),(53288402,'created_by','JOSM'),(53288403,'created_by','JOSM'),(53288404,'created_by','JOSM'),(53288407,'created_by','JOSM'),(53288410,'created_by','JOSM'),(53288413,'created_by','JOSM'),(53288419,'created_by','JOSM'),(53292901,'created_by','JOSM'),(53292938,'created_by','JOSM'),(53292997,'created_by','JOSM'),(53293001,'created_by','JOSM'),(53293003,'created_by','JOSM'),(53293007,'created_by','JOSM'),(53293010,'created_by','JOSM'),(53293011,'created_by','JOSM'),(53293015,'created_by','JOSM'),(53293017,'created_by','JOSM'),(53293018,'created_by','JOSM'),(53293022,'created_by','JOSM'),(53293025,'created_by','JOSM'),(53293027,'created_by','JOSM'),(53293029,'created_by','JOSM'),(53293032,'created_by','JOSM'),(53293034,'created_by','JOSM'),(53293037,'created_by','JOSM'),(53293039,'created_by','JOSM'),(53293043,'created_by','JOSM'),(53293046,'created_by','JOSM'),(53293058,'created_by','JOSM'),(53293060,'created_by','JOSM'),(53293062,'created_by','JOSM'),(53293063,'created_by','JOSM'),(53293066,'created_by','JOSM'),(53293067,'created_by','JOSM'),(53293069,'created_by','JOSM'),(53293073,'created_by','JOSM'),(53293076,'created_by','JOSM'),(53293077,'created_by','JOSM'),(53293080,'created_by','JOSM'),(53293082,'created_by','JOSM'),(53293083,'created_by','JOSM'),(53293087,'created_by','JOSM'),(53293089,'created_by','JOSM'),(53293092,'created_by','JOSM'),(53293095,'created_by','JOSM'),(53293097,'created_by','JOSM'),(53293098,'created_by','JOSM'),(53293102,'created_by','JOSM'),(53293105,'created_by','JOSM'),(53293108,'created_by','JOSM'),(53293109,'created_by','JOSM'),(53293111,'created_by','JOSM'),(53293114,'created_by','JOSM'),(53293117,'created_by','JOSM'),(53293119,'created_by','JOSM'),(53293123,'created_by','JOSM'),(53293124,'created_by','JOSM'),(53293127,'created_by','JOSM'),(53293130,'created_by','JOSM'),(53293132,'created_by','JOSM'),(53293136,'created_by','JOSM'),(53293137,'created_by','JOSM'),(53293142,'created_by','JOSM'),(53293144,'created_by','JOSM'),(53293147,'created_by','JOSM'),(53293148,'created_by','JOSM'),(53293150,'created_by','JOSM'),(53293153,'created_by','JOSM'),(53293155,'created_by','JOSM'),(53293157,'created_by','JOSM'),(53293158,'created_by','JOSM'),(53293162,'created_by','JOSM'),(53293164,'created_by','JOSM'),(53293167,'created_by','JOSM'),(53293169,'created_by','JOSM'),(53293172,'created_by','JOSM'),(53293174,'created_by','JOSM'),(53293177,'created_by','JOSM'),(53293179,'created_by','JOSM'),(53293183,'created_by','JOSM'),(53293185,'created_by','JOSM'),(53293188,'created_by','JOSM'),(53293189,'created_by','JOSM'),(53293192,'created_by','JOSM'),(53293193,'created_by','JOSM'),(53293197,'created_by','JOSM'),(53293198,'created_by','JOSM'),(53293200,'created_by','JOSM'),(53293202,'created_by','JOSM'),(53293205,'created_by','JOSM'),(53293212,'created_by','JOSM'),(53293217,'created_by','JOSM'),(53293220,'created_by','JOSM'),(53293232,'created_by','JOSM'),(53293500,'created_by','JOSM'),(53293505,'created_by','JOSM'),(53293507,'created_by','JOSM'),(53293510,'created_by','JOSM'),(53294141,'created_by','JOSM'),(53294144,'created_by','JOSM'),(53294147,'created_by','JOSM'),(53294149,'created_by','JOSM'),(53294152,'created_by','JOSM'),(53294154,'created_by','JOSM'),(53294157,'created_by','JOSM'),(53294160,'created_by','JOSM'),(53294162,'created_by','JOSM'),(53294165,'created_by','JOSM'),(53294166,'created_by','JOSM'),(53294168,'created_by','JOSM'),(53294169,'created_by','JOSM'),(53294170,'created_by','JOSM'),(53294171,'created_by','JOSM'),(53294174,'created_by','JOSM'),(53294177,'created_by','JOSM'),(53294180,'created_by','JOSM'),(53294181,'created_by','JOSM'),(53294184,'created_by','JOSM'),(53294186,'created_by','JOSM'),(53294189,'created_by','JOSM'),(53294192,'created_by','JOSM'),(53294194,'created_by','JOSM'),(53294195,'created_by','JOSM'),(53294197,'created_by','JOSM'),(53294199,'created_by','JOSM'),(53294202,'created_by','JOSM'),(53294205,'created_by','JOSM'),(53294207,'created_by','JOSM'),(53294209,'created_by','JOSM'),(53294212,'created_by','JOSM'),(53294213,'created_by','JOSM'),(53294215,'created_by','JOSM'),(53294218,'created_by','JOSM'),(53294219,'created_by','JOSM'),(53294221,'created_by','JOSM'),(53294223,'created_by','JOSM'),(53294226,'created_by','JOSM'),(53294228,'created_by','JOSM'),(53294231,'created_by','JOSM'),(53294233,'created_by','JOSM'),(53294235,'created_by','JOSM'),(53294236,'created_by','JOSM'),(53294239,'created_by','JOSM'),(53294241,'created_by','JOSM'),(53294244,'created_by','JOSM'),(53294245,'created_by','JOSM'),(53294248,'created_by','JOSM'),(53294251,'created_by','JOSM'),(53294253,'created_by','JOSM'),(53294255,'created_by','JOSM'),(53294258,'created_by','JOSM'),(53294260,'created_by','JOSM'),(53294262,'created_by','JOSM'),(53294264,'created_by','JOSM'),(53294267,'created_by','JOSM'),(53294268,'created_by','JOSM'),(53294270,'created_by','JOSM'),(53294273,'created_by','JOSM'),(53294277,'created_by','JOSM'),(53294279,'created_by','JOSM'),(53294284,'created_by','JOSM'),(53294285,'created_by','JOSM'),(53294290,'created_by','JOSM'),(53294293,'created_by','JOSM'),(53294297,'created_by','JOSM'),(53294300,'created_by','JOSM'),(53294304,'created_by','JOSM'),(53294308,'created_by','JOSM'),(53294311,'created_by','JOSM'),(53294314,'created_by','JOSM'),(53294317,'created_by','JOSM'),(53294320,'created_by','JOSM'),(53294323,'created_by','JOSM'),(53294327,'created_by','JOSM'),(53294331,'created_by','JOSM'),(53294335,'created_by','JOSM'),(53294337,'created_by','JOSM'),(53294341,'created_by','JOSM'),(53294344,'created_by','JOSM'),(53294347,'created_by','JOSM'),(53294350,'created_by','JOSM'),(53294352,'created_by','JOSM'),(53294354,'created_by','JOSM'),(53294357,'created_by','JOSM'),(53294362,'created_by','JOSM'),(53294364,'created_by','JOSM'),(53294366,'created_by','JOSM'),(53294371,'created_by','JOSM'),(53294374,'created_by','JOSM'),(53294377,'created_by','JOSM'),(53294382,'created_by','JOSM'),(53294385,'created_by','JOSM'),(53294389,'created_by','JOSM'),(53294392,'created_by','JOSM'),(53294394,'created_by','JOSM'),(53294396,'created_by','JOSM'),(53294401,'created_by','JOSM'),(53294404,'created_by','JOSM'),(53294409,'created_by','JOSM'),(53294411,'created_by','JOSM'),(53294416,'created_by','JOSM'),(53294418,'created_by','JOSM'),(53294420,'created_by','JOSM'),(53294423,'created_by','JOSM'),(53294425,'created_by','JOSM'),(53294429,'created_by','JOSM'),(53294430,'created_by','JOSM'),(53294433,'created_by','JOSM'),(53294434,'created_by','JOSM'),(53294436,'created_by','JOSM'),(53294443,'created_by','JOSM'),(53294444,'created_by','JOSM'),(53294448,'created_by','JOSM'),(53294450,'created_by','JOSM'),(53294455,'created_by','JOSM'),(53294458,'created_by','JOSM'),(53294463,'created_by','JOSM'),(53294466,'created_by','JOSM'),(53294469,'created_by','JOSM'),(53294474,'created_by','JOSM'),(53294475,'created_by','JOSM'),(53294479,'created_by','JOSM'),(53294483,'created_by','JOSM'),(53294487,'created_by','JOSM'),(53294490,'created_by','JOSM'),(53294493,'created_by','JOSM'),(53294496,'created_by','JOSM'),(53294500,'created_by','JOSM'),(53294503,'created_by','JOSM'),(53294508,'created_by','JOSM'),(53294512,'created_by','JOSM'),(53294515,'created_by','JOSM'),(53294520,'created_by','JOSM'),(53294523,'created_by','JOSM'),(53294526,'created_by','JOSM'),(53294530,'created_by','JOSM'),(53294531,'created_by','JOSM'),(53294534,'created_by','JOSM'),(53294537,'created_by','JOSM'),(53294540,'created_by','JOSM'),(53294541,'created_by','JOSM'),(53294545,'created_by','JOSM'),(53294548,'created_by','JOSM'),(53294552,'created_by','JOSM'),(53294557,'created_by','JOSM'),(53294560,'created_by','JOSM'),(53294562,'created_by','JOSM'),(53294566,'created_by','JOSM'),(53294570,'created_by','JOSM'),(53294573,'created_by','JOSM'),(53294577,'created_by','JOSM'),(53294581,'created_by','JOSM'),(53294998,'created_by','JOSM'),(53295002,'created_by','JOSM'),(53295004,'created_by','JOSM'),(53295006,'created_by','JOSM'),(53295010,'created_by','JOSM'),(53295011,'created_by','JOSM'),(53295014,'created_by','JOSM'),(53295016,'created_by','JOSM'),(53295019,'created_by','JOSM'),(53295022,'created_by','JOSM'),(53295026,'created_by','JOSM'),(53295029,'created_by','JOSM'),(53295033,'created_by','JOSM'),(53295035,'created_by','JOSM'),(53295038,'created_by','JOSM'),(53295040,'created_by','JOSM'),(53295043,'created_by','JOSM'),(53295045,'created_by','JOSM'),(53295047,'created_by','JOSM'),(53295051,'created_by','JOSM'),(53295054,'created_by','JOSM'),(53295057,'created_by','JOSM'),(53295059,'created_by','JOSM'),(53295063,'created_by','JOSM'),(53295067,'created_by','JOSM'),(53295071,'created_by','JOSM'),(53295073,'created_by','JOSM'),(53295077,'created_by','JOSM'),(53295079,'created_by','JOSM'),(53295083,'created_by','JOSM'),(53295085,'created_by','JOSM'),(53295090,'created_by','JOSM'),(53295093,'created_by','JOSM'),(53295097,'created_by','JOSM'),(53295102,'created_by','JOSM'),(53295103,'created_by','JOSM'),(53295107,'created_by','JOSM'),(53295110,'created_by','JOSM'),(53295113,'created_by','JOSM'),(53295117,'created_by','JOSM'),(53295122,'created_by','JOSM'),(53295125,'created_by','JOSM'),(53295128,'created_by','JOSM'),(53295132,'created_by','JOSM'),(53295133,'created_by','JOSM'),(53295137,'created_by','JOSM'),(53295141,'created_by','JOSM'),(53295143,'created_by','JOSM'),(53295147,'created_by','JOSM'),(53295149,'created_by','JOSM'),(53295153,'created_by','JOSM'),(53295157,'created_by','JOSM'),(53295158,'created_by','JOSM'),(53295161,'created_by','JOSM'),(53295165,'created_by','JOSM'),(53295169,'created_by','JOSM'),(53295172,'created_by','JOSM'),(53295175,'created_by','JOSM'),(53295178,'created_by','JOSM'),(53295182,'created_by','JOSM'),(53295186,'created_by','JOSM'),(53295188,'created_by','JOSM'),(53295190,'created_by','JOSM'),(53295193,'created_by','JOSM'),(53295197,'created_by','JOSM'),(53295202,'created_by','JOSM'),(53295208,'created_by','JOSM'),(53295211,'created_by','JOSM'),(53295218,'created_by','JOSM'),(53295222,'created_by','JOSM'),(53295224,'created_by','JOSM'),(53295228,'created_by','JOSM'),(53295233,'created_by','JOSM'),(53295236,'created_by','JOSM'),(53295241,'created_by','JOSM'),(53295243,'created_by','JOSM'),(53295245,'created_by','JOSM'),(53295249,'created_by','JOSM'),(53295251,'created_by','JOSM'),(53295253,'created_by','JOSM'),(53295257,'created_by','JOSM'),(53306569,'created_by','JOSM'),(53306573,'created_by','JOSM'),(53306575,'created_by','JOSM'),(53306579,'created_by','JOSM'),(53306582,'created_by','JOSM'),(53306585,'created_by','JOSM'),(53306588,'created_by','JOSM'),(53306590,'created_by','JOSM'),(53306592,'created_by','JOSM'),(53306595,'created_by','JOSM'),(53306597,'created_by','JOSM'),(53306600,'created_by','JOSM'),(53306695,'created_by','JOSM'),(53306696,'created_by','JOSM'),(53306764,'created_by','JOSM'),(53306767,'created_by','JOSM'),(53306769,'created_by','JOSM'),(53306771,'created_by','JOSM'),(53306774,'created_by','JOSM'),(53306775,'created_by','JOSM'),(53306778,'created_by','JOSM'),(53306780,'created_by','JOSM'),(53306781,'created_by','JOSM'),(53306782,'created_by','JOSM'),(53306786,'created_by','JOSM'),(53306788,'created_by','JOSM'),(53306789,'created_by','JOSM'),(53306790,'created_by','JOSM'),(53306791,'created_by','JOSM'),(53306792,'created_by','JOSM'),(53306794,'created_by','JOSM'),(53306795,'created_by','JOSM'),(53306796,'created_by','JOSM'),(53306799,'created_by','JOSM'),(53306800,'created_by','JOSM'),(53306803,'created_by','JOSM'),(53306804,'created_by','JOSM'),(53306806,'created_by','JOSM'),(53306808,'created_by','JOSM'),(53306810,'created_by','JOSM'),(53306813,'created_by','JOSM'),(53306814,'created_by','JOSM'),(53306817,'created_by','JOSM'),(53306819,'created_by','JOSM'),(53306821,'created_by','JOSM'),(53306823,'created_by','JOSM'),(53306825,'created_by','JOSM'),(53306828,'created_by','JOSM'),(53306831,'created_by','JOSM'),(53306833,'created_by','JOSM'),(53306836,'created_by','JOSM'),(53306838,'created_by','JOSM'),(53306841,'created_by','JOSM'),(53306843,'created_by','JOSM'),(53306845,'created_by','JOSM'),(53306846,'created_by','JOSM'),(53306848,'created_by','JOSM'),(53306849,'created_by','JOSM'),(53306852,'created_by','JOSM'),(53306853,'created_by','JOSM'),(53306856,'created_by','JOSM'),(53306858,'created_by','JOSM'),(53306862,'created_by','JOSM'),(53306863,'created_by','JOSM'),(53306866,'created_by','JOSM'),(53306869,'created_by','JOSM'),(53306871,'created_by','JOSM'),(53306873,'created_by','JOSM'),(53306874,'created_by','JOSM'),(53306875,'created_by','JOSM'),(53306876,'created_by','JOSM'),(53306878,'created_by','JOSM'),(53306881,'created_by','JOSM'),(53306882,'created_by','JOSM'),(53306885,'created_by','JOSM'),(53306886,'created_by','JOSM'),(53306887,'created_by','JOSM'),(53306888,'created_by','JOSM'),(53306889,'created_by','JOSM'),(53306892,'created_by','JOSM'),(53306893,'created_by','JOSM'),(53306897,'created_by','JOSM'),(53306899,'created_by','JOSM'),(53306901,'created_by','JOSM'),(53306904,'created_by','JOSM'),(53306906,'created_by','JOSM'),(53306907,'created_by','JOSM'),(53306910,'created_by','JOSM'),(53306963,'created_by','JOSM'),(53306966,'created_by','JOSM'),(53306970,'created_by','JOSM'),(53306973,'created_by','JOSM'),(53306975,'created_by','JOSM'),(53306978,'created_by','JOSM'),(53306979,'created_by','JOSM'),(53306983,'created_by','JOSM'),(53306984,'created_by','JOSM'),(53306988,'created_by','JOSM'),(53306989,'created_by','JOSM'),(53306991,'created_by','JOSM'),(53306992,'created_by','JOSM'),(53306994,'created_by','JOSM'),(53309350,'created_by','JOSM'),(53309352,'created_by','JOSM'),(53309354,'created_by','JOSM'),(53309356,'created_by','JOSM'),(53309360,'created_by','JOSM'),(53309365,'created_by','JOSM'),(53309368,'created_by','JOSM'),(53309369,'created_by','JOSM'),(53309370,'created_by','JOSM'),(53309371,'created_by','JOSM'),(53309374,'created_by','JOSM'),(53309376,'created_by','JOSM'),(53309379,'created_by','JOSM'),(53309379,'highway','turning_circle'),(53309380,'created_by','JOSM'),(53309384,'created_by','JOSM'),(53309386,'created_by','JOSM'),(53309389,'created_by','JOSM'),(53309392,'created_by','JOSM'),(53309393,'created_by','JOSM'),(53309395,'created_by','JOSM'),(53309397,'created_by','JOSM'),(53309398,'created_by','JOSM'),(53309400,'created_by','JOSM'),(53309402,'created_by','JOSM'),(53309405,'created_by','JOSM'),(53309407,'created_by','JOSM'),(53309409,'created_by','JOSM'),(53309412,'created_by','JOSM'),(53309414,'created_by','JOSM'),(53309417,'created_by','JOSM'),(53309419,'created_by','JOSM'),(53309421,'created_by','JOSM'),(53309423,'created_by','JOSM'),(53309425,'created_by','JOSM'),(53309427,'created_by','JOSM'),(53309431,'created_by','JOSM'),(53309433,'created_by','JOSM'),(53309436,'created_by','JOSM'),(53309438,'created_by','JOSM'),(53309440,'created_by','JOSM'),(53309443,'created_by','JOSM'),(53309446,'created_by','JOSM'),(53309449,'created_by','JOSM'),(53309453,'created_by','JOSM'),(53309457,'created_by','JOSM'),(53309460,'created_by','JOSM'),(53309462,'created_by','JOSM'),(53309464,'created_by','JOSM'),(53309466,'created_by','JOSM'),(53309469,'created_by','JOSM'),(53309473,'created_by','JOSM'),(53309476,'created_by','JOSM'),(53309477,'created_by','JOSM'),(53309480,'created_by','JOSM'),(53309482,'created_by','JOSM'),(53309483,'created_by','JOSM'),(53309485,'created_by','JOSM'),(53315413,'created_by','JOSM'),(53315705,'created_by','JOSM'),(53315884,'created_by','JOSM'),(53315943,'created_by','JOSM'),(53315948,'created_by','JOSM'),(53315952,'created_by','JOSM'),(53315955,'created_by','JOSM'),(53316065,'created_by','JOSM'),(53316068,'created_by','JOSM'),(53316074,'created_by','JOSM'),(53316105,'created_by','JOSM'),(53319479,'created_by','JOSM'),(53319482,'created_by','JOSM'),(53319484,'created_by','JOSM'),(53319487,'created_by','JOSM'),(53319489,'created_by','JOSM'),(53319514,'created_by','JOSM'),(53319515,'created_by','JOSM'),(53319517,'created_by','JOSM'),(53319520,'created_by','JOSM'),(53319521,'created_by','JOSM'),(53319523,'created_by','JOSM'),(53319525,'created_by','JOSM'),(53319529,'created_by','JOSM'),(53319532,'created_by','JOSM'),(53319535,'created_by','JOSM'),(53319536,'created_by','JOSM'),(53319538,'created_by','JOSM'),(53319539,'created_by','JOSM'),(53319541,'created_by','JOSM'),(53319543,'created_by','JOSM'),(53319545,'created_by','JOSM'),(53319547,'created_by','JOSM'),(53319548,'created_by','JOSM'),(53319551,'created_by','JOSM'),(53319552,'created_by','JOSM'),(53319581,'created_by','JOSM'),(53319582,'created_by','JOSM'),(53319584,'created_by','JOSM'),(53319587,'created_by','JOSM'),(53319589,'created_by','JOSM'),(53319592,'created_by','JOSM'),(53319593,'created_by','JOSM'),(53319596,'created_by','JOSM'),(53319598,'created_by','JOSM'),(53319600,'created_by','JOSM'),(53319601,'created_by','JOSM'),(53319603,'created_by','JOSM'),(53319605,'created_by','JOSM'),(53319607,'created_by','JOSM'),(53319609,'created_by','JOSM'),(53319610,'created_by','JOSM'),(53319611,'created_by','JOSM'),(53319612,'created_by','JOSM'),(53319613,'created_by','JOSM'),(53319616,'created_by','JOSM'),(53319617,'created_by','JOSM'),(53319619,'created_by','JOSM'),(53319621,'created_by','JOSM'),(53319624,'created_by','JOSM'),(53319625,'created_by','JOSM'),(53319627,'created_by','JOSM'),(53319629,'created_by','JOSM'),(53319631,'created_by','JOSM'),(53319632,'created_by','JOSM'),(53319634,'created_by','JOSM'),(53319636,'created_by','JOSM'),(53319638,'created_by','JOSM'),(53319639,'created_by','JOSM'),(53319642,'created_by','JOSM'),(53319643,'created_by','JOSM'),(53319645,'created_by','JOSM'),(53319646,'created_by','JOSM'),(53319648,'created_by','JOSM'),(53319649,'created_by','JOSM'),(53319651,'created_by','JOSM'),(53319652,'created_by','JOSM'),(53319657,'created_by','JOSM'),(53319658,'created_by','JOSM'),(53319659,'created_by','JOSM'),(53319661,'created_by','JOSM'),(53319663,'created_by','JOSM'),(53319664,'created_by','JOSM'),(53319665,'created_by','JOSM'),(53319666,'created_by','JOSM'),(53319667,'created_by','JOSM'),(53319669,'created_by','JOSM'),(53319670,'created_by','JOSM'),(53319672,'created_by','JOSM'),(53319675,'created_by','JOSM'),(53319678,'created_by','JOSM'),(53319681,'created_by','JOSM'),(53319682,'created_by','JOSM'),(53319684,'created_by','JOSM'),(53319686,'created_by','JOSM'),(53319688,'created_by','JOSM'),(53319690,'created_by','JOSM'),(53319693,'created_by','JOSM'),(53319695,'created_by','JOSM'),(53319697,'created_by','JOSM'),(53319700,'created_by','JOSM'),(53319701,'created_by','JOSM'),(53319702,'created_by','JOSM'),(53319703,'created_by','JOSM'),(53319749,'created_by','JOSM'),(53319750,'created_by','JOSM'),(53319752,'created_by','JOSM'),(53319753,'created_by','JOSM'),(53319755,'created_by','JOSM'),(53319756,'created_by','JOSM'),(53319758,'created_by','JOSM'),(53319759,'created_by','JOSM'),(53319761,'created_by','JOSM'),(53319765,'created_by','JOSM'),(53319768,'created_by','JOSM'),(53319770,'created_by','JOSM'),(53319773,'created_by','JOSM'),(53319774,'created_by','JOSM'),(53319777,'created_by','JOSM'),(53319778,'created_by','JOSM'),(53319781,'created_by','JOSM'),(53319782,'created_by','JOSM'),(53319784,'created_by','JOSM'),(53319786,'created_by','JOSM'),(53319789,'created_by','JOSM'),(53319790,'created_by','JOSM'),(53319793,'created_by','JOSM'),(53319796,'created_by','JOSM'),(53319797,'created_by','JOSM'),(53319800,'created_by','JOSM'),(53319801,'created_by','JOSM'),(53319804,'created_by','JOSM'),(53319806,'created_by','JOSM'),(53319807,'created_by','JOSM'),(53319809,'created_by','JOSM'),(53319811,'created_by','JOSM'),(53319813,'created_by','JOSM'),(53319815,'created_by','JOSM'),(53319816,'created_by','JOSM'),(53319817,'created_by','JOSM'),(53319818,'created_by','JOSM'),(53319819,'created_by','JOSM'),(53319820,'created_by','JOSM'),(53319821,'created_by','JOSM'),(53319822,'created_by','JOSM'),(53319823,'created_by','JOSM'),(53319826,'created_by','JOSM'),(53325709,'created_by','JOSM'),(53325711,'created_by','JOSM'),(53325715,'created_by','JOSM'),(53325718,'created_by','JOSM'),(53325720,'created_by','JOSM'),(53325722,'created_by','JOSM'),(53325723,'created_by','JOSM'),(53325724,'created_by','JOSM'),(53325725,'created_by','JOSM'),(53325726,'created_by','JOSM'),(53325729,'created_by','JOSM'),(53325732,'created_by','JOSM'),(53325735,'created_by','JOSM'),(53325736,'created_by','JOSM'),(53325739,'created_by','JOSM'),(53325742,'created_by','JOSM'),(53325743,'created_by','JOSM'),(53325746,'created_by','JOSM'),(53325748,'created_by','JOSM'),(53325750,'created_by','JOSM'),(53325752,'created_by','JOSM'),(53325792,'created_by','JOSM'),(53325795,'created_by','JOSM'),(53325798,'created_by','JOSM'),(53325801,'created_by','JOSM'),(53325802,'created_by','JOSM'),(53325805,'created_by','JOSM'),(53325807,'created_by','JOSM'),(53325809,'created_by','JOSM'),(53325813,'created_by','JOSM'),(53325815,'created_by','JOSM'),(53325817,'created_by','JOSM'),(53325820,'created_by','JOSM'),(53325823,'created_by','JOSM'),(53325827,'created_by','JOSM'),(53325829,'created_by','JOSM'),(53325840,'created_by','JOSM'),(53325843,'created_by','JOSM'),(53325846,'created_by','JOSM'),(53325848,'created_by','JOSM'),(53325850,'created_by','JOSM'),(53327622,'created_by','JOSM'),(53327629,'created_by','JOSM'),(53327630,'created_by','JOSM'),(53327633,'created_by','JOSM'),(53327636,'created_by','JOSM'),(53327637,'created_by','JOSM'),(53327639,'created_by','JOSM'),(53327642,'created_by','JOSM'),(53327646,'created_by','JOSM'),(53327649,'created_by','JOSM'),(53327652,'created_by','JOSM'),(53327654,'created_by','JOSM'),(53327657,'created_by','JOSM'),(53327661,'created_by','JOSM'),(53327664,'created_by','JOSM'),(53327667,'created_by','JOSM'),(53327669,'created_by','JOSM'),(53327672,'created_by','JOSM'),(53327675,'created_by','JOSM'),(53327678,'created_by','JOSM'),(53327682,'created_by','JOSM'),(53327685,'created_by','JOSM'),(53327686,'created_by','JOSM'),(53327689,'created_by','JOSM'),(53327693,'created_by','JOSM'),(53327696,'created_by','JOSM'),(53327697,'created_by','JOSM'),(53327700,'created_by','JOSM'),(53327703,'created_by','JOSM'),(53327705,'created_by','JOSM'),(53327706,'created_by','JOSM'),(53327708,'created_by','JOSM'),(53327710,'created_by','JOSM'),(53327712,'created_by','JOSM'),(53327716,'created_by','JOSM'),(53327717,'created_by','JOSM'),(53327720,'created_by','JOSM'),(53327721,'created_by','JOSM'),(53327724,'created_by','JOSM'),(53327726,'created_by','JOSM'),(53327728,'created_by','JOSM'),(53327730,'created_by','JOSM'),(53327733,'created_by','JOSM'),(53327734,'created_by','JOSM'),(53327735,'created_by','JOSM'),(53327736,'created_by','JOSM'),(53327737,'created_by','JOSM'),(53327738,'created_by','JOSM'),(53327739,'created_by','JOSM'),(53327812,'highway','mini_roundabout'),(53327814,'created_by','JOSM'),(53327815,'created_by','JOSM'),(53327818,'created_by','JOSM'),(53327821,'created_by','JOSM'),(53327824,'created_by','JOSM'),(53327826,'created_by','JOSM'),(53327830,'created_by','JOSM'),(53327833,'created_by','JOSM'),(53327836,'created_by','JOSM'),(53327838,'created_by','JOSM'),(53327844,'created_by','JOSM'),(53327851,'created_by','JOSM'),(53327853,'created_by','JOSM'),(53327855,'created_by','JOSM'),(53327873,'created_by','JOSM'),(53327875,'created_by','JOSM'),(53327877,'created_by','JOSM'),(53327879,'created_by','JOSM'),(53327880,'created_by','JOSM'),(53327882,'created_by','JOSM'),(53330450,'created_by','JOSM'),(53330453,'created_by','JOSM'),(53334410,'created_by','JOSM'),(53334413,'created_by','JOSM'),(53334414,'created_by','JOSM'),(53334417,'created_by','JOSM'),(53334419,'created_by','JOSM'),(53334421,'created_by','JOSM'),(53334422,'created_by','JOSM'),(53334423,'created_by','JOSM'),(53334424,'created_by','JOSM'),(53334427,'created_by','JOSM'),(53334428,'created_by','JOSM'),(53334431,'created_by','JOSM'),(53334432,'created_by','JOSM'),(53334433,'created_by','JOSM'),(53334437,'created_by','JOSM'),(53334441,'created_by','JOSM'),(53334442,'created_by','JOSM'),(53334444,'created_by','JOSM'),(53334448,'created_by','JOSM'),(53335700,'created_by','JOSM'),(53335702,'created_by','JOSM'),(53335703,'created_by','JOSM'),(53335707,'created_by','JOSM'),(53335710,'created_by','JOSM'),(53335714,'created_by','JOSM'),(53335715,'created_by','JOSM'),(53335717,'created_by','JOSM'),(53335718,'created_by','JOSM'),(53335719,'created_by','JOSM'),(53335720,'created_by','JOSM'),(53335721,'created_by','JOSM'),(53335722,'created_by','JOSM'),(53335723,'created_by','JOSM'),(53335724,'created_by','JOSM'),(53335727,'created_by','JOSM'),(53335730,'created_by','JOSM'),(53335733,'created_by','JOSM'),(53335738,'created_by','JOSM'),(53335740,'created_by','JOSM'),(53335742,'created_by','JOSM'),(53335743,'created_by','JOSM'),(53335744,'created_by','JOSM'),(53335745,'created_by','JOSM'),(53335746,'created_by','JOSM'),(53335747,'created_by','JOSM'),(53335750,'created_by','JOSM'),(53335752,'created_by','JOSM'),(53335755,'created_by','JOSM'),(53335756,'created_by','JOSM'),(53335759,'created_by','JOSM'),(53335762,'created_by','JOSM'),(53335764,'created_by','JOSM'),(53335766,'created_by','JOSM'),(53335768,'created_by','JOSM'),(53335771,'created_by','JOSM'),(53335776,'created_by','JOSM'),(53335779,'created_by','JOSM'),(53335782,'created_by','JOSM'),(53335783,'created_by','JOSM'),(53343318,'created_by','JOSM'),(53343339,'created_by','JOSM'),(53343344,'created_by','JOSM'),(53343348,'created_by','JOSM'),(53343353,'created_by','JOSM'),(53343358,'created_by','JOSM'),(53343364,'created_by','JOSM'),(53343367,'created_by','JOSM'),(53343377,'created_by','JOSM'),(53343553,'created_by','JOSM'),(53344982,'created_by','JOSM'),(53350051,'created_by','JOSM'),(53351880,'created_by','JOSM'),(53352405,'created_by','JOSM'),(53352410,'created_by','JOSM'),(53352414,'created_by','JOSM'),(53352419,'created_by','JOSM'),(53352422,'created_by','JOSM'),(53352426,'created_by','JOSM'),(53352429,'created_by','JOSM'),(53352435,'created_by','JOSM'),(53352441,'created_by','JOSM'),(53352444,'created_by','JOSM'),(53352447,'created_by','JOSM'),(53352452,'created_by','JOSM'),(53352461,'created_by','JOSM'),(53352483,'created_by','JOSM'),(53352488,'created_by','JOSM'),(53352494,'created_by','JOSM'),(53352499,'created_by','JOSM'),(53352505,'created_by','JOSM'),(53352508,'created_by','JOSM'),(53352511,'created_by','JOSM'),(53352516,'created_by','JOSM'),(53352521,'created_by','JOSM'),(53352527,'created_by','JOSM'),(53352530,'created_by','JOSM'),(53352537,'created_by','JOSM'),(53352541,'created_by','JOSM'),(53352546,'created_by','JOSM'),(53352552,'created_by','JOSM'),(53352557,'created_by','JOSM'),(53352561,'created_by','JOSM'),(53352568,'created_by','JOSM'),(53352574,'created_by','JOSM'),(53352578,'created_by','JOSM'),(53352584,'created_by','JOSM'),(53352587,'created_by','JOSM'),(53352594,'created_by','JOSM'),(53352599,'created_by','JOSM'),(53352605,'created_by','JOSM'),(53352619,'created_by','JOSM'),(53352632,'created_by','JOSM'),(53352636,'created_by','JOSM'),(53352642,'created_by','JOSM'),(53352645,'created_by','JOSM'),(53352648,'created_by','JOSM'),(53352650,'created_by','JOSM'),(53352704,'created_by','JOSM'),(53352708,'created_by','JOSM'),(53352723,'created_by','JOSM'),(53352737,'created_by','JOSM'),(53352766,'created_by','JOSM'),(53352774,'created_by','JOSM'),(53352779,'created_by','JOSM'),(53352796,'created_by','JOSM'),(53352802,'created_by','JOSM'),(53352807,'created_by','JOSM'),(53352812,'created_by','JOSM'),(53352849,'created_by','JOSM'),(53352853,'created_by','JOSM'),(53352860,'created_by','JOSM'),(53352863,'created_by','JOSM'),(53352868,'created_by','JOSM'),(53352871,'created_by','JOSM'),(53352873,'created_by','JOSM'),(53352876,'created_by','JOSM'),(53352878,'created_by','JOSM'),(53352883,'created_by','JOSM'),(53352887,'created_by','JOSM'),(53352890,'created_by','JOSM'),(53352894,'created_by','JOSM'),(53352896,'created_by','JOSM'),(53352899,'created_by','JOSM'),(53352904,'created_by','JOSM'),(53352906,'created_by','JOSM'),(53352907,'created_by','JOSM'),(53352912,'created_by','JOSM'),(53352934,'created_by','JOSM'),(53352938,'created_by','JOSM'),(53352942,'created_by','JOSM'),(53352946,'created_by','JOSM'),(53352948,'created_by','JOSM'),(53352951,'created_by','JOSM'),(53352954,'created_by','JOSM'),(53352957,'created_by','JOSM'),(53352960,'created_by','JOSM'),(53352963,'created_by','JOSM'),(53352966,'created_by','JOSM'),(53352969,'created_by','JOSM'),(53352974,'created_by','JOSM'),(53352975,'created_by','JOSM'),(53353016,'created_by','JOSM'),(53353021,'created_by','JOSM'),(53353024,'created_by','JOSM'),(53353034,'created_by','JOSM'),(53353040,'created_by','JOSM'),(53353043,'created_by','JOSM'),(53353047,'created_by','JOSM'),(53353051,'created_by','JOSM'),(53353055,'created_by','JOSM'),(53353086,'created_by','JOSM'),(53353092,'created_by','JOSM'),(53353108,'created_by','JOSM');
INSERT INTO `current_node_tags` VALUES (53353111,'created_by','JOSM'),(53353121,'created_by','JOSM'),(53353126,'created_by','JOSM'),(53353132,'created_by','JOSM'),(53353141,'created_by','JOSM'),(53353144,'created_by','JOSM'),(53353148,'created_by','JOSM'),(53353151,'created_by','JOSM'),(53353155,'created_by','JOSM'),(53353160,'created_by','JOSM'),(53353163,'created_by','JOSM'),(53353167,'created_by','JOSM'),(53353170,'created_by','JOSM'),(53353174,'created_by','JOSM'),(53353179,'created_by','JOSM'),(53353181,'created_by','JOSM'),(53353183,'created_by','JOSM'),(53353186,'created_by','JOSM'),(53353189,'created_by','JOSM'),(53353193,'created_by','JOSM'),(53353198,'created_by','JOSM'),(53353199,'created_by','JOSM'),(53353203,'created_by','JOSM'),(53353205,'created_by','JOSM'),(53353208,'created_by','JOSM'),(53353211,'created_by','JOSM'),(53353223,'created_by','JOSM'),(53353237,'created_by','JOSM'),(53353302,'created_by','JOSM'),(53353307,'created_by','JOSM'),(53353314,'created_by','JOSM'),(53353319,'created_by','JOSM'),(53353324,'created_by','JOSM'),(53353328,'created_by','JOSM'),(53353333,'created_by','JOSM'),(53353340,'created_by','JOSM'),(53353343,'created_by','JOSM'),(53353345,'created_by','JOSM'),(53353350,'created_by','JOSM'),(53353359,'created_by','JOSM'),(53353366,'created_by','JOSM'),(53353369,'created_by','JOSM'),(53353372,'created_by','JOSM'),(53353375,'created_by','JOSM'),(53353383,'created_by','JOSM'),(53353388,'created_by','JOSM'),(53353391,'created_by','JOSM'),(53353393,'created_by','JOSM'),(53353395,'created_by','JOSM'),(53353404,'created_by','JOSM'),(53353407,'created_by','JOSM'),(53353413,'created_by','JOSM'),(53353421,'created_by','JOSM'),(53353427,'created_by','JOSM'),(53353431,'created_by','JOSM'),(53353435,'created_by','JOSM'),(53368899,'created_by','JOSM'),(53368914,'created_by','JOSM'),(53368932,'created_by','JOSM'),(53368942,'created_by','JOSM'),(53368953,'created_by','JOSM'),(53368973,'created_by','JOSM'),(53368998,'created_by','JOSM'),(53369007,'created_by','JOSM'),(53369015,'created_by','JOSM'),(53369038,'created_by','JOSM'),(53370808,'created_by','JOSM'),(53370819,'created_by','JOSM'),(53370838,'created_by','JOSM'),(53370844,'created_by','JOSM'),(53370871,'created_by','JOSM'),(53370880,'created_by','JOSM'),(53370887,'created_by','JOSM'),(53370890,'created_by','JOSM'),(53370895,'created_by','JOSM'),(53370900,'created_by','JOSM'),(53370906,'created_by','JOSM'),(53370914,'created_by','JOSM'),(53370920,'created_by','JOSM'),(53370935,'created_by','JOSM'),(53370942,'created_by','JOSM'),(53370949,'created_by','JOSM'),(53370956,'created_by','JOSM'),(53370959,'created_by','JOSM'),(53371037,'created_by','JOSM'),(53371050,'created_by','JOSM'),(53371067,'created_by','JOSM'),(53371073,'created_by','JOSM'),(53371079,'created_by','JOSM'),(53371084,'created_by','JOSM'),(53371089,'created_by','JOSM'),(53371093,'created_by','JOSM'),(53371101,'created_by','JOSM'),(53371106,'created_by','JOSM'),(53371115,'created_by','JOSM'),(53371121,'created_by','JOSM'),(53371129,'created_by','JOSM'),(53371134,'created_by','JOSM'),(53371138,'created_by','JOSM'),(53371141,'created_by','JOSM'),(53371144,'created_by','JOSM'),(53371154,'created_by','JOSM'),(53371160,'created_by','JOSM'),(53371174,'created_by','JOSM'),(53371181,'created_by','JOSM'),(53371551,'created_by','JOSM'),(53371691,'created_by','JOSM'),(53371748,'created_by','JOSM'),(53371756,'created_by','JOSM'),(53371761,'created_by','JOSM'),(53371763,'created_by','JOSM'),(53371771,'created_by','JOSM'),(53371778,'created_by','JOSM'),(53371784,'created_by','JOSM'),(53371787,'created_by','JOSM'),(53371793,'created_by','JOSM'),(53371799,'created_by','JOSM'),(53371804,'created_by','JOSM'),(53371810,'created_by','JOSM'),(53371816,'created_by','JOSM'),(53371823,'created_by','JOSM'),(53371827,'created_by','JOSM'),(53371833,'created_by','JOSM'),(53371840,'created_by','JOSM'),(53371845,'created_by','JOSM'),(53371850,'created_by','JOSM'),(53371856,'created_by','JOSM'),(53371859,'created_by','JOSM'),(53371862,'created_by','JOSM'),(53371868,'created_by','JOSM'),(53371873,'created_by','JOSM'),(53371881,'created_by','JOSM'),(53371890,'created_by','JOSM'),(53371908,'created_by','JOSM'),(53371942,'created_by','JOSM'),(53371951,'created_by','JOSM'),(53371955,'created_by','JOSM'),(53371958,'created_by','JOSM'),(53371963,'created_by','JOSM'),(53371969,'created_by','JOSM'),(53371993,'created_by','JOSM'),(53371998,'created_by','JOSM'),(53372005,'created_by','JOSM'),(53372015,'created_by','JOSM'),(53372021,'created_by','JOSM'),(53372044,'created_by','JOSM'),(53372056,'created_by','JOSM'),(53372063,'created_by','JOSM'),(53372072,'created_by','JOSM'),(53372078,'created_by','JOSM'),(53372086,'created_by','JOSM'),(53372094,'created_by','JOSM'),(53372108,'created_by','JOSM'),(53372121,'created_by','JOSM'),(53372132,'created_by','JOSM'),(53372138,'created_by','JOSM'),(53372143,'created_by','JOSM'),(53372151,'created_by','JOSM'),(53372163,'created_by','JOSM'),(53372180,'created_by','JOSM'),(53372190,'created_by','JOSM'),(53372197,'created_by','JOSM'),(53372208,'created_by','JOSM'),(53372217,'created_by','JOSM'),(53372225,'created_by','JOSM'),(53372232,'created_by','JOSM'),(53372242,'created_by','JOSM'),(53372246,'created_by','JOSM'),(53372255,'created_by','JOSM'),(53372261,'created_by','JOSM'),(53372271,'created_by','JOSM'),(53372278,'created_by','JOSM'),(53372284,'created_by','JOSM'),(53372290,'created_by','JOSM'),(53372297,'created_by','JOSM'),(53372305,'created_by','JOSM'),(53372352,'created_by','JOSM'),(53372357,'created_by','JOSM'),(53372365,'created_by','JOSM'),(53372381,'created_by','JOSM'),(53372404,'created_by','JOSM'),(53372410,'created_by','JOSM'),(53372412,'created_by','JOSM'),(53372413,'created_by','JOSM'),(53372418,'created_by','JOSM'),(53372422,'created_by','JOSM'),(53372427,'created_by','JOSM'),(53372432,'created_by','JOSM'),(53372437,'created_by','JOSM'),(53372442,'created_by','JOSM'),(53372446,'created_by','JOSM'),(53372456,'created_by','JOSM'),(53372458,'created_by','JOSM'),(53372462,'created_by','JOSM'),(53372466,'created_by','JOSM'),(53372476,'created_by','JOSM'),(53372487,'created_by','JOSM'),(53372493,'created_by','JOSM'),(53372501,'created_by','JOSM'),(53372509,'created_by','JOSM'),(53372513,'created_by','JOSM'),(53372518,'created_by','JOSM'),(53372522,'created_by','JOSM'),(53372527,'created_by','JOSM'),(53372535,'created_by','JOSM'),(53372541,'created_by','JOSM'),(53372544,'created_by','JOSM'),(53372549,'created_by','JOSM'),(53372555,'created_by','JOSM'),(53372562,'created_by','JOSM'),(53372568,'created_by','JOSM'),(53372577,'created_by','JOSM'),(53372587,'created_by','JOSM'),(53372608,'created_by','JOSM'),(53372614,'created_by','JOSM'),(53372629,'created_by','JOSM'),(53372637,'created_by','JOSM'),(53372777,'created_by','JOSM'),(53372794,'created_by','JOSM'),(53372806,'created_by','JOSM'),(53372815,'created_by','JOSM'),(53372828,'created_by','JOSM'),(53372832,'created_by','JOSM'),(53372838,'created_by','JOSM'),(53372843,'created_by','JOSM'),(53372852,'created_by','JOSM'),(53372858,'created_by','JOSM'),(53372863,'created_by','JOSM'),(53372873,'created_by','JOSM'),(53372879,'created_by','JOSM'),(53372887,'created_by','JOSM'),(53372892,'created_by','JOSM'),(53372903,'created_by','JOSM'),(53372912,'created_by','JOSM'),(53372917,'created_by','JOSM'),(53372927,'created_by','JOSM'),(53372935,'created_by','JOSM'),(53372942,'created_by','JOSM'),(53372956,'created_by','JOSM'),(53372965,'created_by','JOSM'),(53372978,'created_by','JOSM'),(53372982,'created_by','JOSM'),(53372991,'created_by','JOSM'),(53373005,'created_by','JOSM'),(53373016,'created_by','JOSM'),(53373029,'created_by','JOSM'),(53373035,'created_by','JOSM'),(53373049,'created_by','JOSM'),(53373068,'created_by','JOSM'),(53373079,'created_by','JOSM'),(53373094,'created_by','JOSM'),(53373107,'created_by','JOSM'),(53373114,'created_by','JOSM'),(53373121,'created_by','JOSM'),(53373130,'created_by','JOSM'),(53373163,'created_by','JOSM'),(53373182,'created_by','JOSM'),(53373197,'created_by','JOSM'),(53373203,'created_by','JOSM'),(53373215,'created_by','JOSM'),(53373224,'created_by','JOSM'),(53373230,'created_by','JOSM'),(53373233,'created_by','JOSM'),(53373241,'created_by','JOSM'),(53373246,'created_by','JOSM'),(53373251,'created_by','JOSM'),(53373259,'created_by','JOSM'),(53373266,'created_by','JOSM'),(53373270,'created_by','JOSM'),(53373275,'created_by','JOSM'),(53373280,'created_by','JOSM'),(53373289,'created_by','JOSM'),(53373297,'created_by','JOSM'),(53373303,'created_by','JOSM'),(53373308,'created_by','JOSM'),(53373311,'created_by','JOSM'),(53373318,'created_by','JOSM'),(53373327,'created_by','JOSM'),(53373335,'created_by','JOSM'),(53373343,'created_by','JOSM'),(53373348,'created_by','JOSM'),(53373356,'created_by','JOSM'),(53373365,'created_by','JOSM'),(53373376,'created_by','JOSM'),(53373382,'created_by','JOSM'),(53373386,'created_by','JOSM'),(53373392,'created_by','JOSM'),(53373399,'created_by','JOSM'),(53373402,'created_by','JOSM'),(53373406,'created_by','JOSM'),(53373410,'created_by','JOSM'),(53373416,'created_by','JOSM'),(53373457,'created_by','JOSM'),(53373463,'created_by','JOSM'),(53373467,'created_by','JOSM'),(53373472,'created_by','JOSM'),(53373475,'created_by','JOSM'),(53373479,'created_by','JOSM'),(53373480,'created_by','JOSM'),(53373484,'created_by','JOSM'),(53373499,'created_by','JOSM'),(53373501,'created_by','JOSM'),(53373507,'created_by','JOSM'),(53373512,'created_by','JOSM'),(53373516,'created_by','JOSM'),(53373521,'created_by','JOSM'),(53373529,'created_by','JOSM'),(53373532,'created_by','JOSM'),(53373536,'created_by','JOSM'),(53373543,'created_by','JOSM'),(53373545,'created_by','JOSM'),(53373549,'created_by','JOSM'),(53374387,'created_by','JOSM'),(53374403,'created_by','JOSM'),(53374521,'created_by','JOSM'),(53374531,'created_by','JOSM'),(53374534,'created_by','JOSM'),(53374537,'created_by','JOSM'),(53374542,'created_by','JOSM'),(53374635,'created_by','JOSM'),(53374797,'created_by','JOSM'),(53374856,'created_by','JOSM'),(53374862,'created_by','JOSM'),(53374867,'created_by','JOSM'),(53374883,'created_by','JOSM'),(53374887,'created_by','JOSM'),(53374892,'created_by','JOSM'),(53374894,'created_by','JOSM'),(53374897,'created_by','JOSM'),(53374901,'created_by','JOSM'),(53374925,'created_by','JOSM'),(53374929,'created_by','JOSM'),(53375001,'created_by','JOSM'),(53375004,'created_by','JOSM'),(53375007,'created_by','JOSM'),(53375010,'created_by','JOSM'),(53375014,'created_by','JOSM'),(53375016,'created_by','JOSM'),(53375019,'created_by','JOSM'),(53375022,'created_by','JOSM'),(53375026,'created_by','JOSM'),(53375056,'created_by','JOSM'),(53375086,'created_by','JOSM'),(53375126,'created_by','JOSM'),(53375501,'created_by','JOSM'),(53376238,'created_by','JOSM'),(53376244,'created_by','JOSM'),(53376247,'created_by','JOSM'),(53376253,'created_by','JOSM'),(53376257,'created_by','JOSM'),(53376264,'created_by','JOSM'),(53376267,'created_by','JOSM'),(53376272,'created_by','JOSM'),(53376275,'created_by','JOSM'),(53376314,'created_by','JOSM'),(53376323,'created_by','JOSM'),(53376331,'created_by','JOSM'),(53376354,'created_by','JOSM'),(53376363,'created_by','JOSM'),(53376376,'created_by','JOSM'),(53376378,'created_by','JOSM'),(53376383,'created_by','JOSM'),(53376386,'created_by','JOSM'),(53376390,'created_by','JOSM'),(53376392,'created_by','JOSM'),(53376394,'created_by','JOSM'),(53376397,'created_by','JOSM'),(53376399,'created_by','JOSM'),(53376401,'created_by','JOSM'),(53376405,'created_by','JOSM'),(53376408,'created_by','JOSM'),(53376414,'created_by','JOSM'),(53376419,'created_by','JOSM'),(53376421,'created_by','JOSM'),(53376423,'created_by','JOSM'),(53376428,'created_by','JOSM'),(53376431,'created_by','JOSM'),(53376435,'created_by','JOSM'),(53376437,'created_by','JOSM'),(53376438,'created_by','JOSM'),(53376440,'created_by','JOSM'),(53376442,'created_by','JOSM'),(53376444,'created_by','JOSM'),(53376448,'created_by','JOSM'),(53376451,'created_by','JOSM'),(53376626,'created_by','JOSM'),(53376629,'created_by','JOSM'),(53376632,'created_by','JOSM'),(53376634,'created_by','JOSM'),(53376637,'created_by','JOSM'),(53376658,'created_by','JOSM'),(53376660,'created_by','JOSM'),(53376663,'created_by','JOSM'),(53376664,'created_by','JOSM'),(53376666,'created_by','JOSM'),(53376670,'created_by','JOSM'),(53376674,'created_by','JOSM'),(53376677,'created_by','JOSM'),(53376682,'created_by','JOSM'),(53376683,'created_by','JOSM'),(53376686,'created_by','JOSM'),(53376689,'created_by','JOSM'),(53376692,'created_by','JOSM'),(53376695,'created_by','JOSM'),(53376699,'created_by','JOSM'),(53376702,'created_by','JOSM'),(53376704,'created_by','JOSM'),(53376709,'created_by','JOSM'),(53376715,'created_by','JOSM'),(53376719,'created_by','JOSM'),(53376723,'created_by','JOSM'),(53376729,'created_by','JOSM'),(53376733,'created_by','JOSM'),(53376737,'created_by','JOSM'),(53376740,'created_by','JOSM'),(53376743,'created_by','JOSM'),(53376746,'created_by','JOSM'),(53376748,'created_by','JOSM'),(53376750,'created_by','JOSM'),(53376751,'created_by','JOSM'),(53376753,'created_by','JOSM'),(53376754,'created_by','JOSM'),(53376756,'created_by','JOSM'),(53376757,'created_by','JOSM'),(53376761,'created_by','JOSM'),(53376764,'created_by','JOSM'),(53376766,'created_by','JOSM'),(53376768,'created_by','JOSM'),(53376771,'created_by','JOSM'),(53376772,'created_by','JOSM'),(53376775,'created_by','JOSM'),(53376777,'created_by','JOSM'),(53376780,'created_by','JOSM'),(53376782,'created_by','JOSM'),(53376784,'created_by','JOSM'),(53376788,'created_by','JOSM'),(53376797,'created_by','JOSM'),(53376799,'created_by','JOSM'),(53376802,'created_by','JOSM'),(53376806,'created_by','JOSM'),(53376810,'created_by','JOSM'),(53376814,'created_by','JOSM'),(53376816,'created_by','JOSM'),(53376820,'created_by','JOSM'),(53376827,'created_by','JOSM'),(53376830,'created_by','JOSM'),(53376834,'created_by','JOSM'),(53376837,'created_by','JOSM'),(53376840,'created_by','JOSM'),(53376847,'created_by','JOSM'),(53376853,'created_by','JOSM'),(53376856,'created_by','JOSM'),(53376859,'created_by','JOSM'),(53376862,'created_by','JOSM'),(53376864,'created_by','JOSM'),(53376873,'created_by','JOSM'),(53376881,'created_by','JOSM'),(53376883,'created_by','JOSM'),(53376887,'created_by','JOSM'),(53376891,'created_by','JOSM'),(53376895,'created_by','JOSM'),(53376898,'created_by','JOSM'),(53376899,'created_by','JOSM'),(53376955,'created_by','JOSM'),(53376959,'created_by','JOSM'),(53376962,'created_by','JOSM'),(53376964,'created_by','JOSM'),(53376968,'created_by','JOSM'),(53376972,'created_by','JOSM'),(53376975,'created_by','JOSM'),(53376979,'created_by','JOSM'),(53376983,'created_by','JOSM'),(53376987,'created_by','JOSM'),(53376989,'created_by','JOSM'),(53376996,'created_by','JOSM'),(53377001,'created_by','JOSM'),(53377006,'created_by','JOSM'),(53377009,'created_by','JOSM'),(53377015,'created_by','JOSM'),(53377018,'created_by','JOSM'),(53377021,'created_by','JOSM'),(53377027,'created_by','JOSM'),(53377032,'created_by','JOSM'),(53377035,'created_by','JOSM'),(53377040,'created_by','JOSM'),(53377045,'created_by','JOSM'),(53377047,'created_by','JOSM'),(53377049,'created_by','JOSM'),(53377051,'created_by','JOSM'),(53377053,'created_by','JOSM'),(53377058,'created_by','JOSM'),(53377061,'created_by','JOSM'),(53377065,'created_by','JOSM'),(53377068,'created_by','JOSM'),(53377070,'created_by','JOSM'),(53377077,'created_by','JOSM'),(53377080,'created_by','JOSM'),(53377090,'created_by','JOSM'),(53377093,'created_by','JOSM'),(53377098,'created_by','JOSM'),(53377104,'created_by','JOSM'),(53377113,'created_by','JOSM'),(53377119,'created_by','JOSM'),(53377124,'created_by','JOSM'),(53377128,'created_by','JOSM'),(53377133,'created_by','JOSM'),(53377138,'created_by','JOSM'),(53377141,'created_by','JOSM'),(53377146,'created_by','JOSM'),(53377151,'created_by','JOSM'),(53377156,'created_by','JOSM'),(53377163,'created_by','JOSM'),(53377168,'created_by','JOSM'),(53377175,'created_by','JOSM'),(53377178,'created_by','JOSM'),(53377180,'created_by','JOSM'),(53377183,'created_by','JOSM'),(53377186,'created_by','JOSM'),(53377191,'created_by','JOSM'),(53377195,'created_by','JOSM'),(53380473,'created_by','JOSM'),(53380480,'created_by','JOSM'),(53380485,'created_by','JOSM'),(53380489,'created_by','JOSM'),(53380491,'created_by','JOSM'),(53380499,'created_by','JOSM'),(53380503,'created_by','JOSM'),(53381711,'created_by','JOSM'),(53381723,'created_by','JOSM'),(53381733,'created_by','JOSM'),(53381738,'created_by','JOSM'),(53381779,'created_by','JOSM'),(53381787,'created_by','JOSM'),(53381798,'created_by','JOSM'),(53381809,'created_by','JOSM'),(53381818,'created_by','JOSM'),(53381825,'created_by','JOSM'),(53381829,'created_by','JOSM'),(53381832,'created_by','JOSM'),(53381834,'created_by','JOSM'),(53381837,'created_by','JOSM'),(53381842,'created_by','JOSM'),(53381844,'created_by','JOSM'),(53381850,'created_by','JOSM'),(53381892,'created_by','JOSM'),(53381925,'created_by','JOSM'),(53381944,'created_by','JOSM'),(53381947,'created_by','JOSM'),(53381978,'created_by','JOSM'),(53381995,'created_by','JOSM'),(53382002,'created_by','JOSM'),(53382009,'created_by','JOSM'),(53382019,'created_by','JOSM'),(53382028,'created_by','JOSM'),(53382033,'created_by','JOSM'),(53382041,'created_by','JOSM'),(53382044,'created_by','JOSM'),(53382047,'created_by','JOSM'),(53382052,'created_by','JOSM'),(53382055,'created_by','JOSM'),(53382059,'created_by','JOSM'),(53382064,'created_by','JOSM'),(53382089,'created_by','JOSM'),(53382106,'created_by','JOSM'),(53382126,'created_by','JOSM'),(53382156,'created_by','JOSM'),(53382223,'created_by','JOSM'),(53382318,'created_by','JOSM'),(53382504,'created_by','JOSM'),(53382509,'created_by','JOSM'),(53382959,'created_by','JOSM'),(53383168,'created_by','JOSM'),(53383242,'created_by','JOSM'),(53383258,'created_by','JOSM'),(53383280,'created_by','JOSM'),(53383286,'created_by','JOSM'),(53383289,'created_by','JOSM'),(53383297,'created_by','JOSM'),(53383310,'created_by','JOSM'),(53383321,'created_by','JOSM'),(53383324,'created_by','JOSM'),(53383336,'created_by','JOSM'),(53383341,'created_by','JOSM'),(53383350,'created_by','JOSM'),(53383356,'created_by','JOSM'),(53383364,'created_by','JOSM'),(53383369,'created_by','JOSM'),(53383373,'created_by','JOSM'),(53383379,'created_by','JOSM'),(53383384,'created_by','JOSM'),(53383388,'created_by','JOSM'),(53383393,'created_by','JOSM'),(53383398,'created_by','JOSM'),(53383403,'created_by','JOSM'),(53383409,'created_by','JOSM'),(53383415,'created_by','JOSM'),(53383419,'created_by','JOSM'),(53383424,'created_by','JOSM'),(53383429,'created_by','JOSM'),(53383434,'created_by','JOSM'),(53383440,'created_by','JOSM'),(53383445,'created_by','JOSM'),(53383451,'created_by','JOSM'),(53383455,'created_by','JOSM'),(53383459,'created_by','JOSM'),(53383468,'created_by','JOSM'),(53383474,'created_by','JOSM'),(53383480,'created_by','JOSM'),(53383487,'created_by','JOSM'),(53383494,'created_by','JOSM'),(53383497,'created_by','JOSM'),(53383499,'created_by','JOSM'),(53383505,'created_by','JOSM'),(53383508,'created_by','JOSM'),(53383523,'created_by','JOSM'),(53383556,'created_by','JOSM'),(53383559,'created_by','JOSM'),(53383561,'created_by','JOSM'),(53383562,'created_by','JOSM'),(53383566,'created_by','JOSM'),(53383579,'created_by','JOSM'),(53383582,'created_by','JOSM'),(53383584,'created_by','JOSM'),(53383597,'created_by','JOSM'),(53383600,'created_by','JOSM'),(53383603,'created_by','JOSM'),(53383605,'created_by','JOSM'),(53383606,'created_by','JOSM'),(53383610,'created_by','JOSM'),(53383612,'created_by','JOSM'),(53383614,'created_by','JOSM'),(53383617,'created_by','JOSM'),(53383620,'created_by','JOSM'),(53383622,'created_by','JOSM'),(53383624,'created_by','JOSM'),(53383626,'created_by','JOSM'),(53383628,'created_by','JOSM'),(53383631,'created_by','JOSM'),(53383634,'created_by','JOSM'),(53383636,'created_by','JOSM'),(53383639,'created_by','JOSM'),(53383643,'created_by','JOSM'),(53383646,'created_by','JOSM'),(53383670,'created_by','JOSM'),(53383680,'created_by','JOSM'),(53383685,'created_by','JOSM'),(53383688,'created_by','JOSM'),(53383691,'created_by','JOSM'),(53383694,'created_by','JOSM'),(53383698,'created_by','JOSM'),(53383728,'created_by','JOSM'),(53383735,'created_by','JOSM'),(53383739,'created_by','JOSM'),(53383762,'created_by','JOSM'),(53383772,'created_by','JOSM'),(53383793,'created_by','JOSM'),(53383842,'created_by','JOSM'),(53383953,'created_by','JOSM'),(53383956,'created_by','JOSM'),(53383958,'created_by','JOSM'),(53383961,'created_by','JOSM'),(53383970,'created_by','JOSM'),(53383987,'created_by','JOSM'),(53383990,'created_by','JOSM'),(53384000,'created_by','JOSM'),(53384003,'created_by','JOSM'),(53384008,'created_by','JOSM'),(53384011,'created_by','JOSM'),(53384013,'created_by','JOSM'),(53384016,'created_by','JOSM'),(53384020,'created_by','JOSM'),(53384024,'created_by','JOSM'),(53384026,'created_by','JOSM'),(53384030,'created_by','JOSM'),(53384033,'created_by','JOSM'),(53384036,'created_by','JOSM'),(53384038,'created_by','JOSM'),(53384040,'created_by','JOSM'),(53384065,'created_by','JOSM'),(53384068,'created_by','JOSM'),(53384120,'created_by','JOSM'),(53384283,'created_by','JOSM'),(53384287,'created_by','JOSM'),(53384302,'created_by','JOSM'),(53384325,'created_by','JOSM'),(53384330,'created_by','JOSM'),(53384332,'created_by','JOSM'),(53384335,'created_by','JOSM'),(53384338,'created_by','JOSM'),(53384375,'created_by','JOSM'),(53385461,'created_by','JOSM'),(53385467,'created_by','JOSM'),(53385484,'created_by','JOSM'),(53385511,'created_by','JOSM'),(53387182,'created_by','JOSM'),(53388340,'created_by','JOSM'),(53388543,'created_by','JOSM'),(53389302,'created_by','JOSM'),(53389827,'created_by','JOSM'),(53390266,'created_by','JOSM'),(53390450,'created_by','JOSM'),(53390493,'created_by','JOSM'),(53390505,'created_by','JOSM'),(53390513,'created_by','JOSM'),(53390521,'created_by','JOSM'),(53390534,'created_by','JOSM'),(53390548,'created_by','JOSM'),(53390624,'created_by','JOSM'),(53390658,'created_by','JOSM'),(53390732,'created_by','JOSM'),(53390740,'created_by','JOSM'),(53390749,'created_by','JOSM'),(53390776,'created_by','JOSM'),(53390786,'created_by','JOSM'),(53392096,'created_by','JOSM'),(53392102,'created_by','JOSM'),(53392109,'created_by','JOSM'),(53392116,'created_by','JOSM'),(53392136,'created_by','JOSM'),(53392141,'created_by','JOSM'),(53392147,'created_by','JOSM'),(53392151,'created_by','JOSM'),(53392160,'created_by','JOSM'),(53392164,'created_by','JOSM'),(53392166,'created_by','JOSM'),(53392168,'created_by','JOSM'),(53392180,'created_by','JOSM'),(53392185,'created_by','JOSM'),(53392195,'created_by','JOSM'),(53392200,'created_by','JOSM'),(53392203,'created_by','JOSM'),(53392207,'created_by','JOSM'),(53392208,'created_by','JOSM'),(53392215,'created_by','JOSM'),(53392222,'created_by','JOSM'),(53392224,'created_by','JOSM'),(53392227,'created_by','JOSM'),(53392235,'created_by','JOSM'),(53392239,'created_by','JOSM'),(58957648,'capital','yes'),(58957648,'is_in','Andorra'),(58957648,'name','Andorra la Vella'),(58957648,'name:an','Andorra la Biella'),(58957648,'name:ar','?????? ?? ????'),(58957648,'name:bg','?????? ?? ????'),(58957648,'name:ca','Andorra la Vella'),(58957648,'name:es','Andorra la Vieja'),(58957648,'name:fr','Andorre-la-Vieille'),(58957648,'name:he','?????? ?? ???'),(58957648,'name:is','Andorra la Vella'),(58957648,'name:ja','??????????'),(58957648,'name:ko','??????'),(58957648,'name:la','Andorra Vetus'),(58957648,'name:lt','Andora'),(58957648,'name:lv','Andora la Velja'),(58957648,'name:oc','Andòrra la Vièlha'),(58957648,'name:pl','Andora'),(58957648,'name:pt','Andorra-a-Velha'),(58957648,'name:ru','???????-??-?????'),(58957648,'name:sr','?????? ?? ????'),(58957648,'name:zh','????'),(58957648,'place','town'),(58957648,'population','24678'),(58957648,'wikipedia:fr','Andorre-la-Vieille'),(58963219,'created_by','Potlatch 0.4a'),(58963219,'is_in','Andorra'),(58963219,'name','Ordino'),(58963219,'place','town'),(64796296,'created_by','JOSM'),(64796297,'created_by','JOSM'),(64796301,'created_by','JOSM'),(64796302,'created_by','JOSM'),(64796303,'created_by','JOSM'),(64796304,'created_by','JOSM'),(64796308,'created_by','JOSM'),(64796309,'created_by','JOSM'),(64796310,'created_by','JOSM'),(64796311,'created_by','JOSM'),(64796315,'created_by','JOSM'),(64796316,'created_by','JOSM'),(64796317,'created_by','JOSM'),(64796318,'created_by','JOSM'),(64796322,'created_by','JOSM'),(64796323,'created_by','JOSM'),(64796324,'created_by','JOSM'),(64796325,'created_by','JOSM'),(64796329,'created_by','JOSM'),(64796330,'created_by','JOSM'),(64796331,'created_by','JOSM'),(64796332,'created_by','JOSM'),(64796335,'created_by','JOSM'),(64796337,'created_by','JOSM'),(64796338,'created_by','JOSM'),(64796339,'created_by','JOSM'),(64796340,'created_by','JOSM'),(64796344,'created_by','JOSM'),(64796345,'created_by','JOSM'),(64796346,'created_by','JOSM'),(64796349,'created_by','JOSM'),(64796351,'created_by','JOSM'),(64796352,'created_by','JOSM'),(64796353,'created_by','JOSM'),(64796356,'created_by','JOSM'),(64796358,'created_by','JOSM'),(64796359,'created_by','JOSM'),(64796360,'created_by','JOSM'),(64796363,'created_by','JOSM'),(64796365,'created_by','JOSM'),(64796366,'created_by','JOSM'),(64796367,'created_by','JOSM'),(64796368,'created_by','JOSM'),(64796372,'created_by','JOSM'),(64796373,'created_by','JOSM'),(64796374,'created_by','JOSM'),(64796375,'created_by','JOSM'),(64796376,'created_by','JOSM'),(64796377,'created_by','JOSM'),(64796381,'created_by','JOSM'),(64796382,'created_by','JOSM'),(64796383,'created_by','JOSM'),(64796385,'created_by','JOSM'),(64796388,'created_by','JOSM'),(64798267,'created_by','JOSM'),(64798268,'created_by','JOSM'),(64798270,'created_by','JOSM'),(64798271,'created_by','JOSM'),(64798274,'created_by','JOSM'),(64798275,'created_by','JOSM'),(64798277,'created_by','JOSM'),(64798278,'created_by','JOSM'),(64798280,'created_by','JOSM'),(64798282,'created_by','JOSM'),(64798283,'created_by','JOSM'),(64798285,'created_by','JOSM'),(64798286,'created_by','JOSM'),(64798289,'created_by','JOSM'),(64798290,'created_by','JOSM'),(64798291,'created_by','JOSM'),(64798293,'created_by','JOSM'),(64798295,'created_by','JOSM'),(64798297,'created_by','JOSM'),(64798298,'created_by','JOSM'),(64798300,'created_by','JOSM'),(64798301,'created_by','JOSM'),(64798304,'created_by','JOSM'),(64798305,'created_by','JOSM'),(64798306,'created_by','JOSM'),(64798308,'created_by','JOSM'),(64798310,'created_by','JOSM'),(64798312,'created_by','JOSM'),(64798313,'created_by','JOSM'),(64798315,'created_by','JOSM'),(64798316,'created_by','JOSM'),(64798319,'created_by','JOSM'),(64798320,'created_by','JOSM'),(64798321,'created_by','JOSM'),(64798323,'created_by','JOSM'),(64798324,'created_by','JOSM'),(64798327,'created_by','JOSM'),(64798328,'created_by','JOSM'),(64798329,'created_by','JOSM'),(64798331,'created_by','JOSM'),(64798333,'created_by','JOSM'),(64798335,'created_by','JOSM'),(64798336,'created_by','JOSM'),(64798337,'created_by','JOSM'),(64798339,'created_by','JOSM'),(64798342,'created_by','JOSM'),(64798343,'created_by','JOSM'),(64798344,'created_by','JOSM'),(64798345,'created_by','JOSM'),(64798347,'created_by','JOSM'),(64798350,'created_by','JOSM'),(64798351,'created_by','JOSM'),(64798352,'created_by','JOSM'),(64801605,'created_by','JOSM'),(64801639,'created_by','JOSM'),(64801640,'created_by','JOSM'),(64801644,'created_by','JOSM'),(64801645,'created_by','JOSM'),(64801646,'created_by','JOSM'),(64801648,'created_by','JOSM'),(64801651,'created_by','JOSM'),(64801652,'created_by','JOSM'),(64801654,'created_by','JOSM'),(64801657,'created_by','JOSM'),(64801659,'created_by','JOSM'),(64801660,'created_by','JOSM'),(64801663,'created_by','JOSM'),(64801667,'created_by','JOSM'),(64801670,'created_by','JOSM'),(64801672,'created_by','JOSM'),(64801673,'created_by','JOSM'),(64801675,'created_by','JOSM'),(64801678,'created_by','JOSM'),(64801679,'created_by','JOSM'),(64801681,'created_by','JOSM'),(64801684,'created_by','JOSM'),(64801685,'created_by','JOSM'),(64801686,'created_by','JOSM'),(64801688,'created_by','JOSM'),(64801690,'created_by','JOSM'),(64801693,'created_by','JOSM'),(64801694,'created_by','JOSM'),(64801695,'created_by','JOSM'),(64801697,'created_by','JOSM'),(64801702,'created_by','JOSM'),(64801703,'created_by','JOSM'),(64801704,'created_by','JOSM'),(64801705,'created_by','JOSM'),(64801709,'created_by','JOSM'),(64801710,'created_by','JOSM'),(64801711,'created_by','JOSM'),(64801712,'created_by','JOSM'),(64801714,'created_by','JOSM'),(64801717,'created_by','JOSM'),(64801718,'created_by','JOSM'),(64801719,'created_by','JOSM'),(64801721,'created_by','JOSM'),(64801724,'created_by','JOSM'),(64801725,'created_by','JOSM'),(64801729,'created_by','JOSM'),(64801739,'created_by','JOSM'),(64801740,'created_by','JOSM'),(64801741,'created_by','JOSM'),(64801745,'created_by','JOSM'),(64801746,'created_by','JOSM'),(64801747,'created_by','JOSM'),(64801748,'created_by','JOSM'),(64801751,'created_by','JOSM'),(64801753,'created_by','JOSM'),(64801754,'created_by','JOSM'),(64801758,'created_by','JOSM'),(64801759,'created_by','JOSM'),(64801761,'created_by','JOSM'),(64801762,'created_by','JOSM'),(64801766,'created_by','JOSM'),(64801770,'created_by','JOSM'),(64801773,'created_by','JOSM'),(64801774,'created_by','JOSM'),(64801778,'created_by','JOSM'),(64801779,'created_by','JOSM'),(64801780,'created_by','JOSM'),(64801785,'created_by','JOSM'),(64801795,'created_by','JOSM'),(64801802,'created_by','JOSM'),(64801803,'created_by','JOSM'),(64801804,'created_by','JOSM'),(64801805,'created_by','JOSM'),(64801809,'created_by','JOSM'),(64801810,'created_by','JOSM'),(64801811,'created_by','JOSM'),(64801812,'created_by','JOSM'),(64801816,'created_by','JOSM'),(64801817,'created_by','JOSM'),(64801818,'created_by','JOSM'),(64801819,'created_by','JOSM'),(64803147,'created_by','JOSM'),(64803150,'created_by','JOSM'),(64803152,'created_by','JOSM'),(64803153,'created_by','JOSM'),(64803154,'created_by','JOSM'),(64803157,'created_by','JOSM'),(64803159,'created_by','JOSM'),(64803160,'created_by','JOSM'),(64803161,'created_by','JOSM'),(64803162,'created_by','JOSM'),(64803165,'created_by','JOSM'),(64803167,'created_by','JOSM'),(64803168,'created_by','JOSM'),(64803169,'created_by','JOSM'),(64803172,'created_by','JOSM'),(64803174,'created_by','JOSM'),(64803175,'created_by','JOSM'),(64803176,'created_by','JOSM'),(64803177,'created_by','JOSM'),(64803180,'created_by','JOSM'),(64803182,'created_by','JOSM'),(64803183,'created_by','JOSM'),(64803184,'created_by','JOSM'),(64803185,'created_by','JOSM'),(64803188,'created_by','JOSM'),(64803190,'created_by','JOSM'),(64803191,'created_by','JOSM'),(64803192,'created_by','JOSM'),(64803195,'created_by','JOSM'),(64803197,'created_by','JOSM'),(64803198,'created_by','JOSM'),(64803199,'created_by','JOSM'),(64840709,'created_by','JOSM'),(64840717,'created_by','JOSM'),(64840721,'created_by','JOSM'),(64840726,'created_by','JOSM'),(64840730,'created_by','JOSM'),(64840732,'created_by','JOSM'),(64840738,'created_by','JOSM'),(64840741,'created_by','JOSM'),(64840744,'created_by','JOSM'),(64840746,'created_by','JOSM'),(64840750,'created_by','JOSM'),(64840753,'created_by','JOSM'),(64840755,'created_by','JOSM'),(64840758,'created_by','JOSM'),(64840759,'created_by','JOSM'),(64840761,'created_by','JOSM'),(64840762,'created_by','JOSM'),(64840767,'created_by','JOSM'),(64840769,'created_by','JOSM'),(64840773,'created_by','JOSM'),(64840778,'created_by','JOSM'),(64840781,'created_by','JOSM'),(64840785,'created_by','JOSM'),(64840790,'created_by','JOSM'),(64840792,'created_by','JOSM'),(64840793,'created_by','JOSM'),(64840797,'created_by','JOSM'),(64840799,'created_by','JOSM'),(64840802,'created_by','JOSM'),(64840806,'created_by','JOSM'),(64840812,'created_by','JOSM'),(64840816,'created_by','JOSM'),(64840820,'created_by','JOSM'),(64840823,'created_by','JOSM'),(64840828,'created_by','JOSM'),(64840832,'created_by','JOSM'),(64840836,'created_by','JOSM'),(64840839,'created_by','JOSM'),(64840843,'created_by','JOSM'),(64840848,'created_by','JOSM'),(64840849,'created_by','JOSM'),(64840854,'created_by','JOSM'),(64840858,'created_by','JOSM'),(64840861,'created_by','JOSM'),(64840865,'created_by','JOSM'),(64840868,'created_by','JOSM'),(64840872,'created_by','JOSM'),(64840877,'created_by','JOSM'),(64840882,'created_by','JOSM'),(64840886,'created_by','JOSM'),(64840890,'created_by','JOSM'),(64840895,'created_by','JOSM'),(64840899,'created_by','JOSM'),(64840903,'created_by','JOSM'),(64840907,'created_by','JOSM'),(64840911,'created_by','JOSM'),(64840916,'created_by','JOSM'),(64840918,'created_by','JOSM'),(64840922,'created_by','JOSM'),(64840923,'created_by','JOSM'),(64840926,'created_by','JOSM'),(64840929,'created_by','JOSM'),(64840932,'created_by','JOSM'),(64840933,'created_by','JOSM'),(64840934,'created_by','JOSM'),(64840936,'created_by','JOSM'),(64840940,'created_by','JOSM'),(64840946,'created_by','JOSM'),(64840950,'created_by','JOSM'),(64840954,'created_by','JOSM'),(64840959,'created_by','JOSM'),(64840961,'created_by','JOSM'),(64840965,'created_by','JOSM'),(64840968,'created_by','JOSM'),(64840971,'created_by','JOSM'),(64840975,'created_by','JOSM'),(64840979,'created_by','JOSM'),(64840982,'created_by','JOSM'),(64840985,'created_by','JOSM'),(64840987,'created_by','JOSM'),(64840992,'created_by','JOSM'),(64840996,'created_by','JOSM'),(64840997,'created_by','JOSM'),(64840998,'created_by','JOSM'),(64841000,'created_by','JOSM'),(64841005,'created_by','JOSM'),(64841007,'created_by','JOSM'),(64841008,'created_by','JOSM'),(64841013,'created_by','JOSM'),(64841018,'created_by','JOSM'),(64841023,'created_by','JOSM'),(64841026,'created_by','JOSM'),(64841028,'created_by','JOSM'),(64841033,'created_by','JOSM'),(64841037,'created_by','JOSM'),(64841039,'created_by','JOSM'),(64841042,'created_by','JOSM'),(64841046,'created_by','JOSM'),(64841049,'created_by','JOSM'),(64841051,'created_by','JOSM'),(64841053,'created_by','JOSM'),(64841057,'created_by','JOSM'),(64841061,'created_by','JOSM'),(64841066,'created_by','JOSM'),(64841070,'created_by','JOSM'),(64841074,'created_by','JOSM'),(64841080,'created_by','JOSM'),(64841084,'created_by','JOSM'),(64841088,'created_by','JOSM'),(64841091,'created_by','JOSM'),(64841092,'created_by','JOSM'),(64841094,'created_by','JOSM'),(64841097,'created_by','JOSM'),(64841099,'created_by','JOSM'),(64841100,'created_by','JOSM'),(64841101,'created_by','JOSM'),(64841105,'created_by','JOSM'),(64841106,'created_by','JOSM'),(64841108,'created_by','JOSM'),(64841109,'created_by','JOSM'),(64841113,'created_by','JOSM'),(64841115,'created_by','JOSM'),(64841118,'created_by','JOSM'),(64841119,'created_by','JOSM'),(64841120,'created_by','JOSM'),(64841123,'created_by','JOSM'),(64841125,'created_by','JOSM'),(64841128,'created_by','JOSM'),(64841129,'created_by','JOSM'),(64841132,'created_by','JOSM'),(64841134,'created_by','JOSM'),(64841136,'created_by','JOSM'),(64841139,'created_by','JOSM'),(64841145,'created_by','JOSM'),(64841148,'created_by','JOSM'),(64841151,'created_by','JOSM'),(64841154,'created_by','JOSM'),(64841158,'created_by','JOSM'),(64841162,'created_by','JOSM'),(64841165,'created_by','JOSM'),(64841166,'created_by','JOSM'),(64841169,'created_by','JOSM'),(64841177,'created_by','JOSM'),(64841180,'created_by','JOSM'),(64841183,'created_by','JOSM'),(64841185,'created_by','JOSM'),(64841188,'created_by','JOSM'),(64841191,'created_by','JOSM'),(64841194,'created_by','JOSM'),(64841197,'created_by','JOSM'),(64841198,'created_by','JOSM'),(64841202,'created_by','JOSM'),(64841205,'created_by','JOSM'),(64841208,'created_by','JOSM'),(64841211,'created_by','JOSM'),(64841215,'created_by','JOSM'),(64841220,'created_by','JOSM'),(64841224,'created_by','JOSM'),(64841229,'created_by','JOSM'),(64841233,'created_by','JOSM'),(64841236,'created_by','JOSM'),(64841238,'created_by','JOSM'),(64841243,'created_by','JOSM'),(64841245,'created_by','JOSM'),(64841248,'created_by','JOSM'),(64841254,'created_by','JOSM'),(64841257,'created_by','JOSM'),(64841260,'created_by','JOSM'),(64841263,'created_by','JOSM'),(64841266,'created_by','JOSM'),(64841268,'created_by','JOSM'),(64841271,'created_by','JOSM'),(64841274,'created_by','JOSM'),(64841278,'created_by','JOSM'),(64841281,'created_by','JOSM'),(64841282,'created_by','JOSM'),(64841286,'created_by','JOSM'),(64841290,'created_by','JOSM'),(64841293,'created_by','JOSM'),(64841297,'created_by','JOSM'),(64841301,'created_by','JOSM'),(64841307,'created_by','JOSM'),(64841311,'created_by','JOSM'),(64841315,'created_by','JOSM'),(64841316,'created_by','JOSM'),(64841319,'created_by','JOSM'),(64841321,'created_by','JOSM'),(64841324,'created_by','JOSM'),(64841329,'created_by','JOSM'),(64841333,'created_by','JOSM'),(64841337,'created_by','JOSM'),(64841341,'created_by','JOSM'),(64841344,'created_by','JOSM'),(64841346,'created_by','JOSM'),(64841351,'created_by','JOSM'),(64841356,'created_by','JOSM'),(64841360,'created_by','JOSM'),(64841365,'created_by','JOSM'),(64841367,'created_by','JOSM'),(64841370,'created_by','JOSM'),(64841373,'created_by','JOSM'),(64841375,'created_by','JOSM'),(64841376,'created_by','JOSM'),(64841379,'created_by','JOSM'),(64841383,'created_by','JOSM'),(64841386,'created_by','JOSM'),(64841388,'created_by','JOSM'),(64841390,'created_by','JOSM'),(64841393,'created_by','JOSM'),(64841396,'created_by','JOSM'),(64841399,'created_by','JOSM'),(64841407,'created_by','JOSM'),(64841415,'created_by','JOSM'),(64841424,'created_by','JOSM'),(64841431,'created_by','JOSM'),(64841433,'created_by','JOSM'),(64841434,'created_by','JOSM'),(64841436,'created_by','JOSM'),(64841439,'created_by','JOSM'),(64841441,'created_by','JOSM'),(64841444,'created_by','JOSM'),(64841446,'created_by','JOSM'),(64841451,'created_by','JOSM'),(64841452,'created_by','JOSM'),(64841454,'created_by','JOSM'),(64841456,'created_by','JOSM'),(64841461,'created_by','JOSM'),(64841463,'created_by','JOSM'),(64841468,'created_by','JOSM'),(64841472,'created_by','JOSM'),(64841473,'created_by','JOSM'),(64841478,'created_by','JOSM'),(64841481,'created_by','JOSM'),(64841483,'created_by','JOSM'),(64841487,'created_by','JOSM'),(64841488,'created_by','JOSM'),(64841491,'created_by','JOSM'),(64841497,'created_by','JOSM'),(64841499,'created_by','JOSM'),(64841502,'created_by','JOSM'),(64841507,'created_by','JOSM'),(64841511,'created_by','JOSM'),(64841514,'created_by','JOSM'),(64841518,'created_by','JOSM'),(64841521,'created_by','JOSM'),(64841525,'created_by','JOSM'),(64841529,'created_by','JOSM'),(64841532,'created_by','JOSM'),(64841537,'created_by','JOSM'),(64841541,'created_by','JOSM'),(64841547,'created_by','JOSM'),(64841550,'created_by','JOSM'),(64841551,'created_by','JOSM'),(64841553,'created_by','JOSM'),(64841557,'created_by','JOSM'),(64841561,'created_by','JOSM'),(64841566,'created_by','JOSM'),(64841570,'created_by','JOSM'),(64841573,'created_by','JOSM'),(64841579,'created_by','JOSM'),(64841582,'created_by','JOSM'),(64841584,'created_by','JOSM'),(64841587,'created_by','JOSM'),(64841591,'created_by','JOSM'),(64841597,'created_by','JOSM'),(64841600,'created_by','JOSM'),(64841603,'created_by','JOSM'),(64841606,'created_by','JOSM'),(64841612,'created_by','JOSM'),(64841617,'created_by','JOSM'),(64841620,'created_by','JOSM'),(64841623,'created_by','JOSM'),(64841627,'created_by','JOSM'),(64841630,'created_by','JOSM'),(64841635,'created_by','JOSM'),(64841638,'created_by','JOSM'),(64841640,'created_by','JOSM'),(64841645,'created_by','JOSM'),(64841649,'created_by','JOSM'),(64841652,'created_by','JOSM'),(64841654,'created_by','JOSM'),(64954372,'created_by','JOSM'),(64954372,'gns:ADM1','00'),(64954372,'gns:N:xx:FULL_NAME','Aixàs'),(64954372,'gns:N:xx:FULL_NAME_ND','Aixas'),(64954372,'gns:N:xx:NT','N'),(64954372,'gns:N:xx:SORT_NAME','AIXAS'),(64954372,'gns:RC','1'),(64954372,'gns:UFI','-1394392'),(64954372,'gns:UNI','-2001996'),(64954372,'name','Aixàs'),(64954372,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954372,'place','hamlet'),(64954372,'source','gns_an'),(64954377,'created_by','Potlatch 0.10f'),(64954377,'gns:ADM1','00'),(64954377,'gns:N:xx:FULL_NAME','Aubinyà'),(64954377,'gns:N:xx:FULL_NAME_ND','Aubinya'),(64954377,'gns:N:xx:NT','N'),(64954377,'gns:N:xx:SORT_NAME','AUBINYA'),(64954377,'gns:RC','1'),(64954377,'gns:UFI','-1394528'),(64954377,'gns:UNI','-2002172'),(64954377,'gns:V:xx:FULL_NAME','Auvinya'),(64954377,'gns:V:xx:FULL_NAME_ND','Auvinya'),(64954377,'gns:V:xx:MODIFY_DATE','1993-12-23'),(64954377,'gns:V:xx:NT','V'),(64954377,'gns:V:xx:SORT_NAME','AUVINYA'),(64954377,'name','Aubinyà'),(64954377,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954377,'place','village'),(64954377,'source','gns_an'),(64954382,'created_by','Potlatch 0.8a'),(64954382,'gns:ADM1','00'),(64954382,'gns:N:xx:FULL_NAME','Juberri'),(64954382,'gns:N:xx:FULL_NAME_ND','Juberri'),(64954382,'gns:N:xx:NT','N'),(64954382,'gns:N:xx:SORT_NAME','JUBERRI'),(64954382,'gns:RC','1'),(64954382,'gns:UFI','-1395814'),(64954382,'gns:UNI','-2003564'),(64954382,'gns:V:xx:FULL_NAME','Juverri'),(64954382,'gns:V:xx:FULL_NAME_ND','Juverri'),(64954382,'gns:V:xx:NT','V'),(64954382,'gns:V:xx:SORT_NAME','JUVERRI'),(64954382,'name','Juberri'),(64954382,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954382,'place','village'),(64954382,'source','gns_an'),(64954385,'created_by','Potlatch 0.8a'),(64954385,'gns:ADM1','00'),(64954385,'gns:N:xx:FULL_NAME','Nagol'),(64954385,'gns:N:xx:FULL_NAME_ND','Nagol'),(64954385,'gns:N:xx:NT','N'),(64954385,'gns:N:xx:SORT_NAME','NAGOL'),(64954385,'gns:RC','1'),(64954385,'gns:UFI','-1396263'),(64954385,'gns:UNI','-2004023'),(64954385,'name','Nagol'),(64954385,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954385,'place','village'),(64954385,'source','gns_an'),(64954389,'created_by','Potlatch 0.10f'),(64954389,'gns:ADM1','00'),(64954389,'gns:N:xx:FULL_NAME','Anyós'),(64954389,'gns:N:xx:FULL_NAME_ND','Anyos'),(64954389,'gns:N:xx:NT','N'),(64954389,'gns:N:xx:SORT_NAME','ANYOS'),(64954389,'gns:RC','1'),(64954389,'gns:UFI','-1394459'),(64954389,'gns:UNI','-2002089'),(64954389,'name','Anyós'),(64954389,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954389,'place','hamlet'),(64954389,'source','gns_an'),(64954396,'created_by','Potlatch 0.8a'),(64954396,'gns:ADM1','00'),(64954396,'gns:N:xx:FULL_NAME','Els Vilars'),(64954396,'gns:N:xx:FULL_NAME_ND','Els Vilars'),(64954396,'gns:N:xx:NT','N'),(64954396,'gns:N:xx:SORT_NAME','ELSVILARS'),(64954396,'gns:RC','1'),(64954396,'gns:UFI','-1395318'),(64954396,'gns:UNI','-2003021'),(64954396,'name','Els Vilars'),(64954396,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954396,'place','hamlet'),(64954396,'source','gns_an'),(64954400,'created_by','JOSM'),(64954400,'gns:ADM1','00'),(64954400,'gns:N:xx:FULL_NAME','Bixessarri'),(64954400,'gns:N:xx:FULL_NAME_ND','Bixessarri'),(64954400,'gns:N:xx:NT','N'),(64954400,'gns:N:xx:SORT_NAME','BIXESSARRI'),(64954400,'gns:RC','1'),(64954400,'gns:UFI','-1394629'),(64954400,'gns:UNI','-2005085'),(64954400,'gns:V:xx:FULL_NAME','Vixesarri'),(64954400,'gns:V:xx:FULL_NAME_ND','Vixesarri'),(64954400,'gns:V:xx:MODIFY_DATE','1993-12-23'),(64954400,'gns:V:xx:NT','V'),(64954400,'gns:V:xx:SORT_NAME','VIXESARRI'),(64954400,'name','Bixessarri'),(64954400,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954400,'place','village'),(64954400,'source','gns_an'),(64954404,'created_by','Potlatch 0.8a'),(64954404,'gns:ADM1','00'),(64954404,'gns:N:xx:FULL_NAME','El Tarter'),(64954404,'gns:N:xx:FULL_NAME_ND','El Tarter'),(64954404,'gns:N:xx:NT','N'),(64954404,'gns:N:xx:SORT_NAME','ELTARTER'),(64954404,'gns:RC','1'),(64954404,'gns:UFI','-1395312'),(64954404,'gns:UNI','-2003015'),(64954404,'name','El Tarter'),(64954404,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954404,'place','village'),(64954404,'source','gns_an'),(64954409,'created_by','Potlatch 0.8a'),(64954409,'gns:ADM1','00'),(64954409,'gns:N:xx:FULL_NAME','Prats'),(64954409,'gns:N:xx:FULL_NAME_ND','Prats'),(64954409,'gns:N:xx:NT','N'),(64954409,'gns:N:xx:SORT_NAME','PRATS'),(64954409,'gns:RC','1'),(64954409,'gns:UFI','-1396638'),(64954409,'gns:UNI','-2004442'),(64954409,'name','Prats'),(64954409,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954409,'place','village'),(64954409,'source','gns_an'),(64954415,'created_by','Potlatch 0.9c'),(64954415,'gns:ADM1','00'),(64954415,'gns:N:xx:FULL_NAME','Sispony'),(64954415,'gns:N:xx:FULL_NAME_ND','Sispony'),(64954415,'gns:N:xx:NT','N'),(64954415,'gns:N:xx:SORT_NAME','SISPONY'),(64954415,'gns:RC','1'),(64954415,'gns:UFI','-1396951'),(64954415,'gns:UNI','-2004800'),(64954415,'name','Sispony'),(64954415,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954415,'place','hamlet'),(64954415,'source','gns_an'),(64954417,'created_by','Potlatch 0.8a'),(64954417,'gns:ADM1','00'),(64954417,'gns:N:xx:FULL_NAME','Els Plans'),(64954417,'gns:N:xx:FULL_NAME_ND','Els Plans'),(64954417,'gns:N:xx:NT','N'),(64954417,'gns:N:xx:SORT_NAME','ELSPLANS'),(64954417,'gns:RC','1'),(64954417,'gns:UFI','-1395303'),(64954417,'gns:UNI','-2003006'),(64954417,'name','Els Plans'),(64954417,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954417,'place','hamlet'),(64954417,'source','gns_an'),(64954422,'created_by','Potlatch 0.8a'),(64954422,'gns:ADM1','00'),(64954422,'gns:N:xx:FULL_NAME','L’Aldosa'),(64954422,'gns:N:xx:FULL_NAME_ND','L\'Aldosa'),(64954422,'gns:N:xx:NT','N'),(64954422,'gns:N:xx:SORT_NAME','LALDOSA'),(64954422,'gns:RC','1'),(64954422,'gns:UFI','-1395874'),(64954422,'gns:UNI','-2003610'),(64954422,'name','L’Aldosa de Canillo'),(64954422,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954422,'place','hamlet'),(64954422,'source','gns_an'),(64954429,'created_by','Potlatch 0.8a'),(64954429,'gns:ADM1','00'),(64954429,'gns:N:xx:FULL_NAME','Sant Pere'),(64954429,'gns:N:xx:FULL_NAME_ND','Sant Pere'),(64954429,'gns:N:xx:NT','N'),(64954429,'gns:N:xx:SORT_NAME','SANTPERE'),(64954429,'gns:RC','1'),(64954429,'gns:UFI','-1396873'),(64954429,'gns:UNI','-2004705'),(64954429,'name','Sant Pere'),(64954429,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954429,'place','village'),(64954429,'source','gns_an'),(64954433,'created_by','Potlatch 0.8a'),(64954433,'gns:N:xx:FULL_NAME','Canillo'),(64954433,'gns:N:xx:FULL_NAME_ND','Canillo'),(64954433,'name','Canillo'),(64954433,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954433,'place','town'),(64954433,'source','gns_an'),(64954435,'created_by','Potlatch 0.9a'),(64954435,'gns:ADM1','00'),(64954435,'gns:N:xx:FULL_NAME','Sornás'),(64954435,'gns:N:xx:FULL_NAME_ND','Sornas'),(64954435,'gns:N:xx:NT','N'),(64954435,'gns:N:xx:SORT_NAME','SORNAS'),(64954435,'gns:RC','1'),(64954435,'gns:UFI','-1397041'),(64954435,'gns:UNI','-2004894'),(64954435,'name','Sornás'),(64954435,'note','Experimental import of Andorrian places and POIs from GNS Dataset - corrected by user 3ld'),(64954435,'place','village'),(64954435,'source','gns_an'),(64954441,'created_by','Potlatch 0.8c'),(64954441,'gns:ADM1','00'),(64954441,'gns:N:xx:FULL_NAME','Sant Joan de Caselles'),(64954441,'gns:N:xx:FULL_NAME_ND','Sant Joan de Caselles'),(64954441,'gns:N:xx:NT','N'),(64954441,'gns:N:xx:SORT_NAME','SANTJOANDECASELLES'),(64954441,'gns:RC','1'),(64954441,'gns:UFI','-1396861'),(64954441,'gns:UNI','-2004686'),(64954441,'gns:V:xx:FULL_NAME','Sant Joan de Casellas'),(64954441,'gns:V:xx:FULL_NAME_ND','Sant Joan de Casellas'),(64954441,'gns:V:xx:MODIFY_DATE','1993-12-23'),(64954441,'gns:V:xx:NT','V'),(64954441,'gns:V:xx:SORT_NAME','SANTJOANDECASELLAS'),(64954441,'name','Sant Joan de Caselles'),(64954441,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954441,'place','hamlet'),(64954441,'source','gns_an'),(64954447,'created_by','Potlatch 0.9c'),(64954447,'gns:ADM1','00'),(64954447,'gns:N:xx:FULL_NAME','L’Aldosa'),(64954447,'gns:N:xx:FULL_NAME_ND','L\'Aldosa'),(64954447,'gns:N:xx:NT','N'),(64954447,'gns:N:xx:SORT_NAME','LALDOSA'),(64954447,'gns:RC','1'),(64954447,'gns:UFI','-1395873'),(64954447,'gns:UNI','-2003609'),(64954447,'name','L’Aldosa'),(64954447,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954447,'place','hamlet'),(64954447,'source','gns_an'),(64954451,'created_by','Potlatch 0.8a'),(64954451,'gns:ADM1','00'),(64954451,'gns:N:xx:FULL_NAME','El Serrat'),(64954451,'gns:N:xx:FULL_NAME_ND','El Serrat'),(64954451,'gns:N:xx:NT','N'),(64954451,'gns:N:xx:SORT_NAME','ELSERRAT'),(64954451,'gns:RC','1'),(64954451,'gns:UFI','-1395275'),(64954451,'gns:UNI','-2003810'),(64954451,'gns:V:xx:FULL_NAME','Lo Serrat'),(64954451,'gns:V:xx:FULL_NAME_ND','Lo Serrat'),(64954451,'gns:V:xx:MODIFY_DATE','1993-12-23'),(64954451,'gns:V:xx:NT','V'),(64954451,'gns:V:xx:SORT_NAME','LOSERRAT'),(64954451,'name','El Serrat'),(64954451,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954451,'place','village'),(64954451,'source','gns_an'),(64954457,'created_by','Potlatch 0.8a'),(64954457,'gns:ADM1','00'),(64954457,'gns:N:xx:FULL_NAME','Ransol'),(64954457,'gns:N:xx:FULL_NAME_ND','Ransol'),(64954457,'gns:N:xx:NT','N'),(64954457,'gns:N:xx:SORT_NAME','RANSOL'),(64954457,'gns:RC','1'),(64954457,'gns:UFI','-1396705'),(64954457,'gns:UNI','-2004518'),(64954457,'name','Ransol'),(64954457,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954457,'place','village'),(64954457,'source','gns_an'),(64954460,'created_by','Potlatch 0.9a'),(64954460,'gns:ADM1','00'),(64954460,'gns:N:xx:FULL_NAME','El Pui'),(64954460,'gns:N:xx:FULL_NAME_ND','El Pui'),(64954460,'gns:N:xx:NT','N'),(64954460,'gns:N:xx:SORT_NAME','ELPUI'),(64954460,'gns:RC','1'),(64954460,'gns:UFI','-1395245'),(64954460,'gns:UNI','-2002947'),(64954460,'name','El Pui'),(64954460,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954460,'place','hamlet'),(64954460,'source','gns_an'),(64954464,'created_by','Potlatch 0.10b'),(64954464,'gns:ADM1','00'),(64954464,'gns:N:xx:FULL_NAME','Vila'),(64954464,'gns:N:xx:FULL_NAME_ND','Vila'),(64954464,'gns:N:xx:NT','N'),(64954464,'gns:N:xx:SORT_NAME','VILA'),(64954464,'gns:RC','1'),(64954464,'gns:UFI','-1397198'),(64954464,'gns:UNI','-2005072'),(64954464,'gns:V:xx:FULL_NAME','Casas Vila'),(64954464,'gns:V:xx:FULL_NAME_ND','Casas Vila'),(64954464,'gns:V:xx:MODIFY_DATE','1993-12-23'),(64954464,'gns:V:xx:NT','V'),(64954464,'gns:V:xx:SORT_NAME','CASASVILA'),(64954464,'name','Vila'),(64954464,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954464,'place','village'),(64954464,'source','gns_an'),(64954467,'created_by','Potlatch 0.9c'),(64954467,'gns:ADM1','00'),(64954467,'gns:N:xx:FULL_NAME','Erts'),(64954467,'gns:N:xx:FULL_NAME_ND','Erts'),(64954467,'gns:N:xx:SORT_NAME','ERTS'),(64954467,'gns:RC','1'),(64954467,'gns:UFI','-1395403'),(64954467,'gns:UNI','-2003119'),(64954467,'gns:V:xx:FULL_NAME','Erez'),(64954467,'gns:V:xx:FULL_NAME_ND','Erez'),(64954467,'gns:V:xx:MODIFY_DATE','1993-12-23'),(64954467,'gns:V:xx:SORT_NAME','EREZ'),(64954467,'name','Erts'),(64954467,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954467,'place','village'),(64954467,'source','gns_an'),(64954472,'created_by','Potlatch 0.9a'),(64954472,'gns:ADM1','00'),(64954472,'gns:N:xx:FULL_NAME','Ansalonga'),(64954472,'gns:N:xx:FULL_NAME_ND','Ansalonga'),(64954472,'gns:N:xx:NT','N'),(64954472,'gns:N:xx:SORT_NAME','ANSALONGA'),(64954472,'gns:RC','1'),(64954472,'gns:UFI','-1394456'),(64954472,'gns:UNI','-2002086'),(64954472,'name','Ansalonga'),(64954472,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954472,'place','village'),(64954472,'source','gns_an'),(64954477,'created_by','Potlatch 0.8a'),(64954477,'gns:ADM1','00'),(64954477,'gns:N:xx:FULL_NAME','Engordany'),(64954477,'gns:N:xx:FULL_NAME_ND','Engordany'),(64954477,'gns:N:xx:NT','N'),(64954477,'gns:N:xx:SORT_NAME','ENGORDANY'),(64954477,'gns:RC','1'),(64954477,'gns:UFI','-1395364'),(64954477,'gns:UNI','-2003073'),(64954477,'name','Engordany'),(64954477,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954477,'place','village'),(64954477,'source','gns_an'),(64954483,'created_by','Potlatch 0.10f'),(64954483,'gns:ADM1','00'),(64954483,'gns:N:xx:FULL_NAME','Arinsal'),(64954483,'gns:N:xx:FULL_NAME_ND','Arinsal'),(64954483,'gns:N:xx:NT','N'),(64954483,'gns:N:xx:SORT_NAME','ARINSAL'),(64954483,'gns:RC','1'),(64954483,'gns:UFI','-1394484'),(64954483,'gns:UNI','-2002121'),(64954483,'name','Arinsal'),(64954483,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954483,'place','village'),(64954483,'source','gns_an'),(64954486,'created_by','Potlatch 0.8a'),(64954486,'gns:N:xx:FULL_NAME_ND','Sant Julia de Loria'),(64954486,'gns:V:xx:FULL_NAME','Sant Juliá'),(64954486,'gns:V:xx:FULL_NAME_ND','Sant Julia'),(64954486,'gns:V:xx:MODIFY_DATE','2004-05-05'),(64954486,'name','Sant Julià de Lòria'),(64954486,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954486,'place','town'),(64954486,'source','gns_an'),(64954492,'created_by','Potlatch 0.8a'),(64954492,'gns:ADM1','00'),(64954492,'gns:N:xx:FULL_NAME','Les Bons'),(64954492,'gns:N:xx:FULL_NAME_ND','Les Bons'),(64954492,'gns:N:xx:NT','N'),(64954492,'gns:N:xx:SORT_NAME','LESBONS'),(64954492,'gns:RC','1'),(64954492,'gns:UFI','-1395948'),(64954492,'gns:UNI','-2003690'),(64954492,'gns:V:xx:FULL_NAME','Els Bons'),(64954492,'gns:V:xx:FULL_NAME_ND','Els Bons'),(64954492,'gns:V:xx:MODIFY_DATE','1993-12-23'),(64954492,'gns:V:xx:NT','V'),(64954492,'gns:V:xx:SORT_NAME','ELSBONS'),(64954492,'name','Les Bons'),(64954492,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954492,'place','hamlet'),(64954492,'source','gns_an'),(64954503,'created_by','Potlatch 0.9c'),(64954503,'gns:ADM1','00'),(64954503,'gns:N:xx:FULL_NAME','Puiol del Piu'),(64954503,'gns:N:xx:FULL_NAME_ND','Puiol del Piu'),(64954503,'gns:N:xx:NT','N'),(64954503,'gns:N:xx:SORT_NAME','PUIOLDELPIU'),(64954503,'gns:RC','1'),(64954503,'gns:UFI','-1396654'),(64954503,'gns:UNI','-2004458'),(64954503,'name','Puiol del Piu'),(64954503,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954503,'place','hamlet'),(64954503,'source','gns_an'),(64954508,'created_by','Potlatch 0.10f'),(64954508,'gns:ADM1','00'),(64954508,'gns:N:xx:FULL_NAME','Fontaneda'),(64954508,'gns:N:xx:FULL_NAME_ND','Fontaneda'),(64954508,'gns:N:xx:NT','N'),(64954508,'gns:N:xx:SORT_NAME','FONTANEDA'),(64954508,'gns:RC','1'),(64954508,'gns:UFI','-1395576'),(64954508,'gns:UNI','-2003297'),(64954508,'name','Fontaneda'),(64954508,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954508,'place','village'),(64954508,'source','gns_an'),(64954512,'created_by','Potlatch 0.9c'),(64954512,'gns:ADM1','00'),(64954512,'gns:N:xx:FULL_NAME','Santa Coloma'),(64954512,'gns:N:xx:FULL_NAME_ND','Santa Coloma'),(64954512,'gns:N:xx:NT','N'),(64954512,'gns:N:xx:SORT_NAME','SANTACOLOMA'),(64954512,'gns:RC','1'),(64954512,'gns:UFI','-1396846'),(64954512,'gns:UNI','-2004669'),(64954512,'name','Santa Coloma'),(64954512,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954512,'place','village'),(64954512,'source','gns_an'),(64954515,'created_by','Potlatch 0.8a'),(64954515,'gns:ADM1','00'),(64954515,'gns:N:xx:FULL_NAME','Pal'),(64954515,'gns:N:xx:FULL_NAME_ND','Pal'),(64954515,'gns:N:xx:NT','N'),(64954515,'gns:N:xx:SORT_NAME','PAL'),(64954515,'gns:RC','1'),(64954515,'gns:UFI','-1396388'),(64954515,'gns:UNI','-2004163'),(64954515,'name','Pal'),(64954515,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954515,'place','village'),(64954515,'source','gns_an'),(64954521,'created_by','Potlatch 0.8a'),(64954521,'gns:ADM1','00'),(64954521,'gns:N:xx:FULL_NAME','Xixerella'),(64954521,'gns:N:xx:FULL_NAME_ND','Xixerella'),(64954521,'gns:N:xx:NT','N'),(64954521,'gns:N:xx:SORT_NAME','XIXERELLA'),(64954521,'gns:RC','1'),(64954521,'gns:UFI','-1397214'),(64954521,'gns:UNI','-2005091'),(64954521,'name','Xixerella'),(64954521,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954521,'place','village'),(64954521,'source','gns_an'),(64954525,'created_by','Potlatch 0.8a'),(64954525,'gns:ADM1','00'),(64954525,'gns:N:xx:FULL_NAME','Aixovall'),(64954525,'gns:N:xx:FULL_NAME_ND','Aixovall'),(64954525,'gns:N:xx:NT','N'),(64954525,'gns:N:xx:SORT_NAME','AIXOVALL'),(64954525,'gns:RC','1'),(64954525,'gns:UFI','-1394403'),(64954525,'gns:UNI','-2002009'),(64954525,'name','Aixovall'),(64954525,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954525,'place','village'),(64954525,'source','gns_an'),(64954531,'created_by','Potlatch 0.9c'),(64954531,'gns:ADM1','00'),(64954531,'gns:N:xx:FULL_NAME','Llorts'),(64954531,'gns:N:xx:FULL_NAME_ND','Llorts'),(64954531,'gns:N:xx:NT','N'),(64954531,'gns:N:xx:SORT_NAME','LLORTS'),(64954531,'gns:RC','1'),(64954531,'gns:UFI','-1396036'),(64954531,'gns:UNI','-2003809'),(64954531,'gns:V:xx:FULL_NAME','Lors'),(64954531,'gns:V:xx:FULL_NAME_ND','Lors'),(64954531,'gns:V:xx:MODIFY_DATE','1993-12-23'),(64954531,'gns:V:xx:NT','V'),(64954531,'gns:V:xx:SORT_NAME','LORS'),(64954531,'name','Llorts'),(64954531,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954531,'place','village'),(64954531,'source','gns_an'),(64954538,'created_by','Potlatch 0.9c'),(64954538,'gns:ADM1','00'),(64954538,'gns:N:xx:FULL_NAME','Soldeu'),(64954538,'gns:N:xx:FULL_NAME_ND','Soldeu'),(64954538,'gns:N:xx:NT','N'),(64954538,'gns:N:xx:SORT_NAME','SOLDEU'),(64954538,'gns:RC','1'),(64954538,'gns:UFI','-1397029'),(64954538,'gns:UNI','-2004879'),(64954538,'name','Soldeu'),(64954538,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954538,'place','village'),(64954538,'source','gns_an'),(64954542,'created_by','Potlatch 0.9c'),(64954542,'gns:ADM1','00'),(64954542,'gns:N:xx:FULL_NAME','Mas de Ribafeta'),(64954542,'gns:N:xx:FULL_NAME_ND','Mas de Ribafeta'),(64954542,'gns:N:xx:NT','N'),(64954542,'gns:N:xx:SORT_NAME','MASDERIBAFETA'),(64954542,'gns:RC','1'),(64954542,'gns:UFI','-1396119'),(64954542,'gns:UNI','-2003869'),(64954542,'name','Mas de Ribafeta'),(64954542,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954542,'place','hamlet'),(64954542,'source','gns_an'),(64954546,'created_by','Potlatch 0.9c'),(64954546,'gns:ADM1','00'),(64954546,'gns:N:xx:FULL_NAME','La Cortinada'),(64954546,'gns:N:xx:FULL_NAME_ND','La Cortinada'),(64954546,'gns:N:xx:NT','N'),(64954546,'gns:N:xx:SORT_NAME','LACORTINADA'),(64954546,'gns:RC','1'),(64954546,'gns:UFI','-1395860'),(64954546,'gns:UNI','-2003596'),(64954546,'name','La Cortinada'),(64954546,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954546,'place','village'),(64954546,'source','gns_an'),(64954554,'created_by','Potlatch 0.8a'),(64954554,'gns:ADM1','00'),(64954554,'gns:N:xx:FULL_NAME','Llumeneres'),(64954554,'gns:N:xx:FULL_NAME_ND','Llumeneres'),(64954554,'gns:N:xx:NT','N'),(64954554,'gns:N:xx:SORT_NAME','LLUMENERES'),(64954554,'gns:RC','1'),(64954554,'gns:UFI','-1396056'),(64954554,'gns:UNI','-2003801'),(64954554,'name','Llumeneres'),(64954554,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954554,'place','village'),(64954554,'source','gns_an'),(64954560,'created_by','Potlatch 0.8c'),(64954560,'gns:ADM1','00'),(64954560,'gns:N:xx:FULL_NAME','Arans'),(64954560,'gns:N:xx:FULL_NAME_ND','Arans'),(64954560,'gns:N:xx:NT','N'),(64954560,'gns:N:xx:SORT_NAME','ARANS'),(64954560,'gns:RC','1'),(64954560,'gns:UFI','-1394461'),(64954560,'gns:UNI','-2002092'),(64954560,'name','Arans'),(64954560,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954560,'place','village'),(64954560,'source','gns_an'),(64954563,'created_by','Potlatch 0.8b'),(64954563,'gns:ADM1','04'),(64954563,'gns:V:xx:FULL_NAME','La Maçana'),(64954563,'gns:V:xx:FULL_NAME_ND','La Macana'),(64954563,'name','La Massana'),(64954563,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954563,'place','town'),(64954563,'source','gns_an'),(64954565,'created_by','Potlatch 0.8c'),(64954565,'gns:ADM1','00'),(64954565,'gns:N:xx:FULL_NAME','Escàs'),(64954565,'gns:N:xx:FULL_NAME_ND','Escas'),(64954565,'gns:N:xx:NT','N'),(64954565,'gns:N:xx:SORT_NAME','ESCAS'),(64954565,'gns:RC','1'),(64954565,'gns:UFI','-1395411'),(64954565,'gns:UNI','-2003129'),(64954565,'name','Escàs'),(64954565,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954565,'place','hamlet'),(64954565,'source','gns_an'),(64954570,'created_by','Potlatch 0.9a'),(64954570,'gns:ADM1','00'),(64954570,'gns:N:xx:FULL_NAME','Segudet'),(64954570,'gns:N:xx:FULL_NAME_ND','Segudet'),(64954570,'gns:N:xx:NT','N'),(64954570,'gns:N:xx:SORT_NAME','SEGUDET'),(64954570,'gns:RC','1'),(64954570,'gns:UFI','-1396896'),(64954570,'gns:UNI','-2004734'),(64954570,'name','Segudet'),(64954570,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954570,'place','village'),(64954570,'source','gns_an'),(64954584,'created_by','Potlatch 0.8a'),(64954584,'gns:ADM1','03'),(64954584,'gns:N:xx:FULL_NAME','Encamp'),(64954584,'gns:N:xx:FULL_NAME_ND','Encamp'),(64954584,'gns:RC','1'),(64954584,'gns:UFI','-1395326'),(64954584,'gns:UNI','-2003031'),(64954584,'name','Encamp'),(64954584,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954584,'place','town'),(64954584,'source','gns_an'),(64954589,'created_by','Potlatch 0.8b'),(64954589,'gns:ADM1','08'),(64954589,'gns:N:xx:FULL_NAME','Les Escaldes'),(64954589,'gns:N:xx:FULL_NAME_ND','Les Escaldes'),(64954589,'gns:N:xx:NT','N'),(64954589,'gns:N:xx:SHORT_FORM','Escaldes'),(64954589,'gns:N:xx:SORT_NAME','LESESCALDES'),(64954589,'gns:RC','1'),(64954589,'gns:UFI','-1395964'),(64954589,'gns:UNI','-2003706'),(64954589,'gns:V:xx:FULL_NAME','Las Escadas'),(64954589,'gns:V:xx:FULL_NAME_ND','Las Escadas'),(64954589,'gns:V:xx:MODIFY_DATE','2004-05-05'),(64954589,'gns:V:xx:NT','V'),(64954589,'gns:V:xx:SORT_NAME','LASESCADAS'),(64954589,'name','Les Escaldes'),(64954589,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954589,'place','town'),(64954589,'source','gns_an'),(64954593,'created_by','Potlatch 0.8a'),(64954593,'gns:ADM1','00'),(64954593,'gns:N:xx:FULL_NAME','Aixirivall'),(64954593,'gns:N:xx:FULL_NAME_ND','Aixirivall'),(64954593,'gns:N:xx:NT','N'),(64954593,'gns:N:xx:SORT_NAME','AIXIRIVALL'),(64954593,'gns:RC','1'),(64954593,'gns:UFI','-1394397'),(64954593,'gns:UNI','-2150077'),(64954593,'gns:V:xx:FULL_NAME','Eixirivall'),(64954593,'gns:V:xx:FULL_NAME_ND','Eixirivall'),(64954593,'gns:V:xx:MODIFY_DATE','1993-12-23'),(64954593,'gns:V:xx:NT','V'),(64954593,'gns:V:xx:SORT_NAME','EIXIRIVALL'),(64954593,'name','Aixirivall'),(64954593,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954593,'place','village'),(64954593,'source','gns_an'),(64954598,'created_by','Potlatch 0.8a'),(64954598,'gns:ADM1','00'),(64954598,'gns:N:xx:FULL_NAME','Certers'),(64954598,'gns:N:xx:FULL_NAME_ND','Certers'),(64954598,'gns:N:xx:NT','N'),(64954598,'gns:N:xx:SORT_NAME','CERTERS'),(64954598,'gns:RC','1'),(64954598,'gns:UFI','-1394910');
INSERT INTO `current_node_tags` VALUES (64954598,'gns:UNI','-2004772'),(64954598,'gns:V:xx:FULL_NAME','Sertes'),(64954598,'gns:V:xx:FULL_NAME_ND','Sertes'),(64954598,'gns:V:xx:MODIFY_DATE','1993-12-23'),(64954598,'gns:V:xx:NT','V'),(64954598,'gns:V:xx:SORT_NAME','SERTES'),(64954598,'name','Certers'),(64954598,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954598,'place','village'),(64954598,'source','gns_an'),(64954601,'created_by','Potlatch 0.8a'),(64954601,'gns:ADM1','00'),(64954601,'gns:N:xx:FULL_NAME','Meritxell'),(64954601,'gns:N:xx:FULL_NAME_ND','Meritxell'),(64954601,'gns:N:xx:NT','N'),(64954601,'gns:N:xx:SORT_NAME','MERITXELL'),(64954601,'gns:RC','1'),(64954601,'gns:UFI','-1396155'),(64954601,'gns:UNI','-2004711'),(64954601,'gns:V:xx:FULL_NAME','Santuari de Meritxell'),(64954601,'gns:V:xx:FULL_NAME_ND','Santuari de Meritxell'),(64954601,'gns:V:xx:MODIFY_DATE','1993-12-23'),(64954601,'gns:V:xx:NT','V'),(64954601,'gns:V:xx:SORT_NAME','SANTUARIDEMERITXELL'),(64954601,'name','Meritxell'),(64954601,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954601,'place','village'),(64954601,'source','gns_an'),(148874198,'capital_city','Andorra la Vella'),(148874198,'country_code_iso3166_1_alpha_2','AD'),(148874198,'is_in:continent','Europe'),(148874198,'name','Andorra'),(148874198,'name:ar','??????'),(148874198,'name:be','??????'),(148874198,'name:bg','??????'),(148874198,'name:br','Andorra'),(148874198,'name:ca','Andorra'),(148874198,'name:el','???????'),(148874198,'name:eo','Andoro'),(148874198,'name:eu','Andorra'),(148874198,'name:fa','??????'),(148874198,'name:fi','Andorra'),(148874198,'name:fr','Andorre'),(148874198,'name:ga','Andóra'),(148874198,'name:haw','‘Anakola'),(148874198,'name:he','??????'),(148874198,'name:hr','Andora'),(148874198,'name:hu','Andorra'),(148874198,'name:hy','???????'),(148874198,'name:is','Andorra'),(148874198,'name:it','Andorra'),(148874198,'name:ja','????'),(148874198,'name:ka','??????'),(148874198,'name:ko','???'),(148874198,'name:lt','Andora'),(148874198,'name:lv','Andora'),(148874198,'name:mn','???????'),(148874198,'name:oc','Andòrra'),(148874198,'name:pl','Andora'),(148874198,'name:pt','Andorra'),(148874198,'name:ru','???????'),(148874198,'name:sco','Andorrae'),(148874198,'name:sk','Andorra'),(148874198,'name:sl','Andora'),(148874198,'name:sv','Andorra'),(148874198,'name:tg','???????'),(148874198,'name:th','???????????????'),(148874198,'name:uk','??????'),(148874198,'name:zh','???'),(148874198,'name:zh_pinyin','?ndào?r'),(148874198,'official_name:cy','Tywysogaeth Andorra'),(148874198,'official_name:el','?????????? ??? ????????'),(148874198,'official_name:fi','Andorran ruhtinaskunta'),(148874198,'official_name:fr','Principauté d\'Andorre'),(148874198,'official_name:id','Kepangeranan Andorra'),(148874198,'official_name:ja','??????'),(148874198,'official_name:la','Principatus Andorrae'),(148874198,'official_name:lt','Andoros Kunigaikštyst?'),(148874198,'official_name:lv','Andoras Firstiste'),(148874198,'official_name:pt','Principado de Andorra'),(148874198,'official_name:sk','Andorrské kniežatstvo'),(148874198,'official_name:sv','Furstendömet Andorra'),(148874198,'official_name:vi','Công qu?c Andorra'),(148874198,'place','country'),(148874198,'population','94609'),(148874198,'wikipedia:fr','Andorre'),(206332846,'ele','2408'),(206332846,'mountain_pass','yes'),(206332846,'name','Port d\'Envalira'),(206332846,'wikipedia','http://de.wikipedia.org/wiki/Port_d%E2%80%99Envalira'),(247045686,'created_by','JOSM'),(247045688,'created_by','JOSM'),(247045690,'created_by','JOSM'),(247045691,'created_by','JOSM'),(247045693,'created_by','JOSM'),(247045695,'created_by','JOSM'),(247045696,'created_by','JOSM'),(247045698,'created_by','JOSM'),(247045700,'created_by','JOSM'),(247045701,'created_by','JOSM'),(247045703,'created_by','JOSM'),(247045712,'created_by','JOSM'),(247045718,'created_by','JOSM'),(247045724,'created_by','JOSM'),(247045732,'created_by','JOSM'),(247045739,'created_by','JOSM'),(247045741,'created_by','JOSM'),(247045742,'created_by','JOSM'),(247045744,'created_by','JOSM'),(247046008,'created_by','JOSM'),(247046009,'created_by','JOSM'),(247046010,'created_by','JOSM'),(247046011,'created_by','JOSM'),(247046012,'created_by','JOSM'),(247046013,'created_by','JOSM'),(247046014,'created_by','JOSM'),(247046015,'created_by','JOSM'),(247046016,'created_by','JOSM'),(247046017,'created_by','JOSM'),(247046018,'created_by','JOSM'),(247046019,'created_by','JOSM'),(247046020,'created_by','JOSM'),(247046021,'created_by','JOSM'),(247046022,'created_by','JOSM'),(247046023,'created_by','JOSM'),(247046024,'created_by','JOSM'),(247046025,'created_by','JOSM'),(247046026,'created_by','JOSM'),(247046027,'created_by','JOSM'),(247046028,'created_by','JOSM'),(247046029,'created_by','JOSM'),(247046030,'created_by','JOSM'),(247046031,'created_by','JOSM'),(247046032,'created_by','JOSM'),(247046033,'created_by','JOSM'),(247046034,'created_by','JOSM'),(247046035,'created_by','JOSM'),(247046036,'created_by','JOSM'),(247046037,'created_by','JOSM'),(247046038,'created_by','JOSM'),(247046039,'created_by','JOSM'),(247046040,'created_by','JOSM'),(247046041,'created_by','JOSM'),(247046042,'created_by','JOSM'),(247046043,'created_by','JOSM'),(247046044,'created_by','JOSM'),(247046045,'created_by','JOSM'),(247046046,'created_by','JOSM'),(247046047,'created_by','JOSM'),(247046048,'created_by','JOSM'),(247046072,'created_by','JOSM'),(247046073,'created_by','JOSM'),(247046074,'created_by','JOSM'),(247046075,'created_by','JOSM'),(247046076,'created_by','JOSM'),(247046077,'created_by','JOSM'),(247046078,'created_by','JOSM'),(247046079,'created_by','JOSM'),(258355185,'created_by','Potlatch 0.8a'),(258355185,'is_in','La Massana'),(258355185,'name','Super Pal'),(258355185,'place','hamlet'),(258356188,'created_by','Potlatch 0.8a'),(258356188,'name','Vallnord: Sector Pal'),(258356188,'sport','skiing'),(258356379,'created_by','Potlatch 0.8a'),(258356379,'name','Vallnord: Sector Arinsal'),(258356379,'sport','skiing'),(258357981,'created_by','Potlatch 0.8a'),(258357981,'name','Vallnord: Sector Arcalis'),(258357981,'sport','skiing'),(258361905,'created_by','Potlatch 0.8a'),(258361905,'is_in','Encamp'),(258361905,'name','Grau Roig'),(258361905,'place','village'),(258823161,'created_by','JOSM'),(259475446,'highway','mini_roundabout'),(259476084,'amenity','fuel'),(259476084,'created_by','Potlatch 0.8b'),(259476084,'operator','ESSO'),(260996387,'highway','mini_roundabout'),(262464083,'highway','traffic_signals'),(262466673,'created_by','Potlatch 0.8c'),(262466673,'name','el Vilar'),(262466673,'place','hamlet'),(262472865,'name','Coll d\'Ordino'),(262472865,'tourism','viewpoint'),(262473157,'created_by','Potlatch 0.9a'),(262473157,'description','Looks like Totem Poles'),(262473157,'name','Estructures Autogeneradores'),(262473157,'tourism','artwork'),(262473680,'created_by','Potlatch 0.8c'),(262473680,'is_in','Canillo'),(262473680,'name','el Forn'),(262473680,'place','hamlet'),(262892996,'created_by','JOSM'),(262892997,'created_by','JOSM'),(262892998,'created_by','JOSM'),(262892999,'created_by','JOSM'),(262893000,'created_by','JOSM'),(262893001,'created_by','JOSM'),(262893002,'created_by','JOSM'),(262893003,'created_by','JOSM'),(264053391,'created_by','Potlatch 0.9a'),(264053391,'name','Lloc de Repos de Redort'),(264053391,'tourism','picnic_site'),(264272401,'amenity','parking'),(264331306,'highway','speed_camera'),(264465123,'created_by','JOSM'),(264465125,'created_by','JOSM'),(264465125,'highway','mini_roundabout'),(264465126,'created_by','JOSM'),(264465127,'created_by','JOSM'),(264465128,'created_by','JOSM'),(264465129,'created_by','JOSM'),(264465130,'created_by','JOSM'),(264496511,'created_by','Potlatch 0.9a'),(264496511,'is_in','la Massana'),(264496511,'name','el Cortalet'),(264496511,'place','hamlet'),(264496540,'created_by','Potlatch 0.9a'),(264496540,'is_in','la Massana'),(264496540,'name','el Bosquet'),(264496540,'place','hamlet'),(264932311,'created_by','JOSM'),(264932314,'created_by','JOSM'),(264932315,'created_by','JOSM'),(264932316,'created_by','JOSM'),(264932317,'created_by','JOSM'),(264932318,'created_by','JOSM'),(264932319,'created_by','JOSM'),(264932321,'created_by','JOSM'),(264932322,'created_by','JOSM'),(264932325,'created_by','JOSM'),(264932326,'created_by','JOSM'),(264932327,'created_by','JOSM'),(264932328,'created_by','JOSM'),(264932329,'created_by','JOSM'),(264932330,'created_by','JOSM'),(264932340,'created_by','JOSM'),(264932341,'created_by','JOSM'),(264932342,'created_by','JOSM'),(264932343,'created_by','JOSM'),(264932344,'created_by','JOSM'),(264932345,'created_by','JOSM'),(264932347,'created_by','JOSM'),(264932348,'created_by','JOSM'),(264932349,'created_by','JOSM'),(264932350,'created_by','JOSM'),(264932351,'created_by','JOSM'),(264932352,'created_by','JOSM'),(264932353,'created_by','JOSM'),(264932354,'created_by','JOSM'),(264932355,'created_by','JOSM'),(264932356,'created_by','JOSM'),(264932357,'created_by','JOSM'),(264932359,'created_by','JOSM'),(264932360,'created_by','JOSM'),(264932361,'created_by','JOSM'),(264932362,'created_by','JOSM'),(264932363,'created_by','JOSM'),(264932364,'created_by','JOSM'),(264932365,'created_by','JOSM'),(264932366,'created_by','JOSM'),(264932367,'created_by','JOSM'),(264932368,'created_by','JOSM'),(264932370,'created_by','JOSM'),(264932371,'created_by','JOSM'),(264932372,'created_by','JOSM'),(264932373,'created_by','JOSM'),(264932374,'created_by','JOSM'),(264932375,'created_by','JOSM'),(264932376,'created_by','JOSM'),(264932377,'created_by','JOSM'),(264932379,'created_by','JOSM'),(264932380,'created_by','JOSM'),(264932381,'created_by','JOSM'),(264932382,'created_by','JOSM'),(264932383,'created_by','JOSM'),(264932384,'created_by','JOSM'),(264932386,'created_by','JOSM'),(264932387,'created_by','JOSM'),(264932388,'created_by','JOSM'),(264932390,'created_by','JOSM'),(264932393,'created_by','JOSM'),(264932395,'created_by','JOSM'),(264932396,'created_by','JOSM'),(264932397,'created_by','JOSM'),(264932398,'created_by','JOSM'),(264932399,'created_by','JOSM'),(264932400,'created_by','JOSM'),(264932401,'created_by','JOSM'),(264932402,'created_by','JOSM'),(264932404,'created_by','JOSM'),(264932405,'created_by','JOSM'),(264932406,'created_by','JOSM'),(264932407,'created_by','JOSM'),(264932408,'created_by','JOSM'),(264932409,'created_by','JOSM'),(264932410,'created_by','JOSM'),(264932411,'created_by','JOSM'),(264932412,'created_by','JOSM'),(264932414,'created_by','JOSM'),(264932415,'created_by','JOSM'),(264932416,'created_by','JOSM'),(264932417,'created_by','JOSM'),(264932420,'created_by','JOSM'),(264932427,'created_by','JOSM'),(264932428,'created_by','JOSM'),(264932429,'created_by','JOSM'),(264932430,'created_by','JOSM'),(264932431,'created_by','JOSM'),(264932432,'created_by','JOSM'),(264932433,'created_by','JOSM'),(264932435,'created_by','JOSM'),(264932436,'created_by','JOSM'),(264932437,'created_by','JOSM'),(264932438,'created_by','JOSM'),(264932439,'created_by','JOSM'),(264932440,'created_by','JOSM'),(264932441,'created_by','JOSM'),(264932442,'created_by','JOSM'),(264932444,'created_by','JOSM'),(264932445,'created_by','JOSM'),(264932446,'created_by','JOSM'),(264932447,'created_by','JOSM'),(264932448,'created_by','JOSM'),(264932449,'created_by','JOSM'),(264932450,'created_by','JOSM'),(264932451,'created_by','JOSM'),(264932452,'created_by','JOSM'),(264932453,'created_by','JOSM'),(264932454,'created_by','JOSM'),(264932456,'created_by','JOSM'),(264932457,'created_by','JOSM'),(264932458,'created_by','JOSM'),(264932459,'created_by','JOSM'),(264932460,'created_by','JOSM'),(264932461,'created_by','JOSM'),(264932462,'created_by','JOSM'),(264932463,'created_by','JOSM'),(264932464,'created_by','JOSM'),(264932465,'created_by','JOSM'),(264932466,'created_by','JOSM'),(264932467,'created_by','JOSM'),(264932469,'created_by','JOSM'),(264932470,'created_by','JOSM'),(264932471,'created_by','JOSM'),(264932472,'created_by','JOSM'),(264932473,'created_by','JOSM'),(264932474,'created_by','JOSM'),(264932475,'created_by','JOSM'),(264932476,'created_by','JOSM'),(264932477,'created_by','JOSM'),(264932478,'created_by','JOSM'),(264932479,'created_by','JOSM'),(264932481,'created_by','JOSM'),(264932482,'created_by','JOSM'),(264932483,'created_by','JOSM'),(264932484,'created_by','JOSM'),(264932486,'created_by','JOSM'),(264932487,'created_by','JOSM'),(264932488,'created_by','JOSM'),(264932489,'created_by','JOSM'),(264932490,'created_by','JOSM'),(264932491,'created_by','JOSM'),(264932492,'created_by','JOSM'),(264932493,'created_by','JOSM'),(264932495,'created_by','JOSM'),(264932496,'created_by','JOSM'),(264932497,'created_by','JOSM'),(264932498,'created_by','JOSM'),(264932499,'created_by','JOSM'),(264932500,'created_by','JOSM'),(264932501,'created_by','JOSM'),(264932529,'created_by','JOSM'),(264932531,'created_by','JOSM'),(264932532,'created_by','JOSM'),(264932534,'created_by','JOSM'),(264932535,'created_by','JOSM'),(264932536,'created_by','JOSM'),(264932537,'created_by','JOSM'),(264932538,'created_by','JOSM'),(264932539,'created_by','JOSM'),(264932540,'created_by','JOSM'),(264932541,'created_by','JOSM'),(264932543,'created_by','JOSM'),(264932544,'created_by','JOSM'),(264932545,'created_by','JOSM'),(264932546,'created_by','JOSM'),(264932547,'created_by','JOSM'),(264932548,'created_by','JOSM'),(264932549,'created_by','JOSM'),(264932550,'created_by','JOSM'),(264932551,'created_by','JOSM'),(264932567,'created_by','JOSM'),(264932568,'created_by','JOSM'),(264932569,'created_by','JOSM'),(264932570,'created_by','JOSM'),(264932572,'created_by','JOSM'),(264932573,'created_by','JOSM'),(264932574,'created_by','JOSM'),(264932575,'created_by','JOSM'),(264932576,'created_by','JOSM'),(264932577,'created_by','JOSM'),(264932578,'created_by','JOSM'),(264932579,'created_by','JOSM'),(264932581,'created_by','JOSM'),(264932582,'created_by','JOSM'),(264932583,'created_by','JOSM'),(264932584,'created_by','JOSM'),(264932585,'created_by','JOSM'),(264932586,'created_by','JOSM'),(264932587,'created_by','JOSM'),(264932589,'created_by','JOSM'),(264932590,'created_by','JOSM'),(264932591,'created_by','JOSM'),(264932592,'created_by','JOSM'),(264932593,'created_by','JOSM'),(264932594,'created_by','JOSM'),(264932595,'created_by','JOSM'),(264932596,'created_by','JOSM'),(264932598,'created_by','JOSM'),(264932599,'created_by','JOSM'),(264932600,'created_by','JOSM'),(264932601,'created_by','JOSM'),(264932602,'created_by','JOSM'),(264932603,'created_by','JOSM'),(264932604,'created_by','JOSM'),(264932605,'created_by','JOSM'),(264932606,'created_by','JOSM'),(264932608,'created_by','JOSM'),(264932609,'created_by','JOSM'),(264932610,'created_by','JOSM'),(264932611,'created_by','JOSM'),(264932612,'created_by','JOSM'),(264932613,'created_by','JOSM'),(264932614,'created_by','JOSM'),(264932615,'created_by','JOSM'),(264932616,'created_by','JOSM'),(264932617,'created_by','JOSM'),(264932619,'created_by','JOSM'),(264932620,'created_by','JOSM'),(264932621,'created_by','JOSM'),(264932622,'created_by','JOSM'),(264932623,'created_by','JOSM'),(264932624,'created_by','JOSM'),(264932625,'created_by','JOSM'),(264932626,'created_by','JOSM'),(264932627,'created_by','JOSM'),(264932628,'created_by','JOSM'),(264932629,'created_by','JOSM'),(264932631,'created_by','JOSM'),(264932632,'created_by','JOSM'),(264932633,'created_by','JOSM'),(264932634,'created_by','JOSM'),(264932635,'created_by','JOSM'),(264932636,'created_by','JOSM'),(264932637,'created_by','JOSM'),(264932638,'created_by','JOSM'),(264932639,'created_by','JOSM'),(264932641,'created_by','JOSM'),(264932642,'created_by','JOSM'),(264932643,'created_by','JOSM'),(264932644,'created_by','JOSM'),(264932645,'created_by','JOSM'),(264932646,'created_by','JOSM'),(264932647,'created_by','JOSM'),(264932649,'created_by','JOSM'),(264932650,'created_by','JOSM'),(264932651,'created_by','JOSM'),(264932652,'created_by','JOSM'),(264932653,'created_by','JOSM'),(264932654,'created_by','JOSM'),(264932655,'created_by','JOSM'),(264932656,'created_by','JOSM'),(264932657,'created_by','JOSM'),(264932658,'created_by','JOSM'),(264932659,'created_by','JOSM'),(264932660,'created_by','JOSM'),(264932661,'created_by','JOSM'),(264932662,'created_by','JOSM'),(264932663,'created_by','JOSM'),(264932665,'created_by','JOSM'),(264932666,'created_by','JOSM'),(264932667,'created_by','JOSM'),(264932668,'created_by','JOSM'),(264932669,'created_by','JOSM'),(264932670,'created_by','JOSM'),(264932671,'created_by','JOSM'),(264932672,'created_by','JOSM'),(264932673,'created_by','JOSM'),(264932675,'created_by','JOSM'),(264932676,'created_by','JOSM'),(264932677,'created_by','JOSM'),(264932678,'created_by','JOSM'),(264932679,'created_by','JOSM'),(264932680,'created_by','JOSM'),(264932681,'created_by','JOSM'),(264932682,'created_by','JOSM'),(264932684,'created_by','JOSM'),(264932685,'created_by','JOSM'),(264932686,'created_by','JOSM'),(264932687,'created_by','JOSM'),(264932688,'created_by','JOSM'),(264932689,'created_by','JOSM'),(264932690,'created_by','JOSM'),(264932691,'created_by','JOSM'),(264932693,'created_by','JOSM'),(264932694,'created_by','JOSM'),(264932695,'created_by','JOSM'),(264932696,'created_by','JOSM'),(264932697,'created_by','JOSM'),(264932698,'created_by','JOSM'),(264932699,'created_by','JOSM'),(264932701,'created_by','JOSM'),(264932702,'created_by','JOSM'),(264932703,'created_by','JOSM'),(264932704,'created_by','JOSM'),(264932705,'created_by','JOSM'),(264932706,'created_by','JOSM'),(264932707,'created_by','JOSM'),(264932708,'created_by','JOSM'),(264932710,'created_by','JOSM'),(264932711,'created_by','JOSM'),(264932712,'created_by','JOSM'),(264932713,'created_by','JOSM'),(264932714,'created_by','JOSM'),(264932715,'created_by','JOSM'),(264932716,'created_by','JOSM'),(264932717,'created_by','JOSM'),(264932718,'created_by','JOSM'),(264932719,'created_by','JOSM'),(264932720,'created_by','JOSM'),(264932722,'created_by','JOSM'),(264932723,'created_by','JOSM'),(264932724,'created_by','JOSM'),(264932725,'created_by','JOSM'),(264932726,'created_by','JOSM'),(264932727,'created_by','JOSM'),(264932728,'created_by','JOSM'),(264932729,'created_by','JOSM'),(264932731,'created_by','JOSM'),(264932732,'created_by','JOSM'),(264932733,'created_by','JOSM'),(264932734,'created_by','JOSM'),(264932735,'created_by','JOSM'),(264932736,'created_by','JOSM'),(264932737,'created_by','JOSM'),(264932738,'created_by','JOSM'),(264932739,'created_by','JOSM'),(264932740,'created_by','JOSM'),(264932742,'created_by','JOSM'),(264932743,'created_by','JOSM'),(264932744,'created_by','JOSM'),(264932745,'created_by','JOSM'),(264932746,'created_by','JOSM'),(264932747,'created_by','JOSM'),(264932748,'created_by','JOSM'),(264932749,'created_by','JOSM'),(264932750,'created_by','JOSM'),(264932752,'created_by','JOSM'),(264932753,'created_by','JOSM'),(264932754,'created_by','JOSM'),(264932755,'created_by','JOSM'),(264932756,'created_by','JOSM'),(264932757,'created_by','JOSM'),(264932759,'created_by','JOSM'),(264932760,'created_by','JOSM'),(264932761,'created_by','JOSM'),(264932762,'created_by','JOSM'),(264932763,'created_by','JOSM'),(264932764,'created_by','JOSM'),(264932765,'created_by','JOSM'),(264932766,'created_by','JOSM'),(264932767,'created_by','JOSM'),(264932769,'created_by','JOSM'),(264932770,'created_by','JOSM'),(264932771,'created_by','JOSM'),(264932772,'created_by','JOSM'),(264932773,'created_by','JOSM'),(264932774,'created_by','JOSM'),(264932775,'created_by','JOSM'),(264932776,'created_by','JOSM'),(264932777,'created_by','JOSM'),(264932779,'created_by','JOSM'),(264932780,'created_by','JOSM'),(264932781,'created_by','JOSM'),(264932782,'created_by','JOSM'),(264932783,'created_by','JOSM'),(264932784,'created_by','JOSM'),(264932785,'created_by','JOSM'),(264932786,'created_by','JOSM'),(264932787,'created_by','JOSM'),(264932788,'created_by','JOSM'),(264932789,'created_by','JOSM'),(264932791,'created_by','JOSM'),(264932792,'created_by','JOSM'),(264932793,'created_by','JOSM'),(264932794,'created_by','JOSM'),(264932795,'created_by','JOSM'),(264932796,'created_by','JOSM'),(264932797,'created_by','JOSM'),(264932798,'created_by','JOSM'),(264932800,'created_by','JOSM'),(264932801,'created_by','JOSM'),(264932802,'created_by','JOSM'),(264932803,'created_by','JOSM'),(264932804,'created_by','JOSM'),(264932805,'created_by','JOSM'),(264932806,'created_by','JOSM'),(264932807,'created_by','JOSM'),(264932808,'created_by','JOSM'),(264932809,'created_by','JOSM'),(264932811,'created_by','JOSM'),(264932812,'created_by','JOSM'),(264932813,'created_by','JOSM'),(264932814,'created_by','JOSM'),(264932815,'created_by','JOSM'),(264932816,'created_by','JOSM'),(264932817,'created_by','JOSM'),(264932818,'created_by','JOSM'),(264932820,'created_by','JOSM'),(264932821,'created_by','JOSM'),(264932822,'created_by','JOSM'),(264932823,'created_by','JOSM'),(264932824,'created_by','JOSM'),(264932825,'created_by','JOSM'),(264932826,'created_by','JOSM'),(264932827,'created_by','JOSM'),(264932828,'created_by','JOSM'),(264932829,'created_by','JOSM'),(264932831,'created_by','JOSM'),(264932832,'created_by','JOSM'),(264932833,'created_by','JOSM'),(264932834,'created_by','JOSM'),(264932835,'created_by','JOSM'),(264932836,'created_by','JOSM'),(264932837,'created_by','JOSM'),(264932838,'created_by','JOSM'),(264932839,'created_by','JOSM'),(264932840,'created_by','JOSM'),(264932841,'created_by','JOSM'),(264932842,'created_by','JOSM'),(264932843,'created_by','JOSM'),(264932844,'created_by','JOSM'),(264932846,'created_by','JOSM'),(264932847,'created_by','JOSM'),(264932848,'created_by','JOSM'),(264932849,'created_by','JOSM'),(264932850,'created_by','JOSM'),(264932851,'created_by','JOSM'),(264932852,'created_by','JOSM'),(264932853,'created_by','JOSM'),(264932855,'created_by','JOSM'),(264932856,'created_by','JOSM'),(264932857,'created_by','JOSM'),(264932858,'created_by','JOSM'),(264932859,'created_by','JOSM'),(264932860,'created_by','JOSM'),(264932861,'created_by','JOSM'),(264932862,'created_by','JOSM'),(264932864,'created_by','JOSM'),(264932865,'created_by','JOSM'),(264932866,'created_by','JOSM'),(264932867,'created_by','JOSM'),(264932868,'created_by','JOSM'),(264932869,'created_by','JOSM'),(264932870,'created_by','JOSM'),(264932871,'created_by','JOSM'),(266324553,'created_by','Potlatch 0.9a'),(266324553,'is_in','Ordino'),(266324553,'name','Mas d\'en Soler'),(266324553,'place','hamlet'),(266324699,'building','water mill'),(266324699,'created_by','Potlatch 0.9a'),(266324699,'name','Moli de Mas d\'en Soler'),(266331736,'amenity','parking'),(266331736,'created_by','Potlatch 0.9a'),(266331970,'amenity','parking'),(266331970,'created_by','Potlatch 0.9a'),(266338686,'amenity','parking'),(266338686,'created_by','Potlatch 0.9a'),(266619909,'highway','turning_circle'),(266622062,'highway','turning_circle'),(266622086,'amenity','parking'),(266622086,'created_by','Potlatch 0.9a'),(266622595,'amenity','parking'),(266622595,'created_by','Potlatch 0.9a'),(268092455,'highway','turning_circle'),(268093053,'highway','mini_roundabout'),(268096174,'created_by','Potlatch 0.9c'),(268096174,'name','Hotel Xalet Besoli'),(268096174,'tourism','hotel'),(268123183,'highway','turning_circle'),(271938772,'created_by','JOSM'),(271938773,'created_by','JOSM'),(271938774,'created_by','JOSM'),(271938778,'created_by','JOSM'),(271939031,'amenity','fuel'),(271939031,'name','bp'),(271939031,'operator','BP'),(271939032,'created_by','JOSM'),(271939033,'created_by','JOSM'),(271939034,'created_by','JOSM'),(276993930,'ele','2360'),(276993930,'mountain_pass','yes'),(276993930,'name','Port de Siguer'),(276993930,'wikipedia','fr:Port_de_Siguer'),(277000148,'place_name','Plaça del Poble'),(277003684,'highway','turning_circle'),(277377767,'created_by','Potlatch 0.9c'),(277377767,'ele','2746'),(277377767,'name','Pic Oest de Casamanya'),(277377767,'natural','peak'),(277377889,'created_by','Potlatch 0.9c'),(277377889,'ele','2757'),(277377889,'name','Pic Est de Casamanya'),(277377889,'natural','peak'),(277377892,'created_by','Potlatch 0.9c'),(277377892,'ele','2731'),(277377892,'name','Pic Mig de Casamanya'),(277377892,'natural','peak'),(277378560,'created_by','Potlatch 0.9c'),(277378560,'ele','2550'),(277378560,'mountain_pass','yes'),(277378560,'name','Col d\'Arenys'),(278752636,'created_by','Potlatch 0.9c'),(278752636,'name','Hotel Nordic'),(278752636,'tourism','hotel'),(281694408,'created_by','Potlatch 0.10'),(281694408,'name','Hotel la Coma'),(281694408,'tourism','hotel'),(283678401,'amenity','parking'),(283678401,'created_by','Potlatch 0.10b'),(283680492,'amenity','arts_centre'),(283680492,'created_by','Potlatch 0.10b'),(283680492,'name','Auditori Nacional d\'Andorra'),(287401324,'highway','mini_roundabout'),(292503717,'amenity','fuel'),(292503717,'operator','Gasopas'),(316961244,'highway','mini_roundabout'),(316961410,'highway','mini_roundabout'),(316961518,'highway','mini_roundabout'),(316985105,'created_by','Potlatch 0.10f'),(316985105,'is_in','Ordino'),(316985105,'name','Les Salines'),(316985105,'place','hamlet'),(321651109,'ele','2642'),(321651109,'name','Pic Negre'),(321651109,'natural','peak'),(321679779,'name','Collada de Mitjana'),(321679779,'natural','land'),(321683609,'barrier','kissing_gate'),(321683609,'bicycle','yes'),(323130871,'aerialway','station'),(323130873,'aerialway','station'),(337743301,'amenity','parking'),(337743301,'created_by','Potlatch 0.10f'),(337743301,'operator','Parc central'),(337745019,'amenity','parking'),(337745019,'created_by','Potlatch 0.10f'),(337745019,'operator','Hipermercat Andorra 2000'),(337775428,'barrier','entrance'),(338420702,'barrier','garage door'),(339066904,'created_by','Potlatch 0.10f'),(339066904,'natural','peak'),(339066905,'created_by','Potlatch 0.10f'),(339066905,'natural','peak'),(364104064,'name','Camping Xixerella'),(364104064,'tourism','camp_site'),(367680434,'amenity','parking'),(367680434,'parking','surface'),(370902435,'highway','turning_circle'),(370903030,'highway','turning_circle'),(370903796,'highway','turning_circle'),(370909282,'highway','turning_circle'),(370911870,'amenity','place_of_worship'),(370911870,'created_by','Potlatch 0.10f'),(370911870,'denomination','roman_catholic'),(370911870,'name','Sant Cristofol d\'Anyos'),(370911870,'religion','christian'),(385582153,'amenity','parking'),(385582153,'operator','Aparcement Comunal Tobira'),(394816282,'highway','turning_circle'),(394820724,'highway','turning_circle'),(394832428,'highway','turning_circle'),(394840157,'amenity','place_of_worship'),(394840157,'denomination','roman_catholic'),(394840157,'name','Sant Romà d\'Auvinyà'),(394840157,'religion','christian'),(394841036,'highway','turning_circle'),(394847593,'highway','gate'),(441154305,'barrier','fence'),(441154308,'highway','turning_circle'),(442879444,'amenity','parking'),(442879444,'name','Parking Comunal de l\'Aldosa'),(442881217,'name','Hotel Magic Ski'),(442881217,'tourism','hotel'),(442881670,'name','Hotel Font'),(442881670,'tourism','hotel'),(442881710,'name','Hotel Magic'),(442881710,'tourism','hotel'),(442881842,'name','Hotel Marco Polo'),(442881842,'tourism','hotel'),(442881998,'amenity','parking'),(442881998,'name','Les Fontetes'),(442882169,'amenity','theatre'),(442882169,'name','Les Fontetes'),(442882272,'name','Hotel Burna'),(442882272,'tourism','hotel'),(442882442,'name','Compra Be'),(442882442,'shop','supermarket'),(442882581,'name','Residential de l\'Aldosa'),(442882581,'tourism','hotel'),(444324773,'amenity','parking'),(444324773,'name','Les Pardines'),(458761736,'building','Borda'),(458761736,'name','Borda de Sedornet'),(458762722,'ele','1934'),(458762722,'name','Roc de Castell'),(458762722,'natural','peak'),(458765074,'amenity','parking'),(470343766,'tourism','viewpoint'),(470364200,'amenity','parking'),(470364488,'amenity','parking'),(482150309,'ele','2570'),(482150309,'name','Pic del\'Hortell'),(482150309,'natural','peak'),(485578146,'ele','2526'),(485578146,'mountain_pass','yes'),(485578146,'name','Col de l\'Homme Mort'),(521134858,'amenity','restaurant'),(521134858,'name','Surf'),(521135636,'amenity','fast_food'),(521143390,'shop','supermarket'),(521144650,'shop','supermarket'),(521146418,'amenity','bar'),(521146418,'name','Red X'),(521153185,'aerialway','station'),(521153185,'man_made','Uphill Terminal'),(521153188,'aerialway','station'),(521153188,'man_made','Downhill Terminal'),(522787948,'amenity','restaurant'),(522787954,'amenity','bar'),(522787964,'amenity','fast_food'),(522787974,'amenity','hospital'),(522787985,'amenity','restaurant'),(522788283,'highway','bus_stop'),(522788287,'tourism','hotel'),(522800785,'amenity','bank'),(522800785,'atm','yes'),(522800788,'amenity','atm'),(529940889,'amenity','school'),(529941178,'name','Casa d\'Areny-Plandolit'),(529941178,'tourism','museum'),(529943807,'amenity','place_of_worship'),(535384824,'highway','speed_camera'),(567007523,'aerialway','station'),(567007523,'FIXME','Needs survey of correct position and full extent'),(567007523,'source','Estimate based on local knowledge'),(590463652,'name','Hotel St. Gothard'),(590463652,'tourism','hotel'),(590463653,'name','Apartments St. Moritz'),(590463653,'tourism','hotel'),(590463654,'name','St. Moritz Ski Hire'),(590463654,'shop','sports'),(590463655,'amenity','pharmacy'),(590463655,'dispensing','yes'),(590463656,'name','Hotel Solana'),(590463656,'tourism','hotel'),(590463659,'name','Hotel Princesa Parc'),(590463659,'tourism','hotel'),(590463661,'name','Hotel Xalet Verdu'),(590463661,'tourism','hotel'),(590463663,'name','Hotel Patagonia'),(590463663,'tourism','hotel'),(590463666,'highway','bus_stop'),(590463666,'name','Central Bus Stop'),(590463666,'name:en','Central Bus Stop'),(590463669,'name','Hotel Ayma'),(590463669,'tourism','hotel'),(590538923,'name','Resedencia Daina'),(590538923,'tourism','hotel'),(590538926,'name','Hotel Arinsal'),(590538926,'tourism','hotel'),(593870539,'amenity','restaurant'),(593870539,'ele','1926'),(593870539,'name','Restaurant Panoramix'),(593870540,'ele','1966'),(593870540,'name','Esports Rossell'),(593870540,'shop','sports'),(593870541,'amenity','atm'),(593870541,'ele','1935'),(593870542,'ele','1923'),(593870542,'name','Pic Negre'),(593870542,'shop','sports'),(593870542,'ski_hire','yes'),(593870543,'ele','1912'),(593870543,'name','Lift Pass Office'),(593870543,'shop','lift_pass'),(593870544,'ele','1923'),(593870544,'FIXME','Position is suspect'),(593870544,'name','Top of Chair lift'),(593870545,'ele','1935'),(593870545,'FIXME','Need a proper name'),(593870545,'name','Souvenir Shop at the Top of Gondola'),(593870545,'shop','gift'),(593870546,'ele','1482'),(593870546,'name','Shop 5150 (ski/sport shop)'),(593870547,'ele','1409'),(593870547,'name','Supermarket Nou'),(593870547,'shop','supermarket'),(593870548,'amenity','restaurant'),(593870548,'ele','1423'),(593870548,'internet_access','yes'),(593870548,'name','Restaurant Granja Del Poble (Internet Café)'),(593870549,'amenity','bar'),(593870549,'ele','1430'),(593870549,'name','Bar El Bosc'),(593870550,'amenity','restaurant'),(593870550,'ele','1422'),(593870550,'name','Restaurant Timotea'),(593870551,'amenity','atm'),(593870551,'ele','1430'),(593870552,'ele','1926'),(593870552,'name','Ski School'),(593870552,'shop','ski_school'),(593870553,'amenity','bar'),(593870553,'ele','146'),(593870553,'name','Bar/Restaurant 360'),(593870554,'amenity','bar'),(593870554,'ele','1461'),(593870554,'name','Black Bull Bar'),(593870555,'amenity','atm'),(593870555,'ele','1442'),(593870556,'amenity','restaurant'),(593870556,'ele','1474'),(593870556,'name','Restaurant/Bar Mollies'),(593870557,'amenity','atm'),(593870557,'ele','1476'),(593870558,'amenity','restaurant'),(593870558,'ele','1477'),(593870558,'name','Restaurant/Bar Ciscos'),(593870559,'amenity','bar'),(593870559,'ele','1515'),(593870559,'name','Cau Bar'),(593870560,'amenity','bar'),(593870560,'ele','1524'),(593870560,'name','Bar Quo Vadis'),(613344821,'man_made','Downhill Terminal'),(613344822,'man_made','Uphill Terminal'),(613344823,'man_made','Downhill Terminal'),(613344824,'man_made','Uphill Terminal'),(613344825,'man_made','Downhill Terminal'),(613344827,'man_made','Uphill Terminal'),(620937074,'amenity','restaurant'),(620937074,'building','yes'),(620937074,'name','Steak House'),(621473071,'amenity','restaurant'),(621473071,'name','Cubil'),(621473074,'ele','2560'),(621473074,'name','Tosa de Llosada'),(621473074,'natural','peak'),(621473077,'ele','2502'),(621473077,'name','Cortals'),(621473077,'natural','peak'),(621473079,'amenity','restaurant'),(621473079,'name','Solanelles'),(621473081,'ele','2467'),(621473081,'name','Tosa de Espiolets'),(621473081,'natural','peak'),(623510069,'ele','2528'),(623510069,'mountain_pass','yes'),(623510069,'name','Col Blanc'),(663075945,'man_made','Uphill Terminal'),(663075946,'man_made','Downhill Terminal'),(663078911,'man_made','Uphill Terminal'),(663078912,'man_made','Downhill Terminal'),(663080312,'man_made','Uphill Terminal'),(663080313,'man_made','Downhill Terminal'),(663084327,'man_made','Uphill Terminal'),(663084328,'man_made','Downhill Terminal'),(663086638,'man_made','Downhill Terminal'),(663086639,'man_made','Uphill Terminal'),(663092389,'man_made','Uphill Terminal'),(663092390,'man_made','Downhill Terminal'),(663093429,'man_made','Uphill Terminal'),(663093430,'man_made','Downhill Terminal'),(663095052,'man_made','Downhill Terminal'),(663339197,'man_made','Uphill Terminal'),(663339199,'man_made','Downhill Terminal'),(663345420,'man_made','Uphill Terminal'),(663345421,'man_made','Downhill Terminal'),(663372539,'man_made','Uphill Terminal'),(663372540,'man_made','Downhill Terminal'),(663373401,'aerialway','station'),(663373401,'man_made','Uphill Terminal'),(663373402,'aerialway','station'),(663373402,'man_made','Downhill Terminal'),(663802644,'man_made','Uphill Terminal'),(663802645,'man_made','Downhill Terminal'),(663803593,'man_made','Uphill Terminal'),(663803594,'man_made','Downhill Terminal'),(663952666,'man_made','Downhill Terminal'),(663952667,'man_made','Uphill Terminal'),(663953196,'historic','monument'),(663953196,'name','Monument L\'Anella d\'Ordino'),(664116090,'man_made','Downhill Terminal'),(664116091,'aerialway','station'),(664116091,'man_made','Uphill Terminal'),(664116161,'aerialway','station'),(664116161,'man_made','Downhill Terminal'),(664192679,'aerialway','pylon'),(664192680,'aerialway','pylon'),(664192681,'aerialway','pylon'),(664195007,'man_made','Downhill Terminal'),(664195008,'man_made','Uphill Terminal'),(664205614,'aerialway','station'),(664205614,'man_made','Uphill Terminal'),(664205619,'aerialway','pylon'),(664205621,'aerialway','pylon'),(664205624,'aerialway','pylon'),(664205627,'aerialway','pylon'),(664205630,'aerialway','pylon'),(664205633,'aerialway','pylon'),(664205635,'aerialway','pylon'),(664205638,'aerialway','station'),(664205638,'man_made','Downhill Terminal'),(664205641,'aerialway','pylon'),(664205644,'aerialway','pylon'),(664225476,'aerialway','pylon'),(664225514,'aerialway','pylon'),(664225516,'aerialway','pylon'),(664225519,'aerialway','pylon'),(664225521,'aerialway','pylon'),(664225523,'aerialway','pylon'),(664225525,'aerialway','pylon'),(664225527,'aerialway','pylon'),(664225529,'aerialway','pylon'),(664225531,'aerialway','pylon'),(664236924,'aerialway','pylon'),(664236925,'aerialway','pylon'),(664236926,'aerialway','pylon'),(664236927,'aerialway','pylon'),(664236928,'aerialway','pylon'),(664605824,'aerialway','station'),(666793593,'ele','2447'),(666793593,'information','guidepost'),(666793593,'name','Collada D\'Enradort'),(666793593,'tourism','information'),(666793594,'amenity','restaurant'),(666793594,'name','Roc De Les Bruixes'),(666793595,'amenity','fast_food'),(666793596,'amenity','toilets'),(666793597,'ele','2000'),(666793597,'information','guidepost'),(666793597,'name','El Forn'),(666793597,'tourism','information'),(666793598,'amenity','fast_food'),(666793599,'amenity','toilets'),(666793600,'ele','2560'),(666793600,'information','guidepost'),(666793600,'name','Tosa De La Llosada'),(666793600,'tourism','information'),(666793601,'amenity','hospital'),(666793602,'amenity','hospital'),(666793603,'ele','2465'),(666793603,'information','guidepost'),(666793603,'name','Portella'),(666793603,'tourism','information'),(666793604,'ele','2458'),(666793604,'information','guidepost'),(666793604,'name','C. De Les Solanelles'),(666793604,'tourism','information'),(666793605,'ele','2502'),(666793605,'information','guidepost'),(666793605,'name','Cortals'),(666793605,'tourism','information'),(666793606,'amenity','fast_food'),(666793607,'amenity','hospital'),(666793608,'amenity','toilets'),(666793609,'amenity','toilets'),(666793610,'amenity','hospital'),(666793611,'ele','2467'),(666793611,'information','guidepost'),(666793611,'name','Tossa Dels Espiolets'),(666793611,'tourism','information'),(666793612,'amenity','fast_food'),(666793613,'ele','2100'),(666793613,'information','guidepost'),(666793613,'name','Riba Escorxada'),(666793613,'tourism','information'),(666793614,'amenity','restaurant'),(666793614,'name','El Mercal Del Pi'),(666793615,'amenity','toilets'),(666793616,'amenity','restaurant'),(666793616,'name','Gall De Bosc'),(666793617,'amenity','fast_food'),(666793618,'ele','2250'),(666793618,'information','guidepost'),(666793618,'name','Espiolets'),(666793618,'tourism','information'),(666793619,'amenity','fast_food'),(666793620,'ele','2150'),(666793620,'information','guidepost'),(666793620,'name','Pla De Les Pedres'),(666793620,'tourism','information'),(666793621,'amenity','toilets'),(666793622,'amenity','fast_food'),(666793623,'amenity','toilets'),(669985285,'description','Mire Duralumin - Point vu en place en 1948'),(669985285,'man_made','survey_point'),(669985285,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669985285,'ref','0902401 -'),(669985285,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669985285,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0902401&no_ptg=02&numero_f50=2149'),(669985286,'description','Repère I - Point vu en place en 1948'),(669985286,'man_made','survey_point'),(669985286,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669985286,'ref','0902401 -'),(669985286,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669985286,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0902401&no_ptg=04&numero_f50=2149'),(669985287,'description','Repère II - Point vu en place en 1948'),(669985287,'man_made','survey_point'),(669985287,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669985287,'ref','0902401 -'),(669985287,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669985287,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0902401&no_ptg=05&numero_f50=2149'),(669985289,'description','Repère III - Point vu en place en 1948'),(669985289,'man_made','survey_point'),(669985289,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669985289,'ref','0902401 -'),(669985289,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669985289,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0902401&no_ptg=06&numero_f50=2149'),(669985291,'description','Borne en granit gravée IGN - Point vu en place en 1950'),(669985291,'ele','2912.38'),(669985291,'man_made','survey_point'),(669985291,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669985291,'ref','0902401 - 1'),(669985291,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669985291,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0902401&no_ptg=01&numero_f50=2149'),(669985299,'description','Borne en granit gravée IGN - Point vu en place en 1950'),(669985299,'ele','2594.87'),(669985299,'man_made','survey_point'),(669985299,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669985299,'ref','0902407 - 1'),(669985299,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669985299,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0902407&no_ptg=01&numero_f50=2149'),(669985301,'description','Rocher : Repère : Rivet en fer scellé - Point vu en place en 1950'),(669985301,'ele','2594.99'),(669985301,'man_made','survey_point'),(669985301,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669985301,'ref','0902407 - A'),(669985301,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669985301,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0902407&no_ptg=03&numero_f50=2149'),(669985341,'description','Borne en granit gravée IGN - Point vu en place en 1950'),(669985341,'ele','2913.56'),(669985341,'man_made','survey_point'),(669985341,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669985341,'ref','0903004 - 1'),(669985341,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669985341,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0903004&no_ptg=01&numero_f50=2149'),(669985348,'description','Borne en granit gravée IGN - Point vu en place en 1950'),(669985348,'ele','2804.65'),(669985348,'man_made','survey_point'),(669985348,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669985348,'ref','0903008 - 1'),(669985348,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669985348,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0903008&no_ptg=01&numero_f50=2149'),(669985685,'description','Rocher : Repère en bronze scellé - Point vu en place en 1950'),(669985685,'ele','2810.7'),(669985685,'man_made','survey_point'),(669985685,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669985685,'ref','0913901 - 1'),(669985685,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669985685,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0913901&no_ptg=01&numero_f50=2149'),(669985690,'description','Rocher : Croix gravée - Point vu en place en 1948'),(669985690,'man_made','survey_point'),(669985690,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669985690,'ref','0913901 - 2'),(669985690,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669985690,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0913901&no_ptg=02&numero_f50=2149'),(669986979,'description','Borne en granit gravée IGN - Point vu en place en 1950'),(669986979,'ele','2902.82'),(669986979,'man_made','survey_point'),(669986979,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669986979,'ref','0929501 - 1'),(669986979,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669986979,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0929501&no_ptg=01&numero_f50=2149'),(669986980,'description','Repère en bronze scellé - Point vu en place en 1950'),(669986980,'ele','2902.66'),(669986980,'man_made','survey_point'),(669986980,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669986980,'ref','0929501 - A'),(669986980,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669986980,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0929501&no_ptg=03&numero_f50=2149'),(669986981,'description','Rivet en fer scellé au N.E - Point vu en place en 1950'),(669986981,'ele','2902.92'),(669986981,'man_made','survey_point'),(669986981,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669986981,'ref','0929501 - B'),(669986981,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669986981,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0929501&no_ptg=04&numero_f50=2149'),(669986982,'description','Rivet en fer scellé au N.O - Point vu en place en 1950'),(669986982,'ele','2902.11'),(669986982,'man_made','survey_point'),(669986982,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669986982,'ref','0929501 - C'),(669986982,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669986982,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0929501&no_ptg=05&numero_f50=2149'),(796044564,'name','River'),(796044564,'shop','supermarket'),(796044575,'name','Punt de Trobada'),(796044575,'shop','supermarket'),(820950476,'name','Hotel Himalaya'),(820950476,'tourism','hotel'),(820952919,'name','Hotel'),(820952919,'tourism','hotel'),(820954183,'name','Hotel Bruxelles'),(820954183,'tourism','hotel'),(821006310,'amenity','restaurant'),(821006310,'name','Bruxellles Restaurant'),(894259010,'man_made','tower'),(894259010,'name','Torre dals Morus'),(894259010,'tourism','viewpoint'),(894259394,'amenity','place_of_worship'),(894259394,'religion','christian'),(894259503,'amenity','place_of_worship'),(894259503,'name','Santa Romà de les Bons'),(894259503,'religion','christian'),(894259507,'amenity','restaurant'),(894259507,'name','La Dama del Llac'),(894259507,'phone','+376828206'),(894259529,'amenity','restaurant'),(894259529,'name','Camp del FIXME'),(894259529,'tourism','hotel'),(894263141,'amenity','parking'),(894263144,'historic','church'),(894263144,'name','Sant Joan de Caselles'),(894263144,'tourism','attraction'),(895601487,'highway','bus_stop'),(895601487,'shelter','no'),(895601494,'amenity','restaurant'),(895601494,'name','Borda del Tremat'),(895604180,'amenity','restaurant'),(895604180,'name','L\'era del Rossell'),(899525861,'amenity','shelter'),(899525861,'ele','2218'),(899525861,'fireplace','yes'),(899525861,'name','Refuge de Coms de Jan - andorre'),(899525861,'note','98'),(899525861,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525869,'amenity','shelter'),(899525869,'ele','2030'),(899525869,'fireplace','no'),(899525869,'name','Cabane Estany   - andorre'),(899525869,'note','583'),(899525869,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525876,'amenity','shelter'),(899525876,'ele','2250'),(899525876,'name','Cabane Setut - andorre'),(899525876,'note','593'),(899525876,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525898,'amenity','shelter'),(899525898,'name','Cabane Banyell planells de rialp - andorre'),(899525898,'note','579'),(899525898,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525904,'amenity','shelter'),(899525904,'ele','2280'),(899525904,'name','Refuge Claror - andorre'),(899525904,'note','580'),(899525904,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525912,'amenity','shelter'),(899525912,'ele','2220'),(899525912,'fireplace','yes'),(899525912,'name','Refuge de l Angonella - andorre'),(899525912,'note','10'),(899525912,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525929,'amenity','shelter'),(899525929,'ele','2394'),(899525929,'fireplace','yes'),(899525929,'name','Cabane de l Estany de Juclar - andorre'),(899525929,'note','183'),(899525929,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525940,'amenity','shelter'),(899525940,'name','Cabane Estall Serrer - Andorre'),(899525940,'note','1129'),(899525940,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525948,'amenity','shelter'),(899525948,'ele','2220'),(899525948,'fireplace','no'),(899525948,'name','Cabane Fonts - andorre'),(899525948,'note','584'),(899525948,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525953,'amenity','shelter'),(899525953,'name','Cabane Riu dels Orris - andorre'),(899525953,'note','591'),(899525953,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525975,'amenity','shelter'),(899525975,'ele','2240'),(899525975,'fireplace','yes'),(899525975,'name','Cabane Portella - andorre'),(899525975,'note','589'),(899525975,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525984,'ele','2250'),(899525984,'name','Refuge de La Coma Pedrosa - andorre'),(899525984,'note','96'),(899525984,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525984,'tourism','alpine_hut'),(899525989,'amenity','shelter'),(899525989,'name','Cabane Vall del Riu - andorre'),(899525989,'note','592'),(899525989,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526014,'amenity','shelter'),(899526014,'ele','1980'),(899526014,'fireplace','yes'),(899526014,'name','Cabane Borda Sorteny - andorre'),(899526014,'note','594'),(899526014,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526022,'amenity','shelter'),(899526022,'ele','2260'),(899526022,'fireplace','no'),(899526022,'name','Cabane de La Coma Pedrosa - andorre'),(899526022,'note','95'),(899526022,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526028,'amenity','shelter'),(899526028,'ele','2629'),(899526028,'fireplace','no'),(899526028,'name','Cabane de l Estany Forcat - Andorre'),(899526028,'note','968'),(899526028,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526049,'amenity','shelter'),(899526049,'ele','1830'),(899526049,'fireplace','yes'),(899526049,'name','Refuge de Fontverd - andorre'),(899526049,'note','143'),(899526049,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526058,'amenity','shelter'),(899526058,'ele','1838'),(899526058,'fireplace','yes'),(899526058,'name','Cabane Arcalis ou Pleta castellar - andorre'),(899526058,'note','578'),(899526058,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526069,'amenity','shelter'),(899526069,'ele','2250'),(899526069,'fireplace','yes'),(899526069,'name','Cabane de Sorda - andorre'),(899526069,'note','303'),(899526069,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526084,'amenity','shelter'),(899526084,'ele','2480'),(899526084,'name','Cabane Estany  Illa - andorre'),(899526084,'note','585'),(899526084,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526090,'amenity','shelter'),(899526090,'ele','2480'),(899526090,'fireplace','yes'),(899526090,'name','Cabane Ensagents - andorre'),(899526090,'note','581'),(899526090,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526097,'amenity','shelter'),(899526097,'name','Refuge Prat Primer - andorre'),(899526097,'note','590'),(899526097,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526119,'amenity','shelter'),(899526119,'ele','2200'),(899526119,'fireplace','yes'),(899526119,'name','Cabanes de Perafita - andorre'),(899526119,'note','248'),(899526119,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526127,'amenity','shelter'),(899526127,'name','Cabane Riba Escorxada - andorre'),(899526127,'note','582'),(899526127,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526136,'amenity','shelter'),(899526136,'name','Cabane Estanya - Andorre'),(899526136,'note','1132'),(899526136,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526171,'amenity','shelter'),(899526171,'ele','2020'),(899526171,'fireplace','yes'),(899526171,'name','Refuge de Rialp - andorre'),(899526171,'note','287'),(899526171,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526182,'amenity','shelter'),(899526182,'ele','2200'),(899526182,'fireplace','yes'),(899526182,'name','Cabane de La Farga - andorre'),(899526182,'note','140'),(899526182,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526219,'amenity','shelter'),(899526219,'ele','2250'),(899526219,'fireplace','yes'),(899526219,'name','Refuge des Agols - andorre'),(899526219,'note','5'),(899526219,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526225,'amenity','shelter'),(899526225,'ele','2010'),(899526225,'fireplace','yes'),(899526225,'name','Refuge de Coma Obaga - andorre'),(899526225,'note','94'),(899526225,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526237,'amenity','shelter'),(899526237,'ele','2150'),(899526237,'fireplace','yes'),(899526237,'name','Pla de les Pedres - Andorre'),(899526237,'note','985'),(899526237,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526263,'amenity','shelter'),(899526263,'ele','2190'),(899526263,'fireplace','yes'),(899526263,'name','Cabane Pleta Serrera - Andorre'),(899526263,'note','967'),(899526263,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526271,'amenity','shelter'),(899526271,'name','Cabane del Serrat de la  Barracota - Andorre'),(899526271,'note','1131'),(899526271,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526282,'amenity','shelter'),(899526282,'ele','2180'),(899526282,'fireplace','yes'),(899526282,'name','Refuge de Siscaro - andorre'),(899526282,'note','301'),(899526282,'source','Association \"Refuges et cabanes des Pyrénées\"'),(901125108,'ele','2946'),(901125108,'name','Pic de Coma Pedrosa'),(901125108,'natural','peak'),(901125108,'note','Pic de Coma Pedrosa'),(901170351,'ele','2914'),(901170351,'name','Pic de Medecourbe'),(901170351,'natural','peak');
INSERT INTO `current_nodes` VALUES (625022,425128450,15513604,232546,1,'2008-04-23 11:33:55',3310491548,4),(625023,425131024,15516715,232546,1,'2008-04-23 11:31:12',3310491548,3),(625024,425132796,15520491,232546,1,'2008-04-23 11:31:12',3310491548,3),(625025,425141739,15526900,427965,1,'2007-09-14 19:57:45',3310491548,1),(625026,425144463,15526776,2762,1,'2006-03-14 15:46:56',3310491548,1),(625027,425152372,15529780,2762,1,'2006-03-14 15:46:57',3310491549,1),(625028,425165907,15535741,427965,1,'2007-09-14 19:57:45',3310491549,1),(625029,425170402,15539651,2762,1,'2006-03-14 15:47:00',3310491549,1),(625030,425179485,15552163,232546,1,'2008-04-23 11:29:32',3310491594,2),(625031,425192920,15567756,427965,1,'2007-09-14 19:57:45',3310491594,1),(625032,425212467,15586896,427965,1,'2007-09-14 19:57:45',3310491595,1),(625033,425219426,15596166,427965,1,'2007-09-14 19:57:45',3310491595,1),(625034,425226005,15608611,427965,1,'2007-09-14 19:56:23',3310491617,1),(625035,425239988,15622907,2762,1,'2006-03-14 15:49:10',3310491620,1),(625036,425245931,15631270,427965,1,'2007-09-14 19:56:23',3310491620,1),(625037,425248714,15641570,427965,1,'2007-09-14 19:56:23',3310491620,1),(625038,425250612,15644488,427965,1,'2007-09-14 19:56:22',3310491620,1),(625039,425252761,15648066,2895121,1,'2009-10-19 19:23:45',3310491620,3),(625040,425261618,15667319,427965,1,'2007-09-14 19:56:23',3310491623,1),(625041,425270725,15679480,188228,1,'2008-06-16 19:35:06',3310491623,2),(625042,425273129,15685402,188228,1,'2008-06-16 19:35:26',3310491623,2),(625043,425275912,15690552,188228,1,'2008-06-16 19:35:55',3310491623,2),(625044,425285020,15692440,188228,1,'2008-06-16 19:38:21',3310491623,2),(625045,425288309,15691496,188228,1,'2008-06-16 19:38:45',3310491634,2),(625046,425291915,15695616,188228,1,'2008-06-16 19:39:37',3310491634,2),(625047,425291472,15702311,188228,1,'2008-06-16 19:39:37',3310491634,2),(625048,425291219,15707117,188228,1,'2008-06-16 19:39:37',3310491634,2),(625049,425291851,15710207,188228,1,'2008-06-16 19:39:37',3310491634,2),(625050,425298176,15719305,188228,1,'2008-06-16 19:41:22',3310491640,2),(625051,425311524,15728774,427965,1,'2007-09-14 19:56:23',3310491640,1),(625052,425320693,15738617,188228,1,'2008-06-16 20:02:41',3310491641,2),(625053,425323793,15745827,188228,1,'2008-06-16 20:02:41',3310491641,2),(625054,425326386,15756470,188228,1,'2008-06-16 20:02:41',3310491641,2),(625055,425327840,15765225,188228,1,'2008-06-16 20:02:41',3310491641,2),(625056,425329807,15783839,2762,1,'2006-03-14 15:49:36',3310491643,1),(625057,425333918,15797143,2762,1,'2006-03-14 15:49:37',3310491643,1),(625058,425341250,15806451,427965,1,'2007-09-14 19:56:23',3310491643,1),(625059,425350548,15813489,427965,1,'2007-09-14 19:56:23',3310491646,1),(625060,425359216,15819888,2762,1,'2006-03-14 15:49:41',3310491646,1),(625061,425363959,15826325,2762,1,'2006-03-14 15:49:42',3310493012,1),(625062,425371549,15837483,2762,1,'2006-03-14 15:49:45',3310493013,1),(625063,425368509,15847220,427965,1,'2007-09-14 19:56:23',3310493012,1),(625064,425362311,15850224,427965,1,'2007-09-14 19:56:23',3310493012,1),(625065,425349978,15857091,427965,1,'2007-09-14 19:56:23',3310493012,1),(625066,425347069,15857778,427965,1,'2007-09-14 19:51:34',3310493012,1),(625067,425340875,15851645,2762,1,'2006-03-14 15:49:54',3310493009,1),(625068,425335499,15850358,2762,1,'2006-03-14 15:49:57',3310493009,1),(625069,425335874,15855718,427965,1,'2007-09-14 19:56:23',3310493009,1),(625070,425342456,15863662,2762,1,'2006-03-14 15:49:59',3310493012,1),(625071,425220944,15598655,427965,1,'2007-09-14 19:56:23',3310491595,1),(625072,425372177,15843959,427965,1,'2007-09-14 19:56:23',3310493013,1),(625073,425349219,15876918,427965,1,'2007-09-14 19:51:17',3310493014,1),(625074,425356746,15884728,427965,1,'2007-09-14 19:51:17',3310493014,1),(625075,425363959,15888124,2762,1,'2006-03-14 15:52:08',3310493014,1),(625076,425370217,15893140,427965,1,'2007-09-14 19:51:17',3310493015,1),(625077,425375466,15904727,427965,1,'2007-09-14 19:51:17',3310493015,1),(625078,425396209,15917516,427965,1,'2007-09-14 19:51:17',3310493015,1),(625079,425402596,15919147,427965,1,'2007-09-14 19:51:17',3310503938,1),(625080,425404557,15920777,427965,1,'2007-09-14 19:51:17',3310503938,1),(625081,425412339,15922456,2762,1,'2006-03-14 15:52:18',3310503938,1),(625082,425417078,15917773,427965,1,'2007-09-14 19:51:17',3310503938,1),(625083,425420240,15916142,427965,1,'2007-09-14 19:51:17',3310503938,1),(625084,425429789,15914941,427965,1,'2007-09-14 19:49:09',3310503939,1),(625085,425432825,15915456,427965,1,'2007-09-14 19:49:09',3310503939,1),(625086,425443161,15918083,427965,1,'2007-09-14 20:33:11',3310503939,1),(625087,425445535,15917344,427965,1,'2007-09-14 19:49:09',3310503939,1),(625088,425452175,15914855,427965,1,'2007-09-14 19:49:09',3310503942,1),(625089,425462925,15914598,427965,1,'2007-09-14 19:49:09',3310503942,1),(625090,425470576,15917516,427965,1,'2007-09-14 19:49:09',3310503942,1),(625091,425489988,15916314,427965,1,'2007-09-14 19:48:40',3310503943,1),(625198,425497074,15914076,5671401,1,'2010-09-03 18:06:00',3310503943,2),(625199,425513473,15905539,5671401,1,'2010-09-03 18:06:02',3310503954,2),(625200,425515861,15903207,5671401,1,'2010-09-03 18:06:01',3310503954,2),(625202,425524242,15892711,5671401,1,'2010-09-03 18:06:00',3310503954,2),(625203,425529637,15888124,2774,1,'2006-03-14 23:12:11',3310503954,1),(625204,425535071,15886788,427965,1,'2007-09-14 19:48:40',3310503955,1),(625205,425547555,15885554,426786,1,'2007-09-14 10:10:35',3310503955,1),(625206,425554498,15884953,454632,1,'2007-09-17 18:41:27',3310503955,1),(625207,425574843,15886836,2774,1,'2006-03-14 23:12:15',3310503958,1),(625208,425587673,15891681,427965,1,'2007-09-14 19:46:49',3310503958,1),(625209,425593493,15892415,2774,1,'2006-03-14 23:12:17',3310503959,1),(625210,425596654,15894132,2774,1,'2006-03-14 23:12:18',3310503959,1),(625211,425605438,15899920,427965,1,'2007-09-14 19:46:49',3310503959,1),(625243,425619375,15903578,426786,1,'2007-09-14 10:13:24',3310504002,1),(625244,425629553,15905981,426786,1,'2007-09-14 10:13:24',3310504002,1),(625245,425638755,15910869,427965,1,'2007-09-14 19:12:43',3310504002,1),(625246,425640145,15919232,427965,1,'2007-09-14 19:45:55',3310504002,1),(625247,425641347,15925460,427965,1,'2007-09-14 19:12:43',3310504002,1),(625248,425642513,15928641,426786,1,'2007-09-14 10:13:29',3310504002,1),(625249,425656076,15936017,427965,1,'2007-09-14 19:12:39',3310504009,1),(625250,425657088,15938077,427965,1,'2007-09-14 19:12:11',3310504009,1),(625251,425660438,15942369,427965,1,'2007-09-14 19:12:11',3310504009,1),(625252,425661414,15956622,426786,1,'2007-09-14 10:13:29',3310504009,1),(625254,425658292,15967517,2774,1,'2006-03-14 23:27:22',3310504009,1),(625256,425657530,15975671,427965,1,'2007-09-14 19:12:11',3310504009,1),(625257,425658380,15978852,426786,1,'2007-09-14 10:13:29',3310504009,1),(625259,425666345,15998593,426786,1,'2007-09-14 10:13:29',3310504011,1),(625260,425671275,16010266,426786,1,'2007-09-14 10:13:37',3310504011,1),(625261,425675167,16016956,427965,1,'2007-09-14 19:10:26',3310504014,1),(625263,425680378,16026316,426786,1,'2007-09-14 10:13:32',3310504014,1),(625264,425684522,16037383,427965,1,'2007-09-14 19:10:38',3310504014,1),(625265,425695079,16047254,427965,1,'2007-09-14 19:10:38',3310504036,1),(625266,425699377,16048198,427965,1,'2007-09-14 19:10:15',3310504037,1),(625267,425707721,16062532,427965,1,'2007-09-14 19:10:15',3310504037,1),(625268,425708858,16070085,427965,1,'2007-09-14 19:10:11',3310504037,1),(625269,425710375,16078067,427965,1,'2007-09-14 19:10:11',3310504037,1),(625270,425715495,16091199,427965,1,'2007-09-14 19:08:20',3310504037,1),(625271,425715559,16095319,427965,1,'2007-09-14 19:08:20',3310504039,1),(625272,425716218,16112147,426786,1,'2007-09-14 10:13:42',3310504039,1),(625273,425718747,16117039,426786,1,'2007-09-14 10:13:42',3310504039,1),(625274,425723902,16146131,427965,1,'2007-09-14 19:08:20',3310504039,1),(625275,425725699,16151801,426786,1,'2007-09-14 10:13:42',3310504045,1),(625276,425728101,16160040,426786,1,'2007-09-14 10:13:42',3310504056,1),(625277,425729084,16165137,427965,1,'2007-09-14 19:43:57',3310504056,1),(625293,425746312,16207325,495907,1,'2008-07-15 19:46:04',3310504058,2),(625294,425754781,16222517,495907,1,'2008-07-15 19:48:35',3310504059,3),(625295,425765336,16246378,495907,1,'2008-07-15 19:48:35',3310504059,2),(625296,425770772,16255219,495907,1,'2008-07-15 19:48:35',3310504059,2),(625297,425775133,16258480,495907,1,'2008-07-15 19:48:35',3310504059,2),(625298,425779620,16270840,495907,1,'2008-07-15 19:48:35',3310504145,2),(625299,425780442,16292898,495907,1,'2008-07-15 19:48:35',3310504145,2),(625300,425784044,16300366,495907,1,'2008-07-15 19:48:35',3310504148,2),(625301,425785561,16319334,495907,1,'2008-07-15 19:48:35',3310504150,2),(625302,425783033,16329119,495907,1,'2008-07-15 19:48:35',3310504150,2),(625303,425783602,16348946,495907,1,'2008-07-15 19:50:23',3310504150,2),(625304,425789795,16374952,495907,1,'2008-07-15 19:50:23',3310504156,2),(625305,425787963,16390316,495907,1,'2008-07-15 19:50:23',3310504156,2),(625306,425797064,16404478,495907,1,'2008-07-15 19:50:57',3310504156,2),(625307,425799781,16416409,495907,1,'2008-07-15 19:50:57',3310504156,2),(26609114,424993792,15130420,434787,1,'2007-09-15 15:33:35',3310491403,1),(45160875,425835415,14617491,110477,1,'2008-12-04 18:28:50',3310502109,5),(45160879,425822776,14579726,110477,1,'2008-12-04 18:28:50',3310502103,5),(45160885,425754519,14572859,110477,1,'2008-12-04 18:28:50',3310502099,5),(45160890,425726708,14524794,110477,1,'2008-12-04 18:28:50',3310502085,5),(45160893,425681197,14466429,110477,1,'2008-12-04 18:28:50',3310501998,5),(45160897,425951686,14751387,110477,1,'2008-12-04 18:28:48',3310502320,5),(45160899,425928939,14737654,110477,1,'2008-12-04 18:28:49',3310502309,5),(45160902,425901136,14734221,110477,1,'2008-12-04 18:28:49',3310502308,5),(45160904,425880560,14747220,110477,1,'2008-12-04 18:28:49',3310502305,4),(45160908,425855560,14719440,110477,1,'2008-12-04 18:28:49',3310502282,4),(45160910,425830560,14688890,110477,1,'2008-12-04 18:28:49',3310502111,4),(45160922,426499887,15166808,784366,1,'2008-11-23 16:35:10',3310503520,4),(45160924,426497362,15129042,784366,1,'2008-11-23 16:35:10',3310503498,4),(45160947,426014867,14706755,110477,1,'2008-12-04 18:28:48',3310502302,5),(45160950,425979486,14747954,110477,1,'2008-12-04 18:28:48',3310502321,6),(45160954,426411500,14765120,784366,1,'2008-11-23 16:35:10',3310503088,4),(45160958,426224900,14663107,784366,1,'2008-11-23 16:35:12',3310502364,7),(45160962,426464534,14957381,784366,1,'2008-11-23 16:35:10',3310503444,4),(45160967,426456958,14878416,784366,1,'2008-11-23 16:35:10',3310503100,4),(45160974,426497362,15091277,784366,1,'2008-11-23 16:35:10',3310503496,4),(45160977,426479685,15043211,784366,1,'2008-11-23 16:35:10',3310503447,4),(45161058,426561110,15547220,784366,1,'2008-11-23 16:35:09',3310503630,3),(45161062,426535206,15582609,784366,1,'2008-11-23 16:35:09',3310503627,4),(45161066,426530156,15622091,784366,1,'2008-11-23 16:35:08',3310503649,4),(45161067,426525738,15652990,784366,1,'2008-11-23 16:35:08',3310503649,4),(45161204,426483330,15230560,784366,1,'2008-11-23 16:35:10',3310503479,3),(45161208,426522220,15244440,784366,1,'2008-11-23 16:35:10',3310503522,3),(45161227,426295915,16118192,784366,1,'2008-11-23 16:35:05',3310504994,4),(45161231,426280127,16069269,784366,1,'2008-11-23 16:35:06',3310504992,4),(45161233,426273181,16014337,784366,1,'2008-11-23 16:35:07',3310504287,4),(45161238,426307913,15973138,784366,1,'2008-11-23 16:35:07',3310504969,4),(45161251,426355273,16260671,784366,1,'2008-11-23 16:35:05',3310505092,4),(45161256,426323069,16200589,784366,1,'2008-11-23 16:35:05',3310505001,4),(45161262,426307282,16167974,784366,1,'2008-11-23 16:35:05',3310505001,4),(45161265,426444299,15791177,784366,1,'2008-11-23 16:35:08',3310503614,4),(45161269,426475866,15751695,784366,1,'2008-11-23 16:35:08',3310503613,4),(45161277,426492911,15713929,784366,1,'2008-11-23 16:35:08',3310503613,4),(45161283,426513112,15675306,784366,1,'2008-11-23 16:35:08',3310503650,4),(45161289,426369164,15938806,784366,1,'2008-11-23 16:35:07',3310504973,4),(45161296,426391895,15890741,784366,1,'2008-11-23 16:35:07',3310504978,4),(45161302,426409574,15840101,784366,1,'2008-11-23 16:35:07',3310504976,4),(45161308,426429778,15815210,784366,1,'2008-11-23 16:35:08',3310503611,4),(45161330,426308330,16950000,784366,1,'2008-11-23 16:35:01',3310505505,3),(45161333,426291670,16991670,784366,1,'2008-11-23 16:35:00',3310505506,3),(45161344,426327780,16911110,784366,1,'2008-11-23 16:35:01',3310505483,3),(45181716,426174178,14623441,4133451,1,'2010-03-15 12:47:53',3310502360,4),(51110488,424847502,14917003,592895,1,'2008-07-25 21:28:01',3310490863,5),(51110489,424844591,14912196,592895,1,'2008-07-25 21:28:01',3310490863,2),(51110491,424844528,14910994,592895,1,'2008-07-25 21:28:01',3310490863,2),(51110493,424843895,14910308,592895,1,'2008-07-25 21:28:01',3310490863,2),(51110495,424842888,14910345,592895,1,'2008-07-25 21:28:01',3310490863,2),(51110496,424842445,14910775,592895,1,'2008-07-25 21:28:01',3310490863,2),(51110498,424842122,14912883,592895,1,'2008-07-25 21:28:02',3310490863,3),(51110499,424842882,14913913,592895,1,'2008-07-25 21:28:02',3310490863,3),(51110501,424843831,14914084,592895,1,'2008-07-25 21:28:02',3310490863,3),(51110502,424849275,14919320,592895,1,'2008-07-25 22:02:15',3310490874,7),(51111214,424677313,14916363,508959,1,'2007-09-24 18:39:54',3310490811,1),(51111216,424681373,14917652,508959,1,'2007-09-24 18:39:54',3310490811,1),(51111218,424685366,14919282,508959,1,'2007-09-24 18:39:54',3310490814,1),(51111220,424689157,14920253,434787,1,'2007-09-15 15:24:53',3310490814,1),(51111222,424693209,14921408,508959,1,'2007-09-24 18:39:54',3310490814,1),(51111223,424697434,14923825,434787,1,'2007-09-15 15:24:53',3310490814,1),(51111226,424700374,14926036,508959,1,'2007-09-24 18:39:54',3310490814,1),(51111228,424702667,14927482,508959,1,'2007-09-24 18:39:54',3310490814,1),(51111229,424704976,14928559,508959,1,'2007-09-24 18:39:54',3310490814,1),(51111231,424707140,14928726,434787,1,'2007-09-15 15:24:52',3310490814,1),(51111232,424710217,14926263,508959,1,'2007-09-24 18:39:54',3310490814,1),(51111234,424712653,14924229,508959,1,'2007-09-24 18:39:54',3310490815,1),(51111236,424715202,14923357,508959,1,'2007-09-24 18:39:54',3310490815,1),(51111238,424717599,14924075,508959,1,'2007-09-24 18:39:54',3310490815,1),(51111239,424721813,14926893,508959,1,'2007-09-24 18:39:54',3310490815,1),(51111241,424725420,14929417,508959,1,'2007-09-24 18:39:54',3310490815,1),(51111244,424730160,14929298,508959,1,'2007-09-24 18:39:54',3310490815,1),(51111245,424732120,14924517,508959,1,'2007-09-24 18:39:54',3310490815,1),(51111247,424734485,14916877,508959,1,'2007-09-24 18:39:54',3310490815,1),(51111248,424736992,14910081,434787,1,'2007-09-15 15:24:50',3310490815,1),(51111250,424740856,14906846,508959,1,'2007-09-24 18:39:54',3310490858,1),(51111251,424743955,14904108,508959,1,'2007-09-24 18:39:54',3310490858,1),(51111253,424747340,14904050,434787,1,'2007-09-15 15:24:51',3310490858,1),(51111254,424750434,14904726,508959,1,'2007-09-24 18:39:54',3310490858,1),(51111256,424753143,14905178,508959,1,'2007-09-24 18:39:54',3310490858,1),(51111257,424756886,14903817,508959,1,'2007-09-24 18:39:54',3310490858,1),(51111259,424760469,14903137,434787,1,'2007-09-15 15:24:49',3310490858,1),(51111260,424763119,14903020,508959,1,'2007-09-24 18:39:54',3310490858,1),(51111262,424767085,14903025,434787,1,'2007-09-15 15:24:50',3310490859,1),(51111263,424772493,14902004,508959,1,'2007-09-24 18:39:54',3310490859,1),(51111265,424777773,14899603,508959,1,'2007-09-24 18:39:54',3310490859,1),(51111266,424784717,14892353,434787,1,'2007-09-15 15:24:47',3310490859,1),(51111268,424790334,14886523,508959,1,'2007-09-24 18:39:54',3310490857,1),(51111270,424793845,14884688,434787,1,'2007-09-15 15:24:48',3310490860,1),(51111271,424799476,14884529,508959,1,'2007-09-24 18:39:54',3310490860,1),(51111273,424804414,14885945,508959,1,'2007-09-24 18:39:54',3310490860,1),(51118071,425403068,17242365,206510,1,'2008-12-06 20:13:39',3310504578,2),(51118073,425405092,17245369,206510,1,'2008-12-06 20:13:39',3310504578,2),(51118074,425407052,17247172,206510,1,'2008-12-06 20:13:39',3310504578,2),(51118076,425408633,17248116,206510,1,'2008-12-06 20:13:39',3310504578,2),(51118077,425410910,17248631,426786,1,'2007-09-14 10:14:01',3310504578,1),(51118078,425413313,17248030,426786,1,'2007-09-14 10:14:01',3310504578,1),(51118080,425414451,17247258,426786,1,'2007-09-14 10:14:01',3310504578,1),(51118081,425415716,17246743,426786,1,'2007-09-14 10:14:01',3310504578,1),(51118082,425416285,17246914,426786,1,'2007-09-14 10:14:01',3310504578,1),(51118083,425416791,17247429,426786,1,'2007-09-14 10:14:01',3310504578,1),(51118085,425416791,17248631,426786,1,'2007-09-14 10:14:01',3310504578,1),(51118086,425416538,17249833,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118087,425415842,17250605,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118088,425414704,17250948,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118090,425412933,17251034,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118091,425410783,17251721,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118092,425408886,17253266,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118094,425406799,17254639,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118095,425404712,17255326,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118096,425402689,17254811,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118097,425401044,17253609,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118099,425398009,17250176,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118100,425396112,17247258,426786,1,'2007-09-14 10:14:01',3310493655,1),(51118102,425395606,17245284,426786,1,'2007-09-14 10:14:01',3310493655,1),(51118103,425394467,17243996,426786,1,'2007-09-14 10:14:01',3310493655,1),(51118104,425393392,17243739,426786,1,'2007-09-14 10:14:01',3310493655,1),(51118105,425392570,17244597,426786,1,'2007-09-14 10:14:01',3310493655,1),(51118106,425392507,17246228,426786,1,'2007-09-14 10:14:01',3310493655,1),(51118107,425393456,17248373,426786,1,'2007-09-14 10:14:01',3310493655,1),(51118108,425394784,17250863,426786,1,'2007-09-14 10:14:01',3310493661,1),(51118110,425397313,17254982,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118111,425399527,17258416,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118113,425402183,17260476,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118114,425404523,17261248,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118115,425407305,17262106,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118117,425409582,17262965,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118118,425412111,17264252,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118119,425413756,17265969,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118121,425415842,17268200,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118122,425417297,17270174,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118123,425419321,17271805,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118124,425422609,17273264,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118125,425426719,17275153,426786,1,'2007-09-14 10:14:01',3310504585,1),(51118127,425429439,17276698,426786,1,'2007-09-14 10:14:01',3310504585,1),(51118128,425431399,17276869,426786,1,'2007-09-14 10:14:01',3310504585,1),(51118129,425432790,17276354,206510,1,'2008-12-06 20:11:10',3310504585,2),(51118130,425433865,17275496,206510,1,'2008-12-06 20:11:10',3310504585,2),(51118131,425434877,17275582,206510,1,'2008-12-06 20:11:11',3310504585,2),(51118132,425435446,17276869,206510,1,'2008-12-06 20:11:11',3310504585,2),(51118133,425435446,17278157,206510,1,'2008-12-06 20:11:11',3310504585,2),(51118134,425434814,17278929,206510,1,'2008-12-06 20:11:11',3310504585,2),(51118135,425433612,17279444,206510,1,'2008-12-06 20:11:32',3310504585,4),(51118136,425431905,17279444,206510,1,'2008-12-06 20:11:32',3310504585,3),(51118137,425428490,17279444,206510,1,'2008-12-06 20:11:33',3310504585,3),(51118138,425424506,17279015,206510,1,'2008-12-06 20:11:33',3310504584,3),(51118140,425420269,17278157,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118141,425417423,17277384,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118142,425414262,17275925,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118143,425410151,17274552,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118144,425407368,17273865,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118145,425405471,17273865,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118146,425402878,17274294,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118148,425400918,17275668,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118149,425398894,17277213,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118150,425396618,17278500,426786,1,'2007-09-14 10:14:01',3310493661,1),(51118151,425393582,17278157,426786,1,'2007-09-14 10:14:01',3310493661,1),(51118152,425389788,17276183,426786,1,'2007-09-14 10:14:01',3310493661,1),(51118153,425384981,17273522,426786,1,'2007-09-14 10:14:01',3310493661,1),(51118155,425380491,17271204,426786,1,'2007-09-14 10:14:01',3310493661,1),(51118156,425377708,17268629,426786,1,'2007-09-14 10:14:01',3310493661,1),(51118157,425376127,17266741,206510,1,'2008-12-06 20:10:04',3310493661,2),(51118159,425374862,17266655,206510,1,'2008-12-06 20:10:04',3310493661,2),(51118160,425374103,17267514,206510,1,'2008-12-06 20:10:04',3310493661,2),(51118161,425373850,17269316,206510,1,'2008-12-06 20:10:04',3310493661,2),(51118162,425374483,17270689,206510,1,'2008-12-06 20:10:04',3310493661,2),(51118164,425375684,17271719,206510,1,'2008-12-06 20:10:15',3310493661,4),(51118165,425376886,17273436,206510,1,'2008-12-06 20:10:15',3310493661,3),(51118166,425378024,17276783,206510,1,'2008-12-06 20:10:15',3310493661,3),(51118168,425378973,17279272,206510,1,'2008-12-06 20:10:15',3310493661,3),(51118169,425380807,17282448,206510,1,'2008-12-06 20:10:24',3310493661,4),(51118170,425383590,17285452,206510,1,'2008-12-06 20:10:24',3310493661,2),(51118171,425388143,17290173,206510,1,'2008-12-06 20:10:24',3310493661,2),(51118173,425391242,17292405,206510,1,'2008-12-06 20:10:24',3310493661,2),(51118174,425393961,17293263,206510,1,'2008-12-06 20:10:24',3310493661,2),(51118176,425397629,17293349,206510,1,'2008-12-06 20:10:24',3310504584,2),(51118177,425400728,17293950,206510,1,'2008-12-06 20:10:24',3310504584,2),(51118178,425404270,17295151,206510,1,'2008-12-06 20:10:24',3310504584,2),(51118179,425408760,17296954,206510,1,'2008-12-06 20:10:24',3310504584,2),(51118180,425411732,17297984,206510,1,'2008-12-06 20:10:24',3310504584,2),(51118181,425416918,17298842,206510,1,'2008-12-06 20:10:24',3310504584,2),(51118182,425420965,17299614,206510,1,'2008-12-06 20:10:24',3310504584,2),(51118183,425426467,17301503,206510,1,'2008-12-06 20:10:24',3310504585,2),(51118184,425435257,17304249,206510,1,'2008-12-06 20:10:24',3310504587,2),(51118185,425438608,17305365,206510,1,'2008-12-06 20:10:24',3310504587,2),(51118186,425443351,17305708,206510,1,'2008-12-06 20:10:24',3310504587,2),(51118187,425448030,17305708,206510,1,'2008-12-06 20:10:24',3310504587,2),(51118188,425452899,17306223,206510,1,'2008-12-06 20:10:24',3310504590,2),(51118189,425458338,17307682,206510,1,'2008-12-06 20:10:24',3310504590,2),(51118190,425462574,17308970,206510,1,'2008-12-06 20:10:24',3310504590,2),(51118191,425468012,17310000,206510,1,'2008-12-06 20:09:53',3310504590,4),(51118192,425471048,17312060,206510,1,'2008-12-06 20:09:53',3310504590,4),(51118193,425473703,17315236,206510,1,'2008-12-06 20:09:53',3310504590,4),(51118194,425479711,17320557,206510,1,'2008-12-06 20:09:53',3310504591,4),(51118205,425475600,17321930,206510,1,'2008-12-06 20:09:05',3310504590,3),(51118206,425471237,17319956,206510,1,'2008-12-06 20:09:05',3310504590,3),(51118207,425468771,17318583,206510,1,'2008-12-06 20:09:05',3310504590,3),(51118208,425465610,17317124,206510,1,'2008-12-06 20:09:05',3310504590,3),(51118209,425462258,17317381,206510,1,'2008-12-06 20:09:05',3310504590,3),(51118210,425457199,17318755,206510,1,'2008-12-06 20:09:05',3310504590,3),(51118211,425453532,17319699,206510,1,'2008-12-06 20:09:06',3310504590,3),(51118263,425394594,17232066,206510,1,'2008-12-06 20:13:38',3310493655,2),(51118641,425405408,17190352,206510,1,'2008-12-06 20:14:08',3310504576,4),(51118642,425402815,17192755,206510,1,'2008-12-06 20:14:08',3310504576,4),(51118653,425397575,17209422,206510,1,'2008-12-06 20:14:04',3310504578,5),(51118654,425395542,17205458,206510,1,'2008-12-06 20:14:04',3310493655,5),(51118655,425391558,17199965,206510,1,'2008-12-06 20:13:34',3310493655,2),(51118656,425387068,17193785,206510,1,'2008-12-06 20:13:35',3310493653,2),(51118658,425383843,17191725,206510,1,'2008-12-06 20:13:35',3310493653,2),(51118659,425380364,17191554,206510,1,'2008-12-06 20:13:35',3310493653,2),(51118661,425378214,17192927,206510,1,'2008-12-06 20:13:35',3310493653,2),(51118662,425376507,17194815,206510,1,'2008-12-06 20:13:36',3310493655,2),(51118663,425375368,17198248,206510,1,'2008-12-06 20:13:36',3310493655,2),(51118664,425375115,17202540,206510,1,'2008-12-06 20:13:37',3310493655,2),(51118666,425375874,17206488,206510,1,'2008-12-06 20:13:37',3310493655,2),(51118667,425377202,17210093,206510,1,'2008-12-06 20:13:37',3310493655,2),(51118668,425380301,17214728,206510,1,'2008-12-06 20:13:38',3310493655,2),(51118669,425384159,17219534,206510,1,'2008-12-06 20:13:38',3310493655,2),(51118671,425388649,17224856,206510,1,'2008-12-06 20:13:38',3310493655,2),(51119058,425419447,17109585,426786,1,'2007-09-14 10:13:57',3310504490,1),(51119060,425417993,17114220,426786,1,'2007-09-14 10:13:57',3310504490,1),(51119061,425415716,17116795,426786,1,'2007-09-14 10:13:57',3310504490,1),(51119062,425412681,17117653,206510,1,'2008-12-06 20:15:08',3310504490,6),(51119064,425410341,17116967,206510,1,'2008-12-06 20:15:08',3310504490,6),(51119065,425408380,17115336,206510,1,'2008-12-06 20:15:09',3310504490,6),(51119066,425406989,17114821,206510,1,'2008-12-06 20:15:09',3310504490,6),(51119067,425406357,17114907,206510,1,'2008-12-06 20:15:09',3310504490,6),(51119069,425405851,17115937,206510,1,'2008-12-06 20:15:09',3310504490,6),(51119070,425405724,17117138,206510,1,'2008-12-06 20:15:09',3310504490,6),(51119071,425405914,17118254,206510,1,'2008-12-06 20:15:09',3310504490,6),(51119072,425406989,17119284,206510,1,'2008-12-06 20:15:09',3310504490,6),(51119073,425409708,17120829,206510,1,'2008-12-06 20:15:09',3310504490,6),(51119075,425413439,17122803,206510,1,'2008-12-06 20:15:09',3310504490,6),(51119076,425417360,17125121,206510,1,'2008-12-06 20:15:10',3310504490,6),(51119077,425419637,17126494,206510,1,'2008-12-06 20:15:10',3310504490,6),(51119078,425421660,17126494,206510,1,'2008-12-06 20:15:10',3310504490,6),(51119079,425423241,17125292,206510,1,'2008-12-06 20:15:10',3310504490,6),(51119081,425424190,17123490,206510,1,'2008-12-06 20:15:10',3310504490,6),(51119082,425424633,17122116,206510,1,'2008-12-06 20:15:10',3310504491,6),(51119083,425424822,17119198,206510,1,'2008-12-06 20:15:11',3310504491,6),(51119085,425424316,17116795,206510,1,'2008-12-06 20:15:11',3310504490,6),(51119086,425424822,17115593,206510,1,'2008-12-06 20:15:11',3310504491,6),(51119088,425425455,17114993,206510,1,'2008-12-06 20:15:11',3310504491,6),(51119089,425426340,17114993,206510,1,'2008-12-06 20:15:11',3310504491,6),(51119090,425426783,17116194,206510,1,'2008-12-06 20:15:11',3310504491,6),(51119091,425426593,17117911,206510,1,'2008-12-06 20:15:12',3310504491,6),(51119093,425426467,17120400,206510,1,'2008-12-06 20:15:12',3310504491,6),(51119094,425426467,17123061,206510,1,'2008-12-06 20:15:12',3310504491,6),(51119096,425426467,17124434,206510,1,'2008-12-06 20:15:12',3310504491,6),(51119097,425426467,17127009,206510,1,'2008-12-06 20:15:12',3310504491,6),(51119098,425425265,17130442,206510,1,'2008-12-06 20:15:12',3310504491,6),(51119099,425423621,17133618,206510,1,'2008-12-06 20:15:12',3310504490,6),(51119101,425421660,17136364,206510,1,'2008-12-06 20:15:12',3310504490,6),(51119102,425418499,17139368,206510,1,'2008-12-06 20:15:12',3310504576,6),(51119103,425415526,17140570,206510,1,'2008-12-06 20:15:13',3310504576,6),(51119104,425412807,17140484,206510,1,'2008-12-06 20:15:13',3310504576,6),(51119105,425407432,17138939,206510,1,'2008-12-06 20:15:13',3310504576,8),(51119106,425404459,17136708,206510,1,'2008-12-06 20:15:03',3310504490,7),(51119107,425403321,17135420,206510,1,'2008-12-06 20:15:03',3310504490,7),(51119108,425402056,17135163,206510,1,'2008-12-06 20:15:03',3310504490,7),(51119109,425401424,17135935,206510,1,'2008-12-06 20:15:04',3310504490,7),(51119110,425401234,17137223,206510,1,'2008-12-06 20:15:04',3310504490,7),(51119111,425401740,17138853,206510,1,'2008-12-06 20:15:04',3310504490,7),(51119112,425404396,17141686,206510,1,'2008-12-06 20:15:04',3310504576,8),(51119113,425405787,17144175,206510,1,'2008-12-06 20:14:56',3310504576,5),(51119114,425407368,17147866,206510,1,'2008-12-06 20:14:56',3310504576,5),(51119116,425408949,17151299,206510,1,'2008-12-06 20:14:56',3310504576,5),(51119117,425410973,17156449,206510,1,'2008-12-06 20:14:56',3310504576,5),(51119118,425412301,17159796,206510,1,'2008-12-06 20:14:56',3310504576,5),(51119119,425414198,17161770,206510,1,'2008-12-06 20:14:57',3310504576,5),(51119120,425416728,17162800,206510,1,'2008-12-06 20:14:57',3310504576,5),(51119121,425419763,17162371,206510,1,'2008-12-06 20:14:57',3310504576,6),(51119123,425422293,17161169,206510,1,'2008-12-06 20:14:16',3310504576,5),(51119124,425423178,17161770,206510,1,'2008-12-06 20:14:17',3310504576,5),(51119125,425423747,17162800,206510,1,'2008-12-06 20:14:17',3310504576,5),(51119126,425423558,17164431,206510,1,'2008-12-06 20:14:17',3310504576,5),(51119127,425421913,17167864,206510,1,'2008-12-06 20:14:17',3310504576,6),(51119128,425416222,17179709,206510,1,'2008-12-06 20:14:08',3310504576,4),(51119129,425414325,17183314,206510,1,'2008-12-06 20:14:08',3310504576,4),(51119130,425411732,17185975,206510,1,'2008-12-06 20:14:08',3310504576,4),(51119131,425408191,17188635,206510,1,'2008-12-06 20:14:08',3310504576,4),(51119407,425483947,17055169,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119409,425479900,17055169,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119410,425476169,17055169,426786,1,'2007-09-14 10:13:57',3310504492,1),(51119411,425473071,17056284,426786,1,'2007-09-14 10:13:57',3310504492,1),(51119413,425470162,17058430,426786,1,'2007-09-14 10:13:57',3310504492,1),(51119414,425466811,17060833,426786,1,'2007-09-14 10:13:57',3310504492,1),(51119416,425463902,17063580,426786,1,'2007-09-14 10:13:57',3310504492,1),(51119417,425461246,17067099,426786,1,'2007-09-14 10:13:57',3310504492,1),(51119419,425457832,17070961,426786,1,'2007-09-14 10:13:57',3310504492,1),(51119420,425452963,17074824,426786,1,'2007-09-14 10:13:57',3310504492,1),(51119421,425447967,17077999,426786,1,'2007-09-14 10:13:57',3310504489,1),(51119422,425443477,17079888,426786,1,'2007-09-14 10:13:57',3310504489,1),(51119424,425440315,17080918,426786,1,'2007-09-14 10:13:57',3310504489,1),(51119425,425435257,17083664,426786,1,'2007-09-14 10:13:57',3310504489,1),(51119426,425431715,17086497,426786,1,'2007-09-14 10:13:57',3310504491,1),(51119427,425428996,17089930,426786,1,'2007-09-14 10:13:57',3310504491,1),(51119428,425426846,17092934,426786,1,'2007-09-14 10:13:57',3310504491,1),(51119430,425424822,17096024,426786,1,'2007-09-14 10:13:57',3310504491,1),(51119431,425422546,17099715,426786,1,'2007-09-14 10:13:57',3310504490,1),(51119432,425421028,17102890,426786,1,'2007-09-14 10:13:57',3310504490,1),(51119433,425420016,17107010,426786,1,'2007-09-14 10:13:57',3310504490,1),(51119435,425419004,17112246,426786,1,'2007-09-14 10:13:57',3310504490,1),(51119541,425476233,17041436,426786,1,'2007-09-14 10:13:57',3310504492,1),(51119542,425480406,17042036,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119543,425484200,17043925,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119545,425486856,17044182,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119546,425489701,17043581,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119547,425492863,17041350,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119548,425495708,17038517,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119550,425497289,17036887,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119551,425498111,17036543,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119553,425498996,17037058,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119554,425498996,17038260,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119555,425498617,17039633,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119556,425496088,17042723,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119558,425493369,17045813,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119559,425490333,17049675,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119560,425487109,17053109,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119613,425465483,17042809,426786,1,'2007-09-14 10:13:55',3310504492,1),(51119614,425465926,17042723,426786,1,'2007-09-14 10:13:55',3310504492,1),(51119615,425467759,17042122,426786,1,'2007-09-14 10:13:55',3310504492,1),(51119616,425470795,17041350,426786,1,'2007-09-14 10:13:55',3310504492,1),(51119617,425473703,17041264,426786,1,'2007-09-14 10:13:55',3310504492,1),(51119951,425431652,17035342,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119952,425429945,17034569,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119953,425428996,17034912,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119954,425428300,17035857,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119956,425428490,17037144,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119957,425429502,17038346,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119958,425432790,17038947,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119959,425436648,17038775,426786,1,'2007-09-14 09:57:16',3310504489,1),(51119960,425439240,17038517,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119961,425441138,17037659,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119962,425442529,17037230,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119964,425443288,17037487,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119965,425443920,17038689,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119966,425443541,17039891,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119968,425442592,17041006,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119969,425440379,17041092,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119970,425437280,17041779,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119972,425434434,17043152,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119973,425428680,17046156,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119974,425426340,17047015,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119976,425424190,17047272,426786,1,'2007-09-14 10:13:55',3310504488,1),(51119977,425422356,17047015,426786,1,'2007-09-14 10:13:55',3310504488,1),(51119978,425421091,17047530,426786,1,'2007-09-14 10:13:55',3310504488,1),(51119979,425420522,17048645,426786,1,'2007-09-14 10:13:55',3310504488,1),(51119980,425420522,17050019,426786,1,'2007-09-14 10:13:55',3310504488,1),(51119981,425421471,17051220,426786,1,'2007-09-14 09:57:16',3310504488,1),(51119983,425422609,17051220,426786,1,'2007-09-14 09:57:16',3310504488,1),(51119984,425424063,17050362,426786,1,'2007-09-14 10:13:55',3310504488,1),(51119986,425425518,17050019,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119987,425427478,17049933,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119988,425430387,17050448,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119989,425435889,17050705,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119990,425438355,17050448,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119991,425442971,17049075,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119992,425448410,17047701,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119993,425453089,17046500,426786,1,'2007-09-14 10:13:55',3310504492,1),(51119994,425458464,17044783,426786,1,'2007-09-14 10:13:55',3310504492,1),(51120868,425564816,16896382,426786,1,'2007-09-14 10:13:53',3310504478,1),(51120869,425556470,16903677,426786,1,'2007-09-14 10:13:55',3310504475,1),(51120871,425547871,16911316,426786,1,'2007-09-14 10:13:55',3310504475,1),(51120872,425540095,16918698,426786,1,'2007-09-14 10:13:55',3310504475,1),(51120873,425533203,16927195,426786,1,'2007-09-14 10:13:55',3310504496,1),(51120874,425529093,16933117,426786,1,'2007-09-14 10:13:55',3310504496,1),(51120876,425522932,16942897,427965,1,'2007-09-14 18:53:33',3310504496,1),(51120877,425514713,16955514,427965,1,'2007-09-14 18:53:55',3310504496,1),(51120878,425507659,16965990,426786,1,'2007-09-14 10:13:55',3310504496,1),(51120879,425504244,16971312,426786,1,'2007-09-14 10:13:55',3310504485,1),(51120881,425501462,16976118,426786,1,'2007-09-14 10:13:55',3310504487,1),(51120882,425499059,16980410,426786,1,'2007-09-14 10:13:55',3310504487,1),(51120883,425497289,16984101,426786,1,'2007-09-14 10:13:55',3310504487,1),(51120884,425494444,16988306,426786,1,'2007-09-14 10:13:55',3310504487,1),(51120885,425490903,16992855,426786,1,'2007-09-14 10:13:55',3310504487,1),(51120887,425486160,16997490,426786,1,'2007-09-14 10:13:55',3310504487,1),(51120888,425482366,16999894,426786,1,'2007-09-14 10:13:55',3310504487,1),(51120889,425480216,17000924,426786,1,'2007-09-14 10:13:55',3310504487,1),(51120890,425476739,17002297,426786,1,'2007-09-14 10:13:55',3310504486,1),(51120891,425470731,17006245,427965,1,'2007-09-14 20:50:22',3310504486,1),(51120892,425465104,17010107,426786,1,'2007-09-14 10:13:55',3310504486,1),(51120893,425459602,17014485,426786,1,'2007-09-14 10:13:55',3310504486,1),(51120895,425454101,17019549,426786,1,'2007-09-14 10:13:55',3310504486,1),(51120896,425449232,17024870,426786,1,'2007-09-14 10:13:55',3310504483,1),(51120897,425443288,17030707,426786,1,'2007-09-14 10:13:55',3310504489,1),(51120898,425439430,17033797,426786,1,'2007-09-14 10:13:55',3310504489,1),(51120899,425435762,17034998,426786,1,'2007-09-14 10:13:55',3310504489,1),(51120900,425433739,17035427,426786,1,'2007-09-14 10:13:55',3310504489,1),(51120956,425577713,16883593,426786,1,'2007-09-14 10:13:53',3310504478,1),(51120957,425575311,16887112,426786,1,'2007-09-14 10:13:53',3310504478,1),(51120959,425571454,16891489,426786,1,'2007-09-14 10:13:53',3310504478,1),(51121326,425650035,16796647,426786,1,'2007-09-14 10:13:53',3310504515,1),(51121327,425647064,16796647,426786,1,'2007-09-14 10:13:53',3310504515,1),(51121329,425645484,16797333,426786,1,'2007-09-14 10:13:53',3310504515,1),(51121330,425643271,16798706,426786,1,'2007-09-14 10:13:53',3310504514,1),(51121331,425640300,16801196,426786,1,'2007-09-14 10:13:53',3310504514,1),(51121332,425620380,16821803,198831,1,'2008-04-20 16:24:55',3310504520,2),(51121334,425615329,16827803,426786,1,'2007-09-14 10:13:53',3310504477,1),(51121335,425612168,16831751,426786,1,'2007-09-14 10:13:53',3310504477,1),(51121337,425609576,16836300,426786,1,'2007-09-14 10:13:53',3310504477,1),(51121338,425605657,16843682,426786,1,'2007-09-14 10:13:53',3310504477,1),(51121339,425601990,16848917,426786,1,'2007-09-14 10:13:53',3310504477,1),(51121341,425595795,16857758,426786,1,'2007-09-14 10:13:53',3310504477,1),(51121342,425588967,16866856,426786,1,'2007-09-14 10:13:53',3310504478,1),(51121362,425658253,16794501,426786,1,'2007-09-14 10:00:01',3310504515,1),(51121363,425654208,16796217,426786,1,'2007-09-14 10:13:53',3310504515,1),(51121951,425832890,16630135,426786,1,'2007-09-14 10:13:53',3310504189,1),(51121953,425835797,16632452,426786,1,'2007-09-14 10:13:53',3310504189,1),(51121955,425837440,16634770,426786,1,'2007-09-14 10:13:53',3310504360,1),(51121956,425838136,16636744,426786,1,'2007-09-14 10:13:53',3310504360,1),(51121957,425838325,16638546,426786,1,'2007-09-14 10:13:53',3310504360,1),(51121958,425838136,16640606,426786,1,'2007-09-14 10:13:53',3310504360,1),(51121959,425836998,16643353,426786,1,'2007-09-14 10:13:53',3310504360,1),(51121960,425835292,16645155,426786,1,'2007-09-14 10:13:53',3310504191,1),(51121962,425832827,16646014,426786,1,'2007-09-14 10:13:53',3310504191,1),(51121964,425828782,16645584,426786,1,'2007-09-14 10:13:53',3310504191,1),(51121965,425823537,16644469,426786,1,'2007-09-14 10:13:53',3310504189,1),(51121967,425818481,16644297,426786,1,'2007-09-14 10:13:53',3310504189,1),(51121968,425814879,16644469,426786,1,'2007-09-14 10:13:53',3310504189,1),(51121970,425812667,16643954,426786,1,'2007-09-14 10:13:53',3310504189,1),(51121972,425808180,16642237,426786,1,'2007-09-14 10:13:53',3310504188,1),(51121973,425797689,16638031,426786,1,'2007-09-14 10:13:53',3310504188,1),(51121974,425793075,16637087,426786,1,'2007-09-14 10:13:53',3310504188,1),(51121976,425791242,16637001,426786,1,'2007-09-14 10:13:53',3310504188,1),(51121977,425789030,16636486,426786,1,'2007-09-14 10:13:53',3310504188,1),(51121979,425787766,16635628,426786,1,'2007-09-14 10:13:53',3310504188,1),(51121981,425786502,16633997,426786,1,'2007-09-14 10:13:53',3310504188,1),(51121982,425783096,16631673,495907,1,'2008-07-15 20:10:14',3310504188,2),(51121984,425780315,16630815,495907,1,'2008-07-15 20:10:14',3310504185,2),(51121985,425778103,16630987,495907,1,'2008-07-15 20:10:14',3310504185,2),(51121987,425776649,16631931,495907,1,'2008-07-15 20:10:14',3310504185,2),(51121988,425774816,16637510,495907,1,'2008-07-15 20:10:14',3310504185,2),(51121989,425774683,16642838,426786,1,'2007-09-14 10:13:53',3310504185,1),(51121991,425773110,16648925,495907,1,'2008-07-15 20:10:14',3310504187,2),(51121992,425772029,16653567,426786,1,'2007-09-14 10:13:53',3310504187,1),(51121993,425770891,16658974,426786,1,'2007-09-14 10:13:53',3310504187,1),(51121995,425769311,16664639,426786,1,'2007-09-14 10:13:53',3310504187,1),(51121997,425767921,16671248,426786,1,'2007-09-14 10:13:53',3310504187,1),(51121998,425767169,16677507,495907,1,'2008-07-15 20:17:56',3310504187,2),(51122000,425766979,16680254,495907,1,'2008-07-15 20:18:38',3310504187,3),(51122001,425765329,16685667,426786,1,'2007-09-14 10:13:53',3310504187,1),(51122003,425761790,16693221,426786,1,'2007-09-14 10:13:53',3310504187,1),(51122005,425759135,16700774,426786,1,'2007-09-14 10:13:53',3310504529,1),(51122006,425757176,16706953,426786,1,'2007-09-14 10:13:53',3310504529,1),(51122007,425754648,16715193,426786,1,'2007-09-14 10:13:53',3310504529,1),(51122009,425752632,16720251,495907,1,'2008-07-15 20:26:14',3310504528,2),(51122010,425750736,16724885,495907,1,'2008-07-15 20:26:14',3310504528,2),(51122012,425747576,16728834,495907,1,'2008-07-15 20:26:14',3310504528,2),(51122014,425744914,16731244,426786,1,'2007-09-14 10:13:53',3310504528,1),(51122015,425743777,16733818,426786,1,'2007-09-14 10:13:53',3310504528,1),(51122016,425742646,16737588,495907,1,'2008-07-15 20:26:14',3310504528,2),(51122018,425739359,16742996,495907,1,'2008-07-15 20:26:14',3310504528,2),(51122020,425734359,16746178,426786,1,'2007-09-14 10:13:53',3310504528,1),(51122022,425731205,16749090,495907,1,'2008-07-15 20:26:14',3310504528,2),(51122023,425727027,16753045,426786,1,'2007-09-14 10:13:53',3310504528,1),(51122025,425722476,16759224,426786,1,'2007-09-14 10:13:53',3310504519,1),(51122027,425719884,16763430,426786,1,'2007-09-14 10:13:53',3310504519,1),(51122028,425716408,16767464,426786,1,'2007-09-14 10:13:53',3310504519,1),(51122029,425712742,16770554,426786,1,'2007-09-14 10:13:53',3310504519,1),(51122030,425708444,16773386,426786,1,'2007-09-14 10:13:53',3310504519,1),(51122032,425705978,16775189,426786,1,'2007-09-14 10:13:53',3310504519,1),(51122033,425701491,16778965,426786,1,'2007-09-14 10:13:53',3310504519,1),(51122034,425697572,16781798,426786,1,'2007-09-14 10:13:53',3310504518,1),(51122036,425693589,16783257,426786,1,'2007-09-14 10:13:53',3310504518,1),(51122038,425685309,16785489,426786,1,'2007-09-14 10:13:53',3310504518,1),(51122039,425680568,16786089,426786,1,'2007-09-14 10:13:53',3310504518,1),(51122041,425675953,16786261,426786,1,'2007-09-14 10:13:53',3310504518,1),(51122042,425672350,16786433,426786,1,'2007-09-14 10:13:53',3310504518,1),(51122044,425670201,16787205,426786,1,'2007-09-14 10:13:53',3310504515,1),(51122045,425667040,16789179,426786,1,'2007-09-14 10:13:53',3310504515,1),(51122790,425796748,16433231,495907,1,'2008-07-15 19:51:34',3310504158,2),(51122791,425797127,16441128,495907,1,'2008-07-15 19:51:34',3310504158,2),(51122792,425798833,16452114,495907,1,'2008-07-15 19:52:43',3310504158,2),(51122793,425800350,16458637,495907,1,'2008-07-15 19:52:43',3310504158,2),(51122795,425801867,16463616,495907,1,'2008-07-15 19:52:43',3310504158,2),(51122796,425803889,16470825,495907,1,'2008-07-15 19:52:43',3310504158,2),(51122797,425804205,16474001,495907,1,'2008-07-15 19:52:43',3310504158,2),(51122798,425804016,16477949,495907,1,'2008-07-15 19:52:43',3310504158,2),(51122800,425801361,16483528,495907,1,'2008-07-15 19:52:43',3310504180,2),(51122801,425798264,16491339,495907,1,'2008-07-15 19:52:43',3310504180,2),(51122802,425796242,16495115,495907,1,'2008-07-15 19:52:43',3310504180,2),(51122803,425794409,16496660,495907,1,'2008-07-15 19:52:54',3310504180,2),(51122804,425791059,16498119,495907,1,'2008-07-15 19:53:29',3310504180,2),(51122805,425789045,16498969,443749,1,'2007-09-17 01:56:34',3310504180,1),(51122806,425787710,16500523,495907,1,'2008-07-15 19:53:29',3310504180,2),(51122807,425787204,16504900,495907,1,'2008-07-15 19:53:29',3310504180,2),(51122808,425786193,16510050,495907,1,'2008-07-15 19:53:29',3310504180,2),(51122809,425782963,16517697,426786,1,'2007-09-14 10:13:53',3310504180,1),(51122810,425781193,16522675,426786,1,'2007-09-14 10:13:53',3310504177,1),(51122811,425780814,16525851,426786,1,'2007-09-14 10:13:53',3310504177,1),(51122812,425780119,16530142,426786,1,'2007-09-14 10:13:53',3310504177,1),(51122814,425778602,16534691,426786,1,'2007-09-14 10:13:53',3310504179,1),(51122815,425776516,16543188,426786,1,'2007-09-14 10:13:53',3310504179,1),(51122816,425775631,16547738,426786,1,'2007-09-14 10:13:53',3310504179,1),(51122817,425776011,16554003,426786,1,'2007-09-14 10:13:53',3310504179,1),(51122819,425776516,16557951,426786,1,'2007-09-14 10:13:53',3310504179,1),(51122820,425777970,16562243,426786,1,'2007-09-14 10:13:53',3310504179,1),(51122821,425779803,16567049,426786,1,'2007-09-14 10:13:53',3310504179,1),(51122822,425782141,16570912,426786,1,'2007-09-14 10:13:53',3310504182,1),(51122823,425787829,16577950,426786,1,'2007-09-14 10:13:53',3310504182,1),(51122824,425794655,16589194,426786,1,'2007-09-14 10:13:53',3310504182,1),(51122825,425800722,16598034,426786,1,'2007-09-14 10:13:53',3310504188,1),(51122826,425805083,16604042,426786,1,'2007-09-14 10:13:53',3310504188,1),(51122827,425808306,16607819,426786,1,'2007-09-14 10:13:53',3310504188,1),(51122828,425815069,16615200,426786,1,'2007-09-14 10:13:53',3310504189,1),(51122829,425822842,16622496,426786,1,'2007-09-14 10:13:53',3310504189,1),(51122830,425827898,16626187,426786,1,'2007-09-14 10:13:53',3310504189,1),(51123230,425784676,16355040,495907,1,'2008-07-15 19:50:23',3310504150,2),(51123231,425785435,16358130,495907,1,'2008-07-15 19:50:23',3310504150,2),(51123232,425787836,16367142,495907,1,'2008-07-15 19:50:23',3310504150,2),(51123233,425789100,16371433,495907,1,'2008-07-15 19:50:23',3310504156,2),(51123235,425788595,16383707,495907,1,'2008-07-15 19:50:23',3310504156,2),(51123236,425788974,16392548,495907,1,'2008-07-15 19:50:23',3310504156,2),(51123237,425792324,16398384,495907,1,'2008-07-15 19:50:57',3310504156,2),(51123238,425799149,16408941,495907,1,'2008-07-15 19:50:57',3310504156,2),(51123262,425782654,16338217,495907,1,'2008-07-15 19:49:01',3310504150,2),(51123907,425757309,16225006,495907,1,'2008-07-15 19:48:35',3310504059,2),(51123908,425758953,16227924,495907,1,'2008-07-15 19:48:35',3310504059,2),(51123909,425760090,16232302,495907,1,'2008-07-15 19:48:35',3310504059,2),(51123910,425762555,16236937,495907,1,'2008-07-15 19:48:35',3310504059,2),(51123911,425764135,16242172,495907,1,'2008-07-15 19:48:35',3310504059,2),(51123912,425766853,16249897,495907,1,'2008-07-15 19:48:35',3310504059,2),(51123913,425769192,16253760,495907,1,'2008-07-15 19:48:35',3310504059,2),(51123914,425773237,16257107,495907,1,'2008-07-15 19:48:35',3310504059,2),(51123916,425777218,16260540,495907,1,'2008-07-15 19:48:35',3310504145,2),(51123917,425778735,16262943,495907,1,'2008-07-15 19:48:35',3310504145,2),(51123918,425779241,16266205,495907,1,'2008-07-15 19:48:35',3310504145,2),(51123919,425778293,16279680,495907,1,'2008-07-15 19:48:35',3310504145,2),(51123920,425777850,16283972,495907,1,'2008-07-15 19:48:35',3310504145,2),(51123921,425778230,16287233,495907,1,'2008-07-15 19:48:35',3310504145,2),(51123922,425782401,16296847,495907,1,'2008-07-15 19:48:35',3310504148,2),(51123924,425785940,16304743,495907,1,'2008-07-15 19:48:35',3310504148,2),(51123925,425786762,16307232,495907,1,'2008-07-15 19:48:35',3310504148,2),(51123926,425786762,16311609,495907,1,'2008-07-15 19:48:35',3310504148,2),(51124044,425742519,16192305,495907,1,'2008-07-15 19:46:04',3310504056,2),(51124045,425744036,16197540,495907,1,'2008-07-15 19:46:04',3310504056,2),(51124046,425747576,16211788,495907,1,'2008-07-15 19:46:04',3310504058,2),(51124047,425748903,16215136,495907,1,'2008-07-15 19:46:04',3310504058,2),(51124048,425752000,16219084,495907,1,'2008-07-15 19:46:04',3310504058,2),(51124483,425719948,16120301,426786,1,'2007-09-14 10:07:07',3310504039,1),(51124484,425720390,16123734,426786,1,'2007-09-14 10:13:42',3310504039,1),(51124485,425720643,16132574,426786,1,'2007-09-14 10:13:42',3310504039,1),(51124486,425730566,16170683,426786,1,'2007-09-14 10:13:43',3310504056,1),(51124487,425732083,16175833,426786,1,'2007-09-14 10:13:43',3310504056,1),(51124488,425734548,16180983,426786,1,'2007-09-14 10:13:43',3310504056,1),(51124489,425737273,16183807,495907,1,'2008-07-15 19:46:04',3310504056,2),(51124490,425741066,16189129,495907,1,'2008-07-15 19:46:04',3310504056,2),(51124700,425722448,16140895,427965,1,'2007-09-14 19:08:20',3310504039,1),(51124890,425714168,16086307,427965,1,'2007-09-14 19:10:11',3310504037,1),(51124891,425714954,16089058,426786,1,'2007-09-14 10:13:42',3310504037,1),(51124892,425714891,16099959,426786,1,'2007-09-14 10:13:42',3310504039,1),(51124893,425714701,16104508,426786,1,'2007-09-14 10:13:42',3310504039,1),(51124895,425714891,16108284,426786,1,'2007-09-14 10:13:42',3310504039,1),(51124975,425712461,16083560,427965,1,'2007-09-14 19:10:11',3310504037,1),(51125152,425686067,16041508,426786,1,'2007-09-14 10:13:32',3310504036,1),(51125154,425687367,16043821,427965,1,'2007-09-14 19:10:38',3310504036,1),(51125155,425689074,16045280,427965,1,'2007-09-14 19:10:38',3310504036,1),(51125157,425690275,16045795,427965,1,'2007-09-14 19:10:38',3310504036,1),(51125159,425706204,16056781,427965,1,'2007-09-14 19:10:15',3310504037,1),(51125330,425673582,16014218,4963967,1,'2010-06-11 20:09:43',3310504014,2),(51125332,425673300,16012680,4963967,1,'2010-06-11 20:09:44',3310504014,2),(51125333,425672568,16012572,4963967,1,'2010-06-11 20:09:44',3310504014,2),(51125335,425672111,16013104,4963967,1,'2010-06-11 20:09:44',3310504014,2),(51125337,425672022,16013842,4963967,1,'2010-06-11 20:09:44',3310504014,2),(51125340,425672157,16014294,4963967,1,'2010-06-11 20:09:44',3310504014,2),(51125342,425672441,16014646,4963967,1,'2010-06-11 20:09:44',3310504014,2),(51125344,425673377,16014542,4963967,1,'2010-06-11 20:09:43',3310504014,2),(51125414,425672344,16012736,4963967,1,'2010-06-11 20:09:44',3310504014,2),(51125478,425667491,16001936,4963967,1,'2010-06-11 20:09:47',3310504011,3),(51125724,425640237,15923319,426786,1,'2007-09-14 10:13:29',3310504002,1),(51125727,425643461,15930357,426786,1,'2007-09-14 10:13:29',3310504002,1),(51125728,425644662,15932074,426786,1,'2007-09-14 10:13:29',3310504009,1),(51125730,425646369,15932675,426786,1,'2007-09-14 10:13:29',3310504009,1),(51125731,425648680,15933013,427965,1,'2007-09-14 19:12:39',3310504009,1),(51125733,425662145,15945630,427965,1,'2007-09-14 19:12:11',3310504009,1),(51125734,425662714,15949922,427965,1,'2007-09-14 19:12:11',3310504009,1),(51125737,425660023,15962286,426786,1,'2007-09-14 10:13:29',3310504009,1),(51125738,425657116,15971814,426786,1,'2007-09-14 10:13:29',3310504009,1),(51125784,425640237,15914994,426786,1,'2007-09-14 10:13:29',3310504002,1),(51125788,425639858,15920830,426786,1,'2007-09-14 10:13:29',3310504002,1),(51125904,425634611,15908900,426786,1,'2007-09-14 10:13:29',3310504002,1),(51125905,425637139,15909501,426786,1,'2007-09-14 10:13:29',3310504002,1),(51126211,425538008,15886498,426786,1,'2007-09-14 10:13:24',3310503955,1),(51126212,425542308,15885640,426786,1,'2007-09-14 10:13:24',3310503955,1),(51126213,425558654,15885844,427965,1,'2007-09-14 19:46:49',3310503955,1),(51126214,425561499,15886703,427965,1,'2007-09-14 19:46:49',3310503955,1),(51126215,425565511,15886326,426786,1,'2007-09-14 10:13:24',3310503958,1),(51126216,425570632,15885897,426786,1,'2007-09-14 10:13:24',3310503958,1),(51126217,425581886,15888987,426786,1,'2007-09-14 10:13:24',3310503958,1),(51126218,425610180,15902238,427965,1,'2007-09-14 19:46:49',3310503959,1),(51126219,425614697,15902377,426786,1,'2007-09-14 10:13:24',3310503959,1),(51126221,425624117,15903836,426786,1,'2007-09-14 10:13:24',3310504002,1),(51126223,425627151,15904265,426786,1,'2007-09-14 10:13:24',3310504002,1),(51126225,425631007,15906926,426786,1,'2007-09-14 10:13:24',3310504002,1),(51126226,425632967,15908213,426786,1,'2007-09-14 10:13:24',3310504002,1),(51342421,425512942,16950536,427965,1,'2007-09-14 18:53:33',3310504496,1),(51342422,425504912,16959033,427965,1,'2007-09-14 18:58:59',3310504485,1),(51342559,425516167,16953283,427965,1,'2007-09-14 18:53:55',3310504496,1),(51342838,425522057,16951184,4963942,1,'2010-06-11 20:05:26',3310504496,2),(51342839,425521906,16948762,4963942,1,'2010-06-11 20:05:26',3310504496,2),(51342840,425520694,16946985,4963942,1,'2010-06-11 20:05:26',3310504496,2),(51342841,425519615,16946553,4963942,1,'2010-06-11 20:05:26',3310504496,2),(51342842,425518210,16946903,4963942,1,'2010-06-11 20:05:26',3310504496,2),(51342843,425516971,16948509,4963942,1,'2010-06-11 20:05:27',3310504496,2),(51342844,425516703,16951028,4963942,1,'2010-06-11 20:05:27',3310504496,2),(51342845,425517700,16953208,4963942,1,'2010-06-11 20:05:27',3310504496,2),(51342846,425519270,16953996,4963942,1,'2010-06-11 20:05:27',3310504496,2),(51342847,425520545,16953656,4963942,1,'2010-06-11 20:05:27',3310504496,2),(51342848,425521420,16952788,4963942,1,'2010-06-11 20:05:27',3310504496,2),(51342855,425517120,16952366,4963942,1,'2010-06-11 20:05:27',3310504496,2),(51342907,425519897,16944699,427965,1,'2007-09-14 18:53:33',3310504496,1),(51342909,425517179,16946674,427965,1,'2007-09-14 18:53:33',3310504496,1),(51342910,425514586,16949163,427965,1,'2007-09-14 18:53:33',3310504496,1),(51343029,425510366,16955036,4963942,1,'2010-06-11 20:05:25',3310504496,2),(51343031,425516645,16950279,4963942,1,'2010-06-11 20:05:25',3310504496,2),(51343103,425497577,16963582,427965,1,'2007-09-14 18:58:59',3310504485,1),(51344677,425475762,16980233,5107412,1,'2010-06-29 20:12:26',3310504486,2),(51344678,425460270,16997400,427965,1,'2007-09-14 19:00:20',3310504486,1),(51344679,425451733,17014651,427965,1,'2007-09-14 19:00:20',3310504483,1),(51344681,425444461,17058854,427965,1,'2007-09-14 19:00:20',3310504489,1),(51344682,425440667,17115932,427965,1,'2007-09-14 19:00:20',3310504491,1),(51344683,425439719,17156701,427965,1,'2007-09-14 19:00:20',3310504577,1),(51344685,425437505,17221933,427965,1,'2007-09-14 19:00:20',3310504579,1),(51344687,425438770,17256265,427965,1,'2007-09-14 19:00:20',3310504585,1),(51344688,425443829,17281585,427965,1,'2007-09-14 19:00:20',3310504585,1),(51344690,425456160,17311197,427965,1,'2007-09-14 19:00:20',3310504590,1),(51345073,425484931,16973195,427965,1,'2007-09-14 18:58:59',3310504485,1),(51347750,425703738,16051459,427965,1,'2007-09-14 19:10:15',3310504037,1),(51347752,425707025,16059785,427965,1,'2007-09-14 19:10:15',3310504037,1),(51347925,425702032,16049657,427965,1,'2007-09-14 19:10:15',3310504037,1),(51347926,425704813,16053348,427965,1,'2007-09-14 19:10:15',3310504037,1),(51348096,425739675,16186726,495907,1,'2008-07-15 19:46:04',3310504056,2),(51348165,425715495,16093002,427965,1,'2007-09-14 19:08:20',3310504037,1),(51348167,425715306,16097636,427965,1,'2007-09-14 19:08:20',3310504039,1),(51348517,425682563,16031118,427965,1,'2007-09-14 19:10:38',3310504014,1),(51348571,425721437,16137376,427965,1,'2007-09-14 19:08:20',3310504039,1),(51349842,425679655,16025024,427965,1,'2007-09-14 19:10:49',3310504014,1),(51350384,425657214,15974212,427965,1,'2007-09-14 19:12:11',3310504009,1),(51350385,425657151,15972924,427965,1,'2007-09-14 19:12:11',3310504009,1),(51350585,425662588,15947776,427965,1,'2007-09-14 19:12:11',3310504009,1),(51350698,425650640,15932927,427965,1,'2007-09-14 19:12:39',3310504009,1),(51350699,425652220,15933013,427965,1,'2007-09-14 19:12:39',3310504009,1),(51350700,425654180,15933442,427965,1,'2007-09-14 19:12:39',3310504009,1),(51350702,425655255,15934816,427965,1,'2007-09-14 19:12:28',3310504009,1),(51356383,424673865,14916718,508959,1,'2007-09-24 18:39:54',3310490811,1),(51356432,424524124,14849968,508959,1,'2007-09-24 18:39:54',3310490792,1),(51356433,424544964,14856697,508959,1,'2007-09-24 18:39:54',3310490792,1),(51356434,424548481,14856540,508959,1,'2007-09-24 18:39:54',3310490793,1),(51356435,424554163,14857905,508959,1,'2007-09-24 18:39:54',3310490793,1),(51356437,424563243,14860483,508959,1,'2007-09-24 18:39:54',3310490793,1),(51356438,424569706,14862543,434787,1,'2007-09-15 15:28:04',3310490793,1),(51356439,424574414,14863644,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356440,424578231,14863922,434787,1,'2007-09-15 15:28:04',3310490796,1),(51356442,424581638,14865079,434787,1,'2007-09-15 15:28:05',3310490796,1),(51356444,424585586,14868300,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356445,424587163,14870744,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356446,424588461,14872583,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356448,424590557,14874947,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356450,424592691,14875430,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356451,424594856,14875918,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356452,424596617,14876982,434787,1,'2007-09-15 15:28:07',3310490796,1),(51356454,424598915,14879348,434787,1,'2007-09-15 15:28:07',3310490796,1),(51356455,424601853,14883173,508959,1,'2007-09-24 18:39:54',3310490797,1),(51356457,424605273,14888784,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356458,424607729,14892410,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356460,424609389,14893912,434787,1,'2007-09-15 15:28:08',3310490799,1),(51356461,424612485,14896909,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356462,424616981,14899987,434787,1,'2007-09-15 15:28:08',3310490799,1),(51356465,424621510,14900345,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356466,424625060,14899441,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356468,424634374,14896704,434787,1,'2007-09-15 15:10:21',3310490810,1),(51356469,424644835,14894490,508959,1,'2007-09-24 18:39:54',3310490810,1),(51356470,424648539,14894406,508959,1,'2007-09-24 18:39:54',3310490810,1),(51356471,424650615,14895452,508959,1,'2007-09-24 18:39:54',3310490810,1),(51356472,424653290,14897426,508959,1,'2007-09-24 18:39:54',3310490810,1),(51356473,424655245,14899686,508959,1,'2007-09-24 18:39:54',3310490810,1),(51356474,424657603,14899123,434787,1,'2007-09-15 15:10:22',3310490811,1),(51356475,424660066,14901118,434787,1,'2007-09-15 15:10:22',3310490811,1),(51356476,424662594,14903157,508959,1,'2007-09-24 18:39:54',3310490811,1),(51356477,424663789,14904882,508959,1,'2007-09-24 18:39:54',3310490811,1),(51356478,424664468,14908098,508959,1,'2007-09-24 18:39:54',3310490811,1),(51356479,424666182,14911657,508959,1,'2007-09-24 18:39:54',3310490811,1),(51356480,424667621,14914564,434787,1,'2007-09-15 15:10:12',3310490811,1),(51356481,424670475,14916739,434787,1,'2007-09-15 15:10:12',3310490811,1),(51356964,424522992,14851025,508959,1,'2007-09-24 18:39:54',3310490792,1),(51356965,424546433,14858880,508959,1,'2007-09-24 18:39:54',3310490793,1),(51356967,424550739,14859567,508959,1,'2007-09-24 18:39:54',3310490793,1),(51356968,424559288,14862742,508959,1,'2007-09-24 18:39:54',3310490793,1),(51356969,424568407,14864974,508959,1,'2007-09-24 18:39:54',3310490793,1),(51356970,424571573,14866347,508959,1,'2007-09-24 18:39:54',3310490793,1),(51356972,424575499,14866347,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356973,424577842,14866347,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356974,424579362,14866691,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356975,424581452,14867377,427965,1,'2007-09-14 19:33:57',3310490796,1),(51356977,424584618,14870296,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356978,424586264,14872012,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356979,424588670,14875531,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356981,424590887,14877076,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356982,424593103,14877334,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356983,424595129,14878364,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356985,424597536,14880767,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356986,424599499,14883342,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356987,424602665,14888492,427965,1,'2007-09-14 19:33:57',3310490799,1),(51356988,424605261,14892268,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356991,424607477,14895015,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356992,424609883,14897590,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356994,424612479,14899907,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356995,424615075,14901795,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356997,424617228,14902997,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356998,424620648,14903083,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356999,424624510,14901967,427965,1,'2007-09-14 19:33:57',3310490799,1),(51357000,424638630,14897933,508959,1,'2007-09-24 18:39:54',3310490810,1),(51357002,424644582,14896731,508959,1,'2007-09-24 18:39:54',3310490810,1),(51357003,424647368,14896302,508959,1,'2007-09-24 18:39:54',3310490810,1),(51357004,424649077,14896302,508959,1,'2007-09-24 18:39:54',3310490810,1),(51357006,424650534,14897246,427965,1,'2007-09-14 19:33:57',3310490810,1),(51357007,424653256,14900165,508959,1,'2007-09-24 18:39:54',3310490810,1),(51357008,424654459,14901452,508959,1,'2007-09-24 18:39:54',3310490810,1),(51357009,424658448,14903255,508959,1,'2007-09-24 18:39:54',3310490811,1),(51357010,424661867,14905229,508959,1,'2007-09-24 18:39:54',3310490811,1),(51357011,424663133,14907374,508959,1,'2007-09-24 18:39:54',3310490811,1),(51357012,424663640,14909434,508959,1,'2007-09-24 18:39:54',3310490811,1),(51357013,424662754,14910636,427965,1,'2007-09-14 19:33:57',3310490811,1),(51357015,424663830,14912181,427965,1,'2007-09-14 19:33:57',3310490811,1),(51357016,424665223,14914670,508959,1,'2007-09-24 18:39:54',3310490811,1),(51357018,424666362,14916902,427965,1,'2007-09-14 19:33:57',3310490811,1),(51357019,424669718,14918447,508959,1,'2007-09-24 18:39:54',3310490811,1),(51357255,424672757,14918876,427965,1,'2007-09-14 19:33:57',3310490811,1),(51357256,424675416,14918876,508959,1,'2007-09-24 18:39:54',3310490811,1),(51357259,424677632,14918447,508959,1,'2007-09-24 18:39:54',3310490811,1),(51357260,424680735,14919477,508959,1,'2007-09-24 18:39:54',3310490811,1),(51357261,424683457,14920764,508959,1,'2007-09-24 18:39:54',3310490814,1),(51357264,424687066,14921880,508959,1,'2007-09-24 18:39:54',3310490814,1),(51357265,424692954,14923940,508959,1,'2007-09-24 18:39:54',3310490814,1),(51357268,424696943,14925399,508959,1,'2007-09-24 18:39:54',3310490814,1),(51357269,424699665,14927115,508959,1,'2007-09-24 18:39:54',3310490814,1),(51357270,424700425,14928060,508959,1,'2007-09-24 18:39:54',3310490814,1),(51357272,424702831,14929519,427965,1,'2007-09-14 19:33:57',3310490814,1),(51357274,424705300,14930034,508959,1,'2007-09-24 18:39:54',3310490814,1),(51357275,424706946,14929776,508959,1,'2007-09-24 18:39:54',3310490814,1),(51357276,424708529,14929090,427965,1,'2007-09-14 19:33:57',3310490814,1),(51357277,424711251,14926772,508959,1,'2007-09-24 18:39:54',3310490815,1),(51357279,424713657,14925742,508959,1,'2007-09-24 18:39:54',3310490815,1),(51357281,424715430,14925914,427965,1,'2007-09-14 19:33:57',3310490815,1);
INSERT INTO `current_nodes` VALUES (51357282,424717772,14926858,508959,1,'2007-09-24 18:39:54',3310490815,1),(51357285,424721634,14929090,427965,1,'2007-09-14 19:33:57',3310490815,1),(51357287,424725369,14931836,508959,1,'2007-09-24 18:39:54',3310490815,1),(51357288,424727522,14932780,508959,1,'2007-09-24 18:39:54',3310490815,1),(51357291,424729674,14932523,508959,1,'2007-09-24 18:39:54',3310490815,1),(51357292,424731573,14930463,508959,1,'2007-09-24 18:39:54',3310490815,1),(51357293,424733852,14926000,427965,1,'2007-09-14 19:33:57',3310490815,1),(51357295,424735878,14919648,427965,1,'2007-09-14 19:33:57',3310490815,1),(51357297,424736575,14916816,427965,1,'2007-09-14 19:33:57',3310490815,1),(51357298,424737777,14912868,508959,1,'2007-09-24 18:39:54',3310490815,1),(51357300,424739170,14910378,427965,1,'2007-09-14 19:33:08',3310490858,1),(51357303,424742209,14907804,508959,1,'2007-09-24 18:39:54',3310490858,1),(51357305,424745817,14906173,508959,1,'2007-09-24 18:39:54',3310490858,1),(51357308,424748920,14906173,508959,1,'2007-09-24 18:39:54',3310490858,1),(51357309,424751578,14906859,427965,1,'2007-09-14 19:33:57',3310490858,1),(51357310,424753731,14906516,427965,1,'2007-09-14 19:33:57',3310490858,1),(51357312,424756516,14905229,508959,1,'2007-09-24 18:39:54',3310490858,1),(51357313,424759808,14904885,508959,1,'2007-09-24 18:39:54',3310490858,1),(51357315,424763480,14905143,508959,1,'2007-09-24 18:39:54',3310490858,1),(51357317,424766582,14905143,508959,1,'2007-09-24 18:39:54',3310490859,1),(51357319,424771646,14904370,427965,1,'2007-09-14 19:33:57',3310490859,1),(51357320,424775571,14902997,508959,1,'2007-09-24 18:39:54',3310490859,1),(51357323,424778926,14900508,508959,1,'2007-09-24 18:39:54',3310490859,1),(51357326,424784750,14894500,427965,1,'2007-09-14 19:33:57',3310490859,1),(51357328,424788358,14891410,508959,1,'2007-09-24 18:39:54',3310490859,1),(51357329,424792979,14888663,508959,1,'2007-09-24 18:39:54',3310490862,1),(51357330,424796714,14887633,508959,1,'2007-09-24 18:39:54',3310490862,1),(51357332,424800892,14887118,508959,1,'2007-09-24 18:39:54',3310490862,1),(51357335,424805006,14889007,508959,1,'2007-09-24 18:39:54',3310490862,1),(51357538,424807222,14890294,427965,1,'2007-09-14 19:33:57',3310490862,1),(51357539,424810260,14890466,508959,1,'2007-09-24 18:39:54',3310490862,1),(51357540,424814248,14889865,508959,1,'2007-09-24 18:39:54',3310490862,1),(51357542,424819059,14890208,508959,1,'2007-09-24 18:39:54',3310490862,1),(51357543,424823427,14892268,508959,1,'2007-09-24 18:39:54',3310490863,1),(51357544,424827225,14896045,508959,1,'2007-09-24 18:39:54',3310490863,1),(51357546,424833365,14902225,427965,1,'2007-09-14 19:33:57',3310490863,1),(51357547,424836086,14905314,508959,1,'2007-09-24 18:39:54',3310490863,1),(51357549,424838492,14910121,427965,1,'2007-09-14 19:33:57',3310490863,1),(51357550,424840264,14918962,508959,1,'2007-09-24 18:39:54',3310490863,1),(51357551,424843745,14925742,508959,1,'2007-09-24 18:39:54',3310490863,1),(51357552,424847733,14931235,508959,1,'2007-09-24 18:39:54',3310490863,1),(51357554,424852164,14938445,508959,1,'2007-09-24 18:39:54',3310490874,1),(51357556,424856911,14944539,508959,1,'2007-09-24 18:39:54',3310491216,1),(51357557,424861848,14949002,508959,1,'2007-09-24 18:39:54',3310491216,1),(51357558,424866912,14951491,508959,1,'2007-09-24 18:39:54',3310491216,1),(51357560,424870899,14951577,427965,1,'2007-09-14 19:33:57',3310491216,1),(51357561,424875456,14950633,508959,1,'2007-09-24 18:39:54',3310491217,1),(51357562,424879823,14949775,508959,1,'2007-09-24 18:39:54',3310491217,1),(51357564,424884444,14950461,427965,1,'2007-09-14 19:33:57',3310491217,1),(51357566,424887798,14952435,508959,1,'2007-09-24 18:39:54',3310491217,1),(51357567,424890796,14953824,592895,1,'2008-07-25 22:11:36',3310491217,2),(51357568,424894277,14956571,592895,1,'2008-07-25 22:11:36',3310491217,2),(51357570,424897735,14959044,508959,1,'2007-09-24 18:39:54',3310491217,1),(51357571,424899824,14958444,427965,1,'2007-09-14 19:33:57',3310491217,1),(51357573,424904191,14956813,508959,1,'2007-09-24 18:39:54',3310491220,1),(51357949,425040631,15202975,508959,1,'2007-09-24 18:39:54',3310491429,1),(51357951,425037783,15195079,427965,1,'2007-09-14 19:42:25',3310491428,1),(51357953,425037530,15191216,508959,1,'2007-09-24 18:39:54',3310491428,1),(51357954,425037595,15187055,508959,1,'2007-09-24 18:39:54',3310491428,1),(51357955,425038226,15177140,508959,1,'2007-09-24 18:39:54',3310491428,1),(51357956,425038543,15172420,508959,1,'2007-09-24 18:39:54',3310491428,1),(51357958,425038290,15167184,427965,1,'2007-09-14 19:42:25',3310491428,1),(51357959,425036897,15162206,508959,1,'2007-09-24 18:39:54',3310491428,1),(51357960,425034366,15158343,508959,1,'2007-09-24 18:39:54',3310491406,1),(51357962,425029178,15151305,508959,1,'2007-09-24 18:39:54',3310491406,1),(51357963,425026330,15146327,508959,1,'2007-09-24 18:39:54',3310491406,1),(51357965,425024052,15139718,508959,1,'2007-09-24 18:39:54',3310491406,1),(51357966,425022090,15136285,508959,1,'2007-09-24 18:39:54',3310491406,1),(51357967,425019053,15133109,427965,1,'2007-09-14 19:42:25',3310491406,1),(51357969,425016585,15130963,508959,1,'2007-09-24 18:39:54',3310491406,1),(51357971,425014244,15130105,508959,1,'2007-09-24 18:39:54',3310491406,1),(51357972,425011396,15127788,508959,1,'2007-09-24 18:39:54',3310491403,1),(51357973,425008738,15125213,427965,1,'2007-09-14 19:42:25',3310491403,1),(51357975,425003992,15122552,427965,1,'2007-09-14 19:42:25',3310491403,1),(51357977,424991716,15113196,427965,1,'2007-09-14 19:42:25',3310491403,1),(51357978,424986843,15109420,508959,1,'2007-09-24 18:39:54',3310491403,1),(51357980,424981148,15103755,508959,1,'2007-09-24 18:39:54',3310491400,1),(51357981,424977559,15096896,508959,1,'2007-09-24 18:39:54',3310491400,1),(51357983,424974056,15089381,508959,1,'2007-09-24 18:39:54',3310491400,1),(51357984,424970640,15082383,508959,1,'2007-09-24 18:39:54',3310491400,1),(51357986,424965473,15069081,434787,1,'2007-09-15 15:11:10',3310491400,1),(51357988,424961783,15058780,427965,1,'2007-09-14 19:42:25',3310491400,1),(51357989,424958659,15050069,508959,1,'2007-09-24 18:39:54',3310491394,1),(51357991,424955028,15043304,508959,1,'2007-09-24 18:39:54',3310491223,1),(51357993,424952670,15038524,508959,1,'2007-09-24 18:39:54',3310491223,1),(51357994,424952227,15035090,427965,1,'2007-09-14 19:42:25',3310491223,1),(51357995,424949948,15029855,508959,1,'2007-09-24 18:39:54',3310491223,1),(51357997,424947500,15024621,434787,1,'2007-09-15 15:11:11',3310491223,1),(51358000,424945075,15019898,508959,1,'2007-09-24 18:39:54',3310491223,1),(51358001,424941468,15011315,508959,1,'2007-09-24 18:39:54',3310491223,1),(51358002,424935582,15000587,508959,1,'2007-09-24 18:39:54',3310491223,1),(51358003,424928937,14992175,427965,1,'2007-09-14 19:42:25',3310491220,1),(51358004,424927798,14989257,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358005,424926722,14982734,427965,1,'2007-09-14 19:42:25',3310491220,1),(51358007,424926089,14976726,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358008,424924823,14973979,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358009,424922925,14972262,427965,1,'2007-09-14 19:42:25',3310491220,1),(51358011,424920140,14970717,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358013,424918115,14969859,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358015,424915773,14967971,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358016,424913431,14965053,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358018,424911912,14962392,427965,1,'2007-09-14 19:42:25',3310491220,1),(51358019,424910520,14959645,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358021,424909444,14958186,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358023,424907672,14957070,427965,1,'2007-09-14 19:42:25',3310491220,1),(51358025,424905836,14956641,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358396,425095390,15316725,437032,1,'2008-05-13 20:45:03',3310491449,2),(51358398,425091060,15305629,427965,1,'2007-09-14 19:42:25',3310491448,1),(51358399,425087581,15296273,427965,1,'2007-09-14 19:42:25',3310491448,1),(51358401,425086315,15292239,427965,1,'2007-09-14 19:42:25',3310491448,1),(51358402,425083847,15287261,508959,1,'2007-09-24 18:39:54',3310491448,1),(51358404,425081696,15284858,427965,1,'2007-09-14 19:42:25',3310491448,1),(51358405,425077586,15281470,434787,1,'2007-09-15 15:11:02',3310491448,1),(51358407,425070560,15276875,508959,1,'2007-09-24 18:39:54',3310491448,1),(51358408,425067460,15274301,508959,1,'2007-09-24 18:39:54',3310491437,1),(51358409,425066381,15271609,508959,1,'2007-09-24 18:39:54',3310491437,1),(51358411,425065941,15266576,508959,1,'2007-09-24 18:39:54',3310491431,1),(51358412,425065435,15261769,508959,1,'2007-09-24 18:39:54',3310491431,1),(51358414,425064486,15257907,508959,1,'2007-09-24 18:39:54',3310491431,1),(51358415,425063410,15254989,508959,1,'2007-09-24 18:39:54',3310491431,1),(51358417,425061638,15251727,427965,1,'2007-09-14 19:42:25',3310491431,1),(51358418,425059360,15249066,508959,1,'2007-09-24 18:39:54',3310491431,1),(51358419,425055501,15245290,508959,1,'2007-09-24 18:39:54',3310491431,1),(51358421,425051008,15240483,427965,1,'2007-09-14 19:42:25',3310491431,1),(51358423,425048793,15235333,427965,1,'2007-09-14 19:42:25',3310491431,1),(51358424,425047908,15230699,508959,1,'2007-09-24 18:39:54',3310491431,1),(51358425,425047022,15224519,508959,1,'2007-09-24 18:39:54',3310491431,1),(51358427,425046073,15217738,508959,1,'2007-09-24 18:39:54',3310491431,1),(51358428,425044576,15212201,434787,1,'2007-09-15 15:11:01',3310491429,1),(51358430,425042361,15206750,508959,1,'2007-09-24 18:39:54',3310491429,1),(51358786,424807359,14888329,508959,1,'2007-09-24 18:39:54',3310490862,1),(51358788,424810508,14888600,508959,1,'2007-09-24 18:39:54',3310490862,1),(51358789,424815115,14888495,508959,1,'2007-09-24 18:39:54',3310490862,1),(51358791,424820097,14889010,508959,1,'2007-09-24 18:39:54',3310490862,1),(51358792,424823126,14889979,434787,1,'2007-09-15 15:24:45',3310490863,1),(51358793,424826326,14892939,508959,1,'2007-09-24 18:39:54',3310490863,1),(51358794,424831694,14898426,508959,1,'2007-09-24 18:39:54',3310490863,1),(51358795,424835326,14901681,508959,1,'2007-09-24 18:39:54',3310490863,1),(51358797,424836907,14903618,434787,1,'2007-09-15 15:24:46',3310490863,1),(51358798,424838997,14907748,508959,1,'2007-09-24 18:39:54',3310490863,1),(51358800,424840307,14912216,434787,1,'2007-09-15 15:24:44',3310490863,1),(51358802,424841001,14916503,508959,1,'2007-09-24 18:39:54',3310490863,1),(51358803,424846760,14926540,508959,1,'2007-09-24 18:39:54',3310490863,1),(51358805,424851922,14934265,508959,1,'2007-09-24 18:39:54',3310490874,1),(51358806,424855121,14939196,508959,1,'2007-09-24 18:39:54',3310490874,1),(51358807,424858573,14943404,434787,1,'2007-09-15 15:24:45',3310491216,1),(51358809,424863437,14947382,508959,1,'2007-09-24 18:39:54',3310491216,1),(51358810,424867813,14949008,508959,1,'2007-09-24 18:39:54',3310491216,1),(51358811,424869754,14949399,508959,1,'2007-09-24 18:39:54',3310491216,1),(51358812,424875416,14949103,592895,1,'2008-07-25 22:29:55',3310491217,2),(51358813,424882315,14947987,592895,1,'2008-07-25 22:29:55',3310491217,2),(51358814,424885086,14947941,508959,1,'2007-09-24 18:39:54',3310491217,1),(51358815,424888109,14949771,508959,1,'2007-09-24 18:39:54',3310491217,1),(51358816,424892315,14952022,592895,1,'2008-07-25 22:11:36',3310491217,2),(51358818,424895416,14954682,592895,1,'2008-07-25 22:11:36',3310491217,2),(51358819,424898391,14956934,434787,1,'2007-09-15 15:24:42',3310491217,1),(51358820,424901548,14956557,508959,1,'2007-09-24 18:39:54',3310491217,1),(51358821,424904263,14955461,434787,1,'2007-09-15 15:24:42',3310491220,1),(51358823,424906583,14955100,434787,1,'2007-09-15 15:24:43',3310491220,1),(51358824,424909431,14955789,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358825,424912723,14959810,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358827,424914584,14963628,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358829,424916278,14965868,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358832,424918892,14967734,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358837,424920598,14968740,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358838,424922170,14968484,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358839,424925585,14971653,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358840,424927075,14974234,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358841,424928335,14983737,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358842,424929808,14989502,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358843,424932360,14993695,434787,1,'2007-09-15 15:10:44',3310491221,1),(51358845,424935674,14997822,434787,1,'2007-09-15 15:10:44',3310491223,1),(51358847,424938099,15000654,508959,1,'2007-09-24 18:39:54',3310491223,1),(51358848,424940420,15004955,508959,1,'2007-09-24 18:39:54',3310491223,1),(51358849,424946769,15019369,434787,1,'2007-09-15 15:10:58',3310491223,1),(51358850,424953012,15032635,508959,1,'2007-09-24 18:39:54',3310491223,1),(51358851,424956723,15042711,508959,1,'2007-09-24 18:39:54',3310491223,1),(51358852,424960666,15048850,508959,1,'2007-09-24 18:39:54',3310491394,1),(51358853,424962230,15054326,508959,1,'2007-09-24 18:39:54',3310491400,1),(51358854,424966025,15064085,508959,1,'2007-09-24 18:39:54',3310491400,1),(51358856,424968725,15071603,508959,1,'2007-09-24 18:39:54',3310491400,1),(51358858,424973284,15083525,508959,1,'2007-09-24 18:39:54',3310491400,1),(51358859,424982739,15101487,434787,1,'2007-09-15 15:11:00',3310491400,1),(51358861,424985506,15105063,508959,1,'2007-09-24 18:39:54',3310491401,1),(51358862,424991858,15110266,508959,1,'2007-09-24 18:39:54',3310491403,1),(51358863,425000828,15117231,434787,1,'2007-09-15 15:10:59',3310491403,1),(51359239,425007692,15122468,508959,1,'2007-09-24 18:39:54',3310491403,1),(51359241,425014737,15127997,508959,1,'2007-09-24 18:39:54',3310491406,1),(51359242,425021234,15132846,508959,1,'2007-09-24 18:39:54',3310491406,1),(51359243,425024541,15135545,508959,1,'2007-09-24 18:39:54',3310491406,1),(51359245,425025197,15137161,434787,1,'2007-09-15 15:10:31',3310491406,1),(51359246,425027138,15143261,434787,1,'2007-09-15 15:10:31',3310491406,1),(51359247,425029522,15148736,508959,1,'2007-09-24 18:39:54',3310491406,1),(51359249,425032523,15153429,508959,1,'2007-09-24 18:39:54',3310491406,1),(51359251,425036736,15158791,508959,1,'2007-09-24 18:39:54',3310491406,1),(51359252,425039282,15165539,508959,1,'2007-09-24 18:39:54',3310491428,1),(51359253,425039685,15167906,508959,1,'2007-09-24 18:39:54',3310491428,1),(51359255,425039979,15174085,508959,1,'2007-09-24 18:39:54',3310491428,1),(51359256,425038654,15186787,508959,1,'2007-09-24 18:39:54',3310491428,1),(51359257,425042159,15203863,508959,1,'2007-09-24 18:39:54',3310491429,1),(51359259,425044641,15208435,508959,1,'2007-09-24 18:39:54',3310491429,1),(51359260,425046531,15213114,434787,1,'2007-09-15 15:10:28',3310491429,1),(51359261,425047604,15217315,508959,1,'2007-09-24 18:39:54',3310491431,1),(51359262,425048711,15223499,508959,1,'2007-09-24 18:39:54',3310491431,1),(51359264,425049470,15228651,508959,1,'2007-09-24 18:39:54',3310491431,1),(51359265,425050040,15232836,508959,1,'2007-09-24 18:39:54',3310491431,1),(51359266,425051115,15236386,434787,1,'2007-09-15 15:10:36',3310491431,1),(51359268,425052602,15239381,508959,1,'2007-09-24 18:39:54',3310491431,1),(51359269,425054907,15242401,508959,1,'2007-09-24 18:39:54',3310491431,1),(51359271,425056518,15243874,508959,1,'2007-09-24 18:39:54',3310491431,1),(51359272,425059344,15246029,508959,1,'2007-09-24 18:39:54',3310491431,1),(51359274,425063167,15250552,434787,1,'2007-09-15 15:10:35',3310491431,1),(51359275,425066240,15257991,508959,1,'2007-09-24 18:39:54',3310491431,1),(51359276,425066931,15259768,434787,1,'2007-09-15 15:10:35',3310491431,1),(51359278,425067287,15262695,508959,1,'2007-09-24 18:39:54',3310491431,1),(51359279,425067089,15266922,508959,1,'2007-09-24 18:39:54',3310491431,1),(51359280,425068591,15272474,434787,1,'2007-09-15 15:10:33',3310491448,1),(51359281,425070286,15274125,508959,1,'2007-09-24 18:39:54',3310491448,1),(51359283,425077223,15279009,434787,1,'2007-09-15 15:10:33',3310491448,1),(51359284,425082862,15283938,437032,1,'2008-05-13 20:45:03',3310491448,2),(51359285,425086981,15289800,508959,1,'2007-09-24 18:39:54',3310491448,1),(51359287,425088557,15294409,437032,1,'2008-05-13 21:07:22',3310491448,2),(51359288,425090012,15299903,437032,1,'2008-05-13 21:07:22',3310491448,2),(51359290,425093113,15307799,437032,1,'2008-05-13 21:07:22',3310491448,2),(51359291,425095355,15314062,508959,1,'2007-09-24 18:39:54',3310491449,1),(51359292,425097492,15319727,508959,1,'2007-09-24 18:39:54',3310491449,1),(51359293,425098355,15322401,434787,1,'2007-09-15 15:10:32',3310491449,1),(51359295,425099693,15327197,437032,1,'2008-05-13 20:45:03',3310491451,2),(51359296,425101085,15331059,437032,1,'2008-05-13 20:42:53',3310491451,2),(51359297,425104248,15336295,437032,1,'2008-05-13 20:42:53',3310491451,2),(51359299,425107440,15343992,508959,1,'2007-09-24 18:39:54',3310491451,1),(51359302,425111423,15349450,508959,1,'2007-09-24 18:39:54',3310491451,1),(51359303,425114417,15353498,508959,1,'2007-09-24 18:39:54',3310491451,1),(51359304,425115319,15356325,508959,1,'2007-09-24 18:39:54',3310491451,1),(51359305,425115892,15359671,508959,1,'2007-09-24 18:39:54',3310491451,1),(51359307,425113756,15368265,508959,1,'2007-09-24 18:39:54',3310491451,1),(51359308,425107442,15383028,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359309,425105784,15387331,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359310,425104745,15390684,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359312,425104809,15399336,434787,1,'2007-09-15 15:10:40',3310491537,1),(51359313,425104758,15402274,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359314,425104822,15405731,434787,1,'2007-09-15 15:10:40',3310491537,1),(51359316,425104267,15407546,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359317,425103129,15410483,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359318,425097966,15414794,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359320,425094037,15418611,508959,1,'2007-09-24 18:39:54',3310491536,1),(51359322,425092583,15420925,508959,1,'2007-09-24 18:39:54',3310491536,1),(51359323,425091025,15424314,508959,1,'2007-09-24 18:39:54',3310491536,1),(51359324,425093554,15441457,508959,1,'2007-09-24 18:39:54',3310491538,1),(51359325,425095142,15448064,508959,1,'2007-09-24 18:39:54',3310491539,1),(51359327,425095691,15449511,434787,1,'2007-09-15 15:10:37',3310491539,1),(51359328,425097130,15451304,508959,1,'2007-09-24 18:39:54',3310491539,1),(51359330,425098139,15455925,508959,1,'2007-09-24 18:39:54',3310491539,1),(51359331,425098307,15457247,434787,1,'2007-09-15 15:10:43',3310491539,1),(51359357,425099696,15460021,508959,1,'2007-09-24 18:39:54',3310491539,1),(51359358,425102608,15460668,434787,1,'2007-09-15 15:10:43',3310491539,1),(51359756,425112338,15468030,188228,1,'2008-06-16 18:49:01',3310491539,2),(51359758,425109081,15461733,434787,1,'2007-09-15 15:10:07',3310491539,1),(51359760,425106246,15459942,508959,1,'2007-09-24 18:39:54',3310491539,1),(51359761,425103445,15461543,434787,1,'2007-09-15 15:10:09',3310491539,1),(51359762,425100281,15462216,508959,1,'2007-09-24 18:39:54',3310491539,1),(51359763,425098308,15460926,434787,1,'2007-09-15 15:10:08',3310491539,1),(51359764,425097180,15456850,508959,1,'2007-09-24 18:39:54',3310491539,1),(51359766,425095634,15451106,434787,1,'2007-09-15 15:10:07',3310491539,1),(51359769,425093055,15445630,508959,1,'2007-09-24 18:39:54',3310491538,1),(51359771,425090681,15432561,508959,1,'2007-09-24 18:39:54',3310491536,1),(51359772,425090436,15423686,434787,1,'2007-09-15 15:10:09',3310491536,1),(51359773,425090908,15420979,434787,1,'2007-09-15 15:10:09',3310491536,1),(51359774,425093121,15417933,434787,1,'2007-09-15 15:10:09',3310491536,1),(51359775,425098084,15413003,427965,1,'2007-09-14 19:42:25',3310491537,1),(51359776,425102133,15410085,427965,1,'2007-09-14 19:42:25',3310491537,1),(51359777,425103006,15407959,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359778,425103905,15404077,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359779,425103651,15392404,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359780,425104031,15388713,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359781,425106435,15382705,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359782,425112762,15366139,508959,1,'2007-09-24 18:39:54',3310491451,1),(51359783,425114344,15360818,508959,1,'2007-09-24 18:39:54',3310491451,1),(51359784,425114066,15357167,434787,1,'2007-09-15 15:10:11',3310491451,1),(51359785,425112889,15354724,508959,1,'2007-09-24 18:39:54',3310491451,1),(51359786,425108333,15347943,508959,1,'2007-09-24 18:39:54',3310491451,1),(51359787,425103173,15337668,437032,1,'2008-05-13 20:42:53',3310491451,2),(51359788,425099946,15333291,437032,1,'2008-05-13 20:42:53',3310491451,2),(51359789,425098491,15328742,437032,1,'2008-05-13 20:45:03',3310491451,2),(51359790,425097542,15324279,437032,1,'2008-05-13 20:45:03',3310491449,2),(51359793,425096846,15321017,437032,1,'2008-05-13 20:45:03',3310491449,2),(51359948,425107582,15458743,508959,1,'2007-09-24 18:39:54',3310491539,1),(51359949,425108740,15459659,508959,1,'2007-09-24 18:39:54',3310491539,1),(51359951,425110946,15462365,188228,1,'2008-06-16 18:49:01',3310491539,2),(51359952,425113097,15466314,188228,1,'2008-06-16 18:49:29',3310491539,3),(51359953,425116007,15479017,188228,1,'2008-06-16 18:50:28',3310491539,3),(51360246,425115248,15481420,188228,1,'2008-06-16 18:50:28',3310491539,2),(51360952,425680412,16028409,427965,1,'2007-09-14 19:43:57',3310504014,1),(51360953,425682056,16033559,427965,1,'2007-09-14 19:43:57',3310504014,1),(51360955,425683510,16037850,427965,1,'2007-09-14 19:43:57',3310504014,1),(51360957,425685090,16041713,427965,1,'2007-09-14 19:43:57',3310504036,1),(51360958,425686165,16044374,427965,1,'2007-09-14 19:43:57',3310504036,1),(51360960,425688251,16046348,427965,1,'2007-09-14 19:43:57',3310504036,1),(51360961,425691158,16047549,427965,1,'2007-09-14 19:43:57',3310504036,1),(51360963,425694635,16048493,427965,1,'2007-09-14 19:43:57',3310504036,1),(51360964,425698175,16049266,427965,1,'2007-09-14 19:43:57',3310504036,1),(51360965,425700703,16049953,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360967,425703168,16052527,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360968,425704432,16055017,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360969,425705949,16059566,427965,1,'2007-09-14 19:43:53',3310504037,1),(51360970,425706898,16064715,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360971,425708604,16072440,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360974,425709742,16078019,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360975,425710501,16080766,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360976,425711828,16083941,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360979,425712966,16085916,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360980,425713914,16088233,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360981,425714419,16090465,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360982,425714862,16093040,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360984,425714609,16097159,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360985,425713914,16102910,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360986,425713787,16106687,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360987,425714356,16110549,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360988,425715620,16113553,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360990,425717453,16116471,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360991,425718781,16119390,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360992,425719350,16121964,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360993,425719603,16126428,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360994,425719666,16132350,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360995,425720614,16137671,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360996,425722384,16144109,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360998,425725544,16154151,427965,1,'2007-09-14 19:43:57',3310504045,1),(51361715,425639639,15913053,427965,1,'2007-09-14 19:45:55',3310504002,1),(51361716,425640524,15916657,427965,1,'2007-09-14 19:45:55',3310504002,1),(51361728,425628513,15904813,427965,1,'2007-09-14 19:46:49',3310504002,1),(51361816,425601455,15898376,427965,1,'2007-09-14 19:46:49',3310503959,1),(51361817,425608093,15901380,427965,1,'2007-09-14 19:46:49',3310503959,1),(51362009,425522479,15895040,5671401,1,'2010-09-03 18:06:01',3310503954,2),(51362011,425526123,15890270,5671401,1,'2010-09-03 18:06:00',3310503954,2),(51362012,425532415,15887046,427965,1,'2007-09-14 19:48:40',3310503954,1),(51362129,425511649,15906919,5671401,1,'2010-09-03 18:06:00',3310503954,2),(51362133,425517816,15901493,5671401,1,'2010-09-03 18:06:02',3310503954,2),(51362135,425519968,15898966,5671401,1,'2010-09-03 18:06:01',3310503954,2),(51362153,425506521,15909868,5671401,1,'2010-09-03 18:06:01',3310503943,2),(51362471,425459510,15913911,427965,1,'2007-09-14 19:49:09',3310503942,1),(51362474,425466592,15916057,427965,1,'2007-09-14 19:49:09',3310503942,1),(51362475,425475508,15918031,427965,1,'2007-09-14 19:49:09',3310503942,1),(51362477,425479745,15918374,427965,1,'2007-09-14 19:49:09',3310503943,1),(51362529,425439654,15917859,427965,1,'2007-09-14 19:49:09',3310503939,1),(51362531,425455779,15913739,427965,1,'2007-09-14 19:49:09',3310503942,1),(51362569,425422643,15915370,427965,1,'2007-09-14 19:51:17',3310503938,1),(51362570,425426627,15914855,427965,1,'2007-09-14 19:49:09',3310503939,1),(51362572,425436239,15917087,427965,1,'2007-09-14 19:49:09',3310503939,1),(51362612,425425173,15915627,427965,1,'2007-09-14 19:49:34',3310503939,1),(51362613,425429599,15915971,427965,1,'2007-09-14 19:49:34',3310503939,1),(51362614,425432445,15916228,427965,1,'2007-09-14 19:49:34',3310503939,1),(51362854,425433836,15917087,427965,1,'2007-09-14 19:49:34',3310503939,1),(51362856,425435607,15917945,427965,1,'2007-09-14 19:49:34',3310503939,1),(51362857,425437947,15918803,427965,1,'2007-09-14 19:49:34',3310503939,1),(51362858,425440666,15919147,427965,1,'2007-09-14 19:49:34',3310503939,1),(51362860,425443638,15919061,427965,1,'2007-09-14 19:49:34',3310503939,1),(51362861,425447495,15917859,427965,1,'2007-09-14 19:49:34',3310503939,1),(51362863,425451859,15916057,427965,1,'2007-09-14 19:49:34',3310503939,1),(51362864,425454704,15915112,427965,1,'2007-09-14 19:49:34',3310503942,1),(51362865,425457739,15914769,427965,1,'2007-09-14 19:49:34',3310503942,1),(51362867,425461660,15915370,427965,1,'2007-09-14 19:49:34',3310503942,1),(51362868,425465391,15916743,427965,1,'2007-09-14 19:49:34',3310503942,1),(51362870,425468047,15917945,427965,1,'2007-09-14 19:49:34',3310503942,1),(51362871,425471461,15918632,427965,1,'2007-09-14 19:49:34',3310503942,1),(51362872,425474307,15919147,427965,1,'2007-09-14 19:49:34',3310503942,1),(51362929,425406454,15922408,427965,1,'2007-09-14 19:51:17',3310503938,1),(51362931,425408098,15922923,427965,1,'2007-09-14 19:51:17',3310503938,1),(51362932,425410565,15923266,427965,1,'2007-09-14 19:51:17',3310503938,1),(51363022,425390989,15917139,427965,1,'2007-09-14 20:33:03',3310493015,1),(51363024,425399814,15917773,427965,1,'2007-09-14 19:51:17',3310503938,1),(51363076,425382422,15915542,427965,1,'2007-09-14 19:51:17',3310493015,1),(51363078,425385585,15916657,427965,1,'2007-09-14 19:51:17',3310493015,1),(51363079,425387925,15917087,427965,1,'2007-09-14 19:51:17',3310493015,1),(51363105,425372810,15898204,427965,1,'2007-09-14 19:51:17',3310493015,1),(51363107,425378059,15910563,427965,1,'2007-09-14 19:51:17',3310493015,1),(51363109,425380272,15913568,427965,1,'2007-09-14 19:51:17',3310493015,1),(51363149,425368888,15891337,427965,1,'2007-09-14 19:51:17',3310493014,1),(51363244,425338910,15849795,427965,1,'2007-09-14 19:56:23',3310493009,1),(51363246,425336950,15849624,427965,1,'2007-09-14 19:56:23',3310493009,1),(51363247,425333634,15851997,232546,1,'2008-04-23 11:34:50',3310493009,2),(51363248,425334862,15853572,427965,1,'2007-09-14 19:56:23',3310493009,1),(51363250,425339922,15859666,427965,1,'2007-09-14 19:56:23',3310493009,1),(51363414,425355228,15854087,427965,1,'2007-09-14 19:56:23',3310493012,1),(51363415,425345045,15856061,427965,1,'2007-09-14 19:56:23',3310493012,1),(51363565,425372430,15839667,427965,1,'2007-09-14 19:56:23',3310493013,1),(51363567,425372557,15841727,427965,1,'2007-09-14 19:56:23',3310493013,1),(51363568,425371165,15845847,427965,1,'2007-09-14 19:56:23',3310493013,1),(51363795,425337456,15802588,427965,1,'2007-09-14 19:56:23',3310491643,1),(51363797,425345361,15809712,427965,1,'2007-09-14 19:56:23',3310491646,1),(51363800,425355164,15816493,427965,1,'2007-09-14 19:56:23',3310491646,1),(51363884,425316773,15733495,427965,1,'2007-09-14 19:56:23',3310491641,1),(51364400,425305895,15725083,427965,1,'2007-09-14 19:56:23',3310491640,1),(51364728,425308045,15717015,427965,1,'2007-09-14 19:54:01',3310491640,1),(51364730,425306211,15722508,427965,1,'2007-09-14 19:54:01',3310491640,1),(51364732,425297735,15717530,427965,1,'2007-09-14 19:54:01',3310491640,1),(51364733,425299823,15712295,427965,1,'2007-09-14 19:54:01',3310491640,1),(51364894,425301530,15707488,427965,1,'2007-09-14 19:54:18',3310491634,1),(51364896,425300139,15711522,427965,1,'2007-09-14 19:54:18',3310491640,1),(51364898,425302988,15713193,198831,1,'2008-04-20 16:27:39',3310491640,2),(51364899,425304377,15709462,427965,1,'2007-09-14 19:54:18',3310491634,1),(51364998,425289574,15692183,188228,1,'2008-06-16 19:39:37',3310491634,2),(51365000,425290903,15693470,188228,1,'2008-06-16 19:39:37',3310491634,2),(51365004,425291219,15705057,188228,1,'2008-06-16 19:39:37',3310491634,2),(51365354,425281162,15693127,188228,1,'2008-06-16 19:38:21',3310491623,2),(51365356,425283249,15693213,188228,1,'2008-06-16 19:38:21',3310491623,2),(51365357,425286665,15691668,188228,1,'2008-06-16 19:38:45',3310491623,2),(51366010,425243211,15625434,427965,1,'2007-09-14 19:56:23',3310491620,1),(51366011,425244729,15628181,427965,1,'2007-09-14 19:56:23',3310491620,1),(51366015,425246500,15633674,427965,1,'2007-09-14 19:56:23',3310491620,1),(51366017,425247259,15638738,427965,1,'2007-09-14 19:56:23',3310491620,1),(51366022,425254405,15653473,188228,1,'2008-06-16 19:34:03',3310491620,2),(51366025,425256366,15658709,188228,1,'2008-06-16 19:34:03',3310491622,2),(51366028,425259213,15663515,188228,1,'2008-06-16 19:34:19',3310491622,2),(51366033,425268827,15676476,188228,1,'2008-06-16 19:35:06',3310491623,2),(51366035,425272180,15682570,188228,1,'2008-06-16 19:35:06',3310491623,2),(51366036,425273508,15686689,188228,1,'2008-06-16 19:35:26',3310491623,2),(51366037,425274267,15688664,188228,1,'2008-06-16 19:35:26',3310491623,2),(51366039,425278062,15692354,188228,1,'2008-06-16 19:35:55',3310491623,2),(51366154,425231888,15616078,2895121,1,'2009-10-19 19:23:28',3310491617,2),(51366157,425236632,15620198,427965,1,'2007-09-14 19:56:22',3310491620,1),(51366554,425173159,15543236,232546,1,'2008-04-23 11:29:32',3310491549,2),(51366556,425176322,15547099,232546,1,'2008-04-23 11:29:32',3310491551,2),(51366560,425182988,15557799,427965,1,'2007-09-14 19:57:45',3310491594,1),(51366562,425188279,15563664,232546,1,'2008-04-23 11:29:32',3310491594,2),(51366564,425205698,15578914,427965,1,'2007-09-14 19:57:45',3310491595,1),(51366769,425148382,15527329,427965,1,'2007-09-14 19:57:45',3310491548,1),(51366772,425150533,15528274,427965,1,'2007-09-14 19:57:45',3310491549,1),(51366773,425155468,15532565,427965,1,'2007-09-14 19:57:45',3310491549,1),(51366775,425158694,15533767,427965,1,'2007-09-14 19:57:45',3310491549,1),(51366776,425161858,15534711,427965,1,'2007-09-14 19:57:45',3310491549,1),(51366854,425134314,15523152,232546,1,'2008-04-23 11:31:12',3310491548,3),(51366858,425138806,15525727,232546,1,'2008-04-23 11:28:56',3310491548,2),(51366991,425123220,15508113,188228,1,'2008-06-16 18:55:07',3310491548,3),(51366992,425125416,15510163,427965,1,'2007-09-14 19:57:45',3310491548,1),(51367555,425122882,15503762,188228,1,'2008-06-16 18:51:17',3310491548,4),(51367558,425122081,15502792,188228,1,'2008-06-16 18:52:21',3310491545,4),(51367559,425121195,15503307,188228,1,'2008-06-16 18:52:21',3310491545,4),(51367563,425121630,15505152,188228,1,'2008-06-16 18:51:17',3310491545,3),(51367565,425122358,15505136,188228,1,'2008-06-16 18:51:17',3310491545,3),(51367748,425083963,15448487,840745,1,'2009-01-26 19:29:53',3310491538,2),(51367752,425083204,15451319,840745,1,'2009-01-26 19:29:53',3310491538,2),(51367755,425081179,15457499,840745,1,'2009-01-26 19:29:53',3310491538,2),(51367756,425080293,15461790,840745,1,'2009-01-26 19:29:53',3310491538,2),(51367760,425080293,15465138,840745,1,'2009-01-26 19:29:53',3310491538,2),(51367761,425081306,15469343,840745,1,'2009-01-26 19:29:53',3310491538,2),(51367762,425082571,15471403,840745,1,'2009-01-26 19:29:53',3310491538,2),(51367763,425084849,15473978,840745,1,'2009-01-26 19:29:53',3310491538,2),(51367764,425088456,15475523,840745,1,'2009-01-26 19:29:53',3310491538,2),(51367767,425097503,15479471,840745,1,'2009-01-26 19:29:53',3310491539,2),(51367769,425102059,15481102,840745,1,'2009-01-26 19:29:53',3310491539,2),(51367770,425106994,15483076,840745,1,'2009-01-26 19:29:53',3310491539,2),(51367772,425109145,15484278,840745,1,'2009-01-26 19:29:53',3310491539,2),(51367774,425110790,15485995,840745,1,'2009-01-26 19:29:53',3310491539,2),(51367776,425112245,15489771,840745,1,'2009-01-26 19:29:54',3310491539,2),(51367779,425113827,15492775,840745,1,'2009-01-26 19:29:54',3310491545,2),(51367783,425115978,15495608,840745,1,'2009-01-26 19:29:54',3310491545,2),(51367785,425117433,15498783,840745,1,'2009-01-26 19:29:54',3310491545,2),(51367787,425118369,15500716,840745,1,'2009-01-26 19:29:54',3310491545,3),(51367788,425119015,15501959,840745,1,'2009-01-26 19:29:54',3310491545,2),(51367806,425121006,15504251,840745,1,'2009-01-26 19:29:54',3310491545,5),(51367819,425122844,15504425,188228,1,'2008-06-16 18:51:17',3310491548,3),(51367842,425122696,15505700,427965,1,'2007-09-14 19:59:43',3310491548,1),(51369095,425029810,15154996,427965,1,'2007-09-14 20:01:57',3310491406,1),(51369096,425031392,15157571,427965,1,'2007-09-14 20:01:47',3310491406,1),(51369098,425033987,15161605,427965,1,'2007-09-14 20:01:47',3310491428,1),(51369101,425036455,15165982,427965,1,'2007-09-14 20:01:57',3310491428,1),(51369102,425037024,15171647,427965,1,'2007-09-14 20:01:57',3310491428,1),(51369103,425037024,15174136,427965,1,'2007-09-14 20:01:57',3310491428,1),(51369105,425037024,15176454,427965,1,'2007-09-14 20:01:57',3310491428,1),(51369106,425036201,15182977,427965,1,'2007-09-14 20:01:57',3310491428,1),(51369109,425036690,15195113,3916355,1,'2010-02-19 17:31:54',3310491428,6),(51369110,425038479,15200057,840745,1,'2009-01-26 20:00:22',3310491428,4),(51369112,425043984,15212674,840745,1,'2009-01-26 20:00:22',3310491429,4),(51369114,425045250,15216537,840745,1,'2009-01-26 20:00:23',3310491431,4),(51369115,425046009,15222030,840745,1,'2009-01-26 20:00:23',3310491431,4),(51369118,425046516,15230012,840745,1,'2009-01-26 20:00:23',3310491431,4),(51369120,425047212,15236363,840745,1,'2009-01-26 20:00:23',3310491431,4),(51369123,425049173,15247521,840745,1,'2009-01-26 20:00:23',3310491431,4),(51369125,425050807,15256082,840745,1,'2009-01-26 20:00:24',3310491431,4),(51369126,425052072,15265180,840745,1,'2009-01-26 20:00:24',3310491431,4),(51369129,425052992,15273228,3916355,1,'2010-02-19 17:34:12',3310491437,8),(51369131,425052684,15275616,3916355,1,'2010-02-19 17:34:13',3310491437,6),(51369132,425053211,15283462,840745,1,'2009-01-26 19:28:30',3310491437,2),(51369133,425054034,15288011,840745,1,'2009-01-26 19:28:30',3310491437,2),(51369134,425055489,15294963,840745,1,'2009-01-26 19:28:30',3310491437,2),(51369136,425057313,15304087,840745,1,'2009-01-26 19:28:31',3310491437,2),(51369139,425058512,15310033,840745,1,'2009-01-26 19:28:31',3310491437,2),(51369142,425062956,15329982,840745,1,'2009-01-26 19:29:52',3310491439,2),(51369145,425064158,15335904,840745,1,'2009-01-26 19:29:52',3310491439,2),(51369146,425067129,15351941,840745,1,'2009-01-26 19:29:52',3310491439,2),(51369147,425068335,15359051,840745,1,'2009-01-26 19:29:52',3310491450,2),(51369148,425069284,15366347,840745,1,'2009-01-26 19:29:52',3310491450,2),(51369150,425070802,15375874,840745,1,'2009-01-26 19:29:52',3310491450,2),(51369153,425072258,15385573,840745,1,'2009-01-26 19:29:52',3310491536,2),(51369155,425073080,15389778,840745,1,'2009-01-26 19:29:52',3310491536,2),(51369157,425074472,15397074,840745,1,'2009-01-26 19:29:52',3310491536,2),(51369159,425075168,15401795,840745,1,'2009-01-26 19:29:52',3310491536,2),(51369160,425075485,15406430,840745,1,'2009-01-26 19:29:52',3310491536,2),(51369162,425076371,15412180,840745,1,'2009-01-26 19:29:52',3310491536,2),(51369164,425078522,15419905,840745,1,'2009-01-26 19:29:52',3310491536,2),(51369165,425079787,15427630,840745,1,'2009-01-26 19:29:52',3310491536,2),(51369168,425080736,15432265,840745,1,'2009-01-26 19:29:52',3310491536,2),(51369170,425082002,15435011,840745,1,'2009-01-26 19:29:52',3310491536,2),(51369171,425083900,15440676,840745,1,'2009-01-26 19:29:52',3310491538,2),(51369173,425084216,15444453,840745,1,'2009-01-26 19:29:53',3310491538,2),(51369221,425036961,15168986,427965,1,'2007-09-14 20:01:57',3310491428,1),(51369359,425009751,15132594,427965,1,'2007-09-14 20:04:19',3310491403,1),(51369361,425006978,15138172,434787,1,'2007-09-15 14:31:20',3310491403,1),(51369362,425015130,15144868,427965,1,'2007-09-14 20:04:19',3310491406,1),(51369364,425017891,15138553,434787,1,'2007-09-15 14:31:20',3310491406,1),(51370189,425008232,15131135,427965,1,'2007-09-14 20:08:28',3310491403,1),(51370191,425007410,15131478,427965,1,'2007-09-14 20:08:28',3310491403,1),(51370193,425006207,15132422,427965,1,'2007-09-14 20:08:28',3310491403,1),(51370194,425005574,15133452,427965,1,'2007-09-14 20:08:28',3310491403,1),(51370196,425005258,15134997,427965,1,'2007-09-14 20:08:28',3310491403,1),(51370197,425005448,15137143,427965,1,'2007-09-14 20:08:28',3310491403,1),(51370198,425005828,15138688,427965,1,'2007-09-14 20:08:28',3310491403,1),(51370199,425007156,15140061,427965,1,'2007-09-14 20:08:28',3310491403,1),(51370201,425015320,15146327,427965,1,'2007-09-14 20:08:28',3310491406,1),(51370202,425016838,15146499,427965,1,'2007-09-14 20:08:28',3310491406,1),(51370203,425018104,15145812,427965,1,'2007-09-14 20:08:28',3310491406,1),(51370206,425019116,15144696,427965,1,'2007-09-14 20:08:28',3310491406,1),(51370208,425019812,15143580,427965,1,'2007-09-14 20:08:28',3310491406,1),(51370210,425019876,15141006,427965,1,'2007-09-14 20:08:28',3310491406,1),(51370211,425019559,15139461,427965,1,'2007-09-14 20:08:28',3310491406,1),(51370213,425018800,15138001,427965,1,'2007-09-14 20:08:28',3310491406,1),(51370260,425009624,15131049,427965,1,'2007-09-14 20:08:28',3310491403,1),(51371237,425021584,15139203,427965,1,'2007-09-14 20:05:51',3310491406,1),(51371240,425023229,15142035,427965,1,'2007-09-14 20:05:14',3310491406,1),(51371243,425025191,15147014,427965,1,'2007-09-14 20:05:14',3310491406,1),(51371246,425027659,15151563,427965,1,'2007-09-14 20:05:14',3310491406,1),(51371386,424939190,15008054,427965,1,'2007-09-14 20:05:52',3310491223,1),(51371387,424939140,15009063,592895,1,'2008-07-25 23:27:47',3310491223,2),(51371388,424939823,15011058,427965,1,'2007-09-14 20:05:51',3310491223,1),(51371389,424941617,15014249,592895,1,'2008-07-25 22:38:46',3310491223,3),(51371391,424944085,15020514,592895,1,'2008-07-25 22:38:46',3310491223,3),(51371392,424948009,15029269,592895,1,'2008-07-25 22:38:46',3310491223,3),(51371395,424949971,15033732,592895,1,'2008-07-25 22:35:39',3310491223,2),(51371400,424950961,15042729,427965,1,'2007-09-14 20:05:51',3310491223,1),(51371401,424950771,15045819,427965,1,'2007-09-14 20:05:51',3310491223,1),(51371402,424950708,15048223,427965,1,'2007-09-14 20:05:51',3310491223,1),(51371403,424951024,15050712,427965,1,'2007-09-14 20:05:51',3310491223,1),(51371404,424952037,15053716,427965,1,'2007-09-14 20:05:51',3310491229,1),(51371406,424955138,15058780,427965,1,'2007-09-14 20:05:51',3310491229,1),(51371408,424960201,15067449,427965,1,'2007-09-14 20:05:51',3310491400,1),(51371409,424965263,15074830,427965,1,'2007-09-14 20:05:51',3310491400,1),(51371411,424967162,15077662,427965,1,'2007-09-14 20:05:51',3310491400,1),(51371413,424972794,15090709,427965,1,'2007-09-14 20:05:51',3310491400,1),(51371415,424977857,15100751,427965,1,'2007-09-14 20:05:51',3310491400,1),(51371418,424981781,15106330,427965,1,'2007-09-14 20:05:51',3310491400,1),(51371421,424985577,15109591,427965,1,'2007-09-14 20:05:51',3310491403,1),(51371422,424989881,15113626,427965,1,'2007-09-14 20:05:31',3310491403,1),(51371423,424995260,15117230,427965,1,'2007-09-14 20:05:51',3310491403,1),(51371425,425005321,15125041,427965,1,'2007-09-14 20:05:51',3310491403,1),(51371428,425008675,15127616,427965,1,'2007-09-14 20:05:51',3310491403,1),(51371430,425019180,15136542,427965,1,'2007-09-14 20:05:51',3310491406,1),(51384482,424942193,14992314,427965,1,'2007-09-14 20:30:03',3310491221,1),(51384485,424941307,14995575,427965,1,'2007-09-14 20:30:03',3310491221,1),(51384487,424940927,14999008,427965,1,'2007-09-14 20:30:03',3310491223,1),(51384488,424940801,15003042,427965,1,'2007-09-14 20:30:03',3310491223,1),(51384490,424941094,15005147,462689,1,'2008-05-17 12:22:13',3310491223,3),(51384518,424941054,15004587,427965,1,'2007-09-14 20:30:03',3310491223,1),(51385251,424849718,14920951,592895,1,'2008-07-25 21:23:37',3310490874,3),(51385256,424852826,14923392,427965,1,'2007-09-14 20:30:03',3310490874,1),(51385259,424855484,14925022,427965,1,'2007-09-14 20:30:03',3310490874,1),(51385261,424860421,14926825,427965,1,'2007-09-14 20:30:03',3310490874,1),(51385264,424865801,14928885,427965,1,'2007-09-14 20:30:03',3310490874,1),(51385266,424888903,14941759,427965,1,'2007-09-14 20:30:03',3310491217,1),(51385267,424893903,14944592,427965,1,'2007-09-14 20:30:03',3310491217,1),(51385271,424902131,14949141,427965,1,'2007-09-14 20:30:03',3310491217,1),(51385273,424915226,14958974,592895,1,'2008-07-25 22:09:57',3310491220,2),(51385276,424927504,14971763,592895,1,'2008-07-25 22:09:57',3310491220,2),(51385277,424932630,14978543,592895,1,'2008-07-25 22:16:08',3310491221,2),(51385279,424934719,14981204,592895,1,'2008-07-25 22:16:08',3310491221,2),(51385284,424936428,14982921,592895,1,'2008-07-25 22:16:08',3310491221,2),(51385285,424938263,14983436,592895,1,'2008-07-25 22:16:08',3310491221,2),(51385287,424940288,14983521,592895,1,'2008-07-25 22:16:08',3310491221,2),(51385289,424942187,14983092,592895,1,'2008-07-25 22:16:08',3310491221,2),(51385290,424946019,14981546,592895,1,'2008-07-25 22:14:49',3310491221,2),(51385291,424948902,14980726,592895,1,'2008-07-25 22:14:49',3310491221,2),(51385292,424950484,14980898,592895,1,'2008-07-25 22:14:49',3310491221,2),(51385295,424951616,14981376,592895,1,'2008-07-25 22:15:37',3310491221,3),(51385296,424952376,14982577,592895,1,'2008-07-25 22:15:37',3310491221,3),(51385297,424952692,14983951,592895,1,'2008-07-25 22:15:37',3310491221,3),(51385298,424952313,14985324,592895,1,'2008-07-25 22:15:37',3310491221,3),(51385299,424951363,14986096,592895,1,'2008-07-25 22:15:37',3310491221,3),(51385300,424950098,14986697,592895,1,'2008-07-25 22:15:37',3310491221,3),(51385302,424944402,14988757,592895,1,'2008-07-25 22:16:28',3310491221,2),(51385304,424942952,14990597,427965,1,'2007-09-14 20:30:03',3310491221,1),(51385320,424842122,14911509,592895,1,'2008-07-25 21:28:02',3310490863,3),(51385334,424835945,14906979,439281,1,'2007-09-16 00:57:34',3310490863,1),(51385336,424840103,14909487,427965,1,'2007-09-14 20:30:34',3310490863,1),(51385349,424829931,14903460,439281,1,'2007-09-16 00:57:48',3310490863,1),(51385966,424686038,14926891,439281,1,'2007-09-16 00:57:42',3310490814,1),(51385967,424691989,14927235,439281,1,'2007-09-16 00:57:41',3310490814,1),(51385970,424697877,14927750,439281,1,'2007-09-16 00:57:43',3310490814,1),(51385971,424701613,14930067,439281,1,'2007-09-16 00:57:43',3310490814,1),(51385973,424705664,14930925,439281,1,'2007-09-16 00:57:44',3310490814,1),(51385974,424710983,14931440,439281,1,'2007-09-16 00:57:43',3310490815,1),(51385975,424714655,14932728,439281,1,'2007-09-16 00:57:43',3310490815,1),(51385976,424721809,14934702,439281,1,'2007-09-16 00:57:42',3310490815,1),(51385978,424727823,14934445,439281,1,'2007-09-16 00:57:42',3310490815,1),(51385979,424730039,14934187,439281,1,'2007-09-16 00:57:42',3310490815,1),(51385982,424732001,14932470,439281,1,'2007-09-16 00:57:42',3310490815,1),(51385983,424733711,14930325,439281,1,'2007-09-16 00:57:43',3310490815,1),(51385985,424736053,14924317,439281,1,'2007-09-16 00:57:44',3310490815,1),(51385986,424738459,14916935,439281,1,'2007-09-16 00:57:44',3310490858,1),(51385988,424741624,14912214,439281,1,'2007-09-16 00:57:44',3310490858,1),(51385990,424744156,14909725,439281,1,'2007-09-16 00:57:44',3310490858,1),(51385991,424748904,14907837,439281,1,'2007-09-16 00:57:44',3310490858,1),(51385994,424752893,14908524,439281,1,'2007-09-16 00:57:45',3310490858,1),(51385996,424756121,14908009,439281,1,'2007-09-16 00:57:45',3310490858,1),(51385997,424759033,14907150,439281,1,'2007-09-16 00:57:45',3310490858,1),(51386001,424770112,14906464,439281,1,'2007-09-16 00:57:46',3310490859,1),(51386002,424774036,14905262,439281,1,'2007-09-16 00:57:46',3310490859,1),(51386005,424779860,14902344,439281,1,'2007-09-16 00:57:45',3310490859,1),(51386008,424788533,14897280,439281,1,'2007-09-16 00:57:47',3310490859,1),(51386009,424793407,14894619,439281,1,'2007-09-16 00:57:47',3310490862,1),(51386011,424798091,14893246,439281,1,'2007-09-16 00:57:47',3310490862,1),(51386013,424800687,14893332,439281,1,'2007-09-16 00:57:46',3310490862,1),(51386014,424807080,14894190,439281,1,'2007-09-16 00:57:46',3310490862,1),(51386018,424812208,14895306,439281,1,'2007-09-16 00:57:48',3310490862,1),(51386019,424817461,14896765,439281,1,'2007-09-16 00:57:48',3310490862,1),(51386021,424825057,14900198,439281,1,'2007-09-16 00:57:47',3310490863,1),(51386271,424545848,14868288,439281,1,'2007-09-16 00:57:35',3310490793,1),(51386274,424555157,14864769,439281,1,'2007-09-16 00:57:37',3310490793,1),(51386275,424558576,14864512,439281,1,'2007-09-16 00:57:38',3310490793,1),(51386276,424565289,14865627,439281,1,'2007-09-16 00:57:37',3310490793,1),(51386279,424569911,14867687,439281,1,'2007-09-16 00:57:37',3310490793,1),(51386281,424575231,14870691,439281,1,'2007-09-16 00:57:38',3310490796,1),(51386282,424578460,14873352,439281,1,'2007-09-16 00:57:38',3310490796,1),(51386284,424581690,14878330,439281,1,'2007-09-16 00:57:38',3310490796,1),(51386286,424584413,14881764,439281,1,'2007-09-16 00:57:38',3310490796,1),(51386287,424585806,14882708,439281,1,'2007-09-16 00:57:38',3310490796,1),(51386289,424588845,14883995,439281,1,'2007-09-16 00:57:35',3310490796,1),(51386290,424591821,14886484,439281,1,'2007-09-16 00:57:36',3310490796,1),(51386294,424595051,14888802,439281,1,'2007-09-16 00:57:35',3310490798,1),(51386295,424603916,14894638,439281,1,'2007-09-16 00:57:35',3310490799,1),(51386296,424610850,14899397,443749,1,'2007-09-16 13:41:57',3310490799,1),(51386298,424615313,14903221,439281,1,'2007-09-16 00:57:37',3310490799,1),(51386301,424621575,14904388,439281,1,'2007-09-16 00:57:36',3310490799,1),(51386302,424622668,14904022,439281,1,'2007-09-16 00:57:36',3310490799,1),(51386304,424623862,14903545,439281,1,'2007-09-16 00:57:40',3310490799,1),(51386307,424632916,14901228,439281,1,'2007-09-16 00:57:40',3310490810,1),(51386309,424643427,14898052,439281,1,'2007-09-16 00:57:40',3310490810,1),(51386312,424647163,14897623,439281,1,'2007-09-16 00:57:41',3310490810,1),(51386315,424649885,14898310,439281,1,'2007-09-16 00:57:41',3310490810,1),(51386316,424652418,14900284,439281,1,'2007-09-16 00:57:41',3310490810,1),(51386319,424655710,14905348,439281,1,'2007-09-16 00:57:41',3310490811,1),(51386320,424660649,14913588,439281,1,'2007-09-16 00:57:39',3310490811,1),(51386324,424663751,14917021,439281,1,'2007-09-16 00:57:39',3310490811,1),(51386327,424667803,14919939,439281,1,'2007-09-16 00:57:39',3310490811,1),(51386330,424674578,14923029,439281,1,'2007-09-16 00:57:39',3310490811,1),(51386331,424679200,14925518,439281,1,'2007-09-16 00:57:39',3310490811,1),(51386333,424682176,14926548,439281,1,'2007-09-16 00:57:40',3310490811,1),(51386340,424533036,14870863,427965,1,'2007-09-14 20:32:06',3310490792,1),(51386342,424535949,14870863,427965,1,'2007-09-14 20:32:06',3310490792,1),(51386346,424539832,14870262,439281,1,'2007-09-16 00:57:41',3310490792,1),(51386455,424509858,14861508,427965,1,'2007-09-14 20:32:06',3310490109,1),(51386456,424520687,14866915,427965,1,'2007-09-14 20:32:06',3310490792,1),(51386457,424527020,14869490,427965,1,'2007-09-14 20:32:06',3310490792,1),(51386536,424496051,14842453,427965,1,'2007-09-14 20:32:17',3310490109,1),(51386538,424504665,14855499,427965,1,'2007-09-14 20:32:17',3310490109,1),(51386795,425247920,15640249,427965,1,'2007-09-14 20:32:48',3310491620,1),(51387092,425441896,15918083,427965,1,'2007-09-14 20:33:11',3310503939,1),(51389997,425436395,17314720,427965,1,'2007-09-14 20:38:56',3310504587,1),(51389999,425441137,17314120,427965,1,'2007-09-14 20:38:56',3310504587,1),(51390001,425447524,17312317,427965,1,'2007-09-14 20:38:56',3310504587,1),(51390003,425453089,17311030,427965,1,'2007-09-14 20:38:56',3310504590,1),(51390006,425456630,17310686,427965,1,'2007-09-14 20:38:56',3310504590,1),(51390008,425458907,17311459,427965,1,'2007-09-14 20:38:56',3310504590,1),(51390010,425460551,17311545,427965,1,'2007-09-14 20:38:56',3310504590,1),(51390012,425462384,17311287,427965,1,'2007-09-14 20:38:56',3310504590,1),(51390014,425463965,17310343,427965,1,'2007-09-14 20:38:56',3310504590,1),(51390016,425464977,17309485,206510,1,'2008-12-06 20:10:24',3310504590,5),(51391054,425460677,17308369,206510,1,'2008-12-06 20:10:24',3310504590,2),(51391055,425462068,17306137,427965,1,'2007-09-14 20:41:03',3310504590,1),(51391057,425463586,17304335,427965,1,'2007-09-14 20:41:03',3310504590,1),(51391058,425464914,17303391,427965,1,'2007-09-14 20:41:03',3310504588,1),(51391060,425467127,17303562,427965,1,'2007-09-14 20:41:03',3310504588,1),(51391063,425468392,17304850,427965,1,'2007-09-14 20:41:03',3310504590,1),(51391064,425469467,17306824,427965,1,'2007-09-14 20:41:03',3310504590,1),(51391065,425469720,17309056,427965,1,'2007-09-14 20:41:03',3310504590,1),(51391067,425469656,17310944,206510,1,'2008-12-06 20:09:53',3310504590,4),(51392412,425381756,17283564,206510,1,'2008-12-06 20:10:24',3310493661,2),(51392415,425381376,17284765,427965,1,'2007-09-14 20:47:30',3310493661,1),(51392416,425381629,17285795,427965,1,'2007-09-14 20:47:30',3310493661,1),(51392417,425383337,17287855,427965,1,'2007-09-14 20:47:30',3310493661,1),(51392418,425387764,17292319,427965,1,'2007-09-14 20:47:30',3310493661,1),(51392420,425390293,17294464,427965,1,'2007-09-14 20:43:47',3310493661,1),(51392422,425392823,17295666,427965,1,'2007-09-14 20:47:30',3310493661,1),(51392424,425395100,17295838,427965,1,'2007-09-14 20:47:30',3310493661,1),(51392426,425399906,17296524,427965,1,'2007-09-14 20:47:30',3310504584,1),(51392429,425407368,17299528,427965,1,'2007-09-14 20:47:30',3310504584,1),(51392430,425412997,17301502,427965,1,'2007-09-14 20:47:30',3310504584,1),(51392432,425417929,17304077,427965,1,'2007-09-14 20:47:30',3310504586,1),(51392434,425422356,17305279,427965,1,'2007-09-14 20:47:30',3310504586,1),(51392435,425424885,17305365,427965,1,'2007-09-14 20:47:30',3310504587,1),(51392436,425426530,17306481,427965,1,'2007-09-14 20:47:30',3310504587,1),(51392437,425426656,17307854,427965,1,'2007-09-14 20:47:30',3310504587,1),(51392439,425426403,17308970,427965,1,'2007-09-14 20:47:30',3310504587,1),(51392441,425425455,17309570,427965,1,'2007-09-14 20:47:30',3310504587,1),(51392442,425423557,17309056,427965,1,'2007-09-14 20:47:30',3310504586,1),(51392445,425420079,17308712,427965,1,'2007-09-14 20:47:30',3310504586,1),(51392447,425416411,17308197,427965,1,'2007-09-14 20:47:30',3310504586,1),(51396271,425470289,17005043,427965,1,'2007-09-14 20:51:38',3310504486,1),(51396360,425442212,17007361,427965,1,'2007-09-14 20:51:38',3310504483,1),(51396361,425443351,17007618,427965,1,'2007-09-14 20:51:38',3310504483,1),(51396363,425444679,17008305,427965,1,'2007-09-14 20:51:38',3310504483,1),(51396365,425446260,17010708,427965,1,'2007-09-14 20:51:38',3310504483,1),(51396367,425448157,17012081,427965,1,'2007-09-14 20:51:38',3310504483,1),(51396369,425450686,17012510,427965,1,'2007-09-14 20:51:38',3310504483,1),(51396370,425454290,17011051,427965,1,'2007-09-14 20:51:38',3310504486,1),(51396371,425456820,17009678,427965,1,'2007-09-14 20:51:38',3310504486,1),(51396373,425459412,17009335,427965,1,'2007-09-14 20:51:38',3310504486,1),(51396374,425463143,17008391,427965,1,'2007-09-14 20:51:38',3310504486,1),(51396375,425466178,17007618,427965,1,'2007-09-14 20:51:38',3310504486,1),(51396377,425469087,17005816,427965,1,'2007-09-14 20:51:38',3310504486,1),(51396378,425472186,17003327,427965,1,'2007-09-14 20:51:38',3310504486,1),(51396380,425474019,17002726,427965,1,'2007-09-14 20:51:38',3310504486,1),(51396399,425476296,17002640,427965,1,'2007-09-14 20:51:38',3310504486,1),(51396983,425353739,17018519,427965,1,'2007-09-14 20:51:38',3310493558,1),(51396985,425356964,17018690,427965,1,'2007-09-14 20:51:38',3310493558,1),(51396986,425361771,17017746,427965,1,'2007-09-14 20:51:38',3310493558,1),(51396989,425365376,17016716,427965,1,'2007-09-14 20:51:38',3310493558,1),(51396991,425368538,17014828,427965,1,'2007-09-14 20:51:38',3310493558,1),(51396992,425371637,17012940,427965,1,'2007-09-14 20:51:38',3310493559,1),(51396993,425375431,17012425,427965,1,'2007-09-14 20:51:38',3310493559,1),(51396996,425378594,17012167,427965,1,'2007-09-14 20:51:38',3310493559,1),(51396997,425381186,17012510,427965,1,'2007-09-14 20:51:38',3310493559,1),(51396999,425384032,17012940,427965,1,'2007-09-14 20:51:38',3310493559,1),(51397000,425386436,17012596,427965,1,'2007-09-14 20:51:38',3310493559,1),(51397003,425388965,17012339,427965,1,'2007-09-14 20:51:38',3310493559,1),(51397004,425392254,17012940,427965,1,'2007-09-14 20:51:38',3310493559,1),(51397005,425394467,17013283,427965,1,'2007-09-14 20:51:38',3310493559,1),(51397008,425395985,17012854,427965,1,'2007-09-14 20:51:38',3310493559,1),(51397009,425398198,17012167,427965,1,'2007-09-14 20:51:38',3310504482,1),(51397010,425400412,17011566,427965,1,'2007-09-14 20:51:38',3310504482,1),(51397012,425403637,17011566,427965,1,'2007-09-14 20:51:38',3310504482,1),(51397013,425406103,17012167,427965,1,'2007-09-14 20:51:38',3310504482,1),(51397015,425409076,17013197,427965,1,'2007-09-14 20:51:38',3310504482,1),(51397016,425412680,17014570,427965,1,'2007-09-14 20:51:38',3310504482,1),(51397017,425414767,17015600,427965,1,'2007-09-14 20:51:38',3310504482,1),(51397019,425417423,17015600,427965,1,'2007-09-14 20:51:38',3310504482,1),(51397021,425419953,17014828,427965,1,'2007-09-14 20:51:38',3310504482,1),(51397022,425421724,17013884,427965,1,'2007-09-14 20:51:38',3310504482,1),(51397024,425425265,17012253,427965,1,'2007-09-14 20:51:38',3310504483,1),(51397026,425429818,17010536,427965,1,'2007-09-14 20:51:38',3310504483,1),(51397027,425432600,17009421,427965,1,'2007-09-14 20:51:38',3310504483,1),(51397028,425434940,17008476,427965,1,'2007-09-14 20:51:38',3310504483,1),(51397029,425437659,17007618,427965,1,'2007-09-14 20:51:38',3310504483,1),(51397032,425439936,17007361,427965,1,'2007-09-14 20:51:38',3310504483,1),(51397034,425445501,17009506,427965,1,'2007-09-14 20:51:38',3310504483,1),(51397727,425607048,16810465,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397729,425604519,16811409,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397731,425603507,16813469,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397732,425603570,16815357,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397733,425604898,16818876,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397734,425605530,16821881,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397737,425605530,16824112,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397738,425604772,16826859,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397740,425603823,16828747,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397742,425602369,16830464,427965,1,'2007-09-14 20:53:50',3310504477,1),(51397744,425600409,16831408,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397748,425597565,16831064,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397749,425594151,16829605,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397752,425591875,16829262,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397753,425588081,16830549,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397756,425583087,16830893,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397757,425580179,16832266,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397758,425578219,16833725,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397762,425576954,16835098,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397764,425576322,16836472,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397766,425576449,16838103,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397769,425577334,16840162,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397770,425577334,16843596,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397771,425575690,16847029,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397772,425572213,16850205,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397773,425566522,16854496,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397776,425563172,16858187,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397777,425561528,16861105,427965,1,'2007-09-14 20:53:59',3310504473,1),(51397779,425561275,16864367,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397781,425561717,16867972,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397782,425562539,16871233,427965,1,'2007-09-14 20:53:59',3310504478,1),(51397783,425562919,16873121,427965,1,'2007-09-14 20:53:59',3310504478,1),(51397786,425562034,16874838,427965,1,'2007-09-14 20:53:59',3310504478,1),(51397788,425560769,16875525,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397790,425559125,16874838,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397791,425556723,16874237,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397794,425555205,16873036,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397795,425553688,16873036,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397796,425549642,16875525,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397798,425547618,16876812,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397799,425547113,16878100,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397802,425546923,16880503,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397803,425546101,16883164,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397806,425544584,16886254,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397808,425542687,16887026,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397810,425539968,16889343,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397813,425538956,16891060,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397814,425538514,16893892,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397815,425537882,16896210,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397816,425536870,16897755,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397818,425535795,16898527,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397819,425534847,16898098,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397821,425534720,16896811,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397822,425533961,16895867,427965,1,'2007-09-14 20:53:59',3310504474,1),(51397824,425532950,16895094,427965,1,'2007-09-14 20:53:59',3310504474,1),(51397825,425531622,16895867,427965,1,'2007-09-14 20:53:59',3310504474,1),(51397826,425529346,16898527,427965,1,'2007-09-14 20:53:59',3310504474,1),(51397828,425528145,16902561,427965,1,'2007-09-14 20:53:59',3310504474,1),(51397829,425526754,16907454,427965,1,'2007-09-14 20:53:59',3310504474,1),(51397830,425524161,16912003,427965,1,'2007-09-14 20:53:59',3310504474,1),(51397831,425522264,16913719,427965,1,'2007-09-14 20:53:59',3310504474,1),(51397832,425521379,16915522,427965,1,'2007-09-14 20:53:59',3310504474,1),(51397834,425521379,16918612,427965,1,'2007-09-14 20:53:59',3310504474,1),(51397835,425520368,16920157,427965,1,'2007-09-14 20:53:59',3310504496,1),(51397837,425518534,16923247,427965,1,'2007-09-14 20:53:59',3310504496,1),(51398048,425631260,16788235,427965,1,'2007-09-14 20:53:59',3310504514,1),(51398049,425628415,16789866,427965,1,'2007-09-14 20:53:59',3310504514,1),(51398053,425626203,16793213,427965,1,'2007-09-14 20:53:59',3310504514,1),(51398054,425623990,16794071,427965,1,'2007-09-14 20:53:59',3310504514,1),(51398057,425622663,16796045,427965,1,'2007-09-14 20:53:50',3310504514,1),(51398058,425621145,16800080,427965,1,'2007-09-14 20:53:59',3310504514,1),(51398059,425619312,16802139,427965,1,'2007-09-14 20:53:59',3310504514,1),(51398060,425617289,16801796,427965,1,'2007-09-14 20:53:59',3310504514,1),(51398063,425615835,16802912,427965,1,'2007-09-14 20:53:59',3310504471,1),(51398065,425614444,16805916,427965,1,'2007-09-14 20:53:59',3310504471,1),(51398068,425611979,16807633,427965,1,'2007-09-14 20:53:59',3310504471,1),(51398069,425609323,16809178,427965,1,'2007-09-14 20:53:59',3310504471,1),(51398098,425639162,16782055,427965,1,'2007-09-14 20:53:59',3310504514,1),(51398099,425635622,16784802,427965,1,'2007-09-14 20:53:59',3310504514,1),(51399265,425055276,15279589,305941,1,'2009-02-09 21:25:15',3310491437,2),(51399266,425057238,15287914,305941,1,'2009-02-09 21:25:14',3310491437,2),(51399269,425058503,15291863,305941,1,'2009-02-09 21:25:14',3310491437,2),(51399270,425064768,15301047,305941,1,'2009-02-09 21:25:14',3310491437,2),(51399272,425068248,15306025,305941,1,'2009-02-09 21:25:14',3310491448,2),(51399273,425069070,15307226,305941,1,'2009-02-09 21:25:14',3310491448,2),(51399275,425072614,15316668,305941,1,'2009-02-09 21:25:14',3310491448,2),(51399277,425073373,15318299,305941,1,'2009-02-09 21:25:14',3310491448,2),(51399278,425082801,15326624,305941,1,'2009-02-09 21:25:14',3310491450,2),(51399285,425082862,15292505,443527,1,'2008-05-14 12:03:55',3310491448,2),(51399289,425062971,15310660,443749,1,'2007-09-16 21:50:10',3310491437,1),(51399292,425066578,15319296,443749,1,'2007-09-16 21:50:09',3310491437,1),(51399296,425073430,15281647,443527,1,'2008-05-14 12:03:55',3310491448,2),(51399299,425062047,15296841,305941,1,'2009-02-09 21:25:14',3310491437,2),(51399303,425073942,15300102,427965,1,'2007-09-14 21:15:41',3310491448,1),(51399304,425070336,15294352,427965,1,'2007-09-14 21:15:42',3310491448,1),(51399306,425067172,15289889,427965,1,'2007-09-14 21:15:40',3310491437,1),(51399308,425064261,15285168,427965,1,'2007-09-14 21:15:39',3310491437,1),(51399309,425058820,15292378,305941,1,'2009-02-09 21:25:14',3310491437,2),(51399320,425074408,15341741,104780,1,'2009-02-04 00:34:16',3310491450,5),(51399321,425065613,15341655,104780,1,'2009-02-04 00:34:16',3310491439,6),(51399325,425079574,15327053,427965,1,'2007-09-14 20:57:20',3310491450,1),(51399326,425075967,15325337,427965,1,'2007-09-14 20:57:20',3310491448,1),(51399327,425074132,15324307,427965,1,'2007-09-14 20:57:20',3310491448,1),(51399329,425072361,15322247,427965,1,'2007-09-14 20:57:20',3310491448,1),(51399335,425077233,15316582,427965,1,'2007-09-14 21:15:39',3310491448,1),(51399337,425075461,15312205,427965,1,'2007-09-14 21:15:39',3310491448,1),(51399339,425074702,15301476,427965,1,'2007-09-14 21:15:39',3310491448,1),(51399365,425070248,15326367,305941,1,'2009-02-09 21:23:21',3310491450,2),(51399367,425079913,15341311,305941,1,'2009-02-09 21:23:21',3310491450,6),(51399377,425077313,15285484,443527,1,'2008-05-14 12:03:55',3310491448,2),(51399380,425067235,15298214,427965,1,'2007-09-14 20:57:18',3310491437,1),(51399381,425058194,15307642,840745,1,'2009-01-26 19:28:31',3310491437,2),(51399398,425073942,15324049,427965,1,'2007-09-14 20:57:20',3310491448,1),(51399406,425081978,15315638,305941,1,'2009-02-09 21:17:59',3310491448,5),(51399409,425075588,15320273,305941,1,'2009-02-09 21:25:14',3310491448,2),(51399411,425071450,15328169,305941,1,'2009-02-09 21:23:21',3310491450,2),(51399601,425067727,15320781,3916355,1,'2010-02-19 17:34:16',3310491448,4),(51399602,425072804,15317269,305941,1,'2009-02-09 21:25:14',3310491448,3),(51400247,425088873,15288745,437032,1,'2008-05-13 21:23:13',3310491448,2),(51400250,425088116,15291348,427965,1,'2007-09-14 21:14:43',3310491448,1);
INSERT INTO `current_nodes` VALUES (51400253,425083498,15303690,305941,1,'2009-02-09 21:17:59',3310491448,6),(51400254,425082485,15308497,305941,1,'2009-02-09 21:17:59',3310491448,6),(51400256,425082737,15324478,305941,1,'2009-02-09 21:17:59',3310491448,5),(51400257,425083686,15334606,305941,1,'2009-02-09 21:17:59',3310491450,5),(51400259,425084889,15348683,305941,1,'2009-02-09 21:19:42',3310491450,5),(51400263,425086407,15368338,305941,1,'2009-02-09 21:20:12',3310491450,6),(51400264,425086724,15380011,305941,1,'2009-02-09 21:20:12',3310491450,2),(51400267,425086903,15397735,305941,1,'2009-02-09 21:21:16',3310491536,8),(51400269,425086966,15404516,305941,1,'2009-02-09 21:21:16',3310491536,5),(51400270,425088168,15417133,305941,1,'2009-02-09 21:21:16',3310491536,5),(51400272,425088991,15424600,305941,1,'2009-02-09 21:21:16',3310491536,6),(51400273,425090003,15433612,305941,1,'2009-02-09 21:20:30',3310491536,3),(51400276,425091205,15439534,305941,1,'2009-02-09 21:20:30',3310491538,3),(51400277,425091395,15442281,305941,1,'2009-02-09 21:20:30',3310491538,3),(51400280,425092534,15448633,305941,1,'2009-02-09 21:20:30',3310491538,3),(51400281,425094749,15455756,305941,1,'2009-02-09 21:20:30',3310491538,3),(51400283,425096710,15460477,188228,1,'2008-06-16 18:48:34',3310491539,2),(51400284,425097532,15462537,188228,1,'2008-06-16 18:48:34',3310491539,2),(51400285,425099620,15464425,188228,1,'2008-06-16 18:48:34',3310491539,2),(51400286,425102468,15464254,188228,1,'2008-06-16 18:48:34',3310491539,2),(51400290,425105831,15464297,427965,1,'2007-09-14 21:14:43',3310491539,1),(51400293,425109997,15465713,188228,1,'2008-06-16 18:49:46',3310491539,2),(51400296,425111705,15468717,188228,1,'2008-06-16 18:49:46',3310491539,2),(51400299,425113603,15477901,188228,1,'2008-06-16 18:49:46',3310491539,2),(51400301,425115818,15487686,188228,1,'2008-06-16 18:51:31',3310491539,2),(51400303,425117526,15495410,188228,1,'2008-06-16 18:51:31',3310491545,2),(51400305,425119614,15500131,188228,1,'2008-06-16 18:51:31',3310491545,2),(51400766,425098711,15387955,427965,1,'2007-09-14 22:14:55',3310491537,1),(51400768,425086713,15387264,305941,1,'2009-02-09 21:20:13',3310491536,3),(51400770,425081345,15387650,305941,1,'2009-02-09 21:22:13',3310491536,2),(51400772,425081282,15384731,305941,1,'2009-02-09 21:22:13',3310491536,2),(51400773,425081156,15381985,305941,1,'2009-02-09 21:22:13',3310491536,2),(51400777,425080776,15377779,305941,1,'2009-02-09 21:22:14',3310491450,2),(51400778,425079257,15374689,305941,1,'2009-02-09 21:22:14',3310491450,2),(51400779,425078118,15372114,305941,1,'2009-02-09 21:22:14',3310491450,2),(51400782,425077549,15368939,305941,1,'2009-02-09 21:22:14',3310491450,2),(51400784,425076853,15362759,305941,1,'2009-02-09 21:22:14',3310491450,2),(51400786,425076726,15358982,305941,1,'2009-02-09 21:22:14',3310491450,2),(51400787,425076542,15355927,305941,1,'2009-02-09 21:22:14',3310491450,3),(51400789,425076410,15353918,305941,1,'2009-02-09 21:22:14',3310491450,2),(51400791,425075081,15350142,305941,1,'2009-02-09 21:22:14',3310491450,2),(51400793,425072550,15344219,305941,1,'2009-02-09 21:22:14',3310491450,2),(51400794,425071245,15341826,305941,1,'2009-02-09 21:22:14',3310491450,6),(51400863,425072107,15374088,820251,1,'2009-03-16 23:49:41',3310491450,2),(51400866,425072361,15376749,820251,1,'2009-03-16 23:49:41',3310491450,2),(51400868,425072930,15377951,820251,1,'2009-03-16 23:49:41',3310491450,2),(51400869,425074259,15378809,820251,1,'2009-03-16 23:49:42',3310491450,2),(51400870,425080966,15378981,820251,1,'2009-03-16 23:50:05',3310491450,5),(51400871,425086724,15379238,820251,1,'2009-03-16 23:50:06',3310491450,4),(51400970,425070009,15370519,820251,1,'2009-03-16 23:49:40',3310491450,3),(51400971,425071665,15372372,820251,1,'2009-03-16 23:49:40',3310491450,2),(51401220,425081662,15417433,305941,1,'2009-02-09 21:22:13',3310491536,2),(51401223,425081662,15413914,305941,1,'2009-02-09 21:22:13',3310491536,2),(51401224,425082041,15409193,305941,1,'2009-02-09 21:22:13',3310491536,3),(51401226,425082801,15402155,305941,1,'2009-02-09 21:22:13',3310491536,2),(51401227,425082737,15398379,305941,1,'2009-02-09 21:22:13',3310491536,2),(51401228,425081598,15392113,305941,1,'2009-02-09 21:22:13',3310491536,2),(51401444,425118043,15406189,427965,1,'2007-09-14 21:07:01',3310491537,1),(51401446,425116840,15405417,427965,1,'2007-09-14 21:07:01',3310491537,1),(51401447,425114689,15407133,427965,1,'2007-09-14 21:07:01',3310491537,1),(51401449,425110577,15411511,427965,1,'2007-09-14 21:07:01',3310491537,1),(51401451,425108995,15412712,427965,1,'2007-09-14 21:07:01',3310491537,1),(51401452,425106844,15412712,427965,1,'2007-09-14 21:07:01',3310491537,1),(51401454,425103997,15410824,495907,1,'2008-07-15 17:43:20',3310491537,2),(51401456,425097163,15407820,305941,1,'2009-02-09 21:21:41',3310491537,2),(51401457,425093114,15407734,305941,1,'2009-02-09 21:21:41',3310491536,2),(51401461,425087029,15408550,305941,1,'2009-02-09 21:21:42',3310491536,6),(51402983,425026296,15134449,427965,1,'2007-09-14 21:03:11',3310491406,1),(51402986,425034775,15143719,427965,1,'2007-09-14 21:03:11',3310491406,1),(51402987,425047683,15159083,427965,1,'2007-09-14 21:03:11',3310491407,1),(51402989,425050657,15162430,427965,1,'2007-09-14 21:03:11',3310491429,1),(51402991,425053125,15166722,427965,1,'2007-09-14 21:03:11',3310491429,1),(51402994,425054074,15170155,427965,1,'2007-09-14 21:03:11',3310491429,1),(51402995,425054644,15175390,427965,1,'2007-09-14 21:03:11',3310491429,1),(51402997,425054391,15179081,427965,1,'2007-09-14 21:03:11',3310491429,1),(51403000,425054137,15180283,427965,1,'2007-09-14 21:03:11',3310491429,1),(51403223,425054783,15183030,3916355,1,'2010-02-19 17:32:02',3310491429,2),(51403224,425054605,15182206,3916355,1,'2010-02-19 17:32:03',3310491429,2),(51403225,425054014,15181631,3916355,1,'2010-02-19 17:32:03',3310491429,2),(51403226,425053319,15181700,3916355,1,'2010-02-19 17:32:03',3310491429,2),(51403228,425052823,15182315,3916355,1,'2010-02-19 17:32:03',3310491429,2),(51403229,425052737,15183403,3916355,1,'2010-02-19 17:32:04',3310491429,2),(51403231,425053054,15184070,3916355,1,'2010-02-19 17:32:04',3310491429,2),(51403232,425053932,15184392,3916355,1,'2010-02-19 17:32:04',3310491429,2),(51403234,425054653,15183684,3916355,1,'2010-02-19 17:32:04',3310491429,2),(51403654,425051100,15184918,427965,1,'2007-09-14 21:03:30',3310491429,1),(51403656,425048988,15186761,305941,1,'2009-02-09 21:34:26',3310491429,2),(51403657,425046924,15187493,427965,1,'2007-09-14 21:03:30',3310491429,1),(51403659,425043760,15188780,427965,1,'2007-09-14 21:03:30',3310491429,1),(51403661,425040976,15190239,427965,1,'2007-09-14 21:03:30',3310491429,1),(51403663,425037527,15192491,56648,1,'2008-06-05 20:30:42',3310491428,2),(51403665,425036530,15193235,3916355,1,'2010-02-19 17:31:53',3310491428,5),(51403850,425061477,15215130,305941,1,'2009-02-09 21:34:27',3310491429,2),(51403851,425059896,15211783,305941,1,'2009-02-09 21:34:27',3310491429,2),(51403852,425057934,15206375,305941,1,'2009-02-09 21:34:28',3310491429,2),(51403854,425056479,15202255,305941,1,'2009-02-09 21:34:28',3310491429,2),(51403857,425055150,15197277,305941,1,'2009-02-09 21:34:28',3310491429,2),(51403858,425054391,15192900,305941,1,'2009-02-09 21:34:28',3310491429,2),(51403859,425053568,15187664,305941,1,'2009-02-09 21:34:28',3310491429,2),(51403861,425053478,15184371,3916355,1,'2010-02-19 17:32:04',3310491429,3),(51404061,425062983,15216630,3916355,1,'2010-02-19 17:31:58',3310491431,2),(51404062,425063152,15217362,3916355,1,'2010-02-19 17:31:58',3310491431,2),(51404063,425062915,15218273,3916355,1,'2010-02-19 17:32:00',3310491431,2),(51404066,425062114,15218764,3916355,1,'2010-02-19 17:32:00',3310491431,2),(51404067,425061364,15218276,3916355,1,'2010-02-19 17:31:59',3310491431,2),(51404069,425061140,15217155,3916355,1,'2010-02-19 17:31:59',3310491431,2),(51404071,425061306,15216606,3916355,1,'2010-02-19 17:31:59',3310491431,2),(51404073,425061902,15216053,3916355,1,'2010-02-19 17:31:58',3310491429,3),(51404074,425062566,15216143,3916355,1,'2010-02-19 17:31:58',3310491429,2),(51404272,425049139,15220795,427965,1,'2007-09-14 21:04:29',3310491431,1),(51404274,425061173,15217807,3916355,1,'2010-02-19 17:31:59',3310491431,2),(51404282,425045975,15221396,56648,1,'2008-06-05 20:36:40',3310491431,2),(51404481,425070526,15254183,427965,1,'2007-09-14 21:14:20',3310491442,1),(51404482,425069893,15249720,427965,1,'2007-09-14 21:14:20',3310491442,1),(51404483,425068501,15244656,427965,1,'2007-09-14 21:14:20',3310491442,1),(51404484,425066483,15233915,443749,1,'2007-09-16 21:50:02',3310491431,1),(51404486,425062459,15218694,3916355,1,'2010-02-19 17:32:00',3310491431,2),(51404632,425072361,15273409,427965,1,'2007-09-14 21:14:20',3310491448,1),(51404633,425071475,15263539,427965,1,'2007-09-14 21:14:20',3310491442,1),(51404642,425072867,15280190,427965,1,'2007-09-14 21:06:19',3310491448,1),(51404720,425088873,15290461,820251,1,'2009-03-16 23:53:41',3310491448,3),(51404721,425086534,15287228,427965,1,'2007-09-14 21:05:05',3310491448,1),(51404723,425083244,15283108,427965,1,'2007-09-14 21:14:20',3310491448,1),(51404725,425079637,15279761,427965,1,'2007-09-14 21:14:20',3310491448,1),(51404726,425076663,15277271,427965,1,'2007-09-14 21:14:20',3310491448,1),(51404727,425073310,15275040,427965,1,'2007-09-14 21:14:20',3310491448,1),(51404882,425098102,15335079,188228,1,'2008-06-16 18:36:35',3310491451,5),(51404883,425096972,15330973,437032,1,'2008-05-13 21:27:14',3310491451,3),(51404884,425096529,15326510,437032,1,'2008-05-13 21:13:38',3310491451,3),(51404886,425094125,15317069,437032,1,'2008-05-13 21:13:33',3310491448,2),(51404887,425089063,15304366,437032,1,'2008-05-13 21:20:03',3310491448,2),(51404888,425085648,15297184,427965,1,'2007-09-14 21:14:43',3310491448,1),(51404889,425082484,15291519,427965,1,'2007-09-14 21:06:19',3310491448,1),(51404891,425078308,15286455,427965,1,'2007-09-14 21:06:19',3310491448,1),(51404893,425073816,15282250,427965,1,'2007-09-14 21:06:19',3310491448,1),(51404947,425087609,15308171,427965,1,'2007-09-14 21:05:39',3310491448,1),(51404949,425089887,15306454,427965,1,'2007-09-14 21:06:19',3310491448,1),(51405087,425082231,15318299,820251,1,'2009-03-16 23:48:44',3310491448,7),(51405091,425093809,15316210,820251,1,'2009-03-16 23:48:45',3310491448,4),(51405261,425098029,15337080,3916355,1,'2010-02-19 17:33:03',3310491451,8),(51405263,425098115,15338284,3916355,1,'2010-02-19 17:33:03',3310491451,7),(51405265,425098719,15339308,3916355,1,'2010-02-19 17:33:03',3310491451,4),(51405266,425099137,15339584,3916355,1,'2010-02-19 17:33:03',3310491451,5),(51405268,425100920,15338838,3916355,1,'2010-02-19 17:33:04',3310491451,4),(51405269,425101263,15337344,3916355,1,'2010-02-19 17:33:04',3310491451,4),(51405270,425101213,15336918,3916355,1,'2010-02-19 17:33:04',3310491451,5),(51405271,425100195,15335397,3916355,1,'2010-02-19 17:33:05',3310491451,4),(51405273,425099068,15335400,3916355,1,'2010-02-19 17:33:05',3310491451,4),(51405344,425098322,15336159,3916355,1,'2010-02-19 17:33:03',3310491451,6),(51405527,425122535,15354433,427965,1,'2007-09-14 21:14:20',3310491454,1),(51405528,425120573,15352717,427965,1,'2007-09-14 21:14:20',3310491451,1),(51405530,425117789,15348940,427965,1,'2007-09-14 21:14:20',3310491451,1),(51405533,425113993,15343275,427965,1,'2007-09-14 21:14:20',3310491451,1),(51405534,425111716,15339928,427965,1,'2007-09-14 21:14:20',3310491451,1),(51405536,425108615,15337353,427965,1,'2007-09-14 21:14:20',3310491451,1),(51405537,425105072,15333147,427965,1,'2007-09-14 21:14:20',3310491451,1),(51405539,425102984,15329113,820251,1,'2009-03-16 23:53:39',3310491451,2),(51405540,425098808,15315724,820251,1,'2009-03-16 23:53:39',3310491449,2),(51405542,425096467,15309973,820251,1,'2009-03-16 23:53:39',3310491449,2),(51405543,425094379,15306797,820251,1,'2009-03-16 23:53:39',3310491448,2),(51405544,425092861,15303707,820251,1,'2009-03-16 23:53:40',3310491448,2),(51405547,425091721,15298701,820251,1,'2009-03-16 23:53:40',3310491448,3),(51405548,425090582,15293980,820251,1,'2009-03-16 23:53:41',3310491448,3),(51405550,425089949,15291663,820251,1,'2009-03-16 23:53:41',3310491448,3),(51405712,425127534,15356133,462438,1,'2008-07-11 13:01:05',3310491454,2),(51405715,425126521,15360854,462438,1,'2008-07-11 13:01:05',3310491454,2),(51405716,425124876,15364459,462438,1,'2008-07-11 13:01:05',3310491454,2),(51405720,425119624,15371170,427965,1,'2007-09-14 21:08:08',3310491451,1),(51405722,425115575,15380612,427965,1,'2007-09-14 21:06:57',3310491451,1),(51405723,425113740,15385676,427965,1,'2007-09-14 21:08:08',3310491537,1),(51405725,425112095,15394001,427965,1,'2007-09-14 21:08:08',3310491537,1),(51405727,425110703,15399151,427965,1,'2007-09-14 21:08:08',3310491537,1),(51405728,425107603,15407219,427965,1,'2007-09-14 21:08:08',3310491537,1),(51405729,425106021,15412283,427965,1,'2007-09-14 21:08:08',3310491537,1),(51406111,425127908,15353934,3916355,1,'2010-02-19 17:33:23',3310491454,2),(51406112,425127611,15352872,3916355,1,'2010-02-19 17:33:23',3310491454,2),(51406113,425126716,15352574,3916355,1,'2010-02-19 17:33:23',3310491454,2),(51406114,425126071,15353400,3916355,1,'2010-02-19 17:33:23',3310491454,2),(51406115,425126374,15354811,3916355,1,'2010-02-19 17:33:24',3310491454,2),(51406116,425127246,15355036,3916355,1,'2010-02-19 17:33:24',3310491454,3),(51406117,425127563,15354807,3916355,1,'2010-02-19 17:33:24',3310491454,2),(51406244,425126062,15354183,3916355,1,'2010-02-19 17:33:23',3310491454,2),(51406783,425166695,15287855,432736,1,'2007-09-15 01:38:56',3310491453,1),(51406784,425165619,15291004,427965,1,'2007-09-14 21:36:14',3310491453,1),(51406785,425163342,15294609,427965,1,'2007-09-14 21:36:14',3310491453,1),(51406787,425161127,15298300,427965,1,'2007-09-14 21:36:14',3310491453,1),(51406789,425158723,15303536,427965,1,'2007-09-14 21:36:14',3310491453,1),(51406790,425156509,15307141,427965,1,'2007-09-14 21:36:14',3310491453,1),(51406791,425151321,15313749,427965,1,'2007-09-14 21:36:14',3310491453,1),(51406792,425146703,15318899,427965,1,'2007-09-14 21:36:14',3310491452,1),(51406793,425143793,15321560,427965,1,'2007-09-14 21:36:14',3310491452,1),(51406795,425141452,15323706,427965,1,'2007-09-14 21:36:14',3310491452,1),(51406797,425139427,15326967,427965,1,'2007-09-14 21:36:14',3310491454,1),(51406798,425138099,15330229,427965,1,'2007-09-14 21:36:14',3310491454,1),(51406800,425137213,15334177,427965,1,'2007-09-14 21:36:14',3310491454,1),(51406803,425136137,15338640,427965,1,'2007-09-14 21:36:14',3310491454,1),(51406805,425134682,15340100,427965,1,'2007-09-14 21:36:14',3310491454,1),(51406807,425132088,15342159,427965,1,'2007-09-14 21:08:51',3310491454,1),(51406808,425130253,15345249,427965,1,'2007-09-14 21:36:14',3310491454,1),(51406810,425127878,15350618,427965,1,'2007-09-14 22:12:31',3310491454,1),(51406811,425127268,15352595,3916355,1,'2010-02-19 17:33:23',3310491454,2),(51407218,425177702,15375290,427965,1,'2007-09-14 21:12:21',3310491498,1),(51407219,425174476,15382500,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407220,425172199,15388937,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407222,425169668,15393915,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407223,425168656,15398293,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407226,425167960,15400524,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407227,425167011,15402584,427965,1,'2007-09-14 21:09:37',3310491541,1),(51407228,425166062,15404215,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407231,425163974,15407047,427965,1,'2007-09-14 21:13:38',3310491541,1),(51407232,425161254,15410309,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407234,425159672,15413141,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407235,425158786,15414515,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407236,425158154,15414601,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407238,425157395,15413914,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407240,425157142,15412712,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407243,425157268,15411940,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407245,425158280,15410223,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407247,425159925,15407477,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407708,425161317,15404988,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407709,425161823,15401468,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407712,425162203,15396319,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407714,425162140,15392885,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407715,425162329,15388766,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407716,425162835,15385332,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407718,425164037,15380011,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407719,425165493,15374088,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407720,425166758,15370226,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407723,425167137,15369024,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407725,425166884,15367737,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407726,425166252,15367308,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407728,425165682,15367308,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407729,425164986,15367737,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407731,425163468,15371428,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407733,425161191,15377608,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407736,425159166,15381985,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407738,425157648,15384131,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407739,425156635,15384474,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407740,425155750,15384216,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407742,425155307,15383358,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407743,425155370,15381985,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407744,425156382,15379753,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407746,425159103,15373230,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407747,425161697,15365591,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407749,425162582,15362330,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407751,425163342,15359669,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407753,425164227,15353232,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407754,425164227,15350485,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407756,425165366,15346794,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407759,425167201,15342503,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407760,425168150,15339241,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407764,425168592,15336495,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407765,425169415,15332804,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407766,425170743,15328770,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407767,425172578,15324135,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407769,425173970,15320788,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407773,425174349,15318985,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407774,425174349,15316668,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407775,425174856,15312119,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407778,425174919,15310059,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407779,425174729,15309115,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407781,425173654,15309115,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407782,425173084,15309801,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407784,425172578,15311518,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407785,425171566,15318556,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407786,425170743,15319328,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407787,425169794,15319500,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407789,425168909,15318728,427965,1,'2007-09-14 21:10:27',3310491453,1),(51407790,425168592,15317269,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407791,425169225,15315037,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408269,425170427,15311604,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408270,425171566,15307827,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408271,425172768,15303364,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408274,425173780,15299931,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408275,425174729,15293579,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408278,425174919,15289116,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408279,425174856,15286026,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408280,425174666,15284825,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408281,425173780,15284825,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408282,425172831,15285855,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408283,425172515,15288687,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408284,425172325,15292721,427965,1,'2007-09-14 21:11:10',3310491453,1),(51408285,425169035,15300274,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408286,425165872,15304394,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408287,425164227,15308943,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408288,425162709,15311089,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408289,425160558,15313063,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408290,425150562,15326452,427965,1,'2007-09-14 21:12:21',3310491455,1),(51408292,425147652,15331001,427965,1,'2007-09-14 21:12:21',3310491454,1),(51408294,425146956,15333834,427965,1,'2007-09-14 21:12:21',3310491454,1),(51408296,425145880,15334263,427965,1,'2007-09-14 21:12:21',3310491454,1),(51408299,425145121,15333319,427965,1,'2007-09-14 21:12:21',3310491454,1),(51408300,425145121,15332203,427965,1,'2007-09-14 21:12:21',3310491454,1),(51408302,425145627,15329371,427965,1,'2007-09-14 21:12:21',3310491454,1),(51408305,425146766,15325165,427965,1,'2007-09-14 21:12:21',3310491452,1),(51408306,425149676,15320873,427965,1,'2007-09-14 21:12:21',3310491452,1),(51408307,425152460,15316410,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408310,425152776,15315294,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408311,425151701,15313063,427965,1,'2007-09-14 21:36:14',3310491453,1),(51408485,425177702,15351086,427965,1,'2007-09-14 21:13:38',3310491498,1),(51408486,425176690,15357866,427965,1,'2007-09-14 21:13:38',3310491455,1),(51408490,425175362,15363531,427965,1,'2007-09-14 21:13:38',3310491455,1),(51408491,425173211,15370140,427965,1,'2007-09-14 21:13:38',3310491455,1),(51408492,425170237,15377865,427965,1,'2007-09-14 21:13:38',3310491455,1),(51408495,425168972,15382672,427965,1,'2007-09-14 21:13:38',3310491541,1),(51408496,425167454,15388165,427965,1,'2007-09-14 21:13:38',3310491541,1),(51408497,425166062,15392542,427965,1,'2007-09-14 21:13:38',3310491541,1),(51408498,425165809,15399494,427965,1,'2007-09-14 21:13:38',3310491541,1),(51408499,425164797,15404558,427965,1,'2007-09-14 21:13:38',3310491541,1),(51408872,425143729,15488415,427965,1,'2007-09-14 21:12:15',3310491542,1),(51408873,425145627,15486613,427965,1,'2007-09-14 21:12:15',3310491542,1),(51408874,425148348,15485153,427965,1,'2007-09-14 21:12:15',3310491542,1),(51408875,425149993,15484381,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408876,425151321,15481634,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408879,425152586,15477171,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408880,425153789,15473051,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408883,425154105,15470305,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408884,425153725,15468245,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408885,425154801,15464297,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408887,425155686,15459490,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408889,425156193,15454512,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408891,425155497,15447216,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408892,425154105,15443869,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408893,425153472,15441637,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408896,425153472,15439062,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408897,425152840,15435114,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408898,425152713,15431853,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408900,425153346,15427904,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408902,425153852,15422583,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408904,425153725,15420008,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408905,425153725,15417519,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408906,425154548,15413141,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408909,425154738,15409279,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408910,425155370,15403614,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408911,425156446,15400782,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408912,425158027,15398121,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408913,425158976,15395546,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408914,425159672,15391340,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408915,425160621,15387993,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408916,425162076,15385161,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408917,425163405,15383444,427965,1,'2007-09-14 21:12:15',3310491541,1),(51409632,425144805,15428076,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409633,425144425,15440779,427965,1,'2007-09-14 21:13:34',3310491542,1),(51409634,425144172,15443096,427965,1,'2007-09-14 21:13:34',3310491542,1),(51409635,425143729,15444212,427965,1,'2007-09-14 21:13:34',3310491542,1),(51409636,425142970,15444384,427965,1,'2007-09-14 21:13:34',3310491542,1),(51409638,425142148,15443354,427965,1,'2007-09-14 21:13:34',3310491542,1),(51409639,425141515,15440521,427965,1,'2007-09-14 21:13:34',3310491542,1),(51409640,425140946,15436487,427965,1,'2007-09-14 21:13:34',3310491542,1),(51409641,425141452,15415888,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409642,425141515,15407562,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409644,425141641,15404988,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409645,425141009,15403614,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409646,425140313,15403357,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409647,425139427,15404473,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409648,425138288,15408163,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409649,425136770,15414000,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409651,425135884,15417004,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409652,425134935,15419579,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409653,425133986,15420523,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409655,425132721,15420952,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409656,425132025,15421982,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409657,425132088,15424729,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409658,425132341,15430737,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409659,425132215,15432453,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409660,425131076,15434342,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409662,425130000,15434857,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409663,425128419,15434170,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409664,425124116,15433054,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409665,425123167,15431938,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409666,425122788,15429793,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409667,425123041,15425844,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409668,425123673,15420351,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409669,425123800,15417175,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409670,425123484,15415030,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409671,425123357,15412455,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409672,425123927,15400181,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409673,425124749,15398636,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409674,425125192,15396834,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409675,425125382,15394259,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409676,425125318,15392199,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409677,425124433,15391426,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409678,425123484,15391770,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409679,425122471,15394345,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409680,425122471,15394688,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409972,425100136,15339582,3916355,1,'2010-02-19 17:33:04',3310491451,5),(51409974,425101401,15341187,437032,1,'2008-05-13 21:26:45',3310491451,2),(51409975,425107034,15348666,462438,1,'2008-07-11 13:00:24',3310491451,2),(51409976,425109882,15352614,462438,1,'2008-07-11 13:00:24',3310491451,2),(51409978,425111969,15355635,427965,1,'2007-09-14 21:14:09',3310491451,1),(51409979,425113550,15358982,427965,1,'2007-09-14 21:14:09',3310491451,1),(51409981,425118043,15362742,462438,1,'2008-07-11 13:01:48',3310491451,2),(51409983,425120321,15364716,462438,1,'2008-07-11 13:09:45',3310491451,3),(51410094,425104503,15332117,820251,1,'2009-03-16 23:53:39',3310491451,2),(51410095,425103807,15332890,427965,1,'2007-09-14 21:14:24',3310491451,1),(51410232,425076537,15355635,305941,1,'2009-02-09 21:22:14',3310491450,2),(51410233,425085268,15354605,305941,1,'2009-02-09 21:19:42',3310491450,5),(51410282,425077043,15364733,305941,1,'2009-02-09 21:22:14',3310491450,2),(51410286,425086028,15363703,305941,1,'2009-02-09 21:19:42',3310491450,5),(51410490,425075208,15308600,305941,1,'2009-02-09 21:27:05',3310491448,2),(51410491,425070462,15311003,305941,1,'2009-02-09 21:27:05',3310491448,3),(51410493,425064553,15314436,305941,1,'2009-02-09 21:27:05',3310491437,2),(51410494,425063439,15315209,305941,1,'2009-02-09 21:27:05',3310491437,2),(51410495,425060838,15317037,3916355,1,'2010-02-19 17:34:20',3310491437,4),(51410786,425057428,15279363,443749,1,'2007-09-16 21:49:53',3310491437,1),(51410787,425059073,15285340,427965,1,'2007-09-14 21:15:39',3310491437,1),(51410788,425061414,15289202,427965,1,'2007-09-14 21:15:39',3310491437,1),(51410790,425064515,15293579,427965,1,'2007-09-14 21:15:39',3310491437,1),(51410791,425067488,15298128,427965,1,'2007-09-14 21:15:39',3310491437,1),(51410792,425071158,15303192,427965,1,'2007-09-14 21:15:39',3310491448,1),(51411056,425069513,15329113,427965,1,'2007-09-14 21:16:04',3310491450,1),(51411057,425066729,15329971,427965,1,'2007-09-14 21:16:04',3310491439,1),(51411059,425069513,15340529,427965,1,'2007-09-14 21:16:04',3310491450,1),(51411060,425070399,15341473,427965,1,'2007-09-14 21:16:04',3310491450,1),(51411061,425075081,15341215,427965,1,'2007-09-14 21:16:04',3310491450,1),(51411062,425076600,15339670,427965,1,'2007-09-14 21:16:04',3310491450,1),(51412082,424997756,15233755,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412083,424995858,15232554,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412086,424994466,15232554,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412087,424993580,15233498,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412090,424993390,15235386,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412091,424993390,15237360,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412092,424993010,15239334,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412093,424992378,15240364,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412094,424991365,15240708,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412095,424990479,15240021,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412096,424988517,15238304,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412099,424985670,15235214,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412100,424981999,15230923,427965,1,'2007-09-14 21:22:31',3310491426,1),(51412102,424980101,15227404,427965,1,'2007-09-14 21:22:31',3310491426,1),(51412103,424979278,15223198,427965,1,'2007-09-14 21:22:31',3310491426,1),(51412105,424979088,15218735,427965,1,'2007-09-14 21:22:31',3310491426,1),(51412106,424979848,15215903,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412107,424979784,15214100,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412109,424978582,15213928,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412110,424975987,15214529,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412112,424973836,15214529,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412115,424967760,15214443,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412116,424967001,15213156,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412117,424967001,15211697,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412119,424967887,15210238,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412121,424969343,15208950,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412122,424971494,15206461,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412123,424972886,15203886,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412125,424973709,15202170,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412126,424974785,15199080,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412128,424975291,15197020,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412131,424977253,15192471,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412132,424979278,15187664,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412134,424979721,15183973,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412136,424979088,15176335,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412137,424978329,15170670,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412138,424977949,15165520,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412141,424978012,15160027,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412142,424978392,15154791,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412143,424978202,15151615,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412144,424976683,15146980,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412147,424974152,15139857,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412148,424972254,15135822,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412150,424970355,15133076,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412152,424969975,15132046,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412154,424970482,15131188,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412157,424971811,15131617,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412158,424979848,15143032,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412159,424981113,15145436,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412161,424982379,15148783,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412163,424985227,15163374,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412164,424987631,15168181,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412167,424991112,15171871,427965,1,'2007-09-14 21:17:45',3310491425,1),(51412168,424996807,15174618,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412169,425001110,15176249,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412170,425007185,15177708,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412171,425008894,15178395,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412173,425009716,15179253,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412175,425009590,15181141,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412176,425009084,15186892,427965,1,'2007-09-14 21:17:45',3310491425,1),(51412179,425009147,15189552,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412180,425009590,15190926,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412181,425010539,15192986,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412183,425011678,15195475,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412185,425012691,15197191,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412187,425014020,15198050,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412189,425014969,15198822,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412192,425019651,15198994,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412195,425022499,15199509,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412196,425024397,15200796,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412197,425026043,15202255,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412198,425027498,15202255,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412199,425028827,15201140,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412200,425031105,15197792,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412201,425032370,15195990,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412202,425033952,15194874,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412994,424991492,15306368,427965,1,'2007-09-14 21:22:31',3310491433,1),(51412995,424991871,15305596,427965,1,'2007-09-14 21:22:31',3310491433,1),(51412998,424993200,15305252,427965,1,'2007-09-14 21:22:31',3310491433,1),(51412999,424995478,15305338,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413000,424998706,15306454,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413001,425001553,15307055,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413004,425004528,15306454,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413005,425008388,15303364,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413006,425008767,15301991,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413007,425008767,15301476,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413008,425007881,15300875,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413009,425005540,15300102,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413011,425003768,15298472,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413013,425002123,15294953,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413014,425000794,15292893,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413017,424998073,15290833,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413018,424997440,15290489,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413020,424997313,15289459,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413021,424997313,15288601,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413023,424998010,15288000,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413024,424999465,15287914,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413026,425001806,15288344,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413027,425004654,15289202,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413028,425005287,15289116,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413029,425005856,15288344,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413031,425006173,15287228,427965,1,'2007-09-14 21:20:09',3310491433,1),(51413033,425006932,15284052,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413034,425007312,15281735,427965,1,'2007-09-14 21:20:09',3310491433,1),(51413035,425007818,15280190,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413037,425008451,15279246,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413038,425009337,15279246,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413039,425010286,15279846,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413041,425010856,15280619,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413042,425011678,15281134,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413043,425012754,15281048,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413044,425014273,15280361,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413047,425015791,15279761,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413048,425016930,15279761,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413050,425018512,15281820,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413052,425019398,15282936,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413053,425019968,15283623,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413054,425021233,15283537,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413055,425021676,15282679,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413057,425021486,15280962,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413058,425019272,15278816,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413060,425017500,15277529,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413061,425015348,15276413,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413063,425013703,15275469,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413065,425012374,15273409,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413066,425010856,15270062,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413067,425008324,15264311,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413068,425007059,15260964,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413071,425004085,15258389,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413072,425003135,15256157,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413073,425003072,15254784,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413074,425003705,15253926,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413075,425004464,15253582,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413078,425005224,15254269,427965,1,'2007-09-14 21:20:09',3310491427,1),(51413079,425007692,15257187,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413082,425011045,15260964,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413083,425012817,15262852,427965,1,'2007-09-14 21:22:31',3310491430,1),(51413084,425014716,15263195,427965,1,'2007-09-14 21:22:31',3310491430,1),(51413085,425016614,15263539,427965,1,'2007-09-14 21:22:31',3310491430,1),(51413086,425017753,15264826,427965,1,'2007-09-14 21:22:31',3310491430,1),(51413087,425019019,15266628,427965,1,'2007-09-14 21:22:31',3310491430,1),(51413090,425019715,15267401,427965,1,'2007-09-14 21:22:31',3310491430,1),(51413091,425020347,15267229,427965,1,'2007-09-14 21:22:31',3310491430,1),(51413093,425020664,15266113,427965,1,'2007-09-14 21:22:31',3310491430,1),(51413094,425020664,15265598,427965,1,'2007-09-14 21:22:31',3310491430,1),(51413096,425018512,15262938,427965,1,'2007-09-14 21:22:31',3310491430,1),(51413097,425015095,15258732,427965,1,'2007-09-14 21:22:31',3310491430,1),(51413099,425012374,15254526,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413100,425008198,15246802,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413103,425005160,15241223,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413104,425001617,15237704,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413411,424996048,15311003,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413412,424991935,15307827,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413826,424977443,15275212,427965,1,'2007-09-14 21:22:30',3310491432,1),(51413827,424981683,15280018,427965,1,'2007-09-14 21:22:30',3310491432,1),(51413832,424984594,15283451,427965,1,'2007-09-14 21:22:30',3310491432,1),(51413833,424985859,15286884,427965,1,'2007-09-14 21:22:30',3310491433,1),(51413835,424986492,15288859,427965,1,'2007-09-14 21:22:30',3310491433,1),(51413854,424991618,15306883,427965,1,'2007-09-14 21:22:31',3310491433,1),(51414015,425027498,15348425,258874,1,'2008-10-11 17:23:03',3310491438,2),(51414017,425026802,15345593,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414018,425026992,15342846,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414019,425026928,15340786,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414020,425025536,15339413,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414021,425023511,15338211,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414022,425019651,15334177,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414023,425018765,15332546,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414024,425018006,15331259,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414025,425017120,15331173,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414027,425016614,15331946,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414028,425016741,15333061,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414030,425017880,15335550,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414031,425019651,15338383,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414032,425021044,15340271,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414033,425021486,15341387,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414034,425021613,15342760,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414036,425021297,15343275,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414040,425020158,15343275,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414041,425018133,15340958,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414044,425014652,15338555,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414045,425011995,15336151,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414046,425011172,15334263,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414049,425011045,15332375,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414050,425010919,15331001,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414051,425010539,15330143,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414052,425009590,15329971,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414053,425008894,15330486,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414054,425008831,15331946,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414055,425009527,15335293,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414056,425010286,15339241,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414057,425010919,15340615,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414060,425012627,15342674,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414061,425015791,15345679,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414062,425016994,15346623,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414063,425017437,15347481,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414064,425017437,15348253,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414065,425017120,15349026,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414067,425016361,15349026,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414069,425014969,15348168,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414070,425012184,15345335,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414072,425009463,15343018,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414074,425004717,15337868,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414076,425003009,15333319,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414077,425002376,15330830,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414078,425001996,15328427,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414079,425003135,15324307,427965,1,'2007-09-14 21:22:31',3310491433,1),(51414082,425004401,15319758,427965,1,'2007-09-14 21:22:31',3310491433,1),(51414083,425005477,15317784,427965,1,'2007-09-14 21:22:31',3310491433,1),(51414084,425006995,15316668,427965,1,'2007-09-14 21:22:31',3310491433,1),(51414085,425007059,15315809,427965,1,'2007-09-14 21:22:31',3310491433,1),(51414087,425006995,15314865,427965,1,'2007-09-14 21:22:31',3310491433,1),(51414089,425006173,15314350,427965,1,'2007-09-14 21:22:31',3310491433,1),(51414090,425003642,15314608,427965,1,'2007-09-14 21:22:31',3310491433,1),(51414091,425000984,15314436,427965,1,'2007-09-14 21:22:31',3310491433,1),(51414092,424998769,15313149,427965,1,'2007-09-14 21:22:31',3310491433,1),(51414167,425030725,15363617,258874,1,'2008-10-11 17:23:03',3310491438,2),(51414169,425029966,15358124,258874,1,'2008-10-11 17:23:03',3310491438,2),(51414257,425051670,15487213,258874,1,'2008-10-11 17:23:02',3310491527,2),(51414258,425052492,15482407,258874,1,'2008-10-11 17:23:02',3310491527,2),(51414259,425054960,15475283,258874,1,'2008-10-11 17:23:02',3310491527,2),(51414262,425060465,15462408,258874,1,'2008-10-11 17:23:02',3310491527,2),(51414263,425061098,15458546,258874,1,'2008-10-11 17:23:02',3310491527,2),(51414264,425061920,15449190,258874,1,'2008-10-11 17:23:02',3310491527,2),(51414266,425061477,15441895,258874,1,'2008-10-11 17:23:02',3310491527,2),(51414267,425060655,15437174,258874,1,'2008-10-11 17:23:02',3310491527,2),(51414269,425058567,15431252,258874,1,'2008-10-11 17:23:02',3310491525,2),(51414270,425056922,15426359,258874,1,'2008-10-11 17:23:02',3310491525,2),(51414271,425055783,15419407,258874,1,'2008-10-11 17:23:02',3310491525,2),(51414273,425054897,15410824,258874,1,'2008-10-11 17:23:02',3310491525,2),(51414274,425053758,15406447,258874,1,'2008-10-11 17:23:03',3310491525,2),(51414276,425050341,15402842,258874,1,'2008-10-11 17:23:03',3310491525,2),(51414277,425043697,15397606,258874,1,'2008-10-11 17:23:03',3310491525,2),(51414278,425040976,15395975,258874,1,'2008-10-11 17:23:03',3310491525,2),(51414279,425040280,15394430,258874,1,'2008-10-11 17:23:03',3310491525,2),(51414280,425039331,15391598,258874,1,'2008-10-11 17:23:03',3310491524,2),(51414283,425038192,15389624,258874,1,'2008-10-11 17:23:03',3310491524,2),(51414284,425035091,15387049,258874,1,'2008-10-11 17:23:03',3310491524,2),(51414285,425034016,15385161,258874,1,'2008-10-11 17:23:03',3310491524,2),(51414286,425033509,15382500,258874,1,'2008-10-11 17:23:03',3310491524,2),(51414288,425033509,15379152,258874,1,'2008-10-11 17:23:03',3310491438,2),(51414289,425033826,15377093,258874,1,'2008-10-11 17:23:03',3310491438,2),(51414290,425032687,15372458,258874,1,'2008-10-11 17:23:03',3310491438,2),(51414414,425048190,15385761,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414415,425051353,15388851,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414416,425052872,15391770,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414417,425054011,15394259,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414418,425054264,15396061,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414419,425054137,15397005,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414420,425053505,15397005,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414421,425052176,15396233,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414422,425051227,15394001,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414423,425050594,15392714,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414424,425050088,15391684,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414425,425049265,15391598,427965,1,'2007-09-14 21:23:23',3310491525,1),(51414426,425048822,15392971,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414428,425049518,15396748,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414429,425050784,15399494,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414430,425053631,15401640,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414431,425054960,15402928,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414432,425054580,15404644,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414433,425053441,15404644,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414434,425052366,15403700,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414436,425048949,15400696,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414437,425048443,15399323,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414438,425047810,15397778,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414439,425046987,15397949,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414440,425046291,15399494,258874,1,'2008-10-11 17:23:03',3310491525,2),(51415013,425099898,15480136,2895121,1,'2009-10-19 19:18:49',3310491539,4),(51415016,425099062,15482922,258874,1,'2008-10-11 17:21:48',3310491539,2),(51415017,425097859,15483866,258874,1,'2008-10-11 17:21:48',3310491539,2),(51415018,425095645,15484467,258874,1,'2008-10-11 17:21:48',3310491539,2),(51415019,425092734,15484724,258874,1,'2008-10-11 17:21:48',3310491538,2),(51415021,425089191,15484638,258874,1,'2008-10-11 17:21:48',3310491538,2),(51415023,425085774,15483952,258874,1,'2008-10-11 17:21:48',3310491538,2),(51415024,425081978,15483952,258874,1,'2008-10-11 17:21:48',3310491538,2),(51415026,425077865,15484982,258874,1,'2008-10-11 17:21:48',3310491538,2),(51415027,425072550,15488587,258874,1,'2008-10-11 17:21:48',3310491538,2),(51415028,425065907,15492191,258874,1,'2008-10-11 17:21:48',3310491533,2),(51415030,425065021,15493393,258874,1,'2008-10-11 17:21:48',3310491533,2),(51415032,425064894,15494251,258874,1,'2008-10-11 17:21:48',3310491533,2),(51415033,425066033,15495196,258874,1,'2008-10-11 17:21:49',3310491533,2),(51415034,425067172,15495281,258874,1,'2008-10-11 17:21:49',3310491533,2),(51415035,425077043,15493050,258874,1,'2008-10-11 17:21:49',3310491544,2),(51415036,425078561,15492706,258874,1,'2008-10-11 17:21:49',3310491544,2),(51415039,425078941,15493565,258874,1,'2008-10-11 17:21:49',3310491544,2),(51415041,425078878,15494681,258874,1,'2008-10-11 17:21:49',3310491544,2),(51415042,425077486,15496054,258874,1,'2008-10-11 17:21:49',3310491544,2),(51415045,425074449,15498028,258874,1,'2008-10-11 17:21:49',3310491544,2),(51415046,425068627,15501461,258874,1,'2008-10-11 17:21:49',3310491544,2),(51415047,425060022,15507298,258874,1,'2008-10-11 17:21:49',3310491533,2),(51415048,425055276,15509615,258874,1,'2008-10-11 17:21:49',3310491533,2),(51415049,425050594,15511418,258874,1,'2008-10-11 17:21:49',3310491533,2),(51415050,425049518,15512791,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415051,425047683,15515366,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415052,425046418,15518112,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415053,425044583,15520172,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415055,425040849,15522747,258874,1,'2008-10-11 17:23:02',3310491533,3),(51415057,425040407,15521717,258874,1,'2008-10-11 17:23:02',3310491533,2),(51415059,425039964,15518885,258874,1,'2008-10-11 17:23:02',3310491532,2),(51415060,425040596,15515623,258874,1,'2008-10-11 17:23:02',3310491533,2),(51415061,425041735,15511332,258874,1,'2008-10-11 17:23:02',3310491533,2),(51415062,425043254,15507040,258874,1,'2008-10-11 17:23:02',3310491533,2),(51415066,425045532,15501290,258874,1,'2008-10-11 17:23:02',3310491533,2),(51415068,425048190,15495968,258874,1,'2008-10-11 17:23:02',3310491533,2),(51415069,425050341,15490647,258874,1,'2008-10-11 17:23:02',3310491527,2),(51415249,425040027,15523863,258874,1,'2008-10-11 17:21:50',3310491532,2),(51415251,425040090,15525065,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415253,425040660,15525837,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415255,425041419,15526009,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415257,425043254,15525580,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415258,425047810,15522490,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415781,425049708,15521889,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415783,425051860,15520773,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415785,425054770,15520516,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415788,425057428,15520001,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415790,425060402,15519571,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415795,425068311,15517855,258874,1,'2008-10-11 17:21:50',3310491544,2),(51415796,425075018,15517082,258874,1,'2008-10-11 17:21:50',3310491544,2),(51415798,425082358,15518112,258874,1,'2008-10-11 17:21:50',3310491544,2),(51416264,425064072,15504465,258874,1,'2008-10-11 17:21:49',3310491533,2),(51416291,425085711,15499573,427965,1,'2007-09-14 21:27:14',3310491544,1),(51416292,425086217,15500088,427965,1,'2007-09-14 21:27:14',3310491544,1),(51416294,425087673,15501290,427965,1,'2007-09-14 21:27:14',3310491544,1),(51416297,425088685,15503092,427965,1,'2007-09-14 21:27:14',3310491544,1),(51416298,425091595,15506268,427965,1,'2007-09-14 21:27:14',3310491544,1),(51416299,425090330,15507555,427965,1,'2007-09-14 21:27:14',3310491544,1),(51416340,425084193,15519142,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416343,425085521,15521631,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416345,425087293,15524635,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416349,425089001,15526180,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416351,425092798,15528155,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416352,425094316,15528841,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416353,425095392,15528841,427965,1,'2007-09-14 21:27:15',3310491545,1),(51416354,425095961,15527897,427965,1,'2007-09-14 21:27:15',3310491545,1),(51416356,425095012,15526438,427965,1,'2007-09-14 21:27:15',3310491545,1),(51416357,425092228,15524292,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416359,425090520,15522404,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416361,425089444,15519486,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416364,425088622,15517082,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416365,425087989,15515537,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416366,425086660,15514336,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416367,425082294,15512448,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416370,425078941,15511418,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416371,425076916,15511332,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416372,425076347,15510731,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416375,425076284,15510130,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416376,425076537,15509358,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416379,425077802,15509186,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416380,425080143,15509100,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416381,425084762,15509358,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416382,425088558,15510388,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416727,425083244,15519314,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416729,425083560,15521717,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416731,425084193,15523777,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416732,425085711,15526524,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416733,425088432,15530472,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416734,425091279,15533390,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416735,425093051,15534592,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416736,425093747,15535879,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416737,425093367,15537853,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416739,425092734,15538712,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416740,425091406,15538540,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416741,425089887,15537167,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416743,425088305,15536137,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416744,425087040,15534764,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416746,425084636,15532789,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416747,425082927,15530644,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416748,425081725,15528240,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416749,425080143,15527382,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416750,425079194,15528069,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416753,425078941,15529099,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416754,425079131,15530129,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416755,425081788,15534077,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416756,425085332,15539913,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416757,425086977,15543947,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416758,425087609,15546951,258874,1,'2008-10-11 17:21:52',3310491546,2),(51416760,425087040,15551071,258874,1,'2008-10-11 17:21:52',3310491546,2),(51416761,425087483,15555706,258874,1,'2008-10-11 17:21:52',3310491546,2),(51416762,425088622,15558968,258874,1,'2008-10-11 17:21:52',3310491546,2),(51416763,425090963,15560684,258874,1,'2008-10-11 17:21:52',3310491546,2),(51416764,425093873,15560513,258874,1,'2008-10-11 17:21:52',3310491546,2),(51416765,425097480,15561028,258874,1,'2008-10-11 17:21:52',3310491547,2),(51416767,425101023,15564118,258874,1,'2008-10-11 17:21:52',3310491547,2),(51416768,425103807,15565748,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416769,425106021,15566693,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416770,425108932,15568066,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416771,425111463,15569525,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416772,425112412,15570383,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416774,425112412,15571585,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416775,425112222,15572958,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416776,425111146,15573902,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416779,425109501,15574074,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416780,425106907,15574331,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416781,425104882,15573559,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416782,425103174,15572615,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416783,425100833,15570383,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416785,425099631,15570040,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416786,425098935,15570641,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416787,425098682,15571757,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416789,425099188,15573216,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416790,425101213,15575018,258874,1,'2008-10-11 17:21:53',3310491547,2),(51417251,425104819,15578194,258874,1,'2008-10-11 17:21:53',3310491547,2),(51417252,425110324,15583172,258874,1,'2008-10-11 17:21:53',3310491547,2),(51417253,425115259,15585747,258874,1,'2008-10-11 17:21:53',3310491547,2),(51417260,425120320,15587378,258874,1,'2008-10-11 17:21:53',3310491547,2),(51417263,425125192,15587807,258874,1,'2008-10-11 17:21:53',3310491550,2),(51417265,425127912,15589438,258874,1,'2008-10-11 17:21:53',3310491550,2),(51417268,425131202,15592871,258874,1,'2008-10-11 17:21:53',3310491550,2),(51417269,425134556,15596819,258874,1,'2008-10-11 17:21:53',3310491550,2),(51417272,425136390,15599480,258874,1,'2008-10-11 17:21:53',3310491550,2),(51417275,425136390,15600939,258874,1,'2008-10-11 17:21:53',3310491572,2),(51417277,425135315,15601540,258874,1,'2008-10-11 17:21:53',3310491572,2),(51417284,425133796,15600252,258874,1,'2008-10-11 17:21:53',3310491550,2),(51417285,425131898,15597677,258874,1,'2008-10-11 17:21:53',3310491550,2),(51417288,425129494,15595188,258874,1,'2008-10-11 17:21:53',3310491550,2),(51417289,425126900,15594673,258874,1,'2008-10-11 17:21:53',3310491550,2),(51417291,425122092,15595789,258874,1,'2008-10-11 17:21:54',3310491547,2),(51417294,425117410,15596819,258874,1,'2008-10-11 17:21:54',3310491547,2),(51417298,425113234,15596647,258874,1,'2008-10-11 17:21:54',3310491547,2),(51417398,425122661,15595617,258874,1,'2008-10-11 17:21:54',3310491550,2),(51417410,425093114,15576821,427965,1,'2007-09-14 21:29:02',3310491546,1),(51417414,425095329,15577336,427965,1,'2007-09-14 21:29:02',3310491547,1),(51417416,425097416,15579567,427965,1,'2007-09-14 21:29:02',3310491547,1),(51417419,425099188,15583000,427965,1,'2007-09-14 21:29:02',3310491547,1),(51417420,425101972,15585575,427965,1,'2007-09-14 21:29:02',3310491547,1),(51417421,425106717,15589352,427965,1,'2007-09-14 21:29:02',3310491547,1),(51417467,425089191,15584459,427965,1,'2007-09-14 21:29:01',3310491546,1),(51417468,425091342,15582485,427965,1,'2007-09-14 21:29:01',3310491546,1),(51417469,425093177,15581455,427965,1,'2007-09-14 21:29:01',3310491546,1),(51417472,425094443,15581284,427965,1,'2007-09-14 21:29:01',3310491546,1),(51417476,425095708,15582485,427965,1,'2007-09-14 21:29:01',3310491547,1),(51417481,425097290,15585232,427965,1,'2007-09-14 21:29:01',3310491547,1),(51417482,425098302,15586949,427965,1,'2007-09-14 21:29:01',3310491547,1),(51417484,425100200,15587893,427965,1,'2007-09-14 21:29:01',3310491547,1),(51417488,425103744,15586949,427965,1,'2007-09-14 21:29:01',3310491547,1),(51420037,425107856,15595446,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420038,425104819,15594931,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420040,425102794,15594588,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420042,425101086,15595102,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420044,425099441,15595188,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420045,425098239,15594158,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420046,425096974,15593729,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420048,425095961,15593729,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420050,425095012,15594588,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420052,425094949,15595188,258874,1,'2008-10-11 17:21:54',3310491546,2),(51420054,425095392,15596390,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420057,425096657,15596905,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420058,425105452,15599823,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420059,425114436,15603771,258874,1,'2008-10-11 17:21:54',3310491569,2),(51420061,425119688,15606003,258874,1,'2008-10-11 17:21:54',3310491569,2),(51420063,425121206,15607720,258874,1,'2008-10-11 17:21:54',3310491569,2),(51420066,425121522,15608750,258874,1,'2008-10-11 17:21:54',3310491569,2),(51420067,425121143,15612354,258874,1,'2008-10-11 17:21:54',3310491569,2),(51420068,425119434,15619478,258874,1,'2008-10-11 17:21:54',3310491569,2),(51420072,425118675,15621624,258874,1,'2008-10-11 17:21:54',3310491569,2),(51420073,425117283,15623169,258874,1,'2008-10-11 17:21:54',3310491569,2);
INSERT INTO `current_nodes` VALUES (51420076,425115828,15624113,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420078,425112981,15626774,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420079,425112158,15628147,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420081,425111526,15630722,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420084,425111589,15633898,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420451,425111589,15635357,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420452,425111399,15636559,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420453,425110450,15638361,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420454,425108426,15640164,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420456,425107666,15641279,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420457,425107160,15645142,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420458,425107350,15648833,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420461,425108362,15650721,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420462,425109375,15651407,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420464,425111083,15651407,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420465,425112854,15650807,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420466,425114942,15648833,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420467,425116777,15647631,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420469,425118422,15647288,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420471,425122282,15648318,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420474,425127406,15650721,258874,1,'2008-10-11 17:21:55',3310491572,2),(51420475,425129494,15652180,258874,1,'2008-10-11 17:21:55',3310491572,2),(51420476,425131708,15652523,258874,1,'2008-10-11 17:21:55',3310491572,2),(51420477,425133733,15652008,258874,1,'2008-10-11 17:21:55',3310491572,2),(51420893,425136074,15651407,258874,1,'2008-10-11 17:21:56',3310491572,2),(51420894,425138541,15651751,258874,1,'2008-10-11 17:21:56',3310491572,2),(51420895,425142084,15653897,258874,1,'2008-10-11 17:21:56',3310491572,2),(51420896,425146829,15658188,258874,1,'2008-10-11 17:21:56',3310491574,2),(51420899,425148917,15660162,258874,1,'2008-10-11 17:21:56',3310491574,2),(51420900,425149550,15661364,258874,1,'2008-10-11 17:21:56',3310491574,2),(51420902,425150435,15662651,258874,1,'2008-10-11 17:21:56',3310491575,2),(51420906,425151384,15663252,258874,1,'2008-10-11 17:21:56',3310491575,2),(51420908,425152207,15662394,258874,1,'2008-10-11 17:21:56',3310491575,2),(51420910,425152207,15661535,258874,1,'2008-10-11 17:21:56',3310491575,2),(51420912,425152333,15660591,258874,1,'2008-10-11 17:21:56',3310491575,2),(51420914,425152017,15658875,258874,1,'2008-10-11 17:21:56',3310491575,2),(51420916,425151131,15655527,258874,1,'2008-10-11 17:21:56',3310491573,2),(51420919,425150246,15653210,258874,1,'2008-10-11 17:21:56',3310491573,2),(51420921,425149233,15651751,258874,1,'2008-10-11 17:21:56',3310491572,2),(51420922,425148411,15650034,258874,1,'2008-10-11 17:21:56',3310491572,2),(51420926,425148411,15648833,258874,1,'2008-10-11 17:21:57',3310491572,2),(51420928,425148980,15646858,258874,1,'2008-10-11 17:21:57',3310491572,2),(51420929,425149929,15646858,258874,1,'2008-10-11 17:21:57',3310491573,2),(51420932,425150562,15648318,258874,1,'2008-10-11 17:21:57',3310491573,2),(51420933,425150562,15649347,258874,1,'2008-10-11 17:21:57',3310491573,2),(51420935,425151195,15650892,258874,1,'2008-10-11 17:21:57',3310491573,2),(51420938,425151954,15652094,258874,1,'2008-10-11 17:21:57',3310491573,2),(51420939,425153852,15654926,258874,1,'2008-10-11 17:21:57',3310491573,2),(51420940,425156635,15659733,258874,1,'2008-10-11 17:21:57',3310491575,2),(51420942,425159925,15668402,258874,1,'2008-10-11 17:21:57',3310491575,2),(51420945,425163911,15679474,258874,1,'2008-10-11 17:21:57',3310491575,2),(51420946,425168213,15688658,258874,1,'2008-10-11 17:21:57',3310491575,2),(51420950,425171629,15695439,258874,1,'2008-10-11 17:21:57',3310491575,2),(51420951,425173211,15699902,258874,1,'2008-10-11 17:21:57',3310491575,2),(51420952,425173907,15704107,258874,1,'2008-10-11 17:21:57',3310491575,2),(51420955,425173907,15707283,258874,1,'2008-10-11 17:21:57',3310491575,2),(51420956,425174096,15710287,258874,1,'2008-10-11 17:21:57',3310491575,2),(51420957,425174919,15711832,258874,1,'2008-10-11 17:21:57',3310491581,2),(51420958,425176311,15711575,427965,1,'2007-09-14 21:33:37',3310491581,1),(51420961,425177007,15710716,427965,1,'2007-09-14 21:33:37',3310491581,1),(51420964,425177196,15709515,427965,1,'2007-09-14 21:33:37',3310491575,1),(51420967,425177196,15708142,427965,1,'2007-09-14 21:33:37',3310491575,1),(51420968,425176627,15704880,427965,1,'2007-09-14 21:33:37',3310491575,1),(51420969,425174982,15689602,427965,1,'2007-09-14 21:33:37',3310491575,1),(51420970,425174160,15684023,427965,1,'2007-09-14 21:33:37',3310491575,1),(51421275,424981620,15272207,427965,1,'2007-09-14 21:36:14',3310491432,1),(51421278,424985543,15278645,427965,1,'2007-09-14 21:36:14',3310491433,1),(51421280,424988138,15284138,427965,1,'2007-09-14 21:36:14',3310491433,1),(51421281,424988834,15286627,427965,1,'2007-09-14 21:36:14',3310491433,1),(51421284,424988201,15287743,427965,1,'2007-09-14 21:36:14',3310491433,1),(51421287,424985543,15290661,427965,1,'2007-09-14 21:36:14',3310491433,1),(51421289,424984277,15293579,427965,1,'2007-09-14 21:36:14',3310491432,1),(51421291,424983265,15297098,427965,1,'2007-09-14 21:36:14',3310491432,1),(51421294,424983391,15300703,427965,1,'2007-09-14 21:36:14',3310491432,1),(51421295,424984341,15303106,427965,1,'2007-09-14 21:36:14',3310491432,1),(51421296,424986302,15304651,427965,1,'2007-09-14 21:36:14',3310491433,1),(51421297,424989783,15306196,427965,1,'2007-09-14 21:36:14',3310491433,1),(51438191,425034634,15118277,434787,1,'2007-09-15 15:11:13',3310491406,1),(51438193,425031766,15121021,427965,1,'2007-09-14 22:01:04',3310491406,1),(51438194,425036892,15131063,427965,1,'2007-09-14 22:01:04',3310491406,1),(51438195,425039610,15128839,434787,1,'2007-09-15 15:11:13',3310491406,1),(51438631,425050895,15141671,697263,1,'2009-01-01 16:45:34',3310491407,4),(51438632,425045118,15136042,697263,1,'2009-01-01 16:45:34',3310491407,4),(51438634,425041973,15130428,697263,1,'2009-01-01 16:43:56',3310491407,4),(51438635,425037734,15123218,697263,1,'2009-01-01 16:43:56',3310491406,3),(51438636,425026091,15097469,697263,1,'2009-01-01 16:43:56',3310491404,3),(51438638,425023749,15088971,697263,1,'2009-01-01 16:43:56',3310491404,3),(51438639,425023180,15087083,697263,1,'2009-01-01 16:43:56',3310491404,3),(51438642,425022737,15086397,697263,1,'2009-01-01 16:43:56',3310491404,3),(51438643,425022168,15086826,697263,1,'2009-01-01 16:43:56',3310491404,3),(51438645,425022104,15087770,697263,1,'2009-01-01 16:43:56',3310491404,3),(51438646,425021768,15089951,697263,1,'2009-01-01 16:43:57',3310491404,2),(51438647,425021642,15094671,697263,1,'2009-01-01 16:43:57',3310491404,2),(51438648,425020376,15100164,697263,1,'2009-01-01 16:43:57',3310491404,2),(51438650,425019763,15101503,697263,1,'2009-01-01 16:43:57',3310491404,4),(51438651,425018687,15102104,697263,1,'2009-01-01 16:43:57',3310491404,4),(51438652,425018307,15101503,697263,1,'2009-01-01 16:43:57',3310491404,3),(51438654,425018181,15100559,697263,1,'2009-01-01 16:43:57',3310491404,3),(51438655,425018307,15098928,697263,1,'2009-01-01 16:43:57',3310491404,3),(51438656,425018940,15094379,697263,1,'2009-01-01 16:43:57',3310491404,3),(51438658,425019004,15091632,697263,1,'2009-01-01 16:43:58',3310491404,3),(51438659,425019193,15089658,697263,1,'2009-01-01 16:43:58',3310491404,3),(51438660,425018624,15088714,697263,1,'2009-01-01 16:43:58',3310491404,4),(51438661,425017548,15090774,697263,1,'2009-01-01 16:43:58',3310491404,4),(51438662,425016409,15093950,697263,1,'2009-01-01 16:43:58',3310491404,4),(51438663,425014744,15096388,697263,1,'2009-01-01 16:43:58',3310491404,2),(51438665,425012865,15100559,697263,1,'2009-01-01 16:43:58',3310491404,3),(51438666,425010524,15102876,697263,1,'2009-01-01 16:43:58',3310491401,3),(51438812,425019257,15102189,697263,1,'2009-01-01 16:43:57',3310491404,4),(51439215,424973694,15026229,592895,1,'2008-07-25 23:03:57',3310491394,2),(51439216,424956588,15041628,427965,1,'2007-09-14 22:02:35',3310491223,1),(51439552,424999703,15079273,592895,1,'2008-07-25 23:00:37',3310491401,2),(51439943,424934691,14952965,427965,1,'2007-09-14 22:03:20',3310491221,1),(51439944,424930577,14956570,427965,1,'2007-09-14 22:03:20',3310491221,1),(51439947,424927855,14958887,427965,1,'2007-09-14 22:03:20',3310491220,1),(51439949,424926463,14959488,427965,1,'2007-09-14 22:03:20',3310491220,1),(51439951,424925387,14959402,427965,1,'2007-09-14 22:03:20',3310491220,1),(51439953,424924185,14957685,427965,1,'2007-09-14 22:03:20',3310491220,1),(51439955,424923235,14956656,427965,1,'2007-09-14 22:03:20',3310491220,1),(51439959,424922033,14956656,427965,1,'2007-09-14 22:03:20',3310491220,1),(51439960,424921590,14957256,427965,1,'2007-09-14 22:03:20',3310491220,1),(51439962,424921400,14959745,427965,1,'2007-09-14 22:03:20',3310491220,1),(51439964,424922982,14962749,427965,1,'2007-09-14 22:03:20',3310491220,1),(51439967,424926083,14967985,427965,1,'2007-09-14 22:03:20',3310491220,1),(51440235,424982344,15092182,427965,1,'2007-09-14 22:03:39',3310491400,1),(51440320,425004639,15090259,592895,1,'2008-07-25 23:00:36',3310491401,2),(51440321,425002361,15085109,592895,1,'2008-07-25 23:00:36',3310491401,2),(51440620,424991520,15093384,427965,1,'2007-09-14 22:04:01',3310491401,1),(51440622,425001855,15083993,592895,1,'2008-07-25 23:00:36',3310491401,2),(51441228,425069732,15190029,427965,1,'2007-09-14 22:10:36',3310491440,1),(51441229,425064986,15184278,427965,1,'2007-09-14 22:10:36',3310491429,1),(51441230,425061000,15179987,427965,1,'2007-09-14 22:10:36',3310491429,1),(51441232,425060494,15178013,427965,1,'2007-09-14 22:10:36',3310491429,1),(51441233,425059734,15174065,427965,1,'2007-09-14 22:10:36',3310491429,1),(51441235,425058912,15170288,427965,1,'2007-09-14 22:04:53',3310491429,1),(51441237,425057773,15167370,427965,1,'2007-09-14 22:10:36',3310491429,1),(51441239,425054483,15161533,427965,1,'2007-09-14 22:10:36',3310491429,1),(51441242,425052901,15155439,427965,1,'2007-09-14 22:10:36',3310491407,1),(51441244,425051888,15152521,427965,1,'2007-09-14 22:10:36',3310491407,1),(51441246,425050623,15150547,427965,1,'2007-09-14 22:10:36',3310491407,1),(51441249,425048345,15149517,427965,1,'2007-09-14 22:10:36',3310491407,1),(51441250,425045624,15148573,427965,1,'2007-09-14 22:10:36',3310491407,1),(51441254,425043662,15146770,427965,1,'2007-09-14 22:10:36',3310491407,1),(51441258,425036449,15138874,427965,1,'2007-09-14 22:10:36',3310491406,1),(51441261,425032905,15135269,427965,1,'2007-09-14 22:10:36',3310491406,1),(51441262,425030058,15133896,427965,1,'2007-09-14 22:10:36',3310491406,1),(51441263,425027716,15131149,427965,1,'2007-09-14 22:10:36',3310491406,1),(51441266,425024046,15126514,427965,1,'2007-09-14 22:10:36',3310491406,1),(51441267,425014491,15113297,427965,1,'2007-09-14 22:10:36',3310491406,1),(51441269,425011960,15107803,427965,1,'2007-09-14 22:10:36',3310491403,1),(51441361,425067770,15182562,427965,1,'2007-09-14 22:05:47',3310491440,1),(51441364,425068973,15186338,427965,1,'2007-09-14 22:05:47',3310491440,1),(51441603,425086373,15281868,427965,1,'2007-09-14 22:10:36',3310491448,1),(51441607,425083842,15277061,427965,1,'2007-09-14 22:10:36',3310491448,1),(51441610,425083082,15273457,427965,1,'2007-09-14 22:10:36',3310491448,1),(51441611,425082829,15267706,427965,1,'2007-09-14 22:10:36',3310491442,1),(51441615,425081690,15260239,427965,1,'2007-09-14 22:10:36',3310491442,1),(51441616,425081058,15255346,427965,1,'2007-09-14 22:10:36',3310491442,1),(51441619,425078843,15247707,427965,1,'2007-09-14 22:11:20',3310491442,1),(51441621,425077787,15240634,592895,1,'2008-07-25 23:51:05',3310491442,2),(51441623,425077471,15233768,592895,1,'2008-07-25 23:51:05',3310491442,2),(51441625,425076502,15228825,427965,1,'2007-09-14 22:10:36',3310491442,1),(51441626,425075539,15223711,978767,1,'2009-04-26 22:36:08',3310491442,3),(51441629,425074351,15215178,427965,1,'2007-09-14 22:10:36',3310491440,1),(51441630,425073971,15206337,427965,1,'2007-09-14 22:10:36',3310491440,1),(51441632,425073971,15202303,427965,1,'2007-09-14 22:10:36',3310491440,1),(51441635,425073212,15198355,427965,1,'2007-09-14 22:10:36',3310491440,1),(51441636,425071883,15194149,427965,1,'2007-09-14 22:10:36',3310491440,1),(51441659,425088144,15284958,427965,1,'2007-09-14 22:10:36',3310491448,1),(51441848,425060766,15148967,697263,1,'2009-01-01 16:45:34',3310491407,4),(51441849,425061589,15150598,592895,1,'2008-07-26 00:12:08',3310491407,2),(51441850,425063677,15158065,592895,1,'2008-07-26 00:12:28',3310491407,3),(51441852,425063911,15161619,427965,1,'2007-09-14 22:05:47',3310491429,1),(51441853,425065385,15170339,592895,1,'2008-07-26 00:12:56',3310491429,2),(51441855,425066018,15175746,592895,1,'2008-07-26 00:12:56',3310491429,2),(51441857,425066631,15180159,427965,1,'2007-09-14 22:05:47',3310491429,1),(51442041,424944817,14981890,592895,1,'2008-07-25 22:14:49',3310491221,2),(51442271,424944627,14986954,592895,1,'2008-07-25 22:14:49',3310491221,2),(51442273,424945893,14987812,592895,1,'2008-07-25 22:14:49',3310491221,2),(51442278,424943804,14985237,592895,1,'2008-07-25 22:14:49',3310491221,2),(51442280,424943614,14983520,592895,1,'2008-07-25 22:14:49',3310491221,2),(51442282,424944058,14982576,592895,1,'2008-07-25 22:14:49',3310491221,2),(51442349,424944058,14985752,592895,1,'2008-07-25 22:14:49',3310491221,2),(51442351,424942855,14988670,427965,1,'2007-09-14 22:06:39',3310491221,1),(51442352,424942095,14992533,427965,1,'2007-09-14 22:06:39',3310491221,1),(51442529,424971163,15009235,592895,1,'2008-07-25 23:09:45',3310491394,2),(51442532,424976162,15021079,592895,1,'2008-07-25 23:09:45',3310491394,2),(51442533,424972808,15024598,592895,1,'2008-07-25 23:03:57',3310491394,2),(51442648,424960828,15025406,427965,1,'2007-09-14 22:07:10',3310491394,1),(51442649,424961144,15022230,427965,1,'2007-09-14 22:07:10',3310491394,1),(51442651,424965194,15019655,427965,1,'2007-09-14 22:07:10',3310491394,1),(51442653,424968821,15016445,592895,1,'2008-07-25 23:05:42',3310491394,2),(51442942,425045624,15270624,427965,1,'2007-09-14 22:07:46',3310491431,1),(51442943,425045244,15273199,427965,1,'2007-09-14 22:07:46',3310491437,1),(51442944,425045877,15275602,427965,1,'2007-09-14 22:07:46',3310491437,1),(51442946,425046320,15277147,427965,1,'2007-09-14 22:07:46',3310491437,1),(51442947,425047459,15277576,427965,1,'2007-09-14 22:07:46',3310491437,1),(51442949,425048092,15276031,427965,1,'2007-09-14 22:07:46',3310491437,1),(51442951,425048218,15274401,427965,1,'2007-09-14 22:07:46',3310491437,1),(51442952,425048408,15271826,427965,1,'2007-09-14 22:07:46',3310491437,1),(51442953,425049294,15268049,427965,1,'2007-09-14 22:07:46',3310491431,1),(51442955,425049294,15266418,427965,1,'2007-09-14 22:07:46',3310491431,1),(51442956,425048724,15264015,427965,1,'2007-09-14 22:07:46',3310491431,1),(51442957,425044738,15246677,427965,1,'2007-09-14 22:07:46',3310491431,1),(51442958,425044928,15243759,427965,1,'2007-09-14 22:07:46',3310491431,1),(51442959,425045751,15241528,427965,1,'2007-09-14 22:07:46',3310491431,1),(51442960,425047396,15240068,427965,1,'2007-09-14 22:07:46',3310491431,1),(51442961,425047902,15239725,840745,1,'2009-01-26 20:00:23',3310491431,4),(51443088,425051319,15231915,427965,1,'2007-09-14 22:07:53',3310491431,1),(51443089,425064480,15225992,427965,1,'2007-09-14 22:08:10',3310491431,1),(51443310,425073591,15250883,427965,1,'2007-09-14 22:08:08',3310491442,1),(51443312,425074857,15253801,427965,1,'2007-09-14 22:08:08',3310491442,1),(51443313,425077514,15257578,427965,1,'2007-09-14 22:08:08',3310491442,1),(51443314,425079602,15262384,427965,1,'2007-09-14 22:08:08',3310491442,1),(51443315,425080805,15267963,427965,1,'2007-09-14 22:08:08',3310491442,1),(51443317,425081248,15275860,427965,1,'2007-09-14 22:08:08',3310491448,1),(51443319,425081311,15281267,427965,1,'2007-09-14 22:08:08',3310491448,1),(51443662,425097066,15264616,427965,1,'2007-09-14 22:12:33',3310491443,1),(51443663,425098427,15268231,437032,1,'2008-05-13 20:39:16',3310491443,2),(51443665,425100009,15271321,437032,1,'2008-05-13 20:39:16',3310491449,2),(51443668,425102097,15275183,437032,1,'2008-05-13 20:39:16',3310491449,2),(51443669,425107475,15290032,437032,1,'2008-05-13 20:39:16',3310491449,2),(51443670,425108138,15293455,427965,1,'2007-09-14 22:12:33',3310491449,1),(51443671,425107568,15295515,427965,1,'2007-09-14 22:12:33',3310491449,1),(51443672,425105987,15296202,427965,1,'2007-09-14 22:12:33',3310491449,1),(51443673,425104152,15296373,427965,1,'2007-09-14 22:12:33',3310491449,1),(51443676,425101621,15293970,427965,1,'2007-09-14 22:12:33',3310491449,1),(51443678,425099723,15291910,427965,1,'2007-09-14 22:12:33',3310491449,1),(51443679,425097698,15290194,427965,1,'2007-09-14 22:12:33',3310491449,1),(51443680,425096116,15287876,427965,1,'2007-09-14 22:12:33',3310491449,1),(51443683,425092953,15285044,427965,1,'2007-09-14 22:12:33',3310491448,1),(51443685,425089157,15280409,427965,1,'2007-09-14 22:12:33',3310491448,1),(51443686,425087195,15278091,427965,1,'2007-09-14 22:12:33',3310491448,1),(51443687,425085993,15276031,427965,1,'2007-09-14 22:12:33',3310491448,1),(51443688,425085107,15273886,427965,1,'2007-09-14 22:12:33',3310491448,1),(51443690,425084917,15271654,427965,1,'2007-09-14 22:12:33',3310491448,1),(51443691,425084664,15267105,427965,1,'2007-09-14 22:12:33',3310491442,1),(51443692,425084221,15264187,427965,1,'2007-09-14 22:12:33',3310491442,1),(51443693,425083652,15260925,427965,1,'2007-09-14 22:12:33',3310491442,1),(51443694,425082640,15258179,427965,1,'2007-09-14 22:08:43',3310491442,1),(51443695,425081311,15257063,427965,1,'2007-09-14 22:12:33',3310491442,1),(51444358,425141733,15304613,427965,1,'2007-09-14 22:12:33',3310491452,1),(51444359,425138254,15302982,427965,1,'2007-09-14 22:12:33',3310491452,1),(51444362,425135786,15302725,427965,1,'2007-09-14 22:12:33',3310491452,1),(51444364,425132307,15303326,427965,1,'2007-09-14 22:12:33',3310491452,1),(51444365,425130029,15304527,427965,1,'2007-09-14 22:12:33',3310491452,1),(51444366,425126203,15308314,437032,1,'2008-05-13 20:27:32',3310491452,2),(51444368,425122723,15309344,437032,1,'2008-05-13 20:27:32',3310491452,2),(51444370,425121015,15309344,437032,1,'2008-05-13 20:27:32',3310491449,2),(51444371,425118990,15308228,437032,1,'2008-05-13 20:27:32',3310491449,2),(51444373,425116966,15305567,437032,1,'2008-05-13 20:27:32',3310491449,2),(51444374,425115287,15301609,427965,1,'2007-09-14 22:12:33',3310491449,1),(51444375,425114308,15297843,437032,1,'2008-05-13 20:27:32',3310491449,2),(51444377,425113136,15292253,427965,1,'2007-09-14 22:12:33',3310491449,1),(51444379,425113106,15288401,437032,1,'2008-05-13 20:27:32',3310491449,2),(51444381,425111744,15282469,427965,1,'2007-09-14 22:12:33',3310491449,1),(51444383,425108740,15274153,437032,1,'2008-05-13 20:27:32',3310491449,2),(51444384,425105514,15267888,437032,1,'2008-05-13 20:32:39',3310491443,2),(51444386,425104058,15265742,437032,1,'2008-05-13 20:32:39',3310491443,3),(51444387,425102667,15263167,437032,1,'2008-05-13 20:27:32',3310491443,2),(51444388,425101591,15259734,437032,1,'2008-05-13 20:27:32',3310491443,2),(51444391,425101115,15257235,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444392,425101907,15252696,437032,1,'2008-05-13 20:27:51',3310491443,2),(51444393,425102190,15251312,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444394,425101305,15240669,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444395,425100735,15229511,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444396,425097762,15229683,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444397,425098521,15234318,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444398,425098521,15238094,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444399,425098204,15241871,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444401,425097192,15248480,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444403,425097572,15251656,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444404,425097762,15255003,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444405,425096812,15257063,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444406,425097255,15259380,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444408,425097731,15260335,437032,1,'2008-05-13 20:34:15',3310491443,2),(51444410,425096812,15261784,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444411,425096529,15262995,437032,1,'2008-05-13 20:39:16',3310491443,2),(51444444,425106779,15269347,437032,1,'2008-05-13 20:32:39',3310491443,2),(51444468,425101211,15266257,437032,1,'2008-05-13 20:34:15',3310491443,2),(51444470,425103742,15270377,437032,1,'2008-05-13 20:34:15',3310491443,2),(51444471,425105261,15270034,437032,1,'2008-05-13 20:34:15',3310491443,2),(51444652,425092700,15227709,427965,1,'2007-09-14 22:10:22',3310491442,1),(51444653,425095484,15238266,427965,1,'2007-09-14 22:10:22',3310491443,1),(51444884,425089726,15217323,427965,1,'2007-09-14 22:10:34',3310491442,1),(51444885,425086436,15212345,427965,1,'2007-09-14 22:10:34',3310491440,1),(51444886,425082975,15216773,592895,1,'2008-07-25 23:51:45',3310491442,2),(51444888,425084051,15220035,592895,1,'2008-07-25 23:51:45',3310491442,2),(51444889,425085063,15225614,592895,1,'2008-07-25 23:51:45',3310491442,2),(51444891,425083798,15229562,592895,1,'2008-07-25 23:51:45',3310491442,2),(51444892,425082576,15232000,427965,1,'2007-09-14 22:10:22',3310491442,1),(51444894,425084095,15234489,427965,1,'2007-09-14 22:10:22',3310491442,1),(51444896,425089536,15226336,427965,1,'2007-09-14 22:10:22',3310491442,1),(51444897,425090169,15224962,427965,1,'2007-09-14 22:10:22',3310491442,1),(51444898,425090232,15223503,427965,1,'2007-09-14 22:10:22',3310491442,1),(51444899,425091118,15222473,427965,1,'2007-09-14 22:10:22',3310491442,1),(51444902,425091877,15223503,427965,1,'2007-09-14 22:10:22',3310491442,1),(51445067,425079476,15203161,427965,1,'2007-09-14 22:10:34',3310491440,1),(51445068,425077388,15201359,427965,1,'2007-09-14 22:10:34',3310491440,1),(51445069,425076312,15200586,427965,1,'2007-09-14 22:10:34',3310491440,1),(51445070,425075426,15201788,427965,1,'2007-09-14 22:10:34',3310491440,1),(51445071,425074920,15202904,427965,1,'2007-09-14 22:10:55',3310491440,1),(51445073,425073971,15203505,427965,1,'2007-09-14 22:10:34',3310491440,1),(51445113,425080931,15215693,427965,1,'2007-09-14 22:10:47',3310491440,1),(51445209,425077514,15210114,427965,1,'2007-09-14 22:10:47',3310491440,1),(51445210,425078843,15212946,427965,1,'2007-09-14 22:10:47',3310491440,1),(51445276,425074179,15191520,91018,1,'2008-06-07 20:24:45',3310491440,2),(51445277,425075869,15196209,427965,1,'2007-09-14 22:10:55',3310491440,1),(51445278,425075869,15198698,427965,1,'2007-09-14 22:10:55',3310491440,1),(51445766,425087575,15272083,427965,1,'2007-09-14 22:11:20',3310491448,1),(51445767,425087005,15263758,427965,1,'2007-09-14 22:11:20',3310491442,1),(51445769,425084095,15248566,427965,1,'2007-09-14 22:11:20',3310491442,1),(51445772,425082829,15245905,427965,1,'2007-09-14 22:11:20',3310491442,1),(51445774,425081564,15245733,427965,1,'2007-09-14 22:11:20',3310491442,1),(51445785,425087828,15278864,427965,1,'2007-09-14 22:12:33',3310491448,1),(51446293,425066378,15275259,427965,1,'2007-09-14 22:11:53',3310491437,1),(51446294,425071503,15279207,427965,1,'2007-09-14 22:11:53',3310491448,1),(51446295,425072199,15280323,427965,1,'2007-09-14 22:11:53',3310491448,1),(51446297,425072453,15281696,427965,1,'2007-09-14 22:11:53',3310491448,1),(51446298,425071630,15283499,427965,1,'2007-09-14 22:11:53',3310491448,1),(51446299,425069036,15286760,427965,1,'2007-09-14 22:11:53',3310491448,1),(51446300,425066062,15282125,427965,1,'2007-09-14 22:11:53',3310491437,1),(51446302,425064037,15285044,427965,1,'2007-09-14 22:11:53',3310491437,1),(51446303,425059481,15281954,427965,1,'2007-09-14 22:11:53',3310491437,1),(51446306,425058216,15275087,427965,1,'2007-09-14 22:11:53',3310491437,1),(51446307,425059102,15274658,427965,1,'2007-09-14 22:11:53',3310491437,1),(51446309,425057457,15271225,427965,1,'2007-09-14 22:11:53',3310491431,1),(51446312,425058469,15269423,427965,1,'2007-09-14 22:11:53',3310491431,1),(51446485,425104721,15317144,427965,1,'2007-09-14 22:12:31',3310491449,1),(51446486,425107632,15326500,427965,1,'2007-09-14 22:12:31',3310491451,1),(51446487,425109530,15330963,427965,1,'2007-09-14 22:12:31',3310491451,1),(51446490,425112061,15333967,427965,1,'2007-09-14 22:12:31',3310491451,1),(51446491,425115161,15336027,427965,1,'2007-09-14 22:12:31',3310491451,1),(51446492,425117122,15337400,427965,1,'2007-09-14 22:12:31',3310491451,1),(51446494,425119843,15342894,427965,1,'2007-09-14 22:12:31',3310491451,1),(51446496,425121298,15346842,427965,1,'2007-09-14 22:12:31',3310491451,1),(51446497,425122627,15348816,427965,1,'2007-09-14 22:12:31',3310491454,1),(51446498,425124968,15349846,427965,1,'2007-09-14 22:12:31',3310491454,1),(51446677,425101241,15294914,427965,1,'2007-09-14 22:12:31',3310491449,1),(51446679,425101241,15296974,427965,1,'2007-09-14 22:12:31',3310491449,1),(51446680,425101684,15301867,427965,1,'2007-09-14 22:12:31',3310491449,1),(51446682,425102001,15304356,427965,1,'2007-09-14 22:12:31',3310491449,1),(51446684,425101621,15306587,427965,1,'2007-09-14 22:12:31',3310491449,1),(51446687,425101621,15308905,427965,1,'2007-09-14 22:12:31',3310491449,1),(51446688,425101874,15310020,427965,1,'2007-09-14 22:12:31',3310491449,1),(51446690,425103140,15312510,427965,1,'2007-09-14 22:12:31',3310491449,1),(51446992,425054920,15291959,981792,1,'2009-04-27 01:35:55',3310491437,3),(51446997,425062961,15303326,981792,1,'2009-04-27 01:35:56',3310491437,2),(51447331,425060620,15306072,427965,1,'2007-09-14 22:13:13',3310491437,1),(51447714,425095698,15396877,188228,1,'2008-06-16 18:47:01',3310491537,2),(51447737,425095674,15407782,305941,1,'2009-02-09 21:21:41',3310491537,2),(51448127,425095381,15390697,188228,1,'2008-06-16 19:09:32',3310491537,6),(51448405,425111365,15396795,427965,1,'2007-09-14 22:14:55',3310491537,1),(51448408,425106556,15393019,427965,1,'2007-09-14 22:14:55',3310491537,1),(51448409,425100569,15388122,188228,1,'2008-06-16 19:09:56',3310491537,4),(51448537,425101241,15391216,427965,1,'2007-09-14 22:15:09',3310491537,1),(51448538,425101329,15393787,188228,1,'2008-06-16 18:39:09',3310491537,2),(51448539,425100506,15397048,188228,1,'2008-06-16 18:44:40',3310491537,3),(51448541,425099494,15399537,188228,1,'2008-06-16 18:45:06',3310491537,3),(51448824,425342004,15773420,427965,1,'2007-09-14 22:19:21',3310491643,1),(51448827,425338399,15774107,454632,1,'2007-09-17 19:59:14',3310491643,1),(51448828,425334608,15775868,188228,1,'2008-06-16 20:02:58',3310491643,2),(51448830,425329295,15778185,188228,1,'2008-06-16 20:02:41',3310491643,5),(51448926,425340296,15805349,427965,1,'2007-09-14 22:19:21',3310491643,1),(51448928,425340802,15803118,427965,1,'2007-09-14 22:19:21',3310491643,1),(51448929,425342699,15798998,427965,1,'2007-09-14 22:19:21',3310491646,1),(51448931,425344660,15796938,427965,1,'2007-09-14 22:19:21',3310491646,1),(51448934,425346874,15794191,427965,1,'2007-09-14 22:19:21',3310491646,1),(51448936,425347569,15792303,427965,1,'2007-09-14 22:19:21',3310491646,1),(51448937,425345609,15779343,427965,1,'2007-09-14 22:19:21',3310491646,1),(51448938,425345039,15775824,427965,1,'2007-09-14 22:19:21',3310491646,1),(51448940,425344524,15773962,188228,1,'2008-06-16 20:04:22',3310491646,2),(51449055,425361420,15790501,427965,1,'2007-09-14 22:16:28',3310491646,1),(51449056,425360661,15787497,427965,1,'2007-09-14 22:16:28',3310491646,1),(51449057,425359270,15782261,427965,1,'2007-09-14 22:16:28',3310491646,1),(51449058,425359017,15779943,427965,1,'2007-09-14 22:16:28',3310491646,1),(51449060,425359333,15778313,427965,1,'2007-09-14 22:16:28',3310491646,1),(51449062,425358764,15776510,427965,1,'2007-09-14 22:16:28',3310491646,1),(51449064,425356866,15766211,427965,1,'2007-09-14 22:16:28',3310491646,1),(51449130,425354526,15794191,427965,1,'2007-09-14 22:16:34',3310491646,1),(51449133,425355601,15792046,427965,1,'2007-09-14 22:16:34',3310491646,1),(51449134,425357372,15781059,427965,1,'2007-09-14 22:16:34',3310491646,1),(51449137,425356613,15778399,427965,1,'2007-09-14 22:16:34',3310491646,1),(51449139,425356866,15777369,427965,1,'2007-09-14 22:16:34',3310491646,1),(51449140,425357689,15775995,427965,1,'2007-09-14 22:16:34',3310491646,1),(51449148,425358700,15775480,427965,1,'2007-09-14 22:16:34',3310491646,1),(51449177,425347253,15793419,427965,1,'2007-09-14 22:19:21',3310491646,1),(51449178,425349024,15792131,427965,1,'2007-09-14 22:16:34',3310491646,1),(51449179,425351554,15792046,427965,1,'2007-09-14 22:16:34',3310491646,1),(51449552,425330999,15848093,427965,1,'2007-09-14 22:18:51',3310493009,1),(51449553,425327267,15843887,427965,1,'2007-09-14 22:18:51',3310493009,1),(51449672,425322966,15839167,427965,1,'2007-09-14 22:18:51',3310493009,1),(51449673,425320942,15836420,427965,1,'2007-09-14 22:18:51',3310493009,1),(51449675,425319171,15832644,427965,1,'2007-09-14 22:18:51',3310493009,1),(51449676,425317843,15828695,427965,1,'2007-09-14 22:18:51',3310493009,1),(51449997,425316452,15823460,427965,1,'2007-09-14 22:18:51',3310493009,1),(51449998,425316452,15817451,427965,1,'2007-09-14 22:18:51',3310491643,1),(51449999,425316894,15808353,427965,1,'2007-09-14 22:18:51',3310491643,1),(51450002,425317400,15796423,427965,1,'2007-09-14 22:18:51',3310491643,1),(51450003,425317780,15786037,427965,1,'2007-09-14 22:18:51',3310491643,1),(51450004,425317084,15774536,427965,1,'2007-09-14 22:18:51',3310491643,1),(51450007,425315250,15760117,427965,1,'2007-09-14 22:18:51',3310491641,1),(51450008,425313163,15751190,427965,1,'2007-09-14 22:18:51',3310491640,1),(51450009,425309874,15743122,427965,1,'2007-09-14 22:18:51',3310491640,1),(51450011,425307280,15738487,427965,1,'2007-09-14 22:18:51',3310491640,1),(51450013,425302094,15733852,427965,1,'2007-09-14 22:18:51',3310491640,1),(51450014,425296465,15730333,427965,1,'2007-09-14 22:18:51',3310491640,1),(51450016,425293935,15726900,427965,1,'2007-09-14 22:18:51',3310491640,1),(51450017,425292986,15724497,427965,1,'2007-09-14 22:18:51',3310491640,1),(51450019,425292610,15719563,188228,1,'2008-06-16 19:41:47',3310491640,2),(51450106,425295201,15715529,4963967,1,'2010-06-11 20:09:40',3310491640,4),(51450107,425294561,15713791,4963967,1,'2010-06-11 20:09:40',3310491640,4),(51450110,425293364,15713528,4963967,1,'2010-06-11 20:09:40',3310491640,3),(51450111,425292501,15714426,4963967,1,'2010-06-11 20:09:41',3310491640,4),(51450113,425292300,15715443,4963967,1,'2010-06-11 20:09:41',3310491640,4),(51450114,425292431,15716248,4963967,1,'2010-06-11 20:09:41',3310491640,5),(51450116,425293129,15717207,4963967,1,'2010-06-11 20:09:41',3310491640,3),(51450118,425294262,15717271,4963967,1,'2010-06-11 20:09:41',3310491640,4),(51450178,425292874,15713858,4963967,1,'2010-06-11 20:09:40',3310491640,3),(51450303,425295021,15716383,4963967,1,'2010-06-11 20:09:41',3310491640,4),(51450764,425350605,15769730,427965,1,'2007-09-14 22:19:20',3310491646,1),(51450766,425345988,15775738,427965,1,'2007-09-14 22:19:20',3310491646,1),(51450767,425345229,15776081,427965,1,'2007-09-14 22:19:20',3310491646,1),(51552405,425168593,15276498,432736,1,'2007-09-15 01:37:41',3310491453,1),(51552408,425167422,15280234,432736,1,'2007-09-15 01:37:41',3310491453,1),(51552410,425167010,15284761,432736,1,'2007-09-15 01:37:42',3310491453,1),(51552413,425171285,15269088,461502,1,'2008-05-16 19:07:44',3310491447,3),(51552416,425172740,15265397,461502,1,'2008-05-16 19:07:44',3310491447,3),(51552419,425174827,15260591,461502,1,'2008-05-16 19:07:44',3310491447,3),(51552422,425177674,15257072,461502,1,'2008-05-16 18:47:55',3310491490,2),(51552429,425184190,15248832,461502,1,'2008-05-16 18:47:55',3310491490,3),(51552432,425188492,15242137,461502,1,'2008-05-16 18:44:51',3310491490,3),(51552434,425190517,15239305,461502,1,'2008-05-16 18:44:51',3310491490,3),(51552437,425194122,15237674,461502,1,'2008-05-16 18:41:28',3310491490,2),(51552440,425197286,15237073,461502,1,'2008-05-16 18:41:28',3310491490,2),(51552442,425202577,15235835,463410,1,'2008-05-17 14:55:40',3310491490,3),(51552444,425205067,15234498,461502,1,'2008-05-16 18:39:56',3310491491,2),(51552445,425208040,15233211,461502,1,'2008-05-16 18:39:56',3310491491,2),(51552447,425210317,15232009,461502,1,'2008-05-16 18:39:56',3310491491,2),(51552451,425212025,15230979,461502,1,'2008-05-16 18:39:56',3310491491,2),(51552453,425214303,15228833,461502,1,'2008-05-16 18:39:56',3310491491,2),(51552456,425216517,15225744,461502,1,'2008-05-16 18:39:56',3310491491,2),(51552459,425218857,15222482,461502,1,'2008-05-16 18:39:56',3310491491,2),(51552462,425222083,15219478,461502,1,'2008-05-16 18:38:38',3310491491,2),(51552466,425239796,15210380,461502,1,'2008-05-16 18:36:34',3310491492,4),(51552468,425236949,15212268,461502,1,'2008-05-16 18:38:38',3310491492,2),(51552471,425226258,15217675,461502,1,'2008-05-16 18:38:38',3310491491,2),(51552473,425241187,15209436,461502,1,'2008-05-16 18:36:34',3310491492,5),(51552476,425242832,15208234,461502,1,'2008-05-16 18:36:34',3310491492,5),(51552477,425245172,15207118,461502,1,'2008-05-16 18:35:59',3310491492,5),(51552480,425249980,15206088,461502,1,'2008-05-16 18:36:10',3310491492,4),(51552483,425255814,15205593,2895121,1,'2009-10-19 19:12:50',3310491492,4),(51552486,425259742,15205290,370566,1,'2008-05-09 02:14:23',3310491492,3),(51552489,425261925,15204659,370566,1,'2008-05-09 02:14:24',3310491493,3),(51552492,425262708,15204389,370566,1,'2008-05-09 02:14:24',3310491493,3),(51552495,425263814,15203876,370566,1,'2008-05-09 02:14:24',3310491493,3),(51552497,425264815,15203452,370566,1,'2008-05-09 02:14:24',3310491493,3),(51552500,425265612,15203143,370566,1,'2008-05-09 02:14:24',3310491493,3),(51552504,425192225,15238275,461502,1,'2008-05-16 18:44:01',3310491490,2),(51552507,425275421,15203690,435967,1,'2007-09-15 21:59:37',3310491493,1),(51552509,425278761,15205568,435967,1,'2007-09-15 21:59:37',3310491493,1),(51552513,425282326,15207433,432736,1,'2007-09-15 01:37:50',3310491493,1),(51552516,425287981,15207617,432736,1,'2007-09-15 01:37:50',3310491504,1),(51552518,425292642,15206485,432736,1,'2007-09-15 01:37:50',3310491504,1),(51552546,425295024,15204854,432736,1,'2007-09-15 01:37:53',3310491504,1),(51552549,425296786,15203287,432736,1,'2007-09-15 01:37:54',3310491504,1),(51552550,425299234,15201395,432736,1,'2007-09-15 01:37:54',3310491504,1),(51552553,425301453,15199959,432736,1,'2007-09-15 01:37:54',3310491504,1),(51552555,425303998,15199176,432736,1,'2007-09-15 01:37:54',3310491504,1),(51552557,425306869,15198980,432736,1,'2007-09-15 01:37:54',3310491504,1),(51552559,425309937,15198915,432736,1,'2007-09-15 01:37:55',3310491504,1),(51552562,425311960,15198197,432736,1,'2007-09-15 01:37:55',3310491504,1),(51552565,425314570,15196109,432736,1,'2007-09-15 01:37:55',3310491504,1),(51552569,425317507,15195325,432736,1,'2007-09-15 01:37:55',3310491505,1),(51552572,425320749,15195933,432736,1,'2007-09-15 01:37:56',3310491505,1),(51552575,425325791,15197585,432736,1,'2007-09-15 01:37:56',3310491505,1),(51552578,425333039,15194999,174860,1,'2008-12-06 16:19:27',3310491505,2),(51552581,425335664,15193760,174860,1,'2008-12-06 16:19:27',3310491505,2),(51552583,425339370,15193578,174860,1,'2008-12-06 16:19:27',3310491505,2),(51552587,425342646,15195034,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552589,425297692,15185080,432736,1,'2007-09-15 01:37:57',3310491504,1),(51552592,425300993,15197225,432736,1,'2007-09-15 01:37:57',3310491504,1),(51552595,425341214,15194076,174860,1,'2008-12-06 16:19:27',3310491505,2),(51552599,425337486,15193436,174860,1,'2008-12-06 16:19:27',3310491505,2),(51552602,425327765,15197347,210114,1,'2008-08-12 23:32:51',3310491505,3),(51552605,425331367,15195879,174860,1,'2008-12-06 16:19:27',3310491505,2),(51552608,425323729,15197335,432736,1,'2007-09-15 01:37:58',3310491505,1),(51552612,425345476,15197722,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552615,425348423,15200579,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552619,425352122,15204756,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552622,425355525,15209011,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552625,425358733,15212789,174860,1,'2008-12-06 16:19:27',3310491508,3),(51552628,425359568,15212579,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552630,425360923,15211780,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552633,425361408,15210760,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552635,425363346,15207441,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552637,425365396,15205062,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552640,425368307,15202130,174860,1,'2008-12-06 16:19:27',3310491508,3),(51552643,425372987,15200070,174860,1,'2008-12-06 16:19:27',3310491509,3),(51552645,425378919,15197927,174860,1,'2008-12-06 16:19:27',3310491509,2),(51552648,425384398,15195975,174860,1,'2008-12-06 16:19:27',3310491509,2),(51552651,425390003,15194085,448710,1,'2008-05-14 17:04:23',3310491509,2),(51552653,425392021,15193528,174860,1,'2008-12-06 16:19:27',3310491509,2),(51552656,425356645,15211072,174860,1,'2008-12-06 16:19:27',3310491508,3),(51552659,425353966,15206879,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552660,425362169,15209390,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552664,425357531,15212274,174860,1,'2008-12-06 16:19:27',3310491508,3),(51552667,425366410,15203760,174860,1,'2008-12-06 16:19:27',3310491508,3),(51552671,425344861,15197138,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552672,425397569,15192394,174860,1,'2008-12-06 16:19:27',3310502432,2),(51552675,425399694,15193183,174860,1,'2008-12-06 16:19:27',3310502432,2),(51552679,425402306,15194884,174860,1,'2008-12-06 16:19:27',3310502432,2),(51552682,425404674,15195491,174860,1,'2008-12-06 16:19:28',3310502432,2),(51552686,425406617,15195491,174860,1,'2008-12-06 16:19:28',3310502432,2),(51552688,425408986,15194580,174860,1,'2008-12-06 16:19:28',3310502432,2),(51552691,425410504,15192819,174860,1,'2008-12-06 16:19:28',3310502432,2),(51552693,425412387,15189054,174860,1,'2008-12-06 16:19:28',3310502432,2),(51552694,425414755,15184256,174860,1,'2008-12-06 16:19:28',3310502432,2),(51552699,425417084,15179091,174860,1,'2008-12-06 16:19:28',3310502432,2),(51552702,425418890,15177028,174860,1,'2008-12-06 16:19:28',3310502432,2),(51552705,425421262,15175222,174860,1,'2008-12-06 16:19:28',3310502432,2),(51552707,425428071,15171663,174860,1,'2008-12-06 16:19:28',3310502433,2),(51552709,425431887,15169910,174860,1,'2008-12-06 16:19:28',3310502433,2),(51552710,425433900,15167802,174860,1,'2008-12-06 16:19:28',3310502433,2),(51552711,425436391,15164544,174860,1,'2008-12-06 16:19:28',3310502433,3),(51552712,425440033,15160423,174860,1,'2008-12-06 16:19:28',3310502411,2),(51552715,425443099,15157356,174860,1,'2008-12-06 16:19:28',3310502411,2),(51552717,425446549,15154865,174860,1,'2008-12-06 16:19:28',3310502411,2),(51552720,425450191,15152660,174860,1,'2008-12-06 16:19:28',3310502411,2),(51552722,425453449,15151223,174860,1,'2008-12-06 16:19:28',3310502414,2),(51552723,425455366,15149786,174860,1,'2008-12-06 16:19:28',3310502414,2),(51552726,425456420,15147102,174860,1,'2008-12-06 16:19:28',3310502414,2),(51552727,425457187,15144802,174860,1,'2008-12-06 16:19:29',3310502414,2),(51552728,425460061,15140969,174860,1,'2008-12-06 16:19:29',3310502414,2),(51552731,425462656,15140044,174860,1,'2008-12-06 16:19:29',3310502414,2),(51552733,425465321,15139381,174860,1,'2008-12-06 16:19:29',3310502414,2),(51552736,425469214,15136948,432736,1,'2007-09-15 02:31:16',3310502414,1),(51552737,425471370,15135794,432736,1,'2007-09-15 01:38:10',3310502414,1),(51552740,425474743,15133705,432736,1,'2007-09-15 01:38:10',3310502414,1),(51552744,425476697,15134152,306164,1,'2008-05-01 17:04:02',3310502414,7),(51552747,425478423,15133628,432736,1,'2007-09-15 01:38:10',3310502414,1),(51552750,425481183,15132632,432736,1,'2007-09-15 01:38:11',3310502415,1),(51552755,425484786,15130102,432736,1,'2007-09-15 01:38:11',3310502415,1),(51552758,425491992,15123432,432736,1,'2007-09-15 01:38:11',3310502415,1),(51552761,425499921,15116558,306164,1,'2008-05-01 17:19:32',3310502415,2),(51552762,425508331,15105915,306164,1,'2008-05-01 17:19:32',3310502424,2),(51552764,425515989,15094683,432736,1,'2007-09-15 01:38:13',3310502424,1),(51552766,425519362,15089469,432736,1,'2007-09-15 01:38:14',3310502424,1),(51552768,425526415,15081803,432736,1,'2007-09-15 01:38:14',3310502424,1),(51552770,425529175,15078046,432736,1,'2007-09-15 01:38:15',3310502424,1),(51552773,425532699,15074437,432736,1,'2007-09-15 01:38:15',3310502424,1),(51552774,425536515,15070145,432736,1,'2007-09-15 01:38:15',3310502425,1),(51552777,425540012,15068078,432736,1,'2007-09-15 01:38:16',3310502425,1),(51552779,425543668,15066489,432736,1,'2007-09-15 01:38:16',3310502425,1),(51552782,425548756,15065853,432736,1,'2007-09-15 01:38:17',3310502425,1),(51552785,425552571,15064422,432736,1,'2007-09-15 01:38:17',3310502425,1),(51552787,425555591,15061719,432736,1,'2007-09-15 01:38:17',3310502425,1),(51552789,425560520,15058063,432736,1,'2007-09-15 01:38:17',3310502425,1),(51552791,425564812,15055361,432736,1,'2007-09-15 01:38:17',3310502428,1),(51552793,425566719,15052499,432736,1,'2007-09-15 01:38:18',3310502428,1),(51552797,425570535,15049479,432736,1,'2007-09-15 01:38:18',3310502422,1),(51552800,425573555,15047730,432736,1,'2007-09-15 01:38:18',3310502422,1),(51552802,425578642,15047412,432736,1,'2007-09-15 01:38:18',3310502422,1),(51552806,425584365,15047253,432736,1,'2007-09-15 01:38:19',3310502422,1),(51552807,425586909,15046776,432736,1,'2007-09-15 01:38:19',3310502422,1),(51552811,425588181,15045504,432736,1,'2007-09-15 01:38:19',3310502422,1),(51552814,425589875,15043383,432736,1,'2007-09-15 01:38:19',3310502423,1),(51552815,425593217,15039333,432736,1,'2007-09-15 01:38:19',3310502423,1),(51552818,425596862,15035788,432736,1,'2007-09-15 01:38:20',3310502423,1),(51552821,425600508,15032446,432736,1,'2007-09-15 01:38:20',3310502423,1),(51552823,425603343,15028902,432736,1,'2007-09-15 01:38:20',3310502423,1),(51552824,425605571,15026168,432736,1,'2007-09-15 01:38:20',3310502423,1),(51552825,425607394,15024345,432736,1,'2007-09-15 01:38:20',3310502423,1),(51552828,425610027,15022927,432736,1,'2007-09-15 01:38:20',3310502423,1),(51552830,425612458,15021712,432736,1,'2007-09-15 01:38:21',3310502423,1),(51552832,425613571,15019990,432736,1,'2007-09-15 01:38:21',3310502423,1),(51552835,425614078,15018370,432736,1,'2007-09-15 01:38:21',3310502423,1),(51552838,425613977,15016446,432736,1,'2007-09-15 01:38:21',3310502423,1),(51552841,425613774,15014320,432736,1,'2007-09-15 01:38:21',3310502423,1),(51552844,425613875,15012193,432736,1,'2007-09-15 01:38:21',3310502423,1),(51552847,425614382,15010066,432736,1,'2007-09-15 01:38:22',3310502423,1),(51552849,425615090,15008446,432736,1,'2007-09-15 01:38:22',3310502423,1),(51552851,425616508,15005104,432736,1,'2007-09-15 01:38:22',3310502423,1),(51552852,425617116,15002674,432736,1,'2007-09-15 01:38:22',3310502466,1),(51552854,425617318,14999433,432736,1,'2007-09-15 01:38:22',3310502466,1),(51552856,425616913,14992648,432736,1,'2007-09-15 01:38:22',3310502464,1),(51552859,425616103,14987889,432736,1,'2007-09-15 01:38:22',3310502421,1),(51552861,425615394,14984243,432736,1,'2007-09-15 01:38:23',3310502421,1),(51552863,425614787,14979484,432736,1,'2007-09-15 01:38:23',3310502421,1),(51552865,425614685,14976446,432736,1,'2007-09-15 01:38:23',3310502421,1),(51552868,425614709,14973998,432736,1,'2007-09-15 01:38:23',3310502421,1),(51552871,425614709,14972772,432736,1,'2007-09-15 01:38:23',3310502421,1),(51552873,425614787,14971490,432736,1,'2007-09-15 01:38:23',3310502421,1),(51552875,425614811,14966812,432736,1,'2007-09-15 01:41:47',3310502421,1),(51554685,425615950,14965540,432736,1,'2007-09-15 01:41:44',3310502421,1),(51554688,425615701,14965073,432736,1,'2007-09-15 01:41:44',3310502421,1),(51554691,425615355,14964827,432736,1,'2007-09-15 01:41:44',3310502421,1),(51554693,425614978,14964740,432736,1,'2007-09-15 01:41:44',3310502421,1),(51554694,425614598,14964796,432736,1,'2007-09-15 01:41:44',3310502421,1),(51554697,425614240,14965008,432736,1,'2007-09-15 01:41:44',3310502421,1),(51554700,425613989,14965352,432736,1,'2007-09-15 01:41:44',3310502421,1),(51554703,425613900,14965846,432736,1,'2007-09-15 01:41:44',3310502421,1),(51554705,425614040,14966305,432736,1,'2007-09-15 01:41:44',3310502421,1),(51554707,425614430,14966687,432736,1,'2007-09-15 01:41:45',3310502421,1),(51554710,425615160,14966796,432736,1,'2007-09-15 01:41:45',3310502421,1),(51554712,425615502,14966653,432736,1,'2007-09-15 01:41:45',3310502421,1),(51554715,425615734,14966448,432736,1,'2007-09-15 01:41:45',3310502421,1),(51554716,425615933,14966083,432736,1,'2007-09-15 01:41:45',3310502421,1),(51557999,425613611,14965020,370566,1,'2008-05-09 02:14:23',3310502421,2),(51558001,425612892,14964653,370566,1,'2008-05-09 02:14:23',3310502421,2),(51558003,425611587,14963476,432736,1,'2007-09-15 01:47:01',3310502421,1),(51558005,425610666,14962303,432736,1,'2007-09-15 01:47:01',3310502421,1),(51558007,425609681,14960502,432736,1,'2007-09-15 01:47:02',3310502421,1),(51558010,425608550,14958910,432736,1,'2007-09-15 01:47:02',3310502421,1),(51558014,425607712,14957695,432736,1,'2007-09-15 01:47:02',3310502421,1),(51558017,425606518,14956208,432736,1,'2007-09-15 01:47:02',3310502421,1),(51558021,425605345,14954846,432736,1,'2007-09-15 01:47:03',3310502421,1),(51558024,425604738,14953841,432736,1,'2007-09-15 01:47:03',3310502421,1),(51558026,425604319,14952730,432736,1,'2007-09-15 01:47:03',3310502421,1),(51558029,425602915,14950322,432736,1,'2007-09-15 01:47:04',3310502421,1),(51558031,425601282,14947960,432736,1,'2007-09-15 01:47:04',3310502421,1),(51558033,425599834,14946223,432736,1,'2007-09-15 01:47:04',3310502421,1),(51558036,425598314,14944413,432736,1,'2007-09-15 01:47:04',3310502421,1),(51558038,425597445,14943472,432736,1,'2007-09-15 01:47:05',3310502421,1),(51558040,425595563,14941481,432736,1,'2007-09-15 01:47:05',3310502079,1),(51558041,425594622,14941300,432736,1,'2007-09-15 01:47:05',3310502079,1),(51558043,425592052,14940830,432736,1,'2007-09-15 01:47:05',3310502079,1),(51558045,425590749,14940250,432736,1,'2007-09-15 01:47:05',3310502079,1),(51558047,425588794,14939527,432736,1,'2007-09-15 01:47:05',3310502078,1),(51558051,425585038,14937175,432736,1,'2007-09-15 01:47:05',3310502078,1),(51558054,425583837,14936095,432736,1,'2007-09-15 01:47:06',3310502078,1),(51558057,425580133,14934280,432736,1,'2007-09-15 01:47:06',3310502078,1),(51558059,425576994,14932907,432736,1,'2007-09-15 01:47:06',3310502078,1),(51558060,425575596,14932343,432736,1,'2007-09-15 01:47:07',3310502078,1),(51558063,425574345,14931607,432736,1,'2007-09-15 01:47:07',3310502078,1),(51558064,425573241,14930405,432736,1,'2007-09-15 01:47:08',3310502078,1),(51558067,425571917,14929203,432736,1,'2007-09-15 01:47:08',3310502078,1),(51558070,425569683,14927373,432736,1,'2007-09-15 01:47:09',3310502078,1),(51558071,425566632,14924932,432736,1,'2007-09-15 01:47:09',3310502078,1),(51558074,425563763,14922979,432736,1,'2007-09-15 01:47:10',3310502078,1),(51558075,425562237,14921453,432736,1,'2007-09-15 01:47:11',3310502078,1),(51558078,425561139,14919744,432736,1,'2007-09-15 01:47:11',3310502075,1),(51558083,425559857,14917425,432736,1,'2007-09-15 01:47:14',3310502075,1),(51558085,425558515,14915960,432736,1,'2007-09-15 01:47:15',3310502075,1),(51558086,425557050,14914068,432736,1,'2007-09-15 01:47:15',3310502075,1),(51558089,425554731,14912543,432736,1,'2007-09-15 01:47:16',3310502075,1),(51558091,425552534,14911688,432736,1,'2007-09-15 01:47:16',3310502075,1),(51558093,425551191,14910773,432736,1,'2007-09-15 01:47:16',3310502075,1),(51558095,425550520,14909552,432736,1,'2007-09-15 01:47:17',3310502075,1),(51558097,425549543,14908087,432736,1,'2007-09-15 01:47:17',3310502075,1),(51558099,425548750,14906806,432736,1,'2007-09-15 01:47:17',3310502075,1),(51558103,425547590,14905829,432736,1,'2007-09-15 01:47:17',3310502075,1),(51558105,425545454,14904853,432736,1,'2007-09-15 01:47:18',3310502075,1),(51558108,425543074,14903266,432736,1,'2007-09-15 01:47:18',3310502075,1),(51558111,425539290,14900703,432736,1,'2007-09-15 01:47:18',3310502075,1),(51558113,425536727,14898140,432736,1,'2007-09-15 01:47:18',3310502075,1),(51558115,425535811,14895698,432736,1,'2007-09-15 01:47:19',3310502075,1),(51558118,425535201,14892464,432736,1,'2007-09-15 01:47:19',3310502075,1),(51558121,425535018,14888680,432736,1,'2007-09-15 01:47:19',3310502075,1),(51558124,425534896,14884286,432736,1,'2007-09-15 01:47:19',3310502073,1),(51558125,425534896,14881234,432736,1,'2007-09-15 01:47:20',3310502073,1),(51558128,425534041,14878976,432736,1,'2007-09-15 01:47:20',3310502072,1),(51558131,425532150,14876291,432736,1,'2007-09-15 01:47:20',3310502072,1),(51558246,425530380,14874033,432736,1,'2007-09-15 01:47:38',3310502072,1),(51558248,425528488,14871225,432736,1,'2007-09-15 01:47:38',3310502072,1),(51558253,425527206,14869638,432736,1,'2007-09-15 01:47:39',3310502072,1),(51558257,425525924,14868967,432736,1,'2007-09-15 01:47:39',3310502072,1),(51558260,425524643,14869089,432736,1,'2007-09-15 01:47:39',3310502072,1),(51558262,425523300,14869699,432736,1,'2007-09-15 01:47:39',3310502072,1),(51558265,425520432,14871652,432736,1,'2007-09-15 01:47:39',3310502072,1),(51558268,425518479,14873117,432736,1,'2007-09-15 01:47:39',3310502072,1),(51558271,425516404,14874033,432736,1,'2007-09-15 01:47:39',3310502072,1),(51558273,425513535,14874826,432736,1,'2007-09-15 01:47:40',3310502072,1),(51558276,425510850,14875863,432736,1,'2007-09-15 01:47:40',3310502072,1),(51558279,425507982,14876474,432736,1,'2007-09-15 01:47:40',3310502072,1),(51558282,425505968,14877450,432736,1,'2007-09-15 01:47:40',3310502061,1),(51558284,425503832,14878793,432736,1,'2007-09-15 01:47:40',3310502061,1),(51558287,425502001,14879830,432736,1,'2007-09-15 01:47:41',3310502061,1),(51558293,425499376,14878854,432736,1,'2007-09-15 01:47:41',3310502061,1),(51558295,425498034,14876779,432736,1,'2007-09-15 01:47:41',3310502061,1),(51558298,425496935,14875192,432736,1,'2007-09-15 01:47:41',3310502061,1),(51558301,425495348,14873727,432736,1,'2007-09-15 01:47:41',3310502061,1),(51558304,425493639,14873422,432736,1,'2007-09-15 01:47:41',3310502061,1),(51558305,425491809,14873300,432736,1,'2007-09-15 01:47:42',3310502061,1),(51563059,425490386,14873969,432736,1,'2007-09-15 01:56:05',3310502061,1),(51563061,425489160,14874402,432736,1,'2007-09-15 01:56:05',3310502061,1),(51563063,425487862,14874402,432736,1,'2007-09-15 01:56:05',3310502061,1),(51563066,425485843,14874041,432736,1,'2007-09-15 01:56:05',3310502061,1),(51563071,425483968,14873392,432736,1,'2007-09-15 01:56:05',3310502061,1),(51563075,425481877,14872491,432736,1,'2007-09-15 01:56:05',3310502061,1),(51563076,425480795,14871589,432736,1,'2007-09-15 01:56:06',3310502061,1),(51563080,425479641,14869714,432736,1,'2007-09-15 01:56:06',3310502061,1),(51563083,425478740,14867587,432736,1,'2007-09-15 01:56:06',3310502060,1),(51563087,425477838,14864414,432736,1,'2007-09-15 01:56:06',3310502060,1),(51563090,425477442,14862431,432736,1,'2007-09-15 01:56:06',3310502060,1),(51563094,425477622,14859402,432736,1,'2007-09-15 01:56:06',3310502060,1),(51563098,425477910,14854535,432736,1,'2007-09-15 01:56:06',3310502060,1),(51563100,425478631,14852444,432736,1,'2007-09-15 01:56:07',3310502060,1),(51563103,425480388,14848465,432736,1,'2007-09-15 01:56:07',3310502061,1),(51563105,425482107,14845400,432736,1,'2007-09-15 01:56:07',3310502061,1),(51563108,425482930,14843381,432736,1,'2007-09-15 01:56:08',3310502061,1),(51563110,425482930,14841811,432736,1,'2007-09-15 01:56:08',3310502061,1),(51563113,425482332,14841362,432736,1,'2007-09-15 01:56:08',3310502061,1),(51563115,425481509,14841362,432736,1,'2007-09-15 01:56:08',3310502061,1),(51563118,425480462,14842035,432736,1,'2007-09-15 01:56:08',3310502061,1),(51563120,425479191,14843904,432736,1,'2007-09-15 01:56:08',3310502060,1),(51563122,425476948,14847717,432736,1,'2007-09-15 01:56:09',3310502060,1),(51563124,425474107,14852577,432736,1,'2007-09-15 01:56:09',3310502060,1),(51563127,425472238,14855792,432736,1,'2007-09-15 01:56:09',3310502060,1),(51563130,425471117,14855942,432736,1,'2007-09-15 01:56:09',3310502060,1),(51563134,425470220,14855493,432736,1,'2007-09-15 01:56:10',3310502060,1),(51563137,425469696,14853773,432736,1,'2007-09-15 01:56:10',3310502060,1),(51563140,425468724,14851306,432736,1,'2007-09-15 01:56:10',3310502060,1),(51563141,425467378,14848465,432736,1,'2007-09-15 01:56:10',3310502060,1),(51563145,425465584,14845998,432736,1,'2007-09-15 01:56:10',3310502060,1),(51563148,425462369,14843306,432736,1,'2007-09-15 01:56:11',3310502060,1),(51563152,425457808,14838073,432736,1,'2007-09-15 01:56:11',3310502060,1),(51563155,425455823,14835251,432736,1,'2007-09-15 01:56:11',3310502060,1),(51563159,425454700,14833228,432736,1,'2007-09-15 01:56:11',3310502060,1),(51563162,425453666,14830576,432736,1,'2007-09-15 01:56:11',3310502054,1),(51563164,425452947,14828329,432736,1,'2007-09-15 01:56:12',3310502054,1),(51563168,425452003,14826666,432736,1,'2007-09-15 01:56:12',3310502051,1),(51563170,425448767,14822666,432736,1,'2007-09-15 01:56:12',3310502051,1),(51563173,425445531,14818531,432736,1,'2007-09-15 01:56:12',3310502051,1),(51563176,425442136,14814890,432736,1,'2007-09-15 01:56:12',3310502051,1),(51563177,425439620,14812374,432736,1,'2007-09-15 01:56:12',3310502051,1),(51563179,425437667,14809702,432736,1,'2007-09-15 01:56:13',3310502051,1),(51563181,425437178,14808114,432736,1,'2007-09-15 01:56:13',3310502051,1),(51563185,425436751,14805915,432736,1,'2007-09-15 01:56:13',3310502051,1),(51563189,425436873,14803411,432736,1,'2007-09-15 01:56:13',3310502051,1),(51563192,425436995,14801548,432736,1,'2007-09-15 01:56:13',3310502051,1),(51563195,425436781,14799868,432736,1,'2007-09-15 01:56:13',3310502051,1),(51563197,425436415,14797517,432736,1,'2007-09-15 01:56:14',3310502051,1),(51563199,425436730,14795307,432736,1,'2007-09-15 01:56:14',3310502051,1),(51563200,425437489,14793027,432736,1,'2007-09-15 01:56:14',3310502051,1),(51563202,425439009,14789988,432736,1,'2007-09-15 01:56:15',3310502051,1),(51563205,425441289,14786340,432736,1,'2007-09-15 01:56:15',3310502051,1),(51563210,425444557,14782008,432736,1,'2007-09-15 01:56:15',3310502051,1),(51563214,425448356,14777905,432736,1,'2007-09-15 01:56:15',3310502051,1),(51563216,425451624,14773649,432736,1,'2007-09-15 01:56:16',3310502049,1),(51563224,425453220,14771217,432736,1,'2007-09-15 01:56:16',3310502052,1),(51563226,425454360,14768862,432736,1,'2007-09-15 01:56:17',3310502052,1),(51563230,425455044,14766582,432736,1,'2007-09-15 01:56:17',3310502052,1),(51563233,425455348,14763466,432736,1,'2007-09-15 01:56:17',3310502052,1),(51563236,425455272,14755791,432736,1,'2007-09-15 01:56:18',3310502052,1),(51563238,425455576,14751687,432736,1,'2007-09-15 01:56:18',3310502052,1),(51563242,425455804,14749180,432736,1,'2007-09-15 01:56:18',3310502052,1),(51563244,425455652,14748040,432736,1,'2007-09-15 01:56:18',3310502052,1),(51563247,425454968,14747204,432736,1,'2007-09-15 01:56:18',3310502052,1),(51563252,425453980,14746976,432736,1,'2007-09-15 01:56:18',3310502052,1),(51563255,425452992,14747356,432736,1,'2007-09-15 01:56:18',3310502052,1),(51563257,425452688,14748344,432736,1,'2007-09-15 01:56:18',3310502052,1),(51563261,425451776,14753131,432736,1,'2007-09-15 01:56:18',3310502049,1),(51563266,425450712,14756627,432736,1,'2007-09-15 01:56:19',3310502049,1),(51563268,425449876,14758755,432736,1,'2007-09-15 01:56:19',3310502049,1),(51563272,425449192,14759439,432736,1,'2007-09-15 01:56:19',3310502049,1),(51563276,425448432,14759439,432736,1,'2007-09-15 01:56:19',3310502049,1),(51563279,425447930,14758608,454632,1,'2007-09-18 01:05:24',3310502049,1),(51563281,425447293,14756095,454632,1,'2007-09-18 01:05:25',3310502049,1),(51563284,425445936,14753584,454632,1,'2007-09-18 01:05:25',3310502049,1),(51563374,425445623,14752524,454632,1,'2007-09-18 01:05:23',3310502049,1),(51563375,425446179,14750887,454632,1,'2007-09-18 01:05:24',3310502049,1),(51563437,425447639,14749147,454632,1,'2007-09-18 01:05:26',3310502049,1),(51563439,425448635,14747165,454632,1,'2007-09-18 01:05:26',3310502049,1),(51563440,425448727,14744889,454632,1,'2007-09-18 01:05:27',3310502049,1),(51563441,425447927,14741960,454632,1,'2007-09-18 01:05:27',3310502049,1),(51563442,425447087,14739832,454632,1,'2007-09-18 01:05:27',3310502049,1),(51563443,425445697,14736641,432736,1,'2007-09-15 01:56:37',3310502049,1),(51563447,425444537,14733981,454632,1,'2007-09-18 01:05:28',3310502049,1),(51563450,425443797,14730257,432736,1,'2007-09-15 01:56:37',3310502049,1),(51563451,425443265,14725318,432736,1,'2007-09-15 01:56:37',3310502049,1),(51563453,425443341,14720454,432736,1,'2007-09-15 01:56:37',3310502027,1),(51563454,425443265,14716503,432736,1,'2007-09-15 01:56:38',3310502027,1),(51563456,425443417,14713615,432736,1,'2007-09-15 01:56:38',3310502027,1),(51563458,425443949,14710727,432736,1,'2007-09-15 01:56:38',3310502027,1),(51563460,425445241,14707080,432736,1,'2007-09-15 01:56:38',3310502027,1),(51563462,425445317,14706320,432736,1,'2007-09-15 01:56:38',3310502027,1),(51563463,425444937,14705940,432736,1,'2007-09-15 01:56:39',3310502027,1),(51563466,425444025,14706168,432736,1,'2007-09-15 01:56:39',3310502027,1),(51563470,425442505,14710575,432736,1,'2007-09-15 01:56:39',3310502027,1),(51563472,425440073,14718783,432736,1,'2007-09-15 01:56:39',3310502027,1),(51563474,425438705,14722430,432736,1,'2007-09-15 01:56:39',3310502049,1),(51563477,425438303,14723457,454632,1,'2007-09-18 01:05:25',3310502049,1),(51563480,425437624,14723636,454632,1,'2007-09-18 01:05:25',3310502049,1),(51563481,425436585,14722602,454632,1,'2007-09-18 01:05:26',3310502049,1),(51563484,425435058,14719922,432736,1,'2007-09-15 01:56:40',3310502027,1),(51563485,425433462,14715971,432736,1,'2007-09-15 01:56:40',3310502027,1),(51563488,425430498,14712095,432736,1,'2007-09-15 01:56:40',3310502027,1),(51563490,425427154,14708068,432736,1,'2007-09-15 01:56:40',3310502027,1),(51563492,425424799,14705940,432736,1,'2007-09-15 01:56:40',3310502027,1),(51563494,425422731,14704068,454632,1,'2007-09-18 01:05:26',3310502026,1),(51563496,425420619,14701000,432736,1,'2007-09-15 01:56:41',3310502026,1),(51563499,425417579,14696897,432736,1,'2007-09-15 01:56:41',3310502026,1),(51581574,425470132,15141850,183661,1,'2008-04-18 18:23:07',3310502414,3),(51581577,425470921,15143853,432736,1,'2007-09-15 02:29:01',3310502414,1),(51581580,425471103,15147070,432736,1,'2007-09-15 02:29:01',3310502414,1),(51581582,425469343,15151986,432736,1,'2007-09-15 02:29:01',3310502414,1),(51581587,425464002,15161091,432736,1,'2007-09-15 02:29:01',3310502414,1),(51581590,425461756,15165279,432736,1,'2007-09-15 02:29:02',3310502436,1),(51581593,425460421,15168010,432736,1,'2007-09-15 02:29:02',3310502436,1),(51581596,425458357,15170195,432736,1,'2007-09-15 02:29:02',3310502436,1),(51581598,425456597,15172259,432736,1,'2007-09-15 02:29:02',3310502436,1),(51581602,425455687,15174565,432736,1,'2007-09-15 02:29:03',3310502436,1),(51581607,425455019,15178510,432736,1,'2007-09-15 02:29:03',3310502436,1),(51581611,425454291,15182334,432736,1,'2007-09-15 02:29:03',3310502436,1),(51581613,425454169,15190103,432736,1,'2007-09-15 02:29:03',3310502436,1),(51581617,425454898,15195141,432736,1,'2007-09-15 02:29:03',3310502436,1),(51581620,425456476,15201332,432736,1,'2007-09-15 02:29:04',3310502436,1),(51581622,425458789,15205416,501202,1,'2008-05-22 22:30:34',3310502436,2),(51581625,425460603,15208312,432736,1,'2007-09-15 02:29:04',3310502436,1),(51581628,425463516,15212135,432736,1,'2007-09-15 02:29:04',3310502436,1),(51581633,425473080,15216230,498434,1,'2008-05-22 19:58:22',3310502436,3),(51581643,425475546,15217346,498434,1,'2008-05-22 19:53:32',3310502438,2),(51581645,425478690,15218508,432736,1,'2007-09-15 02:29:05',3310502438,1),(51581650,425483607,15223789,432736,1,'2007-09-15 02:29:06',3310502439,1),(51581654,425485852,15226217,432736,1,'2007-09-15 02:29:06',3310502439,1),(51581657,425488280,15228766,432736,1,'2007-09-15 02:29:06',3310502439,1),(51581661,425490587,15232286,432736,1,'2007-09-15 02:29:06',3310502439,1),(51581663,425491558,15235564,432736,1,'2007-09-15 02:29:06',3310502439,1),(51581667,425492347,15239691,432736,1,'2007-09-15 02:29:07',3310502439,1),(51581670,425494228,15244668,432736,1,'2007-09-15 02:29:07',3310502439,1),(51581675,425496717,15248735,4804396,1,'2010-05-25 17:58:16',3310502439,2),(51581679,425467065,15138495,174860,1,'2008-12-06 16:19:29',3310502414,2),(51581686,425499422,15254440,725665,1,'2009-03-02 22:17:22',3310502439,5),(51581690,425502895,15259401,725665,1,'2009-03-02 22:17:22',3310502439,5),(51581692,425505871,15261386,725665,1,'2009-03-02 22:17:22',3310502439,5),(51581695,425509415,15262803,725665,1,'2009-03-02 22:17:22',3310502450,5),(51581699,425515499,15263968,725665,1,'2009-03-02 22:29:56',3310502450,17),(51581702,425517832,15264320,725665,1,'2009-03-02 22:29:56',3310502450,11),(51581705,425519975,15266205,725665,1,'2009-03-02 22:29:56',3310502450,11),(51581708,425523944,15271379,725665,1,'2009-03-02 22:29:54',3310502456,11),(51581711,425526637,15275135,725665,1,'2009-03-02 22:29:54',3310502456,11),(51581715,425530677,15279742,725665,1,'2009-03-02 22:29:54',3310502456,11),(51581724,425542387,15289732,725665,1,'2009-03-02 22:27:38',3310502457,13),(51581727,425547120,15293562,725665,1,'2009-03-02 22:27:38',3310502457,12),(51581729,425550167,15298877,725665,1,'2009-03-02 22:27:38',3310502457,12),(51581732,425550805,15299941,725665,1,'2009-03-02 22:27:39',3310502457,12),(51581737,425552718,15304760,725665,1,'2009-03-02 22:27:39',3310502457,12),(51581739,425554175,15307955,725665,1,'2009-03-02 22:27:40',3310502457,12),(51581743,425555969,15312333,725665,1,'2009-03-02 22:27:41',3310502457,14),(51581745,425556791,15316195,725665,1,'2009-03-02 22:27:41',3310502457,14),(51581748,425556791,15320916,725665,1,'2009-03-02 22:27:41',3310502457,14),(51581751,425556814,15328970,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51581754,425556779,15329603,1684788,1,'2009-06-30 11:19:38',3310502459,3),(51581757,425556649,15329884,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51581759,425556393,15330134,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51581762,425555947,15330198,1684788,1,'2009-06-30 11:19:38',3310502459,4),(51581766,425555555,15329902,1684788,1,'2009-06-30 11:19:38',3310502459,3),(51581769,425555444,15329694,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51581772,425555355,15329212,1684788,1,'2009-06-30 11:19:38',3310502459,3),(51581776,425555573,15328506,1684788,1,'2009-06-30 11:19:38',3310502459,3),(51581778,425555693,15328375,1684788,1,'2009-06-30 11:19:39',3310502459,5),(51581782,425556376,15328289,1684788,1,'2009-06-30 11:19:39',3310502459,15),(51581783,425556737,15328714,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51581786,425558133,15329365,432736,1,'2007-09-15 02:29:15',3310502459,1),(51581788,425557504,15329452,432736,1,'2007-09-15 02:29:15',3310502459,1),(51581791,425556831,15329335,1684788,1,'2009-06-30 11:19:38',3310502459,3),(51581795,425559126,15328531,615859,1,'2008-07-28 13:58:34',3310502459,2),(51581796,425559856,15327943,432736,1,'2007-09-15 02:29:16',3310502459,1),(51581799,425561199,15327227,432736,1,'2007-09-15 02:29:16',3310502459,1),(51581803,425562871,15326571,432736,1,'2007-09-15 02:29:16',3310502462,1),(51581807,425565221,15326355,432736,1,'2007-09-15 02:29:17',3310502462,1),(51581810,425569705,15326046,432736,1,'2007-09-15 02:29:17',3310502460,1),(51581813,425573292,15325303,432736,1,'2007-09-15 02:29:17',3310502460,1),(51581814,425581843,15325544,432736,1,'2007-09-15 02:29:17',3310502460,1),(51581818,425585075,15324929,432736,1,'2007-09-15 02:29:18',3310502460,1),(51581821,425587614,15323698,432736,1,'2007-09-15 02:29:18',3310502460,1),(51581823,425590153,15321543,432736,1,'2007-09-15 02:29:18',3310502461,1),(51581826,425593847,15318004,432736,1,'2007-09-15 02:29:18',3310502461,1),(51581828,425597925,15314387,432736,1,'2007-09-15 02:29:18',3310502461,1),(51581829,425601388,15312233,432736,1,'2007-09-15 02:29:18',3310502461,1),(51581832,425606004,15310155,432736,1,'2007-09-15 02:29:19',3310502461,1);
INSERT INTO `current_nodes` VALUES (51581835,425608544,15308001,432736,1,'2007-09-15 02:29:19',3310502461,1),(51581837,425610236,15305692,432736,1,'2007-09-15 02:29:19',3310502461,1),(51581840,425611852,15302691,432736,1,'2007-09-15 02:29:19',3310502461,1),(51581843,425613314,15299767,432736,1,'2007-09-15 02:29:20',3310502461,1),(51581846,425615161,15297459,432736,1,'2007-09-15 02:29:20',3310502461,1),(51581849,425617085,15295920,432736,1,'2007-09-15 02:29:20',3310502504,1),(51581852,425619393,15294612,432736,1,'2007-09-15 02:29:20',3310502504,1),(51581854,425621701,15293150,432736,1,'2007-09-15 02:29:20',3310502504,1),(51581857,425623933,15291149,432736,1,'2007-09-15 02:29:21',3310502504,1),(51581861,425625703,15288918,432736,1,'2007-09-15 02:29:21',3310502504,1),(51581863,425628019,15284841,498434,1,'2008-05-22 17:49:55',3310502504,2),(51581868,425630990,15279348,498434,1,'2008-05-22 17:49:55',3310502504,2),(51581874,425633203,15273168,498434,1,'2008-05-22 17:50:41',3310502504,2),(51581876,425635478,15266130,498434,1,'2008-05-22 17:50:41',3310502498,2),(51581877,425637501,15261495,498434,1,'2008-05-22 17:50:41',3310502498,2),(51581881,425639630,15257293,432736,1,'2007-09-15 02:29:23',3310502498,1),(51581883,425643016,15253215,432736,1,'2007-09-15 02:29:23',3310502498,1),(51581886,425646478,15248675,432736,1,'2007-09-15 02:29:23',3310502499,1),(51581888,425648633,15245751,432736,1,'2007-09-15 02:29:23',3310502499,1),(51581890,425654019,15242134,432736,1,'2007-09-15 02:29:23',3310502499,1),(51581895,425660559,15238056,432736,1,'2007-09-15 02:29:24',3310502499,1),(51581898,425667408,15234824,432736,1,'2007-09-15 02:29:24',3310502499,1),(51581902,425674179,15231516,432736,1,'2007-09-15 02:29:24',3310502502,1),(51581904,425676564,15228746,432736,1,'2007-09-15 02:29:24',3310502502,1),(51581906,425678642,15224129,432736,1,'2007-09-15 02:29:24',3310502502,1),(51581910,425682127,15219558,498434,1,'2008-05-22 17:32:10',3310502502,2),(51581912,425685857,15215696,498434,1,'2008-05-22 17:32:10',3310502500,2),(51581914,425688701,15212778,498434,1,'2008-05-22 17:32:10',3310502500,2),(51581916,425692492,15211048,432736,1,'2007-09-15 02:29:25',3310502500,1),(51581922,425697879,15210663,432736,1,'2007-09-15 02:29:26',3310502500,1),(51581923,425702572,15209894,432736,1,'2007-09-15 02:29:26',3310502501,1),(51581926,425706112,15209663,432736,1,'2007-09-15 02:29:26',3310502501,1),(51581928,425710113,15207970,432736,1,'2007-09-15 02:29:26',3310502501,1),(51581931,425713345,15205354,432736,1,'2007-09-15 02:29:26',3310502501,1),(51581932,425716961,15201968,432736,1,'2007-09-15 02:29:26',3310502501,1),(51581936,425719424,15197813,432736,1,'2007-09-15 02:29:27',3310502501,1),(51581939,425722117,15194273,432736,1,'2007-09-15 02:29:27',3310502501,1),(51581941,425725887,15190118,432736,1,'2007-09-15 02:29:27',3310502501,1),(51581944,425729965,15187502,432736,1,'2007-09-15 02:29:27',3310502512,1),(51581946,425736660,15184886,432736,1,'2007-09-15 02:29:27',3310502512,1),(51581951,425743200,15182578,432736,1,'2007-09-15 02:29:27',3310502512,1),(51581955,425749894,15180577,432736,1,'2007-09-15 02:29:28',3310502512,1),(51581958,425752741,15181270,432736,1,'2007-09-15 02:29:28',3310502512,1),(51581960,425755896,15184424,432736,1,'2007-09-15 02:29:28',3310502513,1),(51581962,425759091,15186665,440632,1,'2008-07-09 16:35:09',3310502513,2),(51581964,425761667,15187194,432736,1,'2007-09-15 02:29:29',3310502513,1),(51581967,425763745,15186271,432736,1,'2007-09-15 02:29:29',3310502513,1),(51581970,425764745,15183963,432736,1,'2007-09-15 02:29:29',3310502513,1),(51581973,425766977,15179884,432736,1,'2007-09-15 02:29:29',3310502513,1),(51581976,425769593,15174729,432736,1,'2007-09-15 02:29:30',3310502513,1),(51581979,425773209,15173190,432736,1,'2007-09-15 02:29:30',3310502513,1),(51581980,425775518,15174498,432736,1,'2007-09-15 02:29:30',3310502513,1),(51581983,425779057,15178730,432736,1,'2007-09-15 02:29:30',3310502513,1),(51581986,425780844,15180962,432736,1,'2007-09-15 02:29:30',3310502513,1),(51581990,425784602,15185299,432736,1,'2007-09-15 02:29:31',3310502516,1),(51581993,425787782,15187539,432736,1,'2007-09-15 02:29:31',3310502516,1),(51581995,425790167,15188479,432736,1,'2007-09-15 02:29:31',3310502516,1),(51581997,425795431,15187817,513066,1,'2008-05-24 16:28:02',3310502516,2),(51582003,425799539,15189362,513066,1,'2008-05-24 16:28:02',3310502516,2),(51582007,425802165,15191225,432736,1,'2007-09-15 02:29:32',3310502516,1),(51582009,425803972,15192237,432736,1,'2007-09-15 02:29:33',3310502516,1),(51582013,425806430,15193105,432736,1,'2007-09-15 02:29:33',3310502516,1),(51582019,425808381,15193249,432736,1,'2007-09-15 02:29:33',3310502516,1),(51582023,425810839,15193105,432736,1,'2007-09-15 02:29:34',3310502517,1),(51582027,425813305,15192368,352026,1,'2008-05-06 16:36:31',3310502517,2),(51582031,425817160,15190566,352026,1,'2008-05-06 16:36:31',3310502517,2),(51582034,425821535,15190503,432736,1,'2007-09-15 02:29:34',3310502517,1),(51582038,425830787,15193538,432736,1,'2007-09-15 02:29:35',3310502517,1),(51582045,425837737,15195491,435967,1,'2007-09-15 21:59:03',3310502688,1),(51582060,425840038,15197007,432736,1,'2007-09-15 02:29:37',3310502688,1),(51582066,425842722,15199558,435967,1,'2007-09-15 21:59:03',3310502688,1),(51582074,425846110,15203946,432736,1,'2007-09-15 02:29:37',3310502688,1),(51582077,425847844,15205464,432736,1,'2007-09-15 02:29:37',3310502688,1),(51582082,425851097,15207994,432736,1,'2007-09-15 02:29:38',3310502688,1),(51582085,425854855,15209976,435967,1,'2007-09-15 21:59:10',3310502688,1),(51582086,425856697,15211289,435967,1,'2007-09-15 21:59:09',3310502688,1),(51582089,425860338,15212121,435967,1,'2007-09-15 21:59:10',3310502688,1),(51582090,425863817,15212041,432736,1,'2007-09-15 02:29:38',3310502688,1),(51582091,425867070,15211246,432736,1,'2007-09-15 02:29:39',3310502689,1),(51582093,425870250,15210812,432736,1,'2007-09-15 02:29:39',3310502689,1),(51582096,425872057,15211174,432736,1,'2007-09-15 02:29:39',3310502689,1),(51582098,425873385,15212163,435967,1,'2007-09-15 21:59:05',3310502689,1),(51582101,425874975,15214562,435967,1,'2007-09-15 21:59:06',3310502689,1),(51582102,425877705,15219839,435967,1,'2007-09-15 21:59:05',3310502691,1),(51582105,425881022,15224055,435967,1,'2007-09-15 21:59:07',3310502691,1),(51582107,425884875,15229067,435967,1,'2007-09-15 21:59:06',3310502691,1),(51582110,425889608,15233427,435967,1,'2007-09-15 21:59:08',3310502691,1),(51582111,425891465,15235636,435967,1,'2007-09-15 21:59:09',3310502691,1),(51582113,425894380,15237198,435967,1,'2007-09-15 21:59:15',3310502694,1),(51582116,425897654,15239013,435967,1,'2007-09-15 21:59:15',3310502694,1),(51582118,425901652,15243324,435967,1,'2007-09-15 21:59:15',3310502694,1),(51582121,425904772,15245312,435967,1,'2007-09-15 21:59:16',3310502694,1),(51582123,425909626,15247243,435967,1,'2007-09-15 21:59:16',3310502694,1),(51582125,425915915,15249707,435967,1,'2007-09-15 21:59:16',3310502694,1),(51582128,425918736,15251628,56648,1,'2008-06-05 18:37:38',3310502694,2),(51582132,425920822,15251628,56648,1,'2008-06-05 18:37:38',3310502695,2),(51582133,425923096,15251371,56648,1,'2008-06-05 18:37:38',3310502695,2),(51582135,425926572,15252830,56648,1,'2008-06-05 18:37:38',3310502695,2),(51582137,425929541,15254461,56648,1,'2008-06-05 18:37:38',3310502695,2),(51582139,425932473,15255248,435967,1,'2007-09-15 21:59:14',3310502695,1),(51582143,425934977,15256527,435967,1,'2007-09-15 21:59:15',3310502695,1),(51582146,425936373,15258720,435967,1,'2007-09-15 21:59:31',3310502695,1),(51582148,425938392,15264027,435967,1,'2007-09-15 21:59:29',3310502695,1),(51582150,425938832,15266168,435967,1,'2007-09-15 21:59:29',3310502695,1),(51582153,425939438,15267609,435967,1,'2007-09-15 21:59:32',3310502695,1),(51582156,425940764,15268783,435967,1,'2007-09-15 21:59:32',3310502695,1),(51582159,425942732,15269466,435967,1,'2007-09-15 21:59:31',3310502695,1),(51582162,425944423,15268806,435967,1,'2007-09-15 21:59:17',3310502695,1),(51582166,425946020,15267969,435967,1,'2007-09-15 21:59:17',3310502695,1),(51582167,425948782,15267011,435967,1,'2007-09-15 21:59:17',3310502706,1),(51582170,425951566,15265521,435967,1,'2007-09-15 21:59:29',3310502706,1),(51582173,425953590,15264708,435967,1,'2007-09-15 21:59:18',3310502706,1),(51582175,425956698,15264472,435967,1,'2007-09-15 21:59:17',3310502706,1),(51582178,425958822,15265032,435967,1,'2007-09-15 21:59:33',3310502706,1),(51582181,425960439,15265447,56648,1,'2008-06-05 18:53:05',3310502706,2),(51582184,425962145,15267507,56648,1,'2008-06-05 19:06:55',3310502706,5),(51582186,425962777,15270082,56648,1,'2008-06-05 18:53:05',3310502706,2),(51582188,425964409,15272714,435967,1,'2007-09-15 21:59:33',3310502712,1),(51582191,425972497,15280633,435967,1,'2007-09-15 21:59:33',3310502712,1),(51582194,425975611,15283712,435967,1,'2007-09-15 21:59:32',3310502713,1),(51582198,425981100,15289995,56648,1,'2008-06-05 19:06:55',3310502713,2),(51582201,425983737,15293894,435967,1,'2007-09-15 21:59:33',3310502713,1),(51582204,425985949,15299244,435967,1,'2007-09-15 21:59:32',3310502713,1),(51582207,425987720,15305229,435967,1,'2007-09-15 21:59:33',3310502713,1),(51582209,425989506,15308460,435967,1,'2007-09-15 21:58:20',3310502713,1),(51582211,425993658,15313825,435967,1,'2007-09-15 21:58:20',3310502713,1),(51582213,425998449,15322111,206510,1,'2008-12-06 19:38:06',3310502713,4),(51582216,426002768,15330406,206510,1,'2008-12-06 19:38:06',3310502718,4),(51582218,426004930,15334815,206510,1,'2008-12-06 19:38:07',3310502718,4),(51582221,426007287,15337885,206510,1,'2008-12-06 19:38:07',3310502718,4),(51582224,426010195,15341353,206510,1,'2008-12-06 19:38:07',3310502718,4),(51582227,426012957,15342897,206510,1,'2008-12-06 19:38:07',3310502718,4),(51582229,426014627,15344049,206510,1,'2008-12-06 19:38:07',3310502718,4),(51582231,426015698,15345743,206510,1,'2008-12-06 19:38:07',3310502718,4),(51582233,426017471,15348577,206510,1,'2008-12-06 19:38:07',3310502718,4),(51582234,426018707,15350336,206510,1,'2008-12-06 19:38:07',3310502718,4),(51582237,426022777,15352858,206510,1,'2008-12-06 19:38:07',3310502718,4),(51582239,426028754,15356287,206510,1,'2008-12-06 19:38:07',3310502718,4),(51582241,426032887,15357920,206510,1,'2008-12-06 19:38:07',3310502719,4),(51582242,426036089,15359446,206510,1,'2008-12-06 19:38:07',3310502719,4),(51582245,426038695,15360438,206510,1,'2008-12-06 19:38:07',3310502719,4),(51582247,426042532,15360564,206510,1,'2008-12-06 19:38:07',3310502719,4),(51582251,426046307,15360880,206510,1,'2008-12-06 19:38:07',3310502719,4),(51582253,426048947,15361306,206510,1,'2008-12-06 19:38:07',3310502719,4),(51582256,426051752,15362430,206510,1,'2008-12-06 19:38:07',3310502719,4),(51582258,426055484,15365163,206510,1,'2008-12-06 19:38:07',3310502719,4),(51582261,426060694,15368337,206510,1,'2008-12-06 19:38:07',3310502762,4),(51582264,426065421,15371269,206510,1,'2008-12-06 19:38:08',3310502762,4),(51582267,426070148,15373270,206510,1,'2008-12-06 19:38:08',3310502762,4),(51582270,426073252,15374167,206510,1,'2008-12-06 19:38:08',3310502762,4),(51582271,426077237,15373982,206510,1,'2008-12-06 19:38:08',3310502762,4),(51582274,426083085,15373396,206510,1,'2008-12-06 19:38:08',3310502762,4),(51582279,426086501,15374486,206510,1,'2008-12-06 19:38:08',3310502763,4),(51582282,426087795,15375728,206510,1,'2008-12-06 19:38:08',3310502763,4),(51582284,426089966,15377742,206510,1,'2008-12-06 19:38:08',3310502763,4),(51582287,426091985,15379862,206510,1,'2008-12-06 19:38:08',3310502763,4),(51582290,426093173,15381725,206510,1,'2008-12-06 19:38:08',3310502849,4),(51582293,426094880,15382865,206510,1,'2008-12-06 19:38:08',3310502849,4),(51582294,426096636,15383072,206510,1,'2008-12-06 19:38:08',3310502849,4),(51582297,426100029,15383823,206510,1,'2008-12-06 19:38:08',3310502849,4),(51582300,426102682,15384595,206510,1,'2008-12-06 19:38:08',3310502849,4),(51582303,426108081,15386953,206510,1,'2008-12-06 19:38:08',3310502849,4),(51582306,426111647,15389437,206510,1,'2008-12-06 19:38:09',3310502852,4),(51582308,426114394,15390890,206510,1,'2008-12-06 19:38:09',3310502852,4),(51582309,426117453,15390474,206510,1,'2008-12-06 19:38:09',3310502852,4),(51582311,426122521,15389130,206510,1,'2008-12-06 19:38:09',3310502852,4),(51582313,426126820,15387886,206510,1,'2008-12-06 19:38:09',3310502852,4),(51582315,426130235,15387421,206510,1,'2008-12-06 19:38:09',3310502852,4),(51582316,426139807,15386696,206510,1,'2008-12-06 19:38:09',3310502853,4),(51582318,426146535,15386177,206510,1,'2008-12-06 19:38:09',3310502853,4),(51582320,426149847,15385609,206510,1,'2008-12-06 19:38:09',3310502853,4),(51582323,426154919,15384781,206510,1,'2008-12-06 19:38:09',3310502853,4),(51582326,426158335,15384173,206510,1,'2008-12-06 19:38:09',3310502853,4),(51582329,426161543,15384179,206510,1,'2008-12-06 19:38:09',3310502853,4),(51582332,426162921,15384989,206510,1,'2008-12-06 19:38:09',3310502853,4),(51582335,426164492,15387970,206510,1,'2008-12-06 19:38:09',3310502853,4),(51582338,426166519,15390702,206510,1,'2008-12-06 19:38:09',3310502864,4),(51582339,426168281,15392203,206510,1,'2008-12-06 19:38:09',3310502864,4),(51582342,426170270,15393065,206510,1,'2008-12-06 19:38:09',3310502864,4),(51582345,426172108,15392620,206510,1,'2008-12-06 19:38:09',3310502864,4),(51582346,426172942,15392024,206510,1,'2008-12-06 19:38:09',3310502864,4),(51582349,426173539,15391309,206510,1,'2008-12-06 19:38:09',3310502864,4),(51582352,426174135,15389401,206510,1,'2008-12-06 19:38:10',3310502864,4),(51582355,426174850,15387254,206510,1,'2008-12-06 19:38:10',3310502864,4),(51582357,426174969,15384273,206510,1,'2008-12-06 19:38:10',3310502864,4),(51582360,426175566,15382008,206510,1,'2008-12-06 19:38:10',3310502864,4),(51582362,426176504,15380393,206510,1,'2008-12-06 19:38:10',3310502778,4),(51582365,426178845,15377504,206510,1,'2008-12-06 19:38:10',3310502778,4),(51582368,426181393,15374073,206510,1,'2008-12-06 19:38:10',3310502778,4),(51582371,426184021,15370832,206510,1,'2008-12-06 19:38:10',3310502778,4),(51582373,426185392,15369174,206510,1,'2008-12-06 19:38:10',3310502778,4),(51582377,426186878,15368416,206510,1,'2008-12-06 19:38:10',3310502778,4),(51582380,426187533,15368443,206510,1,'2008-12-06 19:38:11',3310502778,4),(51582383,426188178,15368811,206510,1,'2008-12-06 19:38:11',3310502778,4),(51582385,426188324,15370003,206510,1,'2008-12-06 19:38:11',3310502778,4),(51582388,426187918,15371755,206510,1,'2008-12-06 19:38:11',3310502778,4),(51582392,426186113,15375244,206510,1,'2008-12-06 19:38:11',3310502778,4),(51582395,426184389,15378073,206510,1,'2008-12-06 19:38:11',3310502778,4),(51582399,426184270,15380458,206510,1,'2008-12-06 19:38:11',3310502778,4),(51582403,426184270,15384273,206510,1,'2008-12-06 19:38:11',3310502864,4),(51582405,426184746,15388447,206510,1,'2008-12-06 19:38:11',3310502864,4),(51582407,426186789,15392550,206510,1,'2008-12-06 19:38:11',3310502864,4),(51582410,426188941,15394913,206510,1,'2008-12-06 19:38:11',3310502864,4),(51582413,426190616,15397141,206510,1,'2008-12-06 19:38:11',3310502864,4),(51582415,426191841,15397803,206510,1,'2008-12-06 19:38:11',3310502864,4),(51582418,426192584,15396697,206510,1,'2008-12-06 19:38:11',3310502864,4),(51582421,426192297,15394751,206510,1,'2008-12-06 19:38:12',3310502864,4),(51582424,426191744,15392788,206510,1,'2008-12-06 19:38:12',3310502864,4),(51582426,426191386,15390869,206510,1,'2008-12-06 19:38:12',3310502864,4),(51582429,426191956,15388523,206510,1,'2008-12-06 19:38:12',3310502864,4),(51582432,426192726,15386946,206510,1,'2008-12-06 19:38:12',3310502864,4),(51582435,426193387,15385071,206510,1,'2008-12-06 19:38:12',3310502864,4),(51582437,426194097,15384513,206510,1,'2008-12-06 19:38:12',3310502865,4),(51582439,426194877,15384220,206510,1,'2008-12-06 19:38:12',3310502865,4),(51582441,426195240,15385358,206510,1,'2008-12-06 19:38:12',3310502865,4),(51582444,426194714,15386285,206510,1,'2008-12-06 19:38:12',3310502865,4),(51582446,426194286,15387174,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582448,426193868,15388573,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582451,426194115,15389789,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582453,426194995,15391049,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582455,426196383,15393064,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582459,426197922,15395531,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582462,426199294,15398344,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582463,426200248,15401682,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582465,426200606,15404306,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582469,426201083,15407287,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582472,426202156,15410745,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582474,426203453,15414051,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582476,426204302,15416826,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582479,426204581,15419629,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582482,426205684,15423980,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582483,426206640,15427136,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582486,426207094,15428375,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582489,426208100,15428666,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582492,426208720,15427898,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582495,426208368,15425123,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582496,426207880,15422311,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582499,426207760,15420641,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582501,426207999,15418137,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582502,426208476,15415395,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582504,426208714,15413249,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582506,426208714,15410983,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582508,426208237,15408360,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582509,426207641,15404663,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582510,426207045,15401086,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582512,426206926,15397748,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582516,426206806,15394051,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582518,426206449,15390593,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582521,426206449,15387612,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582523,426207641,15384035,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582525,426209072,15379265,206510,1,'2008-12-06 19:38:14',3310502779,4),(51582527,426217740,15364049,206510,1,'2008-12-06 19:38:14',3310502779,4),(51582530,426227492,15346850,206510,1,'2008-12-06 19:38:14',3310502782,4),(51587693,425555805,15331384,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51587694,425555327,15332479,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51587703,425553935,15331764,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51587705,425554323,15330268,1684788,1,'2009-06-30 11:19:38',3310502459,4),(51587707,425554719,15330070,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51587715,425553941,15330926,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51587721,425554390,15332498,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51587723,425554962,15332645,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51587726,425555647,15332069,1684788,1,'2009-06-30 11:19:38',3310502459,3),(51587729,425555709,15330791,1684788,1,'2009-06-30 11:19:39',3310502459,4),(51587732,425555298,15330212,1684788,1,'2009-06-30 11:19:39',3310502459,4),(51589112,425553377,15329156,498434,1,'2008-05-22 18:27:07',3310502459,2),(51589115,425552555,15328555,498434,1,'2008-05-22 18:27:07',3310502459,2),(51589117,425551607,15327782,498434,1,'2008-05-22 18:27:07',3310502459,2),(51589119,425550595,15326838,498434,1,'2008-05-22 18:27:07',3310502459,2),(51589122,425549204,15325723,498434,1,'2008-05-22 18:27:07',3310502457,2),(51589125,425548192,15324864,498434,1,'2008-05-22 18:27:07',3310502457,2),(51589128,425546754,15323865,432736,1,'2007-09-15 02:41:19',3310502457,1),(51589130,425545351,15322641,432736,1,'2007-09-15 02:41:19',3310502457,1),(51589133,425542940,15321462,432736,1,'2007-09-15 02:41:19',3310502457,1),(51589136,425540877,15320172,432736,1,'2007-09-15 02:41:19',3310502457,1),(51589138,425539459,15319312,432736,1,'2007-09-15 02:41:20',3310502457,1),(51589142,425538255,15319140,432736,1,'2007-09-15 02:41:20',3310502457,1),(51589144,425537352,15319484,432736,1,'2007-09-15 02:41:20',3310502457,1),(51589146,425536837,15320258,432736,1,'2007-09-15 02:41:20',3310502457,1),(51589149,425536708,15321247,432736,1,'2007-09-15 02:41:20',3310502457,1),(51589152,425537352,15322536,432736,1,'2007-09-15 02:41:20',3310502457,1),(51589155,425537825,15324599,432736,1,'2007-09-15 02:41:20',3310502457,1),(51589157,425538470,15327823,432736,1,'2007-09-15 02:41:21',3310502459,1),(51589158,425538728,15331004,432736,1,'2007-09-15 02:41:21',3310502459,1),(51589160,425539373,15333755,432736,1,'2007-09-15 02:41:21',3310502459,1),(51589161,425539502,15335346,432736,1,'2007-09-15 02:41:21',3310502459,1),(51589162,425539545,15336721,432736,1,'2007-09-15 02:41:21',3310502459,1),(51589163,425538943,15337839,432736,1,'2007-09-15 02:41:21',3310502459,1),(51589165,425538126,15338355,432736,1,'2007-09-15 02:41:22',3310502459,1),(51589169,425537137,15338355,432736,1,'2007-09-15 02:41:22',3310502459,1),(51589172,425536321,15337710,432736,1,'2007-09-15 02:41:22',3310502459,1),(51589174,425535332,15336506,432736,1,'2007-09-15 02:41:22',3310502459,1),(51589177,425533413,15333574,432736,1,'2007-09-15 02:41:22',3310502458,1),(51589180,425531530,15331521,432736,1,'2007-09-15 02:41:22',3310502458,1),(51589183,425529705,15330266,432736,1,'2007-09-15 02:41:22',3310502458,1),(51589185,425527708,15329581,432736,1,'2007-09-15 02:41:23',3310502458,1),(51589187,425525426,15328783,432736,1,'2007-09-15 02:41:23',3310502458,1),(51589190,425523886,15327185,432736,1,'2007-09-15 02:41:23',3310502458,1),(51589192,425522403,15325189,432736,1,'2007-09-15 02:41:23',3310502456,1),(51589194,425521319,15321253,432736,1,'2007-09-15 02:41:23',3310502456,1),(51589196,425520463,15317887,432736,1,'2007-09-15 02:41:24',3310502456,1),(51589198,425519265,15314521,432736,1,'2007-09-15 02:41:24',3310502456,1),(51589201,425518182,15311441,432736,1,'2007-09-15 02:41:24',3310502456,1),(51589203,425516870,15308532,432736,1,'2007-09-15 02:41:24',3310502456,1),(51589205,425515272,15307162,432736,1,'2007-09-15 02:41:24',3310502456,1),(51589208,425512477,15305907,432736,1,'2007-09-15 02:41:25',3310502456,1),(51589210,425511507,15304710,432736,1,'2007-09-15 02:41:25',3310502456,1),(51589213,425511336,15303226,432736,1,'2007-09-15 02:41:25',3310502456,1),(51589215,425511393,15300431,432736,1,'2007-09-15 02:41:25',3310502456,1),(51589217,425510880,15298206,432736,1,'2007-09-15 02:41:25',3310502456,1),(51589220,425509796,15294898,432736,1,'2007-09-15 02:41:26',3310502456,1),(51589223,425508826,15292103,432736,1,'2007-09-15 02:41:26',3310502456,1),(51589226,425508427,15289878,432736,1,'2007-09-15 02:41:26',3310502456,1),(51589229,425508256,15287653,432736,1,'2007-09-15 02:41:26',3310502456,1),(51589230,425507914,15285257,432736,1,'2007-09-15 02:41:26',3310502456,1),(51589233,425506830,15284744,432736,1,'2007-09-15 02:41:26',3310502445,1),(51589236,425505917,15284744,432736,1,'2007-09-15 02:41:27',3310502445,1),(51589238,425505232,15285885,432736,1,'2007-09-15 02:41:27',3310502445,1),(51589243,425504833,15288452,432736,1,'2007-09-15 02:41:27',3310502445,1),(51589247,425504662,15291133,432736,1,'2007-09-15 02:41:27',3310502445,1),(51589249,425503806,15293186,432736,1,'2007-09-15 02:41:27',3310502445,1),(51589252,425503350,15295126,432736,1,'2007-09-15 02:41:28',3310502445,1),(51589254,425503122,15297065,432736,1,'2007-09-15 02:41:28',3310502445,1),(51589256,425503350,15299804,432736,1,'2007-09-15 02:41:28',3310502445,1),(51589259,425504263,15304025,432736,1,'2007-09-15 02:41:28',3310502445,1),(51589262,425504890,15306649,432736,1,'2007-09-15 02:41:28',3310502445,1),(51589263,425504947,15309501,432736,1,'2007-09-15 02:41:29',3310502445,1),(51589267,425504719,15312411,432736,1,'2007-09-15 02:41:29',3310502445,1),(51589270,425504776,15316974,432736,1,'2007-09-15 02:41:29',3310502445,1),(51589273,425504719,15321367,432736,1,'2007-09-15 02:41:29',3310502445,1),(51589275,425504605,15323021,432736,1,'2007-09-15 02:41:29',3310502445,1),(51589278,425505862,15329177,432736,1,'2007-09-15 02:41:29',3310502447,1),(51589281,425506848,15332135,432736,1,'2007-09-15 02:41:30',3310502447,1),(51589284,425507834,15334763,432736,1,'2007-09-15 02:41:30',3310502458,1),(51589288,425507751,15337803,432736,1,'2007-09-15 02:41:30',3310502458,1),(51589290,425506154,15340352,434787,1,'2007-09-15 13:10:20',3310502447,1),(51589293,425505908,15344788,434787,1,'2007-09-15 13:10:20',3310502447,1),(51589296,425505826,15347170,434787,1,'2007-09-15 13:10:19',3310502447,1),(51589297,425506976,15351524,434787,1,'2007-09-15 13:10:19',3310502447,1),(51589299,425509933,15358506,434787,1,'2007-09-15 13:10:19',3310502458,1),(51589302,425512726,15364010,434787,1,'2007-09-15 13:10:19',3310502458,1),(51589304,425514697,15368363,434787,1,'2007-09-15 13:10:19',3310502458,1),(51589307,425515683,15372799,434787,1,'2007-09-15 13:10:18',3310502458,1),(51589310,425516587,15379453,434787,1,'2007-09-15 13:10:19',3310502458,1),(51589313,425517819,15385449,434787,1,'2007-09-15 13:10:21',3310502544,1),(51589315,425519051,15390542,434787,1,'2007-09-15 13:10:21',3310502544,1),(51589320,425520612,15395143,434787,1,'2007-09-15 13:10:21',3310502544,1),(51589325,425523651,15399496,434787,1,'2007-09-15 13:10:21',3310502544,1),(51589328,425526608,15403193,434787,1,'2007-09-15 13:10:21',3310502544,1),(51589334,425529894,15406068,434787,1,'2007-09-15 13:10:21',3310502544,1),(51589337,425532687,15407136,434787,1,'2007-09-15 13:10:20',3310502544,1),(51589338,425535809,15407793,434787,1,'2007-09-15 13:10:20',3310502545,1),(51589340,425537944,15410339,434787,1,'2007-09-15 13:10:20',3310502545,1),(51589342,425539341,15412968,434787,1,'2007-09-15 13:10:20',3310502545,1),(51589344,425540737,15413543,434787,1,'2007-09-15 13:10:23',3310502545,1),(51589348,425542462,15412968,434787,1,'2007-09-15 13:10:23',3310502545,1),(51589352,425544762,15411243,434787,1,'2007-09-15 13:10:23',3310502545,1),(51589354,425546980,15409354,434787,1,'2007-09-15 13:10:23',3310502545,1),(51589357,425549116,15408532,434787,1,'2007-09-15 13:10:22',3310502545,1),(51589360,425550513,15408532,434787,1,'2007-09-15 13:10:22',3310502545,1),(51589363,425551663,15409436,434787,1,'2007-09-15 13:10:22',3310502545,1),(51589366,425552402,15411489,434787,1,'2007-09-15 13:10:22',3310502545,1),(51589368,425553141,15415432,434787,1,'2007-09-15 13:10:22',3310502545,1),(51589370,425554866,15423400,434787,1,'2007-09-15 13:10:21',3310502545,1),(51590535,425555649,15427255,434787,1,'2007-09-15 13:10:15',3310502545,1),(51590538,425555931,15430557,434787,1,'2007-09-15 13:10:15',3310502545,1),(51590542,425555891,15433214,434787,1,'2007-09-15 13:10:15',3310502545,1),(51590544,425556253,15435832,434787,1,'2007-09-15 13:10:15',3310502545,1),(51590546,425557421,15438570,434787,1,'2007-09-15 13:10:15',3310502547,1),(51590549,425558790,15441348,434787,1,'2007-09-15 13:10:16',3310502547,1),(51590551,425559394,15443160,434787,1,'2007-09-15 13:10:16',3310502547,1),(51590553,425559796,15446220,434787,1,'2007-09-15 13:10:16',3310502547,1),(51590557,425559149,15451087,434787,1,'2007-09-15 13:10:16',3310502547,1),(51590560,425559149,15453258,434787,1,'2007-09-15 13:10:16',3310502547,1),(51590563,425559817,15454845,434787,1,'2007-09-15 13:10:16',3310502547,1),(51590564,425562406,15457767,434787,1,'2007-09-15 13:10:16',3310502550,1),(51590567,425564910,15459854,434787,1,'2007-09-15 13:10:17',3310502550,1),(51590572,425565411,15461107,434787,1,'2007-09-15 13:10:17',3310502550,1),(51590575,425565411,15462526,434787,1,'2007-09-15 13:10:17',3310502550,1),(51590578,425564409,15463361,434787,1,'2007-09-15 13:10:17',3310502550,1),(51590580,425563408,15463194,434787,1,'2007-09-15 13:10:17',3310502550,1),(51590582,425562155,15461607,434787,1,'2007-09-15 13:10:17',3310502550,1),(51590585,425559901,15459270,434787,1,'2007-09-15 13:10:17',3310502547,1),(51590588,425557730,15457433,434787,1,'2007-09-15 13:10:18',3310502547,1),(51590589,425556645,15457266,434787,1,'2007-09-15 13:10:18',3310502547,1),(51590592,425556227,15458184,434787,1,'2007-09-15 13:10:10',3310502547,1),(51590595,425556227,15459353,434787,1,'2007-09-15 13:10:10',3310502547,1),(51590598,425556979,15460439,434787,1,'2007-09-15 13:10:10',3310502547,1),(51590600,425558899,15462442,434787,1,'2007-09-15 13:10:11',3310502547,1),(51590603,425560318,15464279,434787,1,'2007-09-15 13:10:11',3310502547,1),(51590606,425561738,15467202,434787,1,'2007-09-15 13:10:11',3310502547,1),(51590608,425562239,15470458,434787,1,'2007-09-15 13:10:11',3310502550,1),(51590611,425562656,15472378,434787,1,'2007-09-15 13:10:11',3310502550,1),(51590613,425563241,15474298,434787,1,'2007-09-15 13:10:11',3310502550,1),(51590616,425564409,15475551,434787,1,'2007-09-15 13:10:12',3310502550,1),(51590619,425566747,15476970,434787,1,'2007-09-15 13:10:12',3310502550,1),(51590622,425568751,15477889,434787,1,'2007-09-15 13:10:12',3310502550,1),(51590623,425570671,15479466,434787,1,'2007-09-15 13:10:12',3310502550,1),(51590626,425572897,15481055,434787,1,'2007-09-15 13:10:13',3310502550,1),(51590630,425574397,15482596,434787,1,'2007-09-15 13:10:13',3310502550,1),(51590631,425576139,15485138,434787,1,'2007-09-15 13:10:12',3310502550,1),(51590633,425577846,15488576,434787,1,'2007-09-15 13:10:13',3310502550,1),(51590634,425578080,15490476,434787,1,'2007-09-15 13:10:14',3310502550,1),(51590635,425578362,15491882,434787,1,'2007-09-15 13:10:14',3310502556,1),(51590636,425577975,15492667,434787,1,'2007-09-15 13:10:13',3310502556,1),(51590637,425577424,15493142,434787,1,'2007-09-15 13:10:13',3310502556,1),(51590638,425576700,15493147,434787,1,'2007-09-15 13:10:13',3310502556,1),(51590643,425575865,15491984,434787,1,'2007-09-15 13:10:14',3310502556,1),(51590645,425574926,15489191,434787,1,'2007-09-15 13:10:14',3310502550,1),(51590646,425573626,15487597,434787,1,'2007-09-15 13:10:14',3310502550,1),(51590648,425571256,15486405,434787,1,'2007-09-15 13:10:15',3310502550,1),(51590650,425566831,15484401,434787,1,'2007-09-15 13:10:15',3310502550,1),(51590653,425563074,15482481,434787,1,'2007-09-15 13:10:14',3310502550,1),(51590654,425559817,15480978,434787,1,'2007-09-15 13:10:15',3310502547,1),(51590657,425556895,15479559,434787,1,'2007-09-15 13:10:10',3310502547,1),(51590660,425555225,15478223,434787,1,'2007-09-15 13:10:10',3310502547,1),(51590663,425554004,15475980,434787,1,'2007-09-15 13:10:10',3310502547,1),(51590665,425551946,15471252,434787,1,'2007-09-15 13:10:10',3310502547,1),(51590668,425550521,15467294,434787,1,'2007-09-15 13:10:09',3310502547,1),(51590669,425548451,15463735,434787,1,'2007-09-15 13:10:09',3310502547,1),(51590671,425545923,15461443,434787,1,'2007-09-15 13:10:09',3310502547,1),(51590673,425543447,15459673,434787,1,'2007-09-15 13:10:08',3310502547,1),(51590676,425542796,15458654,434787,1,'2007-09-15 13:10:08',3310502547,1),(51590679,425543116,15457358,434787,1,'2007-09-15 13:10:08',3310502547,1),(51590680,425544224,15455495,434787,1,'2007-09-15 13:10:08',3310502547,1),(51590683,425544446,15453984,434787,1,'2007-09-15 13:10:08',3310502547,1),(51590686,425544705,15451695,434787,1,'2007-09-15 13:10:08',3310502547,1),(51590687,425544581,15447293,434787,1,'2007-09-15 13:10:07',3310502547,1),(51590690,425544377,15443187,434787,1,'2007-09-15 13:10:07',3310502547,1),(51590691,425543168,15441111,434787,1,'2007-09-15 13:10:07',3310502547,1),(51590693,425541616,15440484,434787,1,'2007-09-15 13:10:07',3310502547,1),(51590695,425540029,15440233,434787,1,'2007-09-15 13:10:07',3310502547,1),(51590699,425538102,15441760,434787,1,'2007-09-15 13:10:07',3310502547,1),(51590702,425535516,15443699,434787,1,'2007-09-15 13:10:06',3310502547,1),(51590705,425533208,15444899,434787,1,'2007-09-15 13:10:06',3310502546,1),(51590707,425531699,15444426,434787,1,'2007-09-15 13:10:06',3310502546,1),(51590708,425530689,15442764,434787,1,'2007-09-15 13:10:06',3310502546,1),(51590711,425530258,15440917,434787,1,'2007-09-15 13:10:06',3310502546,1),(51590714,425529310,15438406,434787,1,'2007-09-15 13:10:06',3310502546,1),(51590716,425527691,15437371,434787,1,'2007-09-15 13:10:05',3310502546,1),(51590719,425523974,15436804,434787,1,'2007-09-15 13:10:05',3310502546,1),(51590722,425520899,15437298,434787,1,'2007-09-15 13:10:05',3310502546,1),(51590725,425518624,15437688,434787,1,'2007-09-15 13:10:05',3310502546,1),(51590728,425516244,15437408,434787,1,'2007-09-15 13:10:04',3310502546,1),(51590730,425514311,15436915,434787,1,'2007-09-15 13:10:04',3310502546,1),(51929590,425512717,15436876,434787,1,'2007-09-15 13:06:23',3310502546,1),(51929593,425510506,15436823,434787,1,'2007-09-15 13:06:23',3310502546,1),(51929595,425509454,15436297,434787,1,'2007-09-15 13:06:23',3310502546,1),(51929598,425508717,15435139,434787,1,'2007-09-15 13:06:23',3310502544,1),(51929600,425508349,15432245,434787,1,'2007-09-15 13:06:23',3310502544,1),(51929603,425507770,15430140,434787,1,'2007-09-15 13:06:23',3310502544,1),(51929607,425507349,15429140,434787,1,'2007-09-15 13:06:23',3310502544,1),(51929610,425506349,15428140,434787,1,'2007-09-15 13:06:24',3310502533,1),(51929614,425505454,15427509,434787,1,'2007-09-15 13:06:24',3310502533,1),(51929617,425504507,15426561,434787,1,'2007-09-15 13:06:24',3310502533,1),(51929619,425503139,15425140,434787,1,'2007-09-15 13:06:24',3310502533,1),(51929620,425501981,15424562,434787,1,'2007-09-15 13:06:25',3310502533,1),(51929623,425500718,15424562,434787,1,'2007-09-15 13:06:25',3310502533,1),(51929625,425498823,15424456,434787,1,'2007-09-15 13:06:25',3310502533,1),(51929626,425497297,15424088,434787,1,'2007-09-15 13:06:25',3310502533,1),(51929628,425496455,15423667,434787,1,'2007-09-15 13:06:25',3310502533,1),(51929630,425495824,15422772,434787,1,'2007-09-15 13:06:26',3310502533,1),(51929632,425495403,15421246,434787,1,'2007-09-15 13:06:26',3310502533,1),(51929634,425494982,15419457,434787,1,'2007-09-15 13:06:26',3310502533,1),(51929636,425494455,15416194,434787,1,'2007-09-15 13:06:26',3310502533,1),(51929638,425494245,15413826,434787,1,'2007-09-15 13:06:26',3310502533,1),(51929640,425494140,15411984,434787,1,'2007-09-15 13:06:27',3310502533,1),(51929642,425493929,15410037,434787,1,'2007-09-15 13:06:27',3310502533,1),(51929644,425493508,15409090,434787,1,'2007-09-15 13:06:27',3310502533,1),(51929645,425492666,15408932,434787,1,'2007-09-15 13:06:27',3310502533,1),(51929647,425492456,15409353,434787,1,'2007-09-15 13:06:27',3310502533,1),(51929649,425492403,15410300,434787,1,'2007-09-15 13:06:27',3310502533,1),(51929650,425492350,15411931,434787,1,'2007-09-15 13:06:28',3310502533,1),(51929653,425492350,15413615,434787,1,'2007-09-15 13:06:28',3310502533,1),(51929656,425492666,15418878,434787,1,'2007-09-15 13:06:28',3310502533,1),(51929657,425493192,15421930,434787,1,'2007-09-15 13:06:28',3310502533,1),(51929660,425494455,15427614,434787,1,'2007-09-15 13:06:28',3310502533,1),(51929661,425494719,15428456,434787,1,'2007-09-15 13:06:28',3310502533,1),(51929663,425495297,15428877,434787,1,'2007-09-15 13:06:29',3310502533,1),(51929665,425496087,15429140,434787,1,'2007-09-15 13:06:29',3310502533,1),(51929667,425497876,15429298,434787,1,'2007-09-15 13:06:29',3310502533,1),(51929670,425499297,15429351,434787,1,'2007-09-15 13:06:29',3310502533,1),(51929671,425500455,15429666,434787,1,'2007-09-15 13:06:29',3310502533,1),(51929673,425501718,15430982,434787,1,'2007-09-15 13:06:29',3310502533,1),(51929675,425502770,15432298,434787,1,'2007-09-15 13:06:29',3310502533,1),(51929677,425503454,15433666,434787,1,'2007-09-15 13:06:29',3310502533,1),(51929678,425503981,15436297,434787,1,'2007-09-15 13:06:30',3310502535,1),(51929680,425504191,15438560,434787,1,'2007-09-15 13:06:30',3310502535,1),(51929682,425503981,15442875,434787,1,'2007-09-15 13:06:30',3310502535,1),(51929684,425504297,15444612,434787,1,'2007-09-15 13:06:30',3310502535,1),(51929687,425505612,15446086,434787,1,'2007-09-15 13:06:30',3310502535,1),(51929689,425507244,15446507,434787,1,'2007-09-15 13:06:30',3310502546,1),(51929690,425509454,15446664,434787,1,'2007-09-15 13:06:31',3310502546,1),(51929693,425511612,15447349,434787,1,'2007-09-15 13:06:31',3310502546,1),(51929696,425513980,15448769,434787,1,'2007-09-15 13:06:31',3310502546,1),(51929700,425516032,15450243,434787,1,'2007-09-15 13:06:31',3310502546,1),(51929702,425518084,15451559,434787,1,'2007-09-15 13:06:31',3310502546,1),(51929704,425518663,15452348,434787,1,'2007-09-15 13:06:31',3310502546,1),(51929707,425518769,15453927,434787,1,'2007-09-15 13:06:32',3310502546,1),(51929709,425519453,15456505,434787,1,'2007-09-15 13:06:32',3310502546,1),(51929711,425520453,15458768,434787,1,'2007-09-15 13:06:32',3310502546,1),(51929713,425521716,15460821,434787,1,'2007-09-15 13:06:32',3310502546,1),(51929715,425522768,15463663,434787,1,'2007-09-15 13:06:32',3310502546,1),(51929717,425523610,15466399,434787,1,'2007-09-15 13:06:32',3310502546,1),(51929720,425524400,15469136,434787,1,'2007-09-15 13:06:32',3310502546,1),(51929722,425525242,15471451,434787,1,'2007-09-15 13:06:33',3310502546,1),(51929725,425525978,15473030,434787,1,'2007-09-15 13:06:33',3310502546,1),(51929728,425527136,15474819,434787,1,'2007-09-15 13:06:33',3310502546,1),(51929731,425528820,15476661,434787,1,'2007-09-15 13:06:33',3310502546,1),(51929734,425531136,15478608,434787,1,'2007-09-15 13:06:33',3310502546,1),(51929736,425532767,15480135,434787,1,'2007-09-15 13:06:33',3310502546,1),(51929739,425533571,15481367,434787,1,'2007-09-15 13:06:33',3310502546,1),(51929741,425534577,15483092,434787,1,'2007-09-15 13:06:34',3310502547,1),(51929743,425535382,15485018,434787,1,'2007-09-15 13:06:34',3310502547,1),(51929746,425535899,15488008,434787,1,'2007-09-15 13:06:34',3310502547,1),(51929749,425536647,15490653,434787,1,'2007-09-15 13:06:34',3310502547,1),(51929752,425537653,15492492,434787,1,'2007-09-15 13:06:34',3310502553,1),(51929754,425538544,15493815,434787,1,'2007-09-15 13:06:34',3310502553,1),(51929757,425539320,15495425,434787,1,'2007-09-15 13:06:34',3310502553,1),(51929760,425539953,15497983,434787,1,'2007-09-15 13:06:35',3310502553,1),(51929762,425540355,15500542,434787,1,'2007-09-15 13:06:35',3310502553,1),(51929764,425541116,15503323,434787,1,'2007-09-15 13:06:35',3310502553,1),(51929767,425541564,15505265,434787,1,'2007-09-15 13:06:35',3310502553,1),(51929770,425542722,15508142,434787,1,'2007-09-15 13:06:35',3310502553,1),(51929771,425544366,15511056,434787,1,'2007-09-15 13:06:36',3310502553,1),(51929773,425546085,15513820,434787,1,'2007-09-15 13:06:36',3310502553,1),(51929775,425547579,15516585,434787,1,'2007-09-15 13:06:36',3310502553,1),(51929777,425549148,15519424,434787,1,'2007-09-15 13:06:37',3310502553,1),(51929780,425550456,15521927,434787,1,'2007-09-15 13:06:37',3310502553,1),(51929782,425550941,15523982,434787,1,'2007-09-15 13:06:37',3310502553,1),(51929784,425550904,15526037,434787,1,'2007-09-15 13:06:37',3310502553,1),(51929785,425550493,15527606,434787,1,'2007-09-15 13:06:37',3310502553,1),(51929786,425549335,15531790,434787,1,'2007-09-15 13:06:37',3310502553,1),(51929788,425548364,15536049,434787,1,'2007-09-15 13:06:37',3310502553,1),(51929790,425547841,15539710,434787,1,'2007-09-15 13:06:37',3310502553,1),(51929793,425547392,15544342,434787,1,'2007-09-15 13:06:37',3310502553,1),(51929796,425547654,15546175,434787,1,'2007-09-15 13:06:38',3310502555,1),(51929797,425548102,15548132,434787,1,'2007-09-15 13:06:38',3310502555,1),(51929800,425548178,15549921,434787,1,'2007-09-15 13:06:38',3310502555,1),(51929802,425547874,15551597,434787,1,'2007-09-15 13:06:38',3310502555,1),(51929805,425547645,15553310,434787,1,'2007-09-15 13:06:38',3310502555,1),(51929807,425547836,15554681,434787,1,'2007-09-15 13:06:38',3310502555,1),(51929810,425548064,15555519,434787,1,'2007-09-15 13:06:38',3310502555,1),(51929812,425548826,15556470,434787,1,'2007-09-15 13:06:38',3310502555,1),(51929814,425549701,15557346,434787,1,'2007-09-15 13:06:39',3310502555,1),(51929818,425551415,15557879,434787,1,'2007-09-15 13:06:39',3310502555,1),(51929820,425553547,15557841,434787,1,'2007-09-15 13:06:39',3310502555,1),(51929823,425554804,15557499,434787,1,'2007-09-15 13:06:39',3310502555,1),(51929825,425556822,15556889,434787,1,'2007-09-15 13:06:39',3310502555,1),(51929827,425558307,15556699,434787,1,'2007-09-15 13:06:40',3310502555,1),(51929829,425560210,15556965,434787,1,'2007-09-15 13:06:40',3310502555,1),(51929833,425561162,15558146,434787,1,'2007-09-15 13:06:40',3310502555,1),(51929834,425561924,15561306,434787,1,'2007-09-15 13:06:40',3310502558,1),(51929837,425562305,15563439,434787,1,'2007-09-15 13:06:40',3310502558,1),(51929840,425562343,15565799,434787,1,'2007-09-15 13:06:40',3310502558,1),(51929842,425562305,15567589,434787,1,'2007-09-15 13:06:41',3310502558,1),(51929844,425561581,15570445,434787,1,'2007-09-15 13:06:41',3310502555,1),(51929846,425560858,15574100,434787,1,'2007-09-15 13:06:41',3310502555,1),(51929848,425560858,15576346,434787,1,'2007-09-15 13:06:41',3310502555,1),(51929852,425561048,15579773,434787,1,'2007-09-15 13:06:41',3310502555,1),(51929854,425561391,15583543,434787,1,'2007-09-15 13:06:41',3310502555,1),(51929858,425561543,15586056,434787,1,'2007-09-15 13:06:41',3310502555,1),(51929860,425561467,15587541,434787,1,'2007-09-15 13:06:42',3310502555,1),(51929862,425561162,15589331,434787,1,'2007-09-15 13:06:42',3310502555,1),(51929864,425560627,15593102,434787,1,'2007-09-15 13:06:42',3310502555,1),(51929866,425560510,15595469,434787,1,'2007-09-15 13:06:42',3310502555,1),(51929869,425560006,15599156,434787,1,'2007-09-15 13:06:42',3310502555,1),(51929872,425559812,15602416,434787,1,'2007-09-15 13:06:43',3310502577,1),(51929873,425559695,15605443,434787,1,'2007-09-15 13:06:43',3310502577,1),(51929875,425559307,15610954,434787,1,'2007-09-15 13:06:43',3310502577,1),(51929878,425559152,15613865,434787,1,'2007-09-15 13:06:43',3310502577,1),(51929880,425559152,15616853,434787,1,'2007-09-15 13:06:43',3310502577,1),(51929883,425559152,15618405,434787,1,'2007-09-15 13:06:43',3310502577,1),(51929886,425558919,15619492,434787,1,'2007-09-15 13:06:43',3310502577,1),(51929889,425558609,15620035,434787,1,'2007-09-15 13:06:43',3310502577,1),(51929892,425558065,15620462,434787,1,'2007-09-15 13:06:44',3310502577,1),(51929893,425557367,15620462,434787,1,'2007-09-15 13:06:44',3310502577,1),(51929896,425556862,15620151,434787,1,'2007-09-15 13:06:44',3310502577,1),(51929899,425556513,15619453,434787,1,'2007-09-15 13:06:44',3310502577,1),(51929902,425556358,15618483,434787,1,'2007-09-15 13:06:44',3310502577,1),(51929905,425556241,15617241,434787,1,'2007-09-15 13:06:44',3310502577,1),(51929907,425556435,15615611,434787,1,'2007-09-15 13:06:44',3310502577,1),(51929909,425556591,15614136,434787,1,'2007-09-15 13:06:44',3310502577,1),(51929910,425556707,15612429,434787,1,'2007-09-15 13:06:45',3310502577,1),(51929913,425556629,15611226,434787,1,'2007-09-15 13:06:45',3310502577,1),(51929915,425556358,15610178,434787,1,'2007-09-15 13:06:45',3310502577,1),(51929916,425556086,15609324,434787,1,'2007-09-15 13:06:45',3310502577,1),(51929918,425555387,15608548,434787,1,'2007-09-15 13:06:45',3310502577,1),(51929920,425554107,15607616,434787,1,'2007-09-15 13:06:45',3310502577,1),(51929922,425553137,15606530,434787,1,'2007-09-15 13:06:45',3310502577,1),(51929923,425552360,15606025,434787,1,'2007-09-15 13:06:45',3310502577,1),(51929925,425551662,15605288,434787,1,'2007-09-15 13:06:46',3310502577,1),(51929927,425551274,15604356,434787,1,'2007-09-15 13:06:46',3310502577,1),(51929930,425550847,15602533,434787,1,'2007-09-15 13:06:46',3310502577,1),(51929933,425550614,15600709,434787,1,'2007-09-15 13:06:46',3310502555,1),(51929936,425550653,15597992,434787,1,'2007-09-15 13:06:46',3310502555,1),(51929938,425550342,15596595,434787,1,'2007-09-15 13:06:46',3310502555,1),(51929939,425549683,15594344,434787,1,'2007-09-15 13:06:47',3310502555,1),(51929942,425549101,15591317,434787,1,'2007-09-15 13:06:47',3310502555,1),(51929943,425548596,15588988,434787,1,'2007-09-15 13:06:47',3310502555,1),(51929946,425547859,15585418,434787,1,'2007-09-15 13:06:47',3310502555,1),(51929949,425546500,15581266,434787,1,'2007-09-15 13:06:47',3310502555,1),(51929950,425545491,15579519,434787,1,'2007-09-15 13:06:47',3310502555,1),(51929953,425543706,15577346,434787,1,'2007-09-15 13:06:48',3310502555,1),(51929955,425540679,15573620,434787,1,'2007-09-15 13:06:48',3310502555,1),(51929957,425538584,15571796,434787,1,'2007-09-15 13:06:48',3310502555,1),(51929960,425537342,15570749,434787,1,'2007-09-15 13:06:48',3310502555,1),(51929964,425536100,15569119,434787,1,'2007-09-15 13:06:49',3310502555,1),(51929966,425534664,15566907,434787,1,'2007-09-15 13:06:49',3310502555,1),(51929968,425532723,15562094,434787,1,'2007-09-15 13:06:49',3310502554,1),(51929971,425531404,15559145,434787,1,'2007-09-15 13:06:49',3310502554,1),(51929974,425530356,15556816,434787,1,'2007-09-15 13:06:49',3310502554,1),(51929975,425529075,15552470,434787,1,'2007-09-15 13:06:49',3310502554,1),(51929978,425528804,15549986,434787,1,'2007-09-15 13:06:50',3310502554,1),(51929980,425528299,15546105,434787,1,'2007-09-15 13:06:50',3310502554,1),(51929983,425528338,15542768,434787,1,'2007-09-15 13:06:50',3310502552,1),(51929986,425528571,15540168,434787,1,'2007-09-15 13:06:50',3310502552,1),(51929988,425528843,15535588,434787,1,'2007-09-15 13:06:50',3310502552,1),(51929990,425528726,15533609,434787,1,'2007-09-15 13:06:50',3310502552,1),(51929993,425528338,15530660,434787,1,'2007-09-15 13:06:51',3310502552,1),(51929999,425527484,15527594,434787,1,'2007-09-15 13:06:51',3310502552,1),(51930002,425526553,15525265,434787,1,'2007-09-15 13:06:51',3310502552,1),(51930009,425525117,15522626,434787,1,'2007-09-15 13:06:51',3310502552,1),(51930014,425524302,15521074,434787,1,'2007-09-15 13:06:51',3310502552,1),(51930018,425523371,15520065,434787,1,'2007-09-15 13:06:51',3310502552,1),(51930020,425522439,15519716,434787,1,'2007-09-15 13:06:51',3310502552,1),(51930022,425521663,15520065,434787,1,'2007-09-15 13:06:52',3310502552,1),(51930024,425521508,15520725,434787,1,'2007-09-15 13:06:52',3310502552,1),(51930026,425521663,15521656,434787,1,'2007-09-15 13:06:52',3310502552,1),(51930027,425522439,15522820,864892,1,'2009-03-28 17:17:44',3310502552,2),(51930029,425523293,15524023,434787,1,'2007-09-15 13:06:52',3310502552,1),(51930031,425524186,15525731,434787,1,'2007-09-15 13:06:53',3310502552,1),(51930033,425524186,15526818,434787,1,'2007-09-15 13:06:53',3310502552,1),(51930035,425524030,15528215,434787,1,'2007-09-15 13:06:53',3310502552,1),(51930037,425523759,15529495,434787,1,'2007-09-15 13:06:54',3310502552,1),(51930040,425523409,15530892,434787,1,'2007-09-15 13:06:54',3310502552,1),(51930043,425522711,15532212,434787,1,'2007-09-15 13:06:54',3310502552,1),(51930044,425521974,15533415,434787,1,'2007-09-15 13:06:54',3310502552,1),(51930047,425521197,15535278,434787,1,'2007-09-15 13:06:54',3310502552,1),(51930048,425520809,15536636,434787,1,'2007-09-15 13:06:54',3310502552,1),(51930050,425520128,15539582,434787,1,'2007-09-15 13:06:54',3310502552,1),(51930052,425519834,15542059,434787,1,'2007-09-15 13:06:54',3310502552,1),(51930053,425519582,15544663,434787,1,'2007-09-15 13:06:54',3310502552,1),(51930055,425519414,15547561,434787,1,'2007-09-15 13:06:54',3310502554,1),(51930058,425519540,15550752,434787,1,'2007-09-15 13:06:55',3310502554,1),(51930062,425519960,15554364,434787,1,'2007-09-15 13:06:55',3310502554,1),(51930063,425520212,15557639,434787,1,'2007-09-15 13:06:55',3310502554,1),(51930066,425521010,15561041,434787,1,'2007-09-15 13:06:55',3310502554,1),(51930068,425521723,15563182,434787,1,'2007-09-15 13:06:56',3310502554,1),(51930071,425522437,15567592,434787,1,'2007-09-15 13:06:56',3310502554,1),(51930073,425523697,15571329,434787,1,'2007-09-15 13:06:56',3310502554,1),(51930076,425525251,15573681,434787,1,'2007-09-15 13:06:56',3310502554,1),(51930079,425525839,15575486,434787,1,'2007-09-15 13:06:56',3310502554,1),(51930080,425526007,15578930,434787,1,'2007-09-15 13:06:56',3310502554,1),(51930082,425526217,15582289,434787,1,'2007-09-15 13:06:57',3310502554,1),(51930085,425526763,15588127,434787,1,'2007-09-15 13:06:57',3310502554,1),(51930088,425526427,15590898,434787,1,'2007-09-15 13:06:57',3310502554,1),(51930092,425525839,15592662,434787,1,'2007-09-15 13:06:57',3310502554,1),(51930094,425524831,15594384,434787,1,'2007-09-15 13:06:57',3310502554,1),(51930096,425523790,15596926,434787,1,'2007-09-15 13:06:57',3310502554,1),(51930098,425523067,15598833,434787,1,'2007-09-15 13:06:57',3310502554,1),(51930099,425522168,15600914,434787,1,'2007-09-15 13:06:57',3310502576,1),(51930102,425521379,15602777,434787,1,'2007-09-15 13:06:58',3310502576,1),(51930104,425520371,15606371,434787,1,'2007-09-15 13:06:58',3310502576,1),(51930107,425520152,15608409,434787,1,'2007-09-15 13:06:58',3310502576,1),(51930108,425520086,15612354,434787,1,'2007-09-15 13:06:58',3310502576,1),(51930110,425519867,15616539,434787,1,'2007-09-15 13:06:58',3310502576,1),(51930112,425519495,15618511,434787,1,'2007-09-15 13:06:59',3310502576,1),(51930113,425519254,15620571,434787,1,'2007-09-15 13:06:59',3310502576,1),(51930115,425519012,15622806,434787,1,'2007-09-15 13:06:59',3310502576,1),(51930118,425518793,15624866,434787,1,'2007-09-15 13:06:59',3310502576,1),(51930119,425518749,15628833,434787,1,'2007-09-15 13:06:59',3310502576,1),(51930121,425518991,15630958,434787,1,'2007-09-15 13:06:59',3310502576,1),(51930124,425519341,15633216,434787,1,'2007-09-15 13:06:59',3310502576,1),(51930125,425520486,15635878,434787,1,'2007-09-15 13:07:00',3310502576,1),(51930127,425522535,15640424,434787,1,'2007-09-15 13:07:00',3310502576,1),(51930129,425525608,15646378,434787,1,'2007-09-15 13:07:00',3310502576,1),(51930132,425527016,15648555,434787,1,'2007-09-15 13:07:00',3310502576,1),(51930134,425528779,15650840,434787,1,'2007-09-15 13:07:00',3310502576,1),(51930136,425530254,15653140,434787,1,'2007-09-15 13:07:00',3310502576,1),(51930138,425531209,15655526,434787,1,'2007-09-15 13:07:00',3310502576,1),(51930141,425532076,15658996,434787,1,'2007-09-15 13:07:00',3310502578,1),(51930143,425533248,15662901,434787,1,'2007-09-15 13:07:01',3310502578,1),(51930145,425534332,15666241,434787,1,'2007-09-15 13:07:01',3310502578,1),(51930148,425536371,15670883,434787,1,'2007-09-15 13:07:01',3310502579,1),(51930149,425538280,15673877,434787,1,'2007-09-15 13:07:01',3310502579,1),(51930152,425540319,15676089,434787,1,'2007-09-15 13:07:01',3310502579,1),(51930153,425542749,15678649,434787,1,'2007-09-15 13:07:01',3310502579,1),(51930156,425544744,15681209,434787,1,'2007-09-15 13:07:01',3310502579,1),(51930158,425546827,15685937,434787,1,'2007-09-15 13:07:02',3310502579,1),(51930160,425548041,15690319,434787,1,'2007-09-15 13:07:02',3310502579,1),(51930163,425549560,15696263,434787,1,'2007-09-15 13:07:02',3310502579,1),(51930165,425550731,15700905,434787,1,'2007-09-15 13:07:02',3310502579,1),(51930167,425551729,15704245,434787,1,'2007-09-15 13:07:02',3310502579,1),(51930169,425553074,15707716,864892,1,'2009-03-28 17:18:56',3310502579,3),(51930171,425554245,15710362,434787,1,'2007-09-15 13:07:02',3310502579,1),(51930173,425557152,15713703,434787,1,'2007-09-15 13:07:02',3310502585,1),(51930175,425558942,15715267,434787,1,'2007-09-15 13:07:02',3310502585,1),(51930177,425560396,15716555,864892,1,'2009-03-28 14:31:35',3310502585,2),(51930178,425561102,15718133,434787,1,'2007-09-15 13:07:02',3310502585,1),(51930181,425561143,15719545,434787,1,'2007-09-15 13:07:03',3310502585,1),(51930184,425560977,15720874,434787,1,'2007-09-15 13:07:03',3310502585,1),(51930186,425560556,15722893,1258067,1,'2009-05-20 09:21:27',3310502585,5),(51930188,425559565,15725900,434787,1,'2007-09-15 13:07:03',3310502585,1),(51930191,425558983,15727769,434787,1,'2007-09-15 13:07:03',3310502585,1),(51930193,425558859,15728890,434787,1,'2007-09-15 13:07:03',3310502585,1),(51930195,425558983,15730136,434787,1,'2007-09-15 13:07:04',3310502585,1),(51930198,425559648,15732005,434787,1,'2007-09-15 13:07:04',3310502585,1),(51930199,425561434,15734580,434787,1,'2007-09-15 13:07:04',3310502585,1),(51930202,425566293,15742596,538211,1,'2007-09-30 15:36:23',3310502588,1),(51930206,425568762,15746342,434787,1,'2007-09-15 13:07:05',3310502588,1),(51930208,425570088,15748839,434787,1,'2007-09-15 13:07:05',3310502588,1),(51930211,425571766,15752194,434787,1,'2007-09-15 13:07:05',3310502588,1),(51930213,425573131,15755003,434787,1,'2007-09-15 13:07:05',3310502588,1),(51930216,425574497,15756992,434787,1,'2007-09-15 13:07:05',3310502588,1),(51930219,425576174,15758085,434787,1,'2007-09-15 13:07:05',3310502588,1),(51930222,425577618,15758787,434787,1,'2007-09-15 13:07:05',3310502588,1),(51930223,425579764,15758943,434787,1,'2007-09-15 13:07:06',3310502588,1),(51930226,425581090,15758826,434787,1,'2007-09-15 13:07:06',3310502588,1),(51930228,425582572,15758163,434787,1,'2007-09-15 13:07:06',3310502588,1),(51930230,425585186,15756758,434787,1,'2007-09-15 13:07:06',3310502588,1),(51930232,425587098,15756017,434787,1,'2007-09-15 13:07:06',3310502588,1),(51930235,425589868,15755393,434787,1,'2007-09-15 13:07:06',3310502589,1),(51930238,425593036,15754768,434787,1,'2007-09-15 13:07:06',3310502589,1),(51930241,425595625,15753473,434787,1,'2007-09-15 13:07:07',3310502589,1),(51930242,425599314,15751532,434787,1,'2007-09-15 13:07:07',3310502589,1),(51930245,425603520,15749137,434787,1,'2007-09-15 13:07:07',3310502589,1),(51930247,425605462,15748037,434787,1,'2007-09-15 13:07:07',3310502589,1),(51930250,425606886,15747584,434787,1,'2007-09-15 13:07:07',3310502589,1),(51930252,425608633,15747390,434787,1,'2007-09-15 13:07:07',3310502589,1),(51930253,425610316,15747714,434787,1,'2007-09-15 13:07:07',3310502589,1),(51930255,425611998,15748684,434787,1,'2007-09-15 13:07:08',3310502589,1),(51930257,425613616,15749267,434787,1,'2007-09-15 13:07:08',3310502589,1),(51930259,425615299,15749267,434787,1,'2007-09-15 13:07:08',3310502589,1),(51930262,425617370,15749137,434787,1,'2007-09-15 13:07:08',3310502632,1),(51930264,425619376,15748814,434787,1,'2007-09-15 13:07:08',3310502632,1),(51930267,425622159,15747908,434787,1,'2007-09-15 13:07:08',3310502632,1),(51930270,425625201,15745837,434787,1,'2007-09-15 13:07:09',3310502632,1),(51930272,425628178,15744478,434787,1,'2007-09-15 13:07:09',3310502632,1),(51930275,425630313,15743442,434787,1,'2007-09-15 13:07:09',3310502632,1),(51930278,425633381,15742692,434787,1,'2007-09-15 13:07:09',3310502632,1),(51930280,425635193,15742743,434787,1,'2007-09-15 13:07:09',3310502632,1),(51930282,425637059,15743369,437032,1,'2008-05-13 19:37:07',3310502632,2),(51930284,425638134,15744914,437032,1,'2008-05-13 19:37:07',3310502632,2),(51930288,425638703,15746974,437032,1,'2008-05-13 19:37:07',3310502632,2),(51930291,425638869,15749060,434787,1,'2007-09-15 13:07:10',3310502632,1),(51930293,425639076,15750872,434787,1,'2007-09-15 13:07:10',3310502632,1),(51930297,425640112,15754289,434787,1,'2007-09-15 13:07:10',3310502632,1),(51930299,425640836,15755946,434787,1,'2007-09-15 13:07:10',3310502632,1),(51930302,425641613,15757965,434787,1,'2007-09-15 13:07:11',3310502632,1),(51930305,425642545,15759156,434787,1,'2007-09-15 13:07:11',3310502632,1),(51930307,425643425,15759984,434787,1,'2007-09-15 13:07:11',3310502632,1),(51930309,425644823,15760605,434787,1,'2007-09-15 13:07:11',3310502633,1),(51930311,425646117,15760709,434787,1,'2007-09-15 13:07:11',3310502633,1),(51930312,425647360,15761071,434787,1,'2007-09-15 13:07:11',3310502633,1),(51930313,425649793,15762159,434787,1,'2007-09-15 13:07:12',3310502633,1),(51930314,425652279,15764074,434787,1,'2007-09-15 13:07:12',3310502633,1),(51930315,425654526,15765306,434787,1,'2007-09-15 13:07:12',3310502633,1),(51930319,425656949,15767419,434787,1,'2007-09-15 13:07:12',3310502635,1),(51930321,425659372,15769469,434787,1,'2007-09-15 13:07:13',3310502635,1),(51930324,425661360,15771954,434787,1,'2007-09-15 13:07:13',3310502635,1),(51930326,425663286,15775682,434787,1,'2007-09-15 13:07:13',3310502635,1),(51930328,425664404,15778851,434787,1,'2007-09-15 13:07:13',3310502635,1),(51930331,425664901,15782268,434787,1,'2007-09-15 13:07:13',3310502635,1),(51930332,425665274,15798545,434787,1,'2007-09-15 13:07:13',3310502635,1),(51930334,425660760,15801808,434787,1,'2007-09-15 13:07:13',3310502635,1),(51930336,425660200,15800179,434787,1,'2007-09-15 13:07:13',3310502635,1),(51930338,425659894,15798652,434787,1,'2007-09-15 13:07:14',3310502635,1),(51930340,425659818,15797660,434787,1,'2007-09-15 13:07:14',3310502635,1),(51930343,425659589,15796362,434787,1,'2007-09-15 13:07:14',3310502635,1),(51930345,425659309,15795293,434787,1,'2007-09-15 13:07:14',3310502635,1),(51930348,425659080,15794224,434787,1,'2007-09-15 13:07:14',3310502635,1),(51930349,425658978,15792850,434787,1,'2007-09-15 13:07:14',3310502635,1),(51930352,425658927,15791323,434787,1,'2007-09-15 13:07:14',3310502635,1),(51930354,425658902,15790254,434787,1,'2007-09-15 13:07:14',3310502635,1),(51930357,425658902,15789135,434787,1,'2007-09-15 13:07:14',3310502635,1),(51930359,425658978,15787837,434787,1,'2007-09-15 13:07:15',3310502635,1),(51930360,425659385,15786513,434787,1,'2007-09-15 13:07:15',3310502635,1),(51930362,425659742,15785317,434787,1,'2007-09-15 13:07:15',3310502635,1),(51930364,425660047,15783714,434787,1,'2007-09-15 13:07:15',3310502635,1),(51930365,425660276,15781831,434787,1,'2007-09-15 13:07:15',3310502635,1),(51930368,425660327,15780533,434787,1,'2007-09-15 13:07:16',3310502635,1),(51930371,425660403,15778472,434787,1,'2007-09-15 13:07:16',3310502635,1),(51930373,425660251,15777199,434787,1,'2007-09-15 13:07:16',3310502635,1),(51930376,425659742,15775673,434787,1,'2007-09-15 13:07:16',3310502635,1),(51930378,425659131,15774604,434787,1,'2007-09-15 13:07:16',3310502635,1),(51930380,425658571,15773357,434787,1,'2007-09-15 13:07:16',3310502635,1),(51930382,425658251,15772251,434787,1,'2007-09-15 13:07:17',3310502635,1),(51930384,425657916,15770024,434787,1,'2007-09-15 13:07:17',3310502635,1),(51930386,425658476,15768715,434787,1,'2007-09-15 13:07:17',3310502635,1),(51930388,425657921,15771127,434787,1,'2007-09-15 13:07:17',3310502635,1),(51930390,425658047,15769441,434787,1,'2007-09-15 13:07:18',3310502635,1),(51930396,425657910,15770462,434787,1,'2007-09-15 13:07:18',3310502635,1),(51930403,425665313,15802579,434787,1,'2007-09-15 13:07:18',3310502635,1),(51930405,425665313,15805560,434787,1,'2007-09-15 13:07:18',3310502635,1),(51930408,425665384,15810174,434787,1,'2007-09-15 13:07:18',3310502635,1),(51930410,425665417,15814775,434787,1,'2007-09-15 13:07:18',3310502635,1),(51930412,425665580,15818267,434787,1,'2007-09-15 13:07:18',3310502635,1),(51930413,425666212,15822738,434787,1,'2007-09-15 13:07:19',3310504001,1),(51930415,425667372,15828204,434787,1,'2007-09-15 13:07:19',3310504001,1),(51930416,425668152,15832605,434787,1,'2007-09-15 13:07:19',3310504001,1),(51930417,425668807,15836191,434787,1,'2007-09-15 13:07:19',3310504001,1),(51930418,425669373,15839249,434787,1,'2007-09-15 13:07:19',3310504001,1),(51930420,425669864,15841930,434787,1,'2007-09-15 13:07:19',3310504001,1),(51930422,425670279,15843780,434787,1,'2007-09-15 13:07:19',3310504001,1),(51930424,425671902,15847555,434787,1,'2007-09-15 13:07:19',3310504004,1),(51930426,425672922,15849065,434787,1,'2007-09-15 13:07:20',3310504004,1),(51930428,425674545,15850688,434787,1,'2007-09-15 13:07:20',3310504004,1),(51930429,425676546,15851897,434787,1,'2007-09-15 13:07:20',3310504004,1),(51930433,425678434,15853180,434787,1,'2007-09-15 13:07:20',3310504004,1),(51930437,425679755,15854464,434787,1,'2007-09-15 13:07:20',3310504004,1),(51930439,425681722,15856542,434787,1,'2007-09-15 13:07:21',3310504004,1),(51930441,425684729,15860375,434787,1,'2007-09-15 13:07:21',3310504004,1),(51930443,425687058,15864133,434787,1,'2007-09-15 13:07:21',3310504004,1),(51930445,425688787,15868191,434787,1,'2007-09-15 13:07:21',3310504004,1),(51930447,425690033,15873362,437032,1,'2008-05-13 19:30:42',3310504004,4),(51930448,425691107,15875679,437032,1,'2008-05-13 19:30:42',3310504006,2),(51930449,425692620,15877210,434787,1,'2007-09-15 13:07:21',3310504006,1),(51930450,425694348,15877961,434787,1,'2007-09-15 13:07:21',3310504006,1),(51930453,425696002,15877961,434787,1,'2007-09-15 13:07:22',3310504006,1),(51930455,425697204,15877285,434787,1,'2007-09-15 13:07:22',3310504006,1),(51930457,425698332,15875932,434787,1,'2007-09-15 13:07:22',3310504006,1),(51930458,425701488,15873602,434787,1,'2007-09-15 13:07:22',3310504005,1),(51930461,425704269,15871724,434787,1,'2007-09-15 13:07:22',3310504005,1),(51930462,425706824,15869920,434787,1,'2007-09-15 13:07:23',3310504005,1),(51930465,425710582,15868342,434787,1,'2007-09-15 13:07:23',3310504005,1),(51930467,425713438,15867214,434787,1,'2007-09-15 13:07:23',3310504005,1),(51930469,425716294,15866162,434787,1,'2007-09-15 13:07:23',3310504005,1),(51930470,425718398,15865411,434787,1,'2007-09-15 13:07:23',3310504005,1),(51930473,425720202,15864809,434787,1,'2007-09-15 13:07:23',3310504005,1),(51930475,425722306,15864885,434787,1,'2007-09-15 13:07:24',3310504005,1),(51930478,425724485,15865411,434787,1,'2007-09-15 13:07:24',3310504005,1),(51930481,425725809,15865656,434787,1,'2007-09-15 13:07:24',3310504005,1),(51930483,425727317,15865471,434787,1,'2007-09-15 13:07:24',3310504016,1),(51930485,425728795,15865102,434787,1,'2007-09-15 13:07:25',3310504016,1),(51930488,425730519,15864548,434787,1,'2007-09-15 13:07:25',3310504016,1),(51930492,425731996,15864271,434787,1,'2007-09-15 13:07:25',3310504016,1),(51930495,425733597,15864332,434787,1,'2007-09-15 13:07:25',3310504016,1),(51930497,425735136,15864455,434787,1,'2007-09-15 13:07:25',3310504016,1),(51930500,425735752,15864763,434787,1,'2007-09-15 13:07:25',3310504016,1),(51930503,425736183,15865656,434787,1,'2007-09-15 13:07:25',3310504016,1),(51930505,425735998,15866425,434787,1,'2007-09-15 13:07:26',3310504016,1),(51930507,425735475,15866887,434787,1,'2007-09-15 13:07:26',3310504016,1),(51930509,425734736,15867010,434787,1,'2007-09-15 13:07:26',3310504016,1),(51930511,425733720,15867472,434787,1,'2007-09-15 13:07:26',3310504016,1),(51930513,425730888,15868765,434787,1,'2007-09-15 13:07:26',3310504016,1),(51930517,425729133,15870304,434787,1,'2007-09-15 13:07:26',3310504016,1),(51930519,425724393,15874398,434787,1,'2007-09-15 13:07:27',3310504005,1),(51930521,425719006,15879262,434787,1,'2007-09-15 13:07:27',3310504007,1),(51930524,425714758,15883695,434787,1,'2007-09-15 13:07:27',3310504007,1),(51930527,425712695,15885665,434787,1,'2007-09-15 13:07:27',3310504007,1),(51930531,425711864,15885819,434787,1,'2007-09-15 13:07:27',3310504007,1),(51930534,425711002,15885819,434787,1,'2007-09-15 13:07:28',3310504007,1),(51930537,425710048,15885542,434787,1,'2007-09-15 13:07:28',3310504007,1),(51930540,425708742,15885117,434787,1,'2007-09-15 13:07:28',3310504007,1),(51930542,425707227,15885117,434787,1,'2007-09-15 13:07:28',3310504007,1),(51930544,425705909,15885644,434787,1,'2007-09-15 13:07:29',3310504007,1),(51930548,425704252,15886547,434787,1,'2007-09-15 13:07:29',3310504007,1),(51930553,425702407,15888053,434787,1,'2007-09-15 13:07:29',3310504007,1),(51930556,425700713,15889484,434787,1,'2007-09-15 13:07:29',3310504007,1),(51930560,425699621,15890764,434787,1,'2007-09-15 13:07:29',3310504007,1),(51930563,425698680,15892459,434787,1,'2007-09-15 13:07:29',3310504006,1),(51930565,425696496,15896826,434787,1,'2007-09-15 13:07:30',3310504006,1),(51930567,425692430,15905749,434787,1,'2007-09-15 13:07:30',3310504006,1),(51930569,425691414,15907707,434787,1,'2007-09-15 13:07:30',3310504006,1),(51930572,425690548,15908610,434787,1,'2007-09-15 13:07:30',3310504006,1),(51930573,425689682,15909137,434787,1,'2007-09-15 13:07:30',3310504006,1),(51930576,425688552,15909928,434787,1,'2007-09-15 13:07:30',3310504006,1),(51930579,425687837,15911095,434787,1,'2007-09-15 13:07:30',3310504006,1),(51930582,425687988,15912187,434787,1,'2007-09-15 13:07:31',3310504006,1),(51930583,425688439,15913015,434787,1,'2007-09-15 13:07:31',3310504006,1),(51930586,425689305,15913053,434787,1,'2007-09-15 13:07:31',3310504006,1),(51930588,425690322,15912375,434787,1,'2007-09-15 13:07:31',3310504006,1),(51930590,425691602,15910982,434787,1,'2007-09-15 13:07:31',3310504006,1);
INSERT INTO `current_nodes` VALUES (51930593,425693334,15908384,434787,1,'2007-09-15 13:07:31',3310504006,1),(51930595,425694953,15906125,434787,1,'2007-09-15 13:07:32',3310504006,1),(51930597,425696082,15904168,434787,1,'2007-09-15 13:07:32',3310504006,1),(51930599,425697325,15901457,434787,1,'2007-09-15 13:07:32',3310504006,1),(51930602,425699094,15898332,434787,1,'2007-09-15 13:07:32',3310504006,1),(51930604,425700525,15896976,434787,1,'2007-09-15 13:07:33',3310504007,1),(51930606,425701880,15895809,434787,1,'2007-09-15 13:07:33',3310504007,1),(51930609,425703085,15895470,434787,1,'2007-09-15 13:07:33',3310504007,1),(51930611,425704252,15895621,434787,1,'2007-09-15 13:07:33',3310504007,1),(51930614,425707565,15897541,434787,1,'2007-09-15 13:07:33',3310504007,1),(51930616,425711293,15900060,434787,1,'2007-09-15 13:07:33',3310504007,1),(51930619,425713002,15901342,434787,1,'2007-09-15 13:07:33',3310504007,1),(51930621,425714406,15903294,434787,1,'2007-09-15 13:07:33',3310504007,1),(51930623,425715397,15905109,434787,1,'2007-09-15 13:07:34',3310504007,1),(51930626,425713666,15902132,434787,1,'2007-09-15 13:07:34',3310504007,1),(51930628,425712390,15900781,434787,1,'2007-09-15 13:07:34',3310504007,1),(51930630,425711914,15900460,434787,1,'2007-09-15 13:07:34',3310504007,1),(51930633,425716700,15907497,434787,1,'2007-09-15 13:07:34',3310504007,1),(51930636,425717966,15909572,434787,1,'2007-09-15 13:07:35',3310504007,1),(51930638,425719092,15910838,434787,1,'2007-09-15 13:07:35',3310504007,1),(51930640,425720393,15911752,434787,1,'2007-09-15 13:07:35',3310504007,1),(51930641,425721835,15912209,434787,1,'2007-09-15 13:07:35',3310504007,1),(51930643,425723875,15912385,434787,1,'2007-09-15 13:07:35',3310504007,1),(51930645,425725387,15912209,434787,1,'2007-09-15 13:07:35',3310504007,1),(51930648,425726441,15912264,370566,1,'2008-05-09 02:14:25',3310504007,2),(51930650,425727452,15912797,370566,1,'2008-05-09 02:14:25',3310504018,2),(51930652,425728025,15914003,434787,1,'2007-09-15 13:07:36',3310504018,1),(51930653,425727893,15916092,434787,1,'2007-09-15 13:07:36',3310504018,1),(51930656,425727467,15920407,434787,1,'2007-09-15 13:07:36',3310504018,1),(51930657,425726677,15923446,434787,1,'2007-09-15 13:07:36',3310504007,1),(51930661,425725158,15927336,434787,1,'2007-09-15 13:07:37',3310504007,1),(51930663,425723335,15931104,434787,1,'2007-09-15 13:07:37',3310504013,1),(51930665,425723031,15933778,434787,1,'2007-09-15 13:07:37',3310504013,1),(51930668,425722788,15937424,434787,1,'2007-09-15 13:07:38',3310504013,1),(51930671,425722328,15939716,434787,1,'2007-09-15 13:07:38',3310504013,1),(51930674,425721432,15943132,434787,1,'2007-09-15 13:07:38',3310504013,1),(51930676,425720816,15945093,434787,1,'2007-09-15 13:07:38',3310504013,1),(51930680,425720592,15946213,434787,1,'2007-09-15 13:07:39',3310504013,1),(51930682,425720592,15947949,434787,1,'2007-09-15 13:07:39',3310504013,1),(51930684,425721040,15950526,434787,1,'2007-09-15 13:07:39',3310504013,1),(51930686,425721936,15952206,434787,1,'2007-09-15 13:07:40',3310504013,1),(51930687,425723336,15953158,434787,1,'2007-09-15 13:07:40',3310504013,1),(51930689,425724792,15954502,434787,1,'2007-09-15 13:07:40',3310504013,1),(51930691,425725632,15956015,434787,1,'2007-09-15 13:07:40',3310504013,1),(51930692,425725969,15957471,434787,1,'2007-09-15 13:07:40',3310504013,1),(51930695,425725969,15960215,434787,1,'2007-09-15 13:07:40',3310504013,1),(51930697,425725576,15963520,434787,1,'2007-09-15 13:07:40',3310504013,1),(51930699,425724848,15968785,434787,1,'2007-09-15 13:07:40',3310504013,1),(51930702,425724456,15973490,434787,1,'2007-09-15 13:07:41',3310504013,1),(51930705,425724344,15976290,434787,1,'2007-09-15 13:07:41',3310504013,1),(51930706,425724120,15979819,434787,1,'2007-09-15 13:07:41',3310504013,1),(51930709,425724120,15984132,434787,1,'2007-09-15 13:07:41',3310504013,1),(51930712,425724232,15989004,434787,1,'2007-09-15 13:07:41',3310504015,1),(51930713,425724568,15998022,434787,1,'2007-09-15 13:07:41',3310504015,1),(51930716,425724736,16003791,434787,1,'2007-09-15 13:07:42',3310504015,1),(51930718,425725240,16009392,434787,1,'2007-09-15 13:07:42',3310504015,1),(51930721,425725913,16012585,434787,1,'2007-09-15 13:07:42',3310504015,1),(51930723,425726473,16016113,434787,1,'2007-09-15 13:07:42',3310504015,1),(51930726,425726753,16019474,434787,1,'2007-09-15 13:07:42',3310504026,1),(51930727,425726753,16022722,434787,1,'2007-09-15 13:07:42',3310504026,1),(51930729,425726193,16024011,434787,1,'2007-09-15 13:07:42',3310504015,1),(51930731,425725296,16024683,434787,1,'2007-09-15 13:07:43',3310504015,1),(51930732,425724120,16024571,434787,1,'2007-09-15 13:07:43',3310504015,1),(51930734,425723448,16023787,434787,1,'2007-09-15 13:07:43',3310504015,1),(51930736,425723448,16022498,434787,1,'2007-09-15 13:07:43',3310504015,1),(51930738,425723784,16020034,434787,1,'2007-09-15 13:07:43',3310504015,1),(51930741,425724232,16016841,434787,1,'2007-09-15 13:07:43',3310504015,1),(51930743,425724232,16014937,434787,1,'2007-09-15 13:07:44',3310504015,1),(51930745,425723728,16012977,434787,1,'2007-09-15 13:07:44',3310504015,1),(51930748,425723056,16010736,434787,1,'2007-09-15 13:07:44',3310504015,1),(51930750,425722496,16009056,434787,1,'2007-09-15 13:07:44',3310504015,1),(51930751,425721936,16006368,434787,1,'2007-09-15 13:07:44',3310504015,1),(51930754,425721376,16003287,434787,1,'2007-09-15 13:07:45',3310504015,1),(51930756,425720928,15998022,434787,1,'2007-09-15 13:07:45',3310504015,1),(51930758,425720480,15993485,434787,1,'2007-09-15 13:07:45',3310504015,1),(51930761,425719583,15985756,434787,1,'2007-09-15 13:07:45',3310504015,1),(51930762,425718631,15980155,434787,1,'2007-09-15 13:07:45',3310504013,1),(51930765,425718183,15976290,434787,1,'2007-09-15 13:07:45',3310504013,1),(51930768,425717735,15972538,434787,1,'2007-09-15 13:07:45',3310504013,1),(51930769,425717399,15967833,434787,1,'2007-09-15 13:07:46',3310504013,1),(51930771,425717231,15965984,434787,1,'2007-09-15 13:07:46',3310504013,1),(51930775,425716783,15964416,434787,1,'2007-09-15 13:07:46',3310504013,1),(51930777,425715887,15963240,434787,1,'2007-09-15 13:07:46',3310504013,1),(51930779,425714767,15962288,434787,1,'2007-09-15 13:07:46',3310504013,1),(51930781,425713366,15961896,434787,1,'2007-09-15 13:07:46',3310504013,1),(51930783,425712134,15961560,434787,1,'2007-09-15 13:07:47',3310504013,1),(51930786,425710678,15960551,434787,1,'2007-09-15 13:07:47',3310504013,1),(51930788,425709782,15959095,434787,1,'2007-09-15 13:07:47',3310504013,1),(51930790,425708998,15957527,434787,1,'2007-09-15 13:07:47',3310504013,1),(51930793,425708942,15955903,434787,1,'2007-09-15 13:07:47',3310504013,1),(51930794,425708885,15953774,434787,1,'2007-09-15 13:07:48',3310504013,1),(51930797,425708942,15950582,434787,1,'2007-09-15 13:07:48',3310504013,1),(51930800,425708998,15947445,434787,1,'2007-09-15 13:07:48',3310504013,1),(51930802,425709345,15944891,434787,1,'2007-09-15 13:07:48',3310504013,1),(51930806,425709927,15942919,434787,1,'2007-09-15 13:07:48',3310504013,1),(51930807,425710107,15941889,434787,1,'2007-09-15 13:07:49',3310504013,1),(51930808,425710107,15941306,434787,1,'2007-09-15 13:07:49',3310504013,1),(51930809,425709927,15940500,434787,1,'2007-09-15 13:07:49',3310504013,1),(51930812,425709300,15940231,434787,1,'2007-09-15 13:07:49',3310504013,1),(51930814,425708942,15940589,434787,1,'2007-09-15 13:07:49',3310504013,1),(51930815,425708493,15941172,434787,1,'2007-09-15 13:07:49',3310504013,1),(51930816,425707911,15942740,434787,1,'2007-09-15 13:07:50',3310504013,1),(51930818,425707552,15945473,434787,1,'2007-09-15 13:07:50',3310504013,1),(51930821,425707597,15948924,434787,1,'2007-09-15 13:07:50',3310504013,1),(51930823,425707328,15951164,434787,1,'2007-09-15 13:07:50',3310504013,1),(51930826,425706522,15953539,434787,1,'2007-09-15 13:07:50',3310504013,1),(51930828,425705715,15957796,434787,1,'2007-09-15 13:07:50',3310504013,1),(51930830,425706119,15959946,434787,1,'2007-09-15 13:07:50',3310504013,1),(51930831,425707463,15962635,434787,1,'2007-09-15 13:07:51',3310504013,1),(51930834,425708942,15965458,434787,1,'2007-09-15 13:07:51',3310504013,1),(51930836,425710286,15966488,434787,1,'2007-09-15 13:07:51',3310504013,1),(51930839,425711899,15967340,434787,1,'2007-09-15 13:07:51',3310504013,1),(51930840,425712437,15968505,434787,1,'2007-09-15 13:07:51',3310504013,1),(51930843,425712481,15970073,434787,1,'2007-09-15 13:07:51',3310504013,1),(51930844,425711630,15982306,434787,1,'2007-09-15 13:07:51',3310504013,1),(51930847,425710913,15988803,434787,1,'2007-09-15 13:07:52',3310504015,1),(51930850,425710107,15993597,434787,1,'2007-09-15 13:07:52',3310504015,1),(51930851,425709031,15998885,434787,1,'2007-09-15 13:07:52',3310504015,1),(51930854,425707866,16003993,434787,1,'2007-09-15 13:07:52',3310504015,1),(51930855,425707060,16005292,434787,1,'2007-09-15 13:07:52',3310504015,1),(51930858,425706074,16005651,434787,1,'2007-09-15 13:07:52',3310504015,1),(51930859,425705088,16005471,434787,1,'2007-09-15 13:07:52',3310504015,1),(51930862,425704416,16004710,434787,1,'2007-09-15 13:07:52',3310504015,1),(51930864,425704416,16003545,434787,1,'2007-09-15 13:07:53',3310504015,1),(51930865,425704954,16001752,434787,1,'2007-09-15 13:07:53',3310504015,1),(51930866,425706432,15997585,434787,1,'2007-09-15 13:07:53',3310504015,1),(51930867,425706791,15996286,434787,1,'2007-09-15 13:07:53',3310504015,1),(51930869,425706880,15993866,434787,1,'2007-09-15 13:07:53',3310504015,1),(51930871,425706880,15989161,434787,1,'2007-09-15 13:07:53',3310504015,1),(51930873,425706567,15982261,434787,1,'2007-09-15 13:07:53',3310504013,1),(51930876,425706746,15980334,434787,1,'2007-09-15 13:07:53',3310504013,1),(51930879,425707060,15978004,434787,1,'2007-09-15 13:07:54',3310504013,1),(51930882,425707328,15976391,434787,1,'2007-09-15 13:07:54',3310504013,1),(51930883,425707328,15975181,434787,1,'2007-09-15 13:07:54',3310504013,1),(51930885,425707149,15974509,434787,1,'2007-09-15 13:07:54',3310504013,1),(51930887,425706611,15974195,434787,1,'2007-09-15 13:07:54',3310504013,1),(51930889,425705895,15974733,434787,1,'2007-09-15 13:07:54',3310504013,1),(51930891,425705402,15975360,434787,1,'2007-09-15 13:07:55',3310504013,1),(51930893,425704685,15977377,434787,1,'2007-09-15 13:07:55',3310504013,1),(51930895,425703878,15979079,434787,1,'2007-09-15 13:07:55',3310504013,1),(51930896,425703475,15981275,434787,1,'2007-09-15 13:07:55',3310504013,1),(51930898,425703565,15983560,434787,1,'2007-09-15 13:07:55',3310504013,1),(51930900,425703385,15987055,434787,1,'2007-09-15 13:07:55',3310504015,1),(51930901,425702982,15990057,434787,1,'2007-09-15 13:07:55',3310504015,1),(51930905,425702534,15991312,434787,1,'2007-09-15 13:07:56',3310504015,1),(51930907,425701996,15992387,434787,1,'2007-09-15 13:07:56',3310504015,1),(51930908,425701279,15993194,434787,1,'2007-09-15 13:07:56',3310504015,1),(51930909,425700338,15993508,434787,1,'2007-09-15 13:07:56',3310504015,1),(51930911,425699621,15993508,434787,1,'2007-09-15 13:07:56',3310504015,1),(51930913,425698680,15993328,434787,1,'2007-09-15 13:07:56',3310504014,1),(51930915,425697381,15993418,434787,1,'2007-09-15 13:07:57',3310504014,1),(51930918,425696485,15993732,434787,1,'2007-09-15 13:07:57',3310504014,1),(51930920,425695021,15994415,434787,1,'2007-09-15 13:07:57',3310504014,1),(51930923,425693368,15996113,434787,1,'2007-09-15 13:07:57',3310504014,1),(51930926,425691446,15999286,434787,1,'2007-09-15 13:07:57',3310504014,1),(51930928,425689480,16001654,434787,1,'2007-09-15 13:07:58',3310504014,1),(51930930,425687621,16004067,434787,1,'2007-09-15 13:07:58',3310504014,1),(51930932,425686156,16005568,434787,1,'2007-09-15 13:07:58',3310504014,1),(51930935,425684976,16006069,434787,1,'2007-09-15 13:07:58',3310504014,1),(51930937,425684154,16005818,434787,1,'2007-09-15 13:07:58',3310504014,1),(51930940,425683689,16005139,434787,1,'2007-09-15 13:07:58',3310504014,1),(51930942,425683618,16004174,434787,1,'2007-09-15 13:07:58',3310504014,1),(51930944,425683904,16003388,434787,1,'2007-09-15 13:07:59',3310504014,1),(51930947,425684297,16002851,434787,1,'2007-09-15 13:07:59',3310504014,1),(51930950,425685012,16002315,434787,1,'2007-09-15 13:07:59',3310504014,1),(51930952,425686299,16001707,434787,1,'2007-09-15 13:08:00',3310504014,1),(51930953,425687550,16000456,434787,1,'2007-09-15 13:08:00',3310504014,1),(51930954,425688408,15999026,434787,1,'2007-09-15 13:08:00',3310504014,1),(51930956,425689016,15997167,434787,1,'2007-09-15 13:08:00',3310504014,1),(51930958,425689194,15995916,434787,1,'2007-09-15 13:08:00',3310504014,1),(51930961,425689051,15994236,434787,1,'2007-09-15 13:08:00',3310504014,1),(51930962,425688837,15992413,434787,1,'2007-09-15 13:08:00',3310504014,1),(51930965,425688765,15990161,434787,1,'2007-09-15 13:08:01',3310504014,1),(51930967,425689266,15988159,434787,1,'2007-09-15 13:08:01',3310504014,1),(51930968,425690267,15986944,434787,1,'2007-09-15 13:08:01',3310504014,1),(51930971,425692161,15986121,434787,1,'2007-09-15 13:08:01',3310504014,1),(51930973,425693698,15985335,434787,1,'2007-09-15 13:08:01',3310504012,1),(51930974,425694664,15984549,434787,1,'2007-09-15 13:08:01',3310504012,1),(51930975,425696094,15983154,434787,1,'2007-09-15 13:08:01',3310504012,1),(51930976,425696523,15981188,434787,1,'2007-09-15 13:08:01',3310504012,1),(51930978,425696594,15979437,434787,1,'2007-09-15 13:08:02',3310504012,1),(51930981,425696594,15978078,434787,1,'2007-09-15 13:08:02',3310504012,1),(51930983,425695700,15976291,434787,1,'2007-09-15 13:08:02',3310504012,1),(51930984,425694092,15974897,434787,1,'2007-09-15 13:08:02',3310504012,1),(51930985,425691625,15972716,434787,1,'2007-09-15 13:08:03',3310504012,1),(51930986,425688908,15970571,434787,1,'2007-09-15 13:08:03',3310504012,1),(51930987,425687872,15970214,434787,1,'2007-09-15 13:08:03',3310504012,1),(51930990,425686334,15969856,434787,1,'2007-09-15 13:08:03',3310504012,1),(51930992,425684404,15969606,434787,1,'2007-09-15 13:08:03',3310504012,1),(51930995,425683046,15969034,434787,1,'2007-09-15 13:08:03',3310504012,1),(51930998,425681473,15967926,434787,1,'2007-09-15 13:08:04',3310504012,1),(51930999,425679578,15966210,434787,1,'2007-09-15 13:08:04',3310504012,1),(51931002,425677969,15963672,434787,1,'2007-09-15 13:08:04',3310504012,1),(51931005,425677183,15961741,434787,1,'2007-09-15 13:08:04',3310504012,1),(51931006,425676611,15958667,434787,1,'2007-09-15 13:08:04',3310504012,1),(51931009,425675949,15955049,434787,1,'2007-09-15 13:08:04',3310504012,1),(51931012,425675405,15951906,434787,1,'2007-09-15 13:08:04',3310504012,1),(51931014,425674317,15948219,434787,1,'2007-09-15 13:08:05',3310504012,1),(51931018,425672927,15946285,434787,1,'2007-09-15 13:08:05',3310504012,1),(51931020,425670872,15944049,434787,1,'2007-09-15 13:08:05',3310504009,1),(51931023,425668998,15941269,434787,1,'2007-09-15 13:08:05',3310504009,1),(51931025,425666097,15936554,434787,1,'2007-09-15 13:08:05',3310504009,1),(51931026,425664163,15933895,434787,1,'2007-09-15 13:08:05',3310504009,1),(51931029,425662350,15932263,434787,1,'2007-09-15 13:08:06',3310504009,1),(51931032,425660597,15930571,434787,1,'2007-09-15 13:08:06',3310504009,1),(51931036,425658723,15927911,434787,1,'2007-09-15 13:08:06',3310504003,1),(51931037,425657575,15925856,434787,1,'2007-09-15 13:08:06',3310504003,1),(51931040,425656047,15924149,434787,1,'2007-09-15 13:08:06',3310504003,1),(51931043,425654593,15922819,434787,1,'2007-09-15 13:08:06',3310504003,1),(51931045,425652488,15920745,434787,1,'2007-09-15 13:08:07',3310504003,1),(51931047,425651374,15919322,434787,1,'2007-09-15 13:08:07',3310504003,1),(51931050,425649951,15916568,434787,1,'2007-09-15 13:08:07',3310504003,1),(51931053,425649239,15915918,434787,1,'2007-09-15 13:08:07',3310504003,1),(51931055,425648651,15915887,434787,1,'2007-09-15 13:08:07',3310504003,1),(51931057,425648311,15916413,434787,1,'2007-09-15 13:08:07',3310504003,1),(51931060,425648125,15916939,434787,1,'2007-09-15 13:08:07',3310504003,1),(51931062,425648342,15917991,434787,1,'2007-09-15 13:08:08',3310504003,1),(51931065,425649115,15919446,434787,1,'2007-09-15 13:08:08',3310504003,1),(51931066,425651405,15922726,434787,1,'2007-09-15 13:08:08',3310504003,1),(51931069,425653045,15924242,434787,1,'2007-09-15 13:08:08',3310504003,1),(51931070,425654221,15926377,434787,1,'2007-09-15 13:08:08',3310504003,1),(51931073,425657409,15931948,434787,1,'2007-09-15 13:08:09',3310504009,1),(51931076,425663258,15940767,434787,1,'2007-09-15 13:08:09',3310504009,1),(51931077,425665764,15944976,434787,1,'2007-09-15 13:08:09',3310504009,1),(51931080,425666754,15948504,434787,1,'2007-09-15 13:08:09',3310504009,1),(51931084,425667219,15952557,434787,1,'2007-09-15 13:08:09',3310504009,1),(51931087,425666909,15955312,434787,1,'2007-09-15 13:08:09',3310504009,1),(51931090,425664485,15961121,434787,1,'2007-09-15 13:08:09',3310504009,1),(51931093,425662908,15963986,434787,1,'2007-09-15 13:08:09',3310504009,1),(51931095,425661936,15966089,434787,1,'2007-09-15 13:08:09',3310504009,1),(51931097,425661200,15966772,434787,1,'2007-09-15 13:08:10',3310504009,1),(51931099,425660648,15966956,434787,1,'2007-09-15 13:08:10',3310504009,1),(51931101,425660043,15966825,434787,1,'2007-09-15 13:08:10',3310504009,1),(51931103,425659386,15966510,434787,1,'2007-09-15 13:08:11',3310504009,1),(51931105,425658680,15966344,434787,1,'2007-09-15 13:08:11',3310504009,1),(51951640,426315393,14854723,434787,1,'2007-09-15 13:47:46',3310503081,1),(51951645,426316435,14864695,434787,1,'2007-09-15 13:47:46',3310503081,1),(51951647,426317923,14873922,434787,1,'2007-09-15 13:47:46',3310503081,1),(51951648,426320453,14882704,434787,1,'2007-09-15 13:47:46',3310503081,1),(51951650,426324025,14890443,434787,1,'2007-09-15 13:47:47',3310503083,1),(51951652,426327597,14897438,434787,1,'2007-09-15 13:47:47',3310503083,1),(51951654,426329681,14902350,434787,1,'2007-09-15 13:47:47',3310503083,1),(51951657,426329830,14905326,434787,1,'2007-09-15 13:47:47',3310503083,1),(51951658,426328342,14910833,434787,1,'2007-09-15 13:47:47',3310503083,1),(51951661,426327449,14919466,434787,1,'2007-09-15 13:47:48',3310503083,1),(51951665,426327151,14929586,434787,1,'2007-09-15 13:47:48',3310503083,1),(51951667,426326556,14935688,434787,1,'2007-09-15 13:47:48',3310503083,1),(51951670,426325514,14945660,434787,1,'2007-09-15 13:47:48',3310503425,1),(51951673,426324770,14954144,434787,1,'2007-09-15 13:47:48',3310503425,1),(51951676,426322984,14959353,434787,1,'2007-09-15 13:47:48',3310503425,1),(51951678,426321198,14961139,434787,1,'2007-09-15 13:47:49',3310503425,1),(51951680,426319147,14962559,434787,1,'2007-09-15 13:47:49',3310503425,1),(51951682,426317197,14963534,434787,1,'2007-09-15 13:47:49',3310503425,1),(51951684,426315185,14964144,434787,1,'2007-09-15 13:47:49',3310503425,1),(51951686,426313112,14963900,434787,1,'2007-09-15 13:47:49',3310503425,1),(51951689,426311588,14963230,434787,1,'2007-09-15 13:47:49',3310503425,1),(51951690,426310918,14962315,434787,1,'2007-09-15 13:47:49',3310503425,1),(51951692,426308113,14960608,434787,1,'2007-09-15 13:47:50',3310503425,1),(51951694,426306163,14959511,434787,1,'2007-09-15 13:47:50',3310503425,1),(51951696,426304334,14957499,434787,1,'2007-09-15 13:47:50',3310503425,1),(51951700,426302078,14954085,434787,1,'2007-09-15 13:47:50',3310503424,1),(51951701,426300066,14950976,434787,1,'2007-09-15 13:47:51',3310503424,1),(51951703,426298298,14947745,434787,1,'2007-09-15 13:47:51',3310503424,1),(51951706,426296287,14944270,434787,1,'2007-09-15 13:47:51',3310503424,1),(51951709,426293787,14940186,434787,1,'2007-09-15 13:47:51',3310503082,1),(51951711,426290678,14936894,434787,1,'2007-09-15 13:47:51',3310503082,1),(51951713,426288118,14934212,434787,1,'2007-09-15 13:47:51',3310503082,1),(51951716,426285740,14932931,434787,1,'2007-09-15 13:47:51',3310503082,1),(51951719,426283850,14932261,434787,1,'2007-09-15 13:47:52',3310503082,1),(51951723,426282326,14932261,434787,1,'2007-09-15 13:47:52',3310503082,1),(51951726,426280985,14932444,434787,1,'2007-09-15 13:47:52',3310503082,1),(51951729,426279339,14933785,434787,1,'2007-09-15 13:47:52',3310503082,1),(51951731,426278059,14933724,434787,1,'2007-09-15 13:47:52',3310503082,1),(51951734,426276718,14933480,434787,1,'2007-09-15 13:47:52',3310503082,1),(51951736,426275377,14932017,434787,1,'2007-09-15 13:47:52',3310502399,1),(51951739,426274096,14931590,434787,1,'2007-09-15 13:47:53',3310502399,1),(51951741,426272938,14931895,434787,1,'2007-09-15 13:47:53',3310502399,1),(51951744,426272572,14932992,434787,1,'2007-09-15 13:47:53',3310502399,1),(51951747,426272572,14933541,434787,1,'2007-09-15 13:47:53',3310502399,1),(51951748,426273548,14934699,434787,1,'2007-09-15 13:47:53',3310502399,1),(51951751,426275072,14935553,434787,1,'2007-09-15 13:47:54',3310502399,1),(51951755,426278730,14937382,434787,1,'2007-09-15 13:47:54',3310503082,1),(51951758,426281351,14939088,434787,1,'2007-09-15 13:47:54',3310503082,1),(51951761,426284399,14941466,434787,1,'2007-09-15 13:47:54',3310503082,1),(51951763,426286411,14943783,434787,1,'2007-09-15 13:47:54',3310503424,1),(51951766,426287813,14945002,434787,1,'2007-09-15 13:47:54',3310503424,1),(51951769,426289703,14946038,434787,1,'2007-09-15 13:47:55',3310503424,1),(51951772,426290251,14946953,434787,1,'2007-09-15 13:47:55',3310503424,1),(51951775,426290068,14948233,434787,1,'2007-09-15 13:47:55',3310503424,1),(51951777,426289215,14948599,434787,1,'2007-09-15 13:47:55',3310503424,1),(51951780,426287996,14947928,434787,1,'2007-09-15 13:47:55',3310503424,1),(51951784,426286655,14947014,434787,1,'2007-09-15 13:47:55',3310503424,1),(51951785,426285070,14945733,434787,1,'2007-09-15 13:47:55',3310503424,1),(51951788,426282387,14944209,434787,1,'2007-09-15 13:47:56',3310503424,1),(51951790,426280254,14942685,434787,1,'2007-09-15 13:47:56',3310503424,1),(51951793,426279034,14941954,434787,1,'2007-09-15 13:47:56',3310503424,1),(51951796,426277937,14942015,434787,1,'2007-09-15 13:47:56',3310503424,1),(51951799,426277388,14942563,434787,1,'2007-09-15 13:47:56',3310503424,1),(51951801,426277205,14943661,434787,1,'2007-09-15 13:47:57',3310503424,1),(51951805,426277510,14944453,434787,1,'2007-09-15 13:47:57',3310503424,1),(51951808,426278181,14945490,434787,1,'2007-09-15 13:47:57',3310503424,1),(51951810,426279644,14946160,434787,1,'2007-09-15 13:47:58',3310503424,1),(51951813,426281656,14946770,434787,1,'2007-09-15 13:47:58',3310503424,1),(51951816,426282997,14948416,434787,1,'2007-09-15 13:47:58',3310503424,1),(51951817,426284765,14950549,434787,1,'2007-09-15 13:47:58',3310503424,1),(51951819,426288057,14952866,434787,1,'2007-09-15 13:47:58',3310503424,1),(51951821,426291532,14955183,434787,1,'2007-09-15 13:47:58',3310503424,1),(51951824,426293482,14956646,434787,1,'2007-09-15 13:47:58',3310503424,1),(51951827,426294153,14957743,434787,1,'2007-09-15 13:47:59',3310503424,1),(51951830,426294214,14958901,434787,1,'2007-09-15 13:47:59',3310503424,1),(51951833,426293665,14959877,434787,1,'2007-09-15 13:47:59',3310503424,1),(51951836,426292812,14960120,434787,1,'2007-09-15 13:47:59',3310503424,1),(51951838,426291775,14959694,434787,1,'2007-09-15 13:47:59',3310503424,1),(51951840,426290068,14958596,434787,1,'2007-09-15 13:47:59',3310503424,1),(51951843,426288910,14957987,434787,1,'2007-09-15 13:48:00',3310503424,1),(51951846,426287569,14957499,434787,1,'2007-09-15 13:48:00',3310503424,1),(51951848,426286106,14958170,434787,1,'2007-09-15 13:48:00',3310503424,1),(51951851,426284399,14958901,434787,1,'2007-09-15 13:48:00',3310503424,1),(51951854,426282753,14959267,434787,1,'2007-09-15 13:48:00',3310503424,1),(51951857,426280863,14959694,434787,1,'2007-09-15 13:48:00',3310503424,1),(51951858,426279888,14960425,434787,1,'2007-09-15 13:48:01',3310503424,1),(51951859,426279522,14961584,434787,1,'2007-09-15 13:48:01',3310503424,1),(51951861,426279949,14962559,434787,1,'2007-09-15 13:48:01',3310503424,1),(51951864,426281229,14963778,434787,1,'2007-09-15 13:48:01',3310503424,1),(51951865,426282814,14964266,434787,1,'2007-09-15 13:48:01',3310503424,1),(51951868,426285496,14964022,434787,1,'2007-09-15 13:48:02',3310503424,1),(51951872,426288423,14963839,434787,1,'2007-09-15 13:48:02',3310503424,1),(51951874,426290495,14964144,434787,1,'2007-09-15 13:48:02',3310503424,1),(51951876,426292873,14964876,434787,1,'2007-09-15 13:48:02',3310503424,1),(51951879,426296287,14966826,434787,1,'2007-09-15 13:48:02',3310503424,1),(51951882,426298542,14968655,434787,1,'2007-09-15 13:48:02',3310503424,1),(51951885,426298725,14969509,434787,1,'2007-09-15 13:48:02',3310503424,1),(51951886,426298542,14970423,434787,1,'2007-09-15 13:48:03',3310503424,1),(51951889,426297933,14971033,434787,1,'2007-09-15 13:48:03',3310503424,1),(51951892,426296652,14971094,434787,1,'2007-09-15 13:48:03',3310503424,1),(51951895,426295494,14970667,434787,1,'2007-09-15 13:48:03',3310503424,1),(51951898,426294275,14970545,434787,1,'2007-09-15 13:48:03',3310503424,1),(51951900,426293178,14970484,434787,1,'2007-09-15 13:48:03',3310503424,1),(51951903,426291410,14970972,434787,1,'2007-09-15 13:48:04',3310503424,1),(51951905,426289764,14971581,434787,1,'2007-09-15 13:48:04',3310503424,1),(51951908,426286411,14974203,434787,1,'2007-09-15 13:48:04',3310503424,1),(51951911,426284033,14975361,434787,1,'2007-09-15 13:48:04',3310503424,1),(51951914,426282448,14976580,434787,1,'2007-09-15 13:48:04',3310503424,1),(51951917,426282448,14978531,434787,1,'2007-09-15 13:48:04',3310503424,1),(51951920,426282936,14979506,434787,1,'2007-09-15 13:48:04',3310503424,1),(51951922,426284033,14979811,434787,1,'2007-09-15 13:48:05',3310503424,1),(51951924,426284826,14979263,434787,1,'2007-09-15 13:48:05',3310503424,1),(51951927,426286167,14977678,434787,1,'2007-09-15 13:48:05',3310503424,1),(51951930,426287569,14977190,434787,1,'2007-09-15 13:48:05',3310503424,1),(51951933,426291288,14977495,434787,1,'2007-09-15 13:48:05',3310503424,1),(51951935,426294458,14977190,434787,1,'2007-09-15 13:48:05',3310503424,1),(51951937,426298725,14976580,434787,1,'2007-09-15 13:48:05',3310503424,1),(51951938,426300737,14976215,434787,1,'2007-09-15 13:48:05',3310503424,1),(51951941,426301712,14976215,434787,1,'2007-09-15 13:48:06',3310503424,1),(51951944,426302383,14976824,434787,1,'2007-09-15 13:48:06',3310503424,1),(51951947,426302627,14978165,434787,1,'2007-09-15 13:48:06',3310503424,1),(51951950,426302383,14979263,434787,1,'2007-09-15 13:48:06',3310503424,1),(51951953,426301164,14980055,434787,1,'2007-09-15 13:48:06',3310503424,1),(51951956,426298237,14982067,434787,1,'2007-09-15 13:48:06',3310503424,1),(51951957,426294336,14985237,434787,1,'2007-09-15 13:48:07',3310503424,1),(51951960,426292080,14987614,434787,1,'2007-09-15 13:48:07',3310503424,1),(51951963,426291044,14989321,434787,1,'2007-09-15 13:48:07',3310503424,1),(51951965,426291227,14990419,434787,1,'2007-09-15 13:48:07',3310503424,1),(51951966,426292080,14990845,434787,1,'2007-09-15 13:48:07',3310503424,1),(51951969,426292995,14990845,434787,1,'2007-09-15 13:48:07',3310503424,1),(51951970,426297567,14988590,434787,1,'2007-09-15 13:48:07',3310503424,1),(51951973,426301468,14986212,434787,1,'2007-09-15 13:48:07',3310503424,1),(51951975,426304456,14983957,434787,1,'2007-09-15 13:48:08',3310503425,1),(51951978,426306406,14982494,434787,1,'2007-09-15 13:48:08',3310503425,1),(51951980,426307066,14981746,434787,1,'2007-09-15 13:48:08',3310503425,1),(51951983,426307952,14981999,434787,1,'2007-09-15 13:48:08',3310503425,1),(51951985,426308459,14983076,434787,1,'2007-09-15 13:48:08',3310503425,1),(51951988,426307952,14984406,434787,1,'2007-09-15 13:48:09',3310503425,1),(51951989,426306432,14985989,434787,1,'2007-09-15 13:48:09',3310503425,1),(51951992,426303773,14989662,434787,1,'2007-09-15 13:48:09',3310503425,1),(51951995,426301936,14992575,434787,1,'2007-09-15 13:48:09',3310503424,1),(51951999,426300606,14994222,434787,1,'2007-09-15 13:48:09',3310503424,1),(51952002,426299213,14994412,434787,1,'2007-09-15 13:48:09',3310503424,1),(51952005,426297820,14994348,434787,1,'2007-09-15 13:48:10',3310503424,1),(51952009,426297060,14994855,434787,1,'2007-09-15 13:48:10',3310503424,1),(51952013,426296933,14995805,434787,1,'2007-09-15 13:48:10',3310503424,1),(51952014,426296933,14996881,434787,1,'2007-09-15 13:48:10',3310503426,1),(51952017,426297440,14998021,434787,1,'2007-09-15 13:48:11',3310503426,1),(51952019,426298390,14998021,434787,1,'2007-09-15 13:48:11',3310503426,1),(51952022,426299656,14998021,434787,1,'2007-09-15 13:48:11',3310503426,1),(51952025,426300859,14997325,434787,1,'2007-09-15 13:48:11',3310503426,1),(51952028,426302189,14996438,434787,1,'2007-09-15 13:48:11',3310503424,1),(51952029,426304976,14993652,434787,1,'2007-09-15 13:48:12',3310503425,1),(51952031,426306749,14992068,434787,1,'2007-09-15 13:48:12',3310503425,1),(51952034,426308142,14992005,434787,1,'2007-09-15 13:48:12',3310503425,1),(51952037,426310422,14992005,434787,1,'2007-09-15 13:48:12',3310503425,1),(51952039,426314665,14992448,434787,1,'2007-09-15 13:48:12',3310503425,1),(51952042,426317388,14992702,434787,1,'2007-09-15 13:48:12',3310503425,1),(51952045,426318781,14993525,434787,1,'2007-09-15 13:48:13',3310503425,1),(51952046,426321061,14996058,434787,1,'2007-09-15 13:48:13',3310503425,1),(51952048,426323784,14998021,434787,1,'2007-09-15 13:48:13',3310503427,1),(51952050,426326381,14999414,434787,1,'2007-09-15 13:48:13',3310503427,1),(51952053,426327584,14999984,434787,1,'2007-09-15 13:48:14',3310503427,1),(51952055,426327710,15000998,434787,1,'2007-09-15 13:48:14',3310503427,1),(51952058,426327520,15001884,434787,1,'2007-09-15 13:48:14',3310503427,1),(51952060,426326824,15002264,434787,1,'2007-09-15 13:48:14',3310503427,1),(51952063,426325747,15002201,434787,1,'2007-09-15 13:48:14',3310503427,1),(51952065,426324354,15001504,434787,1,'2007-09-15 13:48:14',3310503427,1),(51952068,426322644,15000491,434787,1,'2007-09-15 13:48:15',3310503427,1),(51952069,426320998,14999668,434787,1,'2007-09-15 13:48:15',3310503427,1),(51952073,426319288,14999794,434787,1,'2007-09-15 13:48:15',3310503427,1),(51952075,426317578,15001251,434787,1,'2007-09-15 13:48:15',3310503427,1),(51952078,426316501,15003214,434787,1,'2007-09-15 13:48:15',3310503427,1),(51952080,426316438,15005431,434787,1,'2007-09-15 13:48:15',3310503427,1),(51952083,426316248,15007710,434787,1,'2007-09-15 13:48:16',3310503427,1),(51952084,426315551,15009737,434787,1,'2007-09-15 13:48:16',3310503427,1),(51952087,426314348,15010623,434787,1,'2007-09-15 13:48:16',3310503427,1),(51952090,426312765,15011320,434787,1,'2007-09-15 13:48:16',3310503427,1),(51952093,426311499,15011510,434787,1,'2007-09-15 13:48:17',3310503427,1),(51952096,426310485,15012713,434787,1,'2007-09-15 13:48:17',3310503427,1),(51952099,426309979,15014170,434787,1,'2007-09-15 13:48:17',3310503427,1),(51952101,426310295,15017273,434787,1,'2007-09-15 13:48:17',3310503427,1),(51952103,426311688,15023289,434787,1,'2007-09-15 13:48:18',3310503427,1),(51952105,426315108,15035448,434787,1,'2007-09-15 13:48:18',3310503427,1),(51952107,426319035,15047670,434787,1,'2007-09-15 13:48:18',3310503427,1),(51952110,426320382,15052106,434787,1,'2007-09-15 13:48:18',3310503433,1),(51952111,426321322,15056879,434787,1,'2007-09-15 13:48:18',3310503433,1),(51952113,426321595,15061937,434787,1,'2007-09-15 13:48:18',3310503433,1),(51952115,426321284,15068162,434787,1,'2007-09-15 13:48:18',3310503433,1),(51952118,426320894,15070886,434787,1,'2007-09-15 13:48:19',3310503433,1),(51952120,426320468,15072599,434787,1,'2007-09-15 13:48:19',3310503433,1),(51952122,426320023,15073775,434787,1,'2007-09-15 13:48:19',3310503433,1),(51952125,426319453,15074759,434787,1,'2007-09-15 13:48:19',3310503433,1),(51952126,426318327,15075959,434787,1,'2007-09-15 13:48:19',3310503433,1),(51952128,426317200,15077122,434787,1,'2007-09-15 13:48:19',3310503433,1),(51952132,426316097,15078850,434787,1,'2007-09-15 13:48:19',3310503433,1),(51952136,426315620,15080251,434787,1,'2007-09-15 13:48:19',3310503433,1),(51952139,426314548,15083946,434787,1,'2007-09-15 13:48:20',3310503433,1),(51952141,426313833,15087402,434787,1,'2007-09-15 13:48:20',3310503433,1),(51952145,426313415,15089578,434787,1,'2007-09-15 13:48:20',3310503433,1),(51952148,426313535,15091127,434787,1,'2007-09-15 13:48:20',3310503433,1),(51952150,426313773,15092647,434787,1,'2007-09-15 13:48:20',3310503433,1),(51952152,426313684,15094137,434787,1,'2007-09-15 13:48:20',3310503433,1),(51952155,426313445,15095001,434787,1,'2007-09-15 13:48:21',3310503433,1),(51952157,426313088,15096879,434787,1,'2007-09-15 13:48:21',3310503433,1),(51952159,426313117,15097951,434787,1,'2007-09-15 13:48:21',3310503433,1),(51952161,426313356,15098547,434787,1,'2007-09-15 13:48:21',3310503433,1),(51952163,426313803,15099143,434787,1,'2007-09-15 13:48:21',3310503433,1),(51952167,426314429,15099441,434787,1,'2007-09-15 13:48:21',3310503433,1),(51952170,426315054,15099352,434787,1,'2007-09-15 13:48:21',3310503433,1),(51952172,426315620,15098935,434787,1,'2007-09-15 13:48:22',3310503433,1),(51952176,426316216,15098130,434787,1,'2007-09-15 13:48:22',3310503433,1),(51952177,426316514,15097147,434787,1,'2007-09-15 13:48:22',3310503433,1),(51952180,426316604,15096342,434787,1,'2007-09-15 13:48:22',3310503433,1),(51952183,426316485,15095329,434787,1,'2007-09-15 13:48:22',3310503433,1),(51952185,426316276,15094197,434787,1,'2007-09-15 13:48:23',3310503433,1),(51952187,426316127,15092737,434787,1,'2007-09-15 13:48:23',3310503433,1),(51952190,426316097,15091425,434787,1,'2007-09-15 13:48:23',3310503433,1),(51952192,426316365,15089965,434787,1,'2007-09-15 13:48:23',3310503433,1),(51952193,426317468,15086747,434787,1,'2007-09-15 13:48:23',3310503433,1),(51952195,426318392,15084542,434787,1,'2007-09-15 13:48:23',3310503433,1),(51952196,426319375,15083231,434787,1,'2007-09-15 13:48:23',3310503433,1),(51952199,426320508,15081979,434787,1,'2007-09-15 13:48:23',3310503433,1),(51952201,426321253,15080578,434787,1,'2007-09-15 13:48:24',3310503433,1),(51952204,426321878,15079655,434787,1,'2007-09-15 13:48:24',3310503433,1),(51952205,426322504,15079178,434787,1,'2007-09-15 13:48:24',3310503433,1),(51952207,426323309,15079327,434787,1,'2007-09-15 13:48:24',3310503433,1),(51952210,426323964,15080161,434787,1,'2007-09-15 13:48:24',3310503433,1),(51952213,426324143,15081025,434787,1,'2007-09-15 13:48:24',3310503433,1),(51952215,426323786,15082158,434787,1,'2007-09-15 13:48:24',3310503433,1),(51952217,426323130,15082933,434787,1,'2007-09-15 13:48:24',3310503433,1),(51952220,426322415,15083350,434787,1,'2007-09-15 13:48:24',3310503433,1),(51952223,426321372,15084274,434787,1,'2007-09-15 13:48:24',3310503433,1),(51952226,426320835,15085138,434787,1,'2007-09-15 13:48:25',3310503433,1),(51952230,426320180,15087164,434787,1,'2007-09-15 13:48:25',3310503433,1),(51952233,426319763,15089488,434787,1,'2007-09-15 13:48:25',3310503433,1),(51952236,426319763,15093213,434787,1,'2007-09-15 13:48:25',3310503433,1),(51952238,426319733,15096372,434787,1,'2007-09-15 13:48:25',3310503433,1),(51952240,426319554,15097415,434787,1,'2007-09-15 13:48:25',3310503433,1),(51952243,426319345,15098488,434787,1,'2007-09-15 13:48:25',3310503433,1),(51952246,426318839,15099650,434787,1,'2007-09-15 13:48:26',3310503433,1),(51952248,426318451,15100365,434787,1,'2007-09-15 13:48:26',3310503433,1),(51952250,426317913,15102097,434787,1,'2007-09-15 13:48:26',3310503433,1),(51952252,426317655,15103488,434787,1,'2007-09-15 13:48:26',3310503433,1),(51952255,426317758,15104930,434787,1,'2007-09-15 13:48:26',3310503433,1),(51952256,426318119,15106629,434787,1,'2007-09-15 13:48:26',3310503435,1),(51952259,426318953,15109101,434787,1,'2007-09-15 13:48:26',3310503435,1),(51952261,426319777,15111243,206510,1,'2008-12-06 19:38:24',3310503435,4),(51952264,426320395,15113096,206510,1,'2008-12-06 19:38:24',3310503435,4),(51952267,426320395,15114662,206510,1,'2008-12-06 19:38:24',3310503435,4),(51952269,426320106,15115857,206510,1,'2008-12-06 19:38:24',3310503435,4),(51952271,426319340,15117298,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952274,426318220,15119638,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952276,426317629,15121487,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952279,426317283,15122903,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952280,426317126,15124193,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952284,426316811,15126760,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952287,426317000,15128422,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952290,426317604,15129554,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952292,426318850,15130423,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952295,426319832,15131442,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952297,426320814,15133254,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952300,426321191,15135067,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952303,426321304,15137068,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952305,426321113,15138218,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952306,426320411,15140322,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952307,426319643,15142293,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952311,426318741,15145634,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952316,426317806,15149442,206510,1,'2008-12-06 19:38:22',3310503435,4),(51952320,426317438,15151680,206510,1,'2008-12-06 19:38:22',3310503435,4),(51952323,426315915,15158197,206510,1,'2008-12-06 19:38:22',3310503435,4),(51952325,426315248,15161445,206510,1,'2008-12-06 19:38:22',3310503457,4),(51952328,426314332,15163485,206510,1,'2008-12-06 19:38:22',3310503457,4),(51952330,426313166,15166567,206510,1,'2008-12-06 19:38:22',3310503457,4),(51952333,426312417,15169731,206510,1,'2008-12-06 19:38:22',3310503457,4),(51952335,426311841,15173744,206510,1,'2008-12-06 19:38:22',3310503457,4),(51952338,426311290,15176408,206510,1,'2008-12-06 19:38:22',3310503457,4),(51952341,426310922,15179025,206510,1,'2008-12-06 19:38:21',3310503457,4),(51952343,426310417,15182699,206510,1,'2008-12-06 19:38:21',3310503457,4),(51952345,426308993,15188899,206510,1,'2008-12-06 19:38:21',3310503457,4),(51952347,426307715,15193479,206510,1,'2008-12-06 19:38:21',3310503457,4),(51952350,426306561,15197161,206510,1,'2008-12-06 19:38:21',3310503457,4),(51952351,426305242,15200514,206510,1,'2008-12-06 19:38:21',3310503457,4),(51952354,426304198,15205075,206510,1,'2008-12-06 19:38:21',3310503457,4),(51952359,426303813,15207438,206510,1,'2008-12-06 19:38:21',3310503457,4),(51952362,426303264,15210241,206510,1,'2008-12-06 19:38:20',3310503456,4),(51952365,426302219,15212165,206510,1,'2008-12-06 19:38:20',3310503456,4),(51952367,426301450,15213374,206510,1,'2008-12-06 19:38:20',3310503456,4),(51952369,426300296,15215297,206510,1,'2008-12-06 19:38:20',3310503456,4),(51952373,426298922,15218155,206510,1,'2008-12-06 19:38:20',3310503458,4),(51952376,426297493,15221475,206510,1,'2008-12-06 19:38:20',3310503458,4),(51952378,426296570,15224200,206510,1,'2008-12-06 19:38:20',3310503458,4),(51952382,426295602,15226443,206510,1,'2008-12-06 19:38:20',3310503458,4),(51952385,426294899,15228157,206510,1,'2008-12-06 19:38:20',3310503458,4),(51952388,426293844,15229564,206510,1,'2008-12-06 19:38:20',3310503458,4),(51952390,426292877,15230312,206510,1,'2008-12-06 19:38:19',3310503458,4),(51952394,426290546,15232598,206510,1,'2008-12-06 19:38:19',3310503458,4),(51952396,426289051,15233961,206510,1,'2008-12-06 19:38:19',3310503458,4),(51952399,426287688,15234840,206510,1,'2008-12-06 19:38:19',3310503458,4),(51952403,426286809,15235368,206510,1,'2008-12-06 19:38:19',3310503458,4),(51952405,426284303,15236379,206510,1,'2008-12-06 19:38:19',3310503458,4),(51952408,426282940,15236555,206510,1,'2008-12-06 19:38:19',3310503458,4),(51952411,426280522,15236643,206510,1,'2008-12-06 19:38:19',3310503458,4),(51952413,426278192,15236775,206510,1,'2008-12-06 19:38:19',3310503458,4),(51952416,426276786,15237483,206510,1,'2008-12-06 19:38:19',3310503458,4),(51952418,426275755,15238583,206510,1,'2008-12-06 19:38:19',3310502775,4),(51952420,426274994,15239418,206510,1,'2008-12-06 19:38:19',3310502775,4),(51952423,426273239,15240830,206510,1,'2008-12-06 19:38:18',3310502775,4),(51952426,426270378,15241749,206510,1,'2008-12-06 19:38:18',3310502775,4),(51952429,426269857,15242589,206510,1,'2008-12-06 19:38:18',3310502775,4),(51952430,426269486,15244293,206510,1,'2008-12-06 19:38:18',3310502775,4),(51952433,426271331,15241100,206510,1,'2008-12-06 19:38:18',3310502775,4),(51952436,426274047,15240347,206510,1,'2008-12-06 19:38:19',3310502775,4),(51952439,426276260,15238044,206510,1,'2008-12-06 19:38:19',3310503458,4),(51952441,426268912,15245824,206510,1,'2008-12-06 19:38:18',3310502775,4),(51952444,426268254,15246937,206510,1,'2008-12-06 19:38:18',3310502775,4),(51952446,426267318,15248101,206510,1,'2008-12-06 19:38:18',3310502775,4),(51952449,426266280,15249543,206510,1,'2008-12-06 19:38:18',3310502775,4),(51952452,426265774,15251795,206510,1,'2008-12-06 19:38:17',3310502775,4),(51952455,426265470,15253491,206510,1,'2008-12-06 19:38:17',3310502775,4),(51952457,426264737,15257590,206510,1,'2008-12-06 19:38:17',3310502775,4),(51952460,426263952,15260146,206510,1,'2008-12-06 19:38:17',3310502775,4),(51952463,426263674,15261537,206510,1,'2008-12-06 19:38:17',3310502775,4),(51952465,426263396,15264245,206510,1,'2008-12-06 19:38:17',3310502775,4),(51952468,426263214,15265846,206510,1,'2008-12-06 19:38:17',3310502775,4),(51952472,426262923,15267777,206510,1,'2008-12-06 19:38:16',3310502775,4),(51952475,426262340,15268943,206510,1,'2008-12-06 19:38:16',3310502775,4),(51952478,426261429,15270437,206510,1,'2008-12-06 19:38:16',3310502775,4),(51952481,426260372,15271494,206510,1,'2008-12-06 19:38:16',3310502781,4),(51952484,426258405,15272441,206510,1,'2008-12-06 19:38:16',3310502781,4),(51952487,426256838,15273206,206510,1,'2008-12-06 19:38:16',3310502781,4),(51952490,426255708,15274044,206510,1,'2008-12-06 19:38:16',3310502781,4),(51952492,426254433,15275174,206510,1,'2008-12-06 19:38:16',3310502781,4),(51952495,426252538,15278636,206510,1,'2008-12-06 19:38:16',3310502781,4),(51952498,426248034,15284558,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952500,426247147,15285928,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952502,426246543,15287298,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952504,426245938,15290965,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952506,426245737,15295841,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952508,426245737,15297856,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952510,426245547,15301341,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952512,426245162,15303579,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952513,426244274,15306356,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952515,426242808,15310099,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952517,426240416,15316696,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952520,426238410,15323640,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952523,426236751,15327960,206510,1,'2008-12-06 19:38:15',3310502782,4),(51952524,426233935,15333863,206510,1,'2008-12-06 19:38:15',3310502782,4),(51952525,426231158,15339650,206510,1,'2008-12-06 19:38:15',3310502782,4),(51952527,426228573,15344356,206510,1,'2008-12-06 19:38:15',3310502782,4),(51952530,426225872,15350915,434787,1,'2007-09-15 13:48:43',3310502782,1),(51952532,426222284,15360907,434787,1,'2007-09-15 13:48:43',3310502782,1),(51952534,426221089,15363607,434787,1,'2007-09-15 13:48:43',3310502779,1),(51952536,426219584,15366462,434787,1,'2007-09-15 13:48:43',3310502779,1),(51952539,426218423,15369541,434787,1,'2007-09-15 13:48:43',3310502779,1),(51952542,426216338,15375927,434787,1,'2007-09-15 13:48:43',3310502779,1),(51952545,426214802,15381518,434787,1,'2007-09-15 13:48:44',3310502865,1),(51952546,426213450,15386125,434787,1,'2007-09-15 13:48:44',3310502865,1),(51952549,426213512,15388030,434787,1,'2007-09-15 13:48:44',3310502865,1),(51952552,426214863,15392515,434787,1,'2007-09-15 13:48:44',3310502865,1),(51952556,426216461,15396385,434787,1,'2007-09-15 13:48:44',3310502865,1),(51952559,426217321,15400686,434787,1,'2007-09-15 13:48:45',3310502865,1),(51952562,426219594,15404618,434787,1,'2007-09-15 13:48:45',3310502865,1),(51952566,426220786,15407370,434787,1,'2007-09-15 13:48:45',3310502865,1),(51952570,426223245,15411389,434787,1,'2007-09-15 13:48:45',3310502868,1),(51952573,426225645,15414989,434787,1,'2007-09-15 13:48:45',3310502868,1),(51952575,426227385,15419608,434787,1,'2007-09-15 13:48:46',3310502868,1),(51952578,426228645,15424648,434787,1,'2007-09-15 13:48:46',3310502868,1),(51952580,426232065,15431547,434787,1,'2007-09-15 13:48:46',3310502868,1),(51952583,426235124,15438026,434787,1,'2007-09-15 13:48:46',3310502870,1),(51952584,426236467,15441568,434787,1,'2007-09-15 13:48:46',3310502870,1),(51952586,426237902,15443817,434787,1,'2007-09-15 13:48:46',3310502870,1),(51952590,426239957,15445601,434787,1,'2007-09-15 13:48:47',3310502870,1),(51952594,426241818,15448005,434787,1,'2007-09-15 13:48:47',3310502870,1),(51952597,426245231,15453124,434787,1,'2007-09-15 13:48:47',3310502870,1),(51952599,426248333,15458204,434787,1,'2007-09-15 13:48:47',3310502870,1),(51952601,426251965,15463806,434787,1,'2007-09-15 13:48:47',3310502871,1),(51952604,426254231,15468023,434787,1,'2007-09-15 13:48:47',3310502871,1),(51952605,426255993,15473939,434787,1,'2007-09-15 13:48:47',3310502871,1),(51952608,426257126,15482059,434787,1,'2007-09-15 13:48:48',3310502871,1),(51952610,426258007,15495402,434787,1,'2007-09-15 13:48:48',3310502877,1),(51952613,426258766,15499341,434787,1,'2007-09-15 13:48:48',3310502877,1),(51952615,426259769,15502392,434787,1,'2007-09-15 13:48:48',3310502877,1),(51952618,426260815,15506402,434787,1,'2007-09-15 13:48:48',3310502877,1),(51952620,426261861,15511894,434787,1,'2007-09-15 13:48:49',3310502877,1),(51952623,426262341,15515076,434787,1,'2007-09-15 13:48:49',3310502877,1),(51952627,426262079,15516428,434787,1,'2007-09-15 13:48:49',3310502877,1),(51952630,426261643,15517256,434787,1,'2007-09-15 13:48:49',3310502877,1),(51952632,426259900,15519130,434787,1,'2007-09-15 13:48:49',3310502877,1),(51952634,426259028,15519522,434787,1,'2007-09-15 13:48:50',3310502877,1),(51952635,426257415,15519653,434787,1,'2007-09-15 13:48:50',3310502877,1),(51952638,426254582,15519392,434787,1,'2007-09-15 13:48:50',3310502877,1),(51952640,426251313,15518912,434787,1,'2007-09-15 13:48:50',3310502877,1),(51952643,426249046,15518302,434787,1,'2007-09-15 13:48:50',3310502877,1),(51952647,426247303,15517604,434787,1,'2007-09-15 13:48:51',3310502876,1),(51952649,426244949,15517561,434787,1,'2007-09-15 13:48:51',3310502876,1),(51952652,426241331,15517910,434787,1,'2007-09-15 13:48:51',3310502876,1),(51952653,426238759,15518084,434787,1,'2007-09-15 13:48:51',3310502876,1),(51952656,426237059,15517866,434787,1,'2007-09-15 13:48:52',3310502876,1),(51952659,426234749,15517735,434787,1,'2007-09-15 13:48:52',3310502876,1),(51952662,426232438,15517110,434787,1,'2007-09-15 13:48:52',3310502876,1),(51952665,426231265,15516684,434787,1,'2007-09-15 13:48:52',3310502876,1),(51952667,426229826,15516791,434787,1,'2007-09-15 13:48:52',3310502876,1),(51952668,426228280,15517697,434787,1,'2007-09-15 13:48:52',3310502876,1),(51952671,426225401,15520469,434787,1,'2007-09-15 13:48:53',3310502876,1),(51952672,426221829,15523561,434787,1,'2007-09-15 13:48:53',3310502876,1),(51952675,426221259,15524255,434787,1,'2007-09-15 13:48:53',3310502876,1),(51952677,426221189,15525227,434787,1,'2007-09-15 13:48:53',3310502876,1),(51952682,426221583,15525690,434787,1,'2007-09-15 13:48:53',3310502876,1),(51952684,426222162,15525883,434787,1,'2007-09-15 13:48:54',3310502876,1),(51952686,426223002,15525267,434787,1,'2007-09-15 13:48:54',3310502876,1),(51952689,426224122,15524627,434787,1,'2007-09-15 13:48:54',3310502876,1),(51952690,426225987,15522868,434787,1,'2007-09-15 13:48:55',3310502876,1),(51952692,426227188,15522081,434787,1,'2007-09-15 13:48:55',3310502876,1),(51952694,426227974,15521393,434787,1,'2007-09-15 13:48:55',3310502876,1),(51952695,426229137,15520623,434787,1,'2007-09-15 13:48:55',3310502876,1),(51952699,426229923,15520640,434787,1,'2007-09-15 13:48:55',3310502876,1),(51952701,426230463,15520885,434787,1,'2007-09-15 13:48:55',3310502876,1),(51952702,426230693,15521459,434787,1,'2007-09-15 13:48:55',3310502876,1),(51952705,426230611,15521835,434787,1,'2007-09-15 13:48:55',3310502876,1),(51952706,426230316,15522245,434787,1,'2007-09-15 13:48:55',3310502876,1),(51952709,426229726,15522556,434787,1,'2007-09-15 13:48:56',3310502876,1),(51952712,426228989,15522752,434787,1,'2007-09-15 13:48:56',3310502876,1),(51952714,426226942,15524472,434787,1,'2007-09-15 13:48:56',3310502876,1),(51952715,426225779,15526077,434787,1,'2007-09-15 13:48:56',3310502876,1),(51952717,426223542,15528266,434787,1,'2007-09-15 13:48:57',3310502876,1),(51952719,426221830,15530222,434787,1,'2007-09-15 13:48:57',3310502876,1),(51952722,426221138,15531567,434787,1,'2007-09-15 13:48:57',3310502876,1),(51952724,426220485,15533441,434787,1,'2007-09-15 13:48:57',3310502873,1),(51952727,426219630,15536579,434787,1,'2007-09-15 13:48:57',3310502873,1),(51952729,426218570,15539147,434787,1,'2007-09-15 13:48:57',3310502873,1),(51952732,426217551,15540410,434787,1,'2007-09-15 13:48:57',3310502873,1),(51952733,426215595,15542937,434787,1,'2007-09-15 13:48:58',3310502873,1),(51952737,426214699,15544485,434787,1,'2007-09-15 13:48:58',3310502873,1),(51952740,426213517,15547053,434787,1,'2007-09-15 13:48:58',3310502875,1),(51952742,426213272,15547908,434787,1,'2007-09-15 13:48:58',3310502875,1),(51952745,426213354,15548683,434787,1,'2007-09-15 13:48:58',3310502875,1),(51952748,426213680,15549375,434787,1,'2007-09-15 13:48:58',3310502875,1),(51952751,426214291,15549579,434787,1,'2007-09-15 13:48:58',3310502875,1),(51952754,426215106,15549538,434787,1,'2007-09-15 13:48:58',3310502875,1),(51952756,426215554,15548846,434787,1,'2007-09-15 13:48:59',3310502875,1),(51952758,426216044,15547582,434787,1,'2007-09-15 13:48:59',3310502875,1),(51952761,426217592,15545789,434787,1,'2007-09-15 13:48:59',3310502873,1),(51952764,426218855,15544811,434787,1,'2007-09-15 13:48:59',3310502873,1),(51952767,426220241,15543344,434787,1,'2007-09-15 13:48:59',3310502873,1),(51952770,426221464,15541959,434787,1,'2007-09-15 13:49:00',3310502876,1),(51952772,426222645,15539758,434787,1,'2007-09-15 13:49:00',3310502876,1),(51952775,426223460,15536865,434787,1,'2007-09-15 13:49:00',3310502876,1),(51952777,426223949,15534786,434787,1,'2007-09-15 13:49:00',3310502876,1),(51952780,426225009,15533401,434787,1,'2007-09-15 13:49:00',3310502876,1),(51952782,426226395,15532137,434787,1,'2007-09-15 13:49:00',3310502876,1),(51952784,426227495,15531241,434787,1,'2007-09-15 13:49:00',3310502876,1),(51952786,426228391,15531322,434787,1,'2007-09-15 13:49:00',3310502876,1),(51952788,426229125,15532137,434787,1,'2007-09-15 13:49:01',3310502876,1),(51952790,426229451,15533971,434787,1,'2007-09-15 13:49:01',3310502876,1),(51952792,426229247,15534786,434787,1,'2007-09-15 13:49:01',3310502876,1),(51952795,426228269,15536335,434787,1,'2007-09-15 13:49:01',3310502876,1),(51952797,426226802,15538291,434787,1,'2007-09-15 13:49:01',3310502876,1),(51952800,426225743,15541103,434787,1,'2007-09-15 13:49:01',3310502876,1),(51952802,426224968,15544485,434787,1,'2007-09-15 13:49:01',3310502876,1),(51952804,426224072,15547338,434787,1,'2007-09-15 13:49:01',3310502878,1),(51952807,426222808,15548927,434787,1,'2007-09-15 13:49:01',3310502878,1),(51952811,426221545,15551332,434787,1,'2007-09-15 13:49:02',3310502878,1),(51952813,426220445,15553410,434787,1,'2007-09-15 13:49:02',3310502875,1),(51952815,426219100,15555488,434787,1,'2007-09-15 13:49:02',3310502875,1),(51952818,426217674,15557526,434787,1,'2007-09-15 13:49:02',3310502875,1),(51952820,426216533,15560134,434787,1,'2007-09-15 13:49:02',3310502875,1),(51952824,426216084,15562335,434787,1,'2007-09-15 13:49:02',3310502875,1),(51952827,426216125,15565717,434787,1,'2007-09-15 13:49:02',3310502875,1),(51952829,426215658,15568442,434787,1,'2007-09-15 13:49:03',3310502875,1),(51952831,426215107,15571455,434787,1,'2007-09-15 13:49:03',3310502875,1),(51952832,426214850,15573917,434787,1,'2007-09-15 13:49:03',3310502875,1),(51952834,426214556,15576563,434787,1,'2007-09-15 13:49:03',3310502875,1),(51952837,426213968,15579282,434787,1,'2007-09-15 13:49:03',3310502875,1),(51952840,426213012,15581524,434787,1,'2007-09-15 13:49:04',3310502875,1),(51952842,426212865,15583729,434787,1,'2007-09-15 13:49:04',3310502875,1),(51952844,426213123,15584243,864892,1,'2009-03-28 14:44:22',3310502875,2),(51952849,426225483,15349535,206510,1,'2008-12-06 19:38:14',3310502782,4),(51956993,426313401,14846734,434787,1,'2007-09-15 13:55:14',3310503081,1),(51956997,426312311,14842100,434787,1,'2007-09-15 13:55:15',3310503081,1),(51956999,426311857,14838465,434787,1,'2007-09-15 13:55:15',3310503081,1),(51957002,426312584,14834286,434787,1,'2007-09-15 13:55:15',3310503081,1),(51957005,426314128,14829924,434787,1,'2007-09-15 13:55:15',3310503075,1),(51957008,426315673,14826108,434787,1,'2007-09-15 13:55:15',3310503075,1),(51957009,426316582,14822201,434787,1,'2007-09-15 13:55:15',3310503075,1),(51957013,426316582,14818657,434787,1,'2007-09-15 13:55:16',3310503075,1),(51957016,426315673,14813933,434787,1,'2007-09-15 13:55:16',3310503075,1),(51957018,426313947,14811207,864892,1,'2009-03-28 14:33:30',3310503075,3),(51957020,426312402,14805846,434787,1,'2007-09-15 13:55:16',3310503075,1),(51957022,426312311,14801212,434787,1,'2007-09-15 13:55:16',3310503075,1),(51957024,426312311,14793125,434787,1,'2007-09-15 13:55:16',3310503075,1),(51957025,426311938,14787679,434787,1,'2007-09-15 13:55:16',3310503075,1),(51957027,426311742,14784336,434787,1,'2007-09-15 13:55:16',3310503075,1),(51957030,426311545,14782173,434787,1,'2007-09-15 13:55:17',3310503075,1),(51957031,426310562,14780010,434787,1,'2007-09-15 13:55:17',3310503075,1),(51957034,426309284,14778535,434787,1,'2007-09-15 13:55:17',3310503075,1),(51957037,426306924,14778339,434787,1,'2007-09-15 13:55:17',3310503075,1),(51957040,426304171,14778830,434787,1,'2007-09-15 13:55:17',3310503075,1),(51957042,426302598,14779322,434787,1,'2007-09-15 13:55:17',3310503074,1),(51957045,426301123,14780895,434787,1,'2007-09-15 13:55:18',3310503074,1),(51957048,426299648,14784730,434787,1,'2007-09-15 13:55:18',3310503074,1),(51957050,426296895,14790236,434787,1,'2007-09-15 13:55:18',3310503074,1),(51957052,426295322,14792300,434787,1,'2007-09-15 13:55:18',3310503074,1),(51957055,426292667,14795053,434787,1,'2007-09-15 13:55:18',3310503074,1),(51957057,426290504,14797315,434787,1,'2007-09-15 13:55:18',3310503074,1),(51957060,426288931,14799576,434787,1,'2007-09-15 13:55:18',3310503074,1),(51957063,426287358,14802329,434787,1,'2007-09-15 13:55:18',3310503074,1),(51957064,426286965,14806360,434787,1,'2007-09-15 13:55:19',3310503074,1),(51957066,426287063,14808916,434787,1,'2007-09-15 13:55:19',3310503074,1),(51957069,426286571,14810391,434787,1,'2007-09-15 13:55:19',3310503074,1),(51957072,426285392,14810391,434787,1,'2007-09-15 13:55:19',3310503074,1),(51957075,426284197,14805596,434787,1,'2007-09-15 13:55:19',3310503074,1),(51957077,426283754,14802825,434787,1,'2007-09-15 13:55:19',3310503074,1),(51957080,426282978,14799944,434787,1,'2007-09-15 13:55:19',3310503074,1),(51957082,426282535,14797506,434787,1,'2007-09-15 13:55:20',3310503074,1),(51957085,426281316,14795733,434787,1,'2007-09-15 13:55:20',3310503074,1),(51957087,426279986,14794292,434787,1,'2007-09-15 13:55:20',3310503074,1),(51957090,426278434,14792408,434787,1,'2007-09-15 13:55:20',3310503074,1),(51957092,426277437,14789970,434787,1,'2007-09-15 13:55:20',3310503074,1),(51957094,426276772,14788861,434787,1,'2007-09-15 13:55:20',3310503074,1),(51957098,426275885,14787864,434787,1,'2007-09-15 13:55:20',3310502391,1),(51957101,426274666,14788640,434787,1,'2007-09-15 13:55:21',3310502391,1),(51957103,426274888,14792851,434787,1,'2007-09-15 13:55:21',3310502391,1),(51957105,426276107,14800498,434787,1,'2007-09-15 13:55:21',3310503074,1),(51957110,426275996,14802382,434787,1,'2007-09-15 13:55:21',3310502391,1),(51957112,426274445,14803158,434787,1,'2007-09-15 13:55:21',3310502391,1),(51957115,426273780,14802160,434787,1,'2007-09-15 13:55:21',3310502391,1),(51957117,426273115,14798060,434787,1,'2007-09-15 13:55:22',3310502391,1),(51957119,426271342,14794070,434787,1,'2007-09-15 13:55:22',3310502391,1),(51957121,426270123,14792740,434787,1,'2007-09-15 13:55:22',3310502391,1),(51957125,426268904,14791078,434787,1,'2007-09-15 13:55:22',3310502391,1),(51957128,426268571,14789416,434787,1,'2007-09-15 13:55:22',3310502391,1),(51957131,426268349,14786312,434787,1,'2007-09-15 13:55:22',3310502391,1),(51957134,426268904,14783542,434787,1,'2007-09-15 13:55:23',3310502391,1),(51957135,426268904,14782323,434787,1,'2007-09-15 13:55:23',3310502391,1),(51957138,426267684,14781436,434787,1,'2007-09-15 13:55:23',3310502391,1),(51957141,426266244,14781990,434787,1,'2007-09-15 13:55:23',3310502391,1),(51957143,426265357,14783209,434787,1,'2007-09-15 13:55:23',3310502391,1),(51957144,426265357,14787975,434787,1,'2007-09-15 13:55:23',3310502391,1),(51957146,426267130,14800055,434787,1,'2007-09-15 13:55:24',3310502391,1),(51957147,426267684,14802493,434787,1,'2007-09-15 13:55:24',3310502391,1),(51957151,426267574,14804488,434787,1,'2007-09-15 13:55:24',3310502391,1),(51957153,426266576,14804931,434787,1,'2007-09-15 13:55:24',3310502391,1),(51957155,426265357,14804377,434787,1,'2007-09-15 13:55:24',3310502391,1),(51957157,426264581,14802493,434787,1,'2007-09-15 13:55:24',3310502391,1),(51957160,426263141,14799611,434787,1,'2007-09-15 13:55:25',3310502391,1),(51957162,426261589,14797284,434787,1,'2007-09-15 13:55:25',3310502391,1),(51957164,426259262,14794846,434787,1,'2007-09-15 13:55:25',3310502391,1),(51957166,426255715,14793959,434787,1,'2007-09-15 13:55:25',3310502391,1),(51957168,426244744,14793405,434787,1,'2007-09-15 13:55:25',3310502390,1),(51957170,426240205,14793093,434787,1,'2007-09-15 13:55:25',3310502390,1),(51957172,426236087,14792740,434787,1,'2007-09-15 13:55:25',3310502390,1),(51957174,426230557,14791564,434787,1,'2007-09-15 13:55:25',3310502390,1),(51972980,425123655,15354572,434787,1,'2007-09-15 14:19:30',3310491454,1),(51972984,425125217,15354238,434787,1,'2007-09-15 14:19:30',3310491454,1),(51972990,425134816,15344759,434787,1,'2007-09-15 14:19:30',3310491454,1),(51972993,425134312,15348285,434787,1,'2007-09-15 14:19:30',3310491454,1),(51972999,425133682,15353890,434787,1,'2007-09-15 14:19:31',3310491454,1),(51973000,425133115,15357858,434787,1,'2007-09-15 14:19:31',3310491454,1),(51973004,425132171,15360692,434787,1,'2007-09-15 14:19:31',3310491454,1),(51973007,425130282,15365289,434787,1,'2007-09-15 14:19:31',3310491454,1),(51973010,425129148,15369193,434787,1,'2007-09-15 14:19:31',3310491454,1),(51973014,425128077,15374420,434787,1,'2007-09-15 14:19:31',3310491454,1),(51973017,425127133,15379836,434787,1,'2007-09-15 14:19:32',3310491454,1),(51973021,425126566,15384874,434787,1,'2007-09-15 14:19:32',3310491540,1),(51973026,425125936,15386701,434787,1,'2007-09-15 14:19:32',3310491540,1),(51973027,425124551,15388842,434787,1,'2007-09-15 14:19:32',3310491540,1),(51973030,425122913,15391928,434787,1,'2007-09-15 14:19:33',3310491540,1),(51973033,425122851,15393143,495907,1,'2008-07-15 17:35:47',3310491540,2),(51973038,425121762,15397763,434787,1,'2007-09-15 14:19:33',3310491537,1),(51973045,425121120,15400066,434787,1,'2007-09-15 14:19:33',3310491537,1),(51973049,425119384,15403766,434787,1,'2007-09-15 14:19:34',3310491537,1),(51973052,425118364,15405654,434787,1,'2007-09-15 14:19:34',3310491537,1),(51973055,425118175,15406296,434787,1,'2007-09-15 14:19:34',3310491537,1),(51973058,425117498,15408946,434787,1,'2007-09-15 14:19:34',3310491537,1),(51973061,425116997,15410749,434787,1,'2007-09-15 14:19:34',3310491537,1),(51973066,425116863,15412720,434787,1,'2007-09-15 14:19:35',3310491537,1),(51973069,425116663,15414591,434787,1,'2007-09-15 14:19:35',3310491537,1),(51973073,425115994,15415726,434787,1,'2007-09-15 14:19:35',3310491537,1),(51973078,425114792,15417230,434787,1,'2007-09-15 14:19:35',3310491537,1),(51973082,425113523,15418098,434787,1,'2007-09-15 14:19:35',3310491537,1),(51973084,425111084,15418332,434787,1,'2007-09-15 14:19:36',3310491537,1),(51973088,425108746,15418332,434787,1,'2007-09-15 14:19:36',3310491537,1),(51973091,425102934,15418465,434787,1,'2007-09-15 14:19:36',3310491537,1),(51973096,425100815,15418808,434787,1,'2007-09-15 14:19:36',3310491537,1),(51973099,425096382,15420508,434787,1,'2007-09-15 14:19:37',3310491537,1),(51973102,425172985,15674698,434787,1,'2007-09-15 14:19:37',3310491575,1),(51973105,425172136,15668758,434787,1,'2007-09-15 14:19:37',3310491575,1),(51973108,425170121,15661758,434787,1,'2007-09-15 14:19:38',3310491575,1),(51973112,425169909,15659318,434787,1,'2007-09-15 14:19:38',3310491575,1),(51973113,425170333,15658046,434787,1,'2007-09-15 14:19:38',3310491575,1),(51973117,425171076,15658046,434787,1,'2007-09-15 14:19:38',3310491575,1),(51973120,425172242,15658576,434787,1,'2007-09-15 14:19:38',3310491575,1),(51973122,425173833,15661121,434787,1,'2007-09-15 14:19:38',3310491575,1),(51973125,425182557,15679190,5671401,1,'2010-09-03 18:06:01',3310491618,2),(51973128,425189743,15692411,434787,1,'2007-09-15 14:19:39',3310491618,1),(51973131,425196637,15702381,434787,1,'2007-09-15 14:19:39',3310491618,1),(51973135,425206714,15711714,434787,1,'2007-09-15 14:19:39',3310491625,1),(51973138,425218911,15720730,434787,1,'2007-09-15 14:19:39',3310491625,1),(51973141,425223260,15723594,434787,1,'2007-09-15 14:19:39',3310491625,1),(51973144,425224108,15725715,434787,1,'2007-09-15 14:19:40',3310491625,1),(51973147,425224214,15728367,434787,1,'2007-09-15 14:19:40',3310491625,1),(51973150,425227714,15737382,434787,1,'2007-09-15 14:19:40',3310491625,1),(51973154,425231108,15744807,434787,1,'2007-09-15 14:19:41',3310491625,1),(51973156,425237048,15752125,434787,1,'2007-09-15 14:19:41',3310491628,1),(51973158,425240973,15755307,434787,1,'2007-09-15 14:19:41',3310491628,1),(51973161,425244791,15757853,434787,1,'2007-09-15 14:19:41',3310491628,1),(51973163,425245003,15760080,434787,1,'2007-09-15 14:19:42',3310491628,1),(51973166,425244048,15762095,434787,1,'2007-09-15 14:19:42',3310491628,1),(51973170,425244367,15766338,434787,1,'2007-09-15 14:19:42',3310491630,1),(51973172,425245003,15770899,434787,1,'2007-09-15 14:19:43',3310491630,1),(51973175,425246700,15773338,434787,1,'2007-09-15 14:19:43',3310491630,1),(51973177,425246700,15774611,434787,1,'2007-09-15 14:19:43',3310491630,1),(51973179,425246700,15778111,434787,1,'2007-09-15 14:19:43',3310491630,1),(51973183,425247655,15782990,434787,1,'2007-09-15 14:19:43',3310491630,1),(51973186,425248415,15785554,434787,1,'2007-09-15 14:19:44',3310491630,1),(51973190,425248495,15787626,434787,1,'2007-09-15 14:19:44',3310491630,1),(51973193,425248495,15788822,434787,1,'2007-09-15 14:19:44',3310491630,1),(51973196,425249052,15790575,434787,1,'2007-09-15 14:19:44',3310491630,1),(51973198,425250647,15793524,434787,1,'2007-09-15 14:19:45',3310491630,1),(51973201,425254074,15798466,434787,1,'2007-09-15 14:19:45',3310491630,1),(51973203,425254711,15799900,434787,1,'2007-09-15 14:19:45',3310491630,1),(51973206,425254472,15801973,434787,1,'2007-09-15 14:19:45',3310491630,1),(51973208,425253595,15803886,434787,1,'2007-09-15 14:19:45',3310491630,1),(51973210,425252798,15806277,434787,1,'2007-09-15 14:19:45',3310491630,1),(51973213,425251922,15807871,434787,1,'2007-09-15 14:19:45',3310491630,1),(51973215,425252081,15809305,434787,1,'2007-09-15 14:19:46',3310491630,1),(51973219,425252639,15810341,434787,1,'2007-09-15 14:19:46',3310491630,1),(51973221,425254313,15811776,434787,1,'2007-09-15 14:19:46',3310491630,1),(51973223,425257581,15812892,434787,1,'2007-09-15 14:19:46',3310491630,1),(51973225,425259254,15813211,434787,1,'2007-09-15 14:19:47',3310491630,1),(51973228,425260290,15814725,434787,1,'2007-09-15 14:19:47',3310491631,1),(51973234,425260609,15817355,434787,1,'2007-09-15 14:19:47',3310491631,1),(51973237,425261167,15819746,434787,1,'2007-09-15 14:19:47',3310491631,1),(51973241,425262841,15822616,434787,1,'2007-09-15 14:19:48',3310492997,1),(51973243,425264515,15826601,434787,1,'2007-09-15 14:19:48',3310492997,1),(51973247,425265391,15827876,434787,1,'2007-09-15 14:19:48',3310492997,1),(51973249,425267145,15829071,434787,1,'2007-09-15 14:19:48',3310492997,1);
INSERT INTO `current_nodes` VALUES (51973253,425269456,15830108,434787,1,'2007-09-15 14:19:49',3310492997,1),(51973256,425270811,15830745,434787,1,'2007-09-15 14:19:49',3310492997,1),(51973260,425272565,15832499,434787,1,'2007-09-15 14:19:49',3310492997,1),(51973264,425275035,15836404,434787,1,'2007-09-15 14:19:49',3310492997,1),(51973268,425278781,15843498,434787,1,'2007-09-15 14:19:50',3310492997,1),(51973269,425280854,15847961,434787,1,'2007-09-15 14:19:50',3310492997,1),(51973273,425282607,15853142,434787,1,'2007-09-15 14:19:50',3310492997,1),(51973276,425284440,15855931,434787,1,'2007-09-15 14:19:50',3310492997,1),(51973278,425285158,15857525,434787,1,'2007-09-15 14:19:50',3310492997,1),(51973281,425285795,15862068,434787,1,'2007-09-15 14:19:50',3310492997,1),(51973284,425287150,15868046,434787,1,'2007-09-15 14:19:51',3310492997,1),(51973287,425287947,15870676,434787,1,'2007-09-15 14:19:51',3310493008,1),(51973290,425288251,15872645,434787,1,'2007-09-15 14:19:51',3310493008,1),(51973293,425288342,15875745,434787,1,'2007-09-15 14:19:51',3310493010,1),(51973296,425287658,15878844,434787,1,'2007-09-15 14:19:52',3310493010,1),(51973300,425286701,15882627,434787,1,'2007-09-15 14:19:52',3310492999,1),(51973302,425285789,15884815,434787,1,'2007-09-15 14:19:52',3310492999,1),(51973306,425284696,15886592,434787,1,'2007-09-15 14:19:52',3310492999,1),(51973310,425284058,15889373,434787,1,'2007-09-15 14:19:52',3310492999,1),(51973313,425283738,15891925,434787,1,'2007-09-15 14:19:53',3310492999,1),(51973316,425283602,15892791,434787,1,'2007-09-15 14:19:53',3310492999,1),(51973320,425283602,15893566,434787,1,'2007-09-15 14:19:53',3310492999,1),(51973324,425283738,15894249,434787,1,'2007-09-15 14:19:53',3310492999,1),(51973326,425284103,15894705,434787,1,'2007-09-15 14:19:53',3310492999,1),(51973327,425285862,15897161,434787,1,'2007-09-15 14:19:53',3310492999,1),(51973329,425286986,15898231,434787,1,'2007-09-15 14:19:53',3310492999,1),(51973334,425287949,15899515,434787,1,'2007-09-15 14:19:54',3310493010,1),(51973336,425287949,15900639,434787,1,'2007-09-15 14:19:54',3310493010,1),(51973339,425287628,15901495,434787,1,'2007-09-15 14:19:54',3310493010,1),(51973341,425286986,15904332,434787,1,'2007-09-15 14:19:54',3310492999,1),(51973344,425286665,15906205,434787,1,'2007-09-15 14:19:54',3310492999,1),(51973346,425286611,15907971,434787,1,'2007-09-15 14:19:54',3310492999,1),(51973348,425286183,15911289,434787,1,'2007-09-15 14:19:55',3310492999,1),(51973351,425285916,15913322,434787,1,'2007-09-15 14:19:55',3310492999,1),(51973352,425286504,15915088,434787,1,'2007-09-15 14:19:55',3310492999,1),(51973353,425287468,15916908,434787,1,'2007-09-15 14:19:55',3310493010,1),(51973354,425288163,15919584,434787,1,'2007-09-15 14:19:55',3310493010,1),(51973356,425288913,15921617,434787,1,'2007-09-15 14:19:56',3310493010,1),(51973357,425289287,15923276,434787,1,'2007-09-15 14:19:56',3310493010,1),(51973359,425289287,15924079,434787,1,'2007-09-15 14:19:56',3310493010,1),(51973361,425288805,15924935,434787,1,'2007-09-15 14:19:56',3310493010,1),(51973362,425288110,15925577,434787,1,'2007-09-15 14:19:56',3310493010,1),(51973363,425286986,15926434,434787,1,'2007-09-15 14:19:56',3310492999,1),(51973364,425285755,15926701,434787,1,'2007-09-15 14:19:56',3310492999,1),(51973366,425284899,15926701,434787,1,'2007-09-15 14:19:56',3310492999,1),(51973369,425284310,15926648,434787,1,'2007-09-15 14:19:57',3310492999,1),(51973370,425283347,15927236,434787,1,'2007-09-15 14:19:57',3310492999,1),(51973373,425281848,15928681,434787,1,'2007-09-15 14:19:57',3310492999,1),(51973375,425280082,15929805,434787,1,'2007-09-15 14:19:57',3310492999,1),(51973378,425278691,15930554,434787,1,'2007-09-15 14:19:57',3310493005,1),(51973380,425277618,15931249,434787,1,'2007-09-15 14:19:58',3310493005,1),(51973384,425276528,15932813,434787,1,'2007-09-15 14:19:58',3310493005,1),(51973387,425275770,15934045,434787,1,'2007-09-15 14:19:58',3310493005,1),(51973390,425274680,15934945,434787,1,'2007-09-15 14:19:58',3310493005,1),(51973394,425272690,15935893,434787,1,'2007-09-15 14:19:59',3310493005,1),(51973396,425271790,15936461,434787,1,'2007-09-15 14:19:59',3310493005,1),(51973398,425271127,15937693,434787,1,'2007-09-15 14:19:59',3310493005,1),(51973400,425271079,15939399,434787,1,'2007-09-15 14:20:00',3310493005,1),(51973403,425271695,15940773,434787,1,'2007-09-15 14:20:00',3310493005,1),(51973405,425272927,15942479,434787,1,'2007-09-15 14:20:00',3310493005,1),(51973407,425273875,15943332,434787,1,'2007-09-15 14:20:00',3310493005,1),(51973409,425274207,15944706,434787,1,'2007-09-15 14:20:00',3310493005,1),(51973413,425274017,15947549,434787,1,'2007-09-15 14:20:00',3310493005,1),(51973416,425273922,15950013,434787,1,'2007-09-15 14:20:01',3310493005,1),(51973417,425273638,15951576,434787,1,'2007-09-15 14:20:01',3310493005,1),(51973419,425273259,15953567,434787,1,'2007-09-15 14:20:01',3310493005,1),(51973424,425272975,15955035,434787,1,'2007-09-15 14:20:01',3310493005,1),(51973426,425272674,15957022,434787,1,'2007-09-15 14:20:01',3310493005,1),(51973428,425273157,15958905,434787,1,'2007-09-15 14:20:01',3310493005,1),(51973430,425274268,15959871,434787,1,'2007-09-15 14:20:02',3310493005,1),(51973432,425275668,15959630,434787,1,'2007-09-15 14:20:02',3310493005,1),(51973436,425276972,15958422,434787,1,'2007-09-15 14:20:02',3310493005,1),(51973439,425279387,15957650,434787,1,'2007-09-15 14:20:02',3310493005,1),(51973441,425280787,15957312,434787,1,'2007-09-15 14:20:02',3310493005,1),(51973444,425282864,15956008,434787,1,'2007-09-15 14:20:02',3310493005,1),(51973448,425284892,15953835,434787,1,'2007-09-15 14:20:02',3310493005,1),(51973451,425286921,15951372,434787,1,'2007-09-15 14:20:03',3310493005,1),(51973454,425288128,15950261,434787,1,'2007-09-15 14:20:03',3310493016,1),(51973456,425289480,15950068,434787,1,'2007-09-15 14:20:03',3310493016,1),(51973459,425291750,15950792,434787,1,'2007-09-15 14:20:03',3310493016,1),(51973462,425292861,15951854,434787,1,'2007-09-15 14:20:03',3310493016,1),(51973467,425294213,15954462,434787,1,'2007-09-15 14:20:03',3310493016,1),(51973470,425295614,15958326,434787,1,'2007-09-15 14:20:03',3310493016,1),(51973471,425296000,15961079,434787,1,'2007-09-15 14:20:03',3310493016,1),(51973475,425297062,15963590,434787,1,'2007-09-15 14:20:04',3310493016,1),(51973478,425299546,15966920,434787,1,'2007-09-15 14:20:04',3310493016,1),(51973481,425301843,15969430,434787,1,'2007-09-15 14:20:04',3310493016,1),(51973484,425303605,15971727,434787,1,'2007-09-15 14:20:04',3310493016,1),(51973487,425303659,15974664,434787,1,'2007-09-15 14:20:04',3310493016,1),(51973489,425302590,15979258,434787,1,'2007-09-15 14:20:05',3310493016,1),(51973491,425301576,15983584,434787,1,'2007-09-15 14:20:05',3310493016,1),(51973494,425301309,15988337,434787,1,'2007-09-15 14:20:05',3310493018,1),(51973497,425301736,15993785,434787,1,'2007-09-15 14:20:05',3310493018,1),(51973499,425302911,15999072,434787,1,'2007-09-15 14:20:05',3310493018,1),(51973501,425303754,16001564,1882243,1,'2009-07-20 12:44:02',3310493018,2),(51973504,425305368,16002769,434787,1,'2007-09-15 14:20:06',3310493018,1),(51973507,425308242,16003952,434787,1,'2007-09-15 14:20:06',3310493018,1),(51973511,425311750,16005165,434787,1,'2007-09-15 14:20:06',3310493018,1),(51973514,425330006,15871191,434787,1,'2007-09-15 14:20:06',3310493009,1),(51973516,425335160,15876009,434787,1,'2007-09-15 14:20:07',3310493011,1),(51973519,425340650,15880378,434787,1,'2007-09-15 14:20:07',3310493011,1),(51973521,425342779,15881162,434787,1,'2007-09-15 14:20:07',3310493014,1),(51973523,425345131,15880938,434787,1,'2007-09-15 14:20:07',3310493014,1),(51973526,425347269,15881092,434787,1,'2007-09-15 14:20:07',3310493014,1),(51973528,425348130,15881150,434787,1,'2007-09-15 14:20:08',3310493014,1),(51973529,425348818,15882354,434787,1,'2007-09-15 14:20:08',3310493014,1),(51973532,425349851,15883387,434787,1,'2007-09-15 14:20:08',3310493014,1),(51973534,425351055,15883387,434787,1,'2007-09-15 14:20:09',3310493014,1),(51973538,425352775,15881569,434787,1,'2007-09-15 14:20:09',3310493014,1),(51973541,425328132,15869606,434787,1,'2007-09-15 14:20:09',3310493009,1),(51973544,425327290,15869044,434787,1,'2007-09-15 14:20:09',3310493009,1),(51973546,425325700,15868577,434787,1,'2007-09-15 14:20:09',3310493009,1),(51973548,425323969,15868062,434787,1,'2007-09-15 14:20:09',3310493009,1),(51973550,425322566,15867782,434787,1,'2007-09-15 14:20:10',3310493009,1),(51973554,425321630,15867220,434787,1,'2007-09-15 14:20:10',3310493009,1),(51973557,425320788,15865583,434787,1,'2007-09-15 14:20:10',3310493009,1),(51973559,425319853,15865022,434787,1,'2007-09-15 14:20:10',3310493009,1),(51973561,425318684,15864648,434787,1,'2007-09-15 14:20:10',3310493009,1),(51973562,425317888,15865302,434787,1,'2007-09-15 14:20:10',3310493009,1),(51973564,425317608,15865817,434787,1,'2007-09-15 14:20:10',3310493009,1),(51973567,425317655,15866940,434787,1,'2007-09-15 14:20:11',3310493009,1),(51973570,425318263,15868062,434787,1,'2007-09-15 14:20:11',3310493009,1),(51973571,425320461,15869840,434787,1,'2007-09-15 14:20:11',3310493009,1),(51973575,425322285,15871570,434787,1,'2007-09-15 14:20:11',3310493009,1),(51973577,425323174,15873254,434787,1,'2007-09-15 14:20:11',3310493009,1),(51973579,425323501,15875078,434787,1,'2007-09-15 14:20:11',3310493009,1),(51973582,425323267,15878773,434787,1,'2007-09-15 14:20:11',3310493011,1),(51973587,425322893,15882702,434787,1,'2007-09-15 14:20:12',3310493011,1),(51973590,425323127,15884901,434787,1,'2007-09-15 14:20:12',3310493011,1),(51973591,425323875,15886818,434787,1,'2007-09-15 14:20:12',3310493011,1),(51973594,425325793,15889297,434787,1,'2007-09-15 14:20:12',3310493011,1),(51973596,425327056,15893180,434787,1,'2007-09-15 14:20:12',3310493011,1),(51973598,425327009,15898371,434787,1,'2007-09-15 14:20:13',3310493011,1),(51973599,425326775,15902862,434787,1,'2007-09-15 14:20:13',3310493011,1),(51973602,425326214,15905247,434787,1,'2007-09-15 14:20:13',3310493011,1),(51973604,425325045,15908054,434787,1,'2007-09-15 14:20:13',3310493011,1),(51973606,425323127,15911281,434787,1,'2007-09-15 14:20:13',3310493011,1),(51973608,425320367,15916333,434787,1,'2007-09-15 14:20:13',3310493011,1),(51973611,425318309,15919513,434787,1,'2007-09-15 14:20:14',3310493011,1),(51973614,425317795,15921805,434787,1,'2007-09-15 14:20:14',3310493011,1),(51973617,425318356,15925126,434787,1,'2007-09-15 14:20:14',3310493011,1),(51973619,425319385,15927231,434787,1,'2007-09-15 14:20:14',3310493011,1),(51973621,425320508,15927886,434787,1,'2007-09-15 14:20:14',3310493011,1),(51973622,425322051,15927839,434787,1,'2007-09-15 14:20:14',3310493011,1),(51973624,425323221,15927278,434787,1,'2007-09-15 14:20:14',3310493011,1),(51973627,425325466,15926389,434787,1,'2007-09-15 14:20:14',3310493011,1),(51973631,425328616,15925170,434787,1,'2007-09-15 14:20:14',3310493011,1),(51973633,425330139,15925215,434787,1,'2007-09-15 14:20:15',3310493011,1),(51973636,425331950,15925525,434787,1,'2007-09-15 14:20:15',3310493011,1),(51973639,425333812,15925474,434787,1,'2007-09-15 14:20:15',3310493011,1),(51973643,425335674,15924853,434787,1,'2007-09-15 14:20:15',3310493011,1),(51973646,425337278,15923870,434787,1,'2007-09-15 14:20:15',3310493011,1),(51973648,425338726,15922939,434787,1,'2007-09-15 14:20:16',3310493011,1),(51973651,425340226,15922473,434787,1,'2007-09-15 14:20:16',3310493011,1),(51973653,425341778,15922939,434787,1,'2007-09-15 14:20:16',3310493011,1),(51973657,425342864,15924129,434787,1,'2007-09-15 14:20:16',3310493014,1),(51973660,425344313,15926922,434787,1,'2007-09-15 14:20:16',3310493014,1),(51973663,425345864,15928784,434787,1,'2007-09-15 14:20:16',3310493014,1),(51973667,425348089,15930543,434787,1,'2007-09-15 14:20:17',3310493020,1),(51973669,425349434,15931940,434787,1,'2007-09-15 14:20:17',3310493020,1),(51973673,425350934,15933440,434787,1,'2007-09-15 14:20:17',3310493020,1),(51973676,425351554,15934785,434787,1,'2007-09-15 14:20:17',3310493020,1),(51973679,425351192,15935923,434787,1,'2007-09-15 14:20:17',3310493020,1),(51973681,425350365,15936233,434787,1,'2007-09-15 14:20:18',3310493020,1),(51973683,425349175,15935923,434787,1,'2007-09-15 14:20:18',3310493020,1),(51973686,425347675,15935198,434787,1,'2007-09-15 14:20:18',3310493020,1),(51973688,425346899,15934629,434787,1,'2007-09-15 14:20:18',3310493020,1),(51973691,425345451,15933285,434787,1,'2007-09-15 14:20:18',3310493020,1),(51973694,425343123,15932095,434787,1,'2007-09-15 14:20:19',3310493020,1),(51973696,425341416,15930853,434787,1,'2007-09-15 14:20:19',3310493017,1),(51973699,425340381,15930595,434787,1,'2007-09-15 14:20:19',3310493017,1),(51973703,425339709,15930646,434787,1,'2007-09-15 14:20:19',3310493017,1),(51973705,425339347,15931681,434787,1,'2007-09-15 14:20:19',3310493017,1),(51973708,425339347,15932612,434787,1,'2007-09-15 14:20:19',3310493017,1),(51973711,425340278,15933595,434787,1,'2007-09-15 14:20:19',3310493017,1),(51973714,425341519,15933957,434787,1,'2007-09-15 14:20:20',3310493017,1),(51973717,425342450,15934733,434787,1,'2007-09-15 14:20:20',3310493020,1),(51973720,425342709,15936078,434787,1,'2007-09-15 14:20:20',3310493020,1),(51973722,425342864,15937630,434787,1,'2007-09-15 14:20:20',3310493020,1),(51973725,425343226,15939906,434787,1,'2007-09-15 14:20:20',3310493020,1),(51973728,425343899,15941147,434787,1,'2007-09-15 14:20:20',3310493020,1),(51973730,425345244,15942647,434787,1,'2007-09-15 14:20:20',3310493020,1),(51973731,425345606,15944406,434787,1,'2007-09-15 14:20:21',3310493020,1),(51973733,425346227,15946837,434787,1,'2007-09-15 14:20:21',3310493020,1),(51973736,425346692,15948130,434787,1,'2007-09-15 14:20:21',3310493020,1),(51973739,425347623,15949372,434787,1,'2007-09-15 14:20:21',3310493020,1),(51973741,425349382,15950510,434787,1,'2007-09-15 14:20:21',3310493020,1),(51973744,425351299,15951569,434787,1,'2007-09-15 14:20:21',3310493020,1),(51973747,425353320,15952816,434787,1,'2007-09-15 14:20:22',3310493020,1),(51973749,425353965,15953976,434787,1,'2007-09-15 14:20:22',3310493020,1),(51973751,425353922,15954793,434787,1,'2007-09-15 14:20:22',3310493020,1),(51973753,425353363,15955911,434787,1,'2007-09-15 14:20:22',3310493020,1),(51973755,425352589,15956083,434787,1,'2007-09-15 14:20:22',3310493020,1),(51973757,425351342,15955825,434787,1,'2007-09-15 14:20:22',3310493020,1),(51973759,425349967,15955524,434787,1,'2007-09-15 14:20:22',3310493020,1),(51973764,425348806,15955524,434787,1,'2007-09-15 14:20:23',3310493020,1),(51973766,425347817,15955524,434787,1,'2007-09-15 14:20:23',3310493020,1),(51973769,425346829,15955438,434787,1,'2007-09-15 14:20:23',3310493020,1),(51973770,425345668,15955051,434787,1,'2007-09-15 14:20:23',3310493020,1),(51973771,425344851,15954363,434787,1,'2007-09-15 14:20:23',3310493020,1),(51973777,425343820,15952988,434787,1,'2007-09-15 14:20:24',3310493020,1),(51973782,425343261,15951354,434787,1,'2007-09-15 14:20:24',3310493020,1),(51973784,425342100,15949850,434787,1,'2007-09-15 14:20:24',3310493017,1),(51973786,425341111,15949033,434787,1,'2007-09-15 14:20:24',3310493017,1),(51973790,425339908,15949033,434787,1,'2007-09-15 14:20:25',3310493017,1),(51973792,425339263,15949420,434787,1,'2007-09-15 14:20:25',3310493017,1),(51973796,425338403,15950365,434787,1,'2007-09-15 14:20:25',3310493017,1),(51973799,425336984,15952257,434787,1,'2007-09-15 14:20:25',3310493017,1),(51973802,425335480,15954320,434787,1,'2007-09-15 14:20:25',3310493017,1),(51973803,425333416,15956857,434787,1,'2007-09-15 14:20:25',3310493017,1),(51973807,425331783,15958361,434787,1,'2007-09-15 14:20:25',3310493017,1),(51973809,425330364,15959780,434787,1,'2007-09-15 14:20:26',3310493017,1),(51973812,425328774,15960554,434787,1,'2007-09-15 14:20:26',3310493017,1),(51973815,425327312,15962058,434787,1,'2007-09-15 14:20:26',3310493017,1),(51973817,425327183,15963348,434787,1,'2007-09-15 14:20:26',3310493017,1),(51973818,425327699,15963864,434787,1,'2007-09-15 14:20:26',3310493017,1),(51973820,425328215,15963907,434787,1,'2007-09-15 14:20:27',3310493017,1),(51973831,425329075,15963348,434787,1,'2007-09-15 14:20:27',3310493017,1),(51973834,425329934,15962617,434787,1,'2007-09-15 14:20:28',3310493017,1),(51973836,425332471,15961456,434787,1,'2007-09-15 14:20:28',3310493017,1),(51973839,425335136,15960726,434787,1,'2007-09-15 14:20:28',3310493017,1),(51973842,425337285,15960683,434787,1,'2007-09-15 14:20:28',3310493017,1),(51973844,425339177,15960339,434787,1,'2007-09-15 14:20:29',3310493017,1),(51973846,425340037,15960339,434787,1,'2007-09-15 14:20:29',3310493017,1),(51973848,425340595,15960897,434787,1,'2007-09-15 14:20:29',3310493017,1),(51973849,425340595,15961413,434787,1,'2007-09-15 14:20:29',3310493017,1),(51973851,425340166,15962488,434787,1,'2007-09-15 14:20:29',3310493017,1),(51973852,425338790,15963434,434787,1,'2007-09-15 14:20:30',3310493017,1),(51973855,425335738,15965411,434787,1,'2007-09-15 14:20:30',3310493017,1),(51973858,425333674,15966486,434787,1,'2007-09-15 14:20:30',3310493017,1),(51973860,425331977,15968116,434787,1,'2007-09-15 14:20:30',3310493017,1),(51973862,425330897,15969454,434787,1,'2007-09-15 14:20:30',3310493017,1),(51973865,425329714,15970483,434787,1,'2007-09-15 14:20:30',3310493017,1),(51973868,425328531,15971306,434787,1,'2007-09-15 14:20:30',3310493017,1),(51973871,425327399,15971460,434787,1,'2007-09-15 14:20:31',3310493017,1),(51973874,425325753,15971100,434787,1,'2007-09-15 14:20:31',3310493017,1),(51973877,425324569,15971100,434787,1,'2007-09-15 14:20:31',3310493017,1),(51973878,425323849,15971100,434787,1,'2007-09-15 14:20:31',3310493017,1),(51973881,425322769,15971512,434787,1,'2007-09-15 14:20:31',3310493017,1),(51973883,425322255,15972540,434787,1,'2007-09-15 14:20:31',3310493017,1),(51973884,425319991,15974547,434787,1,'2007-09-15 14:20:32',3310493017,1),(51973887,425317882,15977170,434787,1,'2007-09-15 14:20:32',3310493017,1),(51973890,425316801,15978662,434787,1,'2007-09-15 14:20:32',3310493017,1),(51973891,425315978,15981183,434787,1,'2007-09-15 14:20:32',3310493017,1),(51973894,425314898,15986379,434787,1,'2007-09-15 14:20:32',3310493019,1),(51973897,425313252,15996050,434787,1,'2007-09-15 14:20:32',3310493018,1),(51973898,425312840,16003355,434787,1,'2007-09-15 14:20:32',3310493018,1),(51973901,425310101,16004909,434787,1,'2007-09-15 14:20:32',3310493018,1),(51973903,425312684,16004829,434787,1,'2007-09-15 14:20:32',3310493018,1),(51973905,425313146,16005443,434787,1,'2007-09-15 14:20:33',3310493018,1),(51973907,425313715,16005991,434787,1,'2007-09-15 14:20:33',3310493018,1),(51973910,425314432,16006328,434787,1,'2007-09-15 14:20:33',3310493018,1),(51973913,425315169,16006371,434787,1,'2007-09-15 14:20:33',3310493019,1),(51973915,425315822,16006118,434787,1,'2007-09-15 14:20:33',3310493019,1),(51973917,425316433,16005359,434787,1,'2007-09-15 14:20:33',3310493019,1),(51973920,425316855,16004348,434787,1,'2007-09-15 14:20:33',3310493019,1),(51973922,425317465,16002883,434787,1,'2007-09-15 14:20:34',3310493019,1),(51973924,425317978,16001806,434787,1,'2007-09-15 14:20:34',3310493019,1),(51973927,425318799,16000472,434787,1,'2007-09-15 14:20:34',3310493019,1),(51973929,425320030,15998779,434787,1,'2007-09-15 14:20:34',3310493019,1),(51973931,425321664,15996067,434787,1,'2007-09-15 14:20:34',3310493019,1),(51973934,425323293,15993703,434787,1,'2007-09-15 14:20:35',3310493019,1),(51973937,425324317,15992154,434787,1,'2007-09-15 14:20:35',3310493019,1),(51973939,425325237,15990683,434787,1,'2007-09-15 14:20:35',3310493019,1),(51973941,425325893,15989501,434787,1,'2007-09-15 14:20:35',3310493019,1),(51973942,425326550,15988056,434787,1,'2007-09-15 14:20:35',3310493019,1),(51973947,425327128,15986375,434787,1,'2007-09-15 14:20:35',3310493019,1),(51973950,425327811,15984563,434787,1,'2007-09-15 14:20:35',3310493017,1),(51973952,425328336,15983591,434787,1,'2007-09-15 14:20:35',3310493017,1),(51973953,425328756,15983065,434787,1,'2007-09-15 14:20:35',3310493017,1),(51973955,425329255,15982855,434787,1,'2007-09-15 14:20:36',3310493017,1),(51973958,425329912,15982776,434787,1,'2007-09-15 14:20:36',3310493017,1),(51973962,425330464,15983197,434787,1,'2007-09-15 14:20:36',3310493017,1),(51973963,425330674,15983591,434787,1,'2007-09-15 14:20:36',3310493017,1),(51973967,425330569,15984274,434787,1,'2007-09-15 14:20:36',3310493017,1),(51973968,425330227,15985298,434787,1,'2007-09-15 14:20:37',3310493017,1),(51973972,425329623,15986060,434787,1,'2007-09-15 14:20:37',3310493019,1),(51973975,425329098,15986848,434787,1,'2007-09-15 14:20:37',3310493019,1),(51973977,425328730,15987531,434787,1,'2007-09-15 14:20:37',3310493019,1),(51973981,425328179,15988949,434787,1,'2007-09-15 14:20:37',3310493019,1),(51973983,425327443,15992548,434787,1,'2007-09-15 14:20:37',3310493019,1),(51973986,425326998,15994611,434787,1,'2007-09-15 14:20:37',3310493019,1),(51973989,425326213,15998271,434787,1,'2007-09-15 14:20:38',3310493019,1),(51973992,425325625,16002389,434787,1,'2007-09-15 14:20:38',3310493019,1),(51973995,425325205,16006217,434787,1,'2007-09-15 14:20:38',3310493019,1),(51973998,425324849,16008127,434787,1,'2007-09-15 14:20:38',3310493019,1),(51974002,425324851,16012092,434787,1,'2007-09-15 14:20:38',3310493019,1),(51974005,425324697,16016774,434787,1,'2007-09-15 14:20:39',3310493019,1),(51974008,425324467,16021762,434787,1,'2007-09-15 14:20:39',3310493019,1),(51974011,425324390,16026136,434787,1,'2007-09-15 14:20:39',3310493019,1),(51974013,425324007,16033657,434787,1,'2007-09-15 14:20:39',3310493019,1),(51974015,425323393,16040180,434787,1,'2007-09-15 14:20:39',3310493019,1),(51974019,425321781,16047700,434787,1,'2007-09-15 14:20:40',3310493041,1),(51974023,425320476,16052689,434787,1,'2007-09-15 14:20:40',3310493041,1),(51974024,425319556,16056219,434787,1,'2007-09-15 14:20:40',3310493041,1),(51974028,425318711,16058598,434787,1,'2007-09-15 14:20:40',3310493041,1),(51974031,425317100,16061821,434787,1,'2007-09-15 14:20:40',3310493041,1),(51974035,425315181,16065044,434787,1,'2007-09-15 14:20:40',3310493041,1),(51974039,425313186,16068114,434787,1,'2007-09-15 14:20:41',3310493040,1),(51974040,425311805,16069725,434787,1,'2007-09-15 14:20:41',3310493040,1),(51974042,425310347,16070953,434787,1,'2007-09-15 14:20:41',3310493040,1),(51974044,425305972,16073255,434787,1,'2007-09-15 14:20:41',3310493040,1),(51974046,425301752,16075558,434787,1,'2007-09-15 14:20:41',3310493040,1),(51974049,425300140,16076632,434787,1,'2007-09-15 14:20:41',3310493040,1),(51974050,425299603,16077399,434787,1,'2007-09-15 14:20:41',3310493040,1),(51974053,425299833,16078397,434787,1,'2007-09-15 14:20:42',3310493040,1),(51974055,425300447,16079088,434787,1,'2007-09-15 14:20:42',3310493040,1),(51974057,425301521,16078934,434787,1,'2007-09-15 14:20:42',3310493040,1),(51974059,425302826,16078320,434787,1,'2007-09-15 14:20:42',3310493040,1),(51974060,425305896,16078244,434787,1,'2007-09-15 14:20:42',3310493040,1),(51974065,425309047,16078913,434787,1,'2007-09-15 14:20:42',3310493040,1),(51974068,425311216,16079542,434787,1,'2007-09-15 14:20:42',3310493040,1),(51974072,425312159,16079730,434787,1,'2007-09-15 14:20:43',3310493040,1),(51974074,425313416,16079793,434787,1,'2007-09-15 14:20:43',3310493040,1),(51974078,425314453,16079322,434787,1,'2007-09-15 14:20:43',3310493040,1),(51974083,425315459,16078882,434787,1,'2007-09-15 14:20:43',3310493041,1),(51974085,425316245,16079164,434787,1,'2007-09-15 14:20:43',3310493041,1),(51974086,425316339,16079793,434787,1,'2007-09-15 14:20:44',3310493041,1),(51974088,425316119,16080516,434787,1,'2007-09-15 14:20:44',3310493041,1),(51974089,425315522,16081176,434787,1,'2007-09-15 14:20:44',3310493041,1),(51974090,425314391,16081836,434787,1,'2007-09-15 14:20:44',3310493040,1),(51974095,425312662,16082936,434787,1,'2007-09-15 14:20:44',3310493040,1),(51974097,425311153,16083156,434787,1,'2007-09-15 14:20:44',3310493040,1),(51974100,425309456,16083156,434787,1,'2007-09-15 14:20:44',3310493040,1),(51974103,425308544,16083628,434787,1,'2007-09-15 14:20:45',3310493040,1),(51974107,425308167,16084382,434787,1,'2007-09-15 14:20:45',3310493040,1),(51974108,425308167,16085263,434787,1,'2007-09-15 14:20:45',3310493040,1),(51974112,425308638,16085828,434787,1,'2007-09-15 14:20:45',3310493040,1),(51974115,425309676,16086111,434787,1,'2007-09-15 14:20:45',3310493040,1),(51974119,425311122,16085891,434787,1,'2007-09-15 14:20:46',3310493040,1),(51974122,425314988,16084980,434787,1,'2007-09-15 14:20:46',3310493041,1),(51974126,425317314,16083848,434787,1,'2007-09-15 14:20:46',3310493041,1),(51974129,425319640,16082182,434787,1,'2007-09-15 14:20:46',3310493041,1),(51974131,425323266,16078703,434787,1,'2007-09-15 14:20:46',3310493041,1),(51974133,425325384,16076313,434787,1,'2007-09-15 14:20:46',3310493041,1),(51974134,425327883,16072565,434787,1,'2007-09-15 14:20:46',3310493041,1),(51974137,425330924,16067677,434787,1,'2007-09-15 14:20:47',3310493041,1),(51974140,425332825,16064363,434787,1,'2007-09-15 14:20:47',3310493041,1),(51974143,425334944,16060344,434787,1,'2007-09-15 14:20:47',3310493041,1),(51974147,425336736,16055836,434787,1,'2007-09-15 14:20:47',3310493041,1),(51974149,425338855,16050024,434787,1,'2007-09-15 14:20:47',3310493041,1),(51974152,425340267,16045515,434787,1,'2007-09-15 14:20:47',3310493041,1),(51974153,425341136,16041876,434787,1,'2007-09-15 14:20:48',3310493041,1),(51974155,425341896,16040084,434787,1,'2007-09-15 14:20:48',3310493019,1),(51974158,425342820,16039812,434787,1,'2007-09-15 14:20:48',3310493022,1),(51974161,425343634,16040192,434787,1,'2007-09-15 14:20:48',3310493022,1),(51974164,425343852,16041496,434787,1,'2007-09-15 14:20:48',3310493044,1),(51974165,425343526,16043288,434787,1,'2007-09-15 14:20:48',3310493044,1),(51974167,425342983,16046982,434787,1,'2007-09-15 14:20:48',3310493044,1),(51974169,425342385,16051110,434787,1,'2007-09-15 14:20:48',3310493044,1),(51974172,425339778,16061430,434787,1,'2007-09-15 14:20:49',3310493041,1),(51974174,425338148,16067731,434787,1,'2007-09-15 14:20:49',3310493041,1),(51974176,425336899,16074792,434787,1,'2007-09-15 14:20:49',3310493041,1),(51974181,425336114,16080316,434787,1,'2007-09-15 14:20:49',3310493041,1),(51974183,425335363,16085666,434787,1,'2007-09-15 14:20:49',3310493041,1),(51974185,425335014,16090363,434787,1,'2007-09-15 14:20:50',3310493041,1),(51974187,425334945,16093261,434787,1,'2007-09-15 14:20:50',3310493041,1),(51974190,425334669,16098644,434787,1,'2007-09-15 14:20:50',3310493043,1),(51974191,425334738,16104579,434787,1,'2007-09-15 14:20:50',3310493043,1),(51974193,425335083,16110100,434787,1,'2007-09-15 14:20:50',3310493043,1),(51974195,425335980,16114171,434787,1,'2007-09-15 14:20:50',3310493043,1),(51974197,425337085,16120451,434787,1,'2007-09-15 14:20:50',3310493043,1),(51974199,425338120,16126110,434787,1,'2007-09-15 14:20:51',3310493043,1),(51974202,425339086,16131907,434787,1,'2007-09-15 14:20:51',3310493043,1),(51974204,425340259,16134874,434787,1,'2007-09-15 14:20:51',3310493043,1),(51974206,425341915,16136807,434787,1,'2007-09-15 14:20:51',3310493043,1),(51974208,425344262,16137773,434787,1,'2007-09-15 14:20:51',3310493046,1),(51974211,425345711,16137773,434787,1,'2007-09-15 14:20:51',3310493046,1),(51974213,425347298,16137428,434787,1,'2007-09-15 14:20:52',3310493046,1),(51974215,425348402,16137014,434787,1,'2007-09-15 14:20:52',3310493046,1),(51974217,425349851,16136876,434787,1,'2007-09-15 14:20:52',3310493046,1),(51974220,425350818,16137635,434787,1,'2007-09-15 14:20:52',3310493046,1),(51974223,425351232,16139015,434787,1,'2007-09-15 14:20:52',3310493046,1),(51974226,425351439,16141706,434787,1,'2007-09-15 14:20:52',3310493046,1),(51974229,425351313,16145218,434787,1,'2007-09-15 14:20:52',3310493046,1),(51974231,425351387,16150567,434787,1,'2007-09-15 14:20:53',3310493052,1),(51974233,425351020,16158553,434787,1,'2007-09-15 14:20:53',3310493052,1),(51974236,425350874,16161337,434787,1,'2007-09-15 14:20:53',3310493052,1),(51974239,425350874,16163315,434787,1,'2007-09-15 14:20:53',3310493052,1),(51974242,425351313,16165660,434787,1,'2007-09-15 14:20:53',3310493052,1),(51974244,425352925,16170056,434787,1,'2007-09-15 14:20:53',3310493052,1),(51974247,425355416,16175038,434787,1,'2007-09-15 14:20:53',3310493052,1),(51974249,425356882,16179361,434787,1,'2007-09-15 14:20:53',3310493052,1),(51974251,425357688,16184636,434787,1,'2007-09-15 14:20:54',3310493052,1),(51974253,425357907,16188299,434787,1,'2007-09-15 14:20:54',3310493052,1),(51974256,425357907,16191230,434787,1,'2007-09-15 14:20:54',3310493052,1),(51974258,425357468,16196065,434787,1,'2007-09-15 14:20:54',3310493052,1),(51974261,425356515,16202952,434787,1,'2007-09-15 14:20:54',3310493052,1),(51974264,425356002,16208448,434787,1,'2007-09-15 14:20:54',3310493054,1),(51974266,425355416,16214455,434787,1,'2007-09-15 14:20:54',3310493054,1),(51974275,425354317,16218705,434787,1,'2007-09-15 14:20:55',3310493054,1),(51974278,425352705,16225885,434787,1,'2007-09-15 14:20:55',3310493054,1),(51974279,425351973,16231453,434787,1,'2007-09-15 14:20:55',3310493054,1),(51974281,425351826,16235483,434787,1,'2007-09-15 14:20:55',3310493054,1),(51974284,425351387,16238560,434787,1,'2007-09-15 14:20:55',3310493054,1),(51974286,425350947,16241711,434787,1,'2007-09-15 14:20:55',3310493054,1),(51974289,425350947,16245374,434787,1,'2007-09-15 14:20:55',3310493054,1),(51974291,425351680,16247865,434787,1,'2007-09-15 14:20:56',3310493054,1),(51974292,425352779,16250136,434787,1,'2007-09-15 14:20:56',3310493054,1),(51974293,425354171,16252115,434787,1,'2007-09-15 14:20:56',3310493054,1),(51974296,425356515,16254020,434787,1,'2007-09-15 14:20:56',3310493054,1),(51974298,425357688,16255558,434787,1,'2007-09-15 14:20:57',3310493054,1),(51974300,425358787,16259295,434787,1,'2007-09-15 14:20:57',3310493054,1),(51974301,425359519,16261786,434787,1,'2007-09-15 14:20:57',3310493140,1),(51974305,425360179,16264204,434787,1,'2007-09-15 14:20:57',3310493140,1),(51974308,425361497,16265596,434787,1,'2007-09-15 14:20:57',3310493140,1),(51974309,425362816,16266109,434787,1,'2007-09-15 14:20:57',3310493140,1),(51974313,425364355,16266402,434787,1,'2007-09-15 14:20:58',3310493140,1),(51974316,425366626,16265962,434787,1,'2007-09-15 14:20:58',3310493140,1),(51974319,425368165,16265156,434787,1,'2007-09-15 14:20:58',3310493140,1),(51974321,425370143,16263398,434787,1,'2007-09-15 14:20:58',3310493141,1),(51974323,425371828,16261566,434787,1,'2007-09-15 14:20:58',3310493141,1),(51974326,425373074,16258782,434787,1,'2007-09-15 14:20:59',3310493055,1),(51974328,425373953,16255558,434787,1,'2007-09-15 14:20:59',3310493055,1),(51974331,425375418,16251089,434787,1,'2007-09-15 14:20:59',3310493055,1),(51974334,425376371,16248085,434787,1,'2007-09-15 14:20:59',3310493055,1),(51974337,425378276,16245667,434787,1,'2007-09-15 14:20:59',3310493055,1),(51974339,425380840,16243689,434787,1,'2007-09-15 14:20:59',3310493055,1),(51974341,425383404,16239586,434787,1,'2007-09-15 14:21:00',3310493055,1),(51974345,425383990,16237535,434787,1,'2007-09-15 14:21:00',3310493055,1),(51974349,425384210,16234091,434787,1,'2007-09-15 14:21:00',3310493055,1),(51974353,425384283,16230061,434787,1,'2007-09-15 14:21:00',3310493055,1),(51974357,425384283,16225958,434787,1,'2007-09-15 14:21:00',3310493055,1),(51974360,425384283,16224933,434787,1,'2007-09-15 14:21:00',3310493055,1),(51974363,425383990,16223101,434787,1,'2007-09-15 14:21:00',3310493055,1),(51974365,425384137,16222222,434787,1,'2007-09-15 14:21:01',3310493055,1),(51974368,425384650,16221709,434787,1,'2007-09-15 14:21:01',3310493055,1),(51974371,425385236,16221929,434787,1,'2007-09-15 14:21:01',3310493055,1),(51974373,425385529,16222735,434787,1,'2007-09-15 14:21:01',3310493055,1),(51974374,425385456,16225006,434787,1,'2007-09-15 14:21:01',3310493055,1),(51974376,425385529,16228816,434787,1,'2007-09-15 14:21:02',3310493055,1),(51974378,425385969,16231600,434787,1,'2007-09-15 14:21:02',3310493055,1),(51974383,425387068,16234897,434787,1,'2007-09-15 14:21:02',3310493055,1),(51974385,425387434,16237461,434787,1,'2007-09-15 14:21:02',3310493055,1),(51974388,425387800,16242956,434787,1,'2007-09-15 14:21:02',3310493055,1),(51974391,425387874,16247865,434787,1,'2007-09-15 14:21:02',3310493055,1),(51974394,425387214,16256437,434787,1,'2007-09-15 14:21:02',3310493055,1),(51974395,425387068,16261639,434787,1,'2007-09-15 14:21:03',3310493141,1),(51974397,425387338,16264267,434787,1,'2007-09-15 14:21:03',3310493141,1),(51974400,425387707,16270816,434787,1,'2007-09-15 14:21:03',3310493141,1),(51974402,425387707,16276166,434787,1,'2007-09-15 14:21:03',3310493141,1),(51974404,425387430,16281332,434787,1,'2007-09-15 14:21:03',3310493141,1),(51974405,425387615,16285667,434787,1,'2007-09-15 14:21:03',3310493141,1),(51974408,425387984,16292493,434787,1,'2007-09-15 14:21:04',3310493141,1),(51974411,425388630,16298027,434787,1,'2007-09-15 14:21:04',3310493141,1),(51974414,425389367,16302270,434787,1,'2007-09-15 14:21:04',3310493141,1),(51974416,425390013,16306329,434787,1,'2007-09-15 14:21:04',3310493141,1),(51974419,425390659,16310019,434787,1,'2007-09-15 14:21:04',3310493141,1),(51974422,425390198,16313155,434787,1,'2007-09-15 14:21:04',3310493141,1),(51974424,425389736,16314907,434787,1,'2007-09-15 14:21:04',3310493141,1),(51974428,425388630,16317767,434787,1,'2007-09-15 14:21:05',3310493143,1),(51974430,425387338,16320811,434787,1,'2007-09-15 14:21:05',3310493143,1),(51974432,425386877,16322748,434787,1,'2007-09-15 14:21:05',3310493143,1),(51974436,425386692,16325699,434787,1,'2007-09-15 14:21:05',3310493143,1),(51974439,425387258,16328597,434787,1,'2007-09-15 14:21:05',3310493143,1),(51974442,425388261,16332064,434787,1,'2007-09-15 14:21:06',3310493143,1),(51974445,425388563,16334592,434787,1,'2007-09-15 14:21:06',3310493143,1),(51974446,425388449,16337913,434787,1,'2007-09-15 14:21:06',3310493143,1),(51974451,425388630,16340181,434787,1,'2007-09-15 14:21:06',3310493143,1),(51974452,425388826,16341451,434787,1,'2007-09-15 14:21:06',3310493143,1),(51974454,425390025,16342039,434787,1,'2007-09-15 14:21:06',3310493143,1),(51974455,425391108,16340973,434787,1,'2007-09-15 14:21:07',3310493143,1),(51974456,425391363,16338890,434787,1,'2007-09-15 14:21:07',3310493143,1),(51974458,425391673,16334647,434787,1,'2007-09-15 14:21:07',3310493143,1),(51974462,425392411,16330680,434787,1,'2007-09-15 14:21:07',3310493143,1),(51974466,425393518,16326991,434787,1,'2007-09-15 14:21:07',3310493143,1),(51974469,425394994,16321733,434787,1,'2007-09-15 14:21:08',3310493143,1),(51974472,425395640,16317767,434787,1,'2007-09-15 14:21:08',3310493143,1),(51974475,425395640,16314446,434787,1,'2007-09-15 14:21:08',3310493141,1),(51974478,425395363,16306698,434787,1,'2007-09-15 14:21:08',3310493141,1),(51974481,425389262,16342039,434787,1,'2007-09-15 14:21:08',3310493143,1),(51974484,425390870,16341610,434787,1,'2007-09-15 14:21:09',3310493143,1),(52002189,425104877,15459263,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002192,425109756,15460923,434787,1,'2007-09-15 15:09:48',3310491539,1),(52002196,425111768,15463739,188228,1,'2008-06-16 18:49:29',3310491539,3),(52002198,425108183,15459222,434787,1,'2007-09-15 15:09:48',3310491539,1),(52002202,425106603,15458834,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002204,425098579,15459191,434787,1,'2007-09-15 15:09:49',3310491539,1),(52002206,425101297,15460794,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002209,425104144,15459928,434787,1,'2007-09-15 15:09:49',3310491539,1),(52002211,425105525,15458928,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002212,425106971,15458859,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002214,425109112,15460059,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002216,425110138,15461553,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002219,425110313,15463739,188228,1,'2008-06-16 18:49:01',3310491539,2),(52002220,425107983,15460208,434787,1,'2007-09-15 15:09:50',3310491539,1),(52002222,425107277,15459617,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002223,425105502,15460425,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002226,425104673,15461243,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002229,425099318,15461965,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002231,425102030,15462096,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002235,425067515,15270951,508959,1,'2007-09-24 18:39:54',3310491431,1),(52002238,425067087,15269869,434787,1,'2007-09-15 15:09:52',3310491431,1),(52002241,425067153,15264746,508959,1,'2007-09-24 18:39:54',3310491431,1),(52002244,425065171,15254581,508959,1,'2007-09-24 18:39:54',3310491431,1),(52002247,425061389,15248466,434787,1,'2007-09-15 15:09:53',3310491431,1),(52002248,425057445,15247192,508959,1,'2007-09-24 18:39:54',3310491431,1),(52002251,425060890,15250852,508959,1,'2007-09-24 18:39:54',3310491431,1),(52002253,425062718,15253714,434787,1,'2007-09-15 15:09:54',3310491431,1),(52002256,425040750,15200351,508959,1,'2007-09-24 18:39:54',3310491429,1),(52002258,425039231,15196247,508959,1,'2007-09-24 18:39:54',3310491428,1),(52002259,425038923,15193100,508959,1,'2007-09-24 18:39:54',3310491428,1),(52002261,425039811,15170198,508959,1,'2007-09-24 18:39:54',3310491428,1),(52002264,425037770,15165326,434787,1,'2007-09-15 15:09:55',3310491428,1),(52002266,425038411,15169701,508959,1,'2007-09-24 18:39:54',3310491428,1),(52002269,425036006,15160845,434787,1,'2007-09-15 15:09:55',3310491406,1),(52002272,425038104,15161314,434787,1,'2007-09-15 15:09:56',3310491406,1),(52002275,425034794,15156277,508959,1,'2007-09-24 18:39:54',3310491406,1),(52002278,425032742,15156139,508959,1,'2007-09-24 18:39:54',3310491406,1),(52002281,424978626,15094146,508959,1,'2007-09-24 18:39:54',3310491400,1),(52009103,424727970,14930747,508959,1,'2007-09-24 18:39:54',3310490815,1),(52009105,424729083,14930328,508959,1,'2007-09-24 18:39:54',3310490815,1),(52009107,424726445,14930313,508959,1,'2007-09-24 18:39:54',3310490815,1),(52009108,424721680,14922054,434787,1,'2007-09-15 15:24:23',3310490815,1),(52009109,424723033,14923441,434787,1,'2007-09-15 15:24:23',3310490815,1),(52009111,424724285,14924422,434787,1,'2007-09-15 15:24:23',3310490815,1),(52009114,424725333,14924997,434787,1,'2007-09-15 15:24:24',3310490815,1),(52009117,424726822,14925099,434787,1,'2007-09-15 15:24:24',3310490815,1),(52009118,424727769,14924794,434787,1,'2007-09-15 15:24:24',3310490815,1),(52009120,424728683,14923644,434787,1,'2007-09-15 15:24:24',3310490815,1),(52009122,424730002,14922765,434787,1,'2007-09-15 15:24:24',3310490815,1),(52009124,424731423,14921783,434787,1,'2007-09-15 15:24:25',3310490815,1),(52009126,424732693,14921298,434787,1,'2007-09-15 15:24:25',3310490815,1),(52009127,424735483,14922359,434787,1,'2007-09-15 15:24:25',3310490815,1),(52009129,424736510,14922913,439281,1,'2007-09-16 00:57:34',3310490815,1),(52009130,424757255,14866933,434787,1,'2007-09-15 15:24:26',3310490856,1),(52009134,424758499,14871947,434787,1,'2007-09-15 15:24:26',3310490856,1),(52009137,424759782,14877971,434787,1,'2007-09-15 15:24:26',3310490856,1),(52009140,424760637,14882402,434787,1,'2007-09-15 15:24:26',3310490856,1),(52009143,424762152,14889670,434787,1,'2007-09-15 15:24:27',3310490858,1),(52009144,424763085,14893635,434787,1,'2007-09-15 15:24:27',3310490858,1),(52009147,424763707,14896472,434787,1,'2007-09-15 15:24:27',3310490858,1),(52009150,424764096,14898843,434787,1,'2007-09-15 15:24:27',3310490858,1),(52009151,424763979,14902691,434787,1,'2007-09-15 15:24:28',3310490858,1),(52009154,424763901,14905372,434787,1,'2007-09-15 15:24:28',3310490858,1),(52009156,424763921,14906675,439281,1,'2007-09-16 00:57:34',3310490858,1),(52009157,424767930,14870633,434787,1,'2007-09-15 15:24:28',3310490857,1),(52009159,424759333,14874206,434787,1,'2007-09-15 15:24:28',3310490856,1),(52009161,424761630,14882458,434787,1,'2007-09-15 15:24:29',3310490856,1),(52009164,424770177,14878581,434787,1,'2007-09-15 15:24:29',3310490857,1),(52009168,424759474,14886019,434787,1,'2007-09-15 15:24:29',3310490856,1),(52009171,424758852,14886712,370566,1,'2008-05-09 02:14:21',3310490858,2),(52009174,424758881,14887758,434787,1,'2007-09-15 15:24:29',3310490858,1),(52009176,424758770,14890608,434787,1,'2007-09-15 15:24:29',3310490858,1),(52009179,424758511,14893198,434787,1,'2007-09-15 15:24:30',3310490858,1),(52009182,424758252,14895270,434787,1,'2007-09-15 15:24:30',3310490858,1),(52009184,424757475,14896047,434787,1,'2007-09-15 15:24:30',3310490858,1),(52009186,424755884,14896528,434787,1,'2007-09-15 15:24:30',3310490858,1),(52009189,424750851,14898601,434787,1,'2007-09-15 15:24:30',3310490858,1),(52009192,424747891,14900044,434787,1,'2007-09-15 15:24:30',3310490858,1),(52009194,424746226,14900821,434787,1,'2007-09-15 15:24:31',3310490858,1),(52009196,424743191,14903411,434787,1,'2007-09-15 15:24:31',3310490858,1),(52009197,424761317,14885508,434787,1,'2007-09-15 15:24:31',3310490856,1),(52011225,424539336,14857205,434787,1,'2007-09-15 15:27:57',3310490792,1),(52011227,424530186,14853952,508959,1,'2007-09-24 18:39:54',3310490792,1),(52011231,424542623,14857218,508959,1,'2007-09-24 18:39:54',3310490792,1),(52011234,424535770,14856367,434787,1,'2007-09-15 15:27:58',3310490792,1),(52011238,424525709,14851274,434787,1,'2007-09-15 15:27:58',3310490792,1),(52011242,424543885,14858714,508959,1,'2007-09-24 18:39:54',3310490792,1),(52011244,424540853,14858477,508959,1,'2007-09-24 18:39:54',3310490792,1),(52011249,424537160,14857946,508959,1,'2007-09-24 18:39:54',3310490792,1),(52011253,424533176,14856682,508959,1,'2007-09-24 18:39:54',3310490792,1),(52011256,424529142,14854856,508959,1,'2007-09-24 18:39:54',3310490792,1),(52011259,424525949,14853411,508959,1,'2007-09-24 18:39:54',3310490792,1),(52031003,425116007,15485111,188228,1,'2008-06-16 18:50:28',3310491539,2),(52031013,425116830,15488286,188228,1,'2008-06-16 18:52:01',3310491539,3),(52031030,425117716,15492664,188228,1,'2008-06-16 18:52:01',3310491545,2),(52031034,425118665,15495239,188228,1,'2008-06-16 18:52:01',3310491545,2),(52031036,425119595,15497880,434787,1,'2007-09-15 16:14:23',3310491545,1),(52031039,425121516,15500056,508959,1,'2007-09-24 18:39:54',3310491545,1),(52031041,425122962,15501502,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031043,425126336,15503109,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031046,425129454,15505198,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031050,425130578,15508154,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031054,425131349,15512107,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031056,425132249,15516060,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031059,425133053,15518245,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031076,425133817,15520466,434787,1,'2007-09-15 16:14:27',3310491548,1),(52031077,425134735,15522628,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031080,425135919,15523339,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031082,425136956,15524228,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031084,425137578,15525205,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031086,425139385,15527959,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031089,425141132,15529410,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031092,425141783,15529707,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031095,425142879,15529262,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031099,425143827,15528285,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031100,425145244,15528216,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031105,425147203,15528552,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031109,425148891,15529322,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031114,425150846,15530714,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031117,425152001,15533172,434787,1,'2007-09-15 16:14:31',3310491549,1),(52031121,425153067,15535808,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031125,425153837,15537792,434787,1,'2007-09-15 16:14:32',3310491549,1),(52031129,425154607,15538503,434787,1,'2007-09-15 16:14:32',3310491549,1),(52031131,425155999,15538947,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031136,425160086,15538858,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031141,425161967,15538663,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031147,425165787,15534984,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031151,425166542,15534984,434787,1,'2007-09-15 16:14:33',3310491549,1),(52031153,425167485,15535928,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031156,425173569,15541021,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031158,425178899,15545832,508959,1,'2007-09-24 18:39:54',3310491592,1),(52031164,425183521,15550171,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031171,425185974,15552058,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031174,425188049,15555218,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031178,425190266,15560595,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031186,425192577,15564321,434787,1,'2007-09-15 16:14:35',3310491594,1),(52031190,425195925,15567245,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031198,425199651,15568848,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031205,425203094,15569697,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031212,425205547,15570924,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031218,425207622,15573423,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031221,425209414,15574414,434787,1,'2007-09-15 16:14:38',3310491595,1),(52031224,425211537,15575593,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031227,425213562,15576830,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031232,425215518,15579764,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031235,425216876,15583458,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031240,425217908,15586501,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031244,425218778,15588837,434787,1,'2007-09-15 16:14:39',3310491595,1),(52031247,425219538,15590522,434787,1,'2007-09-15 16:14:39',3310491595,1),(52031250,425221223,15592206,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031255,425223016,15593945,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031260,425224548,15596343,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031262,425226557,15601096,434787,1,'2007-09-15 16:14:40',3310491617,1),(52031267,425228321,15606142,434787,1,'2007-09-15 16:14:40',3310491617,1),(52031272,425229654,15608318,508959,1,'2007-09-24 18:39:54',3310491617,1),(52031275,425231476,15610199,508959,1,'2007-09-24 18:39:54',3310491617,1),(52031281,425235298,15612374,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031285,425237062,15613609,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031290,425238296,15616137,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031295,425239707,15618548,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031299,425242000,15620840,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031307,425245528,15623251,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031309,425249114,15625309,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031314,425251877,15627778,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031320,425253641,15630424,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031325,425254641,15633246,434787,1,'2007-09-15 16:14:43',3310491620,1),(52031329,425255111,15636715,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031335,425254699,15641594,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031340,425253641,15645651,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031346,425253406,15647826,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031351,425253773,15649696,188228,1,'2008-06-16 19:33:39',3310491620,2),(52031355,425254848,15653130,188228,1,'2008-06-16 19:33:39',3310491620,2),(52031357,425256176,15656563,188228,1,'2008-06-16 19:33:39',3310491622,2),(52031361,425259023,15662056,188228,1,'2008-06-16 19:34:11',3310491622,2),(52031364,425260731,15664459,188228,1,'2008-06-16 19:34:30',3310491623,2),(52031367,425262695,15666464,434787,1,'2007-09-15 16:14:45',3310491623,1),(52031369,425264988,15667522,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031373,425268281,15668522,434787,1,'2007-09-15 16:14:45',3310491623,1),(52031381,425271044,15669991,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031384,425272337,15672696,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031410,425273807,15678046,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031414,425274572,15683631,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031418,425275924,15686630,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031424,425277746,15688864,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031426,425280333,15689687,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031429,425284037,15689687,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031433,425286624,15689570,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031438,425289623,15689687,508959,1,'2007-09-24 18:39:54',3310491634,1),(52031441,425290975,15690687,508959,1,'2007-09-24 18:39:54',3310491634,1),(52031446,425291915,15692803,508959,1,'2007-09-24 18:39:54',3310491634,1),(52031449,425292739,15696037,508959,1,'2007-09-24 18:39:54',3310491634,1),(52031456,425294326,15698800,508959,1,'2007-09-24 18:39:54',3310491634,1),(52031461,425296972,15702916,508959,1,'2007-09-24 18:39:54',3310491634,1),(52031464,425300264,15706032,508959,1,'2007-09-24 18:39:54',3310491634,1),(52031467,425304380,15708618,508959,1,'2007-09-24 18:39:54',3310491634,1),(52031471,425307084,15710500,508959,1,'2007-09-24 18:39:54',3310491634,1),(52031477,425308965,15712616,434787,1,'2007-09-15 16:14:50',3310491640,1),(52031481,425311376,15716320,508959,1,'2007-09-24 18:39:54',3310491640,1),(52031483,425314492,15721553,434787,1,'2007-09-15 16:14:51',3310491640,1),(52031486,425316726,15724963,508959,1,'2007-09-24 18:39:54',3310491641,1),(52031491,425319019,15727079,508959,1,'2007-09-24 18:39:54',3310491641,1),(52031494,425321253,15729196,434787,1,'2007-09-15 16:14:51',3310491641,1),(52031498,425323605,15731548,508959,1,'2007-09-24 18:39:54',3310491641,1),(52031500,425325075,15733723,508959,1,'2007-09-24 18:39:54',3310491641,1),(52031504,425325780,15734899,508959,1,'2007-09-24 18:39:54',3310491641,1),(52031507,425326368,15736545,434787,1,'2007-09-15 16:14:52',3310491641,1),(52031512,425326074,15739661,508959,1,'2007-09-24 18:39:54',3310491641,1),(52031514,425326309,15744659,434787,1,'2007-09-15 16:14:52',3310491641,1),(52031517,425327074,15748480,508959,1,'2007-09-24 18:39:54',3310491641,1),(52031521,425328014,15755065,434787,1,'2007-09-15 16:14:52',3310491641,1),(52031523,425328661,15759357,508959,1,'2007-09-24 18:39:54',3310491641,1),(52031527,425329131,15764825,508959,1,'2007-09-24 18:39:54',3310491641,1),(52031529,425330307,15770763,508959,1,'2007-09-24 18:39:54',3310491643,1),(52031532,425331718,15773761,508959,1,'2007-09-24 18:39:54',3310491643,1),(52031535,425332659,15776054,508959,1,'2007-09-24 18:39:54',3310491643,1),(52031540,425334188,15778994,508959,1,'2007-09-24 18:39:54',3310491643,1),(52031545,425334834,15781522,434787,1,'2007-09-15 16:14:54',3310491643,1),(52031550,425335716,15786578,508959,1,'2007-09-24 18:39:54',3310491643,1),(52031552,425335834,15790282,508959,1,'2007-09-24 18:39:54',3310491643,1),(52031554,425336363,15793692,434787,1,'2007-09-15 16:14:54',3310491643,1),(52031560,425336598,15796690,434787,1,'2007-09-15 16:14:54',3310491643,1),(52031562,425337010,15798748,434787,1,'2007-09-15 16:14:54',3310491643,1),(52031567,425338127,15800630,434787,1,'2007-09-15 16:14:55',3310491643,1),(52031572,425339714,15802158,508959,1,'2007-09-24 18:39:54',3310491643,1),(52031576,425343359,15803922,508959,1,'2007-09-24 18:39:54',3310491646,1),(52031580,425346534,15805627,508959,1,'2007-09-24 18:39:54',3310491646,1),(52031581,425349709,15807450,508959,1,'2007-09-24 18:39:54',3310491646,1),(52031587,425352590,15809978,434787,1,'2007-09-15 16:14:56',3310491646,1),(52031590,425357646,15815504,508959,1,'2007-09-24 18:39:54',3310491646,1),(52031592,425361468,15819267,508959,1,'2007-09-24 18:39:54',3310491646,1),(52031595,425365348,15823676,508959,1,'2007-09-24 18:39:54',3310493012,1),(52031600,425369169,15827204,434787,1,'2007-09-15 16:14:57',3310493012,1),(52031604,425373050,15830261,434787,1,'2007-09-15 16:14:57',3310493013,1),(52031608,425375225,15832143,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031611,425376695,15834494,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031614,425377048,15836434,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031616,425377048,15838610,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031617,425377048,15840668,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031620,425376813,15842608,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031621,425375931,15844842,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031626,425375225,15846547,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031627,425375108,15848605,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031631,425375049,15851133,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031634,425375872,15852661,434787,1,'2007-09-15 16:14:59',3310493013,1),(52031636,425376813,15854543,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031642,425377459,15856718,434787,1,'2007-09-15 16:15:00',3310493013,1),(52031645,425377577,15858305,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031648,425377988,15860716,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031652,425378576,15862186,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031656,425379929,15864361,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031658,425380693,15867712,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031660,425381046,15870828,434787,1,'2007-09-15 16:15:02',3310493013,1),(52031665,425381398,15872945,434787,1,'2007-09-15 16:15:02',3310493013,1),(52031668,425382222,15874121,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031671,425383927,15875885,508959,1,'2007-09-24 18:39:54',3310493015,1),(52031676,425385808,15878119,508959,1,'2007-09-24 18:39:54',3310493015,1),(52031678,425387101,15881235,508959,1,'2007-09-24 18:39:54',3310493015,1),(52031681,425387572,15883586,508959,1,'2007-09-24 18:39:54',3310493015,1),(52031686,425387866,15887584,508959,1,'2007-09-24 18:39:54',3310493015,1),(52031688,425387983,15893405,508959,1,'2007-09-24 18:39:54',3310493015,1),(52031691,425388454,15895110,508959,1,'2007-09-24 18:39:54',3310493015,1),(52031695,425389982,15898520,434787,1,'2007-09-15 16:15:04',3310493015,1),(52031700,425392158,15901695,508959,1,'2007-09-24 18:39:54',3310493015,1),(52031702,425395097,15903929,434787,1,'2007-09-15 16:15:04',3310493015,1),(52031705,425400036,15906045,434787,1,'2007-09-15 16:15:05',3310503938,1),(52031709,425404622,15907221,508959,1,'2007-09-24 18:39:54',3310503938,1),(52031712,425407914,15907045,508959,1,'2007-09-24 18:39:54',3310503938,1),(52031715,425411736,15906281,508959,1,'2007-09-24 18:39:54',3310503938,1),(52031717,425414381,15905575,508959,1,'2007-09-24 18:39:54',3310503938,1),(52031720,425416263,15905163,508959,1,'2007-09-24 18:39:54',3310503938,1),(52031723,425417791,15906104,508959,1,'2007-09-24 18:39:54',3310503938,1),(52031726,425117209,15484939,188228,1,'2008-06-16 18:50:28',3310491539,2),(52031730,425118412,15489745,188228,1,'2008-06-16 18:50:28',3310491539,3),(52031732,425119108,15493007,188228,1,'2008-06-16 18:52:01',3310491545,3),(52031736,425119740,15494380,188228,1,'2008-06-16 18:52:01',3310491545,3),(52031739,425120876,15497601,508959,1,'2007-09-24 18:39:54',3310491545,1),(52031742,425124337,15500196,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031744,425126729,15501621,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031746,425129070,15502995,434787,1,'2007-09-15 16:15:08',3310491548,1),(52031747,425130495,15504726,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031749,425131310,15507372,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031751,425132277,15512157,434787,1,'2007-09-15 16:15:09',3310491548,1),(52031756,425133142,15515567,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031758,425134262,15519078,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031761,425135279,15521318,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031764,425137213,15522946,434787,1,'2007-09-15 16:15:09',3310491548,1),(52031767,425138333,15524626,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031771,425140725,15527476,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031774,425141590,15528290,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031777,425142965,15528138,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031782,425143932,15527527,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031785,425145662,15527476,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031789,425147901,15527985,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031794,425150039,15529054,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031798,425151871,15530428,434787,1,'2007-09-15 16:15:12',3310491549,1),(52031803,425152838,15532158,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031805,425154009,15535467,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031809,425154925,15537248,434787,1,'2007-09-15 16:15:13',3310491549,1),(52031811,425155994,15537910,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031813,425157877,15537808,434787,1,'2007-09-15 16:15:13',3310491549,1),(52031815,425160523,15537553,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031821,425161694,15536841,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031823,425162661,15535823,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031827,425164188,15533940,434787,1,'2007-09-15 16:15:14',3310491549,1),(52031830,425165511,15533431,434787,1,'2007-09-15 16:15:14',3310491549,1),(52031832,425166580,15533380,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031834,425168005,15534500,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031838,425174520,15540658,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031840,425179762,15544831,508959,1,'2007-09-24 18:39:54',3310491592,1),(52031844,425184037,15548343,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031847,425186226,15550481,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031850,425187600,15553127,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031855,425190348,15558522,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031858,425191773,15561525,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031861,425193758,15563764,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031865,425196099,15565698,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031866,425198949,15567174,434787,1,'2007-09-15 16:15:17',3310491594,1),(52031868,425201901,15567887,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031871,425204395,15568752,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031872,425207551,15571653,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031874,425208467,15572722,434787,1,'2007-09-15 16:15:17',3310491595,1),(52031876,425209994,15573180,434787,1,'2007-09-15 16:15:17',3310491595,1),(52031881,425212284,15573943,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031884,425213913,15574859,434787,1,'2007-09-15 16:15:18',3310491595,1),(52031886,425215389,15576641,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031888,425216915,15579694,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031889,425218442,15584937,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031893,425219562,15588347,434787,1,'2007-09-15 16:15:19',3310491595,1),(52031894,425220274,15589823,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031899,425221394,15591044,434787,1,'2007-09-15 16:15:19',3310491595,1),(52031901,425223226,15592571,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031906,425224753,15594861,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031908,425226331,15597864,434787,1,'2007-09-15 16:15:19',3310491595,1),(52031911,425227247,15600562,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031913,425229232,15605549,434787,1,'2007-09-15 16:15:20',3310491617,1),(52031915,425230606,15607432,434787,1,'2007-09-15 16:15:20',3310491617,1),(52031919,425232082,15609163,508959,1,'2007-09-24 18:39:54',3310491617,1),(52031921,425235645,15611250,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031925,425237477,15612522,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031927,425239207,15615626,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031930,425240378,15617764,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031933,425242567,15619596,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031936,425245926,15621683,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031938,425249641,15623872,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031943,425252491,15626823,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031946,425254680,15629775,434787,1,'2007-09-15 16:15:22',3310491620,1),(52031948,425255596,15633033,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031953,425256105,15636697,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031956,425255799,15641685,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031958,425254883,15645756,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031962,425254578,15647996,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031966,425254680,15649624,434787,1,'2007-09-15 16:15:23',3310491620,1),(52031968,425255494,15652627,434787,1,'2007-09-15 16:15:24',3310491620,1),(52031973,425257021,15656292,508959,1,'2007-09-24 18:39:54',3310491622,1),(52031976,425259719,15661112,188228,1,'2008-06-16 19:34:11',3310491622,2),(52031980,425261500,15663570,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031984,425263230,15665249,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031987,425265266,15666165,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031990,425268421,15666522,434787,1,'2007-09-15 16:15:25',3310491623,1),(52031992,425271679,15667998,434787,1,'2007-09-15 16:15:25',3310491623,1),(52031995,425273613,15671306,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031998,425274783,15677668,434787,1,'2007-09-15 16:15:25',3310491623,1),(52032000,425275292,15683368,434787,1,'2007-09-15 16:15:25',3310491623,1),(52032003,425276310,15686167,434787,1,'2007-09-15 16:15:26',3310491623,1),(52032007,425277888,15688203,508959,1,'2007-09-24 18:39:54',3310491623,1),(52032010,425280280,15688458,508959,1,'2007-09-24 18:39:54',3310491623,1),(52032012,425284046,15688203,508959,1,'2007-09-24 18:39:54',3310491623,1),(52032017,425286642,15688152,508959,1,'2007-09-24 18:39:54',3310491623,1),(52032018,425289848,15688661,508959,1,'2007-09-24 18:39:54',3310491634,1),(52032021,425291884,15689628,508959,1,'2007-09-24 18:39:54',3310491634,1),(52032022,425292647,15691664,434787,1,'2007-09-15 16:15:27',3310491634,1),(52032026,425293716,15695430,434787,1,'2007-09-15 16:15:27',3310491634,1),(52032029,425295192,15698026,434787,1,'2007-09-15 16:15:27',3310491634,1),(52032033,425297941,15702047,434787,1,'2007-09-15 16:15:28',3310491634,1),(52032035,425300791,15705100,508959,1,'2007-09-24 18:39:54',3310491634,1),(52032039,425304659,15707340,508959,1,'2007-09-24 18:39:54',3310491634,1),(52032041,425307560,15709528,508959,1,'2007-09-24 18:39:54',3310491634,1),(52032044,425309443,15712175,508959,1,'2007-09-24 18:39:54',3310491640,1),(52032047,425312039,15715788,508959,1,'2007-09-24 18:39:54',3310491640,1),(52032048,425314940,15720980,434787,1,'2007-09-15 16:15:29',3310491641,1),(52032051,425317281,15723982,508959,1,'2007-09-24 18:39:54',3310491641,1),(52032054,425319673,15726324,508959,1,'2007-09-24 18:39:54',3310491641,1),(52032057,425321912,15728410,508959,1,'2007-09-24 18:39:54',3310491641,1),(52032060,425326136,15732380,508959,1,'2007-09-24 18:39:54',3310491641,1),(52032064,425326747,15734263,434787,1,'2007-09-15 16:15:30',3310491641,1),(52032067,425327307,15736401,508959,1,'2007-09-24 18:39:54',3310491641,1),(52032070,425327409,15739963,434787,1,'2007-09-15 16:15:30',3310491641,1),(52032071,425327918,15748158,434787,1,'2007-09-15 16:15:30',3310491641,1),(52032075,425328834,15754825,508959,1,'2007-09-24 18:39:54',3310491641,1),(52032076,425329496,15759456,508959,1,'2007-09-24 18:39:54',3310491641,1),(52032078,425330005,15764749,508959,1,'2007-09-24 18:39:54',3310491641,1),(52032081,425330972,15770195,434787,1,'2007-09-15 16:15:31',3310491643,1),(52032085,425332447,15772944,508959,1,'2007-09-24 18:39:54',3310491643,1),(52032087,425333465,15774776,508959,1,'2007-09-24 18:39:54',3310491643,1),(52032090,425334941,15778186,434787,1,'2007-09-15 16:15:32',3310491643,1),(52032092,425335756,15781290,434787,1,'2007-09-15 16:15:32',3310491643,1),(52032093,425336672,15786583,508959,1,'2007-09-24 18:39:54',3310491643,1),(52032098,425336926,15790095,508959,1,'2007-09-24 18:39:54',3310491643,1),(52032100,425337435,15793811,508959,1,'2007-09-24 18:39:54',3310491643,1),(52032103,425337537,15796610,508959,1,'2007-09-24 18:39:54',3310491643,1),(52032107,425338097,15798544,508959,1,'2007-09-24 18:39:54',3310491643,1);
INSERT INTO `current_nodes` VALUES (52032109,425338708,15799816,508959,1,'2007-09-24 18:39:54',3310491643,1),(52032112,425340234,15800987,508959,1,'2007-09-24 18:39:54',3310491643,1),(52032113,425343441,15802514,434787,1,'2007-09-15 16:15:33',3310491646,1),(52032116,425346851,15804193,434787,1,'2007-09-15 16:15:34',3310491646,1),(52032119,425349752,15805822,434787,1,'2007-09-15 16:15:34',3310491646,1),(52032122,425352449,15808265,434787,1,'2007-09-15 16:15:34',3310491646,1),(52032125,425354638,15810453,508959,1,'2007-09-24 18:39:54',3310491646,1),(52032127,425359167,15815085,508959,1,'2007-09-24 18:39:54',3310491646,1),(52032130,425363239,15819462,434787,1,'2007-09-15 16:15:35',3310491646,1),(52032133,425367565,15823533,508959,1,'2007-09-24 18:39:54',3310493012,1),(52032135,425370873,15826587,434787,1,'2007-09-15 16:15:35',3310493013,1),(52032137,425373673,15828725,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032141,425376319,15831320,434787,1,'2007-09-15 16:15:36',3310493013,1),(52032145,425377642,15833153,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032147,425378100,15836308,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032150,425378050,15840685,434787,1,'2007-09-15 16:15:36',3310493013,1),(52032153,425377744,15843077,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032158,425376828,15845775,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032160,425376116,15847861,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032162,425375810,15849643,434787,1,'2007-09-15 16:15:37',3310493013,1),(52032165,425376116,15851628,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032168,425377083,15853154,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032171,425378151,15855648,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032174,425378660,15859007,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032176,425379322,15861450,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032179,425380594,15863028,434787,1,'2007-09-15 16:15:39',3310493013,1),(52032182,425381256,15864504,434787,1,'2007-09-15 16:15:39',3310493013,1),(52032183,425381867,15866184,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032186,425382121,15867507,434787,1,'2007-09-15 16:15:39',3310493013,1),(52032187,425382070,15869899,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032190,425382477,15872291,434787,1,'2007-09-15 16:15:40',3310493013,1),(52032192,425383750,15874378,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032195,425385124,15875396,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032197,425387007,15877482,508959,1,'2007-09-24 18:39:54',3310493015,1),(52032200,425387974,15879518,508959,1,'2007-09-24 18:39:54',3310493015,1),(52032204,425388636,15883488,508959,1,'2007-09-24 18:39:54',3310493015,1),(52032205,425389094,15887407,434787,1,'2007-09-15 16:15:41',3310493015,1),(52032208,425389145,15892954,434787,1,'2007-09-15 16:15:42',3310493015,1),(52032211,425389552,15894532,508959,1,'2007-09-24 18:39:54',3310493015,1),(52032212,425390824,15898044,434787,1,'2007-09-15 16:15:42',3310493015,1),(52032216,425392656,15900843,508959,1,'2007-09-24 18:39:54',3310493015,1),(52032219,425395303,15902726,508959,1,'2007-09-24 18:39:54',3310493015,1),(52032222,425400291,15904609,508959,1,'2007-09-24 18:39:54',3310503938,1),(52032225,425404515,15905424,508959,1,'2007-09-24 18:39:54',3310503938,1),(52032228,425407518,15905373,434787,1,'2007-09-15 16:15:43',3310503938,1),(52032233,425411233,15905067,508959,1,'2007-09-24 18:39:54',3310503938,1),(52032238,425414134,15904100,434787,1,'2007-09-15 16:15:43',3310503938,1),(52032241,425416374,15903795,434787,1,'2007-09-15 16:15:43',3310503938,1),(52032243,425418186,15904585,434787,1,'2007-09-15 16:15:43',3310503938,1),(52032246,425419679,15905500,508959,1,'2007-09-24 18:39:54',3310503938,1),(52032249,425419359,15906380,434787,1,'2007-09-15 16:15:44',3310503938,1),(52032250,425419510,15905965,508959,1,'2007-09-24 18:39:54',3310503938,1),(52163550,425556412,15336966,72964,1,'2008-08-05 20:37:35',3310502459,4),(52163556,425558372,15343575,72964,1,'2008-08-05 20:37:36',3310502459,4),(52163563,425559826,15346579,72964,1,'2008-08-05 20:37:36',3310502459,4),(52163574,425560910,15347910,72964,1,'2008-08-05 20:37:36',3310502459,3),(52163581,425562312,15347865,72964,1,'2008-08-05 20:37:36',3310502462,3),(52163588,425563036,15347322,435967,1,'2007-09-15 21:25:22',3310502462,1),(52163595,425563579,15346191,435967,1,'2007-09-15 21:25:23',3310502462,1),(52163602,425563669,15344834,435967,1,'2007-09-15 21:25:24',3310502462,1),(52163609,425563986,15343296,435967,1,'2007-09-15 21:25:24',3310502462,1),(52163613,425564710,15340718,435967,1,'2007-09-15 21:25:24',3310502462,1),(52163621,425566066,15337959,435967,1,'2007-09-15 21:25:25',3310502462,1),(52163631,425566790,15335561,435967,1,'2007-09-15 21:25:27',3310502462,1),(52163644,425566790,15333119,435967,1,'2007-09-15 21:25:29',3310502462,1),(52163664,425566428,15329229,435967,1,'2007-09-15 21:25:33',3310502462,1),(52164958,425566971,15327691,538211,1,'2007-09-30 15:36:21',3310502462,1),(52166749,425568147,15326605,198831,1,'2008-04-20 16:36:30',3310502462,2),(52166950,425568578,15326123,2836771,1,'2009-10-13 18:46:13',3310502460,2),(52166959,426369093,14912041,373445,1,'2008-05-09 19:04:04',3310503087,2),(52166976,426368531,14916137,373445,1,'2008-05-09 19:04:04',3310503087,2),(52166980,426368772,14921678,373445,1,'2008-05-09 19:04:04',3310503087,2),(52167010,426369174,14925051,373445,1,'2008-05-09 19:04:04',3310503087,2),(52167017,426368210,14927058,373445,1,'2008-05-09 19:04:04',3310503087,2),(52167025,426368772,14929146,373445,1,'2008-05-09 19:04:04',3310503087,2),(52167030,426368692,14932198,373445,1,'2008-05-09 19:04:04',3310503087,2),(52167039,426367969,14934527,373445,1,'2008-05-09 19:04:04',3310503087,2),(52167045,426366283,14936534,373445,1,'2008-05-09 19:04:04',3310503087,2),(52167049,426364998,14937819,373445,1,'2008-05-09 19:04:04',3310503087,2),(52167052,426364114,14939907,373445,1,'2008-05-09 19:04:04',3310503087,2),(52167062,426362910,14942477,373445,1,'2008-05-09 19:04:04',3310503429,2),(52167066,426361785,14943360,373445,1,'2008-05-09 19:04:04',3310503429,2),(52167070,426360179,14944324,373445,1,'2008-05-09 19:04:04',3310503429,2),(52167076,426358493,14945127,373445,1,'2008-05-09 19:04:04',3310503429,2),(52167082,426357208,14945689,373445,1,'2008-05-09 19:04:04',3310503428,2),(52167086,426354799,14944645,373445,1,'2008-05-09 19:04:04',3310503428,2),(52167105,426353032,14944484,373445,1,'2008-05-09 19:04:04',3310503428,2),(52167111,426351105,14944725,373445,1,'2008-05-09 19:04:04',3310503428,2),(52167122,426349258,14945930,373445,1,'2008-05-09 19:04:04',3310503428,2),(52167128,426346561,14926721,446582,1,'2008-05-15 01:25:41',3310503086,2),(52167136,426347555,14930060,446582,1,'2008-05-15 01:25:41',3310503086,2),(52167142,426347839,14934678,446582,1,'2008-05-15 01:25:41',3310503086,2),(52167150,426347129,14937165,446582,1,'2008-05-15 01:25:42',3310503086,2),(52167155,426346276,14941783,446582,1,'2008-05-15 01:25:41',3310503428,2),(52167165,426346561,14949314,373445,1,'2008-05-09 19:04:04',3310503428,2),(52167175,426346666,14950600,446582,1,'2008-05-15 01:25:41',3310503428,2),(52167179,426346640,14952527,435967,1,'2007-09-15 21:36:39',3310503428,1),(52167183,426346869,14956007,435967,1,'2007-09-15 21:36:39',3310503428,1),(52167190,426346594,14959213,435967,1,'2007-09-15 21:36:39',3310503428,1),(52167198,426346914,14961732,435967,1,'2007-09-15 21:36:40',3310503428,1),(52167208,426347143,14965762,435967,1,'2007-09-15 21:36:40',3310503428,1),(52167211,426346823,14967686,435967,1,'2007-09-15 21:36:40',3310503428,1),(52167218,426345678,14969930,435967,1,'2007-09-15 21:36:41',3310503428,1),(52167223,426343938,14971945,435967,1,'2007-09-15 21:36:41',3310503428,1),(52167232,426342839,14975059,435967,1,'2007-09-15 21:36:42',3310503428,1),(52167248,426342289,14977532,435967,1,'2007-09-15 21:36:42',3310503428,1),(52167254,426341785,14979089,435967,1,'2007-09-15 21:36:43',3310503428,1),(52167257,426340778,14979868,435967,1,'2007-09-15 21:36:43',3310503428,1),(52167262,426339770,14980738,435967,1,'2007-09-15 21:36:44',3310503428,1),(52167277,426339404,14981608,435967,1,'2007-09-15 21:36:46',3310503428,1),(52167279,426338854,14983760,435967,1,'2007-09-15 21:36:46',3310503428,1),(52167284,426338854,14985088,435967,1,'2007-09-15 21:36:46',3310503428,1),(52167289,426338671,14985913,435967,1,'2007-09-15 21:36:47',3310503428,1),(52167293,426337938,14986371,435967,1,'2007-09-15 21:36:47',3310503428,1),(52167300,426337343,14987241,435967,1,'2007-09-15 21:36:48',3310503428,1),(52167307,426336106,14988065,435967,1,'2007-09-15 21:36:49',3310503428,1),(52167309,426334961,14989577,435967,1,'2007-09-15 21:36:49',3310503428,1),(52167315,426333404,14991592,435967,1,'2007-09-15 21:36:49',3310503428,1),(52167320,426332717,14993149,435967,1,'2007-09-15 21:36:49',3310503428,1),(52167323,426333038,14994752,435967,1,'2007-09-15 21:36:50',3310503428,1),(52167329,426333862,14996904,435967,1,'2007-09-15 21:36:50',3310503430,1),(52167336,426333771,14999789,435967,1,'2007-09-15 21:36:50',3310503430,1),(52167345,426333725,15000888,435967,1,'2007-09-15 21:36:51',3310503430,1),(52167349,426333725,15002766,435967,1,'2007-09-15 21:36:51',3310503430,1),(52167353,426333725,15004048,435967,1,'2007-09-15 21:36:51',3310503430,1),(52167358,426333450,15004598,435967,1,'2007-09-15 21:36:52',3310503430,1),(52167363,426332855,15004964,435967,1,'2007-09-15 21:36:52',3310503430,1),(52167368,426332030,15004964,435967,1,'2007-09-15 21:36:52',3310503430,1),(52167372,426331252,15004827,435967,1,'2007-09-15 21:36:52',3310503430,1),(52167380,426330519,15005010,435967,1,'2007-09-15 21:36:52',3310503427,1),(52167387,426329786,15005514,435967,1,'2007-09-15 21:36:53',3310503427,1),(52167389,426328916,15006613,435967,1,'2007-09-15 21:36:53',3310503427,1),(52167390,426328596,15008124,435967,1,'2007-09-15 21:36:53',3310503427,1),(52167393,426328458,15010964,435967,1,'2007-09-15 21:36:54',3310503427,1),(52167396,426327909,15013483,435967,1,'2007-09-15 21:36:54',3310503427,1),(52167398,426327359,15016001,435967,1,'2007-09-15 21:36:54',3310503427,1),(52167402,426326260,15017971,435967,1,'2007-09-15 21:36:55',3310503427,1),(52167406,426325756,15021085,435967,1,'2007-09-15 21:36:55',3310503427,1),(52167421,426326077,15023787,435967,1,'2007-09-15 21:36:57',3310503427,1),(52167425,426326855,15026443,435967,1,'2007-09-15 21:36:58',3310503427,1),(52167428,426327588,15028733,435967,1,'2007-09-15 21:36:58',3310503427,1),(52167430,426327405,15030657,435967,1,'2007-09-15 21:36:58',3310503427,1),(52167433,426327222,15032443,435967,1,'2007-09-15 21:36:58',3310503427,1),(52167436,426326901,15035465,435967,1,'2007-09-15 21:36:58',3310503427,1),(52167438,426326718,15038946,435967,1,'2007-09-15 21:36:59',3310503427,1),(52167439,426326617,15042242,435967,1,'2007-09-15 21:36:59',3310503427,1),(52167444,426326617,15043829,435967,1,'2007-09-15 21:37:00',3310503427,1),(52167446,426325683,15045230,435967,1,'2007-09-15 21:37:00',3310503427,1),(52167453,426324983,15045976,435967,1,'2007-09-15 21:37:01',3310503427,1),(52167457,426325030,15046677,435967,1,'2007-09-15 21:37:01',3310503427,1),(52167470,426325450,15048030,435967,1,'2007-09-15 21:37:03',3310503427,1),(52167473,426327503,15049804,435967,1,'2007-09-15 21:37:03',3310503427,1),(52167477,426329044,15051251,435967,1,'2007-09-15 21:37:03',3310503427,1),(52167484,426329931,15052371,435967,1,'2007-09-15 21:37:04',3310503433,1),(52167487,426330024,15054005,435967,1,'2007-09-15 21:37:04',3310503433,1),(52167490,426329604,15055732,435967,1,'2007-09-15 21:37:04',3310503433,1),(52167496,426328810,15057552,435967,1,'2007-09-15 21:37:04',3310503433,1),(52167500,426328577,15059793,435967,1,'2007-09-15 21:37:04',3310503433,1),(52167503,426328297,15062780,435967,1,'2007-09-15 21:37:04',3310503433,1),(52167507,426328390,15066421,435967,1,'2007-09-15 21:37:05',3310503433,1),(52167511,426329137,15070389,435967,1,'2007-09-15 21:37:05',3310503433,1),(52167513,426329837,15073003,435967,1,'2007-09-15 21:37:05',3310503433,1),(52167517,426330211,15074496,435967,1,'2007-09-15 21:37:05',3310503433,1),(52167521,426329604,15076410,435967,1,'2007-09-15 21:37:06',3310503433,1),(52167525,426329511,15078837,435967,1,'2007-09-15 21:37:06',3310503433,1),(52167528,426329184,15080658,435967,1,'2007-09-15 21:37:06',3310503433,1),(52167530,426328530,15081871,435967,1,'2007-09-15 21:37:07',3310503433,1),(52167534,426327597,15082851,435967,1,'2007-09-15 21:37:07',3310503433,1),(52167535,426327177,15084345,435967,1,'2007-09-15 21:37:07',3310503433,1),(52167538,426326757,15086259,435967,1,'2007-09-15 21:37:07',3310503433,1),(52167540,426326290,15087846,435967,1,'2007-09-15 21:37:07',3310503433,1),(52167544,426326243,15090553,435967,1,'2007-09-15 21:37:07',3310503433,1),(52167547,426325636,15092093,435967,1,'2007-09-15 21:37:07',3310503433,1),(52167551,426325076,15093260,435967,1,'2007-09-15 21:37:07',3310503433,1),(52167557,426325076,15094707,435967,1,'2007-09-15 21:37:08',3310503433,1),(52167562,426324236,15095921,435967,1,'2007-09-15 21:37:08',3310503433,1),(52167568,426323116,15098068,435967,1,'2007-09-15 21:37:08',3310503433,1),(52167574,426322416,15101616,435967,1,'2007-09-15 21:37:09',3310503433,1),(52167579,426321669,15104556,435967,1,'2007-09-15 21:37:09',3310503433,1),(52167581,426320404,15107374,435967,1,'2007-09-15 21:37:09',3310503435,1),(52167585,426318081,15112579,435967,1,'2007-09-15 21:37:09',3310503435,1),(52167590,426316877,15115031,435967,1,'2007-09-15 21:37:10',3310503435,1),(52167593,426315973,15117999,435967,1,'2007-09-15 21:37:10',3310503435,1),(52167599,426314382,15124194,435967,1,'2007-09-15 21:37:10',3310503435,1),(52167604,426314167,15126990,435967,1,'2007-09-15 21:37:10',3310503435,1),(52167607,426314210,15130173,435967,1,'2007-09-15 21:37:10',3310503435,1),(52167614,426313995,15133056,435967,1,'2007-09-15 21:37:11',3310503435,1),(52167615,426313779,15137271,435967,1,'2007-09-15 21:37:11',3310503435,1),(52167619,426313693,15142261,435967,1,'2007-09-15 21:37:11',3310503435,1),(52167622,426313392,15146090,435967,1,'2007-09-15 21:37:11',3310503435,1),(52167627,426312962,15147897,435967,1,'2007-09-15 21:37:12',3310503435,1),(52167632,426312231,15152069,435967,1,'2007-09-15 21:37:12',3310503435,1),(52167636,426310897,15157188,435967,1,'2007-09-15 21:37:12',3310503435,1),(52167641,426310424,15159726,435967,1,'2007-09-15 21:37:12',3310503435,1),(52167645,426309994,15162351,435967,1,'2007-09-15 21:37:12',3310503457,1),(52167650,426308574,15166566,435967,1,'2007-09-15 21:37:12',3310503457,1),(52167655,426305821,15170739,435967,1,'2007-09-15 21:37:13',3310503457,1),(52167660,426304445,15172460,435967,1,'2007-09-15 21:37:13',3310503457,1),(52167664,426303756,15173621,435967,1,'2007-09-15 21:37:13',3310503457,1),(52167666,426303842,15175772,435967,1,'2007-09-15 21:37:13',3310503457,1),(52167669,426303885,15177622,435967,1,'2007-09-15 21:37:13',3310503457,1),(52167673,426303670,15180289,435967,1,'2007-09-15 21:37:14',3310503457,1),(52167677,426303068,15183687,435967,1,'2007-09-15 21:37:14',3310503456,1),(52167683,426302294,15187129,435967,1,'2007-09-15 21:37:14',3310503456,1),(52167687,426301562,15189064,435967,1,'2007-09-15 21:37:14',3310503456,1),(52167691,426300917,15190828,435967,1,'2007-09-15 21:37:15',3310503456,1),(52167695,426300229,15191818,435967,1,'2007-09-15 21:37:15',3310503456,1),(52167700,426299756,15193065,435967,1,'2007-09-15 21:37:15',3310503456,1),(52167702,426299067,15193409,435967,1,'2007-09-15 21:37:15',3310503456,1),(52167707,426298379,15194485,435967,1,'2007-09-15 21:37:16',3310503456,1),(52167710,426297605,15195990,435967,1,'2007-09-15 21:37:16',3310503456,1),(52167713,426296185,15196377,435967,1,'2007-09-15 21:37:16',3310503456,1),(52167714,426294766,15197453,435967,1,'2007-09-15 21:37:16',3310503456,1),(52167718,426294163,15198356,435967,1,'2007-09-15 21:37:17',3310503456,1),(52167721,426293303,15200249,435967,1,'2007-09-15 21:37:17',3310503456,1),(52167725,426293518,15202099,435967,1,'2007-09-15 21:37:17',3310503456,1),(52167727,426293733,15204121,435967,1,'2007-09-15 21:37:17',3310503456,1),(52167732,426293217,15206616,435967,1,'2007-09-15 21:37:18',3310503456,1),(52167736,426292443,15208724,435967,1,'2007-09-15 21:37:18',3310503456,1),(52167740,426291496,15210100,435967,1,'2007-09-15 21:37:18',3310503456,1),(52167744,426290120,15211219,435967,1,'2007-09-15 21:37:18',3310503456,1),(52167747,426288958,15212165,435967,1,'2007-09-15 21:37:19',3310503456,1),(52167752,426288270,15213455,435967,1,'2007-09-15 21:37:19',3310503456,1),(52167756,426287410,15215649,435967,1,'2007-09-15 21:37:19',3310503456,1),(52167758,426286807,15217886,435967,1,'2007-09-15 21:37:19',3310503458,1),(52167761,426286033,15219306,435967,1,'2007-09-15 21:37:20',3310503458,1),(52167765,426284743,15220381,435967,1,'2007-09-15 21:37:20',3310503458,1),(52167769,426282936,15221973,435967,1,'2007-09-15 21:37:20',3310503458,1),(52167773,426280484,15224038,435967,1,'2007-09-15 21:37:21',3310503458,1),(52167777,426278376,15226146,435967,1,'2007-09-15 21:37:21',3310503458,1),(52167781,426277817,15227436,435967,1,'2007-09-15 21:37:21',3310503458,1),(52167784,426276913,15228770,435967,1,'2007-09-15 21:37:21',3310503458,1),(52167787,426275451,15230103,435967,1,'2007-09-15 21:37:21',3310502775,1),(52167790,426273988,15231222,435967,1,'2007-09-15 21:37:22',3310502775,1),(52167795,426272440,15231996,435967,1,'2007-09-15 21:37:22',3310502775,1),(52167796,426271235,15231824,435967,1,'2007-09-15 21:37:22',3310502775,1),(52167799,426269772,15231179,435967,1,'2007-09-15 21:37:22',3310502775,1),(52167802,426268783,15231007,435967,1,'2007-09-15 21:37:23',3310502775,1),(52167805,426267794,15230706,435967,1,'2007-09-15 21:37:23',3310502775,1),(52167807,426266073,15229329,435967,1,'2007-09-15 21:37:23',3310502775,1),(52167811,426265256,15229587,435967,1,'2007-09-15 21:37:24',3310502775,1),(52167812,426264739,15229802,435967,1,'2007-09-15 21:37:24',3310502775,1),(52167815,426264051,15230275,435967,1,'2007-09-15 21:37:24',3310502775,1),(52167820,426263449,15230404,435967,1,'2007-09-15 21:37:25',3310502775,1),(52167825,426261986,15229845,435967,1,'2007-09-15 21:37:25',3310502775,1),(52167828,426261513,15229888,435967,1,'2007-09-15 21:37:26',3310502775,1),(52167834,426260868,15230017,435967,1,'2007-09-15 21:37:26',3310502775,1),(52167836,426260567,15231308,435967,1,'2007-09-15 21:37:27',3310502775,1),(52167839,426260093,15231996,435967,1,'2007-09-15 21:37:27',3310502775,1),(52167843,426259276,15233889,435967,1,'2007-09-15 21:37:27',3310502775,1),(52167847,426258416,15235265,435967,1,'2007-09-15 21:37:27',3310502775,1),(52167849,426256652,15237287,435967,1,'2007-09-15 21:37:28',3310502775,1),(52167853,426253383,15239180,435967,1,'2007-09-15 21:37:28',3310502775,1),(52167859,426247661,15244428,435967,1,'2007-09-15 21:37:28',3310502774,1),(52167860,426244994,15246794,435967,1,'2007-09-15 21:37:29',3310502774,1),(52167867,426243446,15248042,435967,1,'2007-09-15 21:37:29',3310502774,1),(52167872,426241897,15248472,435967,1,'2007-09-15 21:37:30',3310502774,1),(52167883,426240736,15248515,435967,1,'2007-09-15 21:37:32',3310502774,1),(52167887,426239015,15248214,435967,1,'2007-09-15 21:37:32',3310502774,1),(52167891,426237208,15247740,435967,1,'2007-09-15 21:37:32',3310502774,1),(52167896,426236219,15246665,435967,1,'2007-09-15 21:37:33',3310502774,1),(52167900,426235315,15245547,435967,1,'2007-09-15 21:37:33',3310502774,1),(52167906,426234498,15245245,435967,1,'2007-09-15 21:37:33',3310502774,1),(52167911,426233681,15245633,435967,1,'2007-09-15 21:37:34',3310502774,1),(52167916,426233423,15246622,435967,1,'2007-09-15 21:37:34',3310502774,1),(52167922,426233250,15247353,435967,1,'2007-09-15 21:37:34',3310502774,1),(52167924,426232433,15249289,435967,1,'2007-09-15 21:37:35',3310502774,1),(52167927,426231014,15250881,435967,1,'2007-09-15 21:37:35',3310502774,1),(52167930,426230368,15251096,435967,1,'2007-09-15 21:37:35',3310502774,1),(52167932,426229035,15252042,435967,1,'2007-09-15 21:37:35',3310502774,1),(52167937,426228217,15253247,435967,1,'2007-09-15 21:37:35',3310502774,1),(52167944,426226411,15254967,435967,1,'2007-09-15 21:37:36',3310502774,1),(52167948,426225292,15256430,435967,1,'2007-09-15 21:37:36',3310502774,1),(52167953,426224002,15257161,435967,1,'2007-09-15 21:37:36',3310502774,1),(52167958,426223098,15258366,435967,1,'2007-09-15 21:37:37',3310502774,1),(52167963,426221636,15259484,435967,1,'2007-09-15 21:37:37',3310502774,1),(52167967,426220990,15261377,435967,1,'2007-09-15 21:37:37',3310502771,1),(52167969,426219743,15263958,435967,1,'2007-09-15 21:37:37',3310502771,1),(52167970,426218323,15267916,435967,1,'2007-09-15 21:37:37',3310502771,1),(52167973,426217764,15268776,435967,1,'2007-09-15 21:37:38',3310502771,1),(52167977,426216861,15269981,435967,1,'2007-09-15 21:37:38',3310502771,1),(52167981,426216172,15270755,435967,1,'2007-09-15 21:37:38',3310502771,1),(52167986,426215312,15272175,435967,1,'2007-09-15 21:37:39',3310502777,1),(52167991,426214753,15274153,435967,1,'2007-09-15 21:37:39',3310502777,1),(52167995,426213979,15275530,435967,1,'2007-09-15 21:37:40',3310502777,1),(52168000,426213893,15277552,435967,1,'2007-09-15 21:37:40',3310502777,1),(52168004,426213720,15279961,435967,1,'2007-09-15 21:37:40',3310502777,1),(52168009,426213247,15281337,435967,1,'2007-09-15 21:37:40',3310502777,1),(52168013,426212602,15283359,435967,1,'2007-09-15 21:37:40',3310502777,1),(52168015,426211570,15285252,435967,1,'2007-09-15 21:37:41',3310502777,1),(52168018,426211225,15288392,435967,1,'2007-09-15 21:37:41',3310502777,1),(52168021,426211053,15289941,435967,1,'2007-09-15 21:37:41',3310502777,1),(52168025,426211139,15292307,435967,1,'2007-09-15 21:37:41',3310502777,1),(52168028,426211268,15294845,435967,1,'2007-09-15 21:37:41',3310502777,1),(52168033,426211268,15297426,435967,1,'2007-09-15 21:37:42',3310502777,1),(52168034,426211354,15301082,435967,1,'2007-09-15 21:37:42',3310502777,1),(52168038,426210451,15306890,435967,1,'2007-09-15 21:37:42',3310502777,1),(52168039,426210236,15310073,435967,1,'2007-09-15 21:37:42',3310502777,1),(52168043,426210064,15311880,435967,1,'2007-09-15 21:37:43',3310502777,1),(52168046,426210322,15313557,435967,1,'2007-09-15 21:37:43',3310502777,1),(52168049,426210881,15315751,435967,1,'2007-09-15 21:37:44',3310502777,1),(52168053,426211010,15316870,435967,1,'2007-09-15 21:37:44',3310502777,1),(52168055,426210924,15318720,435967,1,'2007-09-15 21:37:44',3310502777,1),(52168056,426210365,15320870,435967,1,'2007-09-15 21:37:44',3310502777,1),(52168060,426209677,15322849,435967,1,'2007-09-15 21:37:44',3310502777,1),(52168063,426208687,15325947,435967,1,'2007-09-15 21:37:45',3310502777,1),(52168065,426207612,15328226,435967,1,'2007-09-15 21:37:45',3310502779,1),(52168070,426206537,15329689,435967,1,'2007-09-15 21:37:45',3310502779,1),(52168071,426204988,15331324,435967,1,'2007-09-15 21:37:45',3310502779,1),(52168073,426204558,15332227,435967,1,'2007-09-15 21:37:45',3310502779,1),(52168077,426202665,15337690,435967,1,'2007-09-15 21:37:46',3310502779,1),(52168080,426200416,15340547,435967,1,'2007-09-15 21:37:46',3310502779,1),(52168084,426199310,15342700,435967,1,'2007-09-15 21:37:46',3310502779,1),(52168086,426198088,15344679,435967,1,'2007-09-15 21:37:46',3310502779,1),(52168090,426194772,15349275,435967,1,'2007-09-15 21:37:46',3310502779,1),(52168094,426191979,15352767,435967,1,'2007-09-15 21:37:47',3310502778,1),(52168096,426188895,15358178,435967,1,'2007-09-15 21:37:47',3310502778,1),(52168100,426187906,15359225,435967,1,'2007-09-15 21:37:47',3310502778,1),(52168101,426185695,15358760,435967,1,'2007-09-15 21:37:47',3310502778,1),(52168104,426184473,15359109,435967,1,'2007-09-15 21:37:48',3310502778,1),(52168108,426182902,15361145,435967,1,'2007-09-15 21:37:48',3310502778,1),(52168111,426178829,15366382,435967,1,'2007-09-15 21:37:48',3310502778,1),(52168115,426176618,15370921,435967,1,'2007-09-15 21:37:48',3310502778,1),(52168118,426175221,15373423,435967,1,'2007-09-15 21:37:49',3310502778,1),(52168121,426173708,15375866,435967,1,'2007-09-15 21:37:49',3310502778,1),(52168124,426171032,15380696,435967,1,'2007-09-15 21:37:49',3310502778,1),(52168127,426168879,15382209,435967,1,'2007-09-15 21:37:49',3310502864,1),(52168130,426166551,15382150,435967,1,'2007-09-15 21:37:50',3310502864,1),(52168135,426161664,15381336,435967,1,'2007-09-15 21:37:50',3310502853,1),(52168138,426158173,15380987,435967,1,'2007-09-15 21:37:50',3310502767,1),(52168143,426154682,15381394,435967,1,'2007-09-15 21:37:51',3310502853,1),(52168146,426148339,15381510,435967,1,'2007-09-15 21:37:51',3310502853,1),(52168149,426146536,15381452,435967,1,'2007-09-15 21:37:51',3310502853,1),(52168152,426144383,15380987,435967,1,'2007-09-15 21:37:51',3310502767,1),(52168156,426141590,15379707,435967,1,'2007-09-15 21:37:51',3310502767,1),(52168160,426135655,15377496,435967,1,'2007-09-15 21:37:52',3310502766,1),(52168163,426133171,15376614,435967,1,'2007-09-15 21:37:52',3310502766,1),(52168167,426132027,15376406,435967,1,'2007-09-15 21:37:52',3310502766,1),(52168171,426130468,15376926,435967,1,'2007-09-15 21:37:53',3310502766,1),(52168175,426128752,15377862,435967,1,'2007-09-15 21:37:53',3310502766,1),(52168178,426126360,15379474,435967,1,'2007-09-15 21:37:53',3310502766,1),(52168181,426123969,15380825,435967,1,'2007-09-15 21:37:53',3310502766,1),(52168186,426121265,15382229,435967,1,'2007-09-15 21:37:54',3310502852,1),(52168188,426117626,15384829,435967,1,'2007-09-15 21:37:54',3310502852,1),(52168191,426115234,15387324,435967,1,'2007-09-15 21:37:54',3310502852,1),(52168195,426113414,15388104,435967,1,'2007-09-15 21:37:55',3310502852,1),(52168198,426110711,15387116,435967,1,'2007-09-15 21:37:55',3310502849,1),(52168203,426109151,15386232,435967,1,'2007-09-15 21:37:56',3310502849,1),(52168207,426104004,15383373,435967,1,'2007-09-15 21:37:56',3310502849,1),(52168214,426101560,15382437,435967,1,'2007-09-15 21:37:57',3310502849,1),(52168217,426100001,15381553,435967,1,'2007-09-15 21:37:57',3310502849,1),(52168220,426097349,15381345,435967,1,'2007-09-15 21:37:57',3310502849,1),(52168225,426095997,15381137,435967,1,'2007-09-15 21:37:57',3310502849,1),(52168228,426085438,15373516,206510,1,'2008-12-06 19:38:08',3310502763,4),(52168231,426093922,15380702,435967,1,'2007-09-15 21:37:58',3310502763,1),(52168235,426092922,15379288,435967,1,'2007-09-15 21:37:58',3310502763,1),(52168237,426091749,15377082,435967,1,'2007-09-15 21:37:59',3310502763,1),(52168240,426090853,15375841,435967,1,'2007-09-15 21:37:59',3310502763,1),(52168243,426089026,15374565,435967,1,'2007-09-15 21:37:59',3310502763,1),(52168247,426087440,15373358,435967,1,'2007-09-15 21:38:00',3310502763,1),(52168248,426085819,15371565,435967,1,'2007-09-15 21:38:00',3310502763,1),(52168249,426084750,15370290,435967,1,'2007-09-15 21:38:00',3310502763,1),(52168251,426083992,15368393,435967,1,'2007-09-15 21:38:00',3310502763,1),(52168254,426083164,15366704,435967,1,'2007-09-15 21:38:00',3310502762,1),(52168256,426081958,15365531,435967,1,'2007-09-15 21:38:00',3310502762,1),(52168258,426080406,15365911,435967,1,'2007-09-15 21:38:01',3310502762,1),(52168261,426078855,15366256,435967,1,'2007-09-15 21:38:01',3310502762,1),(52168265,426077234,15366807,435967,1,'2007-09-15 21:38:01',3310502762,1),(52168270,426074717,15367049,435967,1,'2007-09-15 21:38:02',3310502762,1),(52168274,426073545,15367428,435967,1,'2007-09-15 21:38:02',3310502762,1),(52168278,426071855,15368910,435967,1,'2007-09-15 21:38:02',3310502762,1),(52168283,426069736,15370321,435967,1,'2007-09-15 21:38:03',3310502762,1),(52168286,426067806,15371036,435967,1,'2007-09-15 21:38:03',3310502762,1),(52168287,426066447,15370893,435967,1,'2007-09-15 21:38:03',3310502762,1),(52168291,426065160,15370250,435967,1,'2007-09-15 21:38:03',3310502762,1),(52168296,426064160,15368748,435967,1,'2007-09-15 21:38:04',3310502762,1),(52168298,426062515,15367032,435967,1,'2007-09-15 21:38:04',3310502762,1),(52168302,426061014,15364959,435967,1,'2007-09-15 21:38:04',3310502762,1),(52168305,426058583,15362814,435967,1,'2007-09-15 21:38:04',3310502762,1),(52168308,426055866,15360741,435967,1,'2007-09-15 21:38:05',3310502719,1),(52168309,426054150,15358811,435967,1,'2007-09-15 21:38:05',3310502719,1),(52168314,426053006,15356809,435967,1,'2007-09-15 21:38:05',3310502719,1),(52168316,426051722,15355729,435967,1,'2007-09-15 21:38:05',3310502719,1),(52168318,426050257,15354411,435967,1,'2007-09-15 21:38:05',3310502719,1),(52168321,426048759,15353361,435967,1,'2007-09-15 21:38:06',3310502719,1),(52168325,426046573,15353179,435967,1,'2007-09-15 21:38:06',3310502719,1),(52168326,426044326,15354333,435967,1,'2007-09-15 21:38:06',3310502719,1),(52168329,426041958,15355122,435967,1,'2007-09-15 21:38:06',3310502719,1),(52168333,426039468,15355972,435967,1,'2007-09-15 21:38:06',3310502719,1),(52168336,426037403,15356154,435967,1,'2007-09-15 21:38:07',3310502719,1),(52168338,426035035,15355304,435967,1,'2007-09-15 21:38:07',3310502719,1),(52168342,426032606,15353726,435967,1,'2007-09-15 21:38:07',3310502719,1),(52168346,426028598,15349414,435967,1,'2007-09-15 21:38:08',3310502718,1),(52168347,426025027,15344952,435967,1,'2007-09-15 21:38:08',3310502718,1),(52168348,426022953,15343175,435967,1,'2007-09-15 21:38:08',3310502718,1),(52168350,426021546,15342805,435967,1,'2007-09-15 21:38:08',3310502718,1),(52168356,426019176,15343249,435967,1,'2007-09-15 21:38:08',3310502718,1),(52168360,426016525,15342849,435967,1,'2007-09-15 21:38:09',3310502718,1),(52168362,426014575,15342094,435967,1,'2007-09-15 21:38:09',3310502718,1),(52168414,426013128,15340898,435967,1,'2007-09-15 21:38:14',3310502718,1),(52168416,426011178,15337816,435967,1,'2007-09-15 21:38:14',3310502718,1),(52168419,426009605,15335803,435967,1,'2007-09-15 21:38:14',3310502718,1),(52168423,426007403,15334230,435967,1,'2007-09-15 21:38:14',3310502718,1),(52168427,426006082,15332595,435967,1,'2007-09-15 21:38:15',3310502718,1),(52168429,426005579,15330456,435967,1,'2007-09-15 21:38:15',3310502718,1),(52168432,426004887,15326682,435967,1,'2007-09-15 21:38:16',3310502718,1),(52168436,426001679,15322844,435967,1,'2007-09-15 21:38:16',3310502716,1),(52168440,426000106,15320706,435967,1,'2007-09-15 21:38:16',3310502713,1),(52168442,425998533,15319196,435967,1,'2007-09-15 21:38:16',3310502713,1),(52168445,425997527,15318693,435967,1,'2007-09-15 21:38:16',3310502713,1),(52168447,425995703,15319322,435967,1,'2007-09-15 21:38:16',3310502713,1),(52168452,425994445,15319070,435967,1,'2007-09-15 21:38:17',3310502713,1),(52168455,425993816,15318378,435967,1,'2007-09-15 21:38:17',3310502713,1),(52168459,425993375,15316742,435967,1,'2007-09-15 21:38:17',3310502713,1),(52168461,425992494,15314855,435967,1,'2007-09-15 21:38:17',3310502713,1),(52168464,425991111,15313283,435967,1,'2007-09-15 21:38:17',3310502713,1),(52168468,425988594,15311333,435967,1,'2007-09-15 21:38:18',3310502713,1),(52168470,425985197,15309886,435967,1,'2007-09-15 21:38:18',3310502713,1),(52168474,425981863,15308628,435967,1,'2007-09-15 21:38:18',3310502713,1),(52168476,425979284,15306992,435967,1,'2007-09-15 21:38:18',3310502713,1),(52168479,425977586,15305042,435967,1,'2007-09-15 21:38:19',3310502713,1),(52168481,425972553,15297367,435967,1,'2007-09-15 21:38:19',3310502712,1),(52168484,425968968,15288749,435967,1,'2007-09-15 21:38:19',3310502712,1),(52168486,425967835,15286170,435967,1,'2007-09-15 21:38:19',3310502712,1),(52168489,425966577,15284723,435967,1,'2007-09-15 21:38:19',3310502712,1),(52168492,425964879,15283402,435967,1,'2007-09-15 21:38:19',3310502712,1),(52168495,425963117,15283088,435967,1,'2007-09-15 21:38:19',3310502712,1),(52168497,425961167,15282773,435967,1,'2007-09-15 21:38:20',3310502712,1),(52168502,425958588,15282773,435967,1,'2007-09-15 21:38:20',3310502712,1),(52168506,425957078,15282396,435967,1,'2007-09-15 21:38:20',3310502712,1),(52168509,425955757,15281955,435967,1,'2007-09-15 21:38:20',3310502712,1),(52168512,425953996,15281138,435967,1,'2007-09-15 21:38:20',3310502712,1),(52168516,425953052,15280194,435967,1,'2007-09-15 21:38:21',3310502712,1),(52168519,425952738,15278810,435967,1,'2007-09-15 21:38:21',3310502712,1),(52168521,425951668,15277175,435967,1,'2007-09-15 21:38:21',3310502712,1),(52168523,425950033,15275854,435967,1,'2007-09-15 21:38:21',3310502712,1),(52168529,425948272,15275413,435967,1,'2007-09-15 21:38:21',3310502712,1),(52168531,425944812,15273652,435967,1,'2007-09-15 21:38:21',3310502701,1),(52168534,425943176,15272771,435967,1,'2007-09-15 21:38:22',3310502701,1),(52168537,425940786,15272520,435967,1,'2007-09-15 21:38:22',3310502701,1),(52168541,425938521,15272268,435967,1,'2007-09-15 21:38:22',3310502701,1),(52168543,425936131,15270947,435967,1,'2007-09-15 21:38:22',3310502695,1),(52168547,425933614,15268682,435967,1,'2007-09-15 21:38:22',3310502695,1),(52168549,425931035,15267172,435967,1,'2007-09-15 21:38:22',3310502695,1),(52168553,425928330,15266481,435967,1,'2007-09-15 21:38:23',3310502695,1),(52168555,425926129,15266229,435967,1,'2007-09-15 21:38:23',3310502695,1),(52168558,425924304,15266984,435967,1,'2007-09-15 21:38:23',3310502695,1),(52168561,425922228,15268745,435967,1,'2007-09-15 21:38:23',3310502695,1),(52168565,425920782,15270003,435967,1,'2007-09-15 21:38:23',3310502695,1),(52168568,425919586,15269060,435967,1,'2007-09-15 21:38:24',3310502695,1),(52168569,425917699,15266669,435967,1,'2007-09-15 21:38:24',3310502694,1),(52168572,425915686,15264090,435967,1,'2007-09-15 21:38:24',3310502694,1),(52168576,425913799,15262077,435967,1,'2007-09-15 21:38:24',3310502694,1),(52168579,425912510,15259992,435967,1,'2007-09-15 21:38:24',3310502694,1),(52168582,425911461,15257943,435967,1,'2007-09-15 21:38:25',3310502694,1),(52168586,425910413,15255370,435967,1,'2007-09-15 21:38:25',3310502694,1),(52168589,425908793,15252177,435967,1,'2007-09-15 21:38:25',3310502694,1),(52168592,425907507,15250986,435967,1,'2007-09-15 21:38:25',3310502694,1),(52168595,425906125,15249699,435967,1,'2007-09-15 21:38:25',3310502694,1),(52168596,425903074,15248155,435967,1,'2007-09-15 21:38:25',3310502694,1),(52168600,425898160,15245335,435967,1,'2007-09-15 21:38:26',3310502694,1),(52168604,425895904,15243885,435967,1,'2007-09-15 21:38:26',3310502694,1),(52168607,425893729,15243160,435967,1,'2007-09-15 21:38:26',3310502694,1),(52168612,425890507,15242193,435967,1,'2007-09-15 21:38:27',3310502691,1),(52168613,425888251,15241468,435967,1,'2007-09-15 21:38:27',3310502691,1),(52168616,425886801,15240502,435967,1,'2007-09-15 21:38:27',3310502691,1),(52168622,425885512,15238488,435967,1,'2007-09-15 21:38:27',3310502691,1),(52168626,425884464,15237199,435967,1,'2007-09-15 21:38:27',3310502691,1),(52168631,425883739,15235990,435967,1,'2007-09-15 21:38:28',3310502691,1),(52168635,425882853,15234782,435967,1,'2007-09-15 21:38:28',3310502691,1),(52168638,425880839,15234298,435967,1,'2007-09-15 21:38:28',3310502691,1),(52168640,425878986,15233654,435967,1,'2007-09-15 21:38:28',3310502691,1),(52168644,425877617,15232929,435967,1,'2007-09-15 21:38:28',3310502691,1),(52168648,425876569,15231317,435967,1,'2007-09-15 21:38:29',3310502691,1),(52168654,425875039,15230028,435967,1,'2007-09-15 21:38:29',3310502691,1),(52168657,425871091,15229384,435967,1,'2007-09-15 21:38:29',3310502691,1),(52168660,425865049,15228739,435967,1,'2007-09-15 21:38:30',3310502691,1),(52168663,425863518,15228337,435967,1,'2007-09-15 21:38:30',3310502690,1),(52168665,425862874,15227209,435967,1,'2007-09-15 21:38:30',3310502690,1),(52168668,425861262,15224067,435967,1,'2007-09-15 21:38:30',3310502690,1),(52168671,425859329,15222375,435967,1,'2007-09-15 21:38:30',3310502690,1),(52168674,425857234,15220522,435967,1,'2007-09-15 21:38:30',3310502690,1),(52168676,425854495,15219797,435967,1,'2007-09-15 21:38:31',3310502690,1),(52168679,425851937,15218315,435967,1,'2007-09-15 21:38:31',3310502690,1),(52168682,425848482,15216923,435967,1,'2007-09-15 21:38:31',3310502690,1),(52168686,425844512,15214293,435967,1,'2007-09-15 21:38:31',3310502688,1),(52168687,425841728,15212591,435967,1,'2007-09-15 21:38:32',3310502688,1),(52168690,425840026,15211767,435967,1,'2007-09-15 21:38:32',3310502688,1),(52168693,425838170,15210942,435967,1,'2007-09-15 21:38:32',3310502688,1),(52168695,425836004,15210632,435967,1,'2007-09-15 21:38:32',3310502517,1),(52168698,425833633,15210632,435967,1,'2007-09-15 21:38:33',3310502517,1),(52168700,425831313,15210581,435967,1,'2007-09-15 21:38:33',3310502517,1),(52168702,425828631,15209653,435967,1,'2007-09-15 21:38:33',3310502517,1),(52168703,425826981,15208518,435967,1,'2007-09-15 21:38:33',3310502517,1),(52168705,425825538,15207023,435967,1,'2007-09-15 21:38:33',3310502517,1),(52168708,425823408,15206122,19873,1,'2008-06-02 18:30:23',3310502517,2),(52168710,425821386,15205092,19873,1,'2008-06-02 18:30:23',3310502517,2),(52168712,425819490,15204062,19873,1,'2008-06-02 18:30:23',3310502517,2),(52168714,425816309,15203104,435967,1,'2007-09-15 21:38:34',3310502517,1),(52168717,425814762,15202950,435967,1,'2007-09-15 21:38:34',3310502517,1),(52168720,425812545,15202898,435967,1,'2007-09-15 21:38:35',3310502517,1),(52168722,425810792,15202640,435967,1,'2007-09-15 21:38:35',3310502517,1),(52168725,425808575,15201455,435967,1,'2007-09-15 21:38:35',3310502516,1),(52168727,425805790,15199392,435967,1,'2007-09-15 21:38:35',3310502516,1),(52168729,425802748,15196608,435967,1,'2007-09-15 21:38:36',3310502516,1),(52168732,425800634,15194906,435967,1,'2007-09-15 21:38:36',3310502516,1),(52168734,425798056,15193721,435967,1,'2007-09-15 21:38:36',3310502516,1),(52168736,425795736,15192792,435967,1,'2007-09-15 21:38:36',3310502516,1),(52168739,425793261,15192689,435967,1,'2007-09-15 21:38:36',3310502516,1),(52168741,425791818,15193205,435967,1,'2007-09-15 21:38:36',3310502516,1),(52168744,425789652,15193927,435967,1,'2007-09-15 21:38:36',3310502516,1),(52168745,425786765,15193617,435967,1,'2007-09-15 21:38:37',3310502516,1),(52168747,425784702,15191864,435967,1,'2007-09-15 21:38:37',3310502516,1),(52168750,425783568,15190421,435967,1,'2007-09-15 21:38:37',3310502516,1),(52168770,425782640,15188668,435967,1,'2007-09-15 21:38:39',3310502516,1),(52168772,425781299,15185316,435967,1,'2007-09-15 21:38:39',3310502513,1),(52168773,425780113,15182532,435967,1,'2007-09-15 21:38:39',3310502513,1),(52168774,425779154,15180712,498434,1,'2008-05-22 17:13:55',3310502513,2),(52168777,425777587,15179129,435967,1,'2007-09-15 21:38:40',3310502513,1),(52168779,425775267,15176706,435967,1,'2007-09-15 21:38:40',3310502513,1),(52168782,425773978,15175881,435967,1,'2007-09-15 21:38:40',3310502513,1),(52168786,425771142,15176448,435967,1,'2007-09-15 21:38:40',3310502513,1),(52168788,425770369,15177582,435967,1,'2007-09-15 21:38:41',3310502513,1),(52168789,425768873,15181243,435967,1,'2007-09-15 21:38:41',3310502513,1),(52168790,425768461,15183305,435967,1,'2007-09-15 21:38:41',3310502513,1),(52168794,425767327,15184749,435967,1,'2007-09-15 21:38:41',3310502513,1),(52168796,425765780,15186915,435967,1,'2007-09-15 21:38:41',3310502513,1),(52168799,425763717,15187894,435967,1,'2007-09-15 21:38:41',3310502513,1),(52168802,425761810,15188410,435967,1,'2007-09-15 21:38:42',3310502513,1),(52168805,425759541,15187894,435967,1,'2007-09-15 21:38:42',3310502513,1),(52168808,425757736,15186657,435967,1,'2007-09-15 21:38:42',3310502513,1),(52168810,425755004,15184749,435967,1,'2007-09-15 21:38:42',3310502513,1),(52168813,425752735,15183099,435967,1,'2007-09-15 21:38:43',3310502512,1),(52168816,425751188,15182223,435967,1,'2007-09-15 21:38:43',3310502512,1),(52168819,425749487,15182223,435967,1,'2007-09-15 21:38:43',3310502512,1),(52168821,425747837,15182635,435967,1,'2007-09-15 21:38:43',3310502512,1),(52168824,425746135,15183821,435967,1,'2007-09-15 21:38:44',3310502512,1),(52168828,425743300,15186399,435967,1,'2007-09-15 21:38:44',3310502512,1),(52168829,425742011,15187791,435967,1,'2007-09-15 21:38:44',3310502512,1),(52168830,425739897,15190214,435967,1,'2007-09-15 21:38:44',3310502512,1),(52168834,425737783,15191452,435967,1,'2007-09-15 21:38:44',3310502512,1),(52168836,425735669,15192328,435967,1,'2007-09-15 21:38:45',3310502512,1),(52168838,425731286,15192638,435967,1,'2007-09-15 21:38:45',3310502512,1),(52168842,425729894,15192328,435967,1,'2007-09-15 21:38:45',3310502512,1),(52168845,425728811,15192380,435967,1,'2007-09-15 21:38:45',3310502512,1),(52168846,425727780,15193617,435967,1,'2007-09-15 21:38:45',3310502512,1),(52168849,425727161,15194803,435967,1,'2007-09-15 21:38:45',3310502512,1),(52168851,425725047,15198877,435967,1,'2007-09-15 21:38:46',3310502501,1),(52168854,425723604,15201248,435967,1,'2007-09-15 21:38:46',3310502501,1),(52168856,425722057,15203311,435967,1,'2007-09-15 21:38:46',3310502501,1),(52168858,425720355,15204187,435967,1,'2007-09-15 21:38:46',3310502501,1),(52168859,425718293,15205115,435967,1,'2007-09-15 21:38:46',3310502501,1),(52168862,425716695,15206456,435967,1,'2007-09-15 21:38:46',3310502501,1),(52168865,425715199,15208879,435967,1,'2007-09-15 21:38:47',3310502501,1),(52168866,425713446,15210581,435967,1,'2007-09-15 21:38:47',3310502501,1),(52168867,425710817,15212540,435967,1,'2007-09-15 21:38:47',3310502501,1),(52168870,425708754,15215118,435967,1,'2007-09-15 21:38:47',3310502501,1),(52168873,425707001,15216510,435967,1,'2007-09-15 21:38:47',3310502503,1),(52168875,425705455,15217232,435967,1,'2007-09-15 21:38:47',3310502503,1),(52168878,425703547,15217696,435967,1,'2007-09-15 21:38:47',3310502503,1),(52168881,425700866,15218366,435967,1,'2007-09-15 21:38:48',3310502503,1),(52168883,425699938,15218366,435967,1,'2007-09-15 21:38:48',3310502503,1),(52168886,425696792,15217438,435967,1,'2007-09-15 21:38:49',3310502502,1),(52168889,425694327,15215782,498434,1,'2008-05-22 17:35:14',3310502500,2),(52168892,425692101,15214963,435967,1,'2007-09-15 21:38:49',3310502500,1),(52168895,425690193,15214551,435967,1,'2007-09-15 21:38:49',3310502500,1),(52168899,425689162,15214912,435967,1,'2007-09-15 21:38:49',3310502500,1),(52168901,425687821,15216562,435967,1,'2007-09-15 21:38:50',3310502502,1),(52168904,425685037,15221099,435967,1,'2007-09-15 21:38:50',3310502502,1),(52168905,425683542,15223832,435967,1,'2007-09-15 21:38:50',3310502502,1),(52168909,425681685,15225894,435967,1,'2007-09-15 21:38:51',3310502502,1),(52168912,425679881,15228420,435967,1,'2007-09-15 21:38:51',3310502502,1),(52168914,425678643,15231102,435967,1,'2007-09-15 21:38:51',3310502502,1),(52168917,425678437,15234247,435967,1,'2007-09-15 21:38:51',3310502502,1),(52168919,425678437,15236979,435967,1,'2007-09-15 21:38:52',3310502502,1),(52168920,425678076,15238681,435967,1,'2007-09-15 21:38:52',3310502502,1),(52168921,425677200,15240485,435967,1,'2007-09-15 21:38:52',3310502502,1),(52168924,425675962,15242135,435967,1,'2007-09-15 21:38:52',3310502502,1),(52168926,425673642,15244249,435967,1,'2007-09-15 21:38:52',3310502502,1),(52168929,425671477,15245641,435967,1,'2007-09-15 21:38:52',3310502499,1),(52168931,425669105,15246157,435967,1,'2007-09-15 21:38:53',3310502499,1),(52168933,425665960,15246260,435967,1,'2007-09-15 21:38:53',3310502499,1),(52168936,425663897,15247034,435967,1,'2007-09-15 21:38:53',3310502499,1),(52168939,425661783,15247188,435967,1,'2007-09-15 21:38:53',3310502499,1),(52168943,425660082,15247807,435967,1,'2007-09-15 21:38:54',3310502499,1),(52168945,425658019,15249766,435967,1,'2007-09-15 21:38:54',3310502499,1),(52168946,425656576,15252138,435967,1,'2007-09-15 21:38:54',3310502499,1),(52168948,425655132,15254252,435967,1,'2007-09-15 21:38:54',3310502499,1),(52168952,425653998,15255850,435967,1,'2007-09-15 21:38:54',3310502499,1),(52168955,425653224,15257861,435967,1,'2007-09-15 21:38:55',3310502499,1),(52168959,425652142,15259769,435967,1,'2007-09-15 21:38:55',3310502499,1),(52168961,425650956,15261831,435967,1,'2007-09-15 21:38:55',3310502499,1),(52168964,425649306,15263172,435967,1,'2007-09-15 21:38:55',3310502499,1),(52168965,425647295,15263172,435967,1,'2007-09-15 21:38:56',3310502499,1),(52168967,425644975,15261831,435967,1,'2007-09-15 21:38:56',3310502499,1),(52168969,425642809,15261367,435967,1,'2007-09-15 21:38:56',3310502498,1),(52168972,425640695,15261109,435967,1,'2007-09-15 21:38:56',3310502498,1),(52168974,425639148,15261625,435967,1,'2007-09-15 21:38:56',3310502498,1),(52168976,425638639,15262611,498434,1,'2008-05-22 17:49:21',3310502498,2),(52168981,425638007,15263641,498434,1,'2008-05-22 17:49:21',3310502498,2),(52168984,425637691,15264757,498434,1,'2008-05-22 17:49:21',3310502498,2),(52168987,425637501,15266302,498434,1,'2008-05-22 17:49:21',3310502498,2),(52168989,425636996,15269735,498434,1,'2008-05-22 17:49:21',3310502498,2),(52168992,425634846,15272653,498434,1,'2008-05-22 17:49:21',3310502504,2),(52168995,425632507,15277202,498434,1,'2008-05-22 17:52:10',3310502504,3),(52169000,425631432,15277288,498434,1,'2008-05-22 17:49:21',3310502504,2),(52169003,425629915,15277632,498434,1,'2008-05-22 17:52:10',3310502504,2),(52169006,425627805,15280496,435967,1,'2007-09-15 21:39:00',3310502504,1),(52169008,425626310,15284879,435967,1,'2007-09-15 21:39:01',3310502504,1),(52169011,425624866,15287457,435967,1,'2007-09-15 21:39:01',3310502504,1),(52169014,425623835,15288642,435967,1,'2007-09-15 21:39:01',3310502504,1),(52169016,425622134,15289416,435967,1,'2007-09-15 21:39:01',3310502504,1),(52169018,425619556,15290911,435967,1,'2007-09-15 21:39:02',3310502504,1),(52169021,425616926,15290860,435967,1,'2007-09-15 21:39:02',3310502504,1),(52169022,425615070,15290860,435967,1,'2007-09-15 21:39:02',3310502461,1),(52169024,425613626,15291685,435967,1,'2007-09-15 21:39:02',3310502461,1),(52169028,425612389,15293541,435967,1,'2007-09-15 21:39:03',3310502461,1),(52169032,425610945,15295706,435967,1,'2007-09-15 21:39:03',3310502461,1),(52169034,425609398,15298078,435967,1,'2007-09-15 21:39:04',3310502461,1),(52169036,425607851,15302048,435967,1,'2007-09-15 21:39:04',3310502461,1),(52169041,425606305,15304265,435967,1,'2007-09-15 21:39:04',3310502461,1),(52169044,425604345,15305606,435967,1,'2007-09-15 21:39:05',3310502461,1),(52169045,425600169,15308132,435967,1,'2007-09-15 21:39:05',3310502461,1),(52169048,425593982,15312154,435967,1,'2007-09-15 21:39:05',3310502461,1),(52169052,425590424,15314577,435967,1,'2007-09-15 21:39:06',3310502461,1),(52169054,425588723,15316433,435967,1,'2007-09-15 21:39:06',3310502460,1),(52169055,425586248,15319424,435967,1,'2007-09-15 21:39:06',3310502460,1),(52169058,425584443,15319991,435967,1,'2007-09-15 21:39:06',3310502460,1),(52169060,425582845,15320146,435967,1,'2007-09-15 21:39:06',3310502460,1),(52169061,425581298,15319527,435967,1,'2007-09-15 21:39:07',3310502460,1),(52169064,425579493,15318599,435967,1,'2007-09-15 21:39:07',3310502460,1),(52169067,425577173,15315969,435967,1,'2007-09-15 21:39:07',3310502460,1),(52169070,425574956,15314062,435967,1,'2007-09-15 21:39:07',3310502460,1),(52169073,425573513,15311844,435967,1,'2007-09-15 21:39:07',3310502460,1),(52169075,425572120,15309834,435967,1,'2007-09-15 21:39:07',3310502460,1),(52169076,425570110,15305245,435967,1,'2007-09-15 21:39:08',3310502460,1),(52169078,425567789,15300965,435967,1,'2007-09-15 21:39:08',3310502460,1),(52169080,425565830,15296428,435967,1,'2007-09-15 21:39:08',3310502460,1),(52169083,425563768,15294263,435967,1,'2007-09-15 21:39:08',3310502460,1),(52169088,425560210,15292406,435967,1,'2007-09-15 21:39:09',3310502457,1),(52169089,425557374,15291220,435967,1,'2007-09-15 21:39:09',3310502457,1),(52169092,425554435,15288436,435967,1,'2007-09-15 21:39:09',3310502457,1),(52169094,425552837,15285446,435967,1,'2007-09-15 21:39:10',3310502457,1),(52169097,425550775,15283229,435967,1,'2007-09-15 21:39:10',3310502457,1),(52169100,425547629,15281527,435967,1,'2007-09-15 21:39:11',3310502457,1),(52169103,425544484,15279826,435967,1,'2007-09-15 21:39:11',3310502457,1),(52169105,425540566,15276371,435967,1,'2007-09-15 21:39:11',3310502457,1),(52169109,425539147,15271678,435967,1,'2007-09-15 21:39:12',3310502457,1),(52169111,425537935,15268185,435967,1,'2007-09-15 21:39:12',3310502451,1),(52169113,425536296,15264622,435967,1,'2007-09-15 21:39:12',3310502451,1),(52169115,425533445,15260844,435967,1,'2007-09-15 21:39:13',3310502450,1),(52169117,425529454,15256710,435967,1,'2007-09-15 21:39:13',3310502450,1),(52169119,425526959,15254714,435967,1,'2007-09-15 21:39:13',3310502450,1),(52169121,425525034,15254144,435967,1,'2007-09-15 21:39:14',3310502450,1),(52169123,425523751,15255427,435967,1,'2007-09-15 21:39:14',3310502450,1),(52169124,425521257,15258064,435967,1,'2007-09-15 21:39:14',3310502450,1),(52169125,425519118,15258207,435967,1,'2007-09-15 21:39:14',3310502450,1),(52169126,425516624,15257494,435967,1,'2007-09-15 21:39:15',3310502450,1),(52169127,425513915,15255498,435967,1,'2007-09-15 21:39:15',3310502450,1),(52170031,425273611,15202773,435967,1,'2007-09-15 21:41:21',3310491493,1),(52170032,425269041,15202202,435967,1,'2007-09-15 21:41:21',3310491493,1),(52170036,425271184,15202302,435967,1,'2007-09-15 21:41:21',3310491493,1),(52170040,425264202,15203610,435967,1,'2007-09-15 21:41:21',3310491493,1),(52170042,425265539,15202073,435967,1,'2007-09-15 21:41:22',3310491493,1),(52170044,425267334,15200718,435967,1,'2007-09-15 21:41:22',3310491493,1),(52170048,425268789,15200211,435967,1,'2007-09-15 21:41:23',3310491493,1),(52170056,425272032,15200380,435967,1,'2007-09-15 21:41:23',3310491493,1),(52170061,425275648,15201558,435967,1,'2007-09-15 21:41:24',3310491493,1),(52170065,425278370,15203833,435967,1,'2007-09-15 21:41:24',3310491493,1),(52170071,425281660,15205783,435967,1,'2007-09-15 21:41:25',3310491493,1),(52170076,425284585,15206352,435967,1,'2007-09-15 21:41:25',3310491493,1),(52170080,425288404,15205945,435967,1,'2007-09-15 21:41:26',3310491504,1),(52170088,425291451,15205620,435967,1,'2007-09-15 21:41:27',3310491504,1),(52170090,425291979,15205499,435967,1,'2007-09-15 21:41:27',3310491504,1),(52170096,425293198,15205255,435967,1,'2007-09-15 21:41:27',3310491504,1),(52170099,425295867,15204103,435967,1,'2007-09-15 21:41:28',3310491504,1),(52170371,425498114,15111006,501218,1,'2007-09-23 16:47:41',3310502415,1),(52170374,425502022,15107410,501218,1,'2007-09-23 16:47:41',3310502415,1),(52170377,425504758,15104596,435967,1,'2007-09-15 21:41:57',3310502413,1),(52170378,425507494,15101548,435967,1,'2007-09-15 21:41:57',3310502424,1),(52170381,425509761,15100844,501218,1,'2007-09-23 16:47:41',3310502424,1),(52170384,425512340,15098108,501218,1,'2007-09-23 16:47:41',3310502424,1),(52170386,425514138,15095216,435967,1,'2007-09-15 21:41:58',3310502424,1),(52170388,425515545,15092637,435967,1,'2007-09-15 21:41:58',3310502424,1),(52170391,425516405,15090448,501218,1,'2007-09-23 16:47:41',3310502424,1),(52170394,425519063,15087009,435967,1,'2007-09-15 21:41:59',3310502424,1),(52170397,425521251,15084976,501218,1,'2007-09-23 16:47:41',3310502424,1),(52170400,425522737,15083100,501218,1,'2007-09-23 16:47:41',3310502424,1),(52170401,425523596,15080833,435967,1,'2007-09-15 21:42:00',3310502424,1),(52170406,425523440,15077003,501218,1,'2007-09-23 16:47:41',3310502424,1),(52170410,425523909,15073408,501218,1,'2007-09-23 16:47:41',3310502424,1),(52170411,425526958,15071766,435967,1,'2007-09-15 21:42:01',3310502424,1),(52170415,425528755,15071766,501218,1,'2007-09-23 16:47:41',3310502424,1),(52170416,425531726,15069343,501218,1,'2007-09-23 16:47:41',3310502424,1),(52170417,425533993,15067076,501218,1,'2007-09-23 16:47:41',3310502424,1),(52170418,425535315,15065696,501218,1,'2007-09-23 16:47:41',3310502425,1),(52170423,425536685,15065479,501218,1,'2007-09-23 16:47:41',3310502425,1),(52170440,425537910,15066128,501218,1,'2007-09-23 16:47:41',3310502425,1),(52170441,425539854,15066387,501218,1,'2007-09-23 16:47:41',3310502425,1),(52170496,425540762,15066330,501218,1,'2007-09-23 16:47:41',3310502425,1),(52170512,425542151,15065962,435967,1,'2007-09-15 21:42:22',3310502425,1),(52170525,425544248,15064119,501218,1,'2007-09-23 16:47:41',3310502425,1),(52170533,425545666,15063269,435967,1,'2007-09-15 21:42:26',3310502425,1),(52170540,425546686,15063212,435967,1,'2007-09-15 21:42:27',3310502425,1),(52170544,425547792,15063524,501218,1,'2007-09-23 16:47:41',3310502425,1),(52170561,425549124,15063807,435967,1,'2007-09-15 21:42:31',3310502425,1),(52171046,425550769,15063921,435967,1,'2007-09-15 21:43:52',3310502425,1),(52171050,425553178,15062730,501218,1,'2007-09-23 16:47:41',3310502425,1),(52171054,425554255,15060973,501218,1,'2007-09-23 16:47:41',3310502425,1),(52171057,425554822,15059158,501218,1,'2007-09-23 16:47:41',3310502425,1),(52171060,425555389,15056947,501218,1,'2007-09-23 16:47:41',3310502425,1),(52171070,425556183,15055671,501218,1,'2007-09-23 16:47:41',3310502425,1),(52171073,425557884,15054991,501218,1,'2007-09-23 16:47:41',3310502425,1),(52171075,425559835,15055792,501218,1,'2007-09-23 16:47:41',3310502425,1),(52171078,425561387,15056004,501218,1,'2007-09-23 16:47:41',3310502425,1),(52171081,425564420,15053605,501218,1,'2007-09-23 16:47:41',3310502428,1),(52171084,425565548,15051842,501218,1,'2007-09-23 16:47:41',3310502428,1),(52171088,425568582,15049444,501218,1,'2007-09-23 16:47:41',3310502422,1),(52171092,425571756,15047468,501218,1,'2007-09-23 16:47:41',3310502422,1),(52171100,425576059,15044365,435967,1,'2007-09-15 21:44:00',3310502422,1),(52171107,425577893,15042390,435967,1,'2007-09-15 21:44:01',3310502422,1),(52171112,425579022,15041755,501218,1,'2007-09-23 16:47:41',3310502422,1),(52171114,425580150,15041966,501218,1,'2007-09-23 16:47:41',3310502422,1),(52171118,425581420,15042954,501218,1,'2007-09-23 16:47:41',3310502422,1),(52171120,425582196,15044294,501218,1,'2007-09-23 16:47:41',3310502422,1),(52171121,425583607,15045705,501218,1,'2007-09-23 16:47:41',3310502422,1),(52171125,425584947,15046128,501218,1,'2007-09-23 16:47:41',3310502422,1),(52171127,425586217,15045917,435967,1,'2007-09-15 21:44:04',3310502422,1),(52171129,425588192,15043800,501218,1,'2007-09-23 16:47:41',3310502422,1),(52171131,425591366,15039286,435967,1,'2007-09-15 21:44:05',3310502423,1),(52171136,425593200,15037029,501218,1,'2007-09-23 16:47:41',3310502423,1),(52171140,425596939,15034136,501218,1,'2007-09-23 16:47:41',3310502423,1),(52171146,425599266,15031667,435967,1,'2007-09-15 21:44:07',3310502423,1),(52171151,425602864,15028211,435967,1,'2007-09-15 21:44:08',3310502423,1),(52171156,425604910,15025248,501218,1,'2007-09-23 16:47:41',3310502423,1),(52171165,425606391,15023555,435967,1,'2007-09-15 21:44:10',3310502423,1),(52171167,425608225,15022215,501218,1,'2007-09-23 16:47:41',3310502423,1),(52171173,425610835,15021157,501218,1,'2007-09-23 16:47:41',3310502423,1),(52171179,425611752,15020028,501218,1,'2007-09-23 16:47:41',3310502423,1),(52171184,425612528,15017560,435967,1,'2007-09-15 21:44:10',3310502423,1),(52171188,425612387,15013398,435967,1,'2007-09-15 21:44:10',3310502423,1),(52171247,425613374,15010294,501218,1,'2007-09-23 16:47:41',3310502423,1),(52171251,425614644,15006767,501218,1,'2007-09-23 16:47:41',3310502423,1),(52171256,425616125,15001476,435967,1,'2007-09-15 21:44:17',3310502423,1),(52171259,425616337,14998937,435967,1,'2007-09-15 21:44:17',3310502423,1),(52171263,425615984,14994422,435967,1,'2007-09-15 21:44:17',3310502421,1),(52171280,425615067,14992306,501218,1,'2007-09-23 16:47:41',3310502421,1),(52171284,425613092,14991248,501218,1,'2007-09-23 16:47:41',3310502421,1),(52171289,425612175,14989908,501218,1,'2007-09-23 16:47:41',3310502421,1),(52171295,425612175,14987510,501218,1,'2007-09-23 16:47:41',3310502421,1),(52171297,425612387,14984829,435967,1,'2007-09-15 21:44:21',3310502421,1),(52171300,425612316,14979962,501218,1,'2007-09-23 16:47:41',3310502421,1),(52171305,425611681,14976646,501218,1,'2007-09-23 16:47:41',3310502421,1),(52171307,425610835,14973825,501218,1,'2007-09-23 16:47:41',3310502421,1),(52171311,425611823,14969099,501218,1,'2007-09-23 16:47:41',3310502421,1),(52171317,425613657,14963949,501218,1,'2007-09-23 16:47:41',3310502421,1),(52171321,425615632,14962609,501218,1,'2007-09-23 16:47:41',3310502421,1),(52171324,425618312,14959153,501218,1,'2007-09-23 16:47:41',3310502464,1),(52171330,425620217,14956049,501218,1,'2007-09-23 16:47:41',3310502464,1),(52171338,425622545,14951816,501218,1,'2007-09-23 16:47:41',3310502464,1),(52171344,425624167,14950194,501218,1,'2007-09-23 16:47:41',3310502464,1),(52171351,425626213,14949630,435967,1,'2007-09-15 21:44:27',3310502464,1),(52171364,425627623,14949912,501218,1,'2007-09-23 16:47:41',3310502464,1),(52171370,425629105,14948713,501218,1,'2007-09-23 16:47:41',3310502464,1),(52171373,425630092,14947302,501218,1,'2007-09-23 16:47:41',3310502464,1),(52171378,425631574,14944128,501218,1,'2007-09-23 16:47:41',3310502464,1),(52171382,425632702,14942153,435967,1,'2007-09-15 21:44:29',3310502464,1),(52171385,425633055,14939190,501218,1,'2007-09-23 16:47:41',3310502122,1),(52171391,425633690,14936862,501218,1,'2007-09-23 16:47:41',3310502122,1),(52171407,425634325,14933406,435967,1,'2007-09-15 21:44:31',3310502122,1),(52171413,425635312,14930020,501218,1,'2007-09-23 16:47:41',3310502122,1),(52171417,425636935,14926422,501218,1,'2007-09-23 16:47:41',3310502122,1),(52171422,425639192,14923318,501218,1,'2007-09-23 16:47:41',3310502122,1),(52171426,425643001,14920920,501218,1,'2007-09-23 16:47:41',3310502122,1),(52171432,425650094,14914624,25362,1,'2008-06-03 01:02:03',3310502123,2),(52171437,425652453,14912244,501218,1,'2007-09-23 16:47:41',3310502123,1),(52171443,425654429,14909775,501218,1,'2007-09-23 16:47:41',3310502123,1),(52171444,425655063,14906812,501218,1,'2007-09-23 16:47:41',3310502123,1),(52171447,425656263,14903638,435967,1,'2007-09-15 21:44:35',3310502123,1),(52171449,425658379,14900887,501218,1,'2007-09-23 16:47:41',3310502123,1),(52171451,425669171,14892140,501218,1,'2007-09-23 16:47:41',3310502123,1),(52171454,425672269,14890377,435967,1,'2007-09-15 21:44:35',3310502126,1),(52171458,425675093,14889973,501218,1,'2007-09-23 16:47:41',3310502126,1),(52171465,425677675,14888763,501218,1,'2007-09-23 16:47:41',3310502126,1),(52171467,425680418,14886504,501218,1,'2007-09-23 16:47:41',3310502124,1),(52171474,425685016,14885052,501218,1,'2007-09-23 16:47:41',3310502124,1),(52171479,425687759,14882954,435967,1,'2007-09-15 21:44:38',3310502124,1),(52171481,425691229,14879163,501218,1,'2007-09-23 16:47:41',3310502124,1),(52171485,425693972,14875935,501218,1,'2007-09-23 16:47:41',3310502124,1),(52171487,425697925,14873031,501218,1,'2007-09-23 16:47:41',3310502124,1),(52171491,425700507,14871498,435967,1,'2007-09-15 21:44:39',3310502125,1),(52171494,425702846,14869885,501218,1,'2007-09-23 16:47:41',3310502125,1),(52171498,425703976,14868432,435967,1,'2007-09-15 21:44:39',3310502125,1),(52171503,425705751,14864560,501218,1,'2007-09-23 16:47:41',3310502125,1),(52171506,425707042,14862543,435967,1,'2007-09-15 21:44:40',3310502125,1),(52171511,425707848,14860607,501218,1,'2007-09-23 16:47:41',3310502125,1),(52171515,425709543,14858186,435967,1,'2007-09-15 21:44:40',3310502125,1),(52171521,425712118,14856763,501218,1,'2007-09-23 16:47:41',3310502125,1),(52171525,425713233,14854886,501218,1,'2007-09-23 16:47:41',3310502125,1),(52171528,425713937,14852657,501218,1,'2007-09-23 16:47:41',3310502125,1),(52171531,425714465,14848843,501218,1,'2007-09-23 16:47:41',3310502125,1),(52171534,425714699,14845148,501218,1,'2007-09-23 16:47:41',3310502125,1),(52171537,425715521,14842625,435967,1,'2007-09-15 21:44:42',3310502125,1),(52171542,425717046,14839926,501218,1,'2007-09-23 16:47:41',3310502125,1),(52171547,425718598,14838333,25362,1,'2008-06-03 01:16:20',3310502125,2),(52171553,425721127,14837733,25362,1,'2008-06-03 01:16:20',3310502125,2),(52171557,425725259,14836758,501218,1,'2007-09-23 16:47:41',3310502125,1),(52171562,425727430,14836113,435967,1,'2007-09-15 21:44:43',3310502136,1),(52171569,425728427,14835057,435967,1,'2007-09-15 21:44:43',3310502136,1),(52171574,425730011,14832945,501218,1,'2007-09-23 16:47:41',3310502136,1),(52171579,425732534,14830129,501218,1,'2007-09-23 16:47:41',3310502130,1),(52171585,425734470,14827900,501218,1,'2007-09-23 16:47:41',3310502130,1),(52171590,425739104,14824380,435967,1,'2007-09-15 21:44:44',3310502130,1),(52171594,425740976,14822665,435967,1,'2007-09-15 21:44:44',3310502130,1),(52171595,425742230,14820909,435967,1,'2007-09-15 21:44:44',3310502130,1),(52171601,425743686,14819002,501218,1,'2007-09-23 16:47:41',3310502130,1),(52171606,425745743,14816593,501218,1,'2007-09-23 16:47:41',3310502130,1),(52171610,425748805,14814535,435967,1,'2007-09-15 21:44:45',3310502130,1),(52171616,425750661,14813431,435967,1,'2007-09-15 21:44:45',3310502130,1),(52171622,425752217,14812879,501218,1,'2007-09-23 16:47:41',3310502130,1),(52171628,425753823,14812578,435967,1,'2007-09-15 21:44:46',3310502130,1),(52171633,425755931,14813180,435967,1,'2007-09-15 21:44:47',3310502131,1),(52171636,425758741,14813180,501218,1,'2007-09-23 16:47:41',3310502131,1),(52171644,425761150,14811875,435967,1,'2007-09-15 21:44:48',3310502131,1),(52171649,425765014,14809968,435967,1,'2007-09-15 21:44:48',3310502131,1),(52171653,425768025,14808011,501218,1,'2007-09-23 16:47:41',3310502131,1),(52171656,425770434,14807208,435967,1,'2007-09-15 21:44:49',3310502131,1),(52171659,425773194,14804398,435967,1,'2007-09-15 21:44:49',3310502131,1),(52171662,425775653,14800734,435967,1,'2007-09-15 21:44:49',3310502131,1),(52171665,425779016,14795264,501218,1,'2007-09-23 16:47:41',3310502131,1),(52171764,425782306,14788654,19873,1,'2008-06-02 18:53:15',3310502134,2),(52171771,425786192,14780158,501218,1,'2007-09-23 16:47:41',3310502134,1),(52171775,425787790,14775766,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171777,425789153,14772631,435967,1,'2007-09-15 21:45:03',3310502132,1),(52171781,425790709,14771627,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171785,425793168,14771326,435967,1,'2007-09-15 21:45:04',3310502132,1),(52171787,425795527,14769569,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171790,425797986,14767612,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171795,425799240,14765555,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171797,425800645,14761640,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171801,425802302,14760135,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171805,425802803,14758328,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171808,425803205,14755217,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171810,425802151,14751754,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171811,425801950,14746083,435967,1,'2007-09-15 21:45:06',3310502132,1),(52171814,425802703,14742470,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171815,425803255,14738104,435967,1,'2007-09-15 21:45:06',3310502132,1),(52171818,425803506,14734340,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171820,425803807,14731981,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171822,425804510,14729622,435967,1,'2007-09-15 21:45:06',3310502132,1),(52171825,425806511,14726146,435967,1,'2007-09-15 21:45:06',3310502132,1),(52171858,425808375,14722505,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171863,425808775,14720108,501218,1,'2007-09-23 16:47:41',3310502110,1),(52171867,425810063,14718465,435967,1,'2007-09-15 21:45:13',3310502111,1),(52171885,425811084,14717532,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171888,425811705,14715490,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171892,425812238,14711538,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171895,425813037,14710784,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171932,425814636,14710073,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171934,425817033,14707276,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171940,425818943,14704790,435967,1,'2007-09-15 21:45:24',3310502111,1),(52171942,425821784,14702525,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171945,425823383,14700483,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171948,425826713,14695998,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171949,425827556,14694045,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171952,425827601,14690981,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171963,425828977,14689649,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171972,425830176,14688361,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171975,425831996,14688495,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171977,425833097,14687686,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171979,425833660,14686820,435967,1,'2007-09-15 21:45:29',3310502111,1),(52171981,425834223,14685693,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171985,425834397,14683873,501218,1,'2007-09-23 16:47:41',3310502111,1);
INSERT INTO `current_nodes` VALUES (52171988,425835177,14682487,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171989,425836303,14681751,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171991,425836346,14680971,435967,1,'2007-09-15 21:45:30',3310502111,1),(52171995,425836173,14679628,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171996,425836173,14678068,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171997,425836823,14675469,501218,1,'2007-09-23 16:47:41',3310502282,1),(52172001,425836563,14672696,501218,1,'2007-09-23 16:47:41',3310502111,1),(52172006,425835740,14669187,501218,1,'2007-09-23 16:47:41',3310502111,1),(52172008,425833964,14663208,501218,1,'2007-09-23 16:47:41',3310502109,1),(52172012,425833487,14659395,501218,1,'2007-09-23 16:47:41',3310502109,1),(52172014,425833574,14658182,501218,1,'2007-09-23 16:47:41',3310502109,1),(52172016,425833964,14655453,501218,1,'2007-09-23 16:47:41',3310502109,1),(52172033,425834613,14654370,501218,1,'2007-09-23 16:47:41',3310502109,1),(52172036,425836173,14653200,501218,1,'2007-09-23 16:47:41',3310502109,1),(52172049,425839726,14651077,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172050,425841025,14649864,435967,1,'2007-09-15 21:45:37',3310502280,1),(52172086,425842238,14648608,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172090,425843538,14647525,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172092,425844188,14646615,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172096,425844318,14645619,435967,1,'2007-09-15 21:45:47',3310502280,1),(52172099,425844405,14643886,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172102,425845704,14642196,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172104,425846961,14640810,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172105,425848304,14639250,435967,1,'2007-09-15 21:45:49',3310502280,1),(52172106,425848997,14639077,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172107,425850210,14639337,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172109,425851076,14638817,435967,1,'2007-09-15 21:45:49',3310502280,1),(52172111,425851423,14638557,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172122,425852073,14637950,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172124,425852809,14637864,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172128,425853763,14638167,435967,1,'2007-09-15 21:45:51',3310502280,1),(52172129,425854282,14637430,435967,1,'2007-09-15 21:45:51',3310502280,1),(52172131,425854629,14636304,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172133,425856275,14634224,435967,1,'2007-09-15 21:45:51',3310502280,1),(52172135,425857012,14634008,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172139,425857835,14634008,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172141,425858745,14633834,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172144,425860911,14634008,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172147,425862991,14634484,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172150,425864767,14635957,501218,1,'2007-09-23 16:47:41',3310502281,1),(52172153,425865807,14636434,435967,1,'2007-09-15 21:45:53',3310502281,1),(52172156,425867496,14636174,501218,1,'2007-09-23 16:47:41',3310502281,1),(52172158,425869619,14635871,435967,1,'2007-09-15 21:45:53',3310502281,1),(52172161,425871439,14634528,435967,1,'2007-09-15 21:45:53',3310502281,1),(52172164,425873735,14633011,501218,1,'2007-09-23 16:47:41',3310502281,1),(52172166,425875641,14632058,501218,1,'2007-09-23 16:47:41',3310502281,1),(52172168,425879237,14630975,501218,1,'2007-09-23 16:47:41',3310502281,1),(52172170,425880970,14629979,501218,1,'2007-09-23 16:47:41',3310502281,1),(52172172,425881706,14629155,435967,1,'2007-09-15 21:45:54',3310502281,1),(52172175,425882010,14628332,501218,1,'2007-09-23 16:47:41',3310502281,1),(52172178,425882010,14627119,501218,1,'2007-09-23 16:47:41',3310502281,1),(52172181,425883483,14625040,435967,1,'2007-09-15 21:45:54',3310502281,1),(52202283,425622053,14955746,435967,1,'2007-09-15 22:53:18',3310502464,1),(52202293,425620294,14958267,435967,1,'2007-09-15 22:53:18',3310502464,1),(52202298,425617854,14962173,435967,1,'2007-09-15 22:53:19',3310502464,1),(52202362,425616347,14964163,435967,1,'2007-09-15 22:53:27',3310502421,1),(52202389,425623684,14954337,435967,1,'2007-09-15 22:53:30',3310502464,1),(52202451,425625461,14952920,435967,1,'2007-09-15 22:53:37',3310502464,1),(52202455,425626998,14951887,435967,1,'2007-09-15 22:53:38',3310502464,1),(52202460,425628198,14950975,435967,1,'2007-09-15 22:53:38',3310502464,1),(52202465,425629591,14949750,435967,1,'2007-09-15 22:53:38',3310502464,1),(52202468,425630768,14948334,435967,1,'2007-09-15 22:53:38',3310502464,1),(52202473,425632208,14946388,435967,1,'2007-09-15 22:53:39',3310502464,1),(52202476,425633497,14944720,435967,1,'2007-09-15 22:53:40',3310502464,1),(52202485,425634460,14943027,435967,1,'2007-09-15 22:53:40',3310502464,1),(52202488,425635091,14940936,435967,1,'2007-09-15 22:53:40',3310502122,1),(52202493,425635655,14938180,435967,1,'2007-09-15 22:53:40',3310502122,1),(52202499,425636518,14933998,435967,1,'2007-09-15 22:53:41',3310502122,1),(52202507,425637481,14929317,435967,1,'2007-09-15 22:53:42',3310502122,1),(52202511,425638012,14927093,435967,1,'2007-09-15 22:53:42',3310502122,1),(52202517,425638676,14925632,435967,1,'2007-09-15 22:53:43',3310502122,1),(52202521,425639738,14924603,435967,1,'2007-09-15 22:53:43',3310502122,1),(52202523,425640966,14923806,435967,1,'2007-09-15 22:53:43',3310502122,1),(52202526,425643025,14922545,435967,1,'2007-09-15 22:53:43',3310502122,1),(52202528,425644817,14921250,435967,1,'2007-09-15 22:53:44',3310502123,1),(52202533,425646477,14919923,435967,1,'2007-09-15 22:53:44',3310502123,1),(52202534,425648514,14918057,25362,1,'2008-06-03 01:01:40',3310502123,2),(52202539,425651865,14914710,25362,1,'2008-06-03 01:01:40',3310502123,2),(52202541,425654267,14912135,25362,1,'2008-06-03 01:04:41',3310502123,3),(52202545,425661473,14905011,25362,1,'2008-06-03 01:01:40',3310502123,2),(52202549,425665582,14901750,25362,1,'2008-06-03 01:01:40',3310502123,2),(52202552,425669881,14898059,25362,1,'2008-06-03 00:58:44',3310502123,2),(52202553,425671714,14896256,25362,1,'2008-06-03 00:58:44',3310502123,2),(52202560,425674444,14893548,435967,1,'2007-09-15 22:53:46',3310502126,1),(52202566,425677368,14890508,435967,1,'2007-09-15 22:53:47',3310502126,1),(52202571,425681109,14888228,435967,1,'2007-09-15 22:53:47',3310502126,1),(52202579,425685110,14887342,21109,1,'2008-06-02 23:17:41',3310502126,2),(52203066,425689598,14885196,21109,1,'2008-06-02 23:17:41',3310502124,2),(52204239,425695920,14879998,21109,1,'2008-06-02 23:28:50',3310502124,3),(52204243,425702493,14873303,21109,1,'2008-06-02 23:28:50',3310502125,2),(52204246,425704137,14871415,21109,1,'2008-06-02 23:28:50',3310502125,2),(52204248,425705907,14868497,21109,1,'2008-06-02 23:28:50',3310502125,2),(52204251,425707487,14866265,21109,1,'2008-06-02 23:28:50',3310502125,2),(52204254,425710015,14863347,21109,1,'2008-06-02 23:28:50',3310502125,2),(52204258,425711722,14860257,21109,1,'2008-06-02 23:28:50',3310502125,2),(52204261,425713216,14858037,435967,1,'2007-09-15 22:57:07',3310502125,1),(52204265,425714646,14855806,435967,1,'2007-09-15 22:57:07',3310502125,1),(52204267,425715676,14852316,435967,1,'2007-09-15 22:57:07',3310502125,1),(52204269,425716706,14848827,435967,1,'2007-09-15 22:57:08',3310502125,1),(52204275,425717933,14845359,435967,1,'2007-09-15 22:57:08',3310502125,1),(52204280,425718518,14842805,435967,1,'2007-09-15 22:57:09',3310502125,1),(52204284,425719221,14841414,435967,1,'2007-09-15 22:57:09',3310502125,1),(52204288,425720277,14839707,435967,1,'2007-09-15 22:57:09',3310502125,1),(52204291,425722328,14838419,863220,1,'2009-03-27 04:34:30',3310502125,3),(52204292,425724287,14838162,25362,1,'2008-06-03 01:16:08',3310502125,2),(52204294,425726057,14838162,25362,1,'2008-06-03 01:16:08',3310502125,2),(52204296,425727977,14838007,435967,1,'2007-09-15 22:57:10',3310502136,1),(52204307,425729818,14837458,435967,1,'2007-09-15 22:57:11',3310502136,1),(52204324,425731401,14836360,435967,1,'2007-09-15 22:57:12',3310502136,1),(52204328,425732500,14834906,435967,1,'2007-09-15 22:57:12',3310502136,1),(52204344,425733275,14833421,435967,1,'2007-09-15 22:57:14',3310502136,1),(52204350,425735168,14831333,435967,1,'2007-09-15 22:57:14',3310502130,1),(52204353,425737396,14828630,435967,1,'2007-09-15 22:57:14',3310502130,1),(52204354,425739672,14825786,435967,1,'2007-09-15 22:57:14',3310502130,1),(52204363,425741900,14823178,435967,1,'2007-09-15 22:57:15',3310502130,1),(52204366,425743512,14820903,435967,1,'2007-09-15 22:57:15',3310502130,1),(52204368,425745645,14818200,435967,1,'2007-09-15 22:57:16',3310502130,1),(52204371,425748110,14816399,435967,1,'2007-09-15 22:57:16',3310502130,1),(52204375,425751287,14814503,435967,1,'2007-09-15 22:57:16',3310502130,1),(52204377,425752899,14813697,435967,1,'2007-09-15 22:57:16',3310502130,1),(52204380,425753894,14813554,435967,1,'2007-09-15 22:57:16',3310502130,1),(52204383,425755174,14814029,435967,1,'2007-09-15 22:57:17',3310502131,1),(52204386,425756265,14814503,435967,1,'2007-09-15 22:57:17',3310502131,1),(52204388,425757450,14814645,435967,1,'2007-09-15 22:57:17',3310502131,1),(52204391,425758777,14814645,435967,1,'2007-09-15 22:57:18',3310502131,1),(52204394,425760152,14814076,435967,1,'2007-09-15 22:57:18',3310502131,1),(52204397,425762143,14812938,435967,1,'2007-09-15 22:57:18',3310502131,1),(52204401,425763803,14811753,435967,1,'2007-09-15 22:57:19',3310502131,1),(52204404,425719807,14840378,435967,1,'2007-09-15 22:57:19',3310502125,1),(52204407,425720937,14839020,25362,1,'2008-06-03 01:16:08',3310502125,2),(52204415,425765294,14810726,435967,1,'2007-09-15 22:57:21',3310502131,1),(52204417,425766498,14809923,435967,1,'2007-09-15 22:57:21',3310502131,1),(52204420,425768051,14809173,435967,1,'2007-09-15 22:57:21',3310502131,1),(52204423,425769443,14808718,435967,1,'2007-09-15 22:57:21',3310502131,1),(52204425,425770674,14807995,435967,1,'2007-09-15 22:57:21',3310502131,1),(52204428,425772388,14807005,435967,1,'2007-09-15 22:57:21',3310502131,1),(52204431,425773512,14805452,435967,1,'2007-09-15 22:57:21',3310502131,1),(52204434,425775948,14801410,435967,1,'2007-09-15 22:57:22',3310502131,1),(52204436,425777715,14798519,435967,1,'2007-09-15 22:57:22',3310502131,1),(52204439,425781436,14792602,435967,1,'2007-09-15 22:57:22',3310502131,1),(52204442,425782496,14790800,19873,1,'2008-06-02 18:53:32',3310502134,3),(52204445,425782812,14789255,19873,1,'2008-06-02 18:54:34',3310502134,4),(52204446,425782054,14788053,19873,1,'2008-06-02 18:54:34',3310502134,4),(52204450,425781611,14787624,19873,1,'2008-06-02 18:52:50',3310502131,3),(52204453,425779265,14790515,435967,1,'2007-09-15 22:57:24',3310502131,1),(52204456,425776660,14793739,435967,1,'2007-09-15 22:57:24',3310502131,1),(52204459,425774641,14796507,435967,1,'2007-09-15 22:57:25',3310502131,1),(52204462,425773013,14798461,435967,1,'2007-09-15 22:57:25',3310502131,1),(52204465,425770896,14799893,435967,1,'2007-09-15 22:57:25',3310502131,1),(52204467,425768324,14800675,435967,1,'2007-09-15 22:57:25',3310502131,1),(52204470,425764514,14801359,435967,1,'2007-09-15 22:57:26',3310502131,1),(52204473,425762300,14801359,435967,1,'2007-09-15 22:57:26',3310502131,1),(52204476,425760704,14801163,435967,1,'2007-09-15 22:57:26',3310502131,1),(52204478,425759239,14800838,435967,1,'2007-09-15 22:57:26',3310502131,1),(52204480,425757774,14800479,435967,1,'2007-09-15 22:57:26',3310502131,1),(52204483,425755885,14800317,435967,1,'2007-09-15 22:57:27',3310502131,1),(52204485,425754290,14800154,435967,1,'2007-09-15 22:57:27',3310502131,1),(52204488,425752955,14800251,435967,1,'2007-09-15 22:57:27',3310502130,1),(52204492,425752043,14800382,435967,1,'2007-09-15 22:57:28',3310502130,1),(52204495,425750936,14800675,435967,1,'2007-09-15 22:57:29',3310502130,1),(52204498,425749959,14800740,435967,1,'2007-09-15 22:57:29',3310502130,1),(52204501,425749145,14800675,435967,1,'2007-09-15 22:57:29',3310502130,1),(52204504,425748233,14800121,435967,1,'2007-09-15 22:57:29',3310502130,1),(52204505,425746931,14799405,435967,1,'2007-09-15 22:57:29',3310502130,1),(52204513,425744749,14799437,435967,1,'2007-09-15 22:57:30',3310502130,1),(52204516,425742289,14798888,435967,1,'2007-09-15 22:57:30',3310502130,1),(52204520,425740877,14798109,435967,1,'2007-09-15 22:57:30',3310502130,1),(52204523,425739610,14797573,435967,1,'2007-09-15 22:57:31',3310502130,1),(52204525,425737418,14796988,435967,1,'2007-09-15 22:57:31',3310502130,1),(52204528,425734564,14796803,435967,1,'2007-09-15 22:57:31',3310502130,1),(52204531,425732382,14796764,435967,1,'2007-09-15 22:57:31',3310502130,1),(52204534,425730278,14796414,435967,1,'2007-09-15 22:57:31',3310502130,1),(52204536,425727706,14795751,435967,1,'2007-09-15 22:57:31',3310502130,1),(52204541,425726225,14794660,435967,1,'2007-09-15 22:57:32',3310502119,1),(52204544,425724082,14793608,435967,1,'2007-09-15 22:57:32',3310502119,1),(52204547,425721666,14792634,435967,1,'2007-09-15 22:57:32',3310502119,1),(52204549,425719835,14791854,435967,1,'2007-09-15 22:57:32',3310502119,1),(52204553,425717536,14791231,435967,1,'2007-09-15 22:57:32',3310502119,1),(52204565,425715899,14791075,435967,1,'2007-09-15 22:57:34',3310502119,1),(52204568,425714457,14791036,435967,1,'2007-09-15 22:57:34',3310502119,1),(52204624,425713699,14790855,435967,1,'2007-09-15 22:57:39',3310502119,1),(52204627,425712992,14790170,435967,1,'2007-09-15 22:57:39',3310502119,1),(52204664,425712470,14789049,435967,1,'2007-09-15 22:57:45',3310502119,1),(52204665,425711982,14787049,435967,1,'2007-09-15 22:57:45',3310502119,1),(52204668,425711381,14784477,435967,1,'2007-09-15 22:57:45',3310502119,1),(52204669,425710909,14782313,435967,1,'2007-09-15 22:57:45',3310502119,1),(52204670,425710438,14780654,435967,1,'2007-09-15 22:57:45',3310502119,1),(52204747,425710080,14779532,435967,1,'2007-09-15 22:57:58',3310502119,1),(52204750,425709657,14778507,435967,1,'2007-09-15 22:57:58',3310502119,1),(52204798,425709071,14777222,435967,1,'2007-09-15 22:58:04',3310502119,1),(52204800,425708746,14776424,435967,1,'2007-09-15 22:58:04',3310502117,1),(52204903,425708762,14775416,435967,1,'2007-09-15 22:58:13',3310502117,1),(52204912,425709120,14774505,435967,1,'2007-09-15 22:58:16',3310502117,1),(52204916,425709510,14774147,435967,1,'2007-09-15 22:58:16',3310502117,1),(52204922,425710112,14774147,435967,1,'2007-09-15 22:58:17',3310502117,1),(52204983,425710682,14774570,435967,1,'2007-09-15 22:58:21',3310502117,1),(52205002,425710991,14775757,435967,1,'2007-09-15 22:58:23',3310502117,1),(52205008,425711137,14776734,435967,1,'2007-09-15 22:58:23',3310502117,1),(52205014,425712048,14779645,435967,1,'2007-09-15 22:58:23',3310502119,1),(52205020,425712897,14782036,435967,1,'2007-09-15 22:58:24',3310502119,1),(52205022,425713480,14783591,435967,1,'2007-09-15 22:58:24',3310502119,1),(52205029,425713934,14785080,435967,1,'2007-09-15 22:58:25',3310502119,1),(52205032,425714387,14785987,435967,1,'2007-09-15 22:58:25',3310502119,1),(52205035,425714938,14786473,435967,1,'2007-09-15 22:58:25',3310502119,1),(52205038,425715715,14786537,435967,1,'2007-09-15 22:58:25',3310502119,1),(52205041,425716621,14786473,435967,1,'2007-09-15 22:58:25',3310502119,1),(52205043,425719050,14786408,435967,1,'2007-09-15 22:58:26',3310502119,1),(52205046,425720637,14786505,435967,1,'2007-09-15 22:58:26',3310502119,1),(52205050,425722839,14786829,435967,1,'2007-09-15 22:58:26',3310502119,1),(52205053,425725009,14787768,435967,1,'2007-09-15 22:58:26',3310502119,1),(52205055,425727340,14789063,435967,1,'2007-09-15 22:58:26',3310502130,1),(52205059,425728700,14790520,435967,1,'2007-09-15 22:58:26',3310502130,1),(52205063,425729834,14790877,435967,1,'2007-09-15 22:58:27',3310502130,1),(52205065,425730676,14790682,435967,1,'2007-09-15 22:58:27',3310502130,1),(52205070,425730870,14790229,435967,1,'2007-09-15 22:58:27',3310502130,1),(52205073,425730870,14789290,435967,1,'2007-09-15 22:58:27',3310502130,1),(52205075,425730158,14788772,435967,1,'2007-09-15 22:58:27',3310502130,1),(52205077,425729218,14788351,435967,1,'2007-09-15 22:58:28',3310502130,1),(52205079,425727923,14787282,435967,1,'2007-09-15 22:58:28',3310502130,1),(52205080,425726304,14785793,435967,1,'2007-09-15 22:58:28',3310502119,1),(52205082,425724588,14784789,435967,1,'2007-09-15 22:58:28',3310502119,1),(52205084,425723033,14784011,435967,1,'2007-09-15 22:58:28',3310502119,1),(52205086,425721155,14782651,435967,1,'2007-09-15 22:58:28',3310502119,1),(52205087,425719686,14781704,435967,1,'2007-09-15 22:58:29',3310502119,1),(52205089,425718340,14780796,435967,1,'2007-09-15 22:58:29',3310502119,1),(52205090,425717600,14779820,435967,1,'2007-09-15 22:58:29',3310502119,1),(52205091,425716995,14777869,435967,1,'2007-09-15 22:58:29',3310502119,1),(52205092,425716288,14773698,435967,1,'2007-09-15 22:58:29',3310502117,1),(52205093,425715245,14770603,435967,1,'2007-09-15 22:58:29',3310502117,1),(52205094,425714304,14768383,435967,1,'2007-09-15 22:58:30',3310502117,1),(52205095,425712689,14765691,435967,1,'2007-09-15 22:58:30',3310502117,1),(52205096,425711141,14763539,435967,1,'2007-09-15 22:58:30',3310502117,1),(52205099,425709762,14761722,435967,1,'2007-09-15 22:58:30',3310502117,1),(52205101,425708114,14760410,435967,1,'2007-09-15 22:58:30',3310502117,1),(52205105,425707037,14759468,435967,1,'2007-09-15 22:58:30',3310502117,1),(52205107,425706264,14757988,435967,1,'2007-09-15 22:58:31',3310502117,1),(52205110,425705658,14755869,435967,1,'2007-09-15 22:58:31',3310502117,1),(52205113,425704548,14753245,435967,1,'2007-09-15 22:58:31',3310502117,1),(52205116,425703472,14751597,435967,1,'2007-09-15 22:58:31',3310502117,1),(52205122,425701289,14749469,435967,1,'2007-09-15 22:58:31',3310502117,1),(52205123,425699338,14748362,435967,1,'2007-09-15 22:58:32',3310502117,1),(52205126,425697008,14746673,435967,1,'2007-09-15 22:58:32',3310502116,1),(52205131,425695698,14745858,435967,1,'2007-09-15 22:58:32',3310502116,1),(52205132,425694621,14745742,435967,1,'2007-09-15 22:58:32',3310502116,1),(52205135,425693776,14745829,435967,1,'2007-09-15 22:58:32',3310502116,1),(52205138,425692670,14746411,435967,1,'2007-09-15 22:58:32',3310502116,1),(52205141,425691272,14747198,435967,1,'2007-09-15 22:58:33',3310502116,1),(52205144,425689932,14747984,435967,1,'2007-09-15 22:58:33',3310502116,1),(52205148,425688505,14749003,435967,1,'2007-09-15 22:58:33',3310502116,1),(52205150,425687661,14750314,435967,1,'2007-09-15 22:58:33',3310502116,1),(52205154,425686816,14751973,435967,1,'2007-09-15 22:58:33',3310502116,1),(52205161,425685739,14755148,435967,1,'2007-09-15 22:58:34',3310502116,1),(52205166,425685360,14757099,435967,1,'2007-09-15 22:58:35',3310502116,1),(52205171,425684894,14758613,435967,1,'2007-09-15 22:58:35',3310502116,1),(52205175,425684166,14759894,435967,1,'2007-09-15 22:58:35',3310502116,1),(52205176,425682914,14761205,435967,1,'2007-09-15 22:58:36',3310502116,1),(52205177,425681720,14761962,435967,1,'2007-09-15 22:58:36',3310502116,1),(52205182,425680526,14762369,435967,1,'2007-09-15 22:58:36',3310502116,1),(52205186,425678954,14762573,435967,1,'2007-09-15 22:58:37',3310502116,1),(52205188,425677527,14762078,435967,1,'2007-09-15 22:58:37',3310502116,1),(52205196,425675692,14760739,435967,1,'2007-09-15 22:58:37',3310502116,1),(52205200,425672897,14758904,435967,1,'2007-09-15 22:58:38',3310502116,1),(52205206,425670887,14757914,435967,1,'2007-09-15 22:58:39',3310502113,1),(52205212,425668558,14756545,435967,1,'2007-09-15 22:58:39',3310502113,1),(52205218,425667306,14755730,435967,1,'2007-09-15 22:58:39',3310502113,1),(52205222,425666228,14754769,435967,1,'2007-09-15 22:58:39',3310502113,1),(52205225,425665529,14753255,435967,1,'2007-09-15 22:58:40',3310502113,1),(52205230,425665558,14751886,435967,1,'2007-09-15 22:58:40',3310502113,1),(52205232,425666170,14751071,435967,1,'2007-09-15 22:58:40',3310502113,1),(52205239,425666956,14750954,435967,1,'2007-09-15 22:58:41',3310502113,1),(52205242,425668179,14751449,435967,1,'2007-09-15 22:58:41',3310502113,1),(52205244,425669373,14752265,435967,1,'2007-09-15 22:58:41',3310502113,1),(52205248,425671324,14752643,435967,1,'2007-09-15 22:58:42',3310502113,1),(52205252,425672809,14752993,435967,1,'2007-09-15 22:58:42',3310502116,1),(52205257,425674178,14753429,435967,1,'2007-09-15 22:58:43',3310502116,1),(52205261,425675343,14753924,435967,1,'2007-09-15 22:58:43',3310502116,1),(52205266,425676100,14753895,435967,1,'2007-09-15 22:58:43',3310502116,1),(52205269,425676799,14753546,435967,1,'2007-09-15 22:58:43',3310502116,1),(52205274,425676799,14752847,435967,1,'2007-09-15 22:58:44',3310502116,1),(52205280,425676711,14751740,435967,1,'2007-09-15 22:58:44',3310502116,1),(52205284,425676129,14750750,435967,1,'2007-09-15 22:58:45',3310502116,1),(52205286,425674993,14750343,435967,1,'2007-09-15 22:58:45',3310502116,1),(52205290,425673683,14749935,435967,1,'2007-09-15 22:58:45',3310502116,1),(52205296,425671907,14748858,435967,1,'2007-09-15 22:58:45',3310502116,1),(52205298,425670567,14747547,435967,1,'2007-09-15 22:58:45',3310502113,1),(52205301,425669286,14746615,435967,1,'2007-09-15 22:58:46',3310502113,1),(52205304,425668034,14746062,435967,1,'2007-09-15 22:58:46',3310502113,1),(52205306,425666665,14745480,435967,1,'2007-09-15 22:58:46',3310502113,1),(52205309,425665180,14745392,435967,1,'2007-09-15 22:58:46',3310502113,1),(52205311,425663957,14745363,435967,1,'2007-09-15 22:58:47',3310502113,1),(52205317,425662716,14745689,435967,1,'2007-09-15 22:58:47',3310502113,1),(52205404,425661546,14746224,435967,1,'2007-09-15 22:58:57',3310502113,1),(52205416,425660308,14746191,435967,1,'2007-09-15 22:58:58',3310502113,1),(52205422,425659605,14745655,435967,1,'2007-09-15 22:58:58',3310502113,1),(52205427,425659036,14744685,435967,1,'2007-09-15 22:58:58',3310502113,1),(52205431,425659170,14743548,435967,1,'2007-09-15 22:58:59',3310502113,1),(52205434,425659639,14742879,435967,1,'2007-09-15 22:58:59',3310502113,1),(52205438,425660575,14742711,435967,1,'2007-09-15 22:58:59',3310502113,1),(52205450,425661813,14743146,435967,1,'2007-09-15 22:59:00',3310502113,1),(52205456,425663519,14743247,435967,1,'2007-09-15 22:59:00',3310502113,1),(52205461,425664556,14742946,435967,1,'2007-09-15 22:59:00',3310502113,1),(52205464,425665226,14742276,435967,1,'2007-09-15 22:59:00',3310502113,1),(52205469,425665493,14741440,435967,1,'2007-09-15 22:59:01',3310502113,1),(52205473,425665359,14740570,435967,1,'2007-09-15 22:59:01',3310502113,1),(52205475,425664824,14739801,435967,1,'2007-09-15 22:59:01',3310502113,1),(52205480,425664055,14739533,435967,1,'2007-09-15 22:59:01',3310502113,1),(52205485,425662984,14740102,435967,1,'2007-09-15 22:59:02',3310502113,1),(52205489,425662114,14740537,435967,1,'2007-09-15 22:59:02',3310502113,1),(52205492,425660876,14740604,435967,1,'2007-09-15 22:59:02',3310502113,1),(52205496,425659973,14740336,435967,1,'2007-09-15 22:59:02',3310502113,1),(52205622,425659070,14739767,435967,1,'2007-09-15 22:59:14',3310502113,1),(52205637,425657866,14738429,435967,1,'2007-09-15 22:59:16',3310502113,1),(52205641,425656427,14736154,435967,1,'2007-09-15 22:59:16',3310502113,1),(52205671,425655825,14734716,435967,1,'2007-09-15 22:59:18',3310502113,1),(52205676,425655858,14733712,435967,1,'2007-09-15 22:59:19',3310502113,1),(52205678,425656527,14733143,435967,1,'2007-09-15 22:59:19',3310502113,1),(52205679,425657196,14733244,435967,1,'2007-09-15 22:59:19',3310502113,1),(52205681,425658033,14734080,435967,1,'2007-09-15 22:59:19',3310502113,1),(52205685,425658869,14735418,435967,1,'2007-09-15 22:59:19',3310502113,1),(52205687,425659630,14736220,435967,1,'2007-09-15 22:59:19',3310502113,1),(52205690,425660691,14736785,435967,1,'2007-09-15 22:59:20',3310502113,1),(52205693,425662176,14736644,435967,1,'2007-09-15 22:59:20',3310502113,1),(52205695,425664438,14736538,435967,1,'2007-09-15 22:59:20',3310502113,1),(52205699,425666983,14736927,435967,1,'2007-09-15 22:59:20',3310502113,1),(52205703,425668574,14737422,435967,1,'2007-09-15 22:59:21',3310502113,1),(52205707,425670731,14737987,435967,1,'2007-09-15 22:59:21',3310502113,1),(52205709,425673524,14738659,435967,1,'2007-09-15 22:59:21',3310502116,1),(52205712,425675751,14738801,435967,1,'2007-09-15 22:59:21',3310502116,1),(52205713,425677554,14738553,435967,1,'2007-09-15 22:59:22',3310502116,1),(52205715,425678791,14738023,435967,1,'2007-09-15 22:59:22',3310502116,1),(52205774,425679534,14736962,435967,1,'2007-09-15 22:59:30',3310502116,1),(52205782,425679569,14735548,435967,1,'2007-09-15 22:59:30',3310502116,1),(52205785,425679321,14732932,435967,1,'2007-09-15 22:59:31',3310502116,1),(52205813,425679074,14728230,435967,1,'2007-09-15 22:59:33',3310502116,1),(52205820,425678720,14723670,435967,1,'2007-09-15 22:59:33',3310502116,1),(52205823,425678402,14717766,435967,1,'2007-09-15 22:59:33',3310502094,1),(52205828,425677766,14713630,435967,1,'2007-09-15 22:59:33',3310502094,1),(52205830,425676582,14707747,435967,1,'2007-09-15 22:59:33',3310502094,1),(52205836,425675471,14703463,435967,1,'2007-09-15 22:59:34',3310502094,1),(52205839,425674548,14699136,435967,1,'2007-09-15 22:59:35',3310502094,1),(52205843,425674493,14697863,435967,1,'2007-09-15 22:59:35',3310502094,1),(52205846,425674981,14696482,435967,1,'2007-09-15 22:59:35',3310502094,1),(52205849,425675604,14695670,435967,1,'2007-09-15 22:59:35',3310502094,1),(52205852,425676253,14695074,435967,1,'2007-09-15 22:59:35',3310502094,1),(52205855,425677309,14694587,435967,1,'2007-09-15 22:59:36',3310502094,1),(52205859,425678636,14694560,435967,1,'2007-09-15 22:59:36',3310502094,1),(52205863,425680098,14694993,435967,1,'2007-09-15 22:59:36',3310502094,1),(52205865,425683239,14697078,435967,1,'2007-09-15 22:59:36',3310502094,1),(52205869,425686163,14698946,435967,1,'2007-09-15 22:59:36',3310502094,1),(52205873,425691172,14702791,435967,1,'2007-09-15 22:59:36',3310502094,1),(52205876,425695206,14705986,435967,1,'2007-09-15 22:59:36',3310502094,1),(52205880,425699322,14710101,435967,1,'2007-09-15 22:59:36',3310502095,1),(52205882,425701623,14712944,435967,1,'2007-09-15 22:59:37',3310502095,1),(52205885,425703085,14714406,435967,1,'2007-09-15 22:59:37',3310502095,1),(52205888,425704331,14715056,435967,1,'2007-09-15 22:59:37',3310502095,1),(52205891,425705874,14715381,435967,1,'2007-09-15 22:59:37',3310502095,1),(52205893,425707797,14715760,435967,1,'2007-09-15 22:59:37',3310502095,1),(52205896,425709205,14716356,435967,1,'2007-09-15 22:59:37',3310502095,1),(52205898,425710937,14717791,435967,1,'2007-09-15 22:59:38',3310502095,1),(52205901,425713862,14721473,435967,1,'2007-09-15 22:59:38',3310502095,1),(52205904,425715540,14724127,435967,1,'2007-09-15 22:59:38',3310502117,1),(52205907,425717625,14726834,435967,1,'2007-09-15 22:59:38',3310502117,1),(52205910,425719737,14729054,435967,1,'2007-09-15 22:59:38',3310502117,1),(52205913,425721226,14730652,435967,1,'2007-09-15 22:59:38',3310502117,1),(52205915,425721903,14730950,435967,1,'2007-09-15 22:59:38',3310502117,1),(52205924,425722553,14731139,435967,1,'2007-09-15 22:59:39',3310502117,1),(52205929,425723257,14730706,435967,1,'2007-09-15 22:59:40',3310502117,1),(52205930,425723798,14730002,435967,1,'2007-09-15 22:59:40',3310502117,1),(52205935,425724177,14728946,435967,1,'2007-09-15 22:59:40',3310502117,1),(52205937,425724286,14727484,435967,1,'2007-09-15 22:59:40',3310502117,1),(52205938,425724313,14725751,435967,1,'2007-09-15 22:59:40',3310502117,1),(52205941,425724457,14722343,435967,1,'2007-09-15 22:59:40',3310502117,1),(52205945,425724764,14720190,435967,1,'2007-09-15 22:59:41',3310502095,1),(52205948,425725564,14718406,435967,1,'2007-09-15 22:59:41',3310502095,1),(52205951,425726623,14716695,435967,1,'2007-09-15 22:59:41',3310502095,1),(52205955,425728641,14715957,435967,1,'2007-09-15 22:59:41',3310502106,1),(52205959,425731495,14715661,435967,1,'2007-09-15 22:59:42',3310502106,1),(52205964,425733661,14715317,435967,1,'2007-09-15 22:59:42',3310502106,1),(52205967,425734596,14714825,435967,1,'2007-09-15 22:59:42',3310502106,1),(52205972,425734990,14713791,435967,1,'2007-09-15 22:59:42',3310502106,1),(52205973,425734941,14712856,435967,1,'2007-09-15 22:59:43',3310502106,1),(52205977,425734301,14712314,435967,1,'2007-09-15 22:59:43',3310502106,1),(52205980,425733267,14711773,435967,1,'2007-09-15 22:59:43',3310502106,1),(52205983,425731988,14711773,435967,1,'2007-09-15 22:59:43',3310502106,1),(52205985,425730806,14711773,435967,1,'2007-09-15 22:59:43',3310502106,1),(52205987,425729379,14711773,435967,1,'2007-09-15 22:59:44',3310502106,1),(52205990,425788381,14782206,435967,1,'2007-09-15 22:59:44',3310502134,1),(52205992,425790013,14784655,435967,1,'2007-09-15 22:59:44',3310502134,1),(52205994,425792140,14787420,435967,1,'2007-09-15 22:59:44',3310502134,1),(52205996,425796375,14791544,435967,1,'2007-09-15 22:59:44',3310502134,1),(52205998,425787824,14781429,435967,1,'2007-09-15 22:59:44',3310502134,1),(52206000,425787185,14781048,435967,1,'2007-09-15 22:59:44',3310502134,1),(52206003,425786241,14780759,435967,1,'2007-09-15 22:59:45',3310502134,1),(52206005,425785973,14780708,501218,1,'2007-09-23 16:47:41',3310502134,1),(52206007,425798598,14793625,435967,1,'2007-09-15 22:59:45',3310502134,1),(52206009,425800209,14795075,435967,1,'2007-09-15 22:59:45',3310502134,1),(52206010,425801606,14796550,435967,1,'2007-09-15 22:59:45',3310502134,1),(52206014,425802765,14797874,435967,1,'2007-09-15 22:59:46',3310502134,1),(52206016,425803474,14798749,435967,1,'2007-09-15 22:59:46',3310502134,1),(52206018,425804089,14799387,435967,1,'2007-09-15 22:59:46',3310502134,1),(52206020,425804656,14799600,435967,1,'2007-09-15 22:59:46',3310502134,1),(52206023,425805153,14799907,435967,1,'2007-09-15 22:59:46',3310502134,1),(52206025,425805460,14800404,435967,1,'2007-09-15 22:59:46',3310502134,1),(52206031,425805602,14800806,435967,1,'2007-09-15 22:59:47',3310502134,1),(52206033,425806122,14801231,435967,1,'2007-09-15 22:59:47',3310502134,1),(52206036,425806903,14801775,435967,1,'2007-09-15 22:59:47',3310502134,1),(52206040,425807659,14802177,435967,1,'2007-09-15 22:59:47',3310502134,1),(52206041,425808345,14802201,435967,1,'2007-09-15 22:59:47',3310502134,1),(52206044,425808794,14801964,435967,1,'2007-09-15 22:59:48',3310502134,1),(52206048,425809220,14801397,435967,1,'2007-09-15 22:59:48',3310502135,1),(52206051,425809906,14800830,435967,1,'2007-09-15 22:59:48',3310502135,1),(52206054,425810520,14800759,435967,1,'2007-09-15 22:59:48',3310502135,1),(52206057,425811277,14800830,435967,1,'2007-09-15 22:59:48',3310502135,1),(52206060,425812294,14801397,435967,1,'2007-09-15 22:59:48',3310502135,1),(52206063,425813571,14802130,435967,1,'2007-09-15 22:59:49',3310502135,1),(52206068,425814099,14802539,435967,1,'2007-09-15 22:59:49',3310502135,1),(52206069,425814534,14803039,435967,1,'2007-09-15 22:59:49',3310502135,1),(52206072,425815099,14803430,435967,1,'2007-09-15 22:59:49',3310502135,1),(52206076,425815533,14803474,435967,1,'2007-09-15 22:59:50',3310502135,1),(52206078,425815859,14803365,435967,1,'2007-09-15 22:59:50',3310502135,1),(52206165,425816185,14803822,435967,1,'2007-09-15 22:59:57',3310502135,1),(52206177,425816750,14803865,435967,1,'2007-09-15 22:59:57',3310502135,1),(52206181,425817598,14803908,435967,1,'2007-09-15 22:59:58',3310502135,1),(52206185,425818076,14804278,435967,1,'2007-09-15 22:59:58',3310502135,1),(52206187,425818554,14804626,435967,1,'2007-09-15 22:59:58',3310502135,1),(52206189,425819097,14804582,435967,1,'2007-09-15 22:59:58',3310502135,1),(52206193,425819423,14804821,435967,1,'2007-09-15 22:59:58',3310502135,1),(52206195,425819858,14805930,435967,1,'2007-09-15 22:59:59',3310502135,1),(52206198,425820292,14806364,435967,1,'2007-09-15 22:59:59',3310502135,1),(52206202,425820966,14806603,435967,1,'2007-09-15 22:59:59',3310502135,1),(52206203,425821292,14806775,435967,1,'2007-09-15 22:59:59',3310502135,1),(52206207,425821828,14807162,435967,1,'2007-09-15 22:59:59',3310502135,1),(52206209,425822160,14807550,435967,1,'2007-09-15 22:59:59',3310502135,1),(52206212,425822289,14807845,435967,1,'2007-09-15 23:00:00',3310502135,1),(52206215,425822621,14808011,435967,1,'2007-09-15 23:00:00',3310502135,1),(52206218,425823433,14808085,435967,1,'2007-09-15 23:00:00',3310502135,1),(52206221,425824652,14808602,435967,1,'2007-09-15 23:00:00',3310502135,1),(52206225,425825224,14809137,435967,1,'2007-09-15 23:00:00',3310502135,1),(52206228,425826003,14809650,435967,1,'2007-09-15 23:00:00',3310502135,1),(52206231,425826520,14810137,435967,1,'2007-09-15 23:00:00',3310502135,1),(52206234,425827051,14810492,435967,1,'2007-09-15 23:00:01',3310502135,1),(52206238,425827775,14810699,435967,1,'2007-09-15 23:00:01',3310502135,1),(52206240,425828114,14810935,435967,1,'2007-09-15 23:00:01',3310502135,1),(52206242,425828720,14811437,435967,1,'2007-09-15 23:00:01',3310502135,1),(52206244,425829251,14811964,435967,1,'2007-09-15 23:00:02',3310502135,1),(52206250,425830122,14812879,435967,1,'2007-09-15 23:00:02',3310502135,1),(52206252,425831037,14814006,435967,1,'2007-09-15 23:00:02',3310502135,1),(52206254,425831675,14814558,435967,1,'2007-09-15 23:00:02',3310502135,1),(52206256,425832483,14815047,435967,1,'2007-09-15 23:00:02',3310502135,1),(52206259,425833588,14815664,435967,1,'2007-09-15 23:00:02',3310502135,1),(52206262,425834269,14815664,435967,1,'2007-09-15 23:00:02',3310502135,1),(52206266,425834885,14815409,435967,1,'2007-09-15 23:00:02',3310502135,1),(52206268,425835630,14815154,435967,1,'2007-09-15 23:00:03',3310502135,1),(52206271,425836331,14815303,435967,1,'2007-09-15 23:00:03',3310502135,1),(52206274,425836756,14815451,435967,1,'2007-09-15 23:00:03',3310502306,1),(52206277,425837708,14815771,435967,1,'2007-09-15 23:00:04',3310502306,1),(52206280,425838742,14816171,435967,1,'2007-09-15 23:00:04',3310502306,1),(52206283,425839565,14816641,435967,1,'2007-09-15 23:00:04',3310502306,1),(52206286,425840224,14816782,435967,1,'2007-09-15 23:00:04',3310502306,1),(52206290,425841235,14816947,435967,1,'2007-09-15 23:00:04',3310502306,1),(52206293,425842152,14817205,435967,1,'2007-09-15 23:00:04',3310502306,1),(52206294,425843304,14817840,435967,1,'2007-09-15 23:00:04',3310502306,1),(52206299,425844292,14818264,435967,1,'2007-09-15 23:00:04',3310502306,1),(52206302,425845115,14818428,435967,1,'2007-09-15 23:00:05',3310502306,1),(52206304,425845750,14818710,435967,1,'2007-09-15 23:00:05',3310502306,1),(52206306,425846549,14819134,435967,1,'2007-09-15 23:00:05',3310502306,1),(52206310,425847349,14819722,435967,1,'2007-09-15 23:00:05',3310502306,1),(52206312,425847843,14820098,435967,1,'2007-09-15 23:00:05',3310502306,1),(52206315,425848407,14820568,435967,1,'2007-09-15 23:00:05',3310502306,1),(52206317,425849113,14820850,435967,1,'2007-09-15 23:00:06',3310502306,1),(52206320,425849818,14820944,435967,1,'2007-09-15 23:00:06',3310502306,1),(52206321,425850941,14821137,435967,1,'2007-09-15 23:00:06',3310502306,1),(52206324,425852038,14821390,435967,1,'2007-09-15 23:00:06',3310502306,1),(52206327,425852883,14821601,435967,1,'2007-09-15 23:00:06',3310502306,1),(52206333,425853347,14821981,435967,1,'2007-09-15 23:00:06',3310502306,1),(52206336,425853938,14822825,435967,1,'2007-09-15 23:00:07',3310502306,1),(52206337,425854177,14823136,435967,1,'2007-09-15 23:00:07',3310502306,1),(52206340,425854695,14823352,435967,1,'2007-09-15 23:00:07',3310502306,1),(52206343,425855149,14823698,435967,1,'2007-09-15 23:00:07',3310502306,1),(52206344,425855733,14824368,435967,1,'2007-09-15 23:00:07',3310502306,1),(52206347,425856079,14824671,435967,1,'2007-09-15 23:00:08',3310502306,1),(52206349,425856749,14825146,435967,1,'2007-09-15 23:00:08',3310502306,1),(52206352,425857354,14825751,435967,1,'2007-09-15 23:00:08',3310502306,1),(52206354,425857922,14825767,435967,1,'2007-09-15 23:00:08',3310502306,1),(52206356,425858541,14825940,435967,1,'2007-09-15 23:00:08',3310502306,1),(52206358,425859229,14826525,435967,1,'2007-09-15 23:00:08',3310502306,1),(52206359,425859677,14826628,435967,1,'2007-09-15 23:00:08',3310502306,1),(52206360,425860262,14826834,435967,1,'2007-09-15 23:00:09',3310502306,1),(52206364,425861226,14827351,435967,1,'2007-09-15 23:00:09',3310502306,1),(52206366,425862478,14827970,435967,1,'2007-09-15 23:00:09',3310502306,1),(52206374,425863277,14828356,435967,1,'2007-09-15 23:00:10',3310502306,1),(52206379,425864296,14828961,435967,1,'2007-09-15 23:00:10',3310502307,1),(52206383,425865342,14829402,435967,1,'2007-09-15 23:00:10',3310502307,1),(52206385,425866140,14830063,435967,1,'2007-09-15 23:00:10',3310502307,1),(52206389,425866939,14830669,435967,1,'2007-09-15 23:00:11',3310502307,1),(52206395,425867985,14831054,435967,1,'2007-09-15 23:00:11',3310502307,1),(52206400,425868674,14831247,435967,1,'2007-09-15 23:00:12',3310502307,1),(52206404,425870381,14831742,435967,1,'2007-09-15 23:00:12',3310502307,1),(52206407,425872033,14832155,435967,1,'2007-09-15 23:00:12',3310502313,1),(52206410,425873630,14832651,435967,1,'2007-09-15 23:00:12',3310502313,1),(52206414,425874401,14833449,435967,1,'2007-09-15 23:00:12',3310502313,1),(52206419,425874511,14833477,435967,1,'2007-09-15 23:00:13',3310502313,1),(52206420,425875589,14833961,435967,1,'2007-09-15 23:00:13',3310502313,1),(52206422,425877019,14834390,435967,1,'2007-09-15 23:00:13',3310502313,1),(52206425,425877842,14835105,435967,1,'2007-09-15 23:00:13',3310502313,1),(52206429,425878592,14835605,435967,1,'2007-09-15 23:00:13',3310502313,1),(52206433,425879522,14836285,435967,1,'2007-09-15 23:00:13',3310502313,1),(52206435,425880022,14836678,435967,1,'2007-09-15 23:00:14',3310502313,1),(52206439,425880952,14837250,435967,1,'2007-09-15 23:00:14',3310502313,1),(52206442,425882096,14837572,435967,1,'2007-09-15 23:00:14',3310502313,1),(52206446,425882990,14837500,435967,1,'2007-09-15 23:00:14',3310502313,1),(52206447,425884492,14837107,435967,1,'2007-09-15 23:00:14',3310502313,1),(52206449,425885671,14836964,435967,1,'2007-09-15 23:00:14',3310502313,1),(52206453,425886923,14836892,435967,1,'2007-09-15 23:00:15',3310502313,1),(52206457,425887392,14836352,435967,1,'2007-09-15 23:00:15',3310502313,1),(52206461,425888964,14835626,435967,1,'2007-09-15 23:00:17',3310502313,1),(52206468,425891382,14834538,435967,1,'2007-09-15 23:00:18',3310502313,1),(52206471,425895673,14833632,435967,1,'2007-09-15 23:00:18',3310502316,1),(52206472,425897789,14833027,435967,1,'2007-09-15 23:00:18',3310502316,1),(52206476,425745721,14725549,435967,1,'2007-09-15 23:00:18',3310502128,1),(52206479,425745847,14728685,435967,1,'2007-09-15 23:00:19',3310502128,1),(52206483,425745533,14732072,435967,1,'2007-09-15 23:00:19',3310502128,1),(52206486,425745967,14735043,435967,1,'2007-09-15 23:00:19',3310502128,1),(52206488,425746778,14737547,435967,1,'2007-09-15 23:00:19',3310502128,1),(52206491,425747072,14739757,435967,1,'2007-09-15 23:00:19',3310502128,1),(52206495,425748103,14742850,435967,1,'2007-09-15 23:00:19',3310502128,1),(52206498,425750018,14747784,435967,1,'2007-09-15 23:00:20',3310502128,1),(52206502,425752154,14753381,435967,1,'2007-09-15 23:00:20',3310502128,1),(52206505,425753111,14756475,435967,1,'2007-09-15 23:00:20',3310502128,1),(52206508,425754142,14759273,435967,1,'2007-09-15 23:00:20',3310502128,1),(52206512,425755542,14762587,435967,1,'2007-09-15 23:00:20',3310502129,1),(52206580,425757015,14765901,435967,1,'2007-09-15 23:00:27',3310502129,1),(52206583,425758488,14768847,435967,1,'2007-09-15 23:00:27',3310502129,1),(52206585,425758782,14770689,435967,1,'2007-09-15 23:00:27',3310502129,1),(52206588,425760402,14772972,435967,1,'2007-09-15 23:00:27',3310502129,1),(52206591,425761728,14774150,435967,1,'2007-09-15 23:00:28',3310502129,1),(52206601,425763496,14777832,435967,1,'2007-09-15 23:00:29',3310502131,1),(52206604,425763937,14779379,435967,1,'2007-09-15 23:00:29',3310502131,1),(52206607,425763716,14782325,435967,1,'2007-09-15 23:00:29',3310502131,1),(52206609,425763864,14784534,435967,1,'2007-09-15 23:00:29',3310502131,1),(52206611,425765484,14789248,435967,1,'2007-09-15 23:00:29',3310502131,1),(52206615,425767174,14791732,435967,1,'2007-09-15 23:00:30',3310502131,1),(52206617,425767551,14793919,435967,1,'2007-09-15 23:00:30',3310502131,1),(52206619,425768532,14797690,435967,1,'2007-09-15 23:00:30',3310502131,1),(52206620,425768720,14802743,435967,1,'2007-09-15 23:00:30',3310502131,1),(52206622,425768117,14804025,435967,1,'2007-09-15 23:00:31',3310502131,1),(52206625,425767039,14807004,435967,1,'2007-09-15 23:00:31',3310502131,1),(52206627,425766692,14808092,435967,1,'2007-09-15 23:00:31',3310502131,1),(52206628,425766544,14808797,501218,1,'2007-09-23 16:47:41',3310502131,1),(52206632,425786303,14771120,435967,1,'2007-09-15 23:00:32',3310502132,1),(52206635,425784274,14774797,435967,1,'2007-09-15 23:00:32',3310502132,1),(52206639,425782457,14780081,435967,1,'2007-09-15 23:00:32',3310502134,1),(52206643,425781801,14786594,19873,1,'2008-06-02 18:59:31',3310502134,3),(52206645,425788751,14768098,435967,1,'2007-09-15 23:00:33',3310502132,1),(52206647,425789928,14766760,435967,1,'2007-09-15 23:00:33',3310502132,1),(52206650,425790984,14765656,435967,1,'2007-09-15 23:00:33',3310502132,1),(52206653,425793088,14763631,435967,1,'2007-09-15 23:00:34',3310502132,1),(52206655,425794516,14762436,435967,1,'2007-09-15 23:00:34',3310502132,1),(52206657,425795970,14761371,435967,1,'2007-09-15 23:00:34',3310502132,1),(52206661,425797788,14761034,435967,1,'2007-09-15 23:00:34',3310502132,1),(52206663,425799579,14761733,435967,1,'2007-09-15 23:00:35',3310502132,1),(52206666,425801093,14762959,435967,1,'2007-09-15 23:00:35',3310502132,1),(52206669,425801892,14764721,435967,1,'2007-09-15 23:00:35',3310502132,1),(52206671,425802255,14767292,435967,1,'2007-09-15 23:00:35',3310502132,1),(52206673,425802177,14771578,435967,1,'2007-09-15 23:00:36',3310502132,1),(52206676,425801866,14782277,435967,1,'2007-09-15 23:00:36',3310502134,1),(52206679,425801711,14788956,435967,1,'2007-09-15 23:00:36',3310502134,1),(52206681,425801227,14792779,435967,1,'2007-09-15 23:00:36',3310502134,1),(52206684,425800150,14796118,435967,1,'2007-09-15 23:00:37',3310502134,1),(52206686,425797080,14801934,435967,1,'2007-09-15 23:00:37',3310502134,1),(52206688,425796218,14803226,435967,1,'2007-09-15 23:00:37',3310502134,1),(52206691,425795309,14782350,863220,1,'2009-03-27 04:34:38',3310502134,2),(52206694,425796038,14781183,435967,1,'2007-09-15 23:00:37',3310502134,1),(52206698,425796403,14780198,435967,1,'2007-09-15 23:00:37',3310502134,1),(52206701,425796221,14778847,435967,1,'2007-09-15 23:00:38',3310502134,1),(52206703,425795345,14776767,435967,1,'2007-09-15 23:00:38',3310502132,1),(52206706,425793280,14772310,435967,1,'2007-09-15 23:00:38',3310502132,1),(52206708,425792172,14770362,435967,1,'2007-09-15 23:00:38',3310502132,1),(52206710,425791246,14768753,435967,1,'2007-09-15 23:00:38',3310502132,1),(52206714,425798380,14775894,435967,1,'2007-09-15 23:00:39',3310502132,1),(52212234,425789323,14798844,435967,1,'2007-09-15 23:10:48',3310502134,1),(52212307,425787712,14800324,435967,1,'2007-09-15 23:10:57',3310502134,1),(52212628,425786753,14802110,435967,1,'2007-09-15 23:11:21',3310502134,1),(52212746,425787189,14803721,435967,1,'2007-09-15 23:11:40',3310502134,1),(52212871,425788278,14804635,435967,1,'2007-09-15 23:11:52',3310502134,1),(52212893,425790150,14805071,435967,1,'2007-09-15 23:11:55',3310502134,1),(52212906,425793634,14804723,435967,1,'2007-09-15 23:11:56',3310502134,1),(52212916,425792813,14808465,435967,1,'2007-09-15 23:11:57',3310502134,1),(52212920,425795711,14803863,435967,1,'2007-09-15 23:11:58',3310502134,1),(52252247,424667675,14925149,439281,1,'2007-09-16 00:22:31',3310490811,1),(52252315,424670114,14921036,439281,1,'2007-09-16 00:22:40',3310490811,1),(52252320,424666553,14919223,439281,1,'2007-09-16 00:22:40',3310490811,1),(52252322,424619189,14904314,439281,1,'2007-09-16 00:22:40',3310490799,1),(52252325,424619418,14904879,439281,1,'2007-09-16 00:22:40',3310490799,1),(52252326,424619260,14905372,439281,1,'2007-09-16 00:22:41',3310490799,1),(52252328,424618264,14905621,439281,1,'2007-09-16 00:22:41',3310490799,1),(52252330,424617895,14905265,439281,1,'2007-09-16 00:22:41',3310490799,1),(52252331,424617878,14904550,439281,1,'2007-09-16 00:22:41',3310490799,1),(52252333,424618190,14904201,439281,1,'2007-09-16 00:22:41',3310490799,1),(52252336,424618734,14904092,439281,1,'2007-09-16 00:22:41',3310490799,1),(52252404,424625121,14911084,439281,1,'2007-09-16 00:22:51',3310490799,1),(52252405,424622924,14909583,439281,1,'2007-09-16 00:22:51',3310490799,1),(52252407,424619167,14906066,439281,1,'2007-09-16 00:22:51',3310490799,1),(52252411,424618862,14905712,439281,1,'2007-09-16 00:22:52',3310490799,1),(52252412,424626790,14911587,439281,1,'2007-09-16 00:22:52',3310490799,1),(52252414,424628035,14911489,439281,1,'2007-09-16 00:22:52',3310490799,1),(52252416,424630228,14911096,439281,1,'2007-09-16 00:22:52',3310490810,1),(52252417,424632127,14910866,439281,1,'2007-09-16 00:22:52',3310490810,1),(52252420,424634303,14910005,439281,1,'2007-09-16 00:22:53',3310490810,1),(52252422,424636007,14909206,439281,1,'2007-09-16 00:22:53',3310490810,1),(52252423,424637988,14908580,439281,1,'2007-09-16 00:22:53',3310490810,1),(52252424,424640178,14908441,439281,1,'2007-09-16 00:22:53',3310490810,1),(52252426,424644211,14909345,439281,1,'2007-09-16 00:22:53',3310490810,1),(52252427,424649078,14910944,439281,1,'2007-09-16 00:22:53',3310490810,1),(52252429,424653006,14912682,439281,1,'2007-09-16 00:22:53',3310490810,1),(52252430,424655891,14915289,439281,1,'2007-09-16 00:22:53',3310490811,1),(52252431,424660028,14919391,439281,1,'2007-09-16 00:22:54',3310490811,1),(52252433,424664860,14923006,439281,1,'2007-09-16 00:22:54',3310490811,1),(52252434,424674733,14929159,439281,1,'2007-09-16 00:22:54',3310490811,1),(52252435,424680990,14932775,439281,1,'2007-09-16 00:22:54',3310490811,1),(52252437,424682102,14932983,439281,1,'2007-09-16 00:22:54',3310490811,1),(52252452,424694673,14933367,439281,1,'2007-09-16 00:22:56',3310490814,1),(52252472,424701941,14932706,439281,1,'2007-09-16 00:23:04',3310490814,1),(52252473,424711673,14934208,439281,1,'2007-09-16 00:23:07',3310490815,1),(52252474,424648295,14915734,439281,1,'2007-09-16 00:23:08',3310490810,1),(52252475,424648574,14913301,439281,1,'2007-09-16 00:23:08',3310490810,1),(52252476,424647987,14917382,439281,1,'2007-09-16 00:23:08',3310490810,1),(52252477,424648227,14917804,439281,1,'2007-09-16 00:23:08',3310490810,1),(52252478,424648884,14918041,439281,1,'2007-09-16 00:23:08',3310490810,1),(52252479,424649030,14920295,439281,1,'2007-09-16 00:23:08',3310490810,1),(52252480,424648724,14920936,439281,1,'2007-09-16 00:23:08',3310490810,1),(52261829,424648013,14921608,439281,1,'2007-09-16 00:38:11',3310490810,1),(52261834,424647223,14921805,439281,1,'2007-09-16 00:38:11',3310490810,1),(52261835,424645801,14921529,439281,1,'2007-09-16 00:38:12',3310490810,1),(52261839,424643550,14921371,439281,1,'2007-09-16 00:38:12',3310490810,1),(52261842,424642602,14921687,439281,1,'2007-09-16 00:38:12',3310490810,1),(52261846,424641851,14922832,439281,1,'2007-09-16 00:38:12',3310490810,1),(52261850,424641496,14924294,439281,1,'2007-09-16 00:38:13',3310490810,1),(52261853,424648072,14916779,439281,1,'2007-09-16 00:38:13',3310490810,1),(52261857,424649132,14918605,439281,1,'2007-09-16 00:38:13',3310490810,1),(52261860,424641921,14925632,439281,1,'2007-09-16 00:38:13',3310490810,1),(52261864,424642866,14926420,439281,1,'2007-09-16 00:38:13',3310490810,1),(52261866,424644161,14926910,439281,1,'2007-09-16 00:38:13',3310490810,1),(52261869,424646052,14927313,439281,1,'2007-09-16 00:38:14',3310490810,1),(52261872,424648544,14928203,439281,1,'2007-09-16 00:38:14',3310490810,1),(52261874,424651037,14929633,439281,1,'2007-09-16 00:38:14',3310490810,1),(52261878,424654300,14931539,439281,1,'2007-09-16 00:38:14',3310490810,1),(52261880,424656389,14933043,439281,1,'2007-09-16 00:38:14',3310490811,1),(52261883,424657893,14934692,439281,1,'2007-09-16 00:38:14',3310490811,1),(52261886,424663862,14926991,27626,1,'2009-04-01 15:50:51',3310490811,2),(52261888,424665124,14925040,27626,1,'2009-04-01 15:50:51',3310490811,2),(52261890,424665894,14923708,27626,1,'2009-04-01 15:50:51',3310490811,2),(52261893,424662811,14927921,27626,1,'2009-04-01 15:50:51',3310490811,2),(52261896,424661984,14929039,27626,1,'2009-04-01 15:50:51',3310490811,2),(52261900,424661401,14930400,27626,1,'2009-04-01 15:50:51',3310490811,2),(52261902,424661109,14932880,27626,1,'2009-04-01 15:50:51',3310490811,2),(52261907,424660720,14936356,27626,1,'2009-04-01 15:50:51',3310490811,2),(52261910,424660307,14940002,27626,1,'2009-04-01 15:50:51',3310490811,2),(52261914,424659408,14942725,27626,1,'2009-04-01 15:50:51',3310491153,2),(52261918,424657828,14945763,27626,1,'2009-04-01 15:50:51',3310491153,2),(52261921,424656963,14946941,27626,1,'2009-04-01 15:50:51',3310491153,2),(52261924,424656076,14947465,27626,1,'2009-04-01 15:50:50',3310491153,2),(52261926,424655069,14947707,27626,1,'2009-04-01 15:50:50',3310491152,2),(52261927,424654021,14947586,27626,1,'2009-04-01 15:50:50',3310491152,2),(52261931,424652934,14946861,27626,1,'2009-04-01 15:50:50',3310491152,2),(52261934,424651725,14945410,27626,1,'2009-04-01 15:50:50',3310491152,2),(52261938,424650637,14943557,27626,1,'2009-04-01 15:50:50',3310491152,2),(52261940,424649348,14941703,27626,1,'2009-04-01 15:50:50',3310491152,2),(52261946,424648461,14940575,27626,1,'2009-04-01 15:50:50',3310490810,2),(52261947,424647696,14940172,27626,1,'2009-04-01 15:50:50',3310490810,2),(52261951,424646971,14940334,27626,1,'2009-04-01 15:50:50',3310490810,2),(52261955,424646084,14941381,27626,1,'2009-04-01 15:50:50',3310490810,2),(52261959,424645278,14943436,27626,1,'2009-04-01 15:50:49',3310491152,2),(52261962,424644620,14945263,27626,1,'2009-04-01 15:50:49',3310491152,2),(52261965,424643224,14946700,27626,1,'2009-04-01 15:50:49',3310491152,2),(52261969,424642567,14946700,27626,1,'2009-04-01 15:50:49',3310491152,2),(52261972,424641868,14946454,27626,1,'2009-04-01 15:50:49',3310491152,2),(52261975,424641252,14945756,27626,1,'2009-04-01 15:50:49',3310491152,2),(52261978,424641006,14944483,27626,1,'2009-04-01 15:50:49',3310491152,2),(52261982,424641129,14942676,27626,1,'2009-04-01 15:50:48',3310491152,2),(52261985,424640965,14941157,27626,1,'2009-04-01 15:50:48',3310490810,2),(52261987,424640678,14939801,27626,1,'2009-04-01 15:50:48',3310490810,2),(52261991,424640062,14938816,27626,1,'2009-04-01 15:50:48',3310490810,2),(52261993,424638888,14937398,27626,1,'2009-04-01 15:50:48',3310490810,2),(52261997,424637976,14936901,27626,1,'2009-04-01 15:50:48',3310490810,2),(52261999,424653161,14955776,439281,1,'2007-09-16 00:38:23',3310491152,1),(52262003,424652176,14957007,439281,1,'2007-09-16 00:38:23',3310491152,1),(52262006,424651149,14957747,439281,1,'2007-09-16 00:38:24',3310491152,1),(52262010,424650164,14957747,439281,1,'2007-09-16 00:38:24',3310491152,1),(52262016,424648973,14957049,439281,1,'2007-09-16 00:38:24',3310491152,1),(52262020,424648151,14955283,439281,1,'2007-09-16 00:38:24',3310491152,1),(52262022,424644086,14946166,27626,1,'2009-04-01 15:50:49',3310491152,2),(52262025,424636148,14936133,27626,1,'2009-04-01 15:50:48',3310490810,2),(52262028,424633522,14935680,27626,1,'2009-04-01 15:50:48',3310490810,2),(52262031,424630714,14934955,27626,1,'2009-04-01 15:50:48',3310490810,2),(52262034,424628178,14934049,27626,1,'2009-04-01 15:50:48',3310490810,2),(52262036,424626366,14933008,27626,1,'2009-04-01 15:50:48',3310490799,2),(52262037,424624600,14932238,27626,1,'2009-04-01 15:50:48',3310490799,2),(52262039,424622743,14931287,27626,1,'2009-04-01 15:50:48',3310490799,2),(52262041,424621520,14930698,27626,1,'2009-04-01 15:50:48',3310490799,2),(52262042,424619618,14929339,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262044,424617942,14927618,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262045,424615678,14925897,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262046,424613504,14924493,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262047,424611692,14923225,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262048,424609065,14920870,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262052,424607797,14919421,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262054,424606620,14917881,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262057,424605805,14916477,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262058,424605171,14915390,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262060,424604537,14915254,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262063,424603767,14915254,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262064,424603495,14915662,27626,1,'2009-04-01 15:50:47',3310490799,3),(52262065,424603404,14916386,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262067,424603585,14917337,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262070,424604763,14919285,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262072,424606756,14922908,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262074,424609473,14928841,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262076,424611583,14932753,27626,1,'2009-04-01 16:02:41',3310490799,6),(52262079,424597975,14914131,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262081,424599308,14915435,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262084,424600410,14916102,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262086,424601888,14916276,27626,1,'2009-04-01 15:43:48',3310490799,2),(52262087,424596873,14912816,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262089,424595767,14911766,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262092,424594292,14910802,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262095,424592392,14910008,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262097,424590662,14909100,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262101,424588960,14908278,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262103,424587741,14907824,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262106,424586408,14907739,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262109,424584678,14907853,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262111,424583231,14907370,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262114,424581388,14906973,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262115,424579942,14906888,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262117,424577928,14906747,27626,1,'2009-04-01 15:43:47',3310490798,2),(52262119,424575489,14905839,27626,1,'2009-04-01 15:43:47',3310490798,2),(52262131,424574071,14905896,27626,1,'2009-04-01 15:43:47',3310490798,2),(52262133,424572766,14906236,27626,1,'2009-04-01 15:43:47',3310490795,2),(52262136,424571518,14907342,27626,1,'2009-04-01 15:43:47',3310490795,2),(52262137,424570724,14909327,27626,1,'2009-04-01 15:43:47',3310490795,2),(52262139,424570724,14911568,27626,1,'2009-04-01 15:43:47',3310490795,2),(52262143,424571348,14915538,27626,1,'2009-04-01 15:43:47',3310490795,2),(52262146,424572539,14922231,27626,1,'2009-04-01 15:43:47',3310490795,2),(52262150,424573192,14925294,27626,1,'2009-04-01 15:43:47',3310490798,2),(52262152,424573872,14927194,27626,1,'2009-04-01 15:43:47',3310490798,2),(52262155,424575517,14931222,27626,1,'2009-04-01 15:43:47',3310490798,2),(52262158,424576517,14933685,27626,1,'2009-04-01 15:43:47',3310490798,2),(52262161,424577069,14935858,27626,1,'2009-04-01 15:43:47',3310490798,2),(52262163,424576812,14937441,27626,1,'2009-04-01 15:48:56',3310490798,6),(52262166,424576186,14938399,27626,1,'2009-04-01 15:48:56',3310490798,5),(52262168,424575081,14938583,372139,1,'2009-04-10 12:07:13',3310490798,10),(52262176,424574123,14938251,372139,1,'2009-04-10 12:07:13',3310490798,7),(52262179,424573460,14937699,372139,1,'2009-04-10 12:07:13',3310490798,7),(52262183,424572429,14935674,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262187,424571509,14934532,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262191,424569520,14932433,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262193,424568452,14931439,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262198,424567495,14930334,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262201,424566758,14928934,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262204,424566279,14927204,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262207,424566022,14925399,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262210,424565580,14924037,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262213,424565027,14923558,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262215,424564291,14923484,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262217,424563849,14924000,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262221,424563554,14924810,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262225,424563959,14925988,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262229,424564770,14927793,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262231,424566169,14931770,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262233,424568452,14937220,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262236,424569299,14939283,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262239,424569631,14940571,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262240,424569299,14941455,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262244,424568636,14941897,372139,1,'2009-04-10 12:07:12',3310491137,7),(52262245,424567900,14941492,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262247,424567568,14941050,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262251,424567568,14939945,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262252,424567347,14938951,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262257,424566022,14936852,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262259,424562118,14931917,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262263,424560203,14928566,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262265,424558583,14925546,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262271,424558104,14922969,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262275,424557736,14921606,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262279,424557147,14920464,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262283,424556263,14919838,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262287,424555011,14919838,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262290,424554164,14919728,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262293,424553538,14918881,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262297,424552985,14917776,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262300,424552691,14916782,372139,1,'2009-04-10 12:07:11',3310490795,7),(52262303,424551365,14914683,372139,1,'2009-04-10 12:07:11',3310490795,7),(52262306,424548787,14913136,372139,1,'2009-04-10 12:07:11',3310490795,7),(52262310,424546798,14912105,372139,1,'2009-04-10 12:07:11',3310490795,7),(52262313,424543521,14910853,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262316,424540648,14909932,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262317,424536045,14909233,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262321,424535051,14909343,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262325,424534241,14909859,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262328,424533431,14910853,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262332,424535069,14926040,27626,1,'2009-04-01 15:42:40',3310490794,2),(52262335,424536083,14926453,27626,1,'2009-04-01 15:42:40',3310490794,2),(52262338,424536908,14927541,27626,1,'2009-04-01 15:42:40',3310490794,2),(52262341,424537997,14928818,27626,1,'2009-04-01 15:42:40',3310490794,2),(52262345,424539085,14930206,27626,1,'2009-04-01 15:42:40',3310490794,2),(52262348,424539949,14931070,27626,1,'2009-04-01 15:42:40',3310490794,2),(52262350,424541150,14931820,27626,1,'2009-04-01 15:42:40',3310490794,2),(52262353,424542125,14932121,27626,1,'2009-04-01 15:42:40',3310490794,2),(52262356,424542463,14931858,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262360,424542501,14931032,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262362,424541638,14930131,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262366,424539686,14927429,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262369,424538447,14925890,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262373,424538222,14925064,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262375,424538410,14924464,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262379,424539123,14924689,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262380,424540211,14925890,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262383,424543289,14927917,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262389,424545766,14930357,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262391,424547380,14932196,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262395,424548093,14932684,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262397,424548619,14932383,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262401,424548656,14931633,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262404,424547793,14930131,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262408,424545879,14925890,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262411,424543289,14922024,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262413,424541975,14920523,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262417,424540962,14919960,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262420,424540436,14919397,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262422,424540249,14918496,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262426,424540774,14918121,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262428,424541562,14918121,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262431,424542613,14918946,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262434,424546254,14921686,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262438,424548581,14923863,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262442,424549782,14925552,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262448,424550195,14925965,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262451,424550646,14925777,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262454,424550871,14925327,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262457,424550571,14924501,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262459,424549707,14923263,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262463,424548168,14920560,27626,1,'2009-04-01 15:42:42',3310490795,2),(52262466,424545766,14916507,27626,1,'2009-04-01 15:42:42',3310490795,2),(52262470,424543439,14913879,27626,1,'2009-04-01 15:42:42',3310490794,2),(52262473,424541638,14912078,27626,1,'2009-04-01 15:42:42',3310490794,2),(52262476,424539648,14911027,27626,1,'2009-04-01 15:42:42',3310490794,2),(52262480,424538447,14910576,27626,1,'2009-04-01 15:42:42',3310490794,2),(52262482,424537809,14910464,27626,1,'2009-04-01 15:42:42',3310490794,2),(52262485,424537772,14909600,372139,1,'2009-04-10 12:07:11',3310490794,8),(52262488,424532187,14912438,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262492,424531358,14913462,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262495,424530010,14914453,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262498,424528613,14915168,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262500,424527541,14916386,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262504,424525737,14919375,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262509,424523625,14922836,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262512,424522638,14924227,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262515,424522017,14925096,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262521,424520601,14926512,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262523,424518962,14927828,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262527,424517745,14928598,372139,1,'2009-04-10 12:07:11',3310490111,7),(52262531,424517223,14929418,372139,1,'2009-04-10 12:07:11',3310490111,7),(52262535,424517099,14931777,372139,1,'2009-04-10 12:07:11',3310490111,7),(52262538,424529836,14923917,439281,1,'2007-09-16 00:39:03',3310490794,1),(52262541,424529051,14923183,439281,1,'2007-09-16 00:39:03',3310490794,1),(52262544,424528494,14923107,439281,1,'2007-09-16 00:39:03',3310490794,1),(52262546,424527861,14923664,439281,1,'2007-09-16 00:39:04',3310490794,1),(52262550,424527406,14924221,439281,1,'2007-09-16 00:39:04',3310490794,1),(52262552,424526292,14925461,439281,1,'2007-09-16 00:39:04',3310490794,1),(52262556,424524494,14926828,439281,1,'2007-09-16 00:39:04',3310490794,1),(52262560,424520267,14928828,439281,1,'2007-09-16 00:39:04',3310490794,1),(52262563,424517710,14929967,439281,1,'2007-09-16 00:39:04',3310490111,1),(52262566,424517172,14930144,372139,1,'2009-04-10 12:07:11',3310490111,7),(52262570,424516983,14933014,372139,1,'2009-04-10 12:07:11',3310490111,7);
INSERT INTO `current_nodes` VALUES (52262573,424516660,14933705,372139,1,'2009-04-10 12:07:11',3310490111,7),(52262575,424516107,14934074,372139,1,'2009-04-10 12:07:11',3310490111,7),(52262579,424515231,14934028,372139,1,'2009-04-10 12:07:11',3310490111,7),(52262583,424513848,14933844,372139,1,'2009-04-10 12:07:11',3310490111,7),(52262586,424512926,14933337,372139,1,'2009-04-10 12:07:11',3310490111,7),(52262590,424512096,14932322,372139,1,'2009-04-10 12:07:11',3310490111,7),(52262594,424510666,14928173,372139,1,'2009-04-10 12:07:11',3310490111,7),(52262598,424509883,14925406,372139,1,'2009-04-10 12:07:10',3310490111,7),(52262602,424509283,14923377,372139,1,'2009-04-10 12:07:10',3310490111,7),(52262605,424508499,14921579,372139,1,'2009-04-10 12:07:10',3310490111,7),(52262607,424507485,14920150,372139,1,'2009-04-10 12:07:10',3310490111,7),(52262609,424505272,14918674,372139,1,'2009-04-10 12:07:10',3310490111,7),(52262612,424503658,14917706,372139,1,'2009-04-10 12:07:10',3310490111,7),(52262616,424501353,14916738,372139,1,'2009-04-10 12:07:10',3310490111,7),(52262618,424499139,14915862,372139,1,'2009-04-10 12:07:10',3310490111,7),(52262622,424497065,14914525,372139,1,'2009-04-10 12:07:10',3310490111,7),(52262625,424495451,14914110,372139,1,'2009-04-10 12:07:10',3310490111,7),(52262629,424493297,14913864,1165666,1,'2009-05-12 19:44:46',3310490111,8),(52262632,424491967,14913006,1165666,1,'2009-05-12 19:44:46',3310490111,8),(52262636,424490953,14911375,1165666,1,'2009-05-12 19:44:07',3310490111,8),(52262637,424489813,14909229,1165666,1,'2009-05-12 19:44:46',3310490110,8),(52262641,424488927,14908199,1165813,1,'2009-05-12 19:59:07',3310490110,9),(52262644,424487197,14908392,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262646,424484293,14908392,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262650,424481342,14908715,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262654,424480281,14908254,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262659,424479866,14907332,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262661,424479221,14905303,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262664,424478529,14901246,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262666,424477724,14898840,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262671,424476625,14897089,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262675,424475301,14896029,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262678,424473765,14895765,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262684,424470533,14895765,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262688,424467408,14895712,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262691,424464760,14895871,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262695,424462853,14895976,372139,1,'2009-04-10 12:07:10',3310490107,7),(52262698,424461687,14895849,372139,1,'2009-04-10 12:07:10',3310490107,7),(52262700,424460331,14894705,372139,1,'2009-04-10 12:07:10',3310490107,7),(52262703,424459272,14893476,372139,1,'2009-04-10 12:07:10',3310490107,7),(52262706,424458297,14890425,372139,1,'2009-04-10 12:07:10',3310490107,7),(52262710,424456687,14887332,372139,1,'2009-04-10 12:07:10',3310490107,7),(52262713,424455501,14885721,372139,1,'2009-04-10 12:07:10',3310490105,7),(52262718,424454060,14884789,372139,1,'2009-04-10 12:07:10',3310490105,7),(52262723,424452153,14883984,372139,1,'2009-04-10 12:07:10',3310490105,7),(52262725,424449144,14884959,372139,1,'2009-04-10 12:07:09',3310490105,7),(52262727,424446941,14886060,372139,1,'2009-04-10 12:07:09',3310490105,7),(52262729,424445669,14887501,372139,1,'2009-04-10 12:07:09',3310490107,7),(52262732,424444695,14888391,372139,1,'2009-04-10 12:07:09',3310490107,7),(52262736,424442534,14889027,372139,1,'2009-04-10 12:07:09',3310490107,7),(52262738,424439855,14889544,372139,1,'2009-04-10 12:07:09',3310490107,7),(52262742,424437857,14889922,372139,1,'2009-04-10 12:07:09',3310490107,7),(52262746,424435806,14890515,372139,1,'2009-04-10 12:07:09',3310490107,7),(52262748,424434726,14891001,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262752,424433943,14891730,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262757,424433133,14893512,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262760,424432189,14895698,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262764,424431487,14896886,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262768,424430866,14897345,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262773,424430137,14897534,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262776,424429354,14897534,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262781,424427151,14897810,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262784,424425186,14898079,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262788,424422736,14898026,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262792,424419156,14898079,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262796,424417944,14897756,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262798,424416545,14896868,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262802,424415495,14895630,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262805,424414526,14894849,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262809,424413503,14894768,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262814,424412534,14894849,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262817,424410030,14895980,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262821,424407230,14898510,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262824,424404915,14900717,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262826,424401846,14902575,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262830,424399262,14903867,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262833,424396274,14905368,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262836,424394102,14906991,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262838,424393420,14907244,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262842,424392231,14907446,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262845,424391422,14907371,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262848,424390284,14906941,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262850,424388287,14905929,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262854,424386672,14905117,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262858,424384886,14903796,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262862,424383276,14902841,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262866,424381912,14901968,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262869,424381066,14901723,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262874,424380138,14901777,372139,1,'2009-04-10 12:07:08',3310490094,7),(52262878,424379702,14902268,372139,1,'2009-04-10 12:07:08',3310490094,7),(52262883,424379456,14902841,372139,1,'2009-04-10 12:07:08',3310490094,7),(52262884,424379538,14903769,372139,1,'2009-04-10 12:07:08',3310490094,7),(52262887,424380111,14904806,372139,1,'2009-04-10 12:07:08',3310490094,7),(52262889,424381503,14905761,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262892,424382758,14907153,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262893,424383986,14909499,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262896,424386247,14914771,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262898,424387842,14918799,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262901,424388599,14921016,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262903,424389086,14921909,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262905,424389951,14922801,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262908,424392168,14924748,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262910,424417873,14900642,439281,1,'2007-09-16 00:39:26',3310490106,1),(52262913,424415651,14899346,439281,1,'2007-09-16 00:39:26',3310490106,1),(52262916,424414555,14898505,439281,1,'2007-09-16 00:39:26',3310490106,1),(52262919,424413391,14897891,439281,1,'2007-09-16 00:39:26',3310490106,1),(52262921,424412333,14897616,439281,1,'2007-09-16 00:39:27',3310490106,1),(52262925,424410979,14897722,439281,1,'2007-09-16 00:39:27',3310490106,1),(52262930,424410174,14897806,439281,1,'2007-09-16 00:39:28',3310490106,1),(52262934,424409476,14897362,439281,1,'2007-09-16 00:39:28',3310490106,1),(52262938,424409032,14896960,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262941,424411059,14915662,439281,1,'2007-09-16 00:39:29',3310490106,1),(52262944,424408329,14915769,439281,1,'2007-09-16 00:39:29',3310490095,1),(52262946,424405795,14915983,439281,1,'2007-09-16 00:39:29',3310490095,1),(52262949,424402798,14916161,439281,1,'2007-09-16 00:39:29',3310490095,1),(52262954,424399408,14916375,439281,1,'2007-09-16 00:39:30',3310490095,1),(52262957,424396874,14916625,439281,1,'2007-09-16 00:39:30',3310490095,1),(52262961,424395090,14916375,439281,1,'2007-09-16 00:39:30',3310490095,1),(52262963,424392163,14914841,439281,1,'2007-09-16 00:39:31',3310490095,1),(52262967,424384382,14910324,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262970,424406816,14921586,439281,1,'2007-09-16 00:39:31',3310490095,1),(52262973,424404476,14921920,439281,1,'2007-09-16 00:39:31',3310490095,1),(52262977,424401509,14922129,439281,1,'2007-09-16 00:39:32',3310490095,1),(52262979,424398543,14922213,439281,1,'2007-09-16 00:39:32',3310490095,1),(52262981,424396328,14922338,439281,1,'2007-09-16 00:39:32',3310490095,1),(52263076,424394239,14921837,439281,1,'2007-09-16 00:39:41',3310490095,1),(52263079,424391523,14920249,439281,1,'2007-09-16 00:39:41',3310490095,1),(52263083,424387660,14918137,439281,1,'2007-09-16 00:39:41',3310490095,1),(52263086,424387575,14918124,372139,1,'2009-04-10 12:07:08',3310490095,7),(52263090,424384936,14912293,372139,1,'2009-04-10 12:07:08',3310490095,7),(52263091,424376212,14905831,439281,1,'2007-09-16 00:39:41',3310490094,1),(52263095,424379906,14909127,439281,1,'2007-09-16 00:39:42',3310490094,1),(52263098,424384910,14912304,439281,1,'2007-09-16 00:39:42',3310490095,1),(52263100,424374331,14914896,439281,1,'2007-09-16 00:39:42',3310490094,1),(52263106,424378910,14918185,439281,1,'2007-09-16 00:39:42',3310490094,1),(52263109,424379997,14919703,439281,1,'2007-09-16 00:39:42',3310490094,1),(52263111,424381743,14921651,439281,1,'2007-09-16 00:39:42',3310490095,1),(52263113,424384450,14923649,439281,1,'2007-09-16 00:39:43',3310490095,1),(52263117,424386196,14924813,439281,1,'2007-09-16 00:39:43',3310490095,1),(52263119,424387714,14925268,439281,1,'2007-09-16 00:39:43',3310490095,1),(52263122,424393639,14925761,372139,1,'2009-04-10 12:07:08',3310490095,7),(52263124,424395143,14926363,372139,1,'2009-04-10 12:07:08',3310490095,7),(52263126,424396927,14926341,372139,1,'2009-04-10 12:07:08',3310490095,7),(52263130,424399978,14926298,372139,1,'2009-04-10 12:07:08',3310490095,7),(52263133,424403695,14926277,372139,1,'2009-04-10 12:07:08',3310490095,7),(52263136,424405393,14925783,372139,1,'2009-04-10 12:07:08',3310490095,7),(52263140,424407652,14924912,372139,1,'2009-04-10 12:07:08',3310490095,7),(52263142,424409523,14923709,372139,1,'2009-04-10 12:07:08',3310490106,7),(52263144,424411394,14922550,372139,1,'2009-04-10 12:07:08',3310490106,7),(52263149,424413889,14921704,372139,1,'2009-04-10 12:07:08',3310490106,7),(52263152,424416474,14920991,372139,1,'2009-04-10 12:07:08',3310490106,7),(52263155,424419103,14920456,372139,1,'2009-04-10 12:07:08',3310490106,7),(52263158,424422979,14920768,372139,1,'2009-04-10 12:07:08',3310490106,7),(52263162,424375679,14920875,439281,1,'2007-09-16 00:39:46',3310490094,1),(52263166,424377128,14924226,439281,1,'2007-09-16 00:39:46',3310490094,1),(52263168,424378351,14926808,439281,1,'2007-09-16 00:39:46',3310490094,1),(52263171,424380434,14928664,439281,1,'2007-09-16 00:39:47',3310490094,1),(52263173,424384012,14930521,439281,1,'2007-09-16 00:39:47',3310490095,1),(52263177,424386774,14931291,439281,1,'2007-09-16 00:39:47',3310490095,1),(52263180,424389899,14930793,439281,1,'2007-09-16 00:39:47',3310490095,1),(52263183,424394609,14929978,439281,1,'2007-09-16 00:39:47',3310490095,1),(52263186,424397960,14928755,439281,1,'2007-09-16 00:39:48',3310490095,1),(52263190,424400179,14927487,439281,1,'2007-09-16 00:39:48',3310490095,1),(52263191,424400859,14926717,439281,1,'2007-09-16 00:39:48',3310490095,1),(52263195,424401029,14926331,372139,1,'2009-04-10 12:07:08',3310490095,7),(52263200,424425675,14920353,372139,1,'2009-04-10 12:07:08',3310490106,7),(52263203,424428134,14920448,372139,1,'2009-04-10 12:07:08',3310490106,7),(52263208,424430404,14920826,372139,1,'2009-04-10 12:07:08',3310490106,7),(52263209,424433502,14921080,372139,1,'2009-04-10 12:07:08',3310490106,7),(52263213,424435633,14921129,372139,1,'2009-04-10 12:07:08',3310490106,7),(52263217,424438684,14921613,372139,1,'2009-04-10 12:07:08',3310490107,7),(52263220,424441347,14922581,372139,1,'2009-04-10 12:07:08',3310490107,7),(52263224,424442509,14923405,372139,1,'2009-04-10 12:07:08',3310490107,7),(52263227,424444398,14925584,372139,1,'2009-04-10 12:07:08',3310490107,7),(52263231,424445560,14927811,372139,1,'2009-04-10 12:07:08',3310490107,7),(52263233,424446093,14930669,372139,1,'2009-04-10 12:07:08',3310490107,7),(52263234,424446044,14934107,372139,1,'2009-04-10 12:07:08',3310490107,7),(52263411,424446093,14937012,372139,1,'2009-04-10 12:07:08',3310490107,7),(52263414,424446335,14941274,372139,1,'2009-04-10 12:07:08',3310490107,7),(52263416,424447158,14944567,372139,1,'2009-04-10 12:07:08',3310490449,7),(52263498,424450548,14949555,372139,1,'2009-04-10 12:07:08',3310490449,7),(52263502,424454035,14952654,372139,1,'2009-04-10 12:07:08',3310490449,7),(52263504,424458054,14956189,372139,1,'2009-04-10 12:07:08',3310490449,7),(52263506,424460378,14958368,372139,1,'2009-04-10 12:07:07',3310490449,7),(52263507,424461525,14960044,372139,1,'2009-04-10 12:07:07',3310490449,7),(52263509,424462416,14961964,372139,1,'2009-04-10 12:07:07',3310490449,7),(52263512,424463718,14965118,372139,1,'2009-04-10 12:07:07',3310490452,7),(52263513,424464404,14968854,372139,1,'2009-04-10 12:07:07',3310490452,7),(52263516,424464472,14972007,372139,1,'2009-04-10 12:07:07',3310490452,7),(52263519,424464164,14975434,372139,1,'2009-04-10 12:07:07',3310490452,7),(52263520,424464369,14979719,372139,1,'2009-04-10 12:07:07',3310490452,7),(52263524,424465535,14982495,372139,1,'2009-04-10 12:07:07',3310490452,7),(52263527,424467968,14985648,372139,1,'2009-04-10 12:07:07',3310490452,7),(52263530,424469648,14989110,372139,1,'2009-04-10 12:07:07',3310490452,7),(52263533,424470779,14991852,372139,1,'2009-04-10 12:07:07',3310490452,7),(52263537,424471190,14995485,372139,1,'2009-04-10 12:07:07',3310490452,7),(52263541,424470858,14997540,372139,1,'2009-04-10 12:07:07',3310490454,7),(52263543,424469822,15002100,372139,1,'2009-04-10 12:07:07',3310490454,7),(52263546,424446025,14935657,372139,1,'2009-04-10 12:07:08',3310490107,7),(52263549,424453814,14944816,439281,1,'2007-09-16 00:40:18',3310490449,1),(52263553,424460238,14952231,439281,1,'2007-09-16 00:40:19',3310490449,1),(52263554,424464512,14956873,439281,1,'2007-09-16 00:40:19',3310490452,1),(52263556,424466776,14961458,439281,1,'2007-09-16 00:40:19',3310490452,1),(52263559,424467682,14964911,439281,1,'2007-09-16 00:40:19',3310490452,1),(52263560,424469126,14968675,439281,1,'2007-09-16 00:40:19',3310490452,1),(52263563,424470795,14971477,439281,1,'2007-09-16 00:40:19',3310490452,1),(52263566,424472946,14973657,439281,1,'2007-09-16 00:40:19',3310490452,1),(52263570,424474135,14975440,439281,1,'2007-09-16 00:40:19',3310490452,1),(52263573,424476937,14981242,439281,1,'2007-09-16 00:40:20',3310490452,1),(52263575,424479597,14986324,439281,1,'2007-09-16 00:40:20',3310490452,1),(52263577,424467790,14978672,439281,1,'2007-09-16 00:40:20',3310490452,1),(52263579,424469895,14980950,439281,1,'2007-09-16 00:40:20',3310490452,1),(52263581,424471138,14983470,439281,1,'2007-09-16 00:40:21',3310490452,1),(52263584,424472174,14985162,439281,1,'2007-09-16 00:40:21',3310490452,1),(52263586,424474970,14987233,439281,1,'2007-09-16 00:40:21',3310490452,1),(52263588,424475695,14986923,439281,1,'2007-09-16 00:40:21',3310490452,1),(52263593,424473370,14986443,439281,1,'2007-09-16 00:40:22',3310490452,1),(52263595,424475902,14985852,439281,1,'2007-09-16 00:40:22',3310490452,1),(52263598,424475557,14983298,439281,1,'2007-09-16 00:40:22',3310490452,1),(52263602,424474383,14979190,439281,1,'2007-09-16 00:40:22',3310490452,1),(52263605,424473969,14978120,439281,1,'2007-09-16 00:40:22',3310490452,1),(52263608,424472761,14977498,439281,1,'2007-09-16 00:40:23',3310490452,1),(52263611,424471621,14976601,439281,1,'2007-09-16 00:40:23',3310490452,1),(52263615,424470620,14975185,439281,1,'2007-09-16 00:40:23',3310490452,1),(52263617,424469861,14972942,439281,1,'2007-09-16 00:40:23',3310490452,1),(52263618,424469764,14969746,439281,1,'2007-09-16 00:40:24',3310490452,1),(52263621,424464228,14974725,372139,1,'2009-04-10 12:07:07',3310490452,7),(52263623,424481432,14993432,439281,1,'2007-09-16 00:40:24',3310490452,1),(52263625,424480984,14995734,439281,1,'2007-09-16 00:40:24',3310490452,1),(52263628,424479513,14998996,439281,1,'2007-09-16 00:40:24',3310490454,1),(52263629,424478809,15001938,439281,1,'2007-09-16 00:40:24',3310490454,1),(52263632,424478809,15004561,439281,1,'2007-09-16 00:40:24',3310490454,1),(52263634,424478489,15006863,439281,1,'2007-09-16 00:40:25',3310490454,1),(52263637,424477978,15008782,439281,1,'2007-09-16 00:40:25',3310490454,1),(52263639,424477466,15010317,439281,1,'2007-09-16 00:40:25',3310490454,1),(52263641,424477402,15013451,439281,1,'2007-09-16 00:40:26',3310490454,1),(52263644,424477850,15018248,439281,1,'2007-09-16 00:40:26',3310490454,1),(52263646,424478322,15024752,439281,1,'2007-09-16 00:40:26',3310490454,1),(52263649,424479730,15030680,439281,1,'2007-09-16 00:40:26',3310490454,1),(52263650,424481471,15035699,439281,1,'2007-09-16 00:40:26',3310490454,1),(52263652,424483055,15039094,439281,1,'2007-09-16 00:40:26',3310490454,1),(52263655,424483961,15042885,439281,1,'2007-09-16 00:40:27',3310490454,1),(52263657,424484753,15047299,439281,1,'2007-09-16 00:40:27',3310490454,1),(52263660,424485489,15052619,439281,1,'2007-09-16 00:40:27',3310490460,1),(52263662,424486652,15055240,439281,1,'2007-09-16 00:40:27',3310490460,1),(52263665,424487157,15059278,439281,1,'2007-09-16 00:40:27',3310490460,1),(52263667,424486868,15062666,439281,1,'2007-09-16 00:40:27',3310490460,1),(52263669,424486580,15065406,439281,1,'2007-09-16 00:40:28',3310490460,1),(52263670,424479600,15008556,439281,1,'2007-09-16 00:40:28',3310490454,1),(52263672,424479627,15005590,439281,1,'2007-09-16 00:40:28',3310490454,1),(52263674,424479812,15002360,439281,1,'2007-09-16 00:40:29',3310490454,1),(52263677,424493594,15049241,439281,1,'2007-09-16 00:40:29',3310490455,1),(52263678,424481837,15034104,439281,1,'2007-09-16 00:40:29',3310490454,1),(52263681,424479996,15000734,439281,1,'2007-09-16 00:40:29',3310490454,1),(52263683,424480372,14999304,439281,1,'2007-09-16 00:40:29',3310490454,1),(52263686,424480949,14997799,439281,1,'2007-09-16 00:40:29',3310490454,1),(52263687,424481927,14994864,439281,1,'2007-09-16 00:40:29',3310490452,1),(52263688,424482228,14994087,439281,1,'2007-09-16 00:40:30',3310490452,1),(52263691,424482128,14993435,439281,1,'2007-09-16 00:40:30',3310490452,1),(52263693,424481802,14992758,439281,1,'2007-09-16 00:40:30',3310490452,1),(52263696,424481425,14991453,439281,1,'2007-09-16 00:40:30',3310490452,1),(52263698,424479546,15010187,439281,1,'2007-09-16 00:40:30',3310490454,1),(52263700,424479448,15011189,439281,1,'2007-09-16 00:40:30',3310490454,1),(52263702,424479507,15012111,439281,1,'2007-09-16 00:40:31',3310490454,1),(52263704,424479782,15012916,439281,1,'2007-09-16 00:40:31',3310490454,1),(52263706,424480233,15013211,439281,1,'2007-09-16 00:40:31',3310490454,1),(52263708,424480606,15013191,439281,1,'2007-09-16 00:40:31',3310490454,1),(52263711,424481176,15012936,439281,1,'2007-09-16 00:40:31',3310490454,1),(52263712,424481922,15012053,439281,1,'2007-09-16 00:40:31',3310490454,1),(52263713,424482890,15011155,439281,1,'2007-09-16 00:40:31',3310490454,1),(52263716,424483989,15011155,439281,1,'2007-09-16 00:40:32',3310490454,1),(52263717,424486513,15012091,439281,1,'2007-09-16 00:40:32',3310490454,1),(52263718,424490136,15013109,439281,1,'2007-09-16 00:40:32',3310490454,1),(52263721,424490706,15014005,439281,1,'2007-09-16 00:40:32',3310490454,1),(52263722,424491222,15015319,439281,1,'2007-09-16 00:40:32',3310490455,1),(52263724,424492473,15019461,439281,1,'2007-09-16 00:40:33',3310490455,1),(52263726,424494140,15023291,439281,1,'2007-09-16 00:40:33',3310490455,1),(52263727,424480387,15032575,439281,1,'2007-09-16 00:40:33',3310490454,1),(52263730,424468773,15005186,372139,1,'2009-04-10 12:07:07',3310490454,7),(52263731,424467356,15010571,372139,1,'2009-04-10 12:07:07',3310490454,7),(52263732,424466619,15016183,372139,1,'2009-04-10 12:07:07',3310490454,7),(52263734,424466676,15020264,372139,1,'2009-04-10 12:07:07',3310490454,7),(52263736,424466279,15023324,372139,1,'2009-04-10 12:07:07',3310490454,7),(52263738,424465316,15027632,372139,1,'2009-04-10 12:07:07',3310490454,7),(52263739,424464012,15032223,372139,1,'2009-04-10 12:07:07',3310490454,7),(52263742,424463728,15037608,372139,1,'2009-04-10 12:07:07',3310490454,7),(52263743,424462935,15041179,372139,1,'2009-04-10 12:07:07',3310490451,7),(52263744,424460554,15046394,372139,1,'2009-04-10 12:07:07',3310490451,7),(52263746,424458911,15053932,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263747,424458741,15057843,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263749,424459421,15062264,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263750,424460611,15066062,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263754,424462765,15070483,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263755,424464862,15075471,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263757,424466676,15079439,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263760,424468546,15081649,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263762,424470802,15083316,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263763,424472906,15084259,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263765,424475409,15084803,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263766,424477042,15085565,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263767,424477441,15086980,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263769,424477441,15088467,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263771,424476643,15089301,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263772,424475010,15090100,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263774,424473269,15090136,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263775,424470367,15089374,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263777,424466921,15087161,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263779,424461697,15082917,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263781,424456945,15078999,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263782,424453716,15076750,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263784,424450061,15073306,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263785,424447179,15069013,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263787,424445829,15061101,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263788,424445155,15056624,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263790,424443744,15053066,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263792,424443570,15051371,372139,1,'2009-04-10 12:07:07',3310490451,7),(52263793,424443491,15044148,372139,1,'2009-04-10 12:07:07',3310490451,7),(52263794,424442763,15036070,372139,1,'2009-04-10 12:07:07',3310490451,7),(52263795,424441743,15031149,372139,1,'2009-04-10 12:07:07',3310490451,7),(52263796,424440003,15025928,372139,1,'2009-04-10 12:07:07',3310490451,7),(52263797,424437722,15020587,372139,1,'2009-04-10 12:07:07',3310490451,7),(52263798,424434924,15014547,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263800,424433242,15010827,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263802,424432222,15007768,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263803,424431713,15005322,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263806,424430591,15003742,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263808,424428603,15001397,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263811,424425392,14999256,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263813,424423455,14998492,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263815,424420805,14997574,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263817,424417237,14996708,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263818,424414739,14996860,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263820,424412344,14996453,372139,1,'2009-04-10 12:07:06',3310490448,7),(52263823,424409489,14995382,372139,1,'2009-04-10 12:07:06',3310490448,7),(52263825,424408113,14995077,372139,1,'2009-04-10 12:07:06',3310490437,7),(52263827,424406635,14995943,372139,1,'2009-04-10 12:07:06',3310490437,7),(52263829,424406992,14998186,372139,1,'2009-04-10 12:07:06',3310490439,7),(52263832,424408979,15001907,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263835,424411426,15006086,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263837,424414026,15011897,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263839,424415249,15016280,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263843,424416982,15027290,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263846,424418460,15036057,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263849,424418766,15042072,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263850,424418256,15047169,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263852,424418511,15053438,372139,1,'2009-04-10 12:07:06',3310490456,7),(52263854,424414396,15007502,439281,1,'2007-09-16 00:40:45',3310490450,1),(52263857,424417229,15010086,439281,1,'2007-09-16 00:40:46',3310490450,1),(52263858,424418990,15012337,439281,1,'2007-09-16 00:40:47',3310490450,1),(52263860,424420850,15021667,439281,1,'2007-09-16 00:40:47',3310490450,1),(52263863,424423459,15037423,439281,1,'2007-09-16 00:40:47',3310490450,1),(52263865,424427118,15059088,439281,1,'2007-09-16 00:40:47',3310490456,1),(52263868,424411064,15005468,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263870,424417815,14999686,439281,1,'2007-09-16 00:40:47',3310490450,1),(52263873,424416778,14999628,439281,1,'2007-09-16 00:40:47',3310490450,1),(52263875,424416174,15000521,439281,1,'2007-09-16 00:40:47',3310490450,1),(52263876,424415342,15003786,439281,1,'2007-09-16 00:40:47',3310490450,1),(52263877,424420727,15006435,439281,1,'2007-09-16 00:40:48',3310490450,1),(52263882,424419346,15059831,372139,1,'2009-04-10 12:07:06',3310490456,7),(52263883,424420241,15070006,372139,1,'2009-04-10 12:07:06',3310490456,7),(52263887,424421023,15078168,372139,1,'2009-04-10 12:07:06',3310490456,7),(52263888,424421862,15081131,372139,1,'2009-04-10 12:07:06',3310490456,7),(52263891,424423763,15084877,372139,1,'2009-04-10 12:07:06',3310490456,7),(52263893,424424993,15088734,372139,1,'2009-04-10 12:07:06',3310490456,7),(52263896,424427005,15094493,372139,1,'2009-04-10 12:07:06',3310490456,7),(52263898,424428235,15098294,372139,1,'2009-04-10 12:07:06',3310490456,7),(52263901,424431254,15101481,372139,1,'2009-04-10 12:07:06',3310490456,7),(52263903,424436789,15107463,372139,1,'2009-04-10 12:07:06',3310490459,7),(52263906,424440702,15113780,372139,1,'2009-04-10 12:07:06',3310490459,7),(52263908,424443609,15118197,372139,1,'2009-04-10 12:07:06',3310490459,7),(52263910,424446908,15122502,372139,1,'2009-04-10 12:07:06',3310490459,7),(52263913,424450094,15124738,372139,1,'2009-04-10 12:07:06',3310490459,7),(52263914,424454902,15126191,372139,1,'2009-04-10 12:07:06',3310490459,7),(52263917,424458424,15128036,372139,1,'2009-04-10 12:07:06',3310490459,7),(52263919,424461443,15131055,372139,1,'2009-04-10 12:07:06',3310490459,7),(52263921,424462659,15133291,372139,1,'2009-04-10 12:07:06',3310490459,7),(52263924,424465072,15136232,372139,1,'2009-04-10 12:07:06',3310490462,7),(52263926,424467486,15138419,372139,1,'2009-04-10 12:07:06',3310490462,7),(52263929,424470351,15140531,372139,1,'2009-04-10 12:07:05',3310490462,7),(52263932,424473141,15141888,372139,1,'2009-04-10 12:07:05',3310490462,7),(52263935,424476158,15143623,372139,1,'2009-04-10 12:07:05',3310490462,7),(52263937,424478327,15145670,372139,1,'2009-04-10 12:07:05',3310490462,7),(52263938,424480257,15148720,372139,1,'2009-04-10 12:07:05',3310490462,7),(52263941,424483423,15155129,372139,1,'2009-04-10 12:07:05',3310490462,7),(52263944,424485161,15159724,372139,1,'2009-04-10 12:07:05',3310490462,7),(52263945,424486319,15164280,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263947,424486937,15168720,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263948,424486975,15171036,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263950,424486666,15173044,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263951,424485933,15175013,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263952,424484041,15177214,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263954,424483037,15177214,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263955,424482149,15176789,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263957,424481686,15176210,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263959,424481261,15175091,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263961,424480373,15172504,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263962,424478751,15169994,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263964,424475971,15168025,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263965,424473539,15166442,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263968,424471454,15165631,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263969,424469137,15165206,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263972,424466589,15165284,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263973,424463848,15165129,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263975,424461531,15164627,372139,1,'2009-04-10 12:07:05',3310490481,7),(52263977,424457786,15163585,372139,1,'2009-04-10 12:07:05',3310490481,7),(52263978,424453986,15161306,372139,1,'2009-04-10 12:07:05',3310490459,7),(52263979,424450703,15159224,372139,1,'2009-04-10 12:07:05',3310490459,7),(52263981,424448061,15157623,372139,1,'2009-04-10 12:07:05',3310490459,7),(52263982,424444939,15154500,372139,1,'2009-04-10 12:07:05',3310490459,7),(52263984,424442457,15150817,372139,1,'2009-04-10 12:07:04',3310490459,7),(52263985,424440455,15147535,372139,1,'2009-04-10 12:07:04',3310490459,7),(52263986,424439543,15145361,372139,1,'2009-04-10 12:07:04',3310490459,7),(52263987,424438940,15143918,372139,1,'2009-04-10 12:07:04',3310490459,7),(52263989,424438231,15141819,372139,1,'2009-04-10 12:07:04',3310490459,7),(52263990,424437523,15140638,372139,1,'2009-04-10 12:07:04',3310490459,7),(52263992,424436972,15139668,372139,1,'2009-04-10 12:07:04',3310490459,7),(52263993,424436159,15138907,372139,1,'2009-04-10 12:07:04',3310490459,7),(52263994,424435162,15138093,372139,1,'2009-04-10 12:07:04',3310490458,7),(52263996,424433535,15136860,372139,1,'2009-04-10 12:07:04',3310490458,7),(52263997,424431856,15136205,372139,1,'2009-04-10 12:07:04',3310490458,7),(52263999,424430676,15135837,372139,1,'2009-04-10 12:07:04',3310490458,7),(52264003,424429862,15135837,372139,1,'2009-04-10 12:07:04',3310490458,7),(52264006,424429364,15136178,372139,1,'2009-04-10 12:07:04',3310490458,7),(52264009,424429102,15136651,372139,1,'2009-04-10 12:07:04',3310490458,7),(52264013,424429128,15137543,372139,1,'2009-04-10 12:07:04',3310490458,7),(52264015,424429731,15139248,372139,1,'2009-04-10 12:07:04',3310490458,7),(52264018,424430335,15140481,372139,1,'2009-04-10 12:07:04',3310490458,7),(52264020,424431673,15146043,372139,1,'2009-04-10 12:07:04',3310490458,7),(52264022,424432801,15150398,372139,1,'2009-04-10 12:07:04',3310490458,7),(52264034,424434589,15155730,372139,1,'2009-04-10 12:07:04',3310490458,7),(52264041,424435926,15158938,372139,1,'2009-04-10 12:07:04',3310490459,7),(52264051,424440001,15165933,372139,1,'2009-04-10 12:07:04',3310490481,7),(52264067,424442857,15169944,372139,1,'2009-04-10 12:07:04',3310490481,7),(52264068,424446323,15176362,372139,1,'2009-04-10 12:07:04',3310490481,7),(52264070,424448365,15179025,372139,1,'2009-04-10 12:07:04',3310490481,7),(52264090,424450594,15181505,372139,1,'2009-04-10 12:07:04',3310490481,7),(52265016,424453759,15183860,372139,1,'2009-04-10 12:07:04',3310490481,7),(52265020,424456105,15185481,372139,1,'2009-04-10 12:07:04',3310490481,7),(52265022,424458367,15187273,372139,1,'2009-04-10 12:07:03',3310490481,7),(52265024,424462761,15190430,372139,1,'2009-04-10 12:07:03',3310490481,7),(52265025,424463800,15191652,372139,1,'2009-04-10 12:07:03',3310490484,7),(52265026,424464986,15194531,372139,1,'2009-04-10 12:07:03',3310490484,7),(52265028,424465098,15198992,372139,1,'2009-04-10 12:07:03',3310490484,7),(52265029,424465550,15208647,372139,1,'2009-04-10 12:07:03',3310490484,7),(52265031,424466115,15212205,372139,1,'2009-04-10 12:07:03',3310490484,7),(52265032,424466284,15214407,372139,1,'2009-04-10 12:07:03',3310490484,7),(52265034,424466171,15215254,372139,1,'2009-04-10 12:07:03',3310490484,7),(52265035,424465381,15215423,372139,1,'2009-04-10 12:07:03',3310490484,7),(52265037,424464421,15215141,372139,1,'2009-04-10 12:07:03',3310490484,7),(52265038,424464026,15214633,372139,1,'2009-04-10 12:07:03',3310490484,7),(52265039,424463292,15213729,372139,1,'2009-04-10 12:07:03',3310490484,7),(52265042,424462219,15212713,372139,1,'2009-04-10 12:07:03',3310490481,7),(52265045,424460694,15211132,372139,1,'2009-04-10 12:07:03',3310490481,7),(52265046,424458662,15209438,372139,1,'2009-04-10 12:07:03',3310490481,7),(52265047,424456629,15208252,372139,1,'2009-04-10 12:07:03',3310490481,7),(52265050,424453580,15207066,372139,1,'2009-04-10 12:07:03',3310490481,7),(52265051,424451829,15205993,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265054,424449288,15204412,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265056,424447538,15202606,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265058,424445901,15199952,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265060,424444432,15197806,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265062,424443529,15196564,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265063,424442174,15195039,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265066,424440988,15194023,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265067,424439012,15192668,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265070,424437939,15192216,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265080,424437261,15192611,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265083,424436923,15193233,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265086,424437431,15194757,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265087,424439068,15197524,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265090,424440706,15201476,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265091,424441270,15205485,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265093,424441779,15210228,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265098,424443077,15214124,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265123,424445562,15219601,372139,1,'2009-04-10 12:07:02',3310490483,7),(52265126,424447933,15223385,372139,1,'2009-04-10 12:07:02',3310490483,7),(52265659,424449401,15225643,372139,1,'2009-04-10 12:07:02',3310490483,7),(52266609,424451321,15226942,372139,1,'2009-04-10 12:07:02',3310490483,7),(52266636,424453693,15227902,372139,1,'2009-04-10 12:07:02',3310490483,7),(52266649,424456234,15228523,372139,1,'2009-04-10 12:07:02',3310490483,7),(52266660,424457758,15229426,372139,1,'2009-04-10 12:07:02',3310490483,7),(52266744,424458944,15231064,372139,1,'2009-04-10 12:07:02',3310490483,7),(52266751,424459339,15232532,372139,1,'2009-04-10 12:07:02',3310490483,7),(52266753,424459339,15233830,372139,1,'2009-04-10 12:07:02',3310490483,7),(52266755,424458831,15235073,372139,1,'2009-04-10 12:07:02',3310490483,7),(52266758,424457645,15236541,372139,1,'2009-04-10 12:07:02',3310490483,7),(52266907,424455895,15237444,372139,1,'2009-04-10 12:07:02',3310490483,7),(52266920,424454408,15238923,372139,1,'2009-04-10 12:07:01',3310490483,7),(52266924,424453059,15241211,372139,1,'2009-04-10 12:07:01',3310490483,7),(52266938,424452179,15243322,372139,1,'2009-04-10 12:07:01',3310490483,7),(52266950,424451417,15245727,372139,1,'2009-04-10 12:07:01',3310490483,7),(52266951,424450595,15248719,372139,1,'2009-04-10 12:07:01',3310490483,7),(52266970,424450126,15251651,372139,1,'2009-04-10 12:07:01',3310490483,7),(52266974,424450302,15254643,372139,1,'2009-04-10 12:07:01',3310490483,7),(52267141,424450790,15258926,372139,1,'2009-04-10 12:07:01',3310490483,7),(52267772,424451909,15262459,372139,1,'2009-04-10 12:07:01',3310490483,7),(52267852,424453229,15265167,372139,1,'2009-04-10 12:07:01',3310490483,7),(52268007,424454549,15267977,372139,1,'2009-04-10 12:07:01',3310490483,7),(52268011,424455294,15270346,372139,1,'2009-04-10 12:07:01',3310490483,7),(52268014,424456208,15272987,372139,1,'2009-04-10 12:07:01',3310490489,7),(52268039,424456479,15275864,372139,1,'2009-04-10 12:07:01',3310490489,7),(52268116,424456242,15278064,372139,1,'2009-04-10 12:07:01',3310490489,7),(52268118,424455705,15280751,372139,1,'2009-04-10 12:07:01',3310490489,7),(52268120,424454886,15284848,372139,1,'2009-04-10 12:07:01',3310490489,7),(52268128,424453765,15288039,372139,1,'2009-04-10 12:07:01',3310490489,7),(52268133,424452773,15290498,372139,1,'2009-04-10 12:07:01',3310490489,7),(52268137,424451307,15293430,372139,1,'2009-04-10 12:07:01',3310490489,7),(52268141,424450315,15295802,372139,1,'2009-04-10 12:07:01',3310490489,7),(52268147,424449857,15297018,372139,1,'2009-04-10 12:07:01',3310490489,7),(52268151,424448602,15298523,372139,1,'2009-04-10 12:07:01',3310490489,7),(52268156,424447420,15300351,372139,1,'2009-04-10 12:07:01',3310490489,13),(52268160,424446488,15301784,372139,1,'2009-04-10 12:07:01',3310490489,9),(52268163,424446201,15303755,372139,1,'2009-04-10 12:07:01',3310490489,9),(52268166,424446309,15306479,372139,1,'2009-04-10 12:07:01',3310490489,10),(52283089,424446362,15308365,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283094,424446135,15310681,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283101,424445636,15312997,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283115,424445091,15314268,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283304,424444682,15314677,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283821,424444273,15314768,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283839,424443910,15314722,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283841,424443501,15314268,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283844,424443320,15313814,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283852,424443411,15312179,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283856,424443819,15310000,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283862,424444001,15305186,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283881,424444001,15302371,372139,1,'2009-04-10 12:07:01',3310490489,9),(52284228,424444137,15300600,372139,1,'2009-04-10 12:07:01',3310490489,9),(52284281,424444682,15299101,372139,1,'2009-04-10 12:07:01',3310490489,9),(52284345,424445817,15297239,372139,1,'2009-04-10 12:07:01',3310490489,9),(52284351,424446317,15295605,372139,1,'2009-04-10 12:07:01',3310490489,9),(52284354,424446726,15293016,372139,1,'2009-04-10 12:07:01',3310490489,9),(52284371,424446862,15290428,372139,1,'2009-04-10 12:07:00',3310490489,9),(52284375,424446453,15287340,372139,1,'2009-04-10 12:07:00',3310490489,9),(52284383,424445727,15284434,372139,1,'2009-04-10 12:07:00',3310490489,9),(52284388,424445272,15282436,372139,1,'2009-04-10 12:07:00',3310490489,9),(52284408,424444491,15279819,372139,1,'2009-04-10 12:07:00',3310490489,9),(52284434,424443570,15278062,372139,1,'2009-04-10 12:07:00',3310490489,9),(52284446,424442231,15275634,372139,1,'2009-04-10 12:07:00',3310490489,9),(52284467,424440390,15272914,372139,1,'2009-04-10 12:07:00',3310490489,9),(52284474,424437586,15268771,372139,1,'2009-04-10 12:07:00',3310490483,9),(52284478,424435996,15265967,372139,1,'2009-04-10 12:07:00',3310490483,9),(52284484,424434615,15263289,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284488,424433945,15260527,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284491,424433150,15256216,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284492,424432146,15250859,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284494,424431309,15248223,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284498,424430472,15245628,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284506,424428756,15241234,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284509,424427668,15238556,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284511,424426077,15234747,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284514,424424361,15230855,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284516,424422939,15228344,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284519,424421641,15226043,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284528,424420679,15224871,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284730,424419967,15224703,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284787,424419674,15225080,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284790,424419591,15225624,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284796,424420135,15227131,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284798,424420930,15230186,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284802,424422269,15237467,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284806,424423022,15241862,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284810,424423985,15249060,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284813,424424194,15251362,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284816,424424110,15253705,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284821,424423901,15257765,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284823,424423817,15260987,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284826,424424069,15265423,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284832,424424696,15269315,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284836,424425408,15273458,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284838,424426412,15279443,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284840,424427124,15283544,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284842,424427793,15286725,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284845,424428505,15289319,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284849,424428588,15292039,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284852,424428630,15294132,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284857,424428291,15295899,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284863,424427747,15298209,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284867,424426479,15301967,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284871,424425030,15305047,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284876,424424215,15308443,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284881,424423943,15311296,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284886,424424577,15313741,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284889,424425438,15316277,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284894,424426117,15318270,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284901,424426460,15320276,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284906,424426460,15320926,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284910,424426252,15321946,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284916,424425927,15322688,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284919,424425463,15322989,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284922,424425093,15322989,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284929,424424861,15322896,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284933,424424536,15322131,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284936,424424559,15321088,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284939,424424466,15319998,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284942,424423840,15318769,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284949,424423006,15317564,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284953,424422287,15316381,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284957,424421707,15315060,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284960,424421151,15313599,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284966,424420641,15311930,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284971,424420223,15310492,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284974,424419992,15308730,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284979,424419992,15307501,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284983,424420618,15305623,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284986,424421406,15303073,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284990,424421754,15301218,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284996,424421661,15298853,372139,1,'2009-04-10 12:06:59',3310490488,9),(52285000,424421383,15297183,372139,1,'2009-04-10 12:06:58',3310490488,9),(52285005,424420803,15294795,372139,1,'2009-04-10 12:06:58',3310490488,9),(52285012,424420154,15293079,372139,1,'2009-04-10 12:06:58',3310490488,9),(52285017,424419458,15291503,372139,1,'2009-04-10 12:06:58',3310490488,9),(52286408,424418763,15289648,372139,1,'2009-04-10 12:06:58',3310490488,9),(52286411,424418160,15288187,372139,1,'2009-04-10 12:06:58',3310490488,9),(52286415,424417441,15286657,372139,1,'2009-04-10 12:06:58',3310490488,9),(52286419,424416212,15284988,372139,1,'2009-04-10 12:06:58',3310490488,9),(52286422,424414714,15282987,372139,1,'2009-04-10 12:06:58',3310490488,9),(52286430,424413113,15280602,372139,1,'2009-04-10 12:06:58',3310490488,9),(52286433,424411159,15277355,372139,1,'2009-04-10 12:06:58',3310490488,9),(52286438,424410454,15275813,372139,1,'2009-04-10 12:06:58',3310490488,9),(52286440,424409983,15273408,372139,1,'2009-04-10 12:06:58',3310490488,9),(52286441,424409382,15271187,372139,1,'2009-04-10 12:06:58',3310490482,9),(52286445,424408703,15269018,372139,1,'2009-04-10 12:06:58',3310490482,9),(52286448,424407892,15266718,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286451,424407030,15264444,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286456,424405985,15261909,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286458,424404880,15259716,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286462,424404283,15257657,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286465,424403471,15254731,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286468,424402462,15252593,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286470,424401352,15250485,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286473,424399604,15247932,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286476,424397995,15245463,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286479,424396302,15242938,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286483,424394998,15240551,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286485,424393833,15238248,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286488,424392612,15235696,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286490,424391641,15233698,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286493,424390697,15231284,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286496,424389726,15227899,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286497,424388644,15223654,372139,1,'2009-04-10 12:06:57',3310490471,9),(52286500,424387728,15220768,372139,1,'2009-04-10 12:06:57',3310490471,9),(52286502,424386500,15217787,372139,1,'2009-04-10 12:06:57',3310490471,9),(52286504,424385261,15215190,372139,1,'2009-04-10 12:06:57',3310490469,9),(52286505,424383943,15212473,372139,1,'2009-04-10 12:06:57',3310490469,9),(52286520,424382744,15210395,372139,1,'2009-04-10 12:06:57',3310490469,9),(52286521,424380626,15208038,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286524,424378986,15206131,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286527,424377697,15204658,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286528,424375427,15202244,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286531,424374138,15200628,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286534,424373197,15199769,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286537,424372501,15199114,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286538,424371928,15198948,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286541,424371474,15199245,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286542,424371560,15200178,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286545,424372195,15201753,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286547,424372665,15203717,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286549,424373165,15205704,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286552,424373542,15208027,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286554,424373728,15210232,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286556,424373858,15212995,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286560,424373884,15217035,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286561,424373702,15224515,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286564,424373702,15228841,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286566,424373702,15231291,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286568,424373493,15232333,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286574,424373311,15233089,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286577,424372738,15233350,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286579,424372164,15233298,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286581,424371721,15232881,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286582,424371174,15232177,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286585,424369454,15230431,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286588,424368098,15228815,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286590,424366795,15226574,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286593,424364887,15223290,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286596,424364026,15221224,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286599,424363223,15219044,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286604,424362248,15215315,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286605,424361444,15211700,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286608,424360848,15207328,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286610,424360618,15204207,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286612,424360205,15201085,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286613,424359930,15197551,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286615,424359608,15196036,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286617,424359195,15194889,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286619,424358580,15194466,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286623,424358029,15194797,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286625,424357625,15195568,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286636,424451134,15311742,27626,1,'2009-04-01 16:02:27',3310490489,5),(52286640,424449669,15309750,27626,1,'2009-04-01 16:02:27',3310490489,5),(52286643,424448426,15307522,27626,1,'2009-04-01 16:02:27',3310490489,5),(52286651,424452496,15313549,27626,1,'2009-04-01 16:02:27',3310490489,5),(52286652,424453205,15314793,27626,1,'2009-04-01 16:02:27',3310490489,5),(52286655,424453637,15315916,27626,1,'2009-04-01 16:02:27',3310490489,5),(52286658,424453827,15316780,27626,1,'2009-04-01 16:02:27',3310490489,5),(52286661,424453844,15317730,27626,1,'2009-04-01 16:02:27',3310490489,5),(52286663,424453620,15318750,27626,1,'2009-04-01 16:02:28',3310490489,5),(52286665,424453153,15319355,27626,1,'2009-04-01 16:02:28',3310490489,5),(52286667,424452220,15320374,27626,1,'2009-04-01 16:02:28',3310490489,5),(52286668,424449979,15322625,27626,1,'2009-04-01 16:02:28',3310490489,5),(52286671,424448409,15324095,27626,1,'2009-04-01 16:02:28',3310490489,5),(52286674,424447209,15325245,27626,1,'2009-04-01 16:02:28',3310490489,5),(52286677,424445839,15326783,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286679,424444825,15328593,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286681,424443997,15329996,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286683,424442762,15331839,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286685,424441883,15333259,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286688,424439635,15336700,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286691,424438320,15339008,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286694,424436801,15343215,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286697,424436216,15345581,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286698,424435632,15347276,27626,1,'2009-04-01 16:02:28',3310490490,5),(52286701,424435428,15348415,27626,1,'2009-04-01 16:02:28',3310490490,5),(52286702,424435661,15349467,27626,1,'2009-04-01 16:02:28',3310490490,5),(52286705,424436275,15350314,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286706,424437064,15350431,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286709,424438028,15350460,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286712,424439109,15350986,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286715,424440307,15351424,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286719,424441271,15351337,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286721,424442527,15351103,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286723,424444221,15350314,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286725,424446763,15349000,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286728,424448487,15348240,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286730,424450532,15348065,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286733,424452782,15348386,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286735,424454534,15348883,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286740,424456287,15349233,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286743,424457193,15349438,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286746,424458479,15349467,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286750,424459472,15349116,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286751,424460757,15347948,27626,1,'2009-04-01 16:02:29',3310490491,5),(52286754,424462335,15346662,27626,1,'2009-04-01 16:02:29',3310490491,5),(52286757,424464000,15345494,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286759,424465506,15344856,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286763,424467677,15344133,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286765,424469446,15343570,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286769,424470756,15343540,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286770,424471810,15343729,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286772,424472379,15344214,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286774,424472758,15345057,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286776,424472969,15346216,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286777,424473622,15349061,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286779,424474086,15350263,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286781,424474592,15351127,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286783,424475393,15351654,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286785,424476152,15351675,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286787,424477142,15351148,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286789,424478048,15350410,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286792,424479271,15349356,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286793,424480346,15348197,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286795,424481315,15346722,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286798,424482053,15345268,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286802,424482812,15343561,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286807,424483338,15341896,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286809,424483633,15340315,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286812,424483507,15337786,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286814,424483149,15336121,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286817,424482896,15334625,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286820,424482727,15332728,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286823,424482664,15330978,27626,1,'2009-04-01 16:02:30',3310490494,5),(52286825,424483170,15329777,27626,1,'2009-04-01 16:02:30',3310490494,5),(52286826,424484118,15328660,27626,1,'2009-04-01 16:02:30',3310490494,5),(52286829,424484877,15327269,27626,1,'2009-04-01 16:02:30',3310490494,5),(52286831,424485446,15325899,27626,1,'2009-04-01 16:02:30',3310490492,5),(52286835,424486205,15324803,27626,1,'2009-04-01 16:02:30',3310490492,5),(52286836,424487490,15323749,27626,1,'2009-04-01 16:02:30',3310490492,5),(52286838,424490146,15322527,27626,1,'2009-04-01 16:02:30',3310490492,5),(52286841,424491895,15322000,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286845,424493392,15321473,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286847,424494108,15320757,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286850,424494993,15319450,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286853,424495373,15318206,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286855,424495288,15317089,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286856,424495099,15315825,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286860,424494972,15314687,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286861,424495057,15313043,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286865,424495583,15311821,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286867,424496207,15310662,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286868,424496661,15309270,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286871,424496812,15307968,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286874,424497569,15306697,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286876,424499022,15306092,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286880,424500565,15306183,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286883,424501988,15306818,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286885,424503259,15307968,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286889,424504530,15309542,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286892,424505771,15311570,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286895,424506830,15314143,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286896,424507890,15316322,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286899,424509433,15318955,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286902,424510765,15320559,27626,1,'2009-04-01 16:02:31',3310490493,5),(52286904,424512278,15322133,27626,1,'2009-04-01 16:02:31',3310490493,5),(52286906,424513973,15323101,27626,1,'2009-04-01 16:02:31',3310490493,5),(52286908,424515940,15323192,27626,1,'2009-04-01 16:02:31',3310490493,5),(52286910,424518180,15323404,27626,1,'2009-04-01 16:02:31',3310490493,5),(52286912,424521418,15324191,27626,1,'2009-04-01 16:02:31',3310491176,5),(52286914,424523779,15325462,27626,1,'2009-04-01 16:02:31',3310491176,5),(52286917,424525980,15326951,27626,1,'2009-04-01 16:02:31',3310491178,5),(52286920,424527863,15328363,27626,1,'2009-04-01 16:02:31',3310491178,5),(52286923,424529484,15329147,27626,1,'2009-04-01 16:02:31',3310491178,5),(52286924,424532099,15329670,27626,1,'2009-04-01 16:02:31',3310491178,5),(52286926,424533982,15330298,27626,1,'2009-04-01 16:02:31',3310491178,5),(52286929,424535708,15330978,27626,1,'2009-04-01 16:02:31',3310491178,5),(52286932,424537591,15331449,27626,1,'2009-04-01 16:02:31',3310491178,5),(52286935,424539212,15332181,27626,1,'2009-04-01 16:02:31',3310491178,5),(52286936,424541385,15333517,27626,1,'2009-04-01 16:02:31',3310491178,5),(52286938,424542691,15334589,27626,1,'2009-04-01 16:02:31',3310491178,5),(52286941,424544532,15336128,27626,1,'2009-04-01 16:02:31',3310491178,5),(52286944,424546406,15339074,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286947,424542021,15326154,439281,1,'2007-09-16 01:39:15',3310491176,1),(52286950,424541988,15327325,439281,1,'2007-09-16 01:39:16',3310491178,1),(52286951,424542523,15328631,439281,1,'2007-09-16 01:39:16',3310491178,1),(52286954,424543260,15329936,439281,1,'2007-09-16 01:39:17',3310491178,1),(52286967,424544431,15331275,439281,1,'2007-09-16 01:39:18',3310491178,1),(52286970,424545636,15332246,439281,1,'2007-09-16 01:39:19',3310491178,1),(52286971,424546406,15333015,439281,1,'2007-09-16 01:39:19',3310491179,1),(52286973,424547009,15334622,439281,1,'2007-09-16 01:39:19',3310491179,1),(52286974,424547578,15337434,439281,1,'2007-09-16 01:39:19',3310491179,1),(52286975,424548850,15343492,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286977,424550089,15345890,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286979,424550915,15346954,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286981,424552217,15347581,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286982,424553084,15347147,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286983,424553759,15346472,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286986,424555446,15344255,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286987,424557952,15339580,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286990,424558916,15337411,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286991,424560170,15333651,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286994,424560844,15330181,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286997,424561085,15326373,27626,1,'2009-04-01 16:02:31',3310491179,5),(52287000,424561621,15323304,27626,1,'2009-04-01 16:02:31',3310491177,5),(52287003,424562187,15321465,27626,1,'2009-04-01 16:02:31',3310491177,5),(52287005,424562564,15319815,27626,1,'2009-04-01 16:02:31',3310491177,5),(52287008,424562687,15318277,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287010,424562564,15316560,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287013,424562480,15314995,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287015,424562366,15312920,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287018,424562480,15309939,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287019,424562630,15307411,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287022,424562630,15305186,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287024,424563045,15303148,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287027,424563649,15300960,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287029,424564328,15298847,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287030,424565309,15297036,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287033,424566101,15295829,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287034,424567309,15295225,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287037,424568893,15295188,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287040,424571836,15295980,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287043,424573798,15296584,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287045,424575722,15297451,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287048,424576703,15297829,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287051,424577646,15297715,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287053,424578438,15297112,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287056,424579759,15294999,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287059,424532354,15325774,439281,1,'2007-09-16 01:39:26',3310491176,1),(52287062,424537860,15331343,439281,1,'2007-09-16 01:39:26',3310491178,1),(52287063,424535231,15328748,439281,1,'2007-09-16 01:39:26',3310491178,1),(52287066,424580473,15293844,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287068,424581425,15293042,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287071,424582728,15292040,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287074,424584331,15291188,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287076,424585133,15290415,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287078,424585484,15289735,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287082,424585484,15288883,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287084,424585283,15287681,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287085,424584932,15285376,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287089,424584441,15283676,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287092,424583830,15282069,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287095,424583119,15280762,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287098,424582189,15279415,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287101,424581836,15278004,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287103,424581868,15276786,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287106,424582253,15275086,27626,1,'2009-04-01 16:02:32',3310491180,5);
INSERT INTO `current_nodes` VALUES (52287110,424582839,15273882,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287111,424583304,15272878,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287114,424583377,15271702,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287116,424583133,15270625,27626,1,'2009-04-01 16:02:32',3310491174,5),(52287117,424582447,15268910,27626,1,'2009-04-01 16:02:32',3310491174,5),(52287119,424581878,15267355,27626,1,'2009-04-01 16:02:32',3310491174,5),(52287120,424581384,15266121,27626,1,'2009-04-01 16:02:32',3310491174,5),(52287123,424580678,15264992,27626,1,'2009-04-01 16:02:32',3310491174,5),(52287127,424579091,15260619,27626,1,'2009-04-01 16:02:32',3310491174,5),(52287129,424578280,15258679,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287132,424577786,15257127,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287135,424577317,15255207,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287138,424576504,15253682,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287140,424575691,15252021,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287142,424575047,15250632,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287144,424574471,15249277,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287147,424573548,15247350,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287150,424572768,15245580,27626,1,'2009-04-01 16:02:33',3310491171,5),(52287153,424572403,15244617,27626,1,'2009-04-01 16:02:33',3310491171,5),(52287156,424572403,15243732,27626,1,'2009-04-01 16:02:33',3310491171,5),(52287159,424572585,15243056,27626,1,'2009-04-01 16:02:33',3310491171,5),(52287160,424573054,15242171,27626,1,'2009-04-01 16:02:33',3310491171,5),(52287163,424573939,15241052,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287165,424574902,15240115,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287167,424575448,15239543,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287170,424576255,15238346,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287173,424576879,15237513,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287174,424577842,15236914,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287177,424578727,15236524,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287181,424579664,15236134,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287183,424580288,15235561,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287186,424580731,15234884,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287188,424581303,15233765,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287191,424581720,15232360,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287192,424582006,15231267,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287193,424582787,15230278,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287194,424583906,15229133,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287196,424584791,15227416,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287198,424585181,15225308,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287200,424585493,15223018,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287202,424585884,15221508,27626,1,'2009-04-01 16:02:34',3310491174,5),(52287205,424586456,15219556,27626,1,'2009-04-01 16:02:34',3310491174,5),(52287208,424586963,15217270,27626,1,'2009-04-01 16:02:34',3310491174,5),(52287210,424587218,15215636,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287212,424587324,15214087,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287216,424587260,15212687,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287217,424587069,15211095,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287220,424586581,15209376,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287223,424585732,15206894,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287225,424584799,15204156,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287228,424584141,15201907,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287231,424583271,15198873,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287234,424582613,15196305,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287238,424582167,15194608,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287239,424582061,15193441,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287243,424582167,15192613,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287244,424582613,15191934,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287247,424583101,15191934,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287251,424583462,15192104,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287254,424583759,15192634,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287255,424583907,15193420,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287257,424584247,15194862,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287260,424584565,15196963,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287262,424585181,15198873,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287265,424585754,15200507,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287268,424587281,15203032,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287271,424588576,15205026,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287274,424590188,15207382,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287276,424591398,15208910,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287278,424593477,15210713,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287283,424597466,15212962,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287286,424599801,15214172,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287289,424603302,15215487,27626,1,'2009-04-01 16:02:35',3310491173,5),(52287292,424606421,15216400,27626,1,'2009-04-01 16:02:35',3310491175,5),(52287295,424609158,15216888,27626,1,'2009-04-01 16:02:35',3310491175,5),(52287299,424610559,15217121,27626,1,'2009-04-01 16:02:35',3310491175,5),(52287301,424611959,15217164,27626,1,'2009-04-01 16:02:35',3310491175,5),(52287305,424612850,15216867,27626,1,'2009-04-01 16:02:35',3310491175,5),(52287308,424613317,15216527,27626,1,'2009-04-01 16:02:35',3310491175,5),(52287311,424613317,15215742,27626,1,'2009-04-01 16:02:35',3310491173,5),(52287315,424613169,15215106,27626,1,'2009-04-01 16:02:35',3310491173,5),(52287317,424612681,15214893,27626,1,'2009-04-01 16:02:35',3310491173,5),(52287320,424611768,15214745,27626,1,'2009-04-01 16:02:35',3310491173,5),(52287323,424610410,15214830,27626,1,'2009-04-01 16:02:35',3310491173,5),(52287326,424608582,15214494,27626,1,'2009-04-01 16:02:35',3310491173,5),(52287329,424606512,15213776,27626,1,'2009-04-01 16:02:35',3310491173,5),(52287331,424604062,15212339,27626,1,'2009-04-01 16:02:35',3310491173,5),(52287335,424601865,15210903,27626,1,'2009-04-01 16:02:35',3310491173,5),(52287354,424600007,15209721,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287357,424598233,15208411,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287360,424596839,15206637,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287362,424596163,15205539,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287364,424595487,15203258,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287369,424594980,15201822,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287371,424594304,15200512,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287373,424593586,15199583,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287378,424592657,15197893,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287380,424591728,15195232,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287384,424591010,15191735,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287387,424590469,15188356,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287392,424590165,15186058,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287393,424589827,15183929,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287395,424589354,15181800,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287399,424588712,15179840,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287400,424588070,15177846,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287403,424587394,15175751,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287408,424586313,15172946,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287411,424585333,15170175,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287414,424584522,15168283,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287417,424583880,15166627,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287422,424583238,15165850,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287426,424582528,15164836,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287428,424582359,15164194,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287430,424582596,15163552,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287433,424583069,15163383,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287436,424583542,15163586,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287441,424584285,15164296,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287443,424585366,15166222,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287444,424588036,15170513,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287447,424591415,15176900,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287449,424594490,15182543,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287453,424597126,15187578,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287457,424598985,15190620,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287459,424601553,15193424,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287462,424603614,15195688,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287464,424604662,15196635,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287467,424605642,15197243,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287470,424606385,15197344,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287473,424606858,15197175,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287477,424607095,15196736,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287480,424607196,15196026,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287483,424606926,15195249,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287486,424606520,15194742,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287489,424605608,15194337,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287492,424604898,15194033,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287495,424604020,15193593,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287499,424603310,15192951,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287501,424602634,15191971,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287504,424601688,15190113,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287506,424600303,15187916,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287509,424598985,15184943,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287511,424597734,15181631,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287512,424596383,15177745,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287515,424594220,15171088,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287517,424592733,15166492,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287519,424590908,15159903,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287522,424590266,15156963,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287524,424589422,15153415,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287527,424588408,15147129,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287528,424587698,15141385,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287532,424587394,15139053,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287534,424586980,15136073,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287536,424586514,15134015,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287538,424585893,15131647,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287542,424585117,15129395,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287544,424584379,15128037,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287548,424583409,15126018,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287551,424582554,15124659,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287552,424581856,15123611,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287555,424580885,15122835,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287560,424579565,15122252,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287562,424578711,15121476,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287565,424578478,15120389,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287568,424578672,15119574,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287570,424579255,15119030,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287572,424580381,15119147,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287575,424581662,15120078,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287578,424585117,15123572,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287580,424586980,15126018,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287583,424588727,15128968,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287584,424590396,15132462,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287588,424591600,15135607,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287591,424593735,15141702,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287592,424595288,15145700,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287594,424596763,15148690,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287600,424598044,15151795,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287603,424599092,15154785,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287605,424599791,15157114,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287608,424600335,15158046,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287609,424601732,15158550,27626,1,'2009-04-01 16:02:37',3310491151,5),(52287612,424602082,15158084,27626,1,'2009-04-01 16:02:37',3310491151,5),(52287616,424601965,15157269,27626,1,'2009-04-01 16:02:37',3310491151,5),(52287619,424601771,15156299,27626,1,'2009-04-01 16:02:37',3310491151,5),(52287622,424601019,15158678,27626,1,'2009-04-01 16:02:37',3310491151,5),(52287624,424600917,15154280,27626,1,'2009-04-01 16:02:37',3310491151,5),(52287627,424600102,15151757,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287629,424598743,15148185,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287631,424597695,15142828,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287633,424596918,15138674,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287634,424595909,15131414,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287636,424595404,15128503,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287638,424594706,15125824,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287640,424594084,15123456,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287642,424592532,15119457,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287643,424590552,15114643,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287644,424589503,15111848,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287645,424587562,15108393,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287648,424585815,15104860,27626,1,'2009-04-01 16:02:37',3310491148,5),(52287649,424584379,15101949,27626,1,'2009-04-01 16:02:37',3310491148,5),(52287651,424583253,15100202,27626,1,'2009-04-01 16:02:37',3310491148,5),(52287653,424581895,15097756,27626,1,'2009-04-01 16:02:37',3310491148,5),(52287654,424580846,15095466,27626,1,'2009-04-01 16:02:37',3310491148,5),(52288116,424580031,15093952,27626,1,'2009-04-01 16:02:37',3310491148,5),(52288118,424579565,15092632,27626,1,'2009-04-01 16:02:37',3310491148,5),(52288119,424579643,15091428,27626,1,'2009-04-01 16:02:37',3310491148,5),(52288121,424580109,15090768,27626,1,'2009-04-01 16:02:37',3310491148,5),(52288122,424580730,15090419,27626,1,'2009-04-01 16:02:37',3310491148,5),(52288125,424581506,15090924,27626,1,'2009-04-01 16:02:37',3310491148,5),(52288128,424582089,15091972,27626,1,'2009-04-01 16:02:37',3310491148,5),(52288131,424582982,15094029,27626,1,'2009-04-01 16:02:37',3310491148,5),(52288133,424586825,15100590,27626,1,'2009-04-01 16:02:37',3310491148,5),(52288136,424590008,15105831,27626,1,'2009-04-01 16:02:37',3310491148,5),(52288137,424594007,15112392,27626,1,'2009-04-01 16:02:37',3310491150,5),(52288139,424597928,15118642,27626,1,'2009-04-01 16:02:37',3310491150,5),(52288141,424602314,15124776,27626,1,'2009-04-01 16:02:37',3310491151,5),(52288142,424604916,15128192,27626,1,'2009-04-01 16:02:37',3310491151,5),(52288145,424607206,15130948,27626,1,'2009-04-01 16:02:37',3310491151,5),(52288146,424607866,15132074,27626,1,'2009-04-01 16:02:37',3310491151,5),(52288150,424608177,15135490,27626,1,'2009-04-01 16:02:37',3310491151,5),(52288153,424608177,15136422,27626,1,'2009-04-01 16:02:37',3310491151,5),(52288155,424608914,15138868,27626,1,'2009-04-01 16:02:37',3310491151,5),(52288157,424609535,15139877,27626,1,'2009-04-01 16:02:37',3310491151,5),(52288161,424610234,15140110,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288163,424610661,15139761,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288165,424610739,15139140,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288167,424610661,15138208,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288170,424610389,15136500,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288173,424610079,15133316,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288175,424610040,15131453,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288178,424609496,15129939,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288179,424607982,15127105,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288181,424607012,15125048,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288183,424605129,15120978,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288184,424603363,15116857,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288185,424601650,15113164,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288188,424598546,15106581,27626,1,'2009-04-01 16:02:38',3310491150,5),(52288190,424596619,15100266,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288194,424595335,15093630,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288196,424594960,15088813,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288199,424594104,15082605,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288203,424593650,15075221,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288204,424593894,15072470,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288207,424594068,15070207,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288210,424594103,15067109,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288211,424593929,15065194,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288215,424593093,15063070,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288216,424592257,15060599,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288218,424590517,15055481,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288221,424589584,15052245,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288223,424588732,15049437,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288225,424588130,15045828,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288227,424587879,15043471,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288231,424587578,15040463,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288233,424587328,15037506,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288235,424586826,15034899,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288238,424586175,15032492,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288241,424585974,15031540,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288244,424586175,15031089,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288248,424586826,15030888,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288251,424587378,15031239,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288253,424587929,15032492,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288256,424588531,15035049,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288258,424589133,15038358,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288261,424589684,15040865,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288265,424591088,15045276,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288266,424594146,15051092,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288269,424592428,15048320,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288273,424595963,15053675,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288275,424597582,15055490,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288277,424598857,15057108,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288281,424600182,15058923,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288284,424600721,15059855,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288285,424601163,15061032,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288287,424601801,15063877,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288289,424602585,15066477,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288291,424603370,15068783,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288293,424605430,15072658,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288297,424607147,15075503,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288298,424609122,15079292,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288301,424611529,15083735,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288304,424613357,15086443,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288307,424614931,15088179,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288310,424615764,15088966,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288313,424617084,15089568,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288317,424618380,15090147,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288319,424619421,15090841,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288321,424620486,15092531,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288325,424621505,15094521,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288327,424622245,15096373,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288330,424622708,15096743,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288331,424623379,15097044,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288335,424624051,15096928,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288337,424624421,15096581,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288339,424625023,15095401,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288341,424625717,15093387,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288343,424625995,15091883,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288345,424626203,15090563,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288348,424626203,15088874,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288350,424626111,15086235,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288353,424625507,15081530,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288357,424624867,15078730,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288360,424624107,15075571,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288361,424622507,15070331,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288365,424621067,15066372,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288368,424619708,15062772,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288371,424618668,15060332,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288375,424617428,15058573,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288377,424615705,15057066,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288381,424614694,15055859,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288383,424614107,15054327,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288387,424613911,15051718,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288388,424613878,15049468,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288390,424613781,15046957,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288393,424613552,15045783,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288395,424612672,15044380,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288398,424611596,15042945,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288400,424609737,15040402,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288403,424609150,15039456,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288406,424607878,15037728,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288407,424606900,15035967,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288412,424606090,15033789,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288413,424605437,15030974,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288415,424604539,15027752,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288417,424603928,15025141,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288419,424603234,15022163,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288423,424602296,15017920,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288426,424601521,15014330,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288429,424601521,15010332,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288434,424601602,15006660,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288435,424601888,15003030,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288439,424602173,14999236,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288442,424602785,14996421,27626,1,'2009-04-01 16:02:39',3310491141,5),(52288444,424603724,14992137,27626,1,'2009-04-01 16:02:39',3310491141,5),(52288448,424604703,14988343,27626,1,'2009-04-01 16:02:39',3310491141,5),(52288450,424605315,14985814,27626,1,'2009-04-01 16:02:39',3310491141,5),(52288453,424605192,14983448,27626,1,'2009-04-01 16:02:39',3310491141,5),(52288455,424604580,14979858,27626,1,'2009-04-01 16:02:39',3310491141,5),(52288458,424603275,14975738,27626,1,'2009-04-01 16:02:39',3310491141,5),(52288460,424601398,14971740,27626,1,'2009-04-01 16:02:39',3310491141,5),(52288461,424599481,14968803,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288465,424598053,14966844,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288466,424596176,14964764,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288469,424594545,14963418,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288471,424592790,14962194,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288474,424591689,14961582,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288478,424591199,14960766,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288479,424591403,14959216,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288482,424592179,14958849,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288484,424593402,14959619,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288487,424594422,14960562,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288489,424597564,14963132,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288491,424599726,14964886,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288494,424591064,14959945,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288497,424601846,14966492,27626,1,'2009-04-01 16:02:39',3310491141,5),(52288498,424604142,14968646,27626,1,'2009-04-01 16:02:39',3310491141,5),(52288501,424606225,14971118,27626,1,'2009-04-01 16:02:39',3310491141,5),(52288503,424607638,14972637,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288504,424609545,14975391,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288507,424610181,14977546,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288509,424610357,14979523,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288511,424611205,14982631,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288514,424612158,14986092,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288515,424613076,14989941,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288518,424614560,14996545,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288521,424615160,14999900,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288524,424615972,15004667,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288527,424616678,15006680,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288529,424617667,15008234,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288533,424619362,15010212,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288535,424620881,15012507,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288537,424622717,15016110,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288541,424624059,15018299,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288542,424624730,15019394,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288545,424625366,15019606,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288549,424625825,15019535,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288552,424626143,15019217,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288555,424626178,15018299,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288558,424625896,15017063,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288561,424625437,15015686,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288565,424624412,15012755,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288567,424622823,15009718,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288570,424621016,15004715,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288573,424620756,15002020,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288575,424620549,14997925,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288577,424620601,14993831,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288578,424620918,14989983,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288581,424621030,14987740,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288583,424621030,14985758,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288586,424620880,14984375,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288588,424619646,14980935,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288591,424618673,14977182,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288594,424617973,14974006,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288597,424618242,14971583,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288599,424618942,14969483,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288601,424618867,14967523,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288603,424618307,14965370,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288606,424617548,14963492,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288607,424616449,14961087,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288610,424615452,14958784,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288612,424613528,14954626,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288614,424612600,14952667,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288615,424611782,14951128,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288619,424611315,14950001,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288621,424610352,14948516,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288624,424609280,14947636,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288625,424608010,14946779,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288627,424607042,14946273,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288630,424606603,14945613,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288632,424606427,14944733,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288633,424606603,14944250,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288636,424606977,14944008,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288637,424607636,14943986,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288639,424608428,14944316,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288642,424609418,14945173,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288644,424617665,14951815,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288647,424621250,14954718,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288650,424623383,14956939,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288651,424624571,14958347,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288653,424625253,14960194,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288655,424625846,14962042,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288658,424626330,14962966,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288659,424626968,14963383,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288665,424627518,14963383,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288669,424627826,14963185,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288672,424628024,14962768,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288675,424628024,14962064,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288684,424627716,14961228,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288687,424627056,14959447,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288689,424624822,14953774,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288691,424623115,14949242,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288695,424621479,14946749,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288696,424618977,14942929,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288697,424615803,14938813,27626,1,'2009-04-01 16:02:41',3310490799,5),(52288702,424612470,14934229,27626,1,'2009-04-01 16:02:41',3310490799,5),(52296455,424604569,14970751,439281,1,'2007-09-16 02:00:34',3310491141,1),(52296457,424604928,14971855,439281,1,'2007-09-16 02:00:34',3310491141,1),(52296459,424606315,14973910,439281,1,'2007-09-16 02:00:34',3310491141,1),(52296460,424607168,14975640,439281,1,'2007-09-16 02:00:34',3310491141,1),(52296461,424607938,14978075,439281,1,'2007-09-16 02:00:35',3310491141,1),(52296462,424608092,14980171,439281,1,'2007-09-16 02:00:35',3310491141,1),(52296464,424607842,14983352,439281,1,'2007-09-16 02:00:35',3310491141,1),(52296465,424606866,14986414,439281,1,'2007-09-16 02:00:35',3310491141,1),(52296467,424606134,14989178,439281,1,'2007-09-16 02:00:35',3310491141,1),(52296469,424605743,14992652,439281,1,'2007-09-16 02:00:35',3310491141,1),(52296471,424605135,14995908,439281,1,'2007-09-16 02:00:35',3310491141,1),(52296472,424604223,15001205,439281,1,'2007-09-16 02:00:35',3310491143,1),(52296476,424603894,15005933,439281,1,'2007-09-16 02:00:36',3310491143,1),(52296478,424603843,15009960,439281,1,'2007-09-16 02:00:36',3310491143,1),(52296481,424604353,15013478,439281,1,'2007-09-16 02:00:36',3310491143,1),(52296483,424605118,15015670,439281,1,'2007-09-16 02:00:36',3310491143,1),(52296485,424605679,15017760,439281,1,'2007-09-16 02:00:37',3310491143,1),(52296486,424606749,15021329,439281,1,'2007-09-16 02:00:37',3310491143,1),(52296489,424607157,15023572,439281,1,'2007-09-16 02:00:37',3310491143,1),(52296490,424607718,15026580,439281,1,'2007-09-16 02:00:37',3310491143,1),(52296492,424608228,15029843,439281,1,'2007-09-16 02:00:37',3310491143,1),(52296494,424608840,15033259,439281,1,'2007-09-16 02:00:38',3310491143,1),(52296495,424609859,15035910,439281,1,'2007-09-16 02:00:38',3310491143,1),(52296497,424610828,15038204,439281,1,'2007-09-16 02:00:38',3310491143,1),(52296975,424613938,15042843,439281,1,'2007-09-16 02:01:48',3310491143,1),(52296977,424614600,15044628,439281,1,'2007-09-16 02:01:48',3310491143,1),(52296978,424614651,15045749,439281,1,'2007-09-16 02:01:48',3310491143,1),(52296979,424614345,15046463,439281,1,'2007-09-16 02:01:49',3310491143,1),(52296981,424619732,15049048,439281,1,'2007-09-16 02:01:49',3310491143,1),(52296982,424620370,15048143,439281,1,'2007-09-16 02:01:49',3310491143,1),(52296984,424620736,15046544,439281,1,'2007-09-16 02:01:49',3310491143,1),(52296985,424620481,15045190,439281,1,'2007-09-16 02:01:49',3310491143,1),(52296987,424619814,15044113,439281,1,'2007-09-16 02:01:49',3310491143,1),(52296990,424617406,15042892,439281,1,'2007-09-16 02:01:50',3310491143,1),(52296992,424616212,15042589,439281,1,'2007-09-16 02:01:50',3310491143,1),(52296994,424615116,15042159,439281,1,'2007-09-16 02:01:50',3310491143,1),(52296996,424614133,15041663,439281,1,'2007-09-16 02:01:50',3310491143,1),(52296999,424612886,15041203,439281,1,'2007-09-16 02:01:51',3310491143,1),(52297002,424622303,15048684,439281,1,'2007-09-16 02:01:51',3310491143,1),(52297004,424622872,15047782,439281,1,'2007-09-16 02:01:51',3310491143,1),(52297007,424623147,15046722,439281,1,'2007-09-16 02:01:51',3310491143,1),(52297010,424622931,15045389,439281,1,'2007-09-16 02:01:52',3310491143,1),(52297013,424622342,15044486,439281,1,'2007-09-16 02:01:53',3310491143,1),(52297015,424621303,15043819,439281,1,'2007-09-16 02:01:53',3310491143,1),(52297018,424620303,15043525,439281,1,'2007-09-16 02:01:53',3310491143,1),(52297038,424618792,15043251,439281,1,'2007-09-16 02:01:55',3310491143,1),(52297041,424610096,15017958,439281,1,'2007-09-16 02:01:55',3310491143,1),(52297063,424608851,15015747,439281,1,'2007-09-16 02:01:59',3310491143,1),(52297071,424607694,15013639,439281,1,'2007-09-16 02:02:00',3310491143,1),(52297255,424606702,15010745,439281,1,'2007-09-16 02:02:21',3310491143,1),(52297266,424605875,15007372,439281,1,'2007-09-16 02:02:23',3310491143,1),(52297268,424605180,15005718,439281,1,'2007-09-16 02:02:23',3310491143,1),(52297272,424604949,15003635,439281,1,'2007-09-16 02:02:23',3310491143,1),(52297276,424604862,15001259,439281,1,'2007-09-16 02:02:24',3310491143,1),(52297279,424605379,14998250,439281,1,'2007-09-16 02:02:24',3310491143,1),(52297281,424605147,14997953,439281,1,'2007-09-16 02:02:24',3310491143,1),(52297285,424604803,14997760,439281,1,'2007-09-16 02:02:24',3310491143,1),(52297288,424607774,15042770,439281,1,'2007-09-16 02:02:24',3310491143,1),(52297290,424609624,15044620,439281,1,'2007-09-16 02:02:24',3310491143,1),(52297294,424610858,15046813,439281,1,'2007-09-16 02:02:25',3310491143,1),(52297297,424611783,15048252,439281,1,'2007-09-16 02:02:25',3310491143,1),(52297300,424612400,15049588,439281,1,'2007-09-16 02:02:25',3310491143,1),(52297301,424613976,15050650,27626,1,'2009-04-01 16:02:39',3310491143,5),(52297305,424611269,15054260,439281,1,'2007-09-16 02:02:26',3310491149,1),(52297309,424611451,15050620,439281,1,'2007-09-16 02:02:26',3310491143,1),(52297312,424611439,15047717,439281,1,'2007-09-16 02:02:26',3310491143,1),(52297314,424601900,15041386,439281,1,'2007-09-16 02:02:26',3310491143,1),(52297317,424603704,15043485,439281,1,'2007-09-16 02:02:27',3310491143,1),(52297320,424605672,15045486,439281,1,'2007-09-16 02:02:27',3310491143,1),(52297324,424607345,15046733,439281,1,'2007-09-16 02:02:27',3310491143,1),(52297328,424608329,15047782,439281,1,'2007-09-16 02:02:27',3310491143,1),(52297333,424609313,15049258,439281,1,'2007-09-16 02:02:28',3310491143,1),(52297339,424609509,15050406,439281,1,'2007-09-16 02:02:28',3310491143,1),(52297344,424609378,15052079,439281,1,'2007-09-16 02:02:28',3310491149,1),(52297349,424608985,15053588,439281,1,'2007-09-16 02:02:28',3310491149,1),(52297354,424608952,15054867,439281,1,'2007-09-16 02:02:28',3310491149,1),(52297358,424609149,15055818,439281,1,'2007-09-16 02:02:28',3310491149,1),(52297362,424609706,15056901,439281,1,'2007-09-16 02:02:29',3310491149,1),(52297366,424610428,15057622,439281,1,'2007-09-16 02:02:29',3310491149,1),(52297369,424611477,15058573,439281,1,'2007-09-16 02:02:29',3310491149,1),(52297373,424612265,15059131,439281,1,'2007-09-16 02:02:29',3310491149,1),(52297375,424613019,15059361,439281,1,'2007-09-16 02:02:29',3310491149,1),(52297380,424613872,15059262,439281,1,'2007-09-16 02:02:30',3310491149,1),(52297383,424614593,15058442,439281,1,'2007-09-16 02:02:30',3310491149,1),(52297386,424601113,14972436,439281,1,'2007-09-16 02:02:30',3310491141,1),(52297390,424601326,14972897,439281,1,'2007-09-16 02:02:30',3310491141,1),(52297393,424601650,14973032,439281,1,'2007-09-16 02:02:31',3310491141,1),(52297397,424602067,14972929,27626,1,'2009-04-01 16:02:39',3310491141,5),(52297402,424600609,14971610,439281,1,'2007-09-16 02:02:31',3310491141,1),(52297405,424599759,14970659,439281,1,'2007-09-16 02:02:31',3310491140,1),(52297410,424598723,14970197,439281,1,'2007-09-16 02:02:31',3310491140,1),(52297412,424597876,14969824,439281,1,'2007-09-16 02:02:32',3310491140,1),(52297418,424597254,14969948,439281,1,'2007-09-16 02:02:32',3310491140,1),(52297422,424596905,14970321,439281,1,'2007-09-16 02:02:32',3310491140,1),(52297424,424596905,14970695,439281,1,'2007-09-16 02:02:32',3310491140,1),(52297427,424597304,14971666,439281,1,'2007-09-16 02:02:32',3310491140,1),(52297432,424598075,14973582,439281,1,'2007-09-16 02:02:33',3310491140,1),(52297435,424598748,14974852,439281,1,'2007-09-16 02:02:33',3310491140,1),(52297437,424598897,14975175,439281,1,'2007-09-16 02:02:33',3310491140,1),(52297440,424599021,14975698,439281,1,'2007-09-16 02:02:33',3310491140,1),(52297442,424598922,14975997,439281,1,'2007-09-16 02:02:33',3310491140,1),(52297447,424598673,14976072,439281,1,'2007-09-16 02:02:33',3310491140,1),(52297450,424598001,14975574,439281,1,'2007-09-16 02:02:34',3310491140,1),(52297455,424596955,14974528,439281,1,'2007-09-16 02:02:34',3310491140,1),(52297459,424596482,14974279,439281,1,'2007-09-16 02:02:34',3310491140,1),(52297462,424596233,14974379,439281,1,'2007-09-16 02:02:34',3310491140,1),(52297465,424596109,14974852,439281,1,'2007-09-16 02:02:34',3310491140,1),(52297469,424596557,14975574,439281,1,'2007-09-16 02:02:34',3310491140,1),(52297470,424597453,14977217,439281,1,'2007-09-16 02:02:34',3310491140,1),(52297474,424597827,14977690,439281,1,'2007-09-16 02:02:35',3310491140,1),(52297478,424597901,14978312,439281,1,'2007-09-16 02:02:35',3310491140,1),(52297482,424597752,14978611,439281,1,'2007-09-16 02:02:35',3310491140,1),(52297484,424597428,14978611,439281,1,'2007-09-16 02:02:35',3310491140,1),(52297488,424597030,14978312,439281,1,'2007-09-16 02:02:35',3310491140,1),(52297492,424596457,14978138,439281,1,'2007-09-16 02:02:35',3310491140,1),(52297494,424596034,14977939,439281,1,'2007-09-16 02:02:35',3310491140,1),(52297498,424595636,14978461,439281,1,'2007-09-16 02:02:35',3310491140,1),(52297501,424605173,14969870,27626,1,'2009-04-01 16:02:39',3310491141,5),(52297507,424614360,15017782,439281,1,'2007-09-16 02:02:36',3310491143,1),(52297509,424612677,15018413,439281,1,'2007-09-16 02:02:36',3310491143,1),(52297515,424612361,15018098,439281,1,'2007-09-16 02:02:37',3310491143,1),(52297517,424612151,15017308,439281,1,'2007-09-16 02:02:37',3310491143,1),(52297520,424610257,15012258,439281,1,'2007-09-16 02:02:37',3310491143,1),(52297521,424608784,15008312,439281,1,'2007-09-16 02:02:37',3310491143,1),(52297525,424607521,15004577,439281,1,'2007-09-16 02:02:37',3310491143,1),(52297528,424606521,15000473,439281,1,'2007-09-16 02:02:37',3310491143,1),(52297532,424606431,14999097,439281,1,'2007-09-16 02:02:37',3310491143,1),(52297535,424606566,14996808,439281,1,'2007-09-16 02:02:37',3310491143,1),(52297537,424606768,14994619,439281,1,'2007-09-16 02:02:37',3310491141,1),(52297540,424606768,14992734,439281,1,'2007-09-16 02:02:38',3310491141,1),(52297542,424605850,14991091,439281,1,'2007-09-16 02:02:38',3310491141,1),(52297545,424620095,15023177,439281,1,'2007-09-16 02:02:38',3310491143,1),(52297547,424618293,15019660,439281,1,'2007-09-16 02:02:38',3310491143,1),(52297550,424617006,15016571,439281,1,'2007-09-16 02:02:38',3310491143,1),(52297554,424615591,15012753,439281,1,'2007-09-16 02:02:38',3310491143,1),(52297558,424614218,15009493,439281,1,'2007-09-16 02:02:38',3310491143,1),(52297560,424613360,15006448,439281,1,'2007-09-16 02:02:39',3310491143,1),(52297563,424612245,14999885,439281,1,'2007-09-16 02:02:39',3310491143,1),(52297565,424611730,14997397,439281,1,'2007-09-16 02:02:39',3310491143,1),(52297567,424611515,14995123,439281,1,'2007-09-16 02:02:39',3310491141,1),(52297571,424611172,14992635,439281,1,'2007-09-16 02:02:39',3310491141,1),(52297573,424610872,14989847,439281,1,'2007-09-16 02:02:39',3310491141,1),(52297576,424610829,14987831,439281,1,'2007-09-16 02:02:39',3310491141,1),(52297580,424611129,14986930,439281,1,'2007-09-16 02:02:39',3310491141,1),(52297584,424622242,15022238,439281,1,'2007-09-16 02:02:40',3310491143,1),(52297587,424620843,15020609,439281,1,'2007-09-16 02:02:40',3310491143,1),(52297590,424619406,15018470,439281,1,'2007-09-16 02:02:40',3310491143,1),(52297592,424618337,15016598,439281,1,'2007-09-16 02:02:40',3310491143,1),(52297595,424617223,15014638,439281,1,'2007-09-16 02:02:40',3310491143,1),(52297599,424616733,15013969,439281,1,'2007-09-16 02:02:40',3310491143,1),(52297602,424616081,15014077,439281,1,'2007-09-16 02:02:41',3310491143,1),(52297606,424631521,15016152,439281,1,'2007-09-16 02:02:41',3310491154,1),(52297609,424629450,15013027,439281,1,'2007-09-16 02:02:41',3310491154,1),(52297612,424628142,15010884,439281,1,'2007-09-16 02:02:41',3310491154,1),(52297615,424626652,15008340,439281,1,'2007-09-16 02:02:41',3310491143,1),(52297617,424625562,15005179,439281,1,'2007-09-16 02:02:41',3310491143,1),(52297621,424624944,15002999,439281,1,'2007-09-16 02:02:42',3310491143,1),(52297623,424624254,14999766,439281,1,'2007-09-16 02:02:42',3310491143,1),(52297626,424623963,14995406,439281,1,'2007-09-16 02:02:42',3310491141,1),(52297629,424624363,14991554,439281,1,'2007-09-16 02:02:42',3310491141,1),(52297633,424624690,14989011,439281,1,'2007-09-16 02:02:42',3310491141,1),(52297638,424624581,14987049,439281,1,'2007-09-16 02:02:43',3310491141,1),(52297640,424624218,14985123,439281,1,'2007-09-16 02:02:43',3310491141,1),(52297643,424622982,14981999,439281,1,'2007-09-16 02:02:43',3310491141,1),(52297646,424620875,14977675,439281,1,'2007-09-16 02:02:43',3310491141,1),(52297650,424618166,14972270,27626,1,'2009-04-01 16:02:40',3310491141,5),(52322112,424667190,14927360,439281,1,'2007-09-16 02:48:47',3310490811,1),(52322115,424666587,14925324,439281,1,'2007-09-16 02:48:47',3310490811,1),(52322119,424666875,14924502,439281,1,'2007-09-16 02:48:47',3310490811,1),(52322122,424668200,14930193,439281,1,'2007-09-16 02:48:47',3310490811,1),(52322125,424668922,14933445,439281,1,'2007-09-16 02:48:48',3310490811,1),(52322137,424670157,14936094,439281,1,'2007-09-16 02:48:48',3310490811,1),(52322143,424671362,14938172,439281,1,'2007-09-16 02:48:49',3310490811,1),(52322151,424673797,14940386,439281,1,'2007-09-16 02:48:49',3310490811,1),(52322153,424678046,14943334,439281,1,'2007-09-16 02:48:49',3310491153,1),(52322155,424680735,14946110,439281,1,'2007-09-16 02:48:49',3310491153,1),(52322156,424682773,14947974,439281,1,'2007-09-16 02:48:49',3310491153,1),(52322157,424684420,14949708,439281,1,'2007-09-16 02:48:49',3310491156,1),(52322159,424686241,14950576,439281,1,'2007-09-16 02:48:50',3310491156,1),(52322163,424687846,14950576,439281,1,'2007-09-16 02:48:50',3310491156,1),(52322165,424689190,14949795,439281,1,'2007-09-16 02:48:50',3310491156,1),(52322167,424690317,14948104,439281,1,'2007-09-16 02:48:50',3310491156,1),(52322170,424690968,14946717,439281,1,'2007-09-16 02:48:50',3310491156,1),(52322171,424691705,14946110,439281,1,'2007-09-16 02:48:51',3310491156,1),(52322174,424693179,14946023,439281,1,'2007-09-16 02:48:51',3310491156,1),(52322177,424695000,14945979,439281,1,'2007-09-16 02:48:51',3310491156,1),(52322180,424696605,14945372,439281,1,'2007-09-16 02:48:52',3310491156,1),(52322184,424698252,14944419,439281,1,'2007-09-16 02:48:52',3310491156,1),(52322185,424699943,14943465,439281,1,'2007-09-16 02:48:52',3310491156,1),(52322190,424701071,14943248,439281,1,'2007-09-16 02:48:52',3310491156,1),(52322193,424702025,14944072,439281,1,'2007-09-16 02:48:53',3310491156,1),(52322196,424702848,14946023,439281,1,'2007-09-16 02:48:53',3310491156,1),(52322198,424703022,14948538,439281,1,'2007-09-16 02:48:53',3310491156,1),(52322200,424702675,14950793,439281,1,'2007-09-16 02:48:53',3310491156,1),(52322203,424701895,14953264,439281,1,'2007-09-16 02:48:54',3310491156,1),(52322207,424701071,14955779,439281,1,'2007-09-16 02:48:54',3310491156,1),(52322210,424699727,14957947,439281,1,'2007-09-16 02:48:54',3310491156,1),(52322213,424698079,14959421,439281,1,'2007-09-16 02:48:54',3310491156,1),(52322216,424696084,14960115,439281,1,'2007-09-16 02:48:55',3310491156,1),(52322219,424693960,14960982,439281,1,'2007-09-16 02:48:55',3310491156,1),(52322222,424691228,14960896,439281,1,'2007-09-16 02:48:55',3310491156,1),(52322223,424688236,14960635,439281,1,'2007-09-16 02:48:55',3310491156,1),(52322225,424685244,14960505,439281,1,'2007-09-16 02:48:55',3310491156,1),(52322228,424683163,14960419,439281,1,'2007-09-16 02:48:55',3310491156,1),(52322231,424680240,14959980,439281,1,'2007-09-16 02:48:56',3310491153,1),(52322235,424678464,14959286,439281,1,'2007-09-16 02:48:56',3310491153,1),(52322237,424676161,14958093,439281,1,'2007-09-16 02:48:56',3310491153,1),(52322240,424674773,14957177,439281,1,'2007-09-16 02:48:56',3310491153,1),(52322242,424672886,14956455,439281,1,'2007-09-16 02:48:56',3310491153,1),(52322244,424671499,14955762,439281,1,'2007-09-16 02:48:56',3310491153,1),(52322245,424670750,14955234,439281,1,'2007-09-16 02:48:56',3310491153,1),(52322247,424670028,14954874,439281,1,'2007-09-16 02:48:57',3310491153,1),(52322249,424669445,14954874,439281,1,'2007-09-16 02:48:57',3310491153,1),(52322252,424669168,14955151,439281,1,'2007-09-16 02:48:57',3310491153,1),(52322255,424669085,14955678,439281,1,'2007-09-16 02:48:57',3310491153,1),(52322256,424669418,14956317,439281,1,'2007-09-16 02:48:57',3310491153,1),(52322259,424670500,14957038,439281,1,'2007-09-16 02:48:57',3310491153,1),(52322262,424672054,14958342,439281,1,'2007-09-16 02:48:58',3310491153,1),(52322266,424673663,14959896,439281,1,'2007-09-16 02:48:58',3310491153,1),(52322268,424675384,14962394,439281,1,'2007-09-16 02:48:58',3310491153,1),(52322271,424676300,14963560,439281,1,'2007-09-16 02:48:58',3310491153,1),(52322273,424676688,14964226,439281,1,'2007-09-16 02:48:58',3310491153,1),(52322277,424676716,14964697,439281,1,'2007-09-16 02:48:58',3310491153,1),(52322278,424676522,14964919,439281,1,'2007-09-16 02:48:59',3310491153,1),(52322279,424676189,14965114,439281,1,'2007-09-16 02:48:59',3310491153,1),(52322282,424675745,14965114,439281,1,'2007-09-16 02:48:59',3310491153,1),(52322285,424675356,14964864,439281,1,'2007-09-16 02:48:59',3310491153,1),(52322286,424674884,14964087,439281,1,'2007-09-16 02:48:59',3310491153,1),(52322289,424674163,14963088,439281,1,'2007-09-16 02:48:59',3310491153,1),(52322292,424673469,14962394,439281,1,'2007-09-16 02:48:59',3310491153,1),(52322293,424672220,14961534,439281,1,'2007-09-16 02:49:00',3310491153,1),(52322295,424670972,14961145,439281,1,'2007-09-16 02:49:00',3310491153,1),(52322298,424670101,14960872,439281,1,'2007-09-16 02:49:00',3310491153,1),(52322299,424669140,14960842,439281,1,'2007-09-16 02:49:00',3310491153,1),(52322302,424668479,14961112,439281,1,'2007-09-16 02:49:00',3310491153,1),(52322305,424668022,14961608,439281,1,'2007-09-16 02:49:01',3310491153,1),(52322308,424667977,14962268,439281,1,'2007-09-16 02:49:01',3310491153,1),(52322309,424668343,14962814,439281,1,'2007-09-16 02:49:01',3310491153,1),(52322311,424669438,14963088,439281,1,'2007-09-16 02:49:01',3310491153,1),(52322313,424670610,14963402,439281,1,'2007-09-16 02:49:01',3310491153,1),(52322315,424671809,14964264,439281,1,'2007-09-16 02:49:02',3310491153,1),(52322316,424672464,14965392,439281,1,'2007-09-16 02:49:02',3310491153,1),(52322318,424673412,14967153,439281,1,'2007-09-16 02:49:02',3310491153,1),(52322320,424674630,14968867,439281,1,'2007-09-16 02:49:02',3310491153,1),(52322322,424675627,14969896,439281,1,'2007-09-16 02:49:03',3310491153,1),(52322324,424676801,14970961,439281,1,'2007-09-16 02:49:03',3310491153,1),(52322327,424678028,14971864,439281,1,'2007-09-16 02:49:03',3310491153,1),(52322329,424678552,14972532,439281,1,'2007-09-16 02:49:03',3310491153,1),(52322331,424678624,14972947,439281,1,'2007-09-16 02:49:03',3310491153,1),(52322333,424678570,14973380,439281,1,'2007-09-16 02:49:03',3310491153,1),(52322335,424678317,14973633,439281,1,'2007-09-16 02:49:04',3310491153,1),(52322336,424678028,14973687,439281,1,'2007-09-16 02:49:04',3310491153,1),(52322337,424677541,14973489,439281,1,'2007-09-16 02:49:04',3310491153,1),(52322339,424676783,14973037,439281,1,'2007-09-16 02:49:04',3310491153,1),(52322341,424676006,14972532,439281,1,'2007-09-16 02:49:04',3310491153,1),(52322342,424675230,14972351,439281,1,'2007-09-16 02:49:04',3310491153,1),(52322344,424674635,14972424,439281,1,'2007-09-16 02:49:04',3310491153,1),(52322345,424674201,14972929,439281,1,'2007-09-16 02:49:04',3310491153,1),(52322347,424674039,14973471,439281,1,'2007-09-16 02:49:05',3310491153,1),(52322349,424674183,14974229,439281,1,'2007-09-16 02:49:05',3310491153,1),(52322351,424674598,14975041,439281,1,'2007-09-16 02:49:05',3310491153,1),(52322353,424675826,14975944,439281,1,'2007-09-16 02:49:05',3310491153,1),(52322355,424677126,14976594,439281,1,'2007-09-16 02:49:05',3310491153,1),(52322357,424678512,14976838,439281,1,'2007-09-16 02:49:05',3310491153,1),(52322358,424679831,14976764,439281,1,'2007-09-16 02:49:05',3310491153,1),(52322359,424681662,14976325,439281,1,'2007-09-16 02:49:06',3310491153,1),(52322361,424683616,14975861,439281,1,'2007-09-16 02:49:06',3310491156,1),(52322363,424685300,14975934,439281,1,'2007-09-16 02:49:06',3310491156,1),(52322364,424687132,14976227,439281,1,'2007-09-16 02:49:06',3310491156,1),(52322365,424688548,14976252,439281,1,'2007-09-16 02:49:06',3310491156,1),(52322366,424690355,14976349,439281,1,'2007-09-16 02:49:06',3310491156,1),(52322368,424691673,14976471,439281,1,'2007-09-16 02:49:06',3310491156,1),(52322370,424693136,14977162,439281,1,'2007-09-16 02:49:06',3310491156,1),(52322372,424694086,14978287,439281,1,'2007-09-16 02:49:07',3310491156,1),(52322374,424695035,14979729,439281,1,'2007-09-16 02:49:07',3310491156,1),(52322376,424695879,14980713,439281,1,'2007-09-16 02:49:07',3310491156,1),(52322378,424697145,14981135,439281,1,'2007-09-16 02:49:07',3310491156,1),(52322380,424698551,14981135,439281,1,'2007-09-16 02:49:07',3310491156,1),(52322382,424700063,14981205,439281,1,'2007-09-16 02:49:07',3310491156,1),(52322384,424701821,14981416,439281,1,'2007-09-16 02:49:07',3310491156,1),(52322386,424703720,14981979,439281,1,'2007-09-16 02:49:07',3310491156,1),(52322388,424705443,14982999,439281,1,'2007-09-16 02:49:08',3310491156,1),(52322390,424707412,14984651,439281,1,'2007-09-16 02:49:08',3310491156,1),(52322392,424708783,14986444,439281,1,'2007-09-16 02:49:08',3310491156,1),(52322395,424709908,14987745,439281,1,'2007-09-16 02:49:08',3310491156,1),(52322398,424711314,14988449,439281,1,'2007-09-16 02:49:08',3310491157,1),(52322400,424711877,14989117,439281,1,'2007-09-16 02:49:09',3310491157,1),(52322402,424711842,14989750,439281,1,'2007-09-16 02:49:09',3310491157,1),(52322405,424711631,14990242,439281,1,'2007-09-16 02:49:09',3310491157,1),(52322408,424711139,14990382,439281,1,'2007-09-16 02:49:09',3310491157,1),(52322411,424710013,14990347,439281,1,'2007-09-16 02:49:09',3310491156,1),(52322413,424708396,14990101,439281,1,'2007-09-16 02:49:09',3310491156,1),(52322415,424705970,14989609,439281,1,'2007-09-16 02:49:10',3310491156,1),(52322419,424704282,14989081,439281,1,'2007-09-16 02:49:10',3310491156,1),(52322422,424702313,14988871,439281,1,'2007-09-16 02:49:10',3310491156,1),(52322424,424700309,14988624,439281,1,'2007-09-16 02:49:10',3310491156,1),(52322429,424698797,14988730,439281,1,'2007-09-16 02:49:10',3310491156,1),(52322432,424697285,14988871,439281,1,'2007-09-16 02:49:10',3310491156,1),(52322434,424695598,14988554,439281,1,'2007-09-16 02:49:10',3310491156,1),(52322437,424694050,14988027,439281,1,'2007-09-16 02:49:11',3310491156,1),(52322440,424693031,14987464,439281,1,'2007-09-16 02:49:11',3310491156,1),(52322441,424692292,14987148,439281,1,'2007-09-16 02:49:11',3310491156,1),(52322443,424691695,14987394,439281,1,'2007-09-16 02:49:11',3310491156,1),(52322446,424691554,14988132,439281,1,'2007-09-16 02:49:11',3310491156,1),(52322449,424691730,14988730,439281,1,'2007-09-16 02:49:11',3310491156,1),(52322451,424692855,14989679,439281,1,'2007-09-16 02:49:11',3310491156,1),(52322453,424697088,14992637,439281,1,'2007-09-16 02:49:12',3310491156,1),(52322455,424698765,14993927,439281,1,'2007-09-16 02:49:12',3310491156,1),(52322458,424699926,14995088,439281,1,'2007-09-16 02:49:12',3310491156,1),(52322461,424701173,14997152,439281,1,'2007-09-16 02:49:12',3310491158,1),(52322463,424702506,14999517,439281,1,'2007-09-16 02:49:12',3310491158,1),(52322465,424703753,15000808,439281,1,'2007-09-16 02:49:12',3310491158,1),(52322467,424705688,15002528,439281,1,'2007-09-16 02:49:12',3310491158,1),(52322470,424708527,15004721,439281,1,'2007-09-16 02:49:13',3310491158,1),(52322473,424710462,15006097,439281,1,'2007-09-16 02:49:13',3310491159,1),(52322475,424711924,15007172,439281,1,'2007-09-16 02:49:13',3310491159,1),(52322478,424712870,15008204,439281,1,'2007-09-16 02:49:13',3310491159,1),(52322481,424713472,15009451,439281,1,'2007-09-16 02:49:13',3310491159,1),(52322484,424713816,15010526,439281,1,'2007-09-16 02:49:13',3310491159,1),(52322486,424713945,15011300,439281,1,'2007-09-16 02:49:13',3310491159,1),(52322488,424713816,15012032,439281,1,'2007-09-16 02:49:14',3310491159,1),(52322492,424713386,15012677,439281,1,'2007-09-16 02:49:14',3310491159,1),(52322493,424712698,15013021,439281,1,'2007-09-16 02:49:14',3310491159,1),(52322496,424711537,15012849,439281,1,'2007-09-16 02:49:14',3310491159,1),(52322497,424710247,15012333,439281,1,'2007-09-16 02:49:14',3310491158,1),(52322500,424709000,15012118,439281,1,'2007-09-16 02:49:14',3310491158,1),(52322502,424707709,15012032,439281,1,'2007-09-16 02:49:15',3310491158,1),(52322504,424706849,15011817,439281,1,'2007-09-16 02:49:15',3310491158,1),(52322508,424705258,15010698,439281,1,'2007-09-16 02:49:15',3310491158,1),(52322510,424702936,15009322,439281,1,'2007-09-16 02:49:15',3310491158,1),(52322512,424701560,15008591,439281,1,'2007-09-16 02:49:15',3310491158,1),(52322515,424700485,15008290,439281,1,'2007-09-16 02:49:15',3310491158,1),(52322516,424699152,15008376,439281,1,'2007-09-16 02:49:15',3310491158,1),(52322518,424697518,15008505,439281,1,'2007-09-16 02:49:15',3310491158,1),(52322520,424696615,15008849,439281,1,'2007-09-16 02:49:16',3310491158,1),(52322523,424696141,15009451,439281,1,'2007-09-16 02:49:16',3310491158,1),(52322526,424695840,15010440,439281,1,'2007-09-16 02:49:16',3310491158,1),(52322528,424695840,15011515,439281,1,'2007-09-16 02:49:16',3310491158,1),(52322530,424695969,15012247,439281,1,'2007-09-16 02:49:16',3310491158,1),(52322533,424696400,15012935,439281,1,'2007-09-16 02:49:16',3310491158,1),(52322534,424697174,15013322,439281,1,'2007-09-16 02:49:17',3310491158,1),(52322537,424698507,15013537,439281,1,'2007-09-16 02:49:17',3310491158,1),(52322540,424699582,15013752,439281,1,'2007-09-16 02:49:17',3310491158,1),(52322542,424700356,15013967,439281,1,'2007-09-16 02:49:17',3310491158,1),(52322544,424700786,15014440,439281,1,'2007-09-16 02:49:17',3310491158,1),(52322545,424701216,15015429,439281,1,'2007-09-16 02:49:17',3310491158,1),(52322548,424701259,15016461,439281,1,'2007-09-16 02:49:17',3310491158,1),(52322551,424701087,15017622,439281,1,'2007-09-16 02:49:18',3310491158,1),(52322552,424700958,15018955,439281,1,'2007-09-16 02:49:18',3310491158,1),(52322554,424701001,15020890,439281,1,'2007-09-16 02:49:19',3310491158,1),(52322557,424701001,15024804,439281,1,'2007-09-16 02:49:19',3310491158,1),(52322558,424701142,15026945,439281,1,'2007-09-16 02:49:19',3310491158,1),(52322561,424701584,15029007,439281,1,'2007-09-16 02:49:19',3310491158,1),(52322562,424702153,15030313,439281,1,'2007-09-16 02:49:19',3310491158,1),(52322564,424702890,15031952,439281,1,'2007-09-16 02:49:20',3310491158,1),(52322567,424703636,15033229,439281,1,'2007-09-16 02:49:20',3310491158,1),(52322570,424704559,15034299,439281,1,'2007-09-16 02:49:20',3310491158,1),(52322571,424705698,15035035,439281,1,'2007-09-16 02:49:21',3310491158,1),(52322574,424706719,15035388,439281,1,'2007-09-16 02:49:21',3310491158,1),(52322578,424707818,15035310,439281,1,'2007-09-16 02:49:21',3310491158,1),(52322579,424708997,15034878,439281,1,'2007-09-16 02:49:21',3310491158,1),(52322581,424709900,15034407,439281,1,'2007-09-16 02:49:21',3310491158,1),(52322583,424710607,15034093,439281,1,'2007-09-16 02:49:21',3310491159,1),(52322585,424711510,15034093,439281,1,'2007-09-16 02:49:22',3310491159,1),(52322587,424712531,15034603,439281,1,'2007-09-16 02:49:22',3310491159,1),(52322589,424713356,15035742,439281,1,'2007-09-16 02:49:22',3310491159,1),(52322591,424714455,15038295,439281,1,'2007-09-16 02:49:22',3310491159,1),(52322593,424715712,15040651,439281,1,'2007-09-16 02:49:22',3310491159,1),(52322595,424716380,15041750,439281,1,'2007-09-16 02:49:22',3310491159,1),(52322598,424717283,15042732,439281,1,'2007-09-16 02:49:23',3310491159,1),(52322601,424718343,15042850,439281,1,'2007-09-16 02:49:23',3310491159,1),(52322602,424719836,15042143,439281,1,'2007-09-16 02:49:23',3310491159,1),(52322604,424721131,15041279,439281,1,'2007-09-16 02:49:23',3310491159,1),(52322606,424722310,15040376,439281,1,'2007-09-16 02:49:23',3310491159,1),(52322611,424723331,15039826,439281,1,'2007-09-16 02:49:23',3310491159,1),(52322613,424725019,15040219,439281,1,'2007-09-16 02:49:24',3310491159,1),(52322615,424725726,15040572,439281,1,'2007-09-16 02:49:24',3310491159,1),(52322617,424726889,15040627,439281,1,'2007-09-16 02:49:24',3310491159,1),(52322618,424727894,15039905,439281,1,'2007-09-16 02:49:25',3310491159,1),(52322623,424729025,15038083,439281,1,'2007-09-16 02:49:25',3310491159,1),(52322626,424730596,15035663,439281,1,'2007-09-16 02:49:25',3310491159,1),(52322627,424732010,15032899,439281,1,'2007-09-16 02:49:25',3310491159,1),(52322630,424733112,15031029,439281,1,'2007-09-16 02:49:25',3310491159,1),(52322632,424733609,15030033,439281,1,'2007-09-16 02:49:25',3310491159,1),(52322634,424733836,15028631,439281,1,'2007-09-16 02:49:26',3310491159,1),(52322636,424699396,14968070,439281,1,'2007-09-16 02:49:26',3310491156,1),(52322639,424701038,14966789,439281,1,'2007-09-16 02:49:26',3310491156,1),(52322641,424702716,14965903,439281,1,'2007-09-16 02:49:26',3310491156,1),(52322644,424703638,14965470,439281,1,'2007-09-16 02:49:26',3310491156,1),(52322646,424704708,14965249,439281,1,'2007-09-16 02:49:27',3310491156,1),(52322648,424706220,14965138,439281,1,'2007-09-16 02:49:27',3310491156,1),(52322651,424707364,14965359,439281,1,'2007-09-16 02:49:27',3310491156,1),(52322654,424707733,14966355,439281,1,'2007-09-16 02:49:27',3310491156,1),(52322656,424707438,14966945,439281,1,'2007-09-16 02:49:27',3310491156,1),(52322657,424706479,14967904,439281,1,'2007-09-16 02:49:27',3310491156,1),(52322660,424704966,14968532,439281,1,'2007-09-16 02:49:27',3310491156,1),(52322663,424703048,14969749,439281,1,'2007-09-16 02:49:28',3310491156,1),(52322665,424701462,14971261,439281,1,'2007-09-16 02:49:28',3310491156,1),(52322667,424699433,14973216,439281,1,'2007-09-16 02:49:28',3310491156,1),(52322670,424698031,14974434,439281,1,'2007-09-16 02:49:28',3310491156,1),(52322673,424697441,14974913,439281,1,'2007-09-16 02:49:29',3310491156,1),(52322675,424697441,14975577,439281,1,'2007-09-16 02:49:29',3310491156,1),(52322677,424697662,14976094,439281,1,'2007-09-16 02:49:29',3310491156,1),(52322678,424698326,14976352,439281,1,'2007-09-16 02:49:29',3310491156,1),(52322681,424699249,14976057,439281,1,'2007-09-16 02:49:29',3310491156,1),(52322684,424701167,14975098,439281,1,'2007-09-16 02:49:29',3310491156,1),(52322685,424702679,14974581,439281,1,'2007-09-16 02:49:30',3310491156,1),(52322687,424703970,14974323,439281,1,'2007-09-16 02:49:30',3310491156,1),(52322690,424705151,14974581,439281,1,'2007-09-16 02:49:30',3310491156,1),(52322692,424705888,14975467,439281,1,'2007-09-16 02:49:30',3310491156,1),(52322695,424707212,14977243,439281,1,'2007-09-16 02:49:30',3310491156,1),(52322697,424707460,14977916,439281,1,'2007-09-16 02:49:30',3310491156,1),(52322698,424706787,14978978,439281,1,'2007-09-16 02:49:30',3310491156,1),(52322700,424706043,14978978,439281,1,'2007-09-16 02:49:31',3310491156,1),(52322701,424704875,14979120,439281,1,'2007-09-16 02:49:31',3310491156,1),(52322704,424703529,14979580,439281,1,'2007-09-16 02:49:31',3310491156,1),(52322706,424701723,14980289,439281,1,'2007-09-16 02:49:31',3310491156,1),(52322709,424711666,14983404,439281,1,'2007-09-16 02:49:31',3310491157,1),(52322712,424707614,14978403,439281,1,'2007-09-16 02:49:32',3310491156,1),(52322713,424734301,15026252,439281,1,'2007-09-16 02:49:32',3310491159,1),(52322716,424734817,15024464,439281,1,'2007-09-16 02:49:32',3310491159,1),(52322719,424735952,15022813,439281,1,'2007-09-16 02:49:32',3310491159,1),(52322722,424737293,15020990,439281,1,'2007-09-16 02:49:32',3310491159,1),(52322725,424738875,15018995,439281,1,'2007-09-16 02:49:33',3310491202,1),(52322727,424739735,15017964,439281,1,'2007-09-16 02:49:33',3310491202,1),(52322729,424740595,15016381,439281,1,'2007-09-16 02:49:33',3310491202,1),(52322731,424741386,15014387,439281,1,'2007-09-16 02:49:33',3310491202,1),(52322733,424741730,15013286,439281,1,'2007-09-16 02:49:33',3310491202,1),(52322736,424741902,15011635,439281,1,'2007-09-16 02:49:33',3310491202,1),(52322738,424741455,15010191,439281,1,'2007-09-16 02:49:34',3310491202,1),(52322739,424741248,15008540,439281,1,'2007-09-16 02:49:34',3310491202,1),(52322741,424741420,15007405,439281,1,'2007-09-16 02:49:34',3310491202,1),(52322753,424741936,15006923,439281,1,'2007-09-16 02:49:36',3310491202,1),(52322755,424742521,15006855,439281,1,'2007-09-16 02:49:36',3310491202,1),(52322758,424743002,15007233,439281,1,'2007-09-16 02:49:36',3310491202,1),(52322761,424743209,15008058,439281,1,'2007-09-16 02:49:37',3310491202,1),(52322764,424743209,15010397,439281,1,'2007-09-16 02:49:37',3310491202,1),(52322765,424742899,15013183,439281,1,'2007-09-16 02:49:37',3310491202,1),(52322768,424742280,15016106,439281,1,'2007-09-16 02:49:37',3310491202,1),(52322770,424741386,15018651,439281,1,'2007-09-16 02:49:37',3310491202,1),(52322773,424739460,15022607,439281,1,'2007-09-16 02:49:37',3310491202,1),(52322774,424738463,15025289,439281,1,'2007-09-16 02:49:38',3310491202,1),(52322777,424737775,15028488,439281,1,'2007-09-16 02:49:38',3310491159,1),(52322780,424737775,15030448,439281,1,'2007-09-16 02:49:38',3310491159,1),(52322782,424737706,15031996,439281,1,'2007-09-16 02:49:38',3310491159,1);
INSERT INTO `current_nodes` VALUES (52322785,424737328,15033234,439281,1,'2007-09-16 02:49:38',3310491159,1),(52322787,424736365,15035366,439281,1,'2007-09-16 02:49:38',3310491159,1),(52322789,424735402,15037877,439281,1,'2007-09-16 02:49:39',3310491159,1),(52322791,424734232,15041626,439281,1,'2007-09-16 02:49:39',3310491159,1),(52322793,424733200,15044721,439281,1,'2007-09-16 02:49:39',3310491159,1),(52322795,424732650,15047782,439281,1,'2007-09-16 02:49:39',3310491159,1),(52322796,424732616,15050602,439281,1,'2007-09-16 02:49:39',3310491159,1),(52322799,424732856,15053250,439281,1,'2007-09-16 02:49:40',3310491165,1),(52322800,424732925,15055142,439281,1,'2007-09-16 02:49:40',3310491165,1),(52322802,424732375,15056827,439281,1,'2007-09-16 02:49:40',3310491165,1),(52322804,424731378,15058444,439281,1,'2007-09-16 02:49:40',3310491165,1),(52322806,424730243,15059682,439281,1,'2007-09-16 02:49:40',3310491165,1),(52322809,424728970,15060473,439281,1,'2007-09-16 02:49:41',3310491165,1),(52322810,424727594,15061092,439281,1,'2007-09-16 02:49:41',3310491165,1),(52322815,424725737,15061711,439281,1,'2007-09-16 02:49:41',3310491165,1),(52322816,424723330,15062124,439281,1,'2007-09-16 02:49:41',3310491165,1),(52322819,424721748,15062296,439281,1,'2007-09-16 02:49:41',3310491165,1),(52322823,424720819,15062640,439281,1,'2007-09-16 02:49:42',3310491165,1),(52322826,424720338,15063740,439281,1,'2007-09-16 02:49:42',3310491165,1),(52322827,424720269,15064875,439281,1,'2007-09-16 02:49:42',3310491165,1),(52322830,424720819,15066354,439281,1,'2007-09-16 02:49:42',3310491165,1),(52322833,424721335,15068039,439281,1,'2007-09-16 02:49:42',3310491165,1),(52322836,424721816,15070412,439281,1,'2007-09-16 02:49:42',3310491165,1),(52322837,424721851,15073645,439281,1,'2007-09-16 02:49:42',3310491165,1),(52322840,424721920,15075193,439281,1,'2007-09-16 02:49:42',3310491165,1),(52322842,424721988,15076947,439281,1,'2007-09-16 02:49:42',3310491165,1),(52322844,424722367,15078942,439281,1,'2007-09-16 02:49:42',3310491165,1),(52322846,424723330,15082072,439281,1,'2007-09-16 02:49:43',3310491165,1),(52322847,424724293,15084720,439281,1,'2007-09-16 02:49:43',3310491165,1),(52322850,424724877,15087024,439281,1,'2007-09-16 02:49:43',3310491165,1),(52322851,424724809,15089741,439281,1,'2007-09-16 02:49:43',3310491165,1),(52322855,424723880,15094212,439281,1,'2007-09-16 02:49:44',3310491165,1),(52322858,424723467,15095863,439281,1,'2007-09-16 02:49:44',3310491165,1),(52322859,424723089,15097307,439281,1,'2007-09-16 02:49:44',3310491165,1),(52322863,424722539,15098442,439281,1,'2007-09-16 02:49:44',3310491165,1),(52322865,424721988,15098993,439281,1,'2007-09-16 02:49:44',3310491165,1),(52322867,424721163,15099302,439281,1,'2007-09-16 02:49:44',3310491165,1),(52322871,424720131,15099577,439281,1,'2007-09-16 02:49:45',3310491165,1),(52322874,424719375,15100196,439281,1,'2007-09-16 02:49:45',3310491165,1),(52322877,424718790,15101056,439281,1,'2007-09-16 02:49:45',3310491165,1),(52322879,424718480,15102329,439281,1,'2007-09-16 02:49:45',3310491165,1),(52322880,424718549,15103636,439281,1,'2007-09-16 02:49:45',3310491165,1),(52322883,424719271,15104599,439281,1,'2007-09-16 02:49:45',3310491165,1),(52322887,424720028,15105115,439281,1,'2007-09-16 02:49:46',3310491165,1),(52322889,424721060,15105149,439281,1,'2007-09-16 02:49:46',3310491165,1),(52322891,424721679,15104736,439281,1,'2007-09-16 02:49:46',3310491165,1),(52322893,424722848,15103533,439281,1,'2007-09-16 02:49:47',3310491165,1),(52322896,424723846,15102398,439281,1,'2007-09-16 02:49:47',3310491165,1),(52322898,424725256,15100196,439281,1,'2007-09-16 02:49:47',3310491165,1),(52322902,424726975,15097514,439281,1,'2007-09-16 02:49:47',3310491165,1),(52322903,424728213,15095313,439281,1,'2007-09-16 02:49:47',3310491165,1),(52322904,424729073,15093731,439281,1,'2007-09-16 02:49:47',3310491165,1),(52322907,424729350,15092379,439281,1,'2007-09-16 02:58:00',3310491165,1),(52322910,424728936,15090910,439281,1,'2007-09-16 02:49:48',3310491165,1),(52322911,424728317,15087849,439281,1,'2007-09-16 02:49:48',3310491165,1),(52322915,424727938,15085476,439281,1,'2007-09-16 02:49:48',3310491165,1),(52322917,424727835,15083344,439281,1,'2007-09-16 02:49:48',3310491165,1),(52322919,424727973,15080386,439281,1,'2007-09-16 02:49:48',3310491165,1),(52322921,424728523,15078013,439281,1,'2007-09-16 02:49:48',3310491165,1),(52322924,424728798,15076431,439281,1,'2007-09-16 02:49:48',3310491165,1),(52322927,424729039,15074918,439281,1,'2007-09-16 02:49:48',3310491165,1),(52322929,424729108,15073577,439281,1,'2007-09-16 02:49:49',3310491165,1),(52322931,424729692,15071822,439281,1,'2007-09-16 02:49:49',3310491165,1),(52322934,424730415,15070791,439281,1,'2007-09-16 02:49:49',3310491165,1),(52322937,424731412,15069587,439281,1,'2007-09-16 02:49:49',3310491165,1),(52322940,424733097,15068590,439281,1,'2007-09-16 02:49:49',3310491165,1),(52322942,424734335,15068039,439281,1,'2007-09-16 02:49:49',3310491165,1),(52322945,424735711,15067867,439281,1,'2007-09-16 02:49:50',3310491165,1),(52322947,424737087,15068418,439281,1,'2007-09-16 02:49:50',3310491165,1),(52322950,424739013,15069312,439281,1,'2007-09-16 02:49:50',3310491208,1),(52322953,424740389,15069793,439281,1,'2007-09-16 02:49:50',3310491208,1),(52322955,424741386,15069690,439281,1,'2007-09-16 02:49:50',3310491208,1),(52322957,424741971,15068658,439281,1,'2007-09-16 02:49:50',3310491208,1),(52322959,424742418,15066698,439281,1,'2007-09-16 02:49:51',3310491208,1),(52322962,424742143,15065253,439281,1,'2007-09-16 02:49:51',3310491208,1),(52322964,424742280,15063534,439281,1,'2007-09-16 02:49:51',3310491208,1),(52322966,424742558,15061503,439281,1,'2007-09-16 02:49:51',3310491208,1),(52322969,424742855,15060136,439281,1,'2007-09-16 02:49:51',3310491208,1),(52322972,424743628,15058650,439281,1,'2007-09-16 02:49:51',3310491208,1),(52322974,424745292,15057224,439281,1,'2007-09-16 02:49:51',3310491208,1),(52322976,424747669,15055322,439281,1,'2007-09-16 02:49:52',3310491208,1),(52322977,424748739,15054668,439281,1,'2007-09-16 02:49:52',3310491208,1),(52322979,424749631,15054906,439281,1,'2007-09-16 02:49:52',3310491208,1),(52322982,424750106,15055084,439281,1,'2007-09-16 02:49:52',3310491208,1),(52327233,424745838,15048585,439281,1,'2007-09-16 02:57:29',3310491202,1),(52327235,424744998,15051169,439281,1,'2007-09-16 02:57:29',3310491202,1),(52327238,424744804,15053204,439281,1,'2007-09-16 02:57:29',3310491208,1),(52327241,424744578,15054367,439281,1,'2007-09-16 02:57:29',3310491208,1),(52327243,424744320,15055466,439281,1,'2007-09-16 02:57:29',3310491208,1),(52327246,424743092,15056726,439281,1,'2007-09-16 02:57:29',3310491208,1),(52327247,424742317,15058212,439281,1,'2007-09-16 02:57:30',3310491208,1),(52327250,424741832,15060796,439281,1,'2007-09-16 02:57:30',3310491208,1),(52327252,424741638,15062961,439281,1,'2007-09-16 02:57:30',3310491208,1),(52327263,424756854,15043267,439281,1,'2007-09-16 02:57:31',3310491202,1),(52327265,424755614,15044391,439281,1,'2007-09-16 02:57:31',3310491202,1),(52327268,424753598,15046834,439281,1,'2007-09-16 02:57:31',3310491202,1),(52327271,424752086,15048694,439281,1,'2007-09-16 02:57:31',3310491202,1),(52327274,424750884,15050051,439281,1,'2007-09-16 02:57:31',3310491202,1),(52327277,424750109,15051331,439281,1,'2007-09-16 02:57:31',3310491202,1),(52327279,424750070,15053075,439281,1,'2007-09-16 02:57:31',3310491208,1),(52327281,424749721,15056215,439281,1,'2007-09-16 02:57:31',3310491208,1),(52327282,424749023,15057533,439281,1,'2007-09-16 02:57:32',3310491208,1),(52327285,424747938,15059937,439281,1,'2007-09-16 02:57:32',3310491208,1),(52327287,424747163,15061720,439281,1,'2007-09-16 02:57:32',3310491208,1),(52327288,424746271,15063930,439281,1,'2007-09-16 02:57:32',3310491208,1),(52327290,424745845,15065597,439281,1,'2007-09-16 02:57:32',3310491208,1),(52327292,424745767,15066992,439281,1,'2007-09-16 02:57:33',3310491208,1),(52327295,424746000,15068272,439281,1,'2007-09-16 02:57:33',3310491208,1),(52327298,424746310,15069202,439281,1,'2007-09-16 02:57:33',3310491208,1),(52327300,424746570,15069818,439281,1,'2007-09-16 02:57:33',3310491208,1),(52327302,424746949,15070577,439281,1,'2007-09-16 02:57:34',3310491208,1),(52327303,424748056,15070766,439281,1,'2007-09-16 02:57:34',3310491208,1),(52327306,424748530,15070577,439281,1,'2007-09-16 02:57:34',3310491208,1),(52327309,424748941,15069470,439281,1,'2007-09-16 02:57:34',3310491208,1),(52327310,424749320,15068364,439281,1,'2007-09-16 02:57:34',3310491208,1),(52327313,424749794,15067289,439281,1,'2007-09-16 02:57:34',3310491208,1),(52327316,424750458,15065646,439281,1,'2007-09-16 02:57:35',3310491208,1),(52327317,424751217,15064476,439281,1,'2007-09-16 02:57:35',3310491208,1),(52327321,424752418,15063243,439281,1,'2007-09-16 02:57:35',3310491208,1),(52327325,424753398,15062295,439281,1,'2007-09-16 02:57:35',3310491208,1),(52327328,424754504,15061789,439281,1,'2007-09-16 02:57:35',3310491208,1),(52327329,424756337,15061663,439281,1,'2007-09-16 02:57:35',3310491208,1),(52327331,424757159,15061663,439281,1,'2007-09-16 02:57:36',3310491208,1),(52327333,424757696,15061884,439281,1,'2007-09-16 02:57:36',3310491208,1),(52327337,424747528,15070839,439281,1,'2007-09-16 02:57:36',3310491208,1),(52327339,424750528,15077400,439281,1,'2007-09-16 02:57:36',3310491208,1),(52327341,424751367,15074659,439281,1,'2007-09-16 02:57:36',3310491208,1),(52327342,424752430,15072058,439281,1,'2007-09-16 02:57:36',3310491208,1),(52327345,424753464,15069681,439281,1,'2007-09-16 02:57:37',3310491208,1),(52327347,424754359,15067640,439281,1,'2007-09-16 02:57:37',3310491208,1),(52327351,424755422,15064787,439281,1,'2007-09-16 02:57:37',3310491208,1),(52327354,424758275,15061040,439281,1,'2007-09-16 02:57:37',3310491208,1),(52327358,424759002,15059530,439281,1,'2007-09-16 02:57:37',3310491208,1),(52327359,424759141,15057460,439281,1,'2007-09-16 02:57:38',3310491208,1),(52327361,424759030,15055111,439281,1,'2007-09-16 02:57:38',3310491208,1),(52327362,424759030,15053182,439281,1,'2007-09-16 02:57:38',3310491208,1),(52327365,424759393,15051867,439281,1,'2007-09-16 02:57:38',3310491208,1),(52327368,424759729,15049965,439281,1,'2007-09-16 02:57:38',3310491202,1),(52327371,424760232,15049294,439281,1,'2007-09-16 02:57:38',3310491202,1),(52327372,424760875,15049182,439281,1,'2007-09-16 02:57:39',3310491202,1),(52327375,424761463,15049406,439281,1,'2007-09-16 02:57:39',3310491202,1),(52327378,424761966,15050077,439281,1,'2007-09-16 02:57:39',3310491202,1),(52327379,424762190,15051560,439281,1,'2007-09-16 02:57:39',3310491208,1),(52327381,424762777,15056202,439281,1,'2007-09-16 02:57:39',3310491208,1),(52327383,424763033,15058957,439281,1,'2007-09-16 02:57:39',3310491208,1),(52327384,424763434,15064366,439281,1,'2007-09-16 02:57:40',3310491208,1),(52327387,424763301,15066722,439281,1,'2007-09-16 02:57:40',3310491208,1),(52327388,424721063,15112879,439281,1,'2007-09-16 02:57:40',3310491167,1),(52327390,424721824,15111678,439281,1,'2007-09-16 02:57:40',3310491167,1),(52327392,424723026,15110917,439281,1,'2007-09-16 02:57:40',3310491167,1),(52327393,424723987,15110476,439281,1,'2007-09-16 02:57:40',3310491167,1),(52327398,424724988,15110036,439281,1,'2007-09-16 02:57:40',3310491167,1),(52327401,424726270,15109835,439281,1,'2007-09-16 02:57:40',3310491167,1),(52327403,424726750,15109195,439281,1,'2007-09-16 02:57:41',3310491167,1),(52327406,424728352,15103868,439281,1,'2007-09-16 02:57:41',3310491165,1),(52327408,424730755,15096980,439281,1,'2007-09-16 02:57:41',3310491165,1),(52327411,424730755,15094216,439281,1,'2007-09-16 02:57:41',3310491165,1),(52327413,424730395,15093575,439281,1,'2007-09-16 02:57:41',3310491165,1),(52327417,424729336,15093034,439281,1,'2007-09-16 02:57:41',3310491165,1),(52327418,424730406,15030447,439281,1,'2007-09-16 02:57:42',3310491159,1),(52327421,424729592,15032123,439281,1,'2007-09-16 02:57:42',3310491159,1),(52327423,424728443,15033727,439281,1,'2007-09-16 02:57:42',3310491159,1),(52327427,424727461,15034924,439281,1,'2007-09-16 02:57:42',3310491159,1),(52327429,424726839,15035954,439281,1,'2007-09-16 02:57:42',3310491159,1),(52327432,424726264,15037008,439281,1,'2007-09-16 02:57:42',3310491159,1),(52327434,424725737,15039139,439281,1,'2007-09-16 02:57:42',3310491159,1),(52328346,424726170,15045714,439281,1,'2007-09-16 02:59:18',3310491159,1),(52328347,424725790,15044674,439281,1,'2007-09-16 02:59:18',3310491159,1),(52328348,424724015,15044193,439281,1,'2007-09-16 02:59:19',3310491159,1),(52328350,424723317,15044193,439281,1,'2007-09-16 02:59:19',3310491159,1),(52328353,424722925,15043812,439281,1,'2007-09-16 02:59:19',3310491159,1),(52328354,424722646,15043356,439281,1,'2007-09-16 02:59:19',3310491159,1),(52328357,424722697,15042672,439281,1,'2007-09-16 02:59:19',3310491159,1),(52328358,424723026,15042165,439281,1,'2007-09-16 02:59:19',3310491159,1),(52328360,424723584,15041911,439281,1,'2007-09-16 02:59:20',3310491159,1),(52328362,424724649,15041886,439281,1,'2007-09-16 02:59:20',3310491159,1),(52328364,424725688,15041886,439281,1,'2007-09-16 02:59:20',3310491159,1),(52328365,424726145,15041455,439281,1,'2007-09-16 02:59:20',3310491159,1),(52328367,424726449,15040694,439281,1,'2007-09-16 02:59:20',3310491159,1),(52328370,424725299,15044319,439281,1,'2007-09-16 02:59:21',3310491159,1),(52328373,424724599,15044210,439281,1,'2007-09-16 02:59:21',3310491159,1),(52329934,424699435,14943807,439281,1,'2007-09-16 03:02:35',3310491156,1),(52329937,424699301,14946435,439281,1,'2007-09-16 03:02:35',3310491156,1),(52329940,424698994,14950009,439281,1,'2007-09-16 03:02:35',3310491156,1),(52329942,424698894,14951282,439281,1,'2007-09-16 03:02:35',3310491156,1),(52329943,424698441,14951936,439281,1,'2007-09-16 03:02:35',3310491156,1),(52329946,424697736,14952187,439281,1,'2007-09-16 03:02:35',3310491156,1),(52329948,424696680,14952187,439281,1,'2007-09-16 03:02:35',3310491156,1),(52329951,424694587,14952187,439281,1,'2007-09-16 03:02:35',3310491156,1),(52329953,424691595,14948897,439281,1,'2007-09-16 03:02:36',3310491156,1),(52329956,424691671,14950323,439281,1,'2007-09-16 03:02:36',3310491156,1),(52329957,424691424,14951520,439281,1,'2007-09-16 03:02:36',3310491156,1),(52329960,424690796,14952281,439281,1,'2007-09-16 03:02:36',3310491156,1),(52329962,424689827,14952946,439281,1,'2007-09-16 03:02:36',3310491156,1),(52329964,424688553,14953897,439281,1,'2007-09-16 03:02:36',3310491156,1),(52329967,424687944,14954638,439281,1,'2007-09-16 03:02:36',3310491156,1),(52329968,424687887,14955456,439281,1,'2007-09-16 03:02:36',3310491156,1),(52329970,424688325,14956311,439281,1,'2007-09-16 03:02:37',3310491156,1),(52329972,424688895,14956920,439281,1,'2007-09-16 03:02:37',3310491156,1),(52329974,424689979,14957300,439281,1,'2007-09-16 03:02:37',3310491156,1),(52329978,424692659,14958156,439281,1,'2007-09-16 03:02:37',3310491156,1),(52329981,424694979,14959049,439281,1,'2007-09-16 03:02:37',3310491156,1),(52330668,424692346,14933331,439281,1,'2007-09-16 03:04:37',3310490814,1),(52330669,424692472,14935143,439281,1,'2007-09-16 03:04:37',3310490814,1),(52330670,424692598,14937529,439281,1,'2007-09-16 03:04:37',3310490814,1),(52330671,424692179,14938952,439281,1,'2007-09-16 03:04:37',3310490814,1),(52330672,424690798,14941421,439281,1,'2007-09-16 03:04:37',3310490814,1),(52330673,424688705,14945397,439281,1,'2007-09-16 03:04:37',3310491156,1),(52330674,424687449,14947615,439281,1,'2007-09-16 03:04:37',3310491156,1),(52330675,424686612,14948411,439281,1,'2007-09-16 03:04:38',3310491156,1),(52330676,424685273,14948704,439281,1,'2007-09-16 03:04:38',3310491156,1),(52330677,424683934,14948704,439281,1,'2007-09-16 03:04:38',3310491156,1),(52330678,424683515,14948704,439281,1,'2007-09-16 03:04:38',3310491156,1),(52578581,424613114,14871296,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578583,424618507,14874900,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578586,424623063,14878054,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578587,424626729,14880620,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578590,424628404,14881772,27626,1,'2009-04-01 15:29:34',3310490808,4),(52578592,424629556,14882924,27626,1,'2009-04-01 15:29:34',3310490808,4),(52578594,424630185,14883815,27626,1,'2009-04-01 15:29:34',3310490808,4),(52578597,424630185,14884705,27626,1,'2009-04-01 15:29:34',3310490808,4),(52578598,424629452,14885071,27626,1,'2009-04-01 15:29:34',3310490808,4),(52578600,424627986,14884600,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578601,424626676,14884076,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578604,424625263,14883553,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578605,424623377,14883500,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578607,424620183,14883605,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578610,424617198,14884181,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578612,424614999,14884129,27626,1,'2009-04-01 15:29:35',3310490797,4),(52578614,424613323,14883448,27626,1,'2009-04-01 15:29:35',3310490797,4),(52578616,424611124,14881615,27626,1,'2009-04-01 15:29:35',3310490797,4),(52578617,424608872,14879573,27626,1,'2009-04-01 15:29:35',3310490797,4),(52578620,424607354,14878892,27626,1,'2009-04-01 15:29:35',3310490797,4),(52578621,424606568,14879521,27626,1,'2009-04-01 15:29:35',3310490797,4),(52578624,424606411,14880673,27626,1,'2009-04-01 15:29:35',3310490797,4),(52578626,424608349,14884914,27626,1,'2009-04-01 15:29:35',3310490797,4),(52578628,424610680,14890205,27626,1,'2009-04-01 15:29:35',3310490799,4),(52578630,424612212,14893779,27626,1,'2009-04-01 15:29:35',3310490799,4),(52578632,424612635,14896016,27626,1,'2009-04-01 15:29:35',3310490799,4),(52578634,424612562,14896306,27626,1,'2009-04-01 15:29:35',3310490799,4),(52578637,424611115,14898904,443749,1,'2007-09-16 13:35:16',3310490799,1),(52578638,424612328,14870489,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578640,424611638,14869552,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578642,424611835,14868763,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578644,424612328,14868024,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578646,424613166,14867826,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578648,424614300,14867974,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578650,424618492,14869355,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578651,424621253,14870686,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578653,424622387,14871179,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578654,424623176,14870933,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578656,424623570,14870193,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578657,424623472,14869355,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578659,424622929,14868517,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578662,424622042,14867136,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578663,424621302,14865805,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578665,424621351,14863980,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578666,424621549,14862353,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578668,424621499,14861121,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578669,424620908,14860282,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578671,424620020,14859839,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578672,424618442,14859543,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578673,424616519,14859493,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578674,424614941,14859592,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578675,424612969,14859839,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578676,424611046,14860282,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578677,424608334,14861860,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578678,424606017,14863241,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578679,424603798,14864671,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578680,424602664,14865065,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578682,424601825,14865065,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578685,424601234,14864375,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578686,424601579,14863685,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578689,424602318,14862698,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578690,424604833,14860874,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578693,424606707,14859198,27626,1,'2009-04-01 15:29:33',3310490797,5),(52578697,424607397,14858704,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578699,424608679,14857620,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578701,424610158,14856634,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578703,424610898,14855795,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578705,424610849,14855105,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578707,424610011,14855006,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578708,424609222,14855302,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578711,424607940,14856338,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578713,424606855,14856880,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578715,424605770,14857028,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578716,424604735,14856979,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578719,424603551,14855992,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578720,424602318,14853281,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578722,424601727,14850618,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578724,424601036,14846723,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578725,424600642,14842581,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578727,424600001,14836959,27626,1,'2009-04-01 15:29:32',3310490796,4),(52578728,424600001,14834494,27626,1,'2009-04-01 15:29:32',3310490796,4),(52578730,424600543,14832078,27626,1,'2009-04-01 15:29:32',3310490796,4),(52578733,424600790,14829958,27626,1,'2009-04-01 15:29:32',3310490791,4),(52578735,424600642,14829415,27626,1,'2009-04-01 15:29:32',3310490791,4),(52578738,424599557,14828577,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578740,424598670,14828478,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578743,424597831,14828281,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578746,424594873,14827591,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578748,424592851,14827344,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578750,424591175,14827098,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578753,424588413,14827394,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578754,424586540,14827591,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578757,424584370,14828133,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578760,424582940,14828528,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578761,424581757,14828676,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578764,424581264,14828281,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578767,424581757,14827049,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578769,424582496,14826408,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578770,424584272,14825619,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578773,424589153,14823104,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578774,424593640,14821822,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578775,424595958,14821230,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578776,424597437,14821181,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578778,424599902,14821575,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578780,424601825,14822118,27626,1,'2009-04-01 15:29:32',3310490791,4),(52578782,424603551,14821871,27626,1,'2009-04-01 15:29:32',3310490791,4),(52578783,424604833,14821082,27626,1,'2009-04-01 15:29:32',3310490791,4),(52578786,424605721,14819455,27626,1,'2009-04-01 15:29:32',3310490791,4),(52578788,424604932,14818715,27626,1,'2009-04-01 15:29:31',3310490791,4),(52578790,424604488,14819258,27626,1,'2009-04-01 15:29:31',3310490791,4),(52578792,424604143,14819652,27626,1,'2009-04-01 15:29:31',3310490791,4),(52578793,424603157,14820343,27626,1,'2009-04-01 15:29:31',3310490791,4),(52578794,424605651,14818831,27626,1,'2009-04-01 15:29:32',3310490791,4),(52578797,424605481,14820274,27626,1,'2009-04-01 15:29:32',3310490791,4),(52578800,424594104,14821703,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578801,424605080,14824435,443749,1,'2007-09-16 13:35:52',3310490791,1),(52578802,424598118,14823026,443749,1,'2007-09-16 13:35:52',3310490790,1),(52578805,424601550,14823723,443749,1,'2007-09-16 13:35:53',3310490791,1),(52578806,424602269,14820441,27626,1,'2009-04-01 15:29:31',3310490791,4),(52578809,424601234,14820096,27626,1,'2009-04-01 15:29:31',3310490791,4),(52578810,424599853,14819356,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578813,424598670,14818420,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578814,424597388,14817187,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578817,424595711,14816447,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578818,424594281,14816102,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578820,424592555,14815905,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578822,424591076,14815856,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578825,424589153,14815510,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578826,424587181,14814919,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578829,424585504,14813587,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578830,424584420,14812157,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578833,424583828,14810234,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578835,424583236,14808163,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578837,424581757,14806487,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578839,424580130,14805895,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578841,424577467,14805008,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578843,424575002,14804416,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578845,424573356,14804177,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578848,424571396,14804177,27626,1,'2009-04-01 15:29:30',3310490787,4),(52578852,424569181,14804177,27626,1,'2009-04-01 15:29:30',3310490787,4),(52578856,424567732,14805115,27626,1,'2009-04-01 15:29:30',3310490787,4),(52578858,424567051,14806563,27626,1,'2009-04-01 15:29:30',3310490787,4),(52578861,424566369,14809460,27626,1,'2009-04-01 15:29:30',3310490787,4),(52578863,424566114,14810227,27626,1,'2009-04-01 15:29:30',3310490787,4),(52578867,424565347,14809886,27626,1,'2009-04-01 15:29:30',3310490787,4),(52578871,424565261,14809375,27626,1,'2009-04-01 15:29:30',3310490787,4),(52578872,424565091,14806904,27626,1,'2009-04-01 15:29:30',3310490787,4),(52578875,424565091,14800343,27626,1,'2009-04-01 15:29:30',3310490787,4),(52578877,424564955,14795517,27626,1,'2009-04-01 15:29:30',3310490787,4),(52579067,424566045,14788810,27626,1,'2009-04-01 15:29:30',3310490787,4),(52579069,424567081,14784175,27626,1,'2009-04-01 15:29:30',3310490787,4),(52579071,424567736,14780630,27626,1,'2009-04-01 15:29:30',3310490787,4),(52579074,424568336,14776758,27626,1,'2009-04-01 15:29:30',3310490785,4),(52579075,424569590,14772669,27626,1,'2009-04-01 15:29:30',3310490785,4),(52579077,424571062,14769397,27626,1,'2009-04-01 15:29:30',3310490785,4),(52579079,424571880,14766398,27626,1,'2009-04-01 15:29:30',3310490785,4),(52579081,424572316,14763998,27626,1,'2009-04-01 15:29:30',3310490785,4),(52579083,424572589,14761817,27626,1,'2009-04-01 15:29:30',3310490785,4),(52579084,424572916,14759308,27626,1,'2009-04-01 15:29:30',3310490785,4),(52579087,424573516,14756909,27626,1,'2009-04-01 15:29:30',3310490788,4),(52579089,424574334,14755001,27626,1,'2009-04-01 15:29:30',3310490788,4),(52579091,424575152,14752983,27626,1,'2009-04-01 15:29:30',3310490788,4),(52579092,424575752,14750420,27626,1,'2009-04-01 15:29:30',3310490788,5),(52579096,424576243,14748457,27626,1,'2009-04-01 15:29:30',3310490788,4),(52579099,424577388,14746330,27626,1,'2009-04-01 15:29:30',3310490788,4),(52579100,424577715,14744749,27626,1,'2009-04-01 15:29:30',3310490788,4),(52579103,424577442,14743604,27626,1,'2009-04-01 15:29:30',3310490788,4),(52579104,424576952,14742731,27626,1,'2009-04-01 15:29:30',3310490788,4),(52579107,424575588,14742131,27626,1,'2009-04-01 15:29:30',3310490788,4),(52579108,424574334,14741913,27626,1,'2009-04-01 15:29:29',3310490788,4),(52579111,424573243,14741313,27626,1,'2009-04-01 15:29:29',3310490788,4),(52579113,424572807,14740495,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579115,424572672,14739065,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579117,424572420,14737585,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579118,424572141,14736273,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579121,424571527,14734542,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579122,424570717,14732755,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579125,424569907,14730884,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579126,424568400,14728567,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579129,424566278,14725942,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579131,424564711,14724410,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579133,424563167,14722480,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579135,424562154,14719971,27626,1,'2009-04-01 15:29:29',3310490763,4),(52579138,424560996,14717125,27626,1,'2009-04-01 15:29:29',3310490763,4),(52579140,424559838,14715340,27626,1,'2009-04-01 15:29:29',3310490763,4),(52579142,424558053,14713024,27626,1,'2009-04-01 15:29:29',3310490763,4),(52579145,424556991,14710756,27626,1,'2009-04-01 15:29:29',3310490763,4),(52579146,424556364,14709888,27626,1,'2009-04-01 15:29:29',3310490763,4),(52579149,424555592,14709936,27626,1,'2009-04-01 15:29:29',3310490763,4),(52579151,424555110,14710515,27626,1,'2009-04-01 15:29:29',3310490763,4),(52579153,424555110,14711480,27626,1,'2009-04-01 15:29:29',3310490763,4),(52579155,424554386,14714230,27626,1,'2009-04-01 15:29:29',3310490763,4),(52579159,424554097,14719103,27626,1,'2009-04-01 15:29:29',3310490763,4),(52579160,424554048,14722094,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579163,424553277,14723252,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579165,424552649,14724989,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579167,424552456,14726677,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579171,424552891,14729813,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579173,424553807,14733576,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579177,424554483,14735313,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579179,424554869,14736712,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579183,424554820,14737581,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579184,424554290,14737919,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579188,424553759,14737581,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579190,424552842,14735651,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579194,424551974,14733866,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579199,424550864,14731164,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579201,424549948,14728993,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579203,424549369,14726533,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579206,424549127,14723976,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579208,424549996,14720984,27626,1,'2009-04-01 15:29:28',3310490763,4),(52579210,424550430,14719440,27626,1,'2009-04-01 15:29:28',3310490763,4),(52579211,424549899,14718813,27626,1,'2009-04-01 15:29:28',3310490763,4),(52579213,424549176,14718958,27626,1,'2009-04-01 15:29:28',3310490763,4),(52579216,424548741,14720212,27626,1,'2009-04-01 15:29:28',3310490763,4),(52579219,424547777,14723783,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579222,424547198,14726677,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579224,424546860,14730585,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579225,424546667,14733818,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579226,424546715,14736037,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579227,424547439,14738883,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579228,424547680,14739704,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579229,424547873,14740669,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579230,424547680,14741344,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579233,424546908,14741633,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579235,424546088,14741296,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579236,424545461,14740476,27626,1,'2009-04-01 15:29:28',3310490784,4),(52579238,424544689,14737870,27626,1,'2009-04-01 15:29:28',3310490784,4),(52579240,424543338,14734011,27626,1,'2009-04-01 15:29:28',3310490784,4),(52579242,424542566,14730392,27626,1,'2009-04-01 15:29:28',3310490784,4),(52579243,424541746,14726388,27626,1,'2009-04-01 15:29:28',3310490784,4),(52579246,424541360,14723541,27626,1,'2009-04-01 15:29:28',3310490784,4),(52579248,424541553,14720888,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579250,424542084,14716980,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579252,424542566,14713603,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579254,424542807,14711190,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579257,424543193,14709164,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579258,424543434,14707283,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579261,424543627,14706125,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579262,424543531,14705256,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579265,424542904,14705063,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579266,424542180,14705835,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579269,424542180,14706366,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579270,424542084,14707958,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579271,424541842,14709068,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579274,424541263,14710274,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579275,424539334,14714278,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579277,424537307,14717848,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579279,424535860,14719778,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579281,424535233,14722625,27626,1,'2009-04-01 15:29:28',3310490784,4),(52579282,424534027,14727208,27626,1,'2009-04-01 15:29:28',3310490784,4),(52579285,424533737,14731598,27626,1,'2009-04-01 15:29:28',3310490784,4),(52579287,424533689,14733094,27626,1,'2009-04-01 15:29:27',3310490784,4),(52579290,424534171,14734927,27626,1,'2009-04-01 15:29:27',3310490784,4),(52579292,424534123,14735796,27626,1,'2009-04-01 15:29:27',3310490784,4),(52579293,424533737,14736423,27626,1,'2009-04-01 15:29:27',3310490784,4),(52579296,424532965,14736519,27626,1,'2009-04-01 15:29:27',3310490784,4),(52579297,424532338,14736182,27626,1,'2009-04-01 15:29:27',3310490784,4),(52579299,424531566,14734155,27626,1,'2009-04-01 15:29:27',3310490784,4),(52579301,424531614,14732033,27626,1,'2009-04-01 15:29:27',3310490784,4),(52579303,424530456,14729041,27626,1,'2009-04-01 15:29:27',3310490784,4),(52579306,424530167,14726484,27626,1,'2009-04-01 15:29:27',3310490784,4),(52579308,424529829,14721997,27626,1,'2009-04-01 15:29:27',3310490784,4),(52579310,424529781,14717366,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579312,424530263,14713265,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579313,424531035,14708633,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579315,424531952,14701590,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579317,424532531,14696958,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579319,424532709,14693081,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579321,424532537,14689897,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579323,424531246,14688176,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579324,424530471,14686368,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579327,424530127,14683357,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579328,424530127,14680689,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579331,424530127,14678968,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579332,424529783,14677591,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579335,424529525,14676731,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579336,424528836,14675182,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579339,424528492,14673116,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579340,424529439,14670277,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579342,424530190,14667681,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579343,424530851,14664993,27626,1,'2009-04-01 15:29:27',3310490760,4),(52579345,424530939,14662702,27626,1,'2009-04-01 15:29:27',3310490760,4),(52579347,424530455,14659882,27626,1,'2009-04-01 15:29:27',3310490760,4),(52579349,424529926,14657503,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579350,424529221,14654375,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579353,424529309,14651952,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579355,424529486,14648075,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579357,424528869,14646268,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579359,424527899,14643096,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579361,424526798,14640673,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579363,424525873,14637985,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579365,424524507,14635870,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579367,424523097,14634504,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579369,424522304,14632742,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579371,424521555,14630583,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579373,424521070,14627103,27626,1,'2009-04-01 15:32:40',3310490760,10),(52579376,424520321,14625649,27626,1,'2009-04-01 15:32:40',3310490760,7),(52579377,424519660,14625516,27626,1,'2009-04-01 15:32:40',3310490760,7),(52579379,424518955,14625693,27626,1,'2009-04-01 15:32:40',3310490760,7),(52579381,424518427,14626354,27626,1,'2009-04-01 15:32:41',3310490760,7),(52579383,424518118,14627323,27626,1,'2009-04-01 15:32:41',3310490077,7),(52579386,424518030,14629173,27626,1,'2009-04-01 15:32:41',3310490077,7),(52579387,424517986,14632346,27626,1,'2009-04-01 15:32:41',3310490077,7),(52579389,424518427,14637192,27626,1,'2009-04-01 15:32:41',3310490760,7),(52579390,424519088,14640893,27626,1,'2009-04-01 15:32:41',3310490760,7),(52579393,424519528,14643977,27626,1,'2009-04-01 15:32:41',3310490760,7),(52579395,424519440,14645651,27626,1,'2009-04-01 15:32:41',3310490760,7),(52579397,424518691,14647149,27626,1,'2009-04-01 15:32:41',3310490760,7),(52579399,424516708,14650586,27626,1,'2009-04-01 15:32:41',3310490077,7),(52579401,424513889,14654639,27626,1,'2009-04-01 15:32:41',3310490077,7),(52579402,424512831,14656358,27626,1,'2009-04-01 15:32:41',3310490077,7),(52579405,424512259,14657988,27626,1,'2009-04-01 15:32:41',3310490077,7),(52579406,424511906,14660543,27626,1,'2009-04-01 15:32:41',3310490077,7),(52579409,424511245,14664156,27626,1,'2009-04-01 15:32:41',3310490077,7),(52579410,424511421,14668958,27626,1,'2009-04-01 15:32:41',3310490079,7),(52579413,424511421,14671954,27626,1,'2009-04-01 15:32:41',3310490079,7),(52579415,424511201,14675038,27626,1,'2009-04-01 15:32:41',3310490079,7),(52579416,424510761,14680370,27626,1,'2009-04-01 15:32:41',3310490079,7),(52579418,424510100,14686626,27626,1,'2009-04-01 15:32:41',3310490079,7),(52579420,424509219,14690767,27626,1,'2009-04-01 15:32:41',3310490079,7),(52594915,424508343,14693237,27626,1,'2009-04-01 15:32:41',3310490079,7),(52594920,424507087,14696692,27626,1,'2009-04-01 15:32:41',3310490079,7),(52594929,424505594,14700619,27626,1,'2009-04-01 15:32:41',3310490079,7),(52594931,424503631,14704231,27626,1,'2009-04-01 15:32:41',3310490079,7),(52594940,424501511,14708550,27626,1,'2009-04-01 15:32:41',3310490079,7),(52594946,424500254,14711848,27626,1,'2009-04-01 15:32:41',3310490079,7),(52594954,424499626,14714832,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594957,424499469,14715539,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594959,424499155,14716089,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594963,424498448,14716481,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594965,424497820,14716010,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594968,424497270,14714440,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594974,424496407,14710670,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594977,424496171,14708864,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594982,424496328,14706351,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594985,424496485,14705252,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594988,424496092,14704781,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594989,424495464,14704781,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594992,424494993,14705252,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594994,424494129,14705409,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594997,424493265,14705330,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594999,424492716,14704702,27626,1,'2009-04-01 15:32:42',3310490079,7),(52595005,424492716,14704231,27626,1,'2009-04-01 15:32:42',3310490079,7),(52595009,424492951,14702974,27626,1,'2009-04-01 15:32:42',3310490079,7),(52595015,424493580,14702268,27626,1,'2009-04-01 15:32:42',3310490079,7),(52595021,424494600,14700461,27626,1,'2009-04-01 15:32:42',3310490079,7),(52595029,424495072,14698969,27626,1,'2009-04-01 15:32:42',3310490079,7),(52595034,424494836,14697634,27626,1,'2009-04-01 15:32:42',3310490079,7),(52595041,424494208,14696692,27626,1,'2009-04-01 15:32:42',3310490079,7),(52595042,424493030,14695985,27626,1,'2009-04-01 15:32:42',3310490079,7),(52595047,424492245,14695907,27626,1,'2009-04-01 15:32:42',3310490079,7),(52595051,424491538,14694886,27626,1,'2009-04-01 15:32:42',3310490079,7),(52595054,424490595,14692530,27626,1,'2009-04-01 15:32:42',3310490078,7),(52595059,424489103,14690959,27626,1,'2009-04-01 15:32:42',3310490078,7),(52595062,424487297,14690017,27626,1,'2009-04-01 15:32:42',3310490078,7),(52595064,424485334,14688525,27626,1,'2009-04-01 15:32:42',3310490078,7),(52595067,424483606,14685934,27626,1,'2009-04-01 15:32:42',3310490078,7),(52595070,424482585,14683185,27626,1,'2009-04-01 15:32:42',3310490078,7),(52595073,424481722,14679494,27626,1,'2009-04-01 15:32:42',3310490078,7),(52595074,424480308,14675175,27626,1,'2009-04-01 15:32:42',3310490078,7),(52595077,424478423,14670385,27626,1,'2009-04-01 15:32:42',3310490078,7),(52595079,424477158,14667499,27626,1,'2009-04-01 15:32:42',3310490078,7),(52595082,424475884,14665941,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595084,424473264,14664242,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595087,424470270,14662429,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595090,424468617,14661239,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595093,424467631,14660050,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595096,424467428,14658716,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595100,424467747,14657730,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595103,424468704,14657382,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595106,424469487,14657382,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595107,424470183,14657266,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595115,424470706,14656802,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595118,424471605,14655961,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595122,424472417,14654974,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595125,424472562,14654249,27626,1,'2009-04-01 15:35:06',3310490076,14),(52595131,424472301,14653756,27626,1,'2009-04-01 15:35:06',3310490076,6),(52595134,424471982,14653524,27626,1,'2009-04-01 15:35:06',3310490076,6),(52595137,424471402,14653582,27626,1,'2009-04-01 15:35:06',3310490076,6),(52595140,424470358,14654394,27626,1,'2009-04-01 15:35:05',3310490076,6),(52595144,424469139,14655032,27626,1,'2009-04-01 15:35:05',3310490076,6),(52595145,424467370,14654829,27626,1,'2009-04-01 15:35:05',3310490076,6),(52595148,424463987,14654429,27626,1,'2009-04-01 15:35:05',3310490076,6),(52595151,424461129,14654429,27626,1,'2009-04-01 15:35:05',3310490073,6),(52595153,424459137,14654083,27626,1,'2009-04-01 15:35:05',3310490073,6),(52595154,424457523,14653740,27626,1,'2009-04-01 15:35:05',3310490073,6),(52595155,424454064,14651745,27626,1,'2009-04-01 15:35:05',3310490073,6),(52595157,424451137,14649971,27626,1,'2009-04-01 15:35:05',3310490073,6),(52595161,424449541,14649439,27626,1,'2009-04-01 15:35:05',3310490073,6),(52595162,424446925,14648818,27626,1,'2009-04-01 15:35:05',3310490073,6),(52595168,424444974,14648907,27626,1,'2009-04-01 15:35:05',3310490073,6),(52595169,424444081,14649774,27626,1,'2009-04-01 15:35:04',3310490073,6),(52595173,424442471,14651077,27626,1,'2009-04-01 15:35:04',3310490073,6),(52595176,424440939,14651537,27626,1,'2009-04-01 15:35:04',3310490073,6),(52595181,424439636,14651153,27626,1,'2009-04-01 15:35:04',3310490073,6),(52595184,424439330,14650081,27626,1,'2009-04-01 15:35:04',3310490073,6),(52595187,424439713,14648931,27626,1,'2009-04-01 15:35:04',3310490073,6),(52595188,424441245,14647475,27626,1,'2009-04-01 15:35:04',3310490073,6),(52595191,424443544,14646020,27626,1,'2009-04-01 15:35:04',3310490073,6),(52595193,424445230,14643874,27626,1,'2009-04-01 15:35:04',3310490073,6),(52595198,424447529,14641958,27626,1,'2009-04-01 15:35:04',3310490073,6),(52595201,424449273,14641024,27626,1,'2009-04-01 15:35:03',3310490073,6),(52595203,424450372,14640200,27626,1,'2009-04-01 15:35:03',3310490073,6),(52595483,424450529,14639102,27626,1,'2009-04-01 15:35:03',3310490073,6),(52595486,424450411,14638670,27626,1,'2009-04-01 15:35:03',3310490073,6),(52595489,424449822,14637807,27626,1,'2009-04-01 15:35:03',3310490073,6),(52595854,424449116,14637768,27626,1,'2009-04-01 15:35:03',3310490073,6),(52595856,424448332,14638396,27626,1,'2009-04-01 15:35:03',3310490073,6),(52595860,424447390,14639102,27626,1,'2009-04-01 15:35:03',3310490073,6),(52595861,424445742,14640122,27626,1,'2009-04-01 15:35:03',3310490073,6),(52595865,424443271,14641338,27626,1,'2009-04-01 15:35:03',3310490073,6),(52595868,424440760,14641691,27626,1,'2009-04-01 15:35:02',3310490073,6),(52595872,424438053,14642280,27626,1,'2009-04-01 15:35:02',3310490073,6),(52595874,424436680,14642240,27626,1,'2009-04-01 15:35:02',3310490073,6),(52595878,424434444,14641377,27626,1,'2009-04-01 15:35:02',3310490072,6),(52595880,424431776,14639416,27626,1,'2009-04-01 15:35:02',3310490072,6),(52596149,424535464,14735997,443749,1,'2007-09-16 14:33:49',3310490784,1),(52596154,424535023,14734423,443749,1,'2007-09-16 14:33:50',3310490784,1),(52596158,424535361,14737772,443749,1,'2007-09-16 14:33:50',3310490784,1),(52596161,424535486,14738669,443749,1,'2007-09-16 14:33:51',3310490784,1),(52596163,424536216,14739878,443749,1,'2007-09-16 14:33:51',3310490784,1),(52596167,424536966,14740879,443749,1,'2007-09-16 14:33:51',3310490784,1),(52596171,424537446,14741921,443749,1,'2007-09-16 14:33:51',3310490784,1),(52596178,424537446,14743151,443749,1,'2007-09-16 14:33:52',3310490784,1),(52596180,424536966,14744298,443749,1,'2007-09-16 14:33:52',3310490784,1),(52596184,424536195,14745590,443749,1,'2007-09-16 14:33:53',3310490784,1),(52596186,424534769,14747800,443749,1,'2007-09-16 14:33:53',3310490784,1),(52596191,424533693,14750477,443749,1,'2007-09-16 14:33:53',3310490784,1),(52596195,424532667,14754656,443749,1,'2007-09-16 14:33:53',3310490784,1),(52596197,424531697,14757468,443749,1,'2007-09-16 14:33:54',3310490784,1),(52596200,424531066,14759119,443749,1,'2007-09-16 14:33:54',3310490784,1),(52596204,424530406,14759749,443749,1,'2007-09-16 14:33:55',3310490784,1),(52596208,424529535,14760170,443749,1,'2007-09-16 14:33:55',3310490784,1),(52596212,424527884,14760410,443749,1,'2007-09-16 14:33:55',3310490784,1),(52596213,424526533,14760860,443749,1,'2007-09-16 14:33:55',3310490784,1),(52596216,424525062,14762361,443749,1,'2007-09-16 14:33:55',3310490784,1),(52596219,424524012,14763853,443749,1,'2007-09-16 14:33:56',3310490784,1),(52596222,424522153,14765625,443749,1,'2007-09-16 14:33:56',3310490784,1),(52596226,424520986,14766360,443749,1,'2007-09-16 14:33:57',3310490784,1),(52596228,424519646,14766706,443749,1,'2007-09-16 14:33:57',3310490784,1),(52596231,424517873,14766533,443749,1,'2007-09-16 14:33:57',3310490101,1),(52596234,424513463,14765150,443749,1,'2007-09-16 14:33:58',3310490101,1),(52596236,424508967,14762686,443749,1,'2007-09-16 14:33:58',3310490101,1),(52596238,424504903,14760048,443749,1,'2007-09-16 14:33:58',3310490101,1),(52596241,424504212,14758103,443749,1,'2007-09-16 14:33:58',3310490101,1),(52596243,424502612,14756633,443749,1,'2007-09-16 14:33:58',3310490101,1),(52596246,424501747,14754904,443749,1,'2007-09-16 14:33:59',3310490101,1),(52596249,424500753,14753563,443749,1,'2007-09-16 14:33:59',3310490101,1),(52596271,424497640,14751575,443749,1,'2007-09-16 14:34:04',3310490101,1),(52596274,424496289,14749621,443749,1,'2007-09-16 14:34:04',3310490101,1),(52596277,424494576,14746893,443749,1,'2007-09-16 14:34:04',3310490101,1),(52596280,424493814,14744926,443749,1,'2007-09-16 14:34:04',3310490101,1),(52596283,424493751,14742451,443749,1,'2007-09-16 14:34:05',3310490101,1),(52596285,424493365,14740501,443749,1,'2007-09-16 14:34:05',3310490101,1),(52596288,424492617,14739104,443749,1,'2007-09-16 14:34:06',3310490101,1),(52596291,424491708,14738032,443749,1,'2007-09-16 14:34:06',3310490101,1),(52596295,424490116,14736635,443749,1,'2007-09-16 14:34:06',3310490100,1),(52596297,424488687,14735400,443749,1,'2007-09-16 14:34:07',3310490100,1),(52596299,424487517,14733613,443749,1,'2007-09-16 14:34:08',3310490100,1),(52596300,424486218,14730300,443749,1,'2007-09-16 14:34:08',3310490100,1),(52596303,424484756,14727863,443749,1,'2007-09-16 14:34:09',3310490100,1),(52596305,424482644,14725167,443749,1,'2007-09-16 14:34:09',3310490100,1),(52596308,424480402,14722828,443749,1,'2007-09-16 14:34:10',3310490100,1),(52596310,424477024,14719676,443749,1,'2007-09-16 14:34:10',3310490078,1),(52596312,424472898,14716233,443749,1,'2007-09-16 14:34:10',3310490078,1),(52596314,424470986,14714822,443749,1,'2007-09-16 14:34:10',3310490078,1),(52596318,424466698,14711983,443749,1,'2007-09-16 14:34:10',3310490078,1),(52596320,424461019,14708796,443749,1,'2007-09-16 14:34:11',3310490075,1),(52596326,424458528,14708043,443749,1,'2007-09-16 14:34:12',3310490075,1),(52596331,424456442,14708507,443749,1,'2007-09-16 14:34:13',3310490075,1),(52596335,424449315,14712157,443749,1,'2007-09-16 14:34:14',3310490075,1),(52596339,424441956,14716387,443749,1,'2007-09-16 14:34:15',3310490075,1),(52596343,424440681,14716271,443749,1,'2007-09-16 14:34:16',3310490075,1),(52596346,424439174,14716039,443749,1,'2007-09-16 14:34:17',3310490075,1),(52596351,424436857,14712852,443749,1,'2007-09-16 14:34:20',3310490075,1),(52603531,424756700,14864202,443749,1,'2007-09-16 14:56:49',3310490856,1),(52603533,424755816,14860409,443749,1,'2007-09-16 14:56:49',3310490856,1),(52603536,424755193,14856407,443749,1,'2007-09-16 14:56:49',3310490856,1),(52603537,424754673,14853757,443749,1,'2007-09-16 14:56:49',3310490856,1),(52603540,424754049,14850743,443749,1,'2007-09-16 14:56:50',3310490856,1),(52603542,424753945,14847418,443749,1,'2007-09-16 14:56:50',3310490856,1),(52612605,424754245,14844324,443749,1,'2007-09-16 15:22:54',3310490856,1),(52612609,424755393,14841383,443749,1,'2007-09-16 15:22:54',3310490856,1),(52612612,424755967,14839088,443749,1,'2007-09-16 15:22:55',3310490856,1),(52612615,424756325,14837438,443749,1,'2007-09-16 15:22:55',3310490856,1),(52612616,424756469,14835358,443749,1,'2007-09-16 15:22:55',3310490856,1),(52612619,424756756,14832777,443749,1,'2007-09-16 15:22:55',3310490856,1),(52612622,424756899,14830912,443749,1,'2007-09-16 15:22:55',3310490850,1),(52612624,424757688,14827326,443749,1,'2007-09-16 15:22:55',3310490850,1),(52612626,424758907,14823525,443749,1,'2007-09-16 15:22:56',3310490850,1),(52612629,424759481,14820154,443749,1,'2007-09-16 15:22:56',3310490850,1),(52612634,424760485,14816639,443749,1,'2007-09-16 15:22:56',3310490850,1),(52612635,424761776,14813771,443749,1,'2007-09-16 15:22:57',3310490850,1),(52612638,424763354,14811332,443749,1,'2007-09-16 15:22:58',3310490850,1),(52612640,424765721,14808391,443749,1,'2007-09-16 15:22:59',3310490851,1),(52612642,424768661,14806455,443749,1,'2007-09-16 15:23:00',3310490851,1),(52612645,424771961,14804016,443749,1,'2007-09-16 15:23:00',3310490851,1),(52612646,424773897,14802223,443749,1,'2007-09-16 15:23:01',3310490851,1),(52612649,424774973,14800717,443749,1,'2007-09-16 15:23:02',3310490851,1),(52612651,424775547,14798422,443749,1,'2007-09-16 15:23:03',3310490851,1),(52612653,424776120,14793474,443749,1,'2007-09-16 15:23:04',3310490851,1),(52612656,424776336,14789601,443749,1,'2007-09-16 15:23:05',3310490851,1),(52612658,424776049,14786947,443749,1,'2007-09-16 15:23:05',3310490851,1),(52612660,424775475,14783935,443749,1,'2007-09-16 15:23:06',3310490851,1),(52612661,424774471,14779918,443749,1,'2007-09-16 15:23:07',3310490851,1),(52612664,424772821,14776978,443749,1,'2007-09-16 15:23:08',3310490851,1),(52612665,424771243,14774611,443749,1,'2007-09-16 15:23:08',3310490849,1),(52612667,424770239,14772388,443749,1,'2007-09-16 15:23:08',3310490849,1),(52612670,424769522,14769447,443749,1,'2007-09-16 15:23:09',3310490849,1),(52612672,424769092,14767511,443749,1,'2007-09-16 15:23:09',3310490849,1),(52612675,424768805,14765144,443749,1,'2007-09-16 15:23:09',3310490849,1),(52612677,424769450,14761629,443749,1,'2007-09-16 15:23:09',3310490849,1),(52612678,424770096,14758402,443749,1,'2007-09-16 15:23:09',3310490849,1),(52612681,424771458,14753955,443749,1,'2007-09-16 15:23:10',3310490849,1),(52612684,424771446,14751162,443749,1,'2007-09-16 15:23:10',3310490849,1),(52612686,424771393,14747577,443749,1,'2007-09-16 15:23:10',3310490849,1),(52612688,424771024,14743305,443749,1,'2007-09-16 15:23:11',3310490849,1),(52612691,424770497,14740669,443749,1,'2007-09-16 15:23:11',3310490849,1),(52612692,424769706,14738190,443749,1,'2007-09-16 15:23:11',3310490849,1),(52612694,424769653,14736555,443749,1,'2007-09-16 15:23:11',3310490849,1),(52612696,424770128,14733972,443749,1,'2007-09-16 15:23:11',3310490849,1),(52612699,424771182,14731757,443749,1,'2007-09-16 15:23:12',3310490849,1),(52612701,424773133,14728962,443749,1,'2007-09-16 15:23:12',3310490849,1),(52612704,424774293,14727433,443749,1,'2007-09-16 15:23:12',3310490849,1),(52612708,424774768,14726114,443749,1,'2007-09-16 15:23:12',3310490849,1),(52612710,424775559,14723689,443749,1,'2007-09-16 15:23:12',3310490849,1),(52612712,424776350,14722634,443749,1,'2007-09-16 15:23:13',3310490849,1),(52612716,424777616,14721790,443749,1,'2007-09-16 15:23:13',3310490827,1),(52612717,424779409,14721105,443749,1,'2007-09-16 15:23:13',3310490827,1),(52612719,424780569,14720472,443749,1,'2007-09-16 15:23:13',3310490827,1),(52612720,424780991,14719628,443749,1,'2007-09-16 15:23:13',3310490827,1),(52612722,424780569,14718204,443749,1,'2007-09-16 15:23:14',3310490827,1),(52612725,424779672,14717202,443749,1,'2007-09-16 15:23:14',3310490827,1),(52612728,424778934,14716253,443749,1,'2007-09-16 15:23:14',3310490827,1),(52612732,424778459,14714091,443749,1,'2007-09-16 15:23:14',3310490827,1),(52612735,424778301,14710611,443749,1,'2007-09-16 15:23:15',3310490827,1),(52612738,424778143,14707605,443749,1,'2007-09-16 15:23:15',3310490827,1),(52612740,424777405,14704863,443749,1,'2007-09-16 15:23:16',3310490827,1),(52612742,424777774,14702490,443749,1,'2007-09-16 15:23:17',3310490827,1),(52612744,424778618,14700012,443749,1,'2007-09-16 15:23:17',3310490827,1),(52612746,424778828,14698324,443749,1,'2007-09-16 15:23:17',3310490827,1),(52612748,424778776,14696057,443749,1,'2007-09-16 15:23:17',3310490827,1),(52612750,424778037,14693315,443749,1,'2007-09-16 15:23:18',3310490827,1),(52612752,424777563,14691891,443749,1,'2007-09-16 15:23:18',3310490827,1),(52612754,424777616,14690203,443749,1,'2007-09-16 15:23:19',3310490827,1),(52612756,424779092,14687619,443749,1,'2007-09-16 15:23:19',3310490827,1),(52612758,424780041,14685932,443749,1,'2007-09-16 15:23:19',3310490827,1),(52612760,424780938,14685194,443749,1,'2007-09-16 15:23:19',3310490827,1),(52612761,424781834,14684983,443749,1,'2007-09-16 15:23:20',3310490827,1),(52612763,424782994,14684772,443749,1,'2007-09-16 15:23:20',3310490827,1),(52612765,424784102,14684666,443749,1,'2007-09-16 15:23:20',3310490827,1),(52612768,424784998,14683717,443749,1,'2007-09-16 15:23:21',3310490827,1),(52612770,424786158,14681661,443749,1,'2007-09-16 15:23:21',3310490827,1),(52612773,424787266,14680289,443749,1,'2007-09-16 15:23:21',3310490827,1),(52612776,424788479,14678813,443749,1,'2007-09-16 15:23:21',3310490827,1),(52612779,424789902,14677178,443749,1,'2007-09-16 15:23:21',3310490827,1),(52612782,424790852,14675122,443749,1,'2007-09-16 15:23:22',3310490827,1),(52612786,424791010,14672643,443749,1,'2007-09-16 15:23:22',3310490827,1),(52612789,424790324,14670218,443749,1,'2007-09-16 15:23:22',3310490827,1),(52612791,424789217,14668477,443749,1,'2007-09-16 15:23:22',3310490827,1),(52612794,424787529,14667792,443749,1,'2007-09-16 15:23:22',3310490827,1),(52612796,424785104,14666843,443749,1,'2007-09-16 15:23:23',3310490825,1),(52612800,424783785,14666263,443749,1,'2007-09-16 15:23:23',3310490825,1),(52612803,424781887,14664786,443749,1,'2007-09-16 15:23:23',3310490825,1),(52612804,424780621,14663046,443749,1,'2007-09-16 15:23:23',3310490825,1),(52612807,424780621,14661253,443749,1,'2007-09-16 15:23:24',3310490825,1),(52612810,424781307,14659460,443749,1,'2007-09-16 15:23:24',3310490825,1),(52612813,424783891,14657034,443749,1,'2007-09-16 15:23:25',3310490825,1),(52612815,424785886,14655511,443749,1,'2007-09-16 15:23:25',3310490825,1),(52612817,424788070,14654251,443749,1,'2007-09-16 15:23:26',3310490825,1),(52612820,424790253,14653915,443749,1,'2007-09-16 15:23:26',3310490825,1),(52612824,424791933,14652991,443749,1,'2007-09-16 15:23:26',3310490825,1),(52612827,424793444,14651228,443749,1,'2007-09-16 15:23:26',3310490828,1),(52612831,424794452,14648372,443749,1,'2007-09-16 15:23:27',3310490828,1),(52612835,424795796,14645097,443749,1,'2007-09-16 15:23:28',3310490828,1),(52612840,424796384,14641990,443749,1,'2007-09-16 15:23:28',3310490828,1),(52612843,424795964,14639471,443749,1,'2007-09-16 15:23:28',3310490828,1),(52612845,424794788,14637959,443749,1,'2007-09-16 15:23:28',3310490828,1),(52612849,424793276,14637455,443749,1,'2007-09-16 15:23:29',3310490828,1),(52612853,424790925,14637539,443749,1,'2007-09-16 15:23:29',3310490825,1),(52612855,424789581,14637539,443749,1,'2007-09-16 15:23:30',3310490825,1),(52612859,424788154,14637287,443749,1,'2007-09-16 15:23:30',3310490825,1),(52612862,424786894,14636028,443749,1,'2007-09-16 15:23:31',3310490825,1),(52612864,424785299,14635188,443749,1,'2007-09-16 15:23:31',3310490825,1),(52612867,424784039,14634180,443749,1,'2007-09-16 15:23:31',3310490825,1),(52612870,424783031,14632584,443749,1,'2007-09-16 15:23:32',3310490825,1),(52612873,424782947,14630401,443749,1,'2007-09-16 15:23:32',3310490825,1),(52612877,424783367,14627714,443749,1,'2007-09-16 15:23:32',3310490825,1),(52612882,424784039,14626202,443749,1,'2007-09-16 15:23:32',3310490825,1),(52612885,424784963,14624355,443749,1,'2007-09-16 15:23:33',3310490825,1),(52612888,424786474,14622759,443749,1,'2007-09-16 15:23:33',3310490825,1),(52612892,424788154,14622003,443749,1,'2007-09-16 15:23:34',3310490825,1),(52612893,424789665,14620743,443749,1,'2007-09-16 15:23:34',3310490825,1),(52612895,424790757,14619400,443749,1,'2007-09-16 15:23:34',3310490825,1),(52612897,424791513,14618728,443749,1,'2007-09-16 15:23:34',3310490825,1),(52612899,424792521,14618308,443749,1,'2007-09-16 15:23:34',3310490825,1),(52612900,424794284,14618308,443749,1,'2007-09-16 15:23:34',3310490828,1),(52612902,424795796,14618308,443749,1,'2007-09-16 15:23:35',3310490828,1),(52612907,424796468,14617636,443749,1,'2007-09-16 15:23:36',3310490828,1),(52612909,424796804,14616377,443749,1,'2007-09-16 15:23:36',3310490828,1),(52612911,424797223,14614361,443749,1,'2007-09-16 15:23:36',3310490828,1),(52612913,424797811,14611926,443749,1,'2007-09-16 15:23:37',3310490822,1),(52612916,424798399,14610498,443749,1,'2007-09-16 15:23:38',3310490822,1),(52612918,424799323,14609994,443749,1,'2007-09-16 15:23:38',3310490822,1),(52612920,424800583,14609490,443749,1,'2007-09-16 15:23:38',3310490822,1),(52612923,424802094,14609154,443749,1,'2007-09-16 15:23:39',3310490822,1),(52612927,424803606,14608567,443749,1,'2007-09-16 15:23:39',3310490822,1),(52612929,424805117,14607643,443749,1,'2007-09-16 15:23:40',3310490822,1),(52612932,424806377,14606467,443749,1,'2007-09-16 15:23:40',3310490822,1),(52612935,424806881,14604200,443749,1,'2007-09-16 15:23:41',3310490822,1),(52612936,424807301,14600841,443749,1,'2007-09-16 15:23:41',3310490822,1),(52612939,424808393,14596054,443749,1,'2007-09-16 15:23:42',3310490822,1),(52612941,424809538,14592416,443749,1,'2007-09-16 15:23:43',3310490822,1),(52612943,424810599,14590004,443749,1,'2007-09-16 15:23:43',3310490822,1),(52612946,424812336,14589136,443749,1,'2007-09-16 15:23:43',3310490822,1),(52612948,424816870,14587496,443749,1,'2007-09-16 15:23:43',3310490822,1),(52612951,424819147,14586936,443749,1,'2007-09-16 15:23:43',3310490822,1),(52612954,424822698,14586087,443749,1,'2007-09-16 15:23:43',3310490823,1),(52612957,424825090,14585443,443749,1,'2007-09-16 21:50:21',3310490823,1),(52612958,424827869,14584634,443749,1,'2007-09-16 21:50:22',3310490823,1),(52612962,424830339,14585084,443749,1,'2007-09-16 15:23:44',3310490823,1),(52612967,424832268,14585238,443749,1,'2007-09-16 15:23:45',3310490823,1),(52612973,424835201,14584466,443749,1,'2007-09-16 15:23:45',3310490823,1),(52612976,424837516,14583154,443749,1,'2007-09-16 15:23:45',3310490823,1),(52612978,424839292,14581225,443749,1,'2007-09-16 15:23:45',3310490823,1),(52612981,424841375,14577829,443749,1,'2007-09-16 15:23:45',3310490823,1),(52612983,424842765,14575205,443749,1,'2007-09-16 15:23:46',3310490823,1),(52612986,424843922,14571731,443749,1,'2007-09-16 15:23:46',3310490823,1),(52612989,424844077,14568876,443749,1,'2007-09-16 15:23:46',3310490823,1),(52612992,424843768,14565634,443749,1,'2007-09-16 15:23:46',3310490823,1),(52612994,424842996,14561543,443749,1,'2007-09-16 15:23:47',3310490823,1),(52612996,424842379,14557298,443749,1,'2007-09-16 15:23:47',3310490823,1),(52612998,424840990,14551124,443749,1,'2007-09-16 15:23:47',3310490821,1),(52613000,424839909,14547728,443749,1,'2007-09-16 15:23:47',3310490821,1),(52613003,424838443,14545104,443749,1,'2007-09-16 15:23:47',3310490821,1),(52613006,424837439,14543251,443749,1,'2007-09-16 15:23:47',3310490821,1),(52613008,424837362,14542017,443749,1,'2007-09-16 15:23:47',3310490821,1),(52613010,424837748,14541168,443749,1,'2007-09-16 15:23:48',3310490821,1),(52613013,424838674,14540704,443749,1,'2007-09-16 15:23:48',3310490821,1),(52613016,424839678,14541013,443749,1,'2007-09-16 15:23:48',3310490821,1),(52613017,424841144,14542325,443749,1,'2007-09-16 15:23:49',3310490821,1),(52613020,424842302,14542634,443749,1,'2007-09-16 15:23:49',3310490821,1),(52613021,424843845,14542557,443749,1,'2007-09-16 15:23:49',3310490821,1),(52613024,424845003,14542171,443749,1,'2007-09-16 15:23:49',3310490821,1),(52613027,424846006,14541399,443749,1,'2007-09-16 15:23:50',3310490821,1),(52613030,424846701,14540087,443749,1,'2007-09-16 15:23:50',3310490821,1),(52613032,424847164,14538003,443749,1,'2007-09-16 15:23:50',3310490821,1),(52613034,424847396,14535379,443749,1,'2007-09-16 15:23:50',3310490821,1),(52613037,424847010,14532832,443749,1,'2007-09-16 15:23:50',3310490821,1),(52613039,424846778,14530362,443749,1,'2007-09-16 15:23:51',3310490821,1),(52613041,424847704,14527584,443749,1,'2007-09-16 15:23:51',3310490821,1),(52613044,424848598,14525989,443749,1,'2007-09-16 15:23:51',3310490832,1),(52613047,424849581,14525268,443749,1,'2007-09-16 15:23:51',3310490832,1),(52613049,424851220,14525858,443749,1,'2007-09-16 15:23:51',3310490832,1),(52613052,424852990,14527366,443749,1,'2007-09-16 15:23:51',3310490832,1),(52613054,424854432,14529201,443749,1,'2007-09-16 15:23:52',3310490832,1),(52613056,424855284,14530185,443749,1,'2007-09-16 15:23:52',3310490832,1),(52613058,424856071,14530709,443749,1,'2007-09-16 15:23:52',3310490832,1),(52613061,424858153,14530764,443749,1,'2007-09-16 15:23:52',3310490832,1),(52613062,424858759,14529988,443749,1,'2007-09-16 15:23:52',3310490832,1),(52613065,424859218,14528415,443749,1,'2007-09-16 15:23:52',3310490832,1),(52613067,424859349,14525727,443749,1,'2007-09-16 15:23:53',3310490832,1),(52613070,424859545,14523564,443749,1,'2007-09-16 15:23:53',3310490832,1),(52613072,424860725,14522384,443749,1,'2007-09-16 15:23:53',3310490832,1);
INSERT INTO `current_nodes` VALUES (52613074,424861971,14521663,443749,1,'2007-09-16 15:23:53',3310490832,1),(52613076,424862973,14520921,443749,1,'2007-09-16 15:23:53',3310490832,1),(52613080,424856869,14531058,443749,1,'2007-09-16 15:23:54',3310490832,1),(52613083,424863791,14519788,443749,1,'2007-09-16 15:23:54',3310490832,1),(52613086,424864546,14518655,443749,1,'2007-09-16 15:23:54',3310490832,1),(52613088,424864986,14517271,443749,1,'2007-09-16 15:23:54',3310490832,1),(52613091,424865175,14515697,443749,1,'2007-09-16 15:23:55',3310490832,1),(52613092,424865553,14513432,443749,1,'2007-09-16 15:23:55',3310490832,1),(52613094,424865993,14511040,443749,1,'2007-09-16 15:23:55',3310490832,1),(52613097,424866748,14508586,443749,1,'2007-09-16 15:23:55',3310490832,1),(52613099,424867252,14506761,443749,1,'2007-09-16 15:23:55',3310490832,1),(52613101,424867944,14504873,443749,1,'2007-09-16 15:23:55',3310490832,1),(52613104,424868573,14504244,443749,1,'2007-09-16 15:23:56',3310490832,1),(52613107,424869203,14504181,443749,1,'2007-09-16 15:23:56',3310490832,1),(52613110,424869580,14504621,443749,1,'2007-09-16 15:23:57',3310490832,1),(52613113,424869832,14505062,443749,1,'2007-09-16 15:23:57',3310490832,1),(52613115,424869895,14505377,443749,1,'2007-09-16 15:23:57',3310490832,1),(52613117,424869958,14506635,443749,1,'2007-09-16 15:23:57',3310490832,1),(52613119,424870084,14510096,443749,1,'2007-09-16 15:23:57',3310490832,1),(52613121,424870336,14512865,443749,1,'2007-09-16 15:23:58',3310490832,1),(52613124,424871028,14515068,443749,1,'2007-09-16 15:23:58',3310490832,1),(52613126,424871846,14516767,443749,1,'2007-09-16 15:23:58',3310490832,1),(52613129,424872853,14517648,443749,1,'2007-09-16 15:23:58',3310490832,1),(52613132,424874111,14518341,443749,1,'2007-09-16 15:23:58',3310490832,1),(52613135,424875433,14518844,443749,1,'2007-09-16 15:23:58',3310490833,1),(52613139,424876481,14519245,443749,1,'2007-09-16 15:23:58',3310490833,1),(52613142,424877447,14519309,443749,1,'2007-09-16 15:23:59',3310490833,1),(52613145,424878285,14519245,443749,1,'2007-09-16 15:23:59',3310490833,1),(52613148,424879316,14519148,443749,1,'2007-09-16 15:23:59',3310490833,1),(52613149,424880412,14518826,443749,1,'2007-09-16 15:24:00',3310490833,1),(52613151,424881346,14518020,443749,1,'2007-09-16 15:24:00',3310490833,1),(52613154,424882603,14516216,443749,1,'2007-09-16 15:24:00',3310490833,1),(52613157,424883827,14514798,443749,1,'2007-09-16 15:24:00',3310490833,1),(52613159,424885438,14513703,443749,1,'2007-09-16 15:24:01',3310490833,1),(52613162,424888467,14511351,443749,1,'2007-09-16 15:24:02',3310490833,1),(52613163,424890110,14510094,443749,1,'2007-09-16 15:24:02',3310490833,1),(52613166,424891141,14509095,443749,1,'2007-09-16 15:24:03',3310490833,1),(52613167,424891496,14508257,443749,1,'2007-09-16 15:24:04',3310490833,1),(52613170,424892044,14506034,443749,1,'2007-09-16 15:24:04',3310490833,1),(52613172,424892817,14503875,443749,1,'2007-09-16 15:24:05',3310490833,1),(52613173,424893203,14502103,443749,1,'2007-09-16 15:24:05',3310490747,1),(52613175,424893493,14499429,443749,1,'2007-09-16 15:24:06',3310490747,1),(52613176,424894073,14497238,443749,1,'2007-09-16 15:24:07',3310490747,1),(52613178,424894686,14495756,443749,1,'2007-09-16 15:24:07',3310490747,1),(52613179,424895781,14494499,443749,1,'2007-09-16 15:24:07',3310490747,1),(52613182,424897231,14493371,443749,1,'2007-09-16 15:24:08',3310490747,1),(52613184,424899261,14492276,443749,1,'2007-09-16 15:24:09',3310490747,1),(52613186,424901006,14491587,443749,1,'2007-09-16 15:24:09',3310490747,1),(52613189,424902954,14490399,443749,1,'2007-09-16 15:24:10',3310490750,1),(52613192,424904550,14489485,443749,1,'2007-09-16 15:24:10',3310490750,1),(52613196,424905599,14487588,443749,1,'2007-09-16 15:24:11',3310490750,1),(52613199,424906769,14484925,443749,1,'2007-09-16 15:24:11',3310490750,1),(52613201,424907778,14481696,443749,1,'2007-09-16 15:24:11',3310490750,1),(52613204,424908545,14478145,443749,1,'2007-09-16 15:24:11',3310490750,1),(52613212,424911128,14467936,443749,1,'2007-09-16 15:24:12',3310490750,1),(52613214,424912217,14464384,443749,1,'2007-09-16 15:24:12',3310490750,1),(52613217,424912540,14462811,443749,1,'2007-09-16 15:24:13',3310490750,1),(52613221,424913145,14461075,443749,1,'2007-09-16 15:24:13',3310490750,1),(52613223,424914114,14459582,443749,1,'2007-09-16 15:24:13',3310490750,1),(52613224,424915082,14458251,443749,1,'2007-09-16 15:24:14',3310490750,1),(52613226,424916374,14457040,443749,1,'2007-09-16 15:24:14',3310490750,1),(52613228,424917786,14455910,443749,1,'2007-09-16 15:24:14',3310490750,1),(52613231,424919562,14455224,443749,1,'2007-09-16 15:24:14',3310490750,1),(52613233,424921499,14454175,443749,1,'2007-09-16 15:24:14',3310490750,1),(52613235,424923315,14452843,443749,1,'2007-09-16 15:24:14',3310490750,1),(52613237,424924687,14451713,443749,1,'2007-09-16 15:24:14',3310490750,1),(52613238,424926382,14450825,443749,1,'2007-09-16 15:24:15',3310490750,1),(52613244,424930054,14449090,443749,1,'2007-09-16 15:24:15',3310490750,1),(52613246,424931587,14447960,443749,1,'2007-09-16 15:24:16',3310490751,1),(52613249,424933080,14446669,443749,1,'2007-09-16 15:24:16',3310490749,1),(52613252,424934412,14445539,443749,1,'2007-09-16 15:24:16',3310490749,1),(52613256,424935530,14444501,443749,1,'2007-09-16 15:24:16',3310490749,1),(52613258,424937099,14443566,443749,1,'2007-09-16 15:24:16',3310490749,1),(52613260,424938635,14443032,443749,1,'2007-09-16 15:24:17',3310490749,1),(52613262,424941573,14442197,443749,1,'2007-09-16 15:24:17',3310490749,1),(52613264,424943542,14441362,443749,1,'2007-09-16 15:24:17',3310490749,1),(52613267,424945980,14439893,443749,1,'2007-09-16 15:24:17',3310490749,1),(52613270,424949151,14438091,443749,1,'2007-09-16 15:24:17',3310490749,1),(52613272,424951455,14436922,443749,1,'2007-09-16 15:24:18',3310490749,1),(52613274,424953225,14436321,443749,1,'2007-09-16 15:24:18',3310490749,1),(52613277,424954760,14436087,443749,1,'2007-09-16 15:24:18',3310490749,1),(52613279,424956563,14435319,443749,1,'2007-09-16 15:24:18',3310490749,1),(52613282,424957780,14434445,443749,1,'2007-09-16 15:24:18',3310490920,1),(52613285,424958545,14433680,443749,1,'2007-09-16 15:24:19',3310490920,1),(52613288,424959437,14433043,443749,1,'2007-09-16 15:24:19',3310490920,1),(52613289,424960266,14432437,443749,1,'2007-09-16 15:24:20',3310490920,1),(52613292,424960999,14432405,443749,1,'2007-09-16 15:24:20',3310490920,1),(52613295,424961414,14432724,443749,1,'2007-09-16 15:24:20',3310490920,1),(52613297,424961924,14433425,443749,1,'2007-09-16 15:24:20',3310490920,1),(52613300,424963039,14435338,443749,1,'2007-09-16 15:24:20',3310490920,1),(52613301,424963932,14436645,443749,1,'2007-09-16 15:24:21',3310490920,1),(52613303,424965494,14438270,443749,1,'2007-09-16 15:24:21',3310490920,1),(52613304,424967311,14439545,443749,1,'2007-09-16 15:24:21',3310490920,1),(52613306,424968490,14440183,443749,1,'2007-09-16 15:24:21',3310490920,1),(52613309,424969893,14440374,443749,1,'2007-09-16 15:24:22',3310490920,1),(52613310,424971550,14440247,443749,1,'2007-09-16 15:24:22',3310490920,1),(52613312,424972889,14440119,443749,1,'2007-09-16 15:24:22',3310490920,1),(52613314,424974100,14439705,443749,1,'2007-09-16 15:24:23',3310490920,1),(52613317,424975975,14438758,443749,1,'2007-09-16 15:24:23',3310490920,1),(52613318,424976760,14438062,443749,1,'2007-09-16 15:24:23',3310490920,1),(52613320,424977983,14436233,443749,1,'2007-09-16 15:24:23',3310490920,1),(52613323,424978952,14434970,443749,1,'2007-09-16 15:24:23',3310490920,1),(52613325,424979922,14433619,443749,1,'2007-09-16 15:24:23',3310490920,1),(52613330,424980950,14432943,443749,1,'2007-09-16 15:24:24',3310490920,1),(52613332,424982008,14432855,443749,1,'2007-09-16 15:24:24',3310490920,1),(52623167,424979678,14430785,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623169,424978530,14431875,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623170,424976923,14433883,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623173,424975604,14436293,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623176,424973940,14437383,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623178,424972792,14437612,443749,1,'2007-09-16 15:48:29',3310490920,1),(52623180,424971128,14438129,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623182,424969292,14438416,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623185,424968202,14438129,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623187,424966653,14437612,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623190,424965161,14436121,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623193,424964128,14434055,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623196,424963268,14432391,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623199,424963268,14429924,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623201,424962579,14428317,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623203,424961948,14427858,443749,1,'2007-09-16 15:48:31',3310490920,1),(52623205,424960801,14428145,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623207,424959653,14429121,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623209,424957014,14430670,508959,1,'2007-09-24 18:39:59',3310490749,1),(52623212,424953456,14433194,508959,1,'2007-09-24 18:39:59',3310490749,1),(52623215,424951391,14434514,508959,1,'2007-09-24 18:39:59',3310490749,1),(52623218,424949211,14435030,508959,1,'2007-09-24 18:39:59',3310490749,1),(52623226,424946514,14436121,508959,1,'2007-09-24 18:39:59',3310490749,1),(52623229,424943186,14438358,508959,1,'2007-09-24 18:39:59',3310490749,1),(52623231,424940776,14439678,508959,1,'2007-09-24 18:39:59',3310490749,1),(52623233,424937678,14440940,508959,1,'2007-09-24 18:39:59',3310490749,1),(52623236,424934752,14442260,443749,1,'2007-09-16 15:48:34',3310490749,1),(52623240,424932916,14443350,443749,1,'2007-09-16 15:48:34',3310490749,1),(52623242,424930965,14445817,508959,1,'2007-09-24 18:39:59',3310490749,1),(52623245,424929243,14447252,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623247,424927120,14448629,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623250,424925342,14449432,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623252,424919088,14452186,443749,1,'2007-09-16 15:48:35',3310490750,1),(52623255,424917080,14452989,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623259,424915301,14454137,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623261,424914440,14455571,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623265,424913809,14457350,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623268,424913121,14458957,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623273,424912260,14460276,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623276,424910883,14461424,443749,1,'2007-09-16 15:48:37',3310490750,1),(52623278,424909907,14462801,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623282,424908817,14466186,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623285,424907899,14470145,443749,1,'2007-09-16 15:48:37',3310490750,1),(52623287,424907096,14472497,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623290,424906350,14476571,443749,1,'2007-09-16 15:48:38',3310490750,1),(52623294,424905145,14479096,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623296,424904514,14482424,443749,1,'2007-09-16 15:48:38',3310490750,1),(52623299,424904744,14484719,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623301,424904744,14486153,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623303,424904112,14487530,443749,1,'2007-09-16 15:48:39',3310490750,1),(52623305,424903194,14488792,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623308,424901358,14489137,508959,1,'2007-09-24 18:39:59',3310490747,1),(52623310,424899694,14489710,443749,1,'2007-09-16 15:48:39',3310490747,1),(52623315,424897686,14490169,508959,1,'2007-09-24 18:39:59',3310490747,1),(52623317,424896137,14491661,508959,1,'2007-09-24 18:39:59',3310490747,1),(52623321,424894014,14493210,508959,1,'2007-09-24 18:39:59',3310490747,1),(52623324,424892522,14495792,508959,1,'2007-09-24 18:39:59',3310490747,1),(52623329,424891662,14499637,508959,1,'2007-09-24 18:39:59',3310490747,1),(52623333,424890916,14503710,508959,1,'2007-09-24 18:39:59',3310490833,1),(52623334,424890113,14508587,443749,1,'2007-09-16 15:48:41',3310490833,1),(52623339,424889596,14511686,508959,1,'2007-09-24 18:39:59',3310490833,1),(52623344,424888219,14513866,508959,1,'2007-09-24 18:39:59',3310490833,1),(52623348,424886842,14515645,508959,1,'2007-09-24 18:39:59',3310490833,1),(52623351,424885293,14516505,508959,1,'2007-09-24 18:39:59',3310490833,1),(52623354,424883858,14516907,508959,1,'2007-09-24 18:39:59',3310490833,1),(52623358,424878809,14516792,443749,1,'2007-09-16 15:48:43',3310490833,1),(52623360,424876055,14516964,508959,1,'2007-09-24 18:39:59',3310490833,1),(52623363,424874277,14516333,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623364,424872498,14514784,443749,1,'2007-09-16 15:48:43',3310490832,1),(52623367,424871580,14512833,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623371,424871465,14509792,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623373,424871408,14505202,443749,1,'2007-09-16 15:48:44',3310490832,1),(52623375,424871236,14502792,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623378,424870318,14501358,508959,1,'2007-09-24 18:39:59',3310490746,1),(52623383,424869457,14500841,508959,1,'2007-09-24 18:39:59',3310490746,1),(52623385,424868023,14501473,443749,1,'2007-09-16 15:48:45',3310490746,1),(52623389,424866990,14503079,443749,1,'2007-09-16 15:48:45',3310490832,1),(52623392,424866014,14507669,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623394,424864580,14512317,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623398,424864064,14514956,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623402,424863432,14517710,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623403,424862916,14519317,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623407,424861539,14520292,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623413,424860219,14521153,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623416,424859416,14522186,443749,1,'2007-09-16 15:48:47',3310490832,1),(52623417,424859072,14522932,443749,1,'2007-09-16 15:48:47',3310490832,1),(52623420,424858670,14524653,443749,1,'2007-09-16 15:48:47',3310490832,1),(52623424,424858670,14526259,443749,1,'2007-09-16 15:48:47',3310490832,1),(52623427,424858498,14527751,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623431,424858039,14529013,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623434,424857523,14529415,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623436,424856719,14529415,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623438,424855744,14528669,443749,1,'2007-09-16 15:48:48',3310490832,1),(52623441,424854769,14527579,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623444,424852129,14525112,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623446,424850810,14523505,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623449,424849260,14523104,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623453,424847769,14523907,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623457,424847023,14524538,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623463,424846277,14527866,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623465,424845760,14531079,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623471,424846047,14534522,443749,1,'2007-09-16 15:48:51',3310490821,1),(52623475,424845990,14537218,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623478,424845531,14538595,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623482,424844383,14539915,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623485,424843293,14540661,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623487,424841974,14540489,443749,1,'2007-09-16 15:48:52',3310490821,1),(52623489,424840367,14538882,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623492,424838818,14536759,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623494,424837556,14535899,443749,1,'2007-09-16 15:48:53',3310490821,1),(52623497,424836121,14535899,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623500,424834744,14537448,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623503,424833310,14539685,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623506,424832678,14542440,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623509,424833482,14544333,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623513,424835547,14546685,443749,1,'2007-09-16 15:48:55',3310490821,1),(52623516,424837211,14548292,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623517,424838474,14552653,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623522,424839047,14556153,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623526,424840367,14561776,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623530,424840998,14567513,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623533,424840941,14571243,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623535,424840883,14574628,443749,1,'2007-09-16 15:48:56',3310490823,1),(52623538,424840195,14577038,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623541,424839564,14579218,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623543,424838646,14580767,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623545,424837211,14582202,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623548,424835949,14583120,443749,1,'2007-09-16 15:48:58',3310490823,1),(52623550,424834113,14583636,443749,1,'2007-09-16 15:48:58',3310490823,1),(52623553,424832506,14584152,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623556,424830039,14583407,443749,1,'2007-09-16 15:48:58',3310490823,1),(52623559,424828031,14583005,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623562,424826367,14583636,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623565,424823670,14584439,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623567,424821777,14585587,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623570,424819769,14585874,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623573,424817416,14586275,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623576,424815179,14585816,443749,1,'2007-09-16 15:49:00',3310490822,1),(52623578,424813802,14585243,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623581,424811966,14585931,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623584,424810875,14587251,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623587,424809020,14589681,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623589,424807829,14593253,443749,1,'2007-09-16 15:49:01',3310490822,1),(52623590,424806695,14598355,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623593,424806128,14601644,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623597,424805504,14604252,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623599,424804710,14606520,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623602,424803747,14607484,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623605,424802102,14608108,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623610,424799721,14607994,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623613,424797340,14608221,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623617,424796546,14609128,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623618,424796092,14611396,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623621,424795752,14614458,443749,1,'2007-09-16 15:49:03',3310490828,1),(52623624,424795299,14615818,443749,1,'2007-09-16 15:49:03',3310490828,1),(52623627,424794448,14616896,443749,1,'2007-09-16 15:49:03',3310490828,1),(52623630,424793201,14616385,508959,1,'2007-09-24 18:39:59',3310490828,1),(52623633,424792067,14614514,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623636,424791046,14613777,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623638,424790196,14614855,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623641,424789629,14616385,443749,1,'2007-09-16 15:49:04',3310490825,1),(52623644,424789005,14618313,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623647,424788665,14619844,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623649,424787531,14620978,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623653,424784696,14621375,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623655,424783980,14622336,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623657,424783079,14624137,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623660,424781939,14627078,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623664,424781398,14629899,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623667,424781638,14633261,443749,1,'2007-09-16 15:49:06',3310490825,1),(52623670,424782059,14635122,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623674,424783379,14636143,443749,1,'2007-09-16 15:49:08',3310490825,1),(52623675,424785360,14637103,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623679,424788218,14639108,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623684,424789995,14639924,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623687,424791195,14640165,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623690,424793308,14640549,508959,1,'2007-09-24 18:39:59',3310490828,1),(52623692,424794125,14640885,508959,1,'2007-09-24 18:39:59',3310490828,1),(52623694,424794989,14642086,508959,1,'2007-09-24 18:39:59',3310490828,1),(52623698,424794989,14642806,508959,1,'2007-09-24 18:39:59',3310490828,1),(52623701,424794845,14644679,508959,1,'2007-09-24 18:39:59',3310490828,1),(52623702,424793981,14645927,508959,1,'2007-09-24 18:39:59',3310490828,1),(52623705,424793116,14646696,508959,1,'2007-09-24 18:39:59',3310490828,1),(52623707,424792444,14648089,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623712,424792300,14649337,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623713,424792108,14650634,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623715,424791243,14651402,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623717,424790043,14651834,443749,1,'2007-09-16 15:49:13',3310490825,1),(52623719,424788890,14652363,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623720,424786921,14653659,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623722,424785144,14654524,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623725,424782791,14655820,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623726,424780342,14658366,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623728,424779525,14660047,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623730,424778901,14661583,443749,1,'2007-09-16 15:49:14',3310490825,1),(52623732,424779237,14663840,443749,1,'2007-09-16 15:49:14',3310490825,1),(52623733,424780150,14665377,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623736,424782647,14667250,443749,1,'2007-09-16 15:49:15',3310490827,1),(52623739,424785961,14668979,443749,1,'2007-09-16 15:49:15',3310490827,1),(52623741,424788362,14670132,443749,1,'2007-09-16 15:49:15',3310490827,1),(52623743,424788986,14671284,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623746,424789178,14673733,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623749,424788890,14675174,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623750,424788218,14676567,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623752,424786201,14678296,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623753,424783944,14679352,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623755,424781446,14681273,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623757,424778565,14683434,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623758,424778277,14683818,443749,1,'2007-09-16 15:49:18',3310490827,1),(52623759,424776164,14685643,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623760,424774819,14686988,443749,1,'2007-09-16 15:49:18',3310490827,1),(52623762,424774099,14689341,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623763,424774099,14690542,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623765,424774771,14692751,443749,1,'2007-09-16 15:49:19',3310490827,1),(52623767,424775011,14695104,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623768,424774867,14697505,443749,1,'2007-09-16 15:49:19',3310490827,1),(52623769,424774051,14700003,443749,1,'2007-09-16 15:49:19',3310490827,1),(52623771,424773234,14702692,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623772,424773138,14705333,443749,1,'2007-09-16 15:49:20',3310490827,1),(52623773,424773330,14707398,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623776,424774195,14709607,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623777,424774387,14711865,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623778,424774291,14713785,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623779,424773762,14716235,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623780,424773138,14717916,443749,1,'2007-09-16 15:49:22',3310490827,1),(52623781,424771697,14720125,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623782,424770929,14723102,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623783,424769200,14726224,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623784,424767567,14729105,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623785,424766559,14731026,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623786,424766463,14733043,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623788,424766607,14735781,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623791,424767039,14737990,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623792,424768576,14740343,443749,1,'2007-09-16 15:49:24',3310490849,1),(52623795,424769296,14742024,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623798,424769728,14743849,443749,1,'2007-09-16 15:49:25',3310490849,1),(52623800,424769632,14745529,443749,1,'2007-09-16 15:49:25',3310490849,1),(52623802,424769536,14747354,443749,1,'2007-09-16 15:49:26',3310490849,1),(52623805,424769584,14750476,443749,1,'2007-09-16 15:49:26',3310490849,1),(52623806,424769392,14754174,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623808,424769104,14755855,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623809,424767855,14758784,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623811,424766895,14762770,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623814,424766703,14765940,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623816,424767567,14768725,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623819,424768480,14772231,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623823,424769728,14776121,443749,1,'2007-09-16 15:49:28',3310490849,1),(52623844,424771505,14779482,508959,1,'2007-09-24 18:39:59',3310490851,1),(52623846,424772994,14782604,443749,1,'2007-09-16 15:49:34',3310490851,1),(52623849,424773862,14785752,508959,1,'2007-09-24 18:39:59',3310490851,1),(52635897,424774052,14787812,508959,1,'2007-09-24 18:39:59',3310490851,1),(52635898,424774052,14791331,508959,1,'2007-09-24 18:39:59',3310490851,1),(52635899,424773988,14794421,443749,1,'2007-09-16 16:30:36',3310490851,1),(52635900,424773545,14797769,508959,1,'2007-09-24 18:39:59',3310490851,1),(52635902,424772596,14800000,508959,1,'2007-09-24 18:39:59',3310490851,1),(52635903,424771519,14801288,508959,1,'2007-09-24 18:39:59',3310490851,1),(52635904,424769874,14802060,508959,1,'2007-09-24 18:39:59',3310490851,1),(52635905,424767974,14802060,443749,1,'2007-09-16 16:30:36',3310490851,1),(52635907,424765759,14802403,508959,1,'2007-09-24 18:39:59',3310490851,1),(52635909,424763923,14803433,508959,1,'2007-09-24 18:39:59',3310490850,1),(52635910,424761011,14805923,443749,1,'2007-09-16 16:30:36',3310490850,1),(52635912,424757782,14807296,443749,1,'2007-09-16 16:30:36',3310490850,1),(52635914,424756326,14808927,443749,1,'2007-09-16 16:30:36',3310490850,1),(52635916,424755250,14812703,508959,1,'2007-09-24 18:39:59',3310490850,1),(52635917,424754617,14818368,508959,1,'2007-09-24 18:39:59',3310490850,1),(52636119,424754047,14822145,508959,1,'2007-09-24 18:39:59',3310490850,1),(52636120,424753224,14826865,508959,1,'2007-09-24 18:39:59',3310490850,1),(52636122,424751515,14835105,443749,1,'2007-09-16 16:30:36',3310490856,1),(52636124,424750629,14842229,443749,1,'2007-09-16 16:30:36',3310490856,1),(52636127,424749616,14849353,508959,1,'2007-09-24 18:39:59',3310490856,1),(52636128,424749173,14854417,443749,1,'2007-09-16 16:30:36',3310490856,1),(52636131,424749553,14856133,443749,1,'2007-09-16 16:30:36',3310490856,1),(52636132,424750439,14858623,443749,1,'2007-09-16 16:30:36',3310490856,1),(52636133,424751578,14860768,443749,1,'2007-09-16 16:30:36',3310490856,1),(52636134,424753414,14863000,443749,1,'2007-09-16 16:30:36',3310490856,1),(52636135,424755313,14865317,508959,1,'2007-09-24 18:39:59',3310490856,1),(52636136,424756263,14866948,443749,1,'2007-09-16 16:30:36',3310490856,1),(52636137,424756580,14870124,508959,1,'2007-09-24 18:39:59',3310490856,1),(52636139,424756516,14874673,508959,1,'2007-09-24 18:39:59',3310490856,1),(52636140,424756643,14878449,508959,1,'2007-09-24 18:39:59',3310490856,1),(52636141,424757149,14880166,508959,1,'2007-09-24 18:39:59',3310490856,1),(52636142,424758542,14884286,508959,1,'2007-09-24 18:39:59',3310490856,1),(52648095,424759673,14889812,508959,1,'2007-09-24 18:39:59',3310490858,1),(52648138,424760829,14895162,508959,1,'2007-09-24 18:39:59',3310490858,1),(52648149,424761770,14901495,443749,1,'2007-09-16 17:19:04',3310490858,1),(52648164,424762152,14903063,508959,1,'2007-09-24 18:39:59',3310490858,1),(52650131,424837924,14576772,443749,1,'2007-09-16 21:50:23',3310490823,1),(52650158,424836815,14579343,370566,1,'2008-05-09 02:14:21',3310490823,3),(52650659,424836210,14581006,370566,1,'2008-05-09 02:14:21',3310490823,4),(52652127,424836008,14582417,370566,1,'2008-05-09 02:14:21',3310490823,3),(52652273,424836464,14583834,370566,1,'2008-05-09 02:14:21',3310490823,3),(52652319,424834040,14579491,443749,1,'2007-09-16 17:35:49',3310490823,1),(52652351,424838051,14575645,443749,1,'2007-09-16 17:36:05',3310490823,1),(52652477,424838372,14575229,443749,1,'2007-09-16 17:36:39',3310490823,1),(52652555,424838780,14572364,443749,1,'2007-09-16 17:37:01',3310490823,1),(52661498,424838964,14570412,443749,1,'2007-09-16 18:14:44',3310490823,1),(52672004,424839093,14568056,443749,1,'2007-09-16 18:55:22',3310490823,1),(52672499,424838909,14565699,443749,1,'2007-09-16 18:57:11',3310490823,1),(52675912,424838651,14562108,443749,1,'2007-09-16 19:11:19',3310490823,1),(52676235,424838197,14559763,443749,1,'2007-09-16 19:12:14',3310490823,1),(52676253,424837281,14555066,443749,1,'2007-09-16 19:12:16',3310490821,1),(52676260,424836212,14552202,443749,1,'2007-09-16 19:12:16',3310490821,1),(52676267,424835830,14551439,443749,1,'2007-09-16 19:12:17',3310490821,1),(52676295,424835295,14551630,443749,1,'2007-09-16 19:12:20',3310490821,1),(52676338,424835257,14552241,443749,1,'2007-09-16 19:12:32',3310490821,1),(52676349,424835601,14553272,443749,1,'2007-09-16 19:12:33',3310490821,1),(52676434,424836403,14555448,443749,1,'2007-09-16 19:12:51',3310490821,1),(52676891,424836479,14557815,443749,1,'2007-09-16 19:14:23',3310490823,1),(52676911,424835792,14559763,443749,1,'2007-09-16 19:14:27',3310490823,1),(52677089,424835410,14562168,443749,1,'2007-09-16 19:14:58',3310490823,1),(52677154,424835448,14564993,443749,1,'2007-09-16 19:15:10',3310490823,1),(52677211,424835410,14566826,443749,1,'2007-09-16 19:15:18',3310490823,1),(52677635,424835104,14568621,443749,1,'2007-09-16 19:16:26',3310490823,1),(52677662,424834455,14569766,443749,1,'2007-09-16 19:16:33',3310490823,1),(52677757,424833577,14570874,443749,1,'2007-09-16 19:16:49',3310490823,1),(52677811,424832546,14571866,443749,1,'2007-09-16 19:17:02',3310490823,1),(52677844,424831324,14572248,443749,1,'2007-09-16 19:17:09',3310490823,1),(52677862,424830217,14572172,443749,1,'2007-09-16 19:17:14',3310490823,1),(52677872,424829568,14571675,443749,1,'2007-09-16 19:17:18',3310490823,1),(52677878,424829453,14571179,443749,1,'2007-09-16 19:17:19',3310490823,1),(52677908,424829644,14570148,443749,1,'2007-09-16 19:17:24',3310490823,1),(52677912,424830064,14568697,443749,1,'2007-09-16 19:17:25',3310490823,1),(52677918,424831210,14566712,443749,1,'2007-09-16 19:17:26',3310490823,1),(52677922,424832088,14565223,443749,1,'2007-09-16 19:17:26',3310490823,1),(52677929,424832661,14562741,443749,1,'2007-09-16 19:17:28',3310490823,1),(52677934,424832928,14560870,443749,1,'2007-09-16 19:17:29',3310490823,1),(52677939,424832965,14559190,443749,1,'2007-09-16 19:17:30',3310490823,1),(52677945,424832553,14557413,443749,1,'2007-09-16 19:17:32',3310490823,1),(52677993,424831950,14555351,443749,1,'2007-09-16 19:17:45',3310490821,1),(52678005,424830744,14553383,443749,1,'2007-09-16 19:17:47',3310490821,1),(52678200,424830173,14552241,443749,1,'2007-09-16 19:18:20',3310490821,1),(52678225,424829379,14552495,443749,1,'2007-09-16 19:18:25',3310490821,1),(52678243,424829506,14553447,443749,1,'2007-09-16 19:18:27',3310490821,1),(52678266,424829697,14554177,443749,1,'2007-09-16 19:18:31',3310490821,1),(52678278,424830617,14556556,443749,1,'2007-09-16 19:18:32',3310490821,1),(52678285,424830680,14558397,443749,1,'2007-09-16 19:18:32',3310490823,1),(52678294,424830458,14559952,443749,1,'2007-09-16 19:18:34',3310490823,1),(52678450,424829792,14561253,443749,1,'2007-09-16 19:19:08',3310490823,1),(52678519,424828681,14562141,443749,1,'2007-09-16 19:19:18',3310490823,1),(52678582,424827158,14562776,443749,1,'2007-09-16 19:19:27',3310490823,1),(52678634,424825984,14563125,443749,1,'2007-09-16 19:19:36',3310490823,1),(52678741,424824556,14563664,443749,1,'2007-09-16 19:19:53',3310490823,1),(52678786,424823033,14564299,443749,1,'2007-09-16 19:19:59',3310490823,1),(52678860,424821605,14564997,443749,1,'2007-09-16 19:20:12',3310490823,1),(52679237,424820431,14566171,443749,1,'2007-09-16 19:21:29',3310490823,1),(52679255,424819035,14567313,443749,1,'2007-09-16 19:21:32',3310490822,1),(52679261,424818052,14568011,443749,1,'2007-09-16 19:21:32',3310490822,1),(52679265,424817480,14568455,443749,1,'2007-09-16 19:21:33',3310490822,1),(52679271,424816846,14568455,443749,1,'2007-09-16 19:21:34',3310490822,1),(52679365,424816433,14568392,443749,1,'2007-09-16 19:21:44',3310490822,1),(52679445,424816148,14567916,443749,1,'2007-09-16 19:21:57',3310490822,1),(52679499,424816148,14567377,443749,1,'2007-09-16 19:22:04',3310490822,1),(52679531,424816243,14566805,443749,1,'2007-09-16 19:22:07',3310490822,1),(52679731,424816687,14565568,443749,1,'2007-09-16 19:22:24',3310490822,1),(52679744,424817353,14564077,443749,1,'2007-09-16 19:22:25',3310490822,1),(52679804,424818147,14562522,443749,1,'2007-09-16 19:22:29',3310490822,1),(52679809,424820146,14560777,443749,1,'2007-09-16 19:22:30',3310490822,1),(52679815,424822303,14559190,443749,1,'2007-09-16 19:22:31',3310490823,1),(52679821,424823097,14558238,443749,1,'2007-09-16 19:22:32',3310490823,1),(52679879,424823890,14557096,443749,1,'2007-09-16 19:22:42',3310490821,1),(52679882,424824334,14555573,443749,1,'2007-09-16 19:22:42',3310490821,1),(52679888,424824303,14554970,443749,1,'2007-09-16 19:22:43',3310490821,1),(52679894,424823858,14554081,443749,1,'2007-09-16 19:22:44',3310490821,1),(52679900,424823287,14554081,443749,1,'2007-09-16 19:22:44',3310490821,1),(52679906,424822906,14554303,443749,1,'2007-09-16 19:22:45',3310490821,1),(52679911,424822367,14555065,443749,1,'2007-09-16 19:22:45',3310490821,1),(52679979,424821605,14555953,443749,1,'2007-09-16 19:22:52',3310490821,1),(52679994,424820876,14556525,443749,1,'2007-09-16 19:22:53',3310490821,1),(52680005,424819575,14557096,443749,1,'2007-09-16 19:22:55',3310490820,1),(52680012,424817766,14557477,443749,1,'2007-09-16 19:22:55',3310490822,1),(52680017,424815418,14557984,443749,1,'2007-09-16 19:22:56',3310490822,1),(52680024,424813704,14558651,443749,1,'2007-09-16 19:22:56',3310490822,1),(52680029,424811610,14560015,443749,1,'2007-09-16 19:22:57',3310490822,1),(52680039,424810531,14561538,443749,1,'2007-09-16 19:22:57',3310490822,1),(52680048,424809421,14562871,443749,1,'2007-09-16 19:22:58',3310490822,1),(52680059,424808786,14563188,443749,1,'2007-09-16 19:22:58',3310490822,1),(52680077,424808596,14563156,443749,1,'2007-09-16 19:22:59',3310490822,1),(52680086,424808215,14562744,443749,1,'2007-09-16 19:23:00',3310490822,1),(52680095,424808056,14561982,443749,1,'2007-09-16 19:23:01',3310490822,1),(52680105,424808215,14561602,443749,1,'2007-09-16 19:23:01',3310490822,1),(52680117,424808596,14561030,443749,1,'2007-09-16 19:23:02',3310490822,1),(52680128,424809865,14559349,443749,1,'2007-09-16 19:23:02',3310490822,1),(52680141,424811261,14557508,443749,1,'2007-09-16 19:23:03',3310490822,1),(52680157,424813387,14555890,443749,1,'2007-09-16 19:23:04',3310490820,1),(52680171,424815101,14554303,443749,1,'2007-09-16 19:23:05',3310490820,1),(52680195,424815767,14552876,443749,1,'2007-09-16 19:23:07',3310490820,1),(52680202,424815799,14551955,443749,1,'2007-09-16 19:23:08',3310490820,1),(52680255,424815799,14550210,443749,1,'2007-09-16 19:23:12',3310490820,1),(52680269,424815481,14548179,443749,1,'2007-09-16 19:23:12',3310490820,1),(52680280,424815409,14547101,443749,1,'2007-09-16 19:23:13',3310490820,1),(52680289,424815305,14546093,443749,1,'2007-09-16 19:23:13',3310490820,1),(52680402,424815757,14544771,443749,1,'2007-09-16 19:23:21',3310490820,1),(52680426,424817287,14541746,443749,1,'2007-09-16 19:23:22',3310490820,1),(52680437,424817982,14540773,443749,1,'2007-09-16 19:23:23',3310490820,1),(52680448,424818121,14540181,443749,1,'2007-09-16 19:23:24',3310490820,1),(52680465,424817669,14539521,443749,1,'2007-09-16 19:23:25',3310490820,1),(52680561,424817113,14539590,443749,1,'2007-09-16 19:23:29',3310490820,1),(52680566,424816487,14540147,443749,1,'2007-09-16 19:23:29',3310490820,1),(52680570,424815340,14540773,443749,1,'2007-09-16 19:23:30',3310490820,1),(52680574,424813879,14541607,443749,1,'2007-09-16 19:23:30',3310490820,1),(52680577,424813079,14542268,443749,1,'2007-09-16 19:23:30',3310490820,1),(52680579,424812384,14543902,443749,1,'2007-09-16 19:23:30',3310490820,1),(52680583,424812175,14545015,443749,1,'2007-09-16 19:23:31',3310490820,1),(52680592,424811967,14547414,443749,1,'2007-09-16 19:23:31',3310490820,1),(52680597,424811549,14549118,443749,1,'2007-09-16 19:23:31',3310490820,1),(52680599,424811028,14550231,443749,1,'2007-09-16 19:23:32',3310490820,1),(52680606,424810471,14550926,443749,1,'2007-09-16 19:23:32',3310490820,1),(52680610,424809637,14551830,443749,1,'2007-09-16 19:23:33',3310490820,1),(52680616,424807690,14552213,443749,1,'2007-09-16 19:23:33',3310490820,1),(52680618,424806473,14552248,443749,1,'2007-09-16 19:23:34',3310490820,1),(52680624,424804247,14552074,443749,1,'2007-09-16 19:23:34',3310490820,1),(52680637,424802682,14551865,443749,1,'2007-09-16 19:23:36',3310490820,1),(52680643,424802056,14551483,443749,1,'2007-09-16 19:23:37',3310490820,1),(52680648,424801917,14550961,443749,1,'2007-09-16 19:23:37',3310490820,1),(52680653,424802335,14550509,443749,1,'2007-09-16 19:23:39',3310490820,1),(52680657,424803100,14550126,443749,1,'2007-09-16 19:23:40',3310490820,1),(52680660,424803969,14550266,443749,1,'2007-09-16 19:23:41',3310490820,1),(52680663,424804873,14550544,443749,1,'2007-09-16 19:23:42',3310490820,1),(52680674,424805673,14550370,443749,1,'2007-09-16 19:23:43',3310490820,1),(52680676,424806299,14549501,443749,1,'2007-09-16 19:23:44',3310490820,1),(52680679,424806751,14548527,443749,1,'2007-09-16 19:23:44',3310490820,1),(52680683,424806959,14547414,443749,1,'2007-09-16 19:23:45',3310490820,1),(52680692,424806959,14546023,443749,1,'2007-09-16 19:23:47',3310490820,1),(52680695,424806786,14544458,443749,1,'2007-09-16 19:23:47',3310490820,1),(52680698,424806646,14542824,443749,1,'2007-09-16 19:23:48',3310490820,1),(52680703,424806577,14541711,443749,1,'2007-09-16 19:23:48',3310490820,1),(52680706,424806646,14540425,443749,1,'2007-09-16 19:23:49',3310490820,1),(52680712,424807168,14538651,443749,1,'2007-09-16 19:23:50',3310490820,1),(52680715,424807829,14537156,443749,1,'2007-09-16 19:23:51',3310490820,1),(52680717,424808628,14535557,443749,1,'2007-09-16 19:23:51',3310490820,1),(52680719,424809463,14534235,443749,1,'2007-09-16 19:23:51',3310490820,1),(52680722,424810610,14533227,443749,1,'2007-09-16 19:23:52',3310490820,1),(52680727,424811480,14532288,443749,1,'2007-09-16 19:23:54',3310490820,1),(52680731,424812036,14531662,443749,1,'2007-09-16 19:23:54',3310490820,1),(52680735,424812001,14530967,443749,1,'2007-09-16 19:23:55',3310490820,1),(52680736,424811584,14530723,443749,1,'2007-09-16 19:23:55',3310490820,1),(52680739,424810889,14530688,443749,1,'2007-09-16 19:23:56',3310490820,1),(52680744,424809602,14531697,443749,1,'2007-09-16 19:23:58',3310490820,1),(52680747,424807794,14532810,443749,1,'2007-09-16 19:23:59',3310490820,1),(52680751,424806085,14533889,443749,1,'2007-09-16 19:24:01',3310490820,1),(52680753,424804073,14535206,443749,1,'2007-09-16 19:24:01',3310490820,1),(52680755,424802318,14536852,443749,1,'2007-09-16 19:24:02',3310490820,1),(52680757,424800415,14539230,443749,1,'2007-09-16 19:24:02',3310490820,1),(52680759,424799428,14540584,443749,1,'2007-09-16 19:24:02',3310490820,1),(52680760,424798440,14541279,443749,1,'2007-09-16 19:24:02',3310490820,1),(52680763,424797306,14541974,443749,1,'2007-09-16 19:24:03',3310490820,1),(52680767,424796464,14541974,443749,1,'2007-09-16 19:24:03',3310490820,1),(52680769,424795879,14541572,443749,1,'2007-09-16 19:24:04',3310490820,1),(52680773,424795769,14540694,443749,1,'2007-09-16 19:24:04',3310490820,1),(52680776,424796172,14539816,443749,1,'2007-09-16 19:24:05',3310490820,1),(52680780,424796830,14538901,443749,1,'2007-09-16 19:24:05',3310490820,1),(52680782,424799537,14535316,443749,1,'2007-09-16 19:24:06',3310490820,1),(52680784,424801513,14533085,443749,1,'2007-09-16 19:24:06',3310490820,1),(52680787,424802683,14531841,443749,1,'2007-09-16 19:24:06',3310490820,1),(52680789,424803086,14530963,443749,1,'2007-09-16 19:24:06',3310490820,1),(52680794,424802500,14530707,443749,1,'2007-09-16 19:24:06',3310490820,1),(52680797,424801879,14530743,443749,1,'2007-09-16 19:24:07',3310490820,1),(52680799,424800745,14531329,443749,1,'2007-09-16 19:24:07',3310490820,1),(52680803,424796977,14532499,443749,1,'2007-09-16 19:24:07',3310490820,1),(52680806,424795184,14532755,443749,1,'2007-09-16 19:24:07',3310490820,1),(52680810,424793355,14532828,443749,1,'2007-09-16 19:24:08',3310490820,1),(52680813,424792038,14533121,443749,1,'2007-09-16 19:24:08',3310490817,1),(52680815,424790758,14534072,443749,1,'2007-09-16 19:24:08',3310490817,1),(52680818,424789514,14534987,443749,1,'2007-09-16 19:24:09',3310490817,1),(52680820,424789038,14536194,443749,1,'2007-09-16 19:24:09',3310490817,1),(52680823,424788636,14537474,443749,1,'2007-09-16 19:24:09',3310490817,1),(52680825,424788051,14538718,443749,1,'2007-09-16 19:24:10',3310490817,1),(52680828,424787539,14538645,443749,1,'2007-09-16 19:24:10',3310490817,1),(52680830,424787209,14538169,443749,1,'2007-09-16 19:24:10',3310490817,1),(52680832,424786990,14537511,443749,1,'2007-09-16 19:24:10',3310490817,1),(52680836,424787063,14535755,443749,1,'2007-09-16 19:24:11',3310490817,1),(52680838,424787539,14533633,443749,1,'2007-09-16 19:24:11',3310490817,1),(52680839,424788526,14531877,443749,1,'2007-09-16 19:24:11',3310490817,1),(52680842,424789733,14530414,443749,1,'2007-09-16 19:24:12',3310490817,1),(52680844,424790941,14529097,443749,1,'2007-09-16 19:24:12',3310490817,1),(52680847,424792184,14528256,443749,1,'2007-09-16 19:24:13',3310490817,1),(52680850,424793465,14528109,443749,1,'2007-09-16 19:24:14',3310490820,1),(52680852,424795001,14527707,443749,1,'2007-09-16 19:24:14',3310490820,1),(52680855,424796318,14527049,443749,1,'2007-09-16 19:24:14',3310490820,1),(52680858,424797745,14526573,443749,1,'2007-09-16 19:24:14',3310490820,1),(52680860,424798623,14525878,443749,1,'2007-09-16 19:24:15',3310490820,1),(52680866,424798659,14525329,443749,1,'2007-09-16 19:24:16',3310490820,1),(52680869,424798037,14524927,443749,1,'2007-09-16 19:24:16',3310490820,1),(52680871,424797196,14524890,443749,1,'2007-09-16 19:24:16',3310490820,1),(52680874,424794489,14524963,443749,1,'2007-09-16 19:24:17',3310490820,1),(52680877,424793026,14524744,443749,1,'2007-09-16 19:24:17',3310490820,1),(52680879,424791636,14523866,443749,1,'2007-09-16 19:24:17',3310490817,1),(52680883,424790685,14523354,443749,1,'2007-09-16 19:24:18',3310490817,1),(52680913,424789624,14523427,443749,1,'2007-09-16 19:24:27',3310490817,1),(52680960,424788124,14523720,443749,1,'2007-09-16 19:24:33',3310490817,1),(52681009,424787136,14523720,443749,1,'2007-09-16 19:24:40',3310490817,1),(52681026,424785600,14523500,443749,1,'2007-09-16 19:24:43',3310490817,1),(52681028,424784319,14523317,443749,1,'2007-09-16 19:24:43',3310490817,1),(52681343,424782563,14523427,443749,1,'2007-09-16 19:25:38',3310490817,1),(52681347,424780661,14523683,443749,1,'2007-09-16 19:25:38',3310490817,1),(52681350,424779673,14524268,443749,1,'2007-09-16 19:25:38',3310490817,1),(52681355,424778978,14525073,443749,1,'2007-09-16 19:25:39',3310490817,1),(52681357,424777808,14526207,443749,1,'2007-09-16 19:25:39',3310490817,1),(52681361,424775576,14528512,443749,1,'2007-09-16 19:25:39',3310490817,1),(52681362,424773455,14530048,443749,1,'2007-09-16 19:25:39',3310490817,1),(52681366,424772544,14530277,443749,1,'2007-09-16 19:25:40',3310490817,1),(52681368,424771406,14530624,443749,1,'2007-09-16 19:25:40',3310490817,1),(52681372,424769823,14530327,443749,1,'2007-09-16 19:25:40',3310490817,1),(52681374,424768586,14529634,443749,1,'2007-09-16 19:25:41',3310490817,1),(52681375,424767299,14528793,443749,1,'2007-09-16 19:25:41',3310490817,1),(52681378,424766062,14528842,443749,1,'2007-09-16 19:25:41',3310490817,1),(52681380,424764578,14529832,443749,1,'2007-09-16 19:25:42',3310490816,1),(52681382,424763935,14530723,443749,1,'2007-09-16 19:25:42',3310490816,1),(52681384,424763836,14531762,443749,1,'2007-09-16 19:25:42',3310490816,1),(52681386,424764677,14533345,443749,1,'2007-09-16 19:25:42',3310490816,1),(52681390,424765815,14535473,443749,1,'2007-09-16 19:25:43',3310490817,1),(52681392,424766607,14537650,443749,1,'2007-09-16 19:25:43',3310490817,1),(52681393,424767003,14539778,443749,1,'2007-09-16 19:25:43',3310490817,1),(52681394,424767596,14542895,443749,1,'2007-09-16 19:25:43',3310490817,1),(52681395,424767497,14544082,443749,1,'2007-09-16 19:25:43',3310490817,1),(52681398,424766805,14543934,443749,1,'2007-09-16 19:25:44',3310490817,1),(52681400,424766359,14542994,443749,1,'2007-09-16 19:25:45',3310490817,1),(52681405,424765518,14541213,443749,1,'2007-09-16 19:25:45',3310490817,1),(52681407,424763489,14537947,443749,1,'2007-09-16 19:25:46',3310490816,1),(52681409,424762401,14535869,443749,1,'2007-09-16 19:25:46',3310490816,1),(52681412,424761807,14535027,443749,1,'2007-09-16 19:25:47',3310490816,1),(52681414,424761015,14535126,443749,1,'2007-09-16 19:25:47',3310490816,1),(52681416,424761015,14535770,443749,1,'2007-09-16 19:25:48',3310490816,1),(52681417,424761411,14536908,443749,1,'2007-09-16 19:25:48',3310490816,1),(52681420,424761906,14538590,443749,1,'2007-09-16 19:25:48',3310490816,1),(52681422,424762005,14540223,443749,1,'2007-09-16 19:25:48',3310490816,1),(52681423,424761956,14541064,443749,1,'2007-09-16 19:25:48',3310490816,1),(52681425,424760893,14540517,443749,1,'2007-09-16 19:25:48',3310490816,1),(52681427,424760570,14539728,443749,1,'2007-09-16 19:25:48',3310490816,1),(52681429,424761208,14534760,443749,1,'2007-09-16 19:25:49',3310490816,1),(52681431,424761371,14541027,443749,1,'2007-09-16 19:25:49',3310490816,1),(52681432,424759266,14537435,443749,1,'2007-09-16 19:25:49',3310490816,1),(52681434,424757981,14535122,443749,1,'2007-09-16 19:25:50',3310490816,1),(52681439,424757081,14532360,443749,1,'2007-09-16 19:25:50',3310490816,1),(52681462,424756696,14530432,443749,1,'2007-09-16 19:25:54',3310490816,1),(52681464,424756118,14527605,443749,1,'2007-09-16 19:25:54',3310490816,1),(52681465,424756246,14524328,443749,1,'2007-09-16 19:25:54',3310490816,1),(52681466,424756439,14522786,443749,1,'2007-09-16 19:25:55',3310490816,1),(52681468,424757210,14521437,443749,1,'2007-09-16 19:25:55',3310490816,1),(52681471,424758816,14520409,443749,1,'2007-09-16 19:25:55',3310490816,1),(52681474,424760680,14519445,443749,1,'2007-09-16 19:25:56',3310490816,1),(52681476,424762222,14518417,443749,1,'2007-09-16 19:25:56',3310490816,1),(52681478,424763635,14516682,443749,1,'2007-09-16 19:25:56',3310490816,1),(52681481,424764599,14514691,443749,1,'2007-09-16 19:25:57',3310490816,1),(52681484,424765627,14512827,443749,1,'2007-09-16 19:25:57',3310490817,1),(52681487,424767040,14511607,443749,1,'2007-09-16 19:25:57',3310490817,1),(52681492,424767554,14510450,443749,1,'2007-09-16 19:25:59',3310490817,1),(52681493,424767747,14509101,443749,1,'2007-09-16 19:25:59',3310490817,1),(52681496,424767040,14507752,443749,1,'2007-09-16 19:25:59',3310490817,1),(52681499,424765691,14507366,443749,1,'2007-09-16 19:25:59',3310490817,1),(52681500,424764213,14507173,443749,1,'2007-09-16 19:26:00',3310490816,1),(52681503,424761515,14508137,443749,1,'2007-09-16 19:26:00',3310490816,1),(52681508,424759973,14509229,443749,1,'2007-09-16 19:26:00',3310490816,1),(52681510,424758302,14509743,443749,1,'2007-09-16 19:26:00',3310490816,1),(52681511,424756053,14509229,443749,1,'2007-09-16 19:26:01',3310490816,1),(52681514,424753034,14508844,443749,1,'2007-09-16 19:26:01',3310490816,1),(52681516,424752006,14509037,443749,1,'2007-09-16 19:26:01',3310490816,1),(52681518,424751170,14509551,443749,1,'2007-09-16 19:26:01',3310490816,1),(52681521,424750335,14511542,443749,1,'2007-09-16 19:26:02',3310490816,1),(52681526,424748922,14517325,443749,1,'2007-09-16 19:26:03',3310490816,1),(52681528,424748215,14520666,443749,1,'2007-09-16 19:26:03',3310490816,1),(52681531,424747894,14522529,443749,1,'2007-09-16 19:26:04',3310490816,1),(52681533,424747187,14523043,443749,1,'2007-09-16 19:26:04',3310490816,1),(52681535,424746416,14522979,443749,1,'2007-09-16 19:26:05',3310490816,1),(52681537,424746030,14522336,443749,1,'2007-09-16 19:26:05',3310490816,1),(52681539,424745966,14520794,443749,1,'2007-09-16 19:26:06',3310490816,1),(52681541,424745581,14515976,443749,1,'2007-09-16 19:26:07',3310490816,1),(52681544,424745516,14514498,443749,1,'2007-09-16 19:26:07',3310490816,1),(52681547,424745516,14513534,443749,1,'2007-09-16 19:26:07',3310490816,1),(52681551,424744745,14512056,443749,1,'2007-09-16 19:26:08',3310490816,1),(52681553,424743653,14513149,443749,1,'2007-09-16 19:26:08',3310490816,1),(52681557,424743268,14515012,443749,1,'2007-09-16 19:26:08',3310490816,1),(52681568,424742818,14516490,443749,1,'2007-09-16 19:26:10',3310490816,1),(52681571,424744077,14512262,443749,1,'2007-09-16 19:26:10',3310490816,1),(52681576,424745336,14512603,443749,1,'2007-09-16 19:26:11',3310490816,1),(52681578,424742304,14516939,443749,1,'2007-09-16 19:26:11',3310490816,1),(52681582,424741340,14516875,443749,1,'2007-09-16 19:26:11',3310490816,1),(52681586,424740376,14515911,443749,1,'2007-09-16 19:26:12',3310490816,1),(52681589,424739220,14514883,443749,1,'2007-09-16 19:26:12',3310490816,1),(52681593,424737999,14514305,443749,1,'2007-09-16 19:26:12',3310490816,1),(52681596,424736714,14513598,443749,1,'2007-09-16 19:26:13',3310490773,1),(52681598,424735300,14513470,443749,1,'2007-09-16 19:26:13',3310490773,1),(52681600,424734015,14512892,443749,1,'2007-09-16 19:26:13',3310490773,1),(52681603,424732730,14511607,443749,1,'2007-09-16 19:26:14',3310490773,1),(52681605,424731831,14509679,443749,1,'2007-09-16 19:26:14',3310490773,1),(52681608,424731253,14508073,443749,1,'2007-09-16 19:26:15',3310490773,1),(52681610,424730674,14505567,443749,1,'2007-09-16 19:26:15',3310490773,1),(52681613,424729968,14504346,443749,1,'2007-09-16 19:26:15',3310490773,1),(52681615,424728361,14502933,443749,1,'2007-09-16 19:26:15',3310490773,1),(52681619,424727398,14501391,443749,1,'2007-09-16 19:26:16',3310490687,1),(52681648,424726755,14499078,443749,1,'2007-09-16 19:26:21',3310490687,1),(52681683,424725599,14494901,443749,1,'2007-09-16 19:26:28',3310490687,1),(52681949,424725085,14492781,443749,1,'2007-09-16 19:27:21',3310490687,1),(52682039,424725920,14492203,443749,1,'2007-09-16 19:27:35',3310490687,1),(52682044,424726113,14493038,443749,1,'2007-09-16 19:27:36',3310490687,1),(52682047,424726819,14495801,443749,1,'2007-09-16 19:27:36',3310490687,1),(52682050,424725129,14491669,443749,1,'2007-09-16 19:27:36',3310490687,1),(52682055,424725666,14491789,443749,1,'2007-09-16 19:27:36',3310490687,1),(52682060,424724866,14492241,443749,1,'2007-09-16 19:27:37',3310490687,1),(52682065,424727721,14498459,443749,1,'2007-09-16 19:27:37',3310490687,1),(52682068,424728414,14500385,443749,1,'2007-09-16 19:27:38',3310490687,1),(52682070,424729916,14501810,443749,1,'2007-09-16 19:27:38',3310490687,1),(52682072,424731881,14503929,443749,1,'2007-09-16 19:27:38',3310490773,1),(52682091,424733807,14505816,443749,1,'2007-09-16 19:27:43',3310490773,1),(52682096,424734423,14506086,443749,1,'2007-09-16 19:27:43',3310490773,1),(52682101,424735155,14506086,443749,1,'2007-09-16 19:27:44',3310490773,1),(52682123,424735540,14505778,443749,1,'2007-09-16 19:27:47',3310490773,1),(52682126,424735617,14505123,443749,1,'2007-09-16 19:27:47',3310490773,1),(52682128,424735425,14504353,443749,1,'2007-09-16 19:27:48',3310490773,1),(52682132,424734693,14503890,443749,1,'2007-09-16 19:27:48',3310490773,1),(52682135,424733845,14503582,443749,1,'2007-09-16 19:27:48',3310490773,1),(52682140,424732921,14502696,443749,1,'2007-09-16 19:27:48',3310490773,1),(52682143,424731958,14501271,443749,1,'2007-09-16 19:27:49',3310490687,1),(52682146,424731034,14499268,443749,1,'2007-09-16 19:27:49',3310490687,1),(52682150,424730186,14496456,443749,1,'2007-09-16 19:27:49',3310490687,1),(52682152,424729416,14493452,443749,1,'2007-09-16 19:27:49',3310490687,1),(52682156,424728799,14491218,443749,1,'2007-09-16 19:27:49',3310490687,1),(52682160,424728607,14489754,443749,1,'2007-09-16 19:27:49',3310490687,1),(52682164,424728260,14487481,443749,1,'2007-09-16 19:27:50',3310490687,1),(52682168,424727682,14486133,443749,1,'2007-09-16 19:27:50',3310490687,1),(52682170,424726219,14483861,443749,1,'2007-09-16 19:27:50',3310490687,1),(52682174,424725564,14483013,443749,1,'2007-09-16 19:27:51',3310490687,1),(52682178,424724485,14482628,443749,1,'2007-09-16 19:27:51',3310490687,1),(52682180,424722675,14482320,443749,1,'2007-09-16 19:27:51',3310490687,1),(52682184,424721751,14481935,443749,1,'2007-09-16 19:27:52',3310490687,1),(52682186,424719940,14481203,443749,1,'2007-09-16 19:27:52',3310490687,1),(52682190,424718322,14480933,443749,1,'2007-09-16 19:27:52',3310490687,1),(52682195,424716358,14481318,443749,1,'2007-09-16 19:27:53',3310490687,1),(52682197,424714471,14481781,443749,1,'2007-09-16 19:27:53',3310490687,1),(52682200,424712352,14482320,443749,1,'2007-09-16 19:27:54',3310490687,1),(52682202,424710773,14482821,443749,1,'2007-09-16 19:27:54',3310490687,1),(52682204,424709193,14483283,443749,1,'2007-09-16 19:27:54',3310490686,1),(52682207,424708770,14481858,443749,1,'2007-09-16 19:27:54',3310490686,1),(52682210,424709001,14481280,443749,1,'2007-09-16 19:27:55',3310490686,1),(52682212,424710041,14479585,443749,1,'2007-09-16 19:27:55',3310490686,1),(52682215,424709874,14483327,443749,1,'2007-09-16 19:27:55',3310490686,1),(52682216,424708717,14482657,443749,1,'2007-09-16 19:27:55',3310490686,1),(52682221,424711582,14478699,443749,1,'2007-09-16 19:27:56',3310490687,1),(52682224,424713431,14478121,443749,1,'2007-09-16 19:27:56',3310490687,1),(52682227,424716474,14477120,443749,1,'2007-09-16 19:27:56',3310490687,1),(52682231,424720248,14475810,443749,1,'2007-09-16 19:27:57',3310490687,1),(52682235,424722636,14474770,443749,1,'2007-09-16 19:27:58',3310490687,1),(52682238,424723445,14473884,443749,1,'2007-09-16 19:27:58',3310490687,1),(52682240,424723599,14472960,443749,1,'2007-09-16 19:27:58',3310490687,1),(52682243,424723099,14472035,443749,1,'2007-09-16 19:27:59',3310490687,1),(52682244,424721828,14471997,443749,1,'2007-09-16 19:27:59',3310490687,1),(52682247,424720441,14471958,443749,1,'2007-09-16 19:27:59',3310490687,1),(52682250,424719054,14471727,443749,1,'2007-09-16 19:27:59',3310490687,1),(52682253,424717128,14470533,443749,1,'2007-09-16 19:28:00',3310490687,1),(52682255,424715934,14469455,443749,1,'2007-09-16 19:28:00',3310490687,1),(52682257,424714586,14468993,443749,1,'2007-09-16 19:28:00',3310490687,1),(52682259,424712891,14468684,443749,1,'2007-09-16 19:28:00',3310490687,1),(52682262,424711312,14468684,443749,1,'2007-09-16 19:28:00',3310490687,1),(52682265,424709579,14468877,443749,1,'2007-09-16 19:28:01',3310490686,1),(52682270,424707768,14469917,443749,1,'2007-09-16 19:28:02',3310490686,1),(52682272,424706228,14470880,443749,1,'2007-09-16 19:28:02',3310490686,1),(52682274,424705226,14471342,443749,1,'2007-09-16 19:28:02',3310490686,1),(52682277,424703878,14471766,443749,1,'2007-09-16 19:28:02',3310490686,1),(52682524,424702992,14471304,443749,1,'2007-09-16 19:29:00',3310490686,1),(52682546,424702068,14470456,443749,1,'2007-09-16 19:29:04',3310490686,1),(52682558,424701216,14469560,443749,1,'2007-09-16 19:29:12',3310490686,1),(52682617,424699441,14468179,443749,1,'2007-09-16 19:29:21',3310490686,1),(52682663,424697888,14467193,443749,1,'2007-09-16 19:29:32',3310490686,1),(52682673,424696223,14466029,443749,1,'2007-09-16 19:29:34',3310490686,1),(52685135,424653662,14490028,443749,1,'2007-09-16 19:38:11',3310490682,1),(52685138,424652684,14492170,443749,1,'2007-09-16 19:38:11',3310490682,1),(52685142,424651219,14495290,443749,1,'2007-09-16 19:38:12',3310490682,1),(52685145,424649377,14497846,443749,1,'2007-09-16 19:38:12',3310490682,1),(52685147,424647761,14499537,443749,1,'2007-09-16 19:38:12',3310490682,1),(52685151,424646145,14500740,443749,1,'2007-09-16 19:38:13',3310490682,1),(52685154,424644115,14501266,443749,1,'2007-09-16 19:38:13',3310490682,1),(52685157,424642161,14501942,443749,1,'2007-09-16 19:38:14',3310490682,1),(52685160,424640206,14502920,443749,1,'2007-09-16 19:38:14',3310490768,1),(52685162,424638816,14503972,443749,1,'2007-09-16 19:38:14',3310490768,1),(52685166,424637989,14505138,443749,1,'2007-09-16 19:38:15',3310490768,1),(52685169,424637426,14507167,443749,1,'2007-09-16 19:38:16',3310490768,1),(52685171,424636862,14509647,443749,1,'2007-09-16 19:38:16',3310490768,1),(52685184,424636316,14512315,443749,1,'2007-09-16 19:38:18',3310490768,1),(52685190,424636128,14515351,443749,1,'2007-09-16 19:38:19',3310490768,1),(52685195,424636203,14517412,443749,1,'2007-09-16 19:38:20',3310490768,1),(52685199,424636353,14519399,443749,1,'2007-09-16 19:38:20',3310490768,1),(52685202,424636353,14521235,443749,1,'2007-09-16 19:38:20',3310490768,1),(52685204,424636391,14522885,443749,1,'2007-09-16 19:38:21',3310490768,1),(52685207,424636690,14524271,443749,1,'2007-09-16 19:38:21',3310490768,1),(52685211,424637215,14525808,443749,1,'2007-09-16 19:38:21',3310490768,1),(52685217,424638227,14527157,443749,1,'2007-09-16 19:38:23',3310490768,1),(52685220,424638677,14528169,443749,1,'2007-09-16 19:38:23',3310490768,1),(52685226,424638789,14528769,443749,1,'2007-09-16 19:38:25',3310490768,1),(52685229,424638452,14529256,443749,1,'2007-09-16 19:38:25',3310490768,1),(52685232,424637777,14528844,443749,1,'2007-09-16 19:38:25',3310490768,1),(52685236,424636503,14527945,443749,1,'2007-09-16 19:38:26',3310490768,1),(52685238,424635229,14526483,443749,1,'2007-09-16 19:38:26',3310490768,1),(52685243,424633917,14524384,443749,1,'2007-09-16 19:38:27',3310490768,1),(52685247,424632717,14522885,443749,1,'2007-09-16 19:38:27',3310490768,1),(52685258,424631668,14521235,443749,1,'2007-09-16 19:38:30',3310490768,1),(52685262,424629906,14517937,443749,1,'2007-09-16 19:38:30',3310490768,1),(52685269,424629082,14515238,443749,1,'2007-09-16 19:38:30',3310490768,1),(52685275,424627732,14512165,443749,1,'2007-09-16 19:38:31',3310490757,1),(52685277,424626196,14507480,443749,1,'2007-09-16 19:38:31',3310490757,1),(52685282,424625596,14504894,443749,1,'2007-09-16 19:38:32',3310490757,1),(52685296,424625446,14502382,443749,1,'2007-09-16 19:38:33',3310490757,1),(52685299,424625633,14500321,443749,1,'2007-09-16 19:38:33',3310490671,1),(52685307,424626308,14498634,443749,1,'2007-09-16 19:38:34',3310490671,1),(52685313,424627545,14496310,443749,1,'2007-09-16 19:38:35',3310490671,1),(52685696,424837687,14585331,443749,1,'2007-09-16 19:39:22',3310490823,1),(52685701,424838744,14583757,443749,1,'2007-09-16 19:39:23',3310490823,1),(52685707,424839728,14582650,443749,1,'2007-09-16 19:39:23',3310490823,1),(52685710,424840638,14581421,443749,1,'2007-09-16 19:39:23',3310490823,1),(52685714,424841179,14580585,443749,1,'2007-09-16 19:39:23',3310490823,1),(52685717,424841056,14579724,443749,1,'2007-09-16 19:39:24',3310490823,1),(52685723,424840457,14579274,443749,1,'2007-09-16 19:39:25',3310490823,1),(52685727,424836937,14586608,443749,1,'2007-09-16 19:39:25',3310490823,1),(52685732,424835985,14588109,443749,1,'2007-09-16 19:39:26',3310490823,1),(52685739,424834887,14589372,443749,1,'2007-09-16 19:39:27',3310490823,1),(52685761,424834192,14590770,443749,1,'2007-09-16 19:39:29',3310490823,1),(52685764,424834035,14592082,443749,1,'2007-09-16 19:39:30',3310490823,1),(52685771,424834188,14593843,443749,1,'2007-09-16 19:39:30',3310490823,1),(52685779,424834725,14595690,443749,1,'2007-09-16 19:39:30',3310490823,1),(52685789,424835296,14597436,443749,1,'2007-09-16 19:39:32',3310490823,1),(52685802,424816744,14596902,443749,1,'2007-09-16 19:39:32',3310490822,1),(52685814,424821387,14592237,443749,1,'2007-09-16 19:39:34',3310490823,1),(52685832,424823439,14589925,443749,1,'2007-09-16 19:39:35',3310490823,1),(52685840,424824299,14587943,443749,1,'2007-09-16 19:39:36',3310490823,1),(52685847,424835605,14598566,443749,1,'2007-09-16 19:39:37',3310490823,1),(52685851,424835848,14599376,443749,1,'2007-09-16 19:39:37',3310490823,1),(52685859,424835977,14600041,443749,1,'2007-09-16 19:39:38',3310490823,1),(52685862,424836010,14600720,443749,1,'2007-09-16 19:39:38',3310490823,1),(52685869,424835678,14601301,443749,1,'2007-09-16 19:39:39',3310490823,1),(52685873,424835164,14601649,443749,1,'2007-09-16 19:39:39',3310490823,1),(52685877,424834186,14601699,443749,1,'2007-09-16 19:39:39',3310490823,1),(52685881,424832627,14601400,443749,1,'2007-09-16 19:39:40',3310490823,1),(52685886,424831533,14600919,443749,1,'2007-09-16 19:39:41',3310490823,1),(52685894,424830654,14600439,443749,1,'2007-09-16 19:39:42',3310490823,1),(52685905,424830190,14600439,443749,1,'2007-09-16 19:39:43',3310490823,1),(52685911,424829975,14600637,443749,1,'2007-09-16 19:39:43',3310490823,1),(52685917,424829958,14601118,443749,1,'2007-09-16 19:39:44',3310490823,1),(52685920,424830190,14601682,443749,1,'2007-09-16 19:39:44',3310490823,1),(52685923,424831649,14602826,443749,1,'2007-09-16 19:39:44',3310490823,1),(52685926,424834835,14604943,443749,1,'2007-09-16 19:39:45',3310490823,1),(52685929,424837203,14606166,443749,1,'2007-09-16 19:39:45',3310490823,1),(52685931,424838731,14606510,443749,1,'2007-09-16 19:39:45',3310490823,1),(52685934,424841596,14606815,443749,1,'2007-09-16 19:39:45',3310490823,1),(52685939,424843468,14606701,443749,1,'2007-09-16 19:39:46',3310490823,1),(52685943,424844495,14606426,443749,1,'2007-09-16 19:39:46',3310490823,1),(52685946,424844730,14605707,443749,1,'2007-09-16 19:39:47',3310490823,1),(52685950,424844683,14604533,443749,1,'2007-09-16 19:39:47',3310490823,1),(52685966,424844041,14602890,443749,1,'2007-09-16 19:39:49',3310490823,1),(52685971,424843306,14601247,443749,1,'2007-09-16 19:39:50',3310490823,1),(52685975,424842611,14599702,443749,1,'2007-09-16 19:39:51',3310490823,1),(52685978,424842019,14597446,443749,1,'2007-09-16 19:39:51',3310490823,1),(52685980,424841797,14596373,443749,1,'2007-09-16 19:39:51',3310490823,1),(52685982,424841871,14595374,443749,1,'2007-09-16 19:39:51',3310490823,1),(52685986,424842648,14593599,443749,1,'2007-09-16 19:39:51',3310490823,1),(52685990,424843314,14592785,443749,1,'2007-09-16 19:39:52',3310490823,1),(52685993,424843868,14592526,443749,1,'2007-09-16 19:39:53',3310490823,1),(52685996,424844349,14592489,443749,1,'2007-09-16 19:39:53',3310490823,1),(52686002,424844571,14592822,443749,1,'2007-09-16 19:39:55',3310490823,1),(52686474,424844571,14593303,443749,1,'2007-09-16 19:41:37',3310490823,1),(52686478,424844349,14594265,443749,1,'2007-09-16 19:41:37',3310490823,1),(52686480,424844238,14595522,443749,1,'2007-09-16 19:41:37',3310490823,1),(52686486,424844238,14596077,443749,1,'2007-09-16 19:41:38',3310490823,1),(52686490,424844460,14597520,443749,1,'2007-09-16 19:41:38',3310490823,1),(52686495,424845126,14598999,443749,1,'2007-09-16 19:41:39',3310490823,1),(52686501,424845903,14600442,443749,1,'2007-09-16 19:41:39',3310490823,1),(52686505,424847382,14601329,443749,1,'2007-09-16 19:41:40',3310490823,1),(52686510,424848344,14601588,443749,1,'2007-09-16 19:41:41',3310490834,1),(52686511,424849380,14602143,443749,1,'2007-09-16 19:41:41',3310490834,1),(52686514,424850896,14603364,443749,1,'2007-09-16 19:41:42',3310490834,1);
INSERT INTO `current_nodes` VALUES (52686517,424852265,14604436,443749,1,'2007-09-16 19:41:42',3310490834,1),(52686518,424853448,14605731,443749,1,'2007-09-16 19:41:42',3310490834,1),(52686521,424854003,14606803,443749,1,'2007-09-16 19:41:43',3310490834,1),(52686524,424854632,14607395,443749,1,'2007-09-16 19:41:43',3310490834,1),(52686527,424855298,14607580,557925,1,'2008-01-06 22:29:13',3310490834,2),(52686533,424855889,14607210,443749,1,'2007-09-16 19:41:44',3310490834,1),(52686537,424856111,14606619,443749,1,'2007-09-16 19:41:45',3310490834,1),(52686542,424855815,14605842,443749,1,'2007-09-16 19:41:46',3310490834,1),(52686544,424855409,14604954,443749,1,'2007-09-16 19:41:46',3310490834,1),(52686547,424854225,14603475,443749,1,'2007-09-16 19:41:46',3310490834,1),(52686551,424851895,14601033,443749,1,'2007-09-16 19:41:47',3310490834,1),(52686555,424850341,14599591,443749,1,'2007-09-16 19:41:47',3310490834,1),(52686561,424849971,14598629,443749,1,'2007-09-16 19:41:49',3310490834,1),(52686569,424850119,14598259,443749,1,'2007-09-16 19:41:50',3310490834,1),(52686574,424850711,14598333,443749,1,'2007-09-16 19:41:50',3310490834,1),(52686579,424851192,14598703,443749,1,'2007-09-16 19:41:50',3310490834,1),(52686586,424852782,14599850,443749,1,'2007-09-16 19:41:50',3310490834,1),(52686593,424855815,14602180,443749,1,'2007-09-16 19:41:51',3310490834,1),(52686598,424857036,14603216,443749,1,'2007-09-16 19:41:51',3310490834,1),(52686601,424857739,14604103,443749,1,'2007-09-16 19:41:51',3310490834,1),(52686604,424858737,14604917,443749,1,'2007-09-16 19:41:52',3310490834,1),(52686607,424859440,14605546,443749,1,'2007-09-16 19:41:53',3310490834,1),(52686610,424860254,14606434,443749,1,'2007-09-16 19:41:54',3310490834,1),(52686622,424860809,14607469,443749,1,'2007-09-16 19:41:56',3310490834,1),(52686626,424861475,14609282,443749,1,'2007-09-16 19:41:56',3310490834,1),(52686632,424861696,14610909,443749,1,'2007-09-16 19:41:57',3310490834,1),(52686637,424861622,14612315,443749,1,'2007-09-16 19:41:58',3310490840,1),(52686639,424861475,14613757,443749,1,'2007-09-16 19:41:59',3310490840,1),(52686644,424861216,14615052,443749,1,'2007-09-16 19:42:00',3310490840,1),(52686648,424861327,14615865,443749,1,'2007-09-16 19:42:01',3310490840,1),(52686651,424861881,14616642,443749,1,'2007-09-16 19:42:02',3310490840,1),(52686654,424861992,14617752,443749,1,'2007-09-16 19:42:02',3310490840,1),(52686655,424862066,14618603,443749,1,'2007-09-16 19:42:02',3310490840,1),(52686659,424861475,14619416,443749,1,'2007-09-16 19:42:03',3310490840,1),(52686660,424860624,14620119,443749,1,'2007-09-16 19:42:03',3310490840,1),(52686663,424859218,14621673,443749,1,'2007-09-16 19:42:04',3310490840,1),(52686666,424858848,14622116,443749,1,'2007-09-16 19:42:04',3310490840,1),(52686668,424857924,14622412,443749,1,'2007-09-16 19:42:04',3310490840,1),(52686674,424856925,14622486,443749,1,'2007-09-16 19:42:06',3310490840,1),(52686680,424856111,14622190,443749,1,'2007-09-16 19:42:08',3310490840,1),(52686682,424854632,14621044,443749,1,'2007-09-16 19:42:08',3310490840,1),(52686683,424853448,14620563,443749,1,'2007-09-16 19:42:08',3310490840,1),(52686687,424852080,14620600,443749,1,'2007-09-16 19:42:08',3310490840,1),(52688384,424850896,14620970,443749,1,'2007-09-16 19:46:44',3310490840,1),(52688387,424849343,14621414,443749,1,'2007-09-16 19:46:44',3310490840,1),(52688389,424848196,14622153,443749,1,'2007-09-16 19:46:44',3310490840,1),(52688391,424846827,14623300,443749,1,'2007-09-16 19:46:45',3310490829,1),(52688393,424845496,14624447,443749,1,'2007-09-16 19:46:45',3310490829,1),(52688398,424843425,14625667,443749,1,'2007-09-16 19:46:45',3310490829,1),(52688401,424841834,14626592,443749,1,'2007-09-16 19:46:46',3310490829,1),(52688431,424841020,14626962,443749,1,'2007-09-16 19:46:50',3310490829,1),(52688438,424840540,14627332,443749,1,'2007-09-16 19:46:51',3310490829,1),(52688454,424840170,14627886,443749,1,'2007-09-16 19:46:54',3310490829,1),(52688455,424840207,14628256,443749,1,'2007-09-16 19:46:54',3310490829,1),(52688458,424840392,14628515,443749,1,'2007-09-16 19:46:55',3310490829,1),(52688531,424840651,14628626,443749,1,'2007-09-16 19:47:07',3310490829,1),(52688570,424841094,14628515,443749,1,'2007-09-16 19:47:13',3310490829,1),(52688574,424841982,14628219,443749,1,'2007-09-16 19:47:14',3310490829,1),(52688576,424843462,14627886,443749,1,'2007-09-16 19:47:14',3310490829,1),(52688577,424845496,14627849,443749,1,'2007-09-16 19:47:14',3310490829,1),(52688580,424846753,14627554,443749,1,'2007-09-16 19:47:14',3310490829,1),(52688582,424847604,14627184,443749,1,'2007-09-16 19:47:15',3310490829,1),(52688584,424848862,14627295,443749,1,'2007-09-16 19:47:15',3310490840,1),(52688608,424850082,14627332,443749,1,'2007-09-16 19:47:19',3310490840,1),(52688609,424851451,14627295,443749,1,'2007-09-16 19:47:20',3310490840,1),(52688628,424852006,14627665,443749,1,'2007-09-16 19:47:22',3310490840,1),(52688632,424852154,14627960,443749,1,'2007-09-16 19:47:22',3310490840,1),(52688633,424851599,14628700,443749,1,'2007-09-16 19:47:22',3310490840,1),(52688637,424850267,14629366,443749,1,'2007-09-16 19:47:22',3310490840,1),(52688639,424849010,14629625,443749,1,'2007-09-16 19:47:22',3310490840,1),(52688642,424852028,14628349,443749,1,'2007-09-16 19:47:23',3310490840,1),(52688644,424847616,14630380,443749,1,'2007-09-16 19:47:23',3310490829,1),(52688646,424845712,14631893,443749,1,'2007-09-16 19:47:23',3310490829,1),(52688648,424843515,14633504,443749,1,'2007-09-16 19:47:23',3310490829,1),(52688652,424842100,14635505,443749,1,'2007-09-16 19:47:23',3310490829,1),(52688654,424840733,14637653,443749,1,'2007-09-16 19:47:23',3310490829,1),(52688655,424840196,14639508,443749,1,'2007-09-16 19:47:24',3310490829,1),(52688662,425057314,15310651,443749,1,'2007-09-16 19:47:24',3310491437,1),(52688663,425053517,15312851,443749,1,'2007-09-16 19:47:24',3310491437,1),(52688667,425056708,15326937,443749,1,'2007-09-16 19:47:25',3310491439,1),(52688669,425060615,15324846,443749,1,'2007-09-16 19:47:25',3310491437,1),(52688672,425053738,15274546,3916355,1,'2010-02-19 17:34:14',3310491437,5),(52688676,425053294,15275475,3916355,1,'2010-02-19 17:34:13',3310491437,5),(52688677,425052326,15275408,3916355,1,'2010-02-19 17:34:13',3310491437,5),(52688680,425052053,15274977,3916355,1,'2010-02-19 17:34:13',3310491437,5),(52688683,425051955,15274401,3916355,1,'2010-02-19 17:34:13',3310491437,5),(52688686,425052061,15273850,3916355,1,'2010-02-19 17:34:12',3310491437,5),(52688688,425052378,15273393,3916355,1,'2010-02-19 17:34:12',3310491437,5),(52688692,425053179,15273298,3916355,1,'2010-02-19 17:34:12',3310491437,7),(52688693,425053366,15273436,3916355,1,'2010-02-19 17:34:14',3310491437,5),(52688697,425053618,15273808,3916355,1,'2010-02-19 17:34:14',3310491437,5),(52688698,425054664,15277614,305941,1,'2009-02-09 21:25:15',3310491437,2),(52688701,425053923,15275845,305941,1,'2009-02-09 21:25:15',3310491437,2),(52688703,425053643,15274980,3916355,1,'2010-02-19 17:34:13',3310491437,6),(52688706,425059729,15316721,3916355,1,'2010-02-19 17:34:21',3310491437,5),(52688708,425060596,15316651,3916355,1,'2010-02-19 17:34:21',3310491437,3),(52688711,425060215,15316484,3916355,1,'2010-02-19 17:34:21',3310491437,3),(52688716,425059559,15317020,3916355,1,'2010-02-19 17:34:21',3310491437,3),(52688721,425059490,15317551,3916355,1,'2010-02-19 17:34:21',3310491437,3),(52688724,425059580,15317928,3916355,1,'2010-02-19 17:34:21',3310491437,3),(52688726,425059843,15318283,3916355,1,'2010-02-19 17:34:22',3310491437,3),(52688728,425060185,15318411,3916355,1,'2010-02-19 17:34:22',3310491437,4),(52688732,425060615,15318225,3916355,1,'2010-02-19 17:34:22',3310491437,3),(52688735,425060891,15317644,3916355,1,'2010-02-19 17:34:22',3310491437,3),(52688740,425060899,15317315,3916355,1,'2010-02-19 17:34:20',3310491437,3),(52688741,425053293,15243665,840745,1,'2009-01-26 20:08:19',3310491431,3),(52688744,425057235,15247441,840745,1,'2009-01-26 20:08:19',3310491431,3),(52688747,425059259,15249858,840745,1,'2009-01-26 20:08:19',3310491431,3),(52688750,425060731,15251568,840745,1,'2009-01-26 20:08:19',3310491431,3),(52688753,425061808,15253194,840745,1,'2009-01-26 20:08:20',3310491431,3),(52688756,425063091,15255229,840745,1,'2009-01-26 20:08:20',3310491431,3),(52688759,425063724,15256837,840745,1,'2009-01-26 20:08:20',3310491431,3),(52688763,425064648,15259643,840745,1,'2009-01-26 20:08:20',3310491431,3),(52688767,425065127,15262414,840745,1,'2009-01-26 20:08:21',3310491431,3),(52688771,425065435,15265374,840745,1,'2009-01-26 20:08:21',3310491431,3),(52688773,425065503,15269616,840745,1,'2009-01-26 20:08:21',3310491431,3),(52688774,425064869,15270564,840745,1,'2009-01-26 20:08:21',3310491431,3),(52688778,425061416,15267779,840745,1,'2009-01-26 20:08:21',3310491431,3),(52688781,425060318,15269662,840745,1,'2009-01-26 20:08:21',3310491431,3),(52688783,425058780,15267240,840745,1,'2009-01-26 20:08:21',3310491431,3),(52688788,425057641,15264836,840745,1,'2009-01-26 20:08:22',3310491431,3),(52688790,425055489,15260545,840745,1,'2009-01-26 20:08:22',3310491431,3),(52688795,425053453,15254127,840745,1,'2009-01-26 20:08:22',3310491431,3),(52688797,425052119,15247183,840745,1,'2009-01-26 20:08:22',3310491431,3),(52688801,425051576,15244745,840745,1,'2009-01-26 20:08:22',3310491431,3),(52688802,425051199,15243539,840745,1,'2009-01-26 20:08:22',3310491431,3),(52688807,425051199,15242761,840745,1,'2009-01-26 20:08:22',3310491431,3),(52688810,425066895,15320193,3916355,1,'2010-02-19 17:34:15',3310491437,3),(52688816,425067741,15321356,3916355,1,'2010-02-19 17:34:16',3310491448,4),(52688820,425067559,15321770,3916355,1,'2010-02-19 17:34:16',3310491448,3),(52688824,425067045,15322036,3916355,1,'2010-02-19 17:34:15',3310491437,3),(52688829,425066666,15321854,3916355,1,'2010-02-19 17:34:15',3310491437,4),(52688833,425066459,15321523,3916355,1,'2010-02-19 17:34:15',3310491437,5),(52688838,425066385,15321066,3916355,1,'2010-02-19 17:34:15',3310491437,3),(52688842,425066525,15320530,3916355,1,'2010-02-19 17:34:15',3310491437,3),(52688846,425067352,15320238,3916355,1,'2010-02-19 17:34:14',3310491437,3),(52688849,425067530,15320390,3916355,1,'2010-02-19 17:34:16',3310491448,3),(52688854,425063980,15322880,820251,1,'2009-03-16 23:51:15',3310491437,3),(52688859,425061665,15324233,820251,1,'2009-03-16 23:51:15',3310491437,4),(52688860,425066149,15322742,305941,1,'2009-02-09 21:22:43',3310491437,2),(52688863,425065890,15324522,305941,1,'2009-02-09 21:22:43',3310491437,2),(52688865,425066038,15328637,305941,1,'2009-02-09 21:22:43',3310491439,2),(52688868,425066631,15332159,305941,1,'2009-02-09 21:22:43',3310491439,2),(52688870,425068077,15337090,305941,1,'2009-02-09 21:22:43',3310491450,2),(52688872,425069410,15341569,305941,1,'2009-02-09 21:22:44',3310491450,6),(52688876,425070756,15319990,443749,1,'2007-09-16 19:47:44',3310491448,1),(52688880,425070205,15319053,305941,1,'2009-02-09 21:24:48',3310491448,2),(52688882,425062710,15235378,4652669,1,'2010-05-09 22:02:42',3310491431,2),(52688884,425057667,15238007,4652669,1,'2010-05-09 21:57:58',3310491431,2),(52688886,425054755,15239143,4652669,1,'2010-05-09 22:03:56',3310491431,2),(52688888,425053264,15237722,4652669,1,'2010-05-09 22:03:43',3310491431,2),(52688890,425051346,15233035,4652669,1,'2010-05-09 21:59:17',3310491431,2),(52688892,425049273,15187529,305941,1,'2009-02-09 21:34:26',3310491429,2),(52688894,425049562,15188492,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688896,425050183,15190613,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688899,425050839,15193824,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688903,425051029,15196362,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688904,425051046,15198813,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688905,425051754,15201973,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688908,425052347,15204626,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688912,425053170,15209424,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688914,425054065,15213290,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688916,425054388,15214078,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688920,425054853,15214257,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688923,425055354,15213648,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688929,425053959,15143802,697263,1,'2009-01-01 16:45:34',3310491407,3),(52688931,425056761,15145915,697263,1,'2009-01-01 16:45:34',3310491407,3),(52688934,425058678,15147079,697263,1,'2009-01-01 16:45:34',3310491407,4),(52688936,425024945,15099061,443749,1,'2007-09-16 19:47:49',3310491404,1),(52688938,425021946,15099797,443749,1,'2007-09-16 19:47:49',3310491404,1),(52688942,425021146,15100618,443749,1,'2007-09-16 19:47:49',3310491404,1),(52688945,425020430,15101713,443749,1,'2007-09-16 19:47:49',3310491404,1),(52688948,425019419,15102808,443749,1,'2007-09-16 19:47:50',3310491404,1),(52688951,425018704,15103102,443749,1,'2007-09-16 19:47:50',3310491404,1),(52688953,425018199,15103060,443749,1,'2007-09-16 19:47:50',3310491404,1),(52688956,425017693,15102597,443749,1,'2007-09-16 19:47:50',3310491404,1),(52688958,425017525,15102050,443749,1,'2007-09-16 19:47:51',3310491404,1),(52688962,425016978,15101587,443749,1,'2007-09-16 19:47:51',3310491404,1),(52688963,425015925,15101503,443749,1,'2007-09-16 19:47:51',3310491404,1),(52688967,425015420,15101545,443749,1,'2007-09-16 19:47:51',3310491404,1),(52688969,425015420,15100155,443749,1,'2007-09-16 19:47:51',3310491404,1),(52688973,425014494,15099818,443749,1,'2007-09-16 19:47:52',3310491404,1),(52688975,425013946,15100029,443749,1,'2007-09-16 19:47:52',3310491404,1),(52688978,425013609,15100703,443749,1,'2007-09-16 19:47:52',3310491404,1),(52688981,425012010,15103060,443749,1,'2007-09-16 19:47:52',3310491401,1),(52689010,425011420,15104029,443749,1,'2007-09-16 19:48:02',3310491401,1),(52689011,425012388,15107692,443749,1,'2007-09-16 19:48:02',3310491403,1),(52689013,425014830,15113165,443749,1,'2007-09-16 19:48:02',3310491406,1),(52689016,425019335,15119101,443749,1,'2007-09-16 19:48:03',3310491406,1),(52689017,425022325,15116028,443749,1,'2007-09-16 19:48:03',3310491406,1),(52689019,425024177,15118133,443749,1,'2007-09-16 19:48:03',3310491406,1),(52689020,425025187,15117291,443749,1,'2007-09-16 19:48:03',3310491406,1),(52689024,425026030,15107144,443749,1,'2007-09-16 19:48:04',3310491406,1),(52689026,425026282,15106386,443749,1,'2007-09-16 19:48:05',3310491404,1),(52689028,425026703,15106386,443749,1,'2007-09-16 19:48:05',3310491404,1),(52689032,425027250,15107818,443749,1,'2007-09-16 19:48:06',3310491406,1),(52689035,425029861,15115144,443749,1,'2007-09-16 19:48:07',3310491406,1),(52689036,425032387,15114091,443749,1,'2007-09-16 19:48:07',3310491406,1),(52689039,425032555,15113838,443749,1,'2007-09-16 19:48:08',3310491406,1),(52689041,425028050,15104323,443749,1,'2007-09-16 19:48:08',3310491404,1),(52689048,425025609,15099187,443749,1,'2007-09-16 19:48:09',3310491404,1),(52689055,425024072,15158901,3916355,1,'2010-02-19 17:31:55',3310491406,3),(52689060,425024272,15158920,3916355,1,'2010-02-19 17:31:56',3310491406,3),(52689065,425024860,15160441,3916355,1,'2010-02-19 17:31:56',3310491406,3),(52689066,425024216,15161557,3916355,1,'2010-02-19 17:31:56',3310491428,3),(52689073,425024388,15162329,3916355,1,'2010-02-19 17:31:56',3310491428,3),(52689076,425025847,15162587,3916355,1,'2010-02-19 17:31:56',3310491428,3),(52689081,425026796,15162818,443749,1,'2007-09-16 19:48:13',3310491428,1),(52689083,425028114,15163609,443749,1,'2007-09-16 19:48:13',3310491428,1),(52689086,425029116,15164321,443749,1,'2007-09-16 19:48:14',3310491428,1),(52689090,425029986,15165665,443749,1,'2007-09-16 19:48:15',3310491428,1),(52689092,425030566,15167010,443749,1,'2007-09-16 19:48:16',3310491428,1),(52689094,425029775,15168249,443749,1,'2007-09-16 19:48:16',3310491428,1),(52689095,425028167,15169277,443749,1,'2007-09-16 19:48:16',3310491428,1),(52689097,425024265,15170279,443749,1,'2007-09-16 19:48:17',3310491428,1),(52689102,425019203,15170253,443749,1,'2007-09-16 19:48:18',3310491428,1),(52689104,425017436,15169646,443749,1,'2007-09-16 19:48:19',3310491428,1),(52689106,425017647,15169172,443749,1,'2007-09-16 19:48:19',3310491428,1),(52689107,425018517,15168908,443749,1,'2007-09-16 19:48:19',3310491428,1),(52689110,425019045,15168565,443749,1,'2007-09-16 19:48:19',3310491428,1),(52689111,425019704,15168275,443749,1,'2007-09-16 19:48:19',3310491428,1),(52689114,425020627,15167643,443749,1,'2007-09-16 19:48:20',3310491428,1),(52689115,425021154,15167300,443749,1,'2007-09-16 19:48:20',3310491428,1),(52689118,425021101,15166931,443749,1,'2007-09-16 19:48:20',3310491428,1),(52689120,425019836,15165718,443749,1,'2007-09-16 19:48:21',3310491428,1),(52689141,425018386,15163741,443749,1,'2007-09-16 19:48:25',3310491428,1),(52689142,425016540,15160893,443749,1,'2007-09-16 19:48:25',3310491406,1),(52689145,425014932,15158837,443749,1,'2007-09-16 19:48:26',3310491406,1),(52689148,425014378,15158494,443749,1,'2007-09-16 19:48:26',3310491406,1),(52689150,425013798,15157413,443749,1,'2007-09-16 19:48:26',3310491406,1),(52689154,425013851,15156675,443749,1,'2007-09-16 19:48:26',3310491406,1),(52689156,425013534,15155726,443749,1,'2007-09-16 19:48:27',3310491406,1),(52689157,425012137,15153353,443749,1,'2007-09-16 19:48:27',3310491403,1),(52689160,425011135,15151903,443749,1,'2007-09-16 19:48:27',3310491403,1),(52689162,425009685,15150558,443749,1,'2007-09-16 19:48:27',3310491403,1),(52689165,425012585,15146024,443749,1,'2007-09-16 19:48:27',3310491403,1),(52689167,425015749,15148159,443749,1,'2007-09-16 19:48:27',3310491406,1),(52689173,425016830,15148845,443749,1,'2007-09-16 19:48:28',3310491406,1),(52689178,425018755,15149187,443749,1,'2007-09-16 19:48:28',3310491406,1),(52689180,425018755,15149873,443749,1,'2007-09-16 19:48:28',3310491406,1),(52689184,425018175,15150927,443749,1,'2007-09-16 19:48:28',3310491406,1),(52689187,425017912,15151511,443749,1,'2007-09-16 19:48:29',3310491406,1),(52689189,425017723,15152078,443749,1,'2007-09-16 19:48:29',3310491406,1),(52689194,425017669,15152361,443749,1,'2007-09-16 19:48:30',3310491406,1),(52689197,425017459,15153281,443749,1,'2007-09-16 19:48:30',3310491406,1),(52689201,425018185,15154530,443749,1,'2007-09-16 19:48:30',3310491406,1),(52689204,425019112,15154974,443749,1,'2007-09-16 19:48:30',3310491406,1),(52689208,425019797,15155337,443749,1,'2007-09-16 19:48:31',3310491406,1),(52689210,425020264,15154598,443749,1,'2007-09-16 19:48:31',3310491406,1),(52689214,425021311,15155703,443749,1,'2007-09-16 19:48:32',3310491406,1),(52689217,425022784,15157932,443749,1,'2007-09-16 19:48:32',3310491406,1),(52689218,425023102,15158268,443749,1,'2007-09-16 19:48:33',3310491406,1),(52689226,425037665,15232304,454632,1,'2007-09-17 19:00:43',3310491430,1),(52689230,425040974,15233849,443749,1,'2007-09-16 19:48:35',3310491431,1),(52689232,425042629,15235393,443749,1,'2007-09-16 19:48:35',3310491431,1),(52689236,425043401,15237820,443749,1,'2007-09-16 19:48:35',3310491431,1),(52689239,425044394,15240798,443749,1,'2007-09-16 19:48:35',3310491431,1),(52689242,425044063,15242894,443749,1,'2007-09-16 19:48:36',3310491431,1),(52689243,425042739,15245431,443749,1,'2007-09-16 19:48:36',3310491431,1),(52689245,425042077,15248410,443749,1,'2007-09-16 19:48:36',3310491431,1),(52689248,425041636,15252491,443749,1,'2007-09-16 19:48:36',3310491431,1),(52689249,425042739,15256572,443749,1,'2007-09-16 19:48:36',3310491431,1),(52689251,425043070,15261647,443749,1,'2007-09-16 19:48:37',3310491431,1),(52689253,425041857,15262640,443749,1,'2007-09-16 19:48:37',3310491431,1),(52689255,425039981,15263963,443749,1,'2007-09-16 19:48:37',3310491430,1),(52689257,425040312,15267273,443749,1,'2007-09-16 19:48:37',3310491431,1),(52689259,425041195,15273671,443749,1,'2007-09-16 19:48:37',3310491437,1),(52689262,425041617,15274471,443749,1,'2007-09-16 19:48:38',3310491437,1),(52689263,425043901,15274558,443749,1,'2007-09-16 19:48:38',3310491437,1),(52689265,425045029,15274703,443749,1,'2007-09-16 19:48:38',3310491437,1),(52689267,425045405,15276351,443749,1,'2007-09-16 19:48:39',3310491437,1),(52689270,425046091,15278791,443749,1,'2007-09-16 19:48:39',3310491437,1),(52689273,425047386,15283396,443749,1,'2007-09-16 19:48:39',3310491437,1),(52689275,425048207,15288030,443749,1,'2007-09-16 19:48:40',3310491437,1),(52689278,425049358,15295168,443749,1,'2007-09-16 19:48:40',3310491437,1),(52689279,425047861,15297240,443749,1,'2007-09-16 19:48:40',3310491437,1),(52689280,425046019,15299888,443749,1,'2007-09-16 19:48:40',3310491437,1),(52689282,425046710,15304263,443749,1,'2007-09-16 19:48:41',3310491437,1),(52689285,425049933,15323029,443749,1,'2007-09-16 19:48:41',3310491437,1),(52689288,425051200,15326368,443749,1,'2007-09-16 19:48:41',3310491439,1),(52689290,425057187,15331894,443749,1,'2007-09-16 19:48:41',3310491439,1),(52689292,425058798,15336384,443749,1,'2007-09-16 19:48:41',3310491439,1),(52689294,425060640,15342486,443749,1,'2007-09-16 19:48:41',3310491439,1),(52689295,425062482,15345594,443749,1,'2007-09-16 19:48:41',3310491439,1),(52689303,425065015,15347321,443749,1,'2007-09-16 19:48:42',3310491439,1),(52689304,425065936,15351351,443749,1,'2007-09-16 19:48:42',3310491439,1),(52689308,425067548,15360216,443749,1,'2007-09-16 19:48:43',3310491450,1),(52689311,425068584,15365627,443749,1,'2007-09-16 19:48:43',3310491450,1),(52689316,425069160,15373686,443749,1,'2007-09-16 19:48:43',3310491450,1),(52689319,425070772,15382551,443749,1,'2007-09-16 19:48:44',3310491536,1),(52689321,425072959,15397632,443749,1,'2007-09-16 19:48:44',3310491536,1),(52689323,425074456,15405806,443749,1,'2007-09-16 19:48:44',3310491536,1),(52689326,425076183,15416859,443749,1,'2007-09-16 19:48:45',3310491536,1),(52689328,425077910,15423076,443749,1,'2007-09-16 19:48:45',3310491536,1),(52689330,425078831,15427681,443749,1,'2007-09-16 19:48:45',3310491536,1),(52689333,425080097,15432171,443749,1,'2007-09-16 19:48:45',3310491536,1),(52689336,425082285,15437467,443749,1,'2007-09-16 19:48:45',3310491538,1),(52689338,425083090,15441381,443749,1,'2007-09-16 19:48:46',3310491538,1),(52689340,425083321,15445065,443749,1,'2007-09-16 19:48:46',3310491538,1),(52689343,425082745,15449095,443749,1,'2007-09-16 19:48:46',3310491538,1),(52689345,425081248,15454045,443749,1,'2007-09-16 19:48:46',3310491538,1),(52689348,425079867,15459687,443749,1,'2007-09-16 19:48:46',3310491538,1),(52689350,425079291,15466709,443749,1,'2007-09-16 19:48:47',3310491538,1),(52689351,425081018,15472696,443749,1,'2007-09-16 19:48:47',3310491538,1),(52689353,425081363,15474883,443749,1,'2007-09-16 19:48:47',3310491538,1),(52689355,425077795,15479949,443749,1,'2007-09-16 19:48:47',3310491538,1),(52689358,425075377,15481100,443749,1,'2007-09-16 19:48:48',3310491538,1),(52689359,425072499,15481906,443749,1,'2007-09-16 19:48:48',3310491538,1),(52689361,425070081,15485015,443749,1,'2007-09-16 19:48:48',3310491538,1),(52689363,425070081,15486857,443749,1,'2007-09-16 19:48:48',3310491538,1),(52689365,425067893,15489159,443749,1,'2007-09-16 19:48:49',3310491538,1),(52689366,425065936,15489620,443749,1,'2007-09-16 19:48:49',3310491527,1),(52689367,425065130,15491692,443749,1,'2007-09-16 19:48:49',3310491533,1),(52689371,425062943,15495376,443749,1,'2007-09-16 19:48:49',3310491533,1),(52689372,425058568,15499981,443749,1,'2007-09-16 19:48:49',3310491533,1),(52689375,425052006,15505508,443749,1,'2007-09-16 19:48:50',3310491533,1),(52689377,425046480,15512415,443749,1,'2007-09-16 19:48:50',3310491533,1),(52689379,425042565,15512646,443749,1,'2007-09-16 19:48:50',3310491533,1),(52689382,425044177,15508040,443749,1,'2007-09-16 19:48:51',3310491533,1),(52689385,425048667,15499060,443749,1,'2007-09-16 19:48:51',3310491533,1),(52689387,425054769,15488123,443749,1,'2007-09-16 19:48:51',3310491527,1),(52689390,425056841,15483863,443749,1,'2007-09-16 19:48:52',3310491527,1),(52689392,425059719,15480064,443749,1,'2007-09-16 19:48:52',3310491527,1),(52689394,425061677,15475574,443749,1,'2007-09-16 19:48:52',3310491527,1),(52689396,425063403,15464522,443749,1,'2007-09-16 19:48:53',3310491527,1),(52689398,425064555,15457844,443749,1,'2007-09-16 19:48:53',3310491527,1),(52689402,425063995,15453799,443749,1,'2007-09-16 19:48:53',3310491527,1),(52689405,425062995,15447400,443749,1,'2007-09-16 19:48:53',3310491527,1),(52689406,425061895,15439901,443749,1,'2007-09-16 19:48:54',3310491527,1),(52689409,425060995,15435102,443749,1,'2007-09-16 19:48:54',3310491525,1),(52689410,425057696,15423804,443749,1,'2007-09-16 19:48:54',3310491525,1),(52689412,425056696,15414505,443749,1,'2007-09-16 19:48:54',3310491525,1),(52689414,425060796,15412006,443749,1,'2007-09-16 19:48:54',3310491525,1),(52689416,425058796,15400308,443749,1,'2007-09-16 19:48:54',3310491525,1),(52689419,425055296,15385310,443749,1,'2007-09-16 19:48:54',3310491525,1),(52689420,425048797,15383710,443749,1,'2007-09-16 19:48:55',3310491525,1),(52689423,425045598,15383710,443749,1,'2007-09-16 19:48:55',3310491525,1),(52689425,425040499,15383710,443749,1,'2007-09-16 19:48:55',3310491525,1),(52689427,425033942,15382518,443749,1,'2007-09-16 19:48:55',3310491524,1),(52689429,425033810,15378139,443749,1,'2007-09-16 19:48:55',3310491438,1),(52689432,425030492,15362482,443749,1,'2007-09-16 19:48:56',3310491438,1),(52689433,425029696,15356378,443749,1,'2007-09-16 19:48:56',3310491438,1),(52689436,425027308,15348019,443749,1,'2007-09-16 19:48:56',3310491438,1),(52689437,425026512,15340323,443749,1,'2007-09-16 19:48:56',3310491438,1),(52689440,425022266,15337271,443749,1,'2007-09-16 19:48:56',3310491438,1),(52689443,425018948,15332892,443749,1,'2007-09-16 19:48:57',3310491438,1),(52689445,425017091,15331300,443749,1,'2007-09-16 19:48:57',3310491438,1),(52689447,425016693,15333158,443749,1,'2007-09-16 19:48:58',3310491438,1),(52689450,425018020,15335679,443749,1,'2007-09-16 19:48:58',3310491438,1),(52689451,425019877,15338731,443749,1,'2007-09-16 19:48:58',3310491438,1),(52689452,425021337,15340986,443749,1,'2007-09-16 19:48:58',3310491438,1),(52689455,425021469,15342180,443749,1,'2007-09-16 19:48:58',3310491438,1),(52689456,425020143,15342977,443749,1,'2007-09-16 19:48:59',3310491438,1),(52689459,425018683,15341252,443749,1,'2007-09-16 19:48:59',3310491438,1),(52689461,425016427,15339527,443749,1,'2007-09-16 19:48:59',3310491438,1),(52689464,425012977,15336740,443749,1,'2007-09-16 19:48:59',3310491438,1),(52689484,425011252,15334219,443749,1,'2007-09-16 19:49:03',3310491435,1),(52689486,425010589,15330902,443749,1,'2007-09-16 19:49:03',3310491435,1),(52689488,425008997,15330504,443749,1,'2007-09-16 19:49:03',3310491435,1),(52689491,425009129,15334086,443749,1,'2007-09-16 19:49:03',3310491435,1),(52689493,425009793,15337669,443749,1,'2007-09-16 19:49:03',3310491435,1),(52689494,425012049,15341782,443749,1,'2007-09-16 19:49:04',3310491435,1),(52689496,425014835,15344303,443749,1,'2007-09-16 19:49:04',3310491438,1),(52689497,425016029,15345630,443749,1,'2007-09-16 19:49:04',3310491438,1),(52689499,425017621,15347488,443749,1,'2007-09-16 19:49:04',3310491438,1),(52689501,425017754,15348550,443749,1,'2007-09-16 19:49:04',3310491438,1),(52689503,425015764,15348682,443749,1,'2007-09-16 19:49:05',3310491438,1),(52689505,425014039,15346825,443749,1,'2007-09-16 19:49:05',3310491438,1),(52689508,425011385,15343773,443749,1,'2007-09-16 19:49:05',3310491435,1),(52689513,425008731,15341384,443749,1,'2007-09-16 19:49:06',3310491435,1),(52689516,425005812,15338731,443749,1,'2007-09-16 19:49:06',3310491435,1),(52689518,425003822,15335811,443749,1,'2007-09-16 19:49:06',3310491435,1),(52689522,425002760,15331433,443749,1,'2007-09-16 19:49:06',3310491435,1),(52689524,425002628,15327319,443749,1,'2007-09-16 19:49:07',3310491435,1),(52689527,425003954,15323339,443749,1,'2007-09-16 19:49:07',3310491433,1),(52689528,425005016,15319491,443749,1,'2007-09-16 19:49:07',3310491433,1),(52689532,425006741,15315643,443749,1,'2007-09-16 19:49:08',3310491433,1),(52689534,425005281,15313387,443749,1,'2007-09-16 19:49:08',3310491433,1),(52689537,425003158,15314183,443749,1,'2007-09-16 19:49:08',3310491433,1),(52689538,424995064,15310070,443749,1,'2007-09-16 19:49:08',3310491433,1),(52689540,424993339,15308345,443749,1,'2007-09-16 19:49:08',3310491433,1),(52689545,424992941,15305956,443749,1,'2007-09-16 19:49:08',3310491433,1),(52689549,424994799,15305426,443749,1,'2007-09-16 19:49:09',3310491433,1),(52689552,424999841,15306752,443749,1,'2007-09-16 19:49:09',3310491433,1),(52689553,425004087,15306620,443749,1,'2007-09-16 19:49:09',3310491433,1),(52689556,425006741,15304629,443749,1,'2007-09-16 19:49:10',3310491433,1),(52689558,425007006,15300649,443749,1,'2007-09-16 19:49:10',3310491433,1),(52689560,425004353,15298791,443749,1,'2007-09-16 19:49:10',3310491433,1),(52689562,425002097,15295076,443749,1,'2007-09-16 19:49:10',3310491433,1),(52689565,424997573,15288284,443749,1,'2007-09-16 19:49:11',3310491433,1),(52689567,425001035,15288309,443749,1,'2007-09-16 19:49:11',3310491433,1),(52689570,425012304,15281223,443749,1,'2007-09-16 19:49:11',3310491433,1),(52689572,425016221,15279821,443749,1,'2007-09-16 19:49:11',3310491436,1),(52689573,425017871,15280935,443749,1,'2007-09-16 19:49:11',3310491436,1),(52689576,425020091,15283542,443749,1,'2007-09-16 19:49:12',3310491436,1),(52689579,425021538,15283692,443749,1,'2007-09-16 19:49:12',3310491436,1),(52689580,425021850,15282511,443749,1,'2007-09-16 19:49:12',3310491436,1),(52689583,425020275,15279949,443749,1,'2007-09-16 19:49:13',3310491436,1),(52689584,425017754,15278092,443749,1,'2007-09-16 19:49:13',3310491436,1),(52689585,425014304,15275040,443749,1,'2007-09-16 19:49:13',3310491436,1),(52689586,425010456,15269732,443749,1,'2007-09-16 19:49:13',3310491427,1),(52689589,425007935,15264027,443749,1,'2007-09-16 19:49:13',3310491427,1),(52689591,425004353,15255136,443749,1,'2007-09-16 19:49:13',3310491427,1),(52689593,425006476,15255004,443749,1,'2007-09-16 19:49:13',3310491427,1),(52689594,425009793,15259117,443749,1,'2007-09-16 19:49:13',3310491427,1),(52689596,425012181,15262434,443749,1,'2007-09-16 19:49:13',3310491427,1),(52689600,425015100,15263098,443749,1,'2007-09-16 19:49:14',3310491430,1),(52689603,425019479,15267344,443749,1,'2007-09-16 19:49:14',3310491430,1),(52689604,425020408,15266150,443749,1,'2007-09-16 19:49:14',3310491430,1),(52689607,425016693,15261903,443749,1,'2007-09-16 19:49:14',3310491430,1),(52689608,425015764,15259250,443749,1,'2007-09-16 19:49:14',3310491430,1),(52689609,425013375,15254738,443749,1,'2007-09-16 19:49:14',3310491430,1),(52689610,425010854,15250625,443749,1,'2007-09-16 19:49:15',3310491427,1),(52689612,425007670,15245715,443749,1,'2007-09-16 19:49:15',3310491427,1),(52689613,425003026,15238550,443749,1,'2007-09-16 19:49:15',3310491427,1),(52689615,425001831,15236693,443749,1,'2007-09-16 19:49:15',3310491427,1),(52689617,424997983,15233906,443749,1,'2007-09-16 19:49:15',3310491427,1),(52689618,424995064,15232314,443749,1,'2007-09-16 19:49:15',3310491427,1),(52689619,424993074,15235896,443749,1,'2007-09-16 19:49:15',3310491427,1),(52689621,424992676,15239081,443749,1,'2007-09-16 19:49:15',3310491427,1),(52689624,424990155,15239479,443749,1,'2007-09-16 19:49:16',3310491427,1),(52689627,424986307,15235366,443749,1,'2007-09-16 19:49:16',3310491427,1),(52689629,424981795,15230589,443749,1,'2007-09-16 19:49:16',3310491426,1),(52689631,424980601,15227802,443749,1,'2007-09-16 19:49:17',3310491426,1),(52689635,424979805,15215064,443749,1,'2007-09-16 19:49:17',3310491424,1),(52689639,424976222,15214268,443749,1,'2007-09-16 19:49:17',3310491424,1),(52689643,424969986,15214003,443749,1,'2007-09-16 19:49:18',3310491424,1),(52689647,424975559,15208032,443749,1,'2007-09-16 19:49:18',3310491424,1),(52689650,424980070,15204714,443749,1,'2007-09-16 19:49:18',3310491424,1),(52689653,424985511,15199540,443749,1,'2007-09-16 19:49:18',3310491425,1),(52689656,424987236,15196488,443749,1,'2007-09-16 19:49:18',3310491425,1),(52689659,424990022,15191578,443749,1,'2007-09-16 19:49:19',3310491425,1),(52689661,424991216,15190384,443749,1,'2007-09-16 19:49:19',3310491425,1),(52689663,424992012,15191578,443749,1,'2007-09-16 19:49:19',3310491425,1),(52689665,424991084,15195161,443749,1,'2007-09-16 19:49:19',3310491425,1),(52689666,424990420,15197815,443749,1,'2007-09-16 19:49:19',3310491425,1),(52689670,424988961,15200866,443749,1,'2007-09-16 19:49:20',3310491425,1),(52689673,424988828,15203388,443749,1,'2007-09-16 19:49:20',3310491425,1),(52689676,424989226,15204847,443749,1,'2007-09-16 19:49:20',3310491425,1),(52689679,424992145,15204582,443749,1,'2007-09-16 19:49:20',3310491425,1),(52689681,424994135,15203122,443749,1,'2007-09-16 19:49:20',3310491425,1),(52689684,424995993,15202061,443749,1,'2007-09-16 19:49:20',3310491425,1),(52689687,424998780,15198611,443749,1,'2007-09-16 19:49:21',3310491425,1),(52689689,425000903,15197549,443749,1,'2007-09-16 19:49:21',3310491425,1),(52689692,425002628,15198743,443749,1,'2007-09-16 19:49:21',3310491425,1),(52689696,425004751,15202591,443749,1,'2007-09-16 19:49:21',3310491425,1),(52689699,425005812,15204714,443749,1,'2007-09-16 19:49:22',3310491425,1),(52689701,425008599,15208297,443749,1,'2007-09-16 19:49:22',3310491425,1),(52689705,425015366,15214401,443749,1,'2007-09-16 19:49:22',3310491428,1),(52689707,425019214,15213870,443749,1,'2007-09-16 19:49:22',3310491428,1),(52689709,425021469,15211084,443749,1,'2007-09-16 19:49:23',3310491428,1),(52689713,425022796,15210420,443749,1,'2007-09-16 19:49:23',3310491428,1),(52689714,425023991,15210951,443749,1,'2007-09-16 19:49:23',3310491428,1),(52689718,425025450,15213074,443749,1,'2007-09-16 19:49:23',3310491428,1),(52689720,425028104,15215993,443749,1,'2007-09-16 19:49:23',3310491428,1),(52689723,425030227,15218249,443749,1,'2007-09-16 19:49:23',3310491430,1),(52689724,425028900,15220239,443749,1,'2007-09-16 19:49:23',3310491430,1),(52689728,425027573,15223556,443749,1,'2007-09-16 19:49:23',3310491430,1),(52689731,425028237,15226077,443749,1,'2007-09-16 19:49:24',3310491430,1),(52689733,425031023,15228598,443749,1,'2007-09-16 19:49:24',3310491430,1),(52689737,425011137,15280996,443749,1,'2007-09-16 19:49:24',3310491433,1),(52689739,425009262,15279344,443749,1,'2007-09-16 19:49:24',3310491433,1),(52689742,425007791,15280275,443749,1,'2007-09-16 19:49:24',3310491433,1),(52689743,425006510,15285956,443749,1,'2007-09-16 19:49:24',3310491433,1),(52689747,425005424,15288992,443749,1,'2007-09-16 19:49:24',3310491433,1),(52689748,424999277,15287838,443749,1,'2007-09-16 19:49:24',3310491433,1),(52689751,424997160,15289716,443749,1,'2007-09-16 19:49:24',3310491433,1),(52689755,424998796,15291422,443749,1,'2007-09-16 19:49:24',3310491433,1),(52733171,424953208,15227957,443749,1,'2007-09-16 22:05:47',3310491255,1),(52733173,424959066,15226258,443749,1,'2007-09-16 22:05:48',3310491426,1),(52733177,424963518,15225145,443749,1,'2007-09-16 22:05:48',3310491426,1),(52733181,424966329,15224267,443749,1,'2007-09-16 22:05:48',3310491426,1),(52733186,424969832,15223658,443749,1,'2007-09-16 22:05:49',3310491426,1),(52733193,424972035,15223001,443749,1,'2007-09-16 22:05:50',3310491426,1),(52733201,424973862,15222767,443749,1,'2007-09-16 22:05:52',3310491426,1),(52733204,424975409,15223423,443749,1,'2007-09-16 22:05:52',3310491426,1),(52733206,424975971,15224688,443749,1,'2007-09-16 22:05:52',3310491426,1),(52733209,424978126,15228297,443749,1,'2007-09-16 22:05:53',3310491426,1),(52733212,424981922,15232842,443749,1,'2007-09-16 22:05:54',3310491426,1),(52733215,424984125,15235420,443749,1,'2007-09-16 22:05:55',3310491426,1),(52733218,424985156,15235935,443749,1,'2007-09-16 22:05:55',3310491427,1),(52733223,424986334,15235955,443749,1,'2007-09-16 22:05:56',3310491427,1),(52743859,424949653,15048387,443749,1,'2007-09-16 22:31:34',3310491223,1),(52743862,424950863,15053996,443749,1,'2007-09-16 22:31:34',3310491229,1),(52743866,424956480,15063073,443749,1,'2007-09-16 22:31:34',3310491229,1),(52743871,424958941,15067136,443749,1,'2007-09-16 22:31:34',3310491400,1),(52743874,424964074,15074091,443749,1,'2007-09-16 22:31:34',3310491400,1),(52743875,424967198,15078852,443749,1,'2007-09-16 22:31:35',3310491400,1),(52743878,424969875,15086141,443749,1,'2007-09-16 22:31:35',3310491400,1),(52743880,424974487,15097299,443749,1,'2007-09-16 22:31:35',3310491400,1),(52743882,424977760,15106671,443749,1,'2007-09-16 22:31:35',3310491402,1),(52743884,424984008,15118126,443749,1,'2007-09-16 22:31:35',3310491402,1),(52743887,424987727,15129284,363778,1,'2007-12-19 18:35:06',3310491403,3),(52743889,424988322,15145350,443749,1,'2007-09-16 22:31:36',3310491403,1),(52743892,424986686,15172872,443749,1,'2007-09-16 22:31:36',3310491425,1),(52743895,424986686,15186112,443749,1,'2007-09-16 22:31:36',3310491425,1),(52743896,424972506,15221627,443749,1,'2007-09-16 22:31:36',3310491426,1),(52743899,424979810,15223060,443749,1,'2007-09-16 22:31:37',3310491426,1),(52743900,424950119,15229029,443749,1,'2007-09-16 22:31:37',3310491255,1),(52743901,424955437,15230801,443749,1,'2007-09-16 22:31:37',3310491255,1),(52743902,424957506,15235825,443749,1,'2007-09-16 22:31:37',3310491255,1),(52743904,424956028,15241143,443749,1,'2007-09-16 22:31:37',3310491255,1),(52743907,424952482,15244393,443749,1,'2007-09-16 22:31:38',3310491255,1),(52743909,424957506,15247053,443749,1,'2007-09-16 22:31:38',3310491255,1),(52743910,424962824,15246462,443749,1,'2007-09-16 22:31:38',3310491426,1),(52743913,424966665,15243802,443749,1,'2007-09-16 22:31:38',3310491426,1),(52743916,424969029,15239961,443749,1,'2007-09-16 22:31:39',3310491426,1),(52743919,424971688,15233165,443749,1,'2007-09-16 22:31:40',3310491426,1),(52743921,424976416,15229915,443749,1,'2007-09-16 22:31:40',3310491426,1),(52743924,424982326,15236415,443749,1,'2007-09-16 22:31:40',3310491426,1),(52743925,424988235,15240257,443749,1,'2007-09-16 22:31:41',3310491427,1),(52743927,424993258,15240848,443749,1,'2007-09-16 22:31:41',3310491427,1),(52743928,424995160,15237562,443749,1,'2007-09-16 22:31:41',3310491427,1),(52743930,424996491,15238046,443749,1,'2007-09-16 22:31:41',3310491427,1),(52743933,424999033,15241798,443749,1,'2007-09-16 22:31:42',3310491427,1),(52743936,425002058,15248213,443749,1,'2007-09-16 22:31:42',3310491427,1),(52743937,425002543,15250512,443749,1,'2007-09-16 22:31:42',3310491427,1),(52743940,425001937,15253175,443749,1,'2007-09-16 22:31:42',3310491427,1),(52743941,425001695,15260074,443749,1,'2007-09-16 22:31:42',3310491427,1),(52743943,425003390,15268061,443749,1,'2007-09-16 22:31:43',3310491427,1),(52743946,425002179,15275928,443749,1,'2007-09-16 22:31:43',3310491433,1),(52743947,424999880,15282222,443749,1,'2007-09-16 22:31:43',3310491433,1),(52743950,424997459,15286458,443749,1,'2007-09-16 22:31:44',3310491433,1),(52743951,424996128,15288878,443749,1,'2007-09-16 22:31:44',3310491433,1),(52743954,424996370,15291783,443749,1,'2007-09-16 22:31:44',3310491433,1),(52743955,424998670,15294688,443749,1,'2007-09-16 22:31:44',3310491433,1),(52743958,424997701,15297229,443749,1,'2007-09-16 22:31:44',3310491433,1),(52743959,424994434,15301828,443749,1,'2007-09-16 22:31:44',3310491433,1),(52743961,424991650,15303160,443749,1,'2007-09-16 22:31:44',3310491433,1),(52743964,424988503,15303402,443749,1,'2007-09-16 22:31:45',3310491433,1),(52743966,424985962,15302191,443749,1,'2007-09-16 22:31:45',3310491433,1),(52743967,424984630,15298924,443749,1,'2007-09-16 22:31:45',3310491432,1),(52743969,424984509,15295293,443749,1,'2007-09-16 22:31:45',3310491432,1),(52743971,424986204,15291662,443749,1,'2007-09-16 22:31:46',3310491433,1),(52743972,424989472,15288273,443749,1,'2007-09-16 22:31:46',3310491433,1),(52743973,424990440,15286700,443749,1,'2007-09-16 22:31:46',3310491433,1),(52743976,424991408,15280285,443749,1,'2007-09-16 22:31:46',3310491433,1),(52743980,424991287,15275928,443749,1,'2007-09-16 22:31:47',3310491433,1),(52743981,424987535,15269030,443749,1,'2007-09-16 22:31:47',3310491427,1),(52743984,424983299,15266488,443749,1,'2007-09-16 22:31:47',3310491426,1),(52743986,424981605,15266488,443749,1,'2007-09-16 22:31:47',3310491426,1),(52743987,424977611,15266246,443749,1,'2007-09-16 22:31:48',3310491426,1),(52743988,424973375,15268667,443749,1,'2007-09-16 22:31:48',3310491426,1),(52743991,424971317,15272539,443749,1,'2007-09-16 22:31:48',3310491432,1),(52743992,424975190,15276291,443749,1,'2007-09-16 22:31:48',3310491432,1),(52743995,424977369,15283795,443749,1,'2007-09-16 22:31:48',3310491432,1),(52743997,424980152,15287789,443749,1,'2007-09-16 22:31:49',3310491432,1),(52744001,424983662,15288152,443749,1,'2007-09-16 22:31:49',3310491432,1),(52744002,424983662,15291541,443749,1,'2007-09-16 22:31:49',3310491432,1),(52744005,424982331,15300013,443749,1,'2007-09-16 22:31:49',3310491432,1),(52744007,424982452,15302312,443749,1,'2007-09-16 22:31:50',3310491432,1),(52744009,424987051,15306911,443749,1,'2007-09-16 22:31:50',3310491433,1),(52744012,424980260,15317902,443749,1,'2007-09-16 22:31:50',3310491432,1),(52744014,424970983,15339592,443749,1,'2007-09-16 22:31:51',3310491434,1),(52744016,424964708,15351461,443749,1,'2007-09-16 22:31:51',3310491434,1),(52744019,424964086,15357933,443749,1,'2007-09-16 22:31:51',3310491434,1),(52744021,424963496,15365594,443749,1,'2007-09-16 22:31:51',3310491434,1),(52744022,424957996,15377184,443749,1,'2007-09-16 22:31:52',3310491434,1),(52744025,424950256,15384624,443749,1,'2007-09-16 22:31:52',3310491349,1),(52744028,424945172,15388926,443749,1,'2007-09-16 22:31:52',3310491349,1),(52744030,424943608,15382669,443749,1,'2007-09-16 22:31:52',3310491349,1),(52744032,424939697,15390490,443749,1,'2007-09-16 22:31:52',3310491349,1),(52744035,424934614,15397920,443749,1,'2007-09-16 22:31:53',3310491349,1),(52744036,424928879,15407211,443749,1,'2007-09-16 22:31:53',3310491348,1),(52744038,424925516,15407211,443749,1,'2007-09-16 22:31:54',3310491348,1),(52744042,424923113,15409454,443749,1,'2007-09-16 22:31:54',3310491348,1),(52744043,424921832,15412177,443749,1,'2007-09-16 22:31:54',3310491348,1),(52744046,424921031,15415380,443749,1,'2007-09-16 22:31:54',3310491348,1),(52744049,424919269,15416021,443749,1,'2007-09-16 22:31:54',3310491348,1),(52744050,424916546,15415861,443749,1,'2007-09-16 22:31:54',3310491348,1),(52744052,424915425,15417783,443749,1,'2007-09-16 22:31:55',3310491348,1),(52744053,424915425,15420986,443749,1,'2007-09-16 22:31:55',3310491348,1),(52744054,424915905,15423229,443749,1,'2007-09-16 22:31:55',3310491348,1),(52744056,424914143,15427393,443749,1,'2007-09-16 22:31:55',3310491348,1),(52744057,424910459,15427233,443749,1,'2007-09-16 22:31:55',3310491348,1),(52744059,424909658,15431718,443749,1,'2007-09-16 22:31:56',3310491348,1),(52744062,424903251,15437164,443749,1,'2007-09-16 22:31:56',3310491350,1),(52744064,424902130,15443571,443749,1,'2007-09-16 22:31:56',3310491347,1),(52744066,424897806,15448056,443749,1,'2007-09-16 22:31:56',3310491347,1),(52744067,424893000,15449337,443749,1,'2007-09-16 22:31:56',3310491347,1),(52744070,424891238,15453502,443749,1,'2007-09-16 22:31:56',3310491347,1),(52744072,424886914,15453662,443749,1,'2007-09-16 22:31:57',3310491347,1),(52744073,424885792,15453342,443749,1,'2007-09-16 22:31:57',3310491347,1),(52744074,424885792,15455905,443749,1,'2007-09-16 22:31:57',3310491347,1),(52744075,424883550,15461190,443749,1,'2007-09-16 22:31:57',3310491347,1),(52744078,424880507,15462632,443749,1,'2007-09-16 22:31:57',3310491347,1),(52744081,424879225,15460550,443749,1,'2007-09-16 22:31:58',3310491347,1),(52744082,424878264,15457987,443749,1,'2007-09-16 22:31:58',3310491347,1),(52744084,424877624,15457186,443749,1,'2007-09-16 22:31:58',3310491347,1),(52744086,424873139,15459222,443749,1,'2007-09-16 22:31:58',3310491346,1),(52744087,424861791,15470570,443749,1,'2007-09-16 22:31:58',3310491346,1),(52744089,424859023,15474445,443749,1,'2007-09-16 22:31:59',3310491346,1),(52744091,424861237,15476659,443749,1,'2007-09-16 22:31:59',3310491346,1),(52744093,424852380,15483579,443749,1,'2007-09-16 22:31:59',3310491346,1),(52744094,424845737,15481088,443749,1,'2007-09-16 22:31:59',3310491335,1),(52744096,424840478,15478043,443749,1,'2007-09-16 22:31:59',3310491335,1),(52744097,424829961,15462820,443749,1,'2007-09-16 22:31:59',3310491335,1),(52744099,424821380,15453133,443749,1,'2007-09-16 22:32:00',3310491335,1),(52744100,424814461,15456454,443749,1,'2007-09-16 22:32:00',3310491334,1),(52744101,424805327,15454240,443749,1,'2007-09-16 22:32:00',3310491334,1),(52744102,424797854,15443446,443749,1,'2007-09-16 22:32:00',3310491334,1),(52744104,424806434,15437910,443749,1,'2007-09-16 22:32:00',3310491334,1),(52744106,424811970,15433205,443749,1,'2007-09-16 22:32:00',3310491332,1),(52744108,424814461,15429606,443749,1,'2007-09-16 22:32:01',3310491332,1),(52744110,424810309,15421580,443749,1,'2007-09-16 22:32:01',3310491332,1),(52744111,424825255,15408294,443749,1,'2007-09-16 22:32:01',3310491333,1),(52744114,424823041,15400821,443749,1,'2007-09-16 22:32:01',3310491333,1),(52744116,424817505,15394732,443749,1,'2007-09-16 22:32:01',3310491332,1),(52744118,424813631,15383661,443749,1,'2007-09-16 22:32:01',3310491332,1),(52744120,424813907,15363179,443749,1,'2007-09-16 22:32:01',3310491246,1),(52744122,424817229,15360134,443749,1,'2007-09-16 22:32:01',3310491246,1),(52744124,424819443,15352661,443749,1,'2007-09-16 22:32:02',3310491246,1),(52744126,424816675,15340759,443749,1,'2007-09-16 22:32:02',3310491246,1),(52744128,424815568,15335777,443749,1,'2007-09-16 22:32:02',3310491246,1),(52744130,424810032,15321661,443749,1,'2007-09-16 22:32:02',3310491244,1),(52744133,424808372,15297305,443749,1,'2007-09-16 22:32:02',3310491244,1),(52744134,424809202,15278760,443749,1,'2007-09-16 22:32:03',3310491244,1),(52744136,424809202,15261877,443749,1,'2007-09-16 22:32:03',3310491238,1),(52744138,424808095,15252466,443749,1,'2007-09-16 22:32:03',3310491238,1),(52744141,424807541,15232261,443749,1,'2007-09-16 22:32:03',3310491238,1),(52744144,424807541,15214824,443749,1,'2007-09-16 22:32:03',3310491236,1),(52744147,424803390,15212609,443749,1,'2007-09-16 22:32:04',3310491236,1),(52744149,424796470,15231154,443749,1,'2007-09-16 22:32:04',3310491238,1),(52744152,424792872,15232814,443749,1,'2007-09-16 22:32:04',3310491238,1),(52744155,424785122,15225895,443749,1,'2007-09-16 22:32:04',3310491235,1),(52744158,424780140,15214270,443749,1,'2007-09-16 22:32:04',3310491233,1),(52744159,424782354,15202368,443749,1,'2007-09-16 22:32:05',3310491233,1),(52744161,424786229,15196556,443749,1,'2007-09-16 22:32:05',3310491233,1),(52744163,424793425,15187422,443749,1,'2007-09-16 22:32:05',3310491236,1),(52744165,424796470,15180779,443749,1,'2007-09-16 22:32:05',3310491236,1),(52744166,424795916,15180503,443749,1,'2007-09-16 22:32:05',3310491236,1),(52744172,424799791,15172753,557925,1,'2008-01-06 22:29:13',3310491236,2),(52744174,424799791,15169985,443749,1,'2007-09-16 22:32:06',3310491236,1),(52744177,424801175,15167217,557925,1,'2008-01-06 22:29:13',3310491236,3),(52744180,424802006,15165280,443749,1,'2007-09-16 22:32:06',3310491236,1),(52744181,424802006,15165003,443749,1,'2007-09-16 22:32:07',3310491236,1),(52744184,424801729,15164449,443749,1,'2007-09-16 22:32:07',3310491236,1),(52744187,424802282,15162789,443749,1,'2007-09-16 22:32:07',3310491236,1),(52744189,424793425,15165833,443749,1,'2007-09-16 22:32:07',3310491236,1),(52744190,424782077,15154485,443749,1,'2007-09-16 22:32:07',3310491211,1),(52744193,424777926,15147842,443749,1,'2007-09-16 22:32:08',3310491211,1),(52744196,424778202,15145351,443749,1,'2007-09-16 22:32:08',3310491211,1),(52744198,424779586,15140369,443749,1,'2007-09-16 22:32:08',3310491211,1),(52744201,424781524,15136771,443749,1,'2007-09-16 22:32:08',3310491211,1),(52744202,424782908,15139539,443749,1,'2007-09-16 22:32:09',3310491211,1),(52744205,424787708,15153574,443749,1,'2007-09-16 22:32:09',3310491211,1),(52744206,424789550,15157807,443749,1,'2007-09-16 22:32:09',3310491211,1),(52744209,424796193,15150057,443749,1,'2007-09-16 22:32:09',3310491214,1),(52744212,424799515,15145351,443749,1,'2007-09-16 22:32:09',3310491214,1),(52744213,424802783,15142154,443749,1,'2007-09-16 22:32:09',3310491214,1),(52744214,424803358,15136020,443749,1,'2007-09-16 22:32:09',3310491214,1),(52744218,424803166,15123369,443749,1,'2007-09-16 22:32:09',3310491214,1),(52744219,424803166,15119344,443749,1,'2007-09-16 22:32:10',3310491214,1),(52744222,424800675,15117810,443749,1,'2007-09-16 22:32:10',3310491214,1),(52744223,424798566,15118960,443749,1,'2007-09-16 22:32:10',3310491214,1),(52744227,424798566,15119536,443749,1,'2007-09-16 22:32:10',3310491214,1),(52744228,424799525,15125286,443749,1,'2007-09-16 22:32:10',3310491214,1),(52744231,424797608,15128353,443749,1,'2007-09-16 22:32:10',3310491214,1),(52744232,424794541,15129311,443749,1,'2007-09-16 22:32:11',3310491214,1),(52744236,424790707,15125286,443749,1,'2007-09-16 22:32:11',3310491211,1),(52744237,424790707,15122411,443749,1,'2007-09-16 22:32:11',3310491211,1),(52744238,424796458,15111868,443749,1,'2007-09-16 22:32:11',3310491214,1),(52744240,424798758,15107651,443749,1,'2007-09-16 22:32:11',3310491214,1),(52744241,424796074,15103434,443749,1,'2007-09-16 22:32:11',3310491212,1),(52744245,424800100,15104009,443749,1,'2007-09-16 22:32:11',3310491212,1),(52744246,424801250,15108418,443749,1,'2007-09-16 22:32:12',3310491214,1),(52744249,424803933,15113018,443749,1,'2007-09-16 22:32:12',3310491214,1),(52744250,424805658,15110718,443749,1,'2007-09-16 22:32:12',3310491214,1),(52744253,424804508,15105735,443749,1,'2007-09-16 22:32:12',3310491212,1),(52744254,424801058,15097492,443749,1,'2007-09-16 22:32:12',3310491212,1),(52744257,424799141,15092892,443749,1,'2007-09-16 22:32:12',3310491212,1),(52744259,424800483,15085416,443749,1,'2007-09-16 22:32:12',3310491212,1),(52744260,424802783,15084075,443749,1,'2007-09-16 22:32:12',3310491212,1),(52744262,424803550,15083500,443749,1,'2007-09-16 22:32:13',3310491212,1),(52744264,424799716,15078899,443749,1,'2007-09-16 22:32:13',3310491212,1),(52744265,424799141,15070082,443749,1,'2007-09-16 22:32:13',3310491212,1),(52744268,424799525,15055897,443749,1,'2007-09-16 22:32:13',3310491212,1),(52744270,424798374,15046505,443749,1,'2007-09-16 22:32:13',3310491206,1),(52744272,424795691,15038263,443749,1,'2007-09-16 22:32:13',3310491206,1),(52744274,424792816,15030212,443749,1,'2007-09-16 22:32:14',3310491203,1),(52744277,424785697,15046543,443749,1,'2007-09-16 22:32:14',3310491203,1),(52744279,424783587,15054513,443749,1,'2007-09-16 22:32:14',3310491209,1),(52744281,424779367,15055920,443749,1,'2007-09-16 22:32:14',3310491209,1),(52744284,424781243,15023099,443749,1,'2007-09-16 22:32:14',3310491203,1),(52744286,424776320,15023099,443749,1,'2007-09-16 22:32:14',3310491203,1),(52744289,424776554,15041854,443749,1,'2007-09-16 22:32:15',3310491203,1),(52744292,424776554,15050294,443749,1,'2007-09-16 22:32:15',3310491203,1),(52744294,424773506,15053107,443749,1,'2007-09-16 22:32:15',3310491209,1),(52744296,424770459,15053810,443749,1,'2007-09-16 22:32:15',3310491209,1),(52744298,424760612,15038103,443749,1,'2007-09-16 22:32:15',3310491202,1),(52744301,424758034,15035524,443749,1,'2007-09-16 22:32:16',3310491202,1),(52744303,424755220,15030601,443749,1,'2007-09-16 22:32:16',3310491202,1),(52744306,424749828,15019113,443749,1,'2007-09-16 22:32:16',3310491202,1),(52744308,424744436,15022396,443749,1,'2007-09-16 22:32:16',3310491202,1),(52744309,424743498,15020754,443749,1,'2007-09-16 22:32:16',3310491202,1),(52744312,424745374,15010908,443749,1,'2007-09-16 22:32:17',3310491202,1),(52744313,424740920,15002234,443749,1,'2007-09-16 22:32:17',3310491202,1),(52744315,424735059,15003641,443749,1,'2007-09-16 22:32:17',3310491159,1),(52744318,424732011,15007860,443749,1,'2007-09-16 22:32:17',3310491159,1),(52744320,424720992,14995435,443749,1,'2007-09-16 22:32:17',3310491157,1),(52744323,424712318,14975274,443749,1,'2007-09-16 22:32:17',3310491157,1),(52744326,424710677,14957456,443749,1,'2007-09-16 22:32:17',3310491157,1),(52744329,424708802,14947610,443749,1,'2007-09-16 22:32:18',3310491156,1),(52744330,424711381,14942921,443749,1,'2007-09-16 22:32:18',3310491157,1),(52744333,424715132,14939405,443749,1,'2007-09-16 22:32:18',3310490815,1),(52744334,424717241,14938702,443749,1,'2007-09-16 22:32:18',3310490815,1),(52744337,424723102,14938467,443749,1,'2007-09-16 22:32:18',3310490815,1),(52744339,424735996,14928621,443749,1,'2007-09-16 22:32:19',3310490815,1),(52744342,424732763,14935220,443749,1,'2007-09-16 22:32:19',3310490815,1),(52744344,424738155,14923734,443749,1,'2007-09-16 22:32:19',3310490858,1),(52744346,424739684,14919274,443749,1,'2007-09-16 22:32:19',3310490858,1),(52744349,424742743,14915068,443749,1,'2007-09-16 22:32:20',3310490858,1),(52744350,424747713,14912647,443749,1,'2007-09-16 22:32:20',3310490858,1),(52744352,424751154,14911245,443749,1,'2007-09-16 22:32:20',3310490858,1),(52744356,424754467,14910353,443749,1,'2007-09-16 22:32:21',3310490858,1),(52744359,424759182,14909588,443749,1,'2007-09-16 22:32:21',3310490858,1),(52744360,424769887,14909206,443749,1,'2007-09-16 22:32:21',3310490859,1),(52744364,424772690,14908187,443749,1,'2007-09-16 22:32:21',3310490859,1),(52744365,424777278,14905383,443749,1,'2007-09-16 22:32:21',3310490859,1),(52744368,424781101,14903217,443749,1,'2007-09-16 22:32:22',3310490859,1),(52744370,424788875,14898119,443749,1,'2007-09-16 22:32:22',3310490859,1),(52744372,424792443,14896208,443749,1,'2007-09-16 22:32:22',3310490859,1),(52744375,424796776,14894806,443749,1,'2007-09-16 22:32:22',3310490862,1),(52744378,424802510,14895443,443749,1,'2007-09-16 22:32:22',3310490862,1),(52744379,424806588,14896463,443749,1,'2007-09-16 22:32:22',3310490862,1),(52744383,424813725,14898374,443749,1,'2007-09-16 22:32:23',3310490862,1),(52744385,424818312,14898502,443749,1,'2007-09-16 22:32:23',3310490862,1),(52744387,424822008,14900031,443749,1,'2007-09-16 22:32:23',3310490863,1),(52744390,424831566,14906148,443749,1,'2007-09-16 22:32:23',3310490863,1),(52744392,424836663,14909843,443749,1,'2007-09-16 22:32:23',3310490863,1),(52744394,424837937,14913029,443749,1,'2007-09-16 22:32:23',3310490863,1),(52744396,424838829,14918636,443749,1,'2007-09-16 22:32:24',3310490863,1),(52744399,424840996,14925008,443749,1,'2007-09-16 22:32:24',3310490863,1),(52744400,424844691,14932782,443749,1,'2007-09-16 22:32:24',3310490863,1),(52744402,424849492,14936883,443749,1,'2007-09-16 22:32:24',3310490874,1),(52744405,424851423,14939221,443749,1,'2007-09-16 22:32:25',3310490874,1),(52744409,424853660,14941966,443749,1,'2007-09-16 22:32:25',3310491216,1),(52744411,424859557,14948371,443749,1,'2007-09-16 22:32:25',3310491216,1),(52744413,424863522,14952641,443749,1,'2007-09-16 22:32:25',3310491216,1),(52744416,424867487,14955081,443749,1,'2007-09-16 22:32:25',3310491216,1),(52744418,424870842,14955793,443749,1,'2007-09-16 22:32:26',3310491216,1),(52744420,424874197,14955081,443749,1,'2007-09-16 22:32:26',3310491216,1),(52744423,424877044,14952946,443749,1,'2007-09-16 22:32:26',3310491217,1),(52744426,424878467,14951828,443749,1,'2007-09-16 22:32:26',3310491217,1),(52744429,424881314,14951828,443749,1,'2007-09-16 22:32:26',3310491217,1),(52744432,424884059,14953353,443749,1,'2007-09-16 22:32:27',3310491217,1),(52744434,424885279,14955996,443749,1,'2007-09-16 22:32:27',3310491217,1),(52744437,424885889,14957826,443749,1,'2007-09-16 22:32:27',3310491217,1),(52744439,424887515,14957826,443749,1,'2007-09-16 22:32:27',3310491217,1),(52744440,424891074,14961080,443749,1,'2007-09-16 22:32:27',3310491217,1),(52744443,424894734,14964333,443749,1,'2007-09-16 22:32:27',3310491217,1),(52744446,424898191,14966773,443749,1,'2007-09-16 22:32:28',3310491217,1),(52744447,424901037,14967790,443749,1,'2007-09-16 22:32:28',3310491217,1),(52744450,424906121,14966468,443749,1,'2007-09-16 22:32:28',3310491220,1),(52744452,424907948,14966527,592895,1,'2008-07-25 22:14:24',3310491220,2),(52744455,424911745,14967729,592895,1,'2008-07-25 22:14:24',3310491220,2),(52744457,424914656,14971162,592895,1,'2008-07-25 22:14:24',3310491220,2),(52744460,424922188,14985581,592895,1,'2008-07-25 22:14:24',3310491220,2),(52744462,424926871,14994164,592895,1,'2008-07-25 22:14:24',3310491220,2),(52744464,424934845,15005065,592895,1,'2008-07-25 22:14:24',3310491223,2),(52744468,424938045,15011100,443749,1,'2007-09-16 22:32:29',3310491223,1),(52744471,424943128,15024317,443749,1,'2007-09-16 22:32:29',3310491223,1),(52744473,424947601,15033976,443749,1,'2007-09-16 22:32:30',3310491223,1),(52744475,424949126,15041194,443749,1,'2007-09-16 22:32:30',3310491223,1),(52747815,424649743,14961857,443749,1,'2007-09-16 22:42:22',3310491152,1),(52747820,424656034,14972207,443749,1,'2007-09-16 22:42:22',3310491153,1),(52747826,424662016,14981371,443749,1,'2007-09-16 22:42:23',3310491153,1),(52747832,424670491,14997151,443749,1,'2007-09-16 22:42:23',3310491155,1),(52747838,424677212,15009132,443749,1,'2007-09-16 22:42:24',3310491155,1),(52747841,424686271,15028127,443749,1,'2007-09-16 22:42:24',3310491158,1),(52747846,424690654,15040108,443749,1,'2007-09-16 22:42:25',3310491158,1),(52747849,424693284,15043906,443749,1,'2007-09-16 22:42:25',3310491158,1),(52747852,424697083,15045075,443749,1,'2007-09-16 22:42:26',3310491158,1),(52747855,424697667,15049459,443749,1,'2007-09-16 22:42:26',3310491158,1),(52747857,424697959,15052965,443749,1,'2007-09-16 22:42:27',3310491164,1),(52747861,424700005,15064362,443749,1,'2007-09-16 22:42:27',3310491164,1),(52747863,424706142,15076927,443749,1,'2007-09-16 22:42:27',3310491164,1),(52747865,424706434,15085694,443749,1,'2007-09-16 22:42:28',3310491164,1),(52747867,424713447,15102351,443749,1,'2007-09-16 22:42:28',3310491165,1),(52747869,424718999,15119007,443749,1,'2007-09-16 22:42:28',3310491167,1),(52747872,424730396,15131280,443749,1,'2007-09-16 22:42:28',3310491167,1),(52747876,424737701,15145891,443749,1,'2007-09-16 22:42:29',3310491167,1),(52747878,424738286,15154366,443749,1,'2007-09-16 22:42:29',3310491210,1),(52747881,424738286,15163132,443749,1,'2007-09-16 22:42:29',3310491232,1),(52747884,424734487,15166639,443749,1,'2007-09-16 22:42:30',3310491189,1),(52747885,424726889,15160502,443749,1,'2007-09-16 22:42:30',3310491167,1),(52747888,424726597,15149398,443749,1,'2007-09-16 22:42:31',3310491167,1),(52747890,424721629,15147937,443749,1,'2007-09-16 22:42:31',3310491167,1),(52747893,424720753,15152320,443749,1,'2007-09-16 22:42:31',3310491167,1),(52747898,424720460,15158749,443749,1,'2007-09-16 22:42:32',3310491167,1),(52747901,424717830,15163717,443749,1,'2007-09-16 22:42:32',3310491189,1),(52748785,424716077,15172483,443749,1,'2007-09-16 22:45:33',3310491189,1),(52748790,424717830,15181250,443749,1,'2007-09-16 22:45:33',3310491189,1),(52748831,424714616,15182419,443749,1,'2007-09-16 22:45:42',3310491189,1),(52748833,424713447,15189724,443749,1,'2007-09-16 22:45:42',3310491189,1),(52748835,424713447,15197322,443749,1,'2007-09-16 22:45:43',3310491189,1),(52748837,424717246,15204043,443749,1,'2007-09-16 22:45:43',3310491189,1),(52749087,424723675,15203459,443749,1,'2007-09-16 22:46:34',3310491189,1),(52749143,424729811,15199075,443749,1,'2007-09-16 22:46:46',3310491189,1),(52749145,424740039,15200537,443749,1,'2007-09-16 22:46:46',3310491232,1),(52749150,424741208,15206965,443749,1,'2007-09-16 22:46:46',3310491232,1),(52749155,424745299,15213686,443749,1,'2007-09-16 22:46:47',3310491232,1),(52749158,424745591,15219531,443749,1,'2007-09-16 22:46:47',3310491234,1),(52749159,424748221,15230343,443749,1,'2007-09-16 22:46:48',3310491234,1),(52749162,424753189,15237356,443749,1,'2007-09-16 22:46:48',3310491234,1),(52749165,424749390,15254305,443749,1,'2007-09-16 22:46:48',3310491234,1),(52749169,424744423,15262487,443749,1,'2007-09-16 22:46:50',3310491234,1),(52749171,424735656,15261903,443749,1,'2007-09-16 22:46:50',3310491191,1),(52749174,424726597,15277391,443749,1,'2007-09-16 22:46:50',3310491197,1),(52749175,424728058,15289079,443749,1,'2007-09-16 22:46:50',3310491197,1),(52749183,424723967,15289664,443749,1,'2007-09-16 22:46:52',3310491197,1),(52749184,424717830,15288203,443749,1,'2007-09-16 22:46:52',3310491197,1),(52749185,424717830,15269793,443749,1,'2007-09-16 22:46:52',3310491191,1),(52749189,424720753,15247876,443749,1,'2007-09-16 22:46:53',3310491191,1),(52749191,424718999,15227129,443749,1,'2007-09-16 22:46:53',3310491191,1),(52749208,424712570,15216316,443749,1,'2007-09-16 22:46:55',3310491191,1),(52749211,424699713,15183003,443749,1,'2007-09-16 22:46:55',3310491188,1),(52749214,424691823,15166639,443749,1,'2007-09-16 22:46:56',3310491188,1),(52749218,424687440,15160210,443749,1,'2007-09-16 22:46:56',3310491166,1),(52749220,424676627,15159333,443749,1,'2007-09-16 22:46:57',3310491163,1),(52749224,424656873,15150392,443749,1,'2007-09-16 22:46:57',3310491163,1),(52749225,424657399,15136949,443749,1,'2007-09-16 22:46:57',3310491163,1),(52749228,424664471,15139988,443749,1,'2007-09-16 22:46:57',3310491163,1),(52749231,424672303,15138118,443749,1,'2007-09-16 22:46:57',3310491163,1),(52749233,424682472,15126313,443749,1,'2007-09-16 22:46:57',3310491163,1),(52749238,424683933,15123098,443749,1,'2007-09-16 22:46:58',3310491166,1),(52749240,424672244,15109364,443749,1,'2007-09-16 22:46:58',3310491163,1),(52749243,424666107,15105565,443749,1,'2007-09-16 22:46:59',3310491161,1),(52749244,424661432,15092415,443749,1,'2007-09-16 22:46:59',3310491161,1),(52749247,424655880,15079557,443749,1,'2007-09-16 22:46:59',3310491161,1),(52749251,424657049,15064362,443749,1,'2007-09-16 22:46:59',3310491161,1),(52749255,424657049,15042445,443749,1,'2007-09-16 22:47:00',3310491155,1),(52749256,424652958,15014100,443749,1,'2007-09-16 22:47:00',3310491154,1),(52749259,424642438,14981663,443749,1,'2007-09-16 22:47:01',3310491152,1),(52749261,424640684,14973481,443749,1,'2007-09-16 22:47:01',3310491152,1),(52749263,424643606,14961208,443749,1,'2007-09-16 22:47:02',3310491152,1),(52749266,424599752,15000826,443749,1,'2007-09-16 22:47:02',3310491142,1),(52749268,424599606,15009609,443749,1,'2007-09-16 22:47:02',3310491142,1),(52749271,424599894,15020476,443749,1,'2007-09-16 22:47:02',3310491142,1),(52749275,424598072,15031708,443749,1,'2007-09-16 22:47:03',3310491142,1),(52749276,424598072,15038993,443749,1,'2007-09-16 22:47:03',3310491142,1),(52749280,424600804,15044457,443749,1,'2007-09-16 22:47:03',3310491143,1),(52749282,424606268,15050529,443749,1,'2007-09-16 22:47:04',3310491143,1),(52749284,424607179,15053868,443749,1,'2007-09-16 22:47:04',3310491149,1),(52749285,424608090,15057814,443749,1,'2007-09-16 22:47:05',3310491149,1),(52749288,424607786,15061153,443749,1,'2007-09-16 22:47:06',3310491149,1),(52749289,424609607,15065099,443749,1,'2007-09-16 22:47:06',3310491149,1),(52749309,424610215,15069046,443749,1,'2007-09-16 22:47:11',3310491149,1),(52749310,424608090,15069046,443749,1,'2007-09-16 22:47:12',3310491149,1),(52749312,424604143,15064796,443749,1,'2007-09-16 22:47:12',3310491149,1),(52749314,424604085,15067169,443749,1,'2007-09-16 22:47:12',3310491149,1),(52749316,424609103,15075077,443749,1,'2007-09-16 22:47:12',3310491149,1),(52749321,424610015,15078727,443749,1,'2007-09-16 22:47:13',3310491149,1),(52749324,424600131,15075381,443749,1,'2007-09-16 22:47:13',3310491148,1),(52749326,424599522,15077358,443749,1,'2007-09-16 22:47:13',3310491148,1),(52749328,424600587,15083137,443749,1,'2007-09-16 22:47:13',3310491148,1),(52749331,424602412,15086482,443749,1,'2007-09-16 22:47:14',3310491149,1),(52749334,424601499,15092413,443749,1,'2007-09-16 22:47:14',3310491149,1),(52749340,424600739,15099561,443749,1,'2007-09-16 22:47:14',3310491149,1),(52749341,424602868,15104427,443749,1,'2007-09-16 22:47:14',3310491149,1),(52749343,424604733,15116087,443749,1,'2007-09-16 22:47:14',3310491151,1),(52749347,424609200,15125284,443749,1,'2007-09-16 22:47:14',3310491151,1),(52749349,424610251,15132116,443749,1,'2007-09-16 22:47:15',3310491151,1),(52749352,424607361,15132379,443749,1,'2007-09-16 22:47:15',3310491151,1),(52749354,424604470,15128963,443749,1,'2007-09-16 22:47:15',3310491151,1),(52749357,424604733,15131065,443749,1,'2007-09-16 22:47:16',3310491151,1),(52749359,424604996,15138949,443749,1,'2007-09-16 22:47:16',3310491151,1),(52749363,424602631,15149197,443749,1,'2007-09-16 22:47:16',3310491151,1),(52749366,424602631,15158657,443749,1,'2007-09-16 22:47:16',3310491151,1),(52749368,424604208,15168643,443749,1,'2007-09-16 22:47:16',3310491173,1),(52749371,424612617,15188089,443749,1,'2007-09-16 22:47:16',3310491173,1),(52749376,424615604,15193412,443749,1,'2007-09-16 22:47:17',3310491173,1);
INSERT INTO `current_nodes` VALUES (52749379,424620599,15195682,443749,1,'2007-09-16 22:47:17',3310491173,1),(52749381,424625140,15191141,443749,1,'2007-09-16 22:47:17',3310491173,1),(52749385,424632405,15189779,443749,1,'2007-09-16 22:47:18',3310491184,1),(52749386,424642395,15188871,443749,1,'2007-09-16 22:47:18',3310491184,1),(52749387,424658742,15182968,443749,1,'2007-09-16 22:47:18',3310491185,1),(52749389,424668278,15172524,443749,1,'2007-09-16 22:47:18',3310491185,1),(52749391,424672819,15165258,443749,1,'2007-09-16 22:47:18',3310491185,1),(52749393,424677359,15165712,443749,1,'2007-09-16 22:47:18',3310491185,1),(52749396,424678268,15171615,443749,1,'2007-09-16 22:47:19',3310491185,1),(52749398,424684625,15185692,443749,1,'2007-09-16 22:47:19',3310491188,1),(52749400,424691436,15196590,443749,1,'2007-09-16 22:47:19',3310491188,1),(52749402,424687803,15217478,443749,1,'2007-09-16 22:47:19',3310491190,1),(52749404,424680992,15252443,443749,1,'2007-09-16 22:47:19',3310491187,1),(52749407,424671910,15291040,443749,1,'2007-09-16 22:47:20',3310491193,1),(52749410,424664645,15315106,443749,1,'2007-09-16 22:47:20',3310491193,1),(52749412,424665553,15335994,443749,1,'2007-09-16 22:47:20',3310491195,1),(52749414,424671456,15352341,443749,1,'2007-09-16 22:47:20',3310491195,1),(52749416,424665099,15360515,443749,1,'2007-09-16 22:47:21',3310491195,1),(52749419,424655563,15349617,443749,1,'2007-09-16 22:47:21',3310491195,1),(52749421,424652385,15344168,443749,1,'2007-09-16 22:47:21',3310491194,1),(52749424,424645119,15347347,443749,1,'2007-09-16 22:47:21',3310491194,1),(52749428,424634221,15365964,443749,1,'2007-09-16 22:47:22',3310491194,1),(52749430,424628318,15383673,443749,1,'2007-09-16 22:47:22',3310491280,1),(52749433,424624686,15397296,443749,1,'2007-09-16 22:47:22',3310491269,1),(52749436,424606976,15392301,443749,1,'2007-09-16 22:47:23',3310491269,1),(52749439,424601073,15394117,443749,1,'2007-09-16 22:47:23',3310491269,1),(52749441,424603798,15405470,443749,1,'2007-09-16 22:47:23',3310491269,1),(52749443,424587905,15429082,443749,1,'2007-09-16 22:47:23',3310491268,1),(52749448,424583364,15423633,443749,1,'2007-09-16 22:47:23',3310491268,1),(52749451,424571103,15410010,443749,1,'2007-09-16 22:47:23',3310491265,1),(52749455,424565200,15372775,443749,1,'2007-09-16 22:47:24',3310491179,1),(52749458,424566563,15343260,443749,1,'2007-09-16 22:47:24',3310491179,1),(52749460,424572466,15340081,443749,1,'2007-09-16 22:47:24',3310491179,1),(52749462,424578369,15332816,443749,1,'2007-09-16 22:47:24',3310491182,1),(52749465,424577915,15313290,443749,1,'2007-09-16 22:47:24',3310491180,1),(52749469,424580639,15296943,443749,1,'2007-09-16 22:47:24',3310491180,1),(52749472,424584726,15291040,443749,1,'2007-09-16 22:47:25',3310491180,1),(52749474,424586996,15284229,443749,1,'2007-09-16 22:47:25',3310491180,1),(52749475,424582910,15253805,443749,1,'2007-09-16 22:47:25',3310491174,1),(52749479,424582910,15237458,443749,1,'2007-09-16 22:47:25',3310491174,1),(52749482,424587905,15226560,443749,1,'2007-09-16 22:47:25',3310491174,1),(52749485,424587451,15216116,443749,1,'2007-09-16 22:47:26',3310491172,1),(52749487,424581093,15212483,443749,1,'2007-09-16 22:47:26',3310491172,1),(52749490,424580185,15178427,443749,1,'2007-09-16 22:47:26',3310491172,1),(52749491,424580185,15143462,443749,1,'2007-09-16 22:47:26',3310491150,1),(52749492,424579277,15124391,443749,1,'2007-09-16 22:47:26',3310491150,1),(52749496,424571103,15110768,443749,1,'2007-09-16 22:47:27',3310491147,1),(52749497,424567017,15095783,443749,1,'2007-09-16 22:47:27',3310491145,1),(52749499,424566563,15078528,443749,1,'2007-09-16 22:47:27',3310491145,1),(52749502,424567925,15054915,443749,1,'2007-09-16 22:47:27',3310491145,1),(52749503,424567925,15037206,443749,1,'2007-09-16 22:47:27',3310491139,1),(52749505,424570649,15030849,443749,1,'2007-09-16 22:47:27',3310491139,1),(52749508,424576552,15024946,443749,1,'2007-09-16 22:47:28',3310491142,1),(52749509,424584272,15014502,443749,1,'2007-09-16 22:47:28',3310491142,1),(52749511,424591991,14999517,443749,1,'2007-09-16 22:47:28',3310491142,1),(52749514,424596532,14994976,443749,1,'2007-09-16 22:47:29',3310491140,1),(52749517,424599711,14995884,443749,1,'2007-09-16 22:47:29',3310491140,1),(52769332,424562951,15382372,443749,1,'2007-09-16 23:39:37',3310491265,1),(52769338,424565812,15388753,443749,1,'2007-09-16 23:39:38',3310491265,1),(52769340,424566392,15397747,443749,1,'2007-09-16 23:39:38',3310491265,1),(52769343,424564651,15402970,443749,1,'2007-09-16 23:39:38',3310491265,1),(52769346,424566682,15408772,443749,1,'2007-09-16 23:39:38',3310491265,1),(52769349,424571179,15418927,443749,1,'2007-09-16 23:39:39',3310491265,1),(52769352,424571324,15428066,443749,1,'2007-09-16 23:39:40',3310491265,1),(52769355,424568423,15437641,443749,1,'2007-09-16 23:39:40',3310491267,1),(52769357,424564216,15444314,443749,1,'2007-09-16 23:39:40',3310491267,1),(52769358,424558848,15457660,443749,1,'2007-09-16 23:39:40',3310491267,1),(52769361,424557253,15463318,443749,1,'2007-09-16 23:39:41',3310491267,1),(52769364,424551740,15465349,443749,1,'2007-09-16 23:39:42',3310491267,1),(52769366,424548404,15465204,443749,1,'2007-09-16 23:39:42',3310491267,1),(52769367,424545937,15461722,443749,1,'2007-09-16 23:39:42',3310491267,1),(52769369,424538974,15462447,443749,1,'2007-09-16 23:39:42',3310491266,1),(52769371,424530560,15465784,443749,1,'2007-09-16 23:39:42',3310491266,1),(52769373,424526063,15473908,443749,1,'2007-09-16 23:39:42',3310491266,1),(52769374,424523887,15465494,443749,1,'2007-09-16 23:39:43',3310491266,1),(52769377,424515473,15475793,443749,1,'2007-09-16 23:39:43',3310490583,1),(52769380,424513007,15478695,443749,1,'2007-09-16 23:39:43',3310490583,1),(52769381,424508220,15472457,443749,1,'2007-09-16 23:39:43',3310490583,1),(52769384,424508220,15469120,443749,1,'2007-09-16 23:39:44',3310490583,1),(52769387,424509235,15464188,443749,1,'2007-09-16 23:39:44',3310490583,1),(52769389,424505609,15460706,443749,1,'2007-09-16 23:39:44',3310490583,1),(52769392,424500096,15459836,443749,1,'2007-09-16 23:39:44',3310490583,1),(52769395,424495309,15457225,443749,1,'2007-09-16 23:39:45',3310490583,1),(52769397,424493423,15453163,443749,1,'2007-09-16 23:39:45',3310490583,1),(52769401,424492118,15446635,443749,1,'2007-09-16 23:39:47',3310490583,1),(52769406,424490545,15437518,443749,1,'2007-09-16 23:39:48',3310490582,1),(52769411,424492984,15430844,443749,1,'2007-09-16 23:39:48',3310490581,1),(52769413,424490417,15425068,443749,1,'2007-09-16 23:39:48',3310490580,1),(52769415,424485797,15421475,443749,1,'2007-09-16 23:39:49',3310490580,1),(52769418,424485540,15410693,443749,1,'2007-09-16 23:39:49',3310490580,1),(52769419,424482203,15400682,443749,1,'2007-09-16 23:39:49',3310490580,1),(52769420,424482331,15391056,443749,1,'2007-09-16 23:39:49',3310490580,1),(52769423,424481561,15370393,443749,1,'2007-09-16 23:39:49',3310490494,1),(52769425,424485540,15360638,443749,1,'2007-09-16 23:39:49',3310490494,1),(52769427,424488235,15351141,443749,1,'2007-09-16 23:39:50',3310490494,1),(52769431,424492086,15344467,443749,1,'2007-09-16 23:39:50',3310490495,1),(52769436,424498631,15342927,443749,1,'2007-09-16 23:39:51',3310490495,1),(52769439,424507231,15347290,443749,1,'2007-09-16 23:39:51',3310490495,1),(52769441,424516600,15349216,443749,1,'2007-09-16 23:39:51',3310490495,1),(52769444,424520835,15346905,443749,1,'2007-09-16 23:39:51',3310491178,1),(52769447,424520835,15340360,443749,1,'2007-09-16 23:39:52',3310491178,1),(52769450,424510054,15331375,443749,1,'2007-09-16 23:39:52',3310490495,1),(52769452,424504022,15328423,443749,1,'2007-09-16 23:39:52',3310490495,1),(52769456,424498375,15318156,443749,1,'2007-09-16 23:39:52',3310490493,1),(52769457,424498375,15312124,443749,1,'2007-09-16 23:39:53',3310490493,1),(52769460,424501070,15309685,443749,1,'2007-09-16 23:39:53',3310490493,1),(52769465,424504022,15312509,443749,1,'2007-09-16 23:39:53',3310490493,1),(52769471,424507616,15319824,443749,1,'2007-09-16 23:39:54',3310490493,1),(52769477,424511723,15325472,443749,1,'2007-09-16 23:39:54',3310490493,1),(52769479,424519295,15328552,443749,1,'2007-09-16 23:39:55',3310491178,1),(52769482,424526739,15332787,443749,1,'2007-09-16 23:39:55',3310491178,1),(52769485,424536878,15335611,443749,1,'2007-09-16 23:39:55',3310491178,1),(52769488,424547916,15347290,443749,1,'2007-09-16 23:39:55',3310491179,1),(52769491,424553820,15362435,443749,1,'2007-09-16 23:39:56',3310491179,1),(52769493,424559981,15374500,443749,1,'2007-09-16 23:39:56',3310491179,1),(52792095,425799592,16443960,495907,1,'2008-07-15 19:51:52',3310504158,2),(52792098,425799592,16448080,495907,1,'2008-07-15 19:51:52',3310504158,2),(52792102,425799844,16450312,495907,1,'2008-07-15 19:51:52',3310504158,2),(52792111,425800160,16452458,495907,1,'2008-07-15 19:51:52',3310504158,2),(52792113,425800540,16454174,495907,1,'2008-07-15 19:51:52',3310504158,2),(52792114,425800540,16455376,495907,1,'2008-07-15 19:51:52',3310504158,2),(52792117,425800287,16456062,495907,1,'2008-07-15 19:51:52',3310504158,2),(52792122,425799718,16456406,495907,1,'2008-07-15 19:51:52',3310504158,2),(52792158,425799336,16440207,443749,1,'2007-09-17 00:34:55',3310504158,1),(52792159,425799827,16436896,443749,1,'2007-09-17 00:34:56',3310504158,1),(52792177,425800808,16433585,443749,1,'2007-09-17 00:34:58',3310504158,1),(52792180,425801625,16430683,443749,1,'2007-09-17 00:34:58',3310504158,1),(52792182,425801952,16428066,443749,1,'2007-09-17 00:34:58',3310504158,1),(52792185,425802279,16425041,443749,1,'2007-09-17 00:34:58',3310504158,1),(52792187,425802893,16421403,443749,1,'2007-09-17 00:34:59',3310504156,1),(52792189,425803710,16415885,443749,1,'2007-09-17 00:34:59',3310504156,1),(52792192,425804610,16411266,443749,1,'2007-09-17 00:34:59',3310504156,1),(52792194,425806163,16405502,443749,1,'2007-09-17 00:34:59',3310504156,1),(52792196,425807635,16399574,443749,1,'2007-09-17 00:34:59',3310504156,1),(52792199,425809392,16391808,443749,1,'2007-09-17 00:35:00',3310504157,1),(52792202,425810905,16386289,443749,1,'2007-09-17 00:35:00',3310504157,1),(52792205,425811641,16383019,443749,1,'2007-09-17 00:35:00',3310504157,1),(52792210,425812744,16381220,443749,1,'2007-09-17 00:35:00',3310504157,1),(52796991,425813848,16380689,443749,1,'2007-09-17 00:44:25',3310504157,1),(52797049,425815115,16381016,443749,1,'2007-09-17 00:44:33',3310504157,1),(52797051,425816709,16380934,443749,1,'2007-09-17 00:44:33',3310504157,1),(52797069,425818140,16380198,443749,1,'2007-09-17 00:44:34',3310504157,1),(52797105,425820511,16378727,443749,1,'2007-09-17 00:44:40',3310504157,1),(52797267,425824926,16377623,443749,1,'2007-09-17 00:45:00',3310504157,1),(52797268,425827542,16376642,443749,1,'2007-09-17 00:45:00',3310504157,1),(52797269,425829341,16376356,443749,1,'2007-09-17 00:45:01',3310504157,1),(52797270,425831180,16376110,443749,1,'2007-09-17 00:45:02',3310504157,1),(52797275,425833265,16376151,443749,1,'2007-09-17 00:45:02',3310504157,1),(52797278,425835064,16376070,443749,1,'2007-09-17 00:45:03',3310504157,1),(52797286,425837026,16375170,443749,1,'2007-09-17 00:45:03',3310504328,1),(52797303,425839274,16374394,443749,1,'2007-09-17 00:45:06',3310504328,1),(52797555,425841195,16373903,443749,1,'2007-09-17 00:45:33',3310504328,1),(52798676,425843403,16373699,443749,1,'2007-09-17 00:47:42',3310504328,1),(52799709,425845855,16374271,443749,1,'2007-09-17 00:49:43',3310504328,1),(52799985,425849167,16375375,443749,1,'2007-09-17 00:50:16',3310504328,1),(52800033,425853418,16376805,443749,1,'2007-09-17 00:50:19',3310504328,1),(52800211,425858201,16378727,538211,1,'2007-09-30 15:36:21',3310504328,1),(52800388,425862370,16381057,443749,1,'2007-09-17 00:51:03',3310504328,1),(52800400,425864905,16382814,443749,1,'2007-09-17 00:51:04',3310504329,1),(52800405,425867316,16385063,443749,1,'2007-09-17 00:51:04',3310504329,1),(52800416,425869483,16386943,443749,1,'2007-09-17 00:51:05',3310504329,1),(52800529,425871609,16388006,443749,1,'2007-09-17 00:51:18',3310504329,1),(52800536,425874675,16389396,443749,1,'2007-09-17 00:51:18',3310504329,1),(52800580,425876187,16390295,443749,1,'2007-09-17 00:51:21',3310504329,1),(52800584,425877413,16390540,443749,1,'2007-09-17 00:51:21',3310504329,1),(52800586,425878149,16390173,443749,1,'2007-09-17 00:51:21',3310504329,1),(52800590,425878721,16389151,443749,1,'2007-09-17 00:51:21',3310504329,1),(52800592,425878558,16388251,443749,1,'2007-09-17 00:51:21',3310504329,1),(52800596,425877372,16387148,443749,1,'2007-09-17 00:51:21',3310504329,1),(52800599,425875696,16386044,443749,1,'2007-09-17 00:51:22',3310504329,1),(52800602,425874470,16384245,443749,1,'2007-09-17 00:51:22',3310504329,1),(52800606,425873121,16381629,443749,1,'2007-09-17 00:51:22',3310504329,1),(52800608,425872508,16380198,443749,1,'2007-09-17 00:51:23',3310504329,1),(52800610,425871200,16378890,443749,1,'2007-09-17 00:51:23',3310504329,1),(52800614,425870096,16377500,443749,1,'2007-09-17 00:51:23',3310504329,1),(52800618,425870055,16376397,443749,1,'2007-09-17 00:51:23',3310504329,1),(52800619,425870546,16376070,443749,1,'2007-09-17 00:51:23',3310504329,1),(52800622,425871241,16376070,443749,1,'2007-09-17 00:51:24',3310504329,1),(52800623,425872181,16376928,443749,1,'2007-09-17 00:51:24',3310504329,1),(52800625,425874020,16379422,443749,1,'2007-09-17 00:51:24',3310504329,1),(52800626,425875615,16381915,443749,1,'2007-09-17 00:51:24',3310504329,1),(52800628,425877045,16383877,443749,1,'2007-09-17 00:51:24',3310504329,1),(52800630,425878190,16384695,443749,1,'2007-09-17 00:51:24',3310504329,1),(52800634,425879212,16384981,443749,1,'2007-09-17 00:51:25',3310504329,1),(52800638,425880765,16384899,443749,1,'2007-09-17 00:51:25',3310504329,1),(52800642,425882932,16384490,443749,1,'2007-09-17 00:51:25',3310504329,1),(52800645,425885017,16384082,443749,1,'2007-09-17 00:51:25',3310504329,1),(52800647,425886611,16383959,443749,1,'2007-09-17 00:51:25',3310504329,1),(52800651,425888287,16383796,443749,1,'2007-09-17 00:51:26',3310504329,1),(52800652,425890331,16382855,443749,1,'2007-09-17 00:51:26',3310504329,1),(52800656,425892743,16381506,443749,1,'2007-09-17 00:51:26',3310504332,1),(52800661,425894459,16380484,443749,1,'2007-09-17 00:51:26',3310504332,1),(52800664,425895645,16379503,443749,1,'2007-09-17 00:51:27',3310504332,1),(52800665,425896749,16378727,443749,1,'2007-09-17 00:51:27',3310504332,1),(52800667,425898425,16377746,443749,1,'2007-09-17 00:51:27',3310504332,1),(52800668,425902022,16376560,443749,1,'2007-09-17 00:51:27',3310504332,1),(52800670,425904883,16375620,443749,1,'2007-09-17 00:51:27',3310504332,1),(52800673,425906151,16375007,443749,1,'2007-09-17 00:51:27',3310504332,1),(52800677,425908113,16373658,443749,1,'2007-09-17 00:51:28',3310504332,1),(52800681,425909462,16372840,443749,1,'2007-09-17 00:51:28',3310504332,1),(52800683,425910688,16372472,443749,1,'2007-09-17 00:51:28',3310504332,1),(52800686,425912078,16372799,443749,1,'2007-09-17 00:51:28',3310504332,1),(52800691,425913059,16373249,443749,1,'2007-09-17 00:51:29',3310504332,1),(52800794,425914449,16374802,443749,1,'2007-09-17 00:51:39',3310504332,1),(52800813,425915266,16375334,443749,1,'2007-09-17 00:51:41',3310504332,1),(52800821,425916207,16375661,443749,1,'2007-09-17 00:51:42',3310504332,1),(52800828,425917147,16375620,443749,1,'2007-09-17 00:51:42',3310504332,1),(52800845,425918210,16374966,443749,1,'2007-09-17 00:51:44',3310504332,1),(52800909,425919068,16373944,443749,1,'2007-09-17 00:51:52',3310504333,1),(52800938,425920213,16372963,443749,1,'2007-09-17 00:51:54',3310504333,1),(52800944,425921112,16372554,443749,1,'2007-09-17 00:51:55',3310504333,1),(52800948,425923401,16372799,443749,1,'2007-09-17 00:51:56',3310504333,1),(52800952,425924382,16373576,443749,1,'2007-09-17 00:51:56',3310504333,1),(52800957,425922198,16372507,443749,1,'2007-09-17 00:51:57',3310504333,1),(52800960,425927816,16376315,443749,1,'2007-09-17 00:51:57',3310504333,1),(52800964,425929042,16377010,443749,1,'2007-09-17 00:51:58',3310504333,1),(52800967,425930023,16377173,443749,1,'2007-09-17 00:51:58',3310504333,1),(52800970,425931372,16377214,443749,1,'2007-09-17 00:51:58',3310504333,1),(52800974,425932680,16377010,443749,1,'2007-09-17 00:51:58',3310504333,1),(52800978,425933784,16376356,443749,1,'2007-09-17 00:51:59',3310504333,1),(52800981,425934970,16375170,443749,1,'2007-09-17 00:51:59',3310504333,1),(52800985,425936408,16373938,443749,1,'2007-09-17 00:51:59',3310504333,1),(52800987,425937736,16373147,443749,1,'2007-09-17 00:52:00',3310504333,1),(52800990,425939293,16372203,443749,1,'2007-09-17 00:52:00',3310504333,1),(52800993,425940952,16371488,443749,1,'2007-09-17 00:52:00',3310504333,1),(52800995,425942177,16371130,443749,1,'2007-09-17 00:52:01',3310504333,1),(52800998,425944475,16370518,443749,1,'2007-09-17 00:52:01',3310504333,1),(52801001,425945420,16370262,443749,1,'2007-09-17 00:52:01',3310504333,1),(52801004,425946390,16370084,443749,1,'2007-09-17 00:52:01',3310504333,1),(52801007,425947743,16369982,443749,1,'2007-09-17 00:52:02',3310504344,1),(52801010,425949121,16370007,443749,1,'2007-09-17 00:52:02',3310504344,1),(52801153,425951189,16370467,538211,1,'2007-09-30 15:36:21',3310504344,1),(52801157,425954712,16371692,443749,1,'2007-09-17 00:52:18',3310504344,1),(52801158,425960174,16373811,443749,1,'2007-09-17 00:52:18',3310504344,1),(52801164,425964080,16375266,443749,1,'2007-09-17 00:52:19',3310504344,1),(52801166,425965357,16375827,443749,1,'2007-09-17 00:52:19',3310504344,1),(52801167,425968650,16377640,443749,1,'2007-09-17 00:52:19',3310504344,1),(52801168,425971100,16379121,443749,1,'2007-09-17 00:52:19',3310504344,1),(52801170,425973398,16380652,443749,1,'2007-09-17 00:52:20',3310504344,1),(52801172,425974827,16381214,443749,1,'2007-09-17 00:52:20',3310504345,1),(52801173,425976002,16381469,443749,1,'2007-09-17 00:52:20',3310504345,1),(52801175,425977891,16381469,443749,1,'2007-09-17 00:52:20',3310504345,1),(52801176,425979320,16381226,443749,1,'2007-09-17 00:52:20',3310504345,1),(52801178,425980518,16380871,443749,1,'2007-09-17 00:52:20',3310504345,1),(52801181,425981490,16380207,443749,1,'2007-09-17 00:52:20',3310504345,1),(52801182,425982318,16379489,443749,1,'2007-09-17 00:52:20',3310504345,1),(52801184,425983147,16378356,443749,1,'2007-09-17 00:52:20',3310504345,1),(52801190,425984141,16377169,443749,1,'2007-09-17 00:52:21',3310504345,1),(52801192,425985081,16376367,443749,1,'2007-09-17 00:52:21',3310504345,1),(52801195,425986020,16375732,443749,1,'2007-09-17 00:52:21',3310504345,1),(52801198,425987180,16375124,443749,1,'2007-09-17 00:52:21',3310504345,1),(52801203,425988091,16374793,443749,1,'2007-09-17 00:52:21',3310504345,1),(52801207,425989390,16374682,443749,1,'2007-09-17 00:52:21',3310504345,1),(52801209,425990937,16374682,443749,1,'2007-09-17 00:52:22',3310504345,1),(52801212,425993036,16375069,443749,1,'2007-09-17 00:52:22',3310504345,1),(52801215,425995246,16375456,443749,1,'2007-09-17 00:52:23',3310504345,1),(52801217,425997207,16376146,443749,1,'2007-09-17 00:52:23',3310504345,1),(52801218,425998892,16376727,443749,1,'2007-09-17 00:52:23',3310504345,1),(52801220,426000632,16377141,443749,1,'2007-09-17 00:52:23',3310504345,1),(52801221,426002345,16377251,443749,1,'2007-09-17 00:52:23',3310504348,1),(52801223,426003200,16379655,443749,1,'2007-09-17 00:52:24',3310504348,1),(52801226,426002561,16379687,443749,1,'2007-09-17 00:52:24',3310504348,1),(52801228,426001603,16380006,443749,1,'2007-09-17 00:52:24',3310504348,1),(52801231,426000645,16380102,443749,1,'2007-09-17 00:52:24',3310504345,1),(52801233,425999464,16379910,443749,1,'2007-09-17 00:52:24',3310504345,1),(52801234,425998665,16379335,443749,1,'2007-09-17 00:52:24',3310504345,1),(52801247,425997835,16379080,443749,1,'2007-09-17 00:52:26',3310504345,1),(52801248,425996047,16379272,443749,1,'2007-09-17 00:52:26',3310504345,1),(52801251,425994258,16379527,443749,1,'2007-09-17 00:52:26',3310504345,1),(52801254,425992885,16379591,443749,1,'2007-09-17 00:52:26',3310504345,1),(52801258,425991416,16379431,443749,1,'2007-09-17 00:52:26',3310504345,1),(52801262,425990522,16379463,443749,1,'2007-09-17 00:52:26',3310504345,1),(52801265,425989596,16380325,443749,1,'2007-09-17 00:52:27',3310504345,1),(52801269,425989149,16381379,443749,1,'2007-09-17 00:52:27',3310504345,1),(52801273,425988510,16382146,443749,1,'2007-09-17 00:52:27',3310504345,1),(52801274,425987616,16382752,443749,1,'2007-09-17 00:52:27',3310504345,1),(52801279,425986690,16382784,443749,1,'2007-09-17 00:52:27',3310504345,1),(52801283,425986019,16382305,443749,1,'2007-09-17 00:52:27',3310504345,1),(52801284,425985349,16382178,443749,1,'2007-09-17 00:52:27',3310504345,1),(52801287,425983752,16382146,443749,1,'2007-09-17 00:52:27',3310504345,1),(52801289,425982092,16382114,443749,1,'2007-09-17 00:52:28',3310504345,1),(52801291,425980878,16382305,443749,1,'2007-09-17 00:52:28',3310504345,1),(52801293,425979952,16382912,443749,1,'2007-09-17 00:52:28',3310504345,1),(52801295,425978387,16383327,443749,1,'2007-09-17 00:52:28',3310504345,1),(52801298,425976280,16383104,443749,1,'2007-09-17 00:52:28',3310504345,1),(52801299,425974012,16382657,443749,1,'2007-09-17 00:52:28',3310504345,1),(52801301,425972256,16381826,443749,1,'2007-09-17 00:52:29',3310504344,1),(52801303,425970851,16380293,443749,1,'2007-09-17 00:52:29',3310504344,1),(52801305,425968009,16378473,443749,1,'2007-09-17 00:52:29',3310504344,1),(52801307,425964049,16376653,443749,1,'2007-09-17 00:52:29',3310504344,1),(52801309,425961750,16375535,443749,1,'2007-09-17 00:52:30',3310504344,1),(52801311,425960568,16375440,443749,1,'2007-09-17 00:52:30',3310504344,1),(52801313,425958812,16375440,443749,1,'2007-09-17 00:52:30',3310504344,1),(52801314,425956417,16375312,443749,1,'2007-09-17 00:52:30',3310504344,1),(52801316,425954597,16375088,443749,1,'2007-09-17 00:52:30',3310504344,1),(52801317,425953160,16373747,443749,1,'2007-09-17 00:52:30',3310504344,1),(52801319,425951307,16372086,443749,1,'2007-09-17 00:52:30',3310504344,1),(52801321,425950158,16371863,443749,1,'2007-09-17 00:52:31',3310504344,1),(52801323,425948912,16372597,443749,1,'2007-09-17 00:52:31',3310504344,1),(52801324,425948050,16372949,443749,1,'2007-09-17 00:52:31',3310504344,1),(52801326,425947252,16373140,443749,1,'2007-09-17 00:52:31',3310504344,1),(52801328,425946517,16373492,443749,1,'2007-09-17 00:52:31',3310504344,1),(52801330,425945559,16374609,443749,1,'2007-09-17 00:52:31',3310504333,1),(52801331,425944953,16375280,443749,1,'2007-09-17 00:52:31',3310504333,1),(52801333,425944186,16375663,443749,1,'2007-09-17 00:52:32',3310504333,1),(52801336,425943771,16375567,443749,1,'2007-09-17 00:52:32',3310504333,1),(52801339,425943356,16375152,443749,1,'2007-09-17 00:52:32',3310504333,1),(52801341,425942462,16374897,443749,1,'2007-09-17 00:52:32',3310504333,1),(52801344,425941855,16374992,443749,1,'2007-09-17 00:52:32',3310504333,1),(52801345,425940322,16374609,443749,1,'2007-09-17 00:52:32',3310504333,1),(52801348,425939204,16374226,443749,1,'2007-09-17 00:52:33',3310504333,1),(52801350,425938374,16374258,443749,1,'2007-09-17 00:52:33',3310504333,1),(52801352,425937512,16374865,443749,1,'2007-09-17 00:52:33',3310504333,1),(52801353,425935692,16375887,443749,1,'2007-09-17 00:52:33',3310504333,1),(52801354,425933648,16377803,443749,1,'2007-09-17 00:52:33',3310504333,1),(52801355,425932115,16378346,443749,1,'2007-09-17 00:52:33',3310504333,1),(52801356,425930327,16378250,443749,1,'2007-09-17 00:52:33',3310504333,1),(52801357,425928507,16378026,443749,1,'2007-09-17 00:52:34',3310504333,1),(52801358,425926591,16377867,443749,1,'2007-09-17 00:52:34',3310504333,1),(52801359,425925377,16378377,443749,1,'2007-09-17 00:52:34',3310504333,1),(52801360,425923780,16377228,443749,1,'2007-09-17 00:52:34',3310504333,1),(52801361,425922599,16375535,443749,1,'2007-09-17 00:52:34',3310504333,1),(52801362,425921290,16374801,443749,1,'2007-09-17 00:52:34',3310504333,1),(52801363,425920395,16374992,443749,1,'2007-09-17 00:52:34',3310504333,1),(52801364,425919278,16375631,443749,1,'2007-09-17 00:52:34',3310504333,1),(52801366,425918639,16376877,443749,1,'2007-09-17 00:52:35',3310504332,1),(52801368,425917968,16377835,443749,1,'2007-09-17 00:52:35',3310504332,1),(52801370,425917202,16378250,443749,1,'2007-09-17 00:52:35',3310504332,1),(52801372,425916276,16378218,443749,1,'2007-09-17 00:52:35',3310504332,1),(52801374,425914935,16377164,443749,1,'2007-09-17 00:52:35',3310504332,1),(52801376,425913594,16375950,443749,1,'2007-09-17 00:52:35',3310504332,1),(52801380,425912188,16374992,443749,1,'2007-09-17 00:52:36',3310504332,1),(52801384,425911039,16374418,443749,1,'2007-09-17 00:52:36',3310504332,1),(52801389,425910049,16374386,443749,1,'2007-09-17 00:52:36',3310504332,1),(52801392,425908963,16374961,443749,1,'2007-09-17 00:52:36',3310504332,1),(52801396,425907590,16376142,443749,1,'2007-09-17 00:52:36',3310504332,1),(52801397,425906824,16377324,443749,1,'2007-09-17 00:52:36',3310504332,1),(52801402,425905291,16377611,443749,1,'2007-09-17 00:52:37',3310504332,1),(52801404,425903566,16377419,443749,1,'2007-09-17 00:52:37',3310504332,1),(52801407,425902768,16377419,443749,1,'2007-09-17 00:52:37',3310504332,1),(52801413,425901746,16378473,443749,1,'2007-09-17 00:52:37',3310504332,1),(52801417,425901076,16379176,443749,1,'2007-09-17 00:52:37',3310504332,1),(52801418,425899159,16379527,443749,1,'2007-09-17 00:52:38',3310504332,1),(52801422,425898074,16379623,443749,1,'2007-09-17 00:52:38',3310504332,1),(52801425,425897116,16380421,443749,1,'2007-09-17 00:52:38',3310504332,1),(52801427,425896381,16381443,443749,1,'2007-09-17 00:52:38',3310504332,1),(52801429,425894401,16383519,443749,1,'2007-09-17 00:52:38',3310504332,1),(52801431,425893284,16384605,443749,1,'2007-09-17 00:52:38',3310504332,1),(52801433,425891463,16385786,443749,1,'2007-09-17 00:52:38',3310504329,1),(52801435,425890952,16386457,443749,1,'2007-09-17 00:52:38',3310504329,1),(52801437,425890569,16387191,443749,1,'2007-09-17 00:52:39',3310504329,1),(52801439,425890058,16387766,443749,1,'2007-09-17 00:52:39',3310504329,1),(52801441,425888973,16388628,443749,1,'2007-09-17 00:52:39',3310504329,1),(52801444,425887983,16388564,443749,1,'2007-09-17 00:52:39',3310504329,1),(52801446,425886578,16388309,443749,1,'2007-09-17 00:52:39',3310504329,1),(52801447,425885364,16388021,443749,1,'2007-09-17 00:52:39',3310504329,1),(52801451,425884374,16387830,443749,1,'2007-09-17 00:52:40',3310504329,1),(52801453,425882777,16388341,443749,1,'2007-09-17 00:52:40',3310504329,1),(52801456,425881213,16389650,443749,1,'2007-09-17 00:52:40',3310504329,1),(52801461,425880287,16389842,443749,1,'2007-09-17 00:52:40',3310504329,1),(52801462,425879105,16389778,443749,1,'2007-09-17 00:52:40',3310504329,1),(52801465,425877317,16389427,443749,1,'2007-09-17 00:52:40',3310504329,1),(52801468,425875465,16388437,443749,1,'2007-09-17 00:52:40',3310504329,1),(52801469,425873197,16387319,443749,1,'2007-09-17 00:52:40',3310504329,1),(52801475,425871281,16386169,443749,1,'2007-09-17 00:52:40',3310504329,1),(52801477,425868822,16383934,443749,1,'2007-09-17 00:52:40',3310504329,1),(52801480,425867321,16382018,443749,1,'2007-09-17 00:52:41',3310504329,1),(52801487,425865980,16379942,443749,1,'2007-09-17 00:52:41',3310504329,1),(52801494,425865437,16378888,443749,1,'2007-09-17 00:52:41',3310504329,1),(52801506,425865118,16378729,443749,1,'2007-09-17 00:52:41',3310504329,1),(52801514,425864352,16378314,443749,1,'2007-09-17 00:52:41',3310504329,1),(52801516,425863585,16378314,443749,1,'2007-09-17 00:52:41',3310504328,1),(52801518,425862723,16378377,443749,1,'2007-09-17 00:52:41',3310504328,1),(52801520,425861158,16378186,443749,1,'2007-09-17 00:52:42',3310504328,1),(52801522,425860392,16377867,443749,1,'2007-09-17 00:52:42',3310504328,1),(52801524,425859625,16376813,443749,1,'2007-09-17 00:52:42',3310504328,1),(52801526,425858284,16375919,443749,1,'2007-09-17 00:52:42',3310504328,1),(52801527,425856656,16375344,443749,1,'2007-09-17 00:52:42',3310504328,1),(52801531,425855442,16374513,443749,1,'2007-09-17 00:52:42',3310504328,1),(52801534,425853558,16373555,443749,1,'2007-09-17 00:52:43',3310504328,1),(52801538,425852632,16372757,443749,1,'2007-09-17 00:52:43',3310504328,1),(52801542,425851387,16371863,443749,1,'2007-09-17 00:52:43',3310504328,1),(52801545,425850141,16371256,443749,1,'2007-09-17 00:52:43',3310504328,1),(52801548,425848960,16371128,443749,1,'2007-09-17 00:52:43',3310504328,1),(52801551,425847874,16371256,443749,1,'2007-09-17 00:52:43',3310504328,1),(52801555,425846596,16371033,443749,1,'2007-09-17 00:52:43',3310504328,1),(52801558,425846181,16370905,443749,1,'2007-09-17 00:52:44',3310504328,1),(52801561,425844904,16369755,443749,1,'2007-09-17 00:52:44',3310504322,1),(52801566,425843882,16369053,443749,1,'2007-09-17 00:52:45',3310504322,1),(52801569,425842573,16368254,443749,1,'2007-09-17 00:52:45',3310504322,1),(52801571,425840290,16368343,443749,1,'2007-09-17 00:52:45',3310504322,1),(52801573,425838608,16368574,443749,1,'2007-09-17 00:52:45',3310504322,1),(52801576,425837479,16368896,443749,1,'2007-09-17 00:52:45',3310504322,1),(52801578,425835868,16369486,443749,1,'2007-09-17 00:52:46',3310504151,1),(52801581,425833978,16370083,443749,1,'2007-09-17 00:52:46',3310504157,1),(52801584,425832684,16370050,443749,1,'2007-09-17 00:52:46',3310504157,1),(52801585,425831324,16369751,443749,1,'2007-09-17 00:52:46',3310504151,1),(52801587,425829798,16369188,443749,1,'2007-09-17 00:52:46',3310504151,1),(52801618,425828438,16369320,443749,1,'2007-09-17 00:52:49',3310504151,1),(52801640,425827111,16369486,443749,1,'2007-09-17 00:52:52',3310504151,1),(52801643,425822666,16369884,443749,1,'2007-09-17 00:52:52',3310504157,1),(52801648,425820642,16370813,443749,1,'2007-09-17 00:52:52',3310504157,1),(52801652,425819083,16370581,443749,1,'2007-09-17 00:52:52',3310504157,1),(52801654,425817126,16370680,443749,1,'2007-09-17 00:52:52',3310504157,1),(52801657,425815567,16371543,443749,1,'2007-09-17 00:52:52',3310504157,1),(52801660,425813510,16372737,443749,1,'2007-09-17 00:52:53',3310504157,1),(52801663,425811619,16373799,443749,1,'2007-09-17 00:52:53',3310504157,1),(52801664,425809994,16374761,443749,1,'2007-09-17 00:52:53',3310504157,1),(52801668,425808799,16375656,443749,1,'2007-09-17 00:52:53',3310504156,1),(52801672,425808235,16377249,443749,1,'2007-09-17 00:52:53',3310504156,1),(52801674,425807771,16379239,443749,1,'2007-09-17 00:52:53',3310504156,1),(52801679,425806942,16380035,443749,1,'2007-09-17 00:52:53',3310504156,1),(52801683,425806345,16380599,443749,1,'2007-09-17 00:52:53',3310504156,1),(52801684,425806212,16381860,443749,1,'2007-09-17 00:52:54',3310504156,1),(52801688,425805913,16382855,443749,1,'2007-09-17 00:52:54',3310504156,1),(52801691,425805084,16384115,443749,1,'2007-09-17 00:52:54',3310504156,1),(52801695,425804387,16384679,443749,1,'2007-09-17 00:52:54',3310504156,1),(52801699,425803193,16383717,443749,1,'2007-09-17 00:52:54',3310504156,1),(52801701,425802231,16383684,443749,1,'2007-09-17 00:52:54',3310504156,1),(52801704,425801136,16385310,443749,1,'2007-09-17 00:52:54',3310504156,1),(52801707,425799975,16386570,443749,1,'2007-09-17 00:52:54',3310504156,1),(52801710,425798914,16386139,443749,1,'2007-09-17 00:52:55',3310504156,1),(52801715,425797952,16385409,443749,1,'2007-09-17 00:52:55',3310504156,1),(52801719,425796890,16385807,443749,1,'2007-09-17 00:52:55',3310504156,1),(52801722,425796426,16386338,443749,1,'2007-09-17 00:52:55',3310504156,1),(52801725,425794739,16389086,443749,1,'2007-09-17 00:52:55',3310504156,1),(52801729,425793687,16391481,443749,1,'2007-09-17 00:52:56',3310504156,1),(52801733,425793220,16393292,443749,1,'2007-09-17 00:52:56',3310504156,1),(52801737,425791993,16394986,443749,1,'2007-09-17 00:52:56',3310504156,1),(52801741,425789607,16398400,454632,1,'2007-09-17 18:07:28',3310504156,1),(52801744,425920507,16379623,443749,1,'2007-09-17 00:52:56',3310504333,1),(52801747,425922786,16377759,443749,1,'2007-09-17 00:52:57',3310504333,1),(52801749,425924501,16376193,443749,1,'2007-09-17 00:52:57',3310504333,1),(52801750,425925943,16374900,443749,1,'2007-09-17 00:52:57',3310504333,1),(52801752,425919810,16380145,443749,1,'2007-09-17 00:52:57',3310504333,1),(52801754,425918965,16380568,443749,1,'2007-09-17 00:52:57',3310504332,1),(52801756,425917648,16380817,443749,1,'2007-09-17 00:52:57',3310504332,1),(52801757,425915883,16380568,443749,1,'2007-09-17 00:52:57',3310504332,1),(52801758,425914814,16380046,443749,1,'2007-09-17 00:52:57',3310504332,1),(52801759,425913496,16379599,443749,1,'2007-09-17 00:52:57',3310504332,1),(52801760,425913074,16379599,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801761,425911980,16380145,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801762,425910265,16381165,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801764,425909121,16381811,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801765,425907878,16382333,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801768,425906113,16382930,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801769,425904945,16383601,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801771,425904100,16384222,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801772,425903876,16384322,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801774,425902832,16385863,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801776,425901042,16388697,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801777,425899973,16390263,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801780,425899998,16390263,443749,1,'2007-09-17 00:52:59',3310504332,1),(52801781,425898730,16391581,443749,1,'2007-09-17 00:52:59',3310504332,1),(52801783,425897860,16392277,443749,1,'2007-09-17 00:52:59',3310504332,1),(52801785,425896642,16392476,443749,1,'2007-09-17 00:52:59',3310504332,1),(52801787,425895498,16392923,443749,1,'2007-09-17 00:52:59',3310504332,1),(52801788,425894230,16394091,443749,1,'2007-09-17 00:52:59',3310504332,1),(52801791,425893733,16394589,443749,1,'2007-09-17 00:52:59',3310504332,1),(52801792,425893062,16395061,443749,1,'2007-09-17 00:52:59',3310504332,1),(52801794,425890899,16396252,443749,1,'2007-09-17 00:52:59',3310504329,1),(52801796,425888413,16397670,557925,1,'2008-01-06 23:25:40',3310504329,2),(52801807,425885888,16398959,557925,1,'2008-01-06 23:25:40',3310504329,2),(52801809,425883465,16400196,443749,1,'2007-09-17 00:53:00',3310504329,1),(52801813,425882145,16400717,443749,1,'2007-09-17 00:53:00',3310504329,1),(52801816,425880537,16401211,443749,1,'2007-09-17 00:53:00',3310504329,1),(52801819,425878929,16401644,443749,1,'2007-09-17 00:53:00',3310504329,1),(52801824,425877593,16401688,443749,1,'2007-09-17 00:53:01',3310504329,1),(52801827,425875143,16401688,443749,1,'2007-09-17 00:53:01',3310504329,1),(52801876,425873287,16400871,443749,1,'2007-09-17 00:53:06',3310504329,1),(52802034,425871258,16400500,538211,1,'2007-09-30 15:36:22',3310504329,1),(52802158,425868631,16400354,443749,1,'2007-09-17 00:53:42',3310504329,1),(52802159,425866805,16400176,443749,1,'2007-09-17 00:53:42',3310504329,1),(52802160,425864800,16399686,443749,1,'2007-09-17 00:53:42',3310504329,1),(52802161,425863375,16399241,443749,1,'2007-09-17 00:53:42',3310504328,1),(52802162,425861861,16399018,443749,1,'2007-09-17 00:53:42',3310504328,1),(52802163,425859590,16398751,443749,1,'2007-09-17 00:53:43',3310504328,1),(52802164,425857585,16397815,443749,1,'2007-09-17 00:53:43',3310504328,1),(52802165,425855180,16396747,443749,1,'2007-09-17 00:53:43',3310504328,1),(52802166,425852820,16396657,443749,1,'2007-09-17 00:53:43',3310504328,1),(52802167,425850638,16396346,443749,1,'2007-09-17 00:53:44',3310504328,1),(52802168,425846273,16396257,443749,1,'2007-09-17 00:53:44',3310504328,1),(52802169,425844536,16395811,443749,1,'2007-09-17 00:53:45',3310504328,1),(52802170,425843645,16395856,443749,1,'2007-09-17 00:53:45',3310504328,1),(52802171,425842220,16396390,443749,1,'2007-09-17 00:53:47',3310504328,1),(52802172,425839993,16397637,443749,1,'2007-09-17 00:53:48',3310504328,1),(52802173,425838301,16398884,443749,1,'2007-09-17 00:53:49',3310504328,1),(52802183,425835985,16400621,443749,1,'2007-09-17 00:53:50',3310504157,1),(52802197,425833669,16402180,443749,1,'2007-09-17 00:53:52',3310504157,1),(52802210,425832155,16404140,443749,1,'2007-09-17 00:53:53',3310504157,1),(52802216,425831264,16407480,443749,1,'2007-09-17 00:53:54',3310504157,1),(52802218,425830106,16413047,443749,1,'2007-09-17 00:53:54',3310504157,1),(52802229,425829393,16418659,443749,1,'2007-09-17 00:53:56',3310504157,1),(52802260,425828992,16423380,443749,1,'2007-09-17 00:53:59',3310504157,1),(52803163,425829037,16430105,538211,1,'2007-09-30 15:36:22',3310504159,1),(52803175,425829171,16437231,443749,1,'2007-09-17 00:55:58',3310504159,1),(52803179,425829705,16442932,443749,1,'2007-09-17 00:55:58',3310504159,1),(52803182,425830284,16446228,443749,1,'2007-09-17 00:55:59',3310504159,1),(52803183,425830729,16448811,443749,1,'2007-09-17 00:55:59',3310504159,1),(52803186,425831175,16451260,443749,1,'2007-09-17 00:55:59',3310504159,1),(52803189,425831576,16452329,443749,1,'2007-09-17 00:55:59',3310504159,1),(52803191,425832377,16453576,443749,1,'2007-09-17 00:55:59',3310504159,1),(52803194,425833268,16455402,443749,1,'2007-09-17 00:56:00',3310504159,1),(52803195,425834203,16458074,443749,1,'2007-09-17 00:56:00',3310504159,1),(52803196,425834693,16461370,443749,1,'2007-09-17 00:56:00',3310504159,1),(52803197,425835183,16464131,443749,1,'2007-09-17 00:56:00',3310504159,1),(52803198,425835317,16465913,443749,1,'2007-09-17 00:56:00',3310504159,1),(52803200,425835495,16467873,443749,1,'2007-09-17 00:56:00',3310504159,1),(52803201,425835896,16469209,443749,1,'2007-09-17 00:56:00',3310504159,1),(52803202,425836742,16470545,443749,1,'2007-09-17 00:56:00',3310504330,1),(52803205,425837455,16471836,443749,1,'2007-09-17 00:56:01',3310504330,1),(52803207,425837811,16473440,443749,1,'2007-09-17 00:56:01',3310504330,1),(52803211,425837855,16475088,443749,1,'2007-09-17 00:56:01',3310504330,1),(52803214,425838167,16477938,443749,1,'2007-09-17 00:56:01',3310504330,1),(52803216,425838301,16480610,443749,1,'2007-09-17 00:56:01',3310504352,1),(52803218,425838702,16483951,443749,1,'2007-09-17 00:56:01',3310504352,1),(52803220,425839993,16486667,443749,1,'2007-09-17 00:56:02',3310504352,1),(52803222,425841418,16488315,443749,1,'2007-09-17 00:56:02',3310504352,1),(52803224,425842576,16489295,443749,1,'2007-09-17 00:56:02',3310504352,1),(52803225,425843155,16490987,443749,1,'2007-09-17 00:56:02',3310504352,1),(52803228,425843022,16492635,443749,1,'2007-09-17 00:56:02',3310504352,1),(52803229,425842487,16494239,443749,1,'2007-09-17 00:56:02',3310504352,1),(52803233,425842398,16495664,443749,1,'2007-09-17 00:56:02',3310504352,1),(52803235,425842754,16497134,443749,1,'2007-09-17 00:56:02',3310504352,1),(52803237,425843022,16498648,443749,1,'2007-09-17 00:56:03',3310504352,1),(52803239,425842977,16499984,443749,1,'2007-09-17 00:56:03',3310504352,1),(52803241,425842398,16501676,443749,1,'2007-09-17 00:56:03',3310504352,1),(52803243,425841686,16503235,443749,1,'2007-09-17 00:56:03',3310504352,1),(52803247,425841107,16505373,443749,1,'2007-09-17 00:56:03',3310504352,1),(52803251,425841151,16508001,443749,1,'2007-09-17 00:56:03',3310504352,1),(52803254,425841018,16510183,443749,1,'2007-09-17 00:56:04',3310504352,1),(52803255,425840795,16513256,443749,1,'2007-09-17 00:56:04',3310504352,1),(52803259,425840483,16515528,443749,1,'2007-09-17 00:56:04',3310504352,1),(52803263,425840528,16516641,443749,1,'2007-09-17 00:56:04',3310504352,1),(52803266,425840283,16518634,443749,1,'2007-09-17 00:56:04',3310504352,1),(52803269,425839621,16520746,443749,1,'2007-09-17 00:56:05',3310504352,1),(52803271,425838833,16522700,443749,1,'2007-09-17 00:56:05',3310504352,1),(52803273,425838108,16526151,443749,1,'2007-09-17 00:56:05',3310504352,1),(52803277,425833197,16398304,443749,1,'2007-09-17 00:56:05',3310504157,1),(52803280,425836075,16396975,443749,1,'2007-09-17 00:56:05',3310504157,1),(52803283,425831957,16399322,443749,1,'2007-09-17 00:56:05',3310504157,1),(52803285,425830363,16400916,443749,1,'2007-09-17 00:56:06',3310504157,1),(52803289,425829434,16403174,538211,1,'2007-09-30 15:36:22',3310504157,1),(52803297,425828460,16405432,443749,1,'2007-09-17 00:56:06',3310504157,1),(52803300,425827485,16407248,443749,1,'2007-09-17 00:56:07',3310504157,1),(52803304,425826246,16409329,443749,1,'2007-09-17 00:56:07',3310504157,1),(52803309,425824386,16411941,443749,1,'2007-09-17 00:56:08',3310504157,1),(52803311,425837669,16396311,443749,1,'2007-09-17 00:56:08',3310504328,1),(52803313,425839484,16395470,443749,1,'2007-09-17 00:56:08',3310504328,1),(52803316,425840901,16394939,443749,1,'2007-09-17 00:56:08',3310504328,1),(52803319,425842539,16394585,443749,1,'2007-09-17 00:56:08',3310504328,1),(52803320,425844001,16394629,443749,1,'2007-09-17 00:56:08',3310504328,1),(52803323,425845727,16395027,443749,1,'2007-09-17 00:56:08',3310504328,1),(52803325,425847321,16395736,443749,1,'2007-09-17 00:56:09',3310504328,1),(52803327,425847808,16396267,443749,1,'2007-09-17 00:56:09',3310504328,1),(52803328,425841761,16390329,443749,1,'2007-09-17 00:56:09',3310504328,1),(52803331,425843905,16391119,443749,1,'2007-09-17 00:56:09',3310504328,1),(52803333,425845785,16391683,443749,1,'2007-09-17 00:56:09',3310504328,1),(52803336,425847665,16391796,443749,1,'2007-09-17 00:56:09',3310504328,1),(52803337,425849245,16391345,443749,1,'2007-09-17 00:56:09',3310504328,1),(52803338,425851012,16391157,443749,1,'2007-09-17 00:56:10',3310504328,1),(52803340,425852178,16391533,443749,1,'2007-09-17 00:56:10',3310504328,1),(52803343,425853795,16392962,443749,1,'2007-09-17 00:56:10',3310504328,1),(52803346,425857556,16395105,443749,1,'2007-09-17 00:56:10',3310504328,1),(52803349,425864851,16398302,443749,1,'2007-09-17 00:56:11',3310504329,1),(52803351,426003763,16377246,443749,1,'2007-09-17 00:56:11',3310504348,1),(52803353,426005675,16376591,443749,1,'2007-09-17 00:56:12',3310504348,1),(52803358,426007587,16375990,443749,1,'2007-09-17 00:56:12',3310504348,1),(52803363,426008953,16375553,443749,1,'2007-09-17 00:56:13',3310504348,1),(52803365,426011193,16375443,443749,1,'2007-09-17 00:56:14',3310504348,1),(52803368,426012865,16375719,443749,1,'2007-09-17 00:56:14',3310504348,1),(52803370,426014473,16376873,443749,1,'2007-09-17 00:56:14',3310504348,1),(52803372,426015592,16377887,443749,1,'2007-09-17 00:56:14',3310504348,1),(52803374,426016816,16378691,443749,1,'2007-09-17 00:56:15',3310504348,1),(52803378,426017900,16379495,443749,1,'2007-09-17 00:56:15',3310504348,1),(52803382,426019578,16380159,443749,1,'2007-09-17 00:56:15',3310504348,1),(52803385,426020977,16380334,443749,1,'2007-09-17 00:56:15',3310504348,1),(52803388,426024229,16380614,443749,1,'2007-09-17 00:56:16',3310504348,1),(52803391,426026536,16380894,443749,1,'2007-09-17 00:56:16',3310504348,1),(52803393,426028494,16381278,443749,1,'2007-09-17 00:56:16',3310504348,1),(52803396,426029369,16381663,443749,1,'2007-09-17 00:56:16',3310504349,1),(52803399,426005627,16380229,443749,1,'2007-09-17 00:56:16',3310504348,1),(52803402,426007026,16380264,443749,1,'2007-09-17 00:56:16',3310504348,1),(52803405,426008319,16381068,443749,1,'2007-09-17 00:56:17',3310504348,1),(52803937,426009823,16382152,443749,1,'2007-09-17 00:57:14',3310504348,1),(52803938,426011676,16382362,443749,1,'2007-09-17 00:57:14',3310504348,1),(52803940,426012445,16381628,443749,1,'2007-09-17 00:57:14',3310504348,1),(52803941,426013424,16380894,443749,1,'2007-09-17 00:57:14',3310504348,1),(52803943,426014543,16380439,443749,1,'2007-09-17 00:57:14',3310504348,1),(52803944,426016221,16380544,443749,1,'2007-09-17 00:57:14',3310504348,1),(52803954,426018424,16381138,443749,1,'2007-09-17 00:57:15',3310504348,1),(52803955,426019613,16381803,443749,1,'2007-09-17 00:57:15',3310504348,1),(52803956,426020767,16382362,443749,1,'2007-09-17 00:57:15',3310504348,1),(52803958,426021571,16382642,443749,1,'2007-09-17 00:57:15',3310504348,1),(52803959,426022375,16382607,443749,1,'2007-09-17 00:57:15',3310504348,1),(52803961,426023354,16382222,443749,1,'2007-09-17 00:57:15',3310504348,1),(52803962,426024159,16381873,443749,1,'2007-09-17 00:57:16',3310504348,1),(52803965,426024998,16381733,443749,1,'2007-09-17 00:57:16',3310504348,1),(52803969,426026676,16382152,443749,1,'2007-09-17 00:57:16',3310504348,1),(52803973,426028285,16382607,443749,1,'2007-09-17 00:57:16',3310504348,1),(52803976,426029194,16382957,443749,1,'2007-09-17 00:57:16',3310504349,1),(52803980,426010673,16382512,443749,1,'2007-09-17 00:57:16',3310504348,1),(52803983,426032432,16382471,443749,1,'2007-09-17 00:57:16',3310504349,1),(52803988,426035622,16384138,443749,1,'2007-09-17 00:57:17',3310504349,1),(52803992,426038377,16385951,443749,1,'2007-09-17 00:57:17',3310504349,1),(52803995,426040973,16387903,443749,1,'2007-09-17 00:57:17',3310504349,1),(52803998,426042272,16388831,443749,1,'2007-09-17 00:57:17',3310504349,1),(52804002,426043247,16389155,443749,1,'2007-09-17 00:57:18',3310504349,1),(52804005,426044500,16389155,443749,1,'2007-09-17 00:57:18',3310504349,1),(52804010,426045660,16388784,443749,1,'2007-09-17 00:57:18',3310504349,1),(52804014,426046727,16388135,443749,1,'2007-09-17 00:57:18',3310504349,1),(52804018,426048583,16386510,443749,1,'2007-09-17 00:57:18',3310504349,1),(52804021,426049604,16385582,443749,1,'2007-09-17 00:57:18',3310504349,1),(52804024,426051089,16384747,443749,1,'2007-09-17 00:57:19',3310504349,1),(52804026,426052620,16384422,443749,1,'2007-09-17 00:57:19',3310504349,1),(52804028,426054662,16384701,443749,1,'2007-09-17 00:57:19',3310504349,1),(52804030,426057910,16385629,443749,1,'2007-09-17 00:57:19',3310504392,1),(52804033,426060880,16386139,443749,1,'2007-09-17 00:57:19',3310504392,1),(52804036,426062782,16386464,443749,1,'2007-09-17 00:57:20',3310504392,1),(52804038,426065381,16386742,443749,1,'2007-09-17 00:57:20',3310504392,1),(52804041,426067005,16386835,443749,1,'2007-09-17 00:57:20',3310504392,1),(52804043,426068258,16386696,443749,1,'2007-09-17 00:57:20',3310504392,1),(52804046,426069836,16386325,443749,1,'2007-09-17 00:57:20',3310504392,1),(52804050,426071784,16385072,443749,1,'2007-09-17 00:57:21',3310504392,1),(52804052,426073362,16383726,443749,1,'2007-09-17 00:57:21',3310504392,1),(52804055,426030811,16384794,443749,1,'2007-09-17 00:57:21',3310504349,1),(52804060,426031739,16385536,443749,1,'2007-09-17 00:57:22',3310504349,1),(52804062,426033131,16386278,443749,1,'2007-09-17 00:57:22',3310504349,1),(52804065,426034616,16386928,443749,1,'2007-09-17 00:57:22',3310504349,1),(52804069,426035497,16387717,443749,1,'2007-09-17 00:57:23',3310504349,1),(52804073,426035683,16388970,443749,1,'2007-09-17 00:57:23',3310504349,1),(52804077,426036379,16390316,443749,1,'2007-09-17 00:57:23',3310504349,1),(52804081,426037910,16390919,443749,1,'2007-09-17 00:57:23',3310504349,1),(52804084,426039024,16391940,443749,1,'2007-09-17 00:57:23',3310504349,1),(52804087,426039720,16392543,443749,1,'2007-09-17 00:57:24',3310504349,1),(52804090,426040927,16393425,443749,1,'2007-09-17 00:57:24',3310504349,1),(52804091,426042133,16393517,443749,1,'2007-09-17 00:57:24',3310504349,1),(52804093,426043711,16393657,443749,1,'2007-09-17 00:57:24',3310504349,1),(52804096,426045056,16393842,443749,1,'2007-09-17 00:57:25',3310504349,1),(52804100,426045892,16394353,443749,1,'2007-09-17 00:57:26',3310504349,1),(52804101,426047377,16395049,443749,1,'2007-09-17 00:57:26',3310504349,1),(52804106,426048537,16395188,443749,1,'2007-09-17 00:57:26',3310504349,1),(52804109,426050393,16396719,443749,1,'2007-09-17 00:57:27',3310504349,1),(52804112,426052110,16397276,443749,1,'2007-09-17 00:57:27',3310504349,1),(52804114,426053595,16397044,443749,1,'2007-09-17 00:57:27',3310504349,1),(52804117,426055311,16396719,443749,1,'2007-09-17 00:57:27',3310504349,1),(52804118,426056843,16396534,443749,1,'2007-09-17 00:57:28',3310504392,1),(52804119,426058049,16396951,443749,1,'2007-09-17 00:57:28',3310504392,1),(52804120,426059627,16396580,443749,1,'2007-09-17 00:57:28',3310504392,1),(52804121,426060973,16395977,443749,1,'2007-09-17 00:57:28',3310504392,1),(52804122,426062690,16394724,443749,1,'2007-09-17 00:57:28',3310504392,1),(52804123,426064082,16393935,443749,1,'2007-09-17 00:57:29',3310504392,1),(52804124,426065474,16392868,443749,1,'2007-09-17 00:57:29',3310504392,1),(52804125,426067237,16391244,443749,1,'2007-09-17 00:57:29',3310504392,1),(52804126,426069232,16390084,443749,1,'2007-09-17 00:57:29',3310504392,1),(52804127,426070392,16389759,443749,1,'2007-09-17 00:57:29',3310504392,1),(52804128,426072017,16389573,443749,1,'2007-09-17 00:57:29',3310504392,1),(52804129,426073316,16390316,443749,1,'2007-09-17 00:57:29',3310504392,1),(52804130,426075218,16382102,443749,1,'2007-09-17 00:57:29',3310504392,1),(52804131,426076935,16380664,443749,1,'2007-09-17 00:57:29',3310504392,1),(52804132,426078095,16379921,443749,1,'2007-09-17 00:57:30',3310504392,1),(52804133,426079859,16379364,443749,1,'2007-09-17 00:57:30',3310504392,1),(52804134,426081158,16379272,443749,1,'2007-09-17 00:57:30',3310504392,1),(52804135,426083803,16379225,443749,1,'2007-09-17 00:57:30',3310504393,1),(52804136,426086077,16379411,443749,1,'2007-09-17 00:57:30',3310504393,1),(52804137,426089000,16380107,443749,1,'2007-09-17 00:57:30',3310504393,1),(52804138,426090717,16380292,443749,1,'2007-09-17 00:57:31',3310504393,1),(52804139,426092944,16380757,443749,1,'2007-09-17 00:57:31',3310504393,1),(52804140,426094429,16380942,443749,1,'2007-09-17 00:57:31',3310504393,1),(52804141,426095960,16380942,443749,1,'2007-09-17 00:57:31',3310504393,1),(52804142,426097074,16380710,443749,1,'2007-09-17 00:57:31',3310504393,1),(52804143,426098466,16380385,443749,1,'2007-09-17 00:57:31',3310504393,1),(52804145,426099626,16380014,443749,1,'2007-09-17 00:57:32',3310504393,1),(52804150,426101482,16379689,443749,1,'2007-09-17 00:57:32',3310504393,1),(52804160,426102967,16379550,443749,1,'2007-09-17 00:57:32',3310504393,1),(52804163,426103895,16379318,443749,1,'2007-09-17 00:57:33',3310504393,1),(52804167,426105751,16378993,443749,1,'2007-09-17 00:57:33',3310504393,1),(52804172,426107051,16378900,443749,1,'2007-09-17 00:57:33',3310504393,1),(52804173,426074429,16390223,443749,1,'2007-09-17 00:57:34',3310504392,1),(52804176,426075172,16389527,443749,1,'2007-09-17 00:57:34',3310504392,1),(52804216,426076471,16388970,443749,1,'2007-09-17 00:57:36',3310504392,1),(52804228,426077538,16388831,443749,1,'2007-09-17 00:57:37',3310504392,1),(52804233,426078745,16388599,443749,1,'2007-09-17 00:57:37',3310504392,1),(52804235,426080091,16388367,443749,1,'2007-09-17 00:57:37',3310504392,1),(52804237,426081483,16388738,443749,1,'2007-09-17 00:57:37',3310504392,1),(52804272,426081993,16389202,443749,1,'2007-09-17 00:57:40',3310504392,1),(52804275,426083478,16389202,443749,1,'2007-09-17 00:57:40',3310504392,1),(52804279,426084684,16389712,443749,1,'2007-09-17 00:57:40',3310504393,1),(52804292,426086123,16390919,443749,1,'2007-09-17 00:57:42',3310504393,1),(52804295,426087469,16391800,443749,1,'2007-09-17 00:57:44',3310504393,1),(52804297,426089046,16392264,443749,1,'2007-09-17 00:57:44',3310504393,1),(52804298,426091367,16392728,443749,1,'2007-09-17 00:57:44',3310504393,1),(52804299,426094383,16391986,443749,1,'2007-09-17 00:57:45',3310504393,1),(52804736,426096749,16390919,443749,1,'2007-09-17 00:58:41',3310504393,1),(52804739,426099301,16388923,443749,1,'2007-09-17 00:58:41',3310504393,1),(52804766,426100693,16388227,443749,1,'2007-09-17 00:58:45',3310504393,1),(52804772,426102039,16388320,443749,1,'2007-09-17 00:58:45',3310504393,1),(52804776,426103014,16387995,443749,1,'2007-09-17 00:58:45',3310504393,1),(52804777,426103478,16387253,443749,1,'2007-09-17 00:58:45',3310504393,1),(52804778,426103988,16386186,443749,1,'2007-09-17 00:58:45',3310504393,1),(52804779,426104823,16385954,443749,1,'2007-09-17 00:58:46',3310504393,1),(52804780,426106123,16386278,443749,1,'2007-09-17 00:58:46',3310504393,1),(52804788,426106865,16386186,443749,1,'2007-09-17 00:58:46',3310504393,1),(52804791,426110020,16385907,443749,1,'2007-09-17 00:58:46',3310504393,1),(52804795,426113547,16384469,443749,1,'2007-09-17 00:58:47',3310504396,1),(52804796,426117723,16382798,443749,1,'2007-09-17 00:58:47',3310504396,1),(52804798,426120368,16381128,443749,1,'2007-09-17 00:58:47',3310504396,1),(52804801,426122503,16378900,443749,1,'2007-09-17 00:58:47',3310504396,1),(52804803,426111784,16378761,443749,1,'2007-09-17 00:58:47',3310504396,1),(52804805,426120693,16378808,443749,1,'2007-09-17 00:58:47',3310504396,1),(52804807,426124962,16376441,443749,1,'2007-09-17 00:58:47',3310504396,1),(52804809,426127143,16374307,443749,1,'2007-09-17 00:58:47',3310504396,1),(52804811,426130995,16368506,443749,1,'2007-09-17 00:58:48',3310504390,1),(52804813,426133315,16365629,443749,1,'2007-09-17 00:58:48',3310504390,1),(52804815,426134985,16363031,443749,1,'2007-09-17 00:58:48',3310504390,1),(52812261,425835780,16632409,443749,1,'2007-09-17 01:24:20',3310504189,1),(52812263,425846183,16639219,443749,1,'2007-09-17 01:24:23',3310504360,1),(52812266,425852853,16644071,443749,1,'2007-09-17 01:24:32',3310504360,1),(52812268,425857238,16647103,443749,1,'2007-09-17 01:24:33',3310504362,1),(52812270,425859337,16648455,443749,1,'2007-09-17 01:25:31',3310504362,1),(52812274,425860457,16649108,443749,1,'2007-09-17 01:26:15',3310504362,1),(52812277,425861996,16649482,443749,1,'2007-09-17 01:26:39',3310504362,1),(52812281,425864235,16650135,443749,1,'2007-09-17 01:26:39',3310504363,1),(52812284,425866428,16651721,443749,1,'2007-09-17 01:26:48',3310504363,1),(52812288,425868527,16652794,443749,1,'2007-09-17 01:26:52',3310504363,1),(52812291,425870113,16653260,443749,1,'2007-09-17 01:26:59',3310504363,1),(52812295,425872072,16653680,443749,1,'2007-09-17 01:27:07',3310504363,1),(52812296,425875524,16654613,443749,1,'2007-09-17 01:27:15',3310504363,1),(52812299,425877343,16655639,443749,1,'2007-09-17 01:27:18',3310504363,1),(52812303,425879396,16657738,443749,1,'2007-09-17 01:27:19',3310504363,1),(52812305,425882474,16661610,443749,1,'2007-09-17 01:27:19',3310504363,1),(52812309,425883967,16663429,443749,1,'2007-09-17 01:27:20',3310504363,1),(52812311,425885273,16664689,443749,1,'2007-09-17 01:27:21',3310504363,1),(52812315,425887086,16665337,443749,1,'2007-09-17 01:27:22',3310504363,1),(52812318,425888772,16666368,443749,1,'2007-09-17 01:27:22',3310504363,1),(52812321,425889938,16667441,443749,1,'2007-09-17 01:27:23',3310504363,1),(52812323,425891477,16668281,443749,1,'2007-09-17 01:27:24',3310504363,1),(52812326,425893157,16669354,443749,1,'2007-09-17 01:27:24',3310504366,1),(52812329,425894463,16670940,443749,1,'2007-09-17 01:27:24',3310504366,1),(52812331,425896002,16672152,443749,1,'2007-09-17 01:27:24',3310504366,1),(52812333,425897168,16672992,443749,1,'2007-09-17 01:27:25',3310504366,1),(52812335,425898055,16675184,443749,1,'2007-09-17 01:27:25',3310504366,1),(52812338,425898614,16676071,443749,1,'2007-09-17 01:27:25',3310504366,1),(52812341,425900014,16677144,443749,1,'2007-09-17 01:27:25',3310504366,1),(52812343,425900854,16678310,443749,1,'2007-09-17 01:27:27',3310504366,1),(52812347,425901320,16679103,443749,1,'2007-09-17 01:27:29',3310504366,1),(52812350,425902393,16680502,443749,1,'2007-09-17 01:27:29',3310504366,1),(52812353,425903652,16681715,443749,1,'2007-09-17 01:27:29',3310504366,1),(52812356,425905145,16683021,443749,1,'2007-09-17 01:27:30',3310504366,1),(52812360,425906405,16684141,443749,1,'2007-09-17 01:27:30',3310504366,1),(52812363,425907897,16684934,443749,1,'2007-09-17 01:27:30',3310504366,1),(52812365,425909390,16686193,443749,1,'2007-09-17 01:27:31',3310504366,1),(52812366,425911209,16687873,443749,1,'2007-09-17 01:27:32',3310504366,1),(52812367,425913029,16689645,443749,1,'2007-09-17 01:27:32',3310504366,1),(52812369,425915547,16691371,443749,1,'2007-09-17 01:27:32',3310504366,1),(52812372,425916574,16693284,443749,1,'2007-09-17 01:27:33',3310504366,1),(52812376,425917413,16695056,443749,1,'2007-09-17 01:27:33',3310504366,1),(52812379,425918626,16697016,443749,1,'2007-09-17 01:27:33',3310504366,1),(52812380,425920492,16700561,443749,1,'2007-09-17 01:27:33',3310504709,1),(52812383,425922171,16703686,443749,1,'2007-09-17 01:27:33',3310504709,1),(52812385,425923384,16705505,443749,1,'2007-09-17 01:27:34',3310504709,1),(52812387,425924690,16706951,443749,1,'2007-09-17 01:27:34',3310504709,1),(52812389,425926043,16707884,443749,1,'2007-09-17 01:27:34',3310504709,1),(52812391,425927443,16709517,443749,1,'2007-09-17 01:27:34',3310504709,1),(52812395,425929822,16712736,443749,1,'2007-09-17 01:27:34',3310504709,1),(52812397,425932481,16716841,443749,1,'2007-09-17 01:27:35',3310504709,1),(52812399,425933740,16718473,443749,1,'2007-09-17 01:27:35',3310504709,1),(52812403,425935373,16720293,443749,1,'2007-09-17 01:27:36',3310504709,1),(52812405,425936819,16721412,443749,1,'2007-09-17 01:27:36',3310504709,1),(52812406,425938778,16722578,443749,1,'2007-09-17 01:27:37',3310504709,1),(52812407,425941903,16725237,443749,1,'2007-09-17 01:27:37',3310504709,1),(52812409,425945589,16729202,443749,1,'2007-09-17 01:27:37',3310504709,1),(52812410,425944226,16727392,443749,1,'2007-09-17 01:27:37',3310504709,1),(52812411,425948714,16732608,443749,1,'2007-09-17 01:27:37',3310504720,1),(52812413,425951326,16736153,443749,1,'2007-09-17 01:27:37',3310504720,1),(52812414,425952520,16737529,443749,1,'2007-09-17 01:27:38',3310504720,1),(52812415,425953280,16739193,443749,1,'2007-09-17 01:27:38',3310504720,1),(52812417,425953661,16740334,443749,1,'2007-09-17 01:27:38',3310504720,1),(52812418,425954707,16741523,443749,1,'2007-09-17 01:27:38',3310504720,1),(52812421,425957512,16743758,443749,1,'2007-09-17 01:27:38',3310504720,1),(52812425,425959651,16745612,443749,1,'2007-09-17 01:27:38',3310504720,1),(52812428,425961220,16747466,443749,1,'2007-09-17 01:27:38',3310504720,1),(52812440,425962551,16749748,443749,1,'2007-09-17 01:27:39',3310504720,1),(52812444,425963978,16751935,443749,1,'2007-09-17 01:27:39',3310504720,1),(52812447,425964929,16753694,443749,1,'2007-09-17 01:27:39',3310504720,1),(52812450,425966355,16755396,443749,1,'2007-09-17 01:11:58',3310504722,1),(52812453,425967971,16757916,443749,1,'2007-09-17 01:11:58',3310504722,1),(52812457,425969731,16760293,443749,1,'2007-09-17 01:11:58',3310504722,1),(52812460,425972393,16762575,443749,1,'2007-09-17 01:11:58',3310504722,1),(52812464,425974628,16764097,443749,1,'2007-09-17 01:11:58',3310504723,1),(52812468,425976767,16765475,443749,1,'2007-09-17 01:11:58',3310504723,1),(52812472,425978193,16766902,443749,1,'2007-09-17 01:11:59',3310504723,1),(52812475,425979131,16767382,443749,1,'2007-09-17 01:11:59',3310504723,1),(52812478,425980183,16767887,443749,1,'2007-09-17 01:11:59',3310504723,1),(52812481,425981193,16768097,443749,1,'2007-09-17 01:11:59',3310504723,1),(52812485,425981781,16768097,443749,1,'2007-09-17 01:11:59',3310504723,1),(52812487,425982034,16767803,443749,1,'2007-09-17 01:11:59',3310504723,1),(52812491,425981950,16767214,443749,1,'2007-09-17 01:12:00',3310504723,1),(52812494,425981655,16766120,443749,1,'2007-09-17 01:12:00',3310504723,1),(52812497,425980477,16763597,443749,1,'2007-09-17 01:12:00',3310504723,1),(52812501,425979258,16760274,443749,1,'2007-09-17 01:12:00',3310504723,1),(52812505,425978332,16758339,443749,1,'2007-09-17 01:12:00',3310504723,1),(52812507,425977112,16755689,443749,1,'2007-09-17 01:12:01',3310504723,1),(52812511,425976776,16754637,443749,1,'2007-09-17 01:12:01',3310504723,1),(52812514,425977112,16754048,443749,1,'2007-09-17 01:12:01',3310504721,1),(52812517,425977533,16754006,443749,1,'2007-09-17 01:12:01',3310504721,1),(52812520,425979089,16755520,443749,1,'2007-09-17 01:12:01',3310504723,1),(52812522,425988512,16762797,443749,1,'2007-09-17 01:12:02',3310504723,1),(52812526,425966765,16758423,443749,1,'2007-09-17 01:12:02',3310504722,1),(52812530,425968147,16761134,443749,1,'2007-09-17 01:12:03',3310504722,1),(52812531,425969437,16762765,443749,1,'2007-09-17 01:12:03',3310504722,1),(52812534,425971447,16764245,443749,1,'2007-09-17 01:12:03',3310504722,1),(52812536,425973306,16766293,443749,1,'2007-09-17 01:12:03',3310504722,1),(52812537,425975392,16769289,443749,1,'2007-09-17 01:12:03',3310504723,1),(52812540,425979109,16776762,443749,1,'2007-09-17 01:12:04',3310504723,1),(52812541,425981764,16782110,443749,1,'2007-09-17 01:12:04',3310504723,1),(52812543,425982826,16784082,443749,1,'2007-09-17 01:12:04',3310504723,1),(52812545,425983661,16786434,443749,1,'2007-09-17 01:12:04',3310504723,1),(52812547,425985140,16792541,443749,1,'2007-09-17 01:12:04',3310504723,1),(52812549,425986240,16796106,443749,1,'2007-09-17 01:12:04',3310504723,1),(52812551,425986771,16799444,443749,1,'2007-09-17 01:12:04',3310504723,1),(52812553,425987188,16801682,443749,1,'2007-09-17 01:12:05',3310504723,1),(52812555,425989919,16807447,443749,1,'2007-09-17 01:12:05',3310504723,1),(52812558,425992157,16812378,443749,1,'2007-09-17 01:12:05',3310504729,1),(52812562,425992764,16814958,443749,1,'2007-09-17 01:12:05',3310504729,1),(52812564,425995533,16820116,443749,1,'2007-09-17 01:12:06',3310504729,1),(52812566,426000919,16827209,443749,1,'2007-09-17 01:12:06',3310504729,1),(52812569,426004224,16831488,443749,1,'2007-09-17 01:12:06',3310504732,1),(52812572,426006496,16833577,443749,1,'2007-09-17 01:12:06',3310504732,1),(52812574,426008610,16834986,443749,1,'2007-09-17 01:12:06',3310504732,1),(52812577,426010321,16835943,443749,1,'2007-09-17 01:12:07',3310504732,1),(52812580,426011983,16837453,443749,1,'2007-09-17 01:12:07',3310504732,1),(52812582,426013191,16839768,443749,1,'2007-09-17 01:12:07',3310504732,1),(52812585,426016865,16850188,443749,1,'2007-09-17 01:12:07',3310504732,1),(52812587,426019080,16856480,443749,1,'2007-09-17 01:12:07',3310504732,1),(52812590,426020641,16860643,443749,1,'2007-09-17 01:12:08',3310504732,1),(52812592,426021161,16862759,443749,1,'2007-09-17 01:12:08',3310504732,1),(52812595,426021124,16865060,443749,1,'2007-09-17 01:12:08',3310504734,1),(52812597,426020753,16869736,443749,1,'2007-09-17 01:12:08',3310504734,1),(52812598,426020217,16871115,443749,1,'2007-09-17 01:12:08',3310504734,1),(52818308,425907748,16657043,443749,1,'2007-09-17 01:20:30',3310504366,1),(52818311,425906088,16656779,443749,1,'2007-09-17 01:20:30',3310504366,1),(52818312,425903975,16655534,443749,1,'2007-09-17 01:20:30',3310504366,1),(52818315,425902693,16654063,443749,1,'2007-09-17 01:20:31',3310504366,1),(52818317,425901976,16653837,443749,1,'2007-09-17 01:20:31',3310504366,1),(52818320,425901335,16654327,443749,1,'2007-09-17 01:20:31',3310504366,1),(52818322,425900165,16655006,443749,1,'2007-09-17 01:20:31',3310504366,1),(52818324,425899185,16655496,443749,1,'2007-09-17 01:20:31',3310504366,1),(52818326,425898204,16656100,443749,1,'2007-09-17 01:20:31',3310504366,1),(52818330,425897902,16656175,443749,1,'2007-09-17 01:20:32',3310504366,1),(52818332,425896959,16656175,443749,1,'2007-09-17 01:20:32',3310504366,1),(52818334,425896318,16656930,443749,1,'2007-09-17 01:20:32',3310504366,1),(52818337,425895903,16657496,443749,1,'2007-09-17 01:20:32',3310504366,1),(52818340,425895224,16658288,443749,1,'2007-09-17 01:20:32',3310504366,1),(52818343,425894054,16659306,443749,1,'2007-09-17 01:20:32',3310504366,1),(52818346,425893111,16660325,443749,1,'2007-09-17 01:20:33',3310504366,1),(52818348,425892319,16661192,443749,1,'2007-09-17 01:20:33',3310504366,1),(52818350,425890358,16661381,443749,1,'2007-09-17 01:20:33',3310504363,1),(52818352,425889528,16661758,443749,1,'2007-09-17 01:20:33',3310504363,1),(52818355,425828906,16634379,443749,1,'2007-09-17 01:20:33',3310504189,1),(52818358,425831329,16634825,443749,1,'2007-09-17 01:20:33',3310504189,1),(52818362,425834008,16636101,443749,1,'2007-09-17 01:20:34',3310504189,1),(52818365,425836177,16636483,443749,1,'2007-09-17 01:20:34',3310504189,1),(52818368,425837516,16637504,443749,1,'2007-09-17 01:20:34',3310504360,1),(52818370,425839748,16639991,443749,1,'2007-09-17 01:20:34',3310504360,1),(52818373,425841598,16643180,443749,1,'2007-09-17 01:20:34',3310504360,1),(52818377,425842746,16645285,443749,1,'2007-09-17 01:20:35',3310504362,1),(52818379,425843511,16647389,443749,1,'2007-09-17 01:20:35',3310504362,1),(52818382,425844723,16648984,443749,1,'2007-09-17 01:20:35',3310504362,1),(52818384,425845999,16649686,443749,1,'2007-09-17 01:20:35',3310504362,1),(52818385,425847274,16649749,443749,1,'2007-09-17 01:20:35',3310504362,1),(52818387,425848550,16649558,443749,1,'2007-09-17 01:20:35',3310504362,1),(52818389,425850335,16648601,443749,1,'2007-09-17 01:20:36',3310504362,1);
INSERT INTO `current_nodes` VALUES (52818390,425852440,16648027,443749,1,'2007-09-17 01:20:36',3310504362,1),(52818391,425854991,16648282,443749,1,'2007-09-17 01:20:36',3310504362,1),(52818392,425856713,16648729,443749,1,'2007-09-17 01:20:36',3310504362,1),(52818393,425857415,16650323,443749,1,'2007-09-17 01:20:36',3310504362,1),(52818394,425858627,16652938,443749,1,'2007-09-17 01:20:36',3310504362,1),(52818396,425859839,16655808,443749,1,'2007-09-17 01:20:36',3310504362,1),(52818397,425860540,16656829,443749,1,'2007-09-17 01:20:36',3310504362,1),(52818398,425861816,16658423,443749,1,'2007-09-17 01:20:37',3310504362,1),(52818399,425863857,16658933,443749,1,'2007-09-17 01:20:37',3310504362,1),(52818402,425865961,16660081,443749,1,'2007-09-17 01:20:37',3310504363,1),(52818404,425867492,16662122,443749,1,'2007-09-17 01:20:37',3310504363,1),(52818405,425869150,16664227,443749,1,'2007-09-17 01:20:37',3310504363,1),(52818406,425871446,16666714,443749,1,'2007-09-17 01:20:37',3310504363,1),(52818407,425872658,16668054,443749,1,'2007-09-17 01:20:37',3310504363,1),(52818409,425874061,16668437,443749,1,'2007-09-17 01:20:37',3310504363,1),(52818413,425875337,16668437,443749,1,'2007-09-17 01:20:38',3310504363,1),(52818415,425877123,16668883,443749,1,'2007-09-17 01:20:38',3310504363,1),(52818417,425878972,16670605,443749,1,'2007-09-17 01:20:38',3310504363,1),(52818420,425880120,16671434,443749,1,'2007-09-17 01:20:38',3310504363,1),(52818424,425880758,16673092,443749,1,'2007-09-17 01:20:38',3310504363,1),(52818427,425882289,16675006,443749,1,'2007-09-17 01:20:38',3310504363,1),(52818428,425885414,16677110,443749,1,'2007-09-17 01:20:39',3310504363,1),(52818432,425887837,16679024,443749,1,'2007-09-17 01:20:39',3310504363,1),(52818434,425889304,16681511,443749,1,'2007-09-17 01:20:39',3310504363,1),(52818437,425890771,16683807,443749,1,'2007-09-17 01:20:39',3310504363,1),(52818440,425892812,16686486,443749,1,'2007-09-17 01:20:39',3310504366,1),(52818441,425895108,16687953,443749,1,'2007-09-17 01:20:39',3310504366,1),(52818445,425897277,16688654,443749,1,'2007-09-17 01:20:40',3310504366,1),(52818446,425898807,16689994,443749,1,'2007-09-17 01:20:40',3310504366,1),(52818448,425899509,16690823,443749,1,'2007-09-17 01:20:40',3310504366,1),(52818450,425900912,16690823,443749,1,'2007-09-17 01:20:40',3310504366,1),(52818451,425902315,16690695,443749,1,'2007-09-17 01:20:40',3310504366,1),(52818452,425903846,16690695,443749,1,'2007-09-17 01:20:40',3310504366,1),(52818453,425905504,16691397,443749,1,'2007-09-17 01:20:40',3310504366,1),(52818454,425906461,16692417,443749,1,'2007-09-17 01:20:40',3310504366,1),(52818455,425907481,16694267,443749,1,'2007-09-17 01:20:41',3310504366,1),(52818456,425907992,16695606,443749,1,'2007-09-17 01:20:41',3310504366,1),(52818457,425908629,16696244,443749,1,'2007-09-17 01:20:41',3310504366,1),(52818458,425909905,16697328,443749,1,'2007-09-17 01:20:41',3310504366,1),(52818461,425911117,16698795,443749,1,'2007-09-17 01:20:41',3310504366,1),(52818463,425911882,16701665,443749,1,'2007-09-17 01:20:41',3310504708,1),(52818465,425912775,16706257,443749,1,'2007-09-17 01:20:41',3310504708,1),(52818470,425913221,16711041,443749,1,'2007-09-17 01:20:42',3310504708,1),(52818472,425913859,16712699,443749,1,'2007-09-17 01:20:42',3310504708,1),(52818475,425915581,16714995,443749,1,'2007-09-17 01:20:42',3310504708,1),(52818478,425916857,16716909,443749,1,'2007-09-17 01:20:42',3310504708,1),(52818479,425918005,16718567,443749,1,'2007-09-17 01:20:42',3310504708,1),(52818483,425918898,16720225,443749,1,'2007-09-17 01:20:42',3310504708,1),(52818485,425919663,16722585,443749,1,'2007-09-17 01:20:43',3310504709,1),(52818487,425921640,16723095,443749,1,'2007-09-17 01:20:43',3310504709,1),(52818489,425922023,16723478,443749,1,'2007-09-17 01:20:43',3310504709,1),(52818490,425924319,16726220,443749,1,'2007-09-17 01:20:43',3310504709,1),(52818491,425926551,16729409,443749,1,'2007-09-17 01:20:43',3310504709,1),(52818493,425929294,16731705,443749,1,'2007-09-17 01:20:43',3310504709,1),(52818495,425931016,16732215,443749,1,'2007-09-17 01:20:43',3310504709,1),(52818498,425931972,16732407,443749,1,'2007-09-17 01:20:44',3310504709,1),(52818501,425933121,16733363,443749,1,'2007-09-17 01:20:44',3310504709,1),(52818503,425935991,16737126,443749,1,'2007-09-17 01:20:44',3310504709,1),(52818505,425937649,16739486,443749,1,'2007-09-17 01:20:44',3310504709,1),(52818508,425938414,16740443,443749,1,'2007-09-17 01:20:44',3310504709,1),(52818511,425941157,16742293,443749,1,'2007-09-17 01:20:45',3310504709,1),(52818514,425943708,16744206,443749,1,'2007-09-17 01:20:45',3310504709,1),(52818516,425945302,16745418,443749,1,'2007-09-17 01:20:45',3310504709,1),(52818518,425946961,16745673,443749,1,'2007-09-17 01:20:45',3310504720,1),(52818520,425947790,16745418,443749,1,'2007-09-17 01:20:45',3310504720,1),(52818522,425949257,16745673,443749,1,'2007-09-17 01:20:45',3310504720,1),(52818524,425950341,16746374,443749,1,'2007-09-17 01:20:45',3310504720,1),(52818527,425951616,16748352,443749,1,'2007-09-17 01:20:45',3310504720,1),(52818529,425952382,16749117,443749,1,'2007-09-17 01:20:45',3310504720,1),(52818533,425952892,16750010,443749,1,'2007-09-17 01:20:45',3310504720,1),(52818536,425954550,16749500,443749,1,'2007-09-17 01:20:46',3310504720,1),(52818538,425956017,16748670,443749,1,'2007-09-17 01:20:46',3310504720,1),(52818539,425956719,16749181,443749,1,'2007-09-17 01:20:46',3310504720,1),(52818542,425957675,16750711,443749,1,'2007-09-17 01:20:46',3310504720,1),(52818550,425958696,16753071,443749,1,'2007-09-17 01:20:46',3310504720,1),(52818553,425958760,16754921,443749,1,'2007-09-17 01:20:46',3310504722,1),(52818555,425958823,16756388,443749,1,'2007-09-17 01:20:47',3310504722,1),(52818557,425959142,16758556,443749,1,'2007-09-17 01:20:47',3310504722,1),(52818561,425959971,16759704,443749,1,'2007-09-17 01:20:47',3310504722,1),(52818563,425961375,16760725,443749,1,'2007-09-17 01:20:47',3310504722,1),(52818564,425962012,16761809,443749,1,'2007-09-17 01:20:47',3310504722,1),(52818566,425963160,16764934,443749,1,'2007-09-17 01:20:47',3310504722,1),(52818567,425963288,16766592,443749,1,'2007-09-17 01:20:47',3310504722,1),(52818569,425963097,16767549,443749,1,'2007-09-17 01:20:47',3310504722,1),(52818572,425962841,16769271,443749,1,'2007-09-17 01:20:47',3310504722,1),(52818574,425963224,16771121,443749,1,'2007-09-17 01:20:48',3310504722,1),(52818577,425963671,16772779,443749,1,'2007-09-17 01:20:48',3310504722,1),(52818581,425964691,16774437,443749,1,'2007-09-17 01:20:48',3310504722,1),(52818582,425966222,16775458,443749,1,'2007-09-17 01:20:48',3310504722,1),(52818585,425967816,16776287,443749,1,'2007-09-17 01:20:48',3310504722,1),(52818587,425968645,16776287,443749,1,'2007-09-17 01:20:48',3310504722,1),(52818590,425969411,16776924,443749,1,'2007-09-17 01:20:49',3310504722,1),(52818592,425970304,16777562,443749,1,'2007-09-17 01:20:49',3310504722,1),(52818594,425970750,16777562,443749,1,'2007-09-17 01:20:49',3310504722,1),(52818598,425971452,16777116,443749,1,'2007-09-17 01:20:49',3310504722,1),(52818600,425972153,16777116,443749,1,'2007-09-17 01:20:50',3310504722,1),(52818603,425972982,16777945,443749,1,'2007-09-17 01:20:50',3310504722,1),(52818605,425973301,16779093,443749,1,'2007-09-17 01:20:50',3310504722,1),(52818609,425973237,16779858,443749,1,'2007-09-17 01:20:50',3310504722,1),(52818612,425973237,16781389,443749,1,'2007-09-17 01:20:51',3310504722,1),(52818615,425972345,16783621,443749,1,'2007-09-17 01:20:51',3310504722,1),(52818618,425971515,16785280,443749,1,'2007-09-17 01:20:51',3310504722,1),(52818620,425971260,16786746,443749,1,'2007-09-17 01:20:51',3310504722,1),(52818622,425971707,16789106,443749,1,'2007-09-17 01:20:51',3310504722,1),(52818623,425971643,16790190,443749,1,'2007-09-17 01:20:51',3310504722,1),(52818627,425971771,16791020,443749,1,'2007-09-17 01:20:52',3310504722,1),(52818629,425972472,16791339,443749,1,'2007-09-17 01:20:52',3310504722,1),(52818631,425972982,16792040,443749,1,'2007-09-17 01:20:52',3310504722,1),(52818633,425973237,16793507,443749,1,'2007-09-17 01:20:52',3310504722,1),(52818635,425973046,16795420,443749,1,'2007-09-17 01:20:52',3310504722,1),(52818636,425972855,16796696,443749,1,'2007-09-17 01:20:53',3310504722,1),(52818639,425972536,16798035,443749,1,'2007-09-17 01:20:53',3310504722,1),(52818641,425973110,16799757,443749,1,'2007-09-17 01:20:53',3310504722,1),(52818642,425974194,16801926,443749,1,'2007-09-17 01:20:53',3310504723,1),(52818644,425974513,16802946,443749,1,'2007-09-17 01:20:53',3310504723,1),(52818647,425975597,16804031,443749,1,'2007-09-17 01:20:54',3310504723,1),(52818648,425976618,16804605,443749,1,'2007-09-17 01:20:54',3310504723,1),(52818651,425977574,16805625,443749,1,'2007-09-17 01:20:54',3310504723,1),(52818652,425979041,16808176,443749,1,'2007-09-17 01:20:54',3310504723,1),(52818655,425980253,16810919,443749,1,'2007-09-17 01:20:54',3310504729,1),(52818657,425980827,16812386,443749,1,'2007-09-17 01:20:54',3310504729,1),(52818659,425981656,16813916,443749,1,'2007-09-17 01:20:54',3310504729,1),(52818661,425983442,16817360,443749,1,'2007-09-17 01:20:54',3310504729,1),(52818663,425983570,16818636,443749,1,'2007-09-17 01:20:55',3310504729,1),(52818669,425984016,16819529,443749,1,'2007-09-17 01:20:56',3310504729,1),(52818671,425985228,16821059,443749,1,'2007-09-17 01:20:56',3310504729,1),(52818673,425986312,16822271,443749,1,'2007-09-17 01:20:56',3310504729,1),(52818675,425987269,16822335,443749,1,'2007-09-17 01:20:56',3310504729,1),(52818677,425988736,16822016,443749,1,'2007-09-17 01:20:56',3310504729,1),(52818679,425989820,16822782,443749,1,'2007-09-17 01:20:56',3310504729,1),(52818681,425990777,16823930,443749,1,'2007-09-17 01:20:56',3310504729,1),(52818685,425992558,16826246,443749,1,'2007-09-17 01:20:57',3310504729,1),(52818687,425994236,16828402,443749,1,'2007-09-17 01:20:57',3310504729,1),(52818690,425995354,16831038,443749,1,'2007-09-17 01:20:57',3310504729,1),(52818692,425997111,16833674,443749,1,'2007-09-17 01:20:57',3310504729,1),(52818694,425998709,16835272,443749,1,'2007-09-17 01:20:58',3310504729,1),(52818720,425999827,16837029,443749,1,'2007-09-17 01:21:00',3310504729,1),(52818722,426000227,16838946,443749,1,'2007-09-17 01:21:00',3310504729,1),(52818724,425999588,16841502,443749,1,'2007-09-17 01:21:01',3310504729,1),(52818727,425999907,16842461,443749,1,'2007-09-17 01:21:01',3310504729,1),(52818729,426001585,16843499,443749,1,'2007-09-17 01:21:01',3310504732,1),(52818731,426003182,16845097,443749,1,'2007-09-17 01:21:01',3310504732,1),(52818733,426004460,16846055,443749,1,'2007-09-17 01:21:01',3310504732,1),(52818747,426005419,16847972,443749,1,'2007-09-17 01:21:03',3310504732,1),(52818757,426006377,16849410,443749,1,'2007-09-17 01:21:06',3310504732,1),(52818771,426008294,16851487,443749,1,'2007-09-17 01:21:08',3310504732,1),(52818775,426009253,16852286,443749,1,'2007-09-17 01:21:11',3310504732,1),(52818781,426010211,16853803,443749,1,'2007-09-17 01:21:11',3310504732,1),(52818791,426012608,16855880,443749,1,'2007-09-17 01:21:13',3310504732,1),(52818794,426014365,16857877,443749,1,'2007-09-17 01:21:13',3310504732,1),(52818796,426016122,16859315,443749,1,'2007-09-17 01:21:14',3310504732,1),(52818800,426017241,16860593,443749,1,'2007-09-17 01:21:14',3310504732,1),(52818803,426018598,16862830,443749,1,'2007-09-17 01:21:14',3310504732,1),(52818808,426018838,16865945,443749,1,'2007-09-17 01:21:14',3310504734,1),(52818809,426019477,16868980,443749,1,'2007-09-17 01:21:14',3310504734,1),(52818810,426020356,16872335,443749,1,'2007-09-17 01:21:15',3310504734,1),(52818812,426020356,16873453,443749,1,'2007-09-17 01:21:15',3310504734,1),(52818813,426020436,16874891,443749,1,'2007-09-17 01:21:15',3310504734,1),(52818824,426019557,16877527,443749,1,'2007-09-17 01:21:16',3310504734,1),(52818840,426018678,16879125,443749,1,'2007-09-17 01:21:18',3310504734,1),(52818846,426018279,16880483,443749,1,'2007-09-17 01:21:20',3310504734,1),(52818850,426018838,16882639,443749,1,'2007-09-17 01:21:20',3310504734,1),(52818853,426018918,16884397,443749,1,'2007-09-17 01:21:20',3310504734,1),(52818857,426018918,16885595,443749,1,'2007-09-17 01:21:20',3310504734,1),(52818862,426017400,16887671,443749,1,'2007-09-17 01:21:21',3310504734,1),(52818864,426015963,16889349,443749,1,'2007-09-17 01:21:21',3310504734,1),(52818867,426015643,16890228,443749,1,'2007-09-17 01:21:21',3310504734,1),(52818870,426032337,16875770,443749,1,'2007-09-17 01:21:21',3310504735,1),(52818872,426030261,16874332,443749,1,'2007-09-17 01:21:21',3310504735,1),(52818874,426028903,16873773,443749,1,'2007-09-17 01:21:21',3310504735,1),(52818876,426027066,16872655,443749,1,'2007-09-17 01:21:22',3310504734,1),(52818878,426025388,16872415,443749,1,'2007-09-17 01:21:22',3310504734,1),(52818879,426023711,16872415,443749,1,'2007-09-17 01:21:22',3310504734,1),(52818881,426022193,16873134,443749,1,'2007-09-17 01:21:22',3310504734,1),(52818884,426021794,16873134,443749,1,'2007-09-17 01:21:22',3310504734,1),(52824397,425782274,16586279,443749,1,'2007-09-17 01:31:57',3310504182,1),(52824401,425782950,16590169,443749,1,'2007-09-17 01:31:57',3310504188,1),(52824404,425784304,16594821,443749,1,'2007-09-17 01:31:58',3310504188,1),(52824407,425785488,16598119,443749,1,'2007-09-17 01:31:58',3310504188,1),(52824410,425787433,16603616,443749,1,'2007-09-17 01:31:58',3310504188,1),(52824414,425788701,16606576,443749,1,'2007-09-17 01:31:58',3310504188,1),(52824418,425790816,16610297,443749,1,'2007-09-17 01:31:58',3310504188,1),(52824420,425793014,16613596,443749,1,'2007-09-17 01:31:58',3310504188,1),(52824423,425794283,16617486,443749,1,'2007-09-17 01:31:59',3310504188,1),(52824433,425794706,16620700,443749,1,'2007-09-17 01:31:59',3310504188,1),(52824446,425793606,16621799,443749,1,'2007-09-17 01:32:00',3310504188,1),(52824449,425792338,16621884,443749,1,'2007-09-17 01:32:00',3310504188,1),(52824464,425791154,16621123,443749,1,'2007-09-17 01:32:01',3310504188,1),(52824474,425787771,16617571,443749,1,'2007-09-17 01:32:03',3310504188,1),(52824478,425784388,16612581,443749,1,'2007-09-17 01:32:03',3310504188,1),(52824483,425782950,16610805,443749,1,'2007-09-17 01:32:03',3310504188,1),(52824486,425781936,16610805,443749,1,'2007-09-17 01:32:04',3310504188,1),(52824489,425782189,16612412,443749,1,'2007-09-17 01:32:04',3310504188,1),(52824491,425783373,16616217,443749,1,'2007-09-17 01:32:04',3310504188,1),(52824494,425786925,16626197,443749,1,'2007-09-17 01:32:04',3310504188,1),(52824496,425788786,16630595,443749,1,'2007-09-17 01:32:04',3310504188,1),(52824499,425792253,16633385,443749,1,'2007-09-17 01:32:05',3310504188,1),(52824502,425794790,16634569,443749,1,'2007-09-17 01:32:05',3310504188,1),(52824509,425796651,16636261,443749,1,'2007-09-17 01:32:05',3310504188,1),(52824529,425801298,16633436,443749,1,'2007-09-17 01:32:07',3310504188,1),(52824530,425800798,16634623,443749,1,'2007-09-17 01:32:07',3310504188,1),(52824533,425801735,16635810,443749,1,'2007-09-17 01:32:08',3310504188,1),(52824535,425806171,16638933,443749,1,'2007-09-17 01:32:08',3310504188,1),(52824538,425809357,16640807,443749,1,'2007-09-17 01:32:08',3310504189,1),(52824541,425812356,16641807,443749,1,'2007-09-17 01:32:08',3310504189,1),(52824544,425812668,16642994,443749,1,'2007-09-17 01:32:08',3310504189,1),(52824546,425833097,16637684,443749,1,'2007-09-17 01:32:08',3310504189,1),(52824548,425831410,16638371,443749,1,'2007-09-17 01:32:09',3310504189,1),(52824552,425829036,16638933,443749,1,'2007-09-17 01:32:09',3310504189,1),(52824553,425825975,16638308,443749,1,'2007-09-17 01:32:09',3310504189,1),(52824558,425823038,16637496,443749,1,'2007-09-17 01:32:09',3310504189,1),(52824561,425820602,16637434,443749,1,'2007-09-17 01:32:09',3310504189,1),(52824564,425819103,16637559,443749,1,'2007-09-17 01:32:10',3310504189,1),(52824567,425818166,16638246,443749,1,'2007-09-17 01:32:10',3310504189,1),(52824569,425817875,16639371,443749,1,'2007-09-17 01:32:10',3310504189,1),(52824574,425818185,16640681,443749,1,'2007-09-17 01:32:10',3310504189,1),(52824576,425819415,16641807,443749,1,'2007-09-17 01:32:10',3310504189,1),(52824579,425821414,16641620,443749,1,'2007-09-17 01:32:11',3310504189,1),(52824581,425822726,16641994,443749,1,'2007-09-17 01:32:11',3310504189,1),(52824584,425823288,16642557,443749,1,'2007-09-17 01:32:11',3310504189,1),(52824586,425823538,16644431,443749,1,'2007-09-17 01:32:11',3310504189,1),(52824949,425821820,16614477,443749,1,'2007-09-17 01:32:57',3310504189,1),(52824952,425825633,16618364,443749,1,'2007-09-17 01:33:02',3310504189,1),(52824953,425828399,16621654,443749,1,'2007-09-17 01:33:02',3310504189,1),(52824954,425829296,16623074,443749,1,'2007-09-17 01:33:02',3310504189,1),(52824955,425829446,16624270,443749,1,'2007-09-17 01:33:02',3310504189,1),(52831541,425805830,16484201,443749,1,'2007-09-17 01:44:29',3310504180,1),(52831545,425804851,16486142,443749,1,'2007-09-17 01:44:29',3310504180,1),(52831548,425803769,16487167,443749,1,'2007-09-17 01:44:29',3310504180,1),(52831550,425803264,16488461,443749,1,'2007-09-17 01:44:29',3310504180,1),(52831552,425802976,16490201,443749,1,'2007-09-17 01:44:30',3310504180,1),(52831554,425802626,16491397,443749,1,'2007-09-17 01:44:30',3310504180,1),(52831559,425800133,16493970,443749,1,'2007-09-17 01:44:30',3310504180,1),(52831563,425797380,16495974,495907,1,'2008-07-15 19:52:54',3310504180,2),(52831566,425795294,16497090,495907,1,'2008-07-15 19:52:54',3310504180,2),(52831569,425794727,16499552,443749,1,'2007-09-17 01:44:31',3310504180,1),(52831574,425799301,16499704,443749,1,'2007-09-17 01:44:31',3310504180,1),(52831577,425797700,16500162,443749,1,'2007-09-17 01:44:31',3310504180,1),(52831582,425796137,16500009,443749,1,'2007-09-17 01:44:31',3310504180,1),(52831585,425794651,16499590,443749,1,'2007-09-17 01:44:32',3310504180,1),(52831588,425793279,16499743,443749,1,'2007-09-17 01:44:32',3310504180,1),(52831590,425791944,16500619,443749,1,'2007-09-17 01:44:32',3310504180,1),(52831593,425791068,16501915,443749,1,'2007-09-17 01:44:32',3310504180,1),(52831595,425790877,16504088,443749,1,'2007-09-17 01:44:32',3310504180,1),(52831598,425791144,16507061,443749,1,'2007-09-17 01:44:32',3310504180,1),(52831601,425791868,16509577,443749,1,'2007-09-17 01:44:33',3310504180,1),(52831603,425793279,16515028,443749,1,'2007-09-17 01:44:33',3310504180,1),(52831605,425803723,16504821,370566,1,'2008-05-09 02:14:21',3310504180,2),(52831608,425802122,16504889,443749,1,'2007-09-17 01:44:33',3310504180,1),(52831611,425800636,16505346,443749,1,'2007-09-17 01:44:33',3310504180,1),(52831613,425799035,16506566,443749,1,'2007-09-17 01:44:33',3310504180,1),(52831614,425797700,16507824,443749,1,'2007-09-17 01:44:33',3310504180,1),(52831615,425797662,16508586,443749,1,'2007-09-17 01:44:34',3310504180,1),(52831616,425794803,16508510,443749,1,'2007-09-17 01:44:34',3310504180,1),(52831617,425792859,16508815,443749,1,'2007-09-17 01:44:34',3310504180,1),(52831618,425802160,16509920,370566,1,'2008-05-09 02:14:22',3310504180,2),(52831619,425801055,16509920,443749,1,'2007-09-17 01:44:34',3310504180,1),(52831620,425799187,16509997,370566,1,'2008-05-09 02:14:22',3310504180,3),(52831621,425798120,16509425,443749,1,'2007-09-17 01:44:34',3310504180,1),(52831625,425798348,16511598,370566,1,'2008-05-09 02:14:22',3310504180,3),(52831627,425797281,16512741,370566,1,'2008-05-09 02:14:22',3310504180,3),(52831630,425796214,16513161,370566,1,'2008-05-09 02:14:22',3310504180,3),(52831633,425794193,16512779,370566,1,'2008-05-09 02:14:22',3310504180,3),(52831636,425793317,16512779,370566,1,'2008-05-09 02:14:22',3310504180,3),(52831638,425793088,16513008,370566,1,'2008-05-09 02:14:22',3310504180,3),(52831641,425791068,16505994,443749,1,'2007-09-17 01:44:35',3310504180,1),(52831644,425801857,16492333,370566,1,'2008-05-09 02:14:22',3310504180,2),(52832041,425802673,16493319,443749,1,'2007-09-17 01:45:34',3310504180,1),(52832042,425802780,16494282,443749,1,'2007-09-17 01:45:34',3310504180,1),(52832043,425802032,16496046,443749,1,'2007-09-17 01:45:34',3310504180,1),(52832044,425801497,16498131,443749,1,'2007-09-17 01:45:34',3310504180,1),(52832045,425801626,16499094,370566,1,'2008-05-09 02:14:21',3310504180,2),(52832046,425802249,16500488,443749,1,'2007-09-17 01:45:35',3310504180,1),(52832047,425803234,16501638,443749,1,'2007-09-17 01:45:35',3310504180,1),(52832471,425803891,16503280,443749,1,'2007-09-17 01:46:22',3310504180,1),(52834371,425801619,16512203,538211,1,'2007-09-30 15:36:21',3310504180,1),(52834531,425800661,16514365,443749,1,'2007-09-17 01:50:50',3310504180,1),(52834678,425798335,16516768,443749,1,'2007-09-17 01:51:08',3310504180,1),(52834735,425796088,16519448,443749,1,'2007-09-17 01:51:13',3310504180,1),(52834737,425794748,16522247,443749,1,'2007-09-17 01:51:13',3310504180,1),(52834749,425793217,16527324,443749,1,'2007-09-17 01:51:15',3310504180,1),(52834758,425792193,16533410,443749,1,'2007-09-17 01:51:15',3310504180,1),(52834763,425790264,16545461,443749,1,'2007-09-17 01:51:16',3310504182,1),(52834768,425789722,16549197,443749,1,'2007-09-17 01:51:17',3310504182,1),(52834775,425789722,16550522,443749,1,'2007-09-17 01:51:17',3310504182,1),(52834778,425790084,16551306,443749,1,'2007-09-17 01:51:18',3310504182,1),(52834779,425790807,16551607,443749,1,'2007-09-17 01:51:18',3310504182,1),(52834783,425791349,16551426,443749,1,'2007-09-17 01:51:19',3310504182,1),(52834784,425792193,16550402,443749,1,'2007-09-17 01:51:19',3310504182,1),(52834785,425794181,16546304,443749,1,'2007-09-17 01:51:19',3310504182,1),(52834786,425795928,16541725,443749,1,'2007-09-17 01:51:19',3310504182,1),(52834787,425796953,16537507,443749,1,'2007-09-17 01:51:19',3310504182,1),(52834788,425798158,16530638,443749,1,'2007-09-17 01:51:19',3310504180,1),(52834790,425799062,16527746,443749,1,'2007-09-17 01:51:20',3310504180,1),(52834792,425801291,16524130,443749,1,'2007-09-17 01:51:20',3310504180,1),(52834794,425804485,16520455,443749,1,'2007-09-17 01:51:20',3310504180,1),(52834795,425806112,16518587,443749,1,'2007-09-17 01:51:20',3310504180,1),(52834797,425807678,16516417,443749,1,'2007-09-17 01:51:20',3310504180,1),(52834799,425808763,16513224,443749,1,'2007-09-17 01:51:20',3310504180,1),(52834802,425808823,16509729,443749,1,'2007-09-17 01:51:20',3310504180,1),(52834805,425808703,16504366,443749,1,'2007-09-17 01:51:20',3310504180,1),(52834808,425808763,16500510,443749,1,'2007-09-17 01:51:21',3310504180,1),(52834811,425809607,16498100,443749,1,'2007-09-17 01:51:21',3310504181,1),(52834813,425810390,16497136,443749,1,'2007-09-17 01:51:21',3310504181,1),(52834816,425811113,16497196,443749,1,'2007-09-17 01:51:21',3310504181,1),(52834819,425811716,16498461,443749,1,'2007-09-17 01:51:21',3310504181,1),(52834822,425811716,16501173,443749,1,'2007-09-17 01:51:21',3310504181,1),(52834825,425812017,16515453,443749,1,'2007-09-17 01:51:21',3310504181,1),(52835977,425812017,16520394,443749,1,'2007-09-17 01:53:29',3310504181,1),(52835980,425810812,16524612,443749,1,'2007-09-17 01:53:29',3310504181,1),(52835984,425809607,16526239,443749,1,'2007-09-17 01:53:29',3310504181,1),(52835987,425807678,16529252,443749,1,'2007-09-17 01:53:29',3310504180,1),(52836001,425806172,16530578,443749,1,'2007-09-17 01:53:30',3310504180,1),(52836004,425804726,16532385,443749,1,'2007-09-17 01:53:30',3310504180,1),(52836007,425804123,16534374,443749,1,'2007-09-17 01:53:30',3310504180,1),(52836010,425805148,16537989,443749,1,'2007-09-17 01:53:31',3310504182,1),(52836012,425806112,16537869,443749,1,'2007-09-17 01:53:31',3310504182,1),(52836016,425808341,16536784,443749,1,'2007-09-17 01:53:31',3310504182,1),(52836020,425809607,16533590,443749,1,'2007-09-17 01:53:31',3310504181,1),(52836023,425792367,16532113,443749,1,'2007-09-17 01:53:31',3310504180,1),(52836027,425793699,16534169,443749,1,'2007-09-17 01:53:31',3310504180,1),(52836030,425794277,16535519,443749,1,'2007-09-17 01:53:32',3310504182,1),(52836034,425793892,16538748,443749,1,'2007-09-17 01:53:32',3310504182,1),(52836036,425792814,16545962,443749,1,'2007-09-17 01:53:32',3310504182,1),(52836038,425792526,16547091,443749,1,'2007-09-17 01:53:32',3310504182,1),(52836042,425792638,16530457,443749,1,'2007-09-17 01:53:32',3310504180,1),(52836044,425790469,16529879,443749,1,'2007-09-17 01:53:32',3310504180,1),(52836048,425787770,16529782,443749,1,'2007-09-17 01:53:33',3310504180,1),(52836052,425785697,16529879,443749,1,'2007-09-17 01:53:33',3310504180,1),(52836056,425782708,16532144,443749,1,'2007-09-17 01:53:33',3310504180,1),(52836058,425780202,16535519,443749,1,'2007-09-17 01:53:33',3310504179,1),(52836061,425779141,16538652,443749,1,'2007-09-17 01:53:34',3310504179,1),(52836065,425777743,16538748,443749,1,'2007-09-17 01:53:34',3310504179,1),(52836069,425790116,16546481,443749,1,'2007-09-17 01:53:34',3310504182,1),(52836073,425793594,16547514,443749,1,'2007-09-17 01:53:34',3310504182,1),(53273667,425642165,16780934,454632,1,'2007-09-17 18:04:32',3310504514,1),(53273668,425645963,16780340,454632,1,'2007-09-17 18:04:33',3310504515,1),(53273669,425649881,16781646,454632,1,'2007-09-17 18:04:33',3310504515,1),(53273670,425652730,16783308,454632,1,'2007-09-17 18:04:33',3310504515,1),(53273671,425655579,16783902,454632,1,'2007-09-17 18:04:34',3310504515,1),(53273672,425658547,16783545,454632,1,'2007-09-17 18:04:34',3310504515,1),(53273673,425661159,16781646,454632,1,'2007-09-17 18:04:34',3310504515,1),(53273674,425662465,16779509,454632,1,'2007-09-17 18:04:34',3310504515,1),(53273675,425662346,16776897,454632,1,'2007-09-17 18:04:35',3310504515,1),(53273676,425661990,16774048,454632,1,'2007-09-17 18:04:35',3310504515,1),(53273677,425663652,16771080,454632,1,'2007-09-17 18:04:35',3310504515,1),(53273678,425665077,16769893,454632,1,'2007-09-17 18:04:35',3310504515,1),(53273679,425667451,16770249,454632,1,'2007-09-17 18:04:35',3310504515,1),(53273680,425669350,16770962,454632,1,'2007-09-17 18:04:36',3310504515,1),(53273681,425671606,16770487,454632,1,'2007-09-17 18:04:36',3310504515,1),(53273682,425673861,16769418,454632,1,'2007-09-17 18:04:36',3310504518,1),(53273683,425676007,16769020,454632,1,'2007-09-17 18:04:36',3310504518,1),(53273684,425678621,16768899,454632,1,'2007-09-17 18:04:36',3310504518,1),(53273685,425681295,16767805,454632,1,'2007-09-17 18:04:36',3310504518,1),(53273686,425686036,16764401,454632,1,'2007-09-17 18:04:36',3310504518,1),(53273687,425693573,16758870,454632,1,'2007-09-17 18:04:37',3310504518,1),(53273688,425696673,16759113,454632,1,'2007-09-17 18:04:37',3310504518,1),(53273689,425699043,16759113,454632,1,'2007-09-17 18:04:37',3310504518,1),(53273690,425702265,16759660,454632,1,'2007-09-17 18:04:37',3310504519,1),(53273691,425704149,16758931,454632,1,'2007-09-17 18:04:38',3310504519,1),(53273692,425705121,16758201,454632,1,'2007-09-17 18:04:38',3310504519,1),(53273693,425706337,16755891,454632,1,'2007-09-17 18:04:38',3310504519,1),(53273694,425707917,16754433,454632,1,'2007-09-17 18:04:39',3310504519,1),(53273695,425709376,16753703,454632,1,'2007-09-17 18:04:39',3310504517,1),(53273696,425710592,16753825,454632,1,'2007-09-17 18:04:39',3310504517,1),(53273697,425711625,16754311,454632,1,'2007-09-17 18:04:39',3310504517,1),(53273698,425713023,16754919,454632,1,'2007-09-17 18:04:39',3310504519,1),(53273699,425714482,16755041,454632,1,'2007-09-17 18:04:39',3310504519,1),(53273700,425716488,16753643,454632,1,'2007-09-17 18:04:39',3310504517,1),(53273701,425717643,16752305,454632,1,'2007-09-17 18:04:40',3310504517,1),(53273702,425719041,16749935,454632,1,'2007-09-17 18:04:40',3310504517,1),(53273703,425719892,16745315,454632,1,'2007-09-17 18:04:40',3310504517,1),(53273704,425720439,16740757,454632,1,'2007-09-17 18:04:41',3310504517,1),(53273705,425722201,16736380,454632,1,'2007-09-17 18:04:41',3310504517,1),(53273706,425724815,16733037,454632,1,'2007-09-17 18:04:42',3310504517,1),(53273707,425728887,16728540,454632,1,'2007-09-17 18:04:42',3310504528,1),(53273708,425732352,16723799,454632,1,'2007-09-17 18:04:42',3310504528,1),(53273709,425736910,16716383,454632,1,'2007-09-17 18:04:42',3310504528,1),(53273710,425739463,16713770,454632,1,'2007-09-17 18:04:43',3310504528,1),(53273711,425742624,16711156,454632,1,'2007-09-17 18:04:43',3310504528,1),(53273712,425746149,16706354,454632,1,'2007-09-17 18:04:43',3310504528,1),(53273713,425748702,16702342,454632,1,'2007-09-17 18:04:43',3310504528,1),(53273714,425751377,16696933,454632,1,'2007-09-17 18:04:43',3310504186,1),(53273715,425752896,16691402,454632,1,'2007-09-17 18:04:43',3310504186,1),(53273716,425753018,16688545,454632,1,'2007-09-17 18:04:44',3310504186,1),(53273719,425752835,16686478,454632,1,'2007-09-17 18:04:44',3310504186,1),(53273723,425752835,16684108,454632,1,'2007-09-17 18:04:44',3310504186,1),(53273724,425752714,16680583,454632,1,'2007-09-17 18:04:44',3310504186,1),(53273725,425753261,16676753,454632,1,'2007-09-17 18:04:44',3310504186,1),(53273726,425753929,16673714,454632,1,'2007-09-17 18:04:44',3310504186,1),(53273727,425754841,16669338,454632,1,'2007-09-17 18:04:45',3310504187,1),(53273728,425754963,16666177,454632,1,'2007-09-17 18:04:45',3310504187,1),(53273729,425754659,16663138,454632,1,'2007-09-17 18:04:45',3310504187,1),(53273730,425754720,16659430,454632,1,'2007-09-17 18:04:46',3310504187,1),(53273731,425755449,16656391,454632,1,'2007-09-17 18:04:46',3310504187,1),(53273732,425756665,16651164,454632,1,'2007-09-17 18:04:46',3310504187,1),(53273733,425758427,16645511,454632,1,'2007-09-17 18:04:46',3310504187,1),(53273734,425758549,16640406,454632,1,'2007-09-17 18:04:47',3310504185,1),(53273735,425758792,16635847,454632,1,'2007-09-17 18:04:48',3310504185,1),(53273736,425759643,16628067,454632,1,'2007-09-17 18:04:48',3310504185,1),(53273737,425760312,16620044,454632,1,'2007-09-17 18:04:48',3310504185,1),(53273738,425760312,16615485,454632,1,'2007-09-17 18:04:48',3310504185,1),(53273739,425760190,16610562,454632,1,'2007-09-17 18:04:48',3310504185,1),(53273740,425759521,16607036,454632,1,'2007-09-17 18:04:48',3310504185,1),(53273741,425759643,16604180,454632,1,'2007-09-17 18:04:48',3310504185,1),(53273742,425760676,16598891,454632,1,'2007-09-17 18:05:38',3310504185,1),(53273743,425761649,16592266,454632,1,'2007-09-17 18:05:38',3310504185,1),(53273744,425762135,16588255,454632,1,'2007-09-17 18:05:39',3310504179,1),(53273745,425761831,16585337,454632,1,'2007-09-17 18:05:39',3310504179,1),(53273746,425761345,16581933,454632,1,'2007-09-17 18:05:39',3310504179,1),(53273747,425761953,16579563,454632,1,'2007-09-17 18:05:39',3310504179,1),(53273748,425762986,16575977,454632,1,'2007-09-17 18:05:40',3310504179,1),(53273749,425764749,16570932,454632,1,'2007-09-17 18:05:40',3310504179,1),(53273750,425766451,16568136,454632,1,'2007-09-17 18:05:40',3310504179,1),(53273751,425766998,16564793,454632,1,'2007-09-17 18:05:40',3310504179,1),(53273752,425766998,16561814,454632,1,'2007-09-17 18:05:40',3310504179,1),(53273753,425768031,16557377,454632,1,'2007-09-17 18:05:41',3310504179,1),(53273754,425769611,16554946,454632,1,'2007-09-17 18:05:41',3310504179,1),(53273755,425771556,16553427,454632,1,'2007-09-17 18:05:41',3310504179,1),(53273756,425773744,16552940,454632,1,'2007-09-17 18:05:41',3310504179,1),(53273757,425826191,16634427,454632,1,'2007-09-17 18:05:41',3310504189,1),(53273758,425823992,16633694,454632,1,'2007-09-17 18:05:41',3310504189,1),(53273759,425821792,16632123,454632,1,'2007-09-17 18:05:42',3310504189,1),(53273760,425819907,16630342,454632,1,'2007-09-17 18:05:42',3310504189,1),(53273761,425818126,16628352,454632,1,'2007-09-17 18:05:42',3310504189,1),(53273762,425817288,16626990,454632,1,'2007-09-17 18:05:42',3310504189,1),(53273763,425816241,16625733,454632,1,'2007-09-17 18:05:42',3310504189,1),(53273764,425814984,16625419,454632,1,'2007-09-17 18:05:42',3310504189,1),(53273765,425813936,16622591,454632,1,'2007-09-17 18:05:43',3310504189,1),(53273766,425811842,16621439,454632,1,'2007-09-17 18:05:43',3310504189,1),(53273767,425810019,16620471,454632,1,'2007-09-17 18:05:43',3310504189,1),(53273768,425808276,16619197,454632,1,'2007-09-17 18:05:43',3310504188,1),(53273769,425806868,16616985,454632,1,'2007-09-17 18:05:43',3310504188,1),(53273770,425804187,16612226,454632,1,'2007-09-17 18:05:43',3310504188,1),(53273771,425799763,16606796,454632,1,'2007-09-17 18:05:43',3310504188,1),(53273772,425796143,16602640,454632,1,'2007-09-17 18:05:44',3310504188,1),(53273773,425793461,16600562,454632,1,'2007-09-17 18:05:44',3310504188,1),(53273774,425790378,16596607,454632,1,'2007-09-17 18:05:44',3310504188,1),(53273775,425789506,16595802,454632,1,'2007-09-17 18:05:44',3310504188,1),(53273776,425781931,16574485,454632,1,'2007-09-17 18:05:44',3310504182,1),(53273777,425780524,16572541,454632,1,'2007-09-17 18:05:45',3310504179,1),(53273778,425778982,16570530,454632,1,'2007-09-17 18:05:45',3310504179,1),(53273779,425777976,16567446,454632,1,'2007-09-17 18:05:46',3310504179,1),(53273780,425776502,16562754,454632,1,'2007-09-17 18:05:46',3310504179,1),(53273781,425774155,16555313,454632,1,'2007-09-17 18:05:46',3310504179,1),(53273782,425773771,16548337,454632,1,'2007-09-17 18:05:46',3310504179,1),(53273783,425773828,16545519,454632,1,'2007-09-17 18:05:46',3310504179,1),(53273784,425773771,16541207,454632,1,'2007-09-17 18:05:46',3310504179,1),(53273785,425774173,16538102,454632,1,'2007-09-17 18:05:46',3310504179,1),(53273786,425774691,16535399,454632,1,'2007-09-17 18:05:47',3310504179,1),(53273787,425775669,16531144,454632,1,'2007-09-17 18:05:47',3310504177,1),(53273788,425777049,16524646,454632,1,'2007-09-17 18:05:47',3310504177,1),(53273789,425778256,16520448,454632,1,'2007-09-17 18:05:47',3310504177,1),(53273790,425780671,16514641,454632,1,'2007-09-17 18:05:47',3310504177,1),(53273791,425782856,16510845,454632,1,'2007-09-17 18:05:48',3310504180,1),(53273792,425784064,16507108,454632,1,'2007-09-17 18:05:48',3310504180,1),(53273793,425784294,16504693,454632,1,'2007-09-17 18:05:48',3310504180,1),(53273794,425784294,16502220,454632,1,'2007-09-17 18:05:48',3310504180,1),(53273795,425784294,16499403,454632,1,'2007-09-17 18:05:48',3310504180,1),(53273796,425784179,16495320,454632,1,'2007-09-17 18:05:49',3310504180,1),(53273797,425783604,16490547,454632,1,'2007-09-17 18:05:49',3310504180,1),(53273798,425782971,16485544,454632,1,'2007-09-17 18:05:49',3310504180,1),(53273799,425784294,16484164,454632,1,'2007-09-17 18:05:49',3310504180,1),(53273800,425785674,16485027,454632,1,'2007-09-17 18:05:49',3310504180,1),(53273801,425787054,16485314,454632,1,'2007-09-17 18:05:49',3310504180,1),(53273802,425789412,16484854,454632,1,'2007-09-17 18:05:50',3310504180,1),(53273803,425791654,16482957,454632,1,'2007-09-17 18:05:50',3310504180,1),(53273804,425794529,16479219,454632,1,'2007-09-17 18:05:50',3310504158,1),(53273805,425797117,16475194,454632,1,'2007-09-17 18:05:50',3310504158,1),(53273806,425797922,16472089,454632,1,'2007-09-17 18:05:51',3310504158,1),(53273807,425798037,16469444,454632,1,'2007-09-17 18:05:51',3310504158,1),(53273808,425797404,16465591,454632,1,'2007-09-17 18:05:51',3310504158,1),(53273810,425796427,16463119,454632,1,'2007-09-17 18:05:52',3310504158,1),(53273811,425794529,16461163,454632,1,'2007-09-17 18:05:52',3310504158,1),(53273812,425793207,16457828,454632,1,'2007-09-17 18:05:52',3310504158,1),(53273813,425793092,16453918,454632,1,'2007-09-17 18:05:52',3310504158,1),(53273814,425793264,16449318,454632,1,'2007-09-17 18:05:52',3310504158,1),(53273815,425792574,16446385,454632,1,'2007-09-17 18:05:52',3310504158,1),(53273816,425790792,16442648,454632,1,'2007-09-17 18:05:52',3310504158,1),(53273817,425789067,16440060,454632,1,'2007-09-17 18:05:53',3310504158,1),(53273818,425788319,16438623,454632,1,'2007-09-17 18:05:53',3310504158,1),(53273819,425788319,16436035,454632,1,'2007-09-17 18:05:53',3310504158,1),(53273820,425789527,16434080,454632,1,'2007-09-17 18:05:53',3310504158,1),(53273821,425791367,16430975,454632,1,'2007-09-17 18:05:53',3310504158,1),(53273822,425792344,16429135,454632,1,'2007-09-17 18:05:54',3310504158,1),(53273823,425792517,16427985,454632,1,'2007-09-17 18:05:54',3310504158,1),(53273824,425792517,16427007,454632,1,'2007-09-17 18:05:54',3310504158,1),(53273825,425791654,16425110,454632,1,'2007-09-17 18:05:54',3310504158,1),(53273826,425789527,16420739,454632,1,'2007-09-17 18:05:54',3310504156,1),(53273827,425787801,16416369,454632,1,'2007-09-17 18:05:54',3310504156,1),(53273828,425786824,16412804,454632,1,'2007-09-17 18:05:55',3310504156,1),(53273829,425786881,16410504,454632,1,'2007-09-17 18:05:55',3310504156,1),(53273830,425787801,16407744,454632,1,'2007-09-17 18:05:55',3310504156,1),(53273831,425788608,16405749,454632,1,'2007-09-17 18:05:55',3310504156,1),(53273832,425788873,16404777,454632,1,'2007-09-17 18:05:55',3310504156,1),(53273833,425788799,16402492,454632,1,'2007-09-17 18:05:55',3310504156,1),(53273834,425790238,16395037,495907,1,'2008-07-15 19:50:23',3310504156,2),(53273836,425787788,16395091,454632,1,'2007-09-17 18:05:56',3310504156,1),(53273838,425788335,16396580,454632,1,'2007-09-17 18:05:56',3310504156,1),(53273839,425788655,16397804,454632,1,'2007-09-17 18:05:56',3310504156,1),(53273841,425789409,16399726,454632,1,'2007-09-17 18:05:56',3310504156,1),(53273843,425789371,16400894,454632,1,'2007-09-17 18:05:56',3310504156,1),(53273844,425789220,16401535,454632,1,'2007-09-17 18:05:56',3310504156,1),(53273846,425788373,16402081,454632,1,'2007-09-17 18:05:57',3310504156,1),(53273848,425788033,16402006,454632,1,'2007-09-17 18:05:57',3310504156,1),(53273849,425787883,16401950,454632,1,'2007-09-17 18:05:57',3310504156,1),(53273851,425787261,16401677,454632,1,'2007-09-17 18:05:57',3310504156,1),(53273852,425787059,16401216,454632,1,'2007-09-17 18:05:57',3310504156,1),(53273853,425786524,16400995,454632,1,'2007-09-17 18:05:58',3310504156,1),(53273854,425786358,16400461,454632,1,'2007-09-17 18:05:58',3310504156,1),(53273855,425786008,16399594,454632,1,'2007-09-17 18:05:58',3310504156,1),(53273856,425785602,16398875,454632,1,'2007-09-17 18:05:58',3310504156,1),(53273857,425785547,16398193,454632,1,'2007-09-17 18:05:58',3310504156,1),(53273858,425786303,16395741,454632,1,'2007-09-17 18:05:58',3310504156,1),(53273859,425786690,16394911,454632,1,'2007-09-17 18:05:59',3310504156,1),(53273860,425787759,16395003,454632,1,'2007-09-17 18:05:59',3310504156,1),(53273861,425787543,16401869,454632,1,'2007-09-17 18:05:59',3310504156,1),(53273862,425806928,16363647,454632,1,'2007-09-17 18:05:59',3310504150,1),(53273863,425807531,16365751,454632,1,'2007-09-17 18:05:59',3310504150,1),(53273864,425808244,16366385,454632,1,'2007-09-17 18:05:59',3310504150,1),(53273865,425809323,16366655,454632,1,'2007-09-17 18:06:00',3310504151,1),(53273866,425810805,16367104,454632,1,'2007-09-17 18:06:00',3310504151,1),(53273867,425812737,16367194,454632,1,'2007-09-17 18:06:00',3310504151,1),(53273868,425814759,16366790,454632,1,'2007-09-17 18:06:00',3310504151,1),(53273869,425816646,16366161,454632,1,'2007-09-17 18:06:00',3310504151,1),(53273870,425818443,16366026,454632,1,'2007-09-17 18:06:00',3310504151,1),(53273871,425821364,16366475,454632,1,'2007-09-17 18:06:00',3310504151,1),(53273872,425823251,16367554,454632,1,'2007-09-17 18:06:01',3310504151,1),(53273873,425824554,16368946,454632,1,'2007-09-17 18:06:01',3310504151,1),(53273874,425825093,16370429,454632,1,'2007-09-17 18:06:01',3310504157,1),(53273875,425825183,16371507,454632,1,'2007-09-17 18:06:01',3310504157,1),(53273876,425824419,16372316,454632,1,'2007-09-17 18:06:01',3310504157,1),(53273877,425822756,16373799,454632,1,'2007-09-17 18:06:01',3310504157,1),(53273878,425819342,16376090,454632,1,'2007-09-17 18:06:01',3310504157,1),(53273879,425806601,16360619,454632,1,'2007-09-17 18:06:01',3310504150,1),(53273880,425806436,16357982,454632,1,'2007-09-17 18:06:02',3310504150,1),(53273881,425806271,16356498,454632,1,'2007-09-17 18:06:02',3310504150,1),(53273882,425805447,16354630,454632,1,'2007-09-17 18:06:02',3310504150,1),(53273883,425803524,16352047,454632,1,'2007-09-17 18:06:02',3310504150,1),(53273884,425801545,16349739,454632,1,'2007-09-17 18:06:02',3310504150,1),(53273885,425800996,16348970,454632,1,'2007-09-17 18:06:02',3310504150,1),(53273886,425800776,16348200,454632,1,'2007-09-17 18:06:02',3310504150,1),(53273887,425800556,16347486,454632,1,'2007-09-17 18:06:03',3310504150,1),(53273888,425800337,16346552,454632,1,'2007-09-17 18:06:03',3310504150,1),(53273889,425799457,16345453,454632,1,'2007-09-17 18:06:03',3310504150,1),(53273890,425798358,16344738,454632,1,'2007-09-17 18:06:03',3310504150,1),(53273891,425797919,16343474,454632,1,'2007-09-17 18:06:03',3310504150,1),(53273892,425797974,16342046,454632,1,'2007-09-17 18:06:03',3310504150,1),(53273893,425798193,16340507,454632,1,'2007-09-17 18:06:03',3310504150,1),(53273894,425798688,16338034,454632,1,'2007-09-17 18:06:03',3310504150,1),(53273895,425799622,16335122,454632,1,'2007-09-17 18:06:04',3310504150,1),(53273896,425800721,16333199,454632,1,'2007-09-17 18:06:04',3310504150,1),(53273897,425801875,16331715,454632,1,'2007-09-17 18:06:04',3310504150,1),(53273898,425802535,16330781,454632,1,'2007-09-17 18:06:04',3310504150,1),(53273899,425803139,16329462,454632,1,'2007-09-17 18:06:04',3310504150,1),(53273900,425803249,16327868,454632,1,'2007-09-17 18:06:04',3310504150,1),(53273901,425803497,16325538,454632,1,'2007-09-17 18:06:04',3310504150,1),(53273902,425803857,16323333,454632,1,'2007-09-17 18:06:04',3310504150,1),(53273903,425804555,16321397,454632,1,'2007-09-17 18:06:05',3310504150,1),(53273904,425805545,16319596,454632,1,'2007-09-17 18:06:05',3310504150,1),(53273905,425806558,16318133,454632,1,'2007-09-17 18:06:05',3310504150,1),(53273906,425807278,16317413,454632,1,'2007-09-17 18:06:05',3310504150,1),(53273907,425807954,16317480,454632,1,'2007-09-17 18:06:05',3310504150,1),(53273908,425808359,16317931,454632,1,'2007-09-17 18:06:05',3310504150,1),(53273909,425808471,16318426,454632,1,'2007-09-17 18:06:05',3310504150,1),(53273910,425808449,16318673,454632,1,'2007-09-17 18:06:05',3310504150,1),(53273911,425808291,16319641,454632,1,'2007-09-17 18:06:06',3310504150,1),(53273912,425807684,16320564,454632,1,'2007-09-17 18:06:06',3310504150,1),(53273913,425806986,16321937,454632,1,'2007-09-17 18:06:06',3310504150,1),(53273914,425806468,16323940,454632,1,'2007-09-17 18:06:06',3310504150,1),(53273915,425806581,16325786,454632,1,'2007-09-17 18:06:06',3310504150,1),(53273916,425807368,16327767,454632,1,'2007-09-17 18:06:06',3310504150,1),(53273917,425807967,16328968,454632,1,'2007-09-17 18:06:06',3310504150,1),(53273918,425808564,16330013,454632,1,'2007-09-17 18:06:07',3310504150,1),(53273919,425809311,16330461,454632,1,'2007-09-17 18:06:07',3310504151,1),(53273920,425811044,16329386,454632,1,'2007-09-17 18:06:07',3310504151,1),(53273921,425812209,16328191,454632,1,'2007-09-17 18:06:07',3310504151,1),(53273922,425812746,16326488,454632,1,'2007-09-17 18:06:07',3310504151,1),(53273923,425813165,16324427,454632,1,'2007-09-17 18:06:07',3310504151,1),(53273924,425813822,16321858,454632,1,'2007-09-17 18:06:07',3310504151,1),(53273925,425814449,16320903,454632,1,'2007-09-17 18:06:07',3310504151,1),(53273926,425814957,16320992,454632,1,'2007-09-17 18:06:08',3310504151,1),(53273927,425815375,16321351,454632,1,'2007-09-17 18:06:08',3310504151,1),(53273928,425815345,16321918,454632,1,'2007-09-17 18:06:08',3310504151,1),(53273929,425820005,16335091,454632,1,'2007-09-17 18:06:08',3310504151,1),(53273930,425820184,16336883,454632,1,'2007-09-17 18:06:08',3310504151,1),(53273931,425820065,16337899,454632,1,'2007-09-17 18:06:08',3310504151,1),(53273932,425819736,16339392,454632,1,'2007-09-17 18:06:08',3310504151,1),(53273933,425819318,16341692,454632,1,'2007-09-17 18:06:09',3310504151,1),(53273934,425819109,16342947,454632,1,'2007-09-17 18:06:09',3310504151,1),(53273935,425819019,16343783,454632,1,'2007-09-17 18:06:09',3310504151,1),(53273936,425818511,16344112,454632,1,'2007-09-17 18:06:09',3310504151,1),(53273937,425817914,16343753,454632,1,'2007-09-17 18:06:09',3310504151,1),(53273938,425817466,16342439,454632,1,'2007-09-17 18:06:09',3310504151,1),(53273939,425817078,16341453,454632,1,'2007-09-17 18:06:09',3310504151,1),(53273940,425816271,16341185,454632,1,'2007-09-17 18:06:10',3310504151,1),(53273941,425815435,16340527,454632,1,'2007-09-17 18:06:10',3310504151,1),(53273942,425815046,16339572,454632,1,'2007-09-17 18:06:10',3310504151,1),(53273943,425814778,16339273,454632,1,'2007-09-17 18:06:10',3310504151,1),(53273944,425813523,16339004,454632,1,'2007-09-17 18:06:10',3310504151,1),(53273945,425812746,16338616,454632,1,'2007-09-17 18:06:10',3310504151,1),(53273946,425812179,16337869,454632,1,'2007-09-17 18:06:10',3310504151,1),(53273947,425811940,16337630,454632,1,'2007-09-17 18:06:10',3310504151,1),(53273948,425811313,16337600,454632,1,'2007-09-17 18:06:10',3310504151,1),(53273949,425810864,16337720,454632,1,'2007-09-17 18:06:11',3310504151,1),(53273950,425810267,16338765,454632,1,'2007-09-17 18:06:11',3310504151,1),(53273951,425809640,16340527,454632,1,'2007-09-17 18:06:11',3310504151,1),(53273952,425809610,16341752,454632,1,'2007-09-17 18:06:11',3310504151,1),(53273953,425809550,16342887,454632,1,'2007-09-17 18:06:11',3310504151,1),(53273954,425809251,16343455,454632,1,'2007-09-17 18:06:11',3310504151,1),(53273955,425808415,16342768,454632,1,'2007-09-17 18:06:11',3310504150,1),(53273956,425808057,16341603,454632,1,'2007-09-17 18:06:11',3310504150,1),(53273957,425807967,16339661,454632,1,'2007-09-17 18:06:12',3310504150,1),(53273958,425808415,16337242,454632,1,'2007-09-17 18:06:12',3310504150,1),(53273959,425808953,16334972,454632,1,'2007-09-17 18:06:12',3310504150,1),(53273960,425809789,16330700,454632,1,'2007-09-17 18:06:12',3310504151,1),(53273961,425809819,16330312,454632,1,'2007-09-17 18:06:12',3310504151,1),(53273962,425789719,16370883,454632,1,'2007-09-17 18:06:12',3310504156,1),(53273963,425790233,16370575,454632,1,'2007-09-17 18:06:12',3310504156,1),(53273964,425790684,16370456,454632,1,'2007-09-17 18:06:12',3310504156,1),(53273965,425790827,16370694,454632,1,'2007-09-17 18:06:12',3310504156,1),(53273966,425790850,16371264,454632,1,'2007-09-17 18:06:12',3310504156,1),(53273967,425790803,16372001,454632,1,'2007-09-17 18:06:13',3310504156,1),(53273968,425785968,16381042,454632,1,'2007-09-17 18:06:13',3310504156,1),(53273969,425786129,16385827,454632,1,'2007-09-17 18:06:13',3310504156,1),(53273970,425787255,16394794,454632,1,'2007-09-17 18:06:13',3310504156,1),(53273971,425786446,16378201,454632,1,'2007-09-17 18:06:13',3310504156,1),(53273972,425786053,16376382,454632,1,'2007-09-17 18:06:13',3310504156,1),(53273973,425784676,16374119,454632,1,'2007-09-17 18:06:13',3310504156,1),(53273974,425783790,16371710,454632,1,'2007-09-17 18:06:13',3310504156,1),(53273975,425782905,16367234,454632,1,'2007-09-17 18:06:13',3310504150,1),(53273976,425782413,16363250,454632,1,'2007-09-17 18:06:14',3310504150,1),(53273977,425782413,16359857,454632,1,'2007-09-17 18:06:14',3310504150,1),(53273978,425782020,16356808,454632,1,'2007-09-17 18:06:14',3310504150,1),(53273979,425781184,16354988,454632,1,'2007-09-17 18:06:14',3310504147,1),(53273980,425780397,16349136,454632,1,'2007-09-17 18:06:14',3310504147,1),(53273981,425780151,16345693,454632,1,'2007-09-17 18:06:14',3310504147,1),(53273982,425779413,16341119,454632,1,'2007-09-17 18:06:14',3310504147,1),(53273983,425779315,16337922,454632,1,'2007-09-17 18:06:14',3310504147,1),(53273984,425778971,16332021,454632,1,'2007-09-17 18:06:14',3310504147,1),(53273985,425779266,16328185,454632,1,'2007-09-17 18:06:15',3310504147,1),(53273986,425779856,16322332,454632,1,'2007-09-17 18:06:15',3310504147,1),(53273987,425780741,16318102,454632,1,'2007-09-17 18:06:15',3310504147,1),(53273988,425781528,16314266,454632,1,'2007-09-17 18:06:15',3310504145,1),(53273989,425782069,16310529,454632,1,'2007-09-17 18:06:15',3310504148,1),(53273990,425781872,16307430,454632,1,'2007-09-17 18:06:15',3310504148,1),(53273991,425781872,16304529,454632,1,'2007-09-17 18:06:16',3310504148,1),(53273992,425781922,16302660,454632,1,'2007-09-17 18:06:16',3310504148,1),(53273993,425781331,16301037,454632,1,'2007-09-17 18:06:16',3310504145,1),(53273994,425779217,16298086,454632,1,'2007-09-17 18:06:16',3310504145,1),(53273995,425777102,16295824,454632,1,'2007-09-17 18:06:17',3310504145,1),(53273996,425775774,16293856,454632,1,'2007-09-17 18:06:17',3310504145,1),(53273997,425775430,16290463,454632,1,'2007-09-17 18:06:17',3310504145,1),(53273998,425775282,16288594,454632,1,'2007-09-17 18:06:17',3310504145,1),(53274000,425788856,16282446,454632,1,'2007-09-17 18:06:17',3310504148,1),(53274002,425788856,16286037,454632,1,'2007-09-17 18:06:17',3310504148,1),(53274003,425788807,16289086,454632,1,'2007-09-17 18:06:18',3310504148,1),(53274004,425788561,16290119,454632,1,'2007-09-17 18:06:18',3310504148,1),(53274005,425788118,16291250,454632,1,'2007-09-17 18:06:18',3310504148,1),(53274006,425788709,16294201,454632,1,'2007-09-17 18:06:18',3310504148,1),(53274007,425789692,16297447,454632,1,'2007-09-17 18:06:18',3310504148,1),(53274008,425790873,16300988,454632,1,'2007-09-17 18:06:18',3310504148,1),(53274009,425791463,16303742,454632,1,'2007-09-17 18:06:18',3310504148,1),(53274010,425791709,16308414,454632,1,'2007-09-17 18:06:19',3310504148,1),(53274011,425791364,16310971,454632,1,'2007-09-17 18:06:19',3310504148,1),(53274012,425790332,16315004,454632,1,'2007-09-17 18:06:19',3310504150,1),(53274013,425788315,16318545,454632,1,'2007-09-17 18:06:19',3310504150,1),(53274014,425786545,16321299,454632,1,'2007-09-17 18:06:19',3310504150,1),(53274015,425785856,16323660,454632,1,'2007-09-17 18:06:19',3310504150,1),(53274016,425784929,16329205,495907,1,'2008-07-15 19:49:19',3310504150,3),(53274017,425784550,16332466,495907,1,'2008-07-15 19:49:19',3310504150,3),(53274018,425784107,16338818,495907,1,'2008-07-15 19:49:19',3310504150,3),(53274019,425783981,16342852,495907,1,'2008-07-15 19:49:19',3310504150,3),(53274020,425784044,16345770,495907,1,'2008-07-15 19:49:19',3310504150,3),(53274021,425783539,16346628,495907,1,'2008-07-15 19:48:55',3310504150,2),(53274022,425783286,16346542,495907,1,'2008-07-15 19:48:35',3310504150,2),(53274023,425773850,16283044,454632,1,'2007-09-17 18:06:20',3310504145,1),(53274024,425773026,16279473,454632,1,'2007-09-17 18:06:20',3310504145,1),(53274025,425773105,16277786,454632,1,'2007-09-17 18:06:21',3310504145,1),(53274026,425774046,16274687,454632,1,'2007-09-17 18:06:21',3310504145,1),(53274027,425775223,16271979,454632,1,'2007-09-17 18:06:21',3310504145,1),(53274028,425775773,16268880,454632,1,'2007-09-17 18:06:21',3310504145,1),(53274029,425775420,16266094,454632,1,'2007-09-17 18:06:21',3310504145,1),(53274030,425774125,16263818,454632,1,'2007-09-17 18:06:21',3310504145,1),(53274031,425772673,16261385,454632,1,'2007-09-17 18:06:22',3310504145,1),(53274883,425769476,16258599,454632,1,'2007-09-17 18:30:03',3310504059,1),(53274884,425766090,16256547,454632,1,'2007-09-17 18:30:03',3310504059,1),(53274885,425762807,16253264,454632,1,'2007-09-17 18:30:03',3310504059,1),(53274886,425760242,16250904,454632,1,'2007-09-17 18:30:03',3310504059,1),(53274888,425757779,16247723,557925,1,'2008-01-06 23:25:40',3310504059,2),(53274890,425756138,16243619,454632,1,'2007-09-17 18:30:04',3310504059,1),(53274891,425756343,16240233,454632,1,'2007-09-17 18:30:04',3310504059,1),(53274892,425756548,16234590,454632,1,'2007-09-17 18:30:04',3310504059,1),(53274893,425756343,16231307,454632,1,'2007-09-17 18:30:04',3310504059,1),(53274894,425754906,16227203,454632,1,'2007-09-17 18:30:04',3310504059,1),(53274895,425752957,16223919,454632,1,'2007-09-17 18:30:04',3310504058,1),(53274896,425749058,16220739,454632,1,'2007-09-17 18:30:04',3310504058,1),(53274898,425745569,16217455,454632,1,'2007-09-17 18:30:05',3310504058,1),(53274899,425742081,16213043,454632,1,'2007-09-17 18:30:05',3310504058,1),(53274900,425738798,16209042,454632,1,'2007-09-17 18:30:05',3310504058,1),(53274901,425736848,16204732,454632,1,'2007-09-17 18:30:05',3310504056,1),(53274902,425736951,16200628,454632,1,'2007-09-17 18:30:05',3310504056,1),(53274903,425738182,16195601,454632,1,'2007-09-17 18:30:05',3310504056,1),(53274904,425739003,16190881,454632,1,'2007-09-17 18:30:06',3310504056,1),(53274906,425738079,16188213,454632,1,'2007-09-17 18:30:06',3310504056,1),(53274907,425735822,16186777,454632,1,'2007-09-17 18:30:06',3310504056,1),(53274908,425733257,16184519,454632,1,'2007-09-17 18:30:06',3310504056,1),(53274909,425731410,16180928,454632,1,'2007-09-17 18:30:06',3310504056,1),(53274910,425729050,16174567,454632,1,'2007-09-17 18:30:06',3310504056,1),(53274911,425727306,16167590,454632,1,'2007-09-17 18:30:06',3310504056,1),(53274912,425726485,16162665,454632,1,'2007-09-17 18:30:06',3310504045,1),(53274913,425725870,16158253,454632,1,'2007-09-17 18:30:06',3310504045,1),(53274915,425723715,16153225,454632,1,'2007-09-17 18:30:07',3310504045,1),(53274916,425720945,16148608,454632,1,'2007-09-17 18:30:07',3310504039,1),(53274917,425716840,16143786,454632,1,'2007-09-17 18:30:07',3310504039,1),(53274918,425715609,16141631,454632,1,'2007-09-17 18:30:07',3310504039,1),(53274919,425715301,16139066,454632,1,'2007-09-17 18:30:07',3310504039,1),(53274920,425716122,16134962,454632,1,'2007-09-17 18:30:07',3310504039,1),(53274921,425717456,16130447,454632,1,'2007-09-17 18:30:07',3310504039,1),(53274922,425717456,16127780,454632,1,'2007-09-17 18:30:07',3310504039,1),(53274924,425716840,16124496,454632,1,'2007-09-17 18:30:08',3310504039,1),(53274925,425714788,16119982,454632,1,'2007-09-17 18:30:08',3310504039,1),(53274926,425713249,16115980,454632,1,'2007-09-17 18:30:08',3310504039,1),(53274927,425711300,16111876,454632,1,'2007-09-17 18:30:08',3310504039,1),(53274928,425709199,16107483,454632,1,'2007-09-17 18:30:08',3310504039,1),(53274929,425707770,16105129,454632,1,'2007-09-17 18:30:08',3310504039,1),(53274931,425707308,16103280,454632,1,'2007-09-17 18:30:09',3310504039,1),(53274932,425707770,16101557,454632,1,'2007-09-17 18:30:09',3310504039,1),(53274933,425709704,16098237,454632,1,'2007-09-17 18:30:09',3310504039,1),(53274934,425711090,16095127,454632,1,'2007-09-17 18:30:09',3310504037,1),(53274935,425711259,16093110,454632,1,'2007-09-17 18:30:09',3310504037,1),(53274936,425710754,16089580,454632,1,'2007-09-17 18:30:09',3310504037,1),(53274937,425709620,16086974,454632,1,'2007-09-17 18:30:10',3310504037,1),(53274939,425707896,16084116,454632,1,'2007-09-17 18:30:10',3310504037,1),(53274940,425706215,16082183,454632,1,'2007-09-17 18:30:10',3310504037,1),(53274941,425703736,16079998,454632,1,'2007-09-17 18:30:10',3310504037,1),(53274942,425701634,16078401,454632,1,'2007-09-17 18:30:10',3310504037,1),(53274943,425700416,16076467,454632,1,'2007-09-17 18:30:10',3310504037,1),(53274944,425700206,16075207,454632,1,'2007-09-17 18:30:11',3310504037,1),(53274946,425700542,16073820,454632,1,'2007-09-17 18:30:11',3310504037,1),(53274947,425701004,16071550,454632,1,'2007-09-17 18:30:11',3310504037,1),(53274948,425701088,16065793,454632,1,'2007-09-17 18:30:11',3310504037,1),(53274949,425701508,16062262,454632,1,'2007-09-17 18:30:11',3310504037,1),(53274950,425701971,16057934,454632,1,'2007-09-17 18:30:11',3310504037,1),(53274951,425701971,16055034,454632,1,'2007-09-17 18:30:11',3310504037,1),(53274952,425701550,16053059,454632,1,'2007-09-17 18:30:12',3310504037,1),(53274954,425699701,16051546,454632,1,'2007-09-17 18:30:12',3310504037,1),(53274955,425696928,16050579,454632,1,'2007-09-17 18:30:12',3310504036,1),(53274956,425691632,16049192,454632,1,'2007-09-17 18:30:12',3310504036,1),(53274957,425687892,16048730,454632,1,'2007-09-17 18:30:12',3310504036,1),(53274958,425685333,16048006,454632,1,'2007-09-17 18:30:12',3310504036,1),(53274959,425683431,16047107,454632,1,'2007-09-17 18:30:12',3310504036,1),(53274960,425682324,16046035,454632,1,'2007-09-17 18:30:12',3310504036,1),(53274961,425680457,16043580,454632,1,'2007-09-17 18:30:13',3310504036,1),(53274963,425678796,16039626,454632,1,'2007-09-17 18:30:13',3310504014,1),(53274964,425678426,16036049,454632,1,'2007-09-17 18:30:13',3310504014,1),(53274965,425677991,16031632,454632,1,'2007-09-17 18:30:13',3310504014,1),(53274966,425677031,16026568,454632,1,'2007-09-17 18:30:13',3310504014,1),(53274967,425676158,16023425,454632,1,'2007-09-17 18:30:14',3310504014,1),(53274968,425673666,16013358,4963967,1,'2010-06-11 20:09:43',3310504014,2),(53274970,425672940,16014785,4963967,1,'2010-06-11 20:09:44',3310504014,2),(53274971,425673691,16013744,4963967,1,'2010-06-11 20:09:43',3310504014,2),(53274972,425672730,16014605,454632,1,'2007-09-17 18:30:14',3310504014,1),(53274973,425669451,16020624,454632,1,'2007-09-17 18:30:14',3310504011,1),(53274974,425668285,16022581,454632,1,'2007-09-17 18:30:15',3310504011,1),(53274976,425667449,16023791,454632,1,'2007-09-17 18:30:15',3310504011,1),(53274977,425666613,16024483,454632,1,'2007-09-17 18:30:15',3310504011,1),(53274978,425665806,16024483,454632,1,'2007-09-17 18:30:15',3310504011,1),(53274979,425664970,16024080,454632,1,'2007-09-17 18:30:15',3310504011,1),(53274980,425663269,16022523,454632,1,'2007-09-17 18:30:15',3310504011,1),(53274981,425661827,16021254,454632,1,'2007-09-17 18:30:16',3310504011,1),(53274983,425660761,16020649,454632,1,'2007-09-17 18:30:16',3310504011,1),(53274984,425660011,16020793,454632,1,'2007-09-17 18:30:16',3310504011,1),(53274985,425659723,16021312,454632,1,'2007-09-17 18:30:16',3310504011,1),(53274986,425659146,16022408,454632,1,'2007-09-17 18:30:16',3310504011,1),(53274987,425659146,16023157,454632,1,'2007-09-17 18:30:16',3310504011,1),(53274988,425659694,16023849,454632,1,'2007-09-17 18:30:16',3310504011,1),(53274989,425663817,16027539,454632,1,'2007-09-17 18:30:16',3310504011,1),(53274990,425664480,16028462,454632,1,'2007-09-17 18:30:16',3310504011,1),(53274991,425664480,16029586,454632,1,'2007-09-17 18:30:17',3310504011,1),(53274992,425664076,16030739,454632,1,'2007-09-17 18:30:17',3310504011,1),(53274993,425663471,16031316,454632,1,'2007-09-17 18:30:17',3310504011,1),(53274995,425662865,16031547,454632,1,'2007-09-17 18:30:17',3310504011,1),(53274996,425661972,16031085,454632,1,'2007-09-17 18:30:17',3310504011,1),(53274997,425656667,16026069,454632,1,'2007-09-17 18:30:17',3310504011,1),(53274998,425674193,16019029,454632,1,'2007-09-17 18:30:18',3310504014,1),(53274999,425672577,16016267,454632,1,'2007-09-17 18:30:18',3310504014,1),(53275001,425670432,16013451,454632,1,'2007-09-17 18:30:18',3310504011,1),(53275002,425668776,16012292,454632,1,'2007-09-17 18:30:18',3310504011,1),(53275003,425666458,16010222,454632,1,'2007-09-17 18:30:18',3310504011,1),(53275004,425663146,16006248,454632,1,'2007-09-17 18:30:18',3310504011,1),(53275005,425660537,16001197,454632,1,'2007-09-17 18:30:19',3310504011,1),(53275006,425654824,16018792,454632,1,'2007-09-17 18:30:19',3310504011,1),(53275008,425659324,15999062,454632,1,'2007-09-17 18:30:19',3310504011,1),(53275009,425660455,16003184,454632,1,'2007-09-17 18:30:19',3310504011,1),(53275010,425666415,16011640,454632,1,'2007-09-17 18:30:19',3310504011,1),(53275011,425670556,16015480,454632,1,'2007-09-17 18:30:19',3310504011,1),(53275012,425671749,16016405,454632,1,'2007-09-17 18:30:19',3310504011,1),(53275014,425671521,16016823,454632,1,'2007-09-17 18:30:20',3310504011,1),(53275015,425663724,16008797,454632,1,'2007-09-17 18:30:20',3310504011,1),(53275016,425661971,16006170,454632,1,'2007-09-17 18:30:20',3310504011,1),(53275017,425657675,16008539,454632,1,'2007-09-17 18:30:20',3310504011,1),(53275018,425656568,15999695,454632,1,'2007-09-17 18:30:20',3310504011,1),(53275019,425653344,16000415,454632,1,'2007-09-17 18:30:20',3310504011,1),(53275020,425651081,16000244,454632,1,'2007-09-17 18:30:20',3310504011,1),(53275022,425649537,15999318,454632,1,'2007-09-17 18:30:21',3310504011,1),(53275023,425647548,15997020,454632,1,'2007-09-17 18:30:21',3310504011,1),(53275024,425646176,15994584,454632,1,'2007-09-17 18:30:21',3310504011,1),(53275026,425667647,16001601,4963967,1,'2010-06-11 20:09:45',3310504011,3),(53275027,425666974,16002095,4963967,1,'2010-06-11 20:09:46',3310504011,3),(53275028,425666624,16001664,4963967,1,'2010-06-11 20:09:46',3310504011,3),(53275030,425666602,16001209,4963967,1,'2010-06-11 20:09:46',3310504011,3),(53275031,425666833,16000771,4963967,1,'2010-06-11 20:09:45',3310504011,3),(53275032,425667200,16000659,4963967,1,'2010-06-11 20:09:45',3310504011,3),(53275033,425667578,16000980,4963967,1,'2010-06-11 20:09:45',3310504011,3),(53275034,425672452,16015114,454632,1,'2007-09-17 18:30:22',3310504014,1),(53275035,425663533,16000181,454632,1,'2007-09-17 18:30:22',3310504011,1),(53275036,425665236,16001155,454632,1,'2007-09-17 18:30:23',3310504011,1),(53275038,425653887,15978587,454632,1,'2007-09-17 18:30:23',3310504009,1),(53275039,425658368,15989734,454632,1,'2007-09-17 18:30:23',3310504011,1),(53275040,425661408,15998269,454632,1,'2007-09-17 18:30:23',3310504011,1),(53275506,425672193,15979031,454632,1,'2007-09-17 19:11:34',3310504012,1),(53275507,425673702,15978701,454632,1,'2007-09-17 18:40:28',3310504012,1),(53275508,425675179,15978701,454632,1,'2007-09-17 18:40:28',3310504012,1),(53275510,425675401,15979329,454632,1,'2007-09-17 18:40:29',3310504012,1),(53275511,425674995,15980844,454632,1,'2007-09-17 18:40:29',3310504012,1),(53275512,425673739,15982949,454632,1,'2007-09-17 18:40:29',3310504012,1),(53275514,425671116,15987899,454632,1,'2007-09-17 18:40:29',3310504011,1),(53275515,425669232,15991076,454632,1,'2007-09-17 18:40:29',3310504011,1),(53275516,425669158,15992701,454632,1,'2007-09-17 18:40:30',3310504011,1),(53275517,425668346,15994696,454632,1,'2007-09-17 18:40:30',3310504011,1),(53275518,425667755,15997318,454632,1,'2007-09-17 18:40:30',3310504011,1),(53275519,425667348,15999498,454632,1,'2007-09-17 18:40:30',3310504011,1),(53275520,425670840,15979638,454632,1,'2007-09-17 18:40:30',3310504009,1),(53275521,425669973,15979681,454632,1,'2007-09-17 18:40:31',3310504009,1),(53275522,425668585,15979291,454632,1,'2007-09-17 18:40:31',3310504009,1),(53275523,425667457,15978250,454632,1,'2007-09-17 18:40:31',3310504009,1),(53275524,425666676,15976862,454632,1,'2007-09-17 18:40:31',3310504009,1),(53275525,425665419,15974737,454632,1,'2007-09-17 18:40:32',3310504009,1),(53275526,425664811,15973826,454632,1,'2007-09-17 18:40:32',3310504009,1),(53275527,425664074,15972785,454632,1,'2007-09-17 18:40:32',3310504009,1),(53275528,425663380,15970703,454632,1,'2007-09-17 18:40:33',3310504009,1),(53275529,425662686,15969619,454632,1,'2007-09-17 18:40:33',3310504009,1),(53275530,425661125,15968882,454632,1,'2007-09-17 18:40:33',3310504009,1),(53275531,425660431,15967581,454632,1,'2007-09-17 18:40:33',3310504009,1),(53275533,425659355,15994564,454632,1,'2007-09-17 18:40:34',3310504011,1),(53275534,425658693,15992911,454632,1,'2007-09-17 18:40:34',3310504011,1),(53275535,425656960,15989699,454632,1,'2007-09-17 18:50:21',3310504011,1),(53275536,425654313,15983984,454632,1,'2007-09-17 18:40:34',3310504009,1),(53275537,425652825,15981008,454632,1,'2007-09-17 18:40:34',3310504009,1),(53275538,425651502,15976710,454632,1,'2007-09-17 18:40:35',3310504009,1),(53275539,425651172,15973652,454632,1,'2007-09-17 18:40:35',3310504009,1),(53275540,425651502,15971420,454632,1,'2007-09-17 18:40:35',3310504009,1),(53275541,425654147,15967866,454632,1,'2007-09-17 18:40:36',3310504009,1),(53275542,425655801,15964560,454632,1,'2007-09-17 18:40:36',3310504009,1),(53275543,425657784,15961419,454632,1,'2007-09-17 18:40:36',3310504009,1),(53275544,425659107,15958526,454632,1,'2007-09-17 18:40:36',3310504009,1),(53275545,425660512,15954063,454632,1,'2007-09-17 18:40:37',3310504009,1),(53275546,425661338,15950509,454632,1,'2007-09-17 18:40:37',3310504009,1),(53275547,425661173,15947203,454632,1,'2007-09-17 18:40:37',3310504009,1),(53275548,425660016,15945136,454632,1,'2007-09-17 18:40:37',3310504009,1),(53275549,425657536,15944062,454632,1,'2007-09-17 18:40:37',3310504009,1),(53275550,425655883,15942905,454632,1,'2007-09-17 18:40:38',3310504009,1),(53275551,425655305,15940755,454632,1,'2007-09-17 18:40:38',3310504009,1),(53275552,425654084,15937833,454632,1,'2007-09-17 18:40:38',3310504009,1),(53275554,425653290,15936087,454632,1,'2007-09-17 18:40:38',3310504009,1),(53275555,425652148,15935167,454632,1,'2007-09-17 18:40:39',3310504009,1),(53275556,425649767,15934437,454632,1,'2007-09-17 18:40:39',3310504009,1),(53275557,425648022,15934278,454632,1,'2007-09-17 18:40:39',3310504009,1),(53275558,425646054,15934214,454632,1,'2007-09-17 18:40:39',3310504009,1),(53275559,425644435,15934119,454632,1,'2007-09-17 18:40:39',3310504009,1),(53275560,425643515,15933580,454632,1,'2007-09-17 18:40:39',3310504008,1),(53275561,425642531,15932501,454632,1,'2007-09-17 18:40:40',3310504008,1);
INSERT INTO `current_nodes` VALUES (53275562,425641991,15930787,454632,1,'2007-09-17 18:40:40',3310504008,1),(53275563,425641579,15929549,454632,1,'2007-09-17 18:40:40',3310504002,1),(53275565,425640531,15927010,454632,1,'2007-09-17 18:40:41',3310504002,1),(53275567,425639516,15925645,454632,1,'2007-09-17 18:40:41',3310504002,1),(53275568,425638373,15924217,454632,1,'2007-09-17 18:40:41',3310504002,1),(53275569,425637706,15922566,454632,1,'2007-09-17 18:40:41',3310504002,1),(53275570,425637724,15919540,454632,1,'2007-09-17 18:40:41',3310504002,1),(53275572,425637780,15916435,454632,1,'2007-09-17 18:40:42',3310504002,1),(53275573,425637554,15914346,454632,1,'2007-09-17 18:40:42',3310504002,1),(53275574,425635861,15912539,454632,1,'2007-09-17 18:40:42',3310504002,1),(53275575,425632699,15910394,454632,1,'2007-09-17 18:40:42',3310504002,1),(53275576,425630610,15909152,454632,1,'2007-09-17 18:40:42',3310504002,1),(53275577,425628804,15908813,454632,1,'2007-09-17 18:40:42',3310504002,1),(53275578,425626941,15907063,454632,1,'2007-09-17 18:40:43',3310504002,1),(53275579,425622707,15906837,454632,1,'2007-09-17 18:40:43',3310504002,1),(53275580,425618021,15906950,454632,1,'2007-09-17 18:40:43',3310504002,1),(53275581,425613843,15907345,454632,1,'2007-09-17 18:40:43',3310503959,1),(53275582,425609778,15907740,454632,1,'2007-09-17 18:40:44',3310503959,1),(53275583,425607407,15907684,454632,1,'2007-09-17 18:40:44',3310503959,1),(53275584,425604415,15907007,454632,1,'2007-09-17 18:40:44',3310503959,1),(53275585,425602552,15906047,454632,1,'2007-09-17 18:40:44',3310503959,1),(53275586,425599786,15903450,454632,1,'2007-09-17 18:40:44',3310503959,1),(53275587,425597753,15901305,454632,1,'2007-09-17 18:40:44',3310503959,1),(53275588,425593350,15901022,454632,1,'2007-09-17 18:40:45',3310503959,1),(53275589,425591374,15901079,454632,1,'2007-09-17 18:40:45',3310503959,1),(53275590,425589624,15900288,454632,1,'2007-09-17 18:40:45',3310503959,1),(53275591,425588720,15899893,454632,1,'2007-09-17 18:40:45',3310503958,1),(53275592,425587761,15897861,454632,1,'2007-09-17 18:40:46',3310503958,1),(53275593,425584712,15896111,454632,1,'2007-09-17 18:40:46',3310503958,1),(53275594,425582171,15896506,454632,1,'2007-09-17 18:40:46',3310503958,1),(53275595,425579349,15898312,454632,1,'2007-09-17 18:40:46',3310503958,1),(53275596,425578445,15898369,454632,1,'2007-09-17 18:40:46',3310503958,1),(53275597,425576413,15897522,454632,1,'2007-09-17 18:40:47',3310503958,1),(53275598,425575961,15894981,454632,1,'2007-09-17 18:40:47',3310503958,1),(53275599,425575114,15893288,454632,1,'2007-09-17 18:40:47',3310503958,1),(53275600,425574268,15892441,454632,1,'2007-09-17 18:40:48',3310503958,1),(53275601,425571727,15891933,454632,1,'2007-09-17 18:40:48',3310503958,1),(53275602,425567945,15891030,454632,1,'2007-09-17 18:40:48',3310503958,1),(53275603,425566821,15890662,454632,1,'2007-09-17 18:40:48',3310503958,1),(53275604,425565224,15890401,454632,1,'2007-09-17 18:40:48',3310503958,1),(53275605,425564214,15889880,454632,1,'2007-09-17 18:40:48',3310503958,1),(53275606,425561249,15891867,454632,1,'2007-09-17 18:40:49',3310503955,1),(53275607,425560272,15892421,454632,1,'2007-09-17 18:40:49',3310503955,1),(53275608,425559197,15891998,454632,1,'2007-09-17 18:40:49',3310503955,1),(53275609,425556786,15889847,454632,1,'2007-09-17 18:40:49',3310503955,1),(53275610,425554994,15889130,454632,1,'2007-09-17 18:40:50',3310503955,1),(53275611,425552909,15888642,454632,1,'2007-09-17 18:40:50',3310503955,1),(53275612,425550660,15888577,454632,1,'2007-09-17 18:40:50',3310503955,1),(53275613,425548836,15889261,454632,1,'2007-09-17 18:40:50',3310503955,1),(53275614,425546588,15891248,454632,1,'2007-09-17 18:40:50',3310503955,1),(53275615,425544437,15893301,454632,1,'2007-09-17 18:40:51',3310503955,1),(53275616,425543558,15893301,454632,1,'2007-09-17 18:40:51',3310503955,1),(53275617,425542352,15892128,454632,1,'2007-09-17 18:40:51',3310503955,1),(53275618,425540039,15888544,454632,1,'2007-09-17 18:40:51',3310503955,1),(53275619,425536618,15884178,454632,1,'2007-09-17 18:40:51',3310503955,1),(53275620,425534077,15882288,454632,1,'2007-09-17 18:40:51',3310503954,1),(53275621,425531568,15881865,454632,1,'2007-09-17 18:40:52',3310503954,1),(53275622,425529026,15881800,454632,1,'2007-09-17 18:40:52',3310503954,1),(53275623,425527234,15883005,454632,1,'2007-09-17 18:40:52',3310503954,1),(53275624,425524173,15884799,454632,1,'2007-09-17 18:40:52',3310503954,1),(53275625,425520787,15886017,454632,1,'2007-09-17 18:40:53',3310503954,1),(53275626,425518446,15886297,454632,1,'2007-09-17 18:40:53',3310503954,1),(53275627,425516575,15886147,454632,1,'2007-09-17 18:40:53',3310503954,1),(53275628,425513917,15887532,454632,1,'2007-09-17 18:40:53',3310503954,1),(53275629,425510998,15889890,454632,1,'2007-09-17 18:40:54',3310503954,1),(53275630,425508453,15890863,454632,1,'2007-09-17 18:40:54',3310503954,1),(53275631,425505968,15893262,454632,1,'2007-09-17 18:40:54',3310503943,1),(53275632,425504028,15896496,454632,1,'2007-09-17 18:40:54',3310503943,1),(53275633,425500988,15899342,454632,1,'2007-09-17 18:40:54',3310503943,1),(53275634,425496137,15901670,454632,1,'2007-09-17 18:40:55',3310503943,1),(53275635,425491156,15905810,454632,1,'2007-09-17 18:40:55',3310503943,1),(53275636,425487470,15906198,454632,1,'2007-09-17 18:40:55',3310503943,1),(53275637,425485077,15906133,454632,1,'2007-09-17 18:40:55',3310503943,1),(53275638,425483395,15906068,454632,1,'2007-09-17 18:40:56',3310503943,1),(53275639,425481972,15906909,454632,1,'2007-09-17 18:40:56',3310503943,1),(53275640,425479837,15907555,454632,1,'2007-09-17 18:40:56',3310503943,1),(53275642,425476164,15907283,454632,1,'2007-09-17 18:40:56',3310503942,1),(53275643,425475051,15906613,454632,1,'2007-09-17 18:40:57',3310503942,1),(53275644,425472787,15906392,454632,1,'2007-09-17 18:40:57',3310503942,1),(53275645,425469942,15906456,454632,1,'2007-09-17 18:40:57',3310503942,1),(53275646,425468713,15906068,454632,1,'2007-09-17 18:40:57',3310503942,1),(53275647,425467872,15903999,454632,1,'2007-09-17 18:40:57',3310503942,1),(53275648,425466902,15903028,454632,1,'2007-09-17 18:40:58',3310503942,1),(53275649,425465026,15902446,454632,1,'2007-09-17 18:40:58',3310503942,1),(53275650,425463732,15901088,454632,1,'2007-09-17 18:40:58',3310503942,1),(53275651,425462245,15901088,454632,1,'2007-09-17 18:40:59',3310503942,1),(53275652,425460757,15902123,454632,1,'2007-09-17 18:40:59',3310503942,1),(53275653,425457006,15901541,454632,1,'2007-09-17 18:40:59',3310503942,1),(53275654,425454936,15901282,454632,1,'2007-09-17 18:40:59',3310503942,1),(53275655,425452931,15901282,454632,1,'2007-09-17 18:41:00',3310503942,1),(53275656,425450085,15902382,454632,1,'2007-09-17 18:41:00',3310503939,1),(53275657,425447239,15903093,454632,1,'2007-09-17 18:41:00',3310503939,1),(53275658,425443811,15904387,454632,1,'2007-09-17 18:41:00',3310503939,1),(53275659,425441676,15904387,454632,1,'2007-09-17 18:41:01',3310503939,1),(53275660,425438378,15904128,454632,1,'2007-09-17 18:41:01',3310503939,1),(53275661,425435920,15903158,454632,1,'2007-09-17 18:41:01',3310503939,1),(53275662,425433980,15902252,454632,1,'2007-09-17 18:41:01',3310503939,1),(53275663,425433721,15902382,454632,1,'2007-09-17 18:41:01',3310503939,1),(53275664,425432751,15903028,454632,1,'2007-09-17 18:41:02',3310503939,1),(53275665,425430252,15903836,454632,1,'2007-09-17 18:41:02',3310503939,1),(53275666,425427964,15904063,454632,1,'2007-09-17 18:41:02',3310503939,1),(53275667,425426735,15904128,454632,1,'2007-09-17 18:41:02',3310503939,1),(53275668,425425442,15904193,454632,1,'2007-09-17 18:41:02',3310503939,1),(53275669,425423372,15904839,454632,1,'2007-09-17 18:41:03',3310503938,1),(53275670,425420073,15905874,454632,1,'2007-09-17 18:41:03',3310503938,1),(53276316,425660491,15998668,454632,1,'2007-09-17 19:11:34',3310504011,1),(53276317,425659441,15999022,454632,1,'2007-09-17 19:11:34',3310504011,1),(53276347,425644886,15991244,454632,1,'2007-09-17 18:52:58',3310504011,1),(53276348,425643685,15987296,454632,1,'2007-09-17 18:52:58',3310504010,1),(53276349,425642610,15982833,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276350,425642610,15980258,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276351,425643053,15977854,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276352,425644254,15974421,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276353,425645139,15971846,454632,1,'2007-09-17 18:52:58',3310504009,1),(53276354,425645518,15969271,454632,1,'2007-09-17 18:52:58',3310504009,1),(53276355,425645139,15965752,454632,1,'2007-09-17 18:52:58',3310504009,1),(53276356,425643369,15960860,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276357,425641725,15955195,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276358,425640587,15950818,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276359,425638817,15945754,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276360,425636668,15942578,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276361,425633128,15939231,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276362,425628955,15936141,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276363,425625162,15934252,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276364,425622444,15933480,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276365,425620295,15934338,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276366,425618019,15936827,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276367,425615996,15937943,454632,1,'2007-09-17 18:52:58',3310503965,1),(53276368,425612708,15937514,454632,1,'2007-09-17 18:52:58',3310503965,1),(53276369,425609611,15936913,454632,1,'2007-09-17 18:52:58',3310503965,1),(53276370,425606134,15937085,454632,1,'2007-09-17 18:52:58',3310503965,1),(53276371,425604047,15938286,454632,1,'2007-09-17 18:52:58',3310503965,1),(53276372,425602151,15939059,454632,1,'2007-09-17 18:52:58',3310503965,1),(53276373,425599179,15938286,454632,1,'2007-09-17 18:52:58',3310503965,1),(53276374,425596334,15937686,454632,1,'2007-09-17 18:52:58',3310503965,1),(53276380,425634519,16020856,454632,1,'2007-09-17 18:52:05',3310504010,1),(53276381,425635214,16015620,454632,1,'2007-09-17 18:52:05',3310504010,1),(53276382,425634266,16013989,454632,1,'2007-09-17 18:52:05',3310504010,1),(53276383,425631105,16008839,454632,1,'2007-09-17 18:52:05',3310504010,1),(53276384,425629272,16004548,454632,1,'2007-09-17 18:52:05',3310504010,1),(53276385,425628703,16003689,454632,1,'2007-09-17 18:52:05',3310504010,1),(53276386,425627818,16003604,454632,1,'2007-09-17 18:52:05',3310504010,1),(53276387,425626806,16004977,454632,1,'2007-09-17 18:52:05',3310504010,1),(53276388,425626174,16006694,454632,1,'2007-09-17 18:52:05',3310504010,1),(53276389,425625162,16007809,454632,1,'2007-09-17 18:52:05',3310504010,1),(53276390,425623898,16008410,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276392,425623013,16007209,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276393,425621812,16004634,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276394,425619093,15997166,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276395,425617197,15990815,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276396,425617070,15987124,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276397,425617766,15983090,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276398,425619283,15978541,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276399,425619979,15975022,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276400,425620295,15970473,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276401,425620105,15963521,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276402,425620737,15957255,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276403,425622002,15954079,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276404,425623203,15952449,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276406,425624277,15952363,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276407,425624973,15952878,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276408,425625352,15954079,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276410,425625668,15956225,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276411,425626427,15958800,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276412,425626996,15960002,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276413,425628070,15960087,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276414,425628829,15959658,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276415,425629208,15958371,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276416,425631294,15950389,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276418,425632116,15946784,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276419,425631927,15944295,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276424,425621622,15935969,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276426,425620042,15934767,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276459,425589949,16024203,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276460,425595892,16017766,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276461,425597536,16016478,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276462,425598168,16016392,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276463,425598863,16016478,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276464,425600001,16017508,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276465,425601961,16019826,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276466,425603858,16021199,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276467,425606007,16022143,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276468,425607651,16022830,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276469,425609168,16023945,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276470,425610875,16026864,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276471,425612139,16030383,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276472,425613973,16033559,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276473,425615174,16035103,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276474,425616122,16035447,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276475,425616754,16034932,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276476,425616754,16033816,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276477,425616502,16032700,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276478,425615427,16032357,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276479,425614036,16030812,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276480,425613341,16029439,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276481,425613088,16027465,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276482,425613088,16026091,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276483,425612329,16023431,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276484,425610749,16019997,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276485,425607651,16013817,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276486,425606639,16010985,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276487,425606450,16008067,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276488,425606639,16005921,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276489,425607082,16003174,454632,1,'2007-09-17 18:53:58',3310503967,1),(53276490,425607588,16001286,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276491,425607841,15999398,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276492,425607651,15997510,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276493,425607208,15995965,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276494,425607335,15995192,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276495,425607714,15994849,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276496,425608283,15994935,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276497,425608726,15995621,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276498,425608726,15997510,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276499,425608852,16001115,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276500,425609295,16004548,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276501,425610243,16006694,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276502,425611760,16008839,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276503,425613277,16010556,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276504,425615047,16012101,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276505,425617323,16013045,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276506,425620990,16014418,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276507,425624341,16015620,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276508,425626047,16017079,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276509,425627059,16018710,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276510,425628197,16019997,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276511,425629019,16019997,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276512,425629967,16019053,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276513,425629967,16018023,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276514,425629777,16015706,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276515,425629019,16013045,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276516,425627754,16010728,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276517,425625605,16009698,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276518,425582995,16030039,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276519,425582236,16026606,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276520,425582046,16022486,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276521,425582236,16020941,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276522,425581667,16019396,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276523,425580276,16018366,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276524,425578885,16019053,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276525,425577305,16020255,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276526,425576356,16020341,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276527,425575977,16019568,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276528,425575914,16018710,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276529,425576609,16018023,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276530,425580339,16015105,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276531,425581414,16014676,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276532,425582995,16015706,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276533,425583564,16018109,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276534,425585081,16023173,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276535,425586093,16025405,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276536,425587863,16025748,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276537,425588938,16025405,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276538,425587736,16035018,454632,1,'2007-09-17 18:54:40',3310503966,1),(53276539,425586725,16035275,454632,1,'2007-09-17 18:54:40',3310503966,1),(53276540,425586093,16033816,454632,1,'2007-09-17 18:54:40',3310503966,1),(53276541,425584955,16031155,454632,1,'2007-09-17 18:54:40',3310503966,1),(53276542,425583690,16028409,454632,1,'2007-09-17 18:54:40',3310503966,1),(53276543,425582173,16023345,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276588,425602783,16078791,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276589,425600128,16074929,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276590,425597030,16073041,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276592,425594375,16073212,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276593,425590581,16075015,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276594,425586851,16076646,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276595,425584006,16078190,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276597,425581920,16079907,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276598,425579644,16080680,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276599,425577305,16081710,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276600,425575218,16083512,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276601,425574144,16084971,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276602,425573385,16085572,454632,1,'2007-09-17 18:56:36',3310503988,1),(53276604,425572626,16085314,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276605,425572373,16084199,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276606,425572373,16083254,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276608,425573006,16082225,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276609,425584006,16068492,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276610,425587484,16064028,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276611,425591846,16061024,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276612,425594375,16060080,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276613,425597662,16059909,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276614,425601519,16059909,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276616,425605122,16060767,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276617,425607208,16062398,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276618,425609358,16064973,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276619,425609927,16065831,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276620,425610559,16065144,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276621,425610812,16063943,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276622,425610369,16061711,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276623,425608536,16058449,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276624,425606197,16056218,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276625,425604427,16054501,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276627,425603225,16052012,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276628,425601835,16048493,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276630,425600254,16047377,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276631,425598231,16046691,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276632,425590708,16047549,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276633,425587610,16048064,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276634,425585397,16049266,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276635,425584322,16049609,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276636,425583690,16049609,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276637,425583184,16048751,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276639,425582995,16047892,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276641,425583058,16046776,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276643,425583753,16044373,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276645,425584386,16041283,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276646,425584386,16036992,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276647,425584322,16035790,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276648,425583753,16033215,454632,1,'2007-09-17 19:00:22',3310503966,1),(53277160,425603547,16080392,454632,1,'2007-09-17 19:10:42',3310503989,1),(53277161,425603701,16081548,454632,1,'2007-09-17 19:10:42',3310503989,1),(53277162,425603200,16082280,454632,1,'2007-09-17 19:10:42',3310503989,1),(53277163,425602545,16082435,454632,1,'2007-09-17 19:10:42',3310503989,1),(53277164,425601659,16082049,454632,1,'2007-09-17 19:10:42',3310503989,1),(53277165,425600734,16080623,454632,1,'2007-09-17 19:10:42',3310503989,1),(53277166,425599385,16079082,454632,1,'2007-09-17 19:10:43',3310503989,1),(53277167,425597535,16078465,454632,1,'2007-09-17 19:10:43',3310503989,1),(53277168,425595531,16078311,454632,1,'2007-09-17 19:10:43',3310503989,1),(53277169,425593643,16079352,454632,1,'2007-09-17 19:10:43',3310503989,1),(53277170,425591562,16081240,454632,1,'2007-09-17 19:10:43',3310503989,1),(53277171,425587014,16086519,454632,1,'2007-09-17 19:10:43',3310503988,1),(53277172,425583623,16092146,454632,1,'2007-09-17 19:10:44',3310503988,1),(53277173,425579309,16097856,454632,1,'2007-09-17 19:10:44',3310503990,1),(53277174,425631092,15942403,454632,1,'2007-09-17 19:10:44',3310504008,1),(53277175,425629182,15940430,454632,1,'2007-09-17 19:10:44',3310504008,1),(53277176,425627125,15938142,454632,1,'2007-09-17 19:10:44',3310504008,1),(53277177,425625194,15936190,454632,1,'2007-09-17 19:10:44',3310504008,1),(53277178,425623767,15935602,454632,1,'2007-09-17 19:10:45',3310504008,1),(53277179,425659528,15972911,454632,1,'2007-09-17 19:10:45',3310504009,1),(53277180,425662049,15972430,454632,1,'2007-09-17 19:10:45',3310504009,1),(53277181,425663756,15971581,454632,1,'2007-09-17 19:10:45',3310504009,1),(53277182,425669010,15967564,454632,1,'2007-09-17 19:10:45',3310504009,1),(53277183,425669248,15970862,454632,1,'2007-09-17 19:10:45',3310504009,1),(53277184,425670064,15973208,454632,1,'2007-09-17 19:10:45',3310504009,1),(53277185,425670676,15973718,454632,1,'2007-09-17 19:10:45',3310504009,1),(53277186,425671696,15974194,454632,1,'2007-09-17 19:10:46',3310504009,1),(53277187,425671893,15974570,454632,1,'2007-09-17 19:10:46',3310504012,1),(53277189,425671313,15973955,454632,1,'2007-09-17 19:10:46',3310504009,1),(53277190,425666834,15967496,454632,1,'2007-09-17 19:10:46',3310504009,1),(53277191,425667990,15972936,454632,1,'2007-09-17 19:10:46',3310504009,1),(53277192,425667990,15974568,454632,1,'2007-09-17 19:10:47',3310504009,1),(53277193,425702256,15948039,454632,1,'2007-09-17 19:10:47',3310504013,1),(53277194,425700435,15951681,454632,1,'2007-09-17 19:10:47',3310504013,1),(53277195,425699319,15953898,454632,1,'2007-09-17 19:10:47',3310504013,1),(53277196,425698153,15957114,454632,1,'2007-09-17 19:10:47',3310504012,1),(53277197,425697687,15960704,454632,1,'2007-09-17 19:10:48',3310504012,1),(53277198,425697361,15964200,454632,1,'2007-09-17 19:10:48',3310504012,1),(53277199,425696662,15969001,454632,1,'2007-09-17 19:10:48',3310504012,1),(53277200,425696102,15973569,454632,1,'2007-09-17 19:10:48',3310504012,1),(53277201,425694657,15976412,454632,1,'2007-09-17 19:10:48',3310504012,1),(53277202,425692886,15978277,454632,1,'2007-09-17 19:10:49',3310504012,1),(53277203,425691208,15978510,454632,1,'2007-09-17 19:10:49',3310504012,1),(53277204,425689670,15977671,454632,1,'2007-09-17 19:10:49',3310504012,1),(53277205,425686500,15976366,454632,1,'2007-09-17 19:10:49',3310504012,1),(53277206,425683703,15976039,454632,1,'2007-09-17 19:10:49',3310504012,1),(53277207,425681093,15976272,454632,1,'2007-09-17 19:10:49',3310504012,1),(53277208,425678762,15976412,454632,1,'2007-09-17 19:10:50',3310504012,1),(53277209,425677270,15977298,454632,1,'2007-09-17 19:10:50',3310504012,1),(53277210,425672423,15981307,454632,1,'2007-09-17 19:10:50',3310504012,1),(53277211,425670465,15984989,454632,1,'2007-09-17 19:10:50',3310504009,1),(53277212,425667901,15989418,454632,1,'2007-09-17 19:10:50',3310504011,1),(53277213,425666037,15991562,454632,1,'2007-09-17 19:10:50',3310504011,1),(53277214,425661748,15995943,454632,1,'2007-09-17 19:10:51',3310504011,1),(53277215,425659423,15996934,370566,1,'2008-05-09 02:14:23',3310504011,2),(53277216,425705850,15941318,454632,1,'2007-09-17 19:10:51',3310504013,1),(53277217,425707892,15938087,454632,1,'2007-09-17 19:10:51',3310504013,1),(53277218,425710601,15933574,454632,1,'2007-09-17 19:10:51',3310504013,1),(53277219,425713641,15927493,454632,1,'2007-09-17 19:10:51',3310504007,1),(53277220,425715114,15925212,454632,1,'2007-09-17 19:10:52',3310504007,1),(53277221,425717964,15922029,454632,1,'2007-09-17 19:10:52',3310504007,1),(53277222,425720197,15921459,454632,1,'2007-09-17 19:10:52',3310504007,1),(53277223,425722383,15920936,454632,1,'2007-09-17 19:10:52',3310504007,1),(53277224,425723998,15919178,454632,1,'2007-09-17 19:10:52',3310504007,1),(53277225,425726136,15913715,454632,1,'2007-09-17 19:10:52',3310504007,1),(53277226,425729082,15906874,454632,1,'2007-09-17 19:10:53',3310504018,1),(53277227,425729557,15906018,454632,1,'2007-09-17 19:10:53',3310504018,1),(53277228,425734878,15895186,454632,1,'2007-09-17 19:10:53',3310504018,1),(53277229,425736427,15892517,454632,1,'2007-09-17 19:10:53',3310504018,1),(53277230,425737404,15892061,454632,1,'2007-09-17 19:10:54',3310504018,1),(53277231,425737664,15890369,454632,1,'2007-09-17 19:10:54',3310504018,1),(53277232,425737794,15888872,454632,1,'2007-09-17 19:10:54',3310504018,1),(53277233,425740397,15888417,454632,1,'2007-09-17 19:10:54',3310504018,1),(53277234,425740983,15886855,454632,1,'2007-09-17 19:10:54',3310504018,1),(53277235,425741634,15885163,454632,1,'2007-09-17 19:10:54',3310504018,1),(53277236,425741439,15883991,454632,1,'2007-09-17 19:10:54',3310504018,1),(53277237,425742870,15881583,454632,1,'2007-09-17 19:10:55',3310504018,1),(53277238,425745408,15880412,454632,1,'2007-09-17 19:10:55',3310504018,1),(53277239,425745669,15880347,454632,1,'2007-09-17 19:10:55',3310504018,1),(53277240,425746775,15880412,454632,1,'2007-09-17 19:10:55',3310504018,1),(53277241,425748662,15879826,454632,1,'2007-09-17 19:10:56',3310504018,1),(53277242,425750485,15877939,454632,1,'2007-09-17 19:10:56',3310504018,1),(53277243,425751266,15877418,454632,1,'2007-09-17 19:10:56',3310504018,1),(53277244,425752828,15878134,454632,1,'2007-09-17 19:10:56',3310504018,1),(53277245,425755821,15876898,454632,1,'2007-09-17 19:10:57',3310504019,1),(53277246,425756407,15876898,454632,1,'2007-09-17 19:10:58',3310504019,1),(53277247,425757253,15877744,454632,1,'2007-09-17 19:10:58',3310504019,1),(53277248,425758294,15876768,454632,1,'2007-09-17 19:10:58',3310504019,1),(53277249,425759661,15876442,454632,1,'2007-09-17 19:10:58',3310504019,1),(53277250,425761028,15876312,454632,1,'2007-09-17 19:10:58',3310504019,1),(53277251,425762134,15875531,454632,1,'2007-09-17 19:10:58',3310504019,1),(53277252,425763240,15876052,454632,1,'2007-09-17 19:10:58',3310504019,1),(53277253,425764021,15876052,454632,1,'2007-09-17 19:10:59',3310504019,1),(53277254,425764672,15875531,454632,1,'2007-09-17 19:10:59',3310504019,1),(53277255,425765713,15874880,454632,1,'2007-09-17 19:10:59',3310504017,1),(53277256,425766820,15874880,454632,1,'2007-09-17 19:10:59',3310504017,1),(53277257,425767796,15875141,454632,1,'2007-09-17 19:10:59',3310504017,1),(53277258,425768512,15875141,454632,1,'2007-09-17 19:10:59',3310504017,1),(53277259,425770594,15875141,454632,1,'2007-09-17 19:10:59',3310504017,1),(53277260,425771766,15875141,454632,1,'2007-09-17 19:11:00',3310504017,1),(53277261,425772547,15875010,454632,1,'2007-09-17 19:11:00',3310504017,1),(53277262,425773197,15874034,454632,1,'2007-09-17 19:11:00',3310504017,1),(53277263,425775931,15871301,454632,1,'2007-09-17 19:11:00',3310504017,1),(53277264,425775735,15870195,454632,1,'2007-09-17 19:11:00',3310504017,1),(53277265,425776126,15869479,454632,1,'2007-09-17 19:11:00',3310504017,1),(53277266,425776907,15869088,454632,1,'2007-09-17 19:11:00',3310504017,1),(53277267,425777428,15867852,454632,1,'2007-09-17 19:11:00',3310504017,1),(53277268,425777948,15866550,454632,1,'2007-09-17 19:11:01',3310504017,1),(53277269,425779705,15864468,454632,1,'2007-09-17 19:11:01',3310504017,1),(53277270,425780486,15862515,454632,1,'2007-09-17 19:11:01',3310504017,1),(53277271,425780747,15861994,454632,1,'2007-09-17 19:11:01',3310504017,1),(53277272,425781658,15860368,454632,1,'2007-09-17 19:11:01',3310504020,1),(53277273,425785888,15860368,454632,1,'2007-09-17 19:11:01',3310504020,1),(53277274,425789597,15859977,454632,1,'2007-09-17 19:11:01',3310504020,1),(53277275,425790834,15859782,454632,1,'2007-09-17 19:11:02',3310504020,1),(53277276,425793437,15859261,454632,1,'2007-09-17 19:11:02',3310504020,1),(53277277,425794934,15858675,454632,1,'2007-09-17 19:11:02',3310504020,1),(53277278,425798578,15857829,454632,1,'2007-09-17 19:11:02',3310504020,1),(53277279,425805932,15857894,454632,1,'2007-09-17 19:11:03',3310504020,1),(53277280,425808666,15857699,454632,1,'2007-09-17 19:11:03',3310504020,1),(53277281,425814132,15857309,454632,1,'2007-09-17 19:11:03',3310504021,1),(53277282,425818428,15855942,454632,1,'2007-09-17 19:11:03',3310504021,1),(53277283,425823048,15854250,454632,1,'2007-09-17 19:11:04',3310504021,1),(53277284,425828710,15852558,454632,1,'2007-09-17 19:11:04',3310504021,1),(53277285,425833461,15851061,454632,1,'2007-09-17 19:11:05',3310504021,1),(53277286,425836324,15850671,454632,1,'2007-09-17 19:11:05',3310504021,1),(53277287,425841075,15850671,454632,1,'2007-09-17 19:11:05',3310504192,1),(53277288,425844720,15850801,454632,1,'2007-09-17 19:11:05',3310504192,1),(53277289,425846672,15852428,454632,1,'2007-09-17 19:11:05',3310504192,1),(53277290,425847193,15852233,454632,1,'2007-09-17 19:11:06',3310504192,1),(53277291,425848234,15850606,454632,1,'2007-09-17 19:11:06',3310504192,1),(53277292,425850186,15851256,454632,1,'2007-09-17 19:11:06',3310504192,1),(53277293,425852334,15851061,454632,1,'2007-09-17 19:11:06',3310504192,1),(53277294,425853505,15851712,454632,1,'2007-09-17 19:11:06',3310504192,1),(53277295,425855197,15853274,454632,1,'2007-09-17 19:11:07',3310504192,1),(53277296,425857085,15854250,454632,1,'2007-09-17 19:11:07',3310504192,1),(53277297,425859297,15854120,454632,1,'2007-09-17 19:11:07',3310504192,1),(53277298,425860729,15853599,454632,1,'2007-09-17 19:11:07',3310504192,1),(53277299,425862812,15851191,454632,1,'2007-09-17 19:11:08',3310504192,1),(53277300,425863463,15851061,454632,1,'2007-09-17 19:11:08',3310504192,1),(53277301,425865870,15849825,454632,1,'2007-09-17 19:11:09',3310504193,1),(53277302,425868083,15848848,454632,1,'2007-09-17 19:11:09',3310504193,1),(53277303,425871923,15847742,454632,1,'2007-09-17 19:11:09',3310504193,1),(53277304,425874201,15847872,454632,1,'2007-09-17 19:11:10',3310504193,1),(53277305,425875567,15849434,454632,1,'2007-09-17 19:11:10',3310504193,1),(53277306,425876869,15849760,454632,1,'2007-09-17 19:11:10',3310504193,1),(53277307,425878496,15849174,454632,1,'2007-09-17 19:11:11',3310504193,1),(53277308,425881685,15848133,454632,1,'2007-09-17 19:11:11',3310504193,1),(53277309,425882921,15848133,454632,1,'2007-09-17 19:11:12',3310504193,1),(53277310,425884093,15848133,454632,1,'2007-09-17 19:11:12',3310504193,1),(53277311,425885394,15848393,454632,1,'2007-09-17 19:11:12',3310504193,1),(53277312,425889429,15844814,454632,1,'2007-09-17 19:11:12',3310504193,1),(53277313,425890080,15844293,454632,1,'2007-09-17 19:11:12',3310504193,1),(53278142,425709215,16679923,454632,1,'2007-09-17 19:28:51',3310504175,1),(53278144,425712862,16683844,454632,1,'2007-09-17 19:28:51',3310504175,1),(53278146,425715233,16686579,454632,1,'2007-09-17 19:28:52',3310504175,1),(53278147,425718151,16689041,454632,1,'2007-09-17 19:28:52',3310504175,1),(53278148,425721251,16689588,454632,1,'2007-09-17 19:28:52',3310504175,1),(53278149,425724625,16690591,454632,1,'2007-09-17 19:28:52',3310504175,1),(53278150,425726996,16692050,454632,1,'2007-09-17 19:28:53',3310504186,1),(53278151,425730005,16693965,454632,1,'2007-09-17 19:28:53',3310504186,1),(53278152,425734108,16693874,454632,1,'2007-09-17 19:28:53',3310504186,1),(53278153,425735567,16693418,454632,1,'2007-09-17 19:28:53',3310504186,1),(53278154,425738850,16685667,454632,1,'2007-09-17 19:28:54',3310504186,1),(53278155,425738576,16682841,454632,1,'2007-09-17 19:28:54',3310504186,1),(53278156,425737482,16680379,454632,1,'2007-09-17 19:28:54',3310504186,1),(53278157,425735294,16679467,454632,1,'2007-09-17 19:28:54',3310504186,1),(53278158,425733561,16679558,454632,1,'2007-09-17 19:28:55',3310504186,1),(53278159,425731555,16678281,454632,1,'2007-09-17 19:28:55',3310504186,1),(53278160,425729914,16678008,454632,1,'2007-09-17 19:28:55',3310504186,1),(53278161,425727543,16678464,454632,1,'2007-09-17 19:28:55',3310504186,1),(53278162,425725810,16678190,454632,1,'2007-09-17 19:28:56',3310504175,1),(53278163,425725081,16676458,454632,1,'2007-09-17 19:28:56',3310504175,1),(53278164,425721525,16674999,454632,1,'2007-09-17 19:28:57',3310504175,1),(53278165,425718242,16674269,454632,1,'2007-09-17 19:28:57',3310504175,1),(53278166,425716054,16674816,454632,1,'2007-09-17 19:28:57',3310504175,1),(53278167,425708394,16676549,454632,1,'2007-09-17 19:28:57',3310504175,1),(53278168,425644016,16646532,454632,1,'2007-09-17 19:28:58',3310504170,1),(53278169,425660822,16651807,4106774,1,'2010-03-12 16:31:14',3310504171,2),(53278170,425705134,16665947,4106774,1,'2010-03-12 16:31:14',3310504175,2),(53278171,425715364,16668954,4106774,1,'2010-03-12 16:31:14',3310504175,2),(53278172,425720281,16670684,4106774,1,'2010-03-12 16:31:14',3310504175,2),(53278173,425741793,16677959,454632,1,'2007-09-17 19:28:59',3310504186,1),(53278174,425747662,16679717,4106774,1,'2010-03-12 16:31:14',3310504186,2),(53278175,425761620,16683807,4106774,1,'2010-03-12 16:31:15',3310504187,3),(53278176,425676155,16660424,454632,1,'2007-09-17 19:29:00',3310504174,1),(53278177,425681652,16661776,454632,1,'2007-09-17 19:29:00',3310504174,1),(53278178,425688410,16665650,454632,1,'2007-09-17 19:29:00',3310504174,1),(53278179,425690122,16665650,454632,1,'2007-09-17 19:29:01',3310504174,1),(53278180,425689671,16670156,454632,1,'2007-09-17 19:29:01',3310504174,1),(53278181,425687058,16674481,454632,1,'2007-09-17 19:29:01',3310504174,1),(53278182,425682012,16678806,454632,1,'2007-09-17 19:29:01',3310504174,1),(53278183,425678137,16679887,454632,1,'2007-09-17 19:29:02',3310504174,1),(53278185,425672280,16679166,454632,1,'2007-09-17 19:29:02',3310504174,1),(53278186,425669127,16678445,454632,1,'2007-09-17 19:29:02',3310504171,1),(53278188,425667595,16676193,454632,1,'2007-09-17 19:29:02',3310504171,1),(53278190,425665613,16672498,454632,1,'2007-09-17 19:29:03',3310504171,1),(53278192,425665973,16670066,454632,1,'2007-09-17 19:29:03',3310504171,1),(53278194,425667685,16669525,454632,1,'2007-09-17 19:29:03',3310504171,1),(53278196,425668856,16669345,454632,1,'2007-09-17 19:29:04',3310504171,1),(53278197,425668406,16668083,454632,1,'2007-09-17 19:29:04',3310504171,1),(53278199,425668946,16666101,454632,1,'2007-09-17 19:29:04',3310504171,1),(53278200,425670298,16663938,454632,1,'2007-09-17 19:29:04',3310504171,1),(53278201,425665252,16663848,454632,1,'2007-09-17 19:29:04',3310504171,1),(53278202,425665342,16661595,454632,1,'2007-09-17 19:29:05',3310504171,1),(53278203,425665432,16657721,454632,1,'2007-09-17 19:29:05',3310504171,1),(53278204,425692714,16676203,454632,1,'2007-09-17 19:29:05',3310504174,1),(53278205,425685632,16679238,454632,1,'2007-09-17 19:29:05',3310504174,1),(53278206,425676123,16687736,454632,1,'2007-09-17 19:29:05',3310504174,1),(53278207,425670053,16691176,454632,1,'2007-09-17 19:29:07',3310504171,1),(53278208,425666208,16695627,454632,1,'2007-09-17 19:29:07',3310504171,1),(53278210,425665803,16701293,454632,1,'2007-09-17 19:29:07',3310504513,1),(53278211,425671469,16703114,454632,1,'2007-09-17 19:29:07',3310504513,1),(53278212,425675313,16702507,454632,1,'2007-09-17 19:29:07',3310504516,1),(53278213,425684216,16697448,454632,1,'2007-09-17 19:29:08',3310504174,1),(53278214,425690286,16693199,454632,1,'2007-09-17 19:29:08',3310504174,1),(53278215,425695951,16687331,454632,1,'2007-09-17 19:29:08',3310504174,1),(53278216,425699391,16683285,454632,1,'2007-09-17 19:29:08',3310504175,1),(53278217,425701212,16676001,454632,1,'2007-09-17 19:29:08',3310504175,1),(53278218,425702270,16684514,454632,1,'2007-09-17 19:29:08',3310504175,1),(53278219,425710054,16689536,454632,1,'2007-09-17 19:29:09',3310504175,1),(53278220,425715201,16694181,454632,1,'2007-09-17 19:29:09',3310504175,1),(53278221,425720349,16697948,454632,1,'2007-09-17 19:29:09',3310504175,1),(53278222,425728259,16698826,454632,1,'2007-09-17 19:29:10',3310504186,1),(53278223,425730770,16701086,454632,1,'2007-09-17 19:29:10',3310504528,1),(53278224,425722232,16716278,454632,1,'2007-09-17 19:29:10',3310504517,1),(53278226,425711184,16733604,454632,1,'2007-09-17 19:29:10',3310504517,1),(53278232,425696243,16745280,454632,1,'2007-09-17 19:29:13',3310504516,1),(53278233,425683186,16751809,454632,1,'2007-09-17 19:29:16',3310504516,1),(53278234,425667994,16758338,454632,1,'2007-09-17 19:29:17',3310504515,1),(53278235,425629701,16778552,454632,1,'2007-09-17 19:29:17',3310504514,1),(53278236,425620661,16787089,454632,1,'2007-09-17 19:29:17',3310504514,1),(53278237,425606599,16804917,454632,1,'2007-09-17 19:29:18',3310504471,1),(53278238,425602205,16813329,454632,1,'2007-09-17 19:29:18',3310504477,1),(53278239,425582242,16790981,454632,1,'2007-09-17 19:29:18',3310504470,1),(53278240,425596681,16763109,454632,1,'2007-09-17 19:29:18',3310504471,1),(53278241,425609487,16751432,454632,1,'2007-09-17 19:29:18',3310504469,1),(53278242,425632588,16731093,454632,1,'2007-09-17 19:29:18',3310504512,1),(53278252,425644139,16720547,454632,1,'2007-09-17 19:29:22',3310504512,1),(53278253,425653430,16711884,454632,1,'2007-09-17 19:29:22',3310504513,1),(53278255,425660210,16706485,454632,1,'2007-09-17 19:29:22',3310504513,1),(53278256,425676155,16705732,454632,1,'2007-09-17 19:29:22',3310504516,1),(53278257,425682683,16701589,454632,1,'2007-09-17 19:29:22',3310504516,1),(53278258,425747198,16263155,454632,1,'2007-09-17 19:29:23',3310504144,1),(53278259,425756075,16279306,454632,1,'2007-09-17 19:29:23',3310504145,1),(53278261,425763181,16276745,454632,1,'2007-09-17 19:29:23',3310504145,1),(53278263,425770166,16279306,454632,1,'2007-09-17 19:29:23',3310504145,1),(53278264,425770399,16287688,454632,1,'2007-09-17 19:29:23',3310504145,1),(53278265,425775987,16299795,454632,1,'2007-09-17 19:29:23',3310504145,1),(53278267,425780411,16309341,454632,1,'2007-09-17 19:29:24',3310504145,1),(53278268,425778315,16320750,454632,1,'2007-09-17 19:29:24',3310504147,1),(53278269,425776453,16338678,454632,1,'2007-09-17 19:29:24',3310504147,1),(53278271,425779247,16357770,454632,1,'2007-09-17 19:29:24',3310504147,1),(53278272,425781575,16374533,454632,1,'2007-09-17 19:29:24',3310504153,1),(53278273,425782506,16417839,454632,1,'2007-09-17 19:29:25',3310504156,1),(53278274,425781575,16441821,454632,1,'2007-09-17 19:29:25',3310504155,1),(53278275,425776918,16460680,454632,1,'2007-09-17 19:29:25',3310504155,1),(53278276,425770399,16476512,454632,1,'2007-09-17 19:29:26',3310504155,1),(53278277,425755032,16492112,454632,1,'2007-09-17 19:29:26',3310504177,1),(53278278,425748280,16494440,454632,1,'2007-09-17 19:29:26',3310504176,1),(53278280,425738734,16489551,454632,1,'2007-09-17 19:29:26',3310504176,1),(53278282,425726860,16485127,454632,1,'2007-09-17 19:29:26',3310504176,1),(53278283,425719177,16483497,454632,1,'2007-09-17 19:29:27',3310504165,1),(53278285,425697989,16486524,454632,1,'2007-09-17 19:29:27',3310504164,1),(53278286,425688210,16487688,454632,1,'2007-09-17 19:29:27',3310504164,1),(53278287,425686581,16477909,454632,1,'2007-09-17 19:29:27',3310504142,1),(53278289,425684252,16461844,454632,1,'2007-09-17 19:29:27',3310504142,1),(53278290,425683787,16436466,454632,1,'2007-09-17 19:29:27',3310504142,1),(53278291,425687978,16419935,454632,1,'2007-09-17 19:29:28',3310504140,1),(53278292,425701714,16414580,454632,1,'2007-09-17 19:29:28',3310504141,1),(53278293,425703111,16406431,454632,1,'2007-09-17 19:29:28',3310504141,1),(53278294,425697989,16403637,454632,1,'2007-09-17 19:29:28',3310504140,1),(53278296,425686813,16405267,454632,1,'2007-09-17 19:29:28',3310504140,1),(53278298,425674706,16410622,454632,1,'2007-09-17 19:29:29',3310504140,1),(53278299,425676569,16412252,454632,1,'2007-09-17 19:29:29',3310504140,1),(53278301,425663298,16407129,454632,1,'2007-09-17 19:29:30',3310504137,1),(53278302,425674473,16390831,454632,1,'2007-09-17 19:29:30',3310504140,1),(53278304,425679596,16380587,454632,1,'2007-09-17 19:29:30',3310504140,1),(53278305,425687512,16373602,454632,1,'2007-09-17 19:29:30',3310504140,1),(53278306,425678432,16372671,454632,1,'2007-09-17 19:29:31',3310504140,1),(53278308,425668420,16379655,454632,1,'2007-09-17 19:29:31',3310504137,1),(53278309,425656313,16395255,454632,1,'2007-09-17 19:29:31',3310504137,1),(53278311,425647931,16400144,454632,1,'2007-09-17 19:29:32',3310504137,1),(53278312,425638618,16378491,454632,1,'2007-09-17 19:29:32',3310504136,1),(53278314,425638618,16364754,454632,1,'2007-09-17 19:29:32',3310504130,1),(53278315,425648164,16352647,454632,1,'2007-09-17 19:29:32',3310504131,1),(53278316,425654450,16341472,454632,1,'2007-09-17 19:29:32',3310504131,1),(53278317,425655614,16328433,454632,1,'2007-09-17 19:29:33',3310504131,1),(53278319,425651423,16297933,454632,1,'2007-09-17 19:29:33',3310504129,1),(53278321,425650026,16275348,454632,1,'2007-09-17 19:29:33',3310504129,1),(53278324,425648629,16252997,454632,1,'2007-09-17 19:29:33',3310504043,1),(53278327,425645137,16238561,454632,1,'2007-09-17 19:29:33',3310504043,1),(53278328,425641877,16231343,454632,1,'2007-09-17 19:29:34',3310504042,1),(53278330,425635125,16233206,454632,1,'2007-09-17 19:29:34',3310504042,1),(53278332,425628656,16224038,454632,1,'2007-09-17 19:29:34',3310504042,1),(53278333,425629059,16210761,454632,1,'2007-09-17 19:29:34',3310504042,1),(53278336,425626645,16205129,454632,1,'2007-09-17 19:29:35',3310504042,1),(53278337,425612563,16207945,454632,1,'2007-09-17 19:29:35',3310503999,1),(53278338,425601298,16221222,454632,1,'2007-09-17 19:29:35',3310503999,1),(53278341,425588021,16234499,454632,1,'2007-09-17 19:29:36',3310503998,1),(53278342,425582791,16230878,454632,1,'2007-09-17 19:29:36',3310503998,1),(53278343,425569514,16253408,454632,1,'2007-09-17 19:29:36',3310503998,1),(53278346,425565491,16266283,454632,1,'2007-09-17 19:29:37',3310504084,1),(53278347,425560663,16267087,454632,1,'2007-09-17 19:29:37',3310504081,1),(53278348,425559858,16253006,454632,1,'2007-09-17 19:29:37',3310503995,1),(53278350,425575951,16222429,454632,1,'2007-09-17 19:29:37',3310503998,1),(53278351,425588424,16203117,454632,1,'2007-09-17 19:29:37',3310503996,1),(53278353,425592849,16178575,454632,1,'2007-09-17 19:29:37',3310503997,1),(53278355,425604114,16156447,454632,1,'2007-09-17 19:29:38',3310503997,1),(53278356,425606126,16125065,454632,1,'2007-09-17 19:29:38',3310503991,1),(53278358,425600493,16120640,454632,1,'2007-09-17 19:29:38',3310503991,1),(53278360,425603039,16103200,454632,1,'2007-09-17 19:29:38',3310503991,1),(53278361,425607522,16093180,454632,1,'2007-09-17 19:29:38',3310503989,1),(53278362,425625583,16063781,454632,1,'2007-09-17 19:29:38',3310504032,1),(53278364,425641667,16040842,454632,1,'2007-09-17 19:29:39',3310504032,1),(53278366,425660256,16034909,454632,1,'2007-09-17 19:29:39',3310504011,1),(53278367,425668166,16035964,454632,1,'2007-09-17 19:29:39',3310504011,1),(53278368,425679108,16045852,454632,1,'2007-09-17 19:29:39',3310504036,1),(53278369,425684513,16052443,454632,1,'2007-09-17 19:29:39',3310504036,1),(53278371,425690446,16055080,454632,1,'2007-09-17 19:29:40',3310504036,1),(53278374,425695324,16060749,454632,1,'2007-09-17 19:29:40',3310504036,1),(53278375,425698092,16068132,454632,1,'2007-09-17 19:29:41',3310504036,1),(53278376,425699279,16077228,454632,1,'2007-09-17 19:29:41',3310504037,1),(53278377,425704157,16082370,454632,1,'2007-09-17 19:29:41',3310504037,1),(53278379,425707716,16087248,454632,1,'2007-09-17 19:29:41',3310504037,1),(53278383,425708903,16092653,454632,1,'2007-09-17 19:29:41',3310504037,1),(53278387,425707321,16098058,454632,1,'2007-09-17 19:29:42',3310504039,1),(53278390,425707980,16108605,454632,1,'2007-09-17 19:29:42',3310504039,1),(53278395,425710485,16118756,454632,1,'2007-09-17 19:29:42',3310504039,1),(53278401,425713192,16131077,454632,1,'2007-09-17 19:29:43',3310504039,1),(53278404,425713637,16141553,454632,1,'2007-09-17 19:29:43',3310504039,1),(53278409,425718541,16150246,454632,1,'2007-09-17 19:29:43',3310504045,1),(53278412,425726120,16165181,454632,1,'2007-09-17 19:29:44',3310504045,1),(53278418,425727457,16172314,454632,1,'2007-09-17 19:29:44',3310504056,1),(53278420,425734367,16195941,454632,1,'2007-09-17 19:29:44',3310504056,1),(53278423,425739048,16220014,454632,1,'2007-09-17 19:29:44',3310504058,1),(53278426,425738157,16231159,454632,1,'2007-09-17 19:29:45',3310504058,1),(53278429,425742392,16250329,454632,1,'2007-09-17 19:29:45',3310504058,1),(53281369,425558721,16162295,454632,1,'2007-09-17 19:41:03',3310503993,1),(53281374,425563031,16156468,454632,1,'2007-09-17 19:41:04',3310503996,1),(53281378,425567422,16150121,454632,1,'2007-09-17 19:41:04',3310503990,1),(53281382,425573488,16140782,454632,1,'2007-09-17 19:41:04',3310503990,1),(53281386,425581311,16129048,454632,1,'2007-09-17 19:41:04',3310503990,1),(53281388,425590052,16116315,454632,1,'2007-09-17 19:41:05',3310503991,1),(53281393,425599990,16101667,454632,1,'2007-09-17 19:41:05',3310503991,1),(53281395,425601427,16099353,454632,1,'2007-09-17 19:41:05',3310503991,1),(53281399,425616083,16077259,454632,1,'2007-09-17 19:41:05',3310503989,1),(53281402,425634996,16049762,454632,1,'2007-09-17 19:41:05',3310504032,1),(53281403,425657390,16016703,454632,1,'2007-09-17 19:41:05',3310504011,1),(53281406,425571653,15973792,320551,1,'2008-12-11 14:24:02',3310503964,3),(53281412,425570979,15986944,320551,1,'2008-12-11 14:23:59',3310503966,2),(53281415,425568281,15995375,320551,1,'2008-12-11 14:24:00',3310503966,2),(53281420,425564909,16008527,320551,1,'2008-12-11 14:24:00',3310503966,2),(53281424,425564572,16017295,320551,1,'2008-12-11 14:24:00',3310503966,2),(53281426,425568618,16026738,320551,1,'2008-12-11 14:24:00',3310503966,2),(53281430,425570305,16037529,320551,1,'2008-12-11 14:24:00',3310503966,2),(53281433,425564234,16055403,320551,1,'2008-12-11 14:24:00',3310503988,2),(53281436,425556815,16072939,320551,1,'2008-12-11 14:24:00',3310503985,2),(53281440,425549396,16089464,320551,1,'2008-12-11 14:24:00',3310503985,2),(53281444,425541302,16109698,320551,1,'2008-12-11 14:24:00',3310503987,2),(53282638,425537930,16122850,320551,1,'2008-12-11 14:24:00',3310503987,2),(53282705,425530511,16130944,320551,1,'2008-12-11 14:24:00',3310503986,2),(53282708,425525789,16132293,320551,1,'2008-12-11 14:24:00',3310503986,2),(53282709,425522417,16134316,320551,1,'2008-12-11 14:24:00',3310503986,2),(53282712,425514998,16133304,320551,1,'2008-12-11 14:24:00',3310503986,2),(53282714,425506904,16132967,320551,1,'2008-12-11 14:24:00',3310503975,2),(53282716,425498136,16137351,320551,1,'2008-12-11 14:24:00',3310503975,2),(53282719,425492740,16145782,320551,1,'2008-12-11 14:24:00',3310503975,2),(53282721,425492066,16158260,320551,1,'2008-12-11 14:24:00',3310503981,2),(53282723,425485658,16167365,320551,1,'2008-12-11 14:24:00',3310503981,2),(53282725,425477902,16167365,320551,1,'2008-12-11 14:24:00',3310503980,2),(53282727,425471157,16158597,320551,1,'2008-12-11 14:24:00',3310503980,2),(53282729,425460028,16154213,320551,1,'2008-12-11 14:24:00',3310503980,2),(53282730,425458342,16139037,320551,1,'2008-12-11 14:24:00',3310503974,2),(53282731,425459017,16134990,320551,1,'2008-12-11 14:24:00',3310503974,2),(53282734,425449574,16125885,320551,1,'2008-12-11 14:24:00',3310503971,2),(53282735,425448225,16120827,320551,1,'2008-12-11 14:24:00',3310503971,2),(53282738,425447551,16114419,320551,1,'2008-12-11 14:24:00',3310503971,2),(53282741,425441818,16113070,320551,1,'2008-12-11 14:24:00',3310503971,2),(53282743,425447551,16090475,320551,1,'2008-12-11 14:24:00',3310503969,2),(53282745,425439120,16091487,320551,1,'2008-12-11 14:24:00',3310503969,2),(53282748,425429340,16096208,320551,1,'2008-12-11 14:24:00',3310503971,2),(53282751,425426642,16100592,320551,1,'2008-12-11 14:24:01',3310503971,2),(53282753,425433387,16108012,320551,1,'2008-12-11 14:24:01',3310503971,2),(53282756,425431363,16115431,320551,1,'2008-12-11 14:24:01',3310503971,2),(53282759,425434061,16127571,320551,1,'2008-12-11 14:24:01',3310503971,2),(53282761,425434061,16140049,320551,1,'2008-12-11 14:24:01',3310503971,2),(53282764,425430014,16149492,320551,1,'2008-12-11 14:24:01',3310503971,2),(53282767,425421921,16155899,320551,1,'2008-12-11 14:24:01',3310503976,2),(53282768,425425293,16165679,320551,1,'2008-12-11 14:24:01',3310503977,2),(53282769,425429677,16172086,320551,1,'2008-12-11 14:24:01',3310503977,2),(53282772,425425967,16188948,320551,1,'2008-12-11 14:24:01',3310503977,2),(53282773,425427654,16205473,320551,1,'2008-12-11 14:24:01',3310503979,2),(53282777,425424956,16214915,320551,1,'2008-12-11 14:24:01',3310503979,2),(53282780,425415513,16208171,320551,1,'2008-12-11 14:24:01',3310503978,2),(53282784,425409106,16202438,320551,1,'2008-12-11 14:24:01',3310503976,2),(53282787,425404047,16199403,320551,1,'2008-12-11 14:24:01',3310503976,2),(53282789,425401012,16188611,320551,1,'2008-12-11 14:24:01',3310503976,2),(53282791,425397302,16165342,320551,1,'2008-12-11 14:24:01',3310503976,2),(53282794,425400338,16151852,320551,1,'2008-12-11 14:24:01',3310503976,2),(53282796,425397977,16146794,320551,1,'2008-12-11 14:24:02',3310503970,2),(53282803,425388872,16135665,320551,1,'2008-12-11 14:24:02',3310493047,2),(53282804,425378080,16130269,320551,1,'2008-12-11 14:24:02',3310493047,2),(53282808,425370998,16122175,320551,1,'2008-12-11 14:24:02',3310493047,2),(53282811,425371335,16104976,320551,1,'2008-12-11 14:24:02',3310493047,2),(53282814,425377743,16094522,320551,1,'2008-12-11 14:24:02',3310493045,2),(53282815,425376731,16076649,320551,1,'2008-12-11 14:24:02',3310493045,2),(53282817,425372684,16024040,320551,1,'2008-12-11 14:24:02',3310493023,2),(53282818,425366277,15951534,320551,1,'2008-12-11 14:24:02',3310493020,2),(53282819,425364928,15911740,320551,1,'2008-12-11 14:24:02',3310493014,2),(53282820,425372347,15913089,320551,1,'2008-12-11 14:24:02',3310493015,2),(53282822,425378080,15916124,320551,1,'2008-12-11 14:24:02',3310493015,2),(53282825,425389546,15921183,320551,1,'2008-12-11 14:24:02',3310493015,2),(53282827,425400675,15922194,320551,1,'2008-12-11 14:24:02',3310503938,2),(53282829,425406408,15926241,320551,1,'2008-12-11 14:24:02',3310503938,2),(53282831,425415176,15924892,320551,1,'2008-12-11 14:24:02',3310503938,2),(53282834,425420909,15920171,320551,1,'2008-12-11 14:24:02',3310503938,2),(53282839,425428665,15919159,320551,1,'2008-12-11 14:24:02',3310503939,2),(53282840,425441143,15921857,320551,1,'2008-12-11 14:24:02',3310503939,2),(53282842,425448225,15920846,320551,1,'2008-12-11 14:24:02',3310503939,2),(53282843,425455981,15917810,320551,1,'2008-12-11 14:24:02',3310503942,2),(53282846,425464412,15918148,320551,1,'2008-12-11 14:24:02',3310503942,2),(53282849,425471157,15920508,320551,1,'2008-12-11 14:24:02',3310503942,2),(53282852,425482623,15920508,320551,1,'2008-12-11 14:24:02',3310503943,2),(53282854,425502183,15919834,320551,1,'2008-12-11 14:24:02',3310503943,2),(53282856,425527781,15914072,320551,1,'2008-12-11 14:24:02',3310503954,2),(53282858,425549396,15920846,320551,1,'2008-12-11 14:24:02',3310503955,2),(53282860,425554454,15933661,320551,1,'2008-12-11 14:24:02',3310503961,2),(53282920,425555466,15941754,320551,1,'2008-12-11 14:24:02',3310503961,2),(53282925,425565583,15951197,320551,1,'2008-12-11 14:24:02',3310503964,2),(53282927,425569967,15956930,320551,1,'2008-12-11 14:24:02',3310503964,2),(53282932,425557833,15903245,454632,1,'2007-09-17 19:45:22',3310503955,1),(53282936,425556218,15905551,454632,1,'2007-09-17 19:45:22',3310503955,1),(53282940,425554880,15906612,454632,1,'2007-09-17 19:45:22',3310503955,1),(53282941,425553773,15907028,454632,1,'2007-09-17 19:45:22',3310503955,1),(53282943,425551097,15906243,454632,1,'2007-09-17 19:45:23',3310503955,1),(53282946,425548883,15906105,454632,1,'2007-09-17 19:45:23',3310503955,1),(53282948,425544500,15905690,454632,1,'2007-09-17 19:45:23',3310503955,1),(53282950,425542793,15905413,454632,1,'2007-09-17 19:45:24',3310503955,1),(53282952,425540994,15904859,454632,1,'2007-09-17 19:45:24',3310503955,1),(53282953,425538641,15904675,454632,1,'2007-09-17 19:45:24',3310503955,1),(53282957,425536565,15905136,454632,1,'2007-09-17 19:45:24',3310503955,1),(53282958,425534028,15906013,454632,1,'2007-09-17 19:45:25',3310503954,1),(53282959,425532090,15907443,454632,1,'2007-09-17 19:45:25',3310503954,1),(53282960,425530845,15908965,454632,1,'2007-09-17 19:45:25',3310503954,1),(53282963,425529738,15909934,454632,1,'2007-09-17 19:45:25',3310503954,1),(53282966,425528769,15909934,454632,1,'2007-09-17 19:45:26',3310503954,1),(53282968,425528123,15909011,454632,1,'2007-09-17 19:45:26',3310503954,1),(53282970,425527846,15907812,454632,1,'2007-09-17 19:45:27',3310503954,1),(53282972,425528677,15904629,454632,1,'2007-09-17 19:45:27',3310503954,1),(53282974,425530061,15903014,454632,1,'2007-09-17 19:45:27',3310503954,1),(53282976,425533428,15898954,454632,1,'2007-09-17 19:45:27',3310503954,1),(53282979,425534489,15896740,454632,1,'2007-09-17 19:45:28',3310503955,1),(53282983,425535504,15894664,454632,1,'2007-09-17 19:45:28',3310503955,1),(53282985,425535458,15893142,454632,1,'2007-09-17 19:45:28',3310503955,1),(53282987,425534812,15892542,454632,1,'2007-09-17 19:45:28',3310503955,1),(53282989,425533797,15893188,454632,1,'2007-09-17 19:45:28',3310503954,1),(53282991,425532967,15894987,454632,1,'2007-09-17 19:45:28',3310503954,1),(53282996,425532044,15896371,454632,1,'2007-09-17 19:45:28',3310503954,1),(53282998,425529046,15899139,454632,1,'2007-09-17 19:45:29',3310503954,1),(53283003,425526093,15902137,454632,1,'2007-09-17 19:45:29',3310503954,1),(53283007,425522633,15905459,454632,1,'2007-09-17 19:45:30',3310503954,1),(53283011,425518343,15907673,454632,1,'2007-09-17 19:45:30',3310503954,1),(53288119,425339794,15751749,188228,1,'2008-06-16 20:04:59',3310491641,2),(53288123,425341159,15758337,502899,1,'2007-09-23 18:56:14',3310491641,1),(53288126,425343652,15765997,188228,1,'2008-06-16 20:03:59',3310491646,2),(53288128,425344838,15773008,188228,1,'2008-06-16 20:04:22',3310491646,3),(53288129,425344868,15773649,188228,1,'2008-06-16 20:04:22',3310491646,2),(53288131,425344175,15773932,188228,1,'2008-06-16 20:04:22',3310491646,2),(53288134,425343867,15773724,188228,1,'2008-06-16 20:04:22',3310491646,2),(53288136,425343742,15773290,188228,1,'2008-06-16 20:04:22',3310491646,2),(53288138,425343974,15772875,188228,1,'2008-06-16 20:04:22',3310491646,2),(53288140,425344264,15772754,188228,1,'2008-06-16 20:04:22',3310491646,2),(53288141,425344318,15768970,454632,1,'2007-09-17 19:58:20',3310491646,1),(53288143,425344980,15770889,188228,1,'2008-06-16 20:03:59',3310491646,2),(53288147,425345044,15771919,188228,1,'2008-06-16 20:03:59',3310491646,2),(53288148,425344680,15772820,188228,1,'2008-06-16 20:04:22',3310491646,2),(53288150,425338534,15745675,454632,1,'2007-09-17 19:58:21',3310491641,1),(53288152,425337760,15740784,370566,1,'2008-05-09 02:14:25',3310491641,2),(53288157,425336316,15733553,188228,1,'2008-06-16 19:47:46',3310491641,2),(53288160,425335353,15727110,454632,1,'2007-09-17 19:58:21',3310491641,1),(53288161,425335926,15726173,454632,1,'2007-09-17 19:58:22',3310491641,1),(53288164,425337539,15724247,454632,1,'2007-09-17 19:58:22',3310491641,1),(53288166,425340402,15721592,454632,1,'2007-09-17 19:58:22',3310491641,1),(53288168,425340663,15719614,454632,1,'2007-09-17 19:58:22',3310491641,1),(53288171,425340559,15718990,454632,1,'2007-09-17 19:58:22',3310491641,1),(53288173,425339986,15718157,454632,1,'2007-09-17 19:58:23',3310491641,1),(53288174,425338476,15717845,454632,1,'2007-09-17 19:58:23',3310491641,1),(53288176,425337123,15717220,454632,1,'2007-09-17 19:58:23',3310491641,1),(53288178,425336030,15715450,454632,1,'2007-09-17 19:58:23',3310491641,1),(53288180,425334416,15708527,454632,1,'2007-09-17 19:58:23',3310491635,1),(53288182,425333896,15706133,454632,1,'2007-09-17 19:58:23',3310491635,1),(53288184,425334364,15704259,454632,1,'2007-09-17 19:58:23',3310491635,1),(53288187,425334885,15702281,454632,1,'2007-09-17 19:58:24',3310491635,1),(53288189,425334885,15701135,454632,1,'2007-09-17 19:58:24',3310491635,1),(53288191,425334312,15699678,454632,1,'2007-09-17 19:58:24',3310491635,1),(53288194,425332490,15698377,454632,1,'2007-09-17 19:58:25',3310491635,1),(53288196,425331814,15698272,454632,1,'2007-09-17 19:58:25',3310491635,1),(53288198,425330356,15698793,454632,1,'2007-09-17 19:58:25',3310491635,1),(53288199,425328951,15698689,454632,1,'2007-09-17 19:58:25',3310491635,1),(53288201,425327441,15697648,454632,1,'2007-09-17 19:58:26',3310491635,1),(53288203,425327285,15697023,454632,1,'2007-09-17 19:58:26',3310491635,1),(53288206,425326140,15695878,454632,1,'2007-09-17 19:58:26',3310491635,1),(53288209,425325047,15695826,454632,1,'2007-09-17 19:58:26',3310491635,1),(53288210,425323277,15696086,454632,1,'2007-09-17 19:58:26',3310491635,1),(53288213,425321975,15695878,454632,1,'2007-09-17 19:58:26',3310491635,1),(53288216,425320830,15694837,454632,1,'2007-09-17 19:58:27',3310491635,1),(53288219,425320310,15693327,454632,1,'2007-09-17 19:58:27',3310491635,1),(53288220,425320414,15691922,454632,1,'2007-09-17 19:58:27',3310491635,1),(53288223,425321403,15690621,454632,1,'2007-09-17 19:58:27',3310491635,1),(53288225,425324994,15687497,454632,1,'2007-09-17 19:58:27',3310491635,1),(53288227,425327337,15686248,454632,1,'2007-09-17 19:58:27',3310491635,1),(53288228,425328534,15685936,454632,1,'2007-09-17 19:58:28',3310491635,1),(53288229,425329523,15685780,454632,1,'2007-09-17 19:58:28',3310491635,1),(53288231,425330252,15685103,454632,1,'2007-09-17 19:58:28',3310491635,1),(53288235,425330460,15683906,454632,1,'2007-09-17 19:58:28',3310491635,1),(53288238,425329679,15682969,454632,1,'2007-09-17 19:58:28',3310491635,1),(53288239,425328326,15682760,454632,1,'2007-09-17 19:58:28',3310491635,1),(53288242,425325879,15682136,454632,1,'2007-09-17 19:58:29',3310491635,1),(53288245,425320674,15680314,454632,1,'2007-09-17 19:58:29',3310491635,1),(53288247,425318232,15678954,454632,1,'2007-09-17 19:58:29',3310491635,1),(53288250,425315704,15677149,454632,1,'2007-09-17 19:58:29',3310491635,1),(53288253,425314930,15675498,454632,1,'2007-09-17 19:58:29',3310491635,1),(53288255,425314569,15673280,454632,1,'2007-09-17 19:58:29',3310491634,1),(53288257,425314724,15667607,454632,1,'2007-09-17 19:58:30',3310491635,1),(53288259,425316839,15661056,454632,1,'2007-09-17 19:58:30',3310491635,1),(53288261,425320192,15654196,454632,1,'2007-09-17 19:58:30',3310491633,1),(53288262,425320525,15653271,454632,1,'2007-09-17 19:58:30',3310491633,1),(53288263,425319833,15652232,454632,1,'2007-09-17 19:58:30',3310491633,1),(53288266,425319227,15652145,454632,1,'2007-09-17 19:58:31',3310491633,1),(53288269,425318014,15652448,454632,1,'2007-09-17 19:58:31',3310491633,1),(53288271,425316846,15652492,454632,1,'2007-09-17 19:58:31',3310491633,1),(53288273,425315893,15651712,454632,1,'2007-09-17 19:58:31',3310491633,1),(53288276,425314638,15651106,454632,1,'2007-09-17 19:58:31',3310491632,1),(53288278,425314594,15650500,454632,1,'2007-09-17 19:58:32',3310491632,1),(53288280,425314335,15648552,454632,1,'2007-09-17 19:58:32',3310491632,1),(53288281,425314551,15647080,454632,1,'2007-09-17 19:58:32',3310491632,1),(53288282,425315157,15646171,454632,1,'2007-09-17 19:58:32',3310491633,1),(53288286,425315936,15646085,454632,1,'2007-09-17 19:58:32',3310491633,1),(53288290,425317885,15646561,454632,1,'2007-09-17 19:58:32',3310491633,1),(53288292,425319400,15646691,454632,1,'2007-09-17 19:58:33',3310491633,1),(53288294,425320525,15646344,454632,1,'2007-09-17 19:58:33',3310491633,1),(53288296,425321435,15645652,454632,1,'2007-09-17 19:58:33',3310491633,1),(53288298,425321738,15644613,454632,1,'2007-09-17 19:58:33',3310491633,1),(53288300,425322450,15642714,454632,1,'2007-09-17 19:58:33',3310491633,1),(53288302,425323634,15641837,454632,1,'2007-09-17 19:58:33',3310491633,1),(53288303,425324205,15641134,454632,1,'2007-09-17 19:58:34',3310491633,1),(53288305,425324205,15640652,454632,1,'2007-09-17 19:58:34',3310491633,1),(53288308,425323547,15640389,454632,1,'2007-09-17 19:58:34',3310491633,1),(53288309,425322493,15641091,454632,1,'2007-09-17 19:58:34',3310491633,1),(53288310,425321616,15641661,454632,1,'2007-09-17 19:58:34',3310491633,1),(53288313,425320826,15642275,454632,1,'2007-09-17 19:58:35',3310491633,1),(53288317,425319904,15642407,454632,1,'2007-09-17 19:58:35',3310491633,1),(53288318,425318939,15641398,454632,1,'2007-09-17 19:58:36',3310491633,1),(53288321,425299587,15652080,454632,1,'2007-09-17 19:58:36',3310491632,1),(53288323,425301722,15653099,454632,1,'2007-09-17 19:58:36',3310491632,1),(53288326,425304052,15655622,454632,1,'2007-09-17 19:58:36',3310491632,1),(53288329,425306624,15659165,454632,1,'2007-09-17 19:58:37',3310491634,1),(53288332,425307783,15660307,454632,1,'2007-09-17 19:58:37',3310491634,1),(53288334,425308516,15660577,454632,1,'2007-09-17 19:58:37',3310491634,1),(53288336,425309778,15659870,454632,1,'2007-09-17 19:58:37',3310491634,1),(53288338,425315650,15654555,454632,1,'2007-09-17 19:58:37',3310491633,1),(53288339,425317106,15653875,454632,1,'2007-09-17 19:58:38',3310491633,1),(53288343,425318368,15654360,454632,1,'2007-09-17 19:58:38',3310491633,1),(53288346,425319484,15655428,454632,1,'2007-09-17 19:58:38',3310491633,1);
INSERT INTO `current_nodes` VALUES (53288348,425304664,15678441,454632,1,'2007-09-17 19:58:38',3310491634,1),(53288349,425305689,15678403,454632,1,'2007-09-17 19:58:38',3310491634,1),(53288350,425306335,15680112,454632,1,'2007-09-17 19:58:38',3310491634,1),(53288351,425308044,15684898,454632,1,'2007-09-17 19:58:39',3310491634,1),(53288352,425310058,15688621,454632,1,'2007-09-17 19:58:39',3310491634,1),(53288353,425311463,15690862,454632,1,'2007-09-17 19:58:39',3310491634,1),(53288354,425312185,15691774,454632,1,'2007-09-17 19:58:39',3310491634,1),(53288355,425313780,15691888,454632,1,'2007-09-17 19:58:39',3310491634,1),(53288356,425315832,15692002,454632,1,'2007-09-17 19:58:39',3310491635,1),(53288357,425318339,15692875,454632,1,'2007-09-17 19:58:39',3310491635,1),(53288358,425358462,15703475,454632,1,'2007-09-17 19:58:40',3310491638,1),(53288360,425357875,15714429,454632,1,'2007-09-17 19:58:40',3310491644,1),(53288364,425357484,15717950,454632,1,'2007-09-17 19:58:40',3310491644,1),(53288366,425356115,15719646,454632,1,'2007-09-17 19:58:40',3310491644,1),(53288368,425354289,15719254,454632,1,'2007-09-17 19:58:41',3310491644,1),(53288370,425353768,15718407,454632,1,'2007-09-17 19:58:41',3310491644,1),(53288373,425353507,15714429,454632,1,'2007-09-17 19:58:41',3310491644,1),(53288375,425353833,15704649,454632,1,'2007-09-17 19:58:41',3310491638,1),(53288378,425353833,15701975,454632,1,'2007-09-17 19:58:42',3310491638,1),(53288381,425353116,15699954,454632,1,'2007-09-17 19:58:42',3310491638,1),(53288383,425351746,15700345,454632,1,'2007-09-17 19:58:42',3310491638,1),(53288388,425350834,15702953,454632,1,'2007-09-17 19:58:42',3310491638,1),(53288391,425350442,15712212,454632,1,'2007-09-17 19:58:42',3310491644,1),(53288393,425349138,15716972,454632,1,'2007-09-17 19:58:43',3310491644,1),(53288394,425347117,15719189,454632,1,'2007-09-17 19:58:43',3310491644,1),(53288396,425346595,15721667,454632,1,'2007-09-17 19:58:43',3310491644,1),(53288399,425347313,15724014,454632,1,'2007-09-17 19:58:43',3310491644,1),(53288402,425348877,15725840,454632,1,'2007-09-17 19:58:43',3310491644,1),(53288403,425349073,15727796,454632,1,'2007-09-17 19:58:44',3310491644,1),(53288404,425347378,15729556,454632,1,'2007-09-17 19:58:44',3310491644,1),(53288407,425339097,15735816,454632,1,'2007-09-17 19:58:44',3310491641,1),(53288410,425338054,15736664,454632,1,'2007-09-17 19:58:44',3310491641,1),(53288413,425338575,15740054,454632,1,'2007-09-17 19:58:45',3310491641,1),(53288419,425344777,15732435,454632,1,'2007-09-17 19:58:45',3310491644,1),(53292901,425317700,15638777,454632,1,'2007-09-17 20:12:20',3310491633,1),(53292938,425316338,15636126,454632,1,'2007-09-17 20:12:29',3310491633,1),(53292997,425314829,15633917,454632,1,'2007-09-17 20:12:44',3310491633,1),(53293001,425313061,15631450,454632,1,'2007-09-17 20:12:44',3310491632,1),(53293003,425311773,15628652,454632,1,'2007-09-17 20:12:44',3310491632,1),(53293007,425311478,15626958,454632,1,'2007-09-17 20:12:44',3310491632,1),(53293010,425312104,15626590,454632,1,'2007-09-17 20:12:45',3310491632,1),(53293011,425312730,15626995,454632,1,'2007-09-17 20:12:45',3310491632,1),(53293015,425313282,15628100,454632,1,'2007-09-17 20:12:45',3310491632,1),(53293017,425313945,15629131,454632,1,'2007-09-17 20:12:45',3310491632,1),(53293018,425316117,15630346,454632,1,'2007-09-17 20:12:45',3310491633,1),(53293022,425317958,15631266,454632,1,'2007-09-17 20:12:46',3310491633,1),(53293025,425319725,15632518,454632,1,'2007-09-17 20:12:46',3310491633,1),(53293027,425320499,15633107,454632,1,'2007-09-17 20:12:46',3310491633,1),(53293029,425321714,15633107,454632,1,'2007-09-17 20:12:46',3310491633,1),(53293032,425322413,15632555,454632,1,'2007-09-17 20:12:46',3310491633,1),(53293034,425323702,15632444,454632,1,'2007-09-17 20:12:47',3310491633,1),(53293037,425324475,15632076,454632,1,'2007-09-17 20:12:47',3310491633,1),(53293039,425325101,15630861,454632,1,'2007-09-17 20:12:47',3310491633,1),(53293043,425326647,15626848,454632,1,'2007-09-17 20:12:48',3310491633,1),(53293046,425328338,15622875,454632,1,'2007-09-17 20:12:48',3310491633,1),(53293058,425330425,15619923,454632,1,'2007-09-17 20:12:50',3310491633,1),(53293060,425332308,15616920,454632,1,'2007-09-17 20:12:50',3310491633,1),(53293062,425332919,15615240,454632,1,'2007-09-17 20:12:50',3310491633,1),(53293063,425332410,15614171,454632,1,'2007-09-17 20:12:50',3310491633,1),(53293066,425331493,15613968,454632,1,'2007-09-17 20:12:50',3310491633,1),(53293067,425330577,15614935,454632,1,'2007-09-17 20:12:50',3310491633,1),(53293069,425330781,15616309,454632,1,'2007-09-17 20:12:50',3310491633,1),(53293073,425330323,15617531,454632,1,'2007-09-17 20:12:50',3310491633,1),(53293076,425329152,15618752,454632,1,'2007-09-17 20:12:51',3310491633,1),(53293077,425327014,15620177,454632,1,'2007-09-17 20:12:51',3310491633,1),(53293080,425324622,15621195,454632,1,'2007-09-17 20:12:51',3310491633,1),(53293082,425322332,15621704,454632,1,'2007-09-17 20:12:51',3310491633,1),(53293083,425320601,15621704,454632,1,'2007-09-17 20:12:51',3310491633,1),(53293087,425319990,15620890,454632,1,'2007-09-17 20:12:51',3310491633,1),(53293089,425320398,15619770,454632,1,'2007-09-17 20:12:52',3310491633,1),(53293092,425321263,15619719,454632,1,'2007-09-17 20:12:52',3310491633,1),(53293095,425322230,15619668,454632,1,'2007-09-17 20:12:52',3310491633,1),(53293097,425323706,15618600,454632,1,'2007-09-17 20:12:52',3310491633,1),(53293098,425325437,15617531,454632,1,'2007-09-17 20:12:53',3310491633,1),(53293102,425326200,15616818,454632,1,'2007-09-17 20:12:53',3310491633,1),(53293105,425325895,15615546,454632,1,'2007-09-17 20:12:53',3310491633,1),(53293108,425325335,15615393,454632,1,'2007-09-17 20:12:54',3310491633,1),(53293109,425324164,15615698,454632,1,'2007-09-17 20:12:54',3310491633,1),(53293111,425322637,15615902,454632,1,'2007-09-17 20:12:54',3310491633,1),(53293114,425320652,15615902,454632,1,'2007-09-17 20:12:54',3310491633,1),(53293117,425319431,15615597,454632,1,'2007-09-17 20:12:55',3310491633,1),(53293119,425318413,15615088,454632,1,'2007-09-17 20:12:55',3310491633,1),(53293123,425317700,15613917,454632,1,'2007-09-17 20:12:55',3310491633,1),(53293124,425317089,15612085,454632,1,'2007-09-17 20:12:55',3310491633,1),(53293127,425316988,15610609,454632,1,'2007-09-17 20:12:55',3310491633,1),(53293130,425317038,15608318,454632,1,'2007-09-17 20:12:56',3310491633,1),(53293132,425316835,15607249,454632,1,'2007-09-17 20:12:56',3310491633,1),(53293136,425315664,15604806,454632,1,'2007-09-17 20:12:56',3310491633,1),(53293137,425312407,15599869,454632,1,'2007-09-17 20:12:56',3310491610,1),(53293142,425311236,15597986,454632,1,'2007-09-17 20:12:57',3310491610,1),(53293144,425311592,15597171,454632,1,'2007-09-17 20:12:57',3310491610,1),(53293147,425312356,15597171,454632,1,'2007-09-17 20:12:57',3310491610,1),(53293148,425312814,15597884,454632,1,'2007-09-17 20:12:57',3310491610,1),(53293150,425313628,15599258,454632,1,'2007-09-17 20:12:57',3310491610,1),(53293153,425314697,15600022,454632,1,'2007-09-17 20:12:58',3310491610,1),(53293155,425315817,15600073,454632,1,'2007-09-17 20:12:58',3310491611,1),(53293157,425316784,15600378,454632,1,'2007-09-17 20:12:58',3310491611,1),(53293158,425317802,15602414,454632,1,'2007-09-17 20:12:58',3310491633,1),(53293162,425318667,15603534,454632,1,'2007-09-17 20:12:59',3310491633,1),(53293164,425320449,15604246,454632,1,'2007-09-17 20:12:59',3310491633,1),(53293167,425321772,15604246,454632,1,'2007-09-17 20:12:59',3310491633,1),(53293169,425322739,15603839,454632,1,'2007-09-17 20:12:59',3310491633,1),(53293172,425323502,15602312,454632,1,'2007-09-17 20:12:59',3310491633,1),(53293174,425323452,15600327,454632,1,'2007-09-17 20:12:59',3310491611,1),(53293177,425322485,15598342,454632,1,'2007-09-17 20:12:59',3310491611,1),(53293179,425321772,15597324,454632,1,'2007-09-17 20:12:59',3310491611,1),(53293183,425322179,15596103,454632,1,'2007-09-17 20:13:00',3310491611,1),(53293185,425322790,15595899,454632,1,'2007-09-17 20:13:00',3310491611,1),(53293188,425323706,15595899,454632,1,'2007-09-17 20:13:00',3310491611,1),(53293189,425324928,15596103,454632,1,'2007-09-17 20:13:00',3310491611,1),(53293192,425325487,15595848,454632,1,'2007-09-17 20:13:00',3310491611,1),(53293193,425325742,15594423,454632,1,'2007-09-17 20:13:00',3310491611,1),(53293197,425325335,15593405,454632,1,'2007-09-17 20:13:01',3310491611,1),(53293198,425324877,15593100,454632,1,'2007-09-17 20:13:01',3310491611,1),(53293200,425325284,15592133,454632,1,'2007-09-17 20:13:01',3310491611,1),(53293202,425325996,15591522,454632,1,'2007-09-17 20:13:01',3310491611,1),(53293205,425328745,15592031,454632,1,'2007-09-17 20:13:02',3310491611,1),(53293212,425331086,15592896,454632,1,'2007-09-17 20:13:03',3310491611,1),(53293217,425332410,15592794,454632,1,'2007-09-17 20:13:03',3310491611,1),(53293220,425332868,15591369,454632,1,'2007-09-17 20:13:03',3310491611,1),(53293232,425332308,15589995,454632,1,'2007-09-17 20:13:06',3310491611,1),(53293500,425329254,15588010,454632,1,'2007-09-17 20:14:04',3310491611,1),(53293505,425324368,15586890,454632,1,'2007-09-17 20:14:06',3310491611,1),(53293507,425320499,15586279,454632,1,'2007-09-17 20:14:06',3310491611,1),(53293510,425318922,15586177,454632,1,'2007-09-17 20:14:06',3310491611,1),(53294141,425315308,15585618,454632,1,'2007-09-17 20:16:13',3310491611,1),(53294144,425313781,15585363,454632,1,'2007-09-17 20:16:14',3310491610,1),(53294147,425312152,15584701,454632,1,'2007-09-17 20:16:14',3310491610,1),(53294149,425310167,15582971,454632,1,'2007-09-17 20:16:14',3310491610,1),(53294152,425308640,15581597,454632,1,'2007-09-17 20:16:14',3310491610,1),(53294154,425307266,15581393,454632,1,'2007-09-17 20:16:15',3310491610,1),(53294157,425306248,15581851,454632,1,'2007-09-17 20:16:15',3310491610,1),(53294160,425303856,15583582,454632,1,'2007-09-17 20:16:16',3310491610,1),(53294162,425302991,15584294,454632,1,'2007-09-17 20:16:16',3310491610,1),(53294165,425302125,15584905,454632,1,'2007-09-17 20:16:16',3310491610,1),(53294166,425301464,15584701,454632,1,'2007-09-17 20:16:17',3310491610,1),(53294168,425301107,15584142,454632,1,'2007-09-17 20:16:17',3310491610,1),(53294169,425301005,15583124,454632,1,'2007-09-17 20:16:17',3310491610,1),(53294170,425301667,15582157,454632,1,'2007-09-17 20:16:17',3310491610,1),(53294171,425305485,15577881,454632,1,'2007-09-17 20:16:18',3310491610,1),(53294174,425306850,15576674,454632,1,'2007-09-17 20:16:18',3310491610,1),(53294177,425308131,15576252,454632,1,'2007-09-17 20:16:18',3310491610,1),(53294180,425309302,15576965,454632,1,'2007-09-17 20:16:18',3310491610,1),(53294181,425311389,15577118,454632,1,'2007-09-17 20:16:19',3310491610,1),(53294184,425313272,15577270,454632,1,'2007-09-17 20:16:19',3310491610,1),(53294186,425314290,15576965,454632,1,'2007-09-17 20:16:19',3310491610,1),(53294189,425314799,15576354,454632,1,'2007-09-17 20:16:19',3310491611,1),(53294192,425314748,15575692,454632,1,'2007-09-17 20:16:19',3310491611,1),(53294194,425313934,15574573,454632,1,'2007-09-17 20:16:19',3310491610,1),(53294195,425313425,15574166,454632,1,'2007-09-17 20:16:19',3310491610,1),(53294197,425312559,15572231,454632,1,'2007-09-17 20:16:20',3310491610,1),(53294199,425312136,15569920,454632,1,'2007-09-17 20:16:20',3310491610,1),(53294202,425312356,15569279,454632,1,'2007-09-17 20:16:20',3310491610,1),(53294205,425312862,15569071,454632,1,'2007-09-17 20:16:20',3310491610,1),(53294207,425313781,15570450,454632,1,'2007-09-17 20:16:20',3310491610,1),(53294209,425314290,15571315,454632,1,'2007-09-17 20:16:21',3310491610,1),(53294212,425315053,15572028,454632,1,'2007-09-17 20:16:21',3310491611,1),(53294213,425315410,15571213,454632,1,'2007-09-17 20:16:21',3310491611,1),(53294215,425315511,15570246,454632,1,'2007-09-17 20:16:21',3310491611,1),(53294218,425315461,15568770,454632,1,'2007-09-17 20:16:21',3310491611,1),(53294219,425315919,15567651,454632,1,'2007-09-17 20:16:21',3310491611,1),(53294221,425315664,15565971,454632,1,'2007-09-17 20:16:22',3310491611,1),(53294223,425315401,15571650,454632,1,'2007-09-17 20:16:22',3310491611,1),(53294226,425314524,15562751,454632,1,'2007-09-17 20:16:22',3310491610,1),(53294228,425313407,15560309,454632,1,'2007-09-17 20:16:22',3310491610,1),(53294231,425312662,15558612,454632,1,'2007-09-17 20:16:22',3310491610,1),(53294233,425312951,15557577,454632,1,'2007-09-17 20:16:23',3310491610,1),(53294235,425313738,15556998,454632,1,'2007-09-17 20:16:23',3310491610,1),(53294236,425314441,15557536,454632,1,'2007-09-17 20:16:23',3310491610,1),(53294239,425315104,15559315,454632,1,'2007-09-17 20:16:24',3310491611,1),(53294241,425316428,15561757,454632,1,'2007-09-17 20:16:24',3310491611,1),(53294244,425318953,15565317,454632,1,'2007-09-17 20:16:24',3310491611,1),(53294245,425319780,15566227,454632,1,'2007-09-17 20:16:24',3310491611,1),(53294248,425321063,15566268,454632,1,'2007-09-17 20:16:24',3310491611,1),(53294251,425321684,15565482,454632,1,'2007-09-17 20:16:24',3310491611,1),(53294253,425322305,15563702,454632,1,'2007-09-17 20:16:25',3310491611,1),(53294255,425322263,15562751,454632,1,'2007-09-17 20:16:25',3310491611,1),(53294258,425321932,15561426,454632,1,'2007-09-17 20:16:25',3310491611,1),(53294260,425321353,15560598,454632,1,'2007-09-17 20:16:25',3310491611,1),(53294262,425320608,15559398,454632,1,'2007-09-17 20:16:25',3310491611,1),(53294264,425319723,15557916,454632,1,'2007-09-17 20:16:25',3310491611,1),(53294267,425318368,15554992,454632,1,'2007-09-17 20:16:25',3310491611,1),(53294268,425317583,15552210,454632,1,'2007-09-17 20:16:25',3310491611,1),(53294270,425316656,15549357,454632,1,'2007-09-17 20:16:26',3310491611,1),(53294273,425315016,15547147,454632,1,'2007-09-17 20:16:26',3310491611,1),(53294277,425313304,15546077,454632,1,'2007-09-17 20:16:26',3310491610,1),(53294279,425310879,15545863,454632,1,'2007-09-17 20:16:27',3310491608,1),(53294284,425308525,15545649,454632,1,'2007-09-17 20:16:28',3310491608,1),(53294285,425305387,15544936,454632,1,'2007-09-17 20:16:28',3310491608,1),(53294290,425301964,15543295,454632,1,'2007-09-17 20:16:28',3310491608,1),(53294293,425299040,15541726,454632,1,'2007-09-17 20:16:28',3310491608,1),(53294297,425297098,15541445,454632,1,'2007-09-17 20:16:29',3310491608,1),(53294300,425294718,15541105,454632,1,'2007-09-17 20:16:29',3310491608,1),(53294304,425292830,15540916,454632,1,'2007-09-17 20:16:29',3310491608,1),(53294308,425291773,15540123,454632,1,'2007-09-17 20:16:30',3310491608,1),(53294311,425291018,15538462,454632,1,'2007-09-17 20:16:30',3310491608,1),(53294314,425290904,15537027,454632,1,'2007-09-17 20:16:30',3310491608,1),(53294317,425292302,15534043,454632,1,'2007-09-17 20:16:30',3310491608,1),(53294320,425293397,15533477,454632,1,'2007-09-17 20:16:31',3310491608,1),(53294323,425295247,15534496,454632,1,'2007-09-17 20:16:31',3310491608,1),(53294327,425297060,15536158,454632,1,'2007-09-17 20:16:31',3310491608,1),(53294331,425299477,15536762,454632,1,'2007-09-17 20:16:31',3310491608,1),(53294335,425301289,15536649,454632,1,'2007-09-17 20:16:32',3310491608,1),(53294337,425303442,15536158,454632,1,'2007-09-17 20:16:32',3310491608,1),(53294341,425306085,15534647,454632,1,'2007-09-17 20:16:32',3310491608,1),(53294344,425308049,15534270,454632,1,'2007-09-17 20:16:32',3310491608,1),(53294347,425310768,15534723,454632,1,'2007-09-17 20:16:32',3310491608,1),(53294350,425314393,15535931,454632,1,'2007-09-17 20:16:33',3310491608,1),(53294352,425318850,15540010,454632,1,'2007-09-17 20:16:33',3310491609,1),(53294354,425320398,15541332,454632,1,'2007-09-17 20:16:33',3310491609,1),(53294357,425321871,15544088,454632,1,'2007-09-17 20:16:33',3310491609,1),(53294362,425322815,15546430,454632,1,'2007-09-17 20:16:33',3310491611,1),(53294364,425324930,15549640,454632,1,'2007-09-17 20:16:33',3310491611,1),(53294366,425326818,15550924,454632,1,'2007-09-17 20:16:33',3310491611,1),(53294371,425328139,15550697,454632,1,'2007-09-17 20:16:34',3310491611,1),(53294374,425328970,15549942,454632,1,'2007-09-17 20:16:34',3310491611,1),(53294377,425329084,15548998,454632,1,'2007-09-17 20:16:34',3310491611,1),(53294382,425328933,15547525,454632,1,'2007-09-17 20:16:35',3310491611,1),(53294385,425327460,15546467,454632,1,'2007-09-17 20:16:35',3310491611,1),(53294389,425325685,15545372,454632,1,'2007-09-17 20:16:36',3310491609,1),(53294392,425324552,15544164,454632,1,'2007-09-17 20:16:36',3310491609,1),(53294394,425323457,15541143,454632,1,'2007-09-17 20:16:36',3310491609,1),(53294396,425321795,15538915,454632,1,'2007-09-17 20:16:36',3310491609,1),(53294401,425319454,15532721,454632,1,'2007-09-17 20:16:36',3310491609,1),(53294404,425317756,15529166,454632,1,'2007-09-17 20:16:36',3310491609,1),(53294409,425314205,15525875,454632,1,'2007-09-17 20:16:36',3310491608,1),(53294411,425311087,15523970,454632,1,'2007-09-17 20:16:36',3310491608,1),(53294416,425308056,15524143,454632,1,'2007-09-17 20:16:37',3310491608,1),(53294418,425305585,15524659,454632,1,'2007-09-17 20:16:37',3310491608,1),(53294420,425303314,15524801,454632,1,'2007-09-17 20:16:37',3310491608,1),(53294423,425301470,15523595,454632,1,'2007-09-17 20:16:37',3310491608,1),(53294425,425299306,15521431,454632,1,'2007-09-17 20:16:37',3310491608,1),(53294429,425297568,15518628,454632,1,'2007-09-17 20:16:38',3310491608,1),(53294430,425295865,15515578,454632,1,'2007-09-17 20:16:38',3310491608,1),(53294433,425293666,15513662,454632,1,'2007-09-17 20:16:38',3310491608,1),(53294434,425289693,15511463,454632,1,'2007-09-17 20:16:38',3310491608,1),(53294436,425285791,15510860,454632,1,'2007-09-17 20:16:38',3310491597,1),(53294443,425283237,15510966,454632,1,'2007-09-17 20:16:39',3310491597,1),(53294444,425281499,15511995,454632,1,'2007-09-17 20:16:39',3310491597,1),(53294448,425280648,15513662,454632,1,'2007-09-17 20:16:39',3310491597,1),(53294450,425278499,15517625,454632,1,'2007-09-17 20:16:39',3310491597,1),(53294455,425276549,15519668,454632,1,'2007-09-17 20:16:40',3310491597,1),(53294458,425274924,15520782,454632,1,'2007-09-17 20:16:40',3310491597,1),(53294463,425273810,15520039,454632,1,'2007-09-17 20:16:40',3310491597,1),(53294466,425273392,15518368,454632,1,'2007-09-17 20:16:41',3310491597,1),(53294469,425274831,15515954,454632,1,'2007-09-17 20:16:41',3310491597,1),(53294474,425276595,15513307,454632,1,'2007-09-17 20:16:41',3310491597,1),(53294475,425276735,15510196,454632,1,'2007-09-17 20:16:41',3310491597,1),(53294479,425276828,15505321,454632,1,'2007-09-17 20:16:42',3310491597,1),(53294483,425278731,15503139,454632,1,'2007-09-17 20:16:42',3310491597,1),(53294487,425282538,15500446,454632,1,'2007-09-17 20:16:42',3310491597,1),(53294490,425285788,15498589,454632,1,'2007-09-17 20:16:43',3310491597,1),(53294493,425288945,15497707,454632,1,'2007-09-17 20:16:43',3310491608,1),(53294496,425291406,15497057,454632,1,'2007-09-17 20:16:43',3310491608,1),(53294500,425294331,15497243,454632,1,'2007-09-17 20:16:43',3310491608,1),(53294503,425297024,15498311,454632,1,'2007-09-17 20:16:43',3310491608,1),(53294508,425298835,15500261,454632,1,'2007-09-17 20:16:44',3310491608,1),(53294512,425301063,15503046,454632,1,'2007-09-17 20:16:44',3310491608,1),(53294515,425304546,15505553,454632,1,'2007-09-17 20:16:44',3310491608,1),(53294520,425305242,15504857,454632,1,'2007-09-17 20:16:45',3310491608,1),(53294523,425305567,15504021,454632,1,'2007-09-17 20:16:45',3310491608,1),(53294526,425305335,15501282,454632,1,'2007-09-17 20:16:45',3310491608,1),(53294530,425304406,15500307,454632,1,'2007-09-17 20:16:45',3310491608,1),(53294531,425303013,15500168,454632,1,'2007-09-17 20:16:46',3310491608,1),(53294534,425301342,15498728,454632,1,'2007-09-17 20:16:46',3310491608,1),(53294537,425298974,15495850,454632,1,'2007-09-17 20:16:46',3310491608,1),(53294540,425297131,15493100,454632,1,'2007-09-17 20:16:46',3310491608,1),(53294541,425294579,15489698,454632,1,'2007-09-17 20:16:47',3310491602,1),(53294545,425291832,15488194,454632,1,'2007-09-17 20:16:47',3310491602,1),(53294548,425288627,15487147,454632,1,'2007-09-17 20:16:47',3310491602,1),(53294552,425286337,15487736,454632,1,'2007-09-17 20:16:47',3310491591,1),(53294557,425284178,15487605,454632,1,'2007-09-17 20:16:48',3310491591,1),(53294560,425282020,15485904,454632,1,'2007-09-17 20:16:48',3310491591,1),(53294562,425280319,15484596,454632,1,'2007-09-17 20:16:48',3310491591,1),(53294566,425278945,15484530,454632,1,'2007-09-17 20:16:48',3310491591,1),(53294570,425276982,15485904,454632,1,'2007-09-17 20:16:49',3310491591,1),(53294573,425275936,15487016,454632,1,'2007-09-17 20:16:49',3310491591,1),(53294577,425273515,15488128,454632,1,'2007-09-17 20:16:49',3310491591,1),(53294581,425272076,15488848,454632,1,'2007-09-17 20:16:50',3310491591,1),(53294584,425270310,15488455,864892,1,'2009-03-28 17:17:00',3310491591,3),(53294588,425269917,15487605,864892,1,'2009-03-28 17:17:00',3310491591,3),(53294591,425270637,15486362,864892,1,'2009-03-28 17:17:00',3310491591,3),(53294595,425272861,15484726,864892,1,'2009-03-28 17:17:00',3310491591,3),(53294596,425275151,15482699,864892,1,'2009-03-28 17:17:00',3310491591,3),(53294601,425277506,15479101,864892,1,'2009-03-28 17:17:00',3310491591,3),(53294602,425279534,15474391,864892,1,'2009-03-28 17:17:00',3310491591,3),(53294607,425283001,15465886,864892,1,'2009-03-28 17:17:00',3310491591,3),(53294610,425285356,15462158,864892,1,'2009-03-28 17:17:00',3310491591,3),(53294613,425289019,15459476,864892,1,'2009-03-28 17:17:00',3310491602,3),(53294616,425293402,15458887,864892,1,'2009-03-28 17:17:00',3310491602,3),(53294620,425297769,15458865,864892,1,'2009-03-28 17:16:59',3310491602,3),(53294623,425300588,15460275,864892,1,'2009-03-28 17:16:59',3310491602,3),(53294625,425304111,15462106,864892,1,'2009-03-28 17:16:59',3310491602,3),(53294630,425306365,15462106,864892,1,'2009-03-28 17:16:59',3310491602,3),(53294634,425310211,15460446,864892,1,'2009-03-28 17:16:59',3310491602,3),(53294637,425314035,15457921,864892,1,'2009-03-28 17:16:59',3310491602,3),(53294640,425318148,15455756,864892,1,'2009-03-28 17:16:59',3310491603,3),(53294645,425321033,15454746,864892,1,'2009-03-28 17:16:59',3310491603,3),(53294648,425325506,15454819,864892,1,'2009-03-28 17:16:59',3310491603,3),(53294652,425330485,15455829,864892,1,'2009-03-28 17:16:59',3310491603,3),(53294655,425336328,15455901,864892,1,'2009-03-28 17:16:59',3310491603,3),(53294659,425343038,15455973,864892,1,'2009-03-28 17:16:59',3310491606,3),(53294661,425345852,15456189,864892,1,'2009-03-28 17:16:59',3310491606,3),(53294665,425348810,15457849,864892,1,'2009-03-28 17:16:59',3310491606,3),(53294669,425351768,15460951,864892,1,'2009-03-28 17:16:59',3310491606,3),(53294671,425354942,15465785,864892,1,'2009-03-28 17:16:59',3310491606,3),(53294675,425357900,15469248,864892,1,'2009-03-28 17:16:59',3310491606,3),(53294677,425360930,15472494,864892,1,'2009-03-28 17:16:59',3310491606,3),(53294679,425364538,15475092,864892,1,'2009-03-28 17:16:59',3310491606,3),(53294684,425369011,15477256,864892,1,'2009-03-28 17:16:59',3310491606,3),(53294689,425372113,15480863,864892,1,'2009-03-28 17:16:59',3310491607,3),(53294691,425374710,15484543,864892,1,'2009-03-28 17:16:58',3310491607,3),(53294695,425376370,15488006,864892,1,'2009-03-28 17:16:58',3310491607,3),(53294698,425377524,15489954,864892,1,'2009-03-28 17:16:58',3310491607,3),(53294702,425378390,15490675,864892,1,'2009-03-28 17:16:58',3310491607,3),(53294704,425379833,15490675,864892,1,'2009-03-28 17:16:58',3310491607,3),(53294709,425380626,15489954,864892,1,'2009-03-28 17:17:43',3310491607,5),(53294712,425380121,15488944,864892,1,'2009-03-28 17:16:58',3310491607,3),(53294714,425379039,15487212,864892,1,'2009-03-28 17:16:58',3310491607,3),(53294716,425376153,15481368,864892,1,'2009-03-28 17:16:58',3310491607,3),(53294718,425372330,15473144,864892,1,'2009-03-28 17:16:58',3310491607,3),(53294721,425369804,15469464,864892,1,'2009-03-28 17:16:58',3310491607,3),(53294728,425367207,15466001,864892,1,'2009-03-28 17:16:58',3310491606,3),(53294730,425364971,15462177,864892,1,'2009-03-28 17:16:58',3310491606,3),(53294735,425362806,15457488,864892,1,'2009-03-28 17:16:58',3310491606,3),(53294737,425362013,15454458,864892,1,'2009-03-28 17:16:57',3310491606,3),(53294740,425362518,15451572,864892,1,'2009-03-28 17:16:57',3310491606,3),(53294745,425363167,15449263,864892,1,'2009-03-28 17:16:57',3310491606,3),(53294748,425363672,15447027,864892,1,'2009-03-28 17:16:57',3310491606,3),(53294752,425363239,15444502,864892,1,'2009-03-28 17:16:57',3310491606,3),(53294755,425362662,15440173,864892,1,'2009-03-28 17:16:57',3310491606,3),(53294756,425362013,15433463,864892,1,'2009-03-28 17:16:57',3310491604,3),(53294758,425361435,15429423,864892,1,'2009-03-28 17:16:57',3310491604,3),(53294761,425360570,15427908,864892,1,'2009-03-28 17:16:57',3310491604,3),(53294764,425359271,15426753,864892,1,'2009-03-28 17:16:57',3310491604,3),(53294767,425355087,15427042,864892,1,'2009-03-28 17:16:57',3310491604,3),(53294770,425346357,15426465,864892,1,'2009-03-28 17:16:57',3310491604,3),(53294776,425339791,15425166,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294777,425335901,15424201,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294782,425332447,15423093,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294785,425329505,15421728,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294786,425326904,15420194,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294790,425324858,15418744,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294792,425323621,15416868,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294795,425323238,15415418,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294800,425323195,15414651,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294803,425323962,15413969,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294805,425325028,15414054,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294807,425326904,15415418,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294810,425329079,15415759,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294813,425331552,15415248,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294816,425334366,15413670,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294820,425336839,15411709,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294823,425338331,15410217,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294826,425340292,15409023,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294829,425343149,15407872,864892,1,'2009-03-28 17:16:56',3310491604,3),(53294830,425346975,15407911,864892,1,'2009-03-28 17:16:56',3310491604,3),(53294834,425349420,15408563,864892,1,'2009-03-28 17:16:56',3310491604,3),(53294838,425352407,15408292,864892,1,'2009-03-28 17:16:56',3310491604,3),(53294843,425355721,15407585,864892,1,'2009-03-28 17:16:56',3310491604,3),(53294847,425359197,15405141,864892,1,'2009-03-28 17:16:56',3310491604,3),(53294849,425362511,15404272,864892,1,'2009-03-28 17:16:56',3310491604,3),(53294851,425366965,15402588,864892,1,'2009-03-28 17:16:56',3310491604,3),(53294855,425369083,15401719,864892,1,'2009-03-28 17:16:56',3310491604,3),(53294856,425371365,15400796,864892,1,'2009-03-28 17:16:56',3310491605,3),(53294860,425372668,15399926,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294866,425374081,15400633,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294867,425374298,15401230,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294872,425374461,15402751,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294874,425374895,15404163,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294877,425376145,15408835,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294880,425378861,15415136,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294884,425380979,15418232,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294887,425381359,15420676,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294891,425381631,15422360,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294894,425382228,15424098,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294898,425382935,15424207,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294900,425383478,15423935,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294904,425383912,15422523,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294906,425383695,15419699,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294910,425382772,15415788,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294913,425380979,15412528,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294917,425380816,15410084,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294919,425381033,15401828,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294922,425381359,15395853,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294924,425380653,15392376,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294929,425379838,15390258,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294930,425377666,15387270,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294933,425374515,15386238,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294937,425371093,15386564,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294939,425369068,15387042,864892,1,'2009-03-28 17:16:55',3310491604,3),(53294943,425367017,15386700,864892,1,'2009-03-28 17:16:55',3310491604,3),(53294946,425363988,15384892,864892,1,'2009-03-28 17:16:55',3310491604,3),(53294950,425361888,15383036,864892,1,'2009-03-28 17:16:55',3310491604,3),(53294953,425359836,15381913,864892,1,'2009-03-28 17:16:54',3310491604,3),(53294958,425356759,15380545,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294961,425354463,15379519,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294963,425352021,15378884,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294965,425350751,15378542,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294968,425350311,15377028,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294971,425350555,15375465,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294974,425351532,15372094,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294979,425352008,15369921,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294981,425352604,15367041,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294983,425352653,15365701,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294986,425351809,15364360,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294989,425350717,15363467,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294992,425349029,15362970,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294994,425347341,15362970,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294998,425346696,15362077,454632,1,'2007-09-17 20:17:23',3310491518,1),(53295002,425347043,15361034,454632,1,'2007-09-17 20:17:24',3310491518,1),(53295004,425348135,15360438,454632,1,'2007-09-17 20:17:24',3310491518,1),(53295006,425349277,15360190,454632,1,'2007-09-17 20:17:24',3310491518,1),(53295010,425351412,15360041,454632,1,'2007-09-17 20:17:24',3310491518,1),(53295011,425352405,15360091,454632,1,'2007-09-17 20:17:24',3310491518,1),(53295014,425353547,15361431,454632,1,'2007-09-17 20:17:25',3310491518,1),(53295016,425353994,15362523,454632,1,'2007-09-17 20:17:25',3310491518,1),(53295019,425354888,15363070,454632,1,'2007-09-17 20:17:25',3310491518,1),(53295022,425355533,15362474,454632,1,'2007-09-17 20:17:26',3310491518,1),(53295026,425355781,15361183,454632,1,'2007-09-17 20:17:26',3310491518,1),(53295029,425355781,15358800,454632,1,'2007-09-17 20:17:26',3310491518,1),(53295033,425356030,15356764,454632,1,'2007-09-17 20:17:26',3310491518,1),(53295035,425356526,15352346,454632,1,'2007-09-17 20:17:26',3310491518,1),(53295038,425355831,15350757,454632,1,'2007-09-17 20:17:26',3310491518,1),(53295040,425354242,15348969,454632,1,'2007-09-17 20:17:26',3310491518,1),(53295043,425356383,15354687,454632,1,'2007-09-17 20:17:27',3310491518,1),(53295045,425349917,15345329,454632,1,'2007-09-17 20:17:27',3310491518,1),(53295047,425348548,15343019,454632,1,'2007-09-17 20:17:27',3310491518,1),(53295051,425348034,15340538,454632,1,'2007-09-17 20:17:27',3310491518,1),(53295054,425347179,15336773,454632,1,'2007-09-17 20:17:27',3310491518,1),(53295057,425346494,15330356,454632,1,'2007-09-17 20:17:28',3310491518,1),(53295059,425345724,15323598,454632,1,'2007-09-17 20:17:28',3310491516,1),(53295063,425344698,15317523,454632,1,'2007-09-17 20:17:28',3310491516,1),(53295067,425342730,15312219,454632,1,'2007-09-17 20:17:29',3310491516,1),(53295071,425340677,15307342,454632,1,'2007-09-17 20:17:29',3310491513,1),(53295073,425340249,15305374,454632,1,'2007-09-17 20:17:29',3310491513,1),(53295077,425339564,15302380,454632,1,'2007-09-17 20:17:30',3310491513,1),(53295079,425337853,15301011,454632,1,'2007-09-17 20:17:30',3310491513,1),(53295083,425337083,15301011,454632,1,'2007-09-17 20:17:30',3310491513,1),(53295085,425334859,15302465,454632,1,'2007-09-17 20:17:30',3310491513,1),(53295090,425329725,15305117,454632,1,'2007-09-17 20:17:31',3310491513,1),(53295093,425328442,15306914,454632,1,'2007-09-17 20:17:31',3310491513,1),(53295097,425327586,15309224,454632,1,'2007-09-17 20:17:31',3310491513,1),(53295102,425322106,15316993,454632,1,'2007-09-17 20:17:32',3310491513,1),(53295103,425319547,15320497,454632,1,'2007-09-17 20:17:32',3310491513,1),(53295107,425318811,15321023,454632,1,'2007-09-17 20:17:32',3310491513,1),(53295110,425318251,15320883,454632,1,'2007-09-17 20:17:33',3310491513,1),(53295113,425317865,15320217,454632,1,'2007-09-17 20:17:33',3310491513,1),(53295117,425318671,15318955,454632,1,'2007-09-17 20:17:33',3310491513,1),(53295122,425320423,15316257,454632,1,'2007-09-17 20:17:34',3310491513,1),(53295125,425322246,15312157,454632,1,'2007-09-17 20:17:34',3310491513,1),(53295128,425324547,15305906,454632,1,'2007-09-17 20:17:35',3310491513,1),(53295132,425328686,15297384,454632,1,'2007-09-17 20:17:35',3310491513,1),(53295133,425333705,15291490,454632,1,'2007-09-17 20:17:35',3310491513,1),(53295137,425341820,15281437,454632,1,'2007-09-17 20:17:35',3310491513,1),(53295141,425342681,15280718,454632,1,'2007-09-17 20:17:36',3310491516,1),(53295143,425344836,15280718,454632,1,'2007-09-17 20:17:36',3310491516,1),(53295147,425346415,15281939,454632,1,'2007-09-17 20:17:36',3310491516,1),(53295149,425349144,15285386,454632,1,'2007-09-17 20:17:36',3310491516,1),(53295153,425352447,15288545,454632,1,'2007-09-17 20:17:36',3310491516,1),(53295157,425354171,15291418,454632,1,'2007-09-17 20:17:37',3310491516,1),(53295158,425355176,15295654,454632,1,'2007-09-17 20:17:37',3310491516,1),(53295161,425356468,15299819,454632,1,'2007-09-17 20:17:37',3310491516,1),(53295165,425358264,15301974,454632,1,'2007-09-17 20:17:37',3310491516,1),(53295169,425362069,15303984,454632,1,'2007-09-17 20:17:37',3310491516,1),(53295172,425364726,15305061,454632,1,'2007-09-17 20:17:38',3310491516,1),(53295175,425365875,15306210,454632,1,'2007-09-17 20:17:38',3310491516,1),(53295178,425366234,15308867,454632,1,'2007-09-17 20:17:38',3310491516,1),(53295182,425366522,15309442,454632,1,'2007-09-17 20:17:38',3310491516,1),(53295186,425367599,15309442,454632,1,'2007-09-17 20:17:38',3310491516,1),(53295188,425367886,15306857,454632,1,'2007-09-17 20:17:39',3310491516,1),(53295190,425367168,15304774,454632,1,'2007-09-17 20:17:39',3310491516,1),(53295193,425365875,15302548,454632,1,'2007-09-17 20:17:39',3310491516,1),(53295197,425364080,15300896,454632,1,'2007-09-17 20:17:40',3310491516,1),(53295202,425363290,15299676,454632,1,'2007-09-17 20:17:41',3310491516,1),(53295208,425362500,15297162,454632,1,'2007-09-17 20:17:42',3310491516,1),(53295211,425361639,15294865,454632,1,'2007-09-17 20:17:42',3310491516,1),(53295218,425360992,15290915,454632,1,'2007-09-17 20:17:42',3310491516,1),(53295222,425360849,15288689,454632,1,'2007-09-17 20:17:42',3310491516,1),(53295224,425359700,15285386,454632,1,'2007-09-17 20:17:42',3310491516,1),(53295228,425357689,15280575,454632,1,'2007-09-17 20:17:43',3310491516,1),(53295233,425354745,15276913,454632,1,'2007-09-17 20:17:43',3310491516,1),(53295236,425352734,15273753,454632,1,'2007-09-17 20:17:44',3310491516,1),(53295241,425351945,15272532,454632,1,'2007-09-17 20:17:44',3310491516,1),(53295243,425352160,15271455,454632,1,'2007-09-17 20:17:44',3310491516,1),(53295245,425353093,15271455,454632,1,'2007-09-17 20:17:44',3310491516,1),(53295249,425354314,15272676,454632,1,'2007-09-17 20:17:45',3310491516,1),(53295251,425356397,15274902,454632,1,'2007-09-17 20:17:45',3310491516,1),(53295253,425358551,15277200,454632,1,'2007-09-17 20:17:45',3310491516,1),(53295257,425360705,15278708,454632,1,'2007-09-17 20:17:46',3310491516,1),(53295259,425362462,15281428,327248,1,'2009-04-08 23:30:33',3310491516,6),(53295264,425364169,15282973,327248,1,'2009-04-08 23:30:33',3310491516,6),(53295267,425370855,15311725,327248,1,'2009-04-08 23:18:54',3310491517,8),(53295272,425368176,15308637,327248,1,'2009-04-08 23:18:54',3310491516,8),(53295276,425371718,15313950,327248,1,'2009-04-08 23:18:54',3310491517,8),(53295277,425372808,15315449,327248,1,'2009-04-08 23:18:54',3310491517,8),(53295281,425375170,15317175,327248,1,'2009-04-08 23:18:53',3310491517,8),(53295283,425376487,15318174,327248,1,'2009-04-08 23:18:53',3310491517,8),(53295287,425377625,15319796,327248,1,'2009-04-08 23:18:53',3310491517,8),(53295291,425378068,15320912,327248,1,'2009-04-08 23:18:53',3310491517,9),(53295292,425376759,15322307,327248,1,'2009-04-08 23:18:53',3310491517,8),(53295294,425375351,15322170,327248,1,'2009-04-08 23:18:53',3310491517,8),(53295298,425374307,15321625,327248,1,'2009-04-08 23:18:53',3310491517,8),(53295299,425373081,15320490,327248,1,'2009-04-08 23:18:53',3310491517,8),(53295301,425372082,15319037,327248,1,'2009-04-08 23:18:52',3310491517,8),(53295305,425371301,15318251,327248,1,'2009-04-08 23:18:52',3310491517,8),(53295308,425370352,15318080,327248,1,'2009-04-08 23:18:52',3310491517,8),(53295310,425369530,15318938,327248,1,'2009-04-08 23:18:52',3310491516,9),(53295312,425369594,15320054,327248,1,'2009-04-08 23:18:52',3310491516,8),(53295314,425369910,15321255,327248,1,'2009-04-08 23:18:52',3310491517,8),(53295315,425371219,15323351,327248,1,'2009-04-08 23:18:52',3310491517,8),(53295319,425372990,15326031,327248,1,'2009-04-08 23:18:52',3310491517,8),(53295321,425375475,15328122,327248,1,'2009-04-08 23:18:52',3310491519,8),(53295325,425376487,15329152,327248,1,'2009-04-08 23:18:52',3310491519,8),(53295327,425376740,15330611,327248,1,'2009-04-08 23:18:52',3310491519,8),(53295329,425375896,15331208,327248,1,'2009-04-08 23:18:52',3310491519,8),(53295332,425374779,15330868,327248,1,'2009-04-08 23:18:51',3310491519,8),(53295336,425373641,15330268,327248,1,'2009-04-08 23:18:51',3310491519,8),(53295339,425372313,15329238,327248,1,'2009-04-08 23:18:51',3310491519,8),(53295343,425370858,15327349,327248,1,'2009-04-08 23:18:51',3310491519,8),(53295347,425369175,15324804,327248,1,'2009-04-08 23:18:51',3310491516,8),(53295349,425368085,15323169,327248,1,'2009-04-08 23:18:51',3310491516,8),(53295353,425367313,15322261,327248,1,'2009-04-08 23:18:51',3310491516,8),(53295356,425366431,15322886,327248,1,'2009-04-08 23:18:51',3310491516,10),(53295359,425366305,15323916,327248,1,'2009-04-08 23:18:51',3310491516,8),(53295361,425366558,15325204,327248,1,'2009-04-08 23:18:51',3310491516,8),(53295363,425368585,15328937,327248,1,'2009-04-08 23:18:51',3310491518,8),(53295365,425371900,15334205,327248,1,'2009-04-08 23:18:51',3310491519,8),(53295370,425372400,15335567,327248,1,'2009-04-08 23:18:51',3310491519,8),(53295371,425372354,15337021,327248,1,'2009-04-08 23:18:51',3310491519,8),(53295375,425371219,15337747,327248,1,'2009-04-08 23:18:51',3310491519,8),(53295377,425369675,15337112,327248,1,'2009-04-08 23:18:51',3310491519,8),(53295379,425368676,15334296,327248,1,'2009-04-08 23:18:51',3310491518,8),(53295382,425365905,15329527,327248,1,'2009-04-08 23:18:51',3310491518,8),(53295385,425364089,15326485,327248,1,'2009-04-08 23:18:51',3310491518,8),(53295388,425361909,15325122,327248,1,'2009-04-08 23:18:51',3310491516,8),(53295391,425360410,15324941,327248,1,'2009-04-08 23:18:51',3310491516,8),(53306527,425342376,15239117,327248,1,'2009-04-08 23:30:34',3310491510,5),(53306532,425341080,15243006,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306534,425339843,15246247,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306537,425338311,15248663,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306540,425336248,15249605,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306542,425333715,15249664,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306543,425332242,15250136,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306545,425331181,15251609,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306547,425330180,15252964,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306550,425329119,15253612,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306552,425327705,15253848,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306554,425325937,15253435,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306556,425323816,15252551,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306559,425322048,15251078,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306562,425320458,15249605,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306564,425320104,15248309,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306565,425320104,15243477,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306566,425319927,15241297,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306568,425319102,15237585,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306569,425317276,15233520,454632,1,'2007-09-17 20:41:12',3310491507,1),(53306573,425316569,15232872,454632,1,'2007-09-17 20:41:12',3310491507,1),(53306575,425314094,15231634,454632,1,'2007-09-17 20:41:12',3310491506,1),(53306579,425311737,15231458,454632,1,'2007-09-17 20:41:13',3310491506,1),(53306582,425308261,15232636,454632,1,'2007-09-17 20:41:13',3310491506,1),(53306585,425306199,15234109,454632,1,'2007-09-17 20:41:13',3310491506,1),(53306588,425302310,15238410,454632,1,'2007-09-17 20:41:13',3310491506,1),(53306590,425300542,15239765,454632,1,'2007-09-17 20:41:14',3310491506,1),(53306592,425297773,15240590,454632,1,'2007-09-17 20:41:14',3310491506,1),(53306595,425294591,15240649,454632,1,'2007-09-17 20:41:14',3310491506,1),(53306597,425292795,15240491,454632,1,'2007-09-17 20:41:14',3310491506,1),(53306600,425289345,15240604,454632,1,'2007-09-17 20:41:14',3310491506,1),(53306603,425317174,15231385,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306606,425315421,15229744,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306607,425314572,15229405,327248,1,'2009-04-08 23:30:35',3310491506,5),(53306609,425312706,15229348,327248,1,'2009-04-08 23:30:35',3310491506,5),(53306611,425310839,15229348,327248,1,'2009-04-08 23:30:35',3310491506,5),(53306613,425309821,15229348,327248,1,'2009-04-08 23:30:35',3310491506,5),(53306617,425309312,15228726,327248,1,'2009-04-08 23:30:35',3310491506,5),(53306620,425309538,15227821,327248,1,'2009-04-08 23:30:35',3310491506,5),(53306623,425311122,15227199,327248,1,'2009-04-08 23:30:35',3310491506,5),(53306626,425315421,15227142,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306628,425317174,15227029,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306631,425319550,15228839,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306633,425321417,15232346,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306635,425322152,15234552,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306638,425322774,15235457,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306641,425323283,15235118,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306644,425323962,15234100,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306647,425325829,15231894,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306650,425327356,15231611,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306652,425329562,15231328,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306654,425330693,15231102,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306657,425332107,15229235,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306660,425333917,15224823,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306662,425337311,15220411,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306665,425340422,15217866,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306668,425341554,15217526,327248,1,'2009-04-08 23:30:37',3310491507,7),(53306670,425342798,15217639,226881,1,'2009-04-05 17:13:36',3310491510,4),(53306671,425343251,15218884,226881,1,'2009-04-05 17:13:36',3310491510,4),(53306672,425343760,15219393,226881,1,'2009-04-05 17:13:36',3310491510,4),(53306673,425344778,15220298,226881,1,'2009-04-05 17:13:36',3310491510,4),(53306675,425345909,15220637,226881,1,'2009-04-05 17:13:35',3310491510,4),(53306677,425346814,15220468,226881,1,'2009-04-05 17:13:35',3310491510,4),(53306679,425347070,15220262,226881,1,'2009-04-05 17:13:57',3310491510,6),(53306680,425348511,15217866,226881,1,'2009-04-05 17:13:57',3310491510,5),(53306683,425348850,15215773,226881,1,'2009-04-05 17:13:03',3310491508,3),(53306685,425348454,15211644,226881,1,'2009-04-05 17:13:03',3310491508,3),(53306687,425346701,15207175,226881,1,'2009-04-05 17:13:03',3310491508,3),(53306689,425344269,15201971,226881,1,'2009-04-05 17:09:50',3310491508,4),(53306691,425340875,15198294,226881,1,'2009-04-05 17:09:50',3310491505,4),(53306693,425335332,15197163,226881,1,'2009-04-05 17:09:50',3310491505,4),(53306695,425326521,15220199,454632,1,'2007-09-17 20:41:22',3310491507,1),(53306696,425333027,15219532,454632,1,'2007-09-17 20:41:22',3310491507,1),(53306697,425339157,15218948,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306699,425343685,15235832,327248,1,'2009-04-08 23:30:34',3310491510,5),(53306702,425344493,15234089,327248,1,'2009-04-08 23:30:34',3310491510,5),(53306704,425345343,15233494,327248,1,'2009-04-08 23:30:34',3310491510,5),(53306706,425345938,15233494,327248,1,'2009-04-08 23:30:34',3310491510,5),(53306708,425346575,15234514,327248,1,'2009-04-08 23:30:34',3310491510,5),(53306710,425346108,15235491,327248,1,'2009-04-08 23:30:34',3310491510,5),(53306712,425345428,15237999,327248,1,'2009-04-08 23:30:34',3310491510,5),(53306713,425344748,15241400,327248,1,'2009-04-08 23:30:34',3310491510,5),(53306715,425344238,15244078,327248,1,'2009-04-08 23:30:34',3310491510,6),(53306717,425343898,15246585,327248,1,'2009-04-08 23:30:34',3310491510,5),(53306720,425343175,15250326,327248,1,'2009-04-08 23:30:34',3310491510,5),(53306723,425341985,15252068,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306724,425339392,15253939,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306726,425335907,15256276,327248,1,'2009-04-08 23:30:33',3310491507,5),(53306727,425334631,15257254,327248,1,'2009-04-08 23:30:33',3310491507,5),(53306730,425334461,15258274,327248,1,'2009-04-08 23:30:33',3310491507,5),(53306733,425334844,15258954,327248,1,'2009-04-08 23:30:33',3310491507,5),(53306734,425335099,15259039,327248,1,'2009-04-08 23:30:33',3310491507,5),(53306737,425335694,15258869,327248,1,'2009-04-08 23:30:33',3310491507,5),(53306738,425337012,15258019,327248,1,'2009-04-08 23:30:33',3310491507,5),(53306740,425338627,15257339,327248,1,'2009-04-08 23:30:33',3310491507,5),(53306742,425340880,15257424,327248,1,'2009-04-08 23:30:33',3310491507,5),(53306743,425344450,15258402,327248,1,'2009-04-08 23:30:33',3310491510,5),(53306746,425347510,15259379,327248,1,'2009-04-08 23:30:33',3310491510,5),(53306749,425349168,15260995,327248,1,'2009-04-08 23:30:33',3310491510,5),(53306752,425352399,15265033,327248,1,'2009-04-08 23:30:33',3310491510,5),(53306755,425356522,15270643,327248,1,'2009-04-08 23:30:33',3310491510,5),(53306758,425360772,15276339,327248,1,'2009-04-08 23:30:33',3310491516,5),(53306761,425362855,15279952,327248,1,'2009-04-08 23:30:33',3310491516,5),(53306764,425365502,15285562,454632,1,'2007-09-17 20:41:28',3310491516,1),(53306767,425367828,15287858,454632,1,'2007-09-17 20:41:28',3310491516,1),(53306769,425369273,15290690,454632,1,'2007-09-17 20:41:28',3310491516,1),(53306771,425370351,15292128,454632,1,'2007-09-17 20:41:29',3310491517,1),(53306774,425371848,15294044,454632,1,'2007-09-17 20:41:29',3310491517,1),(53306775,425374843,15295960,454632,1,'2007-09-17 20:41:29',3310491517,1),(53306778,425377238,15298775,454632,1,'2007-09-17 20:41:29',3310491517,1),(53306780,425378975,15301171,454632,1,'2007-09-17 20:41:29',3310491517,1),(53306781,425379694,15301889,454632,1,'2007-09-17 20:41:30',3310491517,1),(53306782,425381011,15302428,454632,1,'2007-09-17 20:41:30',3310491517,1),(53306786,425381550,15302249,454632,1,'2007-09-17 20:41:30',3310491517,1),(53306787,425382736,15301032,1074615,1,'2009-05-04 17:34:16',3310491517,2),(53306788,425382928,15300392,454632,1,'2007-09-17 20:41:30',3310491517,1),(53306789,425382748,15298596,454632,1,'2007-09-17 20:41:31',3310491517,1),(53306790,425381371,15290870,454632,1,'2007-09-17 20:41:31',3310491517,1),(53306791,425380772,15287456,454632,1,'2007-09-17 20:41:31',3310491517,1),(53306792,425381011,15284642,454632,1,'2007-09-17 20:41:31',3310491517,1),(53306794,425381909,15279791,454632,1,'2007-09-17 20:41:31',3310491517,1),(53306795,425381909,15276437,454632,1,'2007-09-17 20:41:31',3310491517,1),(53306796,425382089,15272065,454632,1,'2007-09-17 20:41:31',3310491517,1),(53306799,425381670,15268711,454632,1,'2007-09-17 20:41:32',3310491511,1),(53306800,425381191,15266496,454632,1,'2007-09-17 20:41:32',3310491511,1),(53306803,425380640,15264759,454632,1,'2007-09-17 20:41:32',3310491511,1),(53306804,425380393,15262903,454632,1,'2007-09-17 20:41:32',3310491511,1),(53306806,425380787,15261695,454632,1,'2007-09-17 20:41:32',3310491511,1),(53306808,425386743,15264732,454632,1,'2007-09-17 20:41:32',3310491511,1),(53306810,425386233,15266484,454632,1,'2007-09-17 20:41:32',3310491511,1),(53306813,425386902,15270275,454632,1,'2007-09-17 20:41:32',3310491511,1),(53306814,425387953,15272887,454632,1,'2007-09-17 20:41:33',3310491517,1),(53306817,425388526,15273619,454632,1,'2007-09-17 20:41:33',3310491517,1),(53306819,425388367,15276581,454632,1,'2007-09-17 20:41:33',3310491517,1),(53306821,425387953,15279639,454632,1,'2007-09-17 20:41:33',3310491517,1),(53306823,425386711,15281710,454632,1,'2007-09-17 20:41:33',3310491517,1),(53306825,425385564,15284035,454632,1,'2007-09-17 20:41:34',3310491517,1),(53306828,425384672,15285596,454632,1,'2007-09-17 20:41:34',3310491517,1),(53306831,425384290,15287029,454632,1,'2007-09-17 20:41:34',3310491517,1),(53306833,425384290,15288048,454632,1,'2007-09-17 20:41:34',3310491517,1),(53306836,425384063,15288780,454632,1,'2007-09-17 20:41:34',3310491517,1),(53306838,425383599,15289074,454632,1,'2007-09-17 20:41:34',3310491517,1),(53306841,425383109,15289000,454632,1,'2007-09-17 20:41:35',3310491517,1),(53306843,425382449,15288389,454632,1,'2007-09-17 20:41:35',3310491517,1),(53306845,425382424,15287117,454632,1,'2007-09-17 20:41:35',3310491517,1),(53306846,425382302,15286383,454632,1,'2007-09-17 20:41:35',3310491517,1),(53306848,425381715,15286383,454632,1,'2007-09-17 20:41:35',3310491517,1),(53306849,425381691,15286994,454632,1,'2007-09-17 20:41:36',3310491517,1),(53306852,425381691,15288071,454632,1,'2007-09-17 20:41:36',3310491517,1),(53306853,425382131,15291691,454632,1,'2007-09-17 20:41:36',3310491517,1),(53306856,425382522,15294015,454632,1,'2007-09-17 20:41:36',3310491517,1),(53306858,425383232,15295116,454632,1,'2007-09-17 20:41:36',3310491517,1),(53306862,425383281,15295654,454632,1,'2007-09-17 20:41:36',3310491517,1),(53306863,425382791,15296535,454632,1,'2007-09-17 20:41:36',3310491517,1),(53306866,425382376,15296877,454632,1,'2007-09-17 20:41:37',3310491517,1),(53306869,425387144,15290358,454632,1,'2007-09-17 20:41:37',3310491517,1),(53306871,425382191,15259320,454632,1,'2007-09-17 20:41:37',3310491511,1),(53306873,425384474,15257330,454632,1,'2007-09-17 20:41:37',3310491511,1),(53306874,425386640,15255456,454632,1,'2007-09-17 20:41:37',3310491511,1),(53306875,425387987,15253817,454632,1,'2007-09-17 20:41:37',3310491511,1),(53306876,425389509,15251797,454632,1,'2007-09-17 20:41:37',3310491511,1),(53306878,425392612,15248342,454632,1,'2007-09-17 20:41:38',3310491511,1),(53306881,425396682,15244332,454632,1,'2007-09-17 20:41:38',3310491511,1),(53306882,425398994,15242166,454632,1,'2007-09-17 20:41:38',3310502434,1),(53306885,425401131,15240526,454632,1,'2007-09-17 20:41:38',3310502434,1),(53306886,425403236,15239413,454632,1,'2007-09-17 20:41:38',3310502434,1),(53306887,425405858,15237908,454632,1,'2007-09-17 20:41:38',3310502434,1),(53306888,425408529,15235577,454632,1,'2007-09-17 20:41:38',3310502434,1),(53306889,425410277,15233343,454632,1,'2007-09-17 20:41:39',3310502434,1),(53306892,425412074,15231740,454632,1,'2007-09-17 20:41:39',3310502434,1),(53306893,425414745,15230040,454632,1,'2007-09-17 20:41:39',3310502434,1),(53306897,425417076,15228826,454632,1,'2007-09-17 20:41:39',3310502434,1),(53306899,425419261,15228438,454632,1,'2007-09-17 20:41:39',3310502434,1),(53306901,425420864,15228729,454632,1,'2007-09-17 20:41:39',3310502434,1),(53306904,425423244,15228972,454632,1,'2007-09-17 20:41:40',3310502434,1),(53306906,425425575,15229555,454632,1,'2007-09-17 20:41:40',3310502435,1),(53306907,425427760,15229603,454632,1,'2007-09-17 20:41:40',3310502435,1),(53306910,425428780,15229409,454632,1,'2007-09-17 20:41:40',3310502435,1),(53306911,425431429,15231442,725665,1,'2009-03-02 22:19:39',3310502435,5),(53306912,425436151,15233743,725665,1,'2009-03-02 22:19:39',3310502435,5),(53306913,425441103,15235423,725665,1,'2009-03-02 22:19:39',3310502435,6),(53306917,425446288,15238170,725665,1,'2009-03-02 22:19:39',3310502435,6),(53306921,425455281,15243247,725665,1,'2009-03-02 22:19:39',3310502438,5),(53306923,425462606,15247363,725665,1,'2009-03-02 22:19:39',3310502438,5),(53306925,425465209,15247424,725665,1,'2009-03-02 22:19:39',3310502438,5),(53306928,425469446,15246879,725665,1,'2009-03-02 22:19:39',3310502438,5),(53306930,425472473,15246698,725665,1,'2009-03-02 22:19:39',3310502438,5),(53306932,425475197,15247242,725665,1,'2009-03-02 22:19:39',3310502438,5),(53306935,425477982,15248877,725665,1,'2009-03-02 22:19:39',3310502438,5),(53306936,425479858,15250814,725665,1,'2009-03-02 22:19:39',3310502439,5),(53306938,425482098,15252570,725665,1,'2009-03-02 22:19:39',3310502439,5),(53306940,425484641,15253478,725665,1,'2009-03-02 22:19:39',3310502439,5),(53306943,425487668,15253962,725665,1,'2009-03-02 22:19:39',3310502439,5),(53306944,425490210,15254688,725665,1,'2009-03-02 22:19:39',3310502439,5),(53306946,425495961,15257413,725665,1,'2009-03-02 22:19:39',3310502439,5),(53306949,425499230,15259410,725665,1,'2009-03-02 22:19:39',3310502439,5),(53306952,425503104,15262437,725665,1,'2009-03-02 22:19:39',3310502439,5),(53306954,425507584,15265524,725665,1,'2009-03-02 22:19:39',3310502450,5),(53306956,425511156,15267159,725665,1,'2009-03-02 22:19:39',3310502450,5),(53306959,425513349,15266199,725665,1,'2009-03-02 22:22:38',3310502450,10),(53306963,425463187,15250873,454632,1,'2007-09-17 20:41:45',3310502438,1),(53306966,425462700,15251577,454632,1,'2007-09-17 20:41:45',3310502438,1),(53306970,425461887,15252119,454632,1,'2007-09-17 20:41:45',3310502438,1),(53306973,425460586,15251685,454632,1,'2007-09-17 20:41:46',3310502438,1),(53306975,425458527,15250114,454632,1,'2007-09-17 20:41:46',3310502438,1),(53306978,425454193,15247242,454632,1,'2007-09-17 20:41:46',3310502438,1),(53306979,425451104,15245834,454632,1,'2007-09-17 20:41:46',3310502435,1),(53306980,425448881,15239715,725665,1,'2009-03-02 22:19:39',3310502435,7),(53306983,425448839,15244587,454632,1,'2007-09-17 20:41:46',3310502435,1),(53306984,425448969,15245801,454632,1,'2007-09-17 20:41:47',3310502435,1),(53306988,425450140,15249356,454632,1,'2007-09-17 20:41:47',3310502435,1),(53306989,425451354,15252780,454632,1,'2007-09-17 20:41:47',3310502435,1),(53306991,425452784,15254384,454632,1,'2007-09-17 20:41:47',3310502438,1),(53306992,425455862,15255858,454632,1,'2007-09-17 20:41:47',3310502438,1),(53306994,425459850,15257895,454632,1,'2007-09-17 20:41:47',3310502438,1),(53309350,425446288,15244693,423843,1,'2008-07-08 00:16:11',3310502435,2),(53309352,425445010,15244239,454632,1,'2007-09-17 20:47:54',3310502435,1),(53309354,425443070,15243528,454632,1,'2007-09-17 20:47:54',3310502435,1),(53309356,425440742,15242170,454632,1,'2007-09-17 20:47:55',3310502435,1),(53309360,425437703,15241911,454632,1,'2007-09-17 20:47:55',3310502435,1),(53309365,425433953,15241394,454632,1,'2007-09-17 20:47:55',3310502435,1),(53309368,425431681,15241174,423843,1,'2008-07-08 00:19:31',3310502435,3),(53309369,425427317,15240316,423843,1,'2008-07-08 00:19:31',3310502435,2),(53309370,425424900,15240101,454632,1,'2007-09-17 20:47:56',3310502435,1),(53309371,425422005,15240573,423843,1,'2008-07-08 00:19:31',3310502434,2),(53309374,425419533,15240941,454632,1,'2007-09-17 20:47:57',3310502434,1),(53309376,425417981,15240941,454632,1,'2007-09-17 20:47:57',3310502434,1),(53309379,425415175,15239200,423843,1,'2008-07-08 00:19:31',3310502434,2),(53309380,425448059,15229125,454632,1,'2007-09-17 20:47:58',3310502435,1),(53309382,425444834,15237312,725665,1,'2009-03-02 22:19:39',3310502435,6),(53309384,425434463,15225810,423843,1,'2008-07-08 00:10:55',3310502435,4),(53309386,425444900,15247478,427200,1,'2008-05-12 16:43:07',3310502435,2),(53309389,425441120,15248118,427200,1,'2008-05-12 16:43:07',3310502435,2),(53309392,425449284,15247192,439103,1,'2008-05-14 00:34:52',3310502435,2),(53309393,425438864,15248212,454632,1,'2007-09-17 20:48:00',3310502435,1),(53309395,425435426,15248291,454632,1,'2007-09-17 20:48:00',3310502435,1),(53309397,425432661,15247658,454632,1,'2007-09-17 20:48:00',3310502435,1),(53309398,425429381,15246750,454632,1,'2007-09-17 20:48:00',3310502435,1),(53309400,425426576,15246197,454632,1,'2007-09-17 20:48:00',3310502435,1),(53309402,425423929,15246197,454632,1,'2007-09-17 20:48:01',3310502434,1),(53309405,425421598,15246592,454632,1,'2007-09-17 20:48:01',3310502434,1),(53309407,425419543,15247066,454632,1,'2007-09-17 20:48:02',3310502434,1),(53309409,425418397,15247698,454632,1,'2007-09-17 20:48:02',3310502434,1),(53309412,425418397,15248409,454632,1,'2007-09-17 20:48:02',3310502434,1),(53309414,425418990,15248804,454632,1,'2007-09-17 20:48:02',3310502434,1),(53309417,425419820,15248883,454632,1,'2007-09-17 20:48:03',3310502434,1),(53309419,425418982,15247236,454632,1,'2007-09-17 20:48:03',3310502434,1),(53309421,425424996,15249911,454632,1,'2007-09-17 20:48:03',3310502435,1),(53309423,425428275,15251056,454632,1,'2007-09-17 20:48:03',3310502435,1),(53309425,425431910,15252637,454632,1,'2007-09-17 20:48:03',3310502435,1),(53309427,425434676,15254415,454632,1,'2007-09-17 20:48:04',3310502435,1),(53309431,425437441,15256153,454632,1,'2007-09-17 20:48:04',3310502435,1),(53309433,425440207,15256667,454632,1,'2007-09-17 20:48:04',3310502435,1),(53309436,425442696,15256706,454632,1,'2007-09-17 20:48:05',3310502435,1),(53309438,425446015,15257734,454632,1,'2007-09-17 20:48:05',3310502435,1),(53309440,425448702,15258998,454632,1,'2007-09-17 20:48:06',3310502435,1),(53309443,425451942,15260736,454632,1,'2007-09-17 20:48:06',3310502435,1),(53309446,425455814,15264253,454632,1,'2007-09-17 20:48:06',3310502438,1),(53309449,425458738,15268046,454632,1,'2007-09-17 20:48:06',3310502438,1),(53309453,425461029,15270061,454632,1,'2007-09-17 20:48:06',3310502438,1),(53309457,425462136,15272985,454632,1,'2007-09-17 20:48:07',3310502444,1),(53309460,425463439,15275276,454632,1,'2007-09-17 20:48:07',3310502444,1),(53309462,425464506,15277015,454632,1,'2007-09-17 20:48:07',3310502444,1),(53309464,425467074,15279306,454632,1,'2007-09-17 20:48:07',3310502444,1),(53309466,425468023,15281045,454632,1,'2007-09-17 20:48:07',3310502444,1),(53309469,425468102,15282467,454632,1,'2007-09-17 20:48:08',3310502444,1),(53309473,425467667,15284087,454632,1,'2007-09-17 20:48:08',3310502444,1),(53309476,425466956,15286063,454632,1,'2007-09-17 20:48:08',3310502444,1),(53309477,425466798,15288275,454632,1,'2007-09-17 20:48:08',3310502444,1),(53309480,425467430,15290962,454632,1,'2007-09-17 20:48:09',3310502444,1),(53309482,425468220,15294241,454632,1,'2007-09-17 20:48:09',3310502444,1),(53309483,425469169,15297758,454632,1,'2007-09-17 20:48:09',3310502444,1),(53309485,425470709,15303171,454632,1,'2007-09-17 20:48:10',3310502444,1),(53315413,425565971,15347129,454632,1,'2007-09-17 21:04:42',3310502462,1),(53315705,425566654,15347695,498434,1,'2008-05-22 18:38:15',3310502462,4),(53315884,425566717,15349669,498434,1,'2008-05-22 18:38:00',3310502462,2),(53315943,425564947,15350098,498434,1,'2008-05-22 18:38:48',3310502462,2),(53315948,425563556,15351043,498434,1,'2008-05-22 18:38:48',3310502462,2),(53315952,425562734,15351987,498434,1,'2008-05-22 18:38:48',3310502462,2),(53315955,425562481,15353360,498434,1,'2008-05-22 18:38:48',3310502462,2),(53316065,425562355,15355763,498434,1,'2008-05-22 18:38:48',3310502462,2),(53316068,425561383,15361459,454632,1,'2007-09-17 21:06:31',3310502459,1),(53316074,425561191,15362550,454632,1,'2007-09-17 21:06:32',3310502459,1),(53316105,425550796,15363384,454632,1,'2007-09-17 21:06:39',3310502459,1),(53319479,425557992,15358167,498434,1,'2008-05-22 18:39:02',3310502459,2),(53319482,425562102,15358338,498434,1,'2008-05-22 18:39:02',3310502462,2),(53319484,425561067,15366284,454632,1,'2007-09-17 21:16:42',3310502459,1),(53319487,425547388,15367865,454632,1,'2007-09-17 21:16:42',3310502459,1),(53319489,425561013,15366339,454632,1,'2007-09-17 21:16:43',3310502459,1),(53319491,425431049,15168599,174860,1,'2008-12-06 16:03:50',3310502433,2),(53319492,425427698,15168427,174860,1,'2008-12-06 16:03:50',3310502433,2),(53319495,425424903,15167833,174860,1,'2008-12-06 16:03:50',3310502433,2),(53319497,425424012,15166263,174860,1,'2008-12-06 16:03:50',3310502432,2),(53319500,425424988,15165202,174860,1,'2008-12-06 16:03:50',3310502433,2),(53319503,425427364,15164269,174860,1,'2008-12-06 16:03:50',3310502433,2),(53319505,425428679,15162614,174860,1,'2008-12-06 16:03:50',3310502433,2),(53319509,425429061,15161681,174860,1,'2008-12-06 16:03:50',3310502433,2),(53319512,425426515,15150650,844916,1,'2009-01-27 19:52:23',3310502411,6),(53319514,425402915,15191242,454632,1,'2007-09-17 21:16:45',3310502432,1),(53319515,425405899,15191242,454632,1,'2007-09-17 21:16:45',3310502432,1),(53319517,425408169,15190205,454632,1,'2007-09-17 21:16:45',3310502432,1),(53319520,425410180,15187610,454632,1,'2007-09-17 21:16:46',3310502432,1),(53319521,425412710,15181254,454632,1,'2007-09-17 21:16:46',3310502432,1),(53319523,425415112,15175546,454632,1,'2007-09-17 21:16:46',3310502432,1),(53319525,425416751,15173552,454632,1,'2007-09-17 21:16:46',3310502432,1),(53319529,425418615,15172348,454632,1,'2007-09-17 21:16:46',3310502432,1),(53319532,425421790,15169773,454632,1,'2007-09-17 21:16:47',3310502432,1),(53319533,425424385,15167308,174860,1,'2008-12-06 16:03:50',3310502432,2),(53319535,425402887,15188047,454632,1,'2007-09-17 21:16:48',3310502432,1),(53319536,425405694,15187977,454632,1,'2007-09-17 21:16:48',3310502432,1),(53319538,425407308,15186573,454632,1,'2007-09-17 21:16:49',3310502432,1),(53319539,425408712,15184397,454632,1,'2007-09-17 21:16:49',3310502432,1),(53319541,425410607,15179835,454632,1,'2007-09-17 21:16:50',3310502432,1),(53319543,425412643,15174150,454632,1,'2007-09-17 21:16:50',3310502432,1),(53319545,425414327,15171062,454632,1,'2007-09-17 21:16:51',3310502432,1),(53319547,425416714,15168465,454632,1,'2007-09-17 21:16:51',3310502432,1),(53319548,425418889,15166219,454632,1,'2007-09-17 21:16:52',3310502432,1),(53319551,425421697,15163973,454632,1,'2007-09-17 21:16:52',3310502432,1),(53319552,425425066,15161376,454632,1,'2007-09-17 21:16:53',3310502433,1),(53319554,425428505,15158077,174860,1,'2008-12-06 16:03:50',3310502411,2),(53319555,425417658,15163247,327248,1,'2009-04-08 23:43:26',3310502432,2),(53319557,425427818,15155261,327248,1,'2009-04-08 23:43:27',3310502411,3),(53319560,425428101,15148453,787878,1,'2009-01-15 00:29:04',3310502411,2),(53319563,425429042,15147303,787878,1,'2009-01-15 00:29:04',3310502411,2),(53319564,425431498,15147251,787878,1,'2009-01-15 00:29:04',3310502411,2),(53319566,425433275,15147878,787878,1,'2009-01-15 00:29:04',3310502411,2),(53319568,425435522,15148244,787878,1,'2009-01-15 00:29:04',3310502411,2),(53319570,425437665,15148244,787878,1,'2009-01-15 00:29:04',3310502411,2),(53319571,425439285,15147565,787878,1,'2009-01-15 00:29:04',3310502411,2),(53319573,425442212,15145213,787878,1,'2009-01-15 00:29:03',3310502411,2),(53319576,425443884,15143645,725665,1,'2009-03-02 22:10:41',3310502411,3),(53319578,425444668,15141241,787878,1,'2009-01-15 00:29:03',3310502411,2),(53319581,425337097,15191335,454632,1,'2007-09-17 21:16:58',3310491505,1),(53319582,425337629,15192358,454632,1,'2007-09-17 21:16:59',3310491505,1),(53319584,425336116,15190231,454632,1,'2007-09-17 21:17:00',3310491505,1),(53319587,425333375,15188799,454632,1,'2007-09-17 21:17:00',3310491505,1);
INSERT INTO `current_nodes` VALUES (53319589,425330266,15187490,454632,1,'2007-09-17 21:17:01',3310491505,1),(53319592,425328793,15187408,454632,1,'2007-09-17 21:17:01',3310491505,1),(53319593,425326093,15188267,454632,1,'2007-09-17 21:17:02',3310491505,1),(53319596,425324743,15188676,454632,1,'2007-09-17 21:17:02',3310491505,1),(53319598,425323557,15188472,454632,1,'2007-09-17 21:17:02',3310491505,1),(53319600,425322616,15187981,454632,1,'2007-09-17 21:17:02',3310491505,1),(53319601,425322411,15186754,454632,1,'2007-09-17 21:17:03',3310491505,1),(53319603,425322330,15185240,454632,1,'2007-09-17 21:17:05',3310491505,1),(53319605,425324048,15180740,454632,1,'2007-09-17 21:17:06',3310491505,1),(53319607,425325316,15178367,454632,1,'2007-09-17 21:17:06',3310491505,1),(53319609,425326502,15177263,454632,1,'2007-09-17 21:17:06',3310491505,1),(53319610,425328589,15176527,454632,1,'2007-09-17 21:17:07',3310491505,1),(53319611,425330634,15175299,454632,1,'2007-09-17 21:17:07',3310491505,1),(53319612,425331861,15173867,454632,1,'2007-09-17 21:17:07',3310491505,1),(53319613,425331984,15172681,454632,1,'2007-09-17 21:17:07',3310491505,1),(53319616,425331166,15171617,454632,1,'2007-09-17 21:17:08',3310491505,1),(53319617,425327934,15170881,454632,1,'2007-09-17 21:17:08',3310491505,1),(53319619,425325357,15170799,454632,1,'2007-09-17 21:17:08',3310491505,1),(53319621,425323884,15171699,454632,1,'2007-09-17 21:17:08',3310491505,1),(53319624,425322411,15173499,454632,1,'2007-09-17 21:17:09',3310491505,1),(53319625,425321007,15175256,454632,1,'2007-09-17 21:17:09',3310491505,1),(53319627,425319214,15177633,454632,1,'2007-09-17 21:17:09',3310491505,1),(53319629,425318047,15179009,454632,1,'2007-09-17 21:17:10',3310491505,1),(53319631,425316129,15180802,454632,1,'2007-09-17 21:17:10',3310491505,1),(53319632,425314670,15181385,454632,1,'2007-09-17 21:17:10',3310491504,1),(53319634,425312835,15181302,454632,1,'2007-09-17 21:17:11',3310491504,1),(53319636,425311292,15179509,454632,1,'2007-09-17 21:17:11',3310491504,1),(53319638,425310834,15176757,454632,1,'2007-09-17 21:17:12',3310491504,1),(53319639,425311876,15170878,454632,1,'2007-09-17 21:17:12',3310491504,1),(53319642,425313252,15167043,454632,1,'2007-09-17 21:17:12',3310491504,1),(53319643,425316796,15163999,454632,1,'2007-09-17 21:17:12',3310491505,1),(53319645,425318756,15163665,454632,1,'2007-09-17 21:17:13',3310491505,1),(53319646,425314512,15164899,454632,1,'2007-09-17 21:17:13',3310491504,1),(53319648,425322193,15163589,454632,1,'2007-09-17 21:17:13',3310491505,1),(53319649,425325911,15163390,454632,1,'2007-09-17 21:17:14',3310491505,1),(53319651,425328634,15163324,454632,1,'2007-09-17 21:17:14',3310491505,1),(53319652,425332485,15162660,454632,1,'2007-09-17 21:17:14',3310491505,1),(53319657,425335340,15162328,454632,1,'2007-09-17 21:17:15',3310491505,1),(53319658,425336934,15161398,454632,1,'2007-09-17 21:17:15',3310491505,1),(53319659,425338328,15159473,454632,1,'2007-09-17 21:17:15',3310491483,1),(53319661,425340785,15158078,454632,1,'2007-09-17 21:17:16',3310491483,1),(53319663,425344503,15157613,454632,1,'2007-09-17 21:17:16',3310491486,1),(53319664,425348819,15157547,454632,1,'2007-09-17 21:17:16',3310491486,1),(53319665,425353002,15158543,454632,1,'2007-09-17 21:17:16',3310491486,1),(53319666,425355725,15160336,454632,1,'2007-09-17 21:17:17',3310491486,1),(53319667,425358978,15162129,454632,1,'2007-09-17 21:17:17',3310491508,1),(53319669,425361900,15164386,454632,1,'2007-09-17 21:17:17',3310491508,1),(53319670,425362896,15165183,454632,1,'2007-09-17 21:17:17',3310491508,1),(53319672,425363826,15165648,454632,1,'2007-09-17 21:17:17',3310491508,1),(53319675,425364822,15165581,454632,1,'2007-09-17 21:17:18',3310491508,1),(53319678,425367146,15164785,454632,1,'2007-09-17 21:17:18',3310491508,1),(53319681,425369204,15164054,454632,1,'2007-09-17 21:17:18',3310491508,1),(53319682,425370665,15162660,454632,1,'2007-09-17 21:17:18',3310491509,1),(53319684,425371679,15161533,454632,1,'2007-09-17 21:35:49',3310491509,1),(53319686,425373852,15160668,454632,1,'2007-09-17 21:17:19',3310491487,1),(53319687,425375711,15160668,104780,1,'2009-02-04 00:29:51',3310491487,2),(53319688,425378234,15162195,454632,1,'2007-09-17 21:17:19',3310491509,1),(53319690,425382085,15163988,454632,1,'2007-09-17 21:17:20',3310491509,1),(53319693,425386069,15165249,454632,1,'2007-09-17 21:17:20',3310491509,1),(53319695,425390186,15165714,454632,1,'2007-09-17 21:17:20',3310491509,1),(53319697,425393639,15166046,454632,1,'2007-09-17 21:17:20',3310491509,1),(53319700,425397623,15165183,454632,1,'2007-09-17 21:17:21',3310502432,1),(53319701,425401474,15164453,454632,1,'2007-09-17 21:17:21',3310502432,1),(53319702,425405525,15162394,454632,1,'2007-09-17 21:17:21',3310502432,1),(53319703,425408977,15159539,454632,1,'2007-09-17 21:17:21',3310502410,1),(53319705,425414887,15155887,844916,1,'2009-01-27 19:52:23',3310502410,4),(53319707,425410991,15151349,844916,1,'2009-01-27 19:52:23',3310502410,4),(53319708,425417533,15157215,844916,1,'2009-01-27 19:52:23',3310502410,4),(53319710,425419292,15157530,844916,1,'2009-01-27 19:52:23',3310502410,4),(53319712,425421007,15156899,844916,1,'2009-01-27 19:52:23',3310502410,4),(53319714,425423669,15154147,844916,1,'2009-01-27 19:52:23',3310502410,4),(53319717,425409176,15148884,844916,1,'2009-01-27 19:52:23',3310502410,4),(53319718,425408583,15146827,844916,1,'2009-01-27 19:52:23',3310502410,4),(53319720,425408375,15145987,844916,1,'2009-01-27 19:52:23',3310502410,5),(53319721,425410323,15140340,844916,1,'2009-01-27 19:52:23',3310502410,4),(53319724,425415900,15131243,844916,1,'2009-01-27 19:52:23',3310502410,4),(53319725,425422031,15123570,844916,1,'2009-01-27 19:52:23',3310502410,4),(53319726,425426225,15118832,844916,1,'2009-01-27 19:52:23',3310502411,4),(53319727,425429536,15114342,844916,1,'2009-01-27 19:52:23',3310502411,4),(53319731,425431350,15110940,844916,1,'2009-01-27 19:52:23',3310502411,4),(53319732,425433300,15106088,844916,1,'2009-01-27 19:52:23',3310502409,4),(53319735,425434525,15103321,844916,1,'2009-01-27 19:52:23',3310502409,4),(53319737,425440783,15095974,844916,1,'2009-01-27 19:52:23',3310502409,4),(53319740,425443913,15093298,844916,1,'2009-01-27 19:52:23',3310502409,4),(53319741,425448312,15092573,844916,1,'2009-01-27 19:52:23',3310502409,4),(53319742,425453618,15091529,844916,1,'2009-01-27 19:52:23',3310502412,4),(53319744,425455296,15091031,844916,1,'2009-01-27 19:52:23',3310502412,4),(53319747,425455970,15090330,844916,1,'2009-01-27 19:52:23',3310502412,5),(53319749,425454752,15088264,454632,1,'2007-09-17 21:17:27',3310502412,1),(53319750,425452802,15087357,454632,1,'2007-09-17 21:17:27',3310502412,1),(53319752,425450443,15087901,454632,1,'2007-09-17 21:17:28',3310502409,1),(53319753,425448312,15087765,454632,1,'2007-09-17 21:17:28',3310502409,1),(53319755,425445228,15086813,454632,1,'2007-09-17 21:17:29',3310502409,1),(53319756,425443640,15086677,454632,1,'2007-09-17 21:17:30',3310502409,1),(53319758,425440420,15088355,454632,1,'2007-09-17 21:17:30',3310502409,1),(53319759,425438062,15090622,454632,1,'2007-09-17 21:17:31',3310502409,1),(53319761,425434221,15093245,454632,1,'2007-09-17 21:17:31',3310502409,1),(53319765,425430491,15095679,454632,1,'2007-09-17 21:17:32',3310502409,1),(53319768,425427429,15096936,454632,1,'2007-09-17 21:17:32',3310502409,1),(53319770,425424366,15097996,454632,1,'2007-09-17 21:17:32',3310502408,1),(53319773,425422482,15097996,454632,1,'2007-09-17 21:17:32',3310502408,1),(53319774,425416750,15097751,454632,1,'2007-09-17 21:17:32',3310502408,1),(53319777,425415944,15096334,454632,1,'2007-09-17 21:17:33',3310502408,1),(53319778,425416694,15094556,454632,1,'2007-09-17 21:17:33',3310502408,1),(53319781,425417166,15093916,454632,1,'2007-09-17 21:17:33',3310502408,1),(53319782,425419723,15093305,454632,1,'2007-09-17 21:17:33',3310502408,1),(53319784,425421446,15093277,454632,1,'2007-09-17 21:17:33',3310502408,1),(53319786,425438027,15102334,454632,1,'2007-09-17 21:17:33',3310502409,1),(53319787,425436570,15100548,844916,1,'2009-01-27 19:52:23',3310502409,4),(53319789,425437228,15109475,454632,1,'2007-09-17 21:17:34',3310502411,1),(53319790,425439342,15106515,454632,1,'2007-09-17 21:17:34',3310502411,1),(53319793,425444463,15100830,454632,1,'2007-09-17 21:17:34',3310502409,1),(53319796,425447188,15098998,454632,1,'2007-09-17 21:17:34',3310502409,1),(53319797,425448739,15098716,454632,1,'2007-09-17 21:17:35',3310502409,1),(53319800,425449772,15099703,454632,1,'2007-09-17 21:17:35',3310502409,1),(53319801,425450148,15101394,454632,1,'2007-09-17 21:17:35',3310502409,1),(53319804,425449444,15103179,454632,1,'2007-09-17 21:17:35',3310502409,1),(53319806,425445779,15107737,454632,1,'2007-09-17 21:17:35',3310502411,1),(53319807,425442255,15112435,454632,1,'2007-09-17 21:17:35',3310502411,1),(53319809,425319389,15149734,454632,1,'2007-09-17 21:17:36',3310491483,1),(53319811,425317115,15150013,454632,1,'2007-09-17 21:17:36',3310491483,1),(53319813,425315630,15150199,454632,1,'2007-09-17 21:17:36',3310491483,1),(53319815,425314191,15151034,454632,1,'2007-09-17 21:17:36',3310491482,1),(53319816,425312705,15151684,454632,1,'2007-09-17 21:17:36',3310491482,1),(53319817,425311498,15151313,454632,1,'2007-09-17 21:17:37',3310491482,1),(53319818,425310849,15150013,454632,1,'2007-09-17 21:17:37',3310491482,1),(53319819,425310941,15148249,454632,1,'2007-09-17 21:17:37',3310491482,1),(53319820,425315537,15145650,454632,1,'2007-09-17 21:17:37',3310491483,1),(53319821,425317301,15144953,454632,1,'2007-09-17 21:17:37',3310491483,1),(53319822,425318739,15144814,454632,1,'2007-09-17 21:17:37',3310491483,1),(53319823,425319946,15145046,454632,1,'2007-09-17 21:17:37',3310491483,1),(53319826,425321060,15145742,454632,1,'2007-09-17 21:17:37',3310491483,1),(53319828,425322638,15143376,181856,1,'2009-04-04 22:09:19',3310491483,5),(53319829,425319852,15128638,181856,1,'2009-04-04 22:08:18',3310491483,5),(53319832,425319586,15131563,181856,1,'2009-04-04 22:08:18',3310491483,5),(53319833,425319719,15135817,181856,1,'2009-04-04 22:08:19',3310491483,5),(53319835,425320350,15138742,181856,1,'2009-04-04 22:09:19',3310491483,7),(53319838,425321242,15141244,181856,1,'2009-04-04 22:09:19',3310491483,5),(53319839,425326194,15145404,181856,1,'2009-04-04 22:09:19',3310491483,5),(53325641,425330135,15147493,181856,1,'2009-04-04 22:09:20',3310491483,5),(53325645,425334581,15150732,181856,1,'2009-04-04 22:09:20',3310491483,5),(53325649,425338900,15153908,181856,1,'2009-04-04 22:09:20',3310491483,5),(53325657,425342203,15155877,181856,1,'2009-04-04 22:09:20',3310491486,5),(53325659,425343283,15156893,181856,1,'2009-04-04 22:09:21',3310491486,5),(53325663,425343601,15157846,181856,1,'2009-04-04 22:09:21',3310491486,5),(53325664,425381525,15133789,104780,1,'2009-02-04 00:33:00',3310491487,2),(53325666,425378707,15144167,104780,1,'2009-02-04 00:33:00',3310491487,2),(53325669,425377449,15149147,104780,1,'2009-02-04 00:33:00',3310491487,2),(53325671,425376054,15150384,104780,1,'2009-02-04 00:33:00',3310491487,2),(53325672,425372865,15153652,104780,1,'2009-02-04 00:33:00',3310491487,2),(53325674,425366446,15164956,104780,1,'2009-02-04 00:33:00',3310491508,2),(53325677,425387276,15148156,104780,1,'2009-02-04 00:29:50',3310491487,2),(53325680,425383444,15150851,104780,1,'2009-02-04 00:29:51',3310491487,2),(53325681,425381759,15153251,104780,1,'2009-02-04 00:29:51',3310491487,2),(53325699,425380075,15156115,104780,1,'2009-02-04 00:29:51',3310491487,2),(53325706,425377548,15158515,104780,1,'2009-02-04 00:29:51',3310491487,2),(53325709,425400217,15129422,306164,1,'2008-05-01 18:30:33',3310502410,2),(53325711,425394235,15133655,454632,1,'2007-09-17 21:35:16',3310491487,1),(53325715,425387951,15137724,454632,1,'2007-09-17 21:35:17',3310491487,1),(53325718,425385118,15139372,454632,1,'2007-09-17 21:35:17',3310491487,1),(53325720,425384243,15140711,454632,1,'2007-09-17 21:35:17',3310491487,1),(53325722,425383419,15144935,454632,1,'2007-09-17 21:35:18',3310491487,1),(53325723,425382904,15146222,454632,1,'2007-09-17 21:35:18',3310491487,1),(53325724,425381873,15148283,454632,1,'2007-09-17 21:35:18',3310491487,1),(53325725,425379504,15151321,454632,1,'2007-09-17 21:35:19',3310491487,1),(53325726,425376414,15155699,454632,1,'2007-09-17 21:35:19',3310491487,1),(53325729,425373684,15158687,454632,1,'2007-09-17 21:35:19',3310491487,1),(53325732,425372609,15160973,454632,1,'2007-09-17 21:35:19',3310491487,1),(53325735,425401988,15132426,306164,1,'2008-05-01 18:30:58',3310502410,2),(53325736,425404265,15137318,306164,1,'2008-05-01 18:30:58',3310502410,2),(53325739,425404667,15139744,454632,1,'2007-09-17 21:35:20',3310502410,1),(53325742,425405340,15141266,306164,1,'2008-05-01 18:34:56',3310502410,2),(53325743,425406045,15142768,454632,1,'2007-09-17 21:35:21',3310502410,1),(53325746,425407237,15144270,306164,1,'2008-05-01 18:34:56',3310502410,2),(53325748,425422920,15116118,306164,1,'2008-05-01 18:29:59',3310502410,2),(53325750,425419821,15117835,306164,1,'2008-05-01 18:29:59',3310502410,2),(53325752,425417988,15118865,306164,1,'2008-05-01 18:29:59',3310502410,2),(53325792,425417229,15120066,306164,1,'2008-05-01 18:31:34',3310502410,3),(53325795,425417102,15121525,306164,1,'2008-05-01 18:31:34',3310502410,3),(53325798,425416027,15122384,306164,1,'2008-05-01 18:29:59',3310502410,3),(53325801,425414573,15122813,306164,1,'2008-05-01 18:29:59',3310502410,3),(53325802,425412992,15125388,306164,1,'2008-05-01 18:23:25',3310502410,2),(53325805,425410968,15127276,306164,1,'2008-05-01 18:25:57',3310502410,2),(53325807,425409071,15128392,306164,1,'2008-05-01 18:25:57',3310502410,2),(53325809,425406731,15129937,306164,1,'2008-05-01 18:31:34',3310502410,3),(53325813,425406162,15131653,306164,1,'2008-05-01 18:31:34',3310502410,3),(53325815,425406099,15134228,370566,1,'2008-05-09 01:42:33',3310502410,4),(53325817,425403190,15134228,306164,1,'2008-05-01 18:30:58',3310502410,3),(53325818,425414261,15133916,844916,1,'2009-01-27 19:52:23',3310502410,4),(53325820,425410146,15135258,306164,1,'2008-05-01 18:33:36',3310502410,2),(53325823,425425462,15110073,454632,1,'2007-09-17 21:35:32',3310502411,1),(53325827,425428724,15108079,454632,1,'2007-09-17 21:35:32',3310502411,1),(53325829,425430465,15106666,454632,1,'2007-09-17 21:35:32',3310502411,1),(53325840,425431806,15104780,454632,1,'2007-09-17 21:35:35',3310502409,1),(53325843,425433655,15103620,454632,1,'2007-09-17 21:35:35',3310502409,1),(53325846,425400505,15126786,454632,1,'2007-09-17 21:35:35',3310502410,1),(53325848,425401585,15124672,454632,1,'2007-09-17 21:35:35',3310502410,1),(53325850,425404834,15121611,306164,1,'2008-05-01 18:30:33',3310502410,2),(53325852,425407363,15119895,306164,1,'2008-05-01 18:30:33',3310502410,2),(53327620,425445466,15138893,787878,1,'2009-01-15 00:29:03',3310502411,2),(53327622,425447338,15137254,454632,1,'2007-09-17 21:41:21',3310502411,1),(53327626,425450966,15135558,844916,1,'2009-01-27 20:10:20',3310502411,3),(53327629,425498361,15157348,454632,1,'2007-09-17 21:41:22',3310502415,1),(53327630,425498991,15153971,454632,1,'2007-09-17 21:41:22',3310502415,1),(53327633,425499334,15152654,454632,1,'2007-09-17 21:41:22',3310502415,1),(53327636,425499334,15151566,454632,1,'2007-09-17 21:41:22',3310502415,1),(53327637,425498705,15150536,454632,1,'2007-09-17 21:41:22',3310502415,1),(53327639,425497961,15149448,454632,1,'2007-09-17 21:41:22',3310502415,1),(53327642,425497102,15148532,454632,1,'2007-09-17 21:41:22',3310502415,1),(53327646,425496472,15148475,454632,1,'2007-09-17 21:41:23',3310502415,1),(53327649,425496129,15149162,454632,1,'2007-09-17 21:41:23',3310502415,1),(53327652,425496358,15150708,454632,1,'2007-09-17 21:41:23',3310502415,1),(53327654,425496758,15152425,454632,1,'2007-09-17 21:41:23',3310502415,1),(53327657,425496873,15153169,454632,1,'2007-09-17 21:41:23',3310502415,1),(53327661,425496873,15153742,454632,1,'2007-09-17 21:41:23',3310502415,1),(53327664,425496472,15154142,454632,1,'2007-09-17 21:41:24',3310502415,1),(53327667,425495843,15154257,454632,1,'2007-09-17 21:41:24',3310502415,1),(53327669,425495385,15153971,454632,1,'2007-09-17 21:41:24',3310502415,1),(53327672,425494812,15152826,454632,1,'2007-09-17 21:41:24',3310502415,1),(53327675,425493209,15146758,454632,1,'2007-09-17 21:41:25',3310502415,1),(53327678,425492694,15146186,454632,1,'2007-09-17 21:41:25',3310502415,1),(53327682,425492122,15146357,454632,1,'2007-09-17 21:41:25',3310502415,1),(53327685,425492179,15146815,454632,1,'2007-09-17 21:41:25',3310502415,1),(53327686,425492236,15150078,454632,1,'2007-09-17 21:41:25',3310502415,1),(53327689,425492580,15153284,454632,1,'2007-09-17 21:41:25',3310502415,1),(53327693,425492637,15155001,454632,1,'2007-09-17 21:41:25',3310502415,1),(53327696,425492179,15155688,454632,1,'2007-09-17 21:41:25',3310502415,1),(53327697,425491492,15155631,454632,1,'2007-09-17 21:41:26',3310502415,1),(53327700,425490977,15155344,454632,1,'2007-09-17 21:41:26',3310502415,1),(53327703,425490576,15153856,454632,1,'2007-09-17 21:41:26',3310502415,1),(53327705,425489546,15149162,454632,1,'2007-09-17 21:41:26',3310502415,1),(53327706,425488973,15148532,454632,1,'2007-09-17 21:41:26',3310502415,1),(53327708,425488229,15149391,454632,1,'2007-09-17 21:41:27',3310502415,1),(53327710,425488057,15151395,454632,1,'2007-09-17 21:41:27',3310502415,1),(53327712,425487370,15154142,454632,1,'2007-09-17 21:41:27',3310502415,1),(53327716,425487142,15155402,454632,1,'2007-09-17 21:41:27',3310502415,1),(53327717,425486741,15156031,454632,1,'2007-09-17 21:41:27',3310502415,1),(53327720,425486054,15156203,454632,1,'2007-09-17 21:41:28',3310502415,1),(53327721,425485539,15155802,454632,1,'2007-09-17 21:41:28',3310502415,1),(53327724,425485481,15155058,454632,1,'2007-09-17 21:41:28',3310502415,1),(53327726,425487256,15144525,454632,1,'2007-09-17 21:41:28',3310502415,1),(53327728,425487142,15143438,454632,1,'2007-09-17 21:41:28',3310502415,1),(53327730,425486283,15142923,454632,1,'2007-09-17 21:41:28',3310502415,1),(53327733,425485596,15143266,454632,1,'2007-09-17 21:41:28',3310502415,1),(53327734,425485252,15144010,454632,1,'2007-09-17 21:41:28',3310502415,1),(53327735,425483535,15152196,454632,1,'2007-09-17 21:41:29',3310502415,1),(53327736,425482905,15154028,454632,1,'2007-09-17 21:41:29',3310502415,1),(53327737,425482161,15154600,454632,1,'2007-09-17 21:41:29',3310502415,1),(53327738,425481474,15154829,454632,1,'2007-09-17 21:41:29',3310502415,1),(53327739,425480158,15154486,454632,1,'2007-09-17 21:41:29',3310502415,1),(53327741,425479299,15154429,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327743,425478154,15154829,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327746,425477639,15154543,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327748,425477639,15153799,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327749,425478040,15153055,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327752,425479070,15152769,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327753,425480272,15151738,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327755,425480845,15150765,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327756,425481360,15149849,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327757,425481417,15148647,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327758,425480616,15148189,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327759,425480501,15148590,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327760,425480101,15149735,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327763,425479585,15150364,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327765,425478784,15150937,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327768,425477525,15150937,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327769,425477296,15150536,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327771,425477238,15149906,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327772,425477639,15149620,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327775,425478555,15148590,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327779,425478841,15148246,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327782,425479242,15147330,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327789,425479185,15145728,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327791,425479528,15143495,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327794,425479299,15142121,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327799,425479185,15139946,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327804,425479814,15138400,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327808,425481474,15134966,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327812,425482362,15131804,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327814,425480288,15126795,454632,1,'2007-09-17 21:41:38',3310502415,1),(53327815,425478237,15129268,454632,1,'2007-09-17 21:41:38',3310502414,1),(53327818,425481867,15125585,454632,1,'2007-09-17 21:41:38',3310502415,1),(53327821,425482919,15124007,454632,1,'2007-09-17 21:41:39',3310502415,1),(53327824,425483235,15122587,454632,1,'2007-09-17 21:41:39',3310502415,1),(53327826,425482445,15121692,454632,1,'2007-09-17 21:41:39',3310502415,1),(53327830,425481551,15121640,454632,1,'2007-09-17 21:41:39',3310502415,1),(53327833,425479026,15123376,454632,1,'2007-09-17 21:41:40',3310502414,1),(53327836,425476448,15124954,454632,1,'2007-09-17 21:41:40',3310502414,1),(53327838,425473344,15126427,454632,1,'2007-09-17 21:41:40',3310502414,1),(53327844,425470135,15127953,454632,1,'2007-09-17 21:41:41',3310502414,1),(53327851,425467136,15130005,454632,1,'2007-09-17 21:41:41',3310502414,1),(53327853,425463716,15131425,454632,1,'2007-09-17 21:41:42',3310502414,1),(53327855,425461243,15132214,454632,1,'2007-09-17 21:41:42',3310502414,1),(53327873,425460244,15133161,454632,1,'2007-09-17 21:41:44',3310502414,1),(53327875,425459034,15134792,454632,1,'2007-09-17 21:41:44',3310502414,1),(53327877,425457982,15134792,454632,1,'2007-09-17 21:41:44',3310502414,1),(53327879,425456929,15133214,454632,1,'2007-09-17 21:41:44',3310502414,1),(53327880,425457298,15131793,454632,1,'2007-09-17 21:41:44',3310502414,1),(53327882,425459297,15129426,454632,1,'2007-09-17 21:41:45',3310502414,1),(53330420,425436125,15153073,725665,1,'2009-03-02 22:10:40',3310502411,2),(53330432,425438028,15152887,725665,1,'2009-03-02 22:10:41',3310502411,2),(53330444,425440813,15150845,725665,1,'2009-03-02 22:10:41',3310502411,2),(53330446,425442206,15149266,725665,1,'2009-03-02 22:10:41',3310502411,2),(53330448,425442809,15146853,725665,1,'2009-03-02 22:10:41',3310502411,2),(53330450,425452747,15139835,454632,1,'2007-09-17 21:47:48',3310502414,1),(53330453,425454584,15144107,454632,1,'2007-09-17 21:47:48',3310502414,1),(53332056,425320561,15127157,181856,1,'2009-04-04 22:08:18',3310491483,5),(53332059,425321075,15124588,181856,1,'2009-04-04 22:08:17',3310491483,5),(53332062,425320635,15122900,181856,1,'2009-04-04 22:08:17',3310491483,5),(53332065,425318140,15120918,181856,1,'2009-04-04 22:08:16',3310491483,5),(53332068,425316231,15118496,181856,1,'2009-04-04 22:08:16',3310491483,5),(53332070,425314470,15114533,181856,1,'2009-04-04 22:08:15',3310491482,5),(53332072,425311975,15107634,181856,1,'2009-04-04 22:08:15',3310491482,5),(53332075,425311828,15105433,181856,1,'2009-04-04 22:08:15',3310491480,5),(53332078,425311828,15101763,181856,1,'2009-04-04 22:08:14',3310491480,5),(53332079,425311388,15098607,181856,1,'2009-04-04 22:25:06',3310491480,11),(53332081,425309846,15095598,181856,1,'2009-04-04 22:25:06',3310491480,7),(53332083,425309112,15093030,181856,1,'2009-04-04 22:25:06',3310491480,7),(53332086,425309479,15090314,181856,1,'2009-04-04 22:25:06',3310491480,7),(53332089,425310361,15087819,181856,1,'2009-04-04 22:25:05',3310491480,7),(53332091,425311059,15085126,181856,1,'2009-04-04 22:25:05',3310491480,7),(53332094,425311558,15083430,181856,1,'2009-04-04 22:25:05',3310491480,7),(53332097,425311359,15081884,181856,1,'2009-04-04 22:25:05',3310491480,7),(53332100,425310012,15080139,181856,1,'2009-04-04 22:25:05',3310491480,7),(53332102,425309015,15078194,181856,1,'2009-04-04 22:25:05',3310491480,7),(53332105,425308865,15076449,181856,1,'2009-04-04 22:25:05',3310491480,7),(53332107,425308766,15073756,181856,1,'2009-04-04 22:25:05',3310491480,7),(53332109,425309065,15071811,181856,1,'2009-04-04 22:25:05',3310491480,7),(53332111,425310012,15069019,181856,1,'2009-04-04 22:25:05',3310491480,7),(53332113,425311758,15065777,181856,1,'2009-04-04 22:25:05',3310491480,7),(53332117,425312828,15063919,181856,1,'2009-04-04 22:25:05',3310491480,8),(53332120,425313049,15062173,181856,1,'2009-04-04 22:25:04',3310491480,8),(53332123,425313216,15060190,181856,1,'2009-04-04 22:25:04',3310491480,8),(53334410,425476417,15203842,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334413,425476150,15207044,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334414,425475616,15208538,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334417,425474656,15208912,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334419,425473695,15208698,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334421,425473161,15207311,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334422,425472201,15204696,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334423,425471560,15200639,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334424,425471827,15195142,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334427,425471774,15192527,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334428,425470920,15191140,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334431,425469746,15190659,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334432,425468785,15191140,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334433,425467984,15192527,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334437,425467611,15194449,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334441,425468038,15198398,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334442,425469159,15203094,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334444,425469319,15206777,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334448,425470600,15210886,498434,1,'2008-05-22 19:58:22',3310502436,2),(53335700,425186391,15656546,708302,1,'2008-01-29 23:52:04',3310491618,2),(53335702,425179661,15663348,454632,1,'2007-09-17 21:59:06',3310491618,1),(53335703,425181737,15667500,454632,1,'2007-09-17 21:59:06',3310491618,1),(53335707,425182310,15669004,454632,1,'2007-09-17 21:59:06',3310491618,1),(53335710,425182167,15672655,454632,1,'2007-09-17 21:59:06',3310491618,1),(53335714,425183098,15675662,454632,1,'2007-09-17 21:59:07',3310491618,1),(53335715,425189971,15687189,454632,1,'2007-09-17 21:59:07',3310491618,1),(53335717,425196844,15697355,454632,1,'2007-09-17 21:59:07',3310491618,1),(53335718,425199421,15700648,454632,1,'2007-09-17 21:59:07',3310491618,1),(53335719,425203717,15703798,454632,1,'2007-09-17 21:59:07',3310491618,1),(53335720,425208155,15706018,454632,1,'2007-09-17 21:59:08',3310491619,1),(53335721,425210948,15707235,454632,1,'2007-09-17 21:59:08',3310491619,1),(53335722,425212594,15707736,454632,1,'2007-09-17 21:59:08',3310491619,1),(53335723,425214384,15707664,454632,1,'2007-09-17 21:59:08',3310491619,1),(53335724,425214957,15706948,454632,1,'2007-09-17 21:59:08',3310491619,1),(53335727,425215243,15705373,454632,1,'2007-09-17 21:59:08',3310491619,1),(53335730,425214599,15703011,454632,1,'2007-09-17 21:59:08',3310491619,1),(53335733,425214456,15701293,454632,1,'2007-09-17 21:59:09',3310491619,1),(53335738,425214241,15699145,454632,1,'2007-09-17 21:59:09',3310491619,1),(53335740,425213811,15697283,454632,1,'2007-09-17 21:59:09',3310491619,1),(53335742,425212308,15695493,454632,1,'2007-09-17 21:59:09',3310491619,1),(53335743,425210733,15694563,454632,1,'2007-09-17 21:59:10',3310491619,1),(53335744,425209802,15693202,454632,1,'2007-09-17 21:59:10',3310491619,1),(53335745,425208370,15691985,454632,1,'2007-09-17 21:59:10',3310491619,1),(53335746,425207082,15689766,454632,1,'2007-09-17 21:59:10',3310491619,1),(53335747,425206079,15687189,454632,1,'2007-09-17 21:59:10',3310491619,1),(53335750,425205363,15684038,454632,1,'2007-09-17 21:59:10',3310491619,1),(53335752,425203573,15681389,454632,1,'2007-09-17 21:59:11',3310491618,1),(53335755,425202500,15679743,454632,1,'2007-09-17 21:59:11',3310491618,1),(53335756,425202213,15677810,454632,1,'2007-09-17 21:59:11',3310491618,1),(53335759,425200996,15675948,454632,1,'2007-09-17 21:59:11',3310491618,1),(53335762,425200065,15675447,454632,1,'2007-09-17 21:59:11',3310491618,1),(53335764,425198705,15673013,454632,1,'2007-09-17 21:59:11',3310491618,1),(53335766,425197416,15670078,454632,1,'2007-09-17 21:59:12',3310491618,1),(53335768,425196342,15667787,454632,1,'2007-09-17 21:59:12',3310491618,1),(53335771,425194911,15666283,454632,1,'2007-09-17 21:59:12',3310491618,1),(53335776,425193622,15664780,454632,1,'2007-09-17 21:59:13',3310491618,1),(53335779,425191044,15662990,454632,1,'2007-09-17 21:59:13',3310491618,1),(53335782,425187536,15660627,454632,1,'2007-09-17 21:59:13',3310491618,1),(53335783,425186534,15658408,454632,1,'2007-09-17 21:59:13',3310491618,1),(53343318,425153486,15545410,454632,1,'2007-09-17 22:24:37',3310491549,1),(53343339,425154776,15553171,454632,1,'2007-09-17 22:24:42',3310491551,1),(53343344,425158165,15557727,454632,1,'2007-09-17 22:24:42',3310491551,1),(53343348,425163077,15564407,454632,1,'2007-09-17 22:24:43',3310491551,1),(53343353,425167203,15564211,454632,1,'2007-09-17 22:24:43',3310491551,1),(53343358,425171722,15567354,454632,1,'2007-09-17 22:24:44',3310491551,1),(53343364,425175455,15570891,454632,1,'2007-09-17 22:24:44',3310491551,1),(53343367,425179777,15570694,454632,1,'2007-09-17 22:24:45',3310491594,1),(53343377,425179384,15563818,454632,1,'2007-09-17 22:24:47',3310491594,1),(53343553,425178795,15560478,454632,1,'2007-09-17 22:25:27',3310491594,1),(53344982,425180956,15560281,454632,1,'2007-09-17 22:31:12',3310491594,1),(53350051,425192155,15571480,454632,1,'2007-09-17 22:51:44',3310491594,1),(53351880,425198050,15576392,454632,1,'2007-09-17 22:57:04',3310491594,1),(53352405,425203748,15579929,454632,1,'2007-09-17 22:58:37',3310491594,1),(53352410,425208856,15586216,454632,1,'2007-09-17 22:58:38',3310491595,1),(53352414,425213178,15592110,454632,1,'2007-09-17 22:58:38',3310491595,1),(53352419,425218287,15597022,454632,1,'2007-09-17 22:58:39',3310491595,1),(53352422,425220252,15603113,454632,1,'2007-09-17 22:58:39',3310491617,1),(53352426,425232237,15619224,454632,1,'2007-09-17 22:58:40',3310491617,1),(53352429,425237738,15622368,454632,1,'2007-09-17 22:58:40',3310491620,1),(53352435,425242060,15625511,454632,1,'2007-09-17 22:58:41',3310491620,1),(53352441,425244615,15630030,363778,1,'2007-12-19 18:35:48',3310491620,3),(53352444,425245990,15636711,454632,1,'2007-09-17 22:58:42',3310491620,1),(53352447,425247562,15641426,454632,1,'2007-09-17 22:58:42',3310491620,1),(53352452,425249723,15644766,454632,1,'2007-09-17 22:58:42',3310491620,1),(53352461,425252081,15650857,454632,1,'2007-09-17 22:58:44',3310491620,1),(53352483,425254078,15660320,454632,1,'2007-09-17 22:58:47',3310491622,1),(53352488,425259547,15665593,454632,1,'2007-09-17 22:58:48',3310491622,1),(53352494,425266234,15674158,188228,1,'2008-06-16 19:34:38',3310491623,2),(53352499,425270535,15680596,188228,1,'2008-06-16 19:35:14',3310491623,2),(53352505,425271925,15687205,454632,1,'2007-09-17 22:58:50',3310491623,1),(53352508,425278315,15693899,188228,1,'2008-06-16 19:35:37',3310491623,2),(53352511,425282174,15693899,188228,1,'2008-06-16 19:38:10',3310491623,2),(53352516,425277623,15697029,454632,1,'2007-09-17 22:58:52',3310491623,1),(53352521,425272907,15697225,454632,1,'2007-09-17 22:58:53',3310491623,1),(53352527,425273693,15702923,454632,1,'2007-09-17 22:58:54',3310491623,1),(53352530,425277819,15709014,454632,1,'2007-09-17 22:58:54',3310491623,1),(53352537,425283320,15712943,454632,1,'2007-09-17 22:58:55',3310491629,1),(53352541,425287643,15713533,454632,1,'2007-09-17 22:58:55',3310491640,1),(53352546,425290787,15721785,454632,1,'2007-09-17 22:58:56',3310491640,1),(53352552,425293537,15730233,454632,1,'2007-09-17 22:58:57',3310491640,1),(53352557,425298253,15735735,454632,1,'2007-09-17 22:58:58',3310491640,1),(53352561,425301593,15743004,454632,1,'2007-09-17 22:58:58',3310491640,1),(53352568,425295895,15745951,454632,1,'2007-09-17 22:58:58',3310491640,1),(53352574,425300217,15758722,454632,1,'2007-09-17 22:58:59',3310491640,1),(53352578,425298646,15765795,454632,1,'2007-09-17 22:59:00',3310491642,1),(53352584,425299039,15772869,454632,1,'2007-09-17 22:59:00',3310491642,1),(53352587,425303754,15773065,454632,1,'2007-09-17 22:59:01',3310491642,1),(53352594,425306898,15784068,454632,1,'2007-09-17 22:59:01',3310491642,1),(53352599,425307684,15793106,454632,1,'2007-09-17 22:59:02',3310491642,1),(53352605,425308862,15801554,454632,1,'2007-09-17 22:59:03',3310491642,1),(53352619,425312202,15803912,454632,1,'2007-09-17 22:59:05',3310491642,1),(53352632,425314364,15816486,454632,1,'2007-09-17 22:59:07',3310491642,1),(53352636,425316527,15833582,454632,1,'2007-09-17 22:59:07',3310493009,1),(53352638,425317192,15845098,363778,1,'2007-12-19 18:35:38',3310493009,2),(53352642,425316749,15858164,454632,1,'2007-09-17 22:59:08',3310493009,1),(53352645,425315198,15873445,454632,1,'2007-09-17 22:59:08',3310493009,1),(53352648,425312762,15888062,454632,1,'2007-09-17 22:59:08',3310493010,1),(53352650,425310105,15918181,454632,1,'2007-09-17 22:59:08',3310493010,1),(53352704,425313205,15924825,454632,1,'2007-09-17 22:59:15',3310493010,1),(53352708,425325607,15931026,454632,1,'2007-09-17 22:59:15',3310493017,1),(53352723,425328929,15942763,454632,1,'2007-09-17 22:59:17',3310493017,1),(53352737,425311876,15973989,454632,1,'2007-09-17 22:59:19',3310493016,1),(53352766,425306561,15983291,454632,1,'2007-09-17 22:59:22',3310493016,1),(53352774,425299566,15998522,454632,1,'2007-09-17 22:59:23',3310493018,1),(53352779,425304116,16010548,454632,1,'2007-09-17 22:59:24',3310493018,1),(53352796,425309967,16025825,454632,1,'2007-09-17 22:59:26',3310493018,1),(53352802,425309967,16052477,454632,1,'2007-09-17 22:59:27',3310493040,1),(53352807,425303141,16068729,454632,1,'2007-09-17 22:59:27',3310493040,1),(53352812,425293065,16070679,454632,1,'2007-09-17 22:59:27',3310493040,1),(53352849,425286239,16084006,454632,1,'2007-09-17 22:59:32',3310493029,1),(53352853,425275513,16090506,454632,1,'2007-09-17 22:59:32',3310493029,1),(53352860,425274863,16113259,454632,1,'2007-09-17 22:59:33',3310493031,1),(53352863,425281364,16111309,454632,1,'2007-09-17 22:59:34',3310493031,1),(53352868,425288515,16098957,454632,1,'2007-09-17 22:59:34',3310493042,1),(53352871,425295015,16095382,454632,1,'2007-09-17 22:59:34',3310493042,1),(53352873,425305416,16098632,454632,1,'2007-09-17 22:59:35',3310493042,1),(53352876,425310617,16100582,454632,1,'2007-09-17 22:59:35',3310493042,1),(53352878,425311592,16118459,454632,1,'2007-09-17 22:59:35',3310493042,1),(53352883,425315817,16118784,454632,1,'2007-09-17 22:59:36',3310493043,1),(53352887,425315817,16097332,454632,1,'2007-09-17 22:59:36',3310493043,1),(53352890,425333369,16074255,454632,1,'2007-09-17 22:59:36',3310493041,1),(53352894,425337595,16080430,454632,1,'2007-09-17 22:59:37',3310493041,1),(53352896,425340520,16100582,454632,1,'2007-09-17 22:59:37',3310493043,1),(53352899,425339545,16141212,454632,1,'2007-09-17 22:59:38',3310493043,1),(53352904,425344745,16178591,454632,1,'2007-09-17 22:59:39',3310493052,1),(53352906,425345071,16191917,454632,1,'2007-09-17 22:59:39',3310493052,1),(53352907,425346221,16219056,454632,1,'2007-09-17 22:59:39',3310493054,1),(53352912,425345061,16232970,454632,1,'2007-09-17 22:59:40',3310493054,1),(53352934,425348540,16263117,454632,1,'2007-09-17 22:59:44',3310493140,1),(53352938,425353094,16286460,454632,1,'2007-09-17 22:59:44',3310493140,1),(53352942,425351907,16295721,454632,1,'2007-09-17 22:59:45',3310493140,1),(53352946,425350720,16331103,454632,1,'2007-09-17 22:59:45',3310493142,1),(53352948,425341459,16333240,454632,1,'2007-09-17 22:59:45',3310493139,1),(53352951,425329585,16340364,454632,1,'2007-09-17 22:59:46',3310493139,1),(53352954,425313913,16362685,454632,1,'2007-09-17 22:59:46',3310493138,1),(53352957,425299903,16351999,454632,1,'2007-09-17 22:59:46',3310493138,1),(53352960,425288505,16329678,454632,1,'2007-09-17 22:59:46',3310493138,1),(53352963,425265708,16313531,454632,1,'2007-09-17 22:59:46',3310493125,1),(53352966,425246413,16309632,454632,1,'2007-09-17 22:59:47',3310493124,1),(53352969,425227322,16356241,454632,1,'2007-09-17 22:59:47',3310493123,1),(53352974,425218437,16375849,454632,1,'2007-09-17 22:59:47',3310493129,1),(53352975,425208326,16360530,454632,1,'2007-09-17 22:59:47',3310493123,1),(53353016,425176769,16367271,454632,1,'2007-09-17 22:59:54',3310493079,1),(53353021,425160837,16352871,454632,1,'2007-09-17 22:59:55',3310493079,1),(53353024,425151645,16311815,454632,1,'2007-09-17 22:59:55',3310493077,1),(53353034,425158999,16269841,454632,1,'2007-09-17 22:59:56',3310493077,1),(53353040,425161143,16206114,454632,1,'2007-09-17 22:59:56',3310492991,1),(53353043,425156241,16167509,454632,1,'2007-09-17 22:59:57',3310492989,1),(53353047,425130811,16121859,454632,1,'2007-09-17 22:59:57',3310492982,1),(53353051,425121926,16089382,454632,1,'2007-09-17 22:59:57',3310492977,1),(53353055,425110590,16051084,454632,1,'2007-09-17 22:59:58',3310492977,1),(53353086,425098578,16003700,454632,1,'2007-09-17 23:00:02',3310492955,1),(53353092,425102160,15976523,454632,1,'2007-09-17 23:00:02',3310492953,1),(53353108,425098207,15948852,454632,1,'2007-09-17 23:00:05',3310492953,1),(53353111,425108090,15923651,454632,1,'2007-09-17 23:00:05',3310492947,1),(53353121,425117478,15918710,454632,1,'2007-09-17 23:00:06',3310492947,1),(53353126,425122914,15890544,454632,1,'2007-09-17 23:00:06',3310492950,1),(53353132,425130326,15872261,454632,1,'2007-09-17 23:00:07',3310492948,1),(53353137,425130326,15856943,363778,1,'2007-12-19 18:35:48',3310492948,2),(53353141,425125384,15839648,454632,1,'2007-09-17 23:00:07',3310492948,1),(53353144,425092772,15840142,454632,1,'2007-09-17 23:00:07',3310492944,1),(53353148,425078936,15861884,454632,1,'2007-09-17 23:00:08',3310492944,1),(53353151,425068559,15866331,454632,1,'2007-09-17 23:00:08',3310492944,1),(53353155,425054723,15848543,454632,1,'2007-09-17 23:00:09',3310492933,1),(53353160,425043852,15832236,454632,1,'2007-09-17 23:00:09',3310492933,1),(53353163,425036440,15770470,454632,1,'2007-09-17 23:00:09',3310491566,1),(53353167,425031993,15763058,454632,1,'2007-09-17 23:00:10',3310491564,1),(53353170,425016675,15760587,454632,1,'2007-09-17 23:00:10',3310491564,1),(53353174,424996416,15758116,454632,1,'2007-09-17 23:00:10',3310491561,1),(53353179,424984062,15750704,454632,1,'2007-09-17 23:00:11',3310491560,1),(53353181,424965779,15741316,454632,1,'2007-09-17 23:00:11',3310491560,1),(53353183,424971709,15704256,454632,1,'2007-09-17 23:00:11',3310491554,1),(53353186,424979121,15670161,454632,1,'2007-09-17 23:00:11',3310491554,1),(53353189,424984062,15621241,454632,1,'2007-09-17 23:00:13',3310491552,1),(53353193,424991474,15565899,454632,1,'2007-09-17 23:00:13',3310491531,1),(53353198,425016675,15543663,454632,1,'2007-09-17 23:00:13',3310491532,1),(53353199,425033970,15532792,454632,1,'2007-09-17 23:00:14',3310491532,1),(53353203,425044346,15528839,454632,1,'2007-09-17 23:00:14',3310491533,1),(53353205,425062629,15523403,454632,1,'2007-09-17 23:00:15',3310491533,1),(53353208,425075477,15520438,454632,1,'2007-09-17 23:00:15',3310491544,1),(53353211,425077453,15526368,454632,1,'2007-09-17 23:00:15',3310491544,1),(53353223,425087830,15541686,363778,1,'2007-12-19 18:35:48',3310491544,3),(53353237,425092277,15556016,454632,1,'2007-09-17 23:00:18',3310491546,1),(53353302,425092277,15568369,454632,1,'2007-09-17 23:00:25',3310491546,1),(53353307,425086348,15580723,454632,1,'2007-09-17 23:00:25',3310491546,1),(53353314,425077948,15595052,454632,1,'2007-09-17 23:00:26',3310491546,1),(53353319,425063124,15610865,454632,1,'2007-09-17 23:00:26',3310491557,1),(53353324,425067571,15621241,454632,1,'2007-09-17 23:00:27',3310491568,1),(53353328,425085360,15621241,454632,1,'2007-09-17 23:00:27',3310491568,1),(53353333,425087336,15646442,454632,1,'2007-09-17 23:00:27',3310491568,1),(53353340,425094748,15666702,454632,1,'2007-09-17 23:00:28',3310491570,1),(53353343,425109078,15665713,454632,1,'2007-09-17 23:00:28',3310491571,1),(53353345,425114513,15654348,454632,1,'2007-09-17 23:00:29',3310491569,1),(53353350,425128843,15655831,454632,1,'2007-09-17 23:00:29',3310491574,1),(53353359,425135267,15653360,454632,1,'2007-09-17 23:00:30',3310491572,1),(53353366,425125878,15637054,454632,1,'2007-09-17 23:00:30',3310491572,1),(53353369,425131314,15632607,454632,1,'2007-09-17 23:00:30',3310491572,1),(53353372,425136255,15627171,454632,1,'2007-09-17 23:00:31',3310491572,1),(53353375,425126373,15602959,454632,1,'2007-09-17 23:00:31',3310491572,1),(53353383,425121925,15601970,454632,1,'2007-09-17 23:00:31',3310491569,1),(53353388,425124396,15582699,454632,1,'2007-09-17 23:00:31',3310491550,1),(53353391,425116490,15577264,454632,1,'2007-09-17 23:00:31',3310491547,1),(53353393,425103325,15559987,454632,1,'2007-09-17 23:00:32',3310491547,1),(53353395,425102516,15544403,454632,1,'2007-09-17 23:00:32',3310491545,1),(53353404,425102516,15528818,454632,1,'2007-09-17 23:00:33',3310491545,1),(53353407,425105957,15515257,454632,1,'2007-09-17 23:00:33',3310491545,1),(53353413,425112231,15507769,454632,1,'2007-09-17 23:00:34',3310491545,1),(53353421,425120529,15506352,454632,1,'2007-09-17 23:00:34',3310491545,1),(53353427,425127411,15515865,454632,1,'2007-09-17 23:00:35',3310491548,1),(53353431,425131256,15523961,454632,1,'2007-09-17 23:00:35',3310491548,1),(53353435,425137530,15532259,454632,1,'2007-09-17 23:00:35',3310491548,1),(53368899,425435824,14735647,454632,1,'2007-09-17 23:47:00',3310502049,1),(53368914,425444025,14750192,454632,1,'2007-09-17 23:47:02',3310502049,1),(53368932,425446448,14754531,454632,1,'2007-09-17 23:47:05',3310502049,1),(53368942,425437504,14756563,454632,1,'2007-09-17 23:47:06',3310502049,1),(53368953,425437462,14751597,454632,1,'2007-09-17 23:47:08',3310502049,1),(53368973,425417580,14712082,538211,1,'2007-09-30 15:36:23',3310502026,1),(53368998,425421094,14712082,454632,1,'2007-09-17 23:47:14',3310502026,1),(53369007,425422832,14712203,454632,1,'2007-09-17 23:47:15',3310502026,1),(53369015,425424286,14712970,454632,1,'2007-09-17 23:47:16',3310502026,1),(53369038,425425255,14714101,454632,1,'2007-09-17 23:47:21',3310502027,1),(53370808,425425942,14715596,454632,1,'2007-09-17 23:53:19',3310502027,1),(53370819,425426871,14716727,454632,1,'2007-09-17 23:53:20',3310502027,1),(53370838,425428730,14717980,454632,1,'2007-09-17 23:53:23',3310502027,1),(53370844,425430507,14719636,454632,1,'2007-09-17 23:53:24',3310502027,1),(53370871,425431800,14720888,454632,1,'2007-09-17 23:53:29',3310502027,1),(53370880,425432204,14721696,454632,1,'2007-09-17 23:53:32',3310502027,1),(53370887,425432163,14722585,454632,1,'2007-09-17 23:53:33',3310502049,1),(53370890,425431881,14723191,454632,1,'2007-09-17 23:53:34',3310502049,1),(53370895,425431194,14723514,454632,1,'2007-09-17 23:53:35',3310502049,1),(53370900,425430103,14723635,454632,1,'2007-09-17 23:53:36',3310502049,1),(53370906,425429255,14723555,454632,1,'2007-09-17 23:53:37',3310502049,1),(53370914,425428770,14724080,454632,1,'2007-09-17 23:53:38',3310502049,1),(53370920,425428730,14725251,454632,1,'2007-09-17 23:53:38',3310502049,1),(53370935,425429134,14726423,454632,1,'2007-09-17 23:53:44',3310502049,1),(53370942,425430386,14727110,454632,1,'2007-09-17 23:53:46',3310502049,1),(53370949,425432083,14727514,454632,1,'2007-09-17 23:53:48',3310502049,1),(53370956,425434628,14728200,454632,1,'2007-09-17 23:53:49',3310502049,1),(53370959,425435638,14728766,454632,1,'2007-09-17 23:53:50',3310502049,1),(53371037,425437254,14730139,454632,1,'2007-09-17 23:54:06',3310502049,1),(53371050,425438587,14731876,454632,1,'2007-09-17 23:54:08',3310502049,1),(53371067,425440930,14737007,454632,1,'2007-09-17 23:54:11',3310502049,1),(53371073,425443192,14741047,454632,1,'2007-09-17 23:54:12',3310502049,1),(53371079,425445091,14744521,454632,1,'2007-09-17 23:54:12',3310502049,1),(53371084,425445899,14746258,454632,1,'2007-09-17 23:54:13',3310502049,1),(53371089,425446262,14746824,454632,1,'2007-09-17 23:54:13',3310502049,1),(53371093,425446747,14746904,454632,1,'2007-09-17 23:54:14',3310502049,1),(53371101,425447232,14746662,454632,1,'2007-09-17 23:54:15',3310502049,1),(53371106,425447515,14745733,454632,1,'2007-09-17 23:54:16',3310502049,1),(53371115,425447515,14744521,454632,1,'2007-09-17 23:54:18',3310502049,1),(53371121,425447757,14743349,454632,1,'2007-09-17 23:54:19',3310502049,1),(53371129,425448220,14742921,454632,1,'2007-09-17 23:54:20',3310502049,1),(53371134,425416509,14695680,454632,1,'2007-09-17 23:54:21',3310502026,1),(53371138,425415521,14694857,454632,1,'2007-09-17 23:54:21',3310502026,1),(53371141,425413998,14694527,454632,1,'2007-09-17 23:54:22',3310502026,1),(53371144,425412762,14695227,454632,1,'2007-09-17 23:54:23',3310502026,1),(53371154,425411815,14696956,454632,1,'2007-09-17 23:54:25',3310502026,1),(53371160,425411074,14699880,454632,1,'2007-09-17 23:54:26',3310502026,1),(53371174,425410498,14702103,454632,1,'2007-09-17 23:54:28',3310502026,1),(53371181,425409963,14703297,454632,1,'2007-09-17 23:54:29',3310502026,1),(53371551,425408398,14704450,454632,1,'2007-09-17 23:55:56',3310502026,1),(53371691,425406463,14705150,454632,1,'2007-09-17 23:56:31',3310502026,1),(53371748,425404939,14705356,454632,1,'2007-09-17 23:56:40',3310502026,1),(53371756,425401192,14706509,454632,1,'2007-09-17 23:56:42',3310502026,1),(53371761,425400451,14707209,454632,1,'2007-09-17 23:56:42',3310502026,1),(53371763,425400081,14708856,454632,1,'2007-09-17 23:56:43',3310502026,1),(53371771,425400369,14710667,454632,1,'2007-09-17 23:56:44',3310502026,1),(53371778,425401069,14712397,454632,1,'2007-09-17 23:56:45',3310502026,1),(53371784,425403499,14715348,454632,1,'2007-09-17 23:56:45',3310502026,1),(53371787,425406279,14718810,454632,1,'2007-09-17 23:56:46',3310502026,1),(53371793,425408745,14723216,454632,1,'2007-09-17 23:56:47',3310502048,1),(53371799,425410948,14728620,454632,1,'2007-09-17 23:56:48',3310502048,1),(53371804,425392903,14703912,454632,1,'2007-09-17 23:56:49',3310491103,1),(53371810,425392064,14703965,454632,1,'2007-09-17 23:56:50',3310491103,1),(53371816,425392064,14704962,454632,1,'2007-09-17 23:56:50',3310491103,1),(53371823,425392168,14706483,454632,1,'2007-09-17 23:56:51',3310491103,1),(53371827,425393218,14707165,454632,1,'2007-09-17 23:56:52',3310491103,1),(53371833,425394791,14707532,454632,1,'2007-09-17 23:56:52',3310491103,1),(53371840,425396994,14707479,454632,1,'2007-09-17 23:56:53',3310491103,1),(53371845,425398883,14707060,454632,1,'2007-09-17 23:56:54',3310502026,1),(53371850,425400562,14705591,454632,1,'2007-09-17 23:56:54',3310502026,1),(53371856,425401663,14705591,454632,1,'2007-09-17 23:56:55',3310502026,1),(53371859,425403079,14705591,454632,1,'2007-09-17 23:56:56',3310502026,1),(53371862,425412944,14733781,454632,1,'2007-09-17 23:56:56',3310502048,1),(53371868,425414557,14740102,454632,1,'2007-09-17 23:56:57',3310502048,1),(53371873,425415211,14745857,454632,1,'2007-09-17 23:56:58',3310502048,1),(53371881,425415036,14751219,454632,1,'2007-09-17 23:56:59',3310502048,1),(53371890,425414739,14753687,454632,1,'2007-09-17 23:57:00',3310502048,1),(53371908,425414045,14756811,454632,1,'2007-09-17 23:57:05',3310502048,1),(53371942,425412483,14760543,454632,1,'2007-09-17 23:57:12',3310502048,1),(53371951,425409272,14766097,454632,1,'2007-09-17 23:57:14',3310502048,1),(53371955,425406235,14771227,454632,1,'2007-09-17 23:57:14',3310502048,1),(53371958,425403791,14775715,454632,1,'2007-09-17 23:57:15',3310502048,1),(53371963,425402902,14777048,454632,1,'2007-09-17 23:57:15',3310502050,1),(53371969,425401925,14778203,454632,1,'2007-09-17 23:57:16',3310502050,1),(53371993,425400414,14778869,454632,1,'2007-09-17 23:57:20',3310502050,1),(53371998,425397748,14778780,454632,1,'2007-09-17 23:57:20',3310502050,1),(53372005,425395527,14779002,454632,1,'2007-09-17 23:57:21',3310491127,1),(53372015,425393616,14780202,454632,1,'2007-09-17 23:57:22',3310491127,1),(53372021,425391617,14782557,454632,1,'2007-09-17 23:57:23',3310491127,1),(53372044,425390239,14784023,454632,1,'2007-09-17 23:57:26',3310491127,1),(53372056,425389040,14784556,454632,1,'2007-09-17 23:57:28',3310491127,1),(53372063,425386818,14784423,454632,1,'2007-09-17 23:57:29',3310491127,1),(53372072,425384997,14784423,454632,1,'2007-09-17 23:57:31',3310491127,1),(53372078,425383308,14785178,454632,1,'2007-09-17 23:57:32',3310491127,1),(53372086,425381309,14787844,454632,1,'2007-09-17 23:57:33',3310491127,1),(53372094,425379823,14790608,454632,1,'2007-09-17 23:57:34',3310491127,1),(53372108,425377525,14794423,454632,1,'2007-09-17 23:57:35',3310491127,1),(53372121,425375617,14797284,454632,1,'2007-09-17 23:57:36',3310491127,1),(53372132,425373927,14800189,454632,1,'2007-09-17 23:57:38',3310491127,1),(53372138,425372713,14803224,454632,1,'2007-09-17 23:57:39',3310491127,1),(53372143,425370979,14810204,454632,1,'2007-09-17 23:57:39',3310491127,1),(53372151,425370328,14814279,454632,1,'2007-09-17 23:57:40',3310491127,1),(53372163,425370849,14818918,454632,1,'2007-09-17 23:57:42',3310491127,1),(53372180,425372323,14823427,454632,1,'2007-09-17 23:57:45',3310491127,1),(53372190,425372496,14824164,454632,1,'2007-09-17 23:57:46',3310491127,1),(53372197,425372106,14825378,454632,1,'2007-09-17 23:57:47',3310491127,1),(53372208,425370458,14825248,454632,1,'2007-09-17 23:57:48',3310491127,1),(53372217,425369938,14823991,454632,1,'2007-09-17 23:57:49',3310491127,1),(53372225,425369201,14821129,454632,1,'2007-09-17 23:57:50',3310491126,1),(53372232,425368161,14816057,454632,1,'2007-09-17 23:57:51',3310491126,1),(53372242,425367510,14807343,454632,1,'2007-09-17 23:57:52',3310491126,1),(53372246,425366990,14801316,454632,1,'2007-09-17 23:57:52',3310491126,1),(53372255,425367857,14794076,454632,1,'2007-09-17 23:57:53',3310491126,1),(53372261,425369461,14785839,454632,1,'2007-09-17 23:57:54',3310491126,1),(53372271,425370198,14779162,454632,1,'2007-09-17 23:57:55',3310491127,1),(53372278,425371586,14775000,454632,1,'2007-09-17 23:57:55',3310491125,1),(53372284,425373710,14771272,454632,1,'2007-09-17 23:57:56',3310491125,1),(53372290,425376831,14767890,454632,1,'2007-09-17 23:57:56',3310491125,1),(53372297,425379910,14765809,454632,1,'2007-09-17 23:57:58',3310491125,1),(53372305,425382889,14765031,454632,1,'2007-09-17 23:57:58',3310491125,1),(53372352,425385356,14764777,454632,1,'2007-09-17 23:58:04',3310491125,1),(53372357,425387478,14764132,454632,1,'2007-09-17 23:58:05',3310491125,1),(53372365,425389807,14763094,454632,1,'2007-09-17 23:58:06',3310491125,1),(53372381,425391859,14761734,454632,1,'2007-09-17 23:58:08',3310491125,1),(53372404,425393634,14759497,454632,1,'2007-09-17 23:58:11',3310491125,1),(53372410,425394534,14756914,454632,1,'2007-09-17 23:58:12',3310491125,1),(53372412,425394718,14753179,454632,1,'2007-09-17 23:58:12',3310491125,1),(53372413,425394026,14750620,454632,1,'2007-09-17 23:58:13',3310491125,1),(53372418,425393035,14748198,454632,1,'2007-09-17 23:58:13',3310491125,1),(53372422,425391190,14746238,454632,1,'2007-09-17 23:58:13',3310491125,1),(53372427,425386602,14742641,454632,1,'2007-09-17 23:58:14',3310491125,1),(53372432,425379419,14737400,454632,1,'2007-09-17 23:58:15',3310491125,1),(53372437,425374912,14733866,454632,1,'2007-09-17 23:58:15',3310491125,1),(53372442,425370038,14729115,454632,1,'2007-09-17 23:58:15',3310491125,1),(53372446,425365937,14725663,454632,1,'2007-09-17 23:58:15',3310491124,1),(53372456,425362647,14723348,454632,1,'2007-09-17 23:58:17',3310491124,1),(53372458,425359845,14722089,454632,1,'2007-09-17 23:58:17',3310491124,1),(53372462,425356637,14720871,454632,1,'2007-09-17 23:58:17',3310491102,1),(53372466,425354078,14718597,454632,1,'2007-09-17 23:58:17',3310491102,1),(53372476,425350992,14713520,454632,1,'2007-09-17 23:58:18',3310491102,1),(53372487,425348628,14709630,454632,1,'2007-09-17 23:58:19',3310491102,1),(53372493,425345212,14703495,454632,1,'2007-09-17 23:58:19',3310491102,1),(53372501,425343161,14698240,454632,1,'2007-09-17 23:58:20',3310491102,1),(53372509,425341068,14690421,454632,1,'2007-09-17 23:58:21',3310491099,1),(53372513,425338846,14679484,454632,1,'2007-09-17 23:58:21',3310491099,1),(53372518,425336240,14666753,454632,1,'2007-09-17 23:58:22',3310491097,1),(53372522,425335932,14663343,454632,1,'2007-09-17 23:58:22',3310491097,1),(53372527,425336534,14661112,454632,1,'2007-09-17 23:58:23',3310491097,1),(53372535,425338127,14659094,454632,1,'2007-09-17 23:58:23',3310491097,1),(53372541,425340854,14656438,454632,1,'2007-09-17 23:58:24',3310491097,1),(53372544,425343155,14653783,454632,1,'2007-09-17 23:58:24',3310491100,1),(53372549,425344713,14651127,454632,1,'2007-09-17 23:58:24',3310491100,1),(53372555,425346059,14647905,454632,1,'2007-09-17 23:58:25',3310491100,1),(53372562,425347085,14644931,454632,1,'2007-09-17 23:58:26',3310491100,1),(53372568,425348077,14643054,454632,1,'2007-09-17 23:58:27',3310491100,1),(53372577,425349564,14642063,454632,1,'2007-09-17 23:58:28',3310491100,1),(53372587,425351582,14641744,454632,1,'2007-09-17 23:58:29',3310491100,1),(53372608,425352644,14642063,454632,1,'2007-09-17 23:58:31',3310491100,1),(53372614,425355796,14644258,454632,1,'2007-09-17 23:58:31',3310491100,1),(53372629,425359867,14646666,454632,1,'2007-09-17 23:58:33',3310491100,1),(53372637,425362629,14648649,454632,1,'2007-09-17 23:58:34',3310491100,1),(53372777,425364364,14649782,454632,1,'2007-09-17 23:58:52',3310491100,1),(53372794,425365780,14650171,454632,1,'2007-09-17 23:58:55',3310491100,1),(53372806,425367055,14649888,454632,1,'2007-09-17 23:58:55',3310491100,1),(53372815,425368578,14648790,454632,1,'2007-09-17 23:58:56',3310491100,1),(53372828,425369640,14647091,454632,1,'2007-09-17 23:58:57',3310491100,1),(53372832,425370313,14644789,454632,1,'2007-09-17 23:58:58',3310491101,1),(53372838,425370525,14641957,454632,1,'2007-09-17 23:58:58',3310491101,1),(53372843,425370171,14637318,454632,1,'2007-09-17 23:58:59',3310491101,1),(53372852,425369215,14632432,454632,1,'2007-09-17 23:59:00',3310491100,1),(53372858,425367947,14625506,454632,1,'2007-09-17 23:59:00',3310491100,1),(53372863,425367016,14620709,454632,1,'2007-09-17 23:59:01',3310491100,1),(53372873,425366146,14617690,454632,1,'2007-09-17 23:59:02',3310491100,1),(53372879,425364650,14613666,454632,1,'2007-09-17 23:59:02',3310491100,1),(53372887,425363753,14610620,454632,1,'2007-09-17 23:59:03',3310491094,1),(53372892,425363399,14608880,454632,1,'2007-09-17 23:59:04',3310491094,1),(53372903,425363263,14607058,454632,1,'2007-09-17 23:59:05',3310491094,1),(53372912,425363726,14605209,454632,1,'2007-09-17 23:59:06',3310491094,1),(53372917,425365439,14602027,454632,1,'2007-09-17 23:59:07',3310491094,1),(53372927,425367995,14597812,454632,1,'2007-09-17 23:59:08',3310491094,1),(53372935,425370769,14593217,454632,1,'2007-09-17 23:59:09',3310491095,1),(53372942,425372237,14590905,454632,1,'2007-09-17 23:59:10',3310491095,1),(53372956,425373134,14590089,454632,1,'2007-09-17 23:59:12',3310491095,1),(53372965,425375092,14589246,454632,1,'2007-09-17 23:59:13',3310491095,1),(53372978,425377295,14588376,454632,1,'2007-09-17 23:59:17',3310491095,1),(53372982,425379525,14586690,454632,1,'2007-09-17 23:59:17',3310491095,1),(53372991,425382353,14583944,454632,1,'2007-09-17 23:59:18',3310491095,1),(53373005,425385181,14581877,454632,1,'2007-09-17 23:59:19',3310491095,1),(53373016,425386595,14581224,454632,1,'2007-09-17 23:59:21',3310491095,1),(53373029,425389613,14580681,454632,1,'2007-09-17 23:59:22',3310491095,1),(53373035,425394021,14580425,454632,1,'2007-09-17 23:59:23',3310491095,1),(53373049,425397450,14580317,454632,1,'2007-09-17 23:59:24',3310502018,1),(53373068,425399723,14580533,454632,1,'2007-09-17 23:59:26',3310502018,1),(53373079,425402105,14581327,454632,1,'2007-09-17 23:59:27',3310502018,1),(53373094,425404342,14582302,454632,1,'2007-09-17 23:59:28',3310502018,1),(53373107,425405461,14582590,454632,1,'2007-09-17 23:59:30',3310502018,1),(53373114,425406544,14582266,454632,1,'2007-09-17 23:59:31',3310502018,1),(53373121,425408023,14581291,454632,1,'2007-09-17 23:59:32',3310502018,1),(53373130,425409431,14578909,454632,1,'2007-09-17 23:59:34',3310502018,1),(53373163,425411560,14575589,454632,1,'2007-09-17 23:59:37',3310502018,1),(53373182,425413545,14572305,454632,1,'2007-09-17 23:59:39',3310502018,1),(53373197,425415133,14569887,454632,1,'2007-09-17 23:59:40',3310502018,1),(53373203,425417117,14568372,454632,1,'2007-09-17 23:59:40',3310502018,1),(53373215,425419211,14567614,454632,1,'2007-09-17 23:59:41',3310502018,1),(53373224,425421087,14566928,454632,1,'2007-09-17 23:59:42',3310502018,1),(53373230,425423252,14565088,454632,1,'2007-09-17 23:59:42',3310502018,1),(53373233,425426951,14562456,454632,1,'2007-09-17 23:59:43',3310502019,1),(53373241,425430303,14559762,454632,1,'2007-09-17 23:59:43',3310502019,1),(53373246,425432758,14556888,454632,1,'2007-09-17 23:59:44',3310502017,1),(53373251,425437368,14550243,454632,1,'2007-09-17 23:59:44',3310502017,1),(53373259,425440002,14546592,454632,1,'2007-09-17 23:59:45',3310502017,1),(53373266,425442528,14542760,454632,1,'2007-09-17 23:59:45',3310502017,1),(53373270,425444252,14539312,454632,1,'2007-09-17 23:59:46',3310502017,1),(53373275,425445545,14536630,454632,1,'2007-09-17 23:59:46',3310502017,1),(53373280,425447413,14534523,454632,1,'2007-09-17 23:59:48',3310502017,1),(53373289,425449951,14532847,454632,1,'2007-09-17 23:59:48',3310502017,1),(53373297,425457557,14529667,454632,1,'2007-09-17 23:59:49',3310502020,1),(53373303,425461373,14527965,454632,1,'2007-09-17 23:59:50',3310502020,1),(53373308,425465419,14527414,454632,1,'2007-09-17 23:59:51',3310502020,1),(53373311,425477648,14526540,454632,1,'2007-09-17 23:59:51',3310502020,1),(53373318,425480453,14526678,454632,1,'2007-09-17 23:59:52',3310502021,1),(53373327,425482752,14527460,454632,1,'2007-09-17 23:59:53',3310502021,1),(53373335,425487763,14529667,454632,1,'2007-09-17 23:59:54',3310502021,1),(53373343,425490154,14531092,454632,1,'2007-09-17 23:59:55',3310502021,1),(53373348,425492085,14532103,454632,1,'2007-09-17 23:59:55',3310502021,1),(53373356,425494660,14533575,454632,1,'2007-09-17 23:59:56',3310502021,1),(53373365,425496729,14533804,454632,1,'2007-09-17 23:59:58',3310502021,1),(53373376,425499671,14534126,454632,1,'2007-09-18 00:00:02',3310502021,1),(53373382,425502798,14535506,454632,1,'2007-09-18 00:00:03',3310502021,1),(53373386,425505510,14537437,454632,1,'2007-09-18 00:00:04',3310502021,1),(53373392,425508729,14539414,454632,1,'2007-09-18 00:00:05',3310502032,1),(53373399,425510568,14540103,454632,1,'2007-09-18 00:00:06',3310502032,1),(53373402,425511918,14540251,454632,1,'2007-09-18 00:00:07',3310502032,1),(53373406,425513828,14541325,454632,1,'2007-09-18 00:00:07',3310502032,1),(53373410,425515739,14542639,454632,1,'2007-09-18 00:00:07',3310502032,1),(53373416,425517649,14542758,454632,1,'2007-09-18 00:00:07',3310502032,1),(53373457,425519798,14542579,454632,1,'2007-09-18 00:00:12',3310502032,1),(53373463,425521888,14540907,454632,1,'2007-09-18 00:00:13',3310502032,1),(53373467,425525171,14538878,454632,1,'2007-09-18 00:00:14',3310502032,1),(53373472,425527560,14536728,454632,1,'2007-09-18 00:00:14',3310502032,1),(53373475,425529768,14533206,454632,1,'2007-09-18 00:00:14',3310502032,1),(53373479,425531321,14530161,454632,1,'2007-09-18 00:00:15',3310502032,1),(53373480,425533709,14526281,454632,1,'2007-09-18 00:00:15',3310502032,1),(53373484,425535380,14522818,454632,1,'2007-09-18 00:00:16',3310502033,1),(53373499,425536216,14520848,454632,1,'2007-09-18 00:00:18',3310502033,1),(53373501,425536694,14518639,454632,1,'2007-09-18 00:00:18',3310502033,1),(53373507,425537171,14514699,454632,1,'2007-09-18 00:00:19',3310502033,1),(53373512,425537291,14512371,454632,1,'2007-09-18 00:00:19',3310502033,1),(53373516,425536933,14510221,454632,1,'2007-09-18 00:00:19',3310502033,1),(53373521,425535977,14507535,454632,1,'2007-09-18 00:00:19',3310502033,1),(53373529,425535112,14504937,454632,1,'2007-09-18 00:00:20',3310502033,1),(53373532,425534727,14502902,454632,1,'2007-09-18 00:00:20',3310502033,1),(53373536,425534476,14501388,454632,1,'2007-09-18 00:00:20',3310501947,1),(53373543,425534406,14499733,454632,1,'2007-09-18 00:00:21',3310501946,1),(53373545,425534476,14497549,454632,1,'2007-09-18 00:00:22',3310501947,1),(53373549,425534723,14494908,454632,1,'2007-09-18 00:00:22',3310501947,1),(53374387,425534828,14492056,454632,1,'2007-09-18 00:02:54',3310501947,1),(53374403,425534582,14489274,454632,1,'2007-09-18 00:02:56',3310501947,1),(53374521,425533561,14485366,454632,1,'2007-09-18 00:03:18',3310501946,1),(53374531,425532702,14482999,454632,1,'2007-09-18 00:03:19',3310501946,1),(53374534,425531456,14480273,454632,1,'2007-09-18 00:03:19',3310501946,1),(53374537,425530677,14477898,454632,1,'2007-09-18 00:03:20',3310501946,1),(53374542,425530288,14475094,454632,1,'2007-09-18 00:03:20',3310501946,1),(53374635,425530794,14472368,454632,1,'2007-09-18 00:03:39',3310501946,1),(53374797,425531846,14470771,454632,1,'2007-09-18 00:04:17',3310501946,1),(53374856,425534104,14469292,454632,1,'2007-09-18 00:04:29',3310501946,1),(53374862,425536051,14468279,454632,1,'2007-09-18 00:04:29',3310501947,1),(53374867,425538115,14467734,454632,1,'2007-09-18 00:04:31',3310501947,1),(53374883,425539362,14467851,454632,1,'2007-09-18 00:04:33',3310501947,1),(53374887,425541114,14468318,454632,1,'2007-09-18 00:04:33',3310501947,1),(53374892,425542828,14468902,454632,1,'2007-09-18 00:04:34',3310501947,1),(53374894,425544463,14469525,454632,1,'2007-09-18 00:04:34',3310501947,1),(53374897,425545748,14469798,454632,1,'2007-09-18 00:04:35',3310501947,1),(53374901,425547462,14469681,454632,1,'2007-09-18 00:04:37',3310501947,1),(53374925,425548825,14469876,454632,1,'2007-09-18 00:04:42',3310501947,1),(53374929,425550227,14470810,454632,1,'2007-09-18 00:04:43',3310501947,1),(53375001,425553654,14472952,454632,1,'2007-09-18 00:04:59',3310501947,1),(53375004,425557470,14475250,454632,1,'2007-09-18 00:05:00',3310501947,1),(53375007,425559690,14476613,454632,1,'2007-09-18 00:05:00',3310501947,1),(53375010,425561325,14477431,454632,1,'2007-09-18 00:05:01',3310501947,1),(53375014,425562922,14477898,454632,1,'2007-09-18 00:05:01',3310501950,1),(53375016,425564519,14478210,454632,1,'2007-09-18 00:05:02',3310501950,1),(53375019,425566660,14477937,454632,1,'2007-09-18 00:05:02',3310501950,1),(53375022,425568530,14477625,454632,1,'2007-09-18 00:05:03',3310501950,1),(53375026,425570438,14477119,454632,1,'2007-09-18 00:05:03',3310501950,1),(53375056,425572034,14475873,454632,1,'2007-09-18 00:05:09',3310501950,1),(53375086,425573670,14474276,454632,1,'2007-09-18 00:05:14',3310501950,1),(53375126,425576201,14472563,454632,1,'2007-09-18 00:05:21',3310501950,1),(53375501,425577837,14471472,454632,1,'2007-09-18 00:06:48',3310501950,1),(53376238,425579511,14469798,454632,1,'2007-09-18 00:08:28',3310501950,1),(53376244,425581342,14467500,454632,1,'2007-09-18 00:08:28',3310501950,1),(53376247,425582783,14465748,454632,1,'2007-09-18 00:08:29',3310501950,1),(53376253,425583912,14464385,454632,1,'2007-09-18 00:08:30',3310501950,1),(53376257,425584613,14462555,454632,1,'2007-09-18 00:08:31',3310501950,1),(53376264,425585392,14460685,454632,1,'2007-09-18 00:08:31',3310501950,1),(53376267,425586755,14460023,454632,1,'2007-09-18 00:08:32',3310501950,1),(53376272,425588235,14459790,454632,1,'2007-09-18 00:08:32',3310501950,1),(53376275,425590065,14460218,454632,1,'2007-09-18 00:08:33',3310501951,1),(53376314,425593297,14460763,454632,1,'2007-09-18 00:08:39',3310501951,1),(53376323,425597075,14460919,454632,1,'2007-09-18 00:08:41',3310501951,1),(53376331,425599255,14460880,454632,1,'2007-09-18 00:08:42',3310501951,1),(53376354,425600657,14460335,454632,1,'2007-09-18 00:08:44',3310501951,1),(53376363,425601280,14458582,454632,1,'2007-09-18 00:08:45',3310501951,1),(53376376,425601164,14456713,454632,1,'2007-09-18 00:08:46',3310501951,1),(53376378,425601047,14454571,454632,1,'2007-09-18 00:08:46',3310501951,1),(53376383,425601514,14451806,454632,1,'2007-09-18 00:08:47',3310501951,1),(53376386,425601670,14449158,454632,1,'2007-09-18 00:08:47',3310501951,1),(53376390,425601436,14446978,454632,1,'2007-09-18 00:08:48',3310501949,1),(53376392,425601241,14445342,454632,1,'2007-09-18 00:08:48',3310501949,1);
INSERT INTO `current_nodes` VALUES (53376394,425600852,14442499,454632,1,'2007-09-18 00:08:49',3310501949,1),(53376397,425600268,14441019,454632,1,'2007-09-18 00:08:49',3310501949,1),(53376399,425599489,14438332,454632,1,'2007-09-18 00:08:49',3310501949,1),(53376401,425599917,14435918,454632,1,'2007-09-18 00:08:50',3310501949,1),(53376405,425600385,14433387,454632,1,'2007-09-18 00:08:50',3310501949,1),(53376408,425600891,14430700,454632,1,'2007-09-18 00:08:51',3310501949,1),(53376414,425600930,14427389,454632,1,'2007-09-18 00:08:51',3310501949,1),(53376419,425601226,14422163,454632,1,'2007-09-18 00:08:52',3310501949,1),(53376421,425601179,14418845,454632,1,'2007-09-18 00:08:52',3310501949,1),(53376423,425600805,14417584,454632,1,'2007-09-18 00:08:53',3310501949,1),(53376428,425600525,14416415,454632,1,'2007-09-18 00:08:53',3310501949,1),(53376431,425600338,14414359,454632,1,'2007-09-18 00:08:53',3310501949,1),(53376435,425600104,14412396,454632,1,'2007-09-18 00:08:54',3310501949,1),(53376437,425600104,14410107,454632,1,'2007-09-18 00:08:54',3310501949,1),(53376438,425600338,14407443,454632,1,'2007-09-18 00:08:54',3310501949,1),(53376440,425600151,14405807,454632,1,'2007-09-18 00:08:54',3310501949,1),(53376442,425599357,14404779,454632,1,'2007-09-18 00:08:54',3310501949,1),(53376444,425597861,14403611,454632,1,'2007-09-18 00:08:55',3310501949,1),(53376448,425595571,14402209,454632,1,'2007-09-18 00:08:55',3310501949,1),(53376451,425592627,14400573,454632,1,'2007-09-18 00:08:55',3310501949,1),(53376626,425590805,14399732,454632,1,'2007-09-18 00:09:15',3310501949,1),(53376629,425589309,14398891,454632,1,'2007-09-18 00:09:16',3310501948,1),(53376632,425588375,14397910,454632,1,'2007-09-18 00:09:16',3310501948,1),(53376634,425588001,14396601,454632,1,'2007-09-18 00:09:16',3310501948,1),(53376637,425588048,14394452,454632,1,'2007-09-18 00:09:16',3310501948,1),(53376658,425588655,14391414,454632,1,'2007-09-18 00:09:19',3310501942,1),(53376660,425589403,14387816,454632,1,'2007-09-18 00:09:19',3310501943,1),(53376663,425589496,14385993,454632,1,'2007-09-18 00:09:19',3310501943,1),(53376664,425588468,14383563,454632,1,'2007-09-18 00:09:19',3310501942,1),(53376666,425587300,14380666,454632,1,'2007-09-18 00:09:19',3310501942,1),(53376670,425584870,14378376,454632,1,'2007-09-18 00:09:20',3310501942,1),(53376674,425582632,14376263,454632,1,'2007-09-18 00:09:20',3310501942,1),(53376677,425581281,14375201,454632,1,'2007-09-18 00:09:20',3310501942,1),(53376682,425580413,14373947,454632,1,'2007-09-18 00:09:21',3310501942,1),(53376683,425580316,14372693,454632,1,'2007-09-18 00:09:21',3310501942,1),(53376686,425580461,14370957,454632,1,'2007-09-18 00:09:21',3310501942,1),(53376689,425582583,14365795,454632,1,'2007-09-18 00:09:22',3310501942,1),(53376692,425583162,14363335,454632,1,'2007-09-18 00:09:22',3310501942,1),(53376695,425583452,14361599,454632,1,'2007-09-18 00:09:22',3310501942,1),(53376699,425583210,14359911,454632,1,'2007-09-18 00:09:23',3310501942,1),(53376702,425582439,14358367,454632,1,'2007-09-18 00:09:23',3310501942,1),(53376704,425580895,14356004,454632,1,'2007-09-18 00:09:23',3310501942,1),(53376709,425580027,14354267,454632,1,'2007-09-18 00:09:24',3310501942,1),(53376715,425579255,14351855,454632,1,'2007-09-18 00:09:25',3310501942,1),(53376719,425579207,14347225,454632,1,'2007-09-18 00:09:25',3310501942,1),(53376723,425579207,14345102,454632,1,'2007-09-18 00:09:25',3310501942,1),(53376729,425578869,14343655,454632,1,'2007-09-18 00:09:25',3310501942,1),(53376733,425578242,14342787,454632,1,'2007-09-18 00:09:26',3310501942,1),(53376737,425577875,14341461,454632,1,'2007-09-18 00:09:26',3310501942,1),(53376740,425576924,14338642,454632,1,'2007-09-18 00:09:26',3310501942,1),(53376743,425576301,14335168,454632,1,'2007-09-18 00:09:26',3310501940,1),(53376746,425576072,14333333,454632,1,'2007-09-18 00:09:26',3310501940,1),(53376748,425575023,14331956,454632,1,'2007-09-18 00:09:27',3310501940,1),(53376750,425572860,14330678,454632,1,'2007-09-18 00:09:27',3310501940,1),(53376751,425569058,14328613,454632,1,'2007-09-18 00:09:27',3310501940,1),(53376753,425567092,14326974,454632,1,'2007-09-18 00:09:27',3310501940,1),(53376754,425565191,14326221,454632,1,'2007-09-18 00:09:28',3310501940,1),(53376756,425561749,14325401,454632,1,'2007-09-18 00:09:28',3310501937,1),(53376757,425558701,14325172,454632,1,'2007-09-18 00:09:28',3310501937,1),(53376761,425555522,14325172,454632,1,'2007-09-18 00:09:28',3310501937,1),(53376764,425552146,14325237,454632,1,'2007-09-18 00:09:28',3310501937,1),(53376766,425550671,14324942,454632,1,'2007-09-18 00:09:28',3310501937,1),(53376768,425548738,14324615,454632,1,'2007-09-18 00:09:28',3310501937,1),(53376771,425547099,14323762,454632,1,'2007-09-18 00:09:29',3310501937,1),(53376772,425545460,14322583,454632,1,'2007-09-18 00:09:29',3310501937,1),(53376775,425544477,14321730,454632,1,'2007-09-18 00:09:29',3310501937,1),(53376777,425543428,14319567,454632,1,'2007-09-18 00:09:29',3310501937,1),(53376780,425542904,14316945,454632,1,'2007-09-18 00:09:29',3310501937,1),(53376782,425542707,14313602,454632,1,'2007-09-18 00:09:30',3310501937,1),(53376784,425542543,14309276,454632,1,'2007-09-18 00:09:30',3310501937,1),(53376788,425542707,14305310,454632,1,'2007-09-18 00:09:30',3310501937,1),(53376797,425543559,14301082,454632,1,'2007-09-18 00:09:31',3310501937,1),(53376799,425544706,14297280,454632,1,'2007-09-18 00:09:31',3310501937,1),(53376802,425545738,14294435,454632,1,'2007-09-18 00:09:31',3310501937,1),(53376806,425546260,14291740,454632,1,'2007-09-18 00:09:32',3310501937,1),(53376810,425546608,14289198,454632,1,'2007-09-18 00:09:32',3310501937,1),(53376814,425547095,14285412,454632,1,'2007-09-18 00:09:32',3310501937,1),(53376816,425546914,14282574,454632,1,'2007-09-18 00:09:32',3310501937,1),(53376820,425545923,14279555,454632,1,'2007-09-18 00:09:32',3310501915,1),(53376827,425544301,14273922,454632,1,'2007-09-18 00:09:33',3310501915,1),(53376830,425541417,14264144,454632,1,'2007-09-18 00:09:33',3310501915,1),(53376834,425540696,14260585,454632,1,'2007-09-18 00:09:34',3310501915,1),(53376837,425538894,14253826,454632,1,'2007-09-18 00:09:34',3310501915,1),(53376840,425537767,14250537,454632,1,'2007-09-18 00:09:34',3310501915,1),(53376847,425535379,14247292,454632,1,'2007-09-18 00:09:35',3310501915,1),(53376853,425531594,14244679,454632,1,'2007-09-18 00:09:36',3310501914,1),(53376856,425530017,14243958,454632,1,'2007-09-18 00:09:36',3310501914,1),(53376859,425525962,14243147,454632,1,'2007-09-18 00:09:36',3310501914,1),(53376862,425523484,14243012,454632,1,'2007-09-18 00:09:36',3310501914,1),(53376864,425520510,14242832,454632,1,'2007-09-18 00:09:37',3310501914,1),(53376873,425515598,14243012,454632,1,'2007-09-18 00:09:37',3310501914,1),(53376881,425512850,14243237,454632,1,'2007-09-18 00:09:38',3310501914,1),(53376883,425507262,14243192,454632,1,'2007-09-18 00:09:38',3310501914,1),(53376887,425503568,14242426,454632,1,'2007-09-18 00:09:38',3310501903,1),(53376891,425501810,14241975,454632,1,'2007-09-18 00:09:38',3310501903,1),(53376895,425497079,14239587,454632,1,'2007-09-18 00:09:39',3310501903,1),(53376898,425494511,14237740,454632,1,'2007-09-18 00:09:39',3310501903,1),(53376899,425491537,14233685,454632,1,'2007-09-18 00:09:39',3310501903,1),(53376955,425376012,14835521,454632,1,'2007-09-18 00:09:45',3310491133,1),(53376959,425373865,14831300,454632,1,'2007-09-18 00:09:45',3310491127,1),(53376962,425372228,14827735,454632,1,'2007-09-18 00:09:45',3310491127,1),(53376964,425371391,14825552,454632,1,'2007-09-18 00:09:45',3310491127,1),(53376968,425378522,14840469,454632,1,'2007-09-18 00:09:45',3310491133,1),(53376972,425379723,14843853,454632,1,'2007-09-18 00:09:46',3310491133,1),(53376975,425380341,14846800,454632,1,'2007-09-18 00:09:46',3310491133,1),(53376979,425381033,14849747,454632,1,'2007-09-18 00:09:46',3310491133,1),(53376983,425382379,14854259,454632,1,'2007-09-18 00:09:47',3310491133,1),(53376987,425384307,14860880,454632,1,'2007-09-18 00:09:47',3310491133,1),(53376989,425385690,14864628,454632,1,'2007-09-18 00:09:47',3310491133,1),(53376996,425387000,14868121,454632,1,'2007-09-18 00:09:48',3310491133,1),(53377001,425389619,14873760,454632,1,'2007-09-18 00:09:48',3310491133,1),(53377006,425391548,14877799,454632,1,'2007-09-18 00:09:48',3310491133,1),(53377009,425393476,14881583,454632,1,'2007-09-18 00:09:49',3310491133,1),(53377015,425394604,14883984,454632,1,'2007-09-18 00:09:49',3310491133,1),(53377018,425395732,14887877,454632,1,'2007-09-18 00:09:49',3310491135,1),(53377021,425395914,14891952,454632,1,'2007-09-18 00:09:49',3310491135,1),(53377027,425395841,14894426,454632,1,'2007-09-18 00:09:50',3310491135,1),(53377032,425396314,14899665,454632,1,'2007-09-18 00:09:50',3310491135,1),(53377035,425397660,14904177,454632,1,'2007-09-18 00:09:50',3310502058,1),(53377040,425401189,14910435,454632,1,'2007-09-18 00:09:50',3310502058,1),(53377045,425404755,14916184,454632,1,'2007-09-18 00:09:50',3310502058,1),(53377047,425407811,14919385,454632,1,'2007-09-18 00:09:51',3310502058,1),(53377049,425410685,14921896,454632,1,'2007-09-18 00:09:51',3310502058,1),(53377051,425413887,14923679,454632,1,'2007-09-18 00:09:51',3310502058,1),(53377053,425418290,14925352,454632,1,'2007-09-18 00:09:51',3310502058,1),(53377058,425421892,14927353,454632,1,'2007-09-18 00:09:52',3310502058,1),(53377061,425424911,14930082,454632,1,'2007-09-18 00:09:52',3310502059,1),(53377065,425427604,14933648,454632,1,'2007-09-18 00:09:52',3310502059,1),(53377068,425428695,14937322,454632,1,'2007-09-18 00:09:53',3310502059,1),(53377070,425428259,14939906,454632,1,'2007-09-18 00:09:53',3310502059,1),(53377077,425427786,14940815,454632,1,'2007-09-18 00:09:53',3310502059,1),(53377080,425426294,14941798,454632,1,'2007-09-18 00:09:54',3310502401,1),(53377090,425424366,14941725,454632,1,'2007-09-18 00:09:55',3310502400,1),(53377093,425421782,14941288,454632,1,'2007-09-18 00:09:55',3310502058,1),(53377098,425418945,14940561,454632,1,'2007-09-18 00:09:55',3310502058,1),(53377104,425411995,14939505,454632,1,'2007-09-18 00:09:56',3310502058,1),(53377113,425409921,14939505,454632,1,'2007-09-18 00:09:56',3310502058,1),(53377119,425407193,14940015,454632,1,'2007-09-18 00:09:57',3310502058,1),(53377124,425403336,14941325,454632,1,'2007-09-18 00:09:57',3310502058,1),(53377128,425399734,14942962,454632,1,'2007-09-18 00:09:58',3310502400,1),(53377133,425394749,14944817,454632,1,'2007-09-18 00:09:58',3310491477,1),(53377138,425390965,14946200,454632,1,'2007-09-18 00:09:59',3310491477,1),(53377141,425387873,14947001,454632,1,'2007-09-18 00:09:59',3310491477,1),(53377146,425385290,14946928,454632,1,'2007-09-18 00:10:00',3310491477,1),(53377151,425381287,14945509,454632,1,'2007-09-18 00:10:00',3310491477,1),(53377156,425377504,14943107,454632,1,'2007-09-18 00:10:01',3310491477,1),(53377163,425375697,14940890,454632,1,'2007-09-18 00:10:01',3310491135,1),(53377168,425374565,14937369,454632,1,'2007-09-18 00:10:01',3310491135,1),(53377175,425372930,14932528,454632,1,'2007-09-18 00:10:02',3310491135,1),(53377178,425370290,14928630,454632,1,'2007-09-18 00:10:03',3310491135,1),(53377180,425366706,14924669,454632,1,'2007-09-18 00:10:03',3310491134,1),(53377183,425364443,14921337,454632,1,'2007-09-18 00:10:03',3310491134,1),(53377186,425363248,14917502,454632,1,'2007-09-18 00:10:04',3310491134,1),(53377191,425363311,14914170,454632,1,'2007-09-18 00:10:06',3310491134,1),(53377195,425365009,14912472,454632,1,'2007-09-18 00:10:06',3310491134,1),(53380473,425366895,14912472,538211,1,'2007-09-30 15:36:19',3310491134,1),(53380480,425374439,14915050,454632,1,'2007-09-18 00:20:15',3310491135,1),(53380485,425381166,14918508,454632,1,'2007-09-18 00:20:16',3310491135,1),(53380489,425385379,14922846,454632,1,'2007-09-18 00:20:17',3310491135,1),(53380491,425390723,14926430,454632,1,'2007-09-18 00:20:18',3310491135,1),(53380499,425394369,14928945,454632,1,'2007-09-18 00:20:19',3310491135,1),(53380503,425396444,14932591,454632,1,'2007-09-18 00:20:20',3310491135,1),(53381711,425396004,14937118,454632,1,'2007-09-18 00:24:28',3310491135,1),(53381723,425394746,14939318,454632,1,'2007-09-18 00:24:31',3310491135,1),(53381733,425389717,14941519,454632,1,'2007-09-18 00:24:33',3310491135,1),(53381738,425385190,14943153,454632,1,'2007-09-18 00:24:34',3310491477,1),(53381779,425382047,14944285,454632,1,'2007-09-18 00:24:40',3310491477,1),(53381787,425379406,14914296,454632,1,'2007-09-18 00:24:41',3310491135,1),(53381798,425383681,14918068,454632,1,'2007-09-18 00:24:44',3310491135,1),(53381809,425387202,14921274,454632,1,'2007-09-18 00:24:46',3310491135,1),(53381818,425390786,14923601,454632,1,'2007-09-18 00:24:48',3310491135,1),(53381825,425394495,14925298,454632,1,'2007-09-18 00:24:48',3310491135,1),(53381829,425396821,14928819,454632,1,'2007-09-18 00:24:49',3310491135,1),(53381832,425398644,14932780,454632,1,'2007-09-18 00:24:49',3310502058,1),(53381834,425398959,14936112,454632,1,'2007-09-18 00:24:50',3310502058,1),(53381837,425395815,14934666,454632,1,'2007-09-18 00:24:50',3310491135,1),(53381842,425395375,14931648,454632,1,'2007-09-18 00:24:50',3310491135,1),(53381844,425392860,14928819,454632,1,'2007-09-18 00:24:51',3310491135,1),(53381850,425390660,14927373,454632,1,'2007-09-18 00:24:52',3310491135,1),(53381892,425387391,14925424,454632,1,'2007-09-18 00:25:00',3310491135,1),(53381925,425385127,14923663,454632,1,'2007-09-18 00:25:06',3310491135,1),(53381944,425383241,14921652,454632,1,'2007-09-18 00:25:10',3310491135,1),(53381947,425381103,14919765,454632,1,'2007-09-18 00:25:11',3310491135,1),(53381978,425377646,14917754,454632,1,'2007-09-18 00:25:21',3310491135,1),(53381995,425370478,14914862,454632,1,'2007-09-18 00:25:28',3310491135,1),(53382002,425371358,14910964,454632,1,'2007-09-18 00:25:29',3310491135,1),(53382009,425365816,14920445,454632,1,'2007-09-18 00:25:31',3310491134,1),(53382019,425367235,14923449,454632,1,'2007-09-18 00:25:35',3310491134,1),(53382028,425369071,14925618,454632,1,'2007-09-18 00:25:36',3310491134,1),(53382033,425371323,14928121,454632,1,'2007-09-18 00:25:38',3310491135,1),(53382041,425373576,14931542,454632,1,'2007-09-18 00:25:39',3310491135,1),(53382044,425375495,14937216,454632,1,'2007-09-18 00:25:40',3310491135,1),(53382047,425376163,14939636,454632,1,'2007-09-18 00:25:41',3310491135,1),(53382052,425377581,14942222,454632,1,'2007-09-18 00:25:42',3310491477,1),(53382055,425379750,14943724,454632,1,'2007-09-18 00:25:43',3310491477,1),(53382059,425380501,14943641,454632,1,'2007-09-18 00:25:44',3310491477,1),(53382064,425381336,14942806,454632,1,'2007-09-18 00:25:44',3310491477,1),(53382089,425382504,14941555,454632,1,'2007-09-18 00:25:49',3310491135,1),(53382106,425385257,14941221,454632,1,'2007-09-18 00:25:53',3310491135,1),(53382126,425388011,14940553,454632,1,'2007-09-18 00:25:56',3310491135,1),(53382156,425391348,14939385,454632,1,'2007-09-18 00:26:02',3310491135,1),(53382223,425393684,14938050,454632,1,'2007-09-18 00:26:16',3310491135,1),(53382318,425395103,14936382,454632,1,'2007-09-18 00:26:35',3310491135,1),(53382504,425395770,14934629,454632,1,'2007-09-18 00:27:16',3310491135,1),(53382509,425395384,14932168,454632,1,'2007-09-18 00:27:17',3310491135,1),(53382959,425394684,14930812,454632,1,'2007-09-18 00:28:30',3310491135,1),(53383168,425390856,14927444,454632,1,'2007-09-18 00:29:04',3310491135,1),(53383242,425385519,14924010,538211,1,'2007-09-30 15:36:20',3310491135,1),(53383258,425384185,14922676,538211,1,'2007-09-30 15:36:20',3310491135,1),(53383280,425381801,14920357,538211,1,'2007-09-30 15:36:20',3310491135,1),(53383286,425379789,14919089,538211,1,'2007-09-30 15:36:20',3310491135,1),(53383289,425377302,14917659,538211,1,'2007-09-30 15:36:20',3310491135,1),(53383297,425375298,14916790,538211,1,'2007-09-30 15:36:20',3310491135,1),(53383310,425370778,14914832,454632,1,'2007-09-18 00:29:29',3310491135,1),(53383321,425369055,14914197,454632,1,'2007-09-18 00:29:31',3310491134,1),(53383324,425366968,14913622,538211,1,'2007-09-30 15:36:19',3310491134,1),(53383336,425365759,14913773,538211,1,'2007-09-30 15:36:19',3310491134,1),(53383341,425364973,14914711,538211,1,'2007-09-30 15:36:19',3310491134,1),(53383350,425364912,14915588,538211,1,'2007-09-30 15:36:19',3310491134,1),(53383356,425365215,14918853,538211,1,'2007-09-30 15:36:19',3310491134,1),(53383364,425379384,14851309,454632,1,'2007-09-18 00:29:36',3310491133,1),(53383369,425375668,14854925,454632,1,'2007-09-18 00:29:36',3310491133,1),(53383373,425372884,14858552,454632,1,'2007-09-18 00:29:36',3310491133,1),(53383379,425369206,14863864,454632,1,'2007-09-18 00:29:37',3310491132,1),(53383384,425364353,14870556,454632,1,'2007-09-18 00:29:37',3310491132,1),(53383388,425358419,14878355,454632,1,'2007-09-18 00:29:38',3310491132,1),(53383393,425353176,14885452,454632,1,'2007-09-18 00:29:38',3310491132,1),(53383398,425348198,14891913,454632,1,'2007-09-18 00:29:39',3310491134,1),(53383403,425347933,14883545,454632,1,'2007-09-18 00:29:40',3310491132,1),(53383409,425356830,14872688,454632,1,'2007-09-18 00:29:40',3310491132,1),(53383415,425362126,14865062,454632,1,'2007-09-18 00:29:41',3310491132,1),(53383419,425368269,14857118,454632,1,'2007-09-18 00:29:42',3310491132,1),(53383424,425377484,14844885,454632,1,'2007-09-18 00:29:42',3310491133,1),(53383429,425337114,14701265,454632,1,'2007-09-18 00:29:42',3310491099,1),(53383434,425308725,14733734,454632,1,'2007-09-18 00:29:43',3310491120,1),(53383440,425306902,14729827,454632,1,'2007-09-18 00:29:44',3310491120,1),(53383445,425306294,14723837,454632,1,'2007-09-18 00:29:44',3310491120,1),(53383451,425305773,14718888,454632,1,'2007-09-18 00:29:45',3310491098,1),(53383455,425303603,14713332,454632,1,'2007-09-18 00:29:46',3310491098,1),(53383459,425303950,14710381,454632,1,'2007-09-18 00:29:47',3310491098,1),(53383468,425306468,14704651,454632,1,'2007-09-18 00:29:48',3310491098,1),(53383474,425308899,14701439,454632,1,'2007-09-18 00:29:49',3310491098,1),(53383480,425312545,14698574,454632,1,'2007-09-18 00:29:50',3310491098,1),(53383487,425316191,14697792,454632,1,'2007-09-18 00:29:52',3310491099,1),(53383494,425321400,14699095,454632,1,'2007-09-18 00:29:54',3310491099,1),(53383497,425324265,14700397,454632,1,'2007-09-18 00:29:54',3310491099,1),(53383499,425326956,14701439,454632,1,'2007-09-18 00:29:54',3310491099,1),(53383505,425331644,14701178,454632,1,'2007-09-18 00:29:55',3310491099,1),(53383508,425333033,14700050,454632,1,'2007-09-18 00:29:55',3310491099,1),(53383523,425335985,14700223,454632,1,'2007-09-18 00:29:58',3310491099,1),(53383556,425327169,14743141,454632,1,'2007-09-18 00:30:04',3310491121,1),(53383559,425321397,14744855,454632,1,'2007-09-18 00:30:04',3310491121,1),(53383561,425313984,14748336,454632,1,'2007-09-18 00:30:05',3310491120,1),(53383562,425318385,14757932,454632,1,'2007-09-18 00:30:06',3310491121,1),(53383566,425321920,14765002,454632,1,'2007-09-18 00:30:06',3310491121,1),(53383579,425324012,14773082,454632,1,'2007-09-18 00:30:10',3310491121,1),(53383582,425325672,14776185,454632,1,'2007-09-18 00:30:12',3310491121,1),(53383584,425327187,14778782,454632,1,'2007-09-18 00:30:12',3310491123,1),(53383597,425330145,14780514,454632,1,'2007-09-18 00:30:16',3310491123,1),(53383600,425342266,14784915,454632,1,'2007-09-18 00:30:16',3310491126,1),(53383603,425352871,14789171,454632,1,'2007-09-18 00:30:16',3310491126,1),(53383605,425356479,14790109,454632,1,'2007-09-18 00:30:17',3310491126,1),(53383606,425359437,14788955,454632,1,'2007-09-18 00:30:17',3310491126,1),(53383610,425362178,14785420,454632,1,'2007-09-18 00:30:17',3310491126,1),(53383612,425363982,14781019,454632,1,'2007-09-18 00:30:17',3310491126,1),(53383614,425364992,14776618,454632,1,'2007-09-18 00:30:17',3310491124,1),(53383617,425364920,14774381,454632,1,'2007-09-18 00:30:17',3310491124,1),(53383620,425363765,14770197,454632,1,'2007-09-18 00:30:18',3310491124,1),(53383622,425362972,14767094,454632,1,'2007-09-18 00:30:18',3310491124,1),(53383624,425361024,14762549,454632,1,'2007-09-18 00:30:18',3310491124,1),(53383626,425357633,14759230,454632,1,'2007-09-18 00:30:19',3310491124,1),(53383628,425352655,14756561,454632,1,'2007-09-18 00:30:19',3310491124,1),(53383631,425349336,14753747,454632,1,'2007-09-18 00:30:19',3310491124,1),(53383634,425344719,14749779,454632,1,'2007-09-18 00:30:19',3310491124,1),(53383636,425333897,14739967,454632,1,'2007-09-18 00:30:20',3310491121,1),(53383639,425338506,14715813,454632,1,'2007-09-18 00:30:20',3310491099,1),(53383643,425339388,14720592,454632,1,'2007-09-18 00:30:21',3310491099,1),(53383646,425339315,14724931,454632,1,'2007-09-18 00:30:22',3310491121,1),(53383670,425337991,14729343,454632,1,'2007-09-18 00:30:27',3310491121,1),(53383680,425335785,14734564,454632,1,'2007-09-18 00:30:29',3310491121,1),(53383685,425334241,14735740,454632,1,'2007-09-18 00:30:29',3310491121,1),(53383688,425331594,14735961,454632,1,'2007-09-18 00:30:29',3310491121,1),(53383691,425329314,14737432,454632,1,'2007-09-18 00:30:29',3310491121,1),(53383694,425325858,14739123,454632,1,'2007-09-18 00:30:30',3310491121,1),(53383698,425322255,14741476,454632,1,'2007-09-18 00:30:30',3310491121,1),(53383728,425317476,14742800,454632,1,'2007-09-18 00:30:35',3310491121,1),(53383735,425313946,14743755,454632,1,'2007-09-18 00:30:37',3310491120,1),(53383739,425311299,14739564,454632,1,'2007-09-18 00:30:38',3310491120,1),(53383762,425320343,14730887,454632,1,'2007-09-18 00:30:42',3310491121,1),(53383772,425323799,14726843,454632,1,'2007-09-18 00:30:43',3310491121,1),(53383793,425326961,14722578,454632,1,'2007-09-18 00:30:46',3310491121,1),(53383842,425329461,14720960,454632,1,'2007-09-18 00:30:54',3310491099,1),(53383953,425335197,14713386,454632,1,'2007-09-18 00:31:08',3310491099,1),(53383956,425337256,14711107,454632,1,'2007-09-18 00:31:09',3310491099,1),(53383958,425297457,14678657,454632,1,'2007-09-18 00:31:10',3310491098,1),(53383961,425302101,14682161,454632,1,'2007-09-18 00:31:10',3310491098,1),(53383970,425308579,14684891,454632,1,'2007-09-18 00:31:12',3310491098,1),(53383987,425308008,14687783,454632,1,'2007-09-18 00:31:15',3310491098,1),(53383990,425305197,14693364,454632,1,'2007-09-18 00:31:15',3310491098,1),(53384000,425302386,14700127,454632,1,'2007-09-18 00:31:17',3310491098,1),(53384003,425301449,14700209,454632,1,'2007-09-18 00:31:17',3310491098,1),(53384008,425300838,14699842,454632,1,'2007-09-18 00:31:18',3310491098,1),(53384011,425298068,14695605,454632,1,'2007-09-18 00:31:18',3310491098,1),(53384013,425294972,14690716,454632,1,'2007-09-18 00:31:19',3310491098,1),(53384016,425293749,14686153,454632,1,'2007-09-18 00:31:19',3310491098,1),(53384020,425292772,14681631,454632,1,'2007-09-18 00:31:19',3310491098,1),(53384024,425292894,14678698,454632,1,'2007-09-18 00:31:20',3310491098,1),(53384026,425294646,14678413,454632,1,'2007-09-18 00:31:20',3310491098,1),(53384030,425331408,14794176,454632,1,'2007-09-18 00:31:20',3310491123,1),(53384033,425333312,14801793,454632,1,'2007-09-18 00:31:21',3310491123,1),(53384036,425335812,14809292,454632,1,'2007-09-18 00:31:22',3310491123,1),(53384038,425339382,14820242,454632,1,'2007-09-18 00:31:22',3310491123,1),(53384040,425343786,14828693,454632,1,'2007-09-18 00:31:23',3310491126,1),(53384065,425348309,14833811,454632,1,'2007-09-18 00:31:27',3310491132,1),(53384068,425353785,14837739,454632,1,'2007-09-18 00:31:27',3310491132,1),(53384120,425357474,14840834,454632,1,'2007-09-18 00:31:39',3310491132,1),(53384283,425360688,14839763,454632,1,'2007-09-18 00:32:11',3310491132,1),(53384287,425364497,14836073,454632,1,'2007-09-18 00:32:12',3310491132,1),(53384302,425367234,14834764,454632,1,'2007-09-18 00:32:16',3310491132,1),(53384325,425369615,14838572,454632,1,'2007-09-18 00:32:22',3310491132,1),(53384330,425365806,14841905,454632,1,'2007-09-18 00:32:24',3310491132,1),(53384332,425362473,14845833,454632,1,'2007-09-18 00:32:24',3310491132,1),(53384335,425361164,14849047,454632,1,'2007-09-18 00:32:25',3310491132,1),(53384338,425359141,14849047,454632,1,'2007-09-18 00:32:26',3310491132,1),(53384375,425357831,14848094,538211,1,'2007-09-30 15:36:19',3310491132,1),(53385461,425353070,14843929,454632,1,'2007-09-18 00:37:46',3310491132,1),(53385467,425350333,14840953,454632,1,'2007-09-18 00:37:47',3310491132,1),(53385484,425348190,14839882,454632,1,'2007-09-18 00:37:50',3310491132,1),(53385511,425346524,14839644,454632,1,'2007-09-18 00:37:55',3310491132,1),(53387182,425344501,14837620,538211,1,'2007-09-30 15:36:20',3310491132,1),(53388340,425338192,14827384,454632,1,'2007-09-18 00:48:16',3310491123,1),(53388543,425334979,14820242,454632,1,'2007-09-18 00:48:59',3310491123,1),(53389302,425332598,14810958,454632,1,'2007-09-18 00:51:38',3310491123,1),(53389827,425331408,14805602,454632,1,'2007-09-18 00:53:37',3310491123,1),(53390266,425329384,14798937,454632,1,'2007-09-18 00:55:18',3310491123,1),(53390450,425325814,14792628,454632,1,'2007-09-18 00:55:58',3310491123,1),(53390493,425325218,14787272,454632,1,'2007-09-18 00:56:06',3310491123,1),(53390505,425324266,14781559,454632,1,'2007-09-18 00:56:09',3310491123,1),(53390513,425319624,14772156,454632,1,'2007-09-18 00:56:11',3310491121,1),(53390521,425317363,14764419,454632,1,'2007-09-18 00:56:12',3310491121,1),(53390534,425313197,14755373,454632,1,'2007-09-18 00:56:14',3310491120,1),(53390548,425306769,14746804,454632,1,'2007-09-18 00:56:16',3310491120,1),(53390624,425304508,14743114,454632,1,'2007-09-18 00:56:32',3310491120,1),(53390658,425306412,14740495,454632,1,'2007-09-18 00:56:39',3310491120,1),(53390732,425313554,14750136,454632,1,'2007-09-18 00:56:54',3310491120,1),(53390740,425316887,14756921,454632,1,'2007-09-18 00:56:56',3310491121,1),(53390749,425320934,14766086,454632,1,'2007-09-18 00:56:57',3310491121,1),(53390776,425325456,14776917,454632,1,'2007-09-18 00:57:04',3310491123,1),(53390786,425321066,14695137,454632,1,'2007-09-18 00:57:06',3310491099,1),(53392096,425316926,14694309,454632,1,'2007-09-18 01:00:37',3310491099,1),(53392102,425314752,14694257,454632,1,'2007-09-18 01:00:38',3310491099,1),(53392109,425312423,14694775,454632,1,'2007-09-18 01:00:39',3310491098,1),(53392116,425313251,14689806,454632,1,'2007-09-18 01:00:40',3310491098,1),(53392136,425315425,14689599,454632,1,'2007-09-18 01:00:45',3310491099,1),(53392141,425320704,14691204,454632,1,'2007-09-18 01:00:46',3310491099,1),(53392147,425328209,14696173,454632,1,'2007-09-18 01:00:47',3310491099,1),(53392151,425327899,14697156,454632,1,'2007-09-18 01:00:48',3310491099,1),(53392160,425326450,14697674,454632,1,'2007-09-18 01:00:50',3310491099,1),(53392164,425323913,14696845,454632,1,'2007-09-18 01:00:50',3310491099,1),(53392166,425322930,14696017,454632,1,'2007-09-18 01:00:50',3310491099,1),(53392168,425322671,14695448,454632,1,'2007-09-18 01:00:50',3310491099,1),(53392180,425322671,14693792,454632,1,'2007-09-18 01:00:51',3310491099,1),(53392185,425322878,14693119,454632,1,'2007-09-18 01:00:53',3310491099,1),(53392195,425323344,14693015,454632,1,'2007-09-18 01:00:54',3310491099,1),(53392200,425324379,14693688,454632,1,'2007-09-18 01:00:55',3310491099,1),(53392203,425324897,14693947,454632,1,'2007-09-18 01:00:56',3310491099,1),(53392207,425309105,14691843,454632,1,'2007-09-18 01:00:56',3310491098,1),(53392208,425306473,14695745,454632,1,'2007-09-18 01:00:56',3310491098,1),(53392215,425304885,14699512,454632,1,'2007-09-18 01:00:57',3310491098,1),(53392222,425304250,14702870,454632,1,'2007-09-18 01:00:58',3310491098,1),(53392224,425306473,14700192,454632,1,'2007-09-18 01:00:58',3310491098,1),(53392227,425309105,14696154,454632,1,'2007-09-18 01:00:58',3310491098,1),(53392235,425311238,14695110,454632,1,'2007-09-18 01:00:58',3310491098,1),(53392239,425311783,14690209,454632,1,'2007-09-18 01:00:59',3310491098,1),(57603545,424579031,14513385,494030,1,'2007-09-22 21:27:14',3310490756,1),(57603546,424582197,14528405,494030,1,'2007-09-22 21:27:14',3310490756,1),(57603547,424585363,14534413,494030,1,'2007-09-22 21:27:14',3310490756,1),(57603548,424591379,14537847,494030,1,'2007-09-22 21:27:14',3310490756,1),(57603549,424598977,14553296,494030,1,'2007-09-22 21:27:14',3310490756,1),(57603550,424609742,14571750,494030,1,'2007-09-22 21:27:14',3310490759,1),(57603551,424618290,14585054,494030,1,'2007-09-22 21:27:14',3310490759,1),(57603552,424622406,14572179,494030,1,'2007-09-22 21:27:14',3310490759,1),(57603553,424630954,14579904,494030,1,'2007-09-22 21:27:14',3310490770,1),(57603554,424637602,14586341,494030,1,'2007-09-22 21:27:14',3310490770,1),(57603555,424639502,14593637,494030,1,'2007-09-22 21:27:14',3310490770,1),(57603556,424645200,14599645,494030,1,'2007-09-22 21:27:14',3310490770,1),(57603557,424647733,14606082,494030,1,'2007-09-22 21:27:14',3310490770,1),(57603559,424649949,14610374,494030,1,'2007-09-22 21:27:14',3310490770,1),(57603560,424657547,14629256,494030,1,'2007-09-22 21:27:14',3310490777,1),(57603561,424656281,14638269,494030,1,'2007-09-22 21:27:14',3310490777,1),(57603562,424665461,14655006,494030,1,'2007-09-22 21:27:14',3310490777,1),(57603563,424663879,14662730,494030,1,'2007-09-22 21:27:14',3310490777,1),(57603564,424659446,14658010,494030,1,'2007-09-22 21:27:14',3310490777,1),(57603565,424661029,14680326,494030,1,'2007-09-22 21:27:14',3310490779,1),(57603566,424671476,14694488,494030,1,'2007-09-22 21:27:14',3310490779,1),(57603567,424672743,14720666,494030,1,'2007-09-22 21:27:14',3310490779,1),(57603568,424674959,14741695,494030,1,'2007-09-22 21:27:14',3310490801,1),(57603569,424668627,14758431,494030,1,'2007-09-22 21:27:14',3310490801,1),(57603570,424665145,14767873,494030,1,'2007-09-22 21:27:14',3310490801,1),(57603571,424664512,14784610,494030,1,'2007-09-22 21:27:14',3310490803,1),(57603572,424668311,14797484,494030,1,'2007-09-22 21:27:14',3310490803,1),(57603573,424674642,14810359,494030,1,'2007-09-22 21:27:14',3310490803,1),(57603574,424678441,14826667,494030,1,'2007-09-22 21:27:14',3310490803,1),(57603575,424690154,14845120,494030,1,'2007-09-22 21:27:14',3310490812,1),(57603994,424692180,14850099,494030,1,'2007-09-22 21:27:14',3310490812,1),(57603995,424692053,14852416,494030,1,'2007-09-22 21:27:14',3310490812,1),(57603996,424696612,14850442,494030,1,'2007-09-22 21:27:14',3310490812,1),(57603997,424698891,14852674,494030,1,'2007-09-22 21:27:14',3310490812,1),(57603998,424699334,14858853,494030,1,'2007-09-22 21:27:14',3310490812,1),(57603999,424704399,14864175,494030,1,'2007-09-22 21:27:14',3310490812,1),(57604000,424707374,14867265,494030,1,'2007-09-22 21:27:14',3310490812,1),(57604001,424710413,14872415,494030,1,'2007-09-22 21:27:14',3310490812,1),(57604002,424713072,14877307,494030,1,'2007-09-22 21:27:14',3310490813,1),(57604003,424715288,14885203,494030,1,'2007-09-22 21:27:14',3310490813,1),(57604004,424718201,14888894,494030,1,'2007-09-22 21:27:14',3310490815,1),(57604005,424720353,14891469,494030,1,'2007-09-22 21:27:14',3310490815,1),(57604006,424719593,14896190,494030,1,'2007-09-22 21:27:14',3310490815,1),(57607196,424718517,14903743,494030,1,'2007-09-22 21:27:14',3310490815,1),(57607197,424716491,14913613,494030,1,'2007-09-22 21:27:14',3310490815,1),(57607198,424709337,14918592,494030,1,'2007-09-22 21:27:14',3310490814,1),(57607199,424706362,14922626,494030,1,'2007-09-22 21:27:14',3310490814,1),(57607200,424705538,14927175,494030,1,'2007-09-22 21:27:14',3310490814,1),(57607201,424706615,14928033,494030,1,'2007-09-22 21:27:14',3310490814,1),(57607202,424708261,14926660,494030,1,'2007-09-22 21:27:14',3310490814,1),(57607203,424711046,14924600,494030,1,'2007-09-22 21:27:14',3310490815,1),(57607204,424714592,14922883,494030,1,'2007-09-22 21:27:14',3310490815,1),(57607205,424718011,14921166,494030,1,'2007-09-22 21:27:14',3310490815,1),(57607206,424719783,14920480,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608723,424721556,14920737,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608724,424722949,14921166,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608725,424724341,14923656,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608726,424725924,14924256,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608727,424727190,14924171,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608728,424728013,14923398,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608729,424727254,14920737,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608730,424729659,14919879,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608731,424730103,14922025,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608732,424731875,14918334,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608735,424733141,14916617,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608736,424734851,14913871,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608737,424736750,14909494,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608738,424740675,14906146,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608739,424742891,14904258,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608740,424741815,14900653,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608741,424744600,14899795,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608742,424745866,14900224,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608743,424748462,14898593,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608744,424748209,14894645,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608745,424754792,14891383,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608746,424755995,14891126,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608748,424756628,14895417,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608750,424757831,14894216,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608751,424758337,14888465,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608752,424757388,14882886,494030,1,'2007-09-22 21:27:14',3310490856,1),(57608754,424755995,14877393,494030,1,'2007-09-22 21:27:14',3310490856,1),(57608755,424756185,14869840,494030,1,'2007-09-22 21:27:14',3310490856,1),(57608756,424755805,14867093,494030,1,'2007-09-22 21:27:14',3310490856,1),(57608757,424753969,14864432,494030,1,'2007-09-22 21:27:14',3310490856,1),(57608758,424750551,14859883,494030,1,'2007-09-22 21:27:14',3310490856,1),(57608759,424749031,14856708,494030,1,'2007-09-22 21:27:14',3310490856,1),(57608760,424748778,14852931,494030,1,'2007-09-22 21:27:14',3310490856,1),(57608761,424749665,14844434,494030,1,'2007-09-22 21:27:14',3310490856,1),(57608762,424751564,14833104,494030,1,'2007-09-22 21:27:14',3310490856,1),(57608763,424753906,14820487,494030,1,'2007-09-22 21:27:14',3310490850,1),(57608764,424754349,14812848,494030,1,'2007-09-22 21:27:14',3310490850,1),(57608765,424755679,14808557,494030,1,'2007-09-22 21:27:14',3310490850,1),(57608766,424756945,14806840,494030,1,'2007-09-22 21:27:14',3310490850,1),(57608767,424761883,14804008,494030,1,'2007-09-22 21:27:14',3310490850,1),(57608768,424766947,14801261,494030,1,'2007-09-22 21:27:14',3310490851,1),(57608769,424770112,14801347,494030,1,'2007-09-22 21:27:14',3310490851,1),(57608770,424772265,14799716,494030,1,'2007-09-22 21:27:14',3310490851,1),(57608771,424773277,14795940,494030,1,'2007-09-22 21:27:14',3310490851,1),(57608772,424773467,14792850,494030,1,'2007-09-22 21:27:14',3310490851,1),(57608774,424773467,14787786,494030,1,'2007-09-22 21:27:14',3310490851,1),(57608776,424772518,14782636,494030,1,'2007-09-22 21:27:14',3310490851,1),(57608777,424770302,14778945,494030,1,'2007-09-22 21:27:14',3310490851,1),(57608778,424768656,14774739,494030,1,'2007-09-22 21:27:14',3310490849,1),(57611783,424783279,14679210,494030,1,'2007-09-22 21:27:14',3310490827,1),(57611874,424766757,14768302,494030,1,'2007-09-22 21:27:14',3310490849,1),(57611875,424766124,14764869,494030,1,'2007-09-22 21:27:14',3310490849,1),(57611876,424767137,14759376,494030,1,'2007-09-22 21:27:14',3310490849,1),(57611877,424769036,14754741,494030,1,'2007-09-22 21:27:14',3310490849,1),(57611878,424769353,14747016,494030,1,'2007-09-22 21:27:14',3310490849,1),(57611879,424768530,14742038,494030,1,'2007-09-22 21:27:14',3310490849,1),(57611880,424766820,14738261,494030,1,'2007-09-22 21:27:14',3310490849,1),(57611881,424766187,14733712,494030,1,'2007-09-22 21:27:14',3310490849,1),(57611882,424766441,14729163,494030,1,'2007-09-22 21:27:14',3310490849,1),(57611883,424769416,14723928,494030,1,'2007-09-22 21:27:14',3310490849,1),(57611884,424772391,14717748,494030,1,'2007-09-22 21:27:14',3310490827,1),(57611885,424773847,14713199,494030,1,'2007-09-22 21:27:14',3310490827,1),(57611886,424772771,14706246,494030,1,'2007-09-22 21:27:14',3310490827,1),(57611887,424773341,14700667,494030,1,'2007-09-22 21:27:14',3310490827,1),(57611888,424774670,14695432,494030,1,'2007-09-22 21:27:14',3310490827,1),(57611889,424773594,14691312,494030,1,'2007-09-22 21:27:14',3310490827,1),(57611890,424773531,14687707,494030,1,'2007-09-22 21:27:14',3310490827,1),(57611891,424775113,14685475,494030,1,'2007-09-22 21:27:14',3310490827,1),(57627518,424789863,14372193,494030,1,'2007-09-22 21:27:14',3310490723,1),(57627519,424781950,14381635,494030,1,'2007-09-22 21:27:14',3310490723,1),(57627521,424775936,14390647,494030,1,'2007-09-22 21:27:14',3310490723,1),(58865012,425232394,15214414,461502,1,'2008-05-16 18:38:38',3310491492,2),(58865013,425228789,15216302,461502,1,'2008-05-16 18:38:38',3310491491,2),(58957648,425069391,15212467,2395774,1,'2009-09-06 23:32:08',3310491440,19),(58963219,425561500,15334945,225225,1,'2008-04-23 01:45:02',3310502459,3),(59015921,425362733,15740530,502899,1,'2007-09-23 18:56:30',3310491644,1),(59015924,425364441,15746109,502899,1,'2007-09-23 18:56:30',3310491644,1),(59015925,425365136,15749886,502899,1,'2007-09-23 18:56:30',3310491644,1),(59015926,425364694,15751259,502899,1,'2007-09-23 18:56:35',3310491644,1),(59015927,425362860,15750830,502899,1,'2007-09-23 18:56:30',3310491644,1),(59015928,425359002,15749886,502899,1,'2007-09-23 18:56:30',3310491644,1),(59015929,425355903,15750401,502899,1,'2007-09-23 18:56:30',3310491644,1),(59015930,425352108,15752718,502899,1,'2007-09-23 18:56:30',3310491644,1),(59015931,425349452,15753920,502899,1,'2007-09-23 18:56:30',3310491644,1),(59015932,425344455,15754606,502899,1,'2007-09-23 18:56:30',3310491644,1),(59015933,425342305,15755550,502899,1,'2007-09-23 18:56:30',3310491644,1),(59015934,425341015,15757717,370566,1,'2008-05-09 02:01:18',3310491641,2),(59016173,425364378,15766966,502899,1,'2007-09-23 18:56:35',3310491646,1),(59016174,425365010,15761215,502899,1,'2007-09-23 18:56:35',3310491644,1),(59016175,425365326,15754435,502899,1,'2007-09-23 18:56:35',3310491644,1),(59632226,424762308,14904936,538211,1,'2007-09-30 15:36:19',3310490858,1),(64796296,425132657,15354227,104599,1,'2007-10-11 20:25:12',3310491454,1),(64796297,425132424,15356646,104599,1,'2007-10-11 20:25:13',3310491454,1),(64796301,425130935,15357996,104599,1,'2007-10-11 20:25:13',3310491454,1),(64796302,425129167,15359205,104599,1,'2007-10-11 20:25:13',3310491454,1),(64796303,425127818,15359391,104599,1,'2007-10-11 20:25:13',3310491454,1),(64796304,425126283,15359578,104599,1,'2007-10-11 20:25:13',3310491454,1),(64796308,425125445,15359857,104599,1,'2007-10-11 20:25:13',3310491454,1),(64796309,425124235,15361113,104599,1,'2007-10-11 20:25:13',3310491454,1),(64796310,425122607,15362276,104599,1,'2007-10-11 20:25:13',3310491454,1),(64796311,425121025,15362555,104599,1,'2007-10-11 20:25:13',3310491451,1),(64796315,425119304,15362695,104599,1,'2007-10-11 20:25:13',3310491451,1),(64796316,425116559,15363579,104599,1,'2007-10-11 20:25:13',3310491451,1),(64796317,425131819,15354227,104599,1,'2007-10-11 20:25:14',3310491454,1),(64796318,425131168,15356228,104599,1,'2007-10-11 20:25:14',3310491454,1),(64796322,425129586,15357391,104599,1,'2007-10-11 20:25:14',3310491454,1),(64796323,425128144,15357530,104599,1,'2007-10-11 20:25:14',3310491454,1),(64796324,425126376,15357996,104599,1,'2007-10-11 20:25:14',3310491454,1),(64796325,425125399,15358926,104599,1,'2007-10-11 20:25:14',3310491454,1),(64796329,425123770,15359950,104599,1,'2007-10-11 20:25:14',3310491454,1),(64796330,425122188,15360787,104599,1,'2007-10-11 20:25:14',3310491451,1),(64796331,425120467,15361113,104599,1,'2007-10-11 20:25:14',3310491451,1),(64796332,425119350,15361159,104599,1,'2007-10-11 20:25:14',3310491451,1),(64796335,425116419,15362043,104599,1,'2007-10-11 20:25:14',3310491451,1),(64796337,425115302,15362881,104599,1,'2007-10-11 20:25:14',3310491451,1),(64796338,425114560,15365030,104599,1,'2007-10-11 20:25:14',3310491451,1),(64796339,425115096,15362872,104599,1,'2007-10-11 20:25:15',3310491451,1),(64796340,425133413,15345948,104599,1,'2007-10-11 20:25:15',3310491454,1),(64796344,425133767,15342620,104599,1,'2007-10-11 20:25:15',3310491454,1),(64796345,425133884,15340618,104599,1,'2007-10-11 20:25:15',3310491454,1),(64796346,425133590,15339145,104599,1,'2007-10-11 20:25:15',3310491454,1),(64796349,425132682,15336256,104599,1,'2007-10-11 20:25:15',3310491454,1),(64796351,425131919,15333559,104599,1,'2007-10-11 20:25:15',3310491454,1),(64796352,425132021,15332236,104599,1,'2007-10-11 20:25:15',3310491454,1),(64796353,425134413,15329132,104599,1,'2007-10-11 20:25:15',3310491454,1),(64796356,425138128,15324297,104599,1,'2007-10-11 20:25:15',3310491452,1),(64796358,425141944,15319412,104599,1,'2007-10-11 20:25:15',3310491452,1),(64796359,425145507,15315493,104599,1,'2007-10-11 20:25:16',3310491452,1),(64796360,425148051,15312236,104599,1,'2007-10-11 20:25:16',3310491452,1),(64796363,425150545,15308470,104599,1,'2007-10-11 20:25:16',3310491453,1),(64796365,425153140,15303941,104599,1,'2007-10-11 20:25:16',3310491453,1),(64796366,425154565,15299514,104599,1,'2007-10-11 20:25:16',3310491453,1),(64796367,425156702,15296409,104599,1,'2007-10-11 20:25:16',3310491453,1),(64796368,425132394,15348907,104599,1,'2007-10-11 20:25:16',3310491454,1),(64796372,425132941,15344426,104599,1,'2007-10-11 20:25:16',3310491454,1),(64796373,425133175,15341971,104599,1,'2007-10-11 20:25:16',3310491454,1),(64796374,425132800,15339307,104599,1,'2007-10-11 20:25:16',3310491454,1),(64796375,425131787,15335856,104599,1,'2007-10-11 20:25:16',3310491454,1),(64796376,425131524,15333679,104599,1,'2007-10-11 20:25:16',3310491454,1),(64796377,425131562,15331803,104599,1,'2007-10-11 20:25:16',3310491454,1),(64796381,425134526,15327564,104599,1,'2007-10-11 20:25:17',3310491454,1),(64796382,425136890,15324750,104599,1,'2007-10-11 20:25:17',3310491452,1),(64796383,425145032,15314882,104599,1,'2007-10-11 20:25:17',3310491452,1),(64796385,425146608,15312631,104599,1,'2007-10-11 20:25:17',3310491452,1),(64796388,425149234,15309029,104599,1,'2007-10-11 20:25:17',3310491452,1),(64798267,425151141,15305949,104599,1,'2007-10-11 20:28:37',3310491453,1),(64798268,425152543,15303081,104599,1,'2007-10-11 20:28:37',3310491453,1),(64798270,425153372,15300595,104599,1,'2007-10-11 20:28:38',3310491453,1),(64798271,425154073,15298364,104599,1,'2007-10-11 20:28:38',3310491453,1),(64798274,425156718,15294923,104599,1,'2007-10-11 20:28:38',3310491453,1),(64798275,425160446,15290206,104599,1,'2007-10-11 20:28:38',3310491453,1),(64798277,425162538,15287952,104599,1,'2007-10-11 20:28:38',3310491453,1),(64798278,425163592,15285931,104599,1,'2007-10-11 20:28:38',3310491453,1),(64798280,425163987,15283208,104599,1,'2007-10-11 20:28:38',3310491453,1),(64798282,425164119,15280879,104599,1,'2007-10-11 20:28:38',3310491453,1),(64798283,425165613,15277013,104599,1,'2007-10-11 20:28:38',3310491453,1),(64798285,425168161,15271829,104599,1,'2007-10-11 20:28:38',3310491453,1),(64798286,425169611,15268886,104599,1,'2007-10-11 20:28:38',3310491447,1),(64798289,425170973,15266206,104599,1,'2007-10-11 20:28:38',3310491447,1),(64798290,425172598,15261900,104599,1,'2007-10-11 20:28:38',3310491447,1),(64798291,425173565,15259089,104599,1,'2007-10-11 20:28:39',3310491447,1),(64798293,425174399,15257815,104599,1,'2007-10-11 20:28:39',3310491447,1),(64798295,425176101,15256038,104599,1,'2007-10-11 20:28:39',3310491447,1),(64798297,425159023,15293664,104599,1,'2007-10-11 20:28:39',3310491453,1),(64798298,425161571,15290764,104599,1,'2007-10-11 20:28:39',3310491453,1),(64798300,425164163,15287469,104599,1,'2007-10-11 20:28:39',3310491453,1),(64798301,425164646,15285975,104599,1,'2007-10-11 20:28:39',3310491453,1),(64798304,425164954,15284438,104599,1,'2007-10-11 20:28:39',3310491453,1),(64798305,425165086,15282065,104599,1,'2007-10-11 20:28:39',3310491453,1),(64798306,425165393,15279957,104599,1,'2007-10-11 20:28:39',3310491453,1),(64798308,425166755,15276530,104599,1,'2007-10-11 20:28:39',3310491453,1),(64798310,425170446,15268974,104599,1,'2007-10-11 20:28:39',3310491447,1),(64798312,425172906,15262999,104599,1,'2007-10-11 20:28:39',3310491447,1),(64798313,425174619,15259528,104599,1,'2007-10-11 20:28:39',3310491447,1),(64798315,425176978,15256814,461502,1,'2008-05-16 18:46:06',3310491447,3),(64798316,425178244,15255269,461502,1,'2008-05-16 18:46:06',3310491490,3),(64798319,425179193,15254325,461502,1,'2008-05-16 18:45:35',3310491490,2),(64798320,425179635,15253553,461502,1,'2008-05-16 18:45:35',3310491490,2),(64798321,425180078,15253209,461502,1,'2008-05-16 18:45:35',3310491490,2),(64798323,425181187,15251602,104599,1,'2007-10-11 20:28:40',3310491490,1),(64798324,425182531,15249997,104599,1,'2007-10-11 20:28:40',3310491490,1),(64798327,425184886,15246772,461502,1,'2008-05-16 18:44:26',3310491490,2),(64798328,425187796,15241708,461502,1,'2008-05-16 18:48:52',3310491490,3),(64798329,425189504,15239476,461502,1,'2008-05-16 18:43:30',3310491490,2),(64798331,425192035,15237588,461502,1,'2008-05-16 18:43:30',3310491490,2),(64798333,425193363,15236987,461502,1,'2008-05-16 18:43:30',3310491490,2),(64798335,425196210,15236558,461502,1,'2008-05-16 18:40:59',3310491490,2),(64798336,425177105,15254497,461502,1,'2008-05-16 18:45:35',3310491447,2),(64798337,425178433,15253038,461502,1,'2008-05-16 18:45:35',3310491490,2),(64798339,425180516,15251117,104599,1,'2007-10-11 20:28:41',3310491490,1),(64798342,425181850,15249261,461502,1,'2008-05-16 18:44:26',3310491490,2),(64798343,425183305,15247373,461502,1,'2008-05-16 18:44:26',3310491490,2),(64798344,425184570,15245485,461502,1,'2008-05-16 18:44:26',3310491490,2),(64798345,425186341,15242652,461502,1,'2008-05-16 18:48:52',3310491490,3),(64798347,425187290,15240850,461502,1,'2008-05-16 18:48:52',3310491490,3),(64798350,425188302,15239047,461502,1,'2008-05-16 18:48:52',3310491490,3),(64798351,425189568,15238017,461502,1,'2008-05-16 18:43:30',3310491490,2),(64798352,425190327,15237502,461502,1,'2008-05-16 18:43:30',3310491490,2),(64801605,425191086,15236902,461502,1,'2008-05-16 18:43:30',3310491490,2),(64801639,425192161,15236301,461502,1,'2008-05-16 18:43:30',3310491490,2),(64801640,425193110,15235786,461502,1,'2008-05-16 18:43:30',3310491490,2),(64801644,425194565,15235442,461502,1,'2008-05-16 18:43:30',3310491490,2),(64801645,425196337,15235271,461502,1,'2008-05-16 18:40:59',3310491490,2),(64801646,425198108,15234756,461502,1,'2008-05-16 18:40:59',3310491490,2),(64801648,425200196,15234327,461502,1,'2008-05-16 18:40:59',3310491490,2),(64801651,425202093,15233983,461502,1,'2008-05-16 18:40:59',3310491490,2),(64801652,425203106,15233640,461502,1,'2008-05-16 18:40:59',3310491490,2),(64801654,425203928,15232868,461502,1,'2008-05-16 18:40:59',3310491490,2),(64801657,425205003,15232095,461502,1,'2008-05-16 18:40:59',3310491491,2),(64801659,425205912,15231953,104599,1,'2007-10-11 20:34:37',3310491491,1),(64801660,425207470,15231065,461502,1,'2008-05-16 18:38:58',3310491491,2),(64801663,425209558,15230636,461502,1,'2008-05-16 18:38:58',3310491491,2),(64801667,425210760,15229778,461502,1,'2008-05-16 18:38:58',3310491491,2),(64801670,425212238,15228480,104599,1,'2007-10-11 20:34:41',3310491491,1),(64801672,425213018,15227161,104599,1,'2007-10-11 20:34:41',3310491491,1),(64801673,425214391,15224577,104599,1,'2007-10-11 20:34:41',3310491491,1),(64801675,425215414,15222235,104599,1,'2007-10-11 20:34:41',3310491491,1),(64801678,425217110,15220486,104599,1,'2007-10-11 20:34:41',3310491491,1),(64801679,425198298,15235957,461502,1,'2008-05-16 18:40:59',3310491490,2),(64801681,425200702,15235786,461502,1,'2008-05-16 18:40:59',3310491490,2),(64801684,425202144,15235344,104599,1,'2007-10-11 20:34:42',3310491490,1),(64801685,425204001,15234133,104599,1,'2007-10-11 20:34:42',3310491490,1),(64801686,425205347,15232975,104599,1,'2007-10-11 20:34:42',3310491491,1),(64801688,425207204,15232356,104599,1,'2007-10-11 20:34:42',3310491491,1),(64801690,425207446,15232222,104599,1,'2007-10-11 20:34:42',3310491491,1),(64801693,425208989,15231752,461502,1,'2008-05-16 18:38:58',3310491491,2),(64801694,425211076,15230893,461502,1,'2008-05-16 18:38:58',3310491491,2),(64801695,425211969,15230041,104599,1,'2007-10-11 20:34:42',3310491491,1),(64801697,425213503,15228319,104599,1,'2007-10-11 20:34:42',3310491491,1),(64801702,425214176,15226542,104599,1,'2007-10-11 20:34:42',3310491491,1),(64801703,425215226,15224227,104599,1,'2007-10-11 20:34:43',3310491491,1),(64801704,425215683,15223447,104599,1,'2007-10-11 20:34:43',3310491491,1),(64801705,425216921,15221374,104599,1,'2007-10-11 20:34:43',3310491491,1),(64801709,425217487,15220889,104599,1,'2007-10-11 20:34:43',3310491491,1),(64801710,425218563,15220997,104599,1,'2007-10-11 20:34:43',3310491491,1),(64801711,425220017,15219974,104599,1,'2007-10-11 20:34:43',3310491491,1),(64801712,425221794,15218521,104599,1,'2007-10-11 20:34:43',3310491491,1),(64801714,425222978,15218117,104599,1,'2007-10-11 20:34:43',3310491491,1),(64801717,425224243,15217686,104599,1,'2007-10-11 20:34:43',3310491491,1),(64801718,425225499,15217246,461502,1,'2008-05-16 18:37:37',3310491491,2),(64801719,425227144,15216388,461502,1,'2008-05-16 18:37:37',3310491491,2),(64801721,425229485,15215186,461502,1,'2008-05-16 18:37:37',3310491489,2),(64801724,425232964,15213384,461502,1,'2008-05-16 18:37:37',3310491492,2),(64801725,425236000,15211238,461502,1,'2008-05-16 18:37:37',3310491492,2),(64801729,425219479,15218628,104599,1,'2007-10-11 20:34:44',3310491491,1),(64801739,425221363,15217013,104599,1,'2007-10-11 20:34:45',3310491491,1),(64801740,425222526,15216646,461502,1,'2008-05-16 18:37:37',3310491491,2),(64801741,425223222,15216560,461502,1,'2008-05-16 18:37:37',3310491491,2),(64801745,425225246,15216131,461502,1,'2008-05-16 18:37:37',3310491489,2),(64801746,425227966,15214414,461502,1,'2008-05-16 18:37:37',3310491489,2),(64801747,425230750,15212869,461502,1,'2008-05-16 18:37:37',3310491489,2),(64801748,425233660,15211324,461502,1,'2008-05-16 18:37:37',3310491492,2),(64801751,425235494,15210037,461502,1,'2008-05-16 18:37:37',3310491492,2),(64801753,425236443,15208921,461502,1,'2008-05-16 18:37:37',3310491492,2),(64801754,425237514,15207296,104599,1,'2007-10-11 20:34:46',3310491492,1),(64801758,425239258,15205576,104599,1,'2007-10-11 20:34:46',3310491492,1),(64801759,425241470,15204825,104599,1,'2007-10-11 20:34:46',3310491492,1),(64801761,425243999,15204588,104599,1,'2007-10-11 20:34:46',3310491492,1),(64801762,425245935,15205062,104599,1,'2007-10-11 20:34:46',3310491492,1),(64801766,425249885,15207511,104599,1,'2007-10-11 20:34:46',3310491492,1),(64801770,425253441,15209131,104599,1,'2007-10-11 20:34:48',3310491492,1),(64801773,425237796,15208934,104599,1,'2007-10-11 20:34:48',3310491492,1),(64801774,425238784,15207709,104599,1,'2007-10-11 20:34:49',3310491492,1),(64801778,425240483,15206129,104599,1,'2007-10-11 20:34:50',3310491492,1),(64801779,425243209,15205259,104599,1,'2007-10-11 20:34:50',3310491492,1),(64801780,425244987,15206089,104599,1,'2007-10-11 20:34:50',3310491492,1),(64801785,425247950,15207906,104599,1,'2007-10-11 20:34:50',3310491492,1),(64801795,425250912,15209447,104599,1,'2007-10-11 20:34:52',3310491492,1),(64801802,425253520,15210435,104599,1,'2007-10-11 20:34:52',3310491492,1),(64801803,425256443,15210909,104599,1,'2007-10-11 20:34:53',3310491492,1),(64801804,425258972,15210672,104599,1,'2007-10-11 20:34:53',3310491492,1),(64801805,425262290,15209566,104599,1,'2007-10-11 20:34:53',3310491493,1),(64801809,425255416,15209763,104599,1,'2007-10-11 20:34:54',3310491492,1),(64801810,425257589,15209645,104599,1,'2007-10-11 20:34:54',3310491492,1),(64801811,425260236,15209052,104599,1,'2007-10-11 20:34:54',3310491493,1),(64801812,425264029,15207985,104599,1,'2007-10-11 20:34:54',3310491493,1),(64801816,425268493,15207235,104599,1,'2007-10-11 20:34:54',3310491493,1),(64801817,425272127,15207156,104599,1,'2007-10-11 20:34:54',3310491493,1),(64801818,425274695,15207788,104599,1,'2007-10-11 20:34:54',3310491493,1),(64801819,425276671,15209882,104599,1,'2007-10-11 20:34:54',3310491493,1),(64803147,425278465,15210401,104599,1,'2007-10-11 20:37:49',3310491493,1),(64803150,425280929,15210715,104599,1,'2007-10-11 20:37:49',3310491493,1),(64803152,425283079,15211292,104599,1,'2007-10-11 20:37:49',3310491493,1),(64803153,425284547,15212498,104599,1,'2007-10-11 20:37:49',3310491493,1),(64803154,425285386,15213232,104599,1,'2007-10-11 20:37:49',3310491493,1),(64803157,425287588,15214490,104599,1,'2007-10-11 20:37:49',3310491504,1),(64803159,425288793,15214805,104599,1,'2007-10-11 20:37:49',3310491504,1),(64803160,425289265,15215434,104599,1,'2007-10-11 20:37:49',3310491504,1),(64803161,425291362,15217898,104599,1,'2007-10-11 20:37:50',3310491506,1),(64803162,425292254,15218580,104599,1,'2007-10-11 20:37:50',3310491506,1),(64803165,425294613,15218632,104599,1,'2007-10-11 20:37:50',3310491506,1),(64803167,425297130,15217950,104599,1,'2007-10-11 20:37:50',3310491506,1),(64803168,425290542,15216407,104599,1,'2007-10-11 20:37:50',3310491506,1),(64803169,425264994,15208918,104599,1,'2007-10-11 20:37:50',3310491493,1),(64803172,425268451,15208080,104599,1,'2007-10-11 20:37:50',3310491493,1),(64803174,425271372,15207865,104599,1,'2007-10-11 20:37:50',3310491493,1),(64803175,425273992,15208230,104599,1,'2007-10-11 20:37:50',3310491493,1),(64803176,425275259,15209626,104599,1,'2007-10-11 20:37:50',3310491493,1),(64803177,425276719,15211108,104599,1,'2007-10-11 20:37:50',3310491493,1),(64803180,425278695,15211602,104599,1,'2007-10-11 20:37:50',3310491493,1),(64803182,425280992,15211774,104599,1,'2007-10-11 20:37:50',3310491493,1),(64803183,425283054,15212289,104599,1,'2007-10-11 20:37:50',3310491493,1),(64803184,425284557,15213492,104599,1,'2007-10-11 20:37:51',3310491493,1),(64803185,425286189,15215210,104599,1,'2007-10-11 20:37:51',3310491493,1),(64803188,425287993,15215918,104599,1,'2007-10-11 20:37:51',3310491504,1),(64803190,425289411,15216541,104599,1,'2007-10-11 20:37:51',3310491506,1),(64803191,425290742,15217830,104599,1,'2007-10-11 20:37:51',3310491506,1),(64803192,425291558,15219591,104599,1,'2007-10-11 20:37:51',3310491506,1),(64803195,425292610,15220192,104599,1,'2007-10-11 20:37:51',3310491506,1),(64803197,425294908,15220213,104599,1,'2007-10-11 20:37:51',3310491506,1),(64803198,425296003,15219698,104599,1,'2007-10-11 20:37:51',3310491506,1),(64803199,425297249,15218517,104599,1,'2007-10-11 20:37:51',3310491506,1),(64840709,425298921,15215927,104599,1,'2007-10-11 21:16:14',3310491504,1),(64840717,425300252,15214684,104599,1,'2007-10-11 21:16:14',3310491504,1),(64840721,425301628,15214574,104599,1,'2007-10-11 21:16:14',3310491504,1),(64840726,425303269,15213997,104599,1,'2007-10-11 21:16:14',3310491504,1),(64840730,425305577,15213065,104599,1,'2007-10-11 21:16:15',3310491504,1),(64840732,425306486,15212133,104599,1,'2007-10-11 21:16:15',3310491504,1),(64840738,425308417,15210669,104599,1,'2007-10-11 21:16:15',3310491504,1),(64840741,425309850,15209532,104599,1,'2007-10-11 21:16:15',3310491504,1),(64840744,425312661,15208126,104599,1,'2007-10-11 21:16:15',3310491504,1),(64840746,425315441,15207519,104599,1,'2007-10-11 21:16:15',3310491505,1),(64840750,425316686,15207551,104599,1,'2007-10-11 21:16:15',3310491505,1),(64840753,425320456,15209436,104599,1,'2007-10-11 21:16:15',3310491505,1),(64840755,425323747,15211609,104599,1,'2007-10-11 21:16:15',3310491505,1),(64840758,425325600,15212184,104599,1,'2007-10-11 21:16:15',3310491505,1),(64840759,425327836,15211864,104599,1,'2007-10-11 21:16:15',3310491505,1),(64840761,425330200,15210139,104599,1,'2007-10-11 21:16:15',3310491505,1),(64840762,425333906,15206465,104599,1,'2007-10-11 21:16:15',3310491505,1),(64840767,425334545,15205347,104599,1,'2007-10-11 21:16:15',3310491505,1),(64840769,425336206,15204996,104599,1,'2007-10-11 21:16:16',3310491505,1),(64840773,425338091,15205922,104599,1,'2007-10-11 21:16:16',3310491505,1),(64840778,425340104,15207264,104599,1,'2007-10-11 21:16:16',3310491505,1),(64840781,425299978,15215985,104599,1,'2007-10-11 21:16:16',3310491504,1),(64840785,425301543,15215251,104599,1,'2007-10-11 21:16:16',3310491504,1),(64840790,425303205,15215251,104599,1,'2007-10-11 21:16:16',3310491504,1),(64840792,425304451,15214899,104599,1,'2007-10-11 21:16:16',3310491504,1),(64840793,425307294,15213110,104599,1,'2007-10-11 21:16:16',3310491504,1),(64840797,425309530,15211002,104599,1,'2007-10-11 21:16:16',3310491504,1),(64840799,425312469,15209756,104599,1,'2007-10-11 21:16:16',3310491504,1),(64840802,425315121,15208829,104599,1,'2007-10-11 21:16:16',3310491505,1),(64840806,425316974,15208638,104599,1,'2007-10-11 21:16:16',3310491505,1),(64840812,425319051,15209660,104599,1,'2007-10-11 21:16:16',3310491505,1),(64840816,425322437,15212088,104599,1,'2007-10-11 21:16:17',3310491505,1),(64840820,425324993,15213206,104599,1,'2007-10-11 21:16:17',3310491505,1),(64840823,425326814,15213110,104599,1,'2007-10-11 21:16:17',3310491505,1),(64840828,425328315,15212759,104599,1,'2007-10-11 21:16:17',3310491505,1),(64840832,425330200,15210906,104599,1,'2007-10-11 21:16:17',3310491505,1),(64840836,425332980,15208414,104599,1,'2007-10-11 21:16:17',3310491505,1),(64840839,425335280,15205986,104599,1,'2007-10-11 21:16:17',3310491505,1),(64840843,425336494,15205762,104599,1,'2007-10-11 21:16:17',3310491505,1),(64840848,425338027,15206561,104599,1,'2007-10-11 21:16:17',3310491505,1),(64840849,425340040,15207743,104599,1,'2007-10-11 21:16:17',3310491505,1),(64840854,425343871,15209679,104599,1,'2007-10-11 21:16:17',3310491508,1),(64840858,425345437,15211839,104599,1,'2007-10-11 21:16:18',3310491508,1),(64840861,425346410,15214972,104599,1,'2007-10-11 21:16:18',3310491508,1),(64840865,425347004,15217079,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840868,425348462,15219888,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840872,425349921,15221508,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840877,425352621,15222750,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840882,425354026,15223182,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840886,425355808,15224641,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840890,425358833,15227288,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840895,425361426,15229826,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840899,425363046,15229880,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840903,425363424,15229016,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840907,425363694,15227720,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840911,425365801,15223885,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840916,425368070,15222210,104599,1,'2007-10-11 21:16:19',3310491510,1),(64840918,425343021,15209781,104599,1,'2007-10-11 21:16:19',3310491508,1),(64840922,425344930,15211717,104599,1,'2007-10-11 21:16:19',3310491508,1),(64840923,425345621,15213929,104599,1,'2007-10-11 21:16:19',3310491508,1),(64840926,425346036,15216888,104599,1,'2007-10-11 21:16:19',3310491510,1),(64840929,425347585,15220235,104599,1,'2007-10-11 21:16:19',3310491510,1),(64840932,425348552,15222087,104599,1,'2007-10-11 21:16:19',3310491510,1),(64840933,425350295,15223691,104599,1,'2007-10-11 21:16:19',3310491510,1),(64840934,425353724,15224853,104599,1,'2007-10-11 21:16:19',3310491510,1),(64840936,425355632,15225959,104599,1,'2007-10-11 21:16:19',3310491510,1),(64840940,425357845,15227785,104599,1,'2007-10-11 21:16:19',3310491510,1),(64840946,425359790,15230538,104599,1,'2007-10-11 21:16:19',3310491510,1),(64840950,425362080,15231560,104599,1,'2007-10-11 21:16:19',3310491510,1),(64840954,425363102,15230961,104599,1,'2007-10-11 21:16:19',3310491510,1),(64840959,425364264,15228847,104599,1,'2007-10-11 21:16:20',3310491510,1),(64840961,425365568,15226839,104599,1,'2007-10-11 21:16:20',3310491510,1),(64840965,425367647,15224020,104599,1,'2007-10-11 21:16:20',3310491510,1),(64840968,425368669,15222998,104599,1,'2007-10-11 21:16:20',3310491510,1),(64840971,425370392,15220659,104599,1,'2007-10-11 21:16:20',3310491511,1),(64840975,425372679,15220326,104599,1,'2007-10-11 21:16:20',3310491511,1),(64840979,425374681,15219659,104599,1,'2007-10-11 21:16:20',3310491511,1),(64840982,425376301,15217991,104599,1,'2007-10-11 21:16:20',3310491511,1),(64840985,425378255,15214941,104599,1,'2007-10-11 21:16:20',3310491509,1),(64840987,425381973,15210508,104599,1,'2007-10-11 21:16:20',3310491509,1),(64840992,425383545,15209269,104599,1,'2007-10-11 21:16:20',3310491509,1),(64840996,425386119,15207935,104599,1,'2007-10-11 21:16:20',3310491509,1),(64840997,425388264,15207172,104599,1,'2007-10-11 21:16:20',3310491509,1),(64840998,425389360,15207554,104599,1,'2007-10-11 21:16:20',3310491509,1),(64841000,425392505,15207506,104599,1,'2007-10-11 21:16:21',3310491509,1),(64841005,425395746,15207506,104599,1,'2007-10-11 21:16:21',3310491509,1),(64841007,425397319,15208602,104599,1,'2007-10-11 21:16:21',3310502432,1),(64841008,425399320,15209793,104599,1,'2007-10-11 21:16:21',3310502432,1),(64841013,425401608,15209936,104599,1,'2007-10-11 21:16:21',3310502432,1),(64841018,425402656,15209793,104599,1,'2007-10-11 21:16:21',3310502432,1),(64841023,425405182,15207887,104599,1,'2007-10-11 21:16:21',3310502432,1),(64841026,425406802,15206696,104599,1,'2007-10-11 21:16:21',3310502432,1),(64841028,425407660,15205457,104599,1,'2007-10-11 21:16:21',3310502432,1),(64841033,425369963,15222042,104599,1,'2007-10-11 21:16:21',3310491511,1),(64841037,425372251,15221613,104599,1,'2007-10-11 21:16:21',3310491511,1),(64841039,425375587,15220659,104599,1,'2007-10-11 21:16:21',3310491511,1),(64841042,425377207,15218658,104599,1,'2007-10-11 21:16:21',3310491511,1),(64841046,425379876,15214655,104599,1,'2007-10-11 21:16:22',3310491509,1),(64841049,425383021,15211080,104599,1,'2007-10-11 21:16:22',3310491509,1),(64841051,425384975,15209651,104599,1,'2007-10-11 21:16:22',3310491509,1),(64841053,425386167,15208936,104599,1,'2007-10-11 21:16:22',3310491509,1),(64841057,425388978,15208507,104599,1,'2007-10-11 21:16:22',3310491509,1),(64841061,425392886,15208602,104599,1,'2007-10-11 21:16:22',3310491509,1),(64841066,425395698,15208888,104599,1,'2007-10-11 21:16:22',3310491509,1),(64841070,425397128,15209889,104599,1,'2007-10-11 21:16:22',3310502432,1),(64841074,425399749,15211271,104599,1,'2007-10-11 21:16:22',3310502432,1),(64841080,425401369,15211509,104599,1,'2007-10-11 21:16:22',3310502432,1),(64841084,425403180,15211509,104599,1,'2007-10-11 21:16:22',3310502432,1),(64841088,425405134,15210032,104599,1,'2007-10-11 21:16:22',3310502432,1),(64841091,425407279,15207697,104599,1,'2007-10-11 21:16:22',3310502432,1),(64841092,425408232,15206505,104599,1,'2007-10-11 21:16:22',3310502432,1),(64841094,425409270,15203779,104599,1,'2007-10-11 21:16:23',3310502432,1),(64841097,425410322,15201998,104599,1,'2007-10-11 21:16:23',3310502432,1),(64841099,425412710,15199853,104599,1,'2007-10-11 21:16:23',3310502432,1),(64841100,425415018,15196574,104599,1,'2007-10-11 21:16:23',3310502432,1),(64841101,425418094,15192445,104599,1,'2007-10-11 21:16:23',3310502432,1),(64841105,425420523,15188802,104599,1,'2007-10-11 21:16:23',3310502432,1),(64841106,425422304,15186373,104599,1,'2007-10-11 21:16:23',3310502432,1),(64841108,425423963,15185442,104599,1,'2007-10-11 21:16:23',3310502432,1),(64841109,425425258,15185442,104599,1,'2007-10-11 21:16:23',3310502433,1),(64841113,425428659,15185240,104599,1,'2007-10-11 21:16:23',3310502433,1),(64841115,425430359,15185078,104599,1,'2007-10-11 21:16:23',3310502433,1),(64841118,425432423,15183742,104599,1,'2007-10-11 21:16:23',3310502433,1),(64841119,425435216,15180828,104599,1,'2007-10-11 21:16:23',3310502433,1),(64841120,425437361,15177671,104599,1,'2007-10-11 21:16:24',3310502433,1),(64841123,425439345,15175728,104599,1,'2007-10-11 21:16:24',3310502433,1),(64841125,425441085,15175566,104599,1,'2007-10-11 21:16:24',3310502433,1),(64841128,425442057,15175242,104599,1,'2007-10-11 21:16:24',3310502433,1),(64841129,425443433,15174271,104599,1,'2007-10-11 21:16:24',3310502433,1),(64841132,425445295,15173178,104599,1,'2007-10-11 21:16:24',3310502433,1),(64841134,425446590,15172328,104599,1,'2007-10-11 21:16:24',3310502433,1),(64841136,425448209,15170304,104599,1,'2007-10-11 21:16:24',3310502433,1),(64841139,425449262,15169049,104599,1,'2007-10-11 21:16:24',3310502433,1);
INSERT INTO `current_nodes` VALUES (64841145,425450881,15167551,104599,1,'2007-10-11 21:16:24',3310502433,1),(64841148,425409909,15204469,104599,1,'2007-10-11 21:16:24',3310502432,1),(64841151,425412760,15201425,104599,1,'2007-10-11 21:16:25',3310502432,1),(64841154,425414593,15199362,104599,1,'2007-10-11 21:16:25',3310502432,1),(64841158,425416914,15196296,104599,1,'2007-10-11 21:16:25',3310502432,1),(64841162,425419550,15192601,104599,1,'2007-10-11 21:16:25',3310502432,1),(64841165,425421613,15189363,104599,1,'2007-10-11 21:16:25',3310502432,1),(64841166,425423274,15187186,104599,1,'2007-10-11 21:16:25',3310502432,1),(64841169,425424306,15186441,104599,1,'2007-10-11 21:16:25',3310502432,1),(64841177,425426168,15186326,104599,1,'2007-10-11 21:16:25',3310502433,1),(64841180,425428202,15186670,104599,1,'2007-10-11 21:16:25',3310502433,1),(64841183,425429864,15186641,104599,1,'2007-10-11 21:16:25',3310502433,1),(64841185,425432671,15184779,104599,1,'2007-10-11 21:16:25',3310502433,1),(64841188,425436482,15180940,104599,1,'2007-10-11 21:16:25',3310502433,1),(64841191,425439003,15178046,104599,1,'2007-10-11 21:16:25',3310502433,1),(64841194,425441381,15176557,104599,1,'2007-10-11 21:16:25',3310502433,1),(64841197,425443386,15175840,104599,1,'2007-10-11 21:16:26',3310502433,1),(64841198,425444876,15174981,104599,1,'2007-10-11 21:16:26',3310502433,1),(64841202,425446337,15173950,104599,1,'2007-10-11 21:16:26',3310502433,1),(64841205,425447856,15172947,104599,1,'2007-10-11 21:16:26',3310502433,1),(64841208,425449174,15171142,104599,1,'2007-10-11 21:16:26',3310502433,1),(64841211,425450893,15169452,104599,1,'2007-10-11 21:16:26',3310502433,1),(64841215,425453643,15166300,104599,1,'2007-10-11 21:16:26',3310502436,1),(64841220,425456737,15162977,104599,1,'2007-10-11 21:16:26',3310502436,1),(64841224,425458084,15160484,104599,1,'2007-10-11 21:16:26',3310502414,1),(64841229,425458571,15158622,104599,1,'2007-10-11 21:16:26',3310502414,1),(64841233,425453029,15165631,104599,1,'2007-10-11 21:16:26',3310502436,1),(64841236,425454412,15164005,104599,1,'2007-10-11 21:16:26',3310502436,1),(64841238,425455608,15162211,104599,1,'2007-10-11 21:16:26',3310502436,1),(64841243,425457141,15159632,104599,1,'2007-10-11 21:16:26',3310502414,1),(64841245,425458262,15157651,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841248,425460267,15155052,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841254,425461924,15154366,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841257,425463696,15154309,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841260,425464696,15153566,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841263,425465610,15150738,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841266,425467010,15147309,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841268,425468724,15144195,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841271,425469724,15142738,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841274,425471210,15141909,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841278,425472924,15140909,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841281,425474638,15139424,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841282,425476524,15137366,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841286,425477410,15135509,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841290,425460290,15156192,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841293,425461210,15155509,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841297,425463051,15155242,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841301,425464386,15154975,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841307,425465425,15154025,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841311,425466078,15152096,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841315,425466612,15149900,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841316,425467473,15147882,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841319,425468719,15145210,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841321,425470292,15143252,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841324,425472044,15142450,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841329,425473795,15141293,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841333,425475190,15139512,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841337,425476881,15137434,104599,1,'2007-10-11 21:16:29',3310502414,1),(64841341,425477772,15135624,104599,1,'2007-10-11 21:16:29',3310502414,1),(64841344,425447439,15184979,104599,1,'2007-10-11 21:16:29',3310502433,1),(64841346,425446094,15181328,104599,1,'2007-10-11 21:16:29',3310502433,1),(64841351,425445325,15179070,104599,1,'2007-10-11 21:16:29',3310502433,1),(64841356,425444541,15177516,104599,1,'2007-10-11 21:16:29',3310502433,1),(64841360,425443110,15177472,104599,1,'2007-10-11 21:16:29',3310502433,1),(64841365,425444577,15179561,263367,1,'2008-04-26 15:44:04',3310502433,2),(64841367,425446094,15183423,263367,1,'2008-04-26 15:44:04',3310502433,2),(64841370,425447513,15187434,104599,1,'2007-10-11 21:16:29',3310502433,1),(64841373,425449066,15190719,263367,1,'2008-04-26 15:44:04',3310502433,2),(64841375,425450046,15193190,104599,1,'2007-10-11 21:16:29',3310502433,1),(64841376,425450415,15196806,104599,1,'2007-10-11 21:16:29',3310502433,1),(64841379,425451055,15198896,104599,1,'2007-10-11 21:16:29',3310502433,1),(64841383,425452752,15201823,104599,1,'2007-10-11 21:16:30',3310502436,1),(64841386,425455416,15204473,513066,1,'2008-05-24 16:09:07',3310502436,3),(64841388,425456323,15207218,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841390,425456811,15210629,104599,1,'2007-10-11 21:16:30',3310502436,1),(64841393,425456934,15211761,104599,1,'2007-10-11 21:16:30',3310502436,1),(64841396,425457398,15212969,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841399,425458473,15214256,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841407,425460749,15215115,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841415,425449157,15188241,104599,1,'2007-10-11 21:16:30',3310502433,1),(64841424,425450347,15190408,104599,1,'2007-10-11 21:16:30',3310502433,1),(64841431,425452781,15198120,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841433,425454362,15201468,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841434,425456680,15204387,513066,1,'2008-05-24 16:09:07',3310502436,4),(64841436,425457275,15208430,104599,1,'2007-10-11 21:16:31',3310502436,1),(64841439,425458093,15210995,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841441,425458473,15212111,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841444,425459168,15212711,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841446,425460559,15213398,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841451,425463089,15216059,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841452,425464606,15216402,498434,1,'2008-05-22 19:52:51',3310502438,2),(64841454,425466503,15216230,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841456,425467901,15215911,104599,1,'2007-10-11 21:16:31',3310502436,1),(64841461,425469389,15216463,104599,1,'2007-10-11 21:16:31',3310502438,1),(64841463,425471056,15218290,498434,1,'2008-05-22 19:52:51',3310502438,2),(64841468,425472953,15219664,498434,1,'2008-05-22 19:52:51',3310502438,2),(64841472,425474319,15220841,104599,1,'2007-10-11 21:16:31',3310502438,1),(64841473,425475679,15221138,104599,1,'2007-10-11 21:16:31',3310502438,1),(64841478,425477847,15223816,104599,1,'2007-10-11 21:16:32',3310502438,1),(64841481,425480440,15225941,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841483,425481715,15228109,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841487,425482796,15231510,513066,1,'2008-05-24 16:05:33',3310502439,2),(64841488,425483075,15232785,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841491,425483118,15233847,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841497,425484265,15236057,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841499,425485625,15237800,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841502,425486985,15238480,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841507,425488473,15238990,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841511,425490216,15238778,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841514,425491278,15238565,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841518,425494041,15238183,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841521,425495104,15238310,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841525,425495741,15239288,104599,1,'2007-10-11 21:16:33',3310502439,1),(64841529,425462836,15214171,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841532,425464164,15214686,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841537,425465808,15214771,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841541,425467264,15214890,104599,1,'2007-10-11 21:16:33',3310502436,1),(64841547,425467944,15214805,104599,1,'2007-10-11 21:16:33',3310502436,1),(64841550,425469431,15215358,104599,1,'2007-10-11 21:16:33',3310502436,1),(64841551,425471429,15217186,104599,1,'2007-10-11 21:16:33',3310502438,1),(64841553,425472662,15218376,104599,1,'2007-10-11 21:16:33',3310502438,1),(64841557,425473894,15218886,104599,1,'2007-10-11 21:16:33',3310502438,1),(64841561,425475212,15219778,104599,1,'2007-10-11 21:16:33',3310502438,1),(64841566,425476997,15221436,104599,1,'2007-10-11 21:16:33',3310502438,1),(64841570,425479250,15223476,104599,1,'2007-10-11 21:16:33',3310502438,1),(64841573,425480907,15225091,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841579,425482140,15227302,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841582,425482480,15228248,513066,1,'2008-05-24 16:05:33',3310502439,2),(64841584,425482735,15229257,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841587,425483925,15232615,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841591,425485200,15235250,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841597,425486730,15236567,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841600,425488261,15236907,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841603,425490896,15237162,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841606,425493191,15236865,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841612,425494849,15236907,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841617,425496825,15239084,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841620,425498413,15241611,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841623,425500615,15244607,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841627,425504445,15248009,183661,1,'2008-04-18 18:37:07',3310502439,2),(64841630,425508774,15252946,104599,1,'2007-10-11 21:16:35',3310502450,1),(64841635,425511084,15253931,183661,1,'2008-04-18 18:37:07',3310502450,2),(64841638,425497944,15243380,104599,1,'2007-10-11 21:16:35',3310502439,1),(64841640,425500182,15245329,104599,1,'2007-10-11 21:16:35',3310502439,1),(64841645,425503142,15248325,104599,1,'2007-10-11 21:16:35',3310502439,1),(64841649,425504117,15249517,104599,1,'2007-10-11 21:16:35',3310502439,1),(64841652,425505778,15251538,104599,1,'2007-10-11 21:16:35',3310502439,1),(64841654,425508846,15254174,104599,1,'2007-10-11 21:16:35',3310502450,1),(64954372,424826042,14641485,312325,1,'2009-04-07 23:03:07',3310490829,4),(64954377,424536046,14934515,312325,1,'2009-04-07 23:03:08',3310490794,6),(64954382,424380788,14944340,312325,1,'2009-04-07 23:03:09',3310490436,5),(64954385,424684764,14988114,312325,1,'2009-04-07 23:03:09',3310491156,6),(64954389,425343610,15254826,327248,1,'2009-04-08 23:21:24',3310491510,7),(64954396,425168287,15413834,312325,1,'2009-04-07 23:03:11',3310491541,6),(64954400,424836288,14566808,312325,1,'2009-04-07 23:03:11',3310490823,5),(64954404,425800293,16519056,312325,1,'2009-04-07 23:03:12',3310504180,7),(64954409,425614772,15944268,312325,1,'2009-04-07 23:03:12',3310503965,6),(64954415,425338717,15156270,312325,1,'2009-04-07 23:03:13',3310491483,5),(64954417,425824623,16316773,312325,1,'2009-04-07 23:03:13',3310504151,5),(64954422,425795551,16278149,312325,1,'2009-04-07 23:03:14',3310504148,6),(64954429,425831185,16499828,312325,1,'2009-04-07 23:03:14',3310504181,6),(64954433,425667074,15980302,312325,1,'2009-04-07 23:03:15',3310504009,6),(64954435,425649323,15274027,312325,1,'2009-04-07 23:03:15',3310502505,8),(64954441,425710971,16163247,312325,1,'2009-04-07 23:03:16',3310504045,5),(64954447,425439332,15230016,312325,1,'2009-04-07 23:03:16',3310502435,7),(64954451,426188902,15413399,312325,1,'2009-04-07 23:03:17',3310502864,5),(64954457,425812936,16351458,312325,1,'2009-04-07 23:03:18',3310504151,7),(64954460,425476987,15155550,312325,1,'2009-04-07 23:03:18',3310502414,7),(64954464,425318538,15666248,312325,1,'2009-04-07 23:03:18',3310491635,5),(64954467,425617130,14968902,312325,1,'2009-04-07 23:03:19',3310502464,6),(64954472,425690218,15221532,312325,1,'2009-04-07 23:03:19',3310502502,8),(64954477,425135389,15382077,312325,1,'2009-04-07 23:03:19',3310491540,5),(64954483,425720821,14844029,312325,1,'2009-04-07 23:03:20',3310502125,6),(64954486,424666593,14920555,312325,1,'2009-04-07 23:03:20',3310490811,7),(64954492,425385245,15844704,312325,1,'2009-04-07 23:03:21',3310493013,5),(64954503,425659682,14921134,312325,1,'2009-04-07 23:03:21',3310502123,4),(64954508,424537756,14631361,312325,1,'2009-04-07 23:03:21',3310490760,6),(64954512,425009937,15084001,312325,1,'2009-04-07 23:03:22',3310491401,6),(64954515,425465557,14755512,312325,1,'2009-04-07 23:03:22',3310502052,6),(64954521,425535743,14862801,312325,1,'2009-04-07 23:03:23',3310502073,6),(64954525,424765348,14914551,312325,1,'2009-04-07 23:03:23',3310490858,5),(64954531,425962642,15261846,2191272,1,'2009-08-18 19:32:39',3310502706,6),(64954538,425769444,16671670,312325,1,'2009-04-07 23:03:24',3310504187,7),(64954542,425707740,14930380,312325,1,'2009-04-07 23:03:25',3310502127,5),(64954546,425755678,15193446,312325,1,'2009-04-07 23:03:25',3310502513,8),(64954554,424727815,15116860,312325,1,'2009-04-07 23:03:26',3310491167,5),(64954560,425825312,15180695,312325,1,'2009-04-07 23:03:26',3310502517,8),(64954563,425442014,15163754,312325,1,'2009-04-07 23:03:26',3310502433,8),(64954565,425468617,15089987,312325,1,'2009-04-07 23:03:28',3310502412,9),(64954570,425570637,15380568,312325,1,'2009-04-07 23:03:28',3310502462,6),(64954584,425337179,15812088,312325,1,'2009-04-07 23:03:29',3310491643,4),(64954589,425090019,15404067,312325,1,'2009-04-07 23:03:29',3310491536,7),(64954593,424627768,15017489,312325,1,'2009-04-07 23:03:30',3310491143,7),(64954598,424760101,15080811,312325,1,'2009-04-07 23:03:30',3310491208,6),(64954601,425526636,15898923,312325,1,'2009-04-07 23:03:31',3310503954,6),(144217502,424392304,14766835,653218,1,'2007-11-30 17:53:23',3310490085,2),(144217504,424408520,14774560,653218,1,'2007-11-30 17:53:23',3310490096,2),(144217505,424416944,14781856,653218,1,'2007-11-30 17:53:23',3310490098,2),(144217506,424420871,14789580,653218,1,'2007-11-30 17:53:23',3310490098,2),(144217507,424425812,14794559,653218,1,'2007-11-30 17:53:23',3310490098,2),(144217508,424429739,14797992,653218,1,'2007-11-30 17:53:23',3310490098,2),(144217510,424444433,14813871,653218,1,'2007-11-30 17:53:23',3310490099,2),(144217512,424452033,14817905,653218,1,'2007-11-30 17:53:23',3310490099,2),(144217513,424460647,14820737,653218,1,'2007-11-30 17:53:23',3310490099,2),(144217514,424475974,14820308,653218,1,'2007-11-30 17:53:23',3310490102,2),(144217515,424480281,14821767,653218,1,'2007-11-30 17:53:23',3310490102,2),(144217517,424482814,14822883,653218,1,'2007-11-30 17:53:23',3310490102,2),(144217519,424489591,14830608,653218,1,'2007-11-30 17:53:23',3310490102,2),(148874198,425407167,15732033,5077512,1,'2010-06-26 01:37:05',3310502568,48),(206330752,425400605,17212856,206510,1,'2008-12-06 20:14:04',3310504578,4),(206330773,425401330,17195685,206510,1,'2008-12-06 20:14:09',3310504578,4),(206332846,425402106,17194036,4055320,1,'2010-03-06 23:55:56',3310504578,6),(206333041,425401566,17211208,206510,1,'2008-12-06 20:14:03',3310504578,4),(206333043,425401465,17211757,206510,1,'2008-12-06 20:14:03',3310504578,4),(206333048,425400250,17203400,206510,1,'2008-12-06 20:14:02',3310504578,4),(206333118,425400824,17207338,206510,1,'2008-12-06 20:14:03',3310504578,4),(206333119,425401583,17210200,206510,1,'2008-12-06 20:14:03',3310504578,4),(206333120,425401364,17209353,206510,1,'2008-12-06 20:14:03',3310504578,4),(206333124,425401009,17208094,206510,1,'2008-12-06 20:14:03',3310504578,4),(206333171,425398783,17211986,206510,1,'2008-12-06 20:14:04',3310504578,4),(206333191,425400959,17196898,206510,1,'2008-12-06 20:14:09',3310504578,4),(206333194,425401600,17210590,206510,1,'2008-12-06 20:14:03',3310504578,4),(206333343,425400250,17200058,206510,1,'2008-12-06 20:14:09',3310504578,6),(206333344,425399289,17212559,206510,1,'2008-12-06 20:14:04',3310504578,4),(206333347,425400689,17198020,206510,1,'2008-12-06 20:14:09',3310504578,4),(206333352,425400200,17201592,206510,1,'2008-12-06 20:14:02',3310504578,4),(206333353,425399711,17212787,206510,1,'2008-12-06 20:14:04',3310504578,4),(206333355,425400385,17204934,206510,1,'2008-12-06 20:14:03',3310504578,4),(206333356,425400470,17205759,206510,1,'2008-12-06 20:14:03',3310504578,4),(206333525,425400942,17212604,206510,1,'2008-12-06 20:14:03',3310504578,4),(206333534,425400149,17212925,206510,1,'2008-12-06 20:14:04',3310504578,4),(206333617,425398260,17210979,206510,1,'2008-12-06 20:14:04',3310504578,4),(206333618,425401263,17212169,206510,1,'2008-12-06 20:14:03',3310504578,4),(247045685,425580784,16809907,197512,1,'2008-04-20 03:23:33',3310504476,5),(247045686,425580784,16828753,91631,1,'2008-02-10 16:57:04',3310504476,3),(247045688,425568714,16834488,91631,1,'2008-02-10 16:57:04',3310504476,3),(247045690,425553625,16855791,91631,1,'2008-02-10 16:57:04',3310504473,3),(247045691,425544571,16871359,91631,1,'2008-02-10 16:57:04',3310504475,3),(247045693,425513789,16936908,91631,1,'2008-02-10 16:57:04',3310504496,3),(247045695,425475157,16947559,91631,1,'2008-02-10 16:57:04',3310504484,3),(247045696,425446786,16941824,91631,1,'2008-02-10 16:57:04',3310504481,3),(247045698,425403924,16959030,91631,1,'2008-02-10 16:57:04',3310504480,3),(247045700,425363475,16955753,91631,1,'2008-02-10 16:57:04',3310493556,3),(247045701,425366494,16935269,91631,1,'2008-02-10 16:57:04',3310493556,3),(247045703,425388228,16928714,91631,1,'2008-02-10 16:57:04',3310493557,3),(247045712,425416602,16914785,91631,1,'2008-02-10 16:57:04',3310504458,3),(247045718,425451012,16894301,91631,1,'2008-02-10 16:57:04',3310504459,3),(247045724,425475761,16868901,91631,1,'2008-02-10 16:57:04',3310504462,3),(247045732,425497491,16838585,91631,1,'2008-02-10 16:57:04',3310504461,3),(247045739,425498095,16808269,91631,1,'2008-02-10 16:57:04',3310504455,3),(247045741,425516203,16808269,91631,1,'2008-02-10 16:57:04',3310504466,3),(247045742,425546986,16790243,91631,1,'2008-02-10 16:57:04',3310504467,3),(247045744,425565092,16764023,91631,1,'2008-02-10 16:57:04',3310504470,3),(247046008,424971326,15694847,91631,1,'2008-02-10 16:54:21',3310491554,1),(247046009,424984469,15646465,91631,1,'2008-02-10 16:54:21',3310491552,1),(247046010,424927203,15632459,91631,1,'2008-02-10 16:54:21',3310491380,1),(247046011,424884955,15647738,91631,1,'2008-02-10 16:54:21',3310491377,1),(247046012,424832376,15670656,91631,1,'2008-02-10 16:54:21',3310491367,1),(247046013,424830498,15775059,91631,1,'2008-02-10 16:54:21',3310491375,1),(247046014,424848338,15754688,91631,1,'2008-02-10 16:54:22',3310491384,1),(247046015,424857727,15838720,91631,1,'2008-02-10 16:54:22',3310492752,1),(247046016,424850216,15876916,91631,1,'2008-02-10 16:54:22',3310492754,1),(247046017,424832376,15958401,91631,1,'2008-02-10 16:54:22',3310492749,1),(247046018,424819230,15992778,91631,1,'2008-02-10 16:54:22',3310492750,1),(247046019,424822986,16062805,91631,1,'2008-02-10 16:54:22',3310492773,1),(247046020,424864299,16024608,91631,1,'2008-02-10 16:54:22',3310492762,1),(247046021,424894344,15968587,91631,1,'2008-02-10 16:54:22',3310492761,1),(247046022,424929081,15911293,91631,1,'2008-02-10 16:54:22',3310492758,1),(247046023,424943163,15862911,91631,1,'2008-02-10 16:54:22',3310492757,1),(247046024,424972265,15773786,91631,1,'2008-02-10 16:54:22',3310491562,1),(247046025,424959123,15757234,91631,1,'2008-02-10 16:54:22',3310491560,1),(247046026,424958184,15726677,91631,1,'2008-02-10 16:54:22',3310491560,1),(247046027,424964755,15705033,91631,1,'2008-02-10 16:54:23',3310491554,1),(247046028,425106221,14700816,91631,1,'2008-02-10 16:54:23',3310491035,1),(247046029,425133722,14759211,91631,1,'2008-02-10 16:54:23',3310491060,1),(247046030,425127743,14798142,91631,1,'2008-02-10 16:54:23',3310491062,1),(247046031,425150461,14835450,91631,1,'2008-02-10 16:54:23',3310491069,1),(247046032,425145678,14885735,91631,1,'2008-02-10 16:54:23',3310491068,1),(247046033,425144483,14926287,91631,1,'2008-02-10 16:54:23',3310491070,1),(247046034,425148070,14965218,91631,1,'2008-02-10 16:54:23',3310491412,1),(247046035,425106221,15049567,91631,1,'2008-02-10 16:54:23',3310491411,1),(247046036,425103829,15125805,91631,1,'2008-02-10 16:54:23',3310491419,1),(247046037,425112199,15240974,91631,1,'2008-02-10 16:54:23',3310491443,1),(247046038,425154048,15383718,91631,1,'2008-02-10 16:54:23',3310491541,1),(247046039,425278382,15531329,91631,1,'2008-02-10 16:54:23',3310491597,1),(247046040,425313048,15380474,91631,1,'2008-02-10 16:54:24',3310491514,1),(247046041,425321415,15210154,91631,1,'2008-02-10 16:54:24',3310491505,1),(247046042,425304680,15184201,91631,1,'2008-02-10 16:54:24',3310491504,1),(247046043,425303485,15117695,91631,1,'2008-02-10 16:54:24',3310491482,1),(247046044,425303485,15064165,91631,1,'2008-02-10 16:54:24',3310491480,1),(247046045,425291531,14981439,91631,1,'2008-02-10 16:54:24',3310491472,1),(247046046,425272405,14898712,91631,1,'2008-02-10 16:54:24',3310491119,1),(247046047,425243715,14777054,91631,1,'2008-02-10 16:54:24',3310491110,1),(247046048,425226978,14682973,91631,1,'2008-02-10 16:54:24',3310491083,1),(247046072,424840712,14345577,91631,1,'2008-02-10 16:54:26',3310490727,1),(247046073,424863440,14369908,91631,1,'2008-02-10 16:54:26',3310490738,1),(247046074,424884971,14433170,91631,1,'2008-02-10 16:54:26',3310490745,1),(247046075,424931619,14493188,91631,1,'2008-02-10 16:54:26',3310490751,1),(247046076,424979460,14515897,91631,1,'2008-02-10 16:54:26',3310491008,1),(247046077,425009359,14524008,91631,1,'2008-02-10 16:54:27',3310491009,1),(247046078,425050019,14600246,91631,1,'2008-02-10 16:54:27',3310491015,1),(247046079,425093067,14684595,91631,1,'2008-02-10 16:54:27',3310491034,1),(258352118,425509377,15253073,183661,1,'2008-04-18 18:38:19',3310502450,1),(258353529,425491925,15112311,183661,1,'2008-04-18 18:54:27',3310502415,1),(258353530,425488764,15113169,183661,1,'2008-04-18 18:54:27',3310502415,1),(258353531,425486740,15114628,183661,1,'2008-04-18 18:54:27',3310502415,1),(258353532,425485792,15117031,183661,1,'2008-04-18 18:54:27',3310502415,1),(258353533,425484970,15120035,183661,1,'2008-04-18 18:54:27',3310502415,1),(258353534,425485160,15122353,183661,1,'2008-04-18 18:54:27',3310502415,1),(258353535,425484717,15125614,183661,1,'2008-04-18 18:54:27',3310502415,1),(258353536,425482820,15127760,183661,1,'2008-04-18 18:54:27',3310502415,1),(258353537,425480417,15129906,183661,1,'2008-04-18 18:54:27',3310502415,1),(258353538,425479026,15132052,183661,1,'2008-04-18 18:54:27',3310502414,1),(258353539,425477590,15135615,370566,1,'2008-05-09 02:14:23',3310502414,2),(258355185,425429513,14734913,183661,1,'2008-04-18 19:02:24',3310502049,1),(258356188,425355521,14914299,183661,1,'2008-04-18 19:13:36',3310491134,2),(258356379,425738036,14690281,183661,1,'2008-04-18 19:15:01',3310502106,1),(258357981,426287057,15006138,183661,1,'2008-04-18 19:41:04',3310503426,1),(258361905,425368991,17017913,225225,1,'2008-04-23 01:47:15',3310493558,3),(258823161,425800625,16639043,198831,1,'2008-04-20 16:24:53',3310504188,1),(259406445,425171577,15541348,232546,1,'2008-04-23 11:29:21',3310491549,1),(259406446,425169933,15540318,232546,1,'2008-04-23 11:29:21',3310491549,1),(259406447,425167845,15539717,232546,1,'2008-04-23 11:29:21',3310491549,1),(259406448,425166010,15540061,232546,1,'2008-04-23 11:29:21',3310491549,1),(259406449,425163733,15540747,232546,1,'2008-04-23 11:29:21',3310491549,1),(259406450,425160696,15542292,232546,1,'2008-04-23 11:29:21',3310491549,1),(259406451,425158482,15542206,232546,1,'2008-04-23 11:29:21',3310491549,1),(259406452,425156078,15541691,232546,1,'2008-04-23 11:29:21',3310491549,1),(259406453,425151143,15538859,232546,1,'2008-04-23 11:29:21',3310491549,1),(259406454,425142222,15533022,232546,1,'2008-04-23 11:29:21',3310491548,1),(259406455,425138173,15529761,232546,1,'2008-04-23 11:29:21',3310491548,1),(259406456,425135326,15526499,232546,1,'2008-04-23 11:34:21',3310491548,3),(259406980,425335279,15851654,232546,1,'2008-04-23 11:34:59',3310493009,1),(259475446,425429563,15171130,370566,1,'2008-05-09 02:14:21',3310502433,4),(259475447,425429942,15172191,306164,1,'2008-05-01 17:57:27',3310502433,2),(259475448,425430500,15172350,239859,1,'2008-04-23 20:00:56',3310502433,1),(259475449,425431552,15172343,239859,1,'2008-04-23 20:00:56',3310502433,1),(259475450,425434052,15171418,306164,1,'2008-05-01 17:57:27',3310502433,2),(259475451,425436139,15169959,306164,1,'2008-05-01 17:57:27',3310502433,2),(259475452,425440123,15166182,306164,1,'2008-05-01 17:57:27',3310502433,2),(259475453,425443567,15165305,239859,1,'2008-04-23 20:00:56',3310502433,1),(259475454,425444895,15164962,239859,1,'2008-04-23 20:00:56',3310502433,1),(259475455,425446539,15164618,239859,1,'2008-04-23 20:00:56',3310502433,1),(259475493,425447080,15160580,239859,1,'2008-04-23 20:01:45',3310502411,1),(259475494,425447420,15155130,239859,1,'2008-04-23 20:01:45',3310502411,1),(259475495,425447361,15154404,239859,1,'2008-04-23 20:01:45',3310502411,1),(259476084,425446602,15155606,239859,1,'2008-04-23 20:07:10',3310502411,1),(259983829,425416620,15228965,263367,1,'2008-04-26 15:22:11',3310502434,1),(259984359,425444634,15180986,263367,1,'2008-04-26 15:31:22',3310502433,2),(259985586,425442863,15181329,263367,1,'2008-04-26 15:37:22',3310502433,2),(259985587,425439750,15181900,263367,1,'2008-04-26 15:37:07',3310502433,1),(259985588,425435085,15183818,263367,1,'2008-04-26 15:37:07',3310502433,1),(259985589,425433000,15186660,263367,1,'2008-04-26 15:37:07',3310502433,1),(259985590,425428280,15188760,263367,1,'2008-04-26 15:37:07',3310502433,1),(259985592,425424980,15192510,263367,1,'2008-04-26 15:37:07',3310502433,1),(259985593,425422950,15196880,263367,1,'2008-04-26 15:37:07',3310502432,1),(259985594,425422830,15198500,263367,1,'2008-04-26 15:37:07',3310502432,1),(259985595,425422000,15199760,263367,1,'2008-04-26 15:37:07',3310502432,1),(259985596,425421650,15202260,263367,1,'2008-04-26 15:37:07',3310502432,1),(259985597,425421830,15203830,263367,1,'2008-04-26 15:37:07',3310502432,1),(259985598,425421340,15205800,263367,1,'2008-04-26 15:37:07',3310502432,1),(259985599,425421800,15211750,263367,1,'2008-04-26 15:37:07',3310502432,1),(259985600,425420980,15215650,263367,1,'2008-04-26 15:37:07',3310502432,1),(259985601,425421750,15218830,263367,1,'2008-04-26 15:37:07',3310502434,1),(259985602,425421900,15223160,263367,1,'2008-04-26 15:37:07',3310502434,1),(259985603,425421110,15226380,263367,1,'2008-04-26 15:37:07',3310502434,1),(259985604,425421680,15227700,263367,1,'2008-04-26 15:37:07',3310502434,1),(259985605,425419212,15227420,263367,1,'2008-04-26 15:37:07',3310502434,1),(259985606,425416750,15228060,263367,1,'2008-04-26 15:37:07',3310502434,1),(259986453,425435271,15222983,1075389,1,'2009-05-04 18:49:37',3310502435,2),(259986454,425436030,15221609,1075389,1,'2009-05-04 18:49:37',3310502435,2),(259986455,425436725,15220064,1075389,1,'2009-05-04 18:51:49',3310502435,3),(259986456,425437611,15218090,1075389,1,'2009-05-04 18:50:26',3310502435,2),(259986457,425438496,15216889,1075389,1,'2009-05-04 18:50:26',3310502435,2),(259986458,425439191,15215859,1075389,1,'2009-05-04 18:50:26',3310502433,2),(259986459,425440014,15215086,1075389,1,'2009-05-04 18:50:26',3310502433,2),(259986460,425441940,15214200,327248,1,'2009-04-08 23:42:55',3310502433,5),(259986461,425443180,15212980,327248,1,'2009-04-08 23:42:55',3310502433,5),(259986462,425443500,15210010,327248,1,'2009-04-08 23:42:55',3310502433,5),(259986463,425442830,15207880,327248,1,'2009-04-08 23:42:55',3310502433,5),(259986464,425444910,15207010,327248,1,'2009-04-08 23:42:55',3310502433,5),(259986465,425445530,15201350,327248,1,'2009-04-08 23:42:55',3310502433,5),(259986466,425446710,15197180,327248,1,'2009-04-08 23:42:55',3310502433,5),(259986467,425445700,15192060,327248,1,'2009-04-08 23:42:54',3310502433,5),(259986468,425445670,15189860,327248,1,'2009-04-08 23:42:54',3310502433,5),(259986469,425446150,15187850,327248,1,'2009-04-08 23:42:54',3310502433,6),(259986470,425445301,15184030,206510,1,'2008-12-06 19:49:43',3310502433,4),(259986747,425444830,15180934,263367,1,'2008-04-26 15:48:52',3310502433,1),(260984109,425370080,15199010,306164,1,'2008-05-01 16:46:35',3310491509,1),(260984110,425368880,15199080,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984111,425364430,15201600,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984112,425362230,15203730,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984113,425360500,15206630,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984114,425359630,15206780,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984115,425356460,15204030,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984116,425353830,15199510,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984117,425352280,15197950,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984118,425352180,15196390,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984120,425353500,15196560,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984121,425359280,15200250,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984122,425360940,15199900,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984123,425363150,15198110,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984124,425363360,15197440,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984125,425362680,15196830,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984126,425357682,15195607,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984127,425356164,15194233,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984128,425354646,15192173,306164,1,'2008-05-01 16:46:35',3310491508,1),(260989290,425472524,15139645,306164,1,'2008-05-01 17:05:59',3310502414,1),(260989291,425475243,15136898,306164,1,'2008-05-01 17:05:59',3310502414,1),(260995478,425520197,15107824,329152,1,'2008-05-04 19:09:05',3310502426,3),(260996387,425500300,15116300,306164,1,'2008-05-01 17:31:51',3310502415,1),(260996388,425506050,15121550,306164,1,'2008-05-01 17:31:51',3310502415,1),(260996389,425507650,15121880,306164,1,'2008-05-01 17:31:51',3310502426,1),(260996390,425511900,15114760,306164,1,'2008-05-01 17:31:51',3310502426,1),(260996391,425518710,15109460,306164,1,'2008-05-01 17:31:51',3310502426,1),(260996392,425519630,15110160,370566,1,'2008-05-09 01:42:21',3310502426,2),(260996399,425516150,15115200,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996400,425510050,15128050,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996401,425509360,15129910,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996402,425509310,15135630,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996403,425509540,15139130,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996405,425511210,15143660,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996406,425512250,15148740,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996407,425512500,15156930,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996408,425513030,15158950,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996409,425514230,15160210,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996410,425514980,15162100,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996411,425515960,15183380,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996413,425515680,15185490,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996414,425514230,15188860,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996415,425514410,15190730,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996416,425520660,15208150,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996417,425522000,15210210,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996418,425522880,15210060,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996419,425521810,15195690,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996421,425523050,15180210,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996422,425523350,15179500,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996423,425526360,15182410,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996425,425527950,15182380,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996426,425530610,15180000,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996427,425532030,15175600,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996429,425534080,15164310,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996430,425538150,15158760,306164,1,'2008-05-01 17:31:53',3310502427,1),(260996431,425540230,15154810,306164,1,'2008-05-01 17:31:53',3310502427,1),(260996432,425540150,15153200,306164,1,'2008-05-01 17:31:53',3310502427,1),(260996434,425538680,15151900,306164,1,'2008-05-01 17:31:53',3310502427,1),(260996435,425530250,15149010,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996436,425528910,15148010,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996437,425527670,15146150,306164,1,'2008-05-01 17:31:53',3310502426,1),(260997624,425446217,15179569,441038,1,'2008-07-09 18:16:13',3310502433,2),(260997625,425444929,15176310,306164,1,'2008-05-01 17:37:06',3310502433,1),(260997626,425444486,15172448,306164,1,'2008-05-01 17:46:13',3310502433,3),(260997627,425444929,15169101,306164,1,'2008-05-01 17:37:06',3310502433,1),(261001744,425442835,15170125,362976,1,'2008-05-08 16:09:30',3310502433,2),(261001745,425439760,15170980,306164,1,'2008-05-01 17:50:16',3310502433,1),(261001746,425436130,15172750,306164,1,'2008-05-01 17:50:16',3310502433,1),(261001747,425421540,15183410,306164,1,'2008-05-01 17:50:16',3310502432,1),(261001748,425415330,15191710,306164,1,'2008-05-01 17:50:16',3310502432,1),(261001749,425410780,15198930,306164,1,'2008-05-01 17:50:16',3310502432,1),(261001750,425409610,15199850,306164,1,'2008-05-01 17:50:16',3310502432,1),(261001751,425405480,15201210,306164,1,'2008-05-01 17:50:16',3310502432,1),(261001752,425398810,15199350,306164,1,'2008-05-01 17:50:16',3310502432,1),(261001753,425393450,15199160,306164,1,'2008-05-01 17:50:16',3310491509,1),(261002668,425378680,15202910,306164,1,'2008-05-01 17:53:01',3310491509,1),(261002669,425374510,15204450,306164,1,'2008-05-01 17:53:01',3310491509,1),(261002671,425371660,15204550,306164,1,'2008-05-01 17:53:01',3310491509,1),(261002672,425367810,15207130,306164,1,'2008-05-01 17:53:01',3310491508,1),(261002673,425363500,15211880,306164,1,'2008-05-01 17:53:01',3310491508,1),(261002674,425359380,15214750,306164,1,'2008-05-01 17:53:01',3310491508,1),(261002675,425357910,15217010,306164,1,'2008-05-01 17:53:01',3310491510,1),(261003171,425357260,15215650,306164,1,'2008-05-01 17:53:35',3310491508,1),(261003172,425357784,15212617,306164,1,'2008-05-01 17:53:35',3310491508,1),(261004007,425425389,15175366,306164,1,'2008-05-01 17:56:44',3310502433,1),(261004008,425428907,15172112,370566,1,'2008-05-09 02:14:23',3310502433,2),(261006066,425362440,15165675,306164,1,'2008-05-01 18:03:49',3310491508,1),(261006067,425364580,15168240,306164,1,'2008-05-01 18:03:49',3310491508,1),(261006068,425364610,15171780,306164,1,'2008-05-01 18:03:49',3310491508,1),(261006069,425368150,15175800,306164,1,'2008-05-01 18:03:49',3310491508,1),(261006070,425368730,15178310,306164,1,'2008-05-01 18:03:49',3310491508,1),(261006071,425368660,15188090,306164,1,'2008-05-01 18:03:49',3310491508,1),(261006072,425370160,15189510,306164,1,'2008-05-01 18:03:49',3310491509,1),(261006073,425370610,15190550,306164,1,'2008-05-01 18:03:49',3310491509,1),(261006074,425370150,15191850,306164,1,'2008-05-01 18:03:49',3310491509,1),(261006075,425365480,15196280,306164,1,'2008-05-01 18:03:49',3310491508,1),(261006076,425363705,15197089,306164,1,'2008-05-01 18:03:49',3310491508,1),(261012133,425409893,15118607,306164,1,'2008-05-01 18:30:33',3310502410,2),(261012134,425412802,15116890,306164,1,'2008-05-01 18:30:33',3310502410,2),(261012135,425415711,15115260,306164,1,'2008-05-01 18:27:11',3310502410,1),(261012136,425419189,15113371,306164,1,'2008-05-01 18:27:11',3310502410,1),(261012137,425422225,15111826,306164,1,'2008-05-01 18:27:11',3310502410,1),(261013457,425413624,15133284,306164,1,'2008-05-01 18:33:36',3310502410,1),(261013458,425412106,15134657,306164,1,'2008-05-01 18:33:36',3310502410,1),(261013459,425408438,15135087,306164,1,'2008-05-01 18:33:36',3310502410,1),(262151572,425519312,15109455,329152,1,'2008-05-04 19:08:39',3310502426,1),(262151641,425519312,15111086,329152,1,'2008-05-04 19:09:08',3310502426,1),(262459990,425400677,15126424,352026,1,'2008-05-06 15:59:55',3310502410,1),(262459991,425398211,15122733,352026,1,'2008-05-06 15:59:55',3310502410,1),(262459992,425395744,15120330,352026,1,'2008-05-06 15:59:55',3310491487,1),(262459993,425394290,15118871,352026,1,'2008-05-06 15:59:55',3310491487,1),(262459994,425392962,15116897,352026,1,'2008-05-06 15:59:55',3310491487,1),(262459995,425390685,15114065,352026,1,'2008-05-06 15:59:55',3310491487,1),(262459997,425389230,15111661,352026,1,'2008-05-06 15:59:55',3310491487,1),(262459998,425390053,15112005,352026,1,'2008-05-06 15:59:55',3310491487,1),(262459999,425390622,15112005,352026,1,'2008-05-06 15:59:55',3310491487,1),(262460047,425403586,15116210,352026,1,'2008-05-06 16:00:14',3310502410,1),(262460177,425400740,15110031,352026,1,'2008-05-06 16:01:58',3310502410,1),(262460178,425398906,15112605,352026,1,'2008-05-06 16:01:58',3310502410,1),(262460179,425398590,15113292,352026,1,'2008-05-06 16:01:58',3310502410,1),(262460180,425398527,15114065,352026,1,'2008-05-06 16:01:58',3310502410,1),(262460181,425398590,15115180,352026,1,'2008-05-06 16:01:58',3310502410,1),(262460920,425466039,15091055,844916,1,'2009-01-27 19:53:21',3310502412,9),(262460921,425465280,15090969,844916,1,'2009-01-27 19:53:21',3310502412,5),(262460922,425464332,15091055,844916,1,'2009-01-27 19:53:21',3310502412,18),(262461658,425456982,15089214,844916,1,'2009-01-27 19:52:23',3310502412,4),(262461659,425457730,15087610,844916,1,'2009-01-27 19:52:23',3310502412,4),(262461660,425458880,15081580,844916,1,'2009-01-27 19:52:23',3310502412,4),(262461661,425459780,15080560,844916,1,'2009-01-27 19:52:23',3310502412,4),(262461662,425460340,15080590,844916,1,'2009-01-27 19:52:23',3310502412,4),(262461663,425461880,15082030,844916,1,'2009-01-27 19:52:23',3310502412,4),(262461664,425463280,15088460,844916,1,'2009-01-27 19:52:23',3310502412,4),(262461792,425466292,15091398,844916,1,'2009-01-27 19:52:38',3310502412,4),(262461793,425464522,15093372,844916,1,'2009-01-27 19:52:38',3310502412,4),(262461794,425466355,15093544,844916,1,'2009-01-27 19:52:38',3310502412,4),(262461823,425469311,15081452,844916,1,'2009-01-27 19:52:46',3310502412,3),(262461824,425469421,15078052,844916,1,'2009-01-27 19:52:46',3310502412,3),(262461825,425467531,15067262,844916,1,'2009-01-27 19:52:46',3310502412,3),(262461826,425465961,15064172,844916,1,'2009-01-27 19:52:46',3310502412,3),(262461827,425464181,15063072,844916,1,'2009-01-27 19:52:46',3310502412,3),(262461828,425463861,15063432,844916,1,'2009-01-27 19:52:46',3310502412,3),(262462280,425468252,15091656,844916,1,'2009-01-27 19:58:51',3310502412,3),(262462281,425466608,15090969,844916,1,'2009-01-27 19:52:46',3310502412,4),(262464083,425822713,15190758,19873,1,'2008-06-02 18:28:19',3310502517,4),(262464084,425822830,15190260,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464085,425823650,15186260,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464086,425823380,15184480,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464087,425822530,15183800,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464088,425818260,15182800,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464089,425817480,15181260,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464090,425818310,15179960,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464091,425824200,15177560,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464092,425824760,15176530,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464093,425823760,15175640,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464094,425816760,15175960,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464095,425816080,15174400,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464096,425816560,15173260,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464097,425817490,15172700,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464098,425828350,15171580,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464099,425835060,15173610,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464100,425838660,15175230,352026,1,'2008-05-06 16:30:59',3310502688,1),(262464101,425850180,15183300,352026,1,'2008-05-06 16:30:59',3310502688,1),(262464355,425822018,15194449,19873,1,'2008-06-02 18:31:13',3310502517,2),(262465820,425742574,15182803,352026,1,'2008-05-06 16:42:55',3310502512,1),(262466673,425745545,15193017,352026,1,'2008-05-06 16:48:44',3310502512,2),(262466981,425743206,15184005,352026,1,'2008-05-06 16:49:21',3310502512,1),(262466982,425743522,15185121,352026,1,'2008-05-06 16:49:21',3310502512,1),(262467014,425743902,15186837,352026,1,'2008-05-06 16:49:31',3310502512,1),(262467026,425751233,15186151,352026,1,'2008-05-06 16:49:34',3310502512,1),(262467028,425744250,15188990,370566,1,'2008-05-09 01:38:47',3310502512,2),(262467056,425743530,15190140,352026,1,'2008-05-06 16:50:08',3310502512,1),(262467057,425742310,15194880,352026,1,'2008-05-06 16:50:08',3310502512,1),(262467058,425745500,15200760,352026,1,'2008-05-06 16:50:08',3310502512,1),(262467059,425745130,15201910,352026,1,'2008-05-06 16:50:08',3310502512,1),(262467060,425742830,15204860,352026,1,'2008-05-06 16:50:08',3310502512,1),(262467061,425742180,15207290,352026,1,'2008-05-06 16:50:08',3310502512,1),(262472865,425549682,15722207,1293006,1,'2009-05-23 12:53:21',3310502585,7),(262473157,425689970,15878082,437032,1,'2008-05-13 19:23:17',3310504006,5),(262473680,425621207,16028493,352026,1,'2008-05-06 17:59:41',3310504010,2),(262892996,425663043,15990444,370566,1,'2008-05-09 02:14:09',3310504011,1),(262892997,425665181,15995823,370566,1,'2008-05-09 02:14:09',3310504011,1),(262892998,425660320,15995138,370566,1,'2008-05-09 02:14:09',3310504011,1),(262892999,425661022,15997276,370566,1,'2008-05-09 02:14:09',3310504011,1),(262893000,424836334,14583281,370566,1,'2008-05-09 02:14:09',3310490823,1),(262893001,425479113,15133389,370566,1,'2008-05-09 02:14:09',3310502414,1),(262893002,425477502,15133837,370566,1,'2008-05-09 02:14:10',3310502414,1),(262893003,425769287,14799812,19873,1,'2008-06-02 18:58:22',3310502131,2),(264053269,425567995,15484843,426052,1,'2008-05-12 18:07:48',3310502550,1),(264053391,425590882,15566640,426052,1,'2008-05-12 18:10:46',3310502559,1),(264054001,425588410,15566630,426052,1,'2008-05-12 18:14:17',3310502558,1),(264054002,425587010,15565850,426052,1,'2008-05-12 18:14:17',3310502558,1),(264054003,425586080,15561550,426052,1,'2008-05-12 18:14:17',3310502558,1),(264054004,425584900,15547850,426052,1,'2008-05-12 18:14:17',3310502558,1),(264054005,425585000,15541480,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054006,425584660,15539180,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054007,425582250,15532260,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054008,425581390,15526460,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054009,425581180,15520760,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054010,425580893,15519948,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054011,425580260,15519810,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054012,425575310,15520560,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054013,425574697,15520291,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054014,425574080,15519710,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054016,425573680,15518850,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054017,425573400,15516680,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054018,425573630,15505830,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054019,425572430,15499710,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054020,425571950,15492650,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054021,425571080,15489760,426052,1,'2008-05-12 18:14:17',3310502550,1),(264054022,425569702,15487504,426052,1,'2008-05-12 18:14:17',3310502550,1),(264054023,425568438,15486302,426052,1,'2008-05-12 18:14:17',3310502550,1),(264054024,425567995,15485530,426052,1,'2008-05-12 18:14:17',3310502550,1),(264271683,425689410,15872840,437032,1,'2008-05-13 19:29:33',3310504004,1),(264271684,425688300,15874230,437032,1,'2008-05-13 19:29:33',3310504004,1),(264271685,425687510,15873740,437032,1,'2008-05-13 19:29:33',3310504004,1),(264271686,425685660,15870280,437032,1,'2008-05-13 19:29:33',3310504004,1),(264271687,425681010,15864760,437032,1,'2008-05-13 19:29:33',3310504004,1),(264271688,425679080,15863410,437032,1,'2008-05-13 19:29:33',3310504004,1),(264271689,425677330,15860530,437032,1,'2008-05-13 19:29:33',3310504004,1),(264271690,425675250,15859500,437032,1,'2008-05-13 19:29:33',3310504004,1),(264271691,425673600,15859380,437032,1,'2008-05-13 19:29:33',3310504004,1),(264271692,425672380,15858250,437032,1,'2008-05-13 19:29:33',3310504004,1),(264271693,425669910,15857580,437032,1,'2008-05-13 19:29:33',3310504001,1),(264271694,425666910,15855480,437032,1,'2008-05-13 19:29:33',3310504001,1),(264271695,425664210,15855830,437032,1,'2008-05-13 19:29:33',3310504001,1),(264271696,425666200,15859280,437032,1,'2008-05-13 19:29:33',3310504001,1),(264271697,425665510,15859760,437032,1,'2008-05-13 19:29:33',3310504001,1),(264271698,425666830,15863800,437032,1,'2008-05-13 19:29:33',3310504001,1),(264271699,425666060,15864910,437032,1,'2008-05-13 19:29:33',3310504001,1),(264271700,425666550,15866780,437032,1,'2008-05-13 19:29:33',3310504001,1),(264271701,425664850,15867490,437032,1,'2008-05-13 19:29:33',3310504001,1),(264272401,425689906,15876280,437032,1,'2008-05-13 19:34:04',3310504006,1),(264272402,425689590,15874735,437032,1,'2008-05-13 19:34:04',3310504004,1),(264272403,425689763,15873478,443527,1,'2008-05-14 12:03:54',3310504004,2),(264273116,425647427,15804566,437032,1,'2008-05-13 19:42:40',3310502635,1),(264273117,425645404,15803107,437032,1,'2008-05-13 19:42:40',3310502635,1),(264274288,425638513,15836924,437032,1,'2008-05-13 19:59:51',3310504000,1),(264274289,425639209,15836238,437032,1,'2008-05-13 19:59:51',3310504000,1),(264274290,425640060,15835836,437032,1,'2008-05-13 19:59:51',3310504000,1),(264274291,425641232,15835894,437032,1,'2008-05-13 19:59:51',3310504000,1),(264274292,425642053,15836152,437032,1,'2008-05-13 19:59:51',3310504000,1),(264274293,425642496,15836495,437032,1,'2008-05-13 19:59:51',3310504000,1),(264274294,425642938,15836152,437032,1,'2008-05-13 19:59:51',3310504000,1),(264274295,425643370,15835446,437032,1,'2008-05-13 19:59:51',3310504000,1),(264274296,425647710,15822286,437032,1,'2008-05-13 19:59:51',3310504001,1),(264274297,425647869,15821389,437032,1,'2008-05-13 19:59:51',3310504001,1),(264274298,425648059,15820359,437032,1,'2008-05-13 19:59:51',3310502635,1),(264274299,425648059,15819243,437032,1,'2008-05-13 19:59:51',3310502635,1),(264274300,425647910,15818316,437032,1,'2008-05-13 19:59:51',3310502635,1),(264274301,425645783,15806025,437032,1,'2008-05-13 19:59:51',3310502635,1),(264274302,425645404,15803794,437032,1,'2008-05-13 19:59:51',3310502635,1),(264274303,425645190,15801836,437032,1,'2008-05-13 19:59:51',3310502635,1),(264274304,425645467,15799759,437032,1,'2008-05-13 19:59:51',3310502635,1),(264274305,425645024,15797270,437032,1,'2008-05-13 19:59:51',3310502635,1),(264274306,425644220,15795186,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274307,425642369,15792121,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274308,425640473,15789202,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274309,425639461,15786542,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274310,425638197,15782422,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274311,425638007,15781134,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274312,425638007,15779589,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274313,425638576,15773581,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274314,425638703,15772637,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274315,425638513,15771865,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274316,425637881,15770663,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274317,425637010,15769746,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274318,425635858,15768775,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274319,425634973,15768946,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274320,425631870,15770216,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274321,425631496,15770320,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274322,425630990,15769976,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274323,425630485,15769290,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274324,425630232,15768345,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274325,425627387,15761136,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274326,425626881,15760192,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274327,425626186,15759762,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274328,425625933,15759076,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274329,425625870,15758217,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274330,425626249,15756844,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274331,425629031,15749463,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274332,425629663,15748089,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274333,425630270,15747316,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274334,425635070,15744446,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274335,425636060,15744566,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274336,425637881,15746287,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274337,425638420,15746446,437032,1,'2008-05-13 19:59:51',3310502632,1),(264278117,425132719,15296813,437032,1,'2008-05-13 20:22:48',3310491452,1),(264278118,425132023,15298014,437032,1,'2008-05-13 20:22:48',3310491452,1),(264278119,425131581,15298701,437032,1,'2008-05-13 20:22:48',3310491452,1),(264278120,425131454,15299645,437032,1,'2008-05-13 20:22:48',3310491452,1),(264278121,425131327,15300675,437032,1,'2008-05-13 20:22:48',3310491452,1),(264278122,425131327,15301877,437032,1,'2008-05-13 20:22:48',3310491452,1),(264278123,425131327,15302735,437032,1,'2008-05-13 20:22:48',3310491452,1),(264278124,425131264,15303765,437032,1,'2008-05-13 20:22:48',3310491452,1),(264278152,425130189,15318957,437032,1,'2008-05-13 20:23:23',3310491452,1),(264278153,425129682,15316983,437032,1,'2008-05-13 20:23:23',3310491452,1),(264278154,425129176,15314494,437032,1,'2008-05-13 20:23:23',3310491452,1),(264278155,425128670,15312176,437032,1,'2008-05-13 20:23:23',3310491452,1),(264278156,425128480,15310631,437032,1,'2008-05-13 20:23:23',3310491452,1),(264278157,425128164,15310031,437032,1,'2008-05-13 20:23:23',3310491452,1),(264278158,425127784,15309602,437032,1,'2008-05-13 20:23:23',3310491452,1),(264278159,425126519,15307627,437032,1,'2008-05-13 20:23:23',3310491452,1),(264279592,425112537,15285226,437032,1,'2008-05-13 20:27:32',3310491449,1),(264279593,425101275,15255271,437032,1,'2008-05-13 20:27:32',3310491443,1),(264281365,425102667,15268832,437032,1,'2008-05-13 20:34:15',3310491443,1),(264283312,425105008,15284024,437032,1,'2008-05-13 20:39:16',3310491449,1),(264289240,425099630,15334664,437032,1,'2008-05-13 21:06:50',3310491451,1),(264289241,425099494,15333963,188228,1,'2008-06-16 18:36:11',3310491451,2),(264289242,425099114,15333190,188228,1,'2008-06-16 18:35:49',3310491451,2),(264289243,425098671,15331645,188228,1,'2008-06-16 18:35:49',3310491451,2),(264289244,425098292,15330015,188228,1,'2008-06-16 18:35:49',3310491451,2),(264289245,425097415,15327025,437032,1,'2008-05-13 21:06:50',3310491451,1),(264289246,425096972,15324622,437032,1,'2008-05-13 21:06:50',3310491449,1),(264289247,425096150,15321103,437032,1,'2008-05-13 21:12:44',3310491449,2),(264289248,425095707,15319644,437032,1,'2008-05-13 21:12:44',3310491449,2),(264289249,425094505,15316468,437032,1,'2008-05-13 21:12:44',3310491448,2),(264289250,425093239,15313378,437032,1,'2008-05-13 21:12:44',3310491448,2),(264289251,425091974,15310202,437032,1,'2008-05-13 21:12:44',3310491448,2),(264290433,425090139,15306941,437032,1,'2008-05-13 21:08:55',3310491448,1),(264290434,425090708,15306941,437032,1,'2008-05-13 21:11:45',3310491448,2),(264290436,425091151,15306683,437032,1,'2008-05-13 21:11:45',3310491448,2),(264290437,425091721,15306168,437032,1,'2008-05-13 21:08:55',3310491448,1),(264290438,425092037,15305396,437032,1,'2008-05-13 21:11:45',3310491448,2),(264290439,425092227,15304623,437032,1,'2008-05-13 21:11:45',3310491448,2),(264290442,425091404,15306340,437032,1,'2008-05-13 21:08:56',3310491448,1),(264292663,425091974,15309258,437032,1,'2008-05-13 21:10:55',3310491448,1),(264292664,425091910,15308400,437032,1,'2008-05-13 21:12:44',3310491448,2),(264292665,425092163,15307627,437032,1,'2008-05-13 21:12:44',3310491448,2),(264292666,425092543,15306769,437032,1,'2008-05-13 21:12:44',3310491448,2),(264292667,425092543,15305653,437032,1,'2008-05-13 21:12:44',3310491448,2),(264292669,425092543,15304537,437032,1,'2008-05-13 21:10:55',3310491448,1),(264292670,425092163,15303593,437032,1,'2008-05-13 21:10:55',3310491448,1),(264292671,425091657,15301791,437032,1,'2008-05-13 21:10:55',3310491448,1),(264292672,425091151,15299388,437032,1,'2008-05-13 21:10:55',3310491448,1),(264292673,425090898,15295354,820251,1,'2009-03-16 23:53:41',3310491448,3),(264294525,425095201,15320245,437032,1,'2008-05-13 21:13:33',3310491449,1),(264294716,425099880,15335288,3916355,1,'2010-02-19 17:33:05',3310491451,4),(264304664,425097795,15331832,437032,1,'2008-05-13 21:28:42',3310491451,2),(264304665,425098355,15333362,188228,1,'2008-06-16 18:36:12',3310491451,3),(264304666,425098798,15334649,188228,1,'2008-06-16 18:36:12',3310491451,2),(264304667,425099250,15336638,437032,1,'2008-05-13 21:26:09',3310491451,1),(264304668,425099946,15338269,437032,1,'2008-05-13 21:26:09',3310491451,1),(264304669,425102606,15342314,462438,1,'2008-07-11 13:00:24',3310491451,2),(264305363,425096782,15327712,437032,1,'2008-05-13 21:27:06',3310491451,1),(264330869,425107551,15329632,437032,1,'2008-05-13 22:10:59',3310491451,4),(264330870,425100852,15336003,3916355,1,'2010-02-19 17:33:04',3310491451,5),(264331301,425185203,15243081,461502,1,'2008-05-16 18:49:51',3310491490,2),(264331302,425171577,15242943,437032,1,'2008-05-13 22:10:33',3310491447,1),(264331303,425158292,15248350,437032,1,'2008-05-13 22:10:33',3310491447,1),(264331304,425143804,15266117,437032,1,'2008-05-13 22:10:33',3310491446,1),(264331305,425132163,15289978,437032,1,'2008-05-13 22:10:33',3310491452,1),(264331306,425122040,15312895,2895121,1,'2009-10-19 19:14:32',3310491449,2),(264331307,425118054,15320018,437032,1,'2008-05-13 22:10:33',3310491449,1),(264331308,425115333,15323452,437032,1,'2008-05-13 22:10:33',3310491449,1),(264331309,425111094,15326885,437032,1,'2008-05-13 22:10:33',3310491451,1),(264465123,425995626,15317229,443527,1,'2008-05-14 12:03:47',3310502713,1),(264465124,425997574,15320696,206510,1,'2008-12-06 19:38:06',3310502713,4),(264465125,425632317,15276087,498434,1,'2008-05-22 18:10:41',3310502504,5),(264465126,425538879,15886285,443527,1,'2008-05-14 12:03:47',3310503955,1),(264465127,424889567,14510513,443527,1,'2008-05-14 12:03:47',3310490833,1),(264465128,424881879,14517173,443527,1,'2008-05-14 12:03:47',3310490833,1),(264465129,424882282,14516622,443527,1,'2008-05-14 12:03:47',3310490833,1),(264465130,425800616,14794715,443527,1,'2008-05-14 12:03:47',3310502134,1),(264495540,425469136,15246836,725665,1,'2009-03-02 22:19:39',3310502438,5),(264495541,425468441,15245806,448710,1,'2008-05-14 16:55:56',3310502438,1),(264495542,425467113,15244433,448710,1,'2008-05-14 16:55:56',3310502438,1),(264495543,425465659,15243145,448710,1,'2008-05-14 16:55:56',3310502438,1),(264495544,425463635,15241772,448710,1,'2008-05-14 16:55:56',3310502438,1),(264495938,425459715,15234991,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495939,425460600,15234390,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495940,425461738,15234305,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495941,425463003,15234734,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495942,425464141,15235163,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495943,425465279,15235935,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495944,425466670,15237223,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495945,425467998,15238253,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495946,425469326,15238939,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495947,425470464,15239369,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495948,425471792,15240227,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495949,425472678,15241514,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495950,425473247,15242888,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495951,425473752,15244518,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495952,425474069,15245892,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495953,425474005,15247008,725665,1,'2009-03-02 22:19:39',3310502438,5),(264496511,425389647,15263830,448710,1,'2008-05-14 17:09:29',3310491511,1),(264496540,425388825,15285288,448710,1,'2008-05-14 17:10:59',3310491517,1),(264501521,425456758,15243898,725665,1,'2009-03-02 22:19:39',3310502438,5),(264501522,425457201,15242267,448710,1,'2008-05-14 18:16:46',3310502438,1),(264501523,425457580,15241237,448710,1,'2008-05-14 18:16:46',3310502438,1),(264501524,425457707,15240293,448710,1,'2008-05-14 18:16:46',3310502438,1),(264501525,425457137,15239607,448710,1,'2008-05-14 18:16:46',3310502438,1),(264501526,425456505,15239177,448710,1,'2008-05-14 18:16:46',3310502438,1),(264501527,425448727,15233598,448710,1,'2008-05-14 18:16:46',3310502435,1),(264501528,425446830,15232225,448710,1,'2008-05-14 18:16:46',3310502435,1),(264502059,425446008,15231281,448710,1,'2008-05-14 18:24:01',3310502435,1),(264502060,425445123,15230594,448710,1,'2008-05-14 18:24:01',3310502435,1),(264502061,425443415,15229479,448710,1,'2008-05-14 18:24:01',3310502435,1),(264502062,425442340,15228706,448710,1,'2008-05-14 18:24:01',3310502435,1),(264502063,425441545,15228214,423843,1,'2008-07-08 00:15:45',3310502435,2),(264502064,425441139,15227676,448710,1,'2008-05-14 18:24:01',3310502435,1),(264502065,425440949,15227247,448710,1,'2008-05-14 18:24:01',3310502435,1),(264502898,425455911,15173972,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502899,425456860,15174830,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502900,425457176,15175259,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502901,425457239,15175946,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502902,425456986,15188134,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502903,425457050,15188820,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502904,425457239,15189164,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502905,425457556,15189250,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502906,425457935,15188563,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502907,425458125,15187447,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502908,425458314,15186160,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502909,425458504,15185301,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502910,425458884,15183070,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502912,425459579,15180151,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502914,425460338,15177834,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502916,425461033,15175946,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502918,425461856,15174315,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502985,425456923,15189765,448710,1,'2008-05-14 18:41:02',3310502436,1),(264502987,425456607,15189850,448710,1,'2008-05-14 18:41:02',3310502436,1),(264502988,425456417,15190279,448710,1,'2008-05-14 18:41:02',3310502436,1),(264502989,425456354,15190794,448710,1,'2008-05-14 18:41:02',3310502436,1),(264502990,425456417,15191309,448710,1,'2008-05-14 18:41:02',3310502436,1),(264906169,425223602,15218620,461502,1,'2008-05-16 18:38:38',3310491491,1),(264906170,425220755,15220422,461502,1,'2008-05-16 18:38:38',3310491491,1),(264906764,425189251,15240936,461502,1,'2008-05-16 18:44:51',3310491490,2),(264907017,425182799,15251064,461502,1,'2008-05-16 18:45:49',3310491490,1),(264908763,425189504,15242824,461502,1,'2008-05-16 18:54:16',3310491490,1),(264908764,425202346,15235957,461502,1,'2008-05-16 18:54:16',3310491490,1),(264908765,425199626,15237331,461502,1,'2008-05-16 18:54:16',3310491490,1),(264908766,425198234,15238017,461502,1,'2008-05-16 18:54:16',3310491490,1),(264908767,425195894,15239391,461502,1,'2008-05-16 18:54:16',3310491490,1),(264908768,425194565,15240163,461502,1,'2008-05-16 18:56:23',3310491490,2),(264908769,425193047,15241021,461502,1,'2008-05-16 18:54:16',3310491490,1),(264908770,425191465,15242051,461502,1,'2008-05-16 18:54:16',3310491490,1),(264908771,425190453,15242481,461502,1,'2008-05-16 18:54:16',3310491490,1),(264909485,425195831,15240421,461502,1,'2008-05-16 19:10:03',3310491490,2),(264909486,425194059,15241622,461502,1,'2008-05-16 19:10:03',3310491490,2),(264909487,425192667,15242738,461502,1,'2008-05-16 19:10:03',3310491490,2),(264909488,425190010,15244798,461502,1,'2008-05-16 19:02:56',3310491490,1),(264909489,425188429,15246515,461502,1,'2008-05-16 19:02:56',3310491490,1),(264909490,425186341,15248746,461502,1,'2008-05-16 19:02:56',3310491490,1),(264909491,425184823,15250205,461502,1,'2008-05-16 19:02:56',3310491490,1),(264909492,425183933,15250856,56648,1,'2008-06-05 19:24:05',3310491490,2),(264909493,425179382,15254926,461502,1,'2008-05-16 19:02:56',3310491490,1),(264910379,425168122,15278186,461502,1,'2008-05-16 19:07:25',3310491453,1),(264910825,425196906,15238790,461502,1,'2008-05-16 19:10:03',3310491490,1),(264932311,426460461,15840646,459604,1,'2008-05-16 21:20:51',3310504980,1),(264932314,426459261,15850492,459604,1,'2008-05-16 21:20:51',3310504980,1),(264932315,426456859,15849532,459604,1,'2008-05-16 21:20:51',3310504980,1),(264932316,426453016,15842087,459604,1,'2008-05-16 21:20:51',3310504980,1),(264932317,426449654,15841847,459604,1,'2008-05-16 21:20:51',3310504980,1),(264932318,426448213,15845689,459604,1,'2008-05-16 21:20:51',3310504980,1),(264932319,426446772,15848571,459604,1,'2008-05-16 21:20:51',3310504980,1),(264932321,426439620,15854549,459604,1,'2008-05-16 21:20:51',3310504977,1),(264932322,426439423,15859270,459604,1,'2008-05-16 21:20:51',3310504977,1),(264932325,426440505,15877272,459604,1,'2008-05-16 21:20:52',3310504979,1),(264932326,426442079,15878354,459604,1,'2008-05-16 21:20:52',3310504982,1),(264932327,426444440,15877272,459604,1,'2008-05-16 21:20:52',3310504982,1),(264932328,426451818,15864484,459604,1,'2008-05-16 21:20:52',3310504980,1),(264932329,426452900,15861828,459604,1,'2008-05-16 21:20:52',3310504980,1),(264932330,426455261,15862516,459604,1,'2008-05-16 21:20:52',3310504980,1),(264932340,426463917,15830743,459604,1,'2008-05-16 21:20:52',3310504980,1),(264932341,426462638,15828284,459604,1,'2008-05-16 21:20:53',3310504980,1),(264932342,426461163,15828776,459604,1,'2008-05-16 21:20:53',3310504980,1),(264932343,426460376,15831334,459604,1,'2008-05-16 21:20:53',3310504980,1),(264932344,426342071,16020551,459604,1,'2008-05-16 21:20:53',3310504974,1),(264932345,426342071,16023941,459604,1,'2008-05-16 21:20:53',3310504974,1),(264932347,426335799,16023772,459604,1,'2008-05-16 21:20:53',3310504974,1),(264932348,426332409,16021059,459604,1,'2008-05-16 21:20:53',3310504974,1),(264932349,426333426,16016144,459604,1,'2008-05-16 21:20:53',3310504974,1),(264932350,426334951,16013601,459604,1,'2008-05-16 21:20:53',3310504974,1),(264932351,426337325,16013431,459604,1,'2008-05-16 21:20:53',3310504974,1),(264932352,426339528,16015296,459604,1,'2008-05-16 21:20:53',3310504974,1),(264932353,426340376,16017330,459604,1,'2008-05-16 21:20:53',3310504974,1),(264932354,426148324,15412858,459604,1,'2008-05-16 21:20:53',3310502853,1),(264932355,426122272,15399290,459604,1,'2008-05-16 21:20:53',3310502852,1);
INSERT INTO `current_nodes` VALUES (264932356,426103277,15390606,459604,1,'2008-05-16 21:20:54',3310502849,1),(264932357,426089709,15394948,459604,1,'2008-05-16 21:20:54',3310502849,1),(264932359,426072341,15411773,459604,1,'2008-05-16 21:20:54',3310502848,1),(264932360,426051718,15399833,459604,1,'2008-05-16 21:20:54',3310502805,1),(264932361,426031094,15378123,459604,1,'2008-05-16 21:20:54',3310502719,1),(264932362,426021325,15361841,459604,1,'2008-05-16 21:20:54',3310502718,1),(264932363,426004500,15348273,459604,1,'2008-05-16 21:20:54',3310502718,1),(264932364,426001244,15327649,459604,1,'2008-05-16 21:20:54',3310502715,1),(264932365,425990932,15318966,459604,1,'2008-05-16 21:20:54',3310502713,1),(264932366,425967594,15302684,459604,1,'2008-05-16 21:20:54',3310502712,1),(264932367,425957282,15286945,459604,1,'2008-05-16 21:20:54',3310502712,1),(264932368,425945885,15285859,459604,1,'2008-05-16 21:20:54',3310502701,1),(264932370,425933945,15277176,459604,1,'2008-05-16 21:20:54',3310502701,1),(264932371,425921462,15278804,459604,1,'2008-05-16 21:20:54',3310502701,1),(264932372,425908437,15269035,459604,1,'2008-05-16 21:20:55',3310502694,1),(264932373,425880215,15262522,459604,1,'2008-05-16 21:20:55',3310502691,1),(264932374,425865018,15256552,459604,1,'2008-05-16 21:20:55',3310502691,1),(264932375,425850365,15253838,459604,1,'2008-05-16 21:20:55',3310502690,1),(264932376,425836796,15244612,459604,1,'2008-05-16 21:20:55',3310502690,1),(264932377,425830284,15221817,459604,1,'2008-05-16 21:20:55',3310502519,1),(264932379,425819429,15213676,459604,1,'2008-05-16 21:20:55',3310502517,1),(264932380,425808574,15204992,459604,1,'2008-05-16 21:20:55',3310502516,1),(264932381,425780352,15193052,459604,1,'2008-05-16 21:20:55',3310502513,1),(264932382,425767870,15193052,459604,1,'2008-05-16 21:20:55',3310502513,1),(264932383,425755930,15193595,459604,1,'2008-05-16 21:20:55',3310502513,1),(264932384,425716853,15210420,459604,1,'2008-05-16 21:20:55',3310502501,1),(264932386,425713597,15223445,459604,1,'2008-05-16 21:20:56',3310502503,1),(264932387,425706541,15227787,459604,1,'2008-05-16 21:20:56',3310502503,1),(264932388,425684289,15248411,459604,1,'2008-05-16 21:20:56',3310502502,1),(264932390,425653896,15270663,459604,1,'2008-05-16 21:20:56',3310502499,1),(264932393,425630559,15310825,459604,1,'2008-05-16 21:20:56',3310502504,1),(264932395,425619162,15336876,459604,1,'2008-05-16 21:20:56',3310502506,1),(264932396,425624046,15371611,459604,1,'2008-05-16 21:20:56',3310502506,1),(264932397,425628388,15394405,459604,1,'2008-05-16 21:20:56',3310502592,1),(264932398,425656067,15402546,459604,1,'2008-05-16 21:20:56',3310502593,1),(264932399,425687546,15416657,459604,1,'2008-05-16 21:20:57',3310502596,1),(264932400,425710883,15421542,459604,1,'2008-05-16 21:20:57',3310502597,1),(264932401,425726079,15423713,459604,1,'2008-05-16 21:20:57',3310502597,1),(264932402,425747789,15444336,459604,1,'2008-05-16 21:20:57',3310502610,1),(264932404,425784627,15452995,459604,1,'2008-05-16 21:20:57',3310502614,1),(264932405,425823348,15471664,459604,1,'2008-05-16 21:20:57',3310502615,1),(264932406,425838560,15491716,459604,1,'2008-05-16 21:20:57',3310502792,1),(264932407,425879356,15500705,459604,1,'2008-05-16 21:20:57',3310502793,1),(264932408,425882122,15486184,459604,1,'2008-05-16 21:20:57',3310502787,1),(264932409,425882122,15470281,459604,1,'2008-05-16 21:20:57',3310502787,1),(264932410,425892493,15424645,459604,1,'2008-05-16 21:20:57',3310502788,1),(264932411,425882122,15400445,459604,1,'2008-05-16 21:20:57',3310502785,1),(264932412,425871750,15383158,459604,1,'2008-05-16 21:20:58',3310502785,1),(264932414,425884196,15363106,459604,1,'2008-05-16 21:20:58',3310502699,1),(264932415,425903557,15399062,459604,1,'2008-05-16 21:20:58',3310502788,1),(264932416,425912545,15407359,459604,1,'2008-05-16 21:20:58',3310502788,1),(264932417,425927066,15407359,459604,1,'2008-05-16 21:20:58',3310502789,1),(264932420,425936746,15431560,459604,1,'2008-05-16 21:20:58',3310502789,1),(264932427,425938129,15467515,459604,1,'2008-05-16 21:20:58',3310502791,1),(264932428,425960255,15479270,459604,1,'2008-05-16 21:20:58',3310502802,1),(264932429,425980307,15502088,459604,1,'2008-05-16 21:20:58',3310502809,1),(264932430,425966478,15554638,459604,1,'2008-05-16 21:20:58',3310502810,1),(264932431,425964404,15585753,459604,1,'2008-05-16 21:20:59',3310502810,1),(264932432,425965096,15617560,459604,1,'2008-05-16 21:20:59',3310502832,1),(264932433,425967861,15654207,459604,1,'2008-05-16 21:20:59',3310502832,1),(264932435,425985839,15652824,459604,1,'2008-05-16 21:20:59',3310502833,1),(264932436,425998285,15637612,459604,1,'2008-05-16 21:20:59',3310502833,1),(264932437,426007274,15599582,459604,1,'2008-05-16 21:20:59',3310502814,1),(264932438,426005200,15547723,459604,1,'2008-05-16 21:20:59',3310502814,1),(264932439,426011423,15516608,459604,1,'2008-05-16 21:20:59',3310502812,1),(264932440,426023177,15518682,459604,1,'2008-05-16 21:20:59',3310502812,1),(264932441,426032166,15544958,459604,1,'2008-05-16 21:20:59',3310502813,1),(264932442,426035623,15590593,459604,1,'2008-05-16 21:20:59',3310502815,1),(264932444,426051527,15582296,459604,1,'2008-05-16 21:21:00',3310502815,1),(264932445,426052218,15535969,459604,1,'2008-05-16 21:21:00',3310502813,1),(264932446,426051527,15513151,459604,1,'2008-05-16 21:21:00',3310502813,1),(264932447,426067430,15484801,459604,1,'2008-05-16 21:21:00',3310502850,1),(264932448,426081259,15482036,459604,1,'2008-05-16 21:21:00',3310502850,1),(264932449,426093705,15506928,459604,1,'2008-05-16 21:21:00',3310502857,1),(264932450,426108226,15510385,459604,1,'2008-05-16 21:21:00',3310502857,1),(264932451,426110300,15526980,459604,1,'2008-05-16 21:21:00',3310502857,1),(264932452,426124129,15558787,459604,1,'2008-05-16 21:21:00',3310502862,1),(264932453,426131043,15576764,459604,1,'2008-05-16 21:21:00',3310502862,1),(264932454,426147638,15562244,459604,1,'2008-05-16 21:21:00',3310502863,1),(264932456,426155936,15549106,459604,1,'2008-05-16 21:21:00',3310502863,1),(264932457,426159393,15560169,459604,1,'2008-05-16 21:21:00',3310502863,1),(264932458,426098545,15658355,459604,1,'2008-05-16 21:21:00',3310502883,1),(264932459,426122746,15692928,459604,1,'2008-05-16 21:21:00',3310502886,1),(264932460,426146947,15706065,459604,1,'2008-05-16 21:21:01',3310502887,1),(264932461,426173222,15714363,459604,1,'2008-05-16 21:21:01',3310502904,1),(264932462,426193965,15730266,459604,1,'2008-05-16 21:21:01',3310502905,1),(264932463,426217474,15742712,459604,1,'2008-05-16 21:21:01',3310502905,1),(264932464,426235452,15734415,459604,1,'2008-05-16 21:21:01',3310502908,1),(264932465,426227846,15693619,459604,1,'2008-05-16 21:21:01',3310502902,1),(264932466,426212634,15605114,459604,1,'2008-05-16 21:21:01',3310502897,1),(264932467,426210560,15565010,459604,1,'2008-05-16 21:21:01',3310502875,1),(264932469,426216783,15533894,459604,1,'2008-05-16 21:21:01',3310502873,1),(264932470,426220240,15520757,459604,1,'2008-05-16 21:21:01',3310502873,1),(264932471,426236144,15534586,459604,1,'2008-05-16 21:21:01',3310502876,1),(264932472,426241675,15556021,459604,1,'2008-05-16 21:21:01',3310502878,1),(264932473,426256196,15631389,459604,1,'2008-05-16 21:21:01',3310502901,1),(264932474,426265876,15654898,459604,1,'2008-05-16 21:21:01',3310502901,1),(264932475,426278322,15673567,459604,1,'2008-05-16 21:21:02',3310503586,1),(264932476,426328106,15689470,459604,1,'2008-05-16 21:21:02',3310503587,1),(264932477,426324649,15656972,459604,1,'2008-05-16 21:21:02',3310503587,1),(264932478,426335712,15661121,459604,1,'2008-05-16 21:21:02',3310503590,1),(264932479,426345393,15678407,459604,1,'2008-05-16 21:21:02',3310503590,1),(264932481,426350233,15691545,459604,1,'2008-05-16 21:21:02',3310503590,1),(264932482,426369593,15673567,459604,1,'2008-05-16 21:21:02',3310503591,1),(264932483,426375125,15652132,459604,1,'2008-05-16 21:21:03',3310503589,1),(264932484,426384805,15652824,459604,1,'2008-05-16 21:21:03',3310503589,1),(264932486,426385497,15674950,459604,1,'2008-05-16 21:21:03',3310503591,1),(264932487,426413846,15660430,459604,1,'2008-05-16 21:21:03',3310503603,1),(264932488,426404857,15659738,459604,1,'2008-05-16 21:21:03',3310503602,1),(264932489,426412463,15642452,459604,1,'2008-05-16 21:21:03',3310503600,1),(264932490,426413155,15621017,459604,1,'2008-05-16 21:21:03',3310503600,1),(264932491,426383422,15606497,459604,1,'2008-05-16 21:21:03',3310503589,1),(264932492,426356456,15608571,459604,1,'2008-05-16 21:21:03',3310503588,1),(264932493,426318426,15603731,459604,1,'2008-05-16 21:21:03',3310503585,1),(264932495,426274865,15587136,459604,1,'2008-05-16 21:21:03',3310502879,1),(264932496,426269333,15559478,459604,1,'2008-05-16 21:21:03',3310502879,1),(264932497,426259850,15523240,459604,1,'2008-05-16 21:21:03',3310502877,1),(264932498,426244581,15485654,459604,1,'2008-05-16 21:21:03',3310502870,1),(264932499,426226962,15451592,459604,1,'2008-05-16 21:21:04',3310502870,1),(264932500,426217566,15439259,459604,1,'2008-05-16 21:21:04',3310502867,1),(264932501,426204646,15431624,459604,1,'2008-05-16 21:21:04',3310502865,1),(264932503,426216126,15395037,862435,1,'2009-03-27 00:59:22',3310502865,2),(264932504,426229311,15430450,862435,1,'2009-03-27 00:59:23',3310502868,2),(264932505,426257501,15426926,862435,1,'2009-03-27 00:59:23',3310502869,2),(264932506,426266897,15406959,862435,1,'2009-03-27 00:59:23',3310502869,2),(264932507,426278056,15366436,862435,1,'2009-03-27 00:59:23',3310503466,2),(264932509,426303797,15329120,862435,1,'2009-03-27 00:59:23',3310503467,2),(264932510,426316246,15289610,862435,1,'2009-03-27 00:59:24',3310503465,2),(264932512,426324906,15236569,862435,1,'2009-03-27 00:59:24',3310503459,2),(264932513,426333565,15221955,862435,1,'2009-03-27 00:59:24',3310503462,2),(264932515,426340601,15230615,862435,1,'2009-03-27 00:59:24',3310503462,2),(264932516,426350344,15269043,862435,1,'2009-03-27 00:59:24',3310503462,2),(264932517,426367122,15290692,862435,1,'2009-03-27 00:59:24',3310503469,2),(264932518,426377947,15285821,862435,1,'2009-03-27 00:59:24',3310503469,2),(264932519,426377406,15263630,862435,1,'2009-03-27 00:59:24',3310503463,2),(264932520,426360627,15218708,862435,1,'2009-03-27 00:59:25',3310503463,2),(264932521,426349261,15191646,862435,1,'2009-03-27 00:59:25',3310503460,2),(264932522,426347161,15172847,862435,1,'2009-03-27 00:59:25',3310503460,2),(264932523,426357091,15132467,862435,1,'2009-03-27 00:59:25',3310503438,2),(264932524,426369668,15092087,862435,1,'2009-03-27 00:59:25',3310503437,2),(264932526,426351133,15066271,862435,1,'2009-03-27 00:59:25',3310503436,3),(264932529,426302148,15024567,459604,1,'2008-05-16 21:21:05',3310503426,1),(264932531,426281627,15027215,459604,1,'2008-05-16 21:21:05',3310503426,1),(264932532,426243233,15040454,459604,1,'2008-05-16 21:21:06',3310502742,1),(264932534,426226684,15047735,459604,1,'2008-05-16 21:21:06',3310502742,1),(264932535,426241247,15061637,459604,1,'2008-05-16 21:21:06',3310502748,1),(264932536,426241909,15082820,459604,1,'2008-05-16 21:21:06',3310502748,1),(264932537,426244557,15120552,459604,1,'2008-05-16 21:21:06',3310502750,1),(264932538,426234627,15144382,459604,1,'2008-05-16 21:21:06',3310502750,1),(264932539,426206825,15166227,459604,1,'2008-05-16 21:21:06',3310502769,1),(264932540,426214106,15194030,459604,1,'2008-05-16 21:21:06',3310502769,1),(264932541,426171741,15158946,459604,1,'2008-05-16 21:21:06',3310502746,1),(264932543,426155191,15188072,459604,1,'2008-05-16 21:21:06',3310502757,1),(264932544,426134009,15229114,459604,1,'2008-05-16 21:21:06',3310502758,1),(264932545,426139966,15269494,459604,1,'2008-05-16 21:21:06',3310502759,1),(264932546,426132685,15317817,459604,1,'2008-05-16 21:21:06',3310502764,1),(264932547,426128051,15340986,459604,1,'2008-05-16 21:21:06',3310502766,1),(264932548,426116797,15346282,459604,1,'2008-05-16 21:21:06',3310502766,1),(264932549,426096938,15338338,459604,1,'2008-05-16 21:21:07',3310502763,1),(264932550,426106868,15313183,459604,1,'2008-05-16 21:21:07',3310502761,1),(264932551,426108120,15289196,459604,1,'2008-05-16 21:21:07',3310502761,1),(264932552,426225808,15363545,862435,1,'2009-03-27 00:59:22',3310502782,2),(264932554,426235866,15338858,862435,1,'2009-03-27 00:59:22',3310502782,2),(264932555,426252781,15302741,862435,1,'2009-03-27 00:59:22',3310502781,2),(264932556,426269697,15281712,862435,1,'2009-03-27 00:59:21',3310502781,2),(264932557,426277469,15267996,862435,1,'2009-03-27 00:59:21',3310503458,2),(264932558,426282498,15254738,862435,1,'2009-03-27 00:59:21',3310503458,2),(264932559,426296213,15235080,862435,1,'2009-03-27 00:59:21',3310503458,2),(264932560,426305356,15218622,862435,1,'2009-03-27 00:59:20',3310503459,2),(264932561,426312671,15193477,862435,1,'2009-03-27 00:59:20',3310503457,2),(264932563,426319529,15169704,862435,1,'2009-03-27 00:59:20',3310503457,2),(264932564,426324557,15142274,862435,1,'2009-03-27 00:59:20',3310503435,2),(264932565,426325015,15121244,862435,1,'2009-03-27 00:59:17',3310503435,2),(264932566,426340101,15084670,862435,1,'2009-03-27 00:59:16',3310503436,2),(264932567,426091047,15271804,459604,1,'2008-05-16 21:21:08',3310502761,1),(264932568,426081027,15256775,459604,1,'2008-05-16 21:21:08',3310502754,1),(264932569,426081027,15241745,459604,1,'2008-05-16 21:21:08',3310502754,1),(264932570,426094805,15223583,459604,1,'2008-05-16 21:21:08',3310502755,1),(264932572,426094805,15207927,459604,1,'2008-05-16 21:21:08',3310502753,1),(264932573,426072886,15173484,459604,1,'2008-05-16 21:21:08',3310502752,1),(264932574,426055351,15155949,459604,1,'2008-05-16 21:21:08',3310502687,1),(264932575,426042826,15154696,459604,1,'2008-05-16 21:21:08',3310502687,1),(264932576,426030301,15150939,459604,1,'2008-05-16 21:21:08',3310502687,1),(264932577,426036564,15135909,459604,1,'2008-05-16 21:21:09',3310502687,1),(264932578,426037816,15103970,459604,1,'2008-05-16 21:21:09',3310502685,1),(264932579,426019029,15067022,459604,1,'2008-05-16 21:21:09',3310502684,1),(264932581,426006504,15068274,459604,1,'2008-05-16 21:21:09',3310502684,1),(264932582,426000242,15078921,459604,1,'2008-05-16 21:21:09',3310502681,1),(264932583,425984711,15083304,459604,1,'2008-05-16 21:21:09',3310502681,1),(264932584,425968929,15083304,459604,1,'2008-05-16 21:21:09',3310502680,1),(264932585,425962917,15077292,459604,1,'2008-05-16 21:21:09',3310502680,1),(264932586,425953148,15071280,459604,1,'2008-05-16 21:21:09',3310502680,1),(264932587,425934360,15072032,459604,1,'2008-05-16 21:21:09',3310502669,1),(264932589,425914070,15084056,459604,1,'2008-05-16 21:21:09',3310502668,1),(264932590,425885513,15114116,459604,1,'2008-05-16 21:21:09',3310502667,1),(264932591,425885062,15143123,459604,1,'2008-05-16 21:21:10',3310502667,1),(264932592,425893479,15187011,459604,1,'2008-05-16 21:21:10',3310502692,1),(264932593,425917527,15220437,459604,1,'2008-05-16 21:21:10',3310502694,1),(264932594,425935563,15244245,459604,1,'2008-05-16 21:21:10',3310502695,1),(264932595,425957927,15226209,459604,1,'2008-05-16 21:21:10',3310502706,1),(264932596,425970913,15230537,459604,1,'2008-05-16 21:21:10',3310502706,1),(264932598,425973077,15252180,459604,1,'2008-05-16 21:21:10',3310502706,1),(264932599,425984620,15273823,459604,1,'2008-05-16 21:21:10',3310502713,1),(264932600,426010592,15313502,459604,1,'2008-05-16 21:21:10',3310502716,1),(264932601,426030792,15336588,459604,1,'2008-05-16 21:21:10',3310502719,1),(264932602,426050993,15343081,459604,1,'2008-05-16 21:21:11',3310502719,1),(264932603,426084179,15357510,459604,1,'2008-05-16 21:21:11',3310502763,1),(264932604,426102936,15374103,459604,1,'2008-05-16 21:21:11',3310502763,1),(264932605,426130350,15370496,459604,1,'2008-05-16 21:21:11',3310502766,1),(264932606,426167144,15371939,459604,1,'2008-05-16 21:21:11',3310502778,1),(264932608,426188065,15345967,459604,1,'2008-05-16 21:21:11',3310502778,1),(264932609,426197444,15323603,459604,1,'2008-05-16 21:21:11',3310502777,1),(264932610,426221251,15305567,459604,1,'2008-05-16 21:21:11',3310502780,1),(264932611,426234237,15278874,459604,1,'2008-05-16 21:21:11',3310502780,1),(264932612,426258766,15250016,459604,1,'2008-05-16 21:21:11',3310502775,1),(264932613,426281131,15206730,459604,1,'2008-05-16 21:21:12',3310503456,1),(264932614,426305227,15173111,459604,1,'2008-05-16 21:21:12',3310503457,1),(264932615,426313018,15138482,459604,1,'2008-05-16 21:21:12',3310503435,1),(264932616,426316481,15068359,459604,1,'2008-05-16 21:21:12',3310503433,1),(264932617,426310421,15038924,459604,1,'2008-05-16 21:21:12',3310503427,1),(264932619,425960809,16112758,459604,1,'2008-05-16 21:21:12',3310504242,1),(264932620,425934839,16107157,459604,1,'2008-05-16 21:21:12',3310504231,1),(264932621,425917526,16108684,459604,1,'2008-05-16 21:21:12',3310504230,1),(264932622,425893083,16108684,459604,1,'2008-05-16 21:21:12',3310504230,1),(264932623,425883408,16108684,459604,1,'2008-05-16 21:21:12',3310504227,1),(264932624,425869150,16111740,459604,1,'2008-05-16 21:21:12',3310504227,1),(264932625,425864567,16124979,459604,1,'2008-05-16 21:21:12',3310504227,1),(264932626,425861002,16130581,459604,1,'2008-05-16 21:21:12',3310504226,1),(264932627,425841652,16131599,459604,1,'2008-05-16 21:21:13',3310504226,1),(264932628,425830958,16118359,459604,1,'2008-05-16 21:21:13',3310504055,1),(264932629,425836560,16110721,459604,1,'2008-05-16 21:21:13',3310504055,1),(264932631,425856929,16103592,459604,1,'2008-05-16 21:21:13',3310504226,1),(264932632,425875770,16079659,459604,1,'2008-05-16 21:21:13',3310504225,1),(264932633,425872205,16059290,459604,1,'2008-05-16 21:21:13',3310504225,1),(264932634,425848272,16054198,459604,1,'2008-05-16 21:21:13',3310504224,1),(264932635,425821793,16054707,459604,1,'2008-05-16 21:21:13',3310504053,1),(264932636,425804479,16057762,459604,1,'2008-05-16 21:21:13',3310504052,1),(264932637,425792258,16067947,459604,1,'2008-05-16 21:21:13',3310504052,1),(264932638,425774944,16088825,459604,1,'2008-05-16 21:21:13',3310504049,1),(264932639,425772907,16119887,459604,1,'2008-05-16 21:21:13',3310504051,1),(264932641,425761705,16121924,459604,1,'2008-05-16 21:21:14',3310504051,1),(264932642,425768324,16130072,459604,1,'2008-05-16 21:21:14',3310504051,1),(264932643,425784110,16149422,459604,1,'2008-05-16 21:21:14',3310504054,1),(264932644,425799896,16167754,459604,1,'2008-05-16 21:21:14',3310504060,1),(264932645,425797859,16210019,459604,1,'2008-05-16 21:21:14',3310504062,1),(264932646,425810080,16233952,459604,1,'2008-05-16 21:21:14',3310504063,1),(264932647,425829940,16232934,459604,1,'2008-05-16 21:21:14',3310504063,1),(264932649,425848272,16216130,459604,1,'2008-05-16 21:21:14',3310504234,1),(264932650,425865585,16210019,459604,1,'2008-05-16 21:21:14',3310504235,1),(264932651,425887482,16209001,459604,1,'2008-05-16 21:21:14',3310504235,1),(264932652,425904286,16200853,459604,1,'2008-05-16 21:21:14',3310504236,1),(264932653,425903777,16185576,459604,1,'2008-05-16 21:21:14',3310504236,1),(264932654,425887482,16183030,459604,1,'2008-05-16 21:21:15',3310504233,1),(264932655,425857947,16172846,459604,1,'2008-05-16 21:21:15',3310504232,1),(264932656,425853364,16157569,459604,1,'2008-05-16 21:21:15',3310504232,1),(264932657,425856929,16147385,459604,1,'2008-05-16 21:21:15',3310504226,1),(264932658,425872205,16143311,459604,1,'2008-05-16 21:21:15',3310504227,1),(264932659,425892574,16142293,459604,1,'2008-05-16 21:21:15',3310504230,1),(264932660,425914470,16142293,459604,1,'2008-05-16 21:21:15',3310504230,1),(264932661,425941968,16136691,459604,1,'2008-05-16 21:21:15',3310504231,1),(264932662,425957754,16130072,459604,1,'2008-05-16 21:21:15',3310504242,1),(264932663,426160001,16385750,459604,1,'2008-05-16 21:21:15',3310504397,1),(264932665,426130751,16388675,459604,1,'2008-05-16 21:21:15',3310504396,1),(264932666,426114956,16394525,459604,1,'2008-05-16 21:21:16',3310504396,1),(264932667,426092725,16402716,459604,1,'2008-05-16 21:21:16',3310504393,1),(264932668,426057040,16405641,459604,1,'2008-05-16 21:21:16',3310504392,1),(264932669,426051775,16405641,459604,1,'2008-05-16 21:21:16',3310504349,1),(264932670,426048265,16397451,459604,1,'2008-05-16 21:21:16',3310504349,1),(264932671,426040660,16387505,459604,1,'2008-05-16 21:21:16',3310504349,1),(264932672,426026253,16386405,459604,1,'2008-05-16 21:21:16',3310504348,1),(264932673,426018585,16387363,459604,1,'2008-05-16 21:21:16',3310504348,1),(264932675,426009767,16394839,459604,1,'2008-05-16 21:21:16',3310504348,1),(264932676,426003824,16399632,459604,1,'2008-05-16 21:21:16',3310504348,1),(264932677,425999152,16398116,459604,1,'2008-05-16 21:21:16',3310504345,1),(264932678,425984645,16393281,459604,1,'2008-05-16 21:21:16',3310504345,1),(264932679,425977172,16385807,459604,1,'2008-05-16 21:21:16',3310504345,1),(264932680,425963545,16382730,459604,1,'2008-05-16 21:21:16',3310504344,1),(264932681,425945521,16380532,459604,1,'2008-05-16 21:21:17',3310504333,1),(264932682,425927497,16384928,459604,1,'2008-05-16 21:21:17',3310504333,1),(264932684,425916068,16391962,459604,1,'2008-05-16 21:21:17',3310504332,1),(264932685,425909473,16399875,459604,1,'2008-05-16 21:21:17',3310504332,1),(264932686,425901561,16404710,459604,1,'2008-05-16 21:21:17',3310504332,1),(264932687,425893648,16404271,459604,1,'2008-05-16 21:21:17',3310504332,1),(264932688,425875624,16387566,459604,1,'2008-05-16 21:21:17',3310504329,1),(264932689,425859359,16382730,459604,1,'2008-05-16 21:21:17',3310504328,1),(264932690,425848808,16379653,459604,1,'2008-05-16 21:21:17',3310504328,1),(264932691,425832543,16379653,459604,1,'2008-05-16 21:21:17',3310504157,1),(264932693,425814080,16392401,459604,1,'2008-05-16 21:21:17',3310504157,1),(264932694,425830345,16417459,459604,1,'2008-05-16 21:21:17',3310504157,1),(264932695,425833422,16447791,459604,1,'2008-05-16 21:21:17',3310504159,1),(264932696,425837818,16464936,459604,1,'2008-05-16 21:21:18',3310504330,1),(264932697,425848369,16498785,459604,1,'2008-05-16 21:21:18',3310504352,1),(264932698,425847490,16521205,459604,1,'2008-05-16 21:21:18',3310504352,1),(264932699,425838698,16537470,459604,1,'2008-05-16 21:21:18',3310504354,1),(264932701,425838698,16557692,459604,1,'2008-05-16 21:21:18',3310504354,1),(264932702,425840456,16570880,459604,1,'2008-05-16 21:21:18',3310504354,1),(264932703,425852765,16574836,459604,1,'2008-05-16 21:21:18',3310504354,1),(264932704,425856282,16570880,459604,1,'2008-05-16 21:21:18',3310504354,1),(264932705,425860678,16559890,459604,1,'2008-05-16 21:21:18',3310504354,1),(264932706,425867272,16533074,459604,1,'2008-05-16 21:21:18',3310504353,1),(264932707,425879141,16484718,459604,1,'2008-05-16 21:21:18',3310504353,1),(264932708,425880460,16463617,459604,1,'2008-05-16 21:21:18',3310504331,1),(264932710,425897165,16489553,459604,1,'2008-05-16 21:21:19',3310504356,1),(264932711,425915628,16484718,459604,1,'2008-05-16 21:21:19',3310504356,1),(264932712,425934970,16483399,459604,1,'2008-05-16 21:21:19',3310504357,1),(264932713,425938927,16483399,459604,1,'2008-05-16 21:21:19',3310504357,1),(264932714,425964424,16485597,459604,1,'2008-05-16 21:21:19',3310504368,1),(264932715,425987283,16483839,459604,1,'2008-05-16 21:21:19',3310504369,1),(264932716,426004428,16483839,459604,1,'2008-05-16 21:21:19',3310504372,1),(264932717,426035639,16509336,459604,1,'2008-05-16 21:21:19',3310504373,1),(264932718,426048388,16518128,459604,1,'2008-05-16 21:21:19',3310504373,1),(264932719,426080039,16524722,459604,1,'2008-05-16 21:21:19',3310504416,1),(264932720,426109492,16521205,459604,1,'2008-05-16 21:21:19',3310504417,1),(264932722,426134989,16502742,459604,1,'2008-05-16 21:21:19',3310504420,1),(264932723,426129714,16477245,459604,1,'2008-05-16 21:21:19',3310504398,1),(264932724,426118724,16457902,459604,1,'2008-05-16 21:21:19',3310504398,1),(264932725,426138067,16438560,459604,1,'2008-05-16 21:21:20',3310504398,1),(264932726,426152573,16412623,459604,1,'2008-05-16 21:21:20',3310504397,1),(264932727,426148082,16341682,459604,1,'2008-05-16 21:21:20',3310504391,1),(264932728,426118937,16332574,459604,1,'2008-05-16 21:21:20',3310504390,1),(264932729,426094800,16336217,459604,1,'2008-05-16 21:21:20',3310504387,1),(264932731,426079316,16337583,459604,1,'2008-05-16 21:21:20',3310504386,1),(264932732,426046983,16338494,459604,1,'2008-05-16 21:21:20',3310504343,1),(264932733,426024213,16330297,459604,1,'2008-05-16 21:21:20',3310504342,1),(264932734,425985504,16316179,459604,1,'2008-05-16 21:21:20',3310504339,1),(264932735,425970931,16313902,459604,1,'2008-05-16 21:21:20',3310504336,1),(264932736,425948161,16318001,459604,1,'2008-05-16 21:21:20',3310504338,1),(264932737,425940874,16319823,459604,1,'2008-05-16 21:21:20',3310504327,1),(264932738,425907630,16322100,459604,1,'2008-05-16 21:21:20',3310504326,1),(264932739,425882127,16323921,459604,1,'2008-05-16 21:21:20',3310504323,1),(264932740,425858902,16323921,459604,1,'2008-05-16 21:21:20',3310504322,1),(264932742,425842052,16332119,459604,1,'2008-05-16 21:21:21',3310504322,1),(264932743,425822925,16357621,459604,1,'2008-05-16 21:21:21',3310504151,1),(264932744,425846150,16364452,459604,1,'2008-05-16 21:21:21',3310504322,1),(264932745,425866643,16377659,459604,1,'2008-05-16 21:21:21',3310504329,1),(264932746,425885770,16381302,459604,1,'2008-05-16 21:21:21',3310504329,1),(264932747,425908540,16370828,459604,1,'2008-05-16 21:21:21',3310504332,1),(264932748,425924935,16370828,459604,1,'2008-05-16 21:21:21',3310504333,1),(264932749,425947250,16370372,459604,1,'2008-05-16 21:21:21',3310504344,1),(264932750,425964100,16369462,459604,1,'2008-05-16 21:21:21',3310504338,1),(264932752,425975940,16377203,459604,1,'2008-05-16 21:21:21',3310504345,1),(264932753,426004175,16370828,459604,1,'2008-05-16 21:21:21',3310504348,1),(264932754,426011006,16373560,459604,1,'2008-05-16 21:21:21',3310504348,1),(264932755,426022847,16376748,459604,1,'2008-05-16 21:21:21',3310504348,1),(264932756,426039696,16382213,459604,1,'2008-05-16 21:21:22',3310504349,1),(264932757,426057457,16382668,459604,1,'2008-05-16 21:21:22',3310504392,1),(264932759,426069753,16380847,459604,1,'2008-05-16 21:21:22',3310504392,1),(264932760,426080227,16379480,459604,1,'2008-05-16 21:21:22',3310504392,1),(264932761,426096166,16376293,459604,1,'2008-05-16 21:21:22',3310504393,1),(264932762,426108007,16376293,459604,1,'2008-05-16 21:21:22',3310504393,1),(264932763,426123035,16370828,459604,1,'2008-05-16 21:21:22',3310504396,1),(264932764,426129866,16362175,459604,1,'2008-05-16 21:21:22',3310504390,1),(264932765,425757309,16509404,459604,1,'2008-05-16 21:21:22',3310504177,1),(264932766,425748520,16529913,459604,1,'2008-05-16 21:21:22',3310504176,1),(264932767,425748101,16544980,459604,1,'2008-05-16 21:21:22',3310504178,1),(264932769,425754379,16567163,459604,1,'2008-05-16 21:21:22',3310504179,1),(264932770,425757728,16583486,459604,1,'2008-05-16 21:21:22',3310504179,1),(264932771,425756472,16624504,459604,1,'2008-05-16 21:21:22',3310504185,1),(264932772,425756472,16646687,459604,1,'2008-05-16 21:21:23',3310504187,1),(264932773,425753542,16666777,459604,1,'2008-05-16 21:21:23',3310504186,1),(264932774,425749357,16673892,459604,1,'2008-05-16 21:21:23',3310504186,1),(264932775,425737219,16668032,459604,1,'2008-05-16 21:21:23',3310504186,1),(264932776,425712943,16656732,459604,1,'2008-05-16 21:21:23',3310504175,1),(264932777,425699969,16652128,459604,1,'2008-05-16 21:21:23',3310504175,1),(264932779,425695783,16655476,459604,1,'2008-05-16 21:21:23',3310504174,1),(264932780,425692435,16658824,459604,1,'2008-05-16 21:21:23',3310504174,1),(264932781,425679041,16654221,459604,1,'2008-05-16 21:21:23',3310504174,1),(264932782,425665648,16650454,459604,1,'2008-05-16 21:21:23',3310504171,1),(264932783,425658114,16639990,459604,1,'2008-05-16 21:21:23',3310504169,1),(264932784,425659788,16604414,459604,1,'2008-05-16 21:21:23',3310504169,1),(264932785,425660625,16576371,459604,1,'2008-05-16 21:21:23',3310504163,1),(264932786,425663555,16553770,459604,1,'2008-05-16 21:21:24',3310504163,1),(264932787,425666066,16534517,459604,1,'2008-05-16 21:21:24',3310504161,1),(264932788,425678623,16511497,459604,1,'2008-05-16 21:21:24',3310504164,1),(264932789,425689086,16497266,459604,1,'2008-05-16 21:21:24',3310504164,1),(264932791,425709176,16493918,459604,1,'2008-05-16 21:21:24',3310504165,1),(264932792,425725081,16496429,459604,1,'2008-05-16 21:21:24',3310504165,1),(264932793,425728011,16499359,459604,1,'2008-05-16 21:21:24',3310504176,1),(264932794,425734289,16501870,459604,1,'2008-05-16 21:21:24',3310504176,1),(264932795,425745171,16503126,459604,1,'2008-05-16 21:21:24',3310504176,1),(264932796,425785888,16653751,459604,1,'2008-05-16 21:21:24',3310504190,1),(264932797,425804071,16648837,459604,1,'2008-05-16 21:21:24',3310504190,1),(264932798,425821763,16656208,459604,1,'2008-05-16 21:21:24',3310504191,1),(264932800,425835522,16665545,459604,1,'2008-05-16 21:21:24',3310504191,1),(264932801,425849774,16672917,459604,1,'2008-05-16 21:21:24',3310504362,1),(264932802,425869431,16679305,459604,1,'2008-05-16 21:21:25',3310504363,1),(264932803,425878277,16685203,459604,1,'2008-05-16 21:21:25',3310504363,1),(264932804,425890071,16696997,459604,1,'2008-05-16 21:21:25',3310504363,1),(264932805,425898917,16708300,459604,1,'2008-05-16 21:21:25',3310504708,1),(264932806,425917100,16723043,459604,1,'2008-05-16 21:21:25',3310504708,1),(264932807,425937740,16749580,459604,1,'2008-05-16 21:21:25',3310504709,1),(264932808,425947077,16760391,459604,1,'2008-05-16 21:21:25',3310504722,1),(264932809,425953465,16783488,459604,1,'2008-05-16 21:21:25',3310504722,1),(264932811,425960837,16797248,459604,1,'2008-05-16 21:21:25',3310504722,1),(264932812,425980494,16818871,459604,1,'2008-05-16 21:21:25',3310504729,1),(264932813,425989831,16847374,459604,1,'2008-05-16 21:21:25',3310504729,1),(264932814,426002117,16872928,459604,1,'2008-05-16 21:21:25',3310504734,1),(264932815,426009488,16893077,459604,1,'2008-05-16 21:21:25',3310504734,1),(264932816,426016368,16925511,459604,1,'2008-05-16 21:21:26',3310504756,1),(264932817,426014402,16950574,459604,1,'2008-05-16 21:21:26',3310504756,1),(264932818,426005065,16972197,459604,1,'2008-05-16 21:21:26',3310504756,1),(264932820,426008505,17004140,459604,1,'2008-05-16 21:21:26',3310504758,1),(264932821,426001134,17022814,459604,1,'2008-05-16 21:21:26',3310504755,1),(264932822,426001134,17047877,459604,1,'2008-05-16 21:21:26',3310504761,1),(264932823,425997694,17080311,459604,1,'2008-05-16 21:21:26',3310504761,1),(264932824,425982951,17058688,459604,1,'2008-05-16 21:21:26',3310504761,1),(264932825,425953465,17057214,459604,1,'2008-05-16 21:21:26',3310504760,1),(264932826,425948060,17064094,459604,1,'2008-05-16 21:21:26',3310504760,1),(264932827,425942162,17072448,459604,1,'2008-05-16 21:21:26',3310504749,1),(264932828,425940197,17101934,459604,1,'2008-05-16 21:21:26',3310504751,1),(264932829,425929877,17134860,459604,1,'2008-05-16 21:21:26',3310504751,1),(264932831,425918574,17131911,459604,1,'2008-05-16 21:21:26',3310504750,1),(264932832,425913660,17119625,459604,1,'2008-05-16 21:21:27',3310504750,1),(264932833,425899408,17042963,459604,1,'2008-05-16 21:21:27',3310504748,1),(264932834,425910711,17023797,459604,1,'2008-05-16 21:21:27',3310504742,1),(264932835,425936265,16987431,459604,1,'2008-05-16 21:21:27',3310504743,1),(264932836,425945111,16959911,459604,1,'2008-05-16 21:21:27',3310504741,1),(264932837,425941671,16909294,459604,1,'2008-05-16 21:21:27',3310504719,1),(264932838,425924962,16892094,459604,1,'2008-05-16 21:21:27',3310504719,1),(264932839,425904814,16901431,459604,1,'2008-05-16 21:21:27',3310504718,1),(264932840,425865991,16903397,459604,1,'2008-05-16 21:21:27',3310504715,1),(264932841,425866482,16885705,459604,1,'2008-05-16 21:21:27',3310504715,1),(264932842,425846334,16805603,459604,1,'2008-05-16 21:21:27',3310504706,1),(264932843,425824220,16811500,459604,1,'2008-05-16 21:21:27',3310504541,1),(264932844,425813900,16811991,459604,1,'2008-05-16 21:21:27',3310504541,1),(264932846,425801123,16816905,459604,1,'2008-05-16 21:21:28',3310504540,1),(264932847,425784905,16829683,459604,1,'2008-05-16 21:21:28',3310504540,1),(264932848,425778517,16843443,459604,1,'2008-05-16 21:21:28',3310504537,1),(264932849,425777043,16880300,459604,1,'2008-05-16 21:21:28',3310504539,1),(264932850,425752471,16898483,459604,1,'2008-05-16 21:21:28',3310504538,1),(264932851,425738711,16896025,459604,1,'2008-05-16 21:21:28',3310504538,1),(264932852,425720037,16892094,459604,1,'2008-05-16 21:21:28',3310504527,1),(264932853,425692517,16890620,459604,1,'2008-05-16 21:21:28',3310504526,1),(264932855,425666471,16890620,459604,1,'2008-05-16 21:21:28',3310504523,1),(264932856,425643865,16897008,459604,1,'2008-05-16 21:21:28',3310504522,1),(264932857,425624700,16915683,459604,1,'2008-05-16 21:21:28',3310504522,1),(264932858,425606025,16936323,459604,1,'2008-05-16 21:21:28',3310504501,1),(264932859,425588825,16934848,459604,1,'2008-05-16 21:21:28',3310504500,1),(264932860,425587843,16905363,459604,1,'2008-05-16 21:21:29',3310504478,1),(264932861,425597671,16885214,459604,1,'2008-05-16 21:21:29',3310504479,1),(264932862,425608974,16862117,459604,1,'2008-05-16 21:21:29',3310504477,1),(264932864,425638951,16814448,459604,1,'2008-05-16 21:21:29',3310504520,1),(264932865,425666963,16808060,459604,1,'2008-05-16 21:21:29',3310504515,1),(264932866,425719054,16791351,459604,1,'2008-05-16 21:21:29',3310504519,1),(264932867,425742643,16764323,459604,1,'2008-05-16 21:21:29',3310504530,1),(264932868,425780974,16717637,459604,1,'2008-05-16 21:21:29',3310504529,1),(264932869,425792277,16694540,459604,1,'2008-05-16 21:21:29',3310504190,1),(264932870,425800631,16703877,459604,1,'2008-05-16 21:21:29',3310504532,1),(264932871,425806528,16688151,459604,1,'2008-05-16 21:21:29',3310504190,1),(265050188,425101882,15336032,462689,1,'2008-05-17 12:19:49',3310491451,1),(265518806,425101014,15339653,470312,1,'2008-05-18 12:17:16',3310491451,1),(266322580,425779470,15180282,498434,1,'2008-05-22 17:17:09',3310502513,2),(266322581,425779028,15181227,498434,1,'2008-05-22 17:15:18',3310502513,1),(266322582,425778838,15181656,498434,1,'2008-05-22 17:15:18',3310502513,1),(266322583,425778206,15180797,498434,1,'2008-05-22 17:15:18',3310502513,1),(266322584,425777385,15179682,498434,1,'2008-05-22 17:15:18',3310502513,1),(266322585,425776563,15178909,498434,1,'2008-05-22 17:15:18',3310502513,1),(266322586,425775931,15178223,498434,1,'2008-05-22 17:15:18',3310502513,1),(266322587,425775236,15178394,498434,1,'2008-05-22 17:15:18',3310502513,1),(266322588,425774477,15178566,498434,1,'2008-05-22 17:15:18',3310502513,1),(266322589,425773782,15178909,498434,1,'2008-05-22 17:15:18',3310502513,1),(266322590,425773403,15179253,498434,1,'2008-05-22 17:15:18',3310502513,1),(266322676,425779091,15182686,498434,1,'2008-05-22 17:15:50',3310502513,1),(266322954,425779913,15179596,498434,1,'2008-05-22 17:17:09',3310502513,1),(266324553,425776121,15180111,498434,1,'2008-05-22 17:26:34',3310502513,1),(266324699,425779660,15183029,498434,1,'2008-05-22 17:27:37',3310502513,2),(266325046,425686489,15217155,498434,1,'2008-05-22 17:32:54',3310502502,1),(266325047,425687627,15218271,498434,1,'2008-05-22 17:32:54',3310502502,1),(266325048,425688385,15219215,498434,1,'2008-05-22 17:32:54',3310502502,1),(266325224,425686362,15225910,498434,1,'2008-05-22 17:35:02',3310502502,1),(266325225,425686236,15225395,498434,1,'2008-05-22 17:35:02',3310502502,1),(266325226,425686742,15223163,498434,1,'2008-05-22 17:35:02',3310502502,1),(266325227,425687437,15221275,498434,1,'2008-05-22 17:35:02',3310502502,1),(266325228,425689270,15218614,498434,1,'2008-05-22 17:35:02',3310502502,1),(266325229,425690471,15217756,498434,1,'2008-05-22 17:35:02',3310502502,1),(266325230,425691988,15216812,498434,1,'2008-05-22 17:35:02',3310502502,1),(266325231,425692557,15216726,498434,1,'2008-05-22 17:35:02',3310502502,1),(266325232,425694264,15216812,498434,1,'2008-05-22 17:35:02',3310502502,1),(266325399,425685414,15216211,498434,1,'2008-05-22 17:37:33',3310502500,1),(266325427,425690155,15219730,498434,1,'2008-05-22 17:38:53',3310502502,1),(266325428,425689649,15218357,498434,1,'2008-05-22 17:38:53',3310502502,1),(266326164,425633013,15276773,498434,1,'2008-05-22 17:52:10',3310502504,1),(266326319,425632823,15276258,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326320,425633835,15276173,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326321,425635162,15276001,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326322,425637059,15276001,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326323,425638576,15276001,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326324,425639777,15276087,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326325,425640789,15276344,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326326,425641421,15276430,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326327,425642116,15276258,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326328,425642369,15275743,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326329,425642369,15275057,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326330,425642116,15274370,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326331,425641800,15273855,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326332,425641484,15273426,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326333,425640915,15272825,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326334,425640662,15271881,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326335,425640852,15270937,498434,1,'2008-05-22 17:56:24',3310502498,1),(266326336,425641294,15270422,498434,1,'2008-05-22 17:56:24',3310502498,1),(266326337,425641926,15269907,498434,1,'2008-05-22 17:56:24',3310502498,1),(266326338,425642622,15269564,498434,1,'2008-05-22 17:56:24',3310502498,1),(266326339,425643507,15269478,498434,1,'2008-05-22 17:56:24',3310502498,1),(266326340,425644518,15269392,498434,1,'2008-05-22 17:56:24',3310502499,1),(266326341,425645150,15269564,498434,1,'2008-05-22 17:56:24',3310502499,1),(266326342,425645466,15270164,498434,1,'2008-05-22 17:56:24',3310502499,1),(266326343,425645656,15271023,498434,1,'2008-05-22 17:56:24',3310502499,1),(266326344,425645846,15272138,498434,1,'2008-05-22 17:56:24',3310502505,1),(266326345,425645909,15273168,498434,1,'2008-05-22 17:56:24',3310502505,1),(266326346,425645846,15274113,498434,1,'2008-05-22 17:56:24',3310502505,1),(266326347,425645909,15274971,498434,1,'2008-05-22 17:56:24',3310502505,1),(266326348,425646162,15275658,498434,1,'2008-05-22 17:56:24',3310502505,1),(266326349,425646668,15276173,498434,1,'2008-05-22 17:56:24',3310502505,1),(266326350,425647426,15276687,498434,1,'2008-05-22 17:56:24',3310502505,1),(266326393,425646541,15272825,498434,1,'2008-05-22 17:58:10',3310502505,1),(266326394,425647742,15272482,498434,1,'2008-05-22 17:58:10',3310502505,1),(266326395,425648880,15272224,498434,1,'2008-05-22 17:58:10',3310502505,1),(266326396,425649828,15271967,498434,1,'2008-05-22 17:58:10',3310502505,1),(266326397,425650397,15271452,498434,1,'2008-05-22 17:58:10',3310502505,1),(266326398,425650650,15270937,498434,1,'2008-05-22 17:58:10',3310502499,1),(266326399,425650840,15270422,498434,1,'2008-05-22 17:58:10',3310502499,1),(266326487,425642559,15276516,498434,1,'2008-05-22 18:00:45',3310502504,1),(266326488,425643001,15277460,498434,1,'2008-05-22 18:00:45',3310502504,1),(266326489,425643570,15278232,498434,1,'2008-05-22 18:00:45',3310502504,1),(266326490,425644202,15278833,498434,1,'2008-05-22 18:00:45',3310502504,1),(266326491,425644834,15279520,498434,1,'2008-05-22 18:00:45',3310502505,1),(266326492,425645277,15280121,498434,1,'2008-05-22 18:00:45',3310502505,1),(266326493,425645783,15280893,498434,1,'2008-05-22 18:00:45',3310502505,1),(266326494,425645846,15281237,498434,1,'2008-05-22 18:00:45',3310502505,1),(266326495,425645719,15281666,498434,1,'2008-05-22 18:00:45',3310502505,1),(266326496,425645340,15281752,498434,1,'2008-05-22 18:00:45',3310502505,1),(266326497,425644898,15281666,498434,1,'2008-05-22 18:00:45',3310502505,1),(266326498,425644076,15281494,498434,1,'2008-05-22 18:00:45',3310502504,1),(266326499,425643064,15281151,498434,1,'2008-05-22 18:00:45',3310502504,1),(266326500,425642369,15280979,498434,1,'2008-05-22 18:00:45',3310502504,1),(266326501,425641674,15280893,498434,1,'2008-05-22 18:00:45',3310502504,1),(266326502,425641041,15281151,498434,1,'2008-05-22 18:00:45',3310502504,1),(266326503,425640156,15281666,498434,1,'2008-05-22 18:00:45',3310502504,1),(266326504,425639145,15282266,498434,1,'2008-05-22 18:00:45',3310502504,1),(266326505,425638513,15282781,498434,1,'2008-05-22 18:00:45',3310502504,1),(266327105,425631496,15278061,498434,1,'2008-05-22 18:08:07',3310502504,1),(266327106,425632065,15276602,498434,1,'2008-05-22 18:08:07',3310502504,1),(266328657,425554831,15326753,498434,1,'2008-05-22 18:23:35',3310502459,1),(266328658,425554136,15325379,498434,1,'2008-05-22 18:23:35',3310502457,1),(266328659,425553566,15323920,498434,1,'2008-05-22 18:23:35',3310502457,1),(266328660,425553250,15322289,498434,1,'2008-05-22 18:23:35',3310502457,1),(266328661,425553250,15320573,498434,1,'2008-05-22 18:23:35',3310502457,1),(266328662,425553250,15318770,498434,1,'2008-05-22 18:23:35',3310502457,1),(266328663,425553377,15317225,498434,1,'2008-05-22 18:23:35',3310502457,1),(266328664,425553566,15315680,498434,1,'2008-05-22 18:23:35',3310502457,1),(266328665,425553693,15314650,498434,1,'2008-05-22 18:23:35',3310502457,1),(266328829,425553250,15319371,498434,1,'2008-05-22 18:25:06',3310502457,1),(266328830,425551859,15319371,498434,1,'2008-05-22 18:25:06',3310502457,1),(266328831,425550089,15319285,498434,1,'2008-05-22 18:25:06',3310502457,1),(266328832,425548256,15319114,498434,1,'2008-05-22 18:25:06',3310502457,1),(266328833,425546296,15318942,498434,1,'2008-05-22 18:25:06',3310502457,1),(266328834,425543387,15318427,498434,1,'2008-05-22 18:25:06',3310502457,1),(266328982,425555716,15334821,72964,1,'2008-08-05 20:37:35',3310502459,3),(266329104,425564884,15346751,498434,1,'2008-05-22 18:32:56',3310502462,1),(266329120,425566970,15349583,498434,1,'2008-05-22 18:33:39',3310502462,1),(266329121,425567476,15349498,498434,1,'2008-05-22 18:33:39',3310502462,1),(266329122,425567729,15348811,498434,1,'2008-05-22 18:33:39',3310502462,1),(266329123,425567665,15348124,498434,1,'2008-05-22 18:33:39',3310502462,1),(266329124,425567349,15347781,498434,1,'2008-05-22 18:33:39',3310502462,1),(266329307,425566527,15348639,498434,1,'2008-05-22 18:38:15',3310502462,1),(266329457,425561090,15369410,498434,1,'2008-05-22 18:39:57',3310502459,1),(266329707,425571901,15366235,498434,1,'2008-05-22 19:36:41',3310502462,2),(266329708,425572218,15368466,498434,1,'2008-05-22 18:44:19',3310502462,1),(266329709,425572787,15370354,498434,1,'2008-05-22 18:44:19',3310502462,1),(266329710,425573356,15372500,498434,1,'2008-05-22 18:44:19',3310502462,1),(266329711,425574114,15373959,498434,1,'2008-05-22 18:44:19',3310502462,1),(266329712,425574430,15374904,498434,1,'2008-05-22 18:44:19',3310502462,1),(266329713,425574494,15375676,498434,1,'2008-05-22 18:44:19',3310502462,1),(266329714,425574430,15376448,498434,1,'2008-05-22 18:44:19',3310502462,1),(266329715,425574051,15377564,498434,1,'2008-05-22 18:44:19',3310502462,1),(266329716,425573672,15378852,498434,1,'2008-05-22 18:44:19',3310502462,1),(266329717,425573608,15380053,498434,1,'2008-05-22 18:44:19',3310502462,1),(266329718,425573545,15382285,498434,1,'2008-05-22 18:44:19',3310502548,1),(266329719,425573861,15383830,498434,1,'2008-05-22 18:44:19',3310502548,1),(266329720,425574430,15385632,498434,1,'2008-05-22 18:44:19',3310502548,1),(266329721,425574999,15387263,498434,1,'2008-05-22 18:44:19',3310502548,1),(266329722,425576264,15390181,498434,1,'2008-05-22 18:44:19',3310502548,1),(266329723,425577275,15392670,498434,1,'2008-05-22 18:44:19',3310502548,1),(266329724,425578034,15395074,498434,1,'2008-05-22 18:44:19',3310502548,1),(266329725,425578603,15397477,498434,1,'2008-05-22 18:44:19',3310502548,1),(266329726,425578982,15398335,498434,1,'2008-05-22 18:44:19',3310502548,1),(266329727,425567918,15350270,498434,1,'2008-05-22 19:36:41',3310502462,2),(266329728,425568614,15352244,498434,1,'2008-05-22 19:38:30',3310502462,3),(266329729,425568867,15354047,498434,1,'2008-05-22 19:38:30',3310502462,3),(266329730,425568993,15355677,498434,1,'2008-05-22 19:36:41',3310502462,2),(266329731,425569056,15358081,498434,1,'2008-05-22 19:36:41',3310502462,2),(266329732,425568993,15361256,498434,1,'2008-05-22 19:36:41',3310502462,2),(266329733,425569373,15362286,498434,1,'2008-05-22 19:38:30',3310502462,3),(266329734,425570005,15363059,498434,1,'2008-05-22 19:36:41',3310502462,2),(266329735,425571206,15364518,498434,1,'2008-05-22 19:36:41',3310502462,2),(266330464,425573482,15375590,498434,1,'2008-05-22 19:33:13',3310502462,2),(266330465,425572534,15375161,498434,1,'2008-05-22 18:48:59',3310502462,1),(266330466,425571775,15374560,498434,1,'2008-05-22 18:48:59',3310502462,1),(266330467,425570953,15373959,498434,1,'2008-05-22 18:48:59',3310502462,1),(266330468,425569942,15372586,498434,1,'2008-05-22 18:48:59',3310502462,1),(266330469,425568993,15371041,498434,1,'2008-05-22 18:48:59',3310502462,1),(266330470,425568108,15370183,498434,1,'2008-05-22 18:48:59',3310502462,1),(266330471,425567096,15369925,498434,1,'2008-05-22 18:48:59',3310502462,1),(266330472,425565832,15369754,498434,1,'2008-05-22 18:48:59',3310502462,1),(266330473,425564504,15369668,498434,1,'2008-05-22 18:48:59',3310502462,1),(266330475,425561146,15370222,2836771,1,'2009-10-13 18:40:26',3310502459,2),(266330476,425559130,15370784,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330477,425557613,15370784,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330478,425555526,15371041,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330479,425552997,15371470,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330480,425550026,15371985,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330481,425547813,15372329,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330482,425545600,15372157,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330483,425544652,15371899,2895121,1,'2009-10-19 19:03:33',3310502459,2),(266330484,425543071,15371556,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330485,425541870,15371556,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330486,425540289,15371556,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330487,425538645,15371127,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330488,425536812,15370612,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330489,425535041,15370526,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330490,425533650,15370612,498434,1,'2008-05-22 18:48:59',3310502458,1),(266330491,425532196,15369496,498434,1,'2008-05-22 18:48:59',3310502458,1),(266330492,425531058,15368810,498434,1,'2008-05-22 18:48:59',3310502458,1),(266330493,425529983,15367865,498434,1,'2008-05-22 18:48:59',3310502458,1),(266330494,425528213,15366406,498434,1,'2008-05-22 18:48:59',3310502458,1),(266330495,425526885,15364776,498434,1,'2008-05-22 18:48:59',3310502458,1),(266330502,425527328,15372672,498434,1,'2008-05-22 18:49:24',3310502458,1),(266330503,425527960,15371299,498434,1,'2008-05-22 18:49:24',3310502458,1),(266330504,425528908,15370011,498434,1,'2008-05-22 18:49:24',3310502458,1),(266330505,425529477,15368895,498434,1,'2008-05-22 18:49:24',3310502458,1),(266330517,425526632,15369840,498434,1,'2008-05-22 18:50:32',3310502458,1),(266330518,425527770,15371728,498434,1,'2008-05-22 18:50:32',3310502458,1),(266330793,425545284,15370698,498434,1,'2008-05-22 18:55:14',3310502459,1),(266330794,425545916,15369496,498434,1,'2008-05-22 18:55:14',3310502459,1),(266330795,425546675,15368466,498434,1,'2008-05-22 18:55:14',3310502459,1),(266330955,425550152,15362887,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330956,425549899,15362029,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330957,425550089,15361171,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330958,425550532,15360741,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330959,425551543,15360312,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330960,425552555,15359883,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330961,425553250,15359454,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330962,425553756,15358596,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330963,425554515,15358338,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330964,425555337,15358338,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330965,425556095,15358424,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330966,425556854,15358424,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330991,425557360,15342889,498434,1,'2008-05-22 19:00:25',3310502459,1),(266330992,425556538,15343060,498434,1,'2008-05-22 19:00:25',3310502459,1),(266330993,425555843,15342631,498434,1,'2008-05-22 19:00:25',3310502459,1),(266330994,425555084,15341687,498434,1,'2008-05-22 19:00:25',3310502459,1),(266330995,425554452,15341172,498434,1,'2008-05-22 19:00:25',3310502459,1),(266330996,425553756,15341172,498434,1,'2008-05-22 19:00:25',3310502459,1),(266330997,425553187,15341515,498434,1,'2008-05-22 19:00:25',3310502459,1),(266330998,425552555,15342460,498434,1,'2008-05-22 19:00:25',3310502459,1),(266330999,425552049,15343575,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331000,425552555,15344262,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331001,425553250,15345120,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331002,425554578,15346579,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331003,425556348,15348554,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331004,425557107,15349412,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331005,425557297,15350613,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331006,425557107,15351300,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331007,425556728,15351901,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331008,425556538,15352588,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331009,425556854,15353017,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331010,425557297,15352759,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331011,425557423,15351987,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331017,425551164,15342889,498434,1,'2008-05-22 19:00:53',3310502459,1),(266331018,425550405,15342202,498434,1,'2008-05-22 19:00:53',3310502459,1),(266331019,425549710,15341430,498434,1,'2008-05-22 19:00:53',3310502459,1),(266331020,425548888,15340571,498434,1,'2008-05-22 19:00:53',3310502459,1),(266331021,425548319,15339455,498434,1,'2008-05-22 19:00:53',3310502459,1),(266331022,425547939,15338683,498434,1,'2008-05-22 19:00:53',3310502459,1),(266331023,425547939,15337396,498434,1,'2008-05-22 19:00:53',3310502459,1),(266331091,425558119,15342631,498434,1,'2008-05-22 19:02:20',3310502459,1),(266331233,425557234,15339713,498434,1,'2008-05-22 19:03:35',3310502459,1),(266331234,425558119,15339112,498434,1,'2008-05-22 19:03:35',3310502459,1),(266331235,425558751,15338940,498434,1,'2008-05-22 19:03:35',3310502459,1),(266331236,425559257,15339112,498434,1,'2008-05-22 19:03:35',3310502459,1),(266331237,425559699,15339627,498434,1,'2008-05-22 19:03:35',3310502459,1),(266331238,425560142,15340485,498434,1,'2008-05-22 19:03:35',3310502459,1),(266331239,425560584,15341430,498434,1,'2008-05-22 19:03:35',3310502459,1),(266331240,425560711,15342374,498434,1,'2008-05-22 19:03:35',3310502459,1),(266331241,425560964,15343404,498434,1,'2008-05-22 19:03:35',3310502459,1),(266331242,425561153,15344262,498434,1,'2008-05-22 19:03:35',3310502459,1),(266331243,425561406,15345120,498434,1,'2008-05-22 19:03:35',3310502459,1),(266331332,425554199,15342030,498434,1,'2008-05-22 19:04:03',3310502459,1),(266331333,425552871,15344519,498434,1,'2008-05-22 19:04:03',3310502459,1),(266331567,425553819,15344605,498434,1,'2008-05-22 19:07:44',3310502459,1),(266331568,425554894,15342545,498434,1,'2008-05-22 19:07:44',3310502459,1),(266331569,425553946,15341687,498434,1,'2008-05-22 19:07:44',3310502459,1),(266331570,425552745,15343575,498434,1,'2008-05-22 19:07:44',3310502459,1),(266331607,425549773,15337052,498434,1,'2008-05-22 19:09:02',3310502459,1),(266331608,425549077,15338254,498434,1,'2008-05-22 19:09:02',3310502459,1),(266331609,425552808,15342116,498434,1,'2008-05-22 19:09:02',3310502459,1),(266331623,425553756,15339799,498434,1,'2008-05-22 19:09:45',3310502459,1),(266331624,425549330,15334992,498434,1,'2008-05-22 19:09:45',3310502459,1),(266331625,425548445,15336623,498434,1,'2008-05-22 19:09:45',3310502459,1),(266331626,425548508,15338597,498434,1,'2008-05-22 19:09:45',3310502459,1),(266331627,425549204,15339970,498434,1,'2008-05-22 19:09:45',3310502459,1),(266331628,425551859,15342631,498434,1,'2008-05-22 19:09:45',3310502459,1),(266331736,425550911,15339026,498434,1,'2008-05-22 19:10:59',3310502459,1),(266331970,425554009,15343318,498434,1,'2008-05-22 19:12:00',3310502459,1),(266331984,425556601,15331902,498434,1,'2008-05-22 19:12:28',3310502459,1),(266331986,425559130,15330958,498434,1,'2008-05-22 19:12:28',3310502459,1),(266331987,425560268,15330615,498434,1,'2008-05-22 19:12:28',3310502459,1),(266331988,425561217,15330443,498434,1,'2008-05-22 19:12:28',3310502459,1),(266331989,425562418,15329757,498434,1,'2008-05-22 19:12:28',3310502462,1),(266332075,425558055,15330357,498434,1,'2008-05-22 19:19:03',3310502459,2),(266332076,425558877,15327782,787878,1,'2009-01-15 00:13:52',3310502459,3),(266332077,425559826,15325894,787878,1,'2009-01-15 00:13:52',3310502457,4),(266332078,425560142,15324006,787878,1,'2009-01-15 00:13:52',3310502457,3),(266332079,425560395,15322118,787878,1,'2009-01-15 00:13:53',3310502457,3),(266332080,425560774,15320058,787878,1,'2009-01-15 00:13:53',3310502457,3),(266332081,425561027,15318169,787878,1,'2009-01-15 00:13:53',3310502457,3),(266332082,425561153,15316281,787878,1,'2009-01-15 00:13:53',3310502457,3),(266332083,425560774,15314565,787878,1,'2009-01-15 00:13:53',3310502457,4),(266332084,425560395,15313020,787878,1,'2009-01-15 00:13:53',3310502457,3),(266332085,425560079,15311475,787878,1,'2009-01-15 00:13:53',3310502457,3),(266332086,425559573,15309844,787878,1,'2009-01-15 00:13:53',3310502457,3),(266332087,425558624,15307698,787878,1,'2009-01-15 00:14:32',3310502457,5),(266332790,425557866,15331387,498434,1,'2008-05-22 19:22:39',3310502459,2),(266332950,425557992,15331387,498434,1,'2008-05-22 19:19:44',3310502459,1),(266333823,425558372,15316624,498434,1,'2008-05-22 19:24:02',3310502457,1),(266333914,425557423,15326152,498434,1,'2008-05-22 19:24:40',3310502457,1),(266333915,425557423,15324435,498434,1,'2008-05-22 19:24:40',3310502457,1),(266333916,425557234,15323834,498434,1,'2008-05-22 19:24:40',3310502457,1),(266333917,425556538,15323663,725665,1,'2009-03-02 22:27:41',3310502457,13),(266333981,425558435,15326066,498434,1,'2008-05-22 19:25:06',3310502457,1),(266333982,425559446,15326924,787878,1,'2009-01-15 00:13:52',3310502459,4),(266334276,425558245,15328126,498434,1,'2008-05-22 19:26:33',3310502459,1),(266334277,425559193,15325637,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334278,425559762,15322976,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334279,425560332,15319543,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334280,425560584,15316624,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334281,425559510,15316024,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334282,425558498,15315509,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334283,425557486,15315251,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334284,425557550,15317054,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334285,425557486,15318599,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334286,425557423,15320487,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334287,425557297,15322289,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334288,425557044,15324521,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334289,425556917,15326667,498434,1,'2008-05-22 19:30:08',3310502459,2),(266334290,425556917,15327525,498434,1,'2008-05-22 19:30:08',3310502459,2),(266334665,425551101,15327353,498434,1,'2008-05-22 19:28:13',3310502459,1),(266334666,425550532,15327954,498434,1,'2008-05-22 19:28:13',3310502459,1),(266334668,425550216,15328469,498434,1,'2008-05-22 19:28:13',3310502459,1),(266334669,425550089,15329242,498434,1,'2008-05-22 19:28:13',3310502459,1),(266334670,425550279,15330014,498434,1,'2008-05-22 19:28:13',3310502459,1),(266334671,425550595,15330615,498434,1,'2008-05-22 19:28:13',3310502459,1),(266334672,425551101,15331645,498434,1,'2008-05-22 19:28:13',3310502459,1),(266334931,425556285,15326066,725665,1,'2009-03-02 22:27:42',3310502457,12),(266334932,425556285,15327267,725665,1,'2009-03-02 22:27:42',3310502459,13),(266336448,425573545,15383658,498434,1,'2008-05-22 19:41:16',3310502548,2),(266336449,425572597,15382972,498434,1,'2008-05-22 19:35:31',3310502548,1),(266336450,425572218,15382371,498434,1,'2008-05-22 19:35:31',3310502548,1),(266336451,425572028,15381512,498434,1,'2008-05-22 19:35:31',3310502548,1),(266336452,425572028,15380568,498434,1,'2008-05-22 19:35:31',3310502462,1),(266336453,425571965,15379624,498434,1,'2008-05-22 19:35:31',3310502462,1),(266336454,425571965,15377993,498434,1,'2008-05-22 19:35:31',3310502462,1),(266336455,425571838,15376963,498434,1,'2008-05-22 19:35:31',3310502462,1),(266336456,425571712,15376363,498434,1,'2008-05-22 19:35:31',3310502462,1),(266336457,425571649,15375590,498434,1,'2008-05-22 19:35:31',3310502462,1),(266336982,425568361,15351300,498434,1,'2008-05-22 19:38:30',3310502462,1),(266337369,425567413,15350613,498434,1,'2008-05-22 19:46:28',3310502462,2),(266337370,425567918,15351643,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337371,425568234,15353360,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337372,425568361,15355077,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337373,425568361,15357308,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337374,425568361,15359883,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337375,425568487,15362029,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337377,425569120,15365205,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337378,425570384,15367780,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337379,425572534,15372071,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337380,425573672,15374303,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337381,425573925,15374989,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337382,425573925,15376363,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337384,425573482,15377736,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337386,425573103,15379109,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337388,425572913,15380654,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337389,425572976,15382542,498434,1,'2008-05-22 19:40:52',3310502548,1),(266337390,425573672,15385203,498434,1,'2008-05-22 19:40:52',3310502548,1),(266337391,425574114,15386319,498434,1,'2008-05-22 19:40:52',3310502548,1),(266337392,425575252,15389752,498434,1,'2008-05-22 19:40:52',3310502548,1),(266337393,425576264,15391898,498434,1,'2008-05-22 19:40:52',3310502548,1),(266337394,425577212,15394902,498434,1,'2008-05-22 19:40:52',3310502548,1),(266337395,425577971,15397906,498434,1,'2008-05-22 19:40:52',3310502548,1),(266337396,425579551,15402112,498434,1,'2008-05-22 19:40:52',3310502548,1),(266337397,425579741,15402970,498434,1,'2008-05-22 19:40:52',3310502548,1),(266338686,425565579,15351386,498434,1,'2008-05-22 19:46:00',3310502462,1),(266340072,425455858,15205846,513066,1,'2008-05-24 16:09:07',3310502436,3),(266340199,425464986,15213055,498434,1,'2008-05-22 19:53:32',3310502436,1),(266340717,425472321,15217175,498434,1,'2008-05-22 20:01:08',3310502438,2),(266340718,425471562,15219406,498434,1,'2008-05-22 20:01:08',3310502438,2),(266340719,425471436,15220436,498434,1,'2008-05-22 19:55:12',3310502438,1),(266340720,425471625,15221037,498434,1,'2008-05-22 19:55:12',3310502438,1),(266340721,425472131,15221466,498434,1,'2008-05-22 19:55:12',3310502438,1),(266340722,425472763,15221895,498434,1,'2008-05-22 19:55:12',3310502438,1),(266340993,425471119,15218891,498434,1,'2008-05-22 19:57:05',3310502438,1),(266340994,425469981,15217690,498434,1,'2008-05-22 19:57:05',3310502438,1),(266340995,425469159,15216917,498434,1,'2008-05-22 19:57:05',3310502438,1),(266340996,425468084,15216488,498434,1,'2008-05-22 19:57:05',3310502438,1),(266340998,425466630,15216660,498434,1,'2008-05-22 19:57:05',3310502438,1),(266340999,425464670,15216831,498434,1,'2008-05-22 19:57:05',3310502438,1),(266341000,425464037,15216831,498434,1,'2008-05-22 19:57:05',3310502438,1),(266341001,425464417,15220093,498434,1,'2008-05-22 19:57:05',3310502438,1),(266341002,425465681,15221037,498434,1,'2008-05-22 19:57:05',3310502438,1),(266341003,425466946,15221552,498434,1,'2008-05-22 19:57:05',3310502438,1),(266341004,425468400,15221380,498434,1,'2008-05-22 19:57:05',3310502438,1),(266341005,425469159,15221123,498434,1,'2008-05-22 19:57:05',3310502438,1),(266341006,425470297,15221123,498434,1,'2008-05-22 19:57:05',3310502438,1),(266341007,425471119,15220608,498434,1,'2008-05-22 19:57:05',3310502438,1),(266341806,425472574,15216059,498434,1,'2008-05-22 20:01:08',3310502436,1),(266380119,425457461,15203356,501202,1,'2008-05-22 22:30:34',3310502436,1),(266380259,425456997,15205503,513066,1,'2008-05-24 16:09:07',3310502436,2),(266380260,425456238,15203615,513066,1,'2008-05-24 16:09:07',3310502436,2),(266380266,425457398,15204300,501202,1,'2008-05-22 22:31:58',3310502436,1),(266380267,425457904,15203957,501202,1,'2008-05-22 22:31:58',3310502436,1),(266380268,425455754,15205502,501202,1,'2008-05-22 22:31:58',3310502436,1),(266619895,425493545,15244813,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619896,425492850,15244899,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619897,425492154,15244813,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619898,425491585,15244384,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619899,425491142,15243955,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619900,425490637,15243182,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619901,425490068,15242839,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619902,425489372,15242753,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619903,425488550,15242667,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619904,425487728,15242667,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619905,425486779,15242496,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619906,425485578,15242324,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619907,425483808,15242067,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619908,425481721,15241809,513066,1,'2008-05-24 16:04:48',3310502439,2),(266619909,425479445,15241466,513066,1,'2008-05-24 16:04:48',3310502438,2),(266619955,425485009,15240608,513066,1,'2008-05-24 15:58:45',3310502439,1),(266619956,425484440,15240264,513066,1,'2008-05-24 15:58:45',3310502439,1),(266620040,425490447,15240779,513066,1,'2008-05-24 15:59:29',3310502439,1),(266620041,425491142,15241294,513066,1,'2008-05-24 15:59:29',3310502439,1),(266620042,425491712,15241809,513066,1,'2008-05-24 15:59:29',3310502439,1),(266620043,425492028,15242667,513066,1,'2008-05-24 15:59:29',3310502439,1),(266620044,425492154,15243697,513066,1,'2008-05-24 15:59:29',3310502439,1),(266622050,425734780,15185578,513066,1,'2008-05-24 16:12:30',3310502512,1),(266622051,425734338,15183518,513066,1,'2008-05-24 16:12:30',3310502512,1),(266622052,425733706,15182403,513066,1,'2008-05-24 16:12:30',3310502512,1),(266622053,425732947,15181287,513066,1,'2008-05-24 16:12:30',3310502512,1),(266622054,425732252,15180600,513066,1,'2008-05-24 16:12:30',3310502512,1),(266622055,425731241,15180429,513066,1,'2008-05-24 16:12:30',3310502512,1),(266622056,425730419,15180686,513066,1,'2008-05-24 16:12:30',3310502512,1),(266622057,425723592,15183003,513066,1,'2008-05-24 16:12:30',3310502501,1),(266622058,425722644,15182918,513066,1,'2008-05-24 16:12:30',3310502501,1),(266622059,425722328,15181716,513066,1,'2008-05-24 16:12:30',3310502501,1),(266622060,425722518,15180600,513066,1,'2008-05-24 16:12:30',3310502501,1),(266622061,425723466,15179742,513066,1,'2008-05-24 16:12:30',3310502501,1),(266622062,425730229,15176995,513066,1,'2008-05-24 16:12:30',3310502512,1),(266622086,425735855,15183003,513066,1,'2008-05-24 16:13:11',3310502512,1),(266622348,425539542,15295997,725665,1,'2009-03-02 22:31:54',3310502457,3),(266622349,425538151,15295482,725665,1,'2009-03-02 22:31:54',3310502457,3),(266622350,425535432,15294367,725665,1,'2009-03-02 22:31:53',3310502457,3),(266622351,425532587,15292564,725665,1,'2009-03-02 22:31:53',3310502456,3);
INSERT INTO `current_nodes` VALUES (266622352,425530184,15289646,725665,1,'2009-03-02 22:31:53',3310502456,3),(266622353,425526707,15285354,725665,1,'2009-03-02 22:31:53',3310502456,3),(266622354,425524114,15283123,725665,1,'2009-03-02 22:31:53',3310502456,3),(266622355,425522723,15281406,725665,1,'2009-03-02 22:31:53',3310502456,3),(266622356,425522091,15280033,725665,1,'2009-03-02 22:31:52',3310502456,3),(266622357,425521901,15278917,725665,1,'2009-03-02 22:31:52',3310502456,3),(266622358,425522344,15278488,725665,1,'2009-03-02 22:31:52',3310502456,3),(266622359,425523609,15278488,725665,1,'2009-03-02 22:31:52',3310502456,3),(266622360,425525126,15279346,725665,1,'2009-03-02 22:31:52',3310502456,3),(266622361,425527845,15281406,725665,1,'2009-03-02 22:31:51',3310502456,3),(266622362,425529868,15283552,725665,1,'2009-03-02 22:31:51',3310502456,3),(266622363,425531765,15285183,725665,1,'2009-03-02 22:31:51',3310502456,3),(266622364,425533346,15286556,725665,1,'2009-03-02 22:31:51',3310502456,3),(266622365,425534990,15287414,725665,1,'2009-03-02 22:31:51',3310502457,3),(266622366,425536301,15287142,725665,1,'2009-03-02 22:33:31',3310502457,5),(266622367,425535922,15284653,725665,1,'2009-03-02 22:33:50',3310502457,15),(266622460,425537772,15291363,513066,1,'2008-05-24 16:17:44',3310502457,1),(266622461,425537013,15294882,725665,1,'2009-03-02 22:31:53',3310502457,3),(266622567,425537961,15294281,513066,1,'2008-05-24 16:19:47',3310502457,1),(266622568,425538657,15291019,513066,1,'2008-05-24 16:19:47',3310502457,1),(266622569,425537329,15290161,513066,1,'2008-05-24 16:19:47',3310502457,1),(266622570,425536697,15292564,513066,1,'2008-05-24 16:19:47',3310502457,1),(266622572,425537076,15293079,513066,1,'2008-05-24 16:19:47',3310502457,1),(266622573,425536823,15293938,513066,1,'2008-05-24 16:19:47',3310502457,1),(266622595,425538088,15291878,513066,1,'2008-05-24 16:20:09',3310502457,1),(266622986,425797454,15188075,513066,1,'2008-05-24 16:28:02',3310502516,1),(266623545,425795368,15186187,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623546,425794673,15185500,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623547,425794041,15184728,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623548,425793472,15184213,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623549,425792145,15183612,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623550,425790818,15182925,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623551,425789870,15182153,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623552,425788858,15181123,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623553,425787847,15179234,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623554,425786773,15176831,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623555,425786393,15175887,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623556,425786267,15175029,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623557,425786267,15174085,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623558,425786773,15173655,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623559,425787341,15173741,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623560,425788100,15174256,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623561,425789301,15175458,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623562,425790691,15176745,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623563,425792082,15177604,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623564,425792650,15177947,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623565,425793219,15177689,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623566,425793598,15177174,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623567,425793725,15176660,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623568,425793535,15176145,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623569,425792714,15174943,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623570,425791386,15173055,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623571,425790249,15170995,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623572,425789301,15169278,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623573,425788416,15167046,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623574,425787405,15165587,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623575,425786520,15164729,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623576,425784940,15163785,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623577,425782412,15162841,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623578,425780136,15162154,513066,1,'2008-05-24 16:34:00',3310502513,1),(266623579,425777798,15161639,513066,1,'2008-05-24 16:34:00',3310502513,1),(266623580,425776281,15160952,513066,1,'2008-05-24 16:34:00',3310502491,1),(266623581,425774764,15160523,513066,1,'2008-05-24 16:34:00',3310502491,1),(266623582,425773753,15160180,513066,1,'2008-05-24 16:34:00',3310502491,1),(266623583,425773058,15159923,513066,1,'2008-05-24 16:34:00',3310502491,1),(266623584,425772299,15159408,513066,1,'2008-05-24 16:34:00',3310502491,1),(266623585,425771857,15158635,513066,1,'2008-05-24 16:34:00',3310502491,1),(266623586,425771541,15157691,513066,1,'2008-05-24 16:34:00',3310502491,1),(266623587,425771478,15157090,513066,1,'2008-05-24 16:34:00',3310502491,1),(266623588,425770972,15156661,513066,1,'2008-05-24 16:34:00',3310502491,1),(266623589,425769392,15156232,513066,1,'2008-05-24 16:34:00',3310502491,1),(266623590,425797454,15187303,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623591,425797011,15186959,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623592,425796126,15186444,513066,1,'2008-05-24 16:34:00',3310502516,1),(268081065,425822138,15190634,19873,1,'2008-06-02 18:28:51',3310502517,1),(268081234,425821954,15195994,19873,1,'2008-06-02 18:29:59',3310502517,1),(268081236,425822081,15197281,19873,1,'2008-06-02 18:29:59',3310502517,1),(268081237,425822460,15198826,19873,1,'2008-06-02 18:29:59',3310502517,1),(268081238,425823029,15200800,19873,1,'2008-06-02 18:29:59',3310502517,1),(268081239,425823155,15202002,19873,1,'2008-06-02 18:31:13',3310502517,2),(268081241,425823155,15203032,19873,1,'2008-06-02 18:29:59',3310502517,1),(268081242,425823092,15204062,19873,1,'2008-06-02 18:29:59',3310502517,1),(268081243,425822902,15205006,19873,1,'2008-06-02 18:31:20',3310502517,2),(268081244,425822523,15206465,19873,1,'2008-06-02 18:31:13',3310502517,2),(268081245,425822460,15207409,19873,1,'2008-06-02 18:29:59',3310502517,1),(268081246,425822650,15207839,19873,1,'2008-06-02 18:29:59',3310502517,1),(268081464,425822270,15192647,19873,1,'2008-06-02 18:31:13',3310502517,1),(268082898,425440876,15104812,19873,1,'2008-06-02 18:40:07',3310502409,1),(268082899,425439554,15103812,19873,1,'2008-06-02 18:40:07',3310502409,1),(268084313,425782875,14790027,19873,1,'2008-06-02 18:53:32',3310502134,1),(268085831,425772194,14799383,19873,1,'2008-06-02 18:58:22',3310502131,1),(268091938,425656142,14914782,21109,1,'2008-06-02 23:05:27',3310502123,1),(268091940,425654625,14916327,21109,1,'2008-06-02 23:05:27',3310502123,1),(268091942,425652286,14919503,21109,1,'2008-06-02 23:05:27',3310502123,1),(268091944,425649820,14922250,21109,1,'2008-06-02 23:05:27',3310502123,1),(268091946,425647608,14924653,21109,1,'2008-06-02 23:05:27',3310502123,1),(268091948,425645838,14926455,21109,1,'2008-06-02 23:05:27',3310502123,1),(268091950,425644131,14929545,21109,1,'2008-06-02 23:05:27',3310502122,1),(268092433,425657975,14911178,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092434,425657849,14912379,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092435,425657406,14913667,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092436,425656774,14915469,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092437,425655762,14917100,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092438,425654119,14919761,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092439,425652349,14921906,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092441,425650263,14924052,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092442,425648619,14925940,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092443,425648050,14926627,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092444,425647861,14927657,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092445,425647987,14928773,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092446,425648493,14929631,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092447,425649441,14929459,21109,1,'2008-06-02 23:11:39',3310502123,2),(268092448,425650389,14928687,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092449,425654941,14924138,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092450,425656205,14922078,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092451,425658354,14918216,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092452,425660377,14914353,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092453,425663032,14909804,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092454,425663854,14908860,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092455,425664992,14908259,25362,1,'2008-06-03 01:06:15',3310502123,2),(268092682,425654309,14926799,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092683,425654182,14927829,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092684,425653740,14928859,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092685,425653234,14929889,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092686,425652918,14930747,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092687,425652791,14931434,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092688,425652981,14931949,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092689,425653613,14931691,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092691,425653992,14930575,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092692,425654688,14929631,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092693,425655636,14928687,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092694,425656268,14928344,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092695,425656711,14928601,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092696,425656900,14929288,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092812,425657150,14914396,21109,1,'2008-06-02 23:08:02',3310502123,1),(268093053,425657554,14908874,25362,1,'2008-06-03 01:01:40',3310502123,2),(268093279,425654656,14924423,21109,1,'2008-06-02 23:09:25',3310502123,1),(268093281,425654561,14925855,21109,1,'2008-06-02 23:09:25',3310502123,1),(268095978,425698385,14880562,21109,1,'2008-06-02 23:19:14',3310502124,1),(268095979,425698701,14881592,21109,1,'2008-06-02 23:19:14',3310502124,1),(268095980,425698764,14882278,21109,1,'2008-06-02 23:19:14',3310502124,1),(268095981,425698195,14883394,21109,1,'2008-06-02 23:19:14',3310502124,1),(268095982,425697247,14884596,21109,1,'2008-06-02 23:19:14',3310502124,1),(268095983,425694592,14886570,21109,1,'2008-06-02 23:19:14',3310502124,1),(268095984,425690294,14889574,21109,1,'2008-06-02 23:19:14',3310502126,1),(268095985,425687133,14892406,21109,1,'2008-06-02 23:19:14',3310502126,1),(268095986,425684857,14894466,21109,1,'2008-06-02 23:19:14',3310502126,1),(268095987,425682582,14896784,21109,1,'2008-06-02 23:19:14',3310502126,1),(268096149,425682835,14897556,21109,1,'2008-06-02 23:21:47',3310502126,1),(268096150,425683024,14899187,21109,1,'2008-06-02 23:21:47',3310502126,1),(268096151,425683720,14899874,21109,1,'2008-06-02 23:21:47',3310502126,1),(268096152,425684478,14899702,21109,1,'2008-06-02 23:21:47',3310502126,1),(268096153,425684921,14898672,21109,1,'2008-06-02 23:21:47',3310502126,1),(268096154,425683656,14896612,21109,1,'2008-06-02 23:21:47',3310502126,1),(268096174,425684921,14896011,21109,1,'2008-06-02 23:22:11',3310502126,1),(268096306,425697251,14878938,21109,1,'2008-06-02 23:23:02',3310502124,1),(268100719,425709699,14865063,21109,1,'2008-06-02 23:33:51',3310502125,1),(268100720,425709573,14866179,21109,1,'2008-06-02 23:33:51',3310502125,1),(268100721,425708372,14868067,21109,1,'2008-06-02 23:33:51',3310502125,1),(268100722,425707297,14870042,21109,1,'2008-06-02 23:33:51',3310502125,1),(268100723,425706412,14872874,21109,1,'2008-06-02 23:33:51',3310502125,1),(268100724,425705275,14877852,21109,1,'2008-06-02 23:51:15',3310502125,2),(268100725,425704769,14880770,21109,1,'2008-06-02 23:33:51',3310502125,1),(268100727,425704326,14883174,21109,1,'2008-06-02 23:51:15',3310502125,2),(268100728,425703315,14885234,21109,1,'2008-06-02 23:51:15',3310502125,3),(268100729,425696804,14892529,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100730,425695540,14894503,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100731,425694782,14895791,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100732,425694845,14897507,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100733,425694782,14898966,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100735,425694655,14901799,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100736,425694908,14904374,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100737,425694908,14905747,21109,1,'2008-06-02 23:51:15',3310502126,2),(268100738,425694402,14907464,21109,1,'2008-06-02 23:51:15',3310502126,2),(268100739,425693581,14907979,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100740,425692822,14908064,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100741,425690736,14907979,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100742,425689093,14908665,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100743,425687449,14909609,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100744,425686248,14910382,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100746,425684415,14911755,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100747,425682329,14913386,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100748,425680622,14914158,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100749,425679990,14914673,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100750,425679864,14915532,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100752,425680433,14916390,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100753,425681318,14916476,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100754,425685869,14915532,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100755,425689725,14914330,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100757,425691368,14914073,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100758,425693834,14914588,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100759,425695667,14915618,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100760,425696994,14917248,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100761,425698385,14918879,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100762,425700534,14919823,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100764,425701735,14919909,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100765,425702367,14919222,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100766,425702809,14916133,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100767,425703884,14908150,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100768,425704010,14907292,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100769,425704706,14906949,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100771,425705085,14907807,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100772,425704895,14908751,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100773,425704579,14910382,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100775,425704895,14913214,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100776,425705338,14916133,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100777,425706096,14920167,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100778,425706855,14922999,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100779,425707108,14924372,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100781,425707108,14925402,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100782,425706539,14926175,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100783,425705338,14926432,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100784,425703189,14926947,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100785,425702051,14926432,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100786,425700660,14925231,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100787,425698385,14923514,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100789,425695983,14921797,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100790,425693834,14920424,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100791,425692569,14919909,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100792,425691305,14919823,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100793,425689472,14920167,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100794,425688271,14920682,21109,1,'2008-06-02 23:33:51',3310502126,1),(268101444,425705662,14875625,21109,1,'2008-06-02 23:35:16',3310502125,1),(268101446,425706981,14876307,21109,1,'2008-06-02 23:35:16',3310502125,1),(268101448,425707803,14876050,21109,1,'2008-06-02 23:35:16',3310502125,1),(268101451,425708372,14875277,21109,1,'2008-06-02 23:35:16',3310502125,1),(268101453,425709762,14872531,21109,1,'2008-06-02 23:35:16',3310502125,1),(268101454,425710458,14871415,21109,1,'2008-06-02 23:35:16',3310502125,1),(268101456,425710900,14871243,21109,1,'2008-06-02 23:35:16',3310502125,1),(268101669,425695161,14891757,21109,1,'2008-06-02 23:36:16',3310502126,1),(268101670,425697255,14892028,21109,1,'2008-06-02 23:36:16',3310502126,1),(268103219,425696488,14897936,21109,1,'2008-06-02 23:43:12',3310502126,1),(268103220,425697500,14896907,21109,1,'2008-06-02 23:43:12',3310502126,1),(268103434,425700058,14919614,21109,1,'2008-06-02 23:44:43',3310502127,1),(268103435,425701672,14908236,21109,1,'2008-06-02 23:44:43',3310502127,1),(268103436,425701861,14906348,21109,1,'2008-06-02 23:44:43',3310502127,1),(268103437,425702557,14904030,21109,1,'2008-06-02 23:44:43',3310502127,1),(268103438,425702873,14902743,21109,1,'2008-06-02 23:44:43',3310502127,1),(268103842,425702362,14886341,21109,1,'2008-06-02 23:51:15',3310502125,4),(268103843,425701292,14886864,21109,1,'2008-06-02 23:45:55',3310502127,1),(268103844,425700407,14887551,21109,1,'2008-06-02 23:45:55',3310502127,1),(268103845,425698385,14889353,21109,1,'2008-06-02 23:45:55',3310502126,1),(268103846,425697057,14890469,21109,1,'2008-06-02 23:45:55',3310502126,1),(268103847,425696236,14890813,21109,1,'2008-06-02 23:45:55',3310502126,1),(268103848,425695477,14890898,21109,1,'2008-06-02 23:45:55',3310502126,1),(268103850,425695098,14891070,21109,1,'2008-06-02 23:45:55',3310502126,1),(268104321,425701040,14886435,21109,1,'2008-06-02 23:48:21',3310502125,1),(268104322,425700534,14886349,21109,1,'2008-06-02 23:48:21',3310502125,1),(268104323,425698701,14887208,21109,1,'2008-06-02 23:48:21',3310502126,1),(268104324,425696804,14888838,21109,1,'2008-06-02 23:48:21',3310502126,1),(268104325,425695098,14889611,21109,1,'2008-06-02 23:48:21',3310502126,1),(268104326,425694971,14891328,21109,1,'2008-06-02 23:48:21',3310502126,1),(268104327,425696236,14891242,21109,1,'2008-06-02 23:48:21',3310502126,1),(268104328,425697184,14891242,21109,1,'2008-06-02 23:48:21',3310502126,1),(268104329,425700471,14887980,21109,1,'2008-06-02 23:48:21',3310502127,1),(268104831,425694845,14906777,21109,1,'2008-06-02 23:51:15',3310502126,1),(268123180,425679299,14886214,25362,1,'2008-06-03 00:57:57',3310502124,1),(268123181,425679678,14887759,25362,1,'2008-06-03 00:57:57',3310502126,1),(268123182,425679744,14888627,25362,1,'2008-06-03 00:57:57',3310502126,1),(268123183,425671208,14883897,25362,1,'2008-06-03 01:00:29',3310502121,2),(268123184,425672725,14883725,25362,1,'2008-06-03 00:57:57',3310502124,1),(268123185,425673926,14883468,25362,1,'2008-06-03 00:57:57',3310502124,1),(268123186,425675823,14882695,25362,1,'2008-06-03 00:57:57',3310502124,1),(268123187,425677024,14882180,25362,1,'2008-06-03 00:57:57',3310502124,1),(268123188,425677592,14882352,25362,1,'2008-06-03 00:57:57',3310502124,1),(268123189,425678098,14882867,25362,1,'2008-06-03 00:57:57',3310502124,1),(268123190,425678541,14883725,25362,1,'2008-06-03 00:57:57',3310502124,1),(268123192,425678920,14884841,25362,1,'2008-06-03 00:57:57',3310502124,1),(268123710,425680121,14888446,25362,1,'2008-06-03 00:58:44',3310502126,1),(268123711,425679046,14888961,25362,1,'2008-06-03 00:58:44',3310502126,1),(268124663,425648704,14912736,25362,1,'2008-06-03 01:01:57',3310502123,1),(268124664,425649273,14912736,25362,1,'2008-06-03 01:01:57',3310502123,1),(268124667,425649652,14913251,25362,1,'2008-06-03 01:01:57',3310502123,1),(268124757,425650411,14915053,25362,1,'2008-06-03 01:02:54',3310502123,1),(268124758,425650989,14915585,25362,1,'2008-06-03 01:02:54',3310502123,1),(268124759,425649778,14914023,25362,1,'2008-06-03 01:02:54',3310502123,1),(268129594,425721127,14838247,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129595,425720747,14837218,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129596,425720558,14836016,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129597,425720431,14835158,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129598,425720811,14834471,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129599,425721190,14834299,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129600,425721695,14834385,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129601,425722454,14834643,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129602,425723023,14834728,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129603,425723339,14834471,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129605,425723465,14833784,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129607,425723402,14832668,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129608,425721885,14827690,25362,1,'2008-06-03 01:18:25',3310502119,1),(268129609,425721000,14825115,25362,1,'2008-06-03 01:18:25',3310502119,1),(268129610,425720684,14824085,25362,1,'2008-06-03 01:18:25',3310502119,1),(268129611,425720242,14824171,25362,1,'2008-06-03 01:18:25',3310502119,1),(268129612,425719357,14825287,25362,1,'2008-06-03 01:20:10',3310502119,2),(268129614,425719041,14825974,25362,1,'2008-06-03 01:18:25',3310502119,1),(268129615,425718598,14827261,25362,1,'2008-06-03 01:18:25',3310502119,1),(268129616,425718472,14828034,25362,1,'2008-06-03 01:18:25',3310502119,1),(268129618,425718598,14829407,25362,1,'2008-06-03 01:18:25',3310502119,1),(268129619,425719104,14832668,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129620,425719420,14833098,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129621,425719989,14832840,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129622,425720747,14831810,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129624,425721253,14831038,25362,1,'2008-06-03 01:18:25',3310502119,1),(268129625,425721443,14829836,25362,1,'2008-06-03 01:18:25',3310502119,1),(268129626,425721379,14828720,25362,1,'2008-06-03 01:18:25',3310502119,1),(268129627,425721316,14827862,25362,1,'2008-06-03 01:18:25',3310502119,1),(268130240,425720400,14832282,25362,1,'2008-06-03 01:20:10',3310502125,1),(268131748,425722751,14830533,25362,1,'2008-06-03 01:31:33',3310502119,1),(268131749,425721443,14832411,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131750,425720684,14833269,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131751,425720178,14834128,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131752,425719610,14835501,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131753,425718661,14835758,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131755,425717587,14836531,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131756,425716323,14837561,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131757,425715059,14838762,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131758,425714427,14840050,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131759,425714300,14842282,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131760,425714363,14843741,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131761,425714300,14844685,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131762,425714174,14845715,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131763,425713858,14846487,25362,1,'2008-06-03 01:31:33',3310502125,1),(268132090,425714616,14852667,25362,1,'2008-06-03 01:33:07',3310502125,1),(268132091,425715423,14853174,25362,1,'2008-06-03 01:33:07',3310502125,1),(268132095,425709753,14852935,2369737,1,'2009-09-04 17:22:13',3310502125,2),(268132096,425710634,14853440,25362,1,'2008-06-03 01:33:07',3310502125,1),(268132097,425711203,14853268,25362,1,'2008-06-03 01:33:07',3310502125,1),(268132098,425712151,14852410,25362,1,'2008-06-03 01:33:07',3310502125,1),(268132099,425713036,14852238,25362,1,'2008-06-03 01:33:07',3310502125,1),(268132100,425713478,14852238,25362,1,'2008-06-03 01:33:07',3310502125,1),(268132455,425718409,14835072,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132456,425716133,14835501,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132457,425713984,14836874,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132458,425712530,14837990,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132459,425711076,14839535,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132460,425709433,14841080,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132461,425709370,14843397,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132462,425708232,14843569,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132463,425708358,14844599,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132464,425711076,14843826,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132465,425712783,14843226,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132466,425714806,14842282,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132467,425716007,14840393,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132468,425717334,14838419,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132469,425719041,14837561,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132982,425713668,14846230,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132983,425713858,14844942,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132985,425713858,14843397,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132986,425712277,14843998,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132987,425708611,14845200,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132989,425707916,14848805,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132990,425707474,14850607,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132991,425707790,14852324,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132992,425708611,14853783,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132993,425709559,14853440,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132994,425710002,14852324,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132996,425711076,14852410,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132997,425713668,14850435,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132998,425714174,14846916,25362,1,'2008-06-03 01:38:51',3310502125,1),(268133215,425722264,14827433,675187,1,'2008-12-30 16:02:49',3310502119,3),(268133216,425722707,14827175,675187,1,'2008-12-30 16:02:48',3310502119,2),(268133217,425721190,14822798,675187,1,'2008-12-30 16:02:48',3310502119,2),(268133218,425719546,14823313,675187,1,'2008-12-30 16:02:49',3310502119,2),(268133219,425717777,14826231,675187,1,'2008-12-30 16:02:49',3310502119,2),(268133221,425717524,14827690,675187,1,'2008-12-30 16:02:49',3310502119,2),(268133222,425718156,14833012,675187,1,'2008-12-30 16:02:49',3310502125,2),(268133223,425719357,14834213,675187,1,'2008-12-30 16:02:49',3310502125,2),(268133224,425721948,14830523,675187,1,'2008-12-30 16:02:49',3310502119,2),(268133225,425721759,14828549,675187,1,'2008-12-30 16:02:49',3310502119,2),(268133712,425721063,14835072,25362,1,'2008-06-03 01:42:02',3310502125,1),(268133714,425721569,14835930,25362,1,'2008-06-03 01:42:02',3310502125,1),(268133715,425723276,14835930,25362,1,'2008-06-03 01:42:02',3310502125,1),(268133716,425724287,14835415,25362,1,'2008-06-03 01:42:02',3310502125,1),(268133717,425724603,14834213,25362,1,'2008-06-03 01:42:02',3310502125,1),(268133718,425723276,14829407,25362,1,'2008-06-03 01:42:02',3310502119,1),(268133719,425720115,14833784,25362,1,'2008-06-03 01:42:02',3310502125,1),(268133883,425719917,14834759,25362,1,'2008-06-03 01:42:43',3310502125,1),(268134045,425721300,14838863,2369619,1,'2009-09-04 17:10:07',3310502125,2),(268148594,425709352,14864112,33354,1,'2008-06-03 03:20:22',3310502125,1),(268612922,425922022,15251371,56648,1,'2008-06-05 18:37:38',3310502695,1),(268612923,425922591,15251285,56648,1,'2008-06-05 18:37:38',3310502695,1),(268613131,425931247,15255577,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613132,425932006,15256177,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613133,425932448,15256950,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613134,425932701,15257894,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613135,425933017,15258838,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613136,425933017,15259525,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613137,425932511,15260297,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613138,425931943,15260726,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613139,425931121,15261156,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613140,425930489,15262100,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613141,425930679,15262786,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613142,425931374,15263902,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613143,425932448,15265705,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613144,425933396,15267078,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613145,425933775,15267850,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613146,425933649,15269309,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613147,425933333,15270425,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613536,425930742,15268794,56648,1,'2008-06-05 18:40:23',3310502695,1),(268613537,425931753,15269395,56648,1,'2008-06-05 18:40:23',3310502695,1),(268613538,425932258,15270254,56648,1,'2008-06-05 18:40:23',3310502695,1),(268613539,425934533,15271112,56648,1,'2008-06-05 18:40:23',3310502695,1),(268613540,425936050,15271970,56648,1,'2008-06-05 18:40:23',3310502701,1),(268613541,425936808,15272399,56648,1,'2008-06-05 18:40:23',3310502701,1),(268613542,425937313,15272485,56648,1,'2008-06-05 18:40:23',3310502701,1),(268613543,425937819,15272399,56648,1,'2008-06-05 18:40:23',3310502701,1),(268613544,425938324,15272657,56648,1,'2008-06-05 18:40:23',3310502701,1),(268613545,425939398,15273172,56648,1,'2008-06-05 18:40:23',3310502701,1),(268613546,425940915,15273773,56648,1,'2008-06-05 18:40:23',3310502701,1),(268613547,425942495,15274545,56648,1,'2008-06-05 18:40:23',3310502701,1),(268613548,425943821,15274888,56648,1,'2008-06-05 18:40:23',3310502701,1),(268613549,425944769,15274888,56648,1,'2008-06-05 18:40:23',3310502701,1),(268613550,425946159,15275489,56648,1,'2008-06-05 18:40:23',3310502701,1),(268613551,425947613,15276090,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613552,425949445,15277206,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613553,425950519,15277893,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613554,425951151,15278236,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613555,425951593,15278922,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613556,425952288,15279695,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613557,425952667,15280210,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613558,425953299,15281154,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613559,425954437,15281755,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613560,425955637,15282356,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613561,425957027,15282785,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613562,425958038,15283214,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613563,425958859,15283643,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613564,425959681,15284330,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613691,425960439,15267421,56648,1,'2008-06-05 18:41:22',3310502706,1),(268613692,425960123,15268537,56648,1,'2008-06-05 18:41:22',3310502706,1),(268613693,425959681,15269653,56648,1,'2008-06-05 18:41:22',3310502706,1),(268613694,425959175,15270769,56648,1,'2008-06-05 18:41:22',3310502706,1),(268613695,425958228,15273086,56648,1,'2008-06-05 18:41:22',3310502712,1),(268613696,425957722,15275318,56648,1,'2008-06-05 18:41:22',3310502712,1),(268613697,425957722,15276863,56648,1,'2008-06-05 18:41:22',3310502712,1),(268613698,425957848,15277893,56648,1,'2008-06-05 18:41:22',3310502712,1),(268613699,425958101,15279266,56648,1,'2008-06-05 18:41:22',3310502712,1),(268613700,425958607,15280553,56648,1,'2008-06-05 18:41:22',3310502712,1),(268613701,425958733,15281412,56648,1,'2008-06-05 18:41:22',3310502712,1),(268613703,425958733,15281927,56648,1,'2008-06-05 18:41:22',3310502712,1),(268613704,425958796,15283128,56648,1,'2008-06-05 18:41:22',3310502712,1),(268614412,425930368,15254683,56648,1,'2008-06-05 18:44:20',3310502695,1),(268615558,425960895,15265943,56648,1,'2008-06-05 18:49:46',3310502706,1),(268615700,425962323,15266456,2191328,1,'2009-08-18 19:37:18',3310502706,3),(268615701,425962260,15265512,2191328,1,'2009-08-18 19:37:18',3310502706,3),(268615702,425962019,15264503,56648,1,'2008-06-05 18:52:35',3310502706,2),(268615703,425961576,15263730,56648,1,'2008-06-05 18:52:35',3310502706,2),(268615704,425961134,15262958,56648,1,'2008-06-05 18:50:53',3310502706,1),(268615705,425961260,15262014,56648,1,'2008-06-05 18:50:53',3310502706,1),(268615706,425961387,15258752,56648,1,'2008-06-05 18:50:53',3310502706,1),(268615707,425961387,15257036,56648,1,'2008-06-05 18:50:53',3310502706,1),(268615782,425962019,15258581,56648,1,'2008-06-05 18:51:53',3310502706,1),(268615783,425962650,15258666,56648,1,'2008-06-05 18:51:53',3310502706,1),(268615784,425963030,15259353,56648,1,'2008-06-05 18:51:53',3310502706,1),(268615786,425963598,15260469,56648,1,'2008-06-05 18:51:53',3310502706,1),(268615787,425964293,15261585,56648,1,'2008-06-05 18:51:53',3310502706,1),(268615788,425965304,15262700,56648,1,'2008-06-05 18:51:53',3310502706,1),(268615789,425965936,15263387,56648,1,'2008-06-05 18:51:53',3310502706,1),(268615790,425966568,15264417,56648,1,'2008-06-05 18:51:53',3310502706,1),(268615948,425962433,15269187,56648,1,'2008-06-05 18:53:05',3310502706,1),(268616479,425964104,15262014,56648,1,'2008-06-05 18:59:25',3310502706,1),(268616480,425964925,15263301,56648,1,'2008-06-05 18:59:25',3310502706,1),(268616481,425964420,15263301,56648,1,'2008-06-05 18:59:25',3310502706,1),(268616482,425964104,15263559,56648,1,'2008-06-05 18:59:25',3310502706,1),(268616483,425964040,15264417,56648,1,'2008-06-05 18:59:25',3310502706,1),(268616484,425963598,15264932,56648,1,'2008-06-05 18:59:25',3310502706,1),(268616485,425963030,15265190,56648,1,'2008-06-05 18:59:25',3310502706,1),(268616486,425962587,15265190,56648,1,'2008-06-05 18:59:25',3310502706,1),(268616487,425962205,15265059,56648,1,'2008-06-05 18:59:25',3310502706,1),(268616713,425960945,15262014,56648,1,'2008-06-05 19:01:56',3310502706,1),(268616714,425960502,15262186,56648,1,'2008-06-05 19:01:56',3310502706,1),(268616715,425960060,15262186,56648,1,'2008-06-05 19:01:56',3310502706,1),(268616716,425959997,15261327,56648,1,'2008-06-05 19:01:56',3310502706,1),(268616717,425958796,15260984,56648,1,'2008-06-05 19:01:56',3310502706,1),(268616718,425958417,15262700,56648,1,'2008-06-05 19:01:56',3310502706,1),(268616719,425960629,15263730,56648,1,'2008-06-05 19:01:56',3310502706,1),(268616892,425961059,15266542,2191328,1,'2009-08-18 19:38:23',3310502706,2),(268616893,425960870,15267143,2191328,1,'2009-08-18 19:40:09',3310502706,3),(268616894,425961691,15268087,2191328,1,'2009-08-18 19:40:10',3310502706,3),(268616895,425961944,15267572,2191328,1,'2009-08-18 19:38:23',3310502706,2),(268617407,425984827,15294544,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617408,425985775,15295230,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617409,425986660,15296003,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617410,425987355,15297033,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617411,425987671,15298835,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617412,425987923,15299779,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617413,425988429,15300209,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617414,425989124,15300037,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617415,425989440,15300809,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617416,425989629,15302268,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617417,425989945,15305616,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617418,425990198,15306388,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617419,425990893,15307247,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617420,425992093,15308534,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617421,425993294,15309392,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617422,425994620,15310680,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617493,425993926,15306817,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617494,425993294,15306302,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617495,425992599,15305273,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617496,425991777,15303985,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617497,425991146,15302011,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617498,425990766,15299951,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617499,425990387,15298406,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617500,425990261,15296861,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617501,425989882,15296174,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617502,425989440,15295831,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617503,425989061,15295745,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617504,425988808,15296260,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617505,425988871,15297634,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617677,425984051,15294654,56648,1,'2008-06-05 19:09:23',3310502713,1),(268617808,425984575,15297977,56648,1,'2008-06-05 19:10:24',3310502713,1),(268617809,425985184,15297393,56648,1,'2008-06-05 19:10:24',3310502713,1),(268618417,425617257,14967271,56648,1,'2008-06-05 19:14:47',3310502464,1),(268619784,425181160,15252916,56648,1,'2008-06-05 19:24:05',3310491490,1),(268630128,425039497,15191226,56648,1,'2008-06-05 20:27:56',3310491428,1),(268630910,425036101,15193555,3916355,1,'2010-02-19 17:31:54',3310491428,2),(268630911,425036007,15194595,3916355,1,'2010-02-19 17:31:54',3310491428,2),(268630913,425037177,15194755,3916355,1,'2010-02-19 17:31:55',3310491428,2),(268630914,425037294,15193887,3916355,1,'2010-02-19 17:31:55',3310491428,2),(268631096,425037167,15192720,305941,1,'2009-02-09 21:32:54',3310491428,2),(268631795,425036172,15191573,3916355,1,'2010-02-19 17:34:23',3310491428,3),(268633715,425083110,15328453,305941,1,'2009-02-09 21:17:59',3310491450,5),(270716339,425455379,15153915,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716340,425455949,15153229,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716341,425456581,15152971,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716342,425457466,15153314,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716343,425458541,15152628,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716344,425459426,15151684,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716346,425459174,15150482,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716347,425458857,15149710,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716348,425459110,15148765,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716349,425459616,15147135,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716350,425459932,15145847,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716351,425460691,15144302,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716352,425462146,15142671,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716353,425463537,15141212,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716354,425463913,15139731,174860,1,'2008-12-06 16:19:29',3310502414,2),(270717286,425458099,15148336,188228,1,'2008-06-16 17:58:16',3310502414,1),(270717287,425457719,15148079,188228,1,'2008-06-16 17:58:16',3310502414,1),(270717288,425457150,15147478,188228,1,'2008-06-16 17:58:16',3310502414,1),(270717289,425456232,15147580,174860,1,'2008-12-06 16:19:28',3310502414,2),(270717898,425429895,15163271,188228,1,'2008-06-16 18:02:15',3310502433,1),(270717899,425431350,15162928,188228,1,'2008-06-16 18:02:15',3310502433,1),(270723120,425097469,15332761,188228,1,'2008-06-16 18:36:30',3310491451,1),(270723241,425098608,15341258,188228,1,'2008-06-16 18:38:03',3310491451,1),(270723242,425098482,15342717,188228,1,'2008-06-16 18:38:03',3310491451,1),(270723243,425098482,15346408,188228,1,'2008-06-16 18:38:03',3310491451,1),(270723244,425100063,15372072,188228,1,'2008-06-16 18:38:03',3310491451,1),(270723325,425101898,15388551,188228,1,'2008-06-16 19:09:56',3310491537,3),(270723368,425101012,15386920,188228,1,'2008-06-16 18:44:23',3310491537,3),(270723369,425100696,15387435,188228,1,'2008-06-16 19:09:56',3310491537,4),(270723412,425101961,15387779,188228,1,'2008-06-16 18:44:23',3310491537,2),(270723413,425101645,15387092,188228,1,'2008-06-16 19:09:31',3310491537,3),(270723459,425101329,15389238,188228,1,'2008-06-16 19:09:56',3310491537,3),(270723912,425100823,15388980,188228,1,'2008-06-16 19:09:56',3310491537,2),(270723936,425101076,15395503,188228,1,'2008-06-16 18:44:40',3310491537,1),(270723937,425098671,15400911,188228,1,'2008-06-16 18:45:06',3310491537,2),(270724218,425098671,15464082,188228,1,'2008-06-16 18:48:34',3310491539,1),(270724708,425120373,15501504,188228,1,'2008-06-16 18:52:32',3310491545,1),(270724742,425120289,15503426,840745,1,'2009-01-26 19:29:54',3310491545,2),(270725821,425096700,15403380,3916355,1,'2010-02-19 17:34:16',3310491537,2),(270725822,425097013,15402794,3916355,1,'2010-02-19 17:34:17',3310491537,2),(270725823,425096963,15401983,3916355,1,'2010-02-19 17:34:17',3310491537,2),(270725825,425096539,15401449,3916355,1,'2010-02-19 17:34:17',3310491537,2),(270725826,425095501,15401979,3916355,1,'2010-02-19 17:34:17',3310491537,2),(270725827,425095450,15402797,3916355,1,'2010-02-19 17:34:18',3310491537,2),(270725828,425095729,15403347,3916355,1,'2010-02-19 17:34:18',3310491537,2),(270725839,425096199,15403580,3916355,1,'2010-02-19 17:34:18',3310491537,2),(270725952,425095931,15401444,3916355,1,'2010-02-19 17:34:17',3310491537,2),(270726179,425093546,15387779,188228,1,'2008-06-16 19:02:49',3310491536,2),(270726764,425095707,15388473,3916355,1,'2010-02-19 17:34:19',3310491537,6),(270726765,425095796,15387837,3916355,1,'2010-02-19 17:34:19',3310491537,3),(270726766,425095505,15387272,3916355,1,'2010-02-19 17:34:19',3310491537,4),(270726767,425094964,15387193,3916355,1,'2010-02-19 17:34:19',3310491536,5),(270726768,425094547,15387861,3916355,1,'2010-02-19 17:34:20',3310491536,4),(270726770,425094783,15388687,3916355,1,'2010-02-19 17:34:20',3310491536,5),(270726771,425095299,15388852,3916355,1,'2010-02-19 17:34:20',3310491537,4),(270727242,425091849,15336838,840745,1,'2009-01-26 20:10:50',3310491450,4),(270729579,425263767,15670124,188228,1,'2008-06-16 19:35:06',3310491623,1),(270730270,425291978,15696903,188228,1,'2008-06-16 19:39:37',3310491634,1),(270730467,425295028,15714489,4963967,1,'2010-06-11 20:09:40',3310491640,2),(270730923,425294023,15713492,4963967,1,'2010-06-11 20:09:40',3310491640,2),(270730924,425295583,15714155,188228,1,'2008-06-16 19:45:37',3310491640,1),(270730925,425295836,15712782,188228,1,'2008-06-16 19:45:37',3310491640,1),(270730926,425300896,15704113,188228,1,'2008-06-16 19:45:37',3310491634,1),(270730927,425301402,15703598,188228,1,'2008-06-16 19:45:37',3310491634,1),(270730928,425302098,15703512,188228,1,'2008-06-16 19:45:37',3310491634,1),(270730929,425302857,15703770,188228,1,'2008-06-16 19:45:37',3310491634,1),(270730930,425304628,15705229,188228,1,'2008-06-16 19:45:37',3310491634,1),(270730931,425306968,15706259,188228,1,'2008-06-16 19:45:37',3310491634,1),(270730932,425313483,15708147,188228,1,'2008-06-16 19:45:37',3310491634,1),(270730933,425321010,15712181,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730934,425324235,15714069,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730935,425325310,15715014,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730936,425326512,15717159,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730937,425328663,15721708,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730938,425329801,15725313,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730939,425331129,15727717,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730940,425332963,15729605,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730941,425334165,15731493,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730942,425335051,15733896,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730943,425335304,15736300,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730944,425335430,15737587,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730945,425335936,15738188,188228,1,'2008-06-16 19:45:37',3310491641,1),(270731114,425336948,15739046,188228,1,'2008-06-16 20:05:18',3310491641,2),(270731115,425337517,15739132,188228,1,'2008-06-16 19:47:21',3310491641,1),(270731116,425337707,15738445,188228,1,'2008-06-16 19:47:21',3310491641,1),(270731117,425337644,15737759,188228,1,'2008-06-16 19:47:21',3310491641,1),(270731118,425337391,15737415,188228,1,'2008-06-16 20:05:18',3310491641,2),(270731119,425337011,15737415,188228,1,'2008-06-16 19:49:35',3310491641,2),(270731143,425336758,15738360,188228,1,'2008-06-16 19:49:35',3310491641,3),(270733583,425319239,15736300,188228,1,'2008-06-16 20:02:41',3310491641,1),(270733584,425327398,15762135,188228,1,'2008-06-16 20:02:41',3310491641,1),(270733631,425332399,15776831,188228,1,'2008-06-16 20:02:58',3310491643,1),(271938772,425073597,15225081,258909,1,'2008-06-22 19:25:20',3310491442,1),(271938773,425071485,15224951,258909,1,'2008-06-22 19:25:20',3310491442,1),(271938774,425069817,15221849,258909,1,'2008-06-22 19:25:20',3310491442,1),(271938778,425067200,15215540,258909,1,'2008-06-22 19:25:20',3310491429,1),(271939031,425795800,16400616,3475126,1,'2009-12-28 21:41:30',3310504156,3),(271939032,425399438,17192126,258909,1,'2008-06-22 19:28:24',3310504576,1),(271939033,425387081,17176253,258909,1,'2008-06-22 19:28:24',3310493653,1),(271939034,425375443,17160301,258909,1,'2008-06-22 19:28:24',3310493653,1),(276993930,426528772,15636298,4114763,1,'2010-03-13 15:42:56',3310503649,5),(276995290,426528835,15634839,423843,1,'2008-07-07 23:49:54',3310503649,1),(276995291,426528709,15635268,423843,1,'2008-07-07 23:49:54',3310503649,1),(276995292,426528646,15635698,423843,1,'2008-07-07 23:49:54',3310503649,1),(276995293,426528456,15636041,423843,1,'2008-07-07 23:49:54',3310503649,1),(276995294,426528393,15636470,423843,1,'2008-07-07 23:49:54',3310503649,1),(276998391,425448312,15239457,725665,1,'2009-03-02 22:19:39',3310502435,6),(276998392,425448249,15242118,423843,1,'2008-07-08 00:06:13',3310502435,1),(276998393,425448059,15243577,423843,1,'2008-07-08 00:06:13',3310502435,1),(276998394,425447363,15244436,423843,1,'2008-07-08 00:16:11',3310502435,2),(276998671,425437815,15231132,423843,1,'2008-07-08 00:10:55',3310502435,2),(276999219,425434702,15224356,1075389,1,'2009-05-04 18:49:38',3310502435,2),(277000148,425435728,15227184,423843,1,'2008-07-08 00:13:18',3310502435,2),(277000149,425436676,15228471,423843,1,'2008-07-08 00:10:55',3310502435,1),(277000665,425437625,15228729,423843,1,'2008-07-08 00:11:51',3310502435,1),(277000666,425438637,15227956,423843,1,'2008-07-08 00:11:51',3310502435,1),(277000667,425439522,15227870,423843,1,'2008-07-08 00:11:51',3310502435,1),(277000669,425440407,15227870,423843,1,'2008-07-08 00:11:51',3310502435,1),(277001703,425434766,15233068,2369619,1,'2009-09-04 17:10:07',3310502435,2),(277001727,425436929,15229072,2369619,1,'2009-09-04 17:10:07',3310502435,2),(277003121,425430479,15241174,423843,1,'2008-07-08 00:19:31',3310502435,1),(277003126,425416503,15240230,423843,1,'2008-07-08 00:19:31',3310502434,1),(277003680,425429847,15239801,423843,1,'2008-07-08 00:20:56',3310502435,1),(277003681,425425610,15237483,423843,1,'2008-07-08 00:20:56',3310502435,1),(277003682,425418843,15237140,423843,1,'2008-07-08 00:20:56',3310502434,1),(277003683,425417009,15236625,423843,1,'2008-07-08 00:20:56',3310502434,1),(277003684,425415239,15235681,423843,1,'2008-07-08 00:20:56',3310502434,1),(277375056,425759909,15186981,440632,1,'2008-07-09 16:26:46',3310502513,1),(277375057,425759850,15187352,440632,1,'2008-07-09 16:26:46',3310502513,1),(277375058,425759597,15188382,440632,1,'2008-07-09 16:26:46',3310502513,1),(277375059,425758712,15189755,440632,1,'2008-07-09 16:26:46',3310502513,1),(277375060,425757195,15191557,440632,1,'2008-07-09 16:26:46',3310502513,1),(277375061,425756310,15192330,440632,1,'2008-07-09 16:26:46',3310502513,1),(277375062,425754856,15192931,440632,1,'2008-07-09 16:26:46',3310502513,1),(277375063,425753340,15193188,440632,1,'2008-07-09 16:26:46',3310502512,1),(277375064,425752455,15189583,440632,1,'2008-07-09 16:26:46',3310502512,1),(277377767,425845906,15654753,440632,1,'2008-07-09 16:47:10',3310502816,1),(277377889,425873712,15702990,440632,1,'2008-07-09 16:49:41',3310502819,1),(277377892,425858229,15691746,440632,1,'2008-07-09 16:51:48',3310502818,3),(277378560,425948590,15751399,440632,1,'2008-07-09 16:54:11',3310502840,1),(277386816,425447165,15181286,441038,1,'2008-07-09 18:15:08',3310502433,1),(277386817,425448177,15183088,441038,1,'2008-07-09 18:15:08',3310502433,1),(277386818,425449189,15184376,441038,1,'2008-07-09 18:15:08',3310502433,1),(277386819,425450390,15186350,441038,1,'2008-07-09 18:15:08',3310502433,1),(277386820,425451465,15188839,844916,1,'2009-01-27 20:20:59',3310502433,3),(277386821,425452034,15189182,844916,1,'2009-01-27 20:20:59',3310502433,3),(277386822,425452351,15189955,844916,1,'2009-01-27 20:20:59',3310502436,3),(277386823,425452667,15191242,844916,1,'2009-01-27 20:20:59',3310502436,3),(277386824,425453742,15195276,844916,1,'2009-01-27 20:20:59',3310502436,3),(277386825,425454501,15197937,844916,1,'2009-01-27 20:20:59',3310502436,3),(277386826,425455323,15199739,844916,1,'2009-01-27 20:20:59',3310502436,3),(277386827,425456163,15200104,844916,1,'2009-01-27 20:20:59',3310502436,3),(277386930,425450770,15184204,441038,1,'2008-07-09 18:16:19',3310502433,1),(277386931,425451529,15183775,441038,1,'2008-07-09 18:16:19',3310502433,1),(277694080,425088502,15307498,305941,1,'2009-02-09 21:18:56',3310491448,2),(277694081,425091228,15316676,820251,1,'2009-03-16 23:48:45',3310491448,4),(277694146,425084763,15306437,462438,1,'2008-07-11 12:57:28',3310491448,1),(277695163,425121314,15367394,3916355,1,'2010-02-19 17:33:25',3310491451,5),(277695164,425122217,15368066,3916355,1,'2010-02-19 17:33:25',3310491451,5),(277695165,425123077,15367517,3916355,1,'2010-02-19 17:33:26',3310491454,5),(277695167,425123309,15366357,3916355,1,'2010-02-19 17:33:26',3310491454,4),(277695168,425122436,15365128,3916355,1,'2010-02-19 17:33:27',3310491451,3),(277695169,425121319,15365762,3916355,1,'2010-02-19 17:33:25',3310491451,6),(277695545,425120574,15369265,462438,1,'2008-07-11 13:06:36',3310491451,1),(277697265,424845097,14903871,462438,1,'2008-07-11 13:26:25',3310490863,1),(277697266,424846173,14901038,462438,1,'2008-07-11 13:26:25',3310490863,1),(277697267,424847629,14898206,462438,1,'2008-07-11 13:26:25',3310490863,1),(277697268,424848705,14899064,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697269,424848515,14904214,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697270,424849148,14907475,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697271,424853326,14909020,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697272,424858389,14909879,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697273,424861997,14912196,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697274,424864086,14911595,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697275,424861681,14908505,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697276,424858516,14905072,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697277,424855478,14900437,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697278,424852060,14896317,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697279,424850414,14893313,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697280,424850604,14890738,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697281,424853326,14891339,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697282,424855035,14893914,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697283,424857883,14893571,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697284,424860098,14892884,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697285,424862947,14894172,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697286,424865985,14898034,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697287,424869149,14899922,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697288,424873074,14901639,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697289,424875732,14902497,462438,1,'2008-07-11 13:26:25',3310490875,1),(277697480,424865478,14910909,462438,1,'2008-07-11 13:28:00',3310490874,1),(277697481,424865985,14909621,462438,1,'2008-07-11 13:28:00',3310490874,1),(277697482,424864719,14907304,462438,1,'2008-07-11 13:28:00',3310490874,1),(277697483,424860288,14901639,462438,1,'2008-07-11 13:28:00',3310490874,1),(277697484,424858643,14902154,462438,1,'2008-07-11 13:28:00',3310490874,1),(277697485,424856791,14902440,462438,1,'2008-07-11 13:28:00',3310490874,1),(277697847,424844717,14908505,462438,1,'2008-07-11 13:31:19',3310490863,1),(278721406,425105212,15391730,2369619,1,'2009-09-04 17:10:07',3310491537,2),(278721797,425103266,15389863,2369619,1,'2009-09-04 17:10:07',3310491537,2),(278722158,425101314,15409645,2369619,1,'2009-09-04 17:10:07',3310491537,3),(278748035,425761102,16234448,495907,1,'2008-07-15 19:48:35',3310504059,1),(278748036,425784234,16323883,495907,1,'2008-07-15 19:48:35',3310504150,1),(278748279,425788089,16387140,495907,1,'2008-07-15 19:50:23',3310504156,1),(278748316,425799781,16412632,495907,1,'2008-07-15 19:50:57',3310504156,1),(278748317,425797506,16419499,495907,1,'2008-07-15 19:51:34',3310504156,2),(278748365,425796874,16424820,495907,1,'2008-07-15 19:51:34',3310504158,1),(278748559,425797316,16493399,495907,1,'2008-07-15 19:52:43',3310504180,1),(278748954,425786806,16506930,495907,1,'2008-07-15 19:53:29',3310504180,1),(278752060,425785182,16506102,495907,1,'2008-07-15 20:01:27',3310504180,2),(278752061,425783539,16505415,495907,1,'2008-07-15 19:59:39',3310504180,1),(278752062,425782022,16504557,495907,1,'2008-07-15 19:59:39',3310504180,1),(278752063,425781326,16503956,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752064,425781010,16502668,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752066,425781263,16501038,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752067,425781895,16499407,495907,1,'2008-07-15 19:59:39',3310504180,1),(278752068,425782148,16497690,495907,1,'2008-07-15 19:59:39',3310504180,1),(278752069,425781958,16496317,495907,1,'2008-07-15 19:59:39',3310504180,1),(278752070,425781263,16495545,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752071,425780758,16495716,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752072,425780315,16497175,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752073,425780631,16499321,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752074,425780378,16501553,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752075,425779999,16504728,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752076,425779999,16506016,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752077,425779241,16507990,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752078,425778546,16509964,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752079,425777092,16510908,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752080,425775196,16511595,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752081,425772921,16512110,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752083,425771973,16512539,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752084,425771404,16513483,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752085,425771909,16514427,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752325,425771024,16514170,495907,1,'2008-07-15 20:02:55',3310504177,3),(278752327,425776902,16512110,495907,1,'2008-07-15 20:02:55',3310504177,2),(278752328,425777661,16516401,495907,1,'2008-07-15 20:02:55',3310504177,2),(278752329,425771657,16518290,495907,1,'2008-07-15 20:02:55',3310504177,2),(278752636,425776839,16506788,495907,1,'2008-07-15 20:01:13',3310504177,1),(278757467,425775701,16633390,495907,1,'2008-07-15 20:10:14',3310504185,1),(278757468,425775133,16635107,495907,1,'2008-07-15 20:10:14',3310504185,1),(278757469,425769832,16662769,495907,1,'2008-07-15 20:10:14',3310504187,1),(278759738,425771783,16663688,495907,1,'2008-07-15 20:16:37',3310504187,1),(278759739,425773805,16664117,495907,1,'2008-07-15 20:16:37',3310504187,1),(278759740,425774880,16663259,495907,1,'2008-07-15 20:16:37',3310504187,1),(278759742,425775765,16660598,495907,1,'2008-07-15 20:16:37',3310504187,1),(278759743,425776649,16657594,495907,1,'2008-07-15 20:16:37',3310504187,1),(278759744,425777724,16655706,495907,1,'2008-07-15 20:16:37',3310504187,1),(278759745,425778672,16654418,495907,1,'2008-07-15 20:16:37',3310504187,1),(278759746,425780505,16652273,495907,1,'2008-07-15 20:16:37',3310504187,1),(278759747,425782211,16649955,495907,1,'2008-07-15 20:16:37',3310504190,1),(278759748,425783854,16647209,495907,1,'2008-07-15 20:16:37',3310504190,1),(278759749,425784550,16646780,495907,1,'2008-07-15 20:16:37',3310504190,1),(278759750,425785182,16646780,495907,1,'2008-07-15 20:16:37',3310504190,1),(278759752,425785498,16647380,495907,1,'2008-07-15 20:16:37',3310504190,1),(278759753,425785308,16648325,495907,1,'2008-07-15 20:16:37',3310504190,1),(278759754,425784739,16649183,495907,1,'2008-07-15 20:16:37',3310504190,1),(278759755,425783918,16650556,495907,1,'2008-07-15 20:16:37',3310504190,1),(278759756,425783412,16652273,495907,1,'2008-07-15 20:16:37',3310504190,1),(278759757,425782970,16656478,495907,1,'2008-07-15 20:16:37',3310504190,1),(278759758,425782338,16660856,495907,1,'2008-07-15 20:16:37',3310504190,1),(278759759,425780694,16665834,495907,1,'2008-07-15 20:16:37',3310504187,1),(278760483,425766031,16684202,495907,1,'2008-07-15 20:17:56',3310504187,1),(278760711,425766663,16681970,495907,1,'2008-07-15 20:18:38',3310504187,1),(278760995,425764198,16681283,495907,1,'2008-07-15 20:19:51',3310504187,1),(278760996,425763756,16680082,495907,1,'2008-07-15 20:19:51',3310504187,1),(278760997,425763819,16678022,495907,1,'2008-07-15 20:19:51',3310504187,1),(278760998,425763566,16676391,495907,1,'2008-07-15 20:19:51',3310504187,1),(278760999,425763377,16671585,495907,1,'2008-07-15 20:19:51',3310504187,1),(278761000,425763630,16667465,495907,1,'2008-07-15 20:19:51',3310504187,1),(278761001,425764198,16666349,495907,1,'2008-07-15 20:19:51',3310504187,1),(278761002,425768559,16668213,495907,1,'2008-07-15 20:19:51',3310504187,1),(278761189,425765083,16665662,495907,1,'2008-07-15 20:20:20',3310504187,1),(278761190,425766031,16665319,495907,1,'2008-07-15 20:20:20',3310504187,1),(278761435,425762871,16676391,495907,1,'2008-07-15 20:20:45',3310504187,1),(278761436,425762492,16676906,495907,1,'2008-07-15 20:20:45',3310504187,1),(278761437,425762302,16678108,495907,1,'2008-07-15 20:20:45',3310504187,1),(278761438,425762429,16679395,495907,1,'2008-07-15 20:20:45',3310504187,1),(278761439,425762808,16680082,495907,1,'2008-07-15 20:20:45',3310504187,1),(278761684,425762113,16681198,495907,1,'2008-07-15 20:21:11',3310504187,1),(278762963,425764830,16680511,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762964,425764704,16676820,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762965,425764578,16672615,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762966,425764578,16668924,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762967,425765020,16667293,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762968,425766221,16666091,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762969,425766916,16666177,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762970,425766916,16664375,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762971,425763819,16664375,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762972,425762555,16665233,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762973,425761481,16668066,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762974,425761354,16671499,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762975,425761228,16675876,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762976,425761733,16680511,495907,1,'2008-07-15 20:24:16',3310504187,1),(278763284,425741508,16740335,495907,1,'2008-07-15 20:26:14',3310504528,1),(281039653,424856617,14894172,592895,1,'2008-07-25 21:09:57',3310490874,1),(281039980,424878644,14906188,592895,1,'2008-07-25 21:10:59',3310490875,1),(281039982,424879276,14905158,592895,1,'2008-07-25 21:10:59',3310490875,1),(281039983,424878580,14904385,592895,1,'2008-07-25 21:11:42',3310490875,2),(281039984,424877568,14903871,592895,1,'2008-07-25 21:10:59',3310490875,1),(281040020,424877568,14904815,592895,1,'2008-07-25 21:11:15',3310490875,1),(281040022,424879213,14905930,592895,1,'2008-07-25 21:11:15',3310490875,1),(281040156,424877821,14905930,592895,1,'2008-07-25 21:11:29',3310490875,1),(281040439,424883960,14905072,592895,1,'2008-07-25 21:12:46',3310490875,1),(281040441,424881302,14905587,592895,1,'2008-07-25 21:12:46',3310490875,1),(281041274,424882504,14905501,592895,1,'2008-07-25 21:17:55',3310490875,1),(281041761,424885036,14905330,592895,1,'2008-07-25 21:21:32',3310490875,1),(281041762,424886302,14904815,592895,1,'2008-07-25 21:21:32',3310490875,1),(281041763,424887061,14904300,592895,1,'2008-07-25 21:21:32',3310490875,1),(281041764,424887061,14901639,592895,1,'2008-07-25 21:21:32',3310490875,1),(281041765,424883201,14901553,592895,1,'2008-07-25 21:21:32',3310490875,1),(281041766,424883137,14903098,592895,1,'2008-07-25 21:21:32',3310490875,1),(281041767,424883834,14903956,592895,1,'2008-07-25 21:21:32',3310490875,1),(281042331,424846869,14921637,592895,1,'2008-07-25 22:01:08',3310490863,4),(281042332,424847629,14921809,592895,1,'2008-07-25 22:00:32',3310490863,3),(281042336,424849148,14918204,592895,1,'2008-07-25 22:02:15',3310490874,3),(281042337,424848515,14917603,592895,1,'2008-07-25 21:28:02',3310490874,2),(281042725,424846173,14918033,592895,1,'2008-07-25 21:28:02',3310490863,2),(281042726,424846481,14919113,592895,1,'2008-07-25 23:38:32',3310490863,3),(281043016,424848317,14921516,305941,1,'2009-02-09 21:29:38',3310490874,4),(281043351,424847629,14923612,592895,1,'2008-07-25 22:01:08',3310490863,3),(281043353,424849401,14928590,592895,1,'2008-07-25 21:33:33',3310490874,2),(281043354,424854528,14937173,592895,1,'2008-07-25 21:28:56',3310490874,1),(281043356,424865216,14947007,592895,1,'2008-07-25 23:31:50',3310491216,2),(281043360,424883002,14951385,305941,1,'2009-02-09 21:30:44',3310491217,3),(281043618,424865288,14946357,592895,1,'2008-07-25 21:30:10',3310491216,1),(281043619,424869086,14947472,592895,1,'2008-07-25 21:30:10',3310491216,1),(281043621,424875407,14946922,592895,1,'2008-07-25 23:31:24',3310491217,2),(281043622,424879964,14947522,305941,1,'2009-02-09 21:30:35',3310491217,4),(281043623,424883454,14950992,305941,1,'2009-02-09 21:30:35',3310491217,2),(281043789,424850469,14927696,305941,1,'2009-02-09 21:29:38',3310490874,3),(281043790,424855406,14935935,305941,1,'2009-02-09 21:29:38',3310490874,3),(281043792,424860279,14941514,305941,1,'2009-02-09 21:29:37',3310490874,3),(281043794,424869331,14946750,305941,1,'2009-02-09 21:29:37',3310491216,3),(281043795,424875470,14946149,305941,1,'2009-02-09 21:29:37',3310491217,3),(281044538,424859908,14943095,592895,1,'2008-07-25 21:33:33',3310491216,1),(281044540,424875280,14947694,592895,1,'2008-07-25 23:31:50',3310491217,2),(281044597,424848443,14923833,592895,1,'2008-07-25 23:32:42',3310490874,3),(281044599,424854971,14936658,592895,1,'2008-07-25 21:34:02',3310490874,1),(281044619,424880217,14946836,305941,1,'2009-02-09 21:29:37',3310491217,6),(281044620,424865596,14945548,305941,1,'2009-02-09 21:29:37',3310491216,3),(281044641,424883834,14950906,305941,1,'2009-02-09 21:29:11',3310491217,2),(281048516,424849148,14924212,305941,1,'2009-02-09 21:29:38',3310490874,3),(281048956,424869204,14948123,592895,1,'2008-07-25 23:31:50',3310491216,2),(281048992,424849899,14928125,592895,1,'2008-07-25 23:32:42',3310490874,2),(281049120,424879656,14948245,305941,1,'2009-02-09 21:30:44',3310491217,3),(281049690,424846490,14920178,592895,1,'2008-07-25 22:02:15',3310490863,1),(281049691,424848760,14921001,592895,1,'2008-07-25 23:33:03',3310490874,2),(281050352,424849338,14921637,592895,1,'2008-07-25 22:03:34',3310490874,1);
INSERT INTO `current_nodes` VALUES (281050354,424855225,14925757,592895,1,'2008-07-25 22:03:34',3310490874,1),(281050357,424876365,14935628,592895,1,'2008-07-25 22:03:34',3310490875,1),(281050523,424907152,14952198,592895,1,'2008-07-25 22:07:05',3310491220,2),(281051136,424865732,14929706,592895,1,'2008-07-25 22:04:59',3310490874,1),(281051138,424901998,14950047,592895,1,'2008-07-25 22:04:59',3310491217,1),(281051139,424906935,14952966,592895,1,'2008-07-25 22:07:05',3310491220,2),(281051762,424907758,14951249,592895,1,'2008-07-25 22:07:05',3310491220,1),(281051764,424907884,14954253,592895,1,'2008-07-25 22:08:49',3310491220,2),(281051765,424908770,14954339,592895,1,'2008-07-25 22:07:05',3310491220,1),(281051766,424909340,14953566,592895,1,'2008-07-25 22:07:05',3310491220,1),(281051966,424909277,14952279,592895,1,'2008-07-25 22:08:49',3310491220,1),(281051967,424909024,14951335,592895,1,'2008-07-25 22:08:49',3310491220,1),(281051968,424908327,14951077,592895,1,'2008-07-25 22:08:49',3310491220,1),(281051969,424907378,14953824,592895,1,'2008-07-25 22:08:49',3310491220,1),(281052233,424910543,14963523,592895,1,'2008-07-25 22:24:15',3310491220,2),(281052234,424908834,14962836,592895,1,'2008-07-25 22:24:15',3310491220,2),(281052236,424898138,14961549,592895,1,'2008-07-25 22:10:54',3310491217,1),(281052237,424895100,14959060,592895,1,'2008-07-25 22:10:54',3310491217,1),(281052341,424901555,14962321,592895,1,'2008-07-25 22:11:40',3310491217,1),(281052343,424911175,14962836,592895,1,'2008-07-25 22:11:40',3310491220,1),(281052458,424886239,14952622,592895,1,'2008-07-25 22:12:56',3310491217,1),(281052509,424890226,14955111,592895,1,'2008-07-25 22:13:14',3310491217,1),(281052580,424894910,14963351,592895,1,'2008-07-25 22:13:40',3310491217,1),(281052582,424902062,14964381,592895,1,'2008-07-25 22:13:40',3310491217,1),(281052585,424912622,14966577,592895,1,'2008-07-25 23:29:27',3310491220,2),(281053771,424897062,14964467,592895,1,'2008-07-25 22:18:59',3310491217,1),(281053773,424915597,14971298,592895,1,'2008-07-25 23:29:27',3310491220,2),(281053776,424930090,14997047,592895,1,'2008-07-25 23:29:27',3310491222,2),(281053777,424933580,15001803,592895,1,'2008-07-25 22:18:59',3310491223,1),(281053833,424885344,14954131,592895,1,'2008-07-25 23:31:04',3310491217,2),(281053836,424927179,14992498,592895,1,'2008-07-25 23:29:27',3310491220,2),(281053935,424860035,14942323,592895,1,'2008-07-25 22:21:29',3310491216,1),(281053938,424897125,14963694,592895,1,'2008-07-25 22:21:29',3310491217,1),(281053939,424908707,14963694,592895,1,'2008-07-25 22:21:30',3310491220,1),(281053940,424912884,14966012,592895,1,'2008-07-25 22:21:30',3310491220,1),(281053941,424921808,14980346,592895,1,'2008-07-25 22:21:30',3310491220,1),(281053942,424927504,14992019,592895,1,'2008-07-25 22:21:30',3310491220,1),(281053943,424930162,14996224,592895,1,'2008-07-25 22:21:30',3310491220,1),(281053944,424938128,15007604,592895,1,'2008-07-25 23:28:00',3310491223,2),(281053945,424938623,15009280,592895,1,'2008-07-25 22:21:30',3310491223,1),(281053946,424908644,14964553,592895,1,'2008-07-25 22:21:31',3310491220,1),(281055053,424885479,14953566,592895,1,'2008-07-25 22:23:55',3310491217,1),(281055773,424938318,15006831,592895,1,'2008-07-25 23:28:18',3310491223,3),(281055776,424927875,14991296,592895,1,'2008-07-25 23:28:18',3310491220,2),(281055778,424913074,14965154,592895,1,'2008-07-25 22:25:08',3310491220,1),(281056115,424930596,14995759,592895,1,'2008-07-25 23:28:18',3310491221,2),(281056116,424922314,14979831,592895,1,'2008-07-25 22:25:47',3310491220,1),(281056804,424885794,14953864,592895,1,'2008-07-25 22:27:13',3310491217,1),(281057175,424914340,14960690,592895,1,'2008-07-25 22:27:53',3310491220,1),(281057998,424895036,14962579,592895,1,'2008-07-25 22:29:27',3310491217,1),(281058251,424921365,14980861,592895,1,'2008-07-25 22:29:39',3310491220,1),(281059700,424951237,15037509,592895,1,'2008-07-25 22:37:44',3310491223,1),(281059701,424950604,15038196,592895,1,'2008-07-25 22:37:44',3310491223,1),(281059703,424950857,15040427,592895,1,'2008-07-25 22:37:44',3310491223,1),(281059704,424951680,15040599,592895,1,'2008-07-25 22:37:44',3310491223,1),(281060136,424950414,15039397,592895,1,'2008-07-25 22:40:16',3310491223,1),(281060138,424952123,15039826,592895,1,'2008-07-25 22:40:16',3310491223,1),(281060139,424952313,15038539,592895,1,'2008-07-25 22:40:16',3310491223,1),(281063471,425001159,15082448,592895,1,'2008-07-25 23:02:12',3310491401,2),(281063820,425002424,15081247,592895,1,'2008-07-25 23:02:12',3310491401,1),(281063821,425004512,15079444,592895,1,'2008-07-25 23:02:12',3310491401,1),(281063822,425003310,15077127,592895,1,'2008-07-25 23:02:12',3310491401,1),(281063857,425000006,15079938,2369619,1,'2009-09-04 17:10:07',3310491401,2),(281063895,424999260,15058416,592895,1,'2008-07-25 23:03:18',3310491401,1),(281063913,424992363,15063909,592895,1,'2008-07-25 23:03:33',3310491401,1),(281063929,424976690,15032276,592895,1,'2008-07-25 23:03:57',3310491394,1),(281064107,424979706,15029233,592895,1,'2008-07-25 23:05:13',3310491394,1),(281064124,424966636,15012042,592895,1,'2008-07-25 23:05:42',3310491394,1),(281064259,424985591,15012840,592895,1,'2008-07-25 23:08:45',3310491395,2),(281064260,424988249,15014556,592895,1,'2008-07-25 23:06:40',3310491395,1),(281064261,424991287,15016702,592895,1,'2008-07-25 23:06:40',3310491395,1),(281064262,424995780,15019964,592895,1,'2008-07-25 23:06:40',3310491395,1),(281064263,424998248,15023311,592895,1,'2008-07-25 23:06:40',3310491395,1),(281064270,424982617,15010093,592895,1,'2008-07-25 23:06:40',3310491394,1),(281064271,424984199,15012153,592895,1,'2008-07-25 23:06:40',3310491394,1),(281064525,424973125,15007089,592895,1,'2008-07-25 23:08:45',3310491394,1),(281064526,424976922,15006402,592895,1,'2008-07-25 23:08:45',3310491394,1),(281064529,424979643,15007346,592895,1,'2008-07-25 23:08:45',3310491394,1),(281064533,424984136,15026830,592895,1,'2008-07-25 23:08:45',3310491394,1),(281064535,424982554,15027345,592895,1,'2008-07-25 23:10:34',3310491394,2),(281064537,424981162,15028203,592895,1,'2008-07-25 23:08:45',3310491394,1),(281064540,424979833,15027517,592895,1,'2008-07-25 23:08:46',3310491394,1),(281064542,424976985,15021938,592895,1,'2008-07-25 23:08:46',3310491394,1),(281064784,424968125,15010522,592895,1,'2008-07-25 23:10:34',3310491394,1),(281064785,424978504,15006231,592895,1,'2008-07-25 23:10:34',3310491394,1),(281064788,424983566,15026916,592895,1,'2008-07-25 23:10:34',3310491394,1),(281064789,424980655,15028117,592895,1,'2008-07-25 23:10:34',3310491394,1),(281065006,424980529,15023654,592895,1,'2008-07-25 23:11:46',3310491394,1),(281065304,424978630,15004085,592895,1,'2008-07-25 23:12:33',3310491394,1),(281065306,424975593,14993699,592895,1,'2008-07-25 23:12:33',3310491392,1),(281065308,424971542,14983743,592895,1,'2008-07-25 23:12:33',3310491392,1),(281065961,424994324,15017646,592895,1,'2008-07-25 23:16:12',3310491395,1),(281065962,424992742,15015672,592895,1,'2008-07-25 23:16:12',3310491395,1),(281065963,424991730,15013784,592895,1,'2008-07-25 23:16:12',3310491395,1),(281065964,424991034,15011724,592895,1,'2008-07-25 23:16:12',3310491395,1),(281065978,424984832,15025285,592895,1,'2008-07-25 23:16:17',3310491394,1),(281065980,424981541,15009836,592895,1,'2008-07-25 23:16:17',3310491394,1),(281066086,424977681,14999536,592895,1,'2008-07-25 23:17:34',3310491394,1),(281066153,424977997,15023826,592895,1,'2008-07-25 23:17:52',3310491394,1),(281066192,424984642,15026229,592895,1,'2008-07-25 23:18:32',3310491394,1),(281066279,424984579,15031122,592895,1,'2008-07-25 23:18:55',3310491394,1),(281066349,424973631,14988035,592895,1,'2008-07-25 23:20:09',3310491392,1),(281066356,424967185,15011482,592895,1,'2008-07-25 23:20:15',3310491394,1),(281066600,424968948,15000308,592895,1,'2008-07-25 23:21:18',3310491394,1),(281066604,424966480,14986490,592895,1,'2008-07-25 23:21:18',3310491392,1),(281066606,424963189,14987520,592895,1,'2008-07-25 23:21:18',3310491392,1),(281066607,424961860,14987777,592895,1,'2008-07-25 23:21:18',3310491392,1),(281066608,424960594,14987348,592895,1,'2008-07-25 23:21:18',3310491392,1),(281066609,424959455,14986661,592895,1,'2008-07-25 23:21:18',3310491392,1),(281066610,424958569,14986490,592895,1,'2008-07-25 23:21:18',3310491392,1),(281066612,424955342,14982112,592895,1,'2008-07-25 23:21:18',3310491221,1),(281066613,424954772,14981254,592895,1,'2008-07-25 23:21:18',3310491221,1),(281066614,424953759,14980996,592895,1,'2008-07-25 23:21:18',3310491221,1),(281066629,424950469,14978936,592895,1,'2008-07-25 23:21:36',3310491221,1),(281066631,424951544,14976276,592895,1,'2008-07-25 23:21:36',3310491221,1),(281066633,424954456,14973958,592895,1,'2008-07-25 23:21:37',3310491221,1),(281066666,424966796,14983486,592895,1,'2008-07-25 23:22:28',3310491392,1),(281066671,424966543,14976533,592895,1,'2008-07-25 23:22:28',3310491392,1),(281066673,424963885,14972671,592895,1,'2008-07-25 23:22:28',3310491392,1),(281066675,424962113,14968379,592895,1,'2008-07-25 23:22:28',3310491392,1),(281066676,424961860,14966577,592895,1,'2008-07-25 23:22:28',3310491392,1),(281066881,424967113,15010351,592895,1,'2008-07-25 23:23:18',3310491394,1),(281066882,424967809,15008205,592895,1,'2008-07-25 23:23:18',3310491394,1),(281066883,424968758,15005630,592895,1,'2008-07-25 23:23:19',3310491394,1),(281066884,424969328,15003227,592895,1,'2008-07-25 23:23:19',3310491394,1),(281066889,424957557,14985202,592895,1,'2008-07-25 23:23:19',3310491221,1),(281067272,424967049,14979709,592895,1,'2008-07-25 23:25:35',3310491392,1),(281067274,424965847,14975589,592895,1,'2008-07-25 23:25:35',3310491392,1),(281067289,424965024,14986404,592895,1,'2008-07-25 23:25:39',3310491392,1),(281067291,424967113,14991039,592895,1,'2008-07-25 23:25:39',3310491392,1),(281067340,424967682,14996532,592895,1,'2008-07-25 23:25:50',3310491392,1),(281067341,424967049,14987605,592895,1,'2008-07-25 23:25:50',3310491392,1),(281067342,424967049,14978164,592895,1,'2008-07-25 23:25:50',3310491392,1),(281067343,424962746,14970954,592895,1,'2008-07-25 23:25:50',3310491392,1),(281069194,424846608,14920915,592895,1,'2008-07-25 23:36:48',3310490863,1),(281069787,424950595,14977477,592895,1,'2008-07-25 23:39:24',3310491221,1),(281069788,424953443,14975074,592895,1,'2008-07-25 23:39:24',3310491221,1),(281070673,425010213,15102208,592895,1,'2008-07-25 23:43:00',3310491401,1),(281070966,425010587,15099014,592895,1,'2008-07-25 23:44:57',3310491401,1),(281070968,425011600,15091289,592895,1,'2008-07-25 23:44:57',3310491401,1),(281071349,425011220,15096010,592895,1,'2008-07-25 23:48:10',3310491401,1),(281072460,425084684,15227760,592895,1,'2008-07-25 23:51:45',3310491442,1),(281072599,425078230,15232480,592895,1,'2008-07-25 23:52:38',3310491442,1),(281072600,425079179,15231193,592895,1,'2008-07-25 23:52:38',3310491442,1),(281072602,425081141,15230935,592895,1,'2008-07-25 23:52:38',3310491442,1),(281073498,425083671,15214885,592895,1,'2008-07-25 23:57:57',3310491440,1),(281073499,425081141,15211967,592895,1,'2008-07-25 23:57:57',3310491440,1),(281073500,425080381,15211023,592895,1,'2008-07-25 23:57:57',3310491440,1),(281073501,425079306,15212396,592895,1,'2008-07-25 23:57:57',3310491440,1),(281073502,425077534,15214971,592895,1,'2008-07-25 23:57:57',3310491440,1),(281073503,425079242,15217460,592895,1,'2008-07-25 23:57:57',3310491442,1),(281073504,425080761,15219348,592895,1,'2008-07-25 23:57:57',3310491442,1),(281073607,425081710,15231794,592895,1,'2008-07-25 23:58:57',3310491442,1),(281073608,425080128,15230335,592895,1,'2008-07-25 23:58:57',3310491442,1),(281076210,425063044,15159782,592895,1,'2008-07-26 00:12:00',3310491407,1),(281076211,425062791,15162013,592895,1,'2008-07-26 00:12:00',3310491429,1),(281076212,425062981,15164502,592895,1,'2008-07-26 00:12:00',3310491429,1),(281076213,425063550,15167507,592895,1,'2008-07-26 00:12:00',3310491429,1),(281076688,425065449,15167592,592895,1,'2008-07-26 00:15:23',3310491429,1),(281076689,425065449,15165275,592895,1,'2008-07-26 00:15:23',3310491429,1),(281076690,425065322,15163387,592895,1,'2008-07-26 00:15:23',3310491429,1),(281076691,425064753,15161842,592895,1,'2008-07-26 00:15:23',3310491429,1),(281076692,425063819,15160217,592895,1,'2008-07-26 00:15:23',3310491407,1),(281076908,425063804,15155662,592895,1,'2008-07-26 00:18:03',3310491407,1),(281076910,425063297,15148538,592895,1,'2008-07-26 00:18:03',3310491407,1),(281076912,425059627,15143731,592895,1,'2008-07-26 00:32:32',3310491407,2),(281079386,425063614,15151370,592895,1,'2008-07-26 00:29:13',3310491407,1),(281079387,425061716,15146306,592895,1,'2008-07-26 00:29:13',3310491407,1),(281079396,425056780,15139268,592895,1,'2008-07-26 00:32:32',3310491407,2),(281080196,425054629,15136951,592895,1,'2008-07-26 00:32:46',3310491407,1),(281080244,425052604,15132831,592895,1,'2008-07-26 00:33:05',3310491407,1),(281694408,425558367,15352907,615859,1,'2008-07-28 14:01:21',3310502459,1),(283678401,425558809,15320788,72964,1,'2008-08-05 20:27:04',3310502457,1),(283680492,425569178,15347739,72964,1,'2008-08-05 20:37:36',3310502462,1),(287395969,425328921,15197058,210114,1,'2008-08-12 23:44:51',3310491505,2),(287396015,425330122,15196543,174860,1,'2008-12-06 16:19:27',3310491505,3),(287396438,425331324,15198087,226881,1,'2009-04-05 17:09:50',3310491505,6),(287397023,425329869,15197830,226881,1,'2009-04-05 17:09:50',3310491505,4),(287397028,425329047,15197573,210114,1,'2008-08-12 23:44:51',3310491505,2),(287397030,425329680,15196199,210114,1,'2008-08-12 23:44:51',3310491505,2),(287397098,425333285,15197143,226881,1,'2009-04-05 17:09:50',3310491505,5),(287397484,425332273,15197401,226881,1,'2009-04-05 17:09:50',3310491505,4),(287397486,425330692,15198259,226881,1,'2009-04-05 17:09:50',3310491505,4),(287399090,425330186,15197229,210114,1,'2008-08-12 23:44:51',3310491505,1),(287399091,425329427,15197830,210114,1,'2008-08-12 23:44:51',3310491505,1),(287399092,425329174,15196371,210114,1,'2008-08-12 23:44:51',3310491505,1),(287401324,425371101,15200900,210114,1,'2008-08-12 23:49:34',3310491509,1),(287403168,425429223,15172596,210114,1,'2008-08-12 23:52:58',3310502433,1),(287403171,425429223,15173197,210114,1,'2008-08-12 23:52:58',3310502433,1),(287403173,425424986,15177145,210114,1,'2008-08-12 23:52:58',3310502433,1),(287403175,425424101,15175342,210114,1,'2008-08-12 23:52:58',3310502432,1),(287403179,425428085,15172252,210114,1,'2008-08-12 23:52:59',3310502433,1),(291063328,426257932,15515967,404186,1,'2008-08-26 00:23:20',3310502877,1),(291063330,426259890,15520602,404186,1,'2008-08-26 00:23:21',3310502877,1),(291063331,426257427,15523177,404186,1,'2008-08-26 00:23:21',3310502877,1),(291063333,426255785,15524292,404186,1,'2008-08-26 00:23:21',3310502877,1),(291063334,426250354,15524464,404186,1,'2008-08-26 00:23:21',3310502877,1),(291063335,426248901,15523949,404186,1,'2008-08-26 00:23:21',3310502877,1),(291063336,426247954,15519743,404186,1,'2008-08-26 00:23:21',3310502876,1),(291063337,426248775,15513478,404186,1,'2008-08-26 00:23:21',3310502877,1),(291063338,426254522,15514250,404186,1,'2008-08-26 00:23:21',3310502877,1),(292503717,425466649,17306629,478731,1,'2008-08-31 13:56:45',3310504590,1),(316946989,425436551,15164222,174860,1,'2008-12-06 15:58:00',3310502433,1),(316946990,425434591,15161561,174860,1,'2008-12-06 15:58:00',3310502433,1),(316946991,425432500,15159700,174860,1,'2008-12-06 15:58:00',3310502411,1),(316946992,425432946,15158900,787878,1,'2009-01-15 00:31:30',3310502411,4),(316947014,425435070,15159300,174860,1,'2008-12-06 16:20:04',3310502411,2),(316947015,425438480,15158270,174860,1,'2008-12-06 16:20:04',3310502411,2),(316947016,425442259,15154852,174860,1,'2008-12-06 16:20:04',3310502411,2),(316947017,425444029,15152621,174860,1,'2008-12-06 16:20:04',3310502411,4),(316949603,425444050,15151230,174860,1,'2008-12-06 16:19:26',3310502411,2),(316949604,425447630,15145580,174860,1,'2008-12-06 16:19:26',3310502411,2),(316949605,425449650,15144300,174860,1,'2008-12-06 16:19:26',3310502411,2),(316950996,425445041,15152020,174860,1,'2008-12-06 16:19:26',3310502411,1),(316950997,425446950,15150920,174860,1,'2008-12-06 16:19:26',3310502411,1),(316950998,425448835,15150046,174860,1,'2008-12-06 16:19:26',3310502411,1),(316950999,425450450,15149200,174860,1,'2008-12-06 16:19:26',3310502411,1),(316951000,425452380,15149830,174860,1,'2008-12-06 16:19:26',3310502414,1),(316951001,425452913,15151460,174860,1,'2008-12-06 16:19:28',3310502414,2),(316961219,426057100,15359760,437534,1,'2008-12-17 18:58:15',3310502762,6),(316961221,426056440,15359790,174860,1,'2008-12-06 17:05:27',3310502762,1),(316961223,426055619,15359017,174860,1,'2008-12-06 17:05:27',3310502719,1),(316961225,426054924,15357987,174860,1,'2008-12-06 17:05:27',3310502719,1),(316961244,426098007,15379359,174860,1,'2008-12-06 17:05:49',3310502763,1),(316961245,426101910,15380960,437534,1,'2008-12-17 19:04:10',3310502763,10),(316961246,426104956,15382192,437534,1,'2008-12-17 19:04:10',3310502849,10),(316961247,426105524,15383308,437534,1,'2008-12-17 19:04:10',3310502849,12),(316961289,426089479,15362108,437534,1,'2008-12-17 19:04:10',3310502763,13),(316961291,426089360,15362680,437534,1,'2008-12-17 19:04:10',3310502763,6),(316961294,426090365,15364424,437534,1,'2008-12-17 19:04:10',3310502763,6),(316961331,426096300,15380380,437534,1,'2008-12-17 18:58:15',3310502763,5),(316961332,426095080,15379760,437534,1,'2008-12-17 18:58:15',3310502763,5),(316961335,426092410,15375180,437534,1,'2008-12-17 18:58:15',3310502763,5),(316961337,426089060,15372100,437534,1,'2008-12-17 18:58:15',3310502763,5),(316961339,426082950,15364660,437534,1,'2008-12-17 18:58:15',3310502762,5),(316961341,426081350,15364130,437534,1,'2008-12-17 18:58:15',3310502762,5),(316961342,426077980,15364780,437534,1,'2008-12-17 18:58:15',3310502762,5),(316961343,426067600,15369730,437534,1,'2008-12-17 18:58:15',3310502762,5),(316961344,426056430,15358660,437534,1,'2008-12-17 18:58:15',3310502762,5),(316961345,426056360,15357210,437534,1,'2008-12-17 18:58:15',3310502762,5),(316961346,426056780,15356460,437534,1,'2008-12-17 18:58:15',3310502762,6),(316961349,426084200,15359910,174860,1,'2008-12-06 17:18:43',3310502763,5),(316961350,426080480,15359880,174860,1,'2008-12-06 17:18:43',3310502762,5),(316961351,426073680,15363210,174860,1,'2008-12-06 17:18:43',3310502762,5),(316961352,426071710,15363600,174860,1,'2008-12-06 17:18:43',3310502762,6),(316961375,426092448,15354297,437534,1,'2008-12-17 18:33:59',3310502763,7),(316961406,426090360,15355630,174860,1,'2008-12-06 17:15:19',3310502763,3),(316961407,426092860,15354880,437534,1,'2008-12-17 19:00:45',3310502763,5),(316961408,426095354,15355928,174860,1,'2008-12-06 17:07:25',3310502763,2),(316961409,426099780,15356780,174860,1,'2008-12-06 17:07:25',3310502763,2),(316961410,426102429,15359103,174860,1,'2008-12-06 17:06:48',3310502763,1),(316961411,426105600,15361580,174860,1,'2008-12-06 17:07:25',3310502763,2),(316961412,426108040,15362300,174860,1,'2008-12-06 17:07:25',3310502763,2),(316961413,426109910,15361650,174860,1,'2008-12-06 17:07:25',3310502763,2),(316961414,426113780,15359130,174860,1,'2008-12-06 17:07:25',3310502766,2),(316961415,426115250,15358860,174860,1,'2008-12-06 17:07:26',3310502766,2),(316961416,426115580,15357860,174860,1,'2008-12-06 17:07:26',3310502766,2),(316961417,426109060,15356390,174860,1,'2008-12-06 17:07:26',3310502763,2),(316961418,426108080,15356860,174860,1,'2008-12-06 17:07:26',3310502763,2),(316961419,426101355,15350177,174860,1,'2008-12-06 17:07:26',3310502763,2),(316961420,426100534,15349490,174860,1,'2008-12-06 17:07:26',3310502763,2),(316961421,426100093,15348610,174860,1,'2008-12-06 17:07:26',3310502763,3),(316961468,426110010,15348760,174860,1,'2008-12-06 17:07:11',3310502763,1),(316961469,426106535,15349576,174860,1,'2008-12-06 17:07:12',3310502763,1),(316961471,426101418,15348718,174860,1,'2008-12-06 17:07:13',3310502763,1),(316961473,426094550,15348160,174860,1,'2008-12-06 17:07:14',3310502763,1),(316961475,426093660,15348630,174860,1,'2008-12-06 17:07:14',3310502763,1),(316961477,426093880,15350230,174860,1,'2008-12-06 17:07:14',3310502763,1),(316961478,426099210,15351910,174860,1,'2008-12-06 17:07:14',3310502763,1),(316961480,426102500,15354060,174860,1,'2008-12-06 17:07:15',3310502763,1),(316961481,426103700,15355800,174860,1,'2008-12-06 17:07:15',3310502763,1),(316961483,426103630,15357450,174860,1,'2008-12-06 17:07:15',3310502763,1),(316961484,426102700,15358780,174860,1,'2008-12-06 17:07:15',3310502763,1),(316961486,426102366,15363051,174860,1,'2008-12-06 17:07:15',3310502763,1),(316961518,426098324,15365196,437534,1,'2008-12-17 19:00:45',3310502763,4),(316962617,426057980,15356260,174860,1,'2008-12-06 17:15:19',3310502762,1),(316962618,426068510,15363160,174860,1,'2008-12-06 17:15:19',3310502762,1),(316962619,426070230,15363660,174860,1,'2008-12-06 17:17:23',3310502762,2),(316962620,426070450,15362730,174860,1,'2008-12-06 17:15:19',3310502762,1),(316962621,426069150,15361330,174860,1,'2008-12-06 17:15:19',3310502762,1),(316962622,426068150,15358360,174860,1,'2008-12-06 17:15:19',3310502762,1),(316962623,426065300,15353850,174860,1,'2008-12-06 17:15:19',3310502762,1),(316962624,426065830,15352910,174860,1,'2008-12-06 17:15:19',3310502762,1),(316962625,426071260,15356000,174860,1,'2008-12-06 17:15:19',3310502762,1),(316962626,426073660,15356310,174860,1,'2008-12-06 17:15:19',3310502762,1),(316962627,426075930,15356030,174860,1,'2008-12-06 17:15:19',3310502762,1),(316962628,426079810,15354400,174860,1,'2008-12-06 17:15:19',3310502762,1),(316963054,426087557,15361307,437534,1,'2008-12-17 19:00:45',3310502763,8),(316985105,426103250,15366914,206510,1,'2008-12-06 19:26:01',3310502763,1),(316985238,426105272,15384595,206510,1,'2008-12-06 19:28:52',3310502849,3),(316985239,426105051,15385582,206510,1,'2008-12-06 19:38:08',3310502849,3),(319538722,426092197,15355583,437534,1,'2008-12-17 19:00:45',3310502763,3),(319538724,426092323,15356442,437534,1,'2008-12-17 19:00:45',3310502763,3),(319538726,426094471,15357815,437534,1,'2008-12-17 19:00:45',3310502763,3),(319538728,426097630,15360390,437534,1,'2008-12-17 19:00:45',3310502763,3),(319538731,426098261,15361935,437534,1,'2008-12-17 19:00:45',3310502763,3),(319538733,426098893,15363480,437534,1,'2008-12-17 19:00:45',3310502763,3),(319538735,426098767,15364338,437534,1,'2008-12-17 19:00:45',3310502763,3),(319541439,426099525,15367771,437534,1,'2008-12-17 19:01:56',3310502763,6),(319541441,426099904,15369831,437534,1,'2008-12-17 19:01:56',3310502763,6),(319541444,426099461,15371548,437534,1,'2008-12-17 19:01:56',3310502763,6),(319541446,426098830,15373093,437534,1,'2008-12-17 19:01:56',3310502763,6),(319541448,426098577,15374724,437534,1,'2008-12-17 19:01:56',3310502763,6),(319541450,426099651,15380045,437534,1,'2008-12-17 19:04:10',3310502763,5),(319543280,426099082,15366741,437534,1,'2008-12-17 19:01:56',3310502763,1),(319543646,426091755,15366141,437534,1,'2008-12-17 19:04:10',3310502763,1),(321651052,424419897,15513121,372139,1,'2009-04-10 12:07:19',3310490584,2),(321651053,424421925,15514429,372139,1,'2009-04-10 12:07:19',3310490584,2),(321651054,424427748,15517897,372139,1,'2009-04-10 12:07:19',3310490584,2),(321651055,424432460,15521234,372139,1,'2009-04-10 12:07:19',3310490584,2),(321651056,424434422,15523459,372139,1,'2009-04-10 12:07:19',3310490584,2),(321651057,424434750,15527319,372139,1,'2009-04-10 12:07:19',3310490584,2),(321651059,424434619,15530460,372139,1,'2009-04-10 12:07:19',3310490584,2),(321651060,424434226,15536022,372139,1,'2009-04-10 12:07:19',3310490584,2),(321651080,424482604,15604502,372139,1,'2009-04-10 12:07:19',3310490612,2),(321651081,424485739,15603902,372139,1,'2009-04-10 12:07:19',3310490612,2),(321651082,424487806,15603035,372139,1,'2009-04-10 12:07:19',3310490612,2),(321651083,424489673,15601368,372139,1,'2009-04-10 12:07:19',3310490612,2),(321651084,424493141,15601368,372139,1,'2009-04-10 12:07:19',3310490613,2),(321651085,424495542,15601768,372139,1,'2009-04-10 12:07:19',3310490613,2),(321651086,424498210,15600834,372139,1,'2009-04-10 12:07:19',3310490613,2),(321651088,424501344,15596766,372139,1,'2009-04-10 12:07:19',3310490591,2),(321651089,424504545,15592365,372139,1,'2009-04-10 12:07:19',3310490591,2),(321651090,424509080,15590031,372139,1,'2009-04-10 12:07:19',3310490591,2),(321651091,424512881,15587963,372139,1,'2009-04-10 12:07:20',3310490591,2),(321651092,424516549,15587763,372139,1,'2009-04-10 12:07:20',3310490591,2),(321651093,424519217,15588563,372139,1,'2009-04-10 12:07:20',3310491274,2),(321651094,424529687,15588097,372139,1,'2009-04-10 12:07:20',3310491274,2),(321651095,424535289,15586829,372139,1,'2009-04-10 12:07:20',3310491274,2),(321651096,424550561,15581094,372139,1,'2009-04-10 12:07:20',3310491275,2),(321651097,424554695,15581428,372139,1,'2009-04-10 12:07:20',3310491275,2),(321651098,424557563,15583428,372139,1,'2009-04-10 12:07:20',3310491275,2),(321651099,424559564,15587496,372139,1,'2009-04-10 12:07:20',3310491275,2),(321651100,424560564,15590431,372139,1,'2009-04-10 12:07:20',3310491275,2),(321651101,424564565,15594032,372139,1,'2009-04-10 12:07:20',3310491275,2),(321651103,424568900,15595566,372139,1,'2009-04-10 12:07:20',3310491275,2),(321651104,424573635,15597433,372139,1,'2009-04-10 12:07:20',3310491278,2),(321651105,424579304,15600901,372139,1,'2009-04-10 12:07:20',3310491300,2),(321651106,424581371,15604302,372139,1,'2009-04-10 12:07:20',3310491300,2),(321651107,424584572,15608103,372139,1,'2009-04-10 12:07:20',3310491300,2),(321651108,424586906,15609971,372139,1,'2009-04-10 12:07:20',3310491300,2),(321651109,424587380,15610294,599374,1,'2008-12-25 21:58:55',3310491300,1),(321679128,424586858,15610012,621592,1,'2008-12-26 01:04:53',3310491300,1),(321679131,424586568,15610346,621592,1,'2008-12-26 01:04:53',3310491300,1),(321679133,424586026,15610554,621592,1,'2008-12-26 01:04:53',3310491300,1),(321679135,424585157,15611108,621592,1,'2008-12-26 01:04:53',3310491300,1),(321679137,424584332,15611625,621592,1,'2008-12-26 01:04:53',3310491300,1),(321679139,424583506,15612394,621592,1,'2008-12-26 01:04:54',3310491300,1),(321679141,424582914,15613276,621592,1,'2008-12-26 01:04:54',3310491300,1),(321679143,424582303,15614234,621592,1,'2008-12-26 01:04:54',3310491300,1),(321679145,424581711,15615342,621592,1,'2008-12-26 01:04:54',3310491300,1),(321679147,424581257,15616615,621592,1,'2008-12-26 01:04:55',3310491300,1),(321679148,424580545,15618291,621592,1,'2008-12-26 01:04:55',3310491300,1),(321679150,424579860,15620151,621592,1,'2008-12-26 01:04:55',3310491300,1),(321679151,424579742,15621503,621592,1,'2008-12-26 01:04:55',3310491300,1),(321679152,424579860,15622719,621592,1,'2008-12-26 01:04:55',3310491300,1),(321679154,424580105,15625322,621592,1,'2008-12-26 01:04:56',3310491300,1),(321679155,424580105,15626856,621592,1,'2008-12-26 01:04:56',3310491300,1),(321679156,424580087,15628208,621592,1,'2008-12-26 01:04:56',3310491300,1),(321679157,424580114,15630821,621592,1,'2008-12-26 01:04:56',3310491300,1),(321679159,424580486,15632680,621592,1,'2008-12-26 01:04:56',3310491300,1),(321679160,424581067,15634341,621592,1,'2008-12-26 01:04:56',3310491300,1),(321679161,424582346,15637090,621592,1,'2008-12-26 01:04:57',3310491300,1),(321679162,424582664,15637988,621592,1,'2008-12-26 01:04:57',3310491300,1),(321679163,424583036,15638941,621592,1,'2008-12-26 01:04:57',3310491300,1),(321679164,424583263,15639186,621592,1,'2008-12-26 01:04:57',3310491300,1),(321679165,424583417,15639095,621592,1,'2008-12-26 01:04:57',3310491300,1),(321679166,424583462,15638805,621592,1,'2008-12-26 01:04:58',3310491300,1),(321679170,424583644,15637562,621592,1,'2008-12-26 01:04:58',3310491300,1),(321679176,424584124,15636273,621592,1,'2008-12-26 01:04:58',3310491300,1),(321679180,424585286,15634286,621592,1,'2008-12-26 01:04:58',3310491300,1),(321679181,424586926,15633795,621592,1,'2008-12-26 01:04:58',3310491300,1),(321679182,424587732,15633435,621592,1,'2008-12-26 01:04:59',3310491300,1),(321679183,424589180,15632445,621592,1,'2008-12-26 01:04:59',3310491300,1),(321679184,424590802,15630245,621592,1,'2008-12-26 01:04:59',3310491300,1),(321679185,424591989,15628982,621592,1,'2008-12-26 01:04:59',3310491300,1),(321679186,424594329,15627251,621592,1,'2008-12-26 01:04:59',3310491300,1),(321679188,424596627,15625629,621592,1,'2008-12-26 01:04:59',3310491300,1),(321679189,424598554,15624344,621592,1,'2008-12-26 01:05:00',3310491300,1),(321679190,424600884,15623299,621592,1,'2008-12-26 01:05:00',3310491301,1),(321679191,424604074,15621165,621592,1,'2008-12-26 01:05:00',3310491301,1),(321679196,424606120,15619249,621592,1,'2008-12-26 01:05:00',3310491301,1),(321679197,424608439,15617017,621592,1,'2008-12-26 01:05:00',3310491301,1),(321679198,424611020,15614241,621592,1,'2008-12-26 01:05:00',3310491301,1),(321679199,424612827,15611987,621592,1,'2008-12-26 01:05:01',3310491301,1),(321679200,424614841,15610724,621592,1,'2008-12-26 01:05:01',3310491301,1),(321679202,424615919,15610452,621592,1,'2008-12-26 01:05:01',3310491301,1),(321679203,424616855,15610463,621592,1,'2008-12-26 01:05:01',3310491301,1),(321679204,424618183,15610224,621592,1,'2008-12-26 01:05:01',3310491301,1),(321679205,424619708,15609483,621592,1,'2008-12-26 01:05:02',3310491301,1),(321679206,424621776,15609233,621592,1,'2008-12-26 01:05:02',3310491301,1),(321679207,424623845,15609004,621592,1,'2008-12-26 01:05:02',3310491301,1),(321679208,424625162,15608732,621592,1,'2008-12-26 01:05:02',3310491301,1),(321679209,424627274,15609266,621592,1,'2008-12-26 01:05:02',3310491301,1),(321679210,424629260,15609869,621592,1,'2008-12-26 01:05:02',3310491312,1),(321679212,424630279,15610481,621592,1,'2008-12-26 01:05:03',3310491312,1),(321679213,424632191,15610888,621592,1,'2008-12-26 01:05:03',3310491312,1),(321679214,424636597,15611515,621592,1,'2008-12-26 01:05:03',3310491312,1),(321679215,424637741,15611766,621592,1,'2008-12-26 01:05:03',3310491312,1),(321679216,424639027,15612142,621592,1,'2008-12-26 01:05:03',3310491312,1),(321679217,424640328,15612628,621592,1,'2008-12-26 01:05:03',3310491312,1),(321679218,424642429,15612283,621592,1,'2008-12-26 01:05:04',3310491312,1),(321679219,424644953,15611923,621592,1,'2008-12-26 01:05:04',3310491312,1),(321679220,424645737,15611970,621592,1,'2008-12-26 01:05:04',3310491312,1),(321679221,424646505,15611562,621592,1,'2008-12-26 01:05:04',3310491312,1),(321679223,424647383,15611688,621592,1,'2008-12-26 01:05:04',3310491312,1),(321679224,424649594,15610967,621592,1,'2008-12-26 01:05:05',3310491312,1),(321679225,424651381,15610145,621592,1,'2008-12-26 01:05:05',3310491312,1),(321679226,424653714,15608170,621592,1,'2008-12-26 01:05:05',3310491312,1),(321679227,424657345,15604859,621592,1,'2008-12-26 01:05:05',3310491313,1),(321679228,424659602,15602770,621592,1,'2008-12-26 01:05:05',3310491313,1),(321679229,424661333,15599252,621592,1,'2008-12-26 01:05:06',3310491291,1),(321679230,424661879,15597785,621592,1,'2008-12-26 01:05:06',3310491291,1),(321679231,424663252,15596204,621592,1,'2008-12-26 01:05:06',3310491291,1),(321679233,424664343,15593683,621592,1,'2008-12-26 01:05:06',3310491291,1),(321679234,424664832,15592442,621592,1,'2008-12-26 01:05:06',3310491291,1),(321679236,424665566,15591106,621592,1,'2008-12-26 01:05:06',3310491291,1),(321679237,424665416,15592874,621592,1,'2008-12-26 01:05:07',3310491291,1),(321679238,424665547,15594229,621592,1,'2008-12-26 01:05:07',3310491291,1),(321679240,424666112,15596073,621592,1,'2008-12-26 01:05:07',3310491291,1),(321679242,424666375,15596901,621592,1,'2008-12-26 01:05:07',3310491291,1),(321679245,424667071,15597070,621592,1,'2008-12-26 01:05:07',3310491291,1),(321679247,424667617,15596750,621592,1,'2008-12-26 01:05:07',3310491291,1),(321679250,424668106,15596016,621592,1,'2008-12-26 01:05:08',3310491291,1),(321679252,424670458,15591971,621592,1,'2008-12-26 01:05:08',3310491291,1),(321679254,424671511,15591915,621592,1,'2008-12-26 01:05:08',3310491291,1),(321679255,424672471,15590993,621592,1,'2008-12-26 01:05:08',3310491291,1),(321679257,424674201,15590354,621592,1,'2008-12-26 01:05:08',3310491291,1),(321679260,424674841,15591012,621592,1,'2008-12-26 01:05:09',3310491291,1),(321679263,424675801,15591369,621592,1,'2008-12-26 01:05:09',3310491291,1),(321679266,424677701,15591840,621592,1,'2008-12-26 01:05:09',3310491291,1),(321679268,424678585,15591144,621592,1,'2008-12-26 01:05:09',3310491291,1),(321679271,424679789,15588980,621592,1,'2008-12-26 01:05:09',3310491291,1),(321679273,424681181,15587042,621592,1,'2008-12-26 01:05:09',3310491291,1),(321679275,424683062,15585782,621592,1,'2008-12-26 01:05:10',3310491294,1),(321679278,424686336,15585500,621592,1,'2008-12-26 01:05:10',3310491294,1),(321679281,424687822,15586327,621592,1,'2008-12-26 01:05:10',3310491294,1),(321679283,424689346,15587569,621592,1,'2008-12-26 01:05:10',3310491294,1),(321679286,424689666,15588472,621592,1,'2008-12-26 01:05:10',3310491294,1),(321679288,424689591,15590918,621592,1,'2008-12-26 01:05:10',3310491294,1),(321679290,424689628,15595602,621592,1,'2008-12-26 01:05:11',3310491294,1),(321679293,424690757,15599835,621592,1,'2008-12-26 01:05:11',3310491294,1),(321679295,424692732,15603353,621592,1,'2008-12-26 01:05:11',3310491316,1),(321679296,424694840,15606928,621592,1,'2008-12-26 01:05:11',3310491316,1),(321679298,424695009,15608283,621592,1,'2008-12-26 01:05:11',3310491316,1),(321679300,424694877,15610898,621592,1,'2008-12-26 01:05:11',3310491316,1),(321679302,424695517,15613851,621592,1,'2008-12-26 01:05:12',3310491316,1),(321679304,424697041,15615751,621592,1,'2008-12-26 01:05:12',3310491316,1),(321679306,424699580,15618178,621592,1,'2008-12-26 01:05:12',3310491316,1),(321679308,424700145,15617445,621592,1,'2008-12-26 01:05:12',3310491316,1),(321679309,424701142,15617896,621592,1,'2008-12-26 01:05:12',3310491316,1),(321679311,424703080,15619439,621592,1,'2008-12-26 01:05:12',3310491316,1),(321679313,424703531,15620662,621592,1,'2008-12-26 01:05:13',3310491316,1),(321679316,424703512,15622280,621592,1,'2008-12-26 01:05:13',3310491316,1),(321679318,424702986,15626005,621592,1,'2008-12-26 01:05:13',3310491316,1),(321679320,424702534,15629466,621592,1,'2008-12-26 01:05:13',3310491316,1),(321679322,424701349,15633060,621592,1,'2008-12-26 01:05:13',3310491316,1),(321679324,424700634,15636991,621592,1,'2008-12-26 01:05:14',3310491316,1),(321679326,424699599,15639080,621592,1,'2008-12-26 01:05:14',3310491316,1),(321679328,424699072,15638497,621592,1,'2008-12-26 01:05:14',3310491316,1),(321679330,424698452,15638120,621592,1,'2008-12-26 01:05:14',3310491316,1),(321679332,424697511,15639005,621592,1,'2008-12-26 01:05:14',3310491316,1),(321679334,424697172,15640039,621592,1,'2008-12-26 01:05:14',3310491316,1),(321679336,424695724,15643237,621592,1,'2008-12-26 01:05:15',3310491316,1),(321679340,424695197,15645570,621592,1,'2008-12-26 01:05:15',3310491316,1),(321679342,424694538,15649201,621592,1,'2008-12-26 01:05:15',3310491316,1),(321679344,424693410,15653303,621592,1,'2008-12-26 01:05:15',3310491316,1),(321679346,424692555,15657288,621592,1,'2008-12-26 01:05:15',3310491318,1),(321679348,424692005,15660799,621592,1,'2008-12-26 01:05:15',3310491318,1),(321679349,424690334,15663611,621592,1,'2008-12-26 01:05:16',3310491318,1),(321679350,424684921,15672472,621592,1,'2008-12-26 01:05:16',3310491318,1),(321679351,424684328,15673762,621592,1,'2008-12-26 01:05:16',3310491318,1),(321679353,424684286,15675433,621592,1,'2008-12-26 01:05:16',3310491318,1),(321679355,424685111,15677717,621592,1,'2008-12-26 01:05:16',3310491318,1),(321679357,424686781,15681566,621592,1,'2008-12-26 01:05:16',3310491318,1),(321679359,424687310,15683490,621592,1,'2008-12-26 01:05:17',3310491318,1),(321679361,424687522,15688544,621592,1,'2008-12-26 01:05:17',3310491318,1),(321679362,424687670,15689834,621592,1,'2008-12-26 01:05:17',3310491318,1),(321679365,424691032,15694825,621592,1,'2008-12-26 01:05:17',3310491318,1),(321679367,424692978,15699435,621592,1,'2008-12-26 01:05:17',3310491318,1),(321679369,424694902,15702459,621592,1,'2008-12-26 01:05:17',3310491318,1),(321679371,424697968,15705610,621592,1,'2008-12-26 01:05:18',3310491318,1),(321679373,424702198,15708740,621592,1,'2008-12-26 01:05:18',3310491318,1),(321679375,424706004,15711130,621592,1,'2008-12-26 01:05:18',3310491324,1),(321679378,424711947,15710960,621592,1,'2008-12-26 01:05:18',3310491325,1),(321679381,424713787,15711256,621592,1,'2008-12-26 01:05:18',3310491325,1),(321679383,424715056,15712250,621592,1,'2008-12-26 01:05:19',3310491325,1),(321679385,424715669,15714006,621592,1,'2008-12-26 01:05:19',3310491325,1),(321679387,424716282,15717305,621592,1,'2008-12-26 01:05:19',3310491325,1),(321679389,424719285,15723945,621592,1,'2008-12-26 01:05:19',3310491325,1),(321679391,424724720,15729570,621592,1,'2008-12-26 01:05:19',3310491325,1),(321679393,424729119,15733165,621592,1,'2008-12-26 01:05:19',3310491325,1),(321679394,424735103,15735576,621592,1,'2008-12-26 01:05:20',3310491325,1),(321679397,424739904,15736506,621592,1,'2008-12-26 01:05:20',3310491368,1),(321679398,424743985,15737077,621592,1,'2008-12-26 01:05:20',3310491368,1),(321679400,424748151,15739615,621592,1,'2008-12-26 01:05:20',3310491368,1),(321679402,424750181,15743041,621592,1,'2008-12-26 01:05:20',3310491368,1),(321679405,424750689,15744902,621592,1,'2008-12-26 01:05:20',3310491368,1),(321679408,424749526,15747144,621592,1,'2008-12-26 01:05:21',3310491368,1),(321679411,424749082,15751711,621592,1,'2008-12-26 01:05:21',3310491368,1),(321679413,424747052,15759240,621592,1,'2008-12-26 01:05:21',3310491368,1),(321679416,424746840,15760614,621592,1,'2008-12-26 01:05:21',3310491368,1),(321679418,424747622,15763681,621592,1,'2008-12-26 01:05:21',3310491368,1),(321679421,424748236,15767509,621592,1,'2008-12-26 01:05:22',3310491370,1),(321679422,424748955,15770385,621592,1,'2008-12-26 01:05:22',3310491370,1),(321679424,424749906,15774064,621592,1,'2008-12-26 01:05:22',3310491370,1),(321679426,424750795,15779330,621592,1,'2008-12-26 01:05:22',3310491370,1),(321679429,424751662,15784553,621592,1,'2008-12-26 01:05:22',3310491370,1),(321679431,424752994,15792103,621592,1,'2008-12-26 01:05:22',3310491370,1),(321679433,424753501,15793985,621592,1,'2008-12-26 01:05:23',3310491370,1),(321679435,424755426,15796777,621592,1,'2008-12-26 01:05:23',3310491370,1),(321679436,424758302,15800731,621592,1,'2008-12-26 01:05:23',3310491370,1),(321679437,424759127,15803713,621592,1,'2008-12-26 01:05:23',3310491370,1),(321679438,424758915,15806124,621592,1,'2008-12-26 01:05:23',3310491370,1),(321679439,424758704,15808725,621592,1,'2008-12-26 01:05:24',3310491370,1),(321679440,424760121,15812870,621592,1,'2008-12-26 01:05:24',3310491370,1),(321679441,424761580,15818368,621592,1,'2008-12-26 01:05:24',3310491370,1),(321679442,424762066,15820588,621592,1,'2008-12-26 01:05:24',3310492736,1),(321679443,424764033,15823084,621592,1,'2008-12-26 01:05:24',3310492736,1),(321679444,424766021,15824776,621592,1,'2008-12-26 01:05:25',3310492737,1),(321679445,424770462,15827483,621592,1,'2008-12-26 01:05:25',3310492737,1),(321679446,424771033,15828180,621592,1,'2008-12-26 01:05:25',3310492737,1),(321679447,424771138,15829534,621592,1,'2008-12-26 01:05:25',3310492737,1),(321679448,424770948,15831247,621592,1,'2008-12-26 01:05:25',3310492737,1),(321679449,424771244,15834186,621592,1,'2008-12-26 01:05:26',3310492737,1),(321679450,424772005,15836386,621592,1,'2008-12-26 01:05:26',3310492737,1),(321679451,424773845,15838796,621592,1,'2008-12-26 01:05:26',3310492737,1),(321679452,424775220,15840573,621592,1,'2008-12-26 01:05:26',3310492737,1),(321679453,424775622,15842518,621592,1,'2008-12-26 01:05:26',3310492737,1),(321679454,424776129,15844506,621592,1,'2008-12-26 01:05:27',3310492737,1),(321679455,424777187,15845585,621592,1,'2008-12-26 01:05:27',3310492737,1),(321679457,424777483,15845712,621592,1,'2008-12-26 01:05:27',3310492737,1),(321679458,424778138,15844802,621592,1,'2008-12-26 01:05:27',3310492737,1),(321679459,424779618,15842455,621592,1,'2008-12-26 01:05:27',3310492737,1),(321679460,424780507,15840911,621592,1,'2008-12-26 01:05:27',3310492737,1),(321679462,424781141,15840911,621592,1,'2008-12-26 01:05:28',3310492737,1),(321679465,424781881,15841461,621592,1,'2008-12-26 01:05:28',3310492737,1),(321679466,424783425,15843364,621592,1,'2008-12-26 01:05:28',3310492737,1),(321679467,424784842,15845733,621592,1,'2008-12-26 01:05:28',3310492737,1),(321679468,424785582,15847298,621592,1,'2008-12-26 01:05:28',3310492737,1),(321679469,424786491,15848841,621592,1,'2008-12-26 01:05:29',3310492737,1),(321679470,424786872,15849835,621592,1,'2008-12-26 01:05:29',3310492737,1),(321679471,424786661,15850723,621592,1,'2008-12-26 01:05:29',3310492737,1),(321679472,424786639,15852310,621592,1,'2008-12-26 01:05:29',3310492737,1),(321679473,424786155,15852204,621592,1,'2008-12-26 01:05:29',3310492737,1),(321679474,424785612,15851713,621592,1,'2008-12-26 01:05:30',3310492737,1),(321679478,424785068,15851868,621592,1,'2008-12-26 01:05:30',3310492737,1),(321679479,424784913,15852877,621592,1,'2008-12-26 01:05:30',3310492737,1),(321679480,424785508,15855386,621592,1,'2008-12-26 01:05:30',3310492737,1),(321679481,424786284,15857558,621592,1,'2008-12-26 01:05:31',3310492737,1),(321679482,424787344,15860222,621592,1,'2008-12-26 01:05:31',3310492737,1),(321679483,424788586,15862550,621592,1,'2008-12-26 01:05:31',3310492737,1),(321679484,424789827,15865059,621592,1,'2008-12-26 01:05:31',3310492737,1),(321679485,424793940,15867982,621592,1,'2008-12-26 01:05:31',3310492740,1),(321679486,424796423,15868421,621592,1,'2008-12-26 01:05:32',3310492740,1),(321679487,424797690,15868939,621592,1,'2008-12-26 01:05:32',3310492740,1),(321679488,424798932,15870879,621592,1,'2008-12-26 01:05:32',3310492740,1),(321679489,424799992,15872275,621592,1,'2008-12-26 01:05:32',3310492740,1),(321679490,424799295,15873647,621592,1,'2008-12-26 01:05:32',3310492740,1),(321679491,424798013,15875902,621592,1,'2008-12-26 01:05:33',3310492742,1),(321679492,424797306,15877714,621592,1,'2008-12-26 01:05:33',3310492742,1),(321679493,424796776,15880720,621592,1,'2008-12-26 01:05:33',3310492742,1),(321679494,424796687,15883151,621592,1,'2008-12-26 01:05:33',3310492742,1),(321679495,424797395,15885759,621592,1,'2008-12-26 01:05:33',3310492742,1),(321679496,424798544,15889207,621592,1,'2008-12-26 01:05:34',3310492742,1),(321679497,424799340,15892301,621592,1,'2008-12-26 01:05:34',3310492742,1),(321679498,424800312,15896766,621592,1,'2008-12-26 01:05:34',3310492742,1),(321679499,424801594,15900700,621592,1,'2008-12-26 01:05:34',3310492742,1),(321679500,424803097,15905076,621592,1,'2008-12-26 01:05:34',3310492742,1),(321679501,424803495,15908966,621592,1,'2008-12-26 01:05:35',3310492742,1),(321679502,424803716,15912458,621592,1,'2008-12-26 01:05:35',3310492742,1),(321679503,424803716,15915111,621592,1,'2008-12-26 01:05:35',3310492742,1),(321679505,424803495,15919001,621592,1,'2008-12-26 01:05:35',3310492742,1),(321679507,424803318,15922095,621592,1,'2008-12-26 01:05:35',3310492742,1),(321679508,424802920,15924747,621592,1,'2008-12-26 01:05:36',3310492742,1),(321679509,424801373,15934472,621592,1,'2008-12-26 01:05:36',3310492748,1),(321679510,424800445,15939998,621592,1,'2008-12-26 01:05:36',3310492748,1),(321679511,424799163,15944374,621592,1,'2008-12-26 01:05:36',3310492748,1),(321679512,424798146,15947777,621592,1,'2008-12-26 01:05:36',3310492748,1),(321679513,424795538,15955955,621592,1,'2008-12-26 01:05:37',3310492748,1),(321679514,424793460,15962763,621592,1,'2008-12-26 01:05:37',3310492748,1),(321679515,424790145,15972222,621592,1,'2008-12-26 01:05:37',3310492745,1),(321679516,424788819,15977085,621592,1,'2008-12-26 01:05:37',3310492745,1),(321679517,424788333,15983981,621592,1,'2008-12-26 01:05:37',3310492745,1),(321679518,424802143,15869086,621592,1,'2008-12-26 01:05:37',3310492740,1),(321679519,424803329,15866714,621592,1,'2008-12-26 01:05:38',3310492740,1),(321679520,424803482,15863958,621592,1,'2008-12-26 01:05:38',3310492740,1),(321679521,424802717,15860591,621592,1,'2008-12-26 01:05:38',3310492740,1),(321679522,424801033,15854583,621592,1,'2008-12-26 01:05:38',3310492740,1),(321679523,424799617,15848078,621592,1,'2008-12-26 01:05:38',3310492740,1),(321679524,424799656,15846203,621592,1,'2008-12-26 01:05:38',3310492740,1),(321679525,424800727,15844405,621592,1,'2008-12-26 01:05:39',3310492740,1),(321679526,424801416,15843524,621592,1,'2008-12-26 01:05:39',3310492740,1),(321679527,424802066,15841879,621592,1,'2008-12-26 01:05:39',3310492740,1),(321679528,424804247,15840234,621592,1,'2008-12-26 01:05:39',3310492740,1),(321679529,424806696,15837478,621592,1,'2008-12-26 01:05:39',3310492740,1),(321679530,424807462,15835756,621592,1,'2008-12-26 01:05:39',3310492740,1),(321679536,424807883,15832695,621592,1,'2008-12-26 01:05:40',3310492740,1),(321679543,424807309,15828065,621592,1,'2008-12-26 01:05:40',3310492740,1),(321679544,424806122,15826726,621592,1,'2008-12-26 01:05:40',3310492740,1),(321679545,424804401,15818728,621592,1,'2008-12-26 01:05:40',3310491374,1),(321679546,424802640,15813983,621592,1,'2008-12-26 01:05:40',3310491374,1),(321679549,424802640,15812835,621592,1,'2008-12-26 01:05:41',3310491374,1),(321679550,424802028,15811993,621592,1,'2008-12-26 01:05:41',3310491374,1),(321679551,424801492,15811764,621592,1,'2008-12-26 01:05:41',3310491374,1),(321679552,424801071,15809544,621592,1,'2008-12-26 01:05:41',3310491374,1),(321679553,424800727,15808396,621592,1,'2008-12-26 01:05:41',3310491374,1),(321679554,424801186,15806980,621592,1,'2008-12-26 01:05:41',3310491374,1),(321679555,424801263,15804761,621592,1,'2008-12-26 01:05:42',3310491374,1),(321679556,424800536,15803957,621592,1,'2008-12-26 01:05:42',3310491374,1),(321679557,424797819,15801240,621592,1,'2008-12-26 01:05:42',3310491374,1),(321679558,424796326,15798026,621592,1,'2008-12-26 01:05:42',3310491374,1),(321679559,424795178,15794620,621592,1,'2008-12-26 01:05:42',3310491374,1),(321679560,424793992,15792324,621592,1,'2008-12-26 01:05:42',3310491374,1),(321679561,424793839,15789416,621592,1,'2008-12-26 01:05:43',3310491374,1),(321679562,424794298,15786661,621592,1,'2008-12-26 01:05:43',3310491374,1),(321679563,424795370,15784403,621592,1,'2008-12-26 01:05:43',3310491374,1),(321679564,424795944,15782949,621592,1,'2008-12-26 01:05:43',3310491374,1),(321679565,424797781,15778128,621592,1,'2008-12-26 01:05:43',3310491374,1),(321679566,424800344,15772464,621592,1,'2008-12-26 01:05:43',3310491374,1),(321679567,424803214,15768217,621592,1,'2008-12-26 01:05:44',3310491374,1),(321679568,424805510,15764582,621592,1,'2008-12-26 01:05:44',3310491372,1),(321679569,424806505,15760832,621592,1,'2008-12-26 01:05:44',3310491372,1),(321679570,424806696,15759569,621592,1,'2008-12-26 01:05:44',3310491372,1),(321679571,424806161,15758306,621592,1,'2008-12-26 01:05:44',3310491372,1),(321679572,424805051,15758765,621592,1,'2008-12-26 01:05:44',3310491372,1),(321679573,424804171,15758765,621592,1,'2008-12-26 01:05:45',3310491372,1),(321679574,424803444,15757962,621592,1,'2008-12-26 01:05:45',3310491372,1),(321679575,424803712,15755015,621592,1,'2008-12-26 01:05:45',3310491372,1),(321679576,424803482,15754020,621592,1,'2008-12-26 01:05:45',3310491372,1),(321679577,424803980,15752643,621592,1,'2008-12-26 01:05:45',3310491372,1),(321679578,424805089,15748625,621592,1,'2008-12-26 01:05:45',3310491372,1),(321679579,424805166,15747209,621592,1,'2008-12-26 01:05:46',3310491372,1),(321679580,424804515,15744836,621592,1,'2008-12-26 01:05:46',3310491372,1),(321679581,424804133,15742464,621592,1,'2008-12-26 01:05:46',3310491372,1),(321679582,424802793,15741354,621592,1,'2008-12-26 01:05:46',3310491372,1),(321679583,424801837,15739709,621592,1,'2008-12-26 01:05:46',3310491372,1),(321679584,424802066,15737719,621592,1,'2008-12-26 01:05:47',3310491372,1),(321679586,424802870,15736647,621592,1,'2008-12-26 01:05:47',3310491372,1),(321679587,424802946,15735270,621592,1,'2008-12-26 01:05:47',3310491372,1),(321679588,424802411,15731864,621592,1,'2008-12-26 01:05:47',3310491372,1),(321679589,424801798,15730448,621592,1,'2008-12-26 01:05:47',3310491372,1),(321679590,424800689,15729032,621592,1,'2008-12-26 01:05:47',3310491372,1),(321679591,424800995,15726354,621592,1,'2008-12-26 01:05:48',3310491372,1),(321679592,424800650,15724326,621592,1,'2008-12-26 01:05:48',3310491372,1),(321679593,424799502,15720193,621592,1,'2008-12-26 01:05:48',3310491372,1),(321679594,424799273,15718356,621592,1,'2008-12-26 01:05:48',3310491372,1),(321679595,424798163,15717247,621592,1,'2008-12-26 01:05:48',3310491372,1),(321679596,424797207,15715333,621592,1,'2008-12-26 01:05:48',3310491372,1),(321679597,424797168,15713305,621592,1,'2008-12-26 01:05:49',3310491372,1),(321679598,424798010,15709134,621592,1,'2008-12-26 01:05:49',3310491366,1),(321679599,424797436,15708331,621592,1,'2008-12-26 01:05:49',3310491366,1),(321679600,424797513,15705767,621592,1,'2008-12-26 01:05:49',3310491366,1),(321679601,424798354,15704198,621592,1,'2008-12-26 01:05:49',3310491366,1),(321679602,424798201,15702935,621592,1,'2008-12-26 01:05:50',3310491366,1),(321679603,424799196,15700830,621592,1,'2008-12-26 01:05:50',3310491366,1),(321679604,424798661,15699836,621592,1,'2008-12-26 01:05:50',3310491366,1),(321679605,424797474,15697884,621592,1,'2008-12-26 01:05:50',3310491366,1),(321679606,424797819,15696085,621592,1,'2008-12-26 01:05:50',3310491366,1),(321679607,424798546,15694937,621592,1,'2008-12-26 01:05:51',3310491366,1),(321679608,424800038,15692909,621592,1,'2008-12-26 01:05:51',3310491366,1),(321679609,424801148,15690499,621592,1,'2008-12-26 01:05:51',3310491366,1),(321679610,424801033,15689351,621592,1,'2008-12-26 01:05:51',3310491366,1),(321679611,424800038,15688317,621592,1,'2008-12-26 01:05:52',3310491366,1),(321679612,424799809,15687208,621592,1,'2008-12-26 01:05:52',3310491366,1),(321679613,424800765,15685945,621592,1,'2008-12-26 01:05:52',3310491366,1),(321679614,424802066,15685754,621592,1,'2008-12-26 01:05:52',3310491366,1),(321679615,424803138,15684606,621592,1,'2008-12-26 01:05:52',3310491366,1),(321679616,424803980,15682348,621592,1,'2008-12-26 01:05:53',3310491366,1),(321679617,424805357,15680741,621592,1,'2008-12-26 01:05:53',3310491366,1),(321679618,424806735,15678789,621592,1,'2008-12-26 01:05:53',3310491366,1),(321679619,424811327,15676914,621592,1,'2008-12-26 01:05:53',3310491366,1),(321679620,424813049,15675192,621592,1,'2008-12-26 01:05:53',3310491366,1),(321679621,424815459,15673623,621592,1,'2008-12-26 01:05:54',3310491366,1),(321679622,424816990,15670524,621592,1,'2008-12-26 01:05:54',3310491366,1),(321679623,424819477,15668266,621592,1,'2008-12-26 01:05:54',3310491366,1),(321679624,424820702,15668228,621592,1,'2008-12-26 01:05:54',3310491367,1),(321679626,424822079,15667309,621592,1,'2008-12-26 01:05:54',3310491367,1),(321679627,424825102,15666314,621592,1,'2008-12-26 01:05:54',3310491367,1),(321679628,424826442,15666161,621592,1,'2008-12-26 01:05:55',3310491367,1),(321679629,424827322,15664975,621592,1,'2008-12-26 01:05:55',3310491367,1),(321679630,424827437,15663865,621592,1,'2008-12-26 01:05:55',3310491367,1),(321679631,424828546,15663177,621592,1,'2008-12-26 01:05:55',3310491367,1),(321679632,424830421,15661952,621592,1,'2008-12-26 01:05:55',3310491367,1),(321679633,424831837,15661608,621592,1,'2008-12-26 01:05:55',3310491367,1),(321679634,424835434,15660115,621592,1,'2008-12-26 01:05:56',3310491367,1),(321679635,424835817,15658929,621592,1,'2008-12-26 01:05:56',3310491367,1),(321679636,424838419,15656136,621592,1,'2008-12-26 01:05:56',3310491367,1),(321679637,424840447,15652539,621592,1,'2008-12-26 01:05:56',3310491365,1),(321679638,424842322,15648865,621592,1,'2008-12-26 01:05:56',3310491365,1),(321679639,424845460,15647220,621592,1,'2008-12-26 01:05:56',3310491365,1),(321679640,424847986,15645498,621592,1,'2008-12-26 01:05:57',3310491376,1),(321679641,424852386,15644618,621592,1,'2008-12-26 01:05:57',3310491376,1),(321679642,424854414,15644082,621592,1,'2008-12-26 01:05:57',3310491376,1),(321679643,424858279,15642283,621592,1,'2008-12-26 01:05:57',3310491376,1),(321679644,424859733,15642054,621592,1,'2008-12-26 01:05:57',3310491376,1),(321679645,424861953,15640179,621592,1,'2008-12-26 01:05:57',3310491376,1),(321679646,424863407,15638954,621592,1,'2008-12-26 01:05:58',3310491376,1),(321679647,424864096,15636544,621592,1,'2008-12-26 01:05:58',3310491376,1),(321679648,424866698,15635357,621592,1,'2008-12-26 01:05:58',3310491376,1),(321679649,424869070,15634401,621592,1,'2008-12-26 01:05:58',3310491376,1),(321679650,424870256,15632908,621592,1,'2008-12-26 01:05:58',3310491376,1),(321679651,424872399,15631531,621592,1,'2008-12-26 01:05:58',3310491376,1),(321679652,424873585,15632487,621592,1,'2008-12-26 01:05:59',3310491376,1),(321679653,424877412,15630153,621592,1,'2008-12-26 01:05:59',3310491377,1),(321679654,424879172,15627781,621592,1,'2008-12-26 01:05:59',3310491377,1),(321679655,424881889,15626824,621592,1,'2008-12-26 01:05:59',3310491377,1),(321679656,424882846,15626862,621592,1,'2008-12-26 01:05:59',3310491377,1),(321679657,424883114,15626212,621592,1,'2008-12-26 01:05:59',3310491377,1),(321679658,424884415,15626135,621592,1,'2008-12-26 01:06:00',3310491377,1),(321679659,424887591,15627015,621592,1,'2008-12-26 01:06:00',3310491377,1),(321679660,424889887,15626556,621592,1,'2008-12-26 01:06:00',3310491377,1),(321679661,424896162,15623533,621592,1,'2008-12-26 01:06:00',3310491377,1),(321679662,424896507,15622117,621592,1,'2008-12-26 01:06:00',3310491377,1),(321679663,424898114,15621811,621592,1,'2008-12-26 01:06:00',3310491377,1),(321679664,424899568,15620548,621592,1,'2008-12-26 01:06:01',3310491377,1),(321679665,424901443,15622500,621592,1,'2008-12-26 01:06:01',3310491377,1),(321679666,424902897,15622691,621592,1,'2008-12-26 01:06:01',3310491380,1),(321679667,424906533,15622041,621592,1,'2008-12-26 01:06:01',3310491380,1),(321679668,424907489,15621237,621592,1,'2008-12-26 01:06:01',3310491380,1),(321679669,424908446,15621428,621592,1,'2008-12-26 01:06:01',3310491380,1),(321679670,424911239,15621084,621592,1,'2008-12-26 01:06:02',3310491380,1),(321679671,424916290,15620510,621592,1,'2008-12-26 01:06:02',3310491380,1),(321679672,424917438,15619783,621592,1,'2008-12-26 01:06:02',3310491380,1),(321679673,424919658,15619668,621592,1,'2008-12-26 01:06:02',3310491380,1),(321679674,424923714,15620013,621592,1,'2008-12-26 01:06:02',3310491380,1),(321679675,424927043,15617143,621592,1,'2008-12-26 01:06:02',3310491380,1),(321679676,424928803,15615497,621592,1,'2008-12-26 01:06:03',3310491380,1),(321679677,424933701,15615995,621592,1,'2008-12-26 01:06:03',3310491381,1),(321679678,424936533,15614694,621592,1,'2008-12-26 01:06:03',3310491381,1),(321679679,424937949,15614732,621592,1,'2008-12-26 01:06:03',3310491381,1),(321679681,424942579,15613201,621592,1,'2008-12-26 01:06:03',3310491381,1),(321679682,424944378,15612130,621592,1,'2008-12-26 01:06:03',3310491381,1),(321679683,424945908,15612168,621592,1,'2008-12-26 01:06:04',3310491381,1),(321679684,424947439,15611250,621592,1,'2008-12-26 01:06:04',3310491381,1),(321679685,424950309,15609681,621592,1,'2008-12-26 01:06:04',3310491381,1),(321679686,424955628,15610676,621592,1,'2008-12-26 01:06:04',3310491381,1),(321679687,424960411,15610293,621592,1,'2008-12-26 01:06:04',3310491552,1),(321679688,424963855,15610217,621592,1,'2008-12-26 01:06:04',3310491552,1),(321679689,424966228,15609375,621592,1,'2008-12-26 01:06:05',3310491552,1),(321679690,424972848,15610752,621592,1,'2008-12-26 01:06:05',3310491552,1),(321679691,424973881,15610140,621592,1,'2008-12-26 01:06:05',3310491552,1),(321679692,424974455,15608112,621592,1,'2008-12-26 01:06:05',3310491552,1),(321679693,424974723,15604974,621592,1,'2008-12-26 01:06:05',3310491552,1),(321679694,424975832,15602793,621592,1,'2008-12-26 01:06:05',3310491552,1),(321679695,424976980,15602563,621592,1,'2008-12-26 01:06:06',3310491552,1),(321679696,424978664,15603214,621592,1,'2008-12-26 01:06:06',3310491552,1),(321679697,424978626,15600803,621592,1,'2008-12-26 01:06:06',3310491530,1),(321679698,424978779,15598431,621592,1,'2008-12-26 01:06:06',3310491530,1),(321679699,424979927,15596135,621592,1,'2008-12-26 01:06:06',3310491530,1),(321679700,424980080,15594719,621592,1,'2008-12-26 01:06:06',3310491530,1),(321679701,424981687,15592805,621592,1,'2008-12-26 01:06:07',3310491530,1),(321679702,424981725,15590089,621592,1,'2008-12-26 01:06:07',3310491530,1),(321679703,424982682,15588558,621592,1,'2008-12-26 01:06:07',3310491530,1),(321679704,424983179,15586874,621592,1,'2008-12-26 01:06:07',3310491530,1),(321679710,424982491,15585918,621592,1,'2008-12-26 01:06:07',3310491530,1),(321679711,424982873,15584770,621592,1,'2008-12-26 01:06:07',3310491530,1),(321679712,424983600,15584043,621592,1,'2008-12-26 01:06:08',3310491530,1),(321679713,424983141,15582895,621592,1,'2008-12-26 01:06:08',3310491530,1),(321679714,424982337,15582588,621592,1,'2008-12-26 01:06:08',3310491530,1),(321679715,424982070,15580943,621592,1,'2008-12-26 01:06:08',3310491530,1),(321679716,424983179,15579412,621592,1,'2008-12-26 01:06:08',3310491530,1),(321679717,424984710,15577499,621592,1,'2008-12-26 01:06:08',3310491530,1),(321679718,424985858,15576045,621592,1,'2008-12-26 01:06:09',3310491531,1),(321679719,424987465,15572678,621592,1,'2008-12-26 01:06:09',3310491531,1),(321679720,424987924,15570917,621592,1,'2008-12-26 01:06:09',3310491531,1),(321679721,424990105,15568927,621592,1,'2008-12-26 01:06:09',3310491531,1),(321679722,424990909,15565981,621592,1,'2008-12-26 01:06:09',3310491531,1),(321679723,424992142,15564242,621592,1,'2008-12-26 01:06:09',3310491531,1),(321679724,424995547,15563391,621592,1,'2008-12-26 01:06:10',3310491531,1),(321679725,424996667,15563301,621592,1,'2008-12-26 01:06:10',3310491531,1),(321679726,424997205,15562809,621592,1,'2008-12-26 01:06:10',3310491531,1),(321679727,424997742,15561554,621592,1,'2008-12-26 01:06:10',3310491531,1),(321679728,424998773,15560658,621592,1,'2008-12-26 01:06:10',3310491531,1),(321679729,425001103,15557835,621592,1,'2008-12-26 01:06:10',3310491531,1),(321679731,425001775,15556132,621592,1,'2008-12-26 01:06:11',3310491531,1),(321679732,425003657,15554475,621592,1,'2008-12-26 01:06:11',3310491531,1),(321679733,425005449,15553086,621592,1,'2008-12-26 01:06:11',3310491531,1),(321679734,425004822,15550845,621592,1,'2008-12-26 01:06:11',3310491531,1),(321679735,425005807,15549232,621592,1,'2008-12-26 01:06:11',3310491531,1),(321679738,425007196,15547888,621592,1,'2008-12-26 01:06:11',3310491531,1),(321679745,425007376,15546365,621592,1,'2008-12-26 01:06:12',3310491531,1),(321679746,425008630,15544348,621592,1,'2008-12-26 01:06:12',3310491529,1),(321679747,425008137,15542198,621592,1,'2008-12-26 01:06:12',3310491529,1),(321679748,425007107,15540271,621592,1,'2008-12-26 01:06:12',3310491529,1),(321679749,425007376,15537672,621592,1,'2008-12-26 01:06:12',3310491529,1),(321679750,425008765,15536239,621592,1,'2008-12-26 01:06:12',3310491529,1),(321679751,425011946,15534088,621592,1,'2008-12-26 01:06:13',3310491529,1),(321679752,425014276,15532027,621592,1,'2008-12-26 01:06:13',3310491532,1),(321679753,425018712,15528487,621592,1,'2008-12-26 01:06:13',3310491532,1),(321679754,425023551,15524634,621592,1,'2008-12-26 01:06:13',3310491532,1),(321679755,425026732,15522035,621592,1,'2008-12-26 01:06:13',3310491532,1),(321679756,425027628,15520915,621592,1,'2008-12-26 01:06:13',3310491532,1),(321679757,425028658,15518047,621592,1,'2008-12-26 01:06:14',3310491532,1),(321679759,425029734,15516210,621592,1,'2008-12-26 01:06:14',3310491532,1),(321679761,425031795,15514956,621592,1,'2008-12-26 01:06:14',3310491532,1),(321679762,425032781,15514597,621592,1,'2008-12-26 01:06:14',3310491532,1),(321679764,425032557,15515897,621592,1,'2008-12-26 01:06:14',3310491532,1),(321679766,425034304,15515897,621592,1,'2008-12-26 01:06:14',3310491532,1),(321679767,425035783,15515897,621592,1,'2008-12-26 01:06:15',3310491532,1),(321679769,425037351,15514956,621592,1,'2008-12-26 01:06:15',3310491532,1),(321679771,425038471,15513836,621592,1,'2008-12-26 01:06:15',3310491532,1),(321679773,425039457,15513656,621592,1,'2008-12-26 01:06:15',3310491532,1),(321679774,425040308,15512850,621592,1,'2008-12-26 01:06:15',3310491533,1),(321679776,425043086,15510072,621592,1,'2008-12-26 01:06:15',3310491533,1),(321679779,424782021,15983952,621592,1,'2008-12-26 01:06:16',3310492745,1),(321681942,425313605,15056438,181856,1,'2009-04-04 22:25:04',3310491480,8),(321681943,425315488,15053537,181856,1,'2009-04-04 22:25:04',3310491481,7),(321681944,425315603,15051476,181856,1,'2009-04-04 22:25:04',3310491475,7),(321681945,425314000,15049187,181856,1,'2009-04-04 22:25:04',3310491474,7),(321681946,425312912,15046840,181856,1,'2009-04-04 22:25:03',3310491474,7),(321681947,425312340,15044092,181856,1,'2009-04-04 22:25:03',3310491474,7),(321681949,425311252,15041574,181856,1,'2009-04-04 22:25:03',3310491474,7),(321681950,425309363,15037968,181856,1,'2009-04-04 22:25:03',3310491474,7),(321681951,425308734,15034762,181856,1,'2009-04-04 22:25:03',3310491474,7),(321681953,425308963,15031042,181856,1,'2009-04-04 22:25:03',3310491474,7),(321681957,425310222,15028065,181856,1,'2009-04-04 22:25:03',3310491474,7),(321681958,425312397,15024173,181856,1,'2009-04-04 22:25:02',3310491474,7),(321681961,425314057,15022284,181856,1,'2009-04-04 22:25:02',3310491474,7),(321681962,425314172,15020452,181856,1,'2009-04-04 22:25:02',3310491474,7),(321681963,425313256,15018906,181856,1,'2009-04-04 22:25:02',3310491474,7),(321681964,425310966,15016903,181856,1,'2009-04-04 22:25:02',3310491474,7),(321681965,425309020,15015186,181856,1,'2009-04-04 22:25:02',3310491474,7),(321681966,425307131,15011637,181856,1,'2009-04-04 22:25:02',3310491474,7),(321681967,425306902,15009176,181856,1,'2009-04-04 22:25:02',3310491474,7),(321681968,425306616,15005798,181856,1,'2009-04-04 22:25:01',3310491474,7),(321681969,425306959,14997269,181856,1,'2009-04-04 22:25:01',3310491474,7),(321681970,425306902,14995037,181856,1,'2009-04-04 22:25:01',3310491472,7),(321681971,425307074,14993320,181856,1,'2009-04-04 22:25:01',3310491472,7),(321681972,425307532,14992061,181856,1,'2009-04-04 22:25:01',3310491472,7),(321681974,425307990,14990858,181856,1,'2009-04-04 22:25:01',3310491472,7),(321681975,425307589,14989885,181856,1,'2009-04-04 22:25:01',3310491472,7),(321681976,425306616,14989485,181856,1,'2009-04-04 22:25:00',3310491472,7),(321681977,425305643,14989485,181856,1,'2009-04-04 22:25:00',3310491472,7),(321681978,425304612,14989141,181856,1,'2009-04-04 22:25:00',3310491472,7),(321681979,425303754,14988225,181856,1,'2009-04-04 22:25:00',3310491472,7),(321681980,425303582,14987023,181856,1,'2009-04-04 22:25:00',3310491472,7),(321681981,425302781,14985478,181856,1,'2009-04-04 22:24:59',3310491472,7),(321681982,425301178,14983818,181856,1,'2009-04-04 22:24:59',3310491472,7),(321681986,425299346,14982444,181856,1,'2009-04-04 22:24:59',3310491472,7),(321681987,425297744,14981929,181856,1,'2009-04-04 22:24:59',3310491472,7),(321681988,425296484,14981528,181856,1,'2009-04-04 22:24:59',3310491472,7),(321681989,425295397,14980097,181856,1,'2009-04-04 22:24:59',3310491472,7),(321681990,425293565,14976892,181856,1,'2009-04-04 22:24:58',3310491472,7),(321681991,425292592,14974201,181856,1,'2009-04-04 22:24:58',3310491472,7),(321681992,425292306,14969794,181856,1,'2009-04-04 22:24:57',3310491472,7),(321681993,425291561,14966703,181856,1,'2009-04-04 22:24:57',3310491472,7),(321681994,425290646,14963039,181856,1,'2009-04-04 22:24:57',3310491472,7),(321681995,425290417,14958975,181856,1,'2009-04-04 22:24:57',3310491472,7),(321681996,425290188,14956457,181856,1,'2009-04-04 22:24:57',3310491472,7),(321681997,425288986,14953366,181856,1,'2009-04-04 22:24:57',3310491472,7),(321681998,425288470,14952106,181856,1,'2009-04-04 22:24:57',3310491472,7),(321681999,425288470,14949244,181856,1,'2009-04-04 22:24:57',3310491472,7),(321682000,425286639,14947184,181856,1,'2009-04-04 22:24:57',3310491461,7),(321682002,425283605,14944207,181856,1,'2009-04-04 22:24:57',3310491461,8),(321682003,425283319,14942948,181856,1,'2009-04-04 22:12:29',3310491461,4),(321682005,425283137,14940490,181856,1,'2009-04-04 22:12:28',3310491119,4),(321682007,425283079,14939289,181856,1,'2009-04-04 22:12:28',3310491119,4),(321682009,425283343,14938322,181856,1,'2009-04-04 22:12:28',3310491119,4),(321682012,425284339,14937823,181856,1,'2009-04-04 22:12:27',3310491119,4),(321682016,425284984,14938439,181856,1,'2009-04-04 22:12:27',3310491119,4);
INSERT INTO `current_nodes` VALUES (321682018,425285394,14939406,181856,1,'2009-04-04 22:12:27',3310491119,4),(321682021,425285746,14940227,181856,1,'2009-04-04 22:12:26',3310491119,4),(321682024,425288325,14941575,181856,1,'2009-04-04 22:12:26',3310491130,4),(321682028,425290845,14942483,181856,1,'2009-04-04 22:12:26',3310491472,4),(321682035,425293161,14943069,181856,1,'2009-04-04 22:12:26',3310491472,4),(321682038,425294216,14943802,181856,1,'2009-04-04 22:12:25',3310491472,4),(321682039,425296941,14943978,181856,1,'2009-04-04 22:12:25',3310491472,4),(321682040,425297439,14945004,181856,1,'2009-04-04 22:12:24',3310491472,4),(321682041,425297762,14946586,181856,1,'2009-04-04 22:12:24',3310491472,4),(321682042,425298201,14947846,181856,1,'2009-04-04 22:12:24',3310491472,4),(321682043,425298465,14948696,181856,1,'2009-04-04 22:12:23',3310491472,4),(321682044,425299462,14949107,181856,1,'2009-04-04 22:12:23',3310491472,4),(321682045,425300077,14948696,181856,1,'2009-04-04 22:12:22',3310491472,4),(321682046,425300048,14947495,181856,1,'2009-04-04 22:12:22',3310491472,4),(321682047,425299901,14945941,181856,1,'2009-04-04 22:12:22',3310491472,4),(321682048,425299872,14944711,181856,1,'2009-04-04 22:12:21',3310491472,4),(321682049,425299872,14943538,181856,1,'2009-04-04 22:12:21',3310491472,4),(321682050,425298729,14940666,181856,1,'2009-04-04 22:12:21',3310491130,4),(321682051,425296912,14938439,181856,1,'2009-04-04 22:12:20',3310491130,4),(321682052,425295476,14935860,181856,1,'2009-04-04 22:12:20',3310491130,4),(321682053,425293542,14933310,181856,1,'2009-04-04 22:12:19',3310491130,4),(321682054,425292868,14930702,181856,1,'2009-04-04 22:12:19',3310491130,4),(321682055,425292457,14927888,181856,1,'2009-04-04 22:12:19',3310491130,4),(321682059,425291519,14922232,181856,1,'2009-04-04 22:12:18',3310491130,4),(321682061,425291578,14920210,181856,1,'2009-04-04 22:12:18',3310491130,4),(321682062,425291812,14918598,181856,1,'2009-04-04 22:12:18',3310491130,4),(321682063,425292106,14916576,181856,1,'2009-04-04 22:12:17',3310491130,4),(321682064,425291812,14915579,181856,1,'2009-04-04 22:12:17',3310491130,4),(321682065,425291050,14914876,181856,1,'2009-04-04 22:12:17',3310491130,4),(321682066,425289526,14914231,181856,1,'2009-04-04 22:12:16',3310491130,4),(321682067,425287973,14914231,181856,1,'2009-04-04 22:12:16',3310491130,4),(321682068,425286772,14913528,181856,1,'2009-04-04 22:12:15',3310491119,4),(321682069,425285160,14911388,181856,1,'2009-04-04 22:12:15',3310491119,4),(321682070,425282522,14906670,181856,1,'2009-04-04 22:12:14',3310491119,4),(321682071,425281789,14904413,181856,1,'2009-04-04 22:12:14',3310491119,4),(321682072,425281233,14902948,181856,1,'2009-04-04 22:12:13',3310491119,4),(321682073,425280119,14900925,181856,1,'2009-04-04 22:12:13',3310491119,4),(321682074,425279181,14900398,181856,1,'2009-04-04 22:12:13',3310491119,4),(321682075,425278155,14899988,181856,1,'2009-04-04 22:12:12',3310491119,4),(321682076,425277012,14898962,181856,1,'2009-04-04 22:12:12',3310491119,4),(321682077,425275547,14895826,181856,1,'2009-04-04 22:12:11',3310491119,4),(321682078,425273876,14893569,181856,1,'2009-04-04 22:12:11',3310491119,4),(321682079,425271532,14890551,181856,1,'2009-04-04 22:12:11',3310491119,4),(321682080,425270447,14888411,181856,1,'2009-04-04 22:12:10',3310491119,4),(321682081,425269949,14885334,181856,1,'2009-04-04 22:12:10',3310491117,4),(321682082,425269803,14883019,181856,1,'2009-04-04 22:12:09',3310491117,4),(321682083,425270184,14881964,181856,1,'2009-04-04 22:12:09',3310491117,4),(321682084,425270858,14881290,181856,1,'2009-04-04 22:12:08',3310491117,4),(321682085,425271883,14881290,181856,1,'2009-04-04 22:12:08',3310491117,4),(321682086,425273876,14882139,181856,1,'2009-04-04 22:12:08',3310491117,4),(321682087,425277247,14883312,181856,1,'2009-04-04 22:12:07',3310491117,4),(321682088,425280295,14884279,181856,1,'2009-04-04 22:12:07',3310491117,4),(321682089,425282288,14884924,181856,1,'2009-04-04 22:12:06',3310491117,4),(321682090,425283225,14884338,181856,1,'2009-04-04 22:12:06',3310491117,4),(321682091,425283401,14882784,181856,1,'2009-04-04 22:12:06',3310491117,4),(321682092,425283079,14880440,181856,1,'2009-04-04 22:12:05',3310491117,4),(321682093,425282170,14877743,181856,1,'2009-04-04 22:12:05',3310491117,4),(321682094,425280383,14873816,181856,1,'2009-04-04 22:12:04',3310491117,4),(321682095,425278360,14869918,181856,1,'2009-04-04 22:12:04',3310491117,4),(321682096,425276690,14868219,181856,1,'2009-04-04 22:12:03',3310491117,4),(321682097,425274228,14867163,181856,1,'2009-04-04 22:12:03',3310491117,4),(321682098,425272733,14866489,181856,1,'2009-04-04 22:12:02',3310491117,4),(321682099,425272030,14864819,181856,1,'2009-04-04 22:12:02',3310491117,4),(321682100,425271239,14861947,181856,1,'2009-04-04 22:12:02',3310491117,4),(321682101,425270389,14858342,181856,1,'2009-04-04 22:12:01',3310491117,4),(321682102,425269392,14855939,181856,1,'2009-04-04 22:12:01',3310491117,4),(321682103,425268396,14853477,181856,1,'2009-04-04 22:12:01',3310491117,4),(321682104,425268572,14852510,181856,1,'2009-04-04 22:12:00',3310491117,4),(321682105,425267077,14851074,181856,1,'2009-04-04 22:12:00',3310491117,4),(321682106,425265084,14848846,181856,1,'2009-04-04 22:11:59',3310491117,4),(321682107,425263912,14846941,181856,1,'2009-04-04 22:11:59',3310491117,4),(321682108,425263296,14843923,181856,1,'2009-04-04 22:11:59',3310491117,4),(321682109,425263355,14841842,181856,1,'2009-04-04 22:11:59',3310491117,4),(321682110,425263619,14840377,181856,1,'2009-04-04 22:11:58',3310491117,4),(321682111,425264352,14839322,181856,1,'2009-04-04 22:11:58',3310491117,4),(321682112,425264791,14838384,181856,1,'2009-04-04 22:11:58',3310491117,4),(321682113,425264791,14837182,181856,1,'2009-04-04 22:11:57',3310491117,4),(321682114,425263296,14835013,181856,1,'2009-04-04 22:11:57',3310491117,4),(321682115,425262974,14833548,181856,1,'2009-04-04 22:11:57',3310491117,4),(321682116,425262652,14830529,181856,1,'2009-04-04 22:11:57',3310491111,4),(321682117,425261567,14828068,181856,1,'2009-04-04 22:11:56',3310491111,4),(321682118,425260131,14825489,181856,1,'2009-04-04 22:11:56',3310491111,4),(321682119,425258812,14822528,181856,1,'2009-04-04 22:11:56',3310491110,4),(321682120,425256790,14819363,181856,1,'2009-04-04 22:11:55',3310491110,4),(321682121,425255120,14817605,181856,1,'2009-04-04 22:11:55',3310491110,4),(321682122,425250841,14813385,181856,1,'2009-04-04 22:11:54',3310491110,4),(321682123,425248760,14812124,181856,1,'2009-04-04 22:11:54',3310491110,4),(321682124,425247324,14812886,181856,1,'2009-04-04 22:11:54',3310491110,4),(321682125,425246240,14813531,181856,1,'2009-04-04 22:11:54',3310491110,4),(321682126,425245829,14812886,181856,1,'2009-04-04 22:11:53',3310491110,4),(321682127,425245888,14811978,181856,1,'2009-04-04 22:11:53',3310491110,4),(321682128,425246034,14808139,181856,1,'2009-04-04 22:11:53',3310491110,4),(321682129,425245712,14806497,181856,1,'2009-04-04 22:11:52',3310491110,4),(321682130,425244159,14804534,181856,1,'2009-04-04 22:11:52',3310491110,4),(321682131,425243338,14801574,181856,1,'2009-04-04 22:11:52',3310491110,4),(321682133,425242899,14799610,181856,1,'2009-04-04 22:11:51',3310491110,4),(321682134,425241990,14795331,181856,1,'2009-04-04 22:11:51',3310491110,4),(321682135,425240964,14792987,181856,1,'2009-04-04 22:11:51',3310491110,4),(321682136,425239645,14792313,181856,1,'2009-04-04 22:11:50',3310491110,4),(321682137,425238913,14790730,181856,1,'2009-04-04 22:11:50',3310491110,4),(321682138,425238209,14788679,181856,1,'2009-04-04 22:11:49',3310491110,4),(321682139,425237301,14786246,181856,1,'2009-04-04 22:11:49',3310491110,4),(321682140,425236685,14782231,181856,1,'2009-04-04 22:11:48',3310491110,4),(321682141,425236275,14778333,181856,1,'2009-04-04 22:11:48',3310491110,4),(321682142,425235308,14772267,181856,1,'2009-04-04 22:11:48',3310491108,4),(321682143,425234370,14768222,181856,1,'2009-04-04 22:11:47',3310491108,4),(321682146,425232876,14765790,181856,1,'2009-04-04 22:11:47',3310491108,4),(321682149,425232524,14762976,181856,1,'2009-04-04 22:11:46',3310491108,4),(321682150,425232143,14760309,181856,1,'2009-04-04 22:11:46',3310491105,4),(321682151,425231703,14758170,181856,1,'2009-04-04 22:11:46',3310491105,4),(321682152,425230531,14756060,181856,1,'2009-04-04 22:11:45',3310491105,4),(321682154,425229740,14755005,181856,1,'2009-04-04 22:11:45',3310491105,4),(321682155,425229681,14753627,181856,1,'2009-04-04 22:11:44',3310491105,4),(321682156,425229036,14752572,181856,1,'2009-04-04 22:11:44',3310491105,4),(321682157,425230033,14751400,181856,1,'2009-04-04 22:11:43',3310491105,4),(321682158,425229447,14750198,181856,1,'2009-04-04 22:11:43',3310491105,4),(321682159,425228802,14747766,181856,1,'2009-04-04 22:11:43',3310491105,4),(321682160,425227659,14745743,181856,1,'2009-04-04 22:11:42',3310491105,4),(321682161,425226076,14742813,181856,1,'2009-04-04 22:11:42',3310491105,4),(321682162,425225197,14741582,181856,1,'2009-04-04 22:11:42',3310491105,4),(321682163,425220420,14740263,181856,1,'2009-04-04 22:11:41',3310491105,4),(321682164,425216757,14740937,181856,1,'2009-04-04 22:11:41',3310491105,4),(321682165,425213679,14741172,181856,1,'2009-04-04 22:11:40',3310491105,4),(321682166,425212155,14739941,181856,1,'2009-04-04 22:11:40',3310491105,4),(321682167,425210368,14738006,181856,1,'2009-04-04 22:11:39',3310491105,4),(321682168,425208521,14737156,181856,1,'2009-04-04 22:11:39',3310491105,4),(321682169,425207114,14736219,181856,1,'2009-04-04 22:11:38',3310491105,4),(321682170,425205854,14733229,181856,1,'2009-04-04 22:11:38',3310491105,4),(321682172,425205151,14730826,181856,1,'2009-04-04 22:11:37',3310491105,4),(321682174,425203979,14730123,181856,1,'2009-04-04 22:11:36',3310491104,4),(321682178,425202455,14729771,181856,1,'2009-04-04 22:11:35',3310491104,4),(321682179,425201487,14728569,181856,1,'2009-04-04 22:11:35',3310491104,4),(321682180,425200813,14726928,181856,1,'2009-04-04 22:11:34',3310491104,4),(321682182,425200169,14726313,181856,1,'2009-04-04 22:11:34',3310491104,4),(321682184,425200550,14724466,181856,1,'2009-04-04 22:11:33',3310491104,4),(321682185,425199553,14722767,181856,1,'2009-04-04 22:11:33',3310491104,4),(321682186,425198234,14720217,181856,1,'2009-04-04 22:11:32',3310491082,4),(321682187,425197472,14718458,181856,1,'2009-04-04 22:11:32',3310491082,4),(321682188,425196036,14716407,181856,1,'2009-04-04 22:11:31',3310491082,4),(321682189,425195802,14714004,181856,1,'2009-04-04 22:11:31',3310491082,4),(321682190,425195421,14712333,181856,1,'2009-04-04 22:11:30',3310491082,4),(321682191,425195567,14709344,181856,1,'2009-04-04 22:11:28',3310491082,4),(321682192,425196593,14707029,181856,1,'2009-04-04 22:11:27',3310491082,4),(321682193,425197443,14705299,181856,1,'2009-04-04 22:11:27',3310491082,4),(321682194,425198293,14704772,181856,1,'2009-04-04 22:11:26',3310491082,4),(321682195,425199582,14704889,181856,1,'2009-04-04 22:11:26',3310491082,4),(321682196,425202689,14706120,181856,1,'2009-04-04 22:11:25',3310491082,4),(321682197,425205913,14707527,181856,1,'2009-04-04 22:11:23',3310491083,4),(321682198,425209547,14708084,181856,1,'2009-04-04 22:11:22',3310491083,4),(321682199,425210778,14708259,181856,1,'2009-04-04 22:11:22',3310491083,4),(321682200,425212038,14709402,181856,1,'2009-04-04 22:11:21',3310491083,4),(321682201,425213503,14710516,181856,1,'2009-04-04 22:11:20',3310491083,4),(321682202,425214441,14710340,181856,1,'2009-04-04 22:11:20',3310491083,4),(321682203,425215203,14709432,181856,1,'2009-04-04 22:11:19',3310491083,4),(321682204,425215614,14708142,181856,1,'2009-04-04 22:11:18',3310491083,4),(321682205,425215057,14706618,181856,1,'2009-04-04 22:11:18',3310491083,4),(321682206,425213972,14705153,181856,1,'2009-04-04 22:11:17',3310491083,4),(321682207,425213386,14704244,181856,1,'2009-04-04 22:11:17',3310491083,4),(321682208,425213240,14702457,181856,1,'2009-04-04 22:11:17',3310491083,4),(321682209,425212038,14701343,181856,1,'2009-04-04 22:11:16',3310491083,4),(321682210,425210309,14700434,181856,1,'2009-04-04 22:11:16',3310491083,4),(321682211,425209107,14699321,181856,1,'2009-04-04 22:11:15',3310491083,4),(321682212,425208609,14696683,181856,1,'2009-04-04 22:11:15',3310491083,4),(321682213,425207525,14694426,181856,1,'2009-04-04 22:11:15',3310491083,4),(321682214,425206001,14691672,181856,1,'2009-04-04 22:11:14',3310491083,4),(321682215,425205297,14689620,181856,1,'2009-04-04 22:11:14',3310491083,4),(321682216,425204213,14688536,181856,1,'2009-04-04 22:11:13',3310491082,4),(321682217,425204184,14687041,181856,1,'2009-04-04 22:11:13',3310491082,4),(321682218,425202103,14684931,181856,1,'2009-04-04 22:11:13',3310491082,4),(321682219,425197853,14681297,181856,1,'2009-04-04 22:11:13',3310491082,4),(321682220,425193487,14676520,181856,1,'2009-04-04 22:11:12',3310491082,4),(321682221,425188416,14671450,181856,1,'2009-04-04 22:11:12',3310491082,4),(321682222,425187508,14668724,181856,1,'2009-04-04 22:11:11',3310491082,4),(321682223,425185837,14666233,181856,1,'2009-04-04 22:11:11',3310491080,4),(321682224,425181764,14661807,181856,1,'2009-04-04 22:11:10',3310491080,4),(321682225,425178745,14658115,181856,1,'2009-04-04 22:11:10',3310491080,4),(321682226,425176723,14656151,181856,1,'2009-04-04 22:11:10',3310491037,4),(321682227,425174818,14655711,181856,1,'2009-04-04 22:11:09',3310491037,4),(321682228,425173411,14654979,181856,1,'2009-04-04 22:11:09',3310491037,4),(321682229,425172034,14655037,181856,1,'2009-04-04 22:11:08',3310491037,4),(321682230,425171184,14653894,181856,1,'2009-04-04 22:11:08',3310491037,4),(321682231,425169748,14651286,181856,1,'2009-04-04 22:11:07',3310491037,4),(321682232,425167989,14649791,181856,1,'2009-04-04 22:11:07',3310491037,4),(321682233,425166641,14649117,181856,1,'2009-04-04 22:11:06',3310491037,4),(321682234,425164590,14646480,181856,1,'2009-04-04 22:11:06',3310491037,4),(321682235,425163505,14644545,181856,1,'2009-04-04 22:11:05',3310491037,4),(321682236,425163300,14643197,181856,1,'2009-04-04 22:11:05',3310491037,4),(321682237,425164502,14643051,181856,1,'2009-04-04 22:11:04',3310491037,4),(321682640,425312528,15064852,181856,1,'2009-04-04 22:25:05',3310491480,7),(321683315,425458640,15081609,621592,1,'2008-12-26 01:49:44',3310502412,1),(321683317,425457736,15081724,621592,1,'2008-12-26 01:49:45',3310502412,1),(321683319,425456785,15081585,621592,1,'2008-12-26 01:49:45',3310502412,1),(321683321,425456089,15081446,621592,1,'2008-12-26 01:49:45',3310502412,1),(321683323,425454860,15080751,621592,1,'2008-12-26 01:49:45',3310502412,1),(321683326,425453747,15079893,621592,1,'2008-12-26 01:49:46',3310502412,1),(321683328,425452959,15078942,621592,1,'2008-12-26 01:49:46',3310502412,1),(321683330,425452541,15078107,621592,1,'2008-12-26 01:49:46',3310502412,1),(321683332,425451823,15077458,621592,1,'2008-12-26 01:49:46',3310502409,1),(321683334,425451034,15076716,621592,1,'2008-12-26 01:49:47',3310502409,1),(321683336,425450107,15075904,621592,1,'2008-12-26 01:49:47',3310502409,1),(321683338,425449434,15075000,621592,1,'2008-12-26 01:49:47',3310502409,1),(321683341,425447579,15073608,621592,1,'2008-12-26 01:49:47',3310502409,1),(321683343,425447393,15072959,621592,1,'2008-12-26 01:49:48',3310502409,1),(321683345,425447533,15071289,621592,1,'2008-12-26 01:49:48',3310502409,1),(321683347,425448020,15069110,621592,1,'2008-12-26 01:49:48',3310502409,1),(321683349,425448507,15067255,621592,1,'2008-12-26 01:49:48',3310502409,1),(321683351,425448738,15065121,621592,1,'2008-12-26 01:49:48',3310502409,1),(321683353,425448994,15063823,621592,1,'2008-12-26 01:49:48',3310502409,1),(321683355,425449272,15062060,621592,1,'2008-12-26 01:49:49',3310502409,1),(321683357,425449643,15060576,621592,1,'2008-12-26 01:49:49',3310502409,1),(321683358,425449434,15059463,621592,1,'2008-12-26 01:49:49',3310502409,1),(321683359,425448947,15057515,621592,1,'2008-12-26 01:49:49',3310502409,1),(321683360,425448483,15055312,621592,1,'2008-12-26 01:49:49',3310502409,1),(321683361,425447904,15052808,621592,1,'2008-12-26 01:49:50',3310502409,1),(321683362,425447533,15050976,621592,1,'2008-12-26 01:49:50',3310502403,1),(321683363,425447138,15048819,621592,1,'2008-12-26 01:49:50',3310502403,1),(321683364,425446767,15046918,621592,1,'2008-12-26 01:49:50',3310502403,1),(321683365,425446559,15047011,621592,1,'2008-12-26 01:49:51',3310502403,1),(321683366,425446489,15048309,621592,1,'2008-12-26 01:49:51',3310502403,1),(321683367,425446860,15050164,621592,1,'2008-12-26 01:49:51',3310502403,1),(321683368,425446837,15051672,621592,1,'2008-12-26 01:49:51',3310502409,1),(321683369,425446605,15052599,621592,1,'2008-12-26 01:49:51',3310502409,1),(321683370,425445886,15053643,621592,1,'2008-12-26 01:49:52',3310502409,1),(321683371,425445191,15054733,621592,1,'2008-12-26 01:49:52',3310502409,1),(321683372,425444773,15055869,621592,1,'2008-12-26 01:49:52',3310502409,1),(321683373,425444240,15057283,621592,1,'2008-12-26 01:49:52',3310502409,1),(321683374,425443985,15057631,621592,1,'2008-12-26 01:49:53',3310502409,1),(321683375,425443614,15057399,621592,1,'2008-12-26 01:49:53',3310502409,1),(321683376,425443359,15056704,621592,1,'2008-12-26 01:49:53',3310502409,1),(321683377,425442709,15053388,621592,1,'2008-12-26 01:49:53',3310502409,1),(321683378,425442431,15051857,621592,1,'2008-12-26 01:49:53',3310502409,1),(321683379,425442176,15051880,621592,1,'2008-12-26 01:49:54',3310502409,1),(321683380,425442176,15053318,621592,1,'2008-12-26 01:49:54',3310502409,1),(321683381,425442222,15054408,621592,1,'2008-12-26 01:49:54',3310502409,1),(321683382,425442083,15055336,621592,1,'2008-12-26 01:49:54',3310502409,1),(321683383,425441619,15056008,621592,1,'2008-12-26 01:49:54',3310502409,1),(321683384,425441295,15055938,621592,1,'2008-12-26 01:49:54',3310502409,1),(321683385,425441017,15055080,621592,1,'2008-12-26 01:49:55',3310502409,1),(321683386,425440993,15052808,621592,1,'2008-12-26 01:49:55',3310502409,1),(321683387,425440831,15051625,621592,1,'2008-12-26 01:49:55',3310502409,1),(321683388,425440506,15051602,621592,1,'2008-12-26 01:49:55',3310502409,1),(321683389,425440159,15052414,621592,1,'2008-12-26 01:49:56',3310502409,1),(321683390,425439532,15054107,621592,1,'2008-12-26 01:49:56',3310502409,1),(321683391,425438698,15055915,621592,1,'2008-12-26 01:49:56',3310502409,1),(321683392,425438234,15056936,621592,1,'2008-12-26 01:49:56',3310502409,1),(321683393,425437701,15056982,621592,1,'2008-12-26 01:49:56',3310502409,1),(321683394,425437144,15056773,621592,1,'2008-12-26 01:49:57',3310502409,1),(321683395,425437144,15056031,621592,1,'2008-12-26 01:49:57',3310502409,1),(321683396,425437214,15055057,621592,1,'2008-12-26 01:49:57',3310502409,1),(321683397,425437121,15054246,621592,1,'2008-12-26 01:49:57',3310502409,1),(321683398,425436773,15054269,621592,1,'2008-12-26 01:49:57',3310502409,1),(321683399,425436448,15054918,621592,1,'2008-12-26 01:49:57',3310502409,1),(321683400,425436100,15055521,621592,1,'2008-12-26 01:49:58',3310502409,1),(321683401,425435614,15055938,621592,1,'2008-12-26 01:49:58',3310502409,1),(321683402,425435196,15055637,621592,1,'2008-12-26 01:49:58',3310502409,1),(321683403,425435127,15054408,621592,1,'2008-12-26 01:49:58',3310502409,1),(321683405,425435103,15053457,621592,1,'2008-12-26 01:49:58',3310502409,1),(321683407,425435011,15052622,621592,1,'2008-12-26 01:49:59',3310502409,1),(321683408,425434524,15051301,621592,1,'2008-12-26 01:49:59',3310502403,1),(321683409,425434222,15050721,621592,1,'2008-12-26 01:49:59',3310502403,1),(321683410,425433874,15050744,621592,1,'2008-12-26 01:49:59',3310502403,1),(321683411,425433712,15051486,621592,1,'2008-12-26 01:49:59',3310502403,1),(321683412,425433457,15052205,621592,1,'2008-12-26 01:50:00',3310502409,1),(321683413,425433202,15052275,621592,1,'2008-12-26 01:50:00',3310502409,1),(321683414,425432808,15051904,621592,1,'2008-12-26 01:50:00',3310502409,1),(321683415,425432576,15050419,621592,1,'2008-12-26 01:50:00',3310502403,1),(321683416,425432158,15049051,621592,1,'2008-12-26 01:50:00',3310502403,1),(321683417,425431787,15048263,621592,1,'2008-12-26 01:50:01',3310502403,1),(321683418,425431300,15048031,621592,1,'2008-12-26 01:50:01',3310502403,1),(321683419,425431115,15049121,621592,1,'2008-12-26 01:50:01',3310502403,1),(321683420,425430929,15050002,621592,1,'2008-12-26 01:50:01',3310502403,1),(321683421,425430048,15051254,621592,1,'2008-12-26 01:50:01',3310502403,1),(321683422,425429700,15052089,621592,1,'2008-12-26 01:50:02',3310502409,1),(321683423,425429306,15052808,621592,1,'2008-12-26 01:50:02',3310502409,1),(321683424,425428634,15053736,621592,1,'2008-12-26 01:50:02',3310502409,1),(321683425,425428286,15054153,621592,1,'2008-12-26 01:50:02',3310502409,1),(321683426,425427729,15054825,621592,1,'2008-12-26 01:50:02',3310502409,1),(321683427,425427312,15054825,621592,1,'2008-12-26 01:50:03',3310502409,1),(321683428,425427196,15054014,621592,1,'2008-12-26 01:50:03',3310502409,1),(321683429,425427196,15053434,621592,1,'2008-12-26 01:50:03',3310502409,1),(321683430,425426825,15053364,621592,1,'2008-12-26 01:50:03',3310502409,1),(321683431,425426431,15053851,621592,1,'2008-12-26 01:50:04',3310502409,1),(321683432,425425990,15053712,621592,1,'2008-12-26 01:50:04',3310502409,1),(321683434,425425387,15053133,621592,1,'2008-12-26 01:50:04',3310502409,1),(321683436,425425086,15052251,621592,1,'2008-12-26 01:50:04',3310502409,1),(321683438,425424970,15051718,621592,1,'2008-12-26 01:50:04',3310502409,1),(321683440,425424529,15051764,621592,1,'2008-12-26 01:50:05',3310502408,1),(321683441,425424436,15052762,621592,1,'2008-12-26 01:50:05',3310502408,1),(321683443,425424158,15052854,621592,1,'2008-12-26 01:50:05',3310502408,1),(321683445,425423555,15052344,621592,1,'2008-12-26 01:50:05',3310502408,1),(321683447,425423370,15051277,621592,1,'2008-12-26 01:50:06',3310502402,1),(321683448,425423393,15050605,621592,1,'2008-12-26 01:50:06',3310502402,1),(321683449,425422976,15050396,621592,1,'2008-12-26 01:50:06',3310502402,1),(321683450,425422442,15050651,621592,1,'2008-12-26 01:50:06',3310502402,1),(321683451,425421747,15050976,621592,1,'2008-12-26 01:50:06',3310502402,1),(321683452,425421213,15050744,621592,1,'2008-12-26 01:50:07',3310502402,1),(321683453,425421120,15050025,621592,1,'2008-12-26 01:50:07',3310502402,1),(321683454,425421399,15049353,621592,1,'2008-12-26 01:50:07',3310502402,1),(321683455,425421886,15048727,621592,1,'2008-12-26 01:50:07',3310502402,1),(321683456,425421515,15047892,621592,1,'2008-12-26 01:50:07',3310502402,1),(321683457,425421097,15047567,621592,1,'2008-12-26 01:50:08',3310502402,1),(321683458,425420494,15047359,621592,1,'2008-12-26 01:50:08',3310502402,1),(321683459,425419706,15047753,621592,1,'2008-12-26 01:50:08',3310502402,1),(321683460,425419080,15047753,621592,1,'2008-12-26 01:50:08',3310502402,1),(321683461,425418523,15047080,621592,1,'2008-12-26 01:50:09',3310502402,1),(321683462,425418384,15046176,621592,1,'2008-12-26 01:50:09',3310502402,1),(321683463,425418616,15045202,621592,1,'2008-12-26 01:50:09',3310502402,1),(321683464,425418732,15044460,621592,1,'2008-12-26 01:50:09',3310502402,1),(321683465,425418547,15043602,621592,1,'2008-12-26 01:50:09',3310502402,1),(321683466,425417735,15042698,621592,1,'2008-12-26 01:50:10',3310502402,1),(321683467,425416970,15041747,621592,1,'2008-12-26 01:50:10',3310502402,1),(321683468,425416181,15041608,621592,1,'2008-12-26 01:50:10',3310502402,1),(321683469,425415370,15042280,621592,1,'2008-12-26 01:50:10',3310502402,1),(321683470,425414071,15043092,621592,1,'2008-12-26 01:50:11',3310502402,1),(321683471,425413375,15042860,621592,1,'2008-12-26 01:50:11',3310502402,1),(321683472,425412541,15042234,621592,1,'2008-12-26 01:50:11',3310502402,1),(321683473,425411451,15041631,621592,1,'2008-12-26 01:50:11',3310502402,1),(321683474,425410338,15041422,621592,1,'2008-12-26 01:50:11',3310502402,1),(321683475,425409410,15040587,621592,1,'2008-12-26 01:50:12',3310502402,1),(321683476,425408367,15038732,621592,1,'2008-12-26 01:50:12',3310502402,1),(321683477,425407230,15037202,621592,1,'2008-12-26 01:50:12',3310502402,1),(321683478,425406210,15035787,621592,1,'2008-12-26 01:50:12',3310502402,1),(321683479,425405259,15034767,621592,1,'2008-12-26 01:50:12',3310502402,1),(321683480,425404100,15034048,621592,1,'2008-12-26 01:50:13',3310502402,1),(321683481,425403126,15033306,621592,1,'2008-12-26 01:50:13',3310502402,1),(321683482,425401990,15033468,621592,1,'2008-12-26 01:50:13',3310502402,1),(321683483,425400830,15033747,621592,1,'2008-12-26 01:50:13',3310502402,1),(321683484,425399740,15033260,621592,1,'2008-12-26 01:50:14',3310502402,1),(321683485,425398650,15033260,621592,1,'2008-12-26 01:50:14',3310502402,1),(321683486,425397445,15033723,621592,1,'2008-12-26 01:50:14',3310502402,1),(321683487,425396100,15033909,621592,1,'2008-12-26 01:50:15',3310491479,1),(321683488,425394824,15034071,621592,1,'2008-12-26 01:50:15',3310491479,1),(321683489,425393503,15033839,621592,1,'2008-12-26 01:50:15',3310491479,1),(321683490,425391949,15032796,621592,1,'2008-12-26 01:50:15',3310491479,1),(321683491,425391462,15032123,621592,1,'2008-12-26 01:50:15',3310491479,1),(321683492,425390673,15032054,621592,1,'2008-12-26 01:50:16',3310491479,1),(321683493,425389630,15033121,621592,1,'2008-12-26 01:50:16',3310491479,1),(321683494,425388262,15034373,621592,1,'2008-12-26 01:50:16',3310491479,1),(321683495,425387427,15035416,621592,1,'2008-12-26 01:50:16',3310491479,1),(321683496,425386407,15035579,621592,1,'2008-12-26 01:50:16',3310491479,1),(321683497,425384482,15036460,621592,1,'2008-12-26 01:50:17',3310491479,1),(321683498,425383485,15036668,621592,1,'2008-12-26 01:50:17',3310491479,1),(321683499,425381978,15037225,621592,1,'2008-12-26 01:50:17',3310491479,1),(321683500,425381027,15036854,621592,1,'2008-12-26 01:50:17',3310491479,1),(321683501,425380030,15036367,621592,1,'2008-12-26 01:50:18',3310491479,1),(321683502,425379218,15034906,621592,1,'2008-12-26 01:50:18',3310491479,1),(321683503,425378708,15033445,621592,1,'2008-12-26 01:50:18',3310491479,1),(321683504,425377873,15032170,621592,1,'2008-12-26 01:50:19',3310491479,1),(321683505,425377224,15031126,621592,1,'2008-12-26 01:50:19',3310491479,1),(321683506,425377386,15029410,621592,1,'2008-12-26 01:50:19',3310491479,1),(321683507,425378105,15026744,621592,1,'2008-12-26 01:50:19',3310491479,1),(321683508,425378476,15024494,621592,1,'2008-12-26 01:50:19',3310491479,1),(321683509,425378685,15021086,621592,1,'2008-12-26 01:50:19',3310491479,1),(321683510,425379844,15017491,621592,1,'2008-12-26 01:50:20',3310491479,1),(321683511,425381259,15013503,621592,1,'2008-12-26 01:50:20',3310491479,1),(321683512,425382441,15009630,621592,1,'2008-12-26 01:50:20',3310491479,1),(321683513,425383091,15007868,621592,1,'2008-12-26 01:50:20',3310491479,1),(321683514,425383601,15004807,621592,1,'2008-12-26 01:50:20',3310491479,1),(321683515,425384737,15000424,621592,1,'2008-12-26 01:50:21',3310491479,1),(321683516,425386105,14995439,621592,1,'2008-12-26 01:50:21',3310491477,1),(321683517,425386221,14992726,621592,1,'2008-12-26 01:50:21',3310491477,1),(321683518,425386685,14991172,621592,1,'2008-12-26 01:50:21',3310491477,1),(321683519,425386662,14989572,621592,1,'2008-12-26 01:50:21',3310491477,1),(321683520,425386731,14988227,621592,1,'2008-12-26 01:50:21',3310491477,1),(321683521,425388262,14984053,621592,1,'2008-12-26 01:50:22',3310491477,1),(321683522,425389329,14980273,621592,1,'2008-12-26 01:50:22',3310491477,1),(321683523,425389700,14978975,621592,1,'2008-12-26 01:50:22',3310491477,1),(321683524,425391462,14976748,621592,1,'2008-12-26 01:50:22',3310491477,1),(321683525,425392134,14975543,621592,1,'2008-12-26 01:50:22',3310491477,1),(321683526,425392505,14974082,621592,1,'2008-12-26 01:50:23',3310491477,1),(321683527,425393410,14972853,621592,1,'2008-12-26 01:50:23',3310491477,1),(321683528,425395242,14970882,621592,1,'2008-12-26 01:50:23',3310491477,1),(321683529,425395520,14969560,621592,1,'2008-12-26 01:50:23',3310491477,1),(321683530,425394987,14968192,621592,1,'2008-12-26 01:50:23',3310491477,1),(321683532,425395358,14965432,621592,1,'2008-12-26 01:50:23',3310491477,1),(321683533,425395775,14962116,621592,1,'2008-12-26 01:50:24',3310491477,1),(321683534,425396332,14960609,621592,1,'2008-12-26 01:50:24',3310491477,1),(321683535,425396934,14959125,621592,1,'2008-12-26 01:50:24',3310491477,1),(321683536,425397885,14957989,621592,1,'2008-12-26 01:50:24',3310502400,1),(321683537,425398581,14956644,621592,1,'2008-12-26 01:50:25',3310502400,1),(321683538,425399346,14954557,621592,1,'2008-12-26 01:50:25',3310502400,1),(321683539,425400204,14952678,621592,1,'2008-12-26 01:50:25',3310502400,1),(321683540,425400969,14950522,621592,1,'2008-12-26 01:50:25',3310502400,1),(321683541,425402685,14947043,621592,1,'2008-12-26 01:50:25',3310502400,1),(321683542,425405012,14943620,621592,1,'2008-12-26 01:50:26',3310502400,1),(321683543,425406022,14941793,621592,1,'2008-12-26 01:50:26',3310502400,1),(321683544,425406647,14940110,621592,1,'2008-12-26 01:50:26',3310502058,1),(321683609,425406511,14940740,621592,1,'2008-12-26 01:51:55',3310502058,1),(323129883,425471289,15137913,675187,1,'2008-12-30 15:54:19',3310502414,1),(323129885,425368590,14909604,675187,1,'2008-12-30 15:54:19',3310491134,1),(323130871,425722862,14812695,4161539,1,'2010-03-18 16:04:24',3310502119,5),(323130873,425731228,14712728,4161539,1,'2010-03-18 16:04:24',3310502106,5),(323131766,425725562,14835446,675187,1,'2008-12-30 16:00:59',3310502125,1),(323131768,425725625,14837506,675187,1,'2008-12-30 16:00:59',3310502125,1),(324270172,425044221,15136989,697263,1,'2009-01-01 16:45:34',3310491407,1),(324270173,425048967,15144284,697263,1,'2009-01-01 16:45:35',3310491407,1),(324270174,425056877,15152610,697263,1,'2009-01-01 16:45:35',3310491407,1),(332119070,425565350,15297020,787878,1,'2009-01-15 00:22:38',3310502460,3),(332119071,425563900,15295380,787878,1,'2009-01-15 00:22:38',3310502460,2),(332119072,425562130,15294800,787878,1,'2009-01-15 00:22:38',3310502460,2),(332119073,425561409,15294708,787878,1,'2009-01-15 00:22:38',3310502457,2),(332119074,425559650,15294270,787878,1,'2009-01-15 00:22:38',3310502457,2),(332119075,425556180,15292320,787878,1,'2009-01-15 00:22:38',3310502457,2),(332119076,425554930,15290880,787878,1,'2009-01-15 00:22:38',3310502457,4),(332119286,425561180,15311580,787878,1,'2009-01-15 00:12:00',3310502457,1),(332119287,425562220,15308300,787878,1,'2009-01-15 00:12:01',3310502460,1),(332119288,425562530,15304730,787878,1,'2009-01-15 00:12:01',3310502460,1),(332119289,425563900,15300280,787878,1,'2009-01-15 00:12:01',3310502460,1),(332119290,425563950,15299370,787878,1,'2009-01-15 00:12:01',3310502460,1),(332119414,425557616,15305179,787878,1,'2009-01-15 00:14:32',3310502457,2),(332119415,425557047,15303463,787878,1,'2009-01-15 00:14:32',3310502457,2),(332119416,425556098,15300373,787878,1,'2009-01-15 00:14:32',3310502457,2),(332119417,425555466,15297970,787878,1,'2009-01-15 00:14:32',3310502457,2),(332119418,425555150,15294880,787878,1,'2009-01-15 00:14:32',3310502457,2),(332121136,425516568,15264062,725665,1,'2009-03-02 22:29:56',3310502450,10),(332121137,425518970,15265007,725665,1,'2009-03-02 22:29:56',3310502450,11),(332122179,425553935,15288782,787878,1,'2009-01-15 00:22:38',3310502457,1),(332122180,425553050,15287350,787878,1,'2009-01-15 00:22:38',3310502457,1),(332122181,425552530,15287100,787878,1,'2009-01-15 00:22:38',3310502457,1),(332122182,425550920,15284900,787878,1,'2009-01-15 00:22:38',3310502457,1),(332122183,425547150,15282000,787878,1,'2009-01-15 00:22:38',3310502457,1),(332122184,425541830,15279920,787878,1,'2009-01-15 00:22:38',3310502457,1),(332122185,425536000,15274450,787878,1,'2009-01-15 00:22:38',3310502457,1),(332122186,425532800,15270670,787878,1,'2009-01-15 00:22:38',3310502450,1),(332122187,425530050,15268400,787878,1,'2009-01-15 00:22:38',3310502450,1),(332122188,425528470,15267430,787878,1,'2009-01-15 00:22:38',3310502450,1),(332122189,425521100,15265820,787878,1,'2009-01-15 00:22:38',3310502450,1),(332125718,425427104,15149834,787878,1,'2009-01-15 00:31:07',3310502411,2),(332126612,425429581,15154224,787878,1,'2009-01-15 00:31:30',3310502411,2),(332126613,425429012,15153023,787878,1,'2009-01-15 00:31:07',3310502411,1),(332126614,425428506,15152079,787878,1,'2009-01-15 00:31:07',3310502411,1),(332126615,425428000,15151134,787878,1,'2009-01-15 00:31:07',3310502411,1),(332126684,425432300,15158602,787878,1,'2009-01-15 00:31:30',3310502411,1),(332126685,425431720,15158020,787878,1,'2009-01-15 00:31:30',3310502411,1),(332126688,425430656,15156198,787878,1,'2009-01-15 00:31:30',3310502411,1),(332126689,425430023,15154997,787878,1,'2009-01-15 00:31:30',3310502411,1),(335320657,425512717,15266972,725665,1,'2009-03-02 22:19:38',3310502450,4),(337729044,425052452,15269986,840745,1,'2009-01-26 20:00:24',3310491431,3),(337733739,425052705,15277883,840745,1,'2009-01-26 19:28:30',3310491437,1),(337739581,425084153,15340807,305941,1,'2009-02-09 21:19:42',3310491450,9),(337742674,425051483,15260942,840745,1,'2009-01-26 20:04:34',3310491431,3),(337743301,425063835,15277017,981792,1,'2009-04-27 01:30:07',3310491437,3),(337745019,425057071,15318395,840745,1,'2009-01-26 19:37:27',3310491437,1),(337767559,425084147,15340729,305941,1,'2009-02-09 21:17:59',3310491450,7),(337775423,425052705,15260888,840745,1,'2009-01-26 20:04:34',3310491431,1),(337775425,425054720,15260870,840745,1,'2009-01-26 20:04:34',3310491431,1),(337775428,425059349,15269986,840745,1,'2009-01-26 20:04:34',3310491431,1),(337779059,425051503,15242692,840745,1,'2009-01-26 20:08:19',3310491431,1),(337781593,425092052,15340147,104780,1,'2009-02-04 00:33:41',3310491450,3),(337782221,425096920,15338630,104780,1,'2009-02-04 00:33:41',3310491451,2),(337782224,425093020,15339970,104780,1,'2009-02-04 00:33:41',3310491450,2),(337833707,425445905,15121785,840745,1,'2009-01-26 21:16:49',3310502411,2),(337833711,425444577,15120669,840745,1,'2009-01-26 21:16:49',3310502411,2),(337833715,425442996,15119381,840745,1,'2009-01-26 21:18:10',3310502411,5),(337840780,425446420,15137720,840745,1,'2009-01-26 21:17:32',3310502411,1),(337840784,425446470,15137350,840745,1,'2009-01-26 21:17:32',3310502411,1),(337840789,425445850,15135870,840745,1,'2009-01-26 21:17:32',3310502411,1),(337840791,425445970,15135770,840745,1,'2009-01-26 21:17:33',3310502411,1),(337840797,425444600,15133100,840745,1,'2009-01-26 21:17:33',3310502411,1),(337840800,425443881,15130282,840745,1,'2009-01-26 21:17:33',3310502411,1),(337840804,425443502,15127106,840745,1,'2009-01-26 21:17:34',3310502411,1),(337840809,425443439,15126076,840745,1,'2009-01-26 21:17:34',3310502411,1),(337840812,425443123,15124875,840745,1,'2009-01-26 21:17:34',3310502411,1),(337840815,425443186,15123072,840745,1,'2009-01-26 21:17:34',3310502411,1),(337840821,425442770,15120300,840745,1,'2009-01-26 21:17:35',3310502411,1),(337840888,425441850,15115670,844916,1,'2009-01-27 20:17:20',3310502411,4),(337840981,425440820,15114280,844916,1,'2009-01-27 20:17:20',3310502411,2),(337840986,425439030,15113180,844916,1,'2009-01-27 20:17:20',3310502411,2),(337840989,425437730,15112280,844916,1,'2009-01-27 20:17:20',3310502411,3),(337841272,425437150,15111430,840745,1,'2009-01-26 21:18:19',3310502411,1),(337841280,425434830,15109250,844916,1,'2009-01-27 20:17:54',3310502411,3),(337841383,425433600,15106300,844916,1,'2009-01-27 20:17:54',3310502409,2),(337841643,425432150,15103770,840745,1,'2009-01-26 21:18:52',3310502409,1),(337841646,425431520,15102370,840745,1,'2009-01-26 21:18:52',3310502409,1),(337841651,425431270,15100780,840745,1,'2009-01-26 21:18:52',3310502409,1),(337841655,425430200,15098030,840745,1,'2009-01-26 21:18:53',3310502409,1),(337841658,425429300,15096580,840745,1,'2009-01-26 21:18:53',3310502409,1),(337841661,425429330,15096300,840745,1,'2009-01-26 21:18:53',3310502409,1),(338418931,425463501,15090135,844916,1,'2009-01-27 19:52:23',3310502412,3),(338418932,425463763,15090883,844916,1,'2009-01-27 19:52:23',3310502412,5),(338420420,425462932,15093826,104780,1,'2009-02-04 00:28:27',3310502412,4),(338420421,425461414,15107473,104780,1,'2009-02-04 00:28:27',3310502414,3),(338420422,425461161,15108074,104780,1,'2009-02-04 00:28:27',3310502414,3),(338420423,425460972,15108159,104780,1,'2009-02-04 00:28:27',3310502414,3),(338420424,425460213,15107988,104780,1,'2009-02-04 00:28:27',3310502414,3),(338420425,425459897,15106958,104780,1,'2009-02-04 00:28:27',3310502414,3),(338420426,425460655,15094255,104780,1,'2009-02-04 00:28:27',3310502412,3),(338420688,425463680,15092330,844916,1,'2009-01-27 19:52:14',3310502412,2),(338420689,425463248,15095542,844916,1,'2009-01-27 19:52:14',3310502412,2),(338420690,425462995,15097516,844916,1,'2009-01-27 19:52:14',3310502412,2),(338420691,425462869,15099319,844916,1,'2009-01-27 19:52:14',3310502412,2),(338420692,425462489,15102666,844916,1,'2009-01-27 19:52:14',3310502412,2),(338420693,425462080,15105800,844916,1,'2009-01-27 19:52:15',3310502412,2),(338420694,425461800,15107250,844916,1,'2009-01-27 19:52:15',3310502414,2),(338420695,425461370,15108700,844916,1,'2009-01-27 19:52:15',3310502414,2),(338420696,425461030,15109070,844916,1,'2009-01-27 19:52:15',3310502414,2),(338420697,425460800,15108950,844916,1,'2009-01-27 19:52:15',3310502414,2),(338420698,425460530,15108580,844916,1,'2009-01-27 19:52:15',3310502414,2),(338420699,425460370,15107470,844916,1,'2009-01-27 19:52:15',3310502414,2),(338420700,425460700,15106820,844916,1,'2009-01-27 19:52:15',3310502414,2),(338420701,425461300,15106920,844916,1,'2009-01-27 19:52:15',3310502414,2),(338420702,425461020,15106450,844916,1,'2009-01-27 19:46:28',3310502414,1),(338422550,425469400,15093800,844916,1,'2009-01-27 19:58:51',3310502412,2),(338422551,425470300,15094430,844916,1,'2009-01-27 20:16:07',3310502412,3),(338425045,425449729,15130615,844916,1,'2009-01-27 20:10:19',3310502411,3),(338425046,425451970,15129950,844916,1,'2009-01-27 20:11:54',3310502411,6),(338425186,425450488,15133705,844916,1,'2009-01-27 20:10:20',3310502411,5),(338425409,425451183,15133190,844916,1,'2009-01-27 20:08:49',3310502411,2),(338425484,425449600,15127830,844916,1,'2009-01-27 20:11:15',3310502411,5),(338425485,425449729,15124521,844916,1,'2009-01-27 20:11:15',3310502411,2),(338425486,425450045,15122032,844916,1,'2009-01-27 20:11:15',3310502411,2),(338425556,425449600,15129150,844916,1,'2009-01-27 20:10:19',3310502411,2),(338425558,425450108,15131387,844916,1,'2009-01-27 20:10:19',3310502411,2),(338425560,425450120,15132130,844916,1,'2009-01-27 20:10:19',3310502411,2),(338425561,425450298,15132932,844916,1,'2009-01-27 20:10:19',3310502411,2),(338425562,425450570,15134470,844916,1,'2009-01-27 20:10:20',3310502411,2),(338425567,425450150,15127780,844916,1,'2009-01-27 20:10:15',3310502411,1),(338425636,425458870,15114850,844916,1,'2009-01-27 20:16:08',3310502414,2),(338425637,425456980,15116950,844916,1,'2009-01-27 20:11:39',3310502414,1),(338425638,425456480,15118700,844916,1,'2009-01-27 20:11:39',3310502414,1),(338425639,425456570,15119850,844916,1,'2009-01-27 20:11:39',3310502414,1),(338425640,425456230,15120320,844916,1,'2009-01-27 20:11:39',3310502414,1),(338425642,425455450,15124980,844916,1,'2009-01-27 20:11:39',3310502414,1),(338425643,425455600,15127380,844916,1,'2009-01-27 20:11:39',3310502414,1),(338425644,425456170,15129770,844916,1,'2009-01-27 20:11:39',3310502414,1),(338425645,425456100,15130380,844916,1,'2009-01-27 20:11:39',3310502414,1),(338425647,425453920,15130320,844916,1,'2009-01-27 20:11:39',3310502414,1),(338425648,425453300,15129980,844916,1,'2009-01-27 20:11:54',3310502414,2),(338425715,425452830,15129330,844916,1,'2009-01-27 20:11:54',3310502414,1),(338425717,425452150,15129500,844916,1,'2009-01-27 20:11:54',3310502414,1),(338426328,425470533,15095081,844916,1,'2009-01-27 20:16:07',3310502412,1),(338426330,425470530,15095780,844916,1,'2009-01-27 20:16:07',3310502412,1),(338426331,425469070,15098370,844916,1,'2009-01-27 20:16:07',3310502412,1),(338426332,425468330,15100420,844916,1,'2009-01-27 20:16:07',3310502412,1),(338426338,425467970,15102370,844916,1,'2009-01-27 20:16:07',3310502412,1),(338426339,425467520,15102820,844916,1,'2009-01-27 20:16:08',3310502412,1),(338426340,425466180,15103400,844916,1,'2009-01-27 20:16:08',3310502412,1),(338426341,425465270,15104230,844916,1,'2009-01-27 20:16:08',3310502412,1),(338426342,425464670,15105180,844916,1,'2009-01-27 20:16:08',3310502412,1),(338426343,425463930,15107380,844916,1,'2009-01-27 20:16:08',3310502414,1),(338426344,425464020,15108480,844916,1,'2009-01-27 20:16:08',3310502414,1),(338426345,425463150,15109820,844916,1,'2009-01-27 20:16:08',3310502414,1),(338426346,425461880,15111480,844916,1,'2009-01-27 20:16:08',3310502414,1),(338426347,425460500,15112520,844916,1,'2009-01-27 20:16:08',3310502414,1),(339066904,425471266,15632572,854025,1,'2009-01-30 08:42:31',3310502564,1),(339066905,425279007,16693439,854025,1,'2009-01-30 08:42:48',3310493167,1),(340304066,425073120,15380097,104780,1,'2009-02-04 00:39:24',3310491450,1),(340304067,425077359,15380268,104780,1,'2009-02-04 00:39:24',3310491450,1),(340304068,425077359,15383358,104780,1,'2009-02-04 00:39:24',3310491536,1),(340304069,425073563,15383358,104780,1,'2009-02-04 00:39:24',3310491536,1),(340304325,425075841,15356922,104780,1,'2009-02-04 00:41:33',3310491450,1),(340304326,425075967,15362931,104780,1,'2009-02-04 00:41:33',3310491450,1),(340304327,425076473,15367050,104780,1,'2009-02-04 00:41:33',3310491450,1),(340304328,425072677,15368252,104780,1,'2009-02-04 00:41:34',3310491450,1),(340304329,425070779,15356236,104780,1,'2009-02-04 00:41:34',3310491450,1),(343733031,425058567,15210324,305941,1,'2009-02-09 21:34:27',3310491429,1),(349145208,424472720,14653330,27626,1,'2009-04-01 15:33:06',3310490076,5),(349145210,424472070,14642500,27626,1,'2009-04-01 15:33:06',3310490076,5),(349145211,424471000,14636820,27626,1,'2009-04-01 15:33:06',3310490076,5),(349145213,424469270,14631530,27626,1,'2009-04-01 15:33:06',3310490076,5),(349145214,424466300,14625170,27626,1,'2009-04-01 15:33:06',3310490076,5),(349145215,424463380,14620670,27626,1,'2009-04-01 15:33:06',3310490076,5),(349145217,424459830,14613980,27626,1,'2009-04-01 15:33:06',3310490073,5),(349145218,424459270,14612200,27626,1,'2009-04-01 15:33:07',3310490073,5),(349145220,424459000,14610320,27626,1,'2009-04-01 15:33:07',3310490067,5),(349145221,424460130,14602730,27626,1,'2009-04-01 15:33:07',3310490067,5),(349145223,424459920,14598770,27626,1,'2009-04-01 15:33:07',3310490067,5),(349145224,424460230,14597380,27626,1,'2009-04-01 15:33:07',3310490067,5),(349145226,424463780,14590920,27626,1,'2009-04-01 15:33:07',3310490070,5),(349145227,424466170,14590030,27626,1,'2009-04-01 15:33:07',3310490070,5),(349145229,424469070,14590330,27626,1,'2009-04-01 15:33:07',3310490070,5),(349145230,424473680,14593270,27626,1,'2009-04-01 15:33:07',3310490070,5),(349145232,424475520,14593850,27626,1,'2009-04-01 15:33:07',3310490070,5),(349145233,424485500,14592430,27626,1,'2009-04-01 15:33:07',3310490070,5),(349145235,424487950,14590920,27626,1,'2009-04-01 15:33:07',3310490070,5),(349145236,424493630,14585950,27626,1,'2009-04-01 15:33:07',3310490071,5),(349145237,424498480,14583450,27626,1,'2009-04-01 15:33:07',3310490071,5),(349145239,424501070,14580220,27626,1,'2009-04-01 15:33:07',3310490071,5),(349145240,424504400,14572870,27626,1,'2009-04-01 15:33:07',3310490071,5),(349145242,424506820,14558780,27626,1,'2009-04-01 15:33:07',3310490071,5),(349145243,424508120,14555030,27626,1,'2009-04-01 15:33:07',3310490069,5),(349145245,424509520,14547480,27626,1,'2009-04-01 15:33:07',3310490069,5),(349145246,424513170,14535200,27626,1,'2009-04-01 15:33:07',3310490069,5),(349145248,424513350,14530570,27626,1,'2009-04-01 15:33:07',3310490069,5),(349145249,424516320,14521480,27626,1,'2009-04-01 15:33:07',3310490069,5),(349145250,424516450,14520130,27626,1,'2009-04-01 15:33:07',3310490069,5),(349145281,424552030,14511400,27626,1,'2009-04-01 15:33:08',3310490753,5),(349145282,424555730,14511780,27626,1,'2009-04-01 15:33:08',3310490753,5),(349145283,424558700,14515520,27626,1,'2009-04-01 15:33:08',3310490753,5),(349145284,424559900,14513600,27626,1,'2009-04-01 15:33:08',3310490753,5),(349145285,424559330,14509670,27626,1,'2009-04-01 15:33:08',3310490753,5),(349146313,424579650,14510630,609884,1,'2009-02-22 17:56:37',3310490756,1),(349146314,424580300,14516250,609884,1,'2009-02-22 17:56:37',3310490756,1),(349146315,424581270,14514850,609884,1,'2009-02-22 17:56:37',3310490756,1),(349146316,424581780,14508830,609884,1,'2009-02-22 17:56:37',3310490756,1),(354962410,425511832,15263367,725665,1,'2009-03-02 22:21:42',3310502450,6),(354962603,425514551,15264139,725665,1,'2009-03-02 22:19:05',3310502450,3),(354962604,425514424,15264826,725665,1,'2009-03-02 22:21:27',3310502450,4),(354962605,425513981,15265169,725665,1,'2009-03-02 22:22:38',3310502450,5),(354962608,425513539,15265169,725665,1,'2009-03-02 22:19:05',3310502450,2),(354962610,425513096,15264998,725665,1,'2009-03-02 22:22:09',3310502450,4),(354962612,425512843,15264311,725665,1,'2009-03-02 22:21:42',3310502450,4),(354962614,425512843,15263539,725665,1,'2009-03-02 22:19:05',3310502450,2),(354962618,425513286,15262938,725665,1,'2009-03-02 22:21:33',3310502450,4),(354962620,425513918,15263024,725665,1,'2009-03-02 22:19:05',3310502450,2),(354962622,425514424,15263367,725665,1,'2009-03-02 22:21:18',3310502450,5),(354966294,425535238,15284029,725665,1,'2009-03-02 22:29:54',3310502457,3),(354966710,425538387,15286885,725665,1,'2009-03-02 22:34:24',3310502457,4),(354966711,425539336,15287657,725665,1,'2009-03-02 22:27:38',3310502457,2),(354966915,425537755,15286284,725665,1,'2009-03-02 22:34:09',3310502457,15),(354966917,425537502,15286799,725665,1,'2009-03-02 22:34:24',3310502457,10),(354966919,425536996,15286799,725665,1,'2009-03-02 22:34:08',3310502457,10),(354966921,425536554,15286370,725665,1,'2009-03-02 22:34:08',3310502457,10),(354966923,425536427,15285683,725665,1,'2009-03-02 22:34:08',3310502457,11),(354966925,425536680,15285168,725665,1,'2009-03-02 22:34:08',3310502457,8),(354966927,425537123,15284825,725665,1,'2009-03-02 22:34:08',3310502457,11),(354966929,425537565,15285082,725665,1,'2009-03-02 22:34:08',3310502457,8),(354966931,425537882,15285597,725665,1,'2009-03-02 22:34:23',3310502457,10),(354968366,425535669,15287571,725665,1,'2009-03-02 22:31:50',3310502457,1),(364104064,425518067,14880767,837556,1,'2009-03-20 18:52:04',3310502072,1),(366060792,426315000,14811600,864892,1,'2009-03-28 14:33:30',3310503075,2),(366060794,426317300,14813300,864892,1,'2009-03-28 14:33:30',3310503075,2),(366060795,426320200,14812900,864892,1,'2009-03-28 14:33:30',3310503075,2),(366060796,426322500,14810600,864892,1,'2009-03-28 14:33:30',3310503075,2),(366060797,426336300,14824100,864892,1,'2009-03-28 14:33:31',3310503078,2),(366060798,426340100,14826000,864892,1,'2009-03-28 14:33:31',3310503078,2),(366060800,426343200,14826700,864892,1,'2009-03-28 14:33:31',3310503078,2),(366060801,426345400,14829000,864892,1,'2009-03-28 14:33:31',3310503078,2),(366060803,426351900,14838500,864892,1,'2009-03-28 14:33:31',3310503084,2),(366060804,426355500,14841700,864892,1,'2009-03-28 14:33:31',3310503084,2),(366060805,426358200,14851400,864892,1,'2009-03-28 14:33:31',3310503084,2),(366060807,426356500,14863000,864892,1,'2009-03-28 14:33:31',3310503084,2),(366060808,426357400,14864100,864892,1,'2009-03-28 14:33:31',3310503084,2),(366060810,426358500,14864400,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060811,426359700,14867200,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060812,426361600,14868300,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060813,426362800,14868200,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060815,426363100,14865800,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060816,426370900,14864900,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060818,426374100,14865200,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060819,426376700,14864700,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060820,426377600,14865300,864892,1,'2009-03-28 14:33:32',3310503085,3),(366060821,426380400,14863700,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060822,426383100,14861900,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060823,426385200,14854800,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060824,426385100,14853500,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060825,426386400,14851400,864892,1,'2009-03-28 14:33:31',3310503096,2),(366060826,426388700,14850100,864892,1,'2009-03-28 14:33:31',3310503096,2),(366060827,426390900,14850000,864892,1,'2009-03-28 14:33:31',3310503096,2),(366060828,426391500,14849200,864892,1,'2009-03-28 14:33:31',3310503096,2),(366060829,426391700,14852500,864892,1,'2009-03-28 14:33:31',3310503096,2),(366060830,426393800,14854500,864892,1,'2009-03-28 14:33:31',3310503096,2),(366060833,426400300,14854000,864892,1,'2009-03-28 14:33:31',3310503096,2),(366060834,426401400,14853500,864892,1,'2009-03-28 14:33:31',3310503096,2),(366060836,426404000,14856600,864892,1,'2009-03-28 14:33:31',3310503096,2),(366060838,426408800,14860500,864892,1,'2009-03-28 14:33:31',3310503096,2),(366060840,426414700,14862900,864892,1,'2009-03-28 14:33:31',3310503097,2),(366060841,426416700,14862600,864892,1,'2009-03-28 14:33:31',3310503097,2),(366060843,426419700,14860400,864892,1,'2009-03-28 14:33:31',3310503097,2),(366060845,426423300,14854200,864892,1,'2009-03-28 14:33:31',3310503097,2),(366060846,426426400,14853800,864892,1,'2009-03-28 14:33:31',3310503097,2),(366060848,426429800,14854800,864892,1,'2009-03-28 14:33:31',3310503097,2),(366060850,426434700,14855200,864892,1,'2009-03-28 14:33:31',3310503097,2),(366060852,426427100,14859600,864892,1,'2009-03-28 14:33:31',3310503097,2),(366060854,426426400,14861500,864892,1,'2009-03-28 14:33:31',3310503097,2),(366060856,426421300,14865500,864892,1,'2009-03-28 14:33:31',3310503097,2),(366060857,426418100,14866300,864892,1,'2009-03-28 14:33:32',3310503097,2),(366060858,426417700,14866800,864892,1,'2009-03-28 14:33:32',3310503097,2),(366060859,426414200,14866200,864892,1,'2009-03-28 14:33:32',3310503097,2),(366060861,426411600,14867800,864892,1,'2009-03-28 14:33:32',3310503096,2),(366060862,426412500,14868700,864892,1,'2009-03-28 14:33:32',3310503096,2),(366060863,426412200,14869500,864892,1,'2009-03-28 14:33:32',3310503096,2),(366060864,426404800,14870400,864892,1,'2009-03-28 14:33:32',3310503096,2),(366060865,426402400,14872700,864892,1,'2009-03-28 14:33:32',3310503096,2),(366060866,426397200,14874200,864892,1,'2009-03-28 14:33:32',3310503096,2),(366060867,426394400,14872800,864892,1,'2009-03-28 14:33:32',3310503096,2),(366060868,426390800,14872100,864892,1,'2009-03-28 14:33:32',3310503096,2),(366060869,426386600,14869900,864892,1,'2009-03-28 14:33:32',3310503096,2),(366060870,426382300,14869000,864892,1,'2009-03-28 14:33:32',3310503085,2),(366060871,426380800,14865600,864892,1,'2009-03-28 14:33:32',3310503085,2),(366060968,426332200,15114200,862435,1,'2009-03-27 00:58:40',3310503438,2),(366060970,426333200,15114500,862435,1,'2009-03-27 00:58:40',3310503438,2),(366060971,426333700,15117800,862435,1,'2009-03-27 00:58:41',3310503438,2),(366060973,426331900,15126900,862435,1,'2009-03-27 00:58:41',3310503438,2),(366060975,426332200,15131000,862435,1,'2009-03-27 00:58:41',3310503438,2),(366060977,426333200,15135400,862435,1,'2009-03-27 00:58:42',3310503438,2),(366060978,426336100,15138900,862435,1,'2009-03-27 00:58:42',3310503438,2),(366060980,426338000,15143400,862435,1,'2009-03-27 00:58:42',3310503438,2),(366060982,426339100,15144300,862435,1,'2009-03-27 00:58:42',3310503438,2),(366060984,426339800,15146800,862435,1,'2009-03-27 00:58:42',3310503438,2),(366060986,426340700,15147300,862435,1,'2009-03-27 00:58:43',3310503438,2),(366060987,426343200,15150800,862435,1,'2009-03-27 00:58:43',3310503438,2),(366060989,426345200,15155700,862435,1,'2009-03-27 00:58:43',3310503438,2),(366060992,426346000,15159900,862435,1,'2009-03-27 00:58:43',3310503438,2),(366060994,426348500,15165700,862435,1,'2009-03-27 00:58:44',3310503460,2),(366060995,426348100,15168300,862435,1,'2009-03-27 00:58:44',3310503460,2),(366060997,426348700,15174100,862435,1,'2009-03-27 00:58:44',3310503460,2),(366060999,426349200,15175100,862435,1,'2009-03-27 00:58:44',3310503460,2),(366061000,426350100,15180100,862435,1,'2009-03-27 00:58:45',3310503460,2),(366061002,426349700,15181700,862435,1,'2009-03-27 00:58:45',3310503460,2),(366061004,426352900,15189100,862435,1,'2009-03-27 00:58:45',3310503460,2),(366061007,426353700,15192900,862435,1,'2009-03-27 00:58:45',3310503460,2),(366061009,426355400,15193400,862435,1,'2009-03-27 00:58:46',3310503460,2),(366061012,426354700,15194200,862435,1,'2009-03-27 00:58:46',3310503460,2),(366061015,426356700,15193600,862435,1,'2009-03-27 00:58:46',3310503460,2),(366061016,426360000,15194300,862435,1,'2009-03-27 00:58:46',3310503461,2),(366061018,426368300,15203500,862435,1,'2009-03-27 00:58:47',3310503461,2),(366061020,426371000,15209200,862435,1,'2009-03-27 00:58:47',3310503461,2),(366061021,426372100,15209000,862435,1,'2009-03-27 00:58:48',3310503461,2),(366061023,426374200,15214200,862435,1,'2009-03-27 00:58:48',3310503461,2),(366061025,426373900,15216000,862435,1,'2009-03-27 00:58:48',3310503461,2),(366061027,426373000,15217100,862435,1,'2009-03-27 00:58:49',3310503463,2),(366061029,426374300,15222900,862435,1,'2009-03-27 00:58:49',3310503463,2),(366061031,426376000,15221600,862435,1,'2009-03-27 00:58:49',3310503463,2),(366061032,426375900,15225700,862435,1,'2009-03-27 00:58:50',3310503463,2),(366061034,426376700,15226600,862435,1,'2009-03-27 00:58:50',3310503463,2),(366061036,426376100,15227200,862435,1,'2009-03-27 00:58:51',3310503463,2),(366061037,426380700,15231300,862435,1,'2009-03-27 00:58:51',3310503463,2),(366061038,426380400,15231500,862435,1,'2009-03-27 00:58:51',3310503463,2),(366061040,426384500,15231900,862435,1,'2009-03-27 00:58:51',3310503463,2),(366061042,426386200,15232600,862435,1,'2009-03-27 00:58:52',3310503474,2),(366061044,426388900,15232400,862435,1,'2009-03-27 00:58:52',3310503474,2),(366061045,426389900,15232800,862435,1,'2009-03-27 00:58:52',3310503474,2),(366061047,426394800,15230200,862435,1,'2009-03-27 00:58:52',3310503474,2),(366061049,426397400,15230800,862435,1,'2009-03-27 00:58:53',3310503474,2),(366061050,426399900,15229400,862435,1,'2009-03-27 00:58:53',3310503474,2),(366061051,426401500,15230100,862435,1,'2009-03-27 00:58:53',3310503474,2),(366061052,426404300,15233100,862435,1,'2009-03-27 00:58:54',3310503474,2),(366061054,426410700,15236300,862435,1,'2009-03-27 00:58:54',3310503474,2),(366061055,426418700,15235900,862435,1,'2009-03-27 00:58:54',3310503475,2),(366061056,426428600,15238500,862435,1,'2009-03-27 00:58:55',3310503475,2),(366061057,426432400,15240300,862435,1,'2009-03-27 00:58:55',3310503475,2),(366061058,426440200,15250900,862435,1,'2009-03-27 00:58:56',3310503475,2),(366061060,426440300,15253800,862435,1,'2009-03-27 00:58:56',3310503475,2),(366061061,426443400,15257200,862435,1,'2009-03-27 00:58:57',3310503478,2),(366061063,426443800,15260700,862435,1,'2009-03-27 00:58:57',3310503478,2),(366061065,426443200,15262300,862435,1,'2009-03-27 00:58:57',3310503478,2),(366061067,426440100,15261200,862435,1,'2009-03-27 00:58:58',3310503475,2),(366061071,426438600,15261900,862435,1,'2009-03-27 00:58:58',3310503475,2),(366061073,426438200,15264700,862435,1,'2009-03-27 00:58:58',3310503475,2),(366061076,426436800,15267200,862435,1,'2009-03-27 00:58:59',3310503475,2),(366061079,426439500,15276400,862435,1,'2009-03-27 00:58:59',3310503481,2),(366061081,426439400,15278900,862435,1,'2009-03-27 00:58:59',3310503481,2),(366061083,426440500,15282600,862435,1,'2009-03-27 00:59:00',3310503481,2),(366061085,426445400,15290500,862435,1,'2009-03-27 00:59:00',3310503484,2),(366061087,426448300,15293200,862435,1,'2009-03-27 00:59:00',3310503484,2),(366061088,426449300,15296400,862435,1,'2009-03-27 00:59:01',3310503484,2),(366061090,426450200,15301600,862435,1,'2009-03-27 00:59:02',3310503484,2),(366061092,426449700,15303700,862435,1,'2009-03-27 00:59:02',3310503484,2),(366061094,426450200,15306500,862435,1,'2009-03-27 00:59:03',3310503484,2),(366061095,426450800,15307600,862435,1,'2009-03-27 00:59:03',3310503484,2),(366061097,426450600,15311000,862435,1,'2009-03-27 00:59:03',3310503484,2),(366061099,426453000,15317800,862435,1,'2009-03-27 00:59:04',3310503484,2),(366061101,426454300,15325200,862435,1,'2009-03-27 00:59:04',3310503484,2),(366061102,426456600,15331500,862435,1,'2009-03-27 00:59:04',3310503486,2),(366061104,426460100,15332400,862435,1,'2009-03-27 00:59:05',3310503486,2),(366061106,426460600,15333800,862435,1,'2009-03-27 00:59:05',3310503486,2),(366061109,426462200,15335900,862435,1,'2009-03-27 00:59:05',3310503486,2),(366061111,426463400,15335900,862435,1,'2009-03-27 00:59:06',3310503486,2),(366061113,426464600,15337000,862435,1,'2009-03-27 00:59:06',3310503486,2),(366061115,426465200,15339200,862435,1,'2009-03-27 00:59:07',3310503486,2),(366061117,426466100,15340400,862435,1,'2009-03-27 00:59:07',3310503486,2),(366061119,426467300,15340800,862435,1,'2009-03-27 00:59:08',3310503486,2),(366061122,426469900,15340400,862435,1,'2009-03-27 00:59:08',3310503487,2),(366061124,426470600,15339100,862435,1,'2009-03-27 00:59:09',3310503487,2),(366061126,426473000,15339800,862435,1,'2009-03-27 00:59:09',3310503487,2),(366061128,426476900,15338900,862435,1,'2009-03-27 00:59:10',3310503487,2),(366061130,426477900,15339000,862435,1,'2009-03-27 00:59:10',3310503487,2),(366061132,426477900,15339700,862435,1,'2009-03-27 00:59:10',3310503487,2),(366061135,426478900,15339600,862435,1,'2009-03-27 00:59:10',3310503487,2),(366061137,426479400,15340700,862435,1,'2009-03-27 00:59:11',3310503487,2),(366061139,426482600,15341900,862435,1,'2009-03-27 00:59:11',3310503487,2),(366061141,426483200,15341100,862435,1,'2009-03-27 00:59:11',3310503487,2),(366061144,426488800,15340800,862435,1,'2009-03-27 00:59:12',3310503487,2),(366061145,426492400,15339700,862435,1,'2009-03-27 00:59:12',3310503487,2),(366061147,426496500,15342000,862435,1,'2009-03-27 00:59:12',3310503530,2),(366061148,426496800,15343500,862435,1,'2009-03-27 00:59:13',3310503530,2),(366061149,426498300,15342900,862435,1,'2009-03-27 00:59:13',3310503530,2),(366061154,426326124,15118555,862435,1,'2009-03-27 00:59:17',3310503435,2),(366076279,425833300,14697800,863220,1,'2009-03-27 04:34:37',3310502111,2),(366076280,425838000,14686500,863220,1,'2009-03-27 04:33:38',3310502282,1),(366076281,425838800,14683300,863220,1,'2009-03-27 04:33:40',3310502282,1),(366076282,425838900,14680700,863220,1,'2009-03-27 04:33:40',3310502282,1),(366076283,425837600,14679600,863220,1,'2009-03-27 04:33:40',3310502282,1),(366076284,425838700,14677000,863220,1,'2009-03-27 04:33:40',3310502282,1),(366076286,425839100,14676100,863220,1,'2009-03-27 04:33:40',3310502282,1),(366076287,425840700,14676800,863220,1,'2009-03-27 04:33:40',3310502282,1),(366076288,425839400,14672100,863220,1,'2009-03-27 04:33:40',3310502282,1),(366076289,425839500,14668100,863220,1,'2009-03-27 04:33:40',3310502282,1),(366076290,425839300,14668700,863220,1,'2009-03-27 04:33:40',3310502282,1),(366076291,425838800,14667300,863220,1,'2009-03-27 04:33:40',3310502282,1),(366076292,425838400,14667800,863220,1,'2009-03-27 04:33:40',3310502282,1),(366076293,425837800,14664900,863220,1,'2009-03-27 04:33:40',3310502280,1),(366076294,425837700,14659600,863220,1,'2009-03-27 04:33:40',3310502280,1),(366076295,425838700,14657600,863220,1,'2009-03-27 04:33:40',3310502280,1),(366076296,425839500,14652500,863220,1,'2009-03-27 04:33:41',3310502280,1),(366076297,425838900,14650600,863220,1,'2009-03-27 04:33:41',3310502280,1),(366076298,425836300,14650000,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076299,425831800,14645100,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076300,425831300,14647400,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076301,425829400,14651500,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076302,425828000,14648900,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076303,425826600,14648100,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076304,425825700,14646700,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076305,425824500,14647800,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076306,425823300,14647700,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076307,425823300,14646100,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076308,425824100,14643400,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076309,425822900,14642000,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076310,425822800,14640700,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076311,425819400,14643500,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076312,425818500,14642700,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076313,425818500,14641400,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076314,425820000,14639400,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076315,425821000,14637000,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076316,425820700,14633500,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076317,425821500,14630900,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076318,425821300,14624200,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076319,425818200,14618000,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076320,425816800,14610300,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076321,425817700,14602900,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076322,425817700,14599500,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076323,425816600,14591500,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076324,425815600,14590000,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076325,425815500,14587000,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076326,425814600,14584400,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076327,425814700,14577300,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076328,425813200,14576000,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076329,425813100,14569500,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076331,425813600,14567400,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076332,425812000,14561300,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076333,425811700,14558500,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076334,425810600,14558100,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076335,425809300,14549100,863220,1,'2009-03-27 04:33:42',3310502101,1),(366076336,425808000,14543800,863220,1,'2009-03-27 04:33:42',3310502100,1),(366076337,425806600,14541100,863220,1,'2009-03-27 04:33:42',3310502100,1),(366076338,425806500,14538900,863220,1,'2009-03-27 04:33:42',3310502100,1),(366076339,425805800,14538500,863220,1,'2009-03-27 04:33:42',3310502100,1),(366076340,425805500,14536400,863220,1,'2009-03-27 04:33:42',3310502100,1),(366076341,425804900,14537600,863220,1,'2009-03-27 04:33:42',3310502100,1),(366076342,425804700,14536000,863220,1,'2009-03-27 04:33:42',3310502100,1),(366076343,425804200,14535800,863220,1,'2009-03-27 04:33:43',3310502100,1),(366076344,425804000,14532500,863220,1,'2009-03-27 04:33:43',3310502100,1),(366076345,425802000,14527000,863220,1,'2009-03-27 04:33:43',3310502100,1),(366076346,425798100,14520800,863220,1,'2009-03-27 04:33:43',3310502100,1),(366076347,425797700,14518300,863220,1,'2009-03-27 04:33:43',3310502100,1),(366076348,425797700,14515600,863220,1,'2009-03-27 04:33:43',3310502100,1),(366076349,425798400,14514300,863220,1,'2009-03-27 04:33:43',3310502100,1),(366076350,425797800,14512600,863220,1,'2009-03-27 04:33:43',3310502100,1),(366076351,425798900,14512400,863220,1,'2009-03-27 04:33:43',3310502100,1),(366076352,425799400,14511200,863220,1,'2009-03-27 04:33:43',3310502100,1),(366076353,425799400,14507900,863220,1,'2009-03-27 04:33:43',3310502100,1),(366076354,425800500,14497700,863220,1,'2009-03-27 04:33:43',3310502014,1),(366076355,425800600,14487700,863220,1,'2009-03-27 04:33:43',3310502014,1),(366076356,425801400,14483400,863220,1,'2009-03-27 04:33:43',3310502014,1),(366076357,425802900,14481200,863220,1,'2009-03-27 04:33:43',3310502014,1),(366076358,425804500,14476200,863220,1,'2009-03-27 04:33:43',3310502014,1),(366076359,425803800,14472400,863220,1,'2009-03-27 04:33:43',3310502014,1),(366076360,425804000,14463200,863220,1,'2009-03-27 04:33:43',3310502014,1),(366076361,425802500,14450900,863220,1,'2009-03-27 04:33:43',3310502014,1),(366076362,425802200,14439900,863220,1,'2009-03-27 04:33:43',3310502012,1),(366076363,425801100,14436900,863220,1,'2009-03-27 04:33:43',3310502012,1);
INSERT INTO `current_nodes` VALUES (366076364,425800600,14432700,863220,1,'2009-03-27 04:33:43',3310502012,1),(366076365,425801100,14424300,863220,1,'2009-03-27 04:33:43',3310502012,1),(366076366,425802000,14417500,863220,1,'2009-03-27 04:33:43',3310502012,1),(366076367,425801500,14411900,863220,1,'2009-03-27 04:33:43',3310502012,1),(366076368,425801500,14406000,863220,1,'2009-03-27 04:33:43',3310502012,1),(366076369,425799700,14394500,863220,1,'2009-03-27 04:33:44',3310502012,1),(366076370,425799400,14383500,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076371,425800000,14379500,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076372,425801600,14376500,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076373,425802200,14374600,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076374,425802200,14373000,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076375,425803700,14370100,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076376,425806900,14367600,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076378,425807100,14366700,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076379,425806600,14364900,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076380,425807900,14354200,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076381,425807500,14350600,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076382,425808200,14348900,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076383,425808300,14346800,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076384,425809100,14345300,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076385,425809200,14342400,863220,1,'2009-03-27 04:33:44',3310502007,1),(366076386,425809900,14339100,863220,1,'2009-03-27 04:33:44',3310502007,1),(366076387,425811500,14338400,863220,1,'2009-03-27 04:33:44',3310502007,1),(366076388,425812900,14338700,863220,1,'2009-03-27 04:33:44',3310502007,1),(366076389,425814500,14335600,863220,1,'2009-03-27 04:33:44',3310502005,1),(366076390,425816100,14331100,863220,1,'2009-03-27 04:33:44',3310502005,1),(366076391,425820100,14324600,863220,1,'2009-03-27 04:33:44',3310502005,1),(366076392,425822000,14331200,863220,1,'2009-03-27 04:33:44',3310502005,1),(366076393,425821700,14332800,863220,1,'2009-03-27 04:33:44',3310502005,1),(366076394,425823700,14335500,863220,1,'2009-03-27 04:33:44',3310502005,1),(366076395,425824700,14335000,863220,1,'2009-03-27 04:33:44',3310502005,1),(366076396,425825700,14337300,863220,1,'2009-03-27 04:33:44',3310502005,1),(366076397,425828900,14341400,863220,1,'2009-03-27 04:33:44',3310502007,1),(366076398,425830900,14340800,863220,1,'2009-03-27 04:33:44',3310502007,1),(366076399,425837300,14346900,863220,1,'2009-03-27 04:33:44',3310502178,1),(366076400,425844700,14351500,863220,1,'2009-03-27 04:33:45',3310502178,1),(366076401,425845100,14353900,863220,1,'2009-03-27 04:33:45',3310502178,1),(366076402,425847700,14361000,863220,1,'2009-03-27 04:33:45',3310502178,1),(366076403,425849600,14360800,863220,1,'2009-03-27 04:33:45',3310502178,1),(366076404,425853500,14363100,863220,1,'2009-03-27 04:33:45',3310502178,1),(366076405,425854500,14362700,863220,1,'2009-03-27 04:33:45',3310502178,1),(366076406,425856700,14363700,863220,1,'2009-03-27 04:33:45',3310502178,1),(366076407,425858700,14366300,863220,1,'2009-03-27 04:33:45',3310502178,1),(366076408,425867100,14370700,863220,1,'2009-03-27 04:33:45',3310502179,1),(366076409,425869900,14374000,863220,1,'2009-03-27 04:33:45',3310502179,1),(366076410,425867600,14381400,863220,1,'2009-03-27 04:33:45',3310502179,1),(366076411,425865400,14386000,863220,1,'2009-03-27 04:33:45',3310502179,1),(366076412,425866800,14393100,863220,1,'2009-03-27 04:33:45',3310502185,1),(366076413,425867800,14393500,863220,1,'2009-03-27 04:33:45',3310502185,1),(366076414,425868800,14394800,863220,1,'2009-03-27 04:33:45',3310502185,1),(366076415,425868800,14396400,863220,1,'2009-03-27 04:33:45',3310502185,1),(366076416,425871300,14397600,863220,1,'2009-03-27 04:33:45',3310502185,1),(366076417,425872500,14401700,863220,1,'2009-03-27 04:33:45',3310502185,1),(366076418,425873700,14402800,863220,1,'2009-03-27 04:33:45',3310502185,1),(366076419,425875400,14407800,863220,1,'2009-03-27 04:33:45',3310502185,1),(366076420,425886400,14423000,863220,1,'2009-03-27 04:33:45',3310502185,1),(366076421,425889100,14425100,863220,1,'2009-03-27 04:33:45',3310502185,1),(366076422,425890200,14426600,863220,1,'2009-03-27 04:33:45',3310502185,1),(366076423,425894400,14428800,863220,1,'2009-03-27 04:33:45',3310502188,1),(366076424,425897700,14431500,863220,1,'2009-03-27 04:33:45',3310502188,1),(366076425,425901700,14433300,863220,1,'2009-03-27 04:33:45',3310502188,1),(366076426,425903000,14433000,863220,1,'2009-03-27 04:33:45',3310502188,1),(366076427,425906000,14435000,863220,1,'2009-03-27 04:33:45',3310502188,1),(366076428,425907200,14435300,863220,1,'2009-03-27 04:33:45',3310502188,1),(366076429,425909600,14434500,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076430,425911300,14434600,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076431,425913100,14435600,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076432,425914800,14434100,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076433,425918200,14436800,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076434,425919300,14434300,863220,1,'2009-03-27 04:33:46',3310502189,1),(366076436,425920500,14432700,863220,1,'2009-03-27 04:33:46',3310502189,1),(366076437,425921400,14432300,863220,1,'2009-03-27 04:33:46',3310502189,1),(366076438,425920800,14431300,863220,1,'2009-03-27 04:33:46',3310502189,1),(366076439,425921200,14428000,863220,1,'2009-03-27 04:33:46',3310502189,1),(366076440,425919900,14421300,863220,1,'2009-03-27 04:33:46',3310502189,1),(366076441,425919400,14420300,863220,1,'2009-03-27 04:33:46',3310502189,1),(366076442,425917200,14419000,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076443,425915900,14417100,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076444,425915400,14414900,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076445,425916100,14411900,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076446,425915600,14408600,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076447,425912500,14401700,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076448,425913400,14397000,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076449,425913242,14393409,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076544,425724900,14843700,863220,1,'2009-03-27 04:34:30',3310502125,1),(366076545,425729500,14841400,863220,1,'2009-03-27 04:34:30',3310502136,1),(366076546,425733600,14841800,863220,1,'2009-03-27 04:34:30',3310502136,1),(366076547,425735300,14842900,863220,1,'2009-03-27 04:34:30',3310502136,1),(366076548,425735600,14843600,863220,1,'2009-03-27 04:34:30',3310502136,1),(366076549,425737800,14843200,863220,1,'2009-03-27 04:34:30',3310502136,1),(366076550,425740700,14844500,863220,1,'2009-03-27 04:34:30',3310502136,1),(366076551,425743200,14844800,863220,1,'2009-03-27 04:34:30',3310502136,1),(366076552,425751000,14843200,863220,1,'2009-03-27 04:34:31',3310502136,1),(366076553,425755600,14843500,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076554,425755400,14842500,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076555,425756400,14844100,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076556,425759100,14846000,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076557,425760900,14845700,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076558,425765600,14841700,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076559,425768800,14851900,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076560,425771000,14854100,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076561,425769900,14858300,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076562,425772000,14858500,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076563,425771800,14864900,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076564,425773100,14864900,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076565,425773900,14865600,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076566,425773700,14867000,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076567,425774600,14869800,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076568,425774700,14869200,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076569,425776100,14869800,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076570,425776400,14871000,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076571,425778500,14869100,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076572,425778900,14866800,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076573,425780500,14865000,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076574,425781500,14862900,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076575,425787200,14861600,863220,1,'2009-03-27 04:34:31',3310502140,1),(366076576,425786800,14862200,863220,1,'2009-03-27 04:34:31',3310502140,1),(366076577,425787300,14861900,863220,1,'2009-03-27 04:34:31',3310502140,1),(366076578,425788800,14863100,863220,1,'2009-03-27 04:34:32',3310502140,1),(366076579,425789300,14864600,863220,1,'2009-03-27 04:34:32',3310502140,1),(366076580,425790700,14865700,863220,1,'2009-03-27 04:34:32',3310502140,1),(366076581,425792300,14868600,863220,1,'2009-03-27 04:34:32',3310502140,1),(366076582,425795000,14871100,863220,1,'2009-03-27 04:34:32',3310502140,1),(366076583,425796000,14874900,863220,1,'2009-03-27 04:34:32',3310502140,1),(366076584,425795500,14876300,863220,1,'2009-03-27 04:34:32',3310502140,1),(366076585,425797100,14881200,863220,1,'2009-03-27 04:34:32',3310502140,1),(366076586,425799400,14882900,863220,1,'2009-03-27 04:34:32',3310502140,1),(366076587,425801800,14882800,863220,1,'2009-03-27 04:34:32',3310502140,1),(366076588,425803700,14884900,863220,1,'2009-03-27 04:34:32',3310502140,1),(366076589,425805400,14888200,863220,1,'2009-03-27 04:34:32',3310502142,1),(366076590,425806200,14888300,863220,1,'2009-03-27 04:34:32',3310502142,1),(366076591,425804800,14891100,863220,1,'2009-03-27 04:34:32',3310502142,1),(366076592,425805800,14892200,863220,1,'2009-03-27 04:34:32',3310502142,1),(366076593,425807100,14892000,863220,1,'2009-03-27 04:34:32',3310502142,1),(366076594,425808300,14892800,863220,1,'2009-03-27 04:34:32',3310502142,1),(366076595,425812600,14890100,863220,1,'2009-03-27 04:34:32',3310502143,1),(366076596,425812200,14888900,863220,1,'2009-03-27 04:34:32',3310502143,1),(366076597,425812600,14887800,863220,1,'2009-03-27 04:34:32',3310502143,1),(366076598,425817000,14883100,863220,1,'2009-03-27 04:34:32',3310502141,1),(366076599,425819200,14881500,863220,1,'2009-03-27 04:34:32',3310502141,1),(366076600,425820100,14876600,863220,1,'2009-03-27 04:34:32',3310502141,1),(366076601,425822500,14873400,863220,1,'2009-03-27 04:34:32',3310502141,1),(366076602,425827200,14870200,863220,1,'2009-03-27 04:34:32',3310502141,1),(366076603,425831400,14869600,863220,1,'2009-03-27 04:34:33',3310502141,1),(366076604,425834600,14867100,863220,1,'2009-03-27 04:34:33',3310502141,1),(366076605,425837200,14865800,863220,1,'2009-03-27 04:34:33',3310502312,1),(366076606,425840300,14867300,863220,1,'2009-03-27 04:34:33',3310502312,1),(366076607,425843100,14866500,863220,1,'2009-03-27 04:34:33',3310502312,1),(366076608,425845700,14863600,863220,1,'2009-03-27 04:34:33',3310502312,1),(366076609,425851200,14853500,863220,1,'2009-03-27 04:34:33',3310502312,1),(366076610,425853400,14851200,863220,1,'2009-03-27 04:34:33',3310502312,1),(366076611,425857900,14849800,863220,1,'2009-03-27 04:34:33',3310502312,1),(366076612,425861900,14847100,863220,1,'2009-03-27 04:34:33',3310502312,1),(366076613,425865800,14845700,863220,1,'2009-03-27 04:34:33',3310502313,1),(366076614,425871900,14844700,863220,1,'2009-03-27 04:34:33',3310502313,1),(366076615,425876100,14843300,863220,1,'2009-03-27 04:34:33',3310502313,1),(366076617,425878700,14839800,863220,1,'2009-03-27 04:34:33',3310502313,1),(366076618,425881700,14837700,863220,1,'2009-03-27 04:34:33',3310502313,1),(366076619,425882800,14834300,863220,1,'2009-03-27 04:34:34',3310502313,1),(366076620,425882000,14830100,863220,1,'2009-03-27 04:34:34',3310502307,1),(366076621,425880200,14825700,863220,1,'2009-03-27 04:34:34',3310502307,1),(366076622,425880000,14823200,863220,1,'2009-03-27 04:34:34',3310502307,1),(366076623,425878700,14820200,863220,1,'2009-03-27 04:34:34',3310502307,1),(366076624,425876000,14815900,863220,1,'2009-03-27 04:34:34',3310502307,1),(366076625,425873700,14807300,863220,1,'2009-03-27 04:34:34',3310502307,1),(366076626,425871600,14803600,863220,1,'2009-03-27 04:34:34',3310502307,1),(366076627,425867200,14798600,863220,1,'2009-03-27 04:34:34',3310502307,1),(366076628,425866600,14796600,863220,1,'2009-03-27 04:34:34',3310502307,1),(366076629,425866900,14796500,863220,1,'2009-03-27 04:34:34',3310502307,1),(366076630,425864800,14791700,863220,1,'2009-03-27 04:34:34',3310502307,1),(366076631,425861600,14786800,863220,1,'2009-03-27 04:34:34',3310502306,1),(366076632,425859700,14779900,863220,1,'2009-03-27 04:34:34',3310502306,1),(366076633,425861600,14769800,863220,1,'2009-03-27 04:34:34',3310502304,1),(366076634,425863400,14765600,863220,1,'2009-03-27 04:34:34',3310502304,1),(366076635,425864600,14761500,863220,1,'2009-03-27 04:34:34',3310502305,1),(366076636,425864200,14758500,863220,1,'2009-03-27 04:34:34',3310502305,1),(366076637,425864500,14754100,863220,1,'2009-03-27 04:34:34',3310502305,1),(366076638,425867700,14746200,863220,1,'2009-03-27 04:34:34',3310502305,1),(366076639,425868500,14742500,863220,1,'2009-03-27 04:34:34',3310502305,1),(366076640,425875800,14736600,863220,1,'2009-03-27 04:34:34',3310502305,1),(366076641,425881300,14721800,863220,1,'2009-03-27 04:34:34',3310502283,1),(366076642,425883500,14714000,863220,1,'2009-03-27 04:34:35',3310502283,1),(366076643,425884500,14708000,863220,1,'2009-03-27 04:34:35',3310502283,1),(366076644,425886100,14704700,863220,1,'2009-03-27 04:34:35',3310502283,1),(366076645,425890200,14701300,863220,1,'2009-03-27 04:34:35',3310502283,1),(366076646,425891100,14699800,863220,1,'2009-03-27 04:34:35',3310502283,1),(366076647,425892400,14696600,863220,1,'2009-03-27 04:34:35',3310502286,1),(366076648,425898000,14686500,863220,1,'2009-03-27 04:34:35',3310502286,1),(366076649,425899800,14682100,863220,1,'2009-03-27 04:34:35',3310502286,1),(366076650,425900800,14677500,863220,1,'2009-03-27 04:34:35',3310502286,1),(366076651,425903900,14668400,863220,1,'2009-03-27 04:34:35',3310502286,1),(366076652,425905800,14660000,863220,1,'2009-03-27 04:34:35',3310502284,1),(366076653,425906100,14658200,863220,1,'2009-03-27 04:34:35',3310502284,1),(366076654,425905600,14653900,863220,1,'2009-03-27 04:34:35',3310502284,1),(366076655,425905900,14650800,863220,1,'2009-03-27 04:34:35',3310502284,1),(366076656,425907500,14648100,863220,1,'2009-03-27 04:34:35',3310502284,1),(366076657,425909000,14643900,863220,1,'2009-03-27 04:34:35',3310502284,1),(366076658,425910300,14638900,863220,1,'2009-03-27 04:34:35',3310502284,1),(366076659,425910100,14635600,863220,1,'2009-03-27 04:34:35',3310502284,1),(366076660,425910600,14633400,863220,1,'2009-03-27 04:34:35',3310502284,1),(366076661,425911800,14630200,863220,1,'2009-03-27 04:34:35',3310502284,1),(366076662,425913400,14628300,863220,1,'2009-03-27 04:34:35',3310502284,1),(366076663,425911600,14623000,863220,1,'2009-03-27 04:34:36',3310502284,1),(366076664,425911000,14622300,863220,1,'2009-03-27 04:34:36',3310502284,1),(366076665,425906100,14623300,863220,1,'2009-03-27 04:34:36',3310502284,1),(366076666,425903200,14622000,863220,1,'2009-03-27 04:34:36',3310502284,1),(366076667,425901300,14620100,863220,1,'2009-03-27 04:34:36',3310502284,1),(366076668,425898400,14615900,863220,1,'2009-03-27 04:34:36',3310502284,1),(366076669,425897500,14616900,863220,1,'2009-03-27 04:34:36',3310502284,1),(366076670,425895800,14621900,863220,1,'2009-03-27 04:34:36',3310502284,1),(366076671,425893100,14627000,863220,1,'2009-03-27 04:34:36',3310502284,1),(366076672,425886800,14632800,863220,1,'2009-03-27 04:34:36',3310502281,1),(366076673,425884700,14635800,863220,1,'2009-03-27 04:34:36',3310502281,1),(366076674,425880000,14639400,863220,1,'2009-03-27 04:34:36',3310502281,1),(366076675,425872200,14647900,863220,1,'2009-03-27 04:34:36',3310502281,1),(366076676,425870500,14657700,863220,1,'2009-03-27 04:34:36',3310502281,1),(366076677,425870300,14664100,863220,1,'2009-03-27 04:34:36',3310502281,1),(366076678,425869700,14667100,863220,1,'2009-03-27 04:34:36',3310502283,1),(366076679,425868700,14668700,863220,1,'2009-03-27 04:34:36',3310502283,1),(366076680,425868300,14671800,863220,1,'2009-03-27 04:34:36',3310502283,1),(366076681,425867100,14673600,863220,1,'2009-03-27 04:34:36',3310502283,1),(366076682,425863900,14675000,863220,1,'2009-03-27 04:34:36',3310502282,1),(366076683,425863700,14679300,863220,1,'2009-03-27 04:34:36',3310502282,1),(366076684,425862700,14682400,863220,1,'2009-03-27 04:34:36',3310502282,1),(366076685,425860200,14687500,863220,1,'2009-03-27 04:34:36',3310502282,1),(366076687,425858100,14696000,863220,1,'2009-03-27 04:34:36',3310502282,1),(366076688,425855500,14700800,863220,1,'2009-03-27 04:34:36',3310502282,1),(366076689,425852400,14704300,863220,1,'2009-03-27 04:34:36',3310502282,1),(366076690,425849700,14708400,863220,1,'2009-03-27 04:34:37',3310502282,1),(366076691,425846300,14708400,863220,1,'2009-03-27 04:34:37',3310502282,1),(366076692,425844800,14707000,863220,1,'2009-03-27 04:34:37',3310502282,1),(366076693,425843400,14707500,863220,1,'2009-03-27 04:34:37',3310502282,1),(366076694,425841200,14709200,863220,1,'2009-03-27 04:34:37',3310502282,1),(366076695,425840400,14711900,863220,1,'2009-03-27 04:34:37',3310502282,1),(366076696,425838400,14714700,863220,1,'2009-03-27 04:34:37',3310502282,1),(366076697,425833700,14718700,863220,1,'2009-03-27 04:34:37',3310502111,1),(366076698,425832200,14721600,863220,1,'2009-03-27 04:34:37',3310502111,1),(366076700,425832000,14719400,863220,1,'2009-03-27 04:34:37',3310502111,1),(366076701,425830700,14719700,863220,1,'2009-03-27 04:34:37',3310502111,1),(366076702,425828800,14721800,863220,1,'2009-03-27 04:34:37',3310502111,1),(366076704,425830700,14712700,863220,1,'2009-03-27 04:34:37',3310502111,1),(366076705,425833000,14706900,863220,1,'2009-03-27 04:34:37',3310502111,1),(366076706,425832700,14699800,863220,1,'2009-03-27 04:34:37',3310502111,1),(366076707,425829600,14705300,863220,1,'2009-03-27 04:34:37',3310502111,1),(366076708,425825400,14709800,863220,1,'2009-03-27 04:34:37',3310502111,1),(366076709,425816300,14716700,863220,1,'2009-03-27 04:34:37',3310502111,1),(366076710,425813300,14722500,863220,1,'2009-03-27 04:34:37',3310502133,1),(366076711,425812000,14728400,863220,1,'2009-03-27 04:34:37',3310502133,1),(366076712,425814000,14735500,863220,1,'2009-03-27 04:34:37',3310502133,1),(366076713,425811600,14743500,863220,1,'2009-03-27 04:34:37',3310502133,1),(366076714,425811400,14747400,863220,1,'2009-03-27 04:34:37',3310502133,1),(366076715,425812100,14752500,863220,1,'2009-03-27 04:34:37',3310502133,1),(366076716,425814300,14761000,863220,1,'2009-03-27 04:34:37',3310502133,1),(366076717,425812600,14767200,863220,1,'2009-03-27 04:34:37',3310502133,1),(366076718,425807000,14780500,863220,1,'2009-03-27 04:34:37',3310502134,1),(366076719,425805300,14790700,863220,1,'2009-03-27 04:34:37',3310502134,1),(366076720,425802600,14794400,863220,1,'2009-03-27 04:34:38',3310502134,1),(366076721,425801300,14794400,863220,1,'2009-03-27 04:34:38',3310502134,1),(366076722,425798700,14786500,863220,1,'2009-03-27 04:34:38',3310502134,1),(366076723,425795400,14786100,863220,1,'2009-03-27 04:34:38',3310502134,1),(366538118,425562200,15718400,864892,1,'2009-03-28 14:31:35',3310502588,1),(366538119,425562300,15722800,864892,1,'2009-03-28 14:31:35',3310502588,1),(366538120,425564200,15722900,864892,1,'2009-03-28 14:31:35',3310502588,1),(366538122,425566300,15723800,864892,1,'2009-03-28 14:31:35',3310502588,1),(366538124,425570500,15729200,864892,1,'2009-03-28 14:31:35',3310502588,1),(366538127,425573100,15731300,864892,1,'2009-03-28 14:31:36',3310502588,1),(366538128,425577600,15733500,864892,1,'2009-03-28 14:31:36',3310502588,1),(366538130,425584100,15733000,864892,1,'2009-03-28 14:31:36',3310502588,1),(366538131,425586400,15731300,864892,1,'2009-03-28 14:31:36',3310502588,1),(366538133,425589200,15730900,864892,1,'2009-03-28 14:31:36',3310502588,1),(366538134,425599500,15726500,864892,1,'2009-03-28 14:31:36',3310502589,1),(366538135,425601700,15724400,864892,1,'2009-03-28 14:31:36',3310502589,1),(366538137,425607200,15721400,864892,1,'2009-03-28 14:31:36',3310502589,1),(366538138,425612000,15721200,864892,1,'2009-03-28 14:31:36',3310502589,1),(366538139,425623500,15708400,864892,1,'2009-03-28 14:31:36',3310502626,1),(366538140,425625200,15705100,864892,1,'2009-03-28 14:31:36',3310502626,1),(366538141,425630300,15699700,864892,1,'2009-03-28 14:31:36',3310502626,1),(366538142,425635500,15691900,864892,1,'2009-03-28 14:31:36',3310502626,1),(366538144,425636400,15688800,864892,1,'2009-03-28 14:31:36',3310502626,1),(366538145,425638200,15686600,864892,1,'2009-03-28 14:31:36',3310502626,1),(366538146,425640400,15685300,864892,1,'2009-03-28 14:31:37',3310502626,1),(366538147,425644700,15683100,864892,1,'2009-03-28 14:31:37',3310502627,1),(366538148,425650600,15682600,864892,1,'2009-03-28 14:31:37',3310502627,1),(366538152,425652800,15682700,864892,1,'2009-03-28 14:31:37',3310502627,1),(366538153,425662000,15679600,864892,1,'2009-03-28 14:31:37',3310502627,1),(366538154,425666400,15677000,864892,1,'2009-03-28 14:31:37',3310502627,1),(366538155,425673700,15677700,864892,1,'2009-03-28 14:31:37',3310502630,1),(366538156,425677900,15676400,864892,1,'2009-03-28 14:31:37',3310502630,1),(366538157,425685500,15672500,864892,1,'2009-03-28 14:31:37',3310502630,1),(366538159,425691100,15668900,864892,1,'2009-03-28 14:31:37',3310502630,1),(366538160,425692200,15667700,864892,1,'2009-03-28 14:31:37',3310502630,1),(366538161,425704400,15660100,864892,1,'2009-03-28 14:31:37',3310502631,1),(366538162,425711400,15658000,864892,1,'2009-03-28 14:31:37',3310502631,1),(366538163,425723500,15656800,864892,1,'2009-03-28 14:31:37',3310502631,1),(366538164,425737800,15657200,864892,1,'2009-03-28 14:31:37',3310502642,1),(366538165,425744400,15660300,864892,1,'2009-03-28 14:31:37',3310502642,1),(366538166,425747900,15663300,864892,1,'2009-03-28 14:31:37',3310502642,1),(366538168,425750500,15664700,864892,1,'2009-03-28 14:31:37',3310502642,1),(366538169,425753000,15664300,864892,1,'2009-03-28 14:31:37',3310502642,1),(366538170,425755000,15666100,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538171,425756200,15666200,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538172,425756900,15665300,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538173,425758100,15666800,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538175,425759200,15666700,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538176,425760200,15665100,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538177,425762100,15663600,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538178,425762800,15664000,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538180,425763000,15667700,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538181,425765500,15666900,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538182,425771600,15669600,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538183,425774400,15666600,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538185,425776200,15669700,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538186,425776900,15669900,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538187,425777600,15668900,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538188,425779000,15669300,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538190,425781000,15668200,864892,1,'2009-03-28 14:31:38',3310502643,1),(366538192,425783200,15666000,864892,1,'2009-03-28 14:31:38',3310502646,1),(366538193,425785700,15664600,864892,1,'2009-03-28 14:31:38',3310502646,1),(366538194,425793000,15662200,864892,1,'2009-03-28 14:31:38',3310502646,1),(366538195,425795100,15661900,864892,1,'2009-03-28 14:31:38',3310502646,1),(366538196,425799900,15662500,864892,1,'2009-03-28 14:31:38',3310502646,1),(366538198,425801300,15664000,864892,1,'2009-03-28 14:31:38',3310502646,1),(366538199,425807700,15664900,864892,1,'2009-03-28 14:31:38',3310502646,1),(366538200,425811200,15664800,864892,1,'2009-03-28 14:31:38',3310502647,1),(366538201,425813300,15664500,864892,1,'2009-03-28 14:31:38',3310502647,1),(366538203,425821000,15659900,864892,1,'2009-03-28 14:31:38',3310502647,1),(366538204,425831700,15655000,864892,1,'2009-03-28 14:31:38',3310502645,1),(366538206,425835300,15655500,864892,1,'2009-03-28 14:31:38',3310502645,1),(366538207,425842100,15654600,864892,1,'2009-03-28 14:31:38',3310502816,1),(366538208,425846000,15655100,864892,1,'2009-03-28 14:31:38',3310502816,1),(366540716,426217621,15595243,864892,1,'2009-03-28 14:44:22',3310502875,1),(366540717,426218632,15603226,864892,1,'2009-03-28 14:44:22',3310502897,1),(366540718,426218884,15612238,864892,1,'2009-03-28 14:44:23',3310502897,1),(366540719,426221916,15623567,864892,1,'2009-03-28 14:44:23',3310502900,1),(366540720,426225074,15635240,864892,1,'2009-03-28 14:44:23',3310502900,1),(366540721,426225579,15646398,864892,1,'2009-03-28 14:44:23',3310502900,1),(366540722,426224700,15656400,864892,1,'2009-03-28 14:44:23',3310502902,1),(366540723,426225500,15672700,864892,1,'2009-03-28 14:44:23',3310502902,1),(366540724,426224000,15681700,864892,1,'2009-03-28 14:44:23',3310502902,1),(366540725,426224900,15689400,864892,1,'2009-03-28 14:44:23',3310502902,1),(366540726,426224500,15694100,864892,1,'2009-03-28 14:44:23',3310502902,1),(366540727,426225300,15696500,864892,1,'2009-03-28 14:44:23',3310502902,1),(366540728,426228100,15701000,864892,1,'2009-03-28 14:44:23',3310502902,1),(366540730,426228300,15704700,864892,1,'2009-03-28 14:44:23',3310502902,1),(366540731,426227700,15706800,864892,1,'2009-03-28 14:44:23',3310502902,1),(366540732,426228300,15709600,864892,1,'2009-03-28 14:44:23',3310502902,1),(366540733,426231600,15713000,864892,1,'2009-03-28 14:44:23',3310502908,1),(366540734,426234100,15718400,864892,1,'2009-03-28 14:44:23',3310502908,1),(366540735,426234100,15719900,864892,1,'2009-03-28 14:44:23',3310502908,1),(366540736,426235800,15727000,864892,1,'2009-03-28 14:44:23',3310502908,1),(366540737,426239700,15731500,864892,1,'2009-03-28 14:44:23',3310502908,1),(366540738,426240800,15734100,864892,1,'2009-03-28 14:44:23',3310502908,1),(366540739,426241200,15739000,864892,1,'2009-03-28 14:44:24',3310502908,1),(366540740,426240600,15743300,864892,1,'2009-03-28 14:44:24',3310502908,1),(366540741,426239700,15745900,864892,1,'2009-03-28 14:44:24',3310502908,1),(366540742,426239500,15749100,864892,1,'2009-03-28 14:44:24',3310502908,1),(366540743,426237800,15754900,864892,1,'2009-03-28 14:44:24',3310502908,1),(366540744,426237600,15757000,864892,1,'2009-03-28 14:44:24',3310502908,1),(366540745,426236900,15758300,864892,1,'2009-03-28 14:44:24',3310502908,1),(366540746,426235400,15766500,864892,1,'2009-03-28 14:44:24',3310502910,1),(366540747,426232000,15768400,864892,1,'2009-03-28 14:44:24',3310502910,1),(366540748,426228500,15768800,864892,1,'2009-03-28 14:44:24',3310502910,1),(366540749,426225100,15770300,864892,1,'2009-03-28 14:44:24',3310502910,1),(366540750,426223000,15770300,864892,1,'2009-03-28 14:44:24',3310502910,1),(366540751,426223000,15773500,864892,1,'2009-03-28 14:44:24',3310502910,1),(366540752,426221700,15775900,864892,1,'2009-03-28 14:44:24',3310502910,1),(366540754,426222300,15777200,864892,1,'2009-03-28 14:44:24',3310502910,1),(366540755,426220600,15781900,864892,1,'2009-03-28 14:44:24',3310502907,1),(366540756,426221300,15782800,864892,1,'2009-03-28 14:44:24',3310502910,1),(366540757,426220400,15782500,864892,1,'2009-03-28 14:44:24',3310502907,1),(366540758,426219700,15783400,864892,1,'2009-03-28 14:44:24',3310502907,1),(366540759,426217600,15787700,864892,1,'2009-03-28 14:44:24',3310502907,1),(366540760,426217400,15789000,864892,1,'2009-03-28 14:44:24',3310502907,1),(366540761,426216700,15789800,864892,1,'2009-03-28 14:44:24',3310502907,1),(366540762,426215200,15794800,864892,1,'2009-03-28 14:44:37',3310502907,2),(366540763,426213300,15796500,864892,1,'2009-03-28 14:44:24',3310502907,1),(366540764,426210700,15797100,864892,1,'2009-03-28 14:44:25',3310502907,1),(366540765,426213300,15800100,864892,1,'2009-03-28 14:44:25',3310502907,1),(366540766,426210700,15804600,864892,1,'2009-03-28 14:44:25',3310502907,1),(366540767,426209000,15809200,864892,1,'2009-03-28 14:44:25',3310502907,1),(366540768,426208800,15811700,864892,1,'2009-03-28 14:44:25',3310502907,1),(366540769,426203700,15822000,864892,1,'2009-03-28 14:44:25',3310504273,1),(366540770,426197600,15830600,864892,1,'2009-03-28 14:44:25',3310504273,1),(366540771,426196600,15834500,864892,1,'2009-03-28 14:44:25',3310504273,1),(366540772,426195500,15835300,864892,1,'2009-03-28 14:44:25',3310504273,1),(366540773,426193100,15838300,864892,1,'2009-03-28 14:44:25',3310504272,1),(366540774,426192700,15839400,864892,1,'2009-03-28 14:44:25',3310504272,1),(366540775,426189700,15842600,864892,1,'2009-03-28 14:44:25',3310504272,1),(366540776,426188900,15845200,864892,1,'2009-03-28 14:44:25',3310504272,1),(366540777,426186500,15861100,864892,1,'2009-03-28 14:44:25',3310504272,1),(366540778,426188200,15864900,864892,1,'2009-03-28 14:44:25',3310504272,1),(366540779,426188400,15868200,864892,1,'2009-03-28 14:44:25',3310504272,1),(366540780,426187600,15869200,864892,1,'2009-03-28 14:44:25',3310504272,1),(366540782,426187800,15871800,864892,1,'2009-03-28 14:44:25',3310504272,1),(366540783,426188200,15872900,864892,1,'2009-03-28 14:44:25',3310504272,1),(366540784,426190600,15875200,864892,1,'2009-03-28 14:44:25',3310504272,1),(366540785,426192700,15878200,864892,1,'2009-03-28 14:44:25',3310504274,1),(366540786,426192900,15881300,864892,1,'2009-03-28 14:44:25',3310504274,1),(366540787,426193400,15882800,864892,1,'2009-03-28 14:44:25',3310504274,1),(366540788,426193100,15884500,864892,1,'2009-03-28 14:44:26',3310504274,1),(366540789,426194400,15890500,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540792,426194900,15892600,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540793,426197200,15902100,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540794,426199600,15907000,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540795,426199400,15911300,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540796,426199800,15912400,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540798,426200400,15913400,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540800,426202800,15914300,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540801,426203700,15914100,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540802,426204300,15915200,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540803,426203700,15917900,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540804,426205600,15917100,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540805,426206400,15917700,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540806,426204900,15920500,864892,1,'2009-03-28 14:44:27',3310504275,1),(366540807,426205600,15921600,864892,1,'2009-03-28 14:44:27',3310504275,1),(366540808,426205600,15922900,864892,1,'2009-03-28 14:44:27',3310504275,1),(366540809,426206900,15925200,864892,1,'2009-03-28 14:44:27',3310504275,1),(366540810,426209700,15925000,864892,1,'2009-03-28 14:44:27',3310504275,1),(366540811,426210100,15926300,864892,1,'2009-03-28 14:44:27',3310504275,1),(366540812,426209400,15927200,864892,1,'2009-03-28 14:44:27',3310504275,1),(366540813,426209200,15928500,864892,1,'2009-03-28 14:44:27',3310504275,1),(366540814,426210100,15928900,864892,1,'2009-03-28 14:44:27',3310504275,1),(366540815,426212200,15928200,864892,1,'2009-03-28 14:44:27',3310504275,1),(366540816,426211800,15930200,864892,1,'2009-03-28 14:44:27',3310504275,1),(366540817,426210100,15932100,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540818,426211000,15932300,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540820,426210500,15933600,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540821,426209700,15934300,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540822,426210700,15934700,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540823,426210500,15936000,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540824,426209700,15936800,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540825,426207900,15941800,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540826,426207100,15942600,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540827,426208200,15944600,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540828,426208600,15947600,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540829,426210300,15951600,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540830,426210500,15952900,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540831,426209700,15957400,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540832,426210100,15958500,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540833,426212000,15960000,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540834,426211400,15962400,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540835,426211800,15964900,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540836,426212900,15965600,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540837,426213500,15966700,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540838,426213100,15969700,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540839,426216300,15970700,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540840,426215500,15973500,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540841,426217600,15973700,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540842,426217800,15975000,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540843,426216700,15979100,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540845,426219700,15980200,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540846,426219700,15981500,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540847,426218200,15987500,864892,1,'2009-03-28 14:44:28',3310504283,1),(366540848,426224300,15993500,864892,1,'2009-03-28 14:44:28',3310504286,1),(366540849,426232600,16005500,864892,1,'2009-03-28 14:44:28',3310504286,1),(366540850,426234300,16000100,864892,1,'2009-03-28 14:44:28',3310504286,1),(366540851,426235400,15998000,864892,1,'2009-03-28 14:44:28',3310504286,1),(366540852,426236300,16000300,864892,1,'2009-03-28 14:44:28',3310504286,1),(366540853,426237300,15998000,864892,1,'2009-03-28 14:44:28',3310504286,1),(366540854,426239100,16001800,864892,1,'2009-03-28 14:44:29',3310504286,1),(366540855,426240100,15998800,864892,1,'2009-03-28 14:44:29',3310504286,1),(366540856,426240800,15998000,864892,1,'2009-03-28 14:44:29',3310504286,1),(366540857,426242700,16005900,864892,1,'2009-03-28 14:44:29',3310504286,1),(366540858,426243400,16007200,864892,1,'2009-03-28 14:44:29',3310504286,1),(366540859,426243800,16006100,864892,1,'2009-03-28 14:44:29',3310504286,1),(366540860,426244600,16006800,864892,1,'2009-03-28 14:44:29',3310504286,1),(366540861,426246100,16012800,864892,1,'2009-03-28 14:44:29',3310504286,1),(366540862,426246100,16014100,864892,1,'2009-03-28 14:44:29',3310504286,1),(366540863,426247200,16016400,864892,1,'2009-03-28 14:44:29',3310504286,1),(366540864,426249100,16010900,864892,1,'2009-03-28 14:44:29',3310504287,1),(366540865,426250200,16013600,864892,1,'2009-03-28 14:44:29',3310504287,1),(366540866,426250200,16015100,864892,1,'2009-03-28 14:44:29',3310504287,1),(366540867,426251100,16014700,864892,1,'2009-03-28 14:44:29',3310504287,1),(366540868,426251500,16013400,864892,1,'2009-03-28 14:44:29',3310504287,1),(366540869,426253400,16020100,864892,1,'2009-03-28 14:44:29',3310504287,1),(366540870,426254300,16020700,864892,1,'2009-03-28 14:44:29',3310504287,1),(366540871,426254900,16023100,864892,1,'2009-03-28 14:44:29',3310504287,1),(366540873,426255800,16024200,864892,1,'2009-03-28 14:44:29',3310504287,1),(366540874,426255200,16026500,864892,1,'2009-03-28 14:44:29',3310504287,1),(366540875,426254900,16030200,864892,1,'2009-03-28 14:44:29',3310504287,1),(366540876,426255200,16031500,864892,1,'2009-03-28 14:44:36',3310504287,2),(366540883,426254700,16030400,864892,1,'2009-03-28 14:44:36',3310504287,1),(366540884,426254700,16026300,864892,1,'2009-03-28 14:44:36',3310504287,1),(366540885,426255600,16025900,864892,1,'2009-03-28 14:44:36',3310504287,1),(366540886,426256200,16021200,864892,1,'2009-03-28 14:44:36',3310504287,1),(366540887,426256700,16008900,864892,1,'2009-03-28 14:44:36',3310504287,1),(366540888,426254900,16003300,864892,1,'2009-03-28 14:44:36',3310504287,1),(366540889,426250200,15993900,864892,1,'2009-03-28 14:44:36',3310504287,1),(366540890,426250400,15992600,864892,1,'2009-03-28 14:44:36',3310504287,1),(366540891,426248100,15989600,864892,1,'2009-03-28 14:44:36',3310504286,1),(366540892,426247900,15988300,864892,1,'2009-03-28 14:44:36',3310504286,1),(366540893,426245900,15983800,864892,1,'2009-03-28 14:44:36',3310504284,1),(366540894,426243600,15980800,864892,1,'2009-03-28 14:44:36',3310504284,1),(366540895,426243600,15979500,864892,1,'2009-03-28 14:44:36',3310504284,1),(366540896,426242900,15978000,864892,1,'2009-03-28 14:44:36',3310504284,1),(366540897,426241400,15977000,864892,1,'2009-03-28 14:44:36',3310504284,1),(366540898,426239500,15973300,864892,1,'2009-03-28 14:44:36',3310504284,1),(366540899,426238600,15972400,864892,1,'2009-03-28 14:44:36',3310504284,1),(366540900,426230500,15971400,864892,1,'2009-03-28 14:44:36',3310504284,1),(366540901,426221500,15967100,864892,1,'2009-03-28 14:44:36',3310504284,1),(366540902,426218700,15964500,864892,1,'2009-03-28 14:44:36',3310504281,1),(366540903,426210300,15948200,864892,1,'2009-03-28 14:44:36',3310504281,1),(366540904,426209700,15929500,864892,1,'2009-03-28 14:44:36',3310504275,1),(366540905,426207700,15925000,864892,1,'2009-03-28 14:44:36',3310504275,1),(366540906,426206200,15923300,864892,1,'2009-03-28 14:44:36',3310504275,1),(366540907,426204500,15919900,864892,1,'2009-03-28 14:44:36',3310504275,1),(366540908,426203700,15917500,864892,1,'2009-03-28 14:44:36',3310504275,1),(366540909,426201300,15904900,864892,1,'2009-03-28 14:44:36',3310504275,1),(366540910,426200900,15899700,864892,1,'2009-03-28 14:44:36',3310504275,1),(366540911,426202600,15882100,864892,1,'2009-03-28 14:44:37',3310504275,1),(366540912,426202200,15875200,864892,1,'2009-03-28 14:44:37',3310504273,1),(366540913,426201500,15869000,864892,1,'2009-03-28 14:44:37',3310504273,1),(366540914,426199800,15862200,864892,1,'2009-03-28 14:44:37',3310504273,1),(366540915,426198300,15847600,864892,1,'2009-03-28 14:44:37',3310504273,1),(366540916,426197400,15843500,864892,1,'2009-03-28 14:44:37',3310504273,1),(366540917,426199200,15835800,864892,1,'2009-03-28 14:44:37',3310504273,1),(366540918,426202800,15825500,864892,1,'2009-03-28 14:44:37',3310504273,1),(366540920,426209700,15813400,864892,1,'2009-03-28 14:44:37',3310502907,1),(366540921,426212000,15807000,864892,1,'2009-03-28 14:44:37',3310502907,1),(366540922,426214200,15803600,864892,1,'2009-03-28 14:44:37',3310502907,1),(366540923,426215500,15803400,864892,1,'2009-03-28 14:44:37',3310502907,1),(366577779,425292990,15456390,327248,1,'2009-04-08 23:29:10',3310491602,4),(366577781,425288270,15452530,327248,1,'2009-04-08 23:29:10',3310491602,4),(366577782,425287630,15450600,327248,1,'2009-04-08 23:29:10',3310491602,4),(366577783,425295350,15447810,327248,1,'2009-04-08 23:29:11',3310491602,4),(366577784,425317450,15431280,327248,1,'2009-04-08 23:29:11',3310491601,4),(366577785,425322390,15422700,327248,1,'2009-04-08 23:29:11',3310491601,4),(366577786,425318740,15414330,327248,1,'2009-04-08 23:29:11',3310491601,4),(366577787,425324960,15398880,327248,1,'2009-04-08 23:29:11',3310491601,4),(366577788,425328180,15394160,327248,1,'2009-04-08 23:29:11',3310491601,4),(366577789,425321960,15389660,327248,1,'2009-04-08 23:29:11',3310491601,4),(366577790,425316810,15380220,327248,1,'2009-04-08 23:29:11',3310491515,4),(366577792,425326250,15370990,327248,1,'2009-04-08 23:29:11',3310491515,4),(366577793,425326680,15361550,327248,1,'2009-04-08 23:29:11',3310491515,4),(366577794,425324540,15359830,327248,1,'2009-04-08 23:29:11',3310491515,4),(366577795,425321960,15360900,327248,1,'2009-04-08 23:29:11',3310491515,4),(366577796,425312300,15367770,327248,1,'2009-04-08 23:29:11',3310491514,4),(366577797,425303290,15364770,327248,1,'2009-04-08 23:29:11',3310491514,4),(366577798,425308870,15357470,327248,1,'2009-04-08 23:29:11',3310491514,4),(366577799,425306300,15354680,327248,1,'2009-04-08 23:29:11',3310491514,4),(366577800,425299860,15355540,327248,1,'2009-04-08 23:29:11',3310491514,4),(366577802,425295780,15347600,327248,1,'2009-04-08 23:29:11',3310491514,4),(366577803,425293640,15346100,327248,1,'2009-04-08 23:29:11',3310491514,4),(366577804,425292130,15341590,327248,1,'2009-04-08 23:29:11',3310491514,4),(366577805,425295350,15318420,327248,1,'2009-04-08 23:29:12',3310491512,4),(366577806,425288920,15294170,327248,1,'2009-04-08 23:29:12',3310491512,4),(366577807,425292130,15285590,327248,1,'2009-04-08 23:29:12',3310491512,4),(366577808,425289340,15279150,327248,1,'2009-04-08 23:29:12',3310491512,4),(366577809,425287840,15278510,327248,1,'2009-04-08 23:29:12',3310491512,4),(366577810,425288270,15264770,327248,1,'2009-04-08 23:29:12',3310491506,4),(366577812,425291920,15255120,327248,1,'2009-04-08 23:29:12',3310491506,4),(366577813,425303290,15257480,327248,1,'2009-04-08 23:29:12',3310491506,4),(366577814,425306730,15261980,327248,1,'2009-04-08 23:29:12',3310491506,4),(366577815,425312950,15286450,327248,1,'2009-04-08 23:29:12',3310491512,4),(366577816,425316170,15281720,327248,1,'2009-04-08 23:29:12',3310491513,4),(366577817,425322180,15275930,327248,1,'2009-04-08 23:29:12',3310491513,4),(366577818,425333111,15269503,327248,1,'2009-04-08 23:29:59',3310491507,5),(366577819,425339340,15264560,327248,1,'2009-04-08 23:29:59',3310491507,5),(366577820,425346772,15262207,327248,1,'2009-04-08 23:29:59',3310491510,5),(366577821,425349896,15261904,327248,1,'2009-04-08 23:30:33',3310491510,9),(366577907,425383760,15493510,864892,1,'2009-03-28 17:17:43',3310491613,3),(366577908,425387620,15496090,864892,1,'2009-03-28 17:17:43',3310491613,3),(366577910,425390620,15495230,864892,1,'2009-03-28 17:17:43',3310491613,3),(366577912,425400070,15486430,864892,1,'2009-03-28 17:17:43',3310502530,3),(366577913,425403070,15487720,864892,1,'2009-03-28 17:17:43',3310502530,3),(366577914,425406930,15497590,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577915,425411220,15502310,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577917,425421520,15505740,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577918,425420880,15507670,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577919,425410150,15508100,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577920,425405430,15505530,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577922,425409290,15510030,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577924,425419590,15514110,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577925,425419380,15516260,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577926,425417880,15516690,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577927,425415090,15514760,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577928,425407580,15514540,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577929,425398140,15507460,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577930,425398140,15509390,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577931,425408010,15519480,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577932,425415090,15522480,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577934,425422380,15531920,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577935,425430110,15532140,864892,1,'2009-03-28 17:17:43',3310502537,3),(366577936,425434610,15528700,864892,1,'2009-03-28 17:17:43',3310502537,3),(366577937,425439980,15521840,864892,1,'2009-03-28 17:17:43',3310502537,3),(366577938,425445130,15518190,864892,1,'2009-03-28 17:17:43',3310502537,3),(366577939,425448130,15509610,864892,1,'2009-03-28 17:17:43',3310502537,3),(366577940,425450490,15508100,864892,1,'2009-03-28 17:17:44',3310502537,3),(366577941,425459930,15505960,864892,1,'2009-03-28 17:17:44',3310502540,3),(366577943,425464010,15503170,864892,1,'2009-03-28 17:17:44',3310502540,3),(366577944,425464440,15504670,864892,1,'2009-03-28 17:17:44',3310502540,3),(366577945,425460580,15509390,864892,1,'2009-03-28 17:17:44',3310502540,3),(366577946,425461220,15509820,864892,1,'2009-03-28 17:17:44',3310502540,3),(366577947,425468090,15505530,864892,1,'2009-03-28 17:17:44',3310502540,3),(366577948,425470880,15502740,864892,1,'2009-03-28 17:17:44',3310502540,3),(366577949,425472160,15494590,864892,1,'2009-03-28 17:17:44',3310502540,3),(366577950,425474310,15498880,864892,1,'2009-03-28 17:17:44',3310502540,3),(366577952,425489330,15494160,864892,1,'2009-03-28 17:17:44',3310502541,3),(366577953,425494910,15495440,864892,1,'2009-03-28 17:17:44',3310502541,3),(366577954,425506070,15515830,864892,1,'2009-03-28 17:17:44',3310502541,3),(366577955,425514220,15521620,864892,1,'2009-03-28 17:17:44',3310502552,3),(366577980,425545760,15710230,864892,1,'2009-03-28 17:18:56',3310502579,4),(366577981,425535890,15710230,864892,1,'2009-03-28 17:18:56',3310502579,4),(366577982,425532250,15709380,864892,1,'2009-03-28 17:18:56',3310502578,4),(366577983,425526880,15705080,864892,1,'2009-03-28 17:18:56',3310502578,4),(366577984,425512080,15705940,864892,1,'2009-03-28 17:18:56',3310502578,4),(366577985,425508430,15702300,864892,1,'2009-03-28 17:18:56',3310502578,4),(366577987,425502420,15712810,864892,1,'2009-03-28 17:18:57',3310502573,4),(366577988,425497060,15713880,864892,1,'2009-03-28 17:18:57',3310502573,4),(366577989,425494690,15712590,864892,1,'2009-03-28 17:18:57',3310502573,4),(366577990,425491050,15705300,864892,1,'2009-03-28 17:18:57',3310502567,4),(366577991,425490620,15700790,864892,1,'2009-03-28 17:18:57',3310502567,4),(366577992,425487830,15698000,864892,1,'2009-03-28 17:18:57',3310502567,4),(366577994,425489540,15687270,864892,1,'2009-03-28 17:18:57',3310502567,4),(366577996,425486110,15689640,864892,1,'2009-03-28 17:18:57',3310502567,4),(366577997,425484180,15688990,864892,1,'2009-03-28 17:18:57',3310502567,4),(366577998,425484820,15681050,864892,1,'2009-03-28 17:18:57',3310502567,4),(366578000,425480530,15671610,864892,1,'2009-03-28 17:18:57',3310502567,4),(366578001,425480530,15663670,864892,1,'2009-03-28 17:18:57',3310502567,4),(366578003,425476880,15662380,864892,1,'2009-03-28 17:18:57',3310502566,4),(366578004,425475600,15660240,864892,1,'2009-03-28 17:18:57',3310502566,4),(366578006,425477100,15651870,864892,1,'2009-03-28 17:18:57',3310502564,4),(366578007,425474100,15638570,864892,1,'2009-03-28 17:18:57',3310502564,4),(366578013,425468090,15639640,864892,1,'2009-03-28 17:18:39',3310502564,4),(366578014,425472380,15636210,864892,1,'2009-03-28 17:18:57',3310502564,6),(366578016,425469590,15630840,864892,1,'2009-03-28 17:18:37',3310502564,4),(366578018,425463800,15611100,864892,1,'2009-03-28 17:18:37',3310502564,4),(366578019,425461650,15607880,864892,1,'2009-03-28 17:18:37',3310502564,4),(366578020,425459070,15606380,864892,1,'2009-03-28 17:18:37',3310502564,4),(366578021,425456930,15601870,864892,1,'2009-03-28 17:18:37',3310502564,4),(366578022,425457790,15600370,864892,1,'2009-03-28 17:18:37',3310502542,4),(366578024,425456710,15597580,864892,1,'2009-03-28 17:18:38',3310502542,4),(366578025,425453070,15594150,864892,1,'2009-03-28 17:18:38',3310502542,4),(366578026,425429030,15591140,864892,1,'2009-03-28 17:18:38',3310502539,4),(366578027,425405000,15581700,864892,1,'2009-03-28 17:18:38',3310502538,4),(366578029,425405000,15570760,864892,1,'2009-03-28 17:18:38',3310502538,4),(366578031,425399640,15568400,864892,1,'2009-03-28 17:18:38',3310502538,4),(366578032,425388910,15555310,864892,1,'2009-03-28 17:18:38',3310491615,4),(366578033,425370450,15538790,864892,1,'2009-03-28 17:18:38',3310491613,4),(366578035,425358220,15535350,864892,1,'2009-03-28 17:18:38',3310491612,4),(366578036,425354790,15525480,864892,1,'2009-03-28 17:18:38',3310491612,4),(366578037,425350930,15526990,864892,1,'2009-03-28 17:18:38',3310491612,4),(366578040,425342990,15518190,864892,1,'2009-03-28 17:18:38',3310491612,4),(366578041,425343420,15516260,864892,1,'2009-03-28 17:18:38',3310491612,4),(366578042,425340630,15511750,864892,1,'2009-03-28 17:18:38',3310491609,4),(366578043,425341490,15511320,864892,1,'2009-03-28 17:18:38',3310491609,4),(366578044,425339340,15504880,864892,1,'2009-03-28 17:18:38',3310491609,4),(366578045,425324750,15486430,864892,1,'2009-03-28 17:18:38',3310491603,4),(366578046,425303510,15470770,864892,1,'2009-03-28 17:18:38',3310491602,4),(366578048,425299430,15473340,864892,1,'2009-03-28 17:18:38',3310491602,4),(366578049,425297710,15478060,864892,1,'2009-03-28 17:18:38',3310491602,4),(366578050,425293210,15476780,864892,1,'2009-03-28 17:18:38',3310491602,4),(366578052,425291060,15472910,864892,1,'2009-03-28 17:18:39',3310491602,4),(366578053,425287410,15470550,864892,1,'2009-03-28 17:18:39',3310491602,4),(366578054,425280025,15473186,864892,1,'2009-03-28 17:18:39',3310491591,6),(366578105,425292221,15459046,327248,1,'2009-04-08 23:29:10',3310491602,4),(366578338,425466575,15638519,864892,1,'2009-03-28 17:18:39',3310502564,1),(367676808,425414241,14408646,216961,1,'2009-04-05 17:52:17',3310501928,2),(367676825,425415595,14408347,216961,1,'2009-04-05 17:52:18',3310501928,2),(367676852,425416696,14407920,216961,1,'2009-04-05 17:52:18',3310501928,2),(367676869,425418175,14407365,216961,1,'2009-04-05 17:52:19',3310501928,2),(367676884,425418962,14407066,216961,1,'2009-04-05 17:52:19',3310501928,2),(367676899,425420158,14407194,216961,1,'2009-04-05 17:52:20',3310501928,2),(367676910,425420977,14407322,216961,1,'2009-04-05 17:52:20',3310501928,2),(367676924,425422267,14407407,216961,1,'2009-04-05 17:52:20',3310501928,2),(367676937,425423369,14407194,216961,1,'2009-04-05 17:52:21',3310501928,2),(367676948,425424376,14406382,216961,1,'2009-04-05 17:52:22',3310501928,2),(367676960,425425540,14405528,216961,1,'2009-04-05 17:52:22',3310501929,2),(367676970,425427177,14405015,216961,1,'2009-04-05 17:52:22',3310501929,2),(367676981,425428719,14404844,216961,1,'2009-04-05 17:52:23',3310501929,2),(367677010,425428940,14403520,870814,1,'2009-03-31 00:46:58',3310501929,1),(367677022,425429317,14402751,870814,1,'2009-03-31 00:46:59',3310501929,1),(367677032,425429632,14402409,870814,1,'2009-03-31 00:46:59',3310501929,1),(367677043,425429569,14401427,870814,1,'2009-03-31 00:47:00',3310501929,1),(367677058,425429726,14400359,870814,1,'2009-03-31 00:47:00',3310501929,1),(367677076,425430010,14399590,870814,1,'2009-03-31 00:47:01',3310501929,1),(367677090,425430356,14398949,870814,1,'2009-03-31 00:47:02',3310501929,1),(367677101,425430828,14398522,870814,1,'2009-03-31 00:47:02',3310501929,1),(367677116,425431206,14398308,870814,1,'2009-03-31 00:47:03',3310501929,1),(367677123,425431961,14398949,870814,1,'2009-03-31 00:47:03',3310501929,1),(367677127,425434133,14399077,870814,1,'2009-03-31 00:47:04',3310501929,1),(367677134,425434542,14399376,870814,1,'2009-03-31 00:47:04',3310501929,1),(367677152,425434825,14399932,870814,1,'2009-03-31 00:47:05',3310501929,1),(367677173,425435767,14400330,870814,1,'2009-03-31 00:47:06',3310501929,1),(367677207,425436774,14401150,870814,1,'2009-03-31 00:47:07',3310501929,1),(367677224,425437318,14401478,870814,1,'2009-03-31 00:47:09',3310501929,1),(367677245,425437821,14401615,870814,1,'2009-03-31 00:47:10',3310501929,1),(367677261,425438164,14401451,870814,1,'2009-03-31 00:47:11',3310501929,1),(367677271,425438567,14400822,870814,1,'2009-03-31 00:47:12',3310501929,1),(367677289,425438829,14400548,870814,1,'2009-03-31 00:47:13',3310501929,1),(367677308,425439191,14400466,870814,1,'2009-03-31 00:47:14',3310501929,1),(367677322,425439614,14400466,870814,1,'2009-03-31 00:47:14',3310501929,1),(367677341,425440581,14401150,870814,1,'2009-03-31 00:47:15',3310501929,1),(367677395,425440883,14401888,870814,1,'2009-03-31 00:47:18',3310501929,1),(367677405,425441085,14402298,870814,1,'2009-03-31 00:47:19',3310501929,1),(367677418,425441407,14402490,870814,1,'2009-03-31 00:47:20',3310501929,1),(367677434,425441910,14402544,870814,1,'2009-03-31 00:47:21',3310501929,1),(367677448,425442615,14402189,870814,1,'2009-03-31 00:47:21',3310501929,1),(367677464,425443139,14401697,870814,1,'2009-03-31 00:47:22',3310501929,1),(367677476,425443401,14401259,870814,1,'2009-03-31 00:47:22',3310501929,1),(367677490,425443663,14401205,870814,1,'2009-03-31 00:47:23',3310501929,1),(367677502,425443925,14401505,870814,1,'2009-03-31 00:47:23',3310501929,1),(367677515,425444610,14401779,870814,1,'2009-03-31 00:47:24',3310501929,1),(367677526,425444992,14401751,870814,1,'2009-03-31 00:47:24',3310501929,1),(367677538,425445234,14401533,870814,1,'2009-03-31 00:47:25',3310501929,1),(367677639,425445375,14401041,870814,1,'2009-03-31 00:47:34',3310501929,1),(367677777,425445536,14400357,870814,1,'2009-03-31 00:47:50',3310501929,1),(367677784,425445738,14399892,870814,1,'2009-03-31 00:47:51',3310501929,1),(367677801,425446080,14399564,870814,1,'2009-03-31 00:47:55',3310501929,1),(367677832,425446584,14399537,870814,1,'2009-03-31 00:47:57',3310501929,1),(367677910,425447168,14399701,870814,1,'2009-03-31 00:48:05',3310501929,1),(367677917,425447691,14399947,870814,1,'2009-03-31 00:48:05',3310501929,1),(367677926,425448155,14400466,870814,1,'2009-03-31 00:48:06',3310501929,1),(367677937,425448457,14401013,870814,1,'2009-03-31 00:48:06',3310501929,1),(367677977,425448759,14401259,870814,1,'2009-03-31 00:48:10',3310501929,1),(367677996,425449242,14401341,870814,1,'2009-03-31 00:48:10',3310501929,1),(367678009,425449746,14401533,870814,1,'2009-03-31 00:48:11',3310501929,1),(367678022,425450733,14401943,870814,1,'2009-03-31 00:48:11',3310501929,1),(367678041,425452264,14402572,870814,1,'2009-03-31 00:48:12',3310501932,1),(367678052,425453472,14402708,870814,1,'2009-03-31 00:48:13',3310501932,1),(367678060,425454661,14402736,870814,1,'2009-03-31 00:48:13',3310501932,1),(367678071,425455225,14402462,870814,1,'2009-03-31 00:48:14',3310501932,1),(367678076,425455688,14402107,870814,1,'2009-03-31 00:48:15',3310501932,1),(367678085,425456433,14402025,870814,1,'2009-03-31 00:48:15',3310501932,1),(367678093,425456594,14402243,870814,1,'2009-03-31 00:48:16',3310501932,1),(367678136,425456735,14402818,870814,1,'2009-03-31 00:48:19',3310501932,1),(367678147,425456876,14403446,870814,1,'2009-03-31 00:48:20',3310501932,1),(367678187,425457400,14403993,870814,1,'2009-03-31 00:48:25',3310501932,1),(367678204,425458125,14404048,870814,1,'2009-03-31 00:48:26',3310501932,1),(367678210,425458629,14404130,870814,1,'2009-03-31 00:48:26',3310501932,1),(367678218,425459374,14404458,870814,1,'2009-03-31 00:48:27',3310501932,1),(367678223,425460703,14405087,870814,1,'2009-03-31 00:48:28',3310501932,1),(367678236,425462275,14405661,870814,1,'2009-03-31 00:48:30',3310501932,1),(367678270,425463523,14405688,870814,1,'2009-03-31 00:48:34',3310501932,1),(367678278,425465336,14405087,870814,1,'2009-03-31 00:48:35',3310501932,1),(367678291,425466666,14404923,870814,1,'2009-03-31 00:48:36',3310501932,1),(367678297,425468579,14405032,870814,1,'2009-03-31 00:48:37',3310501932,1),(367678306,425471419,14405278,870814,1,'2009-03-31 00:48:40',3310501932,1),(367678312,425473292,14405552,870814,1,'2009-03-31 00:48:41',3310501932,1),(367678321,425475367,14405470,870814,1,'2009-03-31 00:48:42',3310501932,1),(367678325,425476938,14405524,870814,1,'2009-03-31 00:48:43',3310501932,1),(367678340,425481288,14406344,870814,1,'2009-03-31 00:48:45',3310501933,1),(367678352,425483947,14406317,870814,1,'2009-03-31 00:48:46',3310501933,1),(367678376,425485699,14406235,870814,1,'2009-03-31 00:48:48',3310501933,1),(367678479,425487875,14406098,870814,1,'2009-03-31 00:49:05',3310501933,1),(367678487,425494159,14406755,870814,1,'2009-03-31 00:49:05',3310501933,1),(367678495,425495367,14406727,870814,1,'2009-03-31 00:49:06',3310501933,1),(367678507,425496415,14406262,870814,1,'2009-03-31 00:49:08',3310501933,1),(367678516,425497522,14405825,870814,1,'2009-03-31 00:49:09',3310501933,1),(367678522,425498308,14405524,870814,1,'2009-03-31 00:49:11',3310501933,1),(367678531,425499879,14404649,870814,1,'2009-03-31 00:49:11',3310501933,1),(367678537,425505800,14400931,870814,1,'2009-03-31 00:49:15',3310501933,1),(367678542,425506344,14400876,870814,1,'2009-03-31 00:49:16',3310501933,1),(367678550,425506888,14401041,870814,1,'2009-03-31 00:49:16',3310501933,1),(367678557,425507250,14401341,870814,1,'2009-03-31 00:49:17',3310501944,1),(367678565,425507714,14402216,870814,1,'2009-03-31 00:49:18',3310501944,1),(367678572,425508016,14403474,870814,1,'2009-03-31 00:49:19',3310501944,1),(367678591,425507975,14404485,870814,1,'2009-03-31 00:49:21',3310501944,1),(367678599,425507855,14405415,870814,1,'2009-03-31 00:49:22',3310501944,1),(367678605,425507573,14406618,870814,1,'2009-03-31 00:49:22',3310501944,1),(367678629,425507069,14407821,870814,1,'2009-03-31 00:49:26',3310501944,1),(367678634,425506566,14408504,870814,1,'2009-03-31 00:49:26',3310501933,1),(367678639,425506062,14409215,870814,1,'2009-03-31 00:49:27',3310501933,1),(367678644,425505579,14409543,870814,1,'2009-03-31 00:49:27',3310501933,1),(367678654,425504813,14409680,870814,1,'2009-03-31 00:49:28',3310501933,1),(367678663,425504411,14409598,870814,1,'2009-03-31 00:49:29',3310501933,1),(367678669,425503867,14409625,870814,1,'2009-03-31 00:49:29',3310501933,1),(367678677,425503242,14409762,870814,1,'2009-03-31 00:49:30',3310501933,1),(367678702,425502235,14410063,870814,1,'2009-03-31 00:49:32',3310501933,1),(367678712,425501148,14410281,870814,1,'2009-03-31 00:49:32',3310501933,1),(367678720,425499959,14410746,870814,1,'2009-03-31 00:49:33',3310501933,1),(367678727,425495569,14412441,870814,1,'2009-03-31 00:49:34',3310501933,1),(367678735,425491178,14414218,870814,1,'2009-03-31 00:49:34',3310501933,1),(367678745,425489567,14414902,870814,1,'2009-03-31 00:49:35',3310501933,1),(367678755,425488076,14415203,870814,1,'2009-03-31 00:49:35',3310501933,1),(367678769,425477099,14416980,870814,1,'2009-03-31 00:49:36',3310501932,1),(367678779,425465417,14419085,870814,1,'2009-03-31 00:49:37',3310501932,1),(367678793,425453271,14421354,870814,1,'2009-03-31 00:49:37',3310501932,1),(367678802,425451740,14421764,870814,1,'2009-03-31 00:49:38',3310501929,1),(367678814,425448396,14422858,870814,1,'2009-03-31 00:49:39',3310501929,1),(367678847,425447389,14423323,870814,1,'2009-03-31 00:49:40',3310501929,1),(367678865,425446745,14423787,870814,1,'2009-03-31 00:49:41',3310501929,1),(367678880,425446503,14424334,870814,1,'2009-03-31 00:49:42',3310501929,1),(367678890,425446342,14424963,870814,1,'2009-03-31 00:49:42',3310501929,1),(367678906,425446443,14425838,870814,1,'2009-03-31 00:49:43',3310501929,1),(367678922,425446805,14426740,870814,1,'2009-03-31 00:49:43',3310501929,1),(367678939,425448960,14431087,870814,1,'2009-03-31 00:49:44',3310501929,1),(367678954,425454197,14441941,870814,1,'2009-03-31 00:49:44',3310501932,1),(367678966,425454399,14442597,870814,1,'2009-03-31 00:49:45',3310501932,1),(367678977,425454399,14443335,870814,1,'2009-03-31 00:49:45',3310501932,1),(367678987,425454278,14443691,870814,1,'2009-03-31 00:49:46',3310501932,1),(367678996,425453895,14443992,870814,1,'2009-03-31 00:49:46',3310501932,1),(367679008,425453351,14444019,870814,1,'2009-03-31 00:49:47',3310501932,1),(367679021,425452485,14443745,870814,1,'2009-03-31 00:49:47',3310501932,1),(367679030,425449827,14442679,870814,1,'2009-03-31 00:49:48',3310501929,1),(367679046,425448920,14442078,870814,1,'2009-03-31 00:49:48',3310501929,1),(367679058,425448074,14441367,870814,1,'2009-03-31 00:49:49',3310501929,1),(367679071,425446584,14439617,870814,1,'2009-03-31 00:49:50',3310501929,1),(367679081,425445677,14438578,870814,1,'2009-03-31 00:49:51',3310501929,1),(367679089,425445174,14438250,870814,1,'2009-03-31 00:49:51',3310501929,1),(367679104,425444670,14438113,870814,1,'2009-03-31 00:49:52',3310501929,1),(367679117,425444227,14438387,870814,1,'2009-03-31 00:49:53',3310501929,1),(367679128,425443824,14439125,870814,1,'2009-03-31 00:49:53',3310501929,1),(367679147,425443784,14439945,870814,1,'2009-03-31 00:49:54',3310501929,1),(367679155,425443945,14440656,870814,1,'2009-03-31 00:49:56',3310501929,1),(367679176,425444388,14441504,870814,1,'2009-03-31 00:49:57',3310501929,1),(367679191,425445194,14442460,870814,1,'2009-03-31 00:49:59',3310501929,1),(367679205,425447289,14444784,870814,1,'2009-03-31 00:49:59',3310501929,1),(367679214,425449988,14448366,870814,1,'2009-03-31 00:50:00',3310501931,1),(367679221,425453090,14453232,870814,1,'2009-03-31 00:50:00',3310501934,1),(367679236,425455164,14457306,870814,1,'2009-03-31 00:50:01',3310501934,1),(367679246,425456957,14461899,870814,1,'2009-03-31 00:50:02',3310501934,1),(367679257,425458931,14467641,870814,1,'2009-03-31 00:50:02',3310501934,1),(367679266,425460139,14470347,870814,1,'2009-03-31 00:50:03',3310501934,1),(367679278,425461288,14472070,870814,1,'2009-03-31 00:50:04',3310501934,1),(367679287,425462174,14472917,870814,1,'2009-03-31 00:50:04',3310501934,1),(367679292,425464309,14474065,870814,1,'2009-03-31 00:50:05',3310501934,1),(367679302,425467894,14475460,870814,1,'2009-03-31 00:50:06',3310501934,1),(367679315,425469344,14476171,870814,1,'2009-03-31 00:50:08',3310501934,1),(367679329,425470956,14477100,870814,1,'2009-03-31 00:50:09',3310501934,1),(367679336,425474722,14480190,870814,1,'2009-03-31 00:50:10',3310501934,1),(367679344,425480765,14484865,870814,1,'2009-03-31 00:50:11',3310501935,1),(367679349,425488902,14490005,870814,1,'2009-03-31 00:50:12',3310501935,1),(367679356,425493835,14494528,870814,1,'2009-03-31 00:50:13',3310501935,1),(367679361,425495822,14496069,870814,1,'2009-03-31 00:50:14',3310501935,1),(367679371,425497893,14497378,870814,1,'2009-03-31 00:50:16',3310501935,1),(367679385,425499352,14497821,870814,1,'2009-03-31 00:50:17',3310501935,1),(367679611,425500213,14497900,870814,1,'2009-03-31 00:50:41',3310501935,1),(367679614,425500666,14497869,870814,1,'2009-03-31 00:50:41',3310501935,1),(367679617,425501212,14497806,870814,1,'2009-03-31 00:50:43',3310501935,1),(367679635,425501863,14497885,870814,1,'2009-03-31 00:50:46',3310501935,1),(367679639,425502189,14498074,870814,1,'2009-03-31 00:50:47',3310501935,1),(367679650,425502433,14498311,870814,1,'2009-03-31 00:50:49',3310501935,1),(367679669,425502537,14498737,870814,1,'2009-03-31 00:50:55',3310501935,1),(367679673,425502595,14499194,870814,1,'2009-03-31 00:50:55',3310501935,1),(367679679,425502526,14499589,870814,1,'2009-03-31 00:50:57',3310501935,1),(367679681,425502340,14499873,870814,1,'2009-03-31 00:50:59',3310501935,1),(367679684,425501991,14500062,870814,1,'2009-03-31 00:51:00',3310501935,1),(367679690,425501735,14500125,870814,1,'2009-03-31 00:51:02',3310501935,1),(367679748,425500898,14500157,870814,1,'2009-03-31 00:51:15',3310501935,1),(367679754,425500247,14500030,870814,1,'2009-03-31 00:51:17',3310501935,1),(367679763,425496435,14499115,870814,1,'2009-03-31 00:51:18',3310501935,1),(367679770,425491820,14498137,870814,1,'2009-03-31 00:51:20',3310501935,1),(367679774,425487624,14497127,870814,1,'2009-03-31 00:51:22',3310501935,1),(367679778,425486880,14497001,870814,1,'2009-03-31 00:51:23',3310501935,1),(367679786,425486055,14496891,870814,1,'2009-03-31 00:51:24',3310501935,1),(367679794,425485102,14496922,870814,1,'2009-03-31 00:51:26',3310501935,1),(367679801,425476523,14497206,870814,1,'2009-03-31 00:51:27',3310501934,1),(367679813,425472513,14497459,870814,1,'2009-03-31 00:51:29',3310501934,1),(367679818,425469235,14497837,870814,1,'2009-03-31 00:51:30',3310501934,1),(367679826,425463620,14498973,870814,1,'2009-03-31 00:51:32',3310501934,1),(367679843,425455820,14501040,870814,1,'2009-03-31 00:51:37',3310501934,1),(367679850,425448648,14503375,870814,1,'2009-03-31 00:51:38',3310502017,1),(367679856,425446370,14504149,870814,1,'2009-03-31 00:51:39',3310502017,1),(367679861,425444859,14504227,870814,1,'2009-03-31 00:51:39',3310502017,1),(367679877,425443801,14503928,870814,1,'2009-03-31 00:51:42',3310502017,1),(367679892,425442894,14503486,870814,1,'2009-03-31 00:51:44',3310502017,1),(367679899,425441406,14502508,870814,1,'2009-03-31 00:51:45',3310502017,1),(367679904,425439662,14500867,870814,1,'2009-03-31 00:51:45',3310501931,1),(367679910,425438163,14499399,870814,1,'2009-03-31 00:51:46',3310501931,1),(367679915,425437442,14498847,870814,1,'2009-03-31 00:51:47',3310501931,1);
INSERT INTO `current_nodes` VALUES (367679927,425436721,14498405,870814,1,'2009-03-31 00:51:48',3310501931,1),(367679934,425435954,14497758,870814,1,'2009-03-31 00:51:49',3310501931,1),(367679939,425435431,14497064,870814,1,'2009-03-31 00:51:50',3310501931,1),(367679943,425435036,14496433,870814,1,'2009-03-31 00:51:51',3310501931,1),(367679962,425433362,14493230,870814,1,'2009-03-31 00:51:53',3310501931,1),(367679973,425432734,14491258,870814,1,'2009-03-31 00:51:53',3310501931,1),(367679979,425430769,14485136,870814,1,'2009-03-31 00:51:54',3310501931,1),(367679988,425429560,14479755,870814,1,'2009-03-31 00:51:55',3310501931,1),(367679994,425428793,14476363,870814,1,'2009-03-31 00:51:56',3310501931,1),(367680003,425428468,14475700,870814,1,'2009-03-31 00:51:57',3310501931,1),(367680016,425428026,14475085,870814,1,'2009-03-31 00:51:59',3310501931,1),(367680026,425427631,14474817,870814,1,'2009-03-31 00:52:00',3310501931,1),(367680034,425427177,14474612,870814,1,'2009-03-31 00:52:01',3310501931,1),(367680039,425426666,14474596,870814,1,'2009-03-31 00:52:01',3310501931,1),(367680045,425426224,14474817,870814,1,'2009-03-31 00:52:02',3310501931,1),(367680054,425425875,14475085,870814,1,'2009-03-31 00:52:03',3310501931,1),(367680063,425425561,14475448,870814,1,'2009-03-31 00:52:04',3310501931,1),(367680074,425425399,14476048,870814,1,'2009-03-31 00:52:04',3310501931,1),(367680085,425425364,14476631,870814,1,'2009-03-31 00:52:05',3310501931,1),(367680092,425425434,14477326,870814,1,'2009-03-31 00:52:06',3310501931,1),(367680095,425425736,14478115,870814,1,'2009-03-31 00:52:06',3310501931,1),(367680103,425426468,14479519,870814,1,'2009-03-31 00:52:07',3310501931,1),(367680112,425426852,14480323,870814,1,'2009-03-31 00:52:07',3310501931,1),(367680121,425427317,14481507,870814,1,'2009-03-31 00:52:08',3310501931,1),(367680135,425427654,14482927,870814,1,'2009-03-31 00:52:09',3310501931,1),(367680145,425427840,14484615,870814,1,'2009-03-31 00:52:11',3310501931,1),(367680154,425428096,14489143,870814,1,'2009-03-31 00:52:12',3310501931,1),(367680180,425428514,14492867,870814,1,'2009-03-31 00:52:16',3310501931,1),(367680191,425429026,14496054,870814,1,'2009-03-31 00:52:18',3310501931,1),(367680197,425430235,14501482,870814,1,'2009-03-31 00:52:19',3310501931,1),(367680206,425431664,14505868,870814,1,'2009-03-31 00:52:19',3310502017,1),(367680220,425434257,14511848,870814,1,'2009-03-31 00:52:21',3310502017,1),(367680228,425435419,14514010,870814,1,'2009-03-31 00:52:22',3310502017,1),(367680235,425437233,14516377,870814,1,'2009-03-31 00:52:23',3310502017,1),(367680239,425437965,14517734,870814,1,'2009-03-31 00:52:23',3310502017,1),(367680244,425438837,14519201,870814,1,'2009-03-31 00:52:24',3310502017,1),(367680258,425440127,14520574,870814,1,'2009-03-31 00:52:24',3310502017,1),(367680266,425440732,14521347,870814,1,'2009-03-31 00:52:25',3310502017,1),(367680270,425441278,14522688,870814,1,'2009-03-31 00:52:26',3310502017,1),(367680273,425443347,14527532,870814,1,'2009-03-31 00:52:30',3310502017,1),(367680291,425444219,14530403,870814,1,'2009-03-31 00:52:33',3310502017,1),(367680297,425445068,14532013,870814,1,'2009-03-31 00:52:34',3310502017,1),(367680427,425446637,14535342,870814,1,'2009-03-31 00:52:56',3310502017,1),(367680434,425446593,14533951,870814,1,'2009-03-31 00:52:59',3310502017,1),(367680440,425445051,14533714,870814,1,'2009-03-31 00:53:01',3310502017,1),(367680443,425444686,14535181,870814,1,'2009-03-31 00:53:01',3310502017,1),(367680445,425444368,14535699,870814,1,'2009-03-31 00:53:02',3310502017,1),(367680449,425443382,14536864,870814,1,'2009-03-31 00:53:02',3310502017,1),(367680460,425442174,14537856,870814,1,'2009-03-31 00:53:03',3310502017,1),(367680463,425441571,14538395,870814,1,'2009-03-31 00:53:04',3310502017,1),(367680466,425441110,14538503,870814,1,'2009-03-31 00:53:04',3310502017,1),(367680470,425440744,14538374,870814,1,'2009-03-31 00:53:04',3310502017,1),(367680475,425440267,14537662,870814,1,'2009-03-31 00:53:04',3310502017,1),(367680481,425439806,14537360,870814,1,'2009-03-31 00:53:05',3310502017,1),(367680486,425439266,14537317,870814,1,'2009-03-31 00:53:05',3310502017,1),(367680498,425438678,14537511,870814,1,'2009-03-31 00:53:06',3310502017,1),(367680503,425438185,14537899,870814,1,'2009-03-31 00:53:07',3310502017,1),(367680513,425437661,14538503,870814,1,'2009-03-31 00:53:08',3310502017,1),(367680522,425437375,14539150,870814,1,'2009-03-31 00:53:09',3310502017,1),(367680528,425436882,14540229,870814,1,'2009-03-31 00:53:10',3310502017,1),(367680536,425436516,14540984,870814,1,'2009-03-31 00:53:11',3310502017,1),(367680577,425436214,14542322,870814,1,'2009-03-31 00:53:17',3310502017,1),(367680583,425435785,14543508,870814,1,'2009-03-31 00:53:17',3310502017,1),(367680601,425434323,14545665,870814,1,'2009-03-31 00:53:20',3310502017,1),(367680690,425433751,14546442,870814,1,'2009-03-31 00:53:40',3310502017,1),(367680699,425433179,14546960,870814,1,'2009-03-31 00:53:41',3310502017,1),(367680708,425432400,14547348,870814,1,'2009-03-31 00:53:42',3310502017,1),(367680716,425431160,14547564,870814,1,'2009-03-31 00:53:43',3310502017,1),(367680726,425430270,14547650,870814,1,'2009-03-31 00:53:44',3310502017,1),(367680747,425429634,14547866,870814,1,'2009-03-31 00:53:46',3310502017,1),(367680753,425428426,14548535,870814,1,'2009-03-31 00:53:47',3310502017,1),(367680901,425427457,14549225,870814,1,'2009-03-31 00:53:58',3310502017,1),(367680914,425426185,14550066,870814,1,'2009-03-31 00:53:59',3310502017,1),(367680923,425424675,14550713,870814,1,'2009-03-31 00:54:00',3310502017,1),(367680933,425423261,14551102,870814,1,'2009-03-31 00:54:01',3310502016,1),(367680940,425422275,14551166,870814,1,'2009-03-31 00:54:02',3310502016,1),(367680947,425421178,14551318,870814,1,'2009-03-31 00:54:04',3310502016,1),(367680956,425419557,14551598,870814,1,'2009-03-31 00:54:05',3310502016,1),(367680960,425417618,14551749,870814,1,'2009-03-31 00:54:05',3310502016,1),(367680964,425417014,14551943,870814,1,'2009-03-31 00:54:06',3310502016,1),(367680970,425416505,14552353,870814,1,'2009-03-31 00:54:07',3310502016,1),(367680975,425415711,14553173,870814,1,'2009-03-31 00:54:07',3310502016,1),(367680978,425415361,14553518,870814,1,'2009-03-31 00:54:08',3310502016,1),(367680983,425415075,14553712,870814,1,'2009-03-31 00:54:08',3310502016,1),(367680990,425414550,14553820,870814,1,'2009-03-31 00:54:09',3310502016,1),(367681000,425413470,14554295,870814,1,'2009-03-31 00:54:10',3310502016,1),(367681004,425411626,14554877,870814,1,'2009-03-31 00:54:10',3310502016,1),(367681008,425410529,14555395,870814,1,'2009-03-31 00:54:11',3310502016,1),(367681012,425410005,14555632,870814,1,'2009-03-31 00:54:12',3310502016,1),(367681029,425409321,14556409,870814,1,'2009-03-31 00:54:18',3310502016,1),(367681033,425406619,14558523,870814,1,'2009-03-31 00:54:18',3310502018,1),(367681059,425406158,14559041,870814,1,'2009-03-31 00:54:24',3310502018,1),(367681064,425405030,14560486,870814,1,'2009-03-31 00:54:25',3310502018,1),(367681082,425403424,14563161,870814,1,'2009-03-31 00:54:32',3310502018,1),(367681083,425402645,14564196,870814,1,'2009-03-31 00:54:33',3310502018,1),(367681084,425400452,14563916,870814,1,'2009-03-31 00:54:34',3310502018,1),(367681087,425399752,14563377,870814,1,'2009-03-31 00:54:34',3310502018,1),(367681092,425398703,14562924,870814,1,'2009-03-31 00:54:35',3310502018,1),(367681096,425396891,14561759,870814,1,'2009-03-31 00:54:37',3310491095,1),(367681118,425395938,14560853,870814,1,'2009-03-31 00:54:41',3310491095,1),(367681124,425395000,14560205,870814,1,'2009-03-31 00:54:42',3310491095,1),(367681129,425394046,14559688,870814,1,'2009-03-31 00:54:42',3310491095,1),(367681130,425392775,14559019,870814,1,'2009-03-31 00:54:43',3310491095,1),(367681143,425392266,14558717,870814,1,'2009-03-31 00:54:45',3310491095,1),(367681147,425391694,14558739,870814,1,'2009-03-31 00:54:45',3310491095,1),(367681150,425390740,14558890,870814,1,'2009-03-31 00:54:46',3310491095,1),(367681156,425389198,14559041,870814,1,'2009-03-31 00:54:47',3310491095,1),(367681162,425387005,14559494,870814,1,'2009-03-31 00:54:48',3310491095,1),(367681174,425384382,14559774,870814,1,'2009-03-31 00:54:49',3310491095,1),(367681183,425383253,14559990,870814,1,'2009-03-31 00:54:50',3310491095,1),(367681190,425382745,14560270,870814,1,'2009-03-31 00:54:52',3310491095,1),(367681198,425382252,14560551,870814,1,'2009-03-31 00:54:53',3310491095,1),(367681204,425381743,14560723,870814,1,'2009-03-31 00:54:54',3310491095,1),(367681212,425380805,14560917,870814,1,'2009-03-31 00:54:54',3310491095,1),(367681216,425379566,14560788,870814,1,'2009-03-31 00:54:55',3310491095,1),(367681225,425378962,14560961,870814,1,'2009-03-31 00:54:56',3310491095,1),(367681230,425378389,14561219,870814,1,'2009-03-31 00:54:57',3310491095,1),(367681236,425377324,14561867,870814,1,'2009-03-31 00:54:57',3310491095,1),(367681256,425376927,14562233,870814,1,'2009-03-31 00:55:01',3310491095,1),(367681261,425375035,14564218,870814,1,'2009-03-31 00:55:02',3310491095,1),(367681429,425372842,14566009,870814,1,'2009-03-31 00:55:26',3310491095,1),(367681439,425370553,14567670,870814,1,'2009-03-31 00:55:27',3310491095,1),(367681447,425370092,14568015,870814,1,'2009-03-31 00:55:29',3310491095,1),(367681453,425369520,14568274,870814,1,'2009-03-31 00:55:30',3310491094,1),(367681456,425368327,14568597,870814,1,'2009-03-31 00:55:30',3310491094,1),(367681461,425367930,14568640,870814,1,'2009-03-31 00:55:31',3310491094,1),(367681465,425367437,14568576,870814,1,'2009-03-31 00:55:32',3310491094,1),(367681477,425366340,14567907,870814,1,'2009-03-31 00:55:33',3310491094,1),(367681482,425365768,14567626,870814,1,'2009-03-31 00:55:34',3310491094,1),(367681490,425365260,14567648,870814,1,'2009-03-31 00:55:35',3310491094,1),(367681497,425364656,14567777,870814,1,'2009-03-31 00:55:36',3310491094,1),(367681504,425364020,14568166,870814,1,'2009-03-31 00:55:37',3310491094,1),(367681514,425362986,14568640,870814,1,'2009-03-31 00:55:38',3310491094,1),(367681521,425361921,14569309,870814,1,'2009-03-31 00:55:38',3310491094,1),(367681533,425360618,14570301,870814,1,'2009-03-31 00:55:39',3310491094,1),(367681539,425360077,14570755,870814,1,'2009-03-31 00:55:39',3310491094,1),(367681545,425359648,14571121,870814,1,'2009-03-31 00:55:40',3310491094,1),(367681552,425359394,14571574,870814,1,'2009-03-31 00:55:40',3310491094,1),(367681555,425358949,14571919,870814,1,'2009-03-31 00:55:40',3310491094,1),(367681560,425358520,14572006,870814,1,'2009-03-31 00:55:41',3310491094,1),(367681574,425357486,14571682,870814,1,'2009-03-31 00:55:43',3310491094,1),(367681579,425356077,14571236,870814,1,'2009-03-31 00:55:43',3310491094,1),(367681584,425355505,14571167,870814,1,'2009-03-31 00:55:43',3310491094,1),(367681590,425354883,14570733,870814,1,'2009-03-31 00:55:44',3310491094,1),(367681596,425352425,14569500,870814,1,'2009-03-31 00:55:44',3310491094,1),(367681601,425351432,14568860,870814,1,'2009-03-31 00:55:45',3310491094,1),(367681607,425350810,14568655,870814,1,'2009-03-31 00:55:45',3310491094,1),(367681613,425350221,14568563,870814,1,'2009-03-31 00:55:46',3310491094,1),(367681617,425348992,14568677,870814,1,'2009-03-31 00:55:47',3310491094,1),(367681624,425348049,14568723,870814,1,'2009-03-31 00:55:47',3310491094,1),(367681630,425346434,14569203,870814,1,'2009-03-31 00:55:48',3310491094,1),(367681635,425345474,14569385,870814,1,'2009-03-31 00:55:48',3310491094,1),(367681640,425344313,14569614,870814,1,'2009-03-31 00:55:49',3310491094,1),(367681644,425343371,14569979,870814,1,'2009-03-31 00:55:49',3310491094,1),(367681647,425342866,14570413,870814,1,'2009-03-31 00:55:50',3310491094,1),(367681651,425342681,14570824,870814,1,'2009-03-31 00:55:50',3310491094,1),(367681655,425342428,14571555,870814,1,'2009-03-31 00:55:51',3310491094,1),(367681663,425342277,14572880,870814,1,'2009-03-31 00:55:52',3310491094,1),(367681671,425342226,14575667,870814,1,'2009-03-31 00:55:53',3310491094,1),(367681676,425342176,14577722,870814,1,'2009-03-31 00:55:53',3310491091,1),(367681681,425342226,14578659,870814,1,'2009-03-31 00:55:53',3310491094,1),(367681687,425342361,14579709,870814,1,'2009-03-31 00:55:54',3310491094,1),(367681691,425342411,14580760,870814,1,'2009-03-31 00:55:54',3310491094,1),(367681694,425342327,14581719,870814,1,'2009-03-31 00:55:54',3310491094,1),(367681697,425342108,14583250,870814,1,'2009-03-31 00:55:55',3310491091,1),(367681701,425341738,14584871,870814,1,'2009-03-31 00:55:55',3310491091,1),(367681708,425341351,14586036,870814,1,'2009-03-31 00:55:58',3310491091,1),(367681722,425340947,14587018,870814,1,'2009-03-31 00:56:00',3310491091,1),(367681730,425340408,14588069,870814,1,'2009-03-31 00:56:00',3310491091,1),(367681735,425339954,14588823,870814,1,'2009-03-31 00:56:02',3310491091,1),(367681739,425339415,14589622,870814,1,'2009-03-31 00:56:03',3310491091,1),(367681745,425338523,14590581,870814,1,'2009-03-31 00:56:03',3310491091,1),(367681753,425337783,14591107,870814,1,'2009-03-31 00:56:04',3310491091,1),(367681758,425336706,14591723,870814,1,'2009-03-31 00:56:04',3310491091,1),(367681766,425335679,14592157,870814,1,'2009-03-31 00:56:05',3310491091,1),(367681773,425333895,14592843,870814,1,'2009-03-31 00:56:05',3310491091,1),(367681779,425331943,14593733,870814,1,'2009-03-31 00:56:06',3310491091,1),(367681894,425330815,14594350,870814,1,'2009-03-31 00:56:22',3310491091,1),(367681900,425329502,14595355,870814,1,'2009-03-31 00:56:22',3310491091,1),(367681907,425328644,14596360,870814,1,'2009-03-31 00:56:23',3310491091,1),(367681915,425327634,14597936,870814,1,'2009-03-31 00:56:24',3310491091,1),(367681939,425327297,14598598,870814,1,'2009-03-31 00:56:25',3310491091,1),(367681946,425326826,14599329,870814,1,'2009-03-31 00:56:26',3310491091,1),(367681956,425326170,14599969,870814,1,'2009-03-31 00:56:27',3310491091,1),(367681967,425325682,14600631,870814,1,'2009-03-31 00:56:27',3310491091,1),(367681972,425324722,14601956,870814,1,'2009-03-31 00:56:27',3310491091,1),(367681980,425322837,14605199,870814,1,'2009-03-31 00:56:28',3310491091,1),(367681989,425321356,14607803,870814,1,'2009-03-31 00:56:28',3310491091,1),(367681997,425320582,14608739,870814,1,'2009-03-31 00:56:28',3310491091,1),(367682006,425320043,14609333,870814,1,'2009-03-31 00:56:29',3310491091,1),(367682014,425319404,14609904,870814,1,'2009-03-31 00:56:29',3310491091,1),(367682022,425318394,14610475,870814,1,'2009-03-31 00:56:29',3310491091,1),(367682032,425317771,14610704,870814,1,'2009-03-31 00:56:30',3310491091,1),(367682040,425316037,14611092,870814,1,'2009-03-31 00:56:30',3310491091,1),(367682054,425314842,14611389,870814,1,'2009-03-31 00:56:33',3310491091,1),(367682060,425313917,14611846,870814,1,'2009-03-31 00:56:34',3310491090,1),(367682068,425311931,14613170,870814,1,'2009-03-31 00:56:34',3310491096,1),(367682073,425309860,14614244,870814,1,'2009-03-31 00:56:34',3310491096,1),(367682101,425308110,14615295,870814,1,'2009-03-31 00:56:36',3310491096,1),(367682111,425307083,14616163,870814,1,'2009-03-31 00:56:37',3310491096,1),(367682123,425306418,14616824,870814,1,'2009-03-31 00:56:38',3310491096,1),(367682130,425305332,14618051,870814,1,'2009-03-31 00:56:38',3310491096,1),(367682139,425304273,14619177,870814,1,'2009-03-31 00:56:39',3310491096,1),(367682148,425303193,14620229,870814,1,'2009-03-31 00:56:39',3310491096,1),(367682156,425302890,14620605,870814,1,'2009-03-31 00:56:40',3310491096,1),(367682164,425302633,14621071,870814,1,'2009-03-31 00:56:40',3310491096,1),(367682172,425302175,14622033,870814,1,'2009-03-31 00:56:41',3310491096,1),(367682183,425301669,14623195,870814,1,'2009-03-31 00:56:42',3310491096,1),(367682193,425300879,14624742,870814,1,'2009-03-31 00:56:42',3310491096,1),(367682230,425300718,14625053,870814,1,'2009-03-31 00:56:44',3310491096,1),(367682241,425300495,14625365,870814,1,'2009-03-31 00:56:44',3310491096,1),(367682252,425300151,14625694,870814,1,'2009-03-31 00:56:44',3310491096,1),(367682263,425299949,14626024,870814,1,'2009-03-31 00:56:45',3310491096,1),(367682269,425299355,14627204,870814,1,'2009-03-31 00:56:45',3310491096,1),(367682279,425298606,14629044,870814,1,'2009-03-31 00:56:45',3310491096,1),(367682505,425298343,14629786,870814,1,'2009-03-31 00:56:56',3310491096,1),(367682512,425298147,14630216,870814,1,'2009-03-31 00:56:57',3310491096,1),(367682529,425297399,14631415,870814,1,'2009-03-31 00:56:57',3310491096,1),(367682541,425293587,14637274,870814,1,'2009-03-31 00:56:58',3310491096,1),(367682547,425292623,14638711,870814,1,'2009-03-31 00:56:58',3310491096,1),(367682550,425292488,14638949,870814,1,'2009-03-31 00:56:58',3310491096,1),(367682554,425291955,14640120,870814,1,'2009-03-31 00:56:58',3310491096,1),(367682560,425291577,14641091,870814,1,'2009-03-31 00:56:59',3310491096,1),(367682567,425291449,14641539,870814,1,'2009-03-31 00:56:59',3310491096,1),(367682571,425290565,14645485,870814,1,'2009-03-31 00:56:59',3310491096,1),(367682574,425290329,14646281,870814,1,'2009-03-31 00:56:59',3310491096,1),(367682578,425290073,14647105,870814,1,'2009-03-31 00:57:00',3310491096,1),(367682582,425288919,14649814,870814,1,'2009-03-31 00:57:00',3310491096,1),(367682587,425288015,14651929,870814,1,'2009-03-31 00:57:00',3310491096,1),(367682591,425286882,14655142,870814,1,'2009-03-31 00:57:00',3310491085,1),(367682595,425286788,14655535,870814,1,'2009-03-31 00:57:01',3310491085,1),(367682600,425286653,14656240,870814,1,'2009-03-31 00:57:02',3310491085,1),(367682607,425286552,14657568,870814,1,'2009-03-31 00:57:02',3310491085,1),(367682612,425286525,14658602,870814,1,'2009-03-31 00:57:02',3310491085,1),(367682618,425286464,14659288,870814,1,'2009-03-31 00:57:03',3310491085,1),(367682624,425286342,14660030,870814,1,'2009-03-31 00:57:03',3310491085,1),(367682629,425286127,14660900,870814,1,'2009-03-31 00:57:03',3310491085,1),(367682636,425285911,14661559,870814,1,'2009-03-31 00:57:03',3310491085,1),(367682639,425285506,14662428,870814,1,'2009-03-31 00:57:04',3310491085,1),(367682645,425282781,14667060,870814,1,'2009-03-31 00:57:04',3310491087,1),(367682650,425282551,14667463,870814,1,'2009-03-31 00:57:04',3310491087,1),(367682653,425282201,14668360,870814,1,'2009-03-31 00:57:05',3310491087,1),(367682657,425282072,14668671,870814,1,'2009-03-31 00:57:05',3310491087,1),(367682670,425281971,14668982,870814,1,'2009-03-31 00:57:07',3310491087,1),(367682675,425281917,14669358,870814,1,'2009-03-31 00:57:07',3310491087,1),(367682678,425281843,14670136,870814,1,'2009-03-31 00:57:08',3310491087,1),(367682684,425281877,14670419,870814,1,'2009-03-31 00:57:08',3310491087,1),(367682688,425282005,14670767,870814,1,'2009-03-31 00:57:08',3310491087,1),(367682691,425282201,14671298,870814,1,'2009-03-31 00:57:08',3310491087,1),(367682694,425282369,14671930,870814,1,'2009-03-31 00:57:09',3310491087,1),(367682698,425282679,14673513,870814,1,'2009-03-31 00:57:09',3310491087,1),(367682700,425282929,14675326,870814,1,'2009-03-31 00:57:09',3310491087,1),(367682704,425283583,14680324,870814,1,'2009-03-31 00:57:09',3310491087,1),(367682708,425283698,14681660,870814,1,'2009-03-31 00:57:09',3310491087,1),(367682711,425283786,14684324,870814,1,'2009-03-31 00:57:10',3310491087,1),(367682716,425283894,14686503,870814,1,'2009-03-31 00:57:10',3310491087,1),(367682724,425284157,14688535,870814,1,'2009-03-31 00:57:10',3310491087,1),(367682732,425284589,14690787,870814,1,'2009-03-31 00:57:10',3310491087,1),(367682739,425285452,14693478,870814,1,'2009-03-31 00:57:11',3310491087,1),(367682743,425286464,14695940,870814,1,'2009-03-31 00:57:12',3310491087,1),(367682748,425288521,14700462,870814,1,'2009-03-31 00:57:12',3310491098,1),(367682754,425289290,14702439,870814,1,'2009-03-31 00:57:13',3310491098,1),(367682760,425289844,14704234,870814,1,'2009-03-31 00:57:13',3310491098,1),(367682767,425290376,14706861,870814,1,'2009-03-31 00:57:13',3310491098,1),(367682772,425290768,14709323,870814,1,'2009-03-31 00:57:14',3310491098,1),(367682777,425291496,14712637,870814,1,'2009-03-31 00:57:14',3310491098,1),(367682784,425292259,14715099,870814,1,'2009-03-31 00:57:15',3310491098,1),(367682789,425293034,14717195,870814,1,'2009-03-31 00:57:15',3310491098,1),(367682795,425296616,14724152,870814,1,'2009-03-31 00:57:15',3310491120,1),(367682800,425297405,14725965,870814,1,'2009-03-31 00:57:16',3310491120,1),(367682806,425298282,14728647,870814,1,'2009-03-31 00:57:17',3310491120,1),(367682813,425298856,14730844,870814,1,'2009-03-31 00:57:18',3310491120,1),(367682819,425299982,14734780,870814,1,'2009-03-31 00:57:18',3310491120,1),(367682825,425301399,14739119,870814,1,'2009-03-31 00:57:18',3310491120,1),(367682830,425302242,14741215,870814,1,'2009-03-31 00:57:19',3310491120,1),(367682837,425302998,14742570,870814,1,'2009-03-31 00:57:20',3310491120,1),(367682842,425305136,14745444,870814,1,'2009-03-31 00:57:21',3310491120,1),(367682845,425305804,14746469,870814,1,'2009-03-31 00:57:22',3310491120,1),(367682852,425306451,14747815,870814,1,'2009-03-31 00:57:22',3310491120,1),(367682859,425307031,14749353,870814,1,'2009-03-31 00:57:23',3310491120,1),(367682865,425308003,14751733,870814,1,'2009-03-31 00:57:23',3310491120,1),(367682873,425309008,14753829,870814,1,'2009-03-31 00:57:23',3310491120,1),(367682879,425311220,14757957,870814,1,'2009-03-31 00:57:24',3310491120,1),(367682885,425311564,14758799,870814,1,'2009-03-31 00:57:24',3310491120,1),(367682891,425311801,14759532,870814,1,'2009-03-31 00:57:24',3310491120,1),(367682900,425311989,14760429,870814,1,'2009-03-31 00:57:25',3310491120,1),(367682906,425312354,14762690,870814,1,'2009-03-31 00:57:25',3310491120,1),(367682911,425312860,14766104,870814,1,'2009-03-31 00:57:25',3310491120,1),(367682916,425313588,14769765,870814,1,'2009-03-31 00:57:26',3310491120,1),(367682920,425315248,14777885,870814,1,'2009-03-31 00:57:26',3310491123,1),(367682927,425315990,14781537,870814,1,'2009-03-31 00:57:27',3310491123,1),(367682932,425316273,14782544,870814,1,'2009-03-31 00:57:28',3310491123,1),(367682940,425316900,14784247,870814,1,'2009-03-31 00:57:28',3310491123,1),(367682947,425317467,14785721,870814,1,'2009-03-31 00:57:29',3310491123,1),(367682953,425317777,14786709,870814,1,'2009-03-31 00:57:29',3310491123,1),(367682961,425318013,14787588,870814,1,'2009-03-31 00:57:30',3310491123,1),(367682968,425318141,14788366,870814,1,'2009-03-31 00:57:31',3310491123,1),(367682978,425318724,14793612,870814,1,'2009-03-31 00:57:32',3310491123,1),(367682985,425318891,14795038,870814,1,'2009-03-31 00:57:32',3310491123,1),(367682989,425319152,14796565,870814,1,'2009-03-31 00:57:33',3310491123,1),(367682996,425319487,14797991,870814,1,'2009-03-31 00:57:33',3310491123,1),(367683000,425320249,14800817,870814,1,'2009-03-31 00:57:34',3310491123,1),(367683005,425320919,14803114,870814,1,'2009-03-31 00:57:34',3310491123,1),(367683011,425321942,14807102,870814,1,'2009-03-31 00:57:34',3310491123,1),(367683017,425322286,14808742,870814,1,'2009-03-31 00:57:35',3310491123,1),(367683026,425323039,14812288,870814,1,'2009-03-31 00:57:35',3310491123,1),(367683034,425323941,14815986,870814,1,'2009-03-31 00:57:37',3310491123,1),(367683042,425325168,14821702,870814,1,'2009-03-31 00:57:37',3310491123,1),(367683051,425325838,14824718,870814,1,'2009-03-31 00:57:38',3310491123,1),(367683060,425326619,14828946,870814,1,'2009-03-31 00:57:38',3310491123,1),(367683065,425327372,14833994,870814,1,'2009-03-31 00:57:39',3310491129,1),(367683069,425327465,14834675,870814,1,'2009-03-31 00:57:39',3310491129,1),(367683074,425327763,14835306,870814,1,'2009-03-31 00:57:39',3310491129,1),(367683080,425328051,14835874,870814,1,'2009-03-31 00:57:40',3310491129,1),(367683084,425328302,14836783,870814,1,'2009-03-31 00:57:40',3310491129,1),(367683091,425329706,14841868,870814,1,'2009-03-31 00:57:40',3310491129,1),(367683097,425330766,14845187,870814,1,'2009-03-31 00:57:41',3310491129,1),(367683102,425331185,14846310,870814,1,'2009-03-31 00:57:42',3310491129,1),(367683107,425332040,14848001,870814,1,'2009-03-31 00:57:42',3310491129,1),(367683114,425333128,14849680,870814,1,'2009-03-31 00:57:42',3310491129,1),(367683120,425334607,14851396,870814,1,'2009-03-31 00:57:43',3310491129,1),(367683128,425336876,14853390,870814,1,'2009-03-31 00:57:43',3310491129,1),(367683134,425338103,14854551,870814,1,'2009-03-31 00:57:43',3310491129,1),(367683139,425339349,14856027,870814,1,'2009-03-31 00:57:44',3310491129,1),(367683144,425340940,14858147,870814,1,'2009-03-31 00:57:44',3310491129,1),(367683147,425341962,14859977,870814,1,'2009-03-31 00:57:44',3310491129,1),(367683155,425342837,14861933,870814,1,'2009-03-31 00:57:45',3310491132,1),(367683161,425344817,14867485,870814,1,'2009-03-31 00:57:45',3310491132,1),(367683168,425346119,14870817,870814,1,'2009-03-31 00:57:45',3310491132,1),(367683176,425346398,14871902,870814,1,'2009-03-31 00:57:45',3310491132,1),(367683182,425346547,14872950,870814,1,'2009-03-31 00:57:46',3310491132,1),(367683188,425346621,14874615,870814,1,'2009-03-31 00:57:47',3310491132,1),(367683198,425346723,14879070,870814,1,'2009-03-31 00:57:47',3310491132,1),(367683208,425346863,14880799,870814,1,'2009-03-31 00:57:48',3310491132,1),(367683212,425347486,14886591,870814,1,'2009-03-31 00:57:48',3310491132,1),(367683222,425348165,14896561,870814,1,'2009-03-31 00:57:48',3310491134,1),(367683232,425348304,14897747,870814,1,'2009-03-31 00:57:48',3310491134,1),(367683242,425348453,14898327,870814,1,'2009-03-31 00:57:49',3310491134,1),(367683249,425349206,14899728,870814,1,'2009-03-31 00:57:49',3310491134,1),(367683260,425349597,14900574,870814,1,'2009-03-31 00:57:50',3310491134,1),(367683266,425349876,14901381,870814,1,'2009-03-31 00:57:50',3310491134,1),(367683274,425350118,14902151,870814,1,'2009-03-31 00:57:51',3310491134,1),(367683286,425350285,14902807,870814,1,'2009-03-31 00:57:52',3310491134,1),(367683291,425350378,14903539,870814,1,'2009-03-31 00:57:52',3310491134,1),(367683298,425350434,14904372,870814,1,'2009-03-31 00:57:53',3310491134,1),(367683303,425350545,14905773,870814,1,'2009-03-31 00:57:53',3310491134,1),(367683309,425350806,14906883,870814,1,'2009-03-31 00:57:53',3310491134,1),(367683318,425351289,14908006,870814,1,'2009-03-31 00:57:54',3310491134,1),(367683330,425352926,14910972,870814,1,'2009-03-31 00:57:55',3310491134,1),(367683340,425353800,14912133,870814,1,'2009-03-31 00:57:56',3310491134,1),(367683346,425357547,14915856,870814,1,'2009-03-31 00:57:56',3310491134,1),(367683352,425361313,14919023,870814,1,'2009-03-31 00:57:56',3310491134,1),(367683359,425364521,14922266,870814,1,'2009-03-31 00:57:57',3310491134,1),(367683366,425366111,14923806,870814,1,'2009-03-31 00:57:57',3310491134,1),(367683372,425445480,14532766,870814,1,'2009-03-31 00:57:58',3310502017,1),(368207292,424540415,14648527,27626,1,'2009-04-01 15:29:25',3310490760,2),(368207293,424540479,14644063,27626,1,'2009-04-01 15:29:25',3310490760,2),(368207294,424540922,14639171,27626,1,'2009-04-01 15:29:25',3310490760,2),(368207295,424540289,14632391,27626,1,'2009-04-01 15:29:25',3310490760,2),(368207296,424539465,14627412,27626,1,'2009-04-01 15:29:25',3310490760,2),(368207297,424537502,14624666,27626,1,'2009-04-01 15:29:26',3310490760,2),(368207298,424535096,14623035,27626,1,'2009-04-01 15:29:26',3310490760,2),(368207299,424530916,14621748,27626,1,'2009-04-01 15:29:26',3310490760,2),(368207300,424529143,14621919,27626,1,'2009-04-01 15:29:26',3310490760,2),(368207301,424527243,14623035,27626,1,'2009-04-01 15:29:26',3310490760,2),(368207302,424525660,14623807,27626,1,'2009-04-01 15:29:26',3310490760,2),(368207303,424523950,14623378,27626,1,'2009-04-01 15:29:26',3310490760,2),(368207305,424521733,14623292,27626,1,'2009-04-01 15:29:26',3310490760,2),(368207306,424521164,14624322,27626,1,'2009-04-01 15:29:26',3310490760,2),(368212962,424447015,15305761,27626,1,'2009-04-01 16:02:27',3310490489,1),(368212966,424447649,15305761,27626,1,'2009-04-01 16:02:27',3310490489,1),(368212967,424448092,15306534,27626,1,'2009-04-01 16:02:27',3310490489,1),(370003141,425345681,15204993,226881,1,'2009-04-05 17:13:03',3310491508,5),(370003845,425343240,15215388,327248,1,'2009-04-08 23:30:37',3310491508,5),(370003846,425343999,15213929,226881,1,'2009-04-05 17:11:58',3310491508,3),(370003848,425344758,15212040,226881,1,'2009-04-05 17:11:58',3310491508,3),(370003849,425345264,15209723,226881,1,'2009-04-05 17:11:58',3310491508,3),(370003853,425345580,15207491,226881,1,'2009-04-05 17:11:58',3310491508,4),(370902435,425357261,15320483,327248,1,'2009-04-08 23:11:52',3310491516,1),(370902436,425357957,15323058,327248,1,'2009-04-08 23:18:51',3310491516,7),(370902438,425359095,15324259,327248,1,'2009-04-08 23:18:51',3310491516,7),(370903026,425365230,15320740,327248,1,'2009-04-08 23:14:40',3310491516,2),(370903027,425363712,15318938,327248,1,'2009-04-08 23:14:40',3310491516,2),(370903028,425362700,15317565,327248,1,'2009-04-08 23:14:40',3310491516,2),(370903029,425361688,15316191,327248,1,'2009-04-08 23:14:40',3310491516,2),(370903030,425360929,15314646,327248,1,'2009-04-08 23:14:06',3310491516,1),(370903788,425368202,15316363,327248,1,'2009-04-08 23:16:00',3310491516,1),(370903791,425367127,15314990,327248,1,'2009-04-08 23:16:00',3310491516,1),(370903794,425365989,15313616,327248,1,'2009-04-08 23:16:01',3310491516,1),(370903796,425364661,15312072,327248,1,'2009-04-08 23:16:01',3310491516,1),(370904235,425377689,15321856,327248,1,'2009-04-08 23:18:53',3310491517,2),(370904334,425379143,15321685,327248,1,'2009-04-08 23:18:01',3310491517,1),(370904336,425380092,15322629,327248,1,'2009-04-08 23:18:01',3310491517,1),(370904339,425380851,15323830,327248,1,'2009-04-08 23:18:02',3310491517,1),(370904341,425381167,15325032,327248,1,'2009-04-08 23:18:02',3310491517,1),(370906892,425324573,15274223,327248,1,'2009-04-08 23:29:58',3310491513,5),(370908030,425327419,15272678,327248,1,'2009-04-08 23:29:58',3310491513,2),(370908032,425330391,15270962,327248,1,'2009-04-08 23:29:59',3310491507,2),(370908035,425336147,15267529,327248,1,'2009-04-08 23:29:59',3310491507,2),(370909129,425348101,15262035,327248,1,'2009-04-08 23:29:59',3310491510,1),(370909130,425349112,15262550,327248,1,'2009-04-08 23:29:59',3310491510,1),(370909276,425349573,15261501,327248,1,'2009-04-08 23:30:40',3310491510,2),(370909282,425348400,15247200,327248,1,'2009-04-08 23:30:39',3310491510,1),(370909283,425348800,15247130,327248,1,'2009-04-08 23:30:39',3310491510,1),(370909284,425349880,15247900,327248,1,'2009-04-08 23:30:40',3310491510,1),(370909285,425350400,15249120,327248,1,'2009-04-08 23:30:40',3310491510,1),(370909286,425350350,15255420,327248,1,'2009-04-08 23:30:40',3310491510,1),(370909287,425349920,15259930,327248,1,'2009-04-08 23:30:40',3310491510,1),(370909951,425349998,15253195,327248,1,'2009-04-08 23:32:51',3310491510,1),(370909953,425348480,15253023,327248,1,'2009-04-08 23:32:51',3310491510,1),(370909956,425348354,15255255,327248,1,'2009-04-08 23:32:51',3310491510,1),(370909959,425349808,15255426,327248,1,'2009-04-08 23:32:52',3310491510,1),(370911870,425349808,15245899,1111251,1,'2009-05-08 00:02:40',3310491510,2),(371357928,424445692,14928518,372139,1,'2009-04-10 12:07:13',3310490107,4),(371358341,424355080,15172080,372139,1,'2009-04-10 12:07:10',3310490468,2),(371358401,424364950,15002350,372139,1,'2009-04-10 12:07:11',3310490438,2),(371358405,424370310,15001270,372139,1,'2009-04-10 12:07:11',3310490438,2),(371358406,424384050,14995690,372139,1,'2009-04-10 12:07:11',3310490437,2),(371358407,424386410,14995910,372139,1,'2009-04-10 12:07:11',3310490437,2),(371358408,424389200,14994620,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358409,424391980,14992480,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358410,424394560,14989470,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358411,424396060,14985820,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358412,424399920,14981320,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358413,424399920,14980460,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358414,424398420,14979170,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358415,424398210,14977880,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358416,424402710,14975950,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358419,424403360,14969300,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358420,424404220,14969300,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358421,424404220,14967370,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358422,424403140,14966300,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358423,424404220,14961150,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358424,424404000,14957070,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358425,424405500,14953420,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358426,424407430,14951280,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358429,424415160,14946340,372139,1,'2009-04-10 12:07:12',3310490448,2),(371358430,424421810,14943550,372139,1,'2009-04-10 12:07:12',3310490448,2),(371358431,424423530,14941840,372139,1,'2009-04-10 12:07:12',3310490448,2),(371358432,424425670,14938620,372139,1,'2009-04-10 12:07:12',3310490106,2),(371358433,424426960,14937970,372139,1,'2009-04-10 12:07:12',3310490106,2),(371358434,424428250,14934750,372139,1,'2009-04-10 12:07:12',3310490106,2),(371358435,424429750,14933680,372139,1,'2009-04-10 12:07:12',3310490106,2),(371358436,424429540,14932390,372139,1,'2009-04-10 12:07:12',3310490106,2),(371358437,424429970,14931960,372139,1,'2009-04-10 12:07:12',3310490106,2),(371358439,424436830,14931320,372139,1,'2009-04-10 12:07:12',3310490107,2),(371358441,424440050,14933900,372139,1,'2009-04-10 12:07:12',3310490107,2),(371358442,424443050,14939480,372139,1,'2009-04-10 12:07:12',3310490107,2),(371358443,424444560,14940550,372139,1,'2009-04-10 12:07:12',3310490107,2),(371358444,424443910,14934750,372139,1,'2009-04-10 12:07:13',3310490107,2),(371358445,424444990,14930030,372139,1,'2009-04-10 12:07:13',3310490107,2),(385582099,425039917,15191701,981792,1,'2009-04-27 01:28:18',3310491428,1),(385582100,425040360,15194791,981792,1,'2009-04-27 01:28:18',3310491429,1),(385582101,425043524,15202516,981792,1,'2009-04-27 01:28:18',3310491429,1),(385582102,425047194,15209382,981792,1,'2009-04-27 01:28:18',3310491429,1),(385582103,425049029,15215820,981792,1,'2009-04-27 01:28:18',3310491429,1),(385582104,425051497,15215391,981792,1,'2009-04-27 01:28:18',3310491429,1),(385582105,425044979,15188955,981792,1,'2009-04-27 01:28:18',3310491429,1),(385582153,425045485,15200456,981792,1,'2009-04-27 01:30:41',3310491429,2),(385743984,425346979,15324328,986514,1,'2009-04-27 12:35:09',3310491516,1),(385743985,425349003,15325186,986514,1,'2009-04-27 12:35:09',3310491516,1),(385743986,425350647,15326473,986514,1,'2009-04-27 12:35:09',3310491518,1),(385743987,425352291,15328190,986514,1,'2009-04-27 12:35:09',3310491518,1),(385743988,425354315,15331194,986514,1,'2009-04-27 12:35:09',3310491518,1),(385743989,425356972,15336086,986514,1,'2009-04-27 12:35:09',3310491518,1),(385743990,425358300,15339605,986514,1,'2009-04-27 12:35:09',3310491518,1),(385743991,425360956,15344669,986514,1,'2009-04-27 12:35:09',3310491518,1),(385743992,425363746,15349778,1075282,1,'2009-05-04 18:27:52',3310491518,2),(385743993,425366086,15354070,1075282,1,'2009-05-04 18:28:06',3310491518,3),(390327159,425408180,15216400,1423654,1,'2009-06-04 22:58:39',3310502434,2),(390327162,425407600,15216470,1074360,1,'2009-05-04 16:59:05',3310502434,1),(390327165,425404930,15217300,1074360,1,'2009-05-04 16:59:05',3310502434,1),(390327166,425403950,15216800,1074360,1,'2009-05-04 16:59:05',3310502434,1),(390327168,425401680,15216420,1074360,1,'2009-05-04 16:59:05',3310502434,1),(390327171,425399470,15215250,1074360,1,'2009-05-04 16:59:05',3310502432,1),(390327172,425396650,15215000,1074360,1,'2009-05-04 16:59:05',3310491509,1),(390327175,425393870,15215870,1074360,1,'2009-05-04 16:59:05',3310491509,1),(390327177,425393270,15215670,1074360,1,'2009-05-04 16:59:06',3310491509,1),(390327179,425392120,15214580,1074360,1,'2009-05-04 16:59:06',3310491509,1),(390327180,425391530,15214430,1074360,1,'2009-05-04 16:59:06',3310491509,1),(390327181,425388070,15215080,1074360,1,'2009-05-04 16:59:06',3310491509,1),(390327182,425386420,15217600,1074360,1,'2009-05-04 16:59:06',3310491511,1),(390327183,425386400,15218220,1074360,1,'2009-05-04 16:59:06',3310491511,1),(390327184,425385880,15219270,1074360,1,'2009-05-04 16:59:06',3310491511,1),(390327185,425383670,15221000,1074360,1,'2009-05-04 16:59:06',3310491511,1),(390327186,425382720,15223370,1074360,1,'2009-05-04 16:59:06',3310491511,1),(390327187,425381680,15224530,1074360,1,'2009-05-04 16:59:06',3310491511,1),(390327188,425381320,15224600,1074360,1,'2009-05-04 16:59:06',3310491511,1),(390327189,425381370,15224870,1074360,1,'2009-05-04 16:59:06',3310491511,1),(390327190,425380080,15225270,1074360,1,'2009-05-04 16:59:06',3310491511,1),(390327191,425378970,15226670,1074360,1,'2009-05-04 16:59:07',3310491511,1),(390327192,425377950,15228500,1074360,1,'2009-05-04 16:59:07',3310491511,1),(390327193,425376400,15230370,1074360,1,'2009-05-04 16:59:07',3310491511,1),(390327194,425376330,15230730,1074360,1,'2009-05-04 16:59:07',3310491511,1),(390327195,425376600,15231180,1074360,1,'2009-05-04 16:59:07',3310491511,1),(390327196,425376380,15231400,1074360,1,'2009-05-04 16:59:07',3310491511,1),(390327197,425376200,15232450,1074360,1,'2009-05-04 16:59:07',3310491511,1),(390327198,425375250,15233670,1074360,1,'2009-05-04 16:59:07',3310491511,1),(390327199,425374330,15236370,1074360,1,'2009-05-04 16:59:07',3310491511,1),(390327200,425374230,15237250,1074360,1,'2009-05-04 16:59:07',3310491511,1),(390327202,425374500,15238280,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327204,425374120,15239420,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327205,425374200,15240250,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327207,425373930,15240620,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327208,425373530,15242480,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327210,425373250,15242700,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327212,425374200,15246100,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327214,425374380,15247850,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327215,425374180,15248780,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327217,425374250,15250200,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327219,425371930,15253250,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327220,425371700,15252630,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327222,425371950,15251250,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327223,425371820,15250750,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327224,425371030,15251380,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327225,425370670,15250780,1074360,1,'2009-05-04 16:59:09',3310491511,1),(390327227,425370030,15250750,1074360,1,'2009-05-04 16:59:09',3310491511,1),(390327229,425370070,15250070,1074360,1,'2009-05-04 16:59:09',3310491511,1),(390327231,425369770,15249850,1074360,1,'2009-05-04 16:59:09',3310491511,1),(390327232,425369350,15249720,1074360,1,'2009-05-04 16:59:09',3310491510,1),(390327233,425369100,15250100,1074360,1,'2009-05-04 16:59:09',3310491510,1),(390327234,425368450,15250220,1074360,1,'2009-05-04 16:59:09',3310491510,1),(390327236,425368630,15250000,1074360,1,'2009-05-04 16:59:09',3310491510,1),(390336072,425350020,15236670,1074615,1,'2009-05-04 17:28:49',3310491510,1),(390336073,425348050,15237315,1074615,1,'2009-05-04 17:28:49',3310491510,1),(390336447,425350220,15246570,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336448,425350430,15245770,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336449,425350270,15244250,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336450,425349430,15242500,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336451,425349100,15240550,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336452,425349230,15237100,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336453,425351850,15237850,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336454,425353430,15239700,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336455,425353650,15240070,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336456,425354470,15244180,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336457,425354870,15245130,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336458,425355770,15246070,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336459,425356180,15245670,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336460,425355820,15244630,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336461,425355880,15243280,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336462,425355670,15242470,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336463,425355670,15241920,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336464,425355900,15241570,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336465,425356130,15241600,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336466,425356580,15242400,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336467,425356980,15242070,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336468,425357470,15242080,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336469,425357480,15242480,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336470,425358880,15243200,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336471,425359080,15243980,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336472,425359670,15243730,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336473,425360370,15244430,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336474,425360970,15243800,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336475,425361020,15243130,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336476,425361600,15243870,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336477,425363020,15244600,1074615,1,'2009-05-04 17:29:53',3310491510,1),(390336479,425363380,15245370,1074615,1,'2009-05-04 17:29:53',3310491510,1),(390336481,425363830,15245730,1074615,1,'2009-05-04 17:29:53',3310491510,1),(390336483,425364070,15246380,1074615,1,'2009-05-04 17:29:53',3310491510,1),(390336485,425364100,15247480,1074615,1,'2009-05-04 17:29:53',3310491510,1),(390336487,425364700,15248300,1074615,1,'2009-05-04 17:29:53',3310491510,1),(390336489,425365520,15248280,1074615,1,'2009-05-04 17:29:53',3310491510,1),(390336491,425367450,15249930,1074615,1,'2009-05-04 17:29:53',3310491510,1),(390336493,425367620,15249850,1074615,1,'2009-05-04 17:29:53',3310491510,1),(390336494,425367970,15251050,1074615,1,'2009-05-04 17:29:53',3310491510,1),(390336495,425368330,15250950,1074615,1,'2009-05-04 17:29:53',3310491510,1),(390336730,425363258,15231766,1074615,1,'2009-05-04 17:32:19',3310491510,1),(390336731,425363827,15234341,1074615,1,'2009-05-04 17:32:19',3310491510,1),(390336732,425365724,15240521,1074615,1,'2009-05-04 17:32:19',3310491510,1),(390336733,425366989,15244727,1074615,1,'2009-05-04 17:32:19',3310491510,1),(390336734,425367938,15249448,1074615,1,'2009-05-04 17:32:19',3310491510,1),(390336735,425368760,15253052,1074615,1,'2009-05-04 17:32:19',3310491510,1),(390336737,425370910,15260005,1074615,1,'2009-05-04 17:32:19',3310491511,1),(390336738,425372491,15264296,1074615,1,'2009-05-04 17:32:19',3310491511,1),(390336740,425372997,15267987,1074615,1,'2009-05-04 17:32:19',3310491511,1),(390336742,425372997,15273137,1074615,1,'2009-05-04 17:32:19',3310491517,1),(390336745,425373946,15277342,1074615,1,'2009-05-04 17:32:20',3310491517,1),(390336747,425376286,15284037,1074615,1,'2009-05-04 17:32:20',3310491517,1),(390336748,425376475,15286355,1074615,1,'2009-05-04 17:32:20',3310491517,1),(390336750,425377551,15292363,1074615,1,'2009-05-04 17:32:20',3310491517,1),(390336752,425380333,15297513,1074615,1,'2009-05-04 17:32:20',3310491517,1),(390336754,425381788,15300688,1074615,1,'2009-05-04 17:33:50',3310491517,2),(390336755,425383812,15304036,1074615,1,'2009-05-04 17:33:50',3310491517,2),(390336757,425386215,15307727,1074615,1,'2009-05-04 17:32:20',3310491517,1),(390336904,425362881,15231090,1074615,1,'2009-05-04 17:33:11',3310491510,1),(390337187,425382104,15301890,1074615,1,'2009-05-04 17:34:16',3310491517,1),(390346965,425326370,15287980,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346966,425326000,15287670,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346967,425325500,15287750,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346968,425324470,15288550,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346969,425324370,15288870,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346970,425324080,15288830,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346971,425324830,15286750,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346972,425326100,15284720,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346973,425326500,15284870,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346974,425327250,15284350,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346975,425331250,15280370,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346976,425332050,15279900,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346977,425333630,15275920,1074995,1,'2009-05-04 18:02:13',3310491513,1),(390346978,425334420,15274250,1074995,1,'2009-05-04 18:02:13',3310491513,1),(390346979,425334920,15273700,1074995,1,'2009-05-04 18:02:13',3310491513,1),(390346980,425335103,15272377,1074995,1,'2009-05-04 18:02:13',3310491513,1),(390351766,425331946,15291605,1075171,1,'2009-05-04 18:16:08',3310491513,1),(390351767,425330238,15291862,1075171,1,'2009-05-04 18:16:08',3310491513,1),(390351768,425328594,15292120,1075171,1,'2009-05-04 18:16:08',3310491513,1),(390351769,425327645,15291777,1075171,1,'2009-05-04 18:16:08',3310491513,1),(390351770,425328214,15290403,1075171,1,'2009-05-04 18:16:08',3310491513,1),(390351771,425328341,15289802,1075171,1,'2009-05-04 18:16:08',3310491513,1),(390351772,425327961,15289545,1075171,1,'2009-05-04 18:16:09',3310491513,1),(390351773,425326380,15290832,1075171,1,'2009-05-04 18:16:09',3310491513,1),(390351774,425325370,15291030,1075171,1,'2009-05-04 18:16:09',3310491513,1),(390351775,425325495,15289631,1075171,1,'2009-05-04 18:16:09',3310491513,1),(390351776,425326127,15288601,1075171,1,'2009-05-04 18:16:09',3310491513,1),(390353660,425343844,15281944,1075235,1,'2009-05-04 18:23:50',3310491516,1),(390353661,425344600,15282870,1075235,1,'2009-05-04 18:23:50',3310491516,1),(390353662,425344856,15283832,1075235,1,'2009-05-04 18:23:50',3310491516,1),(390353663,425343908,15284347,1075235,1,'2009-05-04 18:23:50',3310491516,1),(390353664,425342200,15284200,1075235,1,'2009-05-04 18:23:50',3310491516,1),(390353665,425340935,15285377,1075235,1,'2009-05-04 18:23:50',3310491513,1),(390353666,425339900,15287000,1075235,1,'2009-05-04 18:23:50',3310491513,1),(390353667,425339607,15288038,1075235,1,'2009-05-04 18:23:50',3310491513,1),(390353668,425339986,15288553,1075235,1,'2009-05-04 18:23:50',3310491513,1),(390353669,425340998,15288896,1075235,1,'2009-05-04 18:23:50',3310491513,1),(390353670,425341579,15289787,1075235,1,'2009-05-04 18:23:50',3310491513,1),(390353671,425343030,15293980,1075235,1,'2009-05-04 18:23:51',3310491516,1),(390353672,425343830,15297870,1075235,1,'2009-05-04 18:23:51',3310491516,1),(390353673,425346180,15301130,1075235,1,'2009-05-04 18:23:51',3310491516,1),(390353674,425350250,15311350,1075235,1,'2009-05-04 18:23:51',3310491516,1),(390353675,425350430,15316570,1075235,1,'2009-05-04 18:23:51',3310491516,1),(390353676,425351170,15320480,1075235,1,'2009-05-04 18:23:51',3310491516,1),(390353677,425354150,15324270,1075235,1,'2009-05-04 18:23:51',3310491516,1),(390356561,425355082,15325660,1075282,1,'2009-05-04 18:32:03',3310491516,1),(390356562,425355670,15326470,1075282,1,'2009-05-04 18:32:03',3310491518,1),(390356563,425355880,15327230,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356564,425356650,15328300,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356565,425357850,15328870,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356566,425359730,15329150,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356567,425360520,15329650,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356568,425361420,15330770,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356569,425362870,15334100,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356570,425363380,15334620,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356571,425364070,15339900,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356572,425364430,15341220,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356573,425365380,15342850,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356574,425366580,15345730,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356575,425366870,15346980,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356576,425366970,15350650,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356578,425365897,15356387,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356579,425365833,15361022,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390361836,425429500,15228780,1075389,1,'2009-05-04 18:49:12',3310502435,1),(390361837,425429930,15227180,1075389,1,'2009-05-04 18:49:12',3310502435,1),(390361838,425431630,15223530,1075389,1,'2009-05-04 18:49:12',3310502435,1),(390361839,425432080,15221950,1075389,1,'2009-05-04 18:49:12',3310502435,1),(390361840,425433550,15220450,1075389,1,'2009-05-04 18:49:12',3310502435,1),(394815197,424488770,14909350,1165813,1,'2009-05-12 19:59:07',3310490110,2),(394815198,424491780,14916430,1165813,1,'2009-05-12 19:59:07',3310490111,2),(394815199,424493980,14919480,1165813,1,'2009-05-12 19:59:07',3310490111,2),(394815200,424497293,14920929,1165813,1,'2009-05-12 19:59:07',3310490111,2),(394816282,424511070,14945388,1165753,1,'2009-05-12 19:56:36',3310490453,1),(394816283,424509350,14944620,1165753,1,'2009-05-12 19:56:36',3310490453,1),(394816284,424507450,14943270,1165753,1,'2009-05-12 19:56:36',3310490453,1),(394816285,424504680,14938300,1165753,1,'2009-05-12 19:56:36',3310490111,1),(394816286,424503430,14934770,1165753,1,'2009-05-12 19:56:36',3310490111,1),(394816287,424502140,14927706,1165753,1,'2009-05-12 19:56:36',3310490111,1),(394816288,424501180,14924180,1165753,1,'2009-05-12 19:56:36',3310490111,1),(394816289,424500480,14922700,1165753,1,'2009-05-12 19:56:36',3310490111,1),(394816290,424499607,14921956,1165753,1,'2009-05-12 19:56:36',3310490111,1),(394816825,424497800,14921358,1165813,1,'2009-05-12 20:00:45',3310490111,1),(394816826,424497800,14921959,1165813,1,'2009-05-12 20:00:45',3310490111,1),(394816827,424497420,14922302,1165813,1,'2009-05-12 20:00:45',3310490111,1),(394816828,424496787,14922045,1165813,1,'2009-05-12 20:00:45',3310490111,1),(394816829,424496217,14921616,1165813,1,'2009-05-12 20:00:45',3310490111,1),(394816830,424495280,14921350,1165813,1,'2009-05-12 20:00:45',3310490111,1),(394816831,424492000,14920220,1165813,1,'2009-05-12 20:00:45',3310490111,1),(394816832,424489007,14916125,1166143,1,'2009-05-12 20:31:07',3310490110,2),(394820721,424485330,14913675,1166091,1,'2009-05-12 20:25:27',3310490110,1),(394820722,424486790,14914837,1166143,1,'2009-05-12 20:29:55',3310490110,2),(394820724,424486977,14919168,1166091,1,'2009-05-12 20:25:38',3310490110,1),(394820725,424482480,14915048,1166091,1,'2009-05-12 20:25:38',3310490110,1),(394820726,424481930,14913770,1166091,1,'2009-05-12 20:25:38',3310490110,1),(394820727,424482150,14912550,1166091,1,'2009-05-12 20:25:38',3310490110,1),(394820728,424483120,14912220,1166091,1,'2009-05-12 20:25:38',3310490110,1),(394820729,424483920,14912250,1166091,1,'2009-05-12 20:25:38',3310490110,1),(394822862,424487930,14915953,1166143,1,'2009-05-12 20:29:55',3310490110,1),(394823920,424489941,14917998,1166143,1,'2009-05-12 20:31:07',3310490110,1),(394823921,424488500,14915524,1166143,1,'2009-05-12 20:31:07',3310490110,1),(394823922,424488373,14917584,1166143,1,'2009-05-12 20:31:07',3310490110,1),(394823923,424489197,14918442,1166143,1,'2009-05-12 20:31:07',3310490110,1),(394823924,424490820,14921870,1166143,1,'2009-05-12 20:31:07',3310490111,1),(394823925,424496200,14925570,1166143,1,'2009-05-12 20:31:07',3310490111,1),(394823926,424497250,14927020,1166143,1,'2009-05-12 20:31:07',3310490111,1),(394823927,424498980,14932080,1166143,1,'2009-05-12 20:31:07',3310490111,1),(394823928,424499950,14940050,1166143,1,'2009-05-12 20:31:07',3310490111,1),(394831766,424500143,14942127,1166268,1,'2009-05-12 20:57:11',3310490453,1),(394831767,424500500,14943950,1166268,1,'2009-05-12 20:57:11',3310490453,1),(394831768,424501093,14945818,1166268,1,'2009-05-12 20:57:11',3310490453,1),(394832384,424500120,14944230,1166268,1,'2009-05-12 20:58:50',3310490453,1),(394832388,424499670,14943650,1166268,1,'2009-05-12 20:58:50',3310490453,1),(394832391,424497990,14938608,1166268,1,'2009-05-12 20:58:50',3310490111,1),(394832396,424496407,14933029,1166268,1,'2009-05-12 20:58:50',3310490111,1),(394832401,424495670,14931730,1166268,1,'2009-05-12 20:58:51',3310490111,1),(394832404,424494050,14931800,1166268,1,'2009-05-12 20:58:51',3310490111,1),(394832407,424493370,14933080,1166268,1,'2009-05-12 20:58:51',3310490111,1),(394832411,424493320,14934850,1166268,1,'2009-05-12 20:58:51',3310490111,1),(394832416,424494370,14938830,1166268,1,'2009-05-12 20:58:51',3310490111,1),(394832428,424494570,14940153,1166268,1,'2009-05-12 20:58:51',3310490111,1),(394840157,424530295,14965368,2138435,1,'2009-08-14 08:44:22',3310491136,2),(394840530,424516200,14972030,1166650,1,'2009-05-12 21:14:35',3310490453,1),(394840531,424515476,14971118,1166650,1,'2009-05-12 21:14:35',3310490453,1),(394840532,424514209,14969917,1166650,1,'2009-05-12 21:14:35',3310490453,1),(394840533,424510980,14967084,1166650,1,'2009-05-12 21:14:35',3310490453,1),(394840534,424507940,14963994,1166650,1,'2009-05-12 21:14:35',3310490453,1),(394840995,424502930,14947380,1166650,1,'2009-05-12 21:15:32',3310490453,1),(394840996,424506850,14950020,1166650,1,'2009-05-12 21:15:32',3310490453,1),(394840997,424510070,14953030,1166650,1,'2009-05-12 21:15:32',3310490453,1),(394840998,424512920,14954720,1166650,1,'2009-05-12 21:15:32',3310490453,1),(394840999,424515673,14958322,1166650,1,'2009-05-12 21:15:32',3310490453,1),(394841000,424516363,14958930,1166650,1,'2009-05-12 21:15:32',3310490453,1),(394841001,424517313,14959102,1166650,1,'2009-05-12 21:15:32',3310490453,1),(394841002,424524150,14959350,1166650,1,'2009-05-12 21:15:33',3310491136,1),(394841006,424530980,14960630,1166650,1,'2009-05-12 21:15:33',3310491136,1),(394841007,424533930,14962620,1166650,1,'2009-05-12 21:15:33',3310491136,1),(394841008,424534480,14964230,1166650,1,'2009-05-12 21:15:33',3310491136,1),(394841009,424533980,14965900,1166650,1,'2009-05-12 21:15:33',3310491136,1),(394841010,424528050,14967650,1166650,1,'2009-05-12 21:15:34',3310491136,1),(394841011,424518780,14973120,1166650,1,'2009-05-12 21:15:34',3310491136,1),(394841012,424512930,14972720,1166650,1,'2009-05-12 21:15:34',3310490453,1),(394841013,424511030,14972420,1166650,1,'2009-05-12 21:15:34',3310490453,1),(394841014,424505204,14968649,1166650,1,'2009-05-12 21:15:34',3310490453,1),(394841015,424504900,14968801,1166650,1,'2009-05-12 21:15:34',3310490453,1),(394841016,424504920,14969430,1166650,1,'2009-05-12 21:15:35',3310490453,1),(394841017,424507520,14972700,1166650,1,'2009-05-12 21:15:35',3310490453,1),(394841018,424509050,14976880,1166650,1,'2009-05-12 21:15:35',3310490453,1),(394841019,424509230,14982050,1166650,1,'2009-05-12 21:15:35',3310490453,1),(394841020,424508670,14986420,1166650,1,'2009-05-12 21:15:35',3310490453,1),(394841021,424508230,14987330,1166650,1,'2009-05-12 21:15:35',3310490453,1),(394841022,424507680,14986720,1166650,1,'2009-05-12 21:15:35',3310490453,1),(394841023,424507150,14983130,1166650,1,'2009-05-12 21:15:36',3310490453,1),(394841024,424505800,14980350,1166650,1,'2009-05-12 21:15:36',3310490453,1),(394841026,424505153,14980045,1166650,1,'2009-05-12 21:15:36',3310490453,1),(394841027,424504700,14980870,1166650,1,'2009-05-12 21:15:36',3310490453,1),(394841028,424505900,14986300,1166650,1,'2009-05-12 21:15:36',3310490453,1),(394841029,424505786,14986997,1166650,1,'2009-05-12 21:15:37',3310490453,1),(394841030,424505220,14987270,1166650,1,'2009-05-12 21:15:37',3310490453,1),(394841031,424499670,14978730,1166650,1,'2009-05-12 21:15:37',3310490453,1),(394841032,424496400,14975350,1166650,1,'2009-05-12 21:15:37',3310490453,1),(394841033,424494330,14974350,1166650,1,'2009-05-12 21:15:37',3310490453,1),(394841034,424489870,14973950,1166650,1,'2009-05-12 21:15:37',3310490452,1),(394841035,424488630,14973050,1166650,1,'2009-05-12 21:15:38',3310490452,1),(394841036,424484600,14967700,1166792,1,'2009-05-12 21:27:16',3310490452,2),(394845193,424500396,14979848,1166792,1,'2009-05-12 21:20:47',3310490453,1),(394847583,424500070,14979830,1166792,1,'2009-05-12 21:23:22',3310490453,1),(394847585,424498470,14978920,1166792,1,'2009-05-12 21:23:22',3310490453,1),(394847587,424497030,14979130,1166792,1,'2009-05-12 21:23:22',3310490453,1),(394847589,424496280,14980250,1166792,1,'2009-05-12 21:23:22',3310490453,1),(394847590,424496230,14981080,1166792,1,'2009-05-12 21:23:22',3310490453,1),(394847591,424497480,14988580,1166792,1,'2009-05-12 21:23:22',3310490453,1),(394847592,424499320,14993130,1166792,1,'2009-05-12 21:23:22',3310490453,1),(394847593,424500370,14993420,1166792,1,'2009-05-12 21:23:22',3310490453,1),(394848317,424501583,14993191,1166792,1,'2009-05-12 21:24:15',3310490453,1),(394848319,424502470,14992762,1166792,1,'2009-05-12 21:24:15',3310490453,1),(408986116,425641935,15274809,1276166,1,'2009-05-21 17:05:04',3310502504,1),(408986118,425641809,15275753,1276166,1,'2009-05-21 17:05:04',3310502504,1),(408986121,425640671,15275668,1276166,1,'2009-05-21 17:05:04',3310502504,1),(408986124,425639659,15275410,1276166,1,'2009-05-21 17:05:04',3310502504,1),(408986126,425639976,15273693,1276166,1,'2009-05-21 17:05:05',3310502504,1),(408986129,425640544,15273865,1276166,1,'2009-05-21 17:05:05',3310502504,1),(408986131,425641113,15274294,1276166,1,'2009-05-21 17:05:05',3310502504,1),(408987613,425641556,15275238,1276166,1,'2009-05-21 17:07:30',3310502504,1),(415767140,425401200,15223700,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767141,425405500,15234000,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767142,425403300,15221600,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767143,425404400,15230400,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767144,425405400,15234500,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767145,425402300,15224700,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767146,425404000,15220700,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767147,425404100,15229500,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767148,425408841,15235176,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767149,425406000,15234900,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767150,425402800,15221700,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767151,425408400,15235200,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767152,425403700,15229000,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767153,425405500,15220300,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767154,425408600,15216900,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767155,425405100,15233700,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767156,425400600,15223600,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767157,425404300,15231100,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767158,425407700,15218700,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767159,425403500,15227100,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767160,425405100,15233000,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767161,425401000,15222000,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767162,425402900,15226200,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767163,425400200,15222000,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767164,425405034,15233155,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767165,425403000,15225800,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767166,425408100,15217500,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767167,425399900,15223000,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767168,425405100,15233300,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767169,425403500,15227900,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767170,425404600,15231300,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767171,425401300,15221800,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767172,425407300,15219300,1423654,1,'2009-06-04 22:58:39',3310502434,1),(441154305,425391557,15253450,1816099,1,'2009-07-13 15:48:57',3310491511,1),(441154306,425394213,15251476,1816099,1,'2009-07-13 15:48:58',3310491511,1),(441154307,425396110,15250360,1816099,1,'2009-07-13 15:48:58',3310491511,1),(441154308,425396869,15249931,1816099,1,'2009-07-13 15:48:59',3310491511,1),(441154951,425387726,15254134,1816161,1,'2009-07-13 15:53:33',3310491511,1),(441154982,425388197,15254777,1816161,1,'2009-07-13 15:54:16',3310491511,1),(441154983,425388766,15254863,1816161,1,'2009-07-13 15:54:16',3310491511,1),(441154984,425389904,15254005,1816161,1,'2009-07-13 15:54:17',3310491511,1),(441157250,425387052,15256178,1816208,1,'2009-07-13 16:01:58',3310491511,1),(441157251,425385218,15257809,1816208,1,'2009-07-13 16:01:58',3310491511,1),(441157252,425383320,15259268,1816208,1,'2009-07-13 16:01:59',3310491511,1),(441157253,425382688,15260555,1816208,1,'2009-07-13 16:01:59',3310491511,1),(441157255,425381992,15263560,1816208,1,'2009-07-13 16:02:00',3310491511,1),(441157257,425381880,15264650,1816208,1,'2009-07-13 16:02:01',3310491511,1),(441157259,425382308,15265705,1816208,1,'2009-07-13 16:02:02',3310491511,1),(441157261,425382830,15266620,1816208,1,'2009-07-13 16:02:02',3310491511,1),(441157265,425385950,15269970,1816208,1,'2009-07-13 16:02:05',3310491511,1),(441157267,425388477,15274537,1816208,1,'2009-07-13 16:02:06',3310491517,1),(442879444,425433752,15234253,1851615,1,'2009-07-17 11:50:12',3310502435,1),(442880086,425433878,15237171,1851615,1,'2009-07-17 11:51:42',3310502435,1),(442880684,425435396,15234167,1851615,1,'2009-07-17 11:55:48',3310502435,1),(442880685,425434447,15238201,1851615,1,'2009-07-17 11:55:48',3310502435,1),(442880686,425432361,15237085,1851615,1,'2009-07-17 11:55:48',3310502435,1),(442880687,425433246,15233051,1851615,1,'2009-07-17 11:55:48',3310502435,1),(442881217,425474349,15135634,1851615,1,'2009-07-17 11:58:40',3310502414,1),(442881670,425469796,15138552,1851615,1,'2009-07-17 11:59:09',3310502414,1),(442881710,425471377,15150568,1851615,1,'2009-07-17 11:59:35',3310502414,1),(442881842,425426353,15170824,1851615,1,'2009-07-17 12:00:21',3310502433,1),(442881998,425467456,15142328,1851615,1,'2009-07-17 12:01:25',3310502414,1),(442882169,425466634,15145075,1851615,1,'2009-07-17 12:02:05',3310502414,1),(442882272,425366401,15167992,1851615,1,'2009-07-17 12:02:57',3310491508,1),(442882442,425466128,15219662,1851615,1,'2009-07-17 12:04:21',3310502438,1),(442882581,425442858,15231163,1851615,1,'2009-07-17 12:05:30',3310502435,1),(444324773,425307320,16005116,1882243,1,'2009-07-20 12:45:02',3310493018,1),(458761736,425903956,15174762,2074125,1,'2009-08-08 14:42:15',3310502692,1),(458761931,425899474,15150645,2190495,1,'2009-08-18 18:21:57',3310502670,2),(458761932,425901530,15151870,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761933,425903470,15152280,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761934,425904900,15153670,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761935,425906130,15153530,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761937,425908120,15154980,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761938,425910520,15155320,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761939,425911130,15154600,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761940,425911730,15155620,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761941,425913070,15156050,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761942,425914430,15155470,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761943,425914230,15156050,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761944,425917320,15157470,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761945,425921820,15157070,2074125,1,'2009-08-08 14:44:13',3310502671,1),(458761946,425924180,15158320,2074125,1,'2009-08-08 14:44:13',3310502671,1),(458761947,425927100,15158550,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761948,425927820,15157750,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761949,425927350,15155830,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761950,425931980,15153200,2074125,1,'2009-08-08 14:44:14',3310502671,1);
INSERT INTO `current_nodes` VALUES (458761951,425933020,15153230,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761952,425934580,15150500,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761953,425933420,15147120,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761954,425930870,15146820,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761955,425929520,15145600,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761956,425929030,15144700,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761957,425929630,15143870,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761958,425929250,15142520,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761959,425927720,15141280,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761960,425925480,15141770,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761961,425923930,15139970,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761962,425924920,15138470,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761963,425924670,15137280,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761964,425925520,15135100,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761965,425925180,15135430,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761966,425925150,15134920,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761967,425926180,15134870,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761968,425929700,15131500,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761969,425935750,15130020,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761970,425938250,15128850,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761971,425939250,15128950,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761972,425941880,15126870,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761973,425943200,15127020,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761974,425944580,15126120,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761975,425947700,15125620,2074125,1,'2009-08-08 14:44:15',3310502682,1),(458761977,425948520,15126070,2074125,1,'2009-08-08 14:44:15',3310502682,1),(458761978,425948730,15126900,2074125,1,'2009-08-08 14:44:16',3310502682,1),(458761979,425950830,15129400,2074125,1,'2009-08-08 14:44:16',3310502682,1),(458761980,425955170,15130270,2074125,1,'2009-08-08 14:44:16',3310502682,1),(458761981,425958500,15129870,2074125,1,'2009-08-08 14:44:16',3310502682,1),(458761982,425959650,15130950,2074125,1,'2009-08-08 14:44:16',3310502682,1),(458761983,425962550,15132050,2074125,1,'2009-08-08 14:44:16',3310502682,1),(458761984,425965520,15135200,2074125,1,'2009-08-08 14:44:16',3310502682,1),(458762722,425968785,15145408,2074125,1,'2009-08-08 14:47:36',3310502682,1),(458764071,425967620,15135850,2074345,1,'2009-08-08 14:51:28',3310502682,1),(458764072,425970980,15132900,2074345,1,'2009-08-08 14:51:28',3310502682,1),(458764073,425974380,15125330,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764074,425978730,15117800,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764075,425979100,15118350,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764076,425980200,15118120,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764077,425980750,15119930,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764078,425981430,15120170,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764079,425982120,15122330,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764080,425982070,15124170,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764081,425983370,15125880,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764082,425983630,15127050,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764083,425983650,15134350,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764084,425982550,15134600,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764085,425982920,15137420,2074345,1,'2009-08-08 14:51:29',3310502683,1),(458764086,425981500,15143920,2074345,1,'2009-08-08 14:51:29',3310502683,1),(458764087,425981820,15146400,2074345,1,'2009-08-08 14:51:29',3310502683,1),(458764088,425982500,15148130,2074345,1,'2009-08-08 14:51:29',3310502683,1),(458764089,425982330,15149070,2074345,1,'2009-08-08 14:51:29',3310502683,1),(458764090,425982980,15149670,2074345,1,'2009-08-08 14:51:29',3310502683,1),(458764091,425987030,15150480,2074345,1,'2009-08-08 14:51:29',3310502683,1),(458764092,425988920,15153730,2074345,1,'2009-08-08 14:51:29',3310502683,1),(458764093,425986550,15160780,2074345,1,'2009-08-08 14:51:29',3310502683,1),(458764094,425987120,15162150,2074345,1,'2009-08-08 14:51:29',3310502705,1),(458764095,425988230,15161650,2074345,1,'2009-08-08 14:51:29',3310502705,1),(458764096,425988450,15162400,2074345,1,'2009-08-08 14:51:29',3310502705,1),(458764097,425988850,15161970,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764098,425988420,15163220,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764099,425988930,15164400,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764100,425987450,15166920,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764101,425989250,15166970,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764102,425989270,15168170,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764103,425990170,15169080,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764104,425991320,15168750,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764105,425991650,15170000,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764106,425991150,15172050,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764107,425992320,15172430,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764108,425992430,15173480,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764109,425991730,15174670,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764110,425991920,15175030,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764111,425991030,15177700,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764112,425992450,15177630,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764113,425992000,15179300,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764114,425990400,15181150,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764115,425986580,15183380,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764116,425987120,15183870,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764118,425987250,15184900,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764119,425986520,15184680,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764120,425985980,15185120,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764121,425986700,15184480,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764122,425988320,15185270,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764123,425987430,15186300,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764124,425988080,15185520,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764125,425987450,15185230,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764126,425986550,15186250,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764127,425988970,15186100,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764128,425993770,15187030,2074345,1,'2009-08-08 14:51:32',3310502705,1),(458764129,425995850,15188900,2074345,1,'2009-08-08 14:51:32',3310502705,1),(458764130,425995920,15189850,2074345,1,'2009-08-08 14:51:32',3310502705,1),(458764131,425994520,15191620,2074345,1,'2009-08-08 14:51:32',3310502705,1),(458764132,425993550,15191880,2074345,1,'2009-08-08 14:51:32',3310502705,1),(458764133,425991700,15193720,2074345,1,'2009-08-08 14:51:32',3310502705,1),(458764134,425990820,15193180,2074345,1,'2009-08-08 14:51:32',3310502705,1),(458764135,425988780,15194530,2074345,1,'2009-08-08 14:51:32',3310502705,1),(458764136,425988200,15195970,2074345,1,'2009-08-08 14:51:33',3310502705,1),(458764139,425985550,15198500,2074345,1,'2009-08-08 14:51:33',3310502705,1),(458764150,425984650,15200600,2074345,1,'2009-08-08 14:51:33',3310502705,1),(458764156,425982670,15202970,2074345,1,'2009-08-08 14:51:33',3310502705,1),(458764162,425981400,15203750,2074345,1,'2009-08-08 14:51:33',3310502705,1),(458764166,425979500,15207830,2074345,1,'2009-08-08 14:51:34',3310502705,1),(458764167,425977750,15210550,2074345,1,'2009-08-08 14:51:34',3310502705,1),(458764168,425977400,15210480,2074345,1,'2009-08-08 14:51:34',3310502705,1),(458764169,425977450,15211200,2074345,1,'2009-08-08 14:51:34',3310502705,1),(458764170,425975380,15212580,2074345,1,'2009-08-08 14:51:34',3310502705,1),(458764171,425973120,15215000,2074345,1,'2009-08-08 14:51:34',3310502704,1),(458764172,425972150,15216750,2074345,1,'2009-08-08 14:51:34',3310502706,1),(458764173,425967270,15221370,2074345,1,'2009-08-08 14:51:34',3310502706,1),(458764174,425962730,15228480,2074345,1,'2009-08-08 14:51:34',3310502706,1),(458764175,425963180,15228850,2074345,1,'2009-08-08 14:51:34',3310502706,1),(458764176,425961070,15232700,2074345,1,'2009-08-08 14:51:35',3310502706,1),(458764177,425961000,15236480,2074345,1,'2009-08-08 14:51:35',3310502706,1),(458764178,425960700,15237080,2074345,1,'2009-08-08 14:51:35',3310502706,1),(458764179,425960480,15236779,2074369,1,'2009-08-08 14:56:47',3310502706,2),(458765020,425961307,15260807,2074369,1,'2009-08-08 14:55:39',3310502706,1),(458765074,425959469,15262185,2074369,1,'2009-08-08 14:55:57',3310502706,1),(458765127,425960038,15262614,2074369,1,'2009-08-08 14:56:31',3310502706,1),(458765128,425959027,15262185,2074369,1,'2009-08-08 14:56:31',3310502706,1),(458765312,425958250,15258180,2074369,1,'2009-08-08 14:56:45',3310502706,1),(458765314,425959180,15258920,2074369,1,'2009-08-08 14:56:45',3310502706,1),(458765317,425959480,15260380,2074369,1,'2009-08-08 14:56:45',3310502706,1),(458765319,425960164,15260726,2074369,1,'2009-08-08 14:56:46',3310502706,1),(458765321,425960796,15260812,2074369,1,'2009-08-08 14:56:46',3310502706,1),(458765361,425960038,15235921,2074369,1,'2009-08-08 14:56:47',3310502706,1),(458765365,425960670,15237551,2074369,1,'2009-08-08 14:56:47',3310502706,1),(458765368,425960796,15238152,2074369,1,'2009-08-08 14:56:47',3310502706,1),(458765373,425960700,15238870,2074369,1,'2009-08-08 14:56:47',3310502706,1),(458765375,425959100,15242330,2074369,1,'2009-08-08 14:56:48',3310502706,1),(458765377,425958100,15247980,2074369,1,'2009-08-08 14:56:48',3310502706,1),(458765379,425958395,15249739,2074369,1,'2009-08-08 14:56:48',3310502706,1),(458765381,425958900,15251470,2074369,1,'2009-08-08 14:56:48',3310502706,1),(458765383,425958330,15252850,2074369,1,'2009-08-08 14:56:48',3310502706,1),(458765386,425958400,15255380,2074369,1,'2009-08-08 14:56:48',3310502706,1),(458765388,425957900,15257200,2074369,1,'2009-08-08 14:56:48',3310502706,1),(470343713,425897470,15144530,2190404,1,'2009-08-18 18:09:47',3310502670,1),(470343719,425898100,15149950,2190404,1,'2009-08-18 18:09:47',3310502670,1),(470343724,425896850,15151950,2190404,1,'2009-08-18 18:09:47',3310502670,1),(470343733,425896300,15151500,2190404,1,'2009-08-18 18:09:48',3310502670,1),(470343737,425895820,15158200,2190404,1,'2009-08-18 18:09:48',3310502670,1),(470343746,425897600,15167080,2190404,1,'2009-08-18 18:09:48',3310502692,1),(470343752,425897770,15170650,2190404,1,'2009-08-18 18:09:48',3310502692,1),(470343759,425898820,15173620,2190404,1,'2009-08-18 18:09:49',3310502692,1),(470343766,425898620,15178080,2190404,1,'2009-08-18 18:12:21',3310502692,2),(470343771,425899450,15178430,2190404,1,'2009-08-18 18:09:49',3310502692,1),(470343785,425899550,15179680,2190404,1,'2009-08-18 18:09:50',3310502692,1),(470343793,425900530,15180780,2190404,1,'2009-08-18 18:09:50',3310502692,1),(470343798,425902920,15180050,2190404,1,'2009-08-18 18:09:50',3310502692,1),(470343805,425903530,15180350,2190404,1,'2009-08-18 18:09:50',3310502692,1),(470343810,425903020,15182500,2190404,1,'2009-08-18 18:09:51',3310502692,1),(470343811,425904180,15184680,2190404,1,'2009-08-18 18:09:51',3310502692,1),(470343812,425905070,15185370,2190404,1,'2009-08-18 18:09:51',3310502692,1),(470343814,425904480,15186450,2190404,1,'2009-08-18 18:09:51',3310502692,1),(470343816,425905130,15187100,2190404,1,'2009-08-18 18:09:51',3310502692,1),(470343817,425905030,15187800,2190404,1,'2009-08-18 18:09:52',3310502692,1),(470343819,425905770,15189130,2190404,1,'2009-08-18 18:09:52',3310502692,1),(470343820,425906880,15189580,2190404,1,'2009-08-18 18:09:53',3310502692,1),(470343822,425907580,15188820,2190404,1,'2009-08-18 18:09:53',3310502692,1),(470343823,425909220,15188680,2190404,1,'2009-08-18 18:09:54',3310502692,1),(470343825,425909320,15190750,2190404,1,'2009-08-18 18:09:54',3310502692,1),(470343827,425910570,15192520,2190404,1,'2009-08-18 18:09:54',3310502692,1),(470343828,425912350,15192800,2190404,1,'2009-08-18 18:09:54',3310502692,1),(470343830,425913680,15192300,2190404,1,'2009-08-18 18:09:55',3310502692,1),(470343831,425915520,15193080,2190404,1,'2009-08-18 18:09:55',3310502692,1),(470343832,425916000,15194180,2190404,1,'2009-08-18 18:09:55',3310502692,1),(470343833,425915030,15194580,2190404,1,'2009-08-18 18:09:56',3310502692,1),(470343834,425915020,15195720,2190404,1,'2009-08-18 18:09:56',3310502692,1),(470343835,425913730,15196680,2190404,1,'2009-08-18 18:09:57',3310502692,1),(470343836,425913900,15197370,2190404,1,'2009-08-18 18:09:57',3310502692,1),(470343837,425913120,15198730,2190404,1,'2009-08-18 18:09:57',3310502692,1),(470343838,425913700,15200000,2190404,1,'2009-08-18 18:09:58',3310502692,1),(470343839,425916520,15200730,2190404,1,'2009-08-18 18:09:58',3310502692,1),(470343840,425919480,15203520,2190404,1,'2009-08-18 18:09:59',3310502693,1),(470343841,425919620,15204650,2190404,1,'2009-08-18 18:09:59',3310502693,1),(470343842,425918750,15204850,2190404,1,'2009-08-18 18:09:59',3310502692,1),(470343844,425918120,15205970,2190404,1,'2009-08-18 18:09:59',3310502692,1),(470343850,425918320,15207320,2190404,1,'2009-08-18 18:10:01',3310502692,1),(470343852,425917920,15209420,2190404,1,'2009-08-18 18:10:01',3310502692,1),(470343853,425921000,15211420,2190404,1,'2009-08-18 18:10:01',3310502693,1),(470343854,425922280,15211580,2190404,1,'2009-08-18 18:10:02',3310502693,1),(470343856,425923500,15213270,2190404,1,'2009-08-18 18:10:02',3310502693,1),(470343857,425926430,15215180,2190404,1,'2009-08-18 18:10:02',3310502693,1),(470343858,425926370,15215700,2190404,1,'2009-08-18 18:10:03',3310502693,1),(470343859,425927400,15216970,2190404,1,'2009-08-18 18:10:03',3310502695,1),(470343860,425927280,15218000,2190404,1,'2009-08-18 18:10:03',3310502695,1),(470343861,425932430,15224400,2190404,1,'2009-08-18 18:10:03',3310502695,1),(470343862,425931680,15224480,2190404,1,'2009-08-18 18:10:04',3310502695,1),(470343863,425931080,15226030,2190404,1,'2009-08-18 18:10:04',3310502695,1),(470343864,425932070,15227580,2190404,1,'2009-08-18 18:10:04',3310502695,1),(470343865,425937780,15229320,2190404,1,'2009-08-18 18:10:05',3310502695,1),(470343866,425939450,15231420,2190404,1,'2009-08-18 18:10:05',3310502695,1),(470343867,425941370,15232530,2190404,1,'2009-08-18 18:10:05',3310502695,1),(470343868,425940080,15232780,2190404,1,'2009-08-18 18:10:06',3310502695,1),(470343869,425939480,15233520,2190404,1,'2009-08-18 18:10:06',3310502695,1),(470343870,425941780,15236670,2190404,1,'2009-08-18 18:10:06',3310502695,1),(470343871,425941520,15240150,2190404,1,'2009-08-18 18:10:06',3310502695,1),(470343872,425941830,15241230,2190404,1,'2009-08-18 18:10:07',3310502695,1),(470343873,425942930,15242170,2190404,1,'2009-08-18 18:10:07',3310502695,1),(470343874,425944570,15242380,2190404,1,'2009-08-18 18:10:08',3310502695,1),(470343875,425945450,15241750,2190404,1,'2009-08-18 18:10:08',3310502695,1),(470343876,425947050,15242430,2190404,1,'2009-08-18 18:10:08',3310502706,1),(470343877,425948850,15241770,2190404,1,'2009-08-18 18:10:08',3310502706,1),(470343878,425951100,15238980,2190404,1,'2009-08-18 18:10:09',3310502706,1),(470343879,425956320,15237470,2190404,1,'2009-08-18 18:10:09',3310502706,1),(470343880,425956970,15236230,2190404,1,'2009-08-18 18:10:09',3310502706,1),(470343881,425956950,15235350,2190404,1,'2009-08-18 18:10:09',3310502706,1),(470343882,425958050,15233900,2190404,1,'2009-08-18 18:10:09',3310502706,1),(470343883,425959780,15234720,2190404,1,'2009-08-18 18:10:10',3310502706,1),(470347019,425899200,15146780,2190495,1,'2009-08-18 18:21:42',3310502670,1),(470348213,425806000,15133400,2190594,1,'2009-08-18 18:26:49',3310502494,1),(470348216,425807070,15134480,2190594,1,'2009-08-18 18:26:50',3310502494,1),(470348218,425807120,15133370,2190594,1,'2009-08-18 18:26:50',3310502494,1),(470348220,425807570,15132850,2190594,1,'2009-08-18 18:26:50',3310502494,1),(470348222,425808430,15133250,2190594,1,'2009-08-18 18:26:51',3310502494,1),(470348224,425809870,15132800,2190594,1,'2009-08-18 18:26:51',3310502495,1),(470348227,425811670,15130570,2190594,1,'2009-08-18 18:26:52',3310502495,1),(470348228,425812150,15129220,2190594,1,'2009-08-18 18:26:53',3310502495,1),(470348229,425811380,15129580,2190594,1,'2009-08-18 18:26:53',3310502495,1),(470348231,425812050,15127500,2190594,1,'2009-08-18 18:26:54',3310502495,1),(470348233,425814200,15125900,2190594,1,'2009-08-18 18:26:54',3310502495,1),(470348236,425816020,15125720,2190594,1,'2009-08-18 18:26:54',3310502495,1),(470348239,425816820,15124630,2190594,1,'2009-08-18 18:26:55',3310502495,1),(470348241,425818380,15124450,2190594,1,'2009-08-18 18:26:55',3310502495,1),(470348244,425820920,15121970,2190594,1,'2009-08-18 18:26:56',3310502495,1),(470348245,425821970,15121430,2190594,1,'2009-08-18 18:26:56',3310502495,1),(470348248,425828480,15122200,2190594,1,'2009-08-18 18:26:56',3310502495,1),(470348249,425828930,15120250,2190594,1,'2009-08-18 18:26:56',3310502495,1),(470348250,425830870,15119670,2190594,1,'2009-08-18 18:26:57',3310502495,1),(470348254,425831520,15118380,2190594,1,'2009-08-18 18:26:58',3310502495,1),(470348257,425834500,15117980,2190594,1,'2009-08-18 18:26:58',3310502495,1),(470348260,425836450,15114580,2190594,1,'2009-08-18 18:26:58',3310502495,1),(470348263,425836350,15113970,2190594,1,'2009-08-18 18:26:59',3310502495,1),(470348264,425837480,15113620,2190594,1,'2009-08-18 18:26:59',3310502666,1),(470348269,425839080,15109520,2190594,1,'2009-08-18 18:27:00',3310502666,1),(470348271,425839730,15109170,2190594,1,'2009-08-18 18:27:00',3310502666,1),(470348272,425839330,15107380,2190594,1,'2009-08-18 18:27:01',3310502666,1),(470348273,425839450,15105030,2190594,1,'2009-08-18 18:27:01',3310502664,1),(470348274,425839000,15103700,2190594,1,'2009-08-18 18:27:01',3310502664,1),(470348275,425839500,15104600,2190594,1,'2009-08-18 18:27:02',3310502664,1),(470348277,425841000,15104870,2190594,1,'2009-08-18 18:27:02',3310502664,1),(470348279,425841730,15105700,2190594,1,'2009-08-18 18:27:03',3310502664,1),(470348280,425844020,15104500,2190594,1,'2009-08-18 18:27:03',3310502664,1),(470348281,425844470,15104780,2190594,1,'2009-08-18 18:27:04',3310502664,1),(470348282,425844450,15104070,2190594,1,'2009-08-18 18:27:04',3310502664,1),(470348283,425845120,15104030,2190594,1,'2009-08-18 18:27:04',3310502664,1),(470348286,425845470,15104170,2190594,1,'2009-08-18 18:27:05',3310502664,1),(470348288,425845670,15106770,2190594,1,'2009-08-18 18:27:05',3310502666,1),(470348290,425845620,15107450,2190594,1,'2009-08-18 18:27:06',3310502666,1),(470348292,425845180,15106700,2190594,1,'2009-08-18 18:27:06',3310502666,1),(470348294,425845180,15107400,2190594,1,'2009-08-18 18:27:06',3310502666,1),(470348299,425845970,15112020,2190594,1,'2009-08-18 18:27:06',3310502666,1),(470348301,425847380,15113820,2190594,1,'2009-08-18 18:27:08',3310502666,1),(470348302,425848800,15117380,2190594,1,'2009-08-18 18:27:08',3310502666,1),(470348303,425849770,15118400,2190594,1,'2009-08-18 18:27:08',3310502666,1),(470348304,425850850,15121230,2190594,1,'2009-08-18 18:27:08',3310502666,1),(470348305,425850480,15121770,2190594,1,'2009-08-18 18:27:09',3310502666,1),(470348306,425850480,15123320,2190594,1,'2009-08-18 18:27:09',3310502666,1),(470348307,425854880,15129180,2190594,1,'2009-08-18 18:27:09',3310502666,1),(470348308,425856700,15133070,2190594,1,'2009-08-18 18:27:10',3310502666,1),(470348309,425861480,15137770,2190594,1,'2009-08-18 18:27:10',3310502666,1),(470348310,425865150,15138200,2190594,1,'2009-08-18 18:27:10',3310502667,1),(470348311,425866150,15137570,2190594,1,'2009-08-18 18:27:11',3310502667,1),(470348312,425869680,15137030,2190594,1,'2009-08-18 18:27:11',3310502667,1),(470348314,425873780,15132430,2190594,1,'2009-08-18 18:27:12',3310502667,1),(470348315,425875300,15132050,2190594,1,'2009-08-18 18:27:13',3310502667,1),(470348316,425877170,15133000,2190594,1,'2009-08-18 18:27:14',3310502667,1),(470348318,425879320,15133120,2190594,1,'2009-08-18 18:27:14',3310502667,1),(470348319,425879530,15132570,2190594,1,'2009-08-18 18:27:14',3310502667,1),(470348321,425880450,15132550,2190594,1,'2009-08-18 18:27:15',3310502667,1),(470348322,425881470,15130420,2190594,1,'2009-08-18 18:27:15',3310502667,1),(470348325,425882700,15129050,2190594,1,'2009-08-18 18:27:15',3310502667,1),(470348326,425884850,15128030,2190594,1,'2009-08-18 18:27:16',3310502667,1),(470348327,425886320,15126400,2190594,1,'2009-08-18 18:27:16',3310502667,1),(470348328,425888670,15125580,2190594,1,'2009-08-18 18:27:16',3310502667,1),(470348329,425891950,15127820,2190594,1,'2009-08-18 18:27:16',3310502670,1),(470348330,425893030,15126700,2190594,1,'2009-08-18 18:27:17',3310502670,1),(470348332,425894080,15127180,2190594,1,'2009-08-18 18:27:18',3310502670,1),(470348333,425893920,15128350,2190594,1,'2009-08-18 18:27:18',3310502670,1),(470348335,425892720,15128850,2190594,1,'2009-08-18 18:27:18',3310502670,1),(470348337,425892850,15131700,2190594,1,'2009-08-18 18:27:19',3310502670,1),(470348338,425893820,15134300,2190594,1,'2009-08-18 18:27:19',3310502670,1),(470348339,425893700,15137350,2190594,1,'2009-08-18 18:27:19',3310502670,1),(470348341,425896670,15142450,2190594,1,'2009-08-18 18:27:20',3310502670,1),(470349572,425896769,15124323,2190594,1,'2009-08-18 18:33:11',3310502670,1),(470349573,425895316,15126040,2190594,1,'2009-08-18 18:33:11',3310502670,1),(470349575,425892851,15127842,2190594,1,'2009-08-18 18:33:12',3310502670,1),(470349576,425891335,15129387,2190594,1,'2009-08-18 18:33:12',3310502667,1),(470349578,425889818,15130932,2190594,1,'2009-08-18 18:33:12',3310502667,1),(470349580,425887923,15133507,2190594,1,'2009-08-18 18:33:13',3310502667,1),(470349603,425886848,15135223,2190594,1,'2009-08-18 18:33:14',3310502667,1),(470349632,425899486,15122177,2190594,1,'2009-08-18 18:33:16',3310502670,1),(470351662,425807150,15134920,2190782,1,'2009-08-18 18:45:43',3310502494,1),(470351674,425808430,15134800,2190782,1,'2009-08-18 18:45:44',3310502494,1),(470351687,425808970,15135480,2190782,1,'2009-08-18 18:45:44',3310502494,1),(470351695,425808850,15135830,2190782,1,'2009-08-18 18:45:45',3310502494,1),(470351696,425810230,15136150,2190782,1,'2009-08-18 18:45:45',3310502495,1),(470351698,425808850,15139720,2190782,1,'2009-08-18 18:45:46',3310502494,1),(470351699,425807550,15140500,2190782,1,'2009-08-18 18:45:46',3310502494,1),(470351700,425808000,15141480,2190782,1,'2009-08-18 18:45:48',3310502494,1),(470351702,425808700,15140920,2190782,1,'2009-08-18 18:45:48',3310502494,1),(470351703,425809300,15142050,2190782,1,'2009-08-18 18:45:49',3310502495,1),(470351704,425810030,15141450,2190782,1,'2009-08-18 18:45:49',3310502495,1),(470351705,425811630,15141500,2190782,1,'2009-08-18 18:45:49',3310502495,1),(470351706,425812470,15141770,2190782,1,'2009-08-18 18:45:50',3310502495,1),(470352988,425826484,15171772,2190826,1,'2009-08-18 18:50:13',3310502517,1),(470352989,425826330,15170480,2190826,1,'2009-08-18 18:50:13',3310502517,1),(470352990,425822080,15166850,2190826,1,'2009-08-18 18:50:14',3310502517,1),(470352991,425821630,15165480,2190826,1,'2009-08-18 18:50:14',3310502517,1),(470352992,425820630,15164370,2190826,1,'2009-08-18 18:50:14',3310502517,1),(470352993,425819880,15161650,2190826,1,'2009-08-18 18:50:14',3310502517,1),(470352995,425818280,15159650,2190826,1,'2009-08-18 18:50:15',3310502495,1),(470352996,425818420,15157650,2190826,1,'2009-08-18 18:50:15',3310502495,1),(470352997,425818920,15156620,2190826,1,'2009-08-18 18:50:16',3310502495,1),(470352998,425819270,15156770,2190826,1,'2009-08-18 18:50:16',3310502495,1),(470352999,425819530,15153970,2190826,1,'2009-08-18 18:50:16',3310502495,1),(470353000,425819220,15153400,2190826,1,'2009-08-18 18:50:16',3310502495,1),(470353001,425819570,15152550,2190826,1,'2009-08-18 18:50:16',3310502495,1),(470353002,425819230,15152000,2190826,1,'2009-08-18 18:50:16',3310502495,1),(470353003,425819720,15150870,2190826,1,'2009-08-18 18:50:17',3310502495,1),(470353004,425818370,15145650,2190826,1,'2009-08-18 18:50:17',3310502495,1),(470353005,425815370,15140980,2190826,1,'2009-08-18 18:50:17',3310502495,1),(470353006,425815300,15142000,2190826,1,'2009-08-18 18:50:17',3310502495,1),(470353007,425814620,15142650,2190826,1,'2009-08-18 18:50:18',3310502495,1),(470353008,425814300,15142250,2190826,1,'2009-08-18 18:50:18',3310502495,1),(470353009,425814030,15143280,2190826,1,'2009-08-18 18:50:19',3310502495,1),(470353010,425813220,15142330,2190826,1,'2009-08-18 18:50:19',3310502495,1),(470353011,425812470,15142450,2190826,1,'2009-08-18 18:50:19',3310502495,1),(470356873,425823291,15172101,2191053,1,'2009-08-18 19:08:40',3310502517,1),(470357335,425823723,15172878,2191053,1,'2009-08-18 19:10:23',3310502517,1),(470357336,425824114,15173574,2191053,1,'2009-08-18 19:10:23',3310502517,1),(470357338,425823987,15174175,2191053,1,'2009-08-18 19:10:23',3310502517,1),(470357340,425823300,15175230,2191053,1,'2009-08-18 19:10:24',3310502517,1),(470357348,425823293,15175661,2191053,1,'2009-08-18 19:10:26',3310502517,1),(470358230,425823716,15181204,2191112,1,'2009-08-18 19:14:56',3310502517,1),(470358231,425823527,15182320,2191112,1,'2009-08-18 19:14:56',3310502517,1),(470358232,425823400,15183779,2191112,1,'2009-08-18 19:16:02',3310502517,2),(470358240,425824222,15177942,2191112,1,'2009-08-18 19:15:02',3310502517,1),(470358241,425824159,15178886,2191112,1,'2009-08-18 19:15:02',3310502517,1),(470358242,425823969,15180002,2191112,1,'2009-08-18 19:15:03',3310502517,1),(470358581,425823780,15181633,2191112,1,'2009-08-18 19:17:42',3310502517,2),(470358582,425824348,15181805,2191112,1,'2009-08-18 19:17:43',3310502517,2),(470358583,425824222,15183178,2191112,1,'2009-08-18 19:17:43',3310502517,2),(470358584,425823527,15183092,2191112,1,'2009-08-18 19:17:43',3310502517,2),(470362088,425825130,15213350,2191272,1,'2009-08-18 19:31:26',3310502517,1),(470362090,425833270,15221230,2191272,1,'2009-08-18 19:31:26',3310502519,1),(470362091,425837450,15227400,2191272,1,'2009-08-18 19:31:26',3310502690,1),(470362096,425839020,15229020,2191272,1,'2009-08-18 19:31:27',3310502690,1),(470362099,425844050,15230230,2191272,1,'2009-08-18 19:31:27',3310502690,1),(470362102,425847100,15231770,2191272,1,'2009-08-18 19:31:28',3310502690,1),(470362105,425856980,15231280,2191272,1,'2009-08-18 19:31:28',3310502690,1),(470362109,425859030,15232420,2191272,1,'2009-08-18 19:31:28',3310502690,1),(470362112,425861300,15232600,2191272,1,'2009-08-18 19:31:29',3310502690,1),(470362115,425862120,15233900,2191272,1,'2009-08-18 19:31:29',3310502690,1),(470362117,425864050,15240300,2191272,1,'2009-08-18 19:31:29',3310502691,1),(470362120,425864750,15240970,2191272,1,'2009-08-18 19:31:30',3310502691,1),(470362123,425867830,15239420,2191272,1,'2009-08-18 19:31:30',3310502691,1),(470362131,425869650,15239100,2191272,1,'2009-08-18 19:31:30',3310502691,1),(470362132,425878250,15242230,2191272,1,'2009-08-18 19:31:31',3310502691,1),(470362134,425882300,15246750,2191272,1,'2009-08-18 19:31:32',3310502691,1),(470362136,425883880,15247500,2191272,1,'2009-08-18 19:31:32',3310502691,1),(470362138,425885270,15247000,2191272,1,'2009-08-18 19:31:33',3310502691,1),(470362140,425886120,15247250,2191272,1,'2009-08-18 19:31:33',3310502691,1),(470362142,425888250,15253220,2191272,1,'2009-08-18 19:31:33',3310502691,1),(470362143,425892530,15256650,2191272,1,'2009-08-18 19:31:33',3310502694,1),(470362144,425896770,15257050,2191272,1,'2009-08-18 19:31:34',3310502694,1),(470362145,425905750,15260270,2191272,1,'2009-08-18 19:31:34',3310502694,1),(470362147,425909870,15260480,2191272,1,'2009-08-18 19:31:34',3310502694,1),(470362152,425911150,15261380,2191272,1,'2009-08-18 19:31:35',3310502694,1),(470362154,425914480,15265770,2191272,1,'2009-08-18 19:31:36',3310502694,1),(470362156,425917080,15268020,2191272,1,'2009-08-18 19:31:36',3310502694,1),(470362158,425917750,15269150,2191272,1,'2009-08-18 19:31:36',3310502694,1),(470362160,425920380,15271250,2191272,1,'2009-08-18 19:31:36',3310502701,1),(470362162,425921100,15271270,2191272,1,'2009-08-18 19:31:36',3310502701,1),(470362163,425923530,15268970,2191272,1,'2009-08-18 19:31:37',3310502695,1),(470362164,425925220,15268230,2191272,1,'2009-08-18 19:31:37',3310502695,1),(470363726,425969230,15270400,2191328,1,'2009-08-18 19:36:58',3310502706,1),(470363727,425974680,15279280,2191328,1,'2009-08-18 19:36:58',3310502713,1),(470363728,425974670,15279880,2191328,1,'2009-08-18 19:36:58',3310502713,1),(470363729,425974180,15279920,2191328,1,'2009-08-18 19:36:59',3310502713,1),(470363730,425970570,15277620,2191328,1,'2009-08-18 19:36:59',3310502712,1),(470363731,425969594,15277791,2191328,1,'2009-08-18 19:36:59',3310502712,1),(470364200,425961249,15267400,2191328,1,'2009-08-18 19:38:39',3310502706,1),(470364482,425960996,15265598,2191328,1,'2009-08-18 19:39:28',3310502706,1),(470364483,425962007,15266885,2191328,1,'2009-08-18 19:39:28',3310502706,1),(470364484,425962070,15266113,2191328,1,'2009-08-18 19:39:28',3310502706,1),(470364486,425961249,15265169,2191328,1,'2009-08-18 19:39:28',3310502706,1),(470364488,425961628,15265856,2191328,1,'2009-08-18 19:39:36',3310502706,1),(470365193,425960427,15250063,2191328,1,'2009-08-18 19:42:34',3310502706,1),(470365194,425959985,15253067,2191328,1,'2009-08-18 19:42:34',3310502706,1),(470365195,425959290,15256414,2191328,1,'2009-08-18 19:42:35',3310502706,1),(470365202,425958342,15260019,2191328,1,'2009-08-18 19:42:35',3310502706,1),(470365211,425957458,15264053,2191328,1,'2009-08-18 19:42:35',3310502706,1),(470365221,425957079,15266285,2191328,1,'2009-08-18 19:42:36',3310502706,1),(470365232,425955689,15271606,2191328,1,'2009-08-18 19:42:36',3310502712,1),(470365242,425954299,15276584,2191328,1,'2009-08-18 19:42:36',3310502712,1),(470365262,425958076,15264835,2191328,1,'2009-08-18 19:42:42',3310502706,1),(470365699,425997656,15196688,2357704,1,'2009-09-03 13:36:35',3310502705,2),(470365700,425991022,15201151,2357704,1,'2009-09-03 13:36:35',3310502705,2),(470365701,425986599,15205271,2357704,1,'2009-09-03 13:36:35',3310502705,2),(470365703,425982415,15210409,2191328,1,'2009-08-18 19:45:22',3310502705,1),(470365704,425978940,15213155,2191328,1,'2009-08-18 19:45:22',3310502705,1),(470365706,425975591,15217189,2191328,1,'2009-08-18 19:45:22',3310502707,1),(470365708,425973443,15219078,2191328,1,'2009-08-18 19:45:22',3310502706,1),(470365709,425969842,15221395,2191328,1,'2009-08-18 19:45:23',3310502706,1),(470365710,425966998,15223798,2191328,1,'2009-08-18 19:45:23',3310502706,1),(470365711,425964661,15226974,2191328,1,'2009-08-18 19:45:23',3310502706,1),(470365712,425963523,15229206,2191328,1,'2009-08-18 19:45:23',3310502706,1),(470365713,425962512,15231781,2191328,1,'2009-08-18 19:45:24',3310502706,1),(470365714,425961881,15234871,2191328,1,'2009-08-18 19:45:24',3310502706,1),(470365715,425961375,15237961,2191328,1,'2009-08-18 19:45:24',3310502706,1),(470365716,425961438,15242252,2191328,1,'2009-08-18 19:45:24',3310502706,1),(470365717,425960806,15246629,2191328,1,'2009-08-18 19:45:25',3310502706,1),(482113340,426251662,14999719,2357182,1,'2009-09-03 12:35:53',3310502743,1),(482113341,426252041,14996715,2357182,1,'2009-09-03 12:35:53',3310502743,1),(482113342,426251536,14991909,2357182,1,'2009-09-03 12:35:53',3310502741,1),(482113343,426250399,14987188,2357182,1,'2009-09-03 12:35:53',3310502741,1),(482113344,426248252,14982553,2357182,1,'2009-09-03 12:35:53',3310502740,1),(482113345,426246610,14980064,2357182,1,'2009-09-03 12:35:53',3310502740,1),(482113739,426240168,15069929,2357182,1,'2009-09-03 12:37:28',3310502748,1),(482113740,426239663,15066324,2357182,1,'2009-09-03 12:37:29',3310502748,1),(482113741,426237642,15061002,2357182,1,'2009-09-03 12:37:29',3310502748,1),(482113742,426235242,15057312,2357182,1,'2009-09-03 12:37:29',3310502748,1),(482113743,426232905,15054737,2357182,1,'2009-09-03 12:37:29',3310502748,1),(482113744,426229368,15049329,2357182,1,'2009-09-03 12:40:31',3310502742,2),(482113745,426225958,15047441,2357182,1,'2009-09-03 12:37:29',3310502742,1),(482113746,426223432,15046154,2357182,1,'2009-09-03 12:37:29',3310502742,1),(482113747,426220084,15043836,2357182,1,'2009-09-03 12:37:29',3310502739,1),(482113748,426219200,15042291,2357182,1,'2009-09-03 12:37:29',3310502739,1),(482113749,426218695,15041004,2357182,1,'2009-09-03 12:40:31',3310502739,2),(482113750,426220274,15038686,2357182,1,'2009-09-03 12:37:29',3310502739,1),(482113751,426219326,15037570,2357182,1,'2009-09-03 12:37:29',3310502739,1),(482113752,426217432,15036712,2357182,1,'2009-09-03 12:40:31',3310502739,2),(482113753,426215537,15034137,2357182,1,'2009-09-03 12:40:31',3310502739,2),(482113754,426214779,15030275,2357182,1,'2009-09-03 12:40:31',3310502739,2),(482113755,426216042,15028730,2357182,1,'2009-09-03 12:37:30',3310502739,1),(482113756,426218063,15026670,2357182,1,'2009-09-03 12:37:30',3310502739,1),(482113757,426220905,15024953,2357182,1,'2009-09-03 12:37:30',3310502739,1),(482113758,426221095,15022722,2357182,1,'2009-09-03 12:37:30',3310502739,1),(482113759,426220716,15020662,2357182,1,'2009-09-03 12:37:30',3310502739,1),(482113760,426219958,15019289,2357182,1,'2009-09-03 12:37:30',3310502739,1),(482113761,426219832,15016113,2357182,1,'2009-09-03 12:37:30',3310502739,1),(482113762,426220084,15013280,2357182,1,'2009-09-03 12:40:31',3310502739,2),(482113763,426221853,15010362,2357182,1,'2009-09-03 12:37:30',3310502742,1),(482113764,426224379,15007272,2357182,1,'2009-09-03 12:37:31',3310502742,1),(482113765,426228042,15005212,2357182,1,'2009-09-03 12:37:31',3310502742,1),(482113766,426231326,15005813,2357182,1,'2009-09-03 12:37:31',3310502742,1),(482113767,426235431,15007787,2357182,1,'2009-09-03 12:37:31',3310502742,1),(482113768,426239410,15008817,2357182,1,'2009-09-03 12:37:31',3310502742,1),(482113769,426241557,15008131,2357182,1,'2009-09-03 12:37:31',3310502742,1),(482113770,426244463,15007530,2357182,1,'2009-09-03 12:37:31',3310502742,1),(482113771,426246799,15005212,2357182,1,'2009-09-03 12:37:31',3310502742,1),(482113772,426248504,15003496,2357182,1,'2009-09-03 12:37:31',3310502742,1),(482113773,426232531,15053317,2357182,1,'2009-09-03 12:37:32',3310502748,1),(482114101,426231137,15052076,2357182,1,'2009-09-03 12:40:30',3310502748,1),(482114102,426221979,15045724,2357182,1,'2009-09-03 12:40:31',3310502742,1),(482114103,426214779,15032335,2357182,1,'2009-09-03 12:40:31',3310502739,1),(482114225,426230379,15066753,2357182,1,'2009-09-03 12:41:46',3310502748,1),(482114227,426232589,15066839,2357182,1,'2009-09-03 12:41:46',3310502748,1),(482114229,426234294,15067354,2357182,1,'2009-09-03 12:41:46',3310502748,1),(482114231,426236000,15067697,2357182,1,'2009-09-03 12:41:46',3310502748,1),(482114232,426237642,15068212,2357182,1,'2009-09-03 12:41:46',3310502748,1),(482114235,426239157,15069500,2357182,1,'2009-09-03 12:41:47',3310502748,1),(482114237,426242505,15071044,2357182,1,'2009-09-03 12:41:47',3310502748,1),(482124370,426192610,15089412,2357182,1,'2009-09-03 12:50:02',3310502744,1),(482124371,426192358,15088211,2357182,1,'2009-09-03 12:50:03',3310502744,1),(482124373,426193558,15088554,2357182,1,'2009-09-03 12:50:03',3310502744,1),(482124375,426194821,15090528,2357182,1,'2009-09-03 12:50:03',3310502745,1),(482124378,426196084,15091815,2357182,1,'2009-09-03 12:50:03',3310502745,1),(482124380,426197031,15090786,2357182,1,'2009-09-03 12:50:03',3310502745,1),(482124381,426198610,15090700,2357182,1,'2009-09-03 12:50:03',3310502745,1),(482124383,426200189,15090442,2357182,1,'2009-09-03 12:50:03',3310502745,1),(482124388,426201074,15091386,2357182,1,'2009-09-03 12:50:03',3310502745,1),(482124389,426202526,15092845,2357182,1,'2009-09-03 12:50:03',3310502745,1),(482124392,426203663,15092674,2357182,1,'2009-09-03 12:50:03',3310502745,1),(482124395,426205242,15092330,2357182,1,'2009-09-03 12:50:04',3310502745,1),(482124397,426206947,15090786,2357182,1,'2009-09-03 12:50:04',3310502745,1),(482124398,426209284,15088726,2357182,1,'2009-09-03 12:50:04',3310502745,1),(482124399,426210168,15087266,2357182,1,'2009-09-03 12:50:04',3310502745,1),(482124402,426211684,15085807,2357182,1,'2009-09-03 12:50:04',3310502745,1),(482124404,426212442,15085035,2357182,1,'2009-09-03 12:50:04',3310502745,1),(482124407,426213768,15085121,2357182,1,'2009-09-03 12:50:04',3310502745,1),(482124408,426215347,15084606,2357182,1,'2009-09-03 12:50:04',3310502745,1),(482124409,426216674,15084520,2357182,1,'2009-09-03 12:50:04',3310502745,1),(482124415,426218884,15084091,2357182,1,'2009-09-03 12:50:04',3310502745,1),(482124418,426220400,15083318,2357182,1,'2009-09-03 12:50:05',3310502745,1),(482124421,426221158,15082546,2357182,1,'2009-09-03 12:50:05',3310502748,1),(482124424,426222232,15084606,2357182,1,'2009-09-03 12:50:05',3310502748,1),(482124425,426222737,15083576,2357182,1,'2009-09-03 12:50:05',3310502748,1),(482124427,426223179,15082374,2357182,1,'2009-09-03 12:50:05',3310502748,1),(482124430,426223937,15081087,2357182,1,'2009-09-03 12:50:05',3310502748,1),(482124432,426224695,15081172,2357182,1,'2009-09-03 12:50:05',3310502748,1),(482124434,426225579,15081687,2357182,1,'2009-09-03 12:50:05',3310502748,1),(482124435,426226274,15080743,2357182,1,'2009-09-03 12:50:05',3310502748,1),(482124441,426226716,15080143,2357182,1,'2009-09-03 12:50:05',3310502748,1),(482124443,426227916,15080143,2357182,1,'2009-09-03 12:50:06',3310502748,1),(482124445,426228610,15078941,2357182,1,'2009-09-03 12:50:06',3310502748,1),(482124448,426228547,15077653,2357182,1,'2009-09-03 12:50:06',3310502748,1),(482124450,426228989,15077053,2357182,1,'2009-09-03 12:50:06',3310502748,1),(482124451,426229621,15077310,2357182,1,'2009-09-03 12:50:06',3310502748,1),(482124454,426230252,15076795,2357182,1,'2009-09-03 12:50:06',3310502748,1),(482124457,426230316,15076108,2357182,1,'2009-09-03 12:50:06',3310502748,1),(482124459,426230316,15074821,2357182,1,'2009-09-03 12:50:06',3310502748,1),(482124460,426230758,15073276,2357182,1,'2009-09-03 12:50:06',3310502748,1),(482124466,426231516,15072589,2357182,1,'2009-09-03 12:50:06',3310502748,1),(482124468,426231326,15071645,2357182,1,'2009-09-03 12:50:07',3310502748,1),(482124470,426231642,15070873,2357182,1,'2009-09-03 12:50:07',3310502748,1),(482124473,426231768,15070358,2357182,1,'2009-09-03 12:50:07',3310502748,1),(482124475,426230631,15067611,2357182,1,'2009-09-03 12:50:07',3310502748,1),(482143961,426064930,15164677,2357481,1,'2009-09-03 13:05:01',3310502752,1),(482143969,426066004,15164677,2357481,1,'2009-09-03 13:05:01',3310502752,1),(482143974,426067268,15164763,2357481,1,'2009-09-03 13:05:01',3310502752,1),(482143976,426067900,15164935,2357481,1,'2009-09-03 13:05:02',3310502752,1),(482143978,426068721,15164591,2357481,1,'2009-09-03 13:05:02',3310502752,1),(482143984,426069858,15163733,2357481,1,'2009-09-03 13:05:02',3310502752,1),(482143987,426070363,15163047,2357481,1,'2009-09-03 13:05:02',3310502752,1),(482143992,426071121,15162446,2357481,1,'2009-09-03 13:05:02',3310502752,1),(482143997,426071816,15162703,2357481,1,'2009-09-03 13:05:02',3310502752,1),(482144000,426072701,15162789,2357481,1,'2009-09-03 13:05:02',3310502752,1),(482144005,426073711,15162532,2357481,1,'2009-09-03 13:05:03',3310502752,1),(482144009,426074406,15162446,2357481,1,'2009-09-03 13:05:03',3310502752,1),(482144019,426074849,15162875,2357481,1,'2009-09-03 13:05:03',3310502752,1),(482144023,426075480,15162789,2357481,1,'2009-09-03 13:05:03',3310502752,1),(482144027,426076428,15163047,2357481,1,'2009-09-03 13:05:03',3310502752,1),(482144030,426077186,15163561,2357481,1,'2009-09-03 13:05:03',3310502752,1),(482144032,426077502,15163218,2357481,1,'2009-09-03 13:05:03',3310502752,1),(482144036,426079271,15163047,2357481,1,'2009-09-03 13:05:04',3310502752,1),(482144040,426079965,15162961,2357481,1,'2009-09-03 13:05:04',3310502752,1),(482144044,426080724,15162961,2357481,1,'2009-09-03 13:05:04',3310502752,1),(482144048,426081292,15163132,2357481,1,'2009-09-03 13:05:04',3310502752,1),(482144052,426081671,15163304,2357481,1,'2009-09-03 13:05:04',3310502752,1),(482144069,426081987,15162617,2357481,1,'2009-09-03 13:05:05',3310502752,1),(482144078,426082113,15161759,2357481,1,'2009-09-03 13:05:05',3310502752,1),(482144087,426082240,15161072,2357481,1,'2009-09-03 13:05:05',3310502730,1),(482148188,426081734,15161587,2357481,1,'2009-09-03 13:08:11',3310502752,1),(482148191,426082303,15163819,2357481,1,'2009-09-03 13:08:11',3310502752,1),(482148194,426082240,15165621,2357481,1,'2009-09-03 13:08:11',3310502752,1),(482148198,426082050,15167252,2357481,1,'2009-09-03 13:08:11',3310502752,1),(482148201,426081671,15170085,2357481,1,'2009-09-03 13:08:11',3310502752,1),(482148204,426081103,15173432,2357481,1,'2009-09-03 13:08:11',3310502752,1),(482148213,426080155,15176179,2357481,1,'2009-09-03 13:08:12',3310502752,1),(482148217,426078828,15177895,2357481,1,'2009-09-03 13:08:12',3310502752,1),(482148220,426077565,15179526,2357481,1,'2009-09-03 13:08:12',3310502752,1),(482148223,426075480,15181672,2357481,1,'2009-09-03 13:08:12',3310502752,1),(482148226,426072638,15184848,2357481,1,'2009-09-03 13:08:12',3310502752,1),(482148228,426070300,15190341,2357481,1,'2009-09-03 13:08:12',3310502752,1),(482148231,426069984,15192744,2357481,1,'2009-09-03 13:08:12',3310502752,1),(482148234,426069668,15194976,2357481,1,'2009-09-03 13:08:12',3310502752,1),(482150309,426192717,15090090,2357481,1,'2009-09-03 13:10:34',3310502744,1),(482158226,426019330,15181650,2357704,1,'2009-09-03 13:35:42',3310502708,1),(482158227,426018030,15183970,2357704,1,'2009-09-03 13:35:42',3310502708,1),(482158228,426017530,15186270,2357704,1,'2009-09-03 13:35:42',3310502708,1),(482158229,426013520,15190680,2357704,1,'2009-09-03 13:35:42',3310502708,1),(482158230,426009430,15192520,2357704,1,'2009-09-03 13:35:42',3310502708,1),(482158231,426006580,15195150,2357704,1,'2009-09-03 13:35:42',3310502708,1),(482158232,426004000,15196680,2357704,1,'2009-09-03 13:35:42',3310502708,1),(482158233,426002850,15198480,2357704,1,'2009-09-03 13:35:42',3310502708,1),(482158234,425998450,15199400,2357704,1,'2009-09-03 13:35:43',3310502705,1),(482158235,425995720,15201780,2357704,1,'2009-09-03 13:35:43',3310502705,1),(482158236,425994480,15201580,2357704,1,'2009-09-03 13:35:43',3310502705,1),(482158237,425992130,15202600,2357704,1,'2009-09-03 13:35:43',3310502705,1),(482158238,425988000,15206220,2357704,1,'2009-09-03 13:35:43',3310502705,1),(482158239,425985020,15209950,2357704,1,'2009-09-03 13:35:43',3310502705,1),(482158240,425982070,15214780,2357704,1,'2009-09-03 13:35:43',3310502705,1),(482158241,425979120,15224280,2357704,1,'2009-09-03 13:35:43',3310502707,1),(482158243,425977250,15227000,2357704,1,'2009-09-03 13:35:44',3310502707,1),(482158246,425974130,15233880,2357704,1,'2009-09-03 13:35:44',3310502707,1),(482158248,425973950,15236730,2357704,1,'2009-09-03 13:35:44',3310502707,1),(482158251,425972480,15234530,2357704,1,'2009-09-03 13:35:44',3310502706,1),(482158252,425971370,15236650,2357704,1,'2009-09-03 13:35:44',3310502706,1),(482158253,425970750,15236400,2357704,1,'2009-09-03 13:35:44',3310502706,1),(482158254,425970150,15236950,2357704,1,'2009-09-03 13:35:44',3310502706,1),(482158255,425967730,15237250,2357704,1,'2009-09-03 13:35:44',3310502706,1),(482158256,425965400,15239780,2357704,1,'2009-09-03 13:35:44',3310502706,1),(482158257,425964920,15239520,2357704,1,'2009-09-03 13:35:44',3310502706,1),(482158258,425964350,15240200,2357704,1,'2009-09-03 13:35:44',3310502706,1),(482158259,425964230,15242450,2357704,1,'2009-09-03 13:35:45',3310502706,1),(482158260,425965420,15246180,2357704,1,'2009-09-03 13:35:45',3310502706,1),(482158261,425965300,15246780,2357704,1,'2009-09-03 13:35:45',3310502706,1),(482158262,425966330,15248430,2357704,1,'2009-09-03 13:35:45',3310502706,1),(482158263,425965070,15250270,2357704,1,'2009-09-03 13:35:45',3310502706,1),(482158264,425966230,15253370,2357704,1,'2009-09-03 13:35:45',3310502706,1),(482158265,425965900,15253780,2357704,1,'2009-09-03 13:35:45',3310502706,1),(482158266,425961820,15251830,2357704,1,'2009-09-03 13:35:45',3310502706,1),(482158267,425960430,15252150,2357704,1,'2009-09-03 13:35:45',3310502706,1),(482158268,425960220,15253470,2357704,1,'2009-09-03 13:35:45',3310502706,1),(482158269,425961270,15256380,2357704,1,'2009-09-03 13:35:45',3310502706,1),(482158872,425966002,15252134,2357704,1,'2009-09-03 13:37:50',3310502706,1),(482158873,425964170,15252649,2357704,1,'2009-09-03 13:37:51',3310502706,1),(482159051,426022359,15179521,2357704,1,'2009-09-03 13:39:07',3310502708,1),(482159053,426021348,15180208,2357704,1,'2009-09-03 13:39:07',3310502708,1),(485577918,426546300,15392830,2387382,1,'2009-09-06 10:39:29',3310503617,1),(485577920,426543500,15392500,2387382,1,'2009-09-06 10:39:29',3310503617,1),(485577921,426538900,15399430,2387382,1,'2009-09-06 10:39:29',3310503617,1),(485577922,426537250,15410450,2387382,1,'2009-09-06 10:39:29',3310503617,1),(485577923,426536240,15408790,2387382,1,'2009-09-06 10:39:29',3310503617,1),(485577924,426534830,15409070,2387382,1,'2009-09-06 10:39:29',3310503617,1),(485577925,426534350,15406870,2387382,1,'2009-09-06 10:39:29',3310503617,1),(485577926,426533700,15408210,2387382,1,'2009-09-06 10:39:29',3310503617,1),(485577927,426531870,15406500,2387382,1,'2009-09-06 10:39:30',3310503617,1),(485577928,426531050,15404280,2387382,1,'2009-09-06 10:39:30',3310503617,1),(485577929,426530980,15401530,2387382,1,'2009-09-06 10:39:30',3310503617,1),(485577930,426528560,15399330,2387382,1,'2009-09-06 10:39:30',3310503617,1),(485577931,426527470,15399190,2387382,1,'2009-09-06 10:39:30',3310503617,1),(485577932,426526720,15400490,2387382,1,'2009-09-06 10:39:30',3310503617,1),(485577933,426528130,15409840,2387382,1,'2009-09-06 10:39:30',3310503617,1),(485577934,426527690,15420010,2387382,1,'2009-09-06 10:39:30',3310503617,1),(485577936,426529370,15423670,2387382,1,'2009-09-06 10:39:30',3310503617,1),(485577937,426531980,15425310,2387382,1,'2009-09-06 10:39:30',3310503617,1),(485577938,426536550,15431620,2387382,1,'2009-09-06 10:39:30',3310503617,1),(485577939,426538230,15436230,2387382,1,'2009-09-06 10:39:30',3310503619,1),(485577940,426537920,15448300,2387382,1,'2009-09-06 10:39:30',3310503619,1),(485577941,426534840,15459510,2387382,1,'2009-09-06 10:39:30',3310503619,1),(485577942,426539470,15480160,2387382,1,'2009-09-06 10:39:30',3310503619,1),(485577943,426540510,15500040,2387382,1,'2009-09-06 10:39:30',3310503625,1),(485577944,426541710,15505740,2387382,1,'2009-09-06 10:39:30',3310503625,1),(485577945,426541060,15514880,2387382,1,'2009-09-06 10:39:30',3310503625,1),(485577946,426544120,15525340,2387382,1,'2009-09-06 10:39:30',3310503625,1),(485577947,426544010,15526510,2387382,1,'2009-09-06 10:39:30',3310503625,1),(485577948,426543090,15523550,2387382,1,'2009-09-06 10:39:30',3310503625,1),(485577949,426540810,15526250,2387382,1,'2009-09-06 10:39:30',3310503625,1),(485577950,426539630,15525670,2387382,1,'2009-09-06 10:39:30',3310503625,1),(485577951,426538690,15527990,2387382,1,'2009-09-06 10:39:30',3310503625,1),(485577953,426535260,15543760,2387382,1,'2009-09-06 10:39:30',3310503625,1),(485577954,426530380,15554720,2387382,1,'2009-09-06 10:39:30',3310503627,1),(485577955,426529280,15559980,2387382,1,'2009-09-06 10:39:30',3310503627,1),(485577956,426525030,15566760,2387382,1,'2009-09-06 10:39:30',3310503627,1),(485577957,426522590,15573080,2387382,1,'2009-09-06 10:39:30',3310503626,1),(485577958,426521540,15577940,2387382,1,'2009-09-06 10:39:31',3310503626,1),(485577959,426519680,15582400,2387382,1,'2009-09-06 10:39:31',3310503626,1),(485577960,426520140,15584670,2387382,1,'2009-09-06 10:39:31',3310503626,1),(485577961,426528360,15597540,2387382,1,'2009-09-06 10:39:31',3310503627,1),(485577962,426532120,15605310,2387382,1,'2009-09-06 10:39:31',3310503649,1),(485577963,426534650,15620770,2387382,1,'2009-09-06 10:39:31',3310503649,1),(485577964,426533860,15624670,2387382,1,'2009-09-06 10:39:31',3310503649,1),(485577965,426528660,15634370,2387382,1,'2009-09-06 10:39:31',3310503649,1),(485577966,426528060,15637640,2387382,1,'2009-09-06 10:39:31',3310503649,1),(485577968,426525630,15647440,2387382,1,'2009-09-06 10:39:31',3310503649,1),(485577969,426523260,15648480,2387382,1,'2009-09-06 10:39:31',3310503649,1),(485577970,426523380,15651020,2387382,1,'2009-09-06 10:39:31',3310503649,1),(485577971,426519440,15651900,2387382,1,'2009-09-06 10:39:31',3310503648,1),(485577972,426517210,15656080,2387382,1,'2009-09-06 10:39:31',3310503650,1),(485577973,426516940,15658210,2387382,1,'2009-09-06 10:39:31',3310503650,1),(485577974,426514250,15659690,2387382,1,'2009-09-06 10:39:31',3310503650,1),(485577975,426511860,15663100,2387382,1,'2009-09-06 10:39:31',3310503650,1),(485577976,426505100,15666610,2387382,1,'2009-09-06 10:39:31',3310503650,1),(485577977,426502700,15666080,2387382,1,'2009-09-06 10:39:31',3310503650,1),(485577978,426499760,15666250,2387382,1,'2009-09-06 10:39:31',3310503650,1),(485577979,426499690,15668090,2387382,1,'2009-09-06 10:39:31',3310503650,1),(485577981,426497010,15674700,2387382,1,'2009-09-06 10:39:31',3310503650,1),(485577982,426492740,15679530,2387382,1,'2009-09-06 10:39:32',3310503607,1),(485577984,426484080,15696210,2387382,1,'2009-09-06 10:39:32',3310503607,1),(485577985,426483390,15697030,2387382,1,'2009-09-06 10:39:32',3310503607,1),(485577986,426481720,15696090,2387382,1,'2009-09-06 10:39:32',3310503607,1),(485577987,426480980,15696290,2387382,1,'2009-09-06 10:39:32',3310503607,1),(485577988,426481030,15698730,2387382,1,'2009-09-06 10:39:32',3310503607,1),(485577989,426482970,15706050,2387382,1,'2009-09-06 10:39:32',3310503607,1),(485577990,426482740,15709830,2387382,1,'2009-09-06 10:39:32',3310503607,1),(485577991,426484880,15714190,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485577992,426484340,15714910,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485577993,426481710,15712670,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485577994,426479210,15712290,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485577995,426479110,15718370,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485577996,426479800,15718700,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485577997,426479730,15720080,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485577998,426480560,15725350,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485577999,426480080,15730220,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485578000,426478200,15735710,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485578001,426471070,15741260,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485578003,426469180,15744010,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485578004,426464950,15756380,2387382,1,'2009-09-06 10:39:32',3310503612,1),(485578005,426461980,15759260,2387382,1,'2009-09-06 10:39:32',3310503612,1),(485578006,426456940,15760370,2387382,1,'2009-09-06 10:39:33',3310503612,1),(485578007,426450760,15760350,2387382,1,'2009-09-06 10:39:33',3310503612,1),(485578008,426446200,15765340,2387382,1,'2009-09-06 10:39:33',3310503612,1),(485578009,426433740,15770520,2387382,1,'2009-09-06 10:39:33',3310503611,1),(485578010,426433130,15771940,2387382,1,'2009-09-06 10:39:33',3310503611,1),(485578011,426426470,15776150,2387382,1,'2009-09-06 10:39:33',3310503611,1),(485578012,426423540,15784000,2387382,1,'2009-09-06 10:39:33',3310503611,1),(485578013,426424510,15790190,2387382,1,'2009-09-06 10:39:33',3310503611,1),(485578014,426423740,15797560,2387382,1,'2009-09-06 10:39:33',3310503611,1),(485578016,426420000,15810690,2387382,1,'2009-09-06 10:39:33',3310503611,1),(485578017,426414930,15820800,2387382,1,'2009-09-06 10:39:33',3310504977,1),(485578018,426413540,15827160,2387382,1,'2009-09-06 10:39:33',3310504977,1),(485578019,426411060,15826070,2387382,1,'2009-09-06 10:39:33',3310504976,1),(485578020,426408550,15826460,2387382,1,'2009-09-06 10:39:33',3310504976,1),(485578021,426404240,15833110,2387382,1,'2009-09-06 10:39:33',3310504976,1),(485578022,426399540,15857220,2387382,1,'2009-09-06 10:39:33',3310504976,1),(485578023,426395790,15862690,2387382,1,'2009-09-06 10:39:33',3310504976,1),(485578024,426393830,15872360,2387382,1,'2009-09-06 10:39:33',3310504976,1),(485578025,426392130,15875910,2387382,1,'2009-09-06 10:39:33',3310504978,1),(485578026,426390350,15886660,2387382,1,'2009-09-06 10:39:33',3310504978,1),(485578027,426387230,15891700,2387382,1,'2009-09-06 10:39:33',3310504978,1),(485578028,426386320,15892640,2387382,1,'2009-09-06 10:39:33',3310504978,1),(485578029,426387090,15892820,2387382,1,'2009-09-06 10:39:33',3310504978,1),(485578030,426387360,15899350,2387382,1,'2009-09-06 10:39:33',3310504978,1),(485578031,426386060,15906640,2387382,1,'2009-09-06 10:39:33',3310504978,1),(485578032,426388500,15912790,2387382,1,'2009-09-06 10:39:33',3310504978,1),(485578033,426386510,15915900,2387382,1,'2009-09-06 10:39:33',3310504978,1),(485578035,426384040,15917710,2387382,1,'2009-09-06 10:39:33',3310504967,1),(485578036,426383450,15929800,2387382,1,'2009-09-06 10:39:34',3310504967,1),(485578037,426385590,15933940,2387382,1,'2009-09-06 10:39:34',3310504973,1),(485578038,426387260,15935210,2387382,1,'2009-09-06 10:39:34',3310504984,1),(485578039,426387160,15945070,2387382,1,'2009-09-06 10:39:34',3310504984,1),(485578040,426384280,15952690,2387382,1,'2009-09-06 10:39:34',3310504973,1),(485578041,426381920,15955700,2387382,1,'2009-09-06 10:39:34',3310504973,1),(485578042,426381100,15965500,2387382,1,'2009-09-06 10:39:34',3310504973,1),(485578043,426381870,15967690,2387382,1,'2009-09-06 10:39:34',3310504973,1),(485578044,426379010,15978020,2387382,1,'2009-09-06 10:39:34',3310504973,1),(485578045,426381120,15985720,2387382,1,'2009-09-06 10:39:34',3310504975,1),(485578046,426374760,15992360,2387382,1,'2009-09-06 10:39:34',3310504975,1),(485578048,426372880,15998550,2387382,1,'2009-09-06 10:39:34',3310504975,1),(485578049,426371000,15997230,2387382,1,'2009-09-06 10:39:34',3310504975,1),(485578050,426368680,15998520,2387382,1,'2009-09-06 10:39:34',3310504975,1),(485578051,426367300,16001320,2387382,1,'2009-09-06 10:39:34',3310504975,1),(485578052,426359450,16001280,2387382,1,'2009-09-06 10:39:34',3310504975,1),(485578053,426355210,16008520,2387382,1,'2009-09-06 10:39:34',3310504974,1),(485578054,426356690,16017610,2387382,1,'2009-09-06 10:39:34',3310504974,1),(485578055,426357770,16027260,2387382,1,'2009-09-06 10:39:34',3310504974,1),(485578056,426361160,16031810,2387382,1,'2009-09-06 10:39:34',3310504975,1),(485578057,426361480,16036730,2387382,1,'2009-09-06 10:39:34',3310504975,1),(485578058,426367230,16039200,2387382,1,'2009-09-06 10:39:34',3310504975,1),(485578059,426367870,16041840,2387382,1,'2009-09-06 10:39:34',3310504997,1),(485578060,426370360,16041370,2387382,1,'2009-09-06 10:39:34',3310504997,1),(485578062,426371160,16043940,2387382,1,'2009-09-06 10:39:34',3310504997,1),(485578063,426374390,16045530,2387382,1,'2009-09-06 10:39:34',3310504997,1),(485578064,426380360,16046070,2387382,1,'2009-09-06 10:39:34',3310504997,1),(485578065,426381360,16049700,2387382,1,'2009-09-06 10:39:35',3310504997,1),(485578066,426385870,16052730,2387382,1,'2009-09-06 10:39:35',3310504997,1),(485578067,426390660,16065640,2387382,1,'2009-09-06 10:39:35',3310505008,1),(485578068,426394750,16069360,2387382,1,'2009-09-06 10:39:35',3310505008,1),(485578070,426395550,16073010,2387382,1,'2009-09-06 10:39:35',3310505008,1),(485578071,426392590,16077230,2387382,1,'2009-09-06 10:39:35',3310505008,1),(485578072,426390240,16082900,2387382,1,'2009-09-06 10:39:35',3310505008,1),(485578073,426389860,16089310,2387382,1,'2009-09-06 10:39:35',3310505008,1),(485578074,426386940,16092710,2387382,1,'2009-09-06 10:39:35',3310505008,1),(485578075,426386570,16102250,2387382,1,'2009-09-06 10:39:35',3310505010,1),(485578076,426383820,16112880,2387382,1,'2009-09-06 10:39:35',3310504999,1),(485578077,426383230,16113630,2387382,1,'2009-09-06 10:39:35',3310504999,1),(485578079,426383960,16120770,2387382,1,'2009-09-06 10:39:35',3310504999,1),(485578080,426380830,16122560,2387382,1,'2009-09-06 10:39:35',3310504999,1),(485578081,426380510,16124880,2387382,1,'2009-09-06 10:39:35',3310504999,1),(485578082,426375500,16134020,2387382,1,'2009-09-06 10:39:35',3310504999,1),(485578083,426370260,16158950,2387382,1,'2009-09-06 10:39:35',3310505005,1),(485578084,426365460,16164680,2387382,1,'2009-09-06 10:39:35',3310505005,1),(485578085,426362480,16171590,2387382,1,'2009-09-06 10:39:36',3310505005,1),(485578086,426359630,16172630,2387382,1,'2009-09-06 10:39:36',3310505005,1),(485578087,426356950,16177620,2387382,1,'2009-09-06 10:39:36',3310505004,1),(485578088,426353780,16177570,2387382,1,'2009-09-06 10:39:36',3310505004,1),(485578089,426352330,16179450,2387382,1,'2009-09-06 10:39:36',3310505004,1),(485578090,426348550,16179910,2387382,1,'2009-09-06 10:39:36',3310505004,1),(485578091,426343240,16186310,2387382,1,'2009-09-06 10:39:36',3310505004,1),(485578092,426342680,16188760,2387382,1,'2009-09-06 10:39:36',3310505004,1),(485578093,426336720,16195880,2387382,1,'2009-09-06 10:39:36',3310505004,1),(485578095,426333560,16205040,2387382,1,'2009-09-06 10:39:36',3310505004,1),(485578096,426333710,16210230,2387382,1,'2009-09-06 10:39:36',3310505006,1),(485578097,426331500,16216190,2387382,1,'2009-09-06 10:39:36',3310505006,1),(485578098,426330670,16223400,2387382,1,'2009-09-06 10:39:36',3310505003,1),(485578099,426330550,16234180,2387382,1,'2009-09-06 10:39:36',3310505003,1),(485578100,426328480,16238180,2387382,1,'2009-09-06 10:39:36',3310505003,1),(485578101,426328670,16241030,2387382,1,'2009-09-06 10:39:36',3310505003,1),(485578102,426330090,16243020,2387382,1,'2009-09-06 10:39:36',3310505003,1),(485578103,426329760,16245700,2387382,1,'2009-09-06 10:39:36',3310505003,1),(485578104,426331540,16248330,2387382,1,'2009-09-06 10:39:36',3310505006,1),(485578105,426330590,16252500,2387382,1,'2009-09-06 10:39:36',3310505003,1),(485578106,426328800,16254840,2387382,1,'2009-09-06 10:39:36',3310505003,1),(485578107,426330970,16257000,2387382,1,'2009-09-06 10:39:36',3310505006,1),(485578108,426330300,16259910,2387382,1,'2009-09-06 10:39:36',3310505003,1),(485578109,426331620,16260580,2387382,1,'2009-09-06 10:39:36',3310505092,1),(485578111,426330030,16261650,2387382,1,'2009-09-06 10:39:36',3310505089,1),(485578112,426329220,16267420,2387382,1,'2009-09-06 10:39:36',3310505089,1),(485578113,426330070,16270090,2387382,1,'2009-09-06 10:39:36',3310505089,1),(485578114,426331220,16272230,2387382,1,'2009-09-06 10:39:36',3310505092,1),(485578115,426327620,16281040,2387382,1,'2009-09-06 10:39:36',3310505089,1),(485578116,426329120,16288640,2387382,1,'2009-09-06 10:39:36',3310505089,1),(485578117,426326800,16295690,2387382,1,'2009-09-06 10:39:37',3310505089,1),(485578118,426326510,16300610,2387382,1,'2009-09-06 10:39:37',3310505089,1),(485578119,426327520,16302720,2387382,1,'2009-09-06 10:39:37',3310505089,1),(485578120,426330820,16302320,2387382,1,'2009-09-06 10:39:37',3310505089,1),(485578121,426332970,16303530,2387382,1,'2009-09-06 10:39:37',3310505092,1),(485578122,426333860,16302390,2387382,1,'2009-09-06 10:39:37',3310505092,1),(485578124,426336330,16310810,2387382,1,'2009-09-06 10:39:37',3310505092,1),(485578125,426338160,16310840,2387382,1,'2009-09-06 10:39:37',3310505092,1),(485578126,426338610,16313250,2387382,1,'2009-09-06 10:39:37',3310505092,1),(485578127,426340690,16313850,2387382,1,'2009-09-06 10:39:37',3310505092,1),(485578128,426340850,16315510,2387382,1,'2009-09-06 10:39:37',3310505094,1),(485578129,426342800,16316160,2387382,1,'2009-09-06 10:39:37',3310505094,1),(485578130,426340870,16323210,2387382,1,'2009-09-06 10:39:37',3310505094,1),(485578133,426338270,16338910,2387382,1,'2009-09-06 10:39:37',3310505094,1),(485578134,426332580,16344260,2387382,1,'2009-09-06 10:39:37',3310505094,1),(485578135,426329920,16349200,2387382,1,'2009-09-06 10:39:37',3310505091,1),(485578136,426330700,16349230,2387382,1,'2009-09-06 10:39:37',3310505091,1),(485578137,426331300,16351000,2387382,1,'2009-09-06 10:39:37',3310505094,1),(485578138,426330280,16351000,2387382,1,'2009-09-06 10:39:37',3310505091,1),(485578139,426332220,16353130,2387382,1,'2009-09-06 10:39:37',3310505094,1),(485578140,426331260,16353800,2387382,1,'2009-09-06 10:39:37',3310505094,1),(485578142,426333040,16357040,2387382,1,'2009-09-06 10:39:37',3310505094,1),(485578143,426332240,16364250,2387382,1,'2009-09-06 10:39:37',3310505094,1),(485578146,426330530,16369800,2387382,1,'2009-09-06 10:39:38',3310505091,1),(485578159,426320020,16413160,2387382,1,'2009-09-06 10:39:38',3310505097,1),(485578160,426316910,16418010,2387382,1,'2009-09-06 10:39:38',3310505097,1),(485578161,426314540,16419620,2387382,1,'2009-09-06 10:39:38',3310505097,1),(485578162,426315620,16424580,2387382,1,'2009-09-06 10:39:38',3310505097,1),(485578163,426313160,16431450,2387382,1,'2009-09-06 10:39:38',3310505099,1),(485578164,426314740,16437390,2387382,1,'2009-09-06 10:39:39',3310505099,1),(515429490,425374178,17280820,2695454,1,'2009-10-01 05:43:20',3310493661,1),(515429491,425373204,17273302,2695454,1,'2009-10-01 05:43:20',3310493661,1),(515429492,425397413,17286852,2695454,1,'2009-10-01 05:43:20',3310504584,1),(515429493,425419738,17296659,2695454,1,'2009-10-01 05:43:20',3310504584,1),(515429494,425442923,17293904,2695454,1,'2009-10-01 05:43:20',3310504585,1),(515429495,425461465,17289945,2695454,1,'2009-10-01 05:43:20',3310504588,1),(515429496,425476443,17312384,2695454,1,'2009-10-01 05:43:20',3310504590,1),(515429497,425487620,17319796,2695454,1,'2009-10-01 05:43:20',3310504591,1),(519515756,425943579,16743492,2730324,1,'2009-10-04 02:19:39',3310504709,1),(519515757,425932413,16738599,2730324,1,'2009-10-04 02:19:40',3310504709,1),(519515758,425919314,16722418,2730324,1,'2009-10-04 02:19:40',3310504709,1),(519515759,425907122,16702459,2730324,1,'2009-10-04 02:19:40',3310504708,1),(519515760,425892157,16682533,2730324,1,'2009-10-04 02:19:40',3310504366,1),(519515761,425873506,16668932,2730324,1,'2009-10-04 02:19:40',3310504363,1),(519515762,425848387,16660435,2730324,1,'2009-10-04 02:19:40',3310504362,1),(519515763,425857910,16652183,2730324,1,'2009-10-04 02:19:40',3310504362,1),(519515764,425853665,16637764,2730324,1,'2009-10-04 02:19:40',3310504360,1),(519515765,425855587,16623926,2730324,1,'2009-10-04 02:19:41',3310504360,1),(519515766,425872336,16631266,2730324,1,'2009-10-04 02:19:41',3310504361,1),(519515767,425899283,16635981,2730324,1,'2009-10-04 02:19:41',3310504364,1),(519515768,425917990,16658369,2730324,1,'2009-10-04 02:19:41',3310504366,1),(519515769,425919069,16683484,2730324,1,'2009-10-04 02:19:41',3310504367,1),(519515770,425931230,16698414,2730324,1,'2009-10-04 02:19:41',3310504367,1),(519515771,425933890,16701954,2730324,1,'2009-10-04 02:19:41',3310504709,1),(519515772,425946206,16718342,2730324,1,'2009-10-04 02:19:41',3310504709,1),(521134858,425724747,14829230,2746094,1,'2009-10-05 10:26:44',3310502119,1),(521135636,425722408,14836611,2746094,1,'2009-10-05 10:27:20',3310502125,1),(521143390,425717166,14842276,2746135,1,'2009-10-05 10:33:14',3310502125,1),(521144650,425713942,14859614,2746135,1,'2009-10-05 10:34:10',3310502125,1),(521146418,425695043,14892573,2746135,1,'2009-10-05 10:36:15',3310502126,1),(521153185,425733148,14711057,4101446,1,'2010-03-11 22:58:46',3310502106,3),(521153188,425768495,14798575,4101446,1,'2010-03-11 22:58:46',3310502131,3),(521349887,425672011,14336387,2747796,1,'2009-10-05 13:48:01',3310501988,1),(521349888,425666338,14338480,2747796,1,'2009-10-05 13:48:01',3310501987,1),(521349889,425638696,14315282,2747796,1,'2009-10-05 13:48:01',3310501984,1),(521349890,425628478,14287319,2747796,1,'2009-10-05 13:48:01',3310501984,1),(521349907,425668985,14296040,2747796,1,'2009-10-05 13:48:01',3310501985,1),(521349908,425669784,14317424,2747796,1,'2009-10-05 13:48:01',3310501985,1),(522254633,425647676,14897282,2756081,1,'2009-10-06 02:46:58',3310502123,1),(522254634,425644280,14875442,2756081,1,'2009-10-06 02:46:58',3310502120,1),(522254635,425607712,14803109,2756081,1,'2009-10-06 02:46:58',3310502071,1),(522254636,425586107,14664202,2756081,1,'2009-10-06 02:46:58',3310502044,1),(522254637,425599360,14645873,2756081,1,'2009-10-06 02:46:58',3310502045,1),(522254638,425600809,14656591,2756081,1,'2009-10-06 02:46:58',3310502045,1);
INSERT INTO `current_nodes` VALUES (522254639,425611035,14686810,2756081,1,'2009-10-06 02:46:58',3310502047,1),(522254640,425621114,14699033,2756081,1,'2009-10-06 02:46:58',3310502090,1),(522254641,425650454,14727844,2756081,1,'2009-10-06 02:46:58',3310502113,1),(522254642,425658915,14745718,2756081,1,'2009-10-06 02:46:58',3310502113,1),(522254643,425659286,14745460,2756081,1,'2009-10-06 02:46:58',3310502113,1),(522254644,425682998,14765824,2756081,1,'2009-10-06 02:46:58',3310502116,1),(522254645,425692595,14776927,2756081,1,'2009-10-06 02:46:58',3310502118,1),(522254646,425696842,14802385,2756081,1,'2009-10-06 02:46:58',3310502118,1),(522254647,425700086,14821821,2756081,1,'2009-10-06 02:46:59',3310502119,1),(522254648,425701508,14850731,2756081,1,'2009-10-06 02:46:59',3310502125,1),(522254649,425688624,14873419,2756081,1,'2009-10-06 02:46:59',3310502124,1),(522254650,425676854,14888055,2756081,1,'2009-10-06 02:46:59',3310502126,1),(522256224,425201666,17013324,2756091,1,'2009-10-06 02:48:31',3310493538,1),(522256225,425204499,16991550,2756091,1,'2009-10-06 02:48:31',3310493538,1),(522256226,425210929,16980183,2756091,1,'2009-10-06 02:48:31',3310493539,1),(522256227,425217351,16967571,2756091,1,'2009-10-06 02:48:31',3310493537,1),(522256228,425207895,16938816,2756091,1,'2009-10-06 02:48:31',3310493537,1),(522256229,425222630,16919837,2756091,1,'2009-10-06 02:48:31',3310493537,1),(522256230,425237340,16897087,2756091,1,'2009-10-06 02:48:31',3310493518,1),(522256231,425264200,16888010,2756091,1,'2009-10-06 02:48:31',3310493519,1),(522256232,425284654,16894056,2756091,1,'2009-10-06 02:48:31',3310493519,1),(522256233,425299533,16898906,2756091,1,'2009-10-06 02:48:31',3310493530,1),(522256234,425302492,16927729,2756091,1,'2009-10-06 02:48:31',3310493552,1),(522256235,425296161,16955411,2756091,1,'2009-10-06 02:48:31',3310493552,1),(522256236,425293476,16971747,2756091,1,'2009-10-06 02:48:31',3310493552,1),(522256237,425272152,16975745,2756091,1,'2009-10-06 02:48:31',3310493543,1),(522256238,425257318,16978420,2756091,1,'2009-10-06 02:48:31',3310493542,1),(522256239,425254656,16998525,2756091,1,'2009-10-06 02:48:31',3310493542,1),(522256240,425260358,17021042,2756091,1,'2009-10-06 02:48:31',3310493543,1),(522256241,425266019,17034782,2756091,1,'2009-10-06 02:48:31',3310493549,1),(522256242,425250067,17042027,2756091,1,'2009-10-06 02:48:31',3310493548,1),(522256243,425233347,17027597,2756091,1,'2009-10-06 02:48:31',3310493542,1),(522256245,425219987,17017622,2756091,1,'2009-10-06 02:48:31',3310493539,1),(522787948,425781875,14797015,2759915,1,'2009-10-06 15:48:38',3310502134,1),(522787954,425778715,14801650,2759915,1,'2009-10-06 15:48:39',3310502131,1),(522787964,425728278,14696250,2759915,1,'2009-10-06 15:48:40',3310502106,1),(522787974,425728404,14692302,2759915,1,'2009-10-06 15:48:41',3310502106,1),(522787985,425725560,14692302,2759915,1,'2009-10-06 15:48:42',3310502095,1),(522788283,425771889,14797788,2759915,1,'2009-10-06 15:49:42',3310502131,1),(522788287,425777009,14782596,2759915,1,'2009-10-06 15:49:43',3310502131,1),(522800785,425699987,14878878,3388565,1,'2009-12-16 20:20:11',3310502125,2),(522800788,425720214,14838795,2760016,1,'2009-10-06 15:58:14',3310502125,1),(526428059,426334786,16929614,2788590,1,'2009-10-09 02:31:16',3310505508,1),(526428060,426324101,16929733,2788590,1,'2009-10-09 02:31:16',3310505505,1),(526428062,426314642,16937880,2788590,1,'2009-10-09 02:31:16',3310505505,1),(526428066,426302776,16939623,2788590,1,'2009-10-09 02:31:16',3310505504,1),(526428067,426290314,16942977,2788590,1,'2009-10-09 02:31:16',3310505504,1),(526428069,426284932,16936606,2788590,1,'2009-10-09 02:31:16',3310505504,1),(526428070,426285469,16926948,2788590,1,'2009-10-09 02:31:16',3310505504,1),(526428071,426283581,16910072,2788590,1,'2009-10-09 02:31:16',3310505482,1),(526428073,426289465,16901159,2788590,1,'2009-10-09 02:31:16',3310505482,1),(526428074,426297822,16907496,2788590,1,'2009-10-09 02:31:17',3310505482,1),(526428076,426299065,16916338,2788590,1,'2009-10-09 02:31:17',3310505482,1),(526428077,426307383,16916245,2788590,1,'2009-10-09 02:31:17',3310505483,1),(526428078,426313272,16908130,2788590,1,'2009-10-09 02:31:17',3310505483,1),(526428080,426316217,16903270,2788590,1,'2009-10-09 02:31:17',3310505483,1),(526428081,426326332,16907178,2788590,1,'2009-10-09 02:31:17',3310505483,1),(526428083,426326249,16893505,2788590,1,'2009-10-09 02:31:17',3310505483,1),(526428084,426316699,16884764,2788590,1,'2009-10-09 02:31:17',3310505483,1),(526428086,426316630,16873500,2788590,1,'2009-10-09 02:31:17',3310505483,1),(526428090,426317487,16846689,2788590,1,'2009-10-09 02:31:17',3310505481,1),(526428091,426316310,16841427,2788590,1,'2009-10-09 02:31:17',3310505481,1),(526429982,426479632,15719113,2788599,1,'2009-10-09 02:32:30',3310503613,1),(526429983,426481291,15700113,2788599,1,'2009-10-09 02:32:30',3310503607,1),(526429985,426484084,15688960,2788599,1,'2009-10-09 02:32:30',3310503607,1),(526429986,426497333,15670703,2788599,1,'2009-10-09 02:32:30',3310503650,1),(526429988,426502245,15666987,2788599,1,'2009-10-09 02:32:30',3310503650,1),(526429992,426510532,15664246,2788599,1,'2009-10-09 02:32:30',3310503650,1),(526429993,426523387,15670516,2788599,1,'2009-10-09 02:32:30',3310503651,1),(526431633,426238989,14631757,2788603,1,'2009-10-09 02:33:33',3310502364,1),(526431634,426235821,14635537,2788603,1,'2009-10-09 02:33:33',3310502364,1),(526431636,426234495,14640839,2788603,1,'2009-10-09 02:33:33',3310502364,1),(526431637,426232709,14646141,2788603,1,'2009-10-09 02:33:34',3310502364,1),(526431639,426231602,14650816,2788603,1,'2009-10-09 02:33:34',3310502364,1),(526431640,426226131,14658559,2788603,1,'2009-10-09 02:33:34',3310502364,1),(526431642,426217893,14668335,2788603,1,'2009-10-09 02:33:34',3310502363,1),(526431643,426208398,14668478,2788603,1,'2009-10-09 02:33:34',3310502363,1),(526431645,426201218,14662148,2788603,1,'2009-10-09 02:33:34',3310502361,1),(526431646,426191731,14664707,2788603,1,'2009-10-09 02:33:34',3310502360,1),(526431648,426184597,14664009,2788603,1,'2009-10-09 02:33:34',3310502360,1),(526431649,426188865,14657485,2788603,1,'2009-10-09 02:33:34',3310502360,1),(526431651,426189751,14654675,2788603,1,'2009-10-09 02:33:34',3310502360,1),(526431652,426188339,14649430,2788603,1,'2009-10-09 02:33:34',3310502360,1),(526431654,426186952,14647277,2788603,1,'2009-10-09 02:33:34',3310502360,1),(526431655,426183731,14646095,2788603,1,'2009-10-09 02:33:34',3310502360,1),(526431656,426181442,14646137,2788603,1,'2009-10-09 02:33:34',3310502360,1),(526431658,426177543,14644349,2788603,1,'2009-10-09 02:33:34',3310502360,1),(526431663,426177272,14640013,2788603,1,'2009-10-09 02:33:34',3310502360,1),(526431664,426177699,14635972,2788603,1,'2009-10-09 02:33:34',3310502360,1),(526431666,426177900,14633172,2788603,1,'2009-10-09 02:33:35',3310502360,1),(526431667,426179482,14630351,2788603,1,'2009-10-09 02:33:35',3310502360,1),(526431669,426183118,14627500,2788603,1,'2009-10-09 02:33:35',3310502360,1),(526431671,426189263,14623972,2788603,1,'2009-10-09 02:33:35',3310502360,1),(526431672,426191779,14622688,2788603,1,'2009-10-09 02:33:35',3310502360,1),(526431674,426194050,14620473,2788603,1,'2009-10-09 02:33:35',3310502361,1),(526431798,426273549,16577577,2788608,1,'2009-10-09 02:33:40',3310504439,1),(526431800,426269427,16582451,2788608,1,'2009-10-09 02:33:40',3310504439,1),(526431801,426262915,16585742,2788608,1,'2009-10-09 02:33:40',3310504439,1),(526431803,426258766,16588208,2788608,1,'2009-10-09 02:33:40',3310504439,1),(526431804,426252772,16579424,2788608,1,'2009-10-09 02:33:40',3310504439,1),(526431806,426246782,16571453,2788608,1,'2009-10-09 02:33:40',3310504438,1),(526431807,426243736,16560225,2788608,1,'2009-10-09 02:33:40',3310504438,1),(526431809,426236593,16557900,2788608,1,'2009-10-09 02:33:40',3310504438,1),(526431810,426226976,16554905,2788608,1,'2009-10-09 02:33:40',3310504438,1),(526431812,426225771,16555998,2788608,1,'2009-10-09 02:33:40',3310504438,1),(526431813,426222657,16558831,2788608,1,'2009-10-09 02:33:40',3310504438,1),(526431817,426221142,16562345,2788608,1,'2009-10-09 02:33:41',3310504438,1),(526431818,426224026,16579867,2788608,1,'2009-10-09 02:33:41',3310504438,1),(526431820,426234132,16582021,2788608,1,'2009-10-09 02:33:41',3310504438,1),(526431821,426239230,16591066,2788608,1,'2009-10-09 02:33:41',3310504444,1),(526431823,426238518,16611564,2788608,1,'2009-10-09 02:33:41',3310504444,1),(526431824,426239447,16625203,2788608,1,'2009-10-09 02:33:41',3310504444,1),(526431826,426242045,16636558,2788608,1,'2009-10-09 02:33:41',3310504444,1),(526431827,426250545,16651257,2788608,1,'2009-10-09 02:33:41',3310504447,1),(526431828,426257294,16656864,2788608,1,'2009-10-09 02:33:41',3310504447,1),(526431830,426253218,16676261,2788608,1,'2009-10-09 02:33:41',3310504447,1),(526431831,426255815,16687609,2788608,1,'2009-10-09 02:33:41',3310504447,1),(526431833,426258372,16694412,2788608,1,'2009-10-09 02:33:41',3310504447,1),(526431834,426258465,16709209,2788608,1,'2009-10-09 02:33:41',3310504789,1),(526431836,426256892,16725158,2788608,1,'2009-10-09 02:33:41',3310504789,1),(526431837,426256114,16735412,2788608,1,'2009-10-09 02:33:41',3310504789,1),(526431839,426266208,16737569,2788608,1,'2009-10-09 02:33:41',3310504789,1),(526431840,426278813,16737424,2788608,1,'2009-10-09 02:33:41',3310505472,1),(526431842,426283850,16735094,2788608,1,'2009-10-09 02:33:41',3310505472,1),(526431858,426289279,16797632,2788608,1,'2009-10-09 02:33:42',3310505474,1),(526431859,426285168,16813609,2788608,1,'2009-10-09 02:33:42',3310505480,1),(526431860,426293715,16836277,2788608,1,'2009-10-09 02:33:42',3310505480,1),(526431861,426299667,16847589,2788608,1,'2009-10-09 02:33:42',3310505480,1),(526431863,426288801,16856817,2788608,1,'2009-10-09 02:33:42',3310505480,1),(526431865,426276126,16845581,2788608,1,'2009-10-09 02:33:42',3310505480,1),(526431866,426261093,16861681,2788608,1,'2009-10-09 02:33:42',3310504797,1),(526431868,426270475,16883206,2788608,1,'2009-10-09 02:33:42',3310504799,1),(526431869,426265549,16903744,2788608,1,'2009-10-09 02:33:42',3310504799,1),(526431870,426256408,16919777,2788608,1,'2009-10-09 02:33:43',3310504821,1),(526431872,426248097,16935807,2788608,1,'2009-10-09 02:33:43',3310504820,1),(526431873,426249877,16951717,2788608,1,'2009-10-09 02:33:43',3310504821,1),(526431875,426253329,16967617,2788608,1,'2009-10-09 02:33:43',3310504821,1),(526431876,426255964,16985798,2788608,1,'2009-10-09 02:33:43',3310504823,1),(526431878,426250206,17006344,2788608,1,'2009-10-09 02:33:43',3310504823,1),(526431879,426245268,17023468,2788608,1,'2009-10-09 02:33:43',3310504822,1),(526431881,426243700,17042835,2788608,1,'2009-10-09 02:33:43',3310504828,1),(526431882,426247110,17051903,2788608,1,'2009-10-09 02:33:43',3310504828,1),(526431884,426239650,17067914,2788608,1,'2009-10-09 02:33:43',3310504828,1),(526431885,426228819,17085101,2788608,1,'2009-10-09 02:33:43',3310504830,1),(526431887,426219641,17095445,2788608,1,'2009-10-09 02:33:43',3310504827,1),(526431888,426213840,17109165,2788608,1,'2009-10-09 02:33:43',3310504827,1),(526431892,426205420,17106983,2788608,1,'2009-10-09 02:33:43',3310504827,1),(526431893,426201257,17114992,2788608,1,'2009-10-09 02:33:43',3310504827,1),(526431895,426198042,17138928,2788608,1,'2009-10-09 02:33:43',3310504827,1),(526431896,426193864,17142385,2788608,1,'2009-10-09 02:33:43',3310504913,1),(526431898,426183806,17148177,2788608,1,'2009-10-09 02:33:43',3310504912,1),(526431899,426183144,17178916,2788608,1,'2009-10-09 02:33:43',3310504912,1),(526431901,426184125,17202798,2788608,1,'2009-10-09 02:33:43',3310504914,1),(526431902,426193545,17232289,2788608,1,'2009-10-09 02:33:43',3310504914,1),(526431903,426201241,17254969,2788608,1,'2009-10-09 02:33:44',3310504921,1),(526431930,426171559,17360720,2788608,1,'2009-10-09 02:33:44',3310504944,1),(526431932,426167066,17360159,2788608,1,'2009-10-09 02:33:44',3310504944,1),(526431933,426153112,17361831,2788608,1,'2009-10-09 02:33:44',3310504933,1),(526431935,426151622,17362492,2788608,1,'2009-10-09 02:33:44',3310504933,1),(526432055,425976782,17315071,2788608,1,'2009-10-09 02:33:48',3310504859,1),(526432057,425969218,17301643,2788608,1,'2009-10-09 02:33:48',3310504856,1),(526432058,425952563,17296189,2788608,1,'2009-10-09 02:33:48',3310504856,1),(526432060,425936045,17316621,2788608,1,'2009-10-09 02:33:48',3310504847,1),(526432061,425929491,17334699,2788608,1,'2009-10-09 02:33:48',3310504847,1),(526432063,425924597,17350504,2788608,1,'2009-10-09 02:33:48',3310504847,1),(526432064,425928890,17375222,2788608,1,'2009-10-09 02:33:48',3310504869,1),(526432067,425930670,17394338,2788608,1,'2009-10-09 02:33:48',3310504869,1),(526432069,425931850,17406852,2788608,1,'2009-10-09 02:33:48',3310504869,1),(526432070,425931656,17406841,2788608,1,'2009-10-09 02:33:48',3310504869,1),(526432072,425925886,17415904,2788608,1,'2009-10-09 02:33:48',3310504871,1),(526432073,425918472,17428360,2788608,1,'2009-10-09 02:33:48',3310504870,1),(526432075,425904355,17431881,2788608,1,'2009-10-09 02:33:48',3310504870,1),(526432076,425888449,17412912,2788608,1,'2009-10-09 02:33:49',3310504865,1),(526432078,425880209,17426501,2788608,1,'2009-10-09 02:33:49',3310504867,1),(526432079,425869475,17440116,2788608,1,'2009-10-09 02:33:49',3310504867,1),(526432081,425868017,17443269,2788608,1,'2009-10-09 02:33:49',3310504867,1),(526432082,425856857,17414362,2788608,1,'2009-10-09 02:33:49',3310504866,1),(526432084,425842417,17360496,2788608,1,'2009-10-09 02:33:49',3310504864,1),(526432085,425853208,17357008,2788608,1,'2009-10-09 02:33:49',3310504842,1),(526432087,425847196,17323311,2788608,1,'2009-10-09 02:33:49',3310504842,1),(526432088,425845340,17289571,2788608,1,'2009-10-09 02:33:49',3310504840,1),(526432089,425861925,17281520,2788608,1,'2009-10-09 02:33:49',3310504840,1),(526432091,425851733,17244491,2788608,1,'2009-10-09 02:33:49',3310504834,1),(526432092,425844080,17215314,2788608,1,'2009-10-09 02:33:49',3310504834,1),(526432096,425833985,17195166,2788608,1,'2009-10-09 02:33:49',3310504663,1),(526432097,425811495,17188654,2788608,1,'2009-10-09 02:33:49',3310504661,1),(526432099,425795689,17187697,2788608,1,'2009-10-09 02:33:49',3310504660,1),(526432100,425790661,17180999,2788608,1,'2009-10-09 02:33:49',3310504660,1),(526432102,425782821,17180641,2788608,1,'2009-10-09 02:33:49',3310504660,1),(526432103,425782658,17180139,2788608,1,'2009-10-09 02:33:49',3310504660,1),(526432105,425765856,17166945,2788608,1,'2009-10-09 02:33:49',3310504657,1),(526432106,425765706,17141234,2788608,1,'2009-10-09 02:33:49',3310504657,1),(526432108,425768638,17122681,2788608,1,'2009-10-09 02:33:49',3310504571,1),(526432109,425776824,17092764,2788608,1,'2009-10-09 02:33:49',3310504571,1),(526432111,425774485,17082499,2788608,1,'2009-10-09 02:33:50',3310504569,1),(526432112,425765983,17058929,2788608,1,'2009-10-09 02:33:50',3310504569,1),(526432114,425755301,17053904,2788608,1,'2009-10-09 02:33:50',3310504569,1),(526432115,425743762,17031401,2788608,1,'2009-10-09 02:33:50',3310504568,1),(526432117,425729237,17018188,2788608,1,'2009-10-09 02:33:50',3310504562,1),(526432118,425713283,17019388,2788608,1,'2009-10-09 02:33:50',3310504551,1),(526432120,425708609,16999894,2788608,1,'2009-10-09 02:33:50',3310504551,1),(526432121,425721367,16973010,2788608,1,'2009-10-09 02:33:50',3310504549,1),(526432122,425735713,16956397,2788608,1,'2009-10-09 02:33:50',3310504560,1),(526432126,425768439,16961176,2788608,1,'2009-10-09 02:33:50',3310504561,1),(526432127,425786814,16983604,2788608,1,'2009-10-09 02:33:50',3310504566,1),(526432129,425808032,16971029,2788608,1,'2009-10-09 02:33:50',3310504564,1),(526432130,425833124,16971778,2788608,1,'2009-10-09 02:33:50',3310504565,1),(526432132,425846837,16976768,2788608,1,'2009-10-09 02:33:50',3310504738,1),(526432133,425867464,16993007,2788608,1,'2009-10-09 02:33:50',3310504739,1),(526432135,425883530,17010322,2788608,1,'2009-10-09 02:33:50',3310504739,1),(526432136,425896942,17030653,2788608,1,'2009-10-09 02:33:50',3310504748,1),(526432137,425884389,17045199,2788608,1,'2009-10-09 02:33:50',3310504745,1),(526432139,425871853,17062440,2788608,1,'2009-10-09 02:33:50',3310504745,1),(526432140,425870667,17085861,2788608,1,'2009-10-09 02:33:50',3310504747,1),(526432142,425877492,17116397,2788608,1,'2009-10-09 02:33:50',3310504747,1),(526432143,425890793,17114453,2788608,1,'2009-10-09 02:33:51',3310504747,1),(526432145,425910832,17126299,2788608,1,'2009-10-09 02:33:51',3310504750,1),(526432146,425913952,17139642,2788608,1,'2009-10-09 02:33:51',3310504836,1),(526432148,425912582,17164350,2788608,1,'2009-10-09 02:33:51',3310504836,1),(526432149,425919585,17193086,2788608,1,'2009-10-09 02:33:51',3310504837,1),(526432151,425930327,17210465,2788608,1,'2009-10-09 02:33:51',3310504839,1),(526432154,425946323,17214413,2788608,1,'2009-10-09 02:33:51',3310504839,1),(526432156,425958412,17200907,2788608,1,'2009-10-09 02:33:51',3310504850,1),(526432157,425955215,17174187,2788608,1,'2009-10-09 02:33:51',3310504848,1),(526432159,425952047,17152609,2788608,1,'2009-10-09 02:33:51',3310504848,1),(526432160,425956495,17134034,2788608,1,'2009-10-09 02:33:51',3310504762,1),(526432162,425973880,17116352,2788608,1,'2009-10-09 02:33:51',3310504762,1),(526432163,425982920,17101851,2788608,1,'2009-10-09 02:33:51',3310504763,1),(526432165,425998984,17119173,2788608,1,'2009-10-09 02:33:51',3310504763,1),(526432166,426011963,17127268,2788608,1,'2009-10-09 02:33:51',3310504766,1),(526432168,426025015,17149768,2788608,1,'2009-10-09 02:33:51',3310504852,1),(526432169,426025934,17176515,2788608,1,'2009-10-09 02:33:51',3310504852,1),(526432171,426027569,17197079,2788608,1,'2009-10-09 02:33:51',3310504854,1),(526432172,426043595,17206170,2788608,1,'2009-10-09 02:33:51',3310504855,1),(526432174,426052112,17232845,2788608,1,'2009-10-09 02:33:51',3310504855,1),(526432175,426067262,17224449,2788608,1,'2009-10-09 02:33:51',3310504898,1),(526432176,426077867,17216100,2788608,1,'2009-10-09 02:33:52',3310504898,1),(526432178,426086181,17207776,2788608,1,'2009-10-09 02:33:52',3310504899,1),(526432179,426087589,17189237,2788608,1,'2009-10-09 02:33:52',3310504897,1),(526432183,426082900,17166645,2788608,1,'2009-10-09 02:33:52',3310504896,1),(526432185,426075175,17147170,2788608,1,'2009-10-09 02:33:52',3310504896,1),(526432186,426065922,17123595,2788608,1,'2009-10-09 02:33:52',3310504810,1),(526432188,426068031,17094754,2788608,1,'2009-10-09 02:33:52',3310504810,1),(526432189,426071671,17066921,2788608,1,'2009-10-09 02:33:52',3310504808,1),(526432190,426073058,17045298,2788608,1,'2009-10-09 02:33:52',3310504808,1),(526432192,426073600,17008237,2788608,1,'2009-10-09 02:33:52',3310504802,1),(526432193,426084924,16994733,2788608,1,'2009-10-09 02:33:52',3310504803,1),(526432195,426107701,16989331,2788608,1,'2009-10-09 02:33:52',3310504803,1),(526432196,426121525,17012855,2788608,1,'2009-10-09 02:33:52',3310504806,1),(526432198,426133003,17025085,2788608,1,'2009-10-09 02:33:52',3310504806,1),(526432199,426138477,17050754,2788608,1,'2009-10-09 02:33:52',3310504812,1),(526432200,426149985,17068129,2788608,1,'2009-10-09 02:33:52',3310504813,1),(526432202,426154614,17078375,2788608,1,'2009-10-09 02:33:52',3310504813,1),(526432203,426166088,17097666,2788608,1,'2009-10-09 02:33:52',3310504815,1),(526432205,426173296,17088340,2788608,1,'2009-10-09 02:33:52',3310504826,1),(526432206,426197277,17041792,2788608,1,'2009-10-09 02:33:52',3310504825,1),(526432208,426203968,17028814,2788608,1,'2009-10-09 02:33:52',3310504819,1),(526432212,426207390,17019095,2788608,1,'2009-10-09 02:33:53',3310504819,1),(526432213,426211883,17006339,2788608,1,'2009-10-09 02:33:53',3310504819,1),(526432214,426215438,17000220,2788608,1,'2009-10-09 02:33:53',3310504819,1),(526432216,426220668,16996393,2788608,1,'2009-10-09 02:33:53',3310504819,1),(526432217,426226006,16986037,2788608,1,'2009-10-09 02:33:53',3310504822,1),(526432219,426225270,16977571,2788608,1,'2009-10-09 02:33:53',3310504822,1),(526432220,426225806,16975300,2788608,1,'2009-10-09 02:33:53',3310504822,1),(526432222,426223311,16965357,2788608,1,'2009-10-09 02:33:53',3310504820,1),(526432223,426223422,16961525,2788608,1,'2009-10-09 02:33:53',3310504820,1),(526432225,426223505,16958454,2788608,1,'2009-10-09 02:33:53',3310504820,1),(526432226,426222606,16947155,2788608,1,'2009-10-09 02:33:53',3310504820,1),(526432228,426208192,16950720,2788608,1,'2009-10-09 02:33:53',3310504817,1),(526432229,426198288,16963217,2788608,1,'2009-10-09 02:33:53',3310504817,1),(526432231,426187519,16970091,2788608,1,'2009-10-09 02:33:53',3310504816,1),(526432232,426173329,16962368,2788608,1,'2009-10-09 02:33:53',3310504816,1),(526432234,426159007,16930998,2788608,1,'2009-10-09 02:33:53',3310504805,1),(526432235,426166038,16896602,2788608,1,'2009-10-09 02:33:53',3310504783,1),(526432237,426170311,16875702,2788608,1,'2009-10-09 02:33:53',3310504794,1),(526432240,426159323,16846554,2788608,1,'2009-10-09 02:33:53',3310504781,1),(526432242,426150853,16821877,2788608,1,'2009-10-09 02:33:54',3310504781,1),(526432243,426131720,16820968,2788608,1,'2009-10-09 02:33:54',3310504780,1),(526432245,426127372,16789490,2788608,1,'2009-10-09 02:33:54',3310504774,1),(526432246,426139702,16766835,2788608,1,'2009-10-09 02:33:54',3310504775,1),(526432248,426153789,16757670,2788608,1,'2009-10-09 02:33:54',3310504775,1),(526432249,426152814,16736290,2788608,1,'2009-10-09 02:33:54',3310504773,1),(526432251,426163529,16719275,2788608,1,'2009-10-09 02:33:54',3310504773,1),(526432252,426175013,16694369,2788608,1,'2009-10-09 02:33:54',3310504442,1),(526432254,426167434,16679821,2788608,1,'2009-10-09 02:33:54',3310504442,1),(526432255,426154013,16660834,2788608,1,'2009-10-09 02:33:54',3310504431,1),(526432257,426160565,16646122,2788608,1,'2009-10-09 02:33:54',3310504431,1),(526432258,426156355,16637166,2788608,1,'2009-10-09 02:33:54',3310504429,1),(526432260,426141360,16633959,2788608,1,'2009-10-09 02:33:54',3310504429,1),(526432261,426124794,16643163,2788608,1,'2009-10-09 02:33:54',3310504428,1),(526432263,426113004,16619654,2788608,1,'2009-10-09 02:33:54',3310504428,1),(526432264,426120380,16603808,2788608,1,'2009-10-09 02:33:54',3310504428,1),(526432266,426132746,16585647,2788608,1,'2009-10-09 02:33:54',3310504422,1),(526432269,426150164,16579813,2788608,1,'2009-10-09 02:33:54',3310504423,1),(526432271,426158424,16570711,2788608,1,'2009-10-09 02:33:54',3310504423,1),(526432272,426160807,16553798,2788608,1,'2009-10-09 02:33:55',3310504423,1),(526432274,426170677,16536789,2788608,1,'2009-10-09 02:33:55',3310504434,1),(526432275,426177297,16531080,2788608,1,'2009-10-09 02:33:55',3310504432,1),(526432277,426173028,16513120,2788608,1,'2009-10-09 02:33:55',3310504432,1),(526432278,426186271,16503951,2788608,1,'2009-10-09 02:33:55',3310504432,1),(526432279,426197874,16498182,2788608,1,'2009-10-09 02:33:55',3310504433,1),(526432281,426198646,16489167,2788608,1,'2009-10-09 02:33:55',3310504433,1),(526432282,426210228,16480024,2788608,1,'2009-10-09 02:33:55',3310504433,1),(526432284,426212621,16463101,2788608,1,'2009-10-09 02:33:55',3310504411,1),(526432286,426217520,16450093,2788608,1,'2009-10-09 02:33:55',3310504411,1),(526432287,426224934,16438748,2788608,1,'2009-10-09 02:33:55',3310504414,1),(526432289,426230848,16436893,2788608,1,'2009-10-09 02:33:55',3310504414,1),(526432290,426239401,16455514,2788608,1,'2009-10-09 02:33:55',3310504414,1),(526432292,426251925,16463247,2788608,1,'2009-10-09 02:33:55',3310504415,1),(526432293,426273318,16428082,2788608,1,'2009-10-09 02:33:55',3310504415,1),(526432295,426276556,16414529,2788608,1,'2009-10-09 02:33:55',3310505096,1),(526432296,426258136,16395606,2788608,1,'2009-10-09 02:33:55',3310504413,1),(526432300,426258025,16378716,2788608,1,'2009-10-09 02:33:55',3310504413,1),(526432302,426262874,16357261,2788608,1,'2009-10-09 02:33:55',3310504407,1),(526432303,426265879,16308800,2788608,1,'2009-10-09 02:33:55',3310504405,1),(526432304,426251608,16288704,2788608,1,'2009-10-09 02:33:55',3310504405,1),(526432306,426245970,16288979,2788608,1,'2009-10-09 02:33:56',3310504404,1),(526432307,426247921,16268426,2788608,1,'2009-10-09 02:33:56',3310504404,1),(526432309,426254487,16254832,2788608,1,'2009-10-09 02:33:56',3310504319,1),(526432311,426265049,16261452,2788608,1,'2009-10-09 02:33:56',3310504405,1),(526432312,426265700,16258069,2788608,1,'2009-10-09 02:33:56',3310504319,1),(526432314,426266083,16256628,2788608,1,'2009-10-09 02:33:56',3310504319,1),(526432315,426267573,16251099,2788608,1,'2009-10-09 02:33:56',3310504319,1),(526432317,426268876,16237881,2788608,1,'2009-10-09 02:33:56',3310504319,1),(526432318,426271521,16230552,2788608,1,'2009-10-09 02:33:56',3310504319,1),(526432320,426273067,16224992,2788608,1,'2009-10-09 02:33:56',3310504319,1),(526432321,426273560,16223230,2788608,1,'2009-10-09 02:33:56',3310504319,1),(526432323,426272991,16222006,2788608,1,'2009-10-09 02:33:56',3310504319,1),(526432324,426269619,16214766,2788608,1,'2009-10-09 02:33:56',3310504319,1),(526432326,426268132,16212223,2788608,1,'2009-10-09 02:33:56',3310504319,1),(526432328,426258263,16195328,2788608,1,'2009-10-09 02:33:56',3310504317,1),(526432329,426240610,16169425,2788608,1,'2009-10-09 02:33:56',3310504316,1),(526432330,426218774,16139289,2788608,1,'2009-10-09 02:33:56',3310504307,1),(526432331,426203050,16149623,2788608,1,'2009-10-09 02:33:56',3310504307,1),(526432332,426178106,16151058,2788608,1,'2009-10-09 02:33:56',3310504312,1),(526432333,426153272,16167128,2788608,1,'2009-10-09 02:33:56',3310504301,1),(526432334,426142532,16177398,2788608,1,'2009-10-09 02:33:57',3310504301,1),(526432335,426126065,16202367,2788608,1,'2009-10-09 02:33:57',3310504300,1),(526432336,426120350,16217080,2788608,1,'2009-10-09 02:33:57',3310504302,1),(526432337,426123838,16241801,2788608,1,'2009-10-09 02:33:57',3310504302,1),(526432338,426120674,16265486,2788608,1,'2009-10-09 02:33:57',3310504388,1),(526432339,426107460,16280283,2788608,1,'2009-10-09 02:33:57',3310504385,1),(526432340,426107250,16280229,2788608,1,'2009-10-09 02:33:57',3310504385,1),(526432341,426059116,16230265,2788608,1,'2009-10-09 02:33:57',3310504298,1),(526432342,426042850,16228930,2788608,1,'2009-10-09 02:33:57',3310504255,1),(526432343,426033920,16226025,2788608,1,'2009-10-09 02:33:57',3310504255,1),(526432344,426023737,16195753,2788608,1,'2009-10-09 02:33:57',3310504252,1),(526432345,426006912,16167822,2788608,1,'2009-10-09 02:33:57',3310504252,1),(526432349,426007536,16137418,2788608,1,'2009-10-09 02:33:57',3310504246,1),(526432350,426024040,16118082,2788608,1,'2009-10-09 02:33:57',3310504246,1),(526432352,426021464,16105730,2788608,1,'2009-10-09 02:33:57',3310504246,1),(526432353,426042989,16091952,2788608,1,'2009-10-09 02:33:57',3310504245,1),(526432355,426035356,16070661,2788608,1,'2009-10-09 02:33:57',3310504245,1),(526432356,426050997,16046820,2788608,1,'2009-10-09 02:33:57',3310504245,1),(526432358,426052440,16015279,2788608,1,'2009-10-09 02:33:57',3310504223,1),(526432359,426039751,15983925,2788608,1,'2009-10-09 02:33:57',3310504221,1),(526432361,426010412,15950529,2788608,1,'2009-10-09 02:33:57',3310504220,1),(526432363,425984919,15940881,2788608,1,'2009-10-09 02:33:58',3310504217,1),(526432364,425973437,15963545,2788608,1,'2009-10-09 02:33:58',3310504216,1),(526432366,425963679,15995180,2788608,1,'2009-10-09 02:33:58',3310504218,1),(526432367,425957218,16023407,2788608,1,'2009-10-09 02:33:58',3310504218,1),(526432369,425939862,16039382,2788608,1,'2009-10-09 02:33:58',3310504207,1),(526432370,425925583,16018179,2788608,1,'2009-10-09 02:33:58',3310504207,1),(526432372,425924769,16011927,2788608,1,'2009-10-09 02:33:58',3310504207,1),(526432373,425932664,15979710,2788608,1,'2009-10-09 02:33:58',3310504205,1),(526432374,425918434,15966386,2788608,1,'2009-10-09 02:33:58',3310504204,1),(526432378,425936602,15948146,2788608,1,'2009-10-09 02:33:58',3310504205,1),(526432380,425933189,15935809,2788608,1,'2009-10-09 02:33:58',3310504205,1),(526432381,425938978,15931233,2788608,1,'2009-10-09 02:33:58',3310504205,1),(526432383,425956424,15928758,2788608,1,'2009-10-09 02:33:58',3310504210,1),(526432384,425964660,15917397,2788608,1,'2009-10-09 02:33:58',3310504210,1),(526432385,425969216,15906364,2788608,1,'2009-10-09 02:33:58',3310504210,1),(526432387,425977108,15894694,2788608,1,'2009-10-09 02:33:58',3310504211,1),(526432389,425975847,15862348,2788608,1,'2009-10-09 02:33:58',3310504209,1),(526432390,425975618,15829989,2788608,1,'2009-10-09 02:33:58',3310504209,1),(526432391,425977515,15804644,2788608,1,'2009-10-09 02:33:58',3310502843,1),(526432393,425964913,15787921,2788608,1,'2009-10-09 02:33:58',3310502842,1),(526432395,425941027,15789639,2788608,1,'2009-10-09 02:33:58',3310502831,1),(526432396,425929680,15802450,2788608,1,'2009-10-09 02:33:59',3310502831,1),(526432398,425917490,15813441,2788608,1,'2009-10-09 02:33:59',3310502830,1),(526432399,425895936,15822730,2788608,1,'2009-10-09 02:33:59',3310504196,1),(526432401,425876875,15831979,2788608,1,'2009-10-09 02:33:59',3310504193,1),(526432402,425869292,15818573,2788608,1,'2009-10-09 02:33:59',3310502827,1),(526432404,425869915,15789307,2788608,1,'2009-10-09 02:33:59',3310502827,1),(526432408,425875506,15756597,2788608,1,'2009-10-09 02:33:59',3310502825,1),(526432409,425882831,15733995,2788608,1,'2009-10-09 02:33:59',3310502825,1),(526432411,425876900,15719436,2788608,1,'2009-10-09 02:33:59',3310502825,1),(526432412,425867084,15709259,2788608,1,'2009-10-09 02:33:59',3310502819,1),(526432414,425873536,15691940,2788608,1,'2009-10-09 02:33:59',3310502819,1),(526432415,425879359,15679110,2788608,1,'2009-10-09 02:33:59',3310502819,1),(526432417,425941368,15571673,2788608,1,'2009-10-09 02:33:59',3310502799,1),(526432418,425948341,15564287,2788608,1,'2009-10-09 02:33:59',3310502810,1),(526432420,425962228,15535537,2788608,1,'2009-10-09 02:33:59',3310502808,1),(526432421,425967580,15539067,2788608,1,'2009-10-09 02:33:59',3310502808,1),(526432423,425967226,15579692,2788608,1,'2009-10-09 02:33:59',3310502810,1),(526432424,425966872,15644980,2788608,1,'2009-10-09 02:33:59',3310502832,1),(526432426,425977730,15651589,2788608,1,'2009-10-09 02:33:59',3310502833,1),(526432427,425988004,15652321,2788608,1,'2009-10-09 02:33:59',3310502833,1),(526432429,425987899,15659582,2788608,1,'2009-10-09 02:33:59',3310502835,1),(526432430,426002528,15669241,2788608,1,'2009-10-09 02:34:00',3310502838,1),(526432432,426018036,15657776,2788608,1,'2009-10-09 02:34:00',3310502838,1),(526432433,426027079,15615445,2788608,1,'2009-10-09 02:34:00',3310502836,1),(526432435,426039467,15602614,2788608,1,'2009-10-09 02:34:00',3310502837,1),(526432438,426049650,15585231,2788608,1,'2009-10-09 02:34:00',3310502815,1),(526432440,426057969,15593108,2788608,1,'2009-10-09 02:34:00',3310502858,1),(526432441,426068910,15610974,2788608,1,'2009-10-09 02:34:00',3310502880,1),(526432443,426086331,15605111,2788608,1,'2009-10-09 02:34:00',3310502881,1),(526432444,426093938,15621897,2788608,1,'2009-10-09 02:34:00',3310502881,1),(526432446,426108083,15622834,2788608,1,'2009-10-09 02:34:00',3310502881,1),(526432447,426111190,15620515,2788608,1,'2009-10-09 02:34:00',3310502881,1),(526432449,426113936,15627259,2788608,1,'2009-10-09 02:34:00',3310502884,1),(526432450,426095880,15660149,2788608,1,'2009-10-09 02:34:00',3310502883,1),(526432452,426105633,15672287,2788608,1,'2009-10-09 02:34:00',3310502883,1),(526432453,426099322,15686245,2788608,1,'2009-10-09 02:34:00',3310502883,1),(526432455,426092283,15718707,2788608,1,'2009-10-09 02:34:00',3310502889,1),(526432456,426071708,15748535,2788608,1,'2009-10-09 02:34:00',3310502888,1),(526432458,426072992,15783697,2788608,1,'2009-10-09 02:34:00',3310502890,1),(526432459,426079513,15823015,2788608,1,'2009-10-09 02:34:00',3310504256,1),(526432461,426093087,15831280,2788608,1,'2009-10-09 02:34:00',3310504257,1),(526432462,426121118,15826691,2788608,1,'2009-10-09 02:34:00',3310504260,1),(526432464,426133438,15805421,2788608,1,'2009-10-09 02:34:01',3310502894,1),(526432467,426152179,15809402,2788608,1,'2009-10-09 02:34:01',3310502895,1),(526432469,426183280,15797734,2788608,1,'2009-10-09 02:34:01',3310502906,1),(526432470,426187734,15838493,2788608,1,'2009-10-09 02:34:01',3310504272,1),(526432472,426166152,15873958,2788608,1,'2009-10-09 02:34:01',3310504261,1),(526432473,426168439,15896039,2788608,1,'2009-10-09 02:34:01',3310504274,1),(526432475,426159261,15918273,2788608,1,'2009-10-09 02:34:01',3310504263,1),(526432476,426157058,15959961,2788608,1,'2009-10-09 02:34:01',3310504269,1),(526432478,426152978,15971272,2788608,1,'2009-10-09 02:34:01',3310504269,1),(526432479,426159709,15982446,2788608,1,'2009-10-09 02:34:01',3310504269,1),(526432481,426154884,16006152,2788608,1,'2009-10-09 02:34:01',3310504271,1),(526432482,426169953,16020598,2788608,1,'2009-10-09 02:34:01',3310504282,1),(526432484,426190842,16034971,2788608,1,'2009-10-09 02:34:01',3310504282,1),(526432485,426214133,16035802,2788608,1,'2009-10-09 02:34:01',3310504283,1),(526432486,426213962,16011032,2788608,1,'2009-10-09 02:34:01',3310504283,1),(526432488,426237764,15965686,2788608,1,'2009-10-09 02:34:01',3310504284,1),(526432489,426242643,15949858,2788608,1,'2009-10-09 02:34:01',3310504284,1),(526432491,426280086,15952757,2788608,1,'2009-10-09 02:34:01',3310504968,1),(526432492,426313167,15926430,2788608,1,'2009-10-09 02:34:02',3310504963,1),(526432496,426293733,15882758,2788608,1,'2009-10-09 02:34:02',3310504962,1),(526432497,426312747,15866745,2788608,1,'2009-10-09 02:34:02',3310504961,1),(526432499,426314259,15845327,2788608,1,'2009-10-09 02:34:02',3310504961,1),(526432500,426321591,15823833,2788608,1,'2009-10-09 02:34:02',3310504961,1),(526432502,426321949,15805240,2788608,1,'2009-10-09 02:34:02',3310503595,1),(526432503,426329746,15801201,2788608,1,'2009-10-09 02:34:02',3310503595,1),(526432505,426327866,15770816,2788608,1,'2009-10-09 02:34:02',3310503595,1),(526432506,426322005,15765262,2788608,1,'2009-10-09 02:34:02',3310503593,1),(526432507,426320100,15731499,2788608,1,'2009-10-09 02:34:02',3310503593,1),(526432509,426318554,15719653,2788608,1,'2009-10-09 02:34:02',3310503593,1),(526432511,426326122,15711402,2788608,1,'2009-10-09 02:34:02',3310503593,1),(526432527,426332046,15669082,2788613,1,'2009-10-09 02:34:04',3310503590,1),(526432529,426347565,15659024,2788613,1,'2009-10-09 02:34:04',3310503590,1),(526432530,426379679,15643112,2788613,1,'2009-10-09 02:34:04',3310503589,1),(526432531,426397428,15654134,2788613,1,'2009-10-09 02:34:04',3310503600,1),(526432532,426396742,15702015,2788613,1,'2009-10-09 02:34:04',3310503602,1),(526432534,426401199,15744202,2788613,1,'2009-10-09 02:34:04',3310503608,1),(526432537,426407611,15768050,2788613,1,'2009-10-09 02:34:04',3310503610,1),(526432538,426400048,15792051,2788613,1,'2009-10-09 02:34:04',3310503610,1),(526432539,426392527,15811040,2788613,1,'2009-10-09 02:34:04',3310503610,1),(526432540,426386647,15819160,2788613,1,'2009-10-09 02:34:04',3310503610,1),(526432541,426387985,15841675,2788613,1,'2009-10-09 02:34:04',3310504976,1),(526432543,426379147,15850639,2788613,1,'2009-10-09 02:34:04',3310504965,1),(526432544,426368495,15857216,2788613,1,'2009-10-09 02:34:04',3310504965,1),(526432546,426369169,15868466,2788613,1,'2009-10-09 02:34:04',3310504965,1),(526432547,426372819,15879685,2788613,1,'2009-10-09 02:34:05',3310504967,1),(526432549,426378258,15893290,2788613,1,'2009-10-09 02:34:05',3310504967,1),(526432550,426383691,15906091,2788613,1,'2009-10-09 02:34:05',3310504967,1),(526432552,426388563,15923733,2788613,1,'2009-10-09 02:34:05',3310504978,1),(526432553,426381509,15934284,2788613,1,'2009-10-09 02:34:05',3310504973,1),(526432555,426369078,15940069,2788613,1,'2009-10-09 02:34:05',3310504973,1),(526432556,426361400,15946606,2788613,1,'2009-10-09 02:34:05',3310504973,1),(526432558,426358538,15961124,2788613,1,'2009-10-09 02:34:05',3310504973,1),(526432559,426349699,15971697,2788613,1,'2009-10-09 02:34:05',3310504972,1),(526432561,426339035,15976660,2788613,1,'2009-10-09 02:34:05',3310504972,1),(526432564,426322429,15979282,2788613,1,'2009-10-09 02:34:05',3310504969,1),(526432566,426314756,15986623,2788613,1,'2009-10-09 02:34:05',3310504971,1),(526432567,426316602,15995448,2788613,1,'2009-10-09 02:34:05',3310504971,1),(526432569,426314918,16009949,2788613,1,'2009-10-09 02:34:05',3310504971,1),(526432570,426322140,16023532,2788613,1,'2009-10-09 02:34:05',3310504971,1),(526432572,426322830,16037206,2788613,1,'2009-10-09 02:34:05',3310504971,1),(526432573,426329462,16051602,2788613,1,'2009-10-09 02:34:05',3310504993,1),(526432575,426334877,16061986,2788613,1,'2009-10-09 02:34:05',3310504996,1),(526432576,426337334,16073220,2788613,1,'2009-10-09 02:34:05',3310504996,1),(526432578,426336833,16086901,2788613,1,'2009-10-09 02:34:05',3310504996,1),(526432579,426330989,16100650,2788613,1,'2009-10-09 02:34:05',3310504998,1),(526432581,426317940,16103231,2788613,1,'2009-10-09 02:34:05',3310504995,1),(526432582,426303685,16103409,2788613,1,'2009-10-09 02:34:06',3310504995,1),(526432584,426298970,16109906,2788613,1,'2009-10-09 02:34:06',3310504994,1),(526432585,426300826,16120334,2788613,1,'2009-10-09 02:34:06',3310504994,1),(526432587,426305634,16129130,2788613,1,'2009-10-09 02:34:06',3310504995,1),(526432588,426304003,16150060,2788613,1,'2009-10-09 02:34:06',3310504995,1),(526432590,426299282,16155751,2788613,1,'2009-10-09 02:34:06',3310505000,1),(526432593,426296400,16167857,2788613,1,'2009-10-09 02:34:06',3310505000,1),(526432595,426299462,16182299,2788613,1,'2009-10-09 02:34:06',3310505000,1),(526432596,426297742,16191974,2788613,1,'2009-10-09 02:34:06',3310505000,1),(526432598,426296269,16211541,2788613,1,'2009-10-09 02:34:06',3310505002,1),(526432600,426297381,16224958,2788613,1,'2009-10-09 02:34:06',3310505002,1),(526432601,426303400,16236947,2788613,1,'2009-10-09 02:34:06',3310505002,1),(526432603,426311171,16244095,2788613,1,'2009-10-09 02:34:06',3310505003,1),(526432604,426307757,16267465,2788613,1,'2009-10-09 02:34:06',3310505089,1),(526432606,426317166,16276091,2788613,1,'2009-10-09 02:34:06',3310505089,1),(526432607,426318789,16278861,2788613,1,'2009-10-09 02:34:06',3310505089,1),(526432609,426324763,16282489,2788613,1,'2009-10-09 02:34:06',3310505089,1),(526432610,426328229,16287091,2788613,1,'2009-10-09 02:34:06',3310505089,1),(526432611,426331012,16292013,2788613,1,'2009-10-09 02:34:06',3310505092,1),(526432613,426334488,16298166,2788613,1,'2009-10-09 02:34:06',3310505092,1),(526432614,426336819,16304340,2788613,1,'2009-10-09 02:34:06',3310505092,1),(526432616,426337553,16311773,2788613,1,'2009-10-09 02:34:07',3310505092,1),(526432618,426338739,16317961,2788613,1,'2009-10-09 02:34:07',3310505094,1),(526432619,426341045,16320411,2788613,1,'2009-10-09 02:34:07',3310505094,1),(526432642,426324069,16382720,2788613,1,'2009-10-09 02:34:07',3310505097,1),(526432643,426318802,16382495,2788613,1,'2009-10-09 02:34:07',3310505097,1),(526432645,426311003,16398277,2788613,1,'2009-10-09 02:34:07',3310505097,1),(526432647,426314061,16412728,2788613,1,'2009-10-09 02:34:07',3310505097,1),(526432648,426317678,16419921,2788613,1,'2009-10-09 02:34:07',3310505097,1),(526433326,425836517,17663623,2788613,1,'2009-10-09 02:34:35',3310510167,1),(526433329,425836412,17646263,2788613,1,'2009-10-09 02:34:35',3310510167,1),(526433330,425840207,17627610,2788613,1,'2009-10-09 02:34:35',3310510336,1),(526433332,425847187,17608615,2788613,1,'2009-10-09 02:34:35',3310510336,1),(526433334,425855988,17586175,2788613,1,'2009-10-09 02:34:35',3310510336,1),(526433335,425858330,17581367,2788613,1,'2009-10-09 02:34:35',3310510336,1),(526433336,425864813,17568079,2788613,1,'2009-10-09 02:34:35',3310504875,1),(526433338,425870043,17561814,2788613,1,'2009-10-09 02:34:35',3310504875,1),(526433339,425877100,17557072,2788613,1,'2009-10-09 02:34:35',3310504875,1),(526433343,425879603,17553006,2788613,1,'2009-10-09 02:34:35',3310504875,1),(526433344,425893195,17534276,2788613,1,'2009-10-09 02:34:35',3310504878,1),(526433351,425916937,17467635,2788613,1,'2009-10-09 02:34:36',3310504870,1),(526433352,425925154,17449541,2788613,1,'2009-10-09 02:34:36',3310504871,1),(526433354,425933320,17422446,2788613,1,'2009-10-09 02:34:36',3310504871,1),(526433355,425938051,17377376,2788613,1,'2009-10-09 02:34:36',3310504869,1),(526433357,425948016,17375024,2788613,1,'2009-10-09 02:34:36',3310504880,1),(526433358,425957062,17356920,2788613,1,'2009-10-09 02:34:36',3310504858,1),(526433360,425966989,17347815,2788613,1,'2009-10-09 02:34:36',3310504858,1),(526435772,425171383,17217950,2788623,1,'2009-10-09 02:36:04',3310493591,1),(526435773,425154623,17195648,2788623,1,'2009-10-09 02:36:04',3310493591,1),(526435775,425142793,17163179,2788623,1,'2009-10-09 02:36:04',3310493588,1),(526435776,425131746,17122836,2788623,1,'2009-10-09 02:36:04',3310493502,1),(526435778,425136622,17103676,2788623,1,'2009-10-09 02:36:04',3310493502,1),(526435779,425162291,17085415,2788623,1,'2009-10-09 02:36:04',3310493503,1),(526435781,425163055,17074167,2788623,1,'2009-10-09 02:36:04',3310493501,1),(526435783,425181274,17061605,2788623,1,'2009-10-09 02:36:04',3310493544,1),(526435784,425186209,17052559,2788623,1,'2009-10-09 02:36:04',3310493544,1),(526435785,425182796,17037984,2788623,1,'2009-10-09 02:36:04',3310493544,1),(526435787,425169479,17035881,2788623,1,'2009-10-09 02:36:04',3310493501,1),(526435788,425159515,17038238,2788623,1,'2009-10-09 02:36:05',3310493501,1),(526435790,425132077,17038537,2788623,1,'2009-10-09 02:36:05',3310493500,1),(526435791,425106457,17064666,2788623,1,'2009-10-09 02:36:05',3310493497,1),(526435793,425082405,17075042,2788623,1,'2009-10-09 02:36:05',3310493496,1),(526435794,425064944,17075231,2788623,1,'2009-10-09 02:36:05',3310493485,1),(526435796,425052352,17055139,2788623,1,'2009-10-09 02:36:05',3310493485,1),(526435798,425043052,17029394,2788623,1,'2009-10-09 02:36:05',3310493485,1),(526435800,425038816,17022075,2788623,1,'2009-10-09 02:36:05',3310493478,1),(526435802,425040374,17016220,2788623,1,'2009-10-09 02:36:05',3310493479,1),(526435808,425042731,16993714,2788623,1,'2009-10-09 02:36:05',3310493479,1),(526435811,425050891,16967776,2788623,1,'2009-10-09 02:36:05',3310493477,1),(526435812,425055684,16936262,2788623,1,'2009-10-09 02:36:05',3310493477,1),(526435815,425045611,16920636,2788623,1,'2009-10-09 02:36:06',3310493477,1),(526435816,425026398,16906242,2788623,1,'2009-10-09 02:36:06',3310493454,1),(526435818,425022938,16883808,2788623,1,'2009-10-09 02:36:06',3310493454,1),(526435820,425042021,16876853,2788623,1,'2009-10-09 02:36:06',3310493455,1),(526435821,425057747,16864314,2788623,1,'2009-10-09 02:36:06',3310493455,1),(526435824,425061838,16854158,2788623,1,'2009-10-09 02:36:06',3310493453,1),(526435826,425071649,16827076,2788623,1,'2009-10-09 02:36:06',3310493464,1),(526435827,425061568,16810329,2788623,1,'2009-10-09 02:36:06',3310493453,1),(526435828,425044935,16810516,2788623,1,'2009-10-09 02:36:06',3310493453,1),(526435830,425031559,16798305,2788623,1,'2009-10-09 02:36:06',3310493446,1),(526435831,425023878,16766933,2788623,1,'2009-10-09 02:36:06',3310493446,1),(526435851,424996365,16660950,2788623,1,'2009-10-09 02:36:07',3310493099,1),(526435853,424997470,16659944,2788623,1,'2009-10-09 02:36:07',3310493099,1),(526435854,425168968,16611762,2788623,1,'2009-10-09 02:36:07',3310493117,1),(526435856,425332962,16653895,2788623,1,'2009-10-09 02:36:07',3310493179,1),(526435858,425331734,16665611,2788623,1,'2009-10-09 02:36:07',3310493179,1),(526435859,425340185,16686874,2788623,1,'2009-10-09 02:36:07',3310493179,1),(526435861,425353584,16702466,2788623,1,'2009-10-09 02:36:07',3310493524,1),(526435862,425347074,16723902,2788623,1,'2009-10-09 02:36:07',3310493524,1),(526435864,425339714,16744225,2788623,1,'2009-10-09 02:36:07',3310493521,1),(526435865,425342311,16761056,2788623,1,'2009-10-09 02:36:07',3310493526,1),(526435867,425342451,16783547,2788623,1,'2009-10-09 02:36:07',3310493526,1),(526435880,425330100,16802794,2788624,1,'2009-10-09 02:36:09',3310493523,1),(526435881,425305877,16786208,2788624,1,'2009-10-09 02:36:09',3310493522,1),(526435883,425292465,16768369,2788624,1,'2009-10-09 02:36:09',3310493522,1),(526435884,425291600,16762757,2788624,1,'2009-10-09 02:36:09',3310493522,1),(526435885,425275846,16770812,2788624,1,'2009-10-09 02:36:09',3310493511,1),(526435887,425258331,16760889,2788624,1,'2009-10-09 02:36:09',3310493510,1),(526435888,425246468,16725054,2788624,1,'2009-10-09 02:36:09',3310493508,1),(526435889,425238784,16693663,2788624,1,'2009-10-09 02:36:09',3310493166,1),(526435891,425222953,16689346,2788624,1,'2009-10-09 02:36:09',3310493163,1),(526435892,425209541,16671521,2788624,1,'2009-10-09 02:36:09',3310493163,1),(526435894,425188762,16672883,2788624,1,'2009-10-09 02:36:09',3310493162,1),(526435895,425172101,16668576,2788624,1,'2009-10-09 02:36:09',3310493119,1),(526435896,425155383,16655282,2788624,1,'2009-10-09 02:36:09',3310493119,1),(526435898,425137981,16663349,2788624,1,'2009-10-09 02:36:09',3310493118,1),(526435899,425133100,16681391,2788624,1,'2009-10-09 02:36:09',3310493118,1),(526435901,425151571,16709277,2788624,1,'2009-10-09 02:36:09',3310493461,1),(526435902,425141692,16725130,2788624,1,'2009-10-09 02:36:09',3310493460,1),(526435903,425128491,16741014,2788624,1,'2009-10-09 02:36:09',3310493460,1),(526435905,425123623,16761300,2788624,1,'2009-10-09 02:36:09',3310493462,1),(526435906,425128806,16791583,2788624,1,'2009-10-09 02:36:09',3310493462,1),(526435907,425128966,16817433,2788624,1,'2009-10-09 02:36:10',3310493468,1),(526435908,425117425,16833303,2788624,1,'2009-10-09 02:36:10',3310493465,1),(526435909,425122602,16864710,2788624,1,'2009-10-09 02:36:10',3310493470,1),(526435910,425116873,16880514,2788624,1,'2009-10-09 02:36:10',3310493467,1),(526435912,425105317,16894130,2788624,1,'2009-10-09 02:36:10',3310493467,1),(526435913,425098803,16915554,2788624,1,'2009-10-09 02:36:10',3310493467,1),(526435914,425091502,16945976,2788624,1,'2009-10-09 02:36:10',3310493488,1),(526435916,425085820,16969643,2788624,1,'2009-10-09 02:36:10',3310493488,1),(526435917,425084301,16993257,2788624,1,'2009-10-09 02:36:10',3310493490,1),(526435918,425089437,17016805,2788624,1,'2009-10-09 02:36:10',3310493490,1),(526435920,425100258,17018932,2788624,1,'2009-10-09 02:36:10',3310493491,1),(526435921,425118484,17007491,2788624,1,'2009-10-09 02:36:10',3310493491,1),(526435923,425139283,17009516,2788624,1,'2009-10-09 02:36:10',3310493494,1),(526435924,425157599,17014937,2788624,1,'2009-10-09 02:36:10',3310493495,1),(526435926,425181772,17023662,2788624,1,'2009-10-09 02:36:10',3310493538,1),(526435927,425236944,17073649,2788624,1,'2009-10-09 02:36:10',3310493548,1),(526435928,425233117,17081178,2788624,1,'2009-10-09 02:36:10',3310493548,1),(526435930,425225439,17096253,2788624,1,'2009-10-09 02:36:10',3310493547,1),(526435931,425222183,17107532,2788624,1,'2009-10-09 02:36:10',3310493547,1),(526435933,425203204,17132461,2788624,1,'2009-10-09 02:36:10',3310493546,1),(526435934,425195831,17151651,2788624,1,'2009-10-09 02:36:10',3310493632,1),(526435935,425195145,17176389,2788624,1,'2009-10-09 02:36:11',3310493632,1),(526435937,425187771,17195578,2788624,1,'2009-10-09 02:36:11',3310493634,1),(526435953,425192896,17218002,2788624,1,'2009-10-09 02:36:11',3310493634,1),(526435954,425195607,17226864,2788624,1,'2009-10-09 02:36:13',3310493634,1),(526435955,425203813,17232847,2788624,1,'2009-10-09 02:36:13',3310493634,1),(526435956,425211451,17239753,2788624,1,'2009-10-09 02:36:13',3310493635,1),(526436136,425632841,14524924,2788624,1,'2009-10-09 02:36:19',3310502080,1),(526436137,425622011,14512987,2788624,1,'2009-10-09 02:36:19',3310502080,1),(526436139,425615122,14507952,2788624,1,'2009-10-09 02:36:19',3310502037,1),(526436141,425605168,14498850,2788624,1,'2009-10-09 02:36:19',3310501951,1),(526436142,425598089,14471186,2788624,1,'2009-10-09 02:36:19',3310501951,1),(526436144,425586548,14454912,2788624,1,'2009-10-09 02:36:19',3310501950,1),(526436145,425577678,14459975,2788624,1,'2009-10-09 02:36:19',3310501950,1),(526436146,425580264,14431041,2788624,1,'2009-10-09 02:36:19',3310501948,1),(526436148,425583315,14414892,2788624,1,'2009-10-09 02:36:19',3310501948,1),(526436149,425582442,14392609,2788624,1,'2009-10-09 02:36:19',3310501948,1),(526436151,425594096,14308302,2788624,1,'2009-10-09 02:36:19',3310501941,1),(526436152,425594910,14302421,2788624,1,'2009-10-09 02:36:19',3310501941,1),(526436154,425597252,14285510,2788624,1,'2009-10-09 02:36:19',3310501941,1),(526436155,425617253,14335743,2788624,1,'2009-10-09 02:36:19',3310501984,1),(526436157,425639367,14393897,2788624,1,'2009-10-09 02:36:19',3310501992,1),(526436158,425642382,14409453,2788624,1,'2009-10-09 02:36:20',3310501992,1),(526436160,425645460,14408747,2788624,1,'2009-10-09 02:36:20',3310501993,1),(526436161,425655235,14395226,2788624,1,'2009-10-09 02:36:20',3310501993,1),(526436162,425670354,14385736,2788624,1,'2009-10-09 02:36:20',3310501987,1),(526436163,425678120,14404128,2788624,1,'2009-10-09 02:36:20',3310501996,1),(526436164,425675182,14416519,2788624,1,'2009-10-09 02:36:20',3310501996,1),(526436165,425659350,14433217,2788624,1,'2009-10-09 02:36:20',3310501993,1),(526436167,425655824,14465161,2788624,1,'2009-10-09 02:36:20',3310501995,1),(526436168,425649905,14484795,2788624,1,'2009-10-09 02:36:20',3310501995,1),(526436169,425637928,14507604,2788624,1,'2009-10-09 02:36:20',3310502080,1),(526826196,426552316,15644353,2791232,1,'2009-10-09 12:38:34',3310503652,1),(526826197,426558720,15626565,2791232,1,'2009-10-09 12:38:34',3310503652,1),(526826198,426559810,15612870,2791232,1,'2009-10-09 12:38:34',3310503652,1),(526826199,426553154,15596054,2791232,1,'2009-10-09 12:38:34',3310503630,1),(526826200,426557225,15584738,2791232,1,'2009-10-09 12:38:34',3310503630,1),(526827378,426544354,15516754,2791237,1,'2009-10-09 12:39:53',3310503625,1),(526827379,426539487,15528036,2791237,1,'2009-10-09 12:39:54',3310503625,1),(526827380,426537618,15533437,2791237,1,'2009-10-09 12:39:54',3310503625,1),(526827381,426534155,15543415,2791237,1,'2009-10-09 12:39:54',3310503625,1),(526827382,426524944,15569979,2791237,1,'2009-10-09 12:39:54',3310503627,1),(526827383,426523181,15572998,2791237,1,'2009-10-09 12:39:54',3310503626,1),(526827384,426521873,15575236,2791237,1,'2009-10-09 12:39:54',3310503626,1),(526827385,426520552,15578904,2791237,1,'2009-10-09 12:39:54',3310503626,1),(526827386,426521482,15583150,2791237,1,'2009-10-09 12:39:54',3310503626,1),(526827387,426532511,15603897,2791237,1,'2009-10-09 12:39:54',3310503649,1),(526827388,426533383,15606410,2791237,1,'2009-10-09 12:39:54',3310503649,1),(526827389,426533461,15607953,2791237,1,'2009-10-09 12:39:54',3310503649,1),(526827390,426533841,15615346,2791237,1,'2009-10-09 12:39:54',3310503649,1),(526827391,426534656,15617852,2791237,1,'2009-10-09 12:39:54',3310503649,1),(526827392,426534454,15619391,2791237,1,'2009-10-09 12:39:54',3310503649,1),(526827393,426533873,15621315,2791237,1,'2009-10-09 12:39:54',3310503649,1),(526827394,426534734,15623995,2791237,1,'2009-10-09 12:39:54',3310503649,1),(526827395,426524093,15642532,2791237,1,'2009-10-09 12:39:54',3310503649,1),(526827396,426511720,15636112,2791237,1,'2009-10-09 12:39:54',3310503648,1),(526827397,426493114,15638527,2791237,1,'2009-10-09 12:39:54',3310503605,1),(526827398,426478783,15643767,2791237,1,'2009-10-09 12:39:54',3310503605,1),(526827399,426456978,15646217,2791237,1,'2009-10-09 12:39:54',3310503604,1),(526827400,426445888,15658621,2791237,1,'2009-10-09 12:39:54',3310503606,1),(526827401,426436448,15678932,2791237,1,'2009-10-09 12:39:54',3310503603,1),(526827402,426430020,15673254,2791237,1,'2009-10-09 12:39:54',3310503603,1),(526827403,426429414,15662444,2791237,1,'2009-10-09 12:39:55',3310503603,1),(526827405,426422311,15636591,2791237,1,'2009-10-09 12:39:55',3310503601,1),(526827406,426408909,15624514,2791237,1,'2009-10-09 12:39:55',3310503600,1),(526827407,426413080,15611481,2791237,1,'2009-10-09 12:39:55',3310503600,1),(526827410,426424771,15609158,2791237,1,'2009-10-09 12:39:55',3310503601,1),(526827411,426433734,15597504,2791237,1,'2009-10-09 12:39:56',3310503579,1),(526827412,426441119,15588031,2791237,1,'2009-10-09 12:39:56',3310503582,1),(526827413,426446835,15569935,2791237,1,'2009-10-09 12:39:56',3310503582,1),(526827414,426446607,15538934,2791237,1,'2009-10-09 12:39:56',3310503580,1),(526827415,426449609,15512214,2791237,1,'2009-10-09 12:39:56',3310503580,1),(526827416,426451538,15486239,2791237,1,'2009-10-09 12:39:56',3310503574,1),(526827417,426453398,15449445,2791237,1,'2009-10-09 12:39:56',3310503574,1),(526827418,426462988,15451473,2791237,1,'2009-10-09 12:39:56',3310503574,1),(526827419,426473219,15467194,2791237,1,'2009-10-09 12:39:56',3310503575,1),(526827420,426474473,15492412,2791237,1,'2009-10-09 12:39:56',3310503581,1),(526827421,426485162,15498760,2791237,1,'2009-10-09 12:39:56',3310503581,1),(526827422,426495147,15481319,2791237,1,'2009-10-09 12:39:56',3310503575,1),(526827424,426505271,15464430,2791237,1,'2009-10-09 12:39:56',3310503618,1),(526827425,426521953,15472088,2791237,1,'2009-10-09 12:39:56',3310503618,1),(526827426,426535374,15486551,2791237,1,'2009-10-09 12:39:56',3310503619,1),(526827607,426418237,15589060,2791237,1,'2009-10-09 12:40:06',3310503579,1),(526827608,426416479,15566732,2791237,1,'2009-10-09 12:40:06',3310503579,1),(526827609,426413419,15561186,2791237,1,'2009-10-09 12:40:06',3310503579,1),(526827610,426419581,15559582,2791237,1,'2009-10-09 12:40:06',3310503579,1),(526827611,426420279,15541555,2791237,1,'2009-10-09 12:40:06',3310503577,1),(526827612,426417588,15514556,2791237,1,'2009-10-09 12:40:06',3310503577,1),(526827613,426405790,15493315,2791237,1,'2009-10-09 12:40:06',3310503576,1),(526827614,426398824,15451727,2791237,1,'2009-10-09 12:40:06',3310503570,1),(526827615,426410405,15443685,2791237,1,'2009-10-09 12:40:06',3310503570,1),(526827616,426439466,15437372,2791237,1,'2009-10-09 12:40:06',3310503571,1),(526828351,426401318,15564337,2791248,1,'2009-10-09 12:40:52',3310503578,1),(526828352,426393735,15549797,2791248,1,'2009-10-09 12:40:52',3310503578,1),(526828354,426381968,15534189,2791248,1,'2009-10-09 12:40:53',3310503565,1),(526828355,426376071,15523002,2791248,1,'2009-10-09 12:40:53',3310503565,1),(526828356,426366856,15514119,2791248,1,'2009-10-09 12:40:53',3310503565,1),(526828357,426365851,15490475,2791248,1,'2009-10-09 12:40:53',3310503559,1),(526828358,426363972,15461218,2791248,1,'2009-10-09 12:40:53',3310503559,1),(526828359,426347270,15452431,2791248,1,'2009-10-09 12:40:53',3310503558,1),(526828360,426370831,15503427,5709666,1,'2010-09-07 19:40:44',3310503565,2),(526828361,426362830,15419561,2791248,1,'2009-10-09 12:40:53',3310503557,1),(526828362,426363577,15408285,2791248,1,'2009-10-09 12:40:53',3310503557,1),(526828363,426372564,15386762,2791248,1,'2009-10-09 12:40:53',3310503557,1),(526828364,426373242,15366478,2791248,1,'2009-10-09 12:40:53',3310503471,1),(526828365,426360659,15353135,2791248,1,'2009-10-09 12:40:53',3310503471,1),(526828366,426343882,15333094,2791248,1,'2009-10-09 12:40:53',3310503470,1),(526828367,426352800,15302556,2791248,1,'2009-10-09 12:40:53',3310503468,1),(526828368,426380258,15305556,2791248,1,'2009-10-09 12:40:54',3310503469,1),(526828369,426394631,15335766,2791248,1,'2009-10-09 12:40:54',3310503482,1),(526828370,426401480,15362705,2791248,1,'2009-10-09 12:40:54',3310503482,1),(526828371,426409111,15381750,2791248,1,'2009-10-09 12:40:54',3310503568,1),(526828372,426410077,15399762,2791248,1,'2009-10-09 12:40:54',3310503568,1),(526828373,426411974,15431271,2791248,1,'2009-10-09 12:40:54',3310503568,1),(526829149,426245218,17130607,2791251,1,'2009-10-09 12:41:46',3310504830,1),(526829150,426241953,17119448,2791251,1,'2009-10-09 12:41:46',3310504830,1),(526829151,426240327,17114054,2791251,1,'2009-10-09 12:41:46',3310504830,1),(526829153,426238964,17109372,2791251,1,'2009-10-09 12:41:47',3310504830,1),(526829154,426238633,17098903,2791251,1,'2009-10-09 12:41:47',3310504830,1),(526829155,426241272,17093463,2791251,1,'2009-10-09 12:41:47',3310504830,1),(526829156,426244170,17088012,2791251,1,'2009-10-09 12:41:47',3310504830,1),(526829157,426247332,17081845,2791251,1,'2009-10-09 12:41:47',3310504828,1),(526829158,426251576,17078189,2791251,1,'2009-10-09 12:41:47',3310504829,1),(526829159,426253698,17076357,2791251,1,'2009-10-09 12:41:47',3310504829,1),(526829161,426258760,17076302,2791251,1,'2009-10-09 12:41:47',3310504829,1),(526829168,426266344,17050948,2791251,1,'2009-10-09 12:41:47',3310504829,1),(526829170,426267639,17044071,2791251,1,'2009-10-09 12:41:47',3310504829,1),(526829171,426272393,17037521,2791251,1,'2009-10-09 12:41:47',3310504829,1),(526829550,426076953,16975818,2791253,1,'2009-10-09 12:42:11',3310504802,1),(526829551,426064349,16955694,2791253,1,'2009-10-09 12:42:11',3310504800,1),(526829552,426047569,16929987,2791253,1,'2009-10-09 12:42:11',3310504757,1),(526829553,426035820,16912104,2791253,1,'2009-10-09 12:42:11',3310504735,1),(526829554,426019397,16926661,2791253,1,'2009-10-09 12:42:11',3310504756,1),(526829555,426017279,16906871,2791253,1,'2009-10-09 12:42:11',3310504734,1),(526829556,426012401,16870907,2791253,1,'2009-10-09 12:42:11',3310504734,1),(526829557,425998912,16840435,2791253,1,'2009-10-09 12:42:11',3310504729,1),(526829559,425983464,16816300,2791253,1,'2009-10-09 12:42:12',3310504729,1),(526829560,425971393,16801129,2791253,1,'2009-10-09 12:42:12',3310504722,1),(526829562,425954653,16784212,2791253,1,'2009-10-09 12:42:12',3310504722,1),(526829563,425945893,16765404,2791253,1,'2009-10-09 12:42:12',3310504711,1),(526829564,425945116,16693226,2791253,1,'2009-10-09 12:42:12',3310504367,1),(526829565,425967459,16703019,2791253,1,'2009-10-09 12:42:12',3310504720,1),(526829566,425975897,16716740,2791253,1,'2009-10-09 12:42:12',3310504721,1),(526829567,425986249,16740490,2791253,1,'2009-10-09 12:42:12',3310504721,1),(526829569,425989145,16756790,2791253,1,'2009-10-09 12:42:12',3310504723,1),(526829570,425998518,16773017,2791253,1,'2009-10-09 12:42:12',3310504723,1),(526829571,426011625,16790455,2791253,1,'2009-10-09 12:42:12',3310504726,1),(526829574,426023807,16809158,2791253,1,'2009-10-09 12:42:12',3310504726,1),(526829575,426046014,16798855,2791253,1,'2009-10-09 12:42:12',3310504727,1),(526829576,426058018,16788675,2791253,1,'2009-10-09 12:42:12',3310504770,1),(526829577,426054108,16757303,2791253,1,'2009-10-09 12:42:12',3310504727,1),(526829578,426041995,16749904,2791253,1,'2009-10-09 12:42:12',3310504725,1),(526829579,426025230,16740045,2791253,1,'2009-10-09 12:42:12',3310504724,1),(526829580,426015759,16710007,2791253,1,'2009-10-09 12:42:12',3310504724,1),(526829581,426003543,16686278,2791253,1,'2009-10-09 12:42:12',3310504382,1),(526829582,425995349,16668390,2791253,1,'2009-10-09 12:42:12',3310504379,1),(526829584,426014315,16662450,2791253,1,'2009-10-09 12:42:13',3310504382,1),(526829585,426025060,16652199,2791253,1,'2009-10-09 12:42:13',3310504382,1),(526829586,426042471,16645243,2791253,1,'2009-10-09 12:42:13',3310504383,1),(526829587,426060845,16657414,2791253,1,'2009-10-09 12:42:13',3310504426,1),(526829589,426058537,16686707,2791253,1,'2009-10-09 12:42:13',3310504426,1),(526829590,426068686,16713608,2791253,1,'2009-10-09 12:42:13',3310504768,1),(526829591,426073029,16743958,2791253,1,'2009-10-09 12:42:13',3310504768,1),(526829592,426078254,16781045,2791253,1,'2009-10-09 12:42:13',3310504770,1),(526829594,426075944,16810338,2791253,1,'2009-10-09 12:42:13',3310504776,1),(526829595,426069510,16846440,2791253,1,'2009-10-09 12:42:13',3310504776,1),(526829596,426069696,16876830,2791253,1,'2009-10-09 12:42:13',3310504778,1),(526829597,426087230,16887894,2791253,1,'2009-10-09 12:42:13',3310504779,1),(526829598,426107255,16898930,2791253,1,'2009-10-09 12:42:13',3310504779,1),(526829599,426128166,16918962,2791253,1,'2009-10-09 12:42:13',3310504782,1),(526829600,426136701,16954893,2791253,1,'2009-10-09 12:42:13',3310504804,1),(526829601,426146822,16978421,2791253,1,'2009-10-09 12:42:13',3310504807,1),(526829603,426158557,16994059,2791253,1,'2009-10-09 12:42:13',3310504807,1),(526829604,426183666,17021931,2791253,1,'2009-10-09 12:42:13',3310504818,1),(526830271,426038302,16319017,2791257,1,'2009-10-09 12:42:50',3310504343,1),(526830272,426025346,16325458,2791257,1,'2009-10-09 12:42:50',3310504342,1),(526830274,426005819,16319412,2791257,1,'2009-10-09 12:42:51',3310504342,1),(526830275,425978862,16313458,2791257,1,'2009-10-09 12:42:51',3310504337,1),(526830276,425964902,16307345,2791257,1,'2009-10-09 12:42:51',3310504336,1),(526830277,425951896,16306250,2791257,1,'2009-10-09 12:42:51',3310504336,1),(526830278,425938860,16298873,2791257,1,'2009-10-09 12:42:51',3310504325,1),(526830279,425923910,16283977,2791257,1,'2009-10-09 12:42:51',3310504325,1),(526830280,425913780,16296665,2791257,1,'2009-10-09 12:42:51',3310504324,1),(526830281,425909270,16315565,2791257,1,'2009-10-09 12:42:51',3310504326,1),(526830283,425897179,16311937,2791257,1,'2009-10-09 12:42:51',3310504324,1),(526830284,425882288,16305844,2791257,1,'2009-10-09 12:42:51',3310504321,1),(526830285,425864529,16287217,2791257,1,'2009-10-09 12:42:51',3310504321,1),(526830286,425856909,16257165,2791257,1,'2009-10-09 12:42:51',3310504234,1),(526830287,425840095,16242303,2791257,1,'2009-10-09 12:42:51',3310504234,1),(526830288,425838075,16217211,2791257,1,'2009-10-09 12:42:51',3310504234,1),(526830289,425856681,16223263,2791257,1,'2009-10-09 12:42:51',3310504234,1),(526830290,425861257,16214412,2791257,1,'2009-10-09 12:42:51',3310504234,1),(526830291,425871446,16210518,2791257,1,'2009-10-09 12:42:52',3310504235,1),(526830292,425896464,16205181,2791257,1,'2009-10-09 12:42:52',3310504238,1),(526830293,425911245,16194957,2791257,1,'2009-10-09 12:42:52',3310504236,1),(526830294,425903730,16182487,2791257,1,'2009-10-09 12:42:52',3310504236,1),(526830295,425881453,16181509,2791257,1,'2009-10-09 12:42:52',3310504233,1),(526830297,425861892,16170443,2791257,1,'2009-10-09 12:42:52',3310504232,1),(526830298,425855308,16157969,2791257,1,'2009-10-09 12:42:52',3310504232,1),(526830299,425865425,16145281,2791257,1,'2009-10-09 12:42:52',3310504227,1),(526830300,425897865,16138595,2791257,1,'2009-10-09 12:42:52',3310504230,1),(526830301,425920178,16143346,2791257,1,'2009-10-09 12:42:52',3310504231,1),(526830302,425944188,16126715,2791257,1,'2009-10-09 12:42:52',3310504231,1),(526830303,425943517,16146959,2791257,1,'2009-10-09 12:42:52',3310504231,1),(526830304,425950972,16173598,2791257,1,'2009-10-09 12:42:52',3310504248,1),(526830305,425955410,16215756,2791257,1,'2009-10-09 12:42:52',3310504250,1),(526830306,425941944,16222957,2791257,1,'2009-10-09 12:42:52',3310504239,1),(526830307,425923337,16238659,2791257,1,'2009-10-09 12:42:52',3310504239,1),(526830308,425935941,16256796,2791257,1,'2009-10-09 12:42:52',3310504239,1),(526830309,425952686,16274875,2791257,1,'2009-10-09 12:42:52',3310504336,1),(526830310,425969282,16269050,2791257,1,'2009-10-09 12:42:52',3310504336,1),(526830312,425994234,16268745,2791257,1,'2009-10-09 12:42:52',3310504337,1),(526830313,426006826,16286877,2791257,1,'2009-10-09 12:42:52',3310504340,1),(526830314,426022472,16295134,2791257,1,'2009-10-09 12:42:52',3310504340,1),(526830315,426033919,16296400,2791257,1,'2009-10-09 12:42:52',3310504341,1),(526831529,425713095,14766183,2791267,1,'2009-10-09 12:44:07',3310502117,1),(526831530,425706072,14779142,2791267,1,'2009-10-09 12:44:07',3310502119,1),(526831531,425574208,14587765,2791267,1,'2009-10-09 12:44:07',3310502038,1),(526831532,425583892,14592759,2791267,1,'2009-10-09 12:44:07',3310502038,1),(526831533,425593847,14600838,2791267,1,'2009-10-09 12:44:07',3310502039,1),(526831534,425603622,14588345,2791267,1,'2009-10-09 12:44:07',3310502039,1),(526831535,425618177,14601495,2791267,1,'2009-10-09 12:44:07',3310502082,1),(526831536,425623386,14588046,2791267,1,'2009-10-09 12:44:07',3310502082,1),(526831537,425630054,14566345,2791267,1,'2009-10-09 12:44:07',3310502082,1),(526831538,425634729,14557512,2791267,1,'2009-10-09 12:44:07',3310502082,1),(526831539,425640677,14564126,2791267,1,'2009-10-09 12:44:07',3310502082,1),(526831540,425655927,14569043,2791267,1,'2009-10-09 12:44:07',3310502083,1),(526831541,425665573,14541122,2791267,1,'2009-10-09 12:44:07',3310502081,1),(526831542,425678263,14512129,2791267,1,'2009-10-09 12:44:07',3310502084,1),(526831543,425695775,14514952,2791267,1,'2009-10-09 12:44:07',3310502084,1),(526831544,425702226,14559084,2791267,1,'2009-10-09 12:44:07',3310502087,1),(526831545,425711646,14595967,2791267,1,'2009-10-09 12:44:07',3310502087,1);
INSERT INTO `current_nodes` VALUES (526831546,425727091,14624536,2791267,1,'2009-10-09 12:44:07',3310502104,1),(526831547,425730454,14663578,2791267,1,'2009-10-09 12:44:07',3310502104,1),(526831548,425735179,14684086,2791267,1,'2009-10-09 12:44:07',3310502106,1),(526831549,425736857,14702574,2791267,1,'2009-10-09 12:44:08',3310502106,1),(526831550,425743841,14717939,2791267,1,'2009-10-09 12:44:08',3310502106,1),(526831551,425740443,14719698,2791267,1,'2009-10-09 12:44:08',3310502106,1),(526831552,425728612,14725228,2791267,1,'2009-10-09 12:44:08',3310502128,1),(526831553,425706556,14740561,2791267,1,'2009-10-09 12:44:08',3310502117,1),(529940889,425562347,15367648,2836771,1,'2009-10-13 18:43:08',3310502462,1),(529941178,425565635,15340525,2836771,1,'2009-10-13 18:54:58',3310502462,2),(529943807,425567658,15328852,2836771,1,'2009-10-13 18:54:44',3310502462,1),(529948761,425544851,15372590,2895121,1,'2009-10-19 19:03:33',3310502459,2),(529948762,425545167,15373362,2895121,1,'2009-10-19 19:03:33',3310502459,3),(529948763,425545546,15373877,2895121,1,'2009-10-19 19:03:34',3310502459,4),(529948764,425547569,15374564,2895121,1,'2009-10-19 19:03:34',3310502459,3),(529948765,425548518,15374392,2895121,1,'2009-10-19 19:03:33',3310502459,3),(529948766,425549213,15373877,2895121,1,'2009-10-19 19:03:33',3310502459,3),(535384824,425151799,15256312,2895121,1,'2009-10-19 19:15:15',3310491447,1),(535385847,425099202,15480651,2895121,1,'2009-10-19 19:17:29',3310491539,1),(535386385,425098823,15479793,2895121,1,'2009-10-19 19:20:25',3310491539,2),(535387283,425099582,15480651,2895121,1,'2009-10-19 19:20:05',3310491539,1),(535387288,425099772,15479535,2895121,1,'2009-10-19 19:20:05',3310491539,1),(535387292,425099455,15479278,2895121,1,'2009-10-19 19:20:05',3310491539,1),(535387294,425099076,15479278,2895121,1,'2009-10-19 19:20:25',3310491539,2),(535387296,425098886,15480393,2895121,1,'2009-10-19 19:20:05',3310491539,1),(567007523,425775904,16490101,4108069,1,'2010-03-12 19:04:14',3310504177,3),(579971414,424434795,15530422,3283462,1,'2009-12-03 21:50:21',3310490584,1),(579971423,424460911,15548364,3283462,1,'2009-12-03 21:50:21',3310490587,1),(579971445,424464032,15551386,3283462,1,'2009-12-03 21:50:22',3310490590,1),(579971453,424467646,15557849,3283462,1,'2009-12-03 21:50:23',3310490590,1),(579971472,424474615,15581817,3283462,1,'2009-12-03 21:50:23',3310490590,1),(579971480,424477445,15587614,3283462,1,'2009-12-03 21:50:24',3310490590,1),(579971484,424483022,15596772,3283462,1,'2009-12-03 21:50:24',3310490590,1),(579971485,424486403,15600057,3283462,1,'2009-12-03 21:50:24',3310490590,1),(579971492,424507397,15590642,3283462,1,'2009-12-03 21:50:25',3310490591,1),(579971493,424489591,15601383,3283462,1,'2009-12-03 21:50:25',3310490612,1),(579971494,424493182,15601644,3283462,1,'2009-12-03 21:50:26',3310490613,1),(579971697,424765721,14398064,3283462,1,'2009-12-03 21:50:51',3310490729,1),(579971713,424754801,14410304,3283462,1,'2009-12-03 21:50:51',3310490728,1),(579971721,424749943,14412514,3283462,1,'2009-12-03 21:50:52',3310490728,1),(579971757,424948182,14410755,3283462,1,'2009-12-03 21:50:54',3310490749,1),(579971802,424952163,14433423,3283462,1,'2009-12-03 21:50:56',3310490749,1),(579971887,425052441,14609800,3283462,1,'2009-12-03 21:51:00',3310491015,1),(579971891,425052725,14607144,3283462,1,'2009-12-03 21:51:00',3310491015,1),(579971895,425040155,14590065,3283462,1,'2009-12-03 21:51:00',3310491015,1),(579971896,425035047,14577898,3283462,1,'2009-12-03 21:51:01',3310491014,1),(579971897,425027917,14564492,3283462,1,'2009-12-03 21:51:01',3310491014,1),(579971898,425021840,14556394,3283462,1,'2009-12-03 21:51:01',3310491012,1),(579971902,425016240,14547600,3283462,1,'2009-12-03 21:51:01',3310491012,1),(579971909,425000569,14515337,3283462,1,'2009-12-03 21:51:02',3310491009,1),(579971916,425115594,14680381,3283462,1,'2009-12-03 21:51:02',3310491035,1),(579971917,425107757,14691991,3283462,1,'2009-12-03 21:51:03',3310491035,1),(579971921,425094457,14668285,3283462,1,'2009-12-03 21:51:03',3310491034,1),(579971959,425066258,14624900,3283462,1,'2009-12-03 21:51:04',3310491021,1),(579971967,425138276,14652914,3283462,1,'2009-12-03 21:51:05',3310491036,1),(579971988,425127348,14665278,3283462,1,'2009-12-03 21:51:05',3310491036,1),(579972040,425234718,14599545,3283462,1,'2009-12-03 21:51:09',3310491078,1),(579972062,425187028,14635702,3283462,1,'2009-12-03 21:51:10',3310491080,1),(579972081,425389455,14512692,3283462,1,'2009-12-03 21:51:10',3310491093,1),(579972127,425385107,14522610,3283462,1,'2009-12-03 21:51:12',3310491093,1),(579972135,425381847,14525421,3283462,1,'2009-12-03 21:51:12',3310491093,1),(579972136,425377929,14526603,3283462,1,'2009-12-03 21:51:12',3310491093,1),(579972138,425374611,14526245,3283462,1,'2009-12-03 21:51:13',3310491093,1),(579972142,425364135,14522456,3283462,1,'2009-12-03 21:51:14',3310491092,1),(579972190,424518414,15587553,3283462,1,'2009-12-03 21:51:17',3310491274,1),(579972196,424521224,15584839,3283462,1,'2009-12-03 21:51:17',3310491274,1),(579972201,424523911,15580658,3283462,1,'2009-12-03 21:51:17',3310491274,1),(579972206,424528572,15578930,3283462,1,'2009-12-03 21:51:18',3310491274,1),(579972215,424535005,15571130,3283462,1,'2009-12-03 21:51:18',3310491274,1),(579972234,424539188,15570097,3283462,1,'2009-12-03 21:51:19',3310491274,1),(579972248,424544211,15570583,3283462,1,'2009-12-03 21:51:20',3310491274,1),(579972256,424549926,15574038,3283462,1,'2009-12-03 21:51:20',3310491275,1),(579972263,424556228,15580818,3283462,1,'2009-12-03 21:51:20',3310491275,1),(579972264,424565085,15701828,3283462,1,'2009-12-03 21:51:20',3310491299,1),(579972270,424583055,15601249,3283462,1,'2009-12-03 21:51:21',3310491300,1),(579972277,424585858,15605466,3283462,1,'2009-12-03 21:51:21',3310491300,1),(579972294,424586959,15611746,3283462,1,'2009-12-03 21:51:22',3310491300,1),(579972301,424586855,15616602,3283462,1,'2009-12-03 21:51:22',3310491300,1),(579972312,424581415,15633350,3283462,1,'2009-12-03 21:51:22',3310491300,1),(579972313,424585535,15654198,3283462,1,'2009-12-03 21:51:23',3310491300,1),(579972314,424588124,15659250,3283462,1,'2009-12-03 21:51:23',3310491302,1),(579972316,424589387,15663719,3283462,1,'2009-12-03 21:51:23',3310491302,1),(579972323,424589863,15669833,3283462,1,'2009-12-03 21:51:23',3310491302,1),(579972329,424588776,15674495,3283462,1,'2009-12-03 21:51:23',3310491302,1),(579972335,424584330,15684384,3283462,1,'2009-12-03 21:51:24',3310491302,1),(579972342,424574863,15695975,3283462,1,'2009-12-03 21:51:24',3310491302,1),(579972344,424567322,15699924,3283462,1,'2009-12-03 21:51:24',3310491299,1),(579972345,424558877,15710737,3283462,1,'2009-12-03 21:51:24',3310491305,1),(579972349,424555434,15713525,3283462,1,'2009-12-03 21:51:25',3310491305,1),(579972407,424556556,15824974,3283462,1,'2009-12-03 21:51:27',3310492673,1),(579972412,424560695,15825033,3283462,1,'2009-12-03 21:51:28',3310492673,1),(579972420,424565060,15826203,3283462,1,'2009-12-03 21:51:28',3310492673,1),(579972426,424569772,15829952,3283462,1,'2009-12-03 21:51:28',3310492673,1),(579972437,424573589,15835823,3283462,1,'2009-12-03 21:51:29',3310492676,1),(579972439,424577199,15840100,3283462,1,'2009-12-03 21:51:29',3310492676,1),(579972444,424599242,15853991,3283462,1,'2009-12-03 21:51:29',3310492676,1),(579972446,424604895,15856715,3283462,1,'2009-12-03 21:51:29',3310492677,1),(579972453,424611642,15861342,3283462,1,'2009-12-03 21:51:31',3310492677,1),(579972459,424617443,15867117,3283462,1,'2009-12-03 21:51:31',3310492677,1),(579972466,424626424,15881149,3283462,1,'2009-12-03 21:51:32',3310492679,1),(579972473,424630317,15894080,3283462,1,'2009-12-03 21:51:32',3310492690,1),(579972478,424634267,15903367,3283462,1,'2009-12-03 21:51:32',3310492690,1),(579972488,424647078,15922909,3283462,1,'2009-12-03 21:51:33',3310492690,1),(579972496,424658867,15947727,3283462,1,'2009-12-03 21:51:33',3310492697,1),(579972502,424666286,15960309,3283462,1,'2009-12-03 21:51:33',3310492697,1),(579972508,424673057,15968831,3283462,1,'2009-12-03 21:51:34',3310492697,1),(579972515,424676186,15976114,3283462,1,'2009-12-03 21:51:34',3310492697,1),(579972520,424676456,15987321,3283462,1,'2009-12-03 21:51:34',3310492699,1),(579972522,424669267,16000412,3283462,1,'2009-12-03 21:51:35',3310492699,1),(579972524,424668330,16005815,3283462,1,'2009-12-03 21:51:35',3310492699,1),(579972528,424664488,16014045,3283462,1,'2009-12-03 21:51:35',3310492699,1),(579972529,424661733,16017613,3283462,1,'2009-12-03 21:51:35',3310492699,1),(579972530,424655429,16037821,3283462,1,'2009-12-03 21:51:36',3310492698,1),(579972533,424676976,15983346,3283462,1,'2009-12-03 21:51:36',3310492697,1),(579972540,424651710,16045209,3283462,1,'2009-12-03 21:51:36',3310492720,1),(579972544,424647167,16050711,3283462,1,'2009-12-03 21:51:36',3310492720,1),(579972545,424644813,16055524,3283462,1,'2009-12-03 21:51:37',3310492720,1),(579972546,424645759,16058876,3283462,1,'2009-12-03 21:51:37',3310492720,1),(579972547,424647414,16080399,3283462,1,'2009-12-03 21:51:37',3310492720,1),(579972553,424650408,16093265,3283462,1,'2009-12-03 21:51:37',3310492720,1),(579972562,424652896,16098554,3283462,1,'2009-12-03 21:51:38',3310492722,1),(579972575,424652722,16105108,3283462,1,'2009-12-03 21:51:38',3310492722,1),(579972579,424655243,16125235,3283462,1,'2009-12-03 21:51:39',3310492722,1),(579972589,424655532,16131458,3283462,1,'2009-12-03 21:51:39',3310492723,1),(579972599,424653382,16142365,3283462,1,'2009-12-03 21:51:39',3310492722,1),(579972612,424655015,16150997,3283462,1,'2009-12-03 21:51:39',3310492728,1),(579972640,424650881,16168688,3283462,1,'2009-12-03 21:51:40',3310492728,1),(579972651,424651333,16173099,3283462,1,'2009-12-03 21:51:40',3310492728,1),(579972662,424657535,16188998,3283462,1,'2009-12-03 21:51:41',3310492729,1),(579972678,424656051,16210168,3283462,1,'2009-12-03 21:51:41',3310492731,1),(579972691,424657045,16218997,3283462,1,'2009-12-03 21:51:41',3310492731,1),(579972712,424656776,16225665,3283462,1,'2009-12-03 21:51:42',3310492731,1),(579972748,424655281,16233701,3283462,1,'2009-12-03 21:51:43',3310492730,1),(579972759,424648848,16254749,3283462,1,'2009-12-03 21:51:43',3310492730,1),(579972893,424664226,16328720,3283462,1,'2009-12-03 21:51:48',3310492819,1),(579972911,424670848,16343072,3283462,1,'2009-12-03 21:51:48',3310492819,1),(579972934,424672080,16350459,3283462,1,'2009-12-03 21:51:49',3310492819,1),(579973009,424837366,16619331,3283462,1,'2009-12-03 21:52:03',3310492909,1),(579973010,424841101,16618271,3283462,1,'2009-12-03 21:52:05',3310492909,1),(579973012,424877792,16625989,3283462,1,'2009-12-03 21:52:06',3310492921,1),(579973015,424891140,16623212,3283462,1,'2009-12-03 21:52:06',3310492921,1),(579973018,424901612,16622532,3283462,1,'2009-12-03 21:52:07',3310492921,1),(579973019,424918041,16628134,3283462,1,'2009-12-03 21:52:07',3310492924,1),(579973021,424928851,16623587,3283462,1,'2009-12-03 21:52:07',3310492924,1),(579973023,424931384,16623289,3283462,1,'2009-12-03 21:52:08',3310492925,1),(579973025,424935524,16625543,3283462,1,'2009-12-03 21:52:08',3310492925,1),(579973026,424943920,16633833,3283462,1,'2009-12-03 21:52:09',3310492925,1),(579973027,424958573,16654268,3283462,1,'2009-12-03 21:52:09',3310493098,1),(579973028,424964818,16657896,3283462,1,'2009-12-03 21:52:09',3310493098,1),(579973029,424980656,16658103,3283462,1,'2009-12-03 21:52:10',3310493098,1),(579973030,424984950,16658788,3283462,1,'2009-12-03 21:52:10',3310493098,1),(579973031,424987220,16660539,3283462,1,'2009-12-03 21:52:10',3310493099,1),(579973032,424998156,16677171,3283462,1,'2009-12-03 21:52:11',3310493099,1),(579973033,425027937,16690951,3283462,1,'2009-12-03 21:52:11',3310493102,1),(579973034,425034516,16695213,3283462,1,'2009-12-03 21:52:12',3310493102,1),(579973454,425039210,16699336,3283462,1,'2009-12-03 21:52:39',3310493102,1),(579973464,425041659,16703290,3283462,1,'2009-12-03 21:52:39',3310493445,1),(579973477,425029940,16716895,3283462,1,'2009-12-03 21:52:40',3310493444,1),(579974160,425587107,14261635,3283462,1,'2009-12-03 21:53:19',3310501918,1),(579974175,425567307,14245131,3283462,1,'2009-12-03 21:53:20',3310501918,1),(579974193,425555830,14234576,3283462,1,'2009-12-03 21:53:21',3310501915,1),(579974203,425551879,14231983,3283462,1,'2009-12-03 21:53:23',3310501915,1),(579974208,425536188,14227950,3283462,1,'2009-12-03 21:53:24',3310501915,1),(579974213,425532393,14225976,3283462,1,'2009-12-03 21:53:25',3310501912,1),(579974233,425417944,14351812,3283462,1,'2009-12-03 21:53:29',3310501922,1),(579974236,425427875,14362744,3283462,1,'2009-12-03 21:53:29',3310501923,1),(579974239,425431193,14367728,3283462,1,'2009-12-03 21:53:29',3310501923,1),(579974243,425433419,14373000,3283462,1,'2009-12-03 21:53:30',3310501923,1),(579974248,425436767,14386509,3283462,1,'2009-12-03 21:53:30',3310501923,1),(579974253,425436919,14396504,3283462,1,'2009-12-03 21:53:30',3310501929,1),(579974258,425435984,14406666,3283462,1,'2009-12-03 21:53:31',3310501929,1),(579974267,425432677,14410692,3283462,1,'2009-12-03 21:53:31',3310501929,1),(579974272,425431222,14415703,3283462,1,'2009-12-03 21:53:33',3310501929,1),(579974276,425426153,14437259,3283462,1,'2009-12-03 21:53:34',3310501929,1),(579974280,425412605,14468439,3283462,1,'2009-12-03 21:53:34',3310501930,1),(579974284,425605410,14307507,3283462,1,'2009-12-03 21:53:35',3310501941,1),(579974288,425632716,14376553,3283462,1,'2009-12-03 21:53:35',3310501986,1),(579974296,425632044,14370659,3283462,1,'2009-12-03 21:53:36',3310501986,1),(579974298,425630938,14366683,3283462,1,'2009-12-03 21:53:37',3310501986,1),(579974308,425621200,14348453,3283462,1,'2009-12-03 21:53:39',3310501986,1),(579974311,425651897,14422860,3283462,1,'2009-12-03 21:53:39',3310501993,1),(579974316,425643177,14410913,3283462,1,'2009-12-03 21:53:40',3310501992,1),(579974321,425638715,14400608,3283462,1,'2009-12-03 21:53:40',3310501992,1),(579974336,425666416,14445451,3283462,1,'2009-12-03 21:53:41',3310501993,1),(579974346,425667976,14447024,3283462,1,'2009-12-03 21:53:44',3310501993,1),(579974347,425669266,14448720,3283462,1,'2009-12-03 21:53:44',3310501995,1),(579974361,425391619,14505663,3283462,1,'2009-12-03 21:53:47',3310491093,1),(590463652,425658673,14904344,3373117,1,'2009-12-14 18:44:31',3310502123,1),(590463653,425718009,14841246,3373117,1,'2009-12-14 18:44:31',3310502125,1),(590463654,425718474,14840703,3373117,1,'2009-12-14 18:44:31',3310502125,1),(590463655,425717801,14841978,3373117,1,'2009-12-14 18:44:31',3310502125,1),(590463656,425714552,14858474,3373117,1,'2009-12-14 18:44:31',3310502125,1),(590463659,425739247,14821438,3373535,1,'2009-12-14 19:37:28',3310502130,2),(590463661,425743700,14815300,3373117,1,'2009-12-14 18:44:31',3310502130,1),(590463663,425773866,14786909,3373181,1,'2009-12-14 18:51:21',3310502131,2),(590463666,425732300,14838800,3373117,1,'2009-12-14 18:44:32',3310502136,1),(590463669,425738700,14836200,3373117,1,'2009-12-14 18:44:32',3310502136,1),(590538923,425632000,14897400,3373535,1,'2009-12-14 19:37:28',3310502122,1),(590538926,425741061,14830593,3373535,1,'2009-12-14 19:37:28',3310502130,1),(593870539,425733500,14706500,3388565,1,'2009-12-16 20:20:10',3310502106,1),(593870540,425724333,14716333,3388565,1,'2009-12-16 20:20:10',3310502095,1),(593870541,425729167,14713333,3388565,1,'2009-12-16 20:20:10',3310502106,1),(593870542,425728333,14708667,3388565,1,'2009-12-16 20:20:10',3310502106,1),(593870543,425729333,14708667,3388565,1,'2009-12-16 20:20:10',3310502106,1),(593870544,425732333,14708500,3388565,1,'2009-12-16 20:20:10',3310502106,1),(593870545,425730167,14713167,5833623,1,'2010-09-21 01:50:00',3310502106,2),(593870546,425718500,14840667,3388565,1,'2009-12-16 20:20:10',3310502125,1),(593870547,425697000,14875167,3388565,1,'2009-12-16 20:20:10',3310502124,1),(593870548,425698000,14875833,3388565,1,'2009-12-16 20:20:10',3310502124,1),(593870549,425695833,14878833,3388565,1,'2009-12-16 20:20:10',3310502124,1),(593870550,425695167,14878000,3388565,1,'2009-12-16 20:20:11',3310502124,1),(593870551,425700500,14874333,3388565,1,'2009-12-16 20:20:11',3310502125,1),(593870552,425733667,14733500,3388565,1,'2009-12-16 20:20:11',3310502128,1),(593870553,425734333,14831000,3388565,1,'2009-12-16 20:20:11',3310502130,1),(593870554,425721167,14837000,3388565,1,'2009-12-16 20:20:11',3310502125,1),(593870555,425721260,14836976,3388565,1,'2009-12-16 20:20:11',3310502125,1),(593870556,425726333,14840167,3388565,1,'2009-12-16 20:20:11',3310502125,1),(593870557,425725000,14839167,3388565,1,'2009-12-16 20:20:11',3310502125,1),(593870558,425724667,14840333,3388565,1,'2009-12-16 20:20:11',3310502125,1),(593870559,425733000,14837000,3388565,1,'2009-12-16 20:20:11',3310502136,1),(593870560,425731833,14833167,3388565,1,'2009-12-16 20:20:11',3310502136,1),(613344821,426309927,14833164,4092807,1,'2010-03-10 21:54:57',3310503081,2),(613344822,426179767,14856325,4092807,1,'2010-03-10 21:54:57',3310502392,2),(613344823,426312102,15001087,4161868,1,'2010-03-18 16:48:01',3310503427,3),(613344824,426181795,14866330,4161868,1,'2010-03-18 16:48:00',3310502392,3),(613344825,426276943,14980822,4092743,1,'2010-03-10 21:47:17',3310503424,3),(613344826,426256129,14978080,4161868,1,'2010-03-18 16:48:01',3310502741,2),(613344827,426200273,15021743,4083024,1,'2010-03-09 20:10:05',3310502739,2),(613345211,426202280,14887525,4161868,1,'2010-03-18 16:48:01',3310502395,2),(620937034,425490567,16475639,3724172,1,'2010-01-27 00:45:27',3310504079,1),(620937036,425489241,16467444,3724172,1,'2010-01-27 00:45:27',3310504079,1),(620937038,425465456,16579773,3724172,1,'2010-01-27 00:45:27',3310504102,1),(620937040,425546441,16537133,4108069,1,'2010-03-12 19:04:14',3310504115,2),(620937041,425535870,16624044,3724172,1,'2010-01-27 00:45:27',3310504121,1),(620937043,425532949,16628782,3724172,1,'2010-01-27 00:45:27',3310504120,1),(620937044,425588381,16552939,3724172,1,'2010-01-27 00:45:27',3310504118,1),(620937046,425664340,16419677,4106774,1,'2010-03-12 16:31:14',3310504137,2),(620937047,425669951,16422624,4107810,1,'2010-03-12 18:34:26',3310504137,2),(620937049,425658012,16601209,4107810,1,'2010-03-12 18:34:27',3310504169,2),(620937051,425656322,16601255,4107810,1,'2010-03-12 18:34:27',3310504169,2),(620937056,425644357,16605225,4107810,1,'2010-03-12 18:34:27',3310504169,2),(620937058,425626968,16656863,4107810,1,'2010-03-12 18:34:27',3310504170,2),(620937059,425637171,16601673,4107810,1,'2010-03-12 18:34:27',3310504168,2),(620937061,425626667,16675380,4107810,1,'2010-03-12 18:34:27',3310504170,2),(620937063,425618908,16690082,4107810,1,'2010-03-12 18:34:27',3310504170,2),(620937064,425613037,16698459,3724172,1,'2010-01-27 00:45:28',3310504127,1),(620937066,425628345,16661317,3724172,1,'2010-01-27 00:45:28',3310504170,1),(620937068,425626900,16662228,3724172,1,'2010-01-27 00:45:28',3310504170,1),(620937069,425621939,16664281,3724172,1,'2010-01-27 00:45:28',3310504170,1),(620937071,425616804,16666130,3724172,1,'2010-01-27 00:45:28',3310504127,1),(620937072,425641383,16647821,4106774,1,'2010-03-12 16:31:14',3310504170,2),(620937074,425641393,16652161,4133447,1,'2010-03-15 12:47:11',3310504170,2),(620937076,425639172,16647747,3724172,1,'2010-01-27 00:45:28',3310504170,1),(620937078,425638330,16650764,3724172,1,'2010-01-27 00:45:28',3310504170,1),(620937079,425639147,16656290,3724172,1,'2010-01-27 00:45:28',3310504170,1),(620937081,425640717,16658180,3724172,1,'2010-01-27 00:45:28',3310504170,1),(620937082,425642679,16657855,3724172,1,'2010-01-27 00:45:28',3310504170,1),(620937084,425644124,16656297,3724172,1,'2010-01-27 00:45:28',3310504170,1),(620937086,425645964,16652749,3724172,1,'2010-01-27 00:45:28',3310504171,1),(620937087,425648408,16650717,3724172,1,'2010-01-27 00:45:28',3310504171,1),(620937089,425645861,16664845,3724172,1,'2010-01-27 00:45:28',3310504171,1),(620937091,425648590,16665776,3724172,1,'2010-01-27 00:45:28',3310504171,1),(620937092,425660814,16649774,4106774,1,'2010-03-12 16:31:14',3310504171,2),(620937094,425655149,16663372,3724172,1,'2010-01-27 00:45:29',3310504171,1),(620937095,425662866,16666177,3724172,1,'2010-01-27 00:45:29',3310504171,1),(620937097,425675985,16655921,4106774,1,'2010-03-12 16:31:14',3310504174,2),(620937099,425683808,16657821,4106774,1,'2010-03-12 16:31:14',3310504174,2),(620937100,425692283,16661768,3724172,1,'2010-01-27 00:45:29',3310504174,1),(620937102,425664661,16673264,4106774,1,'2010-03-12 16:31:14',3310504171,2),(620937108,425671549,16682837,4106774,1,'2010-03-12 16:31:14',3310504171,2),(620937109,425675549,16683514,4106774,1,'2010-03-12 16:31:14',3310504174,2),(620937111,425680348,16681251,4106774,1,'2010-03-12 16:31:14',3310504174,2),(620937113,425690353,16674144,3724172,1,'2010-01-27 00:45:29',3310504174,1),(620937114,425691073,16693343,3724172,1,'2010-01-27 00:45:29',3310504174,1),(620937116,425698347,16665259,3724172,1,'2010-01-27 00:45:29',3310504174,1),(620937117,425705841,16665947,3724172,1,'2010-01-27 00:45:29',3310504175,1),(620937119,425715975,16667087,3724172,1,'2010-01-27 00:45:29',3310504175,1),(620937120,425718088,16653948,3724172,1,'2010-01-27 00:45:29',3310504175,1),(620937122,425701874,16683549,3724172,1,'2010-01-27 00:45:30',3310504175,1),(620937124,425711234,16672145,3724172,1,'2010-01-27 00:45:30',3310504175,1),(620937125,425719928,16639866,4106774,1,'2010-03-12 16:31:14',3310504173,2),(620937127,425722206,16629650,4106774,1,'2010-03-12 16:31:14',3310504173,2),(620937130,425725257,16630082,3731851,1,'2010-01-27 23:40:26',3310504173,2),(620937132,425726892,16634407,3724172,1,'2010-01-27 00:45:30',3310504184,1),(620937133,425723028,16626720,3724172,1,'2010-01-27 00:45:30',3310504173,1),(620937135,425732707,16670972,3724172,1,'2010-01-27 00:45:30',3310504186,1),(620937136,425732954,16655552,3724172,1,'2010-01-27 00:45:30',3310504186,1),(620937138,425734579,16665703,3724172,1,'2010-01-27 00:45:30',3310504186,1),(620937139,425746376,16681917,4106774,1,'2010-03-12 16:31:14',3310504186,2),(620937141,425744698,16674841,4106774,1,'2010-03-12 16:31:14',3310504186,2),(620937143,425741387,16697542,3724172,1,'2010-01-27 00:45:30',3310504186,1),(620937144,425745998,16691332,3724172,1,'2010-01-27 00:45:30',3310504186,1),(620937146,425748221,16685068,3724172,1,'2010-01-27 00:45:30',3310504186,1),(620937149,425748094,16687394,3724172,1,'2010-01-27 00:45:30',3310504186,1),(620937151,425606217,16705774,3724172,1,'2010-01-27 00:45:30',3310504469,1),(620937156,425600950,16710488,4107810,1,'2010-03-12 18:34:27',3310504469,2),(620937181,425607973,16737162,4108069,1,'2010-03-12 19:04:16',3310504469,2),(620937182,425617028,16732911,4107810,1,'2010-03-12 18:34:28',3310504512,2),(620937183,425625345,16730122,4107810,1,'2010-03-12 18:34:28',3310504512,2),(620937185,425634023,16725309,4107810,1,'2010-03-12 18:34:27',3310504512,2),(620937186,425644827,16714808,4107810,1,'2010-03-12 18:34:28',3310504513,2),(620937187,425601415,16712286,4107810,1,'2010-03-12 18:34:27',3310504469,2),(620937188,425656438,16703559,4107810,1,'2010-03-12 18:34:28',3310504513,2),(620937189,425663730,16724364,3724172,1,'2010-01-27 00:45:31',3310504513,1),(620937190,425661805,16727410,3724172,1,'2010-01-27 00:45:31',3310504513,1),(620937191,425660918,16729816,3724172,1,'2010-01-27 00:45:32',3310504513,1),(620937192,425661730,16732186,3724172,1,'2010-01-27 00:45:32',3310504513,1),(620937193,425664164,16733548,3724172,1,'2010-01-27 00:45:32',3310504513,1),(620937195,425671545,16704229,3724172,1,'2010-01-27 00:45:32',3310504513,1),(620937196,425675346,16703808,3724172,1,'2010-01-27 00:45:32',3310504516,1),(620937198,425683492,16699503,3724172,1,'2010-01-27 00:45:32',3310504516,1),(620937199,425666857,16711878,4107810,1,'2010-03-12 18:34:28',3310504513,2),(620937201,425667094,16715893,3724172,1,'2010-01-27 00:45:32',3310504513,1),(620937203,425666284,16719270,3724172,1,'2010-01-27 00:45:32',3310504513,1),(620937204,425668294,16734698,3724172,1,'2010-01-27 00:45:32',3310504513,1),(620937206,425678853,16732350,3724172,1,'2010-01-27 00:45:32',3310504516,1),(620937211,425702431,16725746,3724172,1,'2010-01-27 00:45:32',3310504517,1),(620937212,425713582,16718170,3724172,1,'2010-01-27 00:45:32',3310504517,1),(620937214,425723168,16710892,3724172,1,'2010-01-27 00:45:32',3310504517,1),(620937216,425733378,16706606,3724172,1,'2010-01-27 00:45:32',3310504528,1),(621164963,425275938,16871896,3727238,1,'2010-01-27 14:00:39',3310493519,1),(621164964,425270952,16876198,3727238,1,'2010-01-27 14:00:39',3310493519,1),(621164965,425267931,16877381,3727238,1,'2010-01-27 14:00:39',3310493519,1),(621164966,425265183,16878372,3727238,1,'2010-01-27 14:00:39',3310493519,1),(621164967,425262997,16880190,3727238,1,'2010-01-27 14:00:39',3310493519,1),(621164968,425261314,16883769,3727238,1,'2010-01-27 14:00:39',3310493519,1),(621164969,425261766,16887116,3727238,1,'2010-01-27 14:00:40',3310493519,1),(621164970,425264775,16890783,3727238,1,'2010-01-27 14:00:40',3310493519,1),(621164971,425270036,16892444,3727238,1,'2010-01-27 14:00:40',3310493519,1),(621164972,425278351,16895719,3727238,1,'2010-01-27 14:00:40',3310493519,1),(621164973,425380680,16757245,3727238,1,'2010-01-27 14:00:40',3310493527,1),(621164974,425388676,16702138,3727238,1,'2010-01-27 14:00:40',3310493525,1),(621164975,425386304,16706845,3727238,1,'2010-01-27 14:00:40',3310493525,1),(621164976,425381464,16712023,3727238,1,'2010-01-27 14:00:40',3310493525,1),(621164977,425379250,16715234,3727238,1,'2010-01-27 14:00:40',3310493525,1),(621164978,425378065,16723378,3727238,1,'2010-01-27 14:00:40',3310493525,1),(621164979,425376703,16735286,3727238,1,'2010-01-27 14:00:40',3310493525,1),(621164980,425377909,16744035,3727238,1,'2010-01-27 14:00:40',3310493525,1),(621164981,425379705,16750384,3727238,1,'2010-01-27 14:00:40',3310493525,1),(621164982,425381749,16755295,3727238,1,'2010-01-27 14:00:40',3310493527,1),(621164983,425303940,16847896,3727238,1,'2010-01-27 14:00:40',3310493528,1),(621164984,425300542,16852258,3727238,1,'2010-01-27 14:00:40',3310493528,1),(621164985,425298210,16853427,3727238,1,'2010-01-27 14:00:40',3310493528,1),(621164986,425295254,16854235,3727238,1,'2010-01-27 14:00:40',3310493528,1),(621164987,425293065,16855867,3727238,1,'2010-01-27 14:00:41',3310493528,1),(621164988,425292283,16859800,3727238,1,'2010-01-27 14:00:41',3310493528,1),(621164989,425290860,16861975,3727238,1,'2010-01-27 14:00:41',3310493528,1),(621164990,425289155,16863690,3727238,1,'2010-01-27 14:00:41',3310493528,1),(621164991,425334273,16834477,3727238,1,'2010-01-27 14:00:41',3310493529,1),(621164992,425330908,16835761,3727238,1,'2010-01-27 14:00:41',3310493529,1),(621164993,425327056,16836682,3727238,1,'2010-01-27 14:00:41',3310493529,1),(621164994,425321663,16835583,3727238,1,'2010-01-27 14:00:41',3310493529,1),(621164995,425317374,16834555,3727238,1,'2010-01-27 14:00:41',3310493529,1),(621164996,425313734,16835938,3727238,1,'2010-01-27 14:00:41',3310493528,1),(621164997,425309367,16840041,3727238,1,'2010-01-27 14:00:41',3310493528,1),(621164998,425282999,16868203,3727238,1,'2010-01-27 14:00:41',3310493519,1),(621164999,425291044,16901793,3727238,1,'2010-01-27 14:00:41',3310493530,1),(621165000,425310057,16913924,3727238,1,'2010-01-27 14:00:41',3310493530,1),(621165001,425343219,16824545,3727238,1,'2010-01-27 14:00:41',3310493532,1),(621165002,425350167,16833309,3727238,1,'2010-01-27 14:00:41',3310493532,1),(621165003,425352057,16832040,3727238,1,'2010-01-27 14:00:41',3310493532,1),(621165004,425357743,16831687,3727238,1,'2010-01-27 14:00:41',3310493532,1),(621165005,425375270,16841225,3727238,1,'2010-01-27 14:00:41',3310493533,1),(621165006,425389706,16844417,3727238,1,'2010-01-27 14:00:42',3310493533,1),(621165007,425343559,16826352,3727238,1,'2010-01-27 14:00:42',3310493532,1),(621165008,425339401,16830638,3727238,1,'2010-01-27 14:00:42',3310493529,1),(621165009,425337704,16833005,3727238,1,'2010-01-27 14:00:42',3310493529,1),(621165010,425261162,17127004,3727238,1,'2010-01-27 14:00:42',3310493551,1),(621165011,425266114,17125722,3727238,1,'2010-01-27 14:00:42',3310493551,1),(621165012,425266615,17112890,3727238,1,'2010-01-27 14:00:42',3310493551,1),(621165013,425267688,17093488,3727238,1,'2010-01-27 14:00:42',3310493551,1),(621165014,425269366,17079902,3727238,1,'2010-01-27 14:00:42',3310493549,1),(621165015,425273553,17069032,3727238,1,'2010-01-27 14:00:42',3310493549,1),(621165016,425265355,17130201,3727238,1,'2010-01-27 14:00:42',3310493551,1),(621165017,425280553,17125423,3727238,1,'2010-01-27 14:00:42',3310493551,1),(621165018,425303834,16969205,3727238,1,'2010-01-27 14:00:42',3310493552,1),(621165019,425298384,16973046,3727238,1,'2010-01-27 14:00:43',3310493552,1),(621165020,425307734,16970568,3727238,1,'2010-01-27 14:00:43',3310493552,1),(621165021,425300727,16968147,3727238,1,'2010-01-27 14:00:43',3310493552,1),(621165022,425308069,16941180,3727238,1,'2010-01-27 14:00:43',3310493552,1),(621165023,425295322,17012187,3727238,1,'2010-01-27 14:00:43',3310493554,1),(621165024,425302720,16971231,3727238,1,'2010-01-27 14:00:43',3310493552,1),(621165025,425321936,17002159,3727238,1,'2010-01-27 14:00:43',3310493555,1),(621165026,425286608,17032478,3727238,1,'2010-01-27 14:00:43',3310493549,1),(621165027,425283749,17122151,3727238,1,'2010-01-27 14:00:43',3310493551,1),(621165028,425300993,17093670,3727238,1,'2010-01-27 14:00:43',3310493562,1),(621165029,425304985,17084553,3727238,1,'2010-01-27 14:00:43',3310493562,1),(621165030,425255893,17234825,3727238,1,'2010-01-27 14:00:43',3310493638,1),(621165031,425254981,17237419,3727238,1,'2010-01-27 14:00:43',3310493638,1),(621165032,425259184,17237478,3727238,1,'2010-01-27 14:00:43',3310493638,1),(621165033,425262694,17233326,3727238,1,'2010-01-27 14:00:43',3310493639,1),(621165034,425266612,17217509,3727238,1,'2010-01-27 14:00:43',3310493639,1),(621165035,425268466,17200277,3727238,1,'2010-01-27 14:00:43',3310493639,1),(621165036,425268719,17184535,3727238,1,'2010-01-27 14:00:43',3310493637,1),(621165037,425265876,17171334,3727238,1,'2010-01-27 14:00:43',3310493637,1),(621165038,425263770,17156661,3727238,1,'2010-01-27 14:00:43',3310493637,1),(621165039,425263487,17141222,3727238,1,'2010-01-27 14:00:44',3310493637,1),(621165040,425412704,16609272,3727238,1,'2010-01-27 14:00:44',3310504104,1),(621165041,425411079,16609964,3727238,1,'2010-01-27 14:00:44',3310504104,1),(621165042,425409941,16610824,3727238,1,'2010-01-27 14:00:44',3310504104,1),(621165043,425410187,16612908,3727238,1,'2010-01-27 14:00:44',3310504104,1),(621165044,425410620,16615944,3727238,1,'2010-01-27 14:00:44',3310504104,1),(621165045,425410248,16621862,3727238,1,'2010-01-27 14:00:44',3310504104,1),(621165046,425409565,16631308,3727238,1,'2010-01-27 14:00:44',3310504104,1),(621165047,425409269,16636210,3727238,1,'2010-01-27 14:00:44',3310504104,1),(621165048,425409622,16643724,3727238,1,'2010-01-27 14:00:44',3310504104,1),(621165049,425432353,16616643,4133447,1,'2010-03-15 12:47:11',3310504105,2),(621165050,425429517,16612432,3727238,1,'2010-01-27 14:00:44',3310504105,1),(621165051,425426839,16609982,3727238,1,'2010-01-27 14:00:44',3310504105,1),(621165052,425419729,16609718,3727238,1,'2010-01-27 14:00:44',3310504104,1),(621165053,425408453,16653181,3727238,1,'2010-01-27 14:00:44',3310504106,1),(621165054,425406765,16659784,3727238,1,'2010-01-27 14:00:44',3310504106,1),(621165055,425401526,16672314,3727238,1,'2010-01-27 14:00:44',3310504106,1),(621165056,425395952,16682581,3727238,1,'2010-01-27 14:00:44',3310493183,1),(621165057,425391611,16692584,3727238,1,'2010-01-27 14:00:45',3310493183,1),(621165058,425465936,16596928,3727238,1,'2010-01-27 14:00:45',3310504108,1),(621165059,425634815,16602674,3727238,1,'2010-01-27 14:00:45',3310504168,1),(621165060,425623054,16623590,3727238,1,'2010-01-27 14:00:45',3310504168,1),(621165061,425405409,16845367,3727238,1,'2010-01-27 14:00:45',3310504456,1),(621165062,425423905,16841711,3727238,1,'2010-01-27 14:00:45',3310504456,1),(621165063,425446257,16836107,3727238,1,'2010-01-27 14:00:45',3310504457,1),(621165064,425461664,16833798,3727238,1,'2010-01-27 14:00:45',3310504460,1),(621165065,425465603,16831499,3727238,1,'2010-01-27 14:00:45',3310504460,1),(621165066,425488730,16810835,3727238,1,'2010-01-27 14:00:45',3310504461,1),(621165067,425536144,16804984,3727238,1,'2010-01-27 14:00:45',3310504467,1),(621165068,425522020,16807751,3727238,1,'2010-01-27 14:00:45',3310504466,1),(621165069,425502753,16800742,3727238,1,'2010-01-27 14:00:45',3310504455,1),(621165070,425511162,16797298,3727238,1,'2010-01-27 14:00:45',3310504466,1),(621165071,425523512,16796000,4106774,1,'2010-03-12 16:31:16',3310504466,3),(621166567,425715889,16663052,4106774,1,'2010-03-12 16:31:14',3310504175,2),(621413194,425489497,16469665,3730430,1,'2010-01-27 20:41:49',3310504079,1),(621413197,425492510,16468459,3731851,1,'2010-01-27 23:40:26',3310504079,2),(621413198,425500827,16460707,4108069,1,'2010-03-12 19:04:13',3310504079,2),(621413199,425510608,16447225,4108069,1,'2010-03-12 19:04:13',3310504090,2),(621413200,425517548,16440728,4106774,1,'2010-03-12 16:31:12',3310504090,2),(621413201,425526512,16430061,4106774,1,'2010-03-12 16:31:12',3310504090,2),(621413202,425531148,16424216,4108069,1,'2010-03-12 19:04:13',3310504088,3),(621413203,425542596,16399267,4106774,1,'2010-03-12 16:31:12',3310504089,2),(621413204,425545970,16393722,4106774,1,'2010-03-12 16:31:12',3310504089,2),(621413205,425568794,16476915,4106774,1,'2010-03-12 16:31:12',3310504094,2),(621413206,425573601,16470175,4106774,1,'2010-03-12 16:31:12',3310504094,2),(621413207,425578005,16464073,4106774,1,'2010-03-12 16:31:12',3310504094,2),(621413208,425584278,16455120,4106774,1,'2010-03-12 16:31:12',3310504094,2),(621413209,425588855,16452784,3730430,1,'2010-01-27 20:41:50',3310504094,1),(621413210,425610080,16432039,4106774,1,'2010-03-12 16:31:12',3310504095,3),(621413211,425552740,16395741,4106774,1,'2010-03-12 16:31:12',3310504089,2),(621413212,425559431,16397920,4106774,1,'2010-03-12 16:31:12',3310504089,2),(621413213,425578933,16407456,4106774,1,'2010-03-12 16:31:12',3310504092,3),(621413214,425490676,16470736,4106774,1,'2010-03-12 16:31:12',3310504079,2),(621413215,425494965,16468789,4106774,1,'2010-03-12 16:31:12',3310504079,2),(621413216,425496506,16468710,4106774,1,'2010-03-12 16:31:12',3310504079,2),(621413217,425497652,16469693,4106774,1,'2010-03-12 16:31:12',3310504079,2),(621413218,425498027,16471905,4106774,1,'2010-03-12 16:31:12',3310504079,2),(621413219,425499336,16476335,4106774,1,'2010-03-12 16:31:12',3310504079,2),(621413220,425540221,16494813,4106774,1,'2010-03-12 16:31:13',3310504113,2),(621413221,425549802,16497603,4106774,1,'2010-03-12 16:31:13',3310504113,2),(621413222,425561768,16487189,4106774,1,'2010-03-12 16:31:13',3310504113,2),(621413223,425672030,16419152,4106774,1,'2010-03-12 16:31:14',3310504140,3),(621453850,425542422,16531705,4108069,1,'2010-03-12 19:04:14',3310504113,4),(621467407,425491135,16472287,3731738,1,'2010-01-27 23:25:10',3310504079,1),(621467409,425494164,16483446,3731738,1,'2010-01-27 23:25:10',3310504101,1),(621467411,425464871,16581415,4106774,1,'2010-03-12 16:31:12',3310504102,2),(621467412,425465635,16588900,3731738,1,'2010-01-27 23:25:10',3310504102,1),(621467413,425432561,16609799,3731738,1,'2010-01-27 23:25:10',3310504105,1),(621467414,425436413,16608895,3731738,1,'2010-01-27 23:25:11',3310504105,1),(621467415,425445499,16602580,3731738,1,'2010-01-27 23:25:11',3310504105,1),(621467416,425442824,16645884,4106774,1,'2010-03-12 16:31:12',3310504107,2),(621467417,425444104,16679903,3731738,1,'2010-01-27 23:25:11',3310504107,1),(621467419,425437548,16657539,3731738,1,'2010-01-27 23:25:11',3310504107,1),(621467420,425436370,16670480,4106774,1,'2010-03-12 16:31:12',3310504107,2),(621467421,425435228,16687672,3731738,1,'2010-01-27 23:25:11',3310504107,1),(621467422,425465150,16593466,3731738,1,'2010-01-27 23:25:11',3310504108,1),(621467423,425462386,16598991,3731738,1,'2010-01-27 23:25:11',3310504108,1),(621467424,425447470,16613879,4106774,1,'2010-03-12 16:31:12',3310504105,2),(621467425,425446444,16603156,3731738,1,'2010-01-27 23:25:11',3310504105,1),(621467426,425447309,16606346,3731738,1,'2010-01-27 23:25:11',3310504105,1),(621467427,425451135,16623291,4106774,1,'2010-03-12 16:31:13',3310504105,2),(621467428,425455796,16630668,4106774,1,'2010-03-12 16:31:12',3310504108,2),(621467429,425457916,16635510,4106774,1,'2010-03-12 16:31:12',3310504108,2),(621467430,425446869,16625583,4106774,1,'2010-03-12 16:31:13',3310504105,2),(621467431,425467717,16596319,3731738,1,'2010-01-27 23:25:11',3310504108,1),(621467432,425468101,16599576,3731738,1,'2010-01-27 23:25:12',3310504108,1),(621467433,425468804,16600727,3731738,1,'2010-01-27 23:25:12',3310504108,1),(621467434,425483674,16596791,3731738,1,'2010-01-27 23:25:12',3310504109,1),(621467435,425501195,16583419,4106774,1,'2010-03-12 16:31:13',3310504103,2),(621467436,425459871,16644945,4106774,1,'2010-03-12 16:31:13',3310504110,2),(621467437,425461804,16650673,4106774,1,'2010-03-12 16:31:13',3310504110,2),(621467438,425462370,16653913,4106774,1,'2010-03-12 16:31:13',3310504110,2),(621467439,425461444,16658654,3731738,1,'2010-01-27 23:25:12',3310504110,1),(621467441,425461919,16661480,3731738,1,'2010-01-27 23:25:12',3310504110,1),(621467442,425463094,16672194,4106774,1,'2010-03-12 16:31:13',3310504110,2),(621467443,425464335,16679338,3731738,1,'2010-01-27 23:25:12',3310504110,1),(621467444,425465336,16684690,3731738,1,'2010-01-27 23:25:12',3310504110,1),(621467445,425465044,16692682,3731738,1,'2010-01-27 23:25:12',3310504110,1),(621467446,425464656,16697317,3731738,1,'2010-01-27 23:25:12',3310504110,1),(621467447,425510360,16511992,3731738,1,'2010-01-27 23:25:12',3310504112,1),(621467448,425517010,16519535,4108069,1,'2010-03-12 19:04:14',3310504112,2),(621467449,425537728,16532075,4108069,1,'2010-03-12 19:04:14',3310504113,2),(621467450,425506940,16582753,4106774,1,'2010-03-12 16:31:13',3310504103,2),(621467451,425511408,16584493,4106774,1,'2010-03-12 16:31:13',3310504114,2),(621467452,425543051,16537807,3731738,1,'2010-01-27 23:25:12',3310504115,1),(621467453,425546413,16562239,3731738,1,'2010-01-27 23:25:12',3310504115,1),(621467454,425546131,16565303,3731738,1,'2010-01-27 23:25:12',3310504115,1),(621467455,425544881,16579039,3731738,1,'2010-01-27 23:25:12',3310504115,1),(621467456,425543723,16588618,3731738,1,'2010-01-27 23:25:13',3310504115,1),(621467457,425549453,16534178,4108069,1,'2010-03-12 19:04:14',3310504113,3),(621467461,425568399,16552171,4106774,1,'2010-03-12 16:31:13',3310504118,2),(621467462,425570493,16563235,4106774,1,'2010-03-12 16:31:14',3310504118,2),(621467463,425571988,16578700,4106774,1,'2010-03-12 16:31:14',3310504118,2),(621467464,425568238,16581408,4106774,1,'2010-03-12 16:31:14',3310504118,2),(621467468,425587581,16555073,3731738,1,'2010-01-27 23:25:13',3310504118,1),(621467469,425590590,16558740,3731738,1,'2010-01-27 23:25:13',3310504119,1),(621467470,425592307,16558050,3731738,1,'2010-01-27 23:25:13',3310504119,1),(621467471,425603076,16553866,4108069,1,'2010-03-12 19:04:14',3310504119,2),(621467472,425605648,16553469,4108069,1,'2010-03-12 19:04:14',3310504119,2),(621467473,425607964,16554539,4108069,1,'2010-03-12 19:04:14',3310504119,2),(621467474,425516709,16590355,4106774,1,'2010-03-12 16:31:14',3310504120,2),(621467475,425523972,16599537,3731738,1,'2010-01-27 23:25:13',3310504120,1),(621467476,425527826,16604701,3731738,1,'2010-01-27 23:25:13',3310504120,1),(621467477,425542296,16593425,3731738,1,'2010-01-27 23:25:13',3310504121,1),(621467478,425538327,16601249,3731738,1,'2010-01-27 23:25:13',3310504121,1),(621467479,425534045,16612519,3731738,1,'2010-01-27 23:25:13',3310504120,1),(621467480,425533728,16615583,3731738,1,'2010-01-27 23:25:14',3310504120,1),(621467481,425539161,16624718,4106774,1,'2010-03-12 16:31:14',3310504121,2),(621467482,425555368,16595517,4106774,1,'2010-03-12 16:31:14',3310504121,2),(621467483,425552905,16607028,4106774,1,'2010-03-12 16:31:14',3310504121,2),(621467484,425548359,16612251,4106774,1,'2010-03-12 16:31:14',3310504121,2),(621467485,425541749,16619626,4106774,1,'2010-03-12 16:31:14',3310504121,2),(621467486,425541114,16629478,3731738,1,'2010-01-27 23:25:14',3310504121,1),(621467487,425544780,16633248,3731738,1,'2010-01-27 23:25:14',3310504121,1),(621467488,425550120,16640130,3731738,1,'2010-01-27 23:25:14',3310504121,1),(621467489,425530872,16614432,3731738,1,'2010-01-27 23:25:14',3310504120,1),(621467490,425533794,16622151,3731738,1,'2010-01-27 23:25:14',3310504120,1),(621467491,425578195,16597897,4107810,1,'2010-03-12 18:34:26',3310504124,2),(621467492,425558497,16588757,4106774,1,'2010-03-12 16:31:13',3310504115,2),(621467493,425582675,16606305,4107810,1,'2010-03-12 18:34:26',3310504124,2),(621467494,425588246,16617789,3731738,1,'2010-01-27 23:25:14',3310504124,1),(621467495,425590672,16625915,4107810,1,'2010-03-12 18:34:26',3310504125,2),(621467496,425593023,16632114,4107810,1,'2010-03-12 18:34:26',3310504125,2),(621467497,425597605,16644100,3731738,1,'2010-01-27 23:25:14',3310504125,1),(621467499,425606739,16641544,4107810,1,'2010-03-12 18:34:26',3310504125,2),(621467501,425610074,16638433,3731738,1,'2010-01-27 23:25:15',3310504125,1),(621467502,425557793,16647429,3731738,1,'2010-01-27 23:25:15',3310504123,1),(621467503,425561131,16652605,3731738,1,'2010-01-27 23:25:15',3310504123,1),(621467504,425563271,16658624,3731738,1,'2010-01-27 23:25:15',3310504126,1),(621467505,425566085,16670692,3731738,1,'2010-01-27 23:25:15',3310504126,1),(621467506,425574167,16690812,3731738,1,'2010-01-27 23:25:15',3310504126,1),(621467507,425578982,16697006,3731738,1,'2010-01-27 23:25:15',3310504126,1),(621467508,425599525,16647952,4107810,1,'2010-03-12 18:34:26',3310504127,2),(621467509,425601502,16648572,4107810,1,'2010-03-12 18:34:26',3310504127,2),(621467510,425604327,16647217,4107810,1,'2010-03-12 18:34:26',3310504127,2),(621467513,425683956,16474947,3731738,1,'2010-01-27 23:25:15',3310504142,1),(621467519,425611341,16557731,3731738,1,'2010-01-27 23:25:16',3310504119,1),(621467520,425615039,16561384,3731738,1,'2010-01-27 23:25:16',3310504119,1),(621467521,425617386,16561519,3731738,1,'2010-01-27 23:25:16',3310504162,1),(621467522,425620963,16566481,3731738,1,'2010-01-27 23:25:16',3310504162,1),(621467523,425623731,16573046,3731738,1,'2010-01-27 23:25:16',3310504162,1),(621467524,425625427,16576555,3731738,1,'2010-01-27 23:25:16',3310504162,1),(621467526,425628904,16578906,3731738,1,'2010-01-27 23:25:16',3310504162,1),(621467527,425634066,16577954,3731738,1,'2010-01-27 23:25:16',3310504162,1),(621467529,425638775,16579532,3731738,1,'2010-01-27 23:25:16',3310504162,1),(621467530,425642480,16583651,3731738,1,'2010-01-27 23:25:16',3310504162,1),(621467531,425644265,16588838,3731738,1,'2010-01-27 23:25:16',3310504162,1),(621467540,425685862,16481311,4107810,1,'2010-03-12 18:34:26',3310504164,2),(621467541,425688748,16502190,4107810,1,'2010-03-12 18:34:26',3310504164,2),(621467543,425690496,16510134,4107810,1,'2010-03-12 18:34:26',3310504164,2),(621467544,425690288,16514360,4107810,1,'2010-03-12 18:34:26',3310504164,2),(621467545,425688700,16518425,4107810,1,'2010-03-12 18:34:26',3310504164,2),(621467546,425686151,16523728,4107810,1,'2010-03-12 18:34:26',3310504164,2),(621467547,425684272,16526723,4107810,1,'2010-03-12 18:34:26',3310504164,2),(621467549,425684872,16530335,3731738,1,'2010-01-27 23:25:17',3310504164,1),(621467550,425686118,16533574,3731738,1,'2010-01-27 23:25:17',3310504164,1),(621467552,425690084,16540837,3731738,1,'2010-01-27 23:25:17',3310504166,1),(621467554,425694190,16545414,3731738,1,'2010-01-27 23:25:17',3310504166,1),(621467555,425696150,16550737,3731738,1,'2010-01-27 23:25:17',3310504166,1),(621467557,425698067,16559678,3731738,1,'2010-01-27 23:25:17',3310504166,1),(621467558,425699463,16568396,3731738,1,'2010-01-27 23:25:17',3310504167,1),(621467559,425700357,16578409,3731738,1,'2010-01-27 23:25:17',3310504167,1),(621467560,425700105,16586230,3731738,1,'2010-01-27 23:25:17',3310504167,1),(621467561,425622584,16624654,3731738,1,'2010-01-27 23:25:17',3310504168,1),(621467562,425623073,16628644,3731738,1,'2010-01-27 23:25:17',3310504168,1),(621467563,425617517,16633844,4107810,1,'2010-03-12 18:34:27',3310504168,2),(621467565,425621366,16631774,4107810,1,'2010-03-12 18:34:27',3310504168,2),(621467566,425623405,16630613,4107810,1,'2010-03-12 18:34:27',3310504168,2),(621467568,425627106,16625853,4107810,1,'2010-03-12 18:34:27',3310504168,2),(621467569,425634874,16608394,4107810,1,'2010-03-12 18:34:26',3310504168,2),(621467570,425611445,16646895,4107810,1,'2010-03-12 18:34:27',3310504127,2),(621467571,425613042,16672931,3731738,1,'2010-01-27 23:25:18',3310504127,1),(621467572,425701005,16589477,3731738,1,'2010-01-27 23:25:18',3310504167,1),(621467573,425702835,16591456,4107810,1,'2010-03-12 18:34:27',3310504173,2),(621467574,425708196,16593126,4107810,1,'2010-03-12 18:34:27',3310504173,2),(621467575,425710656,16598642,4107810,1,'2010-03-12 18:34:27',3310504173,2),(621467576,425714808,16607758,4107810,1,'2010-03-12 18:34:27',3310504173,2),(621467577,425719561,16618508,4107810,1,'2010-03-12 18:34:27',3310504173,2),(621467582,425441245,16699822,4106774,1,'2010-03-12 16:31:16',3310504449,2),(621467586,425466800,16706002,3731738,1,'2010-01-27 23:25:22',3310504452,1),(621467587,425468677,16715568,4106774,1,'2010-03-12 16:31:16',3310504452,2),(621467589,425472275,16725832,4106774,1,'2010-03-12 16:31:16',3310504452,2),(621467590,425477156,16734995,4106774,1,'2010-03-12 16:31:16',3310504452,2),(621467592,425450951,16700535,4106774,1,'2010-03-12 16:31:16',3310504449,2),(621467593,425461976,16720938,4106774,1,'2010-03-12 16:31:16',3310504452,2),(621467595,425471602,16729225,4106774,1,'2010-03-12 16:31:16',3310504452,2),(621467596,425492788,16759322,4106774,1,'2010-03-12 16:31:16',3310504455,2),(621467598,425449350,16710590,4106774,1,'2010-03-12 16:31:16',3310504449,2),(621467599,425503172,16773917,4106774,1,'2010-03-12 16:31:16',3310504455,2),(621467600,425584790,16707029,3731738,1,'2010-01-27 23:25:22',3310504468,1),(621467601,425587752,16713137,4107810,1,'2010-03-12 18:34:27',3310504468,2),(621467603,425604193,16701307,3731738,1,'2010-01-27 23:25:22',3310504469,1),(621467612,425601491,16702019,4107810,1,'2010-03-12 18:34:27',3310504469,2),(621467615,425589960,16717786,4107810,1,'2010-03-12 18:34:27',3310504469,2),(621473071,425320767,16959540,3731851,1,'2010-01-27 23:40:25',3310493553,1),(621473074,425488496,16468920,3731851,1,'2010-01-27 23:40:26',3310504079,1),(621473077,425429266,16613496,3731851,1,'2010-01-27 23:40:26',3310504105,1),(621473079,425423599,16611370,4133447,1,'2010-03-15 12:47:10',3310504104,2),(621473081,425545972,16535877,3731851,1,'2010-01-27 23:40:26',3310504115,1),(621473083,425723576,16625185,3731851,1,'2010-01-27 23:40:26',3310504173,1),(623510069,425296191,17193248,4763364,1,'2010-05-21 10:18:41',3310493648,2),(643575021,426433585,15759863,3903073,1,'2010-02-17 20:32:18',3310503609,1),(643575023,426429433,15763263,3903073,1,'2010-02-17 20:32:18',3310503609,1),(643575025,426433853,15775498,3903073,1,'2010-02-17 20:32:18',3310503611,1),(643575026,426442585,15759555,3903073,1,'2010-02-17 20:32:18',3310503612,1),(643575027,426484660,15736207,3903073,1,'2010-02-17 20:32:18',3310503613,1),(643575028,426479954,15729593,3903073,1,'2010-02-17 20:32:18',3310503613,1),(643575029,426472015,15751185,3903073,1,'2010-02-17 20:32:18',3310503613,1),(643575030,426468319,15752275,3903073,1,'2010-02-17 20:32:19',3310503613,1),(643575031,426467277,15752585,3903073,1,'2010-02-17 20:32:19',3310503612,1),(643575032,426480453,15745949,3903073,1,'2010-02-17 20:32:19',3310503613,1),(643575034,426480271,15748742,3903073,1,'2010-02-17 20:32:19',3310503613,1),(643575035,426445232,15789034,3903073,1,'2010-02-17 20:32:19',3310503614,1),(643575040,426441737,15797930,3903073,1,'2010-02-17 20:32:19',3310503614,1),(643575042,426440049,15811630,3903073,1,'2010-02-17 20:32:19',3310503611,1),(643575043,426445169,15780178,3903073,1,'2010-02-17 20:32:19',3310503614,1),(643575061,426428969,15924423,3903073,1,'2010-02-17 20:32:20',3310504979,1),(643575062,426422368,15914852,3903073,1,'2010-02-17 20:32:20',3310504979,1),(643575063,426419876,15898790,3903073,1,'2010-02-17 20:32:20',3310504979,1),(643575065,426428176,15896265,3903073,1,'2010-02-17 20:32:20',3310504979,1),(643575066,426443847,15843763,3903073,1,'2010-02-17 20:32:20',3310504980,1),(643575069,426444379,15834906,3903073,1,'2010-02-17 20:32:20',3310504980,1),(643575071,426441331,15824484,3903073,1,'2010-02-17 20:32:20',3310504980,1),(643575074,426436921,15852695,3903073,1,'2010-02-17 20:32:20',3310504977,1),(643575075,426438256,15894531,3903073,1,'2010-02-17 20:32:20',3310504979,1),(643575077,426442942,15884009,3903073,1,'2010-02-17 20:32:20',3310504982,1),(643575080,426438070,15876833,3903073,1,'2010-02-17 20:32:20',3310504979,1),(643575092,426431557,15955766,3903073,1,'2010-02-17 20:32:20',3310504985,1),(643575094,426432617,15937247,3903073,1,'2010-02-17 20:32:20',3310504985,1),(643575096,426401222,16034602,3903073,1,'2010-02-17 20:32:20',3310504986,1),(643575118,426324153,16127051,3903073,1,'2010-02-17 20:32:21',3310504995,1),(643575120,426321295,16144159,3903073,1,'2010-02-17 20:32:21',3310504995,1),(643575122,426321269,16140435,3903073,1,'2010-02-17 20:32:21',3310504995,1),(643575124,426321007,16134851,3903073,1,'2010-02-17 20:32:21',3310504995,1),(643575126,426321651,16128952,3903073,1,'2010-02-17 20:32:21',3310504995,1),(643575127,426347810,16129401,3903073,1,'2010-02-17 20:32:21',3310504998,1),(643575129,426356700,16126074,3903073,1,'2010-02-17 20:32:21',3310504998,1),(643575131,426370278,16113840,3903073,1,'2010-02-17 20:32:21',3310504999,1),(643575134,426328037,16126987,3903073,1,'2010-02-17 20:32:21',3310504995,1),(643575135,426330789,16127257,3903073,1,'2010-02-17 20:32:21',3310504995,1),(643575138,426334673,16125642,3903073,1,'2010-02-17 20:32:21',3310504998,1),(643575147,426315681,16158831,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575150,426314095,16161648,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575152,426320432,16150996,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575154,426318626,16154439,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575156,426316475,16174951,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575159,426319712,16178931,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575160,426312755,16166012,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575163,426313004,16169726,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575165,426323837,16181351,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575167,426321781,16232700,3903073,1,'2010-02-17 20:32:22',3310505003,1),(643575169,426319926,16222263,3903073,1,'2010-02-17 20:32:22',3310505003,1),(643575171,426328665,16183138,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575173,426330952,16184349,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575174,426326369,16182247,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575176,426335363,16192655,3903073,1,'2010-02-17 20:32:22',3310505004,1),(643575177,426334718,16198562,3903073,1,'2010-02-17 20:32:22',3310505004,1),(643575178,426333029,16186178,3903073,1,'2010-02-17 20:32:22',3310505004,1),(643575179,426334193,16188953,3903073,1,'2010-02-17 20:32:22',3310505004,1),(643575180,426333368,16201376,3903073,1,'2010-02-17 20:32:23',3310505004,1),(643575181,426329057,16207959,3903073,1,'2010-02-17 20:32:23',3310505003,1),(643575184,426330423,16205761,3903073,1,'2010-02-17 20:32:23',3310505003,1),(643575186,426328357,16239057,3903073,1,'2010-02-17 20:32:23',3310505003,1),(643575187,426340049,16238442,3903073,1,'2010-02-17 20:32:23',3310505006,1),(643575190,426343270,16244970,3903073,1,'2010-02-17 20:32:23',3310505006,1),(643575192,426340949,16240354,3903073,1,'2010-02-17 20:32:23',3310505006,1),(643575196,426387222,16071786,3903073,1,'2010-02-17 20:32:23',3310505008,1),(643575199,426387083,16051673,3903073,1,'2010-02-17 20:32:23',3310505008,1),(643575200,426396585,16052359,3903073,1,'2010-02-17 20:32:23',3310505008,1),(643575203,426389172,16095898,3903073,1,'2010-02-17 20:32:23',3310505010,1),(643575204,426379741,16107283,3903073,1,'2010-02-17 20:32:23',3310504999,1),(643575264,426380140,16164240,3903073,1,'2010-02-17 20:32:24',3310505005,1),(643575498,426338101,16274329,3903073,1,'2010-02-17 20:32:30',3310505092,1),(643575500,426335635,16261490,3903073,1,'2010-02-17 20:32:30',3310505092,1),(643575502,426346729,16280427,3903073,1,'2010-02-17 20:32:30',3310505092,1),(646807552,425036300,15193338,3916355,1,'2010-02-19 17:31:54',3310491428,1),(646807563,425035977,15193837,3916355,1,'2010-02-19 17:31:54',3310491428,1),(646807568,425035932,15194160,3916355,1,'2010-02-19 17:31:54',3310491428,1),(646807575,425036151,15194859,3916355,1,'2010-02-19 17:31:54',3310491428,1),(646807589,425036353,15195039,3916355,1,'2010-02-19 17:31:54',3310491428,1),(646807600,425036924,15195028,3916355,1,'2010-02-19 17:31:54',3310491428,1),(646807608,425037292,15194466,3916355,1,'2010-02-19 17:31:55',3310491428,1),(646807611,425037326,15194141,3916355,1,'2010-02-19 17:31:55',3310491428,1),(646807615,425037183,15193596,3916355,1,'2010-02-19 17:31:55',3310491428,1),(646807618,425037004,15193374,3916355,1,'2010-02-19 17:31:55',3310491428,1),(646807620,425036781,15193248,3916355,1,'2010-02-19 17:31:55',3310491428,1),(646807701,425063084,15216894,3916355,1,'2010-02-19 17:31:58',3310491431,1),(646807706,425062741,15216284,3916355,1,'2010-02-19 17:31:58',3310491429,1),(646807713,425062226,15216020,3916355,1,'2010-02-19 17:31:58',3310491429,1),(646807720,425061579,15216243,3916355,1,'2010-02-19 17:31:59',3310491429,1),(646807752,425061634,15218582,3916355,1,'2010-02-19 17:31:59',3310491431,1),(646807770,425062768,15218467,3916355,1,'2010-02-19 17:32:00',3310491431,1),(646807785,425063091,15217859,3916355,1,'2010-02-19 17:32:00',3310491431,1),(646807844,425054728,15182544,3916355,1,'2010-02-19 17:32:03',3310491429,1),(646807845,425054353,15181852,3916355,1,'2010-02-19 17:32:03',3310491429,1),(646807846,425053653,15181586,3916355,1,'2010-02-19 17:32:03',3310491429,1),(646807847,425053017,15181974,3916355,1,'2010-02-19 17:32:03',3310491429,1),(646807848,425052706,15182781,3916355,1,'2010-02-19 17:32:03',3310491429,1),(646807849,425052899,15183844,3916355,1,'2010-02-19 17:32:04',3310491429,1),(646807852,425054271,15184218,3916355,1,'2010-02-19 17:32:04',3310491429,1),(646807855,425054547,15183897,3916355,1,'2010-02-19 17:32:04',3310491429,1),(646808595,425098026,15337848,3916355,1,'2010-02-19 17:33:03',3310491451,1),(646808596,425098411,15338940,3916355,1,'2010-02-19 17:33:03',3310491451,1),(646808597,425099698,15339687,3916355,1,'2010-02-19 17:33:03',3310491451,1),(646808603,425100637,15339222,3916355,1,'2010-02-19 17:33:04',3310491451,1),(646808608,425101186,15338159,3916355,1,'2010-02-19 17:33:04',3310491451,1),(646808624,425098579,15335788,3916355,1,'2010-02-19 17:33:05',3310491451,1),(646808843,425127882,15353490,3916355,1,'2010-02-19 17:33:23',3310491454,1),(646808846,425127746,15353084,3916355,1,'2010-02-19 17:33:23',3310491454,1),(646808852,425126943,15352528,3916355,1,'2010-02-19 17:33:23',3310491454,1),(646808857,425126419,15352765,3916355,1,'2010-02-19 17:33:23',3310491454,1),(646808861,425126189,15353082,3916355,1,'2010-02-19 17:33:23',3310491454,1),(646808867,425126021,15353840,3916355,1,'2010-02-19 17:33:23',3310491454,1),(646808879,425126210,15354580,3916355,1,'2010-02-19 17:33:24',3310491454,1),(646808882,425126662,15355025,3916355,1,'2010-02-19 17:33:24',3310491454,1),(646808883,425126986,15355093,3916355,1,'2010-02-19 17:33:24',3310491454,1),(646808884,425127778,15354470,3916355,1,'2010-02-19 17:33:24',3310491454,1),(646808885,425121167,15366233,3916355,1,'2010-02-19 17:33:25',3310491451,1),(646808886,425121143,15366747,3916355,1,'2010-02-19 17:33:25',3310491451,1),(646808887,425121573,15367770,3916355,1,'2010-02-19 17:33:25',3310491451,1),(646808888,425121912,15368002,3916355,1,'2010-02-19 17:33:25',3310491451,1),(646808889,425122591,15367982,3916355,1,'2010-02-19 17:33:25',3310491454,1),(646808890,425122922,15367729,3916355,1,'2010-02-19 17:33:26',3310491454,1),(646808892,425123261,15367067,3916355,1,'2010-02-19 17:33:26',3310491454,1),(646808893,425123186,15365870,3916355,1,'2010-02-19 17:33:26',3310491454,1),(646808895,425122949,15365469,3916355,1,'2010-02-19 17:33:26',3310491454,1),(646808896,425122624,15365202,3916355,1,'2010-02-19 17:33:26',3310491454,1),(646808900,425122056,15365120,3916355,1,'2010-02-19 17:33:27',3310491451,1),(646808903,425121698,15365288,3916355,1,'2010-02-19 17:33:27',3310491451,1),(646809553,425052682,15273233,3916355,1,'2010-02-19 17:34:12',3310491437,1),(646809558,425052994,15275620,3916355,1,'2010-02-19 17:34:13',3310491437,1),(646809563,425053532,15275204,3916355,1,'2010-02-19 17:34:13',3310491437,1),(646809578,425053715,15274126,3916355,1,'2010-02-19 17:34:14',3310491437,1),(646809579,425067118,15320162,3916355,1,'2010-02-19 17:34:14',3310491437,1),(646809584,425066678,15320331,3916355,1,'2010-02-19 17:34:15',3310491437,1),(646809589,425066415,15320820,3916355,1,'2010-02-19 17:34:15',3310491437,1),(646809604,425066881,15321999,3916355,1,'2010-02-19 17:34:15',3310491437,1),(646809608,425067283,15321994,3916355,1,'2010-02-19 17:34:16',3310491437,1),(646809614,425067766,15321032,3916355,1,'2010-02-19 17:34:16',3310491448,1),(646809632,425096900,15403108,3916355,1,'2010-02-19 17:34:17',3310491537,1),(646809636,425097046,15402412,3916355,1,'2010-02-19 17:34:17',3310491537,1),(646809642,425096795,15401673,3916355,1,'2010-02-19 17:34:17',3310491537,1),(646809643,425096262,15401367,3916355,1,'2010-02-19 17:34:17',3310491537,1),(646809644,425095690,15401645,3916355,1,'2010-02-19 17:34:17',3310491537,1),(646809645,425095420,15402348,3916355,1,'2010-02-19 17:34:17',3310491537,1),(646809646,425095579,15403140,3916355,1,'2010-02-19 17:34:18',3310491537,1),(646809647,425095979,15403527,3916355,1,'2010-02-19 17:34:18',3310491537,1),(646809648,425096480,15403529,3916355,1,'2010-02-19 17:34:18',3310491537,1),(646809649,425095793,15388197,3916355,1,'2010-02-19 17:34:19',3310491537,1),(646809650,425095716,15387559,3916355,1,'2010-02-19 17:34:19',3310491537,1),(646809651,425095299,15387162,3916355,1,'2010-02-19 17:34:19',3310491537,1),(646809652,425095079,15387154,3916355,1,'2010-02-19 17:34:19',3310491537,1),(646809653,425094771,15387339,3916355,1,'2010-02-19 17:34:19',3310491536,1),(646809654,425094627,15387566,3916355,1,'2010-02-19 17:34:20',3310491536,1),(646809655,425094548,15388160,3916355,1,'2010-02-19 17:34:20',3310491536,1),(646809656,425094624,15388441,3916355,1,'2010-02-19 17:34:20',3310491536,1),(646809657,425094978,15388827,3916355,1,'2010-02-19 17:34:20',3310491536,1),(646809658,425095504,15388742,3916355,1,'2010-02-19 17:34:20',3310491537,1),(646809672,425060696,15316764,3916355,1,'2010-02-19 17:34:21',3310491437,1),(646809674,425060371,15316514,3916355,1,'2010-02-19 17:34:21',3310491437,1),(646809678,425059971,15316533,3916355,1,'2010-02-19 17:34:21',3310491437,1),(646809684,425059490,15317341,3916355,1,'2010-02-19 17:34:21',3310491437,1),(646809689,425059738,15318184,3916355,1,'2010-02-19 17:34:22',3310491437,1),(646809695,425060429,15318358,3916355,1,'2010-02-19 17:34:22',3310491437,1),(646809706,425060786,15317984,3916355,1,'2010-02-19 17:34:22',3310491437,1),(646809720,425036528,15180066,3916355,1,'2010-02-19 17:34:23',3310491428,1),(646809729,425036667,15192431,3916355,1,'2010-02-19 17:34:26',3310491428,1),(663075945,425350919,14888980,4076773,1,'2010-03-09 00:21:26',3310491134,1),(663075946,425364521,14901933,4076773,1,'2010-03-09 00:21:27',3310491134,1),(663078911,425305403,14743589,4099383,1,'2010-03-11 19:09:03',3310491120,2),(663078912,425364963,14897914,4076872,1,'2010-03-09 00:33:55',3310491134,1),(663080312,425348713,14881373,4076934,1,'2010-03-09 00:40:43',3310491132,1),(663080313,425375895,14845831,4076934,1,'2010-03-09 00:40:43',3310491133,1),(663084327,425305570,14743394,4077060,1,'2010-03-09 00:55:20',3310491120,1),(663084328,425374897,14837366,4077060,1,'2010-03-09 00:55:20',3310491133,1),(663086638,425337908,14700074,4077132,1,'2010-03-09 01:04:51',3310491099,1),(663086639,425305248,14737749,4077132,1,'2010-03-09 01:04:51',3310491120,1),(663092389,425349965,14528820,4161911,1,'2010-03-18 16:53:24',3310491092,2),(663092390,425444649,14524549,4077213,1,'2010-03-09 01:15:07',3310502017,1),(663093429,425388591,14520891,4099383,1,'2010-03-11 19:09:03',3310491093,2),(663093430,425461551,14457107,4099383,1,'2010-03-11 19:09:03',3310501934,2),(663095052,425339072,14688950,4161911,1,'2010-03-18 16:53:24',3310491099,2),(663339197,426242409,15042758,4082908,1,'2010-03-09 19:56:14',3310502742,1),(663339199,426309688,15010315,4082908,1,'2010-03-09 19:56:15',3310503427,1),(663345420,426196539,15035976,4161868,1,'2010-03-18 16:48:01',3310502739,2),(663345421,426310907,15004789,4083006,1,'2010-03-09 20:07:11',3310503427,1),(663372539,425700874,14512465,4161539,1,'2010-03-18 16:04:24',3310502085,2),(663372540,425724358,14707197,4161539,1,'2010-03-18 16:04:24',3310502095,2),(663373401,425727343,14658685,4101592,1,'2010-03-11 23:12:19',3310502104,2),(663373402,425746083,14703624,4101592,1,'2010-03-11 23:12:19',3310502106,2),(663802644,426246755,14975797,4092743,1,'2010-03-10 21:47:17',3310502740,1),(663802645,426276533,14979749,4092743,1,'2010-03-10 21:47:17',3310503424,1),(663803593,426249538,14973830,4092770,1,'2010-03-10 21:50:18',3310502741,1),(663803594,426273575,14976629,4092770,1,'2010-03-10 21:50:21',3310502741,1),(663810387,426243099,15025738,4161868,1,'2010-03-18 16:48:01',3310502742,2),(663810389,426242718,15020443,4161868,1,'2010-03-18 16:48:01',3310502742,2),(663810390,426240402,15039575,4092963,1,'2010-03-10 22:12:46',3310502742,1),(663810391,426242852,15033117,4161868,1,'2010-03-18 16:48:01',3310502742,2),(663810392,426254140,15014955,4092963,1,'2010-03-10 22:12:46',3310502743,1),(663810393,426247089,15016457,4161868,1,'2010-03-18 16:48:01',3310502742,2),(663810394,426262747,15023614,4161868,1,'2010-03-18 16:48:01',3310502743,2),(663810395,426288818,15012708,4161868,1,'2010-03-18 16:48:01',3310503426,2),(663810396,426311083,15008174,4161868,1,'2010-03-18 16:48:01',3310503427,2),(663952666,426289238,14865416,4096040,1,'2010-03-11 10:54:37',3310503080,1),(663952667,426292187,14888431,4096040,1,'2010-03-11 10:54:37',3310503082,1),(663953196,426323880,14960295,4096072,1,'2010-03-11 11:00:51',3310503425,1),(663953551,426324578,14960537,4096095,1,'2010-03-11 11:05:32',3310503425,1),(663953552,426333575,14962751,4096095,1,'2010-03-11 11:05:32',3310503428,1),(663953553,426337339,14972403,4096095,1,'2010-03-11 11:05:32',3310503428,1),(663955433,426319069,14877921,4161868,1,'2010-03-18 16:48:01',3310503081,2),(663955434,426316037,14826937,4161868,1,'2010-03-18 16:48:01',3310503075,2),(663955435,426317929,14869948,4161868,1,'2010-03-18 16:48:01',3310503081,2),(663955436,426275899,14932985,4096166,1,'2010-03-11 11:18:38',3310502399,1),(663955437,426275554,14934126,4096166,1,'2010-03-11 11:18:38',3310502399,1),(663955438,426279293,14933248,4096166,1,'2010-03-11 11:18:38',3310503082,1),(663955439,426281962,14938572,4096166,1,'2010-03-11 11:18:38',3310503082,1),(663955440,426281184,14932654,4096166,1,'2010-03-11 11:18:38',3310503082,1),(663955441,426289146,14934924,4096166,1,'2010-03-11 11:18:38',3310503082,1),(663955442,426283777,14932685,4096166,1,'2010-03-11 11:18:38',3310503082,1),(663955443,426320774,14886521,4096166,1,'2010-03-11 11:18:38',3310503081,1),(663955444,426326907,14918373,4096166,1,'2010-03-11 11:18:38',3310503083,1),(663955445,426330004,14905471,4096166,1,'2010-03-11 11:18:38',3310503083,1),(663955446,426328398,14898584,4096166,1,'2010-03-11 11:18:38',3310503083,1),(663955447,426326662,14932262,4096166,1,'2010-03-11 11:18:38',3310503083,1),(663955448,426279526,14944468,4096166,1,'2010-03-11 11:18:38',3310503424,1),(663955449,426279593,14942972,4096166,1,'2010-03-11 11:18:38',3310503424,1),(663955450,426280794,14942200,4096166,1,'2010-03-11 11:18:38',3310503424,1),(663955451,426282596,14947099,4096166,1,'2010-03-11 11:18:39',3310503424,1),(663955452,426282162,14953268,4096166,1,'2010-03-11 11:18:39',3310503424,1),(663955453,426283230,14949957,4096166,1,'2010-03-11 11:18:39',3310503424,1),(663955454,426279559,14957124,4096166,1,'2010-03-11 11:18:39',3310503424,1),(663955455,426278358,14958666,4096166,1,'2010-03-11 11:18:39',3310503424,1),(663955456,426286568,14943017,4096166,1,'2010-03-11 11:18:39',3310503424,1),(663955457,426285233,14945194,4096166,1,'2010-03-11 11:18:39',3310503424,1);
INSERT INTO `current_nodes` VALUES (663955458,426289805,14948823,4096166,1,'2010-03-11 11:18:39',3310503424,1),(663955459,426295563,14942965,4096166,1,'2010-03-11 11:18:39',3310503424,1),(663955460,426290372,14946147,4096166,1,'2010-03-11 11:18:39',3310503424,1),(663955461,426290740,14947961,4096166,1,'2010-03-11 11:18:39',3310503424,1),(663955462,426303828,14957113,4096166,1,'2010-03-11 11:18:39',3310503425,1),(663955463,426319872,14962699,4096166,1,'2010-03-11 11:18:39',3310503425,1),(663955464,426323838,14957403,4096166,1,'2010-03-11 11:18:39',3310503425,1),(663955465,426313798,14963496,4096166,1,'2010-03-11 11:18:39',3310503425,1),(663955466,426325133,14944050,4096166,1,'2010-03-11 11:18:39',3310503425,1),(663956152,426292908,14889899,4096186,1,'2010-03-11 11:22:31',3310503082,1),(663956153,426294190,14898869,4096186,1,'2010-03-11 11:22:31',3310503082,1),(663956154,426296240,14901743,4096186,1,'2010-03-11 11:22:31',3310503082,1),(663956155,426299465,14902759,4096186,1,'2010-03-11 11:22:32',3310503082,1),(663956156,426300675,14906104,4096186,1,'2010-03-11 11:22:32',3310503082,1),(663956157,426303887,14909280,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956158,426308726,14906558,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956159,426311730,14903780,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956160,426311688,14908656,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956161,426312564,14912058,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956162,426312564,14914496,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956163,426314191,14916197,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956164,426317320,14916821,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956165,426324203,14902759,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956166,426321283,14903666,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956167,426301176,14903836,4096186,1,'2010-03-11 11:22:32',3310503082,1),(663956168,426325454,14906161,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956169,426327457,14905594,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956170,426328666,14907182,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956738,426179584,14858670,4161868,1,'2010-03-18 16:48:00',3310502392,2),(663956739,426188018,14857526,4161868,1,'2010-03-18 16:48:01',3310502392,2),(663956740,426193223,14863153,4096227,1,'2010-03-11 11:29:18',3310502392,1),(663956742,426202937,14861469,4096227,1,'2010-03-11 11:29:18',3310502393,1),(663956743,426214981,14862001,4096227,1,'2010-03-11 11:29:18',3310502393,1),(663956744,426220115,14854249,4096227,1,'2010-03-11 11:29:18',3310502393,1),(663956745,426227041,14851037,4096227,1,'2010-03-11 11:29:18',3310502396,1),(663956746,426228426,14845390,4096227,1,'2010-03-11 11:29:18',3310502396,1),(663956747,426233397,14841956,4096227,1,'2010-03-11 11:29:18',3310502396,1),(663956748,426240079,14831547,4096227,1,'2010-03-11 11:29:18',3310502390,1),(663956749,426243909,14833097,4096227,1,'2010-03-11 11:29:18',3310502396,1),(663956750,426262324,14849376,4096227,1,'2010-03-11 11:29:18',3310502397,1),(663956751,426272102,14849930,4096227,1,'2010-03-11 11:29:18',3310502397,1),(663956752,426293776,14864770,4096227,1,'2010-03-11 11:29:18',3310503080,1),(663956753,426280332,14859011,4096227,1,'2010-03-11 11:29:18',3310503080,1),(663956754,426313005,14871414,4096227,1,'2010-03-11 11:29:18',3310503081,1),(663956755,426318301,14887915,4096227,1,'2010-03-11 11:29:18',3310503083,1),(663956756,426327507,14904415,4096227,1,'2010-03-11 11:29:18',3310503083,1),(663957559,426250466,14914536,4161868,1,'2010-03-18 16:48:01',3310502399,2),(663957562,426227493,14850256,4161868,1,'2010-03-18 16:48:01',3310502396,2),(664061744,425682046,16425324,4098619,1,'2010-03-11 17:30:56',3310504142,1),(664061745,425684920,16466451,4098619,1,'2010-03-11 17:30:56',3310504142,1),(664061746,425684937,16466221,4098619,1,'2010-03-11 17:30:56',3310504142,1),(664061747,425774383,16486767,4098619,1,'2010-03-11 17:30:56',3310504177,1),(664061748,425775092,16489805,4098619,1,'2010-03-11 17:30:56',3310504177,1),(664085275,425331110,14714962,4098931,1,'2010-03-11 18:10:53',3310491099,1),(664085276,425339621,14718488,4098931,1,'2010-03-11 18:10:53',3310491099,1),(664085277,425339621,14714233,4098931,1,'2010-03-11 18:10:53',3310491099,1),(664085278,425339621,14708154,4098931,1,'2010-03-11 18:10:53',3310491099,1),(664085279,425338994,14701102,4098931,1,'2010-03-11 18:10:53',3310491099,1),(664085280,425335768,14708883,4098931,1,'2010-03-11 18:10:53',3310491099,1),(664085281,425337919,14703777,4098931,1,'2010-03-11 18:10:53',3310491099,1),(664085282,425338635,14701467,4098931,1,'2010-03-11 18:10:53',3310491099,1),(664085283,425338366,14700494,4098931,1,'2010-03-11 18:10:53',3310491099,1),(664085284,425304236,14741774,4098931,1,'2010-03-11 18:10:53',3310491120,1),(664085285,425307970,14744579,4098931,1,'2010-03-11 18:10:53',3310491120,1),(664085286,425304590,14741223,4098931,1,'2010-03-11 18:10:53',3310491120,1),(664085287,425305486,14740251,4098931,1,'2010-03-11 18:10:53',3310491120,1),(664085288,425306741,14736117,4098931,1,'2010-03-11 18:10:53',3310491120,1),(664085289,425311141,14748690,4098931,1,'2010-03-11 18:10:53',3310491120,1),(664085290,425309877,14744020,4098931,1,'2010-03-11 18:10:53',3310491120,1),(664085291,425314446,14745478,4098931,1,'2010-03-11 18:10:53',3310491120,1),(664085292,425317940,14744627,4098931,1,'2010-03-11 18:10:53',3310491121,1),(664085293,425310683,14737211,4098931,1,'2010-03-11 18:10:53',3310491120,1),(664085294,425315790,14733321,4098931,1,'2010-03-11 18:10:53',3310491121,1),(664085296,425320180,14729187,4098931,1,'2010-03-11 18:10:53',3310491121,1),(664085297,425323942,14742804,4098931,1,'2010-03-11 18:10:53',3310491121,1),(664085298,425331468,14739156,4098931,1,'2010-03-11 18:10:54',3310491121,1),(664085299,425325645,14722500,4098931,1,'2010-03-11 18:10:54',3310491121,1),(664085300,425313912,14753981,4098931,1,'2010-03-11 18:10:54',3310491120,1),(664085301,425317083,14760291,4098931,1,'2010-03-11 18:10:54',3310491121,1),(664085302,425321252,14770569,4098931,1,'2010-03-11 18:10:54',3310491121,1),(664085303,425327857,14788547,4098931,1,'2010-03-11 18:10:54',3310491123,1),(664085304,425324480,14778183,4098931,1,'2010-03-11 18:10:54',3310491123,1),(664085305,425326451,14780007,4098931,1,'2010-03-11 18:10:54',3310491123,1),(664085306,425333349,14783776,4098931,1,'2010-03-11 18:10:54',3310491123,1),(664085307,425334425,14810086,4098931,1,'2010-03-11 18:10:54',3310491123,1),(664085308,425335948,14737211,4098931,1,'2010-03-11 18:10:54',3310491121,1),(664085309,425338098,14733321,4098931,1,'2010-03-11 18:10:54',3310491121,1),(664085310,425339710,14728457,4098931,1,'2010-03-11 18:10:54',3310491121,1),(664085311,425340248,14723229,4098931,1,'2010-03-11 18:10:54',3310491121,1),(664085312,425339531,14785843,4098931,1,'2010-03-11 18:10:54',3310491123,1),(664085313,425344996,14787180,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085314,425347236,14788031,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085315,425348938,14789976,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085316,425357180,14802256,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085317,425357628,14800432,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085318,425358524,14800311,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085319,425359061,14801162,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085320,425359151,14802621,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085321,425350461,14793745,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085322,425351446,14798730,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085323,425340803,14825940,4098931,1,'2010-03-11 18:10:54',3310491123,1),(664085324,425354761,14826329,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085325,425355657,14820493,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085326,425356642,14812712,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085327,425356822,14806876,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085328,425359599,14806146,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085329,425360942,14812833,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085330,425362913,14821709,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085331,425353328,14804080,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085332,425355119,14808578,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085333,425355926,14810523,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085334,425364705,14826572,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085335,425347182,14836736,4098931,1,'2010-03-11 18:10:54',3310491132,1),(664085336,425352056,14840237,4098931,1,'2010-03-11 18:10:54',3310491132,1),(664085337,425357502,14843252,4098931,1,'2010-03-11 18:10:54',3310491132,1),(664085338,425360799,14843447,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085339,425354492,14856237,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085340,425356105,14847240,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085341,425356284,14839459,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085342,425354671,14832043,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085344,425349207,14884443,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085345,425351715,14883836,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085346,425356553,14876662,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085348,425351984,14874960,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085354,425353686,14865720,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085355,425364024,14840140,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085357,425367106,14838195,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085358,425366676,14831678,4098931,1,'2010-03-11 18:10:55',3310491126,1),(664085360,425369095,14834961,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085361,425370833,14838681,4098931,1,'2010-03-11 18:10:55',3310491133,1),(664085362,425376494,14842085,4098931,1,'2010-03-11 18:10:55',3310491133,1),(664085364,425375186,14840432,4098931,1,'2010-03-11 18:10:55',3310491133,1),(664085365,425372857,14856115,4098931,1,'2010-03-11 18:10:55',3310491133,1),(664085367,425375724,14850523,4098931,1,'2010-03-11 18:10:55',3310491133,1),(664085368,425378770,14855872,4098931,1,'2010-03-11 18:10:55',3310491133,1),(664085369,425378949,14852590,4098931,1,'2010-03-11 18:10:56',3310491133,1),(664085371,425378322,14848578,4098931,1,'2010-03-11 18:10:56',3310491133,1),(664085372,425377247,14843958,4098931,1,'2010-03-11 18:10:56',3310491133,1),(664085373,425377068,14844079,4098931,1,'2010-03-11 18:10:56',3310491133,1),(664085375,425373305,14882741,4098931,1,'2010-03-11 18:10:56',3310491133,1),(664085376,425375007,14873258,4098931,1,'2010-03-11 18:10:56',3310491133,1),(664085377,425363540,14868517,4098931,1,'2010-03-11 18:10:56',3310491132,1),(664085379,425368647,14862559,4098931,1,'2010-03-11 18:10:56',3310491132,1),(664085380,425377068,14863653,4098931,1,'2010-03-11 18:10:56',3310491133,1),(664085381,425348848,14888577,4098931,1,'2010-03-11 18:10:56',3310491134,1),(664085382,425350103,14887604,4098931,1,'2010-03-11 18:10:56',3310491134,1),(664085383,425349834,14890644,4098931,1,'2010-03-11 18:10:56',3310491134,1),(664085384,425350103,14894291,4098931,1,'2010-03-11 18:10:56',3310491134,1),(664085385,425352253,14898303,4098931,1,'2010-03-11 18:10:56',3310491134,1),(664085386,425354940,14901100,4098931,1,'2010-03-11 18:10:56',3310491134,1),(664085387,425357538,14902559,4098931,1,'2010-03-11 18:10:56',3310491134,1),(664085388,425360763,14902559,4098931,1,'2010-03-11 18:10:56',3310491134,1),(664085389,425362913,14902559,4098931,1,'2010-03-11 18:10:56',3310491134,1),(664085390,425366228,14903288,4098931,1,'2010-03-11 18:10:56',3310491134,1),(664085392,425370707,14890887,4098931,1,'2010-03-11 18:10:56',3310491135,1),(664085393,425364526,14902072,4098931,1,'2010-03-11 18:10:56',3310491134,1),(664115756,425265974,14581203,4099383,1,'2010-03-11 19:08:50',3310491079,1),(664115763,425275854,14571334,4099383,1,'2010-03-11 19:08:50',3310491079,1),(664115765,425275471,14601750,4099383,1,'2010-03-11 19:08:50',3310491079,1),(664115766,425279145,14605641,4099383,1,'2010-03-11 19:08:50',3310491079,1),(664115767,425280758,14609045,4099383,1,'2010-03-11 19:08:50',3310491079,1),(664115768,425269737,14589957,4099383,1,'2010-03-11 19:08:50',3310491079,1),(664115769,425276009,14605519,4099383,1,'2010-03-11 19:08:50',3310491079,1),(664115770,425273321,14598346,4099383,1,'2010-03-11 19:08:50',3310491079,1),(664115771,425279593,14659500,4099383,1,'2010-03-11 19:08:50',3310491085,1),(664115772,425279145,14614273,4099383,1,'2010-03-11 19:08:50',3310491085,1),(664115773,425278607,14611963,4099383,1,'2010-03-11 19:08:50',3310491079,1),(664115774,425277980,14632145,4099383,1,'2010-03-11 19:08:50',3310491085,1),(664115775,425278159,14626674,4099383,1,'2010-03-11 19:08:50',3310491085,1),(664115776,425278966,14620352,4099383,1,'2010-03-11 19:08:50',3310491085,1),(664115777,425279145,14616704,4099383,1,'2010-03-11 19:08:50',3310491085,1),(664115778,425277622,14650503,4099383,1,'2010-03-11 19:08:50',3310491085,1),(664115779,425276636,14646005,4099383,1,'2010-03-11 19:08:50',3310491085,1),(664115780,425276636,14642236,4099383,1,'2010-03-11 19:08:50',3310491085,1),(664115781,425277353,14638224,4099383,1,'2010-03-11 19:08:50',3310491085,1),(664115789,425320041,14542156,4099383,1,'2010-03-11 19:08:50',3310491089,1),(664115790,425317942,14548425,4099383,1,'2010-03-11 19:08:50',3310491089,1),(664115791,425316262,14554504,4099383,1,'2010-03-11 19:08:50',3310491089,1),(664115792,425321196,14539604,4099383,1,'2010-03-11 19:08:50',3310491089,1),(664115793,425329508,14549102,4099383,1,'2010-03-11 19:08:50',3310491089,1),(664115800,425282573,14580832,4099383,1,'2010-03-11 19:08:51',3310491079,1),(664115801,425308003,14574641,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115802,425307023,14576540,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115803,425306603,14579960,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115804,425288873,14589761,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115805,425292793,14597930,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115806,425294753,14600399,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115807,425298113,14601539,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115808,425297833,14604958,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115809,425297833,14608758,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115810,425300773,14600209,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115811,425305063,14585279,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115812,425302963,14591168,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115813,425301703,14595157,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115814,425299323,14600476,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115815,425296803,14604276,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115816,425295403,14609405,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115817,425314302,14562103,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115818,425311922,14568562,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115819,425310662,14570081,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115822,425347746,14522941,4099383,1,'2010-03-11 19:08:51',3310491092,1),(664115823,425352777,14522941,4099383,1,'2010-03-11 19:08:51',3310491092,1),(664115824,425358026,14524722,4099383,1,'2010-03-11 19:08:51',3310491092,1),(664115825,425360651,14524722,4099383,1,'2010-03-11 19:08:51',3310491092,1),(664115826,425365462,14524425,4099383,1,'2010-03-11 19:08:51',3310491092,1),(664115827,425370712,14524129,4099383,1,'2010-03-11 19:08:51',3310491093,1),(664115828,425376617,14525019,4099383,1,'2010-03-11 19:08:51',3310491093,1),(664115829,425380991,14525910,4099383,1,'2010-03-11 19:08:51',3310491093,1),(664115830,425384272,14525910,4099383,1,'2010-03-11 19:08:51',3310491093,1),(664115831,425387333,14527097,4099383,1,'2010-03-11 19:08:51',3310491093,1),(664115832,425389662,14528772,4099383,1,'2010-03-11 19:08:51',3310491093,1),(664115833,425388449,14522891,4099383,1,'2010-03-11 19:08:51',3310491093,1),(664115834,425388831,14524006,4099383,1,'2010-03-11 19:08:51',3310491093,1),(664115835,425389447,14524803,4099383,1,'2010-03-11 19:08:51',3310491093,1),(664115836,425390592,14525241,4099383,1,'2010-03-11 19:08:51',3310491093,1),(664115837,425389739,14529768,4099383,1,'2010-03-11 19:08:51',3310491093,1),(664115838,425336726,14558303,4099383,1,'2010-03-11 19:08:52',3310491091,1),(664115839,425343506,14568989,4099383,1,'2010-03-11 19:08:52',3310491094,1),(664115840,425350287,14581456,4099383,1,'2010-03-11 19:08:52',3310491094,1),(664115841,425355098,14590657,4099383,1,'2010-03-11 19:08:52',3310491094,1),(664115842,425358598,14598078,4099383,1,'2010-03-11 19:08:52',3310491094,1),(664115843,425360566,14606983,4099383,1,'2010-03-11 19:08:52',3310491094,1),(664115844,425282102,14612084,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115845,425282102,14614030,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115846,425281923,14616704,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115847,425281475,14619136,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115848,425281475,14620960,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115849,425281743,14623148,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115850,425281385,14625458,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115851,425293863,14615104,4099383,1,'2010-03-11 19:08:52',3310491096,1),(664115852,425291763,14620233,4099383,1,'2010-03-11 19:08:52',3310491096,1),(664115853,425280937,14628741,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115854,425280937,14631780,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115855,425281564,14636157,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115856,425286724,14635050,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115857,425285604,14638280,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115858,425290084,14625552,4099383,1,'2010-03-11 19:08:52',3310491096,1),(664115859,425288404,14630681,4099383,1,'2010-03-11 19:08:52',3310491096,1),(664115860,425299093,14615027,4099383,1,'2010-03-11 19:08:52',3310491096,1),(664115861,425302732,14621865,4099383,1,'2010-03-11 19:08:52',3310491096,1),(664115862,425307352,14627944,4099383,1,'2010-03-11 19:08:52',3310491096,1),(664115863,425282281,14639318,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115864,425283177,14643209,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115865,425284790,14647707,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115866,425287030,14651598,4099383,1,'2010-03-11 19:08:53',3310491085,1),(664115867,425284624,14642459,4099383,1,'2010-03-11 19:08:53',3310491085,1),(664115868,425284344,14650628,4099383,1,'2010-03-11 19:08:53',3310491085,1),(664115869,425281116,14665944,4099383,1,'2010-03-11 19:08:53',3310491085,1),(664115870,425284204,14658986,4099383,1,'2010-03-11 19:08:53',3310491085,1),(664115871,425284904,14664875,4099383,1,'2010-03-11 19:08:53',3310491085,1),(664115872,425289538,14655853,4099383,1,'2010-03-11 19:08:53',3310491096,1),(664115873,425291868,14660716,4099383,1,'2010-03-11 19:08:53',3310491096,1),(664115874,425294556,14664363,4099383,1,'2010-03-11 19:08:53',3310491096,1),(664115875,425312252,14635543,4099383,1,'2010-03-11 19:08:53',3310491096,1),(664115876,425317431,14642952,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115877,425320371,14647701,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115878,425330661,14665214,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115879,425330393,14661689,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115880,425330393,14659257,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115881,425330930,14659257,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115882,425331468,14660108,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115883,425332901,14664485,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115884,425322051,14651310,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115885,425323591,14653590,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115886,425327230,14656439,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115887,425330730,14658529,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115888,425334320,14653584,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115889,425330820,14657740,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115890,425282818,14669227,4099383,1,'2010-03-11 19:08:53',3310491087,1),(664115891,425285865,14671537,4099383,1,'2010-03-11 19:08:53',3310491087,1),(664115892,425286024,14673044,4099383,1,'2010-03-11 19:08:53',3310491087,1),(664115893,425283714,14675184,4099383,1,'2010-03-11 19:08:53',3310491087,1),(664115894,425283325,14678352,4099383,1,'2010-03-11 19:08:53',3310491087,1),(664115895,425285884,14679503,4099383,1,'2010-03-11 19:08:53',3310491087,1),(664115896,425289359,14674211,4099383,1,'2010-03-11 19:08:53',3310491098,1),(664115897,425291957,14675549,4099383,1,'2010-03-11 19:08:53',3310491098,1),(664115898,425294018,14675549,4099383,1,'2010-03-11 19:08:53',3310491098,1),(664115899,425283745,14683085,4099383,1,'2010-03-11 19:08:53',3310491087,1),(664115900,425284431,14688558,4099383,1,'2010-03-11 19:08:53',3310491087,1),(664115901,425285884,14684632,4099383,1,'2010-03-11 19:08:53',3310491087,1),(664115902,425285044,14689951,4099383,1,'2010-03-11 19:08:53',3310491087,1),(664115903,425288373,14683816,4099383,1,'2010-03-11 19:08:53',3310491098,1),(664115904,425292674,14690989,4099383,1,'2010-03-11 19:08:53',3310491098,1),(664115905,425306561,14692691,4099383,1,'2010-03-11 19:08:53',3310491098,1),(664115906,425297243,14676643,4099383,1,'2010-03-11 19:08:53',3310491098,1),(664115907,425301275,14678710,4099383,1,'2010-03-11 19:08:53',3310491098,1),(664115908,425305486,14681020,4099383,1,'2010-03-11 19:08:53',3310491098,1),(664115909,425299394,14669348,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115910,425304053,14673482,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115911,425286724,14695840,4099383,1,'2010-03-11 19:08:54',3310491087,1),(664115912,425289104,14701539,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115913,425290644,14706288,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115914,425290784,14710277,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115915,425291763,14715217,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115916,425294003,14719966,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115917,425301723,14717493,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115918,425302261,14710807,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115919,425303425,14703512,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115920,425304949,14696582,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115921,425296527,14696947,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115922,425300648,14703269,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115923,425302440,14704363,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115924,425303963,14704849,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115925,425306382,14703998,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115926,425307368,14701810,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115927,425314177,14677008,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115928,425314087,14675792,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115929,425314535,14674576,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115930,425309607,14677372,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115931,425311847,14679561,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115932,425313911,14679931,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115933,425315252,14674941,4099383,1,'2010-03-11 19:08:54',3310491099,1),(664115935,425315789,14675913,4099383,1,'2010-03-11 19:08:54',3310491099,1),(664115936,425316237,14678345,4099383,1,'2010-03-11 19:08:54',3310491099,1),(664115938,425309159,14689044,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115940,425311937,14687099,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115941,425313549,14686612,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115943,425314177,14685275,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115945,425314625,14683087,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115947,425314714,14680655,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115948,425308532,14681992,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115950,425310503,14682965,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115952,425312116,14684545,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115953,425314087,14685153,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115955,425314266,14682600,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115957,425317402,14681749,4099383,1,'2010-03-11 19:08:54',3310491099,1),(664115958,425318925,14684424,4099383,1,'2010-03-11 19:08:54',3310491099,1),(664115960,425320717,14687099,4099383,1,'2010-03-11 19:08:54',3310491099,1),(664115961,425321882,14688314,4099383,1,'2010-03-11 19:08:54',3310491099,1),(664115962,425315521,14686734,4099383,1,'2010-03-11 19:08:54',3310491099,1),(664115963,425317402,14687707,4099383,1,'2010-03-11 19:08:54',3310491099,1),(664115964,425320090,14688801,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115965,425323225,14688314,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115966,425324121,14685640,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115967,425325196,14682357,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115968,425327705,14677494,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115970,425329138,14674454,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115971,425330572,14669834,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115973,425334424,14670199,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115974,425335589,14675549,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115976,425335678,14680777,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115977,425324480,14690503,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115978,425327436,14692691,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115980,425329766,14694150,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115981,425308980,14699135,4099383,1,'2010-03-11 19:08:55',3310491098,1),(664115983,425310862,14698041,4099383,1,'2010-03-11 19:08:55',3310491098,1),(664115984,425312922,14696825,4099383,1,'2010-03-11 19:08:55',3310491098,1),(664115985,425315789,14696460,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115986,425320896,14697190,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115987,425324569,14698284,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115988,425327257,14699257,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115989,425329676,14699257,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115990,425332274,14698770,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115991,425334603,14698770,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115992,425331826,14695488,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115993,425334962,14697068,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115994,425347443,14636665,4099383,1,'2010-03-11 19:08:55',3310491100,1),(664115995,425344381,14637852,4099383,1,'2010-03-11 19:08:55',3310491100,1),(664115996,425362097,14613216,4099383,1,'2010-03-11 19:08:55',3310491100,1),(664115997,425361441,14636962,4099383,1,'2010-03-11 19:08:55',3310491100,1),(664115998,425356848,14638743,4099383,1,'2010-03-11 19:08:55',3310491100,1),(664115999,425354005,14636665,4099383,1,'2010-03-11 19:08:55',3310491100,1),(664116000,425351162,14635775,4099383,1,'2010-03-11 19:08:55',3310491100,1),(664116001,425343069,14641117,4099383,1,'2010-03-11 19:08:55',3310491100,1),(664116002,425341538,14645273,4099383,1,'2010-03-11 19:08:55',3310491097,1),(664116003,425337601,14649428,4099383,1,'2010-03-11 19:08:55',3310491097,1),(664116004,425364066,14617075,4099383,1,'2010-03-11 19:08:56',3310491100,1),(664116005,425365378,14623011,4099383,1,'2010-03-11 19:08:56',3310491100,1),(664116006,425366034,14628651,4099383,1,'2010-03-11 19:08:56',3310491100,1),(664116007,425364503,14634587,4099383,1,'2010-03-11 19:08:56',3310491100,1),(664116008,425336037,14686126,4099383,1,'2010-03-11 19:08:56',3310491099,1),(664116009,425336395,14691597,4099383,1,'2010-03-11 19:08:56',3310491099,1),(664116011,425336933,14695731,4099383,1,'2010-03-11 19:08:56',3310491099,1),(664116012,425338277,14698527,4099383,1,'2010-03-11 19:08:56',3310491099,1),(664116013,425338366,14699621,4099383,1,'2010-03-11 19:08:56',3310491099,1),(664116014,425337739,14699013,4099383,1,'2010-03-11 19:08:56',3310491099,1),(664116015,425296943,14723765,4099383,1,'2010-03-11 19:08:56',3310491120,1),(664116016,425298623,14728514,4099383,1,'2010-03-11 19:08:56',3310491120,1),(664116017,425300723,14732694,4099383,1,'2010-03-11 19:08:56',3310491120,1),(664116018,425302440,14730746,4099383,1,'2010-03-11 19:08:56',3310491120,1),(664116019,425302440,14721992,4099383,1,'2010-03-11 19:08:56',3310491120,1),(664116020,425302440,14736946,4099383,1,'2010-03-11 19:08:56',3310491120,1),(664116021,425301983,14737823,4099383,1,'2010-03-11 19:08:56',3310491120,1),(664116022,425303873,14743390,4099383,1,'2010-03-11 19:08:56',3310491120,1),(664116023,425307368,14750928,4099383,1,'2010-03-11 19:08:56',3310491120,1),(664116024,425311310,14760532,4099383,1,'2010-03-11 19:08:56',3310491120,1),(664116025,425313997,14771596,4099383,1,'2010-03-11 19:08:56',3310491120,1),(664116026,425317581,14785699,4099383,1,'2010-03-11 19:08:56',3310491123,1),(664116027,425320896,14802113,4099383,1,'2010-03-11 19:08:56',3310491123,1),(664116028,425324211,14816337,4099383,1,'2010-03-11 19:08:56',3310491123,1),(664116029,425327257,14830076,4099383,1,'2010-03-11 19:08:56',3310491123,1),(664116030,425329766,14842234,4099383,1,'2010-03-11 19:08:56',3310491129,1),(664116031,425331737,14847218,4099383,1,'2010-03-11 19:08:56',3310491129,1),(664116032,425333528,14850015,4099383,1,'2010-03-11 19:08:56',3310491129,1),(664116033,425336395,14852689,4099383,1,'2010-03-11 19:08:56',3310491129,1),(664116034,425340068,14856702,4099383,1,'2010-03-11 19:08:56',3310491129,1),(664116035,425342398,14859619,4099383,1,'2010-03-11 19:08:56',3310491132,1),(664116036,425344100,14863510,4099383,1,'2010-03-11 19:08:57',3310491132,1),(664116037,425346429,14870318,4099383,1,'2010-03-11 19:08:57',3310491132,1),(664116038,425346877,14876641,4099383,1,'2010-03-11 19:08:57',3310491132,1),(664116039,425347683,14884178,4099383,1,'2010-03-11 19:08:57',3310491132,1),(664116040,425347863,14889893,4099383,1,'2010-03-11 19:08:57',3310491134,1),(664116041,425408644,14497732,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116042,425410075,14493002,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116043,425411873,14486926,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116044,425413378,14481050,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116045,425414882,14473381,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116046,425416130,14468849,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116047,425417010,14465562,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116048,425417487,14463919,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116049,425417927,14462525,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116050,425418331,14461529,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116051,425419212,14460583,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116052,425421413,14458690,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116053,425423284,14457395,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116054,425425853,14455852,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116055,425426880,14455503,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116056,425428164,14455105,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116057,425430255,14453860,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116058,425445506,14474262,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116059,425431980,14453013,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116060,425433778,14452565,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116061,425436603,14451669,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116062,425438694,14450872,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116063,425440529,14450473,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116064,425442473,14450324,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116065,425444014,14450424,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116066,425438727,14495930,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116067,425440039,14489697,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116068,425442008,14483464,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116069,425443757,14478121,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116070,425445812,14451121,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116071,425447096,14451669,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116072,425449114,14452665,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116073,425450692,14453461,4099383,1,'2010-03-11 19:08:58',3310501931,1),(664116074,425451609,14454158,4099383,1,'2010-03-11 19:08:58',3310501931,1),(664116075,425452599,14454706,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116076,425453920,14455154,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116077,425455498,14455154,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116078,425457369,14455154,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116079,425458616,14455055,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116080,425448568,14471294,4099383,1,'2010-03-11 19:08:58',3310501931,1),(664116081,425451848,14468326,4099383,1,'2010-03-11 19:08:58',3310501931,1),(664116082,425455566,14465951,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116083,425459502,14462389,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116084,425461908,14459421,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116085,425459607,14454656,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116086,425460671,14454158,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116087,425461918,14454059,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116088,425462652,14454258,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116089,425463349,14454756,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116090,425463547,14456533,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116091,425657374,14446366,4100909,1,'2010-03-11 22:03:01',3310501993,2),(664116093,425392324,14525241,4099383,1,'2010-03-11 19:08:58',3310491093,1),(664116094,425394232,14524723,4099383,1,'2010-03-11 19:08:58',3310491093,1),(664116095,425396375,14523927,4099383,1,'2010-03-11 19:08:58',3310491093,1),(664116096,425398224,14522931,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116097,425399956,14521815,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116098,425401306,14520899,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116099,425402803,14519664,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116100,425404271,14519066,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116101,425400132,14521437,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116102,425402444,14516805,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116103,425406179,14518508,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116104,425408322,14518628,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116105,425410406,14518748,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116106,425414134,14519265,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116107,425404902,14510780,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116108,425406920,14504206,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116109,425391489,14532737,4099383,1,'2010-03-11 19:08:58',3310491093,1),(664116110,425392364,14534814,4099383,1,'2010-03-11 19:08:58',3310491093,1),(664116111,425393457,14537486,4099383,1,'2010-03-11 19:08:58',3310491093,1),(664116112,425395207,14537486,4099383,1,'2010-03-11 19:08:58',3310491093,1),(664116113,425397831,14537486,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116114,425402861,14536298,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116115,425392414,14529768,4099383,1,'2010-03-11 19:08:59',3310491093,1),(664116116,425394615,14530328,4099383,1,'2010-03-11 19:08:59',3310491093,1),(664116117,425395716,14530328,4099383,1,'2010-03-11 19:08:59',3310491093,1),(664116118,425396358,14530640,4099383,1,'2010-03-11 19:08:59',3310491093,1),(664116119,425398973,14531138,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116120,425401128,14531822,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116121,425402412,14532134,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116122,425404339,14532694,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116123,425405486,14535111,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116124,425408766,14534814,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116125,425405669,14532881,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116126,425407412,14533503,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116127,425409659,14534250,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116128,425413578,14533924,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116129,425416639,14534221,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116130,425418360,14519863,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116131,425422587,14519983,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116132,425426990,14520381,4099383,1,'2010-03-11 19:08:59',3310502017,1),(664116133,425429074,14520222,4099383,1,'2010-03-11 19:08:59',3310502017,1),(664116134,425431716,14520381,4099383,1,'2010-03-11 19:08:59',3310502017,1),(664116135,425438509,14502461,4099383,1,'2010-03-11 19:08:59',3310502017,1),(664116136,425440258,14513146,4099383,1,'2010-03-11 19:08:59',3310502017,1),(664116137,425438946,14510178,4099383,1,'2010-03-11 19:08:59',3310502017,1),(664116138,425438727,14507210,4099383,1,'2010-03-11 19:08:59',3310502017,1),(664116139,425434328,14520660,4099383,1,'2010-03-11 19:08:59',3310502017,1),(664116140,425436500,14520779,4099383,1,'2010-03-11 19:08:59',3310502017,1),(664116141,425445506,14519083,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116142,425443757,14517895,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116143,425441570,14515818,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116144,425438819,14520859,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116145,425440022,14520939,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116146,425441431,14521457,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116147,425442429,14521974,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116148,425443574,14522453,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116149,425444924,14523010,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116150,425422763,14535111,4099383,1,'2010-03-11 19:09:00',3310502016,1),(664116151,425426043,14535111,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116152,425430198,14534814,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116153,425436322,14533033,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116154,425439821,14531549,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116155,425443320,14529768,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116156,425445725,14527987,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116157,425447037,14525019,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116158,425447037,14522941,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116159,425446163,14520864,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116160,425446157,14523010,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116161,425455811,14522224,4100909,1,'2010-03-11 22:03:01',3310502020,2),(664192679,425543688,14488592,4100909,1,'2010-03-11 22:02:58',3310501947,1),(664192680,425656069,14446851,4100909,1,'2010-03-11 22:03:01',3310501993,1),(664192681,425457689,14521505,4100909,1,'2010-03-11 22:03:01',3310502020,1),(664195007,425648101,14489414,4100978,1,'2010-03-11 22:09:38',3310501995,1),(664195008,425639202,14519398,4100978,1,'2010-03-11 22:09:38',3310502080,1),(664198471,425640150,14519681,4101078,1,'2010-03-11 22:19:38',3310502080,1),(664198472,425643874,14519400,4101078,1,'2010-03-11 22:19:38',3310502080,1),(664198473,425654425,14524550,4101078,1,'2010-03-11 22:19:38',3310502081,1),(664198474,425660907,14529700,4101078,1,'2010-03-11 22:19:38',3310502081,1),(664198475,425666286,14531854,4101078,1,'2010-03-11 22:19:38',3310502081,1),(664198476,425670010,14536067,4101078,1,'2010-03-11 22:19:38',3310502081,1),(664198477,425673803,14538689,4101078,1,'2010-03-11 22:19:38',3310502084,1),(664198478,425675734,14541124,4101078,1,'2010-03-11 22:19:38',3310502084,1),(664198479,425677803,14541124,4101078,1,'2010-03-11 22:19:38',3310502084,1),(664198480,425679596,14543558,4101078,1,'2010-03-11 22:19:38',3310502084,1),(664205614,425662626,14457254,4101245,1,'2010-03-11 22:37:03',3310501995,1),(664205619,425663057,14458955,4101245,1,'2010-03-11 22:37:03',3310501995,1),(664205621,425664749,14465627,4101245,1,'2010-03-11 22:37:04',3310501995,1),(664205624,425666771,14473605,4101245,1,'2010-03-11 22:37:04',3310501995,1),(664205627,425669107,14482818,4101245,1,'2010-03-11 22:37:04',3310501995,1),(664205630,425670324,14487619,4101245,1,'2010-03-11 22:37:04',3310501995,1),(664205633,425671576,14492558,4101245,1,'2010-03-11 22:37:04',3310501995,1),(664205635,425673227,14499071,4101245,1,'2010-03-11 22:37:04',3310501998,1),(664205638,425678833,14521188,4101245,1,'2010-03-11 22:37:04',3310502084,1),(664205641,425675883,14509549,4101245,1,'2010-03-11 22:37:04',3310502084,1),(664205644,425678218,14518759,4101245,1,'2010-03-11 22:37:04',3310502084,1),(664211795,425749986,14702011,4101313,1,'2010-03-11 22:45:09',3310502106,1),(664211796,425755003,14706072,4101313,1,'2010-03-11 22:45:09',3310502107,1),(664211797,425755099,14708038,4101313,1,'2010-03-11 22:45:09',3310502107,1),(664211798,425751240,14708038,4101313,1,'2010-03-11 22:45:10',3310502106,1),(664211799,425748828,14713409,4101313,1,'2010-03-11 22:45:10',3310502106,1),(664211800,425749311,14719436,4101313,1,'2010-03-11 22:45:10',3310502106,1),(664211801,425753459,14715112,4101313,1,'2010-03-11 22:45:10',3310502106,1),(664211802,425756450,14715636,4101313,1,'2010-03-11 22:45:10',3310502107,1),(664211803,425756353,14718257,4101313,1,'2010-03-11 22:45:10',3310502107,1),(664211804,425753749,14721794,4101313,1,'2010-03-11 22:45:10',3310502106,1),(664211805,425755196,14728738,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211806,425756836,14725593,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211807,425760309,14725855,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211808,425760791,14743673,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211809,425761370,14746031,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211810,425752832,14727558,4101313,1,'2010-03-11 22:45:10',3310502128,1),(664211811,425763010,14726772,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211812,425763107,14728476,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211813,425762335,14732406,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211814,425762721,14735419,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211815,425763589,14746162,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211816,425766387,14742625,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211817,425768606,14739088,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211818,425771789,14737646,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211819,425774201,14735288,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211820,425772368,14742494,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211821,425770728,14747472,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211822,425770728,14750224,4101313,1,'2010-03-11 22:45:11',3310502129,1),(664211823,425772947,14750093,4101313,1,'2010-03-11 22:45:11',3310502129,1),(664211824,425774008,14774723,4101313,1,'2010-03-11 22:45:11',3310502129,1),(664211825,425772465,14782846,4101313,1,'2010-03-11 22:45:11',3310502131,1),(664211826,425771596,14786121,4101313,1,'2010-03-11 22:45:11',3310502131,1),(664211827,425769469,14788897,4101313,1,'2010-03-11 22:45:11',3310502131,1),(664211828,425772217,14778554,4101313,1,'2010-03-11 22:45:11',3310502131,1),(664211829,425769381,14795777,4101313,1,'2010-03-11 22:45:11',3310502131,1),(664211830,425770645,14797452,4101313,1,'2010-03-11 22:45:11',3310502131,1),(664211831,425768481,14792062,4101313,1,'2010-03-11 22:45:11',3310502131,1),(664211832,425775745,14735550,4101313,1,'2010-03-11 22:45:11',3310502129,1),(664211833,425775648,14737384,4101313,1,'2010-03-11 22:45:11',3310502129,1),(664211834,425775166,14747341,4101313,1,'2010-03-11 22:45:11',3310502129,1),(664211835,425777288,14746031,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664211836,425779893,14743935,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664211837,425780858,14745114,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664211838,425779411,14748651,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664211839,425777964,14752582,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664211840,425775745,14757298,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664211841,425776131,14759394,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664211842,425778639,14757167,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664211843,425780761,14754285,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664211844,425783559,14751796,4101313,1,'2010-03-11 22:45:12',3310502132,1),(664211845,425784427,14752975,4101313,1,'2010-03-11 22:45:12',3310502132,1),(664211846,425781919,14760180,4101313,1,'2010-03-11 22:45:12',3310502132,1),(664211847,425780279,14761884,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664211848,425778542,14768827,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664211849,425775938,14773151,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664225476,425736171,14718541,4101446,1,'2010-03-11 22:58:45',3310502106,1),(664225514,425734239,14713759,4101446,1,'2010-03-11 22:58:46',3310502106,1),(664225516,425745932,14742710,4101446,1,'2010-03-11 22:58:46',3310502128,1),(664225519,425740295,14728752,4101446,1,'2010-03-11 22:58:46',3310502128,1),(664225521,425756921,14769918,4101446,1,'2010-03-11 22:58:46',3310502129,1),(664225523,425752472,14758902,4101446,1,'2010-03-11 22:58:46',3310502128,1),(664225525,425749404,14751305,4101446,1,'2010-03-11 22:58:46',3310502128,1),(664225527,425764772,14789356,4101446,1,'2010-03-11 22:58:46',3310502131,1),(664225529,425761732,14781829,4101446,1,'2010-03-11 22:58:46',3310502131,1),(664225531,425767964,14797258,4101446,1,'2010-03-11 22:58:46',3310502131,1),(664236924,425728306,14660994,4101592,1,'2010-03-11 23:12:19',3310502104,1),(664236925,425732739,14671625,4101592,1,'2010-03-11 23:12:19',3310502106,1),(664236926,425740416,14690035,4101592,1,'2010-03-11 23:12:19',3310502106,1),(664236927,425737512,14683069,4101592,1,'2010-03-11 23:12:19',3310502106,1),(664236928,425743704,14697918,4101592,1,'2010-03-11 23:12:19',3310502106,1),(664559648,425389200,16613475,4106774,1,'2010-03-12 16:30:45',3310493181,1),(664559649,425389697,16615364,4106774,1,'2010-03-12 16:30:45',3310493181,1),(664559650,425383037,16753500,4106774,1,'2010-03-12 16:30:45',3310493525,1),(664559651,425500356,16146954,4106774,1,'2010-03-12 16:30:45',3310503975,1),(664559652,425497971,16145875,4106774,1,'2010-03-12 16:30:46',3310503975,1),(664559653,425496858,16144795,4106774,1,'2010-03-12 16:30:46',3310503975,1),(664559654,425496381,16143285,4106774,1,'2010-03-12 16:30:46',3310503975,1),(664559655,425496858,16141234,4106774,1,'2010-03-12 16:30:46',3310503975,1),(664559656,425498448,16139507,4106774,1,'2010-03-12 16:30:46',3310503975,1),(664559657,425458855,16172962,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559658,425459014,16169833,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559659,425458616,16167782,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559660,425457980,16164437,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559661,425458775,16161955,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559662,425459968,16159472,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559663,425461399,16158285,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559664,425462512,16158285,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559665,425465613,16160228,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559666,425469191,16162386,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559667,425471496,16163789,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559668,425465056,16204043,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559669,425463307,16199402,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559670,425462274,16194330,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559671,425461001,16188718,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559672,425459491,16179545,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559673,425473802,16164437,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559674,425475472,16164868,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559675,425477539,16167135,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559676,425478493,16169401,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559677,425480560,16171451,4106774,1,'2010-03-12 16:30:47',3310503981,1),(664559678,425482229,16171991,4106774,1,'2010-03-12 16:30:47',3310503981,1),(664559679,425484138,16171559,4106774,1,'2010-03-12 16:30:47',3310503981,1),(664559680,425486761,16169725,4106774,1,'2010-03-12 16:30:47',3310503981,1),(664559681,425488828,16167782,4106774,1,'2010-03-12 16:30:47',3310503981,1),(664559682,425490418,16165408,4106774,1,'2010-03-12 16:30:47',3310503981,1),(664559683,425493678,16158609,4106774,1,'2010-03-12 16:30:47',3310503981,1),(664559684,425495109,16155911,4106774,1,'2010-03-12 16:30:47',3310503981,1),(664559685,425497574,16153645,4106774,1,'2010-03-12 16:30:47',3310503981,1),(664559686,425499800,16151163,4106774,1,'2010-03-12 16:30:47',3310503981,1),(664559687,425492114,16161756,4106774,1,'2010-03-12 16:30:47',3310503981,1),(664559688,425471417,16210950,4106774,1,'2010-03-12 16:30:47',3310503982,1),(664559689,425467680,16207928,4106774,1,'2010-03-12 16:30:47',3310503982,1),(664559690,425497574,16238577,4106774,1,'2010-03-12 16:30:47',3310503983,1),(664559691,425493758,16233181,4106774,1,'2010-03-12 16:30:47',3310503983,1),(664559692,425491134,16229727,4106774,1,'2010-03-12 16:30:47',3310503983,1),(664559693,425487795,16226274,4106774,1,'2010-03-12 16:30:47',3310503983,1),(664559694,425484615,16223468,4106774,1,'2010-03-12 16:30:47',3310503983,1),(664559695,425481673,16220338,4106774,1,'2010-03-12 16:30:47',3310503983,1),(664559696,425478334,16217101,4106774,1,'2010-03-12 16:30:47',3310503982,1),(664559697,425474756,16214187,4106774,1,'2010-03-12 16:30:47',3310503982,1),(664559698,425501151,16149544,4106774,1,'2010-03-12 16:30:47',3310503975,1),(664559699,425501231,16148357,4106774,1,'2010-03-12 16:30:47',3310503975,1),(664559700,425500992,16147601,4106774,1,'2010-03-12 16:30:47',3310503975,1),(664559701,425500515,16137889,4106774,1,'2010-03-12 16:30:47',3310503975,1),(664559702,425504570,16135622,4106774,1,'2010-03-12 16:30:47',3310503975,1),(664559703,425507909,16134651,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559704,425511407,16134651,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559705,425513394,16134867,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559706,425514189,16135083,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559707,425515859,16135083,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559708,425517528,16134543,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559709,425519675,16134543,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559710,425521503,16134651,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559711,425523968,16135514,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559712,425525319,16136594,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559713,425526591,16136162,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559714,425528658,16134867,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559715,425530566,16133140,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559716,425532156,16131090,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559717,425533349,16129363,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559718,425533985,16128824,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559719,425532539,16135988,4106774,1,'2010-03-12 16:30:48',3310503986,1),(664559720,425532234,16133778,4106774,1,'2010-03-12 16:30:48',3310503986,1),(664559721,425533150,16132604,4106774,1,'2010-03-12 16:30:48',3310503986,1),(664559722,425533913,16131913,4106774,1,'2010-03-12 16:30:48',3310503986,1),(664559723,425535970,16132907,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559724,425535549,16132750,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559725,425534939,16128284,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559726,425535734,16128716,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559727,425536290,16129147,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559728,425536449,16130226,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559729,425537678,16132189,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559730,425535693,16131499,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559731,425532941,16149106,4106774,1,'2010-03-12 16:30:48',3310503986,1),(664559732,425532941,16144890,4106774,1,'2010-03-12 16:30:48',3310503986,1),(664559733,425533313,16141349,4106774,1,'2010-03-12 16:30:48',3310503986,1),(664559734,425534059,16137471,4106774,1,'2010-03-12 16:30:48',3310503986,1),(664559735,425533506,16138060,4106774,1,'2010-03-12 16:30:48',3310503986,1),(664559736,425539611,16148351,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559737,425538187,16145934,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559738,425536813,16143309,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559739,425534879,16140546,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559740,425535425,16174062,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559741,425535798,16167486,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559742,425536170,16162933,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559743,425536170,16158212,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559744,425535177,16155682,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559745,425533935,16151973,4106774,1,'2010-03-12 16:30:48',3310503992,1),(664559746,425541392,16150976,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559747,425555078,16159126,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559748,425555231,16160921,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559749,425553908,16161474,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559750,425552432,16161474,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559751,425550295,16161198,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559752,425549125,16160300,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559753,425547904,16159402,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559754,425546581,16157537,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559755,425545004,16155672,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559756,425543122,16153117,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559757,425534431,16199018,4106774,1,'2010-03-12 16:30:48',3310503992,1),(664559758,425532941,16196489,4106774,1,'2010-03-12 16:30:48',3310503992,1),(664559759,425533562,16189744,4106774,1,'2010-03-12 16:30:48',3310503992,1),(664559760,425535052,16186034,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559761,425535798,16182999,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559762,425535798,16178952,4106774,1,'2010-03-12 16:30:49',3310503993,1),(664559763,425537583,16203783,4106774,1,'2010-03-12 16:30:49',3310503993,1),(664559764,425532526,16192560,4106774,1,'2010-03-12 16:30:49',3310503992,1),(664559765,425532471,16195866,4106774,1,'2010-03-12 16:30:49',3310503992,1),(664559766,425523003,16255676,4106774,1,'2010-03-12 16:30:49',3310503994,1),(664559767,425524618,16246739,4106774,1,'2010-03-12 16:30:49',3310503994,1),(664559768,425526357,16241511,4106774,1,'2010-03-12 16:30:49',3310503994,1),(664559769,425508227,16257247,4106774,1,'2010-03-12 16:30:49',3310503994,1),(664559770,425504649,16250987,4106774,1,'2010-03-12 16:30:49',3310503983,1),(664559771,425500595,16243325,4106774,1,'2010-03-12 16:30:49',3310503983,1),(664559772,425529835,16236453,4106774,1,'2010-03-12 16:30:49',3310503994,1),(664559773,425534183,16231057,4106774,1,'2010-03-12 16:30:49',3310503994,1),(664559774,425536791,16225661,4106774,1,'2010-03-12 16:30:49',3310503995,1),(664559775,425538406,16219759,4106774,1,'2010-03-12 16:30:49',3310503995,1),(664559776,425538779,16212339,4106774,1,'2010-03-12 16:30:49',3310503995,1),(664559777,425537909,16206269,4106774,1,'2010-03-12 16:30:49',3310503995,1),(664559778,425492253,16463604,4106774,1,'2010-03-12 16:30:49',3310504079,1),(664559779,425490381,16464377,4106774,1,'2010-03-12 16:30:49',3310504079,1),(664559780,425492742,16459073,4106774,1,'2010-03-12 16:30:49',3310504079,1),(664559781,425496242,16454100,4106774,1,'2010-03-12 16:30:49',3310504079,1),(664559782,425494873,16464595,4106774,1,'2010-03-12 16:30:49',3310504079,1),(664559783,425496256,16461906,4108069,1,'2010-03-12 19:04:13',3310504079,2),(664559784,425499246,16456366,4106774,1,'2010-03-12 16:30:49',3310504079,1),(664559785,425491494,16467833,4106774,1,'2010-03-12 16:30:49',3310504079,1),(664559786,425491296,16469586,4106774,1,'2010-03-12 16:30:49',3310504079,1),(664559787,425489541,16476284,4106774,1,'2010-03-12 16:30:49',3310504079,1),(664559788,425495171,16467428,4106774,1,'2010-03-12 16:30:49',3310504079,1),(664559789,425497656,16466619,4106774,1,'2010-03-12 16:30:50',3310504079,1),(664559790,425498948,16467563,4106774,1,'2010-03-12 16:30:50',3310504079,1),(664559791,425514110,16268794,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559792,425512202,16265448,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559793,425510850,16262211,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559794,425526567,16280712,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559795,425528709,16286162,4133447,1,'2010-03-15 12:47:10',3310504080,2),(664559796,425526088,16284818,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559797,425520892,16276247,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559798,425521513,16266805,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559799,425526114,16283255,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559800,425523968,16280665,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559801,425521583,16277751,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559802,425519277,16275701,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559803,425516336,16273111,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559804,425527870,16312513,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559805,425527870,16309543,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559806,425527838,16307704,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559807,425527827,16305488,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559808,425527699,16302562,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559809,425527550,16298868,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559810,425527369,16294972,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559811,425526899,16290713,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559812,425527666,16330386,4106774,1,'2010-03-12 16:30:50',3310504082,1),(664559813,425527585,16321655,4106774,1,'2010-03-12 16:30:50',3310504082,1),(664559814,425527788,16315301,4106774,1,'2010-03-12 16:30:50',3310504082,1),(664559815,425528602,16366632,4106774,1,'2010-03-12 16:30:50',3310504082,1),(664559816,425528236,16351327,4106774,1,'2010-03-12 16:30:50',3310504082,1),(664559817,425519607,16420837,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559818,425521723,16416859,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559819,425523026,16414759,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559820,425525428,16411665,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559821,425527178,16409123,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559822,425525580,16422507,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559823,425527866,16419674,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559824,425528440,16379783,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559825,425528562,16376081,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559826,425529823,16378291,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559827,425529864,16394978,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559828,425529661,16392989,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559829,425530068,16391828,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559830,425531085,16390723,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559831,425532103,16390337,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559832,425533243,16390226,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559833,425530678,16390723,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559834,425529661,16387077,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559835,425529132,16383430,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559836,425534425,16392425,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559837,425533630,16391885,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559838,425533033,16390806,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559839,425533033,16388782,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559840,425533630,16387029,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559841,425537306,16395662,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559842,425535716,16393774,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559843,425535120,16386624,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559844,425537704,16385949,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559845,425539791,16385815,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559846,425540784,16384600,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559847,425534822,16389727,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559848,425539592,16389592,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559849,425541977,16381633,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559850,425543964,16378395,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559851,425545753,16377451,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559852,425547244,16377451,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559853,425548237,16378125,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559854,425548933,16379205,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559855,425548933,16380554,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559856,425548833,16382307,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559857,425543368,16389187,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559858,425545852,16389592,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559859,425548833,16384061,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559860,425549132,16386489,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559861,425550125,16388108,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559862,425552113,16390671,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559863,425549728,16390401,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559864,425554994,16390671,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559865,425548933,16393369,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559866,425537394,16398569,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559867,425528317,16407134,4106774,1,'2010-03-12 16:30:52',3310504088,1),(664559868,425528969,16404979,4106774,1,'2010-03-12 16:30:52',3310504088,1),(664559869,425529661,16401608,4106774,1,'2010-03-12 16:30:52',3310504088,1),(664559870,425529742,16397962,4106774,1,'2010-03-12 16:30:52',3310504088,1),(664559871,425530052,16416436,4106774,1,'2010-03-12 16:30:52',3310504088,1),(664559872,425532139,16412390,4106774,1,'2010-03-12 16:30:52',3310504088,1),(664559873,425534822,16407128,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559874,425536810,16402947,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559875,425537704,16402002,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559876,425538400,16400114,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559877,425538400,16399035,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559878,425538002,16397146,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559879,425537803,16408612,4106774,1,'2010-03-12 16:30:52',3310504089,1);
INSERT INTO `current_nodes` VALUES (664559880,425501453,16446364,4106774,1,'2010-03-12 16:30:52',3310504079,1),(664559881,425504180,16442055,4106774,1,'2010-03-12 16:30:52',3310504079,1),(664559882,425506948,16438739,4106774,1,'2010-03-12 16:30:52',3310504079,1),(664559883,425509268,16436529,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559884,425510896,16433601,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559885,425512809,16430562,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559886,425504513,16449352,4106774,1,'2010-03-12 16:30:52',3310504079,1),(664559887,425511370,16440583,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559888,425515414,16427136,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559889,425518724,16430736,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559890,425522897,16425475,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559891,425500836,16470800,4106774,1,'2010-03-12 16:30:52',3310504079,1),(664559892,425503420,16474173,4106774,1,'2010-03-12 16:30:52',3310504079,1),(664559893,425506004,16477276,4106774,1,'2010-03-12 16:30:52',3310504079,1),(664559894,425507594,16478759,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559895,425509184,16478759,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559896,425515941,16477006,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559897,425521506,16474847,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559898,425525282,16474038,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559899,425530549,16473768,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559900,425538201,16473363,4106774,1,'2010-03-12 16:30:52',3310504091,1),(664559901,425544759,16472149,4106774,1,'2010-03-12 16:30:52',3310504091,1),(664559902,425549330,16470396,4106774,1,'2010-03-12 16:30:52',3310504091,1),(664559903,425553206,16468102,4106774,1,'2010-03-12 16:30:52',3310504091,1),(664559904,425555988,16392290,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559905,425559367,16394853,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559906,425563143,16396472,4106774,1,'2010-03-12 16:30:52',3310504092,1),(664559911,425560758,16389727,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559913,425566620,16387433,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559915,425572384,16385140,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559917,425579737,16382982,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559919,425566521,16398900,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559921,425565825,16401058,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559923,425570694,16400788,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559925,425573179,16402542,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559927,425575166,16405105,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559929,425577253,16407398,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559931,425574868,16407938,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559933,425582519,16408208,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559935,425587487,16382982,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559937,425594542,16384196,4106774,1,'2010-03-12 16:30:53',3310504093,1),(664559939,425600305,16385005,4106774,1,'2010-03-12 16:30:53',3310504093,1),(664559941,425607757,16387433,4106774,1,'2010-03-12 16:30:53',3310504093,1),(664559943,425589077,16414683,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559945,425597722,16422912,4106774,1,'2010-03-12 16:30:53',3310504093,1),(664559947,425557578,16464325,4106774,1,'2010-03-12 16:30:53',3310504091,1),(664559949,425563043,16459199,4106774,1,'2010-03-12 16:30:53',3310504094,1),(664559951,425569005,16453129,4106774,1,'2010-03-12 16:30:53',3310504094,1),(664559953,425573278,16447058,4106774,1,'2010-03-12 16:30:53',3310504094,1),(664559955,425578147,16441662,4106774,1,'2010-03-12 16:30:54',3310504094,1),(664559957,425581227,16439099,4106774,1,'2010-03-12 16:30:54',3310504094,1),(664559959,425602590,16428173,4106774,1,'2010-03-12 16:30:54',3310504095,1),(664559961,425599411,16443551,4106774,1,'2010-03-12 16:30:54',3310504095,1),(664559963,425586494,16436536,4106774,1,'2010-03-12 16:30:54',3310504094,1),(664559965,425590965,16435052,4106774,1,'2010-03-12 16:30:54',3310504095,1),(664559966,425593350,16435052,4106774,1,'2010-03-12 16:30:54',3310504095,1),(664559968,425595635,16433703,4106774,1,'2010-03-12 16:30:54',3310504095,1),(664559969,425601100,16429791,4106774,1,'2010-03-12 16:30:54',3310504095,1),(664559970,425602888,16428847,4106774,1,'2010-03-12 16:30:54',3310504095,1),(664559971,425436734,16560373,4106774,1,'2010-03-12 16:30:54',3310504099,1),(664559972,425443989,16578854,4106774,1,'2010-03-12 16:30:54',3310504099,1),(664559973,425442697,16575616,4106774,1,'2010-03-12 16:30:54',3310504099,1),(664559974,425441107,16572514,4106774,1,'2010-03-12 16:30:54',3310504099,1),(664559975,425438821,16567387,4106774,1,'2010-03-12 16:30:54',3310504099,1),(664559976,425437827,16563610,4106774,1,'2010-03-12 16:30:54',3310504099,1),(664559977,425437430,16559429,4106774,1,'2010-03-12 16:30:54',3310504099,1),(664559978,425485725,16506933,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559979,425489541,16482219,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559980,425489541,16486860,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559981,425489780,16491500,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559982,425490336,16495277,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559983,425490257,16496788,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559984,425489780,16498623,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559985,425488667,16501105,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559986,425487156,16503911,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559987,425484691,16510926,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559988,425484771,16514703,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559989,425485248,16517401,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559990,425486679,16521070,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559991,425489144,16526358,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559992,425491290,16531430,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559993,425500115,16514379,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559994,425498127,16514919,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559995,425497014,16515782,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559996,425495981,16517293,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559997,425495822,16519235,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559998,425495981,16521286,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559999,425497094,16523984,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664560000,425499559,16528948,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664560001,425445679,16585734,4106774,1,'2010-03-12 16:30:54',3310504099,1),(664560002,425500041,16589241,4106774,1,'2010-03-12 16:30:54',3310504103,1),(664560003,425493119,16535747,4106774,1,'2010-03-12 16:30:54',3310504103,1),(664560004,425495106,16542546,4106774,1,'2010-03-12 16:30:54',3310504103,1),(664560005,425497650,16548158,4106774,1,'2010-03-12 16:30:54',3310504103,1),(664560006,425492960,16534884,4106774,1,'2010-03-12 16:30:54',3310504103,1),(664560007,425497253,16543625,4106774,1,'2010-03-12 16:30:55',3310504103,1),(664560008,425429081,16605024,4106774,1,'2010-03-12 16:30:55',3310504105,1),(664560009,425423490,16606056,4106774,1,'2010-03-12 16:30:55',3310504104,1),(664560010,425417353,16675846,4106774,1,'2010-03-12 16:30:55',3310504106,1),(664560011,425416061,16681646,4106774,1,'2010-03-12 16:30:55',3310504106,1),(664560012,425415266,16692573,4106774,1,'2010-03-12 16:30:55',3310504106,1),(664560013,425428584,16656555,4106774,1,'2010-03-12 16:30:55',3310504107,1),(664560014,425425702,16659253,4106774,1,'2010-03-12 16:30:55',3310504107,1),(664560015,425424310,16662760,4106774,1,'2010-03-12 16:30:55',3310504106,1),(664560016,425422820,16666538,4106774,1,'2010-03-12 16:30:55',3310504106,1),(664560017,425420434,16669910,4106774,1,'2010-03-12 16:30:55',3310504106,1),(664560018,425442101,16645898,4106774,1,'2010-03-12 16:30:55',3310504107,1),(664560019,425435641,16650620,4106774,1,'2010-03-12 16:30:55',3310504107,1),(664560020,425445083,16647922,4106774,1,'2010-03-12 16:30:55',3310504107,1),(664560021,425444983,16656285,4106774,1,'2010-03-12 16:30:55',3310504107,1),(664560022,425442399,16663030,4106774,1,'2010-03-12 16:30:55',3310504107,1),(664560023,425441405,16667752,4106774,1,'2010-03-12 16:30:55',3310504107,1),(664560024,425434547,16680297,4106774,1,'2010-03-12 16:30:55',3310504107,1),(664560025,425442101,16673687,4106774,1,'2010-03-12 16:30:55',3310504107,1),(664560026,425454127,16605159,4106774,1,'2010-03-12 16:30:55',3310504108,1),(664560027,425447269,16603945,4106774,1,'2010-03-12 16:30:55',3310504105,1),(664560028,425448760,16604350,4106774,1,'2010-03-12 16:30:55',3310504105,1),(664560029,425450251,16604350,4106774,1,'2010-03-12 16:30:55',3310504105,1),(664560030,425451046,16602461,4106774,1,'2010-03-12 16:30:55',3310504105,1),(664560031,425451145,16600707,4106774,1,'2010-03-12 16:30:55',3310504105,1),(664560032,425450052,16599223,4106774,1,'2010-03-12 16:30:55',3310504105,1),(664560033,425448660,16596256,4106774,1,'2010-03-12 16:30:55',3310504105,1),(664560034,425447170,16591264,4106774,1,'2010-03-12 16:30:55',3310504105,1),(664560035,425466152,16597065,4106774,1,'2010-03-12 16:30:55',3310504108,1),(664560036,425466053,16600977,4106774,1,'2010-03-12 16:30:55',3310504108,1),(664560037,425467245,16604484,4106774,1,'2010-03-12 16:30:55',3310504108,1),(664560038,425471121,16611364,4106774,1,'2010-03-12 16:30:55',3310504108,1),(664560039,425445679,16636051,4106774,1,'2010-03-12 16:30:55',3310504105,1),(664560040,425474500,16617974,4106774,1,'2010-03-12 16:30:55',3310504108,1),(664560041,425477581,16626878,4106774,1,'2010-03-12 16:30:55',3310504108,1),(664560043,425481954,16638074,4106774,1,'2010-03-12 16:30:55',3310504109,1),(664560044,425488215,16638479,4106774,1,'2010-03-12 16:30:55',3310504109,1),(664560045,425490202,16628496,4106774,1,'2010-03-12 16:30:55',3310504109,1),(664560046,425491991,16618649,4106774,1,'2010-03-12 16:30:55',3310504109,1),(664560047,425491991,16613388,4106774,1,'2010-03-12 16:30:55',3310504109,1),(664560048,425491892,16607048,4106774,1,'2010-03-12 16:30:56',3310504109,1),(664560049,425491395,16602461,4106774,1,'2010-03-12 16:30:56',3310504109,1),(664560050,425492091,16599898,4106774,1,'2010-03-12 16:30:56',3310504109,1),(664560051,425493681,16597874,4106774,1,'2010-03-12 16:30:56',3310504109,1),(664560052,425496265,16596525,4106774,1,'2010-03-12 16:30:56',3310504109,1),(664560053,425497855,16593018,4106774,1,'2010-03-12 16:30:56',3310504109,1),(664560054,425445579,16652373,4106774,1,'2010-03-12 16:30:56',3310504107,1),(664560055,425447070,16688931,4106774,1,'2010-03-12 16:30:56',3310504107,1),(664560056,425484438,16646573,4106774,1,'2010-03-12 16:30:56',3310504111,1),(664560057,425485730,16649945,4106774,1,'2010-03-12 16:30:56',3310504111,1),(664560058,425486625,16650080,4106774,1,'2010-03-12 16:30:56',3310504111,1),(664560059,425486202,16650168,4106774,1,'2010-03-12 16:30:56',3310504111,1),(664560060,425487519,16649406,4106774,1,'2010-03-12 16:30:56',3310504111,1),(664560061,425487320,16647112,4106774,1,'2010-03-12 16:30:56',3310504111,1),(664560062,425487693,16654484,4106774,1,'2010-03-12 16:30:56',3310504111,1),(664560063,425488686,16659206,4106774,1,'2010-03-12 16:30:56',3310504111,1),(664560064,425490475,16665681,4106774,1,'2010-03-12 16:30:56',3310504111,1),(664560065,425493655,16671616,4106774,1,'2010-03-12 16:30:56',3310504111,1),(664560066,425488488,16659745,4106774,1,'2010-03-12 16:30:56',3310504111,1),(664560067,425488190,16662173,4106774,1,'2010-03-12 16:30:57',3310504111,1),(664560068,425487891,16668649,4106774,1,'2010-03-12 16:30:57',3310504111,1),(664560069,425499718,16680250,4106774,1,'2010-03-12 16:30:57',3310504111,1),(664560070,425487792,16673235,4106774,1,'2010-03-12 16:30:57',3310504111,1),(664560071,425488190,16676608,4106774,1,'2010-03-12 16:30:57',3310504111,1),(664560072,425489084,16679440,4106774,1,'2010-03-12 16:30:57',3310504111,1),(664560073,425490972,16682408,4106774,1,'2010-03-12 16:30:57',3310504111,1),(664560074,425492761,16685646,4106774,1,'2010-03-12 16:30:57',3310504111,1),(664560075,425494450,16689153,4106774,1,'2010-03-12 16:30:57',3310504111,1),(664560076,425495444,16694279,4106774,1,'2010-03-12 16:30:57',3310504111,1),(664560077,425503320,16482267,4106774,1,'2010-03-12 16:30:57',3310504101,1),(664560078,425509879,16488337,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560079,425517034,16492519,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560080,425523692,16494947,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560081,425512676,16519775,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560082,425510053,16518156,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560083,425507747,16516537,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560085,425505203,16515134,4106774,1,'2010-03-12 16:30:57',3310504101,1),(664560086,425502818,16514595,4106774,1,'2010-03-12 16:30:57',3310504101,1),(664560087,425502898,16533373,4106774,1,'2010-03-12 16:30:57',3310504101,1),(664560089,425516651,16519127,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560091,425516969,16520962,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560093,425516890,16522149,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560095,425516651,16522473,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560097,425515856,16522689,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560099,425514982,16521718,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560101,425530350,16495757,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560103,425529754,16495487,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560105,425529853,16500478,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560107,425541579,16504255,4106774,1,'2010-03-12 16:30:57',3310504113,1),(664560109,425538896,16503716,4106774,1,'2010-03-12 16:30:57',3310504113,1),(664560112,425537803,16503716,4106774,1,'2010-03-12 16:30:57',3310504113,1),(664560114,425537803,16504795,4106774,1,'2010-03-12 16:30:57',3310504113,1),(664560116,425545057,16497106,4106774,1,'2010-03-12 16:30:57',3310504113,1),(664560118,425549927,16497645,4106774,1,'2010-03-12 16:30:57',3310504113,1),(664560121,425549927,16501692,4106774,1,'2010-03-12 16:30:57',3310504113,1),(664560123,425548933,16505469,4106774,1,'2010-03-12 16:30:57',3310504113,1),(664560125,425546846,16505469,4106774,1,'2010-03-12 16:30:58',3310504113,1),(664560127,425544163,16505199,4106774,1,'2010-03-12 16:30:58',3310504113,1),(664560129,425531642,16510056,4106774,1,'2010-03-12 16:30:58',3310504112,1),(664560132,425534127,16517205,4106774,1,'2010-03-12 16:30:58',3310504112,1),(664560134,425537008,16524355,4106774,1,'2010-03-12 16:30:58',3310504113,1),(664560135,425541281,16531774,4106774,1,'2010-03-12 16:30:58',3310504113,1),(664560137,425539095,16508032,4106774,1,'2010-03-12 16:30:58',3310504113,1),(664560140,425545057,16516261,4106774,1,'2010-03-12 16:30:58',3310504113,1),(664560142,425553802,16525164,4106774,1,'2010-03-12 16:30:58',3310504113,1),(664560143,425502818,16557331,4106774,1,'2010-03-12 16:30:58',3310504103,1),(664560145,425500672,16549021,4106774,1,'2010-03-12 16:30:58',3310504103,1),(664560147,425503375,16553014,4106774,1,'2010-03-12 16:30:58',3310504103,1),(664560149,425507191,16557762,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560150,425510848,16561432,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560151,425507032,16537905,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560152,425510291,16541035,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560153,425512199,16542546,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560154,425517049,16544812,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560155,425521262,16546755,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560156,425525476,16548158,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560157,425503221,16587487,4106774,1,'2010-03-12 16:30:58',3310504103,1),(664560158,425506302,16587218,4106774,1,'2010-03-12 16:30:58',3310504103,1),(664560159,425510774,16588836,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560160,425509178,16568015,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560161,425513948,16564453,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560162,425517526,16580749,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560163,425521978,16587979,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560164,425516413,16568662,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560165,425519513,16573842,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560166,425521739,16578483,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560167,425524045,16584526,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560168,425528497,16549884,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560169,425530166,16552043,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560170,425531915,16556575,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560171,425534062,16563050,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560172,425534618,16568446,4106774,1,'2010-03-12 16:30:58',3310504115,1),(664560173,425536367,16573734,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560174,425537957,16578267,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560175,425538434,16580749,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560177,425538752,16584526,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560178,425538752,16587332,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560179,425555049,16564453,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560180,425552584,16566504,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560182,425550040,16569418,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560183,425547974,16574166,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560185,425546304,16577943,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560186,425546145,16583447,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560187,425555889,16493598,4106774,1,'2010-03-12 16:30:59',3310504113,1),(664560188,425558671,16530021,4106774,1,'2010-03-12 16:30:59',3310504113,1),(664560189,425560360,16531639,4106774,1,'2010-03-12 16:30:59',3310504113,1),(664560190,425561255,16533528,4106774,1,'2010-03-12 16:30:59',3310504113,1),(664560191,425561155,16537305,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560192,425561255,16540273,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560193,425564191,16545460,4106774,1,'2010-03-12 16:30:59',3310504118,1),(664560194,425563316,16551611,4106774,1,'2010-03-12 16:30:59',3310504118,1),(664560195,425562362,16558194,4106774,1,'2010-03-12 16:30:59',3310504118,1),(664560196,425561170,16560352,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560197,425557819,16538501,4108069,1,'2010-03-12 19:04:14',3310504115,2),(664560198,425557751,16563266,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560199,425564508,16583447,4106774,1,'2010-03-12 16:30:59',3310504118,1),(664560200,425572082,16575010,4107810,1,'2010-03-12 18:34:26',3310504118,2),(664560202,425513854,16591534,4106774,1,'2010-03-12 16:30:59',3310504120,1),(664560203,425517332,16594637,4106774,1,'2010-03-12 16:30:59',3310504120,1),(664560204,425520810,16596256,4106774,1,'2010-03-12 16:30:59',3310504120,1),(664560205,425523792,16599223,4106774,1,'2010-03-12 16:30:59',3310504120,1),(664560206,425524760,16592728,4106774,1,'2010-03-12 16:30:59',3310504120,1),(664560207,425526907,16597260,4106774,1,'2010-03-12 16:30:59',3310504120,1),(664560208,425526430,16591972,4106774,1,'2010-03-12 16:30:59',3310504120,1),(664560209,425528894,16600606,4106774,1,'2010-03-12 16:30:59',3310504120,1),(664560210,425533744,16600282,4106774,1,'2010-03-12 16:31:00',3310504120,1),(664560211,425538434,16590246,4106774,1,'2010-03-12 16:31:00',3310504121,1),(664560212,425537162,16593267,4106774,1,'2010-03-12 16:31:00',3310504121,1),(664560213,425535095,16596181,4106774,1,'2010-03-12 16:31:00',3310504121,1),(664560214,425527965,16604754,4106774,1,'2010-03-12 16:31:00',3310504120,1),(664560215,425530450,16613792,4106774,1,'2010-03-12 16:31:00',3310504120,1),(664560216,425528894,16603628,4106774,1,'2010-03-12 16:31:00',3310504120,1),(664560217,425532392,16613664,4106774,1,'2010-03-12 16:31:00',3310504120,1),(664560218,425531597,16608592,4106774,1,'2010-03-12 16:31:00',3310504120,1),(664560219,425533346,16613125,4106774,1,'2010-03-12 16:31:00',3310504120,1),(664560220,425532869,16603304,4106774,1,'2010-03-12 16:31:00',3310504120,1),(664560221,425532233,16605678,4106774,1,'2010-03-12 16:31:00',3310504120,1),(664560222,425532392,16608484,4106774,1,'2010-03-12 16:31:00',3310504120,1),(664560223,425533108,16611722,4106774,1,'2010-03-12 16:31:00',3310504120,1),(664560224,425540978,16611398,4106774,1,'2010-03-12 16:31:00',3310504121,1),(664560225,425538752,16616470,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560226,425545748,16590246,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560227,425545430,16595102,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560228,425544714,16601361,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560229,425543045,16605894,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560230,425554254,16601685,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560231,425534524,16626338,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560232,425534062,16618952,4106774,1,'2010-03-12 16:31:01',3310504120,1),(664560233,425534062,16630176,4106774,1,'2010-03-12 16:31:01',3310504120,1),(664560234,425534300,16617010,4106774,1,'2010-03-12 16:31:01',3310504120,1),(664560235,425535413,16623269,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560236,425535969,16625319,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560237,425535731,16626830,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560238,425535095,16628125,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560239,425536446,16622837,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560240,425536844,16623701,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560241,425535345,16625581,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560242,425533664,16633089,4106774,1,'2010-03-12 16:31:01',3310504120,1),(664560243,425534698,16636219,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560244,425537162,16642694,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560245,425508463,16691042,4106774,1,'2010-03-12 16:31:01',3310504122,1),(664560246,425540898,16651328,4106774,1,'2010-03-12 16:31:01',3310504123,1),(664560247,425543919,16658450,4106774,1,'2010-03-12 16:31:01',3310504123,1),(664560248,425545748,16664710,4106774,1,'2010-03-12 16:31:01',3310504123,1),(664560249,425547179,16673451,4106774,1,'2010-03-12 16:31:01',3310504123,1),(664560250,425548133,16679818,4106774,1,'2010-03-12 16:31:01',3310504123,1),(664560251,425550040,16686941,4106774,1,'2010-03-12 16:31:01',3310504123,1),(664560252,425552823,16695358,4106774,1,'2010-03-12 16:31:01',3310504123,1),(664560253,425614116,16390401,4106774,1,'2010-03-12 16:31:01',3310504093,1),(664560254,425618786,16394448,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560255,425621965,16398225,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560256,425623853,16403486,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560257,425625443,16409422,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560258,425626536,16414143,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560259,425627430,16416436,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560260,425628821,16419000,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560261,425629616,16419809,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560262,425631305,16420483,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560263,425633590,16420618,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560264,425636571,16419674,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560265,425640148,16417381,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560266,425644023,16414413,4106774,1,'2010-03-12 16:31:02',3310504136,1),(664560267,425647699,16412120,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560268,425649984,16411041,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560269,425652766,16410096,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560270,425655448,16410096,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560271,425659025,16410636,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560272,425661708,16410906,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560273,425663695,16411715,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560274,425648494,16422642,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560275,425658330,16418325,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560276,425613619,16431680,4106774,1,'2010-03-12 16:31:02',3310504095,1),(664560277,425627856,16425638,4108069,1,'2010-03-12 19:04:14',3310504138,2),(664560278,425633094,16425205,4106774,1,'2010-03-12 16:31:02',3310504138,1),(664560279,425638956,16424665,4106774,1,'2010-03-12 16:31:02',3310504136,1),(664560280,425666675,16413469,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560281,425669159,16416302,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560282,425665483,16416302,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560283,425670053,16416571,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560284,425655345,16648058,4106774,1,'2010-03-12 16:31:02',3310504171,1),(664560285,425668459,16653562,4106774,1,'2010-03-12 16:31:02',3310504171,1),(664560286,425666075,16678383,4106774,1,'2010-03-12 16:31:02',3310504171,1),(664560287,425704781,16676873,4106774,1,'2010-03-12 16:31:02',3310504175,1),(664560288,425701125,16673851,4106774,1,'2010-03-12 16:31:02',3310504175,1),(664560289,425697787,16672664,4106774,1,'2010-03-12 16:31:02',3310504174,1),(664560290,425694131,16672988,4106774,1,'2010-03-12 16:31:02',3310504174,1),(664560291,425715828,16690039,4106774,1,'2010-03-12 16:31:02',3310504175,1),(664560292,425709788,16683887,4106774,1,'2010-03-12 16:31:02',3310504175,1),(664560293,425723490,16628206,4106774,1,'2010-03-12 16:31:02',3310504173,1),(664560294,425724443,16628098,4106774,1,'2010-03-12 16:31:02',3310504173,1),(664560295,425735299,16668239,4106774,1,'2010-03-12 16:31:02',3310504186,1),(664560296,425736888,16668671,4106774,1,'2010-03-12 16:31:02',3310504186,1),(664560297,425737921,16665541,4106774,1,'2010-03-12 16:31:02',3310504186,1),(664560298,425739988,16660361,4106774,1,'2010-03-12 16:31:02',3310504186,1),(664560299,425741657,16656476,4106774,1,'2010-03-12 16:31:02',3310504186,1),(664560300,425742849,16653994,4106774,1,'2010-03-12 16:31:02',3310504186,1),(664560301,425744120,16656152,4106774,1,'2010-03-12 16:31:02',3310504186,1),(664560302,425745392,16659282,4106774,1,'2010-03-12 16:31:02',3310504186,1),(664560303,425747299,16666189,4106774,1,'2010-03-12 16:31:02',3310504186,1),(664560304,425733153,16695650,4106774,1,'2010-03-12 16:31:02',3310504186,1),(664560305,425727749,16695435,4106774,1,'2010-03-12 16:31:03',3310504186,1),(664560306,425722265,16693924,4106774,1,'2010-03-12 16:31:03',3310504175,1),(664560307,425746334,16684030,4106774,1,'2010-03-12 16:31:03',3310504186,1),(664560308,425743564,16687772,4106774,1,'2010-03-12 16:31:03',3310504186,1),(664560309,425738398,16693276,4106774,1,'2010-03-12 16:31:03',3310504186,1),(664560310,425748036,16681964,4106774,1,'2010-03-12 16:31:03',3310504186,1),(664560311,425748094,16674067,4106774,1,'2010-03-12 16:31:03',3310504186,1),(664560312,425416359,16701206,4106774,1,'2010-03-12 16:31:03',3310504448,1),(664560313,425418248,16713347,4106774,1,'2010-03-12 16:31:03',3310504448,1),(664560314,425421130,16725623,4106774,1,'2010-03-12 16:31:03',3310504448,1),(664560315,425425106,16744779,4106774,1,'2010-03-12 16:31:03',3310504449,1),(664560316,425427391,16754761,4106774,1,'2010-03-12 16:31:03',3310504451,1),(664560317,425431864,16763529,4106774,1,'2010-03-12 16:31:03',3310504451,1),(664560318,425436635,16773107,4106774,1,'2010-03-12 16:31:03',3310504451,1),(664560319,425441505,16779312,4106774,1,'2010-03-12 16:31:03',3310504451,1),(664560320,425496140,16699945,4106774,1,'2010-03-12 16:31:03',3310504453,1),(664560321,425497134,16704666,4106774,1,'2010-03-12 16:31:03',3310504453,1),(664560322,425497631,16709253,4106774,1,'2010-03-12 16:31:03',3310504453,1),(664560323,425497829,16713030,4106774,1,'2010-03-12 16:31:03',3310504453,1),(664560324,425498426,16718426,4106774,1,'2010-03-12 16:31:03',3310504453,1),(664560325,425499519,16724631,4106774,1,'2010-03-12 16:31:03',3310504453,1),(664560326,425448760,16785653,4106774,1,'2010-03-12 16:31:03',3310504451,1),(664560327,425453630,16787811,4106774,1,'2010-03-12 16:31:03',3310504454,1),(664560328,425459990,16787811,4106774,1,'2010-03-12 16:31:03',3310504454,1),(664560329,425466649,16787541,4106774,1,'2010-03-12 16:31:03',3310504454,1),(664560330,425473606,16789835,4106774,1,'2010-03-12 16:31:03',3310504454,1),(664560331,425480364,16794151,4106774,1,'2010-03-12 16:31:04',3310504455,1),(664560332,425490501,16798603,4106774,1,'2010-03-12 16:31:04',3310504455,1),(664560333,425495668,16799412,4106774,1,'2010-03-12 16:31:04',3310504455,1),(664560334,425515916,16701294,4106774,1,'2010-03-12 16:31:04',3310504464,1),(664560335,425520686,16707499,4106774,1,'2010-03-12 16:31:04',3310504464,1),(664560336,425525058,16713839,4106774,1,'2010-03-12 16:31:04',3310504464,1),(664560337,425501009,16731916,4106774,1,'2010-03-12 16:31:04',3310504453,1),(664560338,425502798,16740010,4106774,1,'2010-03-12 16:31:04',3310504453,1),(664560339,425503693,16744192,4106774,1,'2010-03-12 16:31:04',3310504453,1),(664560340,425504488,16747969,4106774,1,'2010-03-12 16:31:04',3310504453,1),(664560341,425506177,16751746,4106774,1,'2010-03-12 16:31:04',3310504453,1),(664560342,425530226,16722608,4106774,1,'2010-03-12 16:31:04',3310504464,1),(664560343,425533406,16725576,4106774,1,'2010-03-12 16:31:04',3310504464,1),(664560344,425554731,16702157,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560345,425555287,16707014,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560346,425534499,16728004,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560347,425537579,16733400,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560348,425538275,16734884,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560349,425538275,16737312,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560350,425537281,16739605,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560351,425535691,16743112,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560352,425534996,16744731,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560353,425534996,16746350,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560354,425534996,16748508,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560355,425534996,16750262,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560356,425534201,16752960,4106774,1,'2010-03-12 16:31:04',3310504464,1),(664560357,425537977,16730837,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560358,425540362,16735288,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560359,425542945,16740819,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560360,425546523,16748104,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560361,425548113,16749992,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560362,425550001,16750936,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560363,425552584,16750127,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560364,425509158,16757277,4106774,1,'2010-03-12 16:31:04',3310504466,1),(664560365,425513332,16765101,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560366,425516413,16770632,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560367,425519096,16775893,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560368,425501432,16801436,4106774,1,'2010-03-12 16:31:05',3310504455,1),(664560369,425503807,16800310,4106774,1,'2010-03-12 16:31:05',3310504455,1),(664560370,425512264,16800761,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560371,425514152,16784843,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560372,425518922,16787406,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560373,425521904,16790914,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560374,425522077,16782233,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560375,425524363,16787629,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560376,425526648,16794778,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560377,425516736,16803999,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560378,425519519,16807102,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560379,425521307,16807236,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560380,425521922,16805847,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560381,425524289,16798063,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560382,425523593,16802110,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560383,425524661,16798825,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560384,425527642,16802333,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560385,425527046,16802333,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560386,425523667,16804086,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560387,425532611,16757277,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560388,425531617,16764022,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560389,425531617,16769687,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560390,425532412,16777376,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560391,425533704,16783717,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560392,425535095,16790731,4106774,1,'2010-03-12 16:31:05',3310504467,1),(664560393,425536387,16795992,4106774,1,'2010-03-12 16:31:05',3310504467,1),(664560394,425536884,16799500,4106774,1,'2010-03-12 16:31:05',3310504467,1),(664560395,425537182,16802602,4106774,1,'2010-03-12 16:31:05',3310504467,1),(664560396,425537082,16804356,4106774,1,'2010-03-12 16:31:05',3310504467,1),(664560397,425536685,16805166,4106774,1,'2010-03-12 16:31:05',3310504467,1),(664560398,425528735,16800444,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560399,425531021,16805166,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560400,425534101,16806110,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560401,425535890,16805705,4106774,1,'2010-03-12 16:31:05',3310504467,1),(664560402,425533803,16786280,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560403,425533108,16791811,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560404,425531915,16795992,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560405,425529928,16798690,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560406,425556321,16710683,4106774,1,'2010-03-12 16:31:05',3310504465,1),(664560407,425556718,16717050,4106774,1,'2010-03-12 16:31:05',3310504465,1),(664560408,425558069,16722986,4106774,1,'2010-03-12 16:31:06',3310504465,1),(664560409,425555963,16748104,4106774,1,'2010-03-12 16:31:06',3310504465,1),(664560410,425559639,16745541,4106774,1,'2010-03-12 16:31:06',3310504465,1),(664560411,425562919,16741763,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560412,425566794,16739470,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560413,425559580,16728058,4106774,1,'2010-03-12 16:31:06',3310504465,1),(664560414,425561647,16731403,4106774,1,'2010-03-12 16:31:06',3310504465,1),(664560415,425563634,16733777,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560416,425566734,16735396,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560417,425572557,16736772,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560418,425572657,16736502,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560419,425577923,16734074,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560420,425582792,16732590,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560421,425570153,16736152,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560422,425573412,16737447,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560423,425576750,16739605,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560424,425579135,16741116,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560425,425581202,16742087,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560426,425582235,16741979,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560427,425582394,16740792,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560428,425581997,16739281,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560429,425581440,16736691,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560430,425581123,16734749,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560431,425581917,16733238,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560432,425583110,16732590,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560433,425584382,16732590,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560434,425588118,16733885,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560435,425592172,16735072,4106774,1,'2010-03-12 16:31:06',3310504469,1),(664560436,425596544,16737015,4106774,1,'2010-03-12 16:31:06',3310504469,1),(664560437,425601711,16738634,4106774,1,'2010-03-12 16:31:06',3310504469,1),(664560439,425606957,16739065,4106774,1,'2010-03-12 16:31:06',3310504469,1),(664560440,425608388,16738418,4106774,1,'2010-03-12 16:31:06',3310504469,1),(664598393,425608388,16450459,4107810,1,'2010-03-12 18:34:08',3310504095,1),(664598394,425609009,16445906,4107810,1,'2010-03-12 18:34:09',3310504095,1),(664598395,425610127,16442703,4107810,1,'2010-03-12 18:34:09',3310504095,1),(664598396,425609133,16473392,4107810,1,'2010-03-12 18:34:09',3310504095,1),(664598397,425607394,16470357,4107810,1,'2010-03-12 18:34:09',3310504095,1),(664598398,425607022,16465804,4107810,1,'2010-03-12 18:34:09',3310504095,1),(664598399,425606897,16461757,4107810,1,'2010-03-12 18:34:09',3310504095,1),(664598400,425607270,16456361,4107810,1,'2010-03-12 18:34:09',3310504095,1),(664598401,425543399,16535784,4107810,1,'2010-03-12 18:34:09',3310504115,1),(664598402,425595968,16533759,4107810,1,'2010-03-12 18:34:09',3310504117,1),(664598403,425599321,16532747,4107810,1,'2010-03-12 18:34:09',3310504117,1),(664598404,425601308,16531735,4107810,1,'2010-03-12 18:34:09',3310504117,1),(664598405,425604165,16529206,4107810,1,'2010-03-12 18:34:09',3310504117,1),(664598406,425607022,16526171,4107810,1,'2010-03-12 18:34:09',3310504117,1),(664598407,425572244,16581479,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598408,425571872,16584514,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598409,425574535,16588024,4108069,1,'2010-03-12 19:04:14',3310504118,2),(664598410,425571979,16582546,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598411,425570630,16585189,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598412,425570754,16588055,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598413,425572244,16584514,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598414,425573114,16589236,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598415,425587025,16557872,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598416,425586280,16551464,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598417,425584541,16546406,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598418,425584541,16543370,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598419,425585410,16539661,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598420,425587149,16537806,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598421,425588640,16535108,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598422,425592117,16534433,4107810,1,'2010-03-12 18:34:09',3310504117,1),(664598423,425588267,16563942,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598424,425589136,16567483,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598425,425591745,16573891,4107810,1,'2010-03-12 18:34:09',3310504119,1),(664598426,425593856,16580467,4107810,1,'2010-03-12 18:34:10',3310504119,1),(664598427,425595471,16585526,4107810,1,'2010-03-12 18:34:10',3310504119,1),(664598428,425568642,16601039,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598429,425568021,16603063,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598430,425569139,16607278,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598431,425576219,16591934,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598432,425571002,16590922,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598433,425571872,16594969,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598434,425571748,16597161,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598435,425571002,16600028,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598436,425570381,16612337,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598437,425571748,16616553,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598438,425574729,16594126,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598439,425576095,16600028,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598440,425577461,16606941,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598441,425578827,16614360,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598442,425572369,16621105,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598443,425573735,16627513,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598444,425574232,16632572,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598445,425572741,16635270,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598446,425573114,16639485,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598447,425579945,16621780,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598448,425580194,16626839,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598449,425581808,16633752,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598450,425608557,16639274,4107810,1,'2010-03-12 18:34:10',3310504125,1),(664598451,425583547,16641509,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598452,425596713,16592102,4107810,1,'2010-03-12 18:34:10',3310504125,1),(664598453,425597707,16597498,4107810,1,'2010-03-12 18:34:10',3310504125,1),(664598454,425599197,16602388,4107810,1,'2010-03-12 18:34:11',3310504125,1),(664598455,425600439,16610482,4107810,1,'2010-03-12 18:34:11',3310504125,1),(664598456,425602178,16617396,4107810,1,'2010-03-12 18:34:11',3310504125,1),(664598457,425604786,16623635,4107810,1,'2010-03-12 18:34:11',3310504125,1),(664598458,425606649,16628188,4107810,1,'2010-03-12 18:34:11',3310504125,1),(664598459,425609257,16633078,4107810,1,'2010-03-12 18:34:11',3310504125,1),(664598460,425573611,16654155,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598461,425573362,16648085,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598462,425573859,16658034,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598463,425573487,16661069,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598464,425574108,16670006,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598465,425574729,16678100,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598466,425574480,16683664,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598467,425574729,16688723,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598468,425575474,16692770,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598469,425580194,16698503,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598470,425609513,16686730,4107810,1,'2010-03-12 18:34:11',3310504127,1),(664598471,425585907,16652132,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598472,425588515,16659889,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598473,425591372,16670006,4107810,1,'2010-03-12 18:34:11',3310504127,1),(664598474,425592490,16677594,4107810,1,'2010-03-12 18:34:11',3310504127,1),(664598475,425593484,16682484,4107810,1,'2010-03-12 18:34:11',3310504127,1),(664598476,425592863,16685182,4107810,1,'2010-03-12 18:34:11',3310504127,1),(664598477,425592738,16689903,4107810,1,'2010-03-12 18:34:11',3310504127,1),(664598478,425592242,16694625,4107810,1,'2010-03-12 18:34:11',3310504127,1),(664598479,425662164,16424323,4107810,1,'2010-03-12 18:34:11',3310504137,1),(664598480,425611369,16476427,4107810,1,'2010-03-12 18:34:11',3310504095,1),(664598481,425612611,16440173,4107810,1,'2010-03-12 18:34:11',3310504095,1),(664598482,425614970,16439836,4107810,1,'2010-03-12 18:34:11',3310504095,1),(664598483,425617579,16439667,4107810,1,'2010-03-12 18:34:11',3310504138,1),(664598484,425621801,16438318,4107810,1,'2010-03-12 18:34:11',3310504138,1),(664598485,425624658,16437475,4107810,1,'2010-03-12 18:34:11',3310504138,1),(664598486,425627390,16436464,4107810,1,'2010-03-12 18:34:11',3310504138,1),(664598487,425630868,16435958,4107810,1,'2010-03-12 18:34:11',3310504138,1),(664598488,425633973,16435115,4107810,1,'2010-03-12 18:34:12',3310504138,1),(664598489,425637699,16433766,4107810,1,'2010-03-12 18:34:12',3310504138,1),(664598490,425663282,16444389,4107810,1,'2010-03-12 18:34:12',3310504139,1),(664598491,425661544,16448267,4107810,1,'2010-03-12 18:34:12',3310504139,1),(664598492,425659060,16453326,4107810,1,'2010-03-12 18:34:12',3310504139,1),(664598493,425657818,16457204,4107810,1,'2010-03-12 18:34:12',3310504139,1),(664598494,425655707,16462094,4107810,1,'2010-03-12 18:34:12',3310504139,1),(664598495,425653968,16468333,4107810,1,'2010-03-12 18:34:12',3310504139,1),(664598496,425650987,16474910,4107810,1,'2010-03-12 18:34:12',3310504139,1),(664598497,425641300,16432922,4107810,1,'2010-03-12 18:34:12',3310504138,1),(664598499,425646392,16431405,4107810,1,'2010-03-12 18:34:12',3310504139,1),(664598500,425651360,16428876,4107810,1,'2010-03-12 18:34:12',3310504139,1),(664598501,425657445,16426683,4107810,1,'2010-03-12 18:34:12',3310504139,1),(664598503,425689237,16396331,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598504,425672100,16408978,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598505,425674211,16406617,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598506,425677191,16404257,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598507,425671605,16422566,4108069,1,'2010-03-12 19:04:14',3310504137,2),(664598508,425671851,16423480,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598509,425666014,16422299,4107810,1,'2010-03-12 18:34:12',3310504137,1),(664598510,425668374,16419264,4107810,1,'2010-03-12 18:34:12',3310504137,1),(664598511,425669740,16414543,4107810,1,'2010-03-12 18:34:12',3310504137,1),(664598512,425670113,16411676,4107810,1,'2010-03-12 18:34:12',3310504137,1),(664598513,425684022,16399535,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598514,425680325,16422236,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598515,425682869,16422167,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598516,425684649,16421615,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598517,425686124,16420164,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598518,425687650,16418990,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598519,425689634,16418023,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598520,425692483,16417056,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598521,425680224,16422306,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598522,425683276,16418576,4107810,1,'2010-03-12 18:34:13',3310504140,1),(664598523,425685666,16415606,4107810,1,'2010-03-12 18:34:13',3310504140,1),(664598524,425688617,16412360,4107810,1,'2010-03-12 18:34:13',3310504140,1),(664598525,425692228,16408837,4107810,1,'2010-03-12 18:34:13',3310504140,1),(664598526,425694701,16394139,4107810,1,'2010-03-12 18:34:13',3310504140,1),(664598527,425700041,16393802,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598528,425704388,16393802,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598529,425708237,16395320,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598530,425711342,16396669,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598531,425694924,16406213,4107810,1,'2010-03-12 18:34:13',3310504140,1),(664598532,425697773,16404003,4107810,1,'2010-03-12 18:34:13',3310504140,1),(664598533,425706115,16403394,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598534,425704335,16400700,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598535,425704741,16409252,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598536,425705911,16406696,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598537,425700112,16402000,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598538,425702554,16400273,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598539,425703673,16399997,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598540,425705046,16400411,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598541,425694822,16416642,4107810,1,'2010-03-12 18:34:13',3310504140,1),(664598542,425698230,16415951,4107810,1,'2010-03-12 18:34:13',3310504140,1),(664598543,425701079,16415468,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598544,425704182,16415399,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598545,425701384,16423342,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598546,425701180,16421684,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598547,425700824,16420510,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598548,425700367,16419612,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598549,425700061,16419059,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598550,425699807,16418092,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598551,425700011,16417471,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598552,425700774,16416089,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598553,425702147,16413672,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598554,425703469,16411324,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598555,425713080,16401727,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598556,425714819,16406449,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598557,425716061,16412350,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598558,425717178,16417072,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598559,425718544,16421119,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598560,425719786,16424323,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598561,425707488,16416228,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598562,425710540,16418023,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598563,425714660,16423203,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598564,425706572,16404693,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598565,425706928,16404072,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598566,425706674,16403036,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598567,425669740,16428876,4107810,1,'2010-03-12 18:34:14',3310504139,1),(664598568,425668250,16433597,4107810,1,'2010-03-12 18:34:14',3310504139,1),(664598569,425666511,16438487,4107810,1,'2010-03-12 18:34:14',3310504139,1),(664598570,425677935,16436533,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598571,425677019,16432873,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598572,425677477,16429419,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598573,425678647,16425690,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598574,425685260,16425427,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598575,425689481,16451797,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598576,425692483,16448482,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598577,425682309,16451314,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598578,425682106,16449035,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598579,425681088,16445996,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598580,425680173,16442957,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598581,425679257,16440263,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598582,425677440,16476933,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598583,425670255,16468594,4107810,1,'2010-03-12 18:34:14',3310504139,1),(664598584,425671068,16468788,4107810,1,'2010-03-12 18:34:14',3310504139,1),(664598585,425673916,16470100,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598586,425676154,16470998,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598587,425678036,16471344,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598588,425671627,16468028,4107810,1,'2010-03-12 18:34:15',3310504139,1),(664598589,425674832,16466164,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598590,425677782,16462365,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598591,425682208,16464989,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598592,425682614,16462779,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598593,425683377,16460155,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598594,425684395,16458083,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598595,425685870,16456218,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598596,425680478,16458704,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598597,425681495,16456632,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598598,425682004,16453317,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598599,425687599,16454008,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598600,425679302,16473223,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598601,425680296,16471031,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598602,425682283,16470694,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598603,425679715,16470791,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598604,425680834,16469134,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598605,425681699,16466854,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598606,425718017,16426726,4107810,1,'2010-03-12 18:34:15',3310504143,1),(664598607,425694975,16445720,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598608,425697773,16443233,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598609,425699858,16442059,4107810,1,'2010-03-12 18:34:15',3310504143,1),(664598610,425701231,16441506,4107810,1,'2010-03-12 18:34:15',3310504143,1),(664598611,425701994,16440056,4107810,1,'2010-03-12 18:34:15',3310504143,1),(664598612,425701943,16438882,4107810,1,'2010-03-12 18:34:15',3310504143,1),(664598613,425701537,16437915,4107810,1,'2010-03-12 18:34:15',3310504143,1),(664598614,425700926,16437224,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598615,425700519,16435497,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598616,425700519,16433702,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598617,425700570,16431630,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598618,425700723,16429558,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598619,425700672,16428038,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598620,425700672,16427002,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598621,425701180,16425275,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598622,425732949,16395825,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598623,425733321,16393465,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598624,425734190,16392959,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598625,425735681,16393633,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598626,425736426,16395825,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598627,425729223,16422636,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598628,425729720,16419939,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598629,425729720,16415892,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598630,425729844,16413025,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598631,425730093,16407460,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598632,425730714,16403919,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598633,425731707,16399198,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598634,425737667,16401896,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598635,425739530,16408304,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598636,425739903,16411170,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598637,425740772,16414711,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598638,425742634,16418252,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598639,425743752,16421456,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598640,425720904,16426683,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598641,425722394,16431236,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598642,425723635,16434271,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598643,425724629,16435283,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598644,425725250,16435452,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598645,425726616,16434609,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598646,425727982,16432585,4107810,1,'2010-03-12 18:34:16',3310504154,1),(664598647,425728727,16428538,4107810,1,'2010-03-12 18:34:16',3310504154,1),(664598648,425729099,16425166,4107810,1,'2010-03-12 18:34:16',3310504154,1),(664598649,425744745,16426178,4107810,1,'2010-03-12 18:34:17',3310504154,1),(664598650,425746235,16431742,4107810,1,'2010-03-12 18:34:17',3310504154,1),(664598651,425747353,16434609,4107810,1,'2010-03-12 18:34:17',3310504154,1),(664598652,425720458,16429627,4107810,1,'2010-03-12 18:34:17',3310504143,1),(664598653,425722798,16432320,4107810,1,'2010-03-12 18:34:17',3310504143,1),(664598654,425747850,16437981,4107810,1,'2010-03-12 18:34:17',3310504154,1),(664598655,425748222,16442871,4107810,1,'2010-03-12 18:34:17',3310504154,1),(664598656,425748719,16449447,4107810,1,'2010-03-12 18:34:17',3310504154,1),(664598657,425748843,16456361,4107810,1,'2010-03-12 18:34:17',3310504154,1),(664598658,425749588,16463612,4107810,1,'2010-03-12 18:34:17',3310504154,1),(664598659,425750085,16471200,4107810,1,'2010-03-12 18:34:17',3310504154,1),(664598660,425750457,16476764,4107810,1,'2010-03-12 18:34:17',3310504154,1),(664598661,425768089,16478451,4107810,1,'2010-03-12 18:34:17',3310504155,1),(664598662,425770821,16477776,4107810,1,'2010-03-12 18:34:17',3310504155,1),(664598663,425772435,16477776,4107810,1,'2010-03-12 18:34:17',3310504155,1),(664598665,425773801,16479294,4107810,1,'2010-03-12 18:34:17',3310504155,1),(664598666,425623540,16501889,4107810,1,'2010-03-12 18:34:17',3310504160,1),(664598668,425622298,16498348,4107810,1,'2010-03-12 18:34:17',3310504160,1),(664598670,425621056,16494470,4107810,1,'2010-03-12 18:34:17',3310504160,1),(664598672,425618448,16490254,4107810,1,'2010-03-12 18:34:17',3310504160,1),(664598674,425617082,16486713,4107810,1,'2010-03-12 18:34:17',3310504160,1),(664598676,425614598,16484521,4107810,1,'2010-03-12 18:34:17',3310504117,1),(664598678,425613107,16480474,4107810,1,'2010-03-12 18:34:17',3310504117,1),(664598680,425636829,16498854,4107810,1,'2010-03-12 18:34:17',3310504160,1),(664598682,425624410,16506105,4107810,1,'2010-03-12 18:34:17',3310504160,1),(664598684,425610748,16522461,4107810,1,'2010-03-12 18:34:17',3310504117,1),(664598697,425614598,16519426,4107810,1,'2010-03-12 18:34:18',3310504117,1),(664598698,425618200,16517065,4107810,1,'2010-03-12 18:34:18',3310504160,1),(664598699,425620932,16514367,4107810,1,'2010-03-12 18:34:18',3310504160,1),(664598700,425622919,16512512,4107810,1,'2010-03-12 18:34:18',3310504160,1),(664598701,425626645,16511669,4107810,1,'2010-03-12 18:34:18',3310504160,1),(664598702,425633103,16508128,4107810,1,'2010-03-12 18:34:18',3310504160,1),(664598703,425629626,16512007,4107810,1,'2010-03-12 18:34:18',3310504160,1),(664598704,425626273,16513355,4107810,1,'2010-03-12 18:34:18',3310504160,1),(664598706,425624285,16509646,4107810,1,'2010-03-12 18:34:18',3310504160,1),(664598708,425652478,16534265,4107810,1,'2010-03-12 18:34:18',3310504161,1),(664598709,425653844,16527857,4107810,1,'2010-03-12 18:34:18',3310504161,1),(664598710,425655955,16521449,4107810,1,'2010-03-12 18:34:18',3310504161,1),(664598711,425660550,16516391,4107810,1,'2010-03-12 18:34:18',3310504161,1),(664598712,425664151,16511838,4107810,1,'2010-03-12 18:34:18',3310504161,1),(664598713,425646889,16480980,4107810,1,'2010-03-12 18:34:18',3310504161,1),(664598714,425643411,16488231,4107810,1,'2010-03-12 18:34:18',3310504160,1),(664598715,425640679,16494470,4107810,1,'2010-03-12 18:34:18',3310504160,1),(664598716,425638320,16500372,4107810,1,'2010-03-12 18:34:18',3310504160,1),(664598717,425645895,16583671,4107810,1,'2010-03-12 18:34:18',3310504163,1),(664598718,425653099,16573385,4107810,1,'2010-03-12 18:34:18',3310504163,1),(664598719,425654961,16567652,4107810,1,'2010-03-12 18:34:18',3310504163,1),(664598720,425656576,16560738,4107810,1,'2010-03-12 18:34:18',3310504163,1),(664598721,425655955,16555343,4107810,1,'2010-03-12 18:34:18',3310504163,1),(664598722,425654713,16550621,4107810,1,'2010-03-12 18:34:18',3310504163,1),(664598723,425652726,16544888,4107810,1,'2010-03-12 18:34:18',3310504163,1),(664598724,425651484,16539829,4107810,1,'2010-03-12 18:34:18',3310504163,1),(664598725,425649745,16578612,4107810,1,'2010-03-12 18:34:18',3310504163,1),(664598726,425667380,16506273,4107810,1,'2010-03-12 18:34:18',3310504161,1),(664598727,425670734,16499360,4107810,1,'2010-03-12 18:34:18',3310504161,1),(664598728,425671975,16497168,4107810,1,'2010-03-12 18:34:18',3310504164,1),(664598729,425674087,16495650,4107810,1,'2010-03-12 18:34:18',3310504164,1),(664598730,425676322,16493289,4107810,1,'2010-03-12 18:34:18',3310504164,1),(664598731,425676819,16490423,4107810,1,'2010-03-12 18:34:18',3310504164,1),(664598732,425676819,16486882,4107810,1,'2010-03-12 18:34:19',3310504164,1),(664598733,425676819,16483172,4107810,1,'2010-03-12 18:34:19',3310504164,1),(664598734,425687375,16489242,4107810,1,'2010-03-12 18:34:19',3310504164,1),(664598735,425610623,16634258,4107810,1,'2010-03-12 18:34:19',3310504125,1),(664598736,425612114,16634932,4107810,1,'2010-03-12 18:34:19',3310504125,1),(664598737,425614474,16634258,4107810,1,'2010-03-12 18:34:19',3310504125,1),(664598738,425618324,16632403,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598739,425622298,16630042,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598740,425624037,16628019,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598741,425626148,16627176,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598742,425629253,16625827,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598743,425631986,16623972,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598744,425635463,16620262,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598745,425640803,16595981,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598746,425643287,16590079,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598747,425639313,16614192,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598748,425641549,16609133,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598749,425643908,16605761,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598750,425644778,16605255,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598751,425646268,16605929,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598752,425648255,16605592,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598753,425650739,16605086,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598754,425653223,16605086,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598755,425656824,16607110,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598756,425661668,16611663,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598757,425653595,16605255,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598758,425656203,16608627,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598759,425658563,16612843,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598760,425659432,16616047,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598761,425660923,16619925,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598762,425662661,16623466,4107810,1,'2010-03-12 18:34:20',3310504169,1),(664598763,425664524,16626670,4107810,1,'2010-03-12 18:34:20',3310504169,1),(664598764,425610910,16663755,4107810,1,'2010-03-12 18:34:20',3310504127,1),(664598765,425610444,16647104,4107810,1,'2010-03-12 18:34:20',3310504127,1),(664598766,425614015,16654481,4107810,1,'2010-03-12 18:34:20',3310504127,1),(664598767,425614170,16664177,4107810,1,'2010-03-12 18:34:20',3310504127,1),(664598768,425611997,16645629,4107810,1,'2010-03-12 18:34:20',3310504127,1),(664598769,425614170,16649001,4107810,1,'2010-03-12 18:34:20',3310504127,1),(664598770,425620691,16653638,4107810,1,'2010-03-12 18:34:20',3310504170,1),(664598771,425618282,16651507,4107810,1,'2010-03-12 18:34:20',3310504170,1),(664598772,425629384,16662491,4107810,1,'2010-03-12 18:34:20',3310504170,1),(664598773,425629316,16668912,4107810,1,'2010-03-12 18:34:20',3310504170,1),(664598774,425624416,16654903,4107810,1,'2010-03-12 18:34:20',3310504170,1),(664598776,425666387,16616215,4107810,1,'2010-03-12 18:34:20',3310504169,1),(664598777,425671727,16621274,4107810,1,'2010-03-12 18:34:20',3310504169,1),(664598778,425677688,16625152,4107810,1,'2010-03-12 18:34:20',3310504172,1),(664598779,425683773,16628525,4107810,1,'2010-03-12 18:34:20',3310504172,1);
INSERT INTO `current_nodes` VALUES (664598780,425689486,16631729,4107810,1,'2010-03-12 18:34:20',3310504172,1),(664598781,425667753,16628356,4107810,1,'2010-03-12 18:34:20',3310504169,1),(664598782,425674087,16633246,4107810,1,'2010-03-12 18:34:20',3310504172,1),(664598783,425681414,16638136,4107810,1,'2010-03-12 18:34:20',3310504172,1),(664598784,425686505,16642015,4107810,1,'2010-03-12 18:34:20',3310504172,1),(664598785,425706609,16592049,4107810,1,'2010-03-12 18:34:20',3310504173,1),(664598786,425697930,16635944,4107810,1,'2010-03-12 18:34:20',3310504172,1),(664598787,425703891,16637630,4107810,1,'2010-03-12 18:34:20',3310504173,1),(664598788,425708734,16638811,4107810,1,'2010-03-12 18:34:20',3310504173,1),(664598789,425712832,16638811,4107810,1,'2010-03-12 18:34:20',3310504173,1),(664598790,425716681,16637462,4107810,1,'2010-03-12 18:34:20',3310504173,1),(664598791,425719289,16635607,4107810,1,'2010-03-12 18:34:20',3310504173,1),(664598792,425690355,16644881,4107810,1,'2010-03-12 18:34:20',3310504174,1),(664598793,425693335,16648085,4107810,1,'2010-03-12 18:34:20',3310504174,1),(664598794,425698054,16653481,4107810,1,'2010-03-12 18:34:20',3310504174,1),(664598795,425701035,16656348,4107810,1,'2010-03-12 18:34:20',3310504175,1),(664598796,425703891,16658034,4107810,1,'2010-03-12 18:34:20',3310504175,1),(664598797,425706250,16661406,4107810,1,'2010-03-12 18:34:20',3310504175,1),(664598798,425709852,16664779,4107810,1,'2010-03-12 18:34:20',3310504175,1),(664598799,425713825,16667477,4107810,1,'2010-03-12 18:34:20',3310504175,1),(664598800,425712459,16669500,4107810,1,'2010-03-12 18:34:20',3310504175,1),(664598801,425751078,16483172,4107810,1,'2010-03-12 18:34:21',3310504176,1),(664598802,425751575,16488737,4107810,1,'2010-03-12 18:34:21',3310504176,1),(664598803,425752320,16493289,4107810,1,'2010-03-12 18:34:21',3310504176,1),(664598804,425752941,16495987,4107810,1,'2010-03-12 18:34:21',3310504176,1),(664598805,425753562,16496493,4107810,1,'2010-03-12 18:34:21',3310504176,1),(664598806,425754182,16496493,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598807,425755300,16495987,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598808,425756418,16494638,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598809,425757908,16492278,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598810,425759894,16488568,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598811,425767344,16505093,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598812,425771566,16498685,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598813,425774795,16494638,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598814,425761509,16484690,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598815,425763744,16482160,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598816,425765979,16480137,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598817,425774670,16481149,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598818,425751575,16529375,4107810,1,'2010-03-12 18:34:21',3310504176,1),(664598819,425754803,16519595,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598820,425756293,16514873,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598821,425758156,16513187,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598822,425763371,16509477,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598823,425745739,16587212,4107810,1,'2010-03-12 18:34:21',3310504178,1),(664598824,425747353,16572542,4107810,1,'2010-03-12 18:34:21',3310504178,1),(664598825,425748098,16560907,4107810,1,'2010-03-12 18:34:21',3310504178,1),(664598826,425749216,16553488,4107810,1,'2010-03-12 18:34:21',3310504178,1),(664598828,425748719,16545394,4107810,1,'2010-03-12 18:34:21',3310504178,1),(664598829,425750581,16537300,4107810,1,'2010-03-12 18:34:21',3310504178,1),(664598831,425775167,16482666,4107810,1,'2010-03-12 18:34:22',3310504177,1),(664598832,425775664,16485195,4107810,1,'2010-03-12 18:34:22',3310504177,1),(664598833,425775664,16486882,4107810,1,'2010-03-12 18:34:22',3310504177,1),(664598834,425775912,16489074,4107810,1,'2010-03-12 18:34:22',3310504177,1),(664598835,425776036,16490086,4107810,1,'2010-03-12 18:34:22',3310504177,1),(664598837,425727733,16638136,4107810,1,'2010-03-12 18:34:22',3310504184,1),(664598838,425742883,16639823,4107810,1,'2010-03-12 18:34:22',3310504184,1),(664598840,425742883,16627682,4107810,1,'2010-03-12 18:34:22',3310504184,1),(664598842,425743876,16609976,4107810,1,'2010-03-12 18:34:22',3310504184,1),(664598843,425721276,16632572,4107810,1,'2010-03-12 18:34:22',3310504173,1),(664598844,425722642,16628693,4107810,1,'2010-03-12 18:34:22',3310504173,1),(664598846,425730217,16648254,4107810,1,'2010-03-12 18:34:22',3310504186,1),(664598848,425732452,16657191,4107810,1,'2010-03-12 18:34:22',3310504186,1),(664598849,425742138,16654999,4107810,1,'2010-03-12 18:34:22',3310504186,1),(664598850,425734066,16663767,4107810,1,'2010-03-12 18:34:22',3310504186,1),(664598852,425735060,16667814,4107810,1,'2010-03-12 18:34:22',3310504186,1),(664598854,425736922,16667814,4107810,1,'2010-03-12 18:34:22',3310504186,1),(664598855,425738412,16665285,4107810,1,'2010-03-12 18:34:22',3310504186,1),(664598857,425740399,16659383,4107810,1,'2010-03-12 18:34:22',3310504186,1),(664598858,425591038,16721720,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598860,425589027,16725875,4107810,1,'2010-03-12 18:34:22',3310504468,1),(664598861,425583050,16703562,4107810,1,'2010-03-12 18:34:22',3310504468,1),(664598863,425587894,16707272,4107810,1,'2010-03-12 18:34:22',3310504468,1),(664598864,425594974,16711993,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598865,425594601,16724808,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598866,425591372,16725651,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598867,425589136,16726663,4107810,1,'2010-03-12 18:34:22',3310504468,1),(664598868,425594105,16699684,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598869,425595595,16701201,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598870,425601440,16700852,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598871,425597210,16700864,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598872,425599321,16701201,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598873,425598949,16714185,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598874,425602426,16716209,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598875,425601308,16722785,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598876,425598452,16725314,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598877,425605942,16715396,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598878,425604289,16717220,4107810,1,'2010-03-12 18:34:23',3310504469,1),(664598879,425604041,16719581,4107810,1,'2010-03-12 18:34:23',3310504469,1),(664598880,425588764,16728518,4107810,1,'2010-03-12 18:34:23',3310504468,1),(664598881,425593980,16732228,4107810,1,'2010-03-12 18:34:23',3310504469,1),(664598882,425598203,16735263,4107810,1,'2010-03-12 18:34:23',3310504469,1),(664598883,425601557,16736949,4107810,1,'2010-03-12 18:34:23',3310504469,1),(664598884,425604538,16738467,4107810,1,'2010-03-12 18:34:23',3310504469,1),(664598885,425607767,16739479,4107810,1,'2010-03-12 18:34:23',3310504469,1),(664598886,425609506,16736106,4107810,1,'2010-03-12 18:34:23',3310504469,1),(664598887,425628453,16712024,4107810,1,'2010-03-12 18:34:23',3310504512,1),(664598888,425620691,16714975,4107810,1,'2010-03-12 18:34:23',3310504512,1),(664598889,425611686,16714553,4107810,1,'2010-03-12 18:34:23',3310504469,1),(664598890,425613480,16733408,4107810,1,'2010-03-12 18:34:23',3310504469,1),(664598891,425663048,16703644,4107810,1,'2010-03-12 18:34:23',3310504513,1),(664598892,425652205,16703593,4107810,1,'2010-03-12 18:34:23',3310504513,1),(664598893,425662761,16706965,4107810,1,'2010-03-12 18:34:23',3310504513,1),(664598894,425642735,16705279,4107810,1,'2010-03-12 18:34:23',3310504512,1),(664598895,425650808,16708230,4107810,1,'2010-03-12 18:34:23',3310504513,1),(664598896,425657173,16704225,4107810,1,'2010-03-12 18:34:23',3310504513,1),(664605736,425354927,15876138,4108069,1,'2010-03-12 19:03:52',3310493014,1),(664605748,425397563,16307798,4108069,1,'2010-03-12 19:03:54',3310504064,1),(664605750,425485967,16471174,4108069,1,'2010-03-12 19:03:54',3310504079,1),(664605751,425484867,16470013,4108069,1,'2010-03-12 19:03:54',3310504079,1),(664605752,425483768,16469681,4108069,1,'2010-03-12 19:03:54',3310504079,1),(664605753,425483401,16470510,4108069,1,'2010-03-12 19:03:54',3310504079,1),(664605754,425483902,16474158,4108069,1,'2010-03-12 19:03:54',3310504079,1),(664605756,425484416,16479394,4108069,1,'2010-03-12 19:03:54',3310504079,1),(664605757,425498364,16462248,4108069,1,'2010-03-12 19:03:54',3310504079,1),(664605758,425487555,16471671,4108069,1,'2010-03-12 19:03:54',3310504079,1),(664605759,425535187,16417781,4108069,1,'2010-03-12 19:03:54',3310504089,1),(664605760,425506182,16451210,4108069,1,'2010-03-12 19:03:55',3310504079,1),(664605761,425521818,16434336,4108069,1,'2010-03-12 19:03:55',3310504090,1),(664605762,425503368,16455774,4108069,1,'2010-03-12 19:03:55',3310504079,1),(664605764,425568802,16403772,4108069,1,'2010-03-12 19:03:55',3310504092,1),(664605765,425608181,16448161,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605768,425608303,16446006,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605770,425605230,16430410,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605771,425594990,16478341,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605772,425595967,16473201,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605773,425599997,16476683,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605774,425599997,16472537,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605776,425599997,16470050,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605777,425600852,16466899,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605778,425603173,16460598,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605779,425605372,16455126,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605780,425597310,16468889,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605781,425598776,16463251,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605783,425601707,16458442,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605784,425604150,16453634,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605785,425445530,16532196,4108069,1,'2010-03-12 19:03:55',3310504097,1),(664605786,425444797,16535181,4108069,1,'2010-03-12 19:03:56',3310504099,1),(664605787,425442598,16543306,4108069,1,'2010-03-12 19:03:56',3310504099,1),(664605788,425438933,16557401,4108069,1,'2010-03-12 19:03:56',3310504099,1),(664605790,425437842,16558712,4108069,1,'2010-03-12 19:03:56',3310504099,1),(664605791,425440979,16550844,4108069,1,'2010-03-12 19:03:56',3310504099,1),(664605792,425441978,16546610,4108069,1,'2010-03-12 19:03:56',3310504099,1),(664605793,425443619,16538470,4108069,1,'2010-03-12 19:03:56',3310504099,1),(664605794,425452371,16518101,4108069,1,'2010-03-12 19:03:56',3310504100,1),(664605795,425450905,16517936,4108069,1,'2010-03-12 19:03:56',3310504097,1),(664605796,425449317,16518101,4108069,1,'2010-03-12 19:03:56',3310504097,1),(664605797,425447729,16520423,4108069,1,'2010-03-12 19:03:56',3310504097,1),(664605799,425447362,16522910,4108069,1,'2010-03-12 19:03:56',3310504097,1),(664605800,425446850,16527222,4108069,1,'2010-03-12 19:03:56',3310504097,1),(664605801,425448197,16518729,4108069,1,'2010-03-12 19:03:56',3310504097,1),(664605803,425453700,16517824,4108069,1,'2010-03-12 19:03:56',3310504100,1),(664605804,425454528,16518198,4108069,1,'2010-03-12 19:03:56',3310504100,1),(664605805,425456976,16517995,4108069,1,'2010-03-12 19:03:56',3310504100,1),(664605806,425471551,16509313,4108069,1,'2010-03-12 19:03:56',3310504100,1),(664605807,425466176,16509976,4108069,1,'2010-03-12 19:03:56',3310504100,1),(664605808,425464832,16511966,4108069,1,'2010-03-12 19:03:56',3310504100,1),(664605809,425462267,16515117,4108069,1,'2010-03-12 19:03:56',3310504100,1),(664605811,425459585,16516968,4108069,1,'2010-03-12 19:03:57',3310504100,1),(664605812,425466766,16509234,4108069,1,'2010-03-12 19:03:57',3310504100,1),(664605813,425469276,16508922,4108069,1,'2010-03-12 19:03:57',3310504100,1),(664605814,425485356,16490243,4108069,1,'2010-03-12 19:03:57',3310504101,1),(664605815,425485356,16494886,4108069,1,'2010-03-12 19:03:57',3310504101,1),(664605816,425484256,16501353,4108069,1,'2010-03-12 19:03:57',3310504101,1),(664605817,425484731,16484108,4108069,1,'2010-03-12 19:03:57',3310504101,1),(664605818,425482913,16507489,4108069,1,'2010-03-12 19:03:57',3310504101,1),(664605819,425481447,16510971,4108069,1,'2010-03-12 19:03:57',3310504101,1),(664605820,425478637,16512961,4108069,1,'2010-03-12 19:03:57',3310504100,1),(664605821,425475949,16512132,4108069,1,'2010-03-12 19:03:57',3310504100,1),(664605822,425479130,16513439,4108069,1,'2010-03-12 19:03:57',3310504100,1),(664605823,425480596,16512200,4108069,1,'2010-03-12 19:03:57',3310504101,1),(664605824,425426548,16605671,4133447,1,'2010-03-15 12:47:10',3310504105,2),(664605825,425522452,16526145,4108069,1,'2010-03-12 19:03:57',3310504112,1),(664605826,425526055,16528997,4108069,1,'2010-03-12 19:03:57',3310504112,1),(664605827,425531959,16530763,4108069,1,'2010-03-12 19:03:57',3310504112,1),(664605828,425582409,16503546,4108069,1,'2010-03-12 19:03:57',3310504116,1),(664605829,425582409,16496582,4108069,1,'2010-03-12 19:03:58',3310504116,1),(664605830,425582531,16493763,4108069,1,'2010-03-12 19:03:58',3310504116,1),(664605831,425584485,16490446,4108069,1,'2010-03-12 19:03:58',3310504116,1),(664605832,425586195,16485471,4108069,1,'2010-03-12 19:03:58',3310504116,1),(664605833,425590593,16482984,4108069,1,'2010-03-12 19:03:58',3310504117,1),(664605834,425592913,16481658,4108069,1,'2010-03-12 19:03:58',3310504117,1),(664605836,425604761,16500395,4108069,1,'2010-03-12 19:03:58',3310504117,1),(664605837,425604150,16493597,4108069,1,'2010-03-12 19:03:58',3310504117,1),(664605838,425603051,16486466,4108069,1,'2010-03-12 19:03:58',3310504117,1),(664605839,425601463,16481823,4108069,1,'2010-03-12 19:03:58',3310504117,1),(664605840,425588516,16534057,4108069,1,'2010-03-12 19:03:58',3310504116,1),(664605841,425587173,16529083,4108069,1,'2010-03-12 19:03:58',3310504116,1),(664605842,425586073,16523776,4108069,1,'2010-03-12 19:03:58',3310504116,1),(664605843,425585096,16518802,4108069,1,'2010-03-12 19:03:58',3310504116,1),(664605844,425583875,16511837,4108069,1,'2010-03-12 19:03:58',3310504116,1),(664605846,425608182,16533096,4108069,1,'2010-03-12 19:03:58',3310504117,1),(664605847,425603051,16528585,4108069,1,'2010-03-12 19:03:58',3310504117,1),(664605848,425603051,16522450,4108069,1,'2010-03-12 19:03:58',3310504117,1),(664605849,425604150,16517144,4108069,1,'2010-03-12 19:03:58',3310504117,1),(664605850,425604883,16508852,4108069,1,'2010-03-12 19:03:58',3310504117,1),(664605851,425563379,16541970,4108069,1,'2010-03-12 19:03:58',3310504118,1),(664605853,425565431,16543668,4108069,1,'2010-03-12 19:03:58',3310504118,1),(664605854,425566932,16545910,4108069,1,'2010-03-12 19:03:58',3310504118,1),(664605855,425571134,16569818,4108069,1,'2010-03-12 19:03:58',3310504118,1),(664605856,425592424,16553683,4108069,1,'2010-03-12 19:03:58',3310504119,1),(664605857,425589495,16552166,4108069,1,'2010-03-12 19:03:58',3310504119,1),(664605858,425593035,16554785,4108069,1,'2010-03-12 19:03:58',3310504119,1),(664605860,425598599,16550606,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605861,425603211,16547316,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605864,425606494,16544026,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605866,425607901,16542540,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605869,425610325,16540417,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605871,425597434,16546196,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605874,425602808,16540558,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605876,425601707,16551800,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605878,425608547,16548318,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605886,425589738,16563740,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605888,425593035,16567554,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605890,425595967,16570372,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605891,425600120,16574850,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605892,425606837,16581317,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605893,425621098,16428287,4108069,1,'2010-03-12 19:03:59',3310504138,1),(664605894,425661555,16474229,4108069,1,'2010-03-12 19:03:59',3310504139,1),(664605895,425664608,16467762,4108069,1,'2010-03-12 19:03:59',3310504139,1),(664605896,425672099,16422794,4108069,1,'2010-03-12 19:03:59',3310504140,1),(664605897,425672064,16422633,4108069,1,'2010-03-12 19:04:00',3310504140,1),(664605898,425670714,16448195,4108069,1,'2010-03-12 19:04:00',3310504139,1),(664605899,425671080,16440899,4108069,1,'2010-03-12 19:04:00',3310504139,1),(664605900,425671447,16433105,4108069,1,'2010-03-12 19:04:00',3310504139,1),(664605901,425671691,16427633,4108069,1,'2010-03-12 19:04:00',3310504139,1),(664605903,425667172,16463119,4108069,1,'2010-03-12 19:04:00',3310504139,1),(664605904,425669493,16455491,4108069,1,'2010-03-12 19:04:00',3310504139,1),(664605905,425621129,16518504,4108069,1,'2010-03-12 19:04:00',3310504160,1),(664605906,425615249,16531503,4108069,1,'2010-03-12 19:04:00',3310504117,1),(664605907,425616969,16528425,4108069,1,'2010-03-12 19:04:00',3310504160,1),(664605908,425612579,16525966,4108069,1,'2010-03-12 19:04:00',3310504117,1),(664605909,425615755,16522815,4108069,1,'2010-03-12 19:04:00',3310504117,1),(664605911,425621033,16525029,4108069,1,'2010-03-12 19:04:00',3310504160,1),(664605912,425620517,16532068,4108069,1,'2010-03-12 19:04:00',3310504160,1),(664605913,425622104,16528917,4108069,1,'2010-03-12 19:04:00',3310504160,1),(664605914,425623570,16526430,4108069,1,'2010-03-12 19:04:00',3310504160,1),(664605915,425629788,16519404,4108069,1,'2010-03-12 19:04:00',3310504160,1),(664605916,425625648,16516016,4108069,1,'2010-03-12 19:04:00',3310504160,1),(664605917,425635338,16515372,4108069,1,'2010-03-12 19:04:01',3310504160,1),(664605918,425632243,16510876,4108069,1,'2010-03-12 19:04:01',3310504160,1),(664605919,425624551,16522482,4108069,1,'2010-03-12 19:04:01',3310504160,1),(664605920,425625524,16525766,4108069,1,'2010-03-12 19:04:01',3310504160,1),(664605921,425627356,16525766,4108069,1,'2010-03-12 19:04:01',3310504160,1),(664605922,425629066,16526595,4108069,1,'2010-03-12 19:04:01',3310504160,1),(664605923,425630776,16530409,4108069,1,'2010-03-12 19:04:01',3310504160,1),(664605924,425633585,16534389,4108069,1,'2010-03-12 19:04:01',3310504160,1),(664605925,425647062,16506563,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605926,425649564,16506139,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605927,425638594,16506730,4108069,1,'2010-03-12 19:04:01',3310504160,1),(664605928,425643602,16501922,4108069,1,'2010-03-12 19:04:01',3310504160,1),(664605929,425647021,16497279,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605930,425649342,16492470,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605931,425652299,16506245,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605933,425655582,16506775,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605934,425657380,16506775,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605935,425660272,16506775,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605936,425662226,16506351,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605937,425664649,16505184,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605939,425652395,16487163,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605940,425656181,16480696,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605941,425639481,16512188,4108069,1,'2010-03-12 19:04:01',3310504160,1),(664605942,425641278,16510171,4108069,1,'2010-03-12 19:04:02',3310504160,1),(664605943,425644249,16508155,4108069,1,'2010-03-12 19:04:02',3310504160,1),(664605945,425652882,16529414,4108069,1,'2010-03-12 19:04:02',3310504161,1),(664605946,425612122,16538826,4108069,1,'2010-03-12 19:04:02',3310504119,1),(664605948,425613373,16535430,4108069,1,'2010-03-12 19:04:02',3310504119,1),(664605949,425612089,16545665,4108069,1,'2010-03-12 19:04:02',3310504119,1),(664605950,425616242,16541685,4108069,1,'2010-03-12 19:04:02',3310504119,1),(664605951,425617707,16539695,4108069,1,'2010-03-12 19:04:02',3310504162,1),(664605952,425618807,16536711,4108069,1,'2010-03-12 19:04:02',3310504162,1),(664605953,425637127,16538866,4108069,1,'2010-03-12 19:04:02',3310504162,1),(664605954,425615998,16589110,4108069,1,'2010-03-12 19:04:02',3310504119,1),(664605955,425638592,16539695,4108069,1,'2010-03-12 19:04:02',3310504162,1),(664605956,425640180,16539695,4108069,1,'2010-03-12 19:04:02',3310504162,1),(664605958,425643722,16538369,4108069,1,'2010-03-12 19:04:02',3310504162,1),(664605959,425648363,16534721,4108069,1,'2010-03-12 19:04:02',3310504163,1),(664605960,425650625,16561134,4108069,1,'2010-03-12 19:04:02',3310504163,1),(664605961,425651407,16551370,4108069,1,'2010-03-12 19:04:02',3310504163,1),(664605962,425650547,16558268,4108069,1,'2010-03-12 19:04:02',3310504163,1),(664605963,425651954,16542668,4108069,1,'2010-03-12 19:04:02',3310504163,1),(664605964,425645857,16583102,4108069,1,'2010-03-12 19:04:02',3310504163,1),(664605965,425647733,16575992,4108069,1,'2010-03-12 19:04:02',3310504163,1),(664605966,425649765,16568563,4108069,1,'2010-03-12 19:04:02',3310504163,1),(664605968,425645857,16581404,4108069,1,'2010-03-12 19:04:03',3310504163,1),(664605969,425673090,16492236,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605970,425674419,16490432,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605971,425675748,16489371,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605972,425676608,16488840,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605973,425678014,16487779,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605974,425666290,16503592,4108069,1,'2010-03-12 19:04:03',3310504161,1),(664605976,425667775,16501575,4108069,1,'2010-03-12 19:04:03',3310504161,1),(664605977,425668713,16499665,4108069,1,'2010-03-12 19:04:03',3310504161,1),(664605978,425670042,16497118,4108069,1,'2010-03-12 19:04:03',3310504161,1),(664605979,425671214,16495102,4108069,1,'2010-03-12 19:04:03',3310504161,1),(664605980,425679421,16486611,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605981,425680437,16484807,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605982,425681766,16483428,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605983,425682860,16483003,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605984,425683564,16483640,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605985,425685361,16485656,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605986,425686690,16486824,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605987,425688800,16488734,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605988,425691927,16489901,4108069,1,'2010-03-12 19:04:04',3310504164,1),(664605989,425694740,16490538,4108069,1,'2010-03-12 19:04:04',3310504164,1),(664605990,425699039,16489689,4108069,1,'2010-03-12 19:04:04',3310504164,1),(664605991,425703338,16488840,4108069,1,'2010-03-12 19:04:04',3310504165,1),(664605992,425707245,16487673,4108069,1,'2010-03-12 19:04:04',3310504165,1),(664605993,425709746,16486399,4108069,1,'2010-03-12 19:04:04',3310504165,1),(664605994,425713263,16485126,4108069,1,'2010-03-12 19:04:04',3310504165,1),(664605996,425716155,16485232,4108069,1,'2010-03-12 19:04:05',3310504165,1),(664605997,425719047,16485232,4108069,1,'2010-03-12 19:04:05',3310504165,1),(664605998,425619784,16592427,4108069,1,'2010-03-12 19:04:05',3310504168,1),(664605999,425623204,16595246,4108069,1,'2010-03-12 19:04:05',3310504168,1),(664606000,425624669,16598065,4108069,1,'2010-03-12 19:04:05',3310504168,1),(664606001,425626013,16600055,4108069,1,'2010-03-12 19:04:05',3310504168,1),(664606002,425627723,16601215,4108069,1,'2010-03-12 19:04:05',3310504168,1),(664606004,425629677,16600552,4108069,1,'2010-03-12 19:04:05',3310504168,1),(664606005,425631264,16600055,4108069,1,'2010-03-12 19:04:05',3310504168,1),(664606006,425633829,16599391,4108069,1,'2010-03-12 19:04:05',3310504168,1),(664606007,425635295,16599391,4108069,1,'2010-03-12 19:04:05',3310504168,1),(664606008,425636638,16600718,4108069,1,'2010-03-12 19:04:05',3310504168,1),(664606010,425635928,16679546,4108069,1,'2010-03-12 19:04:05',3310504170,1),(664606011,425634211,16685505,4108069,1,'2010-03-12 19:04:05',3310504170,1),(664606012,425632493,16692760,4108069,1,'2010-03-12 19:04:05',3310504170,1),(664606013,425631158,16698201,4108069,1,'2010-03-12 19:04:05',3310504170,1),(664606014,425642035,16654672,4108069,1,'2010-03-12 19:04:05',3310504170,1),(664606015,425643180,16660373,4108069,1,'2010-03-12 19:04:05',3310504170,1),(664606016,425643180,16665554,4108069,1,'2010-03-12 19:04:05',3310504170,1),(664606018,425642607,16669700,4108069,1,'2010-03-12 19:04:06',3310504170,1),(664606019,425640508,16673587,4108069,1,'2010-03-12 19:04:06',3310504170,1),(664606020,425637837,16677214,4108069,1,'2010-03-12 19:04:06',3310504170,1),(664606021,425721235,16485762,4108069,1,'2010-03-12 19:04:06',3310504165,1),(664606022,425723423,16485762,4108069,1,'2010-03-12 19:04:06',3310504165,1),(664606023,425725455,16485762,4108069,1,'2010-03-12 19:04:06',3310504165,1),(664606024,425728035,16486718,4108069,1,'2010-03-12 19:04:06',3310504176,1),(664606025,425732567,16488309,4108069,1,'2010-03-12 19:04:06',3310504176,1),(664606027,425735225,16489689,4108069,1,'2010-03-12 19:04:06',3310504176,1),(664606028,425739836,16491918,4108069,1,'2010-03-12 19:04:06',3310504176,1),(664606029,425743743,16494465,4108069,1,'2010-03-12 19:04:06',3310504176,1),(664606030,425747260,16496906,4108069,1,'2010-03-12 19:04:06',3310504176,1),(664606031,425751636,16500089,4108069,1,'2010-03-12 19:04:06',3310504176,1),(664606033,425753590,16502106,4108069,1,'2010-03-12 19:04:06',3310504176,1),(664606034,425755075,16503273,4108069,1,'2010-03-12 19:04:06',3310504177,1),(664606035,425756794,16504122,4108069,1,'2010-03-12 19:04:06',3310504177,1),(664606036,425759139,16504441,4108069,1,'2010-03-12 19:04:06',3310504177,1),(664606037,425761405,16504122,4108069,1,'2010-03-12 19:04:06',3310504177,1),(664606039,425764844,16501469,4108069,1,'2010-03-12 19:04:06',3310504177,1),(664606040,425767188,16498710,4108069,1,'2010-03-12 19:04:06',3310504177,1),(664606041,425771721,16492979,4108069,1,'2010-03-12 19:04:06',3310504177,1),(664606042,425774065,16491069,4108069,1,'2010-03-12 19:04:06',3310504177,1),(664606043,425763978,16502523,4108069,1,'2010-03-12 19:04:06',3310504177,1),(664606044,425769721,16495627,4108069,1,'2010-03-12 19:04:07',3310504177,1),(664606045,425768393,16497221,4108069,1,'2010-03-12 19:04:07',3310504177,1),(664606046,425775159,16490432,4108069,1,'2010-03-12 19:04:07',3310504177,1),(664606048,425600852,16712995,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606049,425603103,16715168,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606050,425604954,16716934,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606051,425606855,16718157,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606052,425609357,16718157,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606054,425609307,16732556,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606055,425608706,16736563,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606056,425610757,16718157,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606057,425613209,16718157,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606058,425614359,16718428,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606059,425615260,16719243,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606060,425615010,16721009,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606061,425613759,16722911,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606062,425612008,16725832,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606063,425631921,16702865,4108069,1,'2010-03-12 19:04:07',3310504512,1),(664606064,425632684,16705974,4108069,1,'2010-03-12 19:04:07',3310504512,1),(664606066,425634211,16707269,4108069,1,'2010-03-12 19:04:07',3310504512,1),(664606067,425636883,16707269,4108069,1,'2010-03-12 19:04:07',3310504512,1),(664606068,425611007,16727598,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664651800,425198662,16949126,4108991,1,'2010-03-12 22:26:21',3310493536,1),(664651806,425191454,16928967,4108991,1,'2010-03-12 22:26:21',3310493536,1),(664651809,425255889,16978902,4108991,1,'2010-03-12 22:26:22',3310493542,1),(664651811,425268783,17005201,4108991,1,'2010-03-12 22:26:22',3310493543,1),(664651813,425258091,16985314,4108991,1,'2010-03-12 22:26:22',3310493542,1),(664651814,425272227,17016123,4108991,1,'2010-03-12 22:26:22',3310493543,1),(664651816,425260587,17132954,4108991,1,'2010-03-12 22:26:22',3310493551,1),(664651818,425298575,16965481,4108991,1,'2010-03-12 22:26:22',3310493552,1),(664651819,425317992,17004329,4108991,1,'2010-03-12 22:26:22',3310493555,1),(664651821,425321754,17009714,4108991,1,'2010-03-12 22:26:22',3310493555,1),(664651823,425214988,17144946,4108991,1,'2010-03-12 22:26:22',3310493633,1),(664651824,425253838,17236284,4108991,1,'2010-03-12 22:26:22',3310493638,1),(664651826,425239571,17224313,4108991,1,'2010-03-12 22:26:22',3310493638,1),(664651828,425280701,17202245,4108991,1,'2010-03-12 22:26:22',3310493639,1),(664651829,425264120,17240557,4108991,1,'2010-03-12 22:26:22',3310493639,1),(664651832,425283581,17200875,4108991,1,'2010-03-12 22:26:22',3310493639,1),(664651834,425319551,17182165,4108991,1,'2010-03-12 22:26:22',3310493649,1),(664651836,425309478,17196318,4108991,1,'2010-03-12 22:26:22',3310493650,1),(664651837,425334272,17269211,4108991,1,'2010-03-12 22:26:22',3310493657,1),(664651839,425347097,17254884,4108991,1,'2010-03-12 22:26:22',3310493660,1),(664651841,425371726,17262329,4108991,1,'2010-03-12 22:26:22',3310493661,1),(665238087,425658572,14464436,4115604,1,'2010-03-13 17:05:52',3310501995,1),(665238091,425664492,14474049,4115604,1,'2010-03-13 17:05:52',3310501995,1),(665238092,425667239,14493523,4115604,1,'2010-03-13 17:05:52',3310501995,1),(665238096,425674197,14507694,4115604,1,'2010-03-13 17:05:52',3310502084,1),(665240662,425672366,14500982,4115657,1,'2010-03-13 17:11:32',3310501998,1),(666793593,425388567,16614420,4133447,1,'2010-03-15 12:47:08',3310493181,1),(666793594,425546210,16163470,4133447,1,'2010-03-15 12:47:08',3310503993,1),(666793595,425547414,16164034,4133447,1,'2010-03-15 12:47:08',3310503993,1),(666793596,425546791,16165105,4133447,1,'2010-03-15 12:47:08',3310503993,1),(666793597,425547360,16162001,4133447,1,'2010-03-15 12:47:09',3310503993,1),(666793598,425489306,16470723,4133447,1,'2010-03-15 12:47:09',3310504079,1),(666793599,425489094,16471502,4133447,1,'2010-03-15 12:47:09',3310504079,1),(666793600,425489626,16471473,4159615,1,'2010-03-18 11:15:41',3310504079,2),(666793601,425488817,16470779,4159615,1,'2010-03-18 11:15:41',3310504079,2),(666793602,425527445,16281598,4159615,1,'2010-03-18 11:15:41',3310504080,2),(666793603,425528151,16283055,4133447,1,'2010-03-15 12:47:09',3310504080,1),(666793604,425464893,16589234,4133447,1,'2010-03-15 12:47:09',3310504102,1),(666793605,425426490,16610980,4133447,1,'2010-03-15 12:47:09',3310504105,1),(666793606,425425321,16606075,4133447,1,'2010-03-15 12:47:09',3310504105,1),(666793607,425426087,16606738,4159615,1,'2010-03-18 11:15:41',3310504105,2),(666793608,425424343,16611182,4133447,1,'2010-03-15 12:47:09',3310504104,1),(666793609,425466097,16591151,4133447,1,'2010-03-15 12:47:09',3310504108,1),(666793610,425544735,16533601,4159615,1,'2010-03-18 11:15:40',3310504113,2),(666793611,425545665,16534503,4133447,1,'2010-03-15 12:47:09',3310504113,1),(666793612,425677646,16410755,4133447,1,'2010-03-15 12:47:09',3310504140,1),(666793613,425678230,16412604,4133447,1,'2010-03-15 12:47:09',3310504140,1),(666793614,425679462,16411107,4133447,1,'2010-03-15 12:47:09',3310504140,1),(666793615,425680500,16414894,4133447,1,'2010-03-15 12:47:09',3310504140,1),(666793616,425648663,16630216,4133447,1,'2010-03-15 12:47:09',3310504169,1),(666793617,425647054,16630216,4133447,1,'2010-03-15 12:47:09',3310504169,1),(666793618,425645757,16641558,4133447,1,'2010-03-15 12:47:09',3310504169,1),(666793619,425642215,16650964,4133447,1,'2010-03-15 12:47:10',3310504170,1),(666793620,425536628,16805993,4133447,1,'2010-03-15 12:47:10',3310504467,1),(666793621,425535997,16806489,4133447,1,'2010-03-15 12:47:10',3310504467,1),(666793622,425608331,16706959,4133447,1,'2010-03-15 12:47:10',3310504469,1),(666793623,425609792,16705471,4133447,1,'2010-03-15 12:47:10',3310504469,1),(668878334,425665203,14449171,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878337,425664136,14456895,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878339,425661173,14457056,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878340,425657855,14462286,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878342,425656077,14464539,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878344,425654773,14466068,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878346,425653944,14468964,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878348,425654003,14471217,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878349,425654536,14474114,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878351,425655544,14478781,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878353,425656314,14483769,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878354,425656788,14488356,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878356,425657203,14492781,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878358,425657440,14494551,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878359,425658210,14496724,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878361,425659514,14498977,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878362,425662062,14501632,4161539,1,'2010-03-18 16:04:14',3310501995,1),(668878364,425668213,14456626,4161539,1,'2010-03-18 16:04:14',3310501995,1),(668878366,425672935,14457883,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878367,425676917,14459014,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878369,425665559,14463654,4161539,1,'2010-03-18 16:04:14',3310501995,1),(668878371,425667574,14470895,4161539,1,'2010-03-18 16:04:14',3310501995,1),(668878372,425679509,14460146,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878374,425680806,14460146,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878376,425682195,14460146,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878377,425680898,14460523,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878379,425684046,14460900,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878380,425681917,14463792,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878382,425682472,14467438,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878383,425683028,14472592,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878385,425685991,14460774,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878386,425687843,14460774,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878388,425689417,14461655,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878389,425690898,14464672,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878390,425691917,14467312,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878391,425692657,14472592,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878392,425689855,14461642,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878393,425692284,14464056,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878394,425669529,14476769,4161539,1,'2010-03-18 16:04:14',3310501995,1),(668878395,425670892,14480068,4161539,1,'2010-03-18 16:04:14',3310501995,1),(668878396,425673381,14484574,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878397,425675633,14487873,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878398,425676996,14490528,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878399,425677766,14494230,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878400,425678418,14499299,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878401,425684139,14477998,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878402,425686176,14482273,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878403,425688213,14488056,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878404,425689324,14490319,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878405,425689972,14493588,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878406,425690435,14496354,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878407,425690528,14500251,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878408,425693491,14477370,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878409,425693768,14481267,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878410,425693861,14487176,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878411,425694139,14489439,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878412,425694046,14492834,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878413,425694046,14496228,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878414,425694416,14499874,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878415,425694655,14467757,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878416,425696788,14473068,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878417,425698743,14479746,4161539,1,'2010-03-18 16:04:15',3310501998,1),(668878419,425700462,14485298,4161539,1,'2010-03-18 16:04:15',3310501999,1),(668878420,425702180,14490931,4161539,1,'2010-03-18 16:04:15',3310501999,1),(668878422,425704017,14495356,4161539,1,'2010-03-18 16:04:15',3310501999,1),(668878423,425705617,14499299,4161539,1,'2010-03-18 16:04:15',3310501999,1),(668878425,425664670,14503483,4161539,1,'2010-03-18 16:04:15',3310502081,1),(668878427,425667514,14504207,4161539,1,'2010-03-18 16:04:15',3310502081,1),(668878429,425669885,14505092,4161539,1,'2010-03-18 16:04:15',3310502081,1),(668878430,425672018,14506460,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878432,425673914,14508632,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878434,425675396,14512092,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878435,425677114,14517644,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878437,425678477,14522391,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878439,425685435,14511189,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878440,425684232,14513704,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878442,425679188,14505414,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878444,425679959,14510322,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878446,425680433,14515069,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878447,425690343,14505406,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878449,425692194,14506286,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878450,425689509,14507418,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878452,425687009,14508675,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878454,425691917,14509178,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878456,425691361,14513704,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878457,425692483,14508096,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878459,425683861,14517727,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878461,425683676,14522630,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878462,425683954,14526150,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878464,425680433,14518851,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878465,425680077,14521989,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878467,425691176,14519613,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878469,425690805,14523510,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878471,425684232,14530550,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878472,425684880,14535454,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878488,425685806,14541488,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878490,425686731,14546894,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878492,425688028,14553432,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878493,425691083,14529796,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878495,425692009,14537465,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878497,425687129,14550151,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878498,425694879,14503394,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878500,425696361,14507669,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878501,425698583,14513452,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878503,425699787,14518607,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878505,425700990,14524264,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878506,425706802,14502115,4161539,1,'2010-03-18 16:04:16',3310501999,1),(668878508,425707810,14506218,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878510,425708461,14511851,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878511,425709113,14519092,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878513,425709647,14528265,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878515,425701638,14530802,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878516,425702564,14537339,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878518,425702935,14541614,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878520,425702935,14544631,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878521,425703490,14551295,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878523,425693491,14544757,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878525,425694324,14548277,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878526,425694509,14550666,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878528,425695435,14554186,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878530,425695805,14556449,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878531,425706091,14548059,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878533,425704965,14548381,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878534,425704017,14548783,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878536,425703484,14549427,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878538,425710061,14533576,4161539,1,'2010-03-18 16:04:17',3310502085,1),(668878539,425710595,14537921,4161539,1,'2010-03-18 16:04:17',3310502085,1),(668878541,425711365,14542024,4161539,1,'2010-03-18 16:04:17',3310502085,1),(668878543,425711780,14544760,4161539,1,'2010-03-18 16:04:17',3310502085,1),(668878544,425712669,14547978,4161539,1,'2010-03-18 16:04:17',3310502085,1),(668878546,425712669,14548864,4161539,1,'2010-03-18 16:04:17',3310502085,1),(668878548,425712609,14549910,4161539,1,'2010-03-18 16:04:17',3310502085,1),(668878549,425711898,14550151,4161539,1,'2010-03-18 16:04:17',3310502085,1),(668878551,425710950,14549829,4161539,1,'2010-03-18 16:04:17',3310502085,1),(668878553,425708343,14548542,4161539,1,'2010-03-18 16:04:17',3310502085,1),(668878554,425690250,14561855,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878556,425692102,14569399,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878558,425691040,14592233,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878560,425686655,14558278,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878562,425687129,14564876,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878565,425688551,14573807,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878567,425690921,14584911,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878569,425691040,14593440,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878571,425691632,14600520,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878573,425691751,14605187,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878576,425691988,14608889,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878579,425704231,14558084,4161539,1,'2010-03-18 16:04:17',3310502087,1),(668878580,425705897,14566381,4161539,1,'2010-03-18 16:04:17',3310502087,1),(668878583,425693028,14575056,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878586,425694046,14579834,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878588,425695898,14559592,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878591,425696639,14561604,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878592,425699231,14564747,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878595,425699783,14564899,4161539,1,'2010-03-18 16:04:17',3310502087,1),(668878598,425707101,14572165,4161539,1,'2010-03-18 16:04:17',3310502087,1),(668878599,425708675,14578451,4161539,1,'2010-03-18 16:04:17',3310502087,1),(668878602,425709416,14583102,4161539,1,'2010-03-18 16:04:17',3310502087,1),(668878604,425695157,14586748,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878607,425696083,14592029,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878608,425696639,14594543,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878611,425697892,14590984,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878613,425696906,14590160,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878615,425693055,14594808,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878617,425699789,14594125,4161539,1,'2010-03-18 16:04:17',3310502087,1),(668878620,425701306,14597267,4161539,1,'2010-03-18 16:04:17',3310502087,1),(668878622,425698755,14600120,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878625,425699423,14601586,4161539,1,'2010-03-18 16:04:17',3310502087,1),(668878629,425695603,14598992,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878630,425694299,14599153,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878633,425695484,14601969,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878634,425697677,14606233,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878636,425692758,14611061,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878638,425699726,14603286,4161539,1,'2010-03-18 16:04:17',3310502087,1),(668878639,425699874,14604764,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878641,425699922,14607220,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878642,425699899,14608609,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878644,425700036,14610412,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878645,425702292,14600099,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878647,425703316,14603034,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878649,425704491,14606433,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878650,425705515,14609368,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878652,425706350,14611325,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878653,425699632,14610900,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878655,425711082,14588006,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878657,425711916,14592029,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878658,425712934,14597686,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878660,425714138,14604852,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878661,425700128,14612784,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878663,425700343,14614119,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878664,425700877,14617015,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878666,425703365,14623694,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878668,425695247,14616693,4161539,1,'2010-03-18 16:04:18',3310502092,1),(668878669,425697677,14621843,4161539,1,'2010-03-18 16:04:18',3310502092,1),(668878671,425700166,14626993,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878673,425703010,14633510,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878674,425705321,14638901,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878676,425707753,14613951,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878678,425709080,14616526,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878679,425710104,14618998,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878681,425710711,14621212,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878683,425711583,14625332,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878684,425715526,14612522,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878686,425716545,14615539,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878687,425717378,14618682,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878689,425718489,14622831,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878691,425712114,14627495,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878692,425712569,14628988,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878694,425713138,14630636,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878696,425712872,14635116,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878697,425706506,14629406,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878699,425709647,14634878,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878700,425711898,14638257,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878702,425712846,14638257,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878703,425719322,14628488,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878705,425720063,14635277,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878707,425713631,14633005,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878708,425713783,14635940,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878710,425714150,14638177,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878712,425714742,14637131,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878713,425714979,14635843,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878715,425715394,14633993,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878716,425716520,14631901,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878718,425717764,14630613,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878720,425719127,14631016,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878721,425719779,14631820,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878723,425707513,14643005,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878725,425709824,14647430,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878726,425711069,14651373,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878728,425711957,14658775,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878729,425713380,14666097,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878731,425708521,14643890,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878745,425712017,14647993,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878746,425714565,14652177,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878748,425716402,14657166,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878750,425717764,14663844,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878752,425715098,14674224,4161539,1,'2010-03-18 16:04:19',3310502095,1),(668878753,425717053,14681787,4161539,1,'2010-03-18 16:04:19',3310502095,1),(668878755,425718239,14686535,4161539,1,'2010-03-18 16:04:19',3310502095,1),(668878757,425719187,14690880,4161539,1,'2010-03-18 16:04:19',3310502095,1),(668878759,425718179,14669396,4161539,1,'2010-03-18 16:04:19',3310502095,1),(668878761,425718831,14676075,4161539,1,'2010-03-18 16:04:19',3310502095,1),(668878762,425719305,14682351,4161539,1,'2010-03-18 16:04:19',3310502095,1),(668878764,425719957,14687581,4161539,1,'2010-03-18 16:04:19',3310502095,1),(668878766,425722841,14645587,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878767,425723952,14647724,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878769,425724507,14649484,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878771,425724878,14651496,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878772,425721382,14640407,4161539,1,'2010-03-18 16:04:20',3310502093,1),(668878774,425721737,14642273,4161539,1,'2010-03-18 16:04:20',3310502093,1),(668878775,425722070,14643575,4161539,1,'2010-03-18 16:04:20',3310502093,1),(668878777,425725537,14654523,4161539,1,'2010-03-18 16:04:20',3310502093,1),(668878779,425725705,14655879,4161539,1,'2010-03-18 16:04:20',3310502093,1),(668878780,425725171,14657246,4161539,1,'2010-03-18 16:04:20',3310502093,1),(668878782,425723571,14659741,4161539,1,'2010-03-18 16:04:20',3310502093,1),(668878783,425722860,14660706,4161539,1,'2010-03-18 16:04:20',3310502093,1),(668878785,425722327,14661913,4161539,1,'2010-03-18 16:04:20',3310502093,1),(668878787,425722683,14664247,4161539,1,'2010-03-18 16:04:20',3310502093,1),(668878788,425728312,14662235,4161539,1,'2010-03-18 16:04:20',3310502104,1),(668878790,425729141,14659178,4161539,1,'2010-03-18 16:04:20',3310502104,1),(668878792,425731571,14661028,4161539,1,'2010-03-18 16:04:20',3310502104,1),(668878794,425733230,14663442,4161539,1,'2010-03-18 16:04:20',3310502104,1),(668878795,425734533,14666017,4161539,1,'2010-03-18 16:04:20',3310502104,1),(668878797,425722979,14668592,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878799,425724045,14676397,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878800,425725053,14682914,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878802,425725645,14686696,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878804,425726830,14690880,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878805,425727719,14693213,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878807,425721024,14692087,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878809,425729793,14667867,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878810,425730563,14672132,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878812,425732223,14676236,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878814,425733645,14681144,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878816,425734474,14685408,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878817,425735600,14689753,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878819,425736311,14671730,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878820,425738563,14678247,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878822,425740222,14683397,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878823,425741525,14686696,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878825,425742533,14688949,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878826,425743718,14689995,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878828,425745732,14692006,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878830,425725722,14706909,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878831,425726830,14698846,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878833,425726179,14701501,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878834,425725764,14703995,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878836,425720786,14696834,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878837,425722327,14702708,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878839,425723275,14706811,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878840,425722149,14698202,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878841,425723216,14703271,4161539,1,'2010-03-18 16:04:21',3310502095,1),(668878843,425723512,14704397,4161539,1,'2010-03-18 16:04:21',3310502095,1),(668878845,425723512,14706731,4161539,1,'2010-03-18 16:04:21',3310502095,1),(668878847,425728016,14695225,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878848,425727660,14697317,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878850,425722979,14708421,4161539,1,'2010-03-18 16:04:21',3310502095,1),(668878852,425737141,14694420,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878854,425739274,14699811,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878855,425739925,14700857,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878857,425741762,14702627,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878859,425744073,14704076,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878860,425745673,14703995,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878862,425746977,14703271,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878863,425747806,14694179,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878865,425749524,14697317,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878867,425749998,14698363,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878869,425749998,14699892,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878870,425749347,14700696,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878872,425747865,14702627,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668901202,426185361,14830769,4161868,1,'2010-03-18 16:47:26',3310502386,1),(668901203,426171038,14827441,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901204,426170671,14825279,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901205,426171159,14824667,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901206,426172674,14823934,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901207,426175267,14822678,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901208,426177706,14822364,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901209,426179220,14822853,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901210,426180068,14824283,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901211,426180992,14826062,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901212,426181955,14826970,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901213,426183118,14827406,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901214,426184001,14827406,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901215,426185926,14826643,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901216,426195553,14802930,4161868,1,'2010-03-18 16:47:27',3310502387,1),(668901217,426199444,14801676,4161868,1,'2010-03-18 16:47:27',3310502387,1),(668901218,426202132,14800858,4161868,1,'2010-03-18 16:47:27',3310502387,1),(668901219,426204138,14799877,4161868,1,'2010-03-18 16:47:27',3310502387,1),(668901220,426205502,14798514,4161868,1,'2010-03-18 16:47:27',3310502387,1),(668901221,426205822,14796443,4161868,1,'2010-03-18 16:47:27',3310502387,1),(668901222,426206103,14792954,4161868,1,'2010-03-18 16:47:27',3310502387,1),(668901223,426206183,14790555,4161868,1,'2010-03-18 16:47:27',3310502387,1),(668901224,426206825,14788320,4161868,1,'2010-03-18 16:47:27',3310502387,1),(668901225,426207628,14786412,4161868,1,'2010-03-18 16:47:27',3310502387,1),(668901227,426208350,14784995,4161868,1,'2010-03-18 16:47:27',3310502387,1),(668901228,426209473,14784123,4161868,1,'2010-03-18 16:47:28',3310502387,1),(668901229,426211157,14784123,4161868,1,'2010-03-18 16:47:28',3310502387,1),(668901230,426213725,14784123,4161868,1,'2010-03-18 16:47:28',3310502387,1),(668901231,426187565,14827608,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901232,426191482,14824613,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901233,426197236,14821120,4161868,1,'2010-03-18 16:47:28',3310502387,1),(668901234,426188052,14825280,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901235,426190218,14822554,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901236,426191301,14820864,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901237,426191622,14818575,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901238,426190980,14816830,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901239,426190740,14814922,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901240,426190740,14812306,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901241,426190900,14809962,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901242,426191422,14808054,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901243,426192104,14806255,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901244,426193467,14804510,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901245,426201520,14819290,4161868,1,'2010-03-18 16:47:28',3310502387,1),(668901246,426207886,14817793,4161868,1,'2010-03-18 16:47:28',3310502387,1),(668901247,426212538,14815963,4161868,1,'2010-03-18 16:47:28',3310502387,1),(668901248,426224779,14803652,4161868,1,'2010-03-18 16:47:28',3310502390,1),(668901249,426215169,14784014,4161868,1,'2010-03-18 16:47:28',3310502387,1),(668901250,426216693,14783687,4161868,1,'2010-03-18 16:47:28',3310502387,1),(668901251,426218418,14784723,4161868,1,'2010-03-18 16:47:28',3310502387,1),(668901252,426219782,14785922,4161868,1,'2010-03-18 16:47:28',3310502387,1),(668901253,426221867,14786958,4161868,1,'2010-03-18 16:47:28',3310502390,1),(668901254,426224074,14787666,4161868,1,'2010-03-18 16:47:28',3310502390,1),(668901255,426225437,14788484,4161868,1,'2010-03-18 16:47:28',3310502390,1),(668901256,426228696,14798162,4161868,1,'2010-03-18 16:47:28',3310502390,1),(668901257,426231022,14793172,4161868,1,'2010-03-18 16:47:28',3310502390,1),(668901258,426234572,14790843,4161868,1,'2010-03-18 16:47:28',3310502390,1),(668901259,426229048,14789411,4161868,1,'2010-03-18 16:47:28',3310502390,1),(668901260,426232577,14790501,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901261,426236588,14791155,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901262,426241281,14791046,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901263,426224657,14830769,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901264,426228084,14829105,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901265,426216945,14812802,4161868,1,'2010-03-18 16:47:29',3310502387,1),(668901266,426220495,14808643,4161868,1,'2010-03-18 16:47:29',3310502387,1),(668901267,426231022,14827774,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901268,426233103,14823948,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901269,426234817,14820787,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901270,426236408,14819623,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901271,426238856,14818458,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901272,426254280,14803652,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901273,426254280,14798661,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901274,426255259,14794502,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901275,426244731,14791755,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901276,426248501,14792245,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901277,426251590,14792245,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901278,426254759,14790991,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901280,426257165,14789738,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901281,426260585,14788210,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901282,426265521,14782747,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901283,426266989,14781416,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901284,426268360,14781949,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901285,426266451,14781941,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901286,426268106,14781532,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901287,426265325,14789002,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901288,426265423,14786074,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901289,426264317,14790344,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901290,426263142,14788073,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901291,426264145,14787324,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901292,426265348,14785757,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901293,426265749,14783712,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901294,426269144,14784078,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901295,426269144,14786873,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901296,426255924,14793794,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901297,426258176,14793794,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901298,426261114,14795124,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901299,426256850,14792173,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901300,426259910,14791009,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901301,426261869,14790510,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901302,426263268,14799516,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901303,426264835,14802577,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901304,426267969,14801513,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901305,426266500,14794592,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901306,426269242,14790466,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901307,426266765,14791841,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901308,426268968,14795002,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901309,426244242,14816795,4161868,1,'2010-03-18 16:47:30',3310502390,1),(668901310,426250118,14814798,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901311,426252933,14812636,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901312,426254892,14811138,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901313,426254892,14807811,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901314,426254769,14811305,4161868,1,'2010-03-18 16:47:30',3310502391,1);
INSERT INTO `current_nodes` VALUES (668901315,426266500,14807368,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901316,426267479,14808300,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901317,426268458,14807635,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901318,426269046,14806171,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901319,426257952,14811305,4161868,1,'2010-03-18 16:47:31',3310502391,1),(668901320,426262113,14811637,4161868,1,'2010-03-18 16:47:31',3310502391,1),(668901321,426265786,14811637,4161868,1,'2010-03-18 16:47:31',3310502391,1),(668901322,426173119,14837589,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901323,426171528,14831767,4161868,1,'2010-03-18 16:47:31',3310502386,1),(668901324,426175568,14848403,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901325,426185606,14844576,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901326,426178016,14853726,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901327,426184137,14854392,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901328,426187075,14855057,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901329,426175568,14847072,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901330,426178506,14845741,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901331,426181444,14843745,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901332,426183035,14841915,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901333,426183770,14837257,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901334,426183770,14832599,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901335,426174955,14844743,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901336,426181861,14863894,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901337,426184120,14863510,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901338,426186610,14863964,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901339,426195399,14840750,4161868,1,'2010-03-18 16:47:31',3310502393,1),(668901340,426190136,14855722,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901341,426194420,14855722,4161868,1,'2010-03-18 16:47:31',3310502393,1),(668901342,426196868,14856721,4161868,1,'2010-03-18 16:47:31',3310502393,1),(668901343,426198582,14858717,4161868,1,'2010-03-18 16:47:31',3310502393,1),(668901344,426200296,14854558,4161868,1,'2010-03-18 16:47:31',3310502393,1),(668901345,426200051,14847737,4161868,1,'2010-03-18 16:47:31',3310502393,1),(668901347,426200541,14842746,4161868,1,'2010-03-18 16:47:31',3310502393,1),(668901348,426202867,14838255,4161868,1,'2010-03-18 16:47:31',3310502393,1),(668901349,426201031,14858717,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901350,426201031,14856554,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901351,426201643,14839586,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901352,426203846,14837756,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901353,426206172,14837090,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901354,426208988,14837090,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901355,426212170,14836425,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901356,426214252,14834928,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901357,426188639,14864069,4161868,1,'2010-03-18 16:47:32',3310502392,1),(668901358,426190256,14863510,4161868,1,'2010-03-18 16:47:32',3310502392,1),(668901359,426192002,14863789,4161868,1,'2010-03-18 16:47:32',3310502392,1),(668901360,426193260,14864801,4161868,1,'2010-03-18 16:47:32',3310502392,1),(668901361,426193568,14871639,4161868,1,'2010-03-18 16:47:32',3310502392,1),(668901362,426194261,14866092,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901363,426194543,14867592,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901364,426194543,14868953,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901365,426194158,14870348,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901366,426193491,14872965,4161868,1,'2010-03-18 16:47:32',3310502392,1),(668901367,426193799,14874326,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901368,426194672,14876000,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901369,426195981,14877745,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901370,426197727,14879698,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901371,426199627,14881652,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901372,426197553,14880214,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901373,426198630,14885271,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901374,426201809,14883990,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901375,426199707,14891792,4161868,1,'2010-03-18 16:47:32',3310502395,1),(668901376,426204658,14888246,4161868,1,'2010-03-18 16:47:32',3310502395,1),(668901377,426207174,14891944,4161868,1,'2010-03-18 16:47:32',3310502395,1),(668901378,426201176,14897914,4161868,1,'2010-03-18 16:47:32',3310502395,1),(668901379,426208920,14894770,4161868,1,'2010-03-18 16:47:32',3310502395,1),(668901380,426210666,14897735,4161868,1,'2010-03-18 16:47:32',3310502395,1),(668901381,426211821,14900108,4161868,1,'2010-03-18 16:47:32',3310502395,1),(668901382,426202254,14902705,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901383,426203233,14905234,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901384,426204996,14907497,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901385,426212642,14903073,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901386,426213438,14907295,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901387,426214234,14911830,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901388,426207738,14910691,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901389,426208913,14913086,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901390,426209697,14916280,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901391,426209892,14919874,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901392,426211753,14924532,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901393,426214299,14928258,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901394,426219638,14832266,4161868,1,'2010-03-18 16:47:33',3310502393,1),(668901395,426229329,14854340,4161868,1,'2010-03-18 16:47:33',3310502396,1),(668901396,426230269,14856043,4161868,1,'2010-03-18 16:47:33',3310502396,1),(668901397,426230112,14858279,4161868,1,'2010-03-18 16:47:33',3310502396,1),(668901398,426230817,14861579,4161868,1,'2010-03-18 16:47:33',3310502396,1),(668901399,426232149,14865093,4161868,1,'2010-03-18 16:47:33',3310502396,1),(668901400,426235440,14870629,4161868,1,'2010-03-18 16:47:33',3310502396,1),(668901401,426237712,14873611,4161868,1,'2010-03-18 16:47:33',3310502396,1),(668901402,426239435,14877337,4161868,1,'2010-03-18 16:47:33',3310502396,1),(668901403,426240532,14881489,4161868,1,'2010-03-18 16:47:33',3310502396,1),(668901404,426241080,14887452,4161868,1,'2010-03-18 16:47:33',3310502398,1),(668901405,426241864,14891284,4161868,1,'2010-03-18 16:47:33',3310502398,1),(668901406,426241557,14913577,4161868,1,'2010-03-18 16:47:33',3310502398,1),(668901407,426215261,14915493,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901408,426216159,14918773,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901409,426217546,14922890,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901410,426218752,14927599,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901411,426223005,14925518,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901412,426224648,14922593,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901413,426225782,14919601,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901414,426226306,14917803,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901415,426227025,14916826,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901416,426227703,14916547,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901417,426219214,14929030,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901418,426219358,14929805,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901419,426219473,14930163,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901420,426219736,14930073,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901421,426219933,14929783,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901422,426220048,14929247,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901423,426220590,14928778,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901424,426221198,14928711,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901425,426217531,14932650,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901426,426218706,14932650,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901427,426219098,14932384,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901428,426219686,14931452,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901429,426221872,14927885,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901430,426222134,14934114,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901432,426224288,14936509,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901433,426228627,14916547,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901434,426229531,14916659,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901435,426230311,14916714,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901436,426231400,14916687,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901437,426232652,14916714,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901438,426234809,14916156,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901439,426236370,14915654,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901440,426238649,14914761,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901441,426242255,14895543,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901442,426242569,14899908,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901443,426242882,14903315,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901444,426243587,14905338,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901445,426245389,14906403,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901446,426247426,14908213,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901447,426248993,14910875,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901448,426244412,14912768,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901449,426246445,14912796,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901450,426248786,14913521,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901451,426250696,14914638,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901452,426252093,14916201,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901453,426253592,14917624,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901454,426254639,14918880,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901455,426256405,14921420,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901456,426257986,14923765,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901457,426259506,14925942,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901458,426261108,14927867,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901459,426262237,14928788,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901460,426263613,14930547,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901461,426265277,14934175,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901462,426266837,14937608,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901463,426268172,14941181,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901464,426197560,15018516,4161868,1,'2010-03-18 16:47:35',3310502739,1),(668901465,426199566,15013542,4161868,1,'2010-03-18 16:47:35',3310502739,1),(668901466,426201521,15009181,4161868,1,'2010-03-18 16:47:35',3310502739,1),(668901467,426202324,15008704,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901468,426203477,15008363,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901469,426204630,15008772,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901470,426205783,15009862,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901471,426207187,15010680,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901472,426208742,15011157,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901473,426210497,15010680,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901474,426212302,15009317,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901475,426195254,15032757,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901476,426198362,15031463,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901477,426200218,15030713,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901478,426200819,15028805,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901479,426200519,15028055,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901480,426199967,15027306,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901481,426199817,15026488,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901482,426199817,15025125,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901483,426196708,15037595,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901484,426200418,15036982,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901485,426194401,15030917,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901486,426195855,15024444,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901487,426200870,15029895,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901488,426201020,15024717,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901489,426202524,15025466,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901490,426203326,15026556,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901491,426204430,15027919,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901492,426207037,15028669,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901493,426210447,15029214,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901494,426203377,15035619,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901495,426205533,15035210,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901496,426208541,15034256,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901497,426211098,15033098,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901498,426212803,15032008,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901499,426213806,15030509,4161868,1,'2010-03-18 16:47:37',3310502739,1),(668901500,426227912,14942232,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901501,426232612,14948487,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901502,426236138,14952480,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901503,426238292,14955940,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901504,426221578,14993985,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901505,426222280,14989692,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901506,426222781,14987648,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901507,426223633,14985400,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901508,426225088,14982742,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901510,426227795,14979540,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901511,426229751,14977632,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901512,426232859,14975587,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901513,426237171,14973543,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901514,426240480,14972044,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901515,426244657,14962461,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901516,426250827,14967386,4161868,1,'2010-03-18 16:47:37',3310502741,1),(668901517,426249706,14968092,4161868,1,'2010-03-18 16:47:37',3310502741,1),(668901518,426254469,14966320,4161868,1,'2010-03-18 16:47:37',3310502741,1),(668901519,426269384,14944334,4161868,1,'2010-03-18 16:47:37',3310502741,1),(668901520,426257678,14964957,4161868,1,'2010-03-18 16:47:37',3310502741,1),(668901521,426261037,14964480,4161868,1,'2010-03-18 16:47:37',3310502741,1),(668901522,426264747,14963799,4161868,1,'2010-03-18 16:47:37',3310502741,1),(668901523,426267254,14964208,4161868,1,'2010-03-18 16:47:37',3310502741,1),(668901524,426269410,14965775,4161868,1,'2010-03-18 16:47:37',3310502741,1),(668901525,426252463,14993985,4161868,1,'2010-03-18 16:47:37',3310502741,1),(668901526,426253416,14992145,4161868,1,'2010-03-18 16:47:37',3310502741,1),(668901527,426254770,14990851,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901528,426244943,14969932,4161868,1,'2010-03-18 16:47:38',3310502740,1),(668901529,426269522,14993838,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901530,426257076,14990033,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901531,426258129,14989488,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901532,426258781,14988398,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901533,426258981,14987308,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901534,426259081,14985331,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901535,426259081,14983628,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901536,426259533,14982197,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901537,426260385,14980902,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901538,426261388,14980902,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901539,426262591,14981175,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901540,426264246,14982265,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901541,426266201,14983832,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901542,426267956,14984991,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901543,426214859,15007000,4161868,1,'2010-03-18 16:47:38',3310502739,1),(668901544,426217065,15004411,4161868,1,'2010-03-18 16:47:38',3310502739,1),(668901545,426219171,15001958,4161868,1,'2010-03-18 16:47:38',3310502739,1),(668901546,426220274,15000118,4161868,1,'2010-03-18 16:47:38',3310502739,1),(668901547,426220826,14998074,4161868,1,'2010-03-18 16:47:38',3310502739,1),(668901548,426221828,15009589,4161868,1,'2010-03-18 16:47:38',3310502742,1),(668901549,426223333,15007886,4161868,1,'2010-03-18 16:47:38',3310502742,1),(668901550,426225388,15006182,4161868,1,'2010-03-18 16:47:38',3310502742,1),(668901551,426228046,15005024,4161868,1,'2010-03-18 16:47:38',3310502742,1),(668901552,426221026,15021446,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901553,426220575,15019879,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901554,426219873,15016880,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901555,426220124,15014223,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901556,426220976,15011838,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901557,426221578,15023490,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901558,426230302,15004751,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901559,426232157,15004751,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901560,426235717,15006319,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901561,426238023,15007273,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901562,426240129,15007886,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901563,426241734,15008090,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901564,426234865,15022672,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901565,426240039,15023757,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901566,426240289,15021286,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901567,426241417,15018050,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901568,426235817,15021378,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901569,426237973,15019879,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901570,426240330,15018243,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901571,426241884,15017562,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901572,426215009,15029078,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901573,426220124,15029214,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901574,426215711,15028328,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901575,426216714,15027033,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901576,426218569,15026420,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901577,426220224,15025466,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901579,426221076,15024989,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901580,426226040,15029963,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901581,426239036,15040195,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901582,426239161,15033978,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901583,426239788,15028271,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901584,426228748,15030440,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901585,426231405,15030440,4161868,1,'2010-03-18 16:47:40',3310502742,1),(668901586,426232558,15030372,4161868,1,'2010-03-18 16:47:40',3310502742,1),(668901587,426233661,15029623,4161868,1,'2010-03-18 16:47:40',3310502742,1),(668901588,426233762,15028396,4161868,1,'2010-03-18 16:47:40',3310502742,1),(668901589,426234012,15027374,4161868,1,'2010-03-18 16:47:40',3310502742,1),(668901590,426234213,15025125,4161868,1,'2010-03-18 16:47:40',3310502742,1),(668901591,426234313,15023831,4161868,1,'2010-03-18 16:47:40',3310502742,1),(668901592,426243589,15007886,4161868,1,'2010-03-18 16:47:40',3310502742,1),(668901593,426245093,15007273,4161868,1,'2010-03-18 16:47:40',3310502742,1),(668901594,426247249,15005705,4161868,1,'2010-03-18 16:47:40',3310502742,1),(668901595,426253074,15009447,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901596,426255519,15008680,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901597,426253253,15007357,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901598,426254986,15004959,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901599,426249104,15004138,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901600,426250508,15002026,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901601,426251611,14999777,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901602,426252313,14996983,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901603,426244864,15014558,4161868,1,'2010-03-18 16:47:40',3310502742,1),(668901604,426249377,15011321,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901605,426250526,15010584,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901606,426259530,15010384,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901607,426264105,15013706,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901608,426266611,15015835,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901609,426267990,15017283,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901610,426256430,15003171,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901611,426257938,15002298,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901612,426259703,15002080,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901613,426261628,15002691,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901614,426263137,15003345,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901615,426264163,15003432,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901616,426264869,15003127,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901617,426265704,15001775,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901618,426266634,14999769,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901619,426267757,14996804,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901620,426244853,15043378,4161868,1,'2010-03-18 16:47:41',3310502742,1),(668901621,426249652,15047105,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901622,426254254,15048968,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901623,426256898,15048702,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901624,426258954,15046439,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901625,426261402,15043245,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901626,426263361,15040983,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901627,426266592,15039918,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901628,426268943,15041914,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901629,426267328,15026340,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901630,426324125,14757332,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901631,426323454,14757153,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901632,426322653,14757153,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901633,426321877,14757386,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901634,426321181,14757868,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901635,426320826,14758332,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901636,426320537,14758958,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901637,426320498,14759261,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901638,426320721,14760333,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901639,426321155,14761298,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901640,426321904,14762298,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901641,426322482,14763120,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901642,426323034,14763995,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901643,426323546,14765156,4161868,1,'2010-03-18 16:47:42',3310503073,1),(668901644,426324190,14767156,4161868,1,'2010-03-18 16:47:42',3310503073,1),(668901645,426269660,14782350,4161868,1,'2010-03-18 16:47:42',3310502391,1),(668901646,426272117,14783781,4161868,1,'2010-03-18 16:47:42',3310502391,1),(668901647,426275977,14783781,4161868,1,'2010-03-18 16:47:42',3310502391,1),(668901648,426281992,14785252,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901649,426278348,14788603,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901650,426280307,14786208,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901651,426282167,14784877,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901652,426282265,14785941,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901653,426282657,14788071,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901654,426278484,14783917,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901655,426281492,14784666,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901656,426270515,14792330,4161868,1,'2010-03-18 16:47:42',3310502391,1),(668901657,426272081,14795790,4161868,1,'2010-03-18 16:47:42',3310502391,1),(668901658,426273158,14799383,4161868,1,'2010-03-18 16:47:42',3310502391,1),(668901659,426274040,14802577,4161868,1,'2010-03-18 16:47:42',3310502391,1),(668901660,426275117,14802843,4161868,1,'2010-03-18 16:47:42',3310502391,1),(668901661,426275704,14803110,4161868,1,'2010-03-18 16:47:42',3310502391,1),(668901662,426271294,14800159,4161868,1,'2010-03-18 16:47:42',3310502391,1),(668901663,426276488,14800980,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901664,426276586,14796988,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901665,426276586,14793261,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901666,426276880,14790999,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901667,426283832,14784477,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901668,426285497,14784744,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901669,426286769,14786740,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901670,426287357,14787938,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901672,426289609,14790200,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901673,426283538,14790466,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901674,426285497,14793660,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901675,426287847,14795391,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901676,426291959,14791132,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901677,426296463,14792063,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901678,426290197,14798318,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901679,426291959,14800049,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901680,426273619,14805149,4161868,1,'2010-03-18 16:47:43',3310502391,1),(668901681,426275455,14809308,4161868,1,'2010-03-18 16:47:43',3310502391,1),(668901682,426277659,14812636,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901683,426280229,14815630,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901684,426270070,14812303,4161868,1,'2010-03-18 16:47:43',3310502391,1),(668901685,426275088,14813135,4161868,1,'2010-03-18 16:47:43',3310502391,1),(668901686,426279127,14814133,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901687,426293722,14804307,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901688,426295484,14808433,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901689,426284268,14820621,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901690,426287206,14822617,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901691,426290878,14825445,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901692,426293448,14827275,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901693,426295774,14830270,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901694,426299401,14791930,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901695,426301555,14791664,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901696,426304493,14792729,4161868,1,'2010-03-18 16:47:43',3310503075,1),(668901697,426306353,14794326,4161868,1,'2010-03-18 16:47:43',3310503075,1),(668901698,426307626,14797653,4161868,1,'2010-03-18 16:47:43',3310503075,1),(668901699,426308899,14801513,4161868,1,'2010-03-18 16:47:43',3310503075,1),(668901700,426324243,14791593,4161868,1,'2010-03-18 16:47:43',3310503075,1),(668901701,426323836,14793968,4161868,1,'2010-03-18 16:47:43',3310503075,1),(668901702,426323389,14795201,4161868,1,'2010-03-18 16:47:43',3310503075,1),(668901703,426322797,14796362,4161868,1,'2010-03-18 16:47:43',3310503075,1),(668901704,426321693,14797684,4161868,1,'2010-03-18 16:47:43',3310503075,1),(668901705,426320682,14798738,4161868,1,'2010-03-18 16:47:43',3310503075,1),(668901706,426319775,14799684,4161868,1,'2010-03-18 16:47:43',3310503075,1),(668901707,426319302,14800577,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901708,426318999,14801506,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901709,426318921,14802596,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901710,426318999,14803793,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901711,426310661,14807235,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901712,426297443,14810562,4161868,1,'2010-03-18 16:47:44',3310503074,1),(668901713,426299793,14814156,4161868,1,'2010-03-18 16:47:44',3310503074,1),(668901714,426301555,14818015,4161868,1,'2010-03-18 16:47:44',3310503074,1),(668901715,426302339,14820810,4161868,1,'2010-03-18 16:47:44',3310503074,1),(668901716,426303220,14823206,4161868,1,'2010-03-18 16:47:44',3310503074,1),(668901717,426305276,14826932,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901718,426307430,14828130,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901719,426310564,14827864,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901720,426312228,14810696,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901721,426313403,14814023,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901723,426314774,14815620,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901724,426319236,14805061,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901725,426320261,14808098,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901726,426321417,14811063,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901727,426322443,14813438,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901728,426323047,14814528,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901729,426323389,14815564,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901730,426323507,14816564,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901731,426323270,14817797,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901732,426314406,14825019,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901733,426315459,14818281,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901734,426315459,14821209,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901735,426315068,14825069,4161868,1,'2010-03-18 16:47:45',3310503075,1),(668901736,426313011,14826666,4161868,1,'2010-03-18 16:47:45',3310503075,1),(668901737,426319598,14825625,4161868,1,'2010-03-18 16:47:45',3310503075,1),(668901738,426322732,14819280,4161868,1,'2010-03-18 16:47:45',3310503075,1),(668901739,426322193,14820476,4161868,1,'2010-03-18 16:47:45',3310503075,1),(668901740,426321115,14822334,4161868,1,'2010-03-18 16:47:45',3310503075,1),(668901741,426320064,14824085,4161868,1,'2010-03-18 16:47:45',3310503075,1),(668901742,426319499,14825103,4161868,1,'2010-03-18 16:47:45',3310503075,1),(668901743,426330682,14756743,4161868,1,'2010-03-18 16:47:45',3310503073,1),(668901744,426330157,14757118,4161868,1,'2010-03-18 16:47:45',3310503073,1),(668901745,426329670,14758172,4161868,1,'2010-03-18 16:47:45',3310503073,1),(668901746,426329145,14759065,4161868,1,'2010-03-18 16:47:45',3310503073,1),(668901747,426328632,14759333,4161868,1,'2010-03-18 16:47:45',3310503073,1),(668901748,426328028,14759315,4161868,1,'2010-03-18 16:47:45',3310503073,1),(668901749,426327134,14759029,4161868,1,'2010-03-18 16:47:45',3310503073,1),(668901750,426325544,14758011,4161868,1,'2010-03-18 16:47:45',3310503073,1),(668901751,426337700,14761691,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901752,426335847,14759279,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901753,426334953,14758118,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901754,426333850,14757296,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901755,426332903,14756885,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901756,426331957,14756689,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901757,426331353,14756618,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901758,426324716,14769050,4161868,1,'2010-03-18 16:47:45',3310503073,1),(668901759,426325058,14771819,4161868,1,'2010-03-18 16:47:45',3310503073,1),(668901760,426325347,14775623,4161868,1,'2010-03-18 16:47:45',3310503073,1),(668901761,426344244,14776356,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901762,426344231,14774534,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901763,426344231,14773230,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901764,426343942,14771872,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901765,426343088,14769872,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901766,426341826,14767657,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901767,426340552,14765424,4161868,1,'2010-03-18 16:47:46',3310503076,1),(668901768,426339316,14763495,4161868,1,'2010-03-18 16:47:46',3310503076,1),(668901769,426379273,14744837,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901770,426372054,14756230,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901771,426371352,14756639,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901772,426370951,14757048,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901774,426370901,14757934,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901775,426371152,14758888,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901776,426372355,14760796,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901777,426379072,14749825,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901778,426377769,14752074,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901779,426376114,14753982,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901780,426374109,14755549,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901781,426374711,14762567,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901782,426371954,14776264,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901783,426376465,14764543,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901784,426377668,14766588,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901785,426378120,14767405,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901786,426378120,14768019,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901787,426377719,14768496,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901788,426376967,14768496,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901789,426375914,14768496,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901790,426375212,14768768,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901791,426374160,14769518,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901792,426373157,14771085,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901793,426372606,14773470,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901794,426351722,14790682,4161868,1,'2010-03-18 16:47:46',3310503078,1),(668901795,426351222,14787591,4161868,1,'2010-03-18 16:47:46',3310503078,1),(668901796,426350999,14786216,4161868,1,'2010-03-18 16:47:46',3310503078,1),(668901797,426350605,14785180,4161868,1,'2010-03-18 16:47:46',3310503078,1),(668901798,426349829,14784144,4161868,1,'2010-03-18 16:47:46',3310503078,1),(668901799,426348620,14783018,4161868,1,'2010-03-18 16:47:46',3310503078,1),(668901800,426346965,14781071,4161868,1,'2010-03-18 16:47:47',3310503078,1),(668901801,426344954,14778499,4161868,1,'2010-03-18 16:47:47',3310503078,1),(668901802,426344520,14777713,4161868,1,'2010-03-18 16:47:47',3310503078,1),(668901803,426325491,14778982,4161868,1,'2010-03-18 16:47:47',3310503075,1),(668901804,426325347,14783394,4161868,1,'2010-03-18 16:47:47',3310503075,1),(668901805,426325137,14787002,4161868,1,'2010-03-18 16:47:47',3310503075,1),(668901806,426365187,14796024,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901807,426364786,14798137,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901808,426364034,14800658,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901809,426363432,14802361,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901810,426355863,14803315,4161868,1,'2010-03-18 16:47:47',3310503078,1),(668901811,426355010,14800522,4161868,1,'2010-03-18 16:47:47',3310503078,1),(668901812,426353857,14797796,4161868,1,'2010-03-18 16:47:47',3310503078,1),(668901813,426353055,14795615,4161868,1,'2010-03-18 16:47:47',3310503078,1),(668901814,426352077,14793164,4161868,1,'2010-03-18 16:47:47',3310503078,1),(668901815,426370801,14778580,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901816,426370199,14780897,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901817,426369548,14783282,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901818,426369197,14786212,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901819,426368595,14788052,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901820,426367292,14790778,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901821,426366039,14793367,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901822,426362179,14804201,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901823,426360675,14805632,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901824,426359773,14806177,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901825,426358519,14806382,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901826,426358068,14806041,4161868,1,'2010-03-18 16:47:48',3310503078,1),(668901827,426357266,14805496,4161868,1,'2010-03-18 16:47:48',3310503078,1),(668901828,426356464,14804133,4161868,1,'2010-03-18 16:47:48',3310503078,1),(668901829,426286946,14861242,4161868,1,'2010-03-18 16:47:48',3310503080,1),(668901831,426289374,14859113,4161868,1,'2010-03-18 16:47:48',3310503080,1),(668901833,426291568,14854854,4161868,1,'2010-03-18 16:47:48',3310503080,1),(668901834,426295171,14847188,4161868,1,'2010-03-18 16:47:48',3310503080,1),(668901835,426296581,14844207,4161868,1,'2010-03-18 16:47:48',3310503080,1),(668901836,426298069,14841652,4161868,1,'2010-03-18 16:47:48',3310503080,1),(668901837,426300028,14840800,4161868,1,'2010-03-18 16:47:48',3310503080,1),(668901838,426304023,14839203,4161868,1,'2010-03-18 16:47:48',3310503081,1),(668901839,426307156,14837180,4161868,1,'2010-03-18 16:47:48',3310503081,1),(668901840,426309584,14834092,4161868,1,'2010-03-18 16:47:48',3310503081,1),(668901842,426298099,14834262,4161868,1,'2010-03-18 16:47:48',3310503080,1),(668901843,426301159,14839087,4161868,1,'2010-03-18 16:47:48',3310503080,1),(668901844,426302383,14842414,4161868,1,'2010-03-18 16:47:48',3310503080,1),(668901845,426303730,14846240,4161868,1,'2010-03-18 16:47:48',3310503081,1),(668901846,426306667,14849733,4161868,1,'2010-03-18 16:47:48',3310503081,1),(668901847,426313697,14833187,4161868,1,'2010-03-18 16:47:48',3310503081,1),(668901848,426312620,14841439,4161868,1,'2010-03-18 16:47:48',3310503081,1),(668901849,426315753,14855013,4161868,1,'2010-03-18 16:47:48',3310503081,1),(668901850,426311196,14854225,4161868,1,'2010-03-18 16:47:48',3310503081,1),(668901851,426314011,14859715,4161868,1,'2010-03-18 16:47:48',3310503081,1),(668901852,426316826,14866203,4161868,1,'2010-03-18 16:47:48',3310503081,1),(668901853,426329052,14910768,4161868,1,'2010-03-18 16:47:48',3310503083,1),(668901854,426330305,14916731,4161868,1,'2010-03-18 16:47:48',3310503083,1),(668901855,426332185,14924077,4161868,1,'2010-03-18 16:47:48',3310503086,1),(668901856,426334221,14931956,4161868,1,'2010-03-18 16:47:48',3310503086,1),(668901857,426380425,14746077,4161868,1,'2010-03-18 16:47:48',3310503077,1),(668901858,426270513,14947125,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901859,426271458,14949330,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901860,426272588,14951172,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901861,426273594,14953545,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901862,426274805,14956587,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901863,426275463,14958485,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901864,426276366,14960411,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901865,426271716,14968296,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901866,426277742,14962979,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901867,426278871,14965239,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901868,426279241,14966412,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901869,426279672,14967974,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901870,426273922,14970886,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901871,426276930,14975383,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901872,426280309,14970096,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901873,426280781,14972887,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901874,426280822,14974645,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901875,426279426,14979027,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901876,426279788,14982401,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901877,426278935,14979131,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901878,426280720,14976459,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901879,426280206,14977966,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901881,426281342,14982333,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901882,426271383,14990655,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901883,426272923,14988649,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901884,426275458,14986250,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901885,426269610,14985877,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901886,426271967,14986762,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901887,426273521,14986626,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901888,426275977,14985877,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901889,426277481,14984173,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901890,426278635,14982742,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901891,426286164,14995904,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901892,426287856,14995904,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901893,426288671,14996160,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901894,426283297,14983287,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901895,426285403,14984037,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901896,426286556,14984923,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901897,426287659,14987171,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901898,426288210,14989488,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901899,426289213,14991873,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901900,426290517,14994803,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901901,426291369,14996098,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901902,426324430,14989236,4161868,1,'2010-03-18 16:47:50',3310503425,1),(668901903,426320043,14989236,4161868,1,'2010-03-18 16:47:50',3310503425,1),(668901904,426316989,14988810,4161868,1,'2010-03-18 16:47:50',3310503425,1),(668901905,426315187,14988917,4161868,1,'2010-03-18 16:47:50',3310503425,1),(668901906,426314404,14989982,4161868,1,'2010-03-18 16:47:50',3310503425,1),(668901907,426313150,14991579,4161868,1,'2010-03-18 16:47:50',3310503425,1),(668901908,426312915,14993814,4161868,1,'2010-03-18 16:47:50',3310503425,1),(668901909,426276998,15022514,4161868,1,'2010-03-18 16:47:50',3310503426,1),(668901910,426269745,15018390,4161868,1,'2010-03-18 16:47:50',3310502743,1),(668901911,426272189,15017539,4161868,1,'2010-03-18 16:47:50',3310502743,1),(668901912,426273505,15016261,4161868,1,'2010-03-18 16:47:50',3310502743,1),(668901913,426274445,15014047,4161868,1,'2010-03-18 16:47:50',3310502743,1),(668901914,426276952,15009362,4161868,1,'2010-03-18 16:47:50',3310503426,1),(668901915,426279584,15004251,4161868,1,'2010-03-18 16:47:50',3310503426,1),(668901916,426282530,14999907,4161868,1,'2010-03-18 16:47:50',3310503426,1),(668901917,426274592,15013899,4161868,1,'2010-03-18 16:47:50',3310502743,1),(668901918,426276806,15011805,4161868,1,'2010-03-18 16:47:50',3310503426,1),(668901919,426279212,15009756,4161868,1,'2010-03-18 16:47:50',3310503426,1),(668901920,426281490,15008622,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901921,426284472,14997437,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901922,426289799,14997437,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901923,426291366,14999567,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901924,426293371,15000674,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901925,426296505,15002037,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901926,426283897,15007619,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901927,426286271,15007052,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901928,426288517,15007052,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901929,426291437,15007357,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901930,426294614,15007575,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901931,426293876,14997392,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901932,426296432,14998346,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901933,426270999,15044443,4161868,1,'2010-03-18 16:47:51',3310502743,1),(668901934,426273153,15045641,4161868,1,'2010-03-18 16:47:51',3310502743,1),(668901935,426275503,15045641,4161868,1,'2010-03-18 16:47:51',3310502743,1),(668901936,426277364,15043644,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901937,426280399,15039252,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901938,426283141,15034594,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901939,426285100,15032465,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901941,426287156,15031800,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901942,426289212,15031933,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901943,426290681,15034861,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901944,426292150,15036458,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901945,426293912,15036458,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901949,426296654,15035659,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901951,426300408,15009954,4161868,1,'2010-03-18 16:47:52',3310503426,1),(668901953,426299701,15002633,4161868,1,'2010-03-18 16:47:52',3310503426,1),(668901954,426301769,15003144,4161868,1,'2010-03-18 16:47:52',3310503426,1),(668901956,426303210,15003740,4161868,1,'2010-03-18 16:47:52',3310503426,1),(668901957,426297180,15008055,4161868,1,'2010-03-18 16:47:52',3310503426,1),(668901959,426298656,15008578,4161868,1,'2010-03-18 16:47:52',3310503426,1),(668901960,426300293,15009058,4161868,1,'2010-03-18 16:47:52',3310503426,1),(668901962,426301576,15009232,4161868,1,'2010-03-18 16:47:52',3310503426,1),(668901964,426299390,14999368,4161868,1,'2010-03-18 16:47:52',3310503426,1),(668901965,426302699,14998823,4161868,1,'2010-03-18 16:47:52',3310503426,1),(668901966,426310656,15009840,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901968,426304900,15007828,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901972,426308389,15007283,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901973,426304839,15004251,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901975,426307597,15003825,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901976,426309289,15002889,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901978,426306058,14998006,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901979,426309166,14997324,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901980,426310520,14997529,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901982,426303117,15022084,4161868,1,'2010-03-18 16:47:52',3310503426,1),(668901983,426305956,15017559,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901984,426308208,15013966,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901986,426312524,14996476,4161868,1,'2010-03-18 16:47:52',3310503425,1),(668901987,426313072,14999244,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901989,426314012,15000948,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901991,426310793,15002889,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901992,426311921,15003059,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901993,426311623,14998006,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901994,426312225,14998755,4161868,1,'2010-03-18 16:47:53',3310503427,1),(668901995,426313378,15001004,4161868,1,'2010-03-18 16:47:53',3310503427,1),(668901996,426298906,15031134,4161868,1,'2010-03-18 16:47:53',3310503426,1),(668901998,426301256,15026210,4161868,1,'2010-03-18 16:47:53',3310503426,1),(668901999,426338138,14942177,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902000,426340879,14949523,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902002,426342133,14955698,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902003,426342368,14961448,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902005,426342054,14964642,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902007,426340879,14966771,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902011,426337041,14982635,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902013,426335083,14985616,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902015,426332185,14987852,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902016,426328033,14988704,4161868,1,'2010-03-18 16:47:53',3310503425,1),(668902018,426340253,14969539,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902019,426339939,14972308,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902021,426339939,14975076,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902022,426339391,14977951,4161868,1,'2010-03-18 16:47:53',3310503428,1),(669985285,426255468,16025472,4184201,1,'2010-03-20 22:04:06',3310504287,2),(669985286,426255539,16025065,4184201,1,'2010-03-20 22:04:06',3310504287,2),(669985287,426255726,16025677,4184201,1,'2010-03-20 22:04:07',3310504287,2),(669985289,426255357,16025354,4184201,1,'2010-03-20 22:04:07',3310504287,2),(669985291,426255467,16025471,4174714,1,'2010-03-19 23:59:12',3310504287,1),(669985299,426228104,16983392,4174714,1,'2010-03-19 23:59:13',3310504822,1),(669985301,426228020,16983740,4174714,1,'2010-03-19 23:59:13',3310504822,1),(669985341,426037316,14419303,4174714,1,'2010-03-19 23:59:16',3310502205,1),(669985348,426150236,14772623,4174714,1,'2010-03-19 23:59:17',3310502373,1),(669985685,425878196,17418899,4174714,1,'2010-03-19 23:59:51',3310504867,1),(669985690,425877973,17418476,4174714,1,'2010-03-19 23:59:51',3310504867,1),(669986979,426496768,15343333,4174714,1,'2010-03-20 00:00:54',3310503530,1),(669986980,426496919,15343575,4174714,1,'2010-03-20 00:00:54',3310503530,1),(669986981,426497055,15343468,4174714,1,'2010-03-20 00:00:54',3310503530,1),(669986982,426496894,15343268,4174714,1,'2010-03-20 00:00:54',3310503530,1),(690708536,425437782,17314963,4375683,1,'2010-04-09 21:07:05',3310504587,1),(769251745,425497543,17040945,4963942,1,'2010-06-11 20:05:20',3310504493,1),(769251759,425424601,17118147,4963942,1,'2010-06-11 20:05:21',3310504491,1),(769251779,425441839,17037443,4963942,1,'2010-06-11 20:05:23',3310504489,1),(769251780,425441601,17041044,4963942,1,'2010-06-11 20:05:23',3310504489,1),(769251784,425513448,16953105,4963942,1,'2010-06-11 20:05:25',3310504496,1),(769251786,425522126,16949892,4963942,1,'2010-06-11 20:05:26',3310504496,1),(769251787,425521374,16947687,4963942,1,'2010-06-11 20:05:26',3310504496,1),(769251788,425518665,16946673,4963942,1,'2010-06-11 20:05:26',3310504496,1),(769251789,425517434,16947655,4963942,1,'2010-06-11 20:05:26',3310504496,1),(769251791,425518542,16953816,4963942,1,'2010-06-11 20:05:27',3310504496,1),(769251793,425430929,17038607,4963942,1,'2010-06-11 20:05:27',3310504489,1),(769251804,425449663,17297929,4963942,1,'2010-06-11 20:05:34',3310504585,1),(769252942,425295139,15714850,4963967,1,'2010-06-11 20:09:40',3310491640,1),(769252948,425292324,15715067,4963967,1,'2010-06-11 20:09:41',3310491640,1),(769252949,425292718,15716811,4963967,1,'2010-06-11 20:09:41',3310491640,1),(769252950,425293615,15717388,4963967,1,'2010-06-11 20:09:41',3310491640,1),(769252951,425294696,15716923,4963967,1,'2010-06-11 20:09:41',3310491640,1),(769252988,425673544,16012998,4963967,1,'2010-06-11 20:09:43',3310504014,1),(769252996,425673029,16012530,4963967,1,'2010-06-11 20:09:44',3310504014,1),(769252999,425672737,16012515,4963967,1,'2010-06-11 20:09:44',3310504014,1),(769253007,425672019,16013480,4963967,1,'2010-06-11 20:09:44',3310504014,1),(769253012,425672717,16014776,4963967,1,'2010-06-11 20:09:44',3310504014,1),(769253015,425673221,16014675,4963967,1,'2010-06-11 20:09:44',3310504014,1),(769253018,425667669,16001347,4963967,1,'2010-06-11 20:09:45',3310504011,1),(769253019,425667626,16001098,4963967,1,'2010-06-11 20:09:45',3310504011,1),(769253020,425667448,16000795,4963967,1,'2010-06-11 20:09:45',3310504011,1),(769253021,425667012,16000670,4963967,1,'2010-06-11 20:09:45',3310504011,1),(769253022,425666695,16000945,4963967,1,'2010-06-11 20:09:46',3310504011,1),(769253024,425666588,16001464,4963967,1,'2010-06-11 20:09:46',3310504011,1),(769253025,425666724,16001881,4963967,1,'2010-06-11 20:09:46',3310504011,1),(769253026,425666872,16002039,4963967,1,'2010-06-11 20:09:46',3310504011,1),(769253028,425667161,16002124,4963967,1,'2010-06-11 20:09:46',3310504011,1),(769253029,425667344,16002064,4963967,1,'2010-06-11 20:09:47',3310504011,1),(769253030,425667606,16001735,4963967,1,'2010-06-11 20:09:47',3310504011,1),(779158284,425707005,16103265,5043123,1,'2010-06-21 17:17:14',3310504039,1),(796030198,425437639,17239695,5107412,1,'2010-06-29 20:14:39',3310504579,1),(796030199,425440643,17269735,5107412,1,'2010-06-29 20:14:39',3310504585,1),(796031914,425467834,16987782,5107412,1,'2010-06-29 20:15:31',3310504486,1),(796031930,425455820,17005162,5107412,1,'2010-06-29 20:15:32',3310504486,1),(796031933,425446492,17036920,5107412,1,'2010-06-29 20:15:32',3310504489,1),(796031937,425442224,17089920,5107412,1,'2010-06-29 20:15:32',3310504491,1),(796031941,425461194,17322521,5107412,1,'2010-06-29 20:15:32',3310504590,1),(796040771,424724830,14934661,5107450,1,'2010-06-29 20:18:46',3310490815,1),(796041497,424486585,14826729,5107450,1,'2010-06-29 20:19:04',3310490102,1),(796044564,424535231,14864280,5107450,1,'2010-06-29 20:20:40',3310490792,1),(796044575,424471187,14815786,5107450,1,'2010-06-29 20:20:40',3310490102,1),(820950476,425768000,16675220,5236475,1,'2010-07-16 20:30:26',3310504187,1),(820952919,425765610,16671820,5236475,1,'2010-07-16 20:31:32',3310504187,1),(820954183,425768070,16665090,5236785,1,'2010-07-16 21:17:52',3310504187,2),(821006310,425767440,16666650,5236785,1,'2010-07-16 21:18:26',3310504187,1),(840392122,426328793,15005308,5363414,1,'2010-07-31 18:32:50',3310503427,1),(840392129,426329740,15007239,5363414,1,'2010-07-31 18:32:50',3310503427,1),(840392132,426330687,15010887,5363414,1,'2010-07-31 18:32:51',3310503427,1),(840392146,426331477,15014749,5363414,1,'2010-07-31 18:32:51',3310503430,1),(840392147,426331950,15021615,5363414,1,'2010-07-31 18:32:51',3310503430,1),(840392149,426332424,15033417,5363414,1,'2010-07-31 18:32:51',3310503430,1),(840392151,426333687,15040713,5363414,1,'2010-07-31 18:32:51',3310503430,1),(840392153,426332897,15047365,5363414,1,'2010-07-31 18:32:51',3310503430,1),(840392156,426333687,15055948,5363414,1,'2010-07-31 18:32:51',3310503436,1),(840392161,426334160,15064102,5363414,1,'2010-07-31 18:32:51',3310503436,1),(840392165,426334160,15073328,5363414,1,'2010-07-31 18:32:52',3310503436,1),(840392168,426332739,15084272,5363414,1,'2010-07-31 18:32:52',3310503436,1),(840392171,426330529,15090065,5363414,1,'2010-07-31 18:32:52',3310503433,1),(840392172,426328793,15095430,5363414,1,'2010-07-31 18:32:52',3310503433,1),(840392174,426327688,15100365,5363414,1,'2010-07-31 18:32:52',3310503433,1),(840392177,426327688,15104442,5363414,1,'2010-07-31 18:32:52',3310503433,1),(840392179,426326741,15110665,5363414,1,'2010-07-31 18:32:52',3310503435,1),(840392182,426325162,15117102,5363414,1,'2010-07-31 18:32:52',3310503435,1),(840392185,426323425,15120321,5363414,1,'2010-07-31 18:45:28',3310503435,3),(840392187,426321373,15119033,5363414,1,'2010-07-31 18:44:40',3310503435,2),(840392190,426320899,15116458,5363414,1,'2010-07-31 18:32:52',3310503435,1),(840392214,426328004,15004235,5363414,1,'2010-07-31 18:32:54',3310503427,1),(840405569,426322005,15119892,5363414,1,'2010-07-31 18:45:05',3310503435,1),(840406394,426324373,15119248,5363414,1,'2010-07-31 18:45:27',3310503435,1),(894217167,425345988,15836955,5671193,1,'2010-09-03 17:32:57',3310493012,1),(894217168,425345692,15831606,5671193,1,'2010-09-03 17:32:57',3310493012,1),(894217170,425348346,15827049,5671193,1,'2010-09-03 17:32:57',3310493012,1),(894217183,425343267,15818827,5671193,1,'2010-09-03 17:32:57',3310491646,1),(894217186,425345464,15833937,5671193,1,'2010-09-03 17:32:57',3310493012,1),(894217188,425344217,15822092,5671193,1,'2010-09-03 17:32:57',3310493012,1),(894217189,425338605,15803705,5671193,1,'2010-09-03 17:32:57',3310491643,1),(894217190,425347958,15829068,5671193,1,'2010-09-03 17:32:57',3310493012,1),(894217191,425347306,15823825,5671193,1,'2010-09-03 17:32:57',3310493012,1),(894217192,425337803,15807019,5671193,1,'2010-09-03 17:32:58',3310491643,1),(894217194,425346939,15830863,5671193,1,'2010-09-03 17:32:58',3310493012,1),(894217204,425347959,15824835,5671193,1,'2010-09-03 17:32:58',3310493012,1),(894217206,425340060,15811613,5671193,1,'2010-09-03 17:32:58',3310491643,1),(894258957,425274169,15761738,5671401,1,'2010-09-03 18:05:34',3310491629,1),(894258960,425177524,15681080,5671401,1,'2010-09-03 18:05:34',3310491618,1),(894258963,425282402,15760328,5671401,1,'2010-09-03 18:05:34',3310491629,1),(894258967,425292595,15789838,5671401,1,'2010-09-03 18:05:34',3310491642,1),(894258969,425182999,15657036,5671401,1,'2010-09-03 18:05:34',3310491618,1),(894258972,425303698,15770095,5671401,1,'2010-09-03 18:05:34',3310491642,1),(894258974,425540029,15898783,5671401,1,'2010-09-03 18:05:34',3310503955,1),(894258982,425297139,15788922,5671401,1,'2010-09-03 18:05:34',3310491642,1),(894258985,425223309,15718295,5671401,1,'2010-09-03 18:05:35',3310491625,1),(894258989,425289685,15763772,5671401,1,'2010-09-03 18:05:35',3310491640,1),(894258992,425383090,15870042,5671401,1,'2010-09-03 18:05:35',3310493013,1),(894258994,425305785,15797714,5671401,1,'2010-09-03 18:05:35',3310491642,1),(894258996,425274728,15786288,5671401,1,'2010-09-03 18:05:35',3310491631,1),(894258997,425379477,15859907,5671401,1,'2010-09-03 18:05:35',3310493013,1),(894258998,425190953,15662303,5671401,1,'2010-09-03 18:05:35',3310491618,1),(894259008,425301055,15760906,5671401,1,'2010-09-03 18:05:35',3310491640,1),(894259010,425393661,15871751,5678739,1,'2010-09-04 16:07:27',3310493013,2),(894259012,425277803,15763801,5671401,1,'2010-09-03 18:05:35',3310491629,1),(894259014,425298821,15790440,5671401,1,'2010-09-03 18:05:35',3310491642,1),(894259017,425512446,15911932,5671401,1,'2010-09-03 18:05:35',3310503954,1),(894259020,425507717,15908486,5671401,1,'2010-09-03 18:05:35',3310503954,1),(894259022,425198848,15671488,5671401,1,'2010-09-03 18:05:35',3310491618,1),(894259030,425288233,15763627,5671401,1,'2010-09-03 18:05:35',3310491640,1),(894259032,425392331,15871558,5671401,1,'2010-09-03 18:05:35',3310493013,1),(894259034,425314984,15812562,5671401,1,'2010-09-03 18:05:35',3310491643,1),(894259037,425268365,15764707,5671401,1,'2010-09-03 18:05:36',3310491629,1),(894259040,425376534,15865961,5671401,1,'2010-09-03 18:05:36',3310493013,1),(894259043,425183091,15647736,5671401,1,'2010-09-03 18:05:36',3310491616,1),(894259046,425376529,15849905,5671401,1,'2010-09-03 18:05:36',3310493013,1),(894259051,425330248,15799070,5671401,1,'2010-09-03 18:05:36',3310491643,1),(894259053,425176660,15665066,5671401,1,'2010-09-03 18:05:36',3310491575,1),(894259057,425287258,15761499,5671401,1,'2010-09-03 18:05:36',3310491640,1),(894259060,425318727,15820444,5671401,1,'2010-09-03 18:05:36',3310491643,1),(894259063,425287205,15793998,5671401,1,'2010-09-03 18:05:36',3310491631,1),(894259067,425206606,15684581,5671401,1,'2010-09-03 18:05:36',3310491619,1),(894259070,425296025,15764922,5671401,1,'2010-09-03 18:05:36',3310491640,1),(894259073,425388744,15860950,5671401,1,'2010-09-03 18:05:36',3310493013,1),(894259083,425270926,15765808,5671401,1,'2010-09-03 18:05:36',3310491631,1),(894259085,425378942,15836114,5671401,1,'2010-09-03 18:05:36',3310493013,1),(894259087,425541482,15905009,5671401,1,'2010-09-03 18:05:36',3310503955,1),(894259089,425303472,15795515,5671401,1,'2010-09-03 18:05:37',3310491642,1),(894259091,425352341,15818739,5671401,1,'2010-09-03 18:05:37',3310491646,1),(894259093,425312829,15785041,5671401,1,'2010-09-03 18:05:37',3310491642,1),(894259096,425271948,15764193,5671401,1,'2010-09-03 18:05:37',3310491629,1),(894259098,425178265,15674838,5671401,1,'2010-09-03 18:05:37',3310491618,1),(894259105,425281148,15766391,5671401,1,'2010-09-03 18:05:37',3310491631,1),(894259107,425386178,15867302,5671401,1,'2010-09-03 18:05:37',3310493013,1),(894259111,425290451,15791055,5671401,1,'2010-09-03 18:05:37',3310491642,1),(894259114,425185252,15649625,5671401,1,'2010-09-03 18:05:37',3310491616,1),(894259118,425187128,15652848,5671401,1,'2010-09-03 18:05:37',3310491616,1),(894259122,425306712,15775023,5671401,1,'2010-09-03 18:05:37',3310491642,1),(894259125,425343680,15820245,5671401,1,'2010-09-03 18:05:37',3310491646,1),(894259135,425180571,15641081,5671401,1,'2010-09-03 18:05:37',3310491616,1),(894259137,425279888,15770357,5671401,1,'2010-09-03 18:05:38',3310491631,1),(894259139,425545395,15904056,5671401,1,'2010-09-03 18:05:38',3310503955,1),(894259141,425295211,15787485,5671401,1,'2010-09-03 18:05:38',3310491642,1),(894259144,425356746,15831908,5671401,1,'2010-09-03 18:05:38',3310493012,1),(894259148,425247744,15746258,5671401,1,'2010-09-03 18:05:38',3310491628,1),(894259152,425290397,15763800,5671401,1,'2010-09-03 18:05:38',3310491640,1),(894259155,425383018,15872493,5671401,1,'2010-09-03 18:05:38',3310493013,1),(894259161,425307931,15800345,5671401,1,'2010-09-03 18:05:38',3310491642,1),(894259164,425278025,15795517,5671401,1,'2010-09-03 18:05:38',3310491631,1),(894259168,425381378,15863413,5671401,1,'2010-09-03 18:05:38',3310493013,1),(894259171,425187029,15658114,5671401,1,'2010-09-03 18:05:38',3310491618,1),(894259174,425299203,15760485,5671401,1,'2010-09-03 18:05:38',3310491640,1),(894259176,425179924,15671316,5671401,1,'2010-09-03 18:05:38',3310491618,1),(894259178,425277377,15765865,5671401,1,'2010-09-03 18:05:38',3310491631,1),(894259187,425299514,15793310,5671401,1,'2010-09-03 18:05:39',3310491642,1),(894259188,425351525,15835466,5671401,1,'2010-09-03 18:05:39',3310493012,1),(894259189,425510880,15911774,5671401,1,'2010-09-03 18:05:39',3310503954,1),(894259193,425510420,15908141,5671401,1,'2010-09-03 18:05:39',3310503954,1),(894259195,425194709,15664366,5671401,1,'2010-09-03 18:05:39',3310491618,1),(894259199,425175105,15682096,5671401,1,'2010-09-03 18:05:39',3310491575,1),(894259202,425298215,15763456,5671401,1,'2010-09-03 18:05:39',3310491640,1),(894259206,425391642,15869559,5671401,1,'2010-09-03 18:05:39',3310493013,1),(894259217,425313871,15805950,5671401,1,'2010-09-03 18:05:39',3310491642,1),(894259219,425184799,15652824,5671401,1,'2010-09-03 18:05:39',3310491616,1),(894259221,425299650,15793587,5671401,1,'2010-09-03 18:05:39',3310491642,1),(894259225,425178265,15657855,5671401,1,'2010-09-03 18:05:39',3310491618,1),(894259228,425332583,15809668,5671401,1,'2010-09-03 18:05:39',3310491643,1),(894259232,425507822,15910005,5671401,1,'2010-09-03 18:05:39',3310503954,1);
INSERT INTO `current_nodes` VALUES (894259236,425275035,15763719,5671401,1,'2010-09-03 18:05:40',3310491629,1),(894259242,425178798,15682705,5671401,1,'2010-09-03 18:05:40',3310491618,1),(894259245,425283281,15760103,5671401,1,'2010-09-03 18:05:40',3310491629,1),(894259248,425318160,15816754,5671401,1,'2010-09-03 18:05:40',3310491643,1),(894259251,425288203,15792580,5671401,1,'2010-09-03 18:05:40',3310491642,1),(894259254,425356057,15821937,5671401,1,'2010-09-03 18:05:40',3310493012,1),(894259257,425214044,15696253,5671401,1,'2010-09-03 18:05:40',3310491619,1),(894259261,425295660,15764199,5671401,1,'2010-09-03 18:05:40',3310491640,1),(894259262,425389741,15865141,5671401,1,'2010-09-03 18:05:40',3310493013,1),(894259271,425268669,15774836,5671401,1,'2010-09-03 18:05:40',3310491631,1),(894259274,425188125,15689614,5671401,1,'2010-09-03 18:05:40',3310491618,1),(894259276,425370358,15824904,5671401,1,'2010-09-03 18:05:40',3310493013,1),(894259278,425542466,15904179,5671401,1,'2010-09-03 18:05:40',3310503955,1),(894259280,425303123,15793988,5671401,1,'2010-09-03 18:05:40',3310491642,1),(894259282,425273393,15762852,5671401,1,'2010-09-03 18:05:40',3310491629,1),(894259284,425217702,15710386,5671401,1,'2010-09-03 18:05:40',3310491619,1),(894259294,425177011,15672826,5671401,1,'2010-09-03 18:05:40',3310491575,1),(894259295,425281380,15764069,5671401,1,'2010-09-03 18:05:41',3310491629,1),(894259297,425387912,15864303,5671401,1,'2010-09-03 18:05:41',3310493013,1),(894259300,425271817,15782338,5671401,1,'2010-09-03 18:05:41',3310491631,1),(894259303,425361810,15823408,5671401,1,'2010-09-03 18:05:41',3310493012,1),(894259307,425507782,15909421,5671401,1,'2010-09-03 18:05:41',3310503954,1),(894259310,425184846,15653509,5671401,1,'2010-09-03 18:05:41',3310491616,1),(894259313,425301916,15764251,5671401,1,'2010-09-03 18:05:41',3310491640,1),(894259318,425389884,15869430,5671401,1,'2010-09-03 18:05:41',3310493013,1),(894259320,425279508,15768551,5671401,1,'2010-09-03 18:05:41',3310491631,1),(894259324,425364323,15820268,5671401,1,'2010-09-03 18:05:41',3310491646,1),(894259328,425297645,15793041,5671401,1,'2010-09-03 18:05:41',3310491642,1),(894259331,425186302,15653071,5671401,1,'2010-09-03 18:05:41',3310491616,1),(894259334,425358272,15819097,5671401,1,'2010-09-03 18:05:41',3310491646,1),(894259335,425236640,15741184,5671401,1,'2010-09-03 18:05:41',3310491628,1),(894259337,425289032,15763989,5671401,1,'2010-09-03 18:05:41',3310491640,1),(894259344,425306402,15798993,5671401,1,'2010-09-03 18:05:42',3310491642,1),(894259348,425275500,15790922,5671401,1,'2010-09-03 18:05:42',3310491631,1),(894259351,425377414,15852717,5671401,1,'2010-09-03 18:05:42',3310493013,1),(894259353,425181002,15640562,5671401,1,'2010-09-03 18:05:42',3310491616,1),(894259356,425299188,15759268,5671401,1,'2010-09-03 18:05:42',3310491640,1),(894259358,425176422,15663390,5671401,1,'2010-09-03 18:05:42',3310491575,1),(894259360,425276571,15764627,5671401,1,'2010-09-03 18:05:42',3310491629,1),(894259370,425300497,15792359,5671401,1,'2010-09-03 18:05:42',3310491642,1),(894259372,425509808,15910837,5671401,1,'2010-09-03 18:05:42',3310503954,1),(894259375,425202974,15678142,5671401,1,'2010-09-03 18:05:42',3310491618,1),(894259379,425173926,15682164,5671401,1,'2010-09-03 18:05:42',3310491575,1),(894259382,425297804,15762198,5671401,1,'2010-09-03 18:05:42',3310491640,1),(894259386,425392497,15870203,5671401,1,'2010-09-03 18:05:42',3310493013,1),(894259390,425367486,15847716,5671401,1,'2010-09-03 18:05:42',3310493012,1),(894259394,425549048,15908555,5671401,1,'2010-09-03 18:05:42',3310503955,1),(894259398,425180306,15641388,5671401,1,'2010-09-03 18:05:43',3310491616,1),(894259402,425378849,15840837,5671401,1,'2010-09-03 18:05:43',3310493013,1),(894259405,425298726,15794287,5671401,1,'2010-09-03 18:05:43',3310491642,1),(894259408,425177754,15662578,5671401,1,'2010-09-03 18:05:43',3310491618,1),(894259411,425352637,15814848,5671401,1,'2010-09-03 18:05:43',3310491646,1),(894259414,425314528,15794458,5671401,1,'2010-09-03 18:05:43',3310491642,1),(894259417,425274503,15765142,5671401,1,'2010-09-03 18:05:43',3310491629,1),(894259424,425177695,15687674,5671401,1,'2010-09-03 18:05:43',3310491618,1),(894259427,425283733,15761844,5671401,1,'2010-09-03 18:05:43',3310491629,1),(894259431,425291835,15791592,5671401,1,'2010-09-03 18:05:43',3310491642,1),(894259433,425182343,15643125,5671401,1,'2010-09-03 18:05:43',3310491616,1),(894259435,425210741,15692577,5671401,1,'2010-09-03 18:05:43',3310491619,1),(894259437,425293334,15764261,5671401,1,'2010-09-03 18:05:43',3310491640,1),(894259439,425384220,15864233,5671401,1,'2010-09-03 18:05:43',3310493013,1),(894259449,425270124,15773022,5671401,1,'2010-09-03 18:05:44',3310491631,1),(894259451,425336966,15818445,5671401,1,'2010-09-03 18:05:44',3310491643,1),(894259453,425189375,15689562,5671401,1,'2010-09-03 18:05:44',3310491618,1),(894259456,425376344,15829879,5671401,1,'2010-09-03 18:05:44',3310493013,1),(894259459,425545972,15902973,5671401,1,'2010-09-03 18:05:44',3310503955,1),(894259462,425305528,15798390,5671401,1,'2010-09-03 18:05:44',3310491642,1),(894259465,425272268,15766009,5671401,1,'2010-09-03 18:05:44',3310491631,1),(894259468,425215910,15701707,5671401,1,'2010-09-03 18:05:44',3310491619,1),(894259473,425179691,15673239,5671401,1,'2010-09-03 18:05:44',3310491618,1),(894259476,425291089,15764582,5671401,1,'2010-09-03 18:05:44',3310491640,1),(894259480,425384206,15874234,5671401,1,'2010-09-03 18:05:44',3310493013,1),(894259483,425269025,15780323,5671401,1,'2010-09-03 18:05:44',3310491631,1),(894259486,425381971,15864663,5671401,1,'2010-09-03 18:05:44',3310493013,1),(894259489,425364976,15819426,5671401,1,'2010-09-03 18:05:44',3310491646,1),(894259492,425187622,15656154,5671401,1,'2010-09-03 18:05:44',3310491618,1),(894259499,425301471,15768241,5671401,1,'2010-09-03 18:05:44',3310491642,1),(894259503,425389290,15870268,5678739,1,'2010-09-04 16:07:27',3310493013,2),(894259507,425226567,15716967,5678739,1,'2010-09-04 16:07:30',3310491625,2),(894259509,425178322,15668777,5671401,1,'2010-09-03 18:05:45',3310491618,1),(894259511,425278670,15766339,5671401,1,'2010-09-03 18:05:45',3310491631,1),(894259513,425296806,15792694,5671401,1,'2010-09-03 18:05:45',3310491642,1),(894259515,425185446,15653303,5671401,1,'2010-09-03 18:05:45',3310491616,1),(894259525,425361665,15829201,5671401,1,'2010-09-03 18:05:45',3310493012,1),(894259527,425259867,15751024,5671401,1,'2010-09-03 18:05:45',3310491629,1),(894259529,425172644,15680921,5678739,1,'2010-09-04 16:07:26',3310491575,2),(894259531,425289212,15764347,5671401,1,'2010-09-03 18:05:45',3310491640,1),(894259533,425382674,15867785,5671401,1,'2010-09-03 18:05:45',3310493013,1),(894259536,425312200,15800282,5671401,1,'2010-09-03 18:05:45',3310491642,1),(894259540,425283142,15792902,5671401,1,'2010-09-03 18:05:45',3310491631,1),(894259547,425378824,15855917,5671401,1,'2010-09-03 18:05:45',3310493013,1),(894259550,425509554,15907168,5671401,1,'2010-09-03 18:05:45',3310503954,1),(894259553,425265419,15757481,5671401,1,'2010-09-03 18:05:46',3310491629,1),(894259556,425178510,15663755,5671401,1,'2010-09-03 18:05:46',3310491618,1),(894259559,425276161,15763533,5671401,1,'2010-09-03 18:05:46',3310491629,1),(894259562,425287015,15791612,5671401,1,'2010-09-03 18:05:46',3310491631,1),(894259565,425513663,15910594,5671401,1,'2010-09-03 18:05:46',3310503954,1),(894259570,425355422,15826242,5671401,1,'2010-09-03 18:05:46',3310493012,1),(894259572,425508688,15910979,5671401,1,'2010-09-03 18:05:46',3310503954,1),(894259576,425200274,15674454,5671401,1,'2010-09-03 18:05:46',3310491618,1),(894259580,425296618,15763849,5671401,1,'2010-09-03 18:05:46',3310491640,1),(894259582,425390739,15866334,5671401,1,'2010-09-03 18:05:46',3310493013,1),(894259585,425181494,15644109,5671401,1,'2010-09-03 18:05:46',3310491616,1),(894259587,425377736,15845748,5671401,1,'2010-09-03 18:05:46',3310493013,1),(894259590,425544461,15904018,5671401,1,'2010-09-03 18:05:46',3310503955,1),(894259600,425301754,15794504,5671401,1,'2010-09-03 18:05:46',3310491642,1),(894259602,425181328,15657351,5671401,1,'2010-09-03 18:05:46',3310491618,1),(894259604,425319343,15797917,5671401,1,'2010-09-03 18:05:47',3310491643,1),(894259607,425508435,15907310,5671401,1,'2010-09-03 18:05:47',3310503954,1),(894259610,425272982,15761387,5671401,1,'2010-09-03 18:05:47',3310491629,1),(894259613,425178322,15677263,5671401,1,'2010-09-03 18:05:47',3310491618,1),(894259617,425282687,15762295,5671401,1,'2010-09-03 18:05:47',3310491629,1),(894259622,425326770,15827516,5671401,1,'2010-09-03 18:05:47',3310493009,1),(894259624,425289326,15793180,5671401,1,'2010-09-03 18:05:47',3310491642,1),(894259627,425181234,15640280,5671401,1,'2010-09-03 18:05:47',3310491616,1),(894259630,425184769,15654716,5671401,1,'2010-09-03 18:05:47',3310491616,1),(894259633,425293562,15765004,5671401,1,'2010-09-03 18:05:47',3310491640,1),(894259636,425334701,15826747,5671401,1,'2010-09-03 18:05:47',3310493009,1),(894259639,425363296,15821565,5671401,1,'2010-09-03 18:05:47',3310493012,1),(894259641,425304772,15797450,5671401,1,'2010-09-03 18:05:47',3310491642,1),(894259650,425272800,15764998,5671401,1,'2010-09-03 18:05:47',3310491629,1),(894259654,425226895,15724888,5671401,1,'2010-09-03 18:05:47',3310491625,1),(894259658,425177866,15671614,5671401,1,'2010-09-03 18:05:47',3310491618,1),(894259660,425291897,15764687,5671401,1,'2010-09-03 18:05:48',3310491640,1),(894259662,425385014,15870590,5671401,1,'2010-09-03 18:05:48',3310493013,1),(894259664,425306594,15798464,5671401,1,'2010-09-03 18:05:48',3310491642,1),(894259665,425273659,15787497,5671401,1,'2010-09-03 18:05:48',3310491631,1),(894259666,425189667,15654086,5671401,1,'2010-09-03 18:05:48',3310491616,1),(894259676,425300207,15761042,5671401,1,'2010-09-03 18:05:48',3310491640,1),(894259678,425393305,15871009,5671401,1,'2010-09-03 18:05:48',3310493013,1),(894259680,425381827,15875013,5671401,1,'2010-09-03 18:05:48',3310493013,1),(894259682,425177771,15668699,5671401,1,'2010-09-03 18:05:48',3310491618,1),(894259683,425278772,15768519,5671401,1,'2010-09-03 18:05:48',3310491631,1),(894259685,425300365,15789392,5671401,1,'2010-09-03 18:05:48',3310491642,1),(894259687,425361757,15830649,5671401,1,'2010-09-03 18:05:48',3310493012,1),(894259697,425540606,15897700,5671401,1,'2010-09-03 18:05:48',3310503955,1),(894259698,425255448,15745028,5671401,1,'2010-09-03 18:05:48',3310491628,1),(894259699,425288399,15761724,5671401,1,'2010-09-03 18:05:48',3310491640,1),(894259700,425391381,15871074,5671401,1,'2010-09-03 18:05:48',3310493013,1),(894259702,425307885,15798078,5671401,1,'2010-09-03 18:05:48',3310491642,1),(894259703,425279658,15793220,5671401,1,'2010-09-03 18:05:48',3310491631,1),(894259706,425372402,15862025,5671401,1,'2010-09-03 18:05:48',3310493013,1),(894259708,425179007,15664530,5671401,1,'2010-09-03 18:05:48',3310491618,1),(894259720,425510525,15909661,5671401,1,'2010-09-03 18:05:49',3310503954,1),(894259721,425268138,15752407,5671401,1,'2010-09-03 18:05:49',3310491629,1),(894259722,425176643,15665802,5671401,1,'2010-09-03 18:05:49',3310491575,1),(894259724,425285681,15763295,5671401,1,'2010-09-03 18:05:49',3310491629,1),(894259726,425285779,15792934,5671401,1,'2010-09-03 18:05:49',3310491631,1),(894259729,425351525,15825873,5671401,1,'2010-09-03 18:05:49',3310493012,1),(894259732,425208555,15689257,5671401,1,'2010-09-03 18:05:49',3310491619,1),(894259742,425297789,15764385,5671401,1,'2010-09-03 18:05:49',3310491640,1),(894259743,425390478,15868430,5671401,1,'2010-09-03 18:05:49',3310493013,1),(894259746,425268580,15770523,5671401,1,'2010-09-03 18:05:49',3310491631,1),(894259748,425191217,15691376,5671401,1,'2010-09-03 18:05:49',3310491618,1),(894259750,425378200,15832209,5671401,1,'2010-09-03 18:05:49',3310493013,1),(894259753,425544958,15903626,5671401,1,'2010-09-03 18:05:49',3310503955,1),(894259757,425301115,15795907,5671401,1,'2010-09-03 18:05:49',3310491642,1),(894259760,425179286,15656469,5671401,1,'2010-09-03 18:05:49',3310491618,1),(894259773,425348716,15820707,5671401,1,'2010-09-03 18:05:50',3310493012,1),(894259774,425308800,15781793,5671401,1,'2010-09-03 18:05:50',3310491642,1),(894263141,425707227,16073404,5671416,1,'2010-09-03 18:07:15',3310504037,1),(894263144,425707743,16077527,5674807,1,'2010-09-04 01:51:19',3310504037,2),(895601487,425174397,15684365,5678739,1,'2010-09-04 16:07:24',3310491575,1),(895601493,425294753,15764194,5689624,1,'2010-09-05 19:39:54',3310491640,2),(895601494,425346685,15832592,5678739,1,'2010-09-04 16:07:26',3310493012,1),(895601497,425287186,15764638,5689624,1,'2010-09-05 19:39:54',3310491629,2),(895604180,425539600,15897529,5678757,1,'2010-09-04 16:09:45',3310503955,1),(897596948,425291301,15765317,5689624,1,'2010-09-05 19:39:54',3310491640,1),(899525861,426184590,16387810,5709666,1,'2010-09-07 19:40:48',3310504408,2),(899525869,425940070,14605920,5709666,1,'2010-09-07 19:40:47',3310502279,2),(899525876,424825580,16422520,5709666,1,'2010-09-07 19:40:45',3310492877,2),(899525898,426469440,15508330,5702328,1,'2010-09-06 23:22:37',3310503581,1),(899525904,424763610,15650620,5709666,1,'2010-09-07 19:40:50',3310491360,2),(899525912,426081690,14952580,5709666,1,'2010-09-07 19:40:49',3310502720,2),(899525929,426072220,17158330,5709666,1,'2010-09-07 19:40:49',3310504896,2),(899525940,424836000,16122000,5702328,1,'2010-09-06 23:22:38',3310492775,1),(899525948,425901360,14789490,5709666,1,'2010-09-07 19:40:48',3310502310,2),(899525953,424861000,16455000,5702328,1,'2010-09-06 23:22:39',3310492890,1),(899525975,425719980,17206050,5709666,1,'2010-09-07 19:40:49',3310504647,2),(899525984,425777800,14505560,5709666,1,'2010-09-07 19:40:49',3310502097,2),(899525989,425956410,16131340,5702328,1,'2010-09-06 23:22:39',3310504242,1),(899526014,426225220,15641120,5709666,1,'2010-09-07 19:40:47',3310502900,2),(899526022,425813680,14468050,5709666,1,'2010-09-07 19:40:45',3310502015,2),(899526028,425984770,14484790,5709666,1,'2010-09-07 19:40:47',3310502203,2),(899526049,424920840,15945300,5709666,1,'2010-09-07 19:40:45',3310492764,2),(899526058,426382620,15114130,5709666,1,'2010-09-07 19:40:48',3310503439,2),(899526069,426112590,16714670,5709666,1,'2010-09-07 19:40:49',3310504772,2),(899526084,424950030,16563870,5709666,1,'2010-09-07 19:40:46',3310492919,2),(899526090,425170220,16420430,5709666,1,'2010-09-07 19:40:45',3310493085,2),(899526097,424794440,15508330,5709666,1,'2010-09-07 19:40:46',3310491340,2),(899526119,424797410,15782230,5709666,1,'2010-09-07 19:40:46',3310491374,2),(899526127,425659140,16407390,5702328,1,'2010-09-06 23:22:43',3310504137,1),(899526136,424903000,16483000,5702328,1,'2010-09-06 23:22:44',3310492916,1),(899526171,426403520,15613140,5709666,1,'2010-09-07 19:40:46',3310503600,2),(899526182,424898370,16072010,5709666,1,'2010-09-07 19:40:46',3310492785,2),(899526219,425110830,16089280,5709666,1,'2010-09-07 19:40:47',3310492977,2),(899526225,426067770,15504990,5709666,1,'2010-09-07 19:40:48',3310502856,2),(899526237,425536730,16788800,5709666,1,'2010-09-07 19:40:47',3310504467,2),(899526263,426211260,15797730,5709666,1,'2010-09-07 19:40:50',3310502907,2),(899526271,424819000,16286000,5702328,1,'2010-09-06 23:22:46',3310492868,1),(899526282,425966360,17032970,5709666,1,'2010-09-07 19:40:45',3310504760,2),(901125108,425905560,14447220,5709666,1,'2010-09-07 19:40:44',3310502188,1),(901170351,426037248,14419302,5710014,1,'2010-09-07 20:17:59',3310502205,1),(915764943,425039559,17213375,5806005,1,'2010-09-17 21:28:31',3310493574,1),(915765142,425056591,17225403,5806005,1,'2010-09-17 21:28:37',3310493575,1),(915765201,425043596,17214595,5806005,1,'2010-09-17 21:28:38',3310493575,1),(915765239,425026228,17208244,5806005,1,'2010-09-17 21:28:39',3310493574,1),(915765418,425051124,17223931,5806005,1,'2010-09-17 21:28:44',3310493575,1),(915765496,425041325,17214132,5806005,1,'2010-09-17 21:28:46',3310493575,1),(915765630,425054783,17228136,5806005,1,'2010-09-17 21:28:52',3310493575,1),(915765650,425025092,17209170,5806005,1,'2010-09-17 21:28:53',3310493574,1),(915765686,425028078,17208202,5806005,1,'2010-09-17 21:28:54',3310493574,1),(915765778,425054404,17224435,5806005,1,'2010-09-17 21:28:59',3310493575,1),(915765801,425041746,17209548,5806005,1,'2010-09-17 21:29:01',3310493575,1),(915765885,425064077,17229188,5806005,1,'2010-09-17 21:29:06',3310493575,1),(915765906,425067609,17227505,5806005,1,'2010-09-17 21:29:08',3310493586,1),(915765922,425041872,17207235,5806005,1,'2010-09-17 21:29:09',3310493575,1),(915765994,425052680,17221744,5806005,1,'2010-09-17 21:29:14',3310493575,1),(915766018,425041157,17212071,5806005,1,'2010-09-17 21:29:16',3310493575,1),(915766099,425066263,17227463,5806005,1,'2010-09-17 21:29:21',3310493575,1),(915766108,425047801,17220440,5806005,1,'2010-09-17 21:29:22',3310493575,1),(915766135,425043007,17207319,5806005,1,'2010-09-17 21:29:24',3310493575,1),(915766204,425050367,17223426,5806005,1,'2010-09-17 21:29:28',3310493575,1),(915766227,425045993,17216067,5806005,1,'2010-09-17 21:29:29',3310493575,1),(915766317,425049946,17220608,5806005,1,'2010-09-17 21:29:34',3310493575,1),(915766344,425038423,17207530,5806005,1,'2010-09-17 21:29:35',3310493574,1),(915766418,425052638,17228935,5806005,1,'2010-09-17 21:29:39',3310493575,1),(915766445,425045110,17217538,5806005,1,'2010-09-17 21:29:40',3310493575,1),(915766458,425030139,17208749,5806005,1,'2010-09-17 21:29:41',3310493574,1),(915766604,425045825,17218422,5806005,1,'2010-09-17 21:29:45',3310493575,1),(915766632,425040316,17207866,5806005,1,'2010-09-17 21:29:47',3310493575,1),(915766711,425052301,17230702,5806005,1,'2010-09-17 21:29:51',3310493575,1),(915766737,425042376,17214511,5806005,1,'2010-09-17 21:29:53',3310493575,1),(915766750,425034344,17208076,5806005,1,'2010-09-17 21:29:54',3310493574,1),(915766830,425047002,17219347,5806005,1,'2010-09-17 21:29:58',3310493575,1),(924524128,425220136,15721537,5866082,1,'2010-09-24 23:06:23',3310491625,1);
INSERT INTO `current_relation_members` VALUES (7439,'way',8164186,'',1),(7439,'way',23305160,'',2),(8647,'way',8164186,'outer',2),(8647,'way',23305160,'outer',1),(9407,'node',58957648,'capital',1),(9407,'way',6165679,'',3),(9407,'way',8164186,'',2),(9407,'way',45511076,'',5),(9407,'way',45511084,'',4),(9407,'way',45511090,'',6),(82675,'way',23305160,'',1),(92863,'way',6165679,'outer',4),(92863,'way',23305160,'outer',5),(92863,'way',45511076,'outer',2),(92863,'way',45511084,'outer',3),(92863,'way',45511090,'outer',1),(126410,'way',8164186,'',1),(343017,'way',45511076,'',1),(346346,'way',45511090,'',1),(348990,'way',6165679,'',5),(348990,'way',23305160,'',4),(348990,'way',45511076,'',2),(348990,'way',45511084,'',1),(348990,'way',45511090,'',3),(348990,'relation',343017,'',6),(348990,'relation',346346,'',7),(349053,'way',6165679,'outer',2),(349053,'way',23305160,'outer',3),(349053,'way',45511076,'outer',5),(349053,'way',45511084,'outer',6),(349053,'way',45511090,'outer',4),(349053,'relation',348990,'subarea',1),(411235,'way',24406326,'inner',3),(411235,'way',50568365,'outer',1),(411235,'way',50568366,'inner',2),(463686,'node',669985285,'',1),(463686,'node',669985286,'',2),(463686,'node',669985287,'',3),(463686,'node',669985289,'',4),(463686,'node',669985291,'',5),(463692,'node',669985299,'',1),(463692,'node',669985301,'',2),(463708,'node',669985341,'',1),(463712,'node',669985348,'',1),(463875,'node',669985685,'',1),(463875,'node',669985690,'',2),(464189,'node',669986979,'',1),(464189,'node',669986980,'',2),(464189,'node',669986981,'',3),(464189,'node',669986982,'',4),(1161383,'way',6593464,'inner',2),(1161383,'way',17241049,'outer',1),(1181120,'way',77918991,'',1);
INSERT INTO `current_relation_tags` VALUES (7439,'admin_level','6'),(7439,'boundary','administrative'),(7439,'converted_by','Editop_2_OSM_v0016'),(7439,'name','Ariège'),(7439,'ref','09'),(7439,'type','boundary'),(8647,'admin_level','4'),(8647,'boundary','administrative'),(8647,'converted_by','Editop_2_OSM_v0016'),(8647,'name','Midi-Pyrénées'),(8647,'ref','73'),(8647,'ref_NUTS','FR62'),(8647,'type','boundary'),(9407,'admin_level','2'),(9407,'boundary','administrative'),(9407,'ISO3166-1','ad'),(9407,'name','Andorra'),(9407,'name:de','Andorra'),(9407,'name:en','Andorra'),(9407,'name:fr','Andorre'),(9407,'name:ru','???????'),(9407,'type','boundary'),(82675,'admin_level','2'),(82675,'boundary','administrative'),(82675,'name','Spain/France Boundary'),(82675,'name:de','Frankreich - Spanien'),(82675,'name:en','France - Spain'),(82675,'name:es','Frontera España/Francia'),(82675,'name:fr','Frontières Espagne/France'),(82675,'name:ru','??????? - ???????'),(82675,'note','For explanations please read http://wiki.openstreetmap.org/wiki/France_boundary_pyramidal_construction'),(82675,'type','boundary_segment'),(82675,'wikipedia:fr','Frontière entre l\'Espagne et la France'),(92863,'addr:country','ES'),(92863,'admin_level','2'),(92863,'boundary','administrative'),(92863,'currency','EUR'),(92863,'ISO3166-1','es'),(92863,'name','España'),(92863,'name:cs','Špan?lsko'),(92863,'name:de','Spanien'),(92863,'name:en','Spain'),(92863,'name:es','España'),(92863,'name:eu','Espainia'),(92863,'name:fr','Espagne'),(92863,'name:hr','Španjolska'),(92863,'name:pl','Hiszpania'),(92863,'name:ru','???????'),(92863,'name:sk','Španielsko'),(92863,'name:sv','Spanien'),(92863,'timezone','Europe/Madrid'),(92863,'type','boundary'),(92863,'wikipedia','Spain'),(126410,'admin_level','2'),(126410,'boundary','administrative'),(126410,'name','France/Andorra'),(126410,'name:de','Frankreich - Andorra'),(126410,'name:en','France - Andorra'),(126410,'name:ru','??????? - ???????'),(126410,'note','For explanations please read http://wiki.openstreetmap.org/wiki/France_boundary_pyramidal_construction'),(126410,'type','boundary_segment'),(343017,'admin_level','8'),(343017,'boundary','administrative'),(343017,'idee:name','Valls de Valira (Les)'),(343017,'ine:municipio','25239'),(343017,'is_in','Lleida, Cataluña, Spain'),(343017,'is_in:country','Spain'),(343017,'is_in:province','Lleida'),(343017,'is_in:region','Cataluña'),(343017,'name','Les Valls de Valira'),(343017,'source','BDLL25, EGRN, Instituto Geográfico Nacional'),(343017,'type','boundary'),(343017,'wikipedia','es:Les Valls de Valira'),(346346,'admin_level','8'),(346346,'boundary','administrative'),(346346,'idee:name','Lles de Cerdanya'),(346346,'ine:municipio','25127'),(346346,'is_in','Lleida, Cataluña, Spain'),(346346,'is_in:country','Spain'),(346346,'is_in:province','Lleida'),(346346,'is_in:region','Cataluña'),(346346,'name','Lles de Cerdanya'),(346346,'source','BDLL25, EGRN, Instituto Geográfico Nacional'),(346346,'type','boundary'),(346346,'wikipedia:es','Lles de Cerdanya'),(348990,'admin_level','6'),(348990,'boundary','administrative'),(348990,'ine:provincia','25'),(348990,'is_in','Cataluña, Spain'),(348990,'is_in:country','Spain'),(348990,'is_in:region','Cataluña'),(348990,'name','Lleida'),(348990,'name:eu','Lleida'),(348990,'source','BDLL25, EGRN, Instituto Geográfico Nacional'),(348990,'type','boundary'),(348990,'wikipedia:es','Lérida'),(349053,'admin_level','4'),(349053,'boundary','administrative'),(349053,'ine:ccaa','69'),(349053,'is_in','Spain'),(349053,'is_in:country','Spain'),(349053,'name','Catalunya'),(349053,'name:ca','Catalunya'),(349053,'name:es','Cataluña'),(349053,'name:eu','Katalunia'),(349053,'name:hr','Katalonija'),(349053,'name:sv','Katalonien'),(349053,'official_name:ca','Catalunya'),(349053,'official_name:es','Cataluña'),(349053,'official_name:oc','Catalunha'),(349053,'source','BDLL25, EGRN, Instituto Geográfico Nacional'),(349053,'timezone','Europe/Madrid'),(349053,'type','boundary'),(349053,'wikipedia:es','Cataluña'),(349053,'wikipedia:fr','Catalogne'),(411235,'CLC:code','321'),(411235,'CLC:id','FR-244978'),(411235,'CLC:year','2006'),(411235,'natural','grassland'),(411235,'source','Union européenne - SOeS, CORINE Land Cover, 2006.'),(411235,'type','multipolygon'),(463686,'name','Aston I'),(463686,'network','NTF-2'),(463686,'note','Serrhre'),(463686,'ref','0902401'),(463686,'site','geodesic'),(463686,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(463686,'type','site'),(463686,'url','http://ancien-geodesie.ign.fr/fiche_geodesie.asp?num_site=0902401&X=585217&Y=6170556'),(463692,'name','Aston VII'),(463692,'network','NTF-4'),(463692,'ref','0902407'),(463692,'site','geodesic'),(463692,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(463692,'type','site'),(463692,'url','http://ancien-geodesie.ign.fr/fiche_geodesie.asp?num_site=0902407&X=593082&Y=6170116'),(463708,'name','Auzat IV'),(463708,'network','NTF-3'),(463708,'ref','0903004'),(463708,'site','geodesic'),(463708,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(463708,'type','site'),(463708,'url','http://ancien-geodesie.ign.fr/fiche_geodesie.asp?num_site=0903004&X=571978&Y=6168377'),(463712,'name','Auzat VIII'),(463712,'network','NTF-4'),(463712,'ref','0903008'),(463712,'site','geodesic'),(463712,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(463712,'type','site'),(463712,'url','http://ancien-geodesie.ign.fr/fiche_geodesie.asp?num_site=0903008&X=574905&Y=6169576'),(463875,'name','L\'Hospitalet-près-l\'Andorre I'),(463875,'network','NTF-2'),(463875,'note','Roc Mili'),(463875,'ref','0913901'),(463875,'site','geodesic'),(463875,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(463875,'type','site'),(463875,'url','http://ancien-geodesie.ign.fr/fiche_geodesie.asp?num_site=0913901&X=596591&Y=6166165'),(464189,'name','Siguer I'),(464189,'network','NTF-2'),(464189,'ref','0929501'),(464189,'site','geodesic'),(464189,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(464189,'type','site'),(464189,'url','http://ancien-geodesie.ign.fr/fiche_geodesie.asp?num_site=0929501&X=579664&Y=6173342'),(1161383,'type','multipolygon'),(1181120,'name','GR-107'),(1181120,'network','GR'),(1181120,'ref','GR-107'),(1181120,'route','hiking'),(1181120,'type','route');
INSERT INTO `current_relations` VALUES (7439,4091122,'2010-03-10 18:50:41',1,38),(8647,5860604,'2010-09-24 10:54:43',1,236),(9407,3882859,'2010-02-15 14:55:48',1,9),(82675,5061350,'2010-06-23 23:00:46',1,72),(92863,5641978,'2010-08-31 06:40:04',1,125),(126410,3882859,'2010-02-15 14:55:34',1,5),(343017,3283462,'2009-12-03 21:55:40',1,2),(346346,3612902,'2010-01-13 23:29:28',1,3),(348990,4072906,'2010-03-08 17:51:40',1,5),(349053,5636480,'2010-08-30 16:59:53',1,18),(411235,3903073,'2010-02-17 20:32:43',1,1),(463686,4475595,'2010-04-20 12:48:43',1,2),(463692,4475595,'2010-04-20 12:48:44',1,2),(463708,4475595,'2010-04-20 12:48:46',1,2),(463712,4475595,'2010-04-20 12:48:47',1,2),(463875,4475595,'2010-04-20 12:49:29',1,2),(464189,4475595,'2010-04-20 12:50:09',1,2),(1161383,5674807,'2010-09-04 01:51:19',1,2),(1181120,5808039,'2010-09-18 01:40:20',1,2);
INSERT INTO `current_way_nodes` VALUES (6165450,51110488,1),(6165450,51110489,2),(6165450,51110491,3),(6165450,51110493,4),(6165450,51110495,5),(6165450,51110496,6),(6165450,51385320,7),(6165450,51110498,8),(6165450,51110499,9),(6165450,51110501,10),(6165450,281042725,11),(6165450,281042726,12),(6165450,281049690,13),(6165450,281069194,14),(6165450,281042331,15),(6165450,281042332,16),(6165450,281043016,17),(6165450,281049691,18),(6165450,51110502,19),(6165450,281042336,20),(6165450,281042337,21),(6165450,51110488,22),(6165679,45160958,1),(6165679,45160947,2),(6165679,45160950,3),(6165679,45160897,4),(6165679,45160899,5),(6165679,45160902,6),(6165679,45160904,7),(6165679,45160908,8),(6165679,45160910,9),(6165679,45160875,10),(6165679,45160879,11),(6165679,45160885,12),(6165679,45160890,13),(6165679,45160893,14),(6165679,579974347,15),(6165679,579974346,16),(6165877,51121339,1),(6165877,51121341,2),(6165877,51121342,3),(6165877,51120956,4),(6165877,51120957,5),(6165877,51120959,6),(6165877,51120868,7),(6165877,51120869,8),(6165877,51120871,9),(6165877,51120872,10),(6165877,51120873,11),(6165877,51120874,12),(6165877,51120876,13),(6165877,51342840,14),(6165944,625307,1),(6165944,278748317,2),(6165944,278748365,3),(6165944,51122790,4),(6165944,51122791,5),(6165944,51122792,6),(6165944,52792122,7),(6165944,51122793,8),(6165944,51122795,9),(6165944,51122796,10),(6165944,51122797,11),(6165944,51122798,12),(6165944,51122800,13),(6165944,51122801,14),(6165944,278748559,15),(6165944,51122802,16),(6165944,51122803,17),(6165944,51122804,18),(6165944,51122805,19),(6165944,51122806,20),(6165944,51122807,21),(6165944,278748954,22),(6165944,51122808,23),(6165944,51122809,24),(6165944,51122810,25),(6165944,51122811,26),(6165944,51122812,27),(6165944,51122814,28),(6165944,51122815,29),(6165944,51122816,30),(6165944,51122817,31),(6165944,51122819,32),(6165944,51122820,33),(6165944,51122821,34),(6165944,51122822,35),(6165944,51122823,36),(6165944,51122824,37),(6165944,51122825,38),(6165944,51122826,39),(6165944,51122827,40),(6165944,51122828,41),(6165944,51122829,42),(6165944,51122830,43),(6165944,51121951,44),(6165944,51121953,45),(6165944,51121955,46),(6165944,51121956,47),(6166082,625294,1),(6166082,51123907,2),(6166082,51123908,3),(6166082,51123909,4),(6166082,278748035,5),(6166082,51123910,6),(6166082,51123911,7),(6166082,625295,8),(6166082,51123912,9),(6166082,51123913,10),(6166082,625296,11),(6166082,51123914,12),(6166082,625297,13),(6166082,51123916,14),(6166082,51123917,15),(6166082,51123918,16),(6166082,625298,17),(6166082,51123919,18),(6166082,51123920,19),(6166082,51123921,20),(6166082,625299,21),(6166082,51123922,22),(6166082,625300,23),(6166082,51123924,24),(6166082,51123925,25),(6166082,51123926,26),(6166082,625301,27),(6166082,278748036,28),(6166082,625302,29),(6166082,51123262,30),(6166082,53274022,31),(6166082,625303,32),(6166082,51123230,33),(6166082,51123231,34),(6166082,51123232,35),(6166082,51123233,36),(6166082,625304,37),(6166082,51123235,38),(6166082,278748279,39),(6166082,625305,40),(6166082,51123236,41),(6166082,53273834,42),(6166123,625277,1),(6166123,51124486,2),(6166123,51124487,3),(6166123,51124488,4),(6166123,51124489,5),(6166123,51348096,6),(6166123,51124490,7),(6166123,51124044,8),(6166123,51124045,9),(6166123,625293,10),(6166123,51124046,11),(6166123,51124047,12),(6166123,51124048,13),(6166123,625294,14),(6166128,51125344,1),(6166128,625261,2),(6166128,51349842,3),(6166136,51125344,1),(6166136,51125330,2),(6166136,53274971,3),(6166136,53274968,4),(6166136,769252988,5),(6166136,51125332,6),(6166136,769252996,7),(6166136,769252999,8),(6166136,51125333,9),(6166136,51125414,10),(6166136,51125335,11),(6166136,769253007,12),(6166136,51125337,13),(6166136,51125340,14),(6166136,51125342,15),(6166136,769253012,16),(6166136,53274970,17),(6166136,769253015,18),(6166136,51125344,19),(6166145,51125478,1),(6166145,625260,2),(6166145,51125414,3),(6166185,51125904,1),(6166185,51125905,2),(6166185,625245,3),(6166185,51361715,4),(6166185,51125784,5),(6166185,51361716,6),(6166185,625246,7),(6166185,51125788,8),(6166185,51125724,9),(6166185,625247,10),(6176624,51120876,1),(6176624,51342907,2),(6176624,51342909,3),(6176624,51342910,4),(6176624,51342421,5),(6176624,51342422,6),(6176663,51342838,1),(6176663,769251786,2),(6176663,51342839,3),(6176663,769251787,4),(6176663,51342840,5),(6176663,51342841,6),(6176663,769251788,7),(6176663,51342842,8),(6176663,769251789,9),(6176663,51342843,10),(6176663,51343031,11),(6176663,51342844,12),(6176663,51342855,13),(6176663,51342845,14),(6176663,769251791,15),(6176663,51342846,16),(6176663,51342847,17),(6176663,51342848,18),(6176663,51342838,19),(6176681,51344677,1),(6176681,51345073,2),(6176681,51343103,3),(6176681,51342422,4),(6176681,51343029,5),(6176681,769251784,6),(6176681,51343031,7),(6176755,51344677,1),(6176755,796031914,2),(6176755,51344678,3),(6176755,796031930,4),(6176755,51344679,5),(6176755,796031933,6),(6176755,51344681,7),(6176755,796031937,8),(6176755,51344682,9),(6176755,51344683,10),(6176755,51344685,11),(6176755,796030198,12),(6176755,51344687,13),(6176755,796030199,14),(6176755,51344688,15),(6176755,769251804,16),(6176755,51344690,17),(6176755,796031941,18),(6177152,625277,1),(6177152,625276,2),(6177152,625275,3),(6177152,625274,4),(6177152,51124700,5),(6177152,51348571,6),(6177152,51124485,7),(6177152,51124484,8),(6177152,51124483,9),(6177152,625273,10),(6177152,625272,11),(6177152,51124895,12),(6177152,51124893,13),(6177152,51124892,14),(6177152,51348167,15),(6177152,625271,16),(6177152,51348165,17),(6177152,625270,18),(6177152,51124891,19),(6177152,51124890,20),(6177152,51124975,21),(6177152,625269,22),(6177152,625268,23),(6177152,625267,24),(6177152,51347752,25),(6177152,51125159,26),(6177152,51347926,27),(6177152,51347750,28),(6177152,51347925,29),(6177152,625266,30),(6177152,625265,31),(6177152,51125157,32),(6177152,51125155,33),(6177152,51125154,34),(6177152,51125152,35),(6177152,625264,36),(6177152,51348517,37),(6177152,625263,38),(6177152,51349842,39),(6177369,625256,1),(6177369,625257,2),(6177369,262892996,3),(6177399,625249,1),(6177399,625250,2),(6177399,625251,3),(6177399,51125733,4),(6177399,51350585,5),(6177399,51125734,6),(6177399,625252,7),(6177399,51125737,8),(6177399,51931105,9),(6177399,625254,10),(6177399,51125738,11),(6177399,51350385,12),(6177399,51350384,13),(6177399,625256,14),(6177409,625247,1),(6177409,625248,2),(6177409,51125727,3),(6177409,51125728,4),(6177409,51125730,5),(6177409,51125731,6),(6177409,51350698,7),(6177409,51350699,8),(6177409,51350700,9),(6177409,51350702,10),(6177409,625249,11),(6178503,51349842,1),(6178503,51360952,2),(6178503,51360953,3),(6178503,51360955,4),(6178503,51360957,5),(6178503,51360958,6),(6178503,51360960,7),(6178503,51360961,8),(6178503,51360963,9),(6178503,51360964,10),(6178503,51360965,11),(6178503,51360967,12),(6178503,51360968,13),(6178503,51360969,14),(6178503,51360970,15),(6178503,51360971,16),(6178503,51360974,17),(6178503,51360975,18),(6178503,51360976,19),(6178503,51360979,20),(6178503,51360980,21),(6178503,51360981,22),(6178503,51360982,23),(6178503,51360984,24),(6178503,51360985,25),(6178503,51360986,26),(6178503,51360987,27),(6178503,51360988,28),(6178503,51360990,29),(6178503,51360991,30),(6178503,51360992,31),(6178503,51360993,32),(6178503,51360994,33),(6178503,51360995,34),(6178503,51360996,35),(6178503,51360998,36),(6178503,625277,37),(6178632,51126213,1),(6178632,51126214,2),(6178632,51126215,3),(6178632,51126216,4),(6178632,625207,5),(6178632,51126217,6),(6178632,625208,7),(6178632,625209,8),(6178632,625210,9),(6178632,51361816,10),(6178632,625211,11),(6178632,51361817,12),(6178632,51126218,13),(6178632,51126219,14),(6178632,625243,15),(6178632,51126221,16),(6178632,51126223,17),(6178632,51361728,18),(6178632,625244,19),(6178632,51126225,20),(6178632,51126226,21),(6178632,51125904,22),(6178685,51362477,1),(6178685,51362475,2),(6178685,625090,3),(6178685,51362474,4),(6178685,625089,5),(6178685,51362471,6),(6178685,51362531,7),(6178685,625088,8),(6178685,625087,9),(6178685,625086,10),(6178685,51387092,11),(6178685,51362529,12),(6178685,51362572,13),(6178685,625085,14),(6178685,625084,15),(6178685,51362570,16),(6178685,51362569,17),(6178688,51362569,1),(6178688,51362612,2),(6178688,51362613,3),(6178688,51362614,4),(6178688,51362854,5),(6178688,51362856,6),(6178688,51362857,7),(6178688,51362858,8),(6178688,51362860,9),(6178688,51362861,10),(6178688,51362863,11),(6178688,51362864,12),(6178688,51362865,13),(6178688,51362867,14),(6178688,51362868,15),(6178688,51362870,16),(6178688,51362871,17),(6178688,51362872,18),(6178688,51362477,19),(6178694,51362477,1),(6178694,625091,2),(6178694,625198,3),(6178694,51362153,4),(6178694,894259307,5),(6178791,625070,1),(6178791,625073,2),(6178791,51973538,3),(6178791,625074,4),(6178791,625075,5),(6178791,51363149,6),(6178791,625076,7),(6178791,51363105,8),(6178791,625077,9),(6178791,51363107,10),(6178791,51363109,11),(6178791,51363076,12),(6178791,51363078,13),(6178791,51363079,14),(6178791,51363022,15),(6178964,51364728,1),(6178964,51364730,2),(6178964,51364732,3),(6178964,51364733,4),(6178964,51364728,5),(6178980,51364894,1),(6178980,51364896,2),(6178980,51364898,3),(6178980,51364899,4),(6178980,51364894,5),(6179103,625033,1),(6179103,625071,2),(6179103,625034,3),(6179103,51366154,4),(6179103,51366157,5),(6179103,625035,6),(6179103,51366010,7),(6179103,51366011,8),(6179103,625036,9),(6179103,51366015,10),(6179103,51366017,11),(6179103,51386795,12),(6179103,625037,13),(6179174,259406445,1),(6179174,625029,2),(6179174,625028,3),(6179174,51366776,4),(6179174,51366775,5),(6179174,51366773,6),(6179174,625027,7),(6179174,51366772,8),(6179174,51366769,9),(6179174,625026,10),(6179174,625025,11),(6179174,51366858,12),(6179174,51366854,13),(6179174,625024,14),(6179174,625023,15),(6179174,625022,16),(6179174,51366992,17),(6179174,51366991,18),(6179174,51367842,19),(6179174,51367819,20),(6179240,51367555,1),(6179240,51367558,2),(6179240,51367559,3),(6179240,51367806,4),(6179240,51367563,5),(6179240,51367565,6),(6179240,51367819,7),(6179240,51367555,8),(6179270,51384490,1),(6179270,51371386,2),(6179470,51369359,1),(6179470,51369361,2),(6179470,51369362,3),(6179470,51369364,4),(6179470,51369359,5),(6179561,51370189,1),(6179561,51370191,2),(6179561,51370193,3),(6179561,51370194,4),(6179561,51370196,5),(6179561,51370197,6),(6179561,51370198,7),(6179561,51370199,8),(6179561,51370201,9),(6179561,51370202,10),(6179561,51370203,11),(6179561,51370206,12),(6179561,51370208,13),(6179561,51370210,14),(6179561,51370211,15),(6179561,51370213,16),(6179561,51370260,17),(6179561,51370189,18),(6179675,52688728,1),(6179675,52688859,2),(6179675,51369142,3),(6179675,51369145,4),(6179675,51399321,5),(6179675,51369146,6),(6179675,51369147,7),(6179675,51369148,8),(6179675,51400970,9),(6179675,51369150,10),(6179675,51369153,11),(6179675,51369155,12),(6179675,51369157,13),(6179675,51369159,14),(6179675,51369160,15),(6179675,51369162,16),(6179675,51369164,17),(6179675,51369165,18),(6179675,51369168,19),(6179675,51369170,20),(6179675,51369171,21),(6179675,51369173,22),(6179675,51367748,23),(6179675,51367752,24),(6179675,51367755,25),(6179675,51367756,26),(6179675,51367760,27),(6179675,51367761,28),(6179675,51367762,29),(6179675,51367763,30),(6179675,51367764,31),(6179675,51367767,32),(6179675,535386385,33),(6179692,51371386,1),(6179692,51371387,2),(6179692,51371388,3),(6179692,51371389,4),(6179692,51371391,5),(6179692,51371392,6),(6179692,51371395,7),(6179692,281059700,8),(6180790,281050523,1),(6180790,51385271,2),(6180790,51385267,3),(6180790,51385266,4),(6180790,51385264,5),(6180790,51385261,6),(6180790,51385259,7),(6180790,51385256,8),(6180790,51385251,9),(6180790,51110502,10),(6180839,51385334,1),(6180839,51385336,2),(6180840,51386301,1),(6180840,51386302,2),(6180840,51386304,3),(6180840,51386307,4),(6180840,51386309,5),(6180840,51386312,6),(6180840,51386315,7),(6180840,51386316,8),(6180840,51386319,9),(6180840,51386320,10),(6180840,51386324,11),(6180840,51386327,12),(6180840,52252315,13),(6180840,51386330,14),(6180840,51386331,15),(6180840,51386333,16),(6180840,51385966,17),(6180840,51385967,18),(6180840,51385970,19),(6180840,51385971,20),(6180840,51385973,21),(6180840,51385974,22),(6180840,51385975,23),(6180840,51385976,24),(6180840,796040771,25),(6180840,51385978,26),(6180840,51385979,27),(6180840,51385982,28),(6180840,51385983,29),(6180840,51385985,30),(6180840,52009129,31),(6180840,51385986,32),(6180840,51385988,33),(6180840,51385990,34),(6180840,51385991,35),(6180840,51385994,36),(6180840,51385996,37),(6180840,51385997,38),(6180840,52009156,39),(6180840,51386001,40),(6180840,51386002,41),(6180840,51386005,42),(6180840,51386008,43),(6180840,51386009,44),(6180840,51386011,45),(6180840,51386013,46),(6180840,51386014,47),(6180840,51386018,48),(6180840,51386019,49),(6180840,51386021,50),(6180840,51385349,51),(6180840,51385334,52),(6180852,51385336,1),(6180852,51385320,2),(6180968,625037,1),(6180968,625038,2),(6180968,625039,3),(6180968,51366022,4),(6180968,51366025,5),(6180968,51366028,6),(6180968,625040,7),(6180968,270729579,8),(6180968,51366033,9),(6180968,625041,10),(6180968,51366035,11),(6180968,625042,12),(6180968,51366036,13),(6180968,51366037,14),(6180968,625043,15),(6180968,51366039,16),(6180968,51365354,17),(6180968,51365356,18),(6180968,625044,19),(6180977,625044,1),(6180977,51365357,2),(6180977,625045,3),(6180985,625045,1),(6180985,51364998,2),(6180985,51365000,3),(6180985,625046,4),(6180985,270730270,5),(6180985,625047,6),(6180985,51365004,7),(6180985,625048,8),(6180985,625049,9),(6180985,51450178,10),(6180988,51363022,1),(6180988,625078,2),(6180988,51363024,3),(6180988,625079,4),(6180988,625080,5),(6180988,51362929,6),(6180988,51362931,7),(6180988,51362932,8),(6180988,625081,9),(6180988,625082,10),(6180988,625083,11),(6180988,51362569,12),(6181319,51389997,1),(6181319,51389999,2),(6181319,51390001,3),(6181319,51390003,4),(6181319,51390006,5),(6181319,51390008,6),(6181319,51390010,7),(6181319,51390012,8),(6181319,51390014,9),(6181319,51390016,10),(6181357,51392412,1),(6181357,51392415,2),(6181357,51392416,3),(6181357,51392417,4),(6181357,51392418,5),(6181357,51392420,6),(6181357,51392422,7),(6181357,51392424,8),(6181357,51392426,9),(6181357,51392429,10),(6181357,51392430,11),(6181357,51392432,12),(6181357,51392434,13),(6181357,51392435,14),(6181357,51392436,15),(6181357,51392437,16),(6181357,51392439,17),(6181357,51392441,18),(6181357,51392442,19),(6181357,51392445,20),(6181357,51392447,21),(6181419,51391054,1),(6181419,51391055,2),(6181419,51391057,3),(6181419,51391058,4),(6181419,51391060,5),(6181419,51391063,6),(6181419,51391064,7),(6181419,51391065,8),(6181419,51391067,9),(6181836,51396271,1),(6181836,51120891,2),(6181838,51396983,1),(6181838,51396985,2),(6181838,51396986,3),(6181838,51396989,4),(6181838,51396991,5),(6181838,51396992,6),(6181838,51396993,7),(6181838,51396996,8),(6181838,51396997,9),(6181838,51396999,10),(6181838,51397000,11),(6181838,51397003,12),(6181838,51397004,13),(6181838,51397005,14),(6181838,51397008,15),(6181838,51397009,16),(6181838,51397010,17),(6181838,51397012,18),(6181838,51397013,19),(6181838,51397015,20),(6181838,51397016,21),(6181838,51397017,22),(6181838,51397019,23),(6181838,51397021,24),(6181838,51397022,25),(6181838,51397024,26),(6181838,51397026,27),(6181838,51397027,28),(6181838,51397028,29),(6181838,51397029,30),(6181838,51397032,31),(6181838,51396360,32),(6181838,51396361,33),(6181838,51396363,34),(6181838,51397034,35),(6181838,51396365,36),(6181838,51396367,37),(6181838,51396369,38),(6181838,51396370,39),(6181838,51396371,40),(6181838,51396373,41),(6181838,51396374,42),(6181838,51396375,43),(6181838,51396377,44),(6181838,51396271,45),(6181838,51396378,46),(6181838,51396380,47),(6181838,51396399,48),(6181947,53273756,1),(6181947,53273755,2),(6181947,53273754,3),(6181947,53273753,4),(6181947,53273752,5),(6181947,53273751,6),(6181947,53273750,7),(6181947,53273749,8),(6181947,53273748,9),(6181947,53273747,10),(6181947,53273746,11),(6181947,53273745,12),(6181947,53273744,13),(6181947,53273743,14),(6181947,53273742,15),(6181947,53273741,16),(6181947,53273740,17),(6181947,53273739,18),(6181947,53273738,19),(6181947,53273737,20),(6181947,53273736,21),(6181947,53273735,22),(6181947,53273734,23),(6181947,53273733,24),(6181947,53273732,25),(6181947,53273731,26),(6181947,53273730,27),(6181947,53273729,28),(6181947,53273728,29),(6181947,53273727,30),(6181947,53273726,31),(6181947,53273725,32),(6181947,53273724,33),(6181947,53273723,34),(6181947,53273719,35),(6181947,53273716,36),(6181947,53273715,37),(6181947,53273714,38),(6181947,53273713,39),(6181947,53273712,40),(6181947,53273711,41),(6181947,53273710,42),(6181947,53273709,43),(6181947,53273708,44),(6181947,53273707,45),(6181947,53273706,46),(6181947,53273705,47),(6181947,53273704,48),(6181947,53273703,49),(6181947,53273702,50),(6181947,53273701,51),(6181947,53273700,52),(6181947,53273699,53),(6181947,53273698,54),(6181947,53273697,55),(6181947,53273696,56),(6181947,53273695,57),(6181947,53273694,58),(6181947,53273693,59),(6181947,53273692,60),(6181947,53273691,61),(6181947,53273690,62),(6181947,53273689,63),(6181947,53273688,64),(6181947,53273687,65),(6181947,53273686,66),(6181947,53273685,67),(6181947,53273684,68),(6181947,53273683,69),(6181947,53273682,70),(6181947,53273681,71),(6181947,53273680,72),(6181947,53273679,73),(6181947,53273678,74),(6181947,53273677,75),(6181947,53273676,76),(6181947,53273675,77),(6181947,53273674,78),(6181947,53273673,79),(6181947,53273672,80),(6181947,53273671,81),(6181947,53273670,82),(6181947,53273669,83),(6181947,53273668,84),(6181947,53273667,85),(6181947,51398098,86),(6181947,51398099,87),(6181947,51398048,88),(6181947,51398049,89),(6181947,51398053,90),(6181947,51398054,91),(6181947,51398057,92),(6181947,51398058,93),(6181947,51398059,94),(6181947,51398060,95),(6181947,51398063,96),(6181947,51398065,97),(6181947,51398068,98),(6181947,51398069,99),(6181947,51397727,100),(6181947,51397729,101),(6181947,51397731,102),(6181947,51397732,103),(6181947,51397733,104),(6181947,51397734,105),(6181947,51397737,106),(6181947,51397738,107),(6181947,51397740,108),(6181947,51397742,109),(6181947,51397744,110),(6181947,51397748,111),(6181947,51397749,112),(6181947,51397752,113),(6181947,51397753,114),(6181947,51397756,115),(6181947,51397757,116),(6181947,51397758,117),(6181947,51397762,118),(6181947,51397764,119),(6181947,51397766,120),(6181947,51397769,121),(6181947,51397770,122),(6181947,51397771,123),(6181947,51397772,124),(6181947,51397773,125),(6181947,51397776,126),(6181947,51397777,127),(6181947,51397779,128),(6181947,51397781,129),(6181947,51397782,130),(6181947,51397783,131),(6181947,51397786,132),(6181947,51397788,133),(6181947,51397790,134),(6181947,51397791,135),(6181947,51397794,136),(6181947,51397795,137),(6181947,51397796,138),(6181947,51397798,139),(6181947,51397799,140),(6181947,51397802,141),(6181947,51397803,142),(6181947,51397806,143),(6181947,51397808,144),(6181947,51397810,145),(6181947,51397813,146),(6181947,51397814,147),(6181947,51397815,148),(6181947,51397816,149),(6181947,51397818,150),(6181947,51397819,151),(6181947,51397821,152),(6181947,51397822,153),(6181947,51397824,154),(6181947,51397825,155),(6181947,51397826,156),(6181947,51397828,157),(6181947,51397829,158),(6181947,51397830,159),(6181947,51397831,160),(6181947,51397832,161),(6181947,51397834,162),(6181947,51397835,163),(6181947,51397837,164),(6182051,51399278,1),(6182051,51399409,2),(6182051,51399277,3),(6182051,51399602,4),(6182051,51399275,5),(6182051,51410491,6),(6182051,51399273,7),(6182051,51399272,8),(6182051,51399270,9),(6182051,51399299,10),(6182051,51399309,11),(6182051,51399269,12),(6182051,51399266,13),(6182051,51399265,14),(6182051,52688698,15),(6182051,52688701,16),(6182051,52688703,17),(6182052,51399285,1),(6182052,51399303,2),(6182052,51410792,3),(6182052,51399272,4),(6182052,51399289,5),(6182053,51399296,1),(6182053,51399306,2),(6182053,51410790,3),(6182053,51399299,4),(6182054,51399406,1),(6182054,51399335,2),(6182054,51399409,3),(6182054,51399398,4),(6182054,51399411,5),(6182056,268633715,1),(6182056,51399325,2),(6182056,51399326,3),(6182056,51399327,4),(6182056,51399398,5),(6182056,51399329,6),(6182056,52688876,7),(6182056,52688880,8),(6182057,51399335,1),(6182057,51399337,2),(6182057,51410490,3),(6182058,51399377,1),(6182058,51399304,2),(6182058,51410791,3),(6182058,51399380,4),(6182058,51399270,5),(6182058,51446997,6),(6182058,51447331,7),(6182058,51399381,8),(6182065,51399602,1),(6182065,52688880,2),(6182065,51399601,3),(6182097,51441626,1),(6182097,51441625,2),(6182097,51441623,3),(6182097,51441621,4),(6182097,51441619,5),(6182097,51441616,6),(6182097,51443695,7),(6182097,51441615,8),(6182097,51441611,9),(6182097,51441610,10),(6182097,51441607,11),(6182097,51441603,12),(6182097,51441659,13),(6182097,51400247,14),(6182097,51404720,15),(6182097,51400250,16),(6182097,51404888,17),(6182097,51400253,18),(6182097,51400254,19),(6182097,51399406,20),(6182097,51405087,21),(6182097,51400256,22),(6182097,268633715,23),(6182097,51400257,24),(6182097,337767559,25),(6182097,337739581,26),(6182122,51448405,1),(6182122,51448408,2),(6182122,278721406,3),(6182127,51400970,1),(6182127,51400971,2),(6182127,51400863,3),(6182127,51400866,4),(6182127,51400868,5),(6182127,51400869,6),(6182127,51400870,7),(6182159,51401444,1),(6182159,51401446,2),(6182159,51401447,3),(6182159,51401449,4),(6182159,51401451,5),(6182159,51401452,6),(6182159,51405729,7),(6182159,51401454,8),(6182267,51402983,1),(6182267,51402986,2),(6182267,51402987,3),(6182267,51402989,4),(6182278,51403223,1),(6182278,646807844,2),(6182278,51403224,3),(6182278,646807845,4),(6182278,51403225,5),(6182278,646807846,6),(6182278,51403226,7),(6182278,646807847,8),(6182278,51403228,9),(6182278,646807848,10),(6182278,51403229,11),(6182278,646807849,12),(6182278,51403231,13),(6182278,51403861,14),(6182278,51403232,15),(6182278,646807852,16),(6182278,646807855,17),(6182278,51403234,18),(6182278,51403223,19),(6182289,51403229,1),(6182289,51403654,2),(6182289,51403656,3),(6182289,51403657,4),(6182289,51403659,5),(6182289,51403661,6),(6182289,268630128,7),(6182303,51404073,1),(6182303,51403850,2),(6182303,51403851,3),(6182303,51403852,4),(6182303,51403854,5),(6182303,51403857,6),(6182303,51403858,7),(6182303,51403859,8),(6182303,51403861,9),(6182333,51404062,1),(6182333,646807701,2),(6182333,51404061,3),(6182333,646807706,4),(6182333,51404074,5),(6182333,646807713,6),(6182333,51404073,7),(6182333,646807720,8),(6182333,51404071,9),(6182333,51404069,10),(6182333,51404274,11),(6182333,51404067,12),(6182333,646807752,13),(6182333,51404066,14),(6182333,51404486,15),(6182333,646807770,16),(6182333,51404063,17),(6182333,646807785,18),(6182333,51404062,19),(6182349,51404272,1),(6182349,51404274,2),(6182350,51404282,1),(6182350,51404272,2),(6182364,51404888,1),(6182364,51404887,2),(6182364,51404949,3),(6182364,264290433,4),(6182364,51405091,5),(6182364,51404886,6),(6182364,264294525,7),(6182364,51404884,8),(6182364,264305363,9),(6182364,51404883,10),(6182364,270723120,11),(6182364,51404882,12),(6182371,51406244,1),(6182371,51972984,2),(6182371,51972980,3),(6182371,51405527,4),(6182371,51405528,5),(6182371,51405530,6),(6182371,51405533,7),(6182371,51405534,8),(6182371,51405536,9),(6182371,51405537,10),(6182371,51410094,11),(6182386,51400253,1),(6182386,277694146,2),(6182386,51404947,3),(6182386,277694080,4),(6182386,51404949,5),(6182401,51405087,1),(6182401,277694081,2),(6182401,51405091,3),(6182410,51405261,1),(6182410,646808595,2),(6182410,51405263,3),(6182410,646808596,4),(6182410,51405265,5),(6182410,51405266,6),(6182410,646808597,7),(6182410,51409972,8),(6182410,646808603,9),(6182410,51405268,10),(6182410,646808608,11),(6182410,51405269,12),(6182410,51405270,13),(6182410,264330870,14),(6182410,51405271,15),(6182410,264294716,16),(6182410,51405273,17),(6182410,646808624,18),(6182410,51405344,19),(6182410,51405261,20),(6182463,51406116,1),(6182463,51405712,2),(6182463,51405715,3),(6182463,51405716,4),(6182463,277695167,5),(6182505,51406111,1),(6182505,646808843,2),(6182505,646808846,3),(6182505,51406112,4),(6182505,51406811,5),(6182505,646808852,6),(6182505,51406113,7),(6182505,646808857,8),(6182505,646808861,9),(6182505,51406114,10),(6182505,646808867,11),(6182505,51406244,12),(6182505,646808879,13),(6182505,51406115,14),(6182505,646808882,15),(6182505,646808883,16),(6182505,51406116,17),(6182505,51406117,18),(6182505,646808884,19),(6182505,51406111,20),(6182542,51552500,1),(6182542,51552497,2),(6182542,52170040,3),(6182577,51407218,1),(6182577,51407219,2),(6182577,51407220,3),(6182577,51407222,4),(6182577,51407223,5),(6182577,51407226,6),(6182577,51407227,7),(6182577,51407228,8),(6182577,51407231,9),(6182577,51407232,10),(6182577,51407234,11),(6182577,51407235,12),(6182577,51407236,13),(6182577,51407238,14),(6182577,51407240,15),(6182577,51407243,16),(6182577,51407245,17),(6182577,51407247,18),(6182577,51407708,19),(6182577,51407709,20),(6182577,51407712,21),(6182577,51407714,22),(6182577,51407715,23),(6182577,51407716,24),(6182577,51408917,25),(6182577,51407718,26),(6182577,51407719,27),(6182577,51407720,28),(6182577,51407723,29),(6182577,51407725,30),(6182577,51407726,31),(6182577,51407728,32),(6182577,51407729,33),(6182577,51407731,34),(6182577,51407733,35),(6182577,51407736,36),(6182577,51407738,37),(6182577,51407739,38),(6182577,51407740,39),(6182577,51407742,40),(6182577,51407743,41),(6182577,51407744,42),(6182577,51407746,43),(6182577,51407747,44),(6182577,51407749,45),(6182577,51407751,46),(6182577,51407753,47),(6182577,51407754,48),(6182577,51407756,49),(6182577,51407759,50),(6182577,51407760,51),(6182577,51407764,52),(6182577,51407765,53),(6182577,51407766,54),(6182577,51407767,55),(6182577,51407769,56),(6182577,51407773,57),(6182577,51407774,58),(6182577,51407775,59),(6182577,51407778,60),(6182577,51407779,61),(6182577,51407781,62),(6182577,51407782,63),(6182577,51407784,64),(6182577,51407785,65),(6182577,51407786,66),(6182577,51407787,67),(6182577,51407789,68),(6182577,51407790,69),(6182577,51407791,70),(6182577,51408269,71),(6182577,51408270,72),(6182577,51408271,73),(6182577,51408274,74),(6182577,51408275,75),(6182577,51408278,76),(6182577,51408279,77),(6182577,51408280,78),(6182577,51408281,79),(6182577,51408282,80),(6182577,51408283,81),(6182577,51408284,82),(6182577,51408285,83),(6182577,51408286,84),(6182577,51408287,85),(6182577,51408288,86),(6182577,51408289,87),(6182577,51408290,88),(6182577,51408292,89),(6182577,51408294,90),(6182577,51408296,91),(6182577,51408299,92),(6182577,51408300,93),(6182577,51408302,94),(6182577,51408305,95),(6182577,51408306,96),(6182577,51408307,97),(6182577,51408310,98),(6182577,51408311,99),(6182675,51408485,1),(6182675,51408486,2),(6182675,51408490,3),(6182675,51408491,4),(6182675,51408492,5),(6182675,51408495,6),(6182675,51408496,7),(6182675,51408497,8),(6182675,51408498,9),(6182675,51408499,10),(6182675,51407231,11),(6182714,51408872,1),(6182714,51408873,2),(6182714,51408874,3),(6182714,51408875,4),(6182714,51408876,5),(6182714,51408879,6),(6182714,51408880,7),(6182714,51408883,8),(6182714,51408884,9),(6182714,51408885,10),(6182714,51408887,11),(6182714,51408889,12),(6182714,51408891,13),(6182714,51408892,14),(6182714,51408893,15),(6182714,51408896,16),(6182714,51408897,17),(6182714,51408898,18),(6182714,51408900,19),(6182714,51408902,20),(6182714,51408904,21),(6182714,51408905,22),(6182714,51408906,23),(6182714,51408909,24),(6182714,51408910,25),(6182714,51408911,26),(6182714,51408912,27),(6182714,51408913,28),(6182714,51408914,29),(6182714,51408915,30),(6182714,51408916,31),(6182714,51408917,32),(6182761,51409972,1),(6182761,51409974,2),(6182765,51410094,1),(6182765,51410095,2),(6182771,51410232,1),(6182771,51410233,2),(6182773,51410286,1),(6182773,51410282,2),(6182798,51410490,1),(6182798,51410491,2),(6182798,51410493,3),(6182798,51410494,4),(6182798,51410495,5),(6182810,51410786,1),(6182810,51410787,2),(6182810,51410788,3),(6182810,51410790,4),(6182810,51410791,5),(6182810,51410792,6),(6182810,51410490,7),(6182844,51411056,1),(6182844,51411057,2),(6182844,51411059,3),(6182844,51411060,4),(6182844,51411061,5),(6182844,51411062,6),(6182844,51411056,7),(6182932,51369109,1),(6182932,51412202,2),(6182932,51412201,3),(6182932,51412200,4),(6182932,51412199,5),(6182932,51412198,6),(6182932,51412197,7),(6182932,51412196,8),(6182932,51412195,9),(6182932,51412192,10),(6182932,51412189,11),(6182932,51412187,12),(6182932,51412185,13),(6182932,51412183,14),(6182932,51412181,15),(6182932,51412180,16),(6182932,51412179,17),(6182932,51412176,18),(6182932,51412175,19),(6182932,51412173,20),(6182932,51412171,21),(6182932,51412170,22),(6182932,51412169,23),(6182932,51412168,24),(6182932,51412167,25),(6182932,51412164,26),(6182932,51412163,27),(6182932,51412161,28),(6182932,51412159,29),(6182932,51412158,30),(6182932,51412157,31),(6182932,51412154,32),(6182932,51412152,33),(6182932,51412150,34),(6182932,51412148,35),(6182932,51412147,36),(6182932,51412144,37),(6182932,51412143,38),(6182932,51412142,39),(6182932,51412141,40),(6182932,51412138,41),(6182932,51412137,42),(6182932,51412136,43),(6182932,51412134,44),(6182932,51412132,45),(6182932,51412131,46),(6182932,51412128,47),(6182932,51412126,48),(6182932,51412125,49),(6182932,51412123,50),(6182932,51412122,51),(6182932,51412121,52),(6182932,51412119,53),(6182932,51412117,54),(6182932,51412116,55),(6182932,51412115,56),(6182932,51412112,57),(6182932,51412110,58),(6182932,51412109,59),(6182932,51412107,60),(6182932,51412106,61),(6182932,51412105,62),(6182932,51412103,63),(6182932,51412102,64),(6182932,51412100,65),(6182932,51412099,66),(6182932,52733223,67),(6182932,51412096,68),(6182932,51412095,69),(6182932,51412094,70),(6182932,51412093,71),(6182932,51412092,72),(6182932,51412091,73),(6182932,51412090,74),(6182932,51412087,75),(6182932,51412086,76),(6182932,51412083,77),(6182932,51412082,78),(6182932,51413104,79),(6182932,51413103,80),(6182932,51413100,81),(6182932,51413099,82),(6182932,51413097,83),(6182932,51413096,84),(6182932,51413094,85),(6182932,51413093,86),(6182932,51413091,87),(6182932,51413090,88),(6182932,51413087,89),(6182932,51413086,90),(6182932,51413085,91),(6182932,51413084,92),(6182932,51413083,93),(6182932,51413082,94),(6182932,51413079,95),(6182932,51413078,96),(6182932,51413075,97),(6182932,51413074,98),(6182932,51413073,99),(6182932,51413072,100),(6182932,51413071,101),(6182932,51413068,102),(6182932,51413067,103),(6182932,51413066,104),(6182932,51413065,105),(6182932,51413063,106),(6182932,51413061,107),(6182932,51413060,108),(6182932,51413058,109),(6182932,51413057,110),(6182932,51413055,111),(6182932,51413054,112),(6182932,51413053,113),(6182932,51413052,114),(6182932,51413050,115),(6182932,51413048,116),(6182932,51413047,117),(6182932,51413044,118),(6182932,51413043,119),(6182932,51413042,120),(6182932,51413041,121),(6182932,51413039,122),(6182932,51413038,123),(6182932,51413037,124),(6182932,51413035,125),(6182932,51413034,126),(6182932,51413033,127),(6182932,51413031,128),(6182932,51413029,129),(6182932,51413028,130),(6182932,51413027,131),(6182932,51413026,132),(6182932,51413024,133),(6182932,51413023,134),(6182932,51413021,135),(6182932,51413020,136),(6182932,51413018,137),(6182932,51413017,138),(6182932,51413014,139),(6182932,51413013,140),(6182932,51413011,141),(6182932,51413009,142),(6182932,51413008,143),(6182932,51413007,144),(6182932,51413006,145),(6182932,51413005,146),(6182932,51413004,147),(6182932,51413001,148),(6182932,51413000,149),(6182932,51412999,150),(6182932,51412998,151),(6182932,51412995,152),(6182932,51412994,153),(6182932,51413854,154),(6182932,51413412,155),(6182932,51413411,156),(6182932,51414092,157),(6182932,51414091,158),(6182932,51414090,159),(6182932,51414089,160),(6182932,51414087,161),(6182932,51414085,162),(6182932,51414084,163),(6182932,51414083,164),(6182932,51414082,165),(6182932,51414079,166),(6182932,51414078,167),(6182932,51414077,168),(6182932,51414076,169),(6182932,51414074,170),(6182932,51414072,171),(6182932,51414070,172),(6182932,51414069,173),(6182932,51414067,174),(6182932,51414065,175),(6182932,51414064,176),(6182932,51414063,177),(6182932,51414062,178),(6182932,51414061,179),(6182932,51414060,180),(6182932,51414057,181),(6182932,51414056,182),(6182932,51414055,183),(6182932,51414054,184),(6182932,51414053,185),(6182932,51414052,186),(6182932,51414051,187),(6182932,51414050,188),(6182932,51414049,189),(6182932,51414046,190),(6182932,51414045,191),(6182932,51414044,192),(6182932,51414041,193),(6182932,51414040,194),(6182932,51414036,195),(6182932,51414034,196),(6182932,51414033,197),(6182932,51414032,198),(6182932,51414031,199),(6182932,51414030,200),(6182932,51414028,201),(6182932,51414027,202),(6182932,51414025,203),(6182932,51414024,204),(6182932,51414023,205),(6182932,51414022,206),(6182932,51414021,207),(6182932,51414020,208),(6182932,51414019,209),(6182932,51414018,210),(6182932,51414017,211),(6182932,51414015,212),(6183078,51413826,1),(6183078,51413827,2),(6183078,51413832,3),(6183078,51413833,4),(6183078,51413835,5),(6183100,535385847,1),(6183100,51415016,2),(6183100,51415017,3),(6183100,51415018,4),(6183100,51415019,5),(6183100,51415021,6),(6183100,51415023,7),(6183100,51415024,8),(6183100,51415026,9),(6183100,51415027,10),(6183100,51415028,11),(6183100,51415030,12),(6183100,51415032,13),(6183100,51415033,14),(6183100,51415034,15),(6183100,51415035,16),(6183100,51415036,17),(6183100,51415039,18),(6183100,51415041,19),(6183100,51415042,20),(6183100,51415045,21),(6183100,51415046,22),(6183100,51416264,23),(6183100,51415047,24),(6183100,51415048,25),(6183100,51415049,26),(6183100,51415050,27),(6183100,51415051,28),(6183100,51415052,29),(6183100,51415053,30),(6183100,51415055,31),(6183100,51415249,32),(6183100,51415251,33),(6183100,51415253,34),(6183100,51415255,35),(6183100,51415257,36),(6183100,51415258,37),(6183100,51415781,38),(6183100,51415783,39),(6183100,51415785,40),(6183100,51415788,41),(6183100,51415790,42),(6183100,51415795,43),(6183100,51415796,44),(6183100,51415798,45),(6183100,51416727,46),(6183100,51416729,47),(6183100,51416731,48),(6183100,51416732,49),(6183100,51416733,50),(6183100,51416734,51),(6183100,51416735,52),(6183100,51416736,53),(6183100,51416737,54),(6183100,51416739,55),(6183100,51416740,56),(6183100,51416741,57),(6183100,51416743,58),(6183100,51416744,59),(6183100,51416746,60),(6183100,51416747,61),(6183100,51416748,62),(6183100,51416749,63),(6183100,51416750,64),(6183100,51416753,65),(6183100,51416754,66),(6183100,51416755,67),(6183100,51416756,68),(6183100,51416757,69),(6183100,51416758,70),(6183100,51416760,71),(6183100,51416761,72),(6183100,51416762,73),(6183100,51416763,74),(6183100,51416764,75),(6183100,51416765,76),(6183100,51416767,77),(6183100,51416768,78),(6183100,51416769,79),(6183100,51416770,80),(6183100,51416771,81),(6183100,51416772,82),(6183100,51416774,83),(6183100,51416775,84),(6183100,51416776,85),(6183100,51416779,86),(6183100,51416780,87),(6183100,51416781,88),(6183100,51416782,89),(6183100,51416783,90),(6183100,51416785,91),(6183100,51416786,92),(6183100,51416787,93),(6183100,51416789,94),(6183100,51416790,95),(6183100,51417251,96),(6183100,51417252,97),(6183100,51417253,98),(6183100,51417260,99),(6183100,51417263,100),(6183100,51417265,101),(6183100,51417268,102),(6183100,51417269,103),(6183100,51417272,104),(6183100,51417275,105),(6183100,51417277,106),(6183100,51417284,107),(6183100,51417285,108),(6183100,51417288,109),(6183100,51417289,110),(6183100,51417398,111),(6183100,51417291,112),(6183100,51417294,113),(6183100,51417298,114),(6183100,51420037,115),(6183100,51420038,116),(6183100,51420040,117),(6183100,51420042,118),(6183100,51420044,119),(6183100,51420045,120),(6183100,51420046,121),(6183100,51420048,122),(6183100,51420050,123),(6183100,51420052,124),(6183100,51420054,125),(6183100,51420057,126),(6183100,51420058,127),(6183100,51420059,128),(6183100,51420061,129),(6183100,51420063,130),(6183100,51420066,131),(6183100,51420067,132),(6183100,51420068,133),(6183100,51420072,134),(6183100,51420073,135),(6183100,51420076,136),(6183100,51420078,137),(6183100,51420079,138),(6183100,51420081,139),(6183100,51420084,140),(6183100,51420451,141),(6183100,51420452,142),(6183100,51420453,143),(6183100,51420454,144),(6183100,51420456,145),(6183100,51420457,146),(6183100,51420458,147),(6183100,51420461,148),(6183100,51420462,149),(6183100,51420464,150),(6183100,51420465,151),(6183100,51420466,152),(6183100,51420467,153),(6183100,51420469,154),(6183100,51420471,155),(6183100,51420474,156),(6183100,51420475,157),(6183100,51420476,158),(6183100,51420477,159),(6183100,51420893,160),(6183100,51420894,161),(6183100,51420895,162),(6183100,51420896,163),(6183100,51420899,164),(6183100,51420900,165),(6183100,51420902,166),(6183100,51420906,167),(6183100,51420908,168),(6183100,51420910,169),(6183100,51420912,170),(6183100,51420914,171),(6183100,51420916,172),(6183100,51420919,173),(6183100,51420921,174),(6183100,51420922,175),(6183100,51420926,176),(6183100,51420928,177),(6183100,51420929,178),(6183100,51420932,179),(6183100,51420933,180),(6183100,51420935,181),(6183100,51420938,182),(6183100,51420939,183),(6183100,51420940,184),(6183100,51420942,185),(6183100,51420945,186),(6183100,51420946,187),(6183100,51420950,188),(6183100,51420951,189),(6183100,51420952,190),(6183100,51420955,191),(6183100,51420956,192),(6183100,51420957,193),(6183100,51420958,194),(6183100,51420961,195),(6183100,51420964,196),(6183100,51420967,197),(6183100,51420968,198),(6183100,51420969,199),(6183100,51420970,200),(6183127,51414414,1),(6183127,51414415,2),(6183127,51414416,3),(6183127,51414417,4),(6183127,51414418,5),(6183127,51414419,6),(6183127,51414420,7),(6183127,51414421,8),(6183127,51414422,9),(6183127,51414423,10),(6183127,51414424,11),(6183127,51414425,12),(6183127,51414426,13),(6183127,51414428,14),(6183127,51414429,15),(6183127,51414430,16),(6183127,51414431,17),(6183127,51414432,18),(6183127,51414433,19),(6183127,51414434,20),(6183127,51414436,21),(6183127,51414437,22),(6183127,51414438,23),(6183127,51414439,24),(6183127,51414440,25),(6183169,51415055,1),(6183169,51415057,2),(6183169,51415059,3),(6183169,51415060,4),(6183169,51415061,5),(6183169,51415062,6),(6183169,51415066,7),(6183169,51415068,8),(6183169,51415069,9),(6183169,51414257,10),(6183169,51414258,11),(6183169,51414259,12),(6183169,51414262,13),(6183169,51414263,14),(6183169,51414264,15),(6183169,51414266,16),(6183169,51414267,17),(6183169,51414269,18),(6183169,51414270,19),(6183169,51414271,20),(6183169,51414273,21),(6183169,51414274,22),(6183169,51414276,23),(6183169,51414440,24),(6183169,51414277,25),(6183169,51414278,26),(6183169,51414279,27),(6183169,51414280,28),(6183169,51414283,29),(6183169,51414284,30),(6183169,51414285,31),(6183169,51414286,32),(6183169,51414288,33),(6183169,51414289,34),(6183169,51414290,35),(6183169,51414167,36),(6183169,51414169,37),(6183169,51414015,38),(6183270,51416291,1),(6183270,51416292,2),(6183270,51416294,3),(6183270,51416297,4),(6183270,51416298,5),(6183270,51416299,6),(6183273,51415798,1),(6183273,51416340,2),(6183273,51416343,3),(6183273,51416345,4),(6183273,51416349,5),(6183273,51416351,6),(6183273,51416352,7),(6183273,51416353,8),(6183273,51416354,9),(6183273,51416356,10),(6183273,51416357,11),(6183273,51416359,12),(6183273,51416361,13),(6183273,51416364,14),(6183273,51416365,15),(6183273,51416366,16),(6183273,51416367,17),(6183273,51416370,18),(6183273,51416371,19),(6183273,51416372,20),(6183273,51416375,21),(6183273,51416376,22),(6183273,51416379,23),(6183273,51416380,24),(6183273,51416381,25),(6183273,51416382,26),(6183273,51416299,27),(6183273,51416264,28),(6183357,51417410,1),(6183357,51417414,2),(6183357,51417416,3),(6183357,51417419,4),(6183357,51417420,5),(6183357,51417488,6),(6183357,51417421,7),(6183357,51417398,8),(6183360,51417467,1),(6183360,51417468,2),(6183360,51417469,3),(6183360,51417472,4),(6183360,51417476,5),(6183360,51417481,6),(6183360,51417482,7),(6183360,51417484,8),(6183360,51417488,9),(6183573,51421275,1),(6183573,51421278,2),(6183573,51421280,3),(6183573,51421281,4),(6183573,51421284,5),(6183573,51413835,6),(6183573,51421287,7),(6183573,51421289,8),(6183573,51421291,9),(6183573,51421294,10),(6183573,51421295,11),(6183573,51421296,12),(6183573,51421297,13),(6183573,51413854,14),(6184947,51438191,1),(6184947,51438193,2),(6184947,51438194,3),(6184947,51438195,4),(6184947,51438191,5),(6185032,51439215,1),(6185032,51439216,2),(6185060,51440235,1),(6185060,51439552,2),(6185090,51439943,1),(6185090,51439944,2),(6185090,51439947,3),(6185090,51439949,4),(6185090,51439951,5),(6185090,51439953,6),(6185090,51439955,7),(6185090,51439959,8),(6185090,51439960,9),(6185090,51439962,10),(6185090,51439964,11),(6185090,51439967,12),(6185090,51385276,13),(6185110,51441848,1),(6185110,52688934,2),(6185110,52688931,3),(6185110,52688929,4),(6185110,51438631,5),(6185110,51438632,6),(6185110,324270172,7),(6185110,324270173,8),(6185110,324270174,9),(6185122,51441848,1),(6185122,51441849,2),(6185122,51441850,3),(6185149,51440620,1),(6185149,51440622,2),(6185336,51442349,1),(6185336,51442351,2),(6185336,51442352,3),(6185353,51442529,1),(6185353,51442532,2),(6185363,51442648,1),(6185363,51442649,2),(6185363,51442651,3),(6185363,51442653,4),(6185394,51442942,1),(6185394,51442943,2),(6185394,51442944,3),(6185394,51442946,4),(6185394,51442947,5),(6185394,51442949,6),(6185394,51442951,7),(6185394,51442952,8),(6185394,51442953,9),(6185394,51442955,10),(6185394,51442956,11),(6185394,51442957,12),(6185394,51442958,13),(6185394,51442959,14),(6185394,51442960,15),(6185394,51442961,16),(6185421,51443310,1),(6185421,51443312,2),(6185421,51443313,3),(6185421,51443314,4),(6185421,51443315,5),(6185421,51443317,6),(6185421,51443319,7),(6185589,51444884,1),(6185589,51444885,2),(6185589,51445067,3),(6185589,51445068,4),(6185589,51445069,5),(6185589,51445070,6),(6185589,51445071,7),(6185589,51445073,8),(6185611,51445276,1),(6185611,51445277,2),(6185611,51445278,3),(6185611,51445071,4),(6185640,51445785,1),(6185640,51445766,2),(6185640,51445767,3),(6185640,51445769,4),(6185640,51445772,5),(6185640,51445774,6),(6185640,51441619,7),(6185710,51446293,1),(6185710,51446294,2),(6185710,51446295,3),(6185710,51446297,4),(6185710,51446298,5),(6185710,51446299,6),(6185710,51446300,7),(6185710,51446302,8),(6185710,51446303,9),(6185710,51446306,10),(6185710,51446307,11),(6185710,51446309,12),(6185710,51446312,13),(6185710,51446293,14),(6185726,51443676,1),(6185726,51446677,2),(6185726,51446679,3),(6185726,51446680,4),(6185726,51446682,5),(6185726,51446684,6),(6185726,51446687,7),(6185726,51446688,8),(6185726,51446690,9),(6185726,51446485,10),(6185726,51446486,11),(6185726,51446487,12),(6185726,51446490,13),(6185726,51446491,14),(6185726,51446492,15),(6185726,51446494,16),(6185775,51447331,1),(6185775,51399289,2),(6185775,51410493,3),(6185775,51399292,4),(6185775,52688810,5),(6185795,51400267,1),(6185795,51447714,2),(6185800,51400267,1),(6185800,51400269,2),(6185800,51401461,3),(6185800,51400270,4),(6185800,51400272,5),(6185807,51400263,1),(6185807,51400871,2),(6185807,51400264,3),(6185807,51400768,4),(6185807,51400267,5),(6185826,270726771,1),(6185826,51448127,2),(6185826,51447714,3),(6185826,270725952,4),(6185878,270723459,1),(6185878,51448537,2),(6185878,51448538,3),(6185878,270723936,4),(6185878,51448539,5),(6185878,51448541,6),(6185878,270723937,7),(6185878,270725823,8),(6185911,51448926,1),(6185911,51448928,2),(6185911,51448929,3),(6185911,51448931,4),(6185911,51448934,5),(6185911,51449177,6),(6185911,51448936,7),(6185911,51448937,8),(6185911,51450767,9),(6185911,51448938,10),(6185911,51448940,11),(6185926,51449055,1),(6185926,51449056,2),(6185926,51449057,3),(6185926,51449058,4),(6185926,51449060,5),(6185926,51449062,6),(6185926,51449148,7),(6185926,51449064,8),(6185930,51449177,1),(6185930,51449178,2),(6185930,51449179,3),(6185930,51449130,4),(6185930,51449133,5),(6185930,51449134,6),(6185930,51449137,7),(6185930,51449139,8),(6185930,51449140,9),(6185930,51449148,10),(6185971,51363247,1),(6185971,51363248,2),(6185971,625069,3),(6185971,51363250,4),(6185971,625070,5),(6185986,51450303,1),(6185986,625050,2),(6185986,51364400,3),(6185986,625051,4),(6185986,51363884,5),(6185986,270733583,6),(6185986,625052,7),(6185986,625053,8),(6185986,625054,9),(6185986,270733584,10),(6185986,625055,11),(6185986,51448830,12),(6185986,625056,13),(6185986,625057,14),(6185986,51363795,15),(6185986,894217189,16),(6185986,51448926,17),(6185986,625058,18),(6185986,51363797,19),(6185986,625059,20),(6185986,894259411,21),(6185986,51363800,22),(6185986,894259334,23),(6185986,625060,24),(6185986,894259303,25),(6185986,625061,26),(6185986,625062,27),(6185986,51363565,28),(6185986,51363567,29),(6185986,625072,30),(6185986,51363568,31),(6185986,625063,32),(6185986,894259390,33),(6185986,625064,34),(6185986,51363414,35),(6185986,625065,36),(6185986,625066,37),(6185986,51363415,38),(6185986,625067,39),(6185986,51363244,40),(6185986,51363246,41),(6185986,625068,42),(6185986,259406980,43),(6185986,51363248,44),(6185988,51363247,1),(6185988,51449552,2),(6185988,51449553,3),(6185988,51449672,4),(6185988,51449673,5),(6185988,51449675,6),(6185988,51449676,7),(6185988,51449997,8),(6185988,51449998,9),(6185988,51449999,10),(6185988,51450002,11),(6185988,51450003,12),(6185988,51450004,13),(6185988,51450007,14),(6185988,51450008,15),(6185988,51450009,16),(6185988,51450011,17),(6185988,51450013,18),(6185988,51450014,19),(6185988,51450016,20),(6185988,51450017,21),(6185988,51450019,22),(6186037,51450106,1),(6186037,769252942,2),(6186037,270730467,3),(6186037,51450107,4),(6186037,270730923,5),(6186037,51450110,6),(6186037,51450178,7),(6186037,51450111,8),(6186037,769252948,9),(6186037,51450113,10),(6186037,51450114,11),(6186037,769252949,12),(6186037,51450116,13),(6186037,769252950,14),(6186037,51450118,15),(6186037,769252951,16),(6186037,51450303,17),(6186037,51450106,18),(6186094,51450764,1),(6186094,51450766,2),(6186094,51450767,3),(6195793,51552500,1),(6195793,52170032,2),(6195793,52170036,3),(6195793,52170031,4),(6195793,51552507,5),(6195793,51552509,6),(6195793,51552513,7),(6195793,51552516,8),(6195793,51552518,9),(6195794,51552518,1),(6195794,51552546,2),(6195794,52170099,3),(6195795,51552589,1),(6195795,51552592,2),(6195796,51552592,1),(6195796,51552555,2),(6195797,51552592,1),(6195797,51552550,2),(6195885,51554707,1),(6195885,51552875,2),(6195885,51554710,3),(6195885,51554712,4),(6195885,51554715,5),(6195885,51554716,6),(6195885,51554685,7),(6195885,51554688,8),(6195885,51554691,9),(6195885,51554693,10),(6195885,51554694,11),(6195885,51554697,12),(6195885,51554700,13),(6195885,51554703,14),(6195885,51554705,15),(6195885,51554707,16),(6196087,51554700,1),(6196087,51557999,2),(6196407,51558293,1),(6196407,51558295,2),(6196407,51558298,3),(6196407,51558301,4),(6196407,51558304,5),(6196407,51558305,6),(6196407,51563059,7),(6196407,51563061,8),(6196407,51563063,9),(6196407,51563066,10),(6196407,51563071,11),(6196407,51563075,12),(6196407,51563076,13),(6196407,51563080,14),(6196407,51563083,15),(6196407,51563087,16),(6196407,51563090,17),(6196407,51563094,18),(6196407,51563098,19),(6196407,51563100,20),(6196407,51563103,21),(6196407,51563105,22),(6196407,51563108,23),(6196407,51563110,24),(6196407,51563113,25),(6196407,51563115,26),(6196407,51563118,27),(6196407,51563120,28),(6196407,51563122,29),(6196407,51563124,30),(6196407,51563127,31),(6196407,51563130,32),(6196407,51563134,33),(6196407,51563137,34),(6196407,51563140,35),(6196407,51563141,36),(6196407,51563145,37),(6196407,51563148,38),(6196407,51563152,39),(6196407,51563155,40),(6196407,51563159,41),(6196407,51563162,42),(6196407,51563164,43),(6196407,51563168,44),(6196407,51563170,45),(6196407,51563173,46),(6196407,51563176,47),(6196407,51563177,48),(6196407,51563179,49),(6196407,51563181,50),(6196407,51563185,51),(6196407,51563189,52),(6196407,51563192,53),(6196407,51563195,54),(6196407,51563197,55),(6196407,51563199,56),(6196407,51563200,57),(6196407,51563202,58),(6196407,51563205,59),(6196407,51563210,60),(6196407,51563214,61),(6196407,51563216,62),(6196407,51563224,63),(6196407,51563226,64),(6196407,51563230,65),(6196407,51563233,66),(6196407,51563236,67),(6196407,51563238,68),(6196407,51563242,69),(6196407,51563244,70),(6196407,51563247,71),(6196407,51563252,72),(6196407,51563255,73),(6196407,51563257,74),(6196407,51563261,75),(6196407,51563266,76),(6196407,51563268,77),(6196407,51563272,78),(6196407,51563276,79),(6196407,51563279,80),(6196407,51563281,81),(6196407,53368932,82),(6196407,51563284,83),(6196407,51563374,84),(6196407,51563375,85),(6196407,51563437,86),(6196407,51563439,87),(6196407,51563440,88),(6196407,53371129,89),(6196407,51563441,90),(6196407,51563442,91),(6196407,51563443,92),(6196407,51563447,93),(6196407,51563450,94),(6196407,51563451,95),(6196407,51563453,96),(6196407,51563454,97),(6196407,51563456,98),(6196407,51563458,99),(6196407,51563460,100),(6196407,51563462,101),(6196407,51563463,102),(6196407,51563466,103),(6196407,51563470,104),(6196407,51563472,105),(6196407,51563474,106),(6196407,51563477,107),(6196407,51563480,108),(6196407,51563481,109),(6196407,51563484,110),(6196407,51563485,111),(6196407,51563488,112),(6196407,51563490,113),(6196407,51563492,114),(6196407,51563494,115),(6196407,51563496,116),(6196407,51563499,117),(6196407,53371134,118),(6196407,53371138,119),(6196407,53371141,120),(6196407,53371144,121),(6196407,53371154,122),(6196407,53371160,123),(6196407,53371174,124),(6196407,53371181,125),(6196407,53371551,126),(6196407,53371691,127),(6196407,53371748,128),(6196407,53371859,129),(6196407,53371756,130),(6196407,53371761,131),(6196407,53371763,132),(6196407,53371771,133),(6196407,53371778,134),(6196407,53371784,135),(6196407,53371787,136),(6196407,53371793,137),(6196407,53371799,138),(6196407,53371862,139),(6196407,53371868,140),(6196407,53371873,141),(6196407,53371881,142),(6196407,53371890,143),(6196407,53371908,144),(6196407,53371942,145),(6196407,53371951,146),(6196407,53371955,147),(6196407,53371958,148),(6196407,53371963,149),(6196407,53371969,150),(6196407,53371993,151),(6196407,53371998,152),(6196407,53372005,153),(6196407,53372015,154),(6196407,53372021,155),(6196407,53372044,156),(6196407,53372056,157),(6196407,53372063,158),(6196407,53372072,159),(6196407,53372078,160),(6196407,53372086,161),(6196407,53372094,162),(6196407,53372108,163),(6196407,53372121,164),(6196407,53372132,165),(6196407,53372138,166),(6196407,53372143,167),(6196407,53372151,168),(6196407,53372163,169),(6196407,53372180,170),(6196407,53372190,171),(6196407,53372197,172),(6196407,53376964,173),(6196407,53372208,174),(6196407,53372217,175),(6196407,53372225,176),(6196407,53372232,177),(6196407,53372242,178),(6196407,53372246,179),(6196407,53372255,180),(6196407,53372261,181),(6196407,53372271,182),(6196407,53372278,183),(6196407,53372284,184),(6196407,53372290,185),(6196407,53372297,186),(6196407,53372305,187),(6196407,53372352,188),(6196407,53372357,189),(6196407,53372365,190),(6196407,53372381,191),(6196407,53372404,192),(6196407,53372410,193),(6196407,53372412,194),(6196407,53372413,195),(6196407,53372418,196),(6196407,53372422,197),(6196407,53372427,198),(6196407,53372432,199),(6196407,53372437,200),(6196407,53372442,201),(6196407,53372446,202),(6196407,53372456,203),(6196407,53372458,204),(6196407,53372462,205),(6196407,53372466,206),(6196407,53372476,207),(6196407,53372487,208),(6196407,53372493,209),(6196407,53372501,210),(6196407,53372509,211),(6196407,53372513,212),(6196407,53372518,213),(6196407,53372522,214),(6196407,53372527,215),(6196407,53372535,216),(6196407,53372541,217),(6196407,53372544,218),(6196407,53372549,219),(6196407,53372555,220),(6196407,53372562,221),(6196407,53372568,222),(6196407,53372577,223),(6196407,53372587,224),(6196407,53372608,225),(6196407,53372614,226),(6196407,53372629,227),(6196407,53372637,228),(6196407,53372777,229),(6196407,53372794,230),(6196407,53372806,231),(6196407,53372815,232),(6196407,53372828,233),(6196407,53372832,234),(6196407,53372838,235),(6196407,53372843,236),(6196407,53372852,237),(6196407,53372858,238),(6196407,53372863,239),(6196407,53372873,240),(6196407,53372879,241),(6196407,53372887,242),(6196407,53372892,243),(6196407,53372903,244),(6196407,53372912,245),(6196407,53372917,246),(6196407,53372927,247),(6196407,53372935,248),(6196407,53372942,249),(6196407,53372956,250),(6196407,53372965,251),(6196407,53372978,252),(6196407,53372982,253),(6196407,53372991,254),(6196407,53373005,255),(6196407,53373016,256),(6196407,53373029,257),(6196407,53373035,258),(6196407,53373049,259),(6196407,53373068,260),(6196407,53373079,261),(6196407,53373094,262),(6196407,53373107,263),(6196407,53373114,264),(6196407,53373121,265),(6196407,53373130,266),(6196407,53373163,267),(6196407,53373182,268),(6196407,53373197,269),(6196407,53373203,270),(6196407,53373215,271),(6196407,53373224,272),(6196407,53373230,273),(6196407,53373233,274),(6196407,53373241,275),(6196407,53373246,276),(6196407,53373251,277),(6196407,53373259,278),(6196407,53373266,279),(6196407,53373270,280),(6196407,53373275,281),(6196407,367680427,282),(6196407,53373280,283),(6196407,53373289,284),(6196407,53373297,285),(6196407,53373303,286),(6196407,53373308,287),(6196407,53373311,288),(6196407,53373318,289),(6196407,53373327,290),(6196407,53373335,291),(6196407,53373343,292),(6196407,53373348,293),(6196407,53373356,294),(6196407,53373365,295),(6196407,53373376,296),(6196407,53373382,297),(6196407,53373386,298),(6196407,53373392,299),(6196407,53373399,300),(6196407,53373402,301),(6196407,53373406,302),(6196407,53373410,303),(6196407,53373416,304),(6196407,53373457,305),(6196407,53373463,306),(6196407,53373467,307),(6196407,53373472,308),(6196407,53373475,309),(6196407,53373479,310),(6196407,53373480,311),(6196407,53373484,312),(6196407,53373499,313),(6196407,53373501,314),(6196407,53373507,315),(6196407,53373512,316),(6196407,53373516,317),(6196407,53373521,318),(6196407,53373529,319),(6196407,53373532,320),(6196407,53373536,321),(6196407,53373543,322),(6196407,53373545,323),(6196407,53373549,324),(6196407,53374387,325),(6196407,53374403,326),(6196407,53374521,327),(6196407,53374531,328),(6196407,53374534,329),(6196407,53374537,330),(6196407,53374542,331),(6196407,53374635,332),(6196407,53374797,333),(6196407,53374856,334),(6196407,53374862,335),(6196407,53374867,336),(6196407,53374883,337),(6196407,53374887,338),(6196407,53374892,339),(6196407,53374894,340),(6196407,53374897,341),(6196407,53374901,342),(6196407,53374925,343),(6196407,53374929,344),(6196407,53375001,345),(6196407,53375004,346),(6196407,53375007,347),(6196407,53375010,348),(6196407,53375014,349),(6196407,53375016,350),(6196407,53375019,351),(6196407,53375022,352),(6196407,53375026,353),(6196407,53375056,354),(6196407,53375086,355),(6196407,53375126,356),(6196407,53375501,357),(6196407,53376238,358),(6196407,53376244,359),(6196407,53376247,360),(6196407,53376253,361),(6196407,53376257,362),(6196407,53376264,363),(6196407,53376267,364),(6196407,53376272,365),(6196407,53376275,366),(6196407,53376314,367),(6196407,53376323,368),(6196407,53376331,369),(6196407,53376354,370),(6196407,53376363,371),(6196407,53376376,372),(6196407,53376378,373),(6196407,53376383,374),(6196407,53376386,375),(6196407,53376390,376),(6196407,53376392,377),(6196407,53376394,378),(6196407,53376397,379),(6196407,53376399,380),(6196407,53376401,381),(6196407,53376405,382),(6196407,53376408,383),(6196407,53376414,384),(6196407,53376419,385),(6196407,53376421,386),(6196407,53376423,387),(6196407,53376428,388),(6196407,53376431,389),(6196407,53376435,390),(6196407,53376437,391),(6196407,53376438,392),(6196407,53376440,393),(6196407,53376442,394),(6196407,53376444,395),(6196407,53376448,396),(6196407,53376451,397),(6196407,53376626,398),(6196407,53376629,399),(6196407,53376632,400),(6196407,53376634,401),(6196407,53376637,402),(6196407,53376658,403),(6196407,53376660,404),(6196407,53376663,405),(6196407,53376664,406),(6196407,53376666,407),(6196407,53376670,408),(6196407,53376674,409),(6196407,53376677,410),(6196407,53376682,411),(6196407,53376683,412),(6196407,53376686,413),(6196407,53376689,414),(6196407,53376692,415),(6196407,53376695,416),(6196407,53376699,417),(6196407,53376702,418),(6196407,53376704,419),(6196407,53376709,420),(6196407,53376715,421),(6196407,53376719,422),(6196407,53376723,423),(6196407,53376729,424),(6196407,53376733,425),(6196407,53376737,426),(6196407,53376740,427),(6196407,53376743,428),(6196407,53376746,429),(6196407,53376748,430),(6196407,53376750,431),(6196407,53376751,432),(6196407,53376753,433),(6196407,53376754,434),(6196407,53376756,435),(6196407,53376757,436),(6196407,53376761,437),(6196407,53376764,438),(6196407,53376766,439),(6196407,53376768,440),(6196407,53376771,441),(6196407,53376772,442),(6196407,53376775,443),(6196407,53376777,444),(6196407,53376780,445),(6196407,53376782,446),(6196407,53376784,447),(6196407,53376788,448),(6196407,53376797,449),(6196407,53376799,450),(6196407,53376802,451),(6196407,53376806,452),(6196407,53376810,453),(6196407,53376814,454),(6196407,53376816,455),(6196407,53376820,456),(6196407,53376827,457),(6196407,53376830,458),(6196407,53376834,459),(6196407,53376837,460),(6196407,53376840,461),(6196407,53376847,462),(6196407,53376853,463),(6196407,53376856,464),(6196407,53376859,465),(6196407,53376862,466),(6196407,53376864,467),(6196407,53376873,468),(6196407,53376881,469),(6196407,53376883,470),(6196407,53376887,471),(6196407,53376891,472),(6196407,53376895,473),(6196407,53376898,474),(6196407,53376899,475),(6197719,51581679,1),(6197719,51581574,2),(6197721,51581675,1),(6197721,51581686,2),(6197721,51581690,3),(6197721,51581692,4),(6197721,51581695,5),(6197721,354962410,6),(6197723,51581762,1),(6197723,51581759,2),(6197723,51581757,3),(6197723,51581754,4),(6197723,51581791,5),(6197723,51581751,6),(6197723,51581783,7),(6197723,51581782,8),(6197723,51581778,9),(6197723,51581776,10),(6197723,51581772,11),(6197723,51581769,12),(6197723,51581766,13),(6197723,51581762,14),(6197727,51581791,1),(6197727,51581788,2),(6197727,51581786,3),(6197727,51581795,4),(6198025,51587707,1),(6198025,51587705,2),(6198025,51587715,3),(6198025,51587703,4),(6198025,51587721,5),(6198025,51587723,6),(6198025,51587694,7),(6198025,51587726,8),(6198025,51587693,9),(6198025,51587729,10),(6198025,51587732,11),(6198025,51587707,12),(6198027,51581769,1),(6198027,51587707,2),(6198139,51587729,1),(6198139,51581759,2),(6225803,51587705,1),(6225803,51589112,2),(6225803,51589115,3),(6225803,51589117,4),(6225803,266334665,5),(6225803,51589119,6),(6225803,51589122,7),(6225803,51589125,8),(6225803,51589128,9),(6225803,51589130,10),(6225803,51589133,11),(6225803,51589136,12),(6225803,51589138,13),(6225803,51589142,14),(6225803,51589144,15),(6225803,51589146,16),(6225803,51589149,17),(6225803,51589152,18),(6225803,51589155,19),(6225803,51589157,20),(6225803,51589158,21),(6225803,51589160,22),(6225803,51589161,23),(6225803,51589162,24),(6225803,51589163,25),(6225803,51589165,26),(6225803,51589169,27),(6225803,51589172,28),(6225803,51589174,29),(6225803,51589177,30),(6225803,51589180,31),(6225803,51589183,32),(6225803,51589185,33),(6225803,51589187,34),(6225803,51589190,35),(6225803,51589192,36),(6225803,51589194,37),(6225803,51589196,38),(6225803,51589198,39),(6225803,51589201,40),(6225803,51589203,41),(6225803,51589205,42),(6225803,51589208,43),(6225803,51589210,44),(6225803,51589213,45),(6225803,51589215,46),(6225803,51589217,47),(6225803,51589220,48),(6225803,51589223,49),(6225803,51589226,50),(6225803,51589229,51),(6225803,51589230,52),(6225803,51589233,53),(6225803,51589236,54),(6225803,51589238,55),(6225803,51589243,56),(6225803,51589247,57),(6225803,51589249,58),(6225803,51589252,59),(6225803,51589254,60),(6225803,51589256,61),(6225803,51589259,62),(6225803,51589262,63),(6225803,51589263,64),(6225803,51589267,65),(6225803,51589270,66),(6225803,51589273,67),(6225803,51589275,68),(6225803,51589278,69),(6225803,51589281,70),(6225803,51589284,71),(6225803,51589288,72),(6225803,51589290,73),(6225803,51589293,74),(6225803,51589296,75),(6225803,51589297,76),(6225803,51589299,77),(6225803,51589302,78),(6225803,51589304,79),(6225803,51589307,80),(6225803,51589310,81),(6225803,51589313,82),(6225803,51589315,83),(6225803,51589320,84),(6225803,51589325,85),(6225803,51589328,86),(6225803,51589334,87),(6225803,51589337,88),(6225803,51589338,89),(6225803,51589340,90),(6225803,51589342,91),(6225803,51589344,92),(6225803,51589348,93),(6225803,51589352,94),(6225803,51589354,95),(6225803,51589357,96),(6225803,51589360,97),(6225803,51589363,98),(6225803,51589366,99),(6225803,51589368,100),(6225803,51589370,101),(6225803,51590535,102),(6225803,51590538,103),(6225803,51590542,104),(6225803,51590544,105),(6225803,51590546,106),(6225803,51590549,107),(6225803,51590551,108),(6225803,51590553,109),(6225803,51590557,110),(6225803,51590560,111),(6225803,51590563,112),(6225803,51590564,113),(6225803,51590567,114),(6225803,51590572,115),(6225803,51590575,116),(6225803,51590578,117),(6225803,51590580,118),(6225803,51590582,119),(6225803,51590585,120),(6225803,51590588,121),(6225803,51590589,122),(6225803,51590592,123),(6225803,51590595,124),(6225803,51590598,125),(6225803,51590600,126),(6225803,51590603,127),(6225803,51590606,128),(6225803,51590608,129),(6225803,51590611,130),(6225803,51590613,131),(6225803,51590616,132),(6225803,51590619,133),(6225803,51590622,134),(6225803,51590623,135),(6225803,51590626,136),(6225803,51590630,137),(6225803,51590631,138),(6225803,51590633,139),(6225803,51590634,140),(6225803,51590635,141),(6225803,51590636,142),(6225803,51590637,143),(6225803,51590638,144),(6225803,51590643,145),(6225803,51590645,146),(6225803,51590646,147),(6225803,51590648,148),(6225803,264053269,149),(6225803,51590650,150),(6225803,51590653,151),(6225803,51590654,152),(6225803,51590657,153),(6225803,51590660,154),(6225803,51590663,155),(6225803,51590665,156),(6225803,51590668,157),(6225803,51590669,158),(6225803,51590671,159),(6225803,51590673,160),(6225803,51590676,161),(6225803,51590679,162),(6225803,51590680,163),(6225803,51590683,164),(6225803,51590686,165),(6225803,51590687,166),(6225803,51590690,167),(6225803,51590691,168),(6225803,51590693,169),(6225803,51590695,170),(6225803,51590699,171),(6225803,51590702,172),(6225803,51590705,173),(6225803,51590707,174),(6225803,51590708,175),(6225803,51590711,176),(6225803,51590714,177),(6225803,51590716,178),(6225803,51590719,179),(6225803,51590722,180),(6225803,51590725,181),(6225803,51590728,182),(6225803,51590730,183),(6225803,51929590,184),(6225803,51929593,185),(6225803,51929595,186);
INSERT INTO `current_way_nodes` VALUES (6225803,51929598,187),(6225803,51929600,188),(6225803,51929603,189),(6225803,51929607,190),(6225803,51929610,191),(6225803,51929614,192),(6225803,51929617,193),(6225803,51929619,194),(6225803,51929620,195),(6225803,51929623,196),(6225803,51929625,197),(6225803,51929626,198),(6225803,51929628,199),(6225803,51929630,200),(6225803,51929632,201),(6225803,51929634,202),(6225803,51929636,203),(6225803,51929638,204),(6225803,51929640,205),(6225803,51929642,206),(6225803,51929644,207),(6225803,51929645,208),(6225803,51929647,209),(6225803,51929649,210),(6225803,51929650,211),(6225803,51929653,212),(6225803,51929656,213),(6225803,51929657,214),(6225803,51929660,215),(6225803,51929661,216),(6225803,51929663,217),(6225803,51929665,218),(6225803,51929667,219),(6225803,51929670,220),(6225803,51929671,221),(6225803,51929673,222),(6225803,51929675,223),(6225803,51929677,224),(6225803,51929678,225),(6225803,51929680,226),(6225803,51929682,227),(6225803,51929684,228),(6225803,51929687,229),(6225803,51929689,230),(6225803,51929690,231),(6225803,51929693,232),(6225803,51929696,233),(6225803,51929700,234),(6225803,51929702,235),(6225803,51929704,236),(6225803,51929707,237),(6225803,51929709,238),(6225803,51929711,239),(6225803,51929713,240),(6225803,51929715,241),(6225803,51929717,242),(6225803,51929720,243),(6225803,51929722,244),(6225803,51929725,245),(6225803,51929728,246),(6225812,51930334,1),(6225812,51930336,2),(6225812,51930338,3),(6225812,51930340,4),(6225812,51930343,5),(6225812,51930345,6),(6225812,51930348,7),(6225812,51930349,8),(6225812,51930352,9),(6225812,51930354,10),(6225812,51930357,11),(6225812,51930359,12),(6225812,51930360,13),(6225812,51930362,14),(6225812,51930364,15),(6225812,51930365,16),(6225812,51930368,17),(6225812,51930371,18),(6225812,51930373,19),(6225812,51930376,20),(6225812,51930378,21),(6225812,51930380,22),(6225812,51930382,23),(6225812,51930388,24),(6225812,51930396,25),(6225812,51930384,26),(6225812,51930390,27),(6225812,51930386,28),(6227096,51957174,1),(6227096,51957172,2),(6227096,51957170,3),(6227096,51957168,4),(6227096,51957166,5),(6227096,51957164,6),(6227096,51957162,7),(6227096,51957160,8),(6227096,51957157,9),(6227096,51957155,10),(6227096,51957153,11),(6227096,51957151,12),(6227096,51957147,13),(6227096,51957146,14),(6227096,51957144,15),(6227096,51957143,16),(6227096,51957141,17),(6227096,51957138,18),(6227096,51957135,19),(6227096,51957134,20),(6227096,51957131,21),(6227096,51957128,22),(6227096,51957125,23),(6227096,51957121,24),(6227096,51957119,25),(6227096,51957117,26),(6227096,51957115,27),(6227096,51957112,28),(6227096,51957110,29),(6227096,51957105,30),(6227096,51957103,31),(6227096,51957101,32),(6227096,51957098,33),(6227096,51957094,34),(6227096,51957092,35),(6227096,51957090,36),(6227096,51957087,37),(6227096,51957085,38),(6227096,51957082,39),(6227096,51957080,40),(6227096,51957077,41),(6227096,51957075,42),(6227096,51957072,43),(6227096,51957069,44),(6227096,51957066,45),(6227096,51957064,46),(6227096,51957063,47),(6227096,51957060,48),(6227096,51957057,49),(6227096,51957055,50),(6227096,51957052,51),(6227096,51957050,52),(6227096,51957048,53),(6227096,51957045,54),(6227096,51957042,55),(6227096,51957040,56),(6227096,51957037,57),(6227096,51957034,58),(6227096,51957031,59),(6227096,51957030,60),(6227096,51957027,61),(6227096,51957025,62),(6227096,51957024,63),(6227096,51957022,64),(6227096,51957020,65),(6227096,51957018,66),(6227096,51957016,67),(6227096,51957013,68),(6227096,51957009,69),(6227096,51957008,70),(6227096,51957005,71),(6227096,51957002,72),(6227096,51956999,73),(6227096,51956997,74),(6227096,51956993,75),(6227096,51951640,76),(6227096,51951645,77),(6227096,51951647,78),(6227096,51951648,79),(6227096,51951650,80),(6227096,51951652,81),(6227096,51951654,82),(6227096,51951657,83),(6227096,51951658,84),(6227096,51951661,85),(6227096,51951665,86),(6227096,51951667,87),(6227096,51951670,88),(6227096,51951673,89),(6227096,51951676,90),(6227096,51951678,91),(6227096,51951680,92),(6227096,51951682,93),(6227096,51951684,94),(6227096,51951686,95),(6227096,51951689,96),(6227096,51951690,97),(6227096,51951692,98),(6227096,51951694,99),(6227096,51951696,100),(6227096,51951700,101),(6227096,51951701,102),(6227096,51951703,103),(6227096,51951706,104),(6227096,51951709,105),(6227096,51951711,106),(6227096,51951713,107),(6227096,51951716,108),(6227096,51951719,109),(6227096,51951723,110),(6227096,51951726,111),(6227096,51951729,112),(6227096,51951731,113),(6227096,51951734,114),(6227096,51951736,115),(6227096,51951739,116),(6227096,51951741,117),(6227096,51951744,118),(6227096,51951747,119),(6227096,51951748,120),(6227096,51951751,121),(6227096,51951755,122),(6227096,51951758,123),(6227096,51951761,124),(6227096,51951763,125),(6227096,51951766,126),(6227096,51951769,127),(6227096,51951772,128),(6227096,51951775,129),(6227096,51951777,130),(6227096,51951780,131),(6227096,51951784,132),(6227096,51951785,133),(6227096,51951788,134),(6227096,51951790,135),(6227096,51951793,136),(6227096,51951796,137),(6227096,51951799,138),(6227096,51951801,139),(6227096,51951805,140),(6227096,51951808,141),(6227096,51951810,142),(6227096,51951813,143),(6227096,51951816,144),(6227096,51951817,145),(6227096,51951819,146),(6227096,51951821,147),(6227096,51951824,148),(6227096,51951827,149),(6227096,51951830,150),(6227096,51951833,151),(6227096,51951836,152),(6227096,51951838,153),(6227096,51951840,154),(6227096,51951843,155),(6227096,51951846,156),(6227096,51951848,157),(6227096,51951851,158),(6227096,51951854,159),(6227096,51951857,160),(6227096,51951858,161),(6227096,51951859,162),(6227096,51951861,163),(6227096,51951864,164),(6227096,51951865,165),(6227096,51951868,166),(6227096,51951872,167),(6227096,51951874,168),(6227096,51951876,169),(6227096,51951879,170),(6227096,51951882,171),(6227096,51951885,172),(6227096,51951886,173),(6227096,51951889,174),(6227096,51951892,175),(6227096,51951895,176),(6227096,51951898,177),(6227096,51951900,178),(6227096,51951903,179),(6227096,51951905,180),(6227096,51951908,181),(6227096,51951911,182),(6227096,51951914,183),(6227096,51951917,184),(6227096,51951920,185),(6227096,51951922,186),(6227096,51951924,187),(6227096,51951927,188),(6227096,51951930,189),(6227096,51951933,190),(6227096,51951935,191),(6227096,51951937,192),(6227096,51951938,193),(6227096,51951941,194),(6227096,51951944,195),(6227096,51951947,196),(6227096,51951950,197),(6227096,51951953,198),(6227096,51951956,199),(6227096,51951957,200),(6227096,51951960,201),(6227096,51951963,202),(6227096,51951965,203),(6227096,51951966,204),(6227096,51951969,205),(6227096,51951970,206),(6227096,51951973,207),(6227096,51951975,208),(6227096,51951978,209),(6227096,51951980,210),(6227096,51951983,211),(6227096,51951985,212),(6227096,51951988,213),(6227096,51951989,214),(6227096,51951992,215),(6227096,51951995,216),(6227096,51951999,217),(6227096,51952002,218),(6227096,51952005,219),(6227096,51952009,220),(6227096,51952013,221),(6227096,51952014,222),(6227096,51952017,223),(6227096,51952019,224),(6227096,51952022,225),(6227096,51952025,226),(6227096,51952028,227),(6227096,51952029,228),(6227096,51952031,229),(6227096,51952034,230),(6227096,51952037,231),(6227096,51952039,232),(6227096,51952042,233),(6227096,51952045,234),(6227096,51952046,235),(6227096,51952048,236),(6227096,51952050,237),(6227096,51952053,238),(6227096,51952055,239),(6227096,51952058,240),(6227096,51952060,241),(6227096,51952063,242),(6227096,51952065,243),(6227096,51952068,244),(6227096,51952069,245),(6227096,51952073,246),(6227096,51952075,247),(6227096,51952078,248),(6227096,51952080,249),(6227096,51952083,250),(6227096,51952084,251),(6227096,51952087,252),(6227096,51952090,253),(6227096,51952093,254),(6227096,51952096,255),(6227096,51952099,256),(6227096,51952101,257),(6227096,51952103,258),(6227096,51952105,259),(6227096,51952107,260),(6227097,51952107,1),(6227097,51952110,2),(6227097,51952111,3),(6227097,51952113,4),(6227097,51952115,5),(6227097,51952118,6),(6228283,51974478,1),(6228283,51974475,2),(6228283,51974472,3),(6228283,51974469,4),(6228283,51974466,5),(6228283,51974462,6),(6228283,51974458,7),(6228283,51974456,8),(6228283,51974455,9),(6228283,51974484,10),(6228283,51974454,11),(6228283,51974481,12),(6228283,51974452,13),(6228283,51974451,14),(6228283,51974446,15),(6228283,51974445,16),(6228283,51974442,17),(6228283,51974439,18),(6228283,51974436,19),(6228283,51974432,20),(6228283,51974430,21),(6228283,51974428,22),(6228283,51974424,23),(6228283,51974422,24),(6228283,51974419,25),(6228283,51974416,26),(6228283,51974414,27),(6228283,51974411,28),(6228283,51974408,29),(6228283,51974405,30),(6228283,51974404,31),(6228283,51974402,32),(6228283,51974400,33),(6228283,51974397,34),(6228283,51974395,35),(6228283,51974394,36),(6228283,51974391,37),(6228283,51974388,38),(6228283,51974385,39),(6228283,51974383,40),(6228283,51974378,41),(6228283,51974376,42),(6228283,51974374,43),(6228283,51974373,44),(6228283,51974371,45),(6228283,51974368,46),(6228283,51974365,47),(6228283,51974363,48),(6228283,51974360,49),(6228283,51974357,50),(6228283,51974353,51),(6228283,51974349,52),(6228283,51974345,53),(6228283,51974341,54),(6228283,51974339,55),(6228283,51974337,56),(6228283,51974334,57),(6228283,51974331,58),(6228283,51974328,59),(6228283,51974326,60),(6228283,51974323,61),(6228283,51974321,62),(6228283,51974319,63),(6228283,51974316,64),(6228283,51974313,65),(6228283,51974309,66),(6228283,51974308,67),(6228283,51974305,68),(6228283,51974301,69),(6228283,51974300,70),(6228283,51974298,71),(6228283,51974296,72),(6228283,51974293,73),(6228283,51974292,74),(6228283,51974291,75),(6228283,51974289,76),(6228283,51974286,77),(6228283,51974284,78),(6228283,51974281,79),(6228283,51974279,80),(6228283,51974278,81),(6228283,51974275,82),(6228283,51974266,83),(6228283,51974264,84),(6228283,51974261,85),(6228283,51974258,86),(6228283,51974256,87),(6228283,51974253,88),(6228283,51974251,89),(6228283,51974249,90),(6228283,51974247,91),(6228283,51974244,92),(6228283,51974242,93),(6228283,51974239,94),(6228283,51974236,95),(6228283,51974233,96),(6228283,51974231,97),(6228283,51974229,98),(6228283,51974226,99),(6228283,51974223,100),(6228283,51974220,101),(6228283,51974217,102),(6228283,51974215,103),(6228283,51974213,104),(6228283,51974211,105),(6228283,51974208,106),(6228283,51974206,107),(6228283,51974204,108),(6228283,51974202,109),(6228283,51974199,110),(6228283,51974197,111),(6228283,51974195,112),(6228283,51974193,113),(6228283,51974191,114),(6228283,51974190,115),(6228283,51974187,116),(6228283,51974185,117),(6228283,51974183,118),(6228283,51974181,119),(6228283,51974176,120),(6228283,51974174,121),(6228283,51974172,122),(6228283,51974169,123),(6228283,51974167,124),(6228283,51974165,125),(6228283,51974164,126),(6228283,51974161,127),(6228283,51974158,128),(6228283,51974155,129),(6228283,51974153,130),(6228283,51974152,131),(6228283,51974149,132),(6228283,51974147,133),(6228283,51974143,134),(6228283,51974140,135),(6228283,51974137,136),(6228283,51974134,137),(6228283,51974133,138),(6228283,51974131,139),(6228283,51974129,140),(6228283,51974126,141),(6228283,51974122,142),(6228283,51974119,143),(6228283,51974115,144),(6228283,51974112,145),(6228283,51974108,146),(6228283,51974107,147),(6228283,51974103,148),(6228283,51974100,149),(6228283,51974097,150),(6228283,51974095,151),(6228283,51974090,152),(6228283,51974089,153),(6228283,51974088,154),(6228283,51974086,155),(6228283,51974085,156),(6228283,51974083,157),(6228283,51974078,158),(6228283,51974074,159),(6228283,51974072,160),(6228283,51974068,161),(6228283,51974065,162),(6228283,51974060,163),(6228283,51974059,164),(6228283,51974057,165),(6228283,51974055,166),(6228283,51974053,167),(6228283,51974050,168),(6228283,51974049,169),(6228283,51974046,170),(6228283,51974044,171),(6228283,51974042,172),(6228283,51974040,173),(6228283,51974039,174),(6228283,51974035,175),(6228283,51974031,176),(6228283,51974028,177),(6228283,51974024,178),(6228283,51974023,179),(6228283,51974019,180),(6228283,51974015,181),(6228283,51974013,182),(6228283,51974011,183),(6228283,51974008,184),(6228283,51974005,185),(6228283,51974002,186),(6228283,51973998,187),(6228283,51973995,188),(6228283,51973992,189),(6228283,51973989,190),(6228283,51973986,191),(6228283,51973983,192),(6228283,51973981,193),(6228283,51973977,194),(6228283,51973975,195),(6228283,51973972,196),(6228283,51973968,197),(6228283,51973967,198),(6228283,51973963,199),(6228283,51973962,200),(6228283,51973958,201),(6228283,51973955,202),(6228283,51973953,203),(6228283,51973952,204),(6228283,51973950,205),(6228283,51973947,206),(6228283,51973942,207),(6228283,51973941,208),(6228283,51973939,209),(6228283,51973937,210),(6228283,51973934,211),(6228283,51973931,212),(6228283,51973929,213),(6228283,51973927,214),(6228283,51973924,215),(6228283,51973922,216),(6228283,51973920,217),(6228283,51973917,218),(6228283,51973915,219),(6228283,51973913,220),(6228283,51973910,221),(6228283,51973907,222),(6228283,51973905,223),(6228283,51973903,224),(6228283,51973898,225),(6228283,51973897,226),(6228283,51973894,227),(6228283,51973891,228),(6228283,51973890,229),(6228283,51973887,230),(6228283,51973884,231),(6228283,51973883,232),(6228283,51973881,233),(6228283,51973878,234),(6228283,51973877,235),(6228283,51973874,236),(6228283,51973871,237),(6228283,51973868,238),(6228283,51973865,239),(6228283,51973862,240),(6228283,51973860,241),(6228283,51973858,242),(6228283,51973855,243),(6228283,51973852,244),(6228283,51973851,245),(6228283,51973849,246),(6228283,51973848,247),(6228283,51973846,248),(6228283,51973844,249),(6228283,51973842,250),(6228283,51973839,251),(6228283,51973836,252),(6228283,51973834,253),(6228283,51973831,254),(6228283,51973820,255),(6228283,51973818,256),(6228283,51973817,257),(6228283,51973815,258),(6228283,51973812,259),(6228283,51973809,260),(6228283,51973807,261),(6228283,51973803,262),(6228283,51973802,263),(6228283,51973799,264),(6228283,51973796,265),(6228283,51973792,266),(6228283,51973790,267),(6228283,51973786,268),(6228283,51973784,269),(6228283,51973782,270),(6228283,51973777,271),(6228283,51973771,272),(6228283,51973770,273),(6228283,51973769,274),(6228283,51973766,275),(6228283,51973764,276),(6228283,51973759,277),(6228283,51973757,278),(6228283,51973755,279),(6228283,51973753,280),(6228283,51973751,281),(6228283,51973749,282),(6228283,51973747,283),(6228283,51973744,284),(6228283,51973741,285),(6228283,51973739,286),(6228283,51973736,287),(6228283,51973733,288),(6228283,51973731,289),(6228283,51973730,290),(6228283,51973728,291),(6228283,51973725,292),(6228283,51973722,293),(6228283,51973720,294),(6228283,51973717,295),(6228283,51973714,296),(6228283,51973711,297),(6228283,51973708,298),(6228283,51973705,299),(6228283,51973703,300),(6228283,51973699,301),(6228283,51973696,302),(6228283,51973694,303),(6228283,51973691,304),(6228283,51973688,305),(6228283,51973686,306),(6228283,51973683,307),(6228283,51973681,308),(6228283,51973679,309),(6228283,51973676,310),(6228283,51973673,311),(6228283,51973669,312),(6228283,51973667,313),(6228283,51973663,314),(6228283,51973660,315),(6228283,51973657,316),(6228283,51973653,317),(6228283,51973651,318),(6228283,51973648,319),(6228283,51973646,320),(6228283,51973643,321),(6228283,51973639,322),(6228283,51973636,323),(6228283,51973633,324),(6228283,51973631,325),(6228283,51973627,326),(6228283,51973624,327),(6228283,51973622,328),(6228283,51973621,329),(6228283,51973619,330),(6228283,51973617,331),(6228283,51973614,332),(6228283,51973611,333),(6228283,51973608,334),(6228283,51973606,335),(6228283,51973604,336),(6228283,51973602,337),(6228283,51973599,338),(6228283,51973598,339),(6228283,51973596,340),(6228283,51973594,341),(6228283,51973591,342),(6228283,51973590,343),(6228283,51973587,344),(6228283,51973582,345),(6228283,51973579,346),(6228283,51973577,347),(6228283,51973575,348),(6228283,51973571,349),(6228283,51973570,350),(6228283,51973567,351),(6228283,51973564,352),(6228283,51973562,353),(6228283,51973561,354),(6228283,51973559,355),(6228283,51973557,356),(6228283,51973554,357),(6228283,51973550,358),(6228283,51973548,359),(6228283,51973546,360),(6228283,51973544,361),(6228283,51973541,362),(6228283,51973514,363),(6228283,51973516,364),(6228283,51973519,365),(6228283,51973521,366),(6228283,51973523,367),(6228283,51973526,368),(6228283,51973528,369),(6228283,51973529,370),(6228283,51973532,371),(6228283,51973534,372),(6228283,51973538,373),(6230227,52009108,1),(6230227,52009109,2),(6230227,52009111,3),(6230227,52009114,4),(6230227,52009117,5),(6230227,52009118,6),(6230227,52009120,7),(6230227,52009122,8),(6230227,52009124,9),(6230227,52009126,10),(6230228,52009126,1),(6230228,52009127,2),(6230229,52009127,1),(6230229,52009129,2),(6230231,52009151,1),(6230231,52009150,2),(6230231,52009147,3),(6230231,52009144,4),(6230231,52009143,5),(6230231,52009197,6),(6230231,52009140,7),(6230231,52009137,8),(6230231,52009134,9),(6230231,52009130,10),(6230231,52603531,11),(6230231,52603533,12),(6230231,52603536,13),(6230231,52603537,14),(6230231,52603540,15),(6230231,52603542,16),(6230231,52612605,17),(6230231,52612609,18),(6230231,52612612,19),(6230231,52612615,20),(6230231,52612616,21),(6230231,52612619,22),(6230231,52612622,23),(6230231,52612624,24),(6230231,52612626,25),(6230231,52612629,26),(6230231,52612634,27),(6230231,52612635,28),(6230231,52612638,29),(6230231,52612640,30),(6230231,52612642,31),(6230231,52612645,32),(6230231,52612646,33),(6230231,52612649,34),(6230231,52612651,35),(6230231,52612653,36),(6230231,52612656,37),(6230231,52612658,38),(6230231,52612660,39),(6230231,52612661,40),(6230231,52612664,41),(6230231,52612665,42),(6230231,52612667,43),(6230231,52612670,44),(6230231,52612672,45),(6230231,52612675,46),(6230231,52612677,47),(6230231,52612678,48),(6230231,52612681,49),(6230231,52612684,50),(6230231,52612686,51),(6230231,52612688,52),(6230231,52612691,53),(6230231,52612692,54),(6230231,52612694,55),(6230231,52612696,56),(6230231,52612699,57),(6230231,52612701,58),(6230231,52612704,59),(6230231,52612708,60),(6230231,52612710,61),(6230231,52612712,62),(6230231,52612716,63),(6230231,52612717,64),(6230231,52612719,65),(6230231,52612720,66),(6230231,52612722,67),(6230231,52612725,68),(6230231,52612728,69),(6230231,52612732,70),(6230231,52612735,71),(6230231,52612738,72),(6230231,52612740,73),(6230231,52612742,74),(6230231,52612744,75),(6230231,52612746,76),(6230231,52612748,77),(6230231,52612750,78),(6230231,52612752,79),(6230231,52612754,80),(6230231,52612756,81),(6230231,52612758,82),(6230231,52612760,83),(6230231,52612761,84),(6230231,52612763,85),(6230231,52612765,86),(6230231,52612768,87),(6230231,52612770,88),(6230231,52612773,89),(6230231,52612776,90),(6230231,52612779,91),(6230231,52612782,92),(6230231,52612786,93),(6230231,52612789,94),(6230231,52612791,95),(6230231,52612794,96),(6230231,52612796,97),(6230231,52612800,98),(6230231,52612803,99),(6230231,52612804,100),(6230231,52612807,101),(6230231,52612810,102),(6230231,52612813,103),(6230231,52612815,104),(6230231,52612817,105),(6230231,52612820,106),(6230231,52612824,107),(6230231,52612827,108),(6230231,52612831,109),(6230231,52612835,110),(6230231,52612840,111),(6230231,52612843,112),(6230231,52612845,113),(6230231,52612849,114),(6230231,52612853,115),(6230231,52612855,116),(6230231,52612859,117),(6230231,52612862,118),(6230231,52612864,119),(6230231,52612867,120),(6230231,52612870,121),(6230231,52612873,122),(6230231,52612877,123),(6230231,52612882,124),(6230231,52612885,125),(6230231,52612888,126),(6230231,52612892,127),(6230231,52612893,128),(6230231,52612895,129),(6230231,52612897,130),(6230231,52612899,131),(6230231,52612900,132),(6230231,52612902,133),(6230231,52612907,134),(6230231,52612909,135),(6230231,52612911,136),(6230231,52612913,137),(6230231,52612916,138),(6230231,52612918,139),(6230231,52612920,140),(6230231,52612923,141),(6230231,52612927,142),(6230231,52612929,143),(6230231,52612932,144),(6230231,52612935,145),(6230231,52612936,146),(6230231,52612939,147),(6230231,52612941,148),(6230231,52612943,149),(6230231,52612946,150),(6230231,52612948,151),(6230231,52612951,152),(6230231,52612954,153),(6230231,52612957,154),(6230231,52612958,155),(6230231,52612962,156),(6230231,52612967,157),(6230231,52612973,158),(6230231,52652273,159),(6230231,52612976,160),(6230231,52612978,161),(6230231,52685723,162),(6230231,52612981,163),(6230231,52612983,164),(6230231,52612986,165),(6230231,52612989,166),(6230231,52612992,167),(6230231,52612994,168),(6230231,52612996,169),(6230231,52612998,170),(6230231,52613000,171),(6230231,52613003,172),(6230231,52613006,173),(6230231,52613008,174),(6230231,52613010,175),(6230231,52613013,176),(6230231,52613016,177),(6230231,52613017,178),(6230231,52613020,179),(6230231,52613021,180),(6230231,52613024,181),(6230231,52613027,182),(6230231,52613030,183),(6230231,52613032,184),(6230231,52613034,185),(6230231,52613037,186),(6230231,52613039,187),(6230231,52613041,188),(6230231,52613044,189),(6230231,52613047,190),(6230231,52613049,191),(6230231,52613052,192),(6230231,52613054,193),(6230231,52613056,194),(6230231,52613058,195),(6230231,52613080,196),(6230231,52613061,197),(6230231,52613062,198),(6230231,52613065,199),(6230231,52613067,200),(6230231,52613070,201),(6230231,52613072,202),(6230231,52613074,203),(6230231,52613076,204),(6230231,52613083,205),(6230231,52613086,206),(6230231,52613088,207),(6230231,52613091,208),(6230231,52613092,209),(6230231,52613094,210),(6230231,52613097,211),(6230231,52613099,212),(6230231,52613101,213),(6230231,52613104,214),(6230231,52613107,215),(6230231,52613110,216),(6230231,52613113,217),(6230231,52613115,218),(6230231,52613117,219),(6230231,52613119,220),(6230231,52613121,221),(6230231,52613124,222),(6230231,52613126,223),(6230231,52613129,224),(6230231,52613132,225),(6230231,52613135,226),(6230231,52613139,227),(6230231,52613142,228),(6230231,52613145,229),(6230231,52613148,230),(6230231,52613149,231),(6230231,52613151,232),(6230231,264465128,233),(6230232,52009154,1),(6230232,52009156,2),(6230233,52009157,1),(6230233,52009159,2),(6230233,52009161,3),(6230233,52009164,4),(6230233,52009157,5),(6230234,52009197,1),(6230234,52009168,2),(6242742,52166959,1),(6242742,52166976,2),(6242742,52166980,3),(6242742,52167010,4),(6242742,52167017,5),(6242742,52167025,6),(6242742,52167030,7),(6242742,52167039,8),(6242742,52167045,9),(6242742,52167049,10),(6242742,52167052,11),(6242742,52167062,12),(6242742,52167066,13),(6242742,52167070,14),(6242742,52167076,15),(6242742,52167082,16),(6242742,52167086,17),(6242742,52167105,18),(6242742,52167111,19),(6242742,52167122,20),(6242742,52167165,21),(6242747,52167128,1),(6242747,52167136,2),(6242747,52167142,3),(6242747,52167150,4),(6242747,52167155,5),(6242747,52167165,6),(6242747,52167175,7),(6242747,52167179,8),(6242747,52167183,9),(6242747,52167190,10),(6242747,52167198,11),(6242747,52167208,12),(6242747,52167211,13),(6242747,52167218,14),(6242747,52167223,15),(6242747,52167232,16),(6242747,52167248,17),(6242747,52167254,18),(6242747,52167257,19),(6242747,52167262,20),(6242747,52167277,21),(6242747,52167279,22),(6242747,52167284,23),(6242747,52167289,24),(6242747,52167293,25),(6242747,52167300,26),(6242747,52167307,27),(6242747,52167309,28),(6242747,52167315,29),(6242747,52167320,30),(6242747,52167323,31),(6242747,52167329,32),(6242747,52167336,33),(6242747,52167345,34),(6242747,52167349,35),(6242747,52167353,36),(6242747,52167358,37),(6242747,52167363,38),(6242747,52167368,39),(6242747,52167372,40),(6242747,52167380,41),(6242747,52167387,42),(6242747,52167389,43),(6242747,52167390,44),(6242747,52167393,45),(6242747,52167396,46),(6242747,52167398,47),(6242747,52167402,48),(6242747,52167406,49),(6242747,52167421,50),(6242747,52167425,51),(6242747,52167428,52),(6242747,52167430,53),(6242747,52167433,54),(6242747,52167436,55),(6242747,52167438,56),(6242747,52167439,57),(6242747,52167444,58),(6242747,52167446,59),(6242747,52167453,60),(6242747,52167457,61),(6242747,52167470,62),(6242747,52167473,63),(6242747,52167477,64),(6242747,52167484,65),(6242747,52167487,66),(6242747,52167490,67),(6242747,52167496,68),(6242747,52167500,69),(6242747,52167503,70),(6242747,52167507,71),(6242747,52167511,72),(6242747,52167513,73),(6242747,52167517,74),(6242747,52167521,75),(6242747,52167525,76),(6242747,52167528,77),(6242747,52167530,78),(6242747,52167534,79),(6242747,52167535,80),(6242747,52167538,81),(6242747,52167540,82),(6242747,52167544,83),(6242747,52167547,84),(6242747,52167551,85),(6242747,52167557,86),(6242747,52167562,87),(6242747,52167568,88),(6242747,52167574,89),(6242747,52167579,90),(6242747,52167581,91),(6242747,52167585,92),(6242747,52167590,93),(6242747,52167593,94),(6242747,52167599,95),(6242747,52167604,96),(6242747,52167607,97),(6242747,52167614,98),(6242747,52167615,99),(6242747,52167619,100),(6242747,52167622,101),(6242747,52167627,102),(6242747,52167632,103),(6242747,52167636,104),(6242747,52167641,105),(6242747,52167645,106),(6242747,52167650,107),(6242747,52167655,108),(6242747,52167660,109),(6242747,52167664,110),(6242747,52167666,111),(6242747,52167669,112),(6242747,52167673,113),(6242747,52167677,114),(6242747,52167683,115),(6242747,52167687,116),(6242747,52167691,117),(6242747,52167695,118),(6242747,52167700,119),(6242747,52167702,120),(6242747,52167707,121),(6242747,52167710,122),(6242747,52167713,123),(6242747,52167714,124),(6242747,52167718,125),(6242747,52167721,126),(6242747,52167725,127),(6242747,52167727,128),(6242747,52167732,129),(6242747,52167736,130),(6242747,52167740,131),(6242747,52167744,132),(6242747,52167747,133),(6242747,52167752,134),(6242747,52167756,135),(6242747,52167758,136),(6242747,52167761,137),(6242747,52167765,138),(6242747,52167769,139),(6242747,52167773,140),(6242747,52167777,141),(6242747,52167781,142),(6242747,52167784,143),(6242747,52167787,144),(6242747,52167790,145),(6242747,52167795,146),(6242747,52167796,147),(6242747,52167799,148),(6242747,52167802,149),(6242747,52167805,150),(6242747,52167807,151),(6242747,52167811,152),(6242747,52167812,153),(6242747,52167815,154),(6242747,52167820,155),(6242747,52167825,156),(6242747,52167828,157),(6242747,52167834,158),(6242747,52167836,159),(6242747,52167839,160),(6242747,52167843,161),(6242747,52167847,162),(6242747,52167849,163),(6242747,52167853,164),(6242747,52167859,165),(6242747,52167860,166),(6242747,52167867,167),(6242747,52167872,168),(6242747,52167883,169),(6242747,52167887,170),(6242747,52167891,171),(6242747,52167896,172),(6242747,52167900,173),(6242747,52167906,174),(6242747,52167911,175),(6242747,52167916,176),(6242747,52167922,177),(6242747,52167924,178),(6242747,52167927,179),(6242747,52167930,180),(6242747,52167932,181),(6242747,52167937,182),(6242747,52167944,183),(6242747,52167948,184),(6242747,52167953,185),(6242747,52167958,186),(6242747,52167963,187),(6242747,52167967,188),(6242747,52167969,189),(6242747,52167970,190),(6242747,52167973,191),(6242747,52167977,192),(6242747,52167981,193),(6242747,52167986,194),(6242747,52167991,195),(6242747,52167995,196),(6242747,52168000,197),(6242747,52168004,198),(6242747,52168009,199),(6242747,52168013,200),(6242747,52168015,201),(6242747,52168018,202),(6242747,52168021,203),(6242747,52168025,204),(6242747,52168028,205),(6242747,52168033,206),(6242747,52168034,207),(6242747,52168038,208),(6242747,52168039,209),(6242747,52168043,210),(6242747,52168046,211),(6242747,52168049,212),(6242747,52168053,213),(6242747,52168055,214),(6242747,52168056,215),(6242747,52168060,216),(6242747,52168063,217),(6242747,52168065,218),(6242747,52168070,219),(6242747,52168071,220),(6242747,52168073,221),(6242747,52168077,222),(6242747,52168080,223),(6242747,52168084,224),(6242747,52168086,225),(6242747,52168090,226),(6242747,52168094,227),(6242747,52168096,228),(6242747,52168100,229),(6242747,52168101,230),(6242747,52168104,231),(6242747,52168108,232),(6242747,52168111,233),(6242747,52168115,234),(6242747,52168118,235),(6242747,52168121,236),(6242747,52168124,237),(6242747,52168127,238),(6242747,52168130,239),(6242747,52168135,240),(6242747,52168138,241),(6242747,52168143,242),(6242747,52168146,243),(6242747,52168149,244),(6242747,52168152,245),(6242747,52168156,246),(6242747,52168160,247),(6242747,52168163,248),(6242747,52168167,249),(6242747,52168171,250),(6242747,52168175,251),(6242747,52168178,252),(6242747,52168181,253),(6242747,52168186,254),(6242747,52168188,255),(6242747,52168191,256),(6242747,52168195,257),(6242747,52168198,258),(6242747,52168203,259),(6242747,52168207,260),(6242747,52168214,261),(6242747,52168217,262),(6242747,52168220,263),(6242747,52168225,264),(6242747,52168231,265),(6242747,52168235,266),(6242747,52168237,267),(6242747,52168240,268),(6242747,52168243,269),(6242747,52168247,270),(6242747,52168248,271),(6242747,52168249,272),(6242747,52168251,273),(6242747,52168254,274),(6242747,52168256,275),(6242747,52168258,276),(6242747,52168261,277),(6242747,52168265,278),(6242747,52168270,279),(6242747,52168274,280),(6242747,52168278,281),(6242747,52168283,282),(6242747,52168286,283),(6242747,52168287,284),(6242747,52168291,285),(6242747,52168296,286),(6242747,52168298,287),(6242747,52168302,288),(6242747,52168305,289),(6242747,52168308,290),(6242747,52168309,291),(6242747,52168314,292),(6242747,52168316,293),(6242747,52168318,294),(6242747,52168321,295),(6242747,52168325,296),(6242747,52168326,297),(6242747,52168329,298),(6242747,52168333,299),(6242747,52168336,300),(6242747,52168338,301),(6242747,52168342,302),(6242747,52168346,303),(6242747,52168347,304),(6242747,52168348,305),(6242747,52168350,306),(6242747,52168356,307),(6242747,52168360,308),(6242747,52168362,309),(6242747,52168414,310),(6242747,52168416,311),(6242747,52168419,312),(6242747,52168423,313),(6242747,52168427,314),(6242747,52168429,315),(6242747,52168432,316),(6242747,52168436,317),(6242747,52168440,318),(6242747,52168442,319),(6242747,52168445,320),(6242747,52168447,321),(6242747,52168452,322),(6242747,52168455,323),(6242747,52168459,324),(6242747,52168461,325),(6242747,52168464,326),(6242747,52168468,327),(6242747,52168470,328),(6242747,52168474,329),(6242747,52168476,330),(6242747,52168479,331),(6242747,52168481,332),(6242747,52168484,333),(6242747,52168486,334),(6242747,52168489,335),(6242747,52168492,336),(6242747,52168495,337),(6242747,52168497,338),(6242747,52168502,339),(6242747,52168506,340),(6242747,52168509,341),(6242747,52168512,342),(6242747,52168516,343),(6242747,52168519,344),(6242747,52168521,345),(6242747,52168523,346),(6242747,52168529,347),(6242747,52168531,348),(6242747,52168534,349),(6242747,52168537,350),(6242747,52168541,351),(6242747,52168543,352),(6242747,52168547,353),(6242747,52168549,354),(6242747,52168553,355),(6242747,52168555,356),(6242747,52168558,357),(6242747,52168561,358),(6242747,52168565,359),(6242747,52168568,360),(6242747,52168569,361),(6242747,52168572,362),(6242747,52168576,363),(6242747,52168579,364),(6242747,52168582,365),(6242747,52168586,366),(6242747,52168589,367),(6242747,52168592,368),(6242747,52168595,369),(6242747,52168596,370),(6242747,52168600,371),(6242747,52168604,372),(6242747,52168607,373),(6242747,52168612,374),(6242747,52168613,375),(6242747,52168616,376),(6242747,52168622,377),(6242747,52168626,378),(6242747,52168631,379),(6242747,52168635,380),(6242747,52168638,381),(6242747,52168640,382),(6242747,52168644,383),(6242747,52168648,384),(6242747,52168654,385),(6242747,52168657,386),(6242747,52168660,387),(6242747,52168663,388),(6242747,52168665,389),(6242747,52168668,390),(6242747,52168671,391),(6242747,52168674,392),(6242747,52168676,393),(6242747,52168679,394),(6242747,52168682,395),(6242747,52168686,396),(6242747,52168687,397),(6242747,52168690,398),(6242747,52168693,399),(6242747,52168695,400),(6242747,52168698,401),(6242747,52168700,402),(6242747,52168702,403),(6242747,52168703,404),(6242747,52168705,405),(6242747,52168708,406),(6242747,52168710,407),(6242747,52168712,408),(6242747,52168714,409),(6242747,52168717,410),(6242747,52168720,411),(6242747,52168722,412),(6242747,52168725,413),(6242747,52168727,414),(6242747,52168729,415),(6242747,52168732,416),(6242747,52168734,417),(6242747,52168736,418),(6242747,52168739,419),(6242747,52168741,420),(6242747,52168744,421),(6242747,52168745,422),(6242747,52168747,423),(6242747,52168750,424),(6242747,52168770,425),(6242747,52168772,426),(6242747,52168773,427),(6242747,52168774,428),(6242747,52168777,429),(6242747,52168779,430),(6242747,52168782,431),(6242747,52168786,432),(6242747,52168788,433),(6242747,52168789,434),(6242747,52168790,435),(6242747,52168794,436),(6242747,52168796,437),(6242747,52168799,438),(6242747,52168802,439),(6242747,52168805,440),(6242747,52168808,441),(6242747,52168810,442),(6242747,52168813,443),(6242747,52168816,444),(6242747,52168819,445),(6242747,52168821,446),(6242747,52168824,447),(6242747,52168828,448),(6242747,52168829,449),(6242747,52168830,450),(6242747,52168834,451),(6242747,52168836,452),(6242747,52168838,453),(6242747,52168842,454),(6242747,52168845,455),(6242747,52168846,456),(6242747,52168849,457),(6242747,52168851,458),(6242747,52168854,459),(6242747,52168856,460),(6242747,52168858,461),(6242747,52168859,462),(6242747,52168862,463),(6242747,52168865,464),(6242747,52168866,465),(6242747,52168867,466),(6242747,52168870,467),(6242747,52168873,468),(6242747,52168875,469),(6242747,52168878,470),(6242747,52168881,471),(6242747,52168883,472),(6242747,52168886,473),(6242747,52168889,474),(6242747,52168892,475),(6242747,52168895,476),(6242747,52168899,477),(6242747,52168901,478),(6242747,52168904,479),(6242747,52168905,480),(6242747,52168909,481),(6242747,52168912,482),(6242747,52168914,483),(6242747,52168917,484),(6242747,52168919,485),(6242747,52168920,486),(6242747,52168921,487),(6242747,52168924,488),(6242747,52168926,489),(6242747,52168929,490),(6242747,52168931,491),(6242747,52168933,492),(6242747,52168936,493),(6242747,52168939,494),(6242747,52168943,495),(6242747,52168945,496),(6242747,52168946,497),(6242747,52168948,498),(6242747,52168952,499),(6242747,52168955,500),(6242747,52168959,501),(6242747,52168961,502),(6242747,52168964,503),(6242747,52168965,504),(6242747,52168967,505),(6242747,52168969,506),(6242747,52168972,507),(6242747,52168974,508),(6242747,52168976,509),(6242747,52168981,510),(6242747,52168984,511),(6242747,52168987,512),(6242747,52168989,513),(6242747,52168992,514),(6242747,266326164,515),(6242747,52168995,516),(6242747,52169000,517),(6242747,52169003,518),(6242747,52169006,519),(6242747,52169008,520),(6242747,52169011,521),(6242747,52169014,522),(6242747,52169016,523),(6242747,52169018,524),(6242747,52169021,525),(6242747,52169022,526),(6242747,52169024,527),(6242747,52169028,528),(6242747,52169032,529),(6242747,52169034,530),(6242747,52169036,531),(6242747,52169041,532),(6242747,52169044,533),(6242747,52169045,534),(6242747,52169048,535),(6242747,52169052,536),(6242747,52169054,537),(6242747,52169055,538),(6242747,52169058,539),(6242747,52169060,540),(6242747,52169061,541),(6242747,52169064,542),(6242747,52169067,543),(6242747,52169070,544),(6242747,52169073,545),(6242747,52169075,546),(6242747,52169076,547),(6242747,52169078,548),(6242747,52169080,549),(6242747,52169083,550),(6242747,52169088,551),(6242747,52169089,552),(6242747,52169092,553),(6242747,52169094,554),(6242747,52169097,555),(6242747,52169100,556),(6242747,52169103,557),(6242747,52169105,558),(6242747,52169109,559),(6242747,52169111,560),(6242747,52169113,561),(6242747,52169115,562),(6242747,52169117,563),(6242747,52169119,564),(6242747,52169121,565),(6242747,52169123,566),(6242747,52169124,567),(6242747,52169125,568),(6242747,52169126,569),(6242747,52169127,570),(6242753,52172181,1),(6242753,52172178,2),(6242753,52172175,3),(6242753,52172172,4),(6242753,52172170,5),(6242753,52172168,6),(6242753,52172166,7),(6242753,52172164,8),(6242753,52172161,9),(6242753,52172158,10),(6242753,52172156,11),(6242753,52172153,12),(6242753,52172150,13),(6242753,52172147,14),(6242753,52172144,15),(6242753,52172141,16),(6242753,52172139,17),(6242753,52172135,18),(6242753,52172133,19),(6242753,52172131,20),(6242753,52172129,21),(6242753,52172128,22),(6242753,52172124,23),(6242753,52172122,24),(6242753,52172111,25),(6242753,52172109,26),(6242753,52172107,27),(6242753,52172106,28),(6242753,52172105,29),(6242753,52172104,30),(6242753,52172102,31),(6242753,52172099,32),(6242753,52172096,33),(6242753,52172092,34),(6242753,52172090,35),(6242753,52172086,36),(6242753,52172050,37),(6242753,52172049,38),(6242753,52172036,39),(6242753,52172033,40),(6242753,52172016,41),(6242753,52172014,42),(6242753,52172012,43),(6242753,52172008,44),(6242753,52172006,45),(6242753,52172001,46),(6242753,52171997,47),(6242753,52171996,48),(6242753,52171995,49),(6242753,52171991,50),(6242753,52171989,51),(6242753,52171988,52),(6242753,52171985,53),(6242753,52171981,54),(6242753,52171979,55),(6242753,52171977,56),(6242753,52171975,57),(6242753,52171972,58),(6242753,52171963,59),(6242753,52171952,60),(6242753,52171949,61),(6242753,52171948,62),(6242753,52171945,63),(6242753,52171942,64),(6242753,52171940,65),(6242753,52171934,66),(6242753,52171932,67),(6242753,52171895,68),(6242753,52171892,69),(6242753,52171888,70),(6242753,52171885,71),(6242753,52171867,72),(6242753,52171863,73),(6242753,52171858,74),(6242753,52171825,75),(6242753,52171822,76),(6242753,52171820,77),(6242753,52171818,78),(6242753,52171815,79),(6242753,52171814,80),(6242753,52171811,81),(6242753,52171810,82),(6242753,52171808,83),(6242753,52171805,84),(6242753,52171801,85),(6242753,52171797,86),(6242753,52171795,87),(6242753,52171790,88),(6242753,52171787,89),(6242753,52171785,90),(6242753,52171781,91),(6242753,52171777,92),(6242753,52171775,93),(6242753,52171771,94),(6242753,52206005,95),(6242753,52171764,96),(6242753,52171665,97),(6242753,52171662,98),(6242753,52171659,99),(6242753,52171656,100),(6242753,52171653,101),(6242753,52206628,102),(6242753,52171649,103),(6242753,52171644,104),(6242753,52171636,105),(6242753,52171633,106),(6242753,52171628,107),(6242753,52171622,108),(6242753,52171616,109),(6242753,52171610,110),(6242753,52171606,111),(6242753,52171601,112),(6242753,52171595,113),(6242753,52171594,114),(6242753,52171590,115),(6242753,52171585,116),(6242753,52171579,117),(6242753,52171574,118),(6242753,52171569,119),(6242753,52171562,120),(6242753,52171557,121),(6242753,52171553,122),(6242753,52171547,123),(6242753,52171542,124),(6242753,52171537,125),(6242753,52171534,126),(6242753,52171531,127),(6242753,52171528,128),(6242753,52171525,129),(6242753,52171521,130),(6242753,52171515,131),(6242753,52171511,132),(6242753,52171506,133),(6242753,52171503,134),(6242753,52171498,135),(6242753,52171494,136),(6242753,52171491,137),(6242753,52171487,138),(6242753,52171485,139),(6242753,52171481,140),(6242753,52171479,141),(6242753,52171474,142),(6242753,52171467,143),(6242753,52171465,144),(6242753,52171458,145),(6242753,52171454,146),(6242753,52171451,147),(6242753,52171449,148),(6242753,52171447,149),(6242753,52171444,150),(6242753,52171443,151),(6242753,52171437,152),(6242753,52171432,153),(6242753,52171426,154),(6242753,52171422,155),(6242753,52171417,156),(6242753,52171413,157),(6242753,52171407,158),(6242753,52171391,159),(6242753,52171385,160),(6242753,52171382,161),(6242753,52171378,162),(6242753,52171373,163),(6242753,52171370,164),(6242753,52171364,165),(6242753,52171351,166),(6242753,52171344,167),(6242753,52171338,168),(6242753,52171330,169),(6242753,52171324,170),(6242753,52171321,171),(6242753,52171317,172),(6242753,52171311,173),(6242753,52171307,174),(6242753,52171305,175),(6242753,52171300,176),(6242753,52171297,177),(6242753,52171295,178),(6242753,52171289,179),(6242753,52171284,180),(6242753,52171280,181),(6242753,52171263,182),(6242753,52171259,183),(6242753,52171256,184),(6242753,52171251,185),(6242753,52171247,186),(6242753,52171188,187),(6242753,52171184,188),(6242753,52171179,189),(6242753,52171173,190),(6242753,52171167,191),(6242753,52171165,192),(6242753,52171156,193),(6242753,52171151,194),(6242753,52171146,195),(6242753,52171140,196),(6242753,52171136,197),(6242753,52171131,198),(6242753,52171129,199),(6242753,52171127,200),(6242753,52171125,201),(6242753,52171121,202),(6242753,52171120,203),(6242753,52171118,204),(6242753,52171114,205),(6242753,52171112,206),(6242753,52171107,207),(6242753,52171100,208),(6242753,52171092,209),(6242753,52171088,210),(6242753,52171084,211),(6242753,52171081,212),(6242753,52171078,213),(6242753,52171075,214),(6242753,52171073,215),(6242753,52171070,216),(6242753,52171060,217),(6242753,52171057,218),(6242753,52171054,219),(6242753,52171050,220),(6242753,52171046,221),(6242753,52170561,222),(6242753,52170544,223),(6242753,52170540,224),(6242753,52170533,225),(6242753,52170525,226),(6242753,52170512,227),(6242753,52170496,228),(6242753,52170441,229),(6242753,52170440,230),(6242753,52170423,231),(6242753,52170418,232),(6242753,52170417,233),(6242753,52170416,234),(6242753,52170415,235),(6242753,52170411,236),(6242753,52170410,237),(6242753,52170406,238),(6242753,52170401,239),(6242753,52170400,240),(6242753,52170397,241),(6242753,52170394,242),(6242753,52170391,243),(6242753,52170388,244),(6242753,52170386,245),(6242753,52170384,246),(6242753,52170381,247),(6242753,52170378,248),(6242753,52170377,249),(6242753,52170374,250),(6242753,52170371,251),(6242753,258353529,252),(6242753,258353530,253),(6242753,258353531,254),(6242753,258353532,255),(6242753,258353533,256),(6242753,258353534,257),(6242753,258353535,258),(6242753,258353536,259),(6242753,258353537,260),(6242753,258353538,261),(6242753,258353539,262),(6242756,52170090,1),(6242756,52170088,2),(6242756,52170080,3),(6242756,52170076,4),(6242756,52170071,5),(6242756,52170065,6),(6242756,52170061,7),(6242756,52170056,8),(6242756,52170048,9),(6242756,52170044,10),(6242757,52170099,1),(6242757,52170096,2),(6242757,52170090,3),(6242759,52170044,1),(6242759,52170042,2),(6242759,52170040,3),(6244541,52205987,1),(6244541,52205985,2),(6244541,52205983,3),(6244541,52205980,4),(6244541,52205977,5),(6244541,52205973,6),(6244541,52205972,7),(6244541,52205967,8),(6244541,52205964,9),(6244541,52205959,10),(6244541,52205955,11),(6244541,52205951,12),(6244541,52205948,13),(6244541,52205945,14),(6244541,52205941,15),(6244541,52205938,16),(6244541,52205937,17),(6244541,52205935,18),(6244541,52205930,19),(6244541,52205929,20),(6244541,52205924,21),(6244541,52205915,22),(6244541,52205913,23),(6244541,52205910,24),(6244541,52205907,25),(6244541,52205904,26),(6244541,52205901,27),(6244541,52205898,28),(6244541,52205896,29),(6244541,52205893,30),(6244541,52205891,31),(6244541,52205888,32),(6244541,52205885,33),(6244541,52205882,34),(6244541,52205880,35),(6244541,52205876,36),(6244541,52205873,37),(6244541,52205869,38),(6244541,52205865,39),(6244541,52205863,40),(6244541,52205859,41),(6244541,52205855,42),(6244541,52205852,43),(6244541,52205849,44),(6244541,52205846,45),(6244541,52205843,46),(6244541,52205839,47),(6244541,52205836,48),(6244541,52205830,49),(6244541,52205828,50),(6244541,52205823,51),(6244541,52205820,52),(6244541,52205813,53),(6244541,52205785,54),(6244541,52205782,55),(6244541,52205774,56),(6244541,52205715,57),(6244541,52205713,58),(6244541,52205712,59),(6244541,52205709,60),(6244541,52205707,61),(6244541,52205703,62),(6244541,52205699,63),(6244541,52205695,64),(6244541,52205693,65),(6244541,52205690,66),(6244541,52205687,67),(6244541,52205685,68),(6244541,52205681,69),(6244541,52205679,70),(6244541,52205678,71),(6244541,52205676,72),(6244541,52205671,73),(6244541,52205641,74),(6244541,52205637,75),(6244541,52205622,76),(6244541,52205496,77),(6244541,52205492,78),(6244541,52205489,79),(6244541,52205485,80),(6244541,52205480,81),(6244541,52205475,82),(6244541,52205473,83),(6244541,52205469,84),(6244541,52205464,85),(6244541,52205461,86),(6244541,52205456,87),(6244541,52205450,88),(6244541,52205438,89),(6244541,52205434,90),(6244541,52205431,91),(6244541,52205427,92),(6244541,52205422,93),(6244541,52205416,94),(6244541,52205404,95),(6244541,52205317,96),(6244541,52205311,97),(6244541,52205309,98),(6244541,52205306,99),(6244541,52205304,100),(6244541,52205301,101),(6244541,52205298,102),(6244541,52205296,103),(6244541,52205290,104),(6244541,52205286,105),(6244541,52205284,106),(6244541,52205280,107),(6244541,52205274,108),(6244541,52205269,109),(6244541,52205266,110),(6244541,52205261,111),(6244541,52205257,112),(6244541,52205252,113),(6244541,52205248,114),(6244541,52205244,115),(6244541,52205242,116),(6244541,52205239,117),(6244541,52205232,118),(6244541,52205230,119),(6244541,52205225,120),(6244541,52205222,121),(6244541,52205218,122),(6244541,52205212,123),(6244541,52205206,124),(6244541,52205200,125),(6244541,52205196,126),(6244541,52205188,127),(6244541,52205186,128),(6244541,52205182,129),(6244541,52205177,130),(6244541,52205176,131),(6244541,52205175,132),(6244541,52205171,133),(6244541,52205166,134),(6244541,52205161,135),(6244541,52205154,136),(6244541,52205150,137),(6244541,52205148,138),(6244541,52205144,139),(6244541,52205141,140),(6244541,52205138,141),(6244541,52205135,142),(6244541,52205132,143),(6244541,52205131,144),(6244541,52205126,145),(6244541,52205123,146),(6244541,52205122,147),(6244541,52205116,148),(6244541,52205113,149),(6244541,52205110,150),(6244541,52205107,151),(6244541,52205105,152),(6244541,52205101,153),(6244541,52205099,154),(6244541,52205096,155),(6244541,52205095,156),(6244541,52205094,157),(6244541,52205093,158),(6244541,52205092,159),(6244541,52205091,160),(6244541,52205090,161),(6244541,52205089,162),(6244541,52205087,163),(6244541,52205086,164),(6244541,52205084,165),(6244541,52205082,166),(6244541,52205080,167),(6244541,52205079,168),(6244541,52205077,169),(6244541,52205075,170),(6244541,52205073,171),(6244541,52205070,172),(6244541,52205065,173),(6244541,52205063,174),(6244541,52205059,175),(6244541,52205055,176),(6244541,52205053,177),(6244541,52205050,178),(6244541,52205046,179),(6244541,52205043,180),(6244541,52205041,181),(6244541,52205038,182),(6244541,52205035,183),(6244541,52205032,184),(6244541,52205029,185),(6244541,52205022,186),(6244541,52205020,187),(6244541,52205014,188),(6244541,52205008,189),(6244541,52205002,190),(6244541,52204983,191),(6244541,52204922,192),(6244541,52204916,193),(6244541,52204912,194),(6244541,52204903,195),(6244541,52204800,196),(6244541,52204798,197),(6244541,52204750,198),(6244541,52204747,199),(6244541,52204670,200),(6244541,52204669,201),(6244541,52204668,202),(6244541,52204665,203),(6244541,52204664,204),(6244541,52204627,205),(6244541,52204624,206),(6244541,52204568,207),(6244541,52204565,208),(6244541,52204553,209),(6244541,52204549,210),(6244541,52204547,211),(6244541,52204544,212),(6244541,52204541,213),(6244541,52204536,214),(6244541,52204534,215),(6244541,52204531,216),(6244541,52204528,217),(6244541,52204525,218),(6244541,52204523,219),(6244541,52204520,220),(6244541,52204516,221),(6244541,52204513,222),(6244541,52204505,223),(6244541,52204504,224),(6244541,52204501,225),(6244541,52204498,226),(6244541,52204495,227),(6244541,52204492,228),(6244541,52204488,229),(6244541,52204485,230),(6244541,52204483,231),(6244541,52204480,232),(6244541,52204478,233),(6244541,52204476,234),(6244541,52204473,235),(6244541,52204470,236),(6244541,52204467,237),(6244542,52206005,1),(6244542,52206003,2),(6244542,52206000,3),(6244542,52205998,4),(6244542,52205990,5),(6244542,52205992,6),(6244542,52205994,7),(6244542,52205996,8),(6244542,52206007,9),(6244542,52206009,10),(6244542,52206010,11),(6244542,52206014,12),(6244542,52206016,13),(6244542,52206018,14),(6244542,52206020,15),(6244542,52206023,16),(6244542,52206025,17),(6244542,52206031,18),(6244542,52206033,19),(6244542,52206036,20),(6244542,52206040,21),(6244542,52206041,22),(6244542,52206044,23),(6244542,52206048,24),(6244542,52206051,25),(6244542,52206054,26),(6244542,52206057,27),(6244542,52206060,28),(6244542,52206063,29),(6244542,52206068,30),(6244542,52206069,31),(6244542,52206072,32),(6244542,52206076,33),(6244542,52206078,34),(6244542,52206165,35),(6244542,52206177,36),(6244542,52206181,37),(6244542,52206185,38),(6244542,52206187,39),(6244542,52206189,40),(6244542,52206193,41),(6244542,52206195,42),(6244542,52206198,43),(6244542,52206202,44),(6244542,52206203,45),(6244542,52206207,46),(6244542,52206209,47),(6244542,52206212,48),(6244542,52206215,49),(6244542,52206218,50),(6244542,52206221,51),(6244542,52206225,52),(6244542,52206228,53),(6244542,52206231,54),(6244542,52206234,55),(6244542,52206238,56),(6244542,52206240,57),(6244542,52206242,58),(6244542,52206244,59),(6244542,52206250,60),(6244542,52206252,61),(6244542,52206254,62),(6244542,52206256,63),(6244542,52206259,64),(6244542,52206262,65),(6244542,52206266,66),(6244542,52206268,67),(6244542,52206271,68),(6244542,52206274,69),(6244542,52206277,70),(6244542,52206280,71),(6244542,52206283,72),(6244542,52206286,73),(6244542,52206290,74),(6244542,52206293,75),(6244542,52206294,76),(6244542,52206299,77),(6244542,52206302,78),(6244542,52206304,79),(6244542,52206306,80),(6244542,52206310,81),(6244542,52206312,82),(6244542,52206315,83),(6244542,52206317,84),(6244542,52206320,85),(6244542,52206321,86),(6244542,52206324,87),(6244542,52206327,88),(6244542,52206333,89),(6244542,52206336,90),(6244542,52206337,91),(6244542,52206340,92),(6244542,52206343,93),(6244542,52206344,94),(6244542,52206347,95),(6244542,52206349,96),(6244542,52206352,97),(6244542,52206354,98),(6244542,52206356,99),(6244542,52206358,100),(6244542,52206359,101),(6244542,52206360,102),(6244542,52206364,103),(6244542,52206366,104),(6244542,52206374,105),(6244542,52206379,106),(6244542,52206383,107),(6244542,52206385,108),(6244542,52206389,109),(6244542,52206395,110),(6244542,52206400,111),(6244542,52206404,112),(6244542,52206407,113),(6244542,52206410,114),(6244542,52206414,115),(6244542,52206419,116),(6244542,52206420,117),(6244542,52206422,118),(6244542,52206425,119),(6244542,52206429,120),(6244542,52206433,121),(6244542,52206435,122),(6244542,52206439,123),(6244542,52206442,124),(6244542,52206446,125),(6244542,52206447,126),(6244542,52206449,127),(6244542,52206453,128),(6244542,52206457,129),(6244542,52206461,130),(6244542,52206468,131),(6244542,52206471,132),(6244542,52206472,133),(6244545,52206476,1),(6244545,52206479,2),(6244545,52206483,3),(6244545,52206486,4),(6244545,52206488,5),(6244545,52206491,6),(6244545,52206495,7),(6244545,52206498,8),(6244545,52206502,9),(6244545,52206505,10),(6244545,52206508,11),(6244545,52206512,12),(6244545,52206580,13),(6244545,52206583,14),(6244545,52206585,15),(6244545,52206588,16),(6244545,52206591,17),(6244545,52206601,18),(6244545,52206604,19),(6244545,52206607,20),(6244545,52206609,21),(6244545,52206611,22),(6244545,52206615,23),(6244545,52206617,24),(6244545,52206619,25),(6244545,52206620,26),(6244545,52206622,27),(6244545,52206625,28),(6244545,52206627,29),(6244545,52206628,30),(6244550,52206676,1),(6244550,52206679,2),(6244550,52206681,3),(6244550,264465130,4),(6244551,52206645,1),(6244551,52206647,2),(6244551,52206650,3),(6244551,52206653,4),(6244551,52206655,5),(6244551,52206657,6),(6244551,52206661,7),(6244551,52206663,8),(6244552,52206663,1),(6244552,52206666,2),(6244554,52206666,1),(6244554,52206669,2),(6244554,52206671,3),(6244554,52206673,4),(6244554,52206676,5),(6244556,52206708,1),(6244556,52206710,2),(6244556,52206647,3),(6244558,52206706,1),(6244558,52206708,2),(6244561,52206691,1),(6244561,52206694,2),(6244561,52206698,3),(6244561,52206701,4),(6244561,52206703,5),(6244561,52206706,6),(6244562,52206714,1),(6244562,52206701,2),(6244759,52212234,1),(6244759,52212307,2),(6244759,52212628,3),(6244759,52212746,4),(6244759,52212871,5),(6244759,52212893,6),(6244759,52212906,7),(6244759,52212920,8),(6244759,52206688,9),(6244763,52212916,1),(6244763,52212920,2),(6247260,52252247,1),(6247260,52252315,2),(6247267,52252320,1),(6247267,52252433,2),(6247268,144217502,1),(6247268,144217504,2),(6247268,144217505,3),(6247268,144217506,4),(6247268,144217507,5),(6247268,144217508,6),(6247268,144217510,7),(6247268,144217512,8),(6247268,144217513,9),(6247268,144217514,10),(6247268,144217515,11),(6247268,144217517,12),(6247268,796041497,13),(6247268,144217519,14),(6247268,51386536,15),(6247268,51386538,16),(6247268,51386455,17),(6247268,51386456,18),(6247268,51386457,19),(6247268,51386340,20),(6247268,51386342,21),(6247268,51386346,22),(6247268,51386271,23),(6247268,51386274,24),(6247268,51386275,25),(6247268,51386276,26),(6247268,51386279,27),(6247268,51386281,28),(6247268,51386282,29),(6247268,51386284,30),(6247268,51386286,31),(6247268,51386287,32),(6247268,51386289,33),(6247268,51386290,34),(6247268,51386294,35),(6247268,51386295,36),(6247268,51386296,37),(6247268,51386298,38),(6247269,52252333,1),(6247269,51386298,2),(6247270,52252331,1),(6247270,52252330,2),(6247270,52252328,3),(6247270,52252411,4),(6247270,52252326,5),(6247270,52252325,6),(6247270,52252322,7),(6247270,52252336,8),(6247270,52252333,9),(6247270,52252331,10),(6247271,52252326,1),(6247271,51386301,2),(6247273,51386301,1),(6247273,52252322,2),(6247274,52252411,1),(6247274,52252407,2),(6247274,52252405,3),(6247274,52252404,4),(6247274,52252412,5),(6247274,52252414,6),(6247274,52252416,7),(6247274,52252417,8),(6247274,52252420,9),(6247274,52252422,10),(6247274,52252423,11),(6247274,52252424,12),(6247274,52252426,13),(6247274,52252427,14),(6247274,52252429,15),(6247274,52252430,16),(6247274,52252431,17),(6247274,52252433,18),(6247274,52261890,19),(6247274,52322119,20),(6247274,52252247,21),(6247274,52252434,22),(6247274,52252435,23),(6247274,52252437,24),(6247274,52330668,25),(6247274,52252452,26),(6247274,52252472,27),(6247274,52252473,28),(6247274,51385976,29),(6247278,52261850,1),(6247278,52261860,2),(6247278,52261864,3),(6247278,52261866,4),(6247278,52261869,5),(6247278,52261872,6),(6247278,52261874,7),(6247278,52261878,8),(6247278,52261880,9),(6247278,52261883,10),(6247278,52261907,11),(6247279,52262076,1),(6247279,52262074,2),(6247279,52262072,3),(6247279,52262070,4),(6247279,52262067,5),(6247279,52262065,6),(6247279,52262064,7),(6247279,52262063,8),(6247279,52262060,9),(6247279,52262058,10),(6247279,52262057,11),(6247279,52262054,12),(6247279,52262052,13),(6247279,52262048,14),(6247279,52262047,15),(6247279,52262046,16),(6247279,52262045,17),(6247279,52262044,18),(6247279,52262042,19),(6247279,52262041,20),(6247279,52262039,21),(6247279,52262037,22),(6247279,52262036,23),(6247279,52262034,24),(6247279,52262031,25),(6247279,52262028,26),(6247279,52262025,27),(6247279,52261997,28),(6247279,52261993,29),(6247279,52261991,30),(6247279,52261987,31),(6247279,52261985,32),(6247279,52261982,33),(6247279,52261978,34),(6247279,52261975,35),(6247279,52261972,36),(6247279,52261969,37),(6247279,52261965,38),(6247279,52262022,39),(6247279,52261962,40),(6247279,52261959,41),(6247279,52261955,42),(6247279,52261951,43),(6247279,52261947,44),(6247279,52261946,45),(6247279,52261940,46),(6247279,52261938,47),(6247279,52261934,48),(6247279,52261931,49),(6247279,52261927,50),(6247279,52261926,51),(6247279,52261924,52),(6247279,52261921,53),(6247279,52261918,54),(6247279,52261914,55),(6247279,52261910,56),(6247279,52261907,57),(6247279,52261902,58),(6247279,52261900,59),(6247279,52261896,60),(6247279,52261893,61),(6247279,52261886,62),(6247279,52261888,63),(6247279,52261890,64),(6247280,52261999,1),(6247280,52262003,2),(6247280,52262006,3),(6247280,52262010,4),(6247280,52262016,5),(6247280,52262020,6),(6247280,52262022,7),(6247282,52262332,1),(6247282,52262335,2),(6247282,52262338,3),(6247282,52262341,4),(6247282,52262345,5),(6247282,52262348,6),(6247282,52262350,7),(6247282,52262353,8),(6247282,52262356,9),(6247282,52262360,10),(6247282,52262362,11),(6247282,52262366,12),(6247282,52262369,13),(6247282,52262373,14),(6247282,52262375,15),(6247282,52262379,16),(6247282,52262380,17),(6247282,52262383,18),(6247282,52262389,19),(6247282,52262391,20),(6247282,52262395,21),(6247282,52262397,22),(6247282,52262401,23),(6247282,52262404,24),(6247282,52262408,25),(6247282,52262411,26),(6247282,52262413,27),(6247282,52262417,28),(6247282,52262420,29),(6247282,52262422,30),(6247282,52262426,31),(6247282,52262428,32),(6247282,52262431,33),(6247282,52262434,34),(6247282,52262438,35),(6247282,52262442,36),(6247282,52262448,37),(6247282,52262451,38),(6247282,52262454,39),(6247282,52262457,40),(6247282,52262459,41),(6247282,52262463,42),(6247282,52262466,43),(6247282,52262470,44),(6247282,52262473,45),(6247282,52262476,46),(6247282,52262480,47),(6247282,52262482,48),(6247282,52262485,49),(6247283,52262538,1),(6247283,52262541,2),(6247283,52262544,3),(6247283,52262546,4),(6247283,52262550,5),(6247283,52262552,6),(6247283,52262556,7),(6247283,52262560,8),(6247283,52262563,9),(6247283,52262566,10),(6247284,52262910,1),(6247284,52262913,2),(6247284,52262916,3),(6247284,52262919,4),(6247284,52262921,5),(6247284,52262925,6),(6247284,52262930,7),(6247284,52262934,8),(6247284,52262938,9),(6247285,52262941,1),(6247285,52262944,2),(6247285,52262946,3),(6247285,52262949,4),(6247285,52262954,5),(6247285,52262957,6),(6247285,52262961,7),(6247285,52262963,8),(6247285,52262967,9),(6247286,52262970,1),(6247286,52262973,2),(6247286,52262977,3),(6247286,52262979,4),(6247286,52262981,5),(6247286,52263076,6),(6247286,52263079,7),(6247286,52263083,8),(6247287,52263091,1),(6247287,52263095,2),(6247287,52263098,3),(6247288,52263100,1),(6247288,52263106,2),(6247288,52263109,3),(6247288,52263111,4),(6247288,52263113,5),(6247288,52263117,6),(6247288,52263119,7),(6247288,52262908,8),(6247289,52263162,1),(6247289,52263166,2),(6247289,52263168,3),(6247289,52263171,4),(6247289,52263173,5),(6247289,52263177,6),(6247289,52263180,7),(6247289,52263183,8),(6247289,52263186,9),(6247289,52263190,10),(6247289,52263191,11),(6247289,52263195,12),(6247290,52263546,1),(6247290,52263549,2),(6247290,52263553,3),(6247290,52263554,4),(6247290,52263556,5),(6247290,52263559,6),(6247290,52263560,7),(6247290,52263618,8),(6247290,52263563,9),(6247290,52263566,10),(6247290,52263570,11),(6247290,52263573,12),(6247290,52263575,13),(6247290,52263696,14),(6247290,52263623,15),(6247290,52263625,16),(6247290,52263628,17),(6247290,52263629,18),(6247290,52263632,19),(6247290,52263634,20),(6247290,52263637,21),(6247290,52263639,22),(6247290,52263641,23),(6247290,52263644,24),(6247290,52263646,25),(6247290,52263649,26),(6247290,52263727,27),(6247290,52263650,28),(6247290,52263652,29),(6247290,52263655,30),(6247290,52263657,31),(6247290,52263660,32),(6247290,52263662,33),(6247290,52263665,34),(6247290,52263667,35),(6247290,52263669,36),(6247291,52263621,1),(6247291,52263577,2),(6247291,52263579,3),(6247291,52263581,4),(6247291,52263584,5),(6247291,52263593,6),(6247291,52263586,7),(6247291,52263588,8),(6247291,52263595,9),(6247291,52263598,10),(6247291,52263602,11),(6247291,52263605,12),(6247291,52263608,13),(6247291,52263611,14),(6247291,52263615,15),(6247291,52263617,16),(6247291,52263618,17),(6247292,52263726,1),(6247292,52263724,2),(6247292,52263722,3),(6247292,52263721,4),(6247292,52263718,5),(6247292,52263717,6),(6247292,52263716,7),(6247292,52263713,8),(6247292,52263712,9),(6247292,52263711,10),(6247292,52263708,11),(6247292,52263706,12),(6247292,52263704,13),(6247292,52263702,14),(6247292,52263700,15),(6247292,52263698,16),(6247292,52263670,17),(6247292,52263672,18),(6247292,52263674,19),(6247292,52263681,20),(6247292,52263683,21),(6247292,52263686,22),(6247292,52263687,23),(6247292,52263688,24),(6247292,52263691,25),(6247292,52263693,26),(6247292,52263696,27),(6247294,52263868,1),(6247294,52263854,2),(6247294,52263857,3),(6247294,52263858,4),(6247294,52263860,5),(6247294,52263863,6),(6247294,52263865,7),(6247295,52263870,1),(6247295,52263873,2),(6247295,52263875,3),(6247295,52263876,4),(6247295,52263854,5),(6247296,52263877,1),(6247296,52263876,2),(6248150,52286947,1),(6248150,52286950,2),(6248150,52286951,3),(6248150,52286954,4),(6248150,52286967,5),(6248150,52286970,6),(6248150,52286971,7),(6248150,52286973,8),(6248150,52286974,9),(6248150,52286975,10),(6248151,52287059,1),(6248151,52287063,2),(6248151,52287062,3),(6248455,52297501,1),(6248455,52296455,2),(6248455,52296457,3),(6248455,52296459,4),(6248455,52296460,5),(6248455,52296461,6),(6248455,52296462,7),(6248455,52296464,8),(6248455,52296465,9),(6248455,52296467,10),(6248455,52297542,11),(6248455,52296469,12),(6248455,52296471,13),(6248455,52297285,14),(6248455,52296472,15),(6248455,52296476,16),(6248455,52296478,17),(6248455,52296481,18),(6248455,52296483,19),(6248455,52296485,20),(6248455,52296486,21),(6248455,52296489,22),(6248455,52296490,23),(6248455,52296492,24),(6248455,52296494,25),(6248455,52296495,26),(6248455,52296497,27),(6248455,52296999,28),(6248455,52296975,29),(6248455,52296977,30),(6248455,52296978,31),(6248455,52296979,32),(6248455,52288390,33),(6248456,52296981,1),(6248456,52296982,2),(6248456,52296984,3),(6248456,52296985,4),(6248456,52296987,5),(6248456,52297038,6),(6248456,52296990,7),(6248456,52296992,8),(6248456,52296994,9),(6248456,52296996,10),(6248456,52296999,11),(6248458,52297002,1),(6248458,52297004,2),(6248458,52297007,3),(6248458,52297010,4),(6248458,52297013,5),(6248458,52297015,6),(6248458,52297018,7),(6248458,52297038,8),(6248459,52297041,1),(6248459,52297063,2),(6248459,52297071,3),(6248459,52297255,4),(6248459,52297266,5),(6248459,52297268,6),(6248459,52297272,7),(6248459,52297276,8),(6248459,52297279,9),(6248459,52297281,10),(6248459,52297285,11),(6248460,52297288,1),(6248460,52297290,2),(6248460,52297294,3),(6248460,52297312,4),(6248460,52297297,5),(6248460,52297300,6),(6248460,52297301,7),(6248461,52297305,1),(6248461,52297309,2),(6248461,52297312,3),(6248462,52297314,1),(6248462,52297317,2),(6248462,52297320,3),(6248462,52297324,4),(6248462,52297328,5),(6248462,52297333,6),(6248462,52297339,7),(6248462,52297344,8),(6248462,52297349,9),(6248462,52297354,10),(6248462,52297358,11),(6248462,52297362,12),(6248462,52297366,13),(6248462,52297369,14),(6248462,52297373,15),(6248462,52297375,16),(6248462,52297380,17),(6248462,52297383,18),(6248462,52288377,19),(6248463,52297498,1),(6248463,52297494,2),(6248463,52297492,3),(6248463,52297488,4),(6248463,52297484,5),(6248463,52297482,6),(6248463,52297478,7),(6248463,52297474,8),(6248463,52297470,9),(6248463,52297469,10),(6248463,52297465,11),(6248463,52297462,12),(6248463,52297459,13),(6248463,52297455,14),(6248463,52297450,15),(6248463,52297447,16),(6248463,52297442,17),(6248463,52297440,18),(6248463,52297437,19),(6248463,52297435,20),(6248463,52297432,21),(6248463,52297427,22),(6248463,52297424,23),(6248463,52297422,24),(6248463,52297418,25),(6248463,52297412,26),(6248463,52297410,27),(6248463,52297405,28),(6248463,52297402,29),(6248463,52297386,30),(6248463,52297390,31);
INSERT INTO `current_way_nodes` VALUES (6248463,52297393,32),(6248463,52297397,33),(6248464,52297507,1),(6248464,52297509,2),(6248464,52297515,3),(6248464,52297517,4),(6248464,52297520,5),(6248464,52297521,6),(6248464,52297525,7),(6248464,52297528,8),(6248464,52297532,9),(6248464,52297535,10),(6248464,52297537,11),(6248464,52297540,12),(6248464,52297542,13),(6248467,52297545,1),(6248467,52297547,2),(6248467,52297550,3),(6248467,52297602,4),(6248467,52297554,5),(6248467,52297558,6),(6248467,52297560,7),(6248467,52297563,8),(6248467,52297565,9),(6248467,52297567,10),(6248467,52297571,11),(6248467,52297573,12),(6248467,52297576,13),(6248467,52297580,14),(6248467,52288514,15),(6248468,52297584,1),(6248468,52297587,2),(6248468,52297590,3),(6248468,52297592,4),(6248468,52297595,5),(6248468,52297599,6),(6248468,52297602,7),(6248469,52297606,1),(6248469,52297609,2),(6248469,52297612,3),(6248469,52297615,4),(6248469,52297617,5),(6248469,52297621,6),(6248469,52297623,7),(6248469,52297626,8),(6248469,52297629,9),(6248469,52297633,10),(6248469,52297638,11),(6248469,52297640,12),(6248469,52297643,13),(6248469,52297646,14),(6248469,52297650,15),(6249800,52322119,1),(6249800,52322115,2),(6249800,52322112,3),(6249800,52322122,4),(6249800,52322125,5),(6249800,52322137,6),(6249800,52322143,7),(6249800,52322151,8),(6249800,52322153,9),(6249800,52322155,10),(6249800,52322156,11),(6249800,52330678,12),(6249800,52322157,13),(6249800,52322159,14),(6249800,52322163,15),(6249800,52322165,16),(6249800,52322167,17),(6249800,52322170,18),(6249800,52322171,19),(6249800,52322174,20),(6249800,52322177,21),(6249800,52322180,22),(6249800,52322184,23),(6249800,52329934,24),(6249800,52322185,25),(6249800,52322190,26),(6249800,52322193,27),(6249800,52322196,28),(6249800,52322198,29),(6249800,52322200,30),(6249800,52322203,31),(6249800,52322207,32),(6249800,52322210,33),(6249800,52322213,34),(6249800,52322216,35),(6249800,52322219,36),(6249800,52322222,37),(6249800,52322223,38),(6249800,52322225,39),(6249800,52322228,40),(6249800,52322231,41),(6249800,52322235,42),(6249800,52322237,43),(6249800,52322240,44),(6249800,52322242,45),(6249800,52322244,46),(6249800,52322245,47),(6249800,52322247,48),(6249800,52322249,49),(6249800,52322252,50),(6249800,52322255,51),(6249800,52322256,52),(6249800,52322259,53),(6249800,52322262,54),(6249800,52322266,55),(6249800,52322268,56),(6249800,52322271,57),(6249800,52322273,58),(6249800,52322277,59),(6249800,52322278,60),(6249800,52322279,61),(6249800,52322282,62),(6249800,52322285,63),(6249800,52322286,64),(6249800,52322289,65),(6249800,52322292,66),(6249800,52322293,67),(6249800,52322295,68),(6249800,52322298,69),(6249800,52322299,70),(6249800,52322302,71),(6249800,52322305,72),(6249800,52322308,73),(6249800,52322309,74),(6249800,52322311,75),(6249800,52322313,76),(6249800,52322315,77),(6249800,52322316,78),(6249800,52322318,79),(6249800,52322320,80),(6249800,52322322,81),(6249800,52322324,82),(6249800,52322327,83),(6249800,52322329,84),(6249800,52322331,85),(6249800,52322333,86),(6249800,52322335,87),(6249800,52322336,88),(6249800,52322337,89),(6249800,52322339,90),(6249800,52322341,91),(6249800,52322342,92),(6249800,52322344,93),(6249800,52322345,94),(6249800,52322347,95),(6249800,52322349,96),(6249800,52322351,97),(6249800,52322353,98),(6249800,52322355,99),(6249800,52322357,100),(6249800,52322358,101),(6249800,52322359,102),(6249800,52322361,103),(6249800,52322363,104),(6249800,52322364,105),(6249800,52322365,106),(6249800,52322366,107),(6249800,52322368,108),(6249800,52322370,109),(6249800,52322372,110),(6249800,52322374,111),(6249800,52322376,112),(6249800,52322378,113),(6249800,52322380,114),(6249800,52322382,115),(6249800,52322384,116),(6249800,52322386,117),(6249800,52322388,118),(6249800,52322390,119),(6249800,52322392,120),(6249800,52322395,121),(6249800,52322398,122),(6249800,52322400,123),(6249800,52322402,124),(6249800,52322405,125),(6249800,52322408,126),(6249800,52322411,127),(6249800,52322413,128),(6249800,52322415,129),(6249800,52322419,130),(6249800,52322422,131),(6249800,52322424,132),(6249800,52322429,133),(6249800,52322432,134),(6249800,52322434,135),(6249800,52322437,136),(6249800,52322440,137),(6249800,52322441,138),(6249800,52322443,139),(6249800,52322446,140),(6249800,52322449,141),(6249800,52322451,142),(6249800,52322453,143),(6249800,52322455,144),(6249800,52322458,145),(6249800,52322461,146),(6249800,52322463,147),(6249800,52322465,148),(6249800,52322467,149),(6249800,52322470,150),(6249800,52322473,151),(6249800,52322475,152),(6249800,52322478,153),(6249800,52322481,154),(6249800,52322484,155),(6249800,52322486,156),(6249800,52322488,157),(6249800,52322492,158),(6249800,52322493,159),(6249800,52322496,160),(6249800,52322497,161),(6249800,52322500,162),(6249800,52322502,163),(6249800,52322504,164),(6249800,52322508,165),(6249800,52322510,166),(6249800,52322512,167),(6249800,52322515,168),(6249800,52322516,169),(6249800,52322518,170),(6249800,52322520,171),(6249800,52322523,172),(6249800,52322526,173),(6249800,52322528,174),(6249800,52322530,175),(6249800,52322533,176),(6249800,52322534,177),(6249800,52322537,178),(6249800,52322540,179),(6249800,52322542,180),(6249800,52322544,181),(6249800,52322545,182),(6249800,52322548,183),(6249800,52322551,184),(6249800,52322552,185),(6249800,52322554,186),(6249800,52322557,187),(6249800,52322558,188),(6249800,52322561,189),(6249800,52322562,190),(6249800,52322564,191),(6249800,52322567,192),(6249800,52322570,193),(6249800,52322571,194),(6249800,52322574,195),(6249800,52322578,196),(6249800,52322579,197),(6249800,52322581,198),(6249800,52322583,199),(6249800,52322585,200),(6249800,52322587,201),(6249800,52322589,202),(6249800,52322591,203),(6249800,52322593,204),(6249800,52322595,205),(6249800,52322598,206),(6249800,52322601,207),(6249800,52322602,208),(6249800,52322604,209),(6249800,52322606,210),(6249800,52322611,211),(6249800,52322613,212),(6249800,52322615,213),(6249800,52328367,214),(6249800,52322617,215),(6249800,52322618,216),(6249800,52322623,217),(6249800,52322626,218),(6249800,52322627,219),(6249800,52322630,220),(6249800,52322632,221),(6249800,52322634,222),(6249800,52322713,223),(6249800,52322716,224),(6249800,52322719,225),(6249800,52322722,226),(6249800,52322725,227),(6249800,52322727,228),(6249800,52322729,229),(6249800,52322731,230),(6249800,52322733,231),(6249800,52322736,232),(6249800,52322738,233),(6249800,52322739,234),(6249800,52322741,235),(6249800,52322753,236),(6249800,52322755,237),(6249800,52322758,238),(6249800,52322761,239),(6249800,52322764,240),(6249800,52322765,241),(6249800,52322768,242),(6249800,52322770,243),(6249800,52322773,244),(6249800,52322774,245),(6249800,52322777,246),(6249800,52322780,247),(6249800,52322782,248),(6249800,52322785,249),(6249800,52322787,250),(6249800,52322789,251),(6249800,52322791,252),(6249800,52322793,253),(6249800,52322795,254),(6249800,52322796,255),(6249800,52322799,256),(6249800,52322800,257),(6249800,52322802,258),(6249800,52322804,259),(6249800,52322806,260),(6249800,52322809,261),(6249800,52322810,262),(6249800,52322815,263),(6249800,52322816,264),(6249800,52322819,265),(6249800,52322823,266),(6249800,52322826,267),(6249800,52322827,268),(6249800,52322830,269),(6249800,52322833,270),(6249800,52322836,271),(6249800,52322837,272),(6249800,52322840,273),(6249800,52322842,274),(6249800,52322844,275),(6249800,52322846,276),(6249800,52322847,277),(6249800,52322850,278),(6249800,52322851,279),(6249800,52322855,280),(6249800,52322858,281),(6249800,52322859,282),(6249800,52322863,283),(6249800,52322865,284),(6249800,52322867,285),(6249800,52322871,286),(6249800,52322874,287),(6249800,52322877,288),(6249800,52322879,289),(6249800,52322880,290),(6249800,52322883,291),(6249800,52322887,292),(6249800,52322889,293),(6249800,52322891,294),(6249800,52322893,295),(6249800,52322896,296),(6249800,52322898,297),(6249800,52322902,298),(6249800,52322903,299),(6249800,52322904,300),(6249800,52327417,301),(6249800,52322907,302),(6249800,52322910,303),(6249800,52322911,304),(6249800,52322915,305),(6249800,52322917,306),(6249800,52322919,307),(6249800,52322921,308),(6249800,52322924,309),(6249800,52322927,310),(6249800,52322929,311),(6249800,52322931,312),(6249800,52322934,313),(6249800,52322937,314),(6249800,52322940,315),(6249800,52322942,316),(6249800,52322945,317),(6249800,52322947,318),(6249800,52322950,319),(6249800,52322953,320),(6249800,52322955,321),(6249800,52322957,322),(6249800,52322959,323),(6249800,52322962,324),(6249800,52322964,325),(6249800,52322966,326),(6249800,52322969,327),(6249800,52322972,328),(6249800,52322974,329),(6249800,52322976,330),(6249800,52322977,331),(6249800,52322979,332),(6249800,52322982,333),(6249802,52322636,1),(6249802,52322639,2),(6249802,52322641,3),(6249802,52322644,4),(6249802,52322646,5),(6249802,52322648,6),(6249802,52322651,7),(6249802,52322654,8),(6249802,52322656,9),(6249802,52322657,10),(6249802,52322660,11),(6249802,52322663,12),(6249802,52322665,13),(6249802,52322667,14),(6249802,52322670,15),(6249802,52322673,16),(6249802,52322675,17),(6249802,52322677,18),(6249802,52322678,19),(6249802,52322681,20),(6249802,52322684,21),(6249802,52322685,22),(6249802,52322687,23),(6249802,52322690,24),(6249802,52322692,25),(6249802,52322695,26),(6249802,52322697,27),(6249802,52322712,28),(6249802,52322698,29),(6249802,52322700,30),(6249802,52322701,31),(6249802,52322704,32),(6249802,52322706,33),(6249802,52322382,34),(6249803,52322709,1),(6249803,52322712,2),(6250052,52327233,1),(6250052,52327235,2),(6250052,52327238,3),(6250052,52327241,4),(6250052,52327243,5),(6250052,52327246,6),(6250052,52327247,7),(6250052,52327250,8),(6250052,52327252,9),(6250052,52322962,10),(6250053,52327263,1),(6250053,52327265,2),(6250053,52327268,3),(6250053,52327271,4),(6250053,52327274,5),(6250053,52327277,6),(6250053,52327279,7),(6250053,52322982,8),(6250053,52327281,9),(6250053,52327282,10),(6250053,52327285,11),(6250053,52327287,12),(6250053,52327288,13),(6250053,52327290,14),(6250053,52327292,15),(6250053,52327295,16),(6250053,52327298,17),(6250053,52327300,18),(6250053,52327302,19),(6250053,52327337,20),(6250053,52327303,21),(6250053,52327306,22),(6250053,52327309,23),(6250053,52327310,24),(6250053,52327313,25),(6250053,52327316,26),(6250053,52327317,27),(6250053,52327321,28),(6250053,52327325,29),(6250053,52327328,30),(6250053,52327329,31),(6250053,52327331,32),(6250053,52327333,33),(6250055,52327339,1),(6250055,52327341,2),(6250055,52327342,3),(6250055,52327345,4),(6250055,52327347,5),(6250055,52327351,6),(6250055,52327333,7),(6250055,52327354,8),(6250055,52327358,9),(6250055,52327359,10),(6250055,52327361,11),(6250055,52327362,12),(6250055,52327365,13),(6250055,52327368,14),(6250055,52327371,15),(6250055,52327372,16),(6250055,52327375,17),(6250055,52327378,18),(6250055,52327379,19),(6250055,52327381,20),(6250055,52327383,21),(6250055,52327384,22),(6250055,52327387,23),(6250056,52327388,1),(6250056,52327390,2),(6250056,52327392,3),(6250056,52327393,4),(6250056,52327398,5),(6250056,52327401,6),(6250056,52327403,7),(6250056,52327406,8),(6250056,52327408,9),(6250056,52327411,10),(6250056,52327413,11),(6250056,52327417,12),(6250057,52327418,1),(6250057,52327421,2),(6250057,52327423,3),(6250057,52327427,4),(6250057,52327429,5),(6250057,52327432,6),(6250057,52327434,7),(6250057,52322615,8),(6250105,52328346,1),(6250105,52328347,2),(6250105,52328370,3),(6250105,52328373,4),(6250105,52328348,5),(6250105,52328350,6),(6250105,52328353,7),(6250105,52328354,8),(6250105,52328357,9),(6250105,52328358,10),(6250105,52328360,11),(6250105,52328362,12),(6250105,52328364,13),(6250105,52328365,14),(6250105,52328367,15),(6250238,52329934,1),(6250238,52329937,2),(6250238,52329940,3),(6250238,52329942,4),(6250238,52329943,5),(6250238,52329946,6),(6250238,52329948,7),(6250238,52329951,8),(6250239,52322170,1),(6250239,52329953,2),(6250239,52329956,3),(6250239,52329957,4),(6250239,52329960,5),(6250239,52329962,6),(6250239,52329964,7),(6250239,52329967,8),(6250239,52329968,9),(6250239,52329970,10),(6250239,52329972,11),(6250239,52329974,12),(6250239,52329978,13),(6250239,52329981,14),(6250239,52322216,15),(6250280,52330668,1),(6250280,52330669,2),(6250280,52330670,3),(6250280,52330671,4),(6250280,52330672,5),(6250280,52330673,6),(6250280,52330674,7),(6250280,52330675,8),(6250280,52330676,9),(6250280,52330677,10),(6250280,52330678,11),(6267429,52261850,1),(6267429,52261846,2),(6267429,52261842,3),(6267429,52261839,4),(6267429,52261835,5),(6267429,52261834,6),(6267429,52261829,7),(6267429,52252480,8),(6267429,52252479,9),(6267429,52261857,10),(6267429,52252478,11),(6267429,52252477,12),(6267429,52252476,13),(6267429,52261853,14),(6267429,52252474,15),(6267429,52252475,16),(6267429,52252427,17),(6267881,52578634,1),(6267881,52578637,2),(6267882,52578637,1),(6267882,51386296,2),(6267884,52578800,1),(6267884,52578802,2),(6267884,52578805,3),(6267884,52578801,4),(6268924,52579285,1),(6268924,52596154,2),(6268924,52596149,3),(6268924,52596158,4),(6268924,52596161,5),(6268924,52596163,6),(6268924,52596167,7),(6268924,52596171,8),(6268924,52596178,9),(6268924,52596180,10),(6268924,52596184,11),(6268924,52596186,12),(6268924,52596191,13),(6268924,52596195,14),(6268924,52596197,15),(6268924,52596200,16),(6268924,52596204,17),(6268924,52596208,18),(6268924,52596212,19),(6268924,52596213,20),(6268924,52596216,21),(6268924,52596219,22),(6268924,52596222,23),(6268924,52596226,24),(6268924,52596228,25),(6268924,52596231,26),(6268924,52596234,27),(6268924,52596236,28),(6268924,52596238,29),(6268924,52596241,30),(6268924,52596243,31),(6268924,52596246,32),(6268924,52596249,33),(6268924,52596271,34),(6268924,52596274,35),(6268924,52596277,36),(6268924,52596280,37),(6268924,52596283,38),(6268924,52596285,39),(6268924,52596288,40),(6268924,52596291,41),(6268924,52596295,42),(6268924,52596297,43),(6268924,52596299,44),(6268924,52596300,45),(6268924,52596303,46),(6268924,52596305,47),(6268924,52596308,48),(6268924,52596310,49),(6268924,52596312,50),(6268924,52596314,51),(6268924,52596318,52),(6268924,52596320,53),(6268924,52596326,54),(6268924,52596331,55),(6268924,52596335,56),(6268924,52596339,57),(6268924,52596343,58),(6268924,52596346,59),(6268924,52596351,60),(6269464,52623167,1),(6269464,52623169,2),(6269464,52623170,3),(6269464,52623173,4),(6269464,52623176,5),(6269464,52623178,6),(6269464,52623180,7),(6269464,52623182,8),(6269464,52623185,9),(6269464,52623187,10),(6269464,52623190,11),(6269464,52623193,12),(6269464,52623196,13),(6269464,52623199,14),(6269464,52623201,15),(6269464,52623203,16),(6269464,52623205,17),(6269464,52623207,18),(6269464,52623209,19),(6269464,52623212,20),(6269464,52623215,21),(6269464,52623218,22),(6269464,52623226,23),(6269464,52623229,24),(6269464,52623231,25),(6269464,52623233,26),(6269464,52623236,27),(6269464,52623240,28),(6269464,52623242,29),(6269464,52623245,30),(6269464,52623247,31),(6269464,52623250,32),(6269464,52623252,33),(6269464,52623255,34),(6269464,52623259,35),(6269464,52623261,36),(6269464,52623265,37),(6269464,52623268,38),(6269464,52623273,39),(6269464,52623276,40),(6269464,52623278,41),(6269464,52623282,42),(6269464,52623285,43),(6269464,52623287,44),(6269464,52623290,45),(6269464,52623294,46),(6269464,52623296,47),(6269464,52623299,48),(6269464,52623301,49),(6269464,52623303,50),(6269464,52623305,51),(6269464,52623308,52),(6269464,52623310,53),(6269464,52623315,54),(6269464,52623317,55),(6269464,52623321,56),(6269464,52623324,57),(6269464,52623329,58),(6269464,52623333,59),(6269464,52623334,60),(6269464,52623339,61),(6269464,52623344,62),(6269464,52623348,63),(6269464,52623351,64),(6269464,52623354,65),(6269464,52623358,66),(6269464,52623360,67),(6269464,52623363,68),(6269464,52623364,69),(6269464,52623367,70),(6269464,52623371,71),(6269464,52623373,72),(6269464,52623375,73),(6269464,52623378,74),(6269464,52623383,75),(6269464,52623385,76),(6269464,52623389,77),(6269464,52623392,78),(6269464,52623394,79),(6269464,52623398,80),(6269464,52623402,81),(6269464,52623403,82),(6269464,52623407,83),(6269464,52623413,84),(6269464,52623416,85),(6269464,52623417,86),(6269464,52623420,87),(6269464,52623424,88),(6269464,52623427,89),(6269464,52623431,90),(6269464,52623434,91),(6269464,52623436,92),(6269464,52623438,93),(6269464,52623441,94),(6269464,52623444,95),(6269464,52623446,96),(6269464,52623449,97),(6269464,52623453,98),(6269464,52623457,99),(6269464,52623463,100),(6269464,52623465,101),(6269464,52623471,102),(6269464,52623475,103),(6269464,52623478,104),(6269464,52623482,105),(6269464,52623485,106),(6269464,52623487,107),(6269464,52623489,108),(6269464,52623492,109),(6269464,52623494,110),(6269464,52623497,111),(6269464,52623500,112),(6269464,52623503,113),(6269464,52623506,114),(6269464,52623509,115),(6269464,52623513,116),(6269464,52623516,117),(6269464,52623517,118),(6269464,52623522,119),(6269464,52623526,120),(6269464,52623530,121),(6269464,52623533,122),(6269464,52623535,123),(6269464,52623538,124),(6269464,52623541,125),(6269464,52623543,126),(6269464,52623545,127),(6269464,52623548,128),(6269464,52623550,129),(6269464,52623553,130),(6269464,52623556,131),(6269464,52623559,132),(6269464,52623562,133),(6269464,52623565,134),(6269464,52623567,135),(6269464,52623570,136),(6269464,52623573,137),(6269464,52623576,138),(6269464,52623578,139),(6269464,52623581,140),(6269464,52623584,141),(6269464,52623587,142),(6269464,52623589,143),(6269464,52623590,144),(6269464,52623593,145),(6269464,52623597,146),(6269464,52623599,147),(6269464,52623602,148),(6269464,52623605,149),(6269464,52623610,150),(6269464,52623613,151),(6269464,52623617,152),(6269464,52623618,153),(6269464,52623621,154),(6269464,52623624,155),(6269464,52623627,156),(6269464,52623630,157),(6269464,52623633,158),(6269464,52623636,159),(6269464,52623638,160),(6269464,52623641,161),(6269464,52623644,162),(6269464,52623647,163),(6269464,52623649,164),(6269464,52623653,165),(6269464,52623655,166),(6269464,52623657,167),(6269464,52623660,168),(6269464,52623664,169),(6269464,52623667,170),(6269464,52623670,171),(6269464,52623674,172),(6269464,52623675,173),(6269464,52623679,174),(6269464,52623684,175),(6269464,52623687,176),(6269464,52623690,177),(6269464,52623692,178),(6269464,52623694,179),(6269464,52623698,180),(6269464,52623701,181),(6269464,52623702,182),(6269464,52623705,183),(6269464,52623707,184),(6269464,52623712,185),(6269464,52623713,186),(6269464,52623715,187),(6269464,52623717,188),(6269464,52623719,189),(6269464,52623720,190),(6269464,52623722,191),(6269464,52623725,192),(6269464,52623726,193),(6269464,52623728,194),(6269464,52623730,195),(6269464,52623732,196),(6269464,52623733,197),(6269464,52623736,198),(6269464,52623739,199),(6269464,52623741,200),(6269464,52623743,201),(6269464,52623746,202),(6269464,52623749,203),(6269464,52623750,204),(6269464,52623752,205),(6269464,52623753,206),(6269464,52623755,207),(6269464,52623757,208),(6269464,52623758,209),(6269464,52623759,210),(6269464,52623760,211),(6269464,52623762,212),(6269464,52623763,213),(6269464,52623765,214),(6269464,52623767,215),(6269464,52623768,216),(6269464,52623769,217),(6269464,52623771,218),(6269464,52623772,219),(6269464,52623773,220),(6269464,52623776,221),(6269464,52623777,222),(6269464,52623778,223),(6269464,52623779,224),(6269464,52623780,225),(6269464,52623781,226),(6269464,52623782,227),(6269464,52623783,228),(6269464,52623784,229),(6269464,52623785,230),(6269464,52623786,231),(6269464,52623788,232),(6269464,52623791,233),(6269464,52623792,234),(6269464,52623795,235),(6269464,52623798,236),(6269464,52623800,237),(6269464,52623802,238),(6269464,52623805,239),(6269464,52623806,240),(6269464,52623808,241),(6269464,52623809,242),(6269464,52623811,243),(6269464,52623814,244),(6269464,52623816,245),(6269464,52623819,246),(6269464,52623823,247),(6269464,52623844,248),(6269464,52623846,249),(6269464,52623849,250),(6269464,52635897,251),(6269464,52635898,252),(6269464,52635899,253),(6269464,52635900,254),(6269464,52635902,255),(6269464,52635903,256),(6269464,52635904,257),(6269464,52635905,258),(6269464,52635907,259),(6269464,52635909,260),(6269464,52635910,261),(6269464,52635912,262),(6269464,52635914,263),(6269464,52635916,264),(6269464,52635917,265),(6269464,52636119,266),(6269464,52636120,267),(6269464,52636122,268),(6269464,52636124,269),(6269464,52636127,270),(6269464,52636128,271),(6269464,52636131,272),(6269464,52636132,273),(6269464,52636133,274),(6269464,52636134,275),(6269464,52636135,276),(6269464,52636136,277),(6269464,52636137,278),(6269464,52636139,279),(6269464,52636140,280),(6269464,52636141,281),(6269464,52636142,282),(6269464,52648095,283),(6269464,52648138,284),(6269464,52648149,285),(6269464,52648164,286),(6269464,59632226,287),(6275494,52652273,1),(6275494,262893000,2),(6275497,52685723,1),(6275497,52685717,2),(6275497,52685714,3),(6275497,52685710,4),(6275497,52685707,5),(6275497,52685701,6),(6275497,52685696,7),(6275497,52685727,8),(6275497,52685732,9),(6275497,52685739,10),(6275497,52685761,11),(6275497,52685764,12),(6275497,52685771,13),(6275497,52685779,14),(6275497,52685789,15),(6275497,52685847,16),(6275497,52685851,17),(6275497,52685859,18),(6275497,52685862,19),(6275497,52685869,20),(6275497,52685873,21),(6275497,52685877,22),(6275497,52685881,23),(6275497,52685886,24),(6275497,52685894,25),(6275497,52685905,26),(6275497,52685911,27),(6275497,52685917,28),(6275497,52685920,29),(6275497,52685923,30),(6275497,52685926,31),(6275497,52685929,32),(6275497,52685931,33),(6275497,52685934,34),(6275497,52685939,35),(6275497,52685943,36),(6275497,52685946,37),(6275497,52685950,38),(6275497,52685966,39),(6275497,52685971,40),(6275497,52685975,41),(6275497,52685978,42),(6275497,52685980,43),(6275497,52685982,44),(6275497,52685986,45),(6275497,52685990,46),(6275497,52685993,47),(6275497,52685996,48),(6275497,52686002,49),(6275497,52686474,50),(6275497,52686478,51),(6275497,52686480,52),(6275497,52686486,53),(6275497,52686490,54),(6275497,52686495,55),(6275497,52686501,56),(6275497,52686505,57),(6275497,52686510,58),(6275497,52686511,59),(6275497,52686514,60),(6275497,52686517,61),(6275497,52686518,62),(6275497,52686521,63),(6275497,52686524,64),(6275497,52686527,65),(6275497,52686533,66),(6275497,52686537,67),(6275497,52686542,68),(6275497,52686544,69),(6275497,52686547,70),(6275497,52686551,71),(6275497,52686555,72),(6275497,52686561,73),(6275497,52686569,74),(6275497,52686574,75),(6275497,52686579,76),(6275497,52686586,77),(6275497,52686593,78),(6275497,52686598,79),(6275497,52686601,80),(6275497,52686604,81),(6275497,52686607,82),(6275497,52686610,83),(6275497,52686622,84),(6275497,52686626,85),(6275497,52686632,86),(6275497,52686637,87),(6275497,52686639,88),(6275497,52686644,89),(6275497,52686648,90),(6275497,52686651,91),(6275497,52686654,92),(6275497,52686655,93),(6275497,52686659,94),(6275497,52686660,95),(6275497,52686663,96),(6275497,52686666,97),(6275497,52686668,98),(6275497,52686674,99),(6275497,52686680,100),(6275497,52686682,101),(6275497,52686683,102),(6275497,52686687,103),(6275497,52688384,104),(6275497,52688387,105),(6275497,52688389,106),(6275497,52688391,107),(6275497,52688393,108),(6275497,52688398,109),(6275497,52688401,110),(6275497,52688431,111),(6275497,52688438,112),(6275497,52688454,113),(6275497,52688455,114),(6275497,52688458,115),(6275497,52688531,116),(6275497,52688570,117),(6275497,52688574,118),(6275497,52688576,119),(6275497,52688577,120),(6275497,52688580,121),(6275497,52688582,122),(6275497,52688584,123),(6275497,52688608,124),(6275497,52688609,125),(6275497,52688628,126),(6275497,52688632,127),(6275497,52688642,128),(6275497,52688633,129),(6275497,52688637,130),(6275497,52688639,131),(6275497,52688644,132),(6275497,52688646,133),(6275497,52688648,134),(6275497,52688652,135),(6275497,52688654,136),(6275497,52688655,137),(6275498,52685802,1),(6275498,52685814,2),(6275498,52685832,3),(6275498,52685840,4),(6275498,52612957,5),(6275499,52652319,1),(6275499,52652351,2),(6275499,52652477,3),(6275501,51371237,1),(6275501,51371240,2),(6275501,51371243,3),(6275501,51371246,4),(6275501,51369095,5),(6275501,51369096,6),(6275501,51369098,7),(6275501,51369101,8),(6275501,51369221,9),(6275501,51369102,10),(6275501,51369103,11),(6275501,51369105,12),(6275501,646809720,13),(6275501,51369106,14),(6275501,268631795,15),(6275501,646807552,16),(6275503,52688669,1),(6275503,52688662,2),(6275503,52688663,3),(6275503,52688667,4),(6275503,52688669,5),(6275504,52688692,1),(6275504,51369129,2),(6275504,646809553,3),(6275504,52688688,4),(6275504,52688686,5),(6275504,52688683,6),(6275504,52688680,7),(6275504,52688677,8),(6275504,51369131,9),(6275504,646809558,10),(6275504,52688676,11),(6275504,646809563,12),(6275504,52688703,13),(6275504,52688672,14),(6275504,646809578,15),(6275504,52688697,16),(6275504,52688693,17),(6275504,52688692,18),(6275505,51369131,1),(6275505,337733739,2),(6275505,51369132,3),(6275505,51369133,4),(6275505,51446992,5),(6275505,51369134,6),(6275505,51369136,7),(6275505,51399381,8),(6275505,51369139,9),(6275505,52688706,10),(6275506,52688740,1),(6275506,51410495,2),(6275506,646809672,3),(6275506,52688708,4),(6275506,646809674,5),(6275506,52688711,6),(6275506,646809678,7),(6275506,52688706,8),(6275506,52688716,9),(6275506,646809684,10),(6275506,52688721,11),(6275506,52688724,12),(6275506,646809689,13),(6275506,52688726,14),(6275506,52688728,15),(6275506,646809695,16),(6275506,52688732,17),(6275506,646809706,18),(6275506,52688735,19),(6275506,52688740,20),(6275507,52688807,1),(6275507,337779059,2),(6275507,52688741,3),(6275507,52688744,4),(6275507,52688747,5),(6275507,52688750,6),(6275507,52688753,7),(6275507,52688756,8),(6275507,52688759,9),(6275507,52688763,10),(6275507,52688767,11),(6275507,52688771,12),(6275507,52688773,13),(6275507,52688774,14),(6275507,52688778,15),(6275507,52688781,16),(6275507,52688783,17),(6275507,52688788,18),(6275507,52688790,19),(6275507,52688795,20),(6275507,52688797,21),(6275507,52688801,22),(6275507,52688802,23),(6275507,52688807,24),(6275509,51399367,1),(6275509,51399411,2),(6275509,51399365,3),(6275509,52688816,4),(6275510,52688846,1),(6275510,646809579,2),(6275510,52688810,3),(6275510,646809584,4),(6275510,52688842,5),(6275510,646809589,6),(6275510,52688838,7),(6275510,52688833,8),(6275510,52688829,9),(6275510,646809604,10),(6275510,52688824,11),(6275510,646809608,12),(6275510,52688820,13),(6275510,52688816,14),(6275510,646809614,15),(6275510,51399601,16),(6275510,52688849,17),(6275510,52688846,18),(6275512,52688833,1),(6275512,52688854,2),(6275512,52688859,3),(6275513,52688872,1),(6275513,52688870,2),(6275513,52688868,3),(6275513,52688865,4),(6275513,52688863,5),(6275513,52688860,6),(6275513,52688829,7),(6275514,51404484,1),(6275514,52688882,2),(6275514,52688884,3),(6275514,52688886,4),(6275514,52688888,5),(6275514,52688890,6),(6275514,51443088,7),(6275514,51443089,8),(6275516,51403656,1),(6275516,52688892,2),(6275516,52688894,3),(6275516,52688896,4),(6275516,52688899,5),(6275516,52688903,6),(6275516,52688904,7),(6275516,52688905,8),(6275516,52688908,9),(6275516,52688912,10),(6275516,52688914,11),(6275516,52688916,12),(6275516,52688920,13),(6275516,52688923,14),(6275516,343733031,15),(6275517,52689048,1),(6275517,52688936,2),(6275517,52688938,3),(6275517,52688942,4),(6275517,52688945,5),(6275517,52688948,6),(6275517,52688951,7),(6275517,52688953,8),(6275517,52688956,9),(6275517,52688958,10),(6275517,52688962,11),(6275517,52688963,12),(6275517,52688967,13),(6275517,52688969,14),(6275517,52688973,15),(6275517,52688975,16),(6275517,52688978,17),(6275517,52688981,18),(6275517,52689010,19),(6275517,52689011,20),(6275517,52689013,21),(6275517,52689016,22),(6275517,52689017,23),(6275517,52689019,24),(6275517,52689020,25),(6275517,52689024,26),(6275517,52689026,27),(6275517,52689028,28),(6275517,52689032,29),(6275517,52689035,30),(6275517,52689036,31),(6275517,52689039,32),(6275517,52689041,33),(6275517,52689048,34),(6275518,52689055,1),(6275518,52689060,2),(6275518,52689065,3),(6275518,52689066,4),(6275518,52689073,5),(6275518,52689076,6),(6275518,52689081,7),(6275518,52689083,8),(6275518,52689086,9),(6275518,52689090,10),(6275518,52689092,11),(6275518,52689094,12),(6275518,52689095,13),(6275518,52689097,14),(6275518,52689102,15),(6275518,52689104,16),(6275518,52689106,17),(6275518,52689107,18),(6275518,52689110,19),(6275518,52689111,20),(6275518,52689114,21),(6275518,52689115,22),(6275518,52689118,23),(6275518,52689120,24),(6275518,52689141,25),(6275518,52689142,26),(6275518,52689145,27),(6275518,52689148,28),(6275518,52689150,29),(6275518,52689154,30),(6275518,52689156,31),(6275518,52689157,32),(6275518,52689160,33),(6275518,52689162,34),(6275518,52689165,35),(6275518,52689167,36),(6275518,52689173,37),(6275518,52689178,38),(6275518,52689180,39),(6275518,52689184,40),(6275518,52689187,41),(6275518,52689189,42),(6275518,52689194,43),(6275518,52689197,44),(6275518,52689201,45),(6275518,52689204,46),(6275518,52689208,47),(6275518,52689210,48),(6275518,52689214,49),(6275518,52689217,50),(6275518,52689218,51),(6275518,52689055,52),(6275522,52689226,1),(6275522,52689230,2),(6275522,52689232,3),(6275522,52689236,4),(6275522,52689239,5),(6275522,52689242,6),(6275522,52689243,7),(6275522,52689245,8),(6275522,52689248,9),(6275522,52689249,10),(6275522,52689251,11),(6275522,52689253,12),(6275522,52689255,13),(6275522,52689257,14),(6275522,52689259,15),(6275522,52689262,16),(6275522,52689263,17),(6275522,52689265,18),(6275522,52689267,19),(6275522,52689270,20),(6275522,52689273,21),(6275522,52689275,22),(6275522,52689278,23),(6275522,52689279,24),(6275522,52689280,25),(6275522,52689282,26),(6275522,52689285,27),(6275522,52689288,28),(6275522,52689290,29),(6275522,52689292,30),(6275522,52689294,31),(6275522,52689295,32),(6275522,52689303,33),(6275522,52689304,34),(6275522,52689308,35),(6275522,52689311,36),(6275522,52689316,37),(6275522,52689319,38),(6275522,52689321,39),(6275522,52689323,40),(6275522,52689326,41),(6275522,52689328,42),(6275522,52689330,43),(6275522,52689333,44),(6275522,52689336,45),(6275522,52689338,46),(6275522,52689340,47),(6275522,52689343,48),(6275522,52689345,49),(6275522,52689348,50),(6275522,52689350,51),(6275522,52689351,52),(6275522,52689353,53),(6275522,52689355,54),(6275522,52689358,55),(6275522,52689359,56),(6275522,52689361,57),(6275522,52689363,58),(6275522,52689365,59),(6275522,52689366,60),(6275522,52689367,61),(6275522,52689371,62),(6275522,52689372,63),(6275522,52689375,64),(6275522,52689377,65),(6275522,52689379,66),(6275522,321679776,67),(6275522,52689382,68),(6275522,52689385,69),(6275522,52689387,70),(6275522,52689390,71),(6275522,52689392,72),(6275522,52689394,73),(6275522,52689396,74),(6275522,52689398,75),(6275522,52689402,76),(6275522,52689405,77),(6275522,52689406,78),(6275522,52689409,79),(6275522,52689410,80),(6275522,52689412,81),(6275522,52689414,82),(6275522,52689416,83),(6275522,52689419,84),(6275522,52689420,85),(6275522,52689423,86),(6275522,52689425,87),(6275522,52689427,88),(6275522,52689429,89),(6275522,52689432,90),(6275522,52689433,91),(6275522,52689436,92),(6275522,52689437,93),(6275522,52689440,94),(6275522,52689443,95),(6275522,52689445,96),(6275522,52689447,97),(6275522,52689450,98),(6275522,52689451,99),(6275522,52689452,100),(6275522,52689455,101),(6275522,52689456,102),(6275522,52689459,103),(6275522,52689461,104),(6275522,52689464,105),(6275522,52689484,106),(6275522,52689486,107),(6275522,52689488,108),(6275522,52689491,109),(6275522,52689493,110),(6275522,52689494,111),(6275522,52689496,112),(6275522,52689497,113),(6275522,52689499,114),(6275522,52689501,115),(6275522,52689503,116),(6275522,52689505,117),(6275522,52689508,118),(6275522,52689513,119),(6275522,52689516,120),(6275522,52689518,121),(6275522,52689522,122),(6275522,52689524,123),(6275522,52689527,124),(6275522,52689528,125),(6275522,52689532,126),(6275522,52689534,127),(6275522,52689537,128),(6275522,52689538,129),(6275522,52689540,130),(6275522,52689545,131),(6275522,52689549,132),(6275522,52689552,133),(6275522,52689553,134),(6275522,52689556,135),(6275522,52689558,136),(6275522,52689560,137),(6275522,52689562,138),(6275522,52689755,139),(6275522,52689751,140),(6275522,52689565,141),(6275522,52689748,142),(6275522,52689567,143),(6275522,52689747,144),(6275522,52689743,145),(6275522,52689742,146),(6275522,52689739,147),(6275522,52689737,148),(6275522,52689570,149),(6275522,52689572,150),(6275522,52689573,151),(6275522,52689576,152),(6275522,52689579,153),(6275522,52689580,154),(6275522,52689583,155),(6275522,52689584,156),(6275522,52689585,157),(6275522,52689586,158),(6275522,52689589,159),(6275522,52689591,160),(6275522,52689593,161),(6275522,52689594,162),(6275522,52689596,163),(6275522,52689600,164),(6275522,52689603,165),(6275522,52689604,166),(6275522,52689607,167),(6275522,52689608,168),(6275522,52689609,169),(6275522,52689610,170),(6275522,52689612,171),(6275522,52689613,172),(6275522,52689615,173),(6275522,52689617,174),(6275522,52689618,175),(6275522,52689619,176),(6275522,52689621,177),(6275522,52689624,178),(6275522,52689627,179),(6275522,52689629,180),(6275522,52689631,181),(6275522,52743899,182),(6275522,51412105,183),(6275522,52689635,184),(6275522,52689639,185),(6275522,52689643,186),(6275522,52689647,187),(6275522,52689650,188),(6275522,52689653,189),(6275522,52689656,190),(6275522,52689659,191),(6275522,52689661,192),(6275522,52689663,193),(6275522,52689665,194),(6275522,52689666,195),(6275522,52689670,196),(6275522,52689673,197),(6275522,52689676,198),(6275522,52689679,199),(6275522,52689681,200),(6275522,52689684,201),(6275522,52689687,202),(6275522,52689689,203),(6275522,52689692,204),(6275522,52689696,205),(6275522,52689699,206),(6275522,52689701,207),(6275522,52689705,208),(6275522,52689707,209),(6275522,52689709,210),(6275522,52689713,211),(6275522,52689714,212),(6275522,52689718,213),(6275522,52689720,214),(6275522,52689723,215),(6275522,52689724,216),(6275522,52689728,217),(6275522,52689731,218),(6275522,52689733,219),(6275522,52689226,220),(6275851,52733171,1),(6275851,52733173,2),(6275851,52733177,3),(6275851,52733181,4),(6275851,52733186,5),(6275851,52733193,6),(6275851,52733201,7),(6275851,52733204,8),(6275851,52733206,9),(6275851,52733209,10),(6275851,52733212,11),(6275851,52733215,12),(6275851,52733218,13),(6275851,52733223,14),(6276661,52744177,1),(6276661,52744180,2),(6276661,52744181,3),(6276661,52744184,4),(6276661,52744187,5),(6276661,52744189,6),(6276661,52744190,7),(6276661,52744193,8),(6276661,52744196,9),(6276661,52744198,10),(6276661,52744201,11),(6276661,52744202,12),(6276661,52744205,13),(6276661,52744206,14),(6276661,52744209,15),(6276661,52744212,16),(6276661,52744213,17),(6276661,52744214,18),(6276661,52744218,19),(6276661,52744219,20),(6276661,52744222,21),(6276661,52744223,22),(6276661,52744227,23),(6276661,52744228,24),(6276661,52744231,25),(6276661,52744232,26),(6276661,52744236,27),(6276661,52744237,28),(6276661,52744238,29),(6276661,52744240,30),(6276661,52744241,31),(6276661,52744245,32),(6276661,52744246,33),(6276661,52744249,34),(6276661,52744250,35),(6276661,52744253,36),(6276661,52744254,37),(6276661,52744257,38),(6276661,52744259,39),(6276661,52744260,40),(6276661,52744262,41),(6276661,52744264,42),(6276661,52744265,43),(6276661,52744268,44),(6276661,52744270,45),(6276661,52744272,46),(6276661,52744274,47),(6276661,52744277,48),(6276661,52744279,49),(6276661,52744281,50),(6276661,52744284,51),(6276661,52744286,52),(6276661,52744289,53),(6276661,52744292,54),(6276661,52744294,55),(6276661,52744296,56),(6276661,52744298,57),(6276661,52744301,58),(6276661,52744303,59),(6276661,52744306,60),(6276661,52744308,61),(6276661,52744309,62),(6276661,52744312,63),(6276661,52744313,64),(6276661,52744315,65),(6276661,52744318,66),(6276661,52744320,67),(6276661,52744323,68),(6276661,52744326,69),(6276661,52744329,70),(6276661,52744330,71),(6276661,52744333,72),(6276661,52744334,73),(6276661,52744337,74),(6276661,52744342,75),(6276661,52744339,76),(6276661,52744344,77),(6276661,52744346,78),(6276661,52744349,79),(6276661,52744350,80),(6276661,52744352,81),(6276661,52744356,82),(6276661,52744359,83),(6276661,52744360,84),(6276661,52744364,85),(6276661,52744365,86),(6276661,52744368,87),(6276661,52744370,88),(6276661,52744372,89),(6276661,52744375,90),(6276661,52744378,91),(6276661,52744379,92),(6276661,52744383,93),(6276661,52744385,94),(6276661,52744387,95),(6276661,52744390,96),(6276661,52744392,97),(6276661,52744394,98),(6276661,52744396,99),(6276661,52744399,100),(6276661,52744400,101),(6276661,52744402,102),(6276661,52744405,103),(6276661,52744409,104),(6276661,52744411,105),(6276661,52744413,106),(6276661,52744416,107),(6276661,52744418,108),(6276661,52744420,109),(6276661,52744423,110),(6276661,52744426,111),(6276661,52744429,112),(6276661,52744432,113),(6276661,52744434,114),(6276661,52744437,115),(6276661,52744439,116),(6276661,52744440,117),(6276661,52744443,118),(6276661,52744446,119),(6276661,52744447,120),(6276661,52744450,121),(6276661,52744452,122),(6276661,52744455,123),(6276661,52744457,124),(6276661,52744460,125),(6276661,52744462,126),(6276661,52744464,127),(6276661,52744468,128),(6276661,52744471,129),(6276661,52744473,130),(6276661,52744475,131),(6276661,52743859,132),(6276661,52743862,133),(6276661,52743866,134),(6276661,52743871,135),(6276661,52743874,136),(6276661,52743875,137),(6276661,52743878,138),(6276661,52743880,139),(6276661,52743882,140),(6276661,52743884,141),(6276661,52743887,142),(6276661,52744177,143),(6277172,52747815,1),(6277172,52747820,2),(6277172,52747826,3),(6277172,52747832,4),(6277172,52747838,5),(6277172,52747841,6),(6277172,52747846,7),(6277172,52747849,8),(6277172,52747852,9),(6277172,52747855,10),(6277172,52747857,11),(6277172,52747861,12),(6277172,52747863,13),(6277172,52747865,14),(6277172,52747867,15),(6277172,52747869,16),(6277172,52747872,17),(6277172,52747876,18),(6277172,52747878,19),(6277172,52747881,20),(6277172,52747884,21),(6277172,52747885,22),(6277172,52747888,23),(6277172,52747890,24),(6277172,52747893,25),(6277172,52747898,26),(6277172,52747901,27),(6277172,52748785,28),(6277172,52748790,29),(6277172,52748831,30),(6277172,52748833,31),(6277172,52748835,32),(6277172,52748837,33),(6277172,52749087,34),(6277172,52749143,35),(6277172,52749145,36),(6277172,52749150,37),(6277172,52749155,38),(6277172,52749158,39),(6277172,52749159,40),(6277172,52749162,41),(6277172,52749165,42),(6277172,52749169,43),(6277172,52749171,44),(6277172,52749174,45),(6277172,52749175,46),(6277172,52749183,47),(6277172,52749184,48),(6277172,52749185,49),(6277172,52749189,50),(6277172,52749191,51),(6277172,52749208,52),(6277172,52749211,53),(6277172,52749214,54),(6277172,52749218,55),(6277172,52749220,56),(6277172,52749224,57),(6277172,52749225,58),(6277172,52749228,59),(6277172,52749231,60),(6277172,52749233,61),(6277172,52749238,62),(6277172,52749240,63),(6277172,52749243,64),(6277172,52749244,65),(6277172,52749247,66),(6277172,52749251,67),(6277172,52749255,68),(6277172,52749256,69),(6277172,52749259,70),(6277172,52749261,71),(6277172,52749263,72),(6277172,52747815,73),(6277173,52749266,1),(6277173,52749268,2),(6277173,52749271,3),(6277173,52749275,4),(6277173,52749276,5),(6277173,52749280,6),(6277173,52749282,7),(6277173,52749284,8),(6277173,52749285,9),(6277173,52749288,10),(6277173,52749289,11),(6277173,52749309,12),(6277173,52749310,13),(6277173,52749312,14),(6277173,52749314,15),(6277173,52749316,16),(6277173,52749321,17),(6277173,52749324,18),(6277173,52749326,19),(6277173,52749328,20),(6277173,52749331,21),(6277173,52749334,22),(6277173,52749340,23),(6277173,52749341,24),(6277173,52749343,25),(6277173,52749347,26),(6277173,52749349,27),(6277173,52749352,28),(6277173,52749354,29),(6277173,52749357,30),(6277173,52749359,31),(6277173,52749363,32),(6277173,52749366,33),(6277173,52749368,34),(6277173,52749371,35),(6277173,52749376,36),(6277173,52749379,37),(6277173,52749381,38),(6277173,52749385,39),(6277173,52749386,40),(6277173,52749387,41),(6277173,52749389,42),(6277173,52749391,43),(6277173,52749393,44),(6277173,52749396,45),(6277173,52749398,46),(6277173,52749400,47),(6277173,52749402,48),(6277173,52749404,49),(6277173,52749407,50),(6277173,52749410,51),(6277173,52749412,52),(6277173,52749414,53),(6277173,52749416,54),(6277173,52749419,55),(6277173,52749421,56),(6277173,52749424,57),(6277173,52749428,58),(6277173,52749430,59),(6277173,52749433,60),(6277173,52749436,61),(6277173,52749439,62),(6277173,52749441,63),(6277173,52749443,64),(6277173,52749448,65),(6277173,52749451,66),(6277173,52749455,67),(6277173,52749458,68),(6277173,52749460,69),(6277173,52749462,70),(6277173,52749465,71),(6277173,52749469,72),(6277173,52749472,73),(6277173,52749474,74),(6277173,52749475,75),(6277173,52749479,76),(6277173,52749482,77),(6277173,52749485,78),(6277173,52749487,79),(6277173,52749490,80),(6277173,52749491,81),(6277173,52749492,82),(6277173,52749496,83),(6277173,52749497,84),(6277173,52749499,85),(6277173,52749502,86),(6277173,52749503,87),(6277173,52749505,88),(6277173,52749508,89),(6277173,52749509,90),(6277173,52749511,91),(6277173,52749514,92),(6277173,52749517,93),(6277173,52749266,94),(6279235,52769493,1),(6279235,52769332,2),(6279235,52769338,3),(6279235,52769340,4),(6279235,52769343,5),(6279235,52769346,6),(6279235,52769349,7),(6279235,52769352,8),(6279235,52769355,9),(6279235,52769357,10),(6279235,52769358,11),(6279235,52769361,12),(6279235,52769364,13),(6279235,52769366,14),(6279235,52769367,15),(6279235,52769369,16),(6279235,52769371,17),(6279235,52769373,18),(6279235,52769374,19),(6279235,52769377,20),(6279235,52769380,21),(6279235,52769381,22),(6279235,52769384,23),(6279235,52769387,24),(6279235,52769389,25),(6279235,52769392,26),(6279235,52769395,27),(6279235,52769397,28),(6279235,52769401,29),(6279235,52769406,30),(6279235,52769411,31),(6279235,52769413,32),(6279235,52769415,33),(6279235,52769418,34),(6279235,52769419,35),(6279235,52769420,36),(6279235,52769423,37),(6279235,52769425,38),(6279235,52769427,39),(6279235,52769431,40),(6279235,52769436,41),(6279235,52769439,42),(6279235,52769441,43),(6279235,52769444,44),(6279235,52769447,45),(6279235,52769450,46),(6279235,52769452,47),(6279235,52769456,48),(6279235,52769457,49),(6279235,52769460,50),(6279235,52769465,51),(6279235,52769471,52),(6279235,52769477,53),(6279235,52769479,54),(6279235,52769482,55),(6279235,52769485,56),(6279235,52769488,57),(6279235,52769491,58),(6279235,52769493,59),(6281014,52804805,1),(6281014,52804803,2),(6281014,52804172,3),(6281014,52804167,4),(6281014,52804163,5),(6281014,52804160,6),(6281014,52804150,7),(6281014,52804145,8),(6281014,52804143,9),(6281014,52804142,10),(6281014,52804141,11),(6281014,52804140,12),(6281014,52804139,13),(6281014,52804138,14),(6281014,52804137,15),(6281014,52804136,16),(6281014,52804135,17),(6281014,52804134,18),(6281014,52804133,19),(6281014,52804132,20),(6281014,52804131,21),(6281014,52804130,22),(6281014,52804052,23),(6281014,52804050,24),(6281014,52804046,25),(6281014,52804043,26),(6281014,52804041,27),(6281014,52804038,28),(6281014,52804036,29),(6281014,52804033,30),(6281014,52804030,31),(6281014,52804028,32),(6281014,52804026,33),(6281014,52804024,34),(6281014,52804021,35),(6281014,52804018,36),(6281014,52804014,37),(6281014,52804010,38),(6281014,52804005,39),(6281014,52804002,40),(6281014,52803998,41),(6281014,52803995,42),(6281014,52803992,43),(6281014,52803988,44),(6281014,52803983,45),(6281014,52803396,46),(6281014,52803393,47),(6281014,52803391,48),(6281014,52803388,49),(6281014,52803385,50),(6281014,52803382,51),(6281014,52803378,52),(6281014,52803374,53),(6281014,52803372,54),(6281014,52803370,55),(6281014,52803368,56),(6281014,52803365,57),(6281014,52803363,58),(6281014,52803358,59),(6281014,52803353,60),(6281014,52803351,61),(6281014,52801221,62),(6281014,52801220,63),(6281014,52801218,64),(6281014,52801217,65),(6281014,52801215,66),(6281014,52801212,67),(6281014,52801209,68),(6281014,52801207,69),(6281014,52801203,70),(6281014,52801198,71),(6281014,52801195,72),(6281014,52801192,73),(6281014,52801190,74),(6281014,52801184,75),(6281014,52801182,76),(6281014,52801181,77),(6281014,52801178,78),(6281014,52801176,79),(6281014,52801175,80),(6281014,52801173,81),(6281014,52801172,82),(6281014,52801170,83),(6281014,52801168,84),(6281014,52801167,85),(6281014,52801166,86),(6281014,52801164,87),(6281014,52801158,88),(6281014,52801157,89),(6281014,52801153,90),(6281014,52801010,91),(6281014,52801007,92),(6281014,52801004,93),(6281014,52801001,94),(6281014,52800998,95),(6281014,52800995,96),(6281014,52800993,97),(6281014,52800990,98),(6281014,52800987,99),(6281014,52800985,100),(6281014,52800981,101),(6281014,52800978,102),(6281014,52800974,103),(6281014,52800970,104),(6281014,52800967,105),(6281014,52800964,106),(6281014,52800960,107),(6281014,52801750,108),(6281014,52800952,109),(6281014,52800948,110),(6281014,52800957,111),(6281014,52800944,112),(6281014,52800938,113),(6281014,52800909,114),(6281014,52800845,115),(6281014,52800828,116),(6281014,52800821,117),(6281014,52800813,118),(6281014,52800794,119),(6281014,52800691,120),(6281014,52800686,121),(6281014,52800683,122),(6281014,52800681,123),(6281014,52800677,124),(6281014,52800673,125),(6281014,52800670,126),(6281014,52800668,127),(6281014,52800667,128),(6281014,52800665,129),(6281014,52800664,130),(6281014,52800661,131),(6281014,52800656,132),(6281014,52800652,133),(6281014,52800651,134),(6281014,52800647,135),(6281014,52800645,136),(6281014,52800642,137),(6281014,52800638,138),(6281014,52800634,139),(6281014,52800630,140),(6281014,52800628,141),(6281014,52800626,142),(6281014,52800625,143),(6281014,52800623,144),(6281014,52800622,145),(6281014,52800619,146),(6281014,52800618,147),(6281014,52800614,148),(6281014,52800610,149),(6281014,52800608,150),(6281014,52800606,151),(6281014,52800602,152),(6281014,52800599,153),(6281014,52800596,154),(6281014,52800592,155),(6281014,52800590,156),(6281015,52801741,1),(6281015,52801737,2),(6281015,52801733,3),(6281015,52801729,4),(6281015,52801725,5),(6281015,52801722,6),(6281015,52801719,7),(6281015,52801715,8),(6281015,52801710,9),(6281015,52801707,10),(6281015,52801704,11),(6281015,52801701,12),(6281015,52801699,13),(6281015,52801695,14),(6281015,52801691,15),(6281015,52801688,16),(6281015,52801684,17),(6281015,52801683,18),(6281015,52801679,19),(6281015,52801674,20),(6281015,52801672,21),(6281015,52801668,22),(6281015,52801664,23),(6281015,52801663,24),(6281015,52801660,25),(6281015,52801657,26),(6281015,52801654,27),(6281015,52801652,28),(6281015,52801648,29),(6281015,52801643,30),(6281015,52801640,31),(6281015,52801618,32),(6281015,52801587,33),(6281015,52801585,34),(6281015,52801584,35),(6281015,52801581,36),(6281015,52801578,37),(6281015,52801576,38),(6281015,52801573,39),(6281015,52801571,40),(6281015,52801569,41),(6281015,52801566,42),(6281015,52801561,43),(6281015,52801558,44),(6281015,52801555,45),(6281015,52801551,46),(6281015,52801548,47),(6281015,52801545,48),(6281015,52801542,49),(6281015,52801538,50),(6281015,52801534,51),(6281015,52801531,52),(6281015,52801527,53),(6281015,52801526,54),(6281015,52801524,55),(6281015,52801522,56),(6281015,52801520,57),(6281015,52801518,58),(6281015,52801516,59),(6281015,52801514,60),(6281015,52801506,61),(6281015,52801494,62),(6281015,52801487,63),(6281015,52801480,64),(6281015,52801477,65),(6281015,52801475,66),(6281015,52801469,67),(6281015,52801468,68),(6281015,52801465,69),(6281015,52801462,70),(6281015,52801461,71),(6281015,52801456,72),(6281015,52801453,73),(6281015,52801451,74),(6281015,52801447,75),(6281015,52801446,76),(6281015,52801444,77),(6281015,52801441,78),(6281015,52801439,79),(6281015,52801437,80),(6281015,52801435,81),(6281015,52801433,82),(6281015,52801431,83),(6281015,52801429,84),(6281015,52801427,85),(6281015,52801425,86),(6281015,52801422,87),(6281015,52801418,88),(6281015,52801417,89),(6281015,52801413,90),(6281015,52801407,91),(6281015,52801404,92),(6281015,52801402,93),(6281015,52801397,94),(6281015,52801396,95),(6281015,52801392,96),(6281015,52801389,97),(6281015,52801384,98),(6281015,52801380,99),(6281015,52801376,100),(6281015,52801374,101),(6281015,52801372,102),(6281015,52801370,103),(6281015,52801368,104),(6281015,52801366,105),(6281015,52801364,106),(6281015,52801363,107),(6281015,52801362,108),(6281015,52801361,109),(6281015,52801360,110),(6281015,52801359,111),(6281015,52801358,112),(6281015,52801357,113),(6281015,52801356,114),(6281015,52801355,115),(6281015,52801354,116),(6281015,52801353,117),(6281015,52801352,118),(6281015,52801350,119),(6281015,52801348,120),(6281015,52801345,121),(6281015,52801344,122),(6281015,52801341,123),(6281015,52801339,124),(6281015,52801336,125),(6281015,52801333,126),(6281015,52801331,127),(6281015,52801330,128),(6281015,52801328,129),(6281015,52801326,130),(6281015,52801324,131),(6281015,52801323,132),(6281015,52801321,133),(6281015,52801319,134),(6281015,52801317,135),(6281015,52801316,136),(6281015,52801314,137),(6281015,52801313,138),(6281015,52801311,139),(6281015,52801309,140),(6281015,52801307,141),(6281015,52801305,142),(6281015,52801303,143),(6281015,52801301,144),(6281015,52801299,145),(6281015,52801298,146),(6281015,52801295,147),(6281015,52801293,148),(6281015,52801291,149),(6281015,52801289,150),(6281015,52801287,151),(6281015,52801284,152),(6281015,52801283,153),(6281015,52801279,154),(6281015,52801274,155),(6281015,52801273,156),(6281015,52801269,157),(6281015,52801265,158),(6281015,52801262,159),(6281015,52801258,160),(6281015,52801254,161),(6281015,52801251,162),(6281015,52801248,163),(6281015,52801247,164),(6281015,52801234,165),(6281015,52801233,166),(6281015,52801231,167),(6281015,52801228,168),(6281015,52801226,169),(6281015,52801223,170),(6281015,52803399,171),(6281015,52803402,172),(6281015,52803405,173),(6281015,52803937,174),(6281015,52803980,175),(6281015,52803938,176),(6281015,52803940,177),(6281015,52803941,178),(6281015,52803943,179),(6281015,52803944,180),(6281015,52803954,181),(6281015,52803955,182),(6281015,52803956,183),(6281015,52803958,184),(6281015,52803959,185),(6281015,52803961,186),(6281015,52803962,187),(6281015,52803965,188),(6281015,52803969,189),(6281015,52803973,190),(6281015,52803976,191),(6281015,52804055,192),(6281015,52804060,193),(6281015,52804062,194),(6281015,52804065,195),(6281015,52804069,196),(6281015,52804073,197),(6281015,52804077,198),(6281015,52804081,199),(6281015,52804084,200),(6281015,52804087,201),(6281015,52804090,202),(6281015,52804091,203),(6281015,52804093,204),(6281015,52804096,205),(6281015,52804100,206),(6281015,52804101,207),(6281015,52804106,208),(6281015,52804109,209),(6281015,52804112,210),(6281015,52804114,211),(6281015,52804117,212),(6281015,52804118,213),(6281015,52804119,214),(6281015,52804120,215),(6281015,52804121,216),(6281015,52804122,217),(6281015,52804123,218),(6281015,52804124,219),(6281015,52804125,220),(6281015,52804126,221),(6281015,52804127,222),(6281015,52804128,223),(6281015,52804129,224),(6281015,52804173,225),(6281015,52804176,226),(6281015,52804216,227),(6281015,52804228,228),(6281015,52804233,229),(6281015,52804235,230),(6281015,52804237,231),(6281015,52804272,232),(6281015,52804275,233),(6281015,52804279,234),(6281015,52804292,235),(6281015,52804295,236),(6281015,52804297,237),(6281015,52804298,238),(6281015,52804299,239),(6281015,52804736,240),(6281015,52804739,241),(6281015,52804766,242),(6281015,52804772,243),(6281015,52804776,244),(6281015,52804777,245),(6281015,52804778,246),(6281015,52804779,247),(6281015,52804780,248),(6281015,52804788,249),(6281015,52804791,250),(6281015,52804795,251),(6281015,52804796,252),(6281015,52804798,253),(6281015,52804801,254),(6281015,52804807,255),(6281015,52804809,256),(6281015,52804811,257),(6281015,52804813,258),(6281015,52804815,259),(6281016,52801747,1),(6281016,52801744,2),(6281016,52801752,3),(6281016,52801754,4),(6281016,52801756,5),(6281016,52801757,6),(6281016,52801758,7),(6281016,52801759,8),(6281016,52801760,9),(6281016,52801761,10),(6281016,52801762,11),(6281016,52801764,12),(6281016,52801765,13),(6281016,52801768,14),(6281016,52801769,15),(6281016,52801771,16),(6281016,52801772,17),(6281016,52801774,18),(6281016,52801776,19),(6281016,52801777,20),(6281016,52801780,21),(6281016,52801781,22),(6281016,52801783,23),(6281016,52801785,24),(6281016,52801787,25),(6281016,52801788,26),(6281016,52801791,27),(6281016,52801792,28),(6281016,52801794,29),(6281016,52801796,30),(6281016,52801807,31),(6281017,52803309,1),(6281017,52803304,2),(6281017,52803300,3),(6281017,52803297,4),(6281017,52803289,5),(6281017,52803285,6),(6281017,52803283,7),(6281017,52803277,8),(6281017,52803280,9),(6281017,52803311,10),(6281017,52803313,11),(6281017,52803316,12),(6281017,52803319,13),(6281017,52803320,14),(6281017,52803323,15),(6281017,52803325,16),(6281017,52803327,17),(6281018,52803328,1),(6281018,52803331,2),(6281018,52803333,3),(6281018,52803336,4),(6281018,52803337,5),(6281018,52803338,6),(6281018,52803340,7),(6281018,52803343,8),(6281018,52803346,9),(6281018,52803349,10),(6281018,52802158,11),(6281019,52800586,1),(6281019,52800584,2),(6281019,52800580,3),(6281019,52800536,4),(6281019,52800529,5),(6281019,52800416,6),(6281019,52800405,7),(6281019,52800400,8),(6281019,52800388,9),(6281019,52800211,10),(6281019,52800033,11),(6281019,52799985,12),(6281019,52799709,13),(6281019,52798676,14),(6281019,52797555,15),(6281019,52797303,16),(6281019,52797286,17),(6281019,52797278,18),(6281019,52797275,19),(6281019,52797270,20),(6281019,52797269,21),(6281019,52797268,22),(6281019,52797267,23),(6281019,52797105,24),(6281019,52797069,25),(6281019,52797051,26),(6281019,52797049,27),(6281019,52796991,28),(6281019,52792210,29),(6281019,52792205,30),(6281019,52792202,31),(6281019,52792199,32),(6281019,52792196,33),(6281019,52792194,34),(6281019,52792192,35),(6281019,52792189,36),(6281019,52792187,37),(6281019,52792185,38),(6281019,52792182,39),(6281019,52792180,40),(6281019,52792177,41),(6281019,52792159,42),(6281019,52792158,43),(6281019,52792095,44),(6281019,52792098,45),(6281019,52792102,46),(6281019,52792111,47),(6281019,52792113,48),(6281019,52792114,49),(6281019,52792117,50),(6281019,52792122,51),(6281020,52800590,1),(6281020,52800586,2),(6281021,52801750,1),(6281021,52801749,2),(6281022,52801749,1),(6281022,52801747,2),(6281358,52812261,1),(6281358,52812263,2),(6281358,52812266,3),(6281358,52812268,4),(6281358,52812270,5),(6281358,52812274,6),(6281358,52812277,7),(6281358,52812281,8),(6281358,52812284,9),(6281358,52812288,10),(6281358,52812291,11),(6281358,52812295,12),(6281358,52812296,13),(6281358,52812299,14),(6281358,52812303,15),(6281358,52812305,16),(6281358,52812309,17),(6281358,52812311,18),(6281358,52812315,19),(6281358,52812318,20),(6281358,52812321,21),(6281358,52812323,22),(6281358,52812326,23),(6281358,52812329,24),(6281358,52812331,25),(6281358,52812333,26),(6281358,52812335,27),(6281358,52812338,28),(6281358,52812341,29),(6281358,52812343,30),(6281358,52812347,31),(6281358,52812350,32),(6281358,52812353,33),(6281358,52812356,34),(6281358,52812360,35),(6281358,52812363,36),(6281358,52812365,37),(6281358,52812366,38),(6281358,52812367,39),(6281358,52812369,40),(6281358,52812372,41),(6281358,52812376,42),(6281358,52812379,43),(6281358,52812380,44),(6281358,52812383,45),(6281358,52812385,46),(6281358,52812387,47),(6281358,52812389,48),(6281358,52812391,49),(6281358,52812395,50),(6281358,52812397,51),(6281358,52812399,52),(6281358,52812403,53),(6281358,52812405,54),(6281358,52812406,55),(6281358,52812407,56),(6281358,52812410,57),(6281358,52812409,58),(6281358,52812411,59),(6281358,52812413,60),(6281358,52812414,61),(6281358,52812415,62),(6281358,52812417,63),(6281358,52812418,64),(6281358,52812421,65),(6281358,52812425,66),(6281358,52812428,67),(6281358,52812440,68),(6281358,52812444,69),(6281358,52812447,70),(6281360,52812447,1),(6281360,52812450,2),(6281360,52812453,3),(6281360,52812457,4),(6281360,52812460,5),(6281360,52812464,6),(6281360,52812468,7),(6281360,52812472,8),(6281360,52812475,9),(6281360,52812478,10),(6281360,52812481,11),(6281360,52812485,12),(6281360,52812487,13),(6281360,52812491,14),(6281360,52812494,15),(6281360,52812497,16),(6281360,52812501,17),(6281360,52812505,18),(6281360,52812507,19),(6281360,52812511,20),(6281360,52812514,21),(6281360,52812517,22),(6281360,52812520,23),(6281360,52812522,24),(6281361,52812447,1),(6281361,52812526,2),(6281361,52812530,3),(6281361,52812531,4),(6281361,52812534,5),(6281361,52812536,6),(6281361,52812537,7),(6281361,52812540,8),(6281361,52812541,9),(6281361,52812543,10),(6281361,52812545,11),(6281361,52812547,12),(6281361,52812549,13),(6281361,52812551,14),(6281361,52812553,15),(6281361,52812555,16),(6281361,52812558,17),(6281361,52812562,18),(6281361,52812564,19),(6281361,52812566,20),(6281361,52812569,21),(6281361,52812572,22),(6281361,52812574,23),(6281361,52812577,24),(6281361,52812580,25),(6281361,52812582,26),(6281361,52812585,27),(6281361,52812587,28),(6281361,52812590,29),(6281361,52812592,30),(6281361,52812595,31),(6281361,52812597,32),(6281361,52812598,33),(6281741,52818308,1),(6281741,52818311,2),(6281741,52818312,3),(6281741,52818315,4),(6281741,52818317,5),(6281741,52818320,6),(6281741,52818322,7),(6281741,52818324,8),(6281741,52818326,9),(6281741,52818330,10),(6281741,52818332,11),(6281741,52818334,12),(6281741,52818337,13),(6281741,52818340,14),(6281741,52818343,15),(6281741,52818346,16),(6281741,52818348,17),(6281741,52818350,18),(6281741,52818352,19),(6281741,52812315,20),(6281751,53273756,1),(6281751,53273781,2),(6281751,53273780,3),(6281751,53273779,4),(6281751,53273778,5),(6281751,53273777,6),(6281751,53273776,7),(6281751,53273775,8),(6281751,53273774,9),(6281751,53273773,10),(6281751,53273772,11),(6281751,53273771,12),(6281751,53273770,13),(6281751,53273769,14),(6281751,53273768,15),(6281751,53273767,16),(6281751,53273766,17),(6281751,53273765,18),(6281751,53273764,19),(6281751,53273763,20),(6281751,53273762,21),(6281751,53273761,22),(6281751,53273760,23),(6281751,53273759,24),(6281751,53273758,25),(6281751,53273757,26),(6281751,52818355,27),(6281751,52818358,28),(6281751,52818362,29),(6281751,52818365,30),(6281751,52818368,31),(6281751,52818370,32),(6281751,52818373,33),(6281751,52818377,34),(6281751,52818379,35),(6281751,52818382,36),(6281751,52818384,37),(6281751,52818385,38),(6281751,52818387,39),(6281751,52818389,40),(6281751,52818390,41),(6281751,52818391,42),(6281751,52818392,43),(6281751,52818393,44),(6281751,52818394,45),(6281751,52818396,46),(6281751,52818397,47),(6281751,52818398,48),(6281751,52818399,49),(6281751,52818402,50),(6281751,52818404,51),(6281751,52818405,52),(6281751,52818406,53),(6281751,52818407,54),(6281751,52818409,55),(6281751,52818413,56),(6281751,52818415,57),(6281751,52818417,58),(6281751,52818420,59),(6281751,52818424,60),(6281751,52818427,61),(6281751,52818428,62),(6281751,52818432,63),(6281751,52818434,64),(6281751,52818437,65),(6281751,52818440,66),(6281751,52818441,67),(6281751,52818445,68),(6281751,52818446,69),(6281751,52818448,70),(6281751,52818450,71),(6281751,52818451,72),(6281751,52818452,73),(6281751,52818453,74),(6281751,52818454,75),(6281751,52818455,76),(6281751,52818456,77),(6281751,52818457,78),(6281751,52818458,79),(6281751,52818461,80),(6281751,52818463,81),(6281751,52818465,82),(6281751,52818470,83),(6281751,52818472,84),(6281751,52818475,85),(6281751,52818478,86),(6281751,52818479,87),(6281751,52818483,88),(6281751,52818485,89),(6281751,52818487,90),(6281751,52818489,91),(6281751,52818490,92),(6281751,52818491,93),(6281751,52818493,94),(6281751,52818495,95),(6281751,52818498,96),(6281751,52818501,97),(6281751,52818503,98),(6281751,52818505,99),(6281751,52818508,100),(6281751,52818511,101),(6281751,52818514,102),(6281751,52818516,103),(6281751,52818518,104),(6281751,52818520,105),(6281751,52818522,106),(6281751,52818524,107),(6281751,52818527,108),(6281751,52818529,109),(6281751,52818533,110),(6281751,52818536,111),(6281751,52818538,112),(6281751,52818539,113),(6281751,52818542,114),(6281751,52818550,115),(6281751,52818553,116),(6281751,52818555,117),(6281751,52818557,118),(6281751,52818561,119),(6281751,52818563,120),(6281751,52818564,121),(6281751,52818566,122),(6281751,52818567,123),(6281751,52818569,124),(6281751,52818572,125),(6281751,52818574,126),(6281751,52818577,127),(6281751,52818581,128),(6281751,52818582,129),(6281751,52818585,130),(6281751,52818587,131),(6281751,52818590,132),(6281751,52818592,133),(6281751,52818594,134),(6281751,52818598,135),(6281751,52818600,136),(6281751,52818603,137),(6281751,52818605,138),(6281751,52818609,139),(6281751,52818612,140),(6281751,52818615,141),(6281751,52818618,142),(6281751,52818620,143),(6281751,52818622,144),(6281751,52818623,145),(6281751,52818627,146),(6281751,52818629,147),(6281751,52818631,148),(6281751,52818633,149),(6281751,52818635,150),(6281751,52818636,151),(6281751,52818639,152),(6281751,52818641,153),(6281751,52818642,154),(6281751,52818644,155),(6281751,52818647,156),(6281751,52818648,157),(6281751,52818651,158),(6281751,52818652,159),(6281751,52818655,160),(6281751,52818657,161),(6281751,52818659,162),(6281751,52818661,163),(6281751,52818663,164),(6281751,52818669,165),(6281751,52818671,166),(6281751,52818673,167),(6281751,52818675,168),(6281751,52818677,169),(6281751,52818679,170),(6281751,52818681,171),(6281751,52818685,172),(6281751,52818687,173),(6281751,52818690,174),(6281751,52818692,175),(6281751,52818694,176),(6281751,52818720,177),(6281751,52818722,178),(6281751,52818724,179),(6281751,52818727,180),(6281751,52818729,181),(6281751,52818731,182),(6281751,52818733,183),(6281751,52818747,184),(6281751,52818757,185),(6281751,52818771,186),(6281751,52818775,187),(6281751,52818781,188),(6281751,52818791,189),(6281751,52818794,190),(6281751,52818796,191),(6281751,52818800,192),(6281751,52818803,193),(6281751,52818808,194),(6281751,52818809,195),(6281751,52818810,196),(6281751,52818812,197),(6281751,52818813,198),(6281751,52818824,199),(6281751,52818840,200),(6281751,52818846,201),(6281751,52818850,202),(6281751,52818853,203),(6281751,52818857,204),(6281751,52818862,205),(6281751,52818864,206),(6281751,52818867,207),(6281774,52818870,1),(6281774,52818872,2),(6281774,52818874,3),(6281774,52818876,4),(6281774,52818878,5),(6281774,52818879,6),(6281774,52818881,7),(6281774,52818884,8),(6281774,52818810,9),(6281908,52824397,1),(6281908,52824401,2),(6281908,52824404,3),(6281908,52824407,4),(6281908,52824410,5),(6281908,52824414,6),(6281908,52824418,7),(6281908,52824420,8),(6281908,52824423,9),(6281908,52824433,10),(6281908,52824446,11),(6281908,52824449,12),(6281908,52824464,13),(6281908,52824474,14),(6281908,52824478,15),(6281908,52824483,16),(6281908,52824486,17),(6281908,52824489,18),(6281908,52824491,19);
INSERT INTO `current_way_nodes` VALUES (6281908,52824494,20),(6281908,52824496,21),(6281908,52824499,22),(6281908,52824502,23),(6281908,52824509,24),(6281908,51121973,25),(6281909,52824529,1),(6281909,52824530,2),(6281909,52824533,3),(6281909,52824535,4),(6281909,52824538,5),(6281909,52824541,6),(6281909,52824544,7),(6281909,51121970,8),(6281910,52824546,1),(6281910,52824548,2),(6281910,52824552,3),(6281910,52824553,4),(6281910,52824558,5),(6281910,52824561,6),(6281910,52824564,7),(6281910,52824567,8),(6281910,52824569,9),(6281910,52824574,10),(6281910,52824576,11),(6281910,52824579,12),(6281910,52824581,13),(6281910,52824584,14),(6281910,52824586,15),(6281916,52824949,1),(6281916,52824952,2),(6281916,52824953,3),(6281916,52824954,4),(6281916,52824955,5),(6281916,51122830,6),(6282443,52831541,1),(6282443,52831545,2),(6282443,52831548,3),(6282443,52831550,4),(6282443,52831552,5),(6282443,52831554,6),(6282443,52831644,7),(6282443,52831559,8),(6282443,52831563,9),(6282443,52831566,10),(6282443,51122803,11),(6282444,52831569,1),(6282444,52831566,2),(6282445,52832045,1),(6282445,52831574,2),(6282445,52831577,3),(6282445,52831582,4),(6282445,52831585,5),(6282445,52831588,6),(6282445,52831590,7),(6282445,52831593,8),(6282445,52831595,9),(6282445,52831641,10),(6282445,52831598,11),(6282445,52831601,12),(6282445,52831638,13),(6282445,52831603,14),(6282446,52831605,1),(6282446,52831608,2),(6282446,52831611,3),(6282446,52831613,4),(6282446,52831614,5),(6282446,52831615,6),(6282446,52831616,7),(6282446,52831617,8),(6282446,52831601,9),(6282447,52831618,1),(6282447,52831619,2),(6282447,52831620,3),(6282447,52831621,4),(6282447,52831615,5),(6282448,52831620,1),(6282448,52831625,2),(6282448,52831627,3),(6282448,52831630,4),(6282448,52831633,5),(6282448,52831636,6),(6282448,52831638,7),(6282449,52831644,1),(6282449,52832041,2),(6282449,52832042,3),(6282449,52832043,4),(6282449,52832044,5),(6282449,52832045,6),(6282449,52832046,7),(6282449,52832047,8),(6282449,52832471,9),(6282449,52831605,10),(6282449,52831618,11),(6282449,52834371,12),(6282449,52834531,13),(6282449,52834678,14),(6282449,52834735,15),(6282449,52834737,16),(6282449,52834749,17),(6282449,52836042,18),(6282449,52836023,19),(6282449,52834758,20),(6282449,52834763,21),(6282449,52836069,22),(6282449,52834768,23),(6282449,52834775,24),(6282449,52834778,25),(6282449,52834779,26),(6282449,52834783,27),(6282449,52834784,28),(6282449,52836073,29),(6282449,52834785,30),(6282449,52834786,31),(6282449,52834787,32),(6282449,52834788,33),(6282449,52834790,34),(6282449,52834792,35),(6282449,52834794,36),(6282449,52834795,37),(6282449,52834797,38),(6282449,52834799,39),(6282449,52834802,40),(6282449,52834805,41),(6282449,52834808,42),(6282449,52834811,43),(6282449,52834813,44),(6282449,52834816,45),(6282449,52834819,46),(6282449,52834822,47),(6282449,52834825,48),(6282449,52835977,49),(6282449,52835980,50),(6282449,52835984,51),(6282449,52835987,52),(6282449,52836001,53),(6282449,52836004,54),(6282449,52836007,55),(6282449,52836010,56),(6282449,52836012,57),(6282449,52836016,58),(6282449,52836020,59),(6282450,52836042,1),(6282450,52836044,2),(6282450,52836048,3),(6282450,52836052,4),(6282450,52836056,5),(6282450,52836058,6),(6282450,52836061,7),(6282450,52836065,8),(6282451,52836023,1),(6282451,52836027,2),(6282451,52836030,3),(6282451,52836034,4),(6282451,52836036,5),(6282451,52836038,6),(6282452,52836069,1),(6282452,52836038,2),(6282452,52836073,3),(6541502,53273756,1),(6541502,53273782,2),(6541502,53273783,3),(6541502,53273784,4),(6541502,53273785,5),(6541502,53273786,6),(6541502,53273787,7),(6541502,53273788,8),(6541502,53273789,9),(6541502,53273790,10),(6541502,53273791,11),(6541502,53273792,12),(6541502,53273793,13),(6541502,53273794,14),(6541502,53273795,15),(6541502,53273796,16),(6541502,53273797,17),(6541502,53273798,18),(6541502,53273799,19),(6541502,53273800,20),(6541502,53273801,21),(6541502,53273802,22),(6541502,53273803,23),(6541502,53273804,24),(6541502,53273805,25),(6541502,53273806,26),(6541502,53273807,27),(6541502,53273808,28),(6541502,53273810,29),(6541502,53273811,30),(6541502,53273812,31),(6541502,53273813,32),(6541502,53273814,33),(6541502,53273815,34),(6541502,53273816,35),(6541502,53273817,36),(6541502,53273818,37),(6541502,53273819,38),(6541502,53273820,39),(6541502,53273821,40),(6541502,53273822,41),(6541502,53273823,42),(6541502,53273824,43),(6541502,53273825,44),(6541502,53273826,45),(6541502,53273827,46),(6541502,53273828,47),(6541502,53273829,48),(6541502,53273830,49),(6541502,53273831,50),(6541502,53273832,51),(6541502,53273833,52),(6541505,51123237,1),(6541505,625306,2),(6541505,51123238,3),(6541505,278748316,4),(6541505,625307,5),(6541507,53273834,1),(6541507,51123237,2),(6541510,53273836,1),(6541510,53273838,2),(6541510,53273839,3),(6541510,52801741,4),(6541510,53273841,5),(6541510,53273843,6),(6541510,53273844,7),(6541510,53273833,8),(6541510,53273846,9),(6541510,53273848,10),(6541510,53273849,11),(6541510,53273861,12),(6541510,53273851,13),(6541510,53273852,14),(6541510,53273853,15),(6541510,53273854,16),(6541510,53273855,17),(6541510,53273856,18),(6541510,53273857,19),(6541510,53273858,20),(6541510,53273859,21),(6541510,53273970,22),(6541510,53273860,23),(6541510,53273836,24),(6541514,53273928,1),(6541514,53273927,2),(6541514,53273926,3),(6541514,53273925,4),(6541514,53273924,5),(6541514,53273923,6),(6541514,53273922,7),(6541514,53273921,8),(6541514,53273920,9),(6541514,53273961,10),(6541514,53273919,11),(6541514,53273918,12),(6541514,53273917,13),(6541514,53273916,14),(6541514,53273915,15),(6541514,53273914,16),(6541514,53273913,17),(6541514,53273912,18),(6541514,53273911,19),(6541514,53273910,20),(6541514,53273909,21),(6541514,53273908,22),(6541514,53273907,23),(6541514,53273906,24),(6541514,53273905,25),(6541514,53273904,26),(6541514,53273903,27),(6541514,53273902,28),(6541514,53273901,29),(6541514,53273900,30),(6541514,53273899,31),(6541514,53273898,32),(6541514,53273897,33),(6541514,53273896,34),(6541514,53273895,35),(6541514,53273894,36),(6541514,53273893,37),(6541514,53273892,38),(6541514,53273891,39),(6541514,53273890,40),(6541514,53273889,41),(6541514,53273888,42),(6541514,53273887,43),(6541514,53273886,44),(6541514,53273885,45),(6541514,53273884,46),(6541514,53273883,47),(6541514,53273882,48),(6541514,53273881,49),(6541514,53273880,50),(6541514,53273879,51),(6541514,53273862,52),(6541514,53273863,53),(6541514,53273864,54),(6541514,53273865,55),(6541514,53273866,56),(6541514,53273867,57),(6541514,53273868,58),(6541514,53273869,59),(6541514,53273870,60),(6541514,53273871,61),(6541514,53273872,62),(6541514,53273873,63),(6541518,53273874,1),(6541518,53273875,2),(6541518,53273876,3),(6541518,53273877,4),(6541518,53273878,5),(6541518,52796991,6),(6541520,53273873,1),(6541520,53273874,2),(6541522,53273929,1),(6541522,53273930,2),(6541522,53273931,3),(6541522,53273932,4),(6541522,53273933,5),(6541522,53273934,6),(6541522,53273935,7),(6541522,53273936,8),(6541522,53273937,9),(6541522,53273938,10),(6541522,53273939,11),(6541522,53273940,12),(6541522,53273941,13),(6541522,53273942,14),(6541522,53273943,15),(6541522,53273944,16),(6541522,53273945,17),(6541522,53273946,18),(6541522,53273947,19),(6541522,53273948,20),(6541522,53273949,21),(6541522,53273950,22),(6541522,53273951,23),(6541522,53273952,24),(6541522,53273953,25),(6541522,53273954,26),(6541522,53273955,27),(6541522,53273956,28),(6541522,53273957,29),(6541522,53273958,30),(6541522,53273959,31),(6541522,53273960,32),(6541522,53273961,33),(6541525,51123233,1),(6541525,53273962,2),(6541525,53273963,3),(6541525,53273964,4),(6541525,53273965,5),(6541525,53273966,6),(6541525,53273967,7),(6541538,52032250,1),(6541538,53275670,2),(6541538,53275669,3),(6541538,53275668,4),(6541538,53275667,5),(6541538,53275666,6),(6541538,53275665,7),(6541538,53275664,8),(6541538,53275663,9),(6541538,53275662,10),(6541538,53275661,11),(6541538,53275660,12),(6541538,53275659,13),(6541538,53275658,14),(6541538,53275657,15),(6541538,53275656,16),(6541538,53275655,17),(6541538,53275654,18),(6541538,53275653,19),(6541538,53275652,20),(6541538,53275651,21),(6541538,53275650,22),(6541538,53275649,23),(6541538,53275648,24),(6541538,53275647,25),(6541538,53275646,26),(6541538,53275645,27),(6541538,53275644,28),(6541538,53275643,29),(6541538,53275642,30),(6541538,53275640,31),(6541538,53275639,32),(6541538,53275638,33),(6541538,53275637,34),(6541538,53275636,35),(6541538,53275635,36),(6541538,53275634,37),(6541538,53275633,38),(6541538,53275632,39),(6541538,53275631,40),(6541538,53275630,41),(6541538,53275629,42),(6541538,53275628,43),(6541538,53275627,44),(6541538,53275626,45),(6541538,53275625,46),(6541538,53275624,47),(6541538,53275623,48),(6541538,53275622,49),(6541538,53275621,50),(6541538,53275620,51),(6541538,53275619,52),(6541538,53275618,53),(6541538,53275617,54),(6541538,53275616,55),(6541538,53275615,56),(6541538,53275614,57),(6541538,53275613,58),(6541538,53275612,59),(6541538,53275611,60),(6541538,53275610,61),(6541538,53275609,62),(6541538,53275608,63),(6541538,53275607,64),(6541538,53275606,65),(6541538,53275605,66),(6541538,53275604,67),(6541538,53275603,68),(6541538,53275602,69),(6541538,53275601,70),(6541538,53275600,71),(6541538,53275599,72),(6541538,53275598,73),(6541538,53275597,74),(6541538,53275596,75),(6541538,53275595,76),(6541538,53275594,77),(6541538,53275593,78),(6541538,53275592,79),(6541538,53275591,80),(6541538,53275590,81),(6541538,53275589,82),(6541538,53275588,83),(6541538,53275587,84),(6541538,53275586,85),(6541538,53275585,86),(6541538,53275584,87),(6541538,53275583,88),(6541538,53275582,89),(6541538,53275581,90),(6541538,53275580,91),(6541538,53275579,92),(6541538,53275578,93),(6541538,53275577,94),(6541538,53275576,95),(6541538,53275575,96),(6541538,53275574,97),(6541538,53275573,98),(6541538,53275572,99),(6541538,53275570,100),(6541538,53275569,101),(6541538,53275568,102),(6541538,53275567,103),(6541538,53275565,104),(6541538,53275563,105),(6541538,53275562,106),(6541538,53275561,107),(6541538,53275560,108),(6541538,53275559,109),(6541538,53275558,110),(6541538,53275557,111),(6541538,53275556,112),(6541538,53275555,113),(6541538,53275554,114),(6541538,53275552,115),(6541538,53275551,116),(6541538,53275550,117),(6541538,53275549,118),(6541538,53275548,119),(6541538,53275547,120),(6541538,53275546,121),(6541538,53275545,122),(6541538,53275544,123),(6541538,53275543,124),(6541538,53275542,125),(6541538,53275541,126),(6541538,53275540,127),(6541538,53275539,128),(6541538,53275538,129),(6541538,53275537,130),(6541538,53275536,131),(6541538,53275535,132),(6541538,53275534,133),(6541538,53275533,134),(6541538,53277215,135),(6541538,53275005,136),(6541538,53275004,137),(6541538,53275003,138),(6541538,53275002,139),(6541538,53275001,140),(6541538,53274999,141),(6541538,53274998,142),(6541538,53274967,143),(6541538,53274966,144),(6541538,53274965,145),(6541538,53274964,146),(6541538,53274963,147),(6541538,53274961,148),(6541538,53274960,149),(6541538,53274959,150),(6541538,53274958,151),(6541538,53274957,152),(6541538,53274956,153),(6541538,53274955,154),(6541538,53274954,155),(6541538,53274952,156),(6541538,53274951,157),(6541538,53274950,158),(6541538,53274949,159),(6541538,53274948,160),(6541538,53274947,161),(6541538,53274946,162),(6541538,53274944,163),(6541538,53274943,164),(6541538,53274942,165),(6541538,53274941,166),(6541538,53274940,167),(6541538,53274939,168),(6541538,53274937,169),(6541538,53274936,170),(6541538,53274935,171),(6541538,53274934,172),(6541538,53274933,173),(6541538,53274932,174),(6541538,53274931,175),(6541538,53274929,176),(6541538,53274928,177),(6541538,53274927,178),(6541538,53274926,179),(6541538,53274925,180),(6541538,53274924,181),(6541538,53274922,182),(6541538,53274921,183),(6541538,53274920,184),(6541538,53274919,185),(6541538,53274918,186),(6541538,53274917,187),(6541538,53274916,188),(6541538,53274915,189),(6541538,53274913,190),(6541538,53274912,191),(6541538,53274911,192),(6541538,53274910,193),(6541538,53274909,194),(6541538,53274908,195),(6541538,53274907,196),(6541538,53274906,197),(6541538,53274904,198),(6541538,53274903,199),(6541538,53274902,200),(6541538,53274901,201),(6541538,53274900,202),(6541538,53274899,203),(6541538,53274898,204),(6541538,53274896,205),(6541538,53274895,206),(6541538,53274894,207),(6541538,53274893,208),(6541538,53274892,209),(6541538,53274891,210),(6541538,53274890,211),(6541538,53274888,212),(6541538,53274886,213),(6541538,53274885,214),(6541538,53274884,215),(6541538,53274883,216),(6541538,53274031,217),(6541538,53274030,218),(6541538,53274029,219),(6541538,53274028,220),(6541538,53274027,221),(6541538,53274026,222),(6541538,53274025,223),(6541538,53274024,224),(6541538,53274023,225),(6541538,53273998,226),(6541538,53273997,227),(6541538,53273996,228),(6541538,53273995,229),(6541538,53273994,230),(6541538,53273993,231),(6541538,53273992,232),(6541538,53273991,233),(6541538,53273990,234),(6541538,53273989,235),(6541538,53273988,236),(6541538,53273987,237),(6541538,53273986,238),(6541538,53273985,239),(6541538,53273984,240),(6541538,53273983,241),(6541538,53273982,242),(6541538,53273981,243),(6541538,53273980,244),(6541538,53273979,245),(6541538,53273978,246),(6541538,53273977,247),(6541538,53273976,248),(6541538,53273975,249),(6541538,53273974,250),(6541538,53273973,251),(6541538,53273972,252),(6541538,53273971,253),(6541538,53273968,254),(6541538,53273969,255),(6541538,53273970,256),(6541541,53274000,1),(6541541,53274002,2),(6541541,53274003,3),(6541541,53274004,4),(6541541,53274005,5),(6541541,53274006,6),(6541541,53274007,7),(6541541,53274008,8),(6541541,53274009,9),(6541541,53274010,10),(6541541,53274011,11),(6541541,53274012,12),(6541541,53274013,13),(6541541,53274014,14),(6541541,53274015,15),(6541541,53274016,16),(6541541,53274017,17),(6541541,53274018,18),(6541541,53274019,19),(6541541,53274020,20),(6541541,53274021,21),(6541541,53274022,22),(6548812,53275012,1),(6548812,53275014,2),(6548812,53274973,3),(6548812,53274974,4),(6548812,53274976,5),(6548812,53274977,6),(6548812,53274978,7),(6548812,53274979,8),(6548812,53274980,9),(6548812,53274981,10),(6548812,53274983,11),(6548812,53274984,12),(6548812,53274985,13),(6548812,53274986,14),(6548812,53274987,15),(6548812,53274988,16),(6548812,53274989,17),(6548812,53274990,18),(6548812,53274991,19),(6548812,53274992,20),(6548812,53274993,21),(6548812,53274995,22),(6548812,53274996,23),(6548812,53274997,24),(6548814,53275008,1),(6548814,53275009,2),(6548814,53275016,3),(6548814,53275015,4),(6548814,53275010,5),(6548814,53275011,6),(6548814,53275014,7),(6548816,53275006,1),(6548816,53275017,2),(6548816,53275008,3),(6548818,53275028,1),(6548818,53275036,2),(6548818,53275035,3),(6548818,53275040,4),(6548818,53276316,5),(6548820,53275026,1),(6548820,769253018,2),(6548820,769253019,3),(6548820,53275033,4),(6548820,769253020,5),(6548820,53275032,6),(6548820,769253021,7),(6548820,53275031,8),(6548820,769253022,9),(6548820,53275030,10),(6548820,769253024,11),(6548820,53275028,12),(6548820,769253025,13),(6548820,769253026,14),(6548820,53275027,15),(6548820,769253028,16),(6548820,769253029,17),(6548820,51125478,18),(6548820,769253030,19),(6548820,53275026,20),(6548822,53274972,1),(6548822,53275034,2),(6548824,53275034,1),(6548824,53275012,2),(6548826,53275038,1),(6548826,53275039,2),(6548826,262892998,3),(6551314,51931099,1),(6551314,53275531,2),(6551314,53275530,3),(6551314,53275529,4),(6551314,53275528,5),(6551314,53277181,6),(6551314,53275527,7),(6551314,53275526,8),(6551314,53275525,9),(6551314,53275524,10),(6551314,53275523,11),(6551314,53275522,12),(6551314,53275521,13),(6551314,53275520,14),(6551314,53275506,15),(6551314,53275507,16),(6551314,53275508,17),(6551317,51126211,1),(6551317,264465126,2),(6551320,264465126,1),(6551320,51126212,2),(6551320,625205,3),(6551320,625206,4),(6551320,51126213,5),(6553102,53276316,1),(6553102,53276317,2),(6553108,53276317,1),(6553108,53275008,2),(6553108,53275018,3),(6553108,53275019,4),(6553108,53275020,5),(6553108,53275022,6),(6553108,53275023,7),(6553108,53275024,8),(6553108,53276347,9),(6553108,53276348,10),(6553108,53276349,11),(6553108,53276350,12),(6553108,53276351,13),(6553108,53276352,14),(6553108,53276353,15),(6553108,53276354,16),(6553108,53276355,17),(6553108,53276356,18),(6553108,53276357,19),(6553108,53276358,20),(6553108,53276359,21),(6553108,53276360,22),(6553108,53276361,23),(6553108,53276362,24),(6553108,53276363,25),(6553108,53276364,26),(6553108,53276365,27),(6553108,53276426,28),(6553108,53276366,29),(6553108,53276367,30),(6553108,53276368,31),(6553108,53276369,32),(6553108,53276370,33),(6553108,53276371,34),(6553108,53276372,35),(6553108,53276373,36),(6553108,53276374,37),(6553398,53276380,1),(6553398,53276381,2),(6553398,53276382,3),(6553398,53276383,4),(6553398,53276384,5),(6553398,53276385,6),(6553398,53276386,7),(6553398,53276387,8),(6553398,53276388,9),(6553398,53276389,10),(6553398,53276390,11),(6553516,53277173,1),(6553516,53277172,2),(6553516,53277171,3),(6553516,53277170,4),(6553516,53277169,5),(6553516,53277168,6),(6553516,53277167,7),(6553516,53277166,8),(6553516,53277165,9),(6553516,53277164,10),(6553516,53277163,11),(6553516,53277162,12),(6553516,53277161,13),(6553516,53277160,14),(6553516,53276588,15),(6553516,53276589,16),(6553516,53276590,17),(6553516,53276592,18),(6553516,53276593,19),(6553516,53276594,20),(6553516,53276595,21),(6553516,53276597,22),(6553516,53276598,23),(6553516,53276599,24),(6553516,53276600,25),(6553516,53276601,26),(6553516,53276602,27),(6553516,53276604,28),(6553516,53276605,29),(6553516,53276606,30),(6553516,53276608,31),(6553516,53276609,32),(6553516,53276610,33),(6553516,53276611,34),(6553516,53276612,35),(6553516,53276613,36),(6553516,53276614,37),(6553516,53276616,38),(6553516,53276617,39),(6553516,53276618,40),(6553516,53276619,41),(6553516,53276620,42),(6553516,53276621,43),(6553516,53276622,44),(6553516,53276623,45),(6553516,53276624,46),(6553516,53276625,47),(6553516,53276627,48),(6553516,53276628,49),(6553516,53276630,50),(6553516,53276631,51),(6553516,53276632,52),(6553516,53276633,53),(6553516,53276634,54),(6553516,53276635,55),(6553516,53276636,56),(6553516,53276637,57),(6553516,53276639,58),(6553516,53276641,59),(6553516,53276643,60),(6553516,53276645,61),(6553516,53276646,62),(6553516,53276647,63),(6553516,53276648,64),(6553516,53276518,65),(6553516,53276519,66),(6553516,53276543,67),(6553516,53276520,68),(6553516,53276521,69),(6553516,53276522,70),(6553516,53276523,71),(6553516,53276524,72),(6553516,53276525,73),(6553516,53276526,74),(6553516,53276527,75),(6553516,53276528,76),(6553516,53276529,77),(6553516,53276530,78),(6553516,53276531,79),(6553516,53276532,80),(6553516,53276533,81),(6553516,53276534,82),(6553516,53276535,83),(6553516,53276536,84),(6553516,53276537,85),(6553516,53276459,86),(6553516,53276460,87),(6553516,53276461,88),(6553516,53276462,89),(6553516,53276463,90),(6553516,53276464,91),(6553516,53276465,92),(6553516,53276466,93),(6553516,53276467,94),(6553516,53276468,95),(6553516,53276469,96),(6553516,53276470,97),(6553516,53276471,98),(6553516,53276472,99),(6553516,53276473,100),(6553516,53276474,101),(6553516,53276475,102),(6553516,53276476,103),(6553516,53276477,104),(6553516,53276478,105),(6553516,53276479,106),(6553516,53276480,107),(6553516,53276481,108),(6553516,53276482,109),(6553516,53276483,110),(6553516,53276484,111),(6553516,53276485,112),(6553516,53276486,113),(6553516,53276487,114),(6553516,53276488,115),(6553516,53276489,116),(6553516,53276490,117),(6553516,53276491,118),(6553516,53276492,119),(6553516,53276493,120),(6553516,53276494,121),(6553516,53276495,122),(6553516,53276496,123),(6553516,53276497,124),(6553516,53276498,125),(6553516,53276499,126),(6553516,53276500,127),(6553516,53276501,128),(6553516,53276502,129),(6553516,53276503,130),(6553516,53276504,131),(6553516,53276505,132),(6553516,53276506,133),(6553516,53276507,134),(6553516,53276508,135),(6553516,53276509,136),(6553516,53276510,137),(6553516,53276511,138),(6553516,53276512,139),(6553516,53276513,140),(6553516,53276514,141),(6553516,53276515,142),(6553516,53276516,143),(6553516,53276517,144),(6553516,53276390,145),(6553516,53276392,146),(6553516,53276393,147),(6553516,53276394,148),(6553516,53276395,149),(6553516,53276396,150),(6553516,53276397,151),(6553516,53276398,152),(6553516,53276399,153),(6553516,53276400,154),(6553516,53276401,155),(6553516,53276402,156),(6553516,53276403,157),(6553516,53276404,158),(6553516,53276406,159),(6553516,53276407,160),(6553516,53276408,161),(6553516,53276410,162),(6553516,53276411,163),(6553516,53276412,164),(6553516,53276413,165),(6553516,53276414,166),(6553516,53276415,167),(6553516,53276416,168),(6553516,53276418,169),(6553516,53276419,170),(6553516,53277174,171),(6553516,53277175,172),(6553516,53277176,173),(6553516,53277177,174),(6553516,53277178,175),(6553516,53276424,176),(6553741,53276538,1),(6553741,53276539,2),(6553741,53276540,3),(6553741,53276541,4),(6553741,53276542,5),(6553741,53276543,6),(6557168,53276424,1),(6557168,53276426,2),(6557169,53277179,1),(6557169,53277180,2),(6557169,53277181,3),(6557171,53277182,1),(6557171,53277183,2),(6557171,53277184,3),(6557171,53277185,4),(6557171,53277189,5),(6557171,53277186,6),(6557171,53277187,7),(6557171,53275506,8),(6557173,53277190,1),(6557173,53277191,2),(6557173,53277192,3),(6557173,53275523,4),(6557177,53277313,1),(6557177,53277312,2),(6557177,53277311,3),(6557177,53277310,4),(6557177,53277309,5),(6557177,53277308,6),(6557177,53277307,7),(6557177,53277306,8),(6557177,53277305,9),(6557177,53277304,10),(6557177,53277303,11),(6557177,53277302,12),(6557177,53277301,13),(6557177,53277300,14),(6557177,53277299,15),(6557177,53277298,16),(6557177,53277297,17),(6557177,53277296,18),(6557177,53277295,19),(6557177,53277294,20),(6557177,53277293,21),(6557177,53277292,22),(6557177,53277291,23),(6557177,53277290,24),(6557177,53277289,25),(6557177,53277288,26),(6557177,53277287,27),(6557177,53277286,28),(6557177,53277285,29),(6557177,53277284,30),(6557177,53277283,31),(6557177,53277282,32),(6557177,53277281,33),(6557177,53277280,34),(6557177,53277279,35),(6557177,53277278,36),(6557177,53277277,37),(6557177,53277276,38),(6557177,53277275,39),(6557177,53277274,40),(6557177,53277273,41),(6557177,53277272,42),(6557177,53277271,43),(6557177,53277270,44),(6557177,53277269,45),(6557177,53277268,46),(6557177,53277267,47),(6557177,53277266,48),(6557177,53277265,49),(6557177,53277264,50),(6557177,53277263,51),(6557177,53277262,52),(6557177,53277261,53),(6557177,53277260,54),(6557177,53277259,55),(6557177,53277258,56),(6557177,53277257,57),(6557177,53277256,58),(6557177,53277255,59),(6557177,53277254,60),(6557177,53277253,61),(6557177,53277252,62),(6557177,53277251,63),(6557177,53277250,64),(6557177,53277249,65),(6557177,53277248,66),(6557177,53277247,67),(6557177,53277246,68),(6557177,53277245,69),(6557177,53277244,70),(6557177,53277243,71),(6557177,53277242,72),(6557177,53277241,73),(6557177,53277240,74),(6557177,53277239,75),(6557177,53277238,76),(6557177,53277237,77),(6557177,53277236,78),(6557177,53277235,79),(6557177,53277234,80),(6557177,53277233,81),(6557177,53277232,82),(6557177,53277231,83),(6557177,53277230,84),(6557177,53277229,85),(6557177,53277228,86),(6557177,53277227,87),(6557177,53277226,88),(6557177,53277225,89),(6557177,53277224,90),(6557177,53277223,91),(6557177,53277222,92),(6557177,53277221,93),(6557177,53277220,94),(6557177,53277219,95),(6557177,53277218,96),(6557177,53277217,97),(6557177,53277216,98),(6557177,53277193,99),(6557177,53277194,100),(6557177,53277195,101),(6557177,53277196,102),(6557177,53277197,103),(6557177,53277198,104),(6557177,53277199,105),(6557177,53277200,106),(6557177,53277201,107),(6557177,53277202,108),(6557177,53277203,109),(6557177,53277204,110),(6557177,53277205,111),(6557177,53277206,112),(6557177,53277207,113),(6557177,53277208,114),(6557177,53277209,115),(6557177,53277210,116),(6557177,53277211,117),(6557177,53277212,118),(6557177,53277213,119),(6557177,53277214,120),(6557177,53277215,121),(6561466,53278161,1),(6561466,53278162,2),(6561466,53278163,3),(6561466,53278164,4),(6561466,53278165,5),(6561466,53278166,6),(6561466,53278167,7),(6561466,53278142,8),(6561466,53278144,9),(6561466,53278146,10),(6561466,53278147,11),(6561466,53278148,12),(6561466,53278149,13),(6561466,53278150,14),(6561466,53278151,15),(6561466,53278152,16),(6561466,53278153,17),(6561466,53278154,18),(6561466,53278155,19),(6561466,53278156,20),(6561466,53278157,21),(6561466,53278158,22),(6561466,53278159,23),(6561466,53278160,24),(6561466,53278161,25),(6561468,53278175,1),(6561468,53278174,2),(6561468,53278173,3),(6561468,53278172,4),(6561468,53278171,5),(6561468,53278170,6),(6561468,53278169,7),(6561468,53278168,8),(6561470,53278178,1),(6561470,53278179,2),(6561470,53278180,3),(6561470,53278181,4),(6561470,53278182,5),(6561470,53278183,6),(6561470,53278185,7),(6561470,53278186,8),(6561470,53278188,9),(6561470,53278190,10),(6561470,53278192,11),(6561470,53278194,12),(6561470,53278196,13),(6561470,53278197,14),(6561470,53278199,15),(6561470,53278200,16),(6561470,53278201,17),(6561470,53278202,18),(6561470,53278203,19),(6561470,53278176,20),(6561470,53278177,21),(6561470,53278178,22),(6561682,53278204,1),(6561682,53278205,2),(6561682,53278206,3),(6561682,53278207,4),(6561682,53278208,5),(6561682,53278210,6),(6561682,53278211,7),(6561682,53278212,8),(6561682,53278213,9),(6561682,53278214,10),(6561682,53278215,11),(6561682,53278216,12),(6561682,53278217,13),(6561682,53278204,14),(6561704,53278235,1),(6561704,53278236,2),(6561704,53278237,3),(6561704,53278238,4),(6561704,53278239,5),(6561704,53278240,6),(6561704,53278241,7),(6561704,53278242,8),(6561704,53278252,9),(6561704,53278253,10),(6561704,53278255,11),(6561704,53278256,12),(6561704,53278257,13),(6561704,53278218,14),(6561704,53278219,15),(6561704,53278220,16),(6561704,53278221,17),(6561704,53278222,18),(6561704,53278223,19),(6561704,53278224,20),(6561704,53278226,21),(6561704,53278232,22),(6561704,53278233,23),(6561704,53278234,24),(6561704,53278235,25),(6561708,53278258,1),(6561708,53278259,2),(6561708,53278261,3),(6561708,53278263,4),(6561708,53278264,5),(6561708,53278265,6),(6561708,53278267,7),(6561708,53278268,8),(6561708,53278269,9),(6561708,53278271,10),(6561708,53278272,11),(6561708,53278273,12),(6561708,53278274,13),(6561708,53278275,14),(6561708,53278276,15),(6561708,53278277,16),(6561708,53278278,17),(6561708,53278280,18),(6561708,53278282,19),(6561708,53278283,20),(6561708,53278285,21),(6561708,53278286,22),(6561708,53278287,23),(6561708,664061745,24),(6561708,53278289,25),(6561708,53278290,26),(6561708,53278291,27),(6561708,53278292,28),(6561708,53278293,29),(6561708,53278294,30),(6561708,53278296,31),(6561708,53278298,32),(6561708,53278299,33),(6561708,53278301,34),(6561708,53278302,35),(6561708,53278304,36),(6561708,53278305,37),(6561708,53278306,38),(6561708,53278308,39),(6561708,53278309,40),(6561708,53278311,41),(6561708,53278312,42),(6561708,53278314,43),(6561708,53278315,44),(6561708,53278316,45),(6561708,53278317,46),(6561708,53278319,47),(6561708,53278321,48),(6561708,53278324,49),(6561708,53278327,50),(6561708,53278328,51),(6561708,53278330,52),(6561708,53278332,53),(6561708,53278333,54),(6561708,53278336,55),(6561708,53278337,56),(6561708,53278338,57),(6561708,53278341,58),(6561708,53278342,59),(6561708,53278343,60),(6561708,53278346,61),(6561708,53278347,62),(6561708,53278348,63),(6561708,53278350,64),(6561708,53278351,65),(6561708,53278353,66),(6561708,53278355,67),(6561708,53278356,68),(6561708,53278358,69),(6561708,53278360,70),(6561708,53278361,71),(6561708,53278362,72),(6561708,53278364,73),(6561708,53278366,74),(6561708,53278367,75),(6561708,53278368,76),(6561708,53278369,77),(6561708,53278371,78),(6561708,53278374,79),(6561708,53278375,80),(6561708,53278376,81),(6561708,53278377,82),(6561708,53278379,83),(6561708,53278383,84),(6561708,53278387,85),(6561708,779158284,86),(6561708,53278390,87),(6561708,53278395,88),(6561708,53278401,89),(6561708,53278404,90),(6561708,53278409,91),(6561708,53278412,92),(6561708,53278418,93),(6561708,53278420,94),(6561708,53278423,95),(6561708,53278426,96),(6561708,53278429,97),(6561708,53278258,98),(6563683,53281403,1),(6563683,53281402,2),(6563683,53281399,3),(6563683,53281395,4),(6563683,53281393,5),(6563683,53281388,6),(6563683,53281386,7),(6563683,53281382,8),(6563683,53281378,9),(6563683,53281374,10),(6563683,53281369,11),(6563687,53281406,1),(6563687,53281412,2),(6563687,53281415,3),(6563687,53281420,4),(6563687,53281424,5),(6563687,53281426,6),(6563687,53281430,7),(6563687,53281433,8),(6563687,53281436,9),(6563687,53281440,10),(6563687,53281444,11),(6563687,53282638,12),(6563687,53282705,13),(6563687,53282708,14),(6563687,53282709,15),(6563687,53282712,16),(6563687,53282714,17),(6563687,53282716,18),(6563687,53282719,19),(6563687,53282721,20),(6563687,53282723,21),(6563687,53282725,22),(6563687,53282727,23),(6563687,53282729,24),(6563687,53282730,25),(6563687,53282731,26),(6563687,53282734,27),(6563687,53282735,28),(6563687,53282738,29),(6563687,53282741,30),(6563687,53282743,31),(6563687,53282745,32),(6563687,53282748,33),(6563687,53282751,34),(6563687,53282753,35),(6563687,53282756,36),(6563687,53282759,37),(6563687,53282761,38),(6563687,53282764,39),(6563687,53282767,40),(6563687,53282768,41),(6563687,53282769,42),(6563687,53282772,43),(6563687,53282773,44),(6563687,53282777,45),(6563687,53282780,46),(6563687,53282784,47),(6563687,53282787,48),(6563687,53282789,49),(6563687,53282791,50),(6563687,53282794,51),(6563687,53282796,52),(6563687,53282803,53),(6563687,53282804,54),(6563687,53282808,55),(6563687,53282811,56),(6563687,53282814,57),(6563687,53282815,58),(6563687,53282817,59),(6563687,53282818,60),(6563687,53282819,61),(6563687,53282820,62),(6563687,53282822,63),(6563687,53282825,64),(6563687,53282827,65),(6563687,53282829,66),(6563687,53282831,67),(6563687,53282834,68),(6563687,53282839,69),(6563687,53282840,70),(6563687,53282842,71),(6563687,53282843,72),(6563687,53282846,73),(6563687,53282849,74),(6563687,53282852,75),(6563687,53282854,76),(6563687,53282856,77),(6563687,53282858,78),(6563687,53282860,79),(6563687,53282920,80),(6563687,53282925,81),(6563687,53282927,82),(6563687,53281406,83),(6563690,53282932,1),(6563690,53282936,2),(6563690,53282940,3),(6563690,53282941,4),(6563690,53282943,5),(6563690,53282946,6),(6563690,53282948,7),(6563690,53282950,8),(6563690,894259087,9),(6563690,53282952,10),(6563690,53282953,11),(6563690,53282957,12),(6563690,53282958,13),(6563690,53282959,14),(6563690,53282960,15),(6563690,53282963,16),(6563690,53282966,17),(6563690,53282968,18),(6563690,53282970,19),(6563690,53282972,20),(6563690,53282974,21),(6563690,53282976,22),(6563690,53282979,23),(6563690,53282983,24),(6563690,53282985,25),(6563690,53282987,26),(6563690,53282989,27),(6563690,53282991,28),(6563690,53282996,29),(6563690,53282998,30),(6563690,53283003,31),(6563690,53283007,32),(6563690,53283011,33),(6563690,894259565,34),(6563690,894259017,35),(6563690,894259189,36),(6563690,894259372,37),(6566558,53288136,1),(6566558,51448824,2),(6566558,51448827,3),(6566558,51448828,4),(6566561,53288128,1),(6566561,53288148,2),(6566561,53288140,3),(6566561,53288138,4),(6566561,53288136,5),(6566561,53288134,6),(6566561,53288131,7),(6566561,51448940,8),(6566561,53288129,9),(6566561,53288128,10),(6566571,53288321,1),(6566571,53288323,2),(6566571,53288326,3),(6566571,53288329,4),(6566571,53288332,5),(6566571,53288334,6),(6566571,53288336,7),(6566571,53288338,8),(6566571,53288339,9),(6566571,53288343,10),(6566571,53288346,11),(6566573,53288348,1),(6566573,53288349,2),(6566573,53288350,3),(6566573,53288351,4),(6566573,53288352,5),(6566573,53288353,6),(6566573,53288354,7),(6566573,53288355,8),(6566573,53288356,9),(6566573,53288357,10),(6566573,53288216,11),(6566576,53288358,1),(6566576,53288360,2),(6566576,53288364,3),(6566576,53288366,4),(6566576,53288368,5),(6566576,53288370,6),(6566576,53288373,7),(6566576,53288375,8),(6566576,53288378,9),(6566576,53288381,10),(6566576,53288383,11),(6566576,53288388,12),(6566576,53288391,13),(6566576,53288393,14),(6566576,53288394,15),(6566576,53288396,16),(6566576,53288399,17),(6566576,53288402,18),(6566576,53288403,19),(6566576,53288404,20),(6566576,53288419,21),(6566576,53288407,22),(6566576,53288410,23),(6566576,53288413,24),(6566576,53288152,25),(6569859,370902435,1),(6569859,370902436,2),(6569859,370902438,3),(6569859,53295391,4),(6569859,53295388,5),(6569859,53295385,6),(6569859,53295382,7),(6569859,53295379,8),(6569859,53295377,9),(6569859,53295375,10),(6569859,53295371,11),(6569859,53295370,12),(6569859,53295365,13),(6569859,53295363,14),(6569859,53295361,15),(6569859,53295359,16),(6569859,53295356,17),(6569859,53295353,18),(6569859,53295349,19),(6569859,53295347,20),(6569859,53295343,21),(6569859,53295339,22),(6569859,53295336,23),(6569859,53295332,24),(6569859,53295329,25),(6569859,53295327,26),(6569859,53295325,27),(6569859,53295321,28),(6569859,53295319,29),(6569859,53295315,30),(6569859,53295314,31),(6569859,53295312,32),(6569859,53295310,33),(6569859,53295308,34),(6569859,53295305,35),(6569859,53295301,36),(6569859,53295299,37),(6569859,53295298,38),(6569859,53295294,39),(6569859,53295292,40),(6569859,370904235,41),(6569859,53295291,42),(6569859,53295287,43),(6569859,53295283,44),(6569859,53295281,45),(6569859,53295277,46),(6569859,53295276,47),(6569859,53295267,48),(6569859,53295272,49),(6576845,53306568,1),(6576845,53306569,2),(6576845,53306573,3),(6576845,53306575,4),(6576845,53306579,5),(6576845,53306582,6),(6576845,53306585,7),(6576845,53306588,8),(6576845,53306590,9),(6576845,53306592,10),(6576845,53306595,11),(6576845,53306597,12),(6576845,53306600,13),(6576847,53306679,1),(6576847,53306677,2),(6576847,53306675,3),(6576847,53306673,4),(6576847,53306672,5),(6576847,53306671,6),(6576847,53306670,7),(6576847,53306668,8),(6576853,53306680,1),(6576853,53306679,2),(6576855,53306695,1),(6576855,53306696,2),(6576855,53306697,3),(6576858,53306808,1),(6576858,53306810,2),(6576858,53306813,3),(6576858,53306814,4),(6576858,53306817,5),(6576858,441157267,6),(6576858,53306819,7),(6576858,53306821,8),(6576858,53306823,9),(6576858,53306825,10),(6576858,53306828,11),(6576858,53306831,12),(6576858,53306833,13),(6576858,53306836,14),(6576858,53306838,15),(6576858,53306841,16),(6576858,53306843,17),(6576858,53306845,18),(6576858,53306846,19),(6576858,53306848,20),(6576858,53306849,21),(6576858,53306852,22),(6576858,53306853,23),(6576858,53306856,24),(6576858,53306858,25),(6576858,53306862,26),(6576858,53306863,27),(6576858,53306866,28),(6576861,53306869,1),(6576861,53306823,2),(6576864,53306984,1),(6576864,53306979,2),(6576864,53306978,3),(6576864,53306975,4),(6576864,53306973,5),(6576864,53306970,6),(6576864,53306966,7),(6576864,53306963,8),(6576864,53306925,9),(6576866,53306980,1),(6576866,53306983,2),(6576866,53306984,3),(6576866,53309392,4),(6576866,53306988,5),(6576866,53306989,6),(6576866,53306991,7),(6576866,53306992,8),(6576866,53306994,9),(6578446,276998391,1),(6578446,276998392,2),(6578446,276998393,3),(6578446,276998394,4),(6578446,53309350,5),(6578446,53309352,6),(6578446,53309354,7),(6578446,53309356,8),(6578446,53309360,9),(6578446,53309365,10),(6578446,53309368,11),(6578446,277003680,12),(6578446,277003681,13),(6578446,277003682,14),(6578446,277003683,15),(6578446,277003684,16),(6578449,53309380,1),(6578449,264501528,2),(6578449,53309382,3),(6578451,53309384,1),(6578451,277000148,2),(6578451,277000149,3),(6578451,277001727,4),(6578451,276998671,5),(6578451,53306913,6),(6578454,53309392,1),(6578454,53309386,2),(6578454,53309389,3),(6578454,53309393,4),(6578454,53309395,5),(6578454,53309397,6),(6578454,53309398,7),(6578454,53309400,8),(6578454,53309402,9),(6578454,53309405,10),(6578454,53309407,11),(6578454,53309419,12),(6578454,53309409,13),(6578454,53309412,14),(6578454,53309414,15),(6578454,53309417,16),(6578454,53309421,17),(6578454,53309423,18),(6578454,53309425,19),(6578454,53309427,20),(6578454,53309431,21),(6578454,53309433,22),(6578454,53309436,23),(6578454,53309438,24),(6578454,53309440,25),(6578454,53309443,26),(6578454,53309446,27),(6578454,53309449,28),(6578454,53309453,29),(6578454,53309457,30),(6578454,53309460,31),(6578454,53309462,32),(6578454,53309464,33),(6578454,53309466,34),(6578454,53309469,35),(6578454,53309473,36),(6578454,53309476,37),(6578454,53309477,38),(6578454,53309480,39),(6578454,53309482,40),(6578454,53309483,41),(6578454,53309485,42),(6584903,53316105,1),(6584903,53316074,2),(6584906,53319479,1),(6584906,53319482,2),(6584908,53315884,1),(6584908,53315943,2),(6584908,53315948,3),(6584908,53315952,4),(6584908,53315955,5),(6584908,53316065,6),(6584908,53319482,7),(6584908,53316068,8),(6584908,53316074,9),(6584908,53319484,10),(6584910,53319489,1),(6584910,53319487,2),(6584910,266330795,3),(6584910,266330794,4),(6584910,266330793,5),(6584910,266330483,6),(6584917,51552726,1),(6584917,53330453,2),(6584917,53330450,3),(6584917,53327626,4),(6584920,53319514,1),(6584920,53319515,2),(6584920,53319517,3),(6584920,53319520,4),(6584920,53319521,5),(6584920,53319523,6),(6584920,53319525,7),(6584920,53319529,8),(6584920,53319532,9),(6584920,53319533,10),(6584925,53319535,1),(6584925,53319536,2),(6584925,53319538,3),(6584925,53319539,4),(6584925,53319541,5),(6584925,53319543,6),(6584925,53319545,7),(6584925,53319547,8),(6584925,53319548,9),(6584925,53319551,10),(6584925,53319552,11),(6584925,53319554,12),(6584928,53319555,1),(6584928,53319557,2),(6584939,53319705,1),(6584939,53319703,2),(6584939,53319702,3),(6584939,53319701,4),(6584939,53319700,5),(6584939,53319697,6),(6584939,53319695,7),(6584939,53319693,8),(6584939,53319690,9),(6584939,53319688,10),(6584939,53319687,11),(6584939,53319686,12),(6584939,53325732,13),(6584939,53319684,14),(6584939,53319682,15),(6584939,53319681,16),(6584939,53319678,17),(6584939,53325674,18),(6584939,53319675,19),(6584939,53319672,20),(6584939,53319670,21),(6584939,53319669,22),(6584939,53319667,23),(6584939,53319666,24),(6584939,53319665,25),(6584939,53319664,26),(6584939,53319663,27),(6584939,53325663,28),(6584947,53319784,1),(6584947,53319782,2),(6584947,53319781,3),(6584947,53319778,4),(6584947,53319777,5),(6584947,53319774,6),(6584947,53319773,7),(6584947,53319770,8),(6584947,53319768,9),(6584947,53319765,10),(6584947,53319761,11),(6584947,53319759,12),(6584947,53319758,13),(6584947,53319756,14),(6584947,53319755,15),(6584947,53319753,16),(6584947,53319752,17),(6584947,53319750,18),(6584947,53319749,19),(6584947,53319747,20),(6584951,268082898,1),(6584951,268082899,2),(6584951,53319786,3),(6584951,53319787,4),(6584956,53319789,1),(6584956,53319790,2),(6584956,268082898,3),(6584956,53319793,4),(6584956,53319796,5),(6584956,53319797,6),(6584956,53319800,7),(6584956,53319801,8),(6584956,53319804,9),(6584956,53319806,10),(6584956,53319807,11),(6584961,53319809,1),(6584961,53319811,2),(6584961,53319813,3),(6584961,53319815,4),(6584961,53319816,5),(6584961,53319817,6),(6584961,53319818,7),(6584961,53319819,8),(6584961,53319820,9),(6584961,53319821,10),(6584961,53319822,11),(6584961,53319823,12),(6584961,53319826,13),(6584961,53319828,14),(6588508,53325664,1),(6588508,53325666,2),(6588508,53325669,3),(6588508,53325671,4),(6588508,53325672,5),(6588508,53325674,6),(6588510,53325677,1),(6588510,53325680,2),(6588510,53325681,3),(6588510,53325699,4),(6588510,53325706,5),(6588510,53319687,6),(6588513,53319720,1),(6588513,53325746,2),(6588513,53325743,3),(6588513,53325742,4),(6588513,53325739,5),(6588513,53325736,6),(6588513,53325817,7),(6588513,53325735,8),(6588513,53325709,9),(6588516,53325748,1),(6588516,53325750,2),(6588516,53325752,3),(6588516,53325792,4),(6588516,53325795,5),(6588516,53325798,6),(6588516,53325801,7),(6588516,53325802,8),(6588516,53325805,9),(6588516,53325807,10),(6588516,53325809,11),(6588516,53325813,12),(6588516,53325815,13),(6588519,53325818,1),(6588519,261013457,2),(6588519,261013458,3),(6588519,53325820,4),(6588519,261013459,5),(6588519,53325815,6),(6589890,53327629,1),(6589890,53327630,2),(6589890,53327633,3),(6589890,53327636,4),(6589890,53327637,5),(6589890,53327639,6),(6589890,53327642,7),(6589890,53327646,8),(6589890,53327649,9),(6589890,53327652,10),(6589890,53327654,11),(6589890,53327657,12),(6589890,53327661,13),(6589890,53327664,14),(6589890,53327667,15),(6589890,53327669,16),(6589890,53327672,17),(6589890,53327675,18),(6589890,53327678,19),(6589890,53327682,20),(6589890,53327685,21),(6589890,53327686,22),(6589890,53327689,23),(6589890,53327693,24),(6589890,53327696,25),(6589890,53327697,26),(6589890,53327700,27),(6589890,53327703,28),(6589890,53327705,29),(6589890,53327706,30),(6589890,53327708,31),(6589890,53327710,32),(6589890,53327712,33),(6589890,53327716,34),(6589890,53327717,35),(6589890,53327720,36),(6589890,53327721,37),(6589890,53327724,38),(6589890,53327726,39),(6589890,53327728,40),(6589890,53327730,41),(6589890,53327733,42),(6589890,53327734,43),(6589890,53327735,44),(6589890,53327736,45),(6589890,53327737,46),(6589890,53327738,47),(6589890,53327739,48),(6589890,53327741,49),(6589898,53327882,1),(6589898,53327880,2),(6589898,53327879,3),(6589898,53327877,4),(6589898,53327875,5),(6589898,53327873,6),(6589898,53327855,7),(6589898,53327853,8),(6589898,53327851,9),(6589898,53327844,10),(6589898,53327838,11),(6589898,53327836,12),(6589898,53327833,13),(6589898,53327830,14),(6589898,53327826,15),(6589898,53327824,16),(6589898,53327821,17),(6589898,53327818,18),(6589898,53327814,19),(6589898,53327815,20),(6589898,51552740,21),(6590538,53330420,1),(6590538,53330432,2),(6590538,53330444,3),(6590538,53330446,4),(6590538,53330448,5),(6590538,53319576,6),(6592657,53334410,1),(6592657,53334413,2),(6592657,53334414,3),(6592657,53334417,4),(6592657,53334419,5),(6592657,53334421,6),(6592657,53334422,7),(6592657,53334423,8),(6592657,53334424,9),(6592657,53334427,10),(6592657,53334428,11),(6592657,53334431,12),(6592657,53334432,13),(6592657,53334433,14),(6592657,53334437,15),(6592657,53334441,16),(6592657,53334442,17),(6592657,53334444,18),(6592657,53334448,19),(6592657,51581633,20),(6593464,53335700,1),(6593464,53335702,2),(6593464,53335703,3),(6593464,53335707,4),(6593464,53335710,5),(6593464,53335714,6),(6593464,53335715,7),(6593464,53335717,8),(6593464,53335718,9),(6593464,53335719,10),(6593464,53335720,11),(6593464,53335721,12),(6593464,53335722,13),(6593464,53335723,14),(6593464,53335724,15),(6593464,53335727,16),(6593464,53335730,17),(6593464,53335733,18),(6593464,53335738,19),(6593464,53335740,20),(6593464,53335742,21),(6593464,53335743,22),(6593464,53335744,23),(6593464,53335745,24),(6593464,53335746,25),(6593464,53335747,26),(6593464,53335750,27),(6593464,53335752,28),(6593464,53335755,29),(6593464,53335756,30),(6593464,53335759,31),(6593464,53335762,32),(6593464,53335764,33),(6593464,53335766,34),(6593464,53335768,35),(6593464,53335771,36),(6593464,53335776,37),(6593464,53335779,38),(6593464,53335782,39),(6593464,53335783,40),(6593464,53335700,41),(6602616,53352638,1),(6602616,53352642,2),(6602616,53352645,3),(6602616,53352648,4),(6602616,53352650,5),(6602616,53352704,6),(6602616,53352708,7),(6602616,53352723,8),(6602616,53352737,9),(6602616,53352766,10),(6602616,53352774,11),(6602616,53352779,12),(6602616,53352796,13),(6602616,53352802,14),(6602616,53352807,15),(6602616,53352812,16),(6602616,53352849,17),(6602616,53352853,18),(6602616,53352860,19),(6602616,53352863,20),(6602616,53352868,21),(6602616,53352871,22),(6602616,53352873,23),(6602616,53352876,24),(6602616,53352878,25),(6602616,53352883,26),(6602616,53352887,27),(6602616,53352890,28),(6602616,53352894,29),(6602616,53352896,30),(6602616,53352899,31),(6602616,53352904,32),(6602616,53352906,33),(6602616,53352907,34),(6602616,53352912,35),(6602616,53352934,36),(6602616,53352938,37),(6602616,53352942,38),(6602616,53352946,39),(6602616,53352948,40),(6602616,53352951,41),(6602616,53352954,42),(6602616,53352957,43),(6602616,53352960,44),(6602616,53352963,45),(6602616,53352966,46),(6602616,53352969,47),(6602616,53352974,48),(6602616,53352975,49),(6602616,53353016,50),(6602616,53353021,51),(6602616,53353024,52),(6602616,53353034,53),(6602616,53353040,54),(6602616,53353043,55),(6602616,53353047,56),(6602616,53353051,57),(6602616,53353055,58),(6602616,53353086,59),(6602616,53353092,60),(6602616,53353108,61),(6602616,53353111,62),(6602616,53353121,63),(6602616,53353126,64),(6602616,53353132,65),(6602616,53353137,66),(6602616,53352638,67),(6620914,51563374,1),(6620914,53368914,2),(6620914,53368899,3),(6620917,53368914,1),(6620917,53368953,2),(6620920,53368932,1),(6620920,53368942,2),(6620926,53368973,1),(6620926,53368998,2),(6620926,53369007,3),(6620926,53369015,4),(6620926,53369038,5),(6620926,53370808,6),(6620926,53370819,7),(6620926,53370838,8),(6620926,53370844,9),(6620926,53370871,10),(6620926,53370880,11),(6620926,53370887,12),(6620926,53370890,13),(6620926,53370895,14),(6620926,53370900,15),(6620926,53370906,16),(6620926,53370914,17),(6620926,53370920,18),(6620926,53370935,19),(6620926,53370942,20),(6620926,53370949,21),(6620926,53370956,22),(6620926,53370959,23),(6620926,53371037,24),(6620926,53371050,25),(6620926,53371067,26),(6620926,53371073,27),(6620926,53371079,28),(6620926,53371084,29),(6620926,53371089,30),(6620926,53371093,31),(6620926,53371101,32),(6620926,53371106,33),(6620926,53371115,34),(6620926,53371121,35),(6620926,53371129,36),(6620930,53371804,1),(6620930,53371810,2),(6620930,53371816,3),(6620930,53371823,4),(6620930,53371827,5),(6620930,53371833,6),(6620930,53371840,7),(6620930,53371845,8),(6620930,53371850,9),(6620930,53371856,10),(6620930,53371859,11),(6620940,53377151,1),(6620940,53381779,2),(6620940,53381738,3),(6620940,53381733,4),(6620940,53381723,5),(6620940,53381711,6),(6620940,53380503,7),(6620940,53380499,8),(6620940,53380491,9),(6620940,53380489,10),(6620940,53380485,11),(6620940,53380480,12),(6620940,53380473,13),(6620940,53377195,14),(6620940,53377191,15),(6620940,53377186,16),(6620940,53377183,17),(6620940,367683366,18),(6620940,53377180,19),(6620940,53377178,20),(6620940,53377175,21),(6620940,53377168,22),(6620940,53377163,23),(6620940,53377156,24),(6620940,53377151,25),(6620940,53377146,26),(6620940,53377141,27),(6620940,53377138,28),(6620940,53377133,29),(6620940,53377128,30),(6620940,53377124,31),(6620940,321683544,32),(6620940,53377119,33),(6620940,53377113,34),(6620940,53377104,35),(6620940,53377098,36),(6620940,53377093,37),(6620940,53377090,38),(6620940,53377080,39),(6620940,53377077,40),(6620940,53377070,41),(6620940,53377068,42),(6620940,53377065,43),(6620940,53377061,44),(6620940,53377058,45),(6620940,53377053,46),(6620940,53377051,47),(6620940,53377049,48),(6620940,53377047,49),(6620940,53377045,50),(6620940,53377040,51),(6620940,53377035,52),(6620940,53377032,53),(6620940,53377027,54),(6620940,53377021,55),(6620940,53377018,56),(6620940,53377015,57),(6620940,53377009,58),(6620940,53377006,59),(6620940,53377001,60),(6620940,53376996,61),(6620940,53376989,62),(6620940,53376987,63),(6620940,53376983,64),(6620940,53376979,65),(6620940,53376975,66),(6620940,53376972,67),(6620940,53376968,68),(6620940,53376955,69),(6620940,53376959,70),(6620940,53376962,71),(6620940,53376964,72),(6620947,53382002,1),(6620947,53381787,2),(6620947,53381798,3),(6620947,53381809,4),(6620947,53381818,5),(6620947,53381825,6),(6620947,53381829,7),(6620947,53381832,8),(6620947,53381834,9),(6620947,53381837,10),(6620947,53381842,11),(6620947,53381844,12),(6620947,53381850,13),(6620947,53381892,14),(6620947,53381925,15),(6620947,53381944,16),(6620947,53381947,17),(6620947,53381978,18),(6620947,53381995,19),(6620947,53382002,20),(6620952,53383424,1),(6620952,53383364,2),(6620952,53383369,3),(6620952,53383373,4),(6620952,53383379,5),(6620952,53383384,6),(6620952,53383388,7),(6620952,53383393,8),(6620952,53383398,9),(6620952,53383403,10),(6620952,53383409,11),(6620952,53383415,12),(6620952,53383419,13),(6620952,53383424,14),(6620955,53383474,1),(6620955,53383480,2),(6620955,53383487,3),(6620955,53383494,4),(6620955,53383497,5),(6620955,53383499,6),(6620955,53383505,7),(6620955,53383508,8),(6620955,53383523,9),(6620955,53383429,10),(6620955,53383434,11),(6620955,53383440,12),(6620955,53383445,13),(6620955,53383451,14),(6620955,53383455,15),(6620955,53383459,16),(6620955,53383468,17),(6620955,53383474,18),(6620958,53383582,1),(6620958,53383584,2),(6620958,53383597,3),(6620958,53383600,4),(6620958,53383603,5),(6620958,53383605,6),(6620958,53383606,7),(6620958,53383610,8),(6620958,53383612,9),(6620958,53383614,10),(6620958,53383617,11),(6620958,53383620,12),(6620958,53383622,13),(6620958,53383624,14),(6620958,53383626,15),(6620958,53383628,16),(6620958,53383631,17),(6620958,53383634,18),(6620958,53383636,19),(6620958,53383556,20),(6620958,53383559,21),(6620958,53383561,22),(6620958,53383562,23),(6620958,53383566,24),(6620958,53383579,25),(6620958,53383582,26),(6620962,53383728,1),(6620962,53383735,2),(6620962,53383739,3),(6620962,53383762,4),(6620962,53383772,5),(6620962,53383793,6),(6620962,53383842,7),(6620962,53383953,8),(6620962,53383956,9),(6620962,53383639,10),(6620962,53383643,11),(6620962,53383646,12),(6620962,53383670,13),(6620962,53383680,14),(6620962,53383685,15),(6620962,53383688,16),(6620962,53383691,17),(6620962,53383694,18),(6620962,53383698,19),(6620962,53383728,20),(6620964,53384026,1),(6620964,53383958,2),(6620964,53383961,3),(6620964,53383970,4),(6620964,53383987,5),(6620964,53383990,6),(6620964,53384000,7),(6620964,53384003,8),(6620964,53384008,9),(6620964,53384011,10),(6620964,53384013,11),(6620964,53384016,12),(6620964,53384020,13),(6620964,53384024,14),(6620964,53384026,15),(6620969,53384030,1),(6620969,53384033,2),(6620969,53384036,3),(6620969,53384038,4),(6620969,53384040,5),(6620969,53384065,6),(6620969,53384068,7),(6620969,53384120,8),(6620969,53384283,9),(6620969,53384287,10),(6620969,53384302,11),(6620969,53384325,12),(6620969,53384330,13),(6620969,53384332,14),(6620969,53384335,15),(6620969,53384338,16),(6620969,53384375,17),(6620969,53385461,18),(6620969,53385467,19),(6620969,53385484,20),(6620969,53385511,21),(6620969,53387182,22),(6620969,53388340,23),(6620969,53388543,24),(6620969,53389302,25),(6620969,53389827,26),(6620969,53390266,27),(6620969,53390450,28),(6620969,53390493,29),(6620969,53390505,30),(6620969,53390513,31),(6620969,53390521,32),(6620969,53390534,33),(6620969,53390548,34),(6620969,53390624,35),(6620969,53390658,36),(6620969,53390732,37),(6620969,53390740,38),(6620969,53390749,39),(6620969,53390776,40),(6620969,53384030,41),(6620973,53392141,1),(6620973,53390786,2),(6620973,53392096,3),(6620973,53392102,4),(6620973,53392109,5),(6620973,53392116,6),(6620973,53392136,7),(6620973,53392141,8),(6620978,53392200,1),(6620978,53392203,2),(6620978,53392147,3),(6620978,53392151,4),(6620978,53392160,5),(6620978,53392164,6),(6620978,53392166,7),(6620978,53392168,8),(6620978,53392180,9),(6620978,53392185,10),(6620978,53392195,11),(6620978,53392200,12),(6620980,53392235,1),(6620980,53392239,2),(6620980,53392207,3),(6620980,53392208,4),(6620980,53392215,5),(6620980,53392222,6),(6620980,53392224,7),(6620980,53392227,8),(6620980,53392235,9),(7934428,59015921,1),(7934428,59015924,2),(7934428,59015925,3),(7934428,59015926,4),(7934428,59015927,5),(7934428,59015928,6),(7934428,59015929,7),(7934428,59015930,8),(7934428,59015931,9),(7934428,59015932,10),(7934428,59015933,11),(7934428,59015934,12),(7934443,59016173,1),(7934443,59016174,2),(7934443,59016175,3),(7934443,59015926,4),(8164186,45161333,1),(8164186,45161330,2),(8164186,45161344,3),(8164186,45161251,4),(8164186,45161256,5),(8164186,45161262,6),(8164186,45161227,7),(8164186,45161231,8),(8164186,45161233,9),(8164186,45161238,10),(8164186,45161289,11),(8164186,45161296,12),(8164186,45161302,13),(8164186,45161308,14),(8164186,45161265,15),(8164186,45161269,16),(8164186,45161277,17),(8164186,45161283,18),(8164186,45161067,19),(8164186,45161066,20),(8164186,45161062,21),(8164186,45161058,22),(8164186,45161208,23),(8164186,45161204,24),(8164186,45160922,25),(8164186,45160924,26),(8164186,45160974,27),(8164186,45160977,28),(8164186,45160962,29),(8164186,45160967,30),(8164186,45160954,31),(8164186,45160958,32),(8164452,52166749,1),(8164452,52166950,2),(8164478,52263727,1),(8164478,52263678,2),(8164478,52263677,3),(8164597,52650659,1),(8164597,52650158,2),(8164597,52650131,3),(8164597,52652477,4),(8164597,52652555,5),(8164597,52661498,6),(8164597,52672004,7),(8164597,52672499,8),(8164597,52675912,9),(8164597,52676235,10),(8164597,52676253,11),(8164597,52676260,12),(8164597,52676267,13),(8164597,52676295,14),(8164597,52676338,15),(8164597,52676349,16),(8164597,52676434,17),(8164597,52676891,18),(8164597,52676911,19),(8164597,52677089,20),(8164597,52677154,21),(8164597,52677211,22),(8164597,52677635,23),(8164597,52677662,24),(8164597,52677757,25),(8164597,52677811,26),(8164597,52677844,27),(8164597,52677862,28),(8164597,52677872,29),(8164597,52677878,30),(8164597,52677908,31),(8164597,52677912,32),(8164597,52677918,33),(8164597,52677922,34),(8164597,52677929,35),(8164597,52677934,36),(8164597,52677939,37),(8164597,52677945,38),(8164597,52677993,39),(8164597,52678005,40),(8164597,52678200,41),(8164597,52678225,42),(8164597,52678243,43),(8164597,52678266,44),(8164597,52678278,45),(8164597,52678285,46),(8164597,52678294,47),(8164597,52678450,48),(8164597,52678519,49),(8164597,52678582,50),(8164597,52678634,51),(8164597,52678741,52),(8164597,52678786,53),(8164597,52678860,54),(8164597,52679237,55),(8164597,52679255,56),(8164597,52679261,57),(8164597,52679265,58),(8164597,52679271,59),(8164597,52679365,60),(8164597,52679445,61),(8164597,52679499,62),(8164597,52679531,63),(8164597,52679731,64),(8164597,52679744,65),(8164597,52679804,66),(8164597,52679809,67),(8164597,52679815,68),(8164597,52679821,69),(8164597,52679879,70),(8164597,52679882,71),(8164597,52679888,72),(8164597,52679894,73),(8164597,52679900,74),(8164597,52679906,75),(8164597,52679911,76),(8164597,52679979,77),(8164597,52679994,78),(8164597,52680005,79),(8164597,52680012,80),(8164597,52680017,81),(8164597,52680024,82),(8164597,52680029,83),(8164597,52680039,84),(8164597,52680048,85),(8164597,52680059,86),(8164597,52680077,87),(8164597,52680086,88),(8164597,52680095,89),(8164597,52680105,90),(8164597,52680117,91),(8164597,52680128,92),(8164597,52680141,93),(8164597,52680157,94),(8164597,52680171,95),(8164597,52680195,96),(8164597,52680202,97),(8164597,52680255,98),(8164597,52680269,99),(8164597,52680280,100),(8164597,52680289,101),(8164597,52680402,102),(8164597,52680426,103),(8164597,52680437,104),(8164597,52680448,105),(8164597,52680465,106),(8164597,52680561,107),(8164597,52680566,108),(8164597,52680570,109),(8164597,52680574,110),(8164597,52680577,111),(8164597,52680579,112),(8164597,52680583,113),(8164597,52680592,114),(8164597,52680597,115),(8164597,52680599,116),(8164597,52680606,117),(8164597,52680610,118),(8164597,52680616,119),(8164597,52680618,120),(8164597,52680624,121),(8164597,52680637,122),(8164597,52680643,123),(8164597,52680648,124),(8164597,52680653,125),(8164597,52680657,126),(8164597,52680660,127),(8164597,52680663,128),(8164597,52680674,129),(8164597,52680676,130),(8164597,52680679,131),(8164597,52680683,132),(8164597,52680692,133),(8164597,52680695,134),(8164597,52680698,135),(8164597,52680703,136),(8164597,52680706,137),(8164597,52680712,138),(8164597,52680715,139),(8164597,52680717,140),(8164597,52680719,141),(8164597,52680722,142),(8164597,52680727,143),(8164597,52680731,144),(8164597,52680735,145),(8164597,52680736,146),(8164597,52680739,147),(8164597,52680744,148),(8164597,52680747,149),(8164597,52680751,150),(8164597,52680753,151),(8164597,52680755,152),(8164597,52680757,153),(8164597,52680759,154),(8164597,52680760,155),(8164597,52680763,156),(8164597,52680767,157),(8164597,52680769,158),(8164597,52680773,159),(8164597,52680776,160),(8164597,52680780,161),(8164597,52680782,162),(8164597,52680784,163),(8164597,52680787,164),(8164597,52680789,165),(8164597,52680794,166),(8164597,52680797,167),(8164597,52680799,168),(8164597,52680803,169),(8164597,52680806,170),(8164597,52680810,171),(8164597,52680813,172),(8164597,52680815,173),(8164597,52680818,174),(8164597,52680820,175),(8164597,52680823,176),(8164597,52680825,177),(8164597,52680828,178),(8164597,52680830,179),(8164597,52680832,180),(8164597,52680836,181),(8164597,52680838,182),(8164597,52680839,183),(8164597,52680842,184),(8164597,52680844,185),(8164597,52680847,186),(8164597,52680850,187),(8164597,52680852,188),(8164597,52680855,189),(8164597,52680858,190),(8164597,52680860,191),(8164597,52680866,192),(8164597,52680869,193),(8164597,52680871,194),(8164597,52680874,195),(8164597,52680877,196),(8164597,52680879,197),(8164597,52680883,198),(8164597,52680913,199),(8164597,52680960,200),(8164597,52681009,201),(8164597,52681026,202),(8164597,52681028,203),(8164597,52681343,204),(8164597,52681347,205),(8164597,52681350,206),(8164597,52681355,207),(8164597,52681357,208),(8164597,52681361,209),(8164597,52681362,210),(8164597,52681366,211),(8164597,52681368,212),(8164597,52681372,213),(8164597,52681374,214),(8164597,52681375,215),(8164597,52681378,216),(8164597,52681380,217),(8164597,52681382,218),(8164597,52681384,219),(8164597,52681386,220),(8164597,52681390,221),(8164597,52681392,222),(8164597,52681393,223),(8164597,52681394,224),(8164597,52681395,225),(8164597,52681398,226),(8164597,52681400,227),(8164597,52681405,228),(8164597,52681407,229),(8164597,52681409,230),(8164597,52681412,231),(8164597,52681429,232),(8164597,52681414,233),(8164597,52681416,234),(8164597,52681417,235),(8164597,52681420,236),(8164597,52681422,237),(8164597,52681423,238),(8164597,52681431,239),(8164597,52681425,240),(8164597,52681427,241),(8164597,52681432,242),(8164597,52681434,243),(8164597,52681439,244),(8164597,52681462,245),(8164597,52681464,246),(8164597,52681465,247),(8164597,52681466,248),(8164597,52681468,249),(8164597,52681471,250),(8164597,52681474,251),(8164597,52681476,252),(8164597,52681478,253),(8164597,52681481,254),(8164597,52681484,255),(8164597,52681487,256),(8164597,52681492,257),(8164597,52681493,258),(8164597,52681496,259),(8164597,52681499,260),(8164597,52681500,261),(8164597,52681503,262),(8164597,52681508,263),(8164597,52681510,264),(8164597,52681511,265),(8164597,52681514,266),(8164597,52681516,267),(8164597,52681518,268),(8164597,52681521,269),(8164597,52681526,270),(8164597,52681528,271),(8164597,52681531,272),(8164597,52681533,273),(8164597,52681535,274),(8164597,52681537,275),(8164597,52681539,276),(8164597,52681541,277),(8164597,52681544,278),(8164597,52681547,279),(8164597,52681576,280),(8164597,52681551,281),(8164597,52681571,282),(8164597,52681553,283),(8164597,52681557,284),(8164597,52681568,285),(8164597,52681578,286),(8164597,52681582,287),(8164597,52681586,288),(8164597,52681589,289),(8164597,52681593,290),(8164597,52681596,291),(8164597,52681598,292),(8164597,52681600,293),(8164597,52681603,294),(8164597,52681605,295),(8164597,52681608,296),(8164597,52681610,297),(8164597,52681613,298),(8164597,52681615,299),(8164597,52681619,300),(8164597,52681648,301),(8164597,52681683,302),(8164597,52681949,303),(8164597,52682060,304),(8164597,52682050,305),(8164597,52682055,306),(8164597,52682039,307),(8164597,52682044,308),(8164597,52682047,309),(8164597,52682065,310),(8164597,52682068,311),(8164597,52682070,312),(8164597,52682072,313),(8164597,52682091,314),(8164597,52682096,315),(8164597,52682101,316),(8164597,52682123,317),(8164597,52682126,318),(8164597,52682128,319),(8164597,52682132,320),(8164597,52682135,321),(8164597,52682140,322),(8164597,52682143,323),(8164597,52682146,324),(8164597,52682150,325),(8164597,52682152,326),(8164597,52682156,327),(8164597,52682160,328),(8164597,52682164,329),(8164597,52682168,330),(8164597,52682170,331),(8164597,52682174,332),(8164597,52682178,333),(8164597,52682180,334),(8164597,52682184,335),(8164597,52682186,336),(8164597,52682190,337),(8164597,52682195,338),(8164597,52682197,339),(8164597,52682200,340),(8164597,52682202,341),(8164597,52682215,342),(8164597,52682204,343),(8164597,52682216,344),(8164597,52682207,345),(8164597,52682210,346),(8164597,52682212,347),(8164597,52682221,348),(8164597,52682224,349),(8164597,52682227,350),(8164597,52682231,351),(8164597,52682235,352),(8164597,52682238,353),(8164597,52682240,354),(8164597,52682243,355),(8164597,52682244,356),(8164597,52682247,357),(8164597,52682250,358),(8164597,52682253,359),(8164597,52682255,360),(8164597,52682257,361),(8164597,52682259,362),(8164597,52682262,363),(8164597,52682265,364),(8164597,52682270,365),(8164597,52682272,366),(8164597,52682274,367),(8164597,52682277,368),(8164597,52682524,369),(8164597,52682546,370),(8164597,52682558,371),(8164597,52682617,372),(8164597,52682663,373),(8164597,52682673,374),(8164597,52685135,375),(8164597,52685138,376),(8164597,52685142,377),(8164597,52685145,378),(8164597,52685147,379),(8164597,52685151,380),(8164597,52685154,381),(8164597,52685157,382),(8164597,52685160,383),(8164597,52685162,384),(8164597,52685166,385),(8164597,52685169,386),(8164597,52685171,387),(8164597,52685184,388),(8164597,52685190,389),(8164597,52685195,390),(8164597,52685199,391),(8164597,52685202,392),(8164597,52685204,393),(8164597,52685207,394),(8164597,52685211,395),(8164597,52685217,396),(8164597,52685220,397),(8164597,52685226,398),(8164597,52685229,399),(8164597,52685232,400),(8164597,52685236,401),(8164597,52685238,402),(8164597,52685243,403),(8164597,52685247,404),(8164597,52685258,405),(8164597,52685262,406),(8164597,52685269,407),(8164597,52685275,408),(8164597,52685277,409),(8164597,52685282,410),(8164597,52685296,411),(8164597,52685299,412),(8164597,52685307,413),(8164597,52685313,414),(8164653,52801807,1),(8164653,52801809,2),(8164653,52801813,3),(8164653,52801816,4),(8164653,52801819,5),(8164653,52801824,6),(8164653,52801827,7),(8164653,52801876,8),(8164653,52802034,9),(8164653,52802158,10),(8164653,52802159,11),(8164653,52802160,12),(8164653,52802161,13),(8164653,52802162,14),(8164653,52802163,15),(8164653,52802164,16),(8164653,52802165,17),(8164653,52802166,18),(8164653,52802167,19),(8164653,52803327,20),(8164653,52802168,21),(8164653,52802169,22),(8164653,52802170,23),(8164653,52802171,24),(8164653,52802172,25),(8164653,52802173,26),(8164653,52802183,27),(8164653,52802197,28),(8164653,52802210,29),(8164653,52802216,30),(8164653,52802218,31),(8164653,52802229,32),(8164653,52802260,33),(8164653,52803163,34),(8164653,52803175,35),(8164653,52803179,36),(8164653,52803182,37),(8164653,52803183,38),(8164653,52803186,39),(8164653,52803189,40),(8164653,52803191,41),(8164653,52803194,42),(8164653,52803195,43),(8164653,52803196,44),(8164653,52803197,45),(8164653,52803198,46);
INSERT INTO `current_way_nodes` VALUES (8164653,52803200,47),(8164653,52803201,48),(8164653,52803202,49),(8164653,52803205,50),(8164653,52803207,51),(8164653,52803211,52),(8164653,52803214,53),(8164653,52803216,54),(8164653,52803218,55),(8164653,52803220,56),(8164653,52803222,57),(8164653,52803224,58),(8164653,52803225,59),(8164653,52803228,60),(8164653,52803229,61),(8164653,52803233,62),(8164653,52803235,63),(8164653,52803237,64),(8164653,52803239,65),(8164653,52803241,66),(8164653,52803243,67),(8164653,52803247,68),(8164653,52803251,69),(8164653,52803254,70),(8164653,52803255,71),(8164653,52803259,72),(8164653,52803263,73),(8164653,52803266,74),(8164653,52803269,75),(8164653,52803271,76),(8164653,52803273,77),(8166678,57627518,1),(8166678,57627519,2),(8166678,57627521,3),(8166678,57603545,4),(8166678,57603546,5),(8166678,57603547,6),(8166678,57603548,7),(8166678,57603549,8),(8166678,57603550,9),(8166678,57603551,10),(8166678,57603552,11),(8166678,57603553,12),(8166678,57603554,13),(8166678,57603555,14),(8166678,57603556,15),(8166678,57603557,16),(8166678,57603559,17),(8166678,57603560,18),(8166678,57603561,19),(8166678,57603562,20),(8166678,57603563,21),(8166678,57603564,22),(8166678,57603565,23),(8166678,57603566,24),(8166678,57603567,25),(8166678,57603568,26),(8166678,57603569,27),(8166678,57603570,28),(8166678,57603571,29),(8166678,57603572,30),(8166678,57603573,31),(8166678,57603574,32),(8166678,57603575,33),(8166678,57603994,34),(8166678,57603995,35),(8166678,57603996,36),(8166678,57603997,37),(8166678,57603998,38),(8166678,57603999,39),(8166678,57604000,40),(8166678,57604001,41),(8166678,57604002,42),(8166678,57604003,43),(8166678,57604004,44),(8166678,57604005,45),(8166678,57604006,46),(8166678,57607196,47),(8166678,57607197,48),(8166678,57607198,49),(8166678,57607199,50),(8166678,57607200,51),(8166678,57607201,52),(8166678,57607202,53),(8166678,57607203,54),(8166678,57607204,55),(8166678,57607205,56),(8166678,57607206,57),(8166678,57608723,58),(8166678,57608724,59),(8166678,57608725,60),(8166678,57608726,61),(8166678,57608727,62),(8166678,57608728,63),(8166678,57608729,64),(8166678,57608730,65),(8166678,57608731,66),(8166678,57608732,67),(8166678,57608735,68),(8166678,57608736,69),(8166678,57608737,70),(8166678,57608738,71),(8166678,57608739,72),(8166678,57608740,73),(8166678,57608741,74),(8166678,57608742,75),(8166678,57608743,76),(8166678,57608744,77),(8166678,57608745,78),(8166678,57608746,79),(8166678,57608748,80),(8166678,57608750,81),(8166678,57608751,82),(8166678,57608752,83),(8166678,57608754,84),(8166678,57608755,85),(8166678,57608756,86),(8166678,57608757,87),(8166678,57608758,88),(8166678,57608759,89),(8166678,57608760,90),(8166678,57608761,91),(8166678,57608762,92),(8166678,57608763,93),(8166678,57608764,94),(8166678,57608765,95),(8166678,57608766,96),(8166678,57608767,97),(8166678,57608768,98),(8166678,57608769,99),(8166678,57608770,100),(8166678,57608771,101),(8166678,57608772,102),(8166678,57608774,103),(8166678,57608776,104),(8166678,57608777,105),(8166678,57608778,106),(8166678,57611874,107),(8166678,57611875,108),(8166678,57611876,109),(8166678,57611877,110),(8166678,57611878,111),(8166678,57611879,112),(8166678,57611880,113),(8166678,57611881,114),(8166678,57611882,115),(8166678,57611883,116),(8166678,57611884,117),(8166678,57611885,118),(8166678,57611886,119),(8166678,57611887,120),(8166678,57611888,121),(8166678,57611889,122),(8166678,57611890,123),(8166678,57611891,124),(8166678,57611783,125),(8561013,52009151,1),(8561013,52009154,2),(8561432,51386298,1),(8561432,52252330,2),(8667300,53383297,1),(8667300,53383289,2),(8667300,53383286,3),(8667300,53383280,4),(8667300,53383258,5),(8667300,53383242,6),(8667300,53383168,7),(8667300,53382959,8),(8667300,53382509,9),(8667300,53382504,10),(8667300,53382318,11),(8667300,53382223,12),(8667300,53382156,13),(8667300,53382126,14),(8667300,53382106,15),(8667300,53382089,16),(8667300,53382064,17),(8667300,53382059,18),(8667300,53382055,19),(8667300,53382052,20),(8667300,53382047,21),(8667300,53382044,22),(8667300,53382041,23),(8667300,53382033,24),(8667300,53382028,25),(8667300,53382019,26),(8667300,53382009,27),(8667300,53383356,28),(8667300,53383350,29),(8667300,53383341,30),(8667300,53383336,31),(8667300,53383324,32),(8667300,53383321,33),(8667300,53383310,34),(8667300,53383297,35),(8880951,51111226,1),(8880951,51111228,2),(8880951,51111229,3),(8880951,51111231,4),(8880951,51111232,5),(8880951,51111234,6),(8880951,51111236,7),(8880951,51111238,8),(8880951,51111239,9),(8880951,51111241,10),(8880951,52009107,11),(8880951,52009103,12),(8880951,52009105,13),(8880951,51111244,14),(8880951,51111245,15),(8880951,51111247,16),(8880951,51111248,17),(8880951,51111250,18),(8880951,51111251,19),(8880951,51111253,20),(8880951,51111254,21),(8880951,51111256,22),(8880951,51111257,23),(8880951,51111259,24),(8880951,52648164,25),(8880951,51111260,26),(8880951,51111262,27),(8880951,51111263,28),(8880951,51111265,29),(8880951,51111266,30),(8880951,51111268,31),(8880951,51111270,32),(8880951,51111271,33),(8880951,51111273,34),(8880951,51358786,35),(8880951,51358788,36),(8880951,51358789,37),(8880951,51358791,38),(8880951,51358792,39),(8880951,51358793,40),(8880951,51358794,41),(8880951,51358795,42),(8880951,51358797,43),(8880951,51358798,44),(8880951,51358800,45),(8880951,51358802,46),(8880951,51358803,47),(8880951,51357551,48),(8880951,51357550,49),(8880951,51357549,50),(8880951,51357547,51),(8880951,51357546,52),(8880951,51357544,53),(8880951,51357543,54),(8880951,51357542,55),(8880951,51357540,56),(8880951,51357539,57),(8880951,51357538,58),(8880951,51357335,59),(8880951,51357332,60),(8880951,51357330,61),(8880951,51357329,62),(8880951,51357328,63),(8880951,51357326,64),(8880951,51357323,65),(8880951,51357320,66),(8880951,51357319,67),(8880951,51357317,68),(8880951,51357315,69),(8880951,59632226,70),(8880951,51357313,71),(8880951,51357312,72),(8880951,51357310,73),(8880951,51357309,74),(8880951,51357308,75),(8880951,51357305,76),(8880951,51357303,77),(8880951,51357300,78),(8880951,51357298,79),(8880951,51357297,80),(8880951,51357295,81),(8880951,51357293,82),(8880951,51357292,83),(8880951,51357291,84),(8880951,51357288,85),(8880951,51357287,86),(8880951,51357285,87),(8880951,51357282,88),(8880951,51357281,89),(8880951,51357279,90),(8880951,51357277,91),(8880951,51357276,92),(8880951,51357275,93),(8880951,51357274,94),(8880951,51357272,95),(8880951,51357270,96),(8880951,51357269,97),(8880951,51357268,98),(8880951,51357265,99),(8880951,51357264,100),(8880951,51357261,101),(8880951,51357260,102),(8880951,51357259,103),(8880951,51357256,104),(8880951,51357255,105),(8880951,51357019,106),(8880951,51357018,107),(8880951,51357016,108),(8880951,51357015,109),(8880951,51357013,110),(8880951,51357012,111),(8880951,51357011,112),(8880951,51357010,113),(8880951,51357009,114),(8880951,51357008,115),(8880951,51357007,116),(8880951,51357006,117),(8880951,51357004,118),(8880951,51357003,119),(8880951,51357002,120),(8880951,51357000,121),(8880951,51356999,122),(8880951,51356998,123),(8880951,51356997,124),(8880951,51356995,125),(8880951,51356994,126),(8880951,51356992,127),(8880951,51356991,128),(8880951,51356988,129),(8880951,51356987,130),(8880951,51356986,131),(8880951,51356985,132),(8880951,51356983,133),(8880951,51356982,134),(8880951,51356981,135),(8880951,51356979,136),(8880951,51356978,137),(8880951,51356977,138),(8880951,51356975,139),(8880951,51356974,140),(8880951,51356973,141),(8880951,51356972,142),(8880951,51356970,143),(8880951,51356969,144),(8880951,51356968,145),(8880951,51356967,146),(8880951,51356965,147),(8880951,52011242,148),(8880951,52011244,149),(8880951,52011249,150),(8880951,52011253,151),(8880951,52011256,152),(8880951,52011259,153),(8880951,51356964,154),(8880951,51356432,155),(8880951,52011238,156),(8880951,52011227,157),(8880951,52011234,158),(8880951,52011225,159),(8880951,52011231,160),(8880951,51356433,161),(8880951,51356434,162),(8880951,51356435,163),(8880951,51356437,164),(8880951,51356438,165),(8880951,51356439,166),(8880951,51356440,167),(8880951,51356442,168),(8880951,51356444,169),(8880951,51356445,170),(8880951,51356446,171),(8880951,51356448,172),(8880951,51356450,173),(8880951,51356451,174),(8880951,51356452,175),(8880951,51356454,176),(8880951,51356455,177),(8880951,51356457,178),(8880951,51356458,179),(8880951,51356460,180),(8880951,51356461,181),(8880951,51356462,182),(8880951,51356465,183),(8880951,51356466,184),(8880951,51356468,185),(8880951,51356469,186),(8880951,51356470,187),(8880951,51356471,188),(8880951,51356472,189),(8880951,51356473,190),(8880951,51356474,191),(8880951,51356475,192),(8880951,51356476,193),(8880951,51356477,194),(8880951,51356478,195),(8880951,51356479,196),(8880951,51356480,197),(8880951,51356481,198),(8880951,51356383,199),(8880951,51111214,200),(8880951,51111216,201),(8880951,51111218,202),(8880951,51111220,203),(8880951,51111222,204),(8880951,51111223,205),(8880951,51111226,206),(8880952,51357960,1),(8880952,52002278,2),(8880952,51357962,3),(8880952,51357963,4),(8880952,51357965,5),(8880952,51357966,6),(8880952,51357967,7),(8880952,51357969,8),(8880952,51357971,9),(8880952,51357972,10),(8880952,51357973,11),(8880952,51357975,12),(8880952,51357977,13),(8880952,51357978,14),(8880952,51357980,15),(8880952,51357981,16),(8880952,51357983,17),(8880952,51357984,18),(8880952,51357986,19),(8880952,51357988,20),(8880952,51357989,21),(8880952,51357991,22),(8880952,51357993,23),(8880952,51357994,24),(8880952,51357995,25),(8880952,51357997,26),(8880952,51358000,27),(8880952,51358001,28),(8880952,51358002,29),(8880952,51358003,30),(8880952,51358004,31),(8880952,51358005,32),(8880952,51358007,33),(8880952,51358008,34),(8880952,51358009,35),(8880952,51358011,36),(8880952,51358013,37),(8880952,51358015,38),(8880952,51358016,39),(8880952,51358018,40),(8880952,51358019,41),(8880952,51358021,42),(8880952,51358023,43),(8880952,51358025,44),(8880952,51357573,45),(8880952,51357571,46),(8880952,51357570,47),(8880952,51357568,48),(8880952,51357567,49),(8880952,51357566,50),(8880952,51357564,51),(8880952,51357562,52),(8880952,51357561,53),(8880952,51357560,54),(8880952,51357558,55),(8880952,51357557,56),(8880952,51357556,57),(8880952,51357554,58),(8880952,51357552,59),(8880952,51357551,60),(8880952,51358803,61),(8880952,51358805,62),(8880952,51358806,63),(8880952,51358807,64),(8880952,51358809,65),(8880952,51358810,66),(8880952,51358811,67),(8880952,51358812,68),(8880952,51358813,69),(8880952,51358814,70),(8880952,51358815,71),(8880952,51358816,72),(8880952,51358818,73),(8880952,51358819,74),(8880952,51358820,75),(8880952,51358821,76),(8880952,51358823,77),(8880952,51358824,78),(8880952,51358825,79),(8880952,51358827,80),(8880952,51358829,81),(8880952,51358832,82),(8880952,51358837,83),(8880952,51358838,84),(8880952,51358839,85),(8880952,51358840,86),(8880952,51358841,87),(8880952,51358842,88),(8880952,51358843,89),(8880952,51358845,90),(8880952,51358847,91),(8880952,51358848,92),(8880952,51358849,93),(8880952,51358850,94),(8880952,51358851,95),(8880952,51358852,96),(8880952,51358853,97),(8880952,51358854,98),(8880952,51358856,99),(8880952,51358858,100),(8880952,52002281,101),(8880952,51358859,102),(8880952,51358861,103),(8880952,51358862,104),(8880952,51358863,105),(8880952,51359239,106),(8880952,51359241,107),(8880952,51359242,108),(8880952,51359243,109),(8880952,51359245,110),(8880952,51359246,111),(8880952,51359247,112),(8880952,51359249,113),(8880952,52002275,114),(8880952,51359251,115),(8880952,52002272,116),(8880952,51359252,117),(8880952,51359253,118),(8880952,52002261,119),(8880952,51359255,120),(8880952,51359256,121),(8880952,52002259,122),(8880952,52002258,123),(8880952,52002256,124),(8880952,51359257,125),(8880952,51359259,126),(8880952,51359260,127),(8880952,51359261,128),(8880952,51359262,129),(8880952,51359264,130),(8880952,51359265,131),(8880952,51359266,132),(8880952,51359268,133),(8880952,51359269,134),(8880952,51359271,135),(8880952,51359272,136),(8880952,52002247,137),(8880952,51359274,138),(8880952,52002244,139),(8880952,51359275,140),(8880952,51359276,141),(8880952,51359278,142),(8880952,52002241,143),(8880952,51359279,144),(8880952,52002238,145),(8880952,52002235,146),(8880952,51359280,147),(8880952,51359281,148),(8880952,51359283,149),(8880952,51359284,150),(8880952,51359285,151),(8880952,51359287,152),(8880952,51359288,153),(8880952,51359290,154),(8880952,51359291,155),(8880952,51359292,156),(8880952,51359293,157),(8880952,51359295,158),(8880952,51359296,159),(8880952,51359297,160),(8880952,51359299,161),(8880952,51359302,162),(8880952,51359303,163),(8880952,51359304,164),(8880952,51359305,165),(8880952,64796339,166),(8880952,64796338,167),(8880952,51359307,168),(8880952,51359782,169),(8880952,51359783,170),(8880952,51359784,171),(8880952,51359785,172),(8880952,51359786,173),(8880952,51359787,174),(8880952,51359788,175),(8880952,51359789,176),(8880952,51359790,177),(8880952,51359793,178),(8880952,51358396,179),(8880952,264290442,180),(8880952,51358398,181),(8880952,51358399,182),(8880952,51358401,183),(8880952,51358402,184),(8880952,51358404,185),(8880952,51358405,186),(8880952,51358407,187),(8880952,51358408,188),(8880952,51358409,189),(8880952,51358411,190),(8880952,51358412,191),(8880952,51358414,192),(8880952,51358415,193),(8880952,52002253,194),(8880952,51358417,195),(8880952,52002251,196),(8880952,51358418,197),(8880952,52002248,198),(8880952,51358419,199),(8880952,51358421,200),(8880952,51358423,201),(8880952,51358424,202),(8880952,51358425,203),(8880952,51358427,204),(8880952,51358428,205),(8880952,51358430,206),(8880952,51357949,207),(8880952,51357951,208),(8880952,51357953,209),(8880952,51357954,210),(8880952,51357955,211),(8880952,51357956,212),(8880952,52002266,213),(8880952,51357958,214),(8880952,52002264,215),(8880952,51357959,216),(8880952,52002269,217),(8880952,51357960,218),(8880953,52031077,1),(8880953,52031076,2),(8880953,52031059,3),(8880953,52031056,4),(8880953,52031054,5),(8880953,52031050,6),(8880953,52031046,7),(8880953,52031043,8),(8880953,52031041,9),(8880953,52031039,10),(8880953,52031036,11),(8880953,52031034,12),(8880953,52031030,13),(8880953,52031013,14),(8880953,52031003,15),(8880953,51360246,16),(8880953,51359756,17),(8880953,52002219,18),(8880953,51359758,19),(8880953,52002220,20),(8880953,52002222,21),(8880953,51359760,22),(8880953,52002223,23),(8880953,52002226,24),(8880953,51359761,25),(8880953,52002231,26),(8880953,51359762,27),(8880953,52002229,28),(8880953,51359763,29),(8880953,51359764,30),(8880953,51359766,31),(8880953,51359769,32),(8880953,51359771,33),(8880953,51359772,34),(8880953,51359773,35),(8880953,51359774,36),(8880953,51359775,37),(8880953,51359776,38),(8880953,51359777,39),(8880953,51359778,40),(8880953,51359779,41),(8880953,51359780,42),(8880953,51359781,43),(8880953,51359782,44),(8880953,51359307,45),(8880953,51359308,46),(8880953,51359309,47),(8880953,51359310,48),(8880953,51359312,49),(8880953,51359313,50),(8880953,51359314,51),(8880953,51359316,52),(8880953,51359317,53),(8880953,51359318,54),(8880953,51359320,55),(8880953,51359322,56),(8880953,51359323,57),(8880953,51359324,58),(8880953,51359325,59),(8880953,51359327,60),(8880953,51359328,61),(8880953,51359330,62),(8880953,51359331,63),(8880953,52002204,64),(8880953,51359357,65),(8880953,52002206,66),(8880953,51359358,67),(8880953,52002209,68),(8880953,52002189,69),(8880953,52002211,70),(8880953,52002202,71),(8880953,52002212,72),(8880953,51359948,73),(8880953,52002198,74),(8880953,51359949,75),(8880953,52002214,76),(8880953,52002192,77),(8880953,52002216,78),(8880953,51359951,79),(8880953,52002196,80),(8880953,51359952,81),(8880953,51359953,82),(8880953,52031726,83),(8880953,52031730,84),(8880953,52031732,85),(8880953,52031736,86),(8880953,52031739,87),(8880953,52031742,88),(8880953,52031744,89),(8880953,52031746,90),(8880953,52031747,91),(8880953,52031749,92),(8880953,52031751,93),(8880953,52031756,94),(8880953,52031758,95),(8880953,52031761,96),(8880953,52031764,97),(8880953,52031767,98),(8880953,52031771,99),(8880953,52031774,100),(8880953,52031777,101),(8880953,52031782,102),(8880953,52031785,103),(8880953,52031789,104),(8880953,52031794,105),(8880953,52031798,106),(8880953,52031803,107),(8880953,52031805,108),(8880953,52031809,109),(8880953,52031811,110),(8880953,52031813,111),(8880953,52031815,112),(8880953,52031821,113),(8880953,52031823,114),(8880953,52031827,115),(8880953,52031830,116),(8880953,52031832,117),(8880953,52031834,118),(8880953,52031838,119),(8880953,52031840,120),(8880953,52031844,121),(8880953,52031847,122),(8880953,52031850,123),(8880953,52031855,124),(8880953,52031858,125),(8880953,52031861,126),(8880953,52031865,127),(8880953,52031866,128),(8880953,52031868,129),(8880953,52031871,130),(8880953,52031872,131),(8880953,52031874,132),(8880953,52031876,133),(8880953,52031881,134),(8880953,52031884,135),(8880953,52031886,136),(8880953,52031888,137),(8880953,52031889,138),(8880953,52031893,139),(8880953,52031894,140),(8880953,52031899,141),(8880953,52031901,142),(8880953,52031906,143),(8880953,52031908,144),(8880953,52031911,145),(8880953,52031913,146),(8880953,52031915,147),(8880953,52031919,148),(8880953,52031921,149),(8880953,52031925,150),(8880953,52031927,151),(8880953,52031930,152),(8880953,52031933,153),(8880953,52031936,154),(8880953,52031938,155),(8880953,52031943,156),(8880953,52031946,157),(8880953,52031948,158),(8880953,52031953,159),(8880953,52031956,160),(8880953,52031958,161),(8880953,52031962,162),(8880953,52031966,163),(8880953,52031968,164),(8880953,52031973,165),(8880953,52031976,166),(8880953,52031980,167),(8880953,52031984,168),(8880953,52031987,169),(8880953,52031990,170),(8880953,52031992,171),(8880953,52031995,172),(8880953,52031998,173),(8880953,52032000,174),(8880953,52032003,175),(8880953,52032007,176),(8880953,52032010,177),(8880953,52032012,178),(8880953,52032017,179),(8880953,52032018,180),(8880953,52032021,181),(8880953,52032022,182),(8880953,52032026,183),(8880953,52032029,184),(8880953,52032033,185),(8880953,52032035,186),(8880953,52032039,187),(8880953,52032041,188),(8880953,52032044,189),(8880953,52032047,190),(8880953,52032048,191),(8880953,52032051,192),(8880953,52032054,193),(8880953,52032057,194),(8880953,52032060,195),(8880953,52032064,196),(8880953,52032067,197),(8880953,52032070,198),(8880953,52032071,199),(8880953,52032075,200),(8880953,52032076,201),(8880953,52032078,202),(8880953,52032081,203),(8880953,52032085,204),(8880953,52032087,205),(8880953,52032090,206),(8880953,52032092,207),(8880953,52032093,208),(8880953,52032098,209),(8880953,52032100,210),(8880953,52032103,211),(8880953,52032107,212),(8880953,52032109,213),(8880953,52032112,214),(8880953,52032113,215),(8880953,52032116,216),(8880953,52032119,217),(8880953,52032122,218),(8880953,52032125,219),(8880953,52032127,220),(8880953,52032130,221),(8880953,52032133,222),(8880953,52032135,223),(8880953,52032137,224),(8880953,52032141,225),(8880953,52032145,226),(8880953,52032147,227),(8880953,52032150,228),(8880953,52032153,229),(8880953,52032158,230),(8880953,52032160,231),(8880953,52032162,232),(8880953,52032165,233),(8880953,52032168,234),(8880953,52032171,235),(8880953,52032174,236),(8880953,52032176,237),(8880953,52032179,238),(8880953,52032182,239),(8880953,52032183,240),(8880953,52032186,241),(8880953,52032187,242),(8880953,52032190,243),(8880953,52032192,244),(8880953,52032195,245),(8880953,52032197,246),(8880953,52032200,247),(8880953,52032204,248),(8880953,52032205,249),(8880953,52032208,250),(8880953,52032211,251),(8880953,52032212,252),(8880953,52032216,253),(8880953,52032219,254),(8880953,52032222,255),(8880953,52032225,256),(8880953,52032228,257),(8880953,52032233,258),(8880953,52032238,259),(8880953,52032241,260),(8880953,52032243,261),(8880953,52032246,262),(8880953,52032250,263),(8880953,52032249,264),(8880953,52031723,265),(8880953,52031720,266),(8880953,52031717,267),(8880953,52031715,268),(8880953,52031712,269),(8880953,52031709,270),(8880953,52031705,271),(8880953,52031702,272),(8880953,52031700,273),(8880953,52031695,274),(8880953,52031691,275),(8880953,52031688,276),(8880953,52031686,277),(8880953,52031681,278),(8880953,52031678,279),(8880953,52031676,280),(8880953,52031671,281),(8880953,52031668,282),(8880953,52031665,283),(8880953,52031660,284),(8880953,52031658,285),(8880953,52031656,286),(8880953,52031652,287),(8880953,52031648,288),(8880953,52031645,289),(8880953,52031642,290),(8880953,52031636,291),(8880953,52031634,292),(8880953,52031631,293),(8880953,52031627,294),(8880953,52031626,295),(8880953,52031621,296),(8880953,52031620,297),(8880953,52031617,298),(8880953,52031616,299),(8880953,52031614,300),(8880953,52031611,301),(8880953,52031608,302),(8880953,52031604,303),(8880953,52031600,304),(8880953,52031595,305),(8880953,52031592,306),(8880953,52031590,307),(8880953,52031587,308),(8880953,52031581,309),(8880953,52031580,310),(8880953,52031576,311),(8880953,52031572,312),(8880953,52031567,313),(8880953,52031562,314),(8880953,52031560,315),(8880953,52031554,316),(8880953,52031552,317),(8880953,52031550,318),(8880953,52031545,319),(8880953,52031540,320),(8880953,52031535,321),(8880953,52031532,322),(8880953,52031529,323),(8880953,52031527,324),(8880953,52031523,325),(8880953,52031521,326),(8880953,52031517,327),(8880953,52031514,328),(8880953,52031512,329),(8880953,52031507,330),(8880953,52031504,331),(8880953,52031500,332),(8880953,52031498,333),(8880953,52031494,334),(8880953,52031491,335),(8880953,52031486,336),(8880953,52031483,337),(8880953,52031481,338),(8880953,52031477,339),(8880953,52031471,340),(8880953,52031467,341),(8880953,52031464,342),(8880953,52031461,343),(8880953,52031456,344),(8880953,52031449,345),(8880953,52031446,346),(8880953,52031441,347),(8880953,52031438,348),(8880953,52031433,349),(8880953,52031429,350),(8880953,52031426,351),(8880953,52031424,352),(8880953,52031418,353),(8880953,52031414,354),(8880953,52031410,355),(8880953,52031384,356),(8880953,52031381,357),(8880953,52031373,358),(8880953,52031369,359),(8880953,52031367,360),(8880953,52031364,361),(8880953,52031361,362),(8880953,52031357,363),(8880953,52031355,364),(8880953,52031351,365),(8880953,52031346,366),(8880953,52031340,367),(8880953,52031335,368),(8880953,52031329,369),(8880953,52031325,370),(8880953,52031320,371),(8880953,52031314,372),(8880953,52031309,373),(8880953,52031307,374),(8880953,52031299,375),(8880953,52031295,376),(8880953,52031290,377),(8880953,52031285,378),(8880953,52031281,379),(8880953,52031275,380),(8880953,52031272,381),(8880953,52031267,382),(8880953,52031262,383),(8880953,52031260,384),(8880953,52031255,385),(8880953,52031250,386),(8880953,52031247,387),(8880953,52031244,388),(8880953,52031240,389),(8880953,52031235,390),(8880953,52031232,391),(8880953,52031227,392),(8880953,52031224,393),(8880953,52031221,394),(8880953,52031218,395),(8880953,52031212,396),(8880953,52031205,397),(8880953,52031198,398),(8880953,52031190,399),(8880953,52031186,400),(8880953,52031178,401),(8880953,52031174,402),(8880953,52031171,403),(8880953,52031164,404),(8880953,52031158,405),(8880953,52031156,406),(8880953,52031153,407),(8880953,52031151,408),(8880953,52031147,409),(8880953,52031141,410),(8880953,52031136,411),(8880953,52031131,412),(8880953,52031129,413),(8880953,52031125,414),(8880953,52031121,415),(8880953,52031117,416),(8880953,52031114,417),(8880953,52031109,418),(8880953,52031105,419),(8880953,52031100,420),(8880953,52031099,421),(8880953,52031095,422),(8880953,52031092,423),(8880953,52031089,424),(8880953,52031086,425),(8880953,52031084,426),(8880953,52031082,427),(8880953,52031080,428),(8880953,52031077,429),(8880955,64796296,1),(8880955,64796297,2),(8880955,64796301,3),(8880955,64796302,4),(8880955,64796303,5),(8880955,64796304,6),(8880955,64796308,7),(8880955,64796309,8),(8880955,64796310,9),(8880955,64796311,10),(8880955,64796315,11),(8880955,64796316,12),(8880955,64796338,13),(8880955,64796339,14),(8880955,64796337,15),(8880955,64796335,16),(8880955,64796332,17),(8880955,64796331,18),(8880955,64796330,19),(8880955,64796329,20),(8880955,64796325,21),(8880955,64796324,22),(8880955,64796323,23),(8880955,64796322,24),(8880955,64796318,25),(8880955,64796317,26),(8880955,64796296,27),(8880956,64803169,1),(8880956,64801805,2),(8880956,64801804,3),(8880956,64801803,4),(8880956,64801802,5),(8880956,64801795,6),(8880956,64801785,7),(8880956,64801780,8),(8880956,64801779,9),(8880956,64801778,10),(8880956,64801774,11),(8880956,64801773,12),(8880956,64801725,13),(8880956,64801724,14),(8880956,64801721,15),(8880956,64801719,16),(8880956,64801718,17),(8880956,64801717,18),(8880956,64801714,19),(8880956,64801712,20),(8880956,64801711,21),(8880956,64801710,22),(8880956,64801709,23),(8880956,64801705,24),(8880956,64801704,25),(8880956,64801703,26),(8880956,64801702,27),(8880956,64801697,28),(8880956,64801695,29),(8880956,64801694,30),(8880956,64801693,31),(8880956,64801690,32),(8880956,64801688,33),(8880956,64801686,34),(8880956,64801685,35),(8880956,64801684,36),(8880956,64801681,37),(8880956,64801679,38),(8880956,64798335,39),(8880956,64798333,40),(8880956,64798331,41),(8880956,64798329,42),(8880956,64798328,43),(8880956,64798327,44),(8880956,64798324,45),(8880956,64798323,46),(8880956,64798321,47),(8880956,64798320,48),(8880956,64798319,49),(8880956,64798316,50),(8880956,64798315,51),(8880956,64798313,52),(8880956,64798312,53),(8880956,64798310,54),(8880956,64798308,55),(8880956,64798306,56),(8880956,64798305,57),(8880956,64798304,58),(8880956,64798301,59),(8880956,64798300,60),(8880956,64798298,61),(8880956,64798297,62),(8880956,64796367,63),(8880956,64796366,64),(8880956,64796365,65),(8880956,64796363,66),(8880956,64796360,67),(8880956,64796359,68),(8880956,64796358,69),(8880956,64796356,70),(8880956,64796353,71),(8880956,64796352,72),(8880956,64796351,73),(8880956,64796349,74),(8880956,64796346,75),(8880956,64796345,76),(8880956,64796344,77),(8880956,64796340,78),(8880956,64796296,79),(8880956,64796317,80),(8880956,64796368,81),(8880956,64796372,82),(8880956,64796373,83),(8880956,64796374,84),(8880956,64796375,85),(8880956,64796376,86),(8880956,64796377,87),(8880956,64796381,88),(8880956,64796382,89),(8880956,64796383,90),(8880956,64796385,91),(8880956,64796388,92),(8880956,64798267,93),(8880956,64798268,94),(8880956,64798270,95),(8880956,64798271,96),(8880956,64798274,97),(8880956,64798275,98),(8880956,64798277,99),(8880956,64798278,100),(8880956,64798280,101),(8880956,64798282,102),(8880956,64798283,103),(8880956,64798285,104),(8880956,64798286,105),(8880956,64798289,106),(8880956,64798290,107),(8880956,64798291,108),(8880956,64798293,109),(8880956,64798295,110),(8880956,64798336,111),(8880956,64798337,112),(8880956,64798339,113),(8880956,64798342,114),(8880956,64798343,115),(8880956,64798344,116),(8880956,64798345,117),(8880956,64798347,118),(8880956,64798350,119),(8880956,64798351,120),(8880956,64798352,121),(8880956,64801605,122),(8880956,64801639,123),(8880956,64801640,124),(8880956,64801644,125),(8880956,64801645,126),(8880956,64801646,127),(8880956,64801648,128),(8880956,64801651,129),(8880956,64801652,130),(8880956,64801654,131),(8880956,64801657,132),(8880956,64801659,133),(8880956,64801660,134),(8880956,64801663,135),(8880956,64801667,136),(8880956,64801670,137),(8880956,64801672,138),(8880956,64801673,139),(8880956,64801675,140),(8880956,64801678,141),(8880956,64801729,142),(8880956,64801739,143),(8880956,64801740,144),(8880956,64801741,145),(8880956,64801745,146),(8880956,64801746,147),(8880956,64801747,148),(8880956,64801748,149),(8880956,64801751,150),(8880956,64801753,151),(8880956,64801754,152),(8880956,64801758,153),(8880956,64801759,154),(8880956,64801761,155),(8880956,64801762,156),(8880956,64801766,157),(8880956,64801770,158),(8880956,64801809,159),(8880956,64801810,160),(8880956,64801811,161),(8880956,64801812,162),(8880956,64801816,163),(8880956,64801817,164),(8880956,64801818,165),(8880956,64801819,166),(8880956,64803147,167),(8880956,64803150,168),(8880956,64803152,169),(8880956,64803153,170),(8880956,64803154,171),(8880956,64803157,172),(8880956,64803159,173),(8880956,64803160,174),(8880956,64803168,175),(8880956,64803161,176),(8880956,64803162,177),(8880956,64803165,178),(8880956,64803167,179),(8880956,64803199,180),(8880956,64803198,181),(8880956,64803197,182),(8880956,64803195,183),(8880956,64803192,184),(8880956,64803191,185),(8880956,64803190,186),(8880956,64803188,187),(8880956,64803185,188),(8880956,64803184,189),(8880956,64803183,190),(8880956,64803182,191),(8880956,64803180,192),(8880956,64803177,193),(8880956,64803176,194),(8880956,64803175,195),(8880956,64803174,196),(8880956,64803172,197),(8880956,64803169,198),(8885021,64841074,1),(8885021,64841080,2),(8885021,64841084,3),(8885021,64841088,4),(8885021,64841091,5),(8885021,64841092,6),(8885021,64841148,7),(8885021,64841151,8),(8885021,64841154,9),(8885021,64841158,10),(8885021,64841162,11),(8885021,64841165,12),(8885021,64841166,13),(8885021,64841169,14),(8885021,64841177,15),(8885021,64841180,16),(8885021,64841183,17),(8885021,64841185,18),(8885021,64841188,19),(8885021,64841191,20),(8885021,64841194,21),(8885021,64841197,22),(8885021,64841198,23),(8885021,64841202,24),(8885021,64841205,25),(8885021,64841208,26),(8885021,64841211,27),(8885021,64841215,28),(8885021,64841220,29),(8885021,64841224,30),(8885021,64841229,31),(8885021,64841290,32),(8885021,64841293,33),(8885021,64841297,34),(8885021,64841301,35),(8885021,64841307,36),(8885021,64841311,37),(8885021,64841315,38),(8885021,64841316,39),(8885021,64841319,40),(8885021,64841321,41),(8885021,64841324,42),(8885021,64841329,43),(8885021,64841333,44),(8885021,64841337,45),(8885021,64841341,46),(8885021,258353539,47),(8885021,64841286,48),(8885021,64841282,49),(8885021,64841281,50),(8885021,64841278,51),(8885021,64841274,52),(8885021,64841271,53),(8885021,64841268,54),(8885021,64841266,55),(8885021,64841263,56),(8885021,64841260,57),(8885021,64841257,58),(8885021,64841254,59),(8885021,64841248,60),(8885021,64841245,61),(8885021,64841243,62),(8885021,64841238,63),(8885021,64841236,64),(8885021,64841233,65),(8885021,64841145,66),(8885021,64841139,67),(8885021,64841136,68),(8885021,64841134,69),(8885021,64841132,70),(8885021,64841129,71),(8885021,64841128,72),(8885021,64841125,73),(8885021,64841123,74),(8885021,64841120,75),(8885021,64841119,76),(8885021,64841118,77),(8885021,64841115,78),(8885021,64841113,79),(8885021,64841109,80),(8885021,64841108,81),(8885021,64841106,82),(8885021,64841105,83),(8885021,64841101,84),(8885021,64841100,85),(8885021,64841099,86),(8885021,64841097,87),(8885021,64841094,88),(8885021,64841028,89),(8885021,64841026,90),(8885021,64841023,91),(8885021,64841018,92),(8885021,64841013,93),(8885021,64841008,94),(8885021,64841007,95),(8885021,64841005,96),(8885021,64841000,97),(8885021,64840998,98),(8885021,64840997,99),(8885021,64840996,100),(8885021,64840992,101),(8885021,64840987,102),(8885021,64840985,103),(8885021,64840982,104),(8885021,64840979,105),(8885021,64840975,106),(8885021,64840971,107),(8885021,64840916,108),(8885021,64840911,109),(8885021,64840907,110),(8885021,64840903,111),(8885021,64840899,112),(8885021,64840895,113),(8885021,64840890,114),(8885021,64840886,115),(8885021,64840882,116),(8885021,64840877,117),(8885021,64840872,118),(8885021,64840868,119),(8885021,64840865,120),(8885021,64840861,121),(8885021,64840858,122),(8885021,64840854,123),(8885021,64840778,124),(8885021,64840773,125),(8885021,64840769,126),(8885021,64840767,127),(8885021,64840762,128),(8885021,64840761,129),(8885021,64840759,130),(8885021,64840758,131),(8885021,64840755,132),(8885021,64840753,133),(8885021,64840750,134),(8885021,64840746,135),(8885021,64840744,136),(8885021,64840741,137),(8885021,64840738,138),(8885021,64840732,139),(8885021,64840730,140),(8885021,64840726,141),(8885021,64840721,142),(8885021,64840717,143),(8885021,64840709,144),(8885021,64803167,145),(8885021,64803199,146),(8885021,64840781,147),(8885021,64840785,148),(8885021,64840790,149),(8885021,64840792,150),(8885021,64840793,151),(8885021,64840797,152),(8885021,64840799,153),(8885021,64840802,154),(8885021,64840806,155),(8885021,64840812,156),(8885021,64840816,157),(8885021,64840820,158),(8885021,64840823,159),(8885021,64840828,160),(8885021,64840832,161),(8885021,64840836,162),(8885021,64840839,163),(8885021,64840843,164),(8885021,64840848,165),(8885021,64840849,166),(8885021,64840918,167),(8885021,64840922,168),(8885021,64840923,169),(8885021,64840926,170),(8885021,64840929,171),(8885021,64840932,172),(8885021,64840933,173),(8885021,64840934,174),(8885021,64840936,175),(8885021,64840940,176),(8885021,64840946,177),(8885021,64840950,178),(8885021,390336904,179),(8885021,64840954,180),(8885021,64840959,181),(8885021,64840961,182),(8885021,64840965,183),(8885021,64840968,184),(8885021,64841033,185),(8885021,64841037,186),(8885021,64841039,187),(8885021,64841042,188),(8885021,64841046,189),(8885021,64841049,190),(8885021,64841051,191),(8885021,64841053,192),(8885021,64841057,193),(8885021,64841061,194),(8885021,64841066,195),(8885021,64841070,196),(8885021,64841074,197),(8885025,64841635,1),(8885025,258352118,2),(8885025,64841630,3),(8885025,64841627,4),(8885025,64841623,5),(8885025,64841620,6),(8885025,64841617,7),(8885025,64841612,8),(8885025,64841606,9),(8885025,64841603,10),(8885025,64841600,11),(8885025,64841597,12),(8885025,64841591,13),(8885025,64841587,14),(8885025,64841584,15),(8885025,64841582,16),(8885025,64841579,17),(8885025,64841573,18),(8885025,64841570,19),(8885025,64841566,20),(8885025,64841561,21),(8885025,64841557,22),(8885025,64841553,23),(8885025,64841551,24),(8885025,64841550,25),(8885025,64841547,26),(8885025,64841541,27),(8885025,64841537,28),(8885025,64841532,29),(8885025,64841529,30),(8885025,64841446,31),(8885025,64841444,32),(8885025,64841441,33),(8885025,64841439,34),(8885025,64841436,35),(8885025,266380259,36),(8885025,64841434,37),(8885025,266380260,38),(8885025,64841433,39),(8885025,64841431,40),(8885025,64841424,41),(8885025,64841415,42),(8885025,64841344,43),(8885025,64841346,44),(8885025,64841351,45),(8885025,64841356,46),(8885025,64841197,47),(8885025,64841194,48),(8885025,64841360,49),(8885025,64841365,50),(8885025,64841367,51),(8885025,64841370,52),(8885025,64841373,53),(8885025,64841375,54),(8885025,64841376,55),(8885025,64841379,56),(8885025,64841383,57),(8885025,64841386,58),(8885025,266340072,59),(8885025,64841388,60),(8885025,64841390,61),(8885025,64841393,62),(8885025,64841396,63),(8885025,64841399,64),(8885025,64841407,65),(8885025,64841451,66),(8885025,64841452,67),(8885025,64841454,68),(8885025,64841456,69),(8885025,64841461,70),(8885025,64841463,71),(8885025,64841468,72),(8885025,64841472,73),(8885025,64841473,74),(8885025,64841478,75),(8885025,64841481,76),(8885025,64841483,77),(8885025,64841487,78),(8885025,64841488,79),(8885025,64841491,80),(8885025,64841497,81),(8885025,64841499,82),(8885025,64841502,83),(8885025,64841507,84),(8885025,64841511,85),(8885025,64841514,86),(8885025,64841518,87),(8885025,64841521,88),(8885025,64841525,89),(8885025,64841638,90),(8885025,64841640,91),(8885025,64841645,92),(8885025,64841649,93),(8885025,64841652,94),(8885025,64841654,95),(8885025,52169127,96),(8885025,64841635,97),(17240968,52743887,1),(17240968,52743889,2),(17240968,52743892,3),(17240968,52743895,4),(17240968,52689656,5),(17240968,52689653,6),(17240968,52689650,7),(17240968,52689647,8),(17240968,52689643,9),(17240968,52689639,10),(17240968,52689635,11),(17240968,51412105,12),(17240968,52743899,13),(17240968,52743896,14),(17240968,52743900,15),(17240968,52743901,16),(17240968,52743902,17),(17240968,52743904,18),(17240968,52743907,19),(17240968,52743909,20),(17240968,52743910,21),(17240968,52743913,22),(17240968,52743916,23),(17240968,52743919,24),(17240968,52743921,25),(17240968,52743924,26),(17240968,52743925,27),(17240968,52743927,28),(17240968,52743928,29),(17240968,52743930,30),(17240968,52743933,31),(17240968,52743936,32),(17240968,52743937,33),(17240968,52743940,34),(17240968,52743941,35),(17240968,52743943,36),(17240968,52743946,37),(17240968,52743947,38),(17240968,52743950,39),(17240968,52743951,40),(17240968,52743954,41),(17240968,52743955,42),(17240968,52743958,43),(17240968,52743959,44),(17240968,52743961,45),(17240968,52743964,46),(17240968,52743966,47),(17240968,52743967,48),(17240968,52743969,49),(17240968,52743971,50),(17240968,52743972,51),(17240968,52743973,52),(17240968,52743976,53),(17240968,52743980,54),(17240968,52743981,55),(17240968,52743984,56),(17240968,52743986,57),(17240968,52743987,58),(17240968,52743988,59),(17240968,52743991,60),(17240968,52743992,61),(17240968,52743995,62),(17240968,52743997,63),(17240968,52744001,64),(17240968,52744002,65),(17240968,52744005,66),(17240968,52744007,67),(17240968,52744009,68),(17240968,52744012,69),(17240968,52744014,70),(17240968,52744016,71),(17240968,52744019,72),(17240968,52744021,73),(17240968,52744022,74),(17240968,52744025,75),(17240968,52744028,76),(17240968,52744030,77),(17240968,52744032,78),(17240968,52744035,79),(17240968,52744036,80),(17240968,52744038,81),(17240968,52744042,82),(17240968,52744043,83),(17240968,52744046,84),(17240968,52744049,85),(17240968,52744050,86),(17240968,52744052,87),(17240968,52744053,88),(17240968,52744054,89),(17240968,52744056,90),(17240968,52744057,91),(17240968,52744059,92),(17240968,52744062,93),(17240968,52744064,94),(17240968,52744066,95),(17240968,52744067,96),(17240968,52744070,97),(17240968,52744072,98),(17240968,52744073,99),(17240968,52744074,100),(17240968,52744075,101),(17240968,52744078,102),(17240968,52744081,103),(17240968,52744082,104),(17240968,52744084,105),(17240968,52744086,106),(17240968,52744087,107),(17240968,52744089,108),(17240968,52744091,109),(17240968,52744093,110),(17240968,52744094,111),(17240968,52744096,112),(17240968,52744097,113),(17240968,52744099,114),(17240968,52744100,115),(17240968,52744101,116),(17240968,52744102,117),(17240968,52744104,118),(17240968,52744106,119),(17240968,52744108,120),(17240968,52744110,121),(17240968,52744111,122),(17240968,52744114,123),(17240968,52744116,124),(17240968,52744118,125),(17240968,52744120,126),(17240968,52744122,127),(17240968,52744124,128),(17240968,52744126,129),(17240968,52744128,130),(17240968,52744130,131),(17240968,52744133,132),(17240968,52744134,133),(17240968,52744136,134),(17240968,52744138,135),(17240968,52744141,136),(17240968,52744144,137),(17240968,52744147,138),(17240968,52744149,139),(17240968,52744152,140),(17240968,52744155,141),(17240968,52744158,142),(17240968,52744159,143),(17240968,52744161,144),(17240968,52744163,145),(17240968,52744165,146),(17240968,52744166,147),(17240968,52744172,148),(17240968,52744174,149),(17240968,52744177,150),(17240968,52743887,151),(17241049,53353137,1),(17241049,53353141,2),(17241049,53353144,3),(17241049,53353148,4),(17241049,53353151,5),(17241049,53353155,6),(17241049,53353160,7),(17241049,53353163,8),(17241049,53353167,9),(17241049,53353170,10),(17241049,53353174,11),(17241049,53353179,12),(17241049,53353181,13),(17241049,53353183,14),(17241049,53353186,15),(17241049,53353189,16),(17241049,53353193,17),(17241049,321679729,18),(17241049,321679733,19),(17241049,53353198,20),(17241049,53353199,21),(17241049,53353203,22),(17241049,53353205,23),(17241049,53353208,24),(17241049,53353211,25),(17241049,53353223,26),(17241049,53353237,27),(17241049,53353302,28),(17241049,53353307,29),(17241049,53353314,30),(17241049,53353319,31),(17241049,53353324,32),(17241049,53353328,33),(17241049,53353333,34),(17241049,53353340,35),(17241049,53353343,36),(17241049,53353345,37),(17241049,53353350,38),(17241049,53353359,39),(17241049,53353366,40),(17241049,53353369,41),(17241049,53353372,42),(17241049,53353375,43),(17241049,53353383,44),(17241049,53353388,45),(17241049,53353391,46),(17241049,53353393,47),(17241049,53353395,48),(17241049,53353404,49),(17241049,53353407,50),(17241049,53353413,51),(17241049,53353421,52),(17241049,53353427,53),(17241049,53353431,54),(17241049,53353435,55),(17241049,53343318,56),(17241049,53343339,57),(17241049,53343344,58),(17241049,53343348,59),(17241049,53343353,60),(17241049,53343358,61),(17241049,53343364,62),(17241049,53343367,63),(17241049,53343377,64),(17241049,53343553,65),(17241049,53344982,66),(17241049,53350051,67),(17241049,53351880,68),(17241049,53352405,69),(17241049,53352410,70),(17241049,53352414,71),(17241049,53352419,72),(17241049,53352422,73),(17241049,53352426,74),(17241049,53352429,75),(17241049,53352435,76),(17241049,53352441,77),(17241049,53352444,78),(17241049,53352447,79),(17241049,53352452,80),(17241049,53352461,81),(17241049,53352483,82),(17241049,53352488,83),(17241049,53352494,84),(17241049,53352499,85),(17241049,53352505,86),(17241049,53352508,87),(17241049,53352511,88),(17241049,53352516,89),(17241049,53352521,90),(17241049,53352527,91),(17241049,53352530,92),(17241049,53352537,93),(17241049,53352541,94),(17241049,53352546,95),(17241049,53352552,96),(17241049,53352557,97),(17241049,53352561,98),(17241049,53352568,99),(17241049,53352574,100),(17241049,53352578,101),(17241049,53352584,102),(17241049,53352587,103),(17241049,53352594,104),(17241049,53352599,105),(17241049,53352605,106),(17241049,53352619,107),(17241049,53352632,108),(17241049,53352636,109),(17241049,53352638,110),(17241049,53353137,111),(22746153,51118076,1),(22746153,51118077,2),(22746153,51118078,3),(22746153,51118080,4),(22746153,51118081,5),(22746153,51118082,6),(22746153,51118083,7),(22746153,51118085,8),(22746153,51118086,9),(22746153,51118087,10),(22746153,51118088,11),(22746153,51118090,12),(22746153,51118091,13),(22746153,51118092,14),(22746154,51118092,1),(22746154,51118094,2),(22746154,51118095,3),(22746154,51118096,4),(22746154,51118097,5),(22746154,51118099,6),(22746154,51118100,7),(22746155,51118100,1),(22746155,51118102,2),(22746155,51118103,3),(22746155,51118104,4),(22746155,51118105,5),(22746155,51118106,6),(22746155,51118107,7),(22746155,51118108,8),(22746155,51118110,9),(22746155,51118111,10),(22746155,51118113,11),(22746156,51118113,1),(22746156,51118114,2),(22746156,51118115,3),(22746156,51118117,4),(22746156,51118118,5),(22746156,51118119,6),(22746156,51118121,7),(22746156,51118122,8),(22746156,51118123,9),(22746156,51118124,10),(22746156,51118125,11),(22746156,51118127,12),(22746156,51118128,13),(22746156,51118129,14),(22746157,51118129,1),(22746157,51118130,2),(22746157,51118131,3),(22746157,51118132,4),(22746157,51118133,5),(22746157,51118134,6),(22746157,51118135,7),(22746159,51118157,1),(22746159,51118159,2),(22746159,51118160,3),(22746159,51118161,4),(22746159,51118162,5),(22746159,51118164,6),(22746160,51118164,1),(22746160,51118165,2),(22746160,51118166,3),(22746160,51118168,4),(22746160,51118169,5),(22746160,51392412,6),(22746160,51118170,7),(22746160,51118171,8),(22746160,51118173,9),(22746160,51118174,10),(22746160,51118176,11),(22746160,51118177,12),(22746160,51118178,13),(22746160,51118179,14),(22746160,51118180,15),(22746160,51118181,16),(22746160,51118182,17),(22746160,51118183,18),(22746160,51118184,19),(22746160,51118185,20),(22746160,51118186,21),(22746160,51118187,22),(22746160,51118188,23),(22746160,51118189,24),(22746160,51391054,25),(22746160,51118190,26),(22746160,51390016,27),(22932948,247046008,1),(22932948,247046009,2),(22932948,247046010,3),(22932948,247046011,4),(22932948,247046012,5),(22932948,247046013,6),(22932948,247046014,7),(22932948,247046015,8),(22932948,247046016,9),(22932948,247046017,10),(22932948,247046018,11),(22932948,247046019,12),(22932948,247046020,13),(22932948,247046021,14),(22932948,247046022,15),(22932948,247046023,16),(22932948,247046024,17),(22932948,247046025,18),(22932948,247046026,19),(22932948,247046027,20),(22932949,247046028,1),(22932949,247046029,2),(22932949,247046030,3),(22932949,247046031,4),(22932949,247046032,5),(22932949,247046033,6),(22932949,247046034,7),(22932949,247046035,8),(22932949,247046036,9),(22932949,247046037,10),(22932949,247046038,11),(22932949,247046039,12),(22932949,247046040,13),(22932949,247046041,14),(22932949,247046042,15),(22932949,247046043,16),(22932949,247046044,17),(22932949,247046045,18),(22932949,247046046,19),(22932949,247046047,20),(22932949,247046048,21),(22932949,247046072,22),(22932949,247046073,23),(22932949,247046074,24),(22932949,247046075,25),(22932949,247046076,26),(22932949,247046077,27),(22932949,247046078,28),(22932949,247046079,29),(22932949,247046028,30),(23305160,45181716,1),(23305160,45160958,2),(23840927,51552477,1),(23840927,51552476,2),(23840927,51552473,3),(23840927,51552466,4),(23840927,51552468,5),(23840928,51552480,1),(23840928,51552477,2),(23841019,51552744,1),(23841019,51552740,2),(23841019,51552737,3),(23841019,51552736,4),(23841019,51581679,5),(23841049,51552744,1),(23841049,262893002,2),(23841094,51581574,1),(23841094,260989290,2),(23841094,260989291,3),(23841094,51552744,4),(23841127,51581574,1),(23841127,51581577,2),(23841127,51581580,3),(23841127,51581582,4),(23841127,51581587,5),(23841127,51581590,6),(23841127,51581593,7),(23841127,51581596,8),(23841127,51581598,9),(23841127,264502898,10),(23841127,51581602,11),(23841127,51581607,12),(23841127,51581611,13),(23841127,51581613,14),(23841127,51581617,15),(23841127,277386827,16),(23841127,51581620,17),(23841127,266380119,18),(23841127,266380267,19),(23841127,51581622,20),(23841127,51581625,21),(23841127,51581628,22),(23841127,266340199,23),(23841127,266341806,24),(23841127,51581633,25),(23841127,51581643,26),(23841127,51581645,27),(23841127,51581650,28),(23841127,51581654,29),(23841127,51581657,30),(23841127,51581661,31),(23841127,51581663,32),(23841423,51581663,1),(23841423,51581667,2),(23841426,51581667,1),(23841426,51581670,2),(23841426,51581675,3),(23842741,51552468,1),(23842741,58865012,2),(23842741,58865013,3),(23842741,51552471,4),(23842741,264906169,5),(23842741,51552462,6),(23842741,264906170,7),(23857062,52170099,1),(23857062,51552549,2),(23857062,51552550,3),(23857062,51552553,4),(23857062,51552555,5),(23857062,51552557,6),(23857062,51552559,7),(23857062,51552562,8),(23857062,51552565,9),(23857062,51552569,10),(23857062,51552572,11),(23857062,51552608,12),(23857062,51552575,13),(23857062,51552602,14),(23857062,287395969,15),(23857066,52170040,1),(23857066,51552495,2),(23857066,51552492,3),(23857066,51552489,4),(23857066,51552486,5),(23857066,51552483,6),(23857066,51552480,7),(23857247,51582530,1),(23857247,51952530,2),(23857247,51952532,3),(23857247,51952534,4),(23857247,51952536,5),(23857247,51952539,6),(23857247,51952542,7),(23857247,51952545,8),(23857247,51952546,9),(23857247,51952549,10),(23857247,51952552,11),(23857247,51952556,12),(23857247,51952559,13),(23857247,51952562,14),(23857247,51952566,15),(23857247,51952570,16),(23857247,51952573,17),(23857247,51952575,18),(23857247,51952578,19),(23857247,51952580,20),(23857247,51952583,21),(23857247,51952584,22),(23857247,51952586,23),(23857247,51952590,24),(23857247,51952594,25),(23857247,51952597,26),(23857247,51952599,27),(23857247,51952601,28),(23857247,51952604,29),(23857247,51952605,30),(23857247,51952608,31),(23857247,51952610,32),(23857247,51952613,33),(23857247,51952615,34),(23857247,51952618,35),(23857247,51952620,36),(23857247,51952623,37),(23857247,51952627,38),(23857247,51952630,39),(23857247,51952632,40),(23857247,51952634,41),(23857247,51952635,42),(23857247,51952638,43),(23857247,51952640,44),(23857247,51952643,45),(23877195,51342855,1),(23877195,51342559,2),(23877195,51120877,3),(23877195,51120878,4),(23877195,51120879,5),(23877195,51120881,6),(23877195,51120882,7),(23877195,51120883,8),(23877195,51120884,9),(23877195,51120885,10),(23877195,51120887,11),(23877195,51120888,12),(23877195,51120889,13),(23877195,51120890,14),(23877195,51396399,15),(23877195,51120891,16),(23877195,51120892,17),(23877195,51120893,18),(23877195,51120895,19),(23877195,51120896,20),(23877195,51120897,21),(23877195,51120898,22),(23877195,51120899,23),(23877195,51120900,24),(23877195,51119951,25),(23877197,51121332,1),(23877197,51121334,2),(23877197,51121335,3),(23877197,51121337,4),(23877197,51121338,5),(23877197,51121339,6),(23877199,51122009,1),(23877199,51122010,2),(23877199,51122012,3),(23877199,51122014,4),(23877199,51122015,5),(23877199,51122016,6),(23877199,278763284,7),(23877199,51122018,8),(23877199,51122020,9),(23877199,51122022,10),(23877199,51122023,11),(23877199,51122025,12),(23877199,51122027,13),(23877199,51122028,14),(23877199,51122029,15),(23877199,51122030,16),(23877199,51122032,17),(23877199,51122033,18),(23877199,51122034,19),(23877199,51122036,20),(23877199,51122038,21),(23877199,51122039,22),(23877199,51122041,23),(23877199,51122042,24),(23877199,51122044,25),(23877199,51122045,26),(23877199,51121362,27),(23877199,51121363,28),(23877199,51121326,29),(23877199,51121327,30),(23877199,51121329,31),(23877199,51121330,32),(23877199,51121331,33),(23877199,51121332,34),(23877200,258823161,1),(23877200,51121973,2),(23877200,51121974,3),(23877200,51121976,4),(23877200,51121977,5),(23877200,51121979,6),(23877200,51121981,7),(23877200,51121982,8),(23877200,51121984,9),(23877200,51121985,10),(23877200,51121987,11),(23877200,278757467,12),(23877200,278757468,13),(23877200,51121988,14),(23877200,51121989,15),(23877200,51121991,16),(23877200,51121992,17),(23877200,51121993,18),(23877200,278757469,19),(23877200,51121995,20),(23877200,278761002,21),(23877200,51121997,22),(23877200,51121998,23),(23877200,51122000,24),(23877200,278760711,25),(23877200,278760483,26),(23877200,51122001,27),(23877200,51122003,28),(23877200,51122005,29),(23877200,51122006,30),(23877200,51122007,31),(23877201,51122007,1),(23877201,51122009,2),(23878263,247045685,1),(23878263,247045686,2),(23878263,247045688,3),(23878263,247045690,4),(23878263,247045691,5),(23878263,247045693,6),(23878263,247045695,7),(23878263,247045696,8),(23878263,247045698,9),(23878263,247045700,10),(23878263,247045701,11),(23878263,247045703,12),(23878263,247045712,13),(23878263,247045718,14),(23878263,247045724,15),(23878263,247045732,16),(23878263,247045739,17),(23878263,247045741,18),(23878263,247045742,19),(23878263,247045744,20),(23878263,247045685,21),(23878462,51442273,1),(23878462,51385300,2),(23878462,51385299,3),(23878462,51385298,4),(23878462,51385297,5),(23878462,51385296,6),(23878462,51385295,7),(23878462,51385292,8),(23878462,51385291,9),(23878462,51385290,10),(23878462,51442041,11),(23878462,51442282,12),(23878462,51442280,13),(23878462,51442278,14),(23878462,51442349,15),(23878462,51442271,16),(23878462,51442273,17),(23878463,51384490,1),(23878463,51384518,2),(23878463,51384488,3),(23878463,51384487,4),(23878463,51384485,5),(23878463,51442352,6),(23878463,51384482,7),(23878463,51385304,8),(23878463,51385302,9),(23878463,51442273,10),(23924998,51929728,1),(23924998,51929731,2),(23924998,51929734,3),(23924998,51929736,4),(23924998,51929739,5),(23924998,51929741,6),(23924998,51929743,7),(23924998,51929746,8),(23924998,51929749,9),(23924998,51929752,10),(23924998,51929754,11),(23924998,51929757,12),(23924998,51929760,13),(23924998,51929762,14),(23924998,51929764,15),(23924998,51929767,16),(23924998,51929770,17),(23924998,51929771,18),(23924998,51929773,19),(23924998,51929775,20),(23924998,51929777,21),(23924998,51929780,22),(23924998,51929782,23),(23924998,51929784,24),(23924998,51929785,25),(23924998,51929786,26),(23924998,51929788,27),(23924998,51929790,28),(23924998,51929793,29),(23924998,51929796,30),(23924998,51929797,31),(23924998,51929800,32),(23924998,51929802,33),(23924998,51929805,34),(23924998,51929807,35),(23924998,51929810,36),(23924998,51929812,37),(23924998,51929814,38),(23924998,51929818,39),(23924998,51929820,40),(23924998,51929823,41),(23924998,51929825,42),(23924998,51929827,43),(23924998,51929829,44),(23924998,51929833,45),(23924998,51929834,46),(23924998,51929837,47),(23924998,51929840,48),(23924998,51929842,49),(23924998,51929844,50),(23924998,51929846,51),(23924998,51929848,52),(23924998,51929852,53),(23924998,51929854,54),(23924998,51929858,55),(23924998,51929860,56),(23924998,51929862,57),(23924998,51929864,58),(23924998,51929866,59),(23924998,51929869,60),(23924998,51929872,61),(23924998,51929873,62),(23924998,51929875,63),(23924998,51929878,64),(23924998,51929880,65),(23924998,51929883,66),(23924998,51929886,67),(23924998,51929889,68),(23924998,51929892,69),(23924998,51929893,70),(23924998,51929896,71),(23924998,51929899,72),(23924998,51929902,73),(23924998,51929905,74),(23924998,51929907,75),(23924998,51929909,76),(23924998,51929910,77),(23924998,51929913,78),(23924998,51929915,79),(23924998,51929916,80),(23924998,51929918,81),(23924998,51929920,82),(23924998,51929922,83),(23924998,51929923,84),(23924998,51929925,85),(23924998,51929927,86),(23924998,51929930,87),(23924998,51929933,88),(23924998,51929936,89),(23924998,51929938,90),(23924998,51929939,91),(23924998,51929942,92),(23924998,51929943,93),(23924998,51929946,94),(23924998,51929949,95),(23924998,51929950,96),(23924998,51929953,97),(23924998,51929955,98),(23924998,51929957,99),(23924998,51929960,100),(23924998,51929964,101),(23924998,51929966,102),(23924998,51929968,103),(23924998,51929971,104),(23924998,51929974,105),(23924998,51929975,106),(23924998,51929978,107),(23924998,51929980,108),(23924998,51929983,109),(23924998,51929986,110),(23924998,51929988,111),(23924998,51929990,112),(23924998,51929993,113),(23924998,51929999,114),(23924998,51930002,115),(23924998,51930009,116),(23924998,51930014,117),(23924998,51930018,118),(23924998,51930020,119),(23924998,51930022,120),(23924998,51930024,121),(23924998,51930026,122),(23924998,51930027,123),(23924998,51930029,124),(23924998,51930031,125),(23924998,51930033,126),(23924998,51930035,127),(23924998,51930037,128),(23924998,51930040,129),(23924998,51930043,130),(23924998,51930044,131),(23924998,51930047,132),(23924998,51930048,133),(23924998,51930050,134),(23924998,51930052,135),(23924998,51930053,136),(23924998,51930055,137),(23924998,51930058,138),(23924998,51930062,139),(23924998,51930063,140),(23924998,51930066,141),(23924998,51930068,142),(23924998,51930071,143),(23924998,51930073,144),(23924998,51930076,145),(23924998,51930079,146),(23924998,51930080,147),(23924998,51930082,148),(23924998,51930085,149),(23924998,51930088,150),(23924998,51930092,151),(23924998,51930094,152),(23924998,51930096,153),(23924998,51930098,154),(23924998,51930099,155),(23924998,51930102,156),(23924998,51930104,157),(23924998,51930107,158),(23924998,51930108,159),(23924998,51930110,160),(23924998,51930112,161),(23924998,51930113,162),(23924998,51930115,163),(23924998,51930118,164),(23924998,51930119,165),(23924998,51930121,166),(23924998,51930124,167),(23924998,51930125,168),(23924998,51930127,169),(23924998,51930129,170),(23924998,51930132,171),(23924998,51930134,172),(23924998,51930136,173),(23924998,51930138,174),(23924998,51930141,175),(23924998,51930143,176),(23924998,51930145,177),(23924998,51930148,178),(23924998,51930149,179),(23924998,51930152,180),(23924998,51930153,181),(23924998,51930156,182),(23924998,51930158,183),(23924998,51930160,184),(23924998,51930163,185),(23924998,51930165,186),(23924998,51930167,187),(23924998,51930169,188),(23924998,51930171,189),(23924998,51930173,190),(23924998,51930175,191),(23924998,51930177,192),(23924998,51930178,193),(23924998,51930181,194),(23924998,51930184,195),(23924998,51930186,196),(23925250,259406456,1),(23925250,259406455,2),(23925250,259406454,3),(23925250,259406453,4),(23925250,259406452,5),(23925250,259406451,6),(23925250,259406450,7),(23925250,259406449,8),(23925250,259406448,9),(23925250,259406447,10),(23925250,259406446,11),(23925250,259406445,12),(23925255,259406445,1),(23925255,51366554,2),(23925255,51366556,3),(23925255,625030,4),(23925255,51366560,5),(23925255,51366562,6),(23925255,625031,7),(23925255,51366564,8),(23925255,625032,9),(23925255,625033,10),(23925285,259406456,1),(23925285,51366854,2),(23938547,261004007,1),(23938547,261004008,2),(23938547,259475446,3),(23978189,259984359,1),(23978189,260997624,2),(23978342,259984359,1),(23978342,259985586,2),(23978342,259985587,3),(23978424,259985587,1),(23978424,259985588,2),(23978424,259985589,3),(23978424,259985590,4),(23978424,259985592,5),(23978424,259985593,6),(23978424,259985594,7),(23978424,259985595,8),(23978424,259985596,9),(23978424,259985597,10),(23978424,259985598,11),(23978424,259985599,12),(23978424,259985600,13),(23978424,259985601,14),(23978424,259985602,15),(23978424,259985603,16),(23978424,259985604,17),(23978424,259985605,18),(23978424,259985606,19),(23978424,259983829,20),(23978499,259986470,1),(23978499,259986747,2),(24058474,287401324,1),(24058474,260984109,2),(24058474,260984110,3),(24058474,260984111,4),(24058474,260984112,5),(24058474,260984113,6),(24058474,260984114,7),(24058474,260984115,8),(24058474,260984116,9),(24058474,260984117,10),(24058474,260984118,11),(24058474,260984120,12),(24058474,260984121,13),(24058474,260984122,14),(24058474,260984123,15),(24058474,260984124,16),(24058474,260984125,17),(24058474,260984126,18),(24058474,260984127,19),(24058474,260984128,20),(24059004,260995478,1),(24059004,262151572,2),(24059067,260996387,1),(24059067,260996388,2),(24059067,260996389,3),(24059067,260996390,4),(24059067,260996391,5),(24059067,262151572,6),(24059067,260996392,7),(24059068,260996392,1),(24059068,262151641,2),(24059068,260996399,3),(24059068,260996400,4),(24059068,260996401,5),(24059068,260996402,6),(24059068,260996403,7),(24059068,260996405,8),(24059068,260996406,9),(24059068,260996407,10),(24059068,260996408,11),(24059068,260996409,12),(24059068,260996410,13),(24059068,260996411,14),(24059068,260996413,15),(24059068,260996414,16),(24059068,260996415,17),(24059068,260996416,18),(24059068,260996417,19),(24059068,260996418,20),(24059068,260996419,21),(24059068,260996421,22),(24059068,260996422,23),(24059068,260996423,24),(24059068,260996425,25),(24059068,260996426,26),(24059068,260996427,27),(24059068,260996429,28),(24059068,260996430,29),(24059068,260996431,30),(24059068,260996432,31),(24059068,260996434,32),(24059068,260996435,33),(24059068,260996436,34),(24059068,260996437,35),(24059122,260997624,1),(24059122,260997625,2),(24059295,260997625,1),(24059295,260997626,2),(24059296,260997626,1),(24059296,260997627,2),(24059351,260997627,1),(24059351,261001744,2),(24059351,261001745,3),(24059351,261001746,4),(24059351,261001747,5),(24059351,261001748,6),(24059351,261001749,7),(24059351,261001750,8),(24059351,261001751,9),(24059351,261001752,10),(24059351,261001753,11),(24059379,259475495,1),(24059379,259475494,2),(24059379,259475493,3),(24059379,259475455,4),(24059379,260997627,5),(24059392,261001753,1),(24059392,261002668,2),(24059392,261002669,3),(24059392,261002671,4),(24059392,261002672,5),(24059392,261002673,6),(24059392,261002674,7),(24059392,261002675,8),(24059418,261002675,1),(24059418,261003171,2),(24059418,261003172,3),(24059453,259475446,1),(24059453,259475447,2),(24059453,259475448,3),(24059453,259475449,4),(24059453,259475450,5),(24059453,259475451,6),(24059453,259475452,7),(24059453,259475453,8),(24059453,259475454,9),(24059453,259475455,10),(24059572,261006066,1),(24059572,261006067,2),(24059572,261006068,3),(24059572,261006069,4),(24059572,261006070,5),(24059572,261006071,6),(24059572,261006072,7),(24059572,261006073,8),(24059572,261006074,9),(24059572,261006075,10),(24059572,261006076,11),(24059832,53319512,1),(24059832,53319557,2),(24059832,53319554,3),(24059832,53319509,4),(24059832,53319505,5),(24059832,53319503,6),(24059832,53319500,7),(24059832,53319497,8),(24059832,53319533,9),(24059832,53319495,10),(24059832,53319492,11),(24059832,53319491,12),(24059832,51552711,13),(24059857,53327626,1),(24059857,53327622,2),(24059857,53327620,3),(24059999,53325815,1),(24059999,53325817,2),(24060059,53319735,1),(24060059,53325843,2),(24060059,53325840,3),(24060059,53325829,4),(24060059,53325827,5),(24060059,53325823,6),(24060059,261012137,7),(24060059,261012136,8),(24060059,261012135,9),(24060059,261012134,10),(24060059,261012133,11),(24060059,53325852,12),(24060059,53325850,13),(24060059,53325848,14),(24060059,262459990,15),(24060059,53325846,16),(24060059,53325709,17),(24060059,53325711,18),(24060059,53325715,19),(24060059,53325718,20),(24060059,53325720,21),(24060059,53325722,22),(24060059,53325723,23),(24060059,53325724,24),(24060059,53325725,25),(24060059,53325726,26),(24060059,53325729,27),(24060059,53325732,28),(24060260,52204446,1),(24060260,52204445,2),(24060706,53306911,1),(24060706,53306910,2),(24060706,53306907,3),(24060706,53306906,4),(24060706,53306904,5),(24060706,53306901,6),(24060706,53306899,7),(24060706,53306897,8),(24060706,259983829,9),(24060706,53306893,10),(24060706,53306892,11),(24060706,53306889,12),(24060706,415767148,13),(24060706,53306888,14),(24060706,53306887,15),(24060706,53306886,16),(24060706,53306885,17),(24060706,53306882,18),(24060706,53306881,19),(24060706,53306878,20),(24060706,53306876,21),(24060706,53306875,22),(24060706,441154951,23),(24060706,53306874,24),(24060706,53306873,25),(24060706,53306871,26),(24060706,53306806,27),(24060706,53306804,28),(24060706,53306803,29),(24060706,53306800,30),(24060706,53306799,31),(24060706,53306796,32),(24060706,53306795,33),(24060706,53306794,34),(24060706,53306792,35),(24060706,53306791,36),(24060706,53306790,37),(24060706,53306866,38),(24060706,53306789,39),(24060706,53306788,40),(24060706,53306787,41),(24060781,53295259,1),(24060781,53295257,2),(24060781,53295253,3),(24060781,53295251,4),(24060781,53295249,5),(24060781,53295245,6),(24060781,53295243,7),(24060781,53295241,8),(24060781,53295236,9),(24060781,53295233,10),(24060781,53295228,11),(24060781,53295224,12),(24060781,53295222,13),(24060781,53295218,14),(24060781,53295211,15),(24060781,53295208,16),(24060781,53295202,17),(24060781,53295197,18),(24060781,53295193,19),(24060781,53295190,20),(24060781,53295188,21),(24060781,53295272,22),(24060781,53295186,23),(24060781,53295182,24),(24060781,53295178,25),(24060781,53295175,26),(24060781,53295172,27),(24060781,53295169,28),(24060781,53295165,29),(24060781,53295161,30),(24060781,53295158,31),(24060781,53295157,32),(24060781,53295153,33),(24060781,53295149,34),(24060781,53295147,35),(24060781,53295143,36),(24060781,53295141,37),(24060781,53295137,38),(24060781,53295133,39),(24060781,53295132,40),(24060781,53295128,41),(24060781,53295125,42),(24060781,53295122,43),(24060781,53295117,44),(24060781,53295113,45),(24060781,53295110,46),(24060781,53295107,47),(24060781,53295103,48),(24060781,53295102,49),(24060781,53295097,50),(24060781,53295093,51),(24060781,53295090,52),(24060781,53295085,53),(24060781,53295083,54),(24060781,53295079,55),(24060781,53295077,56),(24060781,53295073,57),(24060781,53295071,58),(24060781,53295067,59),(24060781,53295063,60),(24060781,53295059,61),(24060781,53295057,62),(24060781,53295054,63),(24060781,53295051,64);
INSERT INTO `current_way_nodes` VALUES (24060781,53295047,65),(24060781,53295045,66),(24060781,53295040,67),(24060781,53295038,68),(24060781,53295035,69),(24060781,53295043,70),(24060781,53295033,71),(24060781,53295029,72),(24060781,53295026,73),(24060781,53295022,74),(24060781,53295019,75),(24060781,53295016,76),(24060781,53295014,77),(24060781,53295011,78),(24060781,53295010,79),(24060781,53295006,80),(24060781,53295004,81),(24060781,53295002,82),(24060781,53294998,83),(24060781,53294994,84),(24060840,53306959,1),(24060840,335320657,2),(24060840,53306956,3),(24060840,53306954,4),(24060840,53306952,5),(24060840,53306949,6),(24060840,53306946,7),(24060840,53306944,8),(24060840,53306943,9),(24060840,53306940,10),(24060840,53306938,11),(24060840,53306936,12),(24060840,53306935,13),(24060840,53306932,14),(24060840,264495953,15),(24060840,53306930,16),(24060840,53306928,17),(24060840,264495540,18),(24060840,53306925,19),(24060840,53306923,20),(24060840,264501521,21),(24060840,53306921,22),(24060840,53306980,23),(24060840,276998391,24),(24060840,53306917,25),(24060840,53309382,26),(24060840,53306913,27),(24240688,262459990,1),(24240688,262459991,2),(24240688,262459992,3),(24240688,262459993,4),(24240688,262459994,5),(24240688,262459995,6),(24240688,262459997,7),(24240688,262459998,8),(24240688,262459999,9),(24240699,262460047,1),(24240699,262459991,2),(24240709,262460177,1),(24240709,262460178,2),(24240709,262460179,3),(24240709,262460180,4),(24240709,262460181,5),(24240709,262459992,6),(24240780,262460920,1),(24240780,262460921,2),(24240780,262460922,3),(24240808,53319512,1),(24240808,53319714,2),(24240808,53319712,3),(24240808,53319710,4),(24240808,53319708,5),(24240808,53319705,6),(24240808,53319707,7),(24240808,53319717,8),(24240808,53319718,9),(24240808,53319720,10),(24240808,53319721,11),(24240808,53325818,12),(24240808,53319724,13),(24240808,53319725,14),(24240808,53319726,15),(24240808,53319727,16),(24240808,53319731,17),(24240808,53319732,18),(24240808,53319735,19),(24240808,53319787,20),(24240808,53319737,21),(24240808,53319740,22),(24240808,53319741,23),(24240808,53319742,24),(24240808,53319744,25),(24240808,53319747,26),(24240808,262461658,27),(24240808,262461659,28),(24240808,262461660,29),(24240808,262461661,30),(24240808,262461662,31),(24240808,262461663,32),(24240808,262461664,33),(24240808,338418931,34),(24240808,338418932,35),(24240808,262460922,36),(24240825,262461792,1),(24240825,262460922,2),(24240826,262460920,1),(24240826,262462281,2),(24240826,262461823,3),(24240826,262461824,4),(24240826,262461825,5),(24240826,262461826,6),(24240826,262461827,7),(24240826,262461828,8),(24240835,262460922,1),(24240835,262461793,2),(24240835,262461794,3),(24240835,262461792,4),(24240835,262460922,5),(24240868,262462280,1),(24240868,262462281,2),(24241040,262464083,1),(24241040,262464084,2),(24241040,262464085,3),(24241040,262464086,4),(24241040,262464087,5),(24241040,262464088,6),(24241040,262464089,7),(24241040,262464090,8),(24241040,262464091,9),(24241040,262464092,10),(24241040,262464093,11),(24241040,470357348,12),(24241040,262464094,13),(24241040,262464095,14),(24241040,262464096,15),(24241040,262464097,16),(24241040,470356873,17),(24241040,470352988,18),(24241040,262464098,19),(24241040,262464099,20),(24241040,262464100,21),(24241040,262464101,22),(24241072,262464083,1),(24241072,268081464,2),(24241072,262464355,3),(24241072,268081234,4),(24241072,268081236,5),(24241072,268081237,6),(24241072,268081238,7),(24241072,268081239,8),(24241072,268081241,9),(24241072,268081242,10),(24241072,268081243,11),(24241274,262465820,1),(24241274,262466981,2),(24241274,262466982,3),(24241278,262466982,1),(24241278,262467014,2),(24241281,262467014,1),(24241281,262467028,2),(24241289,262467028,1),(24241289,262467056,2),(24241289,262467057,3),(24241289,262467058,4),(24241289,262467059,5),(24241289,262467060,6),(24241289,262467061,7),(24241364,51930199,1),(24241364,51930202,2),(24241364,51930206,3),(24241364,51930208,4),(24241364,51930211,5),(24241364,51930213,6),(24241364,51930216,7),(24241364,51930219,8),(24241364,51930222,9),(24241364,51930223,10),(24241364,51930226,11),(24241364,51930228,12),(24241364,51930230,13),(24241364,51930232,14),(24241364,51930235,15),(24241364,51930238,16),(24241364,51930241,17),(24241364,51930242,18),(24241364,51930245,19),(24241364,51930247,20),(24241364,51930250,21),(24241364,51930252,22),(24241364,51930253,23),(24241364,51930255,24),(24241364,51930257,25),(24241364,51930259,26),(24241364,51930262,27),(24241364,51930264,28),(24241364,51930267,29),(24241364,51930270,30),(24241364,51930272,31),(24241364,51930275,32),(24241364,51930278,33),(24241364,51930280,34),(24241364,51930282,35),(24241364,51930284,36),(24241364,51930288,37),(24241364,51930291,38),(24241364,51930293,39),(24241364,51930297,40),(24241364,51930299,41),(24241364,51930302,42),(24241364,51930305,43),(24241364,51930307,44),(24241364,51930309,45),(24241364,51930311,46),(24241364,51930312,47),(24241364,51930313,48),(24241364,51930314,49),(24241364,51930315,50),(24241364,51930319,51),(24241364,51930386,52),(24241364,51930321,53),(24241364,51930324,54),(24241364,51930326,55),(24241364,51930328,56),(24241364,51930331,57),(24241364,51930332,58),(24241364,51930403,59),(24241364,51930405,60),(24241364,51930408,61),(24241364,51930410,62),(24241364,51930412,63),(24241364,51930413,64),(24241364,51930415,65),(24241364,51930416,66),(24241364,51930417,67),(24241364,51930418,68),(24241364,51930420,69),(24241364,51930422,70),(24241364,51930424,71),(24241364,51930426,72),(24241364,51930428,73),(24241364,51930429,74),(24241364,51930433,75),(24241364,51930437,76),(24241364,51930439,77),(24241364,51930441,78),(24241364,51930443,79),(24241364,51930445,80),(24241364,51930447,81),(24241364,51930448,82),(24241364,51930449,83),(24241364,51930450,84),(24241364,51930453,85),(24241364,51930455,86),(24241364,51930457,87),(24241364,51930458,88),(24241364,51930461,89),(24241364,51930462,90),(24241364,51930465,91),(24241364,51930467,92),(24241364,51930469,93),(24241364,51930470,94),(24241364,51930473,95),(24241364,51930475,96),(24241364,51930478,97),(24241364,51930481,98),(24241364,51930483,99),(24241364,51930485,100),(24241364,51930488,101),(24241364,51930492,102),(24241364,51930495,103),(24241364,51930497,104),(24241364,51930500,105),(24241364,51930503,106),(24241364,51930505,107),(24241364,51930507,108),(24241364,51930509,109),(24241364,51930511,110),(24241364,51930513,111),(24241364,51930517,112),(24241364,51930519,113),(24241364,51930521,114),(24241364,51930524,115),(24241364,51930527,116),(24241364,51930531,117),(24241364,51930534,118),(24241364,51930537,119),(24241364,51930540,120),(24241364,51930542,121),(24241364,51930544,122),(24241364,51930548,123),(24241364,51930553,124),(24241364,51930556,125),(24241364,51930560,126),(24241364,51930563,127),(24241364,51930565,128),(24241364,51930567,129),(24241364,51930569,130),(24241364,51930572,131),(24241364,51930573,132),(24241364,51930576,133),(24241364,51930579,134),(24241364,51930582,135),(24241364,51930583,136),(24241364,51930586,137),(24241364,51930588,138),(24241364,51930590,139),(24241364,51930593,140),(24241364,51930595,141),(24241364,51930597,142),(24241364,51930599,143),(24241364,51930602,144),(24241364,51930604,145),(24241364,51930606,146),(24241364,51930609,147),(24241364,51930611,148),(24241364,51930614,149),(24241364,51930616,150),(24241364,51930630,151),(24241364,51930628,152),(24241364,51930619,153),(24241364,51930626,154),(24241364,51930621,155),(24241364,51930623,156),(24241364,51930633,157),(24241364,51930636,158),(24241364,51930638,159),(24241364,51930640,160),(24241364,51930641,161),(24241364,51930643,162),(24241364,51930645,163),(24241364,51930648,164),(24279813,262467026,1),(24279813,262467028,2),(24279886,262461792,1),(24279886,262460920,2),(24279950,51401220,1),(24279950,51401223,2),(24279950,51401224,3),(24279950,51401226,4),(24279950,51401227,5),(24279950,51401228,6),(24279950,51400770,7),(24279950,51400772,8),(24279950,51400773,9),(24279950,51400870,10),(24279950,51400777,11),(24279950,51400778,12),(24279950,51400779,13),(24279950,51400782,14),(24279950,51410282,15),(24279950,51400784,16),(24279950,51400786,17),(24279950,51400787,18),(24279950,51410232,19),(24279950,51400789,20),(24279950,51400791,21),(24279950,51400793,22),(24279950,51400794,23),(24280101,52206645,1),(24280101,52206632,2),(24280101,52206635,3),(24280101,52206639,4),(24280101,52206643,5),(24280274,51930648,1),(24280274,51930650,2),(24280275,51930650,1),(24280275,51930652,2),(24280275,51930653,3),(24280275,51930656,4),(24280275,51930657,5),(24280275,51930661,6),(24280275,51930663,7),(24280275,51930665,8),(24280275,51930668,9),(24280275,51930671,10),(24280275,51930674,11),(24280275,51930676,12),(24280275,51930680,13),(24280275,51930682,14),(24280275,51930684,15),(24280275,51930686,16),(24280275,51930687,17),(24280275,51930689,18),(24280275,51930691,19),(24280275,51930692,20),(24280275,51930695,21),(24280275,51930697,22),(24280275,51930699,23),(24280275,51930702,24),(24280275,51930705,25),(24280275,51930706,26),(24280275,51930709,27),(24280275,51930712,28),(24280275,51930713,29),(24280275,51930716,30),(24280275,51930718,31),(24280275,51930721,32),(24280275,51930723,33),(24280275,51930726,34),(24280275,51930727,35),(24280275,51930729,36),(24280275,51930731,37),(24280275,51930732,38),(24280275,51930734,39),(24280275,51930736,40),(24280275,51930738,41),(24280275,51930741,42),(24280275,51930743,43),(24280275,51930745,44),(24280275,51930748,45),(24280275,51930750,46),(24280275,51930751,47),(24280275,51930754,48),(24280275,51930756,49),(24280275,51930758,50),(24280275,51930761,51),(24280275,51930762,52),(24280275,51930765,53),(24280275,51930768,54),(24280275,51930769,55),(24280275,51930771,56),(24280275,51930775,57),(24280275,51930777,58),(24280275,51930779,59),(24280275,51930781,60),(24280275,51930783,61),(24280275,51930786,62),(24280275,51930788,63),(24280275,51930790,64),(24280275,51930793,65),(24280275,51930794,66),(24280275,51930797,67),(24280275,51930800,68),(24280275,51930802,69),(24280275,51930806,70),(24280275,51930807,71),(24280275,51930808,72),(24280275,51930809,73),(24280275,51930812,74),(24280275,51930814,75),(24280275,51930815,76),(24280275,51930816,77),(24280275,51930818,78),(24280275,51930821,79),(24280275,51930823,80),(24280275,51930826,81),(24280275,51930828,82),(24280275,51930830,83),(24280275,51930831,84),(24280275,51930834,85),(24280275,51930836,86),(24280275,51930839,87),(24280275,51930840,88),(24280275,51930843,89),(24280275,51930844,90),(24280275,51930847,91),(24280275,51930850,92),(24280275,51930851,93),(24280275,51930854,94),(24280275,51930855,95),(24280275,51930858,96),(24280275,51930859,97),(24280275,51930862,98),(24280275,51930864,99),(24280275,51930865,100),(24280275,51930866,101),(24280275,51930867,102),(24280275,51930869,103),(24280275,51930871,104),(24280275,51930873,105),(24280275,51930876,106),(24280275,51930879,107),(24280275,51930882,108),(24280275,51930883,109),(24280275,51930885,110),(24280275,51930887,111),(24280275,51930889,112),(24280275,51930891,113),(24280275,51930893,114),(24280275,51930895,115),(24280275,51930896,116),(24280275,51930898,117),(24280275,51930900,118),(24280275,51930901,119),(24280275,51930905,120),(24280275,51930907,121),(24280275,51930908,122),(24280275,51930909,123),(24280275,51930911,124),(24280275,51930913,125),(24280275,51930915,126),(24280275,51930918,127),(24280275,51930920,128),(24280275,51930923,129),(24280275,51930926,130),(24280275,51930928,131),(24280275,51930930,132),(24280275,51930932,133),(24280275,51930935,134),(24280275,51930937,135),(24280275,51930940,136),(24280275,51930942,137),(24280275,51930944,138),(24280275,51930947,139),(24280275,51930950,140),(24280275,51930952,141),(24280275,51930953,142),(24280275,51930954,143),(24280275,51930956,144),(24280275,51930958,145),(24280275,51930961,146),(24280275,51930962,147),(24280275,51930965,148),(24280275,51930967,149),(24280275,51930968,150),(24280275,51930971,151),(24280275,51930973,152),(24280275,51930974,153),(24280275,51930975,154),(24280275,51930976,155),(24280275,51930978,156),(24280275,51930981,157),(24280275,51930983,158),(24280276,51930983,1),(24280276,51930984,2),(24280277,51930984,1),(24280277,51930985,2),(24280277,51930986,3),(24280277,51930987,4),(24280277,51930990,5),(24280277,51930992,6),(24280277,51930995,7),(24280277,51930998,8),(24280277,51930999,9),(24280277,51931002,10),(24280277,51931005,11),(24280277,51931006,12),(24280277,51931009,13),(24280277,51931012,14),(24280277,51931014,15),(24280277,51931018,16),(24280277,51931020,17),(24280277,51931023,18),(24280277,51931025,19),(24280277,51931026,20),(24280277,51931029,21),(24280277,51931032,22),(24280277,51931036,23),(24280277,51931037,24),(24280277,51931040,25),(24280277,51931043,26),(24280277,51931045,27),(24280277,51931047,28),(24280277,51931050,29),(24280277,51931053,30),(24280277,51931055,31),(24280277,51931057,32),(24280277,51931060,33),(24280277,51931062,34),(24280277,51931065,35),(24280277,51931066,36),(24280277,51931069,37),(24280277,51931070,38),(24280277,51931073,39),(24280277,51931076,40),(24280277,51931077,41),(24280277,51931080,42),(24280277,51931084,43),(24280277,51931087,44),(24280277,51931090,45),(24280277,51931093,46),(24280277,51931095,47),(24280277,51931097,48),(24280277,51931099,49),(24280277,51931101,50),(24280277,51931103,51),(24280277,51931105,52),(24280278,53275508,1),(24280278,53275510,2),(24280279,53275510,1),(24280279,53275511,2),(24280279,53275512,3),(24280279,53275514,4),(24280279,53275515,5),(24280279,53275516,6),(24280279,53275517,7),(24280279,53275518,8),(24280279,53275519,9),(24280279,53275032,10),(24280280,262892996,1),(24280280,262892997,2),(24280281,262892997,1),(24280281,625259,2),(24280281,53275032,3),(24280282,262892998,1),(24280282,262892999,2),(24280283,262892999,1),(24280283,53275040,2),(24280284,52652127,1),(24280284,52650659,2),(24280285,262893000,1),(24280285,52652127,2),(24280286,52009168,1),(24280286,52009171,2),(24280287,52009171,1),(24280287,52009174,2),(24280287,52009176,3),(24280287,52009179,4),(24280287,52009182,5),(24280287,52009184,6),(24280287,52009186,7),(24280287,52009189,8),(24280287,52009192,9),(24280287,52009194,10),(24280287,52009196,11),(24280288,51557999,1),(24280288,51558001,2),(24280289,51558001,1),(24280289,51558003,2),(24280289,51558005,3),(24280289,51558007,4),(24280289,51558010,5),(24280289,51558014,6),(24280289,51558017,7),(24280289,51558021,8),(24280289,51558024,9),(24280289,51558026,10),(24280289,51558029,11),(24280289,51558031,12),(24280289,51558033,13),(24280289,51558036,14),(24280289,51558038,15),(24280289,51558040,16),(24280289,51558041,17),(24280289,51558043,18),(24280289,51558045,19),(24280289,51558047,20),(24280289,51558051,21),(24280289,51558054,22),(24280289,51558057,23),(24280289,51558059,24),(24280289,51558060,25),(24280289,51558063,26),(24280289,51558064,27),(24280289,51558067,28),(24280289,51558070,29),(24280289,51558071,30),(24280289,51558074,31),(24280289,51558075,32),(24280289,51558078,33),(24280289,51558083,34),(24280289,51558085,35),(24280289,51558086,36),(24280289,51558089,37),(24280289,51558091,38),(24280289,51558093,39),(24280289,51558095,40),(24280289,51558097,41),(24280289,51558099,42),(24280289,51558103,43),(24280289,51558105,44),(24280289,51558108,45),(24280289,51558111,46),(24280289,51558113,47),(24280289,51558115,48),(24280289,51558118,49),(24280289,51558121,50),(24280289,51558124,51),(24280289,51558125,52),(24280289,51558128,53),(24280289,51558131,54),(24280289,51558246,55),(24280289,51558248,56),(24280289,51558253,57),(24280289,51558257,58),(24280289,51558260,59),(24280289,51558262,60),(24280289,51558265,61),(24280289,51558268,62),(24280289,51558271,63),(24280289,51558273,64),(24280289,51558276,65),(24280289,51558279,66),(24280289,51558282,67),(24280289,51558284,68),(24280289,51558287,69),(24280289,51558293,70),(24280290,262893002,1),(24280290,51552747,2),(24280290,262893001,3),(24280291,262893001,1),(24280291,51552750,2),(24280291,53327812,3),(24280291,51552755,4),(24280291,51552758,5),(24280291,51552761,6),(24280291,51552762,7),(24280291,51552764,8),(24280291,51552766,9),(24280291,51552768,10),(24280291,51552770,11),(24280291,51552773,12),(24280291,51552774,13),(24280291,51552777,14),(24280291,51552779,15),(24280291,51552782,16),(24280291,51552785,17),(24280291,51552787,18),(24280291,51552789,19),(24280291,51552791,20),(24280291,51552793,21),(24280291,51552797,22),(24280291,51552800,23),(24280291,51552802,24),(24280291,51552806,25),(24280291,51552807,26),(24280291,51552811,27),(24280291,51552814,28),(24280291,51552815,29),(24280291,51552818,30),(24280291,51552821,31),(24280291,51552823,32),(24280291,51552824,33),(24280291,51552825,34),(24280291,51552828,35),(24280291,51552830,36),(24280291,51552832,37),(24280291,51552835,38),(24280291,51552838,39),(24280291,51552841,40),(24280291,51552844,41),(24280291,51552847,42),(24280291,51552849,43),(24280291,51552851,44),(24280291,51552852,45),(24280291,51552854,46),(24280291,51552856,47),(24280291,51552859,48),(24280291,51552861,49),(24280291,51552863,50),(24280291,51552865,51),(24280291,51552868,52),(24280291,51552871,53),(24280291,51552873,54),(24280291,51552875,55),(24280292,52204445,1),(24280292,268084313,2),(24280292,52204442,3),(24280292,52204439,4),(24280292,52204436,5),(24280292,52204434,6),(24280292,52204431,7),(24280292,52204428,8),(24280292,52204425,9),(24280292,52204423,10),(24280292,52204420,11),(24280292,52204417,12),(24280292,52204415,13),(24280292,52204401,14),(24280292,52204397,15),(24280292,52204394,16),(24280292,52204391,17),(24280292,52204388,18),(24280292,52204386,19),(24280292,52204383,20),(24280292,52204380,21),(24280292,52204377,22),(24280292,52204375,23),(24280292,52204371,24),(24280292,52204368,25),(24280292,52204366,26),(24280292,52204363,27),(24280292,52204354,28),(24280292,52204353,29),(24280292,52204350,30),(24280292,52204344,31),(24280292,52204328,32),(24280292,52204324,33),(24280292,52204307,34),(24280292,52204296,35),(24280292,52204294,36),(24280292,52204292,37),(24280292,52204291,38),(24280292,268134045,39),(24280292,52204407,40),(24280292,52204288,41),(24280292,52204404,42),(24280292,52204284,43),(24280292,52204280,44),(24280292,52204275,45),(24280292,52204269,46),(24280292,52204267,47),(24280292,268132091,48),(24280292,52204265,49),(24280292,52204261,50),(24280292,52204258,51),(24280292,52204254,52),(24280292,268148594,53),(24280292,52204251,54),(24280292,52204248,55),(24280292,52204246,56),(24280292,52204243,57),(24280292,268096306,58),(24280292,52204239,59),(24280292,52203066,60),(24280292,52202579,61),(24280292,52202571,62),(24280292,268123710,63),(24280292,268123182,64),(24280292,268123711,65),(24280292,52202566,66),(24280292,52202560,67),(24280292,52202553,68),(24280292,52202552,69),(24280292,52202549,70),(24280292,52202545,71),(24280292,268093053,72),(24280293,52204467,1),(24280293,262893003,2),(24280294,262893003,1),(24280294,52204465,2),(24280294,268085831,3),(24280294,52204462,4),(24280294,52204459,5),(24280294,52204456,6),(24280294,52204453,7),(24280294,52204450,8),(24280294,52204446,9),(24280295,51121956,1),(24280295,51121957,2),(24280295,51121958,3),(24280296,51121958,1),(24280296,51121959,2),(24280296,51121960,3),(24280296,51121962,4),(24280296,51121964,5),(24280296,51121965,6),(24280296,51121967,7),(24280296,51121968,8),(24280296,51121970,9),(24280296,51121972,10),(24280296,258823161,11),(24341039,264054001,1),(24341039,264054002,2),(24341039,264054003,3),(24341039,264054004,4),(24341039,264054005,5),(24341039,264054006,6),(24341039,264054007,7),(24341039,264054008,8),(24341039,264054009,9),(24341039,264054010,10),(24341039,264054011,11),(24341039,264054012,12),(24341039,264054013,13),(24341039,264054014,14),(24341039,264054016,15),(24341039,264054017,16),(24341039,264054018,17),(24341039,264054019,18),(24341039,264054020,19),(24341039,264054021,20),(24341039,264054022,21),(24341039,264054023,22),(24341039,264054024,23),(24341039,264053269,24),(24360470,51930447,1),(24360470,264271683,2),(24360470,264271684,3),(24360470,264271685,4),(24360470,264271686,5),(24360470,264271687,6),(24360470,264271688,7),(24360470,264271689,8),(24360470,264271690,9),(24360470,264271691,10),(24360470,264271692,11),(24360470,264271693,12),(24360470,264271694,13),(24360470,264271695,14),(24360470,264271696,15),(24360470,264271697,16),(24360470,264271698,17),(24360470,264271699,18),(24360470,264271700,19),(24360470,264271701,20),(24360537,264272401,1),(24360537,264272402,2),(24360537,264272403,3),(24360537,51930447,4),(24360617,264273116,1),(24360617,264273117,2),(24360845,264274337,1),(24360845,264274336,2),(24360845,264274335,3),(24360845,264274334,4),(24360845,264274333,5),(24360845,264274332,6),(24360845,264274331,7),(24360845,264274330,8),(24360845,264274329,9),(24360845,264274328,10),(24360845,264274327,11),(24360845,264274326,12),(24360845,264274325,13),(24360845,264274324,14),(24360845,264274323,15),(24360845,264274322,16),(24360845,264274321,17),(24360845,264274320,18),(24360845,264274319,19),(24360845,264274318,20),(24360845,264274317,21),(24360845,264274316,22),(24360845,264274315,23),(24360845,264274314,24),(24360845,264274313,25),(24360845,264274312,26),(24360845,264274311,27),(24360845,264274310,28),(24360845,264274309,29),(24360845,264274308,30),(24360845,264274307,31),(24360845,264274306,32),(24360845,264274305,33),(24360845,264274304,34),(24360845,264274303,35),(24360845,264273117,36),(24360845,264274302,37),(24360845,264274301,38),(24360845,264274300,39),(24360845,264274299,40),(24360845,264274298,41),(24360845,264274297,42),(24360845,264274296,43),(24360845,264274295,44),(24360845,264274294,45),(24360845,264274293,46),(24360845,264274292,47),(24360845,264274291,48),(24360845,264274290,49),(24360845,264274289,50),(24360845,264274288,51),(24361232,264278117,1),(24361232,264278118,2),(24361232,264278119,3),(24361232,264278120,4),(24361232,264278121,5),(24361232,264278122,6),(24361232,264278123,7),(24361232,264278124,8),(24361241,264278152,1),(24361241,264278153,2),(24361241,264278154,3),(24361241,264278155,4),(24361241,264278156,5),(24361241,264278157,6),(24361241,264278158,7),(24361241,264278159,8),(24361307,51444392,1),(24361307,51444393,2),(24361307,51444394,3),(24361307,51444395,4),(24361318,51444395,1),(24361318,51444396,2),(24361318,51444397,3),(24361318,51444398,4),(24361318,51444399,5),(24361318,51444401,6),(24361367,51444444,1),(24361367,51444384,2),(24361367,51444386,3),(24361367,51444387,4),(24361367,51444388,5),(24361367,51444391,6),(24361367,264279593,7),(24361367,51444392,8),(24361435,51444408,1),(24361435,51444410,2),(24361435,51444411,3),(24361435,51443662,4),(24361435,51443663,5),(24361435,51443665,6),(24361435,51443668,7),(24361435,264283312,8),(24361435,51443669,9),(24361435,51443670,10),(24361435,51443671,11),(24361435,51443672,12),(24361435,51443673,13),(24361435,51443676,14),(24361435,51443678,15),(24361435,51443679,16),(24361435,51443680,17),(24361435,51443683,18),(24361435,51443685,19),(24361435,51445785,20),(24361575,51404888,1),(24361575,51399285,2),(24361575,51404889,3),(24361575,51404891,4),(24361575,51399377,5),(24361575,51404893,6),(24361575,51399296,7),(24361575,51404642,8),(24361575,51404632,9),(24361984,264294716,1),(24361984,264289240,2),(24361984,264289241,3),(24361984,264289242,4),(24362026,264290433,1),(24362026,264290434,2),(24362026,264290436,3),(24362026,264290437,4),(24362026,264290438,5),(24362026,264290439,6),(24362026,264292670,7),(24362252,264292663,1),(24362252,264292664,2),(24362252,264292665,3),(24362252,264292666,4),(24362252,264292667,5),(24362252,264292669,6),(24362252,264292670,7),(24362255,264292670,1),(24362255,264292671,2),(24362255,264292672,3),(24362255,264292673,4),(24362361,264305363,1),(24362361,264304664,2),(24362361,264304665,3),(24362361,264304666,4),(24362714,51446494,1),(24362714,51446496,2),(24362714,51446497,3),(24362714,51446498,4),(24362714,51406810,5),(24362802,51410094,1),(24362802,51405539,2),(24362802,51405540,3),(24362802,51405542,4),(24362802,51405543,5),(24362802,51405544,6),(24362802,51405547,7),(24362802,264292673,8),(24362802,51405548,9),(24362802,51405550,10),(24362802,51404720,11),(24364447,264331301,1),(24364447,264331302,2),(24364447,264331303,3),(24364447,535384824,4),(24364447,264331304,5),(24364447,264331305,6),(24364447,264331306,7),(24364447,264331307,8),(24364447,264331308,9),(24364447,264331309,10),(24364447,264330869,11),(24364513,264330869,1),(24364513,264330870,2),(24364799,51404720,1),(24364799,51404721,2),(24364799,51404723,3),(24364799,51443319,4),(24364799,51404725,5),(24364799,51404726,6),(24364799,51404727,7),(24364799,51404632,8),(24364799,51404633,9),(24364799,51404481,10),(24364799,51404482,11),(24364799,51404483,12),(24364799,51404484,13),(24364799,51443089,14),(24364799,51404486,15),(24367429,53327741,1),(24367429,53327743,2),(24367429,53327746,3),(24367429,53327748,4),(24367429,53327749,5),(24367429,53327752,6),(24367429,53327753,7),(24367429,53327755,8),(24367429,53327756,9),(24367429,53327757,10),(24367429,53327758,11),(24367429,53327759,12),(24367429,53327760,13),(24367429,53327763,14),(24367429,53327765,15),(24367429,53327768,16),(24367429,53327769,17),(24367429,53327771,18),(24367429,53327772,19),(24367429,53327775,20),(24367429,53327779,21),(24367429,53327782,22),(24367429,53327789,23),(24367429,53327791,24),(24367429,53327794,25),(24367429,53327799,26),(24367429,53327804,27),(24367429,53327808,28),(24367429,53327812,29),(24374047,264465123,1),(24374047,264465124,2),(24374048,264465124,1),(24374048,51582213,2),(24374048,51582216,3),(24374048,51582218,4),(24374048,51582221,5),(24374048,51582224,6),(24374048,51582227,7),(24374048,51582229,8),(24374048,51582231,9),(24374048,51582233,10),(24374048,51582234,11),(24374048,51582237,12),(24374048,51582239,13),(24374048,51582241,14),(24374048,51582242,15),(24374048,51582245,16),(24374048,51582247,17),(24374048,51582251,18),(24374048,51582253,19),(24374048,51582256,20),(24374048,51582258,21),(24374048,51582261,22),(24374048,51582264,23),(24374048,51582267,24),(24374048,51582270,25),(24374048,51582271,26),(24374048,51582274,27),(24374048,52168228,28),(24374048,51582279,29),(24374048,51582282,30),(24374048,51582284,31),(24374048,51582287,32),(24374048,51582290,33),(24374048,51582293,34),(24374048,51582294,35),(24374048,51582297,36),(24374048,51582300,37),(24374048,316985239,38),(24374048,51582303,39),(24374048,51582306,40),(24374048,51582308,41),(24374048,51582309,42),(24374048,51582311,43),(24374048,51582313,44),(24374048,51582315,45),(24374048,51582316,46),(24374048,51582318,47),(24374048,51582320,48),(24374048,51582323,49),(24374048,51582326,50),(24374048,51582329,51),(24374048,51582332,52),(24374048,51582335,53),(24374048,51582338,54),(24374048,51582339,55),(24374048,51582342,56),(24374048,51582345,57),(24374048,51582346,58),(24374048,51582349,59),(24374048,51582352,60),(24374048,51582355,61),(24374048,51582357,62),(24374048,51582360,63),(24374048,51582362,64),(24374048,51582365,65),(24374048,51582368,66),(24374048,51582371,67),(24374048,51582373,68),(24374048,51582377,69),(24374048,51582380,70),(24374048,51582383,71),(24374048,51582385,72),(24374048,51582388,73),(24374048,51582392,74),(24374048,51582395,75),(24374048,51582399,76),(24374048,51582403,77),(24374048,51582405,78),(24374048,51582407,79),(24374048,51582410,80),(24374048,51582413,81),(24374048,51582415,82),(24374048,51582418,83),(24374048,51582421,84),(24374048,51582424,85),(24374048,51582426,86),(24374048,51582429,87),(24374048,51582432,88),(24374048,51582435,89),(24374048,51582437,90),(24374048,51582439,91),(24374048,51582441,92),(24374048,51582444,93),(24374048,51582446,94),(24374048,51582448,95),(24374048,51582451,96),(24374048,51582453,97),(24374048,51582455,98),(24374048,51582459,99),(24374048,51582462,100),(24374048,51582463,101),(24374048,51582465,102),(24374048,51582469,103),(24374048,51582472,104),(24374048,51582474,105),(24374048,51582476,106),(24374048,51582479,107),(24374048,51582482,108),(24374048,51582483,109),(24374048,51582486,110),(24374048,51582489,111),(24374048,51582492,112),(24374048,51582495,113),(24374048,51582496,114),(24374048,51582499,115),(24374048,51582501,116),(24374048,51582502,117),(24374048,51582504,118),(24374048,51582506,119),(24374048,51582508,120),(24374048,51582509,121),(24374048,51582510,122),(24374048,51582512,123),(24374048,51582516,124),(24374048,51582518,125),(24374048,51582521,126),(24374048,51582523,127),(24374048,51582525,128),(24374048,51582527,129),(24374048,51952849,130),(24374048,51582530,131),(24374048,51952527,132),(24374048,51952525,133),(24374048,51952524,134),(24374048,51952523,135),(24374048,51952520,136),(24374048,51952517,137),(24374048,51952515,138),(24374048,51952513,139),(24374048,51952512,140),(24374048,51952510,141),(24374048,51952508,142),(24374048,51952506,143),(24374048,51952504,144),(24374048,51952502,145),(24374048,51952500,146),(24374048,51952498,147),(24374048,51952495,148),(24374048,51952492,149),(24374048,51952490,150),(24374048,51952487,151),(24374048,51952484,152),(24374048,51952481,153),(24374048,51952478,154),(24374048,51952475,155),(24374048,51952472,156),(24374048,51952468,157),(24374048,51952465,158),(24374048,51952463,159),(24374048,51952460,160),(24374048,51952457,161),(24374048,51952455,162),(24374048,51952452,163),(24374048,51952449,164),(24374048,51952446,165),(24374048,51952444,166),(24374048,51952441,167),(24374048,51952430,168),(24374048,51952429,169),(24374048,51952426,170),(24374048,51952433,171),(24374048,51952423,172),(24374048,51952436,173),(24374048,51952420,174),(24374048,51952418,175),(24374048,51952439,176),(24374048,51952416,177),(24374048,51952413,178),(24374048,51952411,179),(24374048,51952408,180),(24374048,51952405,181),(24374048,51952403,182),(24374048,51952399,183),(24374048,51952396,184),(24374048,51952394,185),(24374048,51952390,186),(24374048,51952388,187),(24374048,51952385,188),(24374048,51952382,189),(24374048,51952378,190),(24374048,51952376,191),(24374048,51952373,192),(24374048,51952369,193),(24374048,51952367,194),(24374048,51952365,195),(24374048,51952362,196),(24374048,51952359,197),(24374048,51952354,198),(24374048,51952351,199),(24374048,51952350,200),(24374048,51952347,201),(24374048,51952345,202),(24374048,51952343,203),(24374048,51952341,204),(24374048,51952338,205),(24374048,51952335,206),(24374048,51952333,207),(24374048,51952330,208),(24374048,51952328,209),(24374048,51952325,210),(24374048,51952323,211),(24374048,51952320,212),(24374048,51952316,213),(24374048,51952311,214),(24374048,51952307,215),(24374048,51952306,216),(24374048,51952305,217),(24374048,51952303,218),(24374048,51952300,219),(24374048,51952297,220),(24374048,51952295,221),(24374048,51952292,222),(24374048,51952290,223),(24374048,51952287,224),(24374048,51952284,225),(24374048,51952280,226),(24374048,51952279,227),(24374048,51952276,228),(24374048,51952274,229),(24374048,51952271,230),(24374048,51952269,231),(24374048,51952267,232),(24374048,51952264,233),(24374048,51952261,234),(24374049,51952261,1),(24374049,51952259,2),(24374050,51952259,1),(24374050,51952256,2),(24374050,51952255,3),(24374050,51952252,4),(24374050,51952250,5),(24374050,51952248,6),(24374050,51952246,7),(24374050,51952243,8),(24374050,51952240,9),(24374050,51952238,10),(24374050,51952236,11),(24374050,51952233,12),(24374050,51952230,13),(24374050,51952226,14),(24374050,51952223,15),(24374050,51952220,16),(24374050,51952217,17),(24374050,51952215,18),(24374050,51952213,19),(24374050,51952210,20),(24374050,51952207,21),(24374050,51952205,22),(24374050,51952204,23),(24374050,51952201,24),(24374050,51952199,25),(24374050,51952196,26),(24374050,51952195,27),(24374050,51952193,28),(24374050,51952192,29),(24374050,51952190,30),(24374050,51952187,31),(24374050,51952185,32),(24374050,51952183,33),(24374050,51952180,34),(24374050,51952177,35),(24374050,51952176,36),(24374050,51952172,37),(24374050,51952170,38),(24374050,51952167,39),(24374050,51952163,40),(24374050,51952161,41),(24374050,51952159,42),(24374050,51952157,43),(24374050,51952155,44),(24374050,51952152,45),(24374050,51952150,46),(24374050,51952148,47),(24374050,51952145,48),(24374050,51952141,49),(24374050,51952139,50),(24374050,51952136,51),(24374050,51952132,52),(24374050,51952128,53),(24374050,51952126,54),(24374050,51952125,55),(24374050,51952122,56),(24374050,51952120,57),(24374050,51952118,58),(24374051,264465125,1),(24374051,51581874,2),(24374052,51581874,1),(24374052,51581876,2),(24374052,51581877,3),(24374052,51581881,4),(24374052,51581883,5),(24374052,51581886,6),(24374052,51581888,7),(24374052,51581890,8),(24374052,51581895,9),(24374052,51581898,10),(24374052,51581902,11),(24374052,51581904,12),(24374052,51581906,13),(24374052,51581910,14),(24374052,266325399,15),(24374052,51581912,16),(24374052,51581914,17),(24374052,51581916,18),(24374052,51581922,19),(24374052,51581923,20),(24374052,51581926,21),(24374052,51581928,22),(24374052,51581931,23),(24374052,51581932,24),(24374052,51581936,25),(24374052,51581939,26),(24374052,51581941,27),(24374052,51581944,28),(24374052,266622050,29),(24374052,51581946,30),(24374052,262465820,31),(24374052,51581951,32),(24374052,51581955,33),(24374052,51581958,34),(24374052,51581960,35),(24374052,51581962,36),(24374052,277375056,37),(24374052,51581964,38),(24374052,51581967,39),(24374052,51581970,40),(24374052,51581973,41),(24374052,51581976,42),(24374052,51581979,43),(24374052,51581980,44),(24374052,51581983,45),(24374052,266322954,46),(24374052,51581986,47),(24374052,51581990,48),(24374052,51581993,49),(24374052,51581995,50),(24374052,51581997,51),(24374052,266622986,52),(24374052,51582003,53),(24374052,51582007,54),(24374052,51582009,55),(24374052,51582013,56),(24374052,51582019,57),(24374052,51582023,58),(24374052,51582027,59),(24374052,51582031,60),(24374052,51582034,61),(24374052,268081065,62),(24374052,262464083,63),(24374052,51582038,64),(24374052,51582045,65),(24374052,51582060,66),(24374052,51582066,67),(24374052,51582074,68),(24374052,51582077,69),(24374052,51582082,70),(24374052,51582085,71),(24374052,51582086,72),(24374052,51582089,73),(24374052,51582090,74),(24374052,51582091,75),(24374052,51582093,76),(24374052,51582096,77),(24374052,51582098,78),(24374052,51582101,79),(24374052,51582102,80),(24374052,51582105,81),(24374052,51582107,82),(24374052,51582110,83),(24374052,51582111,84),(24374052,51582113,85),(24374052,51582116,86),(24374052,51582118,87),(24374052,51582121,88),(24374052,51582123,89),(24374052,51582125,90),(24374052,51582128,91),(24374052,51582132,92),(24374052,268612922,93),(24374052,268612923,94),(24374052,51582133,95),(24374052,51582135,96),(24374052,51582137,97),(24374052,268614412,98),(24374052,51582139,99),(24374052,51582143,100),(24374052,51582146,101),(24374052,51582148,102),(24374052,51582150,103),(24374052,51582153,104),(24374052,51582156,105),(24374052,51582159,106),(24374052,51582162,107),(24374052,51582166,108),(24374052,51582167,109),(24374052,51582170,110),(24374052,51582173,111),(24374052,51582175,112),(24374054,264465128,1),(24374054,264465129,2),(24374055,264465129,1),(24374055,52613154,2),(24374055,52613157,3),(24374055,52613159,4),(24374055,52613162,5),(24374055,264465127,6),(24374056,264465127,1),(24374056,52613163,2),(24374057,52613163,1),(24374057,52613166,2),(24374057,52613167,3),(24374057,52613170,4),(24374057,52613172,5),(24374057,52613173,6),(24374057,52613175,7),(24374057,52613176,8),(24374057,52613178,9),(24374057,52613179,10),(24374057,52613182,11),(24374057,52613184,12),(24374057,52613186,13),(24374057,52613189,14),(24374057,52613192,15),(24374057,52613196,16),(24374057,52613199,17),(24374057,52613201,18),(24374057,52613204,19),(24374057,52613212,20),(24374057,52613214,21),(24374057,52613217,22),(24374057,52613221,23),(24374057,52613223,24),(24374057,52613224,25),(24374057,52613226,26),(24374057,52613228,27),(24374057,52613231,28),(24374057,52613233,29),(24374057,52613235,30),(24374057,52613237,31),(24374057,52613238,32),(24374057,52613244,33),(24374057,52613246,34),(24374057,52613249,35),(24374057,52613252,36),(24374057,52613256,37),(24374057,52613258,38),(24374057,52613260,39),(24374057,52613262,40),(24374057,52613264,41),(24374057,52613267,42),(24374057,52613270,43),(24374057,52613272,44),(24374057,52613274,45),(24374064,264465130,1),(24374064,52206684,2),(24374065,52206684,1),(24374065,52206686,2),(24374065,52206688,3),(24376755,264495540,1),(24376755,264495541,2),(24376755,264495542,3),(24376755,264495543,4),(24376755,264495544,5),(24376812,264495953,1),(24376812,264495952,2),(24376812,264495951,3),(24376812,264495950,4),(24376812,264495949,5),(24376812,264495948,6),(24376812,264495947,7),(24376812,264495946,8),(24376812,264495945,9),(24376812,264495944,10),(24376812,264495943,11),(24376812,264495942,12),(24376812,264495941,13),(24376812,264495940,14),(24376812,264495939,15),(24376812,264495938,16),(24377511,264501521,1),(24377511,264501522,2),(24377511,264501523,3),(24377511,264501524,4),(24377511,264501525,5),(24377511,264501526,6),(24377511,264501527,7),(24377511,264501528,8),(24377558,264501528,1),(24377558,264502059,2),(24377558,264502060,3),(24377558,264502061,4),(24377558,264502062,5),(24377558,264502063,6),(24377558,264502064,7),(24377558,264502065,8),(24377663,264502898,1),(24377663,264502899,2),(24377663,264502900,3),(24377663,264502901,4),(24377663,264502902,5),(24377663,264502903,6),(24377663,264502904,7),(24377663,264502905,8),(24377663,264502906,9),(24377663,264502907,10),(24377663,264502908,11),(24377663,264502909,12),(24377663,264502910,13),(24377663,264502912,14),(24377663,264502914,15),(24377663,264502916,16),(24377663,264502918,17),(24377667,264502905,1),(24377667,264502985,2),(24377667,264502987,3),(24377667,264502988,4),(24377667,264502989,5),(24377667,264502990,6),(24405095,264908763,1),(24405095,264331301,2),(24405096,264908764,1),(24405096,264908765,2),(24405096,264908766,3),(24405096,264910825,4),(24405096,264908767,5),(24405096,264908768,6),(24405096,264908769,7),(24405096,264908770,8),(24405096,264908771,9),(24405096,264908763,10),(24405131,264906170,1),(24405131,51552459,2),(24405131,51552456,3),(24405131,51552453,4),(24405131,51552451,5),(24405131,51552447,6),(24405131,51552445,7),(24405131,51552444,8),(24405131,51552442,9),(24405159,268619784,1),(24405159,264909492,2),(24405159,264909491,3),(24405159,264909490,4),(24405159,264909489,5),(24405159,264909488,6),(24405159,264909487,7),(24405159,264909486,8),(24405159,264909485,9),(24405159,264910825,10),(24405221,51552442,1),(24405221,264908764,2),(24405221,51552440,3),(24405221,51552437,4),(24405221,51552504,5),(24405221,51552434,6),(24405221,264906764,7),(24405221,51552432,8),(24405221,51552429,9),(24405221,264907017,10),(24405221,268619784,11),(24405221,264909493,12),(24405221,51552422,13),(24405221,51552419,14),(24405221,51552416,15),(24405221,51552413,16),(24405221,51552405,17),(24405221,264910379,18),(24406052,264910379,1),(24406052,51552408,2),(24406052,51552410,3),(24406052,51406783,4),(24406052,51406784,5),(24406052,51406785,6),(24406052,51406787,7),(24406052,51406789,8),(24406052,51406790,9),(24406052,51408311,10),(24406052,51406791,11),(24406052,51406792,12),(24406052,51406793,13),(24406052,51406795,14),(24406052,51406797,15),(24406052,51406798,16),(24406052,51406800,17),(24406052,51406803,18),(24406052,51406805,19),(24406052,51406807,20),(24406052,51406808,21),(24406052,51406810,22),(24406052,51406811,23),(24406326,264932311,1),(24406326,264932343,2),(24406326,264932342,3),(24406326,264932341,4),(24406326,264932340,5),(24406326,264932330,6),(24406326,264932329,7),(24406326,264932328,8),(24406326,264932327,9),(24406326,264932326,10),(24406326,264932325,11),(24406326,264932322,12),(24406326,264932321,13),(24406326,264932319,14),(24406326,264932318,15),(24406326,264932317,16),(24406326,264932316,17),(24406326,264932315,18),(24406326,264932314,19),(24406326,264932311,20),(24406327,264932344,1),(24406327,264932345,2),(24406327,264932347,3),(24406327,264932348,4),(24406327,264932349,5),(24406327,264932350,6),(24406327,264932351,7),(24406327,264932352,8),(24406327,264932353,9),(24406327,264932344,10),(24406328,264932501,1),(24406328,264932354,2),(24406328,264932355,3),(24406328,264932356,4),(24406328,264932357,5),(24406328,264932359,6),(24406328,264932360,7),(24406328,264932361,8),(24406328,264932362,9),(24406328,264932363,10),(24406328,264932364,11),(24406328,264932365,12),(24406328,264932366,13),(24406328,264932367,14),(24406328,264932368,15),(24406328,264932370,16),(24406328,264932371,17),(24406328,264932372,18),(24406328,264932373,19),(24406328,264932374,20),(24406328,264932375,21),(24406328,264932376,22),(24406328,264932377,23),(24406328,264932379,24),(24406328,264932380,25),(24406328,264932381,26),(24406328,264932382,27),(24406328,264932383,28),(24406328,264932384,29),(24406328,264932386,30),(24406328,264932387,31),(24406328,264932388,32),(24406328,264932390,33),(24406328,264932393,34),(24406328,264932395,35),(24406328,264932396,36),(24406328,264932397,37),(24406328,264932398,38),(24406328,264932399,39),(24406328,264932400,40),(24406328,264932401,41),(24406328,264932402,42),(24406328,264932404,43),(24406328,264932405,44),(24406328,264932406,45),(24406328,264932407,46),(24406328,264932408,47),(24406328,264932409,48),(24406328,264932410,49),(24406328,264932411,50),(24406328,264932412,51),(24406328,264932414,52),(24406328,264932415,53),(24406328,264932416,54),(24406328,264932417,55),(24406328,264932420,56),(24406328,264932427,57),(24406328,264932428,58),(24406328,264932429,59),(24406328,264932430,60),(24406328,264932431,61),(24406328,264932432,62),(24406328,264932433,63),(24406328,264932435,64),(24406328,264932436,65),(24406328,264932437,66),(24406328,264932438,67),(24406328,264932439,68),(24406328,264932440,69),(24406328,264932441,70),(24406328,264932442,71),(24406328,264932444,72),(24406328,264932445,73),(24406328,264932446,74),(24406328,264932447,75),(24406328,264932448,76),(24406328,264932449,77),(24406328,264932450,78),(24406328,264932451,79),(24406328,264932452,80),(24406328,264932453,81),(24406328,264932454,82),(24406328,264932456,83),(24406328,264932457,84),(24406328,264932458,85),(24406328,264932459,86),(24406328,264932460,87),(24406328,264932461,88),(24406328,264932462,89),(24406328,264932463,90),(24406328,264932464,91),(24406328,264932465,92),(24406328,264932466,93),(24406328,264932467,94),(24406328,264932469,95),(24406328,264932470,96),(24406328,264932471,97),(24406328,264932472,98),(24406328,264932473,99),(24406328,264932474,100),(24406328,264932475,101),(24406328,264932476,102),(24406328,264932477,103),(24406328,264932478,104),(24406328,264932479,105),(24406328,264932481,106),(24406328,264932482,107),(24406328,264932483,108),(24406328,264932484,109),(24406328,264932486,110),(24406328,264932487,111),(24406328,264932488,112),(24406328,264932489,113),(24406328,264932490,114),(24406328,264932491,115),(24406328,264932492,116),(24406328,264932493,117),(24406328,264932495,118),(24406328,264932496,119),(24406328,264932497,120),(24406328,264932498,121),(24406328,264932499,122),(24406328,264932500,123),(24406328,264932501,124),(24406329,264932526,1),(24406329,264932566,2),(24406329,366061154,3),(24406329,264932565,4),(24406329,264932564,5),(24406329,264932563,6),(24406329,264932561,7),(24406329,264932560,8),(24406329,264932559,9),(24406329,264932558,10),(24406329,264932557,11),(24406329,264932556,12),(24406329,264932555,13),(24406329,264932554,14),(24406329,264932552,15),(24406329,264932503,16),(24406329,264932504,17),(24406329,264932505,18),(24406329,264932506,19),(24406329,264932507,20),(24406329,264932509,21),(24406329,264932510,22),(24406329,264932512,23),(24406329,264932513,24),(24406329,264932515,25),(24406329,264932516,26),(24406329,264932517,27),(24406329,264932518,28),(24406329,264932519,29),(24406329,264932520,30),(24406329,264932521,31),(24406329,264932522,32),(24406329,264932523,33),(24406329,264932524,34),(24406329,264932526,35),(24406331,264932529,1),(24406331,264932531,2),(24406331,264932532,3),(24406331,264932534,4),(24406331,482113773,5),(24406331,264932535,6),(24406331,264932536,7),(24406331,264932537,8),(24406331,264932538,9),(24406331,264932539,10),(24406331,264932540,11),(24406331,264932541,12),(24406331,264932543,13),(24406331,264932544,14),(24406331,264932545,15),(24406331,264932546,16),(24406331,264932547,17),(24406331,264932548,18),(24406331,264932549,19),(24406331,264932550,20),(24406331,264932551,21),(24406331,264932567,22),(24406331,264932568,23),(24406331,264932569,24),(24406331,264932570,25),(24406331,264932572,26),(24406331,264932573,27),(24406331,264932574,28),(24406331,264932575,29),(24406331,264932576,30),(24406331,264932577,31),(24406331,264932578,32),(24406331,264932579,33),(24406331,264932581,34),(24406331,264932582,35),(24406331,264932583,36),(24406331,264932584,37),(24406331,264932585,38),(24406331,264932586,39),(24406331,264932587,40),(24406331,264932589,41),(24406331,264932590,42),(24406331,264932591,43),(24406331,264932592,44),(24406331,264932593,45),(24406331,264932594,46),(24406331,264932595,47),(24406331,264932596,48),(24406331,264932598,49),(24406331,264932599,50),(24406331,264932600,51),(24406331,264932601,52),(24406331,264932602,53),(24406331,264932603,54),(24406331,264932604,55),(24406331,264932605,56),(24406331,264932606,57),(24406331,264932608,58),(24406331,264932609,59),(24406331,264932610,60),(24406331,264932611,61),(24406331,264932612,62),(24406331,264932613,63),(24406331,264932614,64),(24406331,264932615,65),(24406331,264932616,66),(24406331,264932617,67),(24406331,264932529,68),(24406332,264932619,1),(24406332,264932620,2),(24406332,264932621,3),(24406332,264932622,4),(24406332,264932623,5),(24406332,264932624,6),(24406332,264932625,7),(24406332,264932626,8),(24406332,264932627,9),(24406332,264932628,10),(24406332,264932629,11),(24406332,264932631,12),(24406332,264932632,13),(24406332,264932633,14),(24406332,264932634,15),(24406332,264932635,16),(24406332,264932636,17),(24406332,264932637,18),(24406332,264932638,19),(24406332,264932639,20),(24406332,264932641,21),(24406332,264932642,22),(24406332,264932643,23),(24406332,264932644,24),(24406332,264932645,25),(24406332,264932646,26),(24406332,264932647,27),(24406332,264932649,28),(24406332,264932650,29),(24406332,264932651,30),(24406332,264932652,31),(24406332,264932653,32),(24406332,264932654,33),(24406332,264932655,34),(24406332,264932656,35),(24406332,264932657,36),(24406332,264932658,37),(24406332,264932659,38),(24406332,264932660,39),(24406332,264932661,40),(24406332,264932662,41),(24406332,264932619,42),(24406333,264932663,1),(24406333,264932665,2),(24406333,264932666,3),(24406333,264932667,4),(24406333,264932668,5),(24406333,264932669,6),(24406333,264932670,7),(24406333,264932671,8),(24406333,264932672,9),(24406333,264932673,10),(24406333,264932675,11),(24406333,264932676,12),(24406333,264932677,13),(24406333,264932678,14),(24406333,264932679,15),(24406333,264932680,16),(24406333,264932681,17),(24406333,264932682,18),(24406333,264932684,19),(24406333,264932685,20),(24406333,264932686,21),(24406333,264932687,22),(24406333,264932688,23),(24406333,264932689,24),(24406333,264932690,25),(24406333,264932691,26),(24406333,264932693,27),(24406333,264932694,28),(24406333,264932695,29),(24406333,264932696,30),(24406333,264932697,31),(24406333,264932698,32),(24406333,264932699,33),(24406333,264932701,34),(24406333,264932702,35),(24406333,264932703,36),(24406333,264932704,37),(24406333,264932705,38),(24406333,264932706,39),(24406333,264932707,40),(24406333,264932708,41),(24406333,264932710,42),(24406333,264932711,43),(24406333,264932712,44),(24406333,264932713,45),(24406333,264932714,46),(24406333,264932715,47),(24406333,264932716,48),(24406333,264932717,49),(24406333,264932718,50),(24406333,264932719,51),(24406333,264932720,52),(24406333,264932722,53),(24406333,264932723,54),(24406333,264932724,55),(24406333,264932725,56),(24406333,264932726,57),(24406333,264932663,58),(24406334,264932727,1),(24406334,264932728,2),(24406334,264932729,3),(24406334,264932731,4),(24406334,264932732,5),(24406334,264932733,6),(24406334,264932734,7),(24406334,264932735,8),(24406334,264932736,9),(24406334,264932737,10),(24406334,264932738,11),(24406334,264932739,12),(24406334,264932740,13),(24406334,264932742,14),(24406334,264932743,15),(24406334,264932744,16),(24406334,264932745,17),(24406334,264932746,18),(24406334,264932747,19),(24406334,264932748,20),(24406334,264932749,21),(24406334,264932750,22),(24406334,264932752,23),(24406334,264932753,24),(24406334,264932754,25),(24406334,264932755,26),(24406334,264932756,27),(24406334,264932757,28),(24406334,264932759,29),(24406334,264932760,30),(24406334,264932761,31),(24406334,264932762,32),(24406334,264932763,33),(24406334,264932764,34),(24406334,264932727,35),(24406335,264932765,1),(24406335,264932766,2),(24406335,264932767,3),(24406335,264932769,4),(24406335,264932770,5),(24406335,264932771,6),(24406335,264932772,7),(24406335,264932773,8),(24406335,264932774,9),(24406335,264932775,10),(24406335,264932776,11),(24406335,264932777,12),(24406335,264932779,13),(24406335,264932780,14),(24406335,264932781,15),(24406335,264932782,16),(24406335,264932783,17),(24406335,264932784,18),(24406335,264932785,19),(24406335,264932786,20),(24406335,264932787,21),(24406335,264932788,22),(24406335,264932789,23),(24406335,264932791,24),(24406335,264932792,25),(24406335,264932793,26),(24406335,264932794,27),(24406335,264932795,28),(24406335,264932765,29),(24406336,264932796,1),(24406336,264932797,2),(24406336,264932798,3),(24406336,264932800,4),(24406336,264932801,5),(24406336,264932802,6),(24406336,264932803,7),(24406336,264932804,8),(24406336,264932805,9),(24406336,264932806,10),(24406336,264932807,11),(24406336,264932808,12),(24406336,264932809,13),(24406336,264932811,14),(24406336,264932812,15),(24406336,264932813,16),(24406336,264932814,17),(24406336,264932815,18),(24406336,264932816,19),(24406336,264932817,20),(24406336,264932818,21),(24406336,264932820,22),(24406336,264932821,23),(24406336,264932822,24),(24406336,264932823,25),(24406336,264932824,26),(24406336,264932825,27),(24406336,264932826,28),(24406336,264932827,29),(24406336,264932828,30),(24406336,264932829,31),(24406336,264932831,32),(24406336,264932832,33),(24406336,264932833,34),(24406336,264932834,35),(24406336,264932835,36),(24406336,264932836,37),(24406336,264932837,38),(24406336,264932838,39),(24406336,264932839,40),(24406336,264932840,41),(24406336,264932841,42),(24406336,264932842,43),(24406336,264932843,44),(24406336,264932844,45),(24406336,264932846,46),(24406336,264932847,47),(24406336,264932848,48),(24406336,264932849,49),(24406336,264932850,50),(24406336,264932851,51),(24406336,264932852,52),(24406336,264932853,53),(24406336,264932855,54),(24406336,264932856,55),(24406336,264932857,56),(24406336,264932858,57),(24406336,264932859,58),(24406336,264932860,59),(24406336,264932861,60),(24406336,264932862,61),(24406336,264932864,62),(24406336,264932865,63),(24406336,264932866,64),(24406336,264932867,65),(24406336,264932868,66),(24406336,264932869,67),(24406336,264932870,68),(24406336,264932871,69),(24406336,264932796,70),(24413463,51410095,1),(24413463,265050188,2),(24413466,51404882,1),(24413466,51405344,2),(24413467,264289242,1),(24413467,264289243,2),(24413467,264289244,3),(24413467,264289245,4),(24413467,264289246,5),(24413467,264289247,6),(24413467,264289248,7),(24413467,264289249,8),(24413467,264289250,9),(24413467,264289251,10),(24413467,264292663,11),(24413469,51409974,1),(24413469,264304669,2),(24413471,265050188,1),(24413471,51405270,2),(24430806,265518806,1),(24430806,264304669,2),(24430806,51409975,3),(24430806,51409976,4),(24430806,51409978,5),(24430806,51409979,6),(24430806,51409981,7),(24430806,51409983,8),(24430806,277695169,9),(24430807,264304666,1),(24430807,264304667,2),(24430807,264304668,3),(24430807,265518806,4),(24456592,53294994,1),(24456592,53294992,2),(24456592,53294989,3),(24456592,53294986,4),(24456592,53294983,5),(24456592,53294981,6),(24456592,53294979,7),(24456592,53294974,8),(24456592,53294971,9),(24456592,53294968,10),(24456592,53294965,11),(24456592,53294963,12),(24456592,53294961,13),(24456592,53294958,14),(24456592,53294953,15),(24456592,53294950,16),(24456592,53294946,17),(24456592,53294943,18),(24456592,53294939,19),(24456592,53294937,20),(24456592,53294933,21),(24456592,53294930,22),(24456592,53294929,23),(24456592,53294924,24),(24456592,53294922,25),(24456592,53294919,26),(24456592,53294917,27),(24456592,53294913,28),(24456592,53294910,29),(24456592,53294906,30),(24456592,53294904,31),(24456592,53294900,32),(24456592,53294898,33),(24456592,53294894,34),(24456592,53294891,35),(24456592,53294887,36),(24456592,53294884,37),(24456592,53294880,38),(24456592,53294877,39),(24456592,53294874,40),(24456592,53294872,41),(24456592,53294867,42),(24456592,53294866,43),(24456592,53294860,44),(24456592,53294856,45),(24456592,53294855,46),(24456592,53294851,47),(24456592,53294849,48),(24456592,53294847,49),(24456592,53294843,50),(24456592,53294838,51),(24456592,53294834,52),(24456592,53294830,53),(24456592,53294829,54),(24456592,53294826,55),(24456592,53294823,56),(24456592,53294820,57),(24456592,53294816,58),(24456592,53294813,59),(24456592,53294810,60),(24456592,53294807,61),(24456592,53294805,62),(24456592,53294803,63),(24456592,53294800,64),(24456592,53294795,65),(24456592,53294792,66),(24456592,53294790,67),(24456592,53294786,68),(24456592,53294785,69),(24456592,53294782,70),(24456592,53294777,71),(24456592,53294776,72),(24456592,53294770,73),(24456592,53294767,74),(24456592,53294764,75),(24456592,53294761,76),(24456592,53294758,77),(24456592,53294756,78),(24456592,53294755,79),(24456592,53294752,80),(24456592,53294748,81),(24456592,53294745,82),(24456592,53294740,83),(24456592,53294737,84),(24456592,53294735,85),(24456592,53294730,86),(24456592,53294728,87),(24456592,53294721,88),(24456592,53294718,89),(24456592,53294716,90),(24456592,53294714,91),(24456592,53294712,92),(24456592,53294709,93),(24456592,53294704,94),(24456592,53294702,95),(24456592,53294698,96),(24456592,53294695,97),(24456592,53294691,98),(24456592,53294689,99),(24456592,53294684,100),(24456592,53294679,101),(24456592,53294677,102),(24456592,53294675,103),(24456592,53294671,104),(24456592,53294669,105),(24456592,53294665,106),(24456592,53294661,107),(24456592,53294659,108),(24456592,53294655,109),(24456592,53294652,110),(24456592,53294648,111),(24456592,53294645,112),(24456592,53294640,113),(24456592,53294637,114),(24456592,53294634,115),(24456592,53294630,116),(24456592,53294625,117),(24456592,53294623,118),(24456592,53294620,119),(24456592,53294616,120),(24456592,366578105,121),(24456592,53294613,122),(24456592,53294610,123),(24456592,53294607,124),(24456592,366578054,125),(24456592,53294602,126),(24456592,53294601,127),(24456592,53294596,128),(24456592,53294595,129),(24456592,53294591,130),(24456592,53294588,131),(24456592,53294584,132),(24492435,266322954,1),(24492435,266322580,2),(24492437,266322676,1),(24492437,266322582,2),(24492459,266322580,1),(24492459,266322581,2),(24492463,266322581,1),(24492463,266322582,2),(24492463,266322583,3),(24492463,266322584,4),(24492463,266322585,5),(24492463,266322586,6),(24492463,266322587,7),(24492463,266322588,8),(24492463,266322589,9),(24492463,266322590,10),(24492623,266325399,1),(24492623,266325046,2),(24492644,266325224,1),(24492644,266325225,2),(24492644,266325226,3),(24492644,266325227,4),(24492644,266325048,5),(24492644,266325228,6),(24492644,266325428,7),(24492644,266325229,8),(24492644,266325230,9),(24492644,266325231,10),(24492644,266325232,11),(24492653,266325046,1),(24492653,266325047,2),(24492657,266325047,1),(24492657,266325048,2),(24492677,266325427,1),(24492677,266325428,2),(24492804,264465125,1),(24492804,266326319,2),(24492831,266326327,1),(24492831,266326487,2),(24492831,266326488,3),(24492831,266326489,4),(24492831,266326490,5),(24492831,266326491,6),(24492831,266326492,7),(24492831,266326493,8),(24492831,266326494,9),(24492831,266326495,10),(24492831,266326496,11),(24492831,266326497,12),(24492831,266326498,13),(24492831,266326499,14),(24492831,266326500,15),(24492831,266326501,16),(24492831,266326502,17),(24492831,266326503,18),(24492831,266326504,19),(24492831,266326505,20),(24492868,266326319,1),(24492868,266326320,2),(24492889,266326320,1),(24492889,266326321,2),(24492889,266326322,3),(24492889,266326323,4),(24492889,266326324,5),(24492889,266326325,6),(24492889,266326326,7),(24492889,266326327,8),(24492889,266326328,9),(24492889,266326329,10),(24492889,266326330,11),(24492889,266326331,12),(24492889,266326332,13),(24492889,266326333,14),(24492889,266326334,15),(24492889,266326335,16),(24492889,266326336,17),(24492889,266326337,18),(24492889,266326338,19),(24492889,266326339,20),(24492889,266326340,21),(24492889,266326341,22),(24492889,266326342,23),(24492889,266326343,24),(24492889,266326344,25),(24492889,266326345,26),(24492889,266326346,27),(24492889,266326347,28),(24492889,266326348,29),(24492889,266326349,30),(24492889,266326350,31),(24492906,266327106,1),(24492906,264465125,2),(24492907,266327105,1),(24492907,266327106,2),(24493028,51581778,1),(24493028,266328657,2),(24493028,266328658,3),(24493028,266328659,4),(24493028,266328660,5),(24493028,266328661,6),(24493028,266328829,7),(24493028,266328662,8),(24493028,266328663,9),(24493028,266328664,10),(24493028,266328665,11),(24493045,266328829,1),(24493045,266328830,2),(24493045,266328831,3),(24493045,266328832,4),(24493045,266328833,5),(24493045,266328834,6),(24493119,53315705,1),(24493119,53315413,2),(24493119,266329104,3),(24493119,52163588,4),(24493121,53315705,1),(24493121,266329307,2),(24493121,53315884,3),(24493121,266329120,4),(24493121,266329121,5),(24493121,266329122,6),(24493121,266329123,7),(24493121,266329124,8),(24493121,53315705,9),(24493187,266329707,1),(24493187,266329708,2),(24493187,266329709,3),(24493187,266329710,4),(24493187,266329711,5),(24493187,266329712,6),(24493187,266329713,7),(24493187,266329714,8),(24493187,266329715,9),(24493187,266329716,10),(24493187,266329717,11),(24493187,266329718,12),(24493187,266329719,13),(24493187,266329720,14),(24493187,266329721,15),(24493187,266329722,16),(24493187,266329723,17),(24493187,266329724,18),(24493187,266329725,19),(24493187,266329726,20),(24493188,266329121,1),(24493188,266329727,2),(24493188,266336982,3),(24493188,266329728,4),(24493188,266329729,5),(24493188,266329730,6),(24493188,266329731,7),(24493188,266329732,8),(24493188,266329733,9),(24493188,266329734,10),(24493188,266329735,11),(24493188,266329707,12),(24493245,266329713,1),(24493245,266330464,2),(24493247,266330502,1),(24493247,266330518,2),(24493247,266330503,3),(24493247,266330504,4),(24493247,266330505,5),(24493247,266330493,6),(24493250,266330517,1),(24493250,266330518,2),(24493261,266330483,1),(24493261,266330484,2),(24493261,266330485,3),(24493261,266330486,4),(24493261,266330487,5),(24493261,266330488,6),(24493261,266330489,7),(24493261,266330490,8),(24493261,266330491,9),(24493261,266330492,10),(24493261,266330493,11),(24493261,266330494,12),(24493261,266330495,13),(24493330,53316105,1),(24493330,266330955,2),(24493330,266330956,3),(24493330,266330957,4),(24493330,266330958,5),(24493330,266330959,6),(24493330,266330960,7),(24493330,266330961,8),(24493330,266330962,9),(24493330,266330963,10),(24493330,266330964,11),(24493330,266330965,12),(24493330,266330966,13),(24493330,53319479,14),(24493335,266331091,1),(24493335,266330991,2),(24493335,266330992,3),(24493335,266330993,4),(24493335,266330994,5),(24493335,266330995,6),(24493335,266330996,7),(24493335,266330997,8),(24493335,266331609,9),(24493335,266330998,10),(24493335,266330999,11),(24493335,266331000,12),(24493335,266331333,13),(24493335,266331001,14),(24493335,266331002,15),(24493335,266331003,16),(24493335,266331004,17),(24493335,266331005,18),(24493335,266331006,19),(24493335,266331007,20),(24493335,266331008,21),(24493335,266331009,22),(24493335,266331010,23),(24493335,266331011,24),(24493335,266331006,25),(24493338,266330999,1),(24493338,266331017,2),(24493338,266331018,3),(24493338,266331019,4),(24493338,266331020,5),(24493338,266331021,6),(24493338,266331022,7),(24493338,266331023,8),(24493362,266331233,1),(24493362,266331234,2),(24493362,266331235,3),(24493362,266331236,4),(24493362,266331237,5),(24493362,266331238,6),(24493362,266331239,7),(24493362,266331240,8),(24493362,266331241,9),(24493362,266331242,10),(24493362,266331243,11),(24493378,266331332,1),(24493378,266331333,2),(24493431,266331567,1),(24493431,266331568,2),(24493431,266331569,3),(24493431,266331570,4),(24493431,266331567,5),(24493439,266330996,1),(24493439,266331607,2),(24493439,266331608,3),(24493439,266331609,4),(24493444,266331623,1),(24493444,266331624,2),(24493444,266331625,3),(24493444,266331626,4),(24493444,266331627,5),(24493444,266331628,6),(24493444,266331623,7),(24493526,266332075,1),(24493526,266332076,2),(24493528,266332076,1),(24493528,266333982,2),(24493528,266332077,3),(24493528,266332078,4),(24493528,266332079,5),(24493528,266332080,6),(24493528,266332081,7),(24493528,266332082,8),(24493528,266332083,9),(24493528,266332084,10),(24493528,266332085,11),(24493528,266332086,12),(24493528,266332087,13),(24493570,266332790,1),(24493570,266331986,2),(24493570,266331987,3),(24493570,266331988,4),(24493570,266331989,5),(24493584,51587726,1),(24493584,266331984,2),(24493584,266332950,3),(24493584,266332790,4),(24493584,266332075,5),(24493641,266333823,1),(24493641,51581745,2),(24493647,266333914,1),(24493647,266333915,2),(24493647,266333916,3),(24493647,266333917,4),(24493659,266333981,1),(24493659,266333982,2),(24493664,266334276,1),(24493664,266334277,2),(24493664,266334278,3),(24493664,266334279,4),(24493664,266334280,5),(24493664,266334281,6),(24493664,266334282,7),(24493664,266334283,8),(24493664,266334284,9),(24493664,266334285,10),(24493664,266334286,11),(24493664,266334287,12),(24493664,266334288,13),(24493664,266334289,14),(24493664,266334290,15),(24493664,266334276,16),(24493679,266334665,1),(24493679,266334666,2),(24493679,266334668,3),(24493679,266334669,4),(24493679,266334670,5),(24493679,266334671,6),(24493679,266334672,7),(24493789,266329719,1),(24493789,266336448,2),(24493890,266337369,1),(24493890,266337370,2),(24493890,266337371,3),(24493890,266337372,4),(24493890,266337373,5),(24493890,266337374,6),(24493890,266337375,7),(24493890,266337377,8),(24493890,266337378,9),(24493890,266337379,10),(24493890,266337380,11),(24493890,266337381,12),(24493890,266337382,13),(24493890,266337384,14),(24493890,266337386,15),(24493890,266337388,16),(24493890,266337389,17),(24493890,266337390,18),(24493890,266337391,19),(24493890,266337392,20),(24493890,266337393,21),(24493890,266337394,22),(24493890,266337395,23),(24493890,266337396,24),(24493890,266337397,25);
INSERT INTO `current_way_nodes` VALUES (24493895,266336448,1),(24493895,266336449,2),(24493896,266336449,1),(24493896,266336450,2),(24493896,266336451,3),(24493896,266336452,4),(24493896,266336453,5),(24493896,266336454,6),(24493896,266336455,7),(24493896,266336456,8),(24493896,266336457,9),(24493896,266330466,10),(24493927,266330483,1),(24493927,266330482,2),(24493927,266330481,3),(24493927,266330480,4),(24493927,266330479,5),(24493927,266330478,6),(24493927,266330477,7),(24493927,266330476,8),(24493927,266330475,9),(24493967,52166950,1),(24493967,51581810,2),(24493967,51581813,3),(24493967,51581814,4),(24493967,51581818,5),(24493967,51581821,6),(24493967,51581823,7),(24493967,51581826,8),(24493967,51581828,9),(24493967,51581829,10),(24493967,51581832,11),(24493967,51581835,12),(24493967,51581837,13),(24493967,51581840,14),(24493967,51581843,15),(24493967,51581846,16),(24493967,51581849,17),(24493967,51581852,18),(24493967,51581854,19),(24493967,51581857,20),(24493967,51581861,21),(24493967,51581863,22),(24493967,51581868,23),(24493967,266327105,24),(24494051,266341806,1),(24494051,266340717,2),(24494073,266340993,1),(24494073,266340994,2),(24494073,266340995,3),(24494073,266340996,4),(24494073,266340998,5),(24494073,266340999,6),(24494073,266341000,7),(24494073,266341001,8),(24494073,266341002,9),(24494073,266341003,10),(24494073,266341004,11),(24494073,266341005,12),(24494073,266341006,13),(24494073,266341007,14),(24494073,266340993,15),(24494162,266340717,1),(24494162,266340718,2),(24494164,266340718,1),(24494164,266340719,2),(24494164,266340720,3),(24494164,266340721,4),(24494164,266340722,5),(24497076,266380266,1),(24497076,266380267,2),(24497077,266380268,1),(24497077,266380266,2),(24512879,266326345,1),(24512879,266326393,2),(24512879,266326394,3),(24512879,266326395,4),(24512879,266326396,5),(24512879,266326397,6),(24512879,266326398,7),(24512879,266326399,8),(24517626,51581670,1),(24517626,266619895,2),(24517626,266619896,3),(24517626,266619897,4),(24517626,266619898,5),(24517626,266619899,6),(24517626,266619900,7),(24517626,266619901,8),(24517626,266619902,9),(24517626,266619903,10),(24517626,266619904,11),(24517626,266619905,12),(24517626,266619906,13),(24517626,266619907,14),(24517626,266619908,15),(24517626,266619909,16),(24517633,266619906,1),(24517633,266619955,2),(24517633,266619956,3),(24517644,266619897,1),(24517644,266620044,2),(24517644,266620043,3),(24517644,266620042,4),(24517644,266620041,5),(24517644,266620040,6),(24517841,266622050,1),(24517841,266622051,2),(24517841,266622052,3),(24517841,266622053,4),(24517841,266622054,5),(24517841,266622055,6),(24517841,266622056,7),(24517841,266622057,8),(24517841,266622058,9),(24517841,266622059,10),(24517841,266622060,11),(24517841,266622061,12),(24517841,266622062,13),(24517875,266622366,1),(24517875,354968366,2),(24517875,266622365,3),(24517875,266622364,4),(24517875,266622363,5),(24517875,266622362,6),(24517875,266622361,7),(24517875,266622360,8),(24517875,266622359,9),(24517875,266622358,10),(24517875,266622357,11),(24517875,266622356,12),(24517875,266622355,13),(24517875,266622354,14),(24517875,266622353,15),(24517875,266622352,16),(24517875,266622351,17),(24517875,266622350,18),(24517875,266622461,19),(24517875,266622349,20),(24517875,266622348,21),(24517889,266622460,1),(24517889,266622461,2),(24517907,266622567,1),(24517907,266622568,2),(24517907,266622569,3),(24517907,266622570,4),(24517907,266622572,5),(24517907,266622573,6),(24517907,266622567,7),(24518086,266623545,1),(24518086,266623546,2),(24518086,266623547,3),(24518086,266623548,4),(24518086,266623549,5),(24518086,266623550,6),(24518086,266623551,7),(24518086,266623552,8),(24518086,266623553,9),(24518086,266623554,10),(24518086,266623555,11),(24518088,266622986,1),(24518088,266623590,2),(24518088,266623591,3),(24518088,266623592,4),(24518088,266623545,5),(24518115,266623555,1),(24518115,266623556,2),(24518115,266623557,3),(24518115,266623558,4),(24518115,266623559,5),(24518115,266623560,6),(24518124,266623560,1),(24518124,266623561,2),(24518124,266623562,3),(24518124,266623563,4),(24518124,266623564,5),(24518124,266623565,6),(24518124,266623566,7),(24518124,266623567,8),(24518124,266623568,9),(24518124,266623569,10),(24518124,266623570,11),(24518124,266623571,12),(24518124,266623572,13),(24518124,266623573,14),(24518124,266623574,15),(24518124,266623575,16),(24518124,266623576,17),(24518124,266623577,18),(24518124,266623578,19),(24518124,266623579,20),(24518124,266623580,21),(24518124,266623581,22),(24518124,266623582,23),(24518124,266623583,24),(24518124,266623584,25),(24518124,266623585,26),(24518124,266623586,27),(24518124,266623587,28),(24518124,266623588,29),(24518124,266623589,30),(24663518,268081244,1),(24663518,268081245,2),(24663518,268081246,3),(24663520,268081243,1),(24663520,268081244,2),(24663786,53327620,1),(24663786,53319578,2),(24663786,53319576,3),(24663786,53319573,4),(24663786,53319571,5),(24663786,53319570,6),(24663786,53319568,7),(24663786,53319566,8),(24663786,53319564,9),(24663786,53319563,10),(24663786,53319560,11),(24663786,332125718,12),(24663786,53319512,13),(24663894,52206643,1),(24663894,52204450,2),(24664831,268092812,1),(24664831,268091938,2),(24664831,268091940,3),(24664831,268091942,4),(24664831,268091944,5),(24664831,268091946,6),(24664831,268091948,7),(24664831,268091950,8),(24664867,268093053,1),(24664867,268092433,2),(24664867,268092434,3),(24664867,268092435,4),(24664867,268092812,5),(24664867,268092436,6),(24664867,268092437,7),(24664867,268092438,8),(24664867,268092439,9),(24664867,268092441,10),(24664867,268092442,11),(24664867,268092443,12),(24664867,268092444,13),(24664867,268092445,14),(24664867,268092446,15),(24664867,268092447,16),(24664867,268092448,17),(24664867,268093279,18),(24664867,268092449,19),(24664867,268092450,20),(24664867,268092451,21),(24664867,268092452,22),(24664867,268092453,23),(24664867,268092454,24),(24664867,268092455,25),(24664880,268093279,1),(24664880,268093281,2),(24664880,268092682,3),(24664880,268092683,4),(24664880,268092684,5),(24664880,268092685,6),(24664880,268092686,7),(24664880,268092687,8),(24664880,268092688,9),(24664880,268092689,10),(24664880,268092691,11),(24664880,268092692,12),(24664880,268092693,13),(24664880,268092694,14),(24664880,268092695,15),(24664880,268092696,16),(24665224,268096306,1),(24665224,268095978,2),(24665224,268095979,3),(24665224,268095980,4),(24665224,268095981,5),(24665224,268095982,6),(24665224,268095983,7),(24665224,268095984,8),(24665224,268095985,9),(24665224,268095986,10),(24665224,268095987,11),(24665257,268096149,1),(24665257,268096150,2),(24665257,268096151,3),(24665257,268096152,4),(24665257,268096153,5),(24665257,268096154,6),(24665257,268096149,7),(24665737,268148594,1),(24665737,268100719,2),(24665737,268100720,3),(24665737,268100721,4),(24665737,268100722,5),(24665737,268100723,6),(24665737,268101444,7),(24665737,268100724,8),(24665737,268100725,9),(24665737,268100727,10),(24665737,268100728,11),(24665737,268103842,12),(24665737,268101670,13),(24665737,268100729,14),(24665737,268100730,15),(24665737,268100731,16),(24665737,268100732,17),(24665737,268100733,18),(24665737,268100735,19),(24665737,268100736,20),(24665737,268100737,21),(24665737,268104831,22),(24665737,268100738,23),(24665737,268100739,24),(24665737,268100740,25),(24665737,268100741,26),(24665737,268100742,27),(24665737,268100743,28),(24665737,268100744,29),(24665737,268100746,30),(24665737,268100747,31),(24665737,268100748,32),(24665737,268100749,33),(24665737,268100750,34),(24665737,268100752,35),(24665737,268100753,36),(24665737,268100754,37),(24665737,268100755,38),(24665737,268100757,39),(24665737,268100758,40),(24665737,268100759,41),(24665737,268100760,42),(24665737,268100761,43),(24665737,268103434,44),(24665737,268100762,45),(24665737,268100764,46),(24665737,268100765,47),(24665737,268100766,48),(24665737,268100767,49),(24665737,268100768,50),(24665737,268100769,51),(24665737,268100771,52),(24665737,268100772,53),(24665737,268100773,54),(24665737,268100775,55),(24665737,268100776,56),(24665737,268100777,57),(24665737,268100778,58),(24665737,268100779,59),(24665737,268100781,60),(24665737,268100782,61),(24665737,268100783,62),(24665737,268100784,63),(24665737,268100785,64),(24665737,268100786,65),(24665737,268100787,66),(24665737,268100789,67),(24665737,268100790,68),(24665737,268100791,69),(24665737,268100792,70),(24665737,268100793,71),(24665737,268100794,72),(24665785,268101444,1),(24665785,268101446,2),(24665785,268101448,3),(24665785,268101451,4),(24665785,268101453,5),(24665785,268101454,6),(24665785,268101456,7),(24665811,268101669,1),(24665811,268101670,2),(24666049,268100733,1),(24666049,268103219,2),(24666049,268103220,3),(24666099,268103434,1),(24666099,268103435,2),(24666099,268103436,3),(24666099,268103437,4),(24666099,268103438,5),(24666136,268103842,1),(24666136,268103843,2),(24666136,268103844,3),(24666136,268103845,4),(24666136,268103846,5),(24666136,268103847,6),(24666136,268103848,7),(24666136,268103850,8),(24666136,268101669,9),(24666186,268104321,1),(24666186,268104322,2),(24666186,268104323,3),(24666186,268104324,4),(24666186,268104325,5),(24666186,268104326,6),(24666186,268104327,7),(24666186,268104328,8),(24666186,268104329,9),(24666186,268104321,10),(24668180,268123180,1),(24668180,268123181,2),(24668181,268123183,1),(24668181,268123184,2),(24668181,268123185,3),(24668181,268123186,4),(24668181,268123187,5),(24668181,268123188,6),(24668181,268123189,7),(24668181,268123190,8),(24668181,268123192,9),(24668181,268123180,10),(24668187,268123181,1),(24668187,268123182,2),(24668361,268124663,1),(24668361,268124664,2),(24668361,268124667,3),(24668361,268124759,4),(24668372,268124757,1),(24668372,268124758,2),(24668373,268124759,1),(24668373,268124757,2),(24668885,268134045,1),(24668885,268129594,2),(24668954,268129612,1),(24668954,268130240,2),(24669163,268131748,1),(24669163,268131749,2),(24669163,268131750,3),(24669163,268131751,4),(24669163,268133883,5),(24669163,268131752,6),(24669163,268131753,7),(24669163,268131755,8),(24669163,268131756,9),(24669163,268131757,10),(24669163,268131758,11),(24669163,268131759,12),(24669163,268131760,13),(24669163,268131761,14),(24669163,268131762,15),(24669163,268131763,16),(24669245,268132090,1),(24669245,268132091,2),(24669247,268132095,1),(24669247,268132096,2),(24669247,268132097,3),(24669247,268132098,4),(24669247,268132099,5),(24669247,268132100,6),(24669248,268132100,1),(24669248,268132090,2),(24669306,268132455,1),(24669306,268132456,2),(24669306,268132457,3),(24669306,268132458,4),(24669306,268132459,5),(24669306,268132460,6),(24669306,268132461,7),(24669306,268132462,8),(24669306,268132463,9),(24669306,268132464,10),(24669306,268132465,11),(24669306,268132466,12),(24669306,268132467,13),(24669306,268132468,14),(24669306,268132469,15),(24669306,268132455,16),(24669321,268132982,1),(24669321,268132983,2),(24669321,268132985,3),(24669321,268132986,4),(24669321,268132987,5),(24669321,268132989,6),(24669321,268132990,7),(24669321,268132991,8),(24669321,268132992,9),(24669321,268132993,10),(24669321,268132095,11),(24669321,268132994,12),(24669321,268132996,13),(24669321,268132997,14),(24669321,268132998,15),(24669321,268132982,16),(24669352,268133215,1),(24669352,268133216,2),(24669352,268133217,3),(24669352,268133218,4),(24669352,268133219,5),(24669352,268133221,6),(24669352,268133222,7),(24669352,268133223,8),(24669352,268133224,9),(24669352,268133225,10),(24669352,268133215,11),(24669376,268133712,1),(24669376,268133714,2),(24669376,268133715,3),(24669376,268133716,4),(24669376,268133717,5),(24669376,268133718,6),(24669376,268133719,7),(24669376,268133712,8),(24669430,268129597,1),(24669430,268133883,2),(24669444,268129594,1),(24669444,268129595,2),(24669444,268129596,3),(24669444,268129597,4),(24669444,268129598,5),(24669444,268129599,6),(24669444,268129600,7),(24669444,268129601,8),(24669444,268129602,9),(24669444,268129603,10),(24669444,268129605,11),(24669444,268129607,12),(24669444,268131748,13),(24669444,268129608,14),(24669444,268129609,15),(24669444,268129610,16),(24669444,268129611,17),(24669444,268129612,18),(24669444,268129614,19),(24669444,268129615,20),(24669444,268129616,21),(24669444,268129618,22),(24669444,268129619,23),(24669444,268129620,24),(24669444,268129621,25),(24669444,268130240,26),(24669444,268129622,27),(24669444,268129624,28),(24669444,268129625,29),(24669444,268129626,30),(24669444,268129627,31),(24669444,268129608,32),(24713155,268614412,1),(24713155,268613131,2),(24713155,268613132,3),(24713155,268613133,4),(24713155,268613134,5),(24713155,268613135,6),(24713155,268613136,7),(24713155,268613137,8),(24713155,268613138,9),(24713155,268613139,10),(24713155,268613140,11),(24713182,268081246,1),(24713182,470362088,2),(24713182,470362090,3),(24713182,470362091,4),(24713182,470362096,5),(24713182,470362099,6),(24713182,470362102,7),(24713182,470362105,8),(24713182,470362109,9),(24713182,470362112,10),(24713182,470362115,11),(24713182,470362117,12),(24713182,470362120,13),(24713182,470362123,14),(24713182,470362131,15),(24713182,470362132,16),(24713182,470362134,17),(24713182,470362136,18),(24713182,470362138,19),(24713182,470362140,20),(24713182,470362142,21),(24713182,470362143,22),(24713182,470362144,23),(24713182,470362145,24),(24713182,470362147,25),(24713182,470362152,26),(24713182,470362154,27),(24713182,470362156,28),(24713182,470362158,29),(24713182,470362160,30),(24713182,470362162,31),(24713182,470362163,32),(24713182,470362164,33),(24713182,268613536,34),(24713182,268613537,35),(24713182,268613538,36),(24713182,268613147,37),(24713182,268613539,38),(24713182,268613540,39),(24713182,268613541,40),(24713182,268613542,41),(24713182,268613543,42),(24713182,268613544,43),(24713182,268613545,44),(24713182,268613546,45),(24713182,268613547,46),(24713182,268613548,47),(24713182,268613549,48),(24713182,268613550,49),(24713182,268613551,50),(24713182,268613552,51),(24713182,268613553,52),(24713182,268613554,53),(24713182,268613555,54),(24713182,268613556,55),(24713182,268613557,56),(24713182,268613558,57),(24713182,268613559,58),(24713182,268613560,59),(24713182,268613561,60),(24713182,268613562,61),(24713182,268613563,62),(24713182,268613564,63),(24713189,268615558,1),(24713189,268613691,2),(24713189,268613692,3),(24713189,268613693,4),(24713189,268613694,5),(24713189,268613695,6),(24713189,268613696,7),(24713189,268613697,8),(24713189,268613698,9),(24713189,268613699,10),(24713189,268613700,11),(24713189,268613701,12),(24713189,268613703,13),(24713210,268613146,1),(24713210,268613147,2),(24713222,268613140,1),(24713222,268613141,2),(24713222,268613142,3),(24713222,268613143,4),(24713222,268613144,5),(24713222,268613145,6),(24713246,268613145,1),(24713246,268613146,2),(24713303,268613704,1),(24713303,268613563,2),(24713305,268613703,1),(24713305,268613704,2),(24713352,51582184,1),(24713352,268615700,2),(24713352,268615701,3),(24713352,268616487,4),(24713352,268615702,5),(24713352,268615703,6),(24713352,268615704,7),(24713352,268615705,8),(24713352,458765020,9),(24713352,268615706,10),(24713352,268615707,11),(24713362,268615706,1),(24713362,268615782,2),(24713362,268615783,3),(24713362,268615784,4),(24713362,268615786,5),(24713362,268615787,6),(24713447,268615787,1),(24713447,268616479,2),(24713447,268616480,3),(24713447,268616481,4),(24713447,268616482,5),(24713447,268616483,6),(24713447,268616484,7),(24713447,268616485,8),(24713447,268616486,9),(24713447,268616487,10),(24713483,268616713,1),(24713483,268616714,2),(24713483,268616715,3),(24713483,268616716,4),(24713483,268616717,5),(24713483,268616718,6),(24713483,268616719,7),(24713483,268616713,8),(24713502,268616892,1),(24713502,268616893,2),(24713502,268616894,3),(24713502,268616895,4),(24713502,268616892,5),(24713566,268617677,1),(24713566,268617407,2),(24713566,268617408,3),(24713566,268617409,4),(24713566,268617410,5),(24713566,268617411,6),(24713566,268617412,7),(24713566,268617413,8),(24713566,268617414,9),(24713566,268617415,10),(24713566,268617416,11),(24713566,268617417,12),(24713566,268617418,13),(24713566,268617419,14),(24713566,268617420,15),(24713566,268617421,16),(24713566,268617422,17),(24713578,268617414,1),(24713578,268617505,2),(24713578,268617504,3),(24713578,268617503,4),(24713578,268617502,5),(24713578,268617501,6),(24713578,268617500,7),(24713578,268617499,8),(24713578,268617498,9),(24713578,268617497,10),(24713578,268617496,11),(24713578,268617495,12),(24713578,268617494,13),(24713578,268617493,14),(24713611,268617808,1),(24713611,268617809,2),(24713692,268618417,1),(24713692,51554716,2),(24713704,268093053,1),(24713704,52202541,2),(24713704,52202539,3),(24713704,268124758,4),(24713704,52202534,5),(24713704,52202533,6),(24713704,52202528,7),(24713704,52202526,8),(24713704,52202523,9),(24713704,52202521,10),(24713704,52202517,11),(24713704,52202511,12),(24713704,52202507,13),(24713704,52202499,14),(24713704,52202493,15),(24713704,52202488,16),(24713704,52202485,17),(24713704,52202476,18),(24713704,52202473,19),(24713704,52202468,20),(24713704,52202465,21),(24713704,52202460,22),(24713704,52202455,23),(24713704,52202451,24),(24713704,52202389,25),(24713704,52202283,26),(24713704,52202293,27),(24713704,52202298,28),(24713704,52202362,29),(24713704,51554688,30),(24713904,51444885,1),(24713904,51444886,2),(24713918,51445071,1),(24713918,51445209,2),(24713918,51445210,3),(24713936,51445785,1),(24713936,51443686,2),(24713936,51443687,3),(24713936,51443688,4),(24713936,51443690,5),(24713936,51443691,6),(24713936,51443692,7),(24713936,51443693,8),(24713936,51443694,9),(24713936,51443695,10),(24714294,51399308,1),(24714294,51410788,2),(24714294,51399309,3),(24714736,51441228,1),(24714736,51441229,2),(24714736,51441230,3),(24714736,51441232,4),(24714736,51441233,5),(24714736,51441235,6),(24714736,51441237,7),(24714736,51441239,8),(24714736,51441242,9),(24714736,51441244,10),(24714736,51441246,11),(24714736,51441249,12),(24714743,51441249,1),(24714743,51441250,2),(24714743,51441254,3),(24714743,51441258,4),(24714743,51441261,5),(24714743,51441262,6),(24714743,51441263,7),(24714743,51441266,8),(24714743,51441267,9),(24714743,51441269,10),(24714743,51438666,11),(24714743,281070673,12),(24714743,51440320,13),(24714743,51440321,14),(24714743,51440622,15),(24714743,281063471,16),(24714743,281063857,17),(24714743,51439552,18),(24714743,281063913,19),(24714743,281063929,20),(24714743,51439215,21),(24714743,51442533,22),(24714743,51442653,23),(24714743,281064124,24),(24714743,51385297,25),(24714892,51444894,1),(24714892,51444896,2),(24714892,51444897,3),(24714892,51444898,4),(24714892,51444899,5),(24714892,51444902,6),(24714892,51444652,7),(24714892,51444653,8),(24714892,51444401,9),(24714892,51444403,10),(24714892,51444404,11),(24714892,51444405,12),(24714892,51444406,13),(24714892,51444408,14),(24714892,51444468,15),(24714892,264281365,16),(24714892,51444470,17),(24714892,51444471,18),(24714892,51444444,19),(24714892,51444383,20),(24714892,51444381,21),(24714892,264279592,22),(24714892,51444379,23),(24714892,51444377,24),(24714892,51444375,25),(24714892,51444374,26),(24714892,51444373,27),(24714892,51444371,28),(24714892,51444370,29),(24714892,51444368,30),(24714892,51444366,31),(24714892,264278159,32),(24714892,51444365,33),(24714892,264278124,34),(24714892,51444364,35),(24714892,51444362,36),(24714892,51444359,37),(24714892,51444358,38),(24715008,51402989,1),(24715008,51402991,2),(24715008,51402994,3),(24715008,51402995,4),(24715008,51402997,5),(24715008,51403000,6),(24715008,51403225,7),(24715064,268630128,1),(24715064,51403663,2),(24715064,268631096,3),(24715064,51403665,4),(24715082,51403665,1),(24715082,646807552,2),(24715082,268630910,3),(24715082,646807563,4),(24715082,646807568,5),(24715082,268630911,6),(24715082,646807575,7),(24715082,646807589,8),(24715082,51369109,9),(24715082,646807600,10),(24715082,268630913,11),(24715082,646807608,12),(24715082,646807611,13),(24715082,268630914,14),(24715082,646807615,15),(24715082,646807618,16),(24715082,646807620,17),(24715082,51403665,18),(24715152,51369109,1),(24715152,51369110,2),(24715152,51369112,3),(24715152,51369114,4),(24715152,51404282,5),(24715152,51369115,6),(24715152,51369118,7),(24715152,51369120,8),(24715152,51442961,9),(24715152,51369123,10),(24715152,51369125,11),(24715152,337742674,12),(24715152,51369126,13),(24715152,337729044,14),(24715152,51369129,15),(24715185,268631096,1),(24715185,646809729,2),(24715185,268631795,3),(24715324,51410490,1),(24715324,51399339,2),(24715324,51399303,3),(24715324,51399304,4),(24715324,51399306,5),(24715324,51399308,6),(24913724,259475455,1),(24913724,270716339,2),(24913724,270716340,3),(24913724,270716341,4),(24913724,270716342,5),(24913724,270716343,6),(24913724,270716344,7),(24913724,270716346,8),(24913724,270716347,9),(24913724,270716348,10),(24913724,270716349,11),(24913724,270716350,12),(24913724,270716351,13),(24913724,270716352,14),(24913724,270716353,15),(24913724,270716354,16),(24913802,270716347,1),(24913802,270717286,2),(24913802,270717287,3),(24913802,270717288,4),(24913802,270717289,5),(24913861,53319503,1),(24913861,270717898,2),(24913861,270717899,3),(24914526,51405265,1),(24914526,270723241,2),(24914526,270723242,3),(24914526,270723243,4),(24914526,270723244,5),(24914526,270723368,6),(24914534,51448409,1),(24914534,51400766,2),(24914534,270726765,3),(24914563,270723368,1),(24914563,270723369,2),(24914563,51448409,3),(24914563,270723912,4),(24914563,270723459,5),(24914563,270723325,6),(24914563,270723412,7),(24914563,270723413,8),(24914563,270723368,9),(24914660,51447737,1),(24914660,270725839,2),(24914768,270724708,1),(24914768,51367558,2),(24914779,270724742,1),(24914779,51366991,2),(24914843,270725821,1),(24914843,646809632,2),(24914843,270725822,3),(24914843,646809636,4),(24914843,270725823,5),(24914843,646809642,6),(24914843,270725825,7),(24914843,646809643,8),(24914843,270725952,9),(24914843,646809644,10),(24914843,270725826,11),(24914843,646809645,12),(24914843,270725827,13),(24914843,646809646,14),(24914843,270725828,15),(24914843,646809647,16),(24914843,270725839,17),(24914843,646809648,18),(24914843,270725821,19),(24914870,270726768,1),(24914870,270726179,2),(24914870,51400768,3),(24914870,51400770,4),(24914903,270726764,1),(24914903,646809649,2),(24914903,270726765,3),(24914903,646809650,4),(24914903,270726766,5),(24914903,646809651,6),(24914903,646809652,7),(24914903,270726767,8),(24914903,646809653,9),(24914903,646809654,10),(24914903,270726768,11),(24914903,646809655,12),(24914903,646809656,13),(24914903,270726770,14),(24914903,646809657,15),(24914903,270726771,16),(24914903,646809658,17),(24914903,270726764,18),(24914989,270726767,1),(24914989,337781593,2),(24914989,270727242,3),(24915114,51400281,1),(24915114,51400283,2),(24915114,51400284,3),(24915114,270724218,4),(24915114,51400285,5),(24915114,51400286,6),(24915114,51400290,7),(24915114,51400293,8),(24915114,51400296,9),(24915114,51400299,10),(24915114,51400301,11),(24915114,51400303,12),(24915114,51400305,13),(24915114,270724708,14),(24915114,51367559,15),(24915502,51450019,1),(24915502,51450116,2),(24915504,51450114,1),(24915504,51450019,2),(24915554,270731115,1),(24915554,53288152,2),(24915554,53288150,3),(24915554,53288119,4),(24915554,59015934,5),(24915554,53288123,6),(24915554,53288126,7),(24915554,53288141,8),(24915554,53288143,9),(24915554,53288147,10),(24915554,53288148,11),(24915566,270731143,1),(24915566,270731114,2),(24915566,270731115,3),(24915566,270731116,4),(24915566,270731117,5),(24915566,270731118,6),(24915566,270731119,7),(24915566,270731143,8),(24915617,270730925,1),(24915617,270730926,2),(24915624,51450106,1),(24915624,270730924,2),(24915624,270730925,3),(24915706,270730925,1),(24915706,51450107,2),(24915763,270733631,1),(24915763,51448830,2),(24915772,51448828,1),(24915772,270733631,2),(24915834,270730926,1),(24915834,270730927,2),(24915834,270730928,3),(24915834,270730929,4),(24915834,270730930,5),(24915834,270730931,6),(24915834,270730932,7),(24915834,270730933,8),(24915834,270730934,9),(24915834,270730935,10),(24915834,270730936,11),(24915834,270730937,12),(24915834,270730938,13),(24915834,270730939,14),(24915834,270730940,15),(24915834,270730941,16),(24915834,270730942,17),(24915834,270730943,18),(24915834,270730944,19),(24915834,270730945,20),(24915834,270731143,21),(25014753,51441626,1),(25014753,271938772,2),(25014753,271938773,3),(25014753,271938774,4),(25014753,271938778,5),(25014753,51404061,6),(25014777,206332846,1),(25014777,271939032,2),(25014777,271939033,3),(25014777,271939034,4),(25415705,276995290,1),(25415705,276995291,2),(25415705,276995292,3),(25415705,276995293,4),(25415705,276995294,5),(25416126,259986460,1),(25416126,259986459,2),(25416126,259986458,3),(25416126,259986457,4),(25416126,259986456,5),(25416126,259986455,6),(25416126,259986454,7),(25416126,259986453,8),(25416126,276999219,9),(25416126,53309384,10),(25416128,259986470,1),(25416128,259986469,2),(25416227,277001703,1),(25416227,277001727,2),(25416308,277001727,1),(25416308,277000665,2),(25416308,277000666,3),(25416308,277000667,4),(25416308,277000669,5),(25416308,264502063,6),(25416371,53309368,1),(25416371,277003121,2),(25416371,53309369,3),(25416371,53309370,4),(25416371,53309371,5),(25416371,53309374,6),(25416371,53309376,7),(25416371,277003126,8),(25416371,53309379,9),(25453236,277375056,1),(25453236,277375057,2),(25453308,277375057,1),(25453308,277375058,2),(25453310,277375058,1),(25453310,277375059,2),(25453310,277375060,3),(25453310,277375061,4),(25453310,277375062,5),(25453310,277375063,6),(25453310,277375064,7),(25453310,262467026,8),(25454372,260997624,1),(25454372,277386816,2),(25454372,277386817,3),(25454372,277386818,4),(25454372,277386819,5),(25454372,277386820,6),(25454378,277386820,1),(25454378,277386821,2),(25454378,277386822,3),(25454378,277386823,4),(25454378,277386824,5),(25454378,277386825,6),(25454378,277386826,7),(25454378,277386827,8),(25454381,277386818,1),(25454381,277386930,2),(25454381,277386931,3),(25484821,277694081,1),(25484821,277694080,2),(25484883,277695163,1),(25484883,277695545,2),(25484883,51405720,3),(25484883,51405722,4),(25484883,51405723,5),(25484883,51405725,6),(25484883,51448405,7),(25484883,51405727,8),(25484883,51405728,9),(25484883,51405729,10),(25484912,277695169,1),(25484912,646808885,2),(25484912,646808886,3),(25484912,277695163,4),(25484912,646808887,5),(25484912,646808888,6),(25484912,277695164,7),(25484912,646808889,8),(25484912,646808890,9),(25484912,277695165,10),(25484912,646808892,11),(25484912,277695167,12),(25484912,646808893,13),(25484912,646808895,14),(25484912,646808896,15),(25484912,277695168,16),(25484912,646808900,17),(25484912,646808903,18),(25484912,277695169,19),(25485099,51110493,1),(25485099,277697847,2),(25485099,277697265,3),(25485099,277697266,4),(25485099,277697267,5),(25485099,277697268,6),(25485099,277697269,7),(25485099,277697270,8),(25485099,277697271,9),(25485099,277697272,10),(25485099,277697273,11),(25485099,277697274,12),(25485119,277697274,1),(25485119,277697480,2),(25485119,277697481,3),(25485119,277697482,4),(25485119,277697483,5),(25485119,277697484,6),(25485119,277697485,7),(25485130,277697485,1),(25485130,277697277,2),(25485130,277697278,3),(25485130,277697279,4),(25485130,277697280,5),(25485130,277697281,6),(25485130,277697282,7),(25485130,281039653,8),(25485130,277697283,9),(25485130,277697284,10),(25485130,277697285,11),(25485130,277697286,12),(25485130,277697287,13),(25485130,277697288,14),(25485130,277697289,15),(25485130,281039984,16),(25485131,277697274,1),(25485131,277697275,2),(25485131,277697276,3),(25485131,277697485,4),(25569661,51409632,1),(25569661,51409633,2),(25569661,51409634,3),(25569661,51409635,4),(25569661,51409636,5),(25569661,51409638,6),(25569661,51409639,7),(25569661,51409640,8),(25569661,51409641,9),(25569661,51409642,10),(25569661,51409644,11),(25569661,51409645,12),(25569661,51409646,13),(25569661,51409647,14),(25569661,51409648,15),(25569661,51409649,16),(25569661,51409651,17),(25569661,51409652,18),(25569661,51409653,19),(25569661,51409655,20),(25569661,51409656,21),(25569661,51409657,22),(25569661,51409658,23),(25569661,51409659,24),(25569661,51409660,25),(25569661,51409662,26),(25569661,51409663,27),(25569661,51409664,28),(25569661,51409665,29),(25569661,51409666,30),(25569661,51409667,31),(25569661,51409668,32),(25569661,51409669,33),(25569661,51409670,34),(25569661,51409671,35),(25569661,51409672,36),(25569661,51409673,37),(25569661,51409674,38),(25569661,51409675,39),(25569661,51409676,40),(25569661,51409677,41),(25569661,51409678,42),(25569661,51973033,43),(25569665,51406803,1),(25569665,51972990,2),(25569665,51972993,3),(25569665,51972999,4),(25569665,51973000,5),(25569665,51973004,6),(25569665,51973007,7),(25569665,51973010,8),(25569665,51973014,9),(25569665,51973017,10),(25569665,51973021,11),(25569665,51973026,12),(25569665,51973027,13),(25569665,51973030,14),(25569665,51973033,15),(25569665,51409679,16),(25569665,51409680,17),(25569665,51973038,18),(25569665,51973045,19),(25569665,51973049,20),(25569665,51973052,21),(25569665,51973055,22),(25569665,51973058,23),(25569665,51973061,24),(25569665,51973066,25),(25569665,51973069,26),(25569665,51973073,27),(25569665,51973078,28),(25569665,51973082,29),(25569665,51973084,30),(25569665,51973088,31),(25569665,51973091,32),(25569665,51973096,33),(25569665,51973099,34),(25569745,278721406,1),(25569745,278721797,2),(25569748,278721797,1),(25569748,270723325,2),(25569755,278722158,1),(25569755,51401456,2),(25569755,51447737,3),(25569755,51401457,4),(25569755,51401461,5),(25569755,51401224,6),(25569775,51401454,1),(25569775,278722158,2),(25572114,278748954,1),(25572114,278752060,2),(25572121,278752325,1),(25572121,278752327,2),(25572121,278752328,3),(25572121,278752329,4),(25572121,278752325,5),(25572130,278752060,1),(25572130,278752061,2),(25572131,278752061,1),(25572131,278752062,2),(25572131,278752063,3),(25572131,278752064,4),(25572131,278752066,5),(25572131,278752067,6),(25572131,278752068,7),(25572131,278752069,8),(25572131,278752070,9),(25572131,278752071,10),(25572131,278752072,11),(25572131,278752073,12),(25572131,278752074,13),(25572131,278752075,14),(25572131,278752076,15),(25572131,278752077,16),(25572131,278752078,17),(25572131,278752079,18),(25572131,278752080,19),(25572131,278752081,20),(25572131,278752083,21),(25572131,278752084,22),(25572131,278752085,23),(25572572,278757469,1),(25572572,278759738,2),(25572572,278759739,3),(25572572,278759740,4),(25572572,278759742,5),(25572572,278759743,6),(25572572,278759744,7),(25572572,278759745,8),(25572572,278759746,9),(25572572,278759747,10),(25572572,278759748,11),(25572572,278759749,12),(25572572,278759750,13),(25572572,278759752,14),(25572572,278759753,15),(25572572,278759754,16),(25572572,278759755,17),(25572572,278759756,18),(25572572,278759757,19),(25572572,278759758,20),(25572572,278759759,21),(25572731,278760711,1),(25572731,278760995,2),(25572731,278761684,3),(25572741,278761001,1),(25572741,278761189,2),(25572741,278761190,3),(25572746,278760998,1),(25572746,278761435,2),(25572746,278761436,3),(25572746,278761437,4),(25572746,278761438,5),(25572746,278761439,6),(25572746,278760996,7),(25572749,278760995,1),(25572749,278760996,2),(25572749,278760997,3),(25572749,278760998,4),(25572749,278760999,5),(25572749,278761000,6),(25572749,278761001,7),(25572749,278761002,8),(25572883,278762963,1),(25572883,278762964,2),(25572883,278762965,3),(25572883,278762966,4),(25572883,278762967,5),(25572883,278762968,6),(25572883,278762969,7),(25572883,278762970,8),(25572883,278762971,9),(25572883,278762972,10),(25572883,278762973,11),(25572883,278762974,12),(25572883,278762975,13),(25572883,278762976,14),(25572883,278762963,15),(25573596,51930186,1),(25573596,51930188,2),(25573596,51930191,3),(25573596,51930193,4),(25573596,51930195,5),(25573596,51930198,6),(25573596,51930199,7),(25767814,281040020,1),(25767814,281040156,2),(25767814,281039980,3),(25767814,281040022,4),(25767814,281039982,5),(25767814,281039983,6),(25767814,281039984,7),(25767814,281040020,8),(25767827,281040439,1),(25767827,281041274,2),(25767827,281040441,3),(25767827,281039982,4),(25767891,281041761,1),(25767891,281041762,2),(25767891,281041763,3),(25767891,281041764,4),(25767891,281041765,5),(25767891,281041766,6),(25767891,281041767,7),(25767891,281041761,8),(25768003,281042331,1),(25768003,281043351,2),(25768003,281043353,3),(25768003,281043354,4),(25768003,281044538,5),(25768003,281043356,6),(25768003,281048956,7),(25768003,281044540,8),(25768003,281049120,9),(25768018,281042332,1),(25768018,281044597,2),(25768018,281048992,3),(25768018,281044599,4),(25768018,281053935,5),(25768018,281043618,6),(25768018,281043619,7),(25768018,281043621,8),(25768018,281043622,9),(25768677,281049691,1),(25768677,281050352,2),(25768677,281050354,3),(25768677,281051136,4),(25768677,281050357,5),(25768677,281051138,6),(25768677,281051139,7),(25768681,281051766,1),(25768681,51385273,2),(25768681,51385276,3),(25768681,51385277,4),(25768681,51385279,5),(25768681,51385284,6),(25768681,51385285,7),(25768681,51385287,8),(25768681,51385289,9),(25768681,51442041,10),(25768760,281051966,1),(25768760,281051967,2),(25768760,281051968,3),(25768760,281051762,4),(25768760,281050523,5),(25768760,281051139,6),(25768760,281051969,7),(25768760,281051764,8),(25768760,281051765,9),(25768760,281051766,10),(25768760,281051966,11),(25768838,51385273,1),(25768838,281057175,2),(25768852,281052233,1),(25768852,281052234,2),(25768852,281052341,3),(25768852,281052236,4),(25768852,281052237,5),(25768852,281052509,6),(25768852,281052458,7),(25768852,281056804,8),(25768868,281052458,1),(25768868,281044641,2),(25769024,51371387,1),(25769024,281055773,2),(25769024,281056115,3),(25769024,281055776,4),(25769024,281056116,5),(25769024,281055778,6),(25769024,281052233,7),(25769049,281057175,1),(25769049,281052343,2),(25769050,281052343,1),(25769050,281052233,2),(25769069,281049120,1),(25769069,281043360,2),(25769071,281043360,1),(25769071,281053833,2),(25769071,281052580,3),(25769071,281053771,4),(25769071,281052582,5),(25769071,281053946,6),(25769071,281052585,7),(25769071,281053773,8),(25769071,281058251,9),(25769071,281053836,10),(25769071,281053776,11),(25769071,281053777,12),(25769071,281053945,13),(25769071,51371388,14),(25769112,281044619,1),(25769112,281043795,2),(25769112,281043794,3),(25769112,281044620,4),(25769112,281043792,5),(25769112,281043790,6),(25769112,281043789,7),(25769112,281048516,8),(25769112,281043016,9),(25769116,281044641,1),(25769116,281044619,2),(25769122,281043623,1),(25769122,281055053,2),(25769122,281056804,3),(25769122,281057998,4),(25769122,281053938,5),(25769122,281053939,6),(25769122,281053940,7),(25769122,281053941,8),(25769122,281053942,9),(25769122,281053943,10),(25769122,281053944,11),(25769122,281053945,12),(25769124,281043622,1),(25769124,281043623,2),(25769182,281059704,1),(25769182,51371400,2),(25769182,51371401,3),(25769182,51371402,4),(25769182,51371403,5),(25769182,51371404,6),(25769182,51371406,7),(25769182,51371408,8),(25769182,51371409,9),(25769182,51371411,10),(25769182,51371413,11),(25769182,51371415,12),(25769182,51371418,13),(25769182,51371421,14),(25769182,51371422,15),(25769182,51371423,16),(25769182,51371425,17),(25769182,51371428,18),(25769182,51371430,19),(25769182,51371237,20),(25769229,281059700,1),(25769229,281059701,2),(25769229,281060136,3),(25769229,281059703,4),(25769229,281059704,5),(25769229,281060138,6),(25769229,281060139,7),(25769229,281059700,8),(25769702,281063471,1),(25769702,281063820,2),(25769702,281063821,3),(25769702,281063822,4),(25769702,281063857,5),(25769709,281063913,1),(25769709,281063895,2),(25769726,281063929,1),(25769726,281064107,2),(25769803,281064124,1),(25769803,281066356,2),(25769803,281064784,3),(25769803,281064525,4),(25769803,281064526,5),(25769803,281064785,6),(25769803,281064529,7),(25769803,281065980,8),(25769803,281064270,9),(25769803,281064271,10),(25769803,281064259,11),(25769803,281064260,12),(25769803,281064261,13),(25769803,281064262,14),(25769803,281064263,15),(25769822,281064535,1),(25769822,281065006,2),(25769829,281064785,1),(25769829,281065304,2),(25769829,281066086,3),(25769829,281065306,4),(25769829,281066349,5),(25769829,281065308,6),(25769891,281064262,1),(25769891,281065961,2),(25769891,281065962,3),(25769891,281065963,4),(25769891,281065964,5),(25769893,281064259,1),(25769893,281065978,2),(25769893,281066192,3),(25769893,281064533,4),(25769893,281064788,5),(25769893,281064535,6),(25769893,281064537,7),(25769893,281064789,8),(25769893,281064540,9),(25769893,281066153,10),(25769893,281064542,11),(25769893,51442532,12),(25769893,51442533,13),(25769922,281066192,1),(25769922,281066279,2),(25769970,281066356,1),(25769970,281066881,2),(25769970,281066882,3),(25769970,281066883,4),(25769970,281066884,5),(25769970,281066600,6),(25769970,281067340,7),(25769970,281067291,8),(25769970,281067341,9),(25769970,281066604,10),(25769970,281066666,11),(25769970,281067272,12),(25769970,281067342,13),(25769970,281066671,14),(25769970,281067274,15),(25769970,281066673,16),(25769970,281067343,17),(25769970,281066675,18),(25769970,281066676,19),(25769974,51385292,1),(25769974,281066629,2),(25769974,281069787,3),(25769974,281066631,4),(25769974,281069788,5),(25769974,281066633,6),(25770088,281066604,1),(25770088,281067289,2),(25770088,281066606,3),(25770088,281066607,4),(25770088,281066608,5),(25770088,281066609,6),(25770088,281066610,7),(25770088,281066889,8),(25770088,281066612,9),(25770088,281066613,10),(25770088,281066614,11),(25770088,51385295,12),(25770391,281064107,1),(25770391,281064789,2),(25770445,281070673,1),(25770445,281070966,2),(25770445,281071349,3),(25770445,281070968,4),(25770728,281073498,1),(25770728,281073499,2),(25770728,281073500,3),(25770728,281073501,4),(25770728,281073502,5),(25770728,281073503,6),(25770728,281073504,7),(25770728,281073498,8),(25770737,51444892,1),(25770737,51444894,2),(25770744,51444886,1),(25770744,51444888,2),(25770744,51444889,3),(25770744,281072460,4),(25770744,51444891,5),(25770744,51444892,6),(25770744,281073607,7),(25770744,281072602,8),(25770744,281073608,9),(25770744,281072600,10),(25770744,281072599,11),(25770744,51441623,12),(25770745,51445210,1),(25770745,51445113,2),(25770745,51444886,3),(25771015,51441850,1),(25771015,281076210,2),(25771015,281076211,3),(25771015,281076212,4),(25771015,281076213,5),(25771079,51441853,1),(25771079,281076688,2),(25771079,281076689,3),(25771079,281076690,4),(25771079,281076691,5),(25771079,281076692,6),(25771241,281080244,1),(25771241,281080196,2),(25771241,281079396,3),(25771241,281076912,4),(25771241,281079387,5),(25771241,281076910,6),(25771241,281079386,7),(25771241,281076908,8),(25771241,51441850,9),(25771241,281076692,10),(25771241,51441852,11),(25771241,51441853,12),(25771241,51441855,13),(25771241,51441857,14),(25771241,51441361,15),(25771241,51441364,16),(25771241,51441228,17),(25825533,51581795,1),(25825533,51581796,2),(25825533,51581799,3),(25825533,51581803,4),(25825533,51581807,5),(25825533,52166950,6),(26001987,52163588,1),(26001987,52163595,2),(26001987,52163602,3),(26001987,52163609,4),(26001987,52163613,5),(26001987,52163621,6),(26001987,52163631,7),(26001987,52163644,8),(26001987,52163664,9),(26001987,52164958,10),(26001987,52166749,11),(26002036,51587694,1),(26002036,266328982,2),(26002036,52163550,3),(26002036,266331233,4),(26002036,266331091,5),(26002036,52163556,6),(26002036,52163563,7),(26002036,52163574,8),(26002036,52163581,9),(26002036,52163588,10),(26243488,287396015,1),(26243488,51552605,2),(26243488,51552578,3),(26243488,51552581,4),(26243488,51552599,5),(26243488,51552583,6),(26243488,51552595,7),(26243488,51552587,8),(26243488,51552671,9),(26243488,51552612,10),(26243488,51552615,11),(26243488,51552619,12),(26243488,51552659,13),(26243488,51552622,14),(26243488,51552656,15),(26243488,51552664,16),(26243488,51552625,17),(26243488,51552628,18),(26243488,51552630,19),(26243488,51552633,20),(26243488,51552660,21),(26243488,51552635,22),(26243488,51552637,23),(26243488,51552667,24),(26243488,51552640,25),(26243488,287401324,26),(26243488,51552643,27),(26243488,51552645,28),(26243488,51552648,29),(26243488,51552651,30),(26243488,51552653,31),(26243488,51552672,32),(26243488,51552675,33),(26243488,51552679,34),(26243488,51552682,35),(26243488,51552686,36),(26243488,51552688,37),(26243488,51552691,38),(26243488,51552693,39),(26243488,51552694,40),(26243488,51552699,41),(26243488,51552702,42),(26243488,51552705,43),(26243488,51552707,44),(26243488,259475446,45),(26243488,51552709,46),(26243488,51552710,47),(26243488,51552711,48),(26243488,51552712,49),(26243488,51552715,50),(26243488,51552717,51),(26243488,51552720,52),(26243488,316951001,53),(26243488,51552722,54),(26243488,51552723,55),(26243488,270717289,56),(26243488,51552726,57),(26243488,51552727,58),(26243488,51552728,59),(26243488,51552731,60),(26243488,270716354,61),(26243488,51552733,62),(26243488,51581679,63),(26243580,287396015,1),(26243580,287397030,2),(26243580,287399092,3),(26243580,287395969,4),(26243580,287397028,5),(26243580,287399091,6),(26243580,287397023,7),(26243580,287399090,8),(26243580,287396015,9),(26243608,53306680,1),(26243608,53306683,2),(26243608,53306685,3),(26243608,53306687,4),(26243608,370003141,5),(26243681,53325663,1),(26243681,53319661,2),(26243681,53319659,3),(26243681,53319658,4),(26243681,53319657,5),(26243681,53319652,6),(26243681,53319651,7),(26243681,53319649,8),(26243681,53319648,9),(26243681,53319645,10),(26243681,53319643,11),(26243681,53319646,12),(26243681,53319642,13),(26243681,53319639,14),(26243681,53319638,15),(26243681,53319636,16),(26243681,53319634,17),(26243681,53319632,18),(26243681,53319631,19),(26243681,53319629,20),(26243681,53319627,21),(26243681,53319625,22),(26243681,53319624,23),(26243681,53319621,24),(26243681,53319619,25),(26243681,53319617,26),(26243681,53319616,27),(26243681,53319613,28),(26243681,53319612,29),(26243681,53319611,30),(26243681,53319610,31),(26243681,53319609,32),(26243681,53319607,33),(26243681,53319605,34),(26243681,53319603,35),(26243681,53319601,36),(26243681,53319600,37),(26243681,53319598,38),(26243681,53319596,39),(26243681,53319593,40),(26243681,53319592,41),(26243681,53319589,42),(26243681,53319587,43),(26243681,53319584,44),(26243681,53319581,45),(26243681,53319582,46),(26243681,51552599,47),(26243895,287403168,1),(26243895,287403171,2),(26243895,287403173,3),(26243895,287403175,4),(26243895,287403179,5),(26243895,287403168,6),(26455183,53294584,1),(26455183,53294581,2),(26455183,53294577,3),(26455183,53294573,4),(26455183,53294570,5),(26455183,53294566,6),(26455183,53294562,7),(26455183,53294560,8),(26455183,53294557,9),(26455183,53294552,10),(26455183,53294548,11),(26455183,53294545,12),(26455183,53294541,13),(26455183,53294540,14),(26455183,53294537,15),(26455183,53294534,16),(26455183,53294531,17),(26455183,53294530,18),(26455183,53294526,19),(26455183,53294523,20),(26455183,53294520,21),(26455183,53294515,22),(26455183,53294512,23),(26455183,53294508,24),(26455183,53294503,25),(26455183,53294500,26),(26455183,53294496,27),(26455183,53294493,28),(26455183,53294490,29),(26455183,53294487,30),(26455183,53294483,31),(26455183,53294479,32),(26455183,53294475,33),(26455183,53294474,34),(26455183,53294469,35),(26455183,53294466,36),(26455183,53294463,37),(26455183,53294458,38),(26455183,53294455,39),(26455183,53294450,40),(26455183,53294448,41),(26455183,53294444,42),(26455183,53294443,43),(26455183,53294436,44),(26455183,53294434,45),(26455183,53294433,46),(26455183,53294430,47),(26455183,53294429,48),(26455183,53294425,49),(26455183,53294423,50),(26455183,53294420,51),(26455183,53294418,52),(26455183,53294416,53),(26455183,53294411,54),(26455183,53294409,55),(26455183,53294404,56),(26455183,53294401,57),(26455183,53294396,58),(26455183,53294394,59),(26455183,53294392,60),(26455183,53294389,61),(26455183,53294385,62),(26455183,53294382,63),(26455183,53294377,64),(26455183,53294374,65),(26455183,53294371,66),(26455183,53294366,67),(26455183,53294364,68),(26455183,53294362,69),(26455183,53294357,70),(26455183,53294354,71),(26455183,53294352,72),(26455183,53294350,73),(26455183,53294347,74),(26455183,53294344,75),(26455183,53294341,76),(26455183,53294337,77),(26455183,53294335,78),(26455183,53294331,79),(26455183,53294327,80),(26455183,53294323,81),(26455183,53294320,82),(26455183,53294317,83),(26455183,53294314,84),(26455183,53294311,85),(26455183,53294308,86),(26455183,53294304,87),(26455183,53294300,88),(26455183,53294297,89),(26455183,53294293,90),(26455183,53294290,91),(26455183,53294285,92),(26455183,53294284,93),(26455183,53294279,94),(26455183,53294277,95),(26455183,53294273,96),(26455183,53294270,97),(26455183,53294268,98),(26455183,53294267,99),(26455183,53294264,100),(26455183,53294262,101),(26455183,53294260,102),(26455183,53294258,103),(26455183,53294255,104),(26455183,53294253,105),(26455183,53294251,106),(26455183,53294248,107),(26455183,53294245,108),(26455183,53294244,109),(26455183,53294241,110),(26455183,53294239,111),(26455183,53294236,112),(26455183,53294235,113),(26455183,53294233,114),(26455183,53294231,115),(26455183,53294228,116),(26455183,53294226,117),(26455183,53294221,118),(26455183,53294219,119),(26455183,53294218,120),(26455183,53294215,121),(26455183,53294213,122),(26455183,53294223,123),(26455183,53294212,124),(26455183,53294209,125),(26455183,53294207,126),(26455183,53294205,127),(26455183,53294202,128),(26455183,53294199,129),(26455183,53294197,130),(26455183,53294195,131),(26455183,53294194,132),(26455183,53294192,133),(26455183,53294189,134),(26455183,53294186,135),(26455183,53294184,136),(26455183,53294181,137),(26455183,53294180,138),(26455183,53294177,139),(26455183,53294174,140),(26455183,53294171,141),(26455183,53294170,142),(26455183,53294169,143),(26455183,53294168,144),(26455183,53294166,145),(26455183,53294165,146),(26455183,53294162,147),(26455183,53294160,148),(26455183,53294157,149),(26455183,53294154,150),(26455183,53294152,151),(26455183,53294149,152),(26455183,53294147,153),(26455183,53294144,154),(26455183,53294141,155),(26455183,53293510,156),(26455183,53293507,157),(26455183,53293505,158),(26455183,53293500,159),(26455183,53293232,160),(26455183,53293220,161),(26455183,53293217,162),(26455183,53293212,163),(26455183,53293205,164),(26455183,53293202,165),(26455183,53293200,166),(26455183,53293198,167),(26455183,53293197,168),(26455183,53293193,169),(26455183,53293192,170),(26455183,53293189,171),(26455183,53293188,172),(26455183,53293185,173),(26455183,53293183,174),(26455183,53293179,175),(26455183,53293177,176),(26455183,53293174,177),(26455183,53293172,178),(26455183,53293169,179),(26455183,53293167,180),(26455183,53293164,181),(26455183,53293162,182),(26455183,53293158,183),(26455183,53293157,184),(26455183,53293155,185),(26455183,53293153,186),(26455183,53293150,187),(26455183,53293148,188),(26455183,53293147,189),(26455183,53293144,190),(26455183,53293142,191),(26455183,53293137,192),(26455183,53293136,193),(26455183,53293132,194),(26455183,53293130,195),(26455183,53293127,196),(26455183,53293124,197),(26455183,53293123,198),(26455183,53293119,199),(26455183,53293117,200),(26455183,53293114,201),(26455183,53293111,202),(26455183,53293109,203),(26455183,53293108,204),(26455183,53293105,205),(26455183,53293102,206),(26455183,53293098,207),(26455183,53293097,208),(26455183,53293095,209),(26455183,53293092,210),(26455183,53293089,211),(26455183,53293087,212),(26455183,53293083,213),(26455183,53293082,214),(26455183,53293080,215),(26455183,53293077,216),(26455183,53293076,217),(26455183,53293073,218),(26455183,53293069,219),(26455183,53293067,220),(26455183,53293066,221),(26455183,53293063,222),(26455183,53293062,223),(26455183,53293060,224),(26455183,53293058,225),(26455183,53293046,226),(26455183,53293043,227),(26455183,53293039,228),(26455183,53293037,229),(26455183,53293034,230),(26455183,53293032,231),(26455183,53293029,232),(26455183,53293027,233),(26455183,53293025,234),(26455183,53293022,235),(26455183,53293018,236),(26455183,53293017,237),(26455183,53293015,238),(26455183,53293011,239),(26455183,53293010,240),(26455183,53293007,241),(26455183,53293003,242),(26455183,53293001,243),(26455183,53292997,244),(26455183,53292938,245),(26455183,53292901,246),(26455183,53288318,247),(26455183,53288317,248),(26455183,53288313,249),(26455183,53288310,250),(26455183,53288309,251),(26455183,53288308,252),(26455183,53288305,253),(26455183,53288303,254),(26455183,53288302,255),(26455183,53288300,256),(26455183,53288298,257),(26455183,53288296,258),(26455183,53288294,259),(26455183,53288292,260),(26455183,53288290,261),(26455183,53288286,262),(26455183,53288282,263),(26455183,53288281,264),(26455183,53288280,265),(26455183,53288278,266),(26455183,53288276,267),(26455183,53288273,268),(26455183,53288271,269),(26455183,53288269,270),(26455183,53288266,271),(26455183,53288263,272),(26455183,53288262,273),(26455183,53288261,274),(26455183,53288346,275),(26455183,53288259,276),(26455183,53288257,277),(26455183,53288255,278),(26455183,53288253,279),(26455183,53288250,280),(26455183,53288247,281),(26455183,53288245,282),(26455183,53288242,283),(26455183,53288239,284),(26455183,53288238,285),(26455183,53288235,286),(26455183,53288231,287),(26455183,53288229,288),(26455183,53288228,289),(26455183,53288227,290),(26455183,53288225,291),(26455183,53288223,292),(26455183,53288220,293),(26455183,53288219,294),(26455183,53288216,295),(26455183,53288213,296),(26455183,53288210,297),(26455183,53288209,298),(26455183,53288206,299),(26455183,53288203,300),(26455183,53288201,301),(26455183,53288199,302),(26455183,53288198,303),(26455183,53288196,304),(26455183,53288194,305),(26455183,53288191,306),(26455183,53288189,307),(26455183,53288187,308),(26455183,53288184,309),(26455183,53288182,310),(26455183,53288180,311),(26455183,53288178,312),(26455183,53288176,313),(26455183,53288174,314),(26455183,53288173,315),(26455183,53288171,316),(26455183,53288168,317),(26455183,53288166,318),(26455183,53288164,319),(26455183,53288161,320),(26455183,53288160,321),(26455183,53288157,322),(26455183,270731119,323),(26553947,51952643,1),(26553947,51952647,2),(26553947,51952649,3),(26553947,51952652,4),(26553947,51952653,5),(26553947,51952656,6),(26553947,51952659,7),(26553947,51952662,8),(26553947,51952665,9),(26553947,51952667,10),(26553947,51952668,11),(26553947,51952671,12),(26553947,51952672,13),(26553947,51952675,14),(26553947,51952677,15),(26553947,51952682,16),(26553947,51952684,17),(26553947,51952686,18),(26553947,51952689,19),(26553947,51952690,20),(26553947,51952692,21),(26553947,51952694,22),(26553947,51952695,23),(26553947,51952699,24),(26553947,51952701,25),(26553947,51952702,26),(26553947,51952705,27),(26553947,51952706,28),(26553947,51952709,29),(26553947,51952712,30),(26553947,51952714,31),(26553947,51952715,32),(26553947,51952717,33),(26553947,51952719,34),(26553947,51952722,35),(26553947,51952724,36),(26553947,51952727,37),(26553947,51952729,38),(26553947,51952732,39),(26553947,51952733,40),(26553947,51952737,41),(26553947,51952740,42),(26553947,51952742,43),(26553947,51952745,44),(26553947,51952748,45),(26553947,51952751,46),(26553947,51952754,47),(26553947,51952756,48),(26553947,51952758,49),(26553947,51952761,50),(26553947,51952764,51),(26553947,51952767,52),(26553947,51952770,53),(26553947,51952772,54),(26553947,51952775,55),(26553947,51952777,56),(26553947,51952780,57),(26553947,51952782,58),(26553947,51952784,59),(26553947,51952786,60),(26553947,51952788,61),(26553947,51952790,62),(26553947,51952792,63),(26553947,51952795,64),(26553947,51952797,65),(26553947,51952800,66),(26553947,51952802,67),(26553947,51952804,68),(26553947,51952807,69),(26553947,51952811,70),(26553947,51952813,71),(26553947,51952815,72),(26553947,51952818,73),(26553947,51952820,74),(26553947,51952824,75),(26553947,51952827,76),(26553947,51952829,77),(26553947,51952831,78),(26553947,51952832,79),(26553947,51952834,80),(26553947,51952837,81),(26553947,51952840,82),(26553947,51952842,83),(26553947,51952844,84),(26554007,291063328,1),(26554007,291063330,2),(26554007,291063331,3),(26554007,291063333,4),(26554007,291063334,5),(26554007,291063335,6),(26554007,291063336,7),(26554007,291063337,8),(26554007,291063338,9),(26554007,291063328,10),(26668563,51390016,1),(26668563,51118191,2),(26668563,51391067,3),(26668563,51118192,4),(26668563,51118193,5),(26668563,51118194,6),(27826413,52613274,1),(27826413,52613277,2),(27826413,52613279,3),(27826413,52613282,4),(27826413,52613285,5),(27826413,52613288,6),(27826413,52613289,7),(27826413,52613292,8),(27826413,52613295,9),(27826413,52613297,10),(27826413,52613300,11),(27826413,52613301,12),(27826413,52613303,13),(27826413,52613304,14),(27826413,52613306,15),(27826413,52613309,16),(27826413,52613310,17),(27826413,52613312,18),(27826413,52613314,19),(27826413,52613317,20),(27826413,52613318,21),(27826413,52613320,22),(27826413,52613323,23),(27826413,52613325,24),(27826413,52613330,25),(27826413,52613332,26),(28828385,316946989,1),(28828385,316946990,2),(28828385,316946991,3),(28828385,316946992,4),(28828388,316946992,1),(28828388,316947014,2),(28828388,316947015,3),(28828388,316947016,4),(28828388,316947017,5),(28828789,316949605,1),(28828789,316949604,2),(28828789,316949603,3),(28828789,316947017,4),(28828789,316950996,5),(28828789,316950997,6),(28828789,316950998,7),(28828789,316950999,8),(28828789,316951000,9),(28828789,316951001,10),(28829736,316961219,1),(28829736,316961221,2),(28829736,316961223,3),(28829736,316961225,4),(28829748,316961289,1),(28829748,316961291,2),(28829748,316961294,3),(28829748,319543646,4),(28829748,316961244,5),(28829748,319541450,6),(28829748,316961245,7),(28829748,316961246,8),(28829748,316961247,9),(28829753,316961244,1),(28829753,316961331,2),(28829753,316961332,3),(28829753,316961335,4),(28829753,316961337,5),(28829753,316961339,6),(28829753,316961341,7),(28829753,316961342,8),(28829753,316961343,9),(28829753,316961219,10),(28829753,316961344,11),(28829753,316961345,12),(28829753,316961346,13),(28829766,316961407,1),(28829766,319538722,2),(28829766,319538724,3),(28829766,319538726,4),(28829766,319538728,5),(28829766,319538731,6),(28829766,319538733,7),(28829766,319538735,8),(28829766,316961518,9),(28829766,316961289,10),(28829766,316963054,11),(28829773,316961406,1),(28829773,316961375,2),(28829773,316961407,3),(28829773,316961408,4),(28829773,316961409,5),(28829773,316961410,6),(28829773,316961411,7),(28829773,316961412,8),(28829773,316961413,9),(28829773,316961414,10),(28829773,316961415,11),(28829773,316961416,12),(28829773,316961417,13),(28829773,316961418,14),(28829773,316961419,15),(28829773,316961420,16),(28829773,316961421,17),(28829779,316961468,1),(28829779,316961469,2),(28829779,316961471,3),(28829779,316961421,4),(28829779,316961473,5),(28829779,316961475,6),(28829779,316961477,7),(28829779,316961478,8),(28829779,316961480,9),(28829779,316961481,10),(28829779,316961483,11),(28829779,316961484,12),(28829779,316961410,13),(28829779,316961486,14),(28829910,316961346,1),(28829910,316962617,2),(28829910,316962618,3),(28829910,316962619,4),(28829910,316962620,5),(28829910,316962621,6),(28829910,316962622,7),(28829910,316962623,8),(28829910,316962624,9),(28829910,316962625,10),(28829910,316962626,11),(28829910,316962627,12),(28829910,316962628,13),(28829910,316961406,14),(28829964,316961352,1),(28829964,316962619,2),(28829967,316963054,1),(28829967,316961349,2),(28829967,316961350,3),(28829967,316961351,4),(28829967,316961352,5),(28832922,316985238,1),(28832922,316985239,2),(28832923,316961247,1),(28832923,316985238,2),(28833468,259986469,1),(28833468,259986468,2),(28833468,259986467,3),(28833468,259986466,4),(28833468,259986465,5),(28833468,259986464,6),(28833468,259986463,7),(28833468,259986462,8),(28833468,259986461,9),(28833468,259986460,10),(28833770,51118205,1),(28833770,51118206,2),(28833770,51118207,3),(28833770,51118208,4),(28833770,51118209,5),(28833770,51118210,6),(28833770,51118211,7),(28833880,51118135,1),(28833880,51118136,2),(28833880,51118137,3),(28833880,51118138,4),(28833880,51118140,5),(28833880,51118141,6),(28833880,51118142,7),(28833880,51118143,8),(28833880,51118144,9),(28833880,51118145,10),(28833880,51118146,11),(28833880,51118148,12),(28833880,51118149,13),(28833880,51118150,14),(28833880,51118151,15),(28833880,51118152,16),(28833880,51118153,17),(28833880,51118155,18),(28833880,51118156,19),(28833880,51118157,20),(28833924,51118654,1),(28833924,51118655,2),(28833924,51118656,3),(28833924,51118658,4),(28833924,51118659,5),(28833924,51118661,6),(28833924,51118662,7),(28833924,51118663,8),(28833924,51118664,9),(28833924,51118666,10),(28833924,51118667,11),(28833924,51118668,12),(28833924,51118669,13),(28833924,51118671,14),(28833924,51118263,15),(28833924,51118071,16),(28833924,51118073,17),(28833924,51118074,18),(28833924,51118076,19),(28833927,206333343,1),(28833927,206333352,2),(28833927,206333048,3),(28833927,206333355,4),(28833927,206333356,5),(28833927,206333118,6),(28833927,206333124,7),(28833927,206333120,8),(28833927,206333119,9),(28833927,206333194,10),(28833927,206333041,11),(28833927,206333043,12),(28833927,206333618,13),(28833927,206333525,14),(28833927,206330752,15),(28833927,206333534,16),(28833927,206333353,17),(28833927,206333344,18),(28833927,206333171,19),(28833927,206333617,20),(28833927,51118653,21),(28833927,51118654,22),(28833935,51119127,1),(28833935,51119128,2),(28833935,51119129,3),(28833935,51119130,4),(28833935,51119131,5),(28833935,51118641,6),(28833935,51118642,7),(28833935,206332846,8),(28833935,206330773,9),(28833935,206333191,10),(28833935,206333347,11),(28833935,206333343,12),(28833936,51119121,1),(28833936,51119123,2),(28833936,51119124,3),(28833936,51119125,4),(28833936,51119126,5),(28833936,51119127,6),(28833957,51119112,1),(28833957,51119113,2),(28833957,51119114,3),(28833957,51119116,4),(28833957,51119117,5),(28833957,51119118,6),(28833957,51119119,7),(28833957,51119120,8),(28833957,51119121,9),(28833958,51119105,1),(28833958,51119106,2),(28833958,51119107,3),(28833958,51119108,4),(28833958,51119109,5),(28833958,51119110,6),(28833958,51119111,7),(28833958,51119112,8),(29051459,316961518,1),(29051459,319543280,2),(29051459,319541439,3),(29051459,319541441,4),(29051459,319541444,5),(29051459,319541446,6),(29051459,319541448,7),(29051459,316961244,8),(29249135,321679128,1),(29249135,321679131,2),(29249135,321679133,3),(29249135,321679135,4),(29249135,321679137,5),(29249135,321679139,6),(29249135,321679141,7),(29249135,321679143,8),(29249135,321679145,9),(29249135,321679147,10),(29249135,321679148,11),(29249135,321679150,12),(29249135,321679151,13),(29249135,321679152,14),(29249135,321679154,15),(29249135,321679155,16),(29249135,321679156,17),(29249135,321679157,18),(29249135,321679159,19),(29249135,321679160,20),(29249135,321679161,21),(29249135,321679162,22),(29249135,321679163,23),(29249135,321679164,24),(29249135,321679165,25),(29249135,321679166,26),(29249135,321679170,27),(29249135,321679176,28),(29249135,321679180,29),(29249135,321679181,30),(29249135,321679182,31),(29249135,321679183,32),(29249135,321679184,33),(29249135,321679185,34),(29249135,321679186,35),(29249135,321679188,36),(29249135,321679189,37),(29249135,321679190,38),(29249135,321679191,39),(29249135,321679196,40),(29249135,321679197,41),(29249135,321679198,42),(29249135,321679199,43),(29249135,321679200,44),(29249135,321679202,45),(29249135,321679203,46),(29249135,321679204,47),(29249135,321679205,48),(29249135,321679206,49),(29249135,321679207,50),(29249135,321679208,51),(29249135,321679209,52),(29249135,321679210,53),(29249135,321679212,54),(29249135,321679213,55),(29249135,321679214,56),(29249135,321679215,57),(29249135,321679216,58),(29249135,321679217,59),(29249135,321679218,60),(29249135,321679219,61),(29249135,321679220,62),(29249135,321679221,63),(29249135,321679223,64),(29249135,321679224,65),(29249135,321679225,66),(29249135,321679226,67),(29249135,321679227,68),(29249135,321679228,69),(29249135,321679229,70),(29249135,321679230,71),(29249135,321679231,72),(29249135,321679233,73),(29249135,321679234,74),(29249135,321679236,75),(29249135,321679237,76),(29249135,321679238,77),(29249135,321679240,78),(29249135,321679242,79),(29249135,321679245,80),(29249135,321679247,81),(29249135,321679250,82),(29249135,321679252,83),(29249135,321679254,84),(29249135,321679255,85),(29249135,321679257,86),(29249135,321679260,87),(29249135,321679263,88),(29249135,321679266,89),(29249135,321679268,90),(29249135,321679271,91),(29249135,321679273,92),(29249135,321679275,93),(29249135,321679278,94),(29249135,321679281,95),(29249135,321679283,96),(29249135,321679286,97),(29249135,321679288,98),(29249135,321679290,99),(29249135,321679293,100),(29249135,321679295,101),(29249135,321679296,102),(29249135,321679298,103),(29249135,321679300,104),(29249135,321679302,105),(29249135,321679304,106),(29249135,321679306,107),(29249135,321679308,108),(29249135,321679309,109),(29249135,321679311,110),(29249135,321679313,111),(29249135,321679316,112),(29249135,321679318,113),(29249135,321679320,114),(29249135,321679322,115),(29249135,321679324,116),(29249135,321679326,117),(29249136,321679489,1),(29249136,321679518,2),(29249136,321679519,3),(29249136,321679520,4),(29249136,321679521,5),(29249136,321679522,6),(29249136,321679523,7),(29249136,321679524,8),(29249136,321679525,9),(29249136,321679526,10),(29249136,321679527,11),(29249136,321679528,12),(29249136,321679529,13),(29249136,321679530,14),(29249136,321679536,15),(29249136,321679543,16),(29249136,321679544,17),(29249136,321679545,18),(29249136,321679546,19),(29249136,321679549,20),(29249136,321679550,21),(29249136,321679551,22),(29249136,321679552,23),(29249136,321679553,24),(29249136,321679554,25),(29249136,321679555,26),(29249136,321679556,27),(29249136,321679557,28),(29249136,321679558,29),(29249136,321679559,30),(29249136,321679560,31),(29249136,321679561,32),(29249136,321679562,33),(29249136,321679563,34),(29249136,321679564,35),(29249136,321679565,36),(29249136,321679566,37),(29249136,321679567,38),(29249136,321679568,39),(29249700,262461660,1),(29249700,321683315,2),(29249700,321683317,3),(29249700,321683319,4),(29249700,321683321,5),(29249700,321683323,6),(29249700,321683326,7),(29249700,321683328,8),(29249700,321683330,9),(29249700,321683332,10),(29249700,321683334,11),(29249700,321683336,12),(29249700,321683338,13),(29249700,321683341,14),(29249700,321683343,15),(29249700,321683345,16),(29249700,321683347,17),(29249700,321683349,18),(29249700,321683351,19),(29249700,321683353,20),(29249700,321683355,21),(29249700,321683357,22),(29249700,321683358,23),(29249700,321683359,24),(29249700,321683360,25),(29249700,321683361,26),(29249700,321683362,27),(29249700,321683363,28),(29249700,321683364,29),(29249700,321683365,30),(29249700,321683366,31);
INSERT INTO `current_way_nodes` VALUES (29249700,321683367,32),(29249700,321683368,33),(29249700,321683369,34),(29249700,321683370,35),(29249700,321683371,36),(29249700,321683372,37),(29249700,321683373,38),(29249700,321683374,39),(29249700,321683375,40),(29249700,321683376,41),(29249700,321683377,42),(29249700,321683378,43),(29249700,321683379,44),(29249700,321683380,45),(29249700,321683381,46),(29249700,321683382,47),(29249700,321683383,48),(29249700,321683384,49),(29249700,321683385,50),(29249700,321683386,51),(29249700,321683387,52),(29249700,321683388,53),(29249700,321683389,54),(29249700,321683390,55),(29249700,321683391,56),(29249700,321683392,57),(29249700,321683393,58),(29249700,321683394,59),(29249700,321683395,60),(29249700,321683396,61),(29249700,321683397,62),(29249700,321683398,63),(29249700,321683399,64),(29249700,321683400,65),(29249700,321683401,66),(29249700,321683402,67),(29249700,321683403,68),(29249700,321683405,69),(29249700,321683407,70),(29249700,321683408,71),(29249700,321683409,72),(29249700,321683410,73),(29249700,321683411,74),(29249700,321683412,75),(29249700,321683413,76),(29249700,321683414,77),(29249700,321683415,78),(29249700,321683416,79),(29249700,321683417,80),(29249700,321683418,81),(29249700,321683419,82),(29249700,321683420,83),(29249700,321683421,84),(29249700,321683422,85),(29249700,321683423,86),(29249700,321683424,87),(29249700,321683425,88),(29249700,321683426,89),(29249700,321683427,90),(29249700,321683428,91),(29249700,321683429,92),(29249700,321683430,93),(29249700,321683431,94),(29249700,321683432,95),(29249700,321683434,96),(29249700,321683436,97),(29249700,321683438,98),(29249700,321683440,99),(29249700,321683441,100),(29249700,321683443,101),(29249700,321683445,102),(29249700,321683447,103),(29249700,321683448,104),(29249700,321683449,105),(29249700,321683450,106),(29249700,321683451,107),(29249700,321683452,108),(29249700,321683453,109),(29249700,321683454,110),(29249700,321683455,111),(29249700,321683456,112),(29249700,321683457,113),(29249700,321683458,114),(29249700,321683459,115),(29249700,321683460,116),(29249700,321683461,117),(29249700,321683462,118),(29249700,321683463,119),(29249700,321683464,120),(29249700,321683465,121),(29249700,321683466,122),(29249700,321683467,123),(29249700,321683468,124),(29249700,321683469,125),(29249700,321683470,126),(29249700,321683471,127),(29249700,321683472,128),(29249700,321683473,129),(29249700,321683474,130),(29249700,321683475,131),(29249700,321683476,132),(29249700,321683477,133),(29249700,321683478,134),(29249700,321683479,135),(29249700,321683480,136),(29249700,321683481,137),(29249700,321683482,138),(29249700,321683483,139),(29249700,321683484,140),(29249700,321683485,141),(29249700,321683486,142),(29249700,321683487,143),(29249700,321683488,144),(29249700,321683489,145),(29249700,321683490,146),(29249700,321683491,147),(29249700,321683492,148),(29249700,321683493,149),(29249700,321683494,150),(29249700,321683495,151),(29249700,321683496,152),(29249700,321683497,153),(29249700,321683498,154),(29249700,321683499,155),(29249700,321683500,156),(29249700,321683501,157),(29249700,321683502,158),(29249700,321683503,159),(29249700,321683504,160),(29249700,321683505,161),(29249700,321683506,162),(29249700,321683507,163),(29249700,321683508,164),(29249700,321683509,165),(29249700,321683510,166),(29249700,321683511,167),(29249700,321683512,168),(29249700,321683513,169),(29249700,321683514,170),(29249700,321683515,171),(29249700,321683516,172),(29249700,321683517,173),(29249700,321683518,174),(29249700,321683519,175),(29249700,321683520,176),(29249700,321683521,177),(29249700,321683522,178),(29249700,321683523,179),(29249700,321683524,180),(29249700,321683525,181),(29249700,321683526,182),(29249700,321683527,183),(29249700,321683528,184),(29249700,321683529,185),(29249700,321683530,186),(29249700,321683532,187),(29249700,321683533,188),(29249700,321683534,189),(29249700,321683535,190),(29249700,321683536,191),(29249700,321683537,192),(29249700,321683538,193),(29249700,321683539,194),(29249700,321683540,195),(29249700,321683541,196),(29249700,321683542,197),(29249700,321683543,198),(29249700,321683544,199),(29376254,323129883,1),(29376254,323129885,2),(29376356,323130871,1),(29376356,323130873,2),(29376448,323131766,1),(29376448,323131768,2),(29422567,51438632,1),(29422567,51438634,2),(29422567,51438635,3),(29422567,51438636,4),(29422567,51438638,5),(29422567,51438639,6),(29422567,51438642,7),(29422567,51438643,8),(29422567,51438645,9),(29422567,51438646,10),(29422567,51438647,11),(29422567,51438648,12),(29422567,51438650,13),(29422567,51438812,14),(29422567,51438651,15),(29422567,51438652,16),(29422567,51438654,17),(29422567,51438655,18),(29422567,51438656,19),(29422567,51438658,20),(29422567,51438659,21),(29422567,51438660,22),(29422567,51438661,23),(29422567,51438662,24),(29422567,51438663,25),(29422567,51438665,26),(29422567,51438666,27),(30139079,266332083,1),(30139079,332119286,2),(30139079,332119287,3),(30139079,332119288,4),(30139079,332119289,5),(30139079,332119290,6),(30139079,332119070,7),(30139093,266332087,1),(30139093,332119414,2),(30139093,332119415,3),(30139093,332119416,4),(30139093,332119417,5),(30139093,332119418,6),(30139093,332119076,7),(30139242,332119070,1),(30139242,332119071,2),(30139242,332119072,3),(30139242,332119073,4),(30139242,332119074,5),(30139242,332119075,6),(30139242,332119076,7),(30139242,332122179,8),(30139242,332122180,9),(30139242,332122181,10),(30139242,332122182,11),(30139242,332122183,12),(30139242,332122184,13),(30139242,332122185,14),(30139242,332122186,15),(30139242,332122187,16),(30139242,332122188,17),(30139242,332122189,18),(30139242,332121137,19),(30139403,332126612,1),(30139403,332126613,2),(30139403,332126614,3),(30139403,332126615,4),(30139403,332125718,5),(30139408,316946992,1),(30139408,332126684,2),(30139408,332126685,3),(30139408,332126688,4),(30139408,332126689,5),(30139408,332126612,6),(30567238,337742674,1),(30567238,337775423,2),(30567238,337775425,3),(30567238,337775428,4),(30567542,51405263,1),(30567542,337782221,2),(30567542,337782224,3),(30567542,337781593,4),(30567542,337767559,5),(30571624,337833707,1),(30571624,337833711,2),(30571624,337833715,3),(30572100,337840780,1),(30572100,337840784,2),(30572100,337840789,3),(30572100,337840791,4),(30572100,337840797,5),(30572100,337840800,6),(30572100,337840804,7),(30572100,337840809,8),(30572100,337840812,9),(30572100,337840815,10),(30572100,337840821,11),(30572100,337833715,12),(30572104,337833715,1),(30572104,337840888,2),(30572116,337840888,1),(30572116,337840981,2),(30572116,337840986,3),(30572116,337840989,4),(30572138,337840989,1),(30572138,337841272,2),(30572138,337841280,3),(30572145,337841280,1),(30572145,337841383,2),(30572187,337841643,1),(30572187,337841646,2),(30572187,337841651,3),(30572187,337841655,4),(30572187,337841658,5),(30572187,337841661,6),(30605340,338420420,1),(30605340,338420421,2),(30605340,338420422,3),(30605340,338420423,4),(30605340,338420424,5),(30605340,338420425,6),(30605340,338420426,7),(30605340,338420420,8),(30605380,338418932,1),(30605380,338420688,2),(30605380,338420689,3),(30605380,338420690,4),(30605380,338420691,5),(30605380,338420692,6),(30605380,338420693,7),(30605380,338420694,8),(30605380,338420695,9),(30605380,338420696,10),(30605380,338420697,11),(30605380,338420698,12),(30605380,338420699,13),(30605380,338420700,14),(30605380,338420701,15),(30605380,338420702,16),(30605457,262462280,1),(30605457,338422550,2),(30605457,338422551,3),(30605650,338425045,1),(30605650,338425046,2),(30605670,338425186,1),(30605670,338425409,2),(30605670,338425046,3),(30605680,338425484,1),(30605680,338425485,2),(30605680,338425486,3),(30605683,338425484,1),(30605683,338425556,2),(30605683,338425045,3),(30605683,338425558,4),(30605683,338425560,5),(30605683,338425561,6),(30605683,338425186,7),(30605683,338425562,8),(30605683,53327626,9),(30605686,338425046,1),(30605686,338425567,2),(30605686,338425484,3),(30605697,338425636,1),(30605697,338425637,2),(30605697,338425638,3),(30605697,338425639,4),(30605697,338425640,5),(30605697,338425642,6),(30605697,338425643,7),(30605697,338425644,8),(30605697,338425645,9),(30605697,338425647,10),(30605697,338425648,11),(30605698,338425648,1),(30605698,338425715,2),(30605698,338425717,3),(30605698,338425046,4),(30605769,338422551,1),(30605769,338426328,2),(30605769,338426330,3),(30605769,338426331,4),(30605769,338426332,5),(30605769,338426338,6),(30605769,338426339,7),(30605769,338426340,8),(30605769,338426341,9),(30605769,338426342,10),(30605769,338426343,11),(30605769,338426344,12),(30605769,338426345,13),(30605769,338426346,14),(30605769,338426347,15),(30605769,338425636,16),(30772650,340304066,1),(30772650,340304067,2),(30772650,340304068,3),(30772650,340304069,4),(30772650,340304066,5),(30772702,340304325,1),(30772702,340304326,2),(30772702,340304327,3),(30772702,340304328,4),(30772702,340304329,5),(30772702,340304325,6),(30922493,337739581,1),(30922493,51400259,2),(30922493,51410233,3),(30922493,51410286,4),(30922493,51400263,5),(30922528,51400272,1),(30922528,51400273,2),(30922528,51400276,3),(30922528,51400277,4),(30922528,51400280,5),(30922528,51400281,6),(31348544,52579373,1),(31348544,52579376,2),(31348544,52579377,3),(31348544,52579379,4),(31348544,52579381,5),(31348544,52579383,6),(31348544,52579386,7),(31348544,52579387,8),(31348544,52579389,9),(31348544,52579390,10),(31348544,52579393,11),(31348544,52579395,12),(31348544,52579397,13),(31348544,52579399,14),(31348544,52579401,15),(31348544,52579402,16),(31348544,52579405,17),(31348544,52579406,18),(31348544,52579409,19),(31348544,52579410,20),(31348544,52579413,21),(31348544,52579415,22),(31348544,52579416,23),(31348544,52579418,24),(31348544,52579420,25),(31348544,52594915,26),(31348544,52594920,27),(31348544,52594929,28),(31348544,52594931,29),(31348544,52594940,30),(31348544,52594946,31),(31348544,52594954,32),(31348544,52594957,33),(31348544,52594959,34),(31348544,52594963,35),(31348544,52594965,36),(31348544,52594968,37),(31348544,52594974,38),(31348544,52594977,39),(31348544,52594982,40),(31348544,52594985,41),(31348544,52594988,42),(31348544,52594989,43),(31348544,52594992,44),(31348544,52594994,45),(31348544,52594997,46),(31348544,52594999,47),(31348544,52595005,48),(31348544,52595009,49),(31348544,52595015,50),(31348544,52595021,51),(31348544,52595029,52),(31348544,52595034,53),(31348544,52595041,54),(31348544,52595042,55),(31348544,52595047,56),(31348544,52595051,57),(31348544,52595054,58),(31348544,52595059,59),(31348544,52595062,60),(31348544,52595064,61),(31348544,52595067,62),(31348544,52595070,63),(31348544,52595073,64),(31348544,52595074,65),(31348544,52595077,66),(31348544,52595079,67),(31348544,52595082,68),(31348544,52595084,69),(31348544,52595087,70),(31348544,52595090,71),(31348544,52595093,72),(31348544,52595096,73),(31348544,52595100,74),(31348544,52595103,75),(31348544,52595106,76),(31348544,52595107,77),(31348544,52595115,78),(31348544,52595118,79),(31348544,52595122,80),(31348544,52595125,81),(31348633,349146313,1),(31348633,349146314,2),(31348633,349146315,3),(31348633,349146316,4),(31726348,354962604,1),(31726348,51581699,2),(31726372,354962603,1),(31726372,354962622,2),(31726372,354962620,3),(31726372,354962618,4),(31726372,354962614,5),(31726372,354962612,6),(31726372,354962610,7),(31726372,354962608,8),(31726372,354962605,9),(31726372,354962604,10),(31726372,354962603,11),(31726416,51581699,1),(31726416,354962622,2),(31726467,354962410,1),(31726467,354962612,2),(31726482,354962618,1),(31726482,354962410,2),(31726492,53306959,1),(31726492,354962605,2),(31726507,354962610,1),(31726507,53306959,2),(31726661,266622367,1),(31726661,354966294,2),(31726661,51581715,3),(31726661,51581711,4),(31726661,51581708,5),(31726661,51581705,6),(31726661,332121137,7),(31726661,51581702,8),(31726661,332121136,9),(31726661,51581699,10),(31726701,354966710,1),(31726701,354966711,2),(31726701,51581724,3),(31726701,51581727,4),(31726701,51581729,5),(31726701,51581732,6),(31726701,51581737,7),(31726701,51581739,8),(31726701,51581743,9),(31726701,51581745,10),(31726701,51581748,11),(31726701,266333917,12),(31726701,266334931,13),(31726701,266334932,14),(31726701,51581782,15),(31726779,354966915,1),(31726779,354966931,2),(31726779,354966929,3),(31726779,354966927,4),(31726779,354966925,5),(31726779,354966923,6),(31726779,354966921,7),(31726779,354966919,8),(31726779,354966917,9),(31726779,354966915,10),(31726812,354966931,1),(31726812,354966710,2),(31726812,354966917,3),(31726851,354966927,1),(31726851,266622367,2),(31726851,354966923,3),(31726898,354966921,1),(31726898,266622366,2),(31726898,354966919,3),(32211744,51400870,1),(32211744,51400871,2),(32549432,51957018,1),(32549432,366060792,2),(32549432,366060794,3),(32549432,366060795,4),(32549432,366060796,5),(32549432,366060797,6),(32549432,366060798,7),(32549432,366060800,8),(32549432,366060801,9),(32549432,366060803,10),(32549432,366060804,11),(32549432,366060805,12),(32549432,366060807,13),(32549432,366060808,14),(32549432,366060810,15),(32549432,366060811,16),(32549432,366060812,17),(32549432,366060813,18),(32549432,366060815,19),(32549432,366060816,20),(32549432,366060818,21),(32549432,366060819,22),(32549432,366060820,23),(32549432,366060821,24),(32549432,366060822,25),(32549432,366060823,26),(32549432,366060824,27),(32549432,366060825,28),(32549432,366060826,29),(32549432,366060827,30),(32549432,366060828,31),(32549432,366060829,32),(32549432,366060830,33),(32549432,366060833,34),(32549432,366060834,35),(32549432,366060836,36),(32549432,366060838,37),(32549432,366060840,38),(32549432,366060841,39),(32549432,366060843,40),(32549432,366060845,41),(32549432,366060846,42),(32549432,366060848,43),(32549432,366060850,44),(32549432,366060852,45),(32549432,366060854,46),(32549432,366060856,47),(32549432,366060857,48),(32549432,366060858,49),(32549432,366060859,50),(32549432,366060861,51),(32549432,366060862,52),(32549432,366060863,53),(32549432,366060864,54),(32549432,366060865,55),(32549432,366060866,56),(32549432,366060867,57),(32549432,366060868,58),(32549432,366060869,59),(32549432,366060870,60),(32549432,366060871,61),(32549432,366060820,62),(32549444,366061154,1),(32549444,366060968,2),(32549444,366060970,3),(32549444,366060971,4),(32549444,366060973,5),(32549444,366060975,6),(32549444,366060977,7),(32549444,366060978,8),(32549444,366060980,9),(32549444,366060982,10),(32549444,366060984,11),(32549444,366060986,12),(32549444,366060987,13),(32549444,366060989,14),(32549444,366060992,15),(32549444,366060994,16),(32549444,366060995,17),(32549444,366060997,18),(32549444,366060999,19),(32549444,366061000,20),(32549444,366061002,21),(32549444,366061004,22),(32549444,366061007,23),(32549444,366061009,24),(32549444,366061012,25),(32549444,366061015,26),(32549444,366061016,27),(32549444,366061018,28),(32549444,366061020,29),(32549444,366061021,30),(32549444,366061023,31),(32549444,366061025,32),(32549444,366061027,33),(32549444,366061029,34),(32549444,366061031,35),(32549444,366061032,36),(32549444,366061034,37),(32549444,366061036,38),(32549444,366061037,39),(32549444,366061038,40),(32549444,366061040,41),(32549444,366061042,42),(32549444,366061044,43),(32549444,366061045,44),(32549444,366061047,45),(32549444,366061049,46),(32549444,366061050,47),(32549444,366061051,48),(32549444,366061052,49),(32549444,366061054,50),(32549444,366061055,51),(32549444,366061056,52),(32549444,366061057,53),(32549444,366061058,54),(32549444,366061060,55),(32549444,366061061,56),(32549444,366061063,57),(32549444,366061065,58),(32549444,366061067,59),(32549444,366061071,60),(32549444,366061073,61),(32549444,366061076,62),(32549444,366061079,63),(32549444,366061081,64),(32549444,366061083,65),(32549444,366061085,66),(32549444,366061087,67),(32549444,366061088,68),(32549444,366061090,69),(32549444,366061092,70),(32549444,366061094,71),(32549444,366061095,72),(32549444,366061097,73),(32549444,366061099,74),(32549444,366061101,75),(32549444,366061102,76),(32549444,366061104,77),(32549444,366061106,78),(32549444,366061109,79),(32549444,366061111,80),(32549444,366061113,81),(32549444,366061115,82),(32549444,366061117,83),(32549444,366061119,84),(32549444,366061122,85),(32549444,366061124,86),(32549444,366061126,87),(32549444,366061128,88),(32549444,366061130,89),(32549444,366061132,90),(32549444,366061135,91),(32549444,366061137,92),(32549444,366061139,93),(32549444,366061141,94),(32549444,366061144,95),(32549444,366061145,96),(32549444,366061147,97),(32549444,366061148,98),(32549444,366061149,99),(32551123,366076279,1),(32551123,366076280,2),(32551123,366076281,3),(32551123,366076282,4),(32551123,366076283,5),(32551123,366076284,6),(32551123,366076286,7),(32551123,366076287,8),(32551123,366076288,9),(32551123,366076289,10),(32551123,366076290,11),(32551123,366076291,12),(32551123,366076292,13),(32551123,366076293,14),(32551123,366076294,15),(32551123,366076295,16),(32551123,366076296,17),(32551123,366076297,18),(32551123,366076298,19),(32551123,366076299,20),(32551123,366076300,21),(32551123,366076301,22),(32551123,366076302,23),(32551123,366076303,24),(32551123,366076304,25),(32551123,366076305,26),(32551123,366076306,27),(32551123,366076307,28),(32551123,366076308,29),(32551123,366076309,30),(32551123,366076310,31),(32551123,366076311,32),(32551123,366076312,33),(32551123,366076313,34),(32551123,366076314,35),(32551123,366076315,36),(32551123,366076316,37),(32551123,366076317,38),(32551123,366076318,39),(32551123,366076319,40),(32551123,366076320,41),(32551123,366076321,42),(32551123,366076322,43),(32551123,366076323,44),(32551123,366076324,45),(32551123,366076325,46),(32551123,366076326,47),(32551123,366076327,48),(32551123,366076328,49),(32551123,366076329,50),(32551123,366076331,51),(32551123,366076332,52),(32551123,366076333,53),(32551123,366076334,54),(32551123,366076335,55),(32551123,366076336,56),(32551123,366076337,57),(32551123,366076338,58),(32551123,366076339,59),(32551123,366076340,60),(32551123,366076341,61),(32551123,366076342,62),(32551123,366076343,63),(32551123,366076344,64),(32551123,366076345,65),(32551123,366076346,66),(32551123,366076347,67),(32551123,366076348,68),(32551123,366076349,69),(32551123,366076350,70),(32551123,366076351,71),(32551123,366076352,72),(32551123,366076353,73),(32551123,366076354,74),(32551123,366076355,75),(32551123,366076356,76),(32551123,366076357,77),(32551123,366076358,78),(32551123,366076359,79),(32551123,366076360,80),(32551123,366076361,81),(32551123,366076362,82),(32551123,366076363,83),(32551123,366076364,84),(32551123,366076365,85),(32551123,366076366,86),(32551123,366076367,87),(32551123,366076368,88),(32551123,366076369,89),(32551123,366076370,90),(32551123,366076371,91),(32551123,366076372,92),(32551123,366076373,93),(32551123,366076374,94),(32551123,366076375,95),(32551123,366076376,96),(32551123,366076378,97),(32551123,366076379,98),(32551123,366076380,99),(32551123,366076381,100),(32551123,366076382,101),(32551123,366076383,102),(32551123,366076384,103),(32551123,366076385,104),(32551123,366076386,105),(32551123,366076387,106),(32551123,366076388,107),(32551123,366076389,108),(32551123,366076390,109),(32551123,366076391,110),(32551123,366076392,111),(32551123,366076393,112),(32551123,366076394,113),(32551123,366076395,114),(32551123,366076396,115),(32551123,366076397,116),(32551123,366076398,117),(32551123,366076399,118),(32551123,366076400,119),(32551123,366076401,120),(32551123,366076402,121),(32551123,366076403,122),(32551123,366076404,123),(32551123,366076405,124),(32551123,366076406,125),(32551123,366076407,126),(32551123,366076408,127),(32551123,366076409,128),(32551123,366076410,129),(32551123,366076411,130),(32551123,366076412,131),(32551123,366076413,132),(32551123,366076414,133),(32551123,366076415,134),(32551123,366076416,135),(32551123,366076417,136),(32551123,366076418,137),(32551123,366076419,138),(32551123,366076420,139),(32551123,366076421,140),(32551123,366076422,141),(32551123,366076423,142),(32551123,366076424,143),(32551123,366076425,144),(32551123,366076426,145),(32551123,366076427,146),(32551123,366076428,147),(32551123,366076429,148),(32551123,366076430,149),(32551123,366076431,150),(32551123,366076432,151),(32551123,366076433,152),(32551123,366076434,153),(32551123,366076436,154),(32551123,366076437,155),(32551123,366076438,156),(32551123,366076439,157),(32551123,366076440,158),(32551123,366076441,159),(32551123,366076442,160),(32551123,366076443,161),(32551123,366076444,162),(32551123,366076445,163),(32551123,366076446,164),(32551123,366076447,165),(32551123,366076448,166),(32551123,366076449,167),(32551125,52204291,1),(32551125,366076544,2),(32551125,366076545,3),(32551125,366076546,4),(32551125,366076547,5),(32551125,366076548,6),(32551125,366076549,7),(32551125,366076550,8),(32551125,366076551,9),(32551125,366076552,10),(32551125,366076553,11),(32551125,366076554,12),(32551125,366076555,13),(32551125,366076556,14),(32551125,366076557,15),(32551125,366076558,16),(32551125,366076559,17),(32551125,366076560,18),(32551125,366076561,19),(32551125,366076562,20),(32551125,366076563,21),(32551125,366076564,22),(32551125,366076565,23),(32551125,366076566,24),(32551125,366076567,25),(32551125,366076568,26),(32551125,366076569,27),(32551125,366076570,28),(32551125,366076571,29),(32551125,366076572,30),(32551125,366076573,31),(32551125,366076574,32),(32551125,366076575,33),(32551125,366076576,34),(32551125,366076577,35),(32551125,366076578,36),(32551125,366076579,37),(32551125,366076580,38),(32551125,366076581,39),(32551125,366076582,40),(32551125,366076583,41),(32551125,366076584,42),(32551125,366076585,43),(32551125,366076586,44),(32551125,366076587,45),(32551125,366076588,46),(32551125,366076589,47),(32551125,366076590,48),(32551125,366076591,49),(32551125,366076592,50),(32551125,366076593,51),(32551125,366076594,52),(32551125,366076595,53),(32551125,366076596,54),(32551125,366076597,55),(32551125,366076598,56),(32551125,366076599,57),(32551125,366076600,58),(32551125,366076601,59),(32551125,366076602,60),(32551125,366076603,61),(32551125,366076604,62),(32551125,366076605,63),(32551125,366076606,64),(32551125,366076607,65),(32551125,366076608,66),(32551125,366076609,67),(32551125,366076610,68),(32551125,366076611,69),(32551125,366076612,70),(32551125,366076613,71),(32551125,366076614,72),(32551125,366076615,73),(32551125,366076617,74),(32551125,366076618,75),(32551125,366076619,76),(32551125,366076620,77),(32551125,366076621,78),(32551125,366076622,79),(32551125,366076623,80),(32551125,366076624,81),(32551125,366076625,82),(32551125,366076626,83),(32551125,366076627,84),(32551125,366076628,85),(32551125,366076629,86),(32551125,366076630,87),(32551125,366076631,88),(32551125,366076632,89),(32551125,366076633,90),(32551125,366076634,91),(32551125,366076635,92),(32551125,366076636,93),(32551125,366076637,94),(32551125,366076638,95),(32551125,366076639,96),(32551125,366076640,97),(32551125,366076641,98),(32551125,366076642,99),(32551125,366076643,100),(32551125,366076644,101),(32551125,366076645,102),(32551125,366076646,103),(32551125,366076647,104),(32551125,366076648,105),(32551125,366076649,106),(32551125,366076650,107),(32551125,366076651,108),(32551125,366076652,109),(32551125,366076653,110),(32551125,366076654,111),(32551125,366076655,112),(32551125,366076656,113),(32551125,366076657,114),(32551125,366076658,115),(32551125,366076659,116),(32551125,366076660,117),(32551125,366076661,118),(32551125,366076662,119),(32551125,366076663,120),(32551125,366076664,121),(32551125,366076665,122),(32551125,366076666,123),(32551125,366076667,124),(32551125,366076668,125),(32551125,366076669,126),(32551125,366076670,127),(32551125,366076671,128),(32551125,366076672,129),(32551125,366076673,130),(32551125,366076674,131),(32551125,366076675,132),(32551125,366076676,133),(32551125,366076677,134),(32551125,366076678,135),(32551125,366076679,136),(32551125,366076680,137),(32551125,366076681,138),(32551125,366076682,139),(32551125,366076683,140),(32551125,366076684,141),(32551125,366076685,142),(32551125,366076687,143),(32551125,366076688,144),(32551125,366076689,145),(32551125,366076690,146),(32551125,366076691,147),(32551125,366076692,148),(32551125,366076693,149),(32551125,366076694,150),(32551125,366076695,151),(32551125,366076696,152),(32551125,366076697,153),(32551125,366076698,154),(32551125,366076700,155),(32551125,366076701,156),(32551125,366076702,157),(32551125,366076704,158),(32551125,366076705,159),(32551125,366076279,160),(32594779,51930177,1),(32594779,366538118,2),(32594779,366538119,3),(32594779,366538120,4),(32594779,366538122,5),(32594779,366538124,6),(32594779,366538127,7),(32594779,366538128,8),(32594779,366538130,9),(32594779,366538131,10),(32594779,366538133,11),(32594779,366538134,12),(32594779,366538135,13),(32594779,366538137,14),(32594779,366538138,15),(32594779,366538139,16),(32594779,366538140,17),(32594779,366538141,18),(32594779,366538142,19),(32594779,366538144,20),(32594779,366538145,21),(32594779,366538146,22),(32594779,366538147,23),(32594779,366538148,24),(32594779,366538152,25),(32594779,366538153,26),(32594779,366538154,27),(32594779,366538155,28),(32594779,366538156,29),(32594779,366538157,30),(32594779,366538159,31),(32594779,366538160,32),(32594779,366538161,33),(32594779,366538162,34),(32594779,366538163,35),(32594779,366538164,36),(32594779,366538165,37),(32594779,366538166,38),(32594779,366538168,39),(32594779,366538169,40),(32594779,366538170,41),(32594779,366538171,42),(32594779,366538172,43),(32594779,366538173,44),(32594779,366538175,45),(32594779,366538176,46),(32594779,366538177,47),(32594779,366538178,48),(32594779,366538180,49),(32594779,366538181,50),(32594779,366538182,51),(32594779,366538183,52),(32594779,366538185,53),(32594779,366538186,54),(32594779,366538187,55),(32594779,366538188,56),(32594779,366538190,57),(32594779,366538192,58),(32594779,366538193,59),(32594779,366538194,60),(32594779,366538195,61),(32594779,366538196,62),(32594779,366538198,63),(32594779,366538199,64),(32594779,366538200,65),(32594779,366538201,66),(32594779,366538203,67),(32594779,366538204,68),(32594779,366538206,69),(32594779,366538207,70),(32594779,366538208,71),(32594984,51952844,1),(32594984,366540716,2),(32594984,366540717,3),(32594984,366540718,4),(32594984,366540719,5),(32594984,366540720,6),(32594984,366540721,7),(32594984,366540722,8),(32594984,366540723,9),(32594984,366540724,10),(32594984,366540725,11),(32594984,366540726,12),(32594984,366540727,13),(32594984,366540728,14),(32594984,366540730,15),(32594984,366540731,16),(32594984,366540732,17),(32594984,366540733,18),(32594984,366540734,19),(32594984,366540735,20),(32594984,366540736,21),(32594984,366540737,22),(32594984,366540738,23),(32594984,366540739,24),(32594984,366540740,25),(32594984,366540741,26),(32594984,366540742,27),(32594984,366540743,28),(32594984,366540744,29),(32594984,366540745,30),(32594984,366540746,31),(32594984,366540747,32),(32594984,366540748,33),(32594984,366540749,34),(32594984,366540750,35),(32594984,366540751,36),(32594984,366540752,37),(32594984,366540754,38),(32594984,366540755,39),(32594984,366540756,40),(32594984,366540757,41),(32594984,366540758,42),(32594984,366540759,43),(32594984,366540760,44),(32594984,366540761,45),(32594984,366540762,46),(32594984,366540763,47),(32594984,366540764,48),(32594984,366540765,49),(32594984,366540766,50),(32594984,366540767,51),(32594984,366540768,52),(32594984,366540769,53),(32594984,366540770,54),(32594984,366540771,55),(32594984,366540772,56),(32594984,366540773,57),(32594984,366540774,58),(32594984,366540775,59),(32594984,366540776,60),(32594984,366540777,61),(32594984,366540778,62),(32594984,366540779,63),(32594984,366540780,64),(32594984,366540782,65),(32594984,366540783,66),(32594984,366540784,67),(32594984,366540785,68),(32594984,366540786,69),(32594984,366540787,70),(32594984,366540788,71),(32594984,366540789,72),(32594984,366540792,73),(32594984,366540793,74),(32594984,366540794,75),(32594984,366540795,76),(32594984,366540796,77),(32594984,366540798,78),(32594984,366540800,79),(32594984,366540801,80),(32594984,366540802,81),(32594984,366540803,82),(32594984,366540804,83),(32594984,366540805,84),(32594984,366540806,85),(32594984,366540807,86),(32594984,366540808,87),(32594984,366540809,88),(32594984,366540810,89),(32594984,366540811,90),(32594984,366540812,91),(32594984,366540813,92),(32594984,366540814,93),(32594984,366540815,94),(32594984,366540816,95),(32594984,366540817,96),(32594984,366540818,97),(32594984,366540820,98),(32594984,366540821,99),(32594984,366540822,100),(32594984,366540823,101),(32594984,366540824,102),(32594984,366540825,103),(32594984,366540826,104),(32594984,366540827,105),(32594984,366540828,106),(32594984,366540829,107),(32594984,366540830,108),(32594984,366540831,109),(32594984,366540832,110),(32594984,366540833,111),(32594984,366540834,112),(32594984,366540835,113),(32594984,366540836,114),(32594984,366540837,115),(32594984,366540838,116),(32594984,366540839,117),(32594984,366540840,118),(32594984,366540841,119),(32594984,366540842,120),(32594984,366540843,121),(32594984,366540845,122),(32594984,366540846,123),(32594984,366540847,124),(32594984,366540848,125),(32594984,366540849,126),(32594984,366540850,127),(32594984,366540851,128),(32594984,366540852,129),(32594984,366540853,130),(32594984,366540854,131),(32594984,366540855,132),(32594984,366540856,133),(32594984,366540857,134),(32594984,366540858,135),(32594984,366540859,136),(32594984,366540860,137),(32594984,366540861,138),(32594984,366540862,139),(32594984,366540863,140),(32594984,366540864,141),(32594984,366540865,142),(32594984,366540866,143),(32594984,366540867,144),(32594984,366540868,145),(32594984,366540869,146),(32594984,366540870,147),(32594984,366540871,148),(32594984,366540873,149),(32594984,366540874,150),(32594984,366540875,151),(32594984,366540876,152),(32594985,366540876,1),(32594985,366540883,2),(32594985,366540884,3),(32594985,366540885,4),(32594985,366540886,5),(32594985,366540887,6),(32594985,366540888,7),(32594985,366540889,8),(32594985,366540890,9),(32594985,366540891,10),(32594985,366540892,11),(32594985,366540893,12),(32594985,366540894,13),(32594985,366540895,14),(32594985,366540896,15),(32594985,366540897,16),(32594985,366540898,17),(32594985,366540899,18),(32594985,366540900,19),(32594985,366540901,20),(32594985,366540902,21),(32594985,366540903,22),(32594985,366540904,23),(32594985,366540905,24),(32594985,366540906,25),(32594985,366540907,26),(32594985,366540908,27),(32594985,366540909,28),(32594985,366540910,29),(32594985,366540911,30),(32594985,366540912,31),(32594985,366540913,32),(32594985,366540914,33),(32594985,366540915,34),(32594985,366540916,35),(32594985,366540917,36),(32594985,366540918,37),(32594985,366540920,38),(32594985,366540921,39),(32594985,366540922,40),(32594985,366540923,41),(32594985,366540762,42),(32598297,366578105,1),(32598297,366577779,2),(32598297,366577781,3),(32598297,366577782,4),(32598297,366577783,5),(32598297,366577784,6),(32598297,366577785,7),(32598297,366577786,8),(32598297,366577787,9),(32598297,366577788,10),(32598297,366577789,11),(32598297,366577790,12),(32598297,366577792,13),(32598297,366577793,14),(32598297,366577794,15),(32598297,366577795,16),(32598297,366577796,17),(32598297,366577797,18),(32598297,366577798,19),(32598297,366577799,20),(32598297,366577800,21),(32598297,366577802,22),(32598297,366577803,23),(32598297,366577804,24),(32598297,366577805,25),(32598297,366577806,26),(32598297,366577807,27),(32598297,366577808,28),(32598297,366577809,29),(32598297,366577810,30),(32598297,366577812,31),(32598297,366577813,32),(32598297,366577814,33),(32598297,366577815,34),(32598297,366577816,35),(32598297,366577817,36),(32598297,370906892,37),(32598300,53294709,1),(32598300,366577907,2),(32598300,366577908,3),(32598300,366577910,4),(32598300,366577912,5),(32598300,366577913,6),(32598300,366577914,7),(32598300,366577915,8),(32598300,366577917,9),(32598300,366577918,10),(32598300,366577919,11),(32598300,366577920,12),(32598300,366577922,13),(32598300,366577924,14),(32598300,366577925,15),(32598300,366577926,16),(32598300,366577927,17),(32598300,366577928,18),(32598300,366577929,19),(32598300,366577930,20),(32598300,366577931,21),(32598300,366577932,22),(32598300,366577934,23),(32598300,366577935,24),(32598300,366577936,25),(32598300,366577937,26),(32598300,366577938,27),(32598300,366577939,28),(32598300,366577940,29),(32598300,366577941,30),(32598300,366577943,31),(32598300,366577944,32),(32598300,366577945,33),(32598300,366577946,34),(32598300,366577947,35),(32598300,366577948,36),(32598300,366577949,37),(32598300,366577950,38),(32598300,366577952,39),(32598300,366577953,40),(32598300,366577954,41),(32598300,366577955,42),(32598300,51930027,43),(32598313,51930169,1),(32598313,366577980,2),(32598313,366577981,3),(32598313,366577982,4),(32598313,366577983,5),(32598313,366577984,6),(32598313,366577985,7),(32598313,366577987,8),(32598313,366577988,9),(32598313,366577989,10),(32598313,366577990,11),(32598313,366577991,12),(32598313,366577992,13),(32598313,366577994,14),(32598313,366577996,15),(32598313,366577997,16),(32598313,366577998,17),(32598313,366578000,18),(32598313,366578001,19),(32598313,366578003,20),(32598313,366578004,21),(32598313,366578006,22),(32598313,366578007,23),(32598313,366578014,24),(32598338,366578338,1),(32598338,366578013,2),(32598338,366578014,3),(32598345,366578014,1),(32598345,366578016,2),(32598345,366578018,3),(32598345,366578019,4),(32598345,366578020,5),(32598345,366578021,6),(32598345,366578022,7),(32598345,366578024,8),(32598345,366578025,9),(32598345,366578026,10),(32598345,366578027,11),(32598345,366578029,12),(32598345,366578031,13),(32598345,366578032,14),(32598345,366578033,15),(32598345,366578035,16),(32598345,366578036,17),(32598345,366578037,18),(32598345,366578040,19),(32598345,366578041,20),(32598345,366578042,21),(32598345,366578043,22),(32598345,366578044,23),(32598345,366578045,24),(32598345,366578046,25),(32598345,366578048,26),(32598345,366578049,27),(32598345,366578050,28),(32598345,366578052,29),(32598345,366578053,30),(32598345,366578054,31),(32676714,321682237,1),(32676714,321682236,2),(32676714,321682235,3),(32676714,321682234,4),(32676714,321682233,5),(32676714,321682232,6),(32676714,321682231,7),(32676714,321682230,8),(32676714,321682229,9),(32676714,321682228,10),(32676714,321682227,11),(32676714,321682226,12),(32676714,321682225,13),(32676714,321682224,14),(32676714,321682223,15),(32676714,321682222,16),(32676714,321682221,17),(32676714,321682220,18),(32676714,321682219,19),(32676714,321682218,20),(32676714,321682217,21),(32676714,321682216,22),(32676714,321682215,23),(32676714,321682214,24),(32676714,321682213,25),(32676714,321682212,26),(32676714,321682211,27),(32676714,321682210,28),(32676714,321682209,29),(32676714,321682208,30),(32676714,321682207,31),(32676714,321682206,32),(32676714,321682205,33),(32676714,321682204,34),(32676714,321682203,35),(32676714,321682202,36),(32676714,321682201,37),(32676714,321682200,38),(32676714,321682199,39),(32676714,321682198,40),(32676714,321682197,41),(32676714,321682196,42),(32676714,321682195,43),(32676714,321682194,44),(32676714,321682193,45),(32676714,321682192,46),(32676714,321682191,47),(32676714,321682190,48),(32676714,321682189,49),(32676714,321682188,50),(32676714,321682187,51),(32676714,321682186,52),(32676714,321682185,53),(32676714,321682184,54),(32676714,321682182,55),(32676714,321682180,56),(32676714,321682179,57),(32676714,321682178,58),(32676714,321682174,59),(32676714,321682172,60),(32676714,321682170,61),(32676714,321682169,62),(32676714,321682168,63),(32676714,321682167,64),(32676714,321682166,65),(32676714,321682165,66),(32676714,321682164,67),(32676714,321682163,68),(32676714,321682162,69),(32676714,321682161,70),(32676714,321682160,71),(32676714,321682159,72),(32676714,321682158,73),(32676714,321682157,74),(32676714,321682156,75),(32676714,321682155,76),(32676714,321682154,77),(32676714,321682152,78),(32676714,321682151,79),(32676714,321682150,80),(32676714,321682149,81),(32676714,321682146,82),(32676714,321682143,83),(32676714,321682142,84),(32676714,321682141,85),(32676714,321682140,86),(32676714,321682139,87),(32676714,321682138,88),(32676714,321682137,89),(32676714,321682136,90),(32676714,321682135,91),(32676714,321682134,92),(32676714,321682133,93),(32676714,321682131,94),(32676714,321682130,95),(32676714,321682129,96),(32676714,321682128,97),(32676714,321682127,98),(32676714,321682126,99),(32676714,321682125,100),(32676714,321682124,101),(32676714,321682123,102),(32676739,367676808,1),(32676739,367676825,2),(32676739,367676852,3),(32676739,367676869,4),(32676739,367676884,5),(32676739,367676899,6),(32676739,367676910,7),(32676739,367676924,8),(32676739,367676937,9),(32676739,367676948,10),(32676739,367676960,11),(32676739,367676970,12),(32676739,367676981,13),(32676743,367677101,1),(32676743,367677116,2),(32676743,367677123,3),(32676743,367677127,4),(32676743,367677134,5),(32676743,367677152,6),(32676743,367677173,7),(32676743,367677207,8),(32676743,367677224,9),(32676743,367677245,10),(32676743,367677261,11),(32676743,367677271,12),(32676743,367677289,13),(32676743,367677308,14),(32676743,367677322,15),(32676743,367677341,16),(32676743,367677395,17),(32676743,367677405,18),(32676743,367677418,19),(32676743,367677434,20),(32676743,367677448,21),(32676743,367677464,22),(32676743,367677476,23),(32676743,367677490,24),(32676743,367677502,25),(32676743,367677515,26),(32676743,367677526,27),(32676743,367677538,28),(32676743,367677639,29),(32676743,367677777,30),(32676743,367677784,31),(32676743,367677801,32),(32676746,367676981,1),(32676746,367677010,2),(32676746,367677022,3),(32676746,367677032,4),(32676746,367677043,5),(32676746,367677058,6),(32676746,367677076,7),(32676746,367677090,8),(32676746,367677101,9),(32676749,367677801,1),(32676749,367677832,2),(32676749,367677910,3),(32676749,367677917,4),(32676749,367677926,5),(32676749,367677937,6),(32676749,367677977,7),(32676749,367677996,8),(32676749,367678009,9),(32676749,367678022,10),(32676749,367678041,11),(32676749,367678052,12),(32676749,367678060,13),(32676749,367678071,14),(32676749,367678076,15),(32676749,367678085,16),(32676749,367678093,17),(32676749,367678136,18),(32676749,367678147,19),(32676749,367678187,20),(32676749,367678204,21),(32676749,367678210,22),(32676749,367678218,23),(32676749,367678223,24),(32676749,367678236,25),(32676749,367678270,26),(32676749,367678278,27),(32676749,367678291,28),(32676749,367678297,29),(32676749,367678306,30),(32676749,367678312,31),(32676749,367678321,32),(32676749,367678325,33),(32676749,367678340,34),(32676749,367678352,35),(32676749,367678376,36),(32676749,367678479,37),(32676749,367678487,38),(32676749,367678495,39),(32676749,367678507,40),(32676749,367678516,41),(32676749,367678522,42),(32676749,367678531,43),(32676749,367678537,44),(32676749,367678542,45),(32676749,367678550,46),(32676749,367678557,47),(32676749,367678565,48),(32676749,367678572,49),(32676749,367678591,50),(32676749,367678599,51),(32676749,367678605,52),(32676749,367678629,53),(32676749,367678634,54),(32676749,367678639,55),(32676749,367678644,56),(32676749,367678654,57),(32676749,367678663,58),(32676749,367678669,59),(32676749,367678677,60),(32676749,367678702,61),(32676749,367678712,62),(32676749,367678720,63),(32676749,367678727,64),(32676749,367678735,65),(32676749,367678745,66),(32676749,367678755,67),(32676749,367678769,68),(32676749,367678779,69),(32676749,367678793,70),(32676749,367678802,71),(32676749,367678814,72),(32676749,367678847,73),(32676749,367678865,74),(32676749,367678880,75),(32676749,367678890,76),(32676749,367678906,77),(32676749,367678922,78),(32676749,367678939,79),(32676749,367678954,80),(32676749,367678966,81),(32676749,367678977,82),(32676749,367678987,83),(32676749,367678996,84),(32676749,367679008,85),(32676749,367679021,86),(32676749,367679030,87),(32676749,367679046,88),(32676749,367679058,89),(32676749,367679071,90),(32676749,367679081,91),(32676749,367679089,92),(32676749,367679104,93),(32676749,367679117,94),(32676749,367679128,95),(32676749,367679147,96),(32676749,367679155,97),(32676749,367679176,98),(32676749,367679191,99),(32676749,367679205,100),(32676749,367679214,101),(32676749,367679221,102),(32676749,367679236,103),(32676749,367679246,104),(32676749,367679257,105),(32676749,367679266,106),(32676749,367679278,107),(32676749,367679287,108),(32676749,367679292,109),(32676749,367679302,110),(32676749,367679315,111),(32676749,367679329,112),(32676749,367679336,113),(32676749,367679344,114),(32676749,367679349,115),(32676749,367679356,116),(32676749,367679361,117),(32676749,367679371,118),(32676749,367679385,119),(32676749,367679611,120),(32676749,367679614,121),(32676749,367679617,122),(32676749,367679635,123),(32676749,367679639,124),(32676749,367679650,125),(32676749,367679669,126),(32676749,367679673,127),(32676749,367679679,128),(32676749,367679681,129),(32676749,367679684,130),(32676749,367679690,131),(32676749,367679748,132),(32676749,367679754,133),(32676749,367679763,134),(32676749,367679770,135),(32676749,367679774,136),(32676749,367679778,137),(32676749,367679786,138),(32676749,367679794,139),(32676749,367679801,140),(32676749,367679813,141),(32676749,367679818,142),(32676749,367679826,143),(32676749,367679843,144),(32676749,367679850,145),(32676749,367679856,146),(32676749,367679861,147),(32676749,367679877,148),(32676749,367679892,149),(32676749,367679899,150),(32676749,367679904,151),(32676749,367679910,152),(32676749,367679915,153),(32676749,367679927,154),(32676749,367679934,155),(32676749,367679939,156),(32676749,367679943,157),(32676749,367679962,158),(32676749,367679973,159),(32676749,367679979,160),(32676749,367679988,161),(32676749,367679994,162),(32676749,367680003,163),(32676749,367680016,164),(32676749,367680026,165),(32676749,367680034,166),(32676749,367680039,167),(32676749,367680045,168),(32676749,367680054,169),(32676749,367680063,170),(32676749,367680074,171),(32676749,367680085,172),(32676749,367680092,173),(32676749,367680095,174),(32676749,367680103,175),(32676749,367680112,176),(32676749,367680121,177),(32676749,367680135,178),(32676749,367680145,179),(32676749,367680154,180),(32676749,367680180,181),(32676749,367680191,182),(32676749,367680197,183),(32676749,367680206,184),(32676749,367680220,185),(32676749,367680228,186),(32676749,367680235,187),(32676749,367680239,188),(32676749,367680244,189),(32676749,367680258,190),(32676749,367680266,191),(32676749,367680270,192),(32676749,367680273,193),(32676749,367680291,194),(32676749,367680297,195),(32676749,367683372,196),(32676749,367680427,197),(32676753,367683372,1),(32676753,367680440,2),(32676753,367680443,3),(32676753,367680445,4),(32676753,367680449,5),(32676753,367680460,6),(32676753,367680463,7),(32676753,367680466,8),(32676753,367680470,9),(32676753,367680475,10),(32676753,367680481,11),(32676753,367680486,12),(32676753,367680498,13),(32676753,367680503,14),(32676753,367680513,15),(32676753,367680522,16),(32676753,367680528,17),(32676753,367680536,18),(32676753,367680577,19),(32676753,367680583,20),(32676753,367680601,21),(32676753,367680690,22),(32676753,367680699,23),(32676753,367680708,24),(32676753,367680716,25),(32676753,367680726,26),(32676753,367680747,27),(32676753,367680753,28),(32676753,367680901,29),(32676753,367680914,30),(32676753,367680923,31),(32676753,367680933,32),(32676753,367680940,33),(32676753,367680947,34),(32676753,367680956,35),(32676753,367680960,36),(32676753,367680964,37),(32676753,367680970,38),(32676753,367680975,39),(32676753,367680978,40),(32676753,367680983,41),(32676753,367680990,42),(32676753,367681000,43),(32676753,367681004,44),(32676753,367681008,45),(32676753,367681012,46),(32676753,367681029,47),(32676753,367681033,48),(32676753,367681059,49),(32676753,367681064,50),(32676753,367681082,51),(32676753,367681083,52),(32676753,367681084,53),(32676753,367681087,54),(32676753,367681092,55),(32676753,367681096,56),(32676753,367681118,57),(32676753,367681124,58),(32676753,367681129,59),(32676753,367681130,60),(32676753,367681143,61),(32676753,367681147,62),(32676753,367681150,63),(32676753,367681156,64),(32676753,367681162,65),(32676753,367681174,66),(32676753,367681183,67),(32676753,367681190,68),(32676753,367681198,69),(32676753,367681204,70),(32676753,367681212,71),(32676753,367681216,72),(32676753,367681225,73),(32676753,367681230,74),(32676753,367681236,75),(32676753,367681256,76),(32676753,367681261,77),(32676753,367681429,78),(32676753,367681439,79),(32676753,367681447,80),(32676753,367681453,81),(32676753,367681456,82),(32676753,367681461,83),(32676753,367681465,84),(32676753,367681477,85),(32676753,367681482,86),(32676753,367681490,87),(32676753,367681497,88),(32676753,367681504,89),(32676753,367681514,90),(32676753,367681521,91),(32676753,367681533,92),(32676753,367681539,93),(32676753,367681545,94),(32676753,367681552,95),(32676753,367681555,96),(32676753,367681560,97),(32676753,367681574,98),(32676753,367681579,99),(32676753,367681584,100),(32676753,367681590,101),(32676753,367681596,102),(32676753,367681601,103),(32676753,367681607,104),(32676753,367681613,105),(32676753,367681617,106),(32676753,367681624,107),(32676753,367681630,108),(32676753,367681635,109),(32676753,367681640,110),(32676753,367681644,111),(32676753,367681647,112),(32676753,367681651,113),(32676753,367681655,114),(32676753,367681663,115),(32676753,367681671,116),(32676753,367681676,117),(32676753,367681681,118),(32676753,367681687,119),(32676753,367681691,120),(32676753,367681694,121),(32676753,367681697,122),(32676753,367681701,123),(32676753,367681708,124),(32676753,367681722,125),(32676753,367681730,126),(32676753,367681735,127),(32676753,367681739,128),(32676753,367681745,129),(32676753,367681753,130),(32676753,367681758,131),(32676753,367681766,132),(32676753,367681773,133),(32676753,367681779,134),(32676753,367681894,135),(32676753,367681900,136),(32676753,367681907,137),(32676753,367681915,138),(32676753,367681939,139),(32676753,367681946,140),(32676753,367681956,141),(32676753,367681967,142),(32676753,367681972,143),(32676753,367681980,144),(32676753,367681989,145),(32676753,367681997,146),(32676753,367682006,147),(32676753,367682014,148),(32676753,367682022,149),(32676753,367682032,150),(32676753,367682040,151),(32676753,367682054,152),(32676753,367682060,153),(32676753,367682068,154),(32676753,367682073,155),(32676753,367682101,156),(32676753,367682111,157),(32676753,367682123,158),(32676753,367682130,159),(32676753,367682139,160),(32676753,367682148,161),(32676753,367682156,162),(32676753,367682164,163),(32676753,367682172,164),(32676753,367682183,165),(32676753,367682193,166),(32676753,367682230,167),(32676753,367682241,168),(32676753,367682252,169),(32676753,367682263,170),(32676753,367682269,171),(32676753,367682279,172),(32676753,367682505,173),(32676753,367682512,174),(32676753,367682529,175),(32676753,367682541,176),(32676753,367682547,177),(32676753,367682550,178),(32676753,367682554,179),(32676753,367682560,180),(32676753,367682567,181),(32676753,367682571,182),(32676753,367682574,183),(32676753,367682578,184),(32676753,367682582,185),(32676753,367682587,186),(32676753,367682591,187),(32676753,367682595,188),(32676753,367682600,189),(32676753,367682607,190),(32676753,367682612,191),(32676753,367682618,192),(32676753,367682624,193),(32676753,367682629,194),(32676753,367682636,195),(32676753,367682639,196),(32676753,367682645,197),(32676753,367682650,198),(32676753,367682653,199),(32676753,367682657,200),(32676753,367682670,201),(32676753,367682675,202),(32676753,367682678,203),(32676753,367682684,204),(32676753,367682688,205),(32676753,367682691,206),(32676753,367682694,207),(32676753,367682698,208),(32676753,367682700,209),(32676753,664115894,210),(32676753,367682704,211),(32676753,367682708,212),(32676753,664115899,213),(32676753,367682711,214),(32676753,367682716,215),(32676753,367682724,216),(32676753,367682732,217),(32676753,367682739,218),(32676753,367682743,219),(32676753,367682748,220),(32676753,367682754,221),(32676753,367682760,222),(32676753,367682767,223),(32676753,367682772,224),(32676753,367682777,225),(32676753,367682784,226),(32676755,367682784,1),(32676755,367682789,2),(32676755,367682795,3),(32676755,367682800,4),(32676755,367682806,5),(32676755,367682813,6),(32676755,367682819,7),(32676755,367682825,8),(32676755,367682830,9),(32676755,367682837,10),(32676755,367682842,11),(32676755,367682845,12),(32676755,367682852,13),(32676755,367682859,14),(32676755,367682865,15),(32676755,367682873,16),(32676755,367682879,17),(32676755,367682885,18),(32676755,367682891,19),(32676755,367682900,20),(32676755,367682906,21),(32676755,367682911,22),(32676755,367682916,23),(32676755,367682920,24),(32676755,367682927,25),(32676755,367682932,26),(32676755,367682940,27),(32676755,367682947,28),(32676755,367682953,29),(32676755,367682961,30),(32676755,367682968,31),(32676755,367682978,32),(32676755,367682985,33),(32676755,367682989,34),(32676755,367682996,35),(32676755,367683000,36),(32676755,367683005,37),(32676755,367683011,38),(32676755,367683017,39),(32676755,367683026,40),(32676755,367683034,41),(32676755,367683042,42),(32676755,367683051,43),(32676755,367683060,44),(32676755,367683065,45),(32676755,367683069,46),(32676755,367683074,47),(32676755,367683080,48),(32676755,367683084,49),(32676755,367683091,50),(32676755,367683097,51),(32676755,367683102,52),(32676755,367683107,53),(32676755,367683114,54),(32676755,367683120,55),(32676755,367683128,56),(32676755,367683134,57),(32676755,367683139,58),(32676755,367683144,59),(32676755,367683147,60),(32676755,367683155,61),(32676755,367683161,62),(32676755,367683168,63),(32676755,367683176,64),(32676755,367683182,65),(32676755,367683188,66),(32676755,367683198,67),(32676755,367683208,68),(32676755,367683212,69),(32676755,367683222,70),(32676755,367683232,71),(32676755,367683242,72),(32676755,367683249,73),(32676755,367683260,74),(32676755,367683266,75),(32676755,367683274,76),(32676755,367683286,77),(32676755,367683291,78),(32676755,367683298,79),(32676755,367683303,80),(32676755,367683309,81),(32676755,367683318,82),(32676755,367683330,83),(32676755,367683340,84),(32676755,367683346,85),(32676755,367683352,86),(32676755,367683359,87),(32676755,367683366,88),(32722266,53332079,1),(32722266,53332078,2),(32722266,53332075,3),(32722266,53332072,4),(32722266,53332070,5),(32722266,53332068,6),(32722266,53332065,7),(32722266,53332062,8),(32722266,53332059,9),(32722266,53332056,10),(32722266,53319829,11),(32722266,53319832,12),(32722266,53319833,13),(32722266,53319835,14),(32722447,368207292,1),(32722447,368207293,2),(32722447,368207294,3),(32722447,368207295,4),(32722447,368207296,5),(32722447,368207297,6),(32722447,368207298,7),(32722447,368207299,8),(32722447,368207300,9),(32722447,368207301,10),(32722447,368207302,11),(32722447,368207303,12),(32722447,368207305,13),(32722447,368207306,14),(32722447,52579373,15),(32722447,52579371,16),(32722447,52579369,17),(32722447,52579367,18),(32722447,52579365,19),(32722447,52579363,20),(32722447,52579361,21),(32722447,52579359,22),(32722447,52579357,23),(32722447,52579355,24),(32722447,52579353,25),(32722447,52579350,26),(32722447,52579349,27),(32722447,52579347,28),(32722447,52579345,29),(32722447,52579343,30),(32722447,52579342,31),(32722447,52579340,32),(32722447,52579339,33),(32722447,52579336,34),(32722447,52579335,35),(32722447,52579332,36),(32722447,52579331,37),(32722447,52579328,38),(32722447,52579327,39),(32722447,52579324,40),(32722447,52579323,41),(32722447,52579321,42),(32722447,52579319,43),(32722447,52579317,44),(32722447,52579315,45),(32722447,52579313,46),(32722447,52579312,47),(32722447,52579310,48),(32722447,52579308,49),(32722447,52579306,50),(32722447,52579303,51),(32722447,52579301,52),(32722447,52579299,53),(32722447,52579297,54),(32722447,52579296,55),(32722447,52579293,56),(32722447,52579292,57),(32722447,52579290,58),(32722447,52579287,59),(32722447,52579285,60),(32722447,52579282,61),(32722447,52579281,62),(32722447,52579279,63),(32722447,52579277,64),(32722447,52579275,65),(32722447,52579274,66),(32722447,52579271,67),(32722447,52579270,68),(32722447,52579269,69),(32722447,52579266,70),(32722447,52579265,71),(32722447,52579262,72),(32722447,52579261,73),(32722447,52579258,74),(32722447,52579257,75),(32722447,52579254,76),(32722447,52579252,77),(32722447,52579250,78),(32722447,52579248,79),(32722447,52579246,80),(32722447,52579243,81),(32722447,52579242,82),(32722447,52579240,83),(32722447,52579238,84),(32722447,52579236,85),(32722447,52579235,86),(32722447,52579233,87),(32722447,52579230,88),(32722447,52579229,89),(32722447,52579228,90),(32722447,52579227,91),(32722447,52579226,92),(32722447,52579225,93),(32722447,52579224,94),(32722447,52579222,95),(32722447,52579219,96),(32722447,52579216,97),(32722447,52579213,98),(32722447,52579211,99),(32722447,52579210,100),(32722447,52579208,101),(32722447,52579206,102),(32722447,52579203,103),(32722447,52579201,104),(32722447,52579199,105),(32722447,52579194,106),(32722447,52579190,107),(32722447,52579188,108),(32722447,52579184,109),(32722447,52579183,110),(32722447,52579179,111),(32722447,52579177,112),(32722447,52579173,113),(32722447,52579171,114),(32722447,52579167,115),(32722447,52579165,116),(32722447,52579163,117),(32722447,52579160,118),(32722447,52579159,119),(32722447,52579155,120),(32722447,52579153,121),(32722447,52579151,122),(32722447,52579149,123),(32722447,52579146,124),(32722447,52579145,125),(32722447,52579142,126),(32722447,52579140,127),(32722447,52579138,128),(32722447,52579135,129),(32722447,52579133,130),(32722447,52579131,131),(32722447,52579129,132),(32722447,52579126,133),(32722447,52579125,134),(32722447,52579122,135),(32722447,52579121,136),(32722447,52579118,137),(32722447,52579117,138),(32722447,52579115,139),(32722447,52579113,140),(32722447,52579111,141),(32722447,52579108,142),(32722447,52579107,143),(32722447,52579104,144),(32722447,52579103,145),(32722447,52579100,146),(32722447,52579099,147),(32722447,52579096,148),(32722447,52579092,149),(32722447,52579091,150),(32722447,52579089,151),(32722447,52579087,152),(32722447,52579084,153),(32722447,52579083,154),(32722447,52579081,155),(32722447,52579079,156),(32722447,52579077,157),(32722447,52579075,158),(32722447,52579074,159),(32722447,52579071,160),(32722447,52579069,161),(32722447,52579067,162),(32722447,52578877,163),(32722447,52578875,164),(32722447,52578872,165),(32722447,52578871,166),(32722447,52578867,167),(32722447,52578863,168),(32722447,52578861,169),(32722447,52578858,170),(32722447,52578856,171),(32722447,52578852,172),(32722447,52578848,173),(32722447,52578845,174),(32722447,52578843,175),(32722447,52578841,176),(32722447,52578839,177),(32722447,52578837,178),(32722447,52578835,179),(32722447,52578833,180),(32722447,52578830,181),(32722447,52578829,182),(32722447,52578826,183),(32722447,52578825,184),(32722447,52578822,185),(32722447,52578820,186),(32722447,52578818,187),(32722447,52578817,188),(32722447,52578814,189),(32722447,52578813,190),(32722447,52578810,191),(32722447,52578809,192),(32722447,52578806,193),(32722447,52578793,194),(32722447,52578792,195),(32722447,52578790,196),(32722447,52578788,197),(32722447,52578794,198),(32722447,52578786,199),(32722447,52578797,200),(32722447,52578783,201),(32722447,52578782,202),(32722447,52578780,203),(32722447,52578778,204),(32722447,52578776,205),(32722447,52578775,206),(32722447,52578800,207),(32722447,52578774,208),(32722447,52578773,209),(32722447,52578770,210),(32722447,52578769,211),(32722447,52578767,212),(32722447,52578764,213),(32722447,52578761,214),(32722447,52578760,215),(32722447,52578757,216),(32722447,52578754,217),(32722447,52578753,218),(32722447,52578750,219),(32722447,52578748,220),(32722447,52578746,221),(32722447,52578743,222),(32722447,52578740,223),(32722447,52578738,224),(32722447,52578735,225),(32722447,52578733,226),(32722447,52578730,227),(32722447,52578728,228),(32722447,52578727,229),(32722447,52578725,230),(32722447,52578724,231),(32722447,52578722,232),(32722447,52578720,233),(32722447,52578719,234),(32722447,52578716,235),(32722447,52578715,236),(32722447,52578713,237),(32722447,52578711,238),(32722447,52578708,239),(32722447,52578707,240),(32722447,52578705,241),(32722447,52578703,242),(32722447,52578701,243),(32722447,52578699,244),(32722447,52578697,245),(32722447,52578693,246),(32722447,52578690,247),(32722447,52578689,248),(32722447,52578686,249),(32722447,52578685,250),(32722447,52578682,251),(32722447,52578680,252),(32722447,52578679,253),(32722447,52578678,254),(32722447,52578677,255),(32722447,52578676,256),(32722447,52578675,257),(32722447,52578674,258),(32722447,52578673,259),(32722447,52578672,260),(32722447,52578671,261),(32722447,52578669,262),(32722447,52578668,263),(32722447,52578666,264),(32722447,52578665,265),(32722447,52578663,266),(32722447,52578662,267),(32722447,52578659,268),(32722447,52578657,269),(32722447,52578656,270),(32722447,52578654,271),(32722447,52578653,272),(32722447,52578651,273),(32722447,52578650,274),(32722447,52578648,275),(32722447,52578646,276),(32722447,52578644,277),(32722447,52578642,278),(32722447,52578640,279),(32722447,52578638,280),(32722447,52578581,281),(32722447,52578583,282),(32722447,52578586,283),(32722447,52578587,284),(32722447,52578590,285),(32722447,52578592,286),(32722447,52578594,287),(32722447,52578597,288),(32722447,52578598,289),(32722447,52578600,290),(32722447,52578601,291),(32722447,52578604,292),(32722447,52578605,293),(32722447,52578607,294),(32722447,52578610,295),(32722447,52578612,296),(32722447,52578614,297),(32722447,52578616,298),(32722447,52578617,299),(32722447,52578620,300),(32722447,52578621,301),(32722447,52578624,302),(32722447,52578626,303),(32722447,52578628,304),(32722447,52578630,305),(32722447,52578632,306),(32722447,52578634,307),(32722515,52595125,1),(32722515,349145208,2),(32722515,349145210,3),(32722515,349145211,4),(32722515,349145213,5),(32722515,349145214,6),(32722515,349145215,7),(32722515,349145217,8),(32722515,349145218,9),(32722515,349145220,10),(32722515,349145221,11),(32722515,349145223,12),(32722515,349145224,13),(32722515,349145226,14),(32722515,349145227,15),(32722515,349145229,16),(32722515,349145230,17),(32722515,349145232,18),(32722515,349145233,19),(32722515,349145235,20),(32722515,349145236,21),(32722515,349145237,22),(32722515,349145239,23),(32722515,349145240,24),(32722515,349145242,25),(32722515,349145243,26),(32722515,349145245,27),(32722515,349145246,28),(32722515,349145248,29),(32722515,349145249,30),(32722515,349145250,31),(32722515,349145281,32),(32722515,349145282,33),(32722515,349145283,34),(32722515,349145284,35),(32722515,349145285,36),(32722544,52595880,1),(32722544,52595878,2),(32722544,52595874,3),(32722544,52595872,4),(32722544,52595868,5),(32722544,52595865,6),(32722544,52595861,7),(32722544,52595860,8),(32722544,52595856,9),(32722544,52595854,10),(32722544,52595489,11),(32722544,52595486,12),(32722544,52595483,13),(32722544,52595203,14),(32722544,52595201,15),(32722544,52595198,16),(32722544,52595193,17),(32722544,52595191,18),(32722544,52595188,19),(32722544,52595187,20),(32722544,52595184,21),(32722544,52595181,22),(32722544,52595176,23),(32722544,52595173,24),(32722544,52595169,25),(32722544,52595168,26),(32722544,52595162,27),(32722544,52595161,28),(32722544,52595157,29),(32722544,52595155,30),(32722544,52595154,31),(32722544,52595153,32),(32722544,52595151,33),(32722544,52595148,34),(32722544,52595145,35),(32722544,52595144,36),(32722544,52595140,37),(32722544,52595137,38),(32722544,52595134,39),(32722544,52595131,40),(32722544,52595125,41),(32722657,52262163,1),(32722657,52262161,2),(32722657,52262158,3),(32722657,52262155,4),(32722657,52262152,5),(32722657,52262150,6),(32722657,52262146,7),(32722657,52262143,8),(32722657,52262139,9),(32722657,52262137,10),(32722657,52262136,11),(32722657,52262133,12),(32722657,52262131,13),(32722657,52262119,14),(32722657,52262117,15),(32722657,52262115,16),(32722657,52262114,17),(32722657,52262111,18),(32722657,52262109,19),(32722657,52262106,20),(32722657,52262103,21),(32722657,52262101,22),(32722657,52262097,23),(32722657,52262095,24),(32722657,52262092,25),(32722657,52262089,26),(32722657,52262087,27),(32722657,52262079,28),(32722657,52262081,29),(32722657,52262084,30),(32722657,52262086,31),(32722657,52262064,32),(32722658,52262168,1),(32722658,52262166,2),(32722658,52262163,3),(32722762,52286625,1),(32722762,52286623,2),(32722762,52286619,3),(32722762,52286617,4),(32722762,52286615,5),(32722762,52286613,6),(32722762,52286612,7),(32722762,52286610,8),(32722762,52286608,9),(32722762,52286605,10),(32722762,52286604,11),(32722762,52286599,12),(32722762,52286596,13),(32722762,52286593,14),(32722762,52286590,15),(32722762,52286588,16),(32722762,52286585,17),(32722762,52286582,18),(32722762,52286581,19),(32722762,52286579,20),(32722762,52286577,21),(32722762,52286574,22),(32722762,52286568,23),(32722762,52286566,24),(32722762,52286564,25),(32722762,52286561,26),(32722762,52286560,27),(32722762,52286556,28),(32722762,52286554,29),(32722762,52286552,30),(32722762,52286549,31),(32722762,52286547,32),(32722762,52286545,33),(32722762,52286542,34),(32722762,52286541,35),(32722762,52286538,36),(32722762,52286537,37),(32722762,52286534,38),(32722762,52286531,39),(32722762,52286528,40),(32722762,52286527,41),(32722762,52286524,42),(32722762,52286521,43),(32722762,52286520,44),(32722762,52286505,45),(32722762,52286504,46),(32722762,52286502,47),(32722762,52286500,48),(32722762,52286497,49),(32722762,52286496,50),(32722762,52286493,51),(32722762,52286490,52),(32722762,52286488,53),(32722762,52286485,54),(32722762,52286483,55),(32722762,52286479,56),(32722762,52286476,57),(32722762,52286473,58),(32722762,52286470,59),(32722762,52286468,60),(32722762,52286465,61),(32722762,52286462,62),(32722762,52286458,63),(32722762,52286456,64),(32722762,52286451,65),(32722762,52286448,66),(32722762,52286445,67),(32722762,52286441,68),(32722762,52286440,69),(32722762,52286438,70),(32722762,52286433,71),(32722762,52286430,72),(32722762,52286422,73),(32722762,52286419,74),(32722762,52286415,75),(32722762,52286411,76),(32722762,52286408,77),(32722762,52285017,78),(32722762,52285012,79),(32722762,52285005,80),(32722762,52285000,81),(32722762,52284996,82),(32722762,52284990,83),(32722762,52284986,84),(32722762,52284983,85),(32722762,52284979,86),(32722762,52284974,87),(32722762,52284971,88),(32722762,52284966,89),(32722762,52284960,90),(32722762,52284957,91),(32722762,52284953,92),(32722762,52284949,93),(32722762,52284942,94),(32722762,52284939,95),(32722762,52284936,96),(32722762,52284933,97),(32722762,52284929,98),(32722762,52284922,99),(32722762,52284919,100),(32722762,52284916,101),(32722762,52284910,102),(32722762,52284906,103);
INSERT INTO `current_way_nodes` VALUES (32722762,52284901,104),(32722762,52284894,105),(32722762,52284889,106),(32722762,52284886,107),(32722762,52284881,108),(32722762,52284876,109),(32722762,52284871,110),(32722762,52284867,111),(32722762,52284863,112),(32722762,52284857,113),(32722762,52284852,114),(32722762,52284849,115),(32722762,52284845,116),(32722762,52284842,117),(32722762,52284840,118),(32722762,52284838,119),(32722762,52284836,120),(32722762,52284832,121),(32722762,52284826,122),(32722762,52284823,123),(32722762,52284821,124),(32722762,52284816,125),(32722762,52284813,126),(32722762,52284810,127),(32722762,52284806,128),(32722762,52284802,129),(32722762,52284798,130),(32722762,52284796,131),(32722762,52284790,132),(32722762,52284787,133),(32722762,52284730,134),(32722762,52284528,135),(32722762,52284519,136),(32722762,52284516,137),(32722762,52284514,138),(32722762,52284511,139),(32722762,52284509,140),(32722762,52284506,141),(32722762,52284498,142),(32722762,52284494,143),(32722762,52284492,144),(32722762,52284491,145),(32722762,52284488,146),(32722762,52284484,147),(32722762,52284478,148),(32722762,52284474,149),(32722762,52284467,150),(32722762,52284446,151),(32722762,52284434,152),(32722762,52284408,153),(32722762,52284388,154),(32722762,52284383,155),(32722762,52284375,156),(32722762,52284371,157),(32722762,52284354,158),(32722762,52284351,159),(32722762,52284345,160),(32722762,52284281,161),(32722762,52284228,162),(32722762,52283881,163),(32722762,52283862,164),(32722762,52283856,165),(32722762,52283852,166),(32722762,52283844,167),(32722762,52283841,168),(32722762,52283839,169),(32722762,52283821,170),(32722762,52283304,171),(32722762,52283115,172),(32722762,52283101,173),(32722762,52283094,174),(32722762,52283089,175),(32722762,52268166,176),(32722762,52268163,177),(32722762,52268160,178),(32722762,52268156,179),(32722762,52268151,180),(32722762,52268147,181),(32722762,52268141,182),(32722762,52268137,183),(32722762,52268133,184),(32722762,52268128,185),(32722762,52268120,186),(32722762,52268118,187),(32722762,52268116,188),(32722762,52268039,189),(32722762,52268014,190),(32722762,52268011,191),(32722762,52268007,192),(32722762,52267852,193),(32722762,52267772,194),(32722762,52267141,195),(32722762,52266974,196),(32722762,52266970,197),(32722762,52266951,198),(32722762,52266950,199),(32722762,52266938,200),(32722762,52266924,201),(32722762,52266920,202),(32722762,52266907,203),(32722762,52266758,204),(32722762,52266755,205),(32722762,52266753,206),(32722762,52266751,207),(32722762,52266744,208),(32722762,52266660,209),(32722762,52266649,210),(32722762,52266636,211),(32722762,52266609,212),(32722762,52265659,213),(32722762,52265126,214),(32722762,52265123,215),(32722762,52265098,216),(32722762,52265093,217),(32722762,52265091,218),(32722762,52265090,219),(32722762,52265087,220),(32722762,52265086,221),(32722762,52265083,222),(32722762,52265080,223),(32722762,52265070,224),(32722762,52265067,225),(32722762,52265066,226),(32722762,52265063,227),(32722762,52265062,228),(32722762,52265060,229),(32722762,52265058,230),(32722762,52265056,231),(32722762,52265054,232),(32722762,52265051,233),(32722762,52265050,234),(32722762,52265047,235),(32722762,52265046,236),(32722762,52265045,237),(32722762,52265042,238),(32722762,52265039,239),(32722762,52265038,240),(32722762,52265037,241),(32722762,52265035,242),(32722762,52265034,243),(32722762,52265032,244),(32722762,52265031,245),(32722762,52265029,246),(32722762,52265028,247),(32722762,52265026,248),(32722762,52265025,249),(32722762,52265024,250),(32722762,52265022,251),(32722762,52265020,252),(32722762,52265016,253),(32722762,52264090,254),(32722762,52264070,255),(32722762,52264068,256),(32722762,52264067,257),(32722762,52264051,258),(32722762,52264041,259),(32722762,52264034,260),(32722762,52264022,261),(32722762,52264020,262),(32722762,52264018,263),(32722762,52264015,264),(32722762,52264013,265),(32722762,52264009,266),(32722762,52264006,267),(32722762,52264003,268),(32722762,52263999,269),(32722762,52263997,270),(32722762,52263996,271),(32722762,52263994,272),(32722762,52263993,273),(32722762,52263992,274),(32722762,52263990,275),(32722762,52263989,276),(32722762,52263987,277),(32722762,52263986,278),(32722762,52263985,279),(32722762,52263984,280),(32722762,52263982,281),(32722762,52263981,282),(32722762,52263979,283),(32722762,52263978,284),(32722762,52263977,285),(32722762,52263975,286),(32722762,52263973,287),(32722762,52263972,288),(32722762,52263969,289),(32722762,52263968,290),(32722762,52263965,291),(32722762,52263964,292),(32722762,52263962,293),(32722762,52263961,294),(32722762,52263959,295),(32722762,52263957,296),(32722762,52263955,297),(32722762,52263954,298),(32722762,52263952,299),(32722762,52263951,300),(32722762,52263950,301),(32722762,52263948,302),(32722762,52263947,303),(32722762,52263945,304),(32722762,52263944,305),(32722762,52263941,306),(32722762,52263938,307),(32722762,52263937,308),(32722762,52263935,309),(32722762,52263932,310),(32722762,52263929,311),(32722762,52263926,312),(32722762,52263924,313),(32722762,52263921,314),(32722762,52263919,315),(32722762,52263917,316),(32722762,52263914,317),(32722762,52263913,318),(32722762,52263910,319),(32722762,52263908,320),(32722762,52263906,321),(32722762,52263903,322),(32722762,52263901,323),(32722762,52263898,324),(32722762,52263896,325),(32722762,52263893,326),(32722762,52263891,327),(32722762,52263888,328),(32722762,52263887,329),(32722762,52263883,330),(32722762,52263882,331),(32722762,52263852,332),(32722762,52263850,333),(32722762,52263849,334),(32722762,52263846,335),(32722762,52263843,336),(32722762,52263839,337),(32722762,52263837,338),(32722762,52263835,339),(32722762,52263868,340),(32722762,52263832,341),(32722762,52263829,342),(32722762,52263827,343),(32722762,52263825,344),(32722762,52263823,345),(32722762,52263820,346),(32722762,52263818,347),(32722762,52263817,348),(32722762,52263815,349),(32722762,52263813,350),(32722762,52263811,351),(32722762,52263808,352),(32722762,52263806,353),(32722762,52263803,354),(32722762,52263802,355),(32722762,52263800,356),(32722762,52263798,357),(32722762,52263797,358),(32722762,52263796,359),(32722762,52263795,360),(32722762,52263794,361),(32722762,52263793,362),(32722762,52263792,363),(32722762,52263790,364),(32722762,52263788,365),(32722762,52263787,366),(32722762,52263785,367),(32722762,52263784,368),(32722762,52263782,369),(32722762,52263781,370),(32722762,52263779,371),(32722762,52263777,372),(32722762,52263775,373),(32722762,52263774,374),(32722762,52263772,375),(32722762,52263771,376),(32722762,52263769,377),(32722762,52263767,378),(32722762,52263766,379),(32722762,52263765,380),(32722762,52263763,381),(32722762,52263762,382),(32722762,52263760,383),(32722762,52263757,384),(32722762,52263755,385),(32722762,52263754,386),(32722762,52263750,387),(32722762,52263749,388),(32722762,52263747,389),(32722762,52263746,390),(32722762,52263744,391),(32722762,52263743,392),(32722762,52263742,393),(32722762,52263739,394),(32722762,52263738,395),(32722762,52263736,396),(32722762,52263734,397),(32722762,52263732,398),(32722762,52263731,399),(32722762,52263730,400),(32722762,52263543,401),(32722762,52263541,402),(32722762,52263537,403),(32722762,52263533,404),(32722762,52263530,405),(32722762,52263527,406),(32722762,52263524,407),(32722762,52263520,408),(32722762,52263519,409),(32722762,52263621,410),(32722762,52263516,411),(32722762,52263513,412),(32722762,52263512,413),(32722762,52263509,414),(32722762,52263507,415),(32722762,52263506,416),(32722762,52263504,417),(32722762,52263502,418),(32722762,52263498,419),(32722762,52263416,420),(32722762,52263414,421),(32722762,52263411,422),(32722762,52263546,423),(32722762,52263234,424),(32722762,52263233,425),(32722762,371357928,426),(32722762,52263231,427),(32722762,52263227,428),(32722762,52263224,429),(32722762,52263220,430),(32722762,52263217,431),(32722762,52263213,432),(32722762,52263209,433),(32722762,52263208,434),(32722762,52263203,435),(32722762,52263200,436),(32722762,52263158,437),(32722762,52263155,438),(32722762,52263152,439),(32722762,52263149,440),(32722762,52263144,441),(32722762,52263142,442),(32722762,52263140,443),(32722762,52263136,444),(32722762,52263133,445),(32722762,52263195,446),(32722762,52263130,447),(32722762,52263126,448),(32722762,52263124,449),(32722762,52263122,450),(32722762,52262908,451),(32722762,52262905,452),(32722762,52262903,453),(32722762,52262901,454),(32722762,52262898,455),(32722762,52263086,456),(32722762,52262896,457),(32722762,52263090,458),(32722762,52262967,459),(32722762,52262893,460),(32722762,52262892,461),(32722762,52262889,462),(32722762,52262887,463),(32722762,52262884,464),(32722762,52262883,465),(32722762,52262878,466),(32722762,52262874,467),(32722762,52262869,468),(32722762,52262866,469),(32722762,52262862,470),(32722762,52262858,471),(32722762,52262854,472),(32722762,52262850,473),(32722762,52262848,474),(32722762,52262845,475),(32722762,52262842,476),(32722762,52262838,477),(32722762,52262836,478),(32722762,52262833,479),(32722762,52262830,480),(32722762,52262826,481),(32722762,52262824,482),(32722762,52262821,483),(32722762,52262938,484),(32722762,52262817,485),(32722762,52262814,486),(32722762,52262809,487),(32722762,52262805,488),(32722762,52262802,489),(32722762,52262798,490),(32722762,52262796,491),(32722762,52262792,492),(32722762,52262788,493),(32722762,52262784,494),(32722762,52262781,495),(32722762,52262776,496),(32722762,52262773,497),(32722762,52262768,498),(32722762,52262764,499),(32722762,52262760,500),(32722762,52262757,501),(32722762,52262752,502),(32722762,52262748,503),(32722762,52262746,504),(32722762,52262742,505),(32722762,52262738,506),(32722762,52262736,507),(32722762,52262732,508),(32722762,52262729,509),(32722762,52262727,510),(32722762,52262725,511),(32722762,52262723,512),(32722762,52262718,513),(32722762,52262713,514),(32722762,52262710,515),(32722762,52262706,516),(32722762,52262703,517),(32722762,52262700,518),(32722762,52262698,519),(32722762,52262695,520),(32722762,52262691,521),(32722762,52262688,522),(32722762,52262684,523),(32722762,52262678,524),(32722762,52262675,525),(32722762,52262671,526),(32722762,52262666,527),(32722762,52262664,528),(32722762,52262661,529),(32722762,52262659,530),(32722762,52262654,531),(32722762,52262650,532),(32722762,52262646,533),(32722762,52262644,534),(32722762,52262641,535),(32722762,52262637,536),(32722762,52262636,537),(32722762,52262632,538),(32722762,52262629,539),(32722762,52262625,540),(32722762,52262622,541),(32722762,52262618,542),(32722762,52262616,543),(32722762,52262612,544),(32722762,52262609,545),(32722762,52262607,546),(32722762,52262605,547),(32722762,52262602,548),(32722762,52262598,549),(32722762,52262594,550),(32722762,52262590,551),(32722762,52262586,552),(32722762,52262583,553),(32722762,52262579,554),(32722762,52262575,555),(32722762,52262573,556),(32722762,52262570,557),(32722762,52262535,558),(32722762,52262566,559),(32722762,52262531,560),(32722762,52262527,561),(32722762,52262523,562),(32722762,52262521,563),(32722762,52262515,564),(32722762,52262512,565),(32722762,52262509,566),(32722762,52262504,567),(32722762,52262500,568),(32722762,52262498,569),(32722762,52262495,570),(32722762,52262492,571),(32722762,52262488,572),(32722762,52262328,573),(32722762,52262325,574),(32722762,52262321,575),(32722762,52262317,576),(32722762,52262485,577),(32722762,52262316,578),(32722762,52262313,579),(32722762,52262310,580),(32722762,52262306,581),(32722762,52262303,582),(32722762,52262300,583),(32722762,52262297,584),(32722762,52262293,585),(32722762,52262290,586),(32722762,52262287,587),(32722762,52262283,588),(32722762,52262279,589),(32722762,52262275,590),(32722762,52262271,591),(32722762,52262265,592),(32722762,52262263,593),(32722762,52262259,594),(32722762,52262257,595),(32722762,52262252,596),(32722762,52262251,597),(32722762,52262247,598),(32722762,52262245,599),(32722762,52262244,600),(32722762,52262240,601),(32722762,52262239,602),(32722762,52262236,603),(32722762,52262233,604),(32722762,52262231,605),(32722762,52262229,606),(32722762,52262225,607),(32722762,52262221,608),(32722762,52262217,609),(32722762,52262215,610),(32722762,52262213,611),(32722762,52262210,612),(32722762,52262207,613),(32722762,52262204,614),(32722762,52262201,615),(32722762,52262198,616),(32722762,52262193,617),(32722762,52262191,618),(32722762,52262187,619),(32722762,52262183,620),(32722762,52262179,621),(32722762,52262176,622),(32722762,52262168,623),(32722815,52268166,1),(32722815,368212962,2),(32722815,368212966,3),(32722815,368212967,4),(32722815,52286643,5),(32722815,52286640,6),(32722815,52286636,7),(32722815,52286651,8),(32722815,52286652,9),(32722815,52286655,10),(32722815,52286658,11),(32722815,52286661,12),(32722815,52286663,13),(32722815,52286665,14),(32722815,52286667,15),(32722815,52286668,16),(32722815,52286671,17),(32722815,52286674,18),(32722815,52286677,19),(32722815,52286679,20),(32722815,52286681,21),(32722815,52286683,22),(32722815,52286685,23),(32722815,52286688,24),(32722815,52286691,25),(32722815,52286694,26),(32722815,52286697,27),(32722815,52286698,28),(32722815,52286701,29),(32722815,52286702,30),(32722815,52286705,31),(32722815,52286706,32),(32722815,52286709,33),(32722815,52286712,34),(32722815,52286715,35),(32722815,52286719,36),(32722815,52286721,37),(32722815,52286723,38),(32722815,52286725,39),(32722815,52286728,40),(32722815,52286730,41),(32722815,52286733,42),(32722815,52286735,43),(32722815,52286740,44),(32722815,52286743,45),(32722815,52286746,46),(32722815,52286750,47),(32722815,52286751,48),(32722815,52286754,49),(32722815,52286757,50),(32722815,52286759,51),(32722815,52286763,52),(32722815,52286765,53),(32722815,52286769,54),(32722815,52286770,55),(32722815,52286772,56),(32722815,52286774,57),(32722815,52286776,58),(32722815,52286777,59),(32722815,52286779,60),(32722815,52286781,61),(32722815,52286783,62),(32722815,52286785,63),(32722815,52286787,64),(32722815,52286789,65),(32722815,52286792,66),(32722815,52286793,67),(32722815,52286795,68),(32722815,52286798,69),(32722815,52286802,70),(32722815,52286807,71),(32722815,52286809,72),(32722815,52286812,73),(32722815,52286814,74),(32722815,52286817,75),(32722815,52286820,76),(32722815,52286823,77),(32722815,52286825,78),(32722815,52286826,79),(32722815,52286829,80),(32722815,52286831,81),(32722815,52286835,82),(32722815,52286836,83),(32722815,52286838,84),(32722815,52286841,85),(32722815,52286845,86),(32722815,52286847,87),(32722815,52286850,88),(32722815,52286853,89),(32722815,52286855,90),(32722815,52286856,91),(32722815,52286860,92),(32722815,52286861,93),(32722815,52286865,94),(32722815,52286867,95),(32722815,52286868,96),(32722815,52286871,97),(32722815,52286874,98),(32722815,52286876,99),(32722815,52286880,100),(32722815,52286883,101),(32722815,52286885,102),(32722815,52286889,103),(32722815,52286892,104),(32722815,52286895,105),(32722815,52286896,106),(32722815,52286899,107),(32722815,52286902,108),(32722815,52286904,109),(32722815,52286906,110),(32722815,52286908,111),(32722815,52286910,112),(32722815,52286912,113),(32722815,52286914,114),(32722815,52286917,115),(32722815,52286920,116),(32722815,52286923,117),(32722815,52286924,118),(32722815,52286926,119),(32722815,52286929,120),(32722815,52286932,121),(32722815,52286935,122),(32722815,52286936,123),(32722815,52286938,124),(32722815,52286941,125),(32722815,52286944,126),(32722815,52286975,127),(32722815,52286977,128),(32722815,52286979,129),(32722815,52286981,130),(32722815,52286982,131),(32722815,52286983,132),(32722815,52286986,133),(32722815,52286987,134),(32722815,52286990,135),(32722815,52286991,136),(32722815,52286994,137),(32722815,52286997,138),(32722815,52287000,139),(32722815,52287003,140),(32722815,52287005,141),(32722815,52287008,142),(32722815,52287010,143),(32722815,52287013,144),(32722815,52287015,145),(32722815,52287018,146),(32722815,52287019,147),(32722815,52287022,148),(32722815,52287024,149),(32722815,52287027,150),(32722815,52287029,151),(32722815,52287030,152),(32722815,52287033,153),(32722815,52287034,154),(32722815,52287037,155),(32722815,52287040,156),(32722815,52287043,157),(32722815,52287045,158),(32722815,52287048,159),(32722815,52287051,160),(32722815,52287053,161),(32722815,52287056,162),(32722815,52287066,163),(32722815,52287068,164),(32722815,52287071,165),(32722815,52287074,166),(32722815,52287076,167),(32722815,52287078,168),(32722815,52287082,169),(32722815,52287084,170),(32722815,52287085,171),(32722815,52287089,172),(32722815,52287092,173),(32722815,52287095,174),(32722815,52287098,175),(32722815,52287101,176),(32722815,52287103,177),(32722815,52287106,178),(32722815,52287110,179),(32722815,52287111,180),(32722815,52287114,181),(32722815,52287116,182),(32722815,52287117,183),(32722815,52287119,184),(32722815,52287120,185),(32722815,52287123,186),(32722815,52287127,187),(32722815,52287129,188),(32722815,52287132,189),(32722815,52287135,190),(32722815,52287138,191),(32722815,52287140,192),(32722815,52287142,193),(32722815,52287144,194),(32722815,52287147,195),(32722815,52287150,196),(32722815,52287153,197),(32722815,52287156,198),(32722815,52287159,199),(32722815,52287160,200),(32722815,52287163,201),(32722815,52287165,202),(32722815,52287167,203),(32722815,52287170,204),(32722815,52287173,205),(32722815,52287174,206),(32722815,52287177,207),(32722815,52287181,208),(32722815,52287183,209),(32722815,52287186,210),(32722815,52287188,211),(32722815,52287191,212),(32722815,52287192,213),(32722815,52287193,214),(32722815,52287194,215),(32722815,52287196,216),(32722815,52287198,217),(32722815,52287200,218),(32722815,52287202,219),(32722815,52287205,220),(32722815,52287208,221),(32722815,52287210,222),(32722815,52287212,223),(32722815,52287216,224),(32722815,52287217,225),(32722815,52287220,226),(32722815,52287223,227),(32722815,52287225,228),(32722815,52287228,229),(32722815,52287231,230),(32722815,52287234,231),(32722815,52287238,232),(32722815,52287239,233),(32722815,52287243,234),(32722815,52287244,235),(32722815,52287247,236),(32722815,52287251,237),(32722815,52287254,238),(32722815,52287255,239),(32722815,52287257,240),(32722815,52287260,241),(32722815,52287262,242),(32722815,52287265,243),(32722815,52287268,244),(32722815,52287271,245),(32722815,52287274,246),(32722815,52287276,247),(32722815,52287278,248),(32722815,52287283,249),(32722815,52287286,250),(32722815,52287289,251),(32722815,52287292,252),(32722815,52287295,253),(32722815,52287299,254),(32722815,52287301,255),(32722815,52287305,256),(32722815,52287308,257),(32722815,52287311,258),(32722815,52287315,259),(32722815,52287317,260),(32722815,52287320,261),(32722815,52287323,262),(32722815,52287326,263),(32722815,52287329,264),(32722815,52287331,265),(32722815,52287335,266),(32722815,52287354,267),(32722815,52287357,268),(32722815,52287360,269),(32722815,52287362,270),(32722815,52287364,271),(32722815,52287369,272),(32722815,52287371,273),(32722815,52287373,274),(32722815,52287378,275),(32722815,52287380,276),(32722815,52287384,277),(32722815,52287387,278),(32722815,52287392,279),(32722815,52287393,280),(32722815,52287395,281),(32722815,52287399,282),(32722815,52287400,283),(32722815,52287403,284),(32722815,52287408,285),(32722815,52287411,286),(32722815,52287414,287),(32722815,52287417,288),(32722815,52287422,289),(32722815,52287426,290),(32722815,52287428,291),(32722815,52287430,292),(32722815,52287433,293),(32722815,52287436,294),(32722815,52287441,295),(32722815,52287443,296),(32722815,52287444,297),(32722815,52287447,298),(32722815,52287449,299),(32722815,52287453,300),(32722815,52287457,301),(32722815,52287459,302),(32722815,52287462,303),(32722815,52287464,304),(32722815,52287467,305),(32722815,52287470,306),(32722815,52287473,307),(32722815,52287477,308),(32722815,52287480,309),(32722815,52287483,310),(32722815,52287486,311),(32722815,52287489,312),(32722815,52287492,313),(32722815,52287495,314),(32722815,52287499,315),(32722815,52287501,316),(32722815,52287504,317),(32722815,52287506,318),(32722815,52287509,319),(32722815,52287511,320),(32722815,52287512,321),(32722815,52287515,322),(32722815,52287517,323),(32722815,52287519,324),(32722815,52287522,325),(32722815,52287524,326),(32722815,52287527,327),(32722815,52287528,328),(32722815,52287532,329),(32722815,52287534,330),(32722815,52287536,331),(32722815,52287538,332),(32722815,52287542,333),(32722815,52287544,334),(32722815,52287548,335),(32722815,52287551,336),(32722815,52287552,337),(32722815,52287555,338),(32722815,52287560,339),(32722815,52287562,340),(32722815,52287565,341),(32722815,52287568,342),(32722815,52287570,343),(32722815,52287572,344),(32722815,52287575,345),(32722815,52287578,346),(32722815,52287580,347),(32722815,52287583,348),(32722815,52287584,349),(32722815,52287588,350),(32722815,52287591,351),(32722815,52287592,352),(32722815,52287594,353),(32722815,52287600,354),(32722815,52287603,355),(32722815,52287605,356),(32722815,52287608,357),(32722815,52287622,358),(32722815,52287609,359),(32722815,52287612,360),(32722815,52287616,361),(32722815,52287619,362),(32722815,52287624,363),(32722815,52287627,364),(32722815,52287629,365),(32722815,52287631,366),(32722815,52287633,367),(32722815,52287634,368),(32722815,52287636,369),(32722815,52287638,370),(32722815,52287640,371),(32722815,52287642,372),(32722815,52287643,373),(32722815,52287644,374),(32722815,52287645,375),(32722815,52287648,376),(32722815,52287649,377),(32722815,52287651,378),(32722815,52287653,379),(32722815,52287654,380),(32722815,52288116,381),(32722815,52288118,382),(32722815,52288119,383),(32722815,52288121,384),(32722815,52288122,385),(32722815,52288125,386),(32722815,52288128,387),(32722815,52288131,388),(32722815,52288133,389),(32722815,52288136,390),(32722815,52288137,391),(32722815,52288139,392),(32722815,52288141,393),(32722815,52288142,394),(32722815,52288145,395),(32722815,52288146,396),(32722815,52288150,397),(32722815,52288153,398),(32722815,52288155,399),(32722815,52288157,400),(32722815,52288161,401),(32722815,52288163,402),(32722815,52288165,403),(32722815,52288167,404),(32722815,52288170,405),(32722815,52288173,406),(32722815,52288175,407),(32722815,52288178,408),(32722815,52288179,409),(32722815,52288181,410),(32722815,52288183,411),(32722815,52288184,412),(32722815,52288185,413),(32722815,52288188,414),(32722815,52288190,415),(32722815,52288194,416),(32722815,52288196,417),(32722815,52288199,418),(32722815,52288203,419),(32722815,52288204,420),(32722815,52288207,421),(32722815,52288210,422),(32722815,52288211,423),(32722815,52288215,424),(32722815,52288216,425),(32722815,52288218,426),(32722815,52288221,427),(32722815,52288223,428),(32722815,52288225,429),(32722815,52288227,430),(32722815,52288231,431),(32722815,52288233,432),(32722815,52288235,433),(32722815,52288238,434),(32722815,52288241,435),(32722815,52288244,436),(32722815,52288248,437),(32722815,52288251,438),(32722815,52288253,439),(32722815,52288256,440),(32722815,52288258,441),(32722815,52288261,442),(32722815,52288265,443),(32722815,52288269,444),(32722815,52288266,445),(32722815,52288273,446),(32722815,52288275,447),(32722815,52288277,448),(32722815,52288281,449),(32722815,52288284,450),(32722815,52288285,451),(32722815,52288287,452),(32722815,52288289,453),(32722815,52288291,454),(32722815,52288293,455),(32722815,52288297,456),(32722815,52288298,457),(32722815,52288301,458),(32722815,52288304,459),(32722815,52288307,460),(32722815,52288310,461),(32722815,52288313,462),(32722815,52288317,463),(32722815,52288319,464),(32722815,52288321,465),(32722815,52288325,466),(32722815,52288327,467),(32722815,52288330,468),(32722815,52288331,469),(32722815,52288335,470),(32722815,52288337,471),(32722815,52288339,472),(32722815,52288341,473),(32722815,52288343,474),(32722815,52288345,475),(32722815,52288348,476),(32722815,52288350,477),(32722815,52288353,478),(32722815,52288357,479),(32722815,52288360,480),(32722815,52288361,481),(32722815,52288365,482),(32722815,52288368,483),(32722815,52288371,484),(32722815,52288375,485),(32722815,52288377,486),(32722815,52288381,487),(32722815,52288383,488),(32722815,52288387,489),(32722815,52297301,490),(32722815,52288388,491),(32722815,52288390,492),(32722815,52288393,493),(32722815,52288395,494),(32722815,52288398,495),(32722815,52288400,496),(32722815,52288403,497),(32722815,52288406,498),(32722815,52288407,499),(32722815,52288412,500),(32722815,52288413,501),(32722815,52288415,502),(32722815,52288417,503),(32722815,52288419,504),(32722815,52288423,505),(32722815,52288426,506),(32722815,52288429,507),(32722815,52288434,508),(32722815,52288435,509),(32722815,52288439,510),(32722815,52288442,511),(32722815,52288444,512),(32722815,52288448,513),(32722815,52288450,514),(32722815,52288453,515),(32722815,52288455,516),(32722815,52288458,517),(32722815,52297397,518),(32722815,52288460,519),(32722815,52288461,520),(32722815,52288465,521),(32722815,52288466,522),(32722815,52288469,523),(32722815,52288471,524),(32722815,52288474,525),(32722815,52288478,526),(32722815,52288494,527),(32722815,52288479,528),(32722815,52288482,529),(32722815,52288484,530),(32722815,52288487,531),(32722815,52288489,532),(32722815,52288491,533),(32722815,52288497,534),(32722815,52288498,535),(32722815,52297501,536),(32722815,52288501,537),(32722815,52288503,538),(32722815,52288504,539),(32722815,52288507,540),(32722815,52288509,541),(32722815,52288511,542),(32722815,52288514,543),(32722815,52288515,544),(32722815,52288518,545),(32722815,52288521,546),(32722815,52288524,547),(32722815,52288527,548),(32722815,52288529,549),(32722815,52288533,550),(32722815,52288535,551),(32722815,52288537,552),(32722815,52288541,553),(32722815,52288542,554),(32722815,52288545,555),(32722815,52288549,556),(32722815,52288552,557),(32722815,52288555,558),(32722815,52288558,559),(32722815,52288561,560),(32722815,52288565,561),(32722815,52288567,562),(32722815,52288570,563),(32722815,52288573,564),(32722815,52288575,565),(32722815,52288577,566),(32722815,52288578,567),(32722815,52288581,568),(32722815,52288583,569),(32722815,52288586,570),(32722815,52288588,571),(32722815,52288591,572),(32722815,52288594,573),(32722815,52297650,574),(32722815,52288597,575),(32722815,52288599,576),(32722815,52288601,577),(32722815,52288603,578),(32722815,52288606,579),(32722815,52288607,580),(32722815,52288610,581),(32722815,52288612,582),(32722815,52288614,583),(32722815,52288615,584),(32722815,52288619,585),(32722815,52288621,586),(32722815,52288624,587),(32722815,52288625,588),(32722815,52288627,589),(32722815,52288630,590),(32722815,52288632,591),(32722815,52288633,592),(32722815,52288636,593),(32722815,52288637,594),(32722815,52288639,595),(32722815,52288642,596),(32722815,52288644,597),(32722815,52288647,598),(32722815,52288650,599),(32722815,52288651,600),(32722815,52288653,601),(32722815,52288655,602),(32722815,52288658,603),(32722815,52288659,604),(32722815,52288665,605),(32722815,52288669,606),(32722815,52288672,607),(32722815,52288675,608),(32722815,52288684,609),(32722815,52288687,610),(32722815,52288689,611),(32722815,52288691,612),(32722815,52288695,613),(32722815,52288696,614),(32722815,52288697,615),(32722815,52288702,616),(32722815,52262076,617),(32819051,53319835,1),(32819051,53319838,2),(32819051,53319828,3),(32819051,53319839,4),(32819051,53325641,5),(32819051,53325645,6),(32819051,53325649,7),(32819051,53325657,8),(32819051,53325659,9),(32819051,53325663,10),(32819142,321682002,1),(32819142,321682000,2),(32819142,321681999,3),(32819142,321681998,4),(32819142,321681997,5),(32819142,321681996,6),(32819142,321681995,7),(32819142,321681994,8),(32819142,321681993,9),(32819142,321681992,10),(32819142,321681991,11),(32819142,321681990,12),(32819142,321681989,13),(32819142,321681988,14),(32819142,321681987,15),(32819142,321681986,16),(32819142,321681982,17),(32819142,321681981,18),(32819142,321681980,19),(32819142,321681979,20),(32819142,321681978,21),(32819142,321681977,22),(32819142,321681976,23),(32819142,321681975,24),(32819142,321681974,25),(32819142,321681972,26),(32819142,321681971,27),(32819142,321681970,28),(32819142,321681969,29),(32819142,321681968,30),(32819142,321681967,31),(32819142,321681966,32),(32819142,321681965,33),(32819142,321681964,34),(32819142,321681963,35),(32819142,321681962,36),(32819142,321681961,37),(32819142,321681958,38),(32819142,321681957,39),(32819142,321681953,40),(32819142,321681951,41),(32819142,321681950,42),(32819142,321681949,43),(32819142,321681947,44),(32819142,321681946,45),(32819142,321681945,46),(32819142,321681944,47),(32819142,321681943,48),(32819142,321681942,49),(32819142,53332123,50),(32819142,53332120,51),(32819142,53332117,52),(32819142,321682640,53),(32819142,53332113,54),(32819142,53332111,55),(32819142,53332109,56),(32819142,53332107,57),(32819142,53332105,58),(32819142,53332102,59),(32819142,53332100,60),(32819142,53332097,61),(32819142,53332094,62),(32819142,53332091,63),(32819142,53332089,64),(32819142,53332086,65),(32819142,53332083,66),(32819142,53332081,67),(32819142,53332079,68),(32845037,53295259,1),(32845037,53295264,2),(32845037,53306761,3),(32845037,53306758,4),(32845037,53306755,5),(32845037,53306752,6),(32845037,366577821,7),(32845037,370909276,8),(32845037,53306749,9),(32845037,53306746,10),(32845037,53306743,11),(32845037,53306742,12),(32845037,53306740,13),(32845037,53306738,14),(32845037,53306737,15),(32845037,53306734,16),(32845037,53306733,17),(32845037,53306730,18),(32845037,53306727,19),(32845037,53306726,20),(32845037,53306724,21),(32845037,53306723,22),(32845037,53306720,23),(32845037,53306717,24),(32845037,53306715,25),(32845037,53306713,26),(32845037,53306712,27),(32845037,53306710,28),(32845037,53306708,29),(32845037,53306706,30),(32845037,53306704,31),(32845037,53306702,32),(32845037,53306699,33),(32845037,53306527,34),(32845037,53306532,35),(32845037,53306534,36),(32845037,53306537,37),(32845037,53306540,38),(32845037,53306542,39),(32845037,53306543,40),(32845037,53306545,41),(32845037,53306547,42),(32845037,53306550,43),(32845037,53306552,44),(32845037,53306554,45),(32845037,53306556,46),(32845037,53306559,47),(32845037,53306562,48),(32845037,53306564,49),(32845037,53306565,50),(32845037,53306566,51),(32845037,53306568,52),(32845037,53306603,53),(32845037,53306606,54),(32845037,53306607,55),(32845037,53306609,56),(32845037,53306611,57),(32845037,53306613,58),(32845037,53306617,59),(32845037,53306620,60),(32845037,53306623,61),(32845037,53306626,62),(32845037,53306628,63),(32845037,53306631,64),(32845037,53306633,65),(32845037,53306635,66),(32845037,53306638,67),(32845037,53306641,68),(32845037,53306644,69),(32845037,53306647,70),(32845037,53306650,71),(32845037,53306652,72),(32845037,53306654,73),(32845037,53306657,74),(32845037,53306660,75),(32845037,53306662,76),(32845037,53306697,77),(32845037,53306665,78),(32845037,53306668,79),(32845037,370003845,80),(32845056,370003845,1),(32845056,370003846,2),(32845056,370003848,3),(32845056,370003849,4),(32845056,370003853,5),(32845063,370003853,1),(32845063,370003141,2),(32845063,53306689,3),(32845063,53306691,4),(32845063,53306693,5),(32845063,287397098,6),(32845063,287397484,7),(32845063,287396438,8),(32845063,287397486,9),(32845063,287397023,10),(32936885,53295356,1),(32936885,370903026,2),(32936885,370903027,3),(32936885,370903028,4),(32936885,370903029,5),(32936885,370903030,6),(32936960,53295310,1),(32936960,370903788,2),(32936960,370903791,3),(32936960,370903794,4),(32936960,370903796,5),(32937000,53295291,1),(32937000,370904334,2),(32937000,370904336,3),(32937000,370904339,4),(32937000,370904341,5),(32937225,370906892,1),(32937225,370908030,2),(32937225,370908032,3),(32937225,366577818,4),(32937225,370908035,5),(32937225,366577819,6),(32937225,366577820,7),(32937225,370909129,8),(32937225,370909130,9),(32937225,366577821,10),(32937397,370909282,1),(32937397,370909283,2),(32937397,370909284,3),(32937397,370909285,4),(32937397,370909286,5),(32937397,370909287,6),(32937397,370909276,7),(32937466,370909951,1),(32937466,370909953,2),(32937466,370909956,3),(32937466,370909959,4),(32937466,370909951,5),(32973912,371358341,1),(32973912,371358401,2),(32973912,371358405,3),(32973912,371358406,4),(32973912,371358407,5),(32973912,371358408,6),(32973912,371358409,7),(32973912,371358410,8),(32973912,371358411,9),(32973912,371358412,10),(32973912,371358413,11),(32973912,371358414,12),(32973912,371358415,13),(32973912,371358416,14),(32973912,371358419,15),(32973912,371358420,16),(32973912,371358421,17),(32973912,371358422,18),(32973912,371358423,19),(32973912,371358424,20),(32973912,371358425,21),(32973912,371358426,22),(32973912,371358429,23),(32973912,371358430,24),(32973912,371358431,25),(32973912,371358432,26),(32973912,371358433,27),(32973912,371358434,28),(32973912,371358435,29),(32973912,371358436,30),(32973912,371358437,31),(32973912,371358439,32),(32973912,371358441,33),(32973912,371358442,34),(32973912,371358443,35),(32973912,371358444,36),(32973912,371358445,37),(32973912,371357928,38),(33184240,321651052,1),(33184240,321651053,2),(33184240,321651054,3),(33184240,321651055,4),(33184240,321651056,5),(33184240,321651057,6),(33184240,321651059,7),(33184240,321651060,8),(33184240,321651080,9),(33184240,321651081,10),(33184240,321651082,11),(33184240,321651083,12),(33184240,321651084,13),(33184240,321651085,14),(33184240,321651086,15),(33184240,321651088,16),(33184240,321651089,17),(33184240,321651090,18),(33184240,321651091,19),(33184240,321651092,20),(33184240,321651093,21),(33184240,321651094,22),(33184240,321651095,23),(33184240,321651096,24),(33184240,321651097,25),(33184240,321651098,26),(33184240,321651099,27),(33184240,321651100,28),(33184240,321651101,29),(33184240,321651103,30),(33184240,321651104,31),(33184240,321651105,32),(33184240,321651106,33),(33184240,321651107,34),(33184240,321651108,35),(33184244,321679489,1),(33184244,321679490,2),(33184244,321679491,3),(33184244,321679492,4),(33184244,321679493,5),(33184244,321679494,6),(33184244,321679495,7),(33184244,321679496,8),(33184244,321679497,9),(33184244,321679498,10),(33184244,321679499,11),(33184244,321679500,12),(33184244,321679501,13),(33184244,321679502,14),(33184244,321679503,15),(33184244,321679505,16),(33184244,321679507,17),(33184244,321679508,18),(33184244,321679509,19),(33184244,321679510,20),(33184244,321679511,21),(33184244,321679512,22),(33184244,321679513,23),(33184244,321679514,24),(33184244,321679515,25),(33184244,321679516,26),(33184244,321679517,27),(33184247,321679568,1),(33184247,321679569,2),(33184247,321679570,3),(33184247,321679571,4),(33184247,321679572,5),(33184247,321679573,6),(33184247,321679574,7),(33184247,321679575,8),(33184247,321679576,9),(33184247,321679577,10),(33184247,321679578,11),(33184247,321679579,12),(33184247,321679580,13),(33184247,321679581,14),(33184247,321679582,15),(33184247,321679583,16),(33184247,321679584,17),(33184247,321679586,18),(33184247,321679587,19),(33184247,321679588,20),(33184247,321679589,21),(33184247,321679590,22),(33184247,321679591,23),(33184247,321679592,24),(33184247,321679593,25),(33184247,321679594,26),(33184247,321679595,27),(33184247,321679596,28),(33184247,321679597,29),(33184247,321679598,30),(33184247,321679599,31),(33184247,321679600,32),(33184247,321679601,33),(33184247,321679602,34),(33184247,321679603,35),(33184247,321679604,36),(33184247,321679605,37),(33184247,321679606,38),(33184247,321679607,39),(33184247,321679608,40),(33184247,321679609,41),(33184247,321679610,42),(33184247,321679611,43),(33184247,321679612,44),(33184247,321679613,45),(33184247,321679614,46),(33184247,321679615,47),(33184247,321679616,48),(33184247,321679617,49),(33184247,321679618,50),(33184247,321679619,51),(33184247,321679620,52),(33184247,321679621,53),(33184247,321679622,54),(33184247,321679623,55),(33184247,321679624,56),(33184247,321679626,57),(33184247,321679627,58),(33184247,321679628,59),(33184247,321679629,60),(33184247,321679630,61),(33184247,321679631,62),(33184247,321679632,63),(33184247,321679633,64),(33184247,321679634,65),(33184247,321679635,66),(33184247,321679636,67),(33184247,321679637,68),(33184247,321679638,69),(33184247,321679639,70),(33184247,321679640,71),(33184247,321679641,72),(33184247,321679642,73),(33184247,321679643,74),(33184247,321679644,75),(33184247,321679645,76),(33184247,321679646,77),(33184247,321679647,78),(33184247,321679648,79),(33184247,321679649,80),(33184247,321679650,81),(33184247,321679651,82),(33184247,321679652,83),(33184247,321679653,84),(33184247,321679654,85),(33184247,321679655,86),(33184247,321679656,87),(33184247,321679657,88),(33184247,321679658,89),(33184247,321679659,90),(33184247,321679660,91),(33184247,321679661,92),(33184247,321679662,93),(33184247,321679663,94),(33184247,321679664,95),(33184247,321679665,96),(33184247,321679666,97),(33184247,321679667,98),(33184247,321679668,99),(33184247,321679669,100),(33184247,321679670,101),(33184247,321679671,102),(33184247,321679672,103),(33184247,321679673,104),(33184247,321679674,105),(33184247,321679675,106),(33184247,321679676,107),(33184247,321679677,108),(33184247,321679678,109),(33184247,321679679,110),(33184247,321679681,111),(33184247,321679682,112),(33184247,321679683,113),(33184247,321679684,114),(33184247,321679685,115),(33184247,321679686,116),(33184247,321679687,117),(33184247,321679688,118),(33184247,321679689,119),(33184247,321679690,120),(33184247,321679691,121),(33184247,321679692,122),(33184247,321679693,123),(33184247,321679694,124),(33184247,321679695,125),(33184247,321679696,126),(33184252,321679696,1),(33184252,321679697,2),(33184252,321679698,3),(33184252,321679699,4),(33184252,321679700,5),(33184252,321679701,6),(33184252,321679702,7),(33184252,321679703,8),(33184252,321679704,9),(33184252,321679710,10),(33184252,321679711,11),(33184252,321679712,12),(33184252,321679713,13),(33184252,321679714,14),(33184252,321679715,15),(33184252,321679716,16),(33184252,321679717,17),(33184252,321679718,18),(33184252,321679719,19),(33184252,321679720,20),(33184252,321679721,21),(33184252,321679722,22),(33184252,321679723,23),(33184252,321679724,24),(33184252,321679725,25),(33184252,321679726,26),(33184252,321679727,27),(33184252,321679728,28),(33184252,321679729,29),(33184252,321679731,30),(33184252,321679732,31),(33184252,321679733,32),(33184252,321679734,33),(33184252,321679735,34),(33184252,321679738,35),(33184252,321679745,36),(33184252,321679746,37),(33184252,321679747,38),(33184252,321679748,39),(33184252,321679749,40),(33184252,321679750,41),(33184252,321679751,42),(33184252,321679752,43),(33184252,321679753,44),(33184252,321679754,45),(33184252,321679755,46),(33184252,321679756,47),(33184252,321679757,48),(33184252,321679759,49),(33184252,321679761,50),(33184252,321679762,51),(33184252,321679764,52),(33184252,321679766,53),(33184252,321679767,54),(33184252,321679769,55),(33184252,321679771,56),(33184252,321679773,57),(33184252,321679774,58),(33184252,321679776,59),(33184266,321679326,1),(33184266,321679328,2),(33184266,321679330,3),(33184266,321679332,4),(33184266,321679334,5),(33184266,321679336,6),(33184266,321679340,7),(33184266,321679342,8),(33184266,321679344,9),(33184266,321679346,10),(33184266,321679348,11),(33184266,321679349,12),(33184266,321679350,13),(33184266,321679351,14),(33184266,321679353,15),(33184266,321679355,16),(33184266,321679357,17),(33184266,321679359,18),(33184266,321679361,19),(33184266,321679362,20),(33184266,321679365,21),(33184266,321679367,22),(33184266,321679369,23),(33184266,321679371,24),(33184266,321679373,25),(33184266,321679375,26),(33184266,321679378,27),(33184266,321679381,28),(33184266,321679383,29),(33184266,321679385,30),(33184266,321679387,31),(33184266,321679389,32),(33184266,321679391,33),(33184266,321679393,34),(33184266,321679394,35),(33184266,321679397,36),(33184266,321679398,37),(33184266,321679400,38),(33184266,321679402,39),(33184266,321679405,40),(33184266,321679408,41),(33184266,321679411,42),(33184266,321679413,43),(33184266,321679416,44),(33184266,321679418,45),(33184266,321679421,46),(33184266,321679422,47),(33184266,321679424,48),(33184266,321679426,49),(33184266,321679429,50),(33184266,321679431,51),(33184266,321679433,52),(33184266,321679435,53),(33184266,321679436,54),(33184266,321679437,55),(33184266,321679438,56),(33184266,321679439,57),(33184266,321679440,58),(33184266,321679441,59),(33184266,321679442,60),(33184266,321679443,61),(33184266,321679444,62),(33184266,321679445,63),(33184266,321679446,64),(33184266,321679447,65),(33184266,321679448,66),(33184266,321679449,67),(33184266,321679450,68),(33184266,321679451,69),(33184266,321679452,70),(33184266,321679453,71),(33184266,321679454,72),(33184266,321679455,73),(33184266,321679457,74),(33184266,321679458,75),(33184266,321679459,76),(33184266,321679460,77),(33184266,321679462,78),(33184266,321679465,79),(33184266,321679466,80),(33184266,321679467,81),(33184266,321679468,82),(33184266,321679469,83),(33184266,321679470,84),(33184266,321679471,85),(33184266,321679472,86),(33184266,321679473,87),(33184266,321679474,88),(33184266,321679478,89),(33184266,321679479,90),(33184266,321679480,91),(33184266,321679481,92),(33184266,321679482,93),(33184266,321679483,94),(33184266,321679484,95),(33184266,321679485,96),(33184266,321679486,97),(33184266,321679487,98),(33184266,321679488,99),(33184266,321679489,100),(33184270,321682123,1),(33184270,321682122,2),(33184270,321682121,3),(33184270,321682120,4),(33184270,321682119,5),(33184270,321682118,6),(33184270,321682117,7),(33184270,321682116,8),(33184270,321682115,9),(33184270,321682114,10),(33184270,321682113,11),(33184270,321682112,12),(33184270,321682111,13),(33184270,321682110,14),(33184270,321682109,15),(33184270,321682108,16),(33184270,321682107,17),(33184270,321682106,18),(33184270,321682105,19),(33184270,321682104,20),(33184270,321682103,21),(33184270,321682102,22),(33184270,321682101,23),(33184270,321682100,24),(33184270,321682099,25),(33184270,321682098,26),(33184270,321682097,27),(33184270,321682096,28),(33184270,321682095,29),(33184270,321682094,30),(33184270,321682093,31),(33184270,321682092,32),(33184270,321682091,33),(33184270,321682090,34),(33184270,321682089,35),(33184270,321682088,36),(33184270,321682087,37),(33184270,321682086,38),(33184270,321682085,39),(33184270,321682084,40),(33184270,321682083,41),(33184270,321682082,42),(33184270,321682081,43),(33184270,321682080,44),(33184270,321682079,45),(33184270,321682078,46),(33184270,321682077,47),(33184270,321682076,48),(33184270,321682075,49),(33184270,321682074,50),(33184270,321682073,51),(33184270,321682072,52),(33184270,321682071,53),(33184270,321682070,54),(33184270,321682069,55),(33184270,321682068,56),(33184270,321682067,57),(33184270,321682066,58),(33184270,321682065,59),(33184270,321682064,60),(33184270,321682063,61),(33184270,321682062,62),(33184270,321682061,63),(33184270,321682059,64),(33184270,321682055,65),(33184270,321682054,66),(33184270,321682053,67),(33184270,321682052,68),(33184270,321682051,69),(33184270,321682050,70),(33184270,321682049,71),(33184270,321682048,72),(33184270,321682047,73),(33184270,321682046,74),(33184270,321682045,75),(33184270,321682044,76),(33184270,321682043,77),(33184270,321682042,78),(33184270,321682041,79),(33184270,321682040,80),(33184270,321682039,81),(33184270,321682038,82),(33184270,321682035,83),(33184270,321682028,84),(33184270,321682024,85),(33184270,321682021,86),(33184270,321682018,87),(33184270,321682016,88),(33184270,321682012,89),(33184270,321682009,90),(33184270,321682007,91),(33184270,321682005,92),(33184270,321682003,93),(33184270,321682002,94),(33713550,51441626,1),(33713550,51441629,2),(33713550,51441630,3),(33713550,51445073,4),(33713550,51441632,5),(33713550,51441635,6),(33713550,51441636,7),(33713550,51441228,8),(33721575,385582099,1),(33721575,385582100,2),(33721575,385582101,3),(33721575,385582102,4),(33721575,385582103,5),(33721575,385582104,6),(33721575,385582105,7),(33721575,385582099,8),(33733175,53295059,1),(33733175,385743984,2),(33733175,385743985,3),(33733175,385743986,4),(33733175,385743987,5),(33733175,385743988,6),(33733175,385743989,7),(33733175,385743990,8),(33733175,385743991,9),(33733175,385743992,10),(33733175,385743993,11),(34062547,390336072,1),(34062547,390336073,2),(34062547,53306715,3),(34062881,390327159,1),(34062881,390327162,2),(34062881,390327165,3),(34062881,390327166,4),(34062881,390327168,5),(34062881,390327171,6),(34062881,390327172,7),(34062881,390327175,8),(34062881,390327177,9),(34062881,390327179,10),(34062881,390327180,11),(34062881,390327181,12),(34062881,390327182,13),(34062881,390327183,14),(34062881,390327184,15),(34062881,390327185,16),(34062881,390327186,17),(34062881,390327187,18),(34062881,390327188,19),(34062881,390327189,20),(34062881,390327190,21),(34062881,390327191,22),(34062881,390327192,23),(34062881,390327193,24),(34062881,390327194,25),(34062881,390327195,26),(34062881,390327196,27),(34062881,390327197,28),(34062881,390327198,29),(34062881,390327199,30),(34062881,390327200,31),(34062881,390327202,32),(34062881,390327204,33),(34062881,390327205,34),(34062881,390327207,35),(34062881,390327208,36),(34062881,390327210,37),(34062881,390327212,38),(34062881,390327214,39),(34062881,390327215,40),(34062881,390327217,41),(34062881,390327219,42),(34062881,390327220,43),(34062881,390327222,44),(34062881,390327223,45),(34062881,390327224,46),(34062881,390327225,47),(34062881,390327227,48),(34062881,390327229,49),(34062881,390327231,50),(34062881,390327232,51),(34062881,390327233,52),(34062881,390327234,53),(34062881,390327236,54),(34063687,370909285,1),(34063687,390336447,2),(34063687,390336448,3),(34063687,390336449,4),(34063687,390336450,5),(34063687,390336451,6),(34063687,390336452,7),(34063687,390336072,8),(34063687,390336453,9),(34063687,390336454,10),(34063687,390336455,11),(34063687,390336456,12),(34063687,390336457,13),(34063687,390336458,14),(34063687,390336459,15),(34063687,390336460,16),(34063687,390336461,17),(34063687,390336462,18),(34063687,390336463,19),(34063687,390336464,20),(34063687,390336465,21),(34063687,390336466,22),(34063687,390336467,23),(34063687,390336468,24),(34063687,390336469,25),(34063687,390336470,26),(34063687,390336471,27),(34063687,390336472,28),(34063687,390336473,29),(34063687,390336474,30),(34063687,390336475,31),(34063687,390336476,32),(34063687,390336477,33),(34063687,390336479,34),(34063687,390336481,35),(34063687,390336483,36),(34063687,390336485,37),(34063687,390336487,38),(34063687,390336489,39),(34063687,390336491,40),(34063687,390336493,41),(34063687,390336494,42),(34063687,390336495,43),(34063704,390336495,1),(34063704,390327234,2),(34063735,390336904,1),(34063735,390336730,2),(34063735,390336731,3),(34063735,390336732,4),(34063735,390336733,5),(34063735,390336734,6),(34063735,390336735,7),(34063735,390336737,8),(34063735,390336738,9),(34063735,390336740,10),(34063735,390336742,11),(34063735,390336745,12),(34063735,390336747,13),(34063735,390336748,14),(34063735,390336750,15),(34063735,390336752,16),(34063735,390336754,17),(34063735,390336755,18),(34063735,390336757,19),(34063769,53306787,1),(34063769,390337187,2),(34063769,53306786,3),(34063770,53306786,1),(34063770,53306782,2),(34063770,53306781,3),(34063770,53306780,4),(34063770,53306778,5),(34063770,53306775,6),(34063770,53306774,7),(34063770,53306771,8),(34063770,53306769,9),(34063770,53306767,10),(34063770,53306764,11),(34063770,53295264,12),(34064472,390346965,1),(34064472,390346966,2),(34064472,390346967,3),(34064472,390346968,4),(34064472,390346969,5),(34064472,390346970,6),(34064472,390346971,7),(34064472,390346972,8),(34064472,390346973,9),(34064472,390346974,10),(34064472,390346975,11),(34064472,390346976,12),(34064472,390346977,13),(34064472,390346978,14),(34064472,390346979,15),(34064472,390346980,16),(34064813,53295133,1),(34064813,390351766,2),(34064813,390351767,3),(34064813,390351768,4),(34064813,390351769,5),(34064813,390351770,6),(34064813,390351771,7),(34064813,390351772,8),(34064813,390351773,9),(34064813,390351774,10),(34064813,390351775,11),(34064813,390351776,12),(34064813,390346965,13),(34064907,53295141,1),(34064907,390353660,2),(34064907,390353661,3),(34064907,390353662,4),(34064907,390353663,5),(34064907,390353664,6),(34064907,390353665,7),(34064907,390353666,8),(34064907,390353667,9),(34064907,390353668,10),(34064907,390353669,11),(34064907,390353670,12),(34064907,390353671,13),(34064907,390353672,14),(34064907,390353673,15),(34064907,390353674,16),(34064907,390353675,17),(34064907,390353676,18),(34064907,390353677,19),(34065105,390353677,1),(34065105,390356561,2),(34065105,390356562,3),(34065105,390356563,4),(34065105,390356564,5),(34065105,390356565,6),(34065105,390356566,7),(34065105,390356567,8),(34065105,390356568,9),(34065105,390356569,10),(34065105,390356570,11),(34065105,390356571,12),(34065105,390356572,13),(34065105,390356573,14),(34065105,390356574,15),(34065105,390356575,16),(34065105,390356576,17),(34065105,385743993,18),(34065105,390356578,19),(34065105,390356579,20),(34065671,53306910,1),(34065671,390361836,2),(34065671,390361837,3),(34065671,390361838,4),(34065671,390361839,5),(34065671,390361840,6),(34065671,259986455,7),(34065735,53306913,1),(34065735,53306912,2),(34065735,277001703,3),(34065735,53306911,4),(34387676,52262641,1),(34387676,394815197,2),(34387676,394815198,3),(34387676,394815199,4),(34387676,394815200,5),(34387821,394816282,1),(34387821,394816283,2),(34387821,394816284,3),(34387821,394816285,4),(34387821,394816286,5),(34387821,394816287,6),(34387821,394816288,7),(34387821,394816289,8),(34387821,394816290,9),(34387821,394816825,10),(34388549,394820724,1),(34388549,394820725,2),(34388549,394820726,3),(34388549,394820727,4),(34388549,394820728,5),(34388549,394820729,6),(34388549,394820721,7),(34388549,394820722,8),(34388549,394822862,9),(34389528,394831767,1),(34389528,394832384,2),(34389528,394832388,3),(34389528,394832391,4),(34389528,394832396,5),(34389528,394832401,6),(34389528,394832404,7),(34389528,394832407,8),(34389528,394832411,9),(34389528,394832416,10),(34389528,394832428,11),(34390093,394840530,1),(34390093,394840531,2),(34390093,394840532,3),(34390093,394840533,4),(34390093,394840534,5),(34390103,394815200,1),(34390103,394816825,2),(34390103,394816826,3),(34390103,394816827,4),(34390103,394816828,5),(34390103,394816829,6),(34390103,394816830,7),(34390103,394816831,8),(34390103,394823920,9),(34390103,394816832,10),(34390103,394823921,11),(34390103,394822862,12),(34390103,394823922,13),(34390103,394823923,14),(34390103,394823924,15),(34390103,394823925,16),(34390103,394823926,17),(34390103,394823927,18),(34390103,394823928,19),(34390103,394831766,20),(34390103,394831767,21),(34390103,394831768,22),(34390103,394840995,23),(34390103,394840996,24),(34390103,394840997,25),(34390103,394840998,26),(34390103,394840999,27),(34390103,394841000,28),(34390103,394841001,29),(34390103,394841002,30),(34390103,394841006,31),(34390103,394841007,32),(34390103,394841008,33),(34390103,394841009,34),(34390103,394841010,35),(34390103,394841011,36),(34390103,394840530,37),(34390103,394841012,38),(34390103,394841013,39),(34390103,394841014,40),(34390103,394841015,41),(34390103,394841016,42),(34390103,394841017,43),(34390103,394841018,44),(34390103,394841019,45),(34390103,394841020,46),(34390103,394841021,47),(34390103,394841022,48),(34390103,394841023,49),(34390103,394841024,50),(34390103,394841026,51),(34390103,394841027,52),(34390103,394841028,53),(34390103,394841029,54),(34390103,394841030,55),(34390103,394845193,56),(34390103,394841031,57),(34390499,394845193,1),(34390499,394847583,2),(34390499,394847585,3),(34390499,394847587,4),(34390499,394847589,5),(34390499,394847590,6),(34390499,394847591,7),(34390499,394847592,8),(34390499,394847593,9),(34390581,394847593,1),(34390581,394848317,2),(34390581,394848319,3),(34390594,394841031,1),(34390594,394841032,2),(34390594,394841033,3),(34390594,394841034,4),(34390594,394841035,5),(34390594,394841036,6),(34876322,408986116,1),(34876322,408986118,2),(34876322,408986121,3),(34876322,408986124,4),(34876322,408986126,5),(34876322,408986129,6),(34876322,408986131,7),(34876322,408986116,8),(34876405,408987613,1),(34876405,266326328,2),(35444733,390327159,1),(35444733,415767154,2),(35444733,415767166,3),(35444733,415767158,4),(35444733,415767172,5),(35444733,415767153,6),(35444733,415767146,7),(35444733,415767142,8),(35444733,415767150,9),(35444733,415767171,10),(35444733,415767161,11),(35444733,415767163,12),(35444733,415767167,13),(35444733,415767156,14),(35444733,415767140,15),(35444733,415767145,16),(35444733,415767165,17),(35444733,415767162,18),(35444733,415767159,19),(35444733,415767169,20),(35444733,415767152,21),(35444733,415767147,22),(35444733,415767143,23),(35444733,415767157,24),(35444733,415767170,25),(35444733,415767160,26),(35444733,415767164,27),(35444733,415767168,28),(35444733,415767155,29),(35444733,415767141,30),(35444733,415767144,31),(35444733,415767149,32),(35444733,415767151,33),(35444733,415767148,34),(37633206,441154305,1),(37633206,441154306,2),(37633206,441154307,3),(37633206,441154308,4),(37633275,441154951,1),(37633275,441154982,2),(37633275,441154983,3),(37633275,441154984,4),(37633275,441154305,5),(37633404,441154982,1),(37633404,441157250,2),(37633404,441157251,3),(37633404,441157252,4),(37633404,441157253,5),(37633404,441157255,6),(37633404,441157257,7),(37633404,441157259,8),(37633404,441157261,9),(37633404,441157265,10),(37633404,441157267,11),(37756343,277001703,1),(37756343,442880086,2),(37756386,442880684,1),(37756386,442880685,2),(37756386,442880686,3),(37756386,442880687,4),(37756386,442880684,5),(37865954,51973501,1),(37865954,51973504,2),(37865954,51973507,3),(37865954,51973901,4),(37865954,51973511,5),(37865954,51973903,6),(38706653,470343713,1),(38706653,470347019,2),(38706653,458761931,3),(38706653,458761932,4),(38706653,458761933,5),(38706653,458761934,6),(38706653,458761935,7),(38706653,458761937,8),(38706653,458761938,9),(38706653,458761939,10),(38706653,458761940,11),(38706653,458761941,12),(38706653,458761942,13),(38706653,458761943,14),(38706653,458761944,15),(38706653,458761945,16),(38706653,458761946,17),(38706653,458761947,18),(38706653,458761948,19),(38706653,458761949,20),(38706653,458761950,21),(38706653,458761951,22),(38706653,458761952,23),(38706653,458761953,24),(38706653,458761954,25),(38706653,458761955,26),(38706653,458761956,27),(38706653,458761957,28),(38706653,458761958,29),(38706653,458761959,30),(38706653,458761960,31),(38706653,458761961,32),(38706653,458761962,33),(38706653,458761963,34),(38706653,458761964,35),(38706653,458761965,36),(38706653,458761966,37),(38706653,458761967,38),(38706653,458761968,39),(38706653,458761969,40),(38706653,458761970,41),(38706653,458761971,42),(38706653,458761972,43),(38706653,458761973,44),(38706653,458761974,45),(38706653,458761975,46),(38706653,458761977,47),(38706653,458761978,48),(38706653,458761979,49),(38706653,458761980,50),(38706653,458761981,51),(38706653,458761982,52),(38706653,458761983,53),(38706653,458761984,54),(38706653,458764071,55),(38706653,458764072,56),(38706653,458764073,57),(38706653,458764074,58),(38706653,458764075,59),(38706653,458764076,60),(38706653,458764077,61),(38706653,458764078,62),(38706653,458764079,63),(38706653,458764080,64),(38706653,458764081,65),(38706653,458764082,66),(38706653,458764083,67),(38706653,458764084,68),(38706653,458764085,69),(38706653,458764086,70),(38706653,458764087,71),(38706653,458764088,72),(38706653,458764089,73),(38706653,458764090,74),(38706653,458764091,75),(38706653,458764092,76),(38706653,458764093,77),(38706653,458764094,78),(38706653,458764095,79),(38706653,458764096,80),(38706653,458764097,81),(38706653,458764098,82),(38706653,458764099,83),(38706653,458764100,84),(38706653,458764101,85),(38706653,458764102,86),(38706653,458764103,87),(38706653,458764104,88),(38706653,458764105,89),(38706653,458764106,90),(38706653,458764107,91),(38706653,458764108,92),(38706653,458764109,93),(38706653,458764110,94),(38706653,458764111,95),(38706653,458764112,96),(38706653,458764113,97),(38706653,458764114,98),(38706653,458764115,99),(38706653,458764116,100),(38706653,458764118,101),(38706653,458764119,102),(38706653,458764120,103),(38706653,458764121,104),(38706653,458764122,105),(38706653,458764123,106),(38706653,458764124,107),(38706653,458764125,108),(38706653,458764126,109),(38706653,458764127,110),(38706653,458764128,111),(38706653,458764129,112),(38706653,458764130,113),(38706653,458764131,114),(38706653,458764132,115),(38706653,458764133,116),(38706653,458764134,117),(38706653,458764135,118),(38706653,458764136,119),(38706653,458764139,120),(38706653,458764150,121),(38706653,458764156,122),(38706653,458764162,123),(38706653,458764166,124),(38706653,458764167,125),(38706653,458764168,126),(38706653,458764169,127),(38706653,458764170,128),(38706653,458764171,129),(38706653,458764172,130),(38706653,458764173,131),(38706653,458764174,132),(38706653,458764175,133),(38706653,458764176,134),(38706653,458764177,135),(38706653,458764178,136),(38706653,458764179,137),(38706925,268615704,1),(38706925,458765127,2),(38706925,458765128,3),(38706927,458765312,1),(38706927,458765314,2),(38706928,470348213,1),(38706928,470348216,2),(38706928,470351662,3),(38706928,470351674,4),(38706928,470351687,5),(38706928,470351695,6),(38706928,470351696,7),(38706928,470351698,8),(38706928,470351699,9),(38706928,470351700,10),(38706928,470351702,11),(38706928,470351703,12),(38706928,470351704,13),(38706928,470351705,14),(38706928,470351706,15),(38706928,470353011,16),(38706928,470353010,17),(38706928,470353009,18),(38706928,470353008,19),(38706928,470353007,20),(38706928,470353006,21),(38706928,470353005,22),(38706928,470353004,23),(38706928,470353003,24),(38706928,470353002,25),(38706928,470353001,26),(38706928,470353000,27),(38706928,470352999,28),(38706928,470352998,29),(38706928,470352997,30),(38706928,470352996,31),(38706928,470352995,32),(38706928,470352993,33),(38706928,470352992,34),(38706928,470352991,35),(38706928,470352990,36),(38706928,470352989,37),(38706928,470352988,38),(38706936,458765314,1),(38706936,458765317,2),(38706936,458765319,3),(38706936,458765321,4),(38706936,458765020,5),(39258136,470349572,1),(39258136,470349573,2),(39258136,470349575,3),(39258136,470349576,4),(39258136,470349578,5),(39258137,470349632,1),(39258137,470349572,2),(39258144,470349578,1),(39258144,470349580,2),(39258144,470349603,3),(39258742,470348216,1),(39258742,470348218,2),(39258742,470348220,3),(39258742,470348222,4),(39258742,470348224,5),(39258742,470348227,6),(39258742,470348228,7),(39258742,470348229,8),(39258742,470348231,9),(39258742,470348233,10),(39258742,470348236,11),(39258742,470348239,12),(39258742,470348241,13),(39258742,470348244,14),(39258742,470348245,15),(39258742,470348248,16),(39258742,470348249,17),(39258742,470348250,18),(39258742,470348254,19),(39258742,470348257,20),(39258742,470348260,21),(39258742,470348263,22),(39258742,470348264,23),(39258742,470348269,24),(39258742,470348271,25),(39258742,470348272,26),(39258742,470348273,27),(39258742,470348274,28),(39258742,470348275,29),(39258742,470348277,30),(39258742,470348279,31),(39258742,470348280,32),(39258742,470348281,33),(39258742,470348282,34),(39258742,470348283,35),(39258742,470348286,36),(39258742,470348288,37),(39258742,470348290,38),(39258742,470348292,39),(39258742,470348294,40),(39258742,470348299,41),(39258742,470348301,42),(39258742,470348302,43),(39258742,470348303,44),(39258742,470348304,45),(39258742,470348305,46),(39258742,470348306,47),(39258742,470348307,48),(39258742,470348308,49),(39258742,470348309,50),(39258742,470348310,51),(39258742,470348311,52),(39258742,470348312,53),(39258742,470348314,54),(39258742,470348315,55),(39258742,470348316,56),(39258742,470348318,57),(39258742,470348319,58),(39258742,470348321,59),(39258742,470348322,60),(39258742,470348325,61),(39258742,470348326,62),(39258742,470348327,63),(39258742,470348328,64),(39258742,470348329,65),(39258742,470348330,66),(39258742,470348332,67),(39258742,470348333,68),(39258742,470348335,69),(39258742,470348337,70),(39258742,470348338,71),(39258742,470348339,72),(39258742,470348341,73),(39258742,470343713,74),(39258742,470343719,75),(39258742,470343724,76),(39258742,470343733,77),(39258742,470343737,78),(39258742,470343746,79),(39258742,470343752,80),(39258742,470343759,81),(39258742,470343766,82),(39258742,470343771,83),(39258742,470343785,84),(39258742,470343793,85),(39258742,470343798,86),(39258742,470343805,87),(39258742,470343810,88),(39258742,470343811,89),(39258742,470343812,90),(39258742,470343814,91),(39258742,470343816,92),(39258742,470343817,93),(39258742,470343819,94),(39258742,470343820,95),(39258742,470343822,96),(39258742,470343823,97),(39258742,470343825,98),(39258742,470343827,99),(39258742,470343828,100),(39258742,470343830,101),(39258742,470343831,102),(39258742,470343832,103),(39258742,470343833,104),(39258742,470343834,105),(39258742,470343835,106),(39258742,470343836,107),(39258742,470343837,108),(39258742,470343838,109),(39258742,470343839,110),(39258742,470343840,111),(39258742,470343841,112),(39258742,470343842,113),(39258742,470343844,114),(39258742,470343850,115),(39258742,470343852,116),(39258742,470343853,117),(39258742,470343854,118),(39258742,470343856,119),(39258742,470343857,120),(39258742,470343858,121),(39258742,470343859,122),(39258742,470343860,123),(39258742,470343861,124),(39258742,470343862,125),(39258742,470343863,126),(39258742,470343864,127),(39258742,470343865,128),(39258742,470343866,129),(39258742,470343867,130),(39258742,470343868,131),(39258742,470343869,132),(39258742,470343870,133),(39258742,470343871,134),(39258742,470343872,135),(39258742,470343873,136),(39258742,470343874,137),(39258742,470343875,138),(39258742,470343876,139),(39258742,470343877,140),(39258742,470343878,141),(39258742,470343879,142),(39258742,470343880,143),(39258742,470343881,144),(39258742,470343882,145),(39258742,470343883,146),(39258742,458765361,147),(39258742,458764179,148),(39258742,458765365,149),(39258742,458765368,150),(39258742,458765373,151),(39258742,458765375,152),(39258742,458765377,153),(39258742,458765379,154),(39258742,458765381,155),(39258742,458765383,156),(39258742,458765386,157),(39258742,458765388,158),(39258742,458765312,159),(39259019,470357335,1),(39259019,470357336,2),(39259019,470357338,3),(39259019,470357340,4),(39259019,470357348,5),(39259022,470356873,1),(39259022,470357335,2),(39259088,470358230,1),(39259088,470358231,2),(39259088,470358232,3),(39259088,262464086,4),(39259092,262464091,1),(39259092,470358240,2),(39259092,470358241,3),(39259092,470358242,4),(39259092,470358230,5),(39259147,470358581,1),(39259147,470358582,2),(39259147,470358583,3),(39259147,470358584,4),(39259147,470358581,5),(39259506,268615787,1),(39259506,268615788,2),(39259506,268615789,3),(39259506,268615790,4),(39259506,470363726,5),(39259506,470363727,6);
INSERT INTO `current_way_nodes` VALUES (39259506,470363728,7),(39259506,470363729,8),(39259506,470363730,9),(39259506,470363731,10),(39259666,470364482,1),(39259666,470364483,2),(39259666,470364484,3),(39259666,470364486,4),(39259666,470364482,5),(39259759,470365699,1),(39259759,470365700,2),(39259759,470365701,3),(39259759,470365703,4),(39259759,470365704,5),(39259759,470365706,6),(39259759,470365708,7),(39259759,470365709,8),(39259759,470365710,9),(39259759,470365711,10),(39259759,470365712,11),(39259759,470365713,12),(39259759,470365714,13),(39259759,470365715,14),(39259759,470365716,15),(39259759,470365717,16),(39259759,470365193,17),(39259759,470365194,18),(39259759,470365195,19),(39259759,470365202,20),(39259759,470365211,21),(39259759,470365221,22),(39259759,470365232,23),(39259759,470365242,24),(39259759,52168516,25),(39259769,470365262,1),(39259769,51582178,2),(39259769,51582181,3),(39259769,268615558,4),(39259769,51582184,5),(39259769,268615948,6),(39259769,51582186,7),(39259769,51582188,8),(39259769,470363731,9),(39259769,51582191,10),(39259769,51582194,11),(39259769,51582198,12),(39259769,51582201,13),(39259769,268617677,14),(39259769,268617809,15),(39259769,51582204,16),(39259769,51582207,17),(39259769,51582209,18),(39259769,51582211,19),(39259769,264465123,20),(39259770,51582175,1),(39259770,470365262,2),(40064501,482113340,1),(40064501,482113341,2),(40064501,482113342,3),(40064501,482113343,4),(40064501,482113344,5),(40064501,482113345,6),(40064876,482113739,1),(40064876,482113740,2),(40064876,482113741,3),(40064876,482113742,4),(40064876,482113743,5),(40064876,482114101,6),(40064876,482113744,7),(40064876,482113745,8),(40064876,482113746,9),(40064876,482114102,10),(40064876,482113747,11),(40064876,482113748,12),(40064876,482113749,13),(40064876,482113750,14),(40064876,482113751,15),(40064876,482113752,16),(40064876,482113753,17),(40064876,482114103,18),(40064876,482113754,19),(40064876,482113755,20),(40064876,482113756,21),(40064876,482113757,22),(40064876,482113758,23),(40064876,482113759,24),(40064876,482113760,25),(40064876,482113761,26),(40064876,482113762,27),(40064876,482113763,28),(40064876,482113764,29),(40064876,482113765,30),(40064876,482113766,31),(40064876,482113767,32),(40064876,482113768,33),(40064876,482113769,34),(40064876,482113770,35),(40064876,482113771,36),(40064876,482113772,37),(40064876,482113340,38),(40065172,482114225,1),(40065172,482114227,2),(40065172,482114229,3),(40065172,482114231,4),(40065172,482114232,5),(40065172,482114235,6),(40065172,482113739,7),(40065172,482114237,8),(40065349,482124370,1),(40065349,482124371,2),(40065349,482124373,3),(40065349,482124375,4),(40065349,482124378,5),(40065349,482124380,6),(40065349,482124381,7),(40065349,482124383,8),(40065349,482124388,9),(40065349,482124389,10),(40065349,482124392,11),(40065349,482124395,12),(40065349,482124397,13),(40065349,482124398,14),(40065349,482124399,15),(40065349,482124402,16),(40065349,482124404,17),(40065349,482124407,18),(40065349,482124408,19),(40065349,482124409,20),(40065349,482124415,21),(40065349,482124418,22),(40065349,482124421,23),(40065349,482124424,24),(40065349,482124425,25),(40065349,482124427,26),(40065349,482124430,27),(40065349,482124432,28),(40065349,482124434,29),(40065349,482124435,30),(40065349,482124441,31),(40065349,482124443,32),(40065349,482124445,33),(40065349,482124448,34),(40065349,482124450,35),(40065349,482124451,36),(40065349,482124454,37),(40065349,482124457,38),(40065349,482124459,39),(40065349,482124460,40),(40065349,482124466,41),(40065349,482124468,42),(40065349,482124470,43),(40065349,482124473,44),(40065349,482124475,45),(40065810,482143961,1),(40065810,482143969,2),(40065810,482143974,3),(40065810,482143976,4),(40065810,482143978,5),(40065810,482143984,6),(40065810,482143987,7),(40065810,482143992,8),(40065810,482143997,9),(40065810,482144000,10),(40065810,482144005,11),(40065810,482144009,12),(40065810,482144019,13),(40065810,482144023,14),(40065810,482144027,15),(40065810,482144030,16),(40065810,482144032,17),(40065810,482144036,18),(40065810,482144040,19),(40065810,482144044,20),(40065810,482144048,21),(40065810,482144052,22),(40065810,482144069,23),(40065810,482144078,24),(40065810,482144087,25),(40065893,482148188,1),(40065893,482148191,2),(40065893,482148194,3),(40065893,482148198,4),(40065893,482148201,5),(40065893,482148204,6),(40065893,482148213,7),(40065893,482148217,8),(40065893,482148220,9),(40065893,482148223,10),(40065893,482148226,11),(40065893,482148228,12),(40065893,482148231,13),(40065893,482148234,14),(40067891,482159051,1),(40067891,482159053,2),(40067891,482158226,3),(40067891,482158227,4),(40067891,482158228,5),(40067891,482158229,6),(40067891,482158230,7),(40067891,482158231,8),(40067891,482158232,9),(40067891,482158233,10),(40067891,482158234,11),(40067891,482158235,12),(40067891,482158236,13),(40067891,482158237,14),(40067891,482158238,15),(40067891,482158239,16),(40067891,482158240,17),(40067891,482158241,18),(40067891,482158243,19),(40067891,482158246,20),(40067891,482158248,21),(40067891,482158251,22),(40067891,482158252,23),(40067891,482158253,24),(40067891,482158254,25),(40067891,482158255,26),(40067891,482158256,27),(40067891,482158257,28),(40067891,482158258,29),(40067891,482158259,30),(40067891,482158260,31),(40067891,482158261,32),(40067891,482158262,33),(40067891,482158263,34),(40067891,482158872,35),(40067891,482158264,36),(40067891,482158265,37),(40067891,482158873,38),(40067891,482158266,39),(40067891,482158267,40),(40067891,482158268,41),(40067891,482158269,42),(40067891,268615707,43),(40137318,337767559,1),(40137318,51399367,2),(40137318,51399320,3),(40137318,51400794,4),(40137318,52688872,5),(40137318,51399321,6),(40264409,485577918,1),(40264409,485577920,2),(40264409,485577921,3),(40264409,485577922,4),(40264409,485577923,5),(40264409,485577924,6),(40264409,485577925,7),(40264409,485577926,8),(40264409,485577927,9),(40264409,485577928,10),(40264409,485577929,11),(40264409,485577930,12),(40264409,485577931,13),(40264409,485577932,14),(40264409,485577933,15),(40264409,485577934,16),(40264409,485577936,17),(40264409,485577937,18),(40264409,485577938,19),(40264409,485577939,20),(40264409,485577940,21),(40264409,485577941,22),(40264409,485577942,23),(40264409,485577943,24),(40264409,485577944,25),(40264409,485577945,26),(40264409,485577946,27),(40264409,485577947,28),(40264409,485577948,29),(40264409,485577949,30),(40264409,485577950,31),(40264409,485577951,32),(40264409,485577953,33),(40264409,485577954,34),(40264409,485577955,35),(40264409,485577956,36),(40264409,485577957,37),(40264409,485577958,38),(40264409,485577959,39),(40264409,485577960,40),(40264409,485577961,41),(40264409,485577962,42),(40264409,485577963,43),(40264409,485577964,44),(40264409,485577965,45),(40264410,485577965,1),(40264410,485577966,2),(40264410,485577968,3),(40264410,485577969,4),(40264410,485577970,5),(40264410,485577971,6),(40264410,485577972,7),(40264410,485577973,8),(40264410,485577974,9),(40264410,485577975,10),(40264410,485577976,11),(40264410,485577977,12),(40264410,485577978,13),(40264410,485577979,14),(40264410,485577981,15),(40264410,485577982,16),(40264410,485577984,17),(40264410,485577985,18),(40264410,485577986,19),(40264410,485577987,20),(40264410,485577988,21),(40264410,485577989,22),(40264410,485577990,23),(40264410,485577991,24),(40264410,485577992,25),(40264410,485577993,26),(40264410,485577994,27),(40264410,485577995,28),(40264410,485577996,29),(40264410,485577997,30),(40264410,485577998,31),(40264410,485577999,32),(40264410,485578000,33),(40264410,485578001,34),(40264410,485578003,35),(40264410,485578004,36),(40264410,485578005,37),(40264410,485578006,38),(40264410,485578007,39),(40264410,485578008,40),(40264410,485578009,41),(40264410,485578010,42),(40264410,485578011,43),(40264410,485578012,44),(40264410,485578013,45),(40264410,485578014,46),(40264410,485578016,47),(40264410,485578017,48),(40264410,485578018,49),(40264410,485578019,50),(40264410,485578020,51),(40264410,485578021,52),(40264410,485578022,53),(40264410,485578023,54),(40264410,485578024,55),(40264410,485578025,56),(40264410,485578026,57),(40264410,485578027,58),(40264410,485578028,59),(40264410,485578029,60),(40264410,485578030,61),(40264410,485578031,62),(40264410,485578032,63),(40264410,485578033,64),(40264410,485578035,65),(40264410,485578036,66),(40264410,485578037,67),(40264410,485578038,68),(40264410,485578039,69),(40264410,485578040,70),(40264410,485578041,71),(40264410,485578042,72),(40264410,485578043,73),(40264410,485578044,74),(40264410,485578045,75),(40264410,485578046,76),(40264410,485578048,77),(40264410,485578049,78),(40264410,485578050,79),(40264410,485578051,80),(40264410,485578052,81),(40264410,485578053,82),(40264410,485578054,83),(40264410,485578055,84),(40264410,485578056,85),(40264410,485578057,86),(40264410,485578058,87),(40264410,485578059,88),(40264410,485578060,89),(40264410,485578062,90),(40264410,485578063,91),(40264410,485578064,92),(40264410,485578065,93),(40264410,485578066,94),(40264410,485578067,95),(40264410,485578068,96),(40264410,485578070,97),(40264410,485578071,98),(40264410,485578072,99),(40264410,485578073,100),(40264410,485578074,101),(40264410,485578075,102),(40264410,485578076,103),(40264410,485578077,104),(40264410,485578079,105),(40264410,485578080,106),(40264410,485578081,107),(40264410,485578082,108),(40264410,485578083,109),(40264410,485578084,110),(40264410,485578085,111),(40264410,485578086,112),(40264410,485578087,113),(40264410,485578088,114),(40264410,485578089,115),(40264410,485578090,116),(40264410,485578091,117),(40264410,485578092,118),(40264410,485578093,119),(40264410,485578095,120),(40264410,485578096,121),(40264410,485578097,122),(40264410,485578098,123),(40264410,485578099,124),(40264410,485578100,125),(40264410,485578101,126),(40264410,485578102,127),(40264410,485578103,128),(40264410,485578104,129),(40264410,485578105,130),(40264410,485578106,131),(40264410,485578107,132),(40264410,485578108,133),(40264410,485578109,134),(40264410,485578111,135),(40264410,485578112,136),(40264410,485578113,137),(40264410,485578114,138),(40264410,485578115,139),(40264410,485578116,140),(40264410,485578117,141),(40264410,485578118,142),(40264410,485578119,143),(40264410,485578120,144),(40264410,485578121,145),(40264410,485578122,146),(40264410,485578124,147),(40264410,485578125,148),(40264410,485578126,149),(40264410,485578127,150),(40264410,485578128,151),(40264410,485578129,152),(40264410,485578130,153),(40264410,485578133,154),(40264410,485578134,155),(40264410,485578135,156),(40264410,485578136,157),(40264410,485578137,158),(40264410,485578138,159),(40264410,485578139,160),(40264410,485578140,161),(40264410,485578142,162),(40264410,485578143,163),(40264410,485578146,164),(40264410,485578159,165),(40264410,485578160,166),(40264410,485578161,167),(40264410,485578162,168),(40264410,485578163,169),(40264410,485578164,170),(41785125,515429490,1),(41785125,515429491,2),(41785125,515429492,3),(41785125,515429493,4),(41785125,515429494,5),(41785125,515429495,6),(41785125,515429496,7),(41785125,515429497,8),(41935429,519515756,1),(41935429,519515757,2),(41935429,519515758,3),(41935429,519515759,4),(41935429,519515760,5),(41935429,519515761,6),(41935429,519515762,7),(41935429,519515763,8),(41935429,519515764,9),(41935429,519515765,10),(41935429,519515766,11),(41935429,519515767,12),(41935429,519515768,13),(41935429,519515769,14),(41935429,519515770,15),(41935429,519515771,16),(41935429,519515772,17),(41935429,519515756,18),(42014211,521153185,1),(42014211,664225514,2),(42014211,664225476,3),(42014211,664225519,4),(42014211,664225516,5),(42014211,664225525,6),(42014211,664225523,7),(42014211,664225521,8),(42014211,664225529,9),(42014211,664225527,10),(42014211,664225531,11),(42014211,521153188,12),(42021998,521349887,1),(42021998,521349888,2),(42021998,521349889,3),(42021998,521349890,4),(42021998,521349907,5),(42021998,521349908,6),(42021998,521349887,7),(42055725,522254633,1),(42055725,522254634,2),(42055725,522254635,3),(42055725,522254636,4),(42055725,522254637,5),(42055725,522254638,6),(42055725,522254639,7),(42055725,522254640,8),(42055725,522254641,9),(42055725,522254642,10),(42055725,522254643,11),(42055725,522254644,12),(42055725,522254645,13),(42055725,522254646,14),(42055725,522254647,15),(42055725,522254648,16),(42055725,522254649,17),(42055725,522254650,18),(42055725,522254633,19),(42055772,522256224,1),(42055772,522256225,2),(42055772,522256226,3),(42055772,522256227,4),(42055772,522256228,5),(42055772,522256229,6),(42055772,522256230,7),(42055772,522256231,8),(42055772,522256232,9),(42055772,522256233,10),(42055772,522256234,11),(42055772,522256235,12),(42055772,522256236,13),(42055772,522256237,14),(42055772,522256238,15),(42055772,522256239,16),(42055772,522256240,17),(42055772,522256241,18),(42055772,522256242,19),(42055772,522256243,20),(42055772,522256245,21),(42055772,522256224,22),(42235196,526428059,1),(42235196,526428060,2),(42235196,526428062,3),(42235196,526428066,4),(42235196,526428067,5),(42235196,526428069,6),(42235196,526428070,7),(42235196,526428071,8),(42235196,526428073,9),(42235196,526428074,10),(42235196,526428076,11),(42235196,526428077,12),(42235196,526428078,13),(42235196,526428080,14),(42235196,526428081,15),(42235196,526428083,16),(42235196,526428084,17),(42235196,526428086,18),(42235196,526428090,19),(42235196,526428091,20),(42235209,643575027,1),(42235209,643575028,2),(42235209,526429982,3),(42235209,526429983,4),(42235209,526429985,5),(42235209,526429986,6),(42235209,526429988,7),(42235209,526429992,8),(42235209,526429993,9),(42235226,526431633,1),(42235226,526431634,2),(42235226,526431636,3),(42235226,526431637,4),(42235226,526431639,5),(42235226,526431640,6),(42235226,526431642,7),(42235226,526431643,8),(42235226,526431645,9),(42235226,526431646,10),(42235226,526431648,11),(42235226,526431649,12),(42235226,526431651,13),(42235226,526431652,14),(42235226,526431654,15),(42235226,526431655,16),(42235226,526431656,17),(42235226,526431658,18),(42235226,526431663,19),(42235226,526431664,20),(42235226,526431666,21),(42235226,526431667,22),(42235226,526431669,23),(42235226,526431671,24),(42235226,526431672,25),(42235226,526431674,26),(42235229,526431798,1),(42235229,526431800,2),(42235229,526431801,3),(42235229,526431803,4),(42235229,526431804,5),(42235229,526431806,6),(42235229,526431807,7),(42235229,526431809,8),(42235229,526431810,9),(42235229,526431812,10),(42235229,526431813,11),(42235229,526431817,12),(42235229,526431818,13),(42235229,526431820,14),(42235229,526431821,15),(42235229,526431823,16),(42235229,526431824,17),(42235229,526431826,18),(42235229,526431827,19),(42235229,526431828,20),(42235229,526431830,21),(42235229,526431831,22),(42235229,526431833,23),(42235229,526431834,24),(42235229,526431836,25),(42235229,526431837,26),(42235229,526431839,27),(42235229,526431840,28),(42235229,526431842,29),(42235229,526431858,30),(42235229,526431859,31),(42235229,526431860,32),(42235229,526431861,33),(42235229,526431863,34),(42235229,526431865,35),(42235229,526431866,36),(42235229,526431868,37),(42235229,526431869,38),(42235229,526431870,39),(42235229,526431872,40),(42235229,526431873,41),(42235229,526431875,42),(42235229,526431876,43),(42235229,526431878,44),(42235229,526431879,45),(42235229,526431881,46),(42235229,526431882,47),(42235229,526431884,48),(42235229,526431885,49),(42235229,526431887,50),(42235229,526431888,51),(42235229,526431892,52),(42235229,526431893,53),(42235229,526431895,54),(42235229,526431896,55),(42235229,526431898,56),(42235229,526431899,57),(42235229,526431901,58),(42235229,526431902,59),(42235229,526431903,60),(42235229,526431930,61),(42235229,526431932,62),(42235229,526431933,63),(42235229,526431935,64),(42235229,526432055,65),(42235229,526432057,66),(42235229,526432058,67),(42235229,526432060,68),(42235229,526432061,69),(42235229,526432063,70),(42235229,526432064,71),(42235229,526432067,72),(42235229,526432069,73),(42235229,526432070,74),(42235229,526432072,75),(42235229,526432073,76),(42235229,526432075,77),(42235229,526432076,78),(42235229,526432078,79),(42235229,526432079,80),(42235229,526432081,81),(42235229,526432082,82),(42235229,526432084,83),(42235229,526432085,84),(42235229,526432087,85),(42235229,526432088,86),(42235229,526432089,87),(42235229,526432091,88),(42235229,526432092,89),(42235229,526432096,90),(42235229,526432097,91),(42235229,526432099,92),(42235229,526432100,93),(42235229,526432102,94),(42235229,526432103,95),(42235229,526432105,96),(42235229,526432106,97),(42235229,526432108,98),(42235229,526432109,99),(42235229,526432111,100),(42235229,526432112,101),(42235229,526432114,102),(42235229,526432115,103),(42235229,526432117,104),(42235229,526432118,105),(42235229,526432120,106),(42235229,526432121,107),(42235229,526432122,108),(42235229,526432126,109),(42235229,526432127,110),(42235229,526432129,111),(42235229,526432130,112),(42235229,526432132,113),(42235229,526432133,114),(42235229,526432135,115),(42235229,526432136,116),(42235229,526432137,117),(42235229,526432139,118),(42235229,526432140,119),(42235229,526432142,120),(42235229,526432143,121),(42235229,526432145,122),(42235229,526432146,123),(42235229,526432148,124),(42235229,526432149,125),(42235229,526432151,126),(42235229,526432154,127),(42235229,526432156,128),(42235229,526432157,129),(42235229,526432159,130),(42235229,526432160,131),(42235229,526432162,132),(42235229,526432163,133),(42235229,526432165,134),(42235229,526432166,135),(42235229,526432168,136),(42235229,526432169,137),(42235229,526432171,138),(42235229,526432172,139),(42235229,526432174,140),(42235229,526432175,141),(42235229,526432176,142),(42235229,526432178,143),(42235229,526432179,144),(42235229,526432183,145),(42235229,526432185,146),(42235229,526432186,147),(42235229,526432188,148),(42235229,526432189,149),(42235229,526432190,150),(42235229,526432192,151),(42235229,526432193,152),(42235229,526432195,153),(42235229,526432196,154),(42235229,526432198,155),(42235229,526432199,156),(42235229,526432200,157),(42235229,526432202,158),(42235229,526432203,159),(42235229,526432205,160),(42235229,526432206,161),(42235229,526432208,162),(42235229,526432212,163),(42235229,526432213,164),(42235229,526432214,165),(42235229,526432216,166),(42235229,526432217,167),(42235229,526432219,168),(42235229,526432220,169),(42235229,526432222,170),(42235229,526432223,171),(42235229,526432225,172),(42235229,526432226,173),(42235229,526432228,174),(42235229,526432229,175),(42235229,526432231,176),(42235229,526432232,177),(42235229,526432234,178),(42235229,526432235,179),(42235229,526432237,180),(42235229,526432240,181),(42235229,526432242,182),(42235229,526432243,183),(42235229,526432245,184),(42235229,526432246,185),(42235229,526432248,186),(42235229,526432249,187),(42235229,526432251,188),(42235229,526432252,189),(42235229,526432254,190),(42235229,526432255,191),(42235229,526432257,192),(42235229,526432258,193),(42235229,526432260,194),(42235229,526432261,195),(42235229,526432263,196),(42235229,526432264,197),(42235229,526432266,198),(42235229,526432269,199),(42235229,526432271,200),(42235229,526432272,201),(42235229,526432274,202),(42235229,526432275,203),(42235229,526432277,204),(42235229,526432278,205),(42235229,526432279,206),(42235229,526432281,207),(42235229,526432282,208),(42235229,526432284,209),(42235229,526432286,210),(42235229,526432287,211),(42235229,526432289,212),(42235229,526432290,213),(42235229,526432292,214),(42235229,526432293,215),(42235229,526432295,216),(42235229,526432296,217),(42235229,526432300,218),(42235229,526432302,219),(42235229,526432303,220),(42235229,526432304,221),(42235229,526432306,222),(42235229,526432307,223),(42235229,526432309,224),(42235229,526432311,225),(42235229,526432312,226),(42235229,526432314,227),(42235229,526432315,228),(42235229,526432317,229),(42235229,526432318,230),(42235229,526432320,231),(42235229,526432321,232),(42235229,526432323,233),(42235229,526432324,234),(42235229,526432326,235),(42235229,526432328,236),(42235229,526432329,237),(42235229,526432330,238),(42235229,526432331,239),(42235229,526432332,240),(42235229,526432333,241),(42235229,526432334,242),(42235229,526432335,243),(42235229,526432336,244),(42235229,526432337,245),(42235229,526432338,246),(42235229,526432339,247),(42235229,526432340,248),(42235229,526432341,249),(42235229,526432342,250),(42235229,526432343,251),(42235229,526432344,252),(42235229,526432345,253),(42235229,526432349,254),(42235229,526432350,255),(42235229,526432352,256),(42235229,526432353,257),(42235229,526432355,258),(42235229,526432356,259),(42235229,526432358,260),(42235229,526432359,261),(42235229,526432361,262),(42235229,526432363,263),(42235229,526432364,264),(42235229,526432366,265),(42235229,526432367,266),(42235229,526432369,267),(42235229,526432370,268),(42235229,526432372,269),(42235229,526432373,270),(42235229,526432374,271),(42235229,526432378,272),(42235229,526432380,273),(42235229,526432381,274),(42235229,526432383,275),(42235229,526432384,276),(42235229,526432385,277),(42235229,526432387,278),(42235229,526432389,279),(42235229,526432390,280),(42235229,526432391,281),(42235229,526432393,282),(42235229,526432395,283),(42235229,526432396,284),(42235229,526432398,285),(42235229,526432399,286),(42235229,526432401,287),(42235229,526432402,288),(42235229,526432404,289),(42235229,526432408,290),(42235229,526432409,291),(42235229,526432411,292),(42235229,526432412,293),(42235229,526432414,294),(42235229,526432415,295),(42235229,526432417,296),(42235229,526432418,297),(42235229,526432420,298),(42235229,526432421,299),(42235229,526432423,300),(42235229,526432424,301),(42235229,526432426,302),(42235229,526432427,303),(42235229,526432429,304),(42235229,526432430,305),(42235229,526432432,306),(42235229,526432433,307),(42235229,526432435,308),(42235229,526432438,309),(42235229,526432440,310),(42235229,526432441,311),(42235229,526432443,312),(42235229,526432444,313),(42235229,526432446,314),(42235229,526432447,315),(42235229,526432449,316),(42235229,526432450,317),(42235229,526432452,318),(42235229,526432453,319),(42235229,526432455,320),(42235229,526432456,321),(42235229,526432458,322),(42235229,526432459,323),(42235229,526432461,324),(42235229,526432462,325),(42235229,526432464,326),(42235229,526432467,327),(42235229,526432469,328),(42235229,526432470,329),(42235229,526432472,330),(42235229,526432473,331),(42235229,526432475,332),(42235229,526432476,333),(42235229,526432478,334),(42235229,526432479,335),(42235229,526432481,336),(42235229,526432482,337),(42235229,526432484,338),(42235229,526432485,339),(42235229,526432486,340),(42235229,526432488,341),(42235229,526432489,342),(42235229,526432491,343),(42235229,526432492,344),(42235229,526432496,345),(42235229,526432497,346),(42235229,526432499,347),(42235229,526432500,348),(42235229,526432502,349),(42235229,526432503,350),(42235229,526432505,351),(42235229,526432506,352),(42235229,526432507,353),(42235229,526432509,354),(42235229,526432511,355),(42235229,526432527,356),(42235229,526432529,357),(42235229,526432530,358),(42235229,526432531,359),(42235229,526432532,360),(42235229,526432534,361),(42235229,526432537,362),(42235229,526432538,363),(42235229,526432539,364),(42235229,526432540,365),(42235229,526432541,366),(42235229,526432543,367),(42235229,526432544,368),(42235229,526432546,369),(42235229,526432547,370),(42235229,526432549,371),(42235229,526432550,372),(42235229,526432552,373),(42235229,526432553,374),(42235229,526432555,375),(42235229,526432556,376),(42235229,526432558,377),(42235229,526432559,378),(42235229,526432561,379),(42235229,526432564,380),(42235229,526432566,381),(42235229,526432567,382),(42235229,526432569,383),(42235229,526432570,384),(42235229,526432572,385),(42235229,526432573,386),(42235229,526432575,387),(42235229,526432576,388),(42235229,526432578,389),(42235229,526432579,390),(42235229,526432581,391),(42235229,526432582,392),(42235229,526432584,393),(42235229,526432585,394),(42235229,526432587,395),(42235229,526432588,396),(42235229,526432590,397),(42235229,526432593,398),(42235229,526432595,399),(42235229,526432596,400),(42235229,526432598,401),(42235229,526432600,402),(42235229,526432601,403),(42235229,526432603,404),(42235229,526432604,405),(42235229,526432606,406),(42235229,526432607,407),(42235229,526432609,408),(42235229,526432610,409),(42235229,526432611,410),(42235229,526432613,411),(42235229,526432614,412),(42235229,526432616,413),(42235229,526432618,414),(42235229,526432619,415),(42235229,526432642,416),(42235229,526432643,417),(42235229,526432645,418),(42235229,526432647,419),(42235229,526432648,420),(42235235,526433326,1),(42235235,526433329,2),(42235235,526433330,3),(42235235,526433332,4),(42235235,526433334,5),(42235235,526433335,6),(42235235,526433336,7),(42235235,526433338,8),(42235235,526433339,9),(42235235,526433343,10),(42235235,526433344,11),(42235235,526433351,12),(42235235,526433352,13),(42235235,526433354,14),(42235235,526432069,15),(42235235,526432067,16),(42235235,526432064,17),(42235235,526433355,18),(42235235,526433357,19),(42235235,526433358,20),(42235235,526433360,21),(42235255,526435772,1),(42235255,526435773,2),(42235255,526435775,3),(42235255,526435776,4),(42235255,526435778,5),(42235255,526435779,6),(42235255,526435781,7),(42235255,526435783,8),(42235255,526435784,9),(42235255,526435785,10),(42235255,526435787,11),(42235255,526435788,12),(42235255,526435790,13),(42235255,526435791,14),(42235255,526435793,15),(42235255,526435794,16),(42235255,526435796,17),(42235255,526435798,18),(42235255,526435800,19),(42235255,526435802,20),(42235255,526435808,21),(42235255,526435811,22),(42235255,526435812,23),(42235255,526435815,24),(42235255,526435816,25),(42235255,526435818,26),(42235255,526435820,27),(42235255,526435821,28),(42235255,526435824,29),(42235255,526435826,30),(42235255,526435827,31),(42235255,526435828,32),(42235255,526435830,33),(42235255,526435831,34),(42235255,526435851,35),(42235255,526435853,36),(42235255,526435854,37),(42235255,526435856,38),(42235255,526435858,39),(42235255,526435859,40),(42235255,526435861,41),(42235255,526435862,42),(42235255,526435864,43),(42235255,526435865,44),(42235255,526435867,45),(42235255,526435880,46),(42235255,526435881,47),(42235255,526435883,48),(42235255,526435884,49),(42235255,526435885,50),(42235255,526435887,51),(42235255,526435888,52),(42235255,526435889,53),(42235255,526435891,54),(42235255,526435892,55),(42235255,526435894,56),(42235255,526435895,57),(42235255,526435896,58),(42235255,526435898,59),(42235255,526435899,60),(42235255,526435901,61),(42235255,526435902,62),(42235255,526435903,63),(42235255,526435905,64),(42235255,526435906,65),(42235255,526435907,66),(42235255,526435908,67),(42235255,526435909,68),(42235255,526435910,69),(42235255,526435912,70),(42235255,526435913,71),(42235255,526435914,72),(42235255,526435916,73),(42235255,526435917,74),(42235255,526435918,75),(42235255,526435920,76),(42235255,526435921,77),(42235255,526435923,78),(42235255,526435924,79),(42235255,526435926,80),(42235255,522256224,81),(42235255,522256245,82),(42235255,522256243,83),(42235255,522256242,84),(42235255,526435927,85),(42235255,526435928,86),(42235255,526435930,87),(42235255,526435931,88),(42235255,526435933,89),(42235255,526435934,90),(42235255,526435935,91),(42235255,526435937,92),(42235255,526435953,93),(42235255,526435954,94),(42235255,526435955,95),(42235255,526435956,96),(42235256,526436136,1),(42235256,526436137,2),(42235256,526436139,3),(42235256,526436141,4),(42235256,526436142,5),(42235256,526436144,6),(42235256,526436145,7),(42235256,526436146,8),(42235256,526436148,9),(42235256,526436149,10),(42235256,526436151,11),(42235256,526436152,12),(42235256,526436154,13),(42235256,526436155,14),(42235256,526436157,15),(42235256,526436158,16),(42235256,526436160,17),(42235256,526436161,18),(42235256,526436162,19),(42235256,526436163,20),(42235256,526436164,21),(42235256,526436165,22),(42235256,526436167,23),(42235256,526436168,24),(42235256,526436169,25),(42235256,526436136,26),(42252195,526826196,1),(42252195,526826197,2),(42252195,526826198,3),(42252195,526826199,4),(42252195,526826200,5),(42252243,526827378,1),(42252243,526827379,2),(42252243,526827380,3),(42252243,526827381,4),(42252243,526827382,5),(42252243,526827383,6),(42252243,526827384,7),(42252243,526827385,8),(42252243,526827386,9),(42252243,526827387,10),(42252243,526827388,11),(42252243,526827389,12),(42252243,526827390,13),(42252243,526827391,14),(42252243,526827392,15),(42252243,526827393,16),(42252243,526827394,17),(42252243,526827395,18),(42252243,526827396,19),(42252243,526827397,20),(42252243,526827398,21),(42252243,526827399,22),(42252243,526827400,23),(42252243,526827401,24),(42252243,526827402,25),(42252243,526827403,26),(42252243,526827405,27),(42252243,526827406,28),(42252243,526827407,29),(42252243,526827410,30),(42252243,526827411,31),(42252243,526827412,32),(42252243,526827413,33),(42252243,526827414,34),(42252243,526827415,35),(42252243,526827416,36),(42252243,526827417,37),(42252243,526827418,38),(42252243,526827419,39),(42252243,526827420,40),(42252243,526827421,41),(42252243,526827422,42),(42252243,526827424,43),(42252243,526827425,44),(42252243,526827426,45),(42252243,526827378,46),(42252251,526827410,1),(42252251,526827607,2),(42252251,526827608,3),(42252251,526827609,4),(42252251,526827610,5),(42252251,526827611,6),(42252251,526827612,7),(42252251,526827613,8),(42252251,526827614,9),(42252251,526827615,10),(42252251,526827616,11),(42252251,526827417,12),(42252251,526827416,13),(42252251,526827415,14),(42252251,526827414,15),(42252251,526827413,16),(42252251,526827412,17),(42252251,526827411,18),(42252251,526827410,19),(42252272,526827609,1),(42252272,526828351,2),(42252272,526828352,3),(42252272,526828354,4),(42252272,526828355,5),(42252272,526828356,6),(42252272,526828357,7),(42252272,526828358,8),(42252272,526828359,9),(42252272,526828360,10),(42252272,526828361,11),(42252272,526828362,12),(42252272,526828363,13),(42252272,526828364,14),(42252272,526828365,15),(42252272,526828366,16),(42252272,526828367,17),(42252272,526828368,18),(42252272,526828369,19),(42252272,526828370,20),(42252272,526828371,21),(42252272,526828372,22),(42252272,526828373,23),(42252272,526827615,24),(42252272,526827614,25),(42252272,526827613,26),(42252272,526827612,27),(42252272,526827611,28),(42252272,526827610,29),(42252272,526827609,30),(42252309,526829149,1),(42252309,526829150,2),(42252309,526829151,3),(42252309,526829153,4),(42252309,526829154,5),(42252309,526829155,6),(42252309,526829156,7),(42252309,526829157,8),(42252309,526829158,9),(42252309,526829159,10),(42252309,526829161,11),(42252309,526829168,12),(42252309,526829170,13),(42252309,526829171,14),(42252326,526432193,1),(42252326,526829550,2),(42252326,526829551,3),(42252326,526829552,4),(42252326,526829553,5),(42252326,526829554,6),(42252326,526829555,7),(42252326,526829556,8),(42252326,526829557,9),(42252326,526829559,10),(42252326,526829560,11),(42252326,526829562,12),(42252326,526829563,13),(42252326,519515756,14),(42252326,519515772,15),(42252326,519515771,16),(42252326,526829564,17),(42252326,526829565,18),(42252326,526829566,19),(42252326,526829567,20),(42252326,526829569,21),(42252326,526829570,22),(42252326,526829571,23),(42252326,526829574,24),(42252326,526829575,25),(42252326,526829576,26),(42252326,526829577,27),(42252326,526829578,28),(42252326,526829579,29),(42252326,526829580,30),(42252326,526829581,31),(42252326,526829582,32),(42252326,526829584,33),(42252326,526829585,34),(42252326,526829586,35),(42252326,526829587,36),(42252326,526829589,37),(42252326,526829590,38),(42252326,526829591,39),(42252326,526829592,40),(42252326,526829594,41),(42252326,526829595,42),(42252326,526829596,43),(42252326,526829597,44),(42252326,526829598,45),(42252326,526829599,46),(42252326,526829600,47),(42252326,526829601,48),(42252326,526829603,49),(42252326,526829604,50),(42252326,526432206,51),(42252326,526432205,52),(42252326,526432203,53),(42252326,526432202,54),(42252326,526432200,55),(42252326,526432199,56),(42252326,526432198,57),(42252326,526432196,58),(42252326,526432195,59),(42252326,526432193,60),(42252348,526830271,1),(42252348,526830272,2),(42252348,526830274,3),(42252348,526830275,4),(42252348,526830276,5),(42252348,526830277,6),(42252348,526830278,7),(42252348,526830279,8),(42252348,526830280,9),(42252348,526830281,10),(42252348,526830283,11),(42252348,526830284,12),(42252348,526830285,13),(42252348,526830286,14),(42252348,526830287,15),(42252348,526830288,16),(42252348,526830289,17),(42252348,526830290,18),(42252348,526830291,19),(42252348,526830292,20),(42252348,526830293,21),(42252348,526830294,22),(42252348,526830295,23),(42252348,526830297,24),(42252348,526830298,25),(42252348,526830299,26),(42252348,526830300,27),(42252348,526830301,28),(42252348,526830302,29),(42252348,526830303,30),(42252348,526830304,31),(42252348,526830305,32),(42252348,526830306,33),(42252348,526830307,34),(42252348,526830308,35),(42252348,526830309,36),(42252348,526830310,37),(42252348,526830312,38),(42252348,526830313,39),(42252348,526830314,40),(42252348,526830315,41),(42252348,526830271,42),(42252384,526831529,1),(42252384,526831530,2),(42252384,522254646,3),(42252384,522254645,4),(42252384,522254644,5),(42252384,522254643,6),(42252384,522254642,7),(42252384,522254641,8),(42252384,522254640,9),(42252384,522254639,10),(42252384,522254638,11),(42252384,522254637,12),(42252384,522254636,13),(42252384,526831531,14),(42252384,526831532,15),(42252384,526831533,16),(42252384,526831534,17),(42252384,526831535,18),(42252384,526831536,19),(42252384,526831537,20),(42252384,526831538,21),(42252384,526831539,22),(42252384,526831540,23),(42252384,526831541,24),(42252384,526831542,25),(42252384,526831543,26),(42252384,526831544,27),(42252384,526831545,28),(42252384,526831546,29),(42252384,526831547,30),(42252384,526831548,31),(42252384,526831549,32),(42252384,526831550,33),(42252384,526831551,34),(42252384,526831552,35),(42252384,526831553,36),(42252384,526831529,37),(42451011,266330475,1),(42451011,266329457,2),(42451011,53319484,3),(42451016,266330464,1),(42451016,266330465,2),(42451016,266330466,3),(42451016,266330467,4),(42451016,266330468,5),(42451016,266330469,6),(42451016,266330470,7),(42451016,266330471,8),(42451016,266330472,9),(42451016,266330473,10),(42451016,266330475,11),(42451892,266330483,1),(42451892,529948761,2),(42451892,529948762,3),(42451892,529948763,4),(42451892,529948764,5),(42451892,529948765,6),(42809904,529948765,1),(42809904,529948766,2),(42810813,51415013,1),(42810813,51367769,2),(42810813,51367770,3),(42810813,51367772,4),(42810813,51367774,5),(42810813,51367776,6),(42810813,51367779,7),(42810813,51367783,8),(42810813,51367785,9),(42810813,51367787,10),(42810813,51367788,11),(42810813,270724742,12),(42810813,51367806,13),(42811127,535387283,1),(42811127,51415013,2),(42811127,535387288,3),(42811127,535387292,4),(42811127,535387294,5),(42811127,535386385,6),(42811127,535387296,7),(42811127,535385847,8),(42811127,535387283,9),(45511076,579974233,1),(45511076,579974236,2),(45511076,579974239,3),(45511076,579974243,4),(45511076,579974248,5),(45511076,579974253,6),(45511076,579974258,7),(45511076,579974267,8),(45511076,579974272,9),(45511076,579974276,10),(45511076,579974280,11),(45511076,579974361,12),(45511076,579972081,13),(45511076,579972127,14),(45511076,579972135,15),(45511076,579972136,16),(45511076,579972138,17),(45511076,579972142,18),(45511076,579972040,19),(45511076,579972062,20),(45511076,579971967,21),(45511076,579971988,22),(45511076,579971916,23),(45511076,579971917,24),(45511076,579971921,25),(45511076,579971959,26),(45511076,579971887,27),(45511076,579971891,28),(45511076,579971895,29),(45511076,579971896,30),(45511076,579971897,31),(45511076,579971898,32),(45511076,579971902,33),(45511076,579971909,34),(45511076,579971802,35),(45511076,579971757,36),(45511076,579971697,37),(45511076,579971713,38),(45511076,579971721,39),(45511076,579971414,40),(45511076,579971423,41),(45511076,579971445,42),(45511076,579971453,43),(45511076,579971472,44),(45511076,579971480,45),(45511076,579971484,46),(45511076,579971485,47),(45511076,579971493,48),(45511076,579971494,49),(45511076,579971492,50),(45511076,579972190,51),(45511076,579972196,52),(45511076,579972201,53),(45511076,579972206,54),(45511076,579972215,55),(45511076,579972234,56),(45511076,579972248,57),(45511076,579972256,58),(45511076,579972263,59),(45511076,579972270,60),(45511076,579972277,61),(45511076,579972294,62),(45511076,579972301,63),(45511076,579972312,64),(45511076,579972313,65),(45511076,579972314,66),(45511076,579972316,67),(45511076,579972323,68),(45511076,579972329,69),(45511076,579972335,70),(45511076,579972342,71),(45511076,579972344,72),(45511076,579972264,73),(45511076,579972345,74),(45511076,579972349,75),(45511084,579974346,1),(45511084,579974336,2),(45511084,579974311,3),(45511084,579974316,4),(45511084,579974321,5),(45511084,579974288,6),(45511084,579974296,7),(45511084,579974298,8),(45511084,579974308,9),(45511084,579974284,10),(45511084,579974160,11),(45511084,579974175,12),(45511084,579974193,13),(45511084,579974203,14),(45511084,579974208,15),(45511084,579974213,16),(45511090,579972407,1),(45511090,579972412,2),(45511090,579972420,3),(45511090,579972426,4),(45511090,579972437,5),(45511090,579972439,6),(45511090,579972444,7),(45511090,579972446,8),(45511090,579972453,9),(45511090,579972459,10),(45511090,579972466,11),(45511090,579972473,12),(45511090,579972478,13),(45511090,579972488,14),(45511090,579972496,15),(45511090,579972502,16),(45511090,579972508,17),(45511090,579972515,18),(45511090,579972533,19),(45511090,579972520,20),(45511090,579972522,21),(45511090,579972524,22),(45511090,579972528,23),(45511090,579972529,24),(45511090,579972530,25),(45511090,579972540,26),(45511090,579972544,27),(45511090,579972545,28),(45511090,579972546,29),(45511090,579972547,30),(45511090,579972553,31),(45511090,579972562,32),(45511090,579972575,33),(45511090,579972579,34),(45511090,579972589,35),(45511090,579972599,36),(45511090,579972612,37),(45511090,579972640,38),(45511090,579972651,39),(45511090,579972662,40),(45511090,579972678,41),(45511090,579972691,42),(45511090,579972712,43),(45511090,579972748,44),(45511090,579972759,45),(45511090,579972893,46),(45511090,579972911,47),(45511090,579972934,48),(45511090,579973009,49),(45511090,579973010,50),(45511090,579973012,51),(45511090,579973015,52),(45511090,579973018,53),(45511090,579973019,54),(45511090,579973021,55),(45511090,579973023,56),(45511090,579973025,57),(45511090,579973026,58),(45511090,579973027,59),(45511090,579973028,60),(45511090,579973029,61),(45511090,579973030,62),(45511090,579973031,63),(45511090,579973032,64),(45511090,579973033,65),(45511090,579973034,66),(45511090,579973454,67),(45511090,579973464,68),(45511090,579973477,69),(48271354,613344821,1),(48271354,613344822,2),(48271355,613344823,1),(48271355,613345211,2),(48271355,613344824,3),(48271356,613344825,1),(48271356,613344826,2),(48271356,613344827,3),(48928224,664598450,1),(48928224,664598768,2),(48928224,664598769,3),(48928224,664598771,4),(48928224,664598770,5),(48928224,664598774,6),(48928224,620937058,7),(48928224,664598772,8),(48928224,664598773,9),(48928224,620937061,10),(48928224,620937063,11),(48928224,620937064,12),(48928224,620937151,13),(48928224,620937156,14),(48928225,664598410,1),(48928225,664598411,2),(48928225,664598412,3),(48928225,664598432,4),(48928225,664598433,5),(48928225,664598434,6),(48928225,664598435,7),(48928225,664598428,8),(48928225,664598429,9),(48928225,664598430,10),(48928225,664598436,11),(48928225,664598437,12),(48928225,664598442,13),(48928225,664598443,14),(48928225,664598444,15),(48928225,664598445,16),(48928225,664598446,17),(48928225,664598461,18),(48928225,664598460,19),(48928225,664598462,20),(48928225,664598463,21),(48928225,664598464,22),(48928225,664598465,23),(48928225,664598466,24),(48928225,664598467,25),(48928225,664598468,26),(48928225,664598469,27),(48928225,664598861,28),(48928225,664598863,29),(48928225,664598864,30),(48928225,664598873,31),(48928225,664598874,32),(48928225,664598878,33),(48928225,664598879,34),(48928225,664598875,35),(48928225,664598876,36),(48928225,664598865,37),(48928225,664598866,38),(48928225,664598867,39),(48928225,664598880,40),(48928225,664598881,41),(48928225,664598882,42),(48928225,664598883,43),(48928225,664598884,44),(48928225,664598885,45),(48928225,664598886,46),(48928225,664598890,47),(48928225,620937182,48),(48928225,620937183,49),(48928225,620937185,50),(48928225,620937186,51),(48928225,664598895,52),(48928225,664598896,53),(48928225,664598891,54),(48928225,620937195,55),(48928225,620937196,56),(48928225,620937198,57),(48928225,620937114,58),(48928225,620937122,59),(48928225,620937124,60),(48928225,621166567,61),(48928225,620937120,62),(48928225,620937125,63),(48928225,620937127,64),(48928225,664560293,65),(48928225,620937130,66),(48928225,620937132,67),(48928225,620937136,68),(48928225,620937138,69),(48928225,664560295,70),(48928225,664560296,71),(48928225,664560297,72),(48928225,664560298,73),(48928225,664560299,74),(48928225,664560300,75),(48928225,664560301,76),(48928225,664560302,77),(48928225,664560303,78),(48928225,664560311,79),(48928225,664560310,80),(48928226,620937187,1),(48928226,664598877,2),(48928226,664598889,3),(48928226,664598888,4),(48928226,664598887,5),(48928226,664598894,6),(48928226,664598892,7),(48928226,620937188,8),(48928226,664598893,9),(48928226,620937199,10),(48928226,620937201,11),(48928226,620937203,12),(48928226,620937189,13),(48928226,620937190,14),(48928226,620937191,15),(48928226,620937192,16),(48928226,620937193,17),(48928226,620937204,18),(48928226,620937206,19),(48928226,620937211,20),(48928226,620937212,21),(48928226,620937214,22),(48928226,620937216,23),(48928226,620937143,24),(48928226,620937144,25),(48928226,620937149,26),(48928227,620937181,1),(48928227,620937040,2),(48928228,620937047,1),(48928228,620937044,2),(48928229,620937046,1),(48928229,620937036,2),(48928230,620937041,1),(48928230,620937034,2),(48928231,620937043,1),(48928231,620937038,2),(48928232,620937139,1),(48928232,620937072,2),(48928233,620937076,1),(48928233,620937078,2),(48928233,620937079,3),(48928233,620937081,4),(48928233,620937082,5),(48928233,620937084,6),(48928233,620937086,7),(48928233,620937087,8),(48928233,664560284,9),(48928233,620937092,10),(48928233,664560285,11),(48928233,620937097,12),(48928233,620937099,13),(48928233,620937100,14),(48928233,620937116,15),(48928233,620937117,16),(48928233,620937119,17),(48928233,620937135,18),(48928233,620937141,19),(48928233,620937146,20),(48928234,620937133,1),(48928234,620937049,2),(48928234,620937051,3),(48928234,620937056,4),(48928235,620937081,1),(48928235,620937089,2),(48928235,620937091,3),(48928235,620937094,4),(48928235,620937095,5),(48928235,620937102,6),(48928235,664560286,7),(48928235,620937108,8),(48928235,620937109,9),(48928235,620937111,10),(48928235,620937113,11),(48928235,664560290,12),(48928235,664560289,13),(48928235,664560288,14),(48928235,664560287,15),(48928235,664560292,16),(48928235,664560291,17),(48928235,664560306,18),(48928235,664560305,19),(48928235,664560304,20),(48928235,664560309,21),(48928235,664560308,22),(48928235,664560307,23),(48928236,620937066,1),(48928236,620937068,2),(48928236,620937069,3),(48928236,620937071,4),(48957244,621165050,1),(48957244,621165051,2),(48957244,621165052,3),(48957244,621165040,4),(48957244,621165041,5),(48957244,621165042,6),(48957244,621165043,7),(48957244,621165044,8),(48957244,621165045,9),(48957244,621165046,10),(48957244,621165047,11),(48957244,621165048,12),(48957244,621165053,13),(48957244,621165054,14),(48957244,621165055,15),(48957244,621165056,16),(48957244,621165057,17),(48957244,621164974,18),(48957244,621164975,19),(48957244,621164976,20),(48957244,621164977,21),(48957244,621164978,22),(48957244,621164979,23),(48957244,621164980,24),(48957244,621164981,25),(48957244,621164982,26),(48957245,621165003,1),(48957245,621165004,2),(48957245,621165005,3),(48957245,621165006,4),(48957245,621165061,5),(48957245,621165062,6),(48957245,621165063,7),(48957245,621165064,8),(48957245,621165065,9),(48957245,621165066,10),(48957245,621165069,11),(48957245,664560369,12),(48957245,621165070,13),(48957245,621165071,14),(48957246,621164973,1),(48957246,621165001,2),(48957247,621165018,1),(48957247,621165002,2),(48957248,621165019,1),(48957248,621165010,2),(48957249,621165020,1),(48957249,621165030,2),(48957250,621165007,1),(48957250,621165008,2),(48957250,621165009,3),(48957250,621164991,4),(48957250,621164992,5),(48957250,621164993,6),(48957250,621164994,7),(48957250,621164995,8),(48957250,621164996,9),(48957250,621164997,10),(48957250,621164983,11),(48957250,621164984,12),(48957250,621164985,13),(48957250,621164986,14),(48957250,621164987,15),(48957250,621164988,16),(48957250,621164989,17),(48957250,621164990,18),(48957250,621164998,19),(48957250,621164963,20),(48957250,621164964,21),(48957250,621164965,22),(48957250,621164966,23),(48957250,621164967,24),(48957250,621164968,25),(48957250,621164969,26),(48957250,621164970,27),(48957250,621164971,28),(48957250,621164972,29),(48957250,621164999,30),(48957251,621164999,1),(48957251,621165000,2),(48957252,621165022,1),(48957252,621165021,2),(48957253,621165000,1),(48957253,621165022,2),(48957254,621165031,1),(48957254,621165032,2),(48957254,621165033,3),(48957254,621165034,4),(48957254,621165035,5),(48957254,621165036,6),(48957254,621165037,7),(48957254,621165038,8),(48957254,621165039,9),(48957254,621165016,10),(48957254,621165011,11),(48957254,621165012,12),(48957254,621165013,13),(48957254,621165014,14),(48957254,621165015,15),(48957254,621165026,16),(48957254,621165023,17),(48957254,621165024,18),(48957255,621165016,1),(48957255,621165017,2),(48957255,621165027,3),(48957255,621165028,4),(48957255,621165029,5),(48957255,621165025,6),(48957256,621165067,1),(48957256,621165058,2),(48957257,621165068,1),(48957257,621165049,2),(48957258,621165059,1),(48957258,621165060,2),(48969498,621413194,1),(48969498,621413197,2),(48969498,664605757,3),(48969498,621413198,4),(48969498,664605762,5),(48969498,664605760,6),(48969498,621413199,7),(48969498,621413200,8),(48969498,664605761,9),(48969498,621413201,10),(48969498,621413202,11),(48969498,664605759,12),(48969498,664559879,13),(48969498,621413203,14),(48969498,621413204,15),(48969498,664559865,16),(48969498,621413211,17),(48969498,621413212,18),(48969498,664559921,19),(48969498,664605764,20),(48969498,664559931,21),(48969498,621413213,22),(48969498,664559933,23),(48969498,664559943,24),(48969498,664559945,25),(48969498,664559959,26),(48969498,664605770,27),(48969498,621413210,28),(48969498,664560276,29),(48969498,664605893,30),(48969498,664560277,31),(48969498,664560278,32),(48969498,664560279,33),(48969498,664560274,34),(48969498,664560275,35),(48969498,664560282,36),(48969498,664560283,37),(48969498,621413223,38),(48969499,621413214,1),(48969499,621413215,2),(48969499,621413216,3),(48969499,621413217,4),(48969499,621413218,5),(48969499,621413219,6),(48969499,664560077,7),(48969499,664560078,8),(48969499,664560079,9),(48969499,664560080,10),(48969499,664560101,11),(48969499,621413220,12),(48969499,664560116,13),(48969499,621413221,14),(48969499,664560187,15),(48969499,621413222,16),(48969499,621413205,17),(48969499,621413206,18),(48969499,621413207,19),(48969499,621413208,20),(48969499,621413209,21),(48969499,664559961,22),(48969499,621413210,23),(48979047,621467570,1),(48979047,664598766,2),(48979047,664598767,3),(48979047,621467571,4),(48979047,664598470,5),(48979047,621467603,6),(48979047,621467612,7),(48979050,621467424,1),(48979050,621467427,2),(48979050,621467428,3),(48979050,621467429,4),(48979050,621467436,5),(48979050,621467437,6),(48979050,621467438,7),(48979050,621467439,8),(48979050,621467441,9),(48979050,621467442,10),(48979050,621467443,11),(48979050,621467444,12),(48979050,621467445,13),(48979050,621467446,14),(48979050,621467586,15),(48979050,621467587,16),(48979050,621467589,17),(48979050,621467590,18),(48979051,621467416,1),(48979051,664560020,2),(48979051,664560054,3),(48979051,664560021,4),(48979051,664560022,5),(48979051,664560023,6),(48979051,664560025,7),(48979051,621467417,8),(48979051,664560055,9),(48979051,621467592,10),(48979051,621467593,11),(48979052,621467416,1),(48979052,621467419,2),(48979052,621467420,3),(48979052,664560024,4),(48979052,621467421,5),(48979052,621467582,6),(48979052,621467598,7),(48979052,621467593,8),(48979052,621467595,9),(48979052,621467590,10),(48979052,621467596,11),(48979052,621467599,12),(48979052,664560371,13),(48979052,664560372,14),(48979052,664560373,15),(48979052,664560381,16),(48979052,664560382,17),(48979052,664560380,18),(48979055,621467468,1),(48979055,621467469,2),(48979055,621467470,3),(48979055,621467471,4),(48979055,621467472,5),(48979055,621467473,6),(48979055,621467519,7),(48979055,621467520,8),(48979055,621467521,9),(48979055,621467522,10),(48979055,621467523,11),(48979055,621467524,12),(48979055,621467526,13),(48979055,621467527,14),(48979055,621467529,15),(48979055,621467530,16),(48979055,621467531,17),(48979056,621467463,1),(48979056,621467464,2),(48979056,664560199,3),(48979056,621467492,4),(48979056,621467482,5),(48979056,664560230,6),(48979056,621467483,7),(48979056,621467484,8),(48979056,621467485,9),(48979056,621467481,10),(48979056,621467486,11),(48979056,621467487,12),(48979056,621467488,13),(48979056,621467502,14),(48979056,621467503,15),(48979056,621467504,16),(48979056,621467505,17),(48979056,621467506,18),(48979056,621467507,19),(48979056,621467600,20),(48979056,621467601,21),(48979056,621467615,22),(48979056,664598858,23),(48979056,664598860,24),(48979057,621467411,1),(48979057,621467412,2),(48979057,621467422,3),(48979057,621467423,4),(48979057,664560026,5),(48979057,621467424,6),(48979058,621165050,1),(48979058,621467413,2),(48979058,621467414,3),(48979058,621467415,4),(48979058,621467425,5),(48979058,621467426,6),(48979058,621467424,7),(48979058,621467430,8),(48979058,664560039,9),(48979058,621467416,10),(48979059,664598401,1),(48979059,621467452,2),(48979059,621467453,3),(48979059,621467454,4),(48979059,621467455,5),(48979059,621467456,6),(48979059,621467477,7),(48979059,621467478,8),(48979059,621467479,9),(48979059,621467480,10),(48979059,621467490,11),(48979059,664560241,12),(48979060,621467422,1),(48979060,621467431,2),(48979060,621467432,3),(48979060,621467433,4),(48979060,621467434,5),(48979060,621467435,6),(48979060,621467450,7),(48979060,621467451,8),(48979060,621467474,9),(48979060,621467475,10),(48979060,621467476,11),(48979060,621467489,12),(48979060,621467490,13),(48979062,621413194,1),(48979062,621467407,2),(48979062,621467409,3),(48979062,621467447,4),(48979062,621467448,5),(48979062,664605825,6),(48979062,664605826,7),(48979062,664605827,8),(48979062,621467449,9),(48979062,621453850,10),(48979062,621467457,11),(48979062,664560197,12),(48979062,664605851,13),(48979062,664605853,14),(48979062,664605854,15),(48979062,621467461,16),(48979062,621467462,17),(48979062,664605855,18),(48979062,664560200,19),(48979062,664598407,20),(48979062,664598408,21),(48979062,664598409,22),(48979062,664598431,23),(48979062,621467491,24),(48979062,621467493,25),(48979062,621467494,26),(48979062,621467495,27),(48979062,621467496,28),(48979062,621467497,29),(48979062,621467508,30),(48979062,621467509,31),(48979062,621467510,32),(48979062,621467499,33),(48979062,621467501,34),(48979062,621467563,35),(48979062,621467565,36),(48979062,621467566,37),(48979062,621467568,38),(48979062,621467569,39),(48979062,620937059,40),(48979062,664598745,41),(48979062,664598746,42),(48979062,664598717,43),(48979062,664598725,44),(48979062,664598718,45),(48979062,664598719,46),(48979062,664598720,47),(48979062,664598721,48),(48979062,664598722,49),(48979062,664598723,50),(48979062,664598724,51),(48979062,664598708,52),(48979062,664598709,53),(48979062,664598710,54),(48979062,664598711,55),(48979062,664598712,56),(48979062,664598726,57),(48979062,664598727,58),(48979062,664598728,59),(48979062,664598729,60),(48979062,664598730,61),(48979062,664598731,62),(48979062,664598732,63),(48979062,664598733,64),(48979062,664598582,65),(48979062,664598600,66),(48979062,664598601,67),(48979062,664598602,68),(48979062,621467513,69),(48979062,621467540,70),(48979062,664598734,71),(48979062,621467541,72),(48979062,621467543,73),(48979062,621467544,74),(48979062,621467545,75),(48979062,621467546,76),(48979062,621467547,77),(48979062,621467549,78),(48979062,621467550,79),(48979062,621467552,80),(48979062,621467554,81),(48979062,621467555,82),(48979062,621467557,83),(48979062,621467558,84),(48979062,621467559,85),(48979062,621467560,86),(48979062,621467572,87),(48979062,621467573,88),(48979062,664598785,89),(48979062,621467574,90),(48979062,621467575,91),(48979062,621467576,92),(48979062,621467577,93),(48979062,621473083,94),(48979062,664560294,95),(48979062,664598837,96),(48979062,664598846,97),(48979062,664598848,98),(48979062,664598850,99),(48979062,664598852,100),(48979062,664598854,101),(48979062,664598855,102),(48979062,664598857,103),(48979062,664598849,104),(48979062,664598838,105),(48979062,664598840,106),(48979062,664598842,107),(48979062,664598823,108),(48979062,664598824,109),(48979062,664598825,110),(48979062,664598826,111),(48979062,664598828,112),(48979062,664598829,113),(48979062,664598818,114),(48979062,664598819,115),(48979062,664598820,116),(48979062,664598821,117),(48979062,664598822,118),(48979062,664598811,119),(48979062,664598812,120),(48979062,664598813,121),(48979062,664598835,122),(48979063,621467561,1),(48979063,621467562,2),(48979063,620937076,3),(50568365,643575502,1),(50568365,643575498,2),(50568365,643575500,3),(50568365,643575190,4),(50568365,643575192,5),(50568365,643575187,6),(50568365,643575186,7),(50568365,643575167,8),(50568365,643575169,9),(50568365,643575181,10),(50568365,643575184,11),(50568365,643575180,12),(50568365,643575177,13),(50568365,643575176,14),(50568365,643575179,15),(50568365,643575178,16),(50568365,643575173,17),(50568365,643575171,18),(50568365,643575174,19),(50568365,643575165,20),(50568365,643575159,21),(50568365,643575156,22),(50568365,643575163,23),(50568365,643575160,24),(50568365,643575150,25),(50568365,643575147,26),(50568365,643575154,27),(50568365,643575152,28),(50568365,643575120,29),(50568365,643575122,30),(50568365,643575124,31),(50568365,643575126,32),(50568365,643575118,33),(50568365,643575134,34),(50568365,643575135,35),(50568365,643575138,36),(50568365,643575127,37),(50568365,643575129,38),(50568365,643575131,39),(50568365,643575204,40),(50568365,643575203,41),(50568365,643575196,42),(50568365,643575199,43),(50568365,643575200,44),(50568365,643575096,45),(50568365,643575092,46),(50568365,643575094,47),(50568365,643575061,48),(50568365,643575062,49),(50568365,643575063,50),(50568365,643575065,51),(50568365,643575075,52),(50568365,643575077,53),(50568365,643575080,54),(50568365,643575074,55),(50568365,643575066,56),(50568365,643575069,57),(50568365,643575071,58),(50568365,643575042,59),(50568365,643575040,60),(50568365,643575035,61),(50568365,643575043,62),(50568365,643575025,63),(50568365,643575023,64),(50568365,643575021,65),(50568365,643575026,66),(50568365,643575031,67),(50568365,643575030,68),(50568365,643575029,69),(50568365,643575034,70),(50568365,643575032,71),(50568365,643575028,72),(50568365,643575027,73),(50568366,643575264,1),(50734991,366076279,1),(50734991,366076706,2),(50734991,366076707,3),(50734991,366076708,4),(50734991,366076709,5),(50734991,366076710,6),(50734991,366076711,7),(50734991,366076712,8),(50734991,366076713,9),(50734991,366076714,10),(50734991,366076715,11),(50734991,366076716,12),(50734991,366076717,13),(50734991,366076718,14),(50734991,366076719,15),(50734991,366076720,16),(50734991,366076721,17),(50734991,366076722,18),(50734991,366076723,19),(50734991,52206691,20),(52008425,663075946,1),(52008425,663075945,2),(52008767,663078911,1),(52008767,663078912,2),(52009081,663080313,1),(52009081,663080312,2),(52009565,663084328,1),(52009565,663084327,2),(52010630,663092389,1),(52010630,663092390,2),(52010729,663093430,1),(52010729,663093429,2),(52010876,663095052,1),(52035289,663339199,1),(52035289,663339197,2),(52036011,663345421,1),(52036011,663345420,2),(52038527,663372540,1),(52038527,663372539,2),(52038627,663373402,1),(52038627,664236928,2),(52038627,664236926,3),(52038627,664236927,4),(52038627,664236925,5),(52038627,664236924,6),(52038627,663373401,7),(52083535,663802645,1),(52083535,663802644,2),(52083655,663803594,1),(52083655,663803593,2),(52084359,663810390,1),(52084359,663810391,2),(52084359,663810387,3),(52084359,663810389,4),(52084359,663810393,5),(52084359,663810392,6),(52084359,663810394,7),(52084359,668901629,8),(52084359,668901909,9),(52084359,663810395,10),(52084359,668901951,11),(52084359,668901968,12),(52084359,668901972,13),(52084359,663810396,14),(52098923,663952666,1),(52098923,663952667,2),(52099062,663953551,1),(52099062,663953552,2),(52099062,663953553,3),(52099251,663955434,1),(52099251,668901847,2),(52099251,668901848,3),(52099251,668901849,4),(52099251,663955435,5),(52099251,663955433,6),(52099251,663955443,7),(52099251,663955446,8),(52099251,663955445,9),(52099251,663955444,10),(52099251,663955447,11),(52099251,663955466,12),(52099251,663955464,13),(52099251,663955463,14),(52099251,663955465,15),(52099251,663955462,16),(52099251,663955459,17),(52099251,663955441,18),(52099251,663955442,19),(52099251,663955440,20),(52099251,663955438,21),(52099251,663955436,22),(52099251,663955437,23),(52099251,663955439,24),(52099251,663955456,25),(52099251,663955460,26),(52099251,663955461,27),(52099251,663955458,28),(52099251,663955457,29),(52099251,663955450,30),(52099251,663955449,31),(52099251,663955448,32),(52099251,663955451,33),(52099251,663955453,34),(52099251,663955452,35),(52099251,663955454,36),(52099251,663955455,37),(52099335,663956152,1),(52099335,663956153,2),(52099335,663956154,3),(52099335,663956155,4),(52099335,663956167,5),(52099335,663956156,6),(52099335,663956157,7),(52099335,663956158,8),(52099335,663956159,9),(52099335,663956160,10),(52099335,663956161,11),(52099335,663956162,12),(52099335,663956163,13),(52099335,663956164,14),(52099335,663956166,15),(52099335,663956165,16),(52099335,663956168,17),(52099335,663956169,18),(52099335,663956170,19),(52099379,663956738,1),(52099379,663956739,2),(52099379,663956740,3),(52099379,663956742,4),(52099379,663956743,5),(52099379,663956744,6),(52099379,663956745,7),(52099379,663956746,8),(52099379,663956747,9),(52099379,663956748,10),(52099379,663956749,11),(52099379,663956750,12),(52099379,663956751,13),(52099379,663956753,14),(52099379,663956752,15),(52099379,663956754,16),(52099379,663956755,17),(52099379,663956756,18),(52099485,663957562,1),(52099485,668901395,2),(52099485,668901396,3),(52099485,668901397,4),(52099485,668901398,5),(52099485,668901399,6),(52099485,668901400,7),(52099485,668901401,8),(52099485,668901402,9),(52099485,668901403,10),(52099485,668901404,11),(52099485,668901405,12),(52099485,668901441,13),(52099485,668901442,14),(52099485,668901443,15),(52099485,668901444,16),(52099485,668901445,17),(52099485,668901446,18),(52099485,668901447,19),(52099485,663957559,20),(52110420,664061747,1),(52110420,664061744,2),(52110421,664061748,1),(52110421,664061746,2),(52112644,664085286,1),(52112644,664085290,2),(52112644,664085291,3),(52112644,664085292,4),(52112644,664085297,5),(52112644,664085298,6),(52112644,664085308,7),(52112644,664085309,8),(52112644,664085310,9),(52112644,664085311,10),(52112644,664085276,11),(52112644,664085277,12),(52112644,664085278,13),(52112644,664085279,14),(52112645,664085287,1),(52112645,664085293,2),(52112645,664085294,3),(52112645,664085296,4),(52112645,664085299,5),(52112645,664085275,6),(52112645,664085280,7),(52112645,664085281,8),(52112645,664085282,9),(52112646,664085283,1),(52112646,664085288,2),(52112647,664085390,1),(52112647,664085392,2),(52112647,664085375,3),(52112647,664085376,4),(52112647,664085380,5),(52112647,664085368,6),(52112647,664085369,7),(52112647,664085371,8),(52112647,664085372,9),(52112648,664085382,1),(52112648,664085383,2),(52112648,664085384,3),(52112648,664085385,4),(52112648,664085386,5),(52112648,664085387,6),(52112648,664085388,7),(52112648,664085389,8),(52112648,664085393,9),(52112649,664085381,1),(52112649,664085345,2),(52112649,664085346,3),(52112649,664085377,4),(52112649,664085379,5),(52112649,664085365,6),(52112649,664085367,7),(52112649,664085373,8),(52112650,664085344,1),(52112650,664085348,2),(52112650,664085354,3),(52112650,664085339,4),(52112650,664085340,5),(52112650,664085341,6),(52112650,664085342,7),(52112650,664085324,8),(52112650,664085325,9),(52112650,664085326,10),(52112650,664085327,11),(52112650,664085316,12),(52112650,664085317,13),(52112650,664085318,14),(52112650,664085319,15),(52112650,664085320,16),(52112650,664085328,17),(52112650,664085329,18),(52112650,664085330,19),(52112650,664085334,20),(52112650,664085358,21),(52112650,664085360,22),(52112650,664085364,23),(52112651,664085284,1),(52112651,664085285,2),(52112651,664085289,3),(52112651,664085300,4),(52112651,664085301,5),(52112651,664085302,6),(52112651,664085303,7),(52112651,664085307,8),(52112651,664085323,9),(52112651,664085335,10),(52112651,664085336,11),(52112651,664085337,12),(52112651,664085338,13),(52112651,664085355,14),(52112651,664085357,15),(52112651,664085361,16),(52112651,664085362,17),(52112652,664085304,1),(52112652,664085305,2),(52112652,664085306,3),(52112652,664085312,4),(52112652,664085313,5),(52112652,664085314,6),(52112652,664085315,7),(52112652,664085321,8),(52112652,664085322,9),(52112652,664085331,10),(52112652,664085332,11),(52112652,664085333,12),(52114934,664115832,1),(52114934,664116115,2),(52114934,664116116,3),(52114934,664116117,4),(52114934,664116118,5),(52114934,664116119,6),(52114934,664116120,7),(52114934,664116121,8),(52114934,664116122,9),(52114934,664116125,10),(52114934,664116126,11),(52114934,664116127,12),(52114935,664115833,1),(52114935,664115834,2),(52114935,664115835,3),(52114935,664115836,4),(52114935,664116093,5),(52114935,664116094,6),(52114935,664116095,7),(52114935,664116096,8),(52114935,664116097,9),(52114935,664116098,10),(52114935,664116099,11),(52114935,664116100,12),(52114935,664116103,13),(52114935,664116104,14),(52114935,664116105,15),(52114935,664116106,16),(52114935,664116130,17),(52114935,664116131,18),(52114935,664116132,19),(52114935,664116133,20),(52114935,664116134,21),(52114935,664116139,22),(52114935,664116140,23),(52114935,664116144,24),(52114935,664116145,25),(52114935,664116146,26),(52114935,664116147,27),(52114935,664116148,28),(52114935,664116149,29),(52114935,664116160,30),(52114936,664115822,1),(52114936,664115823,2),(52114936,664115824,3),(52114936,664115825,4),(52114936,664115826,5),(52114936,664115827,6);
INSERT INTO `current_way_nodes` VALUES (52114936,664115828,7),(52114936,664115829,8),(52114936,664115830,9),(52114936,664115831,10),(52114936,664115837,11),(52114936,664116109,12),(52114936,664116110,13),(52114936,664116111,14),(52114936,664116112,15),(52114936,664116113,16),(52114936,664116114,17),(52114936,664116123,18),(52114936,664116124,19),(52114936,664116128,20),(52114936,664116129,21),(52114936,664116150,22),(52114936,664116151,23),(52114936,664116152,24),(52114936,664116153,25),(52114936,664116154,26),(52114936,664116155,27),(52114936,664116156,28),(52114936,664116157,29),(52114936,664116158,30),(52114936,664116159,31),(52114936,664116141,32),(52114936,664116142,33),(52114936,664116143,34),(52114936,664116136,35),(52114936,664116137,36),(52114936,664116138,37),(52114936,664116135,38),(52114936,664116066,39),(52114936,664116067,40),(52114936,664116068,41),(52114936,664116069,42),(52114936,664116058,43),(52114936,664116080,44),(52114936,664116081,45),(52114936,664116082,46),(52114936,664116083,47),(52114936,664116084,48),(52114936,664116090,49),(52114937,664116020,1),(52114937,664116018,2),(52114937,664116019,3),(52114937,664115917,4),(52114937,664115918,5),(52114937,664115919,6),(52114937,664115920,7),(52114937,664115905,8),(52114937,664115938,9),(52114937,664115940,10),(52114937,664115941,11),(52114937,664115943,12),(52114937,664115945,13),(52114937,664115947,14),(52114937,664115927,15),(52114937,664115928,16),(52114937,664115929,17),(52114937,664115933,18),(52114937,664115935,19),(52114937,664115936,20),(52114937,664115957,21),(52114937,664115958,22),(52114937,664115960,23),(52114937,664115961,24),(52114937,664115965,25),(52114937,664115966,26),(52114937,664115967,27),(52114937,664115968,28),(52114937,664115970,29),(52114937,664115971,30),(52114937,664115878,31),(52114937,664115879,32),(52114937,664115880,33),(52114937,664115881,34),(52114937,664115882,35),(52114937,664115883,36),(52114937,664115973,37),(52114937,664115974,38),(52114937,664115976,39),(52114937,664116008,40),(52114937,664116009,41),(52114937,664116011,42),(52114937,664116012,43),(52114938,664115765,1),(52114938,664115766,2),(52114938,664115767,3),(52114938,664115844,4),(52114938,664115845,5),(52114938,664115846,6),(52114938,664115847,7),(52114938,664115848,8),(52114938,664115849,9),(52114938,664115850,10),(52114938,664115853,11),(52114938,664115854,12),(52114938,664115855,13),(52114938,664115863,14),(52114938,664115864,15),(52114938,664115865,16),(52114938,664115866,17),(52114938,664115872,18),(52114938,664115873,19),(52114938,664115874,20),(52114938,664115909,21),(52114938,664115910,22),(52114938,664115930,23),(52114938,664115931,24),(52114938,664115955,25),(52114939,664115932,1),(52114940,664115763,1),(52114940,664115800,2),(52114940,664115804,3),(52114940,664115805,4),(52114940,664115806,5),(52114940,664115807,6),(52114942,664115810,1),(52114943,664115756,1),(52114943,664115768,2),(52114943,664115770,3),(52114943,664115769,4),(52114943,664115773,5),(52114943,664115772,6),(52114943,664115777,7),(52114943,664115776,8),(52114943,664115775,9),(52114943,664115774,10),(52114943,664115781,11),(52114943,664115780,12),(52114943,664115779,13),(52114943,664115778,14),(52114943,664115771,15),(52114943,664115869,16),(52114943,367682694,17),(52114943,664115894,18),(52114943,664115899,19),(52114943,664115900,20),(52114944,664115789,1),(52114944,664115790,2),(52114944,664115791,3),(52114944,664115817,4),(52114944,664115818,5),(52114944,664115819,6),(52114944,664115801,7),(52114944,664115802,8),(52114944,664115803,9),(52114944,664115811,10),(52114944,664115812,11),(52114944,664115813,12),(52114944,664115814,13),(52114944,664115815,14),(52114944,664115816,15),(52114944,664115851,16),(52114944,664115852,17),(52114944,664115858,18),(52114944,664115859,19),(52114944,664115856,20),(52114944,664115857,21),(52114944,664115867,22),(52114944,664115868,23),(52114944,664115870,24),(52114944,664115871,25),(52114944,664115892,26),(52114944,664115895,27),(52114944,664115901,28),(52114944,664115902,29),(52114944,664115911,30),(52114944,664115912,31),(52114944,664115913,32),(52114944,664115914,33),(52114944,664115915,34),(52114944,664115916,35),(52114944,664116015,36),(52114944,664116016,37),(52114944,664116017,38),(52114944,664116021,39),(52114946,664115893,1),(52114946,664115903,2),(52114946,664115904,3),(52114946,664115921,4),(52114946,664115922,5),(52114946,664115923,6),(52114946,664115924,7),(52114946,664115925,8),(52114946,664115926,9),(52114946,664115981,10),(52114946,664115983,11),(52114946,664115984,12),(52114946,664115985,13),(52114946,664115986,14),(52114946,664115987,15),(52114946,664115988,16),(52114946,664115989,17),(52114946,664115990,18),(52114946,664115991,19),(52114946,664116013,20),(52114947,664115890,1),(52114947,664115891,2),(52114947,664115896,3),(52114947,664115897,4),(52114947,664115898,5),(52114947,664115906,6),(52114947,664115907,7),(52114947,664115908,8),(52114947,664115948,9),(52114947,664115950,10),(52114947,664115952,11),(52114947,664115953,12),(52114947,664115962,13),(52114947,664115963,14),(52114947,664115964,15),(52114947,664115977,16),(52114947,664115978,17),(52114947,664115980,18),(52114947,664115992,19),(52114947,664115993,20),(52114947,664116014,21),(52114948,664115808,1),(52114948,664115809,2),(52114948,664115860,3),(52114948,664115861,4),(52114948,664115862,5),(52114948,664115875,6),(52114948,664115876,7),(52114948,664115877,8),(52114948,664115884,9),(52114948,664115885,10),(52114948,664115886,11),(52114948,664115887,12),(52114949,664115792,1),(52114949,664115793,2),(52114949,664115838,3),(52114949,664115839,4),(52114949,664115840,5),(52114949,664115841,6),(52114949,664115842,7),(52114949,664115843,8),(52114949,664115996,9),(52114949,664116004,10),(52114949,664116005,11),(52114949,664116006,12),(52114949,664116007,13),(52114949,664115997,14),(52114949,664115998,15),(52114949,664115999,16),(52114949,664116000,17),(52114949,664115994,18),(52114949,664115995,19),(52114949,664116001,20),(52114949,664116002,21),(52114949,664116003,22),(52114949,664115888,23),(52114949,664115889,24),(52114950,664116022,1),(52114950,664116023,2),(52114950,664116024,3),(52114950,664116025,4),(52114950,664116026,5),(52114950,664116027,6),(52114950,664116028,7),(52114950,664116029,8),(52114950,367683084,9),(52114950,664116030,10),(52114950,664116031,11),(52114950,664116032,12),(52114950,664116033,13),(52114950,664116034,14),(52114950,664116035,15),(52114950,664116036,16),(52114950,664116037,17),(52114950,664116038,18),(52114950,664116039,19),(52114950,664116040,20),(52114951,664116101,1),(52114951,664116102,2),(52114951,664116107,3),(52114951,664116108,4),(52114951,664116041,5),(52114951,664116042,6),(52114951,664116043,7),(52114951,664116044,8),(52114951,664116045,9),(52114951,664116046,10),(52114951,664116047,11),(52114951,664116048,12),(52114951,664116049,13),(52114951,664116050,14),(52114951,664116051,15),(52114951,664116052,16),(52114951,664116053,17),(52114951,664116054,18),(52114951,664116055,19),(52114951,664116056,20),(52114951,664116057,21),(52114951,664116059,22),(52114951,664116060,23),(52114951,664116061,24),(52114951,664116062,25),(52114951,664116063,26),(52114951,664116064,27),(52114951,664116065,28),(52114951,664116070,29),(52114951,664116071,30),(52114951,664116072,31),(52114951,664116073,32),(52114951,664116074,33),(52114951,664116075,34),(52114951,664116076,35),(52114951,664116077,36),(52114951,664116078,37),(52114951,664116079,38),(52114951,664116085,39),(52114951,664116086,40),(52114951,664116087,41),(52114951,664116088,42),(52114951,664116089,43),(52114952,664116161,1),(52114952,664192681,2),(52114952,664192679,3),(52114952,664192680,4),(52114952,664116091,5),(52121995,664195007,1),(52121995,664195008,2),(52122469,664198471,1),(52122469,664198472,2),(52122469,664198473,3),(52122469,664198474,4),(52122469,664198475,5),(52122469,664198476,6),(52122469,664198477,7),(52122469,664198478,8),(52122469,664198479,9),(52122469,664198480,10),(52123370,664205638,1),(52123370,664205644,2),(52123370,664205641,3),(52123370,664205635,4),(52123370,664205633,5),(52123370,664205630,6),(52123370,664205627,7),(52123370,664205624,8),(52123370,664205621,9),(52123370,664205619,10),(52123370,664205614,11),(52123917,664211795,1),(52123917,664211796,2),(52123917,664211797,3),(52123917,664211798,4),(52123917,664211799,5),(52123917,664211800,6),(52123917,664211801,7),(52123917,664211802,8),(52123917,664211803,9),(52123917,664211804,10),(52123917,664211810,11),(52123917,664211805,12),(52123917,664211806,13),(52123917,664211807,14),(52123917,664211811,15),(52123917,664211812,16),(52123917,664211813,17),(52123917,664211814,18),(52123917,664211808,19),(52123917,664211809,20),(52123917,664211815,21),(52123917,664211816,22),(52123917,664211817,23),(52123917,664211818,24),(52123917,664211819,25),(52123917,664211832,26),(52123917,664211833,27),(52123917,664211820,28),(52123917,664211821,29),(52123917,664211822,30),(52123917,664211823,31),(52123917,664211834,32),(52123917,664211835,33),(52123917,664211836,34),(52123917,664211837,35),(52123917,664211838,36),(52123917,664211839,37),(52123917,664211840,38),(52123917,664211841,39),(52123917,664211842,40),(52123917,664211843,41),(52123917,664211844,42),(52123917,664211845,43),(52123917,664211846,44),(52123917,664211847,45),(52123917,664211848,46),(52123917,664211849,47),(52123917,664211824,48),(52123917,664211828,49),(52123917,664211825,50),(52123917,664211826,51),(52123917,664211827,52),(52123917,664211831,53),(52123917,664211829,54),(52123917,664211830,55),(52163682,664559648,1),(52163682,664560009,2),(52163683,664559650,1),(52163683,664559649,2),(52163684,664560018,1),(52163684,664560019,2),(52163684,664560013,3),(52163684,664560014,4),(52163684,664560015,5),(52163684,664560016,6),(52163684,664560017,7),(52163684,664560010,8),(52163684,664560011,9),(52163684,664560012,10),(52163684,664560312,11),(52163684,664560313,12),(52163684,664560314,13),(52163684,664560315,14),(52163684,664560316,15),(52163684,664560317,16),(52163684,664560318,17),(52163684,664560319,18),(52163684,664560326,19),(52163684,664560327,20),(52163684,664560328,21),(52163684,664560329,22),(52163684,664560330,23),(52163684,664560331,24),(52163684,664560332,25),(52163684,664560333,26),(52163684,664560368,27),(52163691,664560066,1),(52163691,664560067,2),(52163691,664560068,3),(52163691,664560070,4),(52163691,664560071,5),(52163691,664560072,6),(52163691,664560073,7),(52163691,664560074,8),(52163691,664560075,9),(52163691,664560076,10),(52163691,664560320,11),(52163691,664560321,12),(52163691,664560322,13),(52163691,664560323,14),(52163691,664560324,15),(52163691,664560325,16),(52163691,664560337,17),(52163691,664560338,18),(52163691,664560339,19),(52163691,664560340,20),(52163691,664560341,21),(52163691,664560364,22),(52163691,664560365,23),(52163691,664560366,24),(52163691,664560367,25),(52163691,664560374,26),(52163691,664560375,27),(52163691,664560376,28),(52163691,664560398,29),(52163693,664560059,1),(52163693,664560062,2),(52163693,664560063,3),(52163693,664560064,4),(52163693,664560065,5),(52163693,664560069,6),(52163693,664560245,7),(52163693,664560334,8),(52163693,664560335,9),(52163693,664560336,10),(52163693,664560342,11),(52163693,664560346,12),(52163693,664560347,13),(52163693,664560348,14),(52163693,664560349,15),(52163693,664560350,16),(52163693,664560351,17),(52163693,664560352,18),(52163693,664560353,19),(52163693,664560354,20),(52163693,664560355,21),(52163693,664560356,22),(52163693,664560387,23),(52163693,664560388,24),(52163693,664560389,25),(52163693,664560390,26),(52163693,664560391,27),(52163693,664560392,28),(52163693,664560393,29),(52163693,664560394,30),(52163693,664560395,31),(52163693,664560396,32),(52163693,664560397,33),(52163695,664560003,1),(52163695,664560004,2),(52163695,664560005,3),(52163695,664560143,4),(52163695,664560160,5),(52163695,664560162,6),(52163695,664560163,7),(52163695,664560206,8),(52163695,664560207,9),(52163695,664560216,10),(52163695,664560217,11),(52163695,664560232,12),(52163695,664560235,13),(52163695,664560236,14),(52163695,664560237,15),(52163695,664560238,16),(52163695,664560233,17),(52163695,664560242,18),(52163695,664560243,19),(52163695,664560244,20),(52163695,664560246,21),(52163695,664560247,22),(52163695,664560248,23),(52163695,664560249,24),(52163695,664560250,25),(52163695,664560251,26),(52163695,664560252,27),(52163695,664560344,28),(52163695,664560345,29),(52163695,664560406,30),(52163695,664560407,31),(52163695,664560408,32),(52163695,664560413,33),(52163695,664560414,34),(52163695,664560415,35),(52163695,664560416,36),(52163695,664560421,37),(52163695,664560422,38),(52163695,664560423,39),(52163695,664560424,40),(52163695,664560425,41),(52163695,664560426,42),(52163695,664560427,43),(52163695,664560428,44),(52163695,664560429,45),(52163695,664560430,46),(52163695,664560431,47),(52163695,664560432,48),(52163695,664560433,49),(52163695,664560434,50),(52163695,664560435,51),(52163695,664560436,52),(52163695,664560437,53),(52163695,664560439,54),(52163695,664560440,55),(52163698,664559797,1),(52163698,664559798,2),(52163698,664559766,3),(52163698,664559767,4),(52163698,664559768,5),(52163698,664559772,6),(52163698,664559773,7),(52163698,664559774,8),(52163698,664559775,9),(52163698,664559776,10),(52163698,664559777,11),(52163698,664559763,12),(52163698,664559757,13),(52163698,664559758,14),(52163698,664559765,15),(52163698,664559764,16),(52163698,664559759,17),(52163698,664559760,18),(52163698,664559761,19),(52163698,664559762,20),(52163698,664559740,21),(52163698,664559741,22),(52163698,664559742,23),(52163698,664559743,24),(52163698,664559744,25),(52163698,664559745,26),(52163698,664559731,27),(52163698,664559732,28),(52163698,664559733,29),(52163698,664559734,30),(52163698,664559724,31),(52163700,664559799,1),(52163700,664559800,2),(52163700,664559801,3),(52163700,664559802,4),(52163700,664559803,5),(52163700,664559791,6),(52163700,664559792,7),(52163700,664559793,8),(52163700,664559769,9),(52163700,664559770,10),(52163700,664559771,11),(52163700,664559690,12),(52163700,664559691,13),(52163700,664559692,14),(52163700,664559693,15),(52163700,664559694,16),(52163700,664559695,17),(52163700,664559696,18),(52163700,664559697,19),(52163700,664559688,20),(52163700,664559689,21),(52163700,664559668,22),(52163700,664559669,23),(52163700,664559670,24),(52163700,664559671,25),(52163700,664559672,26),(52163700,664559657,27),(52163700,664559658,28),(52163700,664559659,29),(52163700,664559660,30),(52163700,664559661,31),(52163700,664559662,32),(52163700,664559663,33),(52163700,664559664,34),(52163700,664559665,35),(52163700,664559666,36),(52163700,664559667,37),(52163700,664559673,38),(52163700,664559674,39),(52163700,664559675,40),(52163700,664559676,41),(52163700,664559677,42),(52163700,664559678,43),(52163700,664559679,44),(52163700,664559680,45),(52163700,664559681,46),(52163700,664559682,47),(52163700,664559687,48),(52163700,664559683,49),(52163700,664559684,50),(52163700,664559685,51),(52163700,664559686,52),(52163700,664559698,53),(52163700,664559699,54),(52163700,664559700,55),(52163700,664559651,56),(52163700,664559652,57),(52163700,664559653,58),(52163700,664559654,59),(52163700,664559655,60),(52163700,664559656,61),(52163700,664559701,62),(52163700,664559702,63),(52163700,664559703,64),(52163700,664559704,65),(52163700,664559705,66),(52163700,664559706,67),(52163700,664559707,68),(52163700,664559708,69),(52163700,664559709,70),(52163700,664559710,71),(52163700,664559711,72),(52163700,664559712,73),(52163700,664559713,74),(52163700,664559714,75),(52163700,664559715,76),(52163700,664559716,77),(52163700,664559717,78),(52163700,664559718,79),(52163700,664559725,80),(52163700,664559726,81),(52163700,664559727,82),(52163700,664559728,83),(52163704,664559723,1),(52163704,664559794,2),(52163705,664559847,1),(52163705,664559848,2),(52163705,664559857,3),(52163705,664559858,4),(52163705,664559863,5),(52163705,664559864,6),(52163705,664559911,7),(52163705,664559913,8),(52163705,664559915,9),(52163705,664559917,10),(52163705,664559935,11),(52163705,664559937,12),(52163705,664559939,13),(52163705,664559941,14),(52163705,664560253,15),(52163705,664560254,16),(52163705,664560255,17),(52163705,664560256,18),(52163705,664560257,19),(52163705,664560258,20),(52163705,664560259,21),(52163705,664560260,22),(52163705,664560261,23),(52163705,664560262,24),(52163705,664560263,25),(52163705,664560264,26),(52163705,664560265,27),(52163705,664560266,28),(52163705,664560267,29),(52163705,664560268,30),(52163705,664560269,31),(52163705,664560270,32),(52163705,664560271,33),(52163705,664560272,34),(52163705,664560273,35),(52163705,664560280,36),(52163705,664560281,37),(52163710,664559729,1),(52163710,664559747,2),(52163712,664559748,1),(52163712,664559749,2),(52163712,664559750,3),(52163712,664559751,4),(52163712,664559752,5),(52163712,664559753,6),(52163712,664559754,7),(52163712,664559755,8),(52163712,664559756,9),(52163712,664559746,10),(52163712,664559736,11),(52163712,664559737,12),(52163712,664559738,13),(52163712,664559739,14),(52163712,664559735,15),(52163712,664559719,16),(52163712,664559720,17),(52163712,664559721,18),(52163712,664559722,19),(52163712,664559730,20),(52163714,664559866,1),(52163714,664559778,2),(52163716,664559779,1),(52163716,664559780,2),(52163716,664559781,3),(52163716,664559880,4),(52163716,664559881,5),(52163716,664559882,6),(52163716,664559883,7),(52163716,664559884,8),(52163716,664559885,9),(52163716,664559888,10),(52163716,664559817,11),(52163716,664559818,12),(52163716,664559819,13),(52163716,664559820,14),(52163716,664559821,15),(52163716,664559867,16),(52163716,664559868,17),(52163716,664559869,18),(52163716,664559870,19),(52163716,664559827,20),(52163716,664559828,21),(52163716,664559829,22),(52163716,664559830,23),(52163716,664559831,24),(52163716,664559832,25),(52163719,664559785,1),(52163719,664559782,2),(52163719,664559783,3),(52163719,664559784,4),(52163719,664559886,5),(52163719,664559887,6),(52163719,664559889,7),(52163719,664559890,8),(52163719,664559822,9),(52163719,664559823,10),(52163719,664559871,11),(52163719,664559872,12),(52163719,664559873,13),(52163719,664559874,14),(52163719,664559875,15),(52163719,664559876,16),(52163719,664559877,17),(52163719,664559878,18),(52163719,664559841,19),(52163719,664559842,20),(52163719,664559836,21),(52163719,664559837,22),(52163719,664559838,23),(52163719,664559839,24),(52163719,664559840,25),(52163719,664559843,26),(52163719,664559844,27),(52163719,664559845,28),(52163719,664559846,29),(52163719,664559849,30),(52163719,664559850,31),(52163719,664559851,32),(52163719,664559852,33),(52163719,664559853,34),(52163719,664559854,35),(52163719,664559855,36),(52163719,664559856,37),(52163719,664559859,38),(52163719,664559860,39),(52163719,664559861,40),(52163719,664559862,41),(52163719,664559904,42),(52163719,664559905,43),(52163719,664559906,44),(52163719,664559919,45),(52163719,664559923,46),(52163719,664559925,47),(52163719,664559927,48),(52163719,664559929,49),(52163722,664559786,1),(52163722,664559788,2),(52163722,664559789,3),(52163722,664559790,4),(52163722,664559891,5),(52163722,664559892,6),(52163722,664559893,7),(52163722,664559894,8),(52163722,664559895,9),(52163722,664559896,10),(52163722,664559897,11),(52163722,664559898,12),(52163722,664559899,13),(52163722,664559900,14),(52163722,664559901,15),(52163722,664559902,16),(52163722,664559903,17),(52163722,664559947,18),(52163722,664559949,19),(52163722,664559951,20),(52163722,664559953,21),(52163722,664559955,22),(52163722,664559957,23),(52163722,664559963,24),(52163722,664559965,25),(52163722,664559966,26),(52163722,664559968,27),(52163722,664559969,28),(52163722,664559970,29),(52163729,664560035,1),(52163729,664560036,2),(52163729,664560037,3),(52163729,664560038,4),(52163729,664560040,5),(52163729,664560041,6),(52163729,664560043,7),(52163729,664560056,8),(52163729,664560057,9),(52163729,664560058,10),(52163729,664560060,11),(52163729,664560061,12),(52163729,664560044,13),(52163729,664560045,14),(52163729,664560046,15),(52163729,664560047,16),(52163729,664560048,17),(52163729,664560049,18),(52163729,664560050,19),(52163729,664560051,20),(52163729,664560052,21),(52163729,664560053,22),(52163729,664560002,23),(52163729,664560157,24),(52163729,664560158,25),(52163729,664560159,26),(52163729,664560202,27),(52163729,664560203,28),(52163729,664560204,29),(52163729,664560205,30),(52163729,664560214,31),(52163729,664560215,32),(52163729,664560231,33),(52163731,664559787,1),(52163731,664559979,2),(52163731,664559980,3),(52163731,664559981,4),(52163731,664559982,5),(52163731,664559983,6),(52163731,664559984,7),(52163731,664559985,8),(52163731,664559986,9),(52163731,664559978,10),(52163731,664559987,11),(52163731,664559988,12),(52163731,664559989,13),(52163731,664559990,14),(52163731,664559991,15),(52163731,664559992,16),(52163731,664560006,17),(52163731,664560007,18),(52163731,664560145,19),(52163731,664560147,20),(52163731,664560149,21),(52163731,664560150,22),(52163731,664560161,23),(52163731,664560164,24),(52163731,664560165,25),(52163731,664560166,26),(52163731,664560167,27),(52163731,664560208,28),(52163731,664560209,29),(52163731,664560218,30),(52163731,664560219,31),(52163733,664560089,1),(52163733,664560091,2),(52163733,664560093,3),(52163733,664560095,4),(52163733,664560097,5),(52163733,664560099,6),(52163733,664560081,7),(52163733,664560082,8),(52163733,664560083,9),(52163733,664560085,10),(52163733,664560086,11),(52163733,664559993,12),(52163733,664559994,13),(52163733,664559995,14),(52163733,664559996,15),(52163733,664559997,16),(52163733,664559998,17),(52163733,664559999,18),(52163733,664560000,19),(52163733,664560087,20),(52163733,664560151,21),(52163733,664560152,22),(52163733,664560153,23),(52163733,664560154,24),(52163733,664560155,25),(52163733,664560156,26),(52163733,664560168,27),(52163733,664560169,28),(52163733,664560170,29),(52163733,664560171,30),(52163733,664560172,31),(52163733,664560173,32),(52163733,664560174,33),(52163733,664560175,34),(52163733,664560177,35),(52163733,664560178,36),(52163733,664560211,37),(52163733,664560212,38),(52163733,664560213,39),(52163733,664560210,40),(52163733,664560220,41),(52163733,664560221,42),(52163733,664560222,43),(52163733,664560223,44),(52163733,664560234,45),(52163733,664560239,46),(52163736,664559795,1),(52163736,664559826,2),(52163738,664559833,1),(52163738,664559834,2),(52163738,664559835,3),(52163738,664559824,4),(52163738,664559825,5),(52163738,664559815,6),(52163738,664559816,7),(52163738,664559812,8),(52163738,664559813,9),(52163738,664559814,10),(52163738,664559804,11),(52163738,664559805,12),(52163738,664559806,13),(52163738,664559807,14),(52163738,664559808,15),(52163738,664559809,16),(52163738,664559810,17),(52163738,664559811,18),(52163738,664559796,19),(52163739,664559971,1),(52163739,664560008,2),(52163740,664560027,1),(52163740,664560028,2),(52163740,664560029,3),(52163740,664560030,4),(52163740,664560031,5),(52163740,664560032,6),(52163740,664560033,7),(52163740,664560034,8),(52163740,664560001,9),(52163740,664559972,10),(52163740,664559973,11),(52163740,664559974,12),(52163740,664559975,13),(52163740,664559976,14),(52163740,664559977,15),(52163743,664560135,1),(52163743,664560134,2),(52163743,664560132,3),(52163743,664560129,4),(52163743,664560105,5),(52163743,664560103,6),(52163745,664560192,1),(52163745,664560191,2),(52163745,664560190,3),(52163745,664560189,4),(52163745,664560188,5),(52163745,664560142,6),(52163745,664560140,7),(52163745,664560137,8),(52163745,664560114,9),(52163745,664560112,10),(52163745,664560109,11),(52163745,664560107,12),(52163745,664560127,13),(52163745,664560125,14),(52163745,664560123,15),(52163745,664560121,16),(52163745,664560118,17),(52163746,664560193,1),(52163746,664560194,2),(52163746,664560195,3),(52163746,664560196,4),(52163746,664560198,5),(52163746,664560179,6),(52163746,664560180,7),(52163746,664560182,8),(52163746,664560183,9),(52163746,664560185,10),(52163746,664560186,11),(52163746,664560226,12),(52163746,664560227,13),(52163746,664560228,14),(52163746,664560229,15),(52163746,664560224,16),(52163746,664560225,17),(52163746,664560240,18),(52163748,664560369,1),(52163748,664560370,2),(52163748,664560377,3),(52163748,664560378,4),(52163748,664560379,5),(52163750,664560383,1),(52163750,664560384,2),(52163750,664560399,3),(52163750,664560400,4),(52163750,664560401,5),(52163751,664560402,1),(52163751,664560403,2),(52163751,664560404,3),(52163751,664560405,4),(52163751,664560385,5),(52163751,664560386,6),(52163753,664560343,1),(52163753,664560357,2),(52163753,664560358,3),(52163753,664560359,4),(52163753,664560360,5),(52163753,664560361,6),(52163753,664560362,7),(52163753,664560363,8),(52163753,664560409,9),(52163753,664560410,10),(52163753,664560411,11),(52163753,664560412,12),(52163753,664560417,13),(52163754,664560418,1),(52163754,664560419,2),(52163754,664560420,3),(52171935,664598870,1),(52171935,664598764,2),(52171935,664598765,3),(52171936,664598413,1),(52171936,664598414,2),(52171936,664598438,3),(52171936,664598439,4),(52171936,664598440,5),(52171936,664598441,6),(52171936,664598447,7),(52171936,664598448,8),(52171936,664598449,9),(52171936,664598451,10),(52171936,664598471,11),(52171936,664598472,12),(52171936,664598473,13),(52171936,664598474,14),(52171936,664598475,15),(52171936,664598476,16),(52171936,664598477,17),(52171936,664598478,18),(52171936,664598868,19),(52171936,664598869,20),(52171936,664598871,21),(52171936,664598872,22),(52171936,621467612,23),(52171937,664598415,1),(52171937,664598423,2),(52171937,664598424,3),(52171937,664598425,4),(52171937,664598426,5),(52171937,664598427,6),(52171937,664598452,7),(52171937,664598453,8),(52171937,664598454,9),(52171937,664598455,10),(52171937,664598456,11),(52171937,664598457,12),(52171937,664598458,13),(52171937,664598459,14),(52171937,664598735,15),(52171937,664598736,16),(52171937,664598737,17),(52171937,664598738,18),(52171937,664598739,19),(52171937,664598740,20),(52171937,664598741,21),(52171937,664598742,22),(52171937,664598743,23),(52171937,664598744,24),(52171937,664598747,25),(52171937,664598748,26),(52171937,664598749,27),(52171938,664598416,1),(52171938,664598417,2),(52171938,664598418,3),(52171938,664598419,4),(52171938,664598420,5),(52171938,664598421,6),(52171938,664598422,7),(52171938,664598402,8),(52171938,664598403,9),(52171938,664598404,10),(52171938,664598405,11),(52171938,664598406,12),(52171938,664598684,13),(52171938,664598697,14),(52171938,664598698,15),(52171938,664598699,16),(52171938,664598700,17),(52171938,664598706,18),(52171938,664598682,19),(52171938,664598666,20),(52171938,664598668,21),(52171938,664598670,22),(52171938,664598672,23),(52171938,664598674,24),(52171938,664598676,25),(52171938,664598678,26),(52171938,664598480,27),(52171938,664598396,28),(52171938,664598397,29),(52171938,664598398,30),(52171938,664598399,31),(52171938,664598400,32),(52171938,664598393,33),(52171938,664598394,34),(52171938,664598395,35),(52171938,664598481,36),(52171938,664598482,37),(52171938,664598483,38),(52171938,664598484,39),(52171938,664598485,40),(52171938,664598486,41),(52171938,664598487,42),(52171938,664598488,43),(52171938,664598489,44),(52171938,664598497,45),(52171938,664598499,46),(52171938,664598500,47),(52171938,664598501,48),(52171938,664598479,49),(52171938,664598509,50),(52171938,664598510,51),(52171938,664598511,52),(52171938,664598512,53),(52171938,664598504,54),(52171938,664598505,55),(52171938,664598506,56),(52171938,664598513,57),(52171938,664598503,58),(52171938,664598526,59),(52171938,664598527,60),(52171938,664598528,61),(52171938,664598529,62),(52171938,664598530,63),(52171938,664598555,64),(52171938,664598556,65),(52171938,664598557,66),(52171938,664598558,67),(52171938,664598559,68),(52171938,664598560,69),(52171938,664598640,70),(52171938,664598641,71),(52171938,664598642,72),(52171938,664598643,73),(52171938,664598644,74),(52171938,664598645,75),(52171938,664598646,76),(52171938,664598647,77),(52171938,664598648,78),(52171938,664598627,79),(52171938,664598628,80),(52171938,664598629,81),(52171938,664598630,82),(52171938,664598631,83),(52171938,664598632,84),(52171938,664598633,85),(52171938,664598622,86),(52171938,664598623,87),(52171938,664598624,88),(52171938,664598625,89),(52171938,664598626,90),(52171938,664598634,91),(52171938,664598635,92),(52171938,664598636,93),(52171938,664598637,94),(52171938,664598638,95),(52171938,664598639,96),(52171938,664598649,97),(52171938,664598650,98),(52171938,664598651,99),(52171938,664598654,100),(52171938,664598655,101),(52171938,664598656,102),(52171938,664598657,103),(52171938,664598658,104),(52171938,664598659,105),(52171938,664598660,106),(52171938,664598801,107),(52171938,664598802,108),(52171938,664598803,109),(52171938,664598804,110),(52171938,664598805,111),(52171938,664598806,112),(52171938,664598807,113),(52171938,664598808,114),(52171938,664598809,115),(52171938,664598810,116),(52171938,664598814,117),(52171938,664598815,118),(52171938,664598816,119),(52171938,664598661,120),(52171938,664598662,121),(52171938,664598663,122),(52171938,664598665,123),(52171938,664598817,124),(52171938,664598831,125),(52171938,664598832,126),(52171938,664598833,127),(52171938,664598834,128),(52171938,664598835,129),(52171939,664598750,1),(52171939,664598751,2),(52171939,664598752,3),(52171939,664598753,4),(52171939,664598754,5),(52171939,664598755,6),(52171939,664598756,7),(52171939,664598776,8),(52171939,664598777,9),(52171939,664598778,10),(52171939,664598779,11),(52171939,664598780,12),(52171939,664598786,13),(52171939,664598787,14),(52171939,664598788,15),(52171939,664598789,16),(52171939,664598790,17),(52171939,664598791,18),(52171939,664598843,19),(52171939,664598844,20),(52171940,664598507,1),(52171940,664598680,2),(52171940,664598701,3),(52171941,664598704,1),(52171941,664598703,2),(52171941,664598702,3),(52171941,664598716,4),(52171941,664598715,5),(52171941,664598714,6),(52171941,664598713,7),(52171941,664598496,8),(52171941,664598495,9),(52171941,664598494,10),(52171941,664598493,11),(52171941,664598492,12),(52171941,664598491,13),(52171941,664598490,14),(52171941,664598569,15),(52171941,664598568,16),(52171941,664598567,17),(52171941,664598508,18),(52171942,664598514,1),(52171942,664598515,2),(52171942,664598516,3),(52171942,664598517,4),(52171942,664598518,5),(52171942,664598519,6),(52171942,664598520,7),(52171942,664598541,8),(52171942,664598542,9),(52171942,664598543,10),(52171942,664598544,11),(52171942,664598561,12),(52171942,664598562,13),(52171942,664598563,14),(52171942,664598606,15),(52171942,664598652,16),(52171942,664598653,17),(52171943,664598533,1),(52171943,664598583,2),(52171944,664598534,1),(52171944,664598574,2),(52171945,664598584,1),(52171945,664598585,2),(52171945,664598586,3),(52171945,664598587,4),(52171945,664598603,5),(52171945,664598604,6),(52171945,664598605,7),(52171945,664598591,8),(52171945,664598592,9),(52171945,664598593,10),(52171945,664598594,11),(52171945,664598595,12),(52171945,664598599,13),(52171945,664598575,14),(52171945,664598576,15),(52171945,664598607,16),(52171945,664598608,17),(52171945,664598609,18),(52171945,664598610,19),(52171945,664598611,20),(52171945,664598612,21),(52171945,664598613,22),(52171945,664598614,23),(52171945,664598615,24),(52171945,664598616,25),(52171945,664598617,26),(52171945,664598618,27),(52171945,664598619,28),(52171945,664598620,29),(52171945,664598621,30),(52171945,664598545,31),(52171945,664598546,32),(52171945,664598547,33),(52171945,664598548,34),(52171945,664598549,35),(52171945,664598550,36),(52171945,664598551,37),(52171945,664598552,38),(52171945,664598553,39),(52171945,664598554,40),(52171945,664598535,41),(52171945,664598536,42),(52171945,664598564,43),(52171945,664598565,44),(52171945,664598566,45),(52171946,664598588,1),(52171946,664598589,2),(52171946,664598590,3),(52171946,664598596,4),(52171946,664598597,5),(52171946,664598598,6),(52171946,664598577,7),(52171946,664598578,8),(52171946,664598579,9),(52171946,664598580,10),(52171946,664598581,11),(52171946,664598570,12),(52171946,664598571,13),(52171946,664598572,14),(52171946,664598573,15),(52171946,664598521,16),(52171946,664598522,17),(52171946,664598523,18),(52171946,664598524,19),(52171946,664598525,20),(52171946,664598531,21),(52171946,664598532,22),(52171946,664598537,23),(52171946,664598538,24),(52171946,664598539,25),(52171946,664598540,26),(52171947,664598757,1),(52171947,664598758,2),(52171947,664598759,3),(52171947,664598760,4),(52171947,664598761,5),(52171947,664598762,6),(52171947,664598763,7),(52171947,664598781,8),(52171947,664598782,9),(52171947,664598783,10),(52171947,664598784,11),(52171947,664598792,12),(52171947,664598793,13),(52171947,664598794,14),(52171947,664598795,15),(52171947,664598796,16),(52171947,664598797,17),(52171947,664598798,18),(52171947,664598799,19),(52172905,664605736,1),(52172905,664605748,2),(52172905,664605824,3),(52172907,664606014,1),(52172907,664606015,2),(52172907,664606016,3),(52172907,664606018,4),(52172907,664606019,5),(52172907,664606020,6),(52172907,664606010,7),(52172907,664606011,8),(52172907,664606012,9),(52172907,664606013,10),(52172907,664606063,11),(52172907,664606064,12),(52172907,664606066,13),(52172907,664606067,14),(52172909,664605856,1),(52172909,664605860,2),(52172909,664605861,3),(52172909,664605864,4),(52172909,664605866,5),(52172909,664605869,6),(52172909,664605946,7),(52172909,664605948,8),(52172909,664605906,9),(52172909,664605907,10),(52172909,664605911,11),(52172909,664605919,12),(52172909,664605915,13),(52172909,664605917,14),(52172909,664605941,15),(52172909,664605942,16),(52172909,664605943,17),(52172909,664605925,18),(52172909,664605926,19),(52172909,664605931,20),(52172909,664605933,21),(52172909,664605934,22),(52172909,664605935,23),(52172909,664605936,24),(52172909,664605937,25),(52172909,664605974,26),(52172909,664605976,27),(52172909,664605977,28),(52172909,664605978,29),(52172909,664605979,30),(52172909,664605969,31),(52172909,664605970,32),(52172909,664605971,33),(52172909,664605972,34),(52172909,664605973,35),(52172909,664605980,36),(52172909,664605981,37),(52172909,664605982,38),(52172909,664605983,39),(52172909,664605984,40),(52172909,664605985,41),(52172909,664605986,42),(52172909,664605987,43),(52172909,664605988,44),(52172909,664605989,45),(52172909,664605990,46),(52172909,664605991,47),(52172909,664605992,48),(52172909,664605993,49),(52172909,664605994,50),(52172909,664605996,51),(52172909,664605997,52),(52172909,664606021,53),(52172909,664606022,54),(52172909,664606023,55),(52172909,664606024,56),(52172909,664606025,57),(52172909,664606027,58),(52172909,664606028,59),(52172909,664606029,60),(52172909,664606030,61),(52172909,664606031,62),(52172909,664606033,63),(52172909,664606034,64),(52172909,664606035,65),(52172909,664606036,66),(52172909,664606037,67),(52172909,664606043,68),(52172909,664606039,69),(52172909,664606040,70),(52172909,664606045,71),(52172909,664606044,72),(52172909,664606041,73),(52172909,664606042,74),(52172909,664606046,75),(52172911,664605857,1),(52172911,664605871,2),(52172911,664605874,3),(52172911,664605846,4),(52172911,664605908,5),(52172911,664605909,6),(52172911,664605905,7),(52172911,664605916,8),(52172911,664605918,9),(52172911,664605927,10),(52172911,664605928,11),(52172911,664605929,12),(52172911,664605930,13),(52172911,664605939,14),(52172911,664605940,15),(52172911,664605894,16),(52172911,664605895,17),(52172911,664605903,18),(52172911,664605904,19),(52172911,664605898,20),(52172911,664605899,21),(52172911,664605900,22),(52172911,664605901,23),(52172911,664605896,24),(52172911,664605897,25),(52172913,664605858,1),(52172913,664605876,2),(52172913,664605878,3),(52172913,664605949,4),(52172913,664605950,5),(52172913,664605951,6),(52172913,664605952,7),(52172913,664605912,8),(52172913,664605913,9),(52172913,664605914,10),(52172913,664605920,11),(52172913,664605921,12),(52172913,664605922,13),(52172913,664605923,14),(52172913,664605924,15),(52172913,664605953,16),(52172913,664605955,17),(52172913,664605956,18),(52172913,664605958,19),(52172913,664605959,20),(52172913,664605945,21),(52172914,664605886,1),(52172914,664605888,2),(52172914,664605890,3),(52172914,664605891,4),(52172914,664605892,5),(52172914,664605954,6),(52172914,664605998,7),(52172914,664605999,8),(52172914,664606000,9),(52172914,664606001,10),(52172914,664606002,11),(52172914,664606004,12),(52172914,664606005,13),(52172914,664606006,14),(52172914,664606007,15),(52172914,664606008,16),(52172915,664605847,1),(52172915,664605848,2),(52172915,664605849,3),(52172915,664605850,4),(52172915,664605836,5),(52172915,664605837,6),(52172915,664605838,7),(52172915,664605839,8),(52172915,664605773,9),(52172915,664605774,10),(52172915,664605776,11),(52172915,664605777,12),(52172915,664605778,13),(52172915,664605779,14),(52172915,664605765,15),(52172916,664605840,1),(52172916,664605841,2),(52172916,664605842,3),(52172916,664605843,4),(52172916,664605844,5),(52172916,664605828,6),(52172916,664605829,7),(52172916,664605830,8),(52172916,664605831,9),(52172916,664605832,10),(52172916,664605833,11),(52172916,664605834,12),(52172916,664605771,13),(52172916,664605772,14),(52172916,664605780,15),(52172916,664605781,16),(52172916,664605783,17),(52172916,664605784,18),(52172916,664605768,19),(52172918,664605758,1),(52172918,664605750,2),(52172918,664605751,3),(52172918,664605752,4),(52172918,664605753,5),(52172918,664605754,6),(52172918,664605756,7),(52172918,664605817,8),(52172918,664605814,9),(52172918,664605815,10),(52172918,664605816,11),(52172918,664605818,12),(52172918,664605819,13),(52172918,664605823,14),(52172918,664605822,15),(52172918,664605820,16),(52172918,664605821,17),(52172918,664605806,18),(52172918,664605813,19),(52172918,664605812,20),(52172918,664605807,21),(52172918,664605808,22),(52172918,664605809,23),(52172918,664605811,24),(52172918,664605805,25),(52172918,664605804,26),(52172918,664605803,27),(52172918,664605794,28),(52172918,664605795,29),(52172918,664605796,30),(52172918,664605801,31),(52172918,664605797,32),(52172918,664605799,33),(52172918,664605800,34),(52172918,664605785,35),(52172918,664605786,36),(52172918,664605793,37),(52172918,664605787,38),(52172918,664605792,39),(52172918,664605791,40),(52172918,664605788,41),(52172918,664605790,42),(52172919,664605964,1),(52172919,664605965,2),(52172919,664605966,3),(52172919,664605960,4),(52172919,664605961,5),(52172919,664605963,6),(52172920,664605968,1),(52172920,664605962,2),(52172921,664606048,1),(52172921,664606049,2),(52172921,664606050,3),(52172921,664606051,4),(52172921,664606052,5),(52172921,664606056,6),(52172921,664606057,7),(52172921,664606058,8),(52172921,664606059,9),(52172921,664606060,10),(52172921,664606061,11),(52172921,664606062,12),(52172921,664606068,13),(52172921,664606054,14),(52172921,664606055,15),(52174944,664651839,1),(52174946,664651828,1),(52174948,664651837,1),(52174950,664651829,1),(52174952,664651816,1),(52174952,664651823,2),(52174953,664651819,1),(52174953,664651832,2),(52174956,664651821,1),(52174956,664651834,2),(52174958,664651809,1),(52174958,664651800,2),(52174958,664651806,3),(52174959,664651811,1),(52174959,664651813,2),(52174960,664651818,1),(52174960,664651814,2),(52174962,664651824,1),(52174962,664651826,2),(52174963,664651841,1),(52174963,664651836,2),(52268017,665238087,1),(52268017,665238091,2),(52268017,665238092,3),(52268017,665240662,4),(52268017,665238096,5),(52692955,668878377,1),(52692955,668878380,2),(52692955,668878382,3),(52692955,668878383,4),(52692955,668878401,5),(52692955,668878402,6),(52692955,668878403,7),(52692955,668878404,8),(52692955,668878405,9),(52692955,668878406,10),(52692955,668878407,11),(52692955,668878447,12),(52692956,668878364,1),(52692956,668878366,2),(52692956,668878367,3),(52692956,668878372,4),(52692956,668878374,5),(52692956,668878376,6),(52692956,668878379,7),(52692956,668878385,8),(52692956,668878386,9),(52692956,668878388,10),(52692956,668878389,11),(52692956,668878390,12),(52692956,668878391,13),(52692956,668878408,14),(52692956,668878409,15),(52692956,668878410,16),(52692956,668878411,17),(52692956,668878412,18),(52692956,668878413,19),(52692956,668878414,20),(52692956,668878498,21),(52692956,668878500,22),(52692956,668878501,23),(52692956,668878503,24),(52692956,668878505,25),(52692956,668878515,26),(52692956,668878516,27),(52692956,668878518,28),(52692956,668878520,29),(52692956,668878521,30),(52692956,668878579,31),(52692956,668878580,32),(52692956,668878598,33),(52692956,668878599,34),(52692956,668878602,35),(52692956,668878655,36),(52692956,668878657,37),(52692956,668878658,38),(52692956,668878660,39),(52692956,668878684,40),(52692956,668878686,41),(52692956,668878687,42),(52692956,668878689,43),(52692956,668878703,44),(52692956,668878705,45),(52692956,668878772,46),(52692956,668878774,47),(52692956,668878775,48),(52692956,668878766,49),(52692956,668878767,50),(52692956,668878769,51),(52692956,668878771,52),(52692956,668878777,53),(52692956,668878779,54),(52692956,668878780,55),(52692956,668878782,56),(52692956,668878783,57),(52692956,668878785,58),(52692956,668878787,59),(52692956,668878797,60),(52692956,668878799,61),(52692956,668878800,62),(52692956,668878802,63),(52692956,668878804,64),(52692956,668878805,65),(52692956,668878847,66),(52692956,668878848,67),(52692956,668878831,68),(52692956,668878833,69),(52692956,668878834,70),(52692956,668878830,71),(52692957,668878392,1),(52692957,668878393,2),(52692957,668878415,3),(52692957,668878416,4),(52692957,668878417,5),(52692957,668878419,6),(52692957,668878420,7),(52692957,668878422,8),(52692957,668878423,9),(52692957,668878506,10),(52692957,668878508,11),(52692957,668878510,12),(52692957,668878511,13),(52692957,668878513,14),(52692957,668878538,15),(52692957,668878539,16),(52692957,668878541,17),(52692957,668878543,18),(52692957,668878544,19),(52692957,668878546,20),(52692957,668878548,21),(52692957,668878549,22),(52692957,668878551,23),(52692957,668878553,24),(52692957,668878531,25),(52692957,668878533,26),(52692957,668878534,27),(52692957,668878536,28),(52692958,668878629,1),(52692958,668878334,2),(52692959,668878337,1),(52692959,668878369,2),(52692959,668878371,3),(52692959,668878394,4),(52692959,668878395,5),(52692959,668878396,6),(52692959,668878397,7),(52692959,668878398,8),(52692959,668878399,9),(52692959,668878400,10),(52692959,668878442,11),(52692959,668878444,12),(52692959,668878446,13),(52692959,668878464,14),(52692959,668878465,15),(52692960,668878339,1),(52692960,668878340,2),(52692960,668878342,3),(52692960,668878344,4),(52692960,668878346,5),(52692960,668878348,6),(52692960,668878349,7),(52692960,668878351,8),(52692960,668878353,9),(52692960,668878354,10),(52692960,668878356,11),(52692960,668878358,12),(52692960,668878359,13),(52692960,668878361,14),(52692960,668878362,15),(52692960,668878425,16),(52692960,668878427,17),(52692960,668878429,18),(52692960,668878430,19),(52692960,668878432,20),(52692960,668878434,21),(52692960,668878435,22),(52692960,668878437,23),(52692961,668878850,1),(52692961,668878558,2),(52692962,668878569,1),(52692962,668878571,2),(52692962,668878573,3),(52692962,668878576,4),(52692962,668878636,5),(52692962,668878668,6),(52692962,668878669,7),(52692962,668878671,8),(52692962,668878673,9),(52692962,668878674,10),(52692962,668878723,11),(52692962,668878725,12),(52692962,668878726,13),(52692962,668878728,14),(52692962,668878729,15),(52692962,668878752,16),(52692962,668878753,17),(52692962,668878755,18),(52692962,668878757,19),(52692962,668878836,20),(52692962,668878837,21),(52692962,668878839,22),(52692963,668878731,1),(52692963,668878745,2),(52692963,668878746,3),(52692963,668878748,4),(52692963,668878750,5),(52692963,668878759,6),(52692963,668878761,7),(52692963,668878762,8),(52692963,668878764,9),(52692963,668878807,10),(52692963,668878840,11),(52692963,668878841,12),(52692963,668878843,13),(52692963,668878845,14),(52692964,668878454,1),(52692964,668878456,2),(52692964,668878467,3),(52692964,668878469,4),(52692964,668878493,5),(52692964,668878495,6),(52692964,668878523,7),(52692964,668878525,8),(52692964,668878526,9),(52692964,668878528,10),(52692964,668878530,11),(52692964,668878588,12),(52692964,668878591,13),(52692964,668878592,14),(52692965,668878595,1),(52692965,668878457,2),(52692966,668878449,1),(52692966,668878450,2),(52692966,668878452,3),(52692966,668878439,4),(52692966,668878440,5),(52692966,668878459,6),(52692966,668878461,7),(52692966,668878462,8),(52692966,668878471,9),(52692966,668878472,10),(52692966,668878488,11),(52692966,668878490,12),(52692966,668878492,13),(52692966,668878554,14),(52692966,668878556,15),(52692966,668878583,16),(52692966,668878586,17),(52692966,668878604,18),(52692966,668878607,19),(52692966,668878608,20),(52692966,668878622,21),(52692966,668878625,22),(52692966,668878638,23),(52692966,668878639,24),(52692966,668878641,25),(52692966,668878642,26),(52692966,668878644,27),(52692966,668878661,28),(52692967,668878611,1),(52692967,668878617,2),(52692967,668878620,3),(52692967,668878645,4),(52692967,668878647,5),(52692967,668878649,6),(52692967,668878650,7),(52692967,668878652,8),(52692967,668878676,9),(52692967,668878678,10),(52692967,668878679,11),(52692967,668878681,12),(52692967,668878683,13),(52692967,668878691,14),(52692967,668878692,15),(52692967,668878694,16),(52692967,668878707,17),(52692967,668878708,18),(52692968,668878696,1),(52692968,668878613,2),(52692969,668878497,1),(52692969,668878560,2),(52692969,668878562,3),(52692969,668878565,4),(52692969,668878567,5),(52692969,668878615,6),(52692969,668878630,7),(52692969,668878633,8),(52692969,668878634,9),(52692969,668878653,10),(52692969,668878663,11),(52692969,668878664,12),(52692969,668878666,13),(52692969,668878697,14),(52692969,668878699,15),(52692969,668878700,16),(52692969,668878702,17),(52692969,668878710,18),(52692969,668878712,19),(52692969,668878713,20),(52692969,668878715,21),(52692969,668878716,22),(52692969,668878718,23),(52692969,668878720,24),(52692969,668878721,25),(52692970,668878788,1),(52692970,668878809,2),(52692970,668878810,3),(52692970,668878812,4),(52692970,668878814,5),(52692970,668878816,6),(52692970,668878817,7),(52692970,668878852,8),(52692970,668878854,9),(52692970,668878855,10),(52692970,668878857,11),(52692970,668878859,12),(52692970,668878860,13),(52692971,668878790,1),(52692971,668878792,2),(52692971,668878794,3),(52692971,668878795,4),(52692971,668878819,5),(52692971,668878820,6),(52692971,668878822,7),(52692971,668878823,8),(52692971,668878825,9),(52692971,668878826,10),(52692971,668878828,11),(52692971,668878863,12),(52692971,668878865,13),(52692971,668878867,14),(52692971,668878869,15),(52692971,668878870,16),(52692971,668878872,17),(52692971,668878862,18),(52697930,668901336,1),(52697930,668901337,2),(52697930,668901338,3),(52697930,668901357,4),(52697930,668901358,5),(52697930,668901359,6),(52697930,668901360,7),(52697930,668901362,8),(52697930,668901363,9),(52697930,668901364,10),(52697930,668901365,11),(52697930,668901361,12),(52697930,668901366,13),(52697930,668901367,14),(52697930,668901368,15),(52697930,668901369,16),(52697930,668901370,17),(52697930,668901371,18),(52697930,668901374,19),(52697930,668901376,20),(52697930,668901377,21),(52697930,668901379,22),(52697930,668901380,23),(52697930,668901381,24),(52697930,668901385,25),(52697930,668901386,26),(52697930,668901387,27),(52697930,668901407,28),(52697930,668901408,29),(52697930,668901409,30),(52697930,668901410,31),(52697930,668901417,32),(52697930,668901418,33),(52697930,668901419,34),(52697930,668901420,35),(52697930,668901421,36),(52697930,668901422,37),(52697930,668901423,38),(52697930,668901424,39),(52697930,668901429,40),(52697930,668901411,41),(52697930,668901412,42),(52697930,668901413,43),(52697930,668901414,44),(52697930,668901415,45),(52697930,668901416,46),(52697930,668901433,47),(52697930,668901434,48),(52697930,668901435,49),(52697930,668901436,50),(52697930,668901437,51),(52697930,668901438,52),(52697930,668901439,53),(52697930,668901440,54),(52697930,668901406,55),(52697930,668901448,56),(52697930,668901449,57),(52697930,668901450,58),(52697930,668901451,59),(52697930,668901452,60),(52697930,668901453,61),(52697930,668901454,62),(52697930,668901455,63),(52697930,668901456,64),(52697930,668901457,65),(52697930,668901458,66),(52697930,668901459,67),(52697930,668901460,68),(52697930,668901461,69),(52697930,668901462,70),(52697930,668901463,71),(52697930,668901519,72),(52697930,668901858,73),(52697930,668901859,74),(52697930,668901860,75),(52697930,668901861,76),(52697930,668901862,77),(52697930,668901863,78),(52697930,668901864,79),(52697930,668901866,80),(52697930,668901867,81),(52697930,668901868,82),(52697930,668901869,83),(52697930,668901872,84),(52697930,668901873,85),(52697930,668901874,86),(52697930,668901878,87),(52697930,668901879,88),(52697930,668901875,89),(52697931,668901296,1),(52697931,668901297,2),(52697931,668901298,3),(52697931,668901302,4),(52697931,668901303,5),(52697931,668901315,6),(52697931,668901316,7),(52697931,668901317,8),(52697931,668901318,9),(52697931,668901304,10),(52697931,668901305,11),(52697931,668901287,12),(52697931,668901288,13),(52697931,668901282,14),(52697931,668901283,15),(52697931,668901284,16),(52697931,668901294,17),(52697931,668901295,18),(52697931,668901306,19),(52697931,668901656,20),(52697931,668901657,21),(52697931,668901658,22),(52697931,668901659,23),(52697931,668901660,24),(52697931,668901661,25),(52697931,668901663,26),(52697931,668901664,27),(52697931,668901665,28),(52697931,668901666,29),(52697931,668901649,30),(52697931,668901650,31),(52697931,668901651,32),(52697931,668901667,33),(52697931,668901668,34),(52697931,668901669,35),(52697931,668901670,36),(52697931,668901672,37),(52697931,668901676,38),(52697931,668901677,39),(52697931,668901694,40),(52697931,668901695,41),(52697931,668901696,42),(52697931,668901697,43),(52697931,668901698,44),(52697931,668901699,45),(52697931,668901711,46),(52697931,668901720,47),(52697931,668901721,48),(52697931,668901723,49),(52697931,668901733,50),(52697931,668901734,51),(52697931,668901735,52),(52697932,668901326,1),(52697932,668901327,2),(52697932,668901328,3),(52697932,668901340,4),(52697932,668901341,5),(52697932,668901342,6),(52697932,668901343,7),(52697932,668901349,8),(52697932,668901350,9),(52697932,668901344,10),(52697932,668901345,11),(52697932,668901347,12),(52697932,668901351,13),(52697932,668901352,14),(52697932,668901353,15),(52697932,668901354,16),(52697932,668901355,17),(52697932,668901356,18),(52697932,668901394,19),(52697932,668901263,20),(52697932,668901264,21),(52697932,668901267,22),(52697932,668901268,23),(52697932,668901269,24),(52697932,668901270,25),(52697932,668901271,26),(52697932,668901309,27),(52697932,668901310,28),(52697932,668901311,29),(52697932,668901312,30),(52697932,668901313,31),(52697932,668901272,32),(52697932,668901273,33),(52697932,668901274,34),(52697932,668901299,35),(52697932,668901300,36),(52697932,668901301,37),(52697932,668901289,38),(52697932,668901307,39),(52697932,668901308,40),(52697932,668901662,41),(52697932,668901680,42),(52697932,668901681,43),(52697932,668901682,44),(52697932,668901683,45),(52697932,668901689,46),(52697932,668901690,47),(52697932,668901691,48),(52697932,668901692,49),(52697932,668901693,50),(52697932,668901842,51),(52697932,668901843,52),(52697932,668901844,53),(52697932,668901845,54),(52697932,668901846,55),(52697932,668901850,56),(52697932,668901851,57),(52697932,668901852,58),(52697934,668901314,1),(52697934,668901319,2),(52697934,668901320,3),(52697934,668901321,4),(52697934,668901684,5),(52697934,668901685,6),(52697934,668901686,7),(52697935,668901335,1),(52697935,668901322,2),(52697935,668901323,3),(52697935,668901203,4),(52697935,668901204,5),(52697935,668901205,6),(52697935,668901206,7),(52697935,668901207,8),(52697935,668901208,9),(52697935,668901209,10),(52697935,668901210,11),(52697935,668901211,12),(52697935,668901212,13),(52697935,668901213,14),(52697935,668901214,15),(52697935,668901215,16),(52697935,668901234,17),(52697935,668901235,18),(52697935,668901236,19),(52697935,668901237,20),(52697935,668901238,21),(52697935,668901239,22),(52697935,668901240,23),(52697935,668901241,24),(52697935,668901242,25),(52697935,668901243,26),(52697935,668901244,27),(52697935,668901216,28),(52697935,668901217,29),(52697935,668901218,30),(52697935,668901219,31),(52697935,668901220,32),(52697935,668901221,33),(52697935,668901222,34),(52697935,668901223,35),(52697935,668901224,36),(52697935,668901225,37),(52697935,668901227,38),(52697935,668901228,39),(52697935,668901229,40),(52697935,668901230,41),(52697935,668901249,42),(52697935,668901250,43),(52697935,668901251,44),(52697935,668901252,45),(52697935,668901253,46),(52697935,668901254,47),(52697935,668901255,48),(52697935,668901259,49),(52697935,668901260,50),(52697935,668901261,51),(52697935,668901262,52),(52697935,668901275,53),(52697935,668901276,54),(52697935,668901277,55),(52697935,668901278,56),(52697935,668901280,57),(52697935,668901281,58),(52697935,668901290,59),(52697935,668901291,60),(52697935,668901292,61),(52697935,668901293,62),(52697935,668901285,63),(52697935,668901286,64),(52697935,668901645,65),(52697935,668901646,66),(52697935,668901647,67),(52697935,668901654,68),(52697935,668901655,69),(52697936,668901620,1),(52697936,668901621,2),(52697936,668901622,3),(52697936,668901623,4),(52697936,668901624,5),(52697936,668901625,6),(52697936,668901626,7),(52697936,668901627,8),(52697936,668901628,9),(52697936,668901933,10),(52697936,668901934,11),(52697936,668901935,12),(52697936,668901936,13),(52697936,668901937,14),(52697936,668901938,15),(52697936,668901939,16),(52697936,668901941,17),(52697936,668901942,18),(52697936,668901943,19),(52697936,668901944,20),(52697936,668901945,21),(52697936,668901949,22),(52697936,668901996,23),(52697936,668901998,24),(52697936,668901982,25),(52697936,668901983,26),(52697936,668901984,27),(52697936,668901966,28),(52697937,668901581,1),(52697937,668901582,2),(52697937,668901583,3),(52697937,668901565,4),(52697937,668901566,5),(52697937,668901567,6),(52697937,668901603,7),(52697937,668901604,8),(52697937,668901595,9),(52697937,668901596,10),(52697937,668901606,11),(52697937,668901607,12),(52697937,668901608,13),(52697937,668901609,14),(52697937,668901910,15),(52697937,668901911,16),(52697937,668901912,17),(52697937,668901913,18),(52697937,668901914,19),(52697937,668901915,20),(52697937,668901916,21),(52697937,668901921,22),(52697937,668901891,23),(52697937,668901892,24),(52697937,668901893,25),(52697937,668901922,26),(52697937,668901923,27),(52697937,668901924,28),(52697937,668901925,29),(52697937,668901953,30),(52697937,668901954,31),(52697937,668901956,32),(52697937,668901973,33),(52697937,668901975,34),(52697937,668901976,35),(52697937,668901991,36),(52697937,668901992,37),(52697938,668901605,1),(52697938,668901597,2),(52697938,668901598,3),(52697938,668901610,4),(52697938,668901611,5),(52697938,668901612,6),(52697938,668901613,7),(52697938,668901614,8),(52697938,668901615,9),(52697938,668901616,10),(52697938,668901617,11),(52697938,668901618,12),(52697938,668901619,13),(52697938,668901529,14),(52697938,668901882,15),(52697938,668901883,16),(52697938,668901884,17),(52697939,668901483,1),(52697939,668901484,2),(52697939,668901494,3),(52697939,668901495,4),(52697939,668901496,5),(52697939,668901497,6),(52697939,668901498,7),(52697939,668901499,8),(52697939,668901574,9),(52697939,668901575,10),(52697939,668901576,11),(52697939,668901577,12),(52697939,668901579,13),(52697939,668901557,14),(52697939,668901552,15),(52697939,668901553,16),(52697939,668901554,17),(52697939,668901555,18),(52697939,668901556,19),(52697939,668901548,20),(52697939,668901549,21),(52697939,668901550,22),(52697939,668901551,23),(52697939,668901558,24),(52697939,668901559,25),(52697939,668901560,26),(52697939,668901561,27),(52697939,668901562,28),(52697939,668901563,29),(52697939,668901592,30),(52697939,668901593,31),(52697939,668901594,32),(52697939,668901599,33),(52697939,668901600,34),(52697939,668901601,35),(52697939,668901602,36),(52697939,668901525,37),(52697939,668901526,38),(52697939,668901527,39),(52697939,668901530,40),(52697939,668901531,41),(52697939,668901532,42),(52697939,668901533,43),(52697939,668901534,44),(52697939,668901535,45),(52697939,668901536,46),(52697939,668901537,47),(52697939,668901538,48),(52697939,668901539,49),(52697939,668901540,50),(52697939,668901541,51),(52697939,668901542,52),(52697939,668901885,53),(52697939,668901886,54),(52697939,668901887,55),(52697939,668901888,56),(52697939,668901889,57),(52697939,668901890,58),(52697939,668901876,59),(52697939,668901881,60),(52697939,668901894,61),(52697939,668901895,62),(52697939,668901896,63),(52697939,668901897,64),(52697939,668901898,65),(52697939,668901899,66),(52697939,668901900,67),(52697939,668901901,68),(52697939,668901931,69),(52697939,668901932,70),(52697939,668901964,71),(52697939,668901965,72),(52697939,668901978,73),(52697939,668901979,74),(52697939,668901980,75),(52697939,668901993,76),(52697939,668901994,77),(52697939,668901995,78),(52697940,668901485,1),(52697940,668901486,2),(52697940,668901464,3),(52697940,668901465,4),(52697940,668901466,5),(52697940,668901467,6),(52697940,668901468,7),(52697940,668901469,8),(52697940,668901470,9),(52697940,668901471,10),(52697940,668901472,11),(52697940,668901473,12),(52697940,668901474,13),(52697940,668901543,14),(52697940,668901544,15),(52697940,668901545,16),(52697940,668901546,17),(52697940,668901547,18),(52697940,668901504,19),(52697940,668901505,20),(52697940,668901506,21),(52697940,668901507,22),(52697940,668901508,23),(52697940,668901510,24),(52697940,668901511,25),(52697940,668901512,26),(52697940,668901513,27),(52697940,668901514,28),(52697940,668901528,29),(52697940,668901517,30),(52697940,668901518,31),(52697940,668901520,32),(52697940,668901521,33),(52697940,668901522,34),(52697940,668901523,35),(52697940,668901524,36),(52697940,668901865,37),(52697940,668901870,38),(52697940,668901871,39),(52697940,668901877,40),(52697941,668901428,1),(52697941,668901430,2),(52697941,668901432,3),(52697941,668901500,4),(52697941,668901501,5),(52697941,668901502,6),(52697941,668901503,7),(52697941,668901515,8),(52697941,668901516,9),(52697942,668901324,1),(52697942,668901325,2),(52697942,668901339,3),(52697942,668901348,4),(52697943,668901329,1),(52697943,668901330,2),(52697943,668901331,3),(52697943,668901332,4),(52697943,668901333,5),(52697943,668901334,6),(52697943,668901202,7),(52697943,668901231,8),(52697943,668901232,9),(52697943,668901233,10),(52697943,668901245,11),(52697943,668901246,12),(52697943,668901247,13),(52697943,668901265,14),(52697943,668901266,15),(52697943,668901248,16),(52697943,668901256,17),(52697943,668901257,18),(52697943,668901258,19),(52697944,668901372,1),(52697944,668901373,2),(52697944,668901375,3),(52697944,668901378,4),(52697944,668901382,5),(52697944,668901383,6),(52697944,668901384,7),(52697944,668901388,8),(52697944,668901389,9),(52697944,668901390,10),(52697944,668901391,11),(52697944,668901392,12),(52697944,668901393,13),(52697944,668901425,14),(52697944,668901426,15),(52697944,668901427,16),(52697944,668901419,17),(52697945,668901475,1),(52697945,668901476,2),(52697945,668901477,3),(52697945,668901487,4),(52697945,668901478,5),(52697945,668901479,6),(52697945,668901480,7),(52697945,668901481,8),(52697945,668901482,9),(52697945,668901488,10),(52697945,668901489,11),(52697945,668901490,12),(52697945,668901491,13),(52697945,668901492,14),(52697945,668901493,15),(52697945,668901572,16),(52697945,668901573,17),(52697945,668901580,18),(52697945,668901584,19),(52697945,668901585,20),(52697945,668901586,21),(52697945,668901587,22),(52697945,668901588,23),(52697945,668901589,24),(52697945,668901590,25),(52697945,668901591,26),(52697945,668901564,27),(52697945,668901568,28),(52697945,668901569,29),(52697945,668901570,30),(52697945,668901571,31),(52697946,668901853,1),(52697946,668901854,2),(52697946,668901855,3),(52697946,668901856,4),(52697946,668901999,5),(52697946,668902000,6),(52697946,668902002,7),(52697946,668902003,8),(52697946,668902005,9),(52697946,668902007,10),(52697946,668902018,11),(52697946,668902019,12),(52697946,668902021,13),(52697946,668902022,14),(52697946,668902011,15),(52697946,668902013,16),(52697946,668902015,17),(52697946,668902016,18),(52697946,668901902,19),(52697946,668901903,20),(52697946,668901904,21),(52697946,668901905,22),(52697946,668901906,23),(52697946,668901907,24),(52697946,668901908,25),(52697946,668901986,26),(52697946,668901987,27),(52697946,668901989,28),(52697947,668901737,1),(52697947,668901769,2),(52697948,668901857,1),(52697948,668901777,2),(52697948,668901778,3),(52697948,668901779,4),(52697948,668901780,5),(52697948,668901770,6),(52697948,668901771,7),(52697948,668901772,8),(52697948,668901774,9),(52697948,668901775,10),(52697948,668901776,11),(52697948,668901781,12),(52697948,668901783,13),(52697948,668901784,14),(52697948,668901785,15),(52697948,668901786,16),(52697948,668901787,17),(52697948,668901788,18),(52697948,668901789,19),(52697948,668901790,20),(52697948,668901791,21),(52697948,668901792,22),(52697948,668901793,23),(52697948,668901782,24),(52697948,668901815,25),(52697948,668901816,26),(52697948,668901817,27),(52697948,668901818,28),(52697948,668901819,29),(52697948,668901820,30),(52697948,668901821,31),(52697948,668901806,32),(52697948,668901807,33),(52697948,668901808,34),(52697948,668901809,35),(52697948,668901822,36),(52697948,668901823,37),(52697948,668901824,38),(52697948,668901825,39),(52697948,668901826,40),(52697948,668901827,41),(52697948,668901828,42),(52697948,668901810,43),(52697948,668901811,44),(52697948,668901812,45),(52697948,668901813,46),(52697948,668901814,47),(52697948,668901794,48),(52697948,668901795,49),(52697948,668901796,50),(52697948,668901797,51),(52697948,668901798,52),(52697948,668901799,53),(52697948,668901800,54),(52697948,668901801,55),(52697948,668901802,56),(52697948,668901761,57),(52697948,668901762,58),(52697948,668901763,59),(52697948,668901764,60),(52697948,668901765,61),(52697948,668901766,62),(52697948,668901767,63),(52697948,668901768,64),(52697948,668901751,65),(52697948,668901752,66),(52697948,668901753,67),(52697948,668901754,68),(52697948,668901755,69),(52697948,668901756,70),(52697948,668901757,71),(52697948,668901743,72),(52697948,668901744,73),(52697948,668901745,74),(52697948,668901746,75),(52697948,668901747,76),(52697948,668901748,77),(52697948,668901749,78),(52697948,668901750,79),(52697948,668901630,80),(52697948,668901631,81),(52697948,668901632,82),(52697948,668901633,83),(52697948,668901634,84),(52697948,668901635,85),(52697948,668901636,86),(52697948,668901637,87),(52697948,668901638,88),(52697948,668901639,89),(52697948,668901640,90),(52697948,668901641,91),(52697948,668901642,92),(52697948,668901643,93),(52697948,668901644,94);
INSERT INTO `current_way_nodes` VALUES (52697948,668901758,95),(52697948,668901759,96),(52697948,668901760,97),(52697948,668901803,98),(52697948,668901804,99),(52697948,668901805,100),(52697948,668901700,101),(52697948,668901701,102),(52697948,668901702,103),(52697948,668901703,104),(52697948,668901704,105),(52697948,668901705,106),(52697948,668901706,107),(52697948,668901707,108),(52697948,668901708,109),(52697948,668901709,110),(52697948,668901710,111),(52697948,668901724,112),(52697948,668901725,113),(52697948,668901726,114),(52697948,668901727,115),(52697948,668901728,116),(52697948,668901729,117),(52697948,668901730,118),(52697948,668901731,119),(52697948,668901738,120),(52697948,668901739,121),(52697948,668901740,122),(52697948,668901741,123),(52697948,668901742,124),(52697949,668901732,1),(52697949,668901648,2),(52697950,668901829,1),(52697950,668901831,2),(52697950,668901833,3),(52697950,668901834,4),(52697950,668901835,5),(52697950,668901836,6),(52697950,668901837,7),(52697950,668901838,8),(52697950,668901839,9),(52697950,668901840,10),(52697951,668901652,1),(52697951,668901653,2),(52697951,668901673,3),(52697951,668901674,4),(52697951,668901675,5),(52697951,668901678,6),(52697951,668901679,7),(52697951,668901687,8),(52697951,668901688,9),(52697951,668901712,10),(52697951,668901713,11),(52697951,668901714,12),(52697951,668901715,13),(52697951,668901716,14),(52697951,668901717,15),(52697951,668901718,16),(52697951,668901719,17),(52697951,668901736,18),(52697951,668901732,19),(52697952,668901917,1),(52697952,668901918,2),(52697952,668901919,3),(52697952,668901920,4),(52697952,668901926,5),(52697952,668901927,6),(52697952,668901928,7),(52697952,668901929,8),(52697952,668901930,9),(52697952,668901957,10),(52697952,668901959,11),(52697952,668901960,12),(52697952,668901962,13),(54858984,690708536,1),(54858984,690708536,2),(61736197,769251745,1),(61736197,51119556,2),(61736197,51119558,3),(61736197,51119559,4),(61736197,51119560,5),(61736197,51119407,6),(61736197,51119409,7),(61736197,51119410,8),(61736197,51119411,9),(61736197,51119413,10),(61736197,51119414,11),(61736197,51119416,12),(61736197,51119417,13),(61736197,51119419,14),(61736197,51119420,15),(61736197,51119421,16),(61736197,51119422,17),(61736197,51119424,18),(61736197,51119425,19),(61736197,51119426,20),(61736197,51119427,21),(61736197,51119428,22),(61736197,51119430,23),(61736197,51119431,24),(61736197,51119432,25),(61736197,51119433,26),(61736197,51119058,27),(61736197,51119435,28),(61736197,51119060,29),(61736197,51119061,30),(61736197,51119062,31),(61736197,51119064,32),(61736197,51119065,33),(61736199,51119065,1),(61736199,51119066,2),(61736199,51119067,3),(61736199,51119069,4),(61736199,51119070,5),(61736199,51119071,6),(61736199,51119072,7),(61736200,51119072,1),(61736200,51119073,2),(61736200,51119075,3),(61736200,51119076,4),(61736200,51119077,5),(61736200,51119078,6),(61736200,51119079,7),(61736200,51119081,8),(61736200,51119082,9),(61736200,51119083,10),(61736200,769251759,11),(61736202,769251759,1),(61736202,51119085,2),(61736202,51119086,3),(61736202,51119088,4),(61736202,51119089,5),(61736202,51119090,6),(61736202,51119091,7),(61736203,51119091,1),(61736203,51119093,2),(61736203,51119094,3),(61736203,51119096,4),(61736203,51119097,5),(61736203,51119098,6),(61736203,51119099,7),(61736203,51119101,8),(61736203,51119102,9),(61736203,51119103,10),(61736203,51119104,11),(61736203,51119105,12),(61736208,51119548,1),(61736208,51119547,2),(61736208,51119546,3),(61736208,51119545,4),(61736208,51119543,5),(61736208,51119542,6),(61736208,51119541,7),(61736208,51119617,8),(61736208,51119616,9),(61736208,51119615,10),(61736208,51119614,11),(61736208,51119613,12),(61736208,51119994,13),(61736208,51119993,14),(61736208,51119992,15),(61736208,51119991,16),(61736208,51119990,17),(61736208,51119989,18),(61736208,51119988,19),(61736208,51119987,20),(61736208,51119986,21),(61736208,51119984,22),(61736208,51119983,23),(61736208,51119981,24),(61736208,51119980,25),(61736208,51119979,26),(61736208,51119978,27),(61736208,51119977,28),(61736208,51119976,29),(61736208,51119974,30),(61736208,51119973,31),(61736208,51119972,32),(61736208,51119970,33),(61736208,51119969,34),(61736208,769251780,35),(61736208,51119968,36),(61736208,51119966,37),(61736208,51119965,38),(61736208,51119964,39),(61736208,51119962,40),(61736208,769251779,41),(61736208,51119961,42),(61736208,51119960,43),(61736208,51119959,44),(61736208,51119958,45),(61736208,769251793,46),(61736208,51119957,47),(61736208,51119956,48),(61736208,51119954,49),(61736208,51119953,50),(61736208,51119952,51),(61736208,51119951,52),(61736209,51119548,1),(61736209,51119550,2),(61736209,51119551,3),(61736209,51119553,4),(61736209,51119554,5),(61736209,51119555,6),(61736209,769251745,7),(70427100,840392122,1),(70427100,840392129,2),(70427114,51952060,1),(70427114,840392214,2),(70427114,840392122,3),(70427179,840392129,1),(70427179,840392132,2),(70427179,840392146,3),(70427179,840392147,4),(70427179,840392149,5),(70427179,840392151,6),(70427179,840392153,7),(70427179,840392156,8),(70427179,840392161,9),(70427179,840392165,10),(70427179,840392168,11),(70427179,840392171,12),(70427179,840392172,13),(70427179,840392174,14),(70427179,840392177,15),(70427179,840392179,16),(70427179,840392182,17),(70427179,840406394,18),(70427179,840392185,19),(70427179,840405569,20),(70427179,840392187,21),(70427179,840392190,22),(70427179,51952269,23),(70428387,840392129,1),(70428387,840392122,2),(75744715,894217189,1),(75744715,894217192,2),(75744715,894217206,3),(75744715,894217183,4),(75744715,894259125,5),(75744715,894217188,6),(75744715,894217191,7),(75744715,894217204,8),(75744715,894217170,9),(75744715,894217190,10),(75744715,894217194,11),(75744715,894217168,12),(75744715,894217186,13),(75744715,894217167,14),(75746393,894259639,1),(75746393,894259324,2),(75746394,894259087,1),(75746394,894259278,2),(75746394,894259590,3),(75746394,894259753,4),(75746395,894259636,1),(75746395,894259622,2),(75746395,894259060,3),(75746395,894259248,4),(75746395,894259034,5),(75746395,894259217,6),(75746395,894259536,7),(75746395,894259702,8),(75746395,894259161,9),(75746395,894259344,10),(75746395,894259664,11),(75746395,894258994,12),(75746395,894259462,13),(75746395,894259641,14),(75746395,894259089,15),(75746395,894259280,16),(75746395,894259600,17),(75746395,894259757,18),(75746395,894259221,19),(75746395,894259405,20),(75746395,894259187,21),(75746395,894259370,22),(75746395,894259685,23),(75746395,894259014,24),(75746395,894259328,25),(75746395,894259513,26),(75746395,894258982,27),(75746395,894259141,28),(75746395,894258967,29),(75746395,894259111,30),(75746395,894259431,31),(75746395,894259624,32),(75746395,894259063,33),(75746395,894259251,34),(75746395,894259562,35),(75746395,894259726,36),(75746395,894259540,37),(75746395,894259703,38),(75746395,894259164,39),(75746395,894259348,40),(75746395,894259665,41),(75746395,894258996,42),(75746395,894259300,43),(75746395,894259483,44),(75746395,894259271,45),(75746395,894259449,46),(75746395,894259746,47),(75746395,894259083,48),(75746396,894259570,1),(75746396,894259525,2),(75746396,894259687,3),(75746396,894259144,4),(75746397,894258985,1),(75746397,894259284,2),(75746397,894259468,3),(75746397,894259257,4),(75746397,894259435,5),(75746397,894259732,6),(75746397,894259067,7),(75746397,894259375,8),(75746397,894259576,9),(75746397,894259022,10),(75746397,894259195,11),(75746397,894258998,12),(75746397,894259171,13),(75746397,894259492,14),(75746397,894259666,15),(75746397,894259118,16),(75746397,894259331,17),(75746398,894259193,1),(75746398,51362129,2),(75746398,625199,3),(75746398,625200,4),(75746398,51362133,5),(75746398,51362135,6),(75746398,51362009,7),(75746398,625202,8),(75746398,51362011,9),(75746398,625203,10),(75746398,51362012,11),(75746398,625204,12),(75746398,51126211,13),(75746399,894259331,1),(75746399,894259515,2),(75746400,894259324,1),(75746400,894259489,2),(75746400,894259276,3),(75746400,894259456,4),(75746400,894259750,5),(75746400,894259085,6),(75746400,894259402,7),(75746400,894259587,8),(75746400,894259046,9),(75746400,894259351,10),(75746400,894259547,11),(75746400,894258997,12),(75746400,894259168,13),(75746400,894259486,14),(75746400,894259533,15),(75746400,894258992,16),(75746400,894259155,17),(75746400,894259480,18),(75746400,894259662,19),(75746400,894259107,20),(75746400,894259297,21),(75746400,894259073,22),(75746400,894259262,23),(75746400,894259582,24),(75746400,894259743,25),(75746400,894259206,26),(75746400,894259386,27),(75746400,894259700,28),(75746400,894259032,29),(75746400,894259678,30),(75746400,894259010,31),(75746401,894259722,1),(75746401,894259053,2),(75746401,894259358,3),(75746401,894259556,4),(75746402,894217191,1),(75746402,894259773,2),(75746402,894259091,3),(75746402,894259411,4),(75746403,894259390,1),(75746403,894259706,2),(75746403,894259040,3),(75746403,894259680,4),(75746404,894259509,1),(75746404,894259682,2),(75746404,894259473,3),(75746404,894259658,4),(75746404,894259098,5),(75746404,894259294,6),(75746404,894259613,7),(75746404,894258960,8),(75746404,894259242,9),(75746404,894259424,10),(75746404,894259199,11),(75746404,894259379,12),(75746405,894259118,1),(75746405,894259114,2),(75746405,894259433,3),(75746405,894259627,4),(75746405,894259353,5),(75746406,894259125,1),(75746406,894259451,2),(75746406,894259636,3),(75746409,51420970,1),(75746409,894259379,2),(75746409,51973102,3),(75746409,51973105,4),(75746409,51973108,5),(75746409,51973112,6),(75746409,51973113,7),(75746409,51973117,8),(75746409,51973120,9),(75746409,51973122,10),(75746409,894259722,11),(75746409,894259509,12),(75746409,894259176,13),(75746409,51973125,14),(75746409,894259274,15),(75746409,51973128,16),(75746409,51973131,17),(75746409,51973135,18),(75746409,51973138,19),(75746409,924524128,20),(75746409,51973141,21),(75746409,51973144,22),(75746409,51973147,23),(75746409,51973150,24),(75746409,51973154,25),(75746409,51973156,26),(75746409,51973158,27),(75746409,51973161,28),(75746409,51973163,29),(75746409,51973166,30),(75746409,51973170,31),(75746409,51973172,32),(75746409,51973175,33),(75746409,51973177,34),(75746409,51973179,35),(75746409,51973183,36),(75746409,51973186,37),(75746409,51973190,38),(75746409,51973193,39),(75746409,51973196,40),(75746409,51973198,41),(75746409,51973201,42),(75746409,51973203,43),(75746409,51973206,44),(75746409,51973208,45),(75746409,51973210,46),(75746409,51973213,47),(75746409,51973215,48),(75746409,51973219,49),(75746409,51973221,50),(75746409,51973223,51),(75746409,51973225,52),(75746409,51973228,53),(75746409,51973234,54),(75746409,51973237,55),(75746409,51973241,56),(75746409,51973243,57),(75746409,51973247,58),(75746409,51973249,59),(75746409,51973253,60),(75746409,51973256,61),(75746409,51973260,62),(75746409,51973264,63),(75746409,51973268,64),(75746409,51973269,65),(75746409,51973273,66),(75746409,51973276,67),(75746409,51973278,68),(75746409,51973281,69),(75746409,51973284,70),(75746409,51973287,71),(75746409,51973290,72),(75746409,51973293,73),(75746409,51973296,74),(75746409,51973300,75),(75746409,51973302,76),(75746409,51973306,77),(75746409,51973310,78),(75746409,51973313,79),(75746409,51973316,80),(75746409,51973320,81),(75746409,51973324,82),(75746409,51973326,83),(75746409,51973327,84),(75746409,51973329,85),(75746409,51973334,86),(75746409,51973336,87),(75746409,51973339,88),(75746409,51973341,89),(75746409,51973344,90),(75746409,51973346,91),(75746409,51973348,92),(75746409,51973351,93),(75746409,51973352,94),(75746409,51973353,95),(75746409,51973354,96),(75746409,51973356,97),(75746409,51973357,98),(75746409,51973359,99),(75746409,51973361,100),(75746409,51973362,101),(75746409,51973363,102),(75746409,51973364,103),(75746409,51973366,104),(75746409,51973369,105),(75746409,51973370,106),(75746409,51973373,107),(75746409,51973375,108),(75746409,51973378,109),(75746409,51973380,110),(75746409,51973384,111),(75746409,51973387,112),(75746409,51973390,113),(75746409,51973394,114),(75746409,51973396,115),(75746409,51973398,116),(75746409,51973400,117),(75746409,51973403,118),(75746409,51973405,119),(75746409,51973407,120),(75746409,51973409,121),(75746409,51973413,122),(75746409,51973416,123),(75746409,51973417,124),(75746409,51973419,125),(75746409,51973424,126),(75746409,51973426,127),(75746409,51973428,128),(75746409,51973430,129),(75746409,51973432,130),(75746409,51973436,131),(75746409,51973439,132),(75746409,51973441,133),(75746409,51973444,134),(75746409,51973448,135),(75746409,51973451,136),(75746409,51973454,137),(75746409,51973456,138),(75746409,51973459,139),(75746409,51973462,140),(75746409,51973467,141),(75746409,51973470,142),(75746409,51973471,143),(75746409,51973475,144),(75746409,51973478,145),(75746409,51973481,146),(75746409,51973484,147),(75746409,51973487,148),(75746409,51973489,149),(75746409,51973491,150),(75746409,51973494,151),(75746409,51973497,152),(75746409,51973499,153),(75746409,51973501,154),(75746410,894259451,1),(75746410,894259228,2),(75746410,894259051,3),(75746410,894259604,4),(75746410,894259414,5),(75746410,894259093,6),(75746410,894259774,7),(75746410,894259122,8),(75746410,894258972,9),(75746410,894259499,10),(75746410,894259313,11),(75746410,894259008,12),(75746410,894259676,13),(75746410,894259356,14),(75746410,894259174,15),(75746410,894259382,16),(75746410,894259202,17),(75746410,894259742,18),(75746410,894259580,19),(75746410,894259261,20),(75746410,894259070,21),(75746410,894259633,22),(75746410,894259437,23),(75746410,894259660,24),(75746410,894259476,25),(75746410,894259152,26),(75746410,894258989,27),(75746410,894259531,28),(75746410,894259337,29),(75746410,894259030,30),(75746410,894259699,31),(75746410,894259057,32),(75746410,894259724,33),(75746410,894259427,34),(75746410,894259245,35),(75746410,894258963,36),(75746410,894259617,37),(75746410,894259295,38),(75746410,894259105,39),(75746410,894259320,40),(75746410,894259137,41),(75746410,894259683,42),(75746410,894259511,43),(75746410,894259178,44),(75746410,894259012,45),(75746410,894259559,46),(75746410,894259360,47),(75746410,894259417,48),(75746410,894259236,49),(75746410,894258957,50),(75746410,894259610,51),(75746410,894259282,52),(75746410,894259096,53),(75746410,894259650,54),(75746410,894259465,55),(75746410,894259083,56),(75746410,894259037,57),(75746410,894259553,58),(75746410,894259721,59),(75746410,894259527,60),(75746410,894259698,61),(75746410,894259148,62),(75746410,894259335,63),(75746410,894259654,64),(75746410,894258985,65),(75746411,894259254,1),(75746411,894259334,2),(75746412,894259135,1),(75746412,894259398,2),(75746412,894259585,3),(75746412,894259043,4),(75746412,894259219,5),(75746412,894259310,6),(75746414,894259297,1),(75746414,894259439,2),(75746414,894259486,3),(75746415,894259572,1),(75746415,894259232,2),(75746415,894259307,3),(75746415,894259020,4),(75746415,894259607,5),(75746415,894259550,6),(75746415,894259193,7),(75746415,894259720,8),(75746415,894259372,9),(75746415,894259572,10),(75746416,894259091,1),(75746416,894259254,2),(75746416,894259570,3),(75746416,894259729,4),(75746416,894217170,5),(75746417,894259729,1),(75746417,894259188,2),(75746418,894259353,1),(75746418,894259135,2),(75746419,894259515,1),(75746419,894259310,2),(75746419,894259630,3),(75746419,894258969,4),(75746419,894259602,5),(75746419,894259760,6),(75746419,894259225,7),(75746419,894259408,8),(75746419,894259556,9),(75746419,894259708,10),(75746419,53335702,11),(75746419,53335700,12),(75746421,894259697,1),(75746421,894258974,2),(75746421,894259753,3),(75746421,894259139,4),(75746421,894259459,5),(75746421,894259697,6),(75746422,894259303,1),(75746422,894259639,2),(75746423,894259274,1),(75746423,894259453,2),(75746423,894259748,3),(75746424,894259700,1),(75746424,894259318,2),(75746424,894259503,3),(75871448,895601493,1),(75871448,897596948,2),(75871448,895601497,3),(77918991,915765650,1),(77918991,915765239,2),(77918991,915765686,3),(77918991,915766458,4),(77918991,915766750,5),(77918991,915766344,6),(77918991,915766632,7),(77918991,915765922,8),(77918991,915766135,9),(77918991,915765801,10),(77918991,915766018,11),(77918991,915764943,12),(77918991,915765496,13),(77918991,915766737,14),(77918991,915765201,15),(77918991,915766227,16),(77918991,915766445,17),(77918991,915766604,18),(77918991,915766830,19),(77918991,915766108,20),(77918991,915766317,21),(77918991,915765994,22),(77918991,915766204,23),(77918991,915765418,24),(77918991,915765778,25),(77918991,915765142,26),(77918991,915765630,27),(77918991,915766418,28),(77918991,915766711,29),(77918991,915765885,30),(77918991,915766099,31),(77918991,915765906,32),(79126612,924524128,1),(79126612,894258985,2);
INSERT INTO `current_way_tags` VALUES (6165450,'created_by','Potlatch 0.10'),(6165450,'highway','primary'),(6165450,'junction','roundabout'),(6165679,'admin_level','2'),(6165679,'border_type','nation'),(6165679,'boundary','administrative'),(6165679,'left:country','Andorra'),(6165679,'name','ES, FR'),(6165679,'right:country','Spain'),(6165679,'source','CIA World Database II'),(6165877,'highway','primary'),(6165877,'maxspeed','60'),(6165877,'ref','CG-2'),(6165877,'source','yahoo'),(6165944,'created_by','Potlatch 0.9c'),(6165944,'highway','primary'),(6165944,'ref','CG-2'),(6165944,'source','yahoo'),(6166082,'created_by','Potlatch 0.9c'),(6166082,'highway','primary'),(6166082,'ref','CG-2'),(6166082,'source','yahoo'),(6166123,'created_by','Potlatch 0.9c'),(6166123,'highway','primary'),(6166123,'ref','CG-2'),(6166123,'source','yahoo'),(6166128,'created_by','Potlatch 0.9a'),(6166128,'highway','primary'),(6166128,'ref','CG-2'),(6166128,'source','yahoo'),(6166136,'highway','primary'),(6166136,'junction','roundabout'),(6166145,'created_by','Potlatch 0.9a'),(6166145,'highway','primary'),(6166145,'ref','CG-2'),(6166145,'source','yahoo'),(6166185,'created_by','Potlatch 0.9a'),(6166185,'highway','primary'),(6166185,'ref','CG-2'),(6166185,'source','yahoo'),(6176624,'highway','primary'),(6176624,'oneway','yes'),(6176663,'highway','primary'),(6176663,'junction','roundabout'),(6176681,'highway','primary'),(6176681,'ref','CG-2'),(6176681,'source','yahoo'),(6176681,'toll','yes'),(6176755,'highway','primary'),(6176755,'layer','-1'),(6176755,'name','Túnel d\' Envalira'),(6176755,'ref','CG-2'),(6176755,'source','yahoo and guess'),(6176755,'toll','yes'),(6176755,'tunnel','yes'),(6177152,'created_by','Potlatch 0.9a'),(6177152,'highway','primary'),(6177152,'oneway','yes'),(6177152,'ref','CG-2'),(6177152,'source','yahoo'),(6177369,'created_by','Potlatch 0.9a'),(6177369,'highway','primary'),(6177369,'ref','CG-2'),(6177369,'source','yahoo'),(6177399,'created_by','Potlatch 0.9a'),(6177399,'highway','primary'),(6177399,'ref','CG-2'),(6177399,'source','yahoo'),(6177409,'created_by','Potlatch 0.8c'),(6177409,'highway','primary'),(6177409,'ref','CG-2'),(6177409,'source','yahoo'),(6178503,'created_by','Potlatch 0.9a'),(6178503,'highway','primary'),(6178503,'oneway','yes'),(6178503,'ref','CG-2'),(6178503,'source','yahoo'),(6178632,'created_by','Potlatch 0.9a'),(6178632,'highway','primary'),(6178632,'ref','CG-2'),(6178632,'source','yahoo'),(6178685,'created_by','Potlatch 0.9a'),(6178685,'highway','primary'),(6178685,'oneway','yes'),(6178685,'ref','CG-2'),(6178685,'source','yahoo'),(6178688,'created_by','Potlatch 0.9a'),(6178688,'highway','primary'),(6178688,'oneway','yes'),(6178688,'ref','CG-2'),(6178688,'source','yahoo'),(6178694,'highway','primary'),(6178694,'ref','CG-2'),(6178694,'source','yahoo'),(6178791,'created_by','Potlatch 0.9a'),(6178791,'highway','primary'),(6178791,'ref','CG-2'),(6178791,'source','yahoo'),(6178964,'leisure','pitch'),(6178964,'sport','soccer'),(6178980,'created_by','Potlatch 0.8a'),(6178980,'leisure','pitch'),(6178980,'sport','tennis'),(6179103,'highway','primary'),(6179103,'ref','CG-2'),(6179103,'source','yahoo'),(6179174,'created_by','Potlatch 0.9a'),(6179174,'highway','primary'),(6179174,'oneway','yes'),(6179174,'ref','CG-2'),(6179174,'source','yahoo'),(6179240,'created_by','Potlatch 0.9c'),(6179240,'highway','primary'),(6179240,'junction','roundabout'),(6179270,'bridge','yes'),(6179270,'created_by','Potlatch 0.9a'),(6179270,'highway','primary'),(6179270,'layer','3'),(6179270,'ref','CG-2'),(6179270,'source','yahoo'),(6179470,'layer','1'),(6179470,'leisure','pitch'),(6179470,'sport','soccer'),(6179561,'created_by','Potlatch 0.8a'),(6179561,'leisure','track'),(6179561,'sport','athletics'),(6179675,'highway','primary'),(6179675,'ref','CG-2'),(6179675,'source','yahoo'),(6179692,'created_by','Potlatch 0.10'),(6179692,'highway','primary'),(6179692,'lanes','3'),(6179692,'ref','CG-2'),(6179692,'source','yahoo'),(6180790,'created_by','Potlatch 0.10'),(6180790,'highway','primary'),(6180790,'oneway','yes'),(6180790,'ref','CG-1'),(6180790,'source','yahoo'),(6180839,'bridge','yes'),(6180839,'created_by','Potlatch alpha'),(6180839,'highway','primary'),(6180839,'layer','3'),(6180839,'ref','CG-2'),(6180839,'source','yahoo'),(6180840,'highway','primary'),(6180840,'ref','CG-1'),(6180840,'source','yahoo'),(6180852,'created_by','Potlatch 0.10'),(6180852,'highway','primary'),(6180852,'ref','CG-1'),(6180852,'source','yahoo'),(6180968,'highway','primary'),(6180968,'ref','CG-2'),(6180968,'source','yahoo'),(6180977,'created_by','Potlatch 0.9c'),(6180977,'highway','primary'),(6180977,'ref','CG-2'),(6180977,'source','yahoo'),(6180985,'created_by','Potlatch 0.9c'),(6180985,'highway','primary'),(6180985,'ref','CG-2'),(6180985,'source','yahoo'),(6180988,'created_by','Potlatch 0.9a'),(6180988,'highway','primary'),(6180988,'ref','CG-2'),(6180988,'source','yahoo'),(6181319,'created_by','Potlatch alpha'),(6181319,'highway','secondary'),(6181319,'name','Carrer de Sant Jordi'),(6181357,'created_by','Potlatch alpha'),(6181357,'highway','residential'),(6181357,'name','Carrer Solana'),(6181419,'created_by','Potlatch alpha'),(6181419,'highway','service'),(6181836,'highway','secondary'),(6181838,'created_by','Potlatch 0.8c'),(6181838,'highway','secondary'),(6181838,'ref','CS-280'),(6181947,'boat','no'),(6181947,'created_by','Potlatch 0.8a'),(6181947,'waterway','stream'),(6182051,'created_by','Potlatch 0.10f'),(6182051,'highway','tertiary'),(6182051,'name','Carrer Bonaventura Riberaygua'),(6182051,'oneway','yes'),(6182051,'source','yahoo'),(6182052,'FIXME','Missing name'),(6182052,'highway','residential'),(6182052,'name','Carrer de Joan Maragall'),(6182052,'source','yahoo'),(6182053,'created_by','Potlatch 0.9c'),(6182053,'highway','residential'),(6182053,'name','Carrer Pere d\'Urg'),(6182053,'source','yahoo'),(6182054,'FIXME','Missing name'),(6182054,'highway','residential'),(6182054,'source','yahoo'),(6182056,'created_by','Potlatch 0.9c'),(6182056,'highway','residential'),(6182056,'name','Carrer de la Borda'),(6182056,'source','yahoo'),(6182057,'created_by','Potlatch 0.9c'),(6182057,'highway','pedestrian'),(6182057,'name','Carrer de l\'Aigüeta'),(6182057,'source','yahoo'),(6182058,'created_by','Potlatch 0.9c'),(6182058,'highway','tertiary'),(6182058,'name','Carrer de la Sardana'),(6182058,'source','yahoo'),(6182065,'created_by','Potlatch 0.10f'),(6182065,'highway','tertiary'),(6182065,'name','Carrer Verge del Pilar'),(6182065,'oneway','yes'),(6182097,'highway','secondary'),(6182097,'name','Avinguda Meritxell'),(6182097,'oneway','yes'),(6182122,'highway','tertiary'),(6182122,'name','Carrer de la Constituciò'),(6182122,'source','survey'),(6182127,'created_by','Potlatch 0.10f'),(6182127,'highway','tertiary'),(6182127,'name','Carrer Ciutat de Sabadell'),(6182127,'source','yahoo'),(6182159,'highway','secondary'),(6182159,'name','Avinguda de les Escoles'),(6182159,'source','survey'),(6182267,'FIXME','Missing name'),(6182267,'highway','residential'),(6182267,'source','yahoo'),(6182278,'highway','secondary'),(6182278,'junction','roundabout'),(6182278,'source','yahoo'),(6182289,'created_by','Potlatch 0.9c'),(6182289,'highway','secondary'),(6182289,'name','Baixada del molí'),(6182303,'created_by','Potlatch 0.10f'),(6182303,'highway','primary'),(6182303,'name','Avinguda Prat de la Creu'),(6182303,'ref','CG3a'),(6182333,'highway','primary'),(6182333,'junction','roundabout'),(6182333,'source','yahoo'),(6182349,'created_by','Potlatch 0.9c'),(6182349,'highway','tertiary'),(6182349,'name','Carrer Doctor Vilanova'),(6182349,'source','yahoo'),(6182350,'bridge','yes'),(6182350,'created_by','Potlatch 0.9c'),(6182350,'highway','tertiary'),(6182350,'layer','1'),(6182350,'name','Carrer Doctor Vilanova'),(6182350,'source','yahoo'),(6182364,'created_by','Potlatch 0.9c'),(6182364,'highway','primary'),(6182364,'name','Avinguda Consell d\'Europa'),(6182364,'oneway','yes'),(6182364,'source','yahoo'),(6182371,'created_by','Potlatch 0.9c'),(6182371,'highway','primary'),(6182371,'name','Avinguda Fiter i Rossell'),(6182371,'oneway','yes'),(6182371,'ref','CG-3a'),(6182371,'source','yahoo'),(6182386,'created_by','Potlatch 0.9c'),(6182386,'highway','tertiary'),(6182386,'name','Carrer Pau Casals'),(6182386,'source','survey'),(6182401,'created_by','Potlatch 0.10f'),(6182401,'highway','tertiary'),(6182401,'name','Carrer Josep Rossell i Calva'),(6182401,'source','yahoo'),(6182410,'highway','primary'),(6182410,'junction','roundabout'),(6182410,'layer','2'),(6182463,'FIXME','Missing name'),(6182463,'highway','residential'),(6182463,'source','yahoo'),(6182505,'highway','primary'),(6182505,'junction','roundabout'),(6182542,'created_by','Potlatch 0.8a'),(6182542,'highway','primary'),(6182542,'layer','2'),(6182542,'oneway','yes'),(6182542,'ref','CG3i4'),(6182542,'source','yahoo'),(6182577,'FIXME','Missing name'),(6182577,'highway','residential'),(6182577,'source','yahoo'),(6182675,'FIXME','Missing name'),(6182675,'highway','residential'),(6182675,'source','yahoo'),(6182714,'FIXME','Missing name'),(6182714,'highway','residential'),(6182714,'source','yahoo'),(6182761,'highway','primary_link'),(6182761,'layer','2'),(6182761,'oneway','yes'),(6182761,'source','yahoo'),(6182765,'created_by','Potlatch 0.9a'),(6182765,'highway','primary_link'),(6182765,'source','yahoo'),(6182771,'created_by','Potlatch 0.9c'),(6182771,'highway','tertiary'),(6182771,'name','Carrer Sant Antoni'),(6182771,'oneway','yes'),(6182771,'source','yahoo'),(6182773,'created_by','Potlatch 0.9c'),(6182773,'highway','tertiary'),(6182773,'name','Carrer Isabelle Sandy'),(6182773,'oneway','yes'),(6182773,'source','yahoo'),(6182798,'created_by','Potlatch 0.10f'),(6182798,'highway','residential'),(6182798,'name','Carrer Ciutat de Consuegra'),(6182798,'oneway','yes'),(6182798,'source','yahoo'),(6182810,'created_by','Potlatch 0.9c'),(6182810,'highway','residential'),(6182810,'name','Carrer Callueta'),(6182810,'source','yahoo'),(6182844,'amenity','parking'),(6182844,'created_by','Potlatch alpha'),(6182932,'created_by','Potlatch alpha'),(6182932,'highway','secondary'),(6182932,'ref','CS-101'),(6183078,'FIXME','Missing name'),(6183078,'highway','residential'),(6183100,'highway','secondary'),(6183100,'name','Carretera d\'Engolasters'),(6183100,'ref','CS-200'),(6183127,'FIXME','Missing name'),(6183127,'highway','residential'),(6183169,'created_by','Potlatch 0.10d'),(6183169,'highway','secondary'),(6183169,'name','Carretera de la Comella'),(6183169,'ref','CS-101'),(6183270,'FIXME','Missing name'),(6183270,'highway','residential'),(6183273,'FIXME','Missing name'),(6183273,'highway','residential'),(6183357,'FIXME','Missing name'),(6183357,'highway','residential'),(6183360,'FIXME','Missing name'),(6183360,'highway','residential'),(6183573,'FIXME','Missing name'),(6183573,'highway','residential'),(6184947,'amenity','parking'),(6184947,'created_by','Potlatch alpha'),(6185032,'created_by','Potlatch 0.10'),(6185032,'highway','tertiary'),(6185032,'name','Carrer Prat Salit'),(6185060,'FIXME','Missing name'),(6185060,'highway','residential'),(6185090,'FIXME','Missing name'),(6185090,'highway','residential'),(6185110,'created_by','Potlatch 0.10f'),(6185110,'highway','unclassified'),(6185110,'name','Carrer Bonnavista'),(6185122,'created_by','Potlatch 0.10'),(6185122,'highway','unclassified'),(6185122,'name','Carrer Castellà de Sucarà'),(6185149,'FIXME','Missing name'),(6185149,'highway','residential'),(6185336,'access','permissive'),(6185336,'created_by','Potlatch 0.10'),(6185336,'highway','primary'),(6185336,'oneway','yes'),(6185336,'ref','CG-2'),(6185336,'source','yahoo'),(6185353,'FIXME','Missing name'),(6185353,'highway','residential'),(6185363,'FIXME','Missing name'),(6185363,'highway','residential'),(6185394,'created_by','Potlatch 0.9c'),(6185394,'highway','residential'),(6185394,'name','Carrer Esteve Dolsa Pujol'),(6185394,'source','yahoo'),(6185421,'created_by','Potlatch 0.9a'),(6185421,'highway','residential'),(6185421,'name','Carrer Fiter i Rossell'),(6185589,'created_by','Potlatch 0.9c'),(6185589,'highway','residential'),(6185589,'name','Carrer de l\'Alzinaret'),(6185589,'source','yahoo'),(6185611,'created_by','Potlatch 0.9c'),(6185611,'highway','residential'),(6185611,'name','Carrer del Carubell'),(6185611,'source','yahoo'),(6185640,'FIXME','Missing name'),(6185640,'highway','residential'),(6185640,'name','Carrer del Doctor Molines'),(6185640,'source','yahoo'),(6185710,'amenity','parking'),(6185710,'created_by','Potlatch alpha'),(6185726,'created_by','Potlatch 0.9c'),(6185726,'highway','tertiary'),(6185726,'name','Carrer Sant Andreu'),(6185726,'source','yahoo'),(6185775,'created_by','Potlatch 0.9c'),(6185775,'highway','tertiary'),(6185775,'name','Carrer Maria Plà'),(6185775,'oneway','yes'),(6185775,'source','yahoo'),(6185795,'FIXME','Missing name'),(6185795,'highway','residential'),(6185795,'source','yahoo'),(6185800,'created_by','Potlatch 0.10f'),(6185800,'highway','secondary'),(6185800,'name','Avinguda Carlemany'),(6185800,'oneway','yes'),(6185800,'source','yahoo'),(6185807,'created_by','Potlatch 0.10f'),(6185807,'highway','secondary'),(6185807,'name','Avinguda Carlemany'),(6185807,'oneway','yes'),(6185807,'source','yahoo'),(6185826,'created_by','Potlatch 0.9c'),(6185826,'highway','tertiary'),(6185826,'name','Carrer Prat Gran'),(6185826,'source','survey'),(6185878,'created_by','Potlatch 0.9c'),(6185878,'highway','tertiary'),(6185878,'name','Carrer de Parnal'),(6185878,'source','survey'),(6185911,'FIXME','Missing name'),(6185911,'highway','residential'),(6185911,'source','yahoo'),(6185926,'FIXME','Missing name'),(6185926,'highway','residential'),(6185926,'source','yahoo'),(6185930,'FIXME','Missing name'),(6185930,'highway','residential'),(6185930,'source','yahoo'),(6185971,'created_by','Potlatch 0.9a'),(6185971,'highway','primary'),(6185971,'ref','CG-2'),(6185971,'source','yahoo'),(6185986,'FIXME','Missing name'),(6185986,'highway','secondary'),(6185986,'ref','FIXME'),(6185986,'source','yahoo'),(6185988,'created_by','Potlatch 0.9c'),(6185988,'highway','primary'),(6185988,'ref','CG-2'),(6185988,'source','yahoo'),(6186037,'highway','primary'),(6186037,'junction','roundabout'),(6186094,'FIXME','Missing name'),(6186094,'highway','residential'),(6195793,'created_by','Potlatch 0.8c'),(6195793,'highway','primary'),(6195793,'layer','-1'),(6195793,'name','Avinguda Sant Antoni'),(6195793,'oneway','yes'),(6195793,'ref','CG-3'),(6195793,'tunnel','yes'),(6195794,'created_by','Potlatch 0.8a'),(6195794,'highway','primary'),(6195794,'oneway','yes'),(6195794,'ref','CG3i4'),(6195795,'FIXME','Missing name'),(6195795,'highway','residential'),(6195796,'FIXME','Missing name'),(6195796,'highway','residential'),(6195797,'FIXME','Missing name'),(6195797,'highway','residential'),(6195885,'created_by','Potlatch 0.8a'),(6195885,'highway','primary'),(6195885,'junction','roundabout'),(6196087,'created_by','Potlatch 0.8a'),(6196087,'highway','primary'),(6196087,'ref','CG-4'),(6196407,'created_by','Potlatch 0.10b'),(6196407,'highway','primary'),(6196407,'ref','CG-4'),(6197719,'created_by','Potlatch 0.8a'),(6197719,'highway','primary'),(6197719,'oneway','yes'),(6197719,'source','yahoo'),(6197721,'highway','primary'),(6197721,'ref','CG-3'),(6197721,'source','yahoo'),(6197723,'created_by','Potlatch 0.9a'),(6197723,'highway','primary'),(6197723,'junction','roundabout'),(6197727,'bridge','yes'),(6197727,'created_by','Potlatch 0.10'),(6197727,'highway','primary'),(6197727,'layer','1'),(6197727,'name','Travessia d\'Ordino'),(6197727,'ref','CG-3'),(6197727,'source','user 3ld'),(6198025,'created_by','Potlatch 0.9a'),(6198025,'highway','secondary'),(6198025,'junction','roundabout'),(6198027,'created_by','Potlatch 0.9a'),(6198027,'highway','secondary'),(6198027,'ref','CS-340'),(6198139,'created_by','Potlatch 0.9a'),(6198139,'highway','secondary'),(6198139,'ref','CS-340'),(6225803,'created_by','Potlatch 0.9a'),(6225803,'highway','secondary'),(6225803,'name','Carretera Coll d\'Ordino'),(6225803,'ref','CS-340'),(6225812,'access','private'),(6225812,'created_by','Potlatch 0.9a'),(6225812,'highway','residential'),(6227096,'highway','primary'),(6227096,'name','Carretera General'),(6227096,'ref','CG-3'),(6227097,'highway','primary'),(6227097,'layer','-1'),(6227097,'name','Carretera General'),(6227097,'ref','CG-3'),(6227097,'tunnel','yes'),(6228283,'created_by','Potlatch 0.10b'),(6228283,'highway','secondary'),(6228283,'ref','CS-220'),(6230227,'FIXME','Missing name'),(6230227,'highway','residential'),(6230228,'bridge','yes'),(6230228,'FIXME','Missing name'),(6230228,'highway','residential'),(6230228,'layer','2'),(6230229,'FIXME','Missing name'),(6230229,'highway','residential'),(6230231,'created_by','Potlatch 0.10'),(6230231,'highway','primary'),(6230231,'ref','CG-6'),(6230231,'source','yahoo'),(6230232,'FIXME','Missing name'),(6230232,'highway','primary'),(6230232,'ref','CG-6'),(6230233,'leisure','pitch'),(6230233,'sport','soccer'),(6230234,'FIXME','Missing name'),(6230234,'highway','residential'),(6242742,'created_by','Potlatch 0.9'),(6242742,'waterway','stream'),(6242747,'boat','no'),(6242747,'created_by','Potlatch 0.9c'),(6242747,'history','Retrieved from v3'),(6242747,'name','Valira del Nord'),(6242747,'waterway','river'),(6242753,'boat','no'),(6242753,'created_by','Potlatch 0.9c'),(6242753,'name:ca','Riu d\'Arinsal'),(6242753,'waterway','river'),(6242756,'created_by','Potlatch 0.8c'),(6242756,'highway','primary'),(6242756,'layer','-1'),(6242756,'name','Avinguda Sant Antoni'),(6242756,'oneway','yes'),(6242756,'ref','CG-3'),(6242756,'tunnel','yes'),(6242757,'created_by','Potlatch 0.8a'),(6242757,'highway','primary'),(6242757,'oneway','yes'),(6242757,'ref','CG3i4'),(6242759,'created_by','Potlatch 0.8a'),(6242759,'highway','primary'),(6242759,'layer','2'),(6242759,'oneway','yes'),(6242759,'ref','CG3i4'),(6242759,'source','yahoo'),(6244541,'created_by','Potlatch 0.9c'),(6244541,'highway','secondary'),(6244541,'ref','CS-413'),(6244542,'created_by','JOSM'),(6244542,'source','yahoo'),(6244542,'waterway','stream'),(6244545,'created_by','JOSM'),(6244545,'waterway','stream'),(6244550,'FIXME','Missing name'),(6244550,'highway','residential'),(6244550,'source','Yahoo and guess'),(6244551,'FIXME','Missing name'),(6244551,'highway','residential'),(6244551,'source','YAHOO'),(6244552,'bridge','yes'),(6244552,'FIXME','Missing name'),(6244552,'highway','residential'),(6244552,'layer','1'),(6244554,'FIXME','Missing name'),(6244554,'highway','residential'),(6244554,'source','YAHOO'),(6244556,'FIXME','Missing name'),(6244556,'highway','residential'),(6244556,'source','yahoo'),(6244558,'bridge','yes'),(6244558,'FIXME','Missing name'),(6244558,'highway','residential'),(6244558,'layer','1'),(6244561,'FIXME','Missing name'),(6244561,'highway','residential'),(6244561,'source','YAHOO'),(6244562,'FIXME','Missing name'),(6244562,'highway','residential'),(6244562,'source','YAHOO'),(6244759,'FIXME','Missing name'),(6244759,'highway','residential'),(6244763,'FIXME','Missing name'),(6244763,'highway','residential'),(6247260,'FIXME','Missing name'),(6247260,'highway','secondary'),(6247260,'oneway','true'),(6247267,'FIXME','Missing name'),(6247267,'highway','secondary'),(6247267,'oneway','true'),(6247268,'highway','primary'),(6247268,'ref','CG-1'),(6247269,'highway','primary_link'),(6247269,'oneway','yes'),(6247270,'highway','primary_link'),(6247270,'junction','roundabout'),(6247271,'highway','primary_link'),(6247271,'oneway','yes'),(6247273,'highway','primary_link'),(6247273,'oneway','yes'),(6247274,'FIXME','Missing name'),(6247274,'highway','secondary'),(6247274,'oneway','true'),(6247278,'FIXME','Missing name'),(6247278,'highway','residential'),(6247279,'created_by','Potlatch 0.10f'),(6247279,'highway','secondary'),(6247279,'name','Carretera de la Rabassa'),(6247279,'ref','CS-131'),(6247280,'FIXME','Missing name'),(6247280,'highway','residential'),(6247282,'alt_name','Camì d\'Aubinya'),(6247282,'created_by','Potlatch 0.10f'),(6247282,'highway','residential'),(6247282,'name','Camì d\'Auvinya'),(6247283,'FIXME','Missing name'),(6247283,'highway','residential'),(6247284,'FIXME','Missing name'),(6247284,'highway','residential'),(6247285,'FIXME','Missing name'),(6247285,'highway','residential'),(6247286,'FIXME','Missing name'),(6247286,'highway','residential'),(6247287,'FIXME','Missing name'),(6247287,'highway','residential'),(6247288,'FIXME','Missing name'),(6247288,'highway','residential'),(6247289,'FIXME','Missing name'),(6247289,'highway','residential'),(6247289,'source','YAHOO'),(6247290,'FIXME','Missing name'),(6247290,'highway','residential'),(6247291,'FIXME','Missing name'),(6247291,'highway','residential'),(6247292,'FIXME','Missing name'),(6247292,'highway','residential'),(6247294,'FIXME','Missing name'),(6247294,'highway','residential'),(6247294,'source','YAHOO'),(6247295,'FIXME','Missing name'),(6247295,'highway','residential'),(6247296,'FIXME','Missing name'),(6247296,'highway','residential'),(6248150,'FIXME','Missing name'),(6248150,'highway','residential'),(6248151,'FIXME','Missing name'),(6248151,'highway','residential'),(6248455,'FIXME','Missing name'),(6248455,'highway','residential'),(6248456,'FIXME','Missing name'),(6248456,'highway','residential'),(6248456,'source','YAHOO'),(6248458,'FIXME','Missing name'),(6248458,'highway','residential'),(6248458,'source','YAHOO'),(6248459,'FIXME','Missing name'),(6248459,'highway','residential'),(6248459,'source','yahoo'),(6248460,'FIXME','Missing name'),(6248460,'highway','residential'),(6248460,'source','yahoo'),(6248461,'FIXME','Missing name'),(6248461,'highway','residential'),(6248461,'source','yahoo'),(6248462,'FIXME','Missing name'),(6248462,'highway','residential'),(6248462,'source','yahoo'),(6248463,'FIXME','Missing name'),(6248463,'highway','residential'),(6248463,'source','yahoo'),(6248464,'FIXME','Missing name'),(6248464,'highway','residential'),(6248464,'source','yahoo'),(6248467,'FIXME','Missing name'),(6248467,'highway','residential'),(6248467,'source','yahoo'),(6248468,'FIXME','Missing name'),(6248468,'highway','residential'),(6248468,'source','YAHOO'),(6248469,'FIXME','Missing name'),(6248469,'highway','residential'),(6248469,'source','YAHOO'),(6249800,'FIXME','Missing name'),(6249800,'highway','secondary'),(6249800,'source','YAHOO'),(6249802,'FIXME','Missing name'),(6249802,'highway','residential'),(6249802,'source','YAHOO'),(6249803,'FIXME','Missing name'),(6249803,'highway','residential'),(6249803,'source','yahoo'),(6250052,'FIXME','Missing name'),(6250052,'highway','residential'),(6250052,'source','yahoo'),(6250053,'FIXME','Missing name'),(6250053,'highway','residential'),(6250053,'source','yahoo'),(6250055,'FIXME','Missing name'),(6250055,'highway','residential'),(6250055,'source','yahoo'),(6250056,'FIXME','Missing name'),(6250056,'highway','residential'),(6250056,'source','yahoo'),(6250057,'FIXME','Missing name'),(6250057,'highway','residential'),(6250057,'source','yahoo'),(6250105,'FIXME','Missing name'),(6250105,'highway','residential'),(6250105,'source','yahoo'),(6250238,'FIXME','Missing name'),(6250238,'highway','residential'),(6250238,'source','yahoo'),(6250239,'FIXME','Missing name'),(6250239,'highway','residential'),(6250239,'source','yahoo'),(6250280,'FIXME','Missing name'),(6250280,'highway','residential'),(6250280,'source','yahoo'),(6267429,'FIXME','Missing name'),(6267429,'highway','residential'),(6267881,'bridge','yes'),(6267881,'highway','secondary'),(6267881,'layer','1'),(6267881,'name','Carretera de Fontaneda'),(6267881,'ref','CS-140'),(6267882,'FIXME','Missing name'),(6267882,'highway','secondary'),(6267882,'name','Carretera de Fontaneda'),(6267882,'ref','CS-140'),(6267882,'source','yahoo'),(6267884,'FIXME','Missing name'),(6267884,'highway','residential'),(6268924,'FIXME','Missing name'),(6268924,'highway','secondary'),(6268924,'ref','fixme'),(6269464,'FIXME','Missing name'),(6269464,'source','yahoo'),(6269464,'waterway','river'),(6275494,'FIXME','Missing name'),(6275494,'highway','secondary'),(6275494,'source','yahoo'),(6275497,'FIXME','Missing name'),(6275497,'highway','secondary'),(6275497,'source','YAHOO'),(6275498,'FIXME','Missing name'),(6275498,'highway','residential'),(6275498,'source','yahoo'),(6275499,'FIXME','Missing name'),(6275499,'highway','residential'),(6275499,'source','yahoo'),(6275501,'highway','primary'),(6275501,'name','Avinguda de Tarragona'),(6275501,'ref','CG-2'),(6275501,'source','yahoo'),(6275503,'amenity','parking'),(6275503,'created_by','JOSM'),(6275504,'highway','primary'),(6275504,'junction','roundabout'),(6275505,'created_by','Potlatch 0.10f'),(6275505,'highway','primary'),(6275505,'name','Avinguda de Tarragona'),(6275505,'ref','CG-2'),(6275505,'source','yahoo'),(6275506,'highway','primary'),(6275506,'junction','roundabout'),(6275507,'leisure','park'),(6275507,'name','Parc Central'),(6275509,'created_by','Potlatch 0.10f'),(6275509,'highway','tertiary'),(6275509,'name','Carrer Maria Plà'),(6275509,'oneway','yes'),(6275509,'source','yahoo'),(6275510,'highway','residential'),(6275510,'junction','roundabout'),(6275512,'FIXME','Missing name'),(6275512,'highway','residential'),(6275512,'oneway','yes'),(6275513,'created_by','Potlatch 0.10f'),(6275513,'highway','tertiary'),(6275513,'name','Avinguda del Fener'),(6275513,'oneway','yes'),(6275514,'highway','residential'),(6275514,'name','Carrer Prada Casadet'),(6275516,'created_by','Potlatch 0.10f'),(6275516,'highway','residential'),(6275516,'name','Carrer de la Grau'),(6275516,'source','yahoo'),(6275517,'created_by','JOSM'),(6275517,'natural','wood'),(6275518,'natural','wood'),(6275522,'created_by','Potlatch alpha'),(6275522,'natural','wood'),(6275851,'FIXME','Missing name'),(6275851,'highway','residential'),(6276661,'created_by','Potlatch 0.10'),(6276661,'natural','wood'),(6277172,'created_by','JOSM'),(6277172,'natural','wood'),(6277173,'created_by','JOSM'),(6277173,'natural','wood'),(6279235,'created_by','JOSM'),(6279235,'natural','wood'),(6281014,'FIXME','Missing name'),(6281014,'highway','secondary'),(6281014,'source','yahoo'),(6281015,'created_by','Potlatch 0.8a'),(6281015,'waterway','stream'),(6281016,'FIXME','Missing name'),(6281016,'highway','secondary'),(6281016,'source','yahoo'),(6281017,'FIXME','Missing name'),(6281017,'highway','residential'),(6281018,'FIXME','Missing name'),(6281018,'highway','residential'),(6281019,'FIXME','Missing name'),(6281019,'highway','secondary'),(6281019,'source','yahoo'),(6281020,'bridge','yes'),(6281020,'FIXME','Missing name'),(6281020,'highway','secondary'),(6281020,'layer','1'),(6281020,'source','yahoo'),(6281021,'FIXME','Missing name'),(6281021,'highway','secondary'),(6281021,'source','yahoo'),(6281022,'bridge','yes'),(6281022,'FIXME','Missing name'),(6281022,'highway','secondary'),(6281022,'layer','1'),(6281022,'source','yahoo'),(6281358,'created_by','Potlatch 0.8b'),(6281358,'highway','secondary'),(6281358,'ref','CS-270'),(6281358,'source','GPS survey'),(6281360,'FIXME','Missing name'),(6281360,'highway','residential'),(6281361,'FIXME','Missing name'),(6281361,'highway','secondary'),(6281361,'source','yahoo'),(6281741,'FIXME','Missing name'),(6281741,'highway','residential'),(6281751,'created_by','Potlatch 0.8a'),(6281751,'waterway','stream'),(6281774,'created_by','JOSM'),(6281774,'waterway','stream'),(6281908,'FIXME','Missing name'),(6281908,'highway','residential'),(6281909,'FIXME','Missing name'),(6281909,'highway','residential'),(6281910,'FIXME','Missing name'),(6281910,'highway','residential'),(6281910,'source','yahoo'),(6281916,'FIXME','Missing name'),(6281916,'highway','residential'),(6281916,'source','yahoo'),(6282443,'FIXME','Missing name'),(6282443,'highway','residential'),(6282444,'FIXME','Missing name'),(6282444,'highway','residential'),(6282445,'FIXME','Missing name'),(6282445,'highway','residential'),(6282446,'FIXME','Missing name'),(6282446,'highway','residential'),(6282447,'FIXME','Missing name'),(6282447,'highway','residential'),(6282448,'FIXME','Missing name'),(6282448,'highway','residential'),(6282449,'FIXME','Missing name'),(6282449,'highway','residential'),(6282450,'FIXME','Missing name'),(6282450,'highway','residential'),(6282451,'FIXME','Missing name'),(6282451,'highway','residential'),(6282452,'FIXME','Missing name'),(6282452,'highway','residential'),(6541502,'name','Río Valira'),(6541502,'waterway','river'),(6541505,'created_by','Potlatch 0.9c'),(6541505,'highway','primary'),(6541505,'ref','CG-2'),(6541505,'source','yahoo'),(6541507,'bridge','yes'),(6541507,'created_by','Potlatch 0.8c'),(6541507,'highway','primary'),(6541507,'layer','1'),(6541507,'ref','CG-2'),(6541507,'source','yahoo'),(6541510,'created_by','JOSM'),(6541510,'natural','water'),(6541514,'FIXME','Missing name'),(6541514,'highway','residential'),(6541518,'FIXME','Missing name'),(6541518,'highway','residential'),(6541520,'bridge','yes'),(6541520,'FIXME','Missing name'),(6541520,'highway','residential'),(6541520,'layer','1'),(6541522,'FIXME','Missing name'),(6541522,'highway','residential'),(6541525,'FIXME','Missing name'),(6541525,'highway','residential'),(6541538,'name','Río Valira'),(6541538,'waterway','river'),(6541541,'FIXME','Missing name'),(6541541,'highway','residential'),(6548812,'FIXME','Missing name'),(6548812,'highway','residential'),(6548814,'FIXME','Missing name'),(6548814,'highway','residential'),(6548816,'FIXME','Missing name'),(6548816,'highway','residential'),(6548818,'FIXME','Missing name'),(6548818,'highway','residential'),(6548820,'highway','primary'),(6548820,'junction','roundabout'),(6548822,'FIXME','Missing name'),(6548822,'highway','residential'),(6548824,'bridge','yes'),(6548824,'FIXME','Missing name'),(6548824,'highway','residential'),(6548824,'layer','2'),(6548826,'FIXME','Missing name'),(6548826,'highway','residential'),(6551314,'FIXME','Missing name'),(6551314,'highway','residential'),(6551317,'bridge','true'),(6551317,'created_by','Potlatch 0.9a'),(6551317,'highway','primary'),(6551317,'layer','1'),(6551317,'ref','CG-2'),(6551317,'source','yahoo'),(6551320,'highway','primary'),(6551320,'ref','CG-2'),(6551320,'source','yahoo'),(6553102,'bridge','yes'),(6553102,'FIXME','Missing name'),(6553102,'highway','residential'),(6553102,'layer','2'),(6553108,'FIXME','Missing name'),(6553108,'highway','residential'),(6553398,'FIXME','Missing name'),(6553398,'highway','residential'),(6553516,'FIXME','Missing name'),(6553516,'highway','tertiary'),(6553741,'FIXME','Missing name'),(6553741,'highway','residential'),(6557168,'FIXME','Missing name'),(6557168,'highway','tertiary'),(6557169,'FIXME','Missing name'),(6557169,'highway','residential'),(6557171,'FIXME','Missing name'),(6557171,'highway','residential'),(6557173,'FIXME','Missing name'),(6557173,'highway','residential'),(6557177,'created_by','JOSM'),(6557177,'waterway','stream'),(6561466,'created_by','JOSM'),(6561466,'natural','wood'),(6561468,'aerialway','cable_car'),(6561468,'aerialway:occupancy','8'),(6561468,'name','Soldeu'),(6561470,'created_by','JOSM'),(6561470,'natural','wood'),(6561682,'created_by','JOSM'),(6561682,'natural','wood'),(6561704,'created_by','JOSM'),(6561704,'natural','wood'),(6561708,'natural','wood'),(6563683,'aerialway','cable_car'),(6563683,'aerialway:occupancy','8'),(6563683,'name','TC8 Canillo'),(6563683,'oneway','no'),(6563687,'created_by','Potlatch 0.10f'),(6563687,'natural','wood'),(6563690,'FIXME','Missing name'),(6563690,'highway','residential'),(6566558,'created_by','Potlatch 0.9c'),(6566558,'highway','secondary'),(6566558,'ref','CS-310'),(6566558,'source','yahoo'),(6566561,'highway','secondary'),(6566561,'junction','roundabout'),(6566571,'created_by','Potlatch 0.10b'),(6566571,'highway','residential'),(6566573,'created_by','Potlatch 0.10b'),(6566573,'highway','residential'),(6566576,'FIXME','Missing name'),(6566576,'highway','residential'),(6569859,'created_by','Potlatch 0.10f'),(6569859,'highway','residential'),(6569859,'name','Urb. l\'Oriosos'),(6576845,'created_by','Potlatch 0.10b'),(6576845,'highway','unclassified'),(6576847,'created_by','Potlatch 0.10f'),(6576847,'highway','unclassified'),(6576847,'source','yahoo'),(6576853,'bridge','yes'),(6576853,'created_by','Potlatch 0.10f'),(6576853,'highway','unclassified'),(6576853,'layer','1'),(6576853,'name','Pont d\'Anyos'),(6576853,'source','yahoo'),(6576855,'created_by','Potlatch 0.10b'),(6576855,'highway','residential'),(6576855,'name','Carretera de les Moles'),(6576858,'FIXME','Missing name'),(6576858,'highway','residential'),(6576861,'FIXME','Missing name'),(6576861,'highway','residential'),(6576864,'FIXME','Missing name'),(6576864,'highway','residential'),(6576866,'FIXME','Missing name'),(6576866,'highway','residential'),(6578446,'created_by','Potlatch 0.9c'),(6578446,'highway','residential'),(6578446,'name','Carretera de les Boigues'),(6578449,'FIXME','Missing name'),(6578449,'highway','residential'),(6578451,'created_by','Potlatch 0.9c'),(6578451,'highway','residential'),(6578451,'name','Carretera de l\'Aldosa'),(6578454,'created_by','Potlatch 0.9c'),(6578454,'highway','unclassified'),(6578454,'name','Carretera de la Gonarda'),(6584903,'created_by','Potlatch 0.9a'),(6584903,'highway','residential'),(6584903,'name','Carrer del Puiet'),(6584906,'created_by','Potlatch 0.10'),(6584906,'highway','residential'),(6584908,'highway','residential'),(6584908,'name','Carrer Antoni Fiter i Rossell'),(6584910,'highway','residential'),(6584910,'name','Carrer Manual Digest'),(6584910,'oneway','yes'),(6584917,'created_by','Potlatch 0.8c'),(6584917,'highway','secondary'),(6584917,'name','Carrer Major'),(6584917,'ref','CS-330'),(6584920,'created_by','Potlatch 0.9c'),(6584920,'highway','residential'),(6584920,'name','Carrer Josep Areny'),(6584925,'created_by','Potlatch 0.9c'),(6584925,'highway','residential'),(6584925,'name','Carrer Guillem Areny'),(6584928,'created_by','Potlatch 0.10f'),(6584928,'highway','residential'),(6584939,'created_by','Potlatch 0.10b'),(6584939,'highway','tertiary'),(6584947,'created_by','Potlatch 0.9c'),(6584947,'highway','residential'),(6584947,'name','Urb. El Salze'),(6584951,'created_by','Potlatch 0.9c'),(6584951,'highway','residential'),(6584951,'name','Urb. Borda Rutllan'),(6584956,'created_by','Potlatch 0.9c'),(6584956,'highway','residential'),(6584956,'name','Urb. Borda Rutllan'),(6584961,'FIXME','Missing name'),(6584961,'highway','residential'),(6588508,'created_by','Potlatch 0.10f'),(6588508,'highway','residential'),(6588508,'name','Carretera de les Agudes'),(6588510,'created_by','Potlatch 0.10f'),(6588510,'highway','residential'),(6588510,'name','Les Canadilles'),(6588513,'FIXME','Missing name'),(6588513,'highway','residential'),(6588516,'FIXME','Missing name'),(6588516,'highway','residential'),(6588519,'FIXME','Missing name'),(6588519,'highway','residential'),(6589890,'created_by','Potlatch 0.9a'),(6589890,'highway','residential'),(6589890,'name','Carrer Coma Del Colat'),(6589898,'created_by','Potlatch 0.9c'),(6589898,'highway','residential'),(6589898,'name','Carrer dels Hortals'),(6590538,'created_by','Potlatch 0.10f'),(6590538,'highway','residential'),(6590538,'name','Carrer Dr Vilanova'),(6592657,'FIXME','Missing name'),(6592657,'highway','residential'),(6593464,'layer','2'),(6593464,'name','Lac d\'Engolasters'),(6593464,'natural','water'),(6602616,'created_by','Potlatch 0.5d'),(6602616,'natural','wood'),(6620914,'FIXME','Missing name'),(6620914,'highway','residential'),(6620917,'FIXME','Missing name'),(6620917,'highway','residential'),(6620920,'FIXME','Missing name'),(6620920,'highway','residential'),(6620926,'FIXME','Missing name'),(6620926,'highway','residential'),(6620930,'FIXME','Missing name'),(6620930,'highway','residential'),(6620940,'created_by','Potlatch 0.9a'),(6620940,'highway','secondary'),(6620940,'ref','CS-420'),(6620947,'amenity','parking'),(6620947,'created_by','JOSM'),(6620952,'created_by','JOSM'),(6620952,'landuse','opm:piste'),(6620955,'created_by','JOSM'),(6620955,'natural','wood'),(6620958,'created_by','JOSM'),(6620958,'natural','wood'),(6620962,'created_by','JOSM'),(6620962,'natural','wood'),(6620964,'created_by','JOSM'),(6620964,'natural','wood'),(6620969,'created_by','JOSM'),(6620969,'landuse','opm:piste'),(6620973,'created_by','JOSM'),(6620973,'natural','wood'),(6620978,'created_by','JOSM'),(6620978,'natural','wood'),(6620980,'created_by','JOSM'),(6620980,'natural','wood'),(7934428,'FIXME','Missing name'),(7934428,'highway','residential'),(7934443,'FIXME','Missing name'),(7934443,'highway','residential'),(8164186,'admin_level','2'),(8164186,'border_type','nation'),(8164186,'boundary','administrative'),(8164186,'left:country','Andorra'),(8164186,'note','This border is so wrong - User:3ld'),(8164186,'right:country','France'),(8164186,'right:departement','Ariège'),(8164186,'right:region','Midi-Pyrénées'),(8164186,'source','CIA World Database II'),(8164452,'FIXME','Missing name'),(8164452,'highway','residential'),(8164478,'FIXME','Missing name'),(8164478,'highway','residential'),(8164597,'FIXME','Missing name'),(8164597,'highway','secondary'),(8164597,'source','yahoo'),(8164653,'FIXME','Missing name'),(8164653,'highway','secondary'),(8164653,'source','yahoo'),(8166678,'FIXME','Way is not circular, and should be'),(8166678,'natural','wood'),(8561013,'bridge','yes'),(8561013,'FIXME','Missing name'),(8561013,'highway','primary'),(8561013,'ref','CG-6'),(8561432,'highway','primary_link'),(8561432,'oneway','yes'),(8667300,'created_by','JOSM'),(8667300,'natural','wood'),(8880951,'source','YAHOO'),(8880951,'waterway','riverbank'),(8880952,'source','YAHOO'),(8880952,'waterway','riverbank'),(8880953,'name','Río Valira'),(8880953,'waterway','riverbank'),(8880955,'waterway','riverbank'),(8880956,'waterway','riverbank'),(8885021,'source','yahoo'),(8885021,'waterway','riverbank'),(8885025,'waterway','riverbank'),(17240968,'created_by','Potlatch 0.5d'),(17240968,'natural','wood'),(17241049,'created_by','Potlatch 0.9c'),(17241049,'natural','wood'),(22746153,'highway','primary'),(22746153,'maxspeed','30'),(22746153,'name','Port d\'Envalira'),(22746153,'ref','CG-2'),(22746153,'source','yahoo'),(22746154,'highway','primary'),(22746154,'maxspeed','90'),(22746154,'name','Port d\'Envalira'),(22746154,'ref','CG-2'),(22746154,'source','yahoo'),(22746155,'highway','primary'),(22746155,'maxspeed','30'),(22746155,'name','Port d\'Envalira'),(22746155,'ref','CG-2'),(22746155,'source','yahoo'),(22746156,'highway','primary'),(22746156,'maxspeed','90'),(22746156,'name','Port d\'Envalira'),(22746156,'ref','CG-2'),(22746156,'source','yahoo'),(22746157,'highway','primary'),(22746157,'maxspeed','30'),(22746157,'name','Port d\'Envalira'),(22746157,'ref','CG-2'),(22746157,'source','yahoo'),(22746159,'highway','primary'),(22746159,'maxspeed','30'),(22746159,'name','Port d\'Envalira'),(22746159,'ref','CG-2'),(22746159,'source','yahoo'),(22746160,'highway','primary'),(22746160,'maxspeed','90'),(22746160,'name','Port d\'Envalira'),(22746160,'ref','CG-2'),(22746160,'source','yahoo'),(22932948,'created_by','JOSM'),(22932948,'natural','wood'),(22932949,'created_by','Potlatch 0.8a'),(22932949,'layer','-4'),(22932949,'natural','wood'),(22932949,'source','Landsat IR'),(23305160,'admin_level','2'),(23305160,'border_type','nation'),(23305160,'boundary','administrative'),(23305160,'history','Retrieved from v6'),(23305160,'left:country','France'),(23305160,'left:departement','Ariège'),(23305160,'left:region','Midi-Pyrénées'),(23305160,'right:country','Spain'),(23305160,'source','CIA World Databank II'),(23840927,'created_by','Potlatch 0.9a'),(23840927,'highway','primary'),(23840927,'name','Avingunda Sant Antoni'),(23840927,'ref','CG-3'),(23840927,'source','yahoo'),(23840928,'bridge','yes'),(23840928,'created_by','Potlatch 0.9a'),(23840928,'highway','primary'),(23840928,'layer','2'),(23840928,'name','Pont de Sant Antoni'),(23840928,'ref','CG3i4'),(23840928,'source','yahoo'),(23841019,'created_by','Potlatch 0.8c'),(23841019,'highway','primary'),(23841019,'oneway','yes'),(23841019,'ref','CG-4'),(23841049,'created_by','Potlatch 0.8c'),(23841049,'highway','primary'),(23841049,'name','Avinguda del Ravel'),(23841049,'ref','CG-4'),(23841094,'created_by','Potlatch 0.8c'),(23841094,'highway','primary'),(23841094,'oneway','yes'),(23841127,'created_by','Potlatch 0.9c'),(23841127,'highway','primary'),(23841127,'name','Avinguda el Travès'),(23841127,'ref','CG-3'),(23841127,'source','yahoo'),(23841423,'bridge','yes'),(23841423,'created_by','Potlatch 0.9c'),(23841423,'highway','primary'),(23841423,'layer','1'),(23841423,'name','Pont de Santa Caterina'),(23841423,'ref','CG-3'),(23841423,'source','survey'),(23841426,'created_by','Potlatch 0.8a'),(23841426,'highway','primary'),(23841426,'ref','CG-3'),(23841426,'source','yahoo'),(23842741,'created_by','Potlatch 0.9a'),(23842741,'highway','primary'),(23842741,'layer','-1'),(23842741,'name','Avigunda Sant Antoni; Avinguda Fiter i Rossell'),(23842741,'ref','CG-3'),(23842741,'source','yahoo'),(23842741,'tunnel','yes'),(23857062,'created_by','Potlatch 0.10b'),(23857062,'highway','primary'),(23857062,'name','Avinguda Sant Antoni'),(23857062,'ref','CG-3'),(23857066,'highway','primary'),(23857066,'name','Avinguda Sant Antoni'),(23857066,'ref','CG-3'),(23857066,'source','yahoo'),(23857247,'created_by','Potlatch 0.10b'),(23857247,'highway','secondary'),(23857247,'source','YAHOO'),(23877195,'highway','primary'),(23877195,'maxspeed','90'),(23877195,'name','Port d\'Envalira'),(23877195,'ref','CG-2'),(23877195,'source','yahoo'),(23877197,'created_by','Potlatch 0.8c'),(23877197,'highway','primary'),(23877197,'maxspeed','90'),(23877197,'ref','CG-2'),(23877197,'source','yahoo'),(23877199,'created_by','Potlatch 0.9c'),(23877199,'highway','primary'),(23877199,'maxspeed','60'),(23877199,'ref','CG-2'),(23877199,'source','yahoo'),(23877200,'created_by','Potlatch 0.9c'),(23877200,'highway','primary'),(23877200,'maxspeed','50'),(23877200,'ref','CG-2'),(23877200,'source','yahoo'),(23877201,'created_by','Potlatch alpha'),(23877201,'highway','primary'),(23877201,'ref','CG-2'),(23877201,'source','yahoo'),(23878263,'created_by','Potlatch 0.8a'),(23878263,'history','Retrieved from v2'),(23878263,'natural','wood'),(23878263,'source','Landsat IR'),(23878462,'created_by','Potlatch 0.10'),(23878462,'highway','primary'),(23878462,'ref','CG-2'),(23878462,'source','yahoo'),(23878463,'created_by','Potlatch 0.10'),(23878463,'highway','primary'),(23878463,'oneway','yes'),(23878463,'ref','CG-2'),(23878463,'source','yahoo'),(23924998,'created_by','Potlatch 0.9c'),(23924998,'highway','secondary'),(23924998,'ref','CS-340'),(23925250,'created_by','Potlatch 0.9a'),(23925250,'highway','primary'),(23925250,'oneway','yes'),(23925250,'ref','CG-2'),(23925250,'source','yahoo'),(23925255,'created_by','Potlatch 0.9a'),(23925255,'highway','primary'),(23925255,'ref','CG-2'),(23925255,'source','yahoo'),(23925285,'created_by','Potlatch 0.8b'),(23925285,'highway','primary'),(23925285,'oneway','yes'),(23925285,'ref','CG-2'),(23925285,'source','yahoo'),(23938547,'created_by','Potlatch 0.10b'),(23938547,'highway','service'),(23978189,'bridge','yes'),(23978189,'created_by','Potlatch 0.9'),(23978189,'highway','residential'),(23978189,'history','Retrieved from v3'),(23978189,'layer','2'),(23978342,'created_by','Potlatch 0.8b'),(23978342,'highway','residential'),(23978342,'name','Cami de les Gravades'),(23978424,'created_by','Potlatch 0.8b'),(23978424,'foot','yes'),(23978424,'highway','bridleway'),(23978424,'name','Cami de les Gravades'),(23978499,'created_by','Potlatch 0.8b'),(23978499,'foot','yes'),(23978499,'highway','residential'),(23978499,'name','Cami de les Molleres'),(24058474,'created_by','Potlatch 0.10b'),(24058474,'highway','residential'),(24058474,'name','Urb Sorribes'),(24059004,'created_by','Potlatch 0.8c'),(24059004,'highway','unclassified'),(24059004,'history','Retrieved from v1'),(24059004,'name','Massana Parc'),(24059067,'created_by','Potlatch 0.8c'),(24059067,'highway','secondary'),(24059067,'name','Carretera Comes de Banyàs'),(24059067,'ref','CS-430'),(24059068,'created_by','Potlatch 0.8c'),(24059068,'highway','secondary'),(24059068,'name','Cerretera del Collet dels Colls'),(24059068,'ref','CS-430'),(24059122,'created_by','Potlatch 0.8c'),(24059122,'highway','residential'),(24059122,'name','Carrer de les Palanques'),(24059295,'bridge','yes'),(24059295,'created_by','Potlatch 0.8c'),(24059295,'highway','residential'),(24059295,'name','Pont de les Palanques'),(24059296,'created_by','Potlatch 0.8c'),(24059296,'highway','residential'),(24059296,'name','Carrer de les Palanques'),(24059351,'created_by','Potlatch 0.9'),(24059351,'highway','residential'),(24059351,'name','Cami Ral'),(24059379,'created_by','Potlatch 0.9'),(24059379,'highway','residential'),(24059379,'name','Carrer de les Palanques'),(24059392,'created_by','Potlatch 0.9a'),(24059392,'foot','yes'),(24059392,'highway','track'),(24059392,'name','Cami Ral'),(24059418,'created_by','Potlatch 0.8c'),(24059418,'highway','residential'),(24059418,'name','Cami Ral'),(24059453,'created_by','Potlatch 0.8c'),(24059453,'highway','unclassified'),(24059572,'created_by','Potlatch 0.8c'),(24059572,'foot','yes'),(24059572,'highway','footway'),(24059572,'name','Cami del Pou'),(24059832,'created_by','Potlatch 0.10f'),(24059832,'highway','residential'),(24059832,'name','Urb. Besillosa i Costes Teixidor'),(24059857,'created_by','Potlatch 0.9c'),(24059857,'highway','secondary'),(24059857,'name','Carrer Major'),(24059857,'ref','CS-330'),(24059999,'FIXME','Missing name'),(24059999,'highway','residential'),(24060059,'highway','residential'),(24060059,'name','Carrer dels Plans'),(24060260,'bridge','yes'),(24060260,'created_by','Potlatch 0.8c'),(24060260,'highway','primary'),(24060260,'layer','1'),(24060260,'name','Carretera d\'Arinsal'),(24060260,'ref','CG-5'),(24060706,'created_by','Potlatch 0.8c'),(24060706,'highway','secondary'),(24060706,'name','Carretera de la Creu Blanca'),(24060706,'ref','CS-335'),(24060706,'source','yahoo'),(24060781,'created_by','Potlatch 0.8c'),(24060781,'highway','secondary'),(24060781,'name','Carretera de Beixalis'),(24060781,'ref','CS-310'),(24060781,'source','yahoo'),(24060840,'created_by','Potlatch 0.10f'),(24060840,'highway','secondary'),(24060840,'name','Carretera de l\'Aldosa'),(24060840,'ref','CS-335'),(24060840,'source','yahoo'),(24240688,'highway','residential'),(24240699,'created_by','Potlatch 0.8c'),(24240699,'highway','residential'),(24240709,'created_by','Potlatch 0.8c'),(24240709,'highway','residential'),(24240780,'created_by','Potlatch 0.10f'),(24240780,'highway','secondary'),(24240780,'name','Carratera dels Plans'),(24240780,'ref','CS-330'),(24240808,'created_by','Potlatch 0.10f'),(24240808,'highway','secondary'),(24240808,'name','Carretera dels Plans'),(24240808,'ref','CS-330'),(24240825,'amenity','parking'),(24240825,'created_by','Potlatch 0.8c'),(24240826,'created_by','Potlatch 0.10f'),(24240826,'highway','residential'),(24240826,'name','Urb. Girault'),(24240835,'amenity','parking'),(24240835,'created_by','Potlatch 0.10f'),(24240868,'created_by','Potlatch 0.10f'),(24240868,'highway','residential'),(24241040,'created_by','Potlatch 0.9c'),(24241040,'highway','secondary'),(24241040,'ref','CS-360'),(24241072,'created_by','Potlatch 0.9c'),(24241072,'highway','residential'),(24241274,'created_by','Potlatch 0.8c'),(24241274,'highway','residential'),(24241278,'bridge','yes'),(24241278,'created_by','Potlatch 0.8c'),(24241278,'highway','residential'),(24241278,'layer','1'),(24241281,'highway','residential'),(24241289,'created_by','Potlatch 0.8c'),(24241289,'highway','residential'),(24241364,'created_by','Potlatch 0.9a'),(24241364,'highway','secondary'),(24241364,'name','Carretera de Montaup'),(24241364,'ref','CS-240'),(24279813,'created_by','JOSM'),(24279813,'highway','residential'),(24279886,'created_by','JOSM'),(24279886,'highway','service'),(24279950,'created_by','Potlatch 0.10f'),(24279950,'highway','tertiary'),(24279950,'name','Avinguda del Fener'),(24279950,'oneway','yes'),(24279950,'source','yahoo'),(24280101,'FIXME','Missing name'),(24280101,'highway','residential'),(24280101,'layer','-1'),(24280101,'tunnel','yes'),(24280274,'bridge','yes'),(24280274,'created_by','Potlatch 0.8c'),(24280274,'highway','secondary'),(24280274,'layer','1'),(24280274,'name','Carretera de Montaup'),(24280274,'ref','CS-240'),(24280275,'created_by','Potlatch 0.9a'),(24280275,'highway','secondary'),(24280275,'name','Carretera de Montaup'),(24280275,'ref','CS-240'),(24280276,'bridge','yes'),(24280276,'created_by','Potlatch 0.8c'),(24280276,'highway','secondary'),(24280276,'layer','1'),(24280276,'name','Carretera de Montaup'),(24280276,'ref','CS-240'),(24280277,'created_by','Potlatch 0.9a'),(24280277,'highway','secondary'),(24280277,'name','Carretera de Montaup'),(24280277,'ref','CS-240'),(24280278,'bridge','yes'),(24280278,'FIXME','Missing name'),(24280278,'highway','residential'),(24280278,'layer','1'),(24280279,'FIXME','Missing name'),(24280279,'highway','residential'),(24280280,'bridge','yes'),(24280280,'created_by','Potlatch alpha'),(24280280,'highway','primary'),(24280280,'layer','1'),(24280280,'ref','CG-2'),(24280280,'source','yahoo'),(24280281,'created_by','Potlatch 0.9a'),(24280281,'highway','primary'),(24280281,'ref','CG-2'),(24280281,'source','yahoo'),(24280282,'bridge','yes'),(24280282,'FIXME','Missing name'),(24280282,'highway','residential'),(24280282,'layer','1'),(24280283,'FIXME','Missing name'),(24280283,'highway','residential'),(24280284,'FIXME','Missing name'),(24280284,'highway','secondary'),(24280284,'source','yahoo'),(24280285,'bridge','yes'),(24280285,'FIXME','Missing name'),(24280285,'highway','secondary'),(24280285,'layer','1'),(24280285,'source','yahoo'),(24280286,'bridge','yes'),(24280286,'FIXME','Missing name'),(24280286,'highway','residential'),(24280286,'layer','1'),(24280287,'FIXME','Missing name'),(24280287,'highway','residential'),(24280288,'bridge','yes'),(24280288,'created_by','Potlatch 0.8a'),(24280288,'highway','primary'),(24280288,'layer','1'),(24280288,'ref','CG-4'),(24280289,'created_by','Potlatch 0.9a'),(24280289,'highway','primary'),(24280289,'ref','CG-4'),(24280290,'bridge','yes'),(24280290,'created_by','Potlatch 0.8c'),(24280290,'highway','primary'),(24280290,'layer','1'),(24280290,'name','Avinguda del Ravel'),(24280290,'ref','CG-4'),(24280291,'created_by','Potlatch 0.9a'),(24280291,'highway','primary'),(24280291,'name','Avinguda del Ravel'),(24280291,'ref','CG-4'),(24280292,'created_by','Potlatch 0.9c'),(24280292,'highway','primary'),(24280292,'name','Carretera d\'Arinsal'),(24280292,'ref','CG-5'),(24280293,'bridge','yes'),(24280293,'FIXME','Missing name'),(24280293,'highway','secondary'),(24280293,'layer','1'),(24280293,'ref','CS-413'),(24280294,'highway','secondary'),(24280294,'ref','CS-413'),(24280295,'bridge','yes'),(24280295,'created_by','Potlatch 0.8c'),(24280295,'highway','primary'),(24280295,'layer','1'),(24280295,'ref','CG-2'),(24280295,'source','yahoo'),(24280296,'created_by','Potlatch 0.9a'),(24280296,'highway','primary'),(24280296,'ref','CG-2'),(24280296,'source','yahoo'),(24341039,'highway','unclassified'),(24341039,'name','Cami de Redort'),(24341039,'tracktype','grade2'),(24360470,'created_by','Potlatch 0.9a'),(24360470,'foot','yes'),(24360470,'highway','footway'),(24360470,'name','Cami del Grau'),(24360537,'created_by','Potlatch 0.9a'),(24360537,'highway','service'),(24360617,'created_by','Potlatch 0.9a'),(24360617,'highway','unclassified'),(24360845,'created_by','Potlatch 0.9a'),(24360845,'highway','unclassified'),(24360845,'name','Cami de les Bordes de Mereig'),(24361232,'created_by','Potlatch 0.9a'),(24361232,'highway','residential'),(24361241,'created_by','Potlatch 0.9a'),(24361241,'highway','residential'),(24361307,'created_by','Potlatch 0.9a'),(24361307,'foot','permissive'),(24361307,'highway','footway'),(24361307,'source','yahoo'),(24361318,'FIXME','Missing name'),(24361318,'highway','residential'),(24361318,'source','yahoo'),(24361367,'created_by','Potlatch 0.9a'),(24361367,'highway','residential'),(24361367,'name','Carrer Parc Guillemó'),(24361367,'source','survey'),(24361435,'created_by','Potlatch 0.9c'),(24361435,'highway','tertiary'),(24361435,'name','Carrer de la Creu Grossa'),(24361435,'source','survey'),(24361575,'created_by','Potlatch 0.9a'),(24361575,'highway','primary'),(24361575,'name','Carrer Bonaventura Armengol'),(24361575,'source','yahoo'),(24361984,'created_by','Potlatch 0.9c'),(24361984,'highway','primary'),(24361984,'layer','2'),(24361984,'name','Avinguda Consell d\'Europa'),(24361984,'oneway','yes'),(24361984,'ref','CG3i4'),(24362026,'bridge','yes'),(24362026,'created_by','Potlatch 0.9a'),(24362026,'highway','primary'),(24362026,'layer','1'),(24362026,'name','Pont de Paris'),(24362252,'bridge','yes'),(24362252,'created_by','Potlatch 0.9a'),(24362252,'highway','primary'),(24362252,'layer','1'),(24362252,'name','Pont de Paris'),(24362252,'oneway','yes'),(24362252,'ref','CG3i4'),(24362255,'created_by','Potlatch 0.9a'),(24362255,'highway','primary_link'),(24362255,'name','Avinguda Consell d\'Europa'),(24362255,'oneway','yes'),(24362255,'ref','CG3i4'),(24362361,'created_by','Potlatch 0.9c'),(24362361,'highway','secondary'),(24362361,'name','Avinguda Consell d\'Europa'),(24362361,'source','yahoo'),(24362714,'created_by','Potlatch 0.9a'),(24362714,'highway','residential'),(24362714,'name','Carrer dels Escalls'),(24362714,'source','yahoo'),(24362802,'created_by','Potlatch 0.10f'),(24362802,'highway','primary'),(24362802,'name','Avinguda Doctor Mitjavila'),(24362802,'oneway','yes'),(24362802,'ref','CG-3a'),(24362802,'source','yahoo'),(24364447,'highway','primary'),(24364447,'layer','-1'),(24364447,'name','Tunèl del Pont Pla'),(24364447,'ref','CG-3i4'),(24364447,'tunnel','yes'),(24364513,'bridge','yes'),(24364513,'created_by','Potlatch 0.9c'),(24364513,'highway','primary'),(24364513,'layer','2'),(24364513,'name','Vial de la Uniò'),(24364513,'ref','CG-3i4'),(24364799,'created_by','Potlatch 0.9a'),(24364799,'highway','primary'),(24364799,'name','Avinguda Prat de la Creu'),(24364799,'ref','CG3a'),(24364799,'source','yahoo'),(24367429,'created_by','Potlatch 0.10f'),(24367429,'highway','residential'),(24367429,'name','Carrer del Pui'),(24374047,'bridge','true'),(24374047,'created_by','Potlatch 0.8c'),(24374047,'highway','primary'),(24374047,'layer','1'),(24374047,'name','Carretera General'),(24374047,'ref','CG-3'),(24374047,'source','user 3ld'),(24374048,'created_by','Potlatch 0.10f'),(24374048,'highway','primary'),(24374048,'name','Carretera General'),(24374048,'ref','CG-3'),(24374048,'source','user 3ld'),(24374049,'bridge','true'),(24374049,'created_by','Potlatch 0.8c'),(24374049,'highway','primary'),(24374049,'layer','1'),(24374049,'name','Carretera General'),(24374049,'ref','CG-3'),(24374049,'source','user 3ld'),(24374050,'highway','primary'),(24374050,'name','Carretera General'),(24374050,'ref','CG-3'),(24374051,'created_by','Potlatch 0.9a'),(24374051,'highway','primary'),(24374051,'name','Carretera General'),(24374051,'ref','CG-3'),(24374051,'source','user 3ld'),(24374052,'created_by','Potlatch 0.9c'),(24374052,'highway','primary'),(24374052,'name','Carretera General'),(24374052,'ref','CG-3'),(24374052,'source','user 3ld'),(24374054,'bridge','true'),(24374054,'created_by','JOSM'),(24374054,'highway','primary'),(24374054,'layer','1'),(24374054,'source','yahoo'),(24374055,'created_by','JOSM'),(24374055,'highway','primary'),(24374055,'ref','CG-6'),(24374055,'source','yahoo'),(24374056,'bridge','true'),(24374056,'created_by','JOSM'),(24374056,'highway','primary'),(24374056,'layer','1'),(24374056,'source','yahoo'),(24374057,'highway','primary'),(24374057,'ref','CG-6'),(24374057,'source','yahoo'),(24374064,'bridge','true'),(24374064,'FIXME','Missing name'),(24374064,'highway','residential'),(24374064,'layer','1'),(24374064,'source','Yahoo and guess'),(24374065,'FIXME','Missing name'),(24374065,'highway','residential'),(24374065,'source','Yahoo and guess'),(24376755,'access','permissive'),(24376755,'created_by','Potlatch 0.9a'),(24376755,'highway','residential'),(24376755,'name','Urbanització Giberga'),(24376812,'access','permissive'),(24376812,'created_by','Potlatch 0.9a'),(24376812,'highway','residential'),(24376812,'name','Urbanització Giberga'),(24377511,'created_by','Potlatch 0.9a'),(24377511,'highway','residential'),(24377511,'oneway','yes'),(24377558,'created_by','Potlatch 0.9a'),(24377558,'highway','residential'),(24377663,'created_by','Potlatch 0.9a'),(24377663,'highway','residential'),(24377663,'name','Carrer el Travès'),(24377667,'created_by','Potlatch 0.9a'),(24377667,'highway','service'),(24405095,'bridge','yes'),(24405095,'created_by','Potlatch 0.9a'),(24405095,'highway','primary'),(24405095,'layer','1'),(24405095,'ref','CG3i4'),(24405096,'created_by','Potlatch 0.9a'),(24405096,'highway','primary'),(24405096,'ref','CG3i4'),(24405131,'created_by','Potlatch 0.9a'),(24405131,'highway','primary'),(24405131,'name','Avigunda Sant Antoni; Avinguda Fiter i Rossell'),(24405131,'ref','CG-3'),(24405131,'source','survey'),(24405159,'created_by','Potlatch 0.9c'),(24405159,'highway','primary'),(24405159,'name','Avinguda Sant Antoni'),(24405159,'oneway','yes'),(24405159,'ref','CG-3'),(24405221,'created_by','Potlatch 0.9c'),(24405221,'highway','primary_link'),(24405221,'name','Avigunda Sant Antoni; Avinguda Fiter i Rossell'),(24405221,'oneway','yes'),(24405221,'ref','CG-3'),(24405221,'source','yahoo'),(24406052,'created_by','Potlatch 0.9a'),(24406052,'highway','primary_link'),(24406052,'name','Avigunda Sant Antoni; Avinguda Fiter i Rossell'),(24406052,'ref','CG-3'),(24406052,'source','yahoo'),(24406326,'natural','water'),(24406327,'created_by','Potlatch 0.9c'),(24406327,'natural','water'),(24406328,'created_by','JOSM'),(24406328,'natural','wood'),(24406329,'created_by','Potlatch 0.10f'),(24406329,'natural','wood'),(24406331,'natural','wood'),(24406332,'created_by','JOSM'),(24406332,'natural','wood'),(24406333,'created_by','JOSM'),(24406333,'natural','wood'),(24406334,'created_by','JOSM'),(24406334,'natural','wood'),(24406335,'created_by','JOSM'),(24406335,'natural','wood'),(24406336,'created_by','JOSM'),(24406336,'natural','wood'),(24413463,'bridge','true'),(24413463,'created_by','Potlatch 0.9a'),(24413463,'highway','primary_link'),(24413463,'layer','1'),(24413463,'source','yahoo'),(24413466,'highway','primary'),(24413466,'layer','2'),(24413466,'name','Avinguda Consell d\'Europa'),(24413466,'oneway','yes'),(24413467,'created_by','Potlatch 0.9c'),(24413467,'highway','primary'),(24413467,'name','Avinguda Consell d\'Europa'),(24413467,'oneway','yes'),(24413467,'ref','CG3i4'),(24413469,'highway','primary_link'),(24413469,'oneway','yes'),(24413469,'source','yahoo'),(24413471,'created_by','Potlatch 0.9a'),(24413471,'highway','primary_link'),(24413471,'layer','2'),(24413471,'source','yahoo'),(24430806,'created_by','Potlatch 0.9c'),(24430806,'highway','secondary'),(24430806,'name','Avinguda Consell d\'Europa'),(24430806,'oneway','yes'),(24430806,'source','yahoo'),(24430807,'created_by','Potlatch 0.9a'),(24430807,'highway','secondary'),(24430807,'layer','-1'),(24430807,'name','Avinguda Consell d\'Europa'),(24430807,'source','yahoo'),(24456592,'created_by','Potlatch 0.10f'),(24456592,'highway','secondary'),(24456592,'name','Carretera de Beixalis'),(24456592,'ref','CS-310'),(24456592,'source','yahoo'),(24492435,'created_by','Potlatch 0.9a'),(24492435,'highway','unclassified'),(24492435,'name','Cami Ral'),(24492437,'created_by','Potlatch 0.9a'),(24492437,'highway','unclassified'),(24492437,'name','Cami Ral'),(24492459,'bridge','yes'),(24492459,'created_by','Potlatch 0.9a'),(24492459,'highway','unclassified'),(24492459,'layer','1'),(24492459,'name','Cami Ral'),(24492463,'created_by','Potlatch 0.9a'),(24492463,'highway','unclassified'),(24492623,'created_by','Potlatch 0.9a'),(24492623,'highway','residential'),(24492644,'created_by','Potlatch 0.9a'),(24492644,'highway','residential'),(24492644,'name','Cami Ral'),(24492653,'bridge','yes'),(24492653,'created_by','Potlatch 0.9a'),(24492653,'highway','residential'),(24492653,'layer','1'),(24492653,'name','Pont d\'Ansalonga'),(24492657,'created_by','Potlatch 0.9a'),(24492657,'highway','residential'),(24492677,'created_by','Potlatch 0.9a'),(24492677,'highway','residential'),(24492804,'created_by','Potlatch 0.9a'),(24492804,'highway','secondary'),(24492804,'name','Carrer de Sornás'),(24492804,'ref','CS-350'),(24492831,'created_by','Potlatch 0.9a'),(24492831,'highway','residential'),(24492831,'maxspeed','20'),(24492868,'bridge','yes'),(24492868,'created_by','Potlatch 0.9a'),(24492868,'highway','secondary'),(24492868,'layer','1'),(24492868,'name','Carrer de Sornás'),(24492868,'ref','CS-350'),(24492889,'created_by','Potlatch 0.9a'),(24492889,'highway','secondary'),(24492889,'name','Carrer de Sornás'),(24492889,'ref','CS-350'),(24492906,'created_by','Potlatch 0.9a'),(24492906,'highway','primary'),(24492906,'name','Carretera General'),(24492906,'ref','CG-3'),(24492906,'source','user 3ld'),(24492907,'bridge','yes'),(24492907,'created_by','Potlatch 0.9a'),(24492907,'highway','primary'),(24492907,'layer','1'),(24492907,'name','Carretera General'),(24492907,'ref','CG-3'),(24492907,'source','user 3ld'),(24493028,'created_by','Potlatch 0.9a'),(24493028,'highway','tertiary'),(24493028,'name','Carrer de l\'Anglada'),(24493045,'created_by','Potlatch 0.9a'),(24493045,'highway','residential'),(24493119,'FIXME','Missing name'),(24493119,'highway','residential'),(24493121,'highway','secondary'),(24493121,'junction','roundabout'),(24493187,'created_by','Potlatch 0.9a'),(24493187,'highway','secondary'),(24493187,'name','Carretera de Segudet'),(24493187,'ref','CS-345'),(24493188,'created_by','Potlatch 0.9a'),(24493188,'highway','secondary'),(24493188,'name','Cami de Segudet'),(24493188,'ref','CS-345'),(24493245,'bridge','yes'),(24493245,'created_by','Potlatch 0.9a'),(24493245,'highway','tertiary'),(24493245,'layer','1'),(24493245,'name','La Carrera Nova'),(24493245,'oneway','yes'),(24493247,'created_by','Potlatch 0.9a'),(24493247,'highway','residential'),(24493250,'created_by','Potlatch 0.9a'),(24493250,'highway','residential'),(24493261,'created_by','Potlatch 0.9a'),(24493261,'highway','tertiary'),(24493261,'name','La Carrera Nova'),(24493330,'created_by','Potlatch 0.9a'),(24493330,'highway','residential'),(24493330,'name','La Callisa'),(24493335,'created_by','Potlatch 0.9a'),(24493335,'highway','residential'),(24493338,'created_by','Potlatch 0.9a'),(24493338,'highway','residential'),(24493362,'created_by','Potlatch 0.9a'),(24493362,'highway','residential'),(24493378,'created_by','Potlatch 0.9a'),(24493378,'highway','service'),(24493431,'amenity','parking'),(24493431,'created_by','Potlatch 0.9a'),(24493439,'created_by','Potlatch 0.9a'),(24493439,'highway','service'),(24493444,'amenity','parking'),(24493444,'created_by','Potlatch 0.9a'),(24493526,'created_by','Potlatch 0.10'),(24493526,'highway','tertiary'),(24493526,'name','Cami de Santa Bàrbara'),(24493528,'created_by','Potlatch 0.10f'),(24493528,'highway','tertiary'),(24493528,'name','Cami de Santa Bàrbara'),(24493570,'created_by','Potlatch 0.9a'),(24493570,'highway','residential'),(24493570,'name','Cami Peu de la Grau'),(24493584,'created_by','Potlatch 0.9a'),(24493584,'highway','tertiary'),(24493584,'name','Cami de Santa Bàrbara'),(24493641,'created_by','Potlatch 0.9a'),(24493641,'highway','service'),(24493647,'created_by','Potlatch 0.9a'),(24493647,'highway','service'),(24493659,'created_by','Potlatch 0.9a');
INSERT INTO `current_way_tags` VALUES (24493659,'highway','service'),(24493664,'amenity','parking'),(24493664,'created_by','Potlatch 0.9a'),(24493679,'created_by','Potlatch 0.9a'),(24493679,'highway','residential'),(24493789,'created_by','Potlatch 0.9a'),(24493789,'highway','residential'),(24493890,'boat','no'),(24493890,'created_by','Potlatch 0.9a'),(24493890,'name','Riu de Segudet'),(24493890,'waterway','stream'),(24493895,'bridge','yes'),(24493895,'created_by','Potlatch 0.9a'),(24493895,'highway','residential'),(24493895,'layer','1'),(24493896,'created_by','Potlatch 0.9a'),(24493896,'highway','residential'),(24493927,'highway','tertiary'),(24493927,'name','La Carrera Nova'),(24493927,'oneway','yes'),(24493967,'highway','primary'),(24493967,'name','Carretera General'),(24493967,'ref','CG-3'),(24493967,'source','user 3ld'),(24494051,'highway','residential'),(24494073,'amenity','parking'),(24494073,'created_by','Potlatch 0.9a'),(24494162,'bridge','yes'),(24494162,'highway','residential'),(24494162,'layer','1'),(24494164,'created_by','Potlatch 0.9a'),(24494164,'highway','residential'),(24497076,'created_by','Potlatch 0.9a'),(24497076,'highway','unclassified'),(24497077,'bridge','yes'),(24497077,'created_by','Potlatch 0.9a'),(24497077,'highway','unclassified'),(24497077,'layer','1'),(24512879,'created_by','Potlatch 0.9a'),(24512879,'highway','residential'),(24517626,'created_by','Potlatch 0.9a'),(24517626,'highway','residential'),(24517626,'name','Carrer de la Pleta de l\'Aldosa'),(24517633,'created_by','Potlatch 0.9a'),(24517633,'highway','service'),(24517644,'created_by','Potlatch 0.9a'),(24517644,'highway','service'),(24517841,'created_by','Potlatch 0.9a'),(24517841,'highway','residential'),(24517875,'created_by','Potlatch 0.10f'),(24517875,'highway','residential'),(24517889,'created_by','Potlatch 0.9a'),(24517889,'highway','service'),(24517907,'amenity','parking'),(24517907,'created_by','Potlatch 0.9a'),(24518086,'created_by','Potlatch 0.9a'),(24518086,'highway','track'),(24518086,'maxspeed','30'),(24518086,'tracktype','grade3'),(24518088,'created_by','Potlatch 0.9a'),(24518088,'highway','track'),(24518088,'maxspeed','30'),(24518088,'tracktype','grade1'),(24518115,'created_by','Potlatch 0.9a'),(24518115,'highway','track'),(24518115,'maxspeed','30'),(24518115,'tracktype','grade1'),(24518124,'created_by','Potlatch 0.9a'),(24518124,'highway','track'),(24518124,'maxspeed','30'),(24518124,'tracktype','grade3'),(24663518,'created_by','Potlatch 0.9c'),(24663518,'highway','residential'),(24663520,'bridge','yes'),(24663520,'created_by','Potlatch 0.9c'),(24663520,'highway','residential'),(24663520,'layer','1'),(24663786,'created_by','Potlatch 0.10f'),(24663786,'highway','secondary'),(24663786,'name','Carrer de les Escoles'),(24663786,'ref','CS-330'),(24663894,'FIXME','Missing name'),(24663894,'highway','residential'),(24664831,'created_by','Potlatch 0.9c'),(24664831,'highway','unclassified'),(24664867,'created_by','Potlatch 0.9c'),(24664867,'highway','secondary'),(24664867,'ref','CS-411'),(24664880,'created_by','Potlatch 0.9c'),(24664880,'highway','residential'),(24665224,'created_by','Potlatch 0.9c'),(24665224,'highway','residential'),(24665224,'name','Carretera l\'Escaladella'),(24665257,'access','private'),(24665257,'amenity','parking'),(24665257,'created_by','Potlatch 0.9c'),(24665737,'created_by','Potlatch 0.9c'),(24665737,'highway','secondary'),(24665737,'name','Carretera Mas Ribafeta'),(24665737,'ref','CS-412'),(24665785,'created_by','Potlatch 0.9c'),(24665785,'highway','residential'),(24665785,'name','Els Formantals Parc'),(24665811,'created_by','Potlatch 0.9c'),(24665811,'highway','residential'),(24666049,'created_by','Potlatch 0.9c'),(24666049,'highway','residential'),(24666099,'created_by','Potlatch 0.9c'),(24666099,'highway','residential'),(24666099,'name','Carretera les Feixes'),(24666136,'created_by','Potlatch 0.9c'),(24666136,'highway','service'),(24666186,'amenity','parking'),(24666186,'created_by','Potlatch 0.9c'),(24668180,'bridge','yes'),(24668180,'created_by','Potlatch 0.9c'),(24668180,'highway','residential'),(24668180,'layer','1'),(24668181,'created_by','Potlatch 0.9c'),(24668181,'highway','residential'),(24668187,'created_by','Potlatch 0.9c'),(24668187,'highway','residential'),(24668361,'created_by','Potlatch 0.9c'),(24668361,'highway','residential'),(24668372,'created_by','Potlatch 0.9c'),(24668372,'highway','residential'),(24668373,'bridge','yes'),(24668373,'created_by','Potlatch 0.9c'),(24668373,'highway','residential'),(24668373,'layer','1'),(24668885,'highway','service'),(24668954,'created_by','Potlatch 0.9c'),(24668954,'highway','service'),(24669163,'created_by','Potlatch 0.9c'),(24669163,'highway','service'),(24669245,'created_by','Potlatch 0.9c'),(24669245,'highway','service'),(24669247,'highway','service'),(24669248,'bridge','yes'),(24669248,'created_by','Potlatch 0.9c'),(24669248,'highway','service'),(24669248,'layer','1'),(24669306,'amenity','parking'),(24669306,'created_by','Potlatch 0.9c'),(24669321,'amenity','parking'),(24669352,'amenity','parking'),(24669352,'created_by','Potlatch 0.10f'),(24669376,'amenity','parking'),(24669376,'created_by','Potlatch 0.9c'),(24669430,'created_by','Potlatch 0.9c'),(24669430,'highway','service'),(24669444,'highway','service'),(24713155,'created_by','Potlatch 0.9c'),(24713155,'highway','residential'),(24713182,'created_by','Potlatch 0.9c'),(24713182,'highway','track'),(24713182,'name','Camí Ral d\'Ordino'),(24713182,'tracktype','grade3'),(24713189,'created_by','Potlatch 0.9c'),(24713189,'highway','unclassified'),(24713210,'created_by','Potlatch 0.9c'),(24713210,'highway','track'),(24713210,'tracktype','grade2'),(24713222,'created_by','Potlatch 0.9c'),(24713222,'highway','track'),(24713222,'tracktype','grade3'),(24713246,'bridge','yes'),(24713246,'created_by','Potlatch 0.9c'),(24713246,'highway','track'),(24713246,'layer','1'),(24713246,'tracktype','grade1'),(24713303,'created_by','Potlatch 0.9c'),(24713303,'highway','unclassified'),(24713305,'bridge','yes'),(24713305,'created_by','Potlatch 0.9c'),(24713305,'highway','unclassified'),(24713305,'layer','1'),(24713352,'created_by','Potlatch 0.9c'),(24713352,'highway','residential'),(24713362,'created_by','Potlatch 0.9c'),(24713362,'highway','footway'),(24713447,'created_by','Potlatch 0.9c'),(24713447,'highway','footway'),(24713483,'amenity','parking'),(24713483,'created_by','Potlatch 0.9c'),(24713502,'amenity','parking'),(24713502,'created_by','Potlatch 0.9c'),(24713566,'created_by','Potlatch 0.9c'),(24713566,'highway','residential'),(24713578,'created_by','Potlatch 0.9c'),(24713578,'highway','residential'),(24713611,'created_by','Potlatch 0.9c'),(24713611,'highway','unclassified'),(24713692,'created_by','Potlatch 0.9c'),(24713692,'highway','residential'),(24713692,'name','Carrer Sant Romà'),(24713704,'created_by','Potlatch 0.9c'),(24713704,'highway','primary'),(24713704,'name','Carretera d\'Erts'),(24713704,'ref','CG-5'),(24713904,'created_by','Potlatch 0.9c'),(24713904,'highway','residential'),(24713904,'name','Carrer Mossèn Enric Marfany'),(24713904,'source','yahoo survey'),(24713918,'created_by','Potlatch 0.10'),(24713918,'highway','tertiary'),(24713918,'name','Carrer Doctor Nequi'),(24713918,'source','yahoo survey'),(24713936,'created_by','Potlatch 0.9c'),(24713936,'highway','tertiary'),(24713936,'name','Carrer Bisbe Príncep Iglésias'),(24713936,'source','survey'),(24714294,'created_by','Potlatch 0.9c'),(24714294,'highway','residential'),(24714294,'name','Carrer Roger Bernat III'),(24714294,'source','yahoo'),(24714736,'created_by','Potlatch 0.9c'),(24714736,'highway','secondary'),(24714736,'name','Avinguda de Santa Coloma'),(24714743,'created_by','Potlatch 0.10'),(24714743,'highway','secondary'),(24714743,'name','Avinguda d\'Enclar'),(24714892,'highway','tertiary'),(24714892,'name','Carrer dels Canals'),(24714892,'source','yahoo survey'),(24715008,'created_by','Potlatch 0.9c'),(24715008,'highway','secondary'),(24715008,'name','Baixada del Molì'),(24715008,'source','yahoo'),(24715064,'bridge','yes'),(24715064,'created_by','Potlatch 0.9c'),(24715064,'highway','secondary'),(24715064,'layer','1'),(24715064,'name','Pont de Tobira; Carrer de Tobira'),(24715064,'source','yahoo'),(24715082,'highway','primary'),(24715082,'junction','roundabout'),(24715082,'name','Avinguda de Tarragona'),(24715082,'source','yahoo'),(24715152,'created_by','Potlatch 0.10f'),(24715152,'highway','primary'),(24715152,'name','Avinguda de Tarragona'),(24715152,'ref','CG-2'),(24715152,'source','yahoo'),(24715185,'highway','primary_link'),(24715185,'oneway','yes'),(24715324,'created_by','Potlatch 0.9c'),(24715324,'highway','residential'),(24715324,'name','Carrer de l\'Aigüeta'),(24715324,'oneway','yes'),(24715324,'source','yahoo'),(24913724,'created_by','Potlatch 0.9c'),(24913724,'highway','residential'),(24913724,'name','Cami Ral'),(24913802,'created_by','Potlatch 0.9c'),(24913802,'highway','residential'),(24913802,'name','Peu del Carrer'),(24913861,'created_by','Potlatch 0.9c'),(24913861,'highway','residential'),(24913861,'name','Carrer dels Ocells'),(24914526,'created_by','Potlatch 0.9c'),(24914526,'highway','tertiary'),(24914526,'lanes','2'),(24914526,'name','Avinguda de les Nacions Unides'),(24914534,'created_by','Potlatch 0.9c'),(24914534,'highway','tertiary'),(24914534,'name','Carrer de la Constituciò'),(24914534,'source','survey'),(24914563,'created_by','Potlatch 0.9c'),(24914563,'highway','tertiary'),(24914563,'junction','roundabout'),(24914563,'source','survey'),(24914660,'created_by','Potlatch 0.9c'),(24914660,'highway','tertiary'),(24914660,'name','Carrer de Parnal'),(24914660,'source','survey'),(24914768,'FIXME','Missing name'),(24914768,'highway','residential'),(24914768,'source','yahoo'),(24914779,'created_by','Potlatch 0.9c'),(24914779,'highway','primary'),(24914779,'oneway','yes'),(24914843,'highway','tertiary'),(24914843,'junction','roundabout'),(24914870,'created_by','Potlatch 0.9c'),(24914870,'highway','tertiary'),(24914870,'name','Carrer de la Constituciò'),(24914870,'source','survey'),(24914903,'highway','tertiary'),(24914903,'junction','roundabout'),(24914989,'created_by','Potlatch 0.10f'),(24914989,'highway','tertiary'),(24914989,'name','Avinguda Consell de la Terra'),(24915114,'FIXME','Missing name'),(24915114,'highway','residential'),(24915114,'source','yahoo'),(24915502,'created_by','Potlatch 0.9c'),(24915502,'highway','primary'),(24915502,'ref','CG-2'),(24915502,'source','yahoo'),(24915504,'created_by','Potlatch 0.9c'),(24915504,'highway','primary'),(24915504,'oneway','yes'),(24915504,'ref','CG-2'),(24915504,'source','yahoo'),(24915554,'created_by','Potlatch 0.9c'),(24915554,'highway','secondary'),(24915554,'name','Carretera de Beixalis'),(24915554,'ref','CS-310'),(24915554,'source','yahoo'),(24915566,'created_by','Potlatch 0.9c'),(24915566,'highway','secondary'),(24915566,'junction','roundabout'),(24915617,'bridge','yes'),(24915617,'created_by','Potlatch 0.9c'),(24915617,'highway','secondary'),(24915617,'layer','1'),(24915617,'name','Carretera de les Riberaigües'),(24915624,'created_by','Potlatch 0.9c'),(24915624,'highway','secondary'),(24915624,'oneway','yes'),(24915706,'created_by','Potlatch 0.9c'),(24915706,'highway','secondary'),(24915706,'name','Carretera de les Riberaigües'),(24915706,'oneway','yes'),(24915763,'created_by','Potlatch 0.9c'),(24915763,'highway','secondary'),(24915763,'ref','CS-310'),(24915763,'source','yahoo'),(24915772,'bridge','yes'),(24915772,'created_by','Potlatch 0.9c'),(24915772,'highway','secondary'),(24915772,'layer','1'),(24915772,'ref','CS-310'),(24915772,'source','yahoo'),(24915834,'created_by','Potlatch 0.9c'),(24915834,'highway','secondary'),(24915834,'name','Carretera de les Riberaigües'),(25014753,'created_by','JOSM'),(25014753,'highway','unclassified'),(25014753,'name','Carrer Doctor Vilanova'),(25014777,'created_by','JOSM'),(25014777,'highway','track'),(25014777,'tracktype','grade4'),(25415705,'admin_level','2'),(25415705,'border_type','nation'),(25415705,'boundary','administrative'),(25415705,'left:country','Andorra'),(25415705,'right:country','France'),(25415705,'source','GPS Survey'),(25416126,'created_by','Potlatch 0.9c'),(25416126,'highway','residential'),(25416126,'name','Cami de les Molleres'),(25416128,'created_by','Potlatch 0.10f'),(25416128,'foot','yes'),(25416128,'highway','footway'),(25416128,'name','Cami de les Molleres'),(25416227,'highway','service'),(25416308,'highway','residential'),(25416371,'created_by','Potlatch 0.9c'),(25416371,'highway','residential'),(25453236,'created_by','Potlatch 0.9c'),(25453236,'highway','track'),(25453236,'tracktype','grade1'),(25453308,'bridge','yes'),(25453308,'created_by','Potlatch 0.9c'),(25453308,'highway','track'),(25453308,'layer','1'),(25453308,'tracktype','grade1'),(25453310,'created_by','Potlatch 0.9c'),(25453310,'highway','track'),(25453310,'tracktype','grade1'),(25454372,'created_by','Potlatch 0.9c'),(25454372,'highway','residential'),(25454372,'name','Cami de Santa Caterina'),(25454378,'created_by','Potlatch 0.10f'),(25454378,'foot','yes'),(25454378,'highway','path'),(25454378,'name','Cami de Santa Caterina'),(25454381,'created_by','Potlatch 0.9c'),(25454381,'highway','unclassified'),(25484821,'created_by','Potlatch 0.10f'),(25484821,'highway','tertiary'),(25484821,'oneway','yes'),(25484883,'created_by','Potlatch 0.9c'),(25484883,'highway','residential'),(25484883,'name','Carrer Josep Viladomat'),(25484883,'source','survey'),(25484912,'highway','secondary'),(25484912,'junction','roundabout'),(25485099,'created_by','Potlatch 0.9c'),(25485099,'highway','tertiary'),(25485099,'name','Carretera de la Margineda'),(25485119,'created_by','Potlatch 0.9c'),(25485119,'highway','residential'),(25485119,'name','Carrer dels Castanyers'),(25485130,'created_by','Potlatch 0.10'),(25485130,'highway','tertiary'),(25485130,'name','Carrer Tossalet i Vinyols'),(25485131,'created_by','Potlatch 0.9c'),(25485131,'highway','tertiary'),(25485131,'name','Carrer de i\'Aern'),(25569661,'FIXME','Missing name'),(25569661,'highway','residential'),(25569661,'source','yahoo'),(25569665,'created_by','Potlatch 0.9c'),(25569665,'highway','secondary'),(25569665,'name','Avinguda del Pessebre'),(25569665,'source','survey'),(25569745,'bridge','yes'),(25569745,'highway','tertiary'),(25569745,'layer','1'),(25569745,'name','Carrer de la Constituciò'),(25569745,'source','survey'),(25569748,'created_by','Potlatch 0.9c'),(25569748,'highway','tertiary'),(25569748,'name','Carrer de la Constituciò'),(25569748,'source','survey'),(25569755,'created_by','Potlatch 0.10f'),(25569755,'highway','secondary'),(25569755,'name','Avinguda de les Escoles'),(25569755,'oneway','yes'),(25569755,'source','survey'),(25569775,'bridge','yes'),(25569775,'highway','secondary'),(25569775,'name','Avinguda de les Escoles'),(25569775,'source','survey'),(25572114,'created_by','Potlatch 0.9c'),(25572114,'highway','residential'),(25572121,'amenity','parking'),(25572121,'created_by','Potlatch 0.9c'),(25572130,'bridge','yes'),(25572130,'created_by','Potlatch 0.9c'),(25572130,'highway','residential'),(25572130,'layer','1'),(25572131,'created_by','Potlatch 0.9c'),(25572131,'highway','residential'),(25572572,'created_by','Potlatch 0.9c'),(25572572,'highway','residential'),(25572731,'created_by','Potlatch 0.9c'),(25572731,'highway','residential'),(25572741,'created_by','Potlatch 0.9c'),(25572741,'highway','service'),(25572746,'created_by','Potlatch 0.9c'),(25572746,'highway','service'),(25572749,'created_by','Potlatch 0.9c'),(25572749,'highway','service'),(25572883,'amenity','parking'),(25572883,'created_by','Potlatch 0.9c'),(25573596,'created_by','Potlatch 0.9c'),(25573596,'highway','secondary'),(25573596,'ref','CS-240'),(25767814,'created_by','Potlatch 0.10'),(25767814,'highway','tertiary'),(25767814,'junction','roundabout'),(25767827,'access','permissive'),(25767827,'created_by','Potlatch 0.10'),(25767827,'highway','service'),(25767827,'name','Carrer Tossalet i Vinyols'),(25767891,'created_by','Potlatch 0.10'),(25768003,'access','no'),(25768003,'bicycle','yes'),(25768003,'created_by','Potlatch 0.10'),(25768003,'highway','primary'),(25768003,'motorcycle','yes'),(25768003,'oneway','yes'),(25768003,'psv','yes'),(25768003,'ref','CG-1'),(25768018,'created_by','Potlatch 0.10'),(25768018,'highway','primary'),(25768018,'oneway','yes'),(25768018,'ref','CG-1'),(25768677,'created_by','Potlatch 0.10'),(25768677,'highway','primary'),(25768677,'oneway','yes'),(25768677,'ref','CG-1'),(25768677,'source','yahoo'),(25768681,'created_by','Potlatch 0.10'),(25768681,'highway','primary'),(25768681,'ref','CG-1'),(25768681,'source','yahoo'),(25768760,'highway','primary'),(25768760,'junction','roundabout'),(25768838,'created_by','Potlatch 0.10'),(25768838,'highway','tertiary'),(25768852,'created_by','Potlatch 0.10'),(25768852,'highway','primary'),(25768852,'oneway','yes'),(25768852,'ref','CG-1'),(25768868,'access','no'),(25768868,'bicycle','yes'),(25768868,'created_by','Potlatch 0.10'),(25768868,'highway','primary'),(25768868,'motorcycle','yes'),(25768868,'oneway','yes'),(25768868,'psv','yes'),(25768868,'ref','CG-1'),(25769024,'access','no'),(25769024,'bicycle','yes'),(25769024,'created_by','Potlatch 0.10'),(25769024,'highway','primary'),(25769024,'motorcycle','yes'),(25769024,'oneway','yes'),(25769024,'psv','yes'),(25769024,'ref','CG-1'),(25769049,'bridge','yes'),(25769049,'created_by','Potlatch 0.10'),(25769049,'highway','tertiary'),(25769049,'layer','1'),(25769049,'oneway','yes'),(25769050,'created_by','Potlatch 0.10'),(25769050,'highway','tertiary'),(25769069,'access','no'),(25769069,'bicycle','yes'),(25769069,'bridge','yes'),(25769069,'created_by','Potlatch 0.10f'),(25769069,'highway','primary'),(25769069,'layer','1'),(25769069,'motorcycle','yes'),(25769069,'name','Pont de Madrid'),(25769069,'oneway','yes'),(25769069,'psv','yes'),(25769069,'ref','CG-1'),(25769071,'access','no'),(25769071,'bicycle','yes'),(25769071,'created_by','Potlatch 0.10'),(25769071,'highway','primary'),(25769071,'motorcycle','yes'),(25769071,'oneway','yes'),(25769071,'psv','yes'),(25769071,'ref','CG-1'),(25769112,'created_by','Potlatch 0.10f'),(25769112,'highway','primary'),(25769112,'oneway','yes'),(25769112,'ref','CG-1'),(25769116,'bridge','yes'),(25769116,'created_by','Potlatch 0.10f'),(25769116,'highway','primary'),(25769116,'layer','1'),(25769116,'name','Pont de Madrid'),(25769116,'oneway','yes'),(25769116,'ref','CG-1'),(25769122,'created_by','Potlatch 0.10'),(25769122,'highway','primary'),(25769122,'oneway','yes'),(25769122,'ref','CG-1'),(25769124,'bridge','yes'),(25769124,'created_by','Potlatch 0.10f'),(25769124,'highway','primary'),(25769124,'layer','1'),(25769124,'name','Pont de Madrid'),(25769124,'oneway','yes'),(25769124,'ref','CG-1'),(25769182,'created_by','Potlatch 0.10'),(25769182,'highway','primary'),(25769182,'ref','CG-2'),(25769182,'source','yahoo'),(25769229,'highway','primary'),(25769229,'junction','roundabout'),(25769702,'highway','residential'),(25769702,'name','Carrer Camp Bastida'),(25769702,'oneway','yes'),(25769709,'created_by','Potlatch 0.10'),(25769709,'highway','tertiary'),(25769709,'name','Carrer Camp Pauet'),(25769726,'created_by','Potlatch 0.10'),(25769726,'highway','service'),(25769726,'name','Passatge de Cedre'),(25769803,'created_by','Potlatch 0.10'),(25769803,'highway','unclassified'),(25769803,'name','Carrer Mossèn Lluis Pujol'),(25769822,'created_by','Potlatch 0.10'),(25769822,'highway','residential'),(25769822,'name','El Contrapàs'),(25769829,'created_by','Potlatch 0.10'),(25769829,'highway','unclassified'),(25769829,'name','Carrer Roureda Tapada'),(25769891,'created_by','Potlatch 0.10'),(25769891,'highway','residential'),(25769891,'name','Carrer R'),(25769893,'created_by','Potlatch 0.10'),(25769893,'highway','unclassified'),(25769893,'name','Carrer de Cedre'),(25769922,'created_by','Potlatch 0.10'),(25769922,'highway','unclassified'),(25769922,'name','Carrer de Cedre'),(25769970,'created_by','Potlatch 0.10'),(25769970,'highway','unclassified'),(25769970,'name','Carrer del Barrers'),(25769974,'created_by','Potlatch 0.10'),(25769974,'highway','unclassified'),(25769974,'name','Carrer de la Tartera'),(25770088,'created_by','Potlatch 0.10'),(25770088,'highway','unclassified'),(25770088,'name','Cami Ral'),(25770391,'created_by','Potlatch 0.10'),(25770391,'highway','service'),(25770391,'name','Passatge de Cedre'),(25770445,'created_by','Potlatch 0.10'),(25770445,'highway','unclassified'),(25770445,'name','Carrer de la Closa'),(25770728,'area','yes'),(25770728,'created_by','Potlatch 0.10'),(25770728,'highway','pedestrian'),(25770728,'name','Plaça Guillemó'),(25770737,'created_by','Potlatch 0.10'),(25770737,'highway','tertiary'),(25770737,'name','Carrer Mossèn Tremosa'),(25770737,'source','yahoo survey'),(25770744,'created_by','Potlatch 0.10'),(25770744,'highway','tertiary'),(25770744,'name','Carrer Mossèn Tremosa'),(25770744,'source','yahoo survey'),(25770745,'created_by','Potlatch 0.10'),(25770745,'highway','tertiary'),(25770745,'name','Plaça Guillemó'),(25770745,'source','yahoo survey'),(25771015,'created_by','Potlatch 0.10'),(25771015,'highway','unclassified'),(25771015,'name','Carrer Roc de l\'Aldias'),(25771079,'created_by','Potlatch 0.10'),(25771079,'highway','unclassified'),(25771079,'name','Carrer Font del Pujal'),(25771241,'created_by','Potlatch 0.10'),(25771241,'highway','unclassified'),(25771241,'name','Carrer Mestre Xavier Plana'),(25825533,'created_by','Potlatch 0.10'),(25825533,'highway','primary'),(25825533,'name','Travessia d\'Ordino'),(25825533,'ref','CG-3'),(25825533,'source','user 3ld'),(26001987,'created_by','Potlatch 0.10b'),(26001987,'highway','pedestrian'),(26001987,'name','Carrer Major'),(26002036,'created_by','Potlatch 0.10b'),(26002036,'highway','residential'),(26243488,'created_by','Potlatch 0.10f'),(26243488,'highway','primary'),(26243488,'name','Avinguda Sant Antoni'),(26243488,'ref','CG-3'),(26243580,'highway','primary'),(26243580,'junction','roundabout'),(26243608,'created_by','Potlatch 0.10f'),(26243608,'highway','unclassified'),(26243608,'source','yahoo'),(26243681,'created_by','Potlatch 0.10b'),(26243681,'highway','secondary'),(26243681,'name','Carretera de Sispony'),(26243681,'ref','CS-320'),(26243895,'access','permissive'),(26243895,'amenity','parking'),(26243895,'area','yes'),(26243895,'created_by','Potlatch 0.10b'),(26243895,'landuse','commercial'),(26455183,'created_by','Potlatch 0.10b'),(26455183,'highway','secondary'),(26455183,'name','Carretera de Vila-Beixalis'),(26455183,'ref','CS-210'),(26455183,'source','yahoo'),(26553947,'highway','secondary'),(26553947,'tracktype','grade2'),(26554007,'amenity','parking'),(26554007,'created_by','Potlatch 0.10b'),(26668563,'created_by','Potlatch 0.10f'),(26668563,'highway','primary'),(26668563,'maxspeed','90'),(26668563,'name','Avingunda del Consell General'),(26668563,'ref','CG-2'),(26668563,'source','yahoo'),(27826413,'highway','unclassified'),(27826413,'source','yahoo'),(28828385,'created_by','Potlatch 0.10f'),(28828385,'highway','residential'),(28828385,'name','Carrer de les Entrades'),(28828388,'created_by','Potlatch 0.10f'),(28828388,'highway','residential'),(28828388,'name','Carrer de Josep Rossel'),(28828789,'created_by','Potlatch 0.10f'),(28828789,'highway','residential'),(28828789,'name','Carrer de Josep Rossel'),(28829736,'created_by','Potlatch 0.10f'),(28829736,'highway','unclassified'),(28829748,'created_by','Potlatch 0.10f'),(28829748,'highway','unclassified'),(28829753,'created_by','Potlatch 0.10f'),(28829753,'highway','unclassified'),(28829766,'created_by','Potlatch 0.10f'),(28829766,'highway','unclassified'),(28829773,'created_by','Potlatch 0.10f'),(28829773,'highway','unclassified'),(28829779,'created_by','Potlatch 0.10f'),(28829779,'highway','unclassified'),(28829910,'created_by','Potlatch 0.10f'),(28829910,'highway','track'),(28829910,'tracktype','grade2'),(28829964,'access','designated'),(28829964,'created_by','Potlatch 0.10f'),(28829964,'highway','track'),(28829967,'created_by','Potlatch 0.10f'),(28829967,'highway','track'),(28829967,'tracktype','grade2'),(28832922,'created_by','Potlatch 0.10f'),(28832922,'highway','unclassified'),(28832923,'bridge','yes'),(28832923,'created_by','Potlatch 0.10f'),(28832923,'highway','unclassified'),(28832923,'layer','1'),(28833468,'bicycle','no'),(28833468,'created_by','Potlatch 0.10f'),(28833468,'foot','yes'),(28833468,'highway','steps'),(28833468,'motorcycle','no'),(28833468,'name','Cami de les Molleres'),(28833468,'step_count','75'),(28833770,'highway','primary'),(28833770,'maxspeed','50'),(28833770,'name','Avingunda del Consell General'),(28833770,'ref','CG-2'),(28833770,'source','yahoo'),(28833880,'highway','primary'),(28833880,'maxspeed','90'),(28833880,'name','Port d\'Envalira'),(28833880,'ref','CG-2'),(28833880,'source','yahoo'),(28833924,'highway','primary'),(28833924,'maxspeed','90'),(28833924,'name','Port d\'Envalira'),(28833924,'ref','CG-2'),(28833924,'source','yahoo'),(28833927,'highway','primary'),(28833927,'maxspeed','30'),(28833927,'name','Port d\'Envalira'),(28833927,'ref','CG-2'),(28833927,'source','yahoo'),(28833935,'highway','primary'),(28833935,'maxspeed','90'),(28833935,'name','Port d\'Envalira'),(28833935,'ref','CG-2'),(28833935,'source','yahoo'),(28833936,'highway','primary'),(28833936,'maxspeed','30'),(28833936,'name','Port d\'Envalira'),(28833936,'ref','CG-2'),(28833936,'source','yahoo'),(28833957,'highway','primary'),(28833957,'maxspeed','90'),(28833957,'name','Port d\'Envalira'),(28833957,'ref','CG-2'),(28833957,'source','yahoo'),(28833958,'highway','primary'),(28833958,'maxspeed','30'),(28833958,'name','Port d\'Envalira'),(28833958,'ref','CG-2'),(28833958,'source','yahoo'),(29051459,'access','private'),(29051459,'created_by','Potlatch 0.10f'),(29051459,'highway','unclassified'),(29249135,'highway','path'),(29249135,'mtb:scale','2'),(29249135,'mtb:scale:uphill','4'),(29249135,'sac_scale','alpine_hiking'),(29249136,'highway','path'),(29249136,'mtb:scale','1'),(29249136,'mtb:scale:uphill','4'),(29249136,'sac_scale','demanding_alpine_hiking'),(29249700,'highway','path'),(29249700,'mtb:scale','3'),(29249700,'mtb:scale:uphill','5'),(29249700,'name','Mountainbike Downhill'),(29249700,'surface','unpaved'),(29376254,'aerialway','cable_car'),(29376254,'aerialway:occupancy','16'),(29376254,'name','La Massana'),(29376356,'aerialway','gondola'),(29376356,'name','Els Orriols'),(29376448,'bridge','yes'),(29376448,'created_by','Potlatch 0.10f'),(29376448,'foot','yes'),(29376448,'highway','footway'),(29376448,'layer','1'),(29422567,'created_by','Potlatch 0.10f'),(29422567,'highway','unclassified'),(29422567,'name','Carrer Gil Torres'),(30139079,'created_by','Potlatch 0.10f'),(30139079,'foot','yes'),(30139079,'highway','path'),(30139093,'created_by','Potlatch 0.10f'),(30139093,'highway','track'),(30139093,'name','Cami de Santa Bàrbara'),(30139093,'tracktype','grade3'),(30139242,'created_by','Potlatch 0.10f'),(30139242,'highway','track'),(30139242,'name','Cami Ral'),(30139242,'tracktype','grade3'),(30139403,'created_by','Potlatch 0.10f'),(30139403,'highway','steps'),(30139408,'created_by','Potlatch 0.10f'),(30139408,'highway','footway'),(30567238,'created_by','Potlatch 0.10f'),(30567238,'highway','service'),(30567542,'created_by','Potlatch 0.10f'),(30567542,'highway','secondary'),(30567542,'name','Vial de la Uniò'),(30567542,'oneway','yes'),(30571624,'created_by','Potlatch 0.10f'),(30571624,'foot','yes'),(30571624,'highway','footway'),(30572100,'created_by','Potlatch 0.10f'),(30572100,'foot','yes'),(30572100,'highway','footway'),(30572100,'name','Cami del Barranc de la font del Mosquit'),(30572104,'created_by','Potlatch 0.10f'),(30572104,'foot','yes'),(30572104,'highway','footway'),(30572104,'name','Cami del Barranc de la font del Mosquit'),(30572116,'created_by','Potlatch 0.10f'),(30572116,'foot','yes'),(30572116,'highway','steps'),(30572116,'name','Cami del Barranc de la font del Mosquit'),(30572116,'step_count','52'),(30572138,'created_by','Potlatch 0.10f'),(30572138,'foot','yes'),(30572138,'highway','footway'),(30572138,'name','Cami del Barranc de la font del Mosquit'),(30572145,'created_by','Potlatch 0.10f'),(30572145,'foot','yes'),(30572145,'highway','steps'),(30572145,'name','Cami del Barranc de la font del Mosquit'),(30572145,'step_count','16'),(30572187,'created_by','Potlatch 0.10f'),(30572187,'foot','yes'),(30572187,'highway','footway'),(30605340,'created_by','Potlatch 0.10f'),(30605340,'landuse','residential'),(30605340,'name','Residencial Barraca'),(30605380,'created_by','Potlatch 0.10f'),(30605380,'highway','service'),(30605457,'created_by','Potlatch 0.10f'),(30605457,'foot','yes'),(30605457,'highway','footway'),(30605650,'created_by','Potlatch 0.10f'),(30605650,'foot','yes'),(30605650,'highway','footway'),(30605670,'created_by','Potlatch 0.10f'),(30605670,'foot','yes'),(30605670,'highway','footway'),(30605680,'created_by','Potlatch 0.10f'),(30605683,'created_by','Potlatch 0.10f'),(30605683,'foot','yes'),(30605683,'highway','footway'),(30605686,'created_by','Potlatch 0.10f'),(30605686,'foot','yes'),(30605686,'highway','footway'),(30605697,'created_by','Potlatch 0.10f'),(30605697,'foot','yes'),(30605697,'highway','steps'),(30605697,'name','Cami del Solanell'),(30605697,'step_count','64'),(30605698,'created_by','Potlatch 0.10f'),(30605698,'foot','yes'),(30605698,'highway','footway'),(30605698,'name','Cami del Solanell'),(30605769,'created_by','Potlatch 0.10f'),(30605769,'highway','track'),(30605769,'name','Cami del Solanell'),(30605769,'surface','dirt'),(30772650,'amenity','police'),(30772650,'created_by','Potlatch 0.10f'),(30772702,'amenity','parking'),(30772702,'created_by','Potlatch 0.10f'),(30922493,'created_by','Potlatch 0.10f'),(30922493,'highway','secondary'),(30922493,'name','Avinguda Carlemany'),(30922493,'oneway','yes'),(30922493,'source','yahoo'),(30922528,'created_by','Potlatch 0.10f'),(30922528,'highway','secondary'),(30922528,'name','Avinguda Carlemany'),(30922528,'source','survey'),(31348544,'created_by','Potlatch 0.10f'),(31348544,'highway','secondary'),(31348544,'name','Carretera de Canòlich'),(31348544,'ref','CS-111'),(31348633,'highway','unclassified'),(31726348,'created_by','Potlatch 0.10f'),(31726348,'highway','primary'),(31726348,'oneway','yes'),(31726348,'ref','CG-3'),(31726348,'source','yahoo'),(31726372,'created_by','Potlatch 0.10f'),(31726372,'highway','primary'),(31726372,'junction','roundabout'),(31726416,'created_by','Potlatch 0.10f'),(31726416,'highway','primary'),(31726416,'oneway','yes'),(31726416,'ref','CG-3'),(31726416,'source','yahoo'),(31726467,'created_by','Potlatch 0.10f'),(31726467,'highway','primary'),(31726467,'oneway','yes'),(31726467,'ref','CG-3'),(31726467,'source','yahoo'),(31726482,'created_by','Potlatch 0.10f'),(31726482,'highway','primary'),(31726482,'oneway','yes'),(31726482,'ref','CG-3'),(31726482,'source','yahoo'),(31726492,'created_by','Potlatch 0.10f'),(31726492,'highway','secondary'),(31726492,'name','Carretera de l\'Aldosa'),(31726492,'oneway','yes'),(31726492,'ref','CS-335'),(31726492,'source','yahoo'),(31726507,'created_by','Potlatch 0.10f'),(31726507,'highway','secondary'),(31726507,'name','Carretera de l\'Aldosa'),(31726507,'oneway','yes'),(31726507,'ref','CS-335'),(31726661,'created_by','Potlatch 0.10f'),(31726661,'highway','primary'),(31726661,'ref','CG-3'),(31726661,'source','yahoo'),(31726701,'created_by','Potlatch 0.10f'),(31726701,'highway','primary'),(31726701,'ref','CG-3'),(31726701,'source','yahoo'),(31726779,'highway','primary'),(31726779,'junction','roundabout'),(31726779,'source','yahoo'),(31726812,'created_by','Potlatch 0.10f'),(31726812,'highway','primary'),(31726812,'ref','CG-3'),(31726812,'source','yahoo'),(31726851,'created_by','Potlatch 0.10f'),(31726851,'highway','primary'),(31726851,'ref','CG-3'),(31726851,'source','yahoo'),(31726898,'created_by','Potlatch 0.10f'),(31726898,'highway','residential'),(32211744,'created_by','Potlatch 0.10f'),(32211744,'highway','tertiary'),(32211744,'name','Carrer Ciutat de Sabadell'),(32211744,'oneway','yes'),(32211744,'source','yahoo'),(32549432,'created_by','Potlatch 0.10f'),(32549432,'highway','track'),(32549444,'created_by','Potlatch 0.10f'),(32549444,'natural','wood'),(32551123,'created_by','Potlatch 0.10f'),(32551123,'highway','track'),(32551125,'highway','track'),(32594779,'highway','track'),(32594984,'highway','track'),(32594985,'created_by','Potlatch 0.10f'),(32594985,'highway','track'),(32598297,'created_by','Potlatch 0.10f'),(32598297,'highway','track'),(32598297,'name','Cami de Padern'),(32598300,'created_by','Potlatch 0.10f'),(32598300,'highway','track'),(32598313,'created_by','Potlatch 0.10f'),(32598313,'highway','track'),(32598338,'created_by','Potlatch 0.10f'),(32598338,'highway','track'),(32598345,'created_by','Potlatch 0.10f'),(32598345,'highway','track'),(32676714,'highway','path'),(32676714,'mtb:scale','2'),(32676714,'mtb:scale:uphill','4'),(32676714,'ref','CS-320'),(32676739,'highway','track'),(32676739,'mtb:scale','0'),(32676739,'mtb:scale:uphill','0'),(32676739,'tracktype','grade3'),(32676743,'highway','path'),(32676743,'mtb:scale','3'),(32676743,'mtb:scale:uphill','5'),(32676746,'highway','path'),(32676749,'highway','track'),(32676749,'mtb:scale','0'),(32676749,'mtb:scale:uphill','0'),(32676749,'tracktype','grade2'),(32676753,'highway','path'),(32676753,'mtb:scale','0'),(32676753,'mtb:scale:uphill','1'),(32676755,'highway','track'),(32676755,'mtb:scale','0'),(32676755,'mtb:scale:uphill','0'),(32676755,'tracktype','grade2'),(32722266,'created_by','Potlatch 0.10f'),(32722266,'highway','secondary'),(32722266,'name','Carretera dels Cortals'),(32722266,'ref','CS-320'),(32722447,'created_by','Potlatch 0.10f'),(32722447,'highway','secondary'),(32722447,'name','Carretera de Fontaneda'),(32722447,'ref','CS-140'),(32722515,'created_by','Potlatch 0.10f'),(32722515,'highway','track'),(32722515,'name','Carretera de Canòlich'),(32722515,'ref','CS-111'),(32722515,'tracktype','grade3'),(32722544,'created_by','Potlatch 0.10f'),(32722544,'highway','secondary'),(32722544,'name','Carretera de Mas d\'Alins'),(32722544,'ref','CS-142'),(32722657,'created_by','Potlatch 0.10f'),(32722657,'highway','secondary'),(32722657,'name','Carretera Secundaria de la Rabassa'),(32722657,'ref','CS-130'),(32722658,'bridge','yes'),(32722658,'created_by','Potlatch 0.10f'),(32722658,'highway','secondary'),(32722658,'layer','1'),(32722658,'name','Carretera Secundaria de la Rabassa'),(32722658,'ref','CS-130'),(32722762,'created_by','Potlatch 0.10f'),(32722762,'highway','secondary'),(32722762,'name','Carretera Secundaria de la Rabassa'),(32722762,'ref','CS-130'),(32722815,'created_by','Potlatch 0.10f'),(32722815,'highway','secondary'),(32722815,'name','Carretera de la Rabassa'),(32722815,'ref','CS-131'),(32819051,'created_by','Potlatch 0.10f'),(32819051,'highway','secondary'),(32819051,'name','Carrer Major'),(32819051,'ref','CS-320'),(32819142,'created_by','Potlatch 0.10f'),(32819142,'highway','secondary'),(32819142,'maxweight','2.1'),(32819142,'name','Carretera dels Cortals'),(32819142,'ref','CS-320'),(32845037,'created_by','Potlatch 0.10f'),(32845037,'highway','secondary'),(32845037,'name','Carretera Sant Cristofol'),(32845037,'ref','CS-310'),(32845037,'source','yahoo'),(32845056,'bridge','yes'),(32845056,'created_by','Potlatch 0.10f'),(32845056,'highway','secondary'),(32845056,'layer','1'),(32845056,'name','Pont d\'Anyos'),(32845056,'ref','CS-310'),(32845056,'source','yahoo'),(32845063,'created_by','Potlatch 0.10f'),(32845063,'highway','secondary'),(32845063,'name','Carretera Sant Cristofol'),(32845063,'ref','CS-310'),(32845063,'source','yahoo'),(32936885,'created_by','Potlatch 0.10f'),(32936885,'highway','residential'),(32936960,'created_by','Potlatch 0.10f'),(32936960,'highway','residential'),(32937000,'created_by','Potlatch 0.10f'),(32937000,'highway','unclassified'),(32937225,'created_by','Potlatch 0.10f'),(32937225,'highway','residential'),(32937225,'name','Cami de Padern'),(32937397,'created_by','Potlatch 0.10f'),(32937397,'highway','residential'),(32937466,'created_by','Potlatch 0.10f'),(32937466,'landuse','cemetery'),(32973912,'created_by','Potlatch 0.10f'),(32973912,'highway','track'),(33184240,'created_by','Potlatch 0.10f'),(33184240,'highway','track'),(33184240,'mtb:scale','0'),(33184240,'mtb:scale:uphill','3'),(33184240,'surface','ground'),(33184240,'tracktype','grade5'),(33184244,'highway','path'),(33184244,'mtb:scale','1'),(33184244,'mtb:scale:uphill','1'),(33184244,'sac_scale','alpine_hiking'),(33184247,'highway','path'),(33184247,'mtb:scale','5'),(33184247,'mtb:scale:uphill','5'),(33184247,'sac_scale','demanding_alpine_hiking'),(33184252,'highway','track'),(33184252,'mtb:scale','2'),(33184252,'mtb:scale:uphill','2'),(33184252,'sac_scale','demanding_alpine_hiking'),(33184252,'tracktype','grade5'),(33184266,'highway','path'),(33184266,'mtb:scale','1'),(33184266,'mtb:scale:uphill','2'),(33184266,'sac_scale','alpine_hiking'),(33184270,'created_by','Potlatch 0.10f'),(33184270,'highway','track'),(33184270,'mtb:scale','0'),(33184270,'mtb:scale:uphill','0'),(33184270,'ref','CS-320'),(33184270,'tracktype','grade2'),(33713550,'created_by','Potlatch 0.10'),(33713550,'highway','secondary'),(33713550,'name','Avinguda Príncep Benlloch'),(33721575,'amenity','parking'),(33733175,'highway','residential'),(34062547,'created_by','Potlatch 0.10f'),(34062547,'highway','path'),(34062547,'name','Cami de Rebolians'),(34062547,'note','This trace needs some work. Not that accurate!'),(34062881,'created_by','Potlatch 0.10f'),(34062881,'highway','path'),(34062881,'name','Cami de les Barreres'),(34062881,'sac_scale','mountain_hiking'),(34062881,'source','Fixed by User:3ld with GPS, May 4 2009'),(34062881,'trail_visibility','intermediate'),(34063687,'highway','path'),(34063687,'name','Cami de Rebolians'),(34063687,'sac_scale','hiking'),(34063687,'source','Fixed by User:3ld with GPS, May 4 2009'),(34063687,'trail_visibility','intermediate'),(34063704,'bridge','yes'),(34063704,'highway','path'),(34063704,'layer','1'),(34063704,'name','Cami de Rebolians'),(34063704,'source','Fixed by User:3ld with GPS, May 4 2009'),(34063704,'trail_visibility','intermediate'),(34063735,'boat','no'),(34063735,'waterway','stream'),(34063769,'bridge','yes'),(34063769,'created_by','Potlatch 0.8c'),(34063769,'highway','secondary'),(34063769,'layer','1'),(34063769,'name','Carretera de la Creu Blanca'),(34063769,'ref','CS-335'),(34063769,'source','yahoo'),(34063770,'created_by','Potlatch 0.8c'),(34063770,'highway','secondary'),(34063770,'name','Carretera de la Creu Blanca'),(34063770,'ref','CS-335'),(34063770,'source','yahoo'),(34064472,'highway','track'),(34064472,'tracktype','grade4'),(34064472,'vehicle','agricultural'),(34064813,'foot','yes'),(34064813,'highway','track'),(34064813,'tracktype','grade4'),(34064813,'vehicle','agricultural'),(34064907,'highway','unclassified'),(34065105,'highway','track'),(34065105,'tracktype','grade3'),(34065671,'highway','footway'),(34065671,'name','Carrer Cal Giberga'),(34065735,'highway','secondary'),(34065735,'name','Carretera de la Creu Blanca'),(34065735,'ref','CS-335'),(34065735,'source','yahoo'),(34387676,'highway','residential'),(34387676,'name','Termes de Tarteres'),(34387821,'highway','residential'),(34387821,'name','Marge i Terres No.3'),(34388549,'highway','residential'),(34388549,'name','Marge i Terres No.2'),(34389528,'highway','residential'),(34389528,'name','Tarteres del Mig Carretera 2'),(34390093,'highway','unclassified'),(34390103,'highway','residential'),(34390103,'name','Termes de Tarteres'),(34390499,'highway','residential'),(34390499,'name','Terme Camp dels Mare de Deu'),(34390581,'access','private'),(34390581,'highway','unclassified'),(34390594,'highway','residential'),(34390594,'name','Terra Hortells tambe Caubella'),(34876322,'amenity','parking'),(34876405,'highway','service'),(35444733,'highway','path'),(35444733,'name','Camì de les Barreres'),(35444733,'sac_scale','mountain_hiking'),(35444733,'trail_visibility','intermediate'),(37633206,'access','private'),(37633206,'highway','service'),(37633275,'highway','residential'),(37633404,'access','yes'),(37633404,'highway','track'),(37633404,'surface','dirt'),(37756343,'highway','service'),(37756386,'amenity','parking'),(37865954,'created_by','Potlatch 0.10b'),(37865954,'highway','service'),(37865954,'name','Camì de les Pardines'),(38706653,'highway','path'),(38706653,'name','Cami del Roc de Castell'),(38706653,'sac_scale','alpine_hiking'),(38706653,'trail_visibility','good'),(38706925,'highway','service'),(38706927,'bridge','yes'),(38706927,'highway','path'),(38706927,'layer','1'),(38706927,'name','Cami de Sedornet'),(38706927,'sac_scale','alpine_hiking'),(38706927,'trail_visibility','good'),(38706928,'highway','path'),(38706928,'name','Cami de Coll de les Cases'),(38706928,'sac_scale','alpine_hiking'),(38706928,'trail_visibility','good'),(38706936,'highway','path'),(38706936,'name','Cami de Sedornet'),(38706936,'sac_scale','alpine_hiking'),(38706936,'trail_visibility','good'),(39258136,'boat','no'),(39258136,'natural','waterfall'),(39258136,'waterway','stream'),(39258137,'boat','no'),(39258137,'waterway','stream'),(39258144,'boat','no'),(39258144,'waterway','stream'),(39258742,'highway','path'),(39258742,'name','Cami de Sedornet'),(39258742,'sac_scale','mountain_hiking'),(39258742,'trail_visibility','good'),(39259019,'highway','path'),(39259019,'trail_visibility','good'),(39259022,'highway','steps'),(39259022,'step_count','6'),(39259088,'highway','service'),(39259092,'highway','footway'),(39259147,'access','private'),(39259147,'amenity','parking'),(39259506,'created_by','Potlatch 0.9c'),(39259506,'highway','unclassified'),(39259666,'amenity','parking'),(39259759,'boat','no'),(39259759,'layer','0'),(39259759,'waterway','stream'),(39259769,'created_by','Potlatch 0.9c'),(39259769,'highway','primary'),(39259769,'name','Carretera General'),(39259769,'ref','CG-3'),(39259769,'source','user 3ld'),(39259770,'bridge','yes'),(39259770,'created_by','Potlatch 0.9c'),(39259770,'highway','primary'),(39259770,'layer','1'),(39259770,'name','Carretera General'),(39259770,'ref','CG-3'),(39259770,'source','user 3ld'),(40064501,'sport','skiing'),(40064876,'sport','skiing'),(40065172,'sport','skiing'),(40065349,'highway','path'),(40065349,'sac_scale','mountain_hiking'),(40065349,'trail_visibility','intermediate'),(40065810,'highway','path'),(40065810,'sac_scale','mountain_hiking'),(40065810,'trail_visibility','intermediate'),(40065893,'boat','no'),(40065893,'name','Riu d\'Angonella'),(40065893,'waterway','stream'),(40067891,'highway','path'),(40067891,'name','Cami del Llacs d\'Angonella'),(40067891,'sac_scale','mountain_hiking'),(40067891,'trail_visibility','good'),(40137318,'highway','secondary'),(40137318,'name','Vial de la Uniò'),(40137318,'source','yahoo'),(40264409,'highway','path'),(40264409,'sac_scale','demanding_mountain_hiking'),(40264410,'highway','path'),(40264410,'sac_scale','mountain_hiking'),(41785125,'CLC:code','112'),(41785125,'CLC:id','FR-245890'),(41785125,'CLC:year','2006'),(41785125,'landuse','residential'),(41785125,'source','Union européenne - SOeS, CORINE Land Cover, 2006.'),(41935429,'CLC:code','231'),(41935429,'CLC:id','FR-245641'),(41935429,'CLC:year','2006'),(41935429,'landuse','meadow'),(41935429,'source','Union européenne - SOeS, CORINE Land Cover, 2006.'),(42014211,'aerialway','chair_lift'),(42014211,'aerialway:occupancy','6'),(42014211,'name','Arinsal'),(42021998,'CLC:code','312'),(42021998,'CLC:id','FR-245775'),(42021998,'CLC:year','2006'),(42021998,'landuse','forest'),(42021998,'source','Union européenne - SOeS, CORINE Land Cover, 2006.'),(42021998,'wood','coniferous'),(42055725,'CLC:code','312'),(42055725,'CLC:id','FR-245763'),(42055725,'CLC:year','2006'),(42055725,'landuse','forest'),(42055725,'source','Union européenne - SOeS, CORINE Land Cover, 2006.'),(42055725,'wood','coniferous'),(42055772,'CLC:code','312'),(42055772,'CLC:id','FR-246005'),(42055772,'CLC:year','2006'),(42055772,'landuse','forest'),(42055772,'source','Union européenne - SOeS, CORINE Land Cover, 2006.'),(42055772,'wood','coniferous'),(42235196,'CLC:code','321'),(42235196,'CLC:id','FR-244995'),(42235196,'CLC:year','2006'),(42235196,'natural','grassland'),(42235196,'source','Union européenne - SOeS, CORINE Land Cover, 2006.'),(42235209,'CLC:code','332'),(42235209,'CLC:id','FR-245065'),(42235209,'CLC:year','2006'),(42235209,'natural','rock'),(42235209,'source','Union européenne - SOeS, CORINE Land Cover, 2006.'),(42235226,'CLC:code','321'),(42235226,'CLC:id','FR-245362'),(42235226,'CLC:year','2006'),(42235226,'natural','grassland'),(42235226,'source','Union européenne - SOeS, CORINE Land Cover, 2006.'),(42235229,'CLC:code','332'),(42235229,'CLC:id','FR-245404'),(42235229,'CLC:year','2006'),(42235229,'natural','rock'),(42235229,'source','Union européenne - SOeS, CORINE Land Cover, 2006.'),(42235235,'CLC:code','321'),(42235235,'CLC:id','FR-245529'),(42235235,'CLC:year','2006'),(42235235,'natural','grassland'),(42235235,'source','Union européenne - SOeS, CORINE Land Cover, 2006.'),(42235255,'CLC:code','332'),(42235255,'CLC:id','FR-245865'),(42235255,'CLC:year','2006'),(42235255,'natural','rock'),(42235255,'source','Union européenne - SOeS, CORINE Land Cover, 2006.'),(42235256,'CLC:code','321'),(42235256,'CLC:id','FR-245777'),(42235256,'CLC:year','2006'),(42235256,'natural','grassland'),(42235256,'source','Union européenne - SOeS, CORINE Land Cover, 2006.'),(42252195,'CLC:code','321'),(42252195,'CLC:id','FR-245139'),(42252195,'CLC:year','2006'),(42252195,'natural','grassland'),(42252195,'source','Union européenne - SOeS, CORINE Land Cover, 2006.'),(42252243,'CLC:code','321'),(42252243,'CLC:id','FR-245313'),(42252243,'CLC:year','2006'),(42252243,'natural','grassland'),(42252243,'source','Union européenne - SOeS, CORINE Land Cover, 2006.'),(42252251,'CLC:code','322'),(42252251,'CLC:id','FR-245372'),(42252251,'CLC:year','2006'),(42252251,'natural','heath'),(42252251,'source','Union européenne - SOeS, CORINE Land Cover, 2006.'),(42252272,'CLC:code','332'),(42252272,'CLC:id','FR-245397'),(42252272,'CLC:year','2006'),(42252272,'natural','rock'),(42252272,'source','Union européenne - SOeS, CORINE Land Cover, 2006.'),(42252309,'CLC:code','512'),(42252309,'CLC:id','FR-245454'),(42252309,'CLC:year','2006'),(42252309,'natural','water'),(42252309,'source','Union européenne - SOeS, CORINE Land Cover, 2006.'),(42252326,'CLC:code','321'),(42252326,'CLC:id','FR-245517'),(42252326,'CLC:year','2006'),(42252326,'natural','grassland'),(42252326,'source','Union européenne - SOeS, CORINE Land Cover, 2006.'),(42252348,'CLC:code','321'),(42252348,'CLC:id','FR-245597'),(42252348,'CLC:year','2006'),(42252348,'natural','grassland'),(42252348,'source','Union européenne - SOeS, CORINE Land Cover, 2006.'),(42252384,'CLC:code','321'),(42252384,'CLC:id','FR-245738'),(42252384,'CLC:year','2006'),(42252384,'natural','grassland'),(42252384,'source','Union européenne - SOeS, CORINE Land Cover, 2006.'),(42451011,'highway','residential'),(42451011,'name','Carrer Antoni Fiter i Rossell'),(42451011,'oneway','yes'),(42451016,'highway','tertiary'),(42451016,'name','La Carrera Nova'),(42451016,'oneway','yes'),(42451892,'highway','residential'),(42451892,'name','El Buners d\'Ordino'),(42809904,'highway','track'),(42809904,'tracktype','grade2'),(42810813,'highway','primary'),(42810813,'ref','CG-2'),(42810813,'source','yahoo'),(42811127,'highway','primary'),(42811127,'oneway','yes'),(42811127,'ref','CG-2'),(45511076,'admin_level','2'),(45511076,'boundary','administrative'),(45511076,'source','BDLL25, EGRN, Instituto Geográfico Nacional'),(45511084,'admin_level','2'),(45511084,'boundary','administrative'),(45511084,'source','BDLL25, EGRN, Instituto Geográfico Nacional'),(45511090,'admin_level','2'),(45511090,'boundary','administrative'),(45511090,'source','BDLL25, EGRN, Instituto Geográfico Nacional'),(48271354,'aerialway','chair_lift'),(48271354,'aerialway:occupancy','6'),(48271354,'name','La Coma'),(48271355,'aerialway','chair_lift'),(48271355,'aerialway:occupancy','4'),(48271355,'name','La Basera'),(48271356,'aerialway','platter'),(48271356,'name','L\'Abarsetar'),(48928224,'name','Astoret'),(48928224,'piste:difficulty','easy'),(48928224,'piste:type','downhill'),(48928225,'name','Os'),(48928225,'piste:difficulty','easy'),(48928225,'piste:type','downhill'),(48928226,'name','Bosc Fosc'),(48928226,'piste:difficulty','easy'),(48928226,'piste:type','downhill'),(48928227,'aerialway','chair_lift'),(48928227,'aerialway:occupancy','6'),(48928227,'name','Solana del Forn'),(48928228,'aerialway','chair_lift'),(48928228,'aerialway:occupancy','6'),(48928228,'name','Tosa Espiolets'),(48928229,'aerialway','chair_lift'),(48928229,'aerialway:occupancy','6'),(48928229,'name','Llosada'),(48928230,'aerialway','chair_lift'),(48928230,'aerialway:occupancy','4'),(48928230,'name','Assalador'),(48928231,'aerialway','chair_lift'),(48928231,'aerialway:occupancy','4'),(48928231,'name','Solanelles'),(48928232,'aerialway','chair_lift'),(48928232,'aerialway:capacity','2000'),(48928232,'aerialway:occupancy','6'),(48928232,'name','Soldeu'),(48928233,'name','Avet'),(48928233,'piste:difficulty','advanced'),(48928233,'piste:type','downhill'),(48928234,'aerialway','platter'),(48928234,'aerialway:occupancy','1'),(48928234,'name','Bosc'),(48928234,'piste:lift','platter'),(48928235,'name','Eslalom'),(48928235,'piste:difficulty','advanced'),(48928235,'piste:type','downhill'),(48928236,'aerialway','platter'),(48928236,'aerialway:occupancy','1'),(48928236,'name','Bassots'),(48928236,'piste:lift','platter'),(48957244,'name','Colibri'),(48957244,'piste:difficulty','intermediate'),(48957244,'piste:type','downhill'),(48957245,'name','Serrat Pinos'),(48957245,'piste:difficulty','intermediate'),(48957245,'piste:type','downhill'),(48957246,'aerialway','chair_lift'),(48957246,'aerialway:occupancy','4'),(48957246,'name','Llac del Cubil'),(48957247,'aerialway','chair_lift'),(48957247,'aerialway:occupancy','4'),(48957247,'name','Cubil'),(48957248,'aerialway','chair_lift'),(48957248,'aerialway:occupancy','6'),(48957248,'name','Coma Blanca'),(48957249,'aerialway','chair_lift'),(48957249,'aerialway:occupancy','6'),(48957249,'name','Pic Blanc'),(48957250,'name','Cami de Pessons'),(48957250,'piste:difficulty','intermediate'),(48957250,'piste:type','downhill'),(48957251,'name','Tortuga'),(48957251,'piste:difficulty','easy'),(48957251,'piste:type','downhill'),(48957252,'piste:difficulty','easy'),(48957252,'piste:type','downhill'),(48957253,'name','mirador'),(48957253,'piste:difficulty','advanced'),(48957253,'piste:type','downhill'),(48957254,'name','Pala Nova'),(48957254,'piste:difficulty','intermediate'),(48957254,'piste:type','downhill'),(48957255,'name','Menera'),(48957255,'piste:difficulty','intermediate'),(48957255,'piste:type','downhill'),(48957256,'aerialway','chair_lift'),(48957256,'aerialway:occupancy','6'),(48957256,'name','Pla de les Pedres Soldeu'),(48957257,'aerialway','chair_lift'),(48957257,'aerialway:occupancy','6'),(48957257,'name','Pla de les Pedres Grau Roig'),(48957258,'aerialway','platter'),(48957258,'aerialway:occupancy','1'),(48957258,'name','Escola'),(48957258,'piste:lift','platter'),(48969498,'name','Guineu'),(48969498,'piste:difficulty','easy'),(48969498,'piste:type','downhill'),(48969499,'name','Miquel'),(48969499,'piste:difficulty','intermediate'),(48969499,'piste:type','downhill'),(48979047,'name','Paniquera'),(48979047,'piste:difficulty','easy'),(48979047,'piste:type','downhill'),(48979047,'sport','skiing'),(48979050,'name','Riu De Les Solanelles'),(48979050,'piste:difficulty','easy'),(48979050,'piste:type','downhill'),(48979051,'name','Ayelen'),(48979051,'piste:difficulty','easy'),(48979051,'piste:type','downhill'),(48979052,'name','Solanella'),(48979052,'piste:difficulty','easy'),(48979052,'piste:type','downhill'),(48979055,'name','Falco'),(48979055,'piste:difficulty','advanced'),(48979055,'piste:type','downhill'),(48979056,'name','Fura'),(48979056,'piste:difficulty','easy'),(48979056,'piste:type','downhill'),(48979057,'piste:difficulty','easy'),(48979057,'piste:type','downhill'),(48979057,'sport','skiing'),(48979058,'name','Diagonal d\'Enllac'),(48979058,'piste:difficulty','easy'),(48979058,'piste:type','downhill'),(48979059,'name','Trencalès'),(48979059,'piste:difficulty','advanced'),(48979059,'piste:type','downhill'),(48979060,'name','Obagot'),(48979060,'piste:difficulty','intermediate'),(48979060,'piste:type','downhill'),(48979062,'name','Gall de Bosc'),(48979062,'piste:difficulty','easy'),(48979062,'piste:type','downhill'),(48979063,'piste:difficulty','intermediate'),(48979063,'piste:type','downhill'),(50568365,'CLC:code','321'),(50568365,'CLC:id','FR-244978'),(50568365,'CLC:year','2006'),(50568365,'natural','grassland'),(50568365,'source','Union européenne - SOeS, CORINE Land Cover, 2006.'),(50734991,'highway','track'),(52008425,'aerialway','chair_lift'),(52008425,'aerialway:occupancy','2'),(52008425,'name','La Caubella'),(52008767,'aerialway','chair_lift'),(52008767,'aerialway:occupancy','2'),(52008767,'name','La Serra'),(52009081,'aerialway','chair_lift'),(52009081,'aerialway:occupancy','4'),(52009081,'name','La Carbonera'),(52009565,'aerialway','chair_lift'),(52009565,'aerialway:occupancy','4'),(52009565,'name','La Serra II'),(52010630,'aerialway','chair_lift'),(52010630,'aerialway:occupancy','4'),(52010630,'name','La Botella'),(52010729,'aerialway','chair_lift'),(52010729,'aerialway:occupancy','4'),(52010729,'name','Setúria'),(52010876,'aerialway','chair_lift'),(52010876,'aerialway:occupancy','6'),(52010876,'name','El Cubil'),(52035289,'aerialway','platter'),(52035289,'name','L\'Hortell'),(52036011,'aerialway','chair_lift'),(52036011,'aerialway:occupancy','4'),(52036011,'name','L\'Abarsetar'),(52038527,'aerialway','chair_lift'),(52038527,'aerialway:occupancy','6'),(52038527,'name','Les Fonts'),(52038627,'aerialway','chair_lift'),(52038627,'aerialway:occupancy','4'),(52038627,'name','El Cortal'),(52083535,'aerialway','platter'),(52083535,'name','Els Vailets'),(52083655,'aerialway','platter'),(52083655,'name','Els Vailets'),(52084359,'name','L\'Estadi'),(52084359,'piste:difficulty','intermediate'),(52084359,'piste:type','downhill'),(52098923,'aerialway','platter'),(52098923,'name','Els Feixans'),(52099062,'piste:difficulty','freeride'),(52099062,'piste:type','downhill'),(52099251,'name','La Basera'),(52099251,'piste:difficulty','novice'),(52099251,'piste:type','downhill'),(52099335,'name','Els Feixans'),(52099335,'piste:difficulty','freeride'),(52099335,'piste:type','downhill'),(52099379,'name','La Balma'),(52099379,'piste:difficulty','intermediate'),(52099379,'piste:type','downhill'),(52099485,'name','La Portella d\'Arcalis'),(52099485,'piste:difficulty','advanced'),(52099485,'piste:grooming','backcountry'),(52099485,'piste:type','downhill'),(52110420,'aerialway','cable_car'),(52110420,'aerialway:occupancy','10'),(52110420,'name','TC10 Tarter'),(52110421,'aerialway','chair_lift'),(52110421,'aerialway:occupancy','4'),(52110421,'name','TSD4 Tarter'),(52112644,'name','Corpalanca'),(52112644,'piste:difficulty','intermediate'),(52112644,'piste:type','downhill'),(52112644,'sport','skiing'),(52112645,'name','Estadi Eslalom'),(52112645,'piste:difficulty','intermediate'),(52112645,'piste:type','downhill'),(52112645,'sport','skiing'),(52112646,'aerialway','drag_lift'),(52112646,'name','La Serra'),(52112647,'name','El Bec'),(52112647,'piste:difficulty','easy'),(52112647,'piste:type','downhill'),(52112647,'sport','skiing'),(52112648,'name','El Planell'),(52112648,'piste:difficulty','novice'),(52112648,'piste:type','downhill'),(52112648,'sport','skiing'),(52112649,'name','Els Avets'),(52112649,'piste:difficulty','easy'),(52112649,'piste:type','downhill'),(52112649,'sport','skiing'),(52112650,'name','Transversal'),(52112650,'piste:difficulty','novice'),(52112650,'piste:type','downhill'),(52112650,'sport','skiing'),(52112651,'name','El Besurt II'),(52112651,'piste:difficulty','easy'),(52112651,'piste:type','downhill'),(52112651,'sport','skiing'),(52112652,'name','El Besurt'),(52112652,'piste:difficulty','intermediate'),(52112652,'piste:type','downhill'),(52112652,'sport','skiing'),(52114934,'piste:difficulty','intermediate'),(52114934,'piste:type','downhill'),(52114934,'sport','skiing'),(52114935,'name','Poselletes'),(52114935,'piste:difficulty','intermediate'),(52114935,'piste:type','downhill'),(52114935,'sport','skiing'),(52114936,'name','Coll De La Botella'),(52114936,'piste:difficulty','easy'),(52114936,'piste:type','downhill'),(52114936,'sport','skiing'),(52114937,'name','El Gall'),(52114937,'piste:difficulty','easy'),(52114937,'piste:type','downhill'),(52114937,'sport','skiing'),(52114938,'name','Fontanals De Les Roques'),(52114938,'piste:difficulty','intermediate'),(52114938,'piste:type','downhill'),(52114938,'sport','skiing'),(52114939,'aerialway','drag_lift'),(52114939,'name','El Cubil'),(52114940,'name','Cubil'),(52114940,'piste:difficulty','intermediate'),(52114940,'piste:type','downhill'),(52114940,'sport','skiing'),(52114942,'aerialway','drag_lift'),(52114942,'name','Els Coms'),(52114943,'name','La Serra'),(52114943,'piste:difficulty','intermediate'),(52114943,'piste:type','downhill'),(52114943,'sport','skiing'),(52114944,'name','Cami Superior'),(52114944,'piste:difficulty','easy'),(52114944,'piste:type','downhill'),(52114944,'sport','skiing'),(52114946,'name','Fontanals'),(52114946,'piste:difficulty','intermediate'),(52114946,'piste:type','downhill'),(52114946,'sport','skiing'),(52114947,'name','La Cot'),(52114947,'piste:difficulty','intermediate'),(52114947,'piste:type','downhill'),(52114947,'sport','skiing'),(52114948,'name','Coms'),(52114948,'piste:difficulty','intermediate'),(52114948,'piste:type','downhill'),(52114948,'sport','skiing'),(52114949,'name','La Comellada'),(52114949,'piste:difficulty','advanced'),(52114949,'piste:type','downhill'),(52114949,'sport','skiing'),(52114950,'name','La Serra'),(52114950,'piste:difficulty','easy'),(52114950,'piste:type','downhill'),(52114950,'sport','skiing'),(52114951,'name','Font Roja'),(52114951,'piste:difficulty','intermediate'),(52114951,'piste:type','downhill'),(52114951,'sport','skiing'),(52114952,'aerialway','gondola'),(52114952,'name','Arinsal-Pal'),(52114952,'oneway','no'),(52121995,'aerialway','platter'),(52121995,'name','La Capa'),(52122469,'name','La Capa'),(52122469,'piste:difficulty','advanced'),(52122469,'piste:grooming','classic'),(52122469,'piste:type','downhill'),(52123370,'aerialway','platter'),(52123370,'name','El Coll'),(52123917,'name','Les Marrades'),(52123917,'piste:difficulty','easy'),(52123917,'piste:grooming','classic'),(52123917,'piste:type','downhill'),(52163682,'aerialway','chair_lift'),(52163683,'aerialway','chair_lift'),(52163683,'aerialway:occupancy','4'),(52163683,'name','TSF4 Enradort'),(52163684,'name','Riu Del Cubill'),(52163684,'piste:difficulty','intermediate'),(52163684,'piste:type','downhill'),(52163684,'sport','skiing'),(52163691,'name','Pla De Les Pedres'),(52163691,'piste:difficulty','intermediate'),(52163691,'piste:type','downhill'),(52163691,'sport','skiing'),(52163693,'name','Serra De Les Solanelles'),(52163693,'piste:difficulty','easy'),(52163693,'piste:type','downhill'),(52163693,'sport','skiing'),(52163695,'name','Obaga'),(52163695,'piste:difficulty','easy'),(52163695,'piste:type','downhill'),(52163695,'sport','skiing'),(52163698,'name','Gaig'),(52163698,'piste:difficulty','advanced'),(52163698,'piste:type','downhill'),(52163698,'sport','skiing'),(52163700,'name','Rossinyol'),(52163700,'piste:difficulty','easy'),(52163700,'piste:type','downhill'),(52163700,'sport','skiing'),(52163704,'aerialway','chair_lift'),(52163704,'aerialway:occupancy','4'),(52163704,'name','TSD4 Portella'),(52163705,'name','Tamarro'),(52163705,'piste:difficulty','intermediate'),(52163705,'piste:type','downhill'),(52163705,'sport','skiing'),(52163710,'aerialway','chair_lift'),(52163710,'aerialway:occupancy','4'),(52163710,'name','TSF4 Junior'),(52163712,'name','Junior'),(52163712,'piste:difficulty','novice'),(52163712,'piste:type','downhill'),(52163712,'sport','skiing'),(52163714,'aerialway','drag_lift'),(52163714,'name','TK Llosada'),(52163716,'name','Oreneta'),(52163716,'piste:difficulty','easy'),(52163716,'piste:type','downhill'),(52163716,'sport','skiing'),(52163719,'name','Teixo'),(52163719,'piste:difficulty','easy'),(52163719,'piste:type','downhill'),(52163719,'sport','skiing'),(52163722,'name','Llop'),(52163722,'piste:difficulty','intermediate'),(52163722,'piste:type','downhill'),(52163722,'sport','skiing'),(52163729,'name','Obac Solana'),(52163729,'piste:difficulty','easy'),(52163729,'piste:type','downhill'),(52163729,'sport','skiing'),(52163731,'name','Solana'),(52163731,'piste:difficulty','easy'),(52163731,'piste:type','downhill'),(52163731,'sport','skiing'),(52163733,'name','Marmota'),(52163733,'piste:difficulty','easy'),(52163733,'piste:type','downhill'),(52163733,'sport','skiing'),(52163736,'aerialway','chair_lift'),(52163736,'aerialway:occupancy','4'),(52163736,'name','TSF4 Els Clots'),(52163738,'name','Daina'),(52163738,'piste:difficulty','easy'),(52163738,'piste:type','downhill'),(52163738,'sport','skiing'),(52163739,'aerialway','chair_lift'),(52163739,'aerialway:occupancy','4'),(52163739,'name','TSF4 Colibri'),(52163740,'piste:difficulty','easy'),(52163740,'piste:type','downhill'),(52163740,'sport','skiing'),(52163743,'piste:difficulty','intermediate'),(52163743,'piste:type','downhill'),(52163743,'sport','skiing'),(52163745,'piste:difficulty','intermediate'),(52163745,'piste:type','downhill'),(52163745,'sport','skiing'),(52163746,'name','Cucut'),(52163746,'piste:difficulty','advanced'),(52163746,'piste:type','downhill'),(52163746,'sport','skiing'),(52163748,'piste:difficulty','intermediate'),(52163748,'piste:type','downhill'),(52163748,'sport','skiing'),(52163750,'piste:difficulty','easy'),(52163750,'piste:type','downhill'),(52163750,'sport','skiing'),(52163751,'piste:difficulty','easy'),(52163751,'piste:type','downhill'),(52163751,'sport','skiing'),(52163753,'name','Serrat De La Posa'),(52163753,'piste:difficulty','intermediate'),(52163753,'piste:type','downhill'),(52163753,'sport','skiing'),(52163754,'piste:difficulty','advanced'),(52163754,'piste:type','downhill'),(52163754,'sport','skiing'),(52171935,'aerialway','drag_lift'),(52171935,'name','TK Espiolets'),(52171936,'name','Duc'),(52171936,'piste:difficulty','easy'),(52171936,'piste:type','downhill'),(52171936,'sport','skiing'),(52171937,'name','Llebre'),(52171937,'piste:difficulty','intermediate'),(52171937,'piste:type','downhill'),(52171937,'sport','skiing'),(52171938,'name','Esquirol'),(52171938,'piste:difficulty','easy'),(52171938,'piste:type','downhill'),(52171938,'sport','skiing'),(52171939,'name','Torrallardona'),(52171939,'piste:difficulty','intermediate'),(52171939,'piste:type','downhill'),(52171939,'sport','skiing'),(52171940,'aerialway','drag_lift'),(52171940,'name','TK Font Roges'),(52171941,'name','Mussol'),(52171941,'piste:difficulty','intermediate'),(52171941,'piste:type','downhill'),(52171941,'sport','skiing'),(52171942,'name','Pardal'),(52171942,'piste:difficulty','easy'),(52171942,'piste:type','downhill'),(52171942,'sport','skiing'),(52171943,'aerialway','chair_lift'),(52171943,'aerialway:occupancy','4'),(52171943,'name','TSF4 Pi De Migdia'),(52171944,'aerialway','chair_lift'),(52171944,'name','TSF2 Riba'),(52171945,'piste:difficulty','easy'),(52171945,'piste:type','downhill'),(52171945,'sport','skiing');
INSERT INTO `current_way_tags` VALUES (52171946,'piste:difficulty','easy'),(52171946,'piste:type','downhill'),(52171946,'sport','skiing'),(52171947,'name','Salvans'),(52171947,'piste:difficulty','intermediate'),(52171947,'piste:type','downhill'),(52171947,'sport','skiing'),(52172905,'aerialway','cable_car'),(52172905,'name','Funicamp'),(52172907,'name','Fagina'),(52172907,'piste:difficulty','intermediate'),(52172907,'piste:type','downhill'),(52172907,'sport','skiing'),(52172909,'name','Aliga'),(52172909,'piste:difficulty','advanced'),(52172909,'piste:type','downhill'),(52172909,'sport','skiing'),(52172911,'name','Esparver'),(52172911,'piste:difficulty','intermediate'),(52172911,'piste:type','downhill'),(52172911,'sport','skiing'),(52172913,'name','Muflo'),(52172913,'piste:difficulty','advanced'),(52172913,'piste:type','downhill'),(52172913,'sport','skiing'),(52172914,'name','Cabirol'),(52172914,'piste:difficulty','advanced'),(52172914,'piste:type','downhill'),(52172914,'sport','skiing'),(52172915,'name','Voltor'),(52172915,'piste:difficulty','advanced'),(52172915,'piste:type','downhill'),(52172915,'sport','skiing'),(52172916,'name','Corb'),(52172916,'piste:difficulty','advanced'),(52172916,'piste:type','downhill'),(52172916,'sport','skiing'),(52172918,'name','Cortalets'),(52172918,'piste:difficulty','easy'),(52172918,'piste:type','downhill'),(52172918,'sport','skiing'),(52172919,'piste:difficulty','easy'),(52172919,'piste:type','downhill'),(52172919,'sport','skiing'),(52172920,'aerialway','rope_tow'),(52172921,'piste:difficulty','easy'),(52172921,'piste:type','downhill'),(52172921,'sport','skiing'),(52174944,'aerialway','chair_lift'),(52174944,'aerialway:occupancy','4'),(52174944,'name','TSF4 Solana'),(52174946,'aerialway','chair_lift'),(52174946,'aerialway:occupancy','4'),(52174946,'name','TSD4 Pas De La Casa'),(52174948,'aerialway','chair_lift'),(52174948,'aerialway:occupancy','2'),(52174948,'name','TSF2 Coll Blanc'),(52174950,'aerialway','chair_lift'),(52174950,'aerialway:occupancy','6'),(52174950,'name','TSD6 Font Negre'),(52174952,'aerialway','drag_lift'),(52174952,'name','TK Coma Blanca III'),(52174953,'aerialway','chair_lift'),(52174953,'aerialway:occupancy','2'),(52174953,'name','TSF2 Riberal'),(52174956,'aerialway','chair_lift'),(52174956,'aerialway:occupancy','4'),(52174956,'name','TSD4 Antenes'),(52174958,'aerialway','drag_lift'),(52174958,'name','TK Montmalus'),(52174959,'aerialway','drag_lift'),(52174959,'name','TK Clot'),(52174960,'aerialway','chair_lift'),(52174960,'aerialway:occupancy','4'),(52174960,'name','TSF4 Xavi'),(52174962,'aerialway','drag_lift'),(52174962,'name','TK Pic Blanc'),(52174963,'aerialway','chair_lift'),(52174963,'aerialway:occupancy','4'),(52174963,'name','TSF4 Costa Rodona'),(52268017,'name','Tub del Coll'),(52268017,'piste:difficulty','advanced'),(52268017,'piste:grooming','backcountry'),(52268017,'piste:type','downhill'),(52692955,'name','Bony Vaques'),(52692955,'piste:difficulty','advanced'),(52692955,'piste:type','downhill'),(52692955,'sport','skiing'),(52692956,'name','Les Fonts'),(52692956,'piste:difficulty','easy'),(52692956,'piste:type','downhill'),(52692956,'sport','skiing'),(52692957,'name','La Solana'),(52692957,'piste:difficulty','easy'),(52692957,'piste:type','downhill'),(52692957,'sport','skiing'),(52692958,'aerialway','chair_lift'),(52692958,'aerialway:occupancy','4'),(52692958,'name','Port Negre'),(52692959,'name','Tub Estadi'),(52692959,'piste:difficulty','intermediate'),(52692959,'piste:type','downhill'),(52692959,'sport','skiing'),(52692960,'name','La Pala'),(52692960,'piste:difficulty','intermediate'),(52692960,'piste:type','downhill'),(52692960,'sport','skiing'),(52692961,'aerialway','chair_lift'),(52692961,'aerialway:occupancy','4'),(52692961,'name','La Tossa'),(52692962,'name','La Tossa'),(52692962,'piste:difficulty','intermediate'),(52692962,'piste:type','downhill'),(52692962,'sport','skiing'),(52692963,'name','Estadi'),(52692963,'piste:difficulty','intermediate'),(52692963,'piste:type','downhill'),(52692963,'sport','skiing'),(52692964,'name','Planelles'),(52692964,'piste:difficulty','easy'),(52692964,'piste:type','downhill'),(52692964,'sport','skiing'),(52692965,'aerialway','drag_lift'),(52692965,'name','Els Planels'),(52692966,'name','Port Vell'),(52692966,'piste:difficulty','easy'),(52692966,'piste:type','downhill'),(52692966,'sport','skiing'),(52692967,'name','Salador'),(52692967,'piste:difficulty','easy'),(52692967,'piste:type','downhill'),(52692967,'sport','skiing'),(52692968,'aerialway','drag_lift'),(52692968,'name','Salador'),(52692969,'name','Margarida'),(52692969,'piste:difficulty','easy'),(52692969,'piste:type','downhill'),(52692969,'sport','skiing'),(52692970,'name','El Cortal'),(52692970,'piste:difficulty','novice'),(52692970,'piste:type','downhill'),(52692970,'sport','skiing'),(52692971,'piste:difficulty','novice'),(52692971,'piste:type','downhill'),(52692971,'sport','skiing'),(52697930,'name','La Portella del Mig'),(52697930,'piste:difficulty','intermediate'),(52697930,'piste:type','downhill'),(52697930,'sport','skiing'),(52697931,'name','Els Orris'),(52697931,'piste:difficulty','novice'),(52697931,'piste:type','downhill'),(52697931,'sport','skiing'),(52697932,'name','La Coma'),(52697932,'piste:difficulty','easy'),(52697932,'piste:type','downhill'),(52697932,'sport','skiing'),(52697934,'name','El Mur'),(52697934,'piste:difficulty','intermediate'),(52697934,'piste:type','downhill'),(52697934,'sport','skiing'),(52697935,'name','El Tunel'),(52697935,'piste:difficulty','novice'),(52697935,'piste:type','downhill'),(52697935,'sport','skiing'),(52697936,'name','Woodpark'),(52697936,'piste:difficulty','freeride'),(52697936,'piste:type','downhill'),(52697936,'sport','skiing'),(52697937,'name','L\'Hortell'),(52697937,'piste:difficulty','intermediate'),(52697937,'piste:type','downhill'),(52697937,'sport','skiing'),(52697938,'name','El Bosc'),(52697938,'piste:difficulty','intermediate'),(52697938,'piste:type','downhill'),(52697938,'sport','skiing'),(52697939,'name','La Font'),(52697939,'piste:difficulty','easy'),(52697939,'piste:type','downhill'),(52697939,'sport','skiing'),(52697940,'name','Les Canals'),(52697940,'piste:difficulty','easy'),(52697940,'piste:type','downhill'),(52697940,'sport','skiing'),(52697941,'name','La Canal Gran'),(52697941,'piste:difficulty','advanced'),(52697941,'piste:type','downhill'),(52697941,'sport','skiing'),(52697942,'name','Els Terragals'),(52697942,'piste:difficulty','easy'),(52697942,'piste:type','downhill'),(52697942,'sport','skiing'),(52697943,'name','ECOA'),(52697943,'piste:difficulty','easy'),(52697943,'piste:type','downhill'),(52697943,'sport','skiing'),(52697944,'name','Les Tarteres'),(52697944,'piste:difficulty','intermediate'),(52697944,'piste:type','downhill'),(52697944,'sport','skiing'),(52697945,'name','Les Congestes'),(52697945,'piste:difficulty','intermediate'),(52697945,'piste:type','downhill'),(52697945,'sport','skiing'),(52697946,'name','La Canaleta'),(52697946,'piste:difficulty','intermediate'),(52697946,'piste:type','downhill'),(52697946,'sport','skiing'),(52697947,'aerialway','chair_lift'),(52697947,'aerialway:occupancy','4'),(52697947,'name','Creussans'),(52697948,'name','L\'Estany'),(52697948,'piste:difficulty','intermediate'),(52697948,'piste:type','downhill'),(52697948,'sport','skiing'),(52697949,'aerialway','chair_lift'),(52697949,'aerialway:occupancy','6'),(52697949,'name','La Coma'),(52697950,'name','La Bassa'),(52697950,'piste:difficulty','easy'),(52697950,'piste:type','downhill'),(52697950,'sport','skiing'),(52697951,'name','El Riu'),(52697951,'piste:difficulty','novice'),(52697951,'piste:type','downhill'),(52697951,'sport','skiing'),(52697952,'name','L\'Avetar'),(52697952,'piste:difficulty','intermediate'),(52697952,'piste:type','downhill'),(52697952,'sport','skiing'),(54858984,'name','Pyrénées Hyper-Centre'),(54858984,'shop','supermarket'),(61736197,'highway','primary'),(61736197,'maxspeed','90'),(61736197,'name','Port d\'Envalira'),(61736197,'ref','CG-2'),(61736197,'source','yahoo'),(61736199,'highway','primary'),(61736199,'maxspeed','30'),(61736199,'name','Port d\'Envalira'),(61736199,'ref','CG-2'),(61736199,'source','yahoo'),(61736200,'highway','primary'),(61736200,'maxspeed','90'),(61736200,'name','Port d\'Envalira'),(61736200,'ref','CG-2'),(61736200,'source','yahoo'),(61736202,'highway','primary'),(61736202,'maxspeed','30'),(61736202,'name','Port d\'Envalira'),(61736202,'ref','CG-2'),(61736202,'source','yahoo'),(61736203,'highway','primary'),(61736203,'maxspeed','90'),(61736203,'name','Port d\'Envalira'),(61736203,'ref','CG-2'),(61736203,'source','yahoo'),(61736208,'highway','primary'),(61736208,'maxspeed','90;30;90;30;90;30'),(61736208,'name','Port d\'Envalira'),(61736208,'ref','CG-2'),(61736208,'source','yahoo'),(61736209,'highway','primary'),(61736209,'maxspeed','30'),(61736209,'name','Port d\'Envalira'),(61736209,'ref','CG-2'),(61736209,'source','yahoo'),(70427100,'highway','unclassified'),(70427114,'highway','unclassified'),(70427114,'tracktype','grade1'),(70427179,'highway','unclassified'),(70427179,'tracktype','grade1'),(70428387,'bridge','yes'),(70428387,'highway','unclassified'),(70428387,'layer','1'),(75744715,'highway','residential'),(75746393,'bridge','yes'),(75746393,'highway','footway'),(75746394,'highway','service'),(75746395,'highway','track'),(75746395,'name','Cami del Ferrer de l\'Olla'),(75746396,'highway','residential'),(75746397,'highway','track'),(75746398,'highway','primary'),(75746398,'ref','CG-2'),(75746398,'source','yahoo'),(75746399,'bridge','yes'),(75746399,'highway','track'),(75746400,'highway','footway'),(75746401,'highway','track'),(75746402,'highway','residential'),(75746403,'highway','tertiary'),(75746404,'highway','track'),(75746405,'highway','track'),(75746406,'highway','residential'),(75746409,'highway','track'),(75746409,'name','Camì de les Pardines'),(75746409,'tracktype','grade2'),(75746410,'highway','track'),(75746410,'ref','GR-11'),(75746411,'highway','residential'),(75746412,'highway','track'),(75746414,'highway','footway'),(75746415,'highway','primary'),(75746415,'junction','roundabout'),(75746416,'highway','residential'),(75746417,'highway','residential'),(75746418,'bridge','yes'),(75746418,'highway','track'),(75746419,'highway','track'),(75746421,'amenity','parking'),(75746422,'highway','footway'),(75746423,'highway','track'),(75746424,'highway','footway'),(75871448,'waterway','stream'),(77918991,'highway','path'),(77918991,'name','GR-107'),(77918991,'sac_scale','alpine_hiking'),(79126612,'highway','track');
INSERT INTO `current_ways` VALUES (6165450,592895,'2008-07-25 23:38:32',1,11),(6165679,3283462,'2009-12-03 21:55:01',1,18),(6165877,4963967,'2010-06-11 20:09:52',1,7),(6165944,495907,'2008-07-15 19:53:29',1,12),(6166082,495907,'2008-07-15 19:50:23',1,9),(6166123,495907,'2008-07-15 19:46:04',1,7),(6166128,531541,'2008-05-27 10:39:41',1,4),(6166136,4963967,'2010-06-11 20:09:44',1,4),(6166145,531541,'2008-05-27 10:39:56',1,4),(6166185,531541,'2008-05-27 10:39:55',1,6),(6176624,5107412,'2010-06-29 20:15:57',1,6),(6176663,4963942,'2010-06-11 20:05:27',1,3),(6176681,4963942,'2010-06-11 20:05:26',1,5),(6176755,5107412,'2010-06-29 20:15:32',1,13),(6177152,531541,'2008-05-27 10:39:46',1,8),(6177369,531541,'2008-05-27 10:39:53',1,5),(6177399,531541,'2008-05-27 10:39:55',1,6),(6177409,531541,'2008-05-27 10:39:45',1,4),(6178503,531541,'2008-05-27 10:39:44',1,7),(6178632,531541,'2008-05-27 10:39:40',1,6),(6178685,531541,'2008-05-27 10:39:47',1,6),(6178688,531541,'2008-05-27 10:39:52',1,5),(6178694,5671401,'2010-09-03 18:06:00',1,5),(6178791,531541,'2008-05-27 10:39:46',1,4),(6178964,189418,'2008-04-19 22:43:10',1,2),(6178980,198831,'2008-04-20 16:27:47',1,3),(6179103,2895121,'2009-10-19 19:23:28',1,5),(6179174,531541,'2008-05-27 10:39:54',1,5),(6179240,188228,'2008-06-16 18:52:21',1,4),(6179270,531541,'2008-05-27 10:40:04',1,4),(6179470,189418,'2008-04-19 22:47:07',1,2),(6179561,198831,'2008-04-20 16:28:09',1,2),(6179675,2895121,'2009-10-19 19:18:34',1,9),(6179692,592895,'2008-07-25 22:38:46',1,6),(6180790,592895,'2008-07-25 23:36:49',1,8),(6180839,531541,'2008-05-27 10:39:59',1,3),(6180840,5107450,'2010-06-29 20:18:46',1,3),(6180852,592895,'2008-07-25 23:37:03',1,4),(6180968,2895121,'2009-10-19 19:23:46',1,12),(6180977,188228,'2008-06-16 19:38:45',1,3),(6180985,188228,'2008-06-16 19:39:37',1,5),(6180988,531541,'2008-05-27 10:39:56',1,4),(6181319,478731,'2008-08-31 13:57:01',1,2),(6181357,478731,'2008-08-31 13:57:00',1,3),(6181419,478731,'2008-08-31 13:57:00',1,2),(6181836,4963942,'2010-06-11 20:05:35',1,3),(6181838,553642,'2008-05-31 01:43:48',1,8),(6181947,198831,'2008-04-20 16:20:28',1,2),(6182051,305941,'2009-02-09 21:25:15',1,4),(6182052,3878347,'2010-02-14 22:47:46',1,4),(6182053,56648,'2008-06-05 19:59:58',1,3),(6182054,3100730,'2009-11-12 21:12:52',1,2),(6182056,56648,'2008-06-05 20:46:25',1,3),(6182057,56648,'2008-06-05 20:39:41',1,4),(6182058,56648,'2008-06-05 19:45:08',1,3),(6182065,981922,'2009-04-27 01:40:07',1,4),(6182097,3916355,'2010-02-19 17:32:01',1,7),(6182122,2369688,'2009-09-04 17:16:29',1,9),(6182127,820251,'2009-03-16 23:49:43',1,3),(6182159,2369688,'2009-09-04 17:16:28',1,5),(6182267,3100730,'2009-11-12 21:12:49',1,3),(6182278,3916355,'2010-02-19 17:32:05',1,4),(6182289,951833,'2009-04-25 18:47:58',1,3),(6182303,978767,'2009-04-26 22:29:09',1,3),(6182333,3916355,'2010-02-19 17:32:00',1,5),(6182349,56648,'2008-06-05 20:14:45',1,2),(6182350,56648,'2008-06-05 20:18:20',1,3),(6182364,188228,'2008-06-16 18:36:30',1,13),(6182371,1276166,'2009-05-21 17:14:30',1,11),(6182386,462438,'2008-07-11 12:59:48',1,4),(6182401,820251,'2009-03-16 23:48:46',1,5),(6182410,3916355,'2010-02-19 17:33:05',1,12),(6182463,3100730,'2009-11-12 21:12:52',1,6),(6182505,3916355,'2010-02-19 17:33:24',1,4),(6182542,225225,'2008-04-23 00:46:13',1,8),(6182577,3100730,'2009-11-12 21:12:48',1,2),(6182675,3100730,'2009-11-12 21:12:49',1,2),(6182714,3100730,'2009-11-12 21:12:55',1,2),(6182761,3916355,'2010-02-19 17:33:05',1,9),(6182765,462689,'2008-05-17 12:18:56',1,3),(6182771,56648,'2008-06-05 19:39:48',1,2),(6182773,56648,'2008-06-05 20:47:28',1,3),(6182798,305941,'2009-02-09 21:27:05',1,3),(6182810,56648,'2008-06-05 20:40:00',1,2),(6182844,427965,'2007-09-14 21:16:04',1,1),(6182932,553642,'2008-05-31 01:43:44',1,4),(6183078,3100730,'2009-11-12 21:12:50',1,2),(6183100,5671401,'2010-09-03 18:06:02',1,7),(6183127,3100730,'2009-11-12 21:12:53',1,2),(6183169,258874,'2008-10-11 17:23:03',1,2),(6183270,3100730,'2009-11-12 21:12:55',1,2),(6183273,3100730,'2009-11-12 21:12:55',1,3),(6183357,3100730,'2009-11-12 21:12:54',1,2),(6183360,3100730,'2009-11-12 21:12:55',1,2),(6183573,3100730,'2009-11-12 21:12:50',1,2),(6184947,427965,'2007-09-14 22:01:04',1,1),(6185032,592895,'2008-07-25 22:36:09',1,3),(6185060,3100730,'2009-11-12 21:12:50',1,2),(6185090,3100730,'2009-11-12 21:12:48',1,2),(6185110,697263,'2009-01-01 16:45:35',1,7),(6185122,592895,'2008-07-26 00:32:16',1,11),(6185149,3100730,'2009-11-12 21:12:50',1,2),(6185336,592895,'2008-07-25 22:17:50',1,3),(6185353,3100730,'2009-11-12 21:12:49',1,3),(6185363,3100730,'2009-11-12 21:12:49',1,2),(6185394,56648,'2008-06-05 20:02:45',1,2),(6185421,437032,'2008-05-13 22:22:44',1,2),(6185589,56648,'2008-06-05 20:21:41',1,2),(6185611,91018,'2008-06-07 20:24:45',1,3),(6185640,3878347,'2010-02-14 22:47:46',1,3),(6185710,427965,'2007-09-14 22:11:53',1,1),(6185726,56648,'2008-06-05 19:30:56',1,4),(6185775,56648,'2008-06-05 19:44:23',1,3),(6185795,3100730,'2009-11-12 21:12:54',1,2),(6185800,305941,'2009-02-09 21:21:16',1,13),(6185807,305941,'2009-02-09 21:20:13',1,4),(6185826,495907,'2008-07-15 17:28:34',1,9),(6185878,495907,'2008-07-15 17:27:38',1,8),(6185911,3100730,'2009-11-12 21:12:56',1,2),(6185926,3100730,'2009-11-12 21:12:56',1,2),(6185930,3100730,'2009-11-12 21:12:56',1,2),(6185971,531541,'2008-05-27 10:39:52',1,5),(6185986,5671401,'2010-09-03 18:06:00',1,8),(6185988,188228,'2008-06-16 19:41:47',1,5),(6186037,4963967,'2010-06-11 20:09:41',1,10),(6186094,3100730,'2009-11-12 21:12:56',1,2),(6195793,1276166,'2009-05-21 17:09:44',1,6),(6195794,225225,'2008-04-23 00:45:56',1,6),(6195795,3100730,'2009-11-12 21:12:53',1,2),(6195796,3100730,'2009-11-12 21:12:53',1,2),(6195797,3100730,'2009-11-12 21:12:53',1,2),(6195885,183661,'2008-04-18 18:59:28',1,2),(6196087,531541,'2008-05-27 10:40:02',1,6),(6196407,870814,'2009-03-31 00:59:11',1,8),(6197719,197512,'2008-04-20 03:21:28',1,5),(6197721,4804396,'2010-05-25 17:58:16',1,17),(6197723,1684788,'2009-06-30 11:19:40',1,4),(6197727,615859,'2008-07-28 13:59:33',1,18),(6198025,1684788,'2009-06-30 11:19:40',1,7),(6198027,553642,'2008-05-31 01:43:45',1,4),(6198139,553642,'2008-05-31 01:43:48',1,4),(6225803,553642,'2008-05-31 01:43:38',1,14),(6225812,437032,'2008-05-13 19:47:14',1,2),(6227096,5025308,'2010-06-19 19:17:26',1,6),(6227097,5025308,'2010-06-19 19:17:30',1,6),(6228283,210114,'2008-08-12 23:25:46',1,2),(6230227,3100730,'2009-11-12 21:12:36',1,2),(6230228,3100730,'2009-11-12 21:12:43',1,3),(6230229,3100730,'2009-11-12 21:12:43',1,2),(6230231,433922,'2008-10-19 02:57:33',1,4),(6230232,3100730,'2009-11-12 21:12:43',1,3),(6230233,189418,'2008-04-19 22:45:34',1,2),(6230234,3100730,'2009-11-12 21:12:43',1,3),(6242742,373445,'2008-05-09 19:04:04',1,2),(6242747,19873,'2008-06-02 18:30:23',1,12),(6242753,56648,'2008-06-05 19:20:19',1,16),(6242756,1276166,'2009-05-21 17:09:55',1,6),(6242757,225225,'2008-04-23 00:46:07',1,4),(6242759,225225,'2008-04-23 00:46:13',1,6),(6244541,21109,'2008-06-02 23:03:50',1,4),(6244542,435967,'2007-09-15 23:04:41',1,1),(6244545,435967,'2007-09-15 23:04:42',1,1),(6244550,3132766,'2009-11-16 17:27:53',1,3),(6244551,3132766,'2009-11-16 17:27:53',1,2),(6244552,3132766,'2009-11-16 17:27:53',1,5),(6244554,3132766,'2009-11-16 17:27:53',1,2),(6244556,3132766,'2009-11-16 17:27:53',1,2),(6244558,3132766,'2009-11-16 17:27:53',1,4),(6244561,3132766,'2009-11-16 17:27:53',1,2),(6244562,3132766,'2009-11-16 17:27:53',1,2),(6244759,3132766,'2009-11-16 17:27:53',1,2),(6244763,3132766,'2009-11-16 17:27:52',1,2),(6247260,3100730,'2009-11-12 21:12:40',1,2),(6247267,3100730,'2009-11-12 21:12:40',1,2),(6247268,5107450,'2010-06-29 20:19:04',1,4),(6247269,5107450,'2010-06-29 20:18:44',1,3),(6247270,5107450,'2010-06-29 20:18:45',1,3),(6247271,5107450,'2010-06-29 20:18:44',1,3),(6247273,5107450,'2010-06-29 20:18:45',1,3),(6247274,3100730,'2009-11-12 21:12:40',1,2),(6247278,3100730,'2009-11-12 21:12:40',1,2),(6247279,27626,'2009-04-01 15:50:51',1,2),(6247280,3100730,'2009-11-12 21:12:46',1,2),(6247282,27626,'2009-04-01 15:42:42',1,2),(6247283,3132766,'2009-11-16 17:27:48',1,2),(6247284,3132766,'2009-11-16 17:27:47',1,2),(6247285,3132766,'2009-11-16 17:27:47',1,2),(6247286,3132766,'2009-11-16 17:27:47',1,2),(6247287,3132766,'2009-11-16 17:27:47',1,2),(6247288,3132766,'2009-11-16 17:27:47',1,2),(6247289,3132766,'2009-11-16 17:27:47',1,2),(6247290,3132766,'2009-11-16 17:27:46',1,2),(6247291,3132766,'2009-11-16 17:27:48',1,2),(6247292,3132766,'2009-11-16 17:27:47',1,2),(6247294,3132766,'2009-11-16 17:27:48',1,2),(6247295,3132766,'2009-11-16 17:27:48',1,2),(6247296,3132766,'2009-11-16 17:27:48',1,2),(6248150,3132766,'2009-11-16 17:27:51',1,2),(6248151,3132766,'2009-11-16 17:27:52',1,2),(6248455,3132766,'2009-11-16 17:27:50',1,2),(6248456,3132766,'2009-11-16 17:27:51',1,2),(6248458,3132766,'2009-11-16 17:27:49',1,2),(6248459,3132766,'2009-11-16 17:27:51',1,2),(6248460,3132766,'2009-11-16 17:27:50',1,2),(6248461,3132766,'2009-11-16 17:27:51',1,2),(6248462,3132766,'2009-11-16 17:27:51',1,2),(6248463,3132766,'2009-11-16 17:27:51',1,2),(6248464,3132766,'2009-11-16 17:27:49',1,2),(6248467,3132766,'2009-11-16 17:27:49',1,2),(6248468,3132766,'2009-11-16 17:27:49',1,2),(6248469,3100730,'2009-11-12 21:12:46',1,2),(6249800,3100730,'2009-11-12 21:12:34',1,2),(6249802,3100730,'2009-11-12 21:12:46',1,2),(6249803,3100730,'2009-11-12 21:12:47',1,2),(6250052,3100730,'2009-11-12 21:12:47',1,2),(6250053,3100730,'2009-11-12 21:12:47',1,2),(6250055,3100730,'2009-11-12 21:12:48',1,2),(6250056,3100730,'2009-11-12 21:12:46',1,2),(6250057,3100730,'2009-11-12 21:12:46',1,2),(6250105,3100730,'2009-11-12 21:12:46',1,2),(6250238,3100730,'2009-11-12 21:12:45',1,2),(6250239,3100730,'2009-11-12 21:12:45',1,2),(6250280,3100730,'2009-11-12 21:12:31',1,2),(6267429,3100730,'2009-11-12 21:12:40',1,2),(6267881,5107450,'2010-06-29 20:18:45',1,4),(6267882,5107450,'2010-06-29 20:18:48',1,3),(6267884,3132766,'2009-11-16 17:27:48',1,2),(6268924,3132766,'2009-11-16 17:27:46',1,2),(6269464,3100730,'2009-11-12 21:12:31',1,2),(6275494,3100730,'2009-11-12 21:12:42',1,3),(6275497,3100730,'2009-11-12 21:12:41',1,2),(6275498,3100730,'2009-11-12 21:12:43',1,2),(6275499,3100730,'2009-11-12 21:12:43',1,2),(6275501,3916355,'2010-02-19 17:34:23',1,8),(6275503,443749,'2007-09-16 21:49:38',1,1),(6275504,3916355,'2010-02-19 17:34:14',1,6),(6275505,840745,'2009-01-26 19:28:31',1,6),(6275506,3916355,'2010-02-19 17:34:22',1,4),(6275507,4312140,'2010-04-03 14:51:37',1,4),(6275509,305941,'2009-02-09 21:23:22',1,3),(6275510,3916355,'2010-02-19 17:34:16',1,4),(6275512,3100730,'2009-11-12 21:12:52',1,5),(6275513,981922,'2009-04-27 01:41:06',1,4),(6275514,4652669,'2010-05-09 21:59:04',1,3),(6275516,305941,'2009-02-09 21:34:27',1,3),(6275517,370566,'2008-05-09 02:01:19',1,2),(6275518,3916355,'2010-02-19 17:31:56',1,4),(6275522,621592,'2008-12-26 01:06:21',1,2),(6275851,3100730,'2009-11-12 21:12:50',1,2),(6276661,592895,'2008-07-25 22:14:24',1,4),(6277172,443749,'2007-09-16 22:48:07',1,1),(6277173,443749,'2007-09-16 22:48:09',1,1),(6279235,443749,'2007-09-16 23:40:13',1,1),(6281014,3132766,'2009-11-16 17:28:04',1,2),(6281015,198831,'2008-04-20 16:19:47',1,2),(6281016,3132766,'2009-11-16 17:28:04',1,3),(6281017,3132766,'2009-11-16 17:27:54',1,2),(6281018,3132766,'2009-11-16 17:28:05',1,2),(6281019,3132766,'2009-11-16 17:27:54',1,3),(6281020,3132766,'2009-11-16 17:28:05',1,3),(6281021,3132766,'2009-11-16 17:28:05',1,2),(6281022,3132766,'2009-11-16 17:28:05',1,3),(6281358,553642,'2008-05-31 01:43:35',1,4),(6281360,3132766,'2009-11-16 17:28:07',1,2),(6281361,3132766,'2009-11-16 17:28:07',1,2),(6281741,3132766,'2009-11-16 17:28:05',1,2),(6281751,198831,'2008-04-20 16:20:33',1,2),(6281774,443749,'2007-09-17 01:24:13',1,1),(6281908,3132766,'2009-11-16 17:28:02',1,2),(6281909,3132766,'2009-11-16 17:28:03',1,2),(6281910,3132766,'2009-11-16 17:27:55',1,2),(6281916,3132766,'2009-11-16 17:28:03',1,2),(6282443,3132766,'2009-11-16 17:28:03',1,4),(6282444,3132766,'2009-11-16 17:28:03',1,2),(6282445,3132766,'2009-11-16 17:28:03',1,3),(6282446,3132766,'2009-11-16 17:28:03',1,2),(6282447,3132766,'2009-11-16 17:28:03',1,2),(6282448,3132766,'2009-11-16 17:28:02',1,2),(6282449,3132766,'2009-11-16 17:28:02',1,3),(6282450,3132766,'2009-11-16 17:28:02',1,2),(6282451,3132766,'2009-11-16 17:28:03',1,2),(6282452,3132766,'2009-11-16 17:28:03',1,2),(6541502,5043123,'2010-06-21 17:17:45',1,3),(6541505,495907,'2008-07-15 19:50:57',1,7),(6541507,531541,'2008-05-27 10:39:51',1,5),(6541510,307506,'2009-02-09 17:14:28',1,2),(6541514,3132766,'2009-11-16 17:28:01',1,2),(6541518,3132766,'2009-11-16 17:28:02',1,2),(6541520,3132766,'2009-11-16 17:28:00',1,4),(6541522,3132766,'2009-11-16 17:28:00',1,2),(6541525,3132766,'2009-11-16 17:28:01',1,2),(6541538,5043123,'2010-06-21 17:17:10',1,6),(6541541,3132766,'2009-11-16 17:28:00',1,4),(6548812,3132766,'2009-11-16 17:27:58',1,2),(6548814,3132766,'2009-11-16 17:27:58',1,2),(6548816,3132766,'2009-11-16 17:27:59',1,2),(6548818,3132766,'2009-11-16 17:27:58',1,2),(6548820,4963967,'2010-06-11 20:09:47',1,4),(6548822,3132766,'2009-11-16 17:28:00',1,2),(6548824,3132766,'2009-11-16 17:27:59',1,3),(6548826,3132766,'2009-11-16 17:27:59',1,3),(6551314,3132766,'2009-11-16 17:27:58',1,4),(6551317,531541,'2008-05-27 10:39:54',1,4),(6551320,4963967,'2010-06-11 20:09:48',1,3),(6553102,3132766,'2009-11-16 17:27:58',1,3),(6553108,3132766,'2009-11-16 17:27:56',1,2),(6553398,3132766,'2009-11-16 17:27:58',1,2),(6553516,3132766,'2009-11-16 17:27:56',1,2),(6553741,3132766,'2009-11-16 17:27:58',1,2),(6557168,3132766,'2009-11-16 17:27:59',1,2),(6557169,3132766,'2009-11-16 17:27:59',1,2),(6557171,3132766,'2009-11-16 17:28:00',1,2),(6557173,3132766,'2009-11-16 17:28:00',1,2),(6557177,454632,'2007-09-17 19:11:34',1,1),(6561466,454632,'2007-09-17 19:30:45',1,1),(6561468,3724172,'2010-01-27 00:45:34',1,6),(6561470,454632,'2007-09-17 19:30:48',1,1),(6561682,454632,'2007-09-17 19:33:24',1,1),(6561704,454632,'2007-09-17 19:33:35',1,1),(6561708,5043123,'2010-06-21 17:17:14',1,3),(6563683,4106774,'2010-03-12 16:31:17',1,4),(6563687,320551,'2008-12-11 14:24:02',1,2),(6563690,5671401,'2010-09-03 18:05:59',1,3),(6566558,188228,'2008-06-16 20:03:07',1,5),(6566561,3936411,'2010-02-21 19:45:24',1,4),(6566571,353783,'2008-08-21 18:35:35',1,2),(6566573,369842,'2008-08-22 02:13:49',1,2),(6566576,3100730,'2009-11-12 21:12:55',1,3),(6569859,327248,'2009-04-08 23:18:55',1,8),(6576845,210114,'2008-08-12 23:33:50',1,2),(6576847,226881,'2009-04-05 17:13:36',1,10),(6576853,226881,'2009-04-05 17:13:57',1,7),(6576855,210114,'2008-08-12 23:33:18',1,2),(6576858,3100730,'2009-11-12 21:12:52',1,3),(6576861,3100730,'2009-11-12 21:12:53',1,2),(6576864,3100730,'2009-11-12 21:12:58',1,2),(6576866,3100730,'2009-11-12 21:12:58',1,2),(6578446,423843,'2008-07-08 00:20:56',1,5),(6578449,3100730,'2009-11-12 21:12:58',1,3),(6578451,1075389,'2009-05-04 18:53:55',1,6),(6578454,423843,'2008-07-08 00:22:31',1,2),(6584903,498434,'2008-05-22 18:56:22',1,6),(6584906,615859,'2008-07-28 13:59:42',1,3),(6584908,2836771,'2009-10-13 18:40:57',1,3),(6584910,2836771,'2009-10-13 18:39:07',1,3),(6584917,553642,'2008-05-31 01:43:36',1,5),(6584920,19873,'2008-06-02 18:37:03',1,3),(6584925,19873,'2008-06-02 18:38:06',1,2),(6584928,327248,'2009-04-08 23:43:27',1,2),(6584939,210114,'2008-08-12 23:47:35',1,3),(6584947,19873,'2008-06-02 18:41:19',1,5),(6584951,19873,'2008-06-02 18:40:07',1,4),(6584956,19873,'2008-06-02 18:40:29',1,4),(6584961,3100730,'2009-11-12 21:12:52',1,2),(6588508,104780,'2009-02-04 00:33:00',1,2),(6588510,104780,'2009-02-04 00:29:51',1,2),(6588513,3100730,'2009-11-12 21:12:58',1,5),(6588516,3100730,'2009-11-12 21:12:57',1,6),(6588519,3100730,'2009-11-12 21:12:58',1,5),(6589890,441677,'2008-05-14 00:29:55',1,4),(6589898,19873,'2008-06-02 18:34:56',1,2),(6590538,725665,'2009-03-02 22:10:41',1,2),(6592657,3100730,'2009-11-12 21:12:58',1,3),(6593464,5694915,'2010-09-06 09:25:22',1,4),(6602616,363778,'2007-12-19 18:35:38',1,3),(6620914,3100730,'2009-11-12 21:12:57',1,2),(6620917,3100730,'2009-11-12 21:12:57',1,2),(6620920,3100730,'2009-11-12 21:12:57',1,2),(6620926,3100730,'2009-11-12 21:12:57',1,2),(6620930,3100730,'2009-11-12 21:12:57',1,2),(6620940,870814,'2009-03-31 00:59:28',1,7),(6620947,454632,'2007-09-18 01:05:12',1,1),(6620952,454632,'2007-09-18 01:05:14',1,1),(6620955,454632,'2007-09-18 01:05:15',1,1),(6620958,454632,'2007-09-18 01:05:16',1,1),(6620962,454632,'2007-09-18 01:05:18',1,1),(6620964,454632,'2007-09-18 01:05:19',1,1),(6620969,454632,'2007-09-18 01:05:20',1,1),(6620973,454632,'2007-09-18 01:05:22',1,1),(6620978,454632,'2007-09-18 01:05:22',1,1),(6620980,454632,'2007-09-18 01:05:23',1,1),(7934428,3100730,'2009-11-12 21:12:56',1,3),(7934443,3100730,'2009-11-12 21:12:56',1,2),(8164186,3882859,'2010-02-15 14:55:30',1,11),(8164452,3132766,'2009-11-16 17:27:54',1,3),(8164478,3132766,'2009-11-16 17:27:47',1,2),(8164597,3100730,'2009-11-12 21:12:36',1,3),(8164653,3132766,'2009-11-16 17:27:55',1,3),(8166678,3916410,'2010-02-19 17:39:40',1,4),(8561013,3100730,'2009-11-12 21:12:43',1,5),(8561432,5107450,'2010-06-29 20:18:48',1,3),(8667300,73843,'2007-10-09 23:08:12',1,1),(8880951,3124867,'2009-11-15 19:58:13',1,2),(8880952,3124867,'2009-11-15 19:58:11',1,8),(8880953,4963967,'2010-06-11 20:09:34',1,10),(8880955,3124867,'2009-11-15 19:58:06',1,2),(8880956,3124867,'2009-11-15 19:58:05',1,13),(8885021,3124867,'2009-11-15 19:58:02',1,5),(8885025,3124867,'2009-11-15 19:58:01',1,9),(17240968,557925,'2008-01-06 22:29:17',1,3),(17241049,621592,'2008-12-26 01:06:19',1,7),(22746153,5107412,'2010-06-29 20:14:48',1,4),(22746154,5107412,'2010-06-29 20:14:48',1,4),(22746155,5107412,'2010-06-29 20:14:46',1,4),(22746156,5107412,'2010-06-29 20:14:46',1,4),(22746157,5107412,'2010-06-29 20:14:47',1,5),(22746159,5107412,'2010-06-29 20:14:47',1,5),(22746160,5107412,'2010-06-29 20:14:44',1,7),(22932948,91631,'2008-02-10 16:54:29',1,1),(22932949,433922,'2008-10-19 02:12:05',1,3),(23305160,4159744,'2010-03-18 11:56:45',1,19),(23840927,1276166,'2009-05-21 17:10:34',1,9),(23840928,461502,'2008-05-16 18:35:59',1,8),(23841019,531541,'2008-05-27 10:39:58',1,7),(23841049,531541,'2008-05-27 10:40:16',1,6),(23841094,306164,'2008-05-01 17:05:59',1,6),(23841127,441038,'2008-07-09 18:15:09',1,14),(23841423,423843,'2008-07-08 00:26:53',1,7),(23841426,531541,'2008-05-27 10:39:52',1,2),(23842741,1276166,'2009-05-21 17:10:49',1,18),(23857062,1276166,'2009-05-21 17:09:30',1,14),(23857066,2895121,'2009-10-19 19:12:51',1,7),(23857247,404186,'2008-08-26 00:20:19',1,3),(23877195,5107412,'2010-06-29 20:14:37',1,10),(23877197,531541,'2008-05-27 10:39:45',1,4),(23877199,495907,'2008-07-15 20:26:14',1,7),(23877200,495907,'2008-07-15 20:26:37',1,11),(23877201,531541,'2008-05-27 10:39:42',1,2),(23878263,198831,'2008-04-20 16:36:30',1,1),(23878462,592895,'2008-07-25 22:15:37',1,5),(23878463,592895,'2008-07-25 22:18:15',1,5),(23924998,495907,'2008-07-15 21:08:53',1,9),(23925250,531541,'2008-05-27 10:39:39',1,8),(23925255,531541,'2008-05-27 10:39:40',1,4),(23925285,531541,'2008-05-27 10:40:09',1,2),(23938547,210114,'2008-08-12 23:50:39',1,5),(23978189,362976,'2008-05-08 16:10:19',1,5),(23978342,263367,'2008-04-26 15:38:08',1,3),(23978424,263367,'2008-04-26 15:40:27',1,1),(23978499,263367,'2008-04-26 15:50:01',1,2),(24058474,210114,'2008-08-12 23:49:35',1,2),(24059004,329152,'2008-05-04 19:09:05',1,3),(24059067,553642,'2008-05-31 01:43:50',1,3),(24059068,553642,'2008-05-31 01:43:49',1,6),(24059122,306164,'2008-05-01 17:48:42',1,3),(24059295,306164,'2008-05-01 17:47:55',1,4),(24059296,306164,'2008-05-01 17:49:41',1,2),(24059351,362976,'2008-05-08 16:09:54',1,3),(24059379,362976,'2008-05-08 16:09:46',1,2),(24059392,448710,'2008-05-14 17:05:11',1,2),(24059418,306164,'2008-05-01 17:53:35',1,1),(24059453,370566,'2008-05-09 02:14:33',1,3),(24059572,306164,'2008-05-01 18:03:49',1,1),(24059832,174860,'2008-12-06 16:03:50',1,3),(24059857,19873,'2008-06-02 18:48:24',1,5),(24059999,3100730,'2009-11-12 21:12:58',1,2),(24060059,2369688,'2009-09-04 17:16:28',1,4),(24060260,370566,'2008-05-09 02:22:37',1,5),(24060706,1816161,'2009-07-13 15:53:33',1,7),(24060781,553642,'2008-05-31 01:43:47',1,5),(24060840,1075389,'2009-05-04 18:52:11',1,17),(24240688,2369688,'2009-09-04 17:16:29',1,3),(24240699,352026,'2008-05-06 16:03:01',1,3),(24240709,352026,'2008-05-06 16:02:50',1,2),(24240780,844916,'2009-01-27 19:53:21',1,10),(24240808,844916,'2009-01-27 19:52:23',1,10),(24240825,370566,'2008-05-09 01:42:21',1,4),(24240826,844916,'2009-01-27 19:52:46',1,6),(24240835,844916,'2009-01-27 19:52:38',1,6),(24240868,844916,'2009-01-27 19:51:27',1,2),(24241040,2191053,'2009-08-18 19:10:28',1,9),(24241072,19873,'2008-06-02 18:31:20',1,6),(24241274,352026,'2008-05-06 16:49:21',1,1),(24241278,443527,'2008-05-14 12:04:03',1,2),(24241281,370566,'2008-05-09 01:38:47',1,2),(24241289,352026,'2008-05-06 16:50:08',1,1),(24241364,553642,'2008-05-31 01:43:30',1,12),(24279813,370566,'2008-05-09 01:38:47',1,1),(24279886,370566,'2008-05-09 01:42:20',1,1),(24279950,305941,'2009-02-09 21:22:14',1,4),(24280101,3132766,'2009-11-16 17:27:52',1,6),(24280274,553642,'2008-05-31 01:43:43',1,3),(24280275,553642,'2008-05-31 01:43:42',1,4),(24280276,553642,'2008-05-31 01:43:44',1,3),(24280277,553642,'2008-05-31 01:43:43',1,4),(24280278,3132766,'2009-11-16 17:27:59',1,3),(24280279,3132766,'2009-11-16 17:27:59',1,2),(24280280,531541,'2008-05-27 10:39:40',1,3),(24280281,531541,'2008-05-27 10:39:39',1,4),(24280282,3132766,'2009-11-16 17:27:59',1,3),(24280283,3132766,'2009-11-16 17:27:59',1,2),(24280284,3100730,'2009-11-12 21:12:42',1,2),(24280285,3100730,'2009-11-12 21:12:42',1,3),(24280286,3100730,'2009-11-12 21:12:43',1,3),(24280287,3100730,'2009-11-12 21:12:43',1,2),(24280288,531541,'2008-05-27 10:40:10',1,3),(24280289,531541,'2008-05-27 10:40:10',1,4),(24280290,531541,'2008-05-27 10:40:09',1,3),(24280291,441677,'2008-05-14 00:31:10',1,2),(24280292,56648,'2008-06-05 19:16:08',1,22),(24280293,3373175,'2009-12-14 18:51:01',1,4),(24280294,3373175,'2009-12-14 18:51:01',1,5),(24280295,531541,'2008-05-27 10:39:52',1,3),(24280296,531541,'2008-05-27 10:39:49',1,4),(24341039,412437,'2008-07-07 00:56:27',1,2),(24360470,443527,'2008-05-14 12:04:17',1,2),(24360537,443527,'2008-05-14 12:04:03',1,2),(24360617,437032,'2008-05-13 19:42:40',1,1),(24360845,437032,'2008-05-13 20:08:01',1,2),(24361232,437032,'2008-05-13 20:42:08',1,2),(24361241,437032,'2008-05-13 20:39:44',1,2),(24361307,461502,'2008-05-16 19:16:30',1,3),(24361318,3100730,'2009-11-12 21:12:51',1,4),(24361367,437032,'2008-05-13 20:32:39',1,2),(24361435,56648,'2008-06-05 19:30:45',1,4),(24361575,443527,'2008-05-14 12:04:11',1,3),(24361984,188228,'2008-06-16 18:36:11',1,10),(24362026,437032,'2008-05-13 21:22:13',1,3),(24362252,459604,'2008-05-16 20:57:19',1,5),(24362255,459604,'2008-05-16 20:57:19',1,3),(24362361,188228,'2008-06-16 18:36:12',1,6),(24362714,437032,'2008-05-13 21:50:35',1,2),(24362802,1276166,'2009-05-21 17:14:38',1,7),(24364447,2895121,'2009-10-19 19:15:15',1,9),(24364513,462438,'2008-07-11 13:10:22',1,9),(24364799,459604,'2008-05-16 20:57:20',1,3),(24367429,174860,'2008-12-06 15:53:58',1,2),(24374047,443527,'2008-05-14 12:03:48',1,1),(24374048,206510,'2008-12-06 19:38:24',1,6),(24374049,443527,'2008-05-14 12:03:49',1,1),(24374050,5025265,'2010-06-19 19:15:29',1,4),(24374051,1276166,'2009-05-21 17:03:39',1,4),(24374052,2191328,'2009-08-18 19:42:50',1,21),(24374054,433922,'2008-10-19 02:57:31',1,3),(24374055,433922,'2008-10-19 02:57:31',1,3),(24374056,433922,'2008-10-19 02:57:32',1,3),(24374057,5430086,'2010-08-08 10:43:43',1,5),(24374064,3132766,'2009-11-16 17:27:52',1,2),(24374065,3132766,'2009-11-16 17:27:52',1,2),(24376755,448710,'2008-05-14 17:02:22',1,2),(24376812,448710,'2008-05-14 17:02:52',1,2),(24377511,448710,'2008-05-14 18:16:46',1,1),(24377558,448710,'2008-05-14 18:24:01',1,1),(24377663,448710,'2008-05-14 18:40:23',1,1),(24377667,448710,'2008-05-14 18:41:02',1,1),(24405095,459604,'2008-05-16 20:57:21',1,3),(24405096,459604,'2008-05-16 20:57:21',1,4),(24405131,1276166,'2009-05-21 17:11:01',1,3),(24405159,1276166,'2009-05-21 17:11:27',1,10),(24405221,1276166,'2009-05-21 17:11:19',1,5),(24406052,1276166,'2009-05-21 17:11:41',1,2),(24406326,3956455,'2010-02-23 21:29:46',1,2),(24406327,423843,'2008-07-08 01:18:41',1,2),(24406328,459604,'2008-05-16 21:21:30',1,1),(24406329,862435,'2009-03-27 00:59:25',1,2),(24406331,2357182,'2009-09-03 12:37:32',1,2),(24406332,459604,'2008-05-16 21:21:32',1,1),(24406333,459604,'2008-05-16 21:21:32',1,1),(24406334,459604,'2008-05-16 21:21:32',1,1),(24406335,459604,'2008-05-16 21:21:33',1,1),(24406336,459604,'2008-05-16 21:21:33',1,1),(24413463,462689,'2008-05-17 12:19:49',1,2),(24413466,3916355,'2010-02-19 17:33:03',1,4),(24413467,188228,'2008-06-16 18:35:49',1,2),(24413469,3916355,'2010-02-19 17:33:06',1,2),(24413471,462689,'2008-05-17 12:20:13',1,3),(24430806,462438,'2008-07-11 13:09:45',1,7),(24430807,470312,'2008-05-18 12:17:17',1,1),(24456592,864892,'2009-03-28 17:17:00',1,9),(24492435,498434,'2008-05-22 17:18:57',1,3),(24492437,498434,'2008-05-22 17:19:26',1,2),(24492459,498434,'2008-05-22 17:19:08',1,4),(24492463,498434,'2008-05-22 17:19:50',1,2),(24492623,498434,'2008-05-22 17:37:33',1,3),(24492644,498434,'2008-05-22 17:38:53',1,2),(24492653,498434,'2008-05-22 17:36:59',1,3),(24492657,498434,'2008-05-22 17:38:39',1,2),(24492677,498434,'2008-05-22 17:38:53',1,1),(24492804,553642,'2008-05-31 01:43:48',1,6),(24492831,498434,'2008-05-22 18:00:45',1,1),(24492868,553642,'2008-05-31 01:43:44',1,5),(24492889,553642,'2008-05-31 01:43:44',1,3),(24492906,498434,'2008-05-22 18:10:41',1,2),(24492907,531541,'2008-05-27 10:39:52',1,4),(24493028,498434,'2008-05-22 19:29:26',1,3),(24493045,498434,'2008-05-22 18:25:06',1,1),(24493119,3132766,'2009-11-16 17:27:54',1,2),(24493121,2736717,'2009-10-04 17:29:51',1,7),(24493187,553642,'2008-05-31 01:43:36',1,4),(24493188,553642,'2008-05-31 01:43:35',1,6),(24493245,498434,'2008-05-22 19:43:19',1,6),(24493247,498434,'2008-05-22 18:50:44',1,3),(24493250,498434,'2008-05-22 18:50:53',1,2),(24493261,498434,'2008-05-22 18:51:57',1,1),(24493330,502306,'2008-05-23 10:54:10',1,2),(24493335,498434,'2008-05-22 19:09:02',1,4),(24493338,498434,'2008-05-22 19:02:39',1,2),(24493362,498434,'2008-05-22 19:03:35',1,1),(24493378,498434,'2008-05-22 19:04:03',1,1),(24493431,498434,'2008-05-22 19:07:44',1,1),(24493439,498434,'2008-05-22 19:09:02',1,1),(24493444,498434,'2008-05-22 19:09:45',1,1),(24493526,615859,'2008-07-28 13:58:22',1,5),(24493528,787878,'2009-01-15 00:13:53',1,6),(24493570,498434,'2008-05-22 19:22:39',1,2),(24493584,498434,'2008-05-22 19:21:47',1,2),(24493641,498434,'2008-05-22 19:24:02',1,1),(24493647,498434,'2008-05-22 19:24:40',1,1),(24493659,498434,'2008-05-22 19:25:06',1,1),(24493664,498434,'2008-05-22 19:30:08',1,2),(24493679,498434,'2008-05-22 19:28:13',1,1),(24493789,498434,'2008-05-22 19:41:16',1,2),(24493890,498434,'2008-05-22 19:46:28',1,2),(24493895,498434,'2008-05-22 19:41:45',1,3),(24493896,498434,'2008-05-22 19:41:22',1,1),(24493927,2836771,'2009-10-13 18:41:42',1,3),(24493967,2836771,'2009-10-13 18:46:13',1,4),(24494051,2369688,'2009-09-04 17:16:30',1,3),(24494073,498434,'2008-05-22 19:57:05',1,1),(24494162,2369688,'2009-09-04 17:16:30',1,3),(24494164,498434,'2008-05-22 20:01:08',1,1),(24497076,501202,'2008-05-22 22:31:58',1,1),(24497077,501202,'2008-05-22 22:32:38',1,2),(24512879,508355,'2008-05-24 02:27:42',1,1),(24517626,513066,'2008-05-24 16:04:48',1,2),(24517633,513066,'2008-05-24 15:59:44',1,2),(24517644,513066,'2008-05-24 16:06:38',1,2),(24517841,513066,'2008-05-24 16:12:30',1,1),(24517875,725665,'2009-03-02 22:31:54',1,6),(24517889,513066,'2008-05-24 16:17:44',1,1),(24517907,513066,'2008-05-24 16:19:47',1,1),(24518086,513066,'2008-05-24 16:36:12',1,3),(24518088,513066,'2008-05-24 16:35:58',1,3),(24518115,513066,'2008-05-24 16:36:22',1,4),(24518124,513066,'2008-05-24 16:36:37',1,2),(24663518,19873,'2008-06-02 18:31:12',1,1),(24663520,19873,'2008-06-02 18:32:27',1,2),(24663786,787878,'2009-01-15 00:29:04',1,2),(24663894,3132766,'2009-11-16 17:27:52',1,3),(24664831,21109,'2008-06-02 23:10:19',1,3),(24664867,25362,'2008-06-03 01:06:15',1,7),(24664880,21109,'2008-06-02 23:10:32',1,3),(24665224,21109,'2008-06-02 23:23:02',1,2),(24665257,21109,'2008-06-02 23:21:47',1,1),(24665737,33354,'2008-06-03 03:20:23',1,8),(24665785,21109,'2008-06-02 23:35:16',1,1),(24665811,21109,'2008-06-02 23:36:16',1,1),(24666049,21109,'2008-06-02 23:43:12',1,1),(24666099,21109,'2008-06-02 23:44:43',1,1),(24666136,21109,'2008-06-02 23:46:16',1,2),(24666186,21109,'2008-06-02 23:48:21',1,1),(24668180,25362,'2008-06-03 01:00:46',1,4),(24668181,25362,'2008-06-03 01:00:56',1,3),(24668187,25362,'2008-06-03 01:00:39',1,2),(24668361,25362,'2008-06-03 01:03:49',1,4),(24668372,25362,'2008-06-03 01:04:19',1,2),(24668373,25362,'2008-06-03 01:03:32',1,2),(24668885,2369619,'2009-09-04 17:10:07',1,6),(24668954,25362,'2008-06-03 01:42:20',1,2),(24669163,25362,'2008-06-03 01:42:44',1,3),(24669245,25362,'2008-06-03 01:33:07',1,1),(24669247,2369737,'2009-09-04 17:22:14',1,3),(24669248,25362,'2008-06-03 01:33:26',1,2),(24669306,25362,'2008-06-03 01:36:54',1,1),(24669321,2369737,'2009-09-04 17:22:19',1,2),(24669352,675187,'2008-12-30 16:02:49',1,2),(24669376,25362,'2008-06-03 01:42:02',1,1),(24669430,25362,'2008-06-03 01:42:43',1,1),(24669444,2369688,'2009-09-04 17:16:29',1,3),(24713155,56648,'2008-06-05 18:44:20',1,4),(24713182,2213421,'2009-08-20 19:12:28',1,5),(24713189,56648,'2008-06-05 18:49:46',1,3),(24713210,2191249,'2009-08-18 19:26:22',1,3),(24713222,2191215,'2009-08-18 19:23:39',1,3),(24713246,2191215,'2009-08-18 19:24:01',1,3),(24713303,56648,'2008-06-05 18:48:46',1,1),(24713305,56648,'2008-06-05 18:49:17',1,2),(24713352,2213421,'2009-08-20 19:09:03',1,5),(24713362,2191328,'2009-08-18 19:35:54',1,3),(24713447,2191328,'2009-08-18 19:38:01',1,3),(24713483,56648,'2008-06-05 19:01:56',1,1),(24713502,56648,'2008-06-05 19:03:54',1,1),(24713566,56648,'2008-06-05 19:09:23',1,2),(24713578,56648,'2008-06-05 19:10:29',1,3),(24713611,56648,'2008-06-05 19:10:24',1,1),(24713692,56648,'2008-06-05 19:14:47',1,1),(24713704,56648,'2008-06-05 19:15:46',1,1),(24713904,56648,'2008-06-05 20:23:16',1,3),(24713918,592895,'2008-07-26 00:00:32',1,9),(24713936,56648,'2008-06-05 19:30:31',1,2),(24714294,56648,'2008-06-05 19:58:43',1,3),(24714736,56648,'2008-06-05 20:11:57',1,4),(24714743,592895,'2008-07-25 23:43:01',1,10),(24714892,3100730,'2009-11-12 21:12:51',1,2),(24715008,56648,'2008-06-05 20:26:06',1,2),(24715064,56648,'2008-06-05 20:30:42',1,3),(24715082,3916355,'2010-02-19 17:31:55',1,6),(24715152,840745,'2009-01-26 20:00:24',1,5),(24715185,3916355,'2010-02-19 17:34:27',1,3),(24715324,56648,'2008-06-05 20:39:31',1,1),(24913724,188228,'2008-06-16 18:00:09',1,2),(24913802,188228,'2008-06-16 17:58:16',1,1),(24913861,188228,'2008-06-16 18:02:15',1,1),(24914526,495907,'2008-07-15 17:31:50',1,3),(24914534,495907,'2008-07-15 17:30:04',1,7),(24914563,188228,'2008-06-16 19:09:56',1,5),(24914660,495907,'2008-07-15 17:27:52',1,4),(24914768,3100730,'2009-11-12 21:12:55',1,2),(24914779,188228,'2008-06-16 18:55:07',1,2),(24914843,3916355,'2010-02-19 17:34:18',1,6),(24914870,495907,'2008-07-15 17:30:21',1,5),(24914903,3916355,'2010-02-19 17:34:20',1,6),(24914989,840745,'2009-01-26 20:10:50',1,5),(24915114,3100730,'2009-11-12 21:12:54',1,2),(24915502,188228,'2008-06-16 19:42:28',1,2),(24915504,188228,'2008-06-16 19:42:36',1,3),(24915554,188228,'2008-06-16 20:04:59',1,5),(24915566,188228,'2008-06-16 20:05:18',1,5),(24915617,188228,'2008-06-16 20:06:21',1,4),(24915624,188228,'2008-06-16 19:57:51',1,3),(24915706,188228,'2008-06-16 20:00:07',1,2),(24915763,188228,'2008-06-16 20:02:58',1,1),(24915772,188228,'2008-06-16 20:03:40',1,2),(24915834,188228,'2008-06-16 20:05:47',1,1),(25014753,978767,'2009-04-26 22:35:02',1,4),(25014777,258909,'2008-06-22 19:28:24',1,1),(25415705,2318266,'2009-08-30 23:11:18',1,6),(25416126,1075389,'2009-05-04 18:49:38',1,3),(25416128,206510,'2008-12-06 19:49:43',1,2),(25416227,2369619,'2009-09-04 17:10:08',1,4),(25416308,2369619,'2009-09-04 17:10:07',1,3),(25416371,423843,'2008-07-08 00:20:44',1,3),(25453236,440632,'2008-07-09 16:36:29',1,2),(25453308,440632,'2008-07-09 16:37:16',1,3),(25453310,440632,'2008-07-09 16:36:32',1,1),(25454372,441038,'2008-07-09 18:16:13',1,2),(25454378,844916,'2009-01-27 20:20:59',1,4),(25454381,441038,'2008-07-09 18:18:23',1,2),(25484821,305941,'2009-02-09 21:18:56',1,2),(25484883,495907,'2008-07-15 17:34:41',1,4),(25484912,3916355,'2010-02-19 17:33:27',1,6),(25485099,462438,'2008-07-11 13:31:19',1,5),(25485119,462438,'2008-07-11 13:28:00',1,1),(25485130,592895,'2008-07-25 21:12:34',1,4),(25485131,462438,'2008-07-11 13:29:03',1,2),(25569661,3100730,'2009-11-12 21:12:54',1,3),(25569665,495907,'2008-07-15 17:37:17',1,2),(25569745,2369688,'2009-09-04 17:16:29',1,4),(25569748,495907,'2008-07-15 17:42:48',1,1),(25569755,305941,'2009-02-09 21:21:42',1,2),(25569775,2369688,'2009-09-04 17:16:30',1,3),(25572114,495907,'2008-07-15 20:01:27',1,2),(25572121,495907,'2008-07-15 20:02:55',1,2),(25572130,495907,'2008-07-15 20:02:02',1,3),(25572131,495907,'2008-07-15 20:01:31',1,1),(25572572,495907,'2008-07-15 20:16:37',1,1),(25572731,495907,'2008-07-15 20:24:53',1,4),(25572741,495907,'2008-07-15 20:20:20',1,1),(25572746,495907,'2008-07-15 20:22:38',1,3),(25572749,495907,'2008-07-15 20:22:15',1,2),(25572883,495907,'2008-07-15 20:24:16',1,1),(25573596,495907,'2008-07-15 21:10:05',1,2),(25767814,592895,'2008-07-25 21:11:42',1,4),(25767827,592895,'2008-07-25 21:17:55',1,2),(25767891,592895,'2008-07-25 21:21:32',1,1),(25768003,592895,'2008-07-25 23:31:50',1,12),(25768018,592895,'2008-07-25 23:32:42',1,12),(25768677,592895,'2008-07-25 23:41:05',1,4),(25768681,592895,'2008-07-25 23:27:21',1,6),(25768760,2736717,'2009-10-04 17:29:50',1,3),(25768838,592895,'2008-07-25 22:27:53',1,3),(25768852,592895,'2008-07-25 23:29:46',1,6),(25768868,592895,'2008-07-25 23:30:03',1,5),(25769024,592895,'2008-07-25 23:28:18',1,5),(25769049,592895,'2008-07-25 22:29:13',1,3),(25769050,592895,'2008-07-25 22:27:57',1,1),(25769069,305941,'2009-02-09 21:30:44',1,4),(25769071,592895,'2008-07-25 23:31:04',1,4),(25769112,305941,'2009-02-09 21:29:38',1,6),(25769116,305941,'2009-02-09 21:29:11',1,3),(25769122,592895,'2008-07-25 23:28:00',1,3),(25769124,305941,'2009-02-09 21:30:35',1,3),(25769182,592895,'2008-07-25 22:39:03',1,3),(25769229,2736717,'2009-10-04 17:29:51',1,3),(25769702,3916355,'2010-02-19 17:32:02',1,3),(25769709,592895,'2008-07-25 23:03:33',1,2),(25769726,592895,'2008-07-25 23:40:36',1,2),(25769803,592895,'2008-07-25 23:20:15',1,6),(25769822,592895,'2008-07-25 23:11:46',1,1),(25769829,592895,'2008-07-25 23:20:09',1,3),(25769891,592895,'2008-07-25 23:16:12',1,1),(25769893,592895,'2008-07-25 23:18:32',1,3),(25769922,592895,'2008-07-25 23:19:17',1,2),(25769970,592895,'2008-07-25 23:25:50',1,4),(25769974,592895,'2008-07-25 23:39:24',1,2),(25770088,592895,'2008-07-25 23:26:06',1,2),(25770391,592895,'2008-07-25 23:40:36',1,1),(25770445,592895,'2008-07-25 23:48:10',1,2),(25770728,592895,'2008-07-25 23:57:57',1,1),(25770737,592895,'2008-07-25 23:58:43',1,1),(25770744,592895,'2008-07-25 23:58:57',1,1),(25770745,592895,'2008-07-26 00:01:23',1,2),(25771015,592895,'2008-07-26 00:12:01',1,1),(25771079,592895,'2008-07-26 00:15:23',1,1),(25771241,592895,'2008-07-26 00:33:05',1,4),(25825533,615859,'2008-07-28 13:58:35',1,1),(26001987,72964,'2008-08-05 20:21:08',1,2),(26002036,72964,'2008-08-05 20:37:36',1,2),(26243488,1276166,'2009-05-21 17:09:17',1,5),(26243580,3933161,'2010-02-21 15:14:37',1,4),(26243608,226881,'2009-04-05 17:13:03',1,3),(26243681,210114,'2008-08-12 23:46:32',1,1),(26243895,210114,'2008-08-12 23:52:59',1,1),(26455183,353783,'2008-08-21 18:34:10',1,2),(26553947,565034,'2008-09-07 20:42:42',1,3),(26554007,404186,'2008-08-26 00:23:21',1,1),(26668563,206510,'2008-12-06 20:09:53',1,4),(27826413,3916410,'2010-02-19 17:39:35',1,2),(28828385,174860,'2008-12-06 15:58:00',1,1),(28828388,174860,'2008-12-06 16:20:04',1,2),(28828789,174860,'2008-12-06 16:19:26',1,1),(28829736,174860,'2008-12-06 17:05:28',1,1),(28829748,437534,'2008-12-17 19:04:10',1,6),(28829753,437534,'2008-12-17 18:58:15',1,5),(28829766,437534,'2008-12-17 19:00:45',1,7),(28829773,174860,'2008-12-06 17:07:28',1,2),(28829779,174860,'2008-12-06 17:07:15',1,1),(28829910,174860,'2008-12-06 17:15:19',1,1),(28829964,174860,'2008-12-06 17:17:23',1,1),(28829967,174860,'2008-12-06 17:18:43',1,3),(28832922,206510,'2008-12-06 19:28:04',1,1),(28832923,206510,'2008-12-06 19:28:52',1,2),(28833468,327248,'2009-04-08 23:42:55',1,4),(28833770,4963942,'2010-06-11 20:05:29',1,4),(28833880,5107412,'2010-06-29 20:14:47',1,4),(28833924,5107412,'2010-06-29 20:14:48',1,2),(28833927,5107412,'2010-06-29 20:14:44',1,3),(28833935,5107412,'2010-06-29 20:14:44',1,2),(28833936,5107412,'2010-06-29 20:14:39',1,3),(28833957,5107412,'2010-06-29 20:14:43',1,2),(28833958,5107412,'2010-06-29 20:14:42',1,3),(29051459,437534,'2008-12-17 19:01:56',1,6),(29249135,537461,'2009-04-14 23:04:12',1,2),(29249136,537461,'2009-04-14 23:03:39',1,2),(29249700,537461,'2009-04-14 23:03:33',1,3),(29376254,4099888,'2010-03-11 20:07:08',1,3),(29376356,4083396,'2010-03-09 20:59:22',1,4),(29376448,675187,'2008-12-30 16:00:59',1,1),(29422567,2688289,'2009-09-30 17:08:19',1,2),(30139079,787878,'2009-01-15 00:12:01',1,1),(30139093,787878,'2009-01-15 00:14:32',1,2),(30139242,787878,'2009-01-15 00:22:38',1,1),(30139403,787878,'2009-01-15 00:31:07',1,1),(30139408,787878,'2009-01-15 00:31:30',1,1),(30567238,840745,'2009-01-26 20:04:34',1,1),(30567542,104780,'2009-02-04 00:33:41',1,2),(30571624,840745,'2009-01-26 21:16:49',1,2),(30572100,840745,'2009-01-26 21:17:35',1,1),(30572104,840745,'2009-01-26 21:18:10',1,2),(30572116,844916,'2009-01-27 20:17:20',1,2),(30572138,840745,'2009-01-26 21:18:20',1,1),(30572145,844916,'2009-01-27 20:17:54',1,2),(30572187,840745,'2009-01-26 21:18:53',1,1),(30605340,104780,'2009-02-04 00:28:27',1,3),(30605380,844916,'2009-01-27 19:52:15',1,2),(30605457,844916,'2009-01-27 19:58:51',1,2),(30605650,844916,'2009-01-27 20:05:23',1,1),(30605670,844916,'2009-01-27 20:08:49',1,3),(30605680,844916,'2009-01-27 20:11:15',1,2),(30605683,844916,'2009-01-27 20:10:20',1,2),(30605686,844916,'2009-01-27 20:10:15',1,1),(30605697,844916,'2009-01-27 20:11:39',1,1),(30605698,844916,'2009-01-27 20:11:54',1,1),(30605769,844916,'2009-01-27 20:16:08',1,1),(30772650,104780,'2009-02-04 00:39:24',1,1),(30772702,104780,'2009-02-04 00:41:34',1,1),(30922493,305941,'2009-02-09 21:19:42',1,2),(30922528,305941,'2009-02-09 21:20:30',1,1),(31348544,27626,'2009-04-01 15:32:42',1,5),(31348633,3916410,'2010-02-19 17:39:32',1,2),(31726348,725665,'2009-03-02 22:21:27',1,4),(31726372,1684788,'2009-06-30 11:19:40',1,3),(31726416,725665,'2009-03-02 22:21:19',1,3),(31726467,725665,'2009-03-02 22:21:42',1,2),(31726482,725665,'2009-03-02 22:21:34',1,2),(31726492,725665,'2009-03-02 22:22:38',1,3),(31726507,725665,'2009-03-02 22:22:10',1,2),(31726661,725665,'2009-03-02 22:29:57',1,6),(31726701,725665,'2009-03-02 22:27:42',1,5),(31726779,2736717,'2009-10-04 17:29:50',1,10),(31726812,725665,'2009-03-02 22:34:24',1,2),(31726851,725665,'2009-03-02 22:33:51',1,3),(31726898,725665,'2009-03-02 22:33:31',1,2),(32211744,820251,'2009-03-16 23:50:06',1,2),(32549432,864892,'2009-03-28 14:33:32',1,2),(32549444,862435,'2009-03-27 00:59:14',1,2),(32551123,863220,'2009-03-27 04:33:46',1,1),(32551125,3916410,'2010-02-19 17:39:35',1,3),(32594779,2369737,'2009-09-04 17:22:15',1,2),(32594984,2369737,'2009-09-04 17:22:14',1,2),(32594985,864892,'2009-03-28 14:44:37',1,1),(32598297,327248,'2009-04-08 23:29:12',1,4),(32598300,864892,'2009-03-28 17:17:44',1,3),(32598313,864892,'2009-03-28 17:18:57',1,3),(32598338,864892,'2009-03-28 17:18:39',1,2),(32598345,864892,'2009-03-28 17:18:39',1,1),(32676714,3283462,'2009-12-03 21:54:55',1,6),(32676739,2369619,'2009-09-04 17:10:10',1,4),(32676743,537461,'2009-04-14 23:04:01',1,2),(32676746,870814,'2009-03-31 00:58:28',1,1),(32676749,537461,'2009-04-14 23:03:57',1,2),(32676753,4099383,'2010-03-11 19:09:03',1,3),(32676755,537461,'2009-04-14 23:03:48',1,2),(32722266,181856,'2009-04-04 22:08:21',1,4),(32722447,27626,'2009-04-01 15:29:35',1,2),(32722515,27626,'2009-04-01 15:33:10',1,2),(32722544,27626,'2009-04-01 15:35:06',1,1),(32722657,27626,'2009-04-01 15:43:48',1,1),(32722658,27626,'2009-04-01 15:48:56',1,3),(32722762,372139,'2009-04-10 12:07:13',1,4),(32722815,27626,'2009-04-01 16:02:41',1,3),(32819051,181856,'2009-04-04 22:09:21',1,2),(32819142,181856,'2009-04-04 22:25:06',1,4),(32845037,327248,'2009-04-08 23:30:37',1,3),(32845056,226881,'2009-04-05 17:11:58',1,3),(32845063,226881,'2009-04-05 17:09:50',1,1),(32936885,327248,'2009-04-08 23:14:41',1,2),(32936960,327248,'2009-04-08 23:16:01',1,1),(32937000,327248,'2009-04-08 23:18:02',1,1),(32937225,327248,'2009-04-08 23:29:59',1,3),(32937397,327248,'2009-04-08 23:30:41',1,1),(32937466,327248,'2009-04-08 23:32:52',1,1),(32973912,372139,'2009-04-10 12:07:13',1,2),(33184240,537461,'2009-04-14 23:02:59',1,1),(33184244,537461,'2009-04-14 23:03:02',1,1),(33184247,537461,'2009-04-14 23:03:05',1,1),(33184252,537461,'2009-04-14 23:03:11',1,1),(33184266,537461,'2009-04-14 23:03:26',1,1),(33184270,537461,'2009-04-14 23:03:30',1,1),(33713550,978767,'2009-04-26 22:43:21',1,2),(33721575,981792,'2009-04-27 01:28:18',1,1),(33733175,986514,'2009-04-27 12:35:32',1,2),(34062547,1074615,'2009-05-04 17:28:49',1,5),(34062881,1074615,'2009-05-04 17:26:21',1,4),(34063687,1074615,'2009-05-04 17:29:53',1,1),(34063704,1074615,'2009-05-04 17:30:48',1,1),(34063735,1074615,'2009-05-04 17:33:11',1,2),(34063769,1074615,'2009-05-04 17:35:08',1,3),(34063770,1074615,'2009-05-04 17:34:23',1,1),(34064472,1075282,'2009-05-04 18:32:18',1,2),(34064813,1075282,'2009-05-04 18:32:26',1,2),(34064907,1075235,'2009-05-04 18:23:51',1,1),(34065105,1075282,'2009-05-04 18:32:04',1,1),(34065671,1075389,'2009-05-04 18:51:49',1,2),(34065735,2369619,'2009-09-04 17:10:08',1,3),(34387676,1165666,'2009-05-12 19:50:14',1,1),(34387821,1166143,'2009-05-12 20:31:29',1,2),(34388549,1166143,'2009-05-12 20:30:50',1,3),(34389528,1166268,'2009-05-12 20:58:51',1,1),(34390093,1166650,'2009-05-12 21:14:35',1,1),(34390103,1166792,'2009-05-12 21:24:24',1,3),(34390499,1166792,'2009-05-12 21:23:22',1,1),(34390581,1166792,'2009-05-12 21:24:15',1,1),(34390594,1166792,'2009-05-12 21:26:00',1,2),(34876322,1276166,'2009-05-21 17:06:39',1,3),(34876405,1276166,'2009-05-21 17:07:30',1,1),(35444733,1423654,'2009-06-04 22:58:39',1,1),(37633206,1816099,'2009-07-13 15:48:59',1,1),(37633275,1816161,'2009-07-13 15:54:18',1,1),(37633404,1816208,'2009-07-13 16:02:06',1,1),(37756343,2369619,'2009-09-04 17:10:10',1,2),(37756386,1851615,'2009-07-17 11:55:48',1,1),(37865954,1882243,'2009-07-20 12:44:23',1,2),(38706653,2190495,'2009-08-18 18:22:39',1,4),(38706925,2074369,'2009-08-08 14:56:31',1,1),(38706927,2074369,'2009-08-08 14:57:43',1,3),(38706928,2190826,'2009-08-18 19:02:45',1,7),(38706936,2074369,'2009-08-08 14:56:50',1,1),(39258136,2190594,'2009-08-18 18:34:38',1,3),(39258137,2190594,'2009-08-18 18:33:16',1,1),(39258144,2190594,'2009-08-18 18:33:20',1,1),(39258742,2369737,'2009-09-04 17:22:16',1,2),(39259019,2191053,'2009-08-18 19:10:26',1,1),(39259022,2191053,'2009-08-18 19:10:32',1,1),(39259088,2191112,'2009-08-18 19:16:02',1,2),(39259092,2191112,'2009-08-18 19:15:03',1,1),(39259147,2191112,'2009-08-18 19:17:21',1,1),(39259506,2191328,'2009-08-18 19:37:00',1,2),(39259666,2191328,'2009-08-18 19:39:29',1,1),(39259759,2213421,'2009-08-20 19:10:17',1,3),(39259769,2191328,'2009-08-18 19:42:42',1,1),(39259770,2191328,'2009-08-18 19:43:37',1,2),(40064501,2357182,'2009-09-03 12:35:53',1,1),(40064876,2357182,'2009-09-03 12:40:31',1,2),(40065172,2357182,'2009-09-03 12:41:47',1,1),(40065349,2357481,'2009-09-03 13:10:51',1,2),(40065810,2357481,'2009-09-03 13:05:05',1,1),(40065893,2357481,'2009-09-03 13:08:12',1,1),(40067891,2357704,'2009-09-03 13:39:08',1,3),(40137318,2369688,'2009-09-04 17:16:28',1,1),(40264409,2387382,'2009-09-06 10:39:45',1,1),(40264410,2387382,'2009-09-06 10:39:46',1,1),(41785125,2695454,'2009-10-01 05:43:21',1,1),(41935429,2730324,'2009-10-04 02:19:41',1,1),(42014211,4101446,'2010-03-11 22:58:46',1,2),(42021998,2747796,'2009-10-05 13:48:01',1,1),(42055725,2756081,'2009-10-06 02:46:59',1,1),(42055772,2756091,'2009-10-06 02:48:31',1,1),(42235196,2788592,'2009-10-09 02:31:38',1,1),(42235209,3956455,'2010-02-23 21:29:40',1,2),(42235226,2788608,'2009-10-09 02:33:39',1,1),(42235229,2788613,'2009-10-09 02:34:09',1,1),(42235235,2788617,'2009-10-09 02:34:39',1,1),(42235255,2788624,'2009-10-09 02:36:17',1,1),(42235256,2788624,'2009-10-09 02:36:20',1,1),(42252195,3956455,'2010-02-23 21:29:44',1,3),(42252243,2791237,'2009-10-09 12:39:56',1,1),(42252251,2791237,'2009-10-09 12:40:06',1,1),(42252272,2791248,'2009-10-09 12:40:54',1,1),(42252309,2791251,'2009-10-09 12:41:48',1,1),(42252326,2791253,'2009-10-09 12:42:14',1,1),(42252348,2791257,'2009-10-09 12:42:52',1,1),(42252384,2791267,'2009-10-09 12:44:08',1,1),(42451011,2836771,'2009-10-13 18:41:35',1,2),(42451016,2836771,'2009-10-13 18:42:17',1,2),(42451892,2895121,'2009-10-19 19:04:20',1,3),(42809904,2895121,'2009-10-19 19:08:15',1,2),(42810813,2895121,'2009-10-19 19:18:01',1,1),(42811127,2895121,'2009-10-19 19:21:14',1,2),(45511076,3283462,'2009-12-03 21:53:48',1,1),(45511084,3283462,'2009-12-03 21:54:05',1,1),(45511090,3283462,'2009-12-03 21:54:09',1,1),(48271354,4092807,'2010-03-10 21:54:57',1,2),(48271355,4083044,'2010-03-09 20:12:51',1,3),(48271356,4083024,'2010-03-09 20:10:06',1,2),(48928224,4107810,'2010-03-12 18:34:29',1,2),(48928225,4107810,'2010-03-12 18:34:29',1,4),(48928226,4107810,'2010-03-12 18:34:28',1,2),(48928227,3724172,'2010-01-27 00:45:33',1,1),(48928228,3724172,'2010-01-27 00:45:33',1,1),(48928229,3724172,'2010-01-27 00:45:33',1,1),(48928230,3724172,'2010-01-27 00:45:33',1,1),(48928231,3724172,'2010-01-27 00:45:33',1,1),(48928232,3724172,'2010-01-27 00:45:33',1,1),(48928233,4138831,'2010-03-15 23:33:40',1,4),(48928234,3831437,'2010-02-09 14:01:03',1,4),(48928235,4106774,'2010-03-12 16:31:19',1,2),(48928236,3831437,'2010-02-09 14:01:03',1,5),(48957244,3731738,'2010-01-27 23:25:26',1,2),(48957245,4106774,'2010-03-12 16:31:16',1,2),(48957246,3727238,'2010-01-27 14:00:46',1,1),(48957247,3727238,'2010-01-27 14:00:46',1,1),(48957248,3727238,'2010-01-27 14:00:46',1,1),(48957249,3727238,'2010-01-27 14:00:46',1,1),(48957250,3727238,'2010-01-27 14:00:46',1,1),(48957251,3727238,'2010-01-27 14:00:46',1,1),(48957252,3727238,'2010-01-27 14:00:47',1,1),(48957253,3727238,'2010-01-27 14:00:47',1,1),(48957254,3727238,'2010-01-27 14:00:47',1,1),(48957255,3727238,'2010-01-27 14:00:47',1,1),(48957256,3727238,'2010-01-27 14:00:47',1,1),(48957257,3727238,'2010-01-27 14:00:47',1,1),(48957258,3831437,'2010-02-09 14:01:03',1,4),(48969498,4108069,'2010-03-12 19:04:16',1,3),(48969499,4106774,'2010-03-12 16:31:18',1,2),(48979047,4107810,'2010-03-12 18:34:29',1,2),(48979050,4106774,'2010-03-12 16:31:17',1,3),(48979051,4106774,'2010-03-12 16:31:16',1,2),(48979052,4106774,'2010-03-12 16:31:16',1,2),(48979055,3731738,'2010-01-27 23:25:24',1,1),(48979056,4107810,'2010-03-12 18:34:28',1,3),(48979057,4106774,'2010-03-12 16:31:18',1,2),(48979058,4106774,'2010-03-12 16:31:18',1,2),(48979059,4107810,'2010-03-12 18:34:30',1,3),(48979060,3731738,'2010-01-27 23:25:25',1,1),(48979062,4138831,'2010-03-15 23:33:39',1,6),(48979063,3731738,'2010-01-27 23:25:25',1,1),(50568365,3956455,'2010-02-23 21:29:42',1,2),(50568366,3903073,'2010-02-17 20:32:43',1,1),(50734991,3916410,'2010-02-19 17:39:37',1,1),(52008425,4098931,'2010-03-11 18:10:57',1,2),(52008767,4076872,'2010-03-09 00:33:55',1,1),(52009081,4076934,'2010-03-09 00:40:43',1,1),(52009565,4077060,'2010-03-09 00:55:20',1,1),(52010630,4077213,'2010-03-09 01:15:07',1,1),(52010729,4077244,'2010-03-09 01:19:16',1,1),(52010876,4077310,'2010-03-09 01:28:44',1,1),(52035289,4082908,'2010-03-09 19:56:15',1,1),(52036011,4083737,'2010-03-09 21:36:34',1,2),(52038527,4083476,'2010-03-09 21:09:02',1,1),(52038627,4101592,'2010-03-11 23:12:19',1,2),(52083535,4092743,'2010-03-10 21:47:17',1,1),(52083655,4092770,'2010-03-10 21:50:21',1,1),(52084359,4161868,'2010-03-18 16:48:01',1,2),(52098923,4096040,'2010-03-11 10:54:37',1,1),(52099062,4096095,'2010-03-11 11:05:32',1,1),(52099251,4161868,'2010-03-18 16:48:02',1,2),(52099335,4096186,'2010-03-11 11:22:32',1,1),(52099379,4138831,'2010-03-15 23:33:39',1,2),(52099485,4161868,'2010-03-18 16:48:02',1,2),(52110420,4108069,'2010-03-12 19:04:18',1,2),(52110421,4108069,'2010-03-12 19:04:18',1,3),(52112644,4099383,'2010-03-11 19:09:05',1,2),(52112645,4099383,'2010-03-11 19:09:05',1,2),(52112646,4099383,'2010-03-11 19:09:05',1,2),(52112647,4098931,'2010-03-11 18:10:56',1,1),(52112648,4138831,'2010-03-15 23:33:39',1,2),(52112649,4098931,'2010-03-11 18:10:56',1,1),(52112650,4098931,'2010-03-11 18:10:57',1,1),(52112651,4098931,'2010-03-11 18:10:57',1,1),(52112652,4098931,'2010-03-11 18:10:57',1,1),(52114934,4099383,'2010-03-11 19:09:00',1,1),(52114935,4099383,'2010-03-11 19:09:00',1,1),(52114936,4099383,'2010-03-11 19:09:00',1,1),(52114937,4099383,'2010-03-11 19:09:01',1,1),(52114938,4099383,'2010-03-11 19:09:01',1,1),(52114939,4099383,'2010-03-11 19:09:01',1,1),(52114940,4099383,'2010-03-11 19:09:01',1,1),(52114942,4099383,'2010-03-11 19:09:01',1,1),(52114943,4099383,'2010-03-11 19:09:01',1,1),(52114944,4099383,'2010-03-11 19:09:01',1,1),(52114946,4099383,'2010-03-11 19:09:02',1,1),(52114947,4099383,'2010-03-11 19:09:02',1,1),(52114948,4099383,'2010-03-11 19:09:02',1,1),(52114949,4099383,'2010-03-11 19:09:02',1,1),(52114950,4099383,'2010-03-11 19:09:02',1,1),(52114951,4099383,'2010-03-11 19:09:02',1,1),(52114952,4100909,'2010-03-11 22:03:01',1,2),(52121995,4100978,'2010-03-11 22:09:38',1,1),(52122469,4101078,'2010-03-11 22:19:38',1,1),(52123370,4101245,'2010-03-11 22:37:04',1,1),(52123917,4101313,'2010-03-11 22:45:12',1,1),(52163682,4106774,'2010-03-12 16:31:06',1,1),(52163683,4106774,'2010-03-12 16:31:06',1,1),(52163684,4106774,'2010-03-12 16:31:06',1,1),(52163691,4106774,'2010-03-12 16:31:07',1,1),(52163693,4106774,'2010-03-12 16:31:07',1,1),(52163695,4107810,'2010-03-12 18:34:28',1,2),(52163698,4106774,'2010-03-12 16:31:08',1,1),(52163700,4106774,'2010-03-12 16:31:08',1,1),(52163704,4106774,'2010-03-12 16:31:08',1,1),(52163705,4106774,'2010-03-12 16:31:08',1,1),(52163710,4106774,'2010-03-12 16:31:09',1,1),(52163712,4106774,'2010-03-12 16:31:09',1,1),(52163714,4106774,'2010-03-12 16:31:09',1,1),(52163716,4106774,'2010-03-12 16:31:09',1,1),(52163719,4106774,'2010-03-12 16:31:09',1,1),(52163722,4106774,'2010-03-12 16:31:09',1,1),(52163729,4106774,'2010-03-12 16:31:10',1,1),(52163731,4106774,'2010-03-12 16:31:10',1,1),(52163733,4106774,'2010-03-12 16:31:11',1,1),(52163736,4106774,'2010-03-12 16:31:11',1,1),(52163738,4106774,'2010-03-12 16:31:11',1,1),(52163739,4106774,'2010-03-12 16:31:11',1,1),(52163740,4106774,'2010-03-12 16:31:11',1,1),(52163743,4106774,'2010-03-12 16:31:11',1,1),(52163745,4106774,'2010-03-12 16:31:11',1,1),(52163746,4106774,'2010-03-12 16:31:11',1,1),(52163748,4106774,'2010-03-12 16:31:11',1,1),(52163750,4106774,'2010-03-12 16:31:11',1,1),(52163751,4106774,'2010-03-12 16:31:12',1,1),(52163753,4106774,'2010-03-12 16:31:12',1,1),(52163754,4106774,'2010-03-12 16:31:12',1,1),(52171935,4107810,'2010-03-12 18:34:23',1,1),(52171936,4107810,'2010-03-12 18:34:23',1,1),(52171937,4107810,'2010-03-12 18:34:24',1,1),(52171938,4107810,'2010-03-12 18:34:24',1,1),(52171939,4107810,'2010-03-12 18:34:24',1,1),(52171940,4107810,'2010-03-12 18:34:25',1,1),(52171941,4108069,'2010-03-12 19:04:19',1,2),(52171942,4107810,'2010-03-12 18:34:25',1,1),(52171943,4107810,'2010-03-12 18:34:25',1,1),(52171944,4107810,'2010-03-12 18:34:25',1,1),(52171945,4107810,'2010-03-12 18:34:25',1,1),(52171946,4107810,'2010-03-12 18:34:26',1,1),(52171947,4107810,'2010-03-12 18:34:26',1,1),(52172905,4108069,'2010-03-12 19:04:08',1,1),(52172907,4108069,'2010-03-12 19:04:10',1,1),(52172909,4108069,'2010-03-12 19:04:10',1,1),(52172911,4108069,'2010-03-12 19:04:11',1,1),(52172913,4108069,'2010-03-12 19:04:11',1,1),(52172914,4108069,'2010-03-12 19:04:12',1,1),(52172915,4108069,'2010-03-12 19:04:12',1,1),(52172916,4108069,'2010-03-12 19:04:12',1,1),(52172918,4108069,'2010-03-12 19:04:12',1,1),(52172919,4108069,'2010-03-12 19:04:13',1,1),(52172920,4108069,'2010-03-12 19:04:13',1,1),(52172921,4108069,'2010-03-12 19:04:13',1,1),(52174944,4108991,'2010-03-12 22:26:22',1,1),(52174946,4108991,'2010-03-12 22:26:22',1,1),(52174948,4108991,'2010-03-12 22:26:22',1,1),(52174950,4108991,'2010-03-12 22:26:22',1,1),(52174952,4108991,'2010-03-12 22:26:22',1,1),(52174953,4108991,'2010-03-12 22:26:22',1,1),(52174956,4108991,'2010-03-12 22:26:23',1,1),(52174958,4108991,'2010-03-12 22:26:23',1,1),(52174959,4108991,'2010-03-12 22:26:23',1,1),(52174960,4108991,'2010-03-12 22:26:23',1,1),(52174962,4108991,'2010-03-12 22:26:23',1,1),(52174963,4108991,'2010-03-12 22:26:23',1,1),(52268017,4138831,'2010-03-15 23:33:39',1,2),(52692955,4161539,'2010-03-18 16:04:21',1,1),(52692956,4161539,'2010-03-18 16:04:21',1,1),(52692957,4161911,'2010-03-18 16:53:24',1,2),(52692958,4161539,'2010-03-18 16:04:22',1,1),(52692959,4161539,'2010-03-18 16:04:22',1,1),(52692960,4161539,'2010-03-18 16:04:22',1,1),(52692961,4161539,'2010-03-18 16:04:22',1,1),(52692962,4161539,'2010-03-18 16:04:22',1,1),(52692963,4161539,'2010-03-18 16:04:22',1,1),(52692964,4161539,'2010-03-18 16:04:22',1,1),(52692965,4161539,'2010-03-18 16:04:22',1,1),(52692966,4161539,'2010-03-18 16:04:22',1,1),(52692967,4161539,'2010-03-18 16:04:23',1,1),(52692968,4161539,'2010-03-18 16:04:23',1,1),(52692969,4161539,'2010-03-18 16:04:23',1,1),(52692970,4161539,'2010-03-18 16:04:23',1,1),(52692971,4161539,'2010-03-18 16:04:23',1,1),(52697930,4161868,'2010-03-18 16:47:53',1,1),(52697931,4161868,'2010-03-18 16:47:54',1,1),(52697932,4161868,'2010-03-18 16:47:54',1,1),(52697934,4161868,'2010-03-18 16:47:55',1,1),(52697935,4161868,'2010-03-18 16:47:55',1,1),(52697936,4161868,'2010-03-18 16:47:56',1,1),(52697937,4161868,'2010-03-18 16:47:56',1,1),(52697938,4161868,'2010-03-18 16:47:56',1,1),(52697939,4161868,'2010-03-18 16:47:56',1,1),(52697940,4161868,'2010-03-18 16:47:57',1,1),(52697941,4161868,'2010-03-18 16:47:57',1,1),(52697942,4161868,'2010-03-18 16:47:57',1,1),(52697943,4161868,'2010-03-18 16:47:57',1,1),(52697944,4161868,'2010-03-18 16:47:58',1,1),(52697945,4161868,'2010-03-18 16:47:58',1,1),(52697946,4161868,'2010-03-18 16:47:58',1,1),(52697947,4161868,'2010-03-18 16:47:58',1,1),(52697948,4161868,'2010-03-18 16:47:58',1,1),(52697949,4161868,'2010-03-18 16:47:59',1,1),(52697950,4161868,'2010-03-18 16:47:59',1,1),(52697951,4161868,'2010-03-18 16:47:59',1,1),(52697952,4161868,'2010-03-18 16:48:00',1,1),(54858984,4375683,'2010-04-09 21:07:11',1,1),(61736197,5107412,'2010-06-29 20:14:45',1,2),(61736199,5107412,'2010-06-29 20:14:45',1,2),(61736200,5107412,'2010-06-29 20:14:41',1,2),(61736202,5107412,'2010-06-29 20:14:42',1,2),(61736203,5107412,'2010-06-29 20:14:42',1,2),(61736208,5430086,'2010-08-08 10:43:44',1,3),(61736209,5107412,'2010-06-29 20:14:40',1,2),(70427100,5363414,'2010-07-31 18:33:05',1,2),(70427114,5363414,'2010-07-31 18:41:19',1,2),(70427179,5363414,'2010-07-31 18:45:28',1,4),(70428387,5363414,'2010-07-31 18:38:08',1,1),(75744715,5671401,'2010-09-03 18:05:58',1,2),(75746393,5671401,'2010-09-03 18:05:50',1,1),(75746394,5671401,'2010-09-03 18:05:50',1,1),(75746395,5678739,'2010-09-04 16:07:27',1,2),(75746396,5671401,'2010-09-03 18:05:51',1,1),(75746397,5866046,'2010-09-24 23:01:57',1,2),(75746398,5671401,'2010-09-03 18:05:51',1,1),(75746399,5866046,'2010-09-24 23:01:58',1,2),(75746400,5671401,'2010-09-03 18:05:52',1,1),(75746401,5671401,'2010-09-03 18:05:52',1,1),(75746402,5671401,'2010-09-03 18:05:52',1,1),(75746403,5671401,'2010-09-03 18:05:52',1,1),(75746404,5671401,'2010-09-03 18:05:53',1,1),(75746405,5866046,'2010-09-24 23:01:58',1,2),(75746406,5671401,'2010-09-03 18:05:53',1,1),(75746409,5866082,'2010-09-24 23:06:23',1,2),(75746410,5671401,'2010-09-03 18:05:55',1,1),(75746411,5671401,'2010-09-03 18:05:56',1,1),(75746412,5866046,'2010-09-24 23:01:57',1,2),(75746414,5671401,'2010-09-03 18:05:56',1,1),(75746415,5671401,'2010-09-03 18:05:57',1,1),(75746416,5671401,'2010-09-03 18:05:57',1,1),(75746417,5671401,'2010-09-03 18:05:57',1,1),(75746418,5866046,'2010-09-24 23:01:58',1,2),(75746419,5866046,'2010-09-24 23:01:58',1,2),(75746421,5671401,'2010-09-03 18:05:57',1,1),(75746422,5671401,'2010-09-03 18:05:58',1,1),(75746423,5671401,'2010-09-03 18:05:58',1,1),(75746424,5671401,'2010-09-03 18:05:58',1,1),(75871448,5689624,'2010-09-05 19:39:54',1,2),(77918991,5806005,'2010-09-17 21:30:10',1,1),(79126612,5866082,'2010-09-24 23:06:25',1,1);
INSERT INTO `node_tags` VALUES (625039,3,'highway','mini_roundabout'),(26609114,1,'aeroway','helipad'),(26609114,1,'created_by','Potlatch alpha'),(26609114,1,'iata','ALV'),(26609114,1,'icao','----'),(26609114,1,'is_in','Andorra la Vella,,Andorra'),(26609114,1,'place','airport'),(26609114,1,'source','Gagravarr_Airports'),(26609114,1,'type','civil'),(51344677,2,'barrier','toll_booth'),(51366154,2,'highway','speed_camera'),(51404282,2,'highway','traffic_signals'),(51448830,5,'source','yahoo'),(51552405,1,'created_by','JOSM'),(51552408,1,'created_by','JOSM'),(51552410,1,'created_by','JOSM'),(51552413,3,'created_by','JOSM'),(51552416,3,'created_by','JOSM'),(51552419,3,'created_by','JOSM'),(51552422,2,'created_by','JOSM'),(51552429,3,'created_by','JOSM'),(51552432,3,'created_by','JOSM'),(51552434,3,'created_by','JOSM'),(51552437,2,'created_by','JOSM'),(51552440,2,'created_by','JOSM'),(51552442,3,'created_by','JOSM'),(51552444,2,'created_by','JOSM'),(51552445,2,'created_by','JOSM'),(51552447,2,'created_by','JOSM'),(51552451,2,'created_by','JOSM'),(51552453,2,'created_by','JOSM'),(51552456,2,'created_by','JOSM'),(51552459,2,'created_by','JOSM'),(51552462,2,'created_by','JOSM'),(51552468,2,'created_by','JOSM'),(51552471,2,'created_by','JOSM'),(51552483,4,'highway','speed_camera'),(51552504,2,'created_by','JOSM'),(51552507,1,'created_by','JOSM'),(51552509,1,'created_by','JOSM'),(51552513,1,'created_by','JOSM'),(51552516,1,'created_by','JOSM'),(51552518,1,'created_by','JOSM'),(51552546,1,'created_by','JOSM'),(51552549,1,'created_by','JOSM'),(51552550,1,'created_by','JOSM'),(51552553,1,'created_by','JOSM'),(51552555,1,'created_by','JOSM'),(51552557,1,'created_by','JOSM'),(51552559,1,'created_by','JOSM'),(51552562,1,'created_by','JOSM'),(51552565,1,'created_by','JOSM'),(51552569,1,'created_by','JOSM'),(51552572,1,'created_by','JOSM'),(51552575,1,'created_by','JOSM'),(51552589,1,'created_by','JOSM'),(51552592,1,'created_by','JOSM'),(51552602,3,'created_by','JOSM'),(51552608,1,'created_by','JOSM'),(51552651,2,'created_by','JOSM'),(51552651,2,'highway','mini_roundabout'),(51552736,1,'created_by','JOSM'),(51552737,1,'created_by','JOSM'),(51552740,1,'created_by','JOSM'),(51552744,7,'created_by','JOSM'),(51552747,1,'created_by','JOSM'),(51552750,1,'created_by','JOSM'),(51552755,1,'created_by','JOSM'),(51552758,1,'created_by','JOSM'),(51552761,2,'created_by','JOSM'),(51552762,2,'created_by','JOSM'),(51552764,1,'created_by','JOSM'),(51552766,1,'created_by','JOSM'),(51552768,1,'created_by','JOSM'),(51552770,1,'created_by','JOSM'),(51552773,1,'created_by','JOSM'),(51552774,1,'created_by','JOSM'),(51552777,1,'created_by','JOSM'),(51552779,1,'created_by','JOSM'),(51552782,1,'created_by','JOSM'),(51552785,1,'created_by','JOSM'),(51552787,1,'created_by','JOSM'),(51552789,1,'created_by','JOSM'),(51552791,1,'created_by','JOSM'),(51552793,1,'created_by','JOSM'),(51552797,1,'created_by','JOSM'),(51552800,1,'created_by','JOSM'),(51552802,1,'created_by','JOSM'),(51552806,1,'created_by','JOSM'),(51552807,1,'created_by','JOSM'),(51552811,1,'created_by','JOSM'),(51552814,1,'created_by','JOSM'),(51552815,1,'created_by','JOSM'),(51552818,1,'created_by','JOSM'),(51552821,1,'created_by','JOSM'),(51552823,1,'created_by','JOSM'),(51552824,1,'created_by','JOSM'),(51552825,1,'created_by','JOSM'),(51552828,1,'created_by','JOSM'),(51552830,1,'created_by','JOSM'),(51552832,1,'created_by','JOSM'),(51552835,1,'created_by','JOSM'),(51552838,1,'created_by','JOSM'),(51552841,1,'created_by','JOSM'),(51552844,1,'created_by','JOSM'),(51552847,1,'created_by','JOSM'),(51552849,1,'created_by','JOSM'),(51552851,1,'created_by','JOSM'),(51552852,1,'created_by','JOSM'),(51552854,1,'created_by','JOSM'),(51552856,1,'created_by','JOSM'),(51552859,1,'created_by','JOSM'),(51552861,1,'created_by','JOSM'),(51552863,1,'created_by','JOSM'),(51552865,1,'created_by','JOSM'),(51552868,1,'created_by','JOSM'),(51552871,1,'created_by','JOSM'),(51552873,1,'created_by','JOSM'),(51552875,1,'created_by','JOSM'),(51554685,1,'created_by','JOSM'),(51554688,1,'created_by','JOSM'),(51554691,1,'created_by','JOSM'),(51554693,1,'created_by','JOSM'),(51554694,1,'created_by','JOSM'),(51554697,1,'created_by','JOSM'),(51554700,1,'created_by','JOSM'),(51554703,1,'created_by','JOSM'),(51554705,1,'created_by','JOSM'),(51554707,1,'created_by','JOSM'),(51554710,1,'created_by','JOSM'),(51554712,1,'created_by','JOSM'),(51554715,1,'created_by','JOSM'),(51554716,1,'created_by','JOSM'),(51557999,2,'created_by','JOSM'),(51558001,2,'created_by','JOSM'),(51558003,1,'created_by','JOSM'),(51558005,1,'created_by','JOSM'),(51558007,1,'created_by','JOSM'),(51558010,1,'created_by','JOSM'),(51558014,1,'created_by','JOSM'),(51558017,1,'created_by','JOSM'),(51558021,1,'created_by','JOSM'),(51558024,1,'created_by','JOSM'),(51558026,1,'created_by','JOSM'),(51558029,1,'created_by','JOSM'),(51558031,1,'created_by','JOSM'),(51558033,1,'created_by','JOSM'),(51558036,1,'created_by','JOSM'),(51558038,1,'created_by','JOSM'),(51558040,1,'created_by','JOSM'),(51558041,1,'created_by','JOSM'),(51558043,1,'created_by','JOSM'),(51558045,1,'created_by','JOSM'),(51558047,1,'created_by','JOSM'),(51558051,1,'created_by','JOSM'),(51558054,1,'created_by','JOSM'),(51558057,1,'created_by','JOSM'),(51558059,1,'created_by','JOSM'),(51558060,1,'created_by','JOSM'),(51558063,1,'created_by','JOSM'),(51558064,1,'created_by','JOSM'),(51558067,1,'created_by','JOSM'),(51558070,1,'created_by','JOSM'),(51558071,1,'created_by','JOSM'),(51558074,1,'created_by','JOSM'),(51558075,1,'created_by','JOSM'),(51558078,1,'created_by','JOSM'),(51558083,1,'created_by','JOSM'),(51558085,1,'created_by','JOSM'),(51558086,1,'created_by','JOSM'),(51558089,1,'created_by','JOSM'),(51558091,1,'created_by','JOSM'),(51558093,1,'created_by','JOSM'),(51558095,1,'created_by','JOSM'),(51558097,1,'created_by','JOSM'),(51558099,1,'created_by','JOSM'),(51558103,1,'created_by','JOSM'),(51558105,1,'created_by','JOSM'),(51558108,1,'created_by','JOSM'),(51558111,1,'created_by','JOSM'),(51558113,1,'created_by','JOSM'),(51558115,1,'created_by','JOSM'),(51558118,1,'created_by','JOSM'),(51558121,1,'created_by','JOSM'),(51558124,1,'created_by','JOSM'),(51558125,1,'created_by','JOSM'),(51558128,1,'created_by','JOSM'),(51558131,1,'created_by','JOSM'),(51558246,1,'created_by','JOSM'),(51558248,1,'created_by','JOSM'),(51558253,1,'created_by','JOSM'),(51558257,1,'created_by','JOSM'),(51558260,1,'created_by','JOSM'),(51558262,1,'created_by','JOSM'),(51558265,1,'created_by','JOSM'),(51558268,1,'created_by','JOSM'),(51558271,1,'created_by','JOSM'),(51558273,1,'created_by','JOSM'),(51558276,1,'created_by','JOSM'),(51558279,1,'created_by','JOSM'),(51558282,1,'created_by','JOSM'),(51558284,1,'created_by','JOSM'),(51558287,1,'created_by','JOSM'),(51558293,1,'created_by','JOSM'),(51558295,1,'created_by','JOSM'),(51558298,1,'created_by','JOSM'),(51558301,1,'created_by','JOSM'),(51558304,1,'created_by','JOSM'),(51558305,1,'created_by','JOSM'),(51563059,1,'created_by','JOSM'),(51563061,1,'created_by','JOSM'),(51563063,1,'created_by','JOSM'),(51563066,1,'created_by','JOSM'),(51563071,1,'created_by','JOSM'),(51563075,1,'created_by','JOSM'),(51563076,1,'created_by','JOSM'),(51563080,1,'created_by','JOSM'),(51563083,1,'created_by','JOSM'),(51563087,1,'created_by','JOSM'),(51563090,1,'created_by','JOSM'),(51563094,1,'created_by','JOSM'),(51563098,1,'created_by','JOSM'),(51563100,1,'created_by','JOSM'),(51563103,1,'created_by','JOSM'),(51563105,1,'created_by','JOSM'),(51563108,1,'created_by','JOSM'),(51563110,1,'created_by','JOSM'),(51563113,1,'created_by','JOSM'),(51563115,1,'created_by','JOSM'),(51563118,1,'created_by','JOSM'),(51563120,1,'created_by','JOSM'),(51563122,1,'created_by','JOSM'),(51563124,1,'created_by','JOSM'),(51563127,1,'created_by','JOSM'),(51563130,1,'created_by','JOSM'),(51563134,1,'created_by','JOSM'),(51563137,1,'created_by','JOSM'),(51563140,1,'created_by','JOSM'),(51563141,1,'created_by','JOSM'),(51563145,1,'created_by','JOSM'),(51563148,1,'created_by','JOSM'),(51563152,1,'created_by','JOSM'),(51563155,1,'created_by','JOSM'),(51563159,1,'created_by','JOSM'),(51563162,1,'created_by','JOSM'),(51563164,1,'created_by','JOSM'),(51563168,1,'created_by','JOSM'),(51563170,1,'created_by','JOSM'),(51563173,1,'created_by','JOSM'),(51563176,1,'created_by','JOSM'),(51563177,1,'created_by','JOSM'),(51563179,1,'created_by','JOSM'),(51563181,1,'created_by','JOSM'),(51563185,1,'created_by','JOSM'),(51563189,1,'created_by','JOSM'),(51563192,1,'created_by','JOSM'),(51563195,1,'created_by','JOSM'),(51563197,1,'created_by','JOSM'),(51563199,1,'created_by','JOSM'),(51563200,1,'created_by','JOSM'),(51563202,1,'created_by','JOSM'),(51563205,1,'created_by','JOSM'),(51563210,1,'created_by','JOSM'),(51563214,1,'created_by','JOSM'),(51563216,1,'created_by','JOSM'),(51563224,1,'created_by','JOSM'),(51563226,1,'created_by','JOSM'),(51563230,1,'created_by','JOSM'),(51563233,1,'created_by','JOSM'),(51563236,1,'created_by','JOSM'),(51563238,1,'created_by','JOSM'),(51563242,1,'created_by','JOSM'),(51563244,1,'created_by','JOSM'),(51563247,1,'created_by','JOSM'),(51563252,1,'created_by','JOSM'),(51563255,1,'created_by','JOSM'),(51563257,1,'created_by','JOSM'),(51563261,1,'created_by','JOSM'),(51563266,1,'created_by','JOSM'),(51563268,1,'created_by','JOSM'),(51563272,1,'created_by','JOSM'),(51563276,1,'created_by','JOSM'),(51563279,1,'created_by','JOSM'),(51563281,1,'created_by','JOSM'),(51563284,1,'created_by','JOSM'),(51563374,1,'created_by','JOSM'),(51563375,1,'created_by','JOSM'),(51563437,1,'created_by','JOSM'),(51563439,1,'created_by','JOSM'),(51563440,1,'created_by','JOSM'),(51563441,1,'created_by','JOSM'),(51563442,1,'created_by','JOSM'),(51563443,1,'created_by','JOSM'),(51563447,1,'created_by','JOSM'),(51563450,1,'created_by','JOSM'),(51563451,1,'created_by','JOSM'),(51563453,1,'created_by','JOSM'),(51563454,1,'created_by','JOSM'),(51563456,1,'created_by','JOSM'),(51563458,1,'created_by','JOSM'),(51563460,1,'created_by','JOSM'),(51563462,1,'created_by','JOSM'),(51563463,1,'created_by','JOSM'),(51563466,1,'created_by','JOSM'),(51563470,1,'created_by','JOSM'),(51563472,1,'created_by','JOSM'),(51563474,1,'created_by','JOSM'),(51563477,1,'created_by','JOSM'),(51563480,1,'created_by','JOSM'),(51563481,1,'created_by','JOSM'),(51563484,1,'created_by','JOSM'),(51563485,1,'created_by','JOSM'),(51563488,1,'created_by','JOSM'),(51563490,1,'created_by','JOSM'),(51563492,1,'created_by','JOSM'),(51563494,1,'created_by','JOSM'),(51563496,1,'created_by','JOSM'),(51563499,1,'created_by','JOSM'),(51581574,3,'created_by','JOSM'),(51581577,1,'created_by','JOSM'),(51581580,1,'created_by','JOSM'),(51581582,1,'created_by','JOSM'),(51581587,1,'created_by','JOSM'),(51581590,1,'created_by','JOSM'),(51581593,1,'created_by','JOSM'),(51581596,1,'created_by','JOSM'),(51581598,1,'created_by','JOSM'),(51581602,1,'created_by','JOSM'),(51581607,1,'created_by','JOSM'),(51581611,1,'created_by','JOSM'),(51581613,1,'created_by','JOSM'),(51581617,1,'created_by','JOSM'),(51581620,1,'created_by','JOSM'),(51581622,2,'created_by','JOSM'),(51581625,1,'created_by','JOSM'),(51581628,1,'created_by','JOSM'),(51581633,3,'created_by','JOSM'),(51581643,2,'created_by','JOSM'),(51581645,1,'created_by','JOSM'),(51581650,1,'created_by','JOSM'),(51581654,1,'created_by','JOSM'),(51581657,1,'created_by','JOSM'),(51581661,1,'created_by','JOSM'),(51581663,1,'created_by','JOSM'),(51581667,1,'created_by','JOSM'),(51581670,1,'created_by','JOSM'),(51581751,3,'created_by','JOSM'),(51581754,3,'created_by','JOSM'),(51581757,3,'created_by','JOSM'),(51581759,3,'created_by','JOSM'),(51581762,4,'created_by','JOSM'),(51581766,3,'created_by','JOSM'),(51581769,3,'created_by','JOSM'),(51581772,3,'created_by','JOSM'),(51581776,3,'created_by','JOSM'),(51581783,3,'created_by','JOSM'),(51581786,1,'created_by','JOSM'),(51581788,1,'created_by','JOSM'),(51581791,3,'created_by','JOSM'),(51581795,2,'created_by','JOSM'),(51581796,1,'created_by','JOSM'),(51581799,1,'created_by','JOSM'),(51581803,1,'created_by','JOSM'),(51581807,1,'created_by','JOSM'),(51581810,1,'created_by','JOSM'),(51581813,1,'created_by','JOSM'),(51581814,1,'created_by','JOSM'),(51581818,1,'created_by','JOSM'),(51581821,1,'created_by','JOSM'),(51581823,1,'created_by','JOSM'),(51581826,1,'created_by','JOSM'),(51581828,1,'created_by','JOSM'),(51581829,1,'created_by','JOSM'),(51581832,1,'created_by','JOSM'),(51581835,1,'created_by','JOSM'),(51581837,1,'created_by','JOSM'),(51581840,1,'created_by','JOSM'),(51581843,1,'created_by','JOSM'),(51581846,1,'created_by','JOSM'),(51581849,1,'created_by','JOSM'),(51581852,1,'created_by','JOSM'),(51581854,1,'created_by','JOSM'),(51581857,1,'created_by','JOSM'),(51581861,1,'created_by','JOSM'),(51581863,2,'created_by','JOSM'),(51581868,2,'created_by','JOSM'),(51581874,2,'created_by','JOSM'),(51581876,2,'created_by','JOSM'),(51581877,2,'created_by','JOSM'),(51581881,1,'created_by','JOSM'),(51581883,1,'created_by','JOSM'),(51581886,1,'created_by','JOSM'),(51581888,1,'created_by','JOSM'),(51581890,1,'created_by','JOSM'),(51581895,1,'created_by','JOSM'),(51581898,1,'created_by','JOSM'),(51581902,1,'created_by','JOSM'),(51581904,1,'created_by','JOSM'),(51581906,1,'created_by','JOSM'),(51581910,2,'created_by','JOSM'),(51581912,2,'created_by','JOSM'),(51581914,2,'created_by','JOSM'),(51581916,1,'created_by','JOSM'),(51581922,1,'created_by','JOSM'),(51581923,1,'created_by','JOSM'),(51581926,1,'created_by','JOSM'),(51581928,1,'created_by','JOSM'),(51581931,1,'created_by','JOSM'),(51581932,1,'created_by','JOSM'),(51581936,1,'created_by','JOSM'),(51581939,1,'created_by','JOSM'),(51581941,1,'created_by','JOSM'),(51581944,1,'created_by','JOSM'),(51581946,1,'created_by','JOSM'),(51581951,1,'created_by','JOSM'),(51581955,1,'created_by','JOSM'),(51581958,1,'created_by','JOSM'),(51581960,1,'created_by','JOSM'),(51581962,2,'created_by','JOSM'),(51581964,1,'created_by','JOSM'),(51581967,1,'created_by','JOSM'),(51581970,1,'created_by','JOSM'),(51581973,1,'created_by','JOSM'),(51581976,1,'created_by','JOSM'),(51581979,1,'created_by','JOSM'),(51581980,1,'created_by','JOSM'),(51581983,1,'created_by','JOSM'),(51581986,1,'created_by','JOSM'),(51581990,1,'created_by','JOSM'),(51581993,1,'created_by','JOSM'),(51581995,1,'created_by','JOSM'),(51581997,2,'created_by','JOSM'),(51582003,2,'created_by','JOSM'),(51582007,1,'created_by','JOSM'),(51582009,1,'created_by','JOSM'),(51582013,1,'created_by','JOSM'),(51582019,1,'created_by','JOSM'),(51582023,1,'created_by','JOSM'),(51582027,2,'created_by','JOSM'),(51582031,2,'created_by','JOSM'),(51582034,1,'created_by','JOSM'),(51582038,1,'created_by','JOSM'),(51582045,1,'created_by','JOSM'),(51582060,1,'created_by','JOSM'),(51582066,1,'created_by','JOSM'),(51582074,1,'created_by','JOSM'),(51582077,1,'created_by','JOSM'),(51582082,1,'created_by','JOSM'),(51582085,1,'created_by','JOSM'),(51582086,1,'created_by','JOSM'),(51582089,1,'created_by','JOSM'),(51582090,1,'created_by','JOSM'),(51582091,1,'created_by','JOSM'),(51582093,1,'created_by','JOSM'),(51582096,1,'created_by','JOSM'),(51582098,1,'created_by','JOSM'),(51582101,1,'created_by','JOSM'),(51582102,1,'created_by','JOSM'),(51582105,1,'created_by','JOSM'),(51582107,1,'created_by','JOSM'),(51582110,1,'created_by','JOSM'),(51582111,1,'created_by','JOSM'),(51582113,1,'created_by','JOSM'),(51582116,1,'created_by','JOSM'),(51582118,1,'created_by','JOSM'),(51582121,1,'created_by','JOSM'),(51582123,1,'created_by','JOSM'),(51582125,1,'created_by','JOSM'),(51582128,2,'created_by','JOSM'),(51582132,2,'created_by','JOSM'),(51582133,2,'created_by','JOSM'),(51582135,2,'created_by','JOSM'),(51582137,2,'created_by','JOSM'),(51582139,1,'created_by','JOSM'),(51582143,1,'created_by','JOSM'),(51582146,1,'created_by','JOSM'),(51582148,1,'created_by','JOSM'),(51582150,1,'created_by','JOSM'),(51582153,1,'created_by','JOSM'),(51582156,1,'created_by','JOSM'),(51582159,1,'created_by','JOSM'),(51582162,1,'created_by','JOSM'),(51582166,1,'created_by','JOSM'),(51582167,1,'created_by','JOSM'),(51582170,1,'created_by','JOSM'),(51582173,1,'created_by','JOSM'),(51582175,1,'created_by','JOSM'),(51582178,1,'created_by','JOSM'),(51582181,2,'created_by','JOSM'),(51582184,5,'created_by','JOSM'),(51582186,2,'created_by','JOSM'),(51582188,1,'created_by','JOSM'),(51582191,1,'created_by','JOSM'),(51582194,1,'created_by','JOSM'),(51582198,2,'created_by','JOSM'),(51582201,1,'created_by','JOSM'),(51582204,1,'created_by','JOSM'),(51582207,1,'created_by','JOSM'),(51582209,1,'created_by','JOSM'),(51582211,1,'created_by','JOSM'),(51587693,3,'created_by','JOSM'),(51587703,3,'created_by','JOSM'),(51587705,4,'created_by','JOSM'),(51587707,3,'created_by','JOSM'),(51587715,3,'created_by','JOSM'),(51587721,3,'created_by','JOSM'),(51587723,3,'created_by','JOSM'),(51587729,4,'created_by','JOSM'),(51587732,4,'created_by','JOSM'),(51589112,2,'created_by','JOSM'),(51589115,2,'created_by','JOSM'),(51589117,2,'created_by','JOSM'),(51589119,2,'created_by','JOSM'),(51589122,2,'created_by','JOSM'),(51589125,2,'created_by','JOSM'),(51589128,1,'created_by','JOSM'),(51589130,1,'created_by','JOSM'),(51589133,1,'created_by','JOSM'),(51589136,1,'created_by','JOSM'),(51589138,1,'created_by','JOSM'),(51589142,1,'created_by','JOSM'),(51589144,1,'created_by','JOSM'),(51589146,1,'created_by','JOSM'),(51589149,1,'created_by','JOSM'),(51589152,1,'created_by','JOSM'),(51589155,1,'created_by','JOSM'),(51589157,1,'created_by','JOSM'),(51589158,1,'created_by','JOSM'),(51589160,1,'created_by','JOSM'),(51589161,1,'created_by','JOSM'),(51589162,1,'created_by','JOSM'),(51589163,1,'created_by','JOSM'),(51589165,1,'created_by','JOSM'),(51589169,1,'created_by','JOSM'),(51589172,1,'created_by','JOSM'),(51589174,1,'created_by','JOSM'),(51589177,1,'created_by','JOSM'),(51589180,1,'created_by','JOSM'),(51589183,1,'created_by','JOSM'),(51589185,1,'created_by','JOSM'),(51589187,1,'created_by','JOSM'),(51589190,1,'created_by','JOSM'),(51589192,1,'created_by','JOSM'),(51589194,1,'created_by','JOSM'),(51589196,1,'created_by','JOSM'),(51589198,1,'created_by','JOSM'),(51589201,1,'created_by','JOSM'),(51589203,1,'created_by','JOSM'),(51589205,1,'created_by','JOSM'),(51589208,1,'created_by','JOSM'),(51589210,1,'created_by','JOSM'),(51589213,1,'created_by','JOSM'),(51589215,1,'created_by','JOSM'),(51589217,1,'created_by','JOSM'),(51589220,1,'created_by','JOSM'),(51589223,1,'created_by','JOSM'),(51589226,1,'created_by','JOSM'),(51589229,1,'created_by','JOSM'),(51589230,1,'created_by','JOSM'),(51589233,1,'created_by','JOSM'),(51589236,1,'created_by','JOSM'),(51589238,1,'created_by','JOSM'),(51589243,1,'created_by','JOSM'),(51589247,1,'created_by','JOSM'),(51589249,1,'created_by','JOSM'),(51589252,1,'created_by','JOSM'),(51589254,1,'created_by','JOSM'),(51589256,1,'created_by','JOSM'),(51589259,1,'created_by','JOSM'),(51589262,1,'created_by','JOSM'),(51589263,1,'created_by','JOSM'),(51589267,1,'created_by','JOSM'),(51589270,1,'created_by','JOSM'),(51589273,1,'created_by','JOSM'),(51589275,1,'created_by','JOSM'),(51589278,1,'created_by','JOSM'),(51589281,1,'created_by','JOSM'),(51589284,1,'created_by','JOSM'),(51589288,1,'created_by','JOSM'),(51589290,1,'created_by','JOSM'),(51589293,1,'created_by','JOSM'),(51589296,1,'created_by','JOSM'),(51589297,1,'created_by','JOSM'),(51589299,1,'created_by','JOSM'),(51589302,1,'created_by','JOSM'),(51589304,1,'created_by','JOSM'),(51589307,1,'created_by','JOSM'),(51589310,1,'created_by','JOSM'),(51589313,1,'created_by','JOSM'),(51589315,1,'created_by','JOSM'),(51589320,1,'created_by','JOSM'),(51589325,1,'created_by','JOSM'),(51589328,1,'created_by','JOSM'),(51589334,1,'created_by','JOSM'),(51589337,1,'created_by','JOSM'),(51589338,1,'created_by','JOSM'),(51589340,1,'created_by','JOSM'),(51589342,1,'created_by','JOSM'),(51589344,1,'created_by','JOSM'),(51589348,1,'created_by','JOSM'),(51589352,1,'created_by','JOSM'),(51589354,1,'created_by','JOSM'),(51589357,1,'created_by','JOSM'),(51589360,1,'created_by','JOSM'),(51589363,1,'created_by','JOSM'),(51589366,1,'created_by','JOSM'),(51589368,1,'created_by','JOSM'),(51589370,1,'created_by','JOSM'),(51590535,1,'created_by','JOSM'),(51590538,1,'created_by','JOSM'),(51590542,1,'created_by','JOSM'),(51590544,1,'created_by','JOSM'),(51590546,1,'created_by','JOSM'),(51590549,1,'created_by','JOSM'),(51590551,1,'created_by','JOSM'),(51590553,1,'created_by','JOSM'),(51590557,1,'created_by','JOSM'),(51590560,1,'created_by','JOSM'),(51590563,1,'created_by','JOSM'),(51590564,1,'created_by','JOSM'),(51590567,1,'created_by','JOSM'),(51590572,1,'created_by','JOSM'),(51590575,1,'created_by','JOSM'),(51590578,1,'created_by','JOSM'),(51590580,1,'created_by','JOSM'),(51590582,1,'created_by','JOSM'),(51590585,1,'created_by','JOSM'),(51590588,1,'created_by','JOSM'),(51590589,1,'created_by','JOSM'),(51590592,1,'created_by','JOSM'),(51590595,1,'created_by','JOSM'),(51590598,1,'created_by','JOSM'),(51590600,1,'created_by','JOSM'),(51590603,1,'created_by','JOSM'),(51590606,1,'created_by','JOSM'),(51590608,1,'created_by','JOSM'),(51590611,1,'created_by','JOSM'),(51590613,1,'created_by','JOSM'),(51590616,1,'created_by','JOSM'),(51590619,1,'created_by','JOSM'),(51590622,1,'created_by','JOSM'),(51590623,1,'created_by','JOSM'),(51590626,1,'created_by','JOSM'),(51590630,1,'created_by','JOSM'),(51590631,1,'created_by','JOSM'),(51590633,1,'created_by','JOSM'),(51590634,1,'created_by','JOSM'),(51590635,1,'created_by','JOSM'),(51590636,1,'created_by','JOSM'),(51590637,1,'created_by','JOSM'),(51590638,1,'created_by','JOSM'),(51590643,1,'created_by','JOSM'),(51590645,1,'created_by','JOSM'),(51590646,1,'created_by','JOSM'),(51590648,1,'created_by','JOSM'),(51590650,1,'created_by','JOSM'),(51590653,1,'created_by','JOSM'),(51590654,1,'created_by','JOSM'),(51590657,1,'created_by','JOSM'),(51590660,1,'created_by','JOSM'),(51590663,1,'created_by','JOSM'),(51590665,1,'created_by','JOSM'),(51590668,1,'created_by','JOSM'),(51590669,1,'created_by','JOSM'),(51590671,1,'created_by','JOSM'),(51590673,1,'created_by','JOSM'),(51590676,1,'created_by','JOSM'),(51590679,1,'created_by','JOSM'),(51590680,1,'created_by','JOSM'),(51590683,1,'created_by','JOSM'),(51590686,1,'created_by','JOSM'),(51590687,1,'created_by','JOSM'),(51590690,1,'created_by','JOSM'),(51590691,1,'created_by','JOSM'),(51590693,1,'created_by','JOSM'),(51590695,1,'created_by','JOSM'),(51590699,1,'created_by','JOSM'),(51590702,1,'created_by','JOSM'),(51590705,1,'created_by','JOSM'),(51590707,1,'created_by','JOSM'),(51590708,1,'created_by','JOSM'),(51590711,1,'created_by','JOSM'),(51590714,1,'created_by','JOSM'),(51590716,1,'created_by','JOSM'),(51590719,1,'created_by','JOSM'),(51590722,1,'created_by','JOSM'),(51590725,1,'created_by','JOSM'),(51590728,1,'created_by','JOSM'),(51590730,1,'created_by','JOSM'),(51929590,1,'created_by','JOSM'),(51929593,1,'created_by','JOSM'),(51929595,1,'created_by','JOSM'),(51929598,1,'created_by','JOSM'),(51929600,1,'created_by','JOSM'),(51929603,1,'created_by','JOSM'),(51929607,1,'created_by','JOSM'),(51929610,1,'created_by','JOSM'),(51929614,1,'created_by','JOSM'),(51929617,1,'created_by','JOSM'),(51929619,1,'created_by','JOSM'),(51929620,1,'created_by','JOSM'),(51929623,1,'created_by','JOSM'),(51929625,1,'created_by','JOSM'),(51929626,1,'created_by','JOSM'),(51929628,1,'created_by','JOSM'),(51929630,1,'created_by','JOSM'),(51929632,1,'created_by','JOSM'),(51929634,1,'created_by','JOSM'),(51929636,1,'created_by','JOSM'),(51929638,1,'created_by','JOSM'),(51929640,1,'created_by','JOSM'),(51929642,1,'created_by','JOSM'),(51929644,1,'created_by','JOSM'),(51929645,1,'created_by','JOSM'),(51929647,1,'created_by','JOSM'),(51929649,1,'created_by','JOSM'),(51929650,1,'created_by','JOSM'),(51929653,1,'created_by','JOSM'),(51929656,1,'created_by','JOSM'),(51929657,1,'created_by','JOSM'),(51929660,1,'created_by','JOSM'),(51929661,1,'created_by','JOSM'),(51929663,1,'created_by','JOSM'),(51929665,1,'created_by','JOSM'),(51929667,1,'created_by','JOSM'),(51929670,1,'created_by','JOSM'),(51929671,1,'created_by','JOSM'),(51929673,1,'created_by','JOSM'),(51929675,1,'created_by','JOSM'),(51929677,1,'created_by','JOSM'),(51929678,1,'created_by','JOSM'),(51929680,1,'created_by','JOSM'),(51929682,1,'created_by','JOSM'),(51929684,1,'created_by','JOSM'),(51929687,1,'created_by','JOSM'),(51929689,1,'created_by','JOSM'),(51929690,1,'created_by','JOSM'),(51929693,1,'created_by','JOSM'),(51929696,1,'created_by','JOSM'),(51929700,1,'created_by','JOSM'),(51929702,1,'created_by','JOSM'),(51929704,1,'created_by','JOSM'),(51929707,1,'created_by','JOSM'),(51929709,1,'created_by','JOSM'),(51929711,1,'created_by','JOSM'),(51929713,1,'created_by','JOSM'),(51929715,1,'created_by','JOSM'),(51929717,1,'created_by','JOSM'),(51929720,1,'created_by','JOSM'),(51929722,1,'created_by','JOSM'),(51929725,1,'created_by','JOSM'),(51929728,1,'created_by','JOSM'),(51929731,1,'created_by','JOSM'),(51929734,1,'created_by','JOSM'),(51929736,1,'created_by','JOSM'),(51929739,1,'created_by','JOSM'),(51929741,1,'created_by','JOSM'),(51929743,1,'created_by','JOSM'),(51929746,1,'created_by','JOSM'),(51929749,1,'created_by','JOSM'),(51929752,1,'created_by','JOSM'),(51929754,1,'created_by','JOSM'),(51929757,1,'created_by','JOSM'),(51929760,1,'created_by','JOSM'),(51929762,1,'created_by','JOSM'),(51929764,1,'created_by','JOSM'),(51929767,1,'created_by','JOSM'),(51929770,1,'created_by','JOSM'),(51929771,1,'created_by','JOSM'),(51929773,1,'created_by','JOSM'),(51929775,1,'created_by','JOSM'),(51929777,1,'created_by','JOSM'),(51929780,1,'created_by','JOSM'),(51929782,1,'created_by','JOSM'),(51929784,1,'created_by','JOSM'),(51929785,1,'created_by','JOSM'),(51929786,1,'created_by','JOSM'),(51929788,1,'created_by','JOSM'),(51929790,1,'created_by','JOSM'),(51929793,1,'created_by','JOSM'),(51929796,1,'created_by','JOSM'),(51929797,1,'created_by','JOSM'),(51929800,1,'created_by','JOSM'),(51929802,1,'created_by','JOSM'),(51929805,1,'created_by','JOSM'),(51929807,1,'created_by','JOSM'),(51929810,1,'created_by','JOSM'),(51929812,1,'created_by','JOSM'),(51929814,1,'created_by','JOSM'),(51929818,1,'created_by','JOSM'),(51929820,1,'created_by','JOSM'),(51929823,1,'created_by','JOSM'),(51929825,1,'created_by','JOSM'),(51929827,1,'created_by','JOSM'),(51929829,1,'created_by','JOSM'),(51929833,1,'created_by','JOSM'),(51929834,1,'created_by','JOSM'),(51929837,1,'created_by','JOSM'),(51929840,1,'created_by','JOSM'),(51929842,1,'created_by','JOSM'),(51929844,1,'created_by','JOSM'),(51929846,1,'created_by','JOSM'),(51929848,1,'created_by','JOSM'),(51929852,1,'created_by','JOSM'),(51929854,1,'created_by','JOSM'),(51929858,1,'created_by','JOSM'),(51929860,1,'created_by','JOSM'),(51929862,1,'created_by','JOSM'),(51929864,1,'created_by','JOSM'),(51929866,1,'created_by','JOSM'),(51929869,1,'created_by','JOSM'),(51929872,1,'created_by','JOSM'),(51929873,1,'created_by','JOSM'),(51929875,1,'created_by','JOSM'),(51929878,1,'created_by','JOSM'),(51929880,1,'created_by','JOSM'),(51929883,1,'created_by','JOSM'),(51929886,1,'created_by','JOSM'),(51929889,1,'created_by','JOSM'),(51929892,1,'created_by','JOSM'),(51929893,1,'created_by','JOSM'),(51929896,1,'created_by','JOSM'),(51929899,1,'created_by','JOSM'),(51929902,1,'created_by','JOSM'),(51929905,1,'created_by','JOSM'),(51929907,1,'created_by','JOSM'),(51929909,1,'created_by','JOSM'),(51929910,1,'created_by','JOSM'),(51929913,1,'created_by','JOSM'),(51929915,1,'created_by','JOSM'),(51929916,1,'created_by','JOSM'),(51929918,1,'created_by','JOSM'),(51929920,1,'created_by','JOSM'),(51929922,1,'created_by','JOSM'),(51929923,1,'created_by','JOSM'),(51929925,1,'created_by','JOSM'),(51929927,1,'created_by','JOSM'),(51929930,1,'created_by','JOSM'),(51929933,1,'created_by','JOSM'),(51929936,1,'created_by','JOSM'),(51929938,1,'created_by','JOSM'),(51929939,1,'created_by','JOSM'),(51929942,1,'created_by','JOSM'),(51929943,1,'created_by','JOSM'),(51929946,1,'created_by','JOSM'),(51929949,1,'created_by','JOSM'),(51929950,1,'created_by','JOSM'),(51929953,1,'created_by','JOSM'),(51929955,1,'created_by','JOSM'),(51929957,1,'created_by','JOSM'),(51929960,1,'created_by','JOSM'),(51929964,1,'created_by','JOSM'),(51929966,1,'created_by','JOSM'),(51929968,1,'created_by','JOSM'),(51929971,1,'created_by','JOSM'),(51929974,1,'created_by','JOSM'),(51929975,1,'created_by','JOSM'),(51929978,1,'created_by','JOSM'),(51929980,1,'created_by','JOSM'),(51929983,1,'created_by','JOSM'),(51929986,1,'created_by','JOSM'),(51929988,1,'created_by','JOSM'),(51929990,1,'created_by','JOSM'),(51929993,1,'created_by','JOSM'),(51929999,1,'created_by','JOSM'),(51930002,1,'created_by','JOSM'),(51930009,1,'created_by','JOSM'),(51930014,1,'created_by','JOSM'),(51930018,1,'created_by','JOSM'),(51930020,1,'created_by','JOSM'),(51930022,1,'created_by','JOSM'),(51930024,1,'created_by','JOSM'),(51930026,1,'created_by','JOSM'),(51930029,1,'created_by','JOSM'),(51930031,1,'created_by','JOSM'),(51930033,1,'created_by','JOSM'),(51930035,1,'created_by','JOSM'),(51930037,1,'created_by','JOSM'),(51930040,1,'created_by','JOSM'),(51930043,1,'created_by','JOSM'),(51930044,1,'created_by','JOSM'),(51930047,1,'created_by','JOSM'),(51930048,1,'created_by','JOSM'),(51930050,1,'created_by','JOSM'),(51930052,1,'created_by','JOSM'),(51930053,1,'created_by','JOSM'),(51930055,1,'created_by','JOSM'),(51930058,1,'created_by','JOSM'),(51930062,1,'created_by','JOSM'),(51930063,1,'created_by','JOSM'),(51930066,1,'created_by','JOSM'),(51930068,1,'created_by','JOSM'),(51930071,1,'created_by','JOSM'),(51930073,1,'created_by','JOSM'),(51930076,1,'created_by','JOSM'),(51930079,1,'created_by','JOSM'),(51930080,1,'created_by','JOSM'),(51930082,1,'created_by','JOSM'),(51930085,1,'created_by','JOSM'),(51930088,1,'created_by','JOSM'),(51930092,1,'created_by','JOSM'),(51930094,1,'created_by','JOSM'),(51930096,1,'created_by','JOSM'),(51930098,1,'created_by','JOSM'),(51930099,1,'created_by','JOSM'),(51930102,1,'created_by','JOSM'),(51930104,1,'created_by','JOSM'),(51930107,1,'created_by','JOSM'),(51930108,1,'created_by','JOSM'),(51930110,1,'created_by','JOSM'),(51930112,1,'created_by','JOSM'),(51930113,1,'created_by','JOSM'),(51930115,1,'created_by','JOSM'),(51930118,1,'created_by','JOSM'),(51930119,1,'created_by','JOSM'),(51930121,1,'created_by','JOSM'),(51930124,1,'created_by','JOSM'),(51930125,1,'created_by','JOSM'),(51930127,1,'created_by','JOSM'),(51930129,1,'created_by','JOSM'),(51930132,1,'created_by','JOSM'),(51930134,1,'created_by','JOSM'),(51930136,1,'created_by','JOSM'),(51930138,1,'created_by','JOSM'),(51930141,1,'created_by','JOSM'),(51930143,1,'created_by','JOSM'),(51930145,1,'created_by','JOSM'),(51930148,1,'created_by','JOSM'),(51930149,1,'created_by','JOSM'),(51930152,1,'created_by','JOSM'),(51930153,1,'created_by','JOSM'),(51930156,1,'created_by','JOSM'),(51930158,1,'created_by','JOSM'),(51930160,1,'created_by','JOSM'),(51930163,1,'created_by','JOSM'),(51930165,1,'created_by','JOSM'),(51930167,1,'created_by','JOSM'),(51930171,1,'created_by','JOSM'),(51930173,1,'created_by','JOSM'),(51930175,1,'created_by','JOSM'),(51930178,1,'created_by','JOSM'),(51930181,1,'created_by','JOSM'),(51930184,1,'created_by','JOSM'),(51930186,5,'ele','1987'),(51930186,5,'mountain_pass','yes'),(51930186,5,'name','Col d\'Ordino'),(51930188,1,'created_by','JOSM'),(51930191,1,'created_by','JOSM'),(51930193,1,'created_by','JOSM'),(51930195,1,'created_by','JOSM'),(51930198,1,'created_by','JOSM'),(51930199,1,'created_by','JOSM'),(51930202,1,'created_by','JOSM'),(51930206,1,'created_by','JOSM'),(51930208,1,'created_by','JOSM'),(51930211,1,'created_by','JOSM'),(51930213,1,'created_by','JOSM'),(51930216,1,'created_by','JOSM'),(51930219,1,'created_by','JOSM'),(51930222,1,'created_by','JOSM'),(51930223,1,'created_by','JOSM'),(51930226,1,'created_by','JOSM'),(51930228,1,'created_by','JOSM'),(51930230,1,'created_by','JOSM'),(51930232,1,'created_by','JOSM'),(51930235,1,'created_by','JOSM'),(51930238,1,'created_by','JOSM'),(51930241,1,'created_by','JOSM'),(51930242,1,'created_by','JOSM'),(51930245,1,'created_by','JOSM'),(51930247,1,'created_by','JOSM'),(51930250,1,'created_by','JOSM'),(51930252,1,'created_by','JOSM'),(51930253,1,'created_by','JOSM'),(51930255,1,'created_by','JOSM'),(51930257,1,'created_by','JOSM'),(51930259,1,'created_by','JOSM'),(51930262,1,'created_by','JOSM'),(51930264,1,'created_by','JOSM'),(51930267,1,'created_by','JOSM'),(51930270,1,'created_by','JOSM'),(51930272,1,'created_by','JOSM'),(51930275,1,'created_by','JOSM'),(51930278,1,'created_by','JOSM'),(51930280,1,'created_by','JOSM'),(51930282,2,'created_by','JOSM'),(51930284,2,'created_by','JOSM'),(51930288,2,'created_by','JOSM'),(51930291,1,'created_by','JOSM'),(51930293,1,'created_by','JOSM'),(51930297,1,'created_by','JOSM'),(51930299,1,'created_by','JOSM'),(51930302,1,'created_by','JOSM'),(51930305,1,'created_by','JOSM'),(51930307,1,'created_by','JOSM'),(51930309,1,'created_by','JOSM'),(51930311,1,'created_by','JOSM'),(51930312,1,'created_by','JOSM'),(51930313,1,'created_by','JOSM'),(51930314,1,'created_by','JOSM'),(51930315,1,'created_by','JOSM'),(51930319,1,'created_by','JOSM'),(51930321,1,'created_by','JOSM'),(51930324,1,'created_by','JOSM'),(51930326,1,'created_by','JOSM'),(51930328,1,'created_by','JOSM'),(51930331,1,'created_by','JOSM'),(51930332,1,'created_by','JOSM'),(51930334,1,'created_by','JOSM'),(51930336,1,'created_by','JOSM'),(51930338,1,'created_by','JOSM'),(51930340,1,'created_by','JOSM'),(51930343,1,'created_by','JOSM'),(51930345,1,'created_by','JOSM'),(51930348,1,'created_by','JOSM'),(51930349,1,'created_by','JOSM'),(51930352,1,'created_by','JOSM'),(51930354,1,'created_by','JOSM'),(51930357,1,'created_by','JOSM'),(51930359,1,'created_by','JOSM'),(51930360,1,'created_by','JOSM'),(51930362,1,'created_by','JOSM'),(51930364,1,'created_by','JOSM'),(51930365,1,'created_by','JOSM'),(51930368,1,'created_by','JOSM'),(51930371,1,'created_by','JOSM'),(51930373,1,'created_by','JOSM'),(51930376,1,'created_by','JOSM'),(51930378,1,'created_by','JOSM'),(51930380,1,'created_by','JOSM'),(51930382,1,'created_by','JOSM'),(51930384,1,'created_by','JOSM'),(51930386,1,'created_by','JOSM'),(51930388,1,'created_by','JOSM'),(51930390,1,'created_by','JOSM'),(51930396,1,'created_by','JOSM'),(51930403,1,'created_by','JOSM'),(51930405,1,'created_by','JOSM'),(51930408,1,'created_by','JOSM'),(51930410,1,'created_by','JOSM'),(51930412,1,'created_by','JOSM'),(51930413,1,'created_by','JOSM'),(51930415,1,'created_by','JOSM'),(51930416,1,'created_by','JOSM'),(51930417,1,'created_by','JOSM'),(51930418,1,'created_by','JOSM'),(51930420,1,'created_by','JOSM'),(51930422,1,'created_by','JOSM'),(51930424,1,'created_by','JOSM'),(51930426,1,'created_by','JOSM'),(51930428,1,'created_by','JOSM'),(51930429,1,'created_by','JOSM'),(51930433,1,'created_by','JOSM'),(51930437,1,'created_by','JOSM'),(51930439,1,'created_by','JOSM'),(51930441,1,'created_by','JOSM'),(51930443,1,'created_by','JOSM'),(51930445,1,'created_by','JOSM'),(51930447,4,'created_by','JOSM'),(51930447,4,'ele','1952'),(51930447,4,'mountain_pass','yes'),(51930447,4,'name','Collet de Montaup'),(51930448,2,'created_by','JOSM'),(51930449,1,'created_by','JOSM'),(51930450,1,'created_by','JOSM'),(51930453,1,'created_by','JOSM'),(51930455,1,'created_by','JOSM'),(51930457,1,'created_by','JOSM'),(51930458,1,'created_by','JOSM'),(51930461,1,'created_by','JOSM'),(51930462,1,'created_by','JOSM'),(51930465,1,'created_by','JOSM'),(51930467,1,'created_by','JOSM'),(51930469,1,'created_by','JOSM'),(51930470,1,'created_by','JOSM'),(51930473,1,'created_by','JOSM'),(51930475,1,'created_by','JOSM'),(51930478,1,'created_by','JOSM'),(51930481,1,'created_by','JOSM'),(51930483,1,'created_by','JOSM'),(51930485,1,'created_by','JOSM'),(51930488,1,'created_by','JOSM'),(51930492,1,'created_by','JOSM'),(51930495,1,'created_by','JOSM'),(51930497,1,'created_by','JOSM'),(51930500,1,'created_by','JOSM'),(51930503,1,'created_by','JOSM'),(51930505,1,'created_by','JOSM'),(51930507,1,'created_by','JOSM'),(51930509,1,'created_by','JOSM'),(51930511,1,'created_by','JOSM'),(51930513,1,'created_by','JOSM'),(51930517,1,'created_by','JOSM'),(51930519,1,'created_by','JOSM'),(51930521,1,'created_by','JOSM'),(51930524,1,'created_by','JOSM'),(51930527,1,'created_by','JOSM'),(51930531,1,'created_by','JOSM'),(51930534,1,'created_by','JOSM'),(51930537,1,'created_by','JOSM'),(51930540,1,'created_by','JOSM'),(51930542,1,'created_by','JOSM'),(51930544,1,'created_by','JOSM'),(51930548,1,'created_by','JOSM'),(51930553,1,'created_by','JOSM'),(51930556,1,'created_by','JOSM'),(51930560,1,'created_by','JOSM'),(51930563,1,'created_by','JOSM'),(51930565,1,'created_by','JOSM'),(51930567,1,'created_by','JOSM'),(51930569,1,'created_by','JOSM'),(51930572,1,'created_by','JOSM'),(51930573,1,'created_by','JOSM'),(51930576,1,'created_by','JOSM'),(51930579,1,'created_by','JOSM'),(51930582,1,'created_by','JOSM'),(51930583,1,'created_by','JOSM'),(51930586,1,'created_by','JOSM'),(51930588,1,'created_by','JOSM'),(51930590,1,'created_by','JOSM'),(51930593,1,'created_by','JOSM'),(51930595,1,'created_by','JOSM'),(51930597,1,'created_by','JOSM'),(51930599,1,'created_by','JOSM'),(51930602,1,'created_by','JOSM'),(51930604,1,'created_by','JOSM'),(51930606,1,'created_by','JOSM'),(51930609,1,'created_by','JOSM'),(51930611,1,'created_by','JOSM'),(51930614,1,'created_by','JOSM'),(51930616,1,'created_by','JOSM'),(51930619,1,'created_by','JOSM'),(51930621,1,'created_by','JOSM'),(51930623,1,'created_by','JOSM'),(51930626,1,'created_by','JOSM'),(51930628,1,'created_by','JOSM'),(51930630,1,'created_by','JOSM'),(51930633,1,'created_by','JOSM'),(51930636,1,'created_by','JOSM'),(51930638,1,'created_by','JOSM'),(51930640,1,'created_by','JOSM'),(51930641,1,'created_by','JOSM'),(51930643,1,'created_by','JOSM'),(51930645,1,'created_by','JOSM'),(51930648,2,'created_by','JOSM'),(51930650,2,'created_by','JOSM'),(51930652,1,'created_by','JOSM'),(51930653,1,'created_by','JOSM'),(51930656,1,'created_by','JOSM'),(51930657,1,'created_by','JOSM'),(51930661,1,'created_by','JOSM'),(51930663,1,'created_by','JOSM'),(51930665,1,'created_by','JOSM'),(51930668,1,'created_by','JOSM'),(51930671,1,'created_by','JOSM'),(51930674,1,'created_by','JOSM'),(51930676,1,'created_by','JOSM'),(51930680,1,'created_by','JOSM'),(51930682,1,'created_by','JOSM'),(51930684,1,'created_by','JOSM'),(51930686,1,'created_by','JOSM'),(51930687,1,'created_by','JOSM'),(51930689,1,'created_by','JOSM'),(51930691,1,'created_by','JOSM'),(51930692,1,'created_by','JOSM'),(51930695,1,'created_by','JOSM'),(51930697,1,'created_by','JOSM'),(51930699,1,'created_by','JOSM'),(51930702,1,'created_by','JOSM'),(51930705,1,'created_by','JOSM'),(51930706,1,'created_by','JOSM'),(51930709,1,'created_by','JOSM'),(51930712,1,'created_by','JOSM'),(51930713,1,'created_by','JOSM'),(51930716,1,'created_by','JOSM'),(51930718,1,'created_by','JOSM'),(51930721,1,'created_by','JOSM'),(51930723,1,'created_by','JOSM'),(51930726,1,'created_by','JOSM'),(51930727,1,'created_by','JOSM'),(51930729,1,'created_by','JOSM'),(51930731,1,'created_by','JOSM'),(51930732,1,'created_by','JOSM'),(51930734,1,'created_by','JOSM'),(51930736,1,'created_by','JOSM'),(51930738,1,'created_by','JOSM'),(51930741,1,'created_by','JOSM'),(51930743,1,'created_by','JOSM'),(51930745,1,'created_by','JOSM'),(51930748,1,'created_by','JOSM'),(51930750,1,'created_by','JOSM'),(51930751,1,'created_by','JOSM'),(51930754,1,'created_by','JOSM'),(51930756,1,'created_by','JOSM'),(51930758,1,'created_by','JOSM'),(51930761,1,'created_by','JOSM'),(51930762,1,'created_by','JOSM'),(51930765,1,'created_by','JOSM'),(51930768,1,'created_by','JOSM'),(51930769,1,'created_by','JOSM'),(51930771,1,'created_by','JOSM'),(51930775,1,'created_by','JOSM'),(51930777,1,'created_by','JOSM'),(51930779,1,'created_by','JOSM'),(51930781,1,'created_by','JOSM'),(51930783,1,'created_by','JOSM'),(51930786,1,'created_by','JOSM'),(51930788,1,'created_by','JOSM'),(51930790,1,'created_by','JOSM'),(51930793,1,'created_by','JOSM'),(51930794,1,'created_by','JOSM'),(51930797,1,'created_by','JOSM'),(51930800,1,'created_by','JOSM'),(51930802,1,'created_by','JOSM'),(51930806,1,'created_by','JOSM'),(51930807,1,'created_by','JOSM'),(51930808,1,'created_by','JOSM'),(51930809,1,'created_by','JOSM'),(51930812,1,'created_by','JOSM'),(51930814,1,'created_by','JOSM'),(51930815,1,'created_by','JOSM'),(51930816,1,'created_by','JOSM'),(51930818,1,'created_by','JOSM'),(51930821,1,'created_by','JOSM'),(51930823,1,'created_by','JOSM'),(51930826,1,'created_by','JOSM'),(51930828,1,'created_by','JOSM'),(51930830,1,'created_by','JOSM'),(51930831,1,'created_by','JOSM'),(51930834,1,'created_by','JOSM'),(51930836,1,'created_by','JOSM'),(51930839,1,'created_by','JOSM'),(51930840,1,'created_by','JOSM'),(51930843,1,'created_by','JOSM'),(51930844,1,'created_by','JOSM'),(51930847,1,'created_by','JOSM'),(51930850,1,'created_by','JOSM'),(51930851,1,'created_by','JOSM'),(51930854,1,'created_by','JOSM'),(51930855,1,'created_by','JOSM'),(51930858,1,'created_by','JOSM'),(51930859,1,'created_by','JOSM'),(51930862,1,'created_by','JOSM'),(51930864,1,'created_by','JOSM'),(51930865,1,'created_by','JOSM'),(51930866,1,'created_by','JOSM'),(51930867,1,'created_by','JOSM'),(51930869,1,'created_by','JOSM'),(51930871,1,'created_by','JOSM'),(51930873,1,'created_by','JOSM'),(51930876,1,'created_by','JOSM'),(51930879,1,'created_by','JOSM'),(51930882,1,'created_by','JOSM'),(51930883,1,'created_by','JOSM'),(51930885,1,'created_by','JOSM'),(51930887,1,'created_by','JOSM'),(51930889,1,'created_by','JOSM'),(51930891,1,'created_by','JOSM'),(51930893,1,'created_by','JOSM'),(51930895,1,'created_by','JOSM'),(51930896,1,'created_by','JOSM'),(51930898,1,'created_by','JOSM'),(51930900,1,'created_by','JOSM'),(51930901,1,'created_by','JOSM'),(51930905,1,'created_by','JOSM'),(51930907,1,'created_by','JOSM'),(51930908,1,'created_by','JOSM'),(51930909,1,'created_by','JOSM'),(51930911,1,'created_by','JOSM'),(51930913,1,'created_by','JOSM'),(51930915,1,'created_by','JOSM'),(51930918,1,'created_by','JOSM'),(51930920,1,'created_by','JOSM'),(51930923,1,'created_by','JOSM'),(51930926,1,'created_by','JOSM'),(51930928,1,'created_by','JOSM'),(51930930,1,'created_by','JOSM'),(51930932,1,'created_by','JOSM'),(51930935,1,'created_by','JOSM'),(51930937,1,'created_by','JOSM'),(51930940,1,'created_by','JOSM'),(51930942,1,'created_by','JOSM'),(51930944,1,'created_by','JOSM'),(51930947,1,'created_by','JOSM'),(51930950,1,'created_by','JOSM'),(51930952,1,'created_by','JOSM'),(51930953,1,'created_by','JOSM'),(51930954,1,'created_by','JOSM'),(51930956,1,'created_by','JOSM'),(51930958,1,'created_by','JOSM'),(51930961,1,'created_by','JOSM'),(51930962,1,'created_by','JOSM'),(51930965,1,'created_by','JOSM'),(51930967,1,'created_by','JOSM'),(51930968,1,'created_by','JOSM'),(51930971,1,'created_by','JOSM'),(51930973,1,'created_by','JOSM'),(51930974,1,'created_by','JOSM'),(51930975,1,'created_by','JOSM'),(51930976,1,'created_by','JOSM'),(51930978,1,'created_by','JOSM'),(51930981,1,'created_by','JOSM'),(51930983,1,'created_by','JOSM'),(51930984,1,'created_by','JOSM'),(51930985,1,'created_by','JOSM'),(51930986,1,'created_by','JOSM'),(51930987,1,'created_by','JOSM'),(51930990,1,'created_by','JOSM'),(51930992,1,'created_by','JOSM'),(51930995,1,'created_by','JOSM'),(51930998,1,'created_by','JOSM'),(51930999,1,'created_by','JOSM'),(51931002,1,'created_by','JOSM'),(51931005,1,'created_by','JOSM'),(51931006,1,'created_by','JOSM'),(51931009,1,'created_by','JOSM'),(51931012,1,'created_by','JOSM'),(51931014,1,'created_by','JOSM'),(51931018,1,'created_by','JOSM'),(51931020,1,'created_by','JOSM'),(51931023,1,'created_by','JOSM'),(51931025,1,'created_by','JOSM'),(51931026,1,'created_by','JOSM'),(51931029,1,'created_by','JOSM'),(51931032,1,'created_by','JOSM'),(51931036,1,'created_by','JOSM'),(51931037,1,'created_by','JOSM'),(51931040,1,'created_by','JOSM'),(51931043,1,'created_by','JOSM'),(51931045,1,'created_by','JOSM'),(51931047,1,'created_by','JOSM'),(51931050,1,'created_by','JOSM'),(51931053,1,'created_by','JOSM'),(51931055,1,'created_by','JOSM'),(51931057,1,'created_by','JOSM'),(51931060,1,'created_by','JOSM'),(51931062,1,'created_by','JOSM'),(51931065,1,'created_by','JOSM'),(51931066,1,'created_by','JOSM'),(51931069,1,'created_by','JOSM'),(51931070,1,'created_by','JOSM'),(51931073,1,'created_by','JOSM'),(51931076,1,'created_by','JOSM'),(51931077,1,'created_by','JOSM'),(51931080,1,'created_by','JOSM'),(51931084,1,'created_by','JOSM'),(51931087,1,'created_by','JOSM'),(51931090,1,'created_by','JOSM'),(51931093,1,'created_by','JOSM'),(51931095,1,'created_by','JOSM'),(51931097,1,'created_by','JOSM'),(51931099,1,'created_by','JOSM'),(51931101,1,'created_by','JOSM'),(51931103,1,'created_by','JOSM'),(51931105,1,'created_by','JOSM'),(51951640,1,'created_by','JOSM'),(51951645,1,'created_by','JOSM'),(51951647,1,'created_by','JOSM'),(51951648,1,'created_by','JOSM'),(51951650,1,'created_by','JOSM'),(51951652,1,'created_by','JOSM'),(51951654,1,'created_by','JOSM'),(51951657,1,'created_by','JOSM'),(51951658,1,'created_by','JOSM'),(51951661,1,'created_by','JOSM'),(51951665,1,'created_by','JOSM'),(51951667,1,'created_by','JOSM'),(51951670,1,'created_by','JOSM'),(51951673,1,'created_by','JOSM'),(51951676,1,'created_by','JOSM'),(51951678,1,'created_by','JOSM'),(51951680,1,'created_by','JOSM'),(51951682,1,'created_by','JOSM'),(51951684,1,'created_by','JOSM'),(51951686,1,'created_by','JOSM'),(51951689,1,'created_by','JOSM'),(51951690,1,'created_by','JOSM'),(51951692,1,'created_by','JOSM'),(51951694,1,'created_by','JOSM'),(51951696,1,'created_by','JOSM'),(51951700,1,'created_by','JOSM'),(51951701,1,'created_by','JOSM'),(51951703,1,'created_by','JOSM'),(51951706,1,'created_by','JOSM'),(51951709,1,'created_by','JOSM'),(51951711,1,'created_by','JOSM'),(51951713,1,'created_by','JOSM'),(51951716,1,'created_by','JOSM'),(51951719,1,'created_by','JOSM'),(51951723,1,'created_by','JOSM'),(51951726,1,'created_by','JOSM'),(51951729,1,'created_by','JOSM'),(51951731,1,'created_by','JOSM'),(51951734,1,'created_by','JOSM'),(51951736,1,'created_by','JOSM'),(51951739,1,'created_by','JOSM'),(51951741,1,'created_by','JOSM'),(51951744,1,'created_by','JOSM'),(51951747,1,'created_by','JOSM'),(51951748,1,'created_by','JOSM'),(51951751,1,'created_by','JOSM'),(51951755,1,'created_by','JOSM'),(51951758,1,'created_by','JOSM'),(51951761,1,'created_by','JOSM'),(51951763,1,'created_by','JOSM'),(51951766,1,'created_by','JOSM'),(51951769,1,'created_by','JOSM'),(51951772,1,'created_by','JOSM'),(51951775,1,'created_by','JOSM'),(51951777,1,'created_by','JOSM'),(51951780,1,'created_by','JOSM'),(51951784,1,'created_by','JOSM'),(51951785,1,'created_by','JOSM'),(51951788,1,'created_by','JOSM'),(51951790,1,'created_by','JOSM'),(51951793,1,'created_by','JOSM'),(51951796,1,'created_by','JOSM'),(51951799,1,'created_by','JOSM'),(51951801,1,'created_by','JOSM'),(51951805,1,'created_by','JOSM'),(51951808,1,'created_by','JOSM'),(51951810,1,'created_by','JOSM'),(51951813,1,'created_by','JOSM'),(51951816,1,'created_by','JOSM'),(51951817,1,'created_by','JOSM'),(51951819,1,'created_by','JOSM'),(51951821,1,'created_by','JOSM'),(51951824,1,'created_by','JOSM'),(51951827,1,'created_by','JOSM'),(51951830,1,'created_by','JOSM'),(51951833,1,'created_by','JOSM'),(51951836,1,'created_by','JOSM'),(51951838,1,'created_by','JOSM'),(51951840,1,'created_by','JOSM'),(51951843,1,'created_by','JOSM'),(51951846,1,'created_by','JOSM'),(51951848,1,'created_by','JOSM'),(51951851,1,'created_by','JOSM'),(51951854,1,'created_by','JOSM'),(51951857,1,'created_by','JOSM'),(51951858,1,'created_by','JOSM'),(51951859,1,'created_by','JOSM'),(51951861,1,'created_by','JOSM'),(51951864,1,'created_by','JOSM'),(51951865,1,'created_by','JOSM'),(51951868,1,'created_by','JOSM'),(51951872,1,'created_by','JOSM'),(51951874,1,'created_by','JOSM'),(51951876,1,'created_by','JOSM'),(51951879,1,'created_by','JOSM'),(51951882,1,'created_by','JOSM'),(51951885,1,'created_by','JOSM'),(51951886,1,'created_by','JOSM'),(51951889,1,'created_by','JOSM'),(51951892,1,'created_by','JOSM'),(51951895,1,'created_by','JOSM'),(51951898,1,'created_by','JOSM'),(51951900,1,'created_by','JOSM'),(51951903,1,'created_by','JOSM'),(51951905,1,'created_by','JOSM'),(51951908,1,'created_by','JOSM'),(51951911,1,'created_by','JOSM'),(51951914,1,'created_by','JOSM'),(51951917,1,'created_by','JOSM'),(51951920,1,'created_by','JOSM'),(51951922,1,'created_by','JOSM'),(51951924,1,'created_by','JOSM'),(51951927,1,'created_by','JOSM'),(51951930,1,'created_by','JOSM'),(51951933,1,'created_by','JOSM'),(51951935,1,'created_by','JOSM'),(51951937,1,'created_by','JOSM'),(51951938,1,'created_by','JOSM'),(51951941,1,'created_by','JOSM'),(51951944,1,'created_by','JOSM'),(51951947,1,'created_by','JOSM'),(51951950,1,'created_by','JOSM'),(51951953,1,'created_by','JOSM'),(51951956,1,'created_by','JOSM'),(51951957,1,'created_by','JOSM'),(51951960,1,'created_by','JOSM'),(51951963,1,'created_by','JOSM'),(51951965,1,'created_by','JOSM'),(51951966,1,'created_by','JOSM'),(51951969,1,'created_by','JOSM'),(51951970,1,'created_by','JOSM'),(51951973,1,'created_by','JOSM'),(51951975,1,'created_by','JOSM'),(51951978,1,'created_by','JOSM'),(51951980,1,'created_by','JOSM'),(51951983,1,'created_by','JOSM'),(51951985,1,'created_by','JOSM'),(51951988,1,'created_by','JOSM'),(51951989,1,'created_by','JOSM'),(51951992,1,'created_by','JOSM'),(51951995,1,'created_by','JOSM'),(51951999,1,'created_by','JOSM'),(51952002,1,'created_by','JOSM'),(51952005,1,'created_by','JOSM'),(51952009,1,'created_by','JOSM'),(51952013,1,'created_by','JOSM'),(51952014,1,'created_by','JOSM'),(51952017,1,'created_by','JOSM'),(51952019,1,'created_by','JOSM'),(51952022,1,'created_by','JOSM'),(51952025,1,'created_by','JOSM'),(51952028,1,'created_by','JOSM'),(51952029,1,'created_by','JOSM'),(51952031,1,'created_by','JOSM'),(51952034,1,'created_by','JOSM'),(51952037,1,'created_by','JOSM'),(51952039,1,'created_by','JOSM'),(51952042,1,'created_by','JOSM'),(51952045,1,'created_by','JOSM'),(51952046,1,'created_by','JOSM'),(51952048,1,'created_by','JOSM'),(51952050,1,'created_by','JOSM'),(51952053,1,'created_by','JOSM'),(51952055,1,'created_by','JOSM'),(51952058,1,'created_by','JOSM'),(51952060,1,'created_by','JOSM'),(51952063,1,'created_by','JOSM'),(51952065,1,'created_by','JOSM'),(51952068,1,'created_by','JOSM'),(51952069,1,'created_by','JOSM'),(51952073,1,'created_by','JOSM'),(51952075,1,'created_by','JOSM'),(51952078,1,'created_by','JOSM'),(51952080,1,'created_by','JOSM'),(51952083,1,'created_by','JOSM'),(51952084,1,'created_by','JOSM'),(51952087,1,'created_by','JOSM'),(51952090,1,'created_by','JOSM'),(51952093,1,'created_by','JOSM'),(51952096,1,'created_by','JOSM'),(51952099,1,'created_by','JOSM'),(51952101,1,'created_by','JOSM'),(51952103,1,'created_by','JOSM'),(51952105,1,'created_by','JOSM'),(51952107,1,'created_by','JOSM'),(51952110,1,'created_by','JOSM'),(51952111,1,'created_by','JOSM'),(51952113,1,'created_by','JOSM'),(51952115,1,'created_by','JOSM'),(51952118,1,'created_by','JOSM'),(51952120,1,'created_by','JOSM'),(51952122,1,'created_by','JOSM'),(51952125,1,'created_by','JOSM'),(51952126,1,'created_by','JOSM'),(51952128,1,'created_by','JOSM'),(51952132,1,'created_by','JOSM'),(51952136,1,'created_by','JOSM'),(51952139,1,'created_by','JOSM'),(51952141,1,'created_by','JOSM'),(51952145,1,'created_by','JOSM'),(51952148,1,'created_by','JOSM'),(51952150,1,'created_by','JOSM'),(51952152,1,'created_by','JOSM'),(51952155,1,'created_by','JOSM'),(51952157,1,'created_by','JOSM'),(51952159,1,'created_by','JOSM'),(51952161,1,'created_by','JOSM'),(51952163,1,'created_by','JOSM'),(51952167,1,'created_by','JOSM'),(51952170,1,'created_by','JOSM'),(51952172,1,'created_by','JOSM'),(51952176,1,'created_by','JOSM'),(51952177,1,'created_by','JOSM'),(51952180,1,'created_by','JOSM'),(51952183,1,'created_by','JOSM'),(51952185,1,'created_by','JOSM'),(51952187,1,'created_by','JOSM'),(51952190,1,'created_by','JOSM'),(51952192,1,'created_by','JOSM'),(51952193,1,'created_by','JOSM'),(51952195,1,'created_by','JOSM'),(51952196,1,'created_by','JOSM'),(51952199,1,'created_by','JOSM'),(51952201,1,'created_by','JOSM'),(51952204,1,'created_by','JOSM'),(51952205,1,'created_by','JOSM'),(51952207,1,'created_by','JOSM'),(51952210,1,'created_by','JOSM'),(51952213,1,'created_by','JOSM'),(51952215,1,'created_by','JOSM'),(51952217,1,'created_by','JOSM'),(51952220,1,'created_by','JOSM'),(51952223,1,'created_by','JOSM'),(51952226,1,'created_by','JOSM'),(51952230,1,'created_by','JOSM'),(51952233,1,'created_by','JOSM'),(51952236,1,'created_by','JOSM'),(51952238,1,'created_by','JOSM'),(51952240,1,'created_by','JOSM'),(51952243,1,'created_by','JOSM'),(51952246,1,'created_by','JOSM'),(51952248,1,'created_by','JOSM'),(51952250,1,'created_by','JOSM'),(51952252,1,'created_by','JOSM'),(51952255,1,'created_by','JOSM'),(51952256,1,'created_by','JOSM'),(51952259,1,'created_by','JOSM'),(51952530,1,'created_by','JOSM'),(51952532,1,'created_by','JOSM'),(51952534,1,'created_by','JOSM'),(51952536,1,'created_by','JOSM'),(51952539,1,'created_by','JOSM'),(51952542,1,'created_by','JOSM'),(51952545,1,'created_by','JOSM'),(51952546,1,'created_by','JOSM'),(51952549,1,'created_by','JOSM'),(51952552,1,'created_by','JOSM'),(51952556,1,'created_by','JOSM'),(51952559,1,'created_by','JOSM'),(51952562,1,'created_by','JOSM'),(51952566,1,'created_by','JOSM'),(51952570,1,'created_by','JOSM'),(51952573,1,'created_by','JOSM'),(51952575,1,'created_by','JOSM'),(51952578,1,'created_by','JOSM'),(51952580,1,'created_by','JOSM'),(51952583,1,'created_by','JOSM'),(51952584,1,'created_by','JOSM'),(51952586,1,'created_by','JOSM'),(51952590,1,'created_by','JOSM'),(51952594,1,'created_by','JOSM'),(51952597,1,'created_by','JOSM'),(51952599,1,'created_by','JOSM'),(51952601,1,'created_by','JOSM'),(51952604,1,'created_by','JOSM'),(51952605,1,'created_by','JOSM'),(51952608,1,'created_by','JOSM'),(51952610,1,'created_by','JOSM'),(51952613,1,'created_by','JOSM'),(51952615,1,'created_by','JOSM'),(51952618,1,'created_by','JOSM'),(51952620,1,'created_by','JOSM'),(51952623,1,'created_by','JOSM'),(51952627,1,'created_by','JOSM'),(51952630,1,'created_by','JOSM'),(51952632,1,'created_by','JOSM'),(51952634,1,'created_by','JOSM'),(51952635,1,'created_by','JOSM'),(51952638,1,'created_by','JOSM'),(51952640,1,'created_by','JOSM'),(51952643,1,'created_by','JOSM'),(51952647,1,'created_by','JOSM'),(51952649,1,'created_by','JOSM'),(51952652,1,'created_by','JOSM'),(51952653,1,'created_by','JOSM'),(51952656,1,'created_by','JOSM'),(51952659,1,'created_by','JOSM'),(51952662,1,'created_by','JOSM'),(51952665,1,'created_by','JOSM'),(51952667,1,'created_by','JOSM'),(51952668,1,'created_by','JOSM'),(51952671,1,'created_by','JOSM'),(51952672,1,'created_by','JOSM'),(51952675,1,'created_by','JOSM'),(51952677,1,'created_by','JOSM'),(51952682,1,'created_by','JOSM'),(51952684,1,'created_by','JOSM'),(51952686,1,'created_by','JOSM'),(51952689,1,'created_by','JOSM'),(51952690,1,'created_by','JOSM'),(51952692,1,'created_by','JOSM'),(51952694,1,'created_by','JOSM'),(51952695,1,'created_by','JOSM'),(51952699,1,'created_by','JOSM'),(51952701,1,'created_by','JOSM'),(51952702,1,'created_by','JOSM'),(51952705,1,'created_by','JOSM'),(51952706,1,'created_by','JOSM'),(51952709,1,'created_by','JOSM'),(51952712,1,'created_by','JOSM'),(51952714,1,'created_by','JOSM'),(51952715,1,'created_by','JOSM'),(51952717,1,'created_by','JOSM'),(51952719,1,'created_by','JOSM'),(51952722,1,'created_by','JOSM'),(51952724,1,'created_by','JOSM'),(51952727,1,'created_by','JOSM'),(51952729,1,'created_by','JOSM'),(51952732,1,'created_by','JOSM'),(51952733,1,'created_by','JOSM'),(51952737,1,'created_by','JOSM'),(51952740,1,'created_by','JOSM'),(51952742,1,'created_by','JOSM'),(51952745,1,'created_by','JOSM'),(51952748,1,'created_by','JOSM'),(51952751,1,'created_by','JOSM'),(51952754,1,'created_by','JOSM'),(51952756,1,'created_by','JOSM'),(51952758,1,'created_by','JOSM'),(51952761,1,'created_by','JOSM'),(51952764,1,'created_by','JOSM'),(51952767,1,'created_by','JOSM'),(51952770,1,'created_by','JOSM'),(51952772,1,'created_by','JOSM'),(51952775,1,'created_by','JOSM'),(51952777,1,'created_by','JOSM'),(51952780,1,'created_by','JOSM'),(51952782,1,'created_by','JOSM'),(51952784,1,'created_by','JOSM'),(51952786,1,'created_by','JOSM'),(51952788,1,'created_by','JOSM'),(51952790,1,'created_by','JOSM'),(51952792,1,'created_by','JOSM'),(51952795,1,'created_by','JOSM'),(51952797,1,'created_by','JOSM'),(51952800,1,'created_by','JOSM'),(51952802,1,'created_by','JOSM'),(51952804,1,'created_by','JOSM'),(51952807,1,'created_by','JOSM'),(51952811,1,'created_by','JOSM'),(51952813,1,'created_by','JOSM'),(51952815,1,'created_by','JOSM'),(51952818,1,'created_by','JOSM'),(51952820,1,'created_by','JOSM'),(51952824,1,'created_by','JOSM'),(51952827,1,'created_by','JOSM'),(51952829,1,'created_by','JOSM'),(51952831,1,'created_by','JOSM'),(51952832,1,'created_by','JOSM'),(51952834,1,'created_by','JOSM'),(51952837,1,'created_by','JOSM'),(51952840,1,'created_by','JOSM'),(51952842,1,'created_by','JOSM'),(51956993,1,'created_by','JOSM'),(51956997,1,'created_by','JOSM'),(51956999,1,'created_by','JOSM'),(51957002,1,'created_by','JOSM'),(51957005,1,'created_by','JOSM'),(51957008,1,'created_by','JOSM'),(51957009,1,'created_by','JOSM'),(51957013,1,'created_by','JOSM'),(51957016,1,'created_by','JOSM'),(51957020,1,'created_by','JOSM'),(51957022,1,'created_by','JOSM'),(51957024,1,'created_by','JOSM'),(51957025,1,'created_by','JOSM'),(51957027,1,'created_by','JOSM'),(51957030,1,'created_by','JOSM'),(51957031,1,'created_by','JOSM'),(51957034,1,'created_by','JOSM'),(51957037,1,'created_by','JOSM'),(51957040,1,'created_by','JOSM'),(51957042,1,'created_by','JOSM'),(51957045,1,'created_by','JOSM'),(51957048,1,'created_by','JOSM'),(51957050,1,'created_by','JOSM'),(51957052,1,'created_by','JOSM'),(51957055,1,'created_by','JOSM'),(51957057,1,'created_by','JOSM'),(51957060,1,'created_by','JOSM'),(51957063,1,'created_by','JOSM'),(51957064,1,'created_by','JOSM'),(51957066,1,'created_by','JOSM'),(51957069,1,'created_by','JOSM'),(51957072,1,'created_by','JOSM'),(51957075,1,'created_by','JOSM'),(51957077,1,'created_by','JOSM'),(51957080,1,'created_by','JOSM'),(51957082,1,'created_by','JOSM'),(51957085,1,'created_by','JOSM'),(51957087,1,'created_by','JOSM'),(51957090,1,'created_by','JOSM'),(51957092,1,'created_by','JOSM'),(51957094,1,'created_by','JOSM'),(51957098,1,'created_by','JOSM'),(51957101,1,'created_by','JOSM'),(51957103,1,'created_by','JOSM'),(51957105,1,'created_by','JOSM'),(51957110,1,'created_by','JOSM'),(51957112,1,'created_by','JOSM'),(51957115,1,'created_by','JOSM'),(51957117,1,'created_by','JOSM'),(51957119,1,'created_by','JOSM'),(51957121,1,'created_by','JOSM'),(51957125,1,'created_by','JOSM'),(51957128,1,'created_by','JOSM'),(51957131,1,'created_by','JOSM'),(51957134,1,'created_by','JOSM'),(51957135,1,'created_by','JOSM'),(51957138,1,'created_by','JOSM'),(51957141,1,'created_by','JOSM'),(51957143,1,'created_by','JOSM'),(51957144,1,'created_by','JOSM'),(51957146,1,'created_by','JOSM'),(51957147,1,'created_by','JOSM'),(51957151,1,'created_by','JOSM'),(51957153,1,'created_by','JOSM'),(51957155,1,'created_by','JOSM'),(51957157,1,'created_by','JOSM'),(51957160,1,'created_by','JOSM'),(51957162,1,'created_by','JOSM'),(51957164,1,'created_by','JOSM'),(51957166,1,'created_by','JOSM'),(51957168,1,'created_by','JOSM'),(51957170,1,'created_by','JOSM'),(51957172,1,'created_by','JOSM'),(51957174,1,'created_by','JOSM'),(51972980,1,'created_by','JOSM'),(51972984,1,'created_by','JOSM'),(51972990,1,'created_by','JOSM'),(51972993,1,'created_by','JOSM'),(51972999,1,'created_by','JOSM'),(51973000,1,'created_by','JOSM'),(51973004,1,'created_by','JOSM'),(51973007,1,'created_by','JOSM'),(51973010,1,'created_by','JOSM'),(51973014,1,'created_by','JOSM'),(51973017,1,'created_by','JOSM'),(51973021,1,'created_by','JOSM'),(51973026,1,'created_by','JOSM'),(51973027,1,'created_by','JOSM'),(51973030,1,'created_by','JOSM'),(51973033,2,'created_by','JOSM'),(51973038,1,'created_by','JOSM'),(51973045,1,'created_by','JOSM'),(51973049,1,'created_by','JOSM'),(51973052,1,'created_by','JOSM'),(51973055,1,'created_by','JOSM'),(51973058,1,'created_by','JOSM'),(51973061,1,'created_by','JOSM'),(51973066,1,'created_by','JOSM'),(51973069,1,'created_by','JOSM'),(51973073,1,'created_by','JOSM'),(51973078,1,'created_by','JOSM'),(51973082,1,'created_by','JOSM'),(51973084,1,'created_by','JOSM'),(51973088,1,'created_by','JOSM'),(51973091,1,'created_by','JOSM'),(51973096,1,'created_by','JOSM'),(51973099,1,'created_by','JOSM'),(51973102,1,'created_by','JOSM'),(51973105,1,'created_by','JOSM'),(51973108,1,'created_by','JOSM'),(51973112,1,'created_by','JOSM'),(51973113,1,'created_by','JOSM'),(51973117,1,'created_by','JOSM'),(51973120,1,'created_by','JOSM'),(51973122,1,'created_by','JOSM'),(51973128,1,'created_by','JOSM'),(51973131,1,'created_by','JOSM'),(51973135,1,'created_by','JOSM'),(51973138,1,'created_by','JOSM'),(51973141,1,'created_by','JOSM'),(51973144,1,'created_by','JOSM'),(51973147,1,'created_by','JOSM'),(51973150,1,'created_by','JOSM'),(51973154,1,'created_by','JOSM'),(51973156,1,'created_by','JOSM'),(51973158,1,'created_by','JOSM'),(51973161,1,'created_by','JOSM'),(51973163,1,'created_by','JOSM'),(51973166,1,'created_by','JOSM'),(51973170,1,'created_by','JOSM'),(51973172,1,'created_by','JOSM'),(51973175,1,'created_by','JOSM'),(51973177,1,'created_by','JOSM'),(51973179,1,'created_by','JOSM'),(51973183,1,'created_by','JOSM'),(51973186,1,'created_by','JOSM'),(51973190,1,'created_by','JOSM'),(51973193,1,'created_by','JOSM'),(51973196,1,'created_by','JOSM'),(51973198,1,'created_by','JOSM'),(51973201,1,'created_by','JOSM'),(51973203,1,'created_by','JOSM'),(51973206,1,'created_by','JOSM'),(51973208,1,'created_by','JOSM'),(51973210,1,'created_by','JOSM'),(51973213,1,'created_by','JOSM'),(51973215,1,'created_by','JOSM'),(51973219,1,'created_by','JOSM'),(51973221,1,'created_by','JOSM'),(51973223,1,'created_by','JOSM'),(51973225,1,'created_by','JOSM'),(51973228,1,'created_by','JOSM'),(51973234,1,'created_by','JOSM'),(51973237,1,'created_by','JOSM'),(51973241,1,'created_by','JOSM'),(51973243,1,'created_by','JOSM'),(51973247,1,'created_by','JOSM'),(51973249,1,'created_by','JOSM'),(51973253,1,'created_by','JOSM'),(51973256,1,'created_by','JOSM'),(51973260,1,'created_by','JOSM'),(51973264,1,'created_by','JOSM'),(51973268,1,'created_by','JOSM'),(51973269,1,'created_by','JOSM'),(51973273,1,'created_by','JOSM'),(51973276,1,'created_by','JOSM'),(51973278,1,'created_by','JOSM'),(51973281,1,'created_by','JOSM'),(51973284,1,'created_by','JOSM'),(51973287,1,'created_by','JOSM'),(51973290,1,'created_by','JOSM'),(51973293,1,'created_by','JOSM'),(51973296,1,'created_by','JOSM'),(51973300,1,'created_by','JOSM'),(51973302,1,'created_by','JOSM'),(51973306,1,'created_by','JOSM'),(51973310,1,'created_by','JOSM'),(51973313,1,'created_by','JOSM'),(51973316,1,'created_by','JOSM'),(51973320,1,'created_by','JOSM'),(51973324,1,'created_by','JOSM'),(51973326,1,'created_by','JOSM'),(51973327,1,'created_by','JOSM'),(51973329,1,'created_by','JOSM'),(51973334,1,'created_by','JOSM'),(51973336,1,'created_by','JOSM'),(51973339,1,'created_by','JOSM'),(51973341,1,'created_by','JOSM'),(51973344,1,'created_by','JOSM'),(51973346,1,'created_by','JOSM'),(51973348,1,'created_by','JOSM'),(51973351,1,'created_by','JOSM'),(51973352,1,'created_by','JOSM'),(51973353,1,'created_by','JOSM'),(51973354,1,'created_by','JOSM'),(51973356,1,'created_by','JOSM'),(51973357,1,'created_by','JOSM');
INSERT INTO `node_tags` VALUES (51973359,1,'created_by','JOSM'),(51973361,1,'created_by','JOSM'),(51973362,1,'created_by','JOSM'),(51973363,1,'created_by','JOSM'),(51973364,1,'created_by','JOSM'),(51973366,1,'created_by','JOSM'),(51973369,1,'created_by','JOSM'),(51973370,1,'created_by','JOSM'),(51973373,1,'created_by','JOSM'),(51973375,1,'created_by','JOSM'),(51973378,1,'created_by','JOSM'),(51973380,1,'created_by','JOSM'),(51973384,1,'created_by','JOSM'),(51973387,1,'created_by','JOSM'),(51973390,1,'created_by','JOSM'),(51973394,1,'created_by','JOSM'),(51973396,1,'created_by','JOSM'),(51973398,1,'created_by','JOSM'),(51973400,1,'created_by','JOSM'),(51973403,1,'created_by','JOSM'),(51973405,1,'created_by','JOSM'),(51973407,1,'created_by','JOSM'),(51973409,1,'created_by','JOSM'),(51973413,1,'created_by','JOSM'),(51973416,1,'created_by','JOSM'),(51973417,1,'created_by','JOSM'),(51973419,1,'created_by','JOSM'),(51973424,1,'created_by','JOSM'),(51973426,1,'created_by','JOSM'),(51973428,1,'created_by','JOSM'),(51973430,1,'created_by','JOSM'),(51973432,1,'created_by','JOSM'),(51973436,1,'created_by','JOSM'),(51973439,1,'created_by','JOSM'),(51973441,1,'created_by','JOSM'),(51973444,1,'created_by','JOSM'),(51973448,1,'created_by','JOSM'),(51973451,1,'created_by','JOSM'),(51973454,1,'created_by','JOSM'),(51973456,1,'created_by','JOSM'),(51973459,1,'created_by','JOSM'),(51973462,1,'created_by','JOSM'),(51973467,1,'created_by','JOSM'),(51973470,1,'created_by','JOSM'),(51973471,1,'created_by','JOSM'),(51973475,1,'created_by','JOSM'),(51973478,1,'created_by','JOSM'),(51973481,1,'created_by','JOSM'),(51973484,1,'created_by','JOSM'),(51973487,1,'created_by','JOSM'),(51973489,1,'created_by','JOSM'),(51973491,1,'created_by','JOSM'),(51973494,1,'created_by','JOSM'),(51973497,1,'created_by','JOSM'),(51973499,1,'created_by','JOSM'),(51973504,1,'created_by','JOSM'),(51973507,1,'created_by','JOSM'),(51973511,1,'created_by','JOSM'),(51973514,1,'created_by','JOSM'),(51973516,1,'created_by','JOSM'),(51973519,1,'created_by','JOSM'),(51973521,1,'created_by','JOSM'),(51973523,1,'created_by','JOSM'),(51973526,1,'created_by','JOSM'),(51973528,1,'created_by','JOSM'),(51973529,1,'created_by','JOSM'),(51973532,1,'created_by','JOSM'),(51973534,1,'created_by','JOSM'),(51973538,1,'created_by','JOSM'),(51973541,1,'created_by','JOSM'),(51973544,1,'created_by','JOSM'),(51973546,1,'created_by','JOSM'),(51973548,1,'created_by','JOSM'),(51973550,1,'created_by','JOSM'),(51973554,1,'created_by','JOSM'),(51973557,1,'created_by','JOSM'),(51973559,1,'created_by','JOSM'),(51973561,1,'created_by','JOSM'),(51973562,1,'created_by','JOSM'),(51973564,1,'created_by','JOSM'),(51973567,1,'created_by','JOSM'),(51973570,1,'created_by','JOSM'),(51973571,1,'created_by','JOSM'),(51973575,1,'created_by','JOSM'),(51973577,1,'created_by','JOSM'),(51973579,1,'created_by','JOSM'),(51973582,1,'created_by','JOSM'),(51973587,1,'created_by','JOSM'),(51973590,1,'created_by','JOSM'),(51973591,1,'created_by','JOSM'),(51973594,1,'created_by','JOSM'),(51973596,1,'created_by','JOSM'),(51973598,1,'created_by','JOSM'),(51973599,1,'created_by','JOSM'),(51973602,1,'created_by','JOSM'),(51973604,1,'created_by','JOSM'),(51973606,1,'created_by','JOSM'),(51973608,1,'created_by','JOSM'),(51973611,1,'created_by','JOSM'),(51973614,1,'created_by','JOSM'),(51973617,1,'created_by','JOSM'),(51973619,1,'created_by','JOSM'),(51973621,1,'created_by','JOSM'),(51973622,1,'created_by','JOSM'),(51973624,1,'created_by','JOSM'),(51973627,1,'created_by','JOSM'),(51973631,1,'created_by','JOSM'),(51973633,1,'created_by','JOSM'),(51973636,1,'created_by','JOSM'),(51973639,1,'created_by','JOSM'),(51973643,1,'created_by','JOSM'),(51973646,1,'created_by','JOSM'),(51973648,1,'created_by','JOSM'),(51973651,1,'created_by','JOSM'),(51973653,1,'created_by','JOSM'),(51973657,1,'created_by','JOSM'),(51973660,1,'created_by','JOSM'),(51973663,1,'created_by','JOSM'),(51973667,1,'created_by','JOSM'),(51973669,1,'created_by','JOSM'),(51973673,1,'created_by','JOSM'),(51973676,1,'created_by','JOSM'),(51973679,1,'created_by','JOSM'),(51973681,1,'created_by','JOSM'),(51973683,1,'created_by','JOSM'),(51973686,1,'created_by','JOSM'),(51973688,1,'created_by','JOSM'),(51973691,1,'created_by','JOSM'),(51973694,1,'created_by','JOSM'),(51973696,1,'created_by','JOSM'),(51973699,1,'created_by','JOSM'),(51973703,1,'created_by','JOSM'),(51973705,1,'created_by','JOSM'),(51973708,1,'created_by','JOSM'),(51973711,1,'created_by','JOSM'),(51973714,1,'created_by','JOSM'),(51973717,1,'created_by','JOSM'),(51973720,1,'created_by','JOSM'),(51973722,1,'created_by','JOSM'),(51973725,1,'created_by','JOSM'),(51973728,1,'created_by','JOSM'),(51973730,1,'created_by','JOSM'),(51973731,1,'created_by','JOSM'),(51973733,1,'created_by','JOSM'),(51973736,1,'created_by','JOSM'),(51973739,1,'created_by','JOSM'),(51973741,1,'created_by','JOSM'),(51973744,1,'created_by','JOSM'),(51973747,1,'created_by','JOSM'),(51973749,1,'created_by','JOSM'),(51973751,1,'created_by','JOSM'),(51973753,1,'created_by','JOSM'),(51973755,1,'created_by','JOSM'),(51973757,1,'created_by','JOSM'),(51973759,1,'created_by','JOSM'),(51973764,1,'created_by','JOSM'),(51973766,1,'created_by','JOSM'),(51973769,1,'created_by','JOSM'),(51973770,1,'created_by','JOSM'),(51973771,1,'created_by','JOSM'),(51973777,1,'created_by','JOSM'),(51973782,1,'created_by','JOSM'),(51973784,1,'created_by','JOSM'),(51973786,1,'created_by','JOSM'),(51973790,1,'created_by','JOSM'),(51973792,1,'created_by','JOSM'),(51973796,1,'created_by','JOSM'),(51973799,1,'created_by','JOSM'),(51973802,1,'created_by','JOSM'),(51973803,1,'created_by','JOSM'),(51973807,1,'created_by','JOSM'),(51973809,1,'created_by','JOSM'),(51973812,1,'created_by','JOSM'),(51973815,1,'created_by','JOSM'),(51973817,1,'created_by','JOSM'),(51973818,1,'created_by','JOSM'),(51973820,1,'created_by','JOSM'),(51973831,1,'created_by','JOSM'),(51973834,1,'created_by','JOSM'),(51973836,1,'created_by','JOSM'),(51973839,1,'created_by','JOSM'),(51973842,1,'created_by','JOSM'),(51973844,1,'created_by','JOSM'),(51973846,1,'created_by','JOSM'),(51973848,1,'created_by','JOSM'),(51973849,1,'created_by','JOSM'),(51973851,1,'created_by','JOSM'),(51973852,1,'created_by','JOSM'),(51973855,1,'created_by','JOSM'),(51973858,1,'created_by','JOSM'),(51973860,1,'created_by','JOSM'),(51973862,1,'created_by','JOSM'),(51973865,1,'created_by','JOSM'),(51973868,1,'created_by','JOSM'),(51973871,1,'created_by','JOSM'),(51973874,1,'created_by','JOSM'),(51973877,1,'created_by','JOSM'),(51973878,1,'created_by','JOSM'),(51973881,1,'created_by','JOSM'),(51973883,1,'created_by','JOSM'),(51973884,1,'created_by','JOSM'),(51973887,1,'created_by','JOSM'),(51973890,1,'created_by','JOSM'),(51973891,1,'created_by','JOSM'),(51973894,1,'created_by','JOSM'),(51973897,1,'created_by','JOSM'),(51973898,1,'created_by','JOSM'),(51973901,1,'created_by','JOSM'),(51973903,1,'created_by','JOSM'),(51973905,1,'created_by','JOSM'),(51973907,1,'created_by','JOSM'),(51973910,1,'created_by','JOSM'),(51973913,1,'created_by','JOSM'),(51973915,1,'created_by','JOSM'),(51973917,1,'created_by','JOSM'),(51973920,1,'created_by','JOSM'),(51973922,1,'created_by','JOSM'),(51973924,1,'created_by','JOSM'),(51973927,1,'created_by','JOSM'),(51973929,1,'created_by','JOSM'),(51973931,1,'created_by','JOSM'),(51973934,1,'created_by','JOSM'),(51973937,1,'created_by','JOSM'),(51973939,1,'created_by','JOSM'),(51973941,1,'created_by','JOSM'),(51973942,1,'created_by','JOSM'),(51973947,1,'created_by','JOSM'),(51973950,1,'created_by','JOSM'),(51973952,1,'created_by','JOSM'),(51973953,1,'created_by','JOSM'),(51973955,1,'created_by','JOSM'),(51973958,1,'created_by','JOSM'),(51973962,1,'created_by','JOSM'),(51973963,1,'created_by','JOSM'),(51973967,1,'created_by','JOSM'),(51973968,1,'created_by','JOSM'),(51973972,1,'created_by','JOSM'),(51973975,1,'created_by','JOSM'),(51973977,1,'created_by','JOSM'),(51973981,1,'created_by','JOSM'),(51973983,1,'created_by','JOSM'),(51973986,1,'created_by','JOSM'),(51973989,1,'created_by','JOSM'),(51973992,1,'created_by','JOSM'),(51973995,1,'created_by','JOSM'),(51973998,1,'created_by','JOSM'),(51974002,1,'created_by','JOSM'),(51974005,1,'created_by','JOSM'),(51974008,1,'created_by','JOSM'),(51974011,1,'created_by','JOSM'),(51974013,1,'created_by','JOSM'),(51974015,1,'created_by','JOSM'),(51974019,1,'created_by','JOSM'),(51974023,1,'created_by','JOSM'),(51974024,1,'created_by','JOSM'),(51974028,1,'created_by','JOSM'),(51974031,1,'created_by','JOSM'),(51974035,1,'created_by','JOSM'),(51974039,1,'created_by','JOSM'),(51974040,1,'created_by','JOSM'),(51974042,1,'created_by','JOSM'),(51974044,1,'created_by','JOSM'),(51974046,1,'created_by','JOSM'),(51974049,1,'created_by','JOSM'),(51974050,1,'created_by','JOSM'),(51974053,1,'created_by','JOSM'),(51974055,1,'created_by','JOSM'),(51974057,1,'created_by','JOSM'),(51974059,1,'created_by','JOSM'),(51974060,1,'created_by','JOSM'),(51974065,1,'created_by','JOSM'),(51974068,1,'created_by','JOSM'),(51974072,1,'created_by','JOSM'),(51974074,1,'created_by','JOSM'),(51974078,1,'created_by','JOSM'),(51974083,1,'created_by','JOSM'),(51974085,1,'created_by','JOSM'),(51974086,1,'created_by','JOSM'),(51974088,1,'created_by','JOSM'),(51974089,1,'created_by','JOSM'),(51974090,1,'created_by','JOSM'),(51974095,1,'created_by','JOSM'),(51974097,1,'created_by','JOSM'),(51974100,1,'created_by','JOSM'),(51974103,1,'created_by','JOSM'),(51974107,1,'created_by','JOSM'),(51974108,1,'created_by','JOSM'),(51974112,1,'created_by','JOSM'),(51974115,1,'created_by','JOSM'),(51974119,1,'created_by','JOSM'),(51974122,1,'created_by','JOSM'),(51974126,1,'created_by','JOSM'),(51974129,1,'created_by','JOSM'),(51974131,1,'created_by','JOSM'),(51974133,1,'created_by','JOSM'),(51974134,1,'created_by','JOSM'),(51974137,1,'created_by','JOSM'),(51974140,1,'created_by','JOSM'),(51974143,1,'created_by','JOSM'),(51974147,1,'created_by','JOSM'),(51974149,1,'created_by','JOSM'),(51974152,1,'created_by','JOSM'),(51974153,1,'created_by','JOSM'),(51974155,1,'created_by','JOSM'),(51974158,1,'created_by','JOSM'),(51974161,1,'created_by','JOSM'),(51974164,1,'created_by','JOSM'),(51974165,1,'created_by','JOSM'),(51974167,1,'created_by','JOSM'),(51974169,1,'created_by','JOSM'),(51974172,1,'created_by','JOSM'),(51974174,1,'created_by','JOSM'),(51974176,1,'created_by','JOSM'),(51974181,1,'created_by','JOSM'),(51974183,1,'created_by','JOSM'),(51974185,1,'created_by','JOSM'),(51974187,1,'created_by','JOSM'),(51974190,1,'created_by','JOSM'),(51974191,1,'created_by','JOSM'),(51974193,1,'created_by','JOSM'),(51974195,1,'created_by','JOSM'),(51974197,1,'created_by','JOSM'),(51974199,1,'created_by','JOSM'),(51974202,1,'created_by','JOSM'),(51974204,1,'created_by','JOSM'),(51974206,1,'created_by','JOSM'),(51974208,1,'created_by','JOSM'),(51974211,1,'created_by','JOSM'),(51974213,1,'created_by','JOSM'),(51974215,1,'created_by','JOSM'),(51974217,1,'created_by','JOSM'),(51974220,1,'created_by','JOSM'),(51974223,1,'created_by','JOSM'),(51974226,1,'created_by','JOSM'),(51974229,1,'created_by','JOSM'),(51974231,1,'created_by','JOSM'),(51974233,1,'created_by','JOSM'),(51974236,1,'created_by','JOSM'),(51974239,1,'created_by','JOSM'),(51974242,1,'created_by','JOSM'),(51974244,1,'created_by','JOSM'),(51974247,1,'created_by','JOSM'),(51974249,1,'created_by','JOSM'),(51974251,1,'created_by','JOSM'),(51974253,1,'created_by','JOSM'),(51974256,1,'created_by','JOSM'),(51974258,1,'created_by','JOSM'),(51974261,1,'created_by','JOSM'),(51974264,1,'created_by','JOSM'),(51974266,1,'created_by','JOSM'),(51974275,1,'created_by','JOSM'),(51974278,1,'created_by','JOSM'),(51974279,1,'created_by','JOSM'),(51974281,1,'created_by','JOSM'),(51974284,1,'created_by','JOSM'),(51974286,1,'created_by','JOSM'),(51974289,1,'created_by','JOSM'),(51974291,1,'created_by','JOSM'),(51974292,1,'created_by','JOSM'),(51974293,1,'created_by','JOSM'),(51974296,1,'created_by','JOSM'),(51974298,1,'created_by','JOSM'),(51974300,1,'created_by','JOSM'),(51974301,1,'created_by','JOSM'),(51974305,1,'created_by','JOSM'),(51974308,1,'created_by','JOSM'),(51974309,1,'created_by','JOSM'),(51974313,1,'created_by','JOSM'),(51974316,1,'created_by','JOSM'),(51974319,1,'created_by','JOSM'),(51974321,1,'created_by','JOSM'),(51974323,1,'created_by','JOSM'),(51974326,1,'created_by','JOSM'),(51974328,1,'created_by','JOSM'),(51974331,1,'created_by','JOSM'),(51974334,1,'created_by','JOSM'),(51974337,1,'created_by','JOSM'),(51974339,1,'created_by','JOSM'),(51974341,1,'created_by','JOSM'),(51974345,1,'created_by','JOSM'),(51974349,1,'created_by','JOSM'),(51974353,1,'created_by','JOSM'),(51974357,1,'created_by','JOSM'),(51974360,1,'created_by','JOSM'),(51974363,1,'created_by','JOSM'),(51974365,1,'created_by','JOSM'),(51974368,1,'created_by','JOSM'),(51974371,1,'created_by','JOSM'),(51974373,1,'created_by','JOSM'),(51974374,1,'created_by','JOSM'),(51974376,1,'created_by','JOSM'),(51974378,1,'created_by','JOSM'),(51974383,1,'created_by','JOSM'),(51974385,1,'created_by','JOSM'),(51974388,1,'created_by','JOSM'),(51974391,1,'created_by','JOSM'),(51974394,1,'created_by','JOSM'),(51974395,1,'created_by','JOSM'),(51974397,1,'created_by','JOSM'),(51974400,1,'created_by','JOSM'),(51974402,1,'created_by','JOSM'),(51974404,1,'created_by','JOSM'),(51974405,1,'created_by','JOSM'),(51974408,1,'created_by','JOSM'),(51974411,1,'created_by','JOSM'),(51974414,1,'created_by','JOSM'),(51974416,1,'created_by','JOSM'),(51974419,1,'created_by','JOSM'),(51974422,1,'created_by','JOSM'),(51974424,1,'created_by','JOSM'),(51974428,1,'created_by','JOSM'),(51974430,1,'created_by','JOSM'),(51974432,1,'created_by','JOSM'),(51974436,1,'created_by','JOSM'),(51974439,1,'created_by','JOSM'),(51974442,1,'created_by','JOSM'),(51974445,1,'created_by','JOSM'),(51974446,1,'created_by','JOSM'),(51974451,1,'created_by','JOSM'),(51974452,1,'created_by','JOSM'),(51974454,1,'created_by','JOSM'),(51974455,1,'created_by','JOSM'),(51974456,1,'created_by','JOSM'),(51974458,1,'created_by','JOSM'),(51974462,1,'created_by','JOSM'),(51974466,1,'created_by','JOSM'),(51974469,1,'created_by','JOSM'),(51974472,1,'created_by','JOSM'),(51974475,1,'created_by','JOSM'),(51974478,1,'created_by','JOSM'),(51974481,1,'created_by','JOSM'),(51974484,1,'created_by','JOSM'),(52002189,1,'created_by','JOSM'),(52002192,1,'created_by','JOSM'),(52002196,3,'created_by','JOSM'),(52002198,1,'created_by','JOSM'),(52002202,1,'created_by','JOSM'),(52002204,1,'created_by','JOSM'),(52002206,1,'created_by','JOSM'),(52002209,1,'created_by','JOSM'),(52002211,1,'created_by','JOSM'),(52002212,1,'created_by','JOSM'),(52002214,1,'created_by','JOSM'),(52002216,1,'created_by','JOSM'),(52002219,2,'created_by','JOSM'),(52002220,1,'created_by','JOSM'),(52002222,1,'created_by','JOSM'),(52002223,1,'created_by','JOSM'),(52002226,1,'created_by','JOSM'),(52002229,1,'created_by','JOSM'),(52002231,1,'created_by','JOSM'),(52002235,1,'created_by','JOSM'),(52002238,1,'created_by','JOSM'),(52002241,1,'created_by','JOSM'),(52002244,1,'created_by','JOSM'),(52002247,1,'created_by','JOSM'),(52002248,1,'created_by','JOSM'),(52002251,1,'created_by','JOSM'),(52002253,1,'created_by','JOSM'),(52002256,1,'created_by','JOSM'),(52002258,1,'created_by','JOSM'),(52002259,1,'created_by','JOSM'),(52002261,1,'created_by','JOSM'),(52002264,1,'created_by','JOSM'),(52002266,1,'created_by','JOSM'),(52002269,1,'created_by','JOSM'),(52002272,1,'created_by','JOSM'),(52002275,1,'created_by','JOSM'),(52002278,1,'created_by','JOSM'),(52002281,1,'created_by','JOSM'),(52009103,1,'created_by','JOSM'),(52009105,1,'created_by','JOSM'),(52009107,1,'created_by','JOSM'),(52009108,1,'created_by','JOSM'),(52009109,1,'created_by','JOSM'),(52009111,1,'created_by','JOSM'),(52009114,1,'created_by','JOSM'),(52009117,1,'created_by','JOSM'),(52009118,1,'created_by','JOSM'),(52009120,1,'created_by','JOSM'),(52009122,1,'created_by','JOSM'),(52009124,1,'created_by','JOSM'),(52009126,1,'created_by','JOSM'),(52009127,1,'created_by','JOSM'),(52009129,1,'created_by','JOSM'),(52009130,1,'created_by','JOSM'),(52009134,1,'created_by','JOSM'),(52009137,1,'created_by','JOSM'),(52009140,1,'created_by','JOSM'),(52009143,1,'created_by','JOSM'),(52009144,1,'created_by','JOSM'),(52009147,1,'created_by','JOSM'),(52009150,1,'created_by','JOSM'),(52009151,1,'created_by','JOSM'),(52009154,1,'created_by','JOSM'),(52009156,1,'created_by','JOSM'),(52009157,1,'created_by','JOSM'),(52009159,1,'created_by','JOSM'),(52009161,1,'created_by','JOSM'),(52009164,1,'created_by','JOSM'),(52009168,1,'created_by','JOSM'),(52009171,2,'created_by','JOSM'),(52009174,1,'created_by','JOSM'),(52009176,1,'created_by','JOSM'),(52009179,1,'created_by','JOSM'),(52009182,1,'created_by','JOSM'),(52009184,1,'created_by','JOSM'),(52009186,1,'created_by','JOSM'),(52009189,1,'created_by','JOSM'),(52009192,1,'created_by','JOSM'),(52009194,1,'created_by','JOSM'),(52009196,1,'created_by','JOSM'),(52009197,1,'created_by','JOSM'),(52011225,1,'created_by','JOSM'),(52011227,1,'created_by','JOSM'),(52011231,1,'created_by','JOSM'),(52011234,1,'created_by','JOSM'),(52011238,1,'created_by','JOSM'),(52011242,1,'created_by','JOSM'),(52011244,1,'created_by','JOSM'),(52011249,1,'created_by','JOSM'),(52011253,1,'created_by','JOSM'),(52011256,1,'created_by','JOSM'),(52011259,1,'created_by','JOSM'),(52031003,2,'created_by','JOSM'),(52031013,3,'created_by','JOSM'),(52031030,2,'created_by','JOSM'),(52031034,2,'created_by','JOSM'),(52031036,1,'created_by','JOSM'),(52031039,1,'created_by','JOSM'),(52031041,1,'created_by','JOSM'),(52031043,1,'created_by','JOSM'),(52031046,1,'created_by','JOSM'),(52031050,1,'created_by','JOSM'),(52031054,1,'created_by','JOSM'),(52031056,1,'created_by','JOSM'),(52031059,1,'created_by','JOSM'),(52031076,1,'created_by','JOSM'),(52031077,1,'created_by','JOSM'),(52031080,1,'created_by','JOSM'),(52031082,1,'created_by','JOSM'),(52031084,1,'created_by','JOSM'),(52031086,1,'created_by','JOSM'),(52031089,1,'created_by','JOSM'),(52031092,1,'created_by','JOSM'),(52031095,1,'created_by','JOSM'),(52031099,1,'created_by','JOSM'),(52031100,1,'created_by','JOSM'),(52031105,1,'created_by','JOSM'),(52031109,1,'created_by','JOSM'),(52031114,1,'created_by','JOSM'),(52031117,1,'created_by','JOSM'),(52031121,1,'created_by','JOSM'),(52031125,1,'created_by','JOSM'),(52031129,1,'created_by','JOSM'),(52031131,1,'created_by','JOSM'),(52031136,1,'created_by','JOSM'),(52031141,1,'created_by','JOSM'),(52031147,1,'created_by','JOSM'),(52031151,1,'created_by','JOSM'),(52031153,1,'created_by','JOSM'),(52031156,1,'created_by','JOSM'),(52031158,1,'created_by','JOSM'),(52031164,1,'created_by','JOSM'),(52031171,1,'created_by','JOSM'),(52031174,1,'created_by','JOSM'),(52031178,1,'created_by','JOSM'),(52031186,1,'created_by','JOSM'),(52031190,1,'created_by','JOSM'),(52031198,1,'created_by','JOSM'),(52031205,1,'created_by','JOSM'),(52031212,1,'created_by','JOSM'),(52031218,1,'created_by','JOSM'),(52031221,1,'created_by','JOSM'),(52031224,1,'created_by','JOSM'),(52031227,1,'created_by','JOSM'),(52031232,1,'created_by','JOSM'),(52031235,1,'created_by','JOSM'),(52031240,1,'created_by','JOSM'),(52031244,1,'created_by','JOSM'),(52031247,1,'created_by','JOSM'),(52031250,1,'created_by','JOSM'),(52031255,1,'created_by','JOSM'),(52031260,1,'created_by','JOSM'),(52031262,1,'created_by','JOSM'),(52031267,1,'created_by','JOSM'),(52031272,1,'created_by','JOSM'),(52031275,1,'created_by','JOSM'),(52031281,1,'created_by','JOSM'),(52031285,1,'created_by','JOSM'),(52031290,1,'created_by','JOSM'),(52031295,1,'created_by','JOSM'),(52031299,1,'created_by','JOSM'),(52031307,1,'created_by','JOSM'),(52031309,1,'created_by','JOSM'),(52031314,1,'created_by','JOSM'),(52031320,1,'created_by','JOSM'),(52031325,1,'created_by','JOSM'),(52031329,1,'created_by','JOSM'),(52031335,1,'created_by','JOSM'),(52031340,1,'created_by','JOSM'),(52031346,1,'created_by','JOSM'),(52031351,2,'created_by','JOSM'),(52031355,2,'created_by','JOSM'),(52031357,2,'created_by','JOSM'),(52031361,2,'created_by','JOSM'),(52031364,2,'created_by','JOSM'),(52031367,1,'created_by','JOSM'),(52031369,1,'created_by','JOSM'),(52031373,1,'created_by','JOSM'),(52031381,1,'created_by','JOSM'),(52031384,1,'created_by','JOSM'),(52031410,1,'created_by','JOSM'),(52031414,1,'created_by','JOSM'),(52031418,1,'created_by','JOSM'),(52031424,1,'created_by','JOSM'),(52031426,1,'created_by','JOSM'),(52031429,1,'created_by','JOSM'),(52031433,1,'created_by','JOSM'),(52031438,1,'created_by','JOSM'),(52031441,1,'created_by','JOSM'),(52031446,1,'created_by','JOSM'),(52031449,1,'created_by','JOSM'),(52031456,1,'created_by','JOSM'),(52031461,1,'created_by','JOSM'),(52031464,1,'created_by','JOSM'),(52031467,1,'created_by','JOSM'),(52031471,1,'created_by','JOSM'),(52031477,1,'created_by','JOSM'),(52031481,1,'created_by','JOSM'),(52031483,1,'created_by','JOSM'),(52031486,1,'created_by','JOSM'),(52031491,1,'created_by','JOSM'),(52031494,1,'created_by','JOSM'),(52031498,1,'created_by','JOSM'),(52031500,1,'created_by','JOSM'),(52031504,1,'created_by','JOSM'),(52031507,1,'created_by','JOSM'),(52031512,1,'created_by','JOSM'),(52031514,1,'created_by','JOSM'),(52031517,1,'created_by','JOSM'),(52031521,1,'created_by','JOSM'),(52031523,1,'created_by','JOSM'),(52031527,1,'created_by','JOSM'),(52031529,1,'created_by','JOSM'),(52031532,1,'created_by','JOSM'),(52031535,1,'created_by','JOSM'),(52031540,1,'created_by','JOSM'),(52031545,1,'created_by','JOSM'),(52031550,1,'created_by','JOSM'),(52031552,1,'created_by','JOSM'),(52031554,1,'created_by','JOSM'),(52031560,1,'created_by','JOSM'),(52031562,1,'created_by','JOSM'),(52031567,1,'created_by','JOSM'),(52031572,1,'created_by','JOSM'),(52031576,1,'created_by','JOSM'),(52031580,1,'created_by','JOSM'),(52031581,1,'created_by','JOSM'),(52031587,1,'created_by','JOSM'),(52031590,1,'created_by','JOSM'),(52031592,1,'created_by','JOSM'),(52031595,1,'created_by','JOSM'),(52031600,1,'created_by','JOSM'),(52031604,1,'created_by','JOSM'),(52031608,1,'created_by','JOSM'),(52031611,1,'created_by','JOSM'),(52031614,1,'created_by','JOSM'),(52031616,1,'created_by','JOSM'),(52031617,1,'created_by','JOSM'),(52031620,1,'created_by','JOSM'),(52031621,1,'created_by','JOSM'),(52031626,1,'created_by','JOSM'),(52031627,1,'created_by','JOSM'),(52031631,1,'created_by','JOSM'),(52031634,1,'created_by','JOSM'),(52031636,1,'created_by','JOSM'),(52031642,1,'created_by','JOSM'),(52031645,1,'created_by','JOSM'),(52031648,1,'created_by','JOSM'),(52031652,1,'created_by','JOSM'),(52031656,1,'created_by','JOSM'),(52031658,1,'created_by','JOSM'),(52031660,1,'created_by','JOSM'),(52031665,1,'created_by','JOSM'),(52031668,1,'created_by','JOSM'),(52031671,1,'created_by','JOSM'),(52031676,1,'created_by','JOSM'),(52031678,1,'created_by','JOSM'),(52031681,1,'created_by','JOSM'),(52031686,1,'created_by','JOSM'),(52031688,1,'created_by','JOSM'),(52031691,1,'created_by','JOSM'),(52031695,1,'created_by','JOSM'),(52031700,1,'created_by','JOSM'),(52031702,1,'created_by','JOSM'),(52031705,1,'created_by','JOSM'),(52031709,1,'created_by','JOSM'),(52031712,1,'created_by','JOSM'),(52031715,1,'created_by','JOSM'),(52031717,1,'created_by','JOSM'),(52031720,1,'created_by','JOSM'),(52031723,1,'created_by','JOSM'),(52031726,2,'created_by','JOSM'),(52031730,3,'created_by','JOSM'),(52031732,3,'created_by','JOSM'),(52031736,3,'created_by','JOSM'),(52031739,1,'created_by','JOSM'),(52031742,1,'created_by','JOSM'),(52031744,1,'created_by','JOSM'),(52031746,1,'created_by','JOSM'),(52031747,1,'created_by','JOSM'),(52031749,1,'created_by','JOSM'),(52031751,1,'created_by','JOSM'),(52031756,1,'created_by','JOSM'),(52031758,1,'created_by','JOSM'),(52031761,1,'created_by','JOSM'),(52031764,1,'created_by','JOSM'),(52031767,1,'created_by','JOSM'),(52031771,1,'created_by','JOSM'),(52031774,1,'created_by','JOSM'),(52031777,1,'created_by','JOSM'),(52031782,1,'created_by','JOSM'),(52031785,1,'created_by','JOSM'),(52031789,1,'created_by','JOSM'),(52031794,1,'created_by','JOSM'),(52031798,1,'created_by','JOSM'),(52031803,1,'created_by','JOSM'),(52031805,1,'created_by','JOSM'),(52031809,1,'created_by','JOSM'),(52031811,1,'created_by','JOSM'),(52031813,1,'created_by','JOSM'),(52031815,1,'created_by','JOSM'),(52031821,1,'created_by','JOSM'),(52031823,1,'created_by','JOSM'),(52031827,1,'created_by','JOSM'),(52031830,1,'created_by','JOSM'),(52031832,1,'created_by','JOSM'),(52031834,1,'created_by','JOSM'),(52031838,1,'created_by','JOSM'),(52031840,1,'created_by','JOSM'),(52031844,1,'created_by','JOSM'),(52031847,1,'created_by','JOSM'),(52031850,1,'created_by','JOSM'),(52031855,1,'created_by','JOSM'),(52031858,1,'created_by','JOSM'),(52031861,1,'created_by','JOSM'),(52031865,1,'created_by','JOSM'),(52031866,1,'created_by','JOSM'),(52031868,1,'created_by','JOSM'),(52031871,1,'created_by','JOSM'),(52031872,1,'created_by','JOSM'),(52031874,1,'created_by','JOSM'),(52031876,1,'created_by','JOSM'),(52031881,1,'created_by','JOSM'),(52031884,1,'created_by','JOSM'),(52031886,1,'created_by','JOSM'),(52031888,1,'created_by','JOSM'),(52031889,1,'created_by','JOSM'),(52031893,1,'created_by','JOSM'),(52031894,1,'created_by','JOSM'),(52031899,1,'created_by','JOSM'),(52031901,1,'created_by','JOSM'),(52031906,1,'created_by','JOSM'),(52031908,1,'created_by','JOSM'),(52031911,1,'created_by','JOSM'),(52031913,1,'created_by','JOSM'),(52031915,1,'created_by','JOSM'),(52031919,1,'created_by','JOSM'),(52031921,1,'created_by','JOSM'),(52031925,1,'created_by','JOSM'),(52031927,1,'created_by','JOSM'),(52031930,1,'created_by','JOSM'),(52031933,1,'created_by','JOSM'),(52031936,1,'created_by','JOSM'),(52031938,1,'created_by','JOSM'),(52031943,1,'created_by','JOSM'),(52031946,1,'created_by','JOSM'),(52031948,1,'created_by','JOSM'),(52031953,1,'created_by','JOSM'),(52031956,1,'created_by','JOSM'),(52031958,1,'created_by','JOSM'),(52031962,1,'created_by','JOSM'),(52031966,1,'created_by','JOSM'),(52031968,1,'created_by','JOSM'),(52031973,1,'created_by','JOSM'),(52031976,2,'created_by','JOSM'),(52031980,1,'created_by','JOSM'),(52031984,1,'created_by','JOSM'),(52031987,1,'created_by','JOSM'),(52031990,1,'created_by','JOSM'),(52031992,1,'created_by','JOSM'),(52031995,1,'created_by','JOSM'),(52031998,1,'created_by','JOSM'),(52032000,1,'created_by','JOSM'),(52032003,1,'created_by','JOSM'),(52032007,1,'created_by','JOSM'),(52032010,1,'created_by','JOSM'),(52032012,1,'created_by','JOSM'),(52032017,1,'created_by','JOSM'),(52032018,1,'created_by','JOSM'),(52032021,1,'created_by','JOSM'),(52032022,1,'created_by','JOSM'),(52032026,1,'created_by','JOSM'),(52032029,1,'created_by','JOSM'),(52032033,1,'created_by','JOSM'),(52032035,1,'created_by','JOSM'),(52032039,1,'created_by','JOSM'),(52032041,1,'created_by','JOSM'),(52032044,1,'created_by','JOSM'),(52032047,1,'created_by','JOSM'),(52032048,1,'created_by','JOSM'),(52032051,1,'created_by','JOSM'),(52032054,1,'created_by','JOSM'),(52032057,1,'created_by','JOSM'),(52032060,1,'created_by','JOSM'),(52032064,1,'created_by','JOSM'),(52032067,1,'created_by','JOSM'),(52032070,1,'created_by','JOSM'),(52032071,1,'created_by','JOSM'),(52032075,1,'created_by','JOSM'),(52032076,1,'created_by','JOSM'),(52032078,1,'created_by','JOSM'),(52032081,1,'created_by','JOSM'),(52032085,1,'created_by','JOSM'),(52032087,1,'created_by','JOSM'),(52032090,1,'created_by','JOSM'),(52032092,1,'created_by','JOSM'),(52032093,1,'created_by','JOSM'),(52032098,1,'created_by','JOSM'),(52032100,1,'created_by','JOSM'),(52032103,1,'created_by','JOSM'),(52032107,1,'created_by','JOSM'),(52032109,1,'created_by','JOSM'),(52032112,1,'created_by','JOSM'),(52032113,1,'created_by','JOSM'),(52032116,1,'created_by','JOSM'),(52032119,1,'created_by','JOSM'),(52032122,1,'created_by','JOSM'),(52032125,1,'created_by','JOSM'),(52032127,1,'created_by','JOSM'),(52032130,1,'created_by','JOSM'),(52032133,1,'created_by','JOSM'),(52032135,1,'created_by','JOSM'),(52032137,1,'created_by','JOSM'),(52032141,1,'created_by','JOSM'),(52032145,1,'created_by','JOSM'),(52032147,1,'created_by','JOSM'),(52032150,1,'created_by','JOSM'),(52032153,1,'created_by','JOSM'),(52032158,1,'created_by','JOSM'),(52032160,1,'created_by','JOSM'),(52032162,1,'created_by','JOSM'),(52032165,1,'created_by','JOSM'),(52032168,1,'created_by','JOSM'),(52032171,1,'created_by','JOSM'),(52032174,1,'created_by','JOSM'),(52032176,1,'created_by','JOSM'),(52032179,1,'created_by','JOSM'),(52032182,1,'created_by','JOSM'),(52032183,1,'created_by','JOSM'),(52032186,1,'created_by','JOSM'),(52032187,1,'created_by','JOSM'),(52032190,1,'created_by','JOSM'),(52032192,1,'created_by','JOSM'),(52032195,1,'created_by','JOSM'),(52032197,1,'created_by','JOSM'),(52032200,1,'created_by','JOSM'),(52032204,1,'created_by','JOSM'),(52032205,1,'created_by','JOSM'),(52032208,1,'created_by','JOSM'),(52032211,1,'created_by','JOSM'),(52032212,1,'created_by','JOSM'),(52032216,1,'created_by','JOSM'),(52032219,1,'created_by','JOSM'),(52032222,1,'created_by','JOSM'),(52032225,1,'created_by','JOSM'),(52032228,1,'created_by','JOSM'),(52032233,1,'created_by','JOSM'),(52032238,1,'created_by','JOSM'),(52032241,1,'created_by','JOSM'),(52032243,1,'created_by','JOSM'),(52032246,1,'created_by','JOSM'),(52032249,1,'created_by','JOSM'),(52032250,1,'created_by','JOSM'),(52163550,4,'created_by','JOSM'),(52163556,4,'created_by','JOSM'),(52163563,4,'created_by','JOSM'),(52163574,3,'created_by','JOSM'),(52163581,3,'created_by','JOSM'),(52163588,1,'created_by','JOSM'),(52163595,1,'created_by','JOSM'),(52163602,1,'created_by','JOSM'),(52163609,1,'created_by','JOSM'),(52163613,1,'created_by','JOSM'),(52163621,1,'created_by','JOSM'),(52163631,1,'created_by','JOSM'),(52163644,1,'created_by','JOSM'),(52163664,1,'created_by','JOSM'),(52164958,1,'created_by','JOSM'),(52166749,2,'created_by','JOSM'),(52166950,2,'highway','mini_roundabout'),(52166959,2,'created_by','JOSM'),(52166976,2,'created_by','JOSM'),(52166980,2,'created_by','JOSM'),(52167010,2,'created_by','JOSM'),(52167017,2,'created_by','JOSM'),(52167025,2,'created_by','JOSM'),(52167030,2,'created_by','JOSM'),(52167039,2,'created_by','JOSM'),(52167045,2,'created_by','JOSM'),(52167049,2,'created_by','JOSM'),(52167052,2,'created_by','JOSM'),(52167062,2,'created_by','JOSM'),(52167066,2,'created_by','JOSM'),(52167070,2,'created_by','JOSM'),(52167076,2,'created_by','JOSM'),(52167082,2,'created_by','JOSM'),(52167086,2,'created_by','JOSM'),(52167105,2,'created_by','JOSM'),(52167111,2,'created_by','JOSM'),(52167122,2,'created_by','JOSM'),(52167128,2,'created_by','JOSM'),(52167136,2,'created_by','JOSM'),(52167142,2,'created_by','JOSM'),(52167150,2,'created_by','JOSM'),(52167155,2,'created_by','JOSM'),(52167165,2,'created_by','JOSM'),(52167175,2,'created_by','JOSM'),(52167179,1,'created_by','JOSM'),(52167183,1,'created_by','JOSM'),(52167190,1,'created_by','JOSM'),(52167198,1,'created_by','JOSM'),(52167208,1,'created_by','JOSM'),(52167211,1,'created_by','JOSM'),(52167218,1,'created_by','JOSM'),(52167223,1,'created_by','JOSM'),(52167232,1,'created_by','JOSM'),(52167248,1,'created_by','JOSM'),(52167254,1,'created_by','JOSM'),(52167257,1,'created_by','JOSM'),(52167262,1,'created_by','JOSM'),(52167277,1,'created_by','JOSM'),(52167279,1,'created_by','JOSM'),(52167284,1,'created_by','JOSM'),(52167289,1,'created_by','JOSM'),(52167293,1,'created_by','JOSM'),(52167300,1,'created_by','JOSM'),(52167307,1,'created_by','JOSM'),(52167309,1,'created_by','JOSM'),(52167315,1,'created_by','JOSM'),(52167320,1,'created_by','JOSM'),(52167323,1,'created_by','JOSM'),(52167329,1,'created_by','JOSM'),(52167336,1,'created_by','JOSM'),(52167345,1,'created_by','JOSM'),(52167349,1,'created_by','JOSM'),(52167353,1,'created_by','JOSM'),(52167358,1,'created_by','JOSM'),(52167363,1,'created_by','JOSM'),(52167368,1,'created_by','JOSM'),(52167372,1,'created_by','JOSM'),(52167380,1,'created_by','JOSM'),(52167387,1,'created_by','JOSM'),(52167389,1,'created_by','JOSM'),(52167390,1,'created_by','JOSM'),(52167393,1,'created_by','JOSM'),(52167396,1,'created_by','JOSM'),(52167398,1,'created_by','JOSM'),(52167402,1,'created_by','JOSM'),(52167406,1,'created_by','JOSM'),(52167421,1,'created_by','JOSM'),(52167425,1,'created_by','JOSM'),(52167428,1,'created_by','JOSM'),(52167430,1,'created_by','JOSM'),(52167433,1,'created_by','JOSM'),(52167436,1,'created_by','JOSM'),(52167438,1,'created_by','JOSM'),(52167439,1,'created_by','JOSM'),(52167444,1,'created_by','JOSM'),(52167446,1,'created_by','JOSM'),(52167453,1,'created_by','JOSM'),(52167457,1,'created_by','JOSM'),(52167470,1,'created_by','JOSM'),(52167473,1,'created_by','JOSM'),(52167477,1,'created_by','JOSM'),(52167484,1,'created_by','JOSM'),(52167487,1,'created_by','JOSM'),(52167490,1,'created_by','JOSM'),(52167496,1,'created_by','JOSM'),(52167500,1,'created_by','JOSM'),(52167503,1,'created_by','JOSM'),(52167507,1,'created_by','JOSM'),(52167511,1,'created_by','JOSM'),(52167513,1,'created_by','JOSM'),(52167517,1,'created_by','JOSM'),(52167521,1,'created_by','JOSM'),(52167525,1,'created_by','JOSM'),(52167528,1,'created_by','JOSM'),(52167530,1,'created_by','JOSM'),(52167534,1,'created_by','JOSM'),(52167535,1,'created_by','JOSM'),(52167538,1,'created_by','JOSM'),(52167540,1,'created_by','JOSM'),(52167544,1,'created_by','JOSM'),(52167547,1,'created_by','JOSM'),(52167551,1,'created_by','JOSM'),(52167557,1,'created_by','JOSM'),(52167562,1,'created_by','JOSM'),(52167568,1,'created_by','JOSM'),(52167574,1,'created_by','JOSM'),(52167579,1,'created_by','JOSM'),(52167581,1,'created_by','JOSM'),(52167585,1,'created_by','JOSM'),(52167590,1,'created_by','JOSM'),(52167593,1,'created_by','JOSM'),(52167599,1,'created_by','JOSM'),(52167604,1,'created_by','JOSM'),(52167607,1,'created_by','JOSM'),(52167614,1,'created_by','JOSM'),(52167615,1,'created_by','JOSM'),(52167619,1,'created_by','JOSM'),(52167622,1,'created_by','JOSM'),(52167627,1,'created_by','JOSM'),(52167632,1,'created_by','JOSM'),(52167636,1,'created_by','JOSM'),(52167641,1,'created_by','JOSM'),(52167645,1,'created_by','JOSM'),(52167650,1,'created_by','JOSM'),(52167655,1,'created_by','JOSM'),(52167660,1,'created_by','JOSM'),(52167664,1,'created_by','JOSM'),(52167666,1,'created_by','JOSM'),(52167669,1,'created_by','JOSM'),(52167673,1,'created_by','JOSM'),(52167677,1,'created_by','JOSM'),(52167683,1,'created_by','JOSM'),(52167687,1,'created_by','JOSM'),(52167691,1,'created_by','JOSM'),(52167695,1,'created_by','JOSM'),(52167700,1,'created_by','JOSM'),(52167702,1,'created_by','JOSM'),(52167707,1,'created_by','JOSM'),(52167710,1,'created_by','JOSM'),(52167713,1,'created_by','JOSM'),(52167714,1,'created_by','JOSM'),(52167718,1,'created_by','JOSM'),(52167721,1,'created_by','JOSM'),(52167725,1,'created_by','JOSM'),(52167727,1,'created_by','JOSM'),(52167732,1,'created_by','JOSM'),(52167736,1,'created_by','JOSM'),(52167740,1,'created_by','JOSM'),(52167744,1,'created_by','JOSM'),(52167747,1,'created_by','JOSM'),(52167752,1,'created_by','JOSM'),(52167756,1,'created_by','JOSM'),(52167758,1,'created_by','JOSM'),(52167761,1,'created_by','JOSM'),(52167765,1,'created_by','JOSM'),(52167769,1,'created_by','JOSM'),(52167773,1,'created_by','JOSM'),(52167777,1,'created_by','JOSM'),(52167781,1,'created_by','JOSM'),(52167784,1,'created_by','JOSM'),(52167787,1,'created_by','JOSM'),(52167790,1,'created_by','JOSM'),(52167795,1,'created_by','JOSM'),(52167796,1,'created_by','JOSM'),(52167799,1,'created_by','JOSM'),(52167802,1,'created_by','JOSM'),(52167805,1,'created_by','JOSM'),(52167807,1,'created_by','JOSM'),(52167811,1,'created_by','JOSM'),(52167812,1,'created_by','JOSM'),(52167815,1,'created_by','JOSM'),(52167820,1,'created_by','JOSM'),(52167825,1,'created_by','JOSM'),(52167828,1,'created_by','JOSM'),(52167834,1,'created_by','JOSM'),(52167836,1,'created_by','JOSM'),(52167839,1,'created_by','JOSM'),(52167843,1,'created_by','JOSM'),(52167847,1,'created_by','JOSM'),(52167849,1,'created_by','JOSM'),(52167853,1,'created_by','JOSM'),(52167859,1,'created_by','JOSM'),(52167860,1,'created_by','JOSM'),(52167867,1,'created_by','JOSM'),(52167872,1,'created_by','JOSM'),(52167883,1,'created_by','JOSM'),(52167887,1,'created_by','JOSM'),(52167891,1,'created_by','JOSM'),(52167896,1,'created_by','JOSM'),(52167900,1,'created_by','JOSM'),(52167906,1,'created_by','JOSM'),(52167911,1,'created_by','JOSM'),(52167916,1,'created_by','JOSM'),(52167922,1,'created_by','JOSM'),(52167924,1,'created_by','JOSM'),(52167927,1,'created_by','JOSM'),(52167930,1,'created_by','JOSM'),(52167932,1,'created_by','JOSM'),(52167937,1,'created_by','JOSM'),(52167944,1,'created_by','JOSM'),(52167948,1,'created_by','JOSM'),(52167953,1,'created_by','JOSM'),(52167958,1,'created_by','JOSM'),(52167963,1,'created_by','JOSM'),(52167967,1,'created_by','JOSM'),(52167969,1,'created_by','JOSM'),(52167970,1,'created_by','JOSM'),(52167973,1,'created_by','JOSM'),(52167977,1,'created_by','JOSM'),(52167981,1,'created_by','JOSM'),(52167986,1,'created_by','JOSM'),(52167991,1,'created_by','JOSM'),(52167995,1,'created_by','JOSM'),(52168000,1,'created_by','JOSM'),(52168004,1,'created_by','JOSM'),(52168009,1,'created_by','JOSM'),(52168013,1,'created_by','JOSM'),(52168015,1,'created_by','JOSM'),(52168018,1,'created_by','JOSM'),(52168021,1,'created_by','JOSM'),(52168025,1,'created_by','JOSM'),(52168028,1,'created_by','JOSM'),(52168033,1,'created_by','JOSM'),(52168034,1,'created_by','JOSM'),(52168038,1,'created_by','JOSM'),(52168039,1,'created_by','JOSM'),(52168043,1,'created_by','JOSM'),(52168046,1,'created_by','JOSM'),(52168049,1,'created_by','JOSM'),(52168053,1,'created_by','JOSM'),(52168055,1,'created_by','JOSM'),(52168056,1,'created_by','JOSM'),(52168060,1,'created_by','JOSM'),(52168063,1,'created_by','JOSM'),(52168065,1,'created_by','JOSM'),(52168070,1,'created_by','JOSM'),(52168071,1,'created_by','JOSM'),(52168073,1,'created_by','JOSM'),(52168077,1,'created_by','JOSM'),(52168080,1,'created_by','JOSM'),(52168084,1,'created_by','JOSM'),(52168086,1,'created_by','JOSM'),(52168090,1,'created_by','JOSM'),(52168094,1,'created_by','JOSM'),(52168096,1,'created_by','JOSM'),(52168100,1,'created_by','JOSM'),(52168101,1,'created_by','JOSM'),(52168104,1,'created_by','JOSM'),(52168108,1,'created_by','JOSM'),(52168111,1,'created_by','JOSM'),(52168115,1,'created_by','JOSM'),(52168118,1,'created_by','JOSM'),(52168121,1,'created_by','JOSM'),(52168124,1,'created_by','JOSM'),(52168127,1,'created_by','JOSM'),(52168130,1,'created_by','JOSM'),(52168135,1,'created_by','JOSM'),(52168138,1,'created_by','JOSM'),(52168143,1,'created_by','JOSM'),(52168146,1,'created_by','JOSM'),(52168149,1,'created_by','JOSM'),(52168152,1,'created_by','JOSM'),(52168156,1,'created_by','JOSM'),(52168160,1,'created_by','JOSM'),(52168163,1,'created_by','JOSM'),(52168167,1,'created_by','JOSM'),(52168171,1,'created_by','JOSM'),(52168175,1,'created_by','JOSM'),(52168178,1,'created_by','JOSM'),(52168181,1,'created_by','JOSM'),(52168186,1,'created_by','JOSM'),(52168188,1,'created_by','JOSM'),(52168191,1,'created_by','JOSM'),(52168195,1,'created_by','JOSM'),(52168198,1,'created_by','JOSM'),(52168203,1,'created_by','JOSM'),(52168207,1,'created_by','JOSM'),(52168214,1,'created_by','JOSM'),(52168217,1,'created_by','JOSM'),(52168220,1,'created_by','JOSM'),(52168225,1,'created_by','JOSM'),(52168231,1,'created_by','JOSM'),(52168235,1,'created_by','JOSM'),(52168237,1,'created_by','JOSM'),(52168240,1,'created_by','JOSM'),(52168243,1,'created_by','JOSM'),(52168247,1,'created_by','JOSM'),(52168248,1,'created_by','JOSM'),(52168249,1,'created_by','JOSM'),(52168251,1,'created_by','JOSM'),(52168254,1,'created_by','JOSM'),(52168256,1,'created_by','JOSM'),(52168258,1,'created_by','JOSM'),(52168261,1,'created_by','JOSM'),(52168265,1,'created_by','JOSM'),(52168270,1,'created_by','JOSM'),(52168274,1,'created_by','JOSM'),(52168278,1,'created_by','JOSM'),(52168283,1,'created_by','JOSM'),(52168286,1,'created_by','JOSM'),(52168287,1,'created_by','JOSM'),(52168291,1,'created_by','JOSM'),(52168296,1,'created_by','JOSM'),(52168298,1,'created_by','JOSM'),(52168302,1,'created_by','JOSM'),(52168305,1,'created_by','JOSM'),(52168308,1,'created_by','JOSM'),(52168309,1,'created_by','JOSM'),(52168314,1,'created_by','JOSM'),(52168316,1,'created_by','JOSM'),(52168318,1,'created_by','JOSM'),(52168321,1,'created_by','JOSM'),(52168325,1,'created_by','JOSM'),(52168326,1,'created_by','JOSM'),(52168329,1,'created_by','JOSM'),(52168333,1,'created_by','JOSM'),(52168336,1,'created_by','JOSM'),(52168338,1,'created_by','JOSM'),(52168342,1,'created_by','JOSM'),(52168346,1,'created_by','JOSM'),(52168347,1,'created_by','JOSM'),(52168348,1,'created_by','JOSM'),(52168350,1,'created_by','JOSM'),(52168356,1,'created_by','JOSM'),(52168360,1,'created_by','JOSM'),(52168362,1,'created_by','JOSM'),(52168414,1,'created_by','JOSM'),(52168416,1,'created_by','JOSM'),(52168419,1,'created_by','JOSM'),(52168423,1,'created_by','JOSM'),(52168427,1,'created_by','JOSM'),(52168429,1,'created_by','JOSM'),(52168432,1,'created_by','JOSM'),(52168436,1,'created_by','JOSM'),(52168440,1,'created_by','JOSM'),(52168442,1,'created_by','JOSM'),(52168445,1,'created_by','JOSM'),(52168447,1,'created_by','JOSM'),(52168452,1,'created_by','JOSM'),(52168455,1,'created_by','JOSM'),(52168459,1,'created_by','JOSM'),(52168461,1,'created_by','JOSM'),(52168464,1,'created_by','JOSM'),(52168468,1,'created_by','JOSM'),(52168470,1,'created_by','JOSM'),(52168474,1,'created_by','JOSM'),(52168476,1,'created_by','JOSM'),(52168479,1,'created_by','JOSM'),(52168481,1,'created_by','JOSM'),(52168484,1,'created_by','JOSM'),(52168486,1,'created_by','JOSM'),(52168489,1,'created_by','JOSM'),(52168492,1,'created_by','JOSM'),(52168495,1,'created_by','JOSM'),(52168497,1,'created_by','JOSM'),(52168502,1,'created_by','JOSM'),(52168506,1,'created_by','JOSM'),(52168509,1,'created_by','JOSM'),(52168512,1,'created_by','JOSM'),(52168516,1,'created_by','JOSM'),(52168519,1,'created_by','JOSM'),(52168521,1,'created_by','JOSM'),(52168523,1,'created_by','JOSM'),(52168529,1,'created_by','JOSM'),(52168531,1,'created_by','JOSM'),(52168534,1,'created_by','JOSM'),(52168537,1,'created_by','JOSM'),(52168541,1,'created_by','JOSM'),(52168543,1,'created_by','JOSM'),(52168547,1,'created_by','JOSM'),(52168549,1,'created_by','JOSM'),(52168553,1,'created_by','JOSM'),(52168555,1,'created_by','JOSM'),(52168558,1,'created_by','JOSM'),(52168561,1,'created_by','JOSM'),(52168565,1,'created_by','JOSM'),(52168568,1,'created_by','JOSM'),(52168569,1,'created_by','JOSM'),(52168572,1,'created_by','JOSM'),(52168576,1,'created_by','JOSM'),(52168579,1,'created_by','JOSM'),(52168582,1,'created_by','JOSM'),(52168586,1,'created_by','JOSM'),(52168589,1,'created_by','JOSM'),(52168592,1,'created_by','JOSM'),(52168595,1,'created_by','JOSM'),(52168596,1,'created_by','JOSM'),(52168600,1,'created_by','JOSM'),(52168604,1,'created_by','JOSM'),(52168607,1,'created_by','JOSM'),(52168612,1,'created_by','JOSM'),(52168613,1,'created_by','JOSM'),(52168616,1,'created_by','JOSM'),(52168622,1,'created_by','JOSM'),(52168626,1,'created_by','JOSM'),(52168631,1,'created_by','JOSM'),(52168635,1,'created_by','JOSM'),(52168638,1,'created_by','JOSM'),(52168640,1,'created_by','JOSM'),(52168644,1,'created_by','JOSM'),(52168648,1,'created_by','JOSM'),(52168654,1,'created_by','JOSM'),(52168657,1,'created_by','JOSM'),(52168660,1,'created_by','JOSM'),(52168663,1,'created_by','JOSM'),(52168665,1,'created_by','JOSM'),(52168668,1,'created_by','JOSM'),(52168671,1,'created_by','JOSM'),(52168674,1,'created_by','JOSM'),(52168676,1,'created_by','JOSM'),(52168679,1,'created_by','JOSM'),(52168682,1,'created_by','JOSM'),(52168686,1,'created_by','JOSM'),(52168687,1,'created_by','JOSM'),(52168690,1,'created_by','JOSM'),(52168693,1,'created_by','JOSM'),(52168695,1,'created_by','JOSM'),(52168698,1,'created_by','JOSM'),(52168700,1,'created_by','JOSM'),(52168702,1,'created_by','JOSM'),(52168703,1,'created_by','JOSM'),(52168705,1,'created_by','JOSM'),(52168708,2,'created_by','JOSM'),(52168710,2,'created_by','JOSM'),(52168712,2,'created_by','JOSM'),(52168714,1,'created_by','JOSM'),(52168717,1,'created_by','JOSM'),(52168720,1,'created_by','JOSM'),(52168722,1,'created_by','JOSM'),(52168725,1,'created_by','JOSM'),(52168727,1,'created_by','JOSM'),(52168729,1,'created_by','JOSM'),(52168732,1,'created_by','JOSM'),(52168734,1,'created_by','JOSM'),(52168736,1,'created_by','JOSM'),(52168739,1,'created_by','JOSM'),(52168741,1,'created_by','JOSM'),(52168744,1,'created_by','JOSM'),(52168745,1,'created_by','JOSM'),(52168747,1,'created_by','JOSM'),(52168750,1,'created_by','JOSM'),(52168770,1,'created_by','JOSM'),(52168772,1,'created_by','JOSM'),(52168773,1,'created_by','JOSM'),(52168774,2,'created_by','JOSM'),(52168777,1,'created_by','JOSM'),(52168779,1,'created_by','JOSM'),(52168782,1,'created_by','JOSM'),(52168786,1,'created_by','JOSM'),(52168788,1,'created_by','JOSM'),(52168789,1,'created_by','JOSM'),(52168790,1,'created_by','JOSM'),(52168794,1,'created_by','JOSM'),(52168796,1,'created_by','JOSM'),(52168799,1,'created_by','JOSM'),(52168802,1,'created_by','JOSM'),(52168805,1,'created_by','JOSM'),(52168808,1,'created_by','JOSM'),(52168810,1,'created_by','JOSM'),(52168813,1,'created_by','JOSM'),(52168816,1,'created_by','JOSM'),(52168819,1,'created_by','JOSM'),(52168821,1,'created_by','JOSM'),(52168824,1,'created_by','JOSM'),(52168828,1,'created_by','JOSM'),(52168829,1,'created_by','JOSM'),(52168830,1,'created_by','JOSM'),(52168834,1,'created_by','JOSM'),(52168836,1,'created_by','JOSM'),(52168838,1,'created_by','JOSM'),(52168842,1,'created_by','JOSM'),(52168845,1,'created_by','JOSM'),(52168846,1,'created_by','JOSM'),(52168849,1,'created_by','JOSM'),(52168851,1,'created_by','JOSM'),(52168854,1,'created_by','JOSM'),(52168856,1,'created_by','JOSM'),(52168858,1,'created_by','JOSM'),(52168859,1,'created_by','JOSM'),(52168862,1,'created_by','JOSM'),(52168865,1,'created_by','JOSM'),(52168866,1,'created_by','JOSM'),(52168867,1,'created_by','JOSM'),(52168870,1,'created_by','JOSM'),(52168873,1,'created_by','JOSM'),(52168875,1,'created_by','JOSM'),(52168878,1,'created_by','JOSM'),(52168881,1,'created_by','JOSM'),(52168883,1,'created_by','JOSM'),(52168886,1,'created_by','JOSM'),(52168889,2,'created_by','JOSM'),(52168892,1,'created_by','JOSM'),(52168895,1,'created_by','JOSM'),(52168899,1,'created_by','JOSM'),(52168901,1,'created_by','JOSM'),(52168904,1,'created_by','JOSM'),(52168905,1,'created_by','JOSM'),(52168909,1,'created_by','JOSM'),(52168912,1,'created_by','JOSM'),(52168914,1,'created_by','JOSM'),(52168917,1,'created_by','JOSM'),(52168919,1,'created_by','JOSM'),(52168920,1,'created_by','JOSM'),(52168921,1,'created_by','JOSM'),(52168924,1,'created_by','JOSM'),(52168926,1,'created_by','JOSM'),(52168929,1,'created_by','JOSM'),(52168931,1,'created_by','JOSM'),(52168933,1,'created_by','JOSM'),(52168936,1,'created_by','JOSM'),(52168939,1,'created_by','JOSM'),(52168943,1,'created_by','JOSM'),(52168945,1,'created_by','JOSM'),(52168946,1,'created_by','JOSM'),(52168948,1,'created_by','JOSM'),(52168952,1,'created_by','JOSM'),(52168955,1,'created_by','JOSM'),(52168959,1,'created_by','JOSM'),(52168961,1,'created_by','JOSM'),(52168964,1,'created_by','JOSM'),(52168965,1,'created_by','JOSM'),(52168967,1,'created_by','JOSM'),(52168969,1,'created_by','JOSM'),(52168972,1,'created_by','JOSM'),(52168974,1,'created_by','JOSM'),(52168976,2,'created_by','JOSM'),(52168981,2,'created_by','JOSM'),(52168984,2,'created_by','JOSM'),(52168987,2,'created_by','JOSM'),(52168989,2,'created_by','JOSM'),(52168992,2,'created_by','JOSM'),(52168995,3,'created_by','JOSM'),(52169000,2,'created_by','JOSM'),(52169003,2,'created_by','JOSM'),(52169006,1,'created_by','JOSM'),(52169008,1,'created_by','JOSM'),(52169011,1,'created_by','JOSM'),(52169014,1,'created_by','JOSM'),(52169016,1,'created_by','JOSM'),(52169018,1,'created_by','JOSM'),(52169021,1,'created_by','JOSM'),(52169022,1,'created_by','JOSM'),(52169024,1,'created_by','JOSM'),(52169028,1,'created_by','JOSM'),(52169032,1,'created_by','JOSM'),(52169034,1,'created_by','JOSM'),(52169036,1,'created_by','JOSM'),(52169041,1,'created_by','JOSM'),(52169044,1,'created_by','JOSM'),(52169045,1,'created_by','JOSM'),(52169048,1,'created_by','JOSM'),(52169052,1,'created_by','JOSM'),(52169054,1,'created_by','JOSM'),(52169055,1,'created_by','JOSM'),(52169058,1,'created_by','JOSM'),(52169060,1,'created_by','JOSM'),(52169061,1,'created_by','JOSM'),(52169064,1,'created_by','JOSM'),(52169067,1,'created_by','JOSM'),(52169070,1,'created_by','JOSM'),(52169073,1,'created_by','JOSM'),(52169075,1,'created_by','JOSM'),(52169076,1,'created_by','JOSM'),(52169078,1,'created_by','JOSM'),(52169080,1,'created_by','JOSM'),(52169083,1,'created_by','JOSM'),(52169088,1,'created_by','JOSM'),(52169089,1,'created_by','JOSM'),(52169092,1,'created_by','JOSM'),(52169094,1,'created_by','JOSM'),(52169097,1,'created_by','JOSM'),(52169100,1,'created_by','JOSM'),(52169103,1,'created_by','JOSM'),(52169105,1,'created_by','JOSM'),(52169109,1,'created_by','JOSM'),(52169111,1,'created_by','JOSM'),(52169113,1,'created_by','JOSM'),(52169115,1,'created_by','JOSM'),(52169117,1,'created_by','JOSM'),(52169119,1,'created_by','JOSM'),(52169121,1,'created_by','JOSM'),(52169123,1,'created_by','JOSM'),(52169124,1,'created_by','JOSM'),(52169125,1,'created_by','JOSM'),(52169126,1,'created_by','JOSM'),(52169127,1,'created_by','JOSM'),(52170031,1,'created_by','JOSM'),(52170032,1,'created_by','JOSM'),(52170036,1,'created_by','JOSM'),(52170040,1,'created_by','JOSM'),(52170042,1,'created_by','JOSM'),(52170044,1,'created_by','JOSM'),(52170048,1,'created_by','JOSM'),(52170056,1,'created_by','JOSM'),(52170061,1,'created_by','JOSM'),(52170065,1,'created_by','JOSM'),(52170071,1,'created_by','JOSM'),(52170076,1,'created_by','JOSM'),(52170080,1,'created_by','JOSM'),(52170088,1,'created_by','JOSM'),(52170090,1,'created_by','JOSM'),(52170096,1,'created_by','JOSM'),(52170099,1,'created_by','JOSM'),(52170371,1,'created_by','JOSM'),(52170374,1,'created_by','JOSM'),(52170377,1,'created_by','JOSM'),(52170378,1,'created_by','JOSM'),(52170381,1,'created_by','JOSM'),(52170384,1,'created_by','JOSM'),(52170386,1,'created_by','JOSM'),(52170388,1,'created_by','JOSM'),(52170391,1,'created_by','JOSM'),(52170394,1,'created_by','JOSM'),(52170397,1,'created_by','JOSM'),(52170400,1,'created_by','JOSM'),(52170401,1,'created_by','JOSM'),(52170406,1,'created_by','JOSM'),(52170410,1,'created_by','JOSM'),(52170411,1,'created_by','JOSM'),(52170415,1,'created_by','JOSM'),(52170416,1,'created_by','JOSM'),(52170417,1,'created_by','JOSM'),(52170418,1,'created_by','JOSM'),(52170423,1,'created_by','JOSM'),(52170440,1,'created_by','JOSM'),(52170441,1,'created_by','JOSM'),(52170496,1,'created_by','JOSM'),(52170512,1,'created_by','JOSM'),(52170525,1,'created_by','JOSM'),(52170533,1,'created_by','JOSM'),(52170540,1,'created_by','JOSM'),(52170544,1,'created_by','JOSM'),(52170561,1,'created_by','JOSM'),(52171046,1,'created_by','JOSM'),(52171050,1,'created_by','JOSM'),(52171054,1,'created_by','JOSM'),(52171057,1,'created_by','JOSM'),(52171060,1,'created_by','JOSM'),(52171070,1,'created_by','JOSM'),(52171073,1,'created_by','JOSM'),(52171075,1,'created_by','JOSM'),(52171078,1,'created_by','JOSM'),(52171081,1,'created_by','JOSM'),(52171084,1,'created_by','JOSM'),(52171088,1,'created_by','JOSM'),(52171092,1,'created_by','JOSM'),(52171100,1,'created_by','JOSM'),(52171107,1,'created_by','JOSM'),(52171112,1,'created_by','JOSM'),(52171114,1,'created_by','JOSM'),(52171118,1,'created_by','JOSM'),(52171120,1,'created_by','JOSM'),(52171121,1,'created_by','JOSM'),(52171125,1,'created_by','JOSM'),(52171127,1,'created_by','JOSM'),(52171129,1,'created_by','JOSM'),(52171131,1,'created_by','JOSM'),(52171136,1,'created_by','JOSM'),(52171140,1,'created_by','JOSM'),(52171146,1,'created_by','JOSM'),(52171151,1,'created_by','JOSM'),(52171156,1,'created_by','JOSM'),(52171165,1,'created_by','JOSM'),(52171167,1,'created_by','JOSM'),(52171173,1,'created_by','JOSM'),(52171179,1,'created_by','JOSM'),(52171184,1,'created_by','JOSM'),(52171188,1,'created_by','JOSM'),(52171247,1,'created_by','JOSM'),(52171251,1,'created_by','JOSM'),(52171256,1,'created_by','JOSM'),(52171259,1,'created_by','JOSM'),(52171263,1,'created_by','JOSM'),(52171280,1,'created_by','JOSM'),(52171284,1,'created_by','JOSM'),(52171289,1,'created_by','JOSM'),(52171295,1,'created_by','JOSM'),(52171297,1,'created_by','JOSM'),(52171300,1,'created_by','JOSM'),(52171305,1,'created_by','JOSM'),(52171307,1,'created_by','JOSM'),(52171311,1,'created_by','JOSM'),(52171317,1,'created_by','JOSM'),(52171321,1,'created_by','JOSM'),(52171324,1,'created_by','JOSM'),(52171330,1,'created_by','JOSM'),(52171338,1,'created_by','JOSM'),(52171344,1,'created_by','JOSM'),(52171351,1,'created_by','JOSM'),(52171364,1,'created_by','JOSM'),(52171370,1,'created_by','JOSM'),(52171373,1,'created_by','JOSM'),(52171378,1,'created_by','JOSM'),(52171382,1,'created_by','JOSM'),(52171385,1,'created_by','JOSM'),(52171391,1,'created_by','JOSM'),(52171407,1,'created_by','JOSM'),(52171413,1,'created_by','JOSM'),(52171417,1,'created_by','JOSM'),(52171422,1,'created_by','JOSM'),(52171426,1,'created_by','JOSM'),(52171432,2,'created_by','JOSM'),(52171437,1,'created_by','JOSM'),(52171443,1,'created_by','JOSM'),(52171444,1,'created_by','JOSM'),(52171447,1,'created_by','JOSM'),(52171449,1,'created_by','JOSM'),(52171451,1,'created_by','JOSM'),(52171454,1,'created_by','JOSM'),(52171458,1,'created_by','JOSM'),(52171465,1,'created_by','JOSM'),(52171467,1,'created_by','JOSM'),(52171474,1,'created_by','JOSM'),(52171479,1,'created_by','JOSM'),(52171481,1,'created_by','JOSM'),(52171485,1,'created_by','JOSM'),(52171487,1,'created_by','JOSM'),(52171491,1,'created_by','JOSM'),(52171494,1,'created_by','JOSM'),(52171498,1,'created_by','JOSM'),(52171503,1,'created_by','JOSM'),(52171506,1,'created_by','JOSM'),(52171511,1,'created_by','JOSM'),(52171515,1,'created_by','JOSM'),(52171521,1,'created_by','JOSM'),(52171525,1,'created_by','JOSM'),(52171528,1,'created_by','JOSM'),(52171531,1,'created_by','JOSM'),(52171534,1,'created_by','JOSM'),(52171537,1,'created_by','JOSM'),(52171542,1,'created_by','JOSM'),(52171547,2,'created_by','JOSM'),(52171553,2,'created_by','JOSM'),(52171557,1,'created_by','JOSM'),(52171562,1,'created_by','JOSM'),(52171569,1,'created_by','JOSM'),(52171574,1,'created_by','JOSM'),(52171579,1,'created_by','JOSM'),(52171585,1,'created_by','JOSM'),(52171590,1,'created_by','JOSM'),(52171594,1,'created_by','JOSM'),(52171595,1,'created_by','JOSM'),(52171601,1,'created_by','JOSM'),(52171606,1,'created_by','JOSM'),(52171610,1,'created_by','JOSM'),(52171616,1,'created_by','JOSM'),(52171622,1,'created_by','JOSM'),(52171628,1,'created_by','JOSM'),(52171633,1,'created_by','JOSM'),(52171636,1,'created_by','JOSM'),(52171644,1,'created_by','JOSM'),(52171649,1,'created_by','JOSM'),(52171653,1,'created_by','JOSM'),(52171656,1,'created_by','JOSM'),(52171659,1,'created_by','JOSM'),(52171662,1,'created_by','JOSM'),(52171665,1,'created_by','JOSM'),(52171764,2,'created_by','JOSM'),(52171771,1,'created_by','JOSM'),(52171775,1,'created_by','JOSM'),(52171777,1,'created_by','JOSM'),(52171781,1,'created_by','JOSM'),(52171785,1,'created_by','JOSM'),(52171787,1,'created_by','JOSM'),(52171790,1,'created_by','JOSM'),(52171795,1,'created_by','JOSM'),(52171797,1,'created_by','JOSM'),(52171801,1,'created_by','JOSM'),(52171805,1,'created_by','JOSM'),(52171808,1,'created_by','JOSM'),(52171810,1,'created_by','JOSM'),(52171811,1,'created_by','JOSM'),(52171814,1,'created_by','JOSM'),(52171815,1,'created_by','JOSM'),(52171818,1,'created_by','JOSM'),(52171820,1,'created_by','JOSM'),(52171822,1,'created_by','JOSM'),(52171825,1,'created_by','JOSM'),(52171858,1,'created_by','JOSM'),(52171863,1,'created_by','JOSM'),(52171867,1,'created_by','JOSM'),(52171885,1,'created_by','JOSM'),(52171888,1,'created_by','JOSM'),(52171892,1,'created_by','JOSM'),(52171895,1,'created_by','JOSM'),(52171932,1,'created_by','JOSM'),(52171934,1,'created_by','JOSM'),(52171940,1,'created_by','JOSM'),(52171942,1,'created_by','JOSM'),(52171945,1,'created_by','JOSM'),(52171948,1,'created_by','JOSM'),(52171949,1,'created_by','JOSM'),(52171952,1,'created_by','JOSM'),(52171963,1,'created_by','JOSM'),(52171972,1,'created_by','JOSM'),(52171975,1,'created_by','JOSM'),(52171977,1,'created_by','JOSM'),(52171979,1,'created_by','JOSM'),(52171981,1,'created_by','JOSM'),(52171985,1,'created_by','JOSM'),(52171988,1,'created_by','JOSM'),(52171989,1,'created_by','JOSM'),(52171991,1,'created_by','JOSM'),(52171995,1,'created_by','JOSM'),(52171996,1,'created_by','JOSM'),(52171997,1,'created_by','JOSM'),(52172001,1,'created_by','JOSM'),(52172006,1,'created_by','JOSM'),(52172008,1,'created_by','JOSM'),(52172012,1,'created_by','JOSM'),(52172014,1,'created_by','JOSM'),(52172016,1,'created_by','JOSM'),(52172033,1,'created_by','JOSM'),(52172036,1,'created_by','JOSM'),(52172049,1,'created_by','JOSM'),(52172050,1,'created_by','JOSM'),(52172086,1,'created_by','JOSM'),(52172090,1,'created_by','JOSM'),(52172092,1,'created_by','JOSM'),(52172096,1,'created_by','JOSM'),(52172099,1,'created_by','JOSM'),(52172102,1,'created_by','JOSM'),(52172104,1,'created_by','JOSM'),(52172105,1,'created_by','JOSM'),(52172106,1,'created_by','JOSM'),(52172107,1,'created_by','JOSM'),(52172109,1,'created_by','JOSM'),(52172111,1,'created_by','JOSM'),(52172122,1,'created_by','JOSM'),(52172124,1,'created_by','JOSM'),(52172128,1,'created_by','JOSM'),(52172129,1,'created_by','JOSM'),(52172131,1,'created_by','JOSM'),(52172133,1,'created_by','JOSM'),(52172135,1,'created_by','JOSM'),(52172139,1,'created_by','JOSM'),(52172141,1,'created_by','JOSM'),(52172144,1,'created_by','JOSM'),(52172147,1,'created_by','JOSM'),(52172150,1,'created_by','JOSM'),(52172153,1,'created_by','JOSM'),(52172156,1,'created_by','JOSM'),(52172158,1,'created_by','JOSM'),(52172161,1,'created_by','JOSM'),(52172164,1,'created_by','JOSM'),(52172166,1,'created_by','JOSM'),(52172168,1,'created_by','JOSM'),(52172170,1,'created_by','JOSM'),(52172172,1,'created_by','JOSM'),(52172175,1,'created_by','JOSM'),(52172178,1,'created_by','JOSM'),(52172181,1,'created_by','JOSM'),(52202283,1,'created_by','JOSM'),(52202293,1,'created_by','JOSM'),(52202298,1,'created_by','JOSM'),(52202362,1,'created_by','JOSM'),(52202389,1,'created_by','JOSM'),(52202451,1,'created_by','JOSM'),(52202455,1,'created_by','JOSM'),(52202460,1,'created_by','JOSM'),(52202465,1,'created_by','JOSM'),(52202468,1,'created_by','JOSM'),(52202473,1,'created_by','JOSM'),(52202476,1,'created_by','JOSM'),(52202485,1,'created_by','JOSM'),(52202488,1,'created_by','JOSM'),(52202493,1,'created_by','JOSM'),(52202499,1,'created_by','JOSM'),(52202507,1,'created_by','JOSM'),(52202511,1,'created_by','JOSM'),(52202517,1,'created_by','JOSM'),(52202521,1,'created_by','JOSM'),(52202523,1,'created_by','JOSM'),(52202526,1,'created_by','JOSM'),(52202528,1,'created_by','JOSM'),(52202533,1,'created_by','JOSM'),(52202534,2,'created_by','JOSM'),(52202539,2,'created_by','JOSM'),(52202541,3,'created_by','JOSM'),(52202545,2,'created_by','JOSM'),(52202549,2,'created_by','JOSM'),(52202552,2,'created_by','JOSM'),(52202553,2,'created_by','JOSM'),(52202560,1,'created_by','JOSM'),(52202566,1,'created_by','JOSM'),(52202571,1,'created_by','JOSM'),(52202579,2,'created_by','JOSM'),(52203066,2,'created_by','JOSM'),(52204239,3,'created_by','JOSM'),(52204243,2,'created_by','JOSM'),(52204246,2,'created_by','JOSM'),(52204248,2,'created_by','JOSM'),(52204251,2,'created_by','JOSM'),(52204254,2,'created_by','JOSM'),(52204258,2,'created_by','JOSM'),(52204261,1,'created_by','JOSM'),(52204265,1,'created_by','JOSM'),(52204267,1,'created_by','JOSM'),(52204269,1,'created_by','JOSM'),(52204275,1,'created_by','JOSM'),(52204280,1,'created_by','JOSM'),(52204284,1,'created_by','JOSM'),(52204288,1,'created_by','JOSM'),(52204292,2,'created_by','JOSM'),(52204294,2,'created_by','JOSM'),(52204296,1,'created_by','JOSM'),(52204307,1,'created_by','JOSM'),(52204324,1,'created_by','JOSM'),(52204328,1,'created_by','JOSM'),(52204344,1,'created_by','JOSM'),(52204350,1,'created_by','JOSM'),(52204353,1,'created_by','JOSM'),(52204354,1,'created_by','JOSM'),(52204363,1,'created_by','JOSM'),(52204366,1,'created_by','JOSM'),(52204368,1,'created_by','JOSM'),(52204371,1,'created_by','JOSM'),(52204375,1,'created_by','JOSM'),(52204377,1,'created_by','JOSM'),(52204380,1,'created_by','JOSM'),(52204383,1,'created_by','JOSM'),(52204386,1,'created_by','JOSM'),(52204388,1,'created_by','JOSM'),(52204391,1,'created_by','JOSM'),(52204394,1,'created_by','JOSM'),(52204397,1,'created_by','JOSM'),(52204401,1,'created_by','JOSM'),(52204404,1,'created_by','JOSM'),(52204407,2,'created_by','JOSM'),(52204415,1,'created_by','JOSM'),(52204417,1,'created_by','JOSM'),(52204420,1,'created_by','JOSM'),(52204423,1,'created_by','JOSM'),(52204425,1,'created_by','JOSM'),(52204428,1,'created_by','JOSM'),(52204431,1,'created_by','JOSM'),(52204434,1,'created_by','JOSM'),(52204436,1,'created_by','JOSM'),(52204439,1,'created_by','JOSM'),(52204442,3,'created_by','JOSM'),(52204445,4,'created_by','JOSM'),(52204446,4,'created_by','JOSM'),(52204450,3,'created_by','JOSM'),(52204453,1,'created_by','JOSM'),(52204456,1,'created_by','JOSM'),(52204459,1,'created_by','JOSM'),(52204462,1,'created_by','JOSM'),(52204465,1,'created_by','JOSM'),(52204467,1,'created_by','JOSM'),(52204470,1,'created_by','JOSM'),(52204473,1,'created_by','JOSM'),(52204476,1,'created_by','JOSM'),(52204478,1,'created_by','JOSM'),(52204480,1,'created_by','JOSM'),(52204483,1,'created_by','JOSM'),(52204485,1,'created_by','JOSM'),(52204488,1,'created_by','JOSM'),(52204492,1,'created_by','JOSM'),(52204495,1,'created_by','JOSM'),(52204498,1,'created_by','JOSM'),(52204501,1,'created_by','JOSM'),(52204504,1,'created_by','JOSM'),(52204505,1,'created_by','JOSM'),(52204513,1,'created_by','JOSM'),(52204516,1,'created_by','JOSM'),(52204520,1,'created_by','JOSM'),(52204523,1,'created_by','JOSM'),(52204525,1,'created_by','JOSM'),(52204528,1,'created_by','JOSM'),(52204531,1,'created_by','JOSM'),(52204534,1,'created_by','JOSM'),(52204536,1,'created_by','JOSM'),(52204541,1,'created_by','JOSM'),(52204544,1,'created_by','JOSM'),(52204547,1,'created_by','JOSM'),(52204549,1,'created_by','JOSM'),(52204553,1,'created_by','JOSM'),(52204565,1,'created_by','JOSM'),(52204568,1,'created_by','JOSM'),(52204624,1,'created_by','JOSM'),(52204627,1,'created_by','JOSM'),(52204664,1,'created_by','JOSM'),(52204665,1,'created_by','JOSM'),(52204668,1,'created_by','JOSM'),(52204669,1,'created_by','JOSM'),(52204670,1,'created_by','JOSM'),(52204747,1,'created_by','JOSM'),(52204750,1,'created_by','JOSM'),(52204798,1,'created_by','JOSM'),(52204800,1,'created_by','JOSM'),(52204903,1,'created_by','JOSM'),(52204912,1,'created_by','JOSM'),(52204916,1,'created_by','JOSM'),(52204922,1,'created_by','JOSM'),(52204983,1,'created_by','JOSM'),(52205002,1,'created_by','JOSM'),(52205008,1,'created_by','JOSM'),(52205014,1,'created_by','JOSM'),(52205020,1,'created_by','JOSM'),(52205022,1,'created_by','JOSM'),(52205029,1,'created_by','JOSM'),(52205032,1,'created_by','JOSM'),(52205035,1,'created_by','JOSM'),(52205038,1,'created_by','JOSM'),(52205041,1,'created_by','JOSM'),(52205043,1,'created_by','JOSM'),(52205046,1,'created_by','JOSM'),(52205050,1,'created_by','JOSM'),(52205053,1,'created_by','JOSM'),(52205055,1,'created_by','JOSM'),(52205059,1,'created_by','JOSM'),(52205063,1,'created_by','JOSM'),(52205065,1,'created_by','JOSM'),(52205070,1,'created_by','JOSM'),(52205073,1,'created_by','JOSM'),(52205075,1,'created_by','JOSM'),(52205077,1,'created_by','JOSM'),(52205079,1,'created_by','JOSM'),(52205080,1,'created_by','JOSM'),(52205082,1,'created_by','JOSM'),(52205084,1,'created_by','JOSM');
INSERT INTO `node_tags` VALUES (52205086,1,'created_by','JOSM'),(52205087,1,'created_by','JOSM'),(52205089,1,'created_by','JOSM'),(52205090,1,'created_by','JOSM'),(52205091,1,'created_by','JOSM'),(52205092,1,'created_by','JOSM'),(52205093,1,'created_by','JOSM'),(52205094,1,'created_by','JOSM'),(52205095,1,'created_by','JOSM'),(52205096,1,'created_by','JOSM'),(52205099,1,'created_by','JOSM'),(52205101,1,'created_by','JOSM'),(52205105,1,'created_by','JOSM'),(52205107,1,'created_by','JOSM'),(52205110,1,'created_by','JOSM'),(52205113,1,'created_by','JOSM'),(52205116,1,'created_by','JOSM'),(52205122,1,'created_by','JOSM'),(52205123,1,'created_by','JOSM'),(52205126,1,'created_by','JOSM'),(52205131,1,'created_by','JOSM'),(52205132,1,'created_by','JOSM'),(52205135,1,'created_by','JOSM'),(52205138,1,'created_by','JOSM'),(52205141,1,'created_by','JOSM'),(52205144,1,'created_by','JOSM'),(52205148,1,'created_by','JOSM'),(52205150,1,'created_by','JOSM'),(52205154,1,'created_by','JOSM'),(52205161,1,'created_by','JOSM'),(52205166,1,'created_by','JOSM'),(52205171,1,'created_by','JOSM'),(52205175,1,'created_by','JOSM'),(52205176,1,'created_by','JOSM'),(52205177,1,'created_by','JOSM'),(52205182,1,'created_by','JOSM'),(52205186,1,'created_by','JOSM'),(52205188,1,'created_by','JOSM'),(52205196,1,'created_by','JOSM'),(52205200,1,'created_by','JOSM'),(52205206,1,'created_by','JOSM'),(52205212,1,'created_by','JOSM'),(52205218,1,'created_by','JOSM'),(52205222,1,'created_by','JOSM'),(52205225,1,'created_by','JOSM'),(52205230,1,'created_by','JOSM'),(52205232,1,'created_by','JOSM'),(52205239,1,'created_by','JOSM'),(52205242,1,'created_by','JOSM'),(52205244,1,'created_by','JOSM'),(52205248,1,'created_by','JOSM'),(52205252,1,'created_by','JOSM'),(52205257,1,'created_by','JOSM'),(52205261,1,'created_by','JOSM'),(52205266,1,'created_by','JOSM'),(52205269,1,'created_by','JOSM'),(52205274,1,'created_by','JOSM'),(52205280,1,'created_by','JOSM'),(52205284,1,'created_by','JOSM'),(52205286,1,'created_by','JOSM'),(52205290,1,'created_by','JOSM'),(52205296,1,'created_by','JOSM'),(52205298,1,'created_by','JOSM'),(52205301,1,'created_by','JOSM'),(52205304,1,'created_by','JOSM'),(52205306,1,'created_by','JOSM'),(52205309,1,'created_by','JOSM'),(52205311,1,'created_by','JOSM'),(52205317,1,'created_by','JOSM'),(52205404,1,'created_by','JOSM'),(52205416,1,'created_by','JOSM'),(52205422,1,'created_by','JOSM'),(52205427,1,'created_by','JOSM'),(52205431,1,'created_by','JOSM'),(52205434,1,'created_by','JOSM'),(52205438,1,'created_by','JOSM'),(52205450,1,'created_by','JOSM'),(52205456,1,'created_by','JOSM'),(52205461,1,'created_by','JOSM'),(52205464,1,'created_by','JOSM'),(52205469,1,'created_by','JOSM'),(52205473,1,'created_by','JOSM'),(52205475,1,'created_by','JOSM'),(52205480,1,'created_by','JOSM'),(52205485,1,'created_by','JOSM'),(52205489,1,'created_by','JOSM'),(52205492,1,'created_by','JOSM'),(52205496,1,'created_by','JOSM'),(52205622,1,'created_by','JOSM'),(52205637,1,'created_by','JOSM'),(52205641,1,'created_by','JOSM'),(52205671,1,'created_by','JOSM'),(52205676,1,'created_by','JOSM'),(52205678,1,'created_by','JOSM'),(52205679,1,'created_by','JOSM'),(52205681,1,'created_by','JOSM'),(52205685,1,'created_by','JOSM'),(52205687,1,'created_by','JOSM'),(52205690,1,'created_by','JOSM'),(52205693,1,'created_by','JOSM'),(52205695,1,'created_by','JOSM'),(52205699,1,'created_by','JOSM'),(52205703,1,'created_by','JOSM'),(52205707,1,'created_by','JOSM'),(52205709,1,'created_by','JOSM'),(52205712,1,'created_by','JOSM'),(52205713,1,'created_by','JOSM'),(52205715,1,'created_by','JOSM'),(52205774,1,'created_by','JOSM'),(52205782,1,'created_by','JOSM'),(52205785,1,'created_by','JOSM'),(52205813,1,'created_by','JOSM'),(52205820,1,'created_by','JOSM'),(52205823,1,'created_by','JOSM'),(52205828,1,'created_by','JOSM'),(52205830,1,'created_by','JOSM'),(52205836,1,'created_by','JOSM'),(52205839,1,'created_by','JOSM'),(52205843,1,'created_by','JOSM'),(52205846,1,'created_by','JOSM'),(52205849,1,'created_by','JOSM'),(52205852,1,'created_by','JOSM'),(52205855,1,'created_by','JOSM'),(52205859,1,'created_by','JOSM'),(52205863,1,'created_by','JOSM'),(52205865,1,'created_by','JOSM'),(52205869,1,'created_by','JOSM'),(52205873,1,'created_by','JOSM'),(52205876,1,'created_by','JOSM'),(52205880,1,'created_by','JOSM'),(52205882,1,'created_by','JOSM'),(52205885,1,'created_by','JOSM'),(52205888,1,'created_by','JOSM'),(52205891,1,'created_by','JOSM'),(52205893,1,'created_by','JOSM'),(52205896,1,'created_by','JOSM'),(52205898,1,'created_by','JOSM'),(52205901,1,'created_by','JOSM'),(52205904,1,'created_by','JOSM'),(52205907,1,'created_by','JOSM'),(52205910,1,'created_by','JOSM'),(52205913,1,'created_by','JOSM'),(52205915,1,'created_by','JOSM'),(52205924,1,'created_by','JOSM'),(52205929,1,'created_by','JOSM'),(52205930,1,'created_by','JOSM'),(52205935,1,'created_by','JOSM'),(52205937,1,'created_by','JOSM'),(52205938,1,'created_by','JOSM'),(52205941,1,'created_by','JOSM'),(52205945,1,'created_by','JOSM'),(52205948,1,'created_by','JOSM'),(52205951,1,'created_by','JOSM'),(52205955,1,'created_by','JOSM'),(52205959,1,'created_by','JOSM'),(52205964,1,'created_by','JOSM'),(52205967,1,'created_by','JOSM'),(52205972,1,'created_by','JOSM'),(52205973,1,'created_by','JOSM'),(52205977,1,'created_by','JOSM'),(52205980,1,'created_by','JOSM'),(52205983,1,'created_by','JOSM'),(52205985,1,'created_by','JOSM'),(52205987,1,'created_by','JOSM'),(52205990,1,'created_by','JOSM'),(52205992,1,'created_by','JOSM'),(52205994,1,'created_by','JOSM'),(52205996,1,'created_by','JOSM'),(52205998,1,'created_by','JOSM'),(52206000,1,'created_by','JOSM'),(52206003,1,'created_by','JOSM'),(52206005,1,'created_by','JOSM'),(52206007,1,'created_by','JOSM'),(52206009,1,'created_by','JOSM'),(52206010,1,'created_by','JOSM'),(52206014,1,'created_by','JOSM'),(52206016,1,'created_by','JOSM'),(52206018,1,'created_by','JOSM'),(52206020,1,'created_by','JOSM'),(52206023,1,'created_by','JOSM'),(52206025,1,'created_by','JOSM'),(52206031,1,'created_by','JOSM'),(52206033,1,'created_by','JOSM'),(52206036,1,'created_by','JOSM'),(52206040,1,'created_by','JOSM'),(52206041,1,'created_by','JOSM'),(52206044,1,'created_by','JOSM'),(52206048,1,'created_by','JOSM'),(52206051,1,'created_by','JOSM'),(52206054,1,'created_by','JOSM'),(52206057,1,'created_by','JOSM'),(52206060,1,'created_by','JOSM'),(52206063,1,'created_by','JOSM'),(52206068,1,'created_by','JOSM'),(52206069,1,'created_by','JOSM'),(52206072,1,'created_by','JOSM'),(52206076,1,'created_by','JOSM'),(52206078,1,'created_by','JOSM'),(52206165,1,'created_by','JOSM'),(52206177,1,'created_by','JOSM'),(52206181,1,'created_by','JOSM'),(52206185,1,'created_by','JOSM'),(52206187,1,'created_by','JOSM'),(52206189,1,'created_by','JOSM'),(52206193,1,'created_by','JOSM'),(52206195,1,'created_by','JOSM'),(52206198,1,'created_by','JOSM'),(52206202,1,'created_by','JOSM'),(52206203,1,'created_by','JOSM'),(52206207,1,'created_by','JOSM'),(52206209,1,'created_by','JOSM'),(52206212,1,'created_by','JOSM'),(52206215,1,'created_by','JOSM'),(52206218,1,'created_by','JOSM'),(52206221,1,'created_by','JOSM'),(52206225,1,'created_by','JOSM'),(52206228,1,'created_by','JOSM'),(52206231,1,'created_by','JOSM'),(52206234,1,'created_by','JOSM'),(52206238,1,'created_by','JOSM'),(52206240,1,'created_by','JOSM'),(52206242,1,'created_by','JOSM'),(52206244,1,'created_by','JOSM'),(52206250,1,'created_by','JOSM'),(52206252,1,'created_by','JOSM'),(52206254,1,'created_by','JOSM'),(52206256,1,'created_by','JOSM'),(52206259,1,'created_by','JOSM'),(52206262,1,'created_by','JOSM'),(52206266,1,'created_by','JOSM'),(52206268,1,'created_by','JOSM'),(52206271,1,'created_by','JOSM'),(52206274,1,'created_by','JOSM'),(52206277,1,'created_by','JOSM'),(52206280,1,'created_by','JOSM'),(52206283,1,'created_by','JOSM'),(52206286,1,'created_by','JOSM'),(52206290,1,'created_by','JOSM'),(52206293,1,'created_by','JOSM'),(52206294,1,'created_by','JOSM'),(52206299,1,'created_by','JOSM'),(52206302,1,'created_by','JOSM'),(52206304,1,'created_by','JOSM'),(52206306,1,'created_by','JOSM'),(52206310,1,'created_by','JOSM'),(52206312,1,'created_by','JOSM'),(52206315,1,'created_by','JOSM'),(52206317,1,'created_by','JOSM'),(52206320,1,'created_by','JOSM'),(52206321,1,'created_by','JOSM'),(52206324,1,'created_by','JOSM'),(52206327,1,'created_by','JOSM'),(52206333,1,'created_by','JOSM'),(52206336,1,'created_by','JOSM'),(52206337,1,'created_by','JOSM'),(52206340,1,'created_by','JOSM'),(52206343,1,'created_by','JOSM'),(52206344,1,'created_by','JOSM'),(52206347,1,'created_by','JOSM'),(52206349,1,'created_by','JOSM'),(52206352,1,'created_by','JOSM'),(52206354,1,'created_by','JOSM'),(52206356,1,'created_by','JOSM'),(52206358,1,'created_by','JOSM'),(52206359,1,'created_by','JOSM'),(52206360,1,'created_by','JOSM'),(52206364,1,'created_by','JOSM'),(52206366,1,'created_by','JOSM'),(52206374,1,'created_by','JOSM'),(52206379,1,'created_by','JOSM'),(52206383,1,'created_by','JOSM'),(52206385,1,'created_by','JOSM'),(52206389,1,'created_by','JOSM'),(52206395,1,'created_by','JOSM'),(52206400,1,'created_by','JOSM'),(52206404,1,'created_by','JOSM'),(52206407,1,'created_by','JOSM'),(52206410,1,'created_by','JOSM'),(52206414,1,'created_by','JOSM'),(52206419,1,'created_by','JOSM'),(52206420,1,'created_by','JOSM'),(52206422,1,'created_by','JOSM'),(52206425,1,'created_by','JOSM'),(52206429,1,'created_by','JOSM'),(52206433,1,'created_by','JOSM'),(52206435,1,'created_by','JOSM'),(52206439,1,'created_by','JOSM'),(52206442,1,'created_by','JOSM'),(52206446,1,'created_by','JOSM'),(52206447,1,'created_by','JOSM'),(52206449,1,'created_by','JOSM'),(52206453,1,'created_by','JOSM'),(52206457,1,'created_by','JOSM'),(52206461,1,'created_by','JOSM'),(52206468,1,'created_by','JOSM'),(52206471,1,'created_by','JOSM'),(52206472,1,'created_by','JOSM'),(52206476,1,'created_by','JOSM'),(52206479,1,'created_by','JOSM'),(52206483,1,'created_by','JOSM'),(52206486,1,'created_by','JOSM'),(52206488,1,'created_by','JOSM'),(52206491,1,'created_by','JOSM'),(52206495,1,'created_by','JOSM'),(52206498,1,'created_by','JOSM'),(52206502,1,'created_by','JOSM'),(52206505,1,'created_by','JOSM'),(52206508,1,'created_by','JOSM'),(52206512,1,'created_by','JOSM'),(52206580,1,'created_by','JOSM'),(52206583,1,'created_by','JOSM'),(52206585,1,'created_by','JOSM'),(52206588,1,'created_by','JOSM'),(52206591,1,'created_by','JOSM'),(52206601,1,'created_by','JOSM'),(52206604,1,'created_by','JOSM'),(52206607,1,'created_by','JOSM'),(52206609,1,'created_by','JOSM'),(52206611,1,'created_by','JOSM'),(52206615,1,'created_by','JOSM'),(52206617,1,'created_by','JOSM'),(52206619,1,'created_by','JOSM'),(52206620,1,'created_by','JOSM'),(52206622,1,'created_by','JOSM'),(52206625,1,'created_by','JOSM'),(52206627,1,'created_by','JOSM'),(52206628,1,'created_by','JOSM'),(52206632,1,'created_by','JOSM'),(52206635,1,'created_by','JOSM'),(52206639,1,'created_by','JOSM'),(52206643,3,'created_by','JOSM'),(52206645,1,'created_by','JOSM'),(52206647,1,'created_by','JOSM'),(52206650,1,'created_by','JOSM'),(52206653,1,'created_by','JOSM'),(52206655,1,'created_by','JOSM'),(52206657,1,'created_by','JOSM'),(52206661,1,'created_by','JOSM'),(52206663,1,'created_by','JOSM'),(52206666,1,'created_by','JOSM'),(52206669,1,'created_by','JOSM'),(52206671,1,'created_by','JOSM'),(52206673,1,'created_by','JOSM'),(52206676,1,'created_by','JOSM'),(52206679,1,'created_by','JOSM'),(52206681,1,'created_by','JOSM'),(52206684,1,'created_by','JOSM'),(52206686,1,'created_by','JOSM'),(52206688,1,'created_by','JOSM'),(52206694,1,'created_by','JOSM'),(52206698,1,'created_by','JOSM'),(52206701,1,'created_by','JOSM'),(52206703,1,'created_by','JOSM'),(52206706,1,'created_by','JOSM'),(52206708,1,'created_by','JOSM'),(52206710,1,'created_by','JOSM'),(52206714,1,'created_by','JOSM'),(52212234,1,'created_by','JOSM'),(52212307,1,'created_by','JOSM'),(52212628,1,'created_by','JOSM'),(52212746,1,'created_by','JOSM'),(52212871,1,'created_by','JOSM'),(52212893,1,'created_by','JOSM'),(52212906,1,'created_by','JOSM'),(52212916,1,'created_by','JOSM'),(52212920,1,'created_by','JOSM'),(52252247,1,'created_by','JOSM'),(52252315,1,'created_by','JOSM'),(52252320,1,'created_by','JOSM'),(52252322,1,'created_by','JOSM'),(52252325,1,'created_by','JOSM'),(52252326,1,'created_by','JOSM'),(52252328,1,'created_by','JOSM'),(52252330,1,'created_by','JOSM'),(52252331,1,'created_by','JOSM'),(52252333,1,'created_by','JOSM'),(52252336,1,'created_by','JOSM'),(52252404,1,'created_by','JOSM'),(52252405,1,'created_by','JOSM'),(52252407,1,'created_by','JOSM'),(52252411,1,'created_by','JOSM'),(52252412,1,'created_by','JOSM'),(52252414,1,'created_by','JOSM'),(52252416,1,'created_by','JOSM'),(52252417,1,'created_by','JOSM'),(52252420,1,'created_by','JOSM'),(52252422,1,'created_by','JOSM'),(52252423,1,'created_by','JOSM'),(52252424,1,'created_by','JOSM'),(52252426,1,'created_by','JOSM'),(52252427,1,'created_by','JOSM'),(52252429,1,'created_by','JOSM'),(52252430,1,'created_by','JOSM'),(52252431,1,'created_by','JOSM'),(52252433,1,'created_by','JOSM'),(52252434,1,'created_by','JOSM'),(52252435,1,'created_by','JOSM'),(52252437,1,'created_by','JOSM'),(52252452,1,'created_by','JOSM'),(52252472,1,'created_by','JOSM'),(52252473,1,'created_by','JOSM'),(52252474,1,'created_by','JOSM'),(52252475,1,'created_by','JOSM'),(52252476,1,'created_by','JOSM'),(52252477,1,'created_by','JOSM'),(52252478,1,'created_by','JOSM'),(52252479,1,'created_by','JOSM'),(52252480,1,'created_by','JOSM'),(52261829,1,'created_by','JOSM'),(52261834,1,'created_by','JOSM'),(52261835,1,'created_by','JOSM'),(52261839,1,'created_by','JOSM'),(52261842,1,'created_by','JOSM'),(52261846,1,'created_by','JOSM'),(52261850,1,'created_by','JOSM'),(52261853,1,'created_by','JOSM'),(52261857,1,'created_by','JOSM'),(52261860,1,'created_by','JOSM'),(52261864,1,'created_by','JOSM'),(52261866,1,'created_by','JOSM'),(52261869,1,'created_by','JOSM'),(52261872,1,'created_by','JOSM'),(52261874,1,'created_by','JOSM'),(52261878,1,'created_by','JOSM'),(52261880,1,'created_by','JOSM'),(52261883,1,'created_by','JOSM'),(52261999,1,'created_by','JOSM'),(52262003,1,'created_by','JOSM'),(52262006,1,'created_by','JOSM'),(52262010,1,'created_by','JOSM'),(52262016,1,'created_by','JOSM'),(52262020,1,'created_by','JOSM'),(52262166,5,'name','Pont de Faucellers'),(52262538,1,'created_by','JOSM'),(52262541,1,'created_by','JOSM'),(52262544,1,'created_by','JOSM'),(52262546,1,'created_by','JOSM'),(52262550,1,'created_by','JOSM'),(52262552,1,'created_by','JOSM'),(52262556,1,'created_by','JOSM'),(52262560,1,'created_by','JOSM'),(52262563,1,'created_by','JOSM'),(52262910,1,'created_by','JOSM'),(52262913,1,'created_by','JOSM'),(52262916,1,'created_by','JOSM'),(52262919,1,'created_by','JOSM'),(52262921,1,'created_by','JOSM'),(52262925,1,'created_by','JOSM'),(52262930,1,'created_by','JOSM'),(52262934,1,'created_by','JOSM'),(52262941,1,'created_by','JOSM'),(52262944,1,'created_by','JOSM'),(52262946,1,'created_by','JOSM'),(52262949,1,'created_by','JOSM'),(52262954,1,'created_by','JOSM'),(52262957,1,'created_by','JOSM'),(52262961,1,'created_by','JOSM'),(52262963,1,'created_by','JOSM'),(52262970,1,'created_by','JOSM'),(52262973,1,'created_by','JOSM'),(52262977,1,'created_by','JOSM'),(52262979,1,'created_by','JOSM'),(52262981,1,'created_by','JOSM'),(52263076,1,'created_by','JOSM'),(52263079,1,'created_by','JOSM'),(52263083,1,'created_by','JOSM'),(52263091,1,'created_by','JOSM'),(52263095,1,'created_by','JOSM'),(52263098,1,'created_by','JOSM'),(52263100,1,'created_by','JOSM'),(52263106,1,'created_by','JOSM'),(52263109,1,'created_by','JOSM'),(52263111,1,'created_by','JOSM'),(52263113,1,'created_by','JOSM'),(52263117,1,'created_by','JOSM'),(52263119,1,'created_by','JOSM'),(52263162,1,'created_by','JOSM'),(52263166,1,'created_by','JOSM'),(52263168,1,'created_by','JOSM'),(52263171,1,'created_by','JOSM'),(52263173,1,'created_by','JOSM'),(52263177,1,'created_by','JOSM'),(52263180,1,'created_by','JOSM'),(52263183,1,'created_by','JOSM'),(52263186,1,'created_by','JOSM'),(52263190,1,'created_by','JOSM'),(52263191,1,'created_by','JOSM'),(52263549,1,'created_by','JOSM'),(52263553,1,'created_by','JOSM'),(52263554,1,'created_by','JOSM'),(52263556,1,'created_by','JOSM'),(52263559,1,'created_by','JOSM'),(52263560,1,'created_by','JOSM'),(52263563,1,'created_by','JOSM'),(52263566,1,'created_by','JOSM'),(52263570,1,'created_by','JOSM'),(52263573,1,'created_by','JOSM'),(52263575,1,'created_by','JOSM'),(52263577,1,'created_by','JOSM'),(52263579,1,'created_by','JOSM'),(52263581,1,'created_by','JOSM'),(52263584,1,'created_by','JOSM'),(52263586,1,'created_by','JOSM'),(52263588,1,'created_by','JOSM'),(52263593,1,'created_by','JOSM'),(52263595,1,'created_by','JOSM'),(52263598,1,'created_by','JOSM'),(52263602,1,'created_by','JOSM'),(52263605,1,'created_by','JOSM'),(52263608,1,'created_by','JOSM'),(52263611,1,'created_by','JOSM'),(52263615,1,'created_by','JOSM'),(52263617,1,'created_by','JOSM'),(52263618,1,'created_by','JOSM'),(52263623,1,'created_by','JOSM'),(52263625,1,'created_by','JOSM'),(52263628,1,'created_by','JOSM'),(52263629,1,'created_by','JOSM'),(52263632,1,'created_by','JOSM'),(52263634,1,'created_by','JOSM'),(52263637,1,'created_by','JOSM'),(52263639,1,'created_by','JOSM'),(52263641,1,'created_by','JOSM'),(52263644,1,'created_by','JOSM'),(52263646,1,'created_by','JOSM'),(52263649,1,'created_by','JOSM'),(52263650,1,'created_by','JOSM'),(52263652,1,'created_by','JOSM'),(52263655,1,'created_by','JOSM'),(52263657,1,'created_by','JOSM'),(52263660,1,'created_by','JOSM'),(52263662,1,'created_by','JOSM'),(52263665,1,'created_by','JOSM'),(52263667,1,'created_by','JOSM'),(52263669,1,'created_by','JOSM'),(52263670,1,'created_by','JOSM'),(52263672,1,'created_by','JOSM'),(52263674,1,'created_by','JOSM'),(52263677,1,'created_by','JOSM'),(52263678,1,'created_by','JOSM'),(52263681,1,'created_by','JOSM'),(52263683,1,'created_by','JOSM'),(52263686,1,'created_by','JOSM'),(52263687,1,'created_by','JOSM'),(52263688,1,'created_by','JOSM'),(52263691,1,'created_by','JOSM'),(52263693,1,'created_by','JOSM'),(52263696,1,'created_by','JOSM'),(52263698,1,'created_by','JOSM'),(52263700,1,'created_by','JOSM'),(52263702,1,'created_by','JOSM'),(52263704,1,'created_by','JOSM'),(52263706,1,'created_by','JOSM'),(52263708,1,'created_by','JOSM'),(52263711,1,'created_by','JOSM'),(52263712,1,'created_by','JOSM'),(52263713,1,'created_by','JOSM'),(52263716,1,'created_by','JOSM'),(52263717,1,'created_by','JOSM'),(52263718,1,'created_by','JOSM'),(52263721,1,'created_by','JOSM'),(52263722,1,'created_by','JOSM'),(52263724,1,'created_by','JOSM'),(52263726,1,'created_by','JOSM'),(52263727,1,'created_by','JOSM'),(52263854,1,'created_by','JOSM'),(52263857,1,'created_by','JOSM'),(52263858,1,'created_by','JOSM'),(52263860,1,'created_by','JOSM'),(52263863,1,'created_by','JOSM'),(52263865,1,'created_by','JOSM'),(52263870,1,'created_by','JOSM'),(52263873,1,'created_by','JOSM'),(52263875,1,'created_by','JOSM'),(52263876,1,'created_by','JOSM'),(52263877,1,'created_by','JOSM'),(52286947,1,'created_by','JOSM'),(52286950,1,'created_by','JOSM'),(52286951,1,'created_by','JOSM'),(52286954,1,'created_by','JOSM'),(52286967,1,'created_by','JOSM'),(52286970,1,'created_by','JOSM'),(52286971,1,'created_by','JOSM'),(52286973,1,'created_by','JOSM'),(52286974,1,'created_by','JOSM'),(52287059,1,'created_by','JOSM'),(52287062,1,'created_by','JOSM'),(52287063,1,'created_by','JOSM'),(52296455,1,'created_by','JOSM'),(52296457,1,'created_by','JOSM'),(52296459,1,'created_by','JOSM'),(52296460,1,'created_by','JOSM'),(52296461,1,'created_by','JOSM'),(52296462,1,'created_by','JOSM'),(52296464,1,'created_by','JOSM'),(52296465,1,'created_by','JOSM'),(52296467,1,'created_by','JOSM'),(52296469,1,'created_by','JOSM'),(52296471,1,'created_by','JOSM'),(52296472,1,'created_by','JOSM'),(52296476,1,'created_by','JOSM'),(52296478,1,'created_by','JOSM'),(52296481,1,'created_by','JOSM'),(52296483,1,'created_by','JOSM'),(52296485,1,'created_by','JOSM'),(52296486,1,'created_by','JOSM'),(52296489,1,'created_by','JOSM'),(52296490,1,'created_by','JOSM'),(52296492,1,'created_by','JOSM'),(52296494,1,'created_by','JOSM'),(52296495,1,'created_by','JOSM'),(52296497,1,'created_by','JOSM'),(52296975,1,'created_by','JOSM'),(52296977,1,'created_by','JOSM'),(52296978,1,'created_by','JOSM'),(52296979,1,'created_by','JOSM'),(52296981,1,'created_by','JOSM'),(52296982,1,'created_by','JOSM'),(52296984,1,'created_by','JOSM'),(52296985,1,'created_by','JOSM'),(52296987,1,'created_by','JOSM'),(52296990,1,'created_by','JOSM'),(52296992,1,'created_by','JOSM'),(52296994,1,'created_by','JOSM'),(52296996,1,'created_by','JOSM'),(52296999,1,'created_by','JOSM'),(52297002,1,'created_by','JOSM'),(52297004,1,'created_by','JOSM'),(52297007,1,'created_by','JOSM'),(52297010,1,'created_by','JOSM'),(52297013,1,'created_by','JOSM'),(52297015,1,'created_by','JOSM'),(52297018,1,'created_by','JOSM'),(52297038,1,'created_by','JOSM'),(52297041,1,'created_by','JOSM'),(52297063,1,'created_by','JOSM'),(52297071,1,'created_by','JOSM'),(52297255,1,'created_by','JOSM'),(52297266,1,'created_by','JOSM'),(52297268,1,'created_by','JOSM'),(52297272,1,'created_by','JOSM'),(52297276,1,'created_by','JOSM'),(52297279,1,'created_by','JOSM'),(52297281,1,'created_by','JOSM'),(52297285,1,'created_by','JOSM'),(52297288,1,'created_by','JOSM'),(52297290,1,'created_by','JOSM'),(52297294,1,'created_by','JOSM'),(52297297,1,'created_by','JOSM'),(52297300,1,'created_by','JOSM'),(52297305,1,'created_by','JOSM'),(52297309,1,'created_by','JOSM'),(52297312,1,'created_by','JOSM'),(52297314,1,'created_by','JOSM'),(52297317,1,'created_by','JOSM'),(52297320,1,'created_by','JOSM'),(52297324,1,'created_by','JOSM'),(52297328,1,'created_by','JOSM'),(52297333,1,'created_by','JOSM'),(52297339,1,'created_by','JOSM'),(52297344,1,'created_by','JOSM'),(52297349,1,'created_by','JOSM'),(52297354,1,'created_by','JOSM'),(52297358,1,'created_by','JOSM'),(52297362,1,'created_by','JOSM'),(52297366,1,'created_by','JOSM'),(52297369,1,'created_by','JOSM'),(52297373,1,'created_by','JOSM'),(52297375,1,'created_by','JOSM'),(52297380,1,'created_by','JOSM'),(52297383,1,'created_by','JOSM'),(52297386,1,'created_by','JOSM'),(52297390,1,'created_by','JOSM'),(52297393,1,'created_by','JOSM'),(52297402,1,'created_by','JOSM'),(52297405,1,'created_by','JOSM'),(52297410,1,'created_by','JOSM'),(52297412,1,'created_by','JOSM'),(52297418,1,'created_by','JOSM'),(52297422,1,'created_by','JOSM'),(52297424,1,'created_by','JOSM'),(52297427,1,'created_by','JOSM'),(52297432,1,'created_by','JOSM'),(52297435,1,'created_by','JOSM'),(52297437,1,'created_by','JOSM'),(52297440,1,'created_by','JOSM'),(52297442,1,'created_by','JOSM'),(52297447,1,'created_by','JOSM'),(52297450,1,'created_by','JOSM'),(52297455,1,'created_by','JOSM'),(52297459,1,'created_by','JOSM'),(52297462,1,'created_by','JOSM'),(52297465,1,'created_by','JOSM'),(52297469,1,'created_by','JOSM'),(52297470,1,'created_by','JOSM'),(52297474,1,'created_by','JOSM'),(52297478,1,'created_by','JOSM'),(52297482,1,'created_by','JOSM'),(52297484,1,'created_by','JOSM'),(52297488,1,'created_by','JOSM'),(52297492,1,'created_by','JOSM'),(52297494,1,'created_by','JOSM'),(52297498,1,'created_by','JOSM'),(52297507,1,'created_by','JOSM'),(52297509,1,'created_by','JOSM'),(52297515,1,'created_by','JOSM'),(52297517,1,'created_by','JOSM'),(52297520,1,'created_by','JOSM'),(52297521,1,'created_by','JOSM'),(52297525,1,'created_by','JOSM'),(52297528,1,'created_by','JOSM'),(52297532,1,'created_by','JOSM'),(52297535,1,'created_by','JOSM'),(52297537,1,'created_by','JOSM'),(52297540,1,'created_by','JOSM'),(52297542,1,'created_by','JOSM'),(52297545,1,'created_by','JOSM'),(52297547,1,'created_by','JOSM'),(52297550,1,'created_by','JOSM'),(52297554,1,'created_by','JOSM'),(52297558,1,'created_by','JOSM'),(52297560,1,'created_by','JOSM'),(52297563,1,'created_by','JOSM'),(52297565,1,'created_by','JOSM'),(52297567,1,'created_by','JOSM'),(52297571,1,'created_by','JOSM'),(52297573,1,'created_by','JOSM'),(52297576,1,'created_by','JOSM'),(52297580,1,'created_by','JOSM'),(52297584,1,'created_by','JOSM'),(52297587,1,'created_by','JOSM'),(52297590,1,'created_by','JOSM'),(52297592,1,'created_by','JOSM'),(52297595,1,'created_by','JOSM'),(52297599,1,'created_by','JOSM'),(52297602,1,'created_by','JOSM'),(52297606,1,'created_by','JOSM'),(52297609,1,'created_by','JOSM'),(52297612,1,'created_by','JOSM'),(52297615,1,'created_by','JOSM'),(52297617,1,'created_by','JOSM'),(52297621,1,'created_by','JOSM'),(52297623,1,'created_by','JOSM'),(52297626,1,'created_by','JOSM'),(52297629,1,'created_by','JOSM'),(52297633,1,'created_by','JOSM'),(52297638,1,'created_by','JOSM'),(52297640,1,'created_by','JOSM'),(52297643,1,'created_by','JOSM'),(52297646,1,'created_by','JOSM'),(52322112,1,'created_by','JOSM'),(52322115,1,'created_by','JOSM'),(52322119,1,'created_by','JOSM'),(52322122,1,'created_by','JOSM'),(52322125,1,'created_by','JOSM'),(52322137,1,'created_by','JOSM'),(52322143,1,'created_by','JOSM'),(52322151,1,'created_by','JOSM'),(52322153,1,'created_by','JOSM'),(52322155,1,'created_by','JOSM'),(52322156,1,'created_by','JOSM'),(52322157,1,'created_by','JOSM'),(52322159,1,'created_by','JOSM'),(52322163,1,'created_by','JOSM'),(52322165,1,'created_by','JOSM'),(52322167,1,'created_by','JOSM'),(52322170,1,'created_by','JOSM'),(52322171,1,'created_by','JOSM'),(52322174,1,'created_by','JOSM'),(52322177,1,'created_by','JOSM'),(52322180,1,'created_by','JOSM'),(52322184,1,'created_by','JOSM'),(52322185,1,'created_by','JOSM'),(52322190,1,'created_by','JOSM'),(52322193,1,'created_by','JOSM'),(52322196,1,'created_by','JOSM'),(52322198,1,'created_by','JOSM'),(52322200,1,'created_by','JOSM'),(52322203,1,'created_by','JOSM'),(52322207,1,'created_by','JOSM'),(52322210,1,'created_by','JOSM'),(52322213,1,'created_by','JOSM'),(52322216,1,'created_by','JOSM'),(52322219,1,'created_by','JOSM'),(52322222,1,'created_by','JOSM'),(52322223,1,'created_by','JOSM'),(52322225,1,'created_by','JOSM'),(52322228,1,'created_by','JOSM'),(52322231,1,'created_by','JOSM'),(52322235,1,'created_by','JOSM'),(52322237,1,'created_by','JOSM'),(52322240,1,'created_by','JOSM'),(52322242,1,'created_by','JOSM'),(52322244,1,'created_by','JOSM'),(52322245,1,'created_by','JOSM'),(52322247,1,'created_by','JOSM'),(52322249,1,'created_by','JOSM'),(52322252,1,'created_by','JOSM'),(52322255,1,'created_by','JOSM'),(52322256,1,'created_by','JOSM'),(52322259,1,'created_by','JOSM'),(52322262,1,'created_by','JOSM'),(52322266,1,'created_by','JOSM'),(52322268,1,'created_by','JOSM'),(52322271,1,'created_by','JOSM'),(52322273,1,'created_by','JOSM'),(52322277,1,'created_by','JOSM'),(52322278,1,'created_by','JOSM'),(52322279,1,'created_by','JOSM'),(52322282,1,'created_by','JOSM'),(52322285,1,'created_by','JOSM'),(52322286,1,'created_by','JOSM'),(52322289,1,'created_by','JOSM'),(52322292,1,'created_by','JOSM'),(52322293,1,'created_by','JOSM'),(52322295,1,'created_by','JOSM'),(52322298,1,'created_by','JOSM'),(52322299,1,'created_by','JOSM'),(52322302,1,'created_by','JOSM'),(52322305,1,'created_by','JOSM'),(52322308,1,'created_by','JOSM'),(52322309,1,'created_by','JOSM'),(52322311,1,'created_by','JOSM'),(52322313,1,'created_by','JOSM'),(52322315,1,'created_by','JOSM'),(52322316,1,'created_by','JOSM'),(52322318,1,'created_by','JOSM'),(52322320,1,'created_by','JOSM'),(52322322,1,'created_by','JOSM'),(52322324,1,'created_by','JOSM'),(52322327,1,'created_by','JOSM'),(52322329,1,'created_by','JOSM'),(52322331,1,'created_by','JOSM'),(52322333,1,'created_by','JOSM'),(52322335,1,'created_by','JOSM'),(52322336,1,'created_by','JOSM'),(52322337,1,'created_by','JOSM'),(52322339,1,'created_by','JOSM'),(52322341,1,'created_by','JOSM'),(52322342,1,'created_by','JOSM'),(52322344,1,'created_by','JOSM'),(52322345,1,'created_by','JOSM'),(52322347,1,'created_by','JOSM'),(52322349,1,'created_by','JOSM'),(52322351,1,'created_by','JOSM'),(52322353,1,'created_by','JOSM'),(52322355,1,'created_by','JOSM'),(52322357,1,'created_by','JOSM'),(52322358,1,'created_by','JOSM'),(52322359,1,'created_by','JOSM'),(52322361,1,'created_by','JOSM'),(52322363,1,'created_by','JOSM'),(52322364,1,'created_by','JOSM'),(52322365,1,'created_by','JOSM'),(52322366,1,'created_by','JOSM'),(52322368,1,'created_by','JOSM'),(52322370,1,'created_by','JOSM'),(52322372,1,'created_by','JOSM'),(52322374,1,'created_by','JOSM'),(52322376,1,'created_by','JOSM'),(52322378,1,'created_by','JOSM'),(52322380,1,'created_by','JOSM'),(52322382,1,'created_by','JOSM'),(52322384,1,'created_by','JOSM'),(52322386,1,'created_by','JOSM'),(52322388,1,'created_by','JOSM'),(52322390,1,'created_by','JOSM'),(52322392,1,'created_by','JOSM'),(52322395,1,'created_by','JOSM'),(52322398,1,'created_by','JOSM'),(52322400,1,'created_by','JOSM'),(52322402,1,'created_by','JOSM'),(52322405,1,'created_by','JOSM'),(52322408,1,'created_by','JOSM'),(52322411,1,'created_by','JOSM'),(52322413,1,'created_by','JOSM'),(52322415,1,'created_by','JOSM'),(52322419,1,'created_by','JOSM'),(52322422,1,'created_by','JOSM'),(52322424,1,'created_by','JOSM'),(52322429,1,'created_by','JOSM'),(52322432,1,'created_by','JOSM'),(52322434,1,'created_by','JOSM'),(52322437,1,'created_by','JOSM'),(52322440,1,'created_by','JOSM'),(52322441,1,'created_by','JOSM'),(52322443,1,'created_by','JOSM'),(52322446,1,'created_by','JOSM'),(52322449,1,'created_by','JOSM'),(52322451,1,'created_by','JOSM'),(52322453,1,'created_by','JOSM'),(52322455,1,'created_by','JOSM'),(52322458,1,'created_by','JOSM'),(52322461,1,'created_by','JOSM'),(52322463,1,'created_by','JOSM'),(52322465,1,'created_by','JOSM'),(52322467,1,'created_by','JOSM'),(52322470,1,'created_by','JOSM'),(52322473,1,'created_by','JOSM'),(52322475,1,'created_by','JOSM'),(52322478,1,'created_by','JOSM'),(52322481,1,'created_by','JOSM'),(52322484,1,'created_by','JOSM'),(52322486,1,'created_by','JOSM'),(52322488,1,'created_by','JOSM'),(52322492,1,'created_by','JOSM'),(52322493,1,'created_by','JOSM'),(52322496,1,'created_by','JOSM'),(52322497,1,'created_by','JOSM'),(52322500,1,'created_by','JOSM'),(52322502,1,'created_by','JOSM'),(52322504,1,'created_by','JOSM'),(52322508,1,'created_by','JOSM'),(52322510,1,'created_by','JOSM'),(52322512,1,'created_by','JOSM'),(52322515,1,'created_by','JOSM'),(52322516,1,'created_by','JOSM'),(52322518,1,'created_by','JOSM'),(52322520,1,'created_by','JOSM'),(52322523,1,'created_by','JOSM'),(52322526,1,'created_by','JOSM'),(52322528,1,'created_by','JOSM'),(52322530,1,'created_by','JOSM'),(52322533,1,'created_by','JOSM'),(52322534,1,'created_by','JOSM'),(52322537,1,'created_by','JOSM'),(52322540,1,'created_by','JOSM'),(52322542,1,'created_by','JOSM'),(52322544,1,'created_by','JOSM'),(52322545,1,'created_by','JOSM'),(52322548,1,'created_by','JOSM'),(52322551,1,'created_by','JOSM'),(52322552,1,'created_by','JOSM'),(52322554,1,'created_by','JOSM'),(52322557,1,'created_by','JOSM'),(52322558,1,'created_by','JOSM'),(52322561,1,'created_by','JOSM'),(52322562,1,'created_by','JOSM'),(52322564,1,'created_by','JOSM'),(52322567,1,'created_by','JOSM'),(52322570,1,'created_by','JOSM'),(52322571,1,'created_by','JOSM'),(52322574,1,'created_by','JOSM'),(52322578,1,'created_by','JOSM'),(52322579,1,'created_by','JOSM'),(52322581,1,'created_by','JOSM'),(52322583,1,'created_by','JOSM'),(52322585,1,'created_by','JOSM'),(52322587,1,'created_by','JOSM'),(52322589,1,'created_by','JOSM'),(52322591,1,'created_by','JOSM'),(52322593,1,'created_by','JOSM'),(52322595,1,'created_by','JOSM'),(52322598,1,'created_by','JOSM'),(52322601,1,'created_by','JOSM'),(52322602,1,'created_by','JOSM'),(52322604,1,'created_by','JOSM'),(52322606,1,'created_by','JOSM'),(52322611,1,'created_by','JOSM'),(52322613,1,'created_by','JOSM'),(52322615,1,'created_by','JOSM'),(52322617,1,'created_by','JOSM'),(52322618,1,'created_by','JOSM'),(52322623,1,'created_by','JOSM'),(52322626,1,'created_by','JOSM'),(52322627,1,'created_by','JOSM'),(52322630,1,'created_by','JOSM'),(52322632,1,'created_by','JOSM'),(52322634,1,'created_by','JOSM'),(52322636,1,'created_by','JOSM'),(52322639,1,'created_by','JOSM'),(52322641,1,'created_by','JOSM'),(52322644,1,'created_by','JOSM'),(52322646,1,'created_by','JOSM'),(52322648,1,'created_by','JOSM'),(52322651,1,'created_by','JOSM'),(52322654,1,'created_by','JOSM'),(52322656,1,'created_by','JOSM'),(52322657,1,'created_by','JOSM'),(52322660,1,'created_by','JOSM'),(52322663,1,'created_by','JOSM'),(52322665,1,'created_by','JOSM'),(52322667,1,'created_by','JOSM'),(52322670,1,'created_by','JOSM'),(52322673,1,'created_by','JOSM'),(52322675,1,'created_by','JOSM'),(52322677,1,'created_by','JOSM'),(52322678,1,'created_by','JOSM'),(52322681,1,'created_by','JOSM'),(52322684,1,'created_by','JOSM'),(52322685,1,'created_by','JOSM'),(52322687,1,'created_by','JOSM'),(52322690,1,'created_by','JOSM'),(52322692,1,'created_by','JOSM'),(52322695,1,'created_by','JOSM'),(52322697,1,'created_by','JOSM'),(52322698,1,'created_by','JOSM'),(52322700,1,'created_by','JOSM'),(52322701,1,'created_by','JOSM'),(52322704,1,'created_by','JOSM'),(52322706,1,'created_by','JOSM'),(52322709,1,'created_by','JOSM'),(52322712,1,'created_by','JOSM'),(52322713,1,'created_by','JOSM'),(52322716,1,'created_by','JOSM'),(52322719,1,'created_by','JOSM'),(52322722,1,'created_by','JOSM'),(52322725,1,'created_by','JOSM'),(52322727,1,'created_by','JOSM'),(52322729,1,'created_by','JOSM'),(52322731,1,'created_by','JOSM'),(52322733,1,'created_by','JOSM'),(52322736,1,'created_by','JOSM'),(52322738,1,'created_by','JOSM'),(52322739,1,'created_by','JOSM'),(52322741,1,'created_by','JOSM'),(52322753,1,'created_by','JOSM'),(52322755,1,'created_by','JOSM'),(52322758,1,'created_by','JOSM'),(52322761,1,'created_by','JOSM'),(52322764,1,'created_by','JOSM'),(52322765,1,'created_by','JOSM'),(52322768,1,'created_by','JOSM'),(52322770,1,'created_by','JOSM'),(52322773,1,'created_by','JOSM'),(52322774,1,'created_by','JOSM'),(52322777,1,'created_by','JOSM'),(52322780,1,'created_by','JOSM'),(52322782,1,'created_by','JOSM'),(52322785,1,'created_by','JOSM'),(52322787,1,'created_by','JOSM'),(52322789,1,'created_by','JOSM'),(52322791,1,'created_by','JOSM'),(52322793,1,'created_by','JOSM'),(52322795,1,'created_by','JOSM'),(52322796,1,'created_by','JOSM'),(52322799,1,'created_by','JOSM'),(52322800,1,'created_by','JOSM'),(52322802,1,'created_by','JOSM'),(52322804,1,'created_by','JOSM'),(52322806,1,'created_by','JOSM'),(52322809,1,'created_by','JOSM'),(52322810,1,'created_by','JOSM'),(52322815,1,'created_by','JOSM'),(52322816,1,'created_by','JOSM'),(52322819,1,'created_by','JOSM'),(52322823,1,'created_by','JOSM'),(52322826,1,'created_by','JOSM'),(52322827,1,'created_by','JOSM'),(52322830,1,'created_by','JOSM'),(52322833,1,'created_by','JOSM'),(52322836,1,'created_by','JOSM'),(52322837,1,'created_by','JOSM'),(52322840,1,'created_by','JOSM'),(52322842,1,'created_by','JOSM'),(52322844,1,'created_by','JOSM'),(52322846,1,'created_by','JOSM'),(52322847,1,'created_by','JOSM'),(52322850,1,'created_by','JOSM'),(52322851,1,'created_by','JOSM'),(52322855,1,'created_by','JOSM'),(52322858,1,'created_by','JOSM'),(52322859,1,'created_by','JOSM'),(52322863,1,'created_by','JOSM'),(52322865,1,'created_by','JOSM'),(52322867,1,'created_by','JOSM'),(52322871,1,'created_by','JOSM'),(52322874,1,'created_by','JOSM'),(52322877,1,'created_by','JOSM'),(52322879,1,'created_by','JOSM'),(52322880,1,'created_by','JOSM'),(52322883,1,'created_by','JOSM'),(52322887,1,'created_by','JOSM'),(52322889,1,'created_by','JOSM'),(52322891,1,'created_by','JOSM'),(52322893,1,'created_by','JOSM'),(52322896,1,'created_by','JOSM'),(52322898,1,'created_by','JOSM'),(52322902,1,'created_by','JOSM'),(52322903,1,'created_by','JOSM'),(52322904,1,'created_by','JOSM'),(52322907,1,'created_by','JOSM'),(52322910,1,'created_by','JOSM'),(52322911,1,'created_by','JOSM'),(52322915,1,'created_by','JOSM'),(52322917,1,'created_by','JOSM'),(52322919,1,'created_by','JOSM'),(52322921,1,'created_by','JOSM'),(52322924,1,'created_by','JOSM'),(52322927,1,'created_by','JOSM'),(52322929,1,'created_by','JOSM'),(52322931,1,'created_by','JOSM'),(52322934,1,'created_by','JOSM'),(52322937,1,'created_by','JOSM'),(52322940,1,'created_by','JOSM'),(52322942,1,'created_by','JOSM'),(52322945,1,'created_by','JOSM'),(52322947,1,'created_by','JOSM'),(52322950,1,'created_by','JOSM'),(52322953,1,'created_by','JOSM'),(52322955,1,'created_by','JOSM'),(52322957,1,'created_by','JOSM'),(52322959,1,'created_by','JOSM'),(52322962,1,'created_by','JOSM'),(52322964,1,'created_by','JOSM'),(52322966,1,'created_by','JOSM'),(52322969,1,'created_by','JOSM'),(52322972,1,'created_by','JOSM'),(52322974,1,'created_by','JOSM'),(52322976,1,'created_by','JOSM'),(52322977,1,'created_by','JOSM'),(52322979,1,'created_by','JOSM'),(52322982,1,'created_by','JOSM'),(52327233,1,'created_by','JOSM'),(52327235,1,'created_by','JOSM'),(52327238,1,'created_by','JOSM'),(52327241,1,'created_by','JOSM'),(52327243,1,'created_by','JOSM'),(52327246,1,'created_by','JOSM'),(52327247,1,'created_by','JOSM'),(52327250,1,'created_by','JOSM'),(52327252,1,'created_by','JOSM'),(52327263,1,'created_by','JOSM'),(52327265,1,'created_by','JOSM'),(52327268,1,'created_by','JOSM'),(52327271,1,'created_by','JOSM'),(52327274,1,'created_by','JOSM'),(52327277,1,'created_by','JOSM'),(52327279,1,'created_by','JOSM'),(52327281,1,'created_by','JOSM'),(52327282,1,'created_by','JOSM'),(52327285,1,'created_by','JOSM'),(52327287,1,'created_by','JOSM'),(52327288,1,'created_by','JOSM'),(52327290,1,'created_by','JOSM'),(52327292,1,'created_by','JOSM'),(52327295,1,'created_by','JOSM'),(52327298,1,'created_by','JOSM'),(52327300,1,'created_by','JOSM'),(52327302,1,'created_by','JOSM'),(52327303,1,'created_by','JOSM'),(52327306,1,'created_by','JOSM'),(52327309,1,'created_by','JOSM'),(52327310,1,'created_by','JOSM'),(52327313,1,'created_by','JOSM'),(52327316,1,'created_by','JOSM'),(52327317,1,'created_by','JOSM'),(52327321,1,'created_by','JOSM'),(52327325,1,'created_by','JOSM'),(52327328,1,'created_by','JOSM'),(52327329,1,'created_by','JOSM'),(52327331,1,'created_by','JOSM'),(52327333,1,'created_by','JOSM'),(52327337,1,'created_by','JOSM'),(52327339,1,'created_by','JOSM'),(52327341,1,'created_by','JOSM'),(52327342,1,'created_by','JOSM'),(52327345,1,'created_by','JOSM'),(52327347,1,'created_by','JOSM'),(52327351,1,'created_by','JOSM'),(52327354,1,'created_by','JOSM'),(52327358,1,'created_by','JOSM'),(52327359,1,'created_by','JOSM'),(52327361,1,'created_by','JOSM'),(52327362,1,'created_by','JOSM'),(52327365,1,'created_by','JOSM'),(52327368,1,'created_by','JOSM'),(52327371,1,'created_by','JOSM'),(52327372,1,'created_by','JOSM'),(52327375,1,'created_by','JOSM'),(52327378,1,'created_by','JOSM'),(52327379,1,'created_by','JOSM'),(52327381,1,'created_by','JOSM'),(52327383,1,'created_by','JOSM'),(52327384,1,'created_by','JOSM'),(52327387,1,'created_by','JOSM'),(52327388,1,'created_by','JOSM'),(52327390,1,'created_by','JOSM'),(52327392,1,'created_by','JOSM'),(52327393,1,'created_by','JOSM'),(52327398,1,'created_by','JOSM'),(52327401,1,'created_by','JOSM'),(52327403,1,'created_by','JOSM'),(52327406,1,'created_by','JOSM'),(52327408,1,'created_by','JOSM'),(52327411,1,'created_by','JOSM'),(52327413,1,'created_by','JOSM'),(52327417,1,'created_by','JOSM'),(52327418,1,'created_by','JOSM'),(52327421,1,'created_by','JOSM'),(52327423,1,'created_by','JOSM'),(52327427,1,'created_by','JOSM'),(52327429,1,'created_by','JOSM'),(52327432,1,'created_by','JOSM'),(52327434,1,'created_by','JOSM'),(52328346,1,'created_by','JOSM'),(52328347,1,'created_by','JOSM'),(52328348,1,'created_by','JOSM'),(52328350,1,'created_by','JOSM'),(52328353,1,'created_by','JOSM'),(52328354,1,'created_by','JOSM'),(52328357,1,'created_by','JOSM'),(52328358,1,'created_by','JOSM'),(52328360,1,'created_by','JOSM'),(52328362,1,'created_by','JOSM'),(52328364,1,'created_by','JOSM'),(52328365,1,'created_by','JOSM'),(52328367,1,'created_by','JOSM'),(52328370,1,'created_by','JOSM'),(52328373,1,'created_by','JOSM'),(52329934,1,'created_by','JOSM'),(52329937,1,'created_by','JOSM'),(52329940,1,'created_by','JOSM'),(52329942,1,'created_by','JOSM'),(52329943,1,'created_by','JOSM'),(52329946,1,'created_by','JOSM'),(52329948,1,'created_by','JOSM'),(52329951,1,'created_by','JOSM'),(52329953,1,'created_by','JOSM'),(52329956,1,'created_by','JOSM'),(52329957,1,'created_by','JOSM'),(52329960,1,'created_by','JOSM'),(52329962,1,'created_by','JOSM'),(52329964,1,'created_by','JOSM'),(52329967,1,'created_by','JOSM'),(52329968,1,'created_by','JOSM'),(52329970,1,'created_by','JOSM'),(52329972,1,'created_by','JOSM'),(52329974,1,'created_by','JOSM'),(52329978,1,'created_by','JOSM'),(52329981,1,'created_by','JOSM'),(52330668,1,'created_by','JOSM'),(52330669,1,'created_by','JOSM'),(52330670,1,'created_by','JOSM'),(52330671,1,'created_by','JOSM'),(52330672,1,'created_by','JOSM'),(52330673,1,'created_by','JOSM'),(52330674,1,'created_by','JOSM'),(52330675,1,'created_by','JOSM'),(52330676,1,'created_by','JOSM'),(52330677,1,'created_by','JOSM'),(52330678,1,'created_by','JOSM'),(52578637,1,'created_by','JOSM'),(52578801,1,'created_by','JOSM'),(52578802,1,'created_by','JOSM'),(52578805,1,'created_by','JOSM'),(52596149,1,'created_by','JOSM'),(52596154,1,'created_by','JOSM'),(52596158,1,'created_by','JOSM'),(52596161,1,'created_by','JOSM'),(52596163,1,'created_by','JOSM'),(52596167,1,'created_by','JOSM'),(52596171,1,'created_by','JOSM'),(52596178,1,'created_by','JOSM'),(52596180,1,'created_by','JOSM'),(52596184,1,'created_by','JOSM'),(52596186,1,'created_by','JOSM'),(52596191,1,'created_by','JOSM'),(52596195,1,'created_by','JOSM'),(52596197,1,'created_by','JOSM'),(52596200,1,'created_by','JOSM'),(52596204,1,'created_by','JOSM'),(52596208,1,'created_by','JOSM'),(52596212,1,'created_by','JOSM'),(52596213,1,'created_by','JOSM'),(52596216,1,'created_by','JOSM'),(52596219,1,'created_by','JOSM'),(52596222,1,'created_by','JOSM'),(52596226,1,'created_by','JOSM'),(52596228,1,'created_by','JOSM'),(52596231,1,'created_by','JOSM'),(52596234,1,'created_by','JOSM'),(52596236,1,'created_by','JOSM'),(52596238,1,'created_by','JOSM'),(52596241,1,'created_by','JOSM'),(52596243,1,'created_by','JOSM'),(52596246,1,'created_by','JOSM'),(52596249,1,'created_by','JOSM'),(52596271,1,'created_by','JOSM'),(52596274,1,'created_by','JOSM'),(52596277,1,'created_by','JOSM'),(52596280,1,'created_by','JOSM'),(52596283,1,'created_by','JOSM'),(52596285,1,'created_by','JOSM'),(52596288,1,'created_by','JOSM'),(52596291,1,'created_by','JOSM'),(52596295,1,'created_by','JOSM'),(52596297,1,'created_by','JOSM'),(52596299,1,'created_by','JOSM'),(52596300,1,'created_by','JOSM'),(52596303,1,'created_by','JOSM'),(52596305,1,'created_by','JOSM'),(52596308,1,'created_by','JOSM'),(52596310,1,'created_by','JOSM'),(52596312,1,'created_by','JOSM'),(52596314,1,'created_by','JOSM'),(52596318,1,'created_by','JOSM'),(52596320,1,'created_by','JOSM'),(52596326,1,'created_by','JOSM'),(52596331,1,'created_by','JOSM'),(52596335,1,'created_by','JOSM'),(52596339,1,'created_by','JOSM'),(52596343,1,'created_by','JOSM'),(52596346,1,'created_by','JOSM'),(52596351,1,'created_by','JOSM'),(52603531,1,'created_by','JOSM'),(52603533,1,'created_by','JOSM'),(52603536,1,'created_by','JOSM'),(52603537,1,'created_by','JOSM'),(52603540,1,'created_by','JOSM'),(52603542,1,'created_by','JOSM'),(52612605,1,'created_by','JOSM'),(52612609,1,'created_by','JOSM'),(52612612,1,'created_by','JOSM'),(52612615,1,'created_by','JOSM'),(52612616,1,'created_by','JOSM'),(52612619,1,'created_by','JOSM'),(52612622,1,'created_by','JOSM'),(52612624,1,'created_by','JOSM'),(52612626,1,'created_by','JOSM'),(52612629,1,'created_by','JOSM'),(52612634,1,'created_by','JOSM'),(52612635,1,'created_by','JOSM'),(52612638,1,'created_by','JOSM'),(52612640,1,'created_by','JOSM'),(52612642,1,'created_by','JOSM'),(52612645,1,'created_by','JOSM'),(52612646,1,'created_by','JOSM'),(52612649,1,'created_by','JOSM'),(52612651,1,'created_by','JOSM'),(52612653,1,'created_by','JOSM'),(52612656,1,'created_by','JOSM'),(52612658,1,'created_by','JOSM'),(52612660,1,'created_by','JOSM'),(52612661,1,'created_by','JOSM'),(52612664,1,'created_by','JOSM'),(52612665,1,'created_by','JOSM'),(52612667,1,'created_by','JOSM'),(52612670,1,'created_by','JOSM'),(52612672,1,'created_by','JOSM'),(52612675,1,'created_by','JOSM'),(52612677,1,'created_by','JOSM'),(52612678,1,'created_by','JOSM'),(52612681,1,'created_by','JOSM'),(52612684,1,'created_by','JOSM'),(52612686,1,'created_by','JOSM'),(52612688,1,'created_by','JOSM'),(52612691,1,'created_by','JOSM'),(52612692,1,'created_by','JOSM'),(52612694,1,'created_by','JOSM'),(52612696,1,'created_by','JOSM'),(52612699,1,'created_by','JOSM'),(52612701,1,'created_by','JOSM'),(52612704,1,'created_by','JOSM'),(52612708,1,'created_by','JOSM'),(52612710,1,'created_by','JOSM'),(52612712,1,'created_by','JOSM'),(52612716,1,'created_by','JOSM'),(52612717,1,'created_by','JOSM'),(52612719,1,'created_by','JOSM'),(52612720,1,'created_by','JOSM'),(52612722,1,'created_by','JOSM'),(52612725,1,'created_by','JOSM'),(52612728,1,'created_by','JOSM'),(52612732,1,'created_by','JOSM'),(52612735,1,'created_by','JOSM'),(52612738,1,'created_by','JOSM'),(52612740,1,'created_by','JOSM'),(52612742,1,'created_by','JOSM'),(52612744,1,'created_by','JOSM'),(52612746,1,'created_by','JOSM'),(52612748,1,'created_by','JOSM'),(52612750,1,'created_by','JOSM'),(52612752,1,'created_by','JOSM'),(52612754,1,'created_by','JOSM'),(52612756,1,'created_by','JOSM'),(52612758,1,'created_by','JOSM'),(52612760,1,'created_by','JOSM'),(52612761,1,'created_by','JOSM'),(52612763,1,'created_by','JOSM'),(52612765,1,'created_by','JOSM'),(52612768,1,'created_by','JOSM'),(52612770,1,'created_by','JOSM'),(52612773,1,'created_by','JOSM'),(52612776,1,'created_by','JOSM'),(52612779,1,'created_by','JOSM'),(52612782,1,'created_by','JOSM'),(52612786,1,'created_by','JOSM'),(52612789,1,'created_by','JOSM'),(52612791,1,'created_by','JOSM'),(52612794,1,'created_by','JOSM'),(52612796,1,'created_by','JOSM'),(52612800,1,'created_by','JOSM'),(52612803,1,'created_by','JOSM'),(52612804,1,'created_by','JOSM'),(52612807,1,'created_by','JOSM'),(52612810,1,'created_by','JOSM'),(52612813,1,'created_by','JOSM'),(52612815,1,'created_by','JOSM'),(52612817,1,'created_by','JOSM'),(52612820,1,'created_by','JOSM'),(52612824,1,'created_by','JOSM'),(52612827,1,'created_by','JOSM'),(52612831,1,'created_by','JOSM'),(52612835,1,'created_by','JOSM'),(52612840,1,'created_by','JOSM'),(52612843,1,'created_by','JOSM'),(52612845,1,'created_by','JOSM'),(52612849,1,'created_by','JOSM'),(52612853,1,'created_by','JOSM'),(52612855,1,'created_by','JOSM'),(52612859,1,'created_by','JOSM'),(52612862,1,'created_by','JOSM'),(52612864,1,'created_by','JOSM'),(52612867,1,'created_by','JOSM'),(52612870,1,'created_by','JOSM'),(52612873,1,'created_by','JOSM'),(52612877,1,'created_by','JOSM'),(52612882,1,'created_by','JOSM'),(52612885,1,'created_by','JOSM'),(52612888,1,'created_by','JOSM'),(52612892,1,'created_by','JOSM'),(52612893,1,'created_by','JOSM'),(52612895,1,'created_by','JOSM'),(52612897,1,'created_by','JOSM'),(52612899,1,'created_by','JOSM'),(52612900,1,'created_by','JOSM'),(52612902,1,'created_by','JOSM'),(52612907,1,'created_by','JOSM'),(52612909,1,'created_by','JOSM'),(52612911,1,'created_by','JOSM'),(52612913,1,'created_by','JOSM'),(52612916,1,'created_by','JOSM'),(52612918,1,'created_by','JOSM'),(52612920,1,'created_by','JOSM'),(52612923,1,'created_by','JOSM'),(52612927,1,'created_by','JOSM'),(52612929,1,'created_by','JOSM'),(52612932,1,'created_by','JOSM'),(52612935,1,'created_by','JOSM'),(52612936,1,'created_by','JOSM'),(52612939,1,'created_by','JOSM'),(52612941,1,'created_by','JOSM'),(52612943,1,'created_by','JOSM'),(52612946,1,'created_by','JOSM'),(52612948,1,'created_by','JOSM'),(52612951,1,'created_by','JOSM'),(52612954,1,'created_by','JOSM'),(52612957,1,'created_by','JOSM'),(52612958,1,'created_by','JOSM'),(52612962,1,'created_by','JOSM'),(52612967,1,'created_by','JOSM'),(52612973,1,'created_by','JOSM'),(52612976,1,'created_by','JOSM'),(52612978,1,'created_by','JOSM'),(52612981,1,'created_by','JOSM'),(52612983,1,'created_by','JOSM'),(52612986,1,'created_by','JOSM'),(52612989,1,'created_by','JOSM'),(52612992,1,'created_by','JOSM'),(52612994,1,'created_by','JOSM'),(52612996,1,'created_by','JOSM'),(52612998,1,'created_by','JOSM'),(52613000,1,'created_by','JOSM'),(52613003,1,'created_by','JOSM'),(52613006,1,'created_by','JOSM'),(52613008,1,'created_by','JOSM'),(52613010,1,'created_by','JOSM'),(52613013,1,'created_by','JOSM'),(52613016,1,'created_by','JOSM'),(52613017,1,'created_by','JOSM'),(52613020,1,'created_by','JOSM'),(52613021,1,'created_by','JOSM'),(52613024,1,'created_by','JOSM'),(52613027,1,'created_by','JOSM'),(52613030,1,'created_by','JOSM'),(52613032,1,'created_by','JOSM'),(52613034,1,'created_by','JOSM'),(52613037,1,'created_by','JOSM'),(52613039,1,'created_by','JOSM'),(52613041,1,'created_by','JOSM'),(52613044,1,'created_by','JOSM'),(52613047,1,'created_by','JOSM'),(52613049,1,'created_by','JOSM'),(52613052,1,'created_by','JOSM'),(52613054,1,'created_by','JOSM'),(52613056,1,'created_by','JOSM'),(52613058,1,'created_by','JOSM'),(52613061,1,'created_by','JOSM'),(52613062,1,'created_by','JOSM'),(52613065,1,'created_by','JOSM'),(52613067,1,'created_by','JOSM'),(52613070,1,'created_by','JOSM'),(52613072,1,'created_by','JOSM'),(52613074,1,'created_by','JOSM'),(52613076,1,'created_by','JOSM'),(52613080,1,'created_by','JOSM'),(52613083,1,'created_by','JOSM'),(52613086,1,'created_by','JOSM'),(52613088,1,'created_by','JOSM'),(52613091,1,'created_by','JOSM'),(52613092,1,'created_by','JOSM'),(52613094,1,'created_by','JOSM'),(52613097,1,'created_by','JOSM'),(52613099,1,'created_by','JOSM'),(52613101,1,'created_by','JOSM'),(52613104,1,'created_by','JOSM'),(52613107,1,'created_by','JOSM'),(52613110,1,'created_by','JOSM'),(52613113,1,'created_by','JOSM'),(52613115,1,'created_by','JOSM'),(52613117,1,'created_by','JOSM'),(52613119,1,'created_by','JOSM'),(52613121,1,'created_by','JOSM'),(52613124,1,'created_by','JOSM'),(52613126,1,'created_by','JOSM'),(52613129,1,'created_by','JOSM'),(52613132,1,'created_by','JOSM'),(52613135,1,'created_by','JOSM'),(52613139,1,'created_by','JOSM'),(52613142,1,'created_by','JOSM'),(52613145,1,'created_by','JOSM'),(52613148,1,'created_by','JOSM'),(52613149,1,'created_by','JOSM'),(52613151,1,'created_by','JOSM'),(52613154,1,'created_by','JOSM'),(52613157,1,'created_by','JOSM'),(52613159,1,'created_by','JOSM'),(52613162,1,'created_by','JOSM'),(52613163,1,'created_by','JOSM'),(52613166,1,'created_by','JOSM'),(52613167,1,'created_by','JOSM'),(52613170,1,'created_by','JOSM'),(52613172,1,'created_by','JOSM'),(52613173,1,'created_by','JOSM'),(52613175,1,'created_by','JOSM'),(52613176,1,'created_by','JOSM'),(52613178,1,'created_by','JOSM'),(52613179,1,'created_by','JOSM'),(52613182,1,'created_by','JOSM'),(52613184,1,'created_by','JOSM'),(52613186,1,'created_by','JOSM'),(52613189,1,'created_by','JOSM'),(52613192,1,'created_by','JOSM'),(52613196,1,'created_by','JOSM'),(52613199,1,'created_by','JOSM'),(52613201,1,'created_by','JOSM'),(52613204,1,'created_by','JOSM'),(52613212,1,'created_by','JOSM'),(52613214,1,'created_by','JOSM'),(52613217,1,'created_by','JOSM'),(52613221,1,'created_by','JOSM'),(52613223,1,'created_by','JOSM'),(52613224,1,'created_by','JOSM'),(52613226,1,'created_by','JOSM'),(52613228,1,'created_by','JOSM'),(52613231,1,'created_by','JOSM'),(52613233,1,'created_by','JOSM'),(52613235,1,'created_by','JOSM'),(52613237,1,'created_by','JOSM'),(52613238,1,'created_by','JOSM'),(52613244,1,'created_by','JOSM'),(52613246,1,'created_by','JOSM'),(52613249,1,'created_by','JOSM'),(52613252,1,'created_by','JOSM'),(52613256,1,'created_by','JOSM'),(52613258,1,'created_by','JOSM'),(52613260,1,'created_by','JOSM'),(52613262,1,'created_by','JOSM'),(52613264,1,'created_by','JOSM'),(52613267,1,'created_by','JOSM'),(52613270,1,'created_by','JOSM'),(52613272,1,'created_by','JOSM'),(52613274,1,'created_by','JOSM'),(52613277,1,'created_by','JOSM'),(52613279,1,'created_by','JOSM'),(52613282,1,'created_by','JOSM'),(52613285,1,'created_by','JOSM'),(52613288,1,'created_by','JOSM'),(52613289,1,'created_by','JOSM'),(52613292,1,'created_by','JOSM'),(52613295,1,'created_by','JOSM'),(52613297,1,'created_by','JOSM'),(52613300,1,'created_by','JOSM'),(52613301,1,'created_by','JOSM'),(52613303,1,'created_by','JOSM'),(52613304,1,'created_by','JOSM'),(52613306,1,'created_by','JOSM'),(52613309,1,'created_by','JOSM'),(52613310,1,'created_by','JOSM'),(52613312,1,'created_by','JOSM'),(52613314,1,'created_by','JOSM'),(52613317,1,'created_by','JOSM'),(52613318,1,'created_by','JOSM'),(52613320,1,'created_by','JOSM'),(52613323,1,'created_by','JOSM'),(52613325,1,'created_by','JOSM'),(52613330,1,'created_by','JOSM'),(52613332,1,'created_by','JOSM'),(52623167,1,'created_by','JOSM'),(52623169,1,'created_by','JOSM'),(52623170,1,'created_by','JOSM'),(52623173,1,'created_by','JOSM'),(52623176,1,'created_by','JOSM'),(52623178,1,'created_by','JOSM'),(52623180,1,'created_by','JOSM'),(52623182,1,'created_by','JOSM'),(52623185,1,'created_by','JOSM'),(52623187,1,'created_by','JOSM'),(52623190,1,'created_by','JOSM'),(52623193,1,'created_by','JOSM'),(52623196,1,'created_by','JOSM'),(52623199,1,'created_by','JOSM'),(52623201,1,'created_by','JOSM'),(52623203,1,'created_by','JOSM'),(52623205,1,'created_by','JOSM'),(52623207,1,'created_by','JOSM'),(52623209,1,'created_by','JOSM'),(52623212,1,'created_by','JOSM'),(52623215,1,'created_by','JOSM'),(52623218,1,'created_by','JOSM'),(52623226,1,'created_by','JOSM'),(52623229,1,'created_by','JOSM'),(52623231,1,'created_by','JOSM'),(52623233,1,'created_by','JOSM'),(52623236,1,'created_by','JOSM'),(52623240,1,'created_by','JOSM'),(52623242,1,'created_by','JOSM'),(52623245,1,'created_by','JOSM'),(52623247,1,'created_by','JOSM'),(52623250,1,'created_by','JOSM'),(52623252,1,'created_by','JOSM'),(52623255,1,'created_by','JOSM'),(52623259,1,'created_by','JOSM'),(52623261,1,'created_by','JOSM'),(52623265,1,'created_by','JOSM'),(52623268,1,'created_by','JOSM'),(52623273,1,'created_by','JOSM'),(52623276,1,'created_by','JOSM'),(52623278,1,'created_by','JOSM'),(52623282,1,'created_by','JOSM'),(52623285,1,'created_by','JOSM'),(52623287,1,'created_by','JOSM'),(52623290,1,'created_by','JOSM'),(52623294,1,'created_by','JOSM'),(52623296,1,'created_by','JOSM'),(52623299,1,'created_by','JOSM'),(52623301,1,'created_by','JOSM'),(52623303,1,'created_by','JOSM'),(52623305,1,'created_by','JOSM'),(52623308,1,'created_by','JOSM'),(52623310,1,'created_by','JOSM'),(52623315,1,'created_by','JOSM'),(52623317,1,'created_by','JOSM'),(52623321,1,'created_by','JOSM'),(52623324,1,'created_by','JOSM'),(52623329,1,'created_by','JOSM'),(52623333,1,'created_by','JOSM'),(52623334,1,'created_by','JOSM'),(52623339,1,'created_by','JOSM'),(52623344,1,'created_by','JOSM'),(52623348,1,'created_by','JOSM'),(52623351,1,'created_by','JOSM'),(52623354,1,'created_by','JOSM'),(52623358,1,'created_by','JOSM'),(52623360,1,'created_by','JOSM'),(52623363,1,'created_by','JOSM'),(52623364,1,'created_by','JOSM'),(52623367,1,'created_by','JOSM'),(52623371,1,'created_by','JOSM'),(52623373,1,'created_by','JOSM'),(52623375,1,'created_by','JOSM'),(52623378,1,'created_by','JOSM'),(52623383,1,'created_by','JOSM'),(52623385,1,'created_by','JOSM'),(52623389,1,'created_by','JOSM'),(52623392,1,'created_by','JOSM'),(52623394,1,'created_by','JOSM'),(52623398,1,'created_by','JOSM'),(52623402,1,'created_by','JOSM'),(52623403,1,'created_by','JOSM'),(52623407,1,'created_by','JOSM'),(52623413,1,'created_by','JOSM'),(52623416,1,'created_by','JOSM'),(52623417,1,'created_by','JOSM'),(52623420,1,'created_by','JOSM'),(52623424,1,'created_by','JOSM'),(52623427,1,'created_by','JOSM'),(52623431,1,'created_by','JOSM'),(52623434,1,'created_by','JOSM'),(52623436,1,'created_by','JOSM'),(52623438,1,'created_by','JOSM'),(52623441,1,'created_by','JOSM'),(52623444,1,'created_by','JOSM'),(52623446,1,'created_by','JOSM'),(52623449,1,'created_by','JOSM'),(52623453,1,'created_by','JOSM'),(52623457,1,'created_by','JOSM'),(52623463,1,'created_by','JOSM'),(52623465,1,'created_by','JOSM'),(52623471,1,'created_by','JOSM'),(52623475,1,'created_by','JOSM'),(52623478,1,'created_by','JOSM'),(52623482,1,'created_by','JOSM'),(52623485,1,'created_by','JOSM'),(52623487,1,'created_by','JOSM'),(52623489,1,'created_by','JOSM'),(52623492,1,'created_by','JOSM'),(52623494,1,'created_by','JOSM'),(52623497,1,'created_by','JOSM'),(52623500,1,'created_by','JOSM'),(52623503,1,'created_by','JOSM'),(52623506,1,'created_by','JOSM'),(52623509,1,'created_by','JOSM'),(52623513,1,'created_by','JOSM'),(52623516,1,'created_by','JOSM'),(52623517,1,'created_by','JOSM'),(52623522,1,'created_by','JOSM'),(52623526,1,'created_by','JOSM'),(52623530,1,'created_by','JOSM'),(52623533,1,'created_by','JOSM'),(52623535,1,'created_by','JOSM'),(52623538,1,'created_by','JOSM'),(52623541,1,'created_by','JOSM'),(52623543,1,'created_by','JOSM'),(52623545,1,'created_by','JOSM'),(52623548,1,'created_by','JOSM'),(52623550,1,'created_by','JOSM'),(52623553,1,'created_by','JOSM'),(52623556,1,'created_by','JOSM'),(52623559,1,'created_by','JOSM'),(52623562,1,'created_by','JOSM'),(52623565,1,'created_by','JOSM'),(52623567,1,'created_by','JOSM'),(52623570,1,'created_by','JOSM'),(52623573,1,'created_by','JOSM'),(52623576,1,'created_by','JOSM'),(52623578,1,'created_by','JOSM'),(52623581,1,'created_by','JOSM'),(52623584,1,'created_by','JOSM'),(52623587,1,'created_by','JOSM'),(52623589,1,'created_by','JOSM'),(52623590,1,'created_by','JOSM'),(52623593,1,'created_by','JOSM'),(52623597,1,'created_by','JOSM'),(52623599,1,'created_by','JOSM'),(52623602,1,'created_by','JOSM'),(52623605,1,'created_by','JOSM'),(52623610,1,'created_by','JOSM'),(52623613,1,'created_by','JOSM'),(52623617,1,'created_by','JOSM'),(52623618,1,'created_by','JOSM'),(52623621,1,'created_by','JOSM'),(52623624,1,'created_by','JOSM'),(52623627,1,'created_by','JOSM'),(52623630,1,'created_by','JOSM'),(52623633,1,'created_by','JOSM'),(52623636,1,'created_by','JOSM'),(52623638,1,'created_by','JOSM'),(52623641,1,'created_by','JOSM'),(52623644,1,'created_by','JOSM'),(52623647,1,'created_by','JOSM'),(52623649,1,'created_by','JOSM'),(52623653,1,'created_by','JOSM'),(52623655,1,'created_by','JOSM'),(52623657,1,'created_by','JOSM'),(52623660,1,'created_by','JOSM'),(52623664,1,'created_by','JOSM'),(52623667,1,'created_by','JOSM'),(52623670,1,'created_by','JOSM'),(52623674,1,'created_by','JOSM'),(52623675,1,'created_by','JOSM'),(52623679,1,'created_by','JOSM'),(52623684,1,'created_by','JOSM'),(52623687,1,'created_by','JOSM'),(52623690,1,'created_by','JOSM'),(52623692,1,'created_by','JOSM'),(52623694,1,'created_by','JOSM'),(52623698,1,'created_by','JOSM'),(52623701,1,'created_by','JOSM'),(52623702,1,'created_by','JOSM'),(52623705,1,'created_by','JOSM'),(52623707,1,'created_by','JOSM'),(52623712,1,'created_by','JOSM'),(52623713,1,'created_by','JOSM'),(52623715,1,'created_by','JOSM'),(52623717,1,'created_by','JOSM'),(52623719,1,'created_by','JOSM'),(52623720,1,'created_by','JOSM'),(52623722,1,'created_by','JOSM'),(52623725,1,'created_by','JOSM'),(52623726,1,'created_by','JOSM'),(52623728,1,'created_by','JOSM'),(52623730,1,'created_by','JOSM'),(52623732,1,'created_by','JOSM'),(52623733,1,'created_by','JOSM'),(52623736,1,'created_by','JOSM'),(52623739,1,'created_by','JOSM'),(52623741,1,'created_by','JOSM'),(52623743,1,'created_by','JOSM'),(52623746,1,'created_by','JOSM'),(52623749,1,'created_by','JOSM'),(52623750,1,'created_by','JOSM'),(52623752,1,'created_by','JOSM'),(52623753,1,'created_by','JOSM'),(52623755,1,'created_by','JOSM'),(52623757,1,'created_by','JOSM'),(52623758,1,'created_by','JOSM'),(52623759,1,'created_by','JOSM'),(52623760,1,'created_by','JOSM'),(52623762,1,'created_by','JOSM'),(52623763,1,'created_by','JOSM'),(52623765,1,'created_by','JOSM'),(52623767,1,'created_by','JOSM'),(52623768,1,'created_by','JOSM'),(52623769,1,'created_by','JOSM'),(52623771,1,'created_by','JOSM'),(52623772,1,'created_by','JOSM'),(52623773,1,'created_by','JOSM'),(52623776,1,'created_by','JOSM'),(52623777,1,'created_by','JOSM'),(52623778,1,'created_by','JOSM'),(52623779,1,'created_by','JOSM'),(52623780,1,'created_by','JOSM'),(52623781,1,'created_by','JOSM'),(52623782,1,'created_by','JOSM'),(52623783,1,'created_by','JOSM'),(52623784,1,'created_by','JOSM'),(52623785,1,'created_by','JOSM'),(52623786,1,'created_by','JOSM'),(52623788,1,'created_by','JOSM'),(52623791,1,'created_by','JOSM'),(52623792,1,'created_by','JOSM'),(52623795,1,'created_by','JOSM'),(52623798,1,'created_by','JOSM'),(52623800,1,'created_by','JOSM'),(52623802,1,'created_by','JOSM'),(52623805,1,'created_by','JOSM'),(52623806,1,'created_by','JOSM'),(52623808,1,'created_by','JOSM'),(52623809,1,'created_by','JOSM'),(52623811,1,'created_by','JOSM'),(52623814,1,'created_by','JOSM'),(52623816,1,'created_by','JOSM'),(52623819,1,'created_by','JOSM'),(52623823,1,'created_by','JOSM'),(52623844,1,'created_by','JOSM'),(52623846,1,'created_by','JOSM'),(52623849,1,'created_by','JOSM'),(52648095,1,'created_by','JOSM'),(52648138,1,'created_by','JOSM'),(52648149,1,'created_by','JOSM'),(52648164,1,'created_by','JOSM'),(52650158,3,'source','yahoo'),(52650659,4,'source','yahoo'),(52652127,3,'source','yahoo'),(52652273,3,'source','yahoo'),(52652319,1,'created_by','JOSM'),(52652351,1,'created_by','JOSM'),(52652477,1,'created_by','JOSM'),(52652555,1,'created_by','JOSM'),(52661498,1,'created_by','JOSM'),(52672004,1,'created_by','JOSM'),(52672499,1,'created_by','JOSM'),(52675912,1,'created_by','JOSM'),(52676235,1,'created_by','JOSM'),(52676253,1,'created_by','JOSM'),(52676260,1,'created_by','JOSM'),(52676267,1,'created_by','JOSM'),(52676295,1,'created_by','JOSM'),(52676338,1,'created_by','JOSM'),(52676349,1,'created_by','JOSM'),(52676434,1,'created_by','JOSM'),(52676891,1,'created_by','JOSM'),(52676911,1,'created_by','JOSM'),(52677089,1,'created_by','JOSM'),(52677154,1,'created_by','JOSM'),(52677211,1,'created_by','JOSM'),(52677635,1,'created_by','JOSM'),(52677662,1,'created_by','JOSM'),(52677757,1,'created_by','JOSM'),(52677811,1,'created_by','JOSM'),(52677844,1,'created_by','JOSM'),(52677862,1,'created_by','JOSM'),(52677872,1,'created_by','JOSM'),(52677878,1,'created_by','JOSM'),(52677908,1,'created_by','JOSM'),(52677912,1,'created_by','JOSM'),(52677918,1,'created_by','JOSM'),(52677922,1,'created_by','JOSM'),(52677929,1,'created_by','JOSM'),(52677934,1,'created_by','JOSM'),(52677939,1,'created_by','JOSM'),(52677945,1,'created_by','JOSM'),(52677993,1,'created_by','JOSM'),(52678005,1,'created_by','JOSM'),(52678200,1,'created_by','JOSM'),(52678225,1,'created_by','JOSM'),(52678243,1,'created_by','JOSM'),(52678266,1,'created_by','JOSM'),(52678278,1,'created_by','JOSM'),(52678285,1,'created_by','JOSM'),(52678294,1,'created_by','JOSM'),(52678450,1,'created_by','JOSM'),(52678519,1,'created_by','JOSM'),(52678582,1,'created_by','JOSM'),(52678634,1,'created_by','JOSM'),(52678741,1,'created_by','JOSM'),(52678786,1,'created_by','JOSM'),(52678860,1,'created_by','JOSM'),(52679237,1,'created_by','JOSM'),(52679255,1,'created_by','JOSM'),(52679261,1,'created_by','JOSM'),(52679265,1,'created_by','JOSM'),(52679271,1,'created_by','JOSM'),(52679365,1,'created_by','JOSM'),(52679445,1,'created_by','JOSM'),(52679499,1,'created_by','JOSM'),(52679531,1,'created_by','JOSM'),(52679731,1,'created_by','JOSM'),(52679744,1,'created_by','JOSM'),(52679804,1,'created_by','JOSM'),(52679809,1,'created_by','JOSM'),(52679815,1,'created_by','JOSM'),(52679821,1,'created_by','JOSM'),(52679879,1,'created_by','JOSM');
INSERT INTO `node_tags` VALUES (52679882,1,'created_by','JOSM'),(52679888,1,'created_by','JOSM'),(52679894,1,'created_by','JOSM'),(52679900,1,'created_by','JOSM'),(52679906,1,'created_by','JOSM'),(52679911,1,'created_by','JOSM'),(52679979,1,'created_by','JOSM'),(52679994,1,'created_by','JOSM'),(52680005,1,'created_by','JOSM'),(52680012,1,'created_by','JOSM'),(52680017,1,'created_by','JOSM'),(52680024,1,'created_by','JOSM'),(52680029,1,'created_by','JOSM'),(52680039,1,'created_by','JOSM'),(52680048,1,'created_by','JOSM'),(52680059,1,'created_by','JOSM'),(52680077,1,'created_by','JOSM'),(52680086,1,'created_by','JOSM'),(52680095,1,'created_by','JOSM'),(52680105,1,'created_by','JOSM'),(52680117,1,'created_by','JOSM'),(52680128,1,'created_by','JOSM'),(52680141,1,'created_by','JOSM'),(52680157,1,'created_by','JOSM'),(52680171,1,'created_by','JOSM'),(52680195,1,'created_by','JOSM'),(52680202,1,'created_by','JOSM'),(52680255,1,'created_by','JOSM'),(52680269,1,'created_by','JOSM'),(52680280,1,'created_by','JOSM'),(52680289,1,'created_by','JOSM'),(52680402,1,'created_by','JOSM'),(52680426,1,'created_by','JOSM'),(52680437,1,'created_by','JOSM'),(52680448,1,'created_by','JOSM'),(52680465,1,'created_by','JOSM'),(52680561,1,'created_by','JOSM'),(52680566,1,'created_by','JOSM'),(52680570,1,'created_by','JOSM'),(52680574,1,'created_by','JOSM'),(52680577,1,'created_by','JOSM'),(52680579,1,'created_by','JOSM'),(52680583,1,'created_by','JOSM'),(52680592,1,'created_by','JOSM'),(52680597,1,'created_by','JOSM'),(52680599,1,'created_by','JOSM'),(52680606,1,'created_by','JOSM'),(52680610,1,'created_by','JOSM'),(52680616,1,'created_by','JOSM'),(52680618,1,'created_by','JOSM'),(52680624,1,'created_by','JOSM'),(52680637,1,'created_by','JOSM'),(52680643,1,'created_by','JOSM'),(52680648,1,'created_by','JOSM'),(52680653,1,'created_by','JOSM'),(52680657,1,'created_by','JOSM'),(52680660,1,'created_by','JOSM'),(52680663,1,'created_by','JOSM'),(52680674,1,'created_by','JOSM'),(52680676,1,'created_by','JOSM'),(52680679,1,'created_by','JOSM'),(52680683,1,'created_by','JOSM'),(52680692,1,'created_by','JOSM'),(52680695,1,'created_by','JOSM'),(52680698,1,'created_by','JOSM'),(52680703,1,'created_by','JOSM'),(52680706,1,'created_by','JOSM'),(52680712,1,'created_by','JOSM'),(52680715,1,'created_by','JOSM'),(52680717,1,'created_by','JOSM'),(52680719,1,'created_by','JOSM'),(52680722,1,'created_by','JOSM'),(52680727,1,'created_by','JOSM'),(52680731,1,'created_by','JOSM'),(52680735,1,'created_by','JOSM'),(52680736,1,'created_by','JOSM'),(52680739,1,'created_by','JOSM'),(52680744,1,'created_by','JOSM'),(52680747,1,'created_by','JOSM'),(52680751,1,'created_by','JOSM'),(52680753,1,'created_by','JOSM'),(52680755,1,'created_by','JOSM'),(52680757,1,'created_by','JOSM'),(52680759,1,'created_by','JOSM'),(52680760,1,'created_by','JOSM'),(52680763,1,'created_by','JOSM'),(52680767,1,'created_by','JOSM'),(52680769,1,'created_by','JOSM'),(52680773,1,'created_by','JOSM'),(52680776,1,'created_by','JOSM'),(52680780,1,'created_by','JOSM'),(52680782,1,'created_by','JOSM'),(52680784,1,'created_by','JOSM'),(52680787,1,'created_by','JOSM'),(52680789,1,'created_by','JOSM'),(52680794,1,'created_by','JOSM'),(52680797,1,'created_by','JOSM'),(52680799,1,'created_by','JOSM'),(52680803,1,'created_by','JOSM'),(52680806,1,'created_by','JOSM'),(52680810,1,'created_by','JOSM'),(52680813,1,'created_by','JOSM'),(52680815,1,'created_by','JOSM'),(52680818,1,'created_by','JOSM'),(52680820,1,'created_by','JOSM'),(52680823,1,'created_by','JOSM'),(52680825,1,'created_by','JOSM'),(52680828,1,'created_by','JOSM'),(52680830,1,'created_by','JOSM'),(52680832,1,'created_by','JOSM'),(52680836,1,'created_by','JOSM'),(52680838,1,'created_by','JOSM'),(52680839,1,'created_by','JOSM'),(52680842,1,'created_by','JOSM'),(52680844,1,'created_by','JOSM'),(52680847,1,'created_by','JOSM'),(52680850,1,'created_by','JOSM'),(52680852,1,'created_by','JOSM'),(52680855,1,'created_by','JOSM'),(52680858,1,'created_by','JOSM'),(52680860,1,'created_by','JOSM'),(52680866,1,'created_by','JOSM'),(52680869,1,'created_by','JOSM'),(52680871,1,'created_by','JOSM'),(52680874,1,'created_by','JOSM'),(52680877,1,'created_by','JOSM'),(52680879,1,'created_by','JOSM'),(52680883,1,'created_by','JOSM'),(52680913,1,'created_by','JOSM'),(52680960,1,'created_by','JOSM'),(52681009,1,'created_by','JOSM'),(52681026,1,'created_by','JOSM'),(52681028,1,'created_by','JOSM'),(52681343,1,'created_by','JOSM'),(52681347,1,'created_by','JOSM'),(52681350,1,'created_by','JOSM'),(52681355,1,'created_by','JOSM'),(52681357,1,'created_by','JOSM'),(52681361,1,'created_by','JOSM'),(52681362,1,'created_by','JOSM'),(52681366,1,'created_by','JOSM'),(52681368,1,'created_by','JOSM'),(52681372,1,'created_by','JOSM'),(52681374,1,'created_by','JOSM'),(52681375,1,'created_by','JOSM'),(52681378,1,'created_by','JOSM'),(52681380,1,'created_by','JOSM'),(52681382,1,'created_by','JOSM'),(52681384,1,'created_by','JOSM'),(52681386,1,'created_by','JOSM'),(52681390,1,'created_by','JOSM'),(52681392,1,'created_by','JOSM'),(52681393,1,'created_by','JOSM'),(52681394,1,'created_by','JOSM'),(52681395,1,'created_by','JOSM'),(52681398,1,'created_by','JOSM'),(52681400,1,'created_by','JOSM'),(52681405,1,'created_by','JOSM'),(52681407,1,'created_by','JOSM'),(52681409,1,'created_by','JOSM'),(52681412,1,'created_by','JOSM'),(52681414,1,'created_by','JOSM'),(52681416,1,'created_by','JOSM'),(52681417,1,'created_by','JOSM'),(52681420,1,'created_by','JOSM'),(52681422,1,'created_by','JOSM'),(52681423,1,'created_by','JOSM'),(52681425,1,'created_by','JOSM'),(52681427,1,'created_by','JOSM'),(52681429,1,'created_by','JOSM'),(52681431,1,'created_by','JOSM'),(52681432,1,'created_by','JOSM'),(52681434,1,'created_by','JOSM'),(52681439,1,'created_by','JOSM'),(52681462,1,'created_by','JOSM'),(52681464,1,'created_by','JOSM'),(52681465,1,'created_by','JOSM'),(52681466,1,'created_by','JOSM'),(52681468,1,'created_by','JOSM'),(52681471,1,'created_by','JOSM'),(52681474,1,'created_by','JOSM'),(52681476,1,'created_by','JOSM'),(52681478,1,'created_by','JOSM'),(52681481,1,'created_by','JOSM'),(52681484,1,'created_by','JOSM'),(52681487,1,'created_by','JOSM'),(52681492,1,'created_by','JOSM'),(52681493,1,'created_by','JOSM'),(52681496,1,'created_by','JOSM'),(52681499,1,'created_by','JOSM'),(52681500,1,'created_by','JOSM'),(52681503,1,'created_by','JOSM'),(52681508,1,'created_by','JOSM'),(52681510,1,'created_by','JOSM'),(52681511,1,'created_by','JOSM'),(52681514,1,'created_by','JOSM'),(52681516,1,'created_by','JOSM'),(52681518,1,'created_by','JOSM'),(52681521,1,'created_by','JOSM'),(52681526,1,'created_by','JOSM'),(52681528,1,'created_by','JOSM'),(52681531,1,'created_by','JOSM'),(52681533,1,'created_by','JOSM'),(52681535,1,'created_by','JOSM'),(52681537,1,'created_by','JOSM'),(52681539,1,'created_by','JOSM'),(52681541,1,'created_by','JOSM'),(52681544,1,'created_by','JOSM'),(52681547,1,'created_by','JOSM'),(52681551,1,'created_by','JOSM'),(52681553,1,'created_by','JOSM'),(52681557,1,'created_by','JOSM'),(52681568,1,'created_by','JOSM'),(52681571,1,'created_by','JOSM'),(52681576,1,'created_by','JOSM'),(52681578,1,'created_by','JOSM'),(52681582,1,'created_by','JOSM'),(52681586,1,'created_by','JOSM'),(52681589,1,'created_by','JOSM'),(52681593,1,'created_by','JOSM'),(52681596,1,'created_by','JOSM'),(52681598,1,'created_by','JOSM'),(52681600,1,'created_by','JOSM'),(52681603,1,'created_by','JOSM'),(52681605,1,'created_by','JOSM'),(52681608,1,'created_by','JOSM'),(52681610,1,'created_by','JOSM'),(52681613,1,'created_by','JOSM'),(52681615,1,'created_by','JOSM'),(52681619,1,'created_by','JOSM'),(52681648,1,'created_by','JOSM'),(52681683,1,'created_by','JOSM'),(52681949,1,'created_by','JOSM'),(52682039,1,'created_by','JOSM'),(52682044,1,'created_by','JOSM'),(52682047,1,'created_by','JOSM'),(52682050,1,'created_by','JOSM'),(52682055,1,'created_by','JOSM'),(52682060,1,'created_by','JOSM'),(52682065,1,'created_by','JOSM'),(52682068,1,'created_by','JOSM'),(52682070,1,'created_by','JOSM'),(52682072,1,'created_by','JOSM'),(52682091,1,'created_by','JOSM'),(52682096,1,'created_by','JOSM'),(52682101,1,'created_by','JOSM'),(52682123,1,'created_by','JOSM'),(52682126,1,'created_by','JOSM'),(52682128,1,'created_by','JOSM'),(52682132,1,'created_by','JOSM'),(52682135,1,'created_by','JOSM'),(52682140,1,'created_by','JOSM'),(52682143,1,'created_by','JOSM'),(52682146,1,'created_by','JOSM'),(52682150,1,'created_by','JOSM'),(52682152,1,'created_by','JOSM'),(52682156,1,'created_by','JOSM'),(52682160,1,'created_by','JOSM'),(52682164,1,'created_by','JOSM'),(52682168,1,'created_by','JOSM'),(52682170,1,'created_by','JOSM'),(52682174,1,'created_by','JOSM'),(52682178,1,'created_by','JOSM'),(52682180,1,'created_by','JOSM'),(52682184,1,'created_by','JOSM'),(52682186,1,'created_by','JOSM'),(52682190,1,'created_by','JOSM'),(52682195,1,'created_by','JOSM'),(52682197,1,'created_by','JOSM'),(52682200,1,'created_by','JOSM'),(52682202,1,'created_by','JOSM'),(52682204,1,'created_by','JOSM'),(52682207,1,'created_by','JOSM'),(52682210,1,'created_by','JOSM'),(52682212,1,'created_by','JOSM'),(52682215,1,'created_by','JOSM'),(52682216,1,'created_by','JOSM'),(52682221,1,'created_by','JOSM'),(52682224,1,'created_by','JOSM'),(52682227,1,'created_by','JOSM'),(52682231,1,'created_by','JOSM'),(52682235,1,'created_by','JOSM'),(52682238,1,'created_by','JOSM'),(52682240,1,'created_by','JOSM'),(52682243,1,'created_by','JOSM'),(52682244,1,'created_by','JOSM'),(52682247,1,'created_by','JOSM'),(52682250,1,'created_by','JOSM'),(52682253,1,'created_by','JOSM'),(52682255,1,'created_by','JOSM'),(52682257,1,'created_by','JOSM'),(52682259,1,'created_by','JOSM'),(52682262,1,'created_by','JOSM'),(52682265,1,'created_by','JOSM'),(52682270,1,'created_by','JOSM'),(52682272,1,'created_by','JOSM'),(52682274,1,'created_by','JOSM'),(52682277,1,'created_by','JOSM'),(52682524,1,'created_by','JOSM'),(52682546,1,'created_by','JOSM'),(52682558,1,'created_by','JOSM'),(52682617,1,'created_by','JOSM'),(52682663,1,'created_by','JOSM'),(52682673,1,'created_by','JOSM'),(52685135,1,'created_by','JOSM'),(52685138,1,'created_by','JOSM'),(52685142,1,'created_by','JOSM'),(52685145,1,'created_by','JOSM'),(52685147,1,'created_by','JOSM'),(52685151,1,'created_by','JOSM'),(52685154,1,'created_by','JOSM'),(52685157,1,'created_by','JOSM'),(52685160,1,'created_by','JOSM'),(52685162,1,'created_by','JOSM'),(52685166,1,'created_by','JOSM'),(52685169,1,'created_by','JOSM'),(52685171,1,'created_by','JOSM'),(52685184,1,'created_by','JOSM'),(52685190,1,'created_by','JOSM'),(52685195,1,'created_by','JOSM'),(52685199,1,'created_by','JOSM'),(52685202,1,'created_by','JOSM'),(52685204,1,'created_by','JOSM'),(52685207,1,'created_by','JOSM'),(52685211,1,'created_by','JOSM'),(52685217,1,'created_by','JOSM'),(52685220,1,'created_by','JOSM'),(52685226,1,'created_by','JOSM'),(52685229,1,'created_by','JOSM'),(52685232,1,'created_by','JOSM'),(52685236,1,'created_by','JOSM'),(52685238,1,'created_by','JOSM'),(52685243,1,'created_by','JOSM'),(52685247,1,'created_by','JOSM'),(52685258,1,'created_by','JOSM'),(52685262,1,'created_by','JOSM'),(52685269,1,'created_by','JOSM'),(52685275,1,'created_by','JOSM'),(52685277,1,'created_by','JOSM'),(52685282,1,'created_by','JOSM'),(52685296,1,'created_by','JOSM'),(52685299,1,'created_by','JOSM'),(52685307,1,'created_by','JOSM'),(52685313,1,'created_by','JOSM'),(52685696,1,'created_by','JOSM'),(52685701,1,'created_by','JOSM'),(52685707,1,'created_by','JOSM'),(52685710,1,'created_by','JOSM'),(52685714,1,'created_by','JOSM'),(52685717,1,'created_by','JOSM'),(52685723,1,'created_by','JOSM'),(52685727,1,'created_by','JOSM'),(52685732,1,'created_by','JOSM'),(52685739,1,'created_by','JOSM'),(52685761,1,'created_by','JOSM'),(52685764,1,'created_by','JOSM'),(52685771,1,'created_by','JOSM'),(52685779,1,'created_by','JOSM'),(52685789,1,'created_by','JOSM'),(52685802,1,'created_by','JOSM'),(52685814,1,'created_by','JOSM'),(52685832,1,'created_by','JOSM'),(52685840,1,'created_by','JOSM'),(52685847,1,'created_by','JOSM'),(52685851,1,'created_by','JOSM'),(52685859,1,'created_by','JOSM'),(52685862,1,'created_by','JOSM'),(52685869,1,'created_by','JOSM'),(52685873,1,'created_by','JOSM'),(52685877,1,'created_by','JOSM'),(52685881,1,'created_by','JOSM'),(52685886,1,'created_by','JOSM'),(52685894,1,'created_by','JOSM'),(52685905,1,'created_by','JOSM'),(52685911,1,'created_by','JOSM'),(52685917,1,'created_by','JOSM'),(52685920,1,'created_by','JOSM'),(52685923,1,'created_by','JOSM'),(52685926,1,'created_by','JOSM'),(52685929,1,'created_by','JOSM'),(52685931,1,'created_by','JOSM'),(52685934,1,'created_by','JOSM'),(52685939,1,'created_by','JOSM'),(52685943,1,'created_by','JOSM'),(52685946,1,'created_by','JOSM'),(52685950,1,'created_by','JOSM'),(52685966,1,'created_by','JOSM'),(52685971,1,'created_by','JOSM'),(52685975,1,'created_by','JOSM'),(52685978,1,'created_by','JOSM'),(52685980,1,'created_by','JOSM'),(52685982,1,'created_by','JOSM'),(52685986,1,'created_by','JOSM'),(52685990,1,'created_by','JOSM'),(52685993,1,'created_by','JOSM'),(52685996,1,'created_by','JOSM'),(52686002,1,'created_by','JOSM'),(52686474,1,'created_by','JOSM'),(52686478,1,'created_by','JOSM'),(52686480,1,'created_by','JOSM'),(52686486,1,'created_by','JOSM'),(52686490,1,'created_by','JOSM'),(52686495,1,'created_by','JOSM'),(52686501,1,'created_by','JOSM'),(52686505,1,'created_by','JOSM'),(52686510,1,'created_by','JOSM'),(52686511,1,'created_by','JOSM'),(52686514,1,'created_by','JOSM'),(52686517,1,'created_by','JOSM'),(52686518,1,'created_by','JOSM'),(52686521,1,'created_by','JOSM'),(52686524,1,'created_by','JOSM'),(52686527,2,'created_by','JOSM'),(52686533,1,'created_by','JOSM'),(52686537,1,'created_by','JOSM'),(52686542,1,'created_by','JOSM'),(52686544,1,'created_by','JOSM'),(52686547,1,'created_by','JOSM'),(52686551,1,'created_by','JOSM'),(52686555,1,'created_by','JOSM'),(52686561,1,'created_by','JOSM'),(52686569,1,'created_by','JOSM'),(52686574,1,'created_by','JOSM'),(52686579,1,'created_by','JOSM'),(52686586,1,'created_by','JOSM'),(52686593,1,'created_by','JOSM'),(52686598,1,'created_by','JOSM'),(52686601,1,'created_by','JOSM'),(52686604,1,'created_by','JOSM'),(52686607,1,'created_by','JOSM'),(52686610,1,'created_by','JOSM'),(52686622,1,'created_by','JOSM'),(52686626,1,'created_by','JOSM'),(52686632,1,'created_by','JOSM'),(52686637,1,'created_by','JOSM'),(52686639,1,'created_by','JOSM'),(52686644,1,'created_by','JOSM'),(52686648,1,'created_by','JOSM'),(52686651,1,'created_by','JOSM'),(52686654,1,'created_by','JOSM'),(52686655,1,'created_by','JOSM'),(52686659,1,'created_by','JOSM'),(52686660,1,'created_by','JOSM'),(52686663,1,'created_by','JOSM'),(52686666,1,'created_by','JOSM'),(52686668,1,'created_by','JOSM'),(52686674,1,'created_by','JOSM'),(52686680,1,'created_by','JOSM'),(52686682,1,'created_by','JOSM'),(52686683,1,'created_by','JOSM'),(52686687,1,'created_by','JOSM'),(52688384,1,'created_by','JOSM'),(52688387,1,'created_by','JOSM'),(52688389,1,'created_by','JOSM'),(52688391,1,'created_by','JOSM'),(52688393,1,'created_by','JOSM'),(52688398,1,'created_by','JOSM'),(52688401,1,'created_by','JOSM'),(52688431,1,'created_by','JOSM'),(52688438,1,'created_by','JOSM'),(52688454,1,'created_by','JOSM'),(52688455,1,'created_by','JOSM'),(52688458,1,'created_by','JOSM'),(52688531,1,'created_by','JOSM'),(52688570,1,'created_by','JOSM'),(52688574,1,'created_by','JOSM'),(52688576,1,'created_by','JOSM'),(52688577,1,'created_by','JOSM'),(52688580,1,'created_by','JOSM'),(52688582,1,'created_by','JOSM'),(52688584,1,'created_by','JOSM'),(52688608,1,'created_by','JOSM'),(52688609,1,'created_by','JOSM'),(52688628,1,'created_by','JOSM'),(52688632,1,'created_by','JOSM'),(52688633,1,'created_by','JOSM'),(52688637,1,'created_by','JOSM'),(52688639,1,'created_by','JOSM'),(52688642,1,'created_by','JOSM'),(52688644,1,'created_by','JOSM'),(52688646,1,'created_by','JOSM'),(52688648,1,'created_by','JOSM'),(52688652,1,'created_by','JOSM'),(52688654,1,'created_by','JOSM'),(52688655,1,'created_by','JOSM'),(52688662,1,'created_by','JOSM'),(52688663,1,'created_by','JOSM'),(52688667,1,'created_by','JOSM'),(52688669,1,'created_by','JOSM'),(52688876,1,'created_by','JOSM'),(52688936,1,'created_by','JOSM'),(52688938,1,'created_by','JOSM'),(52688942,1,'created_by','JOSM'),(52688945,1,'created_by','JOSM'),(52688948,1,'created_by','JOSM'),(52688951,1,'created_by','JOSM'),(52688953,1,'created_by','JOSM'),(52688956,1,'created_by','JOSM'),(52688958,1,'created_by','JOSM'),(52688962,1,'created_by','JOSM'),(52688963,1,'created_by','JOSM'),(52688967,1,'created_by','JOSM'),(52688969,1,'created_by','JOSM'),(52688973,1,'created_by','JOSM'),(52688975,1,'created_by','JOSM'),(52688978,1,'created_by','JOSM'),(52688981,1,'created_by','JOSM'),(52689010,1,'created_by','JOSM'),(52689011,1,'created_by','JOSM'),(52689013,1,'created_by','JOSM'),(52689016,1,'created_by','JOSM'),(52689017,1,'created_by','JOSM'),(52689019,1,'created_by','JOSM'),(52689020,1,'created_by','JOSM'),(52689024,1,'created_by','JOSM'),(52689026,1,'created_by','JOSM'),(52689028,1,'created_by','JOSM'),(52689032,1,'created_by','JOSM'),(52689035,1,'created_by','JOSM'),(52689036,1,'created_by','JOSM'),(52689039,1,'created_by','JOSM'),(52689041,1,'created_by','JOSM'),(52689048,1,'created_by','JOSM'),(52689081,1,'created_by','JOSM'),(52689083,1,'created_by','JOSM'),(52689086,1,'created_by','JOSM'),(52689090,1,'created_by','JOSM'),(52689092,1,'created_by','JOSM'),(52689094,1,'created_by','JOSM'),(52689095,1,'created_by','JOSM'),(52689097,1,'created_by','JOSM'),(52689102,1,'created_by','JOSM'),(52689104,1,'created_by','JOSM'),(52689106,1,'created_by','JOSM'),(52689107,1,'created_by','JOSM'),(52689110,1,'created_by','JOSM'),(52689111,1,'created_by','JOSM'),(52689114,1,'created_by','JOSM'),(52689115,1,'created_by','JOSM'),(52689118,1,'created_by','JOSM'),(52689120,1,'created_by','JOSM'),(52689141,1,'created_by','JOSM'),(52689142,1,'created_by','JOSM'),(52689145,1,'created_by','JOSM'),(52689148,1,'created_by','JOSM'),(52689150,1,'created_by','JOSM'),(52689154,1,'created_by','JOSM'),(52689156,1,'created_by','JOSM'),(52689157,1,'created_by','JOSM'),(52689160,1,'created_by','JOSM'),(52689162,1,'created_by','JOSM'),(52689165,1,'created_by','JOSM'),(52689167,1,'created_by','JOSM'),(52689173,1,'created_by','JOSM'),(52689178,1,'created_by','JOSM'),(52689180,1,'created_by','JOSM'),(52689184,1,'created_by','JOSM'),(52689187,1,'created_by','JOSM'),(52689189,1,'created_by','JOSM'),(52689194,1,'created_by','JOSM'),(52689197,1,'created_by','JOSM'),(52689201,1,'created_by','JOSM'),(52689204,1,'created_by','JOSM'),(52689208,1,'created_by','JOSM'),(52689210,1,'created_by','JOSM'),(52689214,1,'created_by','JOSM'),(52689217,1,'created_by','JOSM'),(52689218,1,'created_by','JOSM'),(52689230,1,'created_by','JOSM'),(52689232,1,'created_by','JOSM'),(52689236,1,'created_by','JOSM'),(52689239,1,'created_by','JOSM'),(52689242,1,'created_by','JOSM'),(52689243,1,'created_by','JOSM'),(52689245,1,'created_by','JOSM'),(52689248,1,'created_by','JOSM'),(52689249,1,'created_by','JOSM'),(52689251,1,'created_by','JOSM'),(52689253,1,'created_by','JOSM'),(52689255,1,'created_by','JOSM'),(52689257,1,'created_by','JOSM'),(52689259,1,'created_by','JOSM'),(52689262,1,'created_by','JOSM'),(52689263,1,'created_by','JOSM'),(52689265,1,'created_by','JOSM'),(52689267,1,'created_by','JOSM'),(52689270,1,'created_by','JOSM'),(52689273,1,'created_by','JOSM'),(52689275,1,'created_by','JOSM'),(52689278,1,'created_by','JOSM'),(52689279,1,'created_by','JOSM'),(52689280,1,'created_by','JOSM'),(52689282,1,'created_by','JOSM'),(52689285,1,'created_by','JOSM'),(52689288,1,'created_by','JOSM'),(52689290,1,'created_by','JOSM'),(52689292,1,'created_by','JOSM'),(52689294,1,'created_by','JOSM'),(52689295,1,'created_by','JOSM'),(52689303,1,'created_by','JOSM'),(52689304,1,'created_by','JOSM'),(52689308,1,'created_by','JOSM'),(52689311,1,'created_by','JOSM'),(52689316,1,'created_by','JOSM'),(52689319,1,'created_by','JOSM'),(52689321,1,'created_by','JOSM'),(52689323,1,'created_by','JOSM'),(52689326,1,'created_by','JOSM'),(52689328,1,'created_by','JOSM'),(52689330,1,'created_by','JOSM'),(52689333,1,'created_by','JOSM'),(52689336,1,'created_by','JOSM'),(52689338,1,'created_by','JOSM'),(52689340,1,'created_by','JOSM'),(52689343,1,'created_by','JOSM'),(52689345,1,'created_by','JOSM'),(52689348,1,'created_by','JOSM'),(52689350,1,'created_by','JOSM'),(52689351,1,'created_by','JOSM'),(52689353,1,'created_by','JOSM'),(52689355,1,'created_by','JOSM'),(52689358,1,'created_by','JOSM'),(52689359,1,'created_by','JOSM'),(52689361,1,'created_by','JOSM'),(52689363,1,'created_by','JOSM'),(52689365,1,'created_by','JOSM'),(52689366,1,'created_by','JOSM'),(52689367,1,'created_by','JOSM'),(52689371,1,'created_by','JOSM'),(52689372,1,'created_by','JOSM'),(52689375,1,'created_by','JOSM'),(52689377,1,'created_by','JOSM'),(52689379,1,'created_by','JOSM'),(52689382,1,'created_by','JOSM'),(52689385,1,'created_by','JOSM'),(52689387,1,'created_by','JOSM'),(52689390,1,'created_by','JOSM'),(52689392,1,'created_by','JOSM'),(52689394,1,'created_by','JOSM'),(52689396,1,'created_by','JOSM'),(52689398,1,'created_by','JOSM'),(52689402,1,'created_by','JOSM'),(52689405,1,'created_by','JOSM'),(52689406,1,'created_by','JOSM'),(52689409,1,'created_by','JOSM'),(52689410,1,'created_by','JOSM'),(52689412,1,'created_by','JOSM'),(52689414,1,'created_by','JOSM'),(52689416,1,'created_by','JOSM'),(52689419,1,'created_by','JOSM'),(52689420,1,'created_by','JOSM'),(52689423,1,'created_by','JOSM'),(52689425,1,'created_by','JOSM'),(52689427,1,'created_by','JOSM'),(52689429,1,'created_by','JOSM'),(52689432,1,'created_by','JOSM'),(52689433,1,'created_by','JOSM'),(52689436,1,'created_by','JOSM'),(52689437,1,'created_by','JOSM'),(52689440,1,'created_by','JOSM'),(52689443,1,'created_by','JOSM'),(52689445,1,'created_by','JOSM'),(52689447,1,'created_by','JOSM'),(52689450,1,'created_by','JOSM'),(52689451,1,'created_by','JOSM'),(52689452,1,'created_by','JOSM'),(52689455,1,'created_by','JOSM'),(52689456,1,'created_by','JOSM'),(52689459,1,'created_by','JOSM'),(52689461,1,'created_by','JOSM'),(52689464,1,'created_by','JOSM'),(52689484,1,'created_by','JOSM'),(52689486,1,'created_by','JOSM'),(52689488,1,'created_by','JOSM'),(52689491,1,'created_by','JOSM'),(52689493,1,'created_by','JOSM'),(52689494,1,'created_by','JOSM'),(52689496,1,'created_by','JOSM'),(52689497,1,'created_by','JOSM'),(52689499,1,'created_by','JOSM'),(52689501,1,'created_by','JOSM'),(52689503,1,'created_by','JOSM'),(52689505,1,'created_by','JOSM'),(52689508,1,'created_by','JOSM'),(52689513,1,'created_by','JOSM'),(52689516,1,'created_by','JOSM'),(52689518,1,'created_by','JOSM'),(52689522,1,'created_by','JOSM'),(52689524,1,'created_by','JOSM'),(52689527,1,'created_by','JOSM'),(52689528,1,'created_by','JOSM'),(52689532,1,'created_by','JOSM'),(52689534,1,'created_by','JOSM'),(52689537,1,'created_by','JOSM'),(52689538,1,'created_by','JOSM'),(52689540,1,'created_by','JOSM'),(52689545,1,'created_by','JOSM'),(52689549,1,'created_by','JOSM'),(52689552,1,'created_by','JOSM'),(52689553,1,'created_by','JOSM'),(52689556,1,'created_by','JOSM'),(52689558,1,'created_by','JOSM'),(52689560,1,'created_by','JOSM'),(52689562,1,'created_by','JOSM'),(52689565,1,'created_by','JOSM'),(52689567,1,'created_by','JOSM'),(52689570,1,'created_by','JOSM'),(52689572,1,'created_by','JOSM'),(52689573,1,'created_by','JOSM'),(52689576,1,'created_by','JOSM'),(52689579,1,'created_by','JOSM'),(52689580,1,'created_by','JOSM'),(52689583,1,'created_by','JOSM'),(52689584,1,'created_by','JOSM'),(52689585,1,'created_by','JOSM'),(52689586,1,'created_by','JOSM'),(52689589,1,'created_by','JOSM'),(52689591,1,'created_by','JOSM'),(52689593,1,'created_by','JOSM'),(52689594,1,'created_by','JOSM'),(52689596,1,'created_by','JOSM'),(52689600,1,'created_by','JOSM'),(52689603,1,'created_by','JOSM'),(52689604,1,'created_by','JOSM'),(52689607,1,'created_by','JOSM'),(52689608,1,'created_by','JOSM'),(52689609,1,'created_by','JOSM'),(52689610,1,'created_by','JOSM'),(52689612,1,'created_by','JOSM'),(52689613,1,'created_by','JOSM'),(52689615,1,'created_by','JOSM'),(52689617,1,'created_by','JOSM'),(52689618,1,'created_by','JOSM'),(52689619,1,'created_by','JOSM'),(52689621,1,'created_by','JOSM'),(52689624,1,'created_by','JOSM'),(52689627,1,'created_by','JOSM'),(52689629,1,'created_by','JOSM'),(52689631,1,'created_by','JOSM'),(52689635,1,'created_by','JOSM'),(52689639,1,'created_by','JOSM'),(52689643,1,'created_by','JOSM'),(52689647,1,'created_by','JOSM'),(52689650,1,'created_by','JOSM'),(52689653,1,'created_by','JOSM'),(52689656,1,'created_by','JOSM'),(52689659,1,'created_by','JOSM'),(52689661,1,'created_by','JOSM'),(52689663,1,'created_by','JOSM'),(52689665,1,'created_by','JOSM'),(52689666,1,'created_by','JOSM'),(52689670,1,'created_by','JOSM'),(52689673,1,'created_by','JOSM'),(52689676,1,'created_by','JOSM'),(52689679,1,'created_by','JOSM'),(52689681,1,'created_by','JOSM'),(52689684,1,'created_by','JOSM'),(52689687,1,'created_by','JOSM'),(52689689,1,'created_by','JOSM'),(52689692,1,'created_by','JOSM'),(52689696,1,'created_by','JOSM'),(52689699,1,'created_by','JOSM'),(52689701,1,'created_by','JOSM'),(52689705,1,'created_by','JOSM'),(52689707,1,'created_by','JOSM'),(52689709,1,'created_by','JOSM'),(52689713,1,'created_by','JOSM'),(52689714,1,'created_by','JOSM'),(52689718,1,'created_by','JOSM'),(52689720,1,'created_by','JOSM'),(52689723,1,'created_by','JOSM'),(52689724,1,'created_by','JOSM'),(52689728,1,'created_by','JOSM'),(52689731,1,'created_by','JOSM'),(52689733,1,'created_by','JOSM'),(52689737,1,'created_by','JOSM'),(52689739,1,'created_by','JOSM'),(52689742,1,'created_by','JOSM'),(52689743,1,'created_by','JOSM'),(52689747,1,'created_by','JOSM'),(52689748,1,'created_by','JOSM'),(52689751,1,'created_by','JOSM'),(52689755,1,'created_by','JOSM'),(52733171,1,'created_by','JOSM'),(52733173,1,'created_by','JOSM'),(52733177,1,'created_by','JOSM'),(52733181,1,'created_by','JOSM'),(52733186,1,'created_by','JOSM'),(52733193,1,'created_by','JOSM'),(52733201,1,'created_by','JOSM'),(52733204,1,'created_by','JOSM'),(52733206,1,'created_by','JOSM'),(52733209,1,'created_by','JOSM'),(52733212,1,'created_by','JOSM'),(52733215,1,'created_by','JOSM'),(52733218,1,'created_by','JOSM'),(52733223,1,'created_by','JOSM'),(52743859,1,'created_by','JOSM'),(52743862,1,'created_by','JOSM'),(52743866,1,'created_by','JOSM'),(52743871,1,'created_by','JOSM'),(52743874,1,'created_by','JOSM'),(52743875,1,'created_by','JOSM'),(52743878,1,'created_by','JOSM'),(52743880,1,'created_by','JOSM'),(52743882,1,'created_by','JOSM'),(52743884,1,'created_by','JOSM'),(52743887,3,'created_by','JOSM'),(52743889,1,'created_by','JOSM'),(52743892,1,'created_by','JOSM'),(52743895,1,'created_by','JOSM'),(52743896,1,'created_by','JOSM'),(52743899,1,'created_by','JOSM'),(52743900,1,'created_by','JOSM'),(52743901,1,'created_by','JOSM'),(52743902,1,'created_by','JOSM'),(52743904,1,'created_by','JOSM'),(52743907,1,'created_by','JOSM'),(52743909,1,'created_by','JOSM'),(52743910,1,'created_by','JOSM'),(52743913,1,'created_by','JOSM'),(52743916,1,'created_by','JOSM'),(52743919,1,'created_by','JOSM'),(52743921,1,'created_by','JOSM'),(52743924,1,'created_by','JOSM'),(52743925,1,'created_by','JOSM'),(52743927,1,'created_by','JOSM'),(52743928,1,'created_by','JOSM'),(52743930,1,'created_by','JOSM'),(52743933,1,'created_by','JOSM'),(52743936,1,'created_by','JOSM'),(52743937,1,'created_by','JOSM'),(52743940,1,'created_by','JOSM'),(52743941,1,'created_by','JOSM'),(52743943,1,'created_by','JOSM'),(52743946,1,'created_by','JOSM'),(52743947,1,'created_by','JOSM'),(52743950,1,'created_by','JOSM'),(52743951,1,'created_by','JOSM'),(52743954,1,'created_by','JOSM'),(52743955,1,'created_by','JOSM'),(52743958,1,'created_by','JOSM'),(52743959,1,'created_by','JOSM'),(52743961,1,'created_by','JOSM'),(52743964,1,'created_by','JOSM'),(52743966,1,'created_by','JOSM'),(52743967,1,'created_by','JOSM'),(52743969,1,'created_by','JOSM'),(52743971,1,'created_by','JOSM'),(52743972,1,'created_by','JOSM'),(52743973,1,'created_by','JOSM'),(52743976,1,'created_by','JOSM'),(52743980,1,'created_by','JOSM'),(52743981,1,'created_by','JOSM'),(52743984,1,'created_by','JOSM'),(52743986,1,'created_by','JOSM'),(52743987,1,'created_by','JOSM'),(52743988,1,'created_by','JOSM'),(52743991,1,'created_by','JOSM'),(52743992,1,'created_by','JOSM'),(52743995,1,'created_by','JOSM'),(52743997,1,'created_by','JOSM'),(52744001,1,'created_by','JOSM'),(52744002,1,'created_by','JOSM'),(52744005,1,'created_by','JOSM'),(52744007,1,'created_by','JOSM'),(52744009,1,'created_by','JOSM'),(52744012,1,'created_by','JOSM'),(52744014,1,'created_by','JOSM'),(52744016,1,'created_by','JOSM'),(52744019,1,'created_by','JOSM'),(52744021,1,'created_by','JOSM'),(52744022,1,'created_by','JOSM'),(52744025,1,'created_by','JOSM'),(52744028,1,'created_by','JOSM'),(52744030,1,'created_by','JOSM'),(52744032,1,'created_by','JOSM'),(52744035,1,'created_by','JOSM'),(52744036,1,'created_by','JOSM'),(52744038,1,'created_by','JOSM'),(52744042,1,'created_by','JOSM'),(52744043,1,'created_by','JOSM'),(52744046,1,'created_by','JOSM'),(52744049,1,'created_by','JOSM'),(52744050,1,'created_by','JOSM'),(52744052,1,'created_by','JOSM'),(52744053,1,'created_by','JOSM'),(52744054,1,'created_by','JOSM'),(52744056,1,'created_by','JOSM'),(52744057,1,'created_by','JOSM'),(52744059,1,'created_by','JOSM'),(52744062,1,'created_by','JOSM'),(52744064,1,'created_by','JOSM'),(52744066,1,'created_by','JOSM'),(52744067,1,'created_by','JOSM'),(52744070,1,'created_by','JOSM'),(52744072,1,'created_by','JOSM'),(52744073,1,'created_by','JOSM'),(52744074,1,'created_by','JOSM'),(52744075,1,'created_by','JOSM'),(52744078,1,'created_by','JOSM'),(52744081,1,'created_by','JOSM'),(52744082,1,'created_by','JOSM'),(52744084,1,'created_by','JOSM'),(52744086,1,'created_by','JOSM'),(52744087,1,'created_by','JOSM'),(52744089,1,'created_by','JOSM'),(52744091,1,'created_by','JOSM'),(52744093,1,'created_by','JOSM'),(52744094,1,'created_by','JOSM'),(52744096,1,'created_by','JOSM'),(52744097,1,'created_by','JOSM'),(52744099,1,'created_by','JOSM'),(52744100,1,'created_by','JOSM'),(52744101,1,'created_by','JOSM'),(52744102,1,'created_by','JOSM'),(52744104,1,'created_by','JOSM'),(52744106,1,'created_by','JOSM'),(52744108,1,'created_by','JOSM'),(52744110,1,'created_by','JOSM'),(52744111,1,'created_by','JOSM'),(52744114,1,'created_by','JOSM'),(52744116,1,'created_by','JOSM'),(52744118,1,'created_by','JOSM'),(52744120,1,'created_by','JOSM'),(52744122,1,'created_by','JOSM'),(52744124,1,'created_by','JOSM'),(52744126,1,'created_by','JOSM'),(52744128,1,'created_by','JOSM'),(52744130,1,'created_by','JOSM'),(52744133,1,'created_by','JOSM'),(52744134,1,'created_by','JOSM'),(52744136,1,'created_by','JOSM'),(52744138,1,'created_by','JOSM'),(52744141,1,'created_by','JOSM'),(52744144,1,'created_by','JOSM'),(52744147,1,'created_by','JOSM'),(52744149,1,'created_by','JOSM'),(52744152,1,'created_by','JOSM'),(52744155,1,'created_by','JOSM'),(52744158,1,'created_by','JOSM'),(52744159,1,'created_by','JOSM'),(52744161,1,'created_by','JOSM'),(52744163,1,'created_by','JOSM'),(52744165,1,'created_by','JOSM'),(52744166,1,'created_by','JOSM'),(52744172,2,'created_by','JOSM'),(52744174,1,'created_by','JOSM'),(52744177,3,'created_by','JOSM'),(52744180,1,'created_by','JOSM'),(52744181,1,'created_by','JOSM'),(52744184,1,'created_by','JOSM'),(52744187,1,'created_by','JOSM'),(52744189,1,'created_by','JOSM'),(52744190,1,'created_by','JOSM'),(52744193,1,'created_by','JOSM'),(52744196,1,'created_by','JOSM'),(52744198,1,'created_by','JOSM'),(52744201,1,'created_by','JOSM'),(52744202,1,'created_by','JOSM'),(52744205,1,'created_by','JOSM'),(52744206,1,'created_by','JOSM'),(52744209,1,'created_by','JOSM'),(52744212,1,'created_by','JOSM'),(52744213,1,'created_by','JOSM'),(52744214,1,'created_by','JOSM'),(52744218,1,'created_by','JOSM'),(52744219,1,'created_by','JOSM'),(52744222,1,'created_by','JOSM'),(52744223,1,'created_by','JOSM'),(52744227,1,'created_by','JOSM'),(52744228,1,'created_by','JOSM'),(52744231,1,'created_by','JOSM'),(52744232,1,'created_by','JOSM'),(52744236,1,'created_by','JOSM'),(52744237,1,'created_by','JOSM'),(52744238,1,'created_by','JOSM'),(52744240,1,'created_by','JOSM'),(52744241,1,'created_by','JOSM'),(52744245,1,'created_by','JOSM'),(52744246,1,'created_by','JOSM'),(52744249,1,'created_by','JOSM'),(52744250,1,'created_by','JOSM'),(52744253,1,'created_by','JOSM'),(52744254,1,'created_by','JOSM'),(52744257,1,'created_by','JOSM'),(52744259,1,'created_by','JOSM'),(52744260,1,'created_by','JOSM'),(52744262,1,'created_by','JOSM'),(52744264,1,'created_by','JOSM'),(52744265,1,'created_by','JOSM'),(52744268,1,'created_by','JOSM'),(52744270,1,'created_by','JOSM'),(52744272,1,'created_by','JOSM'),(52744274,1,'created_by','JOSM'),(52744277,1,'created_by','JOSM'),(52744279,1,'created_by','JOSM'),(52744281,1,'created_by','JOSM'),(52744284,1,'created_by','JOSM'),(52744286,1,'created_by','JOSM'),(52744289,1,'created_by','JOSM'),(52744292,1,'created_by','JOSM'),(52744294,1,'created_by','JOSM'),(52744296,1,'created_by','JOSM'),(52744298,1,'created_by','JOSM'),(52744301,1,'created_by','JOSM'),(52744303,1,'created_by','JOSM'),(52744306,1,'created_by','JOSM'),(52744308,1,'created_by','JOSM'),(52744309,1,'created_by','JOSM'),(52744312,1,'created_by','JOSM'),(52744313,1,'created_by','JOSM'),(52744315,1,'created_by','JOSM'),(52744318,1,'created_by','JOSM'),(52744320,1,'created_by','JOSM'),(52744323,1,'created_by','JOSM'),(52744326,1,'created_by','JOSM'),(52744329,1,'created_by','JOSM'),(52744330,1,'created_by','JOSM'),(52744333,1,'created_by','JOSM'),(52744334,1,'created_by','JOSM'),(52744337,1,'created_by','JOSM'),(52744339,1,'created_by','JOSM'),(52744342,1,'created_by','JOSM'),(52744344,1,'created_by','JOSM'),(52744346,1,'created_by','JOSM'),(52744349,1,'created_by','JOSM'),(52744350,1,'created_by','JOSM'),(52744352,1,'created_by','JOSM'),(52744356,1,'created_by','JOSM'),(52744359,1,'created_by','JOSM'),(52744360,1,'created_by','JOSM'),(52744364,1,'created_by','JOSM'),(52744365,1,'created_by','JOSM'),(52744368,1,'created_by','JOSM'),(52744370,1,'created_by','JOSM'),(52744372,1,'created_by','JOSM'),(52744375,1,'created_by','JOSM'),(52744378,1,'created_by','JOSM'),(52744379,1,'created_by','JOSM'),(52744383,1,'created_by','JOSM'),(52744385,1,'created_by','JOSM'),(52744387,1,'created_by','JOSM'),(52744390,1,'created_by','JOSM'),(52744392,1,'created_by','JOSM'),(52744394,1,'created_by','JOSM'),(52744396,1,'created_by','JOSM'),(52744399,1,'created_by','JOSM'),(52744400,1,'created_by','JOSM'),(52744402,1,'created_by','JOSM'),(52744405,1,'created_by','JOSM'),(52744409,1,'created_by','JOSM'),(52744411,1,'created_by','JOSM'),(52744413,1,'created_by','JOSM'),(52744416,1,'created_by','JOSM'),(52744418,1,'created_by','JOSM'),(52744420,1,'created_by','JOSM'),(52744423,1,'created_by','JOSM'),(52744426,1,'created_by','JOSM'),(52744429,1,'created_by','JOSM'),(52744432,1,'created_by','JOSM'),(52744434,1,'created_by','JOSM'),(52744437,1,'created_by','JOSM'),(52744439,1,'created_by','JOSM'),(52744440,1,'created_by','JOSM'),(52744443,1,'created_by','JOSM'),(52744446,1,'created_by','JOSM'),(52744447,1,'created_by','JOSM'),(52744450,1,'created_by','JOSM'),(52744452,2,'created_by','JOSM'),(52744455,2,'created_by','JOSM'),(52744457,2,'created_by','JOSM'),(52744460,2,'created_by','JOSM'),(52744462,2,'created_by','JOSM'),(52744464,2,'created_by','JOSM'),(52744468,1,'created_by','JOSM'),(52744471,1,'created_by','JOSM'),(52744473,1,'created_by','JOSM'),(52744475,1,'created_by','JOSM'),(52747815,1,'created_by','JOSM'),(52747820,1,'created_by','JOSM'),(52747826,1,'created_by','JOSM'),(52747832,1,'created_by','JOSM'),(52747838,1,'created_by','JOSM'),(52747841,1,'created_by','JOSM'),(52747846,1,'created_by','JOSM'),(52747849,1,'created_by','JOSM'),(52747852,1,'created_by','JOSM'),(52747855,1,'created_by','JOSM'),(52747857,1,'created_by','JOSM'),(52747861,1,'created_by','JOSM'),(52747863,1,'created_by','JOSM'),(52747865,1,'created_by','JOSM'),(52747867,1,'created_by','JOSM'),(52747869,1,'created_by','JOSM'),(52747872,1,'created_by','JOSM'),(52747876,1,'created_by','JOSM'),(52747878,1,'created_by','JOSM'),(52747881,1,'created_by','JOSM'),(52747884,1,'created_by','JOSM'),(52747885,1,'created_by','JOSM'),(52747888,1,'created_by','JOSM'),(52747890,1,'created_by','JOSM'),(52747893,1,'created_by','JOSM'),(52747898,1,'created_by','JOSM'),(52747901,1,'created_by','JOSM'),(52748785,1,'created_by','JOSM'),(52748790,1,'created_by','JOSM'),(52748831,1,'created_by','JOSM'),(52748833,1,'created_by','JOSM'),(52748835,1,'created_by','JOSM'),(52748837,1,'created_by','JOSM'),(52749087,1,'created_by','JOSM'),(52749143,1,'created_by','JOSM'),(52749145,1,'created_by','JOSM'),(52749150,1,'created_by','JOSM'),(52749155,1,'created_by','JOSM'),(52749158,1,'created_by','JOSM'),(52749159,1,'created_by','JOSM'),(52749162,1,'created_by','JOSM'),(52749165,1,'created_by','JOSM'),(52749169,1,'created_by','JOSM'),(52749171,1,'created_by','JOSM'),(52749174,1,'created_by','JOSM'),(52749175,1,'created_by','JOSM'),(52749183,1,'created_by','JOSM'),(52749184,1,'created_by','JOSM'),(52749185,1,'created_by','JOSM'),(52749189,1,'created_by','JOSM'),(52749191,1,'created_by','JOSM'),(52749208,1,'created_by','JOSM'),(52749211,1,'created_by','JOSM'),(52749214,1,'created_by','JOSM'),(52749218,1,'created_by','JOSM'),(52749220,1,'created_by','JOSM'),(52749224,1,'created_by','JOSM'),(52749225,1,'created_by','JOSM'),(52749228,1,'created_by','JOSM'),(52749231,1,'created_by','JOSM'),(52749233,1,'created_by','JOSM'),(52749238,1,'created_by','JOSM'),(52749240,1,'created_by','JOSM'),(52749243,1,'created_by','JOSM'),(52749244,1,'created_by','JOSM'),(52749247,1,'created_by','JOSM'),(52749251,1,'created_by','JOSM'),(52749255,1,'created_by','JOSM'),(52749256,1,'created_by','JOSM'),(52749259,1,'created_by','JOSM'),(52749261,1,'created_by','JOSM'),(52749263,1,'created_by','JOSM'),(52749266,1,'created_by','JOSM'),(52749268,1,'created_by','JOSM'),(52749271,1,'created_by','JOSM'),(52749275,1,'created_by','JOSM'),(52749276,1,'created_by','JOSM'),(52749280,1,'created_by','JOSM'),(52749282,1,'created_by','JOSM'),(52749284,1,'created_by','JOSM'),(52749285,1,'created_by','JOSM'),(52749288,1,'created_by','JOSM'),(52749289,1,'created_by','JOSM'),(52749309,1,'created_by','JOSM'),(52749310,1,'created_by','JOSM'),(52749312,1,'created_by','JOSM'),(52749314,1,'created_by','JOSM'),(52749316,1,'created_by','JOSM'),(52749321,1,'created_by','JOSM'),(52749324,1,'created_by','JOSM'),(52749326,1,'created_by','JOSM'),(52749328,1,'created_by','JOSM'),(52749331,1,'created_by','JOSM'),(52749334,1,'created_by','JOSM'),(52749340,1,'created_by','JOSM'),(52749341,1,'created_by','JOSM'),(52749343,1,'created_by','JOSM'),(52749347,1,'created_by','JOSM'),(52749349,1,'created_by','JOSM'),(52749352,1,'created_by','JOSM'),(52749354,1,'created_by','JOSM'),(52749357,1,'created_by','JOSM'),(52749359,1,'created_by','JOSM'),(52749363,1,'created_by','JOSM'),(52749366,1,'created_by','JOSM'),(52749368,1,'created_by','JOSM'),(52749371,1,'created_by','JOSM'),(52749376,1,'created_by','JOSM'),(52749379,1,'created_by','JOSM'),(52749381,1,'created_by','JOSM'),(52749385,1,'created_by','JOSM'),(52749386,1,'created_by','JOSM'),(52749387,1,'created_by','JOSM'),(52749389,1,'created_by','JOSM'),(52749391,1,'created_by','JOSM'),(52749393,1,'created_by','JOSM'),(52749396,1,'created_by','JOSM'),(52749398,1,'created_by','JOSM'),(52749400,1,'created_by','JOSM'),(52749402,1,'created_by','JOSM'),(52749404,1,'created_by','JOSM'),(52749407,1,'created_by','JOSM'),(52749410,1,'created_by','JOSM'),(52749412,1,'created_by','JOSM'),(52749414,1,'created_by','JOSM'),(52749416,1,'created_by','JOSM'),(52749419,1,'created_by','JOSM'),(52749421,1,'created_by','JOSM'),(52749424,1,'created_by','JOSM'),(52749428,1,'created_by','JOSM'),(52749430,1,'created_by','JOSM'),(52749433,1,'created_by','JOSM'),(52749436,1,'created_by','JOSM'),(52749439,1,'created_by','JOSM'),(52749441,1,'created_by','JOSM'),(52749443,1,'created_by','JOSM'),(52749448,1,'created_by','JOSM'),(52749451,1,'created_by','JOSM'),(52749455,1,'created_by','JOSM'),(52749458,1,'created_by','JOSM'),(52749460,1,'created_by','JOSM'),(52749462,1,'created_by','JOSM'),(52749465,1,'created_by','JOSM'),(52749469,1,'created_by','JOSM'),(52749472,1,'created_by','JOSM'),(52749474,1,'created_by','JOSM'),(52749475,1,'created_by','JOSM'),(52749479,1,'created_by','JOSM'),(52749482,1,'created_by','JOSM'),(52749485,1,'created_by','JOSM'),(52749487,1,'created_by','JOSM'),(52749490,1,'created_by','JOSM'),(52749491,1,'created_by','JOSM'),(52749492,1,'created_by','JOSM'),(52749496,1,'created_by','JOSM'),(52749497,1,'created_by','JOSM'),(52749499,1,'created_by','JOSM'),(52749502,1,'created_by','JOSM'),(52749503,1,'created_by','JOSM'),(52749505,1,'created_by','JOSM'),(52749508,1,'created_by','JOSM'),(52749509,1,'created_by','JOSM'),(52749511,1,'created_by','JOSM'),(52749514,1,'created_by','JOSM'),(52749517,1,'created_by','JOSM'),(52769332,1,'created_by','JOSM'),(52769338,1,'created_by','JOSM'),(52769340,1,'created_by','JOSM'),(52769343,1,'created_by','JOSM'),(52769346,1,'created_by','JOSM'),(52769349,1,'created_by','JOSM'),(52769352,1,'created_by','JOSM'),(52769355,1,'created_by','JOSM'),(52769357,1,'created_by','JOSM'),(52769358,1,'created_by','JOSM'),(52769361,1,'created_by','JOSM'),(52769364,1,'created_by','JOSM'),(52769366,1,'created_by','JOSM'),(52769367,1,'created_by','JOSM'),(52769369,1,'created_by','JOSM'),(52769371,1,'created_by','JOSM'),(52769373,1,'created_by','JOSM'),(52769374,1,'created_by','JOSM'),(52769377,1,'created_by','JOSM'),(52769380,1,'created_by','JOSM'),(52769381,1,'created_by','JOSM'),(52769384,1,'created_by','JOSM'),(52769387,1,'created_by','JOSM'),(52769389,1,'created_by','JOSM'),(52769392,1,'created_by','JOSM'),(52769395,1,'created_by','JOSM'),(52769397,1,'created_by','JOSM'),(52769401,1,'created_by','JOSM'),(52769406,1,'created_by','JOSM'),(52769411,1,'created_by','JOSM'),(52769413,1,'created_by','JOSM'),(52769415,1,'created_by','JOSM'),(52769418,1,'created_by','JOSM'),(52769419,1,'created_by','JOSM'),(52769420,1,'created_by','JOSM'),(52769423,1,'created_by','JOSM'),(52769425,1,'created_by','JOSM'),(52769427,1,'created_by','JOSM'),(52769431,1,'created_by','JOSM'),(52769436,1,'created_by','JOSM'),(52769439,1,'created_by','JOSM'),(52769441,1,'created_by','JOSM'),(52769444,1,'created_by','JOSM'),(52769447,1,'created_by','JOSM'),(52769450,1,'created_by','JOSM'),(52769452,1,'created_by','JOSM'),(52769456,1,'created_by','JOSM'),(52769457,1,'created_by','JOSM'),(52769460,1,'created_by','JOSM'),(52769465,1,'created_by','JOSM'),(52769471,1,'created_by','JOSM'),(52769477,1,'created_by','JOSM'),(52769479,1,'created_by','JOSM'),(52769482,1,'created_by','JOSM'),(52769485,1,'created_by','JOSM'),(52769488,1,'created_by','JOSM'),(52769491,1,'created_by','JOSM'),(52769493,1,'created_by','JOSM'),(52792095,2,'created_by','JOSM'),(52792098,2,'created_by','JOSM'),(52792102,2,'created_by','JOSM'),(52792111,2,'created_by','JOSM'),(52792113,2,'created_by','JOSM'),(52792114,2,'created_by','JOSM'),(52792117,2,'created_by','JOSM'),(52792122,2,'created_by','JOSM'),(52792158,1,'created_by','JOSM'),(52792159,1,'created_by','JOSM'),(52792177,1,'created_by','JOSM'),(52792180,1,'created_by','JOSM'),(52792182,1,'created_by','JOSM'),(52792185,1,'created_by','JOSM'),(52792187,1,'created_by','JOSM'),(52792189,1,'created_by','JOSM'),(52792192,1,'created_by','JOSM'),(52792194,1,'created_by','JOSM'),(52792196,1,'created_by','JOSM'),(52792199,1,'created_by','JOSM'),(52792202,1,'created_by','JOSM'),(52792205,1,'created_by','JOSM'),(52792210,1,'created_by','JOSM'),(52796991,1,'created_by','JOSM'),(52797049,1,'created_by','JOSM'),(52797051,1,'created_by','JOSM'),(52797069,1,'created_by','JOSM'),(52797105,1,'created_by','JOSM'),(52797267,1,'created_by','JOSM'),(52797268,1,'created_by','JOSM'),(52797269,1,'created_by','JOSM'),(52797270,1,'created_by','JOSM'),(52797275,1,'created_by','JOSM'),(52797278,1,'created_by','JOSM'),(52797286,1,'created_by','JOSM'),(52797303,1,'created_by','JOSM'),(52797555,1,'created_by','JOSM'),(52798676,1,'created_by','JOSM'),(52799709,1,'created_by','JOSM'),(52799985,1,'created_by','JOSM'),(52800033,1,'created_by','JOSM'),(52800211,1,'created_by','JOSM'),(52800388,1,'created_by','JOSM'),(52800400,1,'created_by','JOSM'),(52800405,1,'created_by','JOSM'),(52800416,1,'created_by','JOSM'),(52800529,1,'created_by','JOSM'),(52800536,1,'created_by','JOSM'),(52800580,1,'created_by','JOSM'),(52800584,1,'created_by','JOSM'),(52800586,1,'created_by','JOSM'),(52800590,1,'created_by','JOSM'),(52800592,1,'created_by','JOSM'),(52800596,1,'created_by','JOSM'),(52800599,1,'created_by','JOSM'),(52800602,1,'created_by','JOSM'),(52800606,1,'created_by','JOSM'),(52800608,1,'created_by','JOSM'),(52800610,1,'created_by','JOSM'),(52800614,1,'created_by','JOSM'),(52800618,1,'created_by','JOSM'),(52800619,1,'created_by','JOSM'),(52800622,1,'created_by','JOSM'),(52800623,1,'created_by','JOSM'),(52800625,1,'created_by','JOSM'),(52800626,1,'created_by','JOSM'),(52800628,1,'created_by','JOSM'),(52800630,1,'created_by','JOSM'),(52800634,1,'created_by','JOSM'),(52800638,1,'created_by','JOSM'),(52800642,1,'created_by','JOSM'),(52800645,1,'created_by','JOSM'),(52800647,1,'created_by','JOSM'),(52800651,1,'created_by','JOSM'),(52800652,1,'created_by','JOSM'),(52800656,1,'created_by','JOSM'),(52800661,1,'created_by','JOSM'),(52800664,1,'created_by','JOSM'),(52800665,1,'created_by','JOSM'),(52800667,1,'created_by','JOSM'),(52800668,1,'created_by','JOSM'),(52800670,1,'created_by','JOSM'),(52800673,1,'created_by','JOSM'),(52800677,1,'created_by','JOSM'),(52800681,1,'created_by','JOSM'),(52800683,1,'created_by','JOSM'),(52800686,1,'created_by','JOSM'),(52800691,1,'created_by','JOSM'),(52800794,1,'created_by','JOSM'),(52800813,1,'created_by','JOSM'),(52800821,1,'created_by','JOSM'),(52800828,1,'created_by','JOSM'),(52800845,1,'created_by','JOSM'),(52800909,1,'created_by','JOSM'),(52800938,1,'created_by','JOSM'),(52800944,1,'created_by','JOSM'),(52800948,1,'created_by','JOSM'),(52800952,1,'created_by','JOSM'),(52800957,1,'created_by','JOSM'),(52800960,1,'created_by','JOSM'),(52800964,1,'created_by','JOSM'),(52800967,1,'created_by','JOSM'),(52800970,1,'created_by','JOSM'),(52800974,1,'created_by','JOSM'),(52800978,1,'created_by','JOSM'),(52800981,1,'created_by','JOSM'),(52800985,1,'created_by','JOSM'),(52800987,1,'created_by','JOSM'),(52800990,1,'created_by','JOSM'),(52800993,1,'created_by','JOSM'),(52800995,1,'created_by','JOSM'),(52800998,1,'created_by','JOSM'),(52801001,1,'created_by','JOSM'),(52801004,1,'created_by','JOSM'),(52801007,1,'created_by','JOSM'),(52801010,1,'created_by','JOSM'),(52801153,1,'created_by','JOSM'),(52801157,1,'created_by','JOSM'),(52801158,1,'created_by','JOSM'),(52801164,1,'created_by','JOSM'),(52801166,1,'created_by','JOSM'),(52801167,1,'created_by','JOSM'),(52801168,1,'created_by','JOSM'),(52801170,1,'created_by','JOSM'),(52801172,1,'created_by','JOSM'),(52801173,1,'created_by','JOSM'),(52801175,1,'created_by','JOSM'),(52801176,1,'created_by','JOSM'),(52801178,1,'created_by','JOSM'),(52801181,1,'created_by','JOSM'),(52801182,1,'created_by','JOSM'),(52801184,1,'created_by','JOSM'),(52801190,1,'created_by','JOSM'),(52801192,1,'created_by','JOSM'),(52801195,1,'created_by','JOSM'),(52801198,1,'created_by','JOSM'),(52801203,1,'created_by','JOSM'),(52801207,1,'created_by','JOSM'),(52801209,1,'created_by','JOSM'),(52801212,1,'created_by','JOSM'),(52801215,1,'created_by','JOSM'),(52801217,1,'created_by','JOSM'),(52801218,1,'created_by','JOSM'),(52801220,1,'created_by','JOSM'),(52801221,1,'created_by','JOSM'),(52801223,1,'created_by','JOSM'),(52801226,1,'created_by','JOSM'),(52801228,1,'created_by','JOSM'),(52801231,1,'created_by','JOSM'),(52801233,1,'created_by','JOSM'),(52801234,1,'created_by','JOSM'),(52801247,1,'created_by','JOSM'),(52801248,1,'created_by','JOSM'),(52801251,1,'created_by','JOSM'),(52801254,1,'created_by','JOSM'),(52801258,1,'created_by','JOSM'),(52801262,1,'created_by','JOSM'),(52801265,1,'created_by','JOSM'),(52801269,1,'created_by','JOSM'),(52801273,1,'created_by','JOSM'),(52801274,1,'created_by','JOSM'),(52801279,1,'created_by','JOSM'),(52801283,1,'created_by','JOSM'),(52801284,1,'created_by','JOSM'),(52801287,1,'created_by','JOSM'),(52801289,1,'created_by','JOSM'),(52801291,1,'created_by','JOSM'),(52801293,1,'created_by','JOSM'),(52801295,1,'created_by','JOSM'),(52801298,1,'created_by','JOSM'),(52801299,1,'created_by','JOSM'),(52801301,1,'created_by','JOSM'),(52801303,1,'created_by','JOSM'),(52801305,1,'created_by','JOSM'),(52801307,1,'created_by','JOSM'),(52801309,1,'created_by','JOSM'),(52801311,1,'created_by','JOSM'),(52801313,1,'created_by','JOSM'),(52801314,1,'created_by','JOSM'),(52801316,1,'created_by','JOSM'),(52801317,1,'created_by','JOSM'),(52801319,1,'created_by','JOSM'),(52801321,1,'created_by','JOSM'),(52801323,1,'created_by','JOSM'),(52801324,1,'created_by','JOSM'),(52801326,1,'created_by','JOSM'),(52801328,1,'created_by','JOSM'),(52801330,1,'created_by','JOSM'),(52801331,1,'created_by','JOSM'),(52801333,1,'created_by','JOSM'),(52801336,1,'created_by','JOSM'),(52801339,1,'created_by','JOSM'),(52801341,1,'created_by','JOSM'),(52801344,1,'created_by','JOSM'),(52801345,1,'created_by','JOSM'),(52801348,1,'created_by','JOSM'),(52801350,1,'created_by','JOSM'),(52801352,1,'created_by','JOSM'),(52801353,1,'created_by','JOSM'),(52801354,1,'created_by','JOSM'),(52801355,1,'created_by','JOSM'),(52801356,1,'created_by','JOSM'),(52801357,1,'created_by','JOSM'),(52801358,1,'created_by','JOSM'),(52801359,1,'created_by','JOSM'),(52801360,1,'created_by','JOSM'),(52801361,1,'created_by','JOSM'),(52801362,1,'created_by','JOSM'),(52801363,1,'created_by','JOSM'),(52801364,1,'created_by','JOSM'),(52801366,1,'created_by','JOSM'),(52801368,1,'created_by','JOSM'),(52801370,1,'created_by','JOSM'),(52801372,1,'created_by','JOSM'),(52801374,1,'created_by','JOSM'),(52801376,1,'created_by','JOSM'),(52801380,1,'created_by','JOSM'),(52801384,1,'created_by','JOSM'),(52801389,1,'created_by','JOSM'),(52801392,1,'created_by','JOSM'),(52801396,1,'created_by','JOSM'),(52801397,1,'created_by','JOSM'),(52801402,1,'created_by','JOSM'),(52801404,1,'created_by','JOSM'),(52801407,1,'created_by','JOSM'),(52801413,1,'created_by','JOSM'),(52801417,1,'created_by','JOSM'),(52801418,1,'created_by','JOSM'),(52801422,1,'created_by','JOSM'),(52801425,1,'created_by','JOSM'),(52801427,1,'created_by','JOSM'),(52801429,1,'created_by','JOSM'),(52801431,1,'created_by','JOSM'),(52801433,1,'created_by','JOSM'),(52801435,1,'created_by','JOSM'),(52801437,1,'created_by','JOSM'),(52801439,1,'created_by','JOSM'),(52801441,1,'created_by','JOSM'),(52801444,1,'created_by','JOSM'),(52801446,1,'created_by','JOSM'),(52801447,1,'created_by','JOSM'),(52801451,1,'created_by','JOSM'),(52801453,1,'created_by','JOSM'),(52801456,1,'created_by','JOSM'),(52801461,1,'created_by','JOSM'),(52801462,1,'created_by','JOSM'),(52801465,1,'created_by','JOSM'),(52801468,1,'created_by','JOSM'),(52801469,1,'created_by','JOSM'),(52801475,1,'created_by','JOSM'),(52801477,1,'created_by','JOSM'),(52801480,1,'created_by','JOSM'),(52801487,1,'created_by','JOSM'),(52801494,1,'created_by','JOSM'),(52801506,1,'created_by','JOSM'),(52801514,1,'created_by','JOSM'),(52801516,1,'created_by','JOSM'),(52801518,1,'created_by','JOSM'),(52801520,1,'created_by','JOSM'),(52801522,1,'created_by','JOSM'),(52801524,1,'created_by','JOSM'),(52801526,1,'created_by','JOSM'),(52801527,1,'created_by','JOSM'),(52801531,1,'created_by','JOSM'),(52801534,1,'created_by','JOSM'),(52801538,1,'created_by','JOSM'),(52801542,1,'created_by','JOSM'),(52801545,1,'created_by','JOSM'),(52801548,1,'created_by','JOSM'),(52801551,1,'created_by','JOSM'),(52801555,1,'created_by','JOSM'),(52801558,1,'created_by','JOSM'),(52801561,1,'created_by','JOSM'),(52801566,1,'created_by','JOSM'),(52801569,1,'created_by','JOSM'),(52801571,1,'created_by','JOSM'),(52801573,1,'created_by','JOSM'),(52801576,1,'created_by','JOSM'),(52801578,1,'created_by','JOSM'),(52801581,1,'created_by','JOSM'),(52801584,1,'created_by','JOSM'),(52801585,1,'created_by','JOSM'),(52801587,1,'created_by','JOSM'),(52801618,1,'created_by','JOSM'),(52801640,1,'created_by','JOSM'),(52801643,1,'created_by','JOSM'),(52801648,1,'created_by','JOSM'),(52801652,1,'created_by','JOSM'),(52801654,1,'created_by','JOSM'),(52801657,1,'created_by','JOSM'),(52801660,1,'created_by','JOSM'),(52801663,1,'created_by','JOSM'),(52801664,1,'created_by','JOSM'),(52801668,1,'created_by','JOSM'),(52801672,1,'created_by','JOSM'),(52801674,1,'created_by','JOSM'),(52801679,1,'created_by','JOSM'),(52801683,1,'created_by','JOSM'),(52801684,1,'created_by','JOSM'),(52801688,1,'created_by','JOSM'),(52801691,1,'created_by','JOSM'),(52801695,1,'created_by','JOSM'),(52801699,1,'created_by','JOSM'),(52801701,1,'created_by','JOSM'),(52801704,1,'created_by','JOSM'),(52801707,1,'created_by','JOSM'),(52801710,1,'created_by','JOSM'),(52801715,1,'created_by','JOSM'),(52801719,1,'created_by','JOSM'),(52801722,1,'created_by','JOSM'),(52801725,1,'created_by','JOSM'),(52801729,1,'created_by','JOSM'),(52801733,1,'created_by','JOSM'),(52801737,1,'created_by','JOSM'),(52801741,1,'created_by','JOSM'),(52801744,1,'created_by','JOSM'),(52801747,1,'created_by','JOSM'),(52801749,1,'created_by','JOSM'),(52801750,1,'created_by','JOSM'),(52801752,1,'created_by','JOSM'),(52801754,1,'created_by','JOSM'),(52801756,1,'created_by','JOSM'),(52801757,1,'created_by','JOSM'),(52801758,1,'created_by','JOSM'),(52801759,1,'created_by','JOSM'),(52801760,1,'created_by','JOSM'),(52801761,1,'created_by','JOSM'),(52801762,1,'created_by','JOSM'),(52801764,1,'created_by','JOSM'),(52801765,1,'created_by','JOSM'),(52801768,1,'created_by','JOSM'),(52801769,1,'created_by','JOSM'),(52801771,1,'created_by','JOSM'),(52801772,1,'created_by','JOSM'),(52801774,1,'created_by','JOSM'),(52801776,1,'created_by','JOSM'),(52801777,1,'created_by','JOSM'),(52801780,1,'created_by','JOSM'),(52801781,1,'created_by','JOSM'),(52801783,1,'created_by','JOSM'),(52801785,1,'created_by','JOSM'),(52801787,1,'created_by','JOSM'),(52801788,1,'created_by','JOSM'),(52801791,1,'created_by','JOSM'),(52801792,1,'created_by','JOSM'),(52801794,1,'created_by','JOSM'),(52801796,2,'created_by','JOSM'),(52801807,2,'created_by','JOSM'),(52801809,1,'created_by','JOSM'),(52801813,1,'created_by','JOSM'),(52801816,1,'created_by','JOSM'),(52801819,1,'created_by','JOSM'),(52801824,1,'created_by','JOSM'),(52801827,1,'created_by','JOSM'),(52801876,1,'created_by','JOSM'),(52802034,1,'created_by','JOSM'),(52802158,1,'created_by','JOSM'),(52802159,1,'created_by','JOSM'),(52802160,1,'created_by','JOSM'),(52802161,1,'created_by','JOSM'),(52802162,1,'created_by','JOSM'),(52802163,1,'created_by','JOSM'),(52802164,1,'created_by','JOSM'),(52802165,1,'created_by','JOSM'),(52802166,1,'created_by','JOSM'),(52802167,1,'created_by','JOSM'),(52802168,1,'created_by','JOSM'),(52802169,1,'created_by','JOSM'),(52802170,1,'created_by','JOSM'),(52802171,1,'created_by','JOSM'),(52802172,1,'created_by','JOSM'),(52802173,1,'created_by','JOSM'),(52802183,1,'created_by','JOSM'),(52802197,1,'created_by','JOSM'),(52802210,1,'created_by','JOSM'),(52802216,1,'created_by','JOSM'),(52802218,1,'created_by','JOSM'),(52802229,1,'created_by','JOSM'),(52802260,1,'created_by','JOSM'),(52803163,1,'created_by','JOSM'),(52803175,1,'created_by','JOSM'),(52803179,1,'created_by','JOSM'),(52803182,1,'created_by','JOSM'),(52803183,1,'created_by','JOSM'),(52803186,1,'created_by','JOSM'),(52803189,1,'created_by','JOSM'),(52803191,1,'created_by','JOSM'),(52803194,1,'created_by','JOSM'),(52803195,1,'created_by','JOSM'),(52803196,1,'created_by','JOSM'),(52803197,1,'created_by','JOSM'),(52803198,1,'created_by','JOSM'),(52803200,1,'created_by','JOSM'),(52803201,1,'created_by','JOSM'),(52803202,1,'created_by','JOSM'),(52803205,1,'created_by','JOSM'),(52803207,1,'created_by','JOSM'),(52803211,1,'created_by','JOSM'),(52803214,1,'created_by','JOSM'),(52803216,1,'created_by','JOSM'),(52803218,1,'created_by','JOSM'),(52803220,1,'created_by','JOSM'),(52803222,1,'created_by','JOSM'),(52803224,1,'created_by','JOSM'),(52803225,1,'created_by','JOSM'),(52803228,1,'created_by','JOSM'),(52803229,1,'created_by','JOSM'),(52803233,1,'created_by','JOSM'),(52803235,1,'created_by','JOSM'),(52803237,1,'created_by','JOSM'),(52803239,1,'created_by','JOSM'),(52803241,1,'created_by','JOSM'),(52803243,1,'created_by','JOSM'),(52803247,1,'created_by','JOSM'),(52803251,1,'created_by','JOSM'),(52803254,1,'created_by','JOSM'),(52803255,1,'created_by','JOSM'),(52803259,1,'created_by','JOSM'),(52803263,1,'created_by','JOSM'),(52803266,1,'created_by','JOSM'),(52803269,1,'created_by','JOSM'),(52803271,1,'created_by','JOSM'),(52803273,1,'created_by','JOSM'),(52803277,1,'created_by','JOSM'),(52803280,1,'created_by','JOSM'),(52803283,1,'created_by','JOSM'),(52803285,1,'created_by','JOSM'),(52803289,1,'created_by','JOSM'),(52803297,1,'created_by','JOSM'),(52803300,1,'created_by','JOSM'),(52803304,1,'created_by','JOSM'),(52803309,1,'created_by','JOSM'),(52803311,1,'created_by','JOSM'),(52803313,1,'created_by','JOSM'),(52803316,1,'created_by','JOSM'),(52803319,1,'created_by','JOSM'),(52803320,1,'created_by','JOSM'),(52803323,1,'created_by','JOSM'),(52803325,1,'created_by','JOSM'),(52803327,1,'created_by','JOSM'),(52803328,1,'created_by','JOSM'),(52803331,1,'created_by','JOSM'),(52803333,1,'created_by','JOSM'),(52803336,1,'created_by','JOSM'),(52803337,1,'created_by','JOSM'),(52803338,1,'created_by','JOSM'),(52803340,1,'created_by','JOSM'),(52803343,1,'created_by','JOSM'),(52803346,1,'created_by','JOSM'),(52803349,1,'created_by','JOSM'),(52803351,1,'created_by','JOSM'),(52803353,1,'created_by','JOSM'),(52803358,1,'created_by','JOSM'),(52803363,1,'created_by','JOSM'),(52803365,1,'created_by','JOSM'),(52803368,1,'created_by','JOSM'),(52803370,1,'created_by','JOSM'),(52803372,1,'created_by','JOSM'),(52803374,1,'created_by','JOSM'),(52803378,1,'created_by','JOSM'),(52803382,1,'created_by','JOSM'),(52803385,1,'created_by','JOSM'),(52803388,1,'created_by','JOSM'),(52803391,1,'created_by','JOSM'),(52803393,1,'created_by','JOSM'),(52803396,1,'created_by','JOSM'),(52803399,1,'created_by','JOSM'),(52803402,1,'created_by','JOSM'),(52803405,1,'created_by','JOSM'),(52803937,1,'created_by','JOSM'),(52803938,1,'created_by','JOSM'),(52803940,1,'created_by','JOSM'),(52803941,1,'created_by','JOSM'),(52803943,1,'created_by','JOSM'),(52803944,1,'created_by','JOSM'),(52803954,1,'created_by','JOSM'),(52803955,1,'created_by','JOSM'),(52803956,1,'created_by','JOSM'),(52803958,1,'created_by','JOSM'),(52803959,1,'created_by','JOSM'),(52803961,1,'created_by','JOSM'),(52803962,1,'created_by','JOSM'),(52803965,1,'created_by','JOSM'),(52803969,1,'created_by','JOSM'),(52803973,1,'created_by','JOSM'),(52803976,1,'created_by','JOSM'),(52803980,1,'created_by','JOSM'),(52803983,1,'created_by','JOSM'),(52803988,1,'created_by','JOSM'),(52803992,1,'created_by','JOSM'),(52803995,1,'created_by','JOSM'),(52803998,1,'created_by','JOSM'),(52804002,1,'created_by','JOSM'),(52804005,1,'created_by','JOSM'),(52804010,1,'created_by','JOSM'),(52804014,1,'created_by','JOSM'),(52804018,1,'created_by','JOSM'),(52804021,1,'created_by','JOSM'),(52804024,1,'created_by','JOSM'),(52804026,1,'created_by','JOSM'),(52804028,1,'created_by','JOSM'),(52804030,1,'created_by','JOSM'),(52804033,1,'created_by','JOSM'),(52804036,1,'created_by','JOSM'),(52804038,1,'created_by','JOSM'),(52804041,1,'created_by','JOSM'),(52804043,1,'created_by','JOSM'),(52804046,1,'created_by','JOSM'),(52804050,1,'created_by','JOSM'),(52804052,1,'created_by','JOSM'),(52804055,1,'created_by','JOSM'),(52804060,1,'created_by','JOSM'),(52804062,1,'created_by','JOSM'),(52804065,1,'created_by','JOSM'),(52804069,1,'created_by','JOSM'),(52804073,1,'created_by','JOSM'),(52804077,1,'created_by','JOSM'),(52804081,1,'created_by','JOSM'),(52804084,1,'created_by','JOSM'),(52804087,1,'created_by','JOSM'),(52804090,1,'created_by','JOSM'),(52804091,1,'created_by','JOSM'),(52804093,1,'created_by','JOSM'),(52804096,1,'created_by','JOSM'),(52804100,1,'created_by','JOSM'),(52804101,1,'created_by','JOSM'),(52804106,1,'created_by','JOSM'),(52804109,1,'created_by','JOSM'),(52804112,1,'created_by','JOSM'),(52804114,1,'created_by','JOSM'),(52804117,1,'created_by','JOSM'),(52804118,1,'created_by','JOSM'),(52804119,1,'created_by','JOSM'),(52804120,1,'created_by','JOSM'),(52804121,1,'created_by','JOSM'),(52804122,1,'created_by','JOSM'),(52804123,1,'created_by','JOSM'),(52804124,1,'created_by','JOSM'),(52804125,1,'created_by','JOSM'),(52804126,1,'created_by','JOSM'),(52804127,1,'created_by','JOSM'),(52804128,1,'created_by','JOSM'),(52804129,1,'created_by','JOSM'),(52804130,1,'created_by','JOSM'),(52804131,1,'created_by','JOSM'),(52804132,1,'created_by','JOSM'),(52804133,1,'created_by','JOSM'),(52804134,1,'created_by','JOSM'),(52804135,1,'created_by','JOSM'),(52804136,1,'created_by','JOSM'),(52804137,1,'created_by','JOSM'),(52804138,1,'created_by','JOSM'),(52804139,1,'created_by','JOSM'),(52804140,1,'created_by','JOSM'),(52804141,1,'created_by','JOSM'),(52804142,1,'created_by','JOSM'),(52804143,1,'created_by','JOSM'),(52804145,1,'created_by','JOSM'),(52804150,1,'created_by','JOSM'),(52804160,1,'created_by','JOSM'),(52804163,1,'created_by','JOSM'),(52804167,1,'created_by','JOSM'),(52804172,1,'created_by','JOSM'),(52804173,1,'created_by','JOSM'),(52804176,1,'created_by','JOSM'),(52804216,1,'created_by','JOSM'),(52804228,1,'created_by','JOSM'),(52804233,1,'created_by','JOSM'),(52804235,1,'created_by','JOSM'),(52804237,1,'created_by','JOSM'),(52804272,1,'created_by','JOSM'),(52804275,1,'created_by','JOSM'),(52804279,1,'created_by','JOSM'),(52804292,1,'created_by','JOSM'),(52804295,1,'created_by','JOSM'),(52804297,1,'created_by','JOSM'),(52804298,1,'created_by','JOSM'),(52804299,1,'created_by','JOSM'),(52804736,1,'created_by','JOSM'),(52804739,1,'created_by','JOSM'),(52804766,1,'created_by','JOSM'),(52804772,1,'created_by','JOSM'),(52804776,1,'created_by','JOSM'),(52804777,1,'created_by','JOSM'),(52804778,1,'created_by','JOSM'),(52804779,1,'created_by','JOSM'),(52804780,1,'created_by','JOSM'),(52804788,1,'created_by','JOSM'),(52804791,1,'created_by','JOSM'),(52804795,1,'created_by','JOSM'),(52804796,1,'created_by','JOSM'),(52804798,1,'created_by','JOSM'),(52804801,1,'created_by','JOSM'),(52804803,1,'created_by','JOSM'),(52804805,1,'created_by','JOSM'),(52804807,1,'created_by','JOSM'),(52804809,1,'created_by','JOSM'),(52804811,1,'created_by','JOSM'),(52804813,1,'created_by','JOSM'),(52804815,1,'created_by','JOSM'),(52812261,1,'created_by','JOSM'),(52812263,1,'created_by','JOSM'),(52812266,1,'created_by','JOSM'),(52812268,1,'created_by','JOSM'),(52812270,1,'created_by','JOSM'),(52812274,1,'created_by','JOSM'),(52812277,1,'created_by','JOSM'),(52812281,1,'created_by','JOSM'),(52812284,1,'created_by','JOSM'),(52812288,1,'created_by','JOSM'),(52812291,1,'created_by','JOSM'),(52812295,1,'created_by','JOSM'),(52812296,1,'created_by','JOSM'),(52812299,1,'created_by','JOSM'),(52812303,1,'created_by','JOSM'),(52812305,1,'created_by','JOSM'),(52812309,1,'created_by','JOSM'),(52812311,1,'created_by','JOSM'),(52812315,1,'created_by','JOSM'),(52812318,1,'created_by','JOSM'),(52812321,1,'created_by','JOSM'),(52812323,1,'created_by','JOSM'),(52812326,1,'created_by','JOSM'),(52812329,1,'created_by','JOSM');
INSERT INTO `node_tags` VALUES (52812331,1,'created_by','JOSM'),(52812333,1,'created_by','JOSM'),(52812335,1,'created_by','JOSM'),(52812338,1,'created_by','JOSM'),(52812341,1,'created_by','JOSM'),(52812343,1,'created_by','JOSM'),(52812347,1,'created_by','JOSM'),(52812350,1,'created_by','JOSM'),(52812353,1,'created_by','JOSM'),(52812356,1,'created_by','JOSM'),(52812360,1,'created_by','JOSM'),(52812363,1,'created_by','JOSM'),(52812365,1,'created_by','JOSM'),(52812366,1,'created_by','JOSM'),(52812367,1,'created_by','JOSM'),(52812369,1,'created_by','JOSM'),(52812372,1,'created_by','JOSM'),(52812376,1,'created_by','JOSM'),(52812379,1,'created_by','JOSM'),(52812380,1,'created_by','JOSM'),(52812383,1,'created_by','JOSM'),(52812385,1,'created_by','JOSM'),(52812387,1,'created_by','JOSM'),(52812389,1,'created_by','JOSM'),(52812391,1,'created_by','JOSM'),(52812395,1,'created_by','JOSM'),(52812397,1,'created_by','JOSM'),(52812399,1,'created_by','JOSM'),(52812403,1,'created_by','JOSM'),(52812405,1,'created_by','JOSM'),(52812406,1,'created_by','JOSM'),(52812407,1,'created_by','JOSM'),(52812409,1,'created_by','JOSM'),(52812410,1,'created_by','JOSM'),(52812411,1,'created_by','JOSM'),(52812413,1,'created_by','JOSM'),(52812414,1,'created_by','JOSM'),(52812415,1,'created_by','JOSM'),(52812417,1,'created_by','JOSM'),(52812418,1,'created_by','JOSM'),(52812421,1,'created_by','JOSM'),(52812425,1,'created_by','JOSM'),(52812428,1,'created_by','JOSM'),(52812440,1,'created_by','JOSM'),(52812444,1,'created_by','JOSM'),(52812447,1,'created_by','JOSM'),(52812450,1,'created_by','JOSM'),(52812453,1,'created_by','JOSM'),(52812457,1,'created_by','JOSM'),(52812460,1,'created_by','JOSM'),(52812464,1,'created_by','JOSM'),(52812468,1,'created_by','JOSM'),(52812472,1,'created_by','JOSM'),(52812475,1,'created_by','JOSM'),(52812478,1,'created_by','JOSM'),(52812481,1,'created_by','JOSM'),(52812485,1,'created_by','JOSM'),(52812487,1,'created_by','JOSM'),(52812491,1,'created_by','JOSM'),(52812494,1,'created_by','JOSM'),(52812497,1,'created_by','JOSM'),(52812501,1,'created_by','JOSM'),(52812505,1,'created_by','JOSM'),(52812507,1,'created_by','JOSM'),(52812511,1,'created_by','JOSM'),(52812514,1,'created_by','JOSM'),(52812517,1,'created_by','JOSM'),(52812520,1,'created_by','JOSM'),(52812522,1,'created_by','JOSM'),(52812526,1,'created_by','JOSM'),(52812530,1,'created_by','JOSM'),(52812531,1,'created_by','JOSM'),(52812534,1,'created_by','JOSM'),(52812536,1,'created_by','JOSM'),(52812537,1,'created_by','JOSM'),(52812540,1,'created_by','JOSM'),(52812541,1,'created_by','JOSM'),(52812543,1,'created_by','JOSM'),(52812545,1,'created_by','JOSM'),(52812547,1,'created_by','JOSM'),(52812549,1,'created_by','JOSM'),(52812551,1,'created_by','JOSM'),(52812553,1,'created_by','JOSM'),(52812555,1,'created_by','JOSM'),(52812558,1,'created_by','JOSM'),(52812562,1,'created_by','JOSM'),(52812564,1,'created_by','JOSM'),(52812566,1,'created_by','JOSM'),(52812569,1,'created_by','JOSM'),(52812572,1,'created_by','JOSM'),(52812574,1,'created_by','JOSM'),(52812577,1,'created_by','JOSM'),(52812580,1,'created_by','JOSM'),(52812582,1,'created_by','JOSM'),(52812585,1,'created_by','JOSM'),(52812587,1,'created_by','JOSM'),(52812590,1,'created_by','JOSM'),(52812592,1,'created_by','JOSM'),(52812595,1,'created_by','JOSM'),(52812597,1,'created_by','JOSM'),(52812598,1,'created_by','JOSM'),(52818308,1,'created_by','JOSM'),(52818311,1,'created_by','JOSM'),(52818312,1,'created_by','JOSM'),(52818315,1,'created_by','JOSM'),(52818317,1,'created_by','JOSM'),(52818320,1,'created_by','JOSM'),(52818322,1,'created_by','JOSM'),(52818324,1,'created_by','JOSM'),(52818326,1,'created_by','JOSM'),(52818330,1,'created_by','JOSM'),(52818332,1,'created_by','JOSM'),(52818334,1,'created_by','JOSM'),(52818337,1,'created_by','JOSM'),(52818340,1,'created_by','JOSM'),(52818343,1,'created_by','JOSM'),(52818346,1,'created_by','JOSM'),(52818348,1,'created_by','JOSM'),(52818350,1,'created_by','JOSM'),(52818352,1,'created_by','JOSM'),(52818355,1,'created_by','JOSM'),(52818358,1,'created_by','JOSM'),(52818362,1,'created_by','JOSM'),(52818365,1,'created_by','JOSM'),(52818368,1,'created_by','JOSM'),(52818370,1,'created_by','JOSM'),(52818373,1,'created_by','JOSM'),(52818377,1,'created_by','JOSM'),(52818379,1,'created_by','JOSM'),(52818382,1,'created_by','JOSM'),(52818384,1,'created_by','JOSM'),(52818385,1,'created_by','JOSM'),(52818387,1,'created_by','JOSM'),(52818389,1,'created_by','JOSM'),(52818390,1,'created_by','JOSM'),(52818391,1,'created_by','JOSM'),(52818392,1,'created_by','JOSM'),(52818393,1,'created_by','JOSM'),(52818394,1,'created_by','JOSM'),(52818396,1,'created_by','JOSM'),(52818397,1,'created_by','JOSM'),(52818398,1,'created_by','JOSM'),(52818399,1,'created_by','JOSM'),(52818402,1,'created_by','JOSM'),(52818404,1,'created_by','JOSM'),(52818405,1,'created_by','JOSM'),(52818406,1,'created_by','JOSM'),(52818407,1,'created_by','JOSM'),(52818409,1,'created_by','JOSM'),(52818413,1,'created_by','JOSM'),(52818415,1,'created_by','JOSM'),(52818417,1,'created_by','JOSM'),(52818420,1,'created_by','JOSM'),(52818424,1,'created_by','JOSM'),(52818427,1,'created_by','JOSM'),(52818428,1,'created_by','JOSM'),(52818432,1,'created_by','JOSM'),(52818434,1,'created_by','JOSM'),(52818437,1,'created_by','JOSM'),(52818440,1,'created_by','JOSM'),(52818441,1,'created_by','JOSM'),(52818445,1,'created_by','JOSM'),(52818446,1,'created_by','JOSM'),(52818448,1,'created_by','JOSM'),(52818450,1,'created_by','JOSM'),(52818451,1,'created_by','JOSM'),(52818452,1,'created_by','JOSM'),(52818453,1,'created_by','JOSM'),(52818454,1,'created_by','JOSM'),(52818455,1,'created_by','JOSM'),(52818456,1,'created_by','JOSM'),(52818457,1,'created_by','JOSM'),(52818458,1,'created_by','JOSM'),(52818461,1,'created_by','JOSM'),(52818463,1,'created_by','JOSM'),(52818465,1,'created_by','JOSM'),(52818470,1,'created_by','JOSM'),(52818472,1,'created_by','JOSM'),(52818475,1,'created_by','JOSM'),(52818478,1,'created_by','JOSM'),(52818479,1,'created_by','JOSM'),(52818483,1,'created_by','JOSM'),(52818485,1,'created_by','JOSM'),(52818487,1,'created_by','JOSM'),(52818489,1,'created_by','JOSM'),(52818490,1,'created_by','JOSM'),(52818491,1,'created_by','JOSM'),(52818493,1,'created_by','JOSM'),(52818495,1,'created_by','JOSM'),(52818498,1,'created_by','JOSM'),(52818501,1,'created_by','JOSM'),(52818503,1,'created_by','JOSM'),(52818505,1,'created_by','JOSM'),(52818508,1,'created_by','JOSM'),(52818511,1,'created_by','JOSM'),(52818514,1,'created_by','JOSM'),(52818516,1,'created_by','JOSM'),(52818518,1,'created_by','JOSM'),(52818520,1,'created_by','JOSM'),(52818522,1,'created_by','JOSM'),(52818524,1,'created_by','JOSM'),(52818527,1,'created_by','JOSM'),(52818529,1,'created_by','JOSM'),(52818533,1,'created_by','JOSM'),(52818536,1,'created_by','JOSM'),(52818538,1,'created_by','JOSM'),(52818539,1,'created_by','JOSM'),(52818542,1,'created_by','JOSM'),(52818550,1,'created_by','JOSM'),(52818553,1,'created_by','JOSM'),(52818555,1,'created_by','JOSM'),(52818557,1,'created_by','JOSM'),(52818561,1,'created_by','JOSM'),(52818563,1,'created_by','JOSM'),(52818564,1,'created_by','JOSM'),(52818566,1,'created_by','JOSM'),(52818567,1,'created_by','JOSM'),(52818569,1,'created_by','JOSM'),(52818572,1,'created_by','JOSM'),(52818574,1,'created_by','JOSM'),(52818577,1,'created_by','JOSM'),(52818581,1,'created_by','JOSM'),(52818582,1,'created_by','JOSM'),(52818585,1,'created_by','JOSM'),(52818587,1,'created_by','JOSM'),(52818590,1,'created_by','JOSM'),(52818592,1,'created_by','JOSM'),(52818594,1,'created_by','JOSM'),(52818598,1,'created_by','JOSM'),(52818600,1,'created_by','JOSM'),(52818603,1,'created_by','JOSM'),(52818605,1,'created_by','JOSM'),(52818609,1,'created_by','JOSM'),(52818612,1,'created_by','JOSM'),(52818615,1,'created_by','JOSM'),(52818618,1,'created_by','JOSM'),(52818620,1,'created_by','JOSM'),(52818622,1,'created_by','JOSM'),(52818623,1,'created_by','JOSM'),(52818627,1,'created_by','JOSM'),(52818629,1,'created_by','JOSM'),(52818631,1,'created_by','JOSM'),(52818633,1,'created_by','JOSM'),(52818635,1,'created_by','JOSM'),(52818636,1,'created_by','JOSM'),(52818639,1,'created_by','JOSM'),(52818641,1,'created_by','JOSM'),(52818642,1,'created_by','JOSM'),(52818644,1,'created_by','JOSM'),(52818647,1,'created_by','JOSM'),(52818648,1,'created_by','JOSM'),(52818651,1,'created_by','JOSM'),(52818652,1,'created_by','JOSM'),(52818655,1,'created_by','JOSM'),(52818657,1,'created_by','JOSM'),(52818659,1,'created_by','JOSM'),(52818661,1,'created_by','JOSM'),(52818663,1,'created_by','JOSM'),(52818669,1,'created_by','JOSM'),(52818671,1,'created_by','JOSM'),(52818673,1,'created_by','JOSM'),(52818675,1,'created_by','JOSM'),(52818677,1,'created_by','JOSM'),(52818679,1,'created_by','JOSM'),(52818681,1,'created_by','JOSM'),(52818685,1,'created_by','JOSM'),(52818687,1,'created_by','JOSM'),(52818690,1,'created_by','JOSM'),(52818692,1,'created_by','JOSM'),(52818694,1,'created_by','JOSM'),(52818720,1,'created_by','JOSM'),(52818722,1,'created_by','JOSM'),(52818724,1,'created_by','JOSM'),(52818727,1,'created_by','JOSM'),(52818729,1,'created_by','JOSM'),(52818731,1,'created_by','JOSM'),(52818733,1,'created_by','JOSM'),(52818747,1,'created_by','JOSM'),(52818757,1,'created_by','JOSM'),(52818771,1,'created_by','JOSM'),(52818775,1,'created_by','JOSM'),(52818781,1,'created_by','JOSM'),(52818791,1,'created_by','JOSM'),(52818794,1,'created_by','JOSM'),(52818796,1,'created_by','JOSM'),(52818800,1,'created_by','JOSM'),(52818803,1,'created_by','JOSM'),(52818808,1,'created_by','JOSM'),(52818809,1,'created_by','JOSM'),(52818810,1,'created_by','JOSM'),(52818812,1,'created_by','JOSM'),(52818813,1,'created_by','JOSM'),(52818824,1,'created_by','JOSM'),(52818840,1,'created_by','JOSM'),(52818846,1,'created_by','JOSM'),(52818850,1,'created_by','JOSM'),(52818853,1,'created_by','JOSM'),(52818857,1,'created_by','JOSM'),(52818862,1,'created_by','JOSM'),(52818864,1,'created_by','JOSM'),(52818867,1,'created_by','JOSM'),(52818870,1,'created_by','JOSM'),(52818872,1,'created_by','JOSM'),(52818874,1,'created_by','JOSM'),(52818876,1,'created_by','JOSM'),(52818878,1,'created_by','JOSM'),(52818879,1,'created_by','JOSM'),(52818881,1,'created_by','JOSM'),(52818884,1,'created_by','JOSM'),(52824397,1,'created_by','JOSM'),(52824401,1,'created_by','JOSM'),(52824404,1,'created_by','JOSM'),(52824407,1,'created_by','JOSM'),(52824410,1,'created_by','JOSM'),(52824414,1,'created_by','JOSM'),(52824418,1,'created_by','JOSM'),(52824420,1,'created_by','JOSM'),(52824423,1,'created_by','JOSM'),(52824433,1,'created_by','JOSM'),(52824446,1,'created_by','JOSM'),(52824449,1,'created_by','JOSM'),(52824464,1,'created_by','JOSM'),(52824474,1,'created_by','JOSM'),(52824478,1,'created_by','JOSM'),(52824483,1,'created_by','JOSM'),(52824486,1,'created_by','JOSM'),(52824489,1,'created_by','JOSM'),(52824491,1,'created_by','JOSM'),(52824494,1,'created_by','JOSM'),(52824496,1,'created_by','JOSM'),(52824499,1,'created_by','JOSM'),(52824502,1,'created_by','JOSM'),(52824509,1,'created_by','JOSM'),(52824529,1,'created_by','JOSM'),(52824530,1,'created_by','JOSM'),(52824533,1,'created_by','JOSM'),(52824535,1,'created_by','JOSM'),(52824538,1,'created_by','JOSM'),(52824541,1,'created_by','JOSM'),(52824544,1,'created_by','JOSM'),(52824546,1,'created_by','JOSM'),(52824548,1,'created_by','JOSM'),(52824552,1,'created_by','JOSM'),(52824553,1,'created_by','JOSM'),(52824558,1,'created_by','JOSM'),(52824561,1,'created_by','JOSM'),(52824564,1,'created_by','JOSM'),(52824567,1,'created_by','JOSM'),(52824569,1,'created_by','JOSM'),(52824574,1,'created_by','JOSM'),(52824576,1,'created_by','JOSM'),(52824579,1,'created_by','JOSM'),(52824581,1,'created_by','JOSM'),(52824584,1,'created_by','JOSM'),(52824586,1,'created_by','JOSM'),(52824949,1,'created_by','JOSM'),(52824952,1,'created_by','JOSM'),(52824953,1,'created_by','JOSM'),(52824954,1,'created_by','JOSM'),(52824955,1,'created_by','JOSM'),(52831541,1,'created_by','JOSM'),(52831545,1,'created_by','JOSM'),(52831548,1,'created_by','JOSM'),(52831550,1,'created_by','JOSM'),(52831552,1,'created_by','JOSM'),(52831554,1,'created_by','JOSM'),(52831559,1,'created_by','JOSM'),(52831563,2,'created_by','JOSM'),(52831566,2,'created_by','JOSM'),(52831569,1,'created_by','JOSM'),(52831574,1,'created_by','JOSM'),(52831577,1,'created_by','JOSM'),(52831582,1,'created_by','JOSM'),(52831585,1,'created_by','JOSM'),(52831588,1,'created_by','JOSM'),(52831590,1,'created_by','JOSM'),(52831593,1,'created_by','JOSM'),(52831595,1,'created_by','JOSM'),(52831598,1,'created_by','JOSM'),(52831601,1,'created_by','JOSM'),(52831603,1,'created_by','JOSM'),(52831605,2,'created_by','JOSM'),(52831608,1,'created_by','JOSM'),(52831611,1,'created_by','JOSM'),(52831613,1,'created_by','JOSM'),(52831614,1,'created_by','JOSM'),(52831615,1,'created_by','JOSM'),(52831616,1,'created_by','JOSM'),(52831617,1,'created_by','JOSM'),(52831618,2,'created_by','JOSM'),(52831619,1,'created_by','JOSM'),(52831621,1,'created_by','JOSM'),(52831641,1,'created_by','JOSM'),(52831644,2,'created_by','JOSM'),(52832041,1,'created_by','JOSM'),(52832042,1,'created_by','JOSM'),(52832043,1,'created_by','JOSM'),(52832044,1,'created_by','JOSM'),(52832045,2,'created_by','JOSM'),(52832046,1,'created_by','JOSM'),(52832047,1,'created_by','JOSM'),(52832471,1,'created_by','JOSM'),(52834371,1,'created_by','JOSM'),(52834531,1,'created_by','JOSM'),(52834678,1,'created_by','JOSM'),(52834735,1,'created_by','JOSM'),(52834737,1,'created_by','JOSM'),(52834749,1,'created_by','JOSM'),(52834758,1,'created_by','JOSM'),(52834763,1,'created_by','JOSM'),(52834768,1,'created_by','JOSM'),(52834775,1,'created_by','JOSM'),(52834778,1,'created_by','JOSM'),(52834779,1,'created_by','JOSM'),(52834783,1,'created_by','JOSM'),(52834784,1,'created_by','JOSM'),(52834785,1,'created_by','JOSM'),(52834786,1,'created_by','JOSM'),(52834787,1,'created_by','JOSM'),(52834788,1,'created_by','JOSM'),(52834790,1,'created_by','JOSM'),(52834792,1,'created_by','JOSM'),(52834794,1,'created_by','JOSM'),(52834795,1,'created_by','JOSM'),(52834797,1,'created_by','JOSM'),(52834799,1,'created_by','JOSM'),(52834802,1,'created_by','JOSM'),(52834805,1,'created_by','JOSM'),(52834808,1,'created_by','JOSM'),(52834811,1,'created_by','JOSM'),(52834813,1,'created_by','JOSM'),(52834816,1,'created_by','JOSM'),(52834819,1,'created_by','JOSM'),(52834822,1,'created_by','JOSM'),(52834825,1,'created_by','JOSM'),(52835977,1,'created_by','JOSM'),(52835980,1,'created_by','JOSM'),(52835984,1,'created_by','JOSM'),(52835987,1,'created_by','JOSM'),(52836001,1,'created_by','JOSM'),(52836004,1,'created_by','JOSM'),(52836007,1,'created_by','JOSM'),(52836010,1,'created_by','JOSM'),(52836012,1,'created_by','JOSM'),(52836016,1,'created_by','JOSM'),(52836020,1,'created_by','JOSM'),(52836023,1,'created_by','JOSM'),(52836027,1,'created_by','JOSM'),(52836030,1,'created_by','JOSM'),(52836034,1,'created_by','JOSM'),(52836036,1,'created_by','JOSM'),(52836038,1,'created_by','JOSM'),(52836042,1,'created_by','JOSM'),(52836044,1,'created_by','JOSM'),(52836048,1,'created_by','JOSM'),(52836052,1,'created_by','JOSM'),(52836056,1,'created_by','JOSM'),(52836058,1,'created_by','JOSM'),(52836061,1,'created_by','JOSM'),(52836065,1,'created_by','JOSM'),(52836069,1,'created_by','JOSM'),(52836073,1,'created_by','JOSM'),(53273667,1,'created_by','JOSM'),(53273668,1,'created_by','JOSM'),(53273669,1,'created_by','JOSM'),(53273670,1,'created_by','JOSM'),(53273671,1,'created_by','JOSM'),(53273672,1,'created_by','JOSM'),(53273673,1,'created_by','JOSM'),(53273674,1,'created_by','JOSM'),(53273675,1,'created_by','JOSM'),(53273676,1,'created_by','JOSM'),(53273677,1,'created_by','JOSM'),(53273678,1,'created_by','JOSM'),(53273679,1,'created_by','JOSM'),(53273680,1,'created_by','JOSM'),(53273681,1,'created_by','JOSM'),(53273682,1,'created_by','JOSM'),(53273683,1,'created_by','JOSM'),(53273684,1,'created_by','JOSM'),(53273685,1,'created_by','JOSM'),(53273686,1,'created_by','JOSM'),(53273687,1,'created_by','JOSM'),(53273688,1,'created_by','JOSM'),(53273689,1,'created_by','JOSM'),(53273690,1,'created_by','JOSM'),(53273691,1,'created_by','JOSM'),(53273692,1,'created_by','JOSM'),(53273693,1,'created_by','JOSM'),(53273694,1,'created_by','JOSM'),(53273695,1,'created_by','JOSM'),(53273696,1,'created_by','JOSM'),(53273697,1,'created_by','JOSM'),(53273698,1,'created_by','JOSM'),(53273699,1,'created_by','JOSM'),(53273700,1,'created_by','JOSM'),(53273701,1,'created_by','JOSM'),(53273702,1,'created_by','JOSM'),(53273703,1,'created_by','JOSM'),(53273704,1,'created_by','JOSM'),(53273705,1,'created_by','JOSM'),(53273706,1,'created_by','JOSM'),(53273707,1,'created_by','JOSM'),(53273708,1,'created_by','JOSM'),(53273709,1,'created_by','JOSM'),(53273710,1,'created_by','JOSM'),(53273711,1,'created_by','JOSM'),(53273712,1,'created_by','JOSM'),(53273713,1,'created_by','JOSM'),(53273714,1,'created_by','JOSM'),(53273715,1,'created_by','JOSM'),(53273716,1,'created_by','JOSM'),(53273719,1,'created_by','JOSM'),(53273723,1,'created_by','JOSM'),(53273724,1,'created_by','JOSM'),(53273725,1,'created_by','JOSM'),(53273726,1,'created_by','JOSM'),(53273727,1,'created_by','JOSM'),(53273728,1,'created_by','JOSM'),(53273729,1,'created_by','JOSM'),(53273730,1,'created_by','JOSM'),(53273731,1,'created_by','JOSM'),(53273732,1,'created_by','JOSM'),(53273733,1,'created_by','JOSM'),(53273734,1,'created_by','JOSM'),(53273735,1,'created_by','JOSM'),(53273736,1,'created_by','JOSM'),(53273737,1,'created_by','JOSM'),(53273738,1,'created_by','JOSM'),(53273739,1,'created_by','JOSM'),(53273740,1,'created_by','JOSM'),(53273741,1,'created_by','JOSM'),(53273742,1,'created_by','JOSM'),(53273743,1,'created_by','JOSM'),(53273744,1,'created_by','JOSM'),(53273745,1,'created_by','JOSM'),(53273746,1,'created_by','JOSM'),(53273747,1,'created_by','JOSM'),(53273748,1,'created_by','JOSM'),(53273749,1,'created_by','JOSM'),(53273750,1,'created_by','JOSM'),(53273751,1,'created_by','JOSM'),(53273752,1,'created_by','JOSM'),(53273753,1,'created_by','JOSM'),(53273754,1,'created_by','JOSM'),(53273755,1,'created_by','JOSM'),(53273756,1,'created_by','JOSM'),(53273757,1,'created_by','JOSM'),(53273758,1,'created_by','JOSM'),(53273759,1,'created_by','JOSM'),(53273760,1,'created_by','JOSM'),(53273761,1,'created_by','JOSM'),(53273762,1,'created_by','JOSM'),(53273763,1,'created_by','JOSM'),(53273764,1,'created_by','JOSM'),(53273765,1,'created_by','JOSM'),(53273766,1,'created_by','JOSM'),(53273767,1,'created_by','JOSM'),(53273768,1,'created_by','JOSM'),(53273769,1,'created_by','JOSM'),(53273770,1,'created_by','JOSM'),(53273771,1,'created_by','JOSM'),(53273772,1,'created_by','JOSM'),(53273773,1,'created_by','JOSM'),(53273774,1,'created_by','JOSM'),(53273775,1,'created_by','JOSM'),(53273776,1,'created_by','JOSM'),(53273777,1,'created_by','JOSM'),(53273778,1,'created_by','JOSM'),(53273779,1,'created_by','JOSM'),(53273780,1,'created_by','JOSM'),(53273781,1,'created_by','JOSM'),(53273782,1,'created_by','JOSM'),(53273783,1,'created_by','JOSM'),(53273784,1,'created_by','JOSM'),(53273785,1,'created_by','JOSM'),(53273786,1,'created_by','JOSM'),(53273787,1,'created_by','JOSM'),(53273788,1,'created_by','JOSM'),(53273789,1,'created_by','JOSM'),(53273790,1,'created_by','JOSM'),(53273791,1,'created_by','JOSM'),(53273792,1,'created_by','JOSM'),(53273793,1,'created_by','JOSM'),(53273794,1,'created_by','JOSM'),(53273795,1,'created_by','JOSM'),(53273796,1,'created_by','JOSM'),(53273797,1,'created_by','JOSM'),(53273798,1,'created_by','JOSM'),(53273799,1,'created_by','JOSM'),(53273800,1,'created_by','JOSM'),(53273801,1,'created_by','JOSM'),(53273802,1,'created_by','JOSM'),(53273803,1,'created_by','JOSM'),(53273804,1,'created_by','JOSM'),(53273805,1,'created_by','JOSM'),(53273806,1,'created_by','JOSM'),(53273807,1,'created_by','JOSM'),(53273808,1,'created_by','JOSM'),(53273810,1,'created_by','JOSM'),(53273811,1,'created_by','JOSM'),(53273812,1,'created_by','JOSM'),(53273813,1,'created_by','JOSM'),(53273814,1,'created_by','JOSM'),(53273815,1,'created_by','JOSM'),(53273816,1,'created_by','JOSM'),(53273817,1,'created_by','JOSM'),(53273818,1,'created_by','JOSM'),(53273819,1,'created_by','JOSM'),(53273820,1,'created_by','JOSM'),(53273821,1,'created_by','JOSM'),(53273822,1,'created_by','JOSM'),(53273823,1,'created_by','JOSM'),(53273824,1,'created_by','JOSM'),(53273825,1,'created_by','JOSM'),(53273826,1,'created_by','JOSM'),(53273827,1,'created_by','JOSM'),(53273828,1,'created_by','JOSM'),(53273829,1,'created_by','JOSM'),(53273830,1,'created_by','JOSM'),(53273831,1,'created_by','JOSM'),(53273832,1,'created_by','JOSM'),(53273833,1,'created_by','JOSM'),(53273834,2,'created_by','JOSM'),(53273836,1,'created_by','JOSM'),(53273838,1,'created_by','JOSM'),(53273839,1,'created_by','JOSM'),(53273841,1,'created_by','JOSM'),(53273843,1,'created_by','JOSM'),(53273844,1,'created_by','JOSM'),(53273846,1,'created_by','JOSM'),(53273848,1,'created_by','JOSM'),(53273849,1,'created_by','JOSM'),(53273851,1,'created_by','JOSM'),(53273852,1,'created_by','JOSM'),(53273853,1,'created_by','JOSM'),(53273854,1,'created_by','JOSM'),(53273855,1,'created_by','JOSM'),(53273856,1,'created_by','JOSM'),(53273857,1,'created_by','JOSM'),(53273858,1,'created_by','JOSM'),(53273859,1,'created_by','JOSM'),(53273860,1,'created_by','JOSM'),(53273861,1,'created_by','JOSM'),(53273862,1,'created_by','JOSM'),(53273863,1,'created_by','JOSM'),(53273864,1,'created_by','JOSM'),(53273865,1,'created_by','JOSM'),(53273866,1,'created_by','JOSM'),(53273867,1,'created_by','JOSM'),(53273868,1,'created_by','JOSM'),(53273869,1,'created_by','JOSM'),(53273870,1,'created_by','JOSM'),(53273871,1,'created_by','JOSM'),(53273872,1,'created_by','JOSM'),(53273873,1,'created_by','JOSM'),(53273874,1,'created_by','JOSM'),(53273875,1,'created_by','JOSM'),(53273876,1,'created_by','JOSM'),(53273877,1,'created_by','JOSM'),(53273878,1,'created_by','JOSM'),(53273879,1,'created_by','JOSM'),(53273880,1,'created_by','JOSM'),(53273881,1,'created_by','JOSM'),(53273882,1,'created_by','JOSM'),(53273883,1,'created_by','JOSM'),(53273884,1,'created_by','JOSM'),(53273885,1,'created_by','JOSM'),(53273886,1,'created_by','JOSM'),(53273887,1,'created_by','JOSM'),(53273888,1,'created_by','JOSM'),(53273889,1,'created_by','JOSM'),(53273890,1,'created_by','JOSM'),(53273891,1,'created_by','JOSM'),(53273892,1,'created_by','JOSM'),(53273893,1,'created_by','JOSM'),(53273894,1,'created_by','JOSM'),(53273895,1,'created_by','JOSM'),(53273896,1,'created_by','JOSM'),(53273897,1,'created_by','JOSM'),(53273898,1,'created_by','JOSM'),(53273899,1,'created_by','JOSM'),(53273900,1,'created_by','JOSM'),(53273901,1,'created_by','JOSM'),(53273902,1,'created_by','JOSM'),(53273903,1,'created_by','JOSM'),(53273904,1,'created_by','JOSM'),(53273905,1,'created_by','JOSM'),(53273906,1,'created_by','JOSM'),(53273907,1,'created_by','JOSM'),(53273908,1,'created_by','JOSM'),(53273909,1,'created_by','JOSM'),(53273910,1,'created_by','JOSM'),(53273911,1,'created_by','JOSM'),(53273912,1,'created_by','JOSM'),(53273913,1,'created_by','JOSM'),(53273914,1,'created_by','JOSM'),(53273915,1,'created_by','JOSM'),(53273916,1,'created_by','JOSM'),(53273917,1,'created_by','JOSM'),(53273918,1,'created_by','JOSM'),(53273919,1,'created_by','JOSM'),(53273920,1,'created_by','JOSM'),(53273921,1,'created_by','JOSM'),(53273922,1,'created_by','JOSM'),(53273923,1,'created_by','JOSM'),(53273924,1,'created_by','JOSM'),(53273925,1,'created_by','JOSM'),(53273926,1,'created_by','JOSM'),(53273927,1,'created_by','JOSM'),(53273928,1,'created_by','JOSM'),(53273929,1,'created_by','JOSM'),(53273930,1,'created_by','JOSM'),(53273931,1,'created_by','JOSM'),(53273932,1,'created_by','JOSM'),(53273933,1,'created_by','JOSM'),(53273934,1,'created_by','JOSM'),(53273935,1,'created_by','JOSM'),(53273936,1,'created_by','JOSM'),(53273937,1,'created_by','JOSM'),(53273938,1,'created_by','JOSM'),(53273939,1,'created_by','JOSM'),(53273940,1,'created_by','JOSM'),(53273941,1,'created_by','JOSM'),(53273942,1,'created_by','JOSM'),(53273943,1,'created_by','JOSM'),(53273944,1,'created_by','JOSM'),(53273945,1,'created_by','JOSM'),(53273946,1,'created_by','JOSM'),(53273947,1,'created_by','JOSM'),(53273948,1,'created_by','JOSM'),(53273949,1,'created_by','JOSM'),(53273950,1,'created_by','JOSM'),(53273951,1,'created_by','JOSM'),(53273952,1,'created_by','JOSM'),(53273953,1,'created_by','JOSM'),(53273954,1,'created_by','JOSM'),(53273955,1,'created_by','JOSM'),(53273956,1,'created_by','JOSM'),(53273957,1,'created_by','JOSM'),(53273958,1,'created_by','JOSM'),(53273959,1,'created_by','JOSM'),(53273960,1,'created_by','JOSM'),(53273961,1,'created_by','JOSM'),(53273962,1,'created_by','JOSM'),(53273963,1,'created_by','JOSM'),(53273964,1,'created_by','JOSM'),(53273965,1,'created_by','JOSM'),(53273966,1,'created_by','JOSM'),(53273967,1,'created_by','JOSM'),(53273968,1,'created_by','JOSM'),(53273969,1,'created_by','JOSM'),(53273970,1,'created_by','JOSM'),(53273971,1,'created_by','JOSM'),(53273972,1,'created_by','JOSM'),(53273973,1,'created_by','JOSM'),(53273974,1,'created_by','JOSM'),(53273975,1,'created_by','JOSM'),(53273976,1,'created_by','JOSM'),(53273977,1,'created_by','JOSM'),(53273978,1,'created_by','JOSM'),(53273979,1,'created_by','JOSM'),(53273980,1,'created_by','JOSM'),(53273981,1,'created_by','JOSM'),(53273982,1,'created_by','JOSM'),(53273983,1,'created_by','JOSM'),(53273984,1,'created_by','JOSM'),(53273985,1,'created_by','JOSM'),(53273986,1,'created_by','JOSM'),(53273987,1,'created_by','JOSM'),(53273988,1,'created_by','JOSM'),(53273989,1,'created_by','JOSM'),(53273990,1,'created_by','JOSM'),(53273991,1,'created_by','JOSM'),(53273992,1,'created_by','JOSM'),(53273993,1,'created_by','JOSM'),(53273994,1,'created_by','JOSM'),(53273995,1,'created_by','JOSM'),(53273996,1,'created_by','JOSM'),(53273997,1,'created_by','JOSM'),(53273998,1,'created_by','JOSM'),(53274000,1,'created_by','JOSM'),(53274002,1,'created_by','JOSM'),(53274003,1,'created_by','JOSM'),(53274004,1,'created_by','JOSM'),(53274005,1,'created_by','JOSM'),(53274006,1,'created_by','JOSM'),(53274007,1,'created_by','JOSM'),(53274008,1,'created_by','JOSM'),(53274009,1,'created_by','JOSM'),(53274010,1,'created_by','JOSM'),(53274011,1,'created_by','JOSM'),(53274012,1,'created_by','JOSM'),(53274013,1,'created_by','JOSM'),(53274014,1,'created_by','JOSM'),(53274015,1,'created_by','JOSM'),(53274016,3,'created_by','JOSM'),(53274017,3,'created_by','JOSM'),(53274018,3,'created_by','JOSM'),(53274019,3,'created_by','JOSM'),(53274020,3,'created_by','JOSM'),(53274021,2,'created_by','JOSM'),(53274022,2,'created_by','JOSM'),(53274023,1,'created_by','JOSM'),(53274024,1,'created_by','JOSM'),(53274025,1,'created_by','JOSM'),(53274026,1,'created_by','JOSM'),(53274027,1,'created_by','JOSM'),(53274028,1,'created_by','JOSM'),(53274029,1,'created_by','JOSM'),(53274030,1,'created_by','JOSM'),(53274031,1,'created_by','JOSM'),(53274883,1,'created_by','JOSM'),(53274884,1,'created_by','JOSM'),(53274885,1,'created_by','JOSM'),(53274886,1,'created_by','JOSM'),(53274888,2,'created_by','JOSM'),(53274890,1,'created_by','JOSM'),(53274891,1,'created_by','JOSM'),(53274892,1,'created_by','JOSM'),(53274893,1,'created_by','JOSM'),(53274894,1,'created_by','JOSM'),(53274895,1,'created_by','JOSM'),(53274896,1,'created_by','JOSM'),(53274898,1,'created_by','JOSM'),(53274899,1,'created_by','JOSM'),(53274900,1,'created_by','JOSM'),(53274901,1,'created_by','JOSM'),(53274902,1,'created_by','JOSM'),(53274903,1,'created_by','JOSM'),(53274904,1,'created_by','JOSM'),(53274906,1,'created_by','JOSM'),(53274907,1,'created_by','JOSM'),(53274908,1,'created_by','JOSM'),(53274909,1,'created_by','JOSM'),(53274910,1,'created_by','JOSM'),(53274911,1,'created_by','JOSM'),(53274912,1,'created_by','JOSM'),(53274913,1,'created_by','JOSM'),(53274915,1,'created_by','JOSM'),(53274916,1,'created_by','JOSM'),(53274917,1,'created_by','JOSM'),(53274918,1,'created_by','JOSM'),(53274919,1,'created_by','JOSM'),(53274920,1,'created_by','JOSM'),(53274921,1,'created_by','JOSM'),(53274922,1,'created_by','JOSM'),(53274924,1,'created_by','JOSM'),(53274925,1,'created_by','JOSM'),(53274926,1,'created_by','JOSM'),(53274927,1,'created_by','JOSM'),(53274928,1,'created_by','JOSM'),(53274929,1,'created_by','JOSM'),(53274931,1,'created_by','JOSM'),(53274932,1,'created_by','JOSM'),(53274933,1,'created_by','JOSM'),(53274934,1,'created_by','JOSM'),(53274935,1,'created_by','JOSM'),(53274936,1,'created_by','JOSM'),(53274937,1,'created_by','JOSM'),(53274939,1,'created_by','JOSM'),(53274940,1,'created_by','JOSM'),(53274941,1,'created_by','JOSM'),(53274942,1,'created_by','JOSM'),(53274943,1,'created_by','JOSM'),(53274944,1,'created_by','JOSM'),(53274946,1,'created_by','JOSM'),(53274947,1,'created_by','JOSM'),(53274948,1,'created_by','JOSM'),(53274949,1,'created_by','JOSM'),(53274950,1,'created_by','JOSM'),(53274951,1,'created_by','JOSM'),(53274952,1,'created_by','JOSM'),(53274954,1,'created_by','JOSM'),(53274955,1,'created_by','JOSM'),(53274956,1,'created_by','JOSM'),(53274957,1,'created_by','JOSM'),(53274958,1,'created_by','JOSM'),(53274959,1,'created_by','JOSM'),(53274960,1,'created_by','JOSM'),(53274961,1,'created_by','JOSM'),(53274963,1,'created_by','JOSM'),(53274964,1,'created_by','JOSM'),(53274965,1,'created_by','JOSM'),(53274966,1,'created_by','JOSM'),(53274967,1,'created_by','JOSM'),(53274972,1,'created_by','JOSM'),(53274973,1,'created_by','JOSM'),(53274974,1,'created_by','JOSM'),(53274976,1,'created_by','JOSM'),(53274977,1,'created_by','JOSM'),(53274978,1,'created_by','JOSM'),(53274979,1,'created_by','JOSM'),(53274980,1,'created_by','JOSM'),(53274981,1,'created_by','JOSM'),(53274983,1,'created_by','JOSM'),(53274984,1,'created_by','JOSM'),(53274985,1,'created_by','JOSM'),(53274986,1,'created_by','JOSM'),(53274987,1,'created_by','JOSM'),(53274988,1,'created_by','JOSM'),(53274989,1,'created_by','JOSM'),(53274990,1,'created_by','JOSM'),(53274991,1,'created_by','JOSM'),(53274992,1,'created_by','JOSM'),(53274993,1,'created_by','JOSM'),(53274995,1,'created_by','JOSM'),(53274996,1,'created_by','JOSM'),(53274997,1,'created_by','JOSM'),(53274998,1,'created_by','JOSM'),(53274999,1,'created_by','JOSM'),(53275001,1,'created_by','JOSM'),(53275002,1,'created_by','JOSM'),(53275003,1,'created_by','JOSM'),(53275004,1,'created_by','JOSM'),(53275005,1,'created_by','JOSM'),(53275006,1,'created_by','JOSM'),(53275008,1,'created_by','JOSM'),(53275009,1,'created_by','JOSM'),(53275010,1,'created_by','JOSM'),(53275011,1,'created_by','JOSM'),(53275012,1,'created_by','JOSM'),(53275014,1,'created_by','JOSM'),(53275015,1,'created_by','JOSM'),(53275016,1,'created_by','JOSM'),(53275017,1,'created_by','JOSM'),(53275018,1,'created_by','JOSM'),(53275019,1,'created_by','JOSM'),(53275020,1,'created_by','JOSM'),(53275022,1,'created_by','JOSM'),(53275023,1,'created_by','JOSM'),(53275024,1,'created_by','JOSM'),(53275034,1,'created_by','JOSM'),(53275035,1,'created_by','JOSM'),(53275036,1,'created_by','JOSM'),(53275038,1,'created_by','JOSM'),(53275039,1,'created_by','JOSM'),(53275040,1,'created_by','JOSM'),(53275506,1,'created_by','JOSM'),(53275507,1,'created_by','JOSM'),(53275508,1,'created_by','JOSM'),(53275510,1,'created_by','JOSM'),(53275511,1,'created_by','JOSM'),(53275512,1,'created_by','JOSM'),(53275514,1,'created_by','JOSM'),(53275515,1,'created_by','JOSM'),(53275516,1,'created_by','JOSM'),(53275517,1,'created_by','JOSM'),(53275518,1,'created_by','JOSM'),(53275519,1,'created_by','JOSM'),(53275520,1,'created_by','JOSM'),(53275521,1,'created_by','JOSM'),(53275522,1,'created_by','JOSM'),(53275523,1,'created_by','JOSM'),(53275524,1,'created_by','JOSM'),(53275525,1,'created_by','JOSM'),(53275526,1,'created_by','JOSM'),(53275527,1,'created_by','JOSM'),(53275528,1,'created_by','JOSM'),(53275529,1,'created_by','JOSM'),(53275530,1,'created_by','JOSM'),(53275531,1,'created_by','JOSM'),(53275533,1,'created_by','JOSM'),(53275534,1,'created_by','JOSM'),(53275535,1,'created_by','JOSM'),(53275536,1,'created_by','JOSM'),(53275537,1,'created_by','JOSM'),(53275538,1,'created_by','JOSM'),(53275539,1,'created_by','JOSM'),(53275540,1,'created_by','JOSM'),(53275541,1,'created_by','JOSM'),(53275542,1,'created_by','JOSM'),(53275543,1,'created_by','JOSM'),(53275544,1,'created_by','JOSM'),(53275545,1,'created_by','JOSM'),(53275546,1,'created_by','JOSM'),(53275547,1,'created_by','JOSM'),(53275548,1,'created_by','JOSM'),(53275549,1,'created_by','JOSM'),(53275550,1,'created_by','JOSM'),(53275551,1,'created_by','JOSM'),(53275552,1,'created_by','JOSM'),(53275554,1,'created_by','JOSM'),(53275555,1,'created_by','JOSM'),(53275556,1,'created_by','JOSM'),(53275557,1,'created_by','JOSM'),(53275558,1,'created_by','JOSM'),(53275559,1,'created_by','JOSM'),(53275560,1,'created_by','JOSM'),(53275561,1,'created_by','JOSM'),(53275562,1,'created_by','JOSM'),(53275563,1,'created_by','JOSM'),(53275565,1,'created_by','JOSM'),(53275567,1,'created_by','JOSM'),(53275568,1,'created_by','JOSM'),(53275569,1,'created_by','JOSM'),(53275570,1,'created_by','JOSM'),(53275572,1,'created_by','JOSM'),(53275573,1,'created_by','JOSM'),(53275574,1,'created_by','JOSM'),(53275575,1,'created_by','JOSM'),(53275576,1,'created_by','JOSM'),(53275577,1,'created_by','JOSM'),(53275578,1,'created_by','JOSM'),(53275579,1,'created_by','JOSM'),(53275580,1,'created_by','JOSM'),(53275581,1,'created_by','JOSM'),(53275582,1,'created_by','JOSM'),(53275583,1,'created_by','JOSM'),(53275584,1,'created_by','JOSM'),(53275585,1,'created_by','JOSM'),(53275586,1,'created_by','JOSM'),(53275587,1,'created_by','JOSM'),(53275588,1,'created_by','JOSM'),(53275589,1,'created_by','JOSM'),(53275590,1,'created_by','JOSM'),(53275591,1,'created_by','JOSM'),(53275592,1,'created_by','JOSM'),(53275593,1,'created_by','JOSM'),(53275594,1,'created_by','JOSM'),(53275595,1,'created_by','JOSM'),(53275596,1,'created_by','JOSM'),(53275597,1,'created_by','JOSM'),(53275598,1,'created_by','JOSM'),(53275599,1,'created_by','JOSM'),(53275600,1,'created_by','JOSM'),(53275601,1,'created_by','JOSM'),(53275602,1,'created_by','JOSM'),(53275603,1,'created_by','JOSM'),(53275604,1,'created_by','JOSM'),(53275605,1,'created_by','JOSM'),(53275606,1,'created_by','JOSM'),(53275607,1,'created_by','JOSM'),(53275608,1,'created_by','JOSM'),(53275609,1,'created_by','JOSM'),(53275610,1,'created_by','JOSM'),(53275611,1,'created_by','JOSM'),(53275612,1,'created_by','JOSM'),(53275613,1,'created_by','JOSM'),(53275614,1,'created_by','JOSM'),(53275615,1,'created_by','JOSM'),(53275616,1,'created_by','JOSM'),(53275617,1,'created_by','JOSM'),(53275618,1,'created_by','JOSM'),(53275619,1,'created_by','JOSM'),(53275620,1,'created_by','JOSM'),(53275621,1,'created_by','JOSM'),(53275622,1,'created_by','JOSM'),(53275623,1,'created_by','JOSM'),(53275624,1,'created_by','JOSM'),(53275625,1,'created_by','JOSM'),(53275626,1,'created_by','JOSM'),(53275627,1,'created_by','JOSM'),(53275628,1,'created_by','JOSM'),(53275629,1,'created_by','JOSM'),(53275630,1,'created_by','JOSM'),(53275631,1,'created_by','JOSM'),(53275632,1,'created_by','JOSM'),(53275633,1,'created_by','JOSM'),(53275634,1,'created_by','JOSM'),(53275635,1,'created_by','JOSM'),(53275636,1,'created_by','JOSM'),(53275637,1,'created_by','JOSM'),(53275638,1,'created_by','JOSM'),(53275639,1,'created_by','JOSM'),(53275640,1,'created_by','JOSM'),(53275642,1,'created_by','JOSM'),(53275643,1,'created_by','JOSM'),(53275644,1,'created_by','JOSM'),(53275645,1,'created_by','JOSM'),(53275646,1,'created_by','JOSM'),(53275647,1,'created_by','JOSM'),(53275648,1,'created_by','JOSM'),(53275649,1,'created_by','JOSM'),(53275650,1,'created_by','JOSM'),(53275651,1,'created_by','JOSM'),(53275652,1,'created_by','JOSM'),(53275653,1,'created_by','JOSM'),(53275654,1,'created_by','JOSM'),(53275655,1,'created_by','JOSM'),(53275656,1,'created_by','JOSM'),(53275657,1,'created_by','JOSM'),(53275658,1,'created_by','JOSM'),(53275659,1,'created_by','JOSM'),(53275660,1,'created_by','JOSM'),(53275661,1,'created_by','JOSM'),(53275662,1,'created_by','JOSM'),(53275663,1,'created_by','JOSM'),(53275664,1,'created_by','JOSM'),(53275665,1,'created_by','JOSM'),(53275666,1,'created_by','JOSM'),(53275667,1,'created_by','JOSM'),(53275668,1,'created_by','JOSM'),(53275669,1,'created_by','JOSM'),(53275670,1,'created_by','JOSM'),(53277160,1,'created_by','JOSM'),(53277161,1,'created_by','JOSM'),(53277162,1,'created_by','JOSM'),(53277163,1,'created_by','JOSM'),(53277164,1,'created_by','JOSM'),(53277165,1,'created_by','JOSM'),(53277166,1,'created_by','JOSM'),(53277167,1,'created_by','JOSM'),(53277168,1,'created_by','JOSM'),(53277169,1,'created_by','JOSM'),(53277170,1,'created_by','JOSM'),(53277171,1,'created_by','JOSM'),(53277172,1,'created_by','JOSM'),(53277173,1,'created_by','JOSM'),(53277174,1,'created_by','JOSM'),(53277175,1,'created_by','JOSM'),(53277176,1,'created_by','JOSM'),(53277177,1,'created_by','JOSM'),(53277178,1,'created_by','JOSM'),(53277179,1,'created_by','JOSM'),(53277180,1,'created_by','JOSM'),(53277181,1,'created_by','JOSM'),(53277182,1,'created_by','JOSM'),(53277183,1,'created_by','JOSM'),(53277184,1,'created_by','JOSM'),(53277185,1,'created_by','JOSM'),(53277186,1,'created_by','JOSM'),(53277187,1,'created_by','JOSM'),(53277189,1,'created_by','JOSM'),(53277190,1,'created_by','JOSM'),(53277191,1,'created_by','JOSM'),(53277192,1,'created_by','JOSM'),(53277193,1,'created_by','JOSM'),(53277194,1,'created_by','JOSM'),(53277195,1,'created_by','JOSM'),(53277196,1,'created_by','JOSM'),(53277197,1,'created_by','JOSM'),(53277198,1,'created_by','JOSM'),(53277199,1,'created_by','JOSM'),(53277200,1,'created_by','JOSM'),(53277201,1,'created_by','JOSM'),(53277202,1,'created_by','JOSM'),(53277203,1,'created_by','JOSM'),(53277204,1,'created_by','JOSM'),(53277205,1,'created_by','JOSM'),(53277206,1,'created_by','JOSM'),(53277207,1,'created_by','JOSM'),(53277208,1,'created_by','JOSM'),(53277209,1,'created_by','JOSM'),(53277210,1,'created_by','JOSM'),(53277211,1,'created_by','JOSM'),(53277212,1,'created_by','JOSM'),(53277213,1,'created_by','JOSM'),(53277214,1,'created_by','JOSM'),(53277215,2,'created_by','JOSM'),(53277216,1,'created_by','JOSM'),(53277217,1,'created_by','JOSM'),(53277218,1,'created_by','JOSM'),(53277219,1,'created_by','JOSM'),(53277220,1,'created_by','JOSM'),(53277221,1,'created_by','JOSM'),(53277222,1,'created_by','JOSM'),(53277223,1,'created_by','JOSM'),(53277224,1,'created_by','JOSM'),(53277225,1,'created_by','JOSM'),(53277226,1,'created_by','JOSM'),(53277227,1,'created_by','JOSM'),(53277228,1,'created_by','JOSM'),(53277229,1,'created_by','JOSM'),(53277230,1,'created_by','JOSM'),(53277231,1,'created_by','JOSM'),(53277232,1,'created_by','JOSM'),(53277233,1,'created_by','JOSM'),(53277234,1,'created_by','JOSM'),(53277235,1,'created_by','JOSM'),(53277236,1,'created_by','JOSM'),(53277237,1,'created_by','JOSM'),(53277238,1,'created_by','JOSM'),(53277239,1,'created_by','JOSM'),(53277240,1,'created_by','JOSM'),(53277241,1,'created_by','JOSM'),(53277242,1,'created_by','JOSM'),(53277243,1,'created_by','JOSM'),(53277244,1,'created_by','JOSM'),(53277245,1,'created_by','JOSM'),(53277246,1,'created_by','JOSM'),(53277247,1,'created_by','JOSM'),(53277248,1,'created_by','JOSM'),(53277249,1,'created_by','JOSM'),(53277250,1,'created_by','JOSM'),(53277251,1,'created_by','JOSM'),(53277252,1,'created_by','JOSM'),(53277253,1,'created_by','JOSM'),(53277254,1,'created_by','JOSM'),(53277255,1,'created_by','JOSM'),(53277256,1,'created_by','JOSM'),(53277257,1,'created_by','JOSM'),(53277258,1,'created_by','JOSM'),(53277259,1,'created_by','JOSM'),(53277260,1,'created_by','JOSM'),(53277261,1,'created_by','JOSM'),(53277262,1,'created_by','JOSM'),(53277263,1,'created_by','JOSM'),(53277264,1,'created_by','JOSM'),(53277265,1,'created_by','JOSM'),(53277266,1,'created_by','JOSM'),(53277267,1,'created_by','JOSM'),(53277268,1,'created_by','JOSM'),(53277269,1,'created_by','JOSM'),(53277270,1,'created_by','JOSM'),(53277271,1,'created_by','JOSM'),(53277272,1,'created_by','JOSM'),(53277273,1,'created_by','JOSM'),(53277274,1,'created_by','JOSM'),(53277275,1,'created_by','JOSM'),(53277276,1,'created_by','JOSM'),(53277277,1,'created_by','JOSM'),(53277278,1,'created_by','JOSM'),(53277279,1,'created_by','JOSM'),(53277280,1,'created_by','JOSM'),(53277281,1,'created_by','JOSM'),(53277282,1,'created_by','JOSM'),(53277283,1,'created_by','JOSM'),(53277284,1,'created_by','JOSM'),(53277285,1,'created_by','JOSM'),(53277286,1,'created_by','JOSM'),(53277287,1,'created_by','JOSM'),(53277288,1,'created_by','JOSM'),(53277289,1,'created_by','JOSM'),(53277290,1,'created_by','JOSM'),(53277291,1,'created_by','JOSM'),(53277292,1,'created_by','JOSM'),(53277293,1,'created_by','JOSM'),(53277294,1,'created_by','JOSM'),(53277295,1,'created_by','JOSM'),(53277296,1,'created_by','JOSM'),(53277297,1,'created_by','JOSM'),(53277298,1,'created_by','JOSM'),(53277299,1,'created_by','JOSM'),(53277300,1,'created_by','JOSM'),(53277301,1,'created_by','JOSM'),(53277302,1,'created_by','JOSM'),(53277303,1,'created_by','JOSM'),(53277304,1,'created_by','JOSM'),(53277305,1,'created_by','JOSM'),(53277306,1,'created_by','JOSM'),(53277307,1,'created_by','JOSM'),(53277308,1,'created_by','JOSM'),(53277309,1,'created_by','JOSM'),(53277310,1,'created_by','JOSM'),(53277311,1,'created_by','JOSM'),(53277312,1,'created_by','JOSM'),(53277313,1,'created_by','JOSM'),(53278142,1,'created_by','JOSM'),(53278144,1,'created_by','JOSM'),(53278146,1,'created_by','JOSM'),(53278147,1,'created_by','JOSM'),(53278148,1,'created_by','JOSM'),(53278149,1,'created_by','JOSM'),(53278150,1,'created_by','JOSM'),(53278151,1,'created_by','JOSM'),(53278152,1,'created_by','JOSM'),(53278153,1,'created_by','JOSM'),(53278154,1,'created_by','JOSM'),(53278155,1,'created_by','JOSM'),(53278156,1,'created_by','JOSM'),(53278157,1,'created_by','JOSM'),(53278158,1,'created_by','JOSM'),(53278159,1,'created_by','JOSM'),(53278160,1,'created_by','JOSM'),(53278161,1,'created_by','JOSM'),(53278162,1,'created_by','JOSM'),(53278163,1,'created_by','JOSM'),(53278164,1,'created_by','JOSM'),(53278165,1,'created_by','JOSM'),(53278166,1,'created_by','JOSM'),(53278167,1,'created_by','JOSM'),(53278168,1,'created_by','JOSM'),(53278173,1,'created_by','JOSM'),(53278175,3,'aerialway','station'),(53278176,1,'created_by','JOSM'),(53278177,1,'created_by','JOSM'),(53278178,1,'created_by','JOSM'),(53278179,1,'created_by','JOSM'),(53278180,1,'created_by','JOSM'),(53278181,1,'created_by','JOSM'),(53278182,1,'created_by','JOSM'),(53278183,1,'created_by','JOSM'),(53278185,1,'created_by','JOSM'),(53278186,1,'created_by','JOSM'),(53278188,1,'created_by','JOSM'),(53278190,1,'created_by','JOSM'),(53278192,1,'created_by','JOSM'),(53278194,1,'created_by','JOSM'),(53278196,1,'created_by','JOSM'),(53278197,1,'created_by','JOSM'),(53278199,1,'created_by','JOSM'),(53278200,1,'created_by','JOSM'),(53278201,1,'created_by','JOSM'),(53278202,1,'created_by','JOSM'),(53278203,1,'created_by','JOSM'),(53278204,1,'created_by','JOSM'),(53278205,1,'created_by','JOSM'),(53278206,1,'created_by','JOSM'),(53278207,1,'created_by','JOSM'),(53278208,1,'created_by','JOSM'),(53278210,1,'created_by','JOSM'),(53278211,1,'created_by','JOSM'),(53278212,1,'created_by','JOSM'),(53278213,1,'created_by','JOSM'),(53278214,1,'created_by','JOSM'),(53278215,1,'created_by','JOSM'),(53278216,1,'created_by','JOSM'),(53278217,1,'created_by','JOSM'),(53278218,1,'created_by','JOSM'),(53278219,1,'created_by','JOSM'),(53278220,1,'created_by','JOSM'),(53278221,1,'created_by','JOSM'),(53278222,1,'created_by','JOSM'),(53278223,1,'created_by','JOSM'),(53278224,1,'created_by','JOSM'),(53278226,1,'created_by','JOSM'),(53278232,1,'created_by','JOSM'),(53278233,1,'created_by','JOSM'),(53278234,1,'created_by','JOSM'),(53278235,1,'created_by','JOSM'),(53278236,1,'created_by','JOSM'),(53278237,1,'created_by','JOSM'),(53278238,1,'created_by','JOSM'),(53278239,1,'created_by','JOSM'),(53278240,1,'created_by','JOSM'),(53278241,1,'created_by','JOSM'),(53278242,1,'created_by','JOSM'),(53278252,1,'created_by','JOSM'),(53278253,1,'created_by','JOSM'),(53278255,1,'created_by','JOSM'),(53278256,1,'created_by','JOSM'),(53278257,1,'created_by','JOSM'),(53278258,1,'created_by','JOSM'),(53278259,1,'created_by','JOSM'),(53278261,1,'created_by','JOSM'),(53278263,1,'created_by','JOSM'),(53278264,1,'created_by','JOSM'),(53278265,1,'created_by','JOSM'),(53278267,1,'created_by','JOSM'),(53278268,1,'created_by','JOSM'),(53278269,1,'created_by','JOSM'),(53278271,1,'created_by','JOSM'),(53278272,1,'created_by','JOSM'),(53278273,1,'created_by','JOSM'),(53278274,1,'created_by','JOSM'),(53278275,1,'created_by','JOSM'),(53278276,1,'created_by','JOSM'),(53278277,1,'created_by','JOSM'),(53278278,1,'created_by','JOSM'),(53278280,1,'created_by','JOSM'),(53278282,1,'created_by','JOSM'),(53278283,1,'created_by','JOSM'),(53278285,1,'created_by','JOSM'),(53278286,1,'created_by','JOSM'),(53278287,1,'created_by','JOSM'),(53278289,1,'created_by','JOSM'),(53278290,1,'created_by','JOSM'),(53278291,1,'created_by','JOSM'),(53278292,1,'created_by','JOSM'),(53278293,1,'created_by','JOSM'),(53278294,1,'created_by','JOSM'),(53278296,1,'created_by','JOSM'),(53278298,1,'created_by','JOSM'),(53278299,1,'created_by','JOSM'),(53278301,1,'created_by','JOSM'),(53278302,1,'created_by','JOSM'),(53278304,1,'created_by','JOSM'),(53278305,1,'created_by','JOSM'),(53278306,1,'created_by','JOSM'),(53278308,1,'created_by','JOSM'),(53278309,1,'created_by','JOSM'),(53278311,1,'created_by','JOSM'),(53278312,1,'created_by','JOSM'),(53278314,1,'created_by','JOSM'),(53278315,1,'created_by','JOSM'),(53278316,1,'created_by','JOSM'),(53278317,1,'created_by','JOSM'),(53278319,1,'created_by','JOSM'),(53278321,1,'created_by','JOSM'),(53278324,1,'created_by','JOSM'),(53278327,1,'created_by','JOSM'),(53278328,1,'created_by','JOSM'),(53278330,1,'created_by','JOSM'),(53278332,1,'created_by','JOSM'),(53278333,1,'created_by','JOSM'),(53278336,1,'created_by','JOSM'),(53278337,1,'created_by','JOSM'),(53278338,1,'created_by','JOSM'),(53278341,1,'created_by','JOSM'),(53278342,1,'created_by','JOSM'),(53278343,1,'created_by','JOSM'),(53278346,1,'created_by','JOSM'),(53278347,1,'created_by','JOSM'),(53278348,1,'created_by','JOSM'),(53278350,1,'created_by','JOSM'),(53278351,1,'created_by','JOSM'),(53278353,1,'created_by','JOSM'),(53278355,1,'created_by','JOSM'),(53278356,1,'created_by','JOSM'),(53278358,1,'created_by','JOSM'),(53278360,1,'created_by','JOSM'),(53278361,1,'created_by','JOSM'),(53278362,1,'created_by','JOSM'),(53278364,1,'created_by','JOSM'),(53278366,1,'created_by','JOSM'),(53278367,1,'created_by','JOSM'),(53278368,1,'created_by','JOSM'),(53278369,1,'created_by','JOSM'),(53278371,1,'created_by','JOSM'),(53278374,1,'created_by','JOSM'),(53278375,1,'created_by','JOSM'),(53278376,1,'created_by','JOSM'),(53278377,1,'created_by','JOSM'),(53278379,1,'created_by','JOSM'),(53278383,1,'created_by','JOSM'),(53278387,1,'created_by','JOSM'),(53278390,1,'created_by','JOSM'),(53278395,1,'created_by','JOSM'),(53278401,1,'created_by','JOSM'),(53278404,1,'created_by','JOSM'),(53278409,1,'created_by','JOSM'),(53278412,1,'created_by','JOSM'),(53278418,1,'created_by','JOSM'),(53278420,1,'created_by','JOSM'),(53278423,1,'created_by','JOSM'),(53278426,1,'created_by','JOSM'),(53278429,1,'created_by','JOSM'),(53281369,1,'created_by','JOSM'),(53281374,1,'created_by','JOSM'),(53281378,1,'created_by','JOSM'),(53281382,1,'created_by','JOSM'),(53281386,1,'created_by','JOSM'),(53281388,1,'created_by','JOSM'),(53281393,1,'created_by','JOSM'),(53281395,1,'created_by','JOSM'),(53281399,1,'created_by','JOSM'),(53281402,1,'created_by','JOSM'),(53281403,1,'created_by','JOSM'),(53282932,1,'created_by','JOSM'),(53282936,1,'created_by','JOSM'),(53282940,1,'created_by','JOSM'),(53282941,1,'created_by','JOSM'),(53282943,1,'created_by','JOSM'),(53282946,1,'created_by','JOSM'),(53282948,1,'created_by','JOSM'),(53282950,1,'created_by','JOSM'),(53282952,1,'created_by','JOSM'),(53282953,1,'created_by','JOSM'),(53282957,1,'created_by','JOSM'),(53282958,1,'created_by','JOSM'),(53282959,1,'created_by','JOSM'),(53282960,1,'created_by','JOSM'),(53282963,1,'created_by','JOSM'),(53282966,1,'created_by','JOSM'),(53282968,1,'created_by','JOSM'),(53282970,1,'created_by','JOSM'),(53282972,1,'created_by','JOSM'),(53282974,1,'created_by','JOSM'),(53282976,1,'created_by','JOSM'),(53282979,1,'created_by','JOSM'),(53282983,1,'created_by','JOSM'),(53282985,1,'created_by','JOSM'),(53282987,1,'created_by','JOSM'),(53282989,1,'created_by','JOSM'),(53282991,1,'created_by','JOSM'),(53282996,1,'created_by','JOSM'),(53282998,1,'created_by','JOSM'),(53283003,1,'created_by','JOSM'),(53283007,1,'created_by','JOSM'),(53283011,1,'created_by','JOSM'),(53288119,2,'created_by','JOSM'),(53288123,1,'created_by','JOSM'),(53288126,2,'created_by','JOSM'),(53288128,3,'created_by','JOSM'),(53288129,2,'created_by','JOSM'),(53288131,2,'created_by','JOSM'),(53288134,2,'created_by','JOSM'),(53288136,2,'created_by','JOSM'),(53288138,2,'created_by','JOSM'),(53288140,2,'created_by','JOSM'),(53288141,1,'created_by','JOSM'),(53288143,2,'created_by','JOSM'),(53288147,2,'created_by','JOSM'),(53288148,2,'created_by','JOSM'),(53288150,1,'created_by','JOSM'),(53288152,2,'created_by','JOSM'),(53288157,2,'created_by','JOSM'),(53288160,1,'created_by','JOSM'),(53288161,1,'created_by','JOSM'),(53288164,1,'created_by','JOSM'),(53288166,1,'created_by','JOSM'),(53288168,1,'created_by','JOSM'),(53288171,1,'created_by','JOSM'),(53288173,1,'created_by','JOSM'),(53288174,1,'created_by','JOSM'),(53288176,1,'created_by','JOSM'),(53288178,1,'created_by','JOSM'),(53288180,1,'created_by','JOSM'),(53288182,1,'created_by','JOSM'),(53288184,1,'created_by','JOSM'),(53288187,1,'created_by','JOSM'),(53288189,1,'created_by','JOSM'),(53288191,1,'created_by','JOSM'),(53288194,1,'created_by','JOSM'),(53288196,1,'created_by','JOSM'),(53288198,1,'created_by','JOSM'),(53288199,1,'created_by','JOSM'),(53288201,1,'created_by','JOSM'),(53288203,1,'created_by','JOSM'),(53288206,1,'created_by','JOSM'),(53288209,1,'created_by','JOSM'),(53288210,1,'created_by','JOSM'),(53288213,1,'created_by','JOSM'),(53288216,1,'created_by','JOSM'),(53288219,1,'created_by','JOSM'),(53288220,1,'created_by','JOSM'),(53288223,1,'created_by','JOSM'),(53288225,1,'created_by','JOSM'),(53288227,1,'created_by','JOSM'),(53288228,1,'created_by','JOSM'),(53288229,1,'created_by','JOSM'),(53288231,1,'created_by','JOSM'),(53288235,1,'created_by','JOSM'),(53288238,1,'created_by','JOSM'),(53288239,1,'created_by','JOSM'),(53288242,1,'created_by','JOSM'),(53288245,1,'created_by','JOSM'),(53288247,1,'created_by','JOSM'),(53288250,1,'created_by','JOSM'),(53288253,1,'created_by','JOSM'),(53288255,1,'created_by','JOSM'),(53288257,1,'created_by','JOSM'),(53288259,1,'created_by','JOSM'),(53288261,1,'created_by','JOSM'),(53288262,1,'created_by','JOSM'),(53288263,1,'created_by','JOSM'),(53288266,1,'created_by','JOSM'),(53288269,1,'created_by','JOSM'),(53288271,1,'created_by','JOSM'),(53288273,1,'created_by','JOSM'),(53288276,1,'created_by','JOSM'),(53288278,1,'created_by','JOSM'),(53288280,1,'created_by','JOSM'),(53288281,1,'created_by','JOSM'),(53288282,1,'created_by','JOSM'),(53288286,1,'created_by','JOSM'),(53288290,1,'created_by','JOSM'),(53288292,1,'created_by','JOSM'),(53288294,1,'created_by','JOSM'),(53288296,1,'created_by','JOSM'),(53288298,1,'created_by','JOSM'),(53288300,1,'created_by','JOSM'),(53288302,1,'created_by','JOSM'),(53288303,1,'created_by','JOSM'),(53288305,1,'created_by','JOSM'),(53288308,1,'created_by','JOSM'),(53288309,1,'created_by','JOSM'),(53288310,1,'created_by','JOSM'),(53288313,1,'created_by','JOSM'),(53288317,1,'created_by','JOSM'),(53288318,1,'created_by','JOSM'),(53288321,1,'created_by','JOSM'),(53288323,1,'created_by','JOSM'),(53288326,1,'created_by','JOSM'),(53288329,1,'created_by','JOSM'),(53288332,1,'created_by','JOSM'),(53288334,1,'created_by','JOSM'),(53288336,1,'created_by','JOSM'),(53288338,1,'created_by','JOSM'),(53288339,1,'created_by','JOSM'),(53288343,1,'created_by','JOSM'),(53288346,1,'created_by','JOSM'),(53288348,1,'created_by','JOSM'),(53288349,1,'created_by','JOSM'),(53288350,1,'created_by','JOSM'),(53288351,1,'created_by','JOSM'),(53288352,1,'created_by','JOSM'),(53288353,1,'created_by','JOSM'),(53288354,1,'created_by','JOSM'),(53288355,1,'created_by','JOSM'),(53288356,1,'created_by','JOSM'),(53288357,1,'created_by','JOSM'),(53288358,1,'created_by','JOSM'),(53288360,1,'created_by','JOSM'),(53288364,1,'created_by','JOSM'),(53288366,1,'created_by','JOSM'),(53288368,1,'created_by','JOSM'),(53288370,1,'created_by','JOSM'),(53288373,1,'created_by','JOSM'),(53288375,1,'created_by','JOSM'),(53288378,1,'created_by','JOSM'),(53288381,1,'created_by','JOSM'),(53288383,1,'created_by','JOSM'),(53288388,1,'created_by','JOSM'),(53288391,1,'created_by','JOSM'),(53288393,1,'created_by','JOSM'),(53288394,1,'created_by','JOSM'),(53288396,1,'created_by','JOSM'),(53288399,1,'created_by','JOSM'),(53288402,1,'created_by','JOSM'),(53288403,1,'created_by','JOSM'),(53288404,1,'created_by','JOSM'),(53288407,1,'created_by','JOSM'),(53288410,1,'created_by','JOSM'),(53288413,1,'created_by','JOSM'),(53288419,1,'created_by','JOSM'),(53292901,1,'created_by','JOSM'),(53292938,1,'created_by','JOSM'),(53292997,1,'created_by','JOSM'),(53293001,1,'created_by','JOSM'),(53293003,1,'created_by','JOSM'),(53293007,1,'created_by','JOSM'),(53293010,1,'created_by','JOSM'),(53293011,1,'created_by','JOSM'),(53293015,1,'created_by','JOSM'),(53293017,1,'created_by','JOSM'),(53293018,1,'created_by','JOSM'),(53293022,1,'created_by','JOSM'),(53293025,1,'created_by','JOSM'),(53293027,1,'created_by','JOSM'),(53293029,1,'created_by','JOSM'),(53293032,1,'created_by','JOSM'),(53293034,1,'created_by','JOSM'),(53293037,1,'created_by','JOSM'),(53293039,1,'created_by','JOSM'),(53293043,1,'created_by','JOSM'),(53293046,1,'created_by','JOSM'),(53293058,1,'created_by','JOSM'),(53293060,1,'created_by','JOSM'),(53293062,1,'created_by','JOSM'),(53293063,1,'created_by','JOSM'),(53293066,1,'created_by','JOSM'),(53293067,1,'created_by','JOSM'),(53293069,1,'created_by','JOSM'),(53293073,1,'created_by','JOSM'),(53293076,1,'created_by','JOSM'),(53293077,1,'created_by','JOSM'),(53293080,1,'created_by','JOSM'),(53293082,1,'created_by','JOSM'),(53293083,1,'created_by','JOSM'),(53293087,1,'created_by','JOSM'),(53293089,1,'created_by','JOSM'),(53293092,1,'created_by','JOSM'),(53293095,1,'created_by','JOSM'),(53293097,1,'created_by','JOSM'),(53293098,1,'created_by','JOSM'),(53293102,1,'created_by','JOSM'),(53293105,1,'created_by','JOSM'),(53293108,1,'created_by','JOSM'),(53293109,1,'created_by','JOSM'),(53293111,1,'created_by','JOSM'),(53293114,1,'created_by','JOSM'),(53293117,1,'created_by','JOSM'),(53293119,1,'created_by','JOSM'),(53293123,1,'created_by','JOSM'),(53293124,1,'created_by','JOSM'),(53293127,1,'created_by','JOSM'),(53293130,1,'created_by','JOSM'),(53293132,1,'created_by','JOSM'),(53293136,1,'created_by','JOSM'),(53293137,1,'created_by','JOSM'),(53293142,1,'created_by','JOSM'),(53293144,1,'created_by','JOSM'),(53293147,1,'created_by','JOSM'),(53293148,1,'created_by','JOSM'),(53293150,1,'created_by','JOSM'),(53293153,1,'created_by','JOSM'),(53293155,1,'created_by','JOSM'),(53293157,1,'created_by','JOSM'),(53293158,1,'created_by','JOSM'),(53293162,1,'created_by','JOSM'),(53293164,1,'created_by','JOSM'),(53293167,1,'created_by','JOSM'),(53293169,1,'created_by','JOSM'),(53293172,1,'created_by','JOSM'),(53293174,1,'created_by','JOSM'),(53293177,1,'created_by','JOSM'),(53293179,1,'created_by','JOSM'),(53293183,1,'created_by','JOSM'),(53293185,1,'created_by','JOSM'),(53293188,1,'created_by','JOSM'),(53293189,1,'created_by','JOSM'),(53293192,1,'created_by','JOSM'),(53293193,1,'created_by','JOSM'),(53293197,1,'created_by','JOSM'),(53293198,1,'created_by','JOSM'),(53293200,1,'created_by','JOSM'),(53293202,1,'created_by','JOSM'),(53293205,1,'created_by','JOSM'),(53293212,1,'created_by','JOSM'),(53293217,1,'created_by','JOSM'),(53293220,1,'created_by','JOSM'),(53293232,1,'created_by','JOSM'),(53293500,1,'created_by','JOSM'),(53293505,1,'created_by','JOSM'),(53293507,1,'created_by','JOSM'),(53293510,1,'created_by','JOSM'),(53294141,1,'created_by','JOSM'),(53294144,1,'created_by','JOSM'),(53294147,1,'created_by','JOSM'),(53294149,1,'created_by','JOSM'),(53294152,1,'created_by','JOSM'),(53294154,1,'created_by','JOSM'),(53294157,1,'created_by','JOSM'),(53294160,1,'created_by','JOSM'),(53294162,1,'created_by','JOSM'),(53294165,1,'created_by','JOSM'),(53294166,1,'created_by','JOSM'),(53294168,1,'created_by','JOSM'),(53294169,1,'created_by','JOSM'),(53294170,1,'created_by','JOSM'),(53294171,1,'created_by','JOSM'),(53294174,1,'created_by','JOSM'),(53294177,1,'created_by','JOSM'),(53294180,1,'created_by','JOSM'),(53294181,1,'created_by','JOSM'),(53294184,1,'created_by','JOSM'),(53294186,1,'created_by','JOSM'),(53294189,1,'created_by','JOSM'),(53294192,1,'created_by','JOSM'),(53294194,1,'created_by','JOSM'),(53294195,1,'created_by','JOSM'),(53294197,1,'created_by','JOSM'),(53294199,1,'created_by','JOSM'),(53294202,1,'created_by','JOSM'),(53294205,1,'created_by','JOSM'),(53294207,1,'created_by','JOSM'),(53294209,1,'created_by','JOSM'),(53294212,1,'created_by','JOSM'),(53294213,1,'created_by','JOSM'),(53294215,1,'created_by','JOSM'),(53294218,1,'created_by','JOSM'),(53294219,1,'created_by','JOSM'),(53294221,1,'created_by','JOSM'),(53294223,1,'created_by','JOSM'),(53294226,1,'created_by','JOSM'),(53294228,1,'created_by','JOSM'),(53294231,1,'created_by','JOSM'),(53294233,1,'created_by','JOSM'),(53294235,1,'created_by','JOSM'),(53294236,1,'created_by','JOSM'),(53294239,1,'created_by','JOSM'),(53294241,1,'created_by','JOSM'),(53294244,1,'created_by','JOSM'),(53294245,1,'created_by','JOSM'),(53294248,1,'created_by','JOSM'),(53294251,1,'created_by','JOSM'),(53294253,1,'created_by','JOSM'),(53294255,1,'created_by','JOSM'),(53294258,1,'created_by','JOSM'),(53294260,1,'created_by','JOSM'),(53294262,1,'created_by','JOSM'),(53294264,1,'created_by','JOSM'),(53294267,1,'created_by','JOSM'),(53294268,1,'created_by','JOSM'),(53294270,1,'created_by','JOSM'),(53294273,1,'created_by','JOSM'),(53294277,1,'created_by','JOSM'),(53294279,1,'created_by','JOSM'),(53294284,1,'created_by','JOSM'),(53294285,1,'created_by','JOSM'),(53294290,1,'created_by','JOSM'),(53294293,1,'created_by','JOSM'),(53294297,1,'created_by','JOSM'),(53294300,1,'created_by','JOSM'),(53294304,1,'created_by','JOSM'),(53294308,1,'created_by','JOSM'),(53294311,1,'created_by','JOSM'),(53294314,1,'created_by','JOSM'),(53294317,1,'created_by','JOSM'),(53294320,1,'created_by','JOSM'),(53294323,1,'created_by','JOSM'),(53294327,1,'created_by','JOSM'),(53294331,1,'created_by','JOSM'),(53294335,1,'created_by','JOSM'),(53294337,1,'created_by','JOSM'),(53294341,1,'created_by','JOSM'),(53294344,1,'created_by','JOSM'),(53294347,1,'created_by','JOSM'),(53294350,1,'created_by','JOSM'),(53294352,1,'created_by','JOSM'),(53294354,1,'created_by','JOSM'),(53294357,1,'created_by','JOSM'),(53294362,1,'created_by','JOSM'),(53294364,1,'created_by','JOSM'),(53294366,1,'created_by','JOSM'),(53294371,1,'created_by','JOSM'),(53294374,1,'created_by','JOSM'),(53294377,1,'created_by','JOSM'),(53294382,1,'created_by','JOSM'),(53294385,1,'created_by','JOSM'),(53294389,1,'created_by','JOSM'),(53294392,1,'created_by','JOSM'),(53294394,1,'created_by','JOSM'),(53294396,1,'created_by','JOSM'),(53294401,1,'created_by','JOSM'),(53294404,1,'created_by','JOSM'),(53294409,1,'created_by','JOSM'),(53294411,1,'created_by','JOSM'),(53294416,1,'created_by','JOSM'),(53294418,1,'created_by','JOSM'),(53294420,1,'created_by','JOSM'),(53294423,1,'created_by','JOSM'),(53294425,1,'created_by','JOSM'),(53294429,1,'created_by','JOSM'),(53294430,1,'created_by','JOSM'),(53294433,1,'created_by','JOSM'),(53294434,1,'created_by','JOSM'),(53294436,1,'created_by','JOSM'),(53294443,1,'created_by','JOSM'),(53294444,1,'created_by','JOSM'),(53294448,1,'created_by','JOSM'),(53294450,1,'created_by','JOSM'),(53294455,1,'created_by','JOSM'),(53294458,1,'created_by','JOSM'),(53294463,1,'created_by','JOSM'),(53294466,1,'created_by','JOSM'),(53294469,1,'created_by','JOSM'),(53294474,1,'created_by','JOSM'),(53294475,1,'created_by','JOSM'),(53294479,1,'created_by','JOSM'),(53294483,1,'created_by','JOSM'),(53294487,1,'created_by','JOSM'),(53294490,1,'created_by','JOSM'),(53294493,1,'created_by','JOSM'),(53294496,1,'created_by','JOSM'),(53294500,1,'created_by','JOSM'),(53294503,1,'created_by','JOSM'),(53294508,1,'created_by','JOSM'),(53294512,1,'created_by','JOSM'),(53294515,1,'created_by','JOSM'),(53294520,1,'created_by','JOSM'),(53294523,1,'created_by','JOSM'),(53294526,1,'created_by','JOSM'),(53294530,1,'created_by','JOSM'),(53294531,1,'created_by','JOSM'),(53294534,1,'created_by','JOSM'),(53294537,1,'created_by','JOSM'),(53294540,1,'created_by','JOSM'),(53294541,1,'created_by','JOSM'),(53294545,1,'created_by','JOSM'),(53294548,1,'created_by','JOSM'),(53294552,1,'created_by','JOSM'),(53294557,1,'created_by','JOSM'),(53294560,1,'created_by','JOSM'),(53294562,1,'created_by','JOSM'),(53294566,1,'created_by','JOSM'),(53294570,1,'created_by','JOSM'),(53294573,1,'created_by','JOSM'),(53294577,1,'created_by','JOSM'),(53294581,1,'created_by','JOSM'),(53294998,1,'created_by','JOSM'),(53295002,1,'created_by','JOSM'),(53295004,1,'created_by','JOSM'),(53295006,1,'created_by','JOSM'),(53295010,1,'created_by','JOSM'),(53295011,1,'created_by','JOSM'),(53295014,1,'created_by','JOSM'),(53295016,1,'created_by','JOSM'),(53295019,1,'created_by','JOSM'),(53295022,1,'created_by','JOSM'),(53295026,1,'created_by','JOSM'),(53295029,1,'created_by','JOSM'),(53295033,1,'created_by','JOSM'),(53295035,1,'created_by','JOSM'),(53295038,1,'created_by','JOSM'),(53295040,1,'created_by','JOSM'),(53295043,1,'created_by','JOSM'),(53295045,1,'created_by','JOSM'),(53295047,1,'created_by','JOSM'),(53295051,1,'created_by','JOSM'),(53295054,1,'created_by','JOSM'),(53295057,1,'created_by','JOSM'),(53295059,1,'created_by','JOSM'),(53295063,1,'created_by','JOSM'),(53295067,1,'created_by','JOSM'),(53295071,1,'created_by','JOSM'),(53295073,1,'created_by','JOSM'),(53295077,1,'created_by','JOSM'),(53295079,1,'created_by','JOSM'),(53295083,1,'created_by','JOSM'),(53295085,1,'created_by','JOSM'),(53295090,1,'created_by','JOSM'),(53295093,1,'created_by','JOSM'),(53295097,1,'created_by','JOSM'),(53295102,1,'created_by','JOSM'),(53295103,1,'created_by','JOSM'),(53295107,1,'created_by','JOSM'),(53295110,1,'created_by','JOSM'),(53295113,1,'created_by','JOSM'),(53295117,1,'created_by','JOSM'),(53295122,1,'created_by','JOSM'),(53295125,1,'created_by','JOSM'),(53295128,1,'created_by','JOSM'),(53295132,1,'created_by','JOSM'),(53295133,1,'created_by','JOSM'),(53295137,1,'created_by','JOSM'),(53295141,1,'created_by','JOSM'),(53295143,1,'created_by','JOSM'),(53295147,1,'created_by','JOSM'),(53295149,1,'created_by','JOSM'),(53295153,1,'created_by','JOSM'),(53295157,1,'created_by','JOSM'),(53295158,1,'created_by','JOSM'),(53295161,1,'created_by','JOSM'),(53295165,1,'created_by','JOSM'),(53295169,1,'created_by','JOSM'),(53295172,1,'created_by','JOSM'),(53295175,1,'created_by','JOSM'),(53295178,1,'created_by','JOSM'),(53295182,1,'created_by','JOSM'),(53295186,1,'created_by','JOSM'),(53295188,1,'created_by','JOSM'),(53295190,1,'created_by','JOSM'),(53295193,1,'created_by','JOSM'),(53295197,1,'created_by','JOSM'),(53295202,1,'created_by','JOSM'),(53295208,1,'created_by','JOSM'),(53295211,1,'created_by','JOSM'),(53295218,1,'created_by','JOSM'),(53295222,1,'created_by','JOSM'),(53295224,1,'created_by','JOSM'),(53295228,1,'created_by','JOSM'),(53295233,1,'created_by','JOSM'),(53295236,1,'created_by','JOSM');
INSERT INTO `node_tags` VALUES (53295241,1,'created_by','JOSM'),(53295243,1,'created_by','JOSM'),(53295245,1,'created_by','JOSM'),(53295249,1,'created_by','JOSM'),(53295251,1,'created_by','JOSM'),(53295253,1,'created_by','JOSM'),(53295257,1,'created_by','JOSM'),(53306569,1,'created_by','JOSM'),(53306573,1,'created_by','JOSM'),(53306575,1,'created_by','JOSM'),(53306579,1,'created_by','JOSM'),(53306582,1,'created_by','JOSM'),(53306585,1,'created_by','JOSM'),(53306588,1,'created_by','JOSM'),(53306590,1,'created_by','JOSM'),(53306592,1,'created_by','JOSM'),(53306595,1,'created_by','JOSM'),(53306597,1,'created_by','JOSM'),(53306600,1,'created_by','JOSM'),(53306695,1,'created_by','JOSM'),(53306696,1,'created_by','JOSM'),(53306764,1,'created_by','JOSM'),(53306767,1,'created_by','JOSM'),(53306769,1,'created_by','JOSM'),(53306771,1,'created_by','JOSM'),(53306774,1,'created_by','JOSM'),(53306775,1,'created_by','JOSM'),(53306778,1,'created_by','JOSM'),(53306780,1,'created_by','JOSM'),(53306781,1,'created_by','JOSM'),(53306782,1,'created_by','JOSM'),(53306786,1,'created_by','JOSM'),(53306788,1,'created_by','JOSM'),(53306789,1,'created_by','JOSM'),(53306790,1,'created_by','JOSM'),(53306791,1,'created_by','JOSM'),(53306792,1,'created_by','JOSM'),(53306794,1,'created_by','JOSM'),(53306795,1,'created_by','JOSM'),(53306796,1,'created_by','JOSM'),(53306799,1,'created_by','JOSM'),(53306800,1,'created_by','JOSM'),(53306803,1,'created_by','JOSM'),(53306804,1,'created_by','JOSM'),(53306806,1,'created_by','JOSM'),(53306808,1,'created_by','JOSM'),(53306810,1,'created_by','JOSM'),(53306813,1,'created_by','JOSM'),(53306814,1,'created_by','JOSM'),(53306817,1,'created_by','JOSM'),(53306819,1,'created_by','JOSM'),(53306821,1,'created_by','JOSM'),(53306823,1,'created_by','JOSM'),(53306825,1,'created_by','JOSM'),(53306828,1,'created_by','JOSM'),(53306831,1,'created_by','JOSM'),(53306833,1,'created_by','JOSM'),(53306836,1,'created_by','JOSM'),(53306838,1,'created_by','JOSM'),(53306841,1,'created_by','JOSM'),(53306843,1,'created_by','JOSM'),(53306845,1,'created_by','JOSM'),(53306846,1,'created_by','JOSM'),(53306848,1,'created_by','JOSM'),(53306849,1,'created_by','JOSM'),(53306852,1,'created_by','JOSM'),(53306853,1,'created_by','JOSM'),(53306856,1,'created_by','JOSM'),(53306858,1,'created_by','JOSM'),(53306862,1,'created_by','JOSM'),(53306863,1,'created_by','JOSM'),(53306866,1,'created_by','JOSM'),(53306869,1,'created_by','JOSM'),(53306871,1,'created_by','JOSM'),(53306873,1,'created_by','JOSM'),(53306874,1,'created_by','JOSM'),(53306875,1,'created_by','JOSM'),(53306876,1,'created_by','JOSM'),(53306878,1,'created_by','JOSM'),(53306881,1,'created_by','JOSM'),(53306882,1,'created_by','JOSM'),(53306885,1,'created_by','JOSM'),(53306886,1,'created_by','JOSM'),(53306887,1,'created_by','JOSM'),(53306888,1,'created_by','JOSM'),(53306889,1,'created_by','JOSM'),(53306892,1,'created_by','JOSM'),(53306893,1,'created_by','JOSM'),(53306897,1,'created_by','JOSM'),(53306899,1,'created_by','JOSM'),(53306901,1,'created_by','JOSM'),(53306904,1,'created_by','JOSM'),(53306906,1,'created_by','JOSM'),(53306907,1,'created_by','JOSM'),(53306910,1,'created_by','JOSM'),(53306963,1,'created_by','JOSM'),(53306966,1,'created_by','JOSM'),(53306970,1,'created_by','JOSM'),(53306973,1,'created_by','JOSM'),(53306975,1,'created_by','JOSM'),(53306978,1,'created_by','JOSM'),(53306979,1,'created_by','JOSM'),(53306983,1,'created_by','JOSM'),(53306984,1,'created_by','JOSM'),(53306988,1,'created_by','JOSM'),(53306989,1,'created_by','JOSM'),(53306991,1,'created_by','JOSM'),(53306992,1,'created_by','JOSM'),(53306994,1,'created_by','JOSM'),(53309350,2,'created_by','JOSM'),(53309352,1,'created_by','JOSM'),(53309354,1,'created_by','JOSM'),(53309356,1,'created_by','JOSM'),(53309360,1,'created_by','JOSM'),(53309365,1,'created_by','JOSM'),(53309368,3,'created_by','JOSM'),(53309369,2,'created_by','JOSM'),(53309370,1,'created_by','JOSM'),(53309371,2,'created_by','JOSM'),(53309374,1,'created_by','JOSM'),(53309376,1,'created_by','JOSM'),(53309379,2,'created_by','JOSM'),(53309379,2,'highway','turning_circle'),(53309380,1,'created_by','JOSM'),(53309384,4,'created_by','JOSM'),(53309386,2,'created_by','JOSM'),(53309389,2,'created_by','JOSM'),(53309392,2,'created_by','JOSM'),(53309393,1,'created_by','JOSM'),(53309395,1,'created_by','JOSM'),(53309397,1,'created_by','JOSM'),(53309398,1,'created_by','JOSM'),(53309400,1,'created_by','JOSM'),(53309402,1,'created_by','JOSM'),(53309405,1,'created_by','JOSM'),(53309407,1,'created_by','JOSM'),(53309409,1,'created_by','JOSM'),(53309412,1,'created_by','JOSM'),(53309414,1,'created_by','JOSM'),(53309417,1,'created_by','JOSM'),(53309419,1,'created_by','JOSM'),(53309421,1,'created_by','JOSM'),(53309423,1,'created_by','JOSM'),(53309425,1,'created_by','JOSM'),(53309427,1,'created_by','JOSM'),(53309431,1,'created_by','JOSM'),(53309433,1,'created_by','JOSM'),(53309436,1,'created_by','JOSM'),(53309438,1,'created_by','JOSM'),(53309440,1,'created_by','JOSM'),(53309443,1,'created_by','JOSM'),(53309446,1,'created_by','JOSM'),(53309449,1,'created_by','JOSM'),(53309453,1,'created_by','JOSM'),(53309457,1,'created_by','JOSM'),(53309460,1,'created_by','JOSM'),(53309462,1,'created_by','JOSM'),(53309464,1,'created_by','JOSM'),(53309466,1,'created_by','JOSM'),(53309469,1,'created_by','JOSM'),(53309473,1,'created_by','JOSM'),(53309476,1,'created_by','JOSM'),(53309477,1,'created_by','JOSM'),(53309480,1,'created_by','JOSM'),(53309482,1,'created_by','JOSM'),(53309483,1,'created_by','JOSM'),(53309485,1,'created_by','JOSM'),(53315413,1,'created_by','JOSM'),(53315705,4,'created_by','JOSM'),(53315884,2,'created_by','JOSM'),(53315943,2,'created_by','JOSM'),(53315948,2,'created_by','JOSM'),(53315952,2,'created_by','JOSM'),(53315955,2,'created_by','JOSM'),(53316065,2,'created_by','JOSM'),(53316068,1,'created_by','JOSM'),(53316074,1,'created_by','JOSM'),(53316105,1,'created_by','JOSM'),(53319479,2,'created_by','JOSM'),(53319482,2,'created_by','JOSM'),(53319484,1,'created_by','JOSM'),(53319487,1,'created_by','JOSM'),(53319489,1,'created_by','JOSM'),(53319514,1,'created_by','JOSM'),(53319515,1,'created_by','JOSM'),(53319517,1,'created_by','JOSM'),(53319520,1,'created_by','JOSM'),(53319521,1,'created_by','JOSM'),(53319523,1,'created_by','JOSM'),(53319525,1,'created_by','JOSM'),(53319529,1,'created_by','JOSM'),(53319532,1,'created_by','JOSM'),(53319535,1,'created_by','JOSM'),(53319536,1,'created_by','JOSM'),(53319538,1,'created_by','JOSM'),(53319539,1,'created_by','JOSM'),(53319541,1,'created_by','JOSM'),(53319543,1,'created_by','JOSM'),(53319545,1,'created_by','JOSM'),(53319547,1,'created_by','JOSM'),(53319548,1,'created_by','JOSM'),(53319551,1,'created_by','JOSM'),(53319552,1,'created_by','JOSM'),(53319581,1,'created_by','JOSM'),(53319582,1,'created_by','JOSM'),(53319584,1,'created_by','JOSM'),(53319587,1,'created_by','JOSM'),(53319589,1,'created_by','JOSM'),(53319592,1,'created_by','JOSM'),(53319593,1,'created_by','JOSM'),(53319596,1,'created_by','JOSM'),(53319598,1,'created_by','JOSM'),(53319600,1,'created_by','JOSM'),(53319601,1,'created_by','JOSM'),(53319603,1,'created_by','JOSM'),(53319605,1,'created_by','JOSM'),(53319607,1,'created_by','JOSM'),(53319609,1,'created_by','JOSM'),(53319610,1,'created_by','JOSM'),(53319611,1,'created_by','JOSM'),(53319612,1,'created_by','JOSM'),(53319613,1,'created_by','JOSM'),(53319616,1,'created_by','JOSM'),(53319617,1,'created_by','JOSM'),(53319619,1,'created_by','JOSM'),(53319621,1,'created_by','JOSM'),(53319624,1,'created_by','JOSM'),(53319625,1,'created_by','JOSM'),(53319627,1,'created_by','JOSM'),(53319629,1,'created_by','JOSM'),(53319631,1,'created_by','JOSM'),(53319632,1,'created_by','JOSM'),(53319634,1,'created_by','JOSM'),(53319636,1,'created_by','JOSM'),(53319638,1,'created_by','JOSM'),(53319639,1,'created_by','JOSM'),(53319642,1,'created_by','JOSM'),(53319643,1,'created_by','JOSM'),(53319645,1,'created_by','JOSM'),(53319646,1,'created_by','JOSM'),(53319648,1,'created_by','JOSM'),(53319649,1,'created_by','JOSM'),(53319651,1,'created_by','JOSM'),(53319652,1,'created_by','JOSM'),(53319657,1,'created_by','JOSM'),(53319658,1,'created_by','JOSM'),(53319659,1,'created_by','JOSM'),(53319661,1,'created_by','JOSM'),(53319663,1,'created_by','JOSM'),(53319664,1,'created_by','JOSM'),(53319665,1,'created_by','JOSM'),(53319666,1,'created_by','JOSM'),(53319667,1,'created_by','JOSM'),(53319669,1,'created_by','JOSM'),(53319670,1,'created_by','JOSM'),(53319672,1,'created_by','JOSM'),(53319675,1,'created_by','JOSM'),(53319678,1,'created_by','JOSM'),(53319681,1,'created_by','JOSM'),(53319682,1,'created_by','JOSM'),(53319684,1,'created_by','JOSM'),(53319686,1,'created_by','JOSM'),(53319688,1,'created_by','JOSM'),(53319690,1,'created_by','JOSM'),(53319693,1,'created_by','JOSM'),(53319695,1,'created_by','JOSM'),(53319697,1,'created_by','JOSM'),(53319700,1,'created_by','JOSM'),(53319701,1,'created_by','JOSM'),(53319702,1,'created_by','JOSM'),(53319703,1,'created_by','JOSM'),(53319749,1,'created_by','JOSM'),(53319750,1,'created_by','JOSM'),(53319752,1,'created_by','JOSM'),(53319753,1,'created_by','JOSM'),(53319755,1,'created_by','JOSM'),(53319756,1,'created_by','JOSM'),(53319758,1,'created_by','JOSM'),(53319759,1,'created_by','JOSM'),(53319761,1,'created_by','JOSM'),(53319765,1,'created_by','JOSM'),(53319768,1,'created_by','JOSM'),(53319770,1,'created_by','JOSM'),(53319773,1,'created_by','JOSM'),(53319774,1,'created_by','JOSM'),(53319777,1,'created_by','JOSM'),(53319778,1,'created_by','JOSM'),(53319781,1,'created_by','JOSM'),(53319782,1,'created_by','JOSM'),(53319784,1,'created_by','JOSM'),(53319786,1,'created_by','JOSM'),(53319789,1,'created_by','JOSM'),(53319790,1,'created_by','JOSM'),(53319793,1,'created_by','JOSM'),(53319796,1,'created_by','JOSM'),(53319797,1,'created_by','JOSM'),(53319800,1,'created_by','JOSM'),(53319801,1,'created_by','JOSM'),(53319804,1,'created_by','JOSM'),(53319806,1,'created_by','JOSM'),(53319807,1,'created_by','JOSM'),(53319809,1,'created_by','JOSM'),(53319811,1,'created_by','JOSM'),(53319813,1,'created_by','JOSM'),(53319815,1,'created_by','JOSM'),(53319816,1,'created_by','JOSM'),(53319817,1,'created_by','JOSM'),(53319818,1,'created_by','JOSM'),(53319819,1,'created_by','JOSM'),(53319820,1,'created_by','JOSM'),(53319821,1,'created_by','JOSM'),(53319822,1,'created_by','JOSM'),(53319823,1,'created_by','JOSM'),(53319826,1,'created_by','JOSM'),(53325709,2,'created_by','JOSM'),(53325711,1,'created_by','JOSM'),(53325715,1,'created_by','JOSM'),(53325718,1,'created_by','JOSM'),(53325720,1,'created_by','JOSM'),(53325722,1,'created_by','JOSM'),(53325723,1,'created_by','JOSM'),(53325724,1,'created_by','JOSM'),(53325725,1,'created_by','JOSM'),(53325726,1,'created_by','JOSM'),(53325729,1,'created_by','JOSM'),(53325732,1,'created_by','JOSM'),(53325735,2,'created_by','JOSM'),(53325736,2,'created_by','JOSM'),(53325739,1,'created_by','JOSM'),(53325742,2,'created_by','JOSM'),(53325743,1,'created_by','JOSM'),(53325746,2,'created_by','JOSM'),(53325748,2,'created_by','JOSM'),(53325750,2,'created_by','JOSM'),(53325752,2,'created_by','JOSM'),(53325792,3,'created_by','JOSM'),(53325795,3,'created_by','JOSM'),(53325798,3,'created_by','JOSM'),(53325801,3,'created_by','JOSM'),(53325802,2,'created_by','JOSM'),(53325805,2,'created_by','JOSM'),(53325807,2,'created_by','JOSM'),(53325809,3,'created_by','JOSM'),(53325813,3,'created_by','JOSM'),(53325815,4,'created_by','JOSM'),(53325817,3,'created_by','JOSM'),(53325820,2,'created_by','JOSM'),(53325823,1,'created_by','JOSM'),(53325827,1,'created_by','JOSM'),(53325829,1,'created_by','JOSM'),(53325840,1,'created_by','JOSM'),(53325843,1,'created_by','JOSM'),(53325846,1,'created_by','JOSM'),(53325848,1,'created_by','JOSM'),(53325850,2,'created_by','JOSM'),(53327622,1,'created_by','JOSM'),(53327629,1,'created_by','JOSM'),(53327630,1,'created_by','JOSM'),(53327633,1,'created_by','JOSM'),(53327636,1,'created_by','JOSM'),(53327637,1,'created_by','JOSM'),(53327639,1,'created_by','JOSM'),(53327642,1,'created_by','JOSM'),(53327646,1,'created_by','JOSM'),(53327649,1,'created_by','JOSM'),(53327652,1,'created_by','JOSM'),(53327654,1,'created_by','JOSM'),(53327657,1,'created_by','JOSM'),(53327661,1,'created_by','JOSM'),(53327664,1,'created_by','JOSM'),(53327667,1,'created_by','JOSM'),(53327669,1,'created_by','JOSM'),(53327672,1,'created_by','JOSM'),(53327675,1,'created_by','JOSM'),(53327678,1,'created_by','JOSM'),(53327682,1,'created_by','JOSM'),(53327685,1,'created_by','JOSM'),(53327686,1,'created_by','JOSM'),(53327689,1,'created_by','JOSM'),(53327693,1,'created_by','JOSM'),(53327696,1,'created_by','JOSM'),(53327697,1,'created_by','JOSM'),(53327700,1,'created_by','JOSM'),(53327703,1,'created_by','JOSM'),(53327705,1,'created_by','JOSM'),(53327706,1,'created_by','JOSM'),(53327708,1,'created_by','JOSM'),(53327710,1,'created_by','JOSM'),(53327712,1,'created_by','JOSM'),(53327716,1,'created_by','JOSM'),(53327717,1,'created_by','JOSM'),(53327720,1,'created_by','JOSM'),(53327721,1,'created_by','JOSM'),(53327724,1,'created_by','JOSM'),(53327726,1,'created_by','JOSM'),(53327728,1,'created_by','JOSM'),(53327730,1,'created_by','JOSM'),(53327733,1,'created_by','JOSM'),(53327734,1,'created_by','JOSM'),(53327735,1,'created_by','JOSM'),(53327736,1,'created_by','JOSM'),(53327737,1,'created_by','JOSM'),(53327738,1,'created_by','JOSM'),(53327739,1,'created_by','JOSM'),(53327812,2,'highway','mini_roundabout'),(53327814,1,'created_by','JOSM'),(53327815,1,'created_by','JOSM'),(53327818,1,'created_by','JOSM'),(53327821,1,'created_by','JOSM'),(53327824,1,'created_by','JOSM'),(53327826,1,'created_by','JOSM'),(53327830,1,'created_by','JOSM'),(53327833,1,'created_by','JOSM'),(53327836,1,'created_by','JOSM'),(53327838,1,'created_by','JOSM'),(53327844,1,'created_by','JOSM'),(53327851,1,'created_by','JOSM'),(53327853,1,'created_by','JOSM'),(53327855,1,'created_by','JOSM'),(53327873,1,'created_by','JOSM'),(53327875,1,'created_by','JOSM'),(53327877,1,'created_by','JOSM'),(53327879,1,'created_by','JOSM'),(53327880,1,'created_by','JOSM'),(53327882,1,'created_by','JOSM'),(53330450,1,'created_by','JOSM'),(53330453,1,'created_by','JOSM'),(53334410,2,'created_by','JOSM'),(53334413,2,'created_by','JOSM'),(53334414,2,'created_by','JOSM'),(53334417,2,'created_by','JOSM'),(53334419,2,'created_by','JOSM'),(53334421,2,'created_by','JOSM'),(53334422,2,'created_by','JOSM'),(53334423,2,'created_by','JOSM'),(53334424,2,'created_by','JOSM'),(53334427,2,'created_by','JOSM'),(53334428,2,'created_by','JOSM'),(53334431,2,'created_by','JOSM'),(53334432,2,'created_by','JOSM'),(53334433,2,'created_by','JOSM'),(53334437,2,'created_by','JOSM'),(53334441,2,'created_by','JOSM'),(53334442,2,'created_by','JOSM'),(53334444,2,'created_by','JOSM'),(53334448,2,'created_by','JOSM'),(53335700,2,'created_by','JOSM'),(53335702,1,'created_by','JOSM'),(53335703,1,'created_by','JOSM'),(53335707,1,'created_by','JOSM'),(53335710,1,'created_by','JOSM'),(53335714,1,'created_by','JOSM'),(53335715,1,'created_by','JOSM'),(53335717,1,'created_by','JOSM'),(53335718,1,'created_by','JOSM'),(53335719,1,'created_by','JOSM'),(53335720,1,'created_by','JOSM'),(53335721,1,'created_by','JOSM'),(53335722,1,'created_by','JOSM'),(53335723,1,'created_by','JOSM'),(53335724,1,'created_by','JOSM'),(53335727,1,'created_by','JOSM'),(53335730,1,'created_by','JOSM'),(53335733,1,'created_by','JOSM'),(53335738,1,'created_by','JOSM'),(53335740,1,'created_by','JOSM'),(53335742,1,'created_by','JOSM'),(53335743,1,'created_by','JOSM'),(53335744,1,'created_by','JOSM'),(53335745,1,'created_by','JOSM'),(53335746,1,'created_by','JOSM'),(53335747,1,'created_by','JOSM'),(53335750,1,'created_by','JOSM'),(53335752,1,'created_by','JOSM'),(53335755,1,'created_by','JOSM'),(53335756,1,'created_by','JOSM'),(53335759,1,'created_by','JOSM'),(53335762,1,'created_by','JOSM'),(53335764,1,'created_by','JOSM'),(53335766,1,'created_by','JOSM'),(53335768,1,'created_by','JOSM'),(53335771,1,'created_by','JOSM'),(53335776,1,'created_by','JOSM'),(53335779,1,'created_by','JOSM'),(53335782,1,'created_by','JOSM'),(53335783,1,'created_by','JOSM'),(53343318,1,'created_by','JOSM'),(53343339,1,'created_by','JOSM'),(53343344,1,'created_by','JOSM'),(53343348,1,'created_by','JOSM'),(53343353,1,'created_by','JOSM'),(53343358,1,'created_by','JOSM'),(53343364,1,'created_by','JOSM'),(53343367,1,'created_by','JOSM'),(53343377,1,'created_by','JOSM'),(53343553,1,'created_by','JOSM'),(53344982,1,'created_by','JOSM'),(53350051,1,'created_by','JOSM'),(53351880,1,'created_by','JOSM'),(53352405,1,'created_by','JOSM'),(53352410,1,'created_by','JOSM'),(53352414,1,'created_by','JOSM'),(53352419,1,'created_by','JOSM'),(53352422,1,'created_by','JOSM'),(53352426,1,'created_by','JOSM'),(53352429,1,'created_by','JOSM'),(53352435,1,'created_by','JOSM'),(53352441,3,'created_by','JOSM'),(53352444,1,'created_by','JOSM'),(53352447,1,'created_by','JOSM'),(53352452,1,'created_by','JOSM'),(53352461,1,'created_by','JOSM'),(53352483,1,'created_by','JOSM'),(53352488,1,'created_by','JOSM'),(53352494,2,'created_by','JOSM'),(53352499,2,'created_by','JOSM'),(53352505,1,'created_by','JOSM'),(53352508,2,'created_by','JOSM'),(53352511,2,'created_by','JOSM'),(53352516,1,'created_by','JOSM'),(53352521,1,'created_by','JOSM'),(53352527,1,'created_by','JOSM'),(53352530,1,'created_by','JOSM'),(53352537,1,'created_by','JOSM'),(53352541,1,'created_by','JOSM'),(53352546,1,'created_by','JOSM'),(53352552,1,'created_by','JOSM'),(53352557,1,'created_by','JOSM'),(53352561,1,'created_by','JOSM'),(53352568,1,'created_by','JOSM'),(53352574,1,'created_by','JOSM'),(53352578,1,'created_by','JOSM'),(53352584,1,'created_by','JOSM'),(53352587,1,'created_by','JOSM'),(53352594,1,'created_by','JOSM'),(53352599,1,'created_by','JOSM'),(53352605,1,'created_by','JOSM'),(53352619,1,'created_by','JOSM'),(53352632,1,'created_by','JOSM'),(53352636,1,'created_by','JOSM'),(53352642,1,'created_by','JOSM'),(53352645,1,'created_by','JOSM'),(53352648,1,'created_by','JOSM'),(53352650,1,'created_by','JOSM'),(53352704,1,'created_by','JOSM'),(53352708,1,'created_by','JOSM'),(53352723,1,'created_by','JOSM'),(53352737,1,'created_by','JOSM'),(53352766,1,'created_by','JOSM'),(53352774,1,'created_by','JOSM'),(53352779,1,'created_by','JOSM'),(53352796,1,'created_by','JOSM'),(53352802,1,'created_by','JOSM'),(53352807,1,'created_by','JOSM'),(53352812,1,'created_by','JOSM'),(53352849,1,'created_by','JOSM'),(53352853,1,'created_by','JOSM'),(53352860,1,'created_by','JOSM'),(53352863,1,'created_by','JOSM'),(53352868,1,'created_by','JOSM'),(53352871,1,'created_by','JOSM'),(53352873,1,'created_by','JOSM'),(53352876,1,'created_by','JOSM'),(53352878,1,'created_by','JOSM'),(53352883,1,'created_by','JOSM'),(53352887,1,'created_by','JOSM'),(53352890,1,'created_by','JOSM'),(53352894,1,'created_by','JOSM'),(53352896,1,'created_by','JOSM'),(53352899,1,'created_by','JOSM'),(53352904,1,'created_by','JOSM'),(53352906,1,'created_by','JOSM'),(53352907,1,'created_by','JOSM'),(53352912,1,'created_by','JOSM'),(53352934,1,'created_by','JOSM'),(53352938,1,'created_by','JOSM'),(53352942,1,'created_by','JOSM'),(53352946,1,'created_by','JOSM'),(53352948,1,'created_by','JOSM'),(53352951,1,'created_by','JOSM'),(53352954,1,'created_by','JOSM'),(53352957,1,'created_by','JOSM'),(53352960,1,'created_by','JOSM'),(53352963,1,'created_by','JOSM'),(53352966,1,'created_by','JOSM'),(53352969,1,'created_by','JOSM'),(53352974,1,'created_by','JOSM'),(53352975,1,'created_by','JOSM'),(53353016,1,'created_by','JOSM'),(53353021,1,'created_by','JOSM'),(53353024,1,'created_by','JOSM'),(53353034,1,'created_by','JOSM'),(53353040,1,'created_by','JOSM'),(53353043,1,'created_by','JOSM'),(53353047,1,'created_by','JOSM'),(53353051,1,'created_by','JOSM'),(53353055,1,'created_by','JOSM'),(53353086,1,'created_by','JOSM'),(53353092,1,'created_by','JOSM'),(53353108,1,'created_by','JOSM'),(53353111,1,'created_by','JOSM'),(53353121,1,'created_by','JOSM'),(53353126,1,'created_by','JOSM'),(53353132,1,'created_by','JOSM'),(53353141,1,'created_by','JOSM'),(53353144,1,'created_by','JOSM'),(53353148,1,'created_by','JOSM'),(53353151,1,'created_by','JOSM'),(53353155,1,'created_by','JOSM'),(53353160,1,'created_by','JOSM'),(53353163,1,'created_by','JOSM'),(53353167,1,'created_by','JOSM'),(53353170,1,'created_by','JOSM'),(53353174,1,'created_by','JOSM'),(53353179,1,'created_by','JOSM'),(53353181,1,'created_by','JOSM'),(53353183,1,'created_by','JOSM'),(53353186,1,'created_by','JOSM'),(53353189,1,'created_by','JOSM'),(53353193,1,'created_by','JOSM'),(53353198,1,'created_by','JOSM'),(53353199,1,'created_by','JOSM'),(53353203,1,'created_by','JOSM'),(53353205,1,'created_by','JOSM'),(53353208,1,'created_by','JOSM'),(53353211,1,'created_by','JOSM'),(53353223,3,'created_by','JOSM'),(53353237,1,'created_by','JOSM'),(53353302,1,'created_by','JOSM'),(53353307,1,'created_by','JOSM'),(53353314,1,'created_by','JOSM'),(53353319,1,'created_by','JOSM'),(53353324,1,'created_by','JOSM'),(53353328,1,'created_by','JOSM'),(53353333,1,'created_by','JOSM'),(53353340,1,'created_by','JOSM'),(53353343,1,'created_by','JOSM'),(53353345,1,'created_by','JOSM'),(53353350,1,'created_by','JOSM'),(53353359,1,'created_by','JOSM'),(53353366,1,'created_by','JOSM'),(53353369,1,'created_by','JOSM'),(53353372,1,'created_by','JOSM'),(53353375,1,'created_by','JOSM'),(53353383,1,'created_by','JOSM'),(53353388,1,'created_by','JOSM'),(53353391,1,'created_by','JOSM'),(53353393,1,'created_by','JOSM'),(53353395,1,'created_by','JOSM'),(53353404,1,'created_by','JOSM'),(53353407,1,'created_by','JOSM'),(53353413,1,'created_by','JOSM'),(53353421,1,'created_by','JOSM'),(53353427,1,'created_by','JOSM'),(53353431,1,'created_by','JOSM'),(53353435,1,'created_by','JOSM'),(53368899,1,'created_by','JOSM'),(53368914,1,'created_by','JOSM'),(53368932,1,'created_by','JOSM'),(53368942,1,'created_by','JOSM'),(53368953,1,'created_by','JOSM'),(53368973,1,'created_by','JOSM'),(53368998,1,'created_by','JOSM'),(53369007,1,'created_by','JOSM'),(53369015,1,'created_by','JOSM'),(53369038,1,'created_by','JOSM'),(53370808,1,'created_by','JOSM'),(53370819,1,'created_by','JOSM'),(53370838,1,'created_by','JOSM'),(53370844,1,'created_by','JOSM'),(53370871,1,'created_by','JOSM'),(53370880,1,'created_by','JOSM'),(53370887,1,'created_by','JOSM'),(53370890,1,'created_by','JOSM'),(53370895,1,'created_by','JOSM'),(53370900,1,'created_by','JOSM'),(53370906,1,'created_by','JOSM'),(53370914,1,'created_by','JOSM'),(53370920,1,'created_by','JOSM'),(53370935,1,'created_by','JOSM'),(53370942,1,'created_by','JOSM'),(53370949,1,'created_by','JOSM'),(53370956,1,'created_by','JOSM'),(53370959,1,'created_by','JOSM'),(53371037,1,'created_by','JOSM'),(53371050,1,'created_by','JOSM'),(53371067,1,'created_by','JOSM'),(53371073,1,'created_by','JOSM'),(53371079,1,'created_by','JOSM'),(53371084,1,'created_by','JOSM'),(53371089,1,'created_by','JOSM'),(53371093,1,'created_by','JOSM'),(53371101,1,'created_by','JOSM'),(53371106,1,'created_by','JOSM'),(53371115,1,'created_by','JOSM'),(53371121,1,'created_by','JOSM'),(53371129,1,'created_by','JOSM'),(53371134,1,'created_by','JOSM'),(53371138,1,'created_by','JOSM'),(53371141,1,'created_by','JOSM'),(53371144,1,'created_by','JOSM'),(53371154,1,'created_by','JOSM'),(53371160,1,'created_by','JOSM'),(53371174,1,'created_by','JOSM'),(53371181,1,'created_by','JOSM'),(53371551,1,'created_by','JOSM'),(53371691,1,'created_by','JOSM'),(53371748,1,'created_by','JOSM'),(53371756,1,'created_by','JOSM'),(53371761,1,'created_by','JOSM'),(53371763,1,'created_by','JOSM'),(53371771,1,'created_by','JOSM'),(53371778,1,'created_by','JOSM'),(53371784,1,'created_by','JOSM'),(53371787,1,'created_by','JOSM'),(53371793,1,'created_by','JOSM'),(53371799,1,'created_by','JOSM'),(53371804,1,'created_by','JOSM'),(53371810,1,'created_by','JOSM'),(53371816,1,'created_by','JOSM'),(53371823,1,'created_by','JOSM'),(53371827,1,'created_by','JOSM'),(53371833,1,'created_by','JOSM'),(53371840,1,'created_by','JOSM'),(53371845,1,'created_by','JOSM'),(53371850,1,'created_by','JOSM'),(53371856,1,'created_by','JOSM'),(53371859,1,'created_by','JOSM'),(53371862,1,'created_by','JOSM'),(53371868,1,'created_by','JOSM'),(53371873,1,'created_by','JOSM'),(53371881,1,'created_by','JOSM'),(53371890,1,'created_by','JOSM'),(53371908,1,'created_by','JOSM'),(53371942,1,'created_by','JOSM'),(53371951,1,'created_by','JOSM'),(53371955,1,'created_by','JOSM'),(53371958,1,'created_by','JOSM'),(53371963,1,'created_by','JOSM'),(53371969,1,'created_by','JOSM'),(53371993,1,'created_by','JOSM'),(53371998,1,'created_by','JOSM'),(53372005,1,'created_by','JOSM'),(53372015,1,'created_by','JOSM'),(53372021,1,'created_by','JOSM'),(53372044,1,'created_by','JOSM'),(53372056,1,'created_by','JOSM'),(53372063,1,'created_by','JOSM'),(53372072,1,'created_by','JOSM'),(53372078,1,'created_by','JOSM'),(53372086,1,'created_by','JOSM'),(53372094,1,'created_by','JOSM'),(53372108,1,'created_by','JOSM'),(53372121,1,'created_by','JOSM'),(53372132,1,'created_by','JOSM'),(53372138,1,'created_by','JOSM'),(53372143,1,'created_by','JOSM'),(53372151,1,'created_by','JOSM'),(53372163,1,'created_by','JOSM'),(53372180,1,'created_by','JOSM'),(53372190,1,'created_by','JOSM'),(53372197,1,'created_by','JOSM'),(53372208,1,'created_by','JOSM'),(53372217,1,'created_by','JOSM'),(53372225,1,'created_by','JOSM'),(53372232,1,'created_by','JOSM'),(53372242,1,'created_by','JOSM'),(53372246,1,'created_by','JOSM'),(53372255,1,'created_by','JOSM'),(53372261,1,'created_by','JOSM'),(53372271,1,'created_by','JOSM'),(53372278,1,'created_by','JOSM'),(53372284,1,'created_by','JOSM'),(53372290,1,'created_by','JOSM'),(53372297,1,'created_by','JOSM'),(53372305,1,'created_by','JOSM'),(53372352,1,'created_by','JOSM'),(53372357,1,'created_by','JOSM'),(53372365,1,'created_by','JOSM'),(53372381,1,'created_by','JOSM'),(53372404,1,'created_by','JOSM'),(53372410,1,'created_by','JOSM'),(53372412,1,'created_by','JOSM'),(53372413,1,'created_by','JOSM'),(53372418,1,'created_by','JOSM'),(53372422,1,'created_by','JOSM'),(53372427,1,'created_by','JOSM'),(53372432,1,'created_by','JOSM'),(53372437,1,'created_by','JOSM'),(53372442,1,'created_by','JOSM'),(53372446,1,'created_by','JOSM'),(53372456,1,'created_by','JOSM'),(53372458,1,'created_by','JOSM'),(53372462,1,'created_by','JOSM'),(53372466,1,'created_by','JOSM'),(53372476,1,'created_by','JOSM'),(53372487,1,'created_by','JOSM'),(53372493,1,'created_by','JOSM'),(53372501,1,'created_by','JOSM'),(53372509,1,'created_by','JOSM'),(53372513,1,'created_by','JOSM'),(53372518,1,'created_by','JOSM'),(53372522,1,'created_by','JOSM'),(53372527,1,'created_by','JOSM'),(53372535,1,'created_by','JOSM'),(53372541,1,'created_by','JOSM'),(53372544,1,'created_by','JOSM'),(53372549,1,'created_by','JOSM'),(53372555,1,'created_by','JOSM'),(53372562,1,'created_by','JOSM'),(53372568,1,'created_by','JOSM'),(53372577,1,'created_by','JOSM'),(53372587,1,'created_by','JOSM'),(53372608,1,'created_by','JOSM'),(53372614,1,'created_by','JOSM'),(53372629,1,'created_by','JOSM'),(53372637,1,'created_by','JOSM'),(53372777,1,'created_by','JOSM'),(53372794,1,'created_by','JOSM'),(53372806,1,'created_by','JOSM'),(53372815,1,'created_by','JOSM'),(53372828,1,'created_by','JOSM'),(53372832,1,'created_by','JOSM'),(53372838,1,'created_by','JOSM'),(53372843,1,'created_by','JOSM'),(53372852,1,'created_by','JOSM'),(53372858,1,'created_by','JOSM'),(53372863,1,'created_by','JOSM'),(53372873,1,'created_by','JOSM'),(53372879,1,'created_by','JOSM'),(53372887,1,'created_by','JOSM'),(53372892,1,'created_by','JOSM'),(53372903,1,'created_by','JOSM'),(53372912,1,'created_by','JOSM'),(53372917,1,'created_by','JOSM'),(53372927,1,'created_by','JOSM'),(53372935,1,'created_by','JOSM'),(53372942,1,'created_by','JOSM'),(53372956,1,'created_by','JOSM'),(53372965,1,'created_by','JOSM'),(53372978,1,'created_by','JOSM'),(53372982,1,'created_by','JOSM'),(53372991,1,'created_by','JOSM'),(53373005,1,'created_by','JOSM'),(53373016,1,'created_by','JOSM'),(53373029,1,'created_by','JOSM'),(53373035,1,'created_by','JOSM'),(53373049,1,'created_by','JOSM'),(53373068,1,'created_by','JOSM'),(53373079,1,'created_by','JOSM'),(53373094,1,'created_by','JOSM'),(53373107,1,'created_by','JOSM'),(53373114,1,'created_by','JOSM'),(53373121,1,'created_by','JOSM'),(53373130,1,'created_by','JOSM'),(53373163,1,'created_by','JOSM'),(53373182,1,'created_by','JOSM'),(53373197,1,'created_by','JOSM'),(53373203,1,'created_by','JOSM'),(53373215,1,'created_by','JOSM'),(53373224,1,'created_by','JOSM'),(53373230,1,'created_by','JOSM'),(53373233,1,'created_by','JOSM'),(53373241,1,'created_by','JOSM'),(53373246,1,'created_by','JOSM'),(53373251,1,'created_by','JOSM'),(53373259,1,'created_by','JOSM'),(53373266,1,'created_by','JOSM'),(53373270,1,'created_by','JOSM'),(53373275,1,'created_by','JOSM'),(53373280,1,'created_by','JOSM'),(53373289,1,'created_by','JOSM'),(53373297,1,'created_by','JOSM'),(53373303,1,'created_by','JOSM'),(53373308,1,'created_by','JOSM'),(53373311,1,'created_by','JOSM'),(53373318,1,'created_by','JOSM'),(53373327,1,'created_by','JOSM'),(53373335,1,'created_by','JOSM'),(53373343,1,'created_by','JOSM'),(53373348,1,'created_by','JOSM'),(53373356,1,'created_by','JOSM'),(53373365,1,'created_by','JOSM'),(53373376,1,'created_by','JOSM'),(53373382,1,'created_by','JOSM'),(53373386,1,'created_by','JOSM'),(53373392,1,'created_by','JOSM'),(53373399,1,'created_by','JOSM'),(53373402,1,'created_by','JOSM'),(53373406,1,'created_by','JOSM'),(53373410,1,'created_by','JOSM'),(53373416,1,'created_by','JOSM'),(53373457,1,'created_by','JOSM'),(53373463,1,'created_by','JOSM'),(53373467,1,'created_by','JOSM'),(53373472,1,'created_by','JOSM'),(53373475,1,'created_by','JOSM'),(53373479,1,'created_by','JOSM'),(53373480,1,'created_by','JOSM'),(53373484,1,'created_by','JOSM'),(53373499,1,'created_by','JOSM'),(53373501,1,'created_by','JOSM'),(53373507,1,'created_by','JOSM'),(53373512,1,'created_by','JOSM'),(53373516,1,'created_by','JOSM'),(53373521,1,'created_by','JOSM'),(53373529,1,'created_by','JOSM'),(53373532,1,'created_by','JOSM'),(53373536,1,'created_by','JOSM'),(53373543,1,'created_by','JOSM'),(53373545,1,'created_by','JOSM'),(53373549,1,'created_by','JOSM'),(53374387,1,'created_by','JOSM'),(53374403,1,'created_by','JOSM'),(53374521,1,'created_by','JOSM'),(53374531,1,'created_by','JOSM'),(53374534,1,'created_by','JOSM'),(53374537,1,'created_by','JOSM'),(53374542,1,'created_by','JOSM'),(53374635,1,'created_by','JOSM'),(53374797,1,'created_by','JOSM'),(53374856,1,'created_by','JOSM'),(53374862,1,'created_by','JOSM'),(53374867,1,'created_by','JOSM'),(53374883,1,'created_by','JOSM'),(53374887,1,'created_by','JOSM'),(53374892,1,'created_by','JOSM'),(53374894,1,'created_by','JOSM'),(53374897,1,'created_by','JOSM'),(53374901,1,'created_by','JOSM'),(53374925,1,'created_by','JOSM'),(53374929,1,'created_by','JOSM'),(53375001,1,'created_by','JOSM'),(53375004,1,'created_by','JOSM'),(53375007,1,'created_by','JOSM'),(53375010,1,'created_by','JOSM'),(53375014,1,'created_by','JOSM'),(53375016,1,'created_by','JOSM'),(53375019,1,'created_by','JOSM'),(53375022,1,'created_by','JOSM'),(53375026,1,'created_by','JOSM'),(53375056,1,'created_by','JOSM'),(53375086,1,'created_by','JOSM'),(53375126,1,'created_by','JOSM'),(53375501,1,'created_by','JOSM'),(53376238,1,'created_by','JOSM'),(53376244,1,'created_by','JOSM'),(53376247,1,'created_by','JOSM'),(53376253,1,'created_by','JOSM'),(53376257,1,'created_by','JOSM'),(53376264,1,'created_by','JOSM'),(53376267,1,'created_by','JOSM'),(53376272,1,'created_by','JOSM'),(53376275,1,'created_by','JOSM'),(53376314,1,'created_by','JOSM'),(53376323,1,'created_by','JOSM'),(53376331,1,'created_by','JOSM'),(53376354,1,'created_by','JOSM'),(53376363,1,'created_by','JOSM'),(53376376,1,'created_by','JOSM'),(53376378,1,'created_by','JOSM'),(53376383,1,'created_by','JOSM'),(53376386,1,'created_by','JOSM'),(53376390,1,'created_by','JOSM'),(53376392,1,'created_by','JOSM'),(53376394,1,'created_by','JOSM'),(53376397,1,'created_by','JOSM'),(53376399,1,'created_by','JOSM'),(53376401,1,'created_by','JOSM'),(53376405,1,'created_by','JOSM'),(53376408,1,'created_by','JOSM'),(53376414,1,'created_by','JOSM'),(53376419,1,'created_by','JOSM'),(53376421,1,'created_by','JOSM'),(53376423,1,'created_by','JOSM'),(53376428,1,'created_by','JOSM'),(53376431,1,'created_by','JOSM'),(53376435,1,'created_by','JOSM'),(53376437,1,'created_by','JOSM'),(53376438,1,'created_by','JOSM'),(53376440,1,'created_by','JOSM'),(53376442,1,'created_by','JOSM'),(53376444,1,'created_by','JOSM'),(53376448,1,'created_by','JOSM'),(53376451,1,'created_by','JOSM'),(53376626,1,'created_by','JOSM'),(53376629,1,'created_by','JOSM'),(53376632,1,'created_by','JOSM'),(53376634,1,'created_by','JOSM'),(53376637,1,'created_by','JOSM'),(53376658,1,'created_by','JOSM'),(53376660,1,'created_by','JOSM'),(53376663,1,'created_by','JOSM'),(53376664,1,'created_by','JOSM'),(53376666,1,'created_by','JOSM'),(53376670,1,'created_by','JOSM'),(53376674,1,'created_by','JOSM'),(53376677,1,'created_by','JOSM'),(53376682,1,'created_by','JOSM'),(53376683,1,'created_by','JOSM'),(53376686,1,'created_by','JOSM'),(53376689,1,'created_by','JOSM'),(53376692,1,'created_by','JOSM'),(53376695,1,'created_by','JOSM'),(53376699,1,'created_by','JOSM'),(53376702,1,'created_by','JOSM'),(53376704,1,'created_by','JOSM'),(53376709,1,'created_by','JOSM'),(53376715,1,'created_by','JOSM'),(53376719,1,'created_by','JOSM'),(53376723,1,'created_by','JOSM'),(53376729,1,'created_by','JOSM'),(53376733,1,'created_by','JOSM'),(53376737,1,'created_by','JOSM'),(53376740,1,'created_by','JOSM'),(53376743,1,'created_by','JOSM'),(53376746,1,'created_by','JOSM'),(53376748,1,'created_by','JOSM'),(53376750,1,'created_by','JOSM'),(53376751,1,'created_by','JOSM'),(53376753,1,'created_by','JOSM'),(53376754,1,'created_by','JOSM'),(53376756,1,'created_by','JOSM'),(53376757,1,'created_by','JOSM'),(53376761,1,'created_by','JOSM'),(53376764,1,'created_by','JOSM'),(53376766,1,'created_by','JOSM'),(53376768,1,'created_by','JOSM'),(53376771,1,'created_by','JOSM'),(53376772,1,'created_by','JOSM'),(53376775,1,'created_by','JOSM'),(53376777,1,'created_by','JOSM'),(53376780,1,'created_by','JOSM'),(53376782,1,'created_by','JOSM'),(53376784,1,'created_by','JOSM'),(53376788,1,'created_by','JOSM'),(53376797,1,'created_by','JOSM'),(53376799,1,'created_by','JOSM'),(53376802,1,'created_by','JOSM'),(53376806,1,'created_by','JOSM'),(53376810,1,'created_by','JOSM'),(53376814,1,'created_by','JOSM'),(53376816,1,'created_by','JOSM'),(53376820,1,'created_by','JOSM'),(53376827,1,'created_by','JOSM'),(53376830,1,'created_by','JOSM'),(53376834,1,'created_by','JOSM'),(53376837,1,'created_by','JOSM'),(53376840,1,'created_by','JOSM'),(53376847,1,'created_by','JOSM'),(53376853,1,'created_by','JOSM'),(53376856,1,'created_by','JOSM'),(53376859,1,'created_by','JOSM'),(53376862,1,'created_by','JOSM'),(53376864,1,'created_by','JOSM'),(53376873,1,'created_by','JOSM'),(53376881,1,'created_by','JOSM'),(53376883,1,'created_by','JOSM'),(53376887,1,'created_by','JOSM'),(53376891,1,'created_by','JOSM'),(53376895,1,'created_by','JOSM'),(53376898,1,'created_by','JOSM'),(53376899,1,'created_by','JOSM'),(53376955,1,'created_by','JOSM'),(53376959,1,'created_by','JOSM'),(53376962,1,'created_by','JOSM'),(53376964,1,'created_by','JOSM'),(53376968,1,'created_by','JOSM'),(53376972,1,'created_by','JOSM'),(53376975,1,'created_by','JOSM'),(53376979,1,'created_by','JOSM'),(53376983,1,'created_by','JOSM'),(53376987,1,'created_by','JOSM'),(53376989,1,'created_by','JOSM'),(53376996,1,'created_by','JOSM'),(53377001,1,'created_by','JOSM'),(53377006,1,'created_by','JOSM'),(53377009,1,'created_by','JOSM'),(53377015,1,'created_by','JOSM'),(53377018,1,'created_by','JOSM'),(53377021,1,'created_by','JOSM'),(53377027,1,'created_by','JOSM'),(53377032,1,'created_by','JOSM'),(53377035,1,'created_by','JOSM'),(53377040,1,'created_by','JOSM'),(53377045,1,'created_by','JOSM'),(53377047,1,'created_by','JOSM'),(53377049,1,'created_by','JOSM'),(53377051,1,'created_by','JOSM'),(53377053,1,'created_by','JOSM'),(53377058,1,'created_by','JOSM'),(53377061,1,'created_by','JOSM'),(53377065,1,'created_by','JOSM'),(53377068,1,'created_by','JOSM'),(53377070,1,'created_by','JOSM'),(53377077,1,'created_by','JOSM'),(53377080,1,'created_by','JOSM'),(53377090,1,'created_by','JOSM'),(53377093,1,'created_by','JOSM'),(53377098,1,'created_by','JOSM'),(53377104,1,'created_by','JOSM'),(53377113,1,'created_by','JOSM'),(53377119,1,'created_by','JOSM'),(53377124,1,'created_by','JOSM'),(53377128,1,'created_by','JOSM'),(53377133,1,'created_by','JOSM'),(53377138,1,'created_by','JOSM'),(53377141,1,'created_by','JOSM'),(53377146,1,'created_by','JOSM'),(53377151,1,'created_by','JOSM'),(53377156,1,'created_by','JOSM'),(53377163,1,'created_by','JOSM'),(53377168,1,'created_by','JOSM'),(53377175,1,'created_by','JOSM'),(53377178,1,'created_by','JOSM'),(53377180,1,'created_by','JOSM'),(53377183,1,'created_by','JOSM'),(53377186,1,'created_by','JOSM'),(53377191,1,'created_by','JOSM'),(53377195,1,'created_by','JOSM'),(53380473,1,'created_by','JOSM'),(53380480,1,'created_by','JOSM'),(53380485,1,'created_by','JOSM'),(53380489,1,'created_by','JOSM'),(53380491,1,'created_by','JOSM'),(53380499,1,'created_by','JOSM'),(53380503,1,'created_by','JOSM'),(53381711,1,'created_by','JOSM'),(53381723,1,'created_by','JOSM'),(53381733,1,'created_by','JOSM'),(53381738,1,'created_by','JOSM'),(53381779,1,'created_by','JOSM'),(53381787,1,'created_by','JOSM'),(53381798,1,'created_by','JOSM'),(53381809,1,'created_by','JOSM'),(53381818,1,'created_by','JOSM'),(53381825,1,'created_by','JOSM'),(53381829,1,'created_by','JOSM'),(53381832,1,'created_by','JOSM'),(53381834,1,'created_by','JOSM'),(53381837,1,'created_by','JOSM'),(53381842,1,'created_by','JOSM'),(53381844,1,'created_by','JOSM'),(53381850,1,'created_by','JOSM'),(53381892,1,'created_by','JOSM'),(53381925,1,'created_by','JOSM'),(53381944,1,'created_by','JOSM'),(53381947,1,'created_by','JOSM'),(53381978,1,'created_by','JOSM'),(53381995,1,'created_by','JOSM'),(53382002,1,'created_by','JOSM'),(53382009,1,'created_by','JOSM'),(53382019,1,'created_by','JOSM'),(53382028,1,'created_by','JOSM'),(53382033,1,'created_by','JOSM'),(53382041,1,'created_by','JOSM'),(53382044,1,'created_by','JOSM'),(53382047,1,'created_by','JOSM'),(53382052,1,'created_by','JOSM'),(53382055,1,'created_by','JOSM'),(53382059,1,'created_by','JOSM'),(53382064,1,'created_by','JOSM'),(53382089,1,'created_by','JOSM'),(53382106,1,'created_by','JOSM'),(53382126,1,'created_by','JOSM'),(53382156,1,'created_by','JOSM'),(53382223,1,'created_by','JOSM'),(53382318,1,'created_by','JOSM'),(53382504,1,'created_by','JOSM'),(53382509,1,'created_by','JOSM'),(53382959,1,'created_by','JOSM'),(53383168,1,'created_by','JOSM'),(53383242,1,'created_by','JOSM'),(53383258,1,'created_by','JOSM'),(53383280,1,'created_by','JOSM'),(53383286,1,'created_by','JOSM'),(53383289,1,'created_by','JOSM'),(53383297,1,'created_by','JOSM'),(53383310,1,'created_by','JOSM'),(53383321,1,'created_by','JOSM'),(53383324,1,'created_by','JOSM'),(53383336,1,'created_by','JOSM'),(53383341,1,'created_by','JOSM'),(53383350,1,'created_by','JOSM'),(53383356,1,'created_by','JOSM'),(53383364,1,'created_by','JOSM'),(53383369,1,'created_by','JOSM'),(53383373,1,'created_by','JOSM'),(53383379,1,'created_by','JOSM'),(53383384,1,'created_by','JOSM'),(53383388,1,'created_by','JOSM'),(53383393,1,'created_by','JOSM'),(53383398,1,'created_by','JOSM'),(53383403,1,'created_by','JOSM'),(53383409,1,'created_by','JOSM'),(53383415,1,'created_by','JOSM'),(53383419,1,'created_by','JOSM'),(53383424,1,'created_by','JOSM'),(53383429,1,'created_by','JOSM'),(53383434,1,'created_by','JOSM'),(53383440,1,'created_by','JOSM'),(53383445,1,'created_by','JOSM'),(53383451,1,'created_by','JOSM'),(53383455,1,'created_by','JOSM'),(53383459,1,'created_by','JOSM'),(53383468,1,'created_by','JOSM'),(53383474,1,'created_by','JOSM'),(53383480,1,'created_by','JOSM'),(53383487,1,'created_by','JOSM'),(53383494,1,'created_by','JOSM'),(53383497,1,'created_by','JOSM'),(53383499,1,'created_by','JOSM'),(53383505,1,'created_by','JOSM'),(53383508,1,'created_by','JOSM'),(53383523,1,'created_by','JOSM'),(53383556,1,'created_by','JOSM'),(53383559,1,'created_by','JOSM'),(53383561,1,'created_by','JOSM'),(53383562,1,'created_by','JOSM'),(53383566,1,'created_by','JOSM'),(53383579,1,'created_by','JOSM'),(53383582,1,'created_by','JOSM'),(53383584,1,'created_by','JOSM'),(53383597,1,'created_by','JOSM'),(53383600,1,'created_by','JOSM'),(53383603,1,'created_by','JOSM'),(53383605,1,'created_by','JOSM'),(53383606,1,'created_by','JOSM'),(53383610,1,'created_by','JOSM'),(53383612,1,'created_by','JOSM'),(53383614,1,'created_by','JOSM'),(53383617,1,'created_by','JOSM'),(53383620,1,'created_by','JOSM'),(53383622,1,'created_by','JOSM'),(53383624,1,'created_by','JOSM'),(53383626,1,'created_by','JOSM'),(53383628,1,'created_by','JOSM'),(53383631,1,'created_by','JOSM'),(53383634,1,'created_by','JOSM'),(53383636,1,'created_by','JOSM'),(53383639,1,'created_by','JOSM'),(53383643,1,'created_by','JOSM'),(53383646,1,'created_by','JOSM'),(53383670,1,'created_by','JOSM'),(53383680,1,'created_by','JOSM'),(53383685,1,'created_by','JOSM'),(53383688,1,'created_by','JOSM'),(53383691,1,'created_by','JOSM'),(53383694,1,'created_by','JOSM'),(53383698,1,'created_by','JOSM'),(53383728,1,'created_by','JOSM'),(53383735,1,'created_by','JOSM'),(53383739,1,'created_by','JOSM'),(53383762,1,'created_by','JOSM'),(53383772,1,'created_by','JOSM'),(53383793,1,'created_by','JOSM'),(53383842,1,'created_by','JOSM'),(53383953,1,'created_by','JOSM'),(53383956,1,'created_by','JOSM'),(53383958,1,'created_by','JOSM'),(53383961,1,'created_by','JOSM'),(53383970,1,'created_by','JOSM'),(53383987,1,'created_by','JOSM'),(53383990,1,'created_by','JOSM'),(53384000,1,'created_by','JOSM'),(53384003,1,'created_by','JOSM'),(53384008,1,'created_by','JOSM'),(53384011,1,'created_by','JOSM'),(53384013,1,'created_by','JOSM'),(53384016,1,'created_by','JOSM'),(53384020,1,'created_by','JOSM'),(53384024,1,'created_by','JOSM'),(53384026,1,'created_by','JOSM'),(53384030,1,'created_by','JOSM'),(53384033,1,'created_by','JOSM'),(53384036,1,'created_by','JOSM'),(53384038,1,'created_by','JOSM'),(53384040,1,'created_by','JOSM'),(53384065,1,'created_by','JOSM'),(53384068,1,'created_by','JOSM'),(53384120,1,'created_by','JOSM'),(53384283,1,'created_by','JOSM'),(53384287,1,'created_by','JOSM'),(53384302,1,'created_by','JOSM'),(53384325,1,'created_by','JOSM'),(53384330,1,'created_by','JOSM'),(53384332,1,'created_by','JOSM'),(53384335,1,'created_by','JOSM'),(53384338,1,'created_by','JOSM'),(53384375,1,'created_by','JOSM'),(53385461,1,'created_by','JOSM'),(53385467,1,'created_by','JOSM'),(53385484,1,'created_by','JOSM'),(53385511,1,'created_by','JOSM'),(53387182,1,'created_by','JOSM'),(53388340,1,'created_by','JOSM'),(53388543,1,'created_by','JOSM'),(53389302,1,'created_by','JOSM'),(53389827,1,'created_by','JOSM'),(53390266,1,'created_by','JOSM'),(53390450,1,'created_by','JOSM'),(53390493,1,'created_by','JOSM'),(53390505,1,'created_by','JOSM'),(53390513,1,'created_by','JOSM'),(53390521,1,'created_by','JOSM'),(53390534,1,'created_by','JOSM'),(53390548,1,'created_by','JOSM'),(53390624,1,'created_by','JOSM'),(53390658,1,'created_by','JOSM'),(53390732,1,'created_by','JOSM'),(53390740,1,'created_by','JOSM'),(53390749,1,'created_by','JOSM'),(53390776,1,'created_by','JOSM'),(53390786,1,'created_by','JOSM'),(53392096,1,'created_by','JOSM'),(53392102,1,'created_by','JOSM'),(53392109,1,'created_by','JOSM'),(53392116,1,'created_by','JOSM'),(53392136,1,'created_by','JOSM'),(53392141,1,'created_by','JOSM'),(53392147,1,'created_by','JOSM'),(53392151,1,'created_by','JOSM'),(53392160,1,'created_by','JOSM'),(53392164,1,'created_by','JOSM'),(53392166,1,'created_by','JOSM'),(53392168,1,'created_by','JOSM'),(53392180,1,'created_by','JOSM'),(53392185,1,'created_by','JOSM'),(53392195,1,'created_by','JOSM'),(53392200,1,'created_by','JOSM'),(53392203,1,'created_by','JOSM'),(53392207,1,'created_by','JOSM'),(53392208,1,'created_by','JOSM'),(53392215,1,'created_by','JOSM'),(53392222,1,'created_by','JOSM'),(53392224,1,'created_by','JOSM'),(53392227,1,'created_by','JOSM'),(53392235,1,'created_by','JOSM'),(53392239,1,'created_by','JOSM'),(58957648,19,'capital','yes'),(58957648,19,'is_in','Andorra'),(58957648,19,'name','Andorra la Vella'),(58957648,19,'name:an','Andorra la Biella'),(58957648,19,'name:ar','?????? ?? ????'),(58957648,19,'name:bg','?????? ?? ????'),(58957648,19,'name:ca','Andorra la Vella'),(58957648,19,'name:es','Andorra la Vieja'),(58957648,19,'name:fr','Andorre-la-Vieille'),(58957648,19,'name:he','?????? ?? ???'),(58957648,19,'name:is','Andorra la Vella'),(58957648,19,'name:ja','??????????'),(58957648,19,'name:ko','??????'),(58957648,19,'name:la','Andorra Vetus'),(58957648,19,'name:lt','Andora'),(58957648,19,'name:lv','Andora la Velja'),(58957648,19,'name:oc','Andòrra la Vièlha'),(58957648,19,'name:pl','Andora'),(58957648,19,'name:pt','Andorra-a-Velha'),(58957648,19,'name:ru','???????-??-?????'),(58957648,19,'name:sr','?????? ?? ????'),(58957648,19,'name:zh','????'),(58957648,19,'place','town'),(58957648,19,'population','24678'),(58957648,19,'wikipedia:fr','Andorre-la-Vieille'),(58963219,3,'created_by','Potlatch 0.4a'),(58963219,3,'is_in','Andorra'),(58963219,3,'name','Ordino'),(58963219,3,'place','town'),(64796296,1,'created_by','JOSM'),(64796297,1,'created_by','JOSM'),(64796301,1,'created_by','JOSM'),(64796302,1,'created_by','JOSM'),(64796303,1,'created_by','JOSM'),(64796304,1,'created_by','JOSM'),(64796308,1,'created_by','JOSM'),(64796309,1,'created_by','JOSM'),(64796310,1,'created_by','JOSM'),(64796311,1,'created_by','JOSM'),(64796315,1,'created_by','JOSM'),(64796316,1,'created_by','JOSM'),(64796317,1,'created_by','JOSM'),(64796318,1,'created_by','JOSM'),(64796322,1,'created_by','JOSM'),(64796323,1,'created_by','JOSM'),(64796324,1,'created_by','JOSM'),(64796325,1,'created_by','JOSM'),(64796329,1,'created_by','JOSM'),(64796330,1,'created_by','JOSM'),(64796331,1,'created_by','JOSM'),(64796332,1,'created_by','JOSM'),(64796335,1,'created_by','JOSM'),(64796337,1,'created_by','JOSM'),(64796338,1,'created_by','JOSM'),(64796339,1,'created_by','JOSM'),(64796340,1,'created_by','JOSM'),(64796344,1,'created_by','JOSM'),(64796345,1,'created_by','JOSM'),(64796346,1,'created_by','JOSM'),(64796349,1,'created_by','JOSM'),(64796351,1,'created_by','JOSM'),(64796352,1,'created_by','JOSM'),(64796353,1,'created_by','JOSM'),(64796356,1,'created_by','JOSM'),(64796358,1,'created_by','JOSM'),(64796359,1,'created_by','JOSM'),(64796360,1,'created_by','JOSM'),(64796363,1,'created_by','JOSM'),(64796365,1,'created_by','JOSM'),(64796366,1,'created_by','JOSM'),(64796367,1,'created_by','JOSM'),(64796368,1,'created_by','JOSM'),(64796372,1,'created_by','JOSM'),(64796373,1,'created_by','JOSM'),(64796374,1,'created_by','JOSM'),(64796375,1,'created_by','JOSM'),(64796376,1,'created_by','JOSM'),(64796377,1,'created_by','JOSM'),(64796381,1,'created_by','JOSM'),(64796382,1,'created_by','JOSM'),(64796383,1,'created_by','JOSM'),(64796385,1,'created_by','JOSM'),(64796388,1,'created_by','JOSM'),(64798267,1,'created_by','JOSM'),(64798268,1,'created_by','JOSM'),(64798270,1,'created_by','JOSM'),(64798271,1,'created_by','JOSM'),(64798274,1,'created_by','JOSM'),(64798275,1,'created_by','JOSM'),(64798277,1,'created_by','JOSM'),(64798278,1,'created_by','JOSM'),(64798280,1,'created_by','JOSM'),(64798282,1,'created_by','JOSM'),(64798283,1,'created_by','JOSM'),(64798285,1,'created_by','JOSM'),(64798286,1,'created_by','JOSM'),(64798289,1,'created_by','JOSM'),(64798290,1,'created_by','JOSM'),(64798291,1,'created_by','JOSM'),(64798293,1,'created_by','JOSM'),(64798295,1,'created_by','JOSM'),(64798297,1,'created_by','JOSM'),(64798298,1,'created_by','JOSM'),(64798300,1,'created_by','JOSM'),(64798301,1,'created_by','JOSM'),(64798304,1,'created_by','JOSM'),(64798305,1,'created_by','JOSM'),(64798306,1,'created_by','JOSM'),(64798308,1,'created_by','JOSM'),(64798310,1,'created_by','JOSM'),(64798312,1,'created_by','JOSM'),(64798313,1,'created_by','JOSM'),(64798315,3,'created_by','JOSM'),(64798316,3,'created_by','JOSM'),(64798319,2,'created_by','JOSM'),(64798320,2,'created_by','JOSM'),(64798321,2,'created_by','JOSM'),(64798323,1,'created_by','JOSM'),(64798324,1,'created_by','JOSM'),(64798327,2,'created_by','JOSM'),(64798328,3,'created_by','JOSM'),(64798329,2,'created_by','JOSM'),(64798331,2,'created_by','JOSM'),(64798333,2,'created_by','JOSM'),(64798335,2,'created_by','JOSM'),(64798336,2,'created_by','JOSM'),(64798337,2,'created_by','JOSM'),(64798339,1,'created_by','JOSM'),(64798342,2,'created_by','JOSM'),(64798343,2,'created_by','JOSM'),(64798344,2,'created_by','JOSM'),(64798345,3,'created_by','JOSM'),(64798347,3,'created_by','JOSM'),(64798350,3,'created_by','JOSM'),(64798351,2,'created_by','JOSM'),(64798352,2,'created_by','JOSM'),(64801605,2,'created_by','JOSM'),(64801639,2,'created_by','JOSM'),(64801640,2,'created_by','JOSM'),(64801644,2,'created_by','JOSM'),(64801645,2,'created_by','JOSM'),(64801646,2,'created_by','JOSM'),(64801648,2,'created_by','JOSM'),(64801651,2,'created_by','JOSM'),(64801652,2,'created_by','JOSM'),(64801654,2,'created_by','JOSM'),(64801657,2,'created_by','JOSM'),(64801659,1,'created_by','JOSM'),(64801660,2,'created_by','JOSM'),(64801663,2,'created_by','JOSM'),(64801667,2,'created_by','JOSM'),(64801670,1,'created_by','JOSM'),(64801672,1,'created_by','JOSM'),(64801673,1,'created_by','JOSM'),(64801675,1,'created_by','JOSM'),(64801678,1,'created_by','JOSM'),(64801679,2,'created_by','JOSM'),(64801681,2,'created_by','JOSM'),(64801684,1,'created_by','JOSM'),(64801685,1,'created_by','JOSM'),(64801686,1,'created_by','JOSM'),(64801688,1,'created_by','JOSM'),(64801690,1,'created_by','JOSM'),(64801693,2,'created_by','JOSM'),(64801694,2,'created_by','JOSM'),(64801695,1,'created_by','JOSM'),(64801697,1,'created_by','JOSM'),(64801702,1,'created_by','JOSM'),(64801703,1,'created_by','JOSM'),(64801704,1,'created_by','JOSM'),(64801705,1,'created_by','JOSM'),(64801709,1,'created_by','JOSM'),(64801710,1,'created_by','JOSM'),(64801711,1,'created_by','JOSM'),(64801712,1,'created_by','JOSM'),(64801714,1,'created_by','JOSM'),(64801717,1,'created_by','JOSM'),(64801718,2,'created_by','JOSM'),(64801719,2,'created_by','JOSM'),(64801721,2,'created_by','JOSM'),(64801724,2,'created_by','JOSM'),(64801725,2,'created_by','JOSM'),(64801729,1,'created_by','JOSM'),(64801739,1,'created_by','JOSM'),(64801740,2,'created_by','JOSM'),(64801741,2,'created_by','JOSM'),(64801745,2,'created_by','JOSM'),(64801746,2,'created_by','JOSM'),(64801747,2,'created_by','JOSM'),(64801748,2,'created_by','JOSM'),(64801751,2,'created_by','JOSM'),(64801753,2,'created_by','JOSM'),(64801754,1,'created_by','JOSM'),(64801758,1,'created_by','JOSM'),(64801759,1,'created_by','JOSM'),(64801761,1,'created_by','JOSM'),(64801762,1,'created_by','JOSM'),(64801766,1,'created_by','JOSM'),(64801770,1,'created_by','JOSM'),(64801773,1,'created_by','JOSM'),(64801774,1,'created_by','JOSM'),(64801778,1,'created_by','JOSM'),(64801779,1,'created_by','JOSM'),(64801780,1,'created_by','JOSM'),(64801785,1,'created_by','JOSM'),(64801795,1,'created_by','JOSM'),(64801802,1,'created_by','JOSM'),(64801803,1,'created_by','JOSM'),(64801804,1,'created_by','JOSM'),(64801805,1,'created_by','JOSM'),(64801809,1,'created_by','JOSM'),(64801810,1,'created_by','JOSM'),(64801811,1,'created_by','JOSM'),(64801812,1,'created_by','JOSM'),(64801816,1,'created_by','JOSM'),(64801817,1,'created_by','JOSM'),(64801818,1,'created_by','JOSM'),(64801819,1,'created_by','JOSM'),(64803147,1,'created_by','JOSM'),(64803150,1,'created_by','JOSM'),(64803152,1,'created_by','JOSM'),(64803153,1,'created_by','JOSM'),(64803154,1,'created_by','JOSM'),(64803157,1,'created_by','JOSM'),(64803159,1,'created_by','JOSM'),(64803160,1,'created_by','JOSM'),(64803161,1,'created_by','JOSM'),(64803162,1,'created_by','JOSM'),(64803165,1,'created_by','JOSM'),(64803167,1,'created_by','JOSM'),(64803168,1,'created_by','JOSM'),(64803169,1,'created_by','JOSM'),(64803172,1,'created_by','JOSM'),(64803174,1,'created_by','JOSM'),(64803175,1,'created_by','JOSM'),(64803176,1,'created_by','JOSM'),(64803177,1,'created_by','JOSM'),(64803180,1,'created_by','JOSM'),(64803182,1,'created_by','JOSM'),(64803183,1,'created_by','JOSM'),(64803184,1,'created_by','JOSM'),(64803185,1,'created_by','JOSM'),(64803188,1,'created_by','JOSM'),(64803190,1,'created_by','JOSM'),(64803191,1,'created_by','JOSM'),(64803192,1,'created_by','JOSM'),(64803195,1,'created_by','JOSM'),(64803197,1,'created_by','JOSM'),(64803198,1,'created_by','JOSM'),(64803199,1,'created_by','JOSM'),(64840709,1,'created_by','JOSM'),(64840717,1,'created_by','JOSM'),(64840721,1,'created_by','JOSM'),(64840726,1,'created_by','JOSM'),(64840730,1,'created_by','JOSM'),(64840732,1,'created_by','JOSM'),(64840738,1,'created_by','JOSM'),(64840741,1,'created_by','JOSM'),(64840744,1,'created_by','JOSM'),(64840746,1,'created_by','JOSM'),(64840750,1,'created_by','JOSM'),(64840753,1,'created_by','JOSM'),(64840755,1,'created_by','JOSM'),(64840758,1,'created_by','JOSM'),(64840759,1,'created_by','JOSM'),(64840761,1,'created_by','JOSM'),(64840762,1,'created_by','JOSM'),(64840767,1,'created_by','JOSM'),(64840769,1,'created_by','JOSM'),(64840773,1,'created_by','JOSM'),(64840778,1,'created_by','JOSM'),(64840781,1,'created_by','JOSM'),(64840785,1,'created_by','JOSM'),(64840790,1,'created_by','JOSM'),(64840792,1,'created_by','JOSM'),(64840793,1,'created_by','JOSM'),(64840797,1,'created_by','JOSM'),(64840799,1,'created_by','JOSM'),(64840802,1,'created_by','JOSM'),(64840806,1,'created_by','JOSM'),(64840812,1,'created_by','JOSM'),(64840816,1,'created_by','JOSM'),(64840820,1,'created_by','JOSM'),(64840823,1,'created_by','JOSM'),(64840828,1,'created_by','JOSM'),(64840832,1,'created_by','JOSM'),(64840836,1,'created_by','JOSM'),(64840839,1,'created_by','JOSM'),(64840843,1,'created_by','JOSM'),(64840848,1,'created_by','JOSM'),(64840849,1,'created_by','JOSM'),(64840854,1,'created_by','JOSM'),(64840858,1,'created_by','JOSM'),(64840861,1,'created_by','JOSM'),(64840865,1,'created_by','JOSM'),(64840868,1,'created_by','JOSM'),(64840872,1,'created_by','JOSM'),(64840877,1,'created_by','JOSM'),(64840882,1,'created_by','JOSM'),(64840886,1,'created_by','JOSM'),(64840890,1,'created_by','JOSM'),(64840895,1,'created_by','JOSM'),(64840899,1,'created_by','JOSM'),(64840903,1,'created_by','JOSM'),(64840907,1,'created_by','JOSM'),(64840911,1,'created_by','JOSM'),(64840916,1,'created_by','JOSM'),(64840918,1,'created_by','JOSM'),(64840922,1,'created_by','JOSM'),(64840923,1,'created_by','JOSM'),(64840926,1,'created_by','JOSM'),(64840929,1,'created_by','JOSM'),(64840932,1,'created_by','JOSM'),(64840933,1,'created_by','JOSM'),(64840934,1,'created_by','JOSM'),(64840936,1,'created_by','JOSM'),(64840940,1,'created_by','JOSM'),(64840946,1,'created_by','JOSM'),(64840950,1,'created_by','JOSM'),(64840954,1,'created_by','JOSM'),(64840959,1,'created_by','JOSM'),(64840961,1,'created_by','JOSM'),(64840965,1,'created_by','JOSM'),(64840968,1,'created_by','JOSM'),(64840971,1,'created_by','JOSM'),(64840975,1,'created_by','JOSM'),(64840979,1,'created_by','JOSM'),(64840982,1,'created_by','JOSM'),(64840985,1,'created_by','JOSM'),(64840987,1,'created_by','JOSM'),(64840992,1,'created_by','JOSM'),(64840996,1,'created_by','JOSM'),(64840997,1,'created_by','JOSM'),(64840998,1,'created_by','JOSM'),(64841000,1,'created_by','JOSM'),(64841005,1,'created_by','JOSM'),(64841007,1,'created_by','JOSM'),(64841008,1,'created_by','JOSM'),(64841013,1,'created_by','JOSM'),(64841018,1,'created_by','JOSM'),(64841023,1,'created_by','JOSM'),(64841026,1,'created_by','JOSM'),(64841028,1,'created_by','JOSM'),(64841033,1,'created_by','JOSM'),(64841037,1,'created_by','JOSM'),(64841039,1,'created_by','JOSM'),(64841042,1,'created_by','JOSM'),(64841046,1,'created_by','JOSM'),(64841049,1,'created_by','JOSM'),(64841051,1,'created_by','JOSM'),(64841053,1,'created_by','JOSM'),(64841057,1,'created_by','JOSM'),(64841061,1,'created_by','JOSM'),(64841066,1,'created_by','JOSM'),(64841070,1,'created_by','JOSM'),(64841074,1,'created_by','JOSM'),(64841080,1,'created_by','JOSM'),(64841084,1,'created_by','JOSM'),(64841088,1,'created_by','JOSM'),(64841091,1,'created_by','JOSM'),(64841092,1,'created_by','JOSM'),(64841094,1,'created_by','JOSM'),(64841097,1,'created_by','JOSM'),(64841099,1,'created_by','JOSM'),(64841100,1,'created_by','JOSM'),(64841101,1,'created_by','JOSM'),(64841105,1,'created_by','JOSM'),(64841106,1,'created_by','JOSM'),(64841108,1,'created_by','JOSM'),(64841109,1,'created_by','JOSM'),(64841113,1,'created_by','JOSM'),(64841115,1,'created_by','JOSM'),(64841118,1,'created_by','JOSM'),(64841119,1,'created_by','JOSM'),(64841120,1,'created_by','JOSM'),(64841123,1,'created_by','JOSM'),(64841125,1,'created_by','JOSM'),(64841128,1,'created_by','JOSM'),(64841129,1,'created_by','JOSM'),(64841132,1,'created_by','JOSM'),(64841134,1,'created_by','JOSM'),(64841136,1,'created_by','JOSM'),(64841139,1,'created_by','JOSM'),(64841145,1,'created_by','JOSM'),(64841148,1,'created_by','JOSM'),(64841151,1,'created_by','JOSM'),(64841154,1,'created_by','JOSM'),(64841158,1,'created_by','JOSM'),(64841162,1,'created_by','JOSM'),(64841165,1,'created_by','JOSM'),(64841166,1,'created_by','JOSM'),(64841169,1,'created_by','JOSM'),(64841177,1,'created_by','JOSM'),(64841180,1,'created_by','JOSM'),(64841183,1,'created_by','JOSM'),(64841185,1,'created_by','JOSM'),(64841188,1,'created_by','JOSM'),(64841191,1,'created_by','JOSM'),(64841194,1,'created_by','JOSM'),(64841197,1,'created_by','JOSM'),(64841198,1,'created_by','JOSM'),(64841202,1,'created_by','JOSM'),(64841205,1,'created_by','JOSM'),(64841208,1,'created_by','JOSM'),(64841211,1,'created_by','JOSM'),(64841215,1,'created_by','JOSM'),(64841220,1,'created_by','JOSM'),(64841224,1,'created_by','JOSM'),(64841229,1,'created_by','JOSM'),(64841233,1,'created_by','JOSM'),(64841236,1,'created_by','JOSM'),(64841238,1,'created_by','JOSM'),(64841243,1,'created_by','JOSM'),(64841245,1,'created_by','JOSM'),(64841248,1,'created_by','JOSM'),(64841254,1,'created_by','JOSM'),(64841257,1,'created_by','JOSM'),(64841260,1,'created_by','JOSM'),(64841263,1,'created_by','JOSM'),(64841266,1,'created_by','JOSM'),(64841268,1,'created_by','JOSM'),(64841271,1,'created_by','JOSM'),(64841274,1,'created_by','JOSM'),(64841278,1,'created_by','JOSM'),(64841281,1,'created_by','JOSM'),(64841282,1,'created_by','JOSM'),(64841286,1,'created_by','JOSM'),(64841290,1,'created_by','JOSM'),(64841293,1,'created_by','JOSM'),(64841297,1,'created_by','JOSM'),(64841301,1,'created_by','JOSM'),(64841307,1,'created_by','JOSM'),(64841311,1,'created_by','JOSM'),(64841315,1,'created_by','JOSM'),(64841316,1,'created_by','JOSM'),(64841319,1,'created_by','JOSM'),(64841321,1,'created_by','JOSM'),(64841324,1,'created_by','JOSM'),(64841329,1,'created_by','JOSM'),(64841333,1,'created_by','JOSM'),(64841337,1,'created_by','JOSM'),(64841341,1,'created_by','JOSM'),(64841344,1,'created_by','JOSM'),(64841346,1,'created_by','JOSM'),(64841351,1,'created_by','JOSM'),(64841356,1,'created_by','JOSM'),(64841360,1,'created_by','JOSM'),(64841365,2,'created_by','JOSM'),(64841367,2,'created_by','JOSM'),(64841370,1,'created_by','JOSM'),(64841373,2,'created_by','JOSM'),(64841375,1,'created_by','JOSM'),(64841376,1,'created_by','JOSM'),(64841379,1,'created_by','JOSM'),(64841383,1,'created_by','JOSM'),(64841386,3,'created_by','JOSM'),(64841388,2,'created_by','JOSM'),(64841390,1,'created_by','JOSM'),(64841393,1,'created_by','JOSM'),(64841396,2,'created_by','JOSM'),(64841399,2,'created_by','JOSM'),(64841407,2,'created_by','JOSM'),(64841415,1,'created_by','JOSM'),(64841424,1,'created_by','JOSM'),(64841431,2,'created_by','JOSM'),(64841433,2,'created_by','JOSM'),(64841434,4,'created_by','JOSM'),(64841436,1,'created_by','JOSM'),(64841439,2,'created_by','JOSM'),(64841441,2,'created_by','JOSM'),(64841444,2,'created_by','JOSM'),(64841446,2,'created_by','JOSM'),(64841451,2,'created_by','JOSM'),(64841452,2,'created_by','JOSM'),(64841454,2,'created_by','JOSM'),(64841456,1,'created_by','JOSM'),(64841461,1,'created_by','JOSM'),(64841463,2,'created_by','JOSM'),(64841468,2,'created_by','JOSM'),(64841472,1,'created_by','JOSM'),(64841473,1,'created_by','JOSM'),(64841478,1,'created_by','JOSM'),(64841481,1,'created_by','JOSM'),(64841483,1,'created_by','JOSM'),(64841487,2,'created_by','JOSM'),(64841488,1,'created_by','JOSM'),(64841491,1,'created_by','JOSM'),(64841497,1,'created_by','JOSM'),(64841499,1,'created_by','JOSM'),(64841502,1,'created_by','JOSM'),(64841507,1,'created_by','JOSM'),(64841511,1,'created_by','JOSM'),(64841514,1,'created_by','JOSM'),(64841518,1,'created_by','JOSM'),(64841521,1,'created_by','JOSM'),(64841525,1,'created_by','JOSM'),(64841529,2,'created_by','JOSM'),(64841532,2,'created_by','JOSM'),(64841537,2,'created_by','JOSM'),(64841541,1,'created_by','JOSM'),(64841547,1,'created_by','JOSM'),(64841550,1,'created_by','JOSM'),(64841551,1,'created_by','JOSM'),(64841553,1,'created_by','JOSM'),(64841557,1,'created_by','JOSM'),(64841561,1,'created_by','JOSM'),(64841566,1,'created_by','JOSM'),(64841570,1,'created_by','JOSM'),(64841573,1,'created_by','JOSM'),(64841579,1,'created_by','JOSM'),(64841582,2,'created_by','JOSM'),(64841584,1,'created_by','JOSM'),(64841587,1,'created_by','JOSM'),(64841591,1,'created_by','JOSM'),(64841597,1,'created_by','JOSM'),(64841600,1,'created_by','JOSM'),(64841603,1,'created_by','JOSM'),(64841606,1,'created_by','JOSM'),(64841612,1,'created_by','JOSM'),(64841617,1,'created_by','JOSM'),(64841620,1,'created_by','JOSM'),(64841623,1,'created_by','JOSM'),(64841627,2,'created_by','JOSM'),(64841630,1,'created_by','JOSM'),(64841635,2,'created_by','JOSM'),(64841638,1,'created_by','JOSM'),(64841640,1,'created_by','JOSM'),(64841645,1,'created_by','JOSM'),(64841649,1,'created_by','JOSM'),(64841652,1,'created_by','JOSM'),(64841654,1,'created_by','JOSM'),(64954372,4,'created_by','JOSM'),(64954372,4,'gns:ADM1','00'),(64954372,4,'gns:N:xx:FULL_NAME','Aixàs'),(64954372,4,'gns:N:xx:FULL_NAME_ND','Aixas'),(64954372,4,'gns:N:xx:NT','N'),(64954372,4,'gns:N:xx:SORT_NAME','AIXAS'),(64954372,4,'gns:RC','1'),(64954372,4,'gns:UFI','-1394392'),(64954372,4,'gns:UNI','-2001996'),(64954372,4,'name','Aixàs'),(64954372,4,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954372,4,'place','hamlet'),(64954372,4,'source','gns_an'),(64954377,6,'created_by','Potlatch 0.10f'),(64954377,6,'gns:ADM1','00'),(64954377,6,'gns:N:xx:FULL_NAME','Aubinyà'),(64954377,6,'gns:N:xx:FULL_NAME_ND','Aubinya'),(64954377,6,'gns:N:xx:NT','N'),(64954377,6,'gns:N:xx:SORT_NAME','AUBINYA'),(64954377,6,'gns:RC','1'),(64954377,6,'gns:UFI','-1394528'),(64954377,6,'gns:UNI','-2002172'),(64954377,6,'gns:V:xx:FULL_NAME','Auvinya'),(64954377,6,'gns:V:xx:FULL_NAME_ND','Auvinya'),(64954377,6,'gns:V:xx:MODIFY_DATE','1993-12-23'),(64954377,6,'gns:V:xx:NT','V'),(64954377,6,'gns:V:xx:SORT_NAME','AUVINYA'),(64954377,6,'name','Aubinyà'),(64954377,6,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954377,6,'place','village'),(64954377,6,'source','gns_an'),(64954382,5,'created_by','Potlatch 0.8a'),(64954382,5,'gns:ADM1','00'),(64954382,5,'gns:N:xx:FULL_NAME','Juberri'),(64954382,5,'gns:N:xx:FULL_NAME_ND','Juberri'),(64954382,5,'gns:N:xx:NT','N'),(64954382,5,'gns:N:xx:SORT_NAME','JUBERRI'),(64954382,5,'gns:RC','1'),(64954382,5,'gns:UFI','-1395814'),(64954382,5,'gns:UNI','-2003564'),(64954382,5,'gns:V:xx:FULL_NAME','Juverri'),(64954382,5,'gns:V:xx:FULL_NAME_ND','Juverri'),(64954382,5,'gns:V:xx:NT','V');
INSERT INTO `node_tags` VALUES (64954382,5,'gns:V:xx:SORT_NAME','JUVERRI'),(64954382,5,'name','Juberri'),(64954382,5,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954382,5,'place','village'),(64954382,5,'source','gns_an'),(64954385,6,'created_by','Potlatch 0.8a'),(64954385,6,'gns:ADM1','00'),(64954385,6,'gns:N:xx:FULL_NAME','Nagol'),(64954385,6,'gns:N:xx:FULL_NAME_ND','Nagol'),(64954385,6,'gns:N:xx:NT','N'),(64954385,6,'gns:N:xx:SORT_NAME','NAGOL'),(64954385,6,'gns:RC','1'),(64954385,6,'gns:UFI','-1396263'),(64954385,6,'gns:UNI','-2004023'),(64954385,6,'name','Nagol'),(64954385,6,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954385,6,'place','village'),(64954385,6,'source','gns_an'),(64954389,7,'created_by','Potlatch 0.10f'),(64954389,7,'gns:ADM1','00'),(64954389,7,'gns:N:xx:FULL_NAME','Anyós'),(64954389,7,'gns:N:xx:FULL_NAME_ND','Anyos'),(64954389,7,'gns:N:xx:NT','N'),(64954389,7,'gns:N:xx:SORT_NAME','ANYOS'),(64954389,7,'gns:RC','1'),(64954389,7,'gns:UFI','-1394459'),(64954389,7,'gns:UNI','-2002089'),(64954389,7,'name','Anyós'),(64954389,7,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954389,7,'place','hamlet'),(64954389,7,'source','gns_an'),(64954396,6,'created_by','Potlatch 0.8a'),(64954396,6,'gns:ADM1','00'),(64954396,6,'gns:N:xx:FULL_NAME','Els Vilars'),(64954396,6,'gns:N:xx:FULL_NAME_ND','Els Vilars'),(64954396,6,'gns:N:xx:NT','N'),(64954396,6,'gns:N:xx:SORT_NAME','ELSVILARS'),(64954396,6,'gns:RC','1'),(64954396,6,'gns:UFI','-1395318'),(64954396,6,'gns:UNI','-2003021'),(64954396,6,'name','Els Vilars'),(64954396,6,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954396,6,'place','hamlet'),(64954396,6,'source','gns_an'),(64954400,5,'created_by','JOSM'),(64954400,5,'gns:ADM1','00'),(64954400,5,'gns:N:xx:FULL_NAME','Bixessarri'),(64954400,5,'gns:N:xx:FULL_NAME_ND','Bixessarri'),(64954400,5,'gns:N:xx:NT','N'),(64954400,5,'gns:N:xx:SORT_NAME','BIXESSARRI'),(64954400,5,'gns:RC','1'),(64954400,5,'gns:UFI','-1394629'),(64954400,5,'gns:UNI','-2005085'),(64954400,5,'gns:V:xx:FULL_NAME','Vixesarri'),(64954400,5,'gns:V:xx:FULL_NAME_ND','Vixesarri'),(64954400,5,'gns:V:xx:MODIFY_DATE','1993-12-23'),(64954400,5,'gns:V:xx:NT','V'),(64954400,5,'gns:V:xx:SORT_NAME','VIXESARRI'),(64954400,5,'name','Bixessarri'),(64954400,5,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954400,5,'place','village'),(64954400,5,'source','gns_an'),(64954404,7,'created_by','Potlatch 0.8a'),(64954404,7,'gns:ADM1','00'),(64954404,7,'gns:N:xx:FULL_NAME','El Tarter'),(64954404,7,'gns:N:xx:FULL_NAME_ND','El Tarter'),(64954404,7,'gns:N:xx:NT','N'),(64954404,7,'gns:N:xx:SORT_NAME','ELTARTER'),(64954404,7,'gns:RC','1'),(64954404,7,'gns:UFI','-1395312'),(64954404,7,'gns:UNI','-2003015'),(64954404,7,'name','El Tarter'),(64954404,7,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954404,7,'place','village'),(64954404,7,'source','gns_an'),(64954409,6,'created_by','Potlatch 0.8a'),(64954409,6,'gns:ADM1','00'),(64954409,6,'gns:N:xx:FULL_NAME','Prats'),(64954409,6,'gns:N:xx:FULL_NAME_ND','Prats'),(64954409,6,'gns:N:xx:NT','N'),(64954409,6,'gns:N:xx:SORT_NAME','PRATS'),(64954409,6,'gns:RC','1'),(64954409,6,'gns:UFI','-1396638'),(64954409,6,'gns:UNI','-2004442'),(64954409,6,'name','Prats'),(64954409,6,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954409,6,'place','village'),(64954409,6,'source','gns_an'),(64954415,5,'created_by','Potlatch 0.9c'),(64954415,5,'gns:ADM1','00'),(64954415,5,'gns:N:xx:FULL_NAME','Sispony'),(64954415,5,'gns:N:xx:FULL_NAME_ND','Sispony'),(64954415,5,'gns:N:xx:NT','N'),(64954415,5,'gns:N:xx:SORT_NAME','SISPONY'),(64954415,5,'gns:RC','1'),(64954415,5,'gns:UFI','-1396951'),(64954415,5,'gns:UNI','-2004800'),(64954415,5,'name','Sispony'),(64954415,5,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954415,5,'place','hamlet'),(64954415,5,'source','gns_an'),(64954417,5,'created_by','Potlatch 0.8a'),(64954417,5,'gns:ADM1','00'),(64954417,5,'gns:N:xx:FULL_NAME','Els Plans'),(64954417,5,'gns:N:xx:FULL_NAME_ND','Els Plans'),(64954417,5,'gns:N:xx:NT','N'),(64954417,5,'gns:N:xx:SORT_NAME','ELSPLANS'),(64954417,5,'gns:RC','1'),(64954417,5,'gns:UFI','-1395303'),(64954417,5,'gns:UNI','-2003006'),(64954417,5,'name','Els Plans'),(64954417,5,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954417,5,'place','hamlet'),(64954417,5,'source','gns_an'),(64954422,6,'created_by','Potlatch 0.8a'),(64954422,6,'gns:ADM1','00'),(64954422,6,'gns:N:xx:FULL_NAME','L’Aldosa'),(64954422,6,'gns:N:xx:FULL_NAME_ND','L\'Aldosa'),(64954422,6,'gns:N:xx:NT','N'),(64954422,6,'gns:N:xx:SORT_NAME','LALDOSA'),(64954422,6,'gns:RC','1'),(64954422,6,'gns:UFI','-1395874'),(64954422,6,'gns:UNI','-2003610'),(64954422,6,'name','L’Aldosa de Canillo'),(64954422,6,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954422,6,'place','hamlet'),(64954422,6,'source','gns_an'),(64954429,6,'created_by','Potlatch 0.8a'),(64954429,6,'gns:ADM1','00'),(64954429,6,'gns:N:xx:FULL_NAME','Sant Pere'),(64954429,6,'gns:N:xx:FULL_NAME_ND','Sant Pere'),(64954429,6,'gns:N:xx:NT','N'),(64954429,6,'gns:N:xx:SORT_NAME','SANTPERE'),(64954429,6,'gns:RC','1'),(64954429,6,'gns:UFI','-1396873'),(64954429,6,'gns:UNI','-2004705'),(64954429,6,'name','Sant Pere'),(64954429,6,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954429,6,'place','village'),(64954429,6,'source','gns_an'),(64954433,6,'created_by','Potlatch 0.8a'),(64954433,6,'gns:N:xx:FULL_NAME','Canillo'),(64954433,6,'gns:N:xx:FULL_NAME_ND','Canillo'),(64954433,6,'name','Canillo'),(64954433,6,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954433,6,'place','town'),(64954433,6,'source','gns_an'),(64954435,8,'created_by','Potlatch 0.9a'),(64954435,8,'gns:ADM1','00'),(64954435,8,'gns:N:xx:FULL_NAME','Sornás'),(64954435,8,'gns:N:xx:FULL_NAME_ND','Sornas'),(64954435,8,'gns:N:xx:NT','N'),(64954435,8,'gns:N:xx:SORT_NAME','SORNAS'),(64954435,8,'gns:RC','1'),(64954435,8,'gns:UFI','-1397041'),(64954435,8,'gns:UNI','-2004894'),(64954435,8,'name','Sornás'),(64954435,8,'note','Experimental import of Andorrian places and POIs from GNS Dataset - corrected by user 3ld'),(64954435,8,'place','village'),(64954435,8,'source','gns_an'),(64954441,5,'created_by','Potlatch 0.8c'),(64954441,5,'gns:ADM1','00'),(64954441,5,'gns:N:xx:FULL_NAME','Sant Joan de Caselles'),(64954441,5,'gns:N:xx:FULL_NAME_ND','Sant Joan de Caselles'),(64954441,5,'gns:N:xx:NT','N'),(64954441,5,'gns:N:xx:SORT_NAME','SANTJOANDECASELLES'),(64954441,5,'gns:RC','1'),(64954441,5,'gns:UFI','-1396861'),(64954441,5,'gns:UNI','-2004686'),(64954441,5,'gns:V:xx:FULL_NAME','Sant Joan de Casellas'),(64954441,5,'gns:V:xx:FULL_NAME_ND','Sant Joan de Casellas'),(64954441,5,'gns:V:xx:MODIFY_DATE','1993-12-23'),(64954441,5,'gns:V:xx:NT','V'),(64954441,5,'gns:V:xx:SORT_NAME','SANTJOANDECASELLAS'),(64954441,5,'name','Sant Joan de Caselles'),(64954441,5,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954441,5,'place','hamlet'),(64954441,5,'source','gns_an'),(64954447,7,'created_by','Potlatch 0.9c'),(64954447,7,'gns:ADM1','00'),(64954447,7,'gns:N:xx:FULL_NAME','L’Aldosa'),(64954447,7,'gns:N:xx:FULL_NAME_ND','L\'Aldosa'),(64954447,7,'gns:N:xx:NT','N'),(64954447,7,'gns:N:xx:SORT_NAME','LALDOSA'),(64954447,7,'gns:RC','1'),(64954447,7,'gns:UFI','-1395873'),(64954447,7,'gns:UNI','-2003609'),(64954447,7,'name','L’Aldosa'),(64954447,7,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954447,7,'place','hamlet'),(64954447,7,'source','gns_an'),(64954451,5,'created_by','Potlatch 0.8a'),(64954451,5,'gns:ADM1','00'),(64954451,5,'gns:N:xx:FULL_NAME','El Serrat'),(64954451,5,'gns:N:xx:FULL_NAME_ND','El Serrat'),(64954451,5,'gns:N:xx:NT','N'),(64954451,5,'gns:N:xx:SORT_NAME','ELSERRAT'),(64954451,5,'gns:RC','1'),(64954451,5,'gns:UFI','-1395275'),(64954451,5,'gns:UNI','-2003810'),(64954451,5,'gns:V:xx:FULL_NAME','Lo Serrat'),(64954451,5,'gns:V:xx:FULL_NAME_ND','Lo Serrat'),(64954451,5,'gns:V:xx:MODIFY_DATE','1993-12-23'),(64954451,5,'gns:V:xx:NT','V'),(64954451,5,'gns:V:xx:SORT_NAME','LOSERRAT'),(64954451,5,'name','El Serrat'),(64954451,5,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954451,5,'place','village'),(64954451,5,'source','gns_an'),(64954457,7,'created_by','Potlatch 0.8a'),(64954457,7,'gns:ADM1','00'),(64954457,7,'gns:N:xx:FULL_NAME','Ransol'),(64954457,7,'gns:N:xx:FULL_NAME_ND','Ransol'),(64954457,7,'gns:N:xx:NT','N'),(64954457,7,'gns:N:xx:SORT_NAME','RANSOL'),(64954457,7,'gns:RC','1'),(64954457,7,'gns:UFI','-1396705'),(64954457,7,'gns:UNI','-2004518'),(64954457,7,'name','Ransol'),(64954457,7,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954457,7,'place','village'),(64954457,7,'source','gns_an'),(64954460,7,'created_by','Potlatch 0.9a'),(64954460,7,'gns:ADM1','00'),(64954460,7,'gns:N:xx:FULL_NAME','El Pui'),(64954460,7,'gns:N:xx:FULL_NAME_ND','El Pui'),(64954460,7,'gns:N:xx:NT','N'),(64954460,7,'gns:N:xx:SORT_NAME','ELPUI'),(64954460,7,'gns:RC','1'),(64954460,7,'gns:UFI','-1395245'),(64954460,7,'gns:UNI','-2002947'),(64954460,7,'name','El Pui'),(64954460,7,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954460,7,'place','hamlet'),(64954460,7,'source','gns_an'),(64954464,5,'created_by','Potlatch 0.10b'),(64954464,5,'gns:ADM1','00'),(64954464,5,'gns:N:xx:FULL_NAME','Vila'),(64954464,5,'gns:N:xx:FULL_NAME_ND','Vila'),(64954464,5,'gns:N:xx:NT','N'),(64954464,5,'gns:N:xx:SORT_NAME','VILA'),(64954464,5,'gns:RC','1'),(64954464,5,'gns:UFI','-1397198'),(64954464,5,'gns:UNI','-2005072'),(64954464,5,'gns:V:xx:FULL_NAME','Casas Vila'),(64954464,5,'gns:V:xx:FULL_NAME_ND','Casas Vila'),(64954464,5,'gns:V:xx:MODIFY_DATE','1993-12-23'),(64954464,5,'gns:V:xx:NT','V'),(64954464,5,'gns:V:xx:SORT_NAME','CASASVILA'),(64954464,5,'name','Vila'),(64954464,5,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954464,5,'place','village'),(64954464,5,'source','gns_an'),(64954467,6,'created_by','Potlatch 0.9c'),(64954467,6,'gns:ADM1','00'),(64954467,6,'gns:N:xx:FULL_NAME','Erts'),(64954467,6,'gns:N:xx:FULL_NAME_ND','Erts'),(64954467,6,'gns:N:xx:SORT_NAME','ERTS'),(64954467,6,'gns:RC','1'),(64954467,6,'gns:UFI','-1395403'),(64954467,6,'gns:UNI','-2003119'),(64954467,6,'gns:V:xx:FULL_NAME','Erez'),(64954467,6,'gns:V:xx:FULL_NAME_ND','Erez'),(64954467,6,'gns:V:xx:MODIFY_DATE','1993-12-23'),(64954467,6,'gns:V:xx:SORT_NAME','EREZ'),(64954467,6,'name','Erts'),(64954467,6,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954467,6,'place','village'),(64954467,6,'source','gns_an'),(64954472,8,'created_by','Potlatch 0.9a'),(64954472,8,'gns:ADM1','00'),(64954472,8,'gns:N:xx:FULL_NAME','Ansalonga'),(64954472,8,'gns:N:xx:FULL_NAME_ND','Ansalonga'),(64954472,8,'gns:N:xx:NT','N'),(64954472,8,'gns:N:xx:SORT_NAME','ANSALONGA'),(64954472,8,'gns:RC','1'),(64954472,8,'gns:UFI','-1394456'),(64954472,8,'gns:UNI','-2002086'),(64954472,8,'name','Ansalonga'),(64954472,8,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954472,8,'place','village'),(64954472,8,'source','gns_an'),(64954477,5,'created_by','Potlatch 0.8a'),(64954477,5,'gns:ADM1','00'),(64954477,5,'gns:N:xx:FULL_NAME','Engordany'),(64954477,5,'gns:N:xx:FULL_NAME_ND','Engordany'),(64954477,5,'gns:N:xx:NT','N'),(64954477,5,'gns:N:xx:SORT_NAME','ENGORDANY'),(64954477,5,'gns:RC','1'),(64954477,5,'gns:UFI','-1395364'),(64954477,5,'gns:UNI','-2003073'),(64954477,5,'name','Engordany'),(64954477,5,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954477,5,'place','village'),(64954477,5,'source','gns_an'),(64954483,6,'created_by','Potlatch 0.10f'),(64954483,6,'gns:ADM1','00'),(64954483,6,'gns:N:xx:FULL_NAME','Arinsal'),(64954483,6,'gns:N:xx:FULL_NAME_ND','Arinsal'),(64954483,6,'gns:N:xx:NT','N'),(64954483,6,'gns:N:xx:SORT_NAME','ARINSAL'),(64954483,6,'gns:RC','1'),(64954483,6,'gns:UFI','-1394484'),(64954483,6,'gns:UNI','-2002121'),(64954483,6,'name','Arinsal'),(64954483,6,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954483,6,'place','village'),(64954483,6,'source','gns_an'),(64954486,7,'created_by','Potlatch 0.8a'),(64954486,7,'gns:N:xx:FULL_NAME_ND','Sant Julia de Loria'),(64954486,7,'gns:V:xx:FULL_NAME','Sant Juliá'),(64954486,7,'gns:V:xx:FULL_NAME_ND','Sant Julia'),(64954486,7,'gns:V:xx:MODIFY_DATE','2004-05-05'),(64954486,7,'name','Sant Julià de Lòria'),(64954486,7,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954486,7,'place','town'),(64954486,7,'source','gns_an'),(64954492,5,'created_by','Potlatch 0.8a'),(64954492,5,'gns:ADM1','00'),(64954492,5,'gns:N:xx:FULL_NAME','Les Bons'),(64954492,5,'gns:N:xx:FULL_NAME_ND','Les Bons'),(64954492,5,'gns:N:xx:NT','N'),(64954492,5,'gns:N:xx:SORT_NAME','LESBONS'),(64954492,5,'gns:RC','1'),(64954492,5,'gns:UFI','-1395948'),(64954492,5,'gns:UNI','-2003690'),(64954492,5,'gns:V:xx:FULL_NAME','Els Bons'),(64954492,5,'gns:V:xx:FULL_NAME_ND','Els Bons'),(64954492,5,'gns:V:xx:MODIFY_DATE','1993-12-23'),(64954492,5,'gns:V:xx:NT','V'),(64954492,5,'gns:V:xx:SORT_NAME','ELSBONS'),(64954492,5,'name','Les Bons'),(64954492,5,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954492,5,'place','hamlet'),(64954492,5,'source','gns_an'),(64954503,4,'created_by','Potlatch 0.9c'),(64954503,4,'gns:ADM1','00'),(64954503,4,'gns:N:xx:FULL_NAME','Puiol del Piu'),(64954503,4,'gns:N:xx:FULL_NAME_ND','Puiol del Piu'),(64954503,4,'gns:N:xx:NT','N'),(64954503,4,'gns:N:xx:SORT_NAME','PUIOLDELPIU'),(64954503,4,'gns:RC','1'),(64954503,4,'gns:UFI','-1396654'),(64954503,4,'gns:UNI','-2004458'),(64954503,4,'name','Puiol del Piu'),(64954503,4,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954503,4,'place','hamlet'),(64954503,4,'source','gns_an'),(64954508,6,'created_by','Potlatch 0.10f'),(64954508,6,'gns:ADM1','00'),(64954508,6,'gns:N:xx:FULL_NAME','Fontaneda'),(64954508,6,'gns:N:xx:FULL_NAME_ND','Fontaneda'),(64954508,6,'gns:N:xx:NT','N'),(64954508,6,'gns:N:xx:SORT_NAME','FONTANEDA'),(64954508,6,'gns:RC','1'),(64954508,6,'gns:UFI','-1395576'),(64954508,6,'gns:UNI','-2003297'),(64954508,6,'name','Fontaneda'),(64954508,6,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954508,6,'place','village'),(64954508,6,'source','gns_an'),(64954512,6,'created_by','Potlatch 0.9c'),(64954512,6,'gns:ADM1','00'),(64954512,6,'gns:N:xx:FULL_NAME','Santa Coloma'),(64954512,6,'gns:N:xx:FULL_NAME_ND','Santa Coloma'),(64954512,6,'gns:N:xx:NT','N'),(64954512,6,'gns:N:xx:SORT_NAME','SANTACOLOMA'),(64954512,6,'gns:RC','1'),(64954512,6,'gns:UFI','-1396846'),(64954512,6,'gns:UNI','-2004669'),(64954512,6,'name','Santa Coloma'),(64954512,6,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954512,6,'place','village'),(64954512,6,'source','gns_an'),(64954515,6,'created_by','Potlatch 0.8a'),(64954515,6,'gns:ADM1','00'),(64954515,6,'gns:N:xx:FULL_NAME','Pal'),(64954515,6,'gns:N:xx:FULL_NAME_ND','Pal'),(64954515,6,'gns:N:xx:NT','N'),(64954515,6,'gns:N:xx:SORT_NAME','PAL'),(64954515,6,'gns:RC','1'),(64954515,6,'gns:UFI','-1396388'),(64954515,6,'gns:UNI','-2004163'),(64954515,6,'name','Pal'),(64954515,6,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954515,6,'place','village'),(64954515,6,'source','gns_an'),(64954521,6,'created_by','Potlatch 0.8a'),(64954521,6,'gns:ADM1','00'),(64954521,6,'gns:N:xx:FULL_NAME','Xixerella'),(64954521,6,'gns:N:xx:FULL_NAME_ND','Xixerella'),(64954521,6,'gns:N:xx:NT','N'),(64954521,6,'gns:N:xx:SORT_NAME','XIXERELLA'),(64954521,6,'gns:RC','1'),(64954521,6,'gns:UFI','-1397214'),(64954521,6,'gns:UNI','-2005091'),(64954521,6,'name','Xixerella'),(64954521,6,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954521,6,'place','village'),(64954521,6,'source','gns_an'),(64954525,5,'created_by','Potlatch 0.8a'),(64954525,5,'gns:ADM1','00'),(64954525,5,'gns:N:xx:FULL_NAME','Aixovall'),(64954525,5,'gns:N:xx:FULL_NAME_ND','Aixovall'),(64954525,5,'gns:N:xx:NT','N'),(64954525,5,'gns:N:xx:SORT_NAME','AIXOVALL'),(64954525,5,'gns:RC','1'),(64954525,5,'gns:UFI','-1394403'),(64954525,5,'gns:UNI','-2002009'),(64954525,5,'name','Aixovall'),(64954525,5,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954525,5,'place','village'),(64954525,5,'source','gns_an'),(64954531,6,'created_by','Potlatch 0.9c'),(64954531,6,'gns:ADM1','00'),(64954531,6,'gns:N:xx:FULL_NAME','Llorts'),(64954531,6,'gns:N:xx:FULL_NAME_ND','Llorts'),(64954531,6,'gns:N:xx:NT','N'),(64954531,6,'gns:N:xx:SORT_NAME','LLORTS'),(64954531,6,'gns:RC','1'),(64954531,6,'gns:UFI','-1396036'),(64954531,6,'gns:UNI','-2003809'),(64954531,6,'gns:V:xx:FULL_NAME','Lors'),(64954531,6,'gns:V:xx:FULL_NAME_ND','Lors'),(64954531,6,'gns:V:xx:MODIFY_DATE','1993-12-23'),(64954531,6,'gns:V:xx:NT','V'),(64954531,6,'gns:V:xx:SORT_NAME','LORS'),(64954531,6,'name','Llorts'),(64954531,6,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954531,6,'place','village'),(64954531,6,'source','gns_an'),(64954538,7,'created_by','Potlatch 0.9c'),(64954538,7,'gns:ADM1','00'),(64954538,7,'gns:N:xx:FULL_NAME','Soldeu'),(64954538,7,'gns:N:xx:FULL_NAME_ND','Soldeu'),(64954538,7,'gns:N:xx:NT','N'),(64954538,7,'gns:N:xx:SORT_NAME','SOLDEU'),(64954538,7,'gns:RC','1'),(64954538,7,'gns:UFI','-1397029'),(64954538,7,'gns:UNI','-2004879'),(64954538,7,'name','Soldeu'),(64954538,7,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954538,7,'place','village'),(64954538,7,'source','gns_an'),(64954542,5,'created_by','Potlatch 0.9c'),(64954542,5,'gns:ADM1','00'),(64954542,5,'gns:N:xx:FULL_NAME','Mas de Ribafeta'),(64954542,5,'gns:N:xx:FULL_NAME_ND','Mas de Ribafeta'),(64954542,5,'gns:N:xx:NT','N'),(64954542,5,'gns:N:xx:SORT_NAME','MASDERIBAFETA'),(64954542,5,'gns:RC','1'),(64954542,5,'gns:UFI','-1396119'),(64954542,5,'gns:UNI','-2003869'),(64954542,5,'name','Mas de Ribafeta'),(64954542,5,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954542,5,'place','hamlet'),(64954542,5,'source','gns_an'),(64954546,8,'created_by','Potlatch 0.9c'),(64954546,8,'gns:ADM1','00'),(64954546,8,'gns:N:xx:FULL_NAME','La Cortinada'),(64954546,8,'gns:N:xx:FULL_NAME_ND','La Cortinada'),(64954546,8,'gns:N:xx:NT','N'),(64954546,8,'gns:N:xx:SORT_NAME','LACORTINADA'),(64954546,8,'gns:RC','1'),(64954546,8,'gns:UFI','-1395860'),(64954546,8,'gns:UNI','-2003596'),(64954546,8,'name','La Cortinada'),(64954546,8,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954546,8,'place','village'),(64954546,8,'source','gns_an'),(64954554,5,'created_by','Potlatch 0.8a'),(64954554,5,'gns:ADM1','00'),(64954554,5,'gns:N:xx:FULL_NAME','Llumeneres'),(64954554,5,'gns:N:xx:FULL_NAME_ND','Llumeneres'),(64954554,5,'gns:N:xx:NT','N'),(64954554,5,'gns:N:xx:SORT_NAME','LLUMENERES'),(64954554,5,'gns:RC','1'),(64954554,5,'gns:UFI','-1396056'),(64954554,5,'gns:UNI','-2003801'),(64954554,5,'name','Llumeneres'),(64954554,5,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954554,5,'place','village'),(64954554,5,'source','gns_an'),(64954560,8,'created_by','Potlatch 0.8c'),(64954560,8,'gns:ADM1','00'),(64954560,8,'gns:N:xx:FULL_NAME','Arans'),(64954560,8,'gns:N:xx:FULL_NAME_ND','Arans'),(64954560,8,'gns:N:xx:NT','N'),(64954560,8,'gns:N:xx:SORT_NAME','ARANS'),(64954560,8,'gns:RC','1'),(64954560,8,'gns:UFI','-1394461'),(64954560,8,'gns:UNI','-2002092'),(64954560,8,'name','Arans'),(64954560,8,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954560,8,'place','village'),(64954560,8,'source','gns_an'),(64954563,8,'created_by','Potlatch 0.8b'),(64954563,8,'gns:ADM1','04'),(64954563,8,'gns:V:xx:FULL_NAME','La Maçana'),(64954563,8,'gns:V:xx:FULL_NAME_ND','La Macana'),(64954563,8,'name','La Massana'),(64954563,8,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954563,8,'place','town'),(64954563,8,'source','gns_an'),(64954565,9,'created_by','Potlatch 0.8c'),(64954565,9,'gns:ADM1','00'),(64954565,9,'gns:N:xx:FULL_NAME','Escàs'),(64954565,9,'gns:N:xx:FULL_NAME_ND','Escas'),(64954565,9,'gns:N:xx:NT','N'),(64954565,9,'gns:N:xx:SORT_NAME','ESCAS'),(64954565,9,'gns:RC','1'),(64954565,9,'gns:UFI','-1395411'),(64954565,9,'gns:UNI','-2003129'),(64954565,9,'name','Escàs'),(64954565,9,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954565,9,'place','hamlet'),(64954565,9,'source','gns_an'),(64954570,6,'created_by','Potlatch 0.9a'),(64954570,6,'gns:ADM1','00'),(64954570,6,'gns:N:xx:FULL_NAME','Segudet'),(64954570,6,'gns:N:xx:FULL_NAME_ND','Segudet'),(64954570,6,'gns:N:xx:NT','N'),(64954570,6,'gns:N:xx:SORT_NAME','SEGUDET'),(64954570,6,'gns:RC','1'),(64954570,6,'gns:UFI','-1396896'),(64954570,6,'gns:UNI','-2004734'),(64954570,6,'name','Segudet'),(64954570,6,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954570,6,'place','village'),(64954570,6,'source','gns_an'),(64954584,4,'created_by','Potlatch 0.8a'),(64954584,4,'gns:ADM1','03'),(64954584,4,'gns:N:xx:FULL_NAME','Encamp'),(64954584,4,'gns:N:xx:FULL_NAME_ND','Encamp'),(64954584,4,'gns:RC','1'),(64954584,4,'gns:UFI','-1395326'),(64954584,4,'gns:UNI','-2003031'),(64954584,4,'name','Encamp'),(64954584,4,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954584,4,'place','town'),(64954584,4,'source','gns_an'),(64954589,7,'created_by','Potlatch 0.8b'),(64954589,7,'gns:ADM1','08'),(64954589,7,'gns:N:xx:FULL_NAME','Les Escaldes'),(64954589,7,'gns:N:xx:FULL_NAME_ND','Les Escaldes'),(64954589,7,'gns:N:xx:NT','N'),(64954589,7,'gns:N:xx:SHORT_FORM','Escaldes'),(64954589,7,'gns:N:xx:SORT_NAME','LESESCALDES'),(64954589,7,'gns:RC','1'),(64954589,7,'gns:UFI','-1395964'),(64954589,7,'gns:UNI','-2003706'),(64954589,7,'gns:V:xx:FULL_NAME','Las Escadas'),(64954589,7,'gns:V:xx:FULL_NAME_ND','Las Escadas'),(64954589,7,'gns:V:xx:MODIFY_DATE','2004-05-05'),(64954589,7,'gns:V:xx:NT','V'),(64954589,7,'gns:V:xx:SORT_NAME','LASESCADAS'),(64954589,7,'name','Les Escaldes'),(64954589,7,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954589,7,'place','town'),(64954589,7,'source','gns_an'),(64954593,7,'created_by','Potlatch 0.8a'),(64954593,7,'gns:ADM1','00'),(64954593,7,'gns:N:xx:FULL_NAME','Aixirivall'),(64954593,7,'gns:N:xx:FULL_NAME_ND','Aixirivall'),(64954593,7,'gns:N:xx:NT','N'),(64954593,7,'gns:N:xx:SORT_NAME','AIXIRIVALL'),(64954593,7,'gns:RC','1'),(64954593,7,'gns:UFI','-1394397'),(64954593,7,'gns:UNI','-2150077'),(64954593,7,'gns:V:xx:FULL_NAME','Eixirivall'),(64954593,7,'gns:V:xx:FULL_NAME_ND','Eixirivall'),(64954593,7,'gns:V:xx:MODIFY_DATE','1993-12-23'),(64954593,7,'gns:V:xx:NT','V'),(64954593,7,'gns:V:xx:SORT_NAME','EIXIRIVALL'),(64954593,7,'name','Aixirivall'),(64954593,7,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954593,7,'place','village'),(64954593,7,'source','gns_an'),(64954598,6,'created_by','Potlatch 0.8a'),(64954598,6,'gns:ADM1','00'),(64954598,6,'gns:N:xx:FULL_NAME','Certers'),(64954598,6,'gns:N:xx:FULL_NAME_ND','Certers'),(64954598,6,'gns:N:xx:NT','N'),(64954598,6,'gns:N:xx:SORT_NAME','CERTERS'),(64954598,6,'gns:RC','1'),(64954598,6,'gns:UFI','-1394910'),(64954598,6,'gns:UNI','-2004772'),(64954598,6,'gns:V:xx:FULL_NAME','Sertes'),(64954598,6,'gns:V:xx:FULL_NAME_ND','Sertes'),(64954598,6,'gns:V:xx:MODIFY_DATE','1993-12-23'),(64954598,6,'gns:V:xx:NT','V'),(64954598,6,'gns:V:xx:SORT_NAME','SERTES'),(64954598,6,'name','Certers'),(64954598,6,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954598,6,'place','village'),(64954598,6,'source','gns_an'),(64954601,6,'created_by','Potlatch 0.8a'),(64954601,6,'gns:ADM1','00'),(64954601,6,'gns:N:xx:FULL_NAME','Meritxell'),(64954601,6,'gns:N:xx:FULL_NAME_ND','Meritxell'),(64954601,6,'gns:N:xx:NT','N'),(64954601,6,'gns:N:xx:SORT_NAME','MERITXELL'),(64954601,6,'gns:RC','1'),(64954601,6,'gns:UFI','-1396155'),(64954601,6,'gns:UNI','-2004711'),(64954601,6,'gns:V:xx:FULL_NAME','Santuari de Meritxell'),(64954601,6,'gns:V:xx:FULL_NAME_ND','Santuari de Meritxell'),(64954601,6,'gns:V:xx:MODIFY_DATE','1993-12-23'),(64954601,6,'gns:V:xx:NT','V'),(64954601,6,'gns:V:xx:SORT_NAME','SANTUARIDEMERITXELL'),(64954601,6,'name','Meritxell'),(64954601,6,'note','Experimental import of Andorrian places and POIs from GNS Dataset'),(64954601,6,'place','village'),(64954601,6,'source','gns_an'),(148874198,48,'capital_city','Andorra la Vella'),(148874198,48,'country_code_iso3166_1_alpha_2','AD'),(148874198,48,'is_in:continent','Europe'),(148874198,48,'name','Andorra'),(148874198,48,'name:ar','??????'),(148874198,48,'name:be','??????'),(148874198,48,'name:bg','??????'),(148874198,48,'name:br','Andorra'),(148874198,48,'name:ca','Andorra'),(148874198,48,'name:el','???????'),(148874198,48,'name:eo','Andoro'),(148874198,48,'name:eu','Andorra'),(148874198,48,'name:fa','??????'),(148874198,48,'name:fi','Andorra'),(148874198,48,'name:fr','Andorre'),(148874198,48,'name:ga','Andóra'),(148874198,48,'name:haw','‘Anakola'),(148874198,48,'name:he','??????'),(148874198,48,'name:hr','Andora'),(148874198,48,'name:hu','Andorra'),(148874198,48,'name:hy','???????'),(148874198,48,'name:is','Andorra'),(148874198,48,'name:it','Andorra'),(148874198,48,'name:ja','????'),(148874198,48,'name:ka','??????'),(148874198,48,'name:ko','???'),(148874198,48,'name:lt','Andora'),(148874198,48,'name:lv','Andora'),(148874198,48,'name:mn','???????'),(148874198,48,'name:oc','Andòrra'),(148874198,48,'name:pl','Andora'),(148874198,48,'name:pt','Andorra'),(148874198,48,'name:ru','???????'),(148874198,48,'name:sco','Andorrae'),(148874198,48,'name:sk','Andorra'),(148874198,48,'name:sl','Andora'),(148874198,48,'name:sv','Andorra'),(148874198,48,'name:tg','???????'),(148874198,48,'name:th','???????????????'),(148874198,48,'name:uk','??????'),(148874198,48,'name:zh','???'),(148874198,48,'name:zh_pinyin','?ndào?r'),(148874198,48,'official_name:cy','Tywysogaeth Andorra'),(148874198,48,'official_name:el','?????????? ??? ????????'),(148874198,48,'official_name:fi','Andorran ruhtinaskunta'),(148874198,48,'official_name:fr','Principauté d\'Andorre'),(148874198,48,'official_name:id','Kepangeranan Andorra'),(148874198,48,'official_name:ja','??????'),(148874198,48,'official_name:la','Principatus Andorrae'),(148874198,48,'official_name:lt','Andoros Kunigaikštyst?'),(148874198,48,'official_name:lv','Andoras Firstiste'),(148874198,48,'official_name:pt','Principado de Andorra'),(148874198,48,'official_name:sk','Andorrské kniežatstvo'),(148874198,48,'official_name:sv','Furstendömet Andorra'),(148874198,48,'official_name:vi','Công qu?c Andorra'),(148874198,48,'place','country'),(148874198,48,'population','94609'),(148874198,48,'wikipedia:fr','Andorre'),(206332846,6,'ele','2408'),(206332846,6,'mountain_pass','yes'),(206332846,6,'name','Port d\'Envalira'),(206332846,6,'wikipedia','http://de.wikipedia.org/wiki/Port_d%E2%80%99Envalira'),(247045686,3,'created_by','JOSM'),(247045688,3,'created_by','JOSM'),(247045690,3,'created_by','JOSM'),(247045691,3,'created_by','JOSM'),(247045693,3,'created_by','JOSM'),(247045695,3,'created_by','JOSM'),(247045696,3,'created_by','JOSM'),(247045698,3,'created_by','JOSM'),(247045700,3,'created_by','JOSM'),(247045701,3,'created_by','JOSM'),(247045703,3,'created_by','JOSM'),(247045712,3,'created_by','JOSM'),(247045718,3,'created_by','JOSM'),(247045724,3,'created_by','JOSM'),(247045732,3,'created_by','JOSM'),(247045739,3,'created_by','JOSM'),(247045741,3,'created_by','JOSM'),(247045742,3,'created_by','JOSM'),(247045744,3,'created_by','JOSM'),(247046008,1,'created_by','JOSM'),(247046009,1,'created_by','JOSM'),(247046010,1,'created_by','JOSM'),(247046011,1,'created_by','JOSM'),(247046012,1,'created_by','JOSM'),(247046013,1,'created_by','JOSM'),(247046014,1,'created_by','JOSM'),(247046015,1,'created_by','JOSM'),(247046016,1,'created_by','JOSM'),(247046017,1,'created_by','JOSM'),(247046018,1,'created_by','JOSM'),(247046019,1,'created_by','JOSM'),(247046020,1,'created_by','JOSM'),(247046021,1,'created_by','JOSM'),(247046022,1,'created_by','JOSM'),(247046023,1,'created_by','JOSM'),(247046024,1,'created_by','JOSM'),(247046025,1,'created_by','JOSM'),(247046026,1,'created_by','JOSM'),(247046027,1,'created_by','JOSM'),(247046028,1,'created_by','JOSM'),(247046029,1,'created_by','JOSM'),(247046030,1,'created_by','JOSM'),(247046031,1,'created_by','JOSM'),(247046032,1,'created_by','JOSM'),(247046033,1,'created_by','JOSM'),(247046034,1,'created_by','JOSM'),(247046035,1,'created_by','JOSM'),(247046036,1,'created_by','JOSM'),(247046037,1,'created_by','JOSM'),(247046038,1,'created_by','JOSM'),(247046039,1,'created_by','JOSM'),(247046040,1,'created_by','JOSM'),(247046041,1,'created_by','JOSM'),(247046042,1,'created_by','JOSM'),(247046043,1,'created_by','JOSM'),(247046044,1,'created_by','JOSM'),(247046045,1,'created_by','JOSM'),(247046046,1,'created_by','JOSM'),(247046047,1,'created_by','JOSM'),(247046048,1,'created_by','JOSM'),(247046072,1,'created_by','JOSM'),(247046073,1,'created_by','JOSM'),(247046074,1,'created_by','JOSM'),(247046075,1,'created_by','JOSM'),(247046076,1,'created_by','JOSM'),(247046077,1,'created_by','JOSM'),(247046078,1,'created_by','JOSM'),(247046079,1,'created_by','JOSM'),(258355185,1,'created_by','Potlatch 0.8a'),(258355185,1,'is_in','La Massana'),(258355185,1,'name','Super Pal'),(258355185,1,'place','hamlet'),(258356188,2,'created_by','Potlatch 0.8a'),(258356188,2,'name','Vallnord: Sector Pal'),(258356188,2,'sport','skiing'),(258356379,1,'created_by','Potlatch 0.8a'),(258356379,1,'name','Vallnord: Sector Arinsal'),(258356379,1,'sport','skiing'),(258357981,1,'created_by','Potlatch 0.8a'),(258357981,1,'name','Vallnord: Sector Arcalis'),(258357981,1,'sport','skiing'),(258361905,3,'created_by','Potlatch 0.8a'),(258361905,3,'is_in','Encamp'),(258361905,3,'name','Grau Roig'),(258361905,3,'place','village'),(258823161,1,'created_by','JOSM'),(259475446,4,'highway','mini_roundabout'),(259476084,1,'amenity','fuel'),(259476084,1,'created_by','Potlatch 0.8b'),(259476084,1,'operator','ESSO'),(260996387,1,'highway','mini_roundabout'),(262464083,4,'highway','traffic_signals'),(262466673,2,'created_by','Potlatch 0.8c'),(262466673,2,'name','el Vilar'),(262466673,2,'place','hamlet'),(262472865,7,'name','Coll d\'Ordino'),(262472865,7,'tourism','viewpoint'),(262473157,5,'created_by','Potlatch 0.9a'),(262473157,5,'description','Looks like Totem Poles'),(262473157,5,'name','Estructures Autogeneradores'),(262473157,5,'tourism','artwork'),(262473680,2,'created_by','Potlatch 0.8c'),(262473680,2,'is_in','Canillo'),(262473680,2,'name','el Forn'),(262473680,2,'place','hamlet'),(262892996,1,'created_by','JOSM'),(262892997,1,'created_by','JOSM'),(262892998,1,'created_by','JOSM'),(262892999,1,'created_by','JOSM'),(262893000,1,'created_by','JOSM'),(262893001,1,'created_by','JOSM'),(262893002,1,'created_by','JOSM'),(262893003,2,'created_by','JOSM'),(264053391,1,'created_by','Potlatch 0.9a'),(264053391,1,'name','Lloc de Repos de Redort'),(264053391,1,'tourism','picnic_site'),(264272401,1,'amenity','parking'),(264331306,2,'highway','speed_camera'),(264465123,1,'created_by','JOSM'),(264465125,5,'created_by','JOSM'),(264465125,5,'highway','mini_roundabout'),(264465126,1,'created_by','JOSM'),(264465127,1,'created_by','JOSM'),(264465128,1,'created_by','JOSM'),(264465129,1,'created_by','JOSM'),(264465130,1,'created_by','JOSM'),(264496511,1,'created_by','Potlatch 0.9a'),(264496511,1,'is_in','la Massana'),(264496511,1,'name','el Cortalet'),(264496511,1,'place','hamlet'),(264496540,1,'created_by','Potlatch 0.9a'),(264496540,1,'is_in','la Massana'),(264496540,1,'name','el Bosquet'),(264496540,1,'place','hamlet'),(264932311,1,'created_by','JOSM'),(264932314,1,'created_by','JOSM'),(264932315,1,'created_by','JOSM'),(264932316,1,'created_by','JOSM'),(264932317,1,'created_by','JOSM'),(264932318,1,'created_by','JOSM'),(264932319,1,'created_by','JOSM'),(264932321,1,'created_by','JOSM'),(264932322,1,'created_by','JOSM'),(264932325,1,'created_by','JOSM'),(264932326,1,'created_by','JOSM'),(264932327,1,'created_by','JOSM'),(264932328,1,'created_by','JOSM'),(264932329,1,'created_by','JOSM'),(264932330,1,'created_by','JOSM'),(264932340,1,'created_by','JOSM'),(264932341,1,'created_by','JOSM'),(264932342,1,'created_by','JOSM'),(264932343,1,'created_by','JOSM'),(264932344,1,'created_by','JOSM'),(264932345,1,'created_by','JOSM'),(264932347,1,'created_by','JOSM'),(264932348,1,'created_by','JOSM'),(264932349,1,'created_by','JOSM'),(264932350,1,'created_by','JOSM'),(264932351,1,'created_by','JOSM'),(264932352,1,'created_by','JOSM'),(264932353,1,'created_by','JOSM'),(264932354,1,'created_by','JOSM'),(264932355,1,'created_by','JOSM'),(264932356,1,'created_by','JOSM'),(264932357,1,'created_by','JOSM'),(264932359,1,'created_by','JOSM'),(264932360,1,'created_by','JOSM'),(264932361,1,'created_by','JOSM'),(264932362,1,'created_by','JOSM'),(264932363,1,'created_by','JOSM'),(264932364,1,'created_by','JOSM'),(264932365,1,'created_by','JOSM'),(264932366,1,'created_by','JOSM'),(264932367,1,'created_by','JOSM'),(264932368,1,'created_by','JOSM'),(264932370,1,'created_by','JOSM'),(264932371,1,'created_by','JOSM'),(264932372,1,'created_by','JOSM'),(264932373,1,'created_by','JOSM'),(264932374,1,'created_by','JOSM'),(264932375,1,'created_by','JOSM'),(264932376,1,'created_by','JOSM'),(264932377,1,'created_by','JOSM'),(264932379,1,'created_by','JOSM'),(264932380,1,'created_by','JOSM'),(264932381,1,'created_by','JOSM'),(264932382,1,'created_by','JOSM'),(264932383,1,'created_by','JOSM'),(264932384,1,'created_by','JOSM'),(264932386,1,'created_by','JOSM'),(264932387,1,'created_by','JOSM'),(264932388,1,'created_by','JOSM'),(264932390,1,'created_by','JOSM'),(264932393,1,'created_by','JOSM'),(264932395,1,'created_by','JOSM'),(264932396,1,'created_by','JOSM'),(264932397,1,'created_by','JOSM'),(264932398,1,'created_by','JOSM'),(264932399,1,'created_by','JOSM'),(264932400,1,'created_by','JOSM'),(264932401,1,'created_by','JOSM'),(264932402,1,'created_by','JOSM'),(264932404,1,'created_by','JOSM'),(264932405,1,'created_by','JOSM'),(264932406,1,'created_by','JOSM'),(264932407,1,'created_by','JOSM'),(264932408,1,'created_by','JOSM'),(264932409,1,'created_by','JOSM'),(264932410,1,'created_by','JOSM'),(264932411,1,'created_by','JOSM'),(264932412,1,'created_by','JOSM'),(264932414,1,'created_by','JOSM'),(264932415,1,'created_by','JOSM'),(264932416,1,'created_by','JOSM'),(264932417,1,'created_by','JOSM'),(264932420,1,'created_by','JOSM'),(264932427,1,'created_by','JOSM'),(264932428,1,'created_by','JOSM'),(264932429,1,'created_by','JOSM'),(264932430,1,'created_by','JOSM'),(264932431,1,'created_by','JOSM'),(264932432,1,'created_by','JOSM'),(264932433,1,'created_by','JOSM'),(264932435,1,'created_by','JOSM'),(264932436,1,'created_by','JOSM'),(264932437,1,'created_by','JOSM'),(264932438,1,'created_by','JOSM'),(264932439,1,'created_by','JOSM'),(264932440,1,'created_by','JOSM'),(264932441,1,'created_by','JOSM'),(264932442,1,'created_by','JOSM'),(264932444,1,'created_by','JOSM'),(264932445,1,'created_by','JOSM'),(264932446,1,'created_by','JOSM'),(264932447,1,'created_by','JOSM'),(264932448,1,'created_by','JOSM'),(264932449,1,'created_by','JOSM'),(264932450,1,'created_by','JOSM'),(264932451,1,'created_by','JOSM'),(264932452,1,'created_by','JOSM'),(264932453,1,'created_by','JOSM'),(264932454,1,'created_by','JOSM'),(264932456,1,'created_by','JOSM'),(264932457,1,'created_by','JOSM'),(264932458,1,'created_by','JOSM'),(264932459,1,'created_by','JOSM'),(264932460,1,'created_by','JOSM'),(264932461,1,'created_by','JOSM'),(264932462,1,'created_by','JOSM'),(264932463,1,'created_by','JOSM'),(264932464,1,'created_by','JOSM'),(264932465,1,'created_by','JOSM'),(264932466,1,'created_by','JOSM'),(264932467,1,'created_by','JOSM'),(264932469,1,'created_by','JOSM'),(264932470,1,'created_by','JOSM'),(264932471,1,'created_by','JOSM'),(264932472,1,'created_by','JOSM'),(264932473,1,'created_by','JOSM'),(264932474,1,'created_by','JOSM'),(264932475,1,'created_by','JOSM'),(264932476,1,'created_by','JOSM'),(264932477,1,'created_by','JOSM'),(264932478,1,'created_by','JOSM'),(264932479,1,'created_by','JOSM'),(264932481,1,'created_by','JOSM'),(264932482,1,'created_by','JOSM'),(264932483,1,'created_by','JOSM'),(264932484,1,'created_by','JOSM'),(264932486,1,'created_by','JOSM'),(264932487,1,'created_by','JOSM'),(264932488,1,'created_by','JOSM'),(264932489,1,'created_by','JOSM'),(264932490,1,'created_by','JOSM'),(264932491,1,'created_by','JOSM'),(264932492,1,'created_by','JOSM'),(264932493,1,'created_by','JOSM'),(264932495,1,'created_by','JOSM'),(264932496,1,'created_by','JOSM'),(264932497,1,'created_by','JOSM'),(264932498,1,'created_by','JOSM'),(264932499,1,'created_by','JOSM'),(264932500,1,'created_by','JOSM'),(264932501,1,'created_by','JOSM'),(264932529,1,'created_by','JOSM'),(264932531,1,'created_by','JOSM'),(264932532,1,'created_by','JOSM'),(264932534,1,'created_by','JOSM'),(264932535,1,'created_by','JOSM'),(264932536,1,'created_by','JOSM'),(264932537,1,'created_by','JOSM'),(264932538,1,'created_by','JOSM'),(264932539,1,'created_by','JOSM'),(264932540,1,'created_by','JOSM'),(264932541,1,'created_by','JOSM'),(264932543,1,'created_by','JOSM'),(264932544,1,'created_by','JOSM'),(264932545,1,'created_by','JOSM'),(264932546,1,'created_by','JOSM'),(264932547,1,'created_by','JOSM'),(264932548,1,'created_by','JOSM'),(264932549,1,'created_by','JOSM'),(264932550,1,'created_by','JOSM'),(264932551,1,'created_by','JOSM'),(264932567,1,'created_by','JOSM'),(264932568,1,'created_by','JOSM'),(264932569,1,'created_by','JOSM'),(264932570,1,'created_by','JOSM'),(264932572,1,'created_by','JOSM'),(264932573,1,'created_by','JOSM'),(264932574,1,'created_by','JOSM'),(264932575,1,'created_by','JOSM'),(264932576,1,'created_by','JOSM'),(264932577,1,'created_by','JOSM'),(264932578,1,'created_by','JOSM'),(264932579,1,'created_by','JOSM'),(264932581,1,'created_by','JOSM'),(264932582,1,'created_by','JOSM'),(264932583,1,'created_by','JOSM'),(264932584,1,'created_by','JOSM'),(264932585,1,'created_by','JOSM'),(264932586,1,'created_by','JOSM'),(264932587,1,'created_by','JOSM'),(264932589,1,'created_by','JOSM'),(264932590,1,'created_by','JOSM'),(264932591,1,'created_by','JOSM'),(264932592,1,'created_by','JOSM'),(264932593,1,'created_by','JOSM'),(264932594,1,'created_by','JOSM'),(264932595,1,'created_by','JOSM'),(264932596,1,'created_by','JOSM'),(264932598,1,'created_by','JOSM'),(264932599,1,'created_by','JOSM'),(264932600,1,'created_by','JOSM'),(264932601,1,'created_by','JOSM'),(264932602,1,'created_by','JOSM'),(264932603,1,'created_by','JOSM'),(264932604,1,'created_by','JOSM'),(264932605,1,'created_by','JOSM'),(264932606,1,'created_by','JOSM'),(264932608,1,'created_by','JOSM'),(264932609,1,'created_by','JOSM'),(264932610,1,'created_by','JOSM'),(264932611,1,'created_by','JOSM'),(264932612,1,'created_by','JOSM'),(264932613,1,'created_by','JOSM'),(264932614,1,'created_by','JOSM'),(264932615,1,'created_by','JOSM'),(264932616,1,'created_by','JOSM'),(264932617,1,'created_by','JOSM'),(264932619,1,'created_by','JOSM'),(264932620,1,'created_by','JOSM'),(264932621,1,'created_by','JOSM'),(264932622,1,'created_by','JOSM'),(264932623,1,'created_by','JOSM'),(264932624,1,'created_by','JOSM'),(264932625,1,'created_by','JOSM'),(264932626,1,'created_by','JOSM'),(264932627,1,'created_by','JOSM'),(264932628,1,'created_by','JOSM'),(264932629,1,'created_by','JOSM'),(264932631,1,'created_by','JOSM'),(264932632,1,'created_by','JOSM'),(264932633,1,'created_by','JOSM'),(264932634,1,'created_by','JOSM'),(264932635,1,'created_by','JOSM'),(264932636,1,'created_by','JOSM'),(264932637,1,'created_by','JOSM'),(264932638,1,'created_by','JOSM'),(264932639,1,'created_by','JOSM'),(264932641,1,'created_by','JOSM'),(264932642,1,'created_by','JOSM'),(264932643,1,'created_by','JOSM'),(264932644,1,'created_by','JOSM'),(264932645,1,'created_by','JOSM'),(264932646,1,'created_by','JOSM'),(264932647,1,'created_by','JOSM'),(264932649,1,'created_by','JOSM'),(264932650,1,'created_by','JOSM'),(264932651,1,'created_by','JOSM'),(264932652,1,'created_by','JOSM'),(264932653,1,'created_by','JOSM'),(264932654,1,'created_by','JOSM'),(264932655,1,'created_by','JOSM'),(264932656,1,'created_by','JOSM'),(264932657,1,'created_by','JOSM'),(264932658,1,'created_by','JOSM'),(264932659,1,'created_by','JOSM'),(264932660,1,'created_by','JOSM'),(264932661,1,'created_by','JOSM'),(264932662,1,'created_by','JOSM'),(264932663,1,'created_by','JOSM'),(264932665,1,'created_by','JOSM'),(264932666,1,'created_by','JOSM'),(264932667,1,'created_by','JOSM'),(264932668,1,'created_by','JOSM'),(264932669,1,'created_by','JOSM'),(264932670,1,'created_by','JOSM'),(264932671,1,'created_by','JOSM'),(264932672,1,'created_by','JOSM'),(264932673,1,'created_by','JOSM'),(264932675,1,'created_by','JOSM'),(264932676,1,'created_by','JOSM'),(264932677,1,'created_by','JOSM'),(264932678,1,'created_by','JOSM'),(264932679,1,'created_by','JOSM'),(264932680,1,'created_by','JOSM'),(264932681,1,'created_by','JOSM'),(264932682,1,'created_by','JOSM'),(264932684,1,'created_by','JOSM'),(264932685,1,'created_by','JOSM'),(264932686,1,'created_by','JOSM'),(264932687,1,'created_by','JOSM'),(264932688,1,'created_by','JOSM'),(264932689,1,'created_by','JOSM'),(264932690,1,'created_by','JOSM'),(264932691,1,'created_by','JOSM'),(264932693,1,'created_by','JOSM'),(264932694,1,'created_by','JOSM'),(264932695,1,'created_by','JOSM'),(264932696,1,'created_by','JOSM'),(264932697,1,'created_by','JOSM'),(264932698,1,'created_by','JOSM'),(264932699,1,'created_by','JOSM'),(264932701,1,'created_by','JOSM'),(264932702,1,'created_by','JOSM'),(264932703,1,'created_by','JOSM'),(264932704,1,'created_by','JOSM'),(264932705,1,'created_by','JOSM'),(264932706,1,'created_by','JOSM'),(264932707,1,'created_by','JOSM'),(264932708,1,'created_by','JOSM'),(264932710,1,'created_by','JOSM'),(264932711,1,'created_by','JOSM'),(264932712,1,'created_by','JOSM'),(264932713,1,'created_by','JOSM'),(264932714,1,'created_by','JOSM'),(264932715,1,'created_by','JOSM'),(264932716,1,'created_by','JOSM'),(264932717,1,'created_by','JOSM'),(264932718,1,'created_by','JOSM'),(264932719,1,'created_by','JOSM'),(264932720,1,'created_by','JOSM'),(264932722,1,'created_by','JOSM'),(264932723,1,'created_by','JOSM'),(264932724,1,'created_by','JOSM'),(264932725,1,'created_by','JOSM'),(264932726,1,'created_by','JOSM'),(264932727,1,'created_by','JOSM'),(264932728,1,'created_by','JOSM'),(264932729,1,'created_by','JOSM'),(264932731,1,'created_by','JOSM'),(264932732,1,'created_by','JOSM'),(264932733,1,'created_by','JOSM'),(264932734,1,'created_by','JOSM'),(264932735,1,'created_by','JOSM'),(264932736,1,'created_by','JOSM'),(264932737,1,'created_by','JOSM'),(264932738,1,'created_by','JOSM'),(264932739,1,'created_by','JOSM'),(264932740,1,'created_by','JOSM'),(264932742,1,'created_by','JOSM'),(264932743,1,'created_by','JOSM'),(264932744,1,'created_by','JOSM'),(264932745,1,'created_by','JOSM'),(264932746,1,'created_by','JOSM'),(264932747,1,'created_by','JOSM'),(264932748,1,'created_by','JOSM'),(264932749,1,'created_by','JOSM'),(264932750,1,'created_by','JOSM'),(264932752,1,'created_by','JOSM'),(264932753,1,'created_by','JOSM'),(264932754,1,'created_by','JOSM'),(264932755,1,'created_by','JOSM'),(264932756,1,'created_by','JOSM'),(264932757,1,'created_by','JOSM'),(264932759,1,'created_by','JOSM'),(264932760,1,'created_by','JOSM'),(264932761,1,'created_by','JOSM'),(264932762,1,'created_by','JOSM'),(264932763,1,'created_by','JOSM'),(264932764,1,'created_by','JOSM'),(264932765,1,'created_by','JOSM'),(264932766,1,'created_by','JOSM'),(264932767,1,'created_by','JOSM'),(264932769,1,'created_by','JOSM'),(264932770,1,'created_by','JOSM'),(264932771,1,'created_by','JOSM'),(264932772,1,'created_by','JOSM'),(264932773,1,'created_by','JOSM'),(264932774,1,'created_by','JOSM'),(264932775,1,'created_by','JOSM'),(264932776,1,'created_by','JOSM'),(264932777,1,'created_by','JOSM'),(264932779,1,'created_by','JOSM'),(264932780,1,'created_by','JOSM'),(264932781,1,'created_by','JOSM'),(264932782,1,'created_by','JOSM'),(264932783,1,'created_by','JOSM'),(264932784,1,'created_by','JOSM'),(264932785,1,'created_by','JOSM'),(264932786,1,'created_by','JOSM'),(264932787,1,'created_by','JOSM'),(264932788,1,'created_by','JOSM'),(264932789,1,'created_by','JOSM'),(264932791,1,'created_by','JOSM'),(264932792,1,'created_by','JOSM'),(264932793,1,'created_by','JOSM'),(264932794,1,'created_by','JOSM'),(264932795,1,'created_by','JOSM'),(264932796,1,'created_by','JOSM'),(264932797,1,'created_by','JOSM'),(264932798,1,'created_by','JOSM'),(264932800,1,'created_by','JOSM'),(264932801,1,'created_by','JOSM'),(264932802,1,'created_by','JOSM'),(264932803,1,'created_by','JOSM'),(264932804,1,'created_by','JOSM'),(264932805,1,'created_by','JOSM'),(264932806,1,'created_by','JOSM'),(264932807,1,'created_by','JOSM'),(264932808,1,'created_by','JOSM'),(264932809,1,'created_by','JOSM'),(264932811,1,'created_by','JOSM'),(264932812,1,'created_by','JOSM'),(264932813,1,'created_by','JOSM'),(264932814,1,'created_by','JOSM'),(264932815,1,'created_by','JOSM'),(264932816,1,'created_by','JOSM'),(264932817,1,'created_by','JOSM'),(264932818,1,'created_by','JOSM'),(264932820,1,'created_by','JOSM'),(264932821,1,'created_by','JOSM'),(264932822,1,'created_by','JOSM'),(264932823,1,'created_by','JOSM'),(264932824,1,'created_by','JOSM'),(264932825,1,'created_by','JOSM'),(264932826,1,'created_by','JOSM'),(264932827,1,'created_by','JOSM'),(264932828,1,'created_by','JOSM'),(264932829,1,'created_by','JOSM'),(264932831,1,'created_by','JOSM'),(264932832,1,'created_by','JOSM'),(264932833,1,'created_by','JOSM'),(264932834,1,'created_by','JOSM'),(264932835,1,'created_by','JOSM'),(264932836,1,'created_by','JOSM'),(264932837,1,'created_by','JOSM'),(264932838,1,'created_by','JOSM'),(264932839,1,'created_by','JOSM'),(264932840,1,'created_by','JOSM'),(264932841,1,'created_by','JOSM'),(264932842,1,'created_by','JOSM'),(264932843,1,'created_by','JOSM'),(264932844,1,'created_by','JOSM'),(264932846,1,'created_by','JOSM'),(264932847,1,'created_by','JOSM'),(264932848,1,'created_by','JOSM'),(264932849,1,'created_by','JOSM'),(264932850,1,'created_by','JOSM'),(264932851,1,'created_by','JOSM'),(264932852,1,'created_by','JOSM'),(264932853,1,'created_by','JOSM'),(264932855,1,'created_by','JOSM'),(264932856,1,'created_by','JOSM'),(264932857,1,'created_by','JOSM'),(264932858,1,'created_by','JOSM'),(264932859,1,'created_by','JOSM'),(264932860,1,'created_by','JOSM'),(264932861,1,'created_by','JOSM'),(264932862,1,'created_by','JOSM'),(264932864,1,'created_by','JOSM'),(264932865,1,'created_by','JOSM'),(264932866,1,'created_by','JOSM'),(264932867,1,'created_by','JOSM'),(264932868,1,'created_by','JOSM'),(264932869,1,'created_by','JOSM'),(264932870,1,'created_by','JOSM'),(264932871,1,'created_by','JOSM'),(266324553,1,'created_by','Potlatch 0.9a'),(266324553,1,'is_in','Ordino'),(266324553,1,'name','Mas d\'en Soler'),(266324553,1,'place','hamlet'),(266324699,2,'building','water mill'),(266324699,2,'created_by','Potlatch 0.9a'),(266324699,2,'name','Moli de Mas d\'en Soler'),(266331736,1,'amenity','parking'),(266331736,1,'created_by','Potlatch 0.9a'),(266331970,1,'amenity','parking'),(266331970,1,'created_by','Potlatch 0.9a'),(266338686,1,'amenity','parking'),(266338686,1,'created_by','Potlatch 0.9a'),(266619909,2,'highway','turning_circle'),(266622062,1,'highway','turning_circle'),(266622086,1,'amenity','parking'),(266622086,1,'created_by','Potlatch 0.9a'),(266622595,1,'amenity','parking'),(266622595,1,'created_by','Potlatch 0.9a'),(268092455,2,'highway','turning_circle'),(268093053,2,'highway','mini_roundabout'),(268096174,1,'created_by','Potlatch 0.9c'),(268096174,1,'name','Hotel Xalet Besoli'),(268096174,1,'tourism','hotel'),(268123183,2,'highway','turning_circle'),(271938772,1,'created_by','JOSM'),(271938773,1,'created_by','JOSM'),(271938774,1,'created_by','JOSM'),(271938778,1,'created_by','JOSM'),(271939031,3,'amenity','fuel'),(271939031,3,'name','bp'),(271939031,3,'operator','BP'),(271939032,1,'created_by','JOSM'),(271939033,1,'created_by','JOSM'),(271939034,1,'created_by','JOSM'),(276993930,5,'ele','2360'),(276993930,5,'mountain_pass','yes'),(276993930,5,'name','Port de Siguer'),(276993930,5,'wikipedia','fr:Port_de_Siguer'),(277000148,2,'place_name','Plaça del Poble'),(277003684,1,'highway','turning_circle'),(277377767,1,'created_by','Potlatch 0.9c'),(277377767,1,'ele','2746'),(277377767,1,'name','Pic Oest de Casamanya'),(277377767,1,'natural','peak'),(277377889,1,'created_by','Potlatch 0.9c'),(277377889,1,'ele','2757'),(277377889,1,'name','Pic Est de Casamanya'),(277377889,1,'natural','peak'),(277377892,3,'created_by','Potlatch 0.9c'),(277377892,3,'ele','2731'),(277377892,3,'name','Pic Mig de Casamanya'),(277377892,3,'natural','peak'),(277378560,1,'created_by','Potlatch 0.9c'),(277378560,1,'ele','2550'),(277378560,1,'mountain_pass','yes'),(277378560,1,'name','Col d\'Arenys'),(278752636,1,'created_by','Potlatch 0.9c'),(278752636,1,'name','Hotel Nordic'),(278752636,1,'tourism','hotel'),(281694408,1,'created_by','Potlatch 0.10'),(281694408,1,'name','Hotel la Coma'),(281694408,1,'tourism','hotel'),(283678401,1,'amenity','parking'),(283678401,1,'created_by','Potlatch 0.10b'),(283680492,1,'amenity','arts_centre'),(283680492,1,'created_by','Potlatch 0.10b'),(283680492,1,'name','Auditori Nacional d\'Andorra'),(287401324,1,'highway','mini_roundabout'),(292503717,1,'amenity','fuel'),(292503717,1,'operator','Gasopas'),(316961244,1,'highway','mini_roundabout'),(316961410,1,'highway','mini_roundabout'),(316961518,4,'highway','mini_roundabout'),(316985105,1,'created_by','Potlatch 0.10f'),(316985105,1,'is_in','Ordino'),(316985105,1,'name','Les Salines'),(316985105,1,'place','hamlet'),(321651109,1,'ele','2642'),(321651109,1,'name','Pic Negre'),(321651109,1,'natural','peak'),(321679779,1,'name','Collada de Mitjana'),(321679779,1,'natural','land'),(321683609,1,'barrier','kissing_gate'),(321683609,1,'bicycle','yes'),(323130871,5,'aerialway','station'),(323130873,5,'aerialway','station'),(337743301,3,'amenity','parking'),(337743301,3,'created_by','Potlatch 0.10f'),(337743301,3,'operator','Parc central'),(337745019,1,'amenity','parking'),(337745019,1,'created_by','Potlatch 0.10f'),(337745019,1,'operator','Hipermercat Andorra 2000'),(337775428,1,'barrier','entrance'),(338420702,1,'barrier','garage door'),(339066904,1,'created_by','Potlatch 0.10f'),(339066904,1,'natural','peak'),(339066905,1,'created_by','Potlatch 0.10f'),(339066905,1,'natural','peak'),(364104064,1,'name','Camping Xixerella'),(364104064,1,'tourism','camp_site'),(367680434,1,'amenity','parking'),(367680434,1,'parking','surface'),(370902435,1,'highway','turning_circle'),(370903030,1,'highway','turning_circle'),(370903796,1,'highway','turning_circle'),(370909282,1,'highway','turning_circle'),(370911870,2,'amenity','place_of_worship'),(370911870,2,'created_by','Potlatch 0.10f'),(370911870,2,'denomination','roman_catholic'),(370911870,2,'name','Sant Cristofol d\'Anyos'),(370911870,2,'religion','christian'),(385582153,2,'amenity','parking'),(385582153,2,'operator','Aparcement Comunal Tobira'),(394816282,1,'highway','turning_circle'),(394820724,1,'highway','turning_circle'),(394832428,1,'highway','turning_circle'),(394840157,2,'amenity','place_of_worship'),(394840157,2,'denomination','roman_catholic'),(394840157,2,'name','Sant Romà d\'Auvinyà'),(394840157,2,'religion','christian'),(394841036,2,'highway','turning_circle'),(394847593,1,'highway','gate'),(441154305,1,'barrier','fence'),(441154308,1,'highway','turning_circle'),(442879444,1,'amenity','parking'),(442879444,1,'name','Parking Comunal de l\'Aldosa'),(442881217,1,'name','Hotel Magic Ski'),(442881217,1,'tourism','hotel'),(442881670,1,'name','Hotel Font'),(442881670,1,'tourism','hotel'),(442881710,1,'name','Hotel Magic'),(442881710,1,'tourism','hotel'),(442881842,1,'name','Hotel Marco Polo'),(442881842,1,'tourism','hotel'),(442881998,1,'amenity','parking'),(442881998,1,'name','Les Fontetes'),(442882169,1,'amenity','theatre'),(442882169,1,'name','Les Fontetes'),(442882272,1,'name','Hotel Burna'),(442882272,1,'tourism','hotel'),(442882442,1,'name','Compra Be'),(442882442,1,'shop','supermarket'),(442882581,1,'name','Residential de l\'Aldosa'),(442882581,1,'tourism','hotel'),(444324773,1,'amenity','parking'),(444324773,1,'name','Les Pardines'),(458761736,1,'building','Borda'),(458761736,1,'name','Borda de Sedornet'),(458762722,1,'ele','1934'),(458762722,1,'name','Roc de Castell'),(458762722,1,'natural','peak'),(458765074,1,'amenity','parking'),(470343766,2,'tourism','viewpoint'),(470364200,1,'amenity','parking'),(470364488,1,'amenity','parking'),(482150309,1,'ele','2570'),(482150309,1,'name','Pic del\'Hortell'),(482150309,1,'natural','peak'),(485578146,1,'ele','2526'),(485578146,1,'mountain_pass','yes'),(485578146,1,'name','Col de l\'Homme Mort'),(521134858,1,'amenity','restaurant'),(521134858,1,'name','Surf'),(521135636,1,'amenity','fast_food'),(521143390,1,'shop','supermarket'),(521144650,1,'shop','supermarket'),(521146418,1,'amenity','bar'),(521146418,1,'name','Red X'),(521153185,3,'aerialway','station'),(521153185,3,'man_made','Uphill Terminal'),(521153188,3,'aerialway','station'),(521153188,3,'man_made','Downhill Terminal'),(522787948,1,'amenity','restaurant'),(522787954,1,'amenity','bar'),(522787964,1,'amenity','fast_food'),(522787974,1,'amenity','hospital'),(522787985,1,'amenity','restaurant'),(522788283,1,'highway','bus_stop'),(522788287,1,'tourism','hotel'),(522800785,2,'amenity','bank'),(522800785,2,'atm','yes'),(522800788,1,'amenity','atm'),(529940889,1,'amenity','school'),(529941178,2,'name','Casa d\'Areny-Plandolit'),(529941178,2,'tourism','museum'),(529943807,1,'amenity','place_of_worship'),(535384824,1,'highway','speed_camera'),(567007523,3,'aerialway','station'),(567007523,3,'FIXME','Needs survey of correct position and full extent'),(567007523,3,'source','Estimate based on local knowledge'),(590463652,1,'name','Hotel St. Gothard'),(590463652,1,'tourism','hotel'),(590463653,1,'name','Apartments St. Moritz'),(590463653,1,'tourism','hotel'),(590463654,1,'name','St. Moritz Ski Hire'),(590463654,1,'shop','sports'),(590463655,1,'amenity','pharmacy'),(590463655,1,'dispensing','yes'),(590463656,1,'name','Hotel Solana'),(590463656,1,'tourism','hotel'),(590463659,2,'name','Hotel Princesa Parc'),(590463659,2,'tourism','hotel'),(590463661,1,'name','Hotel Xalet Verdu'),(590463661,1,'tourism','hotel'),(590463663,2,'name','Hotel Patagonia'),(590463663,2,'tourism','hotel'),(590463666,1,'highway','bus_stop'),(590463666,1,'name','Central Bus Stop'),(590463666,1,'name:en','Central Bus Stop'),(590463669,1,'name','Hotel Ayma'),(590463669,1,'tourism','hotel'),(590538923,1,'name','Resedencia Daina'),(590538923,1,'tourism','hotel'),(590538926,1,'name','Hotel Arinsal'),(590538926,1,'tourism','hotel'),(593870539,1,'amenity','restaurant'),(593870539,1,'ele','1926'),(593870539,1,'name','Restaurant Panoramix'),(593870540,1,'ele','1966'),(593870540,1,'name','Esports Rossell'),(593870540,1,'shop','sports'),(593870541,1,'amenity','atm'),(593870541,1,'ele','1935'),(593870542,1,'ele','1923'),(593870542,1,'name','Pic Negre'),(593870542,1,'shop','sports'),(593870542,1,'ski_hire','yes'),(593870543,1,'ele','1912'),(593870543,1,'name','Lift Pass Office'),(593870543,1,'shop','lift_pass'),(593870544,1,'ele','1923'),(593870544,1,'FIXME','Position is suspect'),(593870544,1,'name','Top of Chair lift'),(593870545,2,'ele','1935'),(593870545,2,'FIXME','Need a proper name'),(593870545,2,'name','Souvenir Shop at the Top of Gondola'),(593870545,2,'shop','gift'),(593870546,1,'ele','1482'),(593870546,1,'name','Shop 5150 (ski/sport shop)'),(593870547,1,'ele','1409'),(593870547,1,'name','Supermarket Nou'),(593870547,1,'shop','supermarket'),(593870548,1,'amenity','restaurant'),(593870548,1,'ele','1423'),(593870548,1,'internet_access','yes'),(593870548,1,'name','Restaurant Granja Del Poble (Internet Café)'),(593870549,1,'amenity','bar'),(593870549,1,'ele','1430'),(593870549,1,'name','Bar El Bosc'),(593870550,1,'amenity','restaurant'),(593870550,1,'ele','1422'),(593870550,1,'name','Restaurant Timotea'),(593870551,1,'amenity','atm'),(593870551,1,'ele','1430'),(593870552,1,'ele','1926'),(593870552,1,'name','Ski School'),(593870552,1,'shop','ski_school'),(593870553,1,'amenity','bar'),(593870553,1,'ele','146'),(593870553,1,'name','Bar/Restaurant 360'),(593870554,1,'amenity','bar'),(593870554,1,'ele','1461'),(593870554,1,'name','Black Bull Bar'),(593870555,1,'amenity','atm'),(593870555,1,'ele','1442'),(593870556,1,'amenity','restaurant'),(593870556,1,'ele','1474'),(593870556,1,'name','Restaurant/Bar Mollies'),(593870557,1,'amenity','atm'),(593870557,1,'ele','1476'),(593870558,1,'amenity','restaurant'),(593870558,1,'ele','1477'),(593870558,1,'name','Restaurant/Bar Ciscos'),(593870559,1,'amenity','bar'),(593870559,1,'ele','1515'),(593870559,1,'name','Cau Bar'),(593870560,1,'amenity','bar'),(593870560,1,'ele','1524'),(593870560,1,'name','Bar Quo Vadis'),(613344821,2,'man_made','Downhill Terminal'),(613344822,2,'man_made','Uphill Terminal'),(613344823,3,'man_made','Downhill Terminal'),(613344824,3,'man_made','Uphill Terminal'),(613344825,3,'man_made','Downhill Terminal'),(613344827,2,'man_made','Uphill Terminal'),(620937074,2,'amenity','restaurant'),(620937074,2,'building','yes'),(620937074,2,'name','Steak House'),(621473071,1,'amenity','restaurant'),(621473071,1,'name','Cubil'),(621473074,1,'ele','2560'),(621473074,1,'name','Tosa de Llosada'),(621473074,1,'natural','peak'),(621473077,1,'ele','2502'),(621473077,1,'name','Cortals'),(621473077,1,'natural','peak'),(621473079,2,'amenity','restaurant'),(621473079,2,'name','Solanelles'),(621473081,1,'ele','2467'),(621473081,1,'name','Tosa de Espiolets'),(621473081,1,'natural','peak'),(623510069,2,'ele','2528'),(623510069,2,'mountain_pass','yes'),(623510069,2,'name','Col Blanc'),(663075945,1,'man_made','Uphill Terminal'),(663075946,1,'man_made','Downhill Terminal'),(663078911,2,'man_made','Uphill Terminal'),(663078912,1,'man_made','Downhill Terminal'),(663080312,1,'man_made','Uphill Terminal'),(663080313,1,'man_made','Downhill Terminal'),(663084327,1,'man_made','Uphill Terminal'),(663084328,1,'man_made','Downhill Terminal'),(663086638,1,'man_made','Downhill Terminal'),(663086639,1,'man_made','Uphill Terminal'),(663092389,2,'man_made','Uphill Terminal'),(663092390,1,'man_made','Downhill Terminal'),(663093429,2,'man_made','Uphill Terminal'),(663093430,2,'man_made','Downhill Terminal'),(663095052,2,'man_made','Downhill Terminal'),(663339197,1,'man_made','Uphill Terminal'),(663339199,1,'man_made','Downhill Terminal'),(663345420,2,'man_made','Uphill Terminal'),(663345421,1,'man_made','Downhill Terminal'),(663372539,2,'man_made','Uphill Terminal'),(663372540,2,'man_made','Downhill Terminal'),(663373401,2,'aerialway','station'),(663373401,2,'man_made','Uphill Terminal'),(663373402,2,'aerialway','station'),(663373402,2,'man_made','Downhill Terminal'),(663802644,1,'man_made','Uphill Terminal'),(663802645,1,'man_made','Downhill Terminal'),(663803593,1,'man_made','Uphill Terminal'),(663803594,1,'man_made','Downhill Terminal'),(663952666,1,'man_made','Downhill Terminal'),(663952667,1,'man_made','Uphill Terminal'),(663953196,1,'historic','monument'),(663953196,1,'name','Monument L\'Anella d\'Ordino'),(664116090,1,'man_made','Downhill Terminal'),(664116091,2,'aerialway','station'),(664116091,2,'man_made','Uphill Terminal'),(664116161,2,'aerialway','station'),(664116161,2,'man_made','Downhill Terminal'),(664192679,1,'aerialway','pylon'),(664192680,1,'aerialway','pylon'),(664192681,1,'aerialway','pylon'),(664195007,1,'man_made','Downhill Terminal'),(664195008,1,'man_made','Uphill Terminal'),(664205614,1,'aerialway','station'),(664205614,1,'man_made','Uphill Terminal'),(664205619,1,'aerialway','pylon'),(664205621,1,'aerialway','pylon'),(664205624,1,'aerialway','pylon'),(664205627,1,'aerialway','pylon'),(664205630,1,'aerialway','pylon'),(664205633,1,'aerialway','pylon'),(664205635,1,'aerialway','pylon'),(664205638,1,'aerialway','station'),(664205638,1,'man_made','Downhill Terminal'),(664205641,1,'aerialway','pylon'),(664205644,1,'aerialway','pylon'),(664225476,1,'aerialway','pylon'),(664225514,1,'aerialway','pylon'),(664225516,1,'aerialway','pylon'),(664225519,1,'aerialway','pylon'),(664225521,1,'aerialway','pylon'),(664225523,1,'aerialway','pylon'),(664225525,1,'aerialway','pylon'),(664225527,1,'aerialway','pylon'),(664225529,1,'aerialway','pylon'),(664225531,1,'aerialway','pylon'),(664236924,1,'aerialway','pylon'),(664236925,1,'aerialway','pylon'),(664236926,1,'aerialway','pylon'),(664236927,1,'aerialway','pylon'),(664236928,1,'aerialway','pylon'),(664605824,2,'aerialway','station'),(666793593,1,'ele','2447'),(666793593,1,'information','guidepost'),(666793593,1,'name','Collada D\'Enradort'),(666793593,1,'tourism','information'),(666793594,1,'amenity','restaurant'),(666793594,1,'name','Roc De Les Bruixes'),(666793595,1,'amenity','fast_food'),(666793596,1,'amenity','toilets'),(666793597,1,'ele','2000'),(666793597,1,'information','guidepost'),(666793597,1,'name','El Forn'),(666793597,1,'tourism','information'),(666793598,1,'amenity','fast_food'),(666793599,1,'amenity','toilets'),(666793600,2,'ele','2560'),(666793600,2,'information','guidepost'),(666793600,2,'name','Tosa De La Llosada'),(666793600,2,'tourism','information'),(666793601,2,'amenity','hospital'),(666793602,2,'amenity','hospital'),(666793603,1,'ele','2465'),(666793603,1,'information','guidepost'),(666793603,1,'name','Portella'),(666793603,1,'tourism','information'),(666793604,1,'ele','2458'),(666793604,1,'information','guidepost'),(666793604,1,'name','C. De Les Solanelles'),(666793604,1,'tourism','information'),(666793605,1,'ele','2502'),(666793605,1,'information','guidepost'),(666793605,1,'name','Cortals'),(666793605,1,'tourism','information'),(666793606,1,'amenity','fast_food'),(666793607,2,'amenity','hospital'),(666793608,1,'amenity','toilets'),(666793609,1,'amenity','toilets'),(666793610,2,'amenity','hospital'),(666793611,1,'ele','2467'),(666793611,1,'information','guidepost'),(666793611,1,'name','Tossa Dels Espiolets'),(666793611,1,'tourism','information'),(666793612,1,'amenity','fast_food'),(666793613,1,'ele','2100'),(666793613,1,'information','guidepost'),(666793613,1,'name','Riba Escorxada'),(666793613,1,'tourism','information'),(666793614,1,'amenity','restaurant'),(666793614,1,'name','El Mercal Del Pi'),(666793615,1,'amenity','toilets'),(666793616,1,'amenity','restaurant'),(666793616,1,'name','Gall De Bosc'),(666793617,1,'amenity','fast_food'),(666793618,1,'ele','2250'),(666793618,1,'information','guidepost'),(666793618,1,'name','Espiolets'),(666793618,1,'tourism','information'),(666793619,1,'amenity','fast_food'),(666793620,1,'ele','2150'),(666793620,1,'information','guidepost'),(666793620,1,'name','Pla De Les Pedres'),(666793620,1,'tourism','information'),(666793621,1,'amenity','toilets'),(666793622,1,'amenity','fast_food'),(666793623,1,'amenity','toilets'),(669985285,2,'description','Mire Duralumin - Point vu en place en 1948'),(669985285,2,'man_made','survey_point');
INSERT INTO `node_tags` VALUES (669985285,2,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669985285,2,'ref','0902401 -'),(669985285,2,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669985285,2,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0902401&no_ptg=02&numero_f50=2149'),(669985286,2,'description','Repère I - Point vu en place en 1948'),(669985286,2,'man_made','survey_point'),(669985286,2,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669985286,2,'ref','0902401 -'),(669985286,2,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669985286,2,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0902401&no_ptg=04&numero_f50=2149'),(669985287,2,'description','Repère II - Point vu en place en 1948'),(669985287,2,'man_made','survey_point'),(669985287,2,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669985287,2,'ref','0902401 -'),(669985287,2,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669985287,2,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0902401&no_ptg=05&numero_f50=2149'),(669985289,2,'description','Repère III - Point vu en place en 1948'),(669985289,2,'man_made','survey_point'),(669985289,2,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669985289,2,'ref','0902401 -'),(669985289,2,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669985289,2,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0902401&no_ptg=06&numero_f50=2149'),(669985291,1,'description','Borne en granit gravée IGN - Point vu en place en 1950'),(669985291,1,'ele','2912.38'),(669985291,1,'man_made','survey_point'),(669985291,1,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669985291,1,'ref','0902401 - 1'),(669985291,1,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669985291,1,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0902401&no_ptg=01&numero_f50=2149'),(669985299,1,'description','Borne en granit gravée IGN - Point vu en place en 1950'),(669985299,1,'ele','2594.87'),(669985299,1,'man_made','survey_point'),(669985299,1,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669985299,1,'ref','0902407 - 1'),(669985299,1,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669985299,1,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0902407&no_ptg=01&numero_f50=2149'),(669985301,1,'description','Rocher : Repère : Rivet en fer scellé - Point vu en place en 1950'),(669985301,1,'ele','2594.99'),(669985301,1,'man_made','survey_point'),(669985301,1,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669985301,1,'ref','0902407 - A'),(669985301,1,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669985301,1,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0902407&no_ptg=03&numero_f50=2149'),(669985341,1,'description','Borne en granit gravée IGN - Point vu en place en 1950'),(669985341,1,'ele','2913.56'),(669985341,1,'man_made','survey_point'),(669985341,1,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669985341,1,'ref','0903004 - 1'),(669985341,1,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669985341,1,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0903004&no_ptg=01&numero_f50=2149'),(669985348,1,'description','Borne en granit gravée IGN - Point vu en place en 1950'),(669985348,1,'ele','2804.65'),(669985348,1,'man_made','survey_point'),(669985348,1,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669985348,1,'ref','0903008 - 1'),(669985348,1,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669985348,1,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0903008&no_ptg=01&numero_f50=2149'),(669985685,1,'description','Rocher : Repère en bronze scellé - Point vu en place en 1950'),(669985685,1,'ele','2810.7'),(669985685,1,'man_made','survey_point'),(669985685,1,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669985685,1,'ref','0913901 - 1'),(669985685,1,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669985685,1,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0913901&no_ptg=01&numero_f50=2149'),(669985690,1,'description','Rocher : Croix gravée - Point vu en place en 1948'),(669985690,1,'man_made','survey_point'),(669985690,1,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669985690,1,'ref','0913901 - 2'),(669985690,1,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669985690,1,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0913901&no_ptg=02&numero_f50=2149'),(669986979,1,'description','Borne en granit gravée IGN - Point vu en place en 1950'),(669986979,1,'ele','2902.82'),(669986979,1,'man_made','survey_point'),(669986979,1,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669986979,1,'ref','0929501 - 1'),(669986979,1,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669986979,1,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0929501&no_ptg=01&numero_f50=2149'),(669986980,1,'description','Repère en bronze scellé - Point vu en place en 1950'),(669986980,1,'ele','2902.66'),(669986980,1,'man_made','survey_point'),(669986980,1,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669986980,1,'ref','0929501 - A'),(669986980,1,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669986980,1,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0929501&no_ptg=03&numero_f50=2149'),(669986981,1,'description','Rivet en fer scellé au N.E - Point vu en place en 1950'),(669986981,1,'ele','2902.92'),(669986981,1,'man_made','survey_point'),(669986981,1,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669986981,1,'ref','0929501 - B'),(669986981,1,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669986981,1,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0929501&no_ptg=04&numero_f50=2149'),(669986982,1,'description','Rivet en fer scellé au N.O - Point vu en place en 1950'),(669986982,1,'ele','2902.11'),(669986982,1,'man_made','survey_point'),(669986982,1,'note','Ne pas déplacer ce point, cf. - Do not move this node, see - http://wiki.openstreetmap.org/wiki/WikiProject_France/Repères_Géodésiques#Permanence_des_rep.C3.A8res'),(669986982,1,'ref','0929501 - C'),(669986982,1,'source','©IGN 2010 dans le cadre de la cartographie réglementaire'),(669986982,1,'url','http://ancien-geodesie.ign.fr/fiche_point.asp?num_site=0929501&no_ptg=05&numero_f50=2149'),(796044564,1,'name','River'),(796044564,1,'shop','supermarket'),(796044575,1,'name','Punt de Trobada'),(796044575,1,'shop','supermarket'),(820950476,1,'name','Hotel Himalaya'),(820950476,1,'tourism','hotel'),(820952919,1,'name','Hotel'),(820952919,1,'tourism','hotel'),(820954183,2,'name','Hotel Bruxelles'),(820954183,2,'tourism','hotel'),(821006310,1,'amenity','restaurant'),(821006310,1,'name','Bruxellles Restaurant'),(894259010,2,'man_made','tower'),(894259010,2,'name','Torre dals Morus'),(894259010,2,'tourism','viewpoint'),(894259394,1,'amenity','place_of_worship'),(894259394,1,'religion','christian'),(894259503,2,'amenity','place_of_worship'),(894259503,2,'name','Santa Romà de les Bons'),(894259503,2,'religion','christian'),(894259507,2,'amenity','restaurant'),(894259507,2,'name','La Dama del Llac'),(894259507,2,'phone','+376828206'),(894259529,2,'amenity','restaurant'),(894259529,2,'name','Camp del FIXME'),(894259529,2,'tourism','hotel'),(894263141,1,'amenity','parking'),(894263144,2,'historic','church'),(894263144,2,'name','Sant Joan de Caselles'),(894263144,2,'tourism','attraction'),(895601487,1,'highway','bus_stop'),(895601487,1,'shelter','no'),(895601494,1,'amenity','restaurant'),(895601494,1,'name','Borda del Tremat'),(895604180,1,'amenity','restaurant'),(895604180,1,'name','L\'era del Rossell'),(899525861,2,'amenity','shelter'),(899525861,2,'ele','2218'),(899525861,2,'fireplace','yes'),(899525861,2,'name','Refuge de Coms de Jan - andorre'),(899525861,2,'note','98'),(899525861,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525869,2,'amenity','shelter'),(899525869,2,'ele','2030'),(899525869,2,'fireplace','no'),(899525869,2,'name','Cabane Estany   - andorre'),(899525869,2,'note','583'),(899525869,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525876,2,'amenity','shelter'),(899525876,2,'ele','2250'),(899525876,2,'name','Cabane Setut - andorre'),(899525876,2,'note','593'),(899525876,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525898,1,'amenity','shelter'),(899525898,1,'name','Cabane Banyell planells de rialp - andorre'),(899525898,1,'note','579'),(899525898,1,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525904,2,'amenity','shelter'),(899525904,2,'ele','2280'),(899525904,2,'name','Refuge Claror - andorre'),(899525904,2,'note','580'),(899525904,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525912,2,'amenity','shelter'),(899525912,2,'ele','2220'),(899525912,2,'fireplace','yes'),(899525912,2,'name','Refuge de l Angonella - andorre'),(899525912,2,'note','10'),(899525912,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525929,2,'amenity','shelter'),(899525929,2,'ele','2394'),(899525929,2,'fireplace','yes'),(899525929,2,'name','Cabane de l Estany de Juclar - andorre'),(899525929,2,'note','183'),(899525929,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525940,1,'amenity','shelter'),(899525940,1,'name','Cabane Estall Serrer - Andorre'),(899525940,1,'note','1129'),(899525940,1,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525948,2,'amenity','shelter'),(899525948,2,'ele','2220'),(899525948,2,'fireplace','no'),(899525948,2,'name','Cabane Fonts - andorre'),(899525948,2,'note','584'),(899525948,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525953,1,'amenity','shelter'),(899525953,1,'name','Cabane Riu dels Orris - andorre'),(899525953,1,'note','591'),(899525953,1,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525975,2,'amenity','shelter'),(899525975,2,'ele','2240'),(899525975,2,'fireplace','yes'),(899525975,2,'name','Cabane Portella - andorre'),(899525975,2,'note','589'),(899525975,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525984,2,'ele','2250'),(899525984,2,'name','Refuge de La Coma Pedrosa - andorre'),(899525984,2,'note','96'),(899525984,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899525984,2,'tourism','alpine_hut'),(899525989,1,'amenity','shelter'),(899525989,1,'name','Cabane Vall del Riu - andorre'),(899525989,1,'note','592'),(899525989,1,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526014,2,'amenity','shelter'),(899526014,2,'ele','1980'),(899526014,2,'fireplace','yes'),(899526014,2,'name','Cabane Borda Sorteny - andorre'),(899526014,2,'note','594'),(899526014,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526022,2,'amenity','shelter'),(899526022,2,'ele','2260'),(899526022,2,'fireplace','no'),(899526022,2,'name','Cabane de La Coma Pedrosa - andorre'),(899526022,2,'note','95'),(899526022,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526028,2,'amenity','shelter'),(899526028,2,'ele','2629'),(899526028,2,'fireplace','no'),(899526028,2,'name','Cabane de l Estany Forcat - Andorre'),(899526028,2,'note','968'),(899526028,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526049,2,'amenity','shelter'),(899526049,2,'ele','1830'),(899526049,2,'fireplace','yes'),(899526049,2,'name','Refuge de Fontverd - andorre'),(899526049,2,'note','143'),(899526049,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526058,2,'amenity','shelter'),(899526058,2,'ele','1838'),(899526058,2,'fireplace','yes'),(899526058,2,'name','Cabane Arcalis ou Pleta castellar - andorre'),(899526058,2,'note','578'),(899526058,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526069,2,'amenity','shelter'),(899526069,2,'ele','2250'),(899526069,2,'fireplace','yes'),(899526069,2,'name','Cabane de Sorda - andorre'),(899526069,2,'note','303'),(899526069,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526084,2,'amenity','shelter'),(899526084,2,'ele','2480'),(899526084,2,'name','Cabane Estany  Illa - andorre'),(899526084,2,'note','585'),(899526084,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526090,2,'amenity','shelter'),(899526090,2,'ele','2480'),(899526090,2,'fireplace','yes'),(899526090,2,'name','Cabane Ensagents - andorre'),(899526090,2,'note','581'),(899526090,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526097,2,'amenity','shelter'),(899526097,2,'name','Refuge Prat Primer - andorre'),(899526097,2,'note','590'),(899526097,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526119,2,'amenity','shelter'),(899526119,2,'ele','2200'),(899526119,2,'fireplace','yes'),(899526119,2,'name','Cabanes de Perafita - andorre'),(899526119,2,'note','248'),(899526119,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526127,1,'amenity','shelter'),(899526127,1,'name','Cabane Riba Escorxada - andorre'),(899526127,1,'note','582'),(899526127,1,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526136,1,'amenity','shelter'),(899526136,1,'name','Cabane Estanya - Andorre'),(899526136,1,'note','1132'),(899526136,1,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526171,2,'amenity','shelter'),(899526171,2,'ele','2020'),(899526171,2,'fireplace','yes'),(899526171,2,'name','Refuge de Rialp - andorre'),(899526171,2,'note','287'),(899526171,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526182,2,'amenity','shelter'),(899526182,2,'ele','2200'),(899526182,2,'fireplace','yes'),(899526182,2,'name','Cabane de La Farga - andorre'),(899526182,2,'note','140'),(899526182,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526219,2,'amenity','shelter'),(899526219,2,'ele','2250'),(899526219,2,'fireplace','yes'),(899526219,2,'name','Refuge des Agols - andorre'),(899526219,2,'note','5'),(899526219,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526225,2,'amenity','shelter'),(899526225,2,'ele','2010'),(899526225,2,'fireplace','yes'),(899526225,2,'name','Refuge de Coma Obaga - andorre'),(899526225,2,'note','94'),(899526225,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526237,2,'amenity','shelter'),(899526237,2,'ele','2150'),(899526237,2,'fireplace','yes'),(899526237,2,'name','Pla de les Pedres - Andorre'),(899526237,2,'note','985'),(899526237,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526263,2,'amenity','shelter'),(899526263,2,'ele','2190'),(899526263,2,'fireplace','yes'),(899526263,2,'name','Cabane Pleta Serrera - Andorre'),(899526263,2,'note','967'),(899526263,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526271,1,'amenity','shelter'),(899526271,1,'name','Cabane del Serrat de la  Barracota - Andorre'),(899526271,1,'note','1131'),(899526271,1,'source','Association \"Refuges et cabanes des Pyrénées\"'),(899526282,2,'amenity','shelter'),(899526282,2,'ele','2180'),(899526282,2,'fireplace','yes'),(899526282,2,'name','Refuge de Siscaro - andorre'),(899526282,2,'note','301'),(899526282,2,'source','Association \"Refuges et cabanes des Pyrénées\"'),(901125108,1,'ele','2946'),(901125108,1,'name','Pic de Coma Pedrosa'),(901125108,1,'natural','peak'),(901125108,1,'note','Pic de Coma Pedrosa'),(901170351,1,'ele','2914'),(901170351,1,'name','Pic de Medecourbe'),(901170351,1,'natural','peak');
INSERT INTO `nodes` VALUES (625022,425128450,15513604,232546,1,'2008-04-23 11:33:55',3310491548,4),(625023,425131024,15516715,232546,1,'2008-04-23 11:31:12',3310491548,3),(625024,425132796,15520491,232546,1,'2008-04-23 11:31:12',3310491548,3),(625025,425141739,15526900,427965,1,'2007-09-14 19:57:45',3310491548,1),(625026,425144463,15526776,2762,1,'2006-03-14 15:46:56',3310491548,1),(625027,425152372,15529780,2762,1,'2006-03-14 15:46:57',3310491549,1),(625028,425165907,15535741,427965,1,'2007-09-14 19:57:45',3310491549,1),(625029,425170402,15539651,2762,1,'2006-03-14 15:47:00',3310491549,1),(625030,425179485,15552163,232546,1,'2008-04-23 11:29:32',3310491594,2),(625031,425192920,15567756,427965,1,'2007-09-14 19:57:45',3310491594,1),(625032,425212467,15586896,427965,1,'2007-09-14 19:57:45',3310491595,1),(625033,425219426,15596166,427965,1,'2007-09-14 19:57:45',3310491595,1),(625034,425226005,15608611,427965,1,'2007-09-14 19:56:23',3310491617,1),(625035,425239988,15622907,2762,1,'2006-03-14 15:49:10',3310491620,1),(625036,425245931,15631270,427965,1,'2007-09-14 19:56:23',3310491620,1),(625037,425248714,15641570,427965,1,'2007-09-14 19:56:23',3310491620,1),(625038,425250612,15644488,427965,1,'2007-09-14 19:56:22',3310491620,1),(625039,425252761,15648066,2895121,1,'2009-10-19 19:23:45',3310491620,3),(625040,425261618,15667319,427965,1,'2007-09-14 19:56:23',3310491623,1),(625041,425270725,15679480,188228,1,'2008-06-16 19:35:06',3310491623,2),(625042,425273129,15685402,188228,1,'2008-06-16 19:35:26',3310491623,2),(625043,425275912,15690552,188228,1,'2008-06-16 19:35:55',3310491623,2),(625044,425285020,15692440,188228,1,'2008-06-16 19:38:21',3310491623,2),(625045,425288309,15691496,188228,1,'2008-06-16 19:38:45',3310491634,2),(625046,425291915,15695616,188228,1,'2008-06-16 19:39:37',3310491634,2),(625047,425291472,15702311,188228,1,'2008-06-16 19:39:37',3310491634,2),(625048,425291219,15707117,188228,1,'2008-06-16 19:39:37',3310491634,2),(625049,425291851,15710207,188228,1,'2008-06-16 19:39:37',3310491634,2),(625050,425298176,15719305,188228,1,'2008-06-16 19:41:22',3310491640,2),(625051,425311524,15728774,427965,1,'2007-09-14 19:56:23',3310491640,1),(625052,425320693,15738617,188228,1,'2008-06-16 20:02:41',3310491641,2),(625053,425323793,15745827,188228,1,'2008-06-16 20:02:41',3310491641,2),(625054,425326386,15756470,188228,1,'2008-06-16 20:02:41',3310491641,2),(625055,425327840,15765225,188228,1,'2008-06-16 20:02:41',3310491641,2),(625056,425329807,15783839,2762,1,'2006-03-14 15:49:36',3310491643,1),(625057,425333918,15797143,2762,1,'2006-03-14 15:49:37',3310491643,1),(625058,425341250,15806451,427965,1,'2007-09-14 19:56:23',3310491643,1),(625059,425350548,15813489,427965,1,'2007-09-14 19:56:23',3310491646,1),(625060,425359216,15819888,2762,1,'2006-03-14 15:49:41',3310491646,1),(625061,425363959,15826325,2762,1,'2006-03-14 15:49:42',3310493012,1),(625062,425371549,15837483,2762,1,'2006-03-14 15:49:45',3310493013,1),(625063,425368509,15847220,427965,1,'2007-09-14 19:56:23',3310493012,1),(625064,425362311,15850224,427965,1,'2007-09-14 19:56:23',3310493012,1),(625065,425349978,15857091,427965,1,'2007-09-14 19:56:23',3310493012,1),(625066,425347069,15857778,427965,1,'2007-09-14 19:51:34',3310493012,1),(625067,425340875,15851645,2762,1,'2006-03-14 15:49:54',3310493009,1),(625068,425335499,15850358,2762,1,'2006-03-14 15:49:57',3310493009,1),(625069,425335874,15855718,427965,1,'2007-09-14 19:56:23',3310493009,1),(625070,425342456,15863662,2762,1,'2006-03-14 15:49:59',3310493012,1),(625071,425220944,15598655,427965,1,'2007-09-14 19:56:23',3310491595,1),(625072,425372177,15843959,427965,1,'2007-09-14 19:56:23',3310493013,1),(625073,425349219,15876918,427965,1,'2007-09-14 19:51:17',3310493014,1),(625074,425356746,15884728,427965,1,'2007-09-14 19:51:17',3310493014,1),(625075,425363959,15888124,2762,1,'2006-03-14 15:52:08',3310493014,1),(625076,425370217,15893140,427965,1,'2007-09-14 19:51:17',3310493015,1),(625077,425375466,15904727,427965,1,'2007-09-14 19:51:17',3310493015,1),(625078,425396209,15917516,427965,1,'2007-09-14 19:51:17',3310493015,1),(625079,425402596,15919147,427965,1,'2007-09-14 19:51:17',3310503938,1),(625080,425404557,15920777,427965,1,'2007-09-14 19:51:17',3310503938,1),(625081,425412339,15922456,2762,1,'2006-03-14 15:52:18',3310503938,1),(625082,425417078,15917773,427965,1,'2007-09-14 19:51:17',3310503938,1),(625083,425420240,15916142,427965,1,'2007-09-14 19:51:17',3310503938,1),(625084,425429789,15914941,427965,1,'2007-09-14 19:49:09',3310503939,1),(625085,425432825,15915456,427965,1,'2007-09-14 19:49:09',3310503939,1),(625086,425443161,15918083,427965,1,'2007-09-14 20:33:11',3310503939,1),(625087,425445535,15917344,427965,1,'2007-09-14 19:49:09',3310503939,1),(625088,425452175,15914855,427965,1,'2007-09-14 19:49:09',3310503942,1),(625089,425462925,15914598,427965,1,'2007-09-14 19:49:09',3310503942,1),(625090,425470576,15917516,427965,1,'2007-09-14 19:49:09',3310503942,1),(625091,425489988,15916314,427965,1,'2007-09-14 19:48:40',3310503943,1),(625198,425497074,15914076,5671401,1,'2010-09-03 18:06:00',3310503943,2),(625199,425513473,15905539,5671401,1,'2010-09-03 18:06:02',3310503954,2),(625200,425515861,15903207,5671401,1,'2010-09-03 18:06:01',3310503954,2),(625202,425524242,15892711,5671401,1,'2010-09-03 18:06:00',3310503954,2),(625203,425529637,15888124,2774,1,'2006-03-14 23:12:11',3310503954,1),(625204,425535071,15886788,427965,1,'2007-09-14 19:48:40',3310503955,1),(625205,425547555,15885554,426786,1,'2007-09-14 10:10:35',3310503955,1),(625206,425554498,15884953,454632,1,'2007-09-17 18:41:27',3310503955,1),(625207,425574843,15886836,2774,1,'2006-03-14 23:12:15',3310503958,1),(625208,425587673,15891681,427965,1,'2007-09-14 19:46:49',3310503958,1),(625209,425593493,15892415,2774,1,'2006-03-14 23:12:17',3310503959,1),(625210,425596654,15894132,2774,1,'2006-03-14 23:12:18',3310503959,1),(625211,425605438,15899920,427965,1,'2007-09-14 19:46:49',3310503959,1),(625243,425619375,15903578,426786,1,'2007-09-14 10:13:24',3310504002,1),(625244,425629553,15905981,426786,1,'2007-09-14 10:13:24',3310504002,1),(625245,425638755,15910869,427965,1,'2007-09-14 19:12:43',3310504002,1),(625246,425640145,15919232,427965,1,'2007-09-14 19:45:55',3310504002,1),(625247,425641347,15925460,427965,1,'2007-09-14 19:12:43',3310504002,1),(625248,425642513,15928641,426786,1,'2007-09-14 10:13:29',3310504002,1),(625249,425656076,15936017,427965,1,'2007-09-14 19:12:39',3310504009,1),(625250,425657088,15938077,427965,1,'2007-09-14 19:12:11',3310504009,1),(625251,425660438,15942369,427965,1,'2007-09-14 19:12:11',3310504009,1),(625252,425661414,15956622,426786,1,'2007-09-14 10:13:29',3310504009,1),(625254,425658292,15967517,2774,1,'2006-03-14 23:27:22',3310504009,1),(625256,425657530,15975671,427965,1,'2007-09-14 19:12:11',3310504009,1),(625257,425658380,15978852,426786,1,'2007-09-14 10:13:29',3310504009,1),(625259,425666345,15998593,426786,1,'2007-09-14 10:13:29',3310504011,1),(625260,425671275,16010266,426786,1,'2007-09-14 10:13:37',3310504011,1),(625261,425675167,16016956,427965,1,'2007-09-14 19:10:26',3310504014,1),(625263,425680378,16026316,426786,1,'2007-09-14 10:13:32',3310504014,1),(625264,425684522,16037383,427965,1,'2007-09-14 19:10:38',3310504014,1),(625265,425695079,16047254,427965,1,'2007-09-14 19:10:38',3310504036,1),(625266,425699377,16048198,427965,1,'2007-09-14 19:10:15',3310504037,1),(625267,425707721,16062532,427965,1,'2007-09-14 19:10:15',3310504037,1),(625268,425708858,16070085,427965,1,'2007-09-14 19:10:11',3310504037,1),(625269,425710375,16078067,427965,1,'2007-09-14 19:10:11',3310504037,1),(625270,425715495,16091199,427965,1,'2007-09-14 19:08:20',3310504037,1),(625271,425715559,16095319,427965,1,'2007-09-14 19:08:20',3310504039,1),(625272,425716218,16112147,426786,1,'2007-09-14 10:13:42',3310504039,1),(625273,425718747,16117039,426786,1,'2007-09-14 10:13:42',3310504039,1),(625274,425723902,16146131,427965,1,'2007-09-14 19:08:20',3310504039,1),(625275,425725699,16151801,426786,1,'2007-09-14 10:13:42',3310504045,1),(625276,425728101,16160040,426786,1,'2007-09-14 10:13:42',3310504056,1),(625277,425729084,16165137,427965,1,'2007-09-14 19:43:57',3310504056,1),(625293,425746312,16207325,495907,1,'2008-07-15 19:46:04',3310504058,2),(625294,425754781,16222517,495907,1,'2008-07-15 19:48:35',3310504059,3),(625295,425765336,16246378,495907,1,'2008-07-15 19:48:35',3310504059,2),(625296,425770772,16255219,495907,1,'2008-07-15 19:48:35',3310504059,2),(625297,425775133,16258480,495907,1,'2008-07-15 19:48:35',3310504059,2),(625298,425779620,16270840,495907,1,'2008-07-15 19:48:35',3310504145,2),(625299,425780442,16292898,495907,1,'2008-07-15 19:48:35',3310504145,2),(625300,425784044,16300366,495907,1,'2008-07-15 19:48:35',3310504148,2),(625301,425785561,16319334,495907,1,'2008-07-15 19:48:35',3310504150,2),(625302,425783033,16329119,495907,1,'2008-07-15 19:48:35',3310504150,2),(625303,425783602,16348946,495907,1,'2008-07-15 19:50:23',3310504150,2),(625304,425789795,16374952,495907,1,'2008-07-15 19:50:23',3310504156,2),(625305,425787963,16390316,495907,1,'2008-07-15 19:50:23',3310504156,2),(625306,425797064,16404478,495907,1,'2008-07-15 19:50:57',3310504156,2),(625307,425799781,16416409,495907,1,'2008-07-15 19:50:57',3310504156,2),(26609114,424993792,15130420,434787,1,'2007-09-15 15:33:35',3310491403,1),(45160875,425835415,14617491,110477,1,'2008-12-04 18:28:50',3310502109,5),(45160879,425822776,14579726,110477,1,'2008-12-04 18:28:50',3310502103,5),(45160885,425754519,14572859,110477,1,'2008-12-04 18:28:50',3310502099,5),(45160890,425726708,14524794,110477,1,'2008-12-04 18:28:50',3310502085,5),(45160893,425681197,14466429,110477,1,'2008-12-04 18:28:50',3310501998,5),(45160897,425951686,14751387,110477,1,'2008-12-04 18:28:48',3310502320,5),(45160899,425928939,14737654,110477,1,'2008-12-04 18:28:49',3310502309,5),(45160902,425901136,14734221,110477,1,'2008-12-04 18:28:49',3310502308,5),(45160904,425880560,14747220,110477,1,'2008-12-04 18:28:49',3310502305,4),(45160908,425855560,14719440,110477,1,'2008-12-04 18:28:49',3310502282,4),(45160910,425830560,14688890,110477,1,'2008-12-04 18:28:49',3310502111,4),(45160922,426499887,15166808,784366,1,'2008-11-23 16:35:10',3310503520,4),(45160924,426497362,15129042,784366,1,'2008-11-23 16:35:10',3310503498,4),(45160947,426014867,14706755,110477,1,'2008-12-04 18:28:48',3310502302,5),(45160950,425979486,14747954,110477,1,'2008-12-04 18:28:48',3310502321,6),(45160954,426411500,14765120,784366,1,'2008-11-23 16:35:10',3310503088,4),(45160958,426224900,14663107,784366,1,'2008-11-23 16:35:12',3310502364,7),(45160962,426464534,14957381,784366,1,'2008-11-23 16:35:10',3310503444,4),(45160967,426456958,14878416,784366,1,'2008-11-23 16:35:10',3310503100,4),(45160974,426497362,15091277,784366,1,'2008-11-23 16:35:10',3310503496,4),(45160977,426479685,15043211,784366,1,'2008-11-23 16:35:10',3310503447,4),(45161058,426561110,15547220,784366,1,'2008-11-23 16:35:09',3310503630,3),(45161062,426535206,15582609,784366,1,'2008-11-23 16:35:09',3310503627,4),(45161066,426530156,15622091,784366,1,'2008-11-23 16:35:08',3310503649,4),(45161067,426525738,15652990,784366,1,'2008-11-23 16:35:08',3310503649,4),(45161204,426483330,15230560,784366,1,'2008-11-23 16:35:10',3310503479,3),(45161208,426522220,15244440,784366,1,'2008-11-23 16:35:10',3310503522,3),(45161227,426295915,16118192,784366,1,'2008-11-23 16:35:05',3310504994,4),(45161231,426280127,16069269,784366,1,'2008-11-23 16:35:06',3310504992,4),(45161233,426273181,16014337,784366,1,'2008-11-23 16:35:07',3310504287,4),(45161238,426307913,15973138,784366,1,'2008-11-23 16:35:07',3310504969,4),(45161251,426355273,16260671,784366,1,'2008-11-23 16:35:05',3310505092,4),(45161256,426323069,16200589,784366,1,'2008-11-23 16:35:05',3310505001,4),(45161262,426307282,16167974,784366,1,'2008-11-23 16:35:05',3310505001,4),(45161265,426444299,15791177,784366,1,'2008-11-23 16:35:08',3310503614,4),(45161269,426475866,15751695,784366,1,'2008-11-23 16:35:08',3310503613,4),(45161277,426492911,15713929,784366,1,'2008-11-23 16:35:08',3310503613,4),(45161283,426513112,15675306,784366,1,'2008-11-23 16:35:08',3310503650,4),(45161289,426369164,15938806,784366,1,'2008-11-23 16:35:07',3310504973,4),(45161296,426391895,15890741,784366,1,'2008-11-23 16:35:07',3310504978,4),(45161302,426409574,15840101,784366,1,'2008-11-23 16:35:07',3310504976,4),(45161308,426429778,15815210,784366,1,'2008-11-23 16:35:08',3310503611,4),(45161330,426308330,16950000,784366,1,'2008-11-23 16:35:01',3310505505,3),(45161333,426291670,16991670,784366,1,'2008-11-23 16:35:00',3310505506,3),(45161344,426327780,16911110,784366,1,'2008-11-23 16:35:01',3310505483,3),(45181716,426174178,14623441,4133451,1,'2010-03-15 12:47:53',3310502360,4),(51110488,424847502,14917003,592895,1,'2008-07-25 21:28:01',3310490863,5),(51110489,424844591,14912196,592895,1,'2008-07-25 21:28:01',3310490863,2),(51110491,424844528,14910994,592895,1,'2008-07-25 21:28:01',3310490863,2),(51110493,424843895,14910308,592895,1,'2008-07-25 21:28:01',3310490863,2),(51110495,424842888,14910345,592895,1,'2008-07-25 21:28:01',3310490863,2),(51110496,424842445,14910775,592895,1,'2008-07-25 21:28:01',3310490863,2),(51110498,424842122,14912883,592895,1,'2008-07-25 21:28:02',3310490863,3),(51110499,424842882,14913913,592895,1,'2008-07-25 21:28:02',3310490863,3),(51110501,424843831,14914084,592895,1,'2008-07-25 21:28:02',3310490863,3),(51110502,424849275,14919320,592895,1,'2008-07-25 22:02:15',3310490874,7),(51111214,424677313,14916363,508959,1,'2007-09-24 18:39:54',3310490811,1),(51111216,424681373,14917652,508959,1,'2007-09-24 18:39:54',3310490811,1),(51111218,424685366,14919282,508959,1,'2007-09-24 18:39:54',3310490814,1),(51111220,424689157,14920253,434787,1,'2007-09-15 15:24:53',3310490814,1),(51111222,424693209,14921408,508959,1,'2007-09-24 18:39:54',3310490814,1),(51111223,424697434,14923825,434787,1,'2007-09-15 15:24:53',3310490814,1),(51111226,424700374,14926036,508959,1,'2007-09-24 18:39:54',3310490814,1),(51111228,424702667,14927482,508959,1,'2007-09-24 18:39:54',3310490814,1),(51111229,424704976,14928559,508959,1,'2007-09-24 18:39:54',3310490814,1),(51111231,424707140,14928726,434787,1,'2007-09-15 15:24:52',3310490814,1),(51111232,424710217,14926263,508959,1,'2007-09-24 18:39:54',3310490814,1),(51111234,424712653,14924229,508959,1,'2007-09-24 18:39:54',3310490815,1),(51111236,424715202,14923357,508959,1,'2007-09-24 18:39:54',3310490815,1),(51111238,424717599,14924075,508959,1,'2007-09-24 18:39:54',3310490815,1),(51111239,424721813,14926893,508959,1,'2007-09-24 18:39:54',3310490815,1),(51111241,424725420,14929417,508959,1,'2007-09-24 18:39:54',3310490815,1),(51111244,424730160,14929298,508959,1,'2007-09-24 18:39:54',3310490815,1),(51111245,424732120,14924517,508959,1,'2007-09-24 18:39:54',3310490815,1),(51111247,424734485,14916877,508959,1,'2007-09-24 18:39:54',3310490815,1),(51111248,424736992,14910081,434787,1,'2007-09-15 15:24:50',3310490815,1),(51111250,424740856,14906846,508959,1,'2007-09-24 18:39:54',3310490858,1),(51111251,424743955,14904108,508959,1,'2007-09-24 18:39:54',3310490858,1),(51111253,424747340,14904050,434787,1,'2007-09-15 15:24:51',3310490858,1),(51111254,424750434,14904726,508959,1,'2007-09-24 18:39:54',3310490858,1),(51111256,424753143,14905178,508959,1,'2007-09-24 18:39:54',3310490858,1),(51111257,424756886,14903817,508959,1,'2007-09-24 18:39:54',3310490858,1),(51111259,424760469,14903137,434787,1,'2007-09-15 15:24:49',3310490858,1),(51111260,424763119,14903020,508959,1,'2007-09-24 18:39:54',3310490858,1),(51111262,424767085,14903025,434787,1,'2007-09-15 15:24:50',3310490859,1),(51111263,424772493,14902004,508959,1,'2007-09-24 18:39:54',3310490859,1),(51111265,424777773,14899603,508959,1,'2007-09-24 18:39:54',3310490859,1),(51111266,424784717,14892353,434787,1,'2007-09-15 15:24:47',3310490859,1),(51111268,424790334,14886523,508959,1,'2007-09-24 18:39:54',3310490857,1),(51111270,424793845,14884688,434787,1,'2007-09-15 15:24:48',3310490860,1),(51111271,424799476,14884529,508959,1,'2007-09-24 18:39:54',3310490860,1),(51111273,424804414,14885945,508959,1,'2007-09-24 18:39:54',3310490860,1),(51118071,425403068,17242365,206510,1,'2008-12-06 20:13:39',3310504578,2),(51118073,425405092,17245369,206510,1,'2008-12-06 20:13:39',3310504578,2),(51118074,425407052,17247172,206510,1,'2008-12-06 20:13:39',3310504578,2),(51118076,425408633,17248116,206510,1,'2008-12-06 20:13:39',3310504578,2),(51118077,425410910,17248631,426786,1,'2007-09-14 10:14:01',3310504578,1),(51118078,425413313,17248030,426786,1,'2007-09-14 10:14:01',3310504578,1),(51118080,425414451,17247258,426786,1,'2007-09-14 10:14:01',3310504578,1),(51118081,425415716,17246743,426786,1,'2007-09-14 10:14:01',3310504578,1),(51118082,425416285,17246914,426786,1,'2007-09-14 10:14:01',3310504578,1),(51118083,425416791,17247429,426786,1,'2007-09-14 10:14:01',3310504578,1),(51118085,425416791,17248631,426786,1,'2007-09-14 10:14:01',3310504578,1),(51118086,425416538,17249833,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118087,425415842,17250605,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118088,425414704,17250948,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118090,425412933,17251034,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118091,425410783,17251721,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118092,425408886,17253266,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118094,425406799,17254639,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118095,425404712,17255326,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118096,425402689,17254811,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118097,425401044,17253609,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118099,425398009,17250176,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118100,425396112,17247258,426786,1,'2007-09-14 10:14:01',3310493655,1),(51118102,425395606,17245284,426786,1,'2007-09-14 10:14:01',3310493655,1),(51118103,425394467,17243996,426786,1,'2007-09-14 10:14:01',3310493655,1),(51118104,425393392,17243739,426786,1,'2007-09-14 10:14:01',3310493655,1),(51118105,425392570,17244597,426786,1,'2007-09-14 10:14:01',3310493655,1),(51118106,425392507,17246228,426786,1,'2007-09-14 10:14:01',3310493655,1),(51118107,425393456,17248373,426786,1,'2007-09-14 10:14:01',3310493655,1),(51118108,425394784,17250863,426786,1,'2007-09-14 10:14:01',3310493661,1),(51118110,425397313,17254982,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118111,425399527,17258416,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118113,425402183,17260476,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118114,425404523,17261248,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118115,425407305,17262106,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118117,425409582,17262965,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118118,425412111,17264252,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118119,425413756,17265969,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118121,425415842,17268200,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118122,425417297,17270174,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118123,425419321,17271805,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118124,425422609,17273264,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118125,425426719,17275153,426786,1,'2007-09-14 10:14:01',3310504585,1),(51118127,425429439,17276698,426786,1,'2007-09-14 10:14:01',3310504585,1),(51118128,425431399,17276869,426786,1,'2007-09-14 10:14:01',3310504585,1),(51118129,425432790,17276354,206510,1,'2008-12-06 20:11:10',3310504585,2),(51118130,425433865,17275496,206510,1,'2008-12-06 20:11:10',3310504585,2),(51118131,425434877,17275582,206510,1,'2008-12-06 20:11:11',3310504585,2),(51118132,425435446,17276869,206510,1,'2008-12-06 20:11:11',3310504585,2),(51118133,425435446,17278157,206510,1,'2008-12-06 20:11:11',3310504585,2),(51118134,425434814,17278929,206510,1,'2008-12-06 20:11:11',3310504585,2),(51118135,425433612,17279444,206510,1,'2008-12-06 20:11:32',3310504585,4),(51118136,425431905,17279444,206510,1,'2008-12-06 20:11:32',3310504585,3),(51118137,425428490,17279444,206510,1,'2008-12-06 20:11:33',3310504585,3),(51118138,425424506,17279015,206510,1,'2008-12-06 20:11:33',3310504584,3),(51118140,425420269,17278157,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118141,425417423,17277384,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118142,425414262,17275925,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118143,425410151,17274552,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118144,425407368,17273865,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118145,425405471,17273865,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118146,425402878,17274294,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118148,425400918,17275668,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118149,425398894,17277213,426786,1,'2007-09-14 10:14:01',3310504584,1),(51118150,425396618,17278500,426786,1,'2007-09-14 10:14:01',3310493661,1),(51118151,425393582,17278157,426786,1,'2007-09-14 10:14:01',3310493661,1),(51118152,425389788,17276183,426786,1,'2007-09-14 10:14:01',3310493661,1),(51118153,425384981,17273522,426786,1,'2007-09-14 10:14:01',3310493661,1),(51118155,425380491,17271204,426786,1,'2007-09-14 10:14:01',3310493661,1),(51118156,425377708,17268629,426786,1,'2007-09-14 10:14:01',3310493661,1),(51118157,425376127,17266741,206510,1,'2008-12-06 20:10:04',3310493661,2),(51118159,425374862,17266655,206510,1,'2008-12-06 20:10:04',3310493661,2),(51118160,425374103,17267514,206510,1,'2008-12-06 20:10:04',3310493661,2),(51118161,425373850,17269316,206510,1,'2008-12-06 20:10:04',3310493661,2),(51118162,425374483,17270689,206510,1,'2008-12-06 20:10:04',3310493661,2),(51118164,425375684,17271719,206510,1,'2008-12-06 20:10:15',3310493661,4),(51118165,425376886,17273436,206510,1,'2008-12-06 20:10:15',3310493661,3),(51118166,425378024,17276783,206510,1,'2008-12-06 20:10:15',3310493661,3),(51118168,425378973,17279272,206510,1,'2008-12-06 20:10:15',3310493661,3),(51118169,425380807,17282448,206510,1,'2008-12-06 20:10:24',3310493661,4),(51118170,425383590,17285452,206510,1,'2008-12-06 20:10:24',3310493661,2),(51118171,425388143,17290173,206510,1,'2008-12-06 20:10:24',3310493661,2),(51118173,425391242,17292405,206510,1,'2008-12-06 20:10:24',3310493661,2),(51118174,425393961,17293263,206510,1,'2008-12-06 20:10:24',3310493661,2),(51118176,425397629,17293349,206510,1,'2008-12-06 20:10:24',3310504584,2),(51118177,425400728,17293950,206510,1,'2008-12-06 20:10:24',3310504584,2),(51118178,425404270,17295151,206510,1,'2008-12-06 20:10:24',3310504584,2),(51118179,425408760,17296954,206510,1,'2008-12-06 20:10:24',3310504584,2),(51118180,425411732,17297984,206510,1,'2008-12-06 20:10:24',3310504584,2),(51118181,425416918,17298842,206510,1,'2008-12-06 20:10:24',3310504584,2),(51118182,425420965,17299614,206510,1,'2008-12-06 20:10:24',3310504584,2),(51118183,425426467,17301503,206510,1,'2008-12-06 20:10:24',3310504585,2),(51118184,425435257,17304249,206510,1,'2008-12-06 20:10:24',3310504587,2),(51118185,425438608,17305365,206510,1,'2008-12-06 20:10:24',3310504587,2),(51118186,425443351,17305708,206510,1,'2008-12-06 20:10:24',3310504587,2),(51118187,425448030,17305708,206510,1,'2008-12-06 20:10:24',3310504587,2),(51118188,425452899,17306223,206510,1,'2008-12-06 20:10:24',3310504590,2),(51118189,425458338,17307682,206510,1,'2008-12-06 20:10:24',3310504590,2),(51118190,425462574,17308970,206510,1,'2008-12-06 20:10:24',3310504590,2),(51118191,425468012,17310000,206510,1,'2008-12-06 20:09:53',3310504590,4),(51118192,425471048,17312060,206510,1,'2008-12-06 20:09:53',3310504590,4),(51118193,425473703,17315236,206510,1,'2008-12-06 20:09:53',3310504590,4),(51118194,425479711,17320557,206510,1,'2008-12-06 20:09:53',3310504591,4),(51118205,425475600,17321930,206510,1,'2008-12-06 20:09:05',3310504590,3),(51118206,425471237,17319956,206510,1,'2008-12-06 20:09:05',3310504590,3),(51118207,425468771,17318583,206510,1,'2008-12-06 20:09:05',3310504590,3),(51118208,425465610,17317124,206510,1,'2008-12-06 20:09:05',3310504590,3),(51118209,425462258,17317381,206510,1,'2008-12-06 20:09:05',3310504590,3),(51118210,425457199,17318755,206510,1,'2008-12-06 20:09:05',3310504590,3),(51118211,425453532,17319699,206510,1,'2008-12-06 20:09:06',3310504590,3),(51118263,425394594,17232066,206510,1,'2008-12-06 20:13:38',3310493655,2),(51118641,425405408,17190352,206510,1,'2008-12-06 20:14:08',3310504576,4),(51118642,425402815,17192755,206510,1,'2008-12-06 20:14:08',3310504576,4),(51118653,425397575,17209422,206510,1,'2008-12-06 20:14:04',3310504578,5),(51118654,425395542,17205458,206510,1,'2008-12-06 20:14:04',3310493655,5),(51118655,425391558,17199965,206510,1,'2008-12-06 20:13:34',3310493655,2),(51118656,425387068,17193785,206510,1,'2008-12-06 20:13:35',3310493653,2),(51118658,425383843,17191725,206510,1,'2008-12-06 20:13:35',3310493653,2),(51118659,425380364,17191554,206510,1,'2008-12-06 20:13:35',3310493653,2),(51118661,425378214,17192927,206510,1,'2008-12-06 20:13:35',3310493653,2),(51118662,425376507,17194815,206510,1,'2008-12-06 20:13:36',3310493655,2),(51118663,425375368,17198248,206510,1,'2008-12-06 20:13:36',3310493655,2),(51118664,425375115,17202540,206510,1,'2008-12-06 20:13:37',3310493655,2),(51118666,425375874,17206488,206510,1,'2008-12-06 20:13:37',3310493655,2),(51118667,425377202,17210093,206510,1,'2008-12-06 20:13:37',3310493655,2),(51118668,425380301,17214728,206510,1,'2008-12-06 20:13:38',3310493655,2),(51118669,425384159,17219534,206510,1,'2008-12-06 20:13:38',3310493655,2),(51118671,425388649,17224856,206510,1,'2008-12-06 20:13:38',3310493655,2),(51119058,425419447,17109585,426786,1,'2007-09-14 10:13:57',3310504490,1),(51119060,425417993,17114220,426786,1,'2007-09-14 10:13:57',3310504490,1),(51119061,425415716,17116795,426786,1,'2007-09-14 10:13:57',3310504490,1),(51119062,425412681,17117653,206510,1,'2008-12-06 20:15:08',3310504490,6),(51119064,425410341,17116967,206510,1,'2008-12-06 20:15:08',3310504490,6),(51119065,425408380,17115336,206510,1,'2008-12-06 20:15:09',3310504490,6),(51119066,425406989,17114821,206510,1,'2008-12-06 20:15:09',3310504490,6),(51119067,425406357,17114907,206510,1,'2008-12-06 20:15:09',3310504490,6),(51119069,425405851,17115937,206510,1,'2008-12-06 20:15:09',3310504490,6),(51119070,425405724,17117138,206510,1,'2008-12-06 20:15:09',3310504490,6),(51119071,425405914,17118254,206510,1,'2008-12-06 20:15:09',3310504490,6),(51119072,425406989,17119284,206510,1,'2008-12-06 20:15:09',3310504490,6),(51119073,425409708,17120829,206510,1,'2008-12-06 20:15:09',3310504490,6),(51119075,425413439,17122803,206510,1,'2008-12-06 20:15:09',3310504490,6),(51119076,425417360,17125121,206510,1,'2008-12-06 20:15:10',3310504490,6),(51119077,425419637,17126494,206510,1,'2008-12-06 20:15:10',3310504490,6),(51119078,425421660,17126494,206510,1,'2008-12-06 20:15:10',3310504490,6),(51119079,425423241,17125292,206510,1,'2008-12-06 20:15:10',3310504490,6),(51119081,425424190,17123490,206510,1,'2008-12-06 20:15:10',3310504490,6),(51119082,425424633,17122116,206510,1,'2008-12-06 20:15:10',3310504491,6),(51119083,425424822,17119198,206510,1,'2008-12-06 20:15:11',3310504491,6),(51119085,425424316,17116795,206510,1,'2008-12-06 20:15:11',3310504490,6),(51119086,425424822,17115593,206510,1,'2008-12-06 20:15:11',3310504491,6),(51119088,425425455,17114993,206510,1,'2008-12-06 20:15:11',3310504491,6),(51119089,425426340,17114993,206510,1,'2008-12-06 20:15:11',3310504491,6),(51119090,425426783,17116194,206510,1,'2008-12-06 20:15:11',3310504491,6),(51119091,425426593,17117911,206510,1,'2008-12-06 20:15:12',3310504491,6),(51119093,425426467,17120400,206510,1,'2008-12-06 20:15:12',3310504491,6),(51119094,425426467,17123061,206510,1,'2008-12-06 20:15:12',3310504491,6),(51119096,425426467,17124434,206510,1,'2008-12-06 20:15:12',3310504491,6),(51119097,425426467,17127009,206510,1,'2008-12-06 20:15:12',3310504491,6),(51119098,425425265,17130442,206510,1,'2008-12-06 20:15:12',3310504491,6),(51119099,425423621,17133618,206510,1,'2008-12-06 20:15:12',3310504490,6),(51119101,425421660,17136364,206510,1,'2008-12-06 20:15:12',3310504490,6),(51119102,425418499,17139368,206510,1,'2008-12-06 20:15:12',3310504576,6),(51119103,425415526,17140570,206510,1,'2008-12-06 20:15:13',3310504576,6),(51119104,425412807,17140484,206510,1,'2008-12-06 20:15:13',3310504576,6),(51119105,425407432,17138939,206510,1,'2008-12-06 20:15:13',3310504576,8),(51119106,425404459,17136708,206510,1,'2008-12-06 20:15:03',3310504490,7),(51119107,425403321,17135420,206510,1,'2008-12-06 20:15:03',3310504490,7),(51119108,425402056,17135163,206510,1,'2008-12-06 20:15:03',3310504490,7),(51119109,425401424,17135935,206510,1,'2008-12-06 20:15:04',3310504490,7),(51119110,425401234,17137223,206510,1,'2008-12-06 20:15:04',3310504490,7),(51119111,425401740,17138853,206510,1,'2008-12-06 20:15:04',3310504490,7),(51119112,425404396,17141686,206510,1,'2008-12-06 20:15:04',3310504576,8),(51119113,425405787,17144175,206510,1,'2008-12-06 20:14:56',3310504576,5),(51119114,425407368,17147866,206510,1,'2008-12-06 20:14:56',3310504576,5),(51119116,425408949,17151299,206510,1,'2008-12-06 20:14:56',3310504576,5),(51119117,425410973,17156449,206510,1,'2008-12-06 20:14:56',3310504576,5),(51119118,425412301,17159796,206510,1,'2008-12-06 20:14:56',3310504576,5),(51119119,425414198,17161770,206510,1,'2008-12-06 20:14:57',3310504576,5),(51119120,425416728,17162800,206510,1,'2008-12-06 20:14:57',3310504576,5),(51119121,425419763,17162371,206510,1,'2008-12-06 20:14:57',3310504576,6),(51119123,425422293,17161169,206510,1,'2008-12-06 20:14:16',3310504576,5),(51119124,425423178,17161770,206510,1,'2008-12-06 20:14:17',3310504576,5),(51119125,425423747,17162800,206510,1,'2008-12-06 20:14:17',3310504576,5),(51119126,425423558,17164431,206510,1,'2008-12-06 20:14:17',3310504576,5),(51119127,425421913,17167864,206510,1,'2008-12-06 20:14:17',3310504576,6),(51119128,425416222,17179709,206510,1,'2008-12-06 20:14:08',3310504576,4),(51119129,425414325,17183314,206510,1,'2008-12-06 20:14:08',3310504576,4),(51119130,425411732,17185975,206510,1,'2008-12-06 20:14:08',3310504576,4),(51119131,425408191,17188635,206510,1,'2008-12-06 20:14:08',3310504576,4),(51119407,425483947,17055169,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119409,425479900,17055169,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119410,425476169,17055169,426786,1,'2007-09-14 10:13:57',3310504492,1),(51119411,425473071,17056284,426786,1,'2007-09-14 10:13:57',3310504492,1),(51119413,425470162,17058430,426786,1,'2007-09-14 10:13:57',3310504492,1),(51119414,425466811,17060833,426786,1,'2007-09-14 10:13:57',3310504492,1),(51119416,425463902,17063580,426786,1,'2007-09-14 10:13:57',3310504492,1),(51119417,425461246,17067099,426786,1,'2007-09-14 10:13:57',3310504492,1),(51119419,425457832,17070961,426786,1,'2007-09-14 10:13:57',3310504492,1),(51119420,425452963,17074824,426786,1,'2007-09-14 10:13:57',3310504492,1),(51119421,425447967,17077999,426786,1,'2007-09-14 10:13:57',3310504489,1),(51119422,425443477,17079888,426786,1,'2007-09-14 10:13:57',3310504489,1),(51119424,425440315,17080918,426786,1,'2007-09-14 10:13:57',3310504489,1),(51119425,425435257,17083664,426786,1,'2007-09-14 10:13:57',3310504489,1),(51119426,425431715,17086497,426786,1,'2007-09-14 10:13:57',3310504491,1),(51119427,425428996,17089930,426786,1,'2007-09-14 10:13:57',3310504491,1),(51119428,425426846,17092934,426786,1,'2007-09-14 10:13:57',3310504491,1),(51119430,425424822,17096024,426786,1,'2007-09-14 10:13:57',3310504491,1),(51119431,425422546,17099715,426786,1,'2007-09-14 10:13:57',3310504490,1),(51119432,425421028,17102890,426786,1,'2007-09-14 10:13:57',3310504490,1),(51119433,425420016,17107010,426786,1,'2007-09-14 10:13:57',3310504490,1),(51119435,425419004,17112246,426786,1,'2007-09-14 10:13:57',3310504490,1),(51119541,425476233,17041436,426786,1,'2007-09-14 10:13:57',3310504492,1),(51119542,425480406,17042036,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119543,425484200,17043925,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119545,425486856,17044182,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119546,425489701,17043581,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119547,425492863,17041350,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119548,425495708,17038517,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119550,425497289,17036887,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119551,425498111,17036543,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119553,425498996,17037058,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119554,425498996,17038260,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119555,425498617,17039633,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119556,425496088,17042723,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119558,425493369,17045813,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119559,425490333,17049675,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119560,425487109,17053109,426786,1,'2007-09-14 10:13:57',3310504493,1),(51119613,425465483,17042809,426786,1,'2007-09-14 10:13:55',3310504492,1),(51119614,425465926,17042723,426786,1,'2007-09-14 10:13:55',3310504492,1),(51119615,425467759,17042122,426786,1,'2007-09-14 10:13:55',3310504492,1),(51119616,425470795,17041350,426786,1,'2007-09-14 10:13:55',3310504492,1),(51119617,425473703,17041264,426786,1,'2007-09-14 10:13:55',3310504492,1),(51119951,425431652,17035342,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119952,425429945,17034569,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119953,425428996,17034912,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119954,425428300,17035857,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119956,425428490,17037144,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119957,425429502,17038346,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119958,425432790,17038947,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119959,425436648,17038775,426786,1,'2007-09-14 09:57:16',3310504489,1),(51119960,425439240,17038517,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119961,425441138,17037659,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119962,425442529,17037230,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119964,425443288,17037487,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119965,425443920,17038689,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119966,425443541,17039891,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119968,425442592,17041006,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119969,425440379,17041092,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119970,425437280,17041779,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119972,425434434,17043152,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119973,425428680,17046156,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119974,425426340,17047015,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119976,425424190,17047272,426786,1,'2007-09-14 10:13:55',3310504488,1),(51119977,425422356,17047015,426786,1,'2007-09-14 10:13:55',3310504488,1),(51119978,425421091,17047530,426786,1,'2007-09-14 10:13:55',3310504488,1),(51119979,425420522,17048645,426786,1,'2007-09-14 10:13:55',3310504488,1),(51119980,425420522,17050019,426786,1,'2007-09-14 10:13:55',3310504488,1),(51119981,425421471,17051220,426786,1,'2007-09-14 09:57:16',3310504488,1),(51119983,425422609,17051220,426786,1,'2007-09-14 09:57:16',3310504488,1),(51119984,425424063,17050362,426786,1,'2007-09-14 10:13:55',3310504488,1),(51119986,425425518,17050019,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119987,425427478,17049933,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119988,425430387,17050448,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119989,425435889,17050705,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119990,425438355,17050448,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119991,425442971,17049075,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119992,425448410,17047701,426786,1,'2007-09-14 10:13:55',3310504489,1),(51119993,425453089,17046500,426786,1,'2007-09-14 10:13:55',3310504492,1),(51119994,425458464,17044783,426786,1,'2007-09-14 10:13:55',3310504492,1),(51120868,425564816,16896382,426786,1,'2007-09-14 10:13:53',3310504478,1),(51120869,425556470,16903677,426786,1,'2007-09-14 10:13:55',3310504475,1),(51120871,425547871,16911316,426786,1,'2007-09-14 10:13:55',3310504475,1),(51120872,425540095,16918698,426786,1,'2007-09-14 10:13:55',3310504475,1),(51120873,425533203,16927195,426786,1,'2007-09-14 10:13:55',3310504496,1),(51120874,425529093,16933117,426786,1,'2007-09-14 10:13:55',3310504496,1),(51120876,425522932,16942897,427965,1,'2007-09-14 18:53:33',3310504496,1),(51120877,425514713,16955514,427965,1,'2007-09-14 18:53:55',3310504496,1),(51120878,425507659,16965990,426786,1,'2007-09-14 10:13:55',3310504496,1),(51120879,425504244,16971312,426786,1,'2007-09-14 10:13:55',3310504485,1),(51120881,425501462,16976118,426786,1,'2007-09-14 10:13:55',3310504487,1),(51120882,425499059,16980410,426786,1,'2007-09-14 10:13:55',3310504487,1),(51120883,425497289,16984101,426786,1,'2007-09-14 10:13:55',3310504487,1),(51120884,425494444,16988306,426786,1,'2007-09-14 10:13:55',3310504487,1),(51120885,425490903,16992855,426786,1,'2007-09-14 10:13:55',3310504487,1),(51120887,425486160,16997490,426786,1,'2007-09-14 10:13:55',3310504487,1),(51120888,425482366,16999894,426786,1,'2007-09-14 10:13:55',3310504487,1),(51120889,425480216,17000924,426786,1,'2007-09-14 10:13:55',3310504487,1),(51120890,425476739,17002297,426786,1,'2007-09-14 10:13:55',3310504486,1),(51120891,425470731,17006245,427965,1,'2007-09-14 20:50:22',3310504486,1),(51120892,425465104,17010107,426786,1,'2007-09-14 10:13:55',3310504486,1),(51120893,425459602,17014485,426786,1,'2007-09-14 10:13:55',3310504486,1),(51120895,425454101,17019549,426786,1,'2007-09-14 10:13:55',3310504486,1),(51120896,425449232,17024870,426786,1,'2007-09-14 10:13:55',3310504483,1),(51120897,425443288,17030707,426786,1,'2007-09-14 10:13:55',3310504489,1),(51120898,425439430,17033797,426786,1,'2007-09-14 10:13:55',3310504489,1),(51120899,425435762,17034998,426786,1,'2007-09-14 10:13:55',3310504489,1),(51120900,425433739,17035427,426786,1,'2007-09-14 10:13:55',3310504489,1),(51120956,425577713,16883593,426786,1,'2007-09-14 10:13:53',3310504478,1),(51120957,425575311,16887112,426786,1,'2007-09-14 10:13:53',3310504478,1),(51120959,425571454,16891489,426786,1,'2007-09-14 10:13:53',3310504478,1),(51121326,425650035,16796647,426786,1,'2007-09-14 10:13:53',3310504515,1),(51121327,425647064,16796647,426786,1,'2007-09-14 10:13:53',3310504515,1),(51121329,425645484,16797333,426786,1,'2007-09-14 10:13:53',3310504515,1),(51121330,425643271,16798706,426786,1,'2007-09-14 10:13:53',3310504514,1),(51121331,425640300,16801196,426786,1,'2007-09-14 10:13:53',3310504514,1),(51121332,425620380,16821803,198831,1,'2008-04-20 16:24:55',3310504520,2),(51121334,425615329,16827803,426786,1,'2007-09-14 10:13:53',3310504477,1),(51121335,425612168,16831751,426786,1,'2007-09-14 10:13:53',3310504477,1),(51121337,425609576,16836300,426786,1,'2007-09-14 10:13:53',3310504477,1),(51121338,425605657,16843682,426786,1,'2007-09-14 10:13:53',3310504477,1),(51121339,425601990,16848917,426786,1,'2007-09-14 10:13:53',3310504477,1),(51121341,425595795,16857758,426786,1,'2007-09-14 10:13:53',3310504477,1),(51121342,425588967,16866856,426786,1,'2007-09-14 10:13:53',3310504478,1),(51121362,425658253,16794501,426786,1,'2007-09-14 10:00:01',3310504515,1),(51121363,425654208,16796217,426786,1,'2007-09-14 10:13:53',3310504515,1),(51121951,425832890,16630135,426786,1,'2007-09-14 10:13:53',3310504189,1),(51121953,425835797,16632452,426786,1,'2007-09-14 10:13:53',3310504189,1),(51121955,425837440,16634770,426786,1,'2007-09-14 10:13:53',3310504360,1),(51121956,425838136,16636744,426786,1,'2007-09-14 10:13:53',3310504360,1),(51121957,425838325,16638546,426786,1,'2007-09-14 10:13:53',3310504360,1),(51121958,425838136,16640606,426786,1,'2007-09-14 10:13:53',3310504360,1),(51121959,425836998,16643353,426786,1,'2007-09-14 10:13:53',3310504360,1),(51121960,425835292,16645155,426786,1,'2007-09-14 10:13:53',3310504191,1),(51121962,425832827,16646014,426786,1,'2007-09-14 10:13:53',3310504191,1),(51121964,425828782,16645584,426786,1,'2007-09-14 10:13:53',3310504191,1),(51121965,425823537,16644469,426786,1,'2007-09-14 10:13:53',3310504189,1),(51121967,425818481,16644297,426786,1,'2007-09-14 10:13:53',3310504189,1),(51121968,425814879,16644469,426786,1,'2007-09-14 10:13:53',3310504189,1),(51121970,425812667,16643954,426786,1,'2007-09-14 10:13:53',3310504189,1),(51121972,425808180,16642237,426786,1,'2007-09-14 10:13:53',3310504188,1),(51121973,425797689,16638031,426786,1,'2007-09-14 10:13:53',3310504188,1),(51121974,425793075,16637087,426786,1,'2007-09-14 10:13:53',3310504188,1),(51121976,425791242,16637001,426786,1,'2007-09-14 10:13:53',3310504188,1),(51121977,425789030,16636486,426786,1,'2007-09-14 10:13:53',3310504188,1),(51121979,425787766,16635628,426786,1,'2007-09-14 10:13:53',3310504188,1),(51121981,425786502,16633997,426786,1,'2007-09-14 10:13:53',3310504188,1),(51121982,425783096,16631673,495907,1,'2008-07-15 20:10:14',3310504188,2),(51121984,425780315,16630815,495907,1,'2008-07-15 20:10:14',3310504185,2),(51121985,425778103,16630987,495907,1,'2008-07-15 20:10:14',3310504185,2),(51121987,425776649,16631931,495907,1,'2008-07-15 20:10:14',3310504185,2),(51121988,425774816,16637510,495907,1,'2008-07-15 20:10:14',3310504185,2),(51121989,425774683,16642838,426786,1,'2007-09-14 10:13:53',3310504185,1),(51121991,425773110,16648925,495907,1,'2008-07-15 20:10:14',3310504187,2),(51121992,425772029,16653567,426786,1,'2007-09-14 10:13:53',3310504187,1),(51121993,425770891,16658974,426786,1,'2007-09-14 10:13:53',3310504187,1),(51121995,425769311,16664639,426786,1,'2007-09-14 10:13:53',3310504187,1),(51121997,425767921,16671248,426786,1,'2007-09-14 10:13:53',3310504187,1),(51121998,425767169,16677507,495907,1,'2008-07-15 20:17:56',3310504187,2),(51122000,425766979,16680254,495907,1,'2008-07-15 20:18:38',3310504187,3),(51122001,425765329,16685667,426786,1,'2007-09-14 10:13:53',3310504187,1),(51122003,425761790,16693221,426786,1,'2007-09-14 10:13:53',3310504187,1),(51122005,425759135,16700774,426786,1,'2007-09-14 10:13:53',3310504529,1),(51122006,425757176,16706953,426786,1,'2007-09-14 10:13:53',3310504529,1),(51122007,425754648,16715193,426786,1,'2007-09-14 10:13:53',3310504529,1),(51122009,425752632,16720251,495907,1,'2008-07-15 20:26:14',3310504528,2),(51122010,425750736,16724885,495907,1,'2008-07-15 20:26:14',3310504528,2),(51122012,425747576,16728834,495907,1,'2008-07-15 20:26:14',3310504528,2),(51122014,425744914,16731244,426786,1,'2007-09-14 10:13:53',3310504528,1),(51122015,425743777,16733818,426786,1,'2007-09-14 10:13:53',3310504528,1),(51122016,425742646,16737588,495907,1,'2008-07-15 20:26:14',3310504528,2),(51122018,425739359,16742996,495907,1,'2008-07-15 20:26:14',3310504528,2),(51122020,425734359,16746178,426786,1,'2007-09-14 10:13:53',3310504528,1),(51122022,425731205,16749090,495907,1,'2008-07-15 20:26:14',3310504528,2),(51122023,425727027,16753045,426786,1,'2007-09-14 10:13:53',3310504528,1),(51122025,425722476,16759224,426786,1,'2007-09-14 10:13:53',3310504519,1),(51122027,425719884,16763430,426786,1,'2007-09-14 10:13:53',3310504519,1),(51122028,425716408,16767464,426786,1,'2007-09-14 10:13:53',3310504519,1),(51122029,425712742,16770554,426786,1,'2007-09-14 10:13:53',3310504519,1),(51122030,425708444,16773386,426786,1,'2007-09-14 10:13:53',3310504519,1),(51122032,425705978,16775189,426786,1,'2007-09-14 10:13:53',3310504519,1),(51122033,425701491,16778965,426786,1,'2007-09-14 10:13:53',3310504519,1),(51122034,425697572,16781798,426786,1,'2007-09-14 10:13:53',3310504518,1),(51122036,425693589,16783257,426786,1,'2007-09-14 10:13:53',3310504518,1),(51122038,425685309,16785489,426786,1,'2007-09-14 10:13:53',3310504518,1),(51122039,425680568,16786089,426786,1,'2007-09-14 10:13:53',3310504518,1),(51122041,425675953,16786261,426786,1,'2007-09-14 10:13:53',3310504518,1),(51122042,425672350,16786433,426786,1,'2007-09-14 10:13:53',3310504518,1),(51122044,425670201,16787205,426786,1,'2007-09-14 10:13:53',3310504515,1),(51122045,425667040,16789179,426786,1,'2007-09-14 10:13:53',3310504515,1),(51122790,425796748,16433231,495907,1,'2008-07-15 19:51:34',3310504158,2),(51122791,425797127,16441128,495907,1,'2008-07-15 19:51:34',3310504158,2),(51122792,425798833,16452114,495907,1,'2008-07-15 19:52:43',3310504158,2),(51122793,425800350,16458637,495907,1,'2008-07-15 19:52:43',3310504158,2),(51122795,425801867,16463616,495907,1,'2008-07-15 19:52:43',3310504158,2),(51122796,425803889,16470825,495907,1,'2008-07-15 19:52:43',3310504158,2),(51122797,425804205,16474001,495907,1,'2008-07-15 19:52:43',3310504158,2),(51122798,425804016,16477949,495907,1,'2008-07-15 19:52:43',3310504158,2),(51122800,425801361,16483528,495907,1,'2008-07-15 19:52:43',3310504180,2),(51122801,425798264,16491339,495907,1,'2008-07-15 19:52:43',3310504180,2),(51122802,425796242,16495115,495907,1,'2008-07-15 19:52:43',3310504180,2),(51122803,425794409,16496660,495907,1,'2008-07-15 19:52:54',3310504180,2),(51122804,425791059,16498119,495907,1,'2008-07-15 19:53:29',3310504180,2),(51122805,425789045,16498969,443749,1,'2007-09-17 01:56:34',3310504180,1),(51122806,425787710,16500523,495907,1,'2008-07-15 19:53:29',3310504180,2),(51122807,425787204,16504900,495907,1,'2008-07-15 19:53:29',3310504180,2),(51122808,425786193,16510050,495907,1,'2008-07-15 19:53:29',3310504180,2),(51122809,425782963,16517697,426786,1,'2007-09-14 10:13:53',3310504180,1),(51122810,425781193,16522675,426786,1,'2007-09-14 10:13:53',3310504177,1),(51122811,425780814,16525851,426786,1,'2007-09-14 10:13:53',3310504177,1),(51122812,425780119,16530142,426786,1,'2007-09-14 10:13:53',3310504177,1),(51122814,425778602,16534691,426786,1,'2007-09-14 10:13:53',3310504179,1),(51122815,425776516,16543188,426786,1,'2007-09-14 10:13:53',3310504179,1),(51122816,425775631,16547738,426786,1,'2007-09-14 10:13:53',3310504179,1),(51122817,425776011,16554003,426786,1,'2007-09-14 10:13:53',3310504179,1),(51122819,425776516,16557951,426786,1,'2007-09-14 10:13:53',3310504179,1),(51122820,425777970,16562243,426786,1,'2007-09-14 10:13:53',3310504179,1),(51122821,425779803,16567049,426786,1,'2007-09-14 10:13:53',3310504179,1),(51122822,425782141,16570912,426786,1,'2007-09-14 10:13:53',3310504182,1),(51122823,425787829,16577950,426786,1,'2007-09-14 10:13:53',3310504182,1),(51122824,425794655,16589194,426786,1,'2007-09-14 10:13:53',3310504182,1),(51122825,425800722,16598034,426786,1,'2007-09-14 10:13:53',3310504188,1),(51122826,425805083,16604042,426786,1,'2007-09-14 10:13:53',3310504188,1),(51122827,425808306,16607819,426786,1,'2007-09-14 10:13:53',3310504188,1),(51122828,425815069,16615200,426786,1,'2007-09-14 10:13:53',3310504189,1),(51122829,425822842,16622496,426786,1,'2007-09-14 10:13:53',3310504189,1),(51122830,425827898,16626187,426786,1,'2007-09-14 10:13:53',3310504189,1),(51123230,425784676,16355040,495907,1,'2008-07-15 19:50:23',3310504150,2),(51123231,425785435,16358130,495907,1,'2008-07-15 19:50:23',3310504150,2),(51123232,425787836,16367142,495907,1,'2008-07-15 19:50:23',3310504150,2),(51123233,425789100,16371433,495907,1,'2008-07-15 19:50:23',3310504156,2),(51123235,425788595,16383707,495907,1,'2008-07-15 19:50:23',3310504156,2),(51123236,425788974,16392548,495907,1,'2008-07-15 19:50:23',3310504156,2),(51123237,425792324,16398384,495907,1,'2008-07-15 19:50:57',3310504156,2),(51123238,425799149,16408941,495907,1,'2008-07-15 19:50:57',3310504156,2),(51123262,425782654,16338217,495907,1,'2008-07-15 19:49:01',3310504150,2),(51123907,425757309,16225006,495907,1,'2008-07-15 19:48:35',3310504059,2),(51123908,425758953,16227924,495907,1,'2008-07-15 19:48:35',3310504059,2),(51123909,425760090,16232302,495907,1,'2008-07-15 19:48:35',3310504059,2),(51123910,425762555,16236937,495907,1,'2008-07-15 19:48:35',3310504059,2),(51123911,425764135,16242172,495907,1,'2008-07-15 19:48:35',3310504059,2),(51123912,425766853,16249897,495907,1,'2008-07-15 19:48:35',3310504059,2),(51123913,425769192,16253760,495907,1,'2008-07-15 19:48:35',3310504059,2),(51123914,425773237,16257107,495907,1,'2008-07-15 19:48:35',3310504059,2),(51123916,425777218,16260540,495907,1,'2008-07-15 19:48:35',3310504145,2),(51123917,425778735,16262943,495907,1,'2008-07-15 19:48:35',3310504145,2),(51123918,425779241,16266205,495907,1,'2008-07-15 19:48:35',3310504145,2),(51123919,425778293,16279680,495907,1,'2008-07-15 19:48:35',3310504145,2),(51123920,425777850,16283972,495907,1,'2008-07-15 19:48:35',3310504145,2),(51123921,425778230,16287233,495907,1,'2008-07-15 19:48:35',3310504145,2),(51123922,425782401,16296847,495907,1,'2008-07-15 19:48:35',3310504148,2),(51123924,425785940,16304743,495907,1,'2008-07-15 19:48:35',3310504148,2),(51123925,425786762,16307232,495907,1,'2008-07-15 19:48:35',3310504148,2),(51123926,425786762,16311609,495907,1,'2008-07-15 19:48:35',3310504148,2),(51124044,425742519,16192305,495907,1,'2008-07-15 19:46:04',3310504056,2),(51124045,425744036,16197540,495907,1,'2008-07-15 19:46:04',3310504056,2),(51124046,425747576,16211788,495907,1,'2008-07-15 19:46:04',3310504058,2),(51124047,425748903,16215136,495907,1,'2008-07-15 19:46:04',3310504058,2),(51124048,425752000,16219084,495907,1,'2008-07-15 19:46:04',3310504058,2),(51124483,425719948,16120301,426786,1,'2007-09-14 10:07:07',3310504039,1),(51124484,425720390,16123734,426786,1,'2007-09-14 10:13:42',3310504039,1),(51124485,425720643,16132574,426786,1,'2007-09-14 10:13:42',3310504039,1),(51124486,425730566,16170683,426786,1,'2007-09-14 10:13:43',3310504056,1),(51124487,425732083,16175833,426786,1,'2007-09-14 10:13:43',3310504056,1),(51124488,425734548,16180983,426786,1,'2007-09-14 10:13:43',3310504056,1),(51124489,425737273,16183807,495907,1,'2008-07-15 19:46:04',3310504056,2),(51124490,425741066,16189129,495907,1,'2008-07-15 19:46:04',3310504056,2),(51124700,425722448,16140895,427965,1,'2007-09-14 19:08:20',3310504039,1),(51124890,425714168,16086307,427965,1,'2007-09-14 19:10:11',3310504037,1),(51124891,425714954,16089058,426786,1,'2007-09-14 10:13:42',3310504037,1),(51124892,425714891,16099959,426786,1,'2007-09-14 10:13:42',3310504039,1),(51124893,425714701,16104508,426786,1,'2007-09-14 10:13:42',3310504039,1),(51124895,425714891,16108284,426786,1,'2007-09-14 10:13:42',3310504039,1),(51124975,425712461,16083560,427965,1,'2007-09-14 19:10:11',3310504037,1),(51125152,425686067,16041508,426786,1,'2007-09-14 10:13:32',3310504036,1),(51125154,425687367,16043821,427965,1,'2007-09-14 19:10:38',3310504036,1),(51125155,425689074,16045280,427965,1,'2007-09-14 19:10:38',3310504036,1),(51125157,425690275,16045795,427965,1,'2007-09-14 19:10:38',3310504036,1),(51125159,425706204,16056781,427965,1,'2007-09-14 19:10:15',3310504037,1),(51125330,425673582,16014218,4963967,1,'2010-06-11 20:09:43',3310504014,2),(51125332,425673300,16012680,4963967,1,'2010-06-11 20:09:44',3310504014,2),(51125333,425672568,16012572,4963967,1,'2010-06-11 20:09:44',3310504014,2),(51125335,425672111,16013104,4963967,1,'2010-06-11 20:09:44',3310504014,2),(51125337,425672022,16013842,4963967,1,'2010-06-11 20:09:44',3310504014,2),(51125340,425672157,16014294,4963967,1,'2010-06-11 20:09:44',3310504014,2),(51125342,425672441,16014646,4963967,1,'2010-06-11 20:09:44',3310504014,2),(51125344,425673377,16014542,4963967,1,'2010-06-11 20:09:43',3310504014,2),(51125414,425672344,16012736,4963967,1,'2010-06-11 20:09:44',3310504014,2),(51125478,425667491,16001936,4963967,1,'2010-06-11 20:09:47',3310504011,3),(51125724,425640237,15923319,426786,1,'2007-09-14 10:13:29',3310504002,1),(51125727,425643461,15930357,426786,1,'2007-09-14 10:13:29',3310504002,1),(51125728,425644662,15932074,426786,1,'2007-09-14 10:13:29',3310504009,1),(51125730,425646369,15932675,426786,1,'2007-09-14 10:13:29',3310504009,1),(51125731,425648680,15933013,427965,1,'2007-09-14 19:12:39',3310504009,1),(51125733,425662145,15945630,427965,1,'2007-09-14 19:12:11',3310504009,1),(51125734,425662714,15949922,427965,1,'2007-09-14 19:12:11',3310504009,1),(51125737,425660023,15962286,426786,1,'2007-09-14 10:13:29',3310504009,1),(51125738,425657116,15971814,426786,1,'2007-09-14 10:13:29',3310504009,1),(51125784,425640237,15914994,426786,1,'2007-09-14 10:13:29',3310504002,1),(51125788,425639858,15920830,426786,1,'2007-09-14 10:13:29',3310504002,1),(51125904,425634611,15908900,426786,1,'2007-09-14 10:13:29',3310504002,1),(51125905,425637139,15909501,426786,1,'2007-09-14 10:13:29',3310504002,1),(51126211,425538008,15886498,426786,1,'2007-09-14 10:13:24',3310503955,1),(51126212,425542308,15885640,426786,1,'2007-09-14 10:13:24',3310503955,1),(51126213,425558654,15885844,427965,1,'2007-09-14 19:46:49',3310503955,1),(51126214,425561499,15886703,427965,1,'2007-09-14 19:46:49',3310503955,1),(51126215,425565511,15886326,426786,1,'2007-09-14 10:13:24',3310503958,1),(51126216,425570632,15885897,426786,1,'2007-09-14 10:13:24',3310503958,1),(51126217,425581886,15888987,426786,1,'2007-09-14 10:13:24',3310503958,1),(51126218,425610180,15902238,427965,1,'2007-09-14 19:46:49',3310503959,1),(51126219,425614697,15902377,426786,1,'2007-09-14 10:13:24',3310503959,1),(51126221,425624117,15903836,426786,1,'2007-09-14 10:13:24',3310504002,1),(51126223,425627151,15904265,426786,1,'2007-09-14 10:13:24',3310504002,1),(51126225,425631007,15906926,426786,1,'2007-09-14 10:13:24',3310504002,1),(51126226,425632967,15908213,426786,1,'2007-09-14 10:13:24',3310504002,1),(51342421,425512942,16950536,427965,1,'2007-09-14 18:53:33',3310504496,1),(51342422,425504912,16959033,427965,1,'2007-09-14 18:58:59',3310504485,1),(51342559,425516167,16953283,427965,1,'2007-09-14 18:53:55',3310504496,1),(51342838,425522057,16951184,4963942,1,'2010-06-11 20:05:26',3310504496,2),(51342839,425521906,16948762,4963942,1,'2010-06-11 20:05:26',3310504496,2),(51342840,425520694,16946985,4963942,1,'2010-06-11 20:05:26',3310504496,2),(51342841,425519615,16946553,4963942,1,'2010-06-11 20:05:26',3310504496,2),(51342842,425518210,16946903,4963942,1,'2010-06-11 20:05:26',3310504496,2),(51342843,425516971,16948509,4963942,1,'2010-06-11 20:05:27',3310504496,2),(51342844,425516703,16951028,4963942,1,'2010-06-11 20:05:27',3310504496,2),(51342845,425517700,16953208,4963942,1,'2010-06-11 20:05:27',3310504496,2),(51342846,425519270,16953996,4963942,1,'2010-06-11 20:05:27',3310504496,2),(51342847,425520545,16953656,4963942,1,'2010-06-11 20:05:27',3310504496,2),(51342848,425521420,16952788,4963942,1,'2010-06-11 20:05:27',3310504496,2),(51342855,425517120,16952366,4963942,1,'2010-06-11 20:05:27',3310504496,2),(51342907,425519897,16944699,427965,1,'2007-09-14 18:53:33',3310504496,1),(51342909,425517179,16946674,427965,1,'2007-09-14 18:53:33',3310504496,1),(51342910,425514586,16949163,427965,1,'2007-09-14 18:53:33',3310504496,1),(51343029,425510366,16955036,4963942,1,'2010-06-11 20:05:25',3310504496,2),(51343031,425516645,16950279,4963942,1,'2010-06-11 20:05:25',3310504496,2),(51343103,425497577,16963582,427965,1,'2007-09-14 18:58:59',3310504485,1),(51344677,425475762,16980233,5107412,1,'2010-06-29 20:12:26',3310504486,2),(51344678,425460270,16997400,427965,1,'2007-09-14 19:00:20',3310504486,1),(51344679,425451733,17014651,427965,1,'2007-09-14 19:00:20',3310504483,1),(51344681,425444461,17058854,427965,1,'2007-09-14 19:00:20',3310504489,1),(51344682,425440667,17115932,427965,1,'2007-09-14 19:00:20',3310504491,1),(51344683,425439719,17156701,427965,1,'2007-09-14 19:00:20',3310504577,1),(51344685,425437505,17221933,427965,1,'2007-09-14 19:00:20',3310504579,1),(51344687,425438770,17256265,427965,1,'2007-09-14 19:00:20',3310504585,1),(51344688,425443829,17281585,427965,1,'2007-09-14 19:00:20',3310504585,1),(51344690,425456160,17311197,427965,1,'2007-09-14 19:00:20',3310504590,1),(51345073,425484931,16973195,427965,1,'2007-09-14 18:58:59',3310504485,1),(51347750,425703738,16051459,427965,1,'2007-09-14 19:10:15',3310504037,1),(51347752,425707025,16059785,427965,1,'2007-09-14 19:10:15',3310504037,1),(51347925,425702032,16049657,427965,1,'2007-09-14 19:10:15',3310504037,1),(51347926,425704813,16053348,427965,1,'2007-09-14 19:10:15',3310504037,1),(51348096,425739675,16186726,495907,1,'2008-07-15 19:46:04',3310504056,2),(51348165,425715495,16093002,427965,1,'2007-09-14 19:08:20',3310504037,1),(51348167,425715306,16097636,427965,1,'2007-09-14 19:08:20',3310504039,1),(51348517,425682563,16031118,427965,1,'2007-09-14 19:10:38',3310504014,1),(51348571,425721437,16137376,427965,1,'2007-09-14 19:08:20',3310504039,1),(51349842,425679655,16025024,427965,1,'2007-09-14 19:10:49',3310504014,1),(51350384,425657214,15974212,427965,1,'2007-09-14 19:12:11',3310504009,1),(51350385,425657151,15972924,427965,1,'2007-09-14 19:12:11',3310504009,1),(51350585,425662588,15947776,427965,1,'2007-09-14 19:12:11',3310504009,1),(51350698,425650640,15932927,427965,1,'2007-09-14 19:12:39',3310504009,1),(51350699,425652220,15933013,427965,1,'2007-09-14 19:12:39',3310504009,1),(51350700,425654180,15933442,427965,1,'2007-09-14 19:12:39',3310504009,1),(51350702,425655255,15934816,427965,1,'2007-09-14 19:12:28',3310504009,1),(51356383,424673865,14916718,508959,1,'2007-09-24 18:39:54',3310490811,1),(51356432,424524124,14849968,508959,1,'2007-09-24 18:39:54',3310490792,1),(51356433,424544964,14856697,508959,1,'2007-09-24 18:39:54',3310490792,1),(51356434,424548481,14856540,508959,1,'2007-09-24 18:39:54',3310490793,1),(51356435,424554163,14857905,508959,1,'2007-09-24 18:39:54',3310490793,1),(51356437,424563243,14860483,508959,1,'2007-09-24 18:39:54',3310490793,1),(51356438,424569706,14862543,434787,1,'2007-09-15 15:28:04',3310490793,1),(51356439,424574414,14863644,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356440,424578231,14863922,434787,1,'2007-09-15 15:28:04',3310490796,1),(51356442,424581638,14865079,434787,1,'2007-09-15 15:28:05',3310490796,1),(51356444,424585586,14868300,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356445,424587163,14870744,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356446,424588461,14872583,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356448,424590557,14874947,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356450,424592691,14875430,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356451,424594856,14875918,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356452,424596617,14876982,434787,1,'2007-09-15 15:28:07',3310490796,1),(51356454,424598915,14879348,434787,1,'2007-09-15 15:28:07',3310490796,1),(51356455,424601853,14883173,508959,1,'2007-09-24 18:39:54',3310490797,1),(51356457,424605273,14888784,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356458,424607729,14892410,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356460,424609389,14893912,434787,1,'2007-09-15 15:28:08',3310490799,1),(51356461,424612485,14896909,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356462,424616981,14899987,434787,1,'2007-09-15 15:28:08',3310490799,1),(51356465,424621510,14900345,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356466,424625060,14899441,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356468,424634374,14896704,434787,1,'2007-09-15 15:10:21',3310490810,1),(51356469,424644835,14894490,508959,1,'2007-09-24 18:39:54',3310490810,1),(51356470,424648539,14894406,508959,1,'2007-09-24 18:39:54',3310490810,1),(51356471,424650615,14895452,508959,1,'2007-09-24 18:39:54',3310490810,1),(51356472,424653290,14897426,508959,1,'2007-09-24 18:39:54',3310490810,1),(51356473,424655245,14899686,508959,1,'2007-09-24 18:39:54',3310490810,1),(51356474,424657603,14899123,434787,1,'2007-09-15 15:10:22',3310490811,1),(51356475,424660066,14901118,434787,1,'2007-09-15 15:10:22',3310490811,1),(51356476,424662594,14903157,508959,1,'2007-09-24 18:39:54',3310490811,1),(51356477,424663789,14904882,508959,1,'2007-09-24 18:39:54',3310490811,1),(51356478,424664468,14908098,508959,1,'2007-09-24 18:39:54',3310490811,1),(51356479,424666182,14911657,508959,1,'2007-09-24 18:39:54',3310490811,1),(51356480,424667621,14914564,434787,1,'2007-09-15 15:10:12',3310490811,1),(51356481,424670475,14916739,434787,1,'2007-09-15 15:10:12',3310490811,1),(51356964,424522992,14851025,508959,1,'2007-09-24 18:39:54',3310490792,1),(51356965,424546433,14858880,508959,1,'2007-09-24 18:39:54',3310490793,1),(51356967,424550739,14859567,508959,1,'2007-09-24 18:39:54',3310490793,1),(51356968,424559288,14862742,508959,1,'2007-09-24 18:39:54',3310490793,1),(51356969,424568407,14864974,508959,1,'2007-09-24 18:39:54',3310490793,1),(51356970,424571573,14866347,508959,1,'2007-09-24 18:39:54',3310490793,1),(51356972,424575499,14866347,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356973,424577842,14866347,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356974,424579362,14866691,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356975,424581452,14867377,427965,1,'2007-09-14 19:33:57',3310490796,1),(51356977,424584618,14870296,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356978,424586264,14872012,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356979,424588670,14875531,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356981,424590887,14877076,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356982,424593103,14877334,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356983,424595129,14878364,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356985,424597536,14880767,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356986,424599499,14883342,508959,1,'2007-09-24 18:39:54',3310490796,1),(51356987,424602665,14888492,427965,1,'2007-09-14 19:33:57',3310490799,1),(51356988,424605261,14892268,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356991,424607477,14895015,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356992,424609883,14897590,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356994,424612479,14899907,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356995,424615075,14901795,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356997,424617228,14902997,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356998,424620648,14903083,508959,1,'2007-09-24 18:39:54',3310490799,1),(51356999,424624510,14901967,427965,1,'2007-09-14 19:33:57',3310490799,1),(51357000,424638630,14897933,508959,1,'2007-09-24 18:39:54',3310490810,1),(51357002,424644582,14896731,508959,1,'2007-09-24 18:39:54',3310490810,1),(51357003,424647368,14896302,508959,1,'2007-09-24 18:39:54',3310490810,1),(51357004,424649077,14896302,508959,1,'2007-09-24 18:39:54',3310490810,1),(51357006,424650534,14897246,427965,1,'2007-09-14 19:33:57',3310490810,1),(51357007,424653256,14900165,508959,1,'2007-09-24 18:39:54',3310490810,1),(51357008,424654459,14901452,508959,1,'2007-09-24 18:39:54',3310490810,1),(51357009,424658448,14903255,508959,1,'2007-09-24 18:39:54',3310490811,1),(51357010,424661867,14905229,508959,1,'2007-09-24 18:39:54',3310490811,1),(51357011,424663133,14907374,508959,1,'2007-09-24 18:39:54',3310490811,1),(51357012,424663640,14909434,508959,1,'2007-09-24 18:39:54',3310490811,1),(51357013,424662754,14910636,427965,1,'2007-09-14 19:33:57',3310490811,1),(51357015,424663830,14912181,427965,1,'2007-09-14 19:33:57',3310490811,1),(51357016,424665223,14914670,508959,1,'2007-09-24 18:39:54',3310490811,1),(51357018,424666362,14916902,427965,1,'2007-09-14 19:33:57',3310490811,1),(51357019,424669718,14918447,508959,1,'2007-09-24 18:39:54',3310490811,1),(51357255,424672757,14918876,427965,1,'2007-09-14 19:33:57',3310490811,1),(51357256,424675416,14918876,508959,1,'2007-09-24 18:39:54',3310490811,1),(51357259,424677632,14918447,508959,1,'2007-09-24 18:39:54',3310490811,1),(51357260,424680735,14919477,508959,1,'2007-09-24 18:39:54',3310490811,1),(51357261,424683457,14920764,508959,1,'2007-09-24 18:39:54',3310490814,1),(51357264,424687066,14921880,508959,1,'2007-09-24 18:39:54',3310490814,1),(51357265,424692954,14923940,508959,1,'2007-09-24 18:39:54',3310490814,1),(51357268,424696943,14925399,508959,1,'2007-09-24 18:39:54',3310490814,1),(51357269,424699665,14927115,508959,1,'2007-09-24 18:39:54',3310490814,1),(51357270,424700425,14928060,508959,1,'2007-09-24 18:39:54',3310490814,1),(51357272,424702831,14929519,427965,1,'2007-09-14 19:33:57',3310490814,1),(51357274,424705300,14930034,508959,1,'2007-09-24 18:39:54',3310490814,1),(51357275,424706946,14929776,508959,1,'2007-09-24 18:39:54',3310490814,1),(51357276,424708529,14929090,427965,1,'2007-09-14 19:33:57',3310490814,1),(51357277,424711251,14926772,508959,1,'2007-09-24 18:39:54',3310490815,1),(51357279,424713657,14925742,508959,1,'2007-09-24 18:39:54',3310490815,1),(51357281,424715430,14925914,427965,1,'2007-09-14 19:33:57',3310490815,1);
INSERT INTO `nodes` VALUES (51357282,424717772,14926858,508959,1,'2007-09-24 18:39:54',3310490815,1),(51357285,424721634,14929090,427965,1,'2007-09-14 19:33:57',3310490815,1),(51357287,424725369,14931836,508959,1,'2007-09-24 18:39:54',3310490815,1),(51357288,424727522,14932780,508959,1,'2007-09-24 18:39:54',3310490815,1),(51357291,424729674,14932523,508959,1,'2007-09-24 18:39:54',3310490815,1),(51357292,424731573,14930463,508959,1,'2007-09-24 18:39:54',3310490815,1),(51357293,424733852,14926000,427965,1,'2007-09-14 19:33:57',3310490815,1),(51357295,424735878,14919648,427965,1,'2007-09-14 19:33:57',3310490815,1),(51357297,424736575,14916816,427965,1,'2007-09-14 19:33:57',3310490815,1),(51357298,424737777,14912868,508959,1,'2007-09-24 18:39:54',3310490815,1),(51357300,424739170,14910378,427965,1,'2007-09-14 19:33:08',3310490858,1),(51357303,424742209,14907804,508959,1,'2007-09-24 18:39:54',3310490858,1),(51357305,424745817,14906173,508959,1,'2007-09-24 18:39:54',3310490858,1),(51357308,424748920,14906173,508959,1,'2007-09-24 18:39:54',3310490858,1),(51357309,424751578,14906859,427965,1,'2007-09-14 19:33:57',3310490858,1),(51357310,424753731,14906516,427965,1,'2007-09-14 19:33:57',3310490858,1),(51357312,424756516,14905229,508959,1,'2007-09-24 18:39:54',3310490858,1),(51357313,424759808,14904885,508959,1,'2007-09-24 18:39:54',3310490858,1),(51357315,424763480,14905143,508959,1,'2007-09-24 18:39:54',3310490858,1),(51357317,424766582,14905143,508959,1,'2007-09-24 18:39:54',3310490859,1),(51357319,424771646,14904370,427965,1,'2007-09-14 19:33:57',3310490859,1),(51357320,424775571,14902997,508959,1,'2007-09-24 18:39:54',3310490859,1),(51357323,424778926,14900508,508959,1,'2007-09-24 18:39:54',3310490859,1),(51357326,424784750,14894500,427965,1,'2007-09-14 19:33:57',3310490859,1),(51357328,424788358,14891410,508959,1,'2007-09-24 18:39:54',3310490859,1),(51357329,424792979,14888663,508959,1,'2007-09-24 18:39:54',3310490862,1),(51357330,424796714,14887633,508959,1,'2007-09-24 18:39:54',3310490862,1),(51357332,424800892,14887118,508959,1,'2007-09-24 18:39:54',3310490862,1),(51357335,424805006,14889007,508959,1,'2007-09-24 18:39:54',3310490862,1),(51357538,424807222,14890294,427965,1,'2007-09-14 19:33:57',3310490862,1),(51357539,424810260,14890466,508959,1,'2007-09-24 18:39:54',3310490862,1),(51357540,424814248,14889865,508959,1,'2007-09-24 18:39:54',3310490862,1),(51357542,424819059,14890208,508959,1,'2007-09-24 18:39:54',3310490862,1),(51357543,424823427,14892268,508959,1,'2007-09-24 18:39:54',3310490863,1),(51357544,424827225,14896045,508959,1,'2007-09-24 18:39:54',3310490863,1),(51357546,424833365,14902225,427965,1,'2007-09-14 19:33:57',3310490863,1),(51357547,424836086,14905314,508959,1,'2007-09-24 18:39:54',3310490863,1),(51357549,424838492,14910121,427965,1,'2007-09-14 19:33:57',3310490863,1),(51357550,424840264,14918962,508959,1,'2007-09-24 18:39:54',3310490863,1),(51357551,424843745,14925742,508959,1,'2007-09-24 18:39:54',3310490863,1),(51357552,424847733,14931235,508959,1,'2007-09-24 18:39:54',3310490863,1),(51357554,424852164,14938445,508959,1,'2007-09-24 18:39:54',3310490874,1),(51357556,424856911,14944539,508959,1,'2007-09-24 18:39:54',3310491216,1),(51357557,424861848,14949002,508959,1,'2007-09-24 18:39:54',3310491216,1),(51357558,424866912,14951491,508959,1,'2007-09-24 18:39:54',3310491216,1),(51357560,424870899,14951577,427965,1,'2007-09-14 19:33:57',3310491216,1),(51357561,424875456,14950633,508959,1,'2007-09-24 18:39:54',3310491217,1),(51357562,424879823,14949775,508959,1,'2007-09-24 18:39:54',3310491217,1),(51357564,424884444,14950461,427965,1,'2007-09-14 19:33:57',3310491217,1),(51357566,424887798,14952435,508959,1,'2007-09-24 18:39:54',3310491217,1),(51357567,424890796,14953824,592895,1,'2008-07-25 22:11:36',3310491217,2),(51357568,424894277,14956571,592895,1,'2008-07-25 22:11:36',3310491217,2),(51357570,424897735,14959044,508959,1,'2007-09-24 18:39:54',3310491217,1),(51357571,424899824,14958444,427965,1,'2007-09-14 19:33:57',3310491217,1),(51357573,424904191,14956813,508959,1,'2007-09-24 18:39:54',3310491220,1),(51357949,425040631,15202975,508959,1,'2007-09-24 18:39:54',3310491429,1),(51357951,425037783,15195079,427965,1,'2007-09-14 19:42:25',3310491428,1),(51357953,425037530,15191216,508959,1,'2007-09-24 18:39:54',3310491428,1),(51357954,425037595,15187055,508959,1,'2007-09-24 18:39:54',3310491428,1),(51357955,425038226,15177140,508959,1,'2007-09-24 18:39:54',3310491428,1),(51357956,425038543,15172420,508959,1,'2007-09-24 18:39:54',3310491428,1),(51357958,425038290,15167184,427965,1,'2007-09-14 19:42:25',3310491428,1),(51357959,425036897,15162206,508959,1,'2007-09-24 18:39:54',3310491428,1),(51357960,425034366,15158343,508959,1,'2007-09-24 18:39:54',3310491406,1),(51357962,425029178,15151305,508959,1,'2007-09-24 18:39:54',3310491406,1),(51357963,425026330,15146327,508959,1,'2007-09-24 18:39:54',3310491406,1),(51357965,425024052,15139718,508959,1,'2007-09-24 18:39:54',3310491406,1),(51357966,425022090,15136285,508959,1,'2007-09-24 18:39:54',3310491406,1),(51357967,425019053,15133109,427965,1,'2007-09-14 19:42:25',3310491406,1),(51357969,425016585,15130963,508959,1,'2007-09-24 18:39:54',3310491406,1),(51357971,425014244,15130105,508959,1,'2007-09-24 18:39:54',3310491406,1),(51357972,425011396,15127788,508959,1,'2007-09-24 18:39:54',3310491403,1),(51357973,425008738,15125213,427965,1,'2007-09-14 19:42:25',3310491403,1),(51357975,425003992,15122552,427965,1,'2007-09-14 19:42:25',3310491403,1),(51357977,424991716,15113196,427965,1,'2007-09-14 19:42:25',3310491403,1),(51357978,424986843,15109420,508959,1,'2007-09-24 18:39:54',3310491403,1),(51357980,424981148,15103755,508959,1,'2007-09-24 18:39:54',3310491400,1),(51357981,424977559,15096896,508959,1,'2007-09-24 18:39:54',3310491400,1),(51357983,424974056,15089381,508959,1,'2007-09-24 18:39:54',3310491400,1),(51357984,424970640,15082383,508959,1,'2007-09-24 18:39:54',3310491400,1),(51357986,424965473,15069081,434787,1,'2007-09-15 15:11:10',3310491400,1),(51357988,424961783,15058780,427965,1,'2007-09-14 19:42:25',3310491400,1),(51357989,424958659,15050069,508959,1,'2007-09-24 18:39:54',3310491394,1),(51357991,424955028,15043304,508959,1,'2007-09-24 18:39:54',3310491223,1),(51357993,424952670,15038524,508959,1,'2007-09-24 18:39:54',3310491223,1),(51357994,424952227,15035090,427965,1,'2007-09-14 19:42:25',3310491223,1),(51357995,424949948,15029855,508959,1,'2007-09-24 18:39:54',3310491223,1),(51357997,424947500,15024621,434787,1,'2007-09-15 15:11:11',3310491223,1),(51358000,424945075,15019898,508959,1,'2007-09-24 18:39:54',3310491223,1),(51358001,424941468,15011315,508959,1,'2007-09-24 18:39:54',3310491223,1),(51358002,424935582,15000587,508959,1,'2007-09-24 18:39:54',3310491223,1),(51358003,424928937,14992175,427965,1,'2007-09-14 19:42:25',3310491220,1),(51358004,424927798,14989257,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358005,424926722,14982734,427965,1,'2007-09-14 19:42:25',3310491220,1),(51358007,424926089,14976726,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358008,424924823,14973979,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358009,424922925,14972262,427965,1,'2007-09-14 19:42:25',3310491220,1),(51358011,424920140,14970717,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358013,424918115,14969859,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358015,424915773,14967971,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358016,424913431,14965053,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358018,424911912,14962392,427965,1,'2007-09-14 19:42:25',3310491220,1),(51358019,424910520,14959645,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358021,424909444,14958186,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358023,424907672,14957070,427965,1,'2007-09-14 19:42:25',3310491220,1),(51358025,424905836,14956641,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358396,425095390,15316725,437032,1,'2008-05-13 20:45:03',3310491449,2),(51358398,425091060,15305629,427965,1,'2007-09-14 19:42:25',3310491448,1),(51358399,425087581,15296273,427965,1,'2007-09-14 19:42:25',3310491448,1),(51358401,425086315,15292239,427965,1,'2007-09-14 19:42:25',3310491448,1),(51358402,425083847,15287261,508959,1,'2007-09-24 18:39:54',3310491448,1),(51358404,425081696,15284858,427965,1,'2007-09-14 19:42:25',3310491448,1),(51358405,425077586,15281470,434787,1,'2007-09-15 15:11:02',3310491448,1),(51358407,425070560,15276875,508959,1,'2007-09-24 18:39:54',3310491448,1),(51358408,425067460,15274301,508959,1,'2007-09-24 18:39:54',3310491437,1),(51358409,425066381,15271609,508959,1,'2007-09-24 18:39:54',3310491437,1),(51358411,425065941,15266576,508959,1,'2007-09-24 18:39:54',3310491431,1),(51358412,425065435,15261769,508959,1,'2007-09-24 18:39:54',3310491431,1),(51358414,425064486,15257907,508959,1,'2007-09-24 18:39:54',3310491431,1),(51358415,425063410,15254989,508959,1,'2007-09-24 18:39:54',3310491431,1),(51358417,425061638,15251727,427965,1,'2007-09-14 19:42:25',3310491431,1),(51358418,425059360,15249066,508959,1,'2007-09-24 18:39:54',3310491431,1),(51358419,425055501,15245290,508959,1,'2007-09-24 18:39:54',3310491431,1),(51358421,425051008,15240483,427965,1,'2007-09-14 19:42:25',3310491431,1),(51358423,425048793,15235333,427965,1,'2007-09-14 19:42:25',3310491431,1),(51358424,425047908,15230699,508959,1,'2007-09-24 18:39:54',3310491431,1),(51358425,425047022,15224519,508959,1,'2007-09-24 18:39:54',3310491431,1),(51358427,425046073,15217738,508959,1,'2007-09-24 18:39:54',3310491431,1),(51358428,425044576,15212201,434787,1,'2007-09-15 15:11:01',3310491429,1),(51358430,425042361,15206750,508959,1,'2007-09-24 18:39:54',3310491429,1),(51358786,424807359,14888329,508959,1,'2007-09-24 18:39:54',3310490862,1),(51358788,424810508,14888600,508959,1,'2007-09-24 18:39:54',3310490862,1),(51358789,424815115,14888495,508959,1,'2007-09-24 18:39:54',3310490862,1),(51358791,424820097,14889010,508959,1,'2007-09-24 18:39:54',3310490862,1),(51358792,424823126,14889979,434787,1,'2007-09-15 15:24:45',3310490863,1),(51358793,424826326,14892939,508959,1,'2007-09-24 18:39:54',3310490863,1),(51358794,424831694,14898426,508959,1,'2007-09-24 18:39:54',3310490863,1),(51358795,424835326,14901681,508959,1,'2007-09-24 18:39:54',3310490863,1),(51358797,424836907,14903618,434787,1,'2007-09-15 15:24:46',3310490863,1),(51358798,424838997,14907748,508959,1,'2007-09-24 18:39:54',3310490863,1),(51358800,424840307,14912216,434787,1,'2007-09-15 15:24:44',3310490863,1),(51358802,424841001,14916503,508959,1,'2007-09-24 18:39:54',3310490863,1),(51358803,424846760,14926540,508959,1,'2007-09-24 18:39:54',3310490863,1),(51358805,424851922,14934265,508959,1,'2007-09-24 18:39:54',3310490874,1),(51358806,424855121,14939196,508959,1,'2007-09-24 18:39:54',3310490874,1),(51358807,424858573,14943404,434787,1,'2007-09-15 15:24:45',3310491216,1),(51358809,424863437,14947382,508959,1,'2007-09-24 18:39:54',3310491216,1),(51358810,424867813,14949008,508959,1,'2007-09-24 18:39:54',3310491216,1),(51358811,424869754,14949399,508959,1,'2007-09-24 18:39:54',3310491216,1),(51358812,424875416,14949103,592895,1,'2008-07-25 22:29:55',3310491217,2),(51358813,424882315,14947987,592895,1,'2008-07-25 22:29:55',3310491217,2),(51358814,424885086,14947941,508959,1,'2007-09-24 18:39:54',3310491217,1),(51358815,424888109,14949771,508959,1,'2007-09-24 18:39:54',3310491217,1),(51358816,424892315,14952022,592895,1,'2008-07-25 22:11:36',3310491217,2),(51358818,424895416,14954682,592895,1,'2008-07-25 22:11:36',3310491217,2),(51358819,424898391,14956934,434787,1,'2007-09-15 15:24:42',3310491217,1),(51358820,424901548,14956557,508959,1,'2007-09-24 18:39:54',3310491217,1),(51358821,424904263,14955461,434787,1,'2007-09-15 15:24:42',3310491220,1),(51358823,424906583,14955100,434787,1,'2007-09-15 15:24:43',3310491220,1),(51358824,424909431,14955789,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358825,424912723,14959810,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358827,424914584,14963628,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358829,424916278,14965868,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358832,424918892,14967734,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358837,424920598,14968740,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358838,424922170,14968484,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358839,424925585,14971653,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358840,424927075,14974234,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358841,424928335,14983737,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358842,424929808,14989502,508959,1,'2007-09-24 18:39:54',3310491220,1),(51358843,424932360,14993695,434787,1,'2007-09-15 15:10:44',3310491221,1),(51358845,424935674,14997822,434787,1,'2007-09-15 15:10:44',3310491223,1),(51358847,424938099,15000654,508959,1,'2007-09-24 18:39:54',3310491223,1),(51358848,424940420,15004955,508959,1,'2007-09-24 18:39:54',3310491223,1),(51358849,424946769,15019369,434787,1,'2007-09-15 15:10:58',3310491223,1),(51358850,424953012,15032635,508959,1,'2007-09-24 18:39:54',3310491223,1),(51358851,424956723,15042711,508959,1,'2007-09-24 18:39:54',3310491223,1),(51358852,424960666,15048850,508959,1,'2007-09-24 18:39:54',3310491394,1),(51358853,424962230,15054326,508959,1,'2007-09-24 18:39:54',3310491400,1),(51358854,424966025,15064085,508959,1,'2007-09-24 18:39:54',3310491400,1),(51358856,424968725,15071603,508959,1,'2007-09-24 18:39:54',3310491400,1),(51358858,424973284,15083525,508959,1,'2007-09-24 18:39:54',3310491400,1),(51358859,424982739,15101487,434787,1,'2007-09-15 15:11:00',3310491400,1),(51358861,424985506,15105063,508959,1,'2007-09-24 18:39:54',3310491401,1),(51358862,424991858,15110266,508959,1,'2007-09-24 18:39:54',3310491403,1),(51358863,425000828,15117231,434787,1,'2007-09-15 15:10:59',3310491403,1),(51359239,425007692,15122468,508959,1,'2007-09-24 18:39:54',3310491403,1),(51359241,425014737,15127997,508959,1,'2007-09-24 18:39:54',3310491406,1),(51359242,425021234,15132846,508959,1,'2007-09-24 18:39:54',3310491406,1),(51359243,425024541,15135545,508959,1,'2007-09-24 18:39:54',3310491406,1),(51359245,425025197,15137161,434787,1,'2007-09-15 15:10:31',3310491406,1),(51359246,425027138,15143261,434787,1,'2007-09-15 15:10:31',3310491406,1),(51359247,425029522,15148736,508959,1,'2007-09-24 18:39:54',3310491406,1),(51359249,425032523,15153429,508959,1,'2007-09-24 18:39:54',3310491406,1),(51359251,425036736,15158791,508959,1,'2007-09-24 18:39:54',3310491406,1),(51359252,425039282,15165539,508959,1,'2007-09-24 18:39:54',3310491428,1),(51359253,425039685,15167906,508959,1,'2007-09-24 18:39:54',3310491428,1),(51359255,425039979,15174085,508959,1,'2007-09-24 18:39:54',3310491428,1),(51359256,425038654,15186787,508959,1,'2007-09-24 18:39:54',3310491428,1),(51359257,425042159,15203863,508959,1,'2007-09-24 18:39:54',3310491429,1),(51359259,425044641,15208435,508959,1,'2007-09-24 18:39:54',3310491429,1),(51359260,425046531,15213114,434787,1,'2007-09-15 15:10:28',3310491429,1),(51359261,425047604,15217315,508959,1,'2007-09-24 18:39:54',3310491431,1),(51359262,425048711,15223499,508959,1,'2007-09-24 18:39:54',3310491431,1),(51359264,425049470,15228651,508959,1,'2007-09-24 18:39:54',3310491431,1),(51359265,425050040,15232836,508959,1,'2007-09-24 18:39:54',3310491431,1),(51359266,425051115,15236386,434787,1,'2007-09-15 15:10:36',3310491431,1),(51359268,425052602,15239381,508959,1,'2007-09-24 18:39:54',3310491431,1),(51359269,425054907,15242401,508959,1,'2007-09-24 18:39:54',3310491431,1),(51359271,425056518,15243874,508959,1,'2007-09-24 18:39:54',3310491431,1),(51359272,425059344,15246029,508959,1,'2007-09-24 18:39:54',3310491431,1),(51359274,425063167,15250552,434787,1,'2007-09-15 15:10:35',3310491431,1),(51359275,425066240,15257991,508959,1,'2007-09-24 18:39:54',3310491431,1),(51359276,425066931,15259768,434787,1,'2007-09-15 15:10:35',3310491431,1),(51359278,425067287,15262695,508959,1,'2007-09-24 18:39:54',3310491431,1),(51359279,425067089,15266922,508959,1,'2007-09-24 18:39:54',3310491431,1),(51359280,425068591,15272474,434787,1,'2007-09-15 15:10:33',3310491448,1),(51359281,425070286,15274125,508959,1,'2007-09-24 18:39:54',3310491448,1),(51359283,425077223,15279009,434787,1,'2007-09-15 15:10:33',3310491448,1),(51359284,425082862,15283938,437032,1,'2008-05-13 20:45:03',3310491448,2),(51359285,425086981,15289800,508959,1,'2007-09-24 18:39:54',3310491448,1),(51359287,425088557,15294409,437032,1,'2008-05-13 21:07:22',3310491448,2),(51359288,425090012,15299903,437032,1,'2008-05-13 21:07:22',3310491448,2),(51359290,425093113,15307799,437032,1,'2008-05-13 21:07:22',3310491448,2),(51359291,425095355,15314062,508959,1,'2007-09-24 18:39:54',3310491449,1),(51359292,425097492,15319727,508959,1,'2007-09-24 18:39:54',3310491449,1),(51359293,425098355,15322401,434787,1,'2007-09-15 15:10:32',3310491449,1),(51359295,425099693,15327197,437032,1,'2008-05-13 20:45:03',3310491451,2),(51359296,425101085,15331059,437032,1,'2008-05-13 20:42:53',3310491451,2),(51359297,425104248,15336295,437032,1,'2008-05-13 20:42:53',3310491451,2),(51359299,425107440,15343992,508959,1,'2007-09-24 18:39:54',3310491451,1),(51359302,425111423,15349450,508959,1,'2007-09-24 18:39:54',3310491451,1),(51359303,425114417,15353498,508959,1,'2007-09-24 18:39:54',3310491451,1),(51359304,425115319,15356325,508959,1,'2007-09-24 18:39:54',3310491451,1),(51359305,425115892,15359671,508959,1,'2007-09-24 18:39:54',3310491451,1),(51359307,425113756,15368265,508959,1,'2007-09-24 18:39:54',3310491451,1),(51359308,425107442,15383028,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359309,425105784,15387331,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359310,425104745,15390684,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359312,425104809,15399336,434787,1,'2007-09-15 15:10:40',3310491537,1),(51359313,425104758,15402274,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359314,425104822,15405731,434787,1,'2007-09-15 15:10:40',3310491537,1),(51359316,425104267,15407546,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359317,425103129,15410483,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359318,425097966,15414794,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359320,425094037,15418611,508959,1,'2007-09-24 18:39:54',3310491536,1),(51359322,425092583,15420925,508959,1,'2007-09-24 18:39:54',3310491536,1),(51359323,425091025,15424314,508959,1,'2007-09-24 18:39:54',3310491536,1),(51359324,425093554,15441457,508959,1,'2007-09-24 18:39:54',3310491538,1),(51359325,425095142,15448064,508959,1,'2007-09-24 18:39:54',3310491539,1),(51359327,425095691,15449511,434787,1,'2007-09-15 15:10:37',3310491539,1),(51359328,425097130,15451304,508959,1,'2007-09-24 18:39:54',3310491539,1),(51359330,425098139,15455925,508959,1,'2007-09-24 18:39:54',3310491539,1),(51359331,425098307,15457247,434787,1,'2007-09-15 15:10:43',3310491539,1),(51359357,425099696,15460021,508959,1,'2007-09-24 18:39:54',3310491539,1),(51359358,425102608,15460668,434787,1,'2007-09-15 15:10:43',3310491539,1),(51359756,425112338,15468030,188228,1,'2008-06-16 18:49:01',3310491539,2),(51359758,425109081,15461733,434787,1,'2007-09-15 15:10:07',3310491539,1),(51359760,425106246,15459942,508959,1,'2007-09-24 18:39:54',3310491539,1),(51359761,425103445,15461543,434787,1,'2007-09-15 15:10:09',3310491539,1),(51359762,425100281,15462216,508959,1,'2007-09-24 18:39:54',3310491539,1),(51359763,425098308,15460926,434787,1,'2007-09-15 15:10:08',3310491539,1),(51359764,425097180,15456850,508959,1,'2007-09-24 18:39:54',3310491539,1),(51359766,425095634,15451106,434787,1,'2007-09-15 15:10:07',3310491539,1),(51359769,425093055,15445630,508959,1,'2007-09-24 18:39:54',3310491538,1),(51359771,425090681,15432561,508959,1,'2007-09-24 18:39:54',3310491536,1),(51359772,425090436,15423686,434787,1,'2007-09-15 15:10:09',3310491536,1),(51359773,425090908,15420979,434787,1,'2007-09-15 15:10:09',3310491536,1),(51359774,425093121,15417933,434787,1,'2007-09-15 15:10:09',3310491536,1),(51359775,425098084,15413003,427965,1,'2007-09-14 19:42:25',3310491537,1),(51359776,425102133,15410085,427965,1,'2007-09-14 19:42:25',3310491537,1),(51359777,425103006,15407959,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359778,425103905,15404077,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359779,425103651,15392404,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359780,425104031,15388713,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359781,425106435,15382705,508959,1,'2007-09-24 18:39:54',3310491537,1),(51359782,425112762,15366139,508959,1,'2007-09-24 18:39:54',3310491451,1),(51359783,425114344,15360818,508959,1,'2007-09-24 18:39:54',3310491451,1),(51359784,425114066,15357167,434787,1,'2007-09-15 15:10:11',3310491451,1),(51359785,425112889,15354724,508959,1,'2007-09-24 18:39:54',3310491451,1),(51359786,425108333,15347943,508959,1,'2007-09-24 18:39:54',3310491451,1),(51359787,425103173,15337668,437032,1,'2008-05-13 20:42:53',3310491451,2),(51359788,425099946,15333291,437032,1,'2008-05-13 20:42:53',3310491451,2),(51359789,425098491,15328742,437032,1,'2008-05-13 20:45:03',3310491451,2),(51359790,425097542,15324279,437032,1,'2008-05-13 20:45:03',3310491449,2),(51359793,425096846,15321017,437032,1,'2008-05-13 20:45:03',3310491449,2),(51359948,425107582,15458743,508959,1,'2007-09-24 18:39:54',3310491539,1),(51359949,425108740,15459659,508959,1,'2007-09-24 18:39:54',3310491539,1),(51359951,425110946,15462365,188228,1,'2008-06-16 18:49:01',3310491539,2),(51359952,425113097,15466314,188228,1,'2008-06-16 18:49:29',3310491539,3),(51359953,425116007,15479017,188228,1,'2008-06-16 18:50:28',3310491539,3),(51360246,425115248,15481420,188228,1,'2008-06-16 18:50:28',3310491539,2),(51360952,425680412,16028409,427965,1,'2007-09-14 19:43:57',3310504014,1),(51360953,425682056,16033559,427965,1,'2007-09-14 19:43:57',3310504014,1),(51360955,425683510,16037850,427965,1,'2007-09-14 19:43:57',3310504014,1),(51360957,425685090,16041713,427965,1,'2007-09-14 19:43:57',3310504036,1),(51360958,425686165,16044374,427965,1,'2007-09-14 19:43:57',3310504036,1),(51360960,425688251,16046348,427965,1,'2007-09-14 19:43:57',3310504036,1),(51360961,425691158,16047549,427965,1,'2007-09-14 19:43:57',3310504036,1),(51360963,425694635,16048493,427965,1,'2007-09-14 19:43:57',3310504036,1),(51360964,425698175,16049266,427965,1,'2007-09-14 19:43:57',3310504036,1),(51360965,425700703,16049953,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360967,425703168,16052527,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360968,425704432,16055017,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360969,425705949,16059566,427965,1,'2007-09-14 19:43:53',3310504037,1),(51360970,425706898,16064715,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360971,425708604,16072440,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360974,425709742,16078019,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360975,425710501,16080766,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360976,425711828,16083941,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360979,425712966,16085916,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360980,425713914,16088233,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360981,425714419,16090465,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360982,425714862,16093040,427965,1,'2007-09-14 19:43:57',3310504037,1),(51360984,425714609,16097159,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360985,425713914,16102910,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360986,425713787,16106687,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360987,425714356,16110549,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360988,425715620,16113553,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360990,425717453,16116471,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360991,425718781,16119390,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360992,425719350,16121964,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360993,425719603,16126428,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360994,425719666,16132350,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360995,425720614,16137671,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360996,425722384,16144109,427965,1,'2007-09-14 19:43:57',3310504039,1),(51360998,425725544,16154151,427965,1,'2007-09-14 19:43:57',3310504045,1),(51361715,425639639,15913053,427965,1,'2007-09-14 19:45:55',3310504002,1),(51361716,425640524,15916657,427965,1,'2007-09-14 19:45:55',3310504002,1),(51361728,425628513,15904813,427965,1,'2007-09-14 19:46:49',3310504002,1),(51361816,425601455,15898376,427965,1,'2007-09-14 19:46:49',3310503959,1),(51361817,425608093,15901380,427965,1,'2007-09-14 19:46:49',3310503959,1),(51362009,425522479,15895040,5671401,1,'2010-09-03 18:06:01',3310503954,2),(51362011,425526123,15890270,5671401,1,'2010-09-03 18:06:00',3310503954,2),(51362012,425532415,15887046,427965,1,'2007-09-14 19:48:40',3310503954,1),(51362129,425511649,15906919,5671401,1,'2010-09-03 18:06:00',3310503954,2),(51362133,425517816,15901493,5671401,1,'2010-09-03 18:06:02',3310503954,2),(51362135,425519968,15898966,5671401,1,'2010-09-03 18:06:01',3310503954,2),(51362153,425506521,15909868,5671401,1,'2010-09-03 18:06:01',3310503943,2),(51362471,425459510,15913911,427965,1,'2007-09-14 19:49:09',3310503942,1),(51362474,425466592,15916057,427965,1,'2007-09-14 19:49:09',3310503942,1),(51362475,425475508,15918031,427965,1,'2007-09-14 19:49:09',3310503942,1),(51362477,425479745,15918374,427965,1,'2007-09-14 19:49:09',3310503943,1),(51362529,425439654,15917859,427965,1,'2007-09-14 19:49:09',3310503939,1),(51362531,425455779,15913739,427965,1,'2007-09-14 19:49:09',3310503942,1),(51362569,425422643,15915370,427965,1,'2007-09-14 19:51:17',3310503938,1),(51362570,425426627,15914855,427965,1,'2007-09-14 19:49:09',3310503939,1),(51362572,425436239,15917087,427965,1,'2007-09-14 19:49:09',3310503939,1),(51362612,425425173,15915627,427965,1,'2007-09-14 19:49:34',3310503939,1),(51362613,425429599,15915971,427965,1,'2007-09-14 19:49:34',3310503939,1),(51362614,425432445,15916228,427965,1,'2007-09-14 19:49:34',3310503939,1),(51362854,425433836,15917087,427965,1,'2007-09-14 19:49:34',3310503939,1),(51362856,425435607,15917945,427965,1,'2007-09-14 19:49:34',3310503939,1),(51362857,425437947,15918803,427965,1,'2007-09-14 19:49:34',3310503939,1),(51362858,425440666,15919147,427965,1,'2007-09-14 19:49:34',3310503939,1),(51362860,425443638,15919061,427965,1,'2007-09-14 19:49:34',3310503939,1),(51362861,425447495,15917859,427965,1,'2007-09-14 19:49:34',3310503939,1),(51362863,425451859,15916057,427965,1,'2007-09-14 19:49:34',3310503939,1),(51362864,425454704,15915112,427965,1,'2007-09-14 19:49:34',3310503942,1),(51362865,425457739,15914769,427965,1,'2007-09-14 19:49:34',3310503942,1),(51362867,425461660,15915370,427965,1,'2007-09-14 19:49:34',3310503942,1),(51362868,425465391,15916743,427965,1,'2007-09-14 19:49:34',3310503942,1),(51362870,425468047,15917945,427965,1,'2007-09-14 19:49:34',3310503942,1),(51362871,425471461,15918632,427965,1,'2007-09-14 19:49:34',3310503942,1),(51362872,425474307,15919147,427965,1,'2007-09-14 19:49:34',3310503942,1),(51362929,425406454,15922408,427965,1,'2007-09-14 19:51:17',3310503938,1),(51362931,425408098,15922923,427965,1,'2007-09-14 19:51:17',3310503938,1),(51362932,425410565,15923266,427965,1,'2007-09-14 19:51:17',3310503938,1),(51363022,425390989,15917139,427965,1,'2007-09-14 20:33:03',3310493015,1),(51363024,425399814,15917773,427965,1,'2007-09-14 19:51:17',3310503938,1),(51363076,425382422,15915542,427965,1,'2007-09-14 19:51:17',3310493015,1),(51363078,425385585,15916657,427965,1,'2007-09-14 19:51:17',3310493015,1),(51363079,425387925,15917087,427965,1,'2007-09-14 19:51:17',3310493015,1),(51363105,425372810,15898204,427965,1,'2007-09-14 19:51:17',3310493015,1),(51363107,425378059,15910563,427965,1,'2007-09-14 19:51:17',3310493015,1),(51363109,425380272,15913568,427965,1,'2007-09-14 19:51:17',3310493015,1),(51363149,425368888,15891337,427965,1,'2007-09-14 19:51:17',3310493014,1),(51363244,425338910,15849795,427965,1,'2007-09-14 19:56:23',3310493009,1),(51363246,425336950,15849624,427965,1,'2007-09-14 19:56:23',3310493009,1),(51363247,425333634,15851997,232546,1,'2008-04-23 11:34:50',3310493009,2),(51363248,425334862,15853572,427965,1,'2007-09-14 19:56:23',3310493009,1),(51363250,425339922,15859666,427965,1,'2007-09-14 19:56:23',3310493009,1),(51363414,425355228,15854087,427965,1,'2007-09-14 19:56:23',3310493012,1),(51363415,425345045,15856061,427965,1,'2007-09-14 19:56:23',3310493012,1),(51363565,425372430,15839667,427965,1,'2007-09-14 19:56:23',3310493013,1),(51363567,425372557,15841727,427965,1,'2007-09-14 19:56:23',3310493013,1),(51363568,425371165,15845847,427965,1,'2007-09-14 19:56:23',3310493013,1),(51363795,425337456,15802588,427965,1,'2007-09-14 19:56:23',3310491643,1),(51363797,425345361,15809712,427965,1,'2007-09-14 19:56:23',3310491646,1),(51363800,425355164,15816493,427965,1,'2007-09-14 19:56:23',3310491646,1),(51363884,425316773,15733495,427965,1,'2007-09-14 19:56:23',3310491641,1),(51364400,425305895,15725083,427965,1,'2007-09-14 19:56:23',3310491640,1),(51364728,425308045,15717015,427965,1,'2007-09-14 19:54:01',3310491640,1),(51364730,425306211,15722508,427965,1,'2007-09-14 19:54:01',3310491640,1),(51364732,425297735,15717530,427965,1,'2007-09-14 19:54:01',3310491640,1),(51364733,425299823,15712295,427965,1,'2007-09-14 19:54:01',3310491640,1),(51364894,425301530,15707488,427965,1,'2007-09-14 19:54:18',3310491634,1),(51364896,425300139,15711522,427965,1,'2007-09-14 19:54:18',3310491640,1),(51364898,425302988,15713193,198831,1,'2008-04-20 16:27:39',3310491640,2),(51364899,425304377,15709462,427965,1,'2007-09-14 19:54:18',3310491634,1),(51364998,425289574,15692183,188228,1,'2008-06-16 19:39:37',3310491634,2),(51365000,425290903,15693470,188228,1,'2008-06-16 19:39:37',3310491634,2),(51365004,425291219,15705057,188228,1,'2008-06-16 19:39:37',3310491634,2),(51365354,425281162,15693127,188228,1,'2008-06-16 19:38:21',3310491623,2),(51365356,425283249,15693213,188228,1,'2008-06-16 19:38:21',3310491623,2),(51365357,425286665,15691668,188228,1,'2008-06-16 19:38:45',3310491623,2),(51366010,425243211,15625434,427965,1,'2007-09-14 19:56:23',3310491620,1),(51366011,425244729,15628181,427965,1,'2007-09-14 19:56:23',3310491620,1),(51366015,425246500,15633674,427965,1,'2007-09-14 19:56:23',3310491620,1),(51366017,425247259,15638738,427965,1,'2007-09-14 19:56:23',3310491620,1),(51366022,425254405,15653473,188228,1,'2008-06-16 19:34:03',3310491620,2),(51366025,425256366,15658709,188228,1,'2008-06-16 19:34:03',3310491622,2),(51366028,425259213,15663515,188228,1,'2008-06-16 19:34:19',3310491622,2),(51366033,425268827,15676476,188228,1,'2008-06-16 19:35:06',3310491623,2),(51366035,425272180,15682570,188228,1,'2008-06-16 19:35:06',3310491623,2),(51366036,425273508,15686689,188228,1,'2008-06-16 19:35:26',3310491623,2),(51366037,425274267,15688664,188228,1,'2008-06-16 19:35:26',3310491623,2),(51366039,425278062,15692354,188228,1,'2008-06-16 19:35:55',3310491623,2),(51366154,425231888,15616078,2895121,1,'2009-10-19 19:23:28',3310491617,2),(51366157,425236632,15620198,427965,1,'2007-09-14 19:56:22',3310491620,1),(51366554,425173159,15543236,232546,1,'2008-04-23 11:29:32',3310491549,2),(51366556,425176322,15547099,232546,1,'2008-04-23 11:29:32',3310491551,2),(51366560,425182988,15557799,427965,1,'2007-09-14 19:57:45',3310491594,1),(51366562,425188279,15563664,232546,1,'2008-04-23 11:29:32',3310491594,2),(51366564,425205698,15578914,427965,1,'2007-09-14 19:57:45',3310491595,1),(51366769,425148382,15527329,427965,1,'2007-09-14 19:57:45',3310491548,1),(51366772,425150533,15528274,427965,1,'2007-09-14 19:57:45',3310491549,1),(51366773,425155468,15532565,427965,1,'2007-09-14 19:57:45',3310491549,1),(51366775,425158694,15533767,427965,1,'2007-09-14 19:57:45',3310491549,1),(51366776,425161858,15534711,427965,1,'2007-09-14 19:57:45',3310491549,1),(51366854,425134314,15523152,232546,1,'2008-04-23 11:31:12',3310491548,3),(51366858,425138806,15525727,232546,1,'2008-04-23 11:28:56',3310491548,2),(51366991,425123220,15508113,188228,1,'2008-06-16 18:55:07',3310491548,3),(51366992,425125416,15510163,427965,1,'2007-09-14 19:57:45',3310491548,1),(51367555,425122882,15503762,188228,1,'2008-06-16 18:51:17',3310491548,4),(51367558,425122081,15502792,188228,1,'2008-06-16 18:52:21',3310491545,4),(51367559,425121195,15503307,188228,1,'2008-06-16 18:52:21',3310491545,4),(51367563,425121630,15505152,188228,1,'2008-06-16 18:51:17',3310491545,3),(51367565,425122358,15505136,188228,1,'2008-06-16 18:51:17',3310491545,3),(51367748,425083963,15448487,840745,1,'2009-01-26 19:29:53',3310491538,2),(51367752,425083204,15451319,840745,1,'2009-01-26 19:29:53',3310491538,2),(51367755,425081179,15457499,840745,1,'2009-01-26 19:29:53',3310491538,2),(51367756,425080293,15461790,840745,1,'2009-01-26 19:29:53',3310491538,2),(51367760,425080293,15465138,840745,1,'2009-01-26 19:29:53',3310491538,2),(51367761,425081306,15469343,840745,1,'2009-01-26 19:29:53',3310491538,2),(51367762,425082571,15471403,840745,1,'2009-01-26 19:29:53',3310491538,2),(51367763,425084849,15473978,840745,1,'2009-01-26 19:29:53',3310491538,2),(51367764,425088456,15475523,840745,1,'2009-01-26 19:29:53',3310491538,2),(51367767,425097503,15479471,840745,1,'2009-01-26 19:29:53',3310491539,2),(51367769,425102059,15481102,840745,1,'2009-01-26 19:29:53',3310491539,2),(51367770,425106994,15483076,840745,1,'2009-01-26 19:29:53',3310491539,2),(51367772,425109145,15484278,840745,1,'2009-01-26 19:29:53',3310491539,2),(51367774,425110790,15485995,840745,1,'2009-01-26 19:29:53',3310491539,2),(51367776,425112245,15489771,840745,1,'2009-01-26 19:29:54',3310491539,2),(51367779,425113827,15492775,840745,1,'2009-01-26 19:29:54',3310491545,2),(51367783,425115978,15495608,840745,1,'2009-01-26 19:29:54',3310491545,2),(51367785,425117433,15498783,840745,1,'2009-01-26 19:29:54',3310491545,2),(51367787,425118369,15500716,840745,1,'2009-01-26 19:29:54',3310491545,3),(51367788,425119015,15501959,840745,1,'2009-01-26 19:29:54',3310491545,2),(51367806,425121006,15504251,840745,1,'2009-01-26 19:29:54',3310491545,5),(51367819,425122844,15504425,188228,1,'2008-06-16 18:51:17',3310491548,3),(51367842,425122696,15505700,427965,1,'2007-09-14 19:59:43',3310491548,1),(51369095,425029810,15154996,427965,1,'2007-09-14 20:01:57',3310491406,1),(51369096,425031392,15157571,427965,1,'2007-09-14 20:01:47',3310491406,1),(51369098,425033987,15161605,427965,1,'2007-09-14 20:01:47',3310491428,1),(51369101,425036455,15165982,427965,1,'2007-09-14 20:01:57',3310491428,1),(51369102,425037024,15171647,427965,1,'2007-09-14 20:01:57',3310491428,1),(51369103,425037024,15174136,427965,1,'2007-09-14 20:01:57',3310491428,1),(51369105,425037024,15176454,427965,1,'2007-09-14 20:01:57',3310491428,1),(51369106,425036201,15182977,427965,1,'2007-09-14 20:01:57',3310491428,1),(51369109,425036690,15195113,3916355,1,'2010-02-19 17:31:54',3310491428,6),(51369110,425038479,15200057,840745,1,'2009-01-26 20:00:22',3310491428,4),(51369112,425043984,15212674,840745,1,'2009-01-26 20:00:22',3310491429,4),(51369114,425045250,15216537,840745,1,'2009-01-26 20:00:23',3310491431,4),(51369115,425046009,15222030,840745,1,'2009-01-26 20:00:23',3310491431,4),(51369118,425046516,15230012,840745,1,'2009-01-26 20:00:23',3310491431,4),(51369120,425047212,15236363,840745,1,'2009-01-26 20:00:23',3310491431,4),(51369123,425049173,15247521,840745,1,'2009-01-26 20:00:23',3310491431,4),(51369125,425050807,15256082,840745,1,'2009-01-26 20:00:24',3310491431,4),(51369126,425052072,15265180,840745,1,'2009-01-26 20:00:24',3310491431,4),(51369129,425052992,15273228,3916355,1,'2010-02-19 17:34:12',3310491437,8),(51369131,425052684,15275616,3916355,1,'2010-02-19 17:34:13',3310491437,6),(51369132,425053211,15283462,840745,1,'2009-01-26 19:28:30',3310491437,2),(51369133,425054034,15288011,840745,1,'2009-01-26 19:28:30',3310491437,2),(51369134,425055489,15294963,840745,1,'2009-01-26 19:28:30',3310491437,2),(51369136,425057313,15304087,840745,1,'2009-01-26 19:28:31',3310491437,2),(51369139,425058512,15310033,840745,1,'2009-01-26 19:28:31',3310491437,2),(51369142,425062956,15329982,840745,1,'2009-01-26 19:29:52',3310491439,2),(51369145,425064158,15335904,840745,1,'2009-01-26 19:29:52',3310491439,2),(51369146,425067129,15351941,840745,1,'2009-01-26 19:29:52',3310491439,2),(51369147,425068335,15359051,840745,1,'2009-01-26 19:29:52',3310491450,2),(51369148,425069284,15366347,840745,1,'2009-01-26 19:29:52',3310491450,2),(51369150,425070802,15375874,840745,1,'2009-01-26 19:29:52',3310491450,2),(51369153,425072258,15385573,840745,1,'2009-01-26 19:29:52',3310491536,2),(51369155,425073080,15389778,840745,1,'2009-01-26 19:29:52',3310491536,2),(51369157,425074472,15397074,840745,1,'2009-01-26 19:29:52',3310491536,2),(51369159,425075168,15401795,840745,1,'2009-01-26 19:29:52',3310491536,2),(51369160,425075485,15406430,840745,1,'2009-01-26 19:29:52',3310491536,2),(51369162,425076371,15412180,840745,1,'2009-01-26 19:29:52',3310491536,2),(51369164,425078522,15419905,840745,1,'2009-01-26 19:29:52',3310491536,2),(51369165,425079787,15427630,840745,1,'2009-01-26 19:29:52',3310491536,2),(51369168,425080736,15432265,840745,1,'2009-01-26 19:29:52',3310491536,2),(51369170,425082002,15435011,840745,1,'2009-01-26 19:29:52',3310491536,2),(51369171,425083900,15440676,840745,1,'2009-01-26 19:29:52',3310491538,2),(51369173,425084216,15444453,840745,1,'2009-01-26 19:29:53',3310491538,2),(51369221,425036961,15168986,427965,1,'2007-09-14 20:01:57',3310491428,1),(51369359,425009751,15132594,427965,1,'2007-09-14 20:04:19',3310491403,1),(51369361,425006978,15138172,434787,1,'2007-09-15 14:31:20',3310491403,1),(51369362,425015130,15144868,427965,1,'2007-09-14 20:04:19',3310491406,1),(51369364,425017891,15138553,434787,1,'2007-09-15 14:31:20',3310491406,1),(51370189,425008232,15131135,427965,1,'2007-09-14 20:08:28',3310491403,1),(51370191,425007410,15131478,427965,1,'2007-09-14 20:08:28',3310491403,1),(51370193,425006207,15132422,427965,1,'2007-09-14 20:08:28',3310491403,1),(51370194,425005574,15133452,427965,1,'2007-09-14 20:08:28',3310491403,1),(51370196,425005258,15134997,427965,1,'2007-09-14 20:08:28',3310491403,1),(51370197,425005448,15137143,427965,1,'2007-09-14 20:08:28',3310491403,1),(51370198,425005828,15138688,427965,1,'2007-09-14 20:08:28',3310491403,1),(51370199,425007156,15140061,427965,1,'2007-09-14 20:08:28',3310491403,1),(51370201,425015320,15146327,427965,1,'2007-09-14 20:08:28',3310491406,1),(51370202,425016838,15146499,427965,1,'2007-09-14 20:08:28',3310491406,1),(51370203,425018104,15145812,427965,1,'2007-09-14 20:08:28',3310491406,1),(51370206,425019116,15144696,427965,1,'2007-09-14 20:08:28',3310491406,1),(51370208,425019812,15143580,427965,1,'2007-09-14 20:08:28',3310491406,1),(51370210,425019876,15141006,427965,1,'2007-09-14 20:08:28',3310491406,1),(51370211,425019559,15139461,427965,1,'2007-09-14 20:08:28',3310491406,1),(51370213,425018800,15138001,427965,1,'2007-09-14 20:08:28',3310491406,1),(51370260,425009624,15131049,427965,1,'2007-09-14 20:08:28',3310491403,1),(51371237,425021584,15139203,427965,1,'2007-09-14 20:05:51',3310491406,1),(51371240,425023229,15142035,427965,1,'2007-09-14 20:05:14',3310491406,1),(51371243,425025191,15147014,427965,1,'2007-09-14 20:05:14',3310491406,1),(51371246,425027659,15151563,427965,1,'2007-09-14 20:05:14',3310491406,1),(51371386,424939190,15008054,427965,1,'2007-09-14 20:05:52',3310491223,1),(51371387,424939140,15009063,592895,1,'2008-07-25 23:27:47',3310491223,2),(51371388,424939823,15011058,427965,1,'2007-09-14 20:05:51',3310491223,1),(51371389,424941617,15014249,592895,1,'2008-07-25 22:38:46',3310491223,3),(51371391,424944085,15020514,592895,1,'2008-07-25 22:38:46',3310491223,3),(51371392,424948009,15029269,592895,1,'2008-07-25 22:38:46',3310491223,3),(51371395,424949971,15033732,592895,1,'2008-07-25 22:35:39',3310491223,2),(51371400,424950961,15042729,427965,1,'2007-09-14 20:05:51',3310491223,1),(51371401,424950771,15045819,427965,1,'2007-09-14 20:05:51',3310491223,1),(51371402,424950708,15048223,427965,1,'2007-09-14 20:05:51',3310491223,1),(51371403,424951024,15050712,427965,1,'2007-09-14 20:05:51',3310491223,1),(51371404,424952037,15053716,427965,1,'2007-09-14 20:05:51',3310491229,1),(51371406,424955138,15058780,427965,1,'2007-09-14 20:05:51',3310491229,1),(51371408,424960201,15067449,427965,1,'2007-09-14 20:05:51',3310491400,1),(51371409,424965263,15074830,427965,1,'2007-09-14 20:05:51',3310491400,1),(51371411,424967162,15077662,427965,1,'2007-09-14 20:05:51',3310491400,1),(51371413,424972794,15090709,427965,1,'2007-09-14 20:05:51',3310491400,1),(51371415,424977857,15100751,427965,1,'2007-09-14 20:05:51',3310491400,1),(51371418,424981781,15106330,427965,1,'2007-09-14 20:05:51',3310491400,1),(51371421,424985577,15109591,427965,1,'2007-09-14 20:05:51',3310491403,1),(51371422,424989881,15113626,427965,1,'2007-09-14 20:05:31',3310491403,1),(51371423,424995260,15117230,427965,1,'2007-09-14 20:05:51',3310491403,1),(51371425,425005321,15125041,427965,1,'2007-09-14 20:05:51',3310491403,1),(51371428,425008675,15127616,427965,1,'2007-09-14 20:05:51',3310491403,1),(51371430,425019180,15136542,427965,1,'2007-09-14 20:05:51',3310491406,1),(51384482,424942193,14992314,427965,1,'2007-09-14 20:30:03',3310491221,1),(51384485,424941307,14995575,427965,1,'2007-09-14 20:30:03',3310491221,1),(51384487,424940927,14999008,427965,1,'2007-09-14 20:30:03',3310491223,1),(51384488,424940801,15003042,427965,1,'2007-09-14 20:30:03',3310491223,1),(51384490,424941094,15005147,462689,1,'2008-05-17 12:22:13',3310491223,3),(51384518,424941054,15004587,427965,1,'2007-09-14 20:30:03',3310491223,1),(51385251,424849718,14920951,592895,1,'2008-07-25 21:23:37',3310490874,3),(51385256,424852826,14923392,427965,1,'2007-09-14 20:30:03',3310490874,1),(51385259,424855484,14925022,427965,1,'2007-09-14 20:30:03',3310490874,1),(51385261,424860421,14926825,427965,1,'2007-09-14 20:30:03',3310490874,1),(51385264,424865801,14928885,427965,1,'2007-09-14 20:30:03',3310490874,1),(51385266,424888903,14941759,427965,1,'2007-09-14 20:30:03',3310491217,1),(51385267,424893903,14944592,427965,1,'2007-09-14 20:30:03',3310491217,1),(51385271,424902131,14949141,427965,1,'2007-09-14 20:30:03',3310491217,1),(51385273,424915226,14958974,592895,1,'2008-07-25 22:09:57',3310491220,2),(51385276,424927504,14971763,592895,1,'2008-07-25 22:09:57',3310491220,2),(51385277,424932630,14978543,592895,1,'2008-07-25 22:16:08',3310491221,2),(51385279,424934719,14981204,592895,1,'2008-07-25 22:16:08',3310491221,2),(51385284,424936428,14982921,592895,1,'2008-07-25 22:16:08',3310491221,2),(51385285,424938263,14983436,592895,1,'2008-07-25 22:16:08',3310491221,2),(51385287,424940288,14983521,592895,1,'2008-07-25 22:16:08',3310491221,2),(51385289,424942187,14983092,592895,1,'2008-07-25 22:16:08',3310491221,2),(51385290,424946019,14981546,592895,1,'2008-07-25 22:14:49',3310491221,2),(51385291,424948902,14980726,592895,1,'2008-07-25 22:14:49',3310491221,2),(51385292,424950484,14980898,592895,1,'2008-07-25 22:14:49',3310491221,2),(51385295,424951616,14981376,592895,1,'2008-07-25 22:15:37',3310491221,3),(51385296,424952376,14982577,592895,1,'2008-07-25 22:15:37',3310491221,3),(51385297,424952692,14983951,592895,1,'2008-07-25 22:15:37',3310491221,3),(51385298,424952313,14985324,592895,1,'2008-07-25 22:15:37',3310491221,3),(51385299,424951363,14986096,592895,1,'2008-07-25 22:15:37',3310491221,3),(51385300,424950098,14986697,592895,1,'2008-07-25 22:15:37',3310491221,3),(51385302,424944402,14988757,592895,1,'2008-07-25 22:16:28',3310491221,2),(51385304,424942952,14990597,427965,1,'2007-09-14 20:30:03',3310491221,1),(51385320,424842122,14911509,592895,1,'2008-07-25 21:28:02',3310490863,3),(51385334,424835945,14906979,439281,1,'2007-09-16 00:57:34',3310490863,1),(51385336,424840103,14909487,427965,1,'2007-09-14 20:30:34',3310490863,1),(51385349,424829931,14903460,439281,1,'2007-09-16 00:57:48',3310490863,1),(51385966,424686038,14926891,439281,1,'2007-09-16 00:57:42',3310490814,1),(51385967,424691989,14927235,439281,1,'2007-09-16 00:57:41',3310490814,1),(51385970,424697877,14927750,439281,1,'2007-09-16 00:57:43',3310490814,1),(51385971,424701613,14930067,439281,1,'2007-09-16 00:57:43',3310490814,1),(51385973,424705664,14930925,439281,1,'2007-09-16 00:57:44',3310490814,1),(51385974,424710983,14931440,439281,1,'2007-09-16 00:57:43',3310490815,1),(51385975,424714655,14932728,439281,1,'2007-09-16 00:57:43',3310490815,1),(51385976,424721809,14934702,439281,1,'2007-09-16 00:57:42',3310490815,1),(51385978,424727823,14934445,439281,1,'2007-09-16 00:57:42',3310490815,1),(51385979,424730039,14934187,439281,1,'2007-09-16 00:57:42',3310490815,1),(51385982,424732001,14932470,439281,1,'2007-09-16 00:57:42',3310490815,1),(51385983,424733711,14930325,439281,1,'2007-09-16 00:57:43',3310490815,1),(51385985,424736053,14924317,439281,1,'2007-09-16 00:57:44',3310490815,1),(51385986,424738459,14916935,439281,1,'2007-09-16 00:57:44',3310490858,1),(51385988,424741624,14912214,439281,1,'2007-09-16 00:57:44',3310490858,1),(51385990,424744156,14909725,439281,1,'2007-09-16 00:57:44',3310490858,1),(51385991,424748904,14907837,439281,1,'2007-09-16 00:57:44',3310490858,1),(51385994,424752893,14908524,439281,1,'2007-09-16 00:57:45',3310490858,1),(51385996,424756121,14908009,439281,1,'2007-09-16 00:57:45',3310490858,1),(51385997,424759033,14907150,439281,1,'2007-09-16 00:57:45',3310490858,1),(51386001,424770112,14906464,439281,1,'2007-09-16 00:57:46',3310490859,1),(51386002,424774036,14905262,439281,1,'2007-09-16 00:57:46',3310490859,1),(51386005,424779860,14902344,439281,1,'2007-09-16 00:57:45',3310490859,1),(51386008,424788533,14897280,439281,1,'2007-09-16 00:57:47',3310490859,1),(51386009,424793407,14894619,439281,1,'2007-09-16 00:57:47',3310490862,1),(51386011,424798091,14893246,439281,1,'2007-09-16 00:57:47',3310490862,1),(51386013,424800687,14893332,439281,1,'2007-09-16 00:57:46',3310490862,1),(51386014,424807080,14894190,439281,1,'2007-09-16 00:57:46',3310490862,1),(51386018,424812208,14895306,439281,1,'2007-09-16 00:57:48',3310490862,1),(51386019,424817461,14896765,439281,1,'2007-09-16 00:57:48',3310490862,1),(51386021,424825057,14900198,439281,1,'2007-09-16 00:57:47',3310490863,1),(51386271,424545848,14868288,439281,1,'2007-09-16 00:57:35',3310490793,1),(51386274,424555157,14864769,439281,1,'2007-09-16 00:57:37',3310490793,1),(51386275,424558576,14864512,439281,1,'2007-09-16 00:57:38',3310490793,1),(51386276,424565289,14865627,439281,1,'2007-09-16 00:57:37',3310490793,1),(51386279,424569911,14867687,439281,1,'2007-09-16 00:57:37',3310490793,1),(51386281,424575231,14870691,439281,1,'2007-09-16 00:57:38',3310490796,1),(51386282,424578460,14873352,439281,1,'2007-09-16 00:57:38',3310490796,1),(51386284,424581690,14878330,439281,1,'2007-09-16 00:57:38',3310490796,1),(51386286,424584413,14881764,439281,1,'2007-09-16 00:57:38',3310490796,1),(51386287,424585806,14882708,439281,1,'2007-09-16 00:57:38',3310490796,1),(51386289,424588845,14883995,439281,1,'2007-09-16 00:57:35',3310490796,1),(51386290,424591821,14886484,439281,1,'2007-09-16 00:57:36',3310490796,1),(51386294,424595051,14888802,439281,1,'2007-09-16 00:57:35',3310490798,1),(51386295,424603916,14894638,439281,1,'2007-09-16 00:57:35',3310490799,1),(51386296,424610850,14899397,443749,1,'2007-09-16 13:41:57',3310490799,1),(51386298,424615313,14903221,439281,1,'2007-09-16 00:57:37',3310490799,1),(51386301,424621575,14904388,439281,1,'2007-09-16 00:57:36',3310490799,1),(51386302,424622668,14904022,439281,1,'2007-09-16 00:57:36',3310490799,1),(51386304,424623862,14903545,439281,1,'2007-09-16 00:57:40',3310490799,1),(51386307,424632916,14901228,439281,1,'2007-09-16 00:57:40',3310490810,1),(51386309,424643427,14898052,439281,1,'2007-09-16 00:57:40',3310490810,1),(51386312,424647163,14897623,439281,1,'2007-09-16 00:57:41',3310490810,1),(51386315,424649885,14898310,439281,1,'2007-09-16 00:57:41',3310490810,1),(51386316,424652418,14900284,439281,1,'2007-09-16 00:57:41',3310490810,1),(51386319,424655710,14905348,439281,1,'2007-09-16 00:57:41',3310490811,1),(51386320,424660649,14913588,439281,1,'2007-09-16 00:57:39',3310490811,1),(51386324,424663751,14917021,439281,1,'2007-09-16 00:57:39',3310490811,1),(51386327,424667803,14919939,439281,1,'2007-09-16 00:57:39',3310490811,1),(51386330,424674578,14923029,439281,1,'2007-09-16 00:57:39',3310490811,1),(51386331,424679200,14925518,439281,1,'2007-09-16 00:57:39',3310490811,1),(51386333,424682176,14926548,439281,1,'2007-09-16 00:57:40',3310490811,1),(51386340,424533036,14870863,427965,1,'2007-09-14 20:32:06',3310490792,1),(51386342,424535949,14870863,427965,1,'2007-09-14 20:32:06',3310490792,1),(51386346,424539832,14870262,439281,1,'2007-09-16 00:57:41',3310490792,1),(51386455,424509858,14861508,427965,1,'2007-09-14 20:32:06',3310490109,1),(51386456,424520687,14866915,427965,1,'2007-09-14 20:32:06',3310490792,1),(51386457,424527020,14869490,427965,1,'2007-09-14 20:32:06',3310490792,1),(51386536,424496051,14842453,427965,1,'2007-09-14 20:32:17',3310490109,1),(51386538,424504665,14855499,427965,1,'2007-09-14 20:32:17',3310490109,1),(51386795,425247920,15640249,427965,1,'2007-09-14 20:32:48',3310491620,1),(51387092,425441896,15918083,427965,1,'2007-09-14 20:33:11',3310503939,1),(51389997,425436395,17314720,427965,1,'2007-09-14 20:38:56',3310504587,1),(51389999,425441137,17314120,427965,1,'2007-09-14 20:38:56',3310504587,1),(51390001,425447524,17312317,427965,1,'2007-09-14 20:38:56',3310504587,1),(51390003,425453089,17311030,427965,1,'2007-09-14 20:38:56',3310504590,1),(51390006,425456630,17310686,427965,1,'2007-09-14 20:38:56',3310504590,1),(51390008,425458907,17311459,427965,1,'2007-09-14 20:38:56',3310504590,1),(51390010,425460551,17311545,427965,1,'2007-09-14 20:38:56',3310504590,1),(51390012,425462384,17311287,427965,1,'2007-09-14 20:38:56',3310504590,1),(51390014,425463965,17310343,427965,1,'2007-09-14 20:38:56',3310504590,1),(51390016,425464977,17309485,206510,1,'2008-12-06 20:10:24',3310504590,5),(51391054,425460677,17308369,206510,1,'2008-12-06 20:10:24',3310504590,2),(51391055,425462068,17306137,427965,1,'2007-09-14 20:41:03',3310504590,1),(51391057,425463586,17304335,427965,1,'2007-09-14 20:41:03',3310504590,1),(51391058,425464914,17303391,427965,1,'2007-09-14 20:41:03',3310504588,1),(51391060,425467127,17303562,427965,1,'2007-09-14 20:41:03',3310504588,1),(51391063,425468392,17304850,427965,1,'2007-09-14 20:41:03',3310504590,1),(51391064,425469467,17306824,427965,1,'2007-09-14 20:41:03',3310504590,1),(51391065,425469720,17309056,427965,1,'2007-09-14 20:41:03',3310504590,1),(51391067,425469656,17310944,206510,1,'2008-12-06 20:09:53',3310504590,4),(51392412,425381756,17283564,206510,1,'2008-12-06 20:10:24',3310493661,2),(51392415,425381376,17284765,427965,1,'2007-09-14 20:47:30',3310493661,1),(51392416,425381629,17285795,427965,1,'2007-09-14 20:47:30',3310493661,1),(51392417,425383337,17287855,427965,1,'2007-09-14 20:47:30',3310493661,1),(51392418,425387764,17292319,427965,1,'2007-09-14 20:47:30',3310493661,1),(51392420,425390293,17294464,427965,1,'2007-09-14 20:43:47',3310493661,1),(51392422,425392823,17295666,427965,1,'2007-09-14 20:47:30',3310493661,1),(51392424,425395100,17295838,427965,1,'2007-09-14 20:47:30',3310493661,1),(51392426,425399906,17296524,427965,1,'2007-09-14 20:47:30',3310504584,1),(51392429,425407368,17299528,427965,1,'2007-09-14 20:47:30',3310504584,1),(51392430,425412997,17301502,427965,1,'2007-09-14 20:47:30',3310504584,1),(51392432,425417929,17304077,427965,1,'2007-09-14 20:47:30',3310504586,1),(51392434,425422356,17305279,427965,1,'2007-09-14 20:47:30',3310504586,1),(51392435,425424885,17305365,427965,1,'2007-09-14 20:47:30',3310504587,1),(51392436,425426530,17306481,427965,1,'2007-09-14 20:47:30',3310504587,1),(51392437,425426656,17307854,427965,1,'2007-09-14 20:47:30',3310504587,1),(51392439,425426403,17308970,427965,1,'2007-09-14 20:47:30',3310504587,1),(51392441,425425455,17309570,427965,1,'2007-09-14 20:47:30',3310504587,1),(51392442,425423557,17309056,427965,1,'2007-09-14 20:47:30',3310504586,1),(51392445,425420079,17308712,427965,1,'2007-09-14 20:47:30',3310504586,1),(51392447,425416411,17308197,427965,1,'2007-09-14 20:47:30',3310504586,1),(51396271,425470289,17005043,427965,1,'2007-09-14 20:51:38',3310504486,1),(51396360,425442212,17007361,427965,1,'2007-09-14 20:51:38',3310504483,1),(51396361,425443351,17007618,427965,1,'2007-09-14 20:51:38',3310504483,1),(51396363,425444679,17008305,427965,1,'2007-09-14 20:51:38',3310504483,1),(51396365,425446260,17010708,427965,1,'2007-09-14 20:51:38',3310504483,1),(51396367,425448157,17012081,427965,1,'2007-09-14 20:51:38',3310504483,1),(51396369,425450686,17012510,427965,1,'2007-09-14 20:51:38',3310504483,1),(51396370,425454290,17011051,427965,1,'2007-09-14 20:51:38',3310504486,1),(51396371,425456820,17009678,427965,1,'2007-09-14 20:51:38',3310504486,1),(51396373,425459412,17009335,427965,1,'2007-09-14 20:51:38',3310504486,1),(51396374,425463143,17008391,427965,1,'2007-09-14 20:51:38',3310504486,1),(51396375,425466178,17007618,427965,1,'2007-09-14 20:51:38',3310504486,1),(51396377,425469087,17005816,427965,1,'2007-09-14 20:51:38',3310504486,1),(51396378,425472186,17003327,427965,1,'2007-09-14 20:51:38',3310504486,1),(51396380,425474019,17002726,427965,1,'2007-09-14 20:51:38',3310504486,1),(51396399,425476296,17002640,427965,1,'2007-09-14 20:51:38',3310504486,1),(51396983,425353739,17018519,427965,1,'2007-09-14 20:51:38',3310493558,1),(51396985,425356964,17018690,427965,1,'2007-09-14 20:51:38',3310493558,1),(51396986,425361771,17017746,427965,1,'2007-09-14 20:51:38',3310493558,1),(51396989,425365376,17016716,427965,1,'2007-09-14 20:51:38',3310493558,1),(51396991,425368538,17014828,427965,1,'2007-09-14 20:51:38',3310493558,1),(51396992,425371637,17012940,427965,1,'2007-09-14 20:51:38',3310493559,1),(51396993,425375431,17012425,427965,1,'2007-09-14 20:51:38',3310493559,1),(51396996,425378594,17012167,427965,1,'2007-09-14 20:51:38',3310493559,1),(51396997,425381186,17012510,427965,1,'2007-09-14 20:51:38',3310493559,1),(51396999,425384032,17012940,427965,1,'2007-09-14 20:51:38',3310493559,1),(51397000,425386436,17012596,427965,1,'2007-09-14 20:51:38',3310493559,1),(51397003,425388965,17012339,427965,1,'2007-09-14 20:51:38',3310493559,1),(51397004,425392254,17012940,427965,1,'2007-09-14 20:51:38',3310493559,1),(51397005,425394467,17013283,427965,1,'2007-09-14 20:51:38',3310493559,1),(51397008,425395985,17012854,427965,1,'2007-09-14 20:51:38',3310493559,1),(51397009,425398198,17012167,427965,1,'2007-09-14 20:51:38',3310504482,1),(51397010,425400412,17011566,427965,1,'2007-09-14 20:51:38',3310504482,1),(51397012,425403637,17011566,427965,1,'2007-09-14 20:51:38',3310504482,1),(51397013,425406103,17012167,427965,1,'2007-09-14 20:51:38',3310504482,1),(51397015,425409076,17013197,427965,1,'2007-09-14 20:51:38',3310504482,1),(51397016,425412680,17014570,427965,1,'2007-09-14 20:51:38',3310504482,1),(51397017,425414767,17015600,427965,1,'2007-09-14 20:51:38',3310504482,1),(51397019,425417423,17015600,427965,1,'2007-09-14 20:51:38',3310504482,1),(51397021,425419953,17014828,427965,1,'2007-09-14 20:51:38',3310504482,1),(51397022,425421724,17013884,427965,1,'2007-09-14 20:51:38',3310504482,1),(51397024,425425265,17012253,427965,1,'2007-09-14 20:51:38',3310504483,1),(51397026,425429818,17010536,427965,1,'2007-09-14 20:51:38',3310504483,1),(51397027,425432600,17009421,427965,1,'2007-09-14 20:51:38',3310504483,1),(51397028,425434940,17008476,427965,1,'2007-09-14 20:51:38',3310504483,1),(51397029,425437659,17007618,427965,1,'2007-09-14 20:51:38',3310504483,1),(51397032,425439936,17007361,427965,1,'2007-09-14 20:51:38',3310504483,1),(51397034,425445501,17009506,427965,1,'2007-09-14 20:51:38',3310504483,1),(51397727,425607048,16810465,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397729,425604519,16811409,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397731,425603507,16813469,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397732,425603570,16815357,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397733,425604898,16818876,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397734,425605530,16821881,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397737,425605530,16824112,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397738,425604772,16826859,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397740,425603823,16828747,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397742,425602369,16830464,427965,1,'2007-09-14 20:53:50',3310504477,1),(51397744,425600409,16831408,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397748,425597565,16831064,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397749,425594151,16829605,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397752,425591875,16829262,427965,1,'2007-09-14 20:53:59',3310504477,1),(51397753,425588081,16830549,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397756,425583087,16830893,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397757,425580179,16832266,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397758,425578219,16833725,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397762,425576954,16835098,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397764,425576322,16836472,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397766,425576449,16838103,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397769,425577334,16840162,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397770,425577334,16843596,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397771,425575690,16847029,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397772,425572213,16850205,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397773,425566522,16854496,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397776,425563172,16858187,427965,1,'2007-09-14 20:53:59',3310504476,1),(51397777,425561528,16861105,427965,1,'2007-09-14 20:53:59',3310504473,1),(51397779,425561275,16864367,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397781,425561717,16867972,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397782,425562539,16871233,427965,1,'2007-09-14 20:53:59',3310504478,1),(51397783,425562919,16873121,427965,1,'2007-09-14 20:53:59',3310504478,1),(51397786,425562034,16874838,427965,1,'2007-09-14 20:53:59',3310504478,1),(51397788,425560769,16875525,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397790,425559125,16874838,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397791,425556723,16874237,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397794,425555205,16873036,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397795,425553688,16873036,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397796,425549642,16875525,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397798,425547618,16876812,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397799,425547113,16878100,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397802,425546923,16880503,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397803,425546101,16883164,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397806,425544584,16886254,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397808,425542687,16887026,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397810,425539968,16889343,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397813,425538956,16891060,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397814,425538514,16893892,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397815,425537882,16896210,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397816,425536870,16897755,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397818,425535795,16898527,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397819,425534847,16898098,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397821,425534720,16896811,427965,1,'2007-09-14 20:53:59',3310504475,1),(51397822,425533961,16895867,427965,1,'2007-09-14 20:53:59',3310504474,1),(51397824,425532950,16895094,427965,1,'2007-09-14 20:53:59',3310504474,1),(51397825,425531622,16895867,427965,1,'2007-09-14 20:53:59',3310504474,1),(51397826,425529346,16898527,427965,1,'2007-09-14 20:53:59',3310504474,1),(51397828,425528145,16902561,427965,1,'2007-09-14 20:53:59',3310504474,1),(51397829,425526754,16907454,427965,1,'2007-09-14 20:53:59',3310504474,1),(51397830,425524161,16912003,427965,1,'2007-09-14 20:53:59',3310504474,1),(51397831,425522264,16913719,427965,1,'2007-09-14 20:53:59',3310504474,1),(51397832,425521379,16915522,427965,1,'2007-09-14 20:53:59',3310504474,1),(51397834,425521379,16918612,427965,1,'2007-09-14 20:53:59',3310504474,1),(51397835,425520368,16920157,427965,1,'2007-09-14 20:53:59',3310504496,1),(51397837,425518534,16923247,427965,1,'2007-09-14 20:53:59',3310504496,1),(51398048,425631260,16788235,427965,1,'2007-09-14 20:53:59',3310504514,1),(51398049,425628415,16789866,427965,1,'2007-09-14 20:53:59',3310504514,1),(51398053,425626203,16793213,427965,1,'2007-09-14 20:53:59',3310504514,1),(51398054,425623990,16794071,427965,1,'2007-09-14 20:53:59',3310504514,1),(51398057,425622663,16796045,427965,1,'2007-09-14 20:53:50',3310504514,1),(51398058,425621145,16800080,427965,1,'2007-09-14 20:53:59',3310504514,1),(51398059,425619312,16802139,427965,1,'2007-09-14 20:53:59',3310504514,1),(51398060,425617289,16801796,427965,1,'2007-09-14 20:53:59',3310504514,1),(51398063,425615835,16802912,427965,1,'2007-09-14 20:53:59',3310504471,1),(51398065,425614444,16805916,427965,1,'2007-09-14 20:53:59',3310504471,1),(51398068,425611979,16807633,427965,1,'2007-09-14 20:53:59',3310504471,1),(51398069,425609323,16809178,427965,1,'2007-09-14 20:53:59',3310504471,1),(51398098,425639162,16782055,427965,1,'2007-09-14 20:53:59',3310504514,1),(51398099,425635622,16784802,427965,1,'2007-09-14 20:53:59',3310504514,1),(51399265,425055276,15279589,305941,1,'2009-02-09 21:25:15',3310491437,2),(51399266,425057238,15287914,305941,1,'2009-02-09 21:25:14',3310491437,2),(51399269,425058503,15291863,305941,1,'2009-02-09 21:25:14',3310491437,2),(51399270,425064768,15301047,305941,1,'2009-02-09 21:25:14',3310491437,2),(51399272,425068248,15306025,305941,1,'2009-02-09 21:25:14',3310491448,2),(51399273,425069070,15307226,305941,1,'2009-02-09 21:25:14',3310491448,2),(51399275,425072614,15316668,305941,1,'2009-02-09 21:25:14',3310491448,2),(51399277,425073373,15318299,305941,1,'2009-02-09 21:25:14',3310491448,2),(51399278,425082801,15326624,305941,1,'2009-02-09 21:25:14',3310491450,2),(51399285,425082862,15292505,443527,1,'2008-05-14 12:03:55',3310491448,2),(51399289,425062971,15310660,443749,1,'2007-09-16 21:50:10',3310491437,1),(51399292,425066578,15319296,443749,1,'2007-09-16 21:50:09',3310491437,1),(51399296,425073430,15281647,443527,1,'2008-05-14 12:03:55',3310491448,2),(51399299,425062047,15296841,305941,1,'2009-02-09 21:25:14',3310491437,2),(51399303,425073942,15300102,427965,1,'2007-09-14 21:15:41',3310491448,1),(51399304,425070336,15294352,427965,1,'2007-09-14 21:15:42',3310491448,1),(51399306,425067172,15289889,427965,1,'2007-09-14 21:15:40',3310491437,1),(51399308,425064261,15285168,427965,1,'2007-09-14 21:15:39',3310491437,1),(51399309,425058820,15292378,305941,1,'2009-02-09 21:25:14',3310491437,2),(51399320,425074408,15341741,104780,1,'2009-02-04 00:34:16',3310491450,5),(51399321,425065613,15341655,104780,1,'2009-02-04 00:34:16',3310491439,6),(51399325,425079574,15327053,427965,1,'2007-09-14 20:57:20',3310491450,1),(51399326,425075967,15325337,427965,1,'2007-09-14 20:57:20',3310491448,1),(51399327,425074132,15324307,427965,1,'2007-09-14 20:57:20',3310491448,1),(51399329,425072361,15322247,427965,1,'2007-09-14 20:57:20',3310491448,1),(51399335,425077233,15316582,427965,1,'2007-09-14 21:15:39',3310491448,1),(51399337,425075461,15312205,427965,1,'2007-09-14 21:15:39',3310491448,1),(51399339,425074702,15301476,427965,1,'2007-09-14 21:15:39',3310491448,1),(51399365,425070248,15326367,305941,1,'2009-02-09 21:23:21',3310491450,2),(51399367,425079913,15341311,305941,1,'2009-02-09 21:23:21',3310491450,6),(51399377,425077313,15285484,443527,1,'2008-05-14 12:03:55',3310491448,2),(51399380,425067235,15298214,427965,1,'2007-09-14 20:57:18',3310491437,1),(51399381,425058194,15307642,840745,1,'2009-01-26 19:28:31',3310491437,2),(51399398,425073942,15324049,427965,1,'2007-09-14 20:57:20',3310491448,1),(51399406,425081978,15315638,305941,1,'2009-02-09 21:17:59',3310491448,5),(51399409,425075588,15320273,305941,1,'2009-02-09 21:25:14',3310491448,2),(51399411,425071450,15328169,305941,1,'2009-02-09 21:23:21',3310491450,2),(51399601,425067727,15320781,3916355,1,'2010-02-19 17:34:16',3310491448,4),(51399602,425072804,15317269,305941,1,'2009-02-09 21:25:14',3310491448,3),(51400247,425088873,15288745,437032,1,'2008-05-13 21:23:13',3310491448,2),(51400250,425088116,15291348,427965,1,'2007-09-14 21:14:43',3310491448,1);
INSERT INTO `nodes` VALUES (51400253,425083498,15303690,305941,1,'2009-02-09 21:17:59',3310491448,6),(51400254,425082485,15308497,305941,1,'2009-02-09 21:17:59',3310491448,6),(51400256,425082737,15324478,305941,1,'2009-02-09 21:17:59',3310491448,5),(51400257,425083686,15334606,305941,1,'2009-02-09 21:17:59',3310491450,5),(51400259,425084889,15348683,305941,1,'2009-02-09 21:19:42',3310491450,5),(51400263,425086407,15368338,305941,1,'2009-02-09 21:20:12',3310491450,6),(51400264,425086724,15380011,305941,1,'2009-02-09 21:20:12',3310491450,2),(51400267,425086903,15397735,305941,1,'2009-02-09 21:21:16',3310491536,8),(51400269,425086966,15404516,305941,1,'2009-02-09 21:21:16',3310491536,5),(51400270,425088168,15417133,305941,1,'2009-02-09 21:21:16',3310491536,5),(51400272,425088991,15424600,305941,1,'2009-02-09 21:21:16',3310491536,6),(51400273,425090003,15433612,305941,1,'2009-02-09 21:20:30',3310491536,3),(51400276,425091205,15439534,305941,1,'2009-02-09 21:20:30',3310491538,3),(51400277,425091395,15442281,305941,1,'2009-02-09 21:20:30',3310491538,3),(51400280,425092534,15448633,305941,1,'2009-02-09 21:20:30',3310491538,3),(51400281,425094749,15455756,305941,1,'2009-02-09 21:20:30',3310491538,3),(51400283,425096710,15460477,188228,1,'2008-06-16 18:48:34',3310491539,2),(51400284,425097532,15462537,188228,1,'2008-06-16 18:48:34',3310491539,2),(51400285,425099620,15464425,188228,1,'2008-06-16 18:48:34',3310491539,2),(51400286,425102468,15464254,188228,1,'2008-06-16 18:48:34',3310491539,2),(51400290,425105831,15464297,427965,1,'2007-09-14 21:14:43',3310491539,1),(51400293,425109997,15465713,188228,1,'2008-06-16 18:49:46',3310491539,2),(51400296,425111705,15468717,188228,1,'2008-06-16 18:49:46',3310491539,2),(51400299,425113603,15477901,188228,1,'2008-06-16 18:49:46',3310491539,2),(51400301,425115818,15487686,188228,1,'2008-06-16 18:51:31',3310491539,2),(51400303,425117526,15495410,188228,1,'2008-06-16 18:51:31',3310491545,2),(51400305,425119614,15500131,188228,1,'2008-06-16 18:51:31',3310491545,2),(51400766,425098711,15387955,427965,1,'2007-09-14 22:14:55',3310491537,1),(51400768,425086713,15387264,305941,1,'2009-02-09 21:20:13',3310491536,3),(51400770,425081345,15387650,305941,1,'2009-02-09 21:22:13',3310491536,2),(51400772,425081282,15384731,305941,1,'2009-02-09 21:22:13',3310491536,2),(51400773,425081156,15381985,305941,1,'2009-02-09 21:22:13',3310491536,2),(51400777,425080776,15377779,305941,1,'2009-02-09 21:22:14',3310491450,2),(51400778,425079257,15374689,305941,1,'2009-02-09 21:22:14',3310491450,2),(51400779,425078118,15372114,305941,1,'2009-02-09 21:22:14',3310491450,2),(51400782,425077549,15368939,305941,1,'2009-02-09 21:22:14',3310491450,2),(51400784,425076853,15362759,305941,1,'2009-02-09 21:22:14',3310491450,2),(51400786,425076726,15358982,305941,1,'2009-02-09 21:22:14',3310491450,2),(51400787,425076542,15355927,305941,1,'2009-02-09 21:22:14',3310491450,3),(51400789,425076410,15353918,305941,1,'2009-02-09 21:22:14',3310491450,2),(51400791,425075081,15350142,305941,1,'2009-02-09 21:22:14',3310491450,2),(51400793,425072550,15344219,305941,1,'2009-02-09 21:22:14',3310491450,2),(51400794,425071245,15341826,305941,1,'2009-02-09 21:22:14',3310491450,6),(51400863,425072107,15374088,820251,1,'2009-03-16 23:49:41',3310491450,2),(51400866,425072361,15376749,820251,1,'2009-03-16 23:49:41',3310491450,2),(51400868,425072930,15377951,820251,1,'2009-03-16 23:49:41',3310491450,2),(51400869,425074259,15378809,820251,1,'2009-03-16 23:49:42',3310491450,2),(51400870,425080966,15378981,820251,1,'2009-03-16 23:50:05',3310491450,5),(51400871,425086724,15379238,820251,1,'2009-03-16 23:50:06',3310491450,4),(51400970,425070009,15370519,820251,1,'2009-03-16 23:49:40',3310491450,3),(51400971,425071665,15372372,820251,1,'2009-03-16 23:49:40',3310491450,2),(51401220,425081662,15417433,305941,1,'2009-02-09 21:22:13',3310491536,2),(51401223,425081662,15413914,305941,1,'2009-02-09 21:22:13',3310491536,2),(51401224,425082041,15409193,305941,1,'2009-02-09 21:22:13',3310491536,3),(51401226,425082801,15402155,305941,1,'2009-02-09 21:22:13',3310491536,2),(51401227,425082737,15398379,305941,1,'2009-02-09 21:22:13',3310491536,2),(51401228,425081598,15392113,305941,1,'2009-02-09 21:22:13',3310491536,2),(51401444,425118043,15406189,427965,1,'2007-09-14 21:07:01',3310491537,1),(51401446,425116840,15405417,427965,1,'2007-09-14 21:07:01',3310491537,1),(51401447,425114689,15407133,427965,1,'2007-09-14 21:07:01',3310491537,1),(51401449,425110577,15411511,427965,1,'2007-09-14 21:07:01',3310491537,1),(51401451,425108995,15412712,427965,1,'2007-09-14 21:07:01',3310491537,1),(51401452,425106844,15412712,427965,1,'2007-09-14 21:07:01',3310491537,1),(51401454,425103997,15410824,495907,1,'2008-07-15 17:43:20',3310491537,2),(51401456,425097163,15407820,305941,1,'2009-02-09 21:21:41',3310491537,2),(51401457,425093114,15407734,305941,1,'2009-02-09 21:21:41',3310491536,2),(51401461,425087029,15408550,305941,1,'2009-02-09 21:21:42',3310491536,6),(51402983,425026296,15134449,427965,1,'2007-09-14 21:03:11',3310491406,1),(51402986,425034775,15143719,427965,1,'2007-09-14 21:03:11',3310491406,1),(51402987,425047683,15159083,427965,1,'2007-09-14 21:03:11',3310491407,1),(51402989,425050657,15162430,427965,1,'2007-09-14 21:03:11',3310491429,1),(51402991,425053125,15166722,427965,1,'2007-09-14 21:03:11',3310491429,1),(51402994,425054074,15170155,427965,1,'2007-09-14 21:03:11',3310491429,1),(51402995,425054644,15175390,427965,1,'2007-09-14 21:03:11',3310491429,1),(51402997,425054391,15179081,427965,1,'2007-09-14 21:03:11',3310491429,1),(51403000,425054137,15180283,427965,1,'2007-09-14 21:03:11',3310491429,1),(51403223,425054783,15183030,3916355,1,'2010-02-19 17:32:02',3310491429,2),(51403224,425054605,15182206,3916355,1,'2010-02-19 17:32:03',3310491429,2),(51403225,425054014,15181631,3916355,1,'2010-02-19 17:32:03',3310491429,2),(51403226,425053319,15181700,3916355,1,'2010-02-19 17:32:03',3310491429,2),(51403228,425052823,15182315,3916355,1,'2010-02-19 17:32:03',3310491429,2),(51403229,425052737,15183403,3916355,1,'2010-02-19 17:32:04',3310491429,2),(51403231,425053054,15184070,3916355,1,'2010-02-19 17:32:04',3310491429,2),(51403232,425053932,15184392,3916355,1,'2010-02-19 17:32:04',3310491429,2),(51403234,425054653,15183684,3916355,1,'2010-02-19 17:32:04',3310491429,2),(51403654,425051100,15184918,427965,1,'2007-09-14 21:03:30',3310491429,1),(51403656,425048988,15186761,305941,1,'2009-02-09 21:34:26',3310491429,2),(51403657,425046924,15187493,427965,1,'2007-09-14 21:03:30',3310491429,1),(51403659,425043760,15188780,427965,1,'2007-09-14 21:03:30',3310491429,1),(51403661,425040976,15190239,427965,1,'2007-09-14 21:03:30',3310491429,1),(51403663,425037527,15192491,56648,1,'2008-06-05 20:30:42',3310491428,2),(51403665,425036530,15193235,3916355,1,'2010-02-19 17:31:53',3310491428,5),(51403850,425061477,15215130,305941,1,'2009-02-09 21:34:27',3310491429,2),(51403851,425059896,15211783,305941,1,'2009-02-09 21:34:27',3310491429,2),(51403852,425057934,15206375,305941,1,'2009-02-09 21:34:28',3310491429,2),(51403854,425056479,15202255,305941,1,'2009-02-09 21:34:28',3310491429,2),(51403857,425055150,15197277,305941,1,'2009-02-09 21:34:28',3310491429,2),(51403858,425054391,15192900,305941,1,'2009-02-09 21:34:28',3310491429,2),(51403859,425053568,15187664,305941,1,'2009-02-09 21:34:28',3310491429,2),(51403861,425053478,15184371,3916355,1,'2010-02-19 17:32:04',3310491429,3),(51404061,425062983,15216630,3916355,1,'2010-02-19 17:31:58',3310491431,2),(51404062,425063152,15217362,3916355,1,'2010-02-19 17:31:58',3310491431,2),(51404063,425062915,15218273,3916355,1,'2010-02-19 17:32:00',3310491431,2),(51404066,425062114,15218764,3916355,1,'2010-02-19 17:32:00',3310491431,2),(51404067,425061364,15218276,3916355,1,'2010-02-19 17:31:59',3310491431,2),(51404069,425061140,15217155,3916355,1,'2010-02-19 17:31:59',3310491431,2),(51404071,425061306,15216606,3916355,1,'2010-02-19 17:31:59',3310491431,2),(51404073,425061902,15216053,3916355,1,'2010-02-19 17:31:58',3310491429,3),(51404074,425062566,15216143,3916355,1,'2010-02-19 17:31:58',3310491429,2),(51404272,425049139,15220795,427965,1,'2007-09-14 21:04:29',3310491431,1),(51404274,425061173,15217807,3916355,1,'2010-02-19 17:31:59',3310491431,2),(51404282,425045975,15221396,56648,1,'2008-06-05 20:36:40',3310491431,2),(51404481,425070526,15254183,427965,1,'2007-09-14 21:14:20',3310491442,1),(51404482,425069893,15249720,427965,1,'2007-09-14 21:14:20',3310491442,1),(51404483,425068501,15244656,427965,1,'2007-09-14 21:14:20',3310491442,1),(51404484,425066483,15233915,443749,1,'2007-09-16 21:50:02',3310491431,1),(51404486,425062459,15218694,3916355,1,'2010-02-19 17:32:00',3310491431,2),(51404632,425072361,15273409,427965,1,'2007-09-14 21:14:20',3310491448,1),(51404633,425071475,15263539,427965,1,'2007-09-14 21:14:20',3310491442,1),(51404642,425072867,15280190,427965,1,'2007-09-14 21:06:19',3310491448,1),(51404720,425088873,15290461,820251,1,'2009-03-16 23:53:41',3310491448,3),(51404721,425086534,15287228,427965,1,'2007-09-14 21:05:05',3310491448,1),(51404723,425083244,15283108,427965,1,'2007-09-14 21:14:20',3310491448,1),(51404725,425079637,15279761,427965,1,'2007-09-14 21:14:20',3310491448,1),(51404726,425076663,15277271,427965,1,'2007-09-14 21:14:20',3310491448,1),(51404727,425073310,15275040,427965,1,'2007-09-14 21:14:20',3310491448,1),(51404882,425098102,15335079,188228,1,'2008-06-16 18:36:35',3310491451,5),(51404883,425096972,15330973,437032,1,'2008-05-13 21:27:14',3310491451,3),(51404884,425096529,15326510,437032,1,'2008-05-13 21:13:38',3310491451,3),(51404886,425094125,15317069,437032,1,'2008-05-13 21:13:33',3310491448,2),(51404887,425089063,15304366,437032,1,'2008-05-13 21:20:03',3310491448,2),(51404888,425085648,15297184,427965,1,'2007-09-14 21:14:43',3310491448,1),(51404889,425082484,15291519,427965,1,'2007-09-14 21:06:19',3310491448,1),(51404891,425078308,15286455,427965,1,'2007-09-14 21:06:19',3310491448,1),(51404893,425073816,15282250,427965,1,'2007-09-14 21:06:19',3310491448,1),(51404947,425087609,15308171,427965,1,'2007-09-14 21:05:39',3310491448,1),(51404949,425089887,15306454,427965,1,'2007-09-14 21:06:19',3310491448,1),(51405087,425082231,15318299,820251,1,'2009-03-16 23:48:44',3310491448,7),(51405091,425093809,15316210,820251,1,'2009-03-16 23:48:45',3310491448,4),(51405261,425098029,15337080,3916355,1,'2010-02-19 17:33:03',3310491451,8),(51405263,425098115,15338284,3916355,1,'2010-02-19 17:33:03',3310491451,7),(51405265,425098719,15339308,3916355,1,'2010-02-19 17:33:03',3310491451,4),(51405266,425099137,15339584,3916355,1,'2010-02-19 17:33:03',3310491451,5),(51405268,425100920,15338838,3916355,1,'2010-02-19 17:33:04',3310491451,4),(51405269,425101263,15337344,3916355,1,'2010-02-19 17:33:04',3310491451,4),(51405270,425101213,15336918,3916355,1,'2010-02-19 17:33:04',3310491451,5),(51405271,425100195,15335397,3916355,1,'2010-02-19 17:33:05',3310491451,4),(51405273,425099068,15335400,3916355,1,'2010-02-19 17:33:05',3310491451,4),(51405344,425098322,15336159,3916355,1,'2010-02-19 17:33:03',3310491451,6),(51405527,425122535,15354433,427965,1,'2007-09-14 21:14:20',3310491454,1),(51405528,425120573,15352717,427965,1,'2007-09-14 21:14:20',3310491451,1),(51405530,425117789,15348940,427965,1,'2007-09-14 21:14:20',3310491451,1),(51405533,425113993,15343275,427965,1,'2007-09-14 21:14:20',3310491451,1),(51405534,425111716,15339928,427965,1,'2007-09-14 21:14:20',3310491451,1),(51405536,425108615,15337353,427965,1,'2007-09-14 21:14:20',3310491451,1),(51405537,425105072,15333147,427965,1,'2007-09-14 21:14:20',3310491451,1),(51405539,425102984,15329113,820251,1,'2009-03-16 23:53:39',3310491451,2),(51405540,425098808,15315724,820251,1,'2009-03-16 23:53:39',3310491449,2),(51405542,425096467,15309973,820251,1,'2009-03-16 23:53:39',3310491449,2),(51405543,425094379,15306797,820251,1,'2009-03-16 23:53:39',3310491448,2),(51405544,425092861,15303707,820251,1,'2009-03-16 23:53:40',3310491448,2),(51405547,425091721,15298701,820251,1,'2009-03-16 23:53:40',3310491448,3),(51405548,425090582,15293980,820251,1,'2009-03-16 23:53:41',3310491448,3),(51405550,425089949,15291663,820251,1,'2009-03-16 23:53:41',3310491448,3),(51405712,425127534,15356133,462438,1,'2008-07-11 13:01:05',3310491454,2),(51405715,425126521,15360854,462438,1,'2008-07-11 13:01:05',3310491454,2),(51405716,425124876,15364459,462438,1,'2008-07-11 13:01:05',3310491454,2),(51405720,425119624,15371170,427965,1,'2007-09-14 21:08:08',3310491451,1),(51405722,425115575,15380612,427965,1,'2007-09-14 21:06:57',3310491451,1),(51405723,425113740,15385676,427965,1,'2007-09-14 21:08:08',3310491537,1),(51405725,425112095,15394001,427965,1,'2007-09-14 21:08:08',3310491537,1),(51405727,425110703,15399151,427965,1,'2007-09-14 21:08:08',3310491537,1),(51405728,425107603,15407219,427965,1,'2007-09-14 21:08:08',3310491537,1),(51405729,425106021,15412283,427965,1,'2007-09-14 21:08:08',3310491537,1),(51406111,425127908,15353934,3916355,1,'2010-02-19 17:33:23',3310491454,2),(51406112,425127611,15352872,3916355,1,'2010-02-19 17:33:23',3310491454,2),(51406113,425126716,15352574,3916355,1,'2010-02-19 17:33:23',3310491454,2),(51406114,425126071,15353400,3916355,1,'2010-02-19 17:33:23',3310491454,2),(51406115,425126374,15354811,3916355,1,'2010-02-19 17:33:24',3310491454,2),(51406116,425127246,15355036,3916355,1,'2010-02-19 17:33:24',3310491454,3),(51406117,425127563,15354807,3916355,1,'2010-02-19 17:33:24',3310491454,2),(51406244,425126062,15354183,3916355,1,'2010-02-19 17:33:23',3310491454,2),(51406783,425166695,15287855,432736,1,'2007-09-15 01:38:56',3310491453,1),(51406784,425165619,15291004,427965,1,'2007-09-14 21:36:14',3310491453,1),(51406785,425163342,15294609,427965,1,'2007-09-14 21:36:14',3310491453,1),(51406787,425161127,15298300,427965,1,'2007-09-14 21:36:14',3310491453,1),(51406789,425158723,15303536,427965,1,'2007-09-14 21:36:14',3310491453,1),(51406790,425156509,15307141,427965,1,'2007-09-14 21:36:14',3310491453,1),(51406791,425151321,15313749,427965,1,'2007-09-14 21:36:14',3310491453,1),(51406792,425146703,15318899,427965,1,'2007-09-14 21:36:14',3310491452,1),(51406793,425143793,15321560,427965,1,'2007-09-14 21:36:14',3310491452,1),(51406795,425141452,15323706,427965,1,'2007-09-14 21:36:14',3310491452,1),(51406797,425139427,15326967,427965,1,'2007-09-14 21:36:14',3310491454,1),(51406798,425138099,15330229,427965,1,'2007-09-14 21:36:14',3310491454,1),(51406800,425137213,15334177,427965,1,'2007-09-14 21:36:14',3310491454,1),(51406803,425136137,15338640,427965,1,'2007-09-14 21:36:14',3310491454,1),(51406805,425134682,15340100,427965,1,'2007-09-14 21:36:14',3310491454,1),(51406807,425132088,15342159,427965,1,'2007-09-14 21:08:51',3310491454,1),(51406808,425130253,15345249,427965,1,'2007-09-14 21:36:14',3310491454,1),(51406810,425127878,15350618,427965,1,'2007-09-14 22:12:31',3310491454,1),(51406811,425127268,15352595,3916355,1,'2010-02-19 17:33:23',3310491454,2),(51407218,425177702,15375290,427965,1,'2007-09-14 21:12:21',3310491498,1),(51407219,425174476,15382500,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407220,425172199,15388937,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407222,425169668,15393915,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407223,425168656,15398293,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407226,425167960,15400524,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407227,425167011,15402584,427965,1,'2007-09-14 21:09:37',3310491541,1),(51407228,425166062,15404215,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407231,425163974,15407047,427965,1,'2007-09-14 21:13:38',3310491541,1),(51407232,425161254,15410309,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407234,425159672,15413141,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407235,425158786,15414515,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407236,425158154,15414601,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407238,425157395,15413914,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407240,425157142,15412712,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407243,425157268,15411940,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407245,425158280,15410223,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407247,425159925,15407477,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407708,425161317,15404988,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407709,425161823,15401468,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407712,425162203,15396319,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407714,425162140,15392885,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407715,425162329,15388766,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407716,425162835,15385332,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407718,425164037,15380011,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407719,425165493,15374088,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407720,425166758,15370226,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407723,425167137,15369024,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407725,425166884,15367737,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407726,425166252,15367308,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407728,425165682,15367308,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407729,425164986,15367737,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407731,425163468,15371428,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407733,425161191,15377608,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407736,425159166,15381985,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407738,425157648,15384131,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407739,425156635,15384474,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407740,425155750,15384216,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407742,425155307,15383358,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407743,425155370,15381985,427965,1,'2007-09-14 21:12:21',3310491541,1),(51407744,425156382,15379753,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407746,425159103,15373230,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407747,425161697,15365591,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407749,425162582,15362330,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407751,425163342,15359669,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407753,425164227,15353232,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407754,425164227,15350485,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407756,425165366,15346794,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407759,425167201,15342503,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407760,425168150,15339241,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407764,425168592,15336495,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407765,425169415,15332804,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407766,425170743,15328770,427965,1,'2007-09-14 21:12:21',3310491455,1),(51407767,425172578,15324135,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407769,425173970,15320788,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407773,425174349,15318985,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407774,425174349,15316668,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407775,425174856,15312119,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407778,425174919,15310059,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407779,425174729,15309115,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407781,425173654,15309115,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407782,425173084,15309801,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407784,425172578,15311518,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407785,425171566,15318556,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407786,425170743,15319328,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407787,425169794,15319500,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407789,425168909,15318728,427965,1,'2007-09-14 21:10:27',3310491453,1),(51407790,425168592,15317269,427965,1,'2007-09-14 21:12:21',3310491453,1),(51407791,425169225,15315037,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408269,425170427,15311604,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408270,425171566,15307827,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408271,425172768,15303364,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408274,425173780,15299931,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408275,425174729,15293579,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408278,425174919,15289116,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408279,425174856,15286026,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408280,425174666,15284825,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408281,425173780,15284825,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408282,425172831,15285855,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408283,425172515,15288687,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408284,425172325,15292721,427965,1,'2007-09-14 21:11:10',3310491453,1),(51408285,425169035,15300274,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408286,425165872,15304394,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408287,425164227,15308943,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408288,425162709,15311089,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408289,425160558,15313063,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408290,425150562,15326452,427965,1,'2007-09-14 21:12:21',3310491455,1),(51408292,425147652,15331001,427965,1,'2007-09-14 21:12:21',3310491454,1),(51408294,425146956,15333834,427965,1,'2007-09-14 21:12:21',3310491454,1),(51408296,425145880,15334263,427965,1,'2007-09-14 21:12:21',3310491454,1),(51408299,425145121,15333319,427965,1,'2007-09-14 21:12:21',3310491454,1),(51408300,425145121,15332203,427965,1,'2007-09-14 21:12:21',3310491454,1),(51408302,425145627,15329371,427965,1,'2007-09-14 21:12:21',3310491454,1),(51408305,425146766,15325165,427965,1,'2007-09-14 21:12:21',3310491452,1),(51408306,425149676,15320873,427965,1,'2007-09-14 21:12:21',3310491452,1),(51408307,425152460,15316410,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408310,425152776,15315294,427965,1,'2007-09-14 21:12:21',3310491453,1),(51408311,425151701,15313063,427965,1,'2007-09-14 21:36:14',3310491453,1),(51408485,425177702,15351086,427965,1,'2007-09-14 21:13:38',3310491498,1),(51408486,425176690,15357866,427965,1,'2007-09-14 21:13:38',3310491455,1),(51408490,425175362,15363531,427965,1,'2007-09-14 21:13:38',3310491455,1),(51408491,425173211,15370140,427965,1,'2007-09-14 21:13:38',3310491455,1),(51408492,425170237,15377865,427965,1,'2007-09-14 21:13:38',3310491455,1),(51408495,425168972,15382672,427965,1,'2007-09-14 21:13:38',3310491541,1),(51408496,425167454,15388165,427965,1,'2007-09-14 21:13:38',3310491541,1),(51408497,425166062,15392542,427965,1,'2007-09-14 21:13:38',3310491541,1),(51408498,425165809,15399494,427965,1,'2007-09-14 21:13:38',3310491541,1),(51408499,425164797,15404558,427965,1,'2007-09-14 21:13:38',3310491541,1),(51408872,425143729,15488415,427965,1,'2007-09-14 21:12:15',3310491542,1),(51408873,425145627,15486613,427965,1,'2007-09-14 21:12:15',3310491542,1),(51408874,425148348,15485153,427965,1,'2007-09-14 21:12:15',3310491542,1),(51408875,425149993,15484381,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408876,425151321,15481634,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408879,425152586,15477171,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408880,425153789,15473051,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408883,425154105,15470305,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408884,425153725,15468245,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408885,425154801,15464297,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408887,425155686,15459490,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408889,425156193,15454512,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408891,425155497,15447216,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408892,425154105,15443869,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408893,425153472,15441637,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408896,425153472,15439062,427965,1,'2007-09-14 21:12:15',3310491543,1),(51408897,425152840,15435114,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408898,425152713,15431853,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408900,425153346,15427904,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408902,425153852,15422583,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408904,425153725,15420008,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408905,425153725,15417519,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408906,425154548,15413141,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408909,425154738,15409279,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408910,425155370,15403614,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408911,425156446,15400782,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408912,425158027,15398121,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408913,425158976,15395546,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408914,425159672,15391340,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408915,425160621,15387993,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408916,425162076,15385161,427965,1,'2007-09-14 21:12:15',3310491541,1),(51408917,425163405,15383444,427965,1,'2007-09-14 21:12:15',3310491541,1),(51409632,425144805,15428076,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409633,425144425,15440779,427965,1,'2007-09-14 21:13:34',3310491542,1),(51409634,425144172,15443096,427965,1,'2007-09-14 21:13:34',3310491542,1),(51409635,425143729,15444212,427965,1,'2007-09-14 21:13:34',3310491542,1),(51409636,425142970,15444384,427965,1,'2007-09-14 21:13:34',3310491542,1),(51409638,425142148,15443354,427965,1,'2007-09-14 21:13:34',3310491542,1),(51409639,425141515,15440521,427965,1,'2007-09-14 21:13:34',3310491542,1),(51409640,425140946,15436487,427965,1,'2007-09-14 21:13:34',3310491542,1),(51409641,425141452,15415888,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409642,425141515,15407562,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409644,425141641,15404988,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409645,425141009,15403614,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409646,425140313,15403357,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409647,425139427,15404473,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409648,425138288,15408163,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409649,425136770,15414000,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409651,425135884,15417004,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409652,425134935,15419579,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409653,425133986,15420523,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409655,425132721,15420952,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409656,425132025,15421982,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409657,425132088,15424729,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409658,425132341,15430737,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409659,425132215,15432453,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409660,425131076,15434342,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409662,425130000,15434857,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409663,425128419,15434170,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409664,425124116,15433054,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409665,425123167,15431938,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409666,425122788,15429793,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409667,425123041,15425844,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409668,425123673,15420351,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409669,425123800,15417175,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409670,425123484,15415030,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409671,425123357,15412455,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409672,425123927,15400181,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409673,425124749,15398636,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409674,425125192,15396834,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409675,425125382,15394259,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409676,425125318,15392199,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409677,425124433,15391426,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409678,425123484,15391770,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409679,425122471,15394345,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409680,425122471,15394688,427965,1,'2007-09-14 21:13:34',3310491540,1),(51409972,425100136,15339582,3916355,1,'2010-02-19 17:33:04',3310491451,5),(51409974,425101401,15341187,437032,1,'2008-05-13 21:26:45',3310491451,2),(51409975,425107034,15348666,462438,1,'2008-07-11 13:00:24',3310491451,2),(51409976,425109882,15352614,462438,1,'2008-07-11 13:00:24',3310491451,2),(51409978,425111969,15355635,427965,1,'2007-09-14 21:14:09',3310491451,1),(51409979,425113550,15358982,427965,1,'2007-09-14 21:14:09',3310491451,1),(51409981,425118043,15362742,462438,1,'2008-07-11 13:01:48',3310491451,2),(51409983,425120321,15364716,462438,1,'2008-07-11 13:09:45',3310491451,3),(51410094,425104503,15332117,820251,1,'2009-03-16 23:53:39',3310491451,2),(51410095,425103807,15332890,427965,1,'2007-09-14 21:14:24',3310491451,1),(51410232,425076537,15355635,305941,1,'2009-02-09 21:22:14',3310491450,2),(51410233,425085268,15354605,305941,1,'2009-02-09 21:19:42',3310491450,5),(51410282,425077043,15364733,305941,1,'2009-02-09 21:22:14',3310491450,2),(51410286,425086028,15363703,305941,1,'2009-02-09 21:19:42',3310491450,5),(51410490,425075208,15308600,305941,1,'2009-02-09 21:27:05',3310491448,2),(51410491,425070462,15311003,305941,1,'2009-02-09 21:27:05',3310491448,3),(51410493,425064553,15314436,305941,1,'2009-02-09 21:27:05',3310491437,2),(51410494,425063439,15315209,305941,1,'2009-02-09 21:27:05',3310491437,2),(51410495,425060838,15317037,3916355,1,'2010-02-19 17:34:20',3310491437,4),(51410786,425057428,15279363,443749,1,'2007-09-16 21:49:53',3310491437,1),(51410787,425059073,15285340,427965,1,'2007-09-14 21:15:39',3310491437,1),(51410788,425061414,15289202,427965,1,'2007-09-14 21:15:39',3310491437,1),(51410790,425064515,15293579,427965,1,'2007-09-14 21:15:39',3310491437,1),(51410791,425067488,15298128,427965,1,'2007-09-14 21:15:39',3310491437,1),(51410792,425071158,15303192,427965,1,'2007-09-14 21:15:39',3310491448,1),(51411056,425069513,15329113,427965,1,'2007-09-14 21:16:04',3310491450,1),(51411057,425066729,15329971,427965,1,'2007-09-14 21:16:04',3310491439,1),(51411059,425069513,15340529,427965,1,'2007-09-14 21:16:04',3310491450,1),(51411060,425070399,15341473,427965,1,'2007-09-14 21:16:04',3310491450,1),(51411061,425075081,15341215,427965,1,'2007-09-14 21:16:04',3310491450,1),(51411062,425076600,15339670,427965,1,'2007-09-14 21:16:04',3310491450,1),(51412082,424997756,15233755,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412083,424995858,15232554,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412086,424994466,15232554,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412087,424993580,15233498,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412090,424993390,15235386,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412091,424993390,15237360,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412092,424993010,15239334,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412093,424992378,15240364,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412094,424991365,15240708,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412095,424990479,15240021,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412096,424988517,15238304,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412099,424985670,15235214,427965,1,'2007-09-14 21:22:31',3310491427,1),(51412100,424981999,15230923,427965,1,'2007-09-14 21:22:31',3310491426,1),(51412102,424980101,15227404,427965,1,'2007-09-14 21:22:31',3310491426,1),(51412103,424979278,15223198,427965,1,'2007-09-14 21:22:31',3310491426,1),(51412105,424979088,15218735,427965,1,'2007-09-14 21:22:31',3310491426,1),(51412106,424979848,15215903,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412107,424979784,15214100,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412109,424978582,15213928,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412110,424975987,15214529,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412112,424973836,15214529,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412115,424967760,15214443,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412116,424967001,15213156,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412117,424967001,15211697,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412119,424967887,15210238,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412121,424969343,15208950,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412122,424971494,15206461,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412123,424972886,15203886,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412125,424973709,15202170,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412126,424974785,15199080,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412128,424975291,15197020,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412131,424977253,15192471,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412132,424979278,15187664,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412134,424979721,15183973,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412136,424979088,15176335,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412137,424978329,15170670,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412138,424977949,15165520,427965,1,'2007-09-14 21:22:31',3310491424,1),(51412141,424978012,15160027,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412142,424978392,15154791,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412143,424978202,15151615,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412144,424976683,15146980,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412147,424974152,15139857,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412148,424972254,15135822,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412150,424970355,15133076,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412152,424969975,15132046,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412154,424970482,15131188,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412157,424971811,15131617,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412158,424979848,15143032,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412159,424981113,15145436,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412161,424982379,15148783,427965,1,'2007-09-14 21:22:31',3310491402,1),(51412163,424985227,15163374,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412164,424987631,15168181,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412167,424991112,15171871,427965,1,'2007-09-14 21:17:45',3310491425,1),(51412168,424996807,15174618,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412169,425001110,15176249,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412170,425007185,15177708,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412171,425008894,15178395,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412173,425009716,15179253,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412175,425009590,15181141,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412176,425009084,15186892,427965,1,'2007-09-14 21:17:45',3310491425,1),(51412179,425009147,15189552,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412180,425009590,15190926,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412181,425010539,15192986,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412183,425011678,15195475,427965,1,'2007-09-14 21:22:31',3310491425,1),(51412185,425012691,15197191,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412187,425014020,15198050,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412189,425014969,15198822,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412192,425019651,15198994,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412195,425022499,15199509,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412196,425024397,15200796,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412197,425026043,15202255,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412198,425027498,15202255,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412199,425028827,15201140,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412200,425031105,15197792,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412201,425032370,15195990,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412202,425033952,15194874,427965,1,'2007-09-14 21:22:31',3310491428,1),(51412994,424991492,15306368,427965,1,'2007-09-14 21:22:31',3310491433,1),(51412995,424991871,15305596,427965,1,'2007-09-14 21:22:31',3310491433,1),(51412998,424993200,15305252,427965,1,'2007-09-14 21:22:31',3310491433,1),(51412999,424995478,15305338,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413000,424998706,15306454,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413001,425001553,15307055,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413004,425004528,15306454,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413005,425008388,15303364,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413006,425008767,15301991,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413007,425008767,15301476,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413008,425007881,15300875,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413009,425005540,15300102,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413011,425003768,15298472,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413013,425002123,15294953,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413014,425000794,15292893,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413017,424998073,15290833,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413018,424997440,15290489,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413020,424997313,15289459,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413021,424997313,15288601,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413023,424998010,15288000,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413024,424999465,15287914,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413026,425001806,15288344,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413027,425004654,15289202,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413028,425005287,15289116,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413029,425005856,15288344,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413031,425006173,15287228,427965,1,'2007-09-14 21:20:09',3310491433,1),(51413033,425006932,15284052,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413034,425007312,15281735,427965,1,'2007-09-14 21:20:09',3310491433,1),(51413035,425007818,15280190,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413037,425008451,15279246,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413038,425009337,15279246,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413039,425010286,15279846,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413041,425010856,15280619,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413042,425011678,15281134,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413043,425012754,15281048,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413044,425014273,15280361,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413047,425015791,15279761,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413048,425016930,15279761,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413050,425018512,15281820,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413052,425019398,15282936,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413053,425019968,15283623,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413054,425021233,15283537,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413055,425021676,15282679,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413057,425021486,15280962,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413058,425019272,15278816,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413060,425017500,15277529,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413061,425015348,15276413,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413063,425013703,15275469,427965,1,'2007-09-14 21:22:31',3310491436,1),(51413065,425012374,15273409,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413066,425010856,15270062,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413067,425008324,15264311,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413068,425007059,15260964,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413071,425004085,15258389,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413072,425003135,15256157,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413073,425003072,15254784,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413074,425003705,15253926,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413075,425004464,15253582,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413078,425005224,15254269,427965,1,'2007-09-14 21:20:09',3310491427,1),(51413079,425007692,15257187,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413082,425011045,15260964,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413083,425012817,15262852,427965,1,'2007-09-14 21:22:31',3310491430,1),(51413084,425014716,15263195,427965,1,'2007-09-14 21:22:31',3310491430,1),(51413085,425016614,15263539,427965,1,'2007-09-14 21:22:31',3310491430,1),(51413086,425017753,15264826,427965,1,'2007-09-14 21:22:31',3310491430,1),(51413087,425019019,15266628,427965,1,'2007-09-14 21:22:31',3310491430,1),(51413090,425019715,15267401,427965,1,'2007-09-14 21:22:31',3310491430,1),(51413091,425020347,15267229,427965,1,'2007-09-14 21:22:31',3310491430,1),(51413093,425020664,15266113,427965,1,'2007-09-14 21:22:31',3310491430,1),(51413094,425020664,15265598,427965,1,'2007-09-14 21:22:31',3310491430,1),(51413096,425018512,15262938,427965,1,'2007-09-14 21:22:31',3310491430,1),(51413097,425015095,15258732,427965,1,'2007-09-14 21:22:31',3310491430,1),(51413099,425012374,15254526,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413100,425008198,15246802,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413103,425005160,15241223,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413104,425001617,15237704,427965,1,'2007-09-14 21:22:31',3310491427,1),(51413411,424996048,15311003,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413412,424991935,15307827,427965,1,'2007-09-14 21:22:31',3310491433,1),(51413826,424977443,15275212,427965,1,'2007-09-14 21:22:30',3310491432,1),(51413827,424981683,15280018,427965,1,'2007-09-14 21:22:30',3310491432,1),(51413832,424984594,15283451,427965,1,'2007-09-14 21:22:30',3310491432,1),(51413833,424985859,15286884,427965,1,'2007-09-14 21:22:30',3310491433,1),(51413835,424986492,15288859,427965,1,'2007-09-14 21:22:30',3310491433,1),(51413854,424991618,15306883,427965,1,'2007-09-14 21:22:31',3310491433,1),(51414015,425027498,15348425,258874,1,'2008-10-11 17:23:03',3310491438,2),(51414017,425026802,15345593,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414018,425026992,15342846,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414019,425026928,15340786,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414020,425025536,15339413,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414021,425023511,15338211,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414022,425019651,15334177,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414023,425018765,15332546,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414024,425018006,15331259,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414025,425017120,15331173,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414027,425016614,15331946,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414028,425016741,15333061,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414030,425017880,15335550,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414031,425019651,15338383,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414032,425021044,15340271,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414033,425021486,15341387,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414034,425021613,15342760,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414036,425021297,15343275,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414040,425020158,15343275,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414041,425018133,15340958,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414044,425014652,15338555,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414045,425011995,15336151,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414046,425011172,15334263,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414049,425011045,15332375,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414050,425010919,15331001,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414051,425010539,15330143,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414052,425009590,15329971,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414053,425008894,15330486,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414054,425008831,15331946,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414055,425009527,15335293,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414056,425010286,15339241,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414057,425010919,15340615,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414060,425012627,15342674,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414061,425015791,15345679,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414062,425016994,15346623,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414063,425017437,15347481,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414064,425017437,15348253,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414065,425017120,15349026,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414067,425016361,15349026,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414069,425014969,15348168,427965,1,'2007-09-14 21:22:31',3310491438,1),(51414070,425012184,15345335,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414072,425009463,15343018,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414074,425004717,15337868,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414076,425003009,15333319,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414077,425002376,15330830,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414078,425001996,15328427,427965,1,'2007-09-14 21:22:31',3310491435,1),(51414079,425003135,15324307,427965,1,'2007-09-14 21:22:31',3310491433,1),(51414082,425004401,15319758,427965,1,'2007-09-14 21:22:31',3310491433,1),(51414083,425005477,15317784,427965,1,'2007-09-14 21:22:31',3310491433,1),(51414084,425006995,15316668,427965,1,'2007-09-14 21:22:31',3310491433,1),(51414085,425007059,15315809,427965,1,'2007-09-14 21:22:31',3310491433,1),(51414087,425006995,15314865,427965,1,'2007-09-14 21:22:31',3310491433,1),(51414089,425006173,15314350,427965,1,'2007-09-14 21:22:31',3310491433,1),(51414090,425003642,15314608,427965,1,'2007-09-14 21:22:31',3310491433,1),(51414091,425000984,15314436,427965,1,'2007-09-14 21:22:31',3310491433,1),(51414092,424998769,15313149,427965,1,'2007-09-14 21:22:31',3310491433,1),(51414167,425030725,15363617,258874,1,'2008-10-11 17:23:03',3310491438,2),(51414169,425029966,15358124,258874,1,'2008-10-11 17:23:03',3310491438,2),(51414257,425051670,15487213,258874,1,'2008-10-11 17:23:02',3310491527,2),(51414258,425052492,15482407,258874,1,'2008-10-11 17:23:02',3310491527,2),(51414259,425054960,15475283,258874,1,'2008-10-11 17:23:02',3310491527,2),(51414262,425060465,15462408,258874,1,'2008-10-11 17:23:02',3310491527,2),(51414263,425061098,15458546,258874,1,'2008-10-11 17:23:02',3310491527,2),(51414264,425061920,15449190,258874,1,'2008-10-11 17:23:02',3310491527,2),(51414266,425061477,15441895,258874,1,'2008-10-11 17:23:02',3310491527,2),(51414267,425060655,15437174,258874,1,'2008-10-11 17:23:02',3310491527,2),(51414269,425058567,15431252,258874,1,'2008-10-11 17:23:02',3310491525,2),(51414270,425056922,15426359,258874,1,'2008-10-11 17:23:02',3310491525,2),(51414271,425055783,15419407,258874,1,'2008-10-11 17:23:02',3310491525,2),(51414273,425054897,15410824,258874,1,'2008-10-11 17:23:02',3310491525,2),(51414274,425053758,15406447,258874,1,'2008-10-11 17:23:03',3310491525,2),(51414276,425050341,15402842,258874,1,'2008-10-11 17:23:03',3310491525,2),(51414277,425043697,15397606,258874,1,'2008-10-11 17:23:03',3310491525,2),(51414278,425040976,15395975,258874,1,'2008-10-11 17:23:03',3310491525,2),(51414279,425040280,15394430,258874,1,'2008-10-11 17:23:03',3310491525,2),(51414280,425039331,15391598,258874,1,'2008-10-11 17:23:03',3310491524,2),(51414283,425038192,15389624,258874,1,'2008-10-11 17:23:03',3310491524,2),(51414284,425035091,15387049,258874,1,'2008-10-11 17:23:03',3310491524,2),(51414285,425034016,15385161,258874,1,'2008-10-11 17:23:03',3310491524,2),(51414286,425033509,15382500,258874,1,'2008-10-11 17:23:03',3310491524,2),(51414288,425033509,15379152,258874,1,'2008-10-11 17:23:03',3310491438,2),(51414289,425033826,15377093,258874,1,'2008-10-11 17:23:03',3310491438,2),(51414290,425032687,15372458,258874,1,'2008-10-11 17:23:03',3310491438,2),(51414414,425048190,15385761,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414415,425051353,15388851,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414416,425052872,15391770,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414417,425054011,15394259,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414418,425054264,15396061,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414419,425054137,15397005,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414420,425053505,15397005,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414421,425052176,15396233,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414422,425051227,15394001,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414423,425050594,15392714,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414424,425050088,15391684,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414425,425049265,15391598,427965,1,'2007-09-14 21:23:23',3310491525,1),(51414426,425048822,15392971,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414428,425049518,15396748,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414429,425050784,15399494,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414430,425053631,15401640,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414431,425054960,15402928,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414432,425054580,15404644,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414433,425053441,15404644,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414434,425052366,15403700,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414436,425048949,15400696,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414437,425048443,15399323,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414438,425047810,15397778,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414439,425046987,15397949,427965,1,'2007-09-14 21:23:36',3310491525,1),(51414440,425046291,15399494,258874,1,'2008-10-11 17:23:03',3310491525,2),(51415013,425099898,15480136,2895121,1,'2009-10-19 19:18:49',3310491539,4),(51415016,425099062,15482922,258874,1,'2008-10-11 17:21:48',3310491539,2),(51415017,425097859,15483866,258874,1,'2008-10-11 17:21:48',3310491539,2),(51415018,425095645,15484467,258874,1,'2008-10-11 17:21:48',3310491539,2),(51415019,425092734,15484724,258874,1,'2008-10-11 17:21:48',3310491538,2),(51415021,425089191,15484638,258874,1,'2008-10-11 17:21:48',3310491538,2),(51415023,425085774,15483952,258874,1,'2008-10-11 17:21:48',3310491538,2),(51415024,425081978,15483952,258874,1,'2008-10-11 17:21:48',3310491538,2),(51415026,425077865,15484982,258874,1,'2008-10-11 17:21:48',3310491538,2),(51415027,425072550,15488587,258874,1,'2008-10-11 17:21:48',3310491538,2),(51415028,425065907,15492191,258874,1,'2008-10-11 17:21:48',3310491533,2),(51415030,425065021,15493393,258874,1,'2008-10-11 17:21:48',3310491533,2),(51415032,425064894,15494251,258874,1,'2008-10-11 17:21:48',3310491533,2),(51415033,425066033,15495196,258874,1,'2008-10-11 17:21:49',3310491533,2),(51415034,425067172,15495281,258874,1,'2008-10-11 17:21:49',3310491533,2),(51415035,425077043,15493050,258874,1,'2008-10-11 17:21:49',3310491544,2),(51415036,425078561,15492706,258874,1,'2008-10-11 17:21:49',3310491544,2),(51415039,425078941,15493565,258874,1,'2008-10-11 17:21:49',3310491544,2),(51415041,425078878,15494681,258874,1,'2008-10-11 17:21:49',3310491544,2),(51415042,425077486,15496054,258874,1,'2008-10-11 17:21:49',3310491544,2),(51415045,425074449,15498028,258874,1,'2008-10-11 17:21:49',3310491544,2),(51415046,425068627,15501461,258874,1,'2008-10-11 17:21:49',3310491544,2),(51415047,425060022,15507298,258874,1,'2008-10-11 17:21:49',3310491533,2),(51415048,425055276,15509615,258874,1,'2008-10-11 17:21:49',3310491533,2),(51415049,425050594,15511418,258874,1,'2008-10-11 17:21:49',3310491533,2),(51415050,425049518,15512791,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415051,425047683,15515366,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415052,425046418,15518112,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415053,425044583,15520172,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415055,425040849,15522747,258874,1,'2008-10-11 17:23:02',3310491533,3),(51415057,425040407,15521717,258874,1,'2008-10-11 17:23:02',3310491533,2),(51415059,425039964,15518885,258874,1,'2008-10-11 17:23:02',3310491532,2),(51415060,425040596,15515623,258874,1,'2008-10-11 17:23:02',3310491533,2),(51415061,425041735,15511332,258874,1,'2008-10-11 17:23:02',3310491533,2),(51415062,425043254,15507040,258874,1,'2008-10-11 17:23:02',3310491533,2),(51415066,425045532,15501290,258874,1,'2008-10-11 17:23:02',3310491533,2),(51415068,425048190,15495968,258874,1,'2008-10-11 17:23:02',3310491533,2),(51415069,425050341,15490647,258874,1,'2008-10-11 17:23:02',3310491527,2),(51415249,425040027,15523863,258874,1,'2008-10-11 17:21:50',3310491532,2),(51415251,425040090,15525065,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415253,425040660,15525837,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415255,425041419,15526009,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415257,425043254,15525580,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415258,425047810,15522490,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415781,425049708,15521889,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415783,425051860,15520773,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415785,425054770,15520516,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415788,425057428,15520001,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415790,425060402,15519571,258874,1,'2008-10-11 17:21:50',3310491533,2),(51415795,425068311,15517855,258874,1,'2008-10-11 17:21:50',3310491544,2),(51415796,425075018,15517082,258874,1,'2008-10-11 17:21:50',3310491544,2),(51415798,425082358,15518112,258874,1,'2008-10-11 17:21:50',3310491544,2),(51416264,425064072,15504465,258874,1,'2008-10-11 17:21:49',3310491533,2),(51416291,425085711,15499573,427965,1,'2007-09-14 21:27:14',3310491544,1),(51416292,425086217,15500088,427965,1,'2007-09-14 21:27:14',3310491544,1),(51416294,425087673,15501290,427965,1,'2007-09-14 21:27:14',3310491544,1),(51416297,425088685,15503092,427965,1,'2007-09-14 21:27:14',3310491544,1),(51416298,425091595,15506268,427965,1,'2007-09-14 21:27:14',3310491544,1),(51416299,425090330,15507555,427965,1,'2007-09-14 21:27:14',3310491544,1),(51416340,425084193,15519142,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416343,425085521,15521631,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416345,425087293,15524635,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416349,425089001,15526180,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416351,425092798,15528155,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416352,425094316,15528841,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416353,425095392,15528841,427965,1,'2007-09-14 21:27:15',3310491545,1),(51416354,425095961,15527897,427965,1,'2007-09-14 21:27:15',3310491545,1),(51416356,425095012,15526438,427965,1,'2007-09-14 21:27:15',3310491545,1),(51416357,425092228,15524292,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416359,425090520,15522404,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416361,425089444,15519486,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416364,425088622,15517082,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416365,425087989,15515537,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416366,425086660,15514336,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416367,425082294,15512448,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416370,425078941,15511418,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416371,425076916,15511332,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416372,425076347,15510731,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416375,425076284,15510130,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416376,425076537,15509358,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416379,425077802,15509186,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416380,425080143,15509100,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416381,425084762,15509358,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416382,425088558,15510388,427965,1,'2007-09-14 21:27:15',3310491544,1),(51416727,425083244,15519314,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416729,425083560,15521717,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416731,425084193,15523777,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416732,425085711,15526524,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416733,425088432,15530472,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416734,425091279,15533390,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416735,425093051,15534592,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416736,425093747,15535879,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416737,425093367,15537853,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416739,425092734,15538712,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416740,425091406,15538540,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416741,425089887,15537167,258874,1,'2008-10-11 17:21:51',3310491544,2),(51416743,425088305,15536137,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416744,425087040,15534764,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416746,425084636,15532789,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416747,425082927,15530644,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416748,425081725,15528240,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416749,425080143,15527382,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416750,425079194,15528069,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416753,425078941,15529099,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416754,425079131,15530129,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416755,425081788,15534077,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416756,425085332,15539913,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416757,425086977,15543947,258874,1,'2008-10-11 17:21:52',3310491544,2),(51416758,425087609,15546951,258874,1,'2008-10-11 17:21:52',3310491546,2),(51416760,425087040,15551071,258874,1,'2008-10-11 17:21:52',3310491546,2),(51416761,425087483,15555706,258874,1,'2008-10-11 17:21:52',3310491546,2),(51416762,425088622,15558968,258874,1,'2008-10-11 17:21:52',3310491546,2),(51416763,425090963,15560684,258874,1,'2008-10-11 17:21:52',3310491546,2),(51416764,425093873,15560513,258874,1,'2008-10-11 17:21:52',3310491546,2),(51416765,425097480,15561028,258874,1,'2008-10-11 17:21:52',3310491547,2),(51416767,425101023,15564118,258874,1,'2008-10-11 17:21:52',3310491547,2),(51416768,425103807,15565748,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416769,425106021,15566693,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416770,425108932,15568066,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416771,425111463,15569525,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416772,425112412,15570383,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416774,425112412,15571585,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416775,425112222,15572958,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416776,425111146,15573902,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416779,425109501,15574074,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416780,425106907,15574331,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416781,425104882,15573559,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416782,425103174,15572615,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416783,425100833,15570383,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416785,425099631,15570040,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416786,425098935,15570641,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416787,425098682,15571757,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416789,425099188,15573216,258874,1,'2008-10-11 17:21:53',3310491547,2),(51416790,425101213,15575018,258874,1,'2008-10-11 17:21:53',3310491547,2),(51417251,425104819,15578194,258874,1,'2008-10-11 17:21:53',3310491547,2),(51417252,425110324,15583172,258874,1,'2008-10-11 17:21:53',3310491547,2),(51417253,425115259,15585747,258874,1,'2008-10-11 17:21:53',3310491547,2),(51417260,425120320,15587378,258874,1,'2008-10-11 17:21:53',3310491547,2),(51417263,425125192,15587807,258874,1,'2008-10-11 17:21:53',3310491550,2),(51417265,425127912,15589438,258874,1,'2008-10-11 17:21:53',3310491550,2),(51417268,425131202,15592871,258874,1,'2008-10-11 17:21:53',3310491550,2),(51417269,425134556,15596819,258874,1,'2008-10-11 17:21:53',3310491550,2),(51417272,425136390,15599480,258874,1,'2008-10-11 17:21:53',3310491550,2),(51417275,425136390,15600939,258874,1,'2008-10-11 17:21:53',3310491572,2),(51417277,425135315,15601540,258874,1,'2008-10-11 17:21:53',3310491572,2),(51417284,425133796,15600252,258874,1,'2008-10-11 17:21:53',3310491550,2),(51417285,425131898,15597677,258874,1,'2008-10-11 17:21:53',3310491550,2),(51417288,425129494,15595188,258874,1,'2008-10-11 17:21:53',3310491550,2),(51417289,425126900,15594673,258874,1,'2008-10-11 17:21:53',3310491550,2),(51417291,425122092,15595789,258874,1,'2008-10-11 17:21:54',3310491547,2),(51417294,425117410,15596819,258874,1,'2008-10-11 17:21:54',3310491547,2),(51417298,425113234,15596647,258874,1,'2008-10-11 17:21:54',3310491547,2),(51417398,425122661,15595617,258874,1,'2008-10-11 17:21:54',3310491550,2),(51417410,425093114,15576821,427965,1,'2007-09-14 21:29:02',3310491546,1),(51417414,425095329,15577336,427965,1,'2007-09-14 21:29:02',3310491547,1),(51417416,425097416,15579567,427965,1,'2007-09-14 21:29:02',3310491547,1),(51417419,425099188,15583000,427965,1,'2007-09-14 21:29:02',3310491547,1),(51417420,425101972,15585575,427965,1,'2007-09-14 21:29:02',3310491547,1),(51417421,425106717,15589352,427965,1,'2007-09-14 21:29:02',3310491547,1),(51417467,425089191,15584459,427965,1,'2007-09-14 21:29:01',3310491546,1),(51417468,425091342,15582485,427965,1,'2007-09-14 21:29:01',3310491546,1),(51417469,425093177,15581455,427965,1,'2007-09-14 21:29:01',3310491546,1),(51417472,425094443,15581284,427965,1,'2007-09-14 21:29:01',3310491546,1),(51417476,425095708,15582485,427965,1,'2007-09-14 21:29:01',3310491547,1),(51417481,425097290,15585232,427965,1,'2007-09-14 21:29:01',3310491547,1),(51417482,425098302,15586949,427965,1,'2007-09-14 21:29:01',3310491547,1),(51417484,425100200,15587893,427965,1,'2007-09-14 21:29:01',3310491547,1),(51417488,425103744,15586949,427965,1,'2007-09-14 21:29:01',3310491547,1),(51420037,425107856,15595446,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420038,425104819,15594931,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420040,425102794,15594588,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420042,425101086,15595102,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420044,425099441,15595188,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420045,425098239,15594158,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420046,425096974,15593729,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420048,425095961,15593729,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420050,425095012,15594588,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420052,425094949,15595188,258874,1,'2008-10-11 17:21:54',3310491546,2),(51420054,425095392,15596390,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420057,425096657,15596905,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420058,425105452,15599823,258874,1,'2008-10-11 17:21:54',3310491547,2),(51420059,425114436,15603771,258874,1,'2008-10-11 17:21:54',3310491569,2),(51420061,425119688,15606003,258874,1,'2008-10-11 17:21:54',3310491569,2),(51420063,425121206,15607720,258874,1,'2008-10-11 17:21:54',3310491569,2),(51420066,425121522,15608750,258874,1,'2008-10-11 17:21:54',3310491569,2),(51420067,425121143,15612354,258874,1,'2008-10-11 17:21:54',3310491569,2),(51420068,425119434,15619478,258874,1,'2008-10-11 17:21:54',3310491569,2),(51420072,425118675,15621624,258874,1,'2008-10-11 17:21:54',3310491569,2),(51420073,425117283,15623169,258874,1,'2008-10-11 17:21:54',3310491569,2);
INSERT INTO `nodes` VALUES (51420076,425115828,15624113,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420078,425112981,15626774,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420079,425112158,15628147,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420081,425111526,15630722,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420084,425111589,15633898,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420451,425111589,15635357,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420452,425111399,15636559,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420453,425110450,15638361,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420454,425108426,15640164,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420456,425107666,15641279,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420457,425107160,15645142,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420458,425107350,15648833,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420461,425108362,15650721,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420462,425109375,15651407,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420464,425111083,15651407,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420465,425112854,15650807,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420466,425114942,15648833,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420467,425116777,15647631,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420469,425118422,15647288,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420471,425122282,15648318,258874,1,'2008-10-11 17:21:55',3310491569,2),(51420474,425127406,15650721,258874,1,'2008-10-11 17:21:55',3310491572,2),(51420475,425129494,15652180,258874,1,'2008-10-11 17:21:55',3310491572,2),(51420476,425131708,15652523,258874,1,'2008-10-11 17:21:55',3310491572,2),(51420477,425133733,15652008,258874,1,'2008-10-11 17:21:55',3310491572,2),(51420893,425136074,15651407,258874,1,'2008-10-11 17:21:56',3310491572,2),(51420894,425138541,15651751,258874,1,'2008-10-11 17:21:56',3310491572,2),(51420895,425142084,15653897,258874,1,'2008-10-11 17:21:56',3310491572,2),(51420896,425146829,15658188,258874,1,'2008-10-11 17:21:56',3310491574,2),(51420899,425148917,15660162,258874,1,'2008-10-11 17:21:56',3310491574,2),(51420900,425149550,15661364,258874,1,'2008-10-11 17:21:56',3310491574,2),(51420902,425150435,15662651,258874,1,'2008-10-11 17:21:56',3310491575,2),(51420906,425151384,15663252,258874,1,'2008-10-11 17:21:56',3310491575,2),(51420908,425152207,15662394,258874,1,'2008-10-11 17:21:56',3310491575,2),(51420910,425152207,15661535,258874,1,'2008-10-11 17:21:56',3310491575,2),(51420912,425152333,15660591,258874,1,'2008-10-11 17:21:56',3310491575,2),(51420914,425152017,15658875,258874,1,'2008-10-11 17:21:56',3310491575,2),(51420916,425151131,15655527,258874,1,'2008-10-11 17:21:56',3310491573,2),(51420919,425150246,15653210,258874,1,'2008-10-11 17:21:56',3310491573,2),(51420921,425149233,15651751,258874,1,'2008-10-11 17:21:56',3310491572,2),(51420922,425148411,15650034,258874,1,'2008-10-11 17:21:56',3310491572,2),(51420926,425148411,15648833,258874,1,'2008-10-11 17:21:57',3310491572,2),(51420928,425148980,15646858,258874,1,'2008-10-11 17:21:57',3310491572,2),(51420929,425149929,15646858,258874,1,'2008-10-11 17:21:57',3310491573,2),(51420932,425150562,15648318,258874,1,'2008-10-11 17:21:57',3310491573,2),(51420933,425150562,15649347,258874,1,'2008-10-11 17:21:57',3310491573,2),(51420935,425151195,15650892,258874,1,'2008-10-11 17:21:57',3310491573,2),(51420938,425151954,15652094,258874,1,'2008-10-11 17:21:57',3310491573,2),(51420939,425153852,15654926,258874,1,'2008-10-11 17:21:57',3310491573,2),(51420940,425156635,15659733,258874,1,'2008-10-11 17:21:57',3310491575,2),(51420942,425159925,15668402,258874,1,'2008-10-11 17:21:57',3310491575,2),(51420945,425163911,15679474,258874,1,'2008-10-11 17:21:57',3310491575,2),(51420946,425168213,15688658,258874,1,'2008-10-11 17:21:57',3310491575,2),(51420950,425171629,15695439,258874,1,'2008-10-11 17:21:57',3310491575,2),(51420951,425173211,15699902,258874,1,'2008-10-11 17:21:57',3310491575,2),(51420952,425173907,15704107,258874,1,'2008-10-11 17:21:57',3310491575,2),(51420955,425173907,15707283,258874,1,'2008-10-11 17:21:57',3310491575,2),(51420956,425174096,15710287,258874,1,'2008-10-11 17:21:57',3310491575,2),(51420957,425174919,15711832,258874,1,'2008-10-11 17:21:57',3310491581,2),(51420958,425176311,15711575,427965,1,'2007-09-14 21:33:37',3310491581,1),(51420961,425177007,15710716,427965,1,'2007-09-14 21:33:37',3310491581,1),(51420964,425177196,15709515,427965,1,'2007-09-14 21:33:37',3310491575,1),(51420967,425177196,15708142,427965,1,'2007-09-14 21:33:37',3310491575,1),(51420968,425176627,15704880,427965,1,'2007-09-14 21:33:37',3310491575,1),(51420969,425174982,15689602,427965,1,'2007-09-14 21:33:37',3310491575,1),(51420970,425174160,15684023,427965,1,'2007-09-14 21:33:37',3310491575,1),(51421275,424981620,15272207,427965,1,'2007-09-14 21:36:14',3310491432,1),(51421278,424985543,15278645,427965,1,'2007-09-14 21:36:14',3310491433,1),(51421280,424988138,15284138,427965,1,'2007-09-14 21:36:14',3310491433,1),(51421281,424988834,15286627,427965,1,'2007-09-14 21:36:14',3310491433,1),(51421284,424988201,15287743,427965,1,'2007-09-14 21:36:14',3310491433,1),(51421287,424985543,15290661,427965,1,'2007-09-14 21:36:14',3310491433,1),(51421289,424984277,15293579,427965,1,'2007-09-14 21:36:14',3310491432,1),(51421291,424983265,15297098,427965,1,'2007-09-14 21:36:14',3310491432,1),(51421294,424983391,15300703,427965,1,'2007-09-14 21:36:14',3310491432,1),(51421295,424984341,15303106,427965,1,'2007-09-14 21:36:14',3310491432,1),(51421296,424986302,15304651,427965,1,'2007-09-14 21:36:14',3310491433,1),(51421297,424989783,15306196,427965,1,'2007-09-14 21:36:14',3310491433,1),(51438191,425034634,15118277,434787,1,'2007-09-15 15:11:13',3310491406,1),(51438193,425031766,15121021,427965,1,'2007-09-14 22:01:04',3310491406,1),(51438194,425036892,15131063,427965,1,'2007-09-14 22:01:04',3310491406,1),(51438195,425039610,15128839,434787,1,'2007-09-15 15:11:13',3310491406,1),(51438631,425050895,15141671,697263,1,'2009-01-01 16:45:34',3310491407,4),(51438632,425045118,15136042,697263,1,'2009-01-01 16:45:34',3310491407,4),(51438634,425041973,15130428,697263,1,'2009-01-01 16:43:56',3310491407,4),(51438635,425037734,15123218,697263,1,'2009-01-01 16:43:56',3310491406,3),(51438636,425026091,15097469,697263,1,'2009-01-01 16:43:56',3310491404,3),(51438638,425023749,15088971,697263,1,'2009-01-01 16:43:56',3310491404,3),(51438639,425023180,15087083,697263,1,'2009-01-01 16:43:56',3310491404,3),(51438642,425022737,15086397,697263,1,'2009-01-01 16:43:56',3310491404,3),(51438643,425022168,15086826,697263,1,'2009-01-01 16:43:56',3310491404,3),(51438645,425022104,15087770,697263,1,'2009-01-01 16:43:56',3310491404,3),(51438646,425021768,15089951,697263,1,'2009-01-01 16:43:57',3310491404,2),(51438647,425021642,15094671,697263,1,'2009-01-01 16:43:57',3310491404,2),(51438648,425020376,15100164,697263,1,'2009-01-01 16:43:57',3310491404,2),(51438650,425019763,15101503,697263,1,'2009-01-01 16:43:57',3310491404,4),(51438651,425018687,15102104,697263,1,'2009-01-01 16:43:57',3310491404,4),(51438652,425018307,15101503,697263,1,'2009-01-01 16:43:57',3310491404,3),(51438654,425018181,15100559,697263,1,'2009-01-01 16:43:57',3310491404,3),(51438655,425018307,15098928,697263,1,'2009-01-01 16:43:57',3310491404,3),(51438656,425018940,15094379,697263,1,'2009-01-01 16:43:57',3310491404,3),(51438658,425019004,15091632,697263,1,'2009-01-01 16:43:58',3310491404,3),(51438659,425019193,15089658,697263,1,'2009-01-01 16:43:58',3310491404,3),(51438660,425018624,15088714,697263,1,'2009-01-01 16:43:58',3310491404,4),(51438661,425017548,15090774,697263,1,'2009-01-01 16:43:58',3310491404,4),(51438662,425016409,15093950,697263,1,'2009-01-01 16:43:58',3310491404,4),(51438663,425014744,15096388,697263,1,'2009-01-01 16:43:58',3310491404,2),(51438665,425012865,15100559,697263,1,'2009-01-01 16:43:58',3310491404,3),(51438666,425010524,15102876,697263,1,'2009-01-01 16:43:58',3310491401,3),(51438812,425019257,15102189,697263,1,'2009-01-01 16:43:57',3310491404,4),(51439215,424973694,15026229,592895,1,'2008-07-25 23:03:57',3310491394,2),(51439216,424956588,15041628,427965,1,'2007-09-14 22:02:35',3310491223,1),(51439552,424999703,15079273,592895,1,'2008-07-25 23:00:37',3310491401,2),(51439943,424934691,14952965,427965,1,'2007-09-14 22:03:20',3310491221,1),(51439944,424930577,14956570,427965,1,'2007-09-14 22:03:20',3310491221,1),(51439947,424927855,14958887,427965,1,'2007-09-14 22:03:20',3310491220,1),(51439949,424926463,14959488,427965,1,'2007-09-14 22:03:20',3310491220,1),(51439951,424925387,14959402,427965,1,'2007-09-14 22:03:20',3310491220,1),(51439953,424924185,14957685,427965,1,'2007-09-14 22:03:20',3310491220,1),(51439955,424923235,14956656,427965,1,'2007-09-14 22:03:20',3310491220,1),(51439959,424922033,14956656,427965,1,'2007-09-14 22:03:20',3310491220,1),(51439960,424921590,14957256,427965,1,'2007-09-14 22:03:20',3310491220,1),(51439962,424921400,14959745,427965,1,'2007-09-14 22:03:20',3310491220,1),(51439964,424922982,14962749,427965,1,'2007-09-14 22:03:20',3310491220,1),(51439967,424926083,14967985,427965,1,'2007-09-14 22:03:20',3310491220,1),(51440235,424982344,15092182,427965,1,'2007-09-14 22:03:39',3310491400,1),(51440320,425004639,15090259,592895,1,'2008-07-25 23:00:36',3310491401,2),(51440321,425002361,15085109,592895,1,'2008-07-25 23:00:36',3310491401,2),(51440620,424991520,15093384,427965,1,'2007-09-14 22:04:01',3310491401,1),(51440622,425001855,15083993,592895,1,'2008-07-25 23:00:36',3310491401,2),(51441228,425069732,15190029,427965,1,'2007-09-14 22:10:36',3310491440,1),(51441229,425064986,15184278,427965,1,'2007-09-14 22:10:36',3310491429,1),(51441230,425061000,15179987,427965,1,'2007-09-14 22:10:36',3310491429,1),(51441232,425060494,15178013,427965,1,'2007-09-14 22:10:36',3310491429,1),(51441233,425059734,15174065,427965,1,'2007-09-14 22:10:36',3310491429,1),(51441235,425058912,15170288,427965,1,'2007-09-14 22:04:53',3310491429,1),(51441237,425057773,15167370,427965,1,'2007-09-14 22:10:36',3310491429,1),(51441239,425054483,15161533,427965,1,'2007-09-14 22:10:36',3310491429,1),(51441242,425052901,15155439,427965,1,'2007-09-14 22:10:36',3310491407,1),(51441244,425051888,15152521,427965,1,'2007-09-14 22:10:36',3310491407,1),(51441246,425050623,15150547,427965,1,'2007-09-14 22:10:36',3310491407,1),(51441249,425048345,15149517,427965,1,'2007-09-14 22:10:36',3310491407,1),(51441250,425045624,15148573,427965,1,'2007-09-14 22:10:36',3310491407,1),(51441254,425043662,15146770,427965,1,'2007-09-14 22:10:36',3310491407,1),(51441258,425036449,15138874,427965,1,'2007-09-14 22:10:36',3310491406,1),(51441261,425032905,15135269,427965,1,'2007-09-14 22:10:36',3310491406,1),(51441262,425030058,15133896,427965,1,'2007-09-14 22:10:36',3310491406,1),(51441263,425027716,15131149,427965,1,'2007-09-14 22:10:36',3310491406,1),(51441266,425024046,15126514,427965,1,'2007-09-14 22:10:36',3310491406,1),(51441267,425014491,15113297,427965,1,'2007-09-14 22:10:36',3310491406,1),(51441269,425011960,15107803,427965,1,'2007-09-14 22:10:36',3310491403,1),(51441361,425067770,15182562,427965,1,'2007-09-14 22:05:47',3310491440,1),(51441364,425068973,15186338,427965,1,'2007-09-14 22:05:47',3310491440,1),(51441603,425086373,15281868,427965,1,'2007-09-14 22:10:36',3310491448,1),(51441607,425083842,15277061,427965,1,'2007-09-14 22:10:36',3310491448,1),(51441610,425083082,15273457,427965,1,'2007-09-14 22:10:36',3310491448,1),(51441611,425082829,15267706,427965,1,'2007-09-14 22:10:36',3310491442,1),(51441615,425081690,15260239,427965,1,'2007-09-14 22:10:36',3310491442,1),(51441616,425081058,15255346,427965,1,'2007-09-14 22:10:36',3310491442,1),(51441619,425078843,15247707,427965,1,'2007-09-14 22:11:20',3310491442,1),(51441621,425077787,15240634,592895,1,'2008-07-25 23:51:05',3310491442,2),(51441623,425077471,15233768,592895,1,'2008-07-25 23:51:05',3310491442,2),(51441625,425076502,15228825,427965,1,'2007-09-14 22:10:36',3310491442,1),(51441626,425075539,15223711,978767,1,'2009-04-26 22:36:08',3310491442,3),(51441629,425074351,15215178,427965,1,'2007-09-14 22:10:36',3310491440,1),(51441630,425073971,15206337,427965,1,'2007-09-14 22:10:36',3310491440,1),(51441632,425073971,15202303,427965,1,'2007-09-14 22:10:36',3310491440,1),(51441635,425073212,15198355,427965,1,'2007-09-14 22:10:36',3310491440,1),(51441636,425071883,15194149,427965,1,'2007-09-14 22:10:36',3310491440,1),(51441659,425088144,15284958,427965,1,'2007-09-14 22:10:36',3310491448,1),(51441848,425060766,15148967,697263,1,'2009-01-01 16:45:34',3310491407,4),(51441849,425061589,15150598,592895,1,'2008-07-26 00:12:08',3310491407,2),(51441850,425063677,15158065,592895,1,'2008-07-26 00:12:28',3310491407,3),(51441852,425063911,15161619,427965,1,'2007-09-14 22:05:47',3310491429,1),(51441853,425065385,15170339,592895,1,'2008-07-26 00:12:56',3310491429,2),(51441855,425066018,15175746,592895,1,'2008-07-26 00:12:56',3310491429,2),(51441857,425066631,15180159,427965,1,'2007-09-14 22:05:47',3310491429,1),(51442041,424944817,14981890,592895,1,'2008-07-25 22:14:49',3310491221,2),(51442271,424944627,14986954,592895,1,'2008-07-25 22:14:49',3310491221,2),(51442273,424945893,14987812,592895,1,'2008-07-25 22:14:49',3310491221,2),(51442278,424943804,14985237,592895,1,'2008-07-25 22:14:49',3310491221,2),(51442280,424943614,14983520,592895,1,'2008-07-25 22:14:49',3310491221,2),(51442282,424944058,14982576,592895,1,'2008-07-25 22:14:49',3310491221,2),(51442349,424944058,14985752,592895,1,'2008-07-25 22:14:49',3310491221,2),(51442351,424942855,14988670,427965,1,'2007-09-14 22:06:39',3310491221,1),(51442352,424942095,14992533,427965,1,'2007-09-14 22:06:39',3310491221,1),(51442529,424971163,15009235,592895,1,'2008-07-25 23:09:45',3310491394,2),(51442532,424976162,15021079,592895,1,'2008-07-25 23:09:45',3310491394,2),(51442533,424972808,15024598,592895,1,'2008-07-25 23:03:57',3310491394,2),(51442648,424960828,15025406,427965,1,'2007-09-14 22:07:10',3310491394,1),(51442649,424961144,15022230,427965,1,'2007-09-14 22:07:10',3310491394,1),(51442651,424965194,15019655,427965,1,'2007-09-14 22:07:10',3310491394,1),(51442653,424968821,15016445,592895,1,'2008-07-25 23:05:42',3310491394,2),(51442942,425045624,15270624,427965,1,'2007-09-14 22:07:46',3310491431,1),(51442943,425045244,15273199,427965,1,'2007-09-14 22:07:46',3310491437,1),(51442944,425045877,15275602,427965,1,'2007-09-14 22:07:46',3310491437,1),(51442946,425046320,15277147,427965,1,'2007-09-14 22:07:46',3310491437,1),(51442947,425047459,15277576,427965,1,'2007-09-14 22:07:46',3310491437,1),(51442949,425048092,15276031,427965,1,'2007-09-14 22:07:46',3310491437,1),(51442951,425048218,15274401,427965,1,'2007-09-14 22:07:46',3310491437,1),(51442952,425048408,15271826,427965,1,'2007-09-14 22:07:46',3310491437,1),(51442953,425049294,15268049,427965,1,'2007-09-14 22:07:46',3310491431,1),(51442955,425049294,15266418,427965,1,'2007-09-14 22:07:46',3310491431,1),(51442956,425048724,15264015,427965,1,'2007-09-14 22:07:46',3310491431,1),(51442957,425044738,15246677,427965,1,'2007-09-14 22:07:46',3310491431,1),(51442958,425044928,15243759,427965,1,'2007-09-14 22:07:46',3310491431,1),(51442959,425045751,15241528,427965,1,'2007-09-14 22:07:46',3310491431,1),(51442960,425047396,15240068,427965,1,'2007-09-14 22:07:46',3310491431,1),(51442961,425047902,15239725,840745,1,'2009-01-26 20:00:23',3310491431,4),(51443088,425051319,15231915,427965,1,'2007-09-14 22:07:53',3310491431,1),(51443089,425064480,15225992,427965,1,'2007-09-14 22:08:10',3310491431,1),(51443310,425073591,15250883,427965,1,'2007-09-14 22:08:08',3310491442,1),(51443312,425074857,15253801,427965,1,'2007-09-14 22:08:08',3310491442,1),(51443313,425077514,15257578,427965,1,'2007-09-14 22:08:08',3310491442,1),(51443314,425079602,15262384,427965,1,'2007-09-14 22:08:08',3310491442,1),(51443315,425080805,15267963,427965,1,'2007-09-14 22:08:08',3310491442,1),(51443317,425081248,15275860,427965,1,'2007-09-14 22:08:08',3310491448,1),(51443319,425081311,15281267,427965,1,'2007-09-14 22:08:08',3310491448,1),(51443662,425097066,15264616,427965,1,'2007-09-14 22:12:33',3310491443,1),(51443663,425098427,15268231,437032,1,'2008-05-13 20:39:16',3310491443,2),(51443665,425100009,15271321,437032,1,'2008-05-13 20:39:16',3310491449,2),(51443668,425102097,15275183,437032,1,'2008-05-13 20:39:16',3310491449,2),(51443669,425107475,15290032,437032,1,'2008-05-13 20:39:16',3310491449,2),(51443670,425108138,15293455,427965,1,'2007-09-14 22:12:33',3310491449,1),(51443671,425107568,15295515,427965,1,'2007-09-14 22:12:33',3310491449,1),(51443672,425105987,15296202,427965,1,'2007-09-14 22:12:33',3310491449,1),(51443673,425104152,15296373,427965,1,'2007-09-14 22:12:33',3310491449,1),(51443676,425101621,15293970,427965,1,'2007-09-14 22:12:33',3310491449,1),(51443678,425099723,15291910,427965,1,'2007-09-14 22:12:33',3310491449,1),(51443679,425097698,15290194,427965,1,'2007-09-14 22:12:33',3310491449,1),(51443680,425096116,15287876,427965,1,'2007-09-14 22:12:33',3310491449,1),(51443683,425092953,15285044,427965,1,'2007-09-14 22:12:33',3310491448,1),(51443685,425089157,15280409,427965,1,'2007-09-14 22:12:33',3310491448,1),(51443686,425087195,15278091,427965,1,'2007-09-14 22:12:33',3310491448,1),(51443687,425085993,15276031,427965,1,'2007-09-14 22:12:33',3310491448,1),(51443688,425085107,15273886,427965,1,'2007-09-14 22:12:33',3310491448,1),(51443690,425084917,15271654,427965,1,'2007-09-14 22:12:33',3310491448,1),(51443691,425084664,15267105,427965,1,'2007-09-14 22:12:33',3310491442,1),(51443692,425084221,15264187,427965,1,'2007-09-14 22:12:33',3310491442,1),(51443693,425083652,15260925,427965,1,'2007-09-14 22:12:33',3310491442,1),(51443694,425082640,15258179,427965,1,'2007-09-14 22:08:43',3310491442,1),(51443695,425081311,15257063,427965,1,'2007-09-14 22:12:33',3310491442,1),(51444358,425141733,15304613,427965,1,'2007-09-14 22:12:33',3310491452,1),(51444359,425138254,15302982,427965,1,'2007-09-14 22:12:33',3310491452,1),(51444362,425135786,15302725,427965,1,'2007-09-14 22:12:33',3310491452,1),(51444364,425132307,15303326,427965,1,'2007-09-14 22:12:33',3310491452,1),(51444365,425130029,15304527,427965,1,'2007-09-14 22:12:33',3310491452,1),(51444366,425126203,15308314,437032,1,'2008-05-13 20:27:32',3310491452,2),(51444368,425122723,15309344,437032,1,'2008-05-13 20:27:32',3310491452,2),(51444370,425121015,15309344,437032,1,'2008-05-13 20:27:32',3310491449,2),(51444371,425118990,15308228,437032,1,'2008-05-13 20:27:32',3310491449,2),(51444373,425116966,15305567,437032,1,'2008-05-13 20:27:32',3310491449,2),(51444374,425115287,15301609,427965,1,'2007-09-14 22:12:33',3310491449,1),(51444375,425114308,15297843,437032,1,'2008-05-13 20:27:32',3310491449,2),(51444377,425113136,15292253,427965,1,'2007-09-14 22:12:33',3310491449,1),(51444379,425113106,15288401,437032,1,'2008-05-13 20:27:32',3310491449,2),(51444381,425111744,15282469,427965,1,'2007-09-14 22:12:33',3310491449,1),(51444383,425108740,15274153,437032,1,'2008-05-13 20:27:32',3310491449,2),(51444384,425105514,15267888,437032,1,'2008-05-13 20:32:39',3310491443,2),(51444386,425104058,15265742,437032,1,'2008-05-13 20:32:39',3310491443,3),(51444387,425102667,15263167,437032,1,'2008-05-13 20:27:32',3310491443,2),(51444388,425101591,15259734,437032,1,'2008-05-13 20:27:32',3310491443,2),(51444391,425101115,15257235,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444392,425101907,15252696,437032,1,'2008-05-13 20:27:51',3310491443,2),(51444393,425102190,15251312,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444394,425101305,15240669,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444395,425100735,15229511,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444396,425097762,15229683,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444397,425098521,15234318,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444398,425098521,15238094,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444399,425098204,15241871,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444401,425097192,15248480,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444403,425097572,15251656,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444404,425097762,15255003,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444405,425096812,15257063,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444406,425097255,15259380,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444408,425097731,15260335,437032,1,'2008-05-13 20:34:15',3310491443,2),(51444410,425096812,15261784,427965,1,'2007-09-14 22:12:33',3310491443,1),(51444411,425096529,15262995,437032,1,'2008-05-13 20:39:16',3310491443,2),(51444444,425106779,15269347,437032,1,'2008-05-13 20:32:39',3310491443,2),(51444468,425101211,15266257,437032,1,'2008-05-13 20:34:15',3310491443,2),(51444470,425103742,15270377,437032,1,'2008-05-13 20:34:15',3310491443,2),(51444471,425105261,15270034,437032,1,'2008-05-13 20:34:15',3310491443,2),(51444652,425092700,15227709,427965,1,'2007-09-14 22:10:22',3310491442,1),(51444653,425095484,15238266,427965,1,'2007-09-14 22:10:22',3310491443,1),(51444884,425089726,15217323,427965,1,'2007-09-14 22:10:34',3310491442,1),(51444885,425086436,15212345,427965,1,'2007-09-14 22:10:34',3310491440,1),(51444886,425082975,15216773,592895,1,'2008-07-25 23:51:45',3310491442,2),(51444888,425084051,15220035,592895,1,'2008-07-25 23:51:45',3310491442,2),(51444889,425085063,15225614,592895,1,'2008-07-25 23:51:45',3310491442,2),(51444891,425083798,15229562,592895,1,'2008-07-25 23:51:45',3310491442,2),(51444892,425082576,15232000,427965,1,'2007-09-14 22:10:22',3310491442,1),(51444894,425084095,15234489,427965,1,'2007-09-14 22:10:22',3310491442,1),(51444896,425089536,15226336,427965,1,'2007-09-14 22:10:22',3310491442,1),(51444897,425090169,15224962,427965,1,'2007-09-14 22:10:22',3310491442,1),(51444898,425090232,15223503,427965,1,'2007-09-14 22:10:22',3310491442,1),(51444899,425091118,15222473,427965,1,'2007-09-14 22:10:22',3310491442,1),(51444902,425091877,15223503,427965,1,'2007-09-14 22:10:22',3310491442,1),(51445067,425079476,15203161,427965,1,'2007-09-14 22:10:34',3310491440,1),(51445068,425077388,15201359,427965,1,'2007-09-14 22:10:34',3310491440,1),(51445069,425076312,15200586,427965,1,'2007-09-14 22:10:34',3310491440,1),(51445070,425075426,15201788,427965,1,'2007-09-14 22:10:34',3310491440,1),(51445071,425074920,15202904,427965,1,'2007-09-14 22:10:55',3310491440,1),(51445073,425073971,15203505,427965,1,'2007-09-14 22:10:34',3310491440,1),(51445113,425080931,15215693,427965,1,'2007-09-14 22:10:47',3310491440,1),(51445209,425077514,15210114,427965,1,'2007-09-14 22:10:47',3310491440,1),(51445210,425078843,15212946,427965,1,'2007-09-14 22:10:47',3310491440,1),(51445276,425074179,15191520,91018,1,'2008-06-07 20:24:45',3310491440,2),(51445277,425075869,15196209,427965,1,'2007-09-14 22:10:55',3310491440,1),(51445278,425075869,15198698,427965,1,'2007-09-14 22:10:55',3310491440,1),(51445766,425087575,15272083,427965,1,'2007-09-14 22:11:20',3310491448,1),(51445767,425087005,15263758,427965,1,'2007-09-14 22:11:20',3310491442,1),(51445769,425084095,15248566,427965,1,'2007-09-14 22:11:20',3310491442,1),(51445772,425082829,15245905,427965,1,'2007-09-14 22:11:20',3310491442,1),(51445774,425081564,15245733,427965,1,'2007-09-14 22:11:20',3310491442,1),(51445785,425087828,15278864,427965,1,'2007-09-14 22:12:33',3310491448,1),(51446293,425066378,15275259,427965,1,'2007-09-14 22:11:53',3310491437,1),(51446294,425071503,15279207,427965,1,'2007-09-14 22:11:53',3310491448,1),(51446295,425072199,15280323,427965,1,'2007-09-14 22:11:53',3310491448,1),(51446297,425072453,15281696,427965,1,'2007-09-14 22:11:53',3310491448,1),(51446298,425071630,15283499,427965,1,'2007-09-14 22:11:53',3310491448,1),(51446299,425069036,15286760,427965,1,'2007-09-14 22:11:53',3310491448,1),(51446300,425066062,15282125,427965,1,'2007-09-14 22:11:53',3310491437,1),(51446302,425064037,15285044,427965,1,'2007-09-14 22:11:53',3310491437,1),(51446303,425059481,15281954,427965,1,'2007-09-14 22:11:53',3310491437,1),(51446306,425058216,15275087,427965,1,'2007-09-14 22:11:53',3310491437,1),(51446307,425059102,15274658,427965,1,'2007-09-14 22:11:53',3310491437,1),(51446309,425057457,15271225,427965,1,'2007-09-14 22:11:53',3310491431,1),(51446312,425058469,15269423,427965,1,'2007-09-14 22:11:53',3310491431,1),(51446485,425104721,15317144,427965,1,'2007-09-14 22:12:31',3310491449,1),(51446486,425107632,15326500,427965,1,'2007-09-14 22:12:31',3310491451,1),(51446487,425109530,15330963,427965,1,'2007-09-14 22:12:31',3310491451,1),(51446490,425112061,15333967,427965,1,'2007-09-14 22:12:31',3310491451,1),(51446491,425115161,15336027,427965,1,'2007-09-14 22:12:31',3310491451,1),(51446492,425117122,15337400,427965,1,'2007-09-14 22:12:31',3310491451,1),(51446494,425119843,15342894,427965,1,'2007-09-14 22:12:31',3310491451,1),(51446496,425121298,15346842,427965,1,'2007-09-14 22:12:31',3310491451,1),(51446497,425122627,15348816,427965,1,'2007-09-14 22:12:31',3310491454,1),(51446498,425124968,15349846,427965,1,'2007-09-14 22:12:31',3310491454,1),(51446677,425101241,15294914,427965,1,'2007-09-14 22:12:31',3310491449,1),(51446679,425101241,15296974,427965,1,'2007-09-14 22:12:31',3310491449,1),(51446680,425101684,15301867,427965,1,'2007-09-14 22:12:31',3310491449,1),(51446682,425102001,15304356,427965,1,'2007-09-14 22:12:31',3310491449,1),(51446684,425101621,15306587,427965,1,'2007-09-14 22:12:31',3310491449,1),(51446687,425101621,15308905,427965,1,'2007-09-14 22:12:31',3310491449,1),(51446688,425101874,15310020,427965,1,'2007-09-14 22:12:31',3310491449,1),(51446690,425103140,15312510,427965,1,'2007-09-14 22:12:31',3310491449,1),(51446992,425054920,15291959,981792,1,'2009-04-27 01:35:55',3310491437,3),(51446997,425062961,15303326,981792,1,'2009-04-27 01:35:56',3310491437,2),(51447331,425060620,15306072,427965,1,'2007-09-14 22:13:13',3310491437,1),(51447714,425095698,15396877,188228,1,'2008-06-16 18:47:01',3310491537,2),(51447737,425095674,15407782,305941,1,'2009-02-09 21:21:41',3310491537,2),(51448127,425095381,15390697,188228,1,'2008-06-16 19:09:32',3310491537,6),(51448405,425111365,15396795,427965,1,'2007-09-14 22:14:55',3310491537,1),(51448408,425106556,15393019,427965,1,'2007-09-14 22:14:55',3310491537,1),(51448409,425100569,15388122,188228,1,'2008-06-16 19:09:56',3310491537,4),(51448537,425101241,15391216,427965,1,'2007-09-14 22:15:09',3310491537,1),(51448538,425101329,15393787,188228,1,'2008-06-16 18:39:09',3310491537,2),(51448539,425100506,15397048,188228,1,'2008-06-16 18:44:40',3310491537,3),(51448541,425099494,15399537,188228,1,'2008-06-16 18:45:06',3310491537,3),(51448824,425342004,15773420,427965,1,'2007-09-14 22:19:21',3310491643,1),(51448827,425338399,15774107,454632,1,'2007-09-17 19:59:14',3310491643,1),(51448828,425334608,15775868,188228,1,'2008-06-16 20:02:58',3310491643,2),(51448830,425329295,15778185,188228,1,'2008-06-16 20:02:41',3310491643,5),(51448926,425340296,15805349,427965,1,'2007-09-14 22:19:21',3310491643,1),(51448928,425340802,15803118,427965,1,'2007-09-14 22:19:21',3310491643,1),(51448929,425342699,15798998,427965,1,'2007-09-14 22:19:21',3310491646,1),(51448931,425344660,15796938,427965,1,'2007-09-14 22:19:21',3310491646,1),(51448934,425346874,15794191,427965,1,'2007-09-14 22:19:21',3310491646,1),(51448936,425347569,15792303,427965,1,'2007-09-14 22:19:21',3310491646,1),(51448937,425345609,15779343,427965,1,'2007-09-14 22:19:21',3310491646,1),(51448938,425345039,15775824,427965,1,'2007-09-14 22:19:21',3310491646,1),(51448940,425344524,15773962,188228,1,'2008-06-16 20:04:22',3310491646,2),(51449055,425361420,15790501,427965,1,'2007-09-14 22:16:28',3310491646,1),(51449056,425360661,15787497,427965,1,'2007-09-14 22:16:28',3310491646,1),(51449057,425359270,15782261,427965,1,'2007-09-14 22:16:28',3310491646,1),(51449058,425359017,15779943,427965,1,'2007-09-14 22:16:28',3310491646,1),(51449060,425359333,15778313,427965,1,'2007-09-14 22:16:28',3310491646,1),(51449062,425358764,15776510,427965,1,'2007-09-14 22:16:28',3310491646,1),(51449064,425356866,15766211,427965,1,'2007-09-14 22:16:28',3310491646,1),(51449130,425354526,15794191,427965,1,'2007-09-14 22:16:34',3310491646,1),(51449133,425355601,15792046,427965,1,'2007-09-14 22:16:34',3310491646,1),(51449134,425357372,15781059,427965,1,'2007-09-14 22:16:34',3310491646,1),(51449137,425356613,15778399,427965,1,'2007-09-14 22:16:34',3310491646,1),(51449139,425356866,15777369,427965,1,'2007-09-14 22:16:34',3310491646,1),(51449140,425357689,15775995,427965,1,'2007-09-14 22:16:34',3310491646,1),(51449148,425358700,15775480,427965,1,'2007-09-14 22:16:34',3310491646,1),(51449177,425347253,15793419,427965,1,'2007-09-14 22:19:21',3310491646,1),(51449178,425349024,15792131,427965,1,'2007-09-14 22:16:34',3310491646,1),(51449179,425351554,15792046,427965,1,'2007-09-14 22:16:34',3310491646,1),(51449552,425330999,15848093,427965,1,'2007-09-14 22:18:51',3310493009,1),(51449553,425327267,15843887,427965,1,'2007-09-14 22:18:51',3310493009,1),(51449672,425322966,15839167,427965,1,'2007-09-14 22:18:51',3310493009,1),(51449673,425320942,15836420,427965,1,'2007-09-14 22:18:51',3310493009,1),(51449675,425319171,15832644,427965,1,'2007-09-14 22:18:51',3310493009,1),(51449676,425317843,15828695,427965,1,'2007-09-14 22:18:51',3310493009,1),(51449997,425316452,15823460,427965,1,'2007-09-14 22:18:51',3310493009,1),(51449998,425316452,15817451,427965,1,'2007-09-14 22:18:51',3310491643,1),(51449999,425316894,15808353,427965,1,'2007-09-14 22:18:51',3310491643,1),(51450002,425317400,15796423,427965,1,'2007-09-14 22:18:51',3310491643,1),(51450003,425317780,15786037,427965,1,'2007-09-14 22:18:51',3310491643,1),(51450004,425317084,15774536,427965,1,'2007-09-14 22:18:51',3310491643,1),(51450007,425315250,15760117,427965,1,'2007-09-14 22:18:51',3310491641,1),(51450008,425313163,15751190,427965,1,'2007-09-14 22:18:51',3310491640,1),(51450009,425309874,15743122,427965,1,'2007-09-14 22:18:51',3310491640,1),(51450011,425307280,15738487,427965,1,'2007-09-14 22:18:51',3310491640,1),(51450013,425302094,15733852,427965,1,'2007-09-14 22:18:51',3310491640,1),(51450014,425296465,15730333,427965,1,'2007-09-14 22:18:51',3310491640,1),(51450016,425293935,15726900,427965,1,'2007-09-14 22:18:51',3310491640,1),(51450017,425292986,15724497,427965,1,'2007-09-14 22:18:51',3310491640,1),(51450019,425292610,15719563,188228,1,'2008-06-16 19:41:47',3310491640,2),(51450106,425295201,15715529,4963967,1,'2010-06-11 20:09:40',3310491640,4),(51450107,425294561,15713791,4963967,1,'2010-06-11 20:09:40',3310491640,4),(51450110,425293364,15713528,4963967,1,'2010-06-11 20:09:40',3310491640,3),(51450111,425292501,15714426,4963967,1,'2010-06-11 20:09:41',3310491640,4),(51450113,425292300,15715443,4963967,1,'2010-06-11 20:09:41',3310491640,4),(51450114,425292431,15716248,4963967,1,'2010-06-11 20:09:41',3310491640,5),(51450116,425293129,15717207,4963967,1,'2010-06-11 20:09:41',3310491640,3),(51450118,425294262,15717271,4963967,1,'2010-06-11 20:09:41',3310491640,4),(51450178,425292874,15713858,4963967,1,'2010-06-11 20:09:40',3310491640,3),(51450303,425295021,15716383,4963967,1,'2010-06-11 20:09:41',3310491640,4),(51450764,425350605,15769730,427965,1,'2007-09-14 22:19:20',3310491646,1),(51450766,425345988,15775738,427965,1,'2007-09-14 22:19:20',3310491646,1),(51450767,425345229,15776081,427965,1,'2007-09-14 22:19:20',3310491646,1),(51552405,425168593,15276498,432736,1,'2007-09-15 01:37:41',3310491453,1),(51552408,425167422,15280234,432736,1,'2007-09-15 01:37:41',3310491453,1),(51552410,425167010,15284761,432736,1,'2007-09-15 01:37:42',3310491453,1),(51552413,425171285,15269088,461502,1,'2008-05-16 19:07:44',3310491447,3),(51552416,425172740,15265397,461502,1,'2008-05-16 19:07:44',3310491447,3),(51552419,425174827,15260591,461502,1,'2008-05-16 19:07:44',3310491447,3),(51552422,425177674,15257072,461502,1,'2008-05-16 18:47:55',3310491490,2),(51552429,425184190,15248832,461502,1,'2008-05-16 18:47:55',3310491490,3),(51552432,425188492,15242137,461502,1,'2008-05-16 18:44:51',3310491490,3),(51552434,425190517,15239305,461502,1,'2008-05-16 18:44:51',3310491490,3),(51552437,425194122,15237674,461502,1,'2008-05-16 18:41:28',3310491490,2),(51552440,425197286,15237073,461502,1,'2008-05-16 18:41:28',3310491490,2),(51552442,425202577,15235835,463410,1,'2008-05-17 14:55:40',3310491490,3),(51552444,425205067,15234498,461502,1,'2008-05-16 18:39:56',3310491491,2),(51552445,425208040,15233211,461502,1,'2008-05-16 18:39:56',3310491491,2),(51552447,425210317,15232009,461502,1,'2008-05-16 18:39:56',3310491491,2),(51552451,425212025,15230979,461502,1,'2008-05-16 18:39:56',3310491491,2),(51552453,425214303,15228833,461502,1,'2008-05-16 18:39:56',3310491491,2),(51552456,425216517,15225744,461502,1,'2008-05-16 18:39:56',3310491491,2),(51552459,425218857,15222482,461502,1,'2008-05-16 18:39:56',3310491491,2),(51552462,425222083,15219478,461502,1,'2008-05-16 18:38:38',3310491491,2),(51552466,425239796,15210380,461502,1,'2008-05-16 18:36:34',3310491492,4),(51552468,425236949,15212268,461502,1,'2008-05-16 18:38:38',3310491492,2),(51552471,425226258,15217675,461502,1,'2008-05-16 18:38:38',3310491491,2),(51552473,425241187,15209436,461502,1,'2008-05-16 18:36:34',3310491492,5),(51552476,425242832,15208234,461502,1,'2008-05-16 18:36:34',3310491492,5),(51552477,425245172,15207118,461502,1,'2008-05-16 18:35:59',3310491492,5),(51552480,425249980,15206088,461502,1,'2008-05-16 18:36:10',3310491492,4),(51552483,425255814,15205593,2895121,1,'2009-10-19 19:12:50',3310491492,4),(51552486,425259742,15205290,370566,1,'2008-05-09 02:14:23',3310491492,3),(51552489,425261925,15204659,370566,1,'2008-05-09 02:14:24',3310491493,3),(51552492,425262708,15204389,370566,1,'2008-05-09 02:14:24',3310491493,3),(51552495,425263814,15203876,370566,1,'2008-05-09 02:14:24',3310491493,3),(51552497,425264815,15203452,370566,1,'2008-05-09 02:14:24',3310491493,3),(51552500,425265612,15203143,370566,1,'2008-05-09 02:14:24',3310491493,3),(51552504,425192225,15238275,461502,1,'2008-05-16 18:44:01',3310491490,2),(51552507,425275421,15203690,435967,1,'2007-09-15 21:59:37',3310491493,1),(51552509,425278761,15205568,435967,1,'2007-09-15 21:59:37',3310491493,1),(51552513,425282326,15207433,432736,1,'2007-09-15 01:37:50',3310491493,1),(51552516,425287981,15207617,432736,1,'2007-09-15 01:37:50',3310491504,1),(51552518,425292642,15206485,432736,1,'2007-09-15 01:37:50',3310491504,1),(51552546,425295024,15204854,432736,1,'2007-09-15 01:37:53',3310491504,1),(51552549,425296786,15203287,432736,1,'2007-09-15 01:37:54',3310491504,1),(51552550,425299234,15201395,432736,1,'2007-09-15 01:37:54',3310491504,1),(51552553,425301453,15199959,432736,1,'2007-09-15 01:37:54',3310491504,1),(51552555,425303998,15199176,432736,1,'2007-09-15 01:37:54',3310491504,1),(51552557,425306869,15198980,432736,1,'2007-09-15 01:37:54',3310491504,1),(51552559,425309937,15198915,432736,1,'2007-09-15 01:37:55',3310491504,1),(51552562,425311960,15198197,432736,1,'2007-09-15 01:37:55',3310491504,1),(51552565,425314570,15196109,432736,1,'2007-09-15 01:37:55',3310491504,1),(51552569,425317507,15195325,432736,1,'2007-09-15 01:37:55',3310491505,1),(51552572,425320749,15195933,432736,1,'2007-09-15 01:37:56',3310491505,1),(51552575,425325791,15197585,432736,1,'2007-09-15 01:37:56',3310491505,1),(51552578,425333039,15194999,174860,1,'2008-12-06 16:19:27',3310491505,2),(51552581,425335664,15193760,174860,1,'2008-12-06 16:19:27',3310491505,2),(51552583,425339370,15193578,174860,1,'2008-12-06 16:19:27',3310491505,2),(51552587,425342646,15195034,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552589,425297692,15185080,432736,1,'2007-09-15 01:37:57',3310491504,1),(51552592,425300993,15197225,432736,1,'2007-09-15 01:37:57',3310491504,1),(51552595,425341214,15194076,174860,1,'2008-12-06 16:19:27',3310491505,2),(51552599,425337486,15193436,174860,1,'2008-12-06 16:19:27',3310491505,2),(51552602,425327765,15197347,210114,1,'2008-08-12 23:32:51',3310491505,3),(51552605,425331367,15195879,174860,1,'2008-12-06 16:19:27',3310491505,2),(51552608,425323729,15197335,432736,1,'2007-09-15 01:37:58',3310491505,1),(51552612,425345476,15197722,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552615,425348423,15200579,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552619,425352122,15204756,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552622,425355525,15209011,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552625,425358733,15212789,174860,1,'2008-12-06 16:19:27',3310491508,3),(51552628,425359568,15212579,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552630,425360923,15211780,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552633,425361408,15210760,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552635,425363346,15207441,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552637,425365396,15205062,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552640,425368307,15202130,174860,1,'2008-12-06 16:19:27',3310491508,3),(51552643,425372987,15200070,174860,1,'2008-12-06 16:19:27',3310491509,3),(51552645,425378919,15197927,174860,1,'2008-12-06 16:19:27',3310491509,2),(51552648,425384398,15195975,174860,1,'2008-12-06 16:19:27',3310491509,2),(51552651,425390003,15194085,448710,1,'2008-05-14 17:04:23',3310491509,2),(51552653,425392021,15193528,174860,1,'2008-12-06 16:19:27',3310491509,2),(51552656,425356645,15211072,174860,1,'2008-12-06 16:19:27',3310491508,3),(51552659,425353966,15206879,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552660,425362169,15209390,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552664,425357531,15212274,174860,1,'2008-12-06 16:19:27',3310491508,3),(51552667,425366410,15203760,174860,1,'2008-12-06 16:19:27',3310491508,3),(51552671,425344861,15197138,174860,1,'2008-12-06 16:19:27',3310491508,2),(51552672,425397569,15192394,174860,1,'2008-12-06 16:19:27',3310502432,2),(51552675,425399694,15193183,174860,1,'2008-12-06 16:19:27',3310502432,2),(51552679,425402306,15194884,174860,1,'2008-12-06 16:19:27',3310502432,2),(51552682,425404674,15195491,174860,1,'2008-12-06 16:19:28',3310502432,2),(51552686,425406617,15195491,174860,1,'2008-12-06 16:19:28',3310502432,2),(51552688,425408986,15194580,174860,1,'2008-12-06 16:19:28',3310502432,2),(51552691,425410504,15192819,174860,1,'2008-12-06 16:19:28',3310502432,2),(51552693,425412387,15189054,174860,1,'2008-12-06 16:19:28',3310502432,2),(51552694,425414755,15184256,174860,1,'2008-12-06 16:19:28',3310502432,2),(51552699,425417084,15179091,174860,1,'2008-12-06 16:19:28',3310502432,2),(51552702,425418890,15177028,174860,1,'2008-12-06 16:19:28',3310502432,2),(51552705,425421262,15175222,174860,1,'2008-12-06 16:19:28',3310502432,2),(51552707,425428071,15171663,174860,1,'2008-12-06 16:19:28',3310502433,2),(51552709,425431887,15169910,174860,1,'2008-12-06 16:19:28',3310502433,2),(51552710,425433900,15167802,174860,1,'2008-12-06 16:19:28',3310502433,2),(51552711,425436391,15164544,174860,1,'2008-12-06 16:19:28',3310502433,3),(51552712,425440033,15160423,174860,1,'2008-12-06 16:19:28',3310502411,2),(51552715,425443099,15157356,174860,1,'2008-12-06 16:19:28',3310502411,2),(51552717,425446549,15154865,174860,1,'2008-12-06 16:19:28',3310502411,2),(51552720,425450191,15152660,174860,1,'2008-12-06 16:19:28',3310502411,2),(51552722,425453449,15151223,174860,1,'2008-12-06 16:19:28',3310502414,2),(51552723,425455366,15149786,174860,1,'2008-12-06 16:19:28',3310502414,2),(51552726,425456420,15147102,174860,1,'2008-12-06 16:19:28',3310502414,2),(51552727,425457187,15144802,174860,1,'2008-12-06 16:19:29',3310502414,2),(51552728,425460061,15140969,174860,1,'2008-12-06 16:19:29',3310502414,2),(51552731,425462656,15140044,174860,1,'2008-12-06 16:19:29',3310502414,2),(51552733,425465321,15139381,174860,1,'2008-12-06 16:19:29',3310502414,2),(51552736,425469214,15136948,432736,1,'2007-09-15 02:31:16',3310502414,1),(51552737,425471370,15135794,432736,1,'2007-09-15 01:38:10',3310502414,1),(51552740,425474743,15133705,432736,1,'2007-09-15 01:38:10',3310502414,1),(51552744,425476697,15134152,306164,1,'2008-05-01 17:04:02',3310502414,7),(51552747,425478423,15133628,432736,1,'2007-09-15 01:38:10',3310502414,1),(51552750,425481183,15132632,432736,1,'2007-09-15 01:38:11',3310502415,1),(51552755,425484786,15130102,432736,1,'2007-09-15 01:38:11',3310502415,1),(51552758,425491992,15123432,432736,1,'2007-09-15 01:38:11',3310502415,1),(51552761,425499921,15116558,306164,1,'2008-05-01 17:19:32',3310502415,2),(51552762,425508331,15105915,306164,1,'2008-05-01 17:19:32',3310502424,2),(51552764,425515989,15094683,432736,1,'2007-09-15 01:38:13',3310502424,1),(51552766,425519362,15089469,432736,1,'2007-09-15 01:38:14',3310502424,1),(51552768,425526415,15081803,432736,1,'2007-09-15 01:38:14',3310502424,1),(51552770,425529175,15078046,432736,1,'2007-09-15 01:38:15',3310502424,1),(51552773,425532699,15074437,432736,1,'2007-09-15 01:38:15',3310502424,1),(51552774,425536515,15070145,432736,1,'2007-09-15 01:38:15',3310502425,1),(51552777,425540012,15068078,432736,1,'2007-09-15 01:38:16',3310502425,1),(51552779,425543668,15066489,432736,1,'2007-09-15 01:38:16',3310502425,1),(51552782,425548756,15065853,432736,1,'2007-09-15 01:38:17',3310502425,1),(51552785,425552571,15064422,432736,1,'2007-09-15 01:38:17',3310502425,1),(51552787,425555591,15061719,432736,1,'2007-09-15 01:38:17',3310502425,1),(51552789,425560520,15058063,432736,1,'2007-09-15 01:38:17',3310502425,1),(51552791,425564812,15055361,432736,1,'2007-09-15 01:38:17',3310502428,1),(51552793,425566719,15052499,432736,1,'2007-09-15 01:38:18',3310502428,1),(51552797,425570535,15049479,432736,1,'2007-09-15 01:38:18',3310502422,1),(51552800,425573555,15047730,432736,1,'2007-09-15 01:38:18',3310502422,1),(51552802,425578642,15047412,432736,1,'2007-09-15 01:38:18',3310502422,1),(51552806,425584365,15047253,432736,1,'2007-09-15 01:38:19',3310502422,1),(51552807,425586909,15046776,432736,1,'2007-09-15 01:38:19',3310502422,1),(51552811,425588181,15045504,432736,1,'2007-09-15 01:38:19',3310502422,1),(51552814,425589875,15043383,432736,1,'2007-09-15 01:38:19',3310502423,1),(51552815,425593217,15039333,432736,1,'2007-09-15 01:38:19',3310502423,1),(51552818,425596862,15035788,432736,1,'2007-09-15 01:38:20',3310502423,1),(51552821,425600508,15032446,432736,1,'2007-09-15 01:38:20',3310502423,1),(51552823,425603343,15028902,432736,1,'2007-09-15 01:38:20',3310502423,1),(51552824,425605571,15026168,432736,1,'2007-09-15 01:38:20',3310502423,1),(51552825,425607394,15024345,432736,1,'2007-09-15 01:38:20',3310502423,1),(51552828,425610027,15022927,432736,1,'2007-09-15 01:38:20',3310502423,1),(51552830,425612458,15021712,432736,1,'2007-09-15 01:38:21',3310502423,1),(51552832,425613571,15019990,432736,1,'2007-09-15 01:38:21',3310502423,1),(51552835,425614078,15018370,432736,1,'2007-09-15 01:38:21',3310502423,1),(51552838,425613977,15016446,432736,1,'2007-09-15 01:38:21',3310502423,1),(51552841,425613774,15014320,432736,1,'2007-09-15 01:38:21',3310502423,1),(51552844,425613875,15012193,432736,1,'2007-09-15 01:38:21',3310502423,1),(51552847,425614382,15010066,432736,1,'2007-09-15 01:38:22',3310502423,1),(51552849,425615090,15008446,432736,1,'2007-09-15 01:38:22',3310502423,1),(51552851,425616508,15005104,432736,1,'2007-09-15 01:38:22',3310502423,1),(51552852,425617116,15002674,432736,1,'2007-09-15 01:38:22',3310502466,1),(51552854,425617318,14999433,432736,1,'2007-09-15 01:38:22',3310502466,1),(51552856,425616913,14992648,432736,1,'2007-09-15 01:38:22',3310502464,1),(51552859,425616103,14987889,432736,1,'2007-09-15 01:38:22',3310502421,1),(51552861,425615394,14984243,432736,1,'2007-09-15 01:38:23',3310502421,1),(51552863,425614787,14979484,432736,1,'2007-09-15 01:38:23',3310502421,1),(51552865,425614685,14976446,432736,1,'2007-09-15 01:38:23',3310502421,1),(51552868,425614709,14973998,432736,1,'2007-09-15 01:38:23',3310502421,1),(51552871,425614709,14972772,432736,1,'2007-09-15 01:38:23',3310502421,1),(51552873,425614787,14971490,432736,1,'2007-09-15 01:38:23',3310502421,1),(51552875,425614811,14966812,432736,1,'2007-09-15 01:41:47',3310502421,1),(51554685,425615950,14965540,432736,1,'2007-09-15 01:41:44',3310502421,1),(51554688,425615701,14965073,432736,1,'2007-09-15 01:41:44',3310502421,1),(51554691,425615355,14964827,432736,1,'2007-09-15 01:41:44',3310502421,1),(51554693,425614978,14964740,432736,1,'2007-09-15 01:41:44',3310502421,1),(51554694,425614598,14964796,432736,1,'2007-09-15 01:41:44',3310502421,1),(51554697,425614240,14965008,432736,1,'2007-09-15 01:41:44',3310502421,1),(51554700,425613989,14965352,432736,1,'2007-09-15 01:41:44',3310502421,1),(51554703,425613900,14965846,432736,1,'2007-09-15 01:41:44',3310502421,1),(51554705,425614040,14966305,432736,1,'2007-09-15 01:41:44',3310502421,1),(51554707,425614430,14966687,432736,1,'2007-09-15 01:41:45',3310502421,1),(51554710,425615160,14966796,432736,1,'2007-09-15 01:41:45',3310502421,1),(51554712,425615502,14966653,432736,1,'2007-09-15 01:41:45',3310502421,1),(51554715,425615734,14966448,432736,1,'2007-09-15 01:41:45',3310502421,1),(51554716,425615933,14966083,432736,1,'2007-09-15 01:41:45',3310502421,1),(51557999,425613611,14965020,370566,1,'2008-05-09 02:14:23',3310502421,2),(51558001,425612892,14964653,370566,1,'2008-05-09 02:14:23',3310502421,2),(51558003,425611587,14963476,432736,1,'2007-09-15 01:47:01',3310502421,1),(51558005,425610666,14962303,432736,1,'2007-09-15 01:47:01',3310502421,1),(51558007,425609681,14960502,432736,1,'2007-09-15 01:47:02',3310502421,1),(51558010,425608550,14958910,432736,1,'2007-09-15 01:47:02',3310502421,1),(51558014,425607712,14957695,432736,1,'2007-09-15 01:47:02',3310502421,1),(51558017,425606518,14956208,432736,1,'2007-09-15 01:47:02',3310502421,1),(51558021,425605345,14954846,432736,1,'2007-09-15 01:47:03',3310502421,1),(51558024,425604738,14953841,432736,1,'2007-09-15 01:47:03',3310502421,1),(51558026,425604319,14952730,432736,1,'2007-09-15 01:47:03',3310502421,1),(51558029,425602915,14950322,432736,1,'2007-09-15 01:47:04',3310502421,1),(51558031,425601282,14947960,432736,1,'2007-09-15 01:47:04',3310502421,1),(51558033,425599834,14946223,432736,1,'2007-09-15 01:47:04',3310502421,1),(51558036,425598314,14944413,432736,1,'2007-09-15 01:47:04',3310502421,1),(51558038,425597445,14943472,432736,1,'2007-09-15 01:47:05',3310502421,1),(51558040,425595563,14941481,432736,1,'2007-09-15 01:47:05',3310502079,1),(51558041,425594622,14941300,432736,1,'2007-09-15 01:47:05',3310502079,1),(51558043,425592052,14940830,432736,1,'2007-09-15 01:47:05',3310502079,1),(51558045,425590749,14940250,432736,1,'2007-09-15 01:47:05',3310502079,1),(51558047,425588794,14939527,432736,1,'2007-09-15 01:47:05',3310502078,1),(51558051,425585038,14937175,432736,1,'2007-09-15 01:47:05',3310502078,1),(51558054,425583837,14936095,432736,1,'2007-09-15 01:47:06',3310502078,1),(51558057,425580133,14934280,432736,1,'2007-09-15 01:47:06',3310502078,1),(51558059,425576994,14932907,432736,1,'2007-09-15 01:47:06',3310502078,1),(51558060,425575596,14932343,432736,1,'2007-09-15 01:47:07',3310502078,1),(51558063,425574345,14931607,432736,1,'2007-09-15 01:47:07',3310502078,1),(51558064,425573241,14930405,432736,1,'2007-09-15 01:47:08',3310502078,1),(51558067,425571917,14929203,432736,1,'2007-09-15 01:47:08',3310502078,1),(51558070,425569683,14927373,432736,1,'2007-09-15 01:47:09',3310502078,1),(51558071,425566632,14924932,432736,1,'2007-09-15 01:47:09',3310502078,1),(51558074,425563763,14922979,432736,1,'2007-09-15 01:47:10',3310502078,1),(51558075,425562237,14921453,432736,1,'2007-09-15 01:47:11',3310502078,1),(51558078,425561139,14919744,432736,1,'2007-09-15 01:47:11',3310502075,1),(51558083,425559857,14917425,432736,1,'2007-09-15 01:47:14',3310502075,1),(51558085,425558515,14915960,432736,1,'2007-09-15 01:47:15',3310502075,1),(51558086,425557050,14914068,432736,1,'2007-09-15 01:47:15',3310502075,1),(51558089,425554731,14912543,432736,1,'2007-09-15 01:47:16',3310502075,1),(51558091,425552534,14911688,432736,1,'2007-09-15 01:47:16',3310502075,1),(51558093,425551191,14910773,432736,1,'2007-09-15 01:47:16',3310502075,1),(51558095,425550520,14909552,432736,1,'2007-09-15 01:47:17',3310502075,1),(51558097,425549543,14908087,432736,1,'2007-09-15 01:47:17',3310502075,1),(51558099,425548750,14906806,432736,1,'2007-09-15 01:47:17',3310502075,1),(51558103,425547590,14905829,432736,1,'2007-09-15 01:47:17',3310502075,1),(51558105,425545454,14904853,432736,1,'2007-09-15 01:47:18',3310502075,1),(51558108,425543074,14903266,432736,1,'2007-09-15 01:47:18',3310502075,1),(51558111,425539290,14900703,432736,1,'2007-09-15 01:47:18',3310502075,1),(51558113,425536727,14898140,432736,1,'2007-09-15 01:47:18',3310502075,1),(51558115,425535811,14895698,432736,1,'2007-09-15 01:47:19',3310502075,1),(51558118,425535201,14892464,432736,1,'2007-09-15 01:47:19',3310502075,1),(51558121,425535018,14888680,432736,1,'2007-09-15 01:47:19',3310502075,1),(51558124,425534896,14884286,432736,1,'2007-09-15 01:47:19',3310502073,1),(51558125,425534896,14881234,432736,1,'2007-09-15 01:47:20',3310502073,1),(51558128,425534041,14878976,432736,1,'2007-09-15 01:47:20',3310502072,1),(51558131,425532150,14876291,432736,1,'2007-09-15 01:47:20',3310502072,1),(51558246,425530380,14874033,432736,1,'2007-09-15 01:47:38',3310502072,1),(51558248,425528488,14871225,432736,1,'2007-09-15 01:47:38',3310502072,1),(51558253,425527206,14869638,432736,1,'2007-09-15 01:47:39',3310502072,1),(51558257,425525924,14868967,432736,1,'2007-09-15 01:47:39',3310502072,1),(51558260,425524643,14869089,432736,1,'2007-09-15 01:47:39',3310502072,1),(51558262,425523300,14869699,432736,1,'2007-09-15 01:47:39',3310502072,1),(51558265,425520432,14871652,432736,1,'2007-09-15 01:47:39',3310502072,1),(51558268,425518479,14873117,432736,1,'2007-09-15 01:47:39',3310502072,1),(51558271,425516404,14874033,432736,1,'2007-09-15 01:47:39',3310502072,1),(51558273,425513535,14874826,432736,1,'2007-09-15 01:47:40',3310502072,1),(51558276,425510850,14875863,432736,1,'2007-09-15 01:47:40',3310502072,1),(51558279,425507982,14876474,432736,1,'2007-09-15 01:47:40',3310502072,1),(51558282,425505968,14877450,432736,1,'2007-09-15 01:47:40',3310502061,1),(51558284,425503832,14878793,432736,1,'2007-09-15 01:47:40',3310502061,1),(51558287,425502001,14879830,432736,1,'2007-09-15 01:47:41',3310502061,1),(51558293,425499376,14878854,432736,1,'2007-09-15 01:47:41',3310502061,1),(51558295,425498034,14876779,432736,1,'2007-09-15 01:47:41',3310502061,1),(51558298,425496935,14875192,432736,1,'2007-09-15 01:47:41',3310502061,1),(51558301,425495348,14873727,432736,1,'2007-09-15 01:47:41',3310502061,1),(51558304,425493639,14873422,432736,1,'2007-09-15 01:47:41',3310502061,1),(51558305,425491809,14873300,432736,1,'2007-09-15 01:47:42',3310502061,1),(51563059,425490386,14873969,432736,1,'2007-09-15 01:56:05',3310502061,1),(51563061,425489160,14874402,432736,1,'2007-09-15 01:56:05',3310502061,1),(51563063,425487862,14874402,432736,1,'2007-09-15 01:56:05',3310502061,1),(51563066,425485843,14874041,432736,1,'2007-09-15 01:56:05',3310502061,1),(51563071,425483968,14873392,432736,1,'2007-09-15 01:56:05',3310502061,1),(51563075,425481877,14872491,432736,1,'2007-09-15 01:56:05',3310502061,1),(51563076,425480795,14871589,432736,1,'2007-09-15 01:56:06',3310502061,1),(51563080,425479641,14869714,432736,1,'2007-09-15 01:56:06',3310502061,1),(51563083,425478740,14867587,432736,1,'2007-09-15 01:56:06',3310502060,1),(51563087,425477838,14864414,432736,1,'2007-09-15 01:56:06',3310502060,1),(51563090,425477442,14862431,432736,1,'2007-09-15 01:56:06',3310502060,1),(51563094,425477622,14859402,432736,1,'2007-09-15 01:56:06',3310502060,1),(51563098,425477910,14854535,432736,1,'2007-09-15 01:56:06',3310502060,1),(51563100,425478631,14852444,432736,1,'2007-09-15 01:56:07',3310502060,1),(51563103,425480388,14848465,432736,1,'2007-09-15 01:56:07',3310502061,1),(51563105,425482107,14845400,432736,1,'2007-09-15 01:56:07',3310502061,1),(51563108,425482930,14843381,432736,1,'2007-09-15 01:56:08',3310502061,1),(51563110,425482930,14841811,432736,1,'2007-09-15 01:56:08',3310502061,1),(51563113,425482332,14841362,432736,1,'2007-09-15 01:56:08',3310502061,1),(51563115,425481509,14841362,432736,1,'2007-09-15 01:56:08',3310502061,1),(51563118,425480462,14842035,432736,1,'2007-09-15 01:56:08',3310502061,1),(51563120,425479191,14843904,432736,1,'2007-09-15 01:56:08',3310502060,1),(51563122,425476948,14847717,432736,1,'2007-09-15 01:56:09',3310502060,1),(51563124,425474107,14852577,432736,1,'2007-09-15 01:56:09',3310502060,1),(51563127,425472238,14855792,432736,1,'2007-09-15 01:56:09',3310502060,1),(51563130,425471117,14855942,432736,1,'2007-09-15 01:56:09',3310502060,1),(51563134,425470220,14855493,432736,1,'2007-09-15 01:56:10',3310502060,1),(51563137,425469696,14853773,432736,1,'2007-09-15 01:56:10',3310502060,1),(51563140,425468724,14851306,432736,1,'2007-09-15 01:56:10',3310502060,1),(51563141,425467378,14848465,432736,1,'2007-09-15 01:56:10',3310502060,1),(51563145,425465584,14845998,432736,1,'2007-09-15 01:56:10',3310502060,1),(51563148,425462369,14843306,432736,1,'2007-09-15 01:56:11',3310502060,1),(51563152,425457808,14838073,432736,1,'2007-09-15 01:56:11',3310502060,1),(51563155,425455823,14835251,432736,1,'2007-09-15 01:56:11',3310502060,1),(51563159,425454700,14833228,432736,1,'2007-09-15 01:56:11',3310502060,1),(51563162,425453666,14830576,432736,1,'2007-09-15 01:56:11',3310502054,1),(51563164,425452947,14828329,432736,1,'2007-09-15 01:56:12',3310502054,1),(51563168,425452003,14826666,432736,1,'2007-09-15 01:56:12',3310502051,1),(51563170,425448767,14822666,432736,1,'2007-09-15 01:56:12',3310502051,1),(51563173,425445531,14818531,432736,1,'2007-09-15 01:56:12',3310502051,1),(51563176,425442136,14814890,432736,1,'2007-09-15 01:56:12',3310502051,1),(51563177,425439620,14812374,432736,1,'2007-09-15 01:56:12',3310502051,1),(51563179,425437667,14809702,432736,1,'2007-09-15 01:56:13',3310502051,1),(51563181,425437178,14808114,432736,1,'2007-09-15 01:56:13',3310502051,1),(51563185,425436751,14805915,432736,1,'2007-09-15 01:56:13',3310502051,1),(51563189,425436873,14803411,432736,1,'2007-09-15 01:56:13',3310502051,1),(51563192,425436995,14801548,432736,1,'2007-09-15 01:56:13',3310502051,1),(51563195,425436781,14799868,432736,1,'2007-09-15 01:56:13',3310502051,1),(51563197,425436415,14797517,432736,1,'2007-09-15 01:56:14',3310502051,1),(51563199,425436730,14795307,432736,1,'2007-09-15 01:56:14',3310502051,1),(51563200,425437489,14793027,432736,1,'2007-09-15 01:56:14',3310502051,1),(51563202,425439009,14789988,432736,1,'2007-09-15 01:56:15',3310502051,1),(51563205,425441289,14786340,432736,1,'2007-09-15 01:56:15',3310502051,1),(51563210,425444557,14782008,432736,1,'2007-09-15 01:56:15',3310502051,1),(51563214,425448356,14777905,432736,1,'2007-09-15 01:56:15',3310502051,1),(51563216,425451624,14773649,432736,1,'2007-09-15 01:56:16',3310502049,1),(51563224,425453220,14771217,432736,1,'2007-09-15 01:56:16',3310502052,1),(51563226,425454360,14768862,432736,1,'2007-09-15 01:56:17',3310502052,1),(51563230,425455044,14766582,432736,1,'2007-09-15 01:56:17',3310502052,1),(51563233,425455348,14763466,432736,1,'2007-09-15 01:56:17',3310502052,1),(51563236,425455272,14755791,432736,1,'2007-09-15 01:56:18',3310502052,1),(51563238,425455576,14751687,432736,1,'2007-09-15 01:56:18',3310502052,1),(51563242,425455804,14749180,432736,1,'2007-09-15 01:56:18',3310502052,1),(51563244,425455652,14748040,432736,1,'2007-09-15 01:56:18',3310502052,1),(51563247,425454968,14747204,432736,1,'2007-09-15 01:56:18',3310502052,1),(51563252,425453980,14746976,432736,1,'2007-09-15 01:56:18',3310502052,1),(51563255,425452992,14747356,432736,1,'2007-09-15 01:56:18',3310502052,1),(51563257,425452688,14748344,432736,1,'2007-09-15 01:56:18',3310502052,1),(51563261,425451776,14753131,432736,1,'2007-09-15 01:56:18',3310502049,1),(51563266,425450712,14756627,432736,1,'2007-09-15 01:56:19',3310502049,1),(51563268,425449876,14758755,432736,1,'2007-09-15 01:56:19',3310502049,1),(51563272,425449192,14759439,432736,1,'2007-09-15 01:56:19',3310502049,1),(51563276,425448432,14759439,432736,1,'2007-09-15 01:56:19',3310502049,1),(51563279,425447930,14758608,454632,1,'2007-09-18 01:05:24',3310502049,1),(51563281,425447293,14756095,454632,1,'2007-09-18 01:05:25',3310502049,1),(51563284,425445936,14753584,454632,1,'2007-09-18 01:05:25',3310502049,1),(51563374,425445623,14752524,454632,1,'2007-09-18 01:05:23',3310502049,1),(51563375,425446179,14750887,454632,1,'2007-09-18 01:05:24',3310502049,1),(51563437,425447639,14749147,454632,1,'2007-09-18 01:05:26',3310502049,1),(51563439,425448635,14747165,454632,1,'2007-09-18 01:05:26',3310502049,1),(51563440,425448727,14744889,454632,1,'2007-09-18 01:05:27',3310502049,1),(51563441,425447927,14741960,454632,1,'2007-09-18 01:05:27',3310502049,1),(51563442,425447087,14739832,454632,1,'2007-09-18 01:05:27',3310502049,1),(51563443,425445697,14736641,432736,1,'2007-09-15 01:56:37',3310502049,1),(51563447,425444537,14733981,454632,1,'2007-09-18 01:05:28',3310502049,1),(51563450,425443797,14730257,432736,1,'2007-09-15 01:56:37',3310502049,1),(51563451,425443265,14725318,432736,1,'2007-09-15 01:56:37',3310502049,1),(51563453,425443341,14720454,432736,1,'2007-09-15 01:56:37',3310502027,1),(51563454,425443265,14716503,432736,1,'2007-09-15 01:56:38',3310502027,1),(51563456,425443417,14713615,432736,1,'2007-09-15 01:56:38',3310502027,1),(51563458,425443949,14710727,432736,1,'2007-09-15 01:56:38',3310502027,1),(51563460,425445241,14707080,432736,1,'2007-09-15 01:56:38',3310502027,1),(51563462,425445317,14706320,432736,1,'2007-09-15 01:56:38',3310502027,1),(51563463,425444937,14705940,432736,1,'2007-09-15 01:56:39',3310502027,1),(51563466,425444025,14706168,432736,1,'2007-09-15 01:56:39',3310502027,1),(51563470,425442505,14710575,432736,1,'2007-09-15 01:56:39',3310502027,1),(51563472,425440073,14718783,432736,1,'2007-09-15 01:56:39',3310502027,1),(51563474,425438705,14722430,432736,1,'2007-09-15 01:56:39',3310502049,1),(51563477,425438303,14723457,454632,1,'2007-09-18 01:05:25',3310502049,1),(51563480,425437624,14723636,454632,1,'2007-09-18 01:05:25',3310502049,1),(51563481,425436585,14722602,454632,1,'2007-09-18 01:05:26',3310502049,1),(51563484,425435058,14719922,432736,1,'2007-09-15 01:56:40',3310502027,1),(51563485,425433462,14715971,432736,1,'2007-09-15 01:56:40',3310502027,1),(51563488,425430498,14712095,432736,1,'2007-09-15 01:56:40',3310502027,1),(51563490,425427154,14708068,432736,1,'2007-09-15 01:56:40',3310502027,1),(51563492,425424799,14705940,432736,1,'2007-09-15 01:56:40',3310502027,1),(51563494,425422731,14704068,454632,1,'2007-09-18 01:05:26',3310502026,1),(51563496,425420619,14701000,432736,1,'2007-09-15 01:56:41',3310502026,1),(51563499,425417579,14696897,432736,1,'2007-09-15 01:56:41',3310502026,1),(51581574,425470132,15141850,183661,1,'2008-04-18 18:23:07',3310502414,3),(51581577,425470921,15143853,432736,1,'2007-09-15 02:29:01',3310502414,1),(51581580,425471103,15147070,432736,1,'2007-09-15 02:29:01',3310502414,1),(51581582,425469343,15151986,432736,1,'2007-09-15 02:29:01',3310502414,1),(51581587,425464002,15161091,432736,1,'2007-09-15 02:29:01',3310502414,1),(51581590,425461756,15165279,432736,1,'2007-09-15 02:29:02',3310502436,1),(51581593,425460421,15168010,432736,1,'2007-09-15 02:29:02',3310502436,1),(51581596,425458357,15170195,432736,1,'2007-09-15 02:29:02',3310502436,1),(51581598,425456597,15172259,432736,1,'2007-09-15 02:29:02',3310502436,1),(51581602,425455687,15174565,432736,1,'2007-09-15 02:29:03',3310502436,1),(51581607,425455019,15178510,432736,1,'2007-09-15 02:29:03',3310502436,1),(51581611,425454291,15182334,432736,1,'2007-09-15 02:29:03',3310502436,1),(51581613,425454169,15190103,432736,1,'2007-09-15 02:29:03',3310502436,1),(51581617,425454898,15195141,432736,1,'2007-09-15 02:29:03',3310502436,1),(51581620,425456476,15201332,432736,1,'2007-09-15 02:29:04',3310502436,1),(51581622,425458789,15205416,501202,1,'2008-05-22 22:30:34',3310502436,2),(51581625,425460603,15208312,432736,1,'2007-09-15 02:29:04',3310502436,1),(51581628,425463516,15212135,432736,1,'2007-09-15 02:29:04',3310502436,1),(51581633,425473080,15216230,498434,1,'2008-05-22 19:58:22',3310502436,3),(51581643,425475546,15217346,498434,1,'2008-05-22 19:53:32',3310502438,2),(51581645,425478690,15218508,432736,1,'2007-09-15 02:29:05',3310502438,1),(51581650,425483607,15223789,432736,1,'2007-09-15 02:29:06',3310502439,1),(51581654,425485852,15226217,432736,1,'2007-09-15 02:29:06',3310502439,1),(51581657,425488280,15228766,432736,1,'2007-09-15 02:29:06',3310502439,1),(51581661,425490587,15232286,432736,1,'2007-09-15 02:29:06',3310502439,1),(51581663,425491558,15235564,432736,1,'2007-09-15 02:29:06',3310502439,1),(51581667,425492347,15239691,432736,1,'2007-09-15 02:29:07',3310502439,1),(51581670,425494228,15244668,432736,1,'2007-09-15 02:29:07',3310502439,1),(51581675,425496717,15248735,4804396,1,'2010-05-25 17:58:16',3310502439,2),(51581679,425467065,15138495,174860,1,'2008-12-06 16:19:29',3310502414,2),(51581686,425499422,15254440,725665,1,'2009-03-02 22:17:22',3310502439,5),(51581690,425502895,15259401,725665,1,'2009-03-02 22:17:22',3310502439,5),(51581692,425505871,15261386,725665,1,'2009-03-02 22:17:22',3310502439,5),(51581695,425509415,15262803,725665,1,'2009-03-02 22:17:22',3310502450,5),(51581699,425515499,15263968,725665,1,'2009-03-02 22:29:56',3310502450,17),(51581702,425517832,15264320,725665,1,'2009-03-02 22:29:56',3310502450,11),(51581705,425519975,15266205,725665,1,'2009-03-02 22:29:56',3310502450,11),(51581708,425523944,15271379,725665,1,'2009-03-02 22:29:54',3310502456,11),(51581711,425526637,15275135,725665,1,'2009-03-02 22:29:54',3310502456,11),(51581715,425530677,15279742,725665,1,'2009-03-02 22:29:54',3310502456,11),(51581724,425542387,15289732,725665,1,'2009-03-02 22:27:38',3310502457,13),(51581727,425547120,15293562,725665,1,'2009-03-02 22:27:38',3310502457,12),(51581729,425550167,15298877,725665,1,'2009-03-02 22:27:38',3310502457,12),(51581732,425550805,15299941,725665,1,'2009-03-02 22:27:39',3310502457,12),(51581737,425552718,15304760,725665,1,'2009-03-02 22:27:39',3310502457,12),(51581739,425554175,15307955,725665,1,'2009-03-02 22:27:40',3310502457,12),(51581743,425555969,15312333,725665,1,'2009-03-02 22:27:41',3310502457,14),(51581745,425556791,15316195,725665,1,'2009-03-02 22:27:41',3310502457,14),(51581748,425556791,15320916,725665,1,'2009-03-02 22:27:41',3310502457,14),(51581751,425556814,15328970,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51581754,425556779,15329603,1684788,1,'2009-06-30 11:19:38',3310502459,3),(51581757,425556649,15329884,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51581759,425556393,15330134,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51581762,425555947,15330198,1684788,1,'2009-06-30 11:19:38',3310502459,4),(51581766,425555555,15329902,1684788,1,'2009-06-30 11:19:38',3310502459,3),(51581769,425555444,15329694,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51581772,425555355,15329212,1684788,1,'2009-06-30 11:19:38',3310502459,3),(51581776,425555573,15328506,1684788,1,'2009-06-30 11:19:38',3310502459,3),(51581778,425555693,15328375,1684788,1,'2009-06-30 11:19:39',3310502459,5),(51581782,425556376,15328289,1684788,1,'2009-06-30 11:19:39',3310502459,15),(51581783,425556737,15328714,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51581786,425558133,15329365,432736,1,'2007-09-15 02:29:15',3310502459,1),(51581788,425557504,15329452,432736,1,'2007-09-15 02:29:15',3310502459,1),(51581791,425556831,15329335,1684788,1,'2009-06-30 11:19:38',3310502459,3),(51581795,425559126,15328531,615859,1,'2008-07-28 13:58:34',3310502459,2),(51581796,425559856,15327943,432736,1,'2007-09-15 02:29:16',3310502459,1),(51581799,425561199,15327227,432736,1,'2007-09-15 02:29:16',3310502459,1),(51581803,425562871,15326571,432736,1,'2007-09-15 02:29:16',3310502462,1),(51581807,425565221,15326355,432736,1,'2007-09-15 02:29:17',3310502462,1),(51581810,425569705,15326046,432736,1,'2007-09-15 02:29:17',3310502460,1),(51581813,425573292,15325303,432736,1,'2007-09-15 02:29:17',3310502460,1),(51581814,425581843,15325544,432736,1,'2007-09-15 02:29:17',3310502460,1),(51581818,425585075,15324929,432736,1,'2007-09-15 02:29:18',3310502460,1),(51581821,425587614,15323698,432736,1,'2007-09-15 02:29:18',3310502460,1),(51581823,425590153,15321543,432736,1,'2007-09-15 02:29:18',3310502461,1),(51581826,425593847,15318004,432736,1,'2007-09-15 02:29:18',3310502461,1),(51581828,425597925,15314387,432736,1,'2007-09-15 02:29:18',3310502461,1),(51581829,425601388,15312233,432736,1,'2007-09-15 02:29:18',3310502461,1),(51581832,425606004,15310155,432736,1,'2007-09-15 02:29:19',3310502461,1);
INSERT INTO `nodes` VALUES (51581835,425608544,15308001,432736,1,'2007-09-15 02:29:19',3310502461,1),(51581837,425610236,15305692,432736,1,'2007-09-15 02:29:19',3310502461,1),(51581840,425611852,15302691,432736,1,'2007-09-15 02:29:19',3310502461,1),(51581843,425613314,15299767,432736,1,'2007-09-15 02:29:20',3310502461,1),(51581846,425615161,15297459,432736,1,'2007-09-15 02:29:20',3310502461,1),(51581849,425617085,15295920,432736,1,'2007-09-15 02:29:20',3310502504,1),(51581852,425619393,15294612,432736,1,'2007-09-15 02:29:20',3310502504,1),(51581854,425621701,15293150,432736,1,'2007-09-15 02:29:20',3310502504,1),(51581857,425623933,15291149,432736,1,'2007-09-15 02:29:21',3310502504,1),(51581861,425625703,15288918,432736,1,'2007-09-15 02:29:21',3310502504,1),(51581863,425628019,15284841,498434,1,'2008-05-22 17:49:55',3310502504,2),(51581868,425630990,15279348,498434,1,'2008-05-22 17:49:55',3310502504,2),(51581874,425633203,15273168,498434,1,'2008-05-22 17:50:41',3310502504,2),(51581876,425635478,15266130,498434,1,'2008-05-22 17:50:41',3310502498,2),(51581877,425637501,15261495,498434,1,'2008-05-22 17:50:41',3310502498,2),(51581881,425639630,15257293,432736,1,'2007-09-15 02:29:23',3310502498,1),(51581883,425643016,15253215,432736,1,'2007-09-15 02:29:23',3310502498,1),(51581886,425646478,15248675,432736,1,'2007-09-15 02:29:23',3310502499,1),(51581888,425648633,15245751,432736,1,'2007-09-15 02:29:23',3310502499,1),(51581890,425654019,15242134,432736,1,'2007-09-15 02:29:23',3310502499,1),(51581895,425660559,15238056,432736,1,'2007-09-15 02:29:24',3310502499,1),(51581898,425667408,15234824,432736,1,'2007-09-15 02:29:24',3310502499,1),(51581902,425674179,15231516,432736,1,'2007-09-15 02:29:24',3310502502,1),(51581904,425676564,15228746,432736,1,'2007-09-15 02:29:24',3310502502,1),(51581906,425678642,15224129,432736,1,'2007-09-15 02:29:24',3310502502,1),(51581910,425682127,15219558,498434,1,'2008-05-22 17:32:10',3310502502,2),(51581912,425685857,15215696,498434,1,'2008-05-22 17:32:10',3310502500,2),(51581914,425688701,15212778,498434,1,'2008-05-22 17:32:10',3310502500,2),(51581916,425692492,15211048,432736,1,'2007-09-15 02:29:25',3310502500,1),(51581922,425697879,15210663,432736,1,'2007-09-15 02:29:26',3310502500,1),(51581923,425702572,15209894,432736,1,'2007-09-15 02:29:26',3310502501,1),(51581926,425706112,15209663,432736,1,'2007-09-15 02:29:26',3310502501,1),(51581928,425710113,15207970,432736,1,'2007-09-15 02:29:26',3310502501,1),(51581931,425713345,15205354,432736,1,'2007-09-15 02:29:26',3310502501,1),(51581932,425716961,15201968,432736,1,'2007-09-15 02:29:26',3310502501,1),(51581936,425719424,15197813,432736,1,'2007-09-15 02:29:27',3310502501,1),(51581939,425722117,15194273,432736,1,'2007-09-15 02:29:27',3310502501,1),(51581941,425725887,15190118,432736,1,'2007-09-15 02:29:27',3310502501,1),(51581944,425729965,15187502,432736,1,'2007-09-15 02:29:27',3310502512,1),(51581946,425736660,15184886,432736,1,'2007-09-15 02:29:27',3310502512,1),(51581951,425743200,15182578,432736,1,'2007-09-15 02:29:27',3310502512,1),(51581955,425749894,15180577,432736,1,'2007-09-15 02:29:28',3310502512,1),(51581958,425752741,15181270,432736,1,'2007-09-15 02:29:28',3310502512,1),(51581960,425755896,15184424,432736,1,'2007-09-15 02:29:28',3310502513,1),(51581962,425759091,15186665,440632,1,'2008-07-09 16:35:09',3310502513,2),(51581964,425761667,15187194,432736,1,'2007-09-15 02:29:29',3310502513,1),(51581967,425763745,15186271,432736,1,'2007-09-15 02:29:29',3310502513,1),(51581970,425764745,15183963,432736,1,'2007-09-15 02:29:29',3310502513,1),(51581973,425766977,15179884,432736,1,'2007-09-15 02:29:29',3310502513,1),(51581976,425769593,15174729,432736,1,'2007-09-15 02:29:30',3310502513,1),(51581979,425773209,15173190,432736,1,'2007-09-15 02:29:30',3310502513,1),(51581980,425775518,15174498,432736,1,'2007-09-15 02:29:30',3310502513,1),(51581983,425779057,15178730,432736,1,'2007-09-15 02:29:30',3310502513,1),(51581986,425780844,15180962,432736,1,'2007-09-15 02:29:30',3310502513,1),(51581990,425784602,15185299,432736,1,'2007-09-15 02:29:31',3310502516,1),(51581993,425787782,15187539,432736,1,'2007-09-15 02:29:31',3310502516,1),(51581995,425790167,15188479,432736,1,'2007-09-15 02:29:31',3310502516,1),(51581997,425795431,15187817,513066,1,'2008-05-24 16:28:02',3310502516,2),(51582003,425799539,15189362,513066,1,'2008-05-24 16:28:02',3310502516,2),(51582007,425802165,15191225,432736,1,'2007-09-15 02:29:32',3310502516,1),(51582009,425803972,15192237,432736,1,'2007-09-15 02:29:33',3310502516,1),(51582013,425806430,15193105,432736,1,'2007-09-15 02:29:33',3310502516,1),(51582019,425808381,15193249,432736,1,'2007-09-15 02:29:33',3310502516,1),(51582023,425810839,15193105,432736,1,'2007-09-15 02:29:34',3310502517,1),(51582027,425813305,15192368,352026,1,'2008-05-06 16:36:31',3310502517,2),(51582031,425817160,15190566,352026,1,'2008-05-06 16:36:31',3310502517,2),(51582034,425821535,15190503,432736,1,'2007-09-15 02:29:34',3310502517,1),(51582038,425830787,15193538,432736,1,'2007-09-15 02:29:35',3310502517,1),(51582045,425837737,15195491,435967,1,'2007-09-15 21:59:03',3310502688,1),(51582060,425840038,15197007,432736,1,'2007-09-15 02:29:37',3310502688,1),(51582066,425842722,15199558,435967,1,'2007-09-15 21:59:03',3310502688,1),(51582074,425846110,15203946,432736,1,'2007-09-15 02:29:37',3310502688,1),(51582077,425847844,15205464,432736,1,'2007-09-15 02:29:37',3310502688,1),(51582082,425851097,15207994,432736,1,'2007-09-15 02:29:38',3310502688,1),(51582085,425854855,15209976,435967,1,'2007-09-15 21:59:10',3310502688,1),(51582086,425856697,15211289,435967,1,'2007-09-15 21:59:09',3310502688,1),(51582089,425860338,15212121,435967,1,'2007-09-15 21:59:10',3310502688,1),(51582090,425863817,15212041,432736,1,'2007-09-15 02:29:38',3310502688,1),(51582091,425867070,15211246,432736,1,'2007-09-15 02:29:39',3310502689,1),(51582093,425870250,15210812,432736,1,'2007-09-15 02:29:39',3310502689,1),(51582096,425872057,15211174,432736,1,'2007-09-15 02:29:39',3310502689,1),(51582098,425873385,15212163,435967,1,'2007-09-15 21:59:05',3310502689,1),(51582101,425874975,15214562,435967,1,'2007-09-15 21:59:06',3310502689,1),(51582102,425877705,15219839,435967,1,'2007-09-15 21:59:05',3310502691,1),(51582105,425881022,15224055,435967,1,'2007-09-15 21:59:07',3310502691,1),(51582107,425884875,15229067,435967,1,'2007-09-15 21:59:06',3310502691,1),(51582110,425889608,15233427,435967,1,'2007-09-15 21:59:08',3310502691,1),(51582111,425891465,15235636,435967,1,'2007-09-15 21:59:09',3310502691,1),(51582113,425894380,15237198,435967,1,'2007-09-15 21:59:15',3310502694,1),(51582116,425897654,15239013,435967,1,'2007-09-15 21:59:15',3310502694,1),(51582118,425901652,15243324,435967,1,'2007-09-15 21:59:15',3310502694,1),(51582121,425904772,15245312,435967,1,'2007-09-15 21:59:16',3310502694,1),(51582123,425909626,15247243,435967,1,'2007-09-15 21:59:16',3310502694,1),(51582125,425915915,15249707,435967,1,'2007-09-15 21:59:16',3310502694,1),(51582128,425918736,15251628,56648,1,'2008-06-05 18:37:38',3310502694,2),(51582132,425920822,15251628,56648,1,'2008-06-05 18:37:38',3310502695,2),(51582133,425923096,15251371,56648,1,'2008-06-05 18:37:38',3310502695,2),(51582135,425926572,15252830,56648,1,'2008-06-05 18:37:38',3310502695,2),(51582137,425929541,15254461,56648,1,'2008-06-05 18:37:38',3310502695,2),(51582139,425932473,15255248,435967,1,'2007-09-15 21:59:14',3310502695,1),(51582143,425934977,15256527,435967,1,'2007-09-15 21:59:15',3310502695,1),(51582146,425936373,15258720,435967,1,'2007-09-15 21:59:31',3310502695,1),(51582148,425938392,15264027,435967,1,'2007-09-15 21:59:29',3310502695,1),(51582150,425938832,15266168,435967,1,'2007-09-15 21:59:29',3310502695,1),(51582153,425939438,15267609,435967,1,'2007-09-15 21:59:32',3310502695,1),(51582156,425940764,15268783,435967,1,'2007-09-15 21:59:32',3310502695,1),(51582159,425942732,15269466,435967,1,'2007-09-15 21:59:31',3310502695,1),(51582162,425944423,15268806,435967,1,'2007-09-15 21:59:17',3310502695,1),(51582166,425946020,15267969,435967,1,'2007-09-15 21:59:17',3310502695,1),(51582167,425948782,15267011,435967,1,'2007-09-15 21:59:17',3310502706,1),(51582170,425951566,15265521,435967,1,'2007-09-15 21:59:29',3310502706,1),(51582173,425953590,15264708,435967,1,'2007-09-15 21:59:18',3310502706,1),(51582175,425956698,15264472,435967,1,'2007-09-15 21:59:17',3310502706,1),(51582178,425958822,15265032,435967,1,'2007-09-15 21:59:33',3310502706,1),(51582181,425960439,15265447,56648,1,'2008-06-05 18:53:05',3310502706,2),(51582184,425962145,15267507,56648,1,'2008-06-05 19:06:55',3310502706,5),(51582186,425962777,15270082,56648,1,'2008-06-05 18:53:05',3310502706,2),(51582188,425964409,15272714,435967,1,'2007-09-15 21:59:33',3310502712,1),(51582191,425972497,15280633,435967,1,'2007-09-15 21:59:33',3310502712,1),(51582194,425975611,15283712,435967,1,'2007-09-15 21:59:32',3310502713,1),(51582198,425981100,15289995,56648,1,'2008-06-05 19:06:55',3310502713,2),(51582201,425983737,15293894,435967,1,'2007-09-15 21:59:33',3310502713,1),(51582204,425985949,15299244,435967,1,'2007-09-15 21:59:32',3310502713,1),(51582207,425987720,15305229,435967,1,'2007-09-15 21:59:33',3310502713,1),(51582209,425989506,15308460,435967,1,'2007-09-15 21:58:20',3310502713,1),(51582211,425993658,15313825,435967,1,'2007-09-15 21:58:20',3310502713,1),(51582213,425998449,15322111,206510,1,'2008-12-06 19:38:06',3310502713,4),(51582216,426002768,15330406,206510,1,'2008-12-06 19:38:06',3310502718,4),(51582218,426004930,15334815,206510,1,'2008-12-06 19:38:07',3310502718,4),(51582221,426007287,15337885,206510,1,'2008-12-06 19:38:07',3310502718,4),(51582224,426010195,15341353,206510,1,'2008-12-06 19:38:07',3310502718,4),(51582227,426012957,15342897,206510,1,'2008-12-06 19:38:07',3310502718,4),(51582229,426014627,15344049,206510,1,'2008-12-06 19:38:07',3310502718,4),(51582231,426015698,15345743,206510,1,'2008-12-06 19:38:07',3310502718,4),(51582233,426017471,15348577,206510,1,'2008-12-06 19:38:07',3310502718,4),(51582234,426018707,15350336,206510,1,'2008-12-06 19:38:07',3310502718,4),(51582237,426022777,15352858,206510,1,'2008-12-06 19:38:07',3310502718,4),(51582239,426028754,15356287,206510,1,'2008-12-06 19:38:07',3310502718,4),(51582241,426032887,15357920,206510,1,'2008-12-06 19:38:07',3310502719,4),(51582242,426036089,15359446,206510,1,'2008-12-06 19:38:07',3310502719,4),(51582245,426038695,15360438,206510,1,'2008-12-06 19:38:07',3310502719,4),(51582247,426042532,15360564,206510,1,'2008-12-06 19:38:07',3310502719,4),(51582251,426046307,15360880,206510,1,'2008-12-06 19:38:07',3310502719,4),(51582253,426048947,15361306,206510,1,'2008-12-06 19:38:07',3310502719,4),(51582256,426051752,15362430,206510,1,'2008-12-06 19:38:07',3310502719,4),(51582258,426055484,15365163,206510,1,'2008-12-06 19:38:07',3310502719,4),(51582261,426060694,15368337,206510,1,'2008-12-06 19:38:07',3310502762,4),(51582264,426065421,15371269,206510,1,'2008-12-06 19:38:08',3310502762,4),(51582267,426070148,15373270,206510,1,'2008-12-06 19:38:08',3310502762,4),(51582270,426073252,15374167,206510,1,'2008-12-06 19:38:08',3310502762,4),(51582271,426077237,15373982,206510,1,'2008-12-06 19:38:08',3310502762,4),(51582274,426083085,15373396,206510,1,'2008-12-06 19:38:08',3310502762,4),(51582279,426086501,15374486,206510,1,'2008-12-06 19:38:08',3310502763,4),(51582282,426087795,15375728,206510,1,'2008-12-06 19:38:08',3310502763,4),(51582284,426089966,15377742,206510,1,'2008-12-06 19:38:08',3310502763,4),(51582287,426091985,15379862,206510,1,'2008-12-06 19:38:08',3310502763,4),(51582290,426093173,15381725,206510,1,'2008-12-06 19:38:08',3310502849,4),(51582293,426094880,15382865,206510,1,'2008-12-06 19:38:08',3310502849,4),(51582294,426096636,15383072,206510,1,'2008-12-06 19:38:08',3310502849,4),(51582297,426100029,15383823,206510,1,'2008-12-06 19:38:08',3310502849,4),(51582300,426102682,15384595,206510,1,'2008-12-06 19:38:08',3310502849,4),(51582303,426108081,15386953,206510,1,'2008-12-06 19:38:08',3310502849,4),(51582306,426111647,15389437,206510,1,'2008-12-06 19:38:09',3310502852,4),(51582308,426114394,15390890,206510,1,'2008-12-06 19:38:09',3310502852,4),(51582309,426117453,15390474,206510,1,'2008-12-06 19:38:09',3310502852,4),(51582311,426122521,15389130,206510,1,'2008-12-06 19:38:09',3310502852,4),(51582313,426126820,15387886,206510,1,'2008-12-06 19:38:09',3310502852,4),(51582315,426130235,15387421,206510,1,'2008-12-06 19:38:09',3310502852,4),(51582316,426139807,15386696,206510,1,'2008-12-06 19:38:09',3310502853,4),(51582318,426146535,15386177,206510,1,'2008-12-06 19:38:09',3310502853,4),(51582320,426149847,15385609,206510,1,'2008-12-06 19:38:09',3310502853,4),(51582323,426154919,15384781,206510,1,'2008-12-06 19:38:09',3310502853,4),(51582326,426158335,15384173,206510,1,'2008-12-06 19:38:09',3310502853,4),(51582329,426161543,15384179,206510,1,'2008-12-06 19:38:09',3310502853,4),(51582332,426162921,15384989,206510,1,'2008-12-06 19:38:09',3310502853,4),(51582335,426164492,15387970,206510,1,'2008-12-06 19:38:09',3310502853,4),(51582338,426166519,15390702,206510,1,'2008-12-06 19:38:09',3310502864,4),(51582339,426168281,15392203,206510,1,'2008-12-06 19:38:09',3310502864,4),(51582342,426170270,15393065,206510,1,'2008-12-06 19:38:09',3310502864,4),(51582345,426172108,15392620,206510,1,'2008-12-06 19:38:09',3310502864,4),(51582346,426172942,15392024,206510,1,'2008-12-06 19:38:09',3310502864,4),(51582349,426173539,15391309,206510,1,'2008-12-06 19:38:09',3310502864,4),(51582352,426174135,15389401,206510,1,'2008-12-06 19:38:10',3310502864,4),(51582355,426174850,15387254,206510,1,'2008-12-06 19:38:10',3310502864,4),(51582357,426174969,15384273,206510,1,'2008-12-06 19:38:10',3310502864,4),(51582360,426175566,15382008,206510,1,'2008-12-06 19:38:10',3310502864,4),(51582362,426176504,15380393,206510,1,'2008-12-06 19:38:10',3310502778,4),(51582365,426178845,15377504,206510,1,'2008-12-06 19:38:10',3310502778,4),(51582368,426181393,15374073,206510,1,'2008-12-06 19:38:10',3310502778,4),(51582371,426184021,15370832,206510,1,'2008-12-06 19:38:10',3310502778,4),(51582373,426185392,15369174,206510,1,'2008-12-06 19:38:10',3310502778,4),(51582377,426186878,15368416,206510,1,'2008-12-06 19:38:10',3310502778,4),(51582380,426187533,15368443,206510,1,'2008-12-06 19:38:11',3310502778,4),(51582383,426188178,15368811,206510,1,'2008-12-06 19:38:11',3310502778,4),(51582385,426188324,15370003,206510,1,'2008-12-06 19:38:11',3310502778,4),(51582388,426187918,15371755,206510,1,'2008-12-06 19:38:11',3310502778,4),(51582392,426186113,15375244,206510,1,'2008-12-06 19:38:11',3310502778,4),(51582395,426184389,15378073,206510,1,'2008-12-06 19:38:11',3310502778,4),(51582399,426184270,15380458,206510,1,'2008-12-06 19:38:11',3310502778,4),(51582403,426184270,15384273,206510,1,'2008-12-06 19:38:11',3310502864,4),(51582405,426184746,15388447,206510,1,'2008-12-06 19:38:11',3310502864,4),(51582407,426186789,15392550,206510,1,'2008-12-06 19:38:11',3310502864,4),(51582410,426188941,15394913,206510,1,'2008-12-06 19:38:11',3310502864,4),(51582413,426190616,15397141,206510,1,'2008-12-06 19:38:11',3310502864,4),(51582415,426191841,15397803,206510,1,'2008-12-06 19:38:11',3310502864,4),(51582418,426192584,15396697,206510,1,'2008-12-06 19:38:11',3310502864,4),(51582421,426192297,15394751,206510,1,'2008-12-06 19:38:12',3310502864,4),(51582424,426191744,15392788,206510,1,'2008-12-06 19:38:12',3310502864,4),(51582426,426191386,15390869,206510,1,'2008-12-06 19:38:12',3310502864,4),(51582429,426191956,15388523,206510,1,'2008-12-06 19:38:12',3310502864,4),(51582432,426192726,15386946,206510,1,'2008-12-06 19:38:12',3310502864,4),(51582435,426193387,15385071,206510,1,'2008-12-06 19:38:12',3310502864,4),(51582437,426194097,15384513,206510,1,'2008-12-06 19:38:12',3310502865,4),(51582439,426194877,15384220,206510,1,'2008-12-06 19:38:12',3310502865,4),(51582441,426195240,15385358,206510,1,'2008-12-06 19:38:12',3310502865,4),(51582444,426194714,15386285,206510,1,'2008-12-06 19:38:12',3310502865,4),(51582446,426194286,15387174,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582448,426193868,15388573,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582451,426194115,15389789,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582453,426194995,15391049,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582455,426196383,15393064,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582459,426197922,15395531,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582462,426199294,15398344,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582463,426200248,15401682,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582465,426200606,15404306,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582469,426201083,15407287,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582472,426202156,15410745,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582474,426203453,15414051,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582476,426204302,15416826,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582479,426204581,15419629,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582482,426205684,15423980,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582483,426206640,15427136,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582486,426207094,15428375,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582489,426208100,15428666,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582492,426208720,15427898,206510,1,'2008-12-06 19:38:13',3310502865,4),(51582495,426208368,15425123,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582496,426207880,15422311,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582499,426207760,15420641,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582501,426207999,15418137,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582502,426208476,15415395,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582504,426208714,15413249,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582506,426208714,15410983,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582508,426208237,15408360,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582509,426207641,15404663,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582510,426207045,15401086,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582512,426206926,15397748,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582516,426206806,15394051,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582518,426206449,15390593,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582521,426206449,15387612,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582523,426207641,15384035,206510,1,'2008-12-06 19:38:14',3310502865,4),(51582525,426209072,15379265,206510,1,'2008-12-06 19:38:14',3310502779,4),(51582527,426217740,15364049,206510,1,'2008-12-06 19:38:14',3310502779,4),(51582530,426227492,15346850,206510,1,'2008-12-06 19:38:14',3310502782,4),(51587693,425555805,15331384,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51587694,425555327,15332479,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51587703,425553935,15331764,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51587705,425554323,15330268,1684788,1,'2009-06-30 11:19:38',3310502459,4),(51587707,425554719,15330070,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51587715,425553941,15330926,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51587721,425554390,15332498,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51587723,425554962,15332645,1684788,1,'2009-06-30 11:19:39',3310502459,3),(51587726,425555647,15332069,1684788,1,'2009-06-30 11:19:38',3310502459,3),(51587729,425555709,15330791,1684788,1,'2009-06-30 11:19:39',3310502459,4),(51587732,425555298,15330212,1684788,1,'2009-06-30 11:19:39',3310502459,4),(51589112,425553377,15329156,498434,1,'2008-05-22 18:27:07',3310502459,2),(51589115,425552555,15328555,498434,1,'2008-05-22 18:27:07',3310502459,2),(51589117,425551607,15327782,498434,1,'2008-05-22 18:27:07',3310502459,2),(51589119,425550595,15326838,498434,1,'2008-05-22 18:27:07',3310502459,2),(51589122,425549204,15325723,498434,1,'2008-05-22 18:27:07',3310502457,2),(51589125,425548192,15324864,498434,1,'2008-05-22 18:27:07',3310502457,2),(51589128,425546754,15323865,432736,1,'2007-09-15 02:41:19',3310502457,1),(51589130,425545351,15322641,432736,1,'2007-09-15 02:41:19',3310502457,1),(51589133,425542940,15321462,432736,1,'2007-09-15 02:41:19',3310502457,1),(51589136,425540877,15320172,432736,1,'2007-09-15 02:41:19',3310502457,1),(51589138,425539459,15319312,432736,1,'2007-09-15 02:41:20',3310502457,1),(51589142,425538255,15319140,432736,1,'2007-09-15 02:41:20',3310502457,1),(51589144,425537352,15319484,432736,1,'2007-09-15 02:41:20',3310502457,1),(51589146,425536837,15320258,432736,1,'2007-09-15 02:41:20',3310502457,1),(51589149,425536708,15321247,432736,1,'2007-09-15 02:41:20',3310502457,1),(51589152,425537352,15322536,432736,1,'2007-09-15 02:41:20',3310502457,1),(51589155,425537825,15324599,432736,1,'2007-09-15 02:41:20',3310502457,1),(51589157,425538470,15327823,432736,1,'2007-09-15 02:41:21',3310502459,1),(51589158,425538728,15331004,432736,1,'2007-09-15 02:41:21',3310502459,1),(51589160,425539373,15333755,432736,1,'2007-09-15 02:41:21',3310502459,1),(51589161,425539502,15335346,432736,1,'2007-09-15 02:41:21',3310502459,1),(51589162,425539545,15336721,432736,1,'2007-09-15 02:41:21',3310502459,1),(51589163,425538943,15337839,432736,1,'2007-09-15 02:41:21',3310502459,1),(51589165,425538126,15338355,432736,1,'2007-09-15 02:41:22',3310502459,1),(51589169,425537137,15338355,432736,1,'2007-09-15 02:41:22',3310502459,1),(51589172,425536321,15337710,432736,1,'2007-09-15 02:41:22',3310502459,1),(51589174,425535332,15336506,432736,1,'2007-09-15 02:41:22',3310502459,1),(51589177,425533413,15333574,432736,1,'2007-09-15 02:41:22',3310502458,1),(51589180,425531530,15331521,432736,1,'2007-09-15 02:41:22',3310502458,1),(51589183,425529705,15330266,432736,1,'2007-09-15 02:41:22',3310502458,1),(51589185,425527708,15329581,432736,1,'2007-09-15 02:41:23',3310502458,1),(51589187,425525426,15328783,432736,1,'2007-09-15 02:41:23',3310502458,1),(51589190,425523886,15327185,432736,1,'2007-09-15 02:41:23',3310502458,1),(51589192,425522403,15325189,432736,1,'2007-09-15 02:41:23',3310502456,1),(51589194,425521319,15321253,432736,1,'2007-09-15 02:41:23',3310502456,1),(51589196,425520463,15317887,432736,1,'2007-09-15 02:41:24',3310502456,1),(51589198,425519265,15314521,432736,1,'2007-09-15 02:41:24',3310502456,1),(51589201,425518182,15311441,432736,1,'2007-09-15 02:41:24',3310502456,1),(51589203,425516870,15308532,432736,1,'2007-09-15 02:41:24',3310502456,1),(51589205,425515272,15307162,432736,1,'2007-09-15 02:41:24',3310502456,1),(51589208,425512477,15305907,432736,1,'2007-09-15 02:41:25',3310502456,1),(51589210,425511507,15304710,432736,1,'2007-09-15 02:41:25',3310502456,1),(51589213,425511336,15303226,432736,1,'2007-09-15 02:41:25',3310502456,1),(51589215,425511393,15300431,432736,1,'2007-09-15 02:41:25',3310502456,1),(51589217,425510880,15298206,432736,1,'2007-09-15 02:41:25',3310502456,1),(51589220,425509796,15294898,432736,1,'2007-09-15 02:41:26',3310502456,1),(51589223,425508826,15292103,432736,1,'2007-09-15 02:41:26',3310502456,1),(51589226,425508427,15289878,432736,1,'2007-09-15 02:41:26',3310502456,1),(51589229,425508256,15287653,432736,1,'2007-09-15 02:41:26',3310502456,1),(51589230,425507914,15285257,432736,1,'2007-09-15 02:41:26',3310502456,1),(51589233,425506830,15284744,432736,1,'2007-09-15 02:41:26',3310502445,1),(51589236,425505917,15284744,432736,1,'2007-09-15 02:41:27',3310502445,1),(51589238,425505232,15285885,432736,1,'2007-09-15 02:41:27',3310502445,1),(51589243,425504833,15288452,432736,1,'2007-09-15 02:41:27',3310502445,1),(51589247,425504662,15291133,432736,1,'2007-09-15 02:41:27',3310502445,1),(51589249,425503806,15293186,432736,1,'2007-09-15 02:41:27',3310502445,1),(51589252,425503350,15295126,432736,1,'2007-09-15 02:41:28',3310502445,1),(51589254,425503122,15297065,432736,1,'2007-09-15 02:41:28',3310502445,1),(51589256,425503350,15299804,432736,1,'2007-09-15 02:41:28',3310502445,1),(51589259,425504263,15304025,432736,1,'2007-09-15 02:41:28',3310502445,1),(51589262,425504890,15306649,432736,1,'2007-09-15 02:41:28',3310502445,1),(51589263,425504947,15309501,432736,1,'2007-09-15 02:41:29',3310502445,1),(51589267,425504719,15312411,432736,1,'2007-09-15 02:41:29',3310502445,1),(51589270,425504776,15316974,432736,1,'2007-09-15 02:41:29',3310502445,1),(51589273,425504719,15321367,432736,1,'2007-09-15 02:41:29',3310502445,1),(51589275,425504605,15323021,432736,1,'2007-09-15 02:41:29',3310502445,1),(51589278,425505862,15329177,432736,1,'2007-09-15 02:41:29',3310502447,1),(51589281,425506848,15332135,432736,1,'2007-09-15 02:41:30',3310502447,1),(51589284,425507834,15334763,432736,1,'2007-09-15 02:41:30',3310502458,1),(51589288,425507751,15337803,432736,1,'2007-09-15 02:41:30',3310502458,1),(51589290,425506154,15340352,434787,1,'2007-09-15 13:10:20',3310502447,1),(51589293,425505908,15344788,434787,1,'2007-09-15 13:10:20',3310502447,1),(51589296,425505826,15347170,434787,1,'2007-09-15 13:10:19',3310502447,1),(51589297,425506976,15351524,434787,1,'2007-09-15 13:10:19',3310502447,1),(51589299,425509933,15358506,434787,1,'2007-09-15 13:10:19',3310502458,1),(51589302,425512726,15364010,434787,1,'2007-09-15 13:10:19',3310502458,1),(51589304,425514697,15368363,434787,1,'2007-09-15 13:10:19',3310502458,1),(51589307,425515683,15372799,434787,1,'2007-09-15 13:10:18',3310502458,1),(51589310,425516587,15379453,434787,1,'2007-09-15 13:10:19',3310502458,1),(51589313,425517819,15385449,434787,1,'2007-09-15 13:10:21',3310502544,1),(51589315,425519051,15390542,434787,1,'2007-09-15 13:10:21',3310502544,1),(51589320,425520612,15395143,434787,1,'2007-09-15 13:10:21',3310502544,1),(51589325,425523651,15399496,434787,1,'2007-09-15 13:10:21',3310502544,1),(51589328,425526608,15403193,434787,1,'2007-09-15 13:10:21',3310502544,1),(51589334,425529894,15406068,434787,1,'2007-09-15 13:10:21',3310502544,1),(51589337,425532687,15407136,434787,1,'2007-09-15 13:10:20',3310502544,1),(51589338,425535809,15407793,434787,1,'2007-09-15 13:10:20',3310502545,1),(51589340,425537944,15410339,434787,1,'2007-09-15 13:10:20',3310502545,1),(51589342,425539341,15412968,434787,1,'2007-09-15 13:10:20',3310502545,1),(51589344,425540737,15413543,434787,1,'2007-09-15 13:10:23',3310502545,1),(51589348,425542462,15412968,434787,1,'2007-09-15 13:10:23',3310502545,1),(51589352,425544762,15411243,434787,1,'2007-09-15 13:10:23',3310502545,1),(51589354,425546980,15409354,434787,1,'2007-09-15 13:10:23',3310502545,1),(51589357,425549116,15408532,434787,1,'2007-09-15 13:10:22',3310502545,1),(51589360,425550513,15408532,434787,1,'2007-09-15 13:10:22',3310502545,1),(51589363,425551663,15409436,434787,1,'2007-09-15 13:10:22',3310502545,1),(51589366,425552402,15411489,434787,1,'2007-09-15 13:10:22',3310502545,1),(51589368,425553141,15415432,434787,1,'2007-09-15 13:10:22',3310502545,1),(51589370,425554866,15423400,434787,1,'2007-09-15 13:10:21',3310502545,1),(51590535,425555649,15427255,434787,1,'2007-09-15 13:10:15',3310502545,1),(51590538,425555931,15430557,434787,1,'2007-09-15 13:10:15',3310502545,1),(51590542,425555891,15433214,434787,1,'2007-09-15 13:10:15',3310502545,1),(51590544,425556253,15435832,434787,1,'2007-09-15 13:10:15',3310502545,1),(51590546,425557421,15438570,434787,1,'2007-09-15 13:10:15',3310502547,1),(51590549,425558790,15441348,434787,1,'2007-09-15 13:10:16',3310502547,1),(51590551,425559394,15443160,434787,1,'2007-09-15 13:10:16',3310502547,1),(51590553,425559796,15446220,434787,1,'2007-09-15 13:10:16',3310502547,1),(51590557,425559149,15451087,434787,1,'2007-09-15 13:10:16',3310502547,1),(51590560,425559149,15453258,434787,1,'2007-09-15 13:10:16',3310502547,1),(51590563,425559817,15454845,434787,1,'2007-09-15 13:10:16',3310502547,1),(51590564,425562406,15457767,434787,1,'2007-09-15 13:10:16',3310502550,1),(51590567,425564910,15459854,434787,1,'2007-09-15 13:10:17',3310502550,1),(51590572,425565411,15461107,434787,1,'2007-09-15 13:10:17',3310502550,1),(51590575,425565411,15462526,434787,1,'2007-09-15 13:10:17',3310502550,1),(51590578,425564409,15463361,434787,1,'2007-09-15 13:10:17',3310502550,1),(51590580,425563408,15463194,434787,1,'2007-09-15 13:10:17',3310502550,1),(51590582,425562155,15461607,434787,1,'2007-09-15 13:10:17',3310502550,1),(51590585,425559901,15459270,434787,1,'2007-09-15 13:10:17',3310502547,1),(51590588,425557730,15457433,434787,1,'2007-09-15 13:10:18',3310502547,1),(51590589,425556645,15457266,434787,1,'2007-09-15 13:10:18',3310502547,1),(51590592,425556227,15458184,434787,1,'2007-09-15 13:10:10',3310502547,1),(51590595,425556227,15459353,434787,1,'2007-09-15 13:10:10',3310502547,1),(51590598,425556979,15460439,434787,1,'2007-09-15 13:10:10',3310502547,1),(51590600,425558899,15462442,434787,1,'2007-09-15 13:10:11',3310502547,1),(51590603,425560318,15464279,434787,1,'2007-09-15 13:10:11',3310502547,1),(51590606,425561738,15467202,434787,1,'2007-09-15 13:10:11',3310502547,1),(51590608,425562239,15470458,434787,1,'2007-09-15 13:10:11',3310502550,1),(51590611,425562656,15472378,434787,1,'2007-09-15 13:10:11',3310502550,1),(51590613,425563241,15474298,434787,1,'2007-09-15 13:10:11',3310502550,1),(51590616,425564409,15475551,434787,1,'2007-09-15 13:10:12',3310502550,1),(51590619,425566747,15476970,434787,1,'2007-09-15 13:10:12',3310502550,1),(51590622,425568751,15477889,434787,1,'2007-09-15 13:10:12',3310502550,1),(51590623,425570671,15479466,434787,1,'2007-09-15 13:10:12',3310502550,1),(51590626,425572897,15481055,434787,1,'2007-09-15 13:10:13',3310502550,1),(51590630,425574397,15482596,434787,1,'2007-09-15 13:10:13',3310502550,1),(51590631,425576139,15485138,434787,1,'2007-09-15 13:10:12',3310502550,1),(51590633,425577846,15488576,434787,1,'2007-09-15 13:10:13',3310502550,1),(51590634,425578080,15490476,434787,1,'2007-09-15 13:10:14',3310502550,1),(51590635,425578362,15491882,434787,1,'2007-09-15 13:10:14',3310502556,1),(51590636,425577975,15492667,434787,1,'2007-09-15 13:10:13',3310502556,1),(51590637,425577424,15493142,434787,1,'2007-09-15 13:10:13',3310502556,1),(51590638,425576700,15493147,434787,1,'2007-09-15 13:10:13',3310502556,1),(51590643,425575865,15491984,434787,1,'2007-09-15 13:10:14',3310502556,1),(51590645,425574926,15489191,434787,1,'2007-09-15 13:10:14',3310502550,1),(51590646,425573626,15487597,434787,1,'2007-09-15 13:10:14',3310502550,1),(51590648,425571256,15486405,434787,1,'2007-09-15 13:10:15',3310502550,1),(51590650,425566831,15484401,434787,1,'2007-09-15 13:10:15',3310502550,1),(51590653,425563074,15482481,434787,1,'2007-09-15 13:10:14',3310502550,1),(51590654,425559817,15480978,434787,1,'2007-09-15 13:10:15',3310502547,1),(51590657,425556895,15479559,434787,1,'2007-09-15 13:10:10',3310502547,1),(51590660,425555225,15478223,434787,1,'2007-09-15 13:10:10',3310502547,1),(51590663,425554004,15475980,434787,1,'2007-09-15 13:10:10',3310502547,1),(51590665,425551946,15471252,434787,1,'2007-09-15 13:10:10',3310502547,1),(51590668,425550521,15467294,434787,1,'2007-09-15 13:10:09',3310502547,1),(51590669,425548451,15463735,434787,1,'2007-09-15 13:10:09',3310502547,1),(51590671,425545923,15461443,434787,1,'2007-09-15 13:10:09',3310502547,1),(51590673,425543447,15459673,434787,1,'2007-09-15 13:10:08',3310502547,1),(51590676,425542796,15458654,434787,1,'2007-09-15 13:10:08',3310502547,1),(51590679,425543116,15457358,434787,1,'2007-09-15 13:10:08',3310502547,1),(51590680,425544224,15455495,434787,1,'2007-09-15 13:10:08',3310502547,1),(51590683,425544446,15453984,434787,1,'2007-09-15 13:10:08',3310502547,1),(51590686,425544705,15451695,434787,1,'2007-09-15 13:10:08',3310502547,1),(51590687,425544581,15447293,434787,1,'2007-09-15 13:10:07',3310502547,1),(51590690,425544377,15443187,434787,1,'2007-09-15 13:10:07',3310502547,1),(51590691,425543168,15441111,434787,1,'2007-09-15 13:10:07',3310502547,1),(51590693,425541616,15440484,434787,1,'2007-09-15 13:10:07',3310502547,1),(51590695,425540029,15440233,434787,1,'2007-09-15 13:10:07',3310502547,1),(51590699,425538102,15441760,434787,1,'2007-09-15 13:10:07',3310502547,1),(51590702,425535516,15443699,434787,1,'2007-09-15 13:10:06',3310502547,1),(51590705,425533208,15444899,434787,1,'2007-09-15 13:10:06',3310502546,1),(51590707,425531699,15444426,434787,1,'2007-09-15 13:10:06',3310502546,1),(51590708,425530689,15442764,434787,1,'2007-09-15 13:10:06',3310502546,1),(51590711,425530258,15440917,434787,1,'2007-09-15 13:10:06',3310502546,1),(51590714,425529310,15438406,434787,1,'2007-09-15 13:10:06',3310502546,1),(51590716,425527691,15437371,434787,1,'2007-09-15 13:10:05',3310502546,1),(51590719,425523974,15436804,434787,1,'2007-09-15 13:10:05',3310502546,1),(51590722,425520899,15437298,434787,1,'2007-09-15 13:10:05',3310502546,1),(51590725,425518624,15437688,434787,1,'2007-09-15 13:10:05',3310502546,1),(51590728,425516244,15437408,434787,1,'2007-09-15 13:10:04',3310502546,1),(51590730,425514311,15436915,434787,1,'2007-09-15 13:10:04',3310502546,1),(51929590,425512717,15436876,434787,1,'2007-09-15 13:06:23',3310502546,1),(51929593,425510506,15436823,434787,1,'2007-09-15 13:06:23',3310502546,1),(51929595,425509454,15436297,434787,1,'2007-09-15 13:06:23',3310502546,1),(51929598,425508717,15435139,434787,1,'2007-09-15 13:06:23',3310502544,1),(51929600,425508349,15432245,434787,1,'2007-09-15 13:06:23',3310502544,1),(51929603,425507770,15430140,434787,1,'2007-09-15 13:06:23',3310502544,1),(51929607,425507349,15429140,434787,1,'2007-09-15 13:06:23',3310502544,1),(51929610,425506349,15428140,434787,1,'2007-09-15 13:06:24',3310502533,1),(51929614,425505454,15427509,434787,1,'2007-09-15 13:06:24',3310502533,1),(51929617,425504507,15426561,434787,1,'2007-09-15 13:06:24',3310502533,1),(51929619,425503139,15425140,434787,1,'2007-09-15 13:06:24',3310502533,1),(51929620,425501981,15424562,434787,1,'2007-09-15 13:06:25',3310502533,1),(51929623,425500718,15424562,434787,1,'2007-09-15 13:06:25',3310502533,1),(51929625,425498823,15424456,434787,1,'2007-09-15 13:06:25',3310502533,1),(51929626,425497297,15424088,434787,1,'2007-09-15 13:06:25',3310502533,1),(51929628,425496455,15423667,434787,1,'2007-09-15 13:06:25',3310502533,1),(51929630,425495824,15422772,434787,1,'2007-09-15 13:06:26',3310502533,1),(51929632,425495403,15421246,434787,1,'2007-09-15 13:06:26',3310502533,1),(51929634,425494982,15419457,434787,1,'2007-09-15 13:06:26',3310502533,1),(51929636,425494455,15416194,434787,1,'2007-09-15 13:06:26',3310502533,1),(51929638,425494245,15413826,434787,1,'2007-09-15 13:06:26',3310502533,1),(51929640,425494140,15411984,434787,1,'2007-09-15 13:06:27',3310502533,1),(51929642,425493929,15410037,434787,1,'2007-09-15 13:06:27',3310502533,1),(51929644,425493508,15409090,434787,1,'2007-09-15 13:06:27',3310502533,1),(51929645,425492666,15408932,434787,1,'2007-09-15 13:06:27',3310502533,1),(51929647,425492456,15409353,434787,1,'2007-09-15 13:06:27',3310502533,1),(51929649,425492403,15410300,434787,1,'2007-09-15 13:06:27',3310502533,1),(51929650,425492350,15411931,434787,1,'2007-09-15 13:06:28',3310502533,1),(51929653,425492350,15413615,434787,1,'2007-09-15 13:06:28',3310502533,1),(51929656,425492666,15418878,434787,1,'2007-09-15 13:06:28',3310502533,1),(51929657,425493192,15421930,434787,1,'2007-09-15 13:06:28',3310502533,1),(51929660,425494455,15427614,434787,1,'2007-09-15 13:06:28',3310502533,1),(51929661,425494719,15428456,434787,1,'2007-09-15 13:06:28',3310502533,1),(51929663,425495297,15428877,434787,1,'2007-09-15 13:06:29',3310502533,1),(51929665,425496087,15429140,434787,1,'2007-09-15 13:06:29',3310502533,1),(51929667,425497876,15429298,434787,1,'2007-09-15 13:06:29',3310502533,1),(51929670,425499297,15429351,434787,1,'2007-09-15 13:06:29',3310502533,1),(51929671,425500455,15429666,434787,1,'2007-09-15 13:06:29',3310502533,1),(51929673,425501718,15430982,434787,1,'2007-09-15 13:06:29',3310502533,1),(51929675,425502770,15432298,434787,1,'2007-09-15 13:06:29',3310502533,1),(51929677,425503454,15433666,434787,1,'2007-09-15 13:06:29',3310502533,1),(51929678,425503981,15436297,434787,1,'2007-09-15 13:06:30',3310502535,1),(51929680,425504191,15438560,434787,1,'2007-09-15 13:06:30',3310502535,1),(51929682,425503981,15442875,434787,1,'2007-09-15 13:06:30',3310502535,1),(51929684,425504297,15444612,434787,1,'2007-09-15 13:06:30',3310502535,1),(51929687,425505612,15446086,434787,1,'2007-09-15 13:06:30',3310502535,1),(51929689,425507244,15446507,434787,1,'2007-09-15 13:06:30',3310502546,1),(51929690,425509454,15446664,434787,1,'2007-09-15 13:06:31',3310502546,1),(51929693,425511612,15447349,434787,1,'2007-09-15 13:06:31',3310502546,1),(51929696,425513980,15448769,434787,1,'2007-09-15 13:06:31',3310502546,1),(51929700,425516032,15450243,434787,1,'2007-09-15 13:06:31',3310502546,1),(51929702,425518084,15451559,434787,1,'2007-09-15 13:06:31',3310502546,1),(51929704,425518663,15452348,434787,1,'2007-09-15 13:06:31',3310502546,1),(51929707,425518769,15453927,434787,1,'2007-09-15 13:06:32',3310502546,1),(51929709,425519453,15456505,434787,1,'2007-09-15 13:06:32',3310502546,1),(51929711,425520453,15458768,434787,1,'2007-09-15 13:06:32',3310502546,1),(51929713,425521716,15460821,434787,1,'2007-09-15 13:06:32',3310502546,1),(51929715,425522768,15463663,434787,1,'2007-09-15 13:06:32',3310502546,1),(51929717,425523610,15466399,434787,1,'2007-09-15 13:06:32',3310502546,1),(51929720,425524400,15469136,434787,1,'2007-09-15 13:06:32',3310502546,1),(51929722,425525242,15471451,434787,1,'2007-09-15 13:06:33',3310502546,1),(51929725,425525978,15473030,434787,1,'2007-09-15 13:06:33',3310502546,1),(51929728,425527136,15474819,434787,1,'2007-09-15 13:06:33',3310502546,1),(51929731,425528820,15476661,434787,1,'2007-09-15 13:06:33',3310502546,1),(51929734,425531136,15478608,434787,1,'2007-09-15 13:06:33',3310502546,1),(51929736,425532767,15480135,434787,1,'2007-09-15 13:06:33',3310502546,1),(51929739,425533571,15481367,434787,1,'2007-09-15 13:06:33',3310502546,1),(51929741,425534577,15483092,434787,1,'2007-09-15 13:06:34',3310502547,1),(51929743,425535382,15485018,434787,1,'2007-09-15 13:06:34',3310502547,1),(51929746,425535899,15488008,434787,1,'2007-09-15 13:06:34',3310502547,1),(51929749,425536647,15490653,434787,1,'2007-09-15 13:06:34',3310502547,1),(51929752,425537653,15492492,434787,1,'2007-09-15 13:06:34',3310502553,1),(51929754,425538544,15493815,434787,1,'2007-09-15 13:06:34',3310502553,1),(51929757,425539320,15495425,434787,1,'2007-09-15 13:06:34',3310502553,1),(51929760,425539953,15497983,434787,1,'2007-09-15 13:06:35',3310502553,1),(51929762,425540355,15500542,434787,1,'2007-09-15 13:06:35',3310502553,1),(51929764,425541116,15503323,434787,1,'2007-09-15 13:06:35',3310502553,1),(51929767,425541564,15505265,434787,1,'2007-09-15 13:06:35',3310502553,1),(51929770,425542722,15508142,434787,1,'2007-09-15 13:06:35',3310502553,1),(51929771,425544366,15511056,434787,1,'2007-09-15 13:06:36',3310502553,1),(51929773,425546085,15513820,434787,1,'2007-09-15 13:06:36',3310502553,1),(51929775,425547579,15516585,434787,1,'2007-09-15 13:06:36',3310502553,1),(51929777,425549148,15519424,434787,1,'2007-09-15 13:06:37',3310502553,1),(51929780,425550456,15521927,434787,1,'2007-09-15 13:06:37',3310502553,1),(51929782,425550941,15523982,434787,1,'2007-09-15 13:06:37',3310502553,1),(51929784,425550904,15526037,434787,1,'2007-09-15 13:06:37',3310502553,1),(51929785,425550493,15527606,434787,1,'2007-09-15 13:06:37',3310502553,1),(51929786,425549335,15531790,434787,1,'2007-09-15 13:06:37',3310502553,1),(51929788,425548364,15536049,434787,1,'2007-09-15 13:06:37',3310502553,1),(51929790,425547841,15539710,434787,1,'2007-09-15 13:06:37',3310502553,1),(51929793,425547392,15544342,434787,1,'2007-09-15 13:06:37',3310502553,1),(51929796,425547654,15546175,434787,1,'2007-09-15 13:06:38',3310502555,1),(51929797,425548102,15548132,434787,1,'2007-09-15 13:06:38',3310502555,1),(51929800,425548178,15549921,434787,1,'2007-09-15 13:06:38',3310502555,1),(51929802,425547874,15551597,434787,1,'2007-09-15 13:06:38',3310502555,1),(51929805,425547645,15553310,434787,1,'2007-09-15 13:06:38',3310502555,1),(51929807,425547836,15554681,434787,1,'2007-09-15 13:06:38',3310502555,1),(51929810,425548064,15555519,434787,1,'2007-09-15 13:06:38',3310502555,1),(51929812,425548826,15556470,434787,1,'2007-09-15 13:06:38',3310502555,1),(51929814,425549701,15557346,434787,1,'2007-09-15 13:06:39',3310502555,1),(51929818,425551415,15557879,434787,1,'2007-09-15 13:06:39',3310502555,1),(51929820,425553547,15557841,434787,1,'2007-09-15 13:06:39',3310502555,1),(51929823,425554804,15557499,434787,1,'2007-09-15 13:06:39',3310502555,1),(51929825,425556822,15556889,434787,1,'2007-09-15 13:06:39',3310502555,1),(51929827,425558307,15556699,434787,1,'2007-09-15 13:06:40',3310502555,1),(51929829,425560210,15556965,434787,1,'2007-09-15 13:06:40',3310502555,1),(51929833,425561162,15558146,434787,1,'2007-09-15 13:06:40',3310502555,1),(51929834,425561924,15561306,434787,1,'2007-09-15 13:06:40',3310502558,1),(51929837,425562305,15563439,434787,1,'2007-09-15 13:06:40',3310502558,1),(51929840,425562343,15565799,434787,1,'2007-09-15 13:06:40',3310502558,1),(51929842,425562305,15567589,434787,1,'2007-09-15 13:06:41',3310502558,1),(51929844,425561581,15570445,434787,1,'2007-09-15 13:06:41',3310502555,1),(51929846,425560858,15574100,434787,1,'2007-09-15 13:06:41',3310502555,1),(51929848,425560858,15576346,434787,1,'2007-09-15 13:06:41',3310502555,1),(51929852,425561048,15579773,434787,1,'2007-09-15 13:06:41',3310502555,1),(51929854,425561391,15583543,434787,1,'2007-09-15 13:06:41',3310502555,1),(51929858,425561543,15586056,434787,1,'2007-09-15 13:06:41',3310502555,1),(51929860,425561467,15587541,434787,1,'2007-09-15 13:06:42',3310502555,1),(51929862,425561162,15589331,434787,1,'2007-09-15 13:06:42',3310502555,1),(51929864,425560627,15593102,434787,1,'2007-09-15 13:06:42',3310502555,1),(51929866,425560510,15595469,434787,1,'2007-09-15 13:06:42',3310502555,1),(51929869,425560006,15599156,434787,1,'2007-09-15 13:06:42',3310502555,1),(51929872,425559812,15602416,434787,1,'2007-09-15 13:06:43',3310502577,1),(51929873,425559695,15605443,434787,1,'2007-09-15 13:06:43',3310502577,1),(51929875,425559307,15610954,434787,1,'2007-09-15 13:06:43',3310502577,1),(51929878,425559152,15613865,434787,1,'2007-09-15 13:06:43',3310502577,1),(51929880,425559152,15616853,434787,1,'2007-09-15 13:06:43',3310502577,1),(51929883,425559152,15618405,434787,1,'2007-09-15 13:06:43',3310502577,1),(51929886,425558919,15619492,434787,1,'2007-09-15 13:06:43',3310502577,1),(51929889,425558609,15620035,434787,1,'2007-09-15 13:06:43',3310502577,1),(51929892,425558065,15620462,434787,1,'2007-09-15 13:06:44',3310502577,1),(51929893,425557367,15620462,434787,1,'2007-09-15 13:06:44',3310502577,1),(51929896,425556862,15620151,434787,1,'2007-09-15 13:06:44',3310502577,1),(51929899,425556513,15619453,434787,1,'2007-09-15 13:06:44',3310502577,1),(51929902,425556358,15618483,434787,1,'2007-09-15 13:06:44',3310502577,1),(51929905,425556241,15617241,434787,1,'2007-09-15 13:06:44',3310502577,1),(51929907,425556435,15615611,434787,1,'2007-09-15 13:06:44',3310502577,1),(51929909,425556591,15614136,434787,1,'2007-09-15 13:06:44',3310502577,1),(51929910,425556707,15612429,434787,1,'2007-09-15 13:06:45',3310502577,1),(51929913,425556629,15611226,434787,1,'2007-09-15 13:06:45',3310502577,1),(51929915,425556358,15610178,434787,1,'2007-09-15 13:06:45',3310502577,1),(51929916,425556086,15609324,434787,1,'2007-09-15 13:06:45',3310502577,1),(51929918,425555387,15608548,434787,1,'2007-09-15 13:06:45',3310502577,1),(51929920,425554107,15607616,434787,1,'2007-09-15 13:06:45',3310502577,1),(51929922,425553137,15606530,434787,1,'2007-09-15 13:06:45',3310502577,1),(51929923,425552360,15606025,434787,1,'2007-09-15 13:06:45',3310502577,1),(51929925,425551662,15605288,434787,1,'2007-09-15 13:06:46',3310502577,1),(51929927,425551274,15604356,434787,1,'2007-09-15 13:06:46',3310502577,1),(51929930,425550847,15602533,434787,1,'2007-09-15 13:06:46',3310502577,1),(51929933,425550614,15600709,434787,1,'2007-09-15 13:06:46',3310502555,1),(51929936,425550653,15597992,434787,1,'2007-09-15 13:06:46',3310502555,1),(51929938,425550342,15596595,434787,1,'2007-09-15 13:06:46',3310502555,1),(51929939,425549683,15594344,434787,1,'2007-09-15 13:06:47',3310502555,1),(51929942,425549101,15591317,434787,1,'2007-09-15 13:06:47',3310502555,1),(51929943,425548596,15588988,434787,1,'2007-09-15 13:06:47',3310502555,1),(51929946,425547859,15585418,434787,1,'2007-09-15 13:06:47',3310502555,1),(51929949,425546500,15581266,434787,1,'2007-09-15 13:06:47',3310502555,1),(51929950,425545491,15579519,434787,1,'2007-09-15 13:06:47',3310502555,1),(51929953,425543706,15577346,434787,1,'2007-09-15 13:06:48',3310502555,1),(51929955,425540679,15573620,434787,1,'2007-09-15 13:06:48',3310502555,1),(51929957,425538584,15571796,434787,1,'2007-09-15 13:06:48',3310502555,1),(51929960,425537342,15570749,434787,1,'2007-09-15 13:06:48',3310502555,1),(51929964,425536100,15569119,434787,1,'2007-09-15 13:06:49',3310502555,1),(51929966,425534664,15566907,434787,1,'2007-09-15 13:06:49',3310502555,1),(51929968,425532723,15562094,434787,1,'2007-09-15 13:06:49',3310502554,1),(51929971,425531404,15559145,434787,1,'2007-09-15 13:06:49',3310502554,1),(51929974,425530356,15556816,434787,1,'2007-09-15 13:06:49',3310502554,1),(51929975,425529075,15552470,434787,1,'2007-09-15 13:06:49',3310502554,1),(51929978,425528804,15549986,434787,1,'2007-09-15 13:06:50',3310502554,1),(51929980,425528299,15546105,434787,1,'2007-09-15 13:06:50',3310502554,1),(51929983,425528338,15542768,434787,1,'2007-09-15 13:06:50',3310502552,1),(51929986,425528571,15540168,434787,1,'2007-09-15 13:06:50',3310502552,1),(51929988,425528843,15535588,434787,1,'2007-09-15 13:06:50',3310502552,1),(51929990,425528726,15533609,434787,1,'2007-09-15 13:06:50',3310502552,1),(51929993,425528338,15530660,434787,1,'2007-09-15 13:06:51',3310502552,1),(51929999,425527484,15527594,434787,1,'2007-09-15 13:06:51',3310502552,1),(51930002,425526553,15525265,434787,1,'2007-09-15 13:06:51',3310502552,1),(51930009,425525117,15522626,434787,1,'2007-09-15 13:06:51',3310502552,1),(51930014,425524302,15521074,434787,1,'2007-09-15 13:06:51',3310502552,1),(51930018,425523371,15520065,434787,1,'2007-09-15 13:06:51',3310502552,1),(51930020,425522439,15519716,434787,1,'2007-09-15 13:06:51',3310502552,1),(51930022,425521663,15520065,434787,1,'2007-09-15 13:06:52',3310502552,1),(51930024,425521508,15520725,434787,1,'2007-09-15 13:06:52',3310502552,1),(51930026,425521663,15521656,434787,1,'2007-09-15 13:06:52',3310502552,1),(51930027,425522439,15522820,864892,1,'2009-03-28 17:17:44',3310502552,2),(51930029,425523293,15524023,434787,1,'2007-09-15 13:06:52',3310502552,1),(51930031,425524186,15525731,434787,1,'2007-09-15 13:06:53',3310502552,1),(51930033,425524186,15526818,434787,1,'2007-09-15 13:06:53',3310502552,1),(51930035,425524030,15528215,434787,1,'2007-09-15 13:06:53',3310502552,1),(51930037,425523759,15529495,434787,1,'2007-09-15 13:06:54',3310502552,1),(51930040,425523409,15530892,434787,1,'2007-09-15 13:06:54',3310502552,1),(51930043,425522711,15532212,434787,1,'2007-09-15 13:06:54',3310502552,1),(51930044,425521974,15533415,434787,1,'2007-09-15 13:06:54',3310502552,1),(51930047,425521197,15535278,434787,1,'2007-09-15 13:06:54',3310502552,1),(51930048,425520809,15536636,434787,1,'2007-09-15 13:06:54',3310502552,1),(51930050,425520128,15539582,434787,1,'2007-09-15 13:06:54',3310502552,1),(51930052,425519834,15542059,434787,1,'2007-09-15 13:06:54',3310502552,1),(51930053,425519582,15544663,434787,1,'2007-09-15 13:06:54',3310502552,1),(51930055,425519414,15547561,434787,1,'2007-09-15 13:06:54',3310502554,1),(51930058,425519540,15550752,434787,1,'2007-09-15 13:06:55',3310502554,1),(51930062,425519960,15554364,434787,1,'2007-09-15 13:06:55',3310502554,1),(51930063,425520212,15557639,434787,1,'2007-09-15 13:06:55',3310502554,1),(51930066,425521010,15561041,434787,1,'2007-09-15 13:06:55',3310502554,1),(51930068,425521723,15563182,434787,1,'2007-09-15 13:06:56',3310502554,1),(51930071,425522437,15567592,434787,1,'2007-09-15 13:06:56',3310502554,1),(51930073,425523697,15571329,434787,1,'2007-09-15 13:06:56',3310502554,1),(51930076,425525251,15573681,434787,1,'2007-09-15 13:06:56',3310502554,1),(51930079,425525839,15575486,434787,1,'2007-09-15 13:06:56',3310502554,1),(51930080,425526007,15578930,434787,1,'2007-09-15 13:06:56',3310502554,1),(51930082,425526217,15582289,434787,1,'2007-09-15 13:06:57',3310502554,1),(51930085,425526763,15588127,434787,1,'2007-09-15 13:06:57',3310502554,1),(51930088,425526427,15590898,434787,1,'2007-09-15 13:06:57',3310502554,1),(51930092,425525839,15592662,434787,1,'2007-09-15 13:06:57',3310502554,1),(51930094,425524831,15594384,434787,1,'2007-09-15 13:06:57',3310502554,1),(51930096,425523790,15596926,434787,1,'2007-09-15 13:06:57',3310502554,1),(51930098,425523067,15598833,434787,1,'2007-09-15 13:06:57',3310502554,1),(51930099,425522168,15600914,434787,1,'2007-09-15 13:06:57',3310502576,1),(51930102,425521379,15602777,434787,1,'2007-09-15 13:06:58',3310502576,1),(51930104,425520371,15606371,434787,1,'2007-09-15 13:06:58',3310502576,1),(51930107,425520152,15608409,434787,1,'2007-09-15 13:06:58',3310502576,1),(51930108,425520086,15612354,434787,1,'2007-09-15 13:06:58',3310502576,1),(51930110,425519867,15616539,434787,1,'2007-09-15 13:06:58',3310502576,1),(51930112,425519495,15618511,434787,1,'2007-09-15 13:06:59',3310502576,1),(51930113,425519254,15620571,434787,1,'2007-09-15 13:06:59',3310502576,1),(51930115,425519012,15622806,434787,1,'2007-09-15 13:06:59',3310502576,1),(51930118,425518793,15624866,434787,1,'2007-09-15 13:06:59',3310502576,1),(51930119,425518749,15628833,434787,1,'2007-09-15 13:06:59',3310502576,1),(51930121,425518991,15630958,434787,1,'2007-09-15 13:06:59',3310502576,1),(51930124,425519341,15633216,434787,1,'2007-09-15 13:06:59',3310502576,1),(51930125,425520486,15635878,434787,1,'2007-09-15 13:07:00',3310502576,1),(51930127,425522535,15640424,434787,1,'2007-09-15 13:07:00',3310502576,1),(51930129,425525608,15646378,434787,1,'2007-09-15 13:07:00',3310502576,1),(51930132,425527016,15648555,434787,1,'2007-09-15 13:07:00',3310502576,1),(51930134,425528779,15650840,434787,1,'2007-09-15 13:07:00',3310502576,1),(51930136,425530254,15653140,434787,1,'2007-09-15 13:07:00',3310502576,1),(51930138,425531209,15655526,434787,1,'2007-09-15 13:07:00',3310502576,1),(51930141,425532076,15658996,434787,1,'2007-09-15 13:07:00',3310502578,1),(51930143,425533248,15662901,434787,1,'2007-09-15 13:07:01',3310502578,1),(51930145,425534332,15666241,434787,1,'2007-09-15 13:07:01',3310502578,1),(51930148,425536371,15670883,434787,1,'2007-09-15 13:07:01',3310502579,1),(51930149,425538280,15673877,434787,1,'2007-09-15 13:07:01',3310502579,1),(51930152,425540319,15676089,434787,1,'2007-09-15 13:07:01',3310502579,1),(51930153,425542749,15678649,434787,1,'2007-09-15 13:07:01',3310502579,1),(51930156,425544744,15681209,434787,1,'2007-09-15 13:07:01',3310502579,1),(51930158,425546827,15685937,434787,1,'2007-09-15 13:07:02',3310502579,1),(51930160,425548041,15690319,434787,1,'2007-09-15 13:07:02',3310502579,1),(51930163,425549560,15696263,434787,1,'2007-09-15 13:07:02',3310502579,1),(51930165,425550731,15700905,434787,1,'2007-09-15 13:07:02',3310502579,1),(51930167,425551729,15704245,434787,1,'2007-09-15 13:07:02',3310502579,1),(51930169,425553074,15707716,864892,1,'2009-03-28 17:18:56',3310502579,3),(51930171,425554245,15710362,434787,1,'2007-09-15 13:07:02',3310502579,1),(51930173,425557152,15713703,434787,1,'2007-09-15 13:07:02',3310502585,1),(51930175,425558942,15715267,434787,1,'2007-09-15 13:07:02',3310502585,1),(51930177,425560396,15716555,864892,1,'2009-03-28 14:31:35',3310502585,2),(51930178,425561102,15718133,434787,1,'2007-09-15 13:07:02',3310502585,1),(51930181,425561143,15719545,434787,1,'2007-09-15 13:07:03',3310502585,1),(51930184,425560977,15720874,434787,1,'2007-09-15 13:07:03',3310502585,1),(51930186,425560556,15722893,1258067,1,'2009-05-20 09:21:27',3310502585,5),(51930188,425559565,15725900,434787,1,'2007-09-15 13:07:03',3310502585,1),(51930191,425558983,15727769,434787,1,'2007-09-15 13:07:03',3310502585,1),(51930193,425558859,15728890,434787,1,'2007-09-15 13:07:03',3310502585,1),(51930195,425558983,15730136,434787,1,'2007-09-15 13:07:04',3310502585,1),(51930198,425559648,15732005,434787,1,'2007-09-15 13:07:04',3310502585,1),(51930199,425561434,15734580,434787,1,'2007-09-15 13:07:04',3310502585,1),(51930202,425566293,15742596,538211,1,'2007-09-30 15:36:23',3310502588,1),(51930206,425568762,15746342,434787,1,'2007-09-15 13:07:05',3310502588,1),(51930208,425570088,15748839,434787,1,'2007-09-15 13:07:05',3310502588,1),(51930211,425571766,15752194,434787,1,'2007-09-15 13:07:05',3310502588,1),(51930213,425573131,15755003,434787,1,'2007-09-15 13:07:05',3310502588,1),(51930216,425574497,15756992,434787,1,'2007-09-15 13:07:05',3310502588,1),(51930219,425576174,15758085,434787,1,'2007-09-15 13:07:05',3310502588,1),(51930222,425577618,15758787,434787,1,'2007-09-15 13:07:05',3310502588,1),(51930223,425579764,15758943,434787,1,'2007-09-15 13:07:06',3310502588,1),(51930226,425581090,15758826,434787,1,'2007-09-15 13:07:06',3310502588,1),(51930228,425582572,15758163,434787,1,'2007-09-15 13:07:06',3310502588,1),(51930230,425585186,15756758,434787,1,'2007-09-15 13:07:06',3310502588,1),(51930232,425587098,15756017,434787,1,'2007-09-15 13:07:06',3310502588,1),(51930235,425589868,15755393,434787,1,'2007-09-15 13:07:06',3310502589,1),(51930238,425593036,15754768,434787,1,'2007-09-15 13:07:06',3310502589,1),(51930241,425595625,15753473,434787,1,'2007-09-15 13:07:07',3310502589,1),(51930242,425599314,15751532,434787,1,'2007-09-15 13:07:07',3310502589,1),(51930245,425603520,15749137,434787,1,'2007-09-15 13:07:07',3310502589,1),(51930247,425605462,15748037,434787,1,'2007-09-15 13:07:07',3310502589,1),(51930250,425606886,15747584,434787,1,'2007-09-15 13:07:07',3310502589,1),(51930252,425608633,15747390,434787,1,'2007-09-15 13:07:07',3310502589,1),(51930253,425610316,15747714,434787,1,'2007-09-15 13:07:07',3310502589,1),(51930255,425611998,15748684,434787,1,'2007-09-15 13:07:08',3310502589,1),(51930257,425613616,15749267,434787,1,'2007-09-15 13:07:08',3310502589,1),(51930259,425615299,15749267,434787,1,'2007-09-15 13:07:08',3310502589,1),(51930262,425617370,15749137,434787,1,'2007-09-15 13:07:08',3310502632,1),(51930264,425619376,15748814,434787,1,'2007-09-15 13:07:08',3310502632,1),(51930267,425622159,15747908,434787,1,'2007-09-15 13:07:08',3310502632,1),(51930270,425625201,15745837,434787,1,'2007-09-15 13:07:09',3310502632,1),(51930272,425628178,15744478,434787,1,'2007-09-15 13:07:09',3310502632,1),(51930275,425630313,15743442,434787,1,'2007-09-15 13:07:09',3310502632,1),(51930278,425633381,15742692,434787,1,'2007-09-15 13:07:09',3310502632,1),(51930280,425635193,15742743,434787,1,'2007-09-15 13:07:09',3310502632,1),(51930282,425637059,15743369,437032,1,'2008-05-13 19:37:07',3310502632,2),(51930284,425638134,15744914,437032,1,'2008-05-13 19:37:07',3310502632,2),(51930288,425638703,15746974,437032,1,'2008-05-13 19:37:07',3310502632,2),(51930291,425638869,15749060,434787,1,'2007-09-15 13:07:10',3310502632,1),(51930293,425639076,15750872,434787,1,'2007-09-15 13:07:10',3310502632,1),(51930297,425640112,15754289,434787,1,'2007-09-15 13:07:10',3310502632,1),(51930299,425640836,15755946,434787,1,'2007-09-15 13:07:10',3310502632,1),(51930302,425641613,15757965,434787,1,'2007-09-15 13:07:11',3310502632,1),(51930305,425642545,15759156,434787,1,'2007-09-15 13:07:11',3310502632,1),(51930307,425643425,15759984,434787,1,'2007-09-15 13:07:11',3310502632,1),(51930309,425644823,15760605,434787,1,'2007-09-15 13:07:11',3310502633,1),(51930311,425646117,15760709,434787,1,'2007-09-15 13:07:11',3310502633,1),(51930312,425647360,15761071,434787,1,'2007-09-15 13:07:11',3310502633,1),(51930313,425649793,15762159,434787,1,'2007-09-15 13:07:12',3310502633,1),(51930314,425652279,15764074,434787,1,'2007-09-15 13:07:12',3310502633,1),(51930315,425654526,15765306,434787,1,'2007-09-15 13:07:12',3310502633,1),(51930319,425656949,15767419,434787,1,'2007-09-15 13:07:12',3310502635,1),(51930321,425659372,15769469,434787,1,'2007-09-15 13:07:13',3310502635,1),(51930324,425661360,15771954,434787,1,'2007-09-15 13:07:13',3310502635,1),(51930326,425663286,15775682,434787,1,'2007-09-15 13:07:13',3310502635,1),(51930328,425664404,15778851,434787,1,'2007-09-15 13:07:13',3310502635,1),(51930331,425664901,15782268,434787,1,'2007-09-15 13:07:13',3310502635,1),(51930332,425665274,15798545,434787,1,'2007-09-15 13:07:13',3310502635,1),(51930334,425660760,15801808,434787,1,'2007-09-15 13:07:13',3310502635,1),(51930336,425660200,15800179,434787,1,'2007-09-15 13:07:13',3310502635,1),(51930338,425659894,15798652,434787,1,'2007-09-15 13:07:14',3310502635,1),(51930340,425659818,15797660,434787,1,'2007-09-15 13:07:14',3310502635,1),(51930343,425659589,15796362,434787,1,'2007-09-15 13:07:14',3310502635,1),(51930345,425659309,15795293,434787,1,'2007-09-15 13:07:14',3310502635,1),(51930348,425659080,15794224,434787,1,'2007-09-15 13:07:14',3310502635,1),(51930349,425658978,15792850,434787,1,'2007-09-15 13:07:14',3310502635,1),(51930352,425658927,15791323,434787,1,'2007-09-15 13:07:14',3310502635,1),(51930354,425658902,15790254,434787,1,'2007-09-15 13:07:14',3310502635,1),(51930357,425658902,15789135,434787,1,'2007-09-15 13:07:14',3310502635,1),(51930359,425658978,15787837,434787,1,'2007-09-15 13:07:15',3310502635,1),(51930360,425659385,15786513,434787,1,'2007-09-15 13:07:15',3310502635,1),(51930362,425659742,15785317,434787,1,'2007-09-15 13:07:15',3310502635,1),(51930364,425660047,15783714,434787,1,'2007-09-15 13:07:15',3310502635,1),(51930365,425660276,15781831,434787,1,'2007-09-15 13:07:15',3310502635,1),(51930368,425660327,15780533,434787,1,'2007-09-15 13:07:16',3310502635,1),(51930371,425660403,15778472,434787,1,'2007-09-15 13:07:16',3310502635,1),(51930373,425660251,15777199,434787,1,'2007-09-15 13:07:16',3310502635,1),(51930376,425659742,15775673,434787,1,'2007-09-15 13:07:16',3310502635,1),(51930378,425659131,15774604,434787,1,'2007-09-15 13:07:16',3310502635,1),(51930380,425658571,15773357,434787,1,'2007-09-15 13:07:16',3310502635,1),(51930382,425658251,15772251,434787,1,'2007-09-15 13:07:17',3310502635,1),(51930384,425657916,15770024,434787,1,'2007-09-15 13:07:17',3310502635,1),(51930386,425658476,15768715,434787,1,'2007-09-15 13:07:17',3310502635,1),(51930388,425657921,15771127,434787,1,'2007-09-15 13:07:17',3310502635,1),(51930390,425658047,15769441,434787,1,'2007-09-15 13:07:18',3310502635,1),(51930396,425657910,15770462,434787,1,'2007-09-15 13:07:18',3310502635,1),(51930403,425665313,15802579,434787,1,'2007-09-15 13:07:18',3310502635,1),(51930405,425665313,15805560,434787,1,'2007-09-15 13:07:18',3310502635,1),(51930408,425665384,15810174,434787,1,'2007-09-15 13:07:18',3310502635,1),(51930410,425665417,15814775,434787,1,'2007-09-15 13:07:18',3310502635,1),(51930412,425665580,15818267,434787,1,'2007-09-15 13:07:18',3310502635,1),(51930413,425666212,15822738,434787,1,'2007-09-15 13:07:19',3310504001,1),(51930415,425667372,15828204,434787,1,'2007-09-15 13:07:19',3310504001,1),(51930416,425668152,15832605,434787,1,'2007-09-15 13:07:19',3310504001,1),(51930417,425668807,15836191,434787,1,'2007-09-15 13:07:19',3310504001,1),(51930418,425669373,15839249,434787,1,'2007-09-15 13:07:19',3310504001,1),(51930420,425669864,15841930,434787,1,'2007-09-15 13:07:19',3310504001,1),(51930422,425670279,15843780,434787,1,'2007-09-15 13:07:19',3310504001,1),(51930424,425671902,15847555,434787,1,'2007-09-15 13:07:19',3310504004,1),(51930426,425672922,15849065,434787,1,'2007-09-15 13:07:20',3310504004,1),(51930428,425674545,15850688,434787,1,'2007-09-15 13:07:20',3310504004,1),(51930429,425676546,15851897,434787,1,'2007-09-15 13:07:20',3310504004,1),(51930433,425678434,15853180,434787,1,'2007-09-15 13:07:20',3310504004,1),(51930437,425679755,15854464,434787,1,'2007-09-15 13:07:20',3310504004,1),(51930439,425681722,15856542,434787,1,'2007-09-15 13:07:21',3310504004,1),(51930441,425684729,15860375,434787,1,'2007-09-15 13:07:21',3310504004,1),(51930443,425687058,15864133,434787,1,'2007-09-15 13:07:21',3310504004,1),(51930445,425688787,15868191,434787,1,'2007-09-15 13:07:21',3310504004,1),(51930447,425690033,15873362,437032,1,'2008-05-13 19:30:42',3310504004,4),(51930448,425691107,15875679,437032,1,'2008-05-13 19:30:42',3310504006,2),(51930449,425692620,15877210,434787,1,'2007-09-15 13:07:21',3310504006,1),(51930450,425694348,15877961,434787,1,'2007-09-15 13:07:21',3310504006,1),(51930453,425696002,15877961,434787,1,'2007-09-15 13:07:22',3310504006,1),(51930455,425697204,15877285,434787,1,'2007-09-15 13:07:22',3310504006,1),(51930457,425698332,15875932,434787,1,'2007-09-15 13:07:22',3310504006,1),(51930458,425701488,15873602,434787,1,'2007-09-15 13:07:22',3310504005,1),(51930461,425704269,15871724,434787,1,'2007-09-15 13:07:22',3310504005,1),(51930462,425706824,15869920,434787,1,'2007-09-15 13:07:23',3310504005,1),(51930465,425710582,15868342,434787,1,'2007-09-15 13:07:23',3310504005,1),(51930467,425713438,15867214,434787,1,'2007-09-15 13:07:23',3310504005,1),(51930469,425716294,15866162,434787,1,'2007-09-15 13:07:23',3310504005,1),(51930470,425718398,15865411,434787,1,'2007-09-15 13:07:23',3310504005,1),(51930473,425720202,15864809,434787,1,'2007-09-15 13:07:23',3310504005,1),(51930475,425722306,15864885,434787,1,'2007-09-15 13:07:24',3310504005,1),(51930478,425724485,15865411,434787,1,'2007-09-15 13:07:24',3310504005,1),(51930481,425725809,15865656,434787,1,'2007-09-15 13:07:24',3310504005,1),(51930483,425727317,15865471,434787,1,'2007-09-15 13:07:24',3310504016,1),(51930485,425728795,15865102,434787,1,'2007-09-15 13:07:25',3310504016,1),(51930488,425730519,15864548,434787,1,'2007-09-15 13:07:25',3310504016,1),(51930492,425731996,15864271,434787,1,'2007-09-15 13:07:25',3310504016,1),(51930495,425733597,15864332,434787,1,'2007-09-15 13:07:25',3310504016,1),(51930497,425735136,15864455,434787,1,'2007-09-15 13:07:25',3310504016,1),(51930500,425735752,15864763,434787,1,'2007-09-15 13:07:25',3310504016,1),(51930503,425736183,15865656,434787,1,'2007-09-15 13:07:25',3310504016,1),(51930505,425735998,15866425,434787,1,'2007-09-15 13:07:26',3310504016,1),(51930507,425735475,15866887,434787,1,'2007-09-15 13:07:26',3310504016,1),(51930509,425734736,15867010,434787,1,'2007-09-15 13:07:26',3310504016,1),(51930511,425733720,15867472,434787,1,'2007-09-15 13:07:26',3310504016,1),(51930513,425730888,15868765,434787,1,'2007-09-15 13:07:26',3310504016,1),(51930517,425729133,15870304,434787,1,'2007-09-15 13:07:26',3310504016,1),(51930519,425724393,15874398,434787,1,'2007-09-15 13:07:27',3310504005,1),(51930521,425719006,15879262,434787,1,'2007-09-15 13:07:27',3310504007,1),(51930524,425714758,15883695,434787,1,'2007-09-15 13:07:27',3310504007,1),(51930527,425712695,15885665,434787,1,'2007-09-15 13:07:27',3310504007,1),(51930531,425711864,15885819,434787,1,'2007-09-15 13:07:27',3310504007,1),(51930534,425711002,15885819,434787,1,'2007-09-15 13:07:28',3310504007,1),(51930537,425710048,15885542,434787,1,'2007-09-15 13:07:28',3310504007,1),(51930540,425708742,15885117,434787,1,'2007-09-15 13:07:28',3310504007,1),(51930542,425707227,15885117,434787,1,'2007-09-15 13:07:28',3310504007,1),(51930544,425705909,15885644,434787,1,'2007-09-15 13:07:29',3310504007,1),(51930548,425704252,15886547,434787,1,'2007-09-15 13:07:29',3310504007,1),(51930553,425702407,15888053,434787,1,'2007-09-15 13:07:29',3310504007,1),(51930556,425700713,15889484,434787,1,'2007-09-15 13:07:29',3310504007,1),(51930560,425699621,15890764,434787,1,'2007-09-15 13:07:29',3310504007,1),(51930563,425698680,15892459,434787,1,'2007-09-15 13:07:29',3310504006,1),(51930565,425696496,15896826,434787,1,'2007-09-15 13:07:30',3310504006,1),(51930567,425692430,15905749,434787,1,'2007-09-15 13:07:30',3310504006,1),(51930569,425691414,15907707,434787,1,'2007-09-15 13:07:30',3310504006,1),(51930572,425690548,15908610,434787,1,'2007-09-15 13:07:30',3310504006,1),(51930573,425689682,15909137,434787,1,'2007-09-15 13:07:30',3310504006,1),(51930576,425688552,15909928,434787,1,'2007-09-15 13:07:30',3310504006,1),(51930579,425687837,15911095,434787,1,'2007-09-15 13:07:30',3310504006,1),(51930582,425687988,15912187,434787,1,'2007-09-15 13:07:31',3310504006,1),(51930583,425688439,15913015,434787,1,'2007-09-15 13:07:31',3310504006,1),(51930586,425689305,15913053,434787,1,'2007-09-15 13:07:31',3310504006,1),(51930588,425690322,15912375,434787,1,'2007-09-15 13:07:31',3310504006,1),(51930590,425691602,15910982,434787,1,'2007-09-15 13:07:31',3310504006,1);
INSERT INTO `nodes` VALUES (51930593,425693334,15908384,434787,1,'2007-09-15 13:07:31',3310504006,1),(51930595,425694953,15906125,434787,1,'2007-09-15 13:07:32',3310504006,1),(51930597,425696082,15904168,434787,1,'2007-09-15 13:07:32',3310504006,1),(51930599,425697325,15901457,434787,1,'2007-09-15 13:07:32',3310504006,1),(51930602,425699094,15898332,434787,1,'2007-09-15 13:07:32',3310504006,1),(51930604,425700525,15896976,434787,1,'2007-09-15 13:07:33',3310504007,1),(51930606,425701880,15895809,434787,1,'2007-09-15 13:07:33',3310504007,1),(51930609,425703085,15895470,434787,1,'2007-09-15 13:07:33',3310504007,1),(51930611,425704252,15895621,434787,1,'2007-09-15 13:07:33',3310504007,1),(51930614,425707565,15897541,434787,1,'2007-09-15 13:07:33',3310504007,1),(51930616,425711293,15900060,434787,1,'2007-09-15 13:07:33',3310504007,1),(51930619,425713002,15901342,434787,1,'2007-09-15 13:07:33',3310504007,1),(51930621,425714406,15903294,434787,1,'2007-09-15 13:07:33',3310504007,1),(51930623,425715397,15905109,434787,1,'2007-09-15 13:07:34',3310504007,1),(51930626,425713666,15902132,434787,1,'2007-09-15 13:07:34',3310504007,1),(51930628,425712390,15900781,434787,1,'2007-09-15 13:07:34',3310504007,1),(51930630,425711914,15900460,434787,1,'2007-09-15 13:07:34',3310504007,1),(51930633,425716700,15907497,434787,1,'2007-09-15 13:07:34',3310504007,1),(51930636,425717966,15909572,434787,1,'2007-09-15 13:07:35',3310504007,1),(51930638,425719092,15910838,434787,1,'2007-09-15 13:07:35',3310504007,1),(51930640,425720393,15911752,434787,1,'2007-09-15 13:07:35',3310504007,1),(51930641,425721835,15912209,434787,1,'2007-09-15 13:07:35',3310504007,1),(51930643,425723875,15912385,434787,1,'2007-09-15 13:07:35',3310504007,1),(51930645,425725387,15912209,434787,1,'2007-09-15 13:07:35',3310504007,1),(51930648,425726441,15912264,370566,1,'2008-05-09 02:14:25',3310504007,2),(51930650,425727452,15912797,370566,1,'2008-05-09 02:14:25',3310504018,2),(51930652,425728025,15914003,434787,1,'2007-09-15 13:07:36',3310504018,1),(51930653,425727893,15916092,434787,1,'2007-09-15 13:07:36',3310504018,1),(51930656,425727467,15920407,434787,1,'2007-09-15 13:07:36',3310504018,1),(51930657,425726677,15923446,434787,1,'2007-09-15 13:07:36',3310504007,1),(51930661,425725158,15927336,434787,1,'2007-09-15 13:07:37',3310504007,1),(51930663,425723335,15931104,434787,1,'2007-09-15 13:07:37',3310504013,1),(51930665,425723031,15933778,434787,1,'2007-09-15 13:07:37',3310504013,1),(51930668,425722788,15937424,434787,1,'2007-09-15 13:07:38',3310504013,1),(51930671,425722328,15939716,434787,1,'2007-09-15 13:07:38',3310504013,1),(51930674,425721432,15943132,434787,1,'2007-09-15 13:07:38',3310504013,1),(51930676,425720816,15945093,434787,1,'2007-09-15 13:07:38',3310504013,1),(51930680,425720592,15946213,434787,1,'2007-09-15 13:07:39',3310504013,1),(51930682,425720592,15947949,434787,1,'2007-09-15 13:07:39',3310504013,1),(51930684,425721040,15950526,434787,1,'2007-09-15 13:07:39',3310504013,1),(51930686,425721936,15952206,434787,1,'2007-09-15 13:07:40',3310504013,1),(51930687,425723336,15953158,434787,1,'2007-09-15 13:07:40',3310504013,1),(51930689,425724792,15954502,434787,1,'2007-09-15 13:07:40',3310504013,1),(51930691,425725632,15956015,434787,1,'2007-09-15 13:07:40',3310504013,1),(51930692,425725969,15957471,434787,1,'2007-09-15 13:07:40',3310504013,1),(51930695,425725969,15960215,434787,1,'2007-09-15 13:07:40',3310504013,1),(51930697,425725576,15963520,434787,1,'2007-09-15 13:07:40',3310504013,1),(51930699,425724848,15968785,434787,1,'2007-09-15 13:07:40',3310504013,1),(51930702,425724456,15973490,434787,1,'2007-09-15 13:07:41',3310504013,1),(51930705,425724344,15976290,434787,1,'2007-09-15 13:07:41',3310504013,1),(51930706,425724120,15979819,434787,1,'2007-09-15 13:07:41',3310504013,1),(51930709,425724120,15984132,434787,1,'2007-09-15 13:07:41',3310504013,1),(51930712,425724232,15989004,434787,1,'2007-09-15 13:07:41',3310504015,1),(51930713,425724568,15998022,434787,1,'2007-09-15 13:07:41',3310504015,1),(51930716,425724736,16003791,434787,1,'2007-09-15 13:07:42',3310504015,1),(51930718,425725240,16009392,434787,1,'2007-09-15 13:07:42',3310504015,1),(51930721,425725913,16012585,434787,1,'2007-09-15 13:07:42',3310504015,1),(51930723,425726473,16016113,434787,1,'2007-09-15 13:07:42',3310504015,1),(51930726,425726753,16019474,434787,1,'2007-09-15 13:07:42',3310504026,1),(51930727,425726753,16022722,434787,1,'2007-09-15 13:07:42',3310504026,1),(51930729,425726193,16024011,434787,1,'2007-09-15 13:07:42',3310504015,1),(51930731,425725296,16024683,434787,1,'2007-09-15 13:07:43',3310504015,1),(51930732,425724120,16024571,434787,1,'2007-09-15 13:07:43',3310504015,1),(51930734,425723448,16023787,434787,1,'2007-09-15 13:07:43',3310504015,1),(51930736,425723448,16022498,434787,1,'2007-09-15 13:07:43',3310504015,1),(51930738,425723784,16020034,434787,1,'2007-09-15 13:07:43',3310504015,1),(51930741,425724232,16016841,434787,1,'2007-09-15 13:07:43',3310504015,1),(51930743,425724232,16014937,434787,1,'2007-09-15 13:07:44',3310504015,1),(51930745,425723728,16012977,434787,1,'2007-09-15 13:07:44',3310504015,1),(51930748,425723056,16010736,434787,1,'2007-09-15 13:07:44',3310504015,1),(51930750,425722496,16009056,434787,1,'2007-09-15 13:07:44',3310504015,1),(51930751,425721936,16006368,434787,1,'2007-09-15 13:07:44',3310504015,1),(51930754,425721376,16003287,434787,1,'2007-09-15 13:07:45',3310504015,1),(51930756,425720928,15998022,434787,1,'2007-09-15 13:07:45',3310504015,1),(51930758,425720480,15993485,434787,1,'2007-09-15 13:07:45',3310504015,1),(51930761,425719583,15985756,434787,1,'2007-09-15 13:07:45',3310504015,1),(51930762,425718631,15980155,434787,1,'2007-09-15 13:07:45',3310504013,1),(51930765,425718183,15976290,434787,1,'2007-09-15 13:07:45',3310504013,1),(51930768,425717735,15972538,434787,1,'2007-09-15 13:07:45',3310504013,1),(51930769,425717399,15967833,434787,1,'2007-09-15 13:07:46',3310504013,1),(51930771,425717231,15965984,434787,1,'2007-09-15 13:07:46',3310504013,1),(51930775,425716783,15964416,434787,1,'2007-09-15 13:07:46',3310504013,1),(51930777,425715887,15963240,434787,1,'2007-09-15 13:07:46',3310504013,1),(51930779,425714767,15962288,434787,1,'2007-09-15 13:07:46',3310504013,1),(51930781,425713366,15961896,434787,1,'2007-09-15 13:07:46',3310504013,1),(51930783,425712134,15961560,434787,1,'2007-09-15 13:07:47',3310504013,1),(51930786,425710678,15960551,434787,1,'2007-09-15 13:07:47',3310504013,1),(51930788,425709782,15959095,434787,1,'2007-09-15 13:07:47',3310504013,1),(51930790,425708998,15957527,434787,1,'2007-09-15 13:07:47',3310504013,1),(51930793,425708942,15955903,434787,1,'2007-09-15 13:07:47',3310504013,1),(51930794,425708885,15953774,434787,1,'2007-09-15 13:07:48',3310504013,1),(51930797,425708942,15950582,434787,1,'2007-09-15 13:07:48',3310504013,1),(51930800,425708998,15947445,434787,1,'2007-09-15 13:07:48',3310504013,1),(51930802,425709345,15944891,434787,1,'2007-09-15 13:07:48',3310504013,1),(51930806,425709927,15942919,434787,1,'2007-09-15 13:07:48',3310504013,1),(51930807,425710107,15941889,434787,1,'2007-09-15 13:07:49',3310504013,1),(51930808,425710107,15941306,434787,1,'2007-09-15 13:07:49',3310504013,1),(51930809,425709927,15940500,434787,1,'2007-09-15 13:07:49',3310504013,1),(51930812,425709300,15940231,434787,1,'2007-09-15 13:07:49',3310504013,1),(51930814,425708942,15940589,434787,1,'2007-09-15 13:07:49',3310504013,1),(51930815,425708493,15941172,434787,1,'2007-09-15 13:07:49',3310504013,1),(51930816,425707911,15942740,434787,1,'2007-09-15 13:07:50',3310504013,1),(51930818,425707552,15945473,434787,1,'2007-09-15 13:07:50',3310504013,1),(51930821,425707597,15948924,434787,1,'2007-09-15 13:07:50',3310504013,1),(51930823,425707328,15951164,434787,1,'2007-09-15 13:07:50',3310504013,1),(51930826,425706522,15953539,434787,1,'2007-09-15 13:07:50',3310504013,1),(51930828,425705715,15957796,434787,1,'2007-09-15 13:07:50',3310504013,1),(51930830,425706119,15959946,434787,1,'2007-09-15 13:07:50',3310504013,1),(51930831,425707463,15962635,434787,1,'2007-09-15 13:07:51',3310504013,1),(51930834,425708942,15965458,434787,1,'2007-09-15 13:07:51',3310504013,1),(51930836,425710286,15966488,434787,1,'2007-09-15 13:07:51',3310504013,1),(51930839,425711899,15967340,434787,1,'2007-09-15 13:07:51',3310504013,1),(51930840,425712437,15968505,434787,1,'2007-09-15 13:07:51',3310504013,1),(51930843,425712481,15970073,434787,1,'2007-09-15 13:07:51',3310504013,1),(51930844,425711630,15982306,434787,1,'2007-09-15 13:07:51',3310504013,1),(51930847,425710913,15988803,434787,1,'2007-09-15 13:07:52',3310504015,1),(51930850,425710107,15993597,434787,1,'2007-09-15 13:07:52',3310504015,1),(51930851,425709031,15998885,434787,1,'2007-09-15 13:07:52',3310504015,1),(51930854,425707866,16003993,434787,1,'2007-09-15 13:07:52',3310504015,1),(51930855,425707060,16005292,434787,1,'2007-09-15 13:07:52',3310504015,1),(51930858,425706074,16005651,434787,1,'2007-09-15 13:07:52',3310504015,1),(51930859,425705088,16005471,434787,1,'2007-09-15 13:07:52',3310504015,1),(51930862,425704416,16004710,434787,1,'2007-09-15 13:07:52',3310504015,1),(51930864,425704416,16003545,434787,1,'2007-09-15 13:07:53',3310504015,1),(51930865,425704954,16001752,434787,1,'2007-09-15 13:07:53',3310504015,1),(51930866,425706432,15997585,434787,1,'2007-09-15 13:07:53',3310504015,1),(51930867,425706791,15996286,434787,1,'2007-09-15 13:07:53',3310504015,1),(51930869,425706880,15993866,434787,1,'2007-09-15 13:07:53',3310504015,1),(51930871,425706880,15989161,434787,1,'2007-09-15 13:07:53',3310504015,1),(51930873,425706567,15982261,434787,1,'2007-09-15 13:07:53',3310504013,1),(51930876,425706746,15980334,434787,1,'2007-09-15 13:07:53',3310504013,1),(51930879,425707060,15978004,434787,1,'2007-09-15 13:07:54',3310504013,1),(51930882,425707328,15976391,434787,1,'2007-09-15 13:07:54',3310504013,1),(51930883,425707328,15975181,434787,1,'2007-09-15 13:07:54',3310504013,1),(51930885,425707149,15974509,434787,1,'2007-09-15 13:07:54',3310504013,1),(51930887,425706611,15974195,434787,1,'2007-09-15 13:07:54',3310504013,1),(51930889,425705895,15974733,434787,1,'2007-09-15 13:07:54',3310504013,1),(51930891,425705402,15975360,434787,1,'2007-09-15 13:07:55',3310504013,1),(51930893,425704685,15977377,434787,1,'2007-09-15 13:07:55',3310504013,1),(51930895,425703878,15979079,434787,1,'2007-09-15 13:07:55',3310504013,1),(51930896,425703475,15981275,434787,1,'2007-09-15 13:07:55',3310504013,1),(51930898,425703565,15983560,434787,1,'2007-09-15 13:07:55',3310504013,1),(51930900,425703385,15987055,434787,1,'2007-09-15 13:07:55',3310504015,1),(51930901,425702982,15990057,434787,1,'2007-09-15 13:07:55',3310504015,1),(51930905,425702534,15991312,434787,1,'2007-09-15 13:07:56',3310504015,1),(51930907,425701996,15992387,434787,1,'2007-09-15 13:07:56',3310504015,1),(51930908,425701279,15993194,434787,1,'2007-09-15 13:07:56',3310504015,1),(51930909,425700338,15993508,434787,1,'2007-09-15 13:07:56',3310504015,1),(51930911,425699621,15993508,434787,1,'2007-09-15 13:07:56',3310504015,1),(51930913,425698680,15993328,434787,1,'2007-09-15 13:07:56',3310504014,1),(51930915,425697381,15993418,434787,1,'2007-09-15 13:07:57',3310504014,1),(51930918,425696485,15993732,434787,1,'2007-09-15 13:07:57',3310504014,1),(51930920,425695021,15994415,434787,1,'2007-09-15 13:07:57',3310504014,1),(51930923,425693368,15996113,434787,1,'2007-09-15 13:07:57',3310504014,1),(51930926,425691446,15999286,434787,1,'2007-09-15 13:07:57',3310504014,1),(51930928,425689480,16001654,434787,1,'2007-09-15 13:07:58',3310504014,1),(51930930,425687621,16004067,434787,1,'2007-09-15 13:07:58',3310504014,1),(51930932,425686156,16005568,434787,1,'2007-09-15 13:07:58',3310504014,1),(51930935,425684976,16006069,434787,1,'2007-09-15 13:07:58',3310504014,1),(51930937,425684154,16005818,434787,1,'2007-09-15 13:07:58',3310504014,1),(51930940,425683689,16005139,434787,1,'2007-09-15 13:07:58',3310504014,1),(51930942,425683618,16004174,434787,1,'2007-09-15 13:07:58',3310504014,1),(51930944,425683904,16003388,434787,1,'2007-09-15 13:07:59',3310504014,1),(51930947,425684297,16002851,434787,1,'2007-09-15 13:07:59',3310504014,1),(51930950,425685012,16002315,434787,1,'2007-09-15 13:07:59',3310504014,1),(51930952,425686299,16001707,434787,1,'2007-09-15 13:08:00',3310504014,1),(51930953,425687550,16000456,434787,1,'2007-09-15 13:08:00',3310504014,1),(51930954,425688408,15999026,434787,1,'2007-09-15 13:08:00',3310504014,1),(51930956,425689016,15997167,434787,1,'2007-09-15 13:08:00',3310504014,1),(51930958,425689194,15995916,434787,1,'2007-09-15 13:08:00',3310504014,1),(51930961,425689051,15994236,434787,1,'2007-09-15 13:08:00',3310504014,1),(51930962,425688837,15992413,434787,1,'2007-09-15 13:08:00',3310504014,1),(51930965,425688765,15990161,434787,1,'2007-09-15 13:08:01',3310504014,1),(51930967,425689266,15988159,434787,1,'2007-09-15 13:08:01',3310504014,1),(51930968,425690267,15986944,434787,1,'2007-09-15 13:08:01',3310504014,1),(51930971,425692161,15986121,434787,1,'2007-09-15 13:08:01',3310504014,1),(51930973,425693698,15985335,434787,1,'2007-09-15 13:08:01',3310504012,1),(51930974,425694664,15984549,434787,1,'2007-09-15 13:08:01',3310504012,1),(51930975,425696094,15983154,434787,1,'2007-09-15 13:08:01',3310504012,1),(51930976,425696523,15981188,434787,1,'2007-09-15 13:08:01',3310504012,1),(51930978,425696594,15979437,434787,1,'2007-09-15 13:08:02',3310504012,1),(51930981,425696594,15978078,434787,1,'2007-09-15 13:08:02',3310504012,1),(51930983,425695700,15976291,434787,1,'2007-09-15 13:08:02',3310504012,1),(51930984,425694092,15974897,434787,1,'2007-09-15 13:08:02',3310504012,1),(51930985,425691625,15972716,434787,1,'2007-09-15 13:08:03',3310504012,1),(51930986,425688908,15970571,434787,1,'2007-09-15 13:08:03',3310504012,1),(51930987,425687872,15970214,434787,1,'2007-09-15 13:08:03',3310504012,1),(51930990,425686334,15969856,434787,1,'2007-09-15 13:08:03',3310504012,1),(51930992,425684404,15969606,434787,1,'2007-09-15 13:08:03',3310504012,1),(51930995,425683046,15969034,434787,1,'2007-09-15 13:08:03',3310504012,1),(51930998,425681473,15967926,434787,1,'2007-09-15 13:08:04',3310504012,1),(51930999,425679578,15966210,434787,1,'2007-09-15 13:08:04',3310504012,1),(51931002,425677969,15963672,434787,1,'2007-09-15 13:08:04',3310504012,1),(51931005,425677183,15961741,434787,1,'2007-09-15 13:08:04',3310504012,1),(51931006,425676611,15958667,434787,1,'2007-09-15 13:08:04',3310504012,1),(51931009,425675949,15955049,434787,1,'2007-09-15 13:08:04',3310504012,1),(51931012,425675405,15951906,434787,1,'2007-09-15 13:08:04',3310504012,1),(51931014,425674317,15948219,434787,1,'2007-09-15 13:08:05',3310504012,1),(51931018,425672927,15946285,434787,1,'2007-09-15 13:08:05',3310504012,1),(51931020,425670872,15944049,434787,1,'2007-09-15 13:08:05',3310504009,1),(51931023,425668998,15941269,434787,1,'2007-09-15 13:08:05',3310504009,1),(51931025,425666097,15936554,434787,1,'2007-09-15 13:08:05',3310504009,1),(51931026,425664163,15933895,434787,1,'2007-09-15 13:08:05',3310504009,1),(51931029,425662350,15932263,434787,1,'2007-09-15 13:08:06',3310504009,1),(51931032,425660597,15930571,434787,1,'2007-09-15 13:08:06',3310504009,1),(51931036,425658723,15927911,434787,1,'2007-09-15 13:08:06',3310504003,1),(51931037,425657575,15925856,434787,1,'2007-09-15 13:08:06',3310504003,1),(51931040,425656047,15924149,434787,1,'2007-09-15 13:08:06',3310504003,1),(51931043,425654593,15922819,434787,1,'2007-09-15 13:08:06',3310504003,1),(51931045,425652488,15920745,434787,1,'2007-09-15 13:08:07',3310504003,1),(51931047,425651374,15919322,434787,1,'2007-09-15 13:08:07',3310504003,1),(51931050,425649951,15916568,434787,1,'2007-09-15 13:08:07',3310504003,1),(51931053,425649239,15915918,434787,1,'2007-09-15 13:08:07',3310504003,1),(51931055,425648651,15915887,434787,1,'2007-09-15 13:08:07',3310504003,1),(51931057,425648311,15916413,434787,1,'2007-09-15 13:08:07',3310504003,1),(51931060,425648125,15916939,434787,1,'2007-09-15 13:08:07',3310504003,1),(51931062,425648342,15917991,434787,1,'2007-09-15 13:08:08',3310504003,1),(51931065,425649115,15919446,434787,1,'2007-09-15 13:08:08',3310504003,1),(51931066,425651405,15922726,434787,1,'2007-09-15 13:08:08',3310504003,1),(51931069,425653045,15924242,434787,1,'2007-09-15 13:08:08',3310504003,1),(51931070,425654221,15926377,434787,1,'2007-09-15 13:08:08',3310504003,1),(51931073,425657409,15931948,434787,1,'2007-09-15 13:08:09',3310504009,1),(51931076,425663258,15940767,434787,1,'2007-09-15 13:08:09',3310504009,1),(51931077,425665764,15944976,434787,1,'2007-09-15 13:08:09',3310504009,1),(51931080,425666754,15948504,434787,1,'2007-09-15 13:08:09',3310504009,1),(51931084,425667219,15952557,434787,1,'2007-09-15 13:08:09',3310504009,1),(51931087,425666909,15955312,434787,1,'2007-09-15 13:08:09',3310504009,1),(51931090,425664485,15961121,434787,1,'2007-09-15 13:08:09',3310504009,1),(51931093,425662908,15963986,434787,1,'2007-09-15 13:08:09',3310504009,1),(51931095,425661936,15966089,434787,1,'2007-09-15 13:08:09',3310504009,1),(51931097,425661200,15966772,434787,1,'2007-09-15 13:08:10',3310504009,1),(51931099,425660648,15966956,434787,1,'2007-09-15 13:08:10',3310504009,1),(51931101,425660043,15966825,434787,1,'2007-09-15 13:08:10',3310504009,1),(51931103,425659386,15966510,434787,1,'2007-09-15 13:08:11',3310504009,1),(51931105,425658680,15966344,434787,1,'2007-09-15 13:08:11',3310504009,1),(51951640,426315393,14854723,434787,1,'2007-09-15 13:47:46',3310503081,1),(51951645,426316435,14864695,434787,1,'2007-09-15 13:47:46',3310503081,1),(51951647,426317923,14873922,434787,1,'2007-09-15 13:47:46',3310503081,1),(51951648,426320453,14882704,434787,1,'2007-09-15 13:47:46',3310503081,1),(51951650,426324025,14890443,434787,1,'2007-09-15 13:47:47',3310503083,1),(51951652,426327597,14897438,434787,1,'2007-09-15 13:47:47',3310503083,1),(51951654,426329681,14902350,434787,1,'2007-09-15 13:47:47',3310503083,1),(51951657,426329830,14905326,434787,1,'2007-09-15 13:47:47',3310503083,1),(51951658,426328342,14910833,434787,1,'2007-09-15 13:47:47',3310503083,1),(51951661,426327449,14919466,434787,1,'2007-09-15 13:47:48',3310503083,1),(51951665,426327151,14929586,434787,1,'2007-09-15 13:47:48',3310503083,1),(51951667,426326556,14935688,434787,1,'2007-09-15 13:47:48',3310503083,1),(51951670,426325514,14945660,434787,1,'2007-09-15 13:47:48',3310503425,1),(51951673,426324770,14954144,434787,1,'2007-09-15 13:47:48',3310503425,1),(51951676,426322984,14959353,434787,1,'2007-09-15 13:47:48',3310503425,1),(51951678,426321198,14961139,434787,1,'2007-09-15 13:47:49',3310503425,1),(51951680,426319147,14962559,434787,1,'2007-09-15 13:47:49',3310503425,1),(51951682,426317197,14963534,434787,1,'2007-09-15 13:47:49',3310503425,1),(51951684,426315185,14964144,434787,1,'2007-09-15 13:47:49',3310503425,1),(51951686,426313112,14963900,434787,1,'2007-09-15 13:47:49',3310503425,1),(51951689,426311588,14963230,434787,1,'2007-09-15 13:47:49',3310503425,1),(51951690,426310918,14962315,434787,1,'2007-09-15 13:47:49',3310503425,1),(51951692,426308113,14960608,434787,1,'2007-09-15 13:47:50',3310503425,1),(51951694,426306163,14959511,434787,1,'2007-09-15 13:47:50',3310503425,1),(51951696,426304334,14957499,434787,1,'2007-09-15 13:47:50',3310503425,1),(51951700,426302078,14954085,434787,1,'2007-09-15 13:47:50',3310503424,1),(51951701,426300066,14950976,434787,1,'2007-09-15 13:47:51',3310503424,1),(51951703,426298298,14947745,434787,1,'2007-09-15 13:47:51',3310503424,1),(51951706,426296287,14944270,434787,1,'2007-09-15 13:47:51',3310503424,1),(51951709,426293787,14940186,434787,1,'2007-09-15 13:47:51',3310503082,1),(51951711,426290678,14936894,434787,1,'2007-09-15 13:47:51',3310503082,1),(51951713,426288118,14934212,434787,1,'2007-09-15 13:47:51',3310503082,1),(51951716,426285740,14932931,434787,1,'2007-09-15 13:47:51',3310503082,1),(51951719,426283850,14932261,434787,1,'2007-09-15 13:47:52',3310503082,1),(51951723,426282326,14932261,434787,1,'2007-09-15 13:47:52',3310503082,1),(51951726,426280985,14932444,434787,1,'2007-09-15 13:47:52',3310503082,1),(51951729,426279339,14933785,434787,1,'2007-09-15 13:47:52',3310503082,1),(51951731,426278059,14933724,434787,1,'2007-09-15 13:47:52',3310503082,1),(51951734,426276718,14933480,434787,1,'2007-09-15 13:47:52',3310503082,1),(51951736,426275377,14932017,434787,1,'2007-09-15 13:47:52',3310502399,1),(51951739,426274096,14931590,434787,1,'2007-09-15 13:47:53',3310502399,1),(51951741,426272938,14931895,434787,1,'2007-09-15 13:47:53',3310502399,1),(51951744,426272572,14932992,434787,1,'2007-09-15 13:47:53',3310502399,1),(51951747,426272572,14933541,434787,1,'2007-09-15 13:47:53',3310502399,1),(51951748,426273548,14934699,434787,1,'2007-09-15 13:47:53',3310502399,1),(51951751,426275072,14935553,434787,1,'2007-09-15 13:47:54',3310502399,1),(51951755,426278730,14937382,434787,1,'2007-09-15 13:47:54',3310503082,1),(51951758,426281351,14939088,434787,1,'2007-09-15 13:47:54',3310503082,1),(51951761,426284399,14941466,434787,1,'2007-09-15 13:47:54',3310503082,1),(51951763,426286411,14943783,434787,1,'2007-09-15 13:47:54',3310503424,1),(51951766,426287813,14945002,434787,1,'2007-09-15 13:47:54',3310503424,1),(51951769,426289703,14946038,434787,1,'2007-09-15 13:47:55',3310503424,1),(51951772,426290251,14946953,434787,1,'2007-09-15 13:47:55',3310503424,1),(51951775,426290068,14948233,434787,1,'2007-09-15 13:47:55',3310503424,1),(51951777,426289215,14948599,434787,1,'2007-09-15 13:47:55',3310503424,1),(51951780,426287996,14947928,434787,1,'2007-09-15 13:47:55',3310503424,1),(51951784,426286655,14947014,434787,1,'2007-09-15 13:47:55',3310503424,1),(51951785,426285070,14945733,434787,1,'2007-09-15 13:47:55',3310503424,1),(51951788,426282387,14944209,434787,1,'2007-09-15 13:47:56',3310503424,1),(51951790,426280254,14942685,434787,1,'2007-09-15 13:47:56',3310503424,1),(51951793,426279034,14941954,434787,1,'2007-09-15 13:47:56',3310503424,1),(51951796,426277937,14942015,434787,1,'2007-09-15 13:47:56',3310503424,1),(51951799,426277388,14942563,434787,1,'2007-09-15 13:47:56',3310503424,1),(51951801,426277205,14943661,434787,1,'2007-09-15 13:47:57',3310503424,1),(51951805,426277510,14944453,434787,1,'2007-09-15 13:47:57',3310503424,1),(51951808,426278181,14945490,434787,1,'2007-09-15 13:47:57',3310503424,1),(51951810,426279644,14946160,434787,1,'2007-09-15 13:47:58',3310503424,1),(51951813,426281656,14946770,434787,1,'2007-09-15 13:47:58',3310503424,1),(51951816,426282997,14948416,434787,1,'2007-09-15 13:47:58',3310503424,1),(51951817,426284765,14950549,434787,1,'2007-09-15 13:47:58',3310503424,1),(51951819,426288057,14952866,434787,1,'2007-09-15 13:47:58',3310503424,1),(51951821,426291532,14955183,434787,1,'2007-09-15 13:47:58',3310503424,1),(51951824,426293482,14956646,434787,1,'2007-09-15 13:47:58',3310503424,1),(51951827,426294153,14957743,434787,1,'2007-09-15 13:47:59',3310503424,1),(51951830,426294214,14958901,434787,1,'2007-09-15 13:47:59',3310503424,1),(51951833,426293665,14959877,434787,1,'2007-09-15 13:47:59',3310503424,1),(51951836,426292812,14960120,434787,1,'2007-09-15 13:47:59',3310503424,1),(51951838,426291775,14959694,434787,1,'2007-09-15 13:47:59',3310503424,1),(51951840,426290068,14958596,434787,1,'2007-09-15 13:47:59',3310503424,1),(51951843,426288910,14957987,434787,1,'2007-09-15 13:48:00',3310503424,1),(51951846,426287569,14957499,434787,1,'2007-09-15 13:48:00',3310503424,1),(51951848,426286106,14958170,434787,1,'2007-09-15 13:48:00',3310503424,1),(51951851,426284399,14958901,434787,1,'2007-09-15 13:48:00',3310503424,1),(51951854,426282753,14959267,434787,1,'2007-09-15 13:48:00',3310503424,1),(51951857,426280863,14959694,434787,1,'2007-09-15 13:48:00',3310503424,1),(51951858,426279888,14960425,434787,1,'2007-09-15 13:48:01',3310503424,1),(51951859,426279522,14961584,434787,1,'2007-09-15 13:48:01',3310503424,1),(51951861,426279949,14962559,434787,1,'2007-09-15 13:48:01',3310503424,1),(51951864,426281229,14963778,434787,1,'2007-09-15 13:48:01',3310503424,1),(51951865,426282814,14964266,434787,1,'2007-09-15 13:48:01',3310503424,1),(51951868,426285496,14964022,434787,1,'2007-09-15 13:48:02',3310503424,1),(51951872,426288423,14963839,434787,1,'2007-09-15 13:48:02',3310503424,1),(51951874,426290495,14964144,434787,1,'2007-09-15 13:48:02',3310503424,1),(51951876,426292873,14964876,434787,1,'2007-09-15 13:48:02',3310503424,1),(51951879,426296287,14966826,434787,1,'2007-09-15 13:48:02',3310503424,1),(51951882,426298542,14968655,434787,1,'2007-09-15 13:48:02',3310503424,1),(51951885,426298725,14969509,434787,1,'2007-09-15 13:48:02',3310503424,1),(51951886,426298542,14970423,434787,1,'2007-09-15 13:48:03',3310503424,1),(51951889,426297933,14971033,434787,1,'2007-09-15 13:48:03',3310503424,1),(51951892,426296652,14971094,434787,1,'2007-09-15 13:48:03',3310503424,1),(51951895,426295494,14970667,434787,1,'2007-09-15 13:48:03',3310503424,1),(51951898,426294275,14970545,434787,1,'2007-09-15 13:48:03',3310503424,1),(51951900,426293178,14970484,434787,1,'2007-09-15 13:48:03',3310503424,1),(51951903,426291410,14970972,434787,1,'2007-09-15 13:48:04',3310503424,1),(51951905,426289764,14971581,434787,1,'2007-09-15 13:48:04',3310503424,1),(51951908,426286411,14974203,434787,1,'2007-09-15 13:48:04',3310503424,1),(51951911,426284033,14975361,434787,1,'2007-09-15 13:48:04',3310503424,1),(51951914,426282448,14976580,434787,1,'2007-09-15 13:48:04',3310503424,1),(51951917,426282448,14978531,434787,1,'2007-09-15 13:48:04',3310503424,1),(51951920,426282936,14979506,434787,1,'2007-09-15 13:48:04',3310503424,1),(51951922,426284033,14979811,434787,1,'2007-09-15 13:48:05',3310503424,1),(51951924,426284826,14979263,434787,1,'2007-09-15 13:48:05',3310503424,1),(51951927,426286167,14977678,434787,1,'2007-09-15 13:48:05',3310503424,1),(51951930,426287569,14977190,434787,1,'2007-09-15 13:48:05',3310503424,1),(51951933,426291288,14977495,434787,1,'2007-09-15 13:48:05',3310503424,1),(51951935,426294458,14977190,434787,1,'2007-09-15 13:48:05',3310503424,1),(51951937,426298725,14976580,434787,1,'2007-09-15 13:48:05',3310503424,1),(51951938,426300737,14976215,434787,1,'2007-09-15 13:48:05',3310503424,1),(51951941,426301712,14976215,434787,1,'2007-09-15 13:48:06',3310503424,1),(51951944,426302383,14976824,434787,1,'2007-09-15 13:48:06',3310503424,1),(51951947,426302627,14978165,434787,1,'2007-09-15 13:48:06',3310503424,1),(51951950,426302383,14979263,434787,1,'2007-09-15 13:48:06',3310503424,1),(51951953,426301164,14980055,434787,1,'2007-09-15 13:48:06',3310503424,1),(51951956,426298237,14982067,434787,1,'2007-09-15 13:48:06',3310503424,1),(51951957,426294336,14985237,434787,1,'2007-09-15 13:48:07',3310503424,1),(51951960,426292080,14987614,434787,1,'2007-09-15 13:48:07',3310503424,1),(51951963,426291044,14989321,434787,1,'2007-09-15 13:48:07',3310503424,1),(51951965,426291227,14990419,434787,1,'2007-09-15 13:48:07',3310503424,1),(51951966,426292080,14990845,434787,1,'2007-09-15 13:48:07',3310503424,1),(51951969,426292995,14990845,434787,1,'2007-09-15 13:48:07',3310503424,1),(51951970,426297567,14988590,434787,1,'2007-09-15 13:48:07',3310503424,1),(51951973,426301468,14986212,434787,1,'2007-09-15 13:48:07',3310503424,1),(51951975,426304456,14983957,434787,1,'2007-09-15 13:48:08',3310503425,1),(51951978,426306406,14982494,434787,1,'2007-09-15 13:48:08',3310503425,1),(51951980,426307066,14981746,434787,1,'2007-09-15 13:48:08',3310503425,1),(51951983,426307952,14981999,434787,1,'2007-09-15 13:48:08',3310503425,1),(51951985,426308459,14983076,434787,1,'2007-09-15 13:48:08',3310503425,1),(51951988,426307952,14984406,434787,1,'2007-09-15 13:48:09',3310503425,1),(51951989,426306432,14985989,434787,1,'2007-09-15 13:48:09',3310503425,1),(51951992,426303773,14989662,434787,1,'2007-09-15 13:48:09',3310503425,1),(51951995,426301936,14992575,434787,1,'2007-09-15 13:48:09',3310503424,1),(51951999,426300606,14994222,434787,1,'2007-09-15 13:48:09',3310503424,1),(51952002,426299213,14994412,434787,1,'2007-09-15 13:48:09',3310503424,1),(51952005,426297820,14994348,434787,1,'2007-09-15 13:48:10',3310503424,1),(51952009,426297060,14994855,434787,1,'2007-09-15 13:48:10',3310503424,1),(51952013,426296933,14995805,434787,1,'2007-09-15 13:48:10',3310503424,1),(51952014,426296933,14996881,434787,1,'2007-09-15 13:48:10',3310503426,1),(51952017,426297440,14998021,434787,1,'2007-09-15 13:48:11',3310503426,1),(51952019,426298390,14998021,434787,1,'2007-09-15 13:48:11',3310503426,1),(51952022,426299656,14998021,434787,1,'2007-09-15 13:48:11',3310503426,1),(51952025,426300859,14997325,434787,1,'2007-09-15 13:48:11',3310503426,1),(51952028,426302189,14996438,434787,1,'2007-09-15 13:48:11',3310503424,1),(51952029,426304976,14993652,434787,1,'2007-09-15 13:48:12',3310503425,1),(51952031,426306749,14992068,434787,1,'2007-09-15 13:48:12',3310503425,1),(51952034,426308142,14992005,434787,1,'2007-09-15 13:48:12',3310503425,1),(51952037,426310422,14992005,434787,1,'2007-09-15 13:48:12',3310503425,1),(51952039,426314665,14992448,434787,1,'2007-09-15 13:48:12',3310503425,1),(51952042,426317388,14992702,434787,1,'2007-09-15 13:48:12',3310503425,1),(51952045,426318781,14993525,434787,1,'2007-09-15 13:48:13',3310503425,1),(51952046,426321061,14996058,434787,1,'2007-09-15 13:48:13',3310503425,1),(51952048,426323784,14998021,434787,1,'2007-09-15 13:48:13',3310503427,1),(51952050,426326381,14999414,434787,1,'2007-09-15 13:48:13',3310503427,1),(51952053,426327584,14999984,434787,1,'2007-09-15 13:48:14',3310503427,1),(51952055,426327710,15000998,434787,1,'2007-09-15 13:48:14',3310503427,1),(51952058,426327520,15001884,434787,1,'2007-09-15 13:48:14',3310503427,1),(51952060,426326824,15002264,434787,1,'2007-09-15 13:48:14',3310503427,1),(51952063,426325747,15002201,434787,1,'2007-09-15 13:48:14',3310503427,1),(51952065,426324354,15001504,434787,1,'2007-09-15 13:48:14',3310503427,1),(51952068,426322644,15000491,434787,1,'2007-09-15 13:48:15',3310503427,1),(51952069,426320998,14999668,434787,1,'2007-09-15 13:48:15',3310503427,1),(51952073,426319288,14999794,434787,1,'2007-09-15 13:48:15',3310503427,1),(51952075,426317578,15001251,434787,1,'2007-09-15 13:48:15',3310503427,1),(51952078,426316501,15003214,434787,1,'2007-09-15 13:48:15',3310503427,1),(51952080,426316438,15005431,434787,1,'2007-09-15 13:48:15',3310503427,1),(51952083,426316248,15007710,434787,1,'2007-09-15 13:48:16',3310503427,1),(51952084,426315551,15009737,434787,1,'2007-09-15 13:48:16',3310503427,1),(51952087,426314348,15010623,434787,1,'2007-09-15 13:48:16',3310503427,1),(51952090,426312765,15011320,434787,1,'2007-09-15 13:48:16',3310503427,1),(51952093,426311499,15011510,434787,1,'2007-09-15 13:48:17',3310503427,1),(51952096,426310485,15012713,434787,1,'2007-09-15 13:48:17',3310503427,1),(51952099,426309979,15014170,434787,1,'2007-09-15 13:48:17',3310503427,1),(51952101,426310295,15017273,434787,1,'2007-09-15 13:48:17',3310503427,1),(51952103,426311688,15023289,434787,1,'2007-09-15 13:48:18',3310503427,1),(51952105,426315108,15035448,434787,1,'2007-09-15 13:48:18',3310503427,1),(51952107,426319035,15047670,434787,1,'2007-09-15 13:48:18',3310503427,1),(51952110,426320382,15052106,434787,1,'2007-09-15 13:48:18',3310503433,1),(51952111,426321322,15056879,434787,1,'2007-09-15 13:48:18',3310503433,1),(51952113,426321595,15061937,434787,1,'2007-09-15 13:48:18',3310503433,1),(51952115,426321284,15068162,434787,1,'2007-09-15 13:48:18',3310503433,1),(51952118,426320894,15070886,434787,1,'2007-09-15 13:48:19',3310503433,1),(51952120,426320468,15072599,434787,1,'2007-09-15 13:48:19',3310503433,1),(51952122,426320023,15073775,434787,1,'2007-09-15 13:48:19',3310503433,1),(51952125,426319453,15074759,434787,1,'2007-09-15 13:48:19',3310503433,1),(51952126,426318327,15075959,434787,1,'2007-09-15 13:48:19',3310503433,1),(51952128,426317200,15077122,434787,1,'2007-09-15 13:48:19',3310503433,1),(51952132,426316097,15078850,434787,1,'2007-09-15 13:48:19',3310503433,1),(51952136,426315620,15080251,434787,1,'2007-09-15 13:48:19',3310503433,1),(51952139,426314548,15083946,434787,1,'2007-09-15 13:48:20',3310503433,1),(51952141,426313833,15087402,434787,1,'2007-09-15 13:48:20',3310503433,1),(51952145,426313415,15089578,434787,1,'2007-09-15 13:48:20',3310503433,1),(51952148,426313535,15091127,434787,1,'2007-09-15 13:48:20',3310503433,1),(51952150,426313773,15092647,434787,1,'2007-09-15 13:48:20',3310503433,1),(51952152,426313684,15094137,434787,1,'2007-09-15 13:48:20',3310503433,1),(51952155,426313445,15095001,434787,1,'2007-09-15 13:48:21',3310503433,1),(51952157,426313088,15096879,434787,1,'2007-09-15 13:48:21',3310503433,1),(51952159,426313117,15097951,434787,1,'2007-09-15 13:48:21',3310503433,1),(51952161,426313356,15098547,434787,1,'2007-09-15 13:48:21',3310503433,1),(51952163,426313803,15099143,434787,1,'2007-09-15 13:48:21',3310503433,1),(51952167,426314429,15099441,434787,1,'2007-09-15 13:48:21',3310503433,1),(51952170,426315054,15099352,434787,1,'2007-09-15 13:48:21',3310503433,1),(51952172,426315620,15098935,434787,1,'2007-09-15 13:48:22',3310503433,1),(51952176,426316216,15098130,434787,1,'2007-09-15 13:48:22',3310503433,1),(51952177,426316514,15097147,434787,1,'2007-09-15 13:48:22',3310503433,1),(51952180,426316604,15096342,434787,1,'2007-09-15 13:48:22',3310503433,1),(51952183,426316485,15095329,434787,1,'2007-09-15 13:48:22',3310503433,1),(51952185,426316276,15094197,434787,1,'2007-09-15 13:48:23',3310503433,1),(51952187,426316127,15092737,434787,1,'2007-09-15 13:48:23',3310503433,1),(51952190,426316097,15091425,434787,1,'2007-09-15 13:48:23',3310503433,1),(51952192,426316365,15089965,434787,1,'2007-09-15 13:48:23',3310503433,1),(51952193,426317468,15086747,434787,1,'2007-09-15 13:48:23',3310503433,1),(51952195,426318392,15084542,434787,1,'2007-09-15 13:48:23',3310503433,1),(51952196,426319375,15083231,434787,1,'2007-09-15 13:48:23',3310503433,1),(51952199,426320508,15081979,434787,1,'2007-09-15 13:48:23',3310503433,1),(51952201,426321253,15080578,434787,1,'2007-09-15 13:48:24',3310503433,1),(51952204,426321878,15079655,434787,1,'2007-09-15 13:48:24',3310503433,1),(51952205,426322504,15079178,434787,1,'2007-09-15 13:48:24',3310503433,1),(51952207,426323309,15079327,434787,1,'2007-09-15 13:48:24',3310503433,1),(51952210,426323964,15080161,434787,1,'2007-09-15 13:48:24',3310503433,1),(51952213,426324143,15081025,434787,1,'2007-09-15 13:48:24',3310503433,1),(51952215,426323786,15082158,434787,1,'2007-09-15 13:48:24',3310503433,1),(51952217,426323130,15082933,434787,1,'2007-09-15 13:48:24',3310503433,1),(51952220,426322415,15083350,434787,1,'2007-09-15 13:48:24',3310503433,1),(51952223,426321372,15084274,434787,1,'2007-09-15 13:48:24',3310503433,1),(51952226,426320835,15085138,434787,1,'2007-09-15 13:48:25',3310503433,1),(51952230,426320180,15087164,434787,1,'2007-09-15 13:48:25',3310503433,1),(51952233,426319763,15089488,434787,1,'2007-09-15 13:48:25',3310503433,1),(51952236,426319763,15093213,434787,1,'2007-09-15 13:48:25',3310503433,1),(51952238,426319733,15096372,434787,1,'2007-09-15 13:48:25',3310503433,1),(51952240,426319554,15097415,434787,1,'2007-09-15 13:48:25',3310503433,1),(51952243,426319345,15098488,434787,1,'2007-09-15 13:48:25',3310503433,1),(51952246,426318839,15099650,434787,1,'2007-09-15 13:48:26',3310503433,1),(51952248,426318451,15100365,434787,1,'2007-09-15 13:48:26',3310503433,1),(51952250,426317913,15102097,434787,1,'2007-09-15 13:48:26',3310503433,1),(51952252,426317655,15103488,434787,1,'2007-09-15 13:48:26',3310503433,1),(51952255,426317758,15104930,434787,1,'2007-09-15 13:48:26',3310503433,1),(51952256,426318119,15106629,434787,1,'2007-09-15 13:48:26',3310503435,1),(51952259,426318953,15109101,434787,1,'2007-09-15 13:48:26',3310503435,1),(51952261,426319777,15111243,206510,1,'2008-12-06 19:38:24',3310503435,4),(51952264,426320395,15113096,206510,1,'2008-12-06 19:38:24',3310503435,4),(51952267,426320395,15114662,206510,1,'2008-12-06 19:38:24',3310503435,4),(51952269,426320106,15115857,206510,1,'2008-12-06 19:38:24',3310503435,4),(51952271,426319340,15117298,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952274,426318220,15119638,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952276,426317629,15121487,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952279,426317283,15122903,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952280,426317126,15124193,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952284,426316811,15126760,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952287,426317000,15128422,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952290,426317604,15129554,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952292,426318850,15130423,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952295,426319832,15131442,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952297,426320814,15133254,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952300,426321191,15135067,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952303,426321304,15137068,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952305,426321113,15138218,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952306,426320411,15140322,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952307,426319643,15142293,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952311,426318741,15145634,206510,1,'2008-12-06 19:38:23',3310503435,4),(51952316,426317806,15149442,206510,1,'2008-12-06 19:38:22',3310503435,4),(51952320,426317438,15151680,206510,1,'2008-12-06 19:38:22',3310503435,4),(51952323,426315915,15158197,206510,1,'2008-12-06 19:38:22',3310503435,4),(51952325,426315248,15161445,206510,1,'2008-12-06 19:38:22',3310503457,4),(51952328,426314332,15163485,206510,1,'2008-12-06 19:38:22',3310503457,4),(51952330,426313166,15166567,206510,1,'2008-12-06 19:38:22',3310503457,4),(51952333,426312417,15169731,206510,1,'2008-12-06 19:38:22',3310503457,4),(51952335,426311841,15173744,206510,1,'2008-12-06 19:38:22',3310503457,4),(51952338,426311290,15176408,206510,1,'2008-12-06 19:38:22',3310503457,4),(51952341,426310922,15179025,206510,1,'2008-12-06 19:38:21',3310503457,4),(51952343,426310417,15182699,206510,1,'2008-12-06 19:38:21',3310503457,4),(51952345,426308993,15188899,206510,1,'2008-12-06 19:38:21',3310503457,4),(51952347,426307715,15193479,206510,1,'2008-12-06 19:38:21',3310503457,4),(51952350,426306561,15197161,206510,1,'2008-12-06 19:38:21',3310503457,4),(51952351,426305242,15200514,206510,1,'2008-12-06 19:38:21',3310503457,4),(51952354,426304198,15205075,206510,1,'2008-12-06 19:38:21',3310503457,4),(51952359,426303813,15207438,206510,1,'2008-12-06 19:38:21',3310503457,4),(51952362,426303264,15210241,206510,1,'2008-12-06 19:38:20',3310503456,4),(51952365,426302219,15212165,206510,1,'2008-12-06 19:38:20',3310503456,4),(51952367,426301450,15213374,206510,1,'2008-12-06 19:38:20',3310503456,4),(51952369,426300296,15215297,206510,1,'2008-12-06 19:38:20',3310503456,4),(51952373,426298922,15218155,206510,1,'2008-12-06 19:38:20',3310503458,4),(51952376,426297493,15221475,206510,1,'2008-12-06 19:38:20',3310503458,4),(51952378,426296570,15224200,206510,1,'2008-12-06 19:38:20',3310503458,4),(51952382,426295602,15226443,206510,1,'2008-12-06 19:38:20',3310503458,4),(51952385,426294899,15228157,206510,1,'2008-12-06 19:38:20',3310503458,4),(51952388,426293844,15229564,206510,1,'2008-12-06 19:38:20',3310503458,4),(51952390,426292877,15230312,206510,1,'2008-12-06 19:38:19',3310503458,4),(51952394,426290546,15232598,206510,1,'2008-12-06 19:38:19',3310503458,4),(51952396,426289051,15233961,206510,1,'2008-12-06 19:38:19',3310503458,4),(51952399,426287688,15234840,206510,1,'2008-12-06 19:38:19',3310503458,4),(51952403,426286809,15235368,206510,1,'2008-12-06 19:38:19',3310503458,4),(51952405,426284303,15236379,206510,1,'2008-12-06 19:38:19',3310503458,4),(51952408,426282940,15236555,206510,1,'2008-12-06 19:38:19',3310503458,4),(51952411,426280522,15236643,206510,1,'2008-12-06 19:38:19',3310503458,4),(51952413,426278192,15236775,206510,1,'2008-12-06 19:38:19',3310503458,4),(51952416,426276786,15237483,206510,1,'2008-12-06 19:38:19',3310503458,4),(51952418,426275755,15238583,206510,1,'2008-12-06 19:38:19',3310502775,4),(51952420,426274994,15239418,206510,1,'2008-12-06 19:38:19',3310502775,4),(51952423,426273239,15240830,206510,1,'2008-12-06 19:38:18',3310502775,4),(51952426,426270378,15241749,206510,1,'2008-12-06 19:38:18',3310502775,4),(51952429,426269857,15242589,206510,1,'2008-12-06 19:38:18',3310502775,4),(51952430,426269486,15244293,206510,1,'2008-12-06 19:38:18',3310502775,4),(51952433,426271331,15241100,206510,1,'2008-12-06 19:38:18',3310502775,4),(51952436,426274047,15240347,206510,1,'2008-12-06 19:38:19',3310502775,4),(51952439,426276260,15238044,206510,1,'2008-12-06 19:38:19',3310503458,4),(51952441,426268912,15245824,206510,1,'2008-12-06 19:38:18',3310502775,4),(51952444,426268254,15246937,206510,1,'2008-12-06 19:38:18',3310502775,4),(51952446,426267318,15248101,206510,1,'2008-12-06 19:38:18',3310502775,4),(51952449,426266280,15249543,206510,1,'2008-12-06 19:38:18',3310502775,4),(51952452,426265774,15251795,206510,1,'2008-12-06 19:38:17',3310502775,4),(51952455,426265470,15253491,206510,1,'2008-12-06 19:38:17',3310502775,4),(51952457,426264737,15257590,206510,1,'2008-12-06 19:38:17',3310502775,4),(51952460,426263952,15260146,206510,1,'2008-12-06 19:38:17',3310502775,4),(51952463,426263674,15261537,206510,1,'2008-12-06 19:38:17',3310502775,4),(51952465,426263396,15264245,206510,1,'2008-12-06 19:38:17',3310502775,4),(51952468,426263214,15265846,206510,1,'2008-12-06 19:38:17',3310502775,4),(51952472,426262923,15267777,206510,1,'2008-12-06 19:38:16',3310502775,4),(51952475,426262340,15268943,206510,1,'2008-12-06 19:38:16',3310502775,4),(51952478,426261429,15270437,206510,1,'2008-12-06 19:38:16',3310502775,4),(51952481,426260372,15271494,206510,1,'2008-12-06 19:38:16',3310502781,4),(51952484,426258405,15272441,206510,1,'2008-12-06 19:38:16',3310502781,4),(51952487,426256838,15273206,206510,1,'2008-12-06 19:38:16',3310502781,4),(51952490,426255708,15274044,206510,1,'2008-12-06 19:38:16',3310502781,4),(51952492,426254433,15275174,206510,1,'2008-12-06 19:38:16',3310502781,4),(51952495,426252538,15278636,206510,1,'2008-12-06 19:38:16',3310502781,4),(51952498,426248034,15284558,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952500,426247147,15285928,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952502,426246543,15287298,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952504,426245938,15290965,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952506,426245737,15295841,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952508,426245737,15297856,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952510,426245547,15301341,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952512,426245162,15303579,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952513,426244274,15306356,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952515,426242808,15310099,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952517,426240416,15316696,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952520,426238410,15323640,206510,1,'2008-12-06 19:38:15',3310502780,4),(51952523,426236751,15327960,206510,1,'2008-12-06 19:38:15',3310502782,4),(51952524,426233935,15333863,206510,1,'2008-12-06 19:38:15',3310502782,4),(51952525,426231158,15339650,206510,1,'2008-12-06 19:38:15',3310502782,4),(51952527,426228573,15344356,206510,1,'2008-12-06 19:38:15',3310502782,4),(51952530,426225872,15350915,434787,1,'2007-09-15 13:48:43',3310502782,1),(51952532,426222284,15360907,434787,1,'2007-09-15 13:48:43',3310502782,1),(51952534,426221089,15363607,434787,1,'2007-09-15 13:48:43',3310502779,1),(51952536,426219584,15366462,434787,1,'2007-09-15 13:48:43',3310502779,1),(51952539,426218423,15369541,434787,1,'2007-09-15 13:48:43',3310502779,1),(51952542,426216338,15375927,434787,1,'2007-09-15 13:48:43',3310502779,1),(51952545,426214802,15381518,434787,1,'2007-09-15 13:48:44',3310502865,1),(51952546,426213450,15386125,434787,1,'2007-09-15 13:48:44',3310502865,1),(51952549,426213512,15388030,434787,1,'2007-09-15 13:48:44',3310502865,1),(51952552,426214863,15392515,434787,1,'2007-09-15 13:48:44',3310502865,1),(51952556,426216461,15396385,434787,1,'2007-09-15 13:48:44',3310502865,1),(51952559,426217321,15400686,434787,1,'2007-09-15 13:48:45',3310502865,1),(51952562,426219594,15404618,434787,1,'2007-09-15 13:48:45',3310502865,1),(51952566,426220786,15407370,434787,1,'2007-09-15 13:48:45',3310502865,1),(51952570,426223245,15411389,434787,1,'2007-09-15 13:48:45',3310502868,1),(51952573,426225645,15414989,434787,1,'2007-09-15 13:48:45',3310502868,1),(51952575,426227385,15419608,434787,1,'2007-09-15 13:48:46',3310502868,1),(51952578,426228645,15424648,434787,1,'2007-09-15 13:48:46',3310502868,1),(51952580,426232065,15431547,434787,1,'2007-09-15 13:48:46',3310502868,1),(51952583,426235124,15438026,434787,1,'2007-09-15 13:48:46',3310502870,1),(51952584,426236467,15441568,434787,1,'2007-09-15 13:48:46',3310502870,1),(51952586,426237902,15443817,434787,1,'2007-09-15 13:48:46',3310502870,1),(51952590,426239957,15445601,434787,1,'2007-09-15 13:48:47',3310502870,1),(51952594,426241818,15448005,434787,1,'2007-09-15 13:48:47',3310502870,1),(51952597,426245231,15453124,434787,1,'2007-09-15 13:48:47',3310502870,1),(51952599,426248333,15458204,434787,1,'2007-09-15 13:48:47',3310502870,1),(51952601,426251965,15463806,434787,1,'2007-09-15 13:48:47',3310502871,1),(51952604,426254231,15468023,434787,1,'2007-09-15 13:48:47',3310502871,1),(51952605,426255993,15473939,434787,1,'2007-09-15 13:48:47',3310502871,1),(51952608,426257126,15482059,434787,1,'2007-09-15 13:48:48',3310502871,1),(51952610,426258007,15495402,434787,1,'2007-09-15 13:48:48',3310502877,1),(51952613,426258766,15499341,434787,1,'2007-09-15 13:48:48',3310502877,1),(51952615,426259769,15502392,434787,1,'2007-09-15 13:48:48',3310502877,1),(51952618,426260815,15506402,434787,1,'2007-09-15 13:48:48',3310502877,1),(51952620,426261861,15511894,434787,1,'2007-09-15 13:48:49',3310502877,1),(51952623,426262341,15515076,434787,1,'2007-09-15 13:48:49',3310502877,1),(51952627,426262079,15516428,434787,1,'2007-09-15 13:48:49',3310502877,1),(51952630,426261643,15517256,434787,1,'2007-09-15 13:48:49',3310502877,1),(51952632,426259900,15519130,434787,1,'2007-09-15 13:48:49',3310502877,1),(51952634,426259028,15519522,434787,1,'2007-09-15 13:48:50',3310502877,1),(51952635,426257415,15519653,434787,1,'2007-09-15 13:48:50',3310502877,1),(51952638,426254582,15519392,434787,1,'2007-09-15 13:48:50',3310502877,1),(51952640,426251313,15518912,434787,1,'2007-09-15 13:48:50',3310502877,1),(51952643,426249046,15518302,434787,1,'2007-09-15 13:48:50',3310502877,1),(51952647,426247303,15517604,434787,1,'2007-09-15 13:48:51',3310502876,1),(51952649,426244949,15517561,434787,1,'2007-09-15 13:48:51',3310502876,1),(51952652,426241331,15517910,434787,1,'2007-09-15 13:48:51',3310502876,1),(51952653,426238759,15518084,434787,1,'2007-09-15 13:48:51',3310502876,1),(51952656,426237059,15517866,434787,1,'2007-09-15 13:48:52',3310502876,1),(51952659,426234749,15517735,434787,1,'2007-09-15 13:48:52',3310502876,1),(51952662,426232438,15517110,434787,1,'2007-09-15 13:48:52',3310502876,1),(51952665,426231265,15516684,434787,1,'2007-09-15 13:48:52',3310502876,1),(51952667,426229826,15516791,434787,1,'2007-09-15 13:48:52',3310502876,1),(51952668,426228280,15517697,434787,1,'2007-09-15 13:48:52',3310502876,1),(51952671,426225401,15520469,434787,1,'2007-09-15 13:48:53',3310502876,1),(51952672,426221829,15523561,434787,1,'2007-09-15 13:48:53',3310502876,1),(51952675,426221259,15524255,434787,1,'2007-09-15 13:48:53',3310502876,1),(51952677,426221189,15525227,434787,1,'2007-09-15 13:48:53',3310502876,1),(51952682,426221583,15525690,434787,1,'2007-09-15 13:48:53',3310502876,1),(51952684,426222162,15525883,434787,1,'2007-09-15 13:48:54',3310502876,1),(51952686,426223002,15525267,434787,1,'2007-09-15 13:48:54',3310502876,1),(51952689,426224122,15524627,434787,1,'2007-09-15 13:48:54',3310502876,1),(51952690,426225987,15522868,434787,1,'2007-09-15 13:48:55',3310502876,1),(51952692,426227188,15522081,434787,1,'2007-09-15 13:48:55',3310502876,1),(51952694,426227974,15521393,434787,1,'2007-09-15 13:48:55',3310502876,1),(51952695,426229137,15520623,434787,1,'2007-09-15 13:48:55',3310502876,1),(51952699,426229923,15520640,434787,1,'2007-09-15 13:48:55',3310502876,1),(51952701,426230463,15520885,434787,1,'2007-09-15 13:48:55',3310502876,1),(51952702,426230693,15521459,434787,1,'2007-09-15 13:48:55',3310502876,1),(51952705,426230611,15521835,434787,1,'2007-09-15 13:48:55',3310502876,1),(51952706,426230316,15522245,434787,1,'2007-09-15 13:48:55',3310502876,1),(51952709,426229726,15522556,434787,1,'2007-09-15 13:48:56',3310502876,1),(51952712,426228989,15522752,434787,1,'2007-09-15 13:48:56',3310502876,1),(51952714,426226942,15524472,434787,1,'2007-09-15 13:48:56',3310502876,1),(51952715,426225779,15526077,434787,1,'2007-09-15 13:48:56',3310502876,1),(51952717,426223542,15528266,434787,1,'2007-09-15 13:48:57',3310502876,1),(51952719,426221830,15530222,434787,1,'2007-09-15 13:48:57',3310502876,1),(51952722,426221138,15531567,434787,1,'2007-09-15 13:48:57',3310502876,1),(51952724,426220485,15533441,434787,1,'2007-09-15 13:48:57',3310502873,1),(51952727,426219630,15536579,434787,1,'2007-09-15 13:48:57',3310502873,1),(51952729,426218570,15539147,434787,1,'2007-09-15 13:48:57',3310502873,1),(51952732,426217551,15540410,434787,1,'2007-09-15 13:48:57',3310502873,1),(51952733,426215595,15542937,434787,1,'2007-09-15 13:48:58',3310502873,1),(51952737,426214699,15544485,434787,1,'2007-09-15 13:48:58',3310502873,1),(51952740,426213517,15547053,434787,1,'2007-09-15 13:48:58',3310502875,1),(51952742,426213272,15547908,434787,1,'2007-09-15 13:48:58',3310502875,1),(51952745,426213354,15548683,434787,1,'2007-09-15 13:48:58',3310502875,1),(51952748,426213680,15549375,434787,1,'2007-09-15 13:48:58',3310502875,1),(51952751,426214291,15549579,434787,1,'2007-09-15 13:48:58',3310502875,1),(51952754,426215106,15549538,434787,1,'2007-09-15 13:48:58',3310502875,1),(51952756,426215554,15548846,434787,1,'2007-09-15 13:48:59',3310502875,1),(51952758,426216044,15547582,434787,1,'2007-09-15 13:48:59',3310502875,1),(51952761,426217592,15545789,434787,1,'2007-09-15 13:48:59',3310502873,1),(51952764,426218855,15544811,434787,1,'2007-09-15 13:48:59',3310502873,1),(51952767,426220241,15543344,434787,1,'2007-09-15 13:48:59',3310502873,1),(51952770,426221464,15541959,434787,1,'2007-09-15 13:49:00',3310502876,1),(51952772,426222645,15539758,434787,1,'2007-09-15 13:49:00',3310502876,1),(51952775,426223460,15536865,434787,1,'2007-09-15 13:49:00',3310502876,1),(51952777,426223949,15534786,434787,1,'2007-09-15 13:49:00',3310502876,1),(51952780,426225009,15533401,434787,1,'2007-09-15 13:49:00',3310502876,1),(51952782,426226395,15532137,434787,1,'2007-09-15 13:49:00',3310502876,1),(51952784,426227495,15531241,434787,1,'2007-09-15 13:49:00',3310502876,1),(51952786,426228391,15531322,434787,1,'2007-09-15 13:49:00',3310502876,1),(51952788,426229125,15532137,434787,1,'2007-09-15 13:49:01',3310502876,1),(51952790,426229451,15533971,434787,1,'2007-09-15 13:49:01',3310502876,1),(51952792,426229247,15534786,434787,1,'2007-09-15 13:49:01',3310502876,1),(51952795,426228269,15536335,434787,1,'2007-09-15 13:49:01',3310502876,1),(51952797,426226802,15538291,434787,1,'2007-09-15 13:49:01',3310502876,1),(51952800,426225743,15541103,434787,1,'2007-09-15 13:49:01',3310502876,1),(51952802,426224968,15544485,434787,1,'2007-09-15 13:49:01',3310502876,1),(51952804,426224072,15547338,434787,1,'2007-09-15 13:49:01',3310502878,1),(51952807,426222808,15548927,434787,1,'2007-09-15 13:49:01',3310502878,1),(51952811,426221545,15551332,434787,1,'2007-09-15 13:49:02',3310502878,1),(51952813,426220445,15553410,434787,1,'2007-09-15 13:49:02',3310502875,1),(51952815,426219100,15555488,434787,1,'2007-09-15 13:49:02',3310502875,1),(51952818,426217674,15557526,434787,1,'2007-09-15 13:49:02',3310502875,1),(51952820,426216533,15560134,434787,1,'2007-09-15 13:49:02',3310502875,1),(51952824,426216084,15562335,434787,1,'2007-09-15 13:49:02',3310502875,1),(51952827,426216125,15565717,434787,1,'2007-09-15 13:49:02',3310502875,1),(51952829,426215658,15568442,434787,1,'2007-09-15 13:49:03',3310502875,1),(51952831,426215107,15571455,434787,1,'2007-09-15 13:49:03',3310502875,1),(51952832,426214850,15573917,434787,1,'2007-09-15 13:49:03',3310502875,1),(51952834,426214556,15576563,434787,1,'2007-09-15 13:49:03',3310502875,1),(51952837,426213968,15579282,434787,1,'2007-09-15 13:49:03',3310502875,1),(51952840,426213012,15581524,434787,1,'2007-09-15 13:49:04',3310502875,1),(51952842,426212865,15583729,434787,1,'2007-09-15 13:49:04',3310502875,1),(51952844,426213123,15584243,864892,1,'2009-03-28 14:44:22',3310502875,2),(51952849,426225483,15349535,206510,1,'2008-12-06 19:38:14',3310502782,4),(51956993,426313401,14846734,434787,1,'2007-09-15 13:55:14',3310503081,1),(51956997,426312311,14842100,434787,1,'2007-09-15 13:55:15',3310503081,1),(51956999,426311857,14838465,434787,1,'2007-09-15 13:55:15',3310503081,1),(51957002,426312584,14834286,434787,1,'2007-09-15 13:55:15',3310503081,1),(51957005,426314128,14829924,434787,1,'2007-09-15 13:55:15',3310503075,1),(51957008,426315673,14826108,434787,1,'2007-09-15 13:55:15',3310503075,1),(51957009,426316582,14822201,434787,1,'2007-09-15 13:55:15',3310503075,1),(51957013,426316582,14818657,434787,1,'2007-09-15 13:55:16',3310503075,1),(51957016,426315673,14813933,434787,1,'2007-09-15 13:55:16',3310503075,1),(51957018,426313947,14811207,864892,1,'2009-03-28 14:33:30',3310503075,3),(51957020,426312402,14805846,434787,1,'2007-09-15 13:55:16',3310503075,1),(51957022,426312311,14801212,434787,1,'2007-09-15 13:55:16',3310503075,1),(51957024,426312311,14793125,434787,1,'2007-09-15 13:55:16',3310503075,1),(51957025,426311938,14787679,434787,1,'2007-09-15 13:55:16',3310503075,1),(51957027,426311742,14784336,434787,1,'2007-09-15 13:55:16',3310503075,1),(51957030,426311545,14782173,434787,1,'2007-09-15 13:55:17',3310503075,1),(51957031,426310562,14780010,434787,1,'2007-09-15 13:55:17',3310503075,1),(51957034,426309284,14778535,434787,1,'2007-09-15 13:55:17',3310503075,1),(51957037,426306924,14778339,434787,1,'2007-09-15 13:55:17',3310503075,1),(51957040,426304171,14778830,434787,1,'2007-09-15 13:55:17',3310503075,1),(51957042,426302598,14779322,434787,1,'2007-09-15 13:55:17',3310503074,1),(51957045,426301123,14780895,434787,1,'2007-09-15 13:55:18',3310503074,1),(51957048,426299648,14784730,434787,1,'2007-09-15 13:55:18',3310503074,1),(51957050,426296895,14790236,434787,1,'2007-09-15 13:55:18',3310503074,1),(51957052,426295322,14792300,434787,1,'2007-09-15 13:55:18',3310503074,1),(51957055,426292667,14795053,434787,1,'2007-09-15 13:55:18',3310503074,1),(51957057,426290504,14797315,434787,1,'2007-09-15 13:55:18',3310503074,1),(51957060,426288931,14799576,434787,1,'2007-09-15 13:55:18',3310503074,1),(51957063,426287358,14802329,434787,1,'2007-09-15 13:55:18',3310503074,1),(51957064,426286965,14806360,434787,1,'2007-09-15 13:55:19',3310503074,1),(51957066,426287063,14808916,434787,1,'2007-09-15 13:55:19',3310503074,1),(51957069,426286571,14810391,434787,1,'2007-09-15 13:55:19',3310503074,1),(51957072,426285392,14810391,434787,1,'2007-09-15 13:55:19',3310503074,1),(51957075,426284197,14805596,434787,1,'2007-09-15 13:55:19',3310503074,1),(51957077,426283754,14802825,434787,1,'2007-09-15 13:55:19',3310503074,1),(51957080,426282978,14799944,434787,1,'2007-09-15 13:55:19',3310503074,1),(51957082,426282535,14797506,434787,1,'2007-09-15 13:55:20',3310503074,1),(51957085,426281316,14795733,434787,1,'2007-09-15 13:55:20',3310503074,1),(51957087,426279986,14794292,434787,1,'2007-09-15 13:55:20',3310503074,1),(51957090,426278434,14792408,434787,1,'2007-09-15 13:55:20',3310503074,1),(51957092,426277437,14789970,434787,1,'2007-09-15 13:55:20',3310503074,1),(51957094,426276772,14788861,434787,1,'2007-09-15 13:55:20',3310503074,1),(51957098,426275885,14787864,434787,1,'2007-09-15 13:55:20',3310502391,1),(51957101,426274666,14788640,434787,1,'2007-09-15 13:55:21',3310502391,1),(51957103,426274888,14792851,434787,1,'2007-09-15 13:55:21',3310502391,1),(51957105,426276107,14800498,434787,1,'2007-09-15 13:55:21',3310503074,1),(51957110,426275996,14802382,434787,1,'2007-09-15 13:55:21',3310502391,1),(51957112,426274445,14803158,434787,1,'2007-09-15 13:55:21',3310502391,1),(51957115,426273780,14802160,434787,1,'2007-09-15 13:55:21',3310502391,1),(51957117,426273115,14798060,434787,1,'2007-09-15 13:55:22',3310502391,1),(51957119,426271342,14794070,434787,1,'2007-09-15 13:55:22',3310502391,1),(51957121,426270123,14792740,434787,1,'2007-09-15 13:55:22',3310502391,1),(51957125,426268904,14791078,434787,1,'2007-09-15 13:55:22',3310502391,1),(51957128,426268571,14789416,434787,1,'2007-09-15 13:55:22',3310502391,1),(51957131,426268349,14786312,434787,1,'2007-09-15 13:55:22',3310502391,1),(51957134,426268904,14783542,434787,1,'2007-09-15 13:55:23',3310502391,1),(51957135,426268904,14782323,434787,1,'2007-09-15 13:55:23',3310502391,1),(51957138,426267684,14781436,434787,1,'2007-09-15 13:55:23',3310502391,1),(51957141,426266244,14781990,434787,1,'2007-09-15 13:55:23',3310502391,1),(51957143,426265357,14783209,434787,1,'2007-09-15 13:55:23',3310502391,1),(51957144,426265357,14787975,434787,1,'2007-09-15 13:55:23',3310502391,1),(51957146,426267130,14800055,434787,1,'2007-09-15 13:55:24',3310502391,1),(51957147,426267684,14802493,434787,1,'2007-09-15 13:55:24',3310502391,1),(51957151,426267574,14804488,434787,1,'2007-09-15 13:55:24',3310502391,1),(51957153,426266576,14804931,434787,1,'2007-09-15 13:55:24',3310502391,1),(51957155,426265357,14804377,434787,1,'2007-09-15 13:55:24',3310502391,1),(51957157,426264581,14802493,434787,1,'2007-09-15 13:55:24',3310502391,1),(51957160,426263141,14799611,434787,1,'2007-09-15 13:55:25',3310502391,1),(51957162,426261589,14797284,434787,1,'2007-09-15 13:55:25',3310502391,1),(51957164,426259262,14794846,434787,1,'2007-09-15 13:55:25',3310502391,1),(51957166,426255715,14793959,434787,1,'2007-09-15 13:55:25',3310502391,1),(51957168,426244744,14793405,434787,1,'2007-09-15 13:55:25',3310502390,1),(51957170,426240205,14793093,434787,1,'2007-09-15 13:55:25',3310502390,1),(51957172,426236087,14792740,434787,1,'2007-09-15 13:55:25',3310502390,1),(51957174,426230557,14791564,434787,1,'2007-09-15 13:55:25',3310502390,1),(51972980,425123655,15354572,434787,1,'2007-09-15 14:19:30',3310491454,1),(51972984,425125217,15354238,434787,1,'2007-09-15 14:19:30',3310491454,1),(51972990,425134816,15344759,434787,1,'2007-09-15 14:19:30',3310491454,1),(51972993,425134312,15348285,434787,1,'2007-09-15 14:19:30',3310491454,1),(51972999,425133682,15353890,434787,1,'2007-09-15 14:19:31',3310491454,1),(51973000,425133115,15357858,434787,1,'2007-09-15 14:19:31',3310491454,1),(51973004,425132171,15360692,434787,1,'2007-09-15 14:19:31',3310491454,1),(51973007,425130282,15365289,434787,1,'2007-09-15 14:19:31',3310491454,1),(51973010,425129148,15369193,434787,1,'2007-09-15 14:19:31',3310491454,1),(51973014,425128077,15374420,434787,1,'2007-09-15 14:19:31',3310491454,1),(51973017,425127133,15379836,434787,1,'2007-09-15 14:19:32',3310491454,1),(51973021,425126566,15384874,434787,1,'2007-09-15 14:19:32',3310491540,1),(51973026,425125936,15386701,434787,1,'2007-09-15 14:19:32',3310491540,1),(51973027,425124551,15388842,434787,1,'2007-09-15 14:19:32',3310491540,1),(51973030,425122913,15391928,434787,1,'2007-09-15 14:19:33',3310491540,1),(51973033,425122851,15393143,495907,1,'2008-07-15 17:35:47',3310491540,2),(51973038,425121762,15397763,434787,1,'2007-09-15 14:19:33',3310491537,1),(51973045,425121120,15400066,434787,1,'2007-09-15 14:19:33',3310491537,1),(51973049,425119384,15403766,434787,1,'2007-09-15 14:19:34',3310491537,1),(51973052,425118364,15405654,434787,1,'2007-09-15 14:19:34',3310491537,1),(51973055,425118175,15406296,434787,1,'2007-09-15 14:19:34',3310491537,1),(51973058,425117498,15408946,434787,1,'2007-09-15 14:19:34',3310491537,1),(51973061,425116997,15410749,434787,1,'2007-09-15 14:19:34',3310491537,1),(51973066,425116863,15412720,434787,1,'2007-09-15 14:19:35',3310491537,1),(51973069,425116663,15414591,434787,1,'2007-09-15 14:19:35',3310491537,1),(51973073,425115994,15415726,434787,1,'2007-09-15 14:19:35',3310491537,1),(51973078,425114792,15417230,434787,1,'2007-09-15 14:19:35',3310491537,1),(51973082,425113523,15418098,434787,1,'2007-09-15 14:19:35',3310491537,1),(51973084,425111084,15418332,434787,1,'2007-09-15 14:19:36',3310491537,1),(51973088,425108746,15418332,434787,1,'2007-09-15 14:19:36',3310491537,1),(51973091,425102934,15418465,434787,1,'2007-09-15 14:19:36',3310491537,1),(51973096,425100815,15418808,434787,1,'2007-09-15 14:19:36',3310491537,1),(51973099,425096382,15420508,434787,1,'2007-09-15 14:19:37',3310491537,1),(51973102,425172985,15674698,434787,1,'2007-09-15 14:19:37',3310491575,1),(51973105,425172136,15668758,434787,1,'2007-09-15 14:19:37',3310491575,1),(51973108,425170121,15661758,434787,1,'2007-09-15 14:19:38',3310491575,1),(51973112,425169909,15659318,434787,1,'2007-09-15 14:19:38',3310491575,1),(51973113,425170333,15658046,434787,1,'2007-09-15 14:19:38',3310491575,1),(51973117,425171076,15658046,434787,1,'2007-09-15 14:19:38',3310491575,1),(51973120,425172242,15658576,434787,1,'2007-09-15 14:19:38',3310491575,1),(51973122,425173833,15661121,434787,1,'2007-09-15 14:19:38',3310491575,1),(51973125,425182557,15679190,5671401,1,'2010-09-03 18:06:01',3310491618,2),(51973128,425189743,15692411,434787,1,'2007-09-15 14:19:39',3310491618,1),(51973131,425196637,15702381,434787,1,'2007-09-15 14:19:39',3310491618,1),(51973135,425206714,15711714,434787,1,'2007-09-15 14:19:39',3310491625,1),(51973138,425218911,15720730,434787,1,'2007-09-15 14:19:39',3310491625,1),(51973141,425223260,15723594,434787,1,'2007-09-15 14:19:39',3310491625,1),(51973144,425224108,15725715,434787,1,'2007-09-15 14:19:40',3310491625,1),(51973147,425224214,15728367,434787,1,'2007-09-15 14:19:40',3310491625,1),(51973150,425227714,15737382,434787,1,'2007-09-15 14:19:40',3310491625,1),(51973154,425231108,15744807,434787,1,'2007-09-15 14:19:41',3310491625,1),(51973156,425237048,15752125,434787,1,'2007-09-15 14:19:41',3310491628,1),(51973158,425240973,15755307,434787,1,'2007-09-15 14:19:41',3310491628,1),(51973161,425244791,15757853,434787,1,'2007-09-15 14:19:41',3310491628,1),(51973163,425245003,15760080,434787,1,'2007-09-15 14:19:42',3310491628,1),(51973166,425244048,15762095,434787,1,'2007-09-15 14:19:42',3310491628,1),(51973170,425244367,15766338,434787,1,'2007-09-15 14:19:42',3310491630,1),(51973172,425245003,15770899,434787,1,'2007-09-15 14:19:43',3310491630,1),(51973175,425246700,15773338,434787,1,'2007-09-15 14:19:43',3310491630,1),(51973177,425246700,15774611,434787,1,'2007-09-15 14:19:43',3310491630,1),(51973179,425246700,15778111,434787,1,'2007-09-15 14:19:43',3310491630,1),(51973183,425247655,15782990,434787,1,'2007-09-15 14:19:43',3310491630,1),(51973186,425248415,15785554,434787,1,'2007-09-15 14:19:44',3310491630,1),(51973190,425248495,15787626,434787,1,'2007-09-15 14:19:44',3310491630,1),(51973193,425248495,15788822,434787,1,'2007-09-15 14:19:44',3310491630,1),(51973196,425249052,15790575,434787,1,'2007-09-15 14:19:44',3310491630,1),(51973198,425250647,15793524,434787,1,'2007-09-15 14:19:45',3310491630,1),(51973201,425254074,15798466,434787,1,'2007-09-15 14:19:45',3310491630,1),(51973203,425254711,15799900,434787,1,'2007-09-15 14:19:45',3310491630,1),(51973206,425254472,15801973,434787,1,'2007-09-15 14:19:45',3310491630,1),(51973208,425253595,15803886,434787,1,'2007-09-15 14:19:45',3310491630,1),(51973210,425252798,15806277,434787,1,'2007-09-15 14:19:45',3310491630,1),(51973213,425251922,15807871,434787,1,'2007-09-15 14:19:45',3310491630,1),(51973215,425252081,15809305,434787,1,'2007-09-15 14:19:46',3310491630,1),(51973219,425252639,15810341,434787,1,'2007-09-15 14:19:46',3310491630,1),(51973221,425254313,15811776,434787,1,'2007-09-15 14:19:46',3310491630,1),(51973223,425257581,15812892,434787,1,'2007-09-15 14:19:46',3310491630,1),(51973225,425259254,15813211,434787,1,'2007-09-15 14:19:47',3310491630,1),(51973228,425260290,15814725,434787,1,'2007-09-15 14:19:47',3310491631,1),(51973234,425260609,15817355,434787,1,'2007-09-15 14:19:47',3310491631,1),(51973237,425261167,15819746,434787,1,'2007-09-15 14:19:47',3310491631,1),(51973241,425262841,15822616,434787,1,'2007-09-15 14:19:48',3310492997,1),(51973243,425264515,15826601,434787,1,'2007-09-15 14:19:48',3310492997,1),(51973247,425265391,15827876,434787,1,'2007-09-15 14:19:48',3310492997,1),(51973249,425267145,15829071,434787,1,'2007-09-15 14:19:48',3310492997,1);
INSERT INTO `nodes` VALUES (51973253,425269456,15830108,434787,1,'2007-09-15 14:19:49',3310492997,1),(51973256,425270811,15830745,434787,1,'2007-09-15 14:19:49',3310492997,1),(51973260,425272565,15832499,434787,1,'2007-09-15 14:19:49',3310492997,1),(51973264,425275035,15836404,434787,1,'2007-09-15 14:19:49',3310492997,1),(51973268,425278781,15843498,434787,1,'2007-09-15 14:19:50',3310492997,1),(51973269,425280854,15847961,434787,1,'2007-09-15 14:19:50',3310492997,1),(51973273,425282607,15853142,434787,1,'2007-09-15 14:19:50',3310492997,1),(51973276,425284440,15855931,434787,1,'2007-09-15 14:19:50',3310492997,1),(51973278,425285158,15857525,434787,1,'2007-09-15 14:19:50',3310492997,1),(51973281,425285795,15862068,434787,1,'2007-09-15 14:19:50',3310492997,1),(51973284,425287150,15868046,434787,1,'2007-09-15 14:19:51',3310492997,1),(51973287,425287947,15870676,434787,1,'2007-09-15 14:19:51',3310493008,1),(51973290,425288251,15872645,434787,1,'2007-09-15 14:19:51',3310493008,1),(51973293,425288342,15875745,434787,1,'2007-09-15 14:19:51',3310493010,1),(51973296,425287658,15878844,434787,1,'2007-09-15 14:19:52',3310493010,1),(51973300,425286701,15882627,434787,1,'2007-09-15 14:19:52',3310492999,1),(51973302,425285789,15884815,434787,1,'2007-09-15 14:19:52',3310492999,1),(51973306,425284696,15886592,434787,1,'2007-09-15 14:19:52',3310492999,1),(51973310,425284058,15889373,434787,1,'2007-09-15 14:19:52',3310492999,1),(51973313,425283738,15891925,434787,1,'2007-09-15 14:19:53',3310492999,1),(51973316,425283602,15892791,434787,1,'2007-09-15 14:19:53',3310492999,1),(51973320,425283602,15893566,434787,1,'2007-09-15 14:19:53',3310492999,1),(51973324,425283738,15894249,434787,1,'2007-09-15 14:19:53',3310492999,1),(51973326,425284103,15894705,434787,1,'2007-09-15 14:19:53',3310492999,1),(51973327,425285862,15897161,434787,1,'2007-09-15 14:19:53',3310492999,1),(51973329,425286986,15898231,434787,1,'2007-09-15 14:19:53',3310492999,1),(51973334,425287949,15899515,434787,1,'2007-09-15 14:19:54',3310493010,1),(51973336,425287949,15900639,434787,1,'2007-09-15 14:19:54',3310493010,1),(51973339,425287628,15901495,434787,1,'2007-09-15 14:19:54',3310493010,1),(51973341,425286986,15904332,434787,1,'2007-09-15 14:19:54',3310492999,1),(51973344,425286665,15906205,434787,1,'2007-09-15 14:19:54',3310492999,1),(51973346,425286611,15907971,434787,1,'2007-09-15 14:19:54',3310492999,1),(51973348,425286183,15911289,434787,1,'2007-09-15 14:19:55',3310492999,1),(51973351,425285916,15913322,434787,1,'2007-09-15 14:19:55',3310492999,1),(51973352,425286504,15915088,434787,1,'2007-09-15 14:19:55',3310492999,1),(51973353,425287468,15916908,434787,1,'2007-09-15 14:19:55',3310493010,1),(51973354,425288163,15919584,434787,1,'2007-09-15 14:19:55',3310493010,1),(51973356,425288913,15921617,434787,1,'2007-09-15 14:19:56',3310493010,1),(51973357,425289287,15923276,434787,1,'2007-09-15 14:19:56',3310493010,1),(51973359,425289287,15924079,434787,1,'2007-09-15 14:19:56',3310493010,1),(51973361,425288805,15924935,434787,1,'2007-09-15 14:19:56',3310493010,1),(51973362,425288110,15925577,434787,1,'2007-09-15 14:19:56',3310493010,1),(51973363,425286986,15926434,434787,1,'2007-09-15 14:19:56',3310492999,1),(51973364,425285755,15926701,434787,1,'2007-09-15 14:19:56',3310492999,1),(51973366,425284899,15926701,434787,1,'2007-09-15 14:19:56',3310492999,1),(51973369,425284310,15926648,434787,1,'2007-09-15 14:19:57',3310492999,1),(51973370,425283347,15927236,434787,1,'2007-09-15 14:19:57',3310492999,1),(51973373,425281848,15928681,434787,1,'2007-09-15 14:19:57',3310492999,1),(51973375,425280082,15929805,434787,1,'2007-09-15 14:19:57',3310492999,1),(51973378,425278691,15930554,434787,1,'2007-09-15 14:19:57',3310493005,1),(51973380,425277618,15931249,434787,1,'2007-09-15 14:19:58',3310493005,1),(51973384,425276528,15932813,434787,1,'2007-09-15 14:19:58',3310493005,1),(51973387,425275770,15934045,434787,1,'2007-09-15 14:19:58',3310493005,1),(51973390,425274680,15934945,434787,1,'2007-09-15 14:19:58',3310493005,1),(51973394,425272690,15935893,434787,1,'2007-09-15 14:19:59',3310493005,1),(51973396,425271790,15936461,434787,1,'2007-09-15 14:19:59',3310493005,1),(51973398,425271127,15937693,434787,1,'2007-09-15 14:19:59',3310493005,1),(51973400,425271079,15939399,434787,1,'2007-09-15 14:20:00',3310493005,1),(51973403,425271695,15940773,434787,1,'2007-09-15 14:20:00',3310493005,1),(51973405,425272927,15942479,434787,1,'2007-09-15 14:20:00',3310493005,1),(51973407,425273875,15943332,434787,1,'2007-09-15 14:20:00',3310493005,1),(51973409,425274207,15944706,434787,1,'2007-09-15 14:20:00',3310493005,1),(51973413,425274017,15947549,434787,1,'2007-09-15 14:20:00',3310493005,1),(51973416,425273922,15950013,434787,1,'2007-09-15 14:20:01',3310493005,1),(51973417,425273638,15951576,434787,1,'2007-09-15 14:20:01',3310493005,1),(51973419,425273259,15953567,434787,1,'2007-09-15 14:20:01',3310493005,1),(51973424,425272975,15955035,434787,1,'2007-09-15 14:20:01',3310493005,1),(51973426,425272674,15957022,434787,1,'2007-09-15 14:20:01',3310493005,1),(51973428,425273157,15958905,434787,1,'2007-09-15 14:20:01',3310493005,1),(51973430,425274268,15959871,434787,1,'2007-09-15 14:20:02',3310493005,1),(51973432,425275668,15959630,434787,1,'2007-09-15 14:20:02',3310493005,1),(51973436,425276972,15958422,434787,1,'2007-09-15 14:20:02',3310493005,1),(51973439,425279387,15957650,434787,1,'2007-09-15 14:20:02',3310493005,1),(51973441,425280787,15957312,434787,1,'2007-09-15 14:20:02',3310493005,1),(51973444,425282864,15956008,434787,1,'2007-09-15 14:20:02',3310493005,1),(51973448,425284892,15953835,434787,1,'2007-09-15 14:20:02',3310493005,1),(51973451,425286921,15951372,434787,1,'2007-09-15 14:20:03',3310493005,1),(51973454,425288128,15950261,434787,1,'2007-09-15 14:20:03',3310493016,1),(51973456,425289480,15950068,434787,1,'2007-09-15 14:20:03',3310493016,1),(51973459,425291750,15950792,434787,1,'2007-09-15 14:20:03',3310493016,1),(51973462,425292861,15951854,434787,1,'2007-09-15 14:20:03',3310493016,1),(51973467,425294213,15954462,434787,1,'2007-09-15 14:20:03',3310493016,1),(51973470,425295614,15958326,434787,1,'2007-09-15 14:20:03',3310493016,1),(51973471,425296000,15961079,434787,1,'2007-09-15 14:20:03',3310493016,1),(51973475,425297062,15963590,434787,1,'2007-09-15 14:20:04',3310493016,1),(51973478,425299546,15966920,434787,1,'2007-09-15 14:20:04',3310493016,1),(51973481,425301843,15969430,434787,1,'2007-09-15 14:20:04',3310493016,1),(51973484,425303605,15971727,434787,1,'2007-09-15 14:20:04',3310493016,1),(51973487,425303659,15974664,434787,1,'2007-09-15 14:20:04',3310493016,1),(51973489,425302590,15979258,434787,1,'2007-09-15 14:20:05',3310493016,1),(51973491,425301576,15983584,434787,1,'2007-09-15 14:20:05',3310493016,1),(51973494,425301309,15988337,434787,1,'2007-09-15 14:20:05',3310493018,1),(51973497,425301736,15993785,434787,1,'2007-09-15 14:20:05',3310493018,1),(51973499,425302911,15999072,434787,1,'2007-09-15 14:20:05',3310493018,1),(51973501,425303754,16001564,1882243,1,'2009-07-20 12:44:02',3310493018,2),(51973504,425305368,16002769,434787,1,'2007-09-15 14:20:06',3310493018,1),(51973507,425308242,16003952,434787,1,'2007-09-15 14:20:06',3310493018,1),(51973511,425311750,16005165,434787,1,'2007-09-15 14:20:06',3310493018,1),(51973514,425330006,15871191,434787,1,'2007-09-15 14:20:06',3310493009,1),(51973516,425335160,15876009,434787,1,'2007-09-15 14:20:07',3310493011,1),(51973519,425340650,15880378,434787,1,'2007-09-15 14:20:07',3310493011,1),(51973521,425342779,15881162,434787,1,'2007-09-15 14:20:07',3310493014,1),(51973523,425345131,15880938,434787,1,'2007-09-15 14:20:07',3310493014,1),(51973526,425347269,15881092,434787,1,'2007-09-15 14:20:07',3310493014,1),(51973528,425348130,15881150,434787,1,'2007-09-15 14:20:08',3310493014,1),(51973529,425348818,15882354,434787,1,'2007-09-15 14:20:08',3310493014,1),(51973532,425349851,15883387,434787,1,'2007-09-15 14:20:08',3310493014,1),(51973534,425351055,15883387,434787,1,'2007-09-15 14:20:09',3310493014,1),(51973538,425352775,15881569,434787,1,'2007-09-15 14:20:09',3310493014,1),(51973541,425328132,15869606,434787,1,'2007-09-15 14:20:09',3310493009,1),(51973544,425327290,15869044,434787,1,'2007-09-15 14:20:09',3310493009,1),(51973546,425325700,15868577,434787,1,'2007-09-15 14:20:09',3310493009,1),(51973548,425323969,15868062,434787,1,'2007-09-15 14:20:09',3310493009,1),(51973550,425322566,15867782,434787,1,'2007-09-15 14:20:10',3310493009,1),(51973554,425321630,15867220,434787,1,'2007-09-15 14:20:10',3310493009,1),(51973557,425320788,15865583,434787,1,'2007-09-15 14:20:10',3310493009,1),(51973559,425319853,15865022,434787,1,'2007-09-15 14:20:10',3310493009,1),(51973561,425318684,15864648,434787,1,'2007-09-15 14:20:10',3310493009,1),(51973562,425317888,15865302,434787,1,'2007-09-15 14:20:10',3310493009,1),(51973564,425317608,15865817,434787,1,'2007-09-15 14:20:10',3310493009,1),(51973567,425317655,15866940,434787,1,'2007-09-15 14:20:11',3310493009,1),(51973570,425318263,15868062,434787,1,'2007-09-15 14:20:11',3310493009,1),(51973571,425320461,15869840,434787,1,'2007-09-15 14:20:11',3310493009,1),(51973575,425322285,15871570,434787,1,'2007-09-15 14:20:11',3310493009,1),(51973577,425323174,15873254,434787,1,'2007-09-15 14:20:11',3310493009,1),(51973579,425323501,15875078,434787,1,'2007-09-15 14:20:11',3310493009,1),(51973582,425323267,15878773,434787,1,'2007-09-15 14:20:11',3310493011,1),(51973587,425322893,15882702,434787,1,'2007-09-15 14:20:12',3310493011,1),(51973590,425323127,15884901,434787,1,'2007-09-15 14:20:12',3310493011,1),(51973591,425323875,15886818,434787,1,'2007-09-15 14:20:12',3310493011,1),(51973594,425325793,15889297,434787,1,'2007-09-15 14:20:12',3310493011,1),(51973596,425327056,15893180,434787,1,'2007-09-15 14:20:12',3310493011,1),(51973598,425327009,15898371,434787,1,'2007-09-15 14:20:13',3310493011,1),(51973599,425326775,15902862,434787,1,'2007-09-15 14:20:13',3310493011,1),(51973602,425326214,15905247,434787,1,'2007-09-15 14:20:13',3310493011,1),(51973604,425325045,15908054,434787,1,'2007-09-15 14:20:13',3310493011,1),(51973606,425323127,15911281,434787,1,'2007-09-15 14:20:13',3310493011,1),(51973608,425320367,15916333,434787,1,'2007-09-15 14:20:13',3310493011,1),(51973611,425318309,15919513,434787,1,'2007-09-15 14:20:14',3310493011,1),(51973614,425317795,15921805,434787,1,'2007-09-15 14:20:14',3310493011,1),(51973617,425318356,15925126,434787,1,'2007-09-15 14:20:14',3310493011,1),(51973619,425319385,15927231,434787,1,'2007-09-15 14:20:14',3310493011,1),(51973621,425320508,15927886,434787,1,'2007-09-15 14:20:14',3310493011,1),(51973622,425322051,15927839,434787,1,'2007-09-15 14:20:14',3310493011,1),(51973624,425323221,15927278,434787,1,'2007-09-15 14:20:14',3310493011,1),(51973627,425325466,15926389,434787,1,'2007-09-15 14:20:14',3310493011,1),(51973631,425328616,15925170,434787,1,'2007-09-15 14:20:14',3310493011,1),(51973633,425330139,15925215,434787,1,'2007-09-15 14:20:15',3310493011,1),(51973636,425331950,15925525,434787,1,'2007-09-15 14:20:15',3310493011,1),(51973639,425333812,15925474,434787,1,'2007-09-15 14:20:15',3310493011,1),(51973643,425335674,15924853,434787,1,'2007-09-15 14:20:15',3310493011,1),(51973646,425337278,15923870,434787,1,'2007-09-15 14:20:15',3310493011,1),(51973648,425338726,15922939,434787,1,'2007-09-15 14:20:16',3310493011,1),(51973651,425340226,15922473,434787,1,'2007-09-15 14:20:16',3310493011,1),(51973653,425341778,15922939,434787,1,'2007-09-15 14:20:16',3310493011,1),(51973657,425342864,15924129,434787,1,'2007-09-15 14:20:16',3310493014,1),(51973660,425344313,15926922,434787,1,'2007-09-15 14:20:16',3310493014,1),(51973663,425345864,15928784,434787,1,'2007-09-15 14:20:16',3310493014,1),(51973667,425348089,15930543,434787,1,'2007-09-15 14:20:17',3310493020,1),(51973669,425349434,15931940,434787,1,'2007-09-15 14:20:17',3310493020,1),(51973673,425350934,15933440,434787,1,'2007-09-15 14:20:17',3310493020,1),(51973676,425351554,15934785,434787,1,'2007-09-15 14:20:17',3310493020,1),(51973679,425351192,15935923,434787,1,'2007-09-15 14:20:17',3310493020,1),(51973681,425350365,15936233,434787,1,'2007-09-15 14:20:18',3310493020,1),(51973683,425349175,15935923,434787,1,'2007-09-15 14:20:18',3310493020,1),(51973686,425347675,15935198,434787,1,'2007-09-15 14:20:18',3310493020,1),(51973688,425346899,15934629,434787,1,'2007-09-15 14:20:18',3310493020,1),(51973691,425345451,15933285,434787,1,'2007-09-15 14:20:18',3310493020,1),(51973694,425343123,15932095,434787,1,'2007-09-15 14:20:19',3310493020,1),(51973696,425341416,15930853,434787,1,'2007-09-15 14:20:19',3310493017,1),(51973699,425340381,15930595,434787,1,'2007-09-15 14:20:19',3310493017,1),(51973703,425339709,15930646,434787,1,'2007-09-15 14:20:19',3310493017,1),(51973705,425339347,15931681,434787,1,'2007-09-15 14:20:19',3310493017,1),(51973708,425339347,15932612,434787,1,'2007-09-15 14:20:19',3310493017,1),(51973711,425340278,15933595,434787,1,'2007-09-15 14:20:19',3310493017,1),(51973714,425341519,15933957,434787,1,'2007-09-15 14:20:20',3310493017,1),(51973717,425342450,15934733,434787,1,'2007-09-15 14:20:20',3310493020,1),(51973720,425342709,15936078,434787,1,'2007-09-15 14:20:20',3310493020,1),(51973722,425342864,15937630,434787,1,'2007-09-15 14:20:20',3310493020,1),(51973725,425343226,15939906,434787,1,'2007-09-15 14:20:20',3310493020,1),(51973728,425343899,15941147,434787,1,'2007-09-15 14:20:20',3310493020,1),(51973730,425345244,15942647,434787,1,'2007-09-15 14:20:20',3310493020,1),(51973731,425345606,15944406,434787,1,'2007-09-15 14:20:21',3310493020,1),(51973733,425346227,15946837,434787,1,'2007-09-15 14:20:21',3310493020,1),(51973736,425346692,15948130,434787,1,'2007-09-15 14:20:21',3310493020,1),(51973739,425347623,15949372,434787,1,'2007-09-15 14:20:21',3310493020,1),(51973741,425349382,15950510,434787,1,'2007-09-15 14:20:21',3310493020,1),(51973744,425351299,15951569,434787,1,'2007-09-15 14:20:21',3310493020,1),(51973747,425353320,15952816,434787,1,'2007-09-15 14:20:22',3310493020,1),(51973749,425353965,15953976,434787,1,'2007-09-15 14:20:22',3310493020,1),(51973751,425353922,15954793,434787,1,'2007-09-15 14:20:22',3310493020,1),(51973753,425353363,15955911,434787,1,'2007-09-15 14:20:22',3310493020,1),(51973755,425352589,15956083,434787,1,'2007-09-15 14:20:22',3310493020,1),(51973757,425351342,15955825,434787,1,'2007-09-15 14:20:22',3310493020,1),(51973759,425349967,15955524,434787,1,'2007-09-15 14:20:22',3310493020,1),(51973764,425348806,15955524,434787,1,'2007-09-15 14:20:23',3310493020,1),(51973766,425347817,15955524,434787,1,'2007-09-15 14:20:23',3310493020,1),(51973769,425346829,15955438,434787,1,'2007-09-15 14:20:23',3310493020,1),(51973770,425345668,15955051,434787,1,'2007-09-15 14:20:23',3310493020,1),(51973771,425344851,15954363,434787,1,'2007-09-15 14:20:23',3310493020,1),(51973777,425343820,15952988,434787,1,'2007-09-15 14:20:24',3310493020,1),(51973782,425343261,15951354,434787,1,'2007-09-15 14:20:24',3310493020,1),(51973784,425342100,15949850,434787,1,'2007-09-15 14:20:24',3310493017,1),(51973786,425341111,15949033,434787,1,'2007-09-15 14:20:24',3310493017,1),(51973790,425339908,15949033,434787,1,'2007-09-15 14:20:25',3310493017,1),(51973792,425339263,15949420,434787,1,'2007-09-15 14:20:25',3310493017,1),(51973796,425338403,15950365,434787,1,'2007-09-15 14:20:25',3310493017,1),(51973799,425336984,15952257,434787,1,'2007-09-15 14:20:25',3310493017,1),(51973802,425335480,15954320,434787,1,'2007-09-15 14:20:25',3310493017,1),(51973803,425333416,15956857,434787,1,'2007-09-15 14:20:25',3310493017,1),(51973807,425331783,15958361,434787,1,'2007-09-15 14:20:25',3310493017,1),(51973809,425330364,15959780,434787,1,'2007-09-15 14:20:26',3310493017,1),(51973812,425328774,15960554,434787,1,'2007-09-15 14:20:26',3310493017,1),(51973815,425327312,15962058,434787,1,'2007-09-15 14:20:26',3310493017,1),(51973817,425327183,15963348,434787,1,'2007-09-15 14:20:26',3310493017,1),(51973818,425327699,15963864,434787,1,'2007-09-15 14:20:26',3310493017,1),(51973820,425328215,15963907,434787,1,'2007-09-15 14:20:27',3310493017,1),(51973831,425329075,15963348,434787,1,'2007-09-15 14:20:27',3310493017,1),(51973834,425329934,15962617,434787,1,'2007-09-15 14:20:28',3310493017,1),(51973836,425332471,15961456,434787,1,'2007-09-15 14:20:28',3310493017,1),(51973839,425335136,15960726,434787,1,'2007-09-15 14:20:28',3310493017,1),(51973842,425337285,15960683,434787,1,'2007-09-15 14:20:28',3310493017,1),(51973844,425339177,15960339,434787,1,'2007-09-15 14:20:29',3310493017,1),(51973846,425340037,15960339,434787,1,'2007-09-15 14:20:29',3310493017,1),(51973848,425340595,15960897,434787,1,'2007-09-15 14:20:29',3310493017,1),(51973849,425340595,15961413,434787,1,'2007-09-15 14:20:29',3310493017,1),(51973851,425340166,15962488,434787,1,'2007-09-15 14:20:29',3310493017,1),(51973852,425338790,15963434,434787,1,'2007-09-15 14:20:30',3310493017,1),(51973855,425335738,15965411,434787,1,'2007-09-15 14:20:30',3310493017,1),(51973858,425333674,15966486,434787,1,'2007-09-15 14:20:30',3310493017,1),(51973860,425331977,15968116,434787,1,'2007-09-15 14:20:30',3310493017,1),(51973862,425330897,15969454,434787,1,'2007-09-15 14:20:30',3310493017,1),(51973865,425329714,15970483,434787,1,'2007-09-15 14:20:30',3310493017,1),(51973868,425328531,15971306,434787,1,'2007-09-15 14:20:30',3310493017,1),(51973871,425327399,15971460,434787,1,'2007-09-15 14:20:31',3310493017,1),(51973874,425325753,15971100,434787,1,'2007-09-15 14:20:31',3310493017,1),(51973877,425324569,15971100,434787,1,'2007-09-15 14:20:31',3310493017,1),(51973878,425323849,15971100,434787,1,'2007-09-15 14:20:31',3310493017,1),(51973881,425322769,15971512,434787,1,'2007-09-15 14:20:31',3310493017,1),(51973883,425322255,15972540,434787,1,'2007-09-15 14:20:31',3310493017,1),(51973884,425319991,15974547,434787,1,'2007-09-15 14:20:32',3310493017,1),(51973887,425317882,15977170,434787,1,'2007-09-15 14:20:32',3310493017,1),(51973890,425316801,15978662,434787,1,'2007-09-15 14:20:32',3310493017,1),(51973891,425315978,15981183,434787,1,'2007-09-15 14:20:32',3310493017,1),(51973894,425314898,15986379,434787,1,'2007-09-15 14:20:32',3310493019,1),(51973897,425313252,15996050,434787,1,'2007-09-15 14:20:32',3310493018,1),(51973898,425312840,16003355,434787,1,'2007-09-15 14:20:32',3310493018,1),(51973901,425310101,16004909,434787,1,'2007-09-15 14:20:32',3310493018,1),(51973903,425312684,16004829,434787,1,'2007-09-15 14:20:32',3310493018,1),(51973905,425313146,16005443,434787,1,'2007-09-15 14:20:33',3310493018,1),(51973907,425313715,16005991,434787,1,'2007-09-15 14:20:33',3310493018,1),(51973910,425314432,16006328,434787,1,'2007-09-15 14:20:33',3310493018,1),(51973913,425315169,16006371,434787,1,'2007-09-15 14:20:33',3310493019,1),(51973915,425315822,16006118,434787,1,'2007-09-15 14:20:33',3310493019,1),(51973917,425316433,16005359,434787,1,'2007-09-15 14:20:33',3310493019,1),(51973920,425316855,16004348,434787,1,'2007-09-15 14:20:33',3310493019,1),(51973922,425317465,16002883,434787,1,'2007-09-15 14:20:34',3310493019,1),(51973924,425317978,16001806,434787,1,'2007-09-15 14:20:34',3310493019,1),(51973927,425318799,16000472,434787,1,'2007-09-15 14:20:34',3310493019,1),(51973929,425320030,15998779,434787,1,'2007-09-15 14:20:34',3310493019,1),(51973931,425321664,15996067,434787,1,'2007-09-15 14:20:34',3310493019,1),(51973934,425323293,15993703,434787,1,'2007-09-15 14:20:35',3310493019,1),(51973937,425324317,15992154,434787,1,'2007-09-15 14:20:35',3310493019,1),(51973939,425325237,15990683,434787,1,'2007-09-15 14:20:35',3310493019,1),(51973941,425325893,15989501,434787,1,'2007-09-15 14:20:35',3310493019,1),(51973942,425326550,15988056,434787,1,'2007-09-15 14:20:35',3310493019,1),(51973947,425327128,15986375,434787,1,'2007-09-15 14:20:35',3310493019,1),(51973950,425327811,15984563,434787,1,'2007-09-15 14:20:35',3310493017,1),(51973952,425328336,15983591,434787,1,'2007-09-15 14:20:35',3310493017,1),(51973953,425328756,15983065,434787,1,'2007-09-15 14:20:35',3310493017,1),(51973955,425329255,15982855,434787,1,'2007-09-15 14:20:36',3310493017,1),(51973958,425329912,15982776,434787,1,'2007-09-15 14:20:36',3310493017,1),(51973962,425330464,15983197,434787,1,'2007-09-15 14:20:36',3310493017,1),(51973963,425330674,15983591,434787,1,'2007-09-15 14:20:36',3310493017,1),(51973967,425330569,15984274,434787,1,'2007-09-15 14:20:36',3310493017,1),(51973968,425330227,15985298,434787,1,'2007-09-15 14:20:37',3310493017,1),(51973972,425329623,15986060,434787,1,'2007-09-15 14:20:37',3310493019,1),(51973975,425329098,15986848,434787,1,'2007-09-15 14:20:37',3310493019,1),(51973977,425328730,15987531,434787,1,'2007-09-15 14:20:37',3310493019,1),(51973981,425328179,15988949,434787,1,'2007-09-15 14:20:37',3310493019,1),(51973983,425327443,15992548,434787,1,'2007-09-15 14:20:37',3310493019,1),(51973986,425326998,15994611,434787,1,'2007-09-15 14:20:37',3310493019,1),(51973989,425326213,15998271,434787,1,'2007-09-15 14:20:38',3310493019,1),(51973992,425325625,16002389,434787,1,'2007-09-15 14:20:38',3310493019,1),(51973995,425325205,16006217,434787,1,'2007-09-15 14:20:38',3310493019,1),(51973998,425324849,16008127,434787,1,'2007-09-15 14:20:38',3310493019,1),(51974002,425324851,16012092,434787,1,'2007-09-15 14:20:38',3310493019,1),(51974005,425324697,16016774,434787,1,'2007-09-15 14:20:39',3310493019,1),(51974008,425324467,16021762,434787,1,'2007-09-15 14:20:39',3310493019,1),(51974011,425324390,16026136,434787,1,'2007-09-15 14:20:39',3310493019,1),(51974013,425324007,16033657,434787,1,'2007-09-15 14:20:39',3310493019,1),(51974015,425323393,16040180,434787,1,'2007-09-15 14:20:39',3310493019,1),(51974019,425321781,16047700,434787,1,'2007-09-15 14:20:40',3310493041,1),(51974023,425320476,16052689,434787,1,'2007-09-15 14:20:40',3310493041,1),(51974024,425319556,16056219,434787,1,'2007-09-15 14:20:40',3310493041,1),(51974028,425318711,16058598,434787,1,'2007-09-15 14:20:40',3310493041,1),(51974031,425317100,16061821,434787,1,'2007-09-15 14:20:40',3310493041,1),(51974035,425315181,16065044,434787,1,'2007-09-15 14:20:40',3310493041,1),(51974039,425313186,16068114,434787,1,'2007-09-15 14:20:41',3310493040,1),(51974040,425311805,16069725,434787,1,'2007-09-15 14:20:41',3310493040,1),(51974042,425310347,16070953,434787,1,'2007-09-15 14:20:41',3310493040,1),(51974044,425305972,16073255,434787,1,'2007-09-15 14:20:41',3310493040,1),(51974046,425301752,16075558,434787,1,'2007-09-15 14:20:41',3310493040,1),(51974049,425300140,16076632,434787,1,'2007-09-15 14:20:41',3310493040,1),(51974050,425299603,16077399,434787,1,'2007-09-15 14:20:41',3310493040,1),(51974053,425299833,16078397,434787,1,'2007-09-15 14:20:42',3310493040,1),(51974055,425300447,16079088,434787,1,'2007-09-15 14:20:42',3310493040,1),(51974057,425301521,16078934,434787,1,'2007-09-15 14:20:42',3310493040,1),(51974059,425302826,16078320,434787,1,'2007-09-15 14:20:42',3310493040,1),(51974060,425305896,16078244,434787,1,'2007-09-15 14:20:42',3310493040,1),(51974065,425309047,16078913,434787,1,'2007-09-15 14:20:42',3310493040,1),(51974068,425311216,16079542,434787,1,'2007-09-15 14:20:42',3310493040,1),(51974072,425312159,16079730,434787,1,'2007-09-15 14:20:43',3310493040,1),(51974074,425313416,16079793,434787,1,'2007-09-15 14:20:43',3310493040,1),(51974078,425314453,16079322,434787,1,'2007-09-15 14:20:43',3310493040,1),(51974083,425315459,16078882,434787,1,'2007-09-15 14:20:43',3310493041,1),(51974085,425316245,16079164,434787,1,'2007-09-15 14:20:43',3310493041,1),(51974086,425316339,16079793,434787,1,'2007-09-15 14:20:44',3310493041,1),(51974088,425316119,16080516,434787,1,'2007-09-15 14:20:44',3310493041,1),(51974089,425315522,16081176,434787,1,'2007-09-15 14:20:44',3310493041,1),(51974090,425314391,16081836,434787,1,'2007-09-15 14:20:44',3310493040,1),(51974095,425312662,16082936,434787,1,'2007-09-15 14:20:44',3310493040,1),(51974097,425311153,16083156,434787,1,'2007-09-15 14:20:44',3310493040,1),(51974100,425309456,16083156,434787,1,'2007-09-15 14:20:44',3310493040,1),(51974103,425308544,16083628,434787,1,'2007-09-15 14:20:45',3310493040,1),(51974107,425308167,16084382,434787,1,'2007-09-15 14:20:45',3310493040,1),(51974108,425308167,16085263,434787,1,'2007-09-15 14:20:45',3310493040,1),(51974112,425308638,16085828,434787,1,'2007-09-15 14:20:45',3310493040,1),(51974115,425309676,16086111,434787,1,'2007-09-15 14:20:45',3310493040,1),(51974119,425311122,16085891,434787,1,'2007-09-15 14:20:46',3310493040,1),(51974122,425314988,16084980,434787,1,'2007-09-15 14:20:46',3310493041,1),(51974126,425317314,16083848,434787,1,'2007-09-15 14:20:46',3310493041,1),(51974129,425319640,16082182,434787,1,'2007-09-15 14:20:46',3310493041,1),(51974131,425323266,16078703,434787,1,'2007-09-15 14:20:46',3310493041,1),(51974133,425325384,16076313,434787,1,'2007-09-15 14:20:46',3310493041,1),(51974134,425327883,16072565,434787,1,'2007-09-15 14:20:46',3310493041,1),(51974137,425330924,16067677,434787,1,'2007-09-15 14:20:47',3310493041,1),(51974140,425332825,16064363,434787,1,'2007-09-15 14:20:47',3310493041,1),(51974143,425334944,16060344,434787,1,'2007-09-15 14:20:47',3310493041,1),(51974147,425336736,16055836,434787,1,'2007-09-15 14:20:47',3310493041,1),(51974149,425338855,16050024,434787,1,'2007-09-15 14:20:47',3310493041,1),(51974152,425340267,16045515,434787,1,'2007-09-15 14:20:47',3310493041,1),(51974153,425341136,16041876,434787,1,'2007-09-15 14:20:48',3310493041,1),(51974155,425341896,16040084,434787,1,'2007-09-15 14:20:48',3310493019,1),(51974158,425342820,16039812,434787,1,'2007-09-15 14:20:48',3310493022,1),(51974161,425343634,16040192,434787,1,'2007-09-15 14:20:48',3310493022,1),(51974164,425343852,16041496,434787,1,'2007-09-15 14:20:48',3310493044,1),(51974165,425343526,16043288,434787,1,'2007-09-15 14:20:48',3310493044,1),(51974167,425342983,16046982,434787,1,'2007-09-15 14:20:48',3310493044,1),(51974169,425342385,16051110,434787,1,'2007-09-15 14:20:48',3310493044,1),(51974172,425339778,16061430,434787,1,'2007-09-15 14:20:49',3310493041,1),(51974174,425338148,16067731,434787,1,'2007-09-15 14:20:49',3310493041,1),(51974176,425336899,16074792,434787,1,'2007-09-15 14:20:49',3310493041,1),(51974181,425336114,16080316,434787,1,'2007-09-15 14:20:49',3310493041,1),(51974183,425335363,16085666,434787,1,'2007-09-15 14:20:49',3310493041,1),(51974185,425335014,16090363,434787,1,'2007-09-15 14:20:50',3310493041,1),(51974187,425334945,16093261,434787,1,'2007-09-15 14:20:50',3310493041,1),(51974190,425334669,16098644,434787,1,'2007-09-15 14:20:50',3310493043,1),(51974191,425334738,16104579,434787,1,'2007-09-15 14:20:50',3310493043,1),(51974193,425335083,16110100,434787,1,'2007-09-15 14:20:50',3310493043,1),(51974195,425335980,16114171,434787,1,'2007-09-15 14:20:50',3310493043,1),(51974197,425337085,16120451,434787,1,'2007-09-15 14:20:50',3310493043,1),(51974199,425338120,16126110,434787,1,'2007-09-15 14:20:51',3310493043,1),(51974202,425339086,16131907,434787,1,'2007-09-15 14:20:51',3310493043,1),(51974204,425340259,16134874,434787,1,'2007-09-15 14:20:51',3310493043,1),(51974206,425341915,16136807,434787,1,'2007-09-15 14:20:51',3310493043,1),(51974208,425344262,16137773,434787,1,'2007-09-15 14:20:51',3310493046,1),(51974211,425345711,16137773,434787,1,'2007-09-15 14:20:51',3310493046,1),(51974213,425347298,16137428,434787,1,'2007-09-15 14:20:52',3310493046,1),(51974215,425348402,16137014,434787,1,'2007-09-15 14:20:52',3310493046,1),(51974217,425349851,16136876,434787,1,'2007-09-15 14:20:52',3310493046,1),(51974220,425350818,16137635,434787,1,'2007-09-15 14:20:52',3310493046,1),(51974223,425351232,16139015,434787,1,'2007-09-15 14:20:52',3310493046,1),(51974226,425351439,16141706,434787,1,'2007-09-15 14:20:52',3310493046,1),(51974229,425351313,16145218,434787,1,'2007-09-15 14:20:52',3310493046,1),(51974231,425351387,16150567,434787,1,'2007-09-15 14:20:53',3310493052,1),(51974233,425351020,16158553,434787,1,'2007-09-15 14:20:53',3310493052,1),(51974236,425350874,16161337,434787,1,'2007-09-15 14:20:53',3310493052,1),(51974239,425350874,16163315,434787,1,'2007-09-15 14:20:53',3310493052,1),(51974242,425351313,16165660,434787,1,'2007-09-15 14:20:53',3310493052,1),(51974244,425352925,16170056,434787,1,'2007-09-15 14:20:53',3310493052,1),(51974247,425355416,16175038,434787,1,'2007-09-15 14:20:53',3310493052,1),(51974249,425356882,16179361,434787,1,'2007-09-15 14:20:53',3310493052,1),(51974251,425357688,16184636,434787,1,'2007-09-15 14:20:54',3310493052,1),(51974253,425357907,16188299,434787,1,'2007-09-15 14:20:54',3310493052,1),(51974256,425357907,16191230,434787,1,'2007-09-15 14:20:54',3310493052,1),(51974258,425357468,16196065,434787,1,'2007-09-15 14:20:54',3310493052,1),(51974261,425356515,16202952,434787,1,'2007-09-15 14:20:54',3310493052,1),(51974264,425356002,16208448,434787,1,'2007-09-15 14:20:54',3310493054,1),(51974266,425355416,16214455,434787,1,'2007-09-15 14:20:54',3310493054,1),(51974275,425354317,16218705,434787,1,'2007-09-15 14:20:55',3310493054,1),(51974278,425352705,16225885,434787,1,'2007-09-15 14:20:55',3310493054,1),(51974279,425351973,16231453,434787,1,'2007-09-15 14:20:55',3310493054,1),(51974281,425351826,16235483,434787,1,'2007-09-15 14:20:55',3310493054,1),(51974284,425351387,16238560,434787,1,'2007-09-15 14:20:55',3310493054,1),(51974286,425350947,16241711,434787,1,'2007-09-15 14:20:55',3310493054,1),(51974289,425350947,16245374,434787,1,'2007-09-15 14:20:55',3310493054,1),(51974291,425351680,16247865,434787,1,'2007-09-15 14:20:56',3310493054,1),(51974292,425352779,16250136,434787,1,'2007-09-15 14:20:56',3310493054,1),(51974293,425354171,16252115,434787,1,'2007-09-15 14:20:56',3310493054,1),(51974296,425356515,16254020,434787,1,'2007-09-15 14:20:56',3310493054,1),(51974298,425357688,16255558,434787,1,'2007-09-15 14:20:57',3310493054,1),(51974300,425358787,16259295,434787,1,'2007-09-15 14:20:57',3310493054,1),(51974301,425359519,16261786,434787,1,'2007-09-15 14:20:57',3310493140,1),(51974305,425360179,16264204,434787,1,'2007-09-15 14:20:57',3310493140,1),(51974308,425361497,16265596,434787,1,'2007-09-15 14:20:57',3310493140,1),(51974309,425362816,16266109,434787,1,'2007-09-15 14:20:57',3310493140,1),(51974313,425364355,16266402,434787,1,'2007-09-15 14:20:58',3310493140,1),(51974316,425366626,16265962,434787,1,'2007-09-15 14:20:58',3310493140,1),(51974319,425368165,16265156,434787,1,'2007-09-15 14:20:58',3310493140,1),(51974321,425370143,16263398,434787,1,'2007-09-15 14:20:58',3310493141,1),(51974323,425371828,16261566,434787,1,'2007-09-15 14:20:58',3310493141,1),(51974326,425373074,16258782,434787,1,'2007-09-15 14:20:59',3310493055,1),(51974328,425373953,16255558,434787,1,'2007-09-15 14:20:59',3310493055,1),(51974331,425375418,16251089,434787,1,'2007-09-15 14:20:59',3310493055,1),(51974334,425376371,16248085,434787,1,'2007-09-15 14:20:59',3310493055,1),(51974337,425378276,16245667,434787,1,'2007-09-15 14:20:59',3310493055,1),(51974339,425380840,16243689,434787,1,'2007-09-15 14:20:59',3310493055,1),(51974341,425383404,16239586,434787,1,'2007-09-15 14:21:00',3310493055,1),(51974345,425383990,16237535,434787,1,'2007-09-15 14:21:00',3310493055,1),(51974349,425384210,16234091,434787,1,'2007-09-15 14:21:00',3310493055,1),(51974353,425384283,16230061,434787,1,'2007-09-15 14:21:00',3310493055,1),(51974357,425384283,16225958,434787,1,'2007-09-15 14:21:00',3310493055,1),(51974360,425384283,16224933,434787,1,'2007-09-15 14:21:00',3310493055,1),(51974363,425383990,16223101,434787,1,'2007-09-15 14:21:00',3310493055,1),(51974365,425384137,16222222,434787,1,'2007-09-15 14:21:01',3310493055,1),(51974368,425384650,16221709,434787,1,'2007-09-15 14:21:01',3310493055,1),(51974371,425385236,16221929,434787,1,'2007-09-15 14:21:01',3310493055,1),(51974373,425385529,16222735,434787,1,'2007-09-15 14:21:01',3310493055,1),(51974374,425385456,16225006,434787,1,'2007-09-15 14:21:01',3310493055,1),(51974376,425385529,16228816,434787,1,'2007-09-15 14:21:02',3310493055,1),(51974378,425385969,16231600,434787,1,'2007-09-15 14:21:02',3310493055,1),(51974383,425387068,16234897,434787,1,'2007-09-15 14:21:02',3310493055,1),(51974385,425387434,16237461,434787,1,'2007-09-15 14:21:02',3310493055,1),(51974388,425387800,16242956,434787,1,'2007-09-15 14:21:02',3310493055,1),(51974391,425387874,16247865,434787,1,'2007-09-15 14:21:02',3310493055,1),(51974394,425387214,16256437,434787,1,'2007-09-15 14:21:02',3310493055,1),(51974395,425387068,16261639,434787,1,'2007-09-15 14:21:03',3310493141,1),(51974397,425387338,16264267,434787,1,'2007-09-15 14:21:03',3310493141,1),(51974400,425387707,16270816,434787,1,'2007-09-15 14:21:03',3310493141,1),(51974402,425387707,16276166,434787,1,'2007-09-15 14:21:03',3310493141,1),(51974404,425387430,16281332,434787,1,'2007-09-15 14:21:03',3310493141,1),(51974405,425387615,16285667,434787,1,'2007-09-15 14:21:03',3310493141,1),(51974408,425387984,16292493,434787,1,'2007-09-15 14:21:04',3310493141,1),(51974411,425388630,16298027,434787,1,'2007-09-15 14:21:04',3310493141,1),(51974414,425389367,16302270,434787,1,'2007-09-15 14:21:04',3310493141,1),(51974416,425390013,16306329,434787,1,'2007-09-15 14:21:04',3310493141,1),(51974419,425390659,16310019,434787,1,'2007-09-15 14:21:04',3310493141,1),(51974422,425390198,16313155,434787,1,'2007-09-15 14:21:04',3310493141,1),(51974424,425389736,16314907,434787,1,'2007-09-15 14:21:04',3310493141,1),(51974428,425388630,16317767,434787,1,'2007-09-15 14:21:05',3310493143,1),(51974430,425387338,16320811,434787,1,'2007-09-15 14:21:05',3310493143,1),(51974432,425386877,16322748,434787,1,'2007-09-15 14:21:05',3310493143,1),(51974436,425386692,16325699,434787,1,'2007-09-15 14:21:05',3310493143,1),(51974439,425387258,16328597,434787,1,'2007-09-15 14:21:05',3310493143,1),(51974442,425388261,16332064,434787,1,'2007-09-15 14:21:06',3310493143,1),(51974445,425388563,16334592,434787,1,'2007-09-15 14:21:06',3310493143,1),(51974446,425388449,16337913,434787,1,'2007-09-15 14:21:06',3310493143,1),(51974451,425388630,16340181,434787,1,'2007-09-15 14:21:06',3310493143,1),(51974452,425388826,16341451,434787,1,'2007-09-15 14:21:06',3310493143,1),(51974454,425390025,16342039,434787,1,'2007-09-15 14:21:06',3310493143,1),(51974455,425391108,16340973,434787,1,'2007-09-15 14:21:07',3310493143,1),(51974456,425391363,16338890,434787,1,'2007-09-15 14:21:07',3310493143,1),(51974458,425391673,16334647,434787,1,'2007-09-15 14:21:07',3310493143,1),(51974462,425392411,16330680,434787,1,'2007-09-15 14:21:07',3310493143,1),(51974466,425393518,16326991,434787,1,'2007-09-15 14:21:07',3310493143,1),(51974469,425394994,16321733,434787,1,'2007-09-15 14:21:08',3310493143,1),(51974472,425395640,16317767,434787,1,'2007-09-15 14:21:08',3310493143,1),(51974475,425395640,16314446,434787,1,'2007-09-15 14:21:08',3310493141,1),(51974478,425395363,16306698,434787,1,'2007-09-15 14:21:08',3310493141,1),(51974481,425389262,16342039,434787,1,'2007-09-15 14:21:08',3310493143,1),(51974484,425390870,16341610,434787,1,'2007-09-15 14:21:09',3310493143,1),(52002189,425104877,15459263,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002192,425109756,15460923,434787,1,'2007-09-15 15:09:48',3310491539,1),(52002196,425111768,15463739,188228,1,'2008-06-16 18:49:29',3310491539,3),(52002198,425108183,15459222,434787,1,'2007-09-15 15:09:48',3310491539,1),(52002202,425106603,15458834,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002204,425098579,15459191,434787,1,'2007-09-15 15:09:49',3310491539,1),(52002206,425101297,15460794,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002209,425104144,15459928,434787,1,'2007-09-15 15:09:49',3310491539,1),(52002211,425105525,15458928,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002212,425106971,15458859,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002214,425109112,15460059,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002216,425110138,15461553,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002219,425110313,15463739,188228,1,'2008-06-16 18:49:01',3310491539,2),(52002220,425107983,15460208,434787,1,'2007-09-15 15:09:50',3310491539,1),(52002222,425107277,15459617,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002223,425105502,15460425,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002226,425104673,15461243,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002229,425099318,15461965,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002231,425102030,15462096,508959,1,'2007-09-24 18:39:54',3310491539,1),(52002235,425067515,15270951,508959,1,'2007-09-24 18:39:54',3310491431,1),(52002238,425067087,15269869,434787,1,'2007-09-15 15:09:52',3310491431,1),(52002241,425067153,15264746,508959,1,'2007-09-24 18:39:54',3310491431,1),(52002244,425065171,15254581,508959,1,'2007-09-24 18:39:54',3310491431,1),(52002247,425061389,15248466,434787,1,'2007-09-15 15:09:53',3310491431,1),(52002248,425057445,15247192,508959,1,'2007-09-24 18:39:54',3310491431,1),(52002251,425060890,15250852,508959,1,'2007-09-24 18:39:54',3310491431,1),(52002253,425062718,15253714,434787,1,'2007-09-15 15:09:54',3310491431,1),(52002256,425040750,15200351,508959,1,'2007-09-24 18:39:54',3310491429,1),(52002258,425039231,15196247,508959,1,'2007-09-24 18:39:54',3310491428,1),(52002259,425038923,15193100,508959,1,'2007-09-24 18:39:54',3310491428,1),(52002261,425039811,15170198,508959,1,'2007-09-24 18:39:54',3310491428,1),(52002264,425037770,15165326,434787,1,'2007-09-15 15:09:55',3310491428,1),(52002266,425038411,15169701,508959,1,'2007-09-24 18:39:54',3310491428,1),(52002269,425036006,15160845,434787,1,'2007-09-15 15:09:55',3310491406,1),(52002272,425038104,15161314,434787,1,'2007-09-15 15:09:56',3310491406,1),(52002275,425034794,15156277,508959,1,'2007-09-24 18:39:54',3310491406,1),(52002278,425032742,15156139,508959,1,'2007-09-24 18:39:54',3310491406,1),(52002281,424978626,15094146,508959,1,'2007-09-24 18:39:54',3310491400,1),(52009103,424727970,14930747,508959,1,'2007-09-24 18:39:54',3310490815,1),(52009105,424729083,14930328,508959,1,'2007-09-24 18:39:54',3310490815,1),(52009107,424726445,14930313,508959,1,'2007-09-24 18:39:54',3310490815,1),(52009108,424721680,14922054,434787,1,'2007-09-15 15:24:23',3310490815,1),(52009109,424723033,14923441,434787,1,'2007-09-15 15:24:23',3310490815,1),(52009111,424724285,14924422,434787,1,'2007-09-15 15:24:23',3310490815,1),(52009114,424725333,14924997,434787,1,'2007-09-15 15:24:24',3310490815,1),(52009117,424726822,14925099,434787,1,'2007-09-15 15:24:24',3310490815,1),(52009118,424727769,14924794,434787,1,'2007-09-15 15:24:24',3310490815,1),(52009120,424728683,14923644,434787,1,'2007-09-15 15:24:24',3310490815,1),(52009122,424730002,14922765,434787,1,'2007-09-15 15:24:24',3310490815,1),(52009124,424731423,14921783,434787,1,'2007-09-15 15:24:25',3310490815,1),(52009126,424732693,14921298,434787,1,'2007-09-15 15:24:25',3310490815,1),(52009127,424735483,14922359,434787,1,'2007-09-15 15:24:25',3310490815,1),(52009129,424736510,14922913,439281,1,'2007-09-16 00:57:34',3310490815,1),(52009130,424757255,14866933,434787,1,'2007-09-15 15:24:26',3310490856,1),(52009134,424758499,14871947,434787,1,'2007-09-15 15:24:26',3310490856,1),(52009137,424759782,14877971,434787,1,'2007-09-15 15:24:26',3310490856,1),(52009140,424760637,14882402,434787,1,'2007-09-15 15:24:26',3310490856,1),(52009143,424762152,14889670,434787,1,'2007-09-15 15:24:27',3310490858,1),(52009144,424763085,14893635,434787,1,'2007-09-15 15:24:27',3310490858,1),(52009147,424763707,14896472,434787,1,'2007-09-15 15:24:27',3310490858,1),(52009150,424764096,14898843,434787,1,'2007-09-15 15:24:27',3310490858,1),(52009151,424763979,14902691,434787,1,'2007-09-15 15:24:28',3310490858,1),(52009154,424763901,14905372,434787,1,'2007-09-15 15:24:28',3310490858,1),(52009156,424763921,14906675,439281,1,'2007-09-16 00:57:34',3310490858,1),(52009157,424767930,14870633,434787,1,'2007-09-15 15:24:28',3310490857,1),(52009159,424759333,14874206,434787,1,'2007-09-15 15:24:28',3310490856,1),(52009161,424761630,14882458,434787,1,'2007-09-15 15:24:29',3310490856,1),(52009164,424770177,14878581,434787,1,'2007-09-15 15:24:29',3310490857,1),(52009168,424759474,14886019,434787,1,'2007-09-15 15:24:29',3310490856,1),(52009171,424758852,14886712,370566,1,'2008-05-09 02:14:21',3310490858,2),(52009174,424758881,14887758,434787,1,'2007-09-15 15:24:29',3310490858,1),(52009176,424758770,14890608,434787,1,'2007-09-15 15:24:29',3310490858,1),(52009179,424758511,14893198,434787,1,'2007-09-15 15:24:30',3310490858,1),(52009182,424758252,14895270,434787,1,'2007-09-15 15:24:30',3310490858,1),(52009184,424757475,14896047,434787,1,'2007-09-15 15:24:30',3310490858,1),(52009186,424755884,14896528,434787,1,'2007-09-15 15:24:30',3310490858,1),(52009189,424750851,14898601,434787,1,'2007-09-15 15:24:30',3310490858,1),(52009192,424747891,14900044,434787,1,'2007-09-15 15:24:30',3310490858,1),(52009194,424746226,14900821,434787,1,'2007-09-15 15:24:31',3310490858,1),(52009196,424743191,14903411,434787,1,'2007-09-15 15:24:31',3310490858,1),(52009197,424761317,14885508,434787,1,'2007-09-15 15:24:31',3310490856,1),(52011225,424539336,14857205,434787,1,'2007-09-15 15:27:57',3310490792,1),(52011227,424530186,14853952,508959,1,'2007-09-24 18:39:54',3310490792,1),(52011231,424542623,14857218,508959,1,'2007-09-24 18:39:54',3310490792,1),(52011234,424535770,14856367,434787,1,'2007-09-15 15:27:58',3310490792,1),(52011238,424525709,14851274,434787,1,'2007-09-15 15:27:58',3310490792,1),(52011242,424543885,14858714,508959,1,'2007-09-24 18:39:54',3310490792,1),(52011244,424540853,14858477,508959,1,'2007-09-24 18:39:54',3310490792,1),(52011249,424537160,14857946,508959,1,'2007-09-24 18:39:54',3310490792,1),(52011253,424533176,14856682,508959,1,'2007-09-24 18:39:54',3310490792,1),(52011256,424529142,14854856,508959,1,'2007-09-24 18:39:54',3310490792,1),(52011259,424525949,14853411,508959,1,'2007-09-24 18:39:54',3310490792,1),(52031003,425116007,15485111,188228,1,'2008-06-16 18:50:28',3310491539,2),(52031013,425116830,15488286,188228,1,'2008-06-16 18:52:01',3310491539,3),(52031030,425117716,15492664,188228,1,'2008-06-16 18:52:01',3310491545,2),(52031034,425118665,15495239,188228,1,'2008-06-16 18:52:01',3310491545,2),(52031036,425119595,15497880,434787,1,'2007-09-15 16:14:23',3310491545,1),(52031039,425121516,15500056,508959,1,'2007-09-24 18:39:54',3310491545,1),(52031041,425122962,15501502,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031043,425126336,15503109,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031046,425129454,15505198,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031050,425130578,15508154,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031054,425131349,15512107,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031056,425132249,15516060,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031059,425133053,15518245,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031076,425133817,15520466,434787,1,'2007-09-15 16:14:27',3310491548,1),(52031077,425134735,15522628,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031080,425135919,15523339,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031082,425136956,15524228,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031084,425137578,15525205,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031086,425139385,15527959,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031089,425141132,15529410,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031092,425141783,15529707,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031095,425142879,15529262,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031099,425143827,15528285,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031100,425145244,15528216,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031105,425147203,15528552,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031109,425148891,15529322,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031114,425150846,15530714,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031117,425152001,15533172,434787,1,'2007-09-15 16:14:31',3310491549,1),(52031121,425153067,15535808,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031125,425153837,15537792,434787,1,'2007-09-15 16:14:32',3310491549,1),(52031129,425154607,15538503,434787,1,'2007-09-15 16:14:32',3310491549,1),(52031131,425155999,15538947,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031136,425160086,15538858,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031141,425161967,15538663,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031147,425165787,15534984,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031151,425166542,15534984,434787,1,'2007-09-15 16:14:33',3310491549,1),(52031153,425167485,15535928,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031156,425173569,15541021,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031158,425178899,15545832,508959,1,'2007-09-24 18:39:54',3310491592,1),(52031164,425183521,15550171,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031171,425185974,15552058,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031174,425188049,15555218,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031178,425190266,15560595,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031186,425192577,15564321,434787,1,'2007-09-15 16:14:35',3310491594,1),(52031190,425195925,15567245,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031198,425199651,15568848,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031205,425203094,15569697,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031212,425205547,15570924,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031218,425207622,15573423,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031221,425209414,15574414,434787,1,'2007-09-15 16:14:38',3310491595,1),(52031224,425211537,15575593,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031227,425213562,15576830,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031232,425215518,15579764,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031235,425216876,15583458,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031240,425217908,15586501,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031244,425218778,15588837,434787,1,'2007-09-15 16:14:39',3310491595,1),(52031247,425219538,15590522,434787,1,'2007-09-15 16:14:39',3310491595,1),(52031250,425221223,15592206,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031255,425223016,15593945,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031260,425224548,15596343,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031262,425226557,15601096,434787,1,'2007-09-15 16:14:40',3310491617,1),(52031267,425228321,15606142,434787,1,'2007-09-15 16:14:40',3310491617,1),(52031272,425229654,15608318,508959,1,'2007-09-24 18:39:54',3310491617,1),(52031275,425231476,15610199,508959,1,'2007-09-24 18:39:54',3310491617,1),(52031281,425235298,15612374,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031285,425237062,15613609,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031290,425238296,15616137,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031295,425239707,15618548,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031299,425242000,15620840,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031307,425245528,15623251,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031309,425249114,15625309,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031314,425251877,15627778,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031320,425253641,15630424,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031325,425254641,15633246,434787,1,'2007-09-15 16:14:43',3310491620,1),(52031329,425255111,15636715,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031335,425254699,15641594,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031340,425253641,15645651,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031346,425253406,15647826,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031351,425253773,15649696,188228,1,'2008-06-16 19:33:39',3310491620,2),(52031355,425254848,15653130,188228,1,'2008-06-16 19:33:39',3310491620,2),(52031357,425256176,15656563,188228,1,'2008-06-16 19:33:39',3310491622,2),(52031361,425259023,15662056,188228,1,'2008-06-16 19:34:11',3310491622,2),(52031364,425260731,15664459,188228,1,'2008-06-16 19:34:30',3310491623,2),(52031367,425262695,15666464,434787,1,'2007-09-15 16:14:45',3310491623,1),(52031369,425264988,15667522,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031373,425268281,15668522,434787,1,'2007-09-15 16:14:45',3310491623,1),(52031381,425271044,15669991,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031384,425272337,15672696,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031410,425273807,15678046,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031414,425274572,15683631,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031418,425275924,15686630,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031424,425277746,15688864,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031426,425280333,15689687,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031429,425284037,15689687,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031433,425286624,15689570,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031438,425289623,15689687,508959,1,'2007-09-24 18:39:54',3310491634,1),(52031441,425290975,15690687,508959,1,'2007-09-24 18:39:54',3310491634,1),(52031446,425291915,15692803,508959,1,'2007-09-24 18:39:54',3310491634,1),(52031449,425292739,15696037,508959,1,'2007-09-24 18:39:54',3310491634,1),(52031456,425294326,15698800,508959,1,'2007-09-24 18:39:54',3310491634,1),(52031461,425296972,15702916,508959,1,'2007-09-24 18:39:54',3310491634,1),(52031464,425300264,15706032,508959,1,'2007-09-24 18:39:54',3310491634,1),(52031467,425304380,15708618,508959,1,'2007-09-24 18:39:54',3310491634,1),(52031471,425307084,15710500,508959,1,'2007-09-24 18:39:54',3310491634,1),(52031477,425308965,15712616,434787,1,'2007-09-15 16:14:50',3310491640,1),(52031481,425311376,15716320,508959,1,'2007-09-24 18:39:54',3310491640,1),(52031483,425314492,15721553,434787,1,'2007-09-15 16:14:51',3310491640,1),(52031486,425316726,15724963,508959,1,'2007-09-24 18:39:54',3310491641,1),(52031491,425319019,15727079,508959,1,'2007-09-24 18:39:54',3310491641,1),(52031494,425321253,15729196,434787,1,'2007-09-15 16:14:51',3310491641,1),(52031498,425323605,15731548,508959,1,'2007-09-24 18:39:54',3310491641,1),(52031500,425325075,15733723,508959,1,'2007-09-24 18:39:54',3310491641,1),(52031504,425325780,15734899,508959,1,'2007-09-24 18:39:54',3310491641,1),(52031507,425326368,15736545,434787,1,'2007-09-15 16:14:52',3310491641,1),(52031512,425326074,15739661,508959,1,'2007-09-24 18:39:54',3310491641,1),(52031514,425326309,15744659,434787,1,'2007-09-15 16:14:52',3310491641,1),(52031517,425327074,15748480,508959,1,'2007-09-24 18:39:54',3310491641,1),(52031521,425328014,15755065,434787,1,'2007-09-15 16:14:52',3310491641,1),(52031523,425328661,15759357,508959,1,'2007-09-24 18:39:54',3310491641,1),(52031527,425329131,15764825,508959,1,'2007-09-24 18:39:54',3310491641,1),(52031529,425330307,15770763,508959,1,'2007-09-24 18:39:54',3310491643,1),(52031532,425331718,15773761,508959,1,'2007-09-24 18:39:54',3310491643,1),(52031535,425332659,15776054,508959,1,'2007-09-24 18:39:54',3310491643,1),(52031540,425334188,15778994,508959,1,'2007-09-24 18:39:54',3310491643,1),(52031545,425334834,15781522,434787,1,'2007-09-15 16:14:54',3310491643,1),(52031550,425335716,15786578,508959,1,'2007-09-24 18:39:54',3310491643,1),(52031552,425335834,15790282,508959,1,'2007-09-24 18:39:54',3310491643,1),(52031554,425336363,15793692,434787,1,'2007-09-15 16:14:54',3310491643,1),(52031560,425336598,15796690,434787,1,'2007-09-15 16:14:54',3310491643,1),(52031562,425337010,15798748,434787,1,'2007-09-15 16:14:54',3310491643,1),(52031567,425338127,15800630,434787,1,'2007-09-15 16:14:55',3310491643,1),(52031572,425339714,15802158,508959,1,'2007-09-24 18:39:54',3310491643,1),(52031576,425343359,15803922,508959,1,'2007-09-24 18:39:54',3310491646,1),(52031580,425346534,15805627,508959,1,'2007-09-24 18:39:54',3310491646,1),(52031581,425349709,15807450,508959,1,'2007-09-24 18:39:54',3310491646,1),(52031587,425352590,15809978,434787,1,'2007-09-15 16:14:56',3310491646,1),(52031590,425357646,15815504,508959,1,'2007-09-24 18:39:54',3310491646,1),(52031592,425361468,15819267,508959,1,'2007-09-24 18:39:54',3310491646,1),(52031595,425365348,15823676,508959,1,'2007-09-24 18:39:54',3310493012,1),(52031600,425369169,15827204,434787,1,'2007-09-15 16:14:57',3310493012,1),(52031604,425373050,15830261,434787,1,'2007-09-15 16:14:57',3310493013,1),(52031608,425375225,15832143,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031611,425376695,15834494,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031614,425377048,15836434,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031616,425377048,15838610,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031617,425377048,15840668,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031620,425376813,15842608,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031621,425375931,15844842,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031626,425375225,15846547,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031627,425375108,15848605,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031631,425375049,15851133,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031634,425375872,15852661,434787,1,'2007-09-15 16:14:59',3310493013,1),(52031636,425376813,15854543,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031642,425377459,15856718,434787,1,'2007-09-15 16:15:00',3310493013,1),(52031645,425377577,15858305,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031648,425377988,15860716,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031652,425378576,15862186,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031656,425379929,15864361,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031658,425380693,15867712,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031660,425381046,15870828,434787,1,'2007-09-15 16:15:02',3310493013,1),(52031665,425381398,15872945,434787,1,'2007-09-15 16:15:02',3310493013,1),(52031668,425382222,15874121,508959,1,'2007-09-24 18:39:54',3310493013,1),(52031671,425383927,15875885,508959,1,'2007-09-24 18:39:54',3310493015,1),(52031676,425385808,15878119,508959,1,'2007-09-24 18:39:54',3310493015,1),(52031678,425387101,15881235,508959,1,'2007-09-24 18:39:54',3310493015,1),(52031681,425387572,15883586,508959,1,'2007-09-24 18:39:54',3310493015,1),(52031686,425387866,15887584,508959,1,'2007-09-24 18:39:54',3310493015,1),(52031688,425387983,15893405,508959,1,'2007-09-24 18:39:54',3310493015,1),(52031691,425388454,15895110,508959,1,'2007-09-24 18:39:54',3310493015,1),(52031695,425389982,15898520,434787,1,'2007-09-15 16:15:04',3310493015,1),(52031700,425392158,15901695,508959,1,'2007-09-24 18:39:54',3310493015,1),(52031702,425395097,15903929,434787,1,'2007-09-15 16:15:04',3310493015,1),(52031705,425400036,15906045,434787,1,'2007-09-15 16:15:05',3310503938,1),(52031709,425404622,15907221,508959,1,'2007-09-24 18:39:54',3310503938,1),(52031712,425407914,15907045,508959,1,'2007-09-24 18:39:54',3310503938,1),(52031715,425411736,15906281,508959,1,'2007-09-24 18:39:54',3310503938,1),(52031717,425414381,15905575,508959,1,'2007-09-24 18:39:54',3310503938,1),(52031720,425416263,15905163,508959,1,'2007-09-24 18:39:54',3310503938,1),(52031723,425417791,15906104,508959,1,'2007-09-24 18:39:54',3310503938,1),(52031726,425117209,15484939,188228,1,'2008-06-16 18:50:28',3310491539,2),(52031730,425118412,15489745,188228,1,'2008-06-16 18:50:28',3310491539,3),(52031732,425119108,15493007,188228,1,'2008-06-16 18:52:01',3310491545,3),(52031736,425119740,15494380,188228,1,'2008-06-16 18:52:01',3310491545,3),(52031739,425120876,15497601,508959,1,'2007-09-24 18:39:54',3310491545,1),(52031742,425124337,15500196,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031744,425126729,15501621,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031746,425129070,15502995,434787,1,'2007-09-15 16:15:08',3310491548,1),(52031747,425130495,15504726,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031749,425131310,15507372,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031751,425132277,15512157,434787,1,'2007-09-15 16:15:09',3310491548,1),(52031756,425133142,15515567,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031758,425134262,15519078,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031761,425135279,15521318,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031764,425137213,15522946,434787,1,'2007-09-15 16:15:09',3310491548,1),(52031767,425138333,15524626,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031771,425140725,15527476,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031774,425141590,15528290,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031777,425142965,15528138,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031782,425143932,15527527,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031785,425145662,15527476,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031789,425147901,15527985,508959,1,'2007-09-24 18:39:54',3310491548,1),(52031794,425150039,15529054,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031798,425151871,15530428,434787,1,'2007-09-15 16:15:12',3310491549,1),(52031803,425152838,15532158,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031805,425154009,15535467,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031809,425154925,15537248,434787,1,'2007-09-15 16:15:13',3310491549,1),(52031811,425155994,15537910,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031813,425157877,15537808,434787,1,'2007-09-15 16:15:13',3310491549,1),(52031815,425160523,15537553,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031821,425161694,15536841,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031823,425162661,15535823,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031827,425164188,15533940,434787,1,'2007-09-15 16:15:14',3310491549,1),(52031830,425165511,15533431,434787,1,'2007-09-15 16:15:14',3310491549,1),(52031832,425166580,15533380,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031834,425168005,15534500,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031838,425174520,15540658,508959,1,'2007-09-24 18:39:54',3310491549,1),(52031840,425179762,15544831,508959,1,'2007-09-24 18:39:54',3310491592,1),(52031844,425184037,15548343,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031847,425186226,15550481,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031850,425187600,15553127,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031855,425190348,15558522,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031858,425191773,15561525,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031861,425193758,15563764,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031865,425196099,15565698,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031866,425198949,15567174,434787,1,'2007-09-15 16:15:17',3310491594,1),(52031868,425201901,15567887,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031871,425204395,15568752,508959,1,'2007-09-24 18:39:54',3310491594,1),(52031872,425207551,15571653,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031874,425208467,15572722,434787,1,'2007-09-15 16:15:17',3310491595,1),(52031876,425209994,15573180,434787,1,'2007-09-15 16:15:17',3310491595,1),(52031881,425212284,15573943,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031884,425213913,15574859,434787,1,'2007-09-15 16:15:18',3310491595,1),(52031886,425215389,15576641,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031888,425216915,15579694,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031889,425218442,15584937,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031893,425219562,15588347,434787,1,'2007-09-15 16:15:19',3310491595,1),(52031894,425220274,15589823,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031899,425221394,15591044,434787,1,'2007-09-15 16:15:19',3310491595,1),(52031901,425223226,15592571,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031906,425224753,15594861,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031908,425226331,15597864,434787,1,'2007-09-15 16:15:19',3310491595,1),(52031911,425227247,15600562,508959,1,'2007-09-24 18:39:54',3310491595,1),(52031913,425229232,15605549,434787,1,'2007-09-15 16:15:20',3310491617,1),(52031915,425230606,15607432,434787,1,'2007-09-15 16:15:20',3310491617,1),(52031919,425232082,15609163,508959,1,'2007-09-24 18:39:54',3310491617,1),(52031921,425235645,15611250,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031925,425237477,15612522,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031927,425239207,15615626,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031930,425240378,15617764,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031933,425242567,15619596,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031936,425245926,15621683,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031938,425249641,15623872,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031943,425252491,15626823,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031946,425254680,15629775,434787,1,'2007-09-15 16:15:22',3310491620,1),(52031948,425255596,15633033,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031953,425256105,15636697,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031956,425255799,15641685,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031958,425254883,15645756,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031962,425254578,15647996,508959,1,'2007-09-24 18:39:54',3310491620,1),(52031966,425254680,15649624,434787,1,'2007-09-15 16:15:23',3310491620,1),(52031968,425255494,15652627,434787,1,'2007-09-15 16:15:24',3310491620,1),(52031973,425257021,15656292,508959,1,'2007-09-24 18:39:54',3310491622,1),(52031976,425259719,15661112,188228,1,'2008-06-16 19:34:11',3310491622,2),(52031980,425261500,15663570,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031984,425263230,15665249,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031987,425265266,15666165,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031990,425268421,15666522,434787,1,'2007-09-15 16:15:25',3310491623,1),(52031992,425271679,15667998,434787,1,'2007-09-15 16:15:25',3310491623,1),(52031995,425273613,15671306,508959,1,'2007-09-24 18:39:54',3310491623,1),(52031998,425274783,15677668,434787,1,'2007-09-15 16:15:25',3310491623,1),(52032000,425275292,15683368,434787,1,'2007-09-15 16:15:25',3310491623,1),(52032003,425276310,15686167,434787,1,'2007-09-15 16:15:26',3310491623,1),(52032007,425277888,15688203,508959,1,'2007-09-24 18:39:54',3310491623,1),(52032010,425280280,15688458,508959,1,'2007-09-24 18:39:54',3310491623,1),(52032012,425284046,15688203,508959,1,'2007-09-24 18:39:54',3310491623,1),(52032017,425286642,15688152,508959,1,'2007-09-24 18:39:54',3310491623,1),(52032018,425289848,15688661,508959,1,'2007-09-24 18:39:54',3310491634,1),(52032021,425291884,15689628,508959,1,'2007-09-24 18:39:54',3310491634,1),(52032022,425292647,15691664,434787,1,'2007-09-15 16:15:27',3310491634,1),(52032026,425293716,15695430,434787,1,'2007-09-15 16:15:27',3310491634,1),(52032029,425295192,15698026,434787,1,'2007-09-15 16:15:27',3310491634,1),(52032033,425297941,15702047,434787,1,'2007-09-15 16:15:28',3310491634,1),(52032035,425300791,15705100,508959,1,'2007-09-24 18:39:54',3310491634,1),(52032039,425304659,15707340,508959,1,'2007-09-24 18:39:54',3310491634,1),(52032041,425307560,15709528,508959,1,'2007-09-24 18:39:54',3310491634,1),(52032044,425309443,15712175,508959,1,'2007-09-24 18:39:54',3310491640,1),(52032047,425312039,15715788,508959,1,'2007-09-24 18:39:54',3310491640,1),(52032048,425314940,15720980,434787,1,'2007-09-15 16:15:29',3310491641,1),(52032051,425317281,15723982,508959,1,'2007-09-24 18:39:54',3310491641,1),(52032054,425319673,15726324,508959,1,'2007-09-24 18:39:54',3310491641,1),(52032057,425321912,15728410,508959,1,'2007-09-24 18:39:54',3310491641,1),(52032060,425326136,15732380,508959,1,'2007-09-24 18:39:54',3310491641,1),(52032064,425326747,15734263,434787,1,'2007-09-15 16:15:30',3310491641,1),(52032067,425327307,15736401,508959,1,'2007-09-24 18:39:54',3310491641,1),(52032070,425327409,15739963,434787,1,'2007-09-15 16:15:30',3310491641,1),(52032071,425327918,15748158,434787,1,'2007-09-15 16:15:30',3310491641,1),(52032075,425328834,15754825,508959,1,'2007-09-24 18:39:54',3310491641,1),(52032076,425329496,15759456,508959,1,'2007-09-24 18:39:54',3310491641,1),(52032078,425330005,15764749,508959,1,'2007-09-24 18:39:54',3310491641,1),(52032081,425330972,15770195,434787,1,'2007-09-15 16:15:31',3310491643,1),(52032085,425332447,15772944,508959,1,'2007-09-24 18:39:54',3310491643,1),(52032087,425333465,15774776,508959,1,'2007-09-24 18:39:54',3310491643,1),(52032090,425334941,15778186,434787,1,'2007-09-15 16:15:32',3310491643,1),(52032092,425335756,15781290,434787,1,'2007-09-15 16:15:32',3310491643,1),(52032093,425336672,15786583,508959,1,'2007-09-24 18:39:54',3310491643,1),(52032098,425336926,15790095,508959,1,'2007-09-24 18:39:54',3310491643,1),(52032100,425337435,15793811,508959,1,'2007-09-24 18:39:54',3310491643,1),(52032103,425337537,15796610,508959,1,'2007-09-24 18:39:54',3310491643,1),(52032107,425338097,15798544,508959,1,'2007-09-24 18:39:54',3310491643,1);
INSERT INTO `nodes` VALUES (52032109,425338708,15799816,508959,1,'2007-09-24 18:39:54',3310491643,1),(52032112,425340234,15800987,508959,1,'2007-09-24 18:39:54',3310491643,1),(52032113,425343441,15802514,434787,1,'2007-09-15 16:15:33',3310491646,1),(52032116,425346851,15804193,434787,1,'2007-09-15 16:15:34',3310491646,1),(52032119,425349752,15805822,434787,1,'2007-09-15 16:15:34',3310491646,1),(52032122,425352449,15808265,434787,1,'2007-09-15 16:15:34',3310491646,1),(52032125,425354638,15810453,508959,1,'2007-09-24 18:39:54',3310491646,1),(52032127,425359167,15815085,508959,1,'2007-09-24 18:39:54',3310491646,1),(52032130,425363239,15819462,434787,1,'2007-09-15 16:15:35',3310491646,1),(52032133,425367565,15823533,508959,1,'2007-09-24 18:39:54',3310493012,1),(52032135,425370873,15826587,434787,1,'2007-09-15 16:15:35',3310493013,1),(52032137,425373673,15828725,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032141,425376319,15831320,434787,1,'2007-09-15 16:15:36',3310493013,1),(52032145,425377642,15833153,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032147,425378100,15836308,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032150,425378050,15840685,434787,1,'2007-09-15 16:15:36',3310493013,1),(52032153,425377744,15843077,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032158,425376828,15845775,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032160,425376116,15847861,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032162,425375810,15849643,434787,1,'2007-09-15 16:15:37',3310493013,1),(52032165,425376116,15851628,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032168,425377083,15853154,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032171,425378151,15855648,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032174,425378660,15859007,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032176,425379322,15861450,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032179,425380594,15863028,434787,1,'2007-09-15 16:15:39',3310493013,1),(52032182,425381256,15864504,434787,1,'2007-09-15 16:15:39',3310493013,1),(52032183,425381867,15866184,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032186,425382121,15867507,434787,1,'2007-09-15 16:15:39',3310493013,1),(52032187,425382070,15869899,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032190,425382477,15872291,434787,1,'2007-09-15 16:15:40',3310493013,1),(52032192,425383750,15874378,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032195,425385124,15875396,508959,1,'2007-09-24 18:39:54',3310493013,1),(52032197,425387007,15877482,508959,1,'2007-09-24 18:39:54',3310493015,1),(52032200,425387974,15879518,508959,1,'2007-09-24 18:39:54',3310493015,1),(52032204,425388636,15883488,508959,1,'2007-09-24 18:39:54',3310493015,1),(52032205,425389094,15887407,434787,1,'2007-09-15 16:15:41',3310493015,1),(52032208,425389145,15892954,434787,1,'2007-09-15 16:15:42',3310493015,1),(52032211,425389552,15894532,508959,1,'2007-09-24 18:39:54',3310493015,1),(52032212,425390824,15898044,434787,1,'2007-09-15 16:15:42',3310493015,1),(52032216,425392656,15900843,508959,1,'2007-09-24 18:39:54',3310493015,1),(52032219,425395303,15902726,508959,1,'2007-09-24 18:39:54',3310493015,1),(52032222,425400291,15904609,508959,1,'2007-09-24 18:39:54',3310503938,1),(52032225,425404515,15905424,508959,1,'2007-09-24 18:39:54',3310503938,1),(52032228,425407518,15905373,434787,1,'2007-09-15 16:15:43',3310503938,1),(52032233,425411233,15905067,508959,1,'2007-09-24 18:39:54',3310503938,1),(52032238,425414134,15904100,434787,1,'2007-09-15 16:15:43',3310503938,1),(52032241,425416374,15903795,434787,1,'2007-09-15 16:15:43',3310503938,1),(52032243,425418186,15904585,434787,1,'2007-09-15 16:15:43',3310503938,1),(52032246,425419679,15905500,508959,1,'2007-09-24 18:39:54',3310503938,1),(52032249,425419359,15906380,434787,1,'2007-09-15 16:15:44',3310503938,1),(52032250,425419510,15905965,508959,1,'2007-09-24 18:39:54',3310503938,1),(52163550,425556412,15336966,72964,1,'2008-08-05 20:37:35',3310502459,4),(52163556,425558372,15343575,72964,1,'2008-08-05 20:37:36',3310502459,4),(52163563,425559826,15346579,72964,1,'2008-08-05 20:37:36',3310502459,4),(52163574,425560910,15347910,72964,1,'2008-08-05 20:37:36',3310502459,3),(52163581,425562312,15347865,72964,1,'2008-08-05 20:37:36',3310502462,3),(52163588,425563036,15347322,435967,1,'2007-09-15 21:25:22',3310502462,1),(52163595,425563579,15346191,435967,1,'2007-09-15 21:25:23',3310502462,1),(52163602,425563669,15344834,435967,1,'2007-09-15 21:25:24',3310502462,1),(52163609,425563986,15343296,435967,1,'2007-09-15 21:25:24',3310502462,1),(52163613,425564710,15340718,435967,1,'2007-09-15 21:25:24',3310502462,1),(52163621,425566066,15337959,435967,1,'2007-09-15 21:25:25',3310502462,1),(52163631,425566790,15335561,435967,1,'2007-09-15 21:25:27',3310502462,1),(52163644,425566790,15333119,435967,1,'2007-09-15 21:25:29',3310502462,1),(52163664,425566428,15329229,435967,1,'2007-09-15 21:25:33',3310502462,1),(52164958,425566971,15327691,538211,1,'2007-09-30 15:36:21',3310502462,1),(52166749,425568147,15326605,198831,1,'2008-04-20 16:36:30',3310502462,2),(52166950,425568578,15326123,2836771,1,'2009-10-13 18:46:13',3310502460,2),(52166959,426369093,14912041,373445,1,'2008-05-09 19:04:04',3310503087,2),(52166976,426368531,14916137,373445,1,'2008-05-09 19:04:04',3310503087,2),(52166980,426368772,14921678,373445,1,'2008-05-09 19:04:04',3310503087,2),(52167010,426369174,14925051,373445,1,'2008-05-09 19:04:04',3310503087,2),(52167017,426368210,14927058,373445,1,'2008-05-09 19:04:04',3310503087,2),(52167025,426368772,14929146,373445,1,'2008-05-09 19:04:04',3310503087,2),(52167030,426368692,14932198,373445,1,'2008-05-09 19:04:04',3310503087,2),(52167039,426367969,14934527,373445,1,'2008-05-09 19:04:04',3310503087,2),(52167045,426366283,14936534,373445,1,'2008-05-09 19:04:04',3310503087,2),(52167049,426364998,14937819,373445,1,'2008-05-09 19:04:04',3310503087,2),(52167052,426364114,14939907,373445,1,'2008-05-09 19:04:04',3310503087,2),(52167062,426362910,14942477,373445,1,'2008-05-09 19:04:04',3310503429,2),(52167066,426361785,14943360,373445,1,'2008-05-09 19:04:04',3310503429,2),(52167070,426360179,14944324,373445,1,'2008-05-09 19:04:04',3310503429,2),(52167076,426358493,14945127,373445,1,'2008-05-09 19:04:04',3310503429,2),(52167082,426357208,14945689,373445,1,'2008-05-09 19:04:04',3310503428,2),(52167086,426354799,14944645,373445,1,'2008-05-09 19:04:04',3310503428,2),(52167105,426353032,14944484,373445,1,'2008-05-09 19:04:04',3310503428,2),(52167111,426351105,14944725,373445,1,'2008-05-09 19:04:04',3310503428,2),(52167122,426349258,14945930,373445,1,'2008-05-09 19:04:04',3310503428,2),(52167128,426346561,14926721,446582,1,'2008-05-15 01:25:41',3310503086,2),(52167136,426347555,14930060,446582,1,'2008-05-15 01:25:41',3310503086,2),(52167142,426347839,14934678,446582,1,'2008-05-15 01:25:41',3310503086,2),(52167150,426347129,14937165,446582,1,'2008-05-15 01:25:42',3310503086,2),(52167155,426346276,14941783,446582,1,'2008-05-15 01:25:41',3310503428,2),(52167165,426346561,14949314,373445,1,'2008-05-09 19:04:04',3310503428,2),(52167175,426346666,14950600,446582,1,'2008-05-15 01:25:41',3310503428,2),(52167179,426346640,14952527,435967,1,'2007-09-15 21:36:39',3310503428,1),(52167183,426346869,14956007,435967,1,'2007-09-15 21:36:39',3310503428,1),(52167190,426346594,14959213,435967,1,'2007-09-15 21:36:39',3310503428,1),(52167198,426346914,14961732,435967,1,'2007-09-15 21:36:40',3310503428,1),(52167208,426347143,14965762,435967,1,'2007-09-15 21:36:40',3310503428,1),(52167211,426346823,14967686,435967,1,'2007-09-15 21:36:40',3310503428,1),(52167218,426345678,14969930,435967,1,'2007-09-15 21:36:41',3310503428,1),(52167223,426343938,14971945,435967,1,'2007-09-15 21:36:41',3310503428,1),(52167232,426342839,14975059,435967,1,'2007-09-15 21:36:42',3310503428,1),(52167248,426342289,14977532,435967,1,'2007-09-15 21:36:42',3310503428,1),(52167254,426341785,14979089,435967,1,'2007-09-15 21:36:43',3310503428,1),(52167257,426340778,14979868,435967,1,'2007-09-15 21:36:43',3310503428,1),(52167262,426339770,14980738,435967,1,'2007-09-15 21:36:44',3310503428,1),(52167277,426339404,14981608,435967,1,'2007-09-15 21:36:46',3310503428,1),(52167279,426338854,14983760,435967,1,'2007-09-15 21:36:46',3310503428,1),(52167284,426338854,14985088,435967,1,'2007-09-15 21:36:46',3310503428,1),(52167289,426338671,14985913,435967,1,'2007-09-15 21:36:47',3310503428,1),(52167293,426337938,14986371,435967,1,'2007-09-15 21:36:47',3310503428,1),(52167300,426337343,14987241,435967,1,'2007-09-15 21:36:48',3310503428,1),(52167307,426336106,14988065,435967,1,'2007-09-15 21:36:49',3310503428,1),(52167309,426334961,14989577,435967,1,'2007-09-15 21:36:49',3310503428,1),(52167315,426333404,14991592,435967,1,'2007-09-15 21:36:49',3310503428,1),(52167320,426332717,14993149,435967,1,'2007-09-15 21:36:49',3310503428,1),(52167323,426333038,14994752,435967,1,'2007-09-15 21:36:50',3310503428,1),(52167329,426333862,14996904,435967,1,'2007-09-15 21:36:50',3310503430,1),(52167336,426333771,14999789,435967,1,'2007-09-15 21:36:50',3310503430,1),(52167345,426333725,15000888,435967,1,'2007-09-15 21:36:51',3310503430,1),(52167349,426333725,15002766,435967,1,'2007-09-15 21:36:51',3310503430,1),(52167353,426333725,15004048,435967,1,'2007-09-15 21:36:51',3310503430,1),(52167358,426333450,15004598,435967,1,'2007-09-15 21:36:52',3310503430,1),(52167363,426332855,15004964,435967,1,'2007-09-15 21:36:52',3310503430,1),(52167368,426332030,15004964,435967,1,'2007-09-15 21:36:52',3310503430,1),(52167372,426331252,15004827,435967,1,'2007-09-15 21:36:52',3310503430,1),(52167380,426330519,15005010,435967,1,'2007-09-15 21:36:52',3310503427,1),(52167387,426329786,15005514,435967,1,'2007-09-15 21:36:53',3310503427,1),(52167389,426328916,15006613,435967,1,'2007-09-15 21:36:53',3310503427,1),(52167390,426328596,15008124,435967,1,'2007-09-15 21:36:53',3310503427,1),(52167393,426328458,15010964,435967,1,'2007-09-15 21:36:54',3310503427,1),(52167396,426327909,15013483,435967,1,'2007-09-15 21:36:54',3310503427,1),(52167398,426327359,15016001,435967,1,'2007-09-15 21:36:54',3310503427,1),(52167402,426326260,15017971,435967,1,'2007-09-15 21:36:55',3310503427,1),(52167406,426325756,15021085,435967,1,'2007-09-15 21:36:55',3310503427,1),(52167421,426326077,15023787,435967,1,'2007-09-15 21:36:57',3310503427,1),(52167425,426326855,15026443,435967,1,'2007-09-15 21:36:58',3310503427,1),(52167428,426327588,15028733,435967,1,'2007-09-15 21:36:58',3310503427,1),(52167430,426327405,15030657,435967,1,'2007-09-15 21:36:58',3310503427,1),(52167433,426327222,15032443,435967,1,'2007-09-15 21:36:58',3310503427,1),(52167436,426326901,15035465,435967,1,'2007-09-15 21:36:58',3310503427,1),(52167438,426326718,15038946,435967,1,'2007-09-15 21:36:59',3310503427,1),(52167439,426326617,15042242,435967,1,'2007-09-15 21:36:59',3310503427,1),(52167444,426326617,15043829,435967,1,'2007-09-15 21:37:00',3310503427,1),(52167446,426325683,15045230,435967,1,'2007-09-15 21:37:00',3310503427,1),(52167453,426324983,15045976,435967,1,'2007-09-15 21:37:01',3310503427,1),(52167457,426325030,15046677,435967,1,'2007-09-15 21:37:01',3310503427,1),(52167470,426325450,15048030,435967,1,'2007-09-15 21:37:03',3310503427,1),(52167473,426327503,15049804,435967,1,'2007-09-15 21:37:03',3310503427,1),(52167477,426329044,15051251,435967,1,'2007-09-15 21:37:03',3310503427,1),(52167484,426329931,15052371,435967,1,'2007-09-15 21:37:04',3310503433,1),(52167487,426330024,15054005,435967,1,'2007-09-15 21:37:04',3310503433,1),(52167490,426329604,15055732,435967,1,'2007-09-15 21:37:04',3310503433,1),(52167496,426328810,15057552,435967,1,'2007-09-15 21:37:04',3310503433,1),(52167500,426328577,15059793,435967,1,'2007-09-15 21:37:04',3310503433,1),(52167503,426328297,15062780,435967,1,'2007-09-15 21:37:04',3310503433,1),(52167507,426328390,15066421,435967,1,'2007-09-15 21:37:05',3310503433,1),(52167511,426329137,15070389,435967,1,'2007-09-15 21:37:05',3310503433,1),(52167513,426329837,15073003,435967,1,'2007-09-15 21:37:05',3310503433,1),(52167517,426330211,15074496,435967,1,'2007-09-15 21:37:05',3310503433,1),(52167521,426329604,15076410,435967,1,'2007-09-15 21:37:06',3310503433,1),(52167525,426329511,15078837,435967,1,'2007-09-15 21:37:06',3310503433,1),(52167528,426329184,15080658,435967,1,'2007-09-15 21:37:06',3310503433,1),(52167530,426328530,15081871,435967,1,'2007-09-15 21:37:07',3310503433,1),(52167534,426327597,15082851,435967,1,'2007-09-15 21:37:07',3310503433,1),(52167535,426327177,15084345,435967,1,'2007-09-15 21:37:07',3310503433,1),(52167538,426326757,15086259,435967,1,'2007-09-15 21:37:07',3310503433,1),(52167540,426326290,15087846,435967,1,'2007-09-15 21:37:07',3310503433,1),(52167544,426326243,15090553,435967,1,'2007-09-15 21:37:07',3310503433,1),(52167547,426325636,15092093,435967,1,'2007-09-15 21:37:07',3310503433,1),(52167551,426325076,15093260,435967,1,'2007-09-15 21:37:07',3310503433,1),(52167557,426325076,15094707,435967,1,'2007-09-15 21:37:08',3310503433,1),(52167562,426324236,15095921,435967,1,'2007-09-15 21:37:08',3310503433,1),(52167568,426323116,15098068,435967,1,'2007-09-15 21:37:08',3310503433,1),(52167574,426322416,15101616,435967,1,'2007-09-15 21:37:09',3310503433,1),(52167579,426321669,15104556,435967,1,'2007-09-15 21:37:09',3310503433,1),(52167581,426320404,15107374,435967,1,'2007-09-15 21:37:09',3310503435,1),(52167585,426318081,15112579,435967,1,'2007-09-15 21:37:09',3310503435,1),(52167590,426316877,15115031,435967,1,'2007-09-15 21:37:10',3310503435,1),(52167593,426315973,15117999,435967,1,'2007-09-15 21:37:10',3310503435,1),(52167599,426314382,15124194,435967,1,'2007-09-15 21:37:10',3310503435,1),(52167604,426314167,15126990,435967,1,'2007-09-15 21:37:10',3310503435,1),(52167607,426314210,15130173,435967,1,'2007-09-15 21:37:10',3310503435,1),(52167614,426313995,15133056,435967,1,'2007-09-15 21:37:11',3310503435,1),(52167615,426313779,15137271,435967,1,'2007-09-15 21:37:11',3310503435,1),(52167619,426313693,15142261,435967,1,'2007-09-15 21:37:11',3310503435,1),(52167622,426313392,15146090,435967,1,'2007-09-15 21:37:11',3310503435,1),(52167627,426312962,15147897,435967,1,'2007-09-15 21:37:12',3310503435,1),(52167632,426312231,15152069,435967,1,'2007-09-15 21:37:12',3310503435,1),(52167636,426310897,15157188,435967,1,'2007-09-15 21:37:12',3310503435,1),(52167641,426310424,15159726,435967,1,'2007-09-15 21:37:12',3310503435,1),(52167645,426309994,15162351,435967,1,'2007-09-15 21:37:12',3310503457,1),(52167650,426308574,15166566,435967,1,'2007-09-15 21:37:12',3310503457,1),(52167655,426305821,15170739,435967,1,'2007-09-15 21:37:13',3310503457,1),(52167660,426304445,15172460,435967,1,'2007-09-15 21:37:13',3310503457,1),(52167664,426303756,15173621,435967,1,'2007-09-15 21:37:13',3310503457,1),(52167666,426303842,15175772,435967,1,'2007-09-15 21:37:13',3310503457,1),(52167669,426303885,15177622,435967,1,'2007-09-15 21:37:13',3310503457,1),(52167673,426303670,15180289,435967,1,'2007-09-15 21:37:14',3310503457,1),(52167677,426303068,15183687,435967,1,'2007-09-15 21:37:14',3310503456,1),(52167683,426302294,15187129,435967,1,'2007-09-15 21:37:14',3310503456,1),(52167687,426301562,15189064,435967,1,'2007-09-15 21:37:14',3310503456,1),(52167691,426300917,15190828,435967,1,'2007-09-15 21:37:15',3310503456,1),(52167695,426300229,15191818,435967,1,'2007-09-15 21:37:15',3310503456,1),(52167700,426299756,15193065,435967,1,'2007-09-15 21:37:15',3310503456,1),(52167702,426299067,15193409,435967,1,'2007-09-15 21:37:15',3310503456,1),(52167707,426298379,15194485,435967,1,'2007-09-15 21:37:16',3310503456,1),(52167710,426297605,15195990,435967,1,'2007-09-15 21:37:16',3310503456,1),(52167713,426296185,15196377,435967,1,'2007-09-15 21:37:16',3310503456,1),(52167714,426294766,15197453,435967,1,'2007-09-15 21:37:16',3310503456,1),(52167718,426294163,15198356,435967,1,'2007-09-15 21:37:17',3310503456,1),(52167721,426293303,15200249,435967,1,'2007-09-15 21:37:17',3310503456,1),(52167725,426293518,15202099,435967,1,'2007-09-15 21:37:17',3310503456,1),(52167727,426293733,15204121,435967,1,'2007-09-15 21:37:17',3310503456,1),(52167732,426293217,15206616,435967,1,'2007-09-15 21:37:18',3310503456,1),(52167736,426292443,15208724,435967,1,'2007-09-15 21:37:18',3310503456,1),(52167740,426291496,15210100,435967,1,'2007-09-15 21:37:18',3310503456,1),(52167744,426290120,15211219,435967,1,'2007-09-15 21:37:18',3310503456,1),(52167747,426288958,15212165,435967,1,'2007-09-15 21:37:19',3310503456,1),(52167752,426288270,15213455,435967,1,'2007-09-15 21:37:19',3310503456,1),(52167756,426287410,15215649,435967,1,'2007-09-15 21:37:19',3310503456,1),(52167758,426286807,15217886,435967,1,'2007-09-15 21:37:19',3310503458,1),(52167761,426286033,15219306,435967,1,'2007-09-15 21:37:20',3310503458,1),(52167765,426284743,15220381,435967,1,'2007-09-15 21:37:20',3310503458,1),(52167769,426282936,15221973,435967,1,'2007-09-15 21:37:20',3310503458,1),(52167773,426280484,15224038,435967,1,'2007-09-15 21:37:21',3310503458,1),(52167777,426278376,15226146,435967,1,'2007-09-15 21:37:21',3310503458,1),(52167781,426277817,15227436,435967,1,'2007-09-15 21:37:21',3310503458,1),(52167784,426276913,15228770,435967,1,'2007-09-15 21:37:21',3310503458,1),(52167787,426275451,15230103,435967,1,'2007-09-15 21:37:21',3310502775,1),(52167790,426273988,15231222,435967,1,'2007-09-15 21:37:22',3310502775,1),(52167795,426272440,15231996,435967,1,'2007-09-15 21:37:22',3310502775,1),(52167796,426271235,15231824,435967,1,'2007-09-15 21:37:22',3310502775,1),(52167799,426269772,15231179,435967,1,'2007-09-15 21:37:22',3310502775,1),(52167802,426268783,15231007,435967,1,'2007-09-15 21:37:23',3310502775,1),(52167805,426267794,15230706,435967,1,'2007-09-15 21:37:23',3310502775,1),(52167807,426266073,15229329,435967,1,'2007-09-15 21:37:23',3310502775,1),(52167811,426265256,15229587,435967,1,'2007-09-15 21:37:24',3310502775,1),(52167812,426264739,15229802,435967,1,'2007-09-15 21:37:24',3310502775,1),(52167815,426264051,15230275,435967,1,'2007-09-15 21:37:24',3310502775,1),(52167820,426263449,15230404,435967,1,'2007-09-15 21:37:25',3310502775,1),(52167825,426261986,15229845,435967,1,'2007-09-15 21:37:25',3310502775,1),(52167828,426261513,15229888,435967,1,'2007-09-15 21:37:26',3310502775,1),(52167834,426260868,15230017,435967,1,'2007-09-15 21:37:26',3310502775,1),(52167836,426260567,15231308,435967,1,'2007-09-15 21:37:27',3310502775,1),(52167839,426260093,15231996,435967,1,'2007-09-15 21:37:27',3310502775,1),(52167843,426259276,15233889,435967,1,'2007-09-15 21:37:27',3310502775,1),(52167847,426258416,15235265,435967,1,'2007-09-15 21:37:27',3310502775,1),(52167849,426256652,15237287,435967,1,'2007-09-15 21:37:28',3310502775,1),(52167853,426253383,15239180,435967,1,'2007-09-15 21:37:28',3310502775,1),(52167859,426247661,15244428,435967,1,'2007-09-15 21:37:28',3310502774,1),(52167860,426244994,15246794,435967,1,'2007-09-15 21:37:29',3310502774,1),(52167867,426243446,15248042,435967,1,'2007-09-15 21:37:29',3310502774,1),(52167872,426241897,15248472,435967,1,'2007-09-15 21:37:30',3310502774,1),(52167883,426240736,15248515,435967,1,'2007-09-15 21:37:32',3310502774,1),(52167887,426239015,15248214,435967,1,'2007-09-15 21:37:32',3310502774,1),(52167891,426237208,15247740,435967,1,'2007-09-15 21:37:32',3310502774,1),(52167896,426236219,15246665,435967,1,'2007-09-15 21:37:33',3310502774,1),(52167900,426235315,15245547,435967,1,'2007-09-15 21:37:33',3310502774,1),(52167906,426234498,15245245,435967,1,'2007-09-15 21:37:33',3310502774,1),(52167911,426233681,15245633,435967,1,'2007-09-15 21:37:34',3310502774,1),(52167916,426233423,15246622,435967,1,'2007-09-15 21:37:34',3310502774,1),(52167922,426233250,15247353,435967,1,'2007-09-15 21:37:34',3310502774,1),(52167924,426232433,15249289,435967,1,'2007-09-15 21:37:35',3310502774,1),(52167927,426231014,15250881,435967,1,'2007-09-15 21:37:35',3310502774,1),(52167930,426230368,15251096,435967,1,'2007-09-15 21:37:35',3310502774,1),(52167932,426229035,15252042,435967,1,'2007-09-15 21:37:35',3310502774,1),(52167937,426228217,15253247,435967,1,'2007-09-15 21:37:35',3310502774,1),(52167944,426226411,15254967,435967,1,'2007-09-15 21:37:36',3310502774,1),(52167948,426225292,15256430,435967,1,'2007-09-15 21:37:36',3310502774,1),(52167953,426224002,15257161,435967,1,'2007-09-15 21:37:36',3310502774,1),(52167958,426223098,15258366,435967,1,'2007-09-15 21:37:37',3310502774,1),(52167963,426221636,15259484,435967,1,'2007-09-15 21:37:37',3310502774,1),(52167967,426220990,15261377,435967,1,'2007-09-15 21:37:37',3310502771,1),(52167969,426219743,15263958,435967,1,'2007-09-15 21:37:37',3310502771,1),(52167970,426218323,15267916,435967,1,'2007-09-15 21:37:37',3310502771,1),(52167973,426217764,15268776,435967,1,'2007-09-15 21:37:38',3310502771,1),(52167977,426216861,15269981,435967,1,'2007-09-15 21:37:38',3310502771,1),(52167981,426216172,15270755,435967,1,'2007-09-15 21:37:38',3310502771,1),(52167986,426215312,15272175,435967,1,'2007-09-15 21:37:39',3310502777,1),(52167991,426214753,15274153,435967,1,'2007-09-15 21:37:39',3310502777,1),(52167995,426213979,15275530,435967,1,'2007-09-15 21:37:40',3310502777,1),(52168000,426213893,15277552,435967,1,'2007-09-15 21:37:40',3310502777,1),(52168004,426213720,15279961,435967,1,'2007-09-15 21:37:40',3310502777,1),(52168009,426213247,15281337,435967,1,'2007-09-15 21:37:40',3310502777,1),(52168013,426212602,15283359,435967,1,'2007-09-15 21:37:40',3310502777,1),(52168015,426211570,15285252,435967,1,'2007-09-15 21:37:41',3310502777,1),(52168018,426211225,15288392,435967,1,'2007-09-15 21:37:41',3310502777,1),(52168021,426211053,15289941,435967,1,'2007-09-15 21:37:41',3310502777,1),(52168025,426211139,15292307,435967,1,'2007-09-15 21:37:41',3310502777,1),(52168028,426211268,15294845,435967,1,'2007-09-15 21:37:41',3310502777,1),(52168033,426211268,15297426,435967,1,'2007-09-15 21:37:42',3310502777,1),(52168034,426211354,15301082,435967,1,'2007-09-15 21:37:42',3310502777,1),(52168038,426210451,15306890,435967,1,'2007-09-15 21:37:42',3310502777,1),(52168039,426210236,15310073,435967,1,'2007-09-15 21:37:42',3310502777,1),(52168043,426210064,15311880,435967,1,'2007-09-15 21:37:43',3310502777,1),(52168046,426210322,15313557,435967,1,'2007-09-15 21:37:43',3310502777,1),(52168049,426210881,15315751,435967,1,'2007-09-15 21:37:44',3310502777,1),(52168053,426211010,15316870,435967,1,'2007-09-15 21:37:44',3310502777,1),(52168055,426210924,15318720,435967,1,'2007-09-15 21:37:44',3310502777,1),(52168056,426210365,15320870,435967,1,'2007-09-15 21:37:44',3310502777,1),(52168060,426209677,15322849,435967,1,'2007-09-15 21:37:44',3310502777,1),(52168063,426208687,15325947,435967,1,'2007-09-15 21:37:45',3310502777,1),(52168065,426207612,15328226,435967,1,'2007-09-15 21:37:45',3310502779,1),(52168070,426206537,15329689,435967,1,'2007-09-15 21:37:45',3310502779,1),(52168071,426204988,15331324,435967,1,'2007-09-15 21:37:45',3310502779,1),(52168073,426204558,15332227,435967,1,'2007-09-15 21:37:45',3310502779,1),(52168077,426202665,15337690,435967,1,'2007-09-15 21:37:46',3310502779,1),(52168080,426200416,15340547,435967,1,'2007-09-15 21:37:46',3310502779,1),(52168084,426199310,15342700,435967,1,'2007-09-15 21:37:46',3310502779,1),(52168086,426198088,15344679,435967,1,'2007-09-15 21:37:46',3310502779,1),(52168090,426194772,15349275,435967,1,'2007-09-15 21:37:46',3310502779,1),(52168094,426191979,15352767,435967,1,'2007-09-15 21:37:47',3310502778,1),(52168096,426188895,15358178,435967,1,'2007-09-15 21:37:47',3310502778,1),(52168100,426187906,15359225,435967,1,'2007-09-15 21:37:47',3310502778,1),(52168101,426185695,15358760,435967,1,'2007-09-15 21:37:47',3310502778,1),(52168104,426184473,15359109,435967,1,'2007-09-15 21:37:48',3310502778,1),(52168108,426182902,15361145,435967,1,'2007-09-15 21:37:48',3310502778,1),(52168111,426178829,15366382,435967,1,'2007-09-15 21:37:48',3310502778,1),(52168115,426176618,15370921,435967,1,'2007-09-15 21:37:48',3310502778,1),(52168118,426175221,15373423,435967,1,'2007-09-15 21:37:49',3310502778,1),(52168121,426173708,15375866,435967,1,'2007-09-15 21:37:49',3310502778,1),(52168124,426171032,15380696,435967,1,'2007-09-15 21:37:49',3310502778,1),(52168127,426168879,15382209,435967,1,'2007-09-15 21:37:49',3310502864,1),(52168130,426166551,15382150,435967,1,'2007-09-15 21:37:50',3310502864,1),(52168135,426161664,15381336,435967,1,'2007-09-15 21:37:50',3310502853,1),(52168138,426158173,15380987,435967,1,'2007-09-15 21:37:50',3310502767,1),(52168143,426154682,15381394,435967,1,'2007-09-15 21:37:51',3310502853,1),(52168146,426148339,15381510,435967,1,'2007-09-15 21:37:51',3310502853,1),(52168149,426146536,15381452,435967,1,'2007-09-15 21:37:51',3310502853,1),(52168152,426144383,15380987,435967,1,'2007-09-15 21:37:51',3310502767,1),(52168156,426141590,15379707,435967,1,'2007-09-15 21:37:51',3310502767,1),(52168160,426135655,15377496,435967,1,'2007-09-15 21:37:52',3310502766,1),(52168163,426133171,15376614,435967,1,'2007-09-15 21:37:52',3310502766,1),(52168167,426132027,15376406,435967,1,'2007-09-15 21:37:52',3310502766,1),(52168171,426130468,15376926,435967,1,'2007-09-15 21:37:53',3310502766,1),(52168175,426128752,15377862,435967,1,'2007-09-15 21:37:53',3310502766,1),(52168178,426126360,15379474,435967,1,'2007-09-15 21:37:53',3310502766,1),(52168181,426123969,15380825,435967,1,'2007-09-15 21:37:53',3310502766,1),(52168186,426121265,15382229,435967,1,'2007-09-15 21:37:54',3310502852,1),(52168188,426117626,15384829,435967,1,'2007-09-15 21:37:54',3310502852,1),(52168191,426115234,15387324,435967,1,'2007-09-15 21:37:54',3310502852,1),(52168195,426113414,15388104,435967,1,'2007-09-15 21:37:55',3310502852,1),(52168198,426110711,15387116,435967,1,'2007-09-15 21:37:55',3310502849,1),(52168203,426109151,15386232,435967,1,'2007-09-15 21:37:56',3310502849,1),(52168207,426104004,15383373,435967,1,'2007-09-15 21:37:56',3310502849,1),(52168214,426101560,15382437,435967,1,'2007-09-15 21:37:57',3310502849,1),(52168217,426100001,15381553,435967,1,'2007-09-15 21:37:57',3310502849,1),(52168220,426097349,15381345,435967,1,'2007-09-15 21:37:57',3310502849,1),(52168225,426095997,15381137,435967,1,'2007-09-15 21:37:57',3310502849,1),(52168228,426085438,15373516,206510,1,'2008-12-06 19:38:08',3310502763,4),(52168231,426093922,15380702,435967,1,'2007-09-15 21:37:58',3310502763,1),(52168235,426092922,15379288,435967,1,'2007-09-15 21:37:58',3310502763,1),(52168237,426091749,15377082,435967,1,'2007-09-15 21:37:59',3310502763,1),(52168240,426090853,15375841,435967,1,'2007-09-15 21:37:59',3310502763,1),(52168243,426089026,15374565,435967,1,'2007-09-15 21:37:59',3310502763,1),(52168247,426087440,15373358,435967,1,'2007-09-15 21:38:00',3310502763,1),(52168248,426085819,15371565,435967,1,'2007-09-15 21:38:00',3310502763,1),(52168249,426084750,15370290,435967,1,'2007-09-15 21:38:00',3310502763,1),(52168251,426083992,15368393,435967,1,'2007-09-15 21:38:00',3310502763,1),(52168254,426083164,15366704,435967,1,'2007-09-15 21:38:00',3310502762,1),(52168256,426081958,15365531,435967,1,'2007-09-15 21:38:00',3310502762,1),(52168258,426080406,15365911,435967,1,'2007-09-15 21:38:01',3310502762,1),(52168261,426078855,15366256,435967,1,'2007-09-15 21:38:01',3310502762,1),(52168265,426077234,15366807,435967,1,'2007-09-15 21:38:01',3310502762,1),(52168270,426074717,15367049,435967,1,'2007-09-15 21:38:02',3310502762,1),(52168274,426073545,15367428,435967,1,'2007-09-15 21:38:02',3310502762,1),(52168278,426071855,15368910,435967,1,'2007-09-15 21:38:02',3310502762,1),(52168283,426069736,15370321,435967,1,'2007-09-15 21:38:03',3310502762,1),(52168286,426067806,15371036,435967,1,'2007-09-15 21:38:03',3310502762,1),(52168287,426066447,15370893,435967,1,'2007-09-15 21:38:03',3310502762,1),(52168291,426065160,15370250,435967,1,'2007-09-15 21:38:03',3310502762,1),(52168296,426064160,15368748,435967,1,'2007-09-15 21:38:04',3310502762,1),(52168298,426062515,15367032,435967,1,'2007-09-15 21:38:04',3310502762,1),(52168302,426061014,15364959,435967,1,'2007-09-15 21:38:04',3310502762,1),(52168305,426058583,15362814,435967,1,'2007-09-15 21:38:04',3310502762,1),(52168308,426055866,15360741,435967,1,'2007-09-15 21:38:05',3310502719,1),(52168309,426054150,15358811,435967,1,'2007-09-15 21:38:05',3310502719,1),(52168314,426053006,15356809,435967,1,'2007-09-15 21:38:05',3310502719,1),(52168316,426051722,15355729,435967,1,'2007-09-15 21:38:05',3310502719,1),(52168318,426050257,15354411,435967,1,'2007-09-15 21:38:05',3310502719,1),(52168321,426048759,15353361,435967,1,'2007-09-15 21:38:06',3310502719,1),(52168325,426046573,15353179,435967,1,'2007-09-15 21:38:06',3310502719,1),(52168326,426044326,15354333,435967,1,'2007-09-15 21:38:06',3310502719,1),(52168329,426041958,15355122,435967,1,'2007-09-15 21:38:06',3310502719,1),(52168333,426039468,15355972,435967,1,'2007-09-15 21:38:06',3310502719,1),(52168336,426037403,15356154,435967,1,'2007-09-15 21:38:07',3310502719,1),(52168338,426035035,15355304,435967,1,'2007-09-15 21:38:07',3310502719,1),(52168342,426032606,15353726,435967,1,'2007-09-15 21:38:07',3310502719,1),(52168346,426028598,15349414,435967,1,'2007-09-15 21:38:08',3310502718,1),(52168347,426025027,15344952,435967,1,'2007-09-15 21:38:08',3310502718,1),(52168348,426022953,15343175,435967,1,'2007-09-15 21:38:08',3310502718,1),(52168350,426021546,15342805,435967,1,'2007-09-15 21:38:08',3310502718,1),(52168356,426019176,15343249,435967,1,'2007-09-15 21:38:08',3310502718,1),(52168360,426016525,15342849,435967,1,'2007-09-15 21:38:09',3310502718,1),(52168362,426014575,15342094,435967,1,'2007-09-15 21:38:09',3310502718,1),(52168414,426013128,15340898,435967,1,'2007-09-15 21:38:14',3310502718,1),(52168416,426011178,15337816,435967,1,'2007-09-15 21:38:14',3310502718,1),(52168419,426009605,15335803,435967,1,'2007-09-15 21:38:14',3310502718,1),(52168423,426007403,15334230,435967,1,'2007-09-15 21:38:14',3310502718,1),(52168427,426006082,15332595,435967,1,'2007-09-15 21:38:15',3310502718,1),(52168429,426005579,15330456,435967,1,'2007-09-15 21:38:15',3310502718,1),(52168432,426004887,15326682,435967,1,'2007-09-15 21:38:16',3310502718,1),(52168436,426001679,15322844,435967,1,'2007-09-15 21:38:16',3310502716,1),(52168440,426000106,15320706,435967,1,'2007-09-15 21:38:16',3310502713,1),(52168442,425998533,15319196,435967,1,'2007-09-15 21:38:16',3310502713,1),(52168445,425997527,15318693,435967,1,'2007-09-15 21:38:16',3310502713,1),(52168447,425995703,15319322,435967,1,'2007-09-15 21:38:16',3310502713,1),(52168452,425994445,15319070,435967,1,'2007-09-15 21:38:17',3310502713,1),(52168455,425993816,15318378,435967,1,'2007-09-15 21:38:17',3310502713,1),(52168459,425993375,15316742,435967,1,'2007-09-15 21:38:17',3310502713,1),(52168461,425992494,15314855,435967,1,'2007-09-15 21:38:17',3310502713,1),(52168464,425991111,15313283,435967,1,'2007-09-15 21:38:17',3310502713,1),(52168468,425988594,15311333,435967,1,'2007-09-15 21:38:18',3310502713,1),(52168470,425985197,15309886,435967,1,'2007-09-15 21:38:18',3310502713,1),(52168474,425981863,15308628,435967,1,'2007-09-15 21:38:18',3310502713,1),(52168476,425979284,15306992,435967,1,'2007-09-15 21:38:18',3310502713,1),(52168479,425977586,15305042,435967,1,'2007-09-15 21:38:19',3310502713,1),(52168481,425972553,15297367,435967,1,'2007-09-15 21:38:19',3310502712,1),(52168484,425968968,15288749,435967,1,'2007-09-15 21:38:19',3310502712,1),(52168486,425967835,15286170,435967,1,'2007-09-15 21:38:19',3310502712,1),(52168489,425966577,15284723,435967,1,'2007-09-15 21:38:19',3310502712,1),(52168492,425964879,15283402,435967,1,'2007-09-15 21:38:19',3310502712,1),(52168495,425963117,15283088,435967,1,'2007-09-15 21:38:19',3310502712,1),(52168497,425961167,15282773,435967,1,'2007-09-15 21:38:20',3310502712,1),(52168502,425958588,15282773,435967,1,'2007-09-15 21:38:20',3310502712,1),(52168506,425957078,15282396,435967,1,'2007-09-15 21:38:20',3310502712,1),(52168509,425955757,15281955,435967,1,'2007-09-15 21:38:20',3310502712,1),(52168512,425953996,15281138,435967,1,'2007-09-15 21:38:20',3310502712,1),(52168516,425953052,15280194,435967,1,'2007-09-15 21:38:21',3310502712,1),(52168519,425952738,15278810,435967,1,'2007-09-15 21:38:21',3310502712,1),(52168521,425951668,15277175,435967,1,'2007-09-15 21:38:21',3310502712,1),(52168523,425950033,15275854,435967,1,'2007-09-15 21:38:21',3310502712,1),(52168529,425948272,15275413,435967,1,'2007-09-15 21:38:21',3310502712,1),(52168531,425944812,15273652,435967,1,'2007-09-15 21:38:21',3310502701,1),(52168534,425943176,15272771,435967,1,'2007-09-15 21:38:22',3310502701,1),(52168537,425940786,15272520,435967,1,'2007-09-15 21:38:22',3310502701,1),(52168541,425938521,15272268,435967,1,'2007-09-15 21:38:22',3310502701,1),(52168543,425936131,15270947,435967,1,'2007-09-15 21:38:22',3310502695,1),(52168547,425933614,15268682,435967,1,'2007-09-15 21:38:22',3310502695,1),(52168549,425931035,15267172,435967,1,'2007-09-15 21:38:22',3310502695,1),(52168553,425928330,15266481,435967,1,'2007-09-15 21:38:23',3310502695,1),(52168555,425926129,15266229,435967,1,'2007-09-15 21:38:23',3310502695,1),(52168558,425924304,15266984,435967,1,'2007-09-15 21:38:23',3310502695,1),(52168561,425922228,15268745,435967,1,'2007-09-15 21:38:23',3310502695,1),(52168565,425920782,15270003,435967,1,'2007-09-15 21:38:23',3310502695,1),(52168568,425919586,15269060,435967,1,'2007-09-15 21:38:24',3310502695,1),(52168569,425917699,15266669,435967,1,'2007-09-15 21:38:24',3310502694,1),(52168572,425915686,15264090,435967,1,'2007-09-15 21:38:24',3310502694,1),(52168576,425913799,15262077,435967,1,'2007-09-15 21:38:24',3310502694,1),(52168579,425912510,15259992,435967,1,'2007-09-15 21:38:24',3310502694,1),(52168582,425911461,15257943,435967,1,'2007-09-15 21:38:25',3310502694,1),(52168586,425910413,15255370,435967,1,'2007-09-15 21:38:25',3310502694,1),(52168589,425908793,15252177,435967,1,'2007-09-15 21:38:25',3310502694,1),(52168592,425907507,15250986,435967,1,'2007-09-15 21:38:25',3310502694,1),(52168595,425906125,15249699,435967,1,'2007-09-15 21:38:25',3310502694,1),(52168596,425903074,15248155,435967,1,'2007-09-15 21:38:25',3310502694,1),(52168600,425898160,15245335,435967,1,'2007-09-15 21:38:26',3310502694,1),(52168604,425895904,15243885,435967,1,'2007-09-15 21:38:26',3310502694,1),(52168607,425893729,15243160,435967,1,'2007-09-15 21:38:26',3310502694,1),(52168612,425890507,15242193,435967,1,'2007-09-15 21:38:27',3310502691,1),(52168613,425888251,15241468,435967,1,'2007-09-15 21:38:27',3310502691,1),(52168616,425886801,15240502,435967,1,'2007-09-15 21:38:27',3310502691,1),(52168622,425885512,15238488,435967,1,'2007-09-15 21:38:27',3310502691,1),(52168626,425884464,15237199,435967,1,'2007-09-15 21:38:27',3310502691,1),(52168631,425883739,15235990,435967,1,'2007-09-15 21:38:28',3310502691,1),(52168635,425882853,15234782,435967,1,'2007-09-15 21:38:28',3310502691,1),(52168638,425880839,15234298,435967,1,'2007-09-15 21:38:28',3310502691,1),(52168640,425878986,15233654,435967,1,'2007-09-15 21:38:28',3310502691,1),(52168644,425877617,15232929,435967,1,'2007-09-15 21:38:28',3310502691,1),(52168648,425876569,15231317,435967,1,'2007-09-15 21:38:29',3310502691,1),(52168654,425875039,15230028,435967,1,'2007-09-15 21:38:29',3310502691,1),(52168657,425871091,15229384,435967,1,'2007-09-15 21:38:29',3310502691,1),(52168660,425865049,15228739,435967,1,'2007-09-15 21:38:30',3310502691,1),(52168663,425863518,15228337,435967,1,'2007-09-15 21:38:30',3310502690,1),(52168665,425862874,15227209,435967,1,'2007-09-15 21:38:30',3310502690,1),(52168668,425861262,15224067,435967,1,'2007-09-15 21:38:30',3310502690,1),(52168671,425859329,15222375,435967,1,'2007-09-15 21:38:30',3310502690,1),(52168674,425857234,15220522,435967,1,'2007-09-15 21:38:30',3310502690,1),(52168676,425854495,15219797,435967,1,'2007-09-15 21:38:31',3310502690,1),(52168679,425851937,15218315,435967,1,'2007-09-15 21:38:31',3310502690,1),(52168682,425848482,15216923,435967,1,'2007-09-15 21:38:31',3310502690,1),(52168686,425844512,15214293,435967,1,'2007-09-15 21:38:31',3310502688,1),(52168687,425841728,15212591,435967,1,'2007-09-15 21:38:32',3310502688,1),(52168690,425840026,15211767,435967,1,'2007-09-15 21:38:32',3310502688,1),(52168693,425838170,15210942,435967,1,'2007-09-15 21:38:32',3310502688,1),(52168695,425836004,15210632,435967,1,'2007-09-15 21:38:32',3310502517,1),(52168698,425833633,15210632,435967,1,'2007-09-15 21:38:33',3310502517,1),(52168700,425831313,15210581,435967,1,'2007-09-15 21:38:33',3310502517,1),(52168702,425828631,15209653,435967,1,'2007-09-15 21:38:33',3310502517,1),(52168703,425826981,15208518,435967,1,'2007-09-15 21:38:33',3310502517,1),(52168705,425825538,15207023,435967,1,'2007-09-15 21:38:33',3310502517,1),(52168708,425823408,15206122,19873,1,'2008-06-02 18:30:23',3310502517,2),(52168710,425821386,15205092,19873,1,'2008-06-02 18:30:23',3310502517,2),(52168712,425819490,15204062,19873,1,'2008-06-02 18:30:23',3310502517,2),(52168714,425816309,15203104,435967,1,'2007-09-15 21:38:34',3310502517,1),(52168717,425814762,15202950,435967,1,'2007-09-15 21:38:34',3310502517,1),(52168720,425812545,15202898,435967,1,'2007-09-15 21:38:35',3310502517,1),(52168722,425810792,15202640,435967,1,'2007-09-15 21:38:35',3310502517,1),(52168725,425808575,15201455,435967,1,'2007-09-15 21:38:35',3310502516,1),(52168727,425805790,15199392,435967,1,'2007-09-15 21:38:35',3310502516,1),(52168729,425802748,15196608,435967,1,'2007-09-15 21:38:36',3310502516,1),(52168732,425800634,15194906,435967,1,'2007-09-15 21:38:36',3310502516,1),(52168734,425798056,15193721,435967,1,'2007-09-15 21:38:36',3310502516,1),(52168736,425795736,15192792,435967,1,'2007-09-15 21:38:36',3310502516,1),(52168739,425793261,15192689,435967,1,'2007-09-15 21:38:36',3310502516,1),(52168741,425791818,15193205,435967,1,'2007-09-15 21:38:36',3310502516,1),(52168744,425789652,15193927,435967,1,'2007-09-15 21:38:36',3310502516,1),(52168745,425786765,15193617,435967,1,'2007-09-15 21:38:37',3310502516,1),(52168747,425784702,15191864,435967,1,'2007-09-15 21:38:37',3310502516,1),(52168750,425783568,15190421,435967,1,'2007-09-15 21:38:37',3310502516,1),(52168770,425782640,15188668,435967,1,'2007-09-15 21:38:39',3310502516,1),(52168772,425781299,15185316,435967,1,'2007-09-15 21:38:39',3310502513,1),(52168773,425780113,15182532,435967,1,'2007-09-15 21:38:39',3310502513,1),(52168774,425779154,15180712,498434,1,'2008-05-22 17:13:55',3310502513,2),(52168777,425777587,15179129,435967,1,'2007-09-15 21:38:40',3310502513,1),(52168779,425775267,15176706,435967,1,'2007-09-15 21:38:40',3310502513,1),(52168782,425773978,15175881,435967,1,'2007-09-15 21:38:40',3310502513,1),(52168786,425771142,15176448,435967,1,'2007-09-15 21:38:40',3310502513,1),(52168788,425770369,15177582,435967,1,'2007-09-15 21:38:41',3310502513,1),(52168789,425768873,15181243,435967,1,'2007-09-15 21:38:41',3310502513,1),(52168790,425768461,15183305,435967,1,'2007-09-15 21:38:41',3310502513,1),(52168794,425767327,15184749,435967,1,'2007-09-15 21:38:41',3310502513,1),(52168796,425765780,15186915,435967,1,'2007-09-15 21:38:41',3310502513,1),(52168799,425763717,15187894,435967,1,'2007-09-15 21:38:41',3310502513,1),(52168802,425761810,15188410,435967,1,'2007-09-15 21:38:42',3310502513,1),(52168805,425759541,15187894,435967,1,'2007-09-15 21:38:42',3310502513,1),(52168808,425757736,15186657,435967,1,'2007-09-15 21:38:42',3310502513,1),(52168810,425755004,15184749,435967,1,'2007-09-15 21:38:42',3310502513,1),(52168813,425752735,15183099,435967,1,'2007-09-15 21:38:43',3310502512,1),(52168816,425751188,15182223,435967,1,'2007-09-15 21:38:43',3310502512,1),(52168819,425749487,15182223,435967,1,'2007-09-15 21:38:43',3310502512,1),(52168821,425747837,15182635,435967,1,'2007-09-15 21:38:43',3310502512,1),(52168824,425746135,15183821,435967,1,'2007-09-15 21:38:44',3310502512,1),(52168828,425743300,15186399,435967,1,'2007-09-15 21:38:44',3310502512,1),(52168829,425742011,15187791,435967,1,'2007-09-15 21:38:44',3310502512,1),(52168830,425739897,15190214,435967,1,'2007-09-15 21:38:44',3310502512,1),(52168834,425737783,15191452,435967,1,'2007-09-15 21:38:44',3310502512,1),(52168836,425735669,15192328,435967,1,'2007-09-15 21:38:45',3310502512,1),(52168838,425731286,15192638,435967,1,'2007-09-15 21:38:45',3310502512,1),(52168842,425729894,15192328,435967,1,'2007-09-15 21:38:45',3310502512,1),(52168845,425728811,15192380,435967,1,'2007-09-15 21:38:45',3310502512,1),(52168846,425727780,15193617,435967,1,'2007-09-15 21:38:45',3310502512,1),(52168849,425727161,15194803,435967,1,'2007-09-15 21:38:45',3310502512,1),(52168851,425725047,15198877,435967,1,'2007-09-15 21:38:46',3310502501,1),(52168854,425723604,15201248,435967,1,'2007-09-15 21:38:46',3310502501,1),(52168856,425722057,15203311,435967,1,'2007-09-15 21:38:46',3310502501,1),(52168858,425720355,15204187,435967,1,'2007-09-15 21:38:46',3310502501,1),(52168859,425718293,15205115,435967,1,'2007-09-15 21:38:46',3310502501,1),(52168862,425716695,15206456,435967,1,'2007-09-15 21:38:46',3310502501,1),(52168865,425715199,15208879,435967,1,'2007-09-15 21:38:47',3310502501,1),(52168866,425713446,15210581,435967,1,'2007-09-15 21:38:47',3310502501,1),(52168867,425710817,15212540,435967,1,'2007-09-15 21:38:47',3310502501,1),(52168870,425708754,15215118,435967,1,'2007-09-15 21:38:47',3310502501,1),(52168873,425707001,15216510,435967,1,'2007-09-15 21:38:47',3310502503,1),(52168875,425705455,15217232,435967,1,'2007-09-15 21:38:47',3310502503,1),(52168878,425703547,15217696,435967,1,'2007-09-15 21:38:47',3310502503,1),(52168881,425700866,15218366,435967,1,'2007-09-15 21:38:48',3310502503,1),(52168883,425699938,15218366,435967,1,'2007-09-15 21:38:48',3310502503,1),(52168886,425696792,15217438,435967,1,'2007-09-15 21:38:49',3310502502,1),(52168889,425694327,15215782,498434,1,'2008-05-22 17:35:14',3310502500,2),(52168892,425692101,15214963,435967,1,'2007-09-15 21:38:49',3310502500,1),(52168895,425690193,15214551,435967,1,'2007-09-15 21:38:49',3310502500,1),(52168899,425689162,15214912,435967,1,'2007-09-15 21:38:49',3310502500,1),(52168901,425687821,15216562,435967,1,'2007-09-15 21:38:50',3310502502,1),(52168904,425685037,15221099,435967,1,'2007-09-15 21:38:50',3310502502,1),(52168905,425683542,15223832,435967,1,'2007-09-15 21:38:50',3310502502,1),(52168909,425681685,15225894,435967,1,'2007-09-15 21:38:51',3310502502,1),(52168912,425679881,15228420,435967,1,'2007-09-15 21:38:51',3310502502,1),(52168914,425678643,15231102,435967,1,'2007-09-15 21:38:51',3310502502,1),(52168917,425678437,15234247,435967,1,'2007-09-15 21:38:51',3310502502,1),(52168919,425678437,15236979,435967,1,'2007-09-15 21:38:52',3310502502,1),(52168920,425678076,15238681,435967,1,'2007-09-15 21:38:52',3310502502,1),(52168921,425677200,15240485,435967,1,'2007-09-15 21:38:52',3310502502,1),(52168924,425675962,15242135,435967,1,'2007-09-15 21:38:52',3310502502,1),(52168926,425673642,15244249,435967,1,'2007-09-15 21:38:52',3310502502,1),(52168929,425671477,15245641,435967,1,'2007-09-15 21:38:52',3310502499,1),(52168931,425669105,15246157,435967,1,'2007-09-15 21:38:53',3310502499,1),(52168933,425665960,15246260,435967,1,'2007-09-15 21:38:53',3310502499,1),(52168936,425663897,15247034,435967,1,'2007-09-15 21:38:53',3310502499,1),(52168939,425661783,15247188,435967,1,'2007-09-15 21:38:53',3310502499,1),(52168943,425660082,15247807,435967,1,'2007-09-15 21:38:54',3310502499,1),(52168945,425658019,15249766,435967,1,'2007-09-15 21:38:54',3310502499,1),(52168946,425656576,15252138,435967,1,'2007-09-15 21:38:54',3310502499,1),(52168948,425655132,15254252,435967,1,'2007-09-15 21:38:54',3310502499,1),(52168952,425653998,15255850,435967,1,'2007-09-15 21:38:54',3310502499,1),(52168955,425653224,15257861,435967,1,'2007-09-15 21:38:55',3310502499,1),(52168959,425652142,15259769,435967,1,'2007-09-15 21:38:55',3310502499,1),(52168961,425650956,15261831,435967,1,'2007-09-15 21:38:55',3310502499,1),(52168964,425649306,15263172,435967,1,'2007-09-15 21:38:55',3310502499,1),(52168965,425647295,15263172,435967,1,'2007-09-15 21:38:56',3310502499,1),(52168967,425644975,15261831,435967,1,'2007-09-15 21:38:56',3310502499,1),(52168969,425642809,15261367,435967,1,'2007-09-15 21:38:56',3310502498,1),(52168972,425640695,15261109,435967,1,'2007-09-15 21:38:56',3310502498,1),(52168974,425639148,15261625,435967,1,'2007-09-15 21:38:56',3310502498,1),(52168976,425638639,15262611,498434,1,'2008-05-22 17:49:21',3310502498,2),(52168981,425638007,15263641,498434,1,'2008-05-22 17:49:21',3310502498,2),(52168984,425637691,15264757,498434,1,'2008-05-22 17:49:21',3310502498,2),(52168987,425637501,15266302,498434,1,'2008-05-22 17:49:21',3310502498,2),(52168989,425636996,15269735,498434,1,'2008-05-22 17:49:21',3310502498,2),(52168992,425634846,15272653,498434,1,'2008-05-22 17:49:21',3310502504,2),(52168995,425632507,15277202,498434,1,'2008-05-22 17:52:10',3310502504,3),(52169000,425631432,15277288,498434,1,'2008-05-22 17:49:21',3310502504,2),(52169003,425629915,15277632,498434,1,'2008-05-22 17:52:10',3310502504,2),(52169006,425627805,15280496,435967,1,'2007-09-15 21:39:00',3310502504,1),(52169008,425626310,15284879,435967,1,'2007-09-15 21:39:01',3310502504,1),(52169011,425624866,15287457,435967,1,'2007-09-15 21:39:01',3310502504,1),(52169014,425623835,15288642,435967,1,'2007-09-15 21:39:01',3310502504,1),(52169016,425622134,15289416,435967,1,'2007-09-15 21:39:01',3310502504,1),(52169018,425619556,15290911,435967,1,'2007-09-15 21:39:02',3310502504,1),(52169021,425616926,15290860,435967,1,'2007-09-15 21:39:02',3310502504,1),(52169022,425615070,15290860,435967,1,'2007-09-15 21:39:02',3310502461,1),(52169024,425613626,15291685,435967,1,'2007-09-15 21:39:02',3310502461,1),(52169028,425612389,15293541,435967,1,'2007-09-15 21:39:03',3310502461,1),(52169032,425610945,15295706,435967,1,'2007-09-15 21:39:03',3310502461,1),(52169034,425609398,15298078,435967,1,'2007-09-15 21:39:04',3310502461,1),(52169036,425607851,15302048,435967,1,'2007-09-15 21:39:04',3310502461,1),(52169041,425606305,15304265,435967,1,'2007-09-15 21:39:04',3310502461,1),(52169044,425604345,15305606,435967,1,'2007-09-15 21:39:05',3310502461,1),(52169045,425600169,15308132,435967,1,'2007-09-15 21:39:05',3310502461,1),(52169048,425593982,15312154,435967,1,'2007-09-15 21:39:05',3310502461,1),(52169052,425590424,15314577,435967,1,'2007-09-15 21:39:06',3310502461,1),(52169054,425588723,15316433,435967,1,'2007-09-15 21:39:06',3310502460,1),(52169055,425586248,15319424,435967,1,'2007-09-15 21:39:06',3310502460,1),(52169058,425584443,15319991,435967,1,'2007-09-15 21:39:06',3310502460,1),(52169060,425582845,15320146,435967,1,'2007-09-15 21:39:06',3310502460,1),(52169061,425581298,15319527,435967,1,'2007-09-15 21:39:07',3310502460,1),(52169064,425579493,15318599,435967,1,'2007-09-15 21:39:07',3310502460,1),(52169067,425577173,15315969,435967,1,'2007-09-15 21:39:07',3310502460,1),(52169070,425574956,15314062,435967,1,'2007-09-15 21:39:07',3310502460,1),(52169073,425573513,15311844,435967,1,'2007-09-15 21:39:07',3310502460,1),(52169075,425572120,15309834,435967,1,'2007-09-15 21:39:07',3310502460,1),(52169076,425570110,15305245,435967,1,'2007-09-15 21:39:08',3310502460,1),(52169078,425567789,15300965,435967,1,'2007-09-15 21:39:08',3310502460,1),(52169080,425565830,15296428,435967,1,'2007-09-15 21:39:08',3310502460,1),(52169083,425563768,15294263,435967,1,'2007-09-15 21:39:08',3310502460,1),(52169088,425560210,15292406,435967,1,'2007-09-15 21:39:09',3310502457,1),(52169089,425557374,15291220,435967,1,'2007-09-15 21:39:09',3310502457,1),(52169092,425554435,15288436,435967,1,'2007-09-15 21:39:09',3310502457,1),(52169094,425552837,15285446,435967,1,'2007-09-15 21:39:10',3310502457,1),(52169097,425550775,15283229,435967,1,'2007-09-15 21:39:10',3310502457,1),(52169100,425547629,15281527,435967,1,'2007-09-15 21:39:11',3310502457,1),(52169103,425544484,15279826,435967,1,'2007-09-15 21:39:11',3310502457,1),(52169105,425540566,15276371,435967,1,'2007-09-15 21:39:11',3310502457,1),(52169109,425539147,15271678,435967,1,'2007-09-15 21:39:12',3310502457,1),(52169111,425537935,15268185,435967,1,'2007-09-15 21:39:12',3310502451,1),(52169113,425536296,15264622,435967,1,'2007-09-15 21:39:12',3310502451,1),(52169115,425533445,15260844,435967,1,'2007-09-15 21:39:13',3310502450,1),(52169117,425529454,15256710,435967,1,'2007-09-15 21:39:13',3310502450,1),(52169119,425526959,15254714,435967,1,'2007-09-15 21:39:13',3310502450,1),(52169121,425525034,15254144,435967,1,'2007-09-15 21:39:14',3310502450,1),(52169123,425523751,15255427,435967,1,'2007-09-15 21:39:14',3310502450,1),(52169124,425521257,15258064,435967,1,'2007-09-15 21:39:14',3310502450,1),(52169125,425519118,15258207,435967,1,'2007-09-15 21:39:14',3310502450,1),(52169126,425516624,15257494,435967,1,'2007-09-15 21:39:15',3310502450,1),(52169127,425513915,15255498,435967,1,'2007-09-15 21:39:15',3310502450,1),(52170031,425273611,15202773,435967,1,'2007-09-15 21:41:21',3310491493,1),(52170032,425269041,15202202,435967,1,'2007-09-15 21:41:21',3310491493,1),(52170036,425271184,15202302,435967,1,'2007-09-15 21:41:21',3310491493,1),(52170040,425264202,15203610,435967,1,'2007-09-15 21:41:21',3310491493,1),(52170042,425265539,15202073,435967,1,'2007-09-15 21:41:22',3310491493,1),(52170044,425267334,15200718,435967,1,'2007-09-15 21:41:22',3310491493,1),(52170048,425268789,15200211,435967,1,'2007-09-15 21:41:23',3310491493,1),(52170056,425272032,15200380,435967,1,'2007-09-15 21:41:23',3310491493,1),(52170061,425275648,15201558,435967,1,'2007-09-15 21:41:24',3310491493,1),(52170065,425278370,15203833,435967,1,'2007-09-15 21:41:24',3310491493,1),(52170071,425281660,15205783,435967,1,'2007-09-15 21:41:25',3310491493,1),(52170076,425284585,15206352,435967,1,'2007-09-15 21:41:25',3310491493,1),(52170080,425288404,15205945,435967,1,'2007-09-15 21:41:26',3310491504,1),(52170088,425291451,15205620,435967,1,'2007-09-15 21:41:27',3310491504,1),(52170090,425291979,15205499,435967,1,'2007-09-15 21:41:27',3310491504,1),(52170096,425293198,15205255,435967,1,'2007-09-15 21:41:27',3310491504,1),(52170099,425295867,15204103,435967,1,'2007-09-15 21:41:28',3310491504,1),(52170371,425498114,15111006,501218,1,'2007-09-23 16:47:41',3310502415,1),(52170374,425502022,15107410,501218,1,'2007-09-23 16:47:41',3310502415,1),(52170377,425504758,15104596,435967,1,'2007-09-15 21:41:57',3310502413,1),(52170378,425507494,15101548,435967,1,'2007-09-15 21:41:57',3310502424,1),(52170381,425509761,15100844,501218,1,'2007-09-23 16:47:41',3310502424,1),(52170384,425512340,15098108,501218,1,'2007-09-23 16:47:41',3310502424,1),(52170386,425514138,15095216,435967,1,'2007-09-15 21:41:58',3310502424,1),(52170388,425515545,15092637,435967,1,'2007-09-15 21:41:58',3310502424,1),(52170391,425516405,15090448,501218,1,'2007-09-23 16:47:41',3310502424,1),(52170394,425519063,15087009,435967,1,'2007-09-15 21:41:59',3310502424,1),(52170397,425521251,15084976,501218,1,'2007-09-23 16:47:41',3310502424,1),(52170400,425522737,15083100,501218,1,'2007-09-23 16:47:41',3310502424,1),(52170401,425523596,15080833,435967,1,'2007-09-15 21:42:00',3310502424,1),(52170406,425523440,15077003,501218,1,'2007-09-23 16:47:41',3310502424,1),(52170410,425523909,15073408,501218,1,'2007-09-23 16:47:41',3310502424,1),(52170411,425526958,15071766,435967,1,'2007-09-15 21:42:01',3310502424,1),(52170415,425528755,15071766,501218,1,'2007-09-23 16:47:41',3310502424,1),(52170416,425531726,15069343,501218,1,'2007-09-23 16:47:41',3310502424,1),(52170417,425533993,15067076,501218,1,'2007-09-23 16:47:41',3310502424,1),(52170418,425535315,15065696,501218,1,'2007-09-23 16:47:41',3310502425,1),(52170423,425536685,15065479,501218,1,'2007-09-23 16:47:41',3310502425,1),(52170440,425537910,15066128,501218,1,'2007-09-23 16:47:41',3310502425,1),(52170441,425539854,15066387,501218,1,'2007-09-23 16:47:41',3310502425,1),(52170496,425540762,15066330,501218,1,'2007-09-23 16:47:41',3310502425,1),(52170512,425542151,15065962,435967,1,'2007-09-15 21:42:22',3310502425,1),(52170525,425544248,15064119,501218,1,'2007-09-23 16:47:41',3310502425,1),(52170533,425545666,15063269,435967,1,'2007-09-15 21:42:26',3310502425,1),(52170540,425546686,15063212,435967,1,'2007-09-15 21:42:27',3310502425,1),(52170544,425547792,15063524,501218,1,'2007-09-23 16:47:41',3310502425,1),(52170561,425549124,15063807,435967,1,'2007-09-15 21:42:31',3310502425,1),(52171046,425550769,15063921,435967,1,'2007-09-15 21:43:52',3310502425,1),(52171050,425553178,15062730,501218,1,'2007-09-23 16:47:41',3310502425,1),(52171054,425554255,15060973,501218,1,'2007-09-23 16:47:41',3310502425,1),(52171057,425554822,15059158,501218,1,'2007-09-23 16:47:41',3310502425,1),(52171060,425555389,15056947,501218,1,'2007-09-23 16:47:41',3310502425,1),(52171070,425556183,15055671,501218,1,'2007-09-23 16:47:41',3310502425,1),(52171073,425557884,15054991,501218,1,'2007-09-23 16:47:41',3310502425,1),(52171075,425559835,15055792,501218,1,'2007-09-23 16:47:41',3310502425,1),(52171078,425561387,15056004,501218,1,'2007-09-23 16:47:41',3310502425,1),(52171081,425564420,15053605,501218,1,'2007-09-23 16:47:41',3310502428,1),(52171084,425565548,15051842,501218,1,'2007-09-23 16:47:41',3310502428,1),(52171088,425568582,15049444,501218,1,'2007-09-23 16:47:41',3310502422,1),(52171092,425571756,15047468,501218,1,'2007-09-23 16:47:41',3310502422,1),(52171100,425576059,15044365,435967,1,'2007-09-15 21:44:00',3310502422,1),(52171107,425577893,15042390,435967,1,'2007-09-15 21:44:01',3310502422,1),(52171112,425579022,15041755,501218,1,'2007-09-23 16:47:41',3310502422,1),(52171114,425580150,15041966,501218,1,'2007-09-23 16:47:41',3310502422,1),(52171118,425581420,15042954,501218,1,'2007-09-23 16:47:41',3310502422,1),(52171120,425582196,15044294,501218,1,'2007-09-23 16:47:41',3310502422,1),(52171121,425583607,15045705,501218,1,'2007-09-23 16:47:41',3310502422,1),(52171125,425584947,15046128,501218,1,'2007-09-23 16:47:41',3310502422,1),(52171127,425586217,15045917,435967,1,'2007-09-15 21:44:04',3310502422,1),(52171129,425588192,15043800,501218,1,'2007-09-23 16:47:41',3310502422,1),(52171131,425591366,15039286,435967,1,'2007-09-15 21:44:05',3310502423,1),(52171136,425593200,15037029,501218,1,'2007-09-23 16:47:41',3310502423,1),(52171140,425596939,15034136,501218,1,'2007-09-23 16:47:41',3310502423,1),(52171146,425599266,15031667,435967,1,'2007-09-15 21:44:07',3310502423,1),(52171151,425602864,15028211,435967,1,'2007-09-15 21:44:08',3310502423,1),(52171156,425604910,15025248,501218,1,'2007-09-23 16:47:41',3310502423,1),(52171165,425606391,15023555,435967,1,'2007-09-15 21:44:10',3310502423,1),(52171167,425608225,15022215,501218,1,'2007-09-23 16:47:41',3310502423,1),(52171173,425610835,15021157,501218,1,'2007-09-23 16:47:41',3310502423,1),(52171179,425611752,15020028,501218,1,'2007-09-23 16:47:41',3310502423,1),(52171184,425612528,15017560,435967,1,'2007-09-15 21:44:10',3310502423,1),(52171188,425612387,15013398,435967,1,'2007-09-15 21:44:10',3310502423,1),(52171247,425613374,15010294,501218,1,'2007-09-23 16:47:41',3310502423,1),(52171251,425614644,15006767,501218,1,'2007-09-23 16:47:41',3310502423,1),(52171256,425616125,15001476,435967,1,'2007-09-15 21:44:17',3310502423,1),(52171259,425616337,14998937,435967,1,'2007-09-15 21:44:17',3310502423,1),(52171263,425615984,14994422,435967,1,'2007-09-15 21:44:17',3310502421,1),(52171280,425615067,14992306,501218,1,'2007-09-23 16:47:41',3310502421,1),(52171284,425613092,14991248,501218,1,'2007-09-23 16:47:41',3310502421,1),(52171289,425612175,14989908,501218,1,'2007-09-23 16:47:41',3310502421,1),(52171295,425612175,14987510,501218,1,'2007-09-23 16:47:41',3310502421,1),(52171297,425612387,14984829,435967,1,'2007-09-15 21:44:21',3310502421,1),(52171300,425612316,14979962,501218,1,'2007-09-23 16:47:41',3310502421,1),(52171305,425611681,14976646,501218,1,'2007-09-23 16:47:41',3310502421,1),(52171307,425610835,14973825,501218,1,'2007-09-23 16:47:41',3310502421,1),(52171311,425611823,14969099,501218,1,'2007-09-23 16:47:41',3310502421,1),(52171317,425613657,14963949,501218,1,'2007-09-23 16:47:41',3310502421,1),(52171321,425615632,14962609,501218,1,'2007-09-23 16:47:41',3310502421,1),(52171324,425618312,14959153,501218,1,'2007-09-23 16:47:41',3310502464,1),(52171330,425620217,14956049,501218,1,'2007-09-23 16:47:41',3310502464,1),(52171338,425622545,14951816,501218,1,'2007-09-23 16:47:41',3310502464,1),(52171344,425624167,14950194,501218,1,'2007-09-23 16:47:41',3310502464,1),(52171351,425626213,14949630,435967,1,'2007-09-15 21:44:27',3310502464,1),(52171364,425627623,14949912,501218,1,'2007-09-23 16:47:41',3310502464,1),(52171370,425629105,14948713,501218,1,'2007-09-23 16:47:41',3310502464,1),(52171373,425630092,14947302,501218,1,'2007-09-23 16:47:41',3310502464,1),(52171378,425631574,14944128,501218,1,'2007-09-23 16:47:41',3310502464,1),(52171382,425632702,14942153,435967,1,'2007-09-15 21:44:29',3310502464,1),(52171385,425633055,14939190,501218,1,'2007-09-23 16:47:41',3310502122,1),(52171391,425633690,14936862,501218,1,'2007-09-23 16:47:41',3310502122,1),(52171407,425634325,14933406,435967,1,'2007-09-15 21:44:31',3310502122,1),(52171413,425635312,14930020,501218,1,'2007-09-23 16:47:41',3310502122,1),(52171417,425636935,14926422,501218,1,'2007-09-23 16:47:41',3310502122,1),(52171422,425639192,14923318,501218,1,'2007-09-23 16:47:41',3310502122,1),(52171426,425643001,14920920,501218,1,'2007-09-23 16:47:41',3310502122,1),(52171432,425650094,14914624,25362,1,'2008-06-03 01:02:03',3310502123,2),(52171437,425652453,14912244,501218,1,'2007-09-23 16:47:41',3310502123,1),(52171443,425654429,14909775,501218,1,'2007-09-23 16:47:41',3310502123,1),(52171444,425655063,14906812,501218,1,'2007-09-23 16:47:41',3310502123,1),(52171447,425656263,14903638,435967,1,'2007-09-15 21:44:35',3310502123,1),(52171449,425658379,14900887,501218,1,'2007-09-23 16:47:41',3310502123,1),(52171451,425669171,14892140,501218,1,'2007-09-23 16:47:41',3310502123,1),(52171454,425672269,14890377,435967,1,'2007-09-15 21:44:35',3310502126,1),(52171458,425675093,14889973,501218,1,'2007-09-23 16:47:41',3310502126,1),(52171465,425677675,14888763,501218,1,'2007-09-23 16:47:41',3310502126,1),(52171467,425680418,14886504,501218,1,'2007-09-23 16:47:41',3310502124,1),(52171474,425685016,14885052,501218,1,'2007-09-23 16:47:41',3310502124,1),(52171479,425687759,14882954,435967,1,'2007-09-15 21:44:38',3310502124,1),(52171481,425691229,14879163,501218,1,'2007-09-23 16:47:41',3310502124,1),(52171485,425693972,14875935,501218,1,'2007-09-23 16:47:41',3310502124,1),(52171487,425697925,14873031,501218,1,'2007-09-23 16:47:41',3310502124,1),(52171491,425700507,14871498,435967,1,'2007-09-15 21:44:39',3310502125,1),(52171494,425702846,14869885,501218,1,'2007-09-23 16:47:41',3310502125,1),(52171498,425703976,14868432,435967,1,'2007-09-15 21:44:39',3310502125,1),(52171503,425705751,14864560,501218,1,'2007-09-23 16:47:41',3310502125,1),(52171506,425707042,14862543,435967,1,'2007-09-15 21:44:40',3310502125,1),(52171511,425707848,14860607,501218,1,'2007-09-23 16:47:41',3310502125,1),(52171515,425709543,14858186,435967,1,'2007-09-15 21:44:40',3310502125,1),(52171521,425712118,14856763,501218,1,'2007-09-23 16:47:41',3310502125,1),(52171525,425713233,14854886,501218,1,'2007-09-23 16:47:41',3310502125,1),(52171528,425713937,14852657,501218,1,'2007-09-23 16:47:41',3310502125,1),(52171531,425714465,14848843,501218,1,'2007-09-23 16:47:41',3310502125,1),(52171534,425714699,14845148,501218,1,'2007-09-23 16:47:41',3310502125,1),(52171537,425715521,14842625,435967,1,'2007-09-15 21:44:42',3310502125,1),(52171542,425717046,14839926,501218,1,'2007-09-23 16:47:41',3310502125,1),(52171547,425718598,14838333,25362,1,'2008-06-03 01:16:20',3310502125,2),(52171553,425721127,14837733,25362,1,'2008-06-03 01:16:20',3310502125,2),(52171557,425725259,14836758,501218,1,'2007-09-23 16:47:41',3310502125,1),(52171562,425727430,14836113,435967,1,'2007-09-15 21:44:43',3310502136,1),(52171569,425728427,14835057,435967,1,'2007-09-15 21:44:43',3310502136,1),(52171574,425730011,14832945,501218,1,'2007-09-23 16:47:41',3310502136,1),(52171579,425732534,14830129,501218,1,'2007-09-23 16:47:41',3310502130,1),(52171585,425734470,14827900,501218,1,'2007-09-23 16:47:41',3310502130,1),(52171590,425739104,14824380,435967,1,'2007-09-15 21:44:44',3310502130,1),(52171594,425740976,14822665,435967,1,'2007-09-15 21:44:44',3310502130,1),(52171595,425742230,14820909,435967,1,'2007-09-15 21:44:44',3310502130,1),(52171601,425743686,14819002,501218,1,'2007-09-23 16:47:41',3310502130,1),(52171606,425745743,14816593,501218,1,'2007-09-23 16:47:41',3310502130,1),(52171610,425748805,14814535,435967,1,'2007-09-15 21:44:45',3310502130,1),(52171616,425750661,14813431,435967,1,'2007-09-15 21:44:45',3310502130,1),(52171622,425752217,14812879,501218,1,'2007-09-23 16:47:41',3310502130,1),(52171628,425753823,14812578,435967,1,'2007-09-15 21:44:46',3310502130,1),(52171633,425755931,14813180,435967,1,'2007-09-15 21:44:47',3310502131,1),(52171636,425758741,14813180,501218,1,'2007-09-23 16:47:41',3310502131,1),(52171644,425761150,14811875,435967,1,'2007-09-15 21:44:48',3310502131,1),(52171649,425765014,14809968,435967,1,'2007-09-15 21:44:48',3310502131,1),(52171653,425768025,14808011,501218,1,'2007-09-23 16:47:41',3310502131,1),(52171656,425770434,14807208,435967,1,'2007-09-15 21:44:49',3310502131,1),(52171659,425773194,14804398,435967,1,'2007-09-15 21:44:49',3310502131,1),(52171662,425775653,14800734,435967,1,'2007-09-15 21:44:49',3310502131,1),(52171665,425779016,14795264,501218,1,'2007-09-23 16:47:41',3310502131,1),(52171764,425782306,14788654,19873,1,'2008-06-02 18:53:15',3310502134,2),(52171771,425786192,14780158,501218,1,'2007-09-23 16:47:41',3310502134,1),(52171775,425787790,14775766,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171777,425789153,14772631,435967,1,'2007-09-15 21:45:03',3310502132,1),(52171781,425790709,14771627,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171785,425793168,14771326,435967,1,'2007-09-15 21:45:04',3310502132,1),(52171787,425795527,14769569,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171790,425797986,14767612,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171795,425799240,14765555,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171797,425800645,14761640,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171801,425802302,14760135,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171805,425802803,14758328,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171808,425803205,14755217,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171810,425802151,14751754,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171811,425801950,14746083,435967,1,'2007-09-15 21:45:06',3310502132,1),(52171814,425802703,14742470,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171815,425803255,14738104,435967,1,'2007-09-15 21:45:06',3310502132,1),(52171818,425803506,14734340,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171820,425803807,14731981,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171822,425804510,14729622,435967,1,'2007-09-15 21:45:06',3310502132,1),(52171825,425806511,14726146,435967,1,'2007-09-15 21:45:06',3310502132,1),(52171858,425808375,14722505,501218,1,'2007-09-23 16:47:41',3310502132,1),(52171863,425808775,14720108,501218,1,'2007-09-23 16:47:41',3310502110,1),(52171867,425810063,14718465,435967,1,'2007-09-15 21:45:13',3310502111,1),(52171885,425811084,14717532,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171888,425811705,14715490,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171892,425812238,14711538,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171895,425813037,14710784,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171932,425814636,14710073,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171934,425817033,14707276,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171940,425818943,14704790,435967,1,'2007-09-15 21:45:24',3310502111,1),(52171942,425821784,14702525,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171945,425823383,14700483,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171948,425826713,14695998,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171949,425827556,14694045,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171952,425827601,14690981,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171963,425828977,14689649,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171972,425830176,14688361,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171975,425831996,14688495,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171977,425833097,14687686,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171979,425833660,14686820,435967,1,'2007-09-15 21:45:29',3310502111,1),(52171981,425834223,14685693,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171985,425834397,14683873,501218,1,'2007-09-23 16:47:41',3310502111,1);
INSERT INTO `nodes` VALUES (52171988,425835177,14682487,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171989,425836303,14681751,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171991,425836346,14680971,435967,1,'2007-09-15 21:45:30',3310502111,1),(52171995,425836173,14679628,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171996,425836173,14678068,501218,1,'2007-09-23 16:47:41',3310502111,1),(52171997,425836823,14675469,501218,1,'2007-09-23 16:47:41',3310502282,1),(52172001,425836563,14672696,501218,1,'2007-09-23 16:47:41',3310502111,1),(52172006,425835740,14669187,501218,1,'2007-09-23 16:47:41',3310502111,1),(52172008,425833964,14663208,501218,1,'2007-09-23 16:47:41',3310502109,1),(52172012,425833487,14659395,501218,1,'2007-09-23 16:47:41',3310502109,1),(52172014,425833574,14658182,501218,1,'2007-09-23 16:47:41',3310502109,1),(52172016,425833964,14655453,501218,1,'2007-09-23 16:47:41',3310502109,1),(52172033,425834613,14654370,501218,1,'2007-09-23 16:47:41',3310502109,1),(52172036,425836173,14653200,501218,1,'2007-09-23 16:47:41',3310502109,1),(52172049,425839726,14651077,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172050,425841025,14649864,435967,1,'2007-09-15 21:45:37',3310502280,1),(52172086,425842238,14648608,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172090,425843538,14647525,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172092,425844188,14646615,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172096,425844318,14645619,435967,1,'2007-09-15 21:45:47',3310502280,1),(52172099,425844405,14643886,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172102,425845704,14642196,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172104,425846961,14640810,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172105,425848304,14639250,435967,1,'2007-09-15 21:45:49',3310502280,1),(52172106,425848997,14639077,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172107,425850210,14639337,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172109,425851076,14638817,435967,1,'2007-09-15 21:45:49',3310502280,1),(52172111,425851423,14638557,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172122,425852073,14637950,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172124,425852809,14637864,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172128,425853763,14638167,435967,1,'2007-09-15 21:45:51',3310502280,1),(52172129,425854282,14637430,435967,1,'2007-09-15 21:45:51',3310502280,1),(52172131,425854629,14636304,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172133,425856275,14634224,435967,1,'2007-09-15 21:45:51',3310502280,1),(52172135,425857012,14634008,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172139,425857835,14634008,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172141,425858745,14633834,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172144,425860911,14634008,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172147,425862991,14634484,501218,1,'2007-09-23 16:47:41',3310502280,1),(52172150,425864767,14635957,501218,1,'2007-09-23 16:47:41',3310502281,1),(52172153,425865807,14636434,435967,1,'2007-09-15 21:45:53',3310502281,1),(52172156,425867496,14636174,501218,1,'2007-09-23 16:47:41',3310502281,1),(52172158,425869619,14635871,435967,1,'2007-09-15 21:45:53',3310502281,1),(52172161,425871439,14634528,435967,1,'2007-09-15 21:45:53',3310502281,1),(52172164,425873735,14633011,501218,1,'2007-09-23 16:47:41',3310502281,1),(52172166,425875641,14632058,501218,1,'2007-09-23 16:47:41',3310502281,1),(52172168,425879237,14630975,501218,1,'2007-09-23 16:47:41',3310502281,1),(52172170,425880970,14629979,501218,1,'2007-09-23 16:47:41',3310502281,1),(52172172,425881706,14629155,435967,1,'2007-09-15 21:45:54',3310502281,1),(52172175,425882010,14628332,501218,1,'2007-09-23 16:47:41',3310502281,1),(52172178,425882010,14627119,501218,1,'2007-09-23 16:47:41',3310502281,1),(52172181,425883483,14625040,435967,1,'2007-09-15 21:45:54',3310502281,1),(52202283,425622053,14955746,435967,1,'2007-09-15 22:53:18',3310502464,1),(52202293,425620294,14958267,435967,1,'2007-09-15 22:53:18',3310502464,1),(52202298,425617854,14962173,435967,1,'2007-09-15 22:53:19',3310502464,1),(52202362,425616347,14964163,435967,1,'2007-09-15 22:53:27',3310502421,1),(52202389,425623684,14954337,435967,1,'2007-09-15 22:53:30',3310502464,1),(52202451,425625461,14952920,435967,1,'2007-09-15 22:53:37',3310502464,1),(52202455,425626998,14951887,435967,1,'2007-09-15 22:53:38',3310502464,1),(52202460,425628198,14950975,435967,1,'2007-09-15 22:53:38',3310502464,1),(52202465,425629591,14949750,435967,1,'2007-09-15 22:53:38',3310502464,1),(52202468,425630768,14948334,435967,1,'2007-09-15 22:53:38',3310502464,1),(52202473,425632208,14946388,435967,1,'2007-09-15 22:53:39',3310502464,1),(52202476,425633497,14944720,435967,1,'2007-09-15 22:53:40',3310502464,1),(52202485,425634460,14943027,435967,1,'2007-09-15 22:53:40',3310502464,1),(52202488,425635091,14940936,435967,1,'2007-09-15 22:53:40',3310502122,1),(52202493,425635655,14938180,435967,1,'2007-09-15 22:53:40',3310502122,1),(52202499,425636518,14933998,435967,1,'2007-09-15 22:53:41',3310502122,1),(52202507,425637481,14929317,435967,1,'2007-09-15 22:53:42',3310502122,1),(52202511,425638012,14927093,435967,1,'2007-09-15 22:53:42',3310502122,1),(52202517,425638676,14925632,435967,1,'2007-09-15 22:53:43',3310502122,1),(52202521,425639738,14924603,435967,1,'2007-09-15 22:53:43',3310502122,1),(52202523,425640966,14923806,435967,1,'2007-09-15 22:53:43',3310502122,1),(52202526,425643025,14922545,435967,1,'2007-09-15 22:53:43',3310502122,1),(52202528,425644817,14921250,435967,1,'2007-09-15 22:53:44',3310502123,1),(52202533,425646477,14919923,435967,1,'2007-09-15 22:53:44',3310502123,1),(52202534,425648514,14918057,25362,1,'2008-06-03 01:01:40',3310502123,2),(52202539,425651865,14914710,25362,1,'2008-06-03 01:01:40',3310502123,2),(52202541,425654267,14912135,25362,1,'2008-06-03 01:04:41',3310502123,3),(52202545,425661473,14905011,25362,1,'2008-06-03 01:01:40',3310502123,2),(52202549,425665582,14901750,25362,1,'2008-06-03 01:01:40',3310502123,2),(52202552,425669881,14898059,25362,1,'2008-06-03 00:58:44',3310502123,2),(52202553,425671714,14896256,25362,1,'2008-06-03 00:58:44',3310502123,2),(52202560,425674444,14893548,435967,1,'2007-09-15 22:53:46',3310502126,1),(52202566,425677368,14890508,435967,1,'2007-09-15 22:53:47',3310502126,1),(52202571,425681109,14888228,435967,1,'2007-09-15 22:53:47',3310502126,1),(52202579,425685110,14887342,21109,1,'2008-06-02 23:17:41',3310502126,2),(52203066,425689598,14885196,21109,1,'2008-06-02 23:17:41',3310502124,2),(52204239,425695920,14879998,21109,1,'2008-06-02 23:28:50',3310502124,3),(52204243,425702493,14873303,21109,1,'2008-06-02 23:28:50',3310502125,2),(52204246,425704137,14871415,21109,1,'2008-06-02 23:28:50',3310502125,2),(52204248,425705907,14868497,21109,1,'2008-06-02 23:28:50',3310502125,2),(52204251,425707487,14866265,21109,1,'2008-06-02 23:28:50',3310502125,2),(52204254,425710015,14863347,21109,1,'2008-06-02 23:28:50',3310502125,2),(52204258,425711722,14860257,21109,1,'2008-06-02 23:28:50',3310502125,2),(52204261,425713216,14858037,435967,1,'2007-09-15 22:57:07',3310502125,1),(52204265,425714646,14855806,435967,1,'2007-09-15 22:57:07',3310502125,1),(52204267,425715676,14852316,435967,1,'2007-09-15 22:57:07',3310502125,1),(52204269,425716706,14848827,435967,1,'2007-09-15 22:57:08',3310502125,1),(52204275,425717933,14845359,435967,1,'2007-09-15 22:57:08',3310502125,1),(52204280,425718518,14842805,435967,1,'2007-09-15 22:57:09',3310502125,1),(52204284,425719221,14841414,435967,1,'2007-09-15 22:57:09',3310502125,1),(52204288,425720277,14839707,435967,1,'2007-09-15 22:57:09',3310502125,1),(52204291,425722328,14838419,863220,1,'2009-03-27 04:34:30',3310502125,3),(52204292,425724287,14838162,25362,1,'2008-06-03 01:16:08',3310502125,2),(52204294,425726057,14838162,25362,1,'2008-06-03 01:16:08',3310502125,2),(52204296,425727977,14838007,435967,1,'2007-09-15 22:57:10',3310502136,1),(52204307,425729818,14837458,435967,1,'2007-09-15 22:57:11',3310502136,1),(52204324,425731401,14836360,435967,1,'2007-09-15 22:57:12',3310502136,1),(52204328,425732500,14834906,435967,1,'2007-09-15 22:57:12',3310502136,1),(52204344,425733275,14833421,435967,1,'2007-09-15 22:57:14',3310502136,1),(52204350,425735168,14831333,435967,1,'2007-09-15 22:57:14',3310502130,1),(52204353,425737396,14828630,435967,1,'2007-09-15 22:57:14',3310502130,1),(52204354,425739672,14825786,435967,1,'2007-09-15 22:57:14',3310502130,1),(52204363,425741900,14823178,435967,1,'2007-09-15 22:57:15',3310502130,1),(52204366,425743512,14820903,435967,1,'2007-09-15 22:57:15',3310502130,1),(52204368,425745645,14818200,435967,1,'2007-09-15 22:57:16',3310502130,1),(52204371,425748110,14816399,435967,1,'2007-09-15 22:57:16',3310502130,1),(52204375,425751287,14814503,435967,1,'2007-09-15 22:57:16',3310502130,1),(52204377,425752899,14813697,435967,1,'2007-09-15 22:57:16',3310502130,1),(52204380,425753894,14813554,435967,1,'2007-09-15 22:57:16',3310502130,1),(52204383,425755174,14814029,435967,1,'2007-09-15 22:57:17',3310502131,1),(52204386,425756265,14814503,435967,1,'2007-09-15 22:57:17',3310502131,1),(52204388,425757450,14814645,435967,1,'2007-09-15 22:57:17',3310502131,1),(52204391,425758777,14814645,435967,1,'2007-09-15 22:57:18',3310502131,1),(52204394,425760152,14814076,435967,1,'2007-09-15 22:57:18',3310502131,1),(52204397,425762143,14812938,435967,1,'2007-09-15 22:57:18',3310502131,1),(52204401,425763803,14811753,435967,1,'2007-09-15 22:57:19',3310502131,1),(52204404,425719807,14840378,435967,1,'2007-09-15 22:57:19',3310502125,1),(52204407,425720937,14839020,25362,1,'2008-06-03 01:16:08',3310502125,2),(52204415,425765294,14810726,435967,1,'2007-09-15 22:57:21',3310502131,1),(52204417,425766498,14809923,435967,1,'2007-09-15 22:57:21',3310502131,1),(52204420,425768051,14809173,435967,1,'2007-09-15 22:57:21',3310502131,1),(52204423,425769443,14808718,435967,1,'2007-09-15 22:57:21',3310502131,1),(52204425,425770674,14807995,435967,1,'2007-09-15 22:57:21',3310502131,1),(52204428,425772388,14807005,435967,1,'2007-09-15 22:57:21',3310502131,1),(52204431,425773512,14805452,435967,1,'2007-09-15 22:57:21',3310502131,1),(52204434,425775948,14801410,435967,1,'2007-09-15 22:57:22',3310502131,1),(52204436,425777715,14798519,435967,1,'2007-09-15 22:57:22',3310502131,1),(52204439,425781436,14792602,435967,1,'2007-09-15 22:57:22',3310502131,1),(52204442,425782496,14790800,19873,1,'2008-06-02 18:53:32',3310502134,3),(52204445,425782812,14789255,19873,1,'2008-06-02 18:54:34',3310502134,4),(52204446,425782054,14788053,19873,1,'2008-06-02 18:54:34',3310502134,4),(52204450,425781611,14787624,19873,1,'2008-06-02 18:52:50',3310502131,3),(52204453,425779265,14790515,435967,1,'2007-09-15 22:57:24',3310502131,1),(52204456,425776660,14793739,435967,1,'2007-09-15 22:57:24',3310502131,1),(52204459,425774641,14796507,435967,1,'2007-09-15 22:57:25',3310502131,1),(52204462,425773013,14798461,435967,1,'2007-09-15 22:57:25',3310502131,1),(52204465,425770896,14799893,435967,1,'2007-09-15 22:57:25',3310502131,1),(52204467,425768324,14800675,435967,1,'2007-09-15 22:57:25',3310502131,1),(52204470,425764514,14801359,435967,1,'2007-09-15 22:57:26',3310502131,1),(52204473,425762300,14801359,435967,1,'2007-09-15 22:57:26',3310502131,1),(52204476,425760704,14801163,435967,1,'2007-09-15 22:57:26',3310502131,1),(52204478,425759239,14800838,435967,1,'2007-09-15 22:57:26',3310502131,1),(52204480,425757774,14800479,435967,1,'2007-09-15 22:57:26',3310502131,1),(52204483,425755885,14800317,435967,1,'2007-09-15 22:57:27',3310502131,1),(52204485,425754290,14800154,435967,1,'2007-09-15 22:57:27',3310502131,1),(52204488,425752955,14800251,435967,1,'2007-09-15 22:57:27',3310502130,1),(52204492,425752043,14800382,435967,1,'2007-09-15 22:57:28',3310502130,1),(52204495,425750936,14800675,435967,1,'2007-09-15 22:57:29',3310502130,1),(52204498,425749959,14800740,435967,1,'2007-09-15 22:57:29',3310502130,1),(52204501,425749145,14800675,435967,1,'2007-09-15 22:57:29',3310502130,1),(52204504,425748233,14800121,435967,1,'2007-09-15 22:57:29',3310502130,1),(52204505,425746931,14799405,435967,1,'2007-09-15 22:57:29',3310502130,1),(52204513,425744749,14799437,435967,1,'2007-09-15 22:57:30',3310502130,1),(52204516,425742289,14798888,435967,1,'2007-09-15 22:57:30',3310502130,1),(52204520,425740877,14798109,435967,1,'2007-09-15 22:57:30',3310502130,1),(52204523,425739610,14797573,435967,1,'2007-09-15 22:57:31',3310502130,1),(52204525,425737418,14796988,435967,1,'2007-09-15 22:57:31',3310502130,1),(52204528,425734564,14796803,435967,1,'2007-09-15 22:57:31',3310502130,1),(52204531,425732382,14796764,435967,1,'2007-09-15 22:57:31',3310502130,1),(52204534,425730278,14796414,435967,1,'2007-09-15 22:57:31',3310502130,1),(52204536,425727706,14795751,435967,1,'2007-09-15 22:57:31',3310502130,1),(52204541,425726225,14794660,435967,1,'2007-09-15 22:57:32',3310502119,1),(52204544,425724082,14793608,435967,1,'2007-09-15 22:57:32',3310502119,1),(52204547,425721666,14792634,435967,1,'2007-09-15 22:57:32',3310502119,1),(52204549,425719835,14791854,435967,1,'2007-09-15 22:57:32',3310502119,1),(52204553,425717536,14791231,435967,1,'2007-09-15 22:57:32',3310502119,1),(52204565,425715899,14791075,435967,1,'2007-09-15 22:57:34',3310502119,1),(52204568,425714457,14791036,435967,1,'2007-09-15 22:57:34',3310502119,1),(52204624,425713699,14790855,435967,1,'2007-09-15 22:57:39',3310502119,1),(52204627,425712992,14790170,435967,1,'2007-09-15 22:57:39',3310502119,1),(52204664,425712470,14789049,435967,1,'2007-09-15 22:57:45',3310502119,1),(52204665,425711982,14787049,435967,1,'2007-09-15 22:57:45',3310502119,1),(52204668,425711381,14784477,435967,1,'2007-09-15 22:57:45',3310502119,1),(52204669,425710909,14782313,435967,1,'2007-09-15 22:57:45',3310502119,1),(52204670,425710438,14780654,435967,1,'2007-09-15 22:57:45',3310502119,1),(52204747,425710080,14779532,435967,1,'2007-09-15 22:57:58',3310502119,1),(52204750,425709657,14778507,435967,1,'2007-09-15 22:57:58',3310502119,1),(52204798,425709071,14777222,435967,1,'2007-09-15 22:58:04',3310502119,1),(52204800,425708746,14776424,435967,1,'2007-09-15 22:58:04',3310502117,1),(52204903,425708762,14775416,435967,1,'2007-09-15 22:58:13',3310502117,1),(52204912,425709120,14774505,435967,1,'2007-09-15 22:58:16',3310502117,1),(52204916,425709510,14774147,435967,1,'2007-09-15 22:58:16',3310502117,1),(52204922,425710112,14774147,435967,1,'2007-09-15 22:58:17',3310502117,1),(52204983,425710682,14774570,435967,1,'2007-09-15 22:58:21',3310502117,1),(52205002,425710991,14775757,435967,1,'2007-09-15 22:58:23',3310502117,1),(52205008,425711137,14776734,435967,1,'2007-09-15 22:58:23',3310502117,1),(52205014,425712048,14779645,435967,1,'2007-09-15 22:58:23',3310502119,1),(52205020,425712897,14782036,435967,1,'2007-09-15 22:58:24',3310502119,1),(52205022,425713480,14783591,435967,1,'2007-09-15 22:58:24',3310502119,1),(52205029,425713934,14785080,435967,1,'2007-09-15 22:58:25',3310502119,1),(52205032,425714387,14785987,435967,1,'2007-09-15 22:58:25',3310502119,1),(52205035,425714938,14786473,435967,1,'2007-09-15 22:58:25',3310502119,1),(52205038,425715715,14786537,435967,1,'2007-09-15 22:58:25',3310502119,1),(52205041,425716621,14786473,435967,1,'2007-09-15 22:58:25',3310502119,1),(52205043,425719050,14786408,435967,1,'2007-09-15 22:58:26',3310502119,1),(52205046,425720637,14786505,435967,1,'2007-09-15 22:58:26',3310502119,1),(52205050,425722839,14786829,435967,1,'2007-09-15 22:58:26',3310502119,1),(52205053,425725009,14787768,435967,1,'2007-09-15 22:58:26',3310502119,1),(52205055,425727340,14789063,435967,1,'2007-09-15 22:58:26',3310502130,1),(52205059,425728700,14790520,435967,1,'2007-09-15 22:58:26',3310502130,1),(52205063,425729834,14790877,435967,1,'2007-09-15 22:58:27',3310502130,1),(52205065,425730676,14790682,435967,1,'2007-09-15 22:58:27',3310502130,1),(52205070,425730870,14790229,435967,1,'2007-09-15 22:58:27',3310502130,1),(52205073,425730870,14789290,435967,1,'2007-09-15 22:58:27',3310502130,1),(52205075,425730158,14788772,435967,1,'2007-09-15 22:58:27',3310502130,1),(52205077,425729218,14788351,435967,1,'2007-09-15 22:58:28',3310502130,1),(52205079,425727923,14787282,435967,1,'2007-09-15 22:58:28',3310502130,1),(52205080,425726304,14785793,435967,1,'2007-09-15 22:58:28',3310502119,1),(52205082,425724588,14784789,435967,1,'2007-09-15 22:58:28',3310502119,1),(52205084,425723033,14784011,435967,1,'2007-09-15 22:58:28',3310502119,1),(52205086,425721155,14782651,435967,1,'2007-09-15 22:58:28',3310502119,1),(52205087,425719686,14781704,435967,1,'2007-09-15 22:58:29',3310502119,1),(52205089,425718340,14780796,435967,1,'2007-09-15 22:58:29',3310502119,1),(52205090,425717600,14779820,435967,1,'2007-09-15 22:58:29',3310502119,1),(52205091,425716995,14777869,435967,1,'2007-09-15 22:58:29',3310502119,1),(52205092,425716288,14773698,435967,1,'2007-09-15 22:58:29',3310502117,1),(52205093,425715245,14770603,435967,1,'2007-09-15 22:58:29',3310502117,1),(52205094,425714304,14768383,435967,1,'2007-09-15 22:58:30',3310502117,1),(52205095,425712689,14765691,435967,1,'2007-09-15 22:58:30',3310502117,1),(52205096,425711141,14763539,435967,1,'2007-09-15 22:58:30',3310502117,1),(52205099,425709762,14761722,435967,1,'2007-09-15 22:58:30',3310502117,1),(52205101,425708114,14760410,435967,1,'2007-09-15 22:58:30',3310502117,1),(52205105,425707037,14759468,435967,1,'2007-09-15 22:58:30',3310502117,1),(52205107,425706264,14757988,435967,1,'2007-09-15 22:58:31',3310502117,1),(52205110,425705658,14755869,435967,1,'2007-09-15 22:58:31',3310502117,1),(52205113,425704548,14753245,435967,1,'2007-09-15 22:58:31',3310502117,1),(52205116,425703472,14751597,435967,1,'2007-09-15 22:58:31',3310502117,1),(52205122,425701289,14749469,435967,1,'2007-09-15 22:58:31',3310502117,1),(52205123,425699338,14748362,435967,1,'2007-09-15 22:58:32',3310502117,1),(52205126,425697008,14746673,435967,1,'2007-09-15 22:58:32',3310502116,1),(52205131,425695698,14745858,435967,1,'2007-09-15 22:58:32',3310502116,1),(52205132,425694621,14745742,435967,1,'2007-09-15 22:58:32',3310502116,1),(52205135,425693776,14745829,435967,1,'2007-09-15 22:58:32',3310502116,1),(52205138,425692670,14746411,435967,1,'2007-09-15 22:58:32',3310502116,1),(52205141,425691272,14747198,435967,1,'2007-09-15 22:58:33',3310502116,1),(52205144,425689932,14747984,435967,1,'2007-09-15 22:58:33',3310502116,1),(52205148,425688505,14749003,435967,1,'2007-09-15 22:58:33',3310502116,1),(52205150,425687661,14750314,435967,1,'2007-09-15 22:58:33',3310502116,1),(52205154,425686816,14751973,435967,1,'2007-09-15 22:58:33',3310502116,1),(52205161,425685739,14755148,435967,1,'2007-09-15 22:58:34',3310502116,1),(52205166,425685360,14757099,435967,1,'2007-09-15 22:58:35',3310502116,1),(52205171,425684894,14758613,435967,1,'2007-09-15 22:58:35',3310502116,1),(52205175,425684166,14759894,435967,1,'2007-09-15 22:58:35',3310502116,1),(52205176,425682914,14761205,435967,1,'2007-09-15 22:58:36',3310502116,1),(52205177,425681720,14761962,435967,1,'2007-09-15 22:58:36',3310502116,1),(52205182,425680526,14762369,435967,1,'2007-09-15 22:58:36',3310502116,1),(52205186,425678954,14762573,435967,1,'2007-09-15 22:58:37',3310502116,1),(52205188,425677527,14762078,435967,1,'2007-09-15 22:58:37',3310502116,1),(52205196,425675692,14760739,435967,1,'2007-09-15 22:58:37',3310502116,1),(52205200,425672897,14758904,435967,1,'2007-09-15 22:58:38',3310502116,1),(52205206,425670887,14757914,435967,1,'2007-09-15 22:58:39',3310502113,1),(52205212,425668558,14756545,435967,1,'2007-09-15 22:58:39',3310502113,1),(52205218,425667306,14755730,435967,1,'2007-09-15 22:58:39',3310502113,1),(52205222,425666228,14754769,435967,1,'2007-09-15 22:58:39',3310502113,1),(52205225,425665529,14753255,435967,1,'2007-09-15 22:58:40',3310502113,1),(52205230,425665558,14751886,435967,1,'2007-09-15 22:58:40',3310502113,1),(52205232,425666170,14751071,435967,1,'2007-09-15 22:58:40',3310502113,1),(52205239,425666956,14750954,435967,1,'2007-09-15 22:58:41',3310502113,1),(52205242,425668179,14751449,435967,1,'2007-09-15 22:58:41',3310502113,1),(52205244,425669373,14752265,435967,1,'2007-09-15 22:58:41',3310502113,1),(52205248,425671324,14752643,435967,1,'2007-09-15 22:58:42',3310502113,1),(52205252,425672809,14752993,435967,1,'2007-09-15 22:58:42',3310502116,1),(52205257,425674178,14753429,435967,1,'2007-09-15 22:58:43',3310502116,1),(52205261,425675343,14753924,435967,1,'2007-09-15 22:58:43',3310502116,1),(52205266,425676100,14753895,435967,1,'2007-09-15 22:58:43',3310502116,1),(52205269,425676799,14753546,435967,1,'2007-09-15 22:58:43',3310502116,1),(52205274,425676799,14752847,435967,1,'2007-09-15 22:58:44',3310502116,1),(52205280,425676711,14751740,435967,1,'2007-09-15 22:58:44',3310502116,1),(52205284,425676129,14750750,435967,1,'2007-09-15 22:58:45',3310502116,1),(52205286,425674993,14750343,435967,1,'2007-09-15 22:58:45',3310502116,1),(52205290,425673683,14749935,435967,1,'2007-09-15 22:58:45',3310502116,1),(52205296,425671907,14748858,435967,1,'2007-09-15 22:58:45',3310502116,1),(52205298,425670567,14747547,435967,1,'2007-09-15 22:58:45',3310502113,1),(52205301,425669286,14746615,435967,1,'2007-09-15 22:58:46',3310502113,1),(52205304,425668034,14746062,435967,1,'2007-09-15 22:58:46',3310502113,1),(52205306,425666665,14745480,435967,1,'2007-09-15 22:58:46',3310502113,1),(52205309,425665180,14745392,435967,1,'2007-09-15 22:58:46',3310502113,1),(52205311,425663957,14745363,435967,1,'2007-09-15 22:58:47',3310502113,1),(52205317,425662716,14745689,435967,1,'2007-09-15 22:58:47',3310502113,1),(52205404,425661546,14746224,435967,1,'2007-09-15 22:58:57',3310502113,1),(52205416,425660308,14746191,435967,1,'2007-09-15 22:58:58',3310502113,1),(52205422,425659605,14745655,435967,1,'2007-09-15 22:58:58',3310502113,1),(52205427,425659036,14744685,435967,1,'2007-09-15 22:58:58',3310502113,1),(52205431,425659170,14743548,435967,1,'2007-09-15 22:58:59',3310502113,1),(52205434,425659639,14742879,435967,1,'2007-09-15 22:58:59',3310502113,1),(52205438,425660575,14742711,435967,1,'2007-09-15 22:58:59',3310502113,1),(52205450,425661813,14743146,435967,1,'2007-09-15 22:59:00',3310502113,1),(52205456,425663519,14743247,435967,1,'2007-09-15 22:59:00',3310502113,1),(52205461,425664556,14742946,435967,1,'2007-09-15 22:59:00',3310502113,1),(52205464,425665226,14742276,435967,1,'2007-09-15 22:59:00',3310502113,1),(52205469,425665493,14741440,435967,1,'2007-09-15 22:59:01',3310502113,1),(52205473,425665359,14740570,435967,1,'2007-09-15 22:59:01',3310502113,1),(52205475,425664824,14739801,435967,1,'2007-09-15 22:59:01',3310502113,1),(52205480,425664055,14739533,435967,1,'2007-09-15 22:59:01',3310502113,1),(52205485,425662984,14740102,435967,1,'2007-09-15 22:59:02',3310502113,1),(52205489,425662114,14740537,435967,1,'2007-09-15 22:59:02',3310502113,1),(52205492,425660876,14740604,435967,1,'2007-09-15 22:59:02',3310502113,1),(52205496,425659973,14740336,435967,1,'2007-09-15 22:59:02',3310502113,1),(52205622,425659070,14739767,435967,1,'2007-09-15 22:59:14',3310502113,1),(52205637,425657866,14738429,435967,1,'2007-09-15 22:59:16',3310502113,1),(52205641,425656427,14736154,435967,1,'2007-09-15 22:59:16',3310502113,1),(52205671,425655825,14734716,435967,1,'2007-09-15 22:59:18',3310502113,1),(52205676,425655858,14733712,435967,1,'2007-09-15 22:59:19',3310502113,1),(52205678,425656527,14733143,435967,1,'2007-09-15 22:59:19',3310502113,1),(52205679,425657196,14733244,435967,1,'2007-09-15 22:59:19',3310502113,1),(52205681,425658033,14734080,435967,1,'2007-09-15 22:59:19',3310502113,1),(52205685,425658869,14735418,435967,1,'2007-09-15 22:59:19',3310502113,1),(52205687,425659630,14736220,435967,1,'2007-09-15 22:59:19',3310502113,1),(52205690,425660691,14736785,435967,1,'2007-09-15 22:59:20',3310502113,1),(52205693,425662176,14736644,435967,1,'2007-09-15 22:59:20',3310502113,1),(52205695,425664438,14736538,435967,1,'2007-09-15 22:59:20',3310502113,1),(52205699,425666983,14736927,435967,1,'2007-09-15 22:59:20',3310502113,1),(52205703,425668574,14737422,435967,1,'2007-09-15 22:59:21',3310502113,1),(52205707,425670731,14737987,435967,1,'2007-09-15 22:59:21',3310502113,1),(52205709,425673524,14738659,435967,1,'2007-09-15 22:59:21',3310502116,1),(52205712,425675751,14738801,435967,1,'2007-09-15 22:59:21',3310502116,1),(52205713,425677554,14738553,435967,1,'2007-09-15 22:59:22',3310502116,1),(52205715,425678791,14738023,435967,1,'2007-09-15 22:59:22',3310502116,1),(52205774,425679534,14736962,435967,1,'2007-09-15 22:59:30',3310502116,1),(52205782,425679569,14735548,435967,1,'2007-09-15 22:59:30',3310502116,1),(52205785,425679321,14732932,435967,1,'2007-09-15 22:59:31',3310502116,1),(52205813,425679074,14728230,435967,1,'2007-09-15 22:59:33',3310502116,1),(52205820,425678720,14723670,435967,1,'2007-09-15 22:59:33',3310502116,1),(52205823,425678402,14717766,435967,1,'2007-09-15 22:59:33',3310502094,1),(52205828,425677766,14713630,435967,1,'2007-09-15 22:59:33',3310502094,1),(52205830,425676582,14707747,435967,1,'2007-09-15 22:59:33',3310502094,1),(52205836,425675471,14703463,435967,1,'2007-09-15 22:59:34',3310502094,1),(52205839,425674548,14699136,435967,1,'2007-09-15 22:59:35',3310502094,1),(52205843,425674493,14697863,435967,1,'2007-09-15 22:59:35',3310502094,1),(52205846,425674981,14696482,435967,1,'2007-09-15 22:59:35',3310502094,1),(52205849,425675604,14695670,435967,1,'2007-09-15 22:59:35',3310502094,1),(52205852,425676253,14695074,435967,1,'2007-09-15 22:59:35',3310502094,1),(52205855,425677309,14694587,435967,1,'2007-09-15 22:59:36',3310502094,1),(52205859,425678636,14694560,435967,1,'2007-09-15 22:59:36',3310502094,1),(52205863,425680098,14694993,435967,1,'2007-09-15 22:59:36',3310502094,1),(52205865,425683239,14697078,435967,1,'2007-09-15 22:59:36',3310502094,1),(52205869,425686163,14698946,435967,1,'2007-09-15 22:59:36',3310502094,1),(52205873,425691172,14702791,435967,1,'2007-09-15 22:59:36',3310502094,1),(52205876,425695206,14705986,435967,1,'2007-09-15 22:59:36',3310502094,1),(52205880,425699322,14710101,435967,1,'2007-09-15 22:59:36',3310502095,1),(52205882,425701623,14712944,435967,1,'2007-09-15 22:59:37',3310502095,1),(52205885,425703085,14714406,435967,1,'2007-09-15 22:59:37',3310502095,1),(52205888,425704331,14715056,435967,1,'2007-09-15 22:59:37',3310502095,1),(52205891,425705874,14715381,435967,1,'2007-09-15 22:59:37',3310502095,1),(52205893,425707797,14715760,435967,1,'2007-09-15 22:59:37',3310502095,1),(52205896,425709205,14716356,435967,1,'2007-09-15 22:59:37',3310502095,1),(52205898,425710937,14717791,435967,1,'2007-09-15 22:59:38',3310502095,1),(52205901,425713862,14721473,435967,1,'2007-09-15 22:59:38',3310502095,1),(52205904,425715540,14724127,435967,1,'2007-09-15 22:59:38',3310502117,1),(52205907,425717625,14726834,435967,1,'2007-09-15 22:59:38',3310502117,1),(52205910,425719737,14729054,435967,1,'2007-09-15 22:59:38',3310502117,1),(52205913,425721226,14730652,435967,1,'2007-09-15 22:59:38',3310502117,1),(52205915,425721903,14730950,435967,1,'2007-09-15 22:59:38',3310502117,1),(52205924,425722553,14731139,435967,1,'2007-09-15 22:59:39',3310502117,1),(52205929,425723257,14730706,435967,1,'2007-09-15 22:59:40',3310502117,1),(52205930,425723798,14730002,435967,1,'2007-09-15 22:59:40',3310502117,1),(52205935,425724177,14728946,435967,1,'2007-09-15 22:59:40',3310502117,1),(52205937,425724286,14727484,435967,1,'2007-09-15 22:59:40',3310502117,1),(52205938,425724313,14725751,435967,1,'2007-09-15 22:59:40',3310502117,1),(52205941,425724457,14722343,435967,1,'2007-09-15 22:59:40',3310502117,1),(52205945,425724764,14720190,435967,1,'2007-09-15 22:59:41',3310502095,1),(52205948,425725564,14718406,435967,1,'2007-09-15 22:59:41',3310502095,1),(52205951,425726623,14716695,435967,1,'2007-09-15 22:59:41',3310502095,1),(52205955,425728641,14715957,435967,1,'2007-09-15 22:59:41',3310502106,1),(52205959,425731495,14715661,435967,1,'2007-09-15 22:59:42',3310502106,1),(52205964,425733661,14715317,435967,1,'2007-09-15 22:59:42',3310502106,1),(52205967,425734596,14714825,435967,1,'2007-09-15 22:59:42',3310502106,1),(52205972,425734990,14713791,435967,1,'2007-09-15 22:59:42',3310502106,1),(52205973,425734941,14712856,435967,1,'2007-09-15 22:59:43',3310502106,1),(52205977,425734301,14712314,435967,1,'2007-09-15 22:59:43',3310502106,1),(52205980,425733267,14711773,435967,1,'2007-09-15 22:59:43',3310502106,1),(52205983,425731988,14711773,435967,1,'2007-09-15 22:59:43',3310502106,1),(52205985,425730806,14711773,435967,1,'2007-09-15 22:59:43',3310502106,1),(52205987,425729379,14711773,435967,1,'2007-09-15 22:59:44',3310502106,1),(52205990,425788381,14782206,435967,1,'2007-09-15 22:59:44',3310502134,1),(52205992,425790013,14784655,435967,1,'2007-09-15 22:59:44',3310502134,1),(52205994,425792140,14787420,435967,1,'2007-09-15 22:59:44',3310502134,1),(52205996,425796375,14791544,435967,1,'2007-09-15 22:59:44',3310502134,1),(52205998,425787824,14781429,435967,1,'2007-09-15 22:59:44',3310502134,1),(52206000,425787185,14781048,435967,1,'2007-09-15 22:59:44',3310502134,1),(52206003,425786241,14780759,435967,1,'2007-09-15 22:59:45',3310502134,1),(52206005,425785973,14780708,501218,1,'2007-09-23 16:47:41',3310502134,1),(52206007,425798598,14793625,435967,1,'2007-09-15 22:59:45',3310502134,1),(52206009,425800209,14795075,435967,1,'2007-09-15 22:59:45',3310502134,1),(52206010,425801606,14796550,435967,1,'2007-09-15 22:59:45',3310502134,1),(52206014,425802765,14797874,435967,1,'2007-09-15 22:59:46',3310502134,1),(52206016,425803474,14798749,435967,1,'2007-09-15 22:59:46',3310502134,1),(52206018,425804089,14799387,435967,1,'2007-09-15 22:59:46',3310502134,1),(52206020,425804656,14799600,435967,1,'2007-09-15 22:59:46',3310502134,1),(52206023,425805153,14799907,435967,1,'2007-09-15 22:59:46',3310502134,1),(52206025,425805460,14800404,435967,1,'2007-09-15 22:59:46',3310502134,1),(52206031,425805602,14800806,435967,1,'2007-09-15 22:59:47',3310502134,1),(52206033,425806122,14801231,435967,1,'2007-09-15 22:59:47',3310502134,1),(52206036,425806903,14801775,435967,1,'2007-09-15 22:59:47',3310502134,1),(52206040,425807659,14802177,435967,1,'2007-09-15 22:59:47',3310502134,1),(52206041,425808345,14802201,435967,1,'2007-09-15 22:59:47',3310502134,1),(52206044,425808794,14801964,435967,1,'2007-09-15 22:59:48',3310502134,1),(52206048,425809220,14801397,435967,1,'2007-09-15 22:59:48',3310502135,1),(52206051,425809906,14800830,435967,1,'2007-09-15 22:59:48',3310502135,1),(52206054,425810520,14800759,435967,1,'2007-09-15 22:59:48',3310502135,1),(52206057,425811277,14800830,435967,1,'2007-09-15 22:59:48',3310502135,1),(52206060,425812294,14801397,435967,1,'2007-09-15 22:59:48',3310502135,1),(52206063,425813571,14802130,435967,1,'2007-09-15 22:59:49',3310502135,1),(52206068,425814099,14802539,435967,1,'2007-09-15 22:59:49',3310502135,1),(52206069,425814534,14803039,435967,1,'2007-09-15 22:59:49',3310502135,1),(52206072,425815099,14803430,435967,1,'2007-09-15 22:59:49',3310502135,1),(52206076,425815533,14803474,435967,1,'2007-09-15 22:59:50',3310502135,1),(52206078,425815859,14803365,435967,1,'2007-09-15 22:59:50',3310502135,1),(52206165,425816185,14803822,435967,1,'2007-09-15 22:59:57',3310502135,1),(52206177,425816750,14803865,435967,1,'2007-09-15 22:59:57',3310502135,1),(52206181,425817598,14803908,435967,1,'2007-09-15 22:59:58',3310502135,1),(52206185,425818076,14804278,435967,1,'2007-09-15 22:59:58',3310502135,1),(52206187,425818554,14804626,435967,1,'2007-09-15 22:59:58',3310502135,1),(52206189,425819097,14804582,435967,1,'2007-09-15 22:59:58',3310502135,1),(52206193,425819423,14804821,435967,1,'2007-09-15 22:59:58',3310502135,1),(52206195,425819858,14805930,435967,1,'2007-09-15 22:59:59',3310502135,1),(52206198,425820292,14806364,435967,1,'2007-09-15 22:59:59',3310502135,1),(52206202,425820966,14806603,435967,1,'2007-09-15 22:59:59',3310502135,1),(52206203,425821292,14806775,435967,1,'2007-09-15 22:59:59',3310502135,1),(52206207,425821828,14807162,435967,1,'2007-09-15 22:59:59',3310502135,1),(52206209,425822160,14807550,435967,1,'2007-09-15 22:59:59',3310502135,1),(52206212,425822289,14807845,435967,1,'2007-09-15 23:00:00',3310502135,1),(52206215,425822621,14808011,435967,1,'2007-09-15 23:00:00',3310502135,1),(52206218,425823433,14808085,435967,1,'2007-09-15 23:00:00',3310502135,1),(52206221,425824652,14808602,435967,1,'2007-09-15 23:00:00',3310502135,1),(52206225,425825224,14809137,435967,1,'2007-09-15 23:00:00',3310502135,1),(52206228,425826003,14809650,435967,1,'2007-09-15 23:00:00',3310502135,1),(52206231,425826520,14810137,435967,1,'2007-09-15 23:00:00',3310502135,1),(52206234,425827051,14810492,435967,1,'2007-09-15 23:00:01',3310502135,1),(52206238,425827775,14810699,435967,1,'2007-09-15 23:00:01',3310502135,1),(52206240,425828114,14810935,435967,1,'2007-09-15 23:00:01',3310502135,1),(52206242,425828720,14811437,435967,1,'2007-09-15 23:00:01',3310502135,1),(52206244,425829251,14811964,435967,1,'2007-09-15 23:00:02',3310502135,1),(52206250,425830122,14812879,435967,1,'2007-09-15 23:00:02',3310502135,1),(52206252,425831037,14814006,435967,1,'2007-09-15 23:00:02',3310502135,1),(52206254,425831675,14814558,435967,1,'2007-09-15 23:00:02',3310502135,1),(52206256,425832483,14815047,435967,1,'2007-09-15 23:00:02',3310502135,1),(52206259,425833588,14815664,435967,1,'2007-09-15 23:00:02',3310502135,1),(52206262,425834269,14815664,435967,1,'2007-09-15 23:00:02',3310502135,1),(52206266,425834885,14815409,435967,1,'2007-09-15 23:00:02',3310502135,1),(52206268,425835630,14815154,435967,1,'2007-09-15 23:00:03',3310502135,1),(52206271,425836331,14815303,435967,1,'2007-09-15 23:00:03',3310502135,1),(52206274,425836756,14815451,435967,1,'2007-09-15 23:00:03',3310502306,1),(52206277,425837708,14815771,435967,1,'2007-09-15 23:00:04',3310502306,1),(52206280,425838742,14816171,435967,1,'2007-09-15 23:00:04',3310502306,1),(52206283,425839565,14816641,435967,1,'2007-09-15 23:00:04',3310502306,1),(52206286,425840224,14816782,435967,1,'2007-09-15 23:00:04',3310502306,1),(52206290,425841235,14816947,435967,1,'2007-09-15 23:00:04',3310502306,1),(52206293,425842152,14817205,435967,1,'2007-09-15 23:00:04',3310502306,1),(52206294,425843304,14817840,435967,1,'2007-09-15 23:00:04',3310502306,1),(52206299,425844292,14818264,435967,1,'2007-09-15 23:00:04',3310502306,1),(52206302,425845115,14818428,435967,1,'2007-09-15 23:00:05',3310502306,1),(52206304,425845750,14818710,435967,1,'2007-09-15 23:00:05',3310502306,1),(52206306,425846549,14819134,435967,1,'2007-09-15 23:00:05',3310502306,1),(52206310,425847349,14819722,435967,1,'2007-09-15 23:00:05',3310502306,1),(52206312,425847843,14820098,435967,1,'2007-09-15 23:00:05',3310502306,1),(52206315,425848407,14820568,435967,1,'2007-09-15 23:00:05',3310502306,1),(52206317,425849113,14820850,435967,1,'2007-09-15 23:00:06',3310502306,1),(52206320,425849818,14820944,435967,1,'2007-09-15 23:00:06',3310502306,1),(52206321,425850941,14821137,435967,1,'2007-09-15 23:00:06',3310502306,1),(52206324,425852038,14821390,435967,1,'2007-09-15 23:00:06',3310502306,1),(52206327,425852883,14821601,435967,1,'2007-09-15 23:00:06',3310502306,1),(52206333,425853347,14821981,435967,1,'2007-09-15 23:00:06',3310502306,1),(52206336,425853938,14822825,435967,1,'2007-09-15 23:00:07',3310502306,1),(52206337,425854177,14823136,435967,1,'2007-09-15 23:00:07',3310502306,1),(52206340,425854695,14823352,435967,1,'2007-09-15 23:00:07',3310502306,1),(52206343,425855149,14823698,435967,1,'2007-09-15 23:00:07',3310502306,1),(52206344,425855733,14824368,435967,1,'2007-09-15 23:00:07',3310502306,1),(52206347,425856079,14824671,435967,1,'2007-09-15 23:00:08',3310502306,1),(52206349,425856749,14825146,435967,1,'2007-09-15 23:00:08',3310502306,1),(52206352,425857354,14825751,435967,1,'2007-09-15 23:00:08',3310502306,1),(52206354,425857922,14825767,435967,1,'2007-09-15 23:00:08',3310502306,1),(52206356,425858541,14825940,435967,1,'2007-09-15 23:00:08',3310502306,1),(52206358,425859229,14826525,435967,1,'2007-09-15 23:00:08',3310502306,1),(52206359,425859677,14826628,435967,1,'2007-09-15 23:00:08',3310502306,1),(52206360,425860262,14826834,435967,1,'2007-09-15 23:00:09',3310502306,1),(52206364,425861226,14827351,435967,1,'2007-09-15 23:00:09',3310502306,1),(52206366,425862478,14827970,435967,1,'2007-09-15 23:00:09',3310502306,1),(52206374,425863277,14828356,435967,1,'2007-09-15 23:00:10',3310502306,1),(52206379,425864296,14828961,435967,1,'2007-09-15 23:00:10',3310502307,1),(52206383,425865342,14829402,435967,1,'2007-09-15 23:00:10',3310502307,1),(52206385,425866140,14830063,435967,1,'2007-09-15 23:00:10',3310502307,1),(52206389,425866939,14830669,435967,1,'2007-09-15 23:00:11',3310502307,1),(52206395,425867985,14831054,435967,1,'2007-09-15 23:00:11',3310502307,1),(52206400,425868674,14831247,435967,1,'2007-09-15 23:00:12',3310502307,1),(52206404,425870381,14831742,435967,1,'2007-09-15 23:00:12',3310502307,1),(52206407,425872033,14832155,435967,1,'2007-09-15 23:00:12',3310502313,1),(52206410,425873630,14832651,435967,1,'2007-09-15 23:00:12',3310502313,1),(52206414,425874401,14833449,435967,1,'2007-09-15 23:00:12',3310502313,1),(52206419,425874511,14833477,435967,1,'2007-09-15 23:00:13',3310502313,1),(52206420,425875589,14833961,435967,1,'2007-09-15 23:00:13',3310502313,1),(52206422,425877019,14834390,435967,1,'2007-09-15 23:00:13',3310502313,1),(52206425,425877842,14835105,435967,1,'2007-09-15 23:00:13',3310502313,1),(52206429,425878592,14835605,435967,1,'2007-09-15 23:00:13',3310502313,1),(52206433,425879522,14836285,435967,1,'2007-09-15 23:00:13',3310502313,1),(52206435,425880022,14836678,435967,1,'2007-09-15 23:00:14',3310502313,1),(52206439,425880952,14837250,435967,1,'2007-09-15 23:00:14',3310502313,1),(52206442,425882096,14837572,435967,1,'2007-09-15 23:00:14',3310502313,1),(52206446,425882990,14837500,435967,1,'2007-09-15 23:00:14',3310502313,1),(52206447,425884492,14837107,435967,1,'2007-09-15 23:00:14',3310502313,1),(52206449,425885671,14836964,435967,1,'2007-09-15 23:00:14',3310502313,1),(52206453,425886923,14836892,435967,1,'2007-09-15 23:00:15',3310502313,1),(52206457,425887392,14836352,435967,1,'2007-09-15 23:00:15',3310502313,1),(52206461,425888964,14835626,435967,1,'2007-09-15 23:00:17',3310502313,1),(52206468,425891382,14834538,435967,1,'2007-09-15 23:00:18',3310502313,1),(52206471,425895673,14833632,435967,1,'2007-09-15 23:00:18',3310502316,1),(52206472,425897789,14833027,435967,1,'2007-09-15 23:00:18',3310502316,1),(52206476,425745721,14725549,435967,1,'2007-09-15 23:00:18',3310502128,1),(52206479,425745847,14728685,435967,1,'2007-09-15 23:00:19',3310502128,1),(52206483,425745533,14732072,435967,1,'2007-09-15 23:00:19',3310502128,1),(52206486,425745967,14735043,435967,1,'2007-09-15 23:00:19',3310502128,1),(52206488,425746778,14737547,435967,1,'2007-09-15 23:00:19',3310502128,1),(52206491,425747072,14739757,435967,1,'2007-09-15 23:00:19',3310502128,1),(52206495,425748103,14742850,435967,1,'2007-09-15 23:00:19',3310502128,1),(52206498,425750018,14747784,435967,1,'2007-09-15 23:00:20',3310502128,1),(52206502,425752154,14753381,435967,1,'2007-09-15 23:00:20',3310502128,1),(52206505,425753111,14756475,435967,1,'2007-09-15 23:00:20',3310502128,1),(52206508,425754142,14759273,435967,1,'2007-09-15 23:00:20',3310502128,1),(52206512,425755542,14762587,435967,1,'2007-09-15 23:00:20',3310502129,1),(52206580,425757015,14765901,435967,1,'2007-09-15 23:00:27',3310502129,1),(52206583,425758488,14768847,435967,1,'2007-09-15 23:00:27',3310502129,1),(52206585,425758782,14770689,435967,1,'2007-09-15 23:00:27',3310502129,1),(52206588,425760402,14772972,435967,1,'2007-09-15 23:00:27',3310502129,1),(52206591,425761728,14774150,435967,1,'2007-09-15 23:00:28',3310502129,1),(52206601,425763496,14777832,435967,1,'2007-09-15 23:00:29',3310502131,1),(52206604,425763937,14779379,435967,1,'2007-09-15 23:00:29',3310502131,1),(52206607,425763716,14782325,435967,1,'2007-09-15 23:00:29',3310502131,1),(52206609,425763864,14784534,435967,1,'2007-09-15 23:00:29',3310502131,1),(52206611,425765484,14789248,435967,1,'2007-09-15 23:00:29',3310502131,1),(52206615,425767174,14791732,435967,1,'2007-09-15 23:00:30',3310502131,1),(52206617,425767551,14793919,435967,1,'2007-09-15 23:00:30',3310502131,1),(52206619,425768532,14797690,435967,1,'2007-09-15 23:00:30',3310502131,1),(52206620,425768720,14802743,435967,1,'2007-09-15 23:00:30',3310502131,1),(52206622,425768117,14804025,435967,1,'2007-09-15 23:00:31',3310502131,1),(52206625,425767039,14807004,435967,1,'2007-09-15 23:00:31',3310502131,1),(52206627,425766692,14808092,435967,1,'2007-09-15 23:00:31',3310502131,1),(52206628,425766544,14808797,501218,1,'2007-09-23 16:47:41',3310502131,1),(52206632,425786303,14771120,435967,1,'2007-09-15 23:00:32',3310502132,1),(52206635,425784274,14774797,435967,1,'2007-09-15 23:00:32',3310502132,1),(52206639,425782457,14780081,435967,1,'2007-09-15 23:00:32',3310502134,1),(52206643,425781801,14786594,19873,1,'2008-06-02 18:59:31',3310502134,3),(52206645,425788751,14768098,435967,1,'2007-09-15 23:00:33',3310502132,1),(52206647,425789928,14766760,435967,1,'2007-09-15 23:00:33',3310502132,1),(52206650,425790984,14765656,435967,1,'2007-09-15 23:00:33',3310502132,1),(52206653,425793088,14763631,435967,1,'2007-09-15 23:00:34',3310502132,1),(52206655,425794516,14762436,435967,1,'2007-09-15 23:00:34',3310502132,1),(52206657,425795970,14761371,435967,1,'2007-09-15 23:00:34',3310502132,1),(52206661,425797788,14761034,435967,1,'2007-09-15 23:00:34',3310502132,1),(52206663,425799579,14761733,435967,1,'2007-09-15 23:00:35',3310502132,1),(52206666,425801093,14762959,435967,1,'2007-09-15 23:00:35',3310502132,1),(52206669,425801892,14764721,435967,1,'2007-09-15 23:00:35',3310502132,1),(52206671,425802255,14767292,435967,1,'2007-09-15 23:00:35',3310502132,1),(52206673,425802177,14771578,435967,1,'2007-09-15 23:00:36',3310502132,1),(52206676,425801866,14782277,435967,1,'2007-09-15 23:00:36',3310502134,1),(52206679,425801711,14788956,435967,1,'2007-09-15 23:00:36',3310502134,1),(52206681,425801227,14792779,435967,1,'2007-09-15 23:00:36',3310502134,1),(52206684,425800150,14796118,435967,1,'2007-09-15 23:00:37',3310502134,1),(52206686,425797080,14801934,435967,1,'2007-09-15 23:00:37',3310502134,1),(52206688,425796218,14803226,435967,1,'2007-09-15 23:00:37',3310502134,1),(52206691,425795309,14782350,863220,1,'2009-03-27 04:34:38',3310502134,2),(52206694,425796038,14781183,435967,1,'2007-09-15 23:00:37',3310502134,1),(52206698,425796403,14780198,435967,1,'2007-09-15 23:00:37',3310502134,1),(52206701,425796221,14778847,435967,1,'2007-09-15 23:00:38',3310502134,1),(52206703,425795345,14776767,435967,1,'2007-09-15 23:00:38',3310502132,1),(52206706,425793280,14772310,435967,1,'2007-09-15 23:00:38',3310502132,1),(52206708,425792172,14770362,435967,1,'2007-09-15 23:00:38',3310502132,1),(52206710,425791246,14768753,435967,1,'2007-09-15 23:00:38',3310502132,1),(52206714,425798380,14775894,435967,1,'2007-09-15 23:00:39',3310502132,1),(52212234,425789323,14798844,435967,1,'2007-09-15 23:10:48',3310502134,1),(52212307,425787712,14800324,435967,1,'2007-09-15 23:10:57',3310502134,1),(52212628,425786753,14802110,435967,1,'2007-09-15 23:11:21',3310502134,1),(52212746,425787189,14803721,435967,1,'2007-09-15 23:11:40',3310502134,1),(52212871,425788278,14804635,435967,1,'2007-09-15 23:11:52',3310502134,1),(52212893,425790150,14805071,435967,1,'2007-09-15 23:11:55',3310502134,1),(52212906,425793634,14804723,435967,1,'2007-09-15 23:11:56',3310502134,1),(52212916,425792813,14808465,435967,1,'2007-09-15 23:11:57',3310502134,1),(52212920,425795711,14803863,435967,1,'2007-09-15 23:11:58',3310502134,1),(52252247,424667675,14925149,439281,1,'2007-09-16 00:22:31',3310490811,1),(52252315,424670114,14921036,439281,1,'2007-09-16 00:22:40',3310490811,1),(52252320,424666553,14919223,439281,1,'2007-09-16 00:22:40',3310490811,1),(52252322,424619189,14904314,439281,1,'2007-09-16 00:22:40',3310490799,1),(52252325,424619418,14904879,439281,1,'2007-09-16 00:22:40',3310490799,1),(52252326,424619260,14905372,439281,1,'2007-09-16 00:22:41',3310490799,1),(52252328,424618264,14905621,439281,1,'2007-09-16 00:22:41',3310490799,1),(52252330,424617895,14905265,439281,1,'2007-09-16 00:22:41',3310490799,1),(52252331,424617878,14904550,439281,1,'2007-09-16 00:22:41',3310490799,1),(52252333,424618190,14904201,439281,1,'2007-09-16 00:22:41',3310490799,1),(52252336,424618734,14904092,439281,1,'2007-09-16 00:22:41',3310490799,1),(52252404,424625121,14911084,439281,1,'2007-09-16 00:22:51',3310490799,1),(52252405,424622924,14909583,439281,1,'2007-09-16 00:22:51',3310490799,1),(52252407,424619167,14906066,439281,1,'2007-09-16 00:22:51',3310490799,1),(52252411,424618862,14905712,439281,1,'2007-09-16 00:22:52',3310490799,1),(52252412,424626790,14911587,439281,1,'2007-09-16 00:22:52',3310490799,1),(52252414,424628035,14911489,439281,1,'2007-09-16 00:22:52',3310490799,1),(52252416,424630228,14911096,439281,1,'2007-09-16 00:22:52',3310490810,1),(52252417,424632127,14910866,439281,1,'2007-09-16 00:22:52',3310490810,1),(52252420,424634303,14910005,439281,1,'2007-09-16 00:22:53',3310490810,1),(52252422,424636007,14909206,439281,1,'2007-09-16 00:22:53',3310490810,1),(52252423,424637988,14908580,439281,1,'2007-09-16 00:22:53',3310490810,1),(52252424,424640178,14908441,439281,1,'2007-09-16 00:22:53',3310490810,1),(52252426,424644211,14909345,439281,1,'2007-09-16 00:22:53',3310490810,1),(52252427,424649078,14910944,439281,1,'2007-09-16 00:22:53',3310490810,1),(52252429,424653006,14912682,439281,1,'2007-09-16 00:22:53',3310490810,1),(52252430,424655891,14915289,439281,1,'2007-09-16 00:22:53',3310490811,1),(52252431,424660028,14919391,439281,1,'2007-09-16 00:22:54',3310490811,1),(52252433,424664860,14923006,439281,1,'2007-09-16 00:22:54',3310490811,1),(52252434,424674733,14929159,439281,1,'2007-09-16 00:22:54',3310490811,1),(52252435,424680990,14932775,439281,1,'2007-09-16 00:22:54',3310490811,1),(52252437,424682102,14932983,439281,1,'2007-09-16 00:22:54',3310490811,1),(52252452,424694673,14933367,439281,1,'2007-09-16 00:22:56',3310490814,1),(52252472,424701941,14932706,439281,1,'2007-09-16 00:23:04',3310490814,1),(52252473,424711673,14934208,439281,1,'2007-09-16 00:23:07',3310490815,1),(52252474,424648295,14915734,439281,1,'2007-09-16 00:23:08',3310490810,1),(52252475,424648574,14913301,439281,1,'2007-09-16 00:23:08',3310490810,1),(52252476,424647987,14917382,439281,1,'2007-09-16 00:23:08',3310490810,1),(52252477,424648227,14917804,439281,1,'2007-09-16 00:23:08',3310490810,1),(52252478,424648884,14918041,439281,1,'2007-09-16 00:23:08',3310490810,1),(52252479,424649030,14920295,439281,1,'2007-09-16 00:23:08',3310490810,1),(52252480,424648724,14920936,439281,1,'2007-09-16 00:23:08',3310490810,1),(52261829,424648013,14921608,439281,1,'2007-09-16 00:38:11',3310490810,1),(52261834,424647223,14921805,439281,1,'2007-09-16 00:38:11',3310490810,1),(52261835,424645801,14921529,439281,1,'2007-09-16 00:38:12',3310490810,1),(52261839,424643550,14921371,439281,1,'2007-09-16 00:38:12',3310490810,1),(52261842,424642602,14921687,439281,1,'2007-09-16 00:38:12',3310490810,1),(52261846,424641851,14922832,439281,1,'2007-09-16 00:38:12',3310490810,1),(52261850,424641496,14924294,439281,1,'2007-09-16 00:38:13',3310490810,1),(52261853,424648072,14916779,439281,1,'2007-09-16 00:38:13',3310490810,1),(52261857,424649132,14918605,439281,1,'2007-09-16 00:38:13',3310490810,1),(52261860,424641921,14925632,439281,1,'2007-09-16 00:38:13',3310490810,1),(52261864,424642866,14926420,439281,1,'2007-09-16 00:38:13',3310490810,1),(52261866,424644161,14926910,439281,1,'2007-09-16 00:38:13',3310490810,1),(52261869,424646052,14927313,439281,1,'2007-09-16 00:38:14',3310490810,1),(52261872,424648544,14928203,439281,1,'2007-09-16 00:38:14',3310490810,1),(52261874,424651037,14929633,439281,1,'2007-09-16 00:38:14',3310490810,1),(52261878,424654300,14931539,439281,1,'2007-09-16 00:38:14',3310490810,1),(52261880,424656389,14933043,439281,1,'2007-09-16 00:38:14',3310490811,1),(52261883,424657893,14934692,439281,1,'2007-09-16 00:38:14',3310490811,1),(52261886,424663862,14926991,27626,1,'2009-04-01 15:50:51',3310490811,2),(52261888,424665124,14925040,27626,1,'2009-04-01 15:50:51',3310490811,2),(52261890,424665894,14923708,27626,1,'2009-04-01 15:50:51',3310490811,2),(52261893,424662811,14927921,27626,1,'2009-04-01 15:50:51',3310490811,2),(52261896,424661984,14929039,27626,1,'2009-04-01 15:50:51',3310490811,2),(52261900,424661401,14930400,27626,1,'2009-04-01 15:50:51',3310490811,2),(52261902,424661109,14932880,27626,1,'2009-04-01 15:50:51',3310490811,2),(52261907,424660720,14936356,27626,1,'2009-04-01 15:50:51',3310490811,2),(52261910,424660307,14940002,27626,1,'2009-04-01 15:50:51',3310490811,2),(52261914,424659408,14942725,27626,1,'2009-04-01 15:50:51',3310491153,2),(52261918,424657828,14945763,27626,1,'2009-04-01 15:50:51',3310491153,2),(52261921,424656963,14946941,27626,1,'2009-04-01 15:50:51',3310491153,2),(52261924,424656076,14947465,27626,1,'2009-04-01 15:50:50',3310491153,2),(52261926,424655069,14947707,27626,1,'2009-04-01 15:50:50',3310491152,2),(52261927,424654021,14947586,27626,1,'2009-04-01 15:50:50',3310491152,2),(52261931,424652934,14946861,27626,1,'2009-04-01 15:50:50',3310491152,2),(52261934,424651725,14945410,27626,1,'2009-04-01 15:50:50',3310491152,2),(52261938,424650637,14943557,27626,1,'2009-04-01 15:50:50',3310491152,2),(52261940,424649348,14941703,27626,1,'2009-04-01 15:50:50',3310491152,2),(52261946,424648461,14940575,27626,1,'2009-04-01 15:50:50',3310490810,2),(52261947,424647696,14940172,27626,1,'2009-04-01 15:50:50',3310490810,2),(52261951,424646971,14940334,27626,1,'2009-04-01 15:50:50',3310490810,2),(52261955,424646084,14941381,27626,1,'2009-04-01 15:50:50',3310490810,2),(52261959,424645278,14943436,27626,1,'2009-04-01 15:50:49',3310491152,2),(52261962,424644620,14945263,27626,1,'2009-04-01 15:50:49',3310491152,2),(52261965,424643224,14946700,27626,1,'2009-04-01 15:50:49',3310491152,2),(52261969,424642567,14946700,27626,1,'2009-04-01 15:50:49',3310491152,2),(52261972,424641868,14946454,27626,1,'2009-04-01 15:50:49',3310491152,2),(52261975,424641252,14945756,27626,1,'2009-04-01 15:50:49',3310491152,2),(52261978,424641006,14944483,27626,1,'2009-04-01 15:50:49',3310491152,2),(52261982,424641129,14942676,27626,1,'2009-04-01 15:50:48',3310491152,2),(52261985,424640965,14941157,27626,1,'2009-04-01 15:50:48',3310490810,2),(52261987,424640678,14939801,27626,1,'2009-04-01 15:50:48',3310490810,2),(52261991,424640062,14938816,27626,1,'2009-04-01 15:50:48',3310490810,2),(52261993,424638888,14937398,27626,1,'2009-04-01 15:50:48',3310490810,2),(52261997,424637976,14936901,27626,1,'2009-04-01 15:50:48',3310490810,2),(52261999,424653161,14955776,439281,1,'2007-09-16 00:38:23',3310491152,1),(52262003,424652176,14957007,439281,1,'2007-09-16 00:38:23',3310491152,1),(52262006,424651149,14957747,439281,1,'2007-09-16 00:38:24',3310491152,1),(52262010,424650164,14957747,439281,1,'2007-09-16 00:38:24',3310491152,1),(52262016,424648973,14957049,439281,1,'2007-09-16 00:38:24',3310491152,1),(52262020,424648151,14955283,439281,1,'2007-09-16 00:38:24',3310491152,1),(52262022,424644086,14946166,27626,1,'2009-04-01 15:50:49',3310491152,2),(52262025,424636148,14936133,27626,1,'2009-04-01 15:50:48',3310490810,2),(52262028,424633522,14935680,27626,1,'2009-04-01 15:50:48',3310490810,2),(52262031,424630714,14934955,27626,1,'2009-04-01 15:50:48',3310490810,2),(52262034,424628178,14934049,27626,1,'2009-04-01 15:50:48',3310490810,2),(52262036,424626366,14933008,27626,1,'2009-04-01 15:50:48',3310490799,2),(52262037,424624600,14932238,27626,1,'2009-04-01 15:50:48',3310490799,2),(52262039,424622743,14931287,27626,1,'2009-04-01 15:50:48',3310490799,2),(52262041,424621520,14930698,27626,1,'2009-04-01 15:50:48',3310490799,2),(52262042,424619618,14929339,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262044,424617942,14927618,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262045,424615678,14925897,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262046,424613504,14924493,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262047,424611692,14923225,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262048,424609065,14920870,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262052,424607797,14919421,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262054,424606620,14917881,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262057,424605805,14916477,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262058,424605171,14915390,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262060,424604537,14915254,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262063,424603767,14915254,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262064,424603495,14915662,27626,1,'2009-04-01 15:50:47',3310490799,3),(52262065,424603404,14916386,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262067,424603585,14917337,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262070,424604763,14919285,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262072,424606756,14922908,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262074,424609473,14928841,27626,1,'2009-04-01 15:50:47',3310490799,2),(52262076,424611583,14932753,27626,1,'2009-04-01 16:02:41',3310490799,6),(52262079,424597975,14914131,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262081,424599308,14915435,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262084,424600410,14916102,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262086,424601888,14916276,27626,1,'2009-04-01 15:43:48',3310490799,2),(52262087,424596873,14912816,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262089,424595767,14911766,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262092,424594292,14910802,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262095,424592392,14910008,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262097,424590662,14909100,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262101,424588960,14908278,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262103,424587741,14907824,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262106,424586408,14907739,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262109,424584678,14907853,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262111,424583231,14907370,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262114,424581388,14906973,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262115,424579942,14906888,27626,1,'2009-04-01 15:43:48',3310490798,2),(52262117,424577928,14906747,27626,1,'2009-04-01 15:43:47',3310490798,2),(52262119,424575489,14905839,27626,1,'2009-04-01 15:43:47',3310490798,2),(52262131,424574071,14905896,27626,1,'2009-04-01 15:43:47',3310490798,2),(52262133,424572766,14906236,27626,1,'2009-04-01 15:43:47',3310490795,2),(52262136,424571518,14907342,27626,1,'2009-04-01 15:43:47',3310490795,2),(52262137,424570724,14909327,27626,1,'2009-04-01 15:43:47',3310490795,2),(52262139,424570724,14911568,27626,1,'2009-04-01 15:43:47',3310490795,2),(52262143,424571348,14915538,27626,1,'2009-04-01 15:43:47',3310490795,2),(52262146,424572539,14922231,27626,1,'2009-04-01 15:43:47',3310490795,2),(52262150,424573192,14925294,27626,1,'2009-04-01 15:43:47',3310490798,2),(52262152,424573872,14927194,27626,1,'2009-04-01 15:43:47',3310490798,2),(52262155,424575517,14931222,27626,1,'2009-04-01 15:43:47',3310490798,2),(52262158,424576517,14933685,27626,1,'2009-04-01 15:43:47',3310490798,2),(52262161,424577069,14935858,27626,1,'2009-04-01 15:43:47',3310490798,2),(52262163,424576812,14937441,27626,1,'2009-04-01 15:48:56',3310490798,6),(52262166,424576186,14938399,27626,1,'2009-04-01 15:48:56',3310490798,5),(52262168,424575081,14938583,372139,1,'2009-04-10 12:07:13',3310490798,10),(52262176,424574123,14938251,372139,1,'2009-04-10 12:07:13',3310490798,7),(52262179,424573460,14937699,372139,1,'2009-04-10 12:07:13',3310490798,7),(52262183,424572429,14935674,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262187,424571509,14934532,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262191,424569520,14932433,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262193,424568452,14931439,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262198,424567495,14930334,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262201,424566758,14928934,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262204,424566279,14927204,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262207,424566022,14925399,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262210,424565580,14924037,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262213,424565027,14923558,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262215,424564291,14923484,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262217,424563849,14924000,372139,1,'2009-04-10 12:07:13',3310490795,7),(52262221,424563554,14924810,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262225,424563959,14925988,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262229,424564770,14927793,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262231,424566169,14931770,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262233,424568452,14937220,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262236,424569299,14939283,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262239,424569631,14940571,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262240,424569299,14941455,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262244,424568636,14941897,372139,1,'2009-04-10 12:07:12',3310491137,7),(52262245,424567900,14941492,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262247,424567568,14941050,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262251,424567568,14939945,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262252,424567347,14938951,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262257,424566022,14936852,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262259,424562118,14931917,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262263,424560203,14928566,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262265,424558583,14925546,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262271,424558104,14922969,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262275,424557736,14921606,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262279,424557147,14920464,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262283,424556263,14919838,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262287,424555011,14919838,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262290,424554164,14919728,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262293,424553538,14918881,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262297,424552985,14917776,372139,1,'2009-04-10 12:07:12',3310490795,7),(52262300,424552691,14916782,372139,1,'2009-04-10 12:07:11',3310490795,7),(52262303,424551365,14914683,372139,1,'2009-04-10 12:07:11',3310490795,7),(52262306,424548787,14913136,372139,1,'2009-04-10 12:07:11',3310490795,7),(52262310,424546798,14912105,372139,1,'2009-04-10 12:07:11',3310490795,7),(52262313,424543521,14910853,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262316,424540648,14909932,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262317,424536045,14909233,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262321,424535051,14909343,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262325,424534241,14909859,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262328,424533431,14910853,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262332,424535069,14926040,27626,1,'2009-04-01 15:42:40',3310490794,2),(52262335,424536083,14926453,27626,1,'2009-04-01 15:42:40',3310490794,2),(52262338,424536908,14927541,27626,1,'2009-04-01 15:42:40',3310490794,2),(52262341,424537997,14928818,27626,1,'2009-04-01 15:42:40',3310490794,2),(52262345,424539085,14930206,27626,1,'2009-04-01 15:42:40',3310490794,2),(52262348,424539949,14931070,27626,1,'2009-04-01 15:42:40',3310490794,2),(52262350,424541150,14931820,27626,1,'2009-04-01 15:42:40',3310490794,2),(52262353,424542125,14932121,27626,1,'2009-04-01 15:42:40',3310490794,2),(52262356,424542463,14931858,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262360,424542501,14931032,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262362,424541638,14930131,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262366,424539686,14927429,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262369,424538447,14925890,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262373,424538222,14925064,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262375,424538410,14924464,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262379,424539123,14924689,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262380,424540211,14925890,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262383,424543289,14927917,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262389,424545766,14930357,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262391,424547380,14932196,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262395,424548093,14932684,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262397,424548619,14932383,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262401,424548656,14931633,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262404,424547793,14930131,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262408,424545879,14925890,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262411,424543289,14922024,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262413,424541975,14920523,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262417,424540962,14919960,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262420,424540436,14919397,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262422,424540249,14918496,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262426,424540774,14918121,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262428,424541562,14918121,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262431,424542613,14918946,27626,1,'2009-04-01 15:42:41',3310490794,2),(52262434,424546254,14921686,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262438,424548581,14923863,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262442,424549782,14925552,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262448,424550195,14925965,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262451,424550646,14925777,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262454,424550871,14925327,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262457,424550571,14924501,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262459,424549707,14923263,27626,1,'2009-04-01 15:42:41',3310490795,2),(52262463,424548168,14920560,27626,1,'2009-04-01 15:42:42',3310490795,2),(52262466,424545766,14916507,27626,1,'2009-04-01 15:42:42',3310490795,2),(52262470,424543439,14913879,27626,1,'2009-04-01 15:42:42',3310490794,2),(52262473,424541638,14912078,27626,1,'2009-04-01 15:42:42',3310490794,2),(52262476,424539648,14911027,27626,1,'2009-04-01 15:42:42',3310490794,2),(52262480,424538447,14910576,27626,1,'2009-04-01 15:42:42',3310490794,2),(52262482,424537809,14910464,27626,1,'2009-04-01 15:42:42',3310490794,2),(52262485,424537772,14909600,372139,1,'2009-04-10 12:07:11',3310490794,8),(52262488,424532187,14912438,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262492,424531358,14913462,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262495,424530010,14914453,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262498,424528613,14915168,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262500,424527541,14916386,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262504,424525737,14919375,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262509,424523625,14922836,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262512,424522638,14924227,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262515,424522017,14925096,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262521,424520601,14926512,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262523,424518962,14927828,372139,1,'2009-04-10 12:07:11',3310490794,7),(52262527,424517745,14928598,372139,1,'2009-04-10 12:07:11',3310490111,7),(52262531,424517223,14929418,372139,1,'2009-04-10 12:07:11',3310490111,7),(52262535,424517099,14931777,372139,1,'2009-04-10 12:07:11',3310490111,7),(52262538,424529836,14923917,439281,1,'2007-09-16 00:39:03',3310490794,1),(52262541,424529051,14923183,439281,1,'2007-09-16 00:39:03',3310490794,1),(52262544,424528494,14923107,439281,1,'2007-09-16 00:39:03',3310490794,1),(52262546,424527861,14923664,439281,1,'2007-09-16 00:39:04',3310490794,1),(52262550,424527406,14924221,439281,1,'2007-09-16 00:39:04',3310490794,1),(52262552,424526292,14925461,439281,1,'2007-09-16 00:39:04',3310490794,1),(52262556,424524494,14926828,439281,1,'2007-09-16 00:39:04',3310490794,1),(52262560,424520267,14928828,439281,1,'2007-09-16 00:39:04',3310490794,1),(52262563,424517710,14929967,439281,1,'2007-09-16 00:39:04',3310490111,1),(52262566,424517172,14930144,372139,1,'2009-04-10 12:07:11',3310490111,7),(52262570,424516983,14933014,372139,1,'2009-04-10 12:07:11',3310490111,7);
INSERT INTO `nodes` VALUES (52262573,424516660,14933705,372139,1,'2009-04-10 12:07:11',3310490111,7),(52262575,424516107,14934074,372139,1,'2009-04-10 12:07:11',3310490111,7),(52262579,424515231,14934028,372139,1,'2009-04-10 12:07:11',3310490111,7),(52262583,424513848,14933844,372139,1,'2009-04-10 12:07:11',3310490111,7),(52262586,424512926,14933337,372139,1,'2009-04-10 12:07:11',3310490111,7),(52262590,424512096,14932322,372139,1,'2009-04-10 12:07:11',3310490111,7),(52262594,424510666,14928173,372139,1,'2009-04-10 12:07:11',3310490111,7),(52262598,424509883,14925406,372139,1,'2009-04-10 12:07:10',3310490111,7),(52262602,424509283,14923377,372139,1,'2009-04-10 12:07:10',3310490111,7),(52262605,424508499,14921579,372139,1,'2009-04-10 12:07:10',3310490111,7),(52262607,424507485,14920150,372139,1,'2009-04-10 12:07:10',3310490111,7),(52262609,424505272,14918674,372139,1,'2009-04-10 12:07:10',3310490111,7),(52262612,424503658,14917706,372139,1,'2009-04-10 12:07:10',3310490111,7),(52262616,424501353,14916738,372139,1,'2009-04-10 12:07:10',3310490111,7),(52262618,424499139,14915862,372139,1,'2009-04-10 12:07:10',3310490111,7),(52262622,424497065,14914525,372139,1,'2009-04-10 12:07:10',3310490111,7),(52262625,424495451,14914110,372139,1,'2009-04-10 12:07:10',3310490111,7),(52262629,424493297,14913864,1165666,1,'2009-05-12 19:44:46',3310490111,8),(52262632,424491967,14913006,1165666,1,'2009-05-12 19:44:46',3310490111,8),(52262636,424490953,14911375,1165666,1,'2009-05-12 19:44:07',3310490111,8),(52262637,424489813,14909229,1165666,1,'2009-05-12 19:44:46',3310490110,8),(52262641,424488927,14908199,1165813,1,'2009-05-12 19:59:07',3310490110,9),(52262644,424487197,14908392,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262646,424484293,14908392,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262650,424481342,14908715,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262654,424480281,14908254,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262659,424479866,14907332,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262661,424479221,14905303,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262664,424478529,14901246,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262666,424477724,14898840,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262671,424476625,14897089,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262675,424475301,14896029,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262678,424473765,14895765,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262684,424470533,14895765,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262688,424467408,14895712,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262691,424464760,14895871,372139,1,'2009-04-10 12:07:10',3310490110,7),(52262695,424462853,14895976,372139,1,'2009-04-10 12:07:10',3310490107,7),(52262698,424461687,14895849,372139,1,'2009-04-10 12:07:10',3310490107,7),(52262700,424460331,14894705,372139,1,'2009-04-10 12:07:10',3310490107,7),(52262703,424459272,14893476,372139,1,'2009-04-10 12:07:10',3310490107,7),(52262706,424458297,14890425,372139,1,'2009-04-10 12:07:10',3310490107,7),(52262710,424456687,14887332,372139,1,'2009-04-10 12:07:10',3310490107,7),(52262713,424455501,14885721,372139,1,'2009-04-10 12:07:10',3310490105,7),(52262718,424454060,14884789,372139,1,'2009-04-10 12:07:10',3310490105,7),(52262723,424452153,14883984,372139,1,'2009-04-10 12:07:10',3310490105,7),(52262725,424449144,14884959,372139,1,'2009-04-10 12:07:09',3310490105,7),(52262727,424446941,14886060,372139,1,'2009-04-10 12:07:09',3310490105,7),(52262729,424445669,14887501,372139,1,'2009-04-10 12:07:09',3310490107,7),(52262732,424444695,14888391,372139,1,'2009-04-10 12:07:09',3310490107,7),(52262736,424442534,14889027,372139,1,'2009-04-10 12:07:09',3310490107,7),(52262738,424439855,14889544,372139,1,'2009-04-10 12:07:09',3310490107,7),(52262742,424437857,14889922,372139,1,'2009-04-10 12:07:09',3310490107,7),(52262746,424435806,14890515,372139,1,'2009-04-10 12:07:09',3310490107,7),(52262748,424434726,14891001,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262752,424433943,14891730,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262757,424433133,14893512,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262760,424432189,14895698,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262764,424431487,14896886,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262768,424430866,14897345,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262773,424430137,14897534,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262776,424429354,14897534,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262781,424427151,14897810,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262784,424425186,14898079,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262788,424422736,14898026,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262792,424419156,14898079,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262796,424417944,14897756,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262798,424416545,14896868,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262802,424415495,14895630,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262805,424414526,14894849,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262809,424413503,14894768,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262814,424412534,14894849,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262817,424410030,14895980,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262821,424407230,14898510,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262824,424404915,14900717,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262826,424401846,14902575,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262830,424399262,14903867,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262833,424396274,14905368,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262836,424394102,14906991,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262838,424393420,14907244,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262842,424392231,14907446,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262845,424391422,14907371,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262848,424390284,14906941,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262850,424388287,14905929,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262854,424386672,14905117,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262858,424384886,14903796,372139,1,'2009-04-10 12:07:09',3310490095,7),(52262862,424383276,14902841,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262866,424381912,14901968,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262869,424381066,14901723,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262874,424380138,14901777,372139,1,'2009-04-10 12:07:08',3310490094,7),(52262878,424379702,14902268,372139,1,'2009-04-10 12:07:08',3310490094,7),(52262883,424379456,14902841,372139,1,'2009-04-10 12:07:08',3310490094,7),(52262884,424379538,14903769,372139,1,'2009-04-10 12:07:08',3310490094,7),(52262887,424380111,14904806,372139,1,'2009-04-10 12:07:08',3310490094,7),(52262889,424381503,14905761,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262892,424382758,14907153,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262893,424383986,14909499,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262896,424386247,14914771,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262898,424387842,14918799,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262901,424388599,14921016,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262903,424389086,14921909,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262905,424389951,14922801,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262908,424392168,14924748,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262910,424417873,14900642,439281,1,'2007-09-16 00:39:26',3310490106,1),(52262913,424415651,14899346,439281,1,'2007-09-16 00:39:26',3310490106,1),(52262916,424414555,14898505,439281,1,'2007-09-16 00:39:26',3310490106,1),(52262919,424413391,14897891,439281,1,'2007-09-16 00:39:26',3310490106,1),(52262921,424412333,14897616,439281,1,'2007-09-16 00:39:27',3310490106,1),(52262925,424410979,14897722,439281,1,'2007-09-16 00:39:27',3310490106,1),(52262930,424410174,14897806,439281,1,'2007-09-16 00:39:28',3310490106,1),(52262934,424409476,14897362,439281,1,'2007-09-16 00:39:28',3310490106,1),(52262938,424409032,14896960,372139,1,'2009-04-10 12:07:09',3310490106,7),(52262941,424411059,14915662,439281,1,'2007-09-16 00:39:29',3310490106,1),(52262944,424408329,14915769,439281,1,'2007-09-16 00:39:29',3310490095,1),(52262946,424405795,14915983,439281,1,'2007-09-16 00:39:29',3310490095,1),(52262949,424402798,14916161,439281,1,'2007-09-16 00:39:29',3310490095,1),(52262954,424399408,14916375,439281,1,'2007-09-16 00:39:30',3310490095,1),(52262957,424396874,14916625,439281,1,'2007-09-16 00:39:30',3310490095,1),(52262961,424395090,14916375,439281,1,'2007-09-16 00:39:30',3310490095,1),(52262963,424392163,14914841,439281,1,'2007-09-16 00:39:31',3310490095,1),(52262967,424384382,14910324,372139,1,'2009-04-10 12:07:08',3310490095,7),(52262970,424406816,14921586,439281,1,'2007-09-16 00:39:31',3310490095,1),(52262973,424404476,14921920,439281,1,'2007-09-16 00:39:31',3310490095,1),(52262977,424401509,14922129,439281,1,'2007-09-16 00:39:32',3310490095,1),(52262979,424398543,14922213,439281,1,'2007-09-16 00:39:32',3310490095,1),(52262981,424396328,14922338,439281,1,'2007-09-16 00:39:32',3310490095,1),(52263076,424394239,14921837,439281,1,'2007-09-16 00:39:41',3310490095,1),(52263079,424391523,14920249,439281,1,'2007-09-16 00:39:41',3310490095,1),(52263083,424387660,14918137,439281,1,'2007-09-16 00:39:41',3310490095,1),(52263086,424387575,14918124,372139,1,'2009-04-10 12:07:08',3310490095,7),(52263090,424384936,14912293,372139,1,'2009-04-10 12:07:08',3310490095,7),(52263091,424376212,14905831,439281,1,'2007-09-16 00:39:41',3310490094,1),(52263095,424379906,14909127,439281,1,'2007-09-16 00:39:42',3310490094,1),(52263098,424384910,14912304,439281,1,'2007-09-16 00:39:42',3310490095,1),(52263100,424374331,14914896,439281,1,'2007-09-16 00:39:42',3310490094,1),(52263106,424378910,14918185,439281,1,'2007-09-16 00:39:42',3310490094,1),(52263109,424379997,14919703,439281,1,'2007-09-16 00:39:42',3310490094,1),(52263111,424381743,14921651,439281,1,'2007-09-16 00:39:42',3310490095,1),(52263113,424384450,14923649,439281,1,'2007-09-16 00:39:43',3310490095,1),(52263117,424386196,14924813,439281,1,'2007-09-16 00:39:43',3310490095,1),(52263119,424387714,14925268,439281,1,'2007-09-16 00:39:43',3310490095,1),(52263122,424393639,14925761,372139,1,'2009-04-10 12:07:08',3310490095,7),(52263124,424395143,14926363,372139,1,'2009-04-10 12:07:08',3310490095,7),(52263126,424396927,14926341,372139,1,'2009-04-10 12:07:08',3310490095,7),(52263130,424399978,14926298,372139,1,'2009-04-10 12:07:08',3310490095,7),(52263133,424403695,14926277,372139,1,'2009-04-10 12:07:08',3310490095,7),(52263136,424405393,14925783,372139,1,'2009-04-10 12:07:08',3310490095,7),(52263140,424407652,14924912,372139,1,'2009-04-10 12:07:08',3310490095,7),(52263142,424409523,14923709,372139,1,'2009-04-10 12:07:08',3310490106,7),(52263144,424411394,14922550,372139,1,'2009-04-10 12:07:08',3310490106,7),(52263149,424413889,14921704,372139,1,'2009-04-10 12:07:08',3310490106,7),(52263152,424416474,14920991,372139,1,'2009-04-10 12:07:08',3310490106,7),(52263155,424419103,14920456,372139,1,'2009-04-10 12:07:08',3310490106,7),(52263158,424422979,14920768,372139,1,'2009-04-10 12:07:08',3310490106,7),(52263162,424375679,14920875,439281,1,'2007-09-16 00:39:46',3310490094,1),(52263166,424377128,14924226,439281,1,'2007-09-16 00:39:46',3310490094,1),(52263168,424378351,14926808,439281,1,'2007-09-16 00:39:46',3310490094,1),(52263171,424380434,14928664,439281,1,'2007-09-16 00:39:47',3310490094,1),(52263173,424384012,14930521,439281,1,'2007-09-16 00:39:47',3310490095,1),(52263177,424386774,14931291,439281,1,'2007-09-16 00:39:47',3310490095,1),(52263180,424389899,14930793,439281,1,'2007-09-16 00:39:47',3310490095,1),(52263183,424394609,14929978,439281,1,'2007-09-16 00:39:47',3310490095,1),(52263186,424397960,14928755,439281,1,'2007-09-16 00:39:48',3310490095,1),(52263190,424400179,14927487,439281,1,'2007-09-16 00:39:48',3310490095,1),(52263191,424400859,14926717,439281,1,'2007-09-16 00:39:48',3310490095,1),(52263195,424401029,14926331,372139,1,'2009-04-10 12:07:08',3310490095,7),(52263200,424425675,14920353,372139,1,'2009-04-10 12:07:08',3310490106,7),(52263203,424428134,14920448,372139,1,'2009-04-10 12:07:08',3310490106,7),(52263208,424430404,14920826,372139,1,'2009-04-10 12:07:08',3310490106,7),(52263209,424433502,14921080,372139,1,'2009-04-10 12:07:08',3310490106,7),(52263213,424435633,14921129,372139,1,'2009-04-10 12:07:08',3310490106,7),(52263217,424438684,14921613,372139,1,'2009-04-10 12:07:08',3310490107,7),(52263220,424441347,14922581,372139,1,'2009-04-10 12:07:08',3310490107,7),(52263224,424442509,14923405,372139,1,'2009-04-10 12:07:08',3310490107,7),(52263227,424444398,14925584,372139,1,'2009-04-10 12:07:08',3310490107,7),(52263231,424445560,14927811,372139,1,'2009-04-10 12:07:08',3310490107,7),(52263233,424446093,14930669,372139,1,'2009-04-10 12:07:08',3310490107,7),(52263234,424446044,14934107,372139,1,'2009-04-10 12:07:08',3310490107,7),(52263411,424446093,14937012,372139,1,'2009-04-10 12:07:08',3310490107,7),(52263414,424446335,14941274,372139,1,'2009-04-10 12:07:08',3310490107,7),(52263416,424447158,14944567,372139,1,'2009-04-10 12:07:08',3310490449,7),(52263498,424450548,14949555,372139,1,'2009-04-10 12:07:08',3310490449,7),(52263502,424454035,14952654,372139,1,'2009-04-10 12:07:08',3310490449,7),(52263504,424458054,14956189,372139,1,'2009-04-10 12:07:08',3310490449,7),(52263506,424460378,14958368,372139,1,'2009-04-10 12:07:07',3310490449,7),(52263507,424461525,14960044,372139,1,'2009-04-10 12:07:07',3310490449,7),(52263509,424462416,14961964,372139,1,'2009-04-10 12:07:07',3310490449,7),(52263512,424463718,14965118,372139,1,'2009-04-10 12:07:07',3310490452,7),(52263513,424464404,14968854,372139,1,'2009-04-10 12:07:07',3310490452,7),(52263516,424464472,14972007,372139,1,'2009-04-10 12:07:07',3310490452,7),(52263519,424464164,14975434,372139,1,'2009-04-10 12:07:07',3310490452,7),(52263520,424464369,14979719,372139,1,'2009-04-10 12:07:07',3310490452,7),(52263524,424465535,14982495,372139,1,'2009-04-10 12:07:07',3310490452,7),(52263527,424467968,14985648,372139,1,'2009-04-10 12:07:07',3310490452,7),(52263530,424469648,14989110,372139,1,'2009-04-10 12:07:07',3310490452,7),(52263533,424470779,14991852,372139,1,'2009-04-10 12:07:07',3310490452,7),(52263537,424471190,14995485,372139,1,'2009-04-10 12:07:07',3310490452,7),(52263541,424470858,14997540,372139,1,'2009-04-10 12:07:07',3310490454,7),(52263543,424469822,15002100,372139,1,'2009-04-10 12:07:07',3310490454,7),(52263546,424446025,14935657,372139,1,'2009-04-10 12:07:08',3310490107,7),(52263549,424453814,14944816,439281,1,'2007-09-16 00:40:18',3310490449,1),(52263553,424460238,14952231,439281,1,'2007-09-16 00:40:19',3310490449,1),(52263554,424464512,14956873,439281,1,'2007-09-16 00:40:19',3310490452,1),(52263556,424466776,14961458,439281,1,'2007-09-16 00:40:19',3310490452,1),(52263559,424467682,14964911,439281,1,'2007-09-16 00:40:19',3310490452,1),(52263560,424469126,14968675,439281,1,'2007-09-16 00:40:19',3310490452,1),(52263563,424470795,14971477,439281,1,'2007-09-16 00:40:19',3310490452,1),(52263566,424472946,14973657,439281,1,'2007-09-16 00:40:19',3310490452,1),(52263570,424474135,14975440,439281,1,'2007-09-16 00:40:19',3310490452,1),(52263573,424476937,14981242,439281,1,'2007-09-16 00:40:20',3310490452,1),(52263575,424479597,14986324,439281,1,'2007-09-16 00:40:20',3310490452,1),(52263577,424467790,14978672,439281,1,'2007-09-16 00:40:20',3310490452,1),(52263579,424469895,14980950,439281,1,'2007-09-16 00:40:20',3310490452,1),(52263581,424471138,14983470,439281,1,'2007-09-16 00:40:21',3310490452,1),(52263584,424472174,14985162,439281,1,'2007-09-16 00:40:21',3310490452,1),(52263586,424474970,14987233,439281,1,'2007-09-16 00:40:21',3310490452,1),(52263588,424475695,14986923,439281,1,'2007-09-16 00:40:21',3310490452,1),(52263593,424473370,14986443,439281,1,'2007-09-16 00:40:22',3310490452,1),(52263595,424475902,14985852,439281,1,'2007-09-16 00:40:22',3310490452,1),(52263598,424475557,14983298,439281,1,'2007-09-16 00:40:22',3310490452,1),(52263602,424474383,14979190,439281,1,'2007-09-16 00:40:22',3310490452,1),(52263605,424473969,14978120,439281,1,'2007-09-16 00:40:22',3310490452,1),(52263608,424472761,14977498,439281,1,'2007-09-16 00:40:23',3310490452,1),(52263611,424471621,14976601,439281,1,'2007-09-16 00:40:23',3310490452,1),(52263615,424470620,14975185,439281,1,'2007-09-16 00:40:23',3310490452,1),(52263617,424469861,14972942,439281,1,'2007-09-16 00:40:23',3310490452,1),(52263618,424469764,14969746,439281,1,'2007-09-16 00:40:24',3310490452,1),(52263621,424464228,14974725,372139,1,'2009-04-10 12:07:07',3310490452,7),(52263623,424481432,14993432,439281,1,'2007-09-16 00:40:24',3310490452,1),(52263625,424480984,14995734,439281,1,'2007-09-16 00:40:24',3310490452,1),(52263628,424479513,14998996,439281,1,'2007-09-16 00:40:24',3310490454,1),(52263629,424478809,15001938,439281,1,'2007-09-16 00:40:24',3310490454,1),(52263632,424478809,15004561,439281,1,'2007-09-16 00:40:24',3310490454,1),(52263634,424478489,15006863,439281,1,'2007-09-16 00:40:25',3310490454,1),(52263637,424477978,15008782,439281,1,'2007-09-16 00:40:25',3310490454,1),(52263639,424477466,15010317,439281,1,'2007-09-16 00:40:25',3310490454,1),(52263641,424477402,15013451,439281,1,'2007-09-16 00:40:26',3310490454,1),(52263644,424477850,15018248,439281,1,'2007-09-16 00:40:26',3310490454,1),(52263646,424478322,15024752,439281,1,'2007-09-16 00:40:26',3310490454,1),(52263649,424479730,15030680,439281,1,'2007-09-16 00:40:26',3310490454,1),(52263650,424481471,15035699,439281,1,'2007-09-16 00:40:26',3310490454,1),(52263652,424483055,15039094,439281,1,'2007-09-16 00:40:26',3310490454,1),(52263655,424483961,15042885,439281,1,'2007-09-16 00:40:27',3310490454,1),(52263657,424484753,15047299,439281,1,'2007-09-16 00:40:27',3310490454,1),(52263660,424485489,15052619,439281,1,'2007-09-16 00:40:27',3310490460,1),(52263662,424486652,15055240,439281,1,'2007-09-16 00:40:27',3310490460,1),(52263665,424487157,15059278,439281,1,'2007-09-16 00:40:27',3310490460,1),(52263667,424486868,15062666,439281,1,'2007-09-16 00:40:27',3310490460,1),(52263669,424486580,15065406,439281,1,'2007-09-16 00:40:28',3310490460,1),(52263670,424479600,15008556,439281,1,'2007-09-16 00:40:28',3310490454,1),(52263672,424479627,15005590,439281,1,'2007-09-16 00:40:28',3310490454,1),(52263674,424479812,15002360,439281,1,'2007-09-16 00:40:29',3310490454,1),(52263677,424493594,15049241,439281,1,'2007-09-16 00:40:29',3310490455,1),(52263678,424481837,15034104,439281,1,'2007-09-16 00:40:29',3310490454,1),(52263681,424479996,15000734,439281,1,'2007-09-16 00:40:29',3310490454,1),(52263683,424480372,14999304,439281,1,'2007-09-16 00:40:29',3310490454,1),(52263686,424480949,14997799,439281,1,'2007-09-16 00:40:29',3310490454,1),(52263687,424481927,14994864,439281,1,'2007-09-16 00:40:29',3310490452,1),(52263688,424482228,14994087,439281,1,'2007-09-16 00:40:30',3310490452,1),(52263691,424482128,14993435,439281,1,'2007-09-16 00:40:30',3310490452,1),(52263693,424481802,14992758,439281,1,'2007-09-16 00:40:30',3310490452,1),(52263696,424481425,14991453,439281,1,'2007-09-16 00:40:30',3310490452,1),(52263698,424479546,15010187,439281,1,'2007-09-16 00:40:30',3310490454,1),(52263700,424479448,15011189,439281,1,'2007-09-16 00:40:30',3310490454,1),(52263702,424479507,15012111,439281,1,'2007-09-16 00:40:31',3310490454,1),(52263704,424479782,15012916,439281,1,'2007-09-16 00:40:31',3310490454,1),(52263706,424480233,15013211,439281,1,'2007-09-16 00:40:31',3310490454,1),(52263708,424480606,15013191,439281,1,'2007-09-16 00:40:31',3310490454,1),(52263711,424481176,15012936,439281,1,'2007-09-16 00:40:31',3310490454,1),(52263712,424481922,15012053,439281,1,'2007-09-16 00:40:31',3310490454,1),(52263713,424482890,15011155,439281,1,'2007-09-16 00:40:31',3310490454,1),(52263716,424483989,15011155,439281,1,'2007-09-16 00:40:32',3310490454,1),(52263717,424486513,15012091,439281,1,'2007-09-16 00:40:32',3310490454,1),(52263718,424490136,15013109,439281,1,'2007-09-16 00:40:32',3310490454,1),(52263721,424490706,15014005,439281,1,'2007-09-16 00:40:32',3310490454,1),(52263722,424491222,15015319,439281,1,'2007-09-16 00:40:32',3310490455,1),(52263724,424492473,15019461,439281,1,'2007-09-16 00:40:33',3310490455,1),(52263726,424494140,15023291,439281,1,'2007-09-16 00:40:33',3310490455,1),(52263727,424480387,15032575,439281,1,'2007-09-16 00:40:33',3310490454,1),(52263730,424468773,15005186,372139,1,'2009-04-10 12:07:07',3310490454,7),(52263731,424467356,15010571,372139,1,'2009-04-10 12:07:07',3310490454,7),(52263732,424466619,15016183,372139,1,'2009-04-10 12:07:07',3310490454,7),(52263734,424466676,15020264,372139,1,'2009-04-10 12:07:07',3310490454,7),(52263736,424466279,15023324,372139,1,'2009-04-10 12:07:07',3310490454,7),(52263738,424465316,15027632,372139,1,'2009-04-10 12:07:07',3310490454,7),(52263739,424464012,15032223,372139,1,'2009-04-10 12:07:07',3310490454,7),(52263742,424463728,15037608,372139,1,'2009-04-10 12:07:07',3310490454,7),(52263743,424462935,15041179,372139,1,'2009-04-10 12:07:07',3310490451,7),(52263744,424460554,15046394,372139,1,'2009-04-10 12:07:07',3310490451,7),(52263746,424458911,15053932,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263747,424458741,15057843,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263749,424459421,15062264,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263750,424460611,15066062,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263754,424462765,15070483,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263755,424464862,15075471,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263757,424466676,15079439,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263760,424468546,15081649,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263762,424470802,15083316,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263763,424472906,15084259,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263765,424475409,15084803,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263766,424477042,15085565,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263767,424477441,15086980,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263769,424477441,15088467,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263771,424476643,15089301,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263772,424475010,15090100,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263774,424473269,15090136,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263775,424470367,15089374,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263777,424466921,15087161,372139,1,'2009-04-10 12:07:07',3310490460,7),(52263779,424461697,15082917,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263781,424456945,15078999,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263782,424453716,15076750,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263784,424450061,15073306,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263785,424447179,15069013,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263787,424445829,15061101,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263788,424445155,15056624,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263790,424443744,15053066,372139,1,'2009-04-10 12:07:07',3310490457,7),(52263792,424443570,15051371,372139,1,'2009-04-10 12:07:07',3310490451,7),(52263793,424443491,15044148,372139,1,'2009-04-10 12:07:07',3310490451,7),(52263794,424442763,15036070,372139,1,'2009-04-10 12:07:07',3310490451,7),(52263795,424441743,15031149,372139,1,'2009-04-10 12:07:07',3310490451,7),(52263796,424440003,15025928,372139,1,'2009-04-10 12:07:07',3310490451,7),(52263797,424437722,15020587,372139,1,'2009-04-10 12:07:07',3310490451,7),(52263798,424434924,15014547,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263800,424433242,15010827,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263802,424432222,15007768,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263803,424431713,15005322,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263806,424430591,15003742,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263808,424428603,15001397,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263811,424425392,14999256,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263813,424423455,14998492,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263815,424420805,14997574,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263817,424417237,14996708,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263818,424414739,14996860,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263820,424412344,14996453,372139,1,'2009-04-10 12:07:06',3310490448,7),(52263823,424409489,14995382,372139,1,'2009-04-10 12:07:06',3310490448,7),(52263825,424408113,14995077,372139,1,'2009-04-10 12:07:06',3310490437,7),(52263827,424406635,14995943,372139,1,'2009-04-10 12:07:06',3310490437,7),(52263829,424406992,14998186,372139,1,'2009-04-10 12:07:06',3310490439,7),(52263832,424408979,15001907,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263835,424411426,15006086,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263837,424414026,15011897,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263839,424415249,15016280,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263843,424416982,15027290,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263846,424418460,15036057,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263849,424418766,15042072,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263850,424418256,15047169,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263852,424418511,15053438,372139,1,'2009-04-10 12:07:06',3310490456,7),(52263854,424414396,15007502,439281,1,'2007-09-16 00:40:45',3310490450,1),(52263857,424417229,15010086,439281,1,'2007-09-16 00:40:46',3310490450,1),(52263858,424418990,15012337,439281,1,'2007-09-16 00:40:47',3310490450,1),(52263860,424420850,15021667,439281,1,'2007-09-16 00:40:47',3310490450,1),(52263863,424423459,15037423,439281,1,'2007-09-16 00:40:47',3310490450,1),(52263865,424427118,15059088,439281,1,'2007-09-16 00:40:47',3310490456,1),(52263868,424411064,15005468,372139,1,'2009-04-10 12:07:06',3310490450,7),(52263870,424417815,14999686,439281,1,'2007-09-16 00:40:47',3310490450,1),(52263873,424416778,14999628,439281,1,'2007-09-16 00:40:47',3310490450,1),(52263875,424416174,15000521,439281,1,'2007-09-16 00:40:47',3310490450,1),(52263876,424415342,15003786,439281,1,'2007-09-16 00:40:47',3310490450,1),(52263877,424420727,15006435,439281,1,'2007-09-16 00:40:48',3310490450,1),(52263882,424419346,15059831,372139,1,'2009-04-10 12:07:06',3310490456,7),(52263883,424420241,15070006,372139,1,'2009-04-10 12:07:06',3310490456,7),(52263887,424421023,15078168,372139,1,'2009-04-10 12:07:06',3310490456,7),(52263888,424421862,15081131,372139,1,'2009-04-10 12:07:06',3310490456,7),(52263891,424423763,15084877,372139,1,'2009-04-10 12:07:06',3310490456,7),(52263893,424424993,15088734,372139,1,'2009-04-10 12:07:06',3310490456,7),(52263896,424427005,15094493,372139,1,'2009-04-10 12:07:06',3310490456,7),(52263898,424428235,15098294,372139,1,'2009-04-10 12:07:06',3310490456,7),(52263901,424431254,15101481,372139,1,'2009-04-10 12:07:06',3310490456,7),(52263903,424436789,15107463,372139,1,'2009-04-10 12:07:06',3310490459,7),(52263906,424440702,15113780,372139,1,'2009-04-10 12:07:06',3310490459,7),(52263908,424443609,15118197,372139,1,'2009-04-10 12:07:06',3310490459,7),(52263910,424446908,15122502,372139,1,'2009-04-10 12:07:06',3310490459,7),(52263913,424450094,15124738,372139,1,'2009-04-10 12:07:06',3310490459,7),(52263914,424454902,15126191,372139,1,'2009-04-10 12:07:06',3310490459,7),(52263917,424458424,15128036,372139,1,'2009-04-10 12:07:06',3310490459,7),(52263919,424461443,15131055,372139,1,'2009-04-10 12:07:06',3310490459,7),(52263921,424462659,15133291,372139,1,'2009-04-10 12:07:06',3310490459,7),(52263924,424465072,15136232,372139,1,'2009-04-10 12:07:06',3310490462,7),(52263926,424467486,15138419,372139,1,'2009-04-10 12:07:06',3310490462,7),(52263929,424470351,15140531,372139,1,'2009-04-10 12:07:05',3310490462,7),(52263932,424473141,15141888,372139,1,'2009-04-10 12:07:05',3310490462,7),(52263935,424476158,15143623,372139,1,'2009-04-10 12:07:05',3310490462,7),(52263937,424478327,15145670,372139,1,'2009-04-10 12:07:05',3310490462,7),(52263938,424480257,15148720,372139,1,'2009-04-10 12:07:05',3310490462,7),(52263941,424483423,15155129,372139,1,'2009-04-10 12:07:05',3310490462,7),(52263944,424485161,15159724,372139,1,'2009-04-10 12:07:05',3310490462,7),(52263945,424486319,15164280,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263947,424486937,15168720,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263948,424486975,15171036,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263950,424486666,15173044,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263951,424485933,15175013,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263952,424484041,15177214,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263954,424483037,15177214,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263955,424482149,15176789,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263957,424481686,15176210,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263959,424481261,15175091,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263961,424480373,15172504,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263962,424478751,15169994,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263964,424475971,15168025,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263965,424473539,15166442,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263968,424471454,15165631,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263969,424469137,15165206,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263972,424466589,15165284,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263973,424463848,15165129,372139,1,'2009-04-10 12:07:05',3310490484,7),(52263975,424461531,15164627,372139,1,'2009-04-10 12:07:05',3310490481,7),(52263977,424457786,15163585,372139,1,'2009-04-10 12:07:05',3310490481,7),(52263978,424453986,15161306,372139,1,'2009-04-10 12:07:05',3310490459,7),(52263979,424450703,15159224,372139,1,'2009-04-10 12:07:05',3310490459,7),(52263981,424448061,15157623,372139,1,'2009-04-10 12:07:05',3310490459,7),(52263982,424444939,15154500,372139,1,'2009-04-10 12:07:05',3310490459,7),(52263984,424442457,15150817,372139,1,'2009-04-10 12:07:04',3310490459,7),(52263985,424440455,15147535,372139,1,'2009-04-10 12:07:04',3310490459,7),(52263986,424439543,15145361,372139,1,'2009-04-10 12:07:04',3310490459,7),(52263987,424438940,15143918,372139,1,'2009-04-10 12:07:04',3310490459,7),(52263989,424438231,15141819,372139,1,'2009-04-10 12:07:04',3310490459,7),(52263990,424437523,15140638,372139,1,'2009-04-10 12:07:04',3310490459,7),(52263992,424436972,15139668,372139,1,'2009-04-10 12:07:04',3310490459,7),(52263993,424436159,15138907,372139,1,'2009-04-10 12:07:04',3310490459,7),(52263994,424435162,15138093,372139,1,'2009-04-10 12:07:04',3310490458,7),(52263996,424433535,15136860,372139,1,'2009-04-10 12:07:04',3310490458,7),(52263997,424431856,15136205,372139,1,'2009-04-10 12:07:04',3310490458,7),(52263999,424430676,15135837,372139,1,'2009-04-10 12:07:04',3310490458,7),(52264003,424429862,15135837,372139,1,'2009-04-10 12:07:04',3310490458,7),(52264006,424429364,15136178,372139,1,'2009-04-10 12:07:04',3310490458,7),(52264009,424429102,15136651,372139,1,'2009-04-10 12:07:04',3310490458,7),(52264013,424429128,15137543,372139,1,'2009-04-10 12:07:04',3310490458,7),(52264015,424429731,15139248,372139,1,'2009-04-10 12:07:04',3310490458,7),(52264018,424430335,15140481,372139,1,'2009-04-10 12:07:04',3310490458,7),(52264020,424431673,15146043,372139,1,'2009-04-10 12:07:04',3310490458,7),(52264022,424432801,15150398,372139,1,'2009-04-10 12:07:04',3310490458,7),(52264034,424434589,15155730,372139,1,'2009-04-10 12:07:04',3310490458,7),(52264041,424435926,15158938,372139,1,'2009-04-10 12:07:04',3310490459,7),(52264051,424440001,15165933,372139,1,'2009-04-10 12:07:04',3310490481,7),(52264067,424442857,15169944,372139,1,'2009-04-10 12:07:04',3310490481,7),(52264068,424446323,15176362,372139,1,'2009-04-10 12:07:04',3310490481,7),(52264070,424448365,15179025,372139,1,'2009-04-10 12:07:04',3310490481,7),(52264090,424450594,15181505,372139,1,'2009-04-10 12:07:04',3310490481,7),(52265016,424453759,15183860,372139,1,'2009-04-10 12:07:04',3310490481,7),(52265020,424456105,15185481,372139,1,'2009-04-10 12:07:04',3310490481,7),(52265022,424458367,15187273,372139,1,'2009-04-10 12:07:03',3310490481,7),(52265024,424462761,15190430,372139,1,'2009-04-10 12:07:03',3310490481,7),(52265025,424463800,15191652,372139,1,'2009-04-10 12:07:03',3310490484,7),(52265026,424464986,15194531,372139,1,'2009-04-10 12:07:03',3310490484,7),(52265028,424465098,15198992,372139,1,'2009-04-10 12:07:03',3310490484,7),(52265029,424465550,15208647,372139,1,'2009-04-10 12:07:03',3310490484,7),(52265031,424466115,15212205,372139,1,'2009-04-10 12:07:03',3310490484,7),(52265032,424466284,15214407,372139,1,'2009-04-10 12:07:03',3310490484,7),(52265034,424466171,15215254,372139,1,'2009-04-10 12:07:03',3310490484,7),(52265035,424465381,15215423,372139,1,'2009-04-10 12:07:03',3310490484,7),(52265037,424464421,15215141,372139,1,'2009-04-10 12:07:03',3310490484,7),(52265038,424464026,15214633,372139,1,'2009-04-10 12:07:03',3310490484,7),(52265039,424463292,15213729,372139,1,'2009-04-10 12:07:03',3310490484,7),(52265042,424462219,15212713,372139,1,'2009-04-10 12:07:03',3310490481,7),(52265045,424460694,15211132,372139,1,'2009-04-10 12:07:03',3310490481,7),(52265046,424458662,15209438,372139,1,'2009-04-10 12:07:03',3310490481,7),(52265047,424456629,15208252,372139,1,'2009-04-10 12:07:03',3310490481,7),(52265050,424453580,15207066,372139,1,'2009-04-10 12:07:03',3310490481,7),(52265051,424451829,15205993,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265054,424449288,15204412,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265056,424447538,15202606,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265058,424445901,15199952,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265060,424444432,15197806,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265062,424443529,15196564,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265063,424442174,15195039,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265066,424440988,15194023,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265067,424439012,15192668,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265070,424437939,15192216,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265080,424437261,15192611,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265083,424436923,15193233,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265086,424437431,15194757,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265087,424439068,15197524,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265090,424440706,15201476,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265091,424441270,15205485,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265093,424441779,15210228,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265098,424443077,15214124,372139,1,'2009-04-10 12:07:02',3310490481,7),(52265123,424445562,15219601,372139,1,'2009-04-10 12:07:02',3310490483,7),(52265126,424447933,15223385,372139,1,'2009-04-10 12:07:02',3310490483,7),(52265659,424449401,15225643,372139,1,'2009-04-10 12:07:02',3310490483,7),(52266609,424451321,15226942,372139,1,'2009-04-10 12:07:02',3310490483,7),(52266636,424453693,15227902,372139,1,'2009-04-10 12:07:02',3310490483,7),(52266649,424456234,15228523,372139,1,'2009-04-10 12:07:02',3310490483,7),(52266660,424457758,15229426,372139,1,'2009-04-10 12:07:02',3310490483,7),(52266744,424458944,15231064,372139,1,'2009-04-10 12:07:02',3310490483,7),(52266751,424459339,15232532,372139,1,'2009-04-10 12:07:02',3310490483,7),(52266753,424459339,15233830,372139,1,'2009-04-10 12:07:02',3310490483,7),(52266755,424458831,15235073,372139,1,'2009-04-10 12:07:02',3310490483,7),(52266758,424457645,15236541,372139,1,'2009-04-10 12:07:02',3310490483,7),(52266907,424455895,15237444,372139,1,'2009-04-10 12:07:02',3310490483,7),(52266920,424454408,15238923,372139,1,'2009-04-10 12:07:01',3310490483,7),(52266924,424453059,15241211,372139,1,'2009-04-10 12:07:01',3310490483,7),(52266938,424452179,15243322,372139,1,'2009-04-10 12:07:01',3310490483,7),(52266950,424451417,15245727,372139,1,'2009-04-10 12:07:01',3310490483,7),(52266951,424450595,15248719,372139,1,'2009-04-10 12:07:01',3310490483,7),(52266970,424450126,15251651,372139,1,'2009-04-10 12:07:01',3310490483,7),(52266974,424450302,15254643,372139,1,'2009-04-10 12:07:01',3310490483,7),(52267141,424450790,15258926,372139,1,'2009-04-10 12:07:01',3310490483,7),(52267772,424451909,15262459,372139,1,'2009-04-10 12:07:01',3310490483,7),(52267852,424453229,15265167,372139,1,'2009-04-10 12:07:01',3310490483,7),(52268007,424454549,15267977,372139,1,'2009-04-10 12:07:01',3310490483,7),(52268011,424455294,15270346,372139,1,'2009-04-10 12:07:01',3310490483,7),(52268014,424456208,15272987,372139,1,'2009-04-10 12:07:01',3310490489,7),(52268039,424456479,15275864,372139,1,'2009-04-10 12:07:01',3310490489,7),(52268116,424456242,15278064,372139,1,'2009-04-10 12:07:01',3310490489,7),(52268118,424455705,15280751,372139,1,'2009-04-10 12:07:01',3310490489,7),(52268120,424454886,15284848,372139,1,'2009-04-10 12:07:01',3310490489,7),(52268128,424453765,15288039,372139,1,'2009-04-10 12:07:01',3310490489,7),(52268133,424452773,15290498,372139,1,'2009-04-10 12:07:01',3310490489,7),(52268137,424451307,15293430,372139,1,'2009-04-10 12:07:01',3310490489,7),(52268141,424450315,15295802,372139,1,'2009-04-10 12:07:01',3310490489,7),(52268147,424449857,15297018,372139,1,'2009-04-10 12:07:01',3310490489,7),(52268151,424448602,15298523,372139,1,'2009-04-10 12:07:01',3310490489,7),(52268156,424447420,15300351,372139,1,'2009-04-10 12:07:01',3310490489,13),(52268160,424446488,15301784,372139,1,'2009-04-10 12:07:01',3310490489,9),(52268163,424446201,15303755,372139,1,'2009-04-10 12:07:01',3310490489,9),(52268166,424446309,15306479,372139,1,'2009-04-10 12:07:01',3310490489,10),(52283089,424446362,15308365,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283094,424446135,15310681,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283101,424445636,15312997,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283115,424445091,15314268,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283304,424444682,15314677,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283821,424444273,15314768,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283839,424443910,15314722,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283841,424443501,15314268,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283844,424443320,15313814,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283852,424443411,15312179,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283856,424443819,15310000,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283862,424444001,15305186,372139,1,'2009-04-10 12:07:01',3310490489,9),(52283881,424444001,15302371,372139,1,'2009-04-10 12:07:01',3310490489,9),(52284228,424444137,15300600,372139,1,'2009-04-10 12:07:01',3310490489,9),(52284281,424444682,15299101,372139,1,'2009-04-10 12:07:01',3310490489,9),(52284345,424445817,15297239,372139,1,'2009-04-10 12:07:01',3310490489,9),(52284351,424446317,15295605,372139,1,'2009-04-10 12:07:01',3310490489,9),(52284354,424446726,15293016,372139,1,'2009-04-10 12:07:01',3310490489,9),(52284371,424446862,15290428,372139,1,'2009-04-10 12:07:00',3310490489,9),(52284375,424446453,15287340,372139,1,'2009-04-10 12:07:00',3310490489,9),(52284383,424445727,15284434,372139,1,'2009-04-10 12:07:00',3310490489,9),(52284388,424445272,15282436,372139,1,'2009-04-10 12:07:00',3310490489,9),(52284408,424444491,15279819,372139,1,'2009-04-10 12:07:00',3310490489,9),(52284434,424443570,15278062,372139,1,'2009-04-10 12:07:00',3310490489,9),(52284446,424442231,15275634,372139,1,'2009-04-10 12:07:00',3310490489,9),(52284467,424440390,15272914,372139,1,'2009-04-10 12:07:00',3310490489,9),(52284474,424437586,15268771,372139,1,'2009-04-10 12:07:00',3310490483,9),(52284478,424435996,15265967,372139,1,'2009-04-10 12:07:00',3310490483,9),(52284484,424434615,15263289,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284488,424433945,15260527,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284491,424433150,15256216,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284492,424432146,15250859,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284494,424431309,15248223,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284498,424430472,15245628,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284506,424428756,15241234,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284509,424427668,15238556,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284511,424426077,15234747,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284514,424424361,15230855,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284516,424422939,15228344,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284519,424421641,15226043,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284528,424420679,15224871,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284730,424419967,15224703,372139,1,'2009-04-10 12:07:00',3310490482,9),(52284787,424419674,15225080,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284790,424419591,15225624,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284796,424420135,15227131,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284798,424420930,15230186,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284802,424422269,15237467,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284806,424423022,15241862,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284810,424423985,15249060,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284813,424424194,15251362,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284816,424424110,15253705,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284821,424423901,15257765,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284823,424423817,15260987,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284826,424424069,15265423,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284832,424424696,15269315,372139,1,'2009-04-10 12:06:59',3310490482,9),(52284836,424425408,15273458,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284838,424426412,15279443,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284840,424427124,15283544,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284842,424427793,15286725,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284845,424428505,15289319,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284849,424428588,15292039,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284852,424428630,15294132,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284857,424428291,15295899,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284863,424427747,15298209,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284867,424426479,15301967,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284871,424425030,15305047,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284876,424424215,15308443,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284881,424423943,15311296,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284886,424424577,15313741,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284889,424425438,15316277,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284894,424426117,15318270,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284901,424426460,15320276,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284906,424426460,15320926,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284910,424426252,15321946,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284916,424425927,15322688,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284919,424425463,15322989,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284922,424425093,15322989,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284929,424424861,15322896,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284933,424424536,15322131,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284936,424424559,15321088,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284939,424424466,15319998,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284942,424423840,15318769,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284949,424423006,15317564,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284953,424422287,15316381,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284957,424421707,15315060,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284960,424421151,15313599,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284966,424420641,15311930,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284971,424420223,15310492,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284974,424419992,15308730,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284979,424419992,15307501,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284983,424420618,15305623,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284986,424421406,15303073,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284990,424421754,15301218,372139,1,'2009-04-10 12:06:59',3310490488,9),(52284996,424421661,15298853,372139,1,'2009-04-10 12:06:59',3310490488,9),(52285000,424421383,15297183,372139,1,'2009-04-10 12:06:58',3310490488,9),(52285005,424420803,15294795,372139,1,'2009-04-10 12:06:58',3310490488,9),(52285012,424420154,15293079,372139,1,'2009-04-10 12:06:58',3310490488,9),(52285017,424419458,15291503,372139,1,'2009-04-10 12:06:58',3310490488,9),(52286408,424418763,15289648,372139,1,'2009-04-10 12:06:58',3310490488,9),(52286411,424418160,15288187,372139,1,'2009-04-10 12:06:58',3310490488,9),(52286415,424417441,15286657,372139,1,'2009-04-10 12:06:58',3310490488,9),(52286419,424416212,15284988,372139,1,'2009-04-10 12:06:58',3310490488,9),(52286422,424414714,15282987,372139,1,'2009-04-10 12:06:58',3310490488,9),(52286430,424413113,15280602,372139,1,'2009-04-10 12:06:58',3310490488,9),(52286433,424411159,15277355,372139,1,'2009-04-10 12:06:58',3310490488,9),(52286438,424410454,15275813,372139,1,'2009-04-10 12:06:58',3310490488,9),(52286440,424409983,15273408,372139,1,'2009-04-10 12:06:58',3310490488,9),(52286441,424409382,15271187,372139,1,'2009-04-10 12:06:58',3310490482,9),(52286445,424408703,15269018,372139,1,'2009-04-10 12:06:58',3310490482,9),(52286448,424407892,15266718,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286451,424407030,15264444,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286456,424405985,15261909,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286458,424404880,15259716,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286462,424404283,15257657,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286465,424403471,15254731,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286468,424402462,15252593,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286470,424401352,15250485,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286473,424399604,15247932,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286476,424397995,15245463,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286479,424396302,15242938,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286483,424394998,15240551,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286485,424393833,15238248,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286488,424392612,15235696,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286490,424391641,15233698,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286493,424390697,15231284,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286496,424389726,15227899,372139,1,'2009-04-10 12:06:58',3310490471,9),(52286497,424388644,15223654,372139,1,'2009-04-10 12:06:57',3310490471,9),(52286500,424387728,15220768,372139,1,'2009-04-10 12:06:57',3310490471,9),(52286502,424386500,15217787,372139,1,'2009-04-10 12:06:57',3310490471,9),(52286504,424385261,15215190,372139,1,'2009-04-10 12:06:57',3310490469,9),(52286505,424383943,15212473,372139,1,'2009-04-10 12:06:57',3310490469,9),(52286520,424382744,15210395,372139,1,'2009-04-10 12:06:57',3310490469,9),(52286521,424380626,15208038,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286524,424378986,15206131,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286527,424377697,15204658,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286528,424375427,15202244,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286531,424374138,15200628,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286534,424373197,15199769,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286537,424372501,15199114,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286538,424371928,15198948,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286541,424371474,15199245,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286542,424371560,15200178,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286545,424372195,15201753,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286547,424372665,15203717,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286549,424373165,15205704,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286552,424373542,15208027,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286554,424373728,15210232,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286556,424373858,15212995,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286560,424373884,15217035,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286561,424373702,15224515,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286564,424373702,15228841,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286566,424373702,15231291,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286568,424373493,15232333,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286574,424373311,15233089,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286577,424372738,15233350,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286579,424372164,15233298,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286581,424371721,15232881,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286582,424371174,15232177,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286585,424369454,15230431,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286588,424368098,15228815,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286590,424366795,15226574,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286593,424364887,15223290,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286596,424364026,15221224,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286599,424363223,15219044,372139,1,'2009-04-10 12:06:57',3310490470,9),(52286604,424362248,15215315,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286605,424361444,15211700,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286608,424360848,15207328,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286610,424360618,15204207,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286612,424360205,15201085,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286613,424359930,15197551,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286615,424359608,15196036,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286617,424359195,15194889,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286619,424358580,15194466,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286623,424358029,15194797,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286625,424357625,15195568,372139,1,'2009-04-10 12:06:57',3310490468,9),(52286636,424451134,15311742,27626,1,'2009-04-01 16:02:27',3310490489,5),(52286640,424449669,15309750,27626,1,'2009-04-01 16:02:27',3310490489,5),(52286643,424448426,15307522,27626,1,'2009-04-01 16:02:27',3310490489,5),(52286651,424452496,15313549,27626,1,'2009-04-01 16:02:27',3310490489,5),(52286652,424453205,15314793,27626,1,'2009-04-01 16:02:27',3310490489,5),(52286655,424453637,15315916,27626,1,'2009-04-01 16:02:27',3310490489,5),(52286658,424453827,15316780,27626,1,'2009-04-01 16:02:27',3310490489,5),(52286661,424453844,15317730,27626,1,'2009-04-01 16:02:27',3310490489,5),(52286663,424453620,15318750,27626,1,'2009-04-01 16:02:28',3310490489,5),(52286665,424453153,15319355,27626,1,'2009-04-01 16:02:28',3310490489,5),(52286667,424452220,15320374,27626,1,'2009-04-01 16:02:28',3310490489,5),(52286668,424449979,15322625,27626,1,'2009-04-01 16:02:28',3310490489,5),(52286671,424448409,15324095,27626,1,'2009-04-01 16:02:28',3310490489,5),(52286674,424447209,15325245,27626,1,'2009-04-01 16:02:28',3310490489,5),(52286677,424445839,15326783,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286679,424444825,15328593,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286681,424443997,15329996,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286683,424442762,15331839,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286685,424441883,15333259,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286688,424439635,15336700,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286691,424438320,15339008,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286694,424436801,15343215,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286697,424436216,15345581,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286698,424435632,15347276,27626,1,'2009-04-01 16:02:28',3310490490,5),(52286701,424435428,15348415,27626,1,'2009-04-01 16:02:28',3310490490,5),(52286702,424435661,15349467,27626,1,'2009-04-01 16:02:28',3310490490,5),(52286705,424436275,15350314,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286706,424437064,15350431,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286709,424438028,15350460,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286712,424439109,15350986,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286715,424440307,15351424,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286719,424441271,15351337,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286721,424442527,15351103,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286723,424444221,15350314,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286725,424446763,15349000,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286728,424448487,15348240,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286730,424450532,15348065,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286733,424452782,15348386,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286735,424454534,15348883,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286740,424456287,15349233,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286743,424457193,15349438,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286746,424458479,15349467,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286750,424459472,15349116,27626,1,'2009-04-01 16:02:28',3310490491,5),(52286751,424460757,15347948,27626,1,'2009-04-01 16:02:29',3310490491,5),(52286754,424462335,15346662,27626,1,'2009-04-01 16:02:29',3310490491,5),(52286757,424464000,15345494,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286759,424465506,15344856,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286763,424467677,15344133,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286765,424469446,15343570,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286769,424470756,15343540,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286770,424471810,15343729,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286772,424472379,15344214,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286774,424472758,15345057,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286776,424472969,15346216,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286777,424473622,15349061,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286779,424474086,15350263,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286781,424474592,15351127,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286783,424475393,15351654,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286785,424476152,15351675,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286787,424477142,15351148,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286789,424478048,15350410,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286792,424479271,15349356,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286793,424480346,15348197,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286795,424481315,15346722,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286798,424482053,15345268,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286802,424482812,15343561,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286807,424483338,15341896,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286809,424483633,15340315,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286812,424483507,15337786,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286814,424483149,15336121,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286817,424482896,15334625,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286820,424482727,15332728,27626,1,'2009-04-01 16:02:29',3310490494,5),(52286823,424482664,15330978,27626,1,'2009-04-01 16:02:30',3310490494,5),(52286825,424483170,15329777,27626,1,'2009-04-01 16:02:30',3310490494,5),(52286826,424484118,15328660,27626,1,'2009-04-01 16:02:30',3310490494,5),(52286829,424484877,15327269,27626,1,'2009-04-01 16:02:30',3310490494,5),(52286831,424485446,15325899,27626,1,'2009-04-01 16:02:30',3310490492,5),(52286835,424486205,15324803,27626,1,'2009-04-01 16:02:30',3310490492,5),(52286836,424487490,15323749,27626,1,'2009-04-01 16:02:30',3310490492,5),(52286838,424490146,15322527,27626,1,'2009-04-01 16:02:30',3310490492,5),(52286841,424491895,15322000,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286845,424493392,15321473,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286847,424494108,15320757,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286850,424494993,15319450,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286853,424495373,15318206,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286855,424495288,15317089,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286856,424495099,15315825,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286860,424494972,15314687,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286861,424495057,15313043,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286865,424495583,15311821,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286867,424496207,15310662,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286868,424496661,15309270,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286871,424496812,15307968,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286874,424497569,15306697,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286876,424499022,15306092,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286880,424500565,15306183,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286883,424501988,15306818,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286885,424503259,15307968,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286889,424504530,15309542,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286892,424505771,15311570,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286895,424506830,15314143,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286896,424507890,15316322,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286899,424509433,15318955,27626,1,'2009-04-01 16:02:30',3310490493,5),(52286902,424510765,15320559,27626,1,'2009-04-01 16:02:31',3310490493,5),(52286904,424512278,15322133,27626,1,'2009-04-01 16:02:31',3310490493,5),(52286906,424513973,15323101,27626,1,'2009-04-01 16:02:31',3310490493,5),(52286908,424515940,15323192,27626,1,'2009-04-01 16:02:31',3310490493,5),(52286910,424518180,15323404,27626,1,'2009-04-01 16:02:31',3310490493,5),(52286912,424521418,15324191,27626,1,'2009-04-01 16:02:31',3310491176,5),(52286914,424523779,15325462,27626,1,'2009-04-01 16:02:31',3310491176,5),(52286917,424525980,15326951,27626,1,'2009-04-01 16:02:31',3310491178,5),(52286920,424527863,15328363,27626,1,'2009-04-01 16:02:31',3310491178,5),(52286923,424529484,15329147,27626,1,'2009-04-01 16:02:31',3310491178,5),(52286924,424532099,15329670,27626,1,'2009-04-01 16:02:31',3310491178,5),(52286926,424533982,15330298,27626,1,'2009-04-01 16:02:31',3310491178,5),(52286929,424535708,15330978,27626,1,'2009-04-01 16:02:31',3310491178,5),(52286932,424537591,15331449,27626,1,'2009-04-01 16:02:31',3310491178,5),(52286935,424539212,15332181,27626,1,'2009-04-01 16:02:31',3310491178,5),(52286936,424541385,15333517,27626,1,'2009-04-01 16:02:31',3310491178,5),(52286938,424542691,15334589,27626,1,'2009-04-01 16:02:31',3310491178,5),(52286941,424544532,15336128,27626,1,'2009-04-01 16:02:31',3310491178,5),(52286944,424546406,15339074,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286947,424542021,15326154,439281,1,'2007-09-16 01:39:15',3310491176,1),(52286950,424541988,15327325,439281,1,'2007-09-16 01:39:16',3310491178,1),(52286951,424542523,15328631,439281,1,'2007-09-16 01:39:16',3310491178,1),(52286954,424543260,15329936,439281,1,'2007-09-16 01:39:17',3310491178,1),(52286967,424544431,15331275,439281,1,'2007-09-16 01:39:18',3310491178,1),(52286970,424545636,15332246,439281,1,'2007-09-16 01:39:19',3310491178,1),(52286971,424546406,15333015,439281,1,'2007-09-16 01:39:19',3310491179,1),(52286973,424547009,15334622,439281,1,'2007-09-16 01:39:19',3310491179,1),(52286974,424547578,15337434,439281,1,'2007-09-16 01:39:19',3310491179,1),(52286975,424548850,15343492,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286977,424550089,15345890,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286979,424550915,15346954,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286981,424552217,15347581,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286982,424553084,15347147,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286983,424553759,15346472,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286986,424555446,15344255,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286987,424557952,15339580,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286990,424558916,15337411,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286991,424560170,15333651,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286994,424560844,15330181,27626,1,'2009-04-01 16:02:31',3310491179,5),(52286997,424561085,15326373,27626,1,'2009-04-01 16:02:31',3310491179,5),(52287000,424561621,15323304,27626,1,'2009-04-01 16:02:31',3310491177,5),(52287003,424562187,15321465,27626,1,'2009-04-01 16:02:31',3310491177,5),(52287005,424562564,15319815,27626,1,'2009-04-01 16:02:31',3310491177,5),(52287008,424562687,15318277,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287010,424562564,15316560,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287013,424562480,15314995,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287015,424562366,15312920,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287018,424562480,15309939,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287019,424562630,15307411,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287022,424562630,15305186,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287024,424563045,15303148,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287027,424563649,15300960,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287029,424564328,15298847,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287030,424565309,15297036,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287033,424566101,15295829,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287034,424567309,15295225,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287037,424568893,15295188,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287040,424571836,15295980,27626,1,'2009-04-01 16:02:32',3310491177,5),(52287043,424573798,15296584,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287045,424575722,15297451,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287048,424576703,15297829,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287051,424577646,15297715,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287053,424578438,15297112,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287056,424579759,15294999,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287059,424532354,15325774,439281,1,'2007-09-16 01:39:26',3310491176,1),(52287062,424537860,15331343,439281,1,'2007-09-16 01:39:26',3310491178,1),(52287063,424535231,15328748,439281,1,'2007-09-16 01:39:26',3310491178,1),(52287066,424580473,15293844,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287068,424581425,15293042,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287071,424582728,15292040,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287074,424584331,15291188,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287076,424585133,15290415,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287078,424585484,15289735,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287082,424585484,15288883,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287084,424585283,15287681,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287085,424584932,15285376,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287089,424584441,15283676,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287092,424583830,15282069,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287095,424583119,15280762,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287098,424582189,15279415,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287101,424581836,15278004,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287103,424581868,15276786,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287106,424582253,15275086,27626,1,'2009-04-01 16:02:32',3310491180,5);
INSERT INTO `nodes` VALUES (52287110,424582839,15273882,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287111,424583304,15272878,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287114,424583377,15271702,27626,1,'2009-04-01 16:02:32',3310491180,5),(52287116,424583133,15270625,27626,1,'2009-04-01 16:02:32',3310491174,5),(52287117,424582447,15268910,27626,1,'2009-04-01 16:02:32',3310491174,5),(52287119,424581878,15267355,27626,1,'2009-04-01 16:02:32',3310491174,5),(52287120,424581384,15266121,27626,1,'2009-04-01 16:02:32',3310491174,5),(52287123,424580678,15264992,27626,1,'2009-04-01 16:02:32',3310491174,5),(52287127,424579091,15260619,27626,1,'2009-04-01 16:02:32',3310491174,5),(52287129,424578280,15258679,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287132,424577786,15257127,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287135,424577317,15255207,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287138,424576504,15253682,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287140,424575691,15252021,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287142,424575047,15250632,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287144,424574471,15249277,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287147,424573548,15247350,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287150,424572768,15245580,27626,1,'2009-04-01 16:02:33',3310491171,5),(52287153,424572403,15244617,27626,1,'2009-04-01 16:02:33',3310491171,5),(52287156,424572403,15243732,27626,1,'2009-04-01 16:02:33',3310491171,5),(52287159,424572585,15243056,27626,1,'2009-04-01 16:02:33',3310491171,5),(52287160,424573054,15242171,27626,1,'2009-04-01 16:02:33',3310491171,5),(52287163,424573939,15241052,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287165,424574902,15240115,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287167,424575448,15239543,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287170,424576255,15238346,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287173,424576879,15237513,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287174,424577842,15236914,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287177,424578727,15236524,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287181,424579664,15236134,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287183,424580288,15235561,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287186,424580731,15234884,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287188,424581303,15233765,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287191,424581720,15232360,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287192,424582006,15231267,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287193,424582787,15230278,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287194,424583906,15229133,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287196,424584791,15227416,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287198,424585181,15225308,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287200,424585493,15223018,27626,1,'2009-04-01 16:02:33',3310491174,5),(52287202,424585884,15221508,27626,1,'2009-04-01 16:02:34',3310491174,5),(52287205,424586456,15219556,27626,1,'2009-04-01 16:02:34',3310491174,5),(52287208,424586963,15217270,27626,1,'2009-04-01 16:02:34',3310491174,5),(52287210,424587218,15215636,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287212,424587324,15214087,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287216,424587260,15212687,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287217,424587069,15211095,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287220,424586581,15209376,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287223,424585732,15206894,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287225,424584799,15204156,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287228,424584141,15201907,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287231,424583271,15198873,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287234,424582613,15196305,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287238,424582167,15194608,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287239,424582061,15193441,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287243,424582167,15192613,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287244,424582613,15191934,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287247,424583101,15191934,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287251,424583462,15192104,27626,1,'2009-04-01 16:02:34',3310491172,5),(52287254,424583759,15192634,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287255,424583907,15193420,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287257,424584247,15194862,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287260,424584565,15196963,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287262,424585181,15198873,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287265,424585754,15200507,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287268,424587281,15203032,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287271,424588576,15205026,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287274,424590188,15207382,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287276,424591398,15208910,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287278,424593477,15210713,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287283,424597466,15212962,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287286,424599801,15214172,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287289,424603302,15215487,27626,1,'2009-04-01 16:02:35',3310491173,5),(52287292,424606421,15216400,27626,1,'2009-04-01 16:02:35',3310491175,5),(52287295,424609158,15216888,27626,1,'2009-04-01 16:02:35',3310491175,5),(52287299,424610559,15217121,27626,1,'2009-04-01 16:02:35',3310491175,5),(52287301,424611959,15217164,27626,1,'2009-04-01 16:02:35',3310491175,5),(52287305,424612850,15216867,27626,1,'2009-04-01 16:02:35',3310491175,5),(52287308,424613317,15216527,27626,1,'2009-04-01 16:02:35',3310491175,5),(52287311,424613317,15215742,27626,1,'2009-04-01 16:02:35',3310491173,5),(52287315,424613169,15215106,27626,1,'2009-04-01 16:02:35',3310491173,5),(52287317,424612681,15214893,27626,1,'2009-04-01 16:02:35',3310491173,5),(52287320,424611768,15214745,27626,1,'2009-04-01 16:02:35',3310491173,5),(52287323,424610410,15214830,27626,1,'2009-04-01 16:02:35',3310491173,5),(52287326,424608582,15214494,27626,1,'2009-04-01 16:02:35',3310491173,5),(52287329,424606512,15213776,27626,1,'2009-04-01 16:02:35',3310491173,5),(52287331,424604062,15212339,27626,1,'2009-04-01 16:02:35',3310491173,5),(52287335,424601865,15210903,27626,1,'2009-04-01 16:02:35',3310491173,5),(52287354,424600007,15209721,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287357,424598233,15208411,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287360,424596839,15206637,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287362,424596163,15205539,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287364,424595487,15203258,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287369,424594980,15201822,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287371,424594304,15200512,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287373,424593586,15199583,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287378,424592657,15197893,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287380,424591728,15195232,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287384,424591010,15191735,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287387,424590469,15188356,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287392,424590165,15186058,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287393,424589827,15183929,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287395,424589354,15181800,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287399,424588712,15179840,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287400,424588070,15177846,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287403,424587394,15175751,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287408,424586313,15172946,27626,1,'2009-04-01 16:02:35',3310491172,5),(52287411,424585333,15170175,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287414,424584522,15168283,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287417,424583880,15166627,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287422,424583238,15165850,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287426,424582528,15164836,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287428,424582359,15164194,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287430,424582596,15163552,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287433,424583069,15163383,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287436,424583542,15163586,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287441,424584285,15164296,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287443,424585366,15166222,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287444,424588036,15170513,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287447,424591415,15176900,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287449,424594490,15182543,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287453,424597126,15187578,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287457,424598985,15190620,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287459,424601553,15193424,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287462,424603614,15195688,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287464,424604662,15196635,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287467,424605642,15197243,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287470,424606385,15197344,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287473,424606858,15197175,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287477,424607095,15196736,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287480,424607196,15196026,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287483,424606926,15195249,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287486,424606520,15194742,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287489,424605608,15194337,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287492,424604898,15194033,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287495,424604020,15193593,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287499,424603310,15192951,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287501,424602634,15191971,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287504,424601688,15190113,27626,1,'2009-04-01 16:02:36',3310491173,5),(52287506,424600303,15187916,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287509,424598985,15184943,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287511,424597734,15181631,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287512,424596383,15177745,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287515,424594220,15171088,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287517,424592733,15166492,27626,1,'2009-04-01 16:02:36',3310491172,5),(52287519,424590908,15159903,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287522,424590266,15156963,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287524,424589422,15153415,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287527,424588408,15147129,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287528,424587698,15141385,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287532,424587394,15139053,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287534,424586980,15136073,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287536,424586514,15134015,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287538,424585893,15131647,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287542,424585117,15129395,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287544,424584379,15128037,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287548,424583409,15126018,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287551,424582554,15124659,27626,1,'2009-04-01 16:02:36',3310491150,5),(52287552,424581856,15123611,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287555,424580885,15122835,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287560,424579565,15122252,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287562,424578711,15121476,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287565,424578478,15120389,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287568,424578672,15119574,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287570,424579255,15119030,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287572,424580381,15119147,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287575,424581662,15120078,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287578,424585117,15123572,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287580,424586980,15126018,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287583,424588727,15128968,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287584,424590396,15132462,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287588,424591600,15135607,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287591,424593735,15141702,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287592,424595288,15145700,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287594,424596763,15148690,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287600,424598044,15151795,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287603,424599092,15154785,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287605,424599791,15157114,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287608,424600335,15158046,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287609,424601732,15158550,27626,1,'2009-04-01 16:02:37',3310491151,5),(52287612,424602082,15158084,27626,1,'2009-04-01 16:02:37',3310491151,5),(52287616,424601965,15157269,27626,1,'2009-04-01 16:02:37',3310491151,5),(52287619,424601771,15156299,27626,1,'2009-04-01 16:02:37',3310491151,5),(52287622,424601019,15158678,27626,1,'2009-04-01 16:02:37',3310491151,5),(52287624,424600917,15154280,27626,1,'2009-04-01 16:02:37',3310491151,5),(52287627,424600102,15151757,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287629,424598743,15148185,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287631,424597695,15142828,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287633,424596918,15138674,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287634,424595909,15131414,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287636,424595404,15128503,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287638,424594706,15125824,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287640,424594084,15123456,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287642,424592532,15119457,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287643,424590552,15114643,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287644,424589503,15111848,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287645,424587562,15108393,27626,1,'2009-04-01 16:02:37',3310491150,5),(52287648,424585815,15104860,27626,1,'2009-04-01 16:02:37',3310491148,5),(52287649,424584379,15101949,27626,1,'2009-04-01 16:02:37',3310491148,5),(52287651,424583253,15100202,27626,1,'2009-04-01 16:02:37',3310491148,5),(52287653,424581895,15097756,27626,1,'2009-04-01 16:02:37',3310491148,5),(52287654,424580846,15095466,27626,1,'2009-04-01 16:02:37',3310491148,5),(52288116,424580031,15093952,27626,1,'2009-04-01 16:02:37',3310491148,5),(52288118,424579565,15092632,27626,1,'2009-04-01 16:02:37',3310491148,5),(52288119,424579643,15091428,27626,1,'2009-04-01 16:02:37',3310491148,5),(52288121,424580109,15090768,27626,1,'2009-04-01 16:02:37',3310491148,5),(52288122,424580730,15090419,27626,1,'2009-04-01 16:02:37',3310491148,5),(52288125,424581506,15090924,27626,1,'2009-04-01 16:02:37',3310491148,5),(52288128,424582089,15091972,27626,1,'2009-04-01 16:02:37',3310491148,5),(52288131,424582982,15094029,27626,1,'2009-04-01 16:02:37',3310491148,5),(52288133,424586825,15100590,27626,1,'2009-04-01 16:02:37',3310491148,5),(52288136,424590008,15105831,27626,1,'2009-04-01 16:02:37',3310491148,5),(52288137,424594007,15112392,27626,1,'2009-04-01 16:02:37',3310491150,5),(52288139,424597928,15118642,27626,1,'2009-04-01 16:02:37',3310491150,5),(52288141,424602314,15124776,27626,1,'2009-04-01 16:02:37',3310491151,5),(52288142,424604916,15128192,27626,1,'2009-04-01 16:02:37',3310491151,5),(52288145,424607206,15130948,27626,1,'2009-04-01 16:02:37',3310491151,5),(52288146,424607866,15132074,27626,1,'2009-04-01 16:02:37',3310491151,5),(52288150,424608177,15135490,27626,1,'2009-04-01 16:02:37',3310491151,5),(52288153,424608177,15136422,27626,1,'2009-04-01 16:02:37',3310491151,5),(52288155,424608914,15138868,27626,1,'2009-04-01 16:02:37',3310491151,5),(52288157,424609535,15139877,27626,1,'2009-04-01 16:02:37',3310491151,5),(52288161,424610234,15140110,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288163,424610661,15139761,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288165,424610739,15139140,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288167,424610661,15138208,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288170,424610389,15136500,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288173,424610079,15133316,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288175,424610040,15131453,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288178,424609496,15129939,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288179,424607982,15127105,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288181,424607012,15125048,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288183,424605129,15120978,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288184,424603363,15116857,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288185,424601650,15113164,27626,1,'2009-04-01 16:02:38',3310491151,5),(52288188,424598546,15106581,27626,1,'2009-04-01 16:02:38',3310491150,5),(52288190,424596619,15100266,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288194,424595335,15093630,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288196,424594960,15088813,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288199,424594104,15082605,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288203,424593650,15075221,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288204,424593894,15072470,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288207,424594068,15070207,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288210,424594103,15067109,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288211,424593929,15065194,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288215,424593093,15063070,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288216,424592257,15060599,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288218,424590517,15055481,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288221,424589584,15052245,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288223,424588732,15049437,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288225,424588130,15045828,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288227,424587879,15043471,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288231,424587578,15040463,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288233,424587328,15037506,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288235,424586826,15034899,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288238,424586175,15032492,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288241,424585974,15031540,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288244,424586175,15031089,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288248,424586826,15030888,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288251,424587378,15031239,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288253,424587929,15032492,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288256,424588531,15035049,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288258,424589133,15038358,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288261,424589684,15040865,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288265,424591088,15045276,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288266,424594146,15051092,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288269,424592428,15048320,27626,1,'2009-04-01 16:02:38',3310491142,5),(52288273,424595963,15053675,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288275,424597582,15055490,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288277,424598857,15057108,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288281,424600182,15058923,27626,1,'2009-04-01 16:02:38',3310491148,5),(52288284,424600721,15059855,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288285,424601163,15061032,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288287,424601801,15063877,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288289,424602585,15066477,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288291,424603370,15068783,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288293,424605430,15072658,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288297,424607147,15075503,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288298,424609122,15079292,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288301,424611529,15083735,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288304,424613357,15086443,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288307,424614931,15088179,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288310,424615764,15088966,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288313,424617084,15089568,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288317,424618380,15090147,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288319,424619421,15090841,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288321,424620486,15092531,27626,1,'2009-04-01 16:02:38',3310491149,5),(52288325,424621505,15094521,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288327,424622245,15096373,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288330,424622708,15096743,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288331,424623379,15097044,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288335,424624051,15096928,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288337,424624421,15096581,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288339,424625023,15095401,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288341,424625717,15093387,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288343,424625995,15091883,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288345,424626203,15090563,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288348,424626203,15088874,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288350,424626111,15086235,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288353,424625507,15081530,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288357,424624867,15078730,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288360,424624107,15075571,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288361,424622507,15070331,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288365,424621067,15066372,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288368,424619708,15062772,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288371,424618668,15060332,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288375,424617428,15058573,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288377,424615705,15057066,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288381,424614694,15055859,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288383,424614107,15054327,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288387,424613911,15051718,27626,1,'2009-04-01 16:02:39',3310491149,5),(52288388,424613878,15049468,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288390,424613781,15046957,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288393,424613552,15045783,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288395,424612672,15044380,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288398,424611596,15042945,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288400,424609737,15040402,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288403,424609150,15039456,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288406,424607878,15037728,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288407,424606900,15035967,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288412,424606090,15033789,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288413,424605437,15030974,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288415,424604539,15027752,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288417,424603928,15025141,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288419,424603234,15022163,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288423,424602296,15017920,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288426,424601521,15014330,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288429,424601521,15010332,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288434,424601602,15006660,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288435,424601888,15003030,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288439,424602173,14999236,27626,1,'2009-04-01 16:02:39',3310491143,5),(52288442,424602785,14996421,27626,1,'2009-04-01 16:02:39',3310491141,5),(52288444,424603724,14992137,27626,1,'2009-04-01 16:02:39',3310491141,5),(52288448,424604703,14988343,27626,1,'2009-04-01 16:02:39',3310491141,5),(52288450,424605315,14985814,27626,1,'2009-04-01 16:02:39',3310491141,5),(52288453,424605192,14983448,27626,1,'2009-04-01 16:02:39',3310491141,5),(52288455,424604580,14979858,27626,1,'2009-04-01 16:02:39',3310491141,5),(52288458,424603275,14975738,27626,1,'2009-04-01 16:02:39',3310491141,5),(52288460,424601398,14971740,27626,1,'2009-04-01 16:02:39',3310491141,5),(52288461,424599481,14968803,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288465,424598053,14966844,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288466,424596176,14964764,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288469,424594545,14963418,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288471,424592790,14962194,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288474,424591689,14961582,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288478,424591199,14960766,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288479,424591403,14959216,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288482,424592179,14958849,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288484,424593402,14959619,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288487,424594422,14960562,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288489,424597564,14963132,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288491,424599726,14964886,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288494,424591064,14959945,27626,1,'2009-04-01 16:02:39',3310491140,5),(52288497,424601846,14966492,27626,1,'2009-04-01 16:02:39',3310491141,5),(52288498,424604142,14968646,27626,1,'2009-04-01 16:02:39',3310491141,5),(52288501,424606225,14971118,27626,1,'2009-04-01 16:02:39',3310491141,5),(52288503,424607638,14972637,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288504,424609545,14975391,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288507,424610181,14977546,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288509,424610357,14979523,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288511,424611205,14982631,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288514,424612158,14986092,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288515,424613076,14989941,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288518,424614560,14996545,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288521,424615160,14999900,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288524,424615972,15004667,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288527,424616678,15006680,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288529,424617667,15008234,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288533,424619362,15010212,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288535,424620881,15012507,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288537,424622717,15016110,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288541,424624059,15018299,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288542,424624730,15019394,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288545,424625366,15019606,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288549,424625825,15019535,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288552,424626143,15019217,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288555,424626178,15018299,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288558,424625896,15017063,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288561,424625437,15015686,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288565,424624412,15012755,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288567,424622823,15009718,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288570,424621016,15004715,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288573,424620756,15002020,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288575,424620549,14997925,27626,1,'2009-04-01 16:02:40',3310491143,5),(52288577,424620601,14993831,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288578,424620918,14989983,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288581,424621030,14987740,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288583,424621030,14985758,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288586,424620880,14984375,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288588,424619646,14980935,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288591,424618673,14977182,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288594,424617973,14974006,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288597,424618242,14971583,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288599,424618942,14969483,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288601,424618867,14967523,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288603,424618307,14965370,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288606,424617548,14963492,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288607,424616449,14961087,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288610,424615452,14958784,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288612,424613528,14954626,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288614,424612600,14952667,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288615,424611782,14951128,27626,1,'2009-04-01 16:02:40',3310491141,5),(52288619,424611315,14950001,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288621,424610352,14948516,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288624,424609280,14947636,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288625,424608010,14946779,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288627,424607042,14946273,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288630,424606603,14945613,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288632,424606427,14944733,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288633,424606603,14944250,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288636,424606977,14944008,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288637,424607636,14943986,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288639,424608428,14944316,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288642,424609418,14945173,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288644,424617665,14951815,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288647,424621250,14954718,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288650,424623383,14956939,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288651,424624571,14958347,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288653,424625253,14960194,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288655,424625846,14962042,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288658,424626330,14962966,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288659,424626968,14963383,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288665,424627518,14963383,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288669,424627826,14963185,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288672,424628024,14962768,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288675,424628024,14962064,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288684,424627716,14961228,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288687,424627056,14959447,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288689,424624822,14953774,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288691,424623115,14949242,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288695,424621479,14946749,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288696,424618977,14942929,27626,1,'2009-04-01 16:02:41',3310491141,5),(52288697,424615803,14938813,27626,1,'2009-04-01 16:02:41',3310490799,5),(52288702,424612470,14934229,27626,1,'2009-04-01 16:02:41',3310490799,5),(52296455,424604569,14970751,439281,1,'2007-09-16 02:00:34',3310491141,1),(52296457,424604928,14971855,439281,1,'2007-09-16 02:00:34',3310491141,1),(52296459,424606315,14973910,439281,1,'2007-09-16 02:00:34',3310491141,1),(52296460,424607168,14975640,439281,1,'2007-09-16 02:00:34',3310491141,1),(52296461,424607938,14978075,439281,1,'2007-09-16 02:00:35',3310491141,1),(52296462,424608092,14980171,439281,1,'2007-09-16 02:00:35',3310491141,1),(52296464,424607842,14983352,439281,1,'2007-09-16 02:00:35',3310491141,1),(52296465,424606866,14986414,439281,1,'2007-09-16 02:00:35',3310491141,1),(52296467,424606134,14989178,439281,1,'2007-09-16 02:00:35',3310491141,1),(52296469,424605743,14992652,439281,1,'2007-09-16 02:00:35',3310491141,1),(52296471,424605135,14995908,439281,1,'2007-09-16 02:00:35',3310491141,1),(52296472,424604223,15001205,439281,1,'2007-09-16 02:00:35',3310491143,1),(52296476,424603894,15005933,439281,1,'2007-09-16 02:00:36',3310491143,1),(52296478,424603843,15009960,439281,1,'2007-09-16 02:00:36',3310491143,1),(52296481,424604353,15013478,439281,1,'2007-09-16 02:00:36',3310491143,1),(52296483,424605118,15015670,439281,1,'2007-09-16 02:00:36',3310491143,1),(52296485,424605679,15017760,439281,1,'2007-09-16 02:00:37',3310491143,1),(52296486,424606749,15021329,439281,1,'2007-09-16 02:00:37',3310491143,1),(52296489,424607157,15023572,439281,1,'2007-09-16 02:00:37',3310491143,1),(52296490,424607718,15026580,439281,1,'2007-09-16 02:00:37',3310491143,1),(52296492,424608228,15029843,439281,1,'2007-09-16 02:00:37',3310491143,1),(52296494,424608840,15033259,439281,1,'2007-09-16 02:00:38',3310491143,1),(52296495,424609859,15035910,439281,1,'2007-09-16 02:00:38',3310491143,1),(52296497,424610828,15038204,439281,1,'2007-09-16 02:00:38',3310491143,1),(52296975,424613938,15042843,439281,1,'2007-09-16 02:01:48',3310491143,1),(52296977,424614600,15044628,439281,1,'2007-09-16 02:01:48',3310491143,1),(52296978,424614651,15045749,439281,1,'2007-09-16 02:01:48',3310491143,1),(52296979,424614345,15046463,439281,1,'2007-09-16 02:01:49',3310491143,1),(52296981,424619732,15049048,439281,1,'2007-09-16 02:01:49',3310491143,1),(52296982,424620370,15048143,439281,1,'2007-09-16 02:01:49',3310491143,1),(52296984,424620736,15046544,439281,1,'2007-09-16 02:01:49',3310491143,1),(52296985,424620481,15045190,439281,1,'2007-09-16 02:01:49',3310491143,1),(52296987,424619814,15044113,439281,1,'2007-09-16 02:01:49',3310491143,1),(52296990,424617406,15042892,439281,1,'2007-09-16 02:01:50',3310491143,1),(52296992,424616212,15042589,439281,1,'2007-09-16 02:01:50',3310491143,1),(52296994,424615116,15042159,439281,1,'2007-09-16 02:01:50',3310491143,1),(52296996,424614133,15041663,439281,1,'2007-09-16 02:01:50',3310491143,1),(52296999,424612886,15041203,439281,1,'2007-09-16 02:01:51',3310491143,1),(52297002,424622303,15048684,439281,1,'2007-09-16 02:01:51',3310491143,1),(52297004,424622872,15047782,439281,1,'2007-09-16 02:01:51',3310491143,1),(52297007,424623147,15046722,439281,1,'2007-09-16 02:01:51',3310491143,1),(52297010,424622931,15045389,439281,1,'2007-09-16 02:01:52',3310491143,1),(52297013,424622342,15044486,439281,1,'2007-09-16 02:01:53',3310491143,1),(52297015,424621303,15043819,439281,1,'2007-09-16 02:01:53',3310491143,1),(52297018,424620303,15043525,439281,1,'2007-09-16 02:01:53',3310491143,1),(52297038,424618792,15043251,439281,1,'2007-09-16 02:01:55',3310491143,1),(52297041,424610096,15017958,439281,1,'2007-09-16 02:01:55',3310491143,1),(52297063,424608851,15015747,439281,1,'2007-09-16 02:01:59',3310491143,1),(52297071,424607694,15013639,439281,1,'2007-09-16 02:02:00',3310491143,1),(52297255,424606702,15010745,439281,1,'2007-09-16 02:02:21',3310491143,1),(52297266,424605875,15007372,439281,1,'2007-09-16 02:02:23',3310491143,1),(52297268,424605180,15005718,439281,1,'2007-09-16 02:02:23',3310491143,1),(52297272,424604949,15003635,439281,1,'2007-09-16 02:02:23',3310491143,1),(52297276,424604862,15001259,439281,1,'2007-09-16 02:02:24',3310491143,1),(52297279,424605379,14998250,439281,1,'2007-09-16 02:02:24',3310491143,1),(52297281,424605147,14997953,439281,1,'2007-09-16 02:02:24',3310491143,1),(52297285,424604803,14997760,439281,1,'2007-09-16 02:02:24',3310491143,1),(52297288,424607774,15042770,439281,1,'2007-09-16 02:02:24',3310491143,1),(52297290,424609624,15044620,439281,1,'2007-09-16 02:02:24',3310491143,1),(52297294,424610858,15046813,439281,1,'2007-09-16 02:02:25',3310491143,1),(52297297,424611783,15048252,439281,1,'2007-09-16 02:02:25',3310491143,1),(52297300,424612400,15049588,439281,1,'2007-09-16 02:02:25',3310491143,1),(52297301,424613976,15050650,27626,1,'2009-04-01 16:02:39',3310491143,5),(52297305,424611269,15054260,439281,1,'2007-09-16 02:02:26',3310491149,1),(52297309,424611451,15050620,439281,1,'2007-09-16 02:02:26',3310491143,1),(52297312,424611439,15047717,439281,1,'2007-09-16 02:02:26',3310491143,1),(52297314,424601900,15041386,439281,1,'2007-09-16 02:02:26',3310491143,1),(52297317,424603704,15043485,439281,1,'2007-09-16 02:02:27',3310491143,1),(52297320,424605672,15045486,439281,1,'2007-09-16 02:02:27',3310491143,1),(52297324,424607345,15046733,439281,1,'2007-09-16 02:02:27',3310491143,1),(52297328,424608329,15047782,439281,1,'2007-09-16 02:02:27',3310491143,1),(52297333,424609313,15049258,439281,1,'2007-09-16 02:02:28',3310491143,1),(52297339,424609509,15050406,439281,1,'2007-09-16 02:02:28',3310491143,1),(52297344,424609378,15052079,439281,1,'2007-09-16 02:02:28',3310491149,1),(52297349,424608985,15053588,439281,1,'2007-09-16 02:02:28',3310491149,1),(52297354,424608952,15054867,439281,1,'2007-09-16 02:02:28',3310491149,1),(52297358,424609149,15055818,439281,1,'2007-09-16 02:02:28',3310491149,1),(52297362,424609706,15056901,439281,1,'2007-09-16 02:02:29',3310491149,1),(52297366,424610428,15057622,439281,1,'2007-09-16 02:02:29',3310491149,1),(52297369,424611477,15058573,439281,1,'2007-09-16 02:02:29',3310491149,1),(52297373,424612265,15059131,439281,1,'2007-09-16 02:02:29',3310491149,1),(52297375,424613019,15059361,439281,1,'2007-09-16 02:02:29',3310491149,1),(52297380,424613872,15059262,439281,1,'2007-09-16 02:02:30',3310491149,1),(52297383,424614593,15058442,439281,1,'2007-09-16 02:02:30',3310491149,1),(52297386,424601113,14972436,439281,1,'2007-09-16 02:02:30',3310491141,1),(52297390,424601326,14972897,439281,1,'2007-09-16 02:02:30',3310491141,1),(52297393,424601650,14973032,439281,1,'2007-09-16 02:02:31',3310491141,1),(52297397,424602067,14972929,27626,1,'2009-04-01 16:02:39',3310491141,5),(52297402,424600609,14971610,439281,1,'2007-09-16 02:02:31',3310491141,1),(52297405,424599759,14970659,439281,1,'2007-09-16 02:02:31',3310491140,1),(52297410,424598723,14970197,439281,1,'2007-09-16 02:02:31',3310491140,1),(52297412,424597876,14969824,439281,1,'2007-09-16 02:02:32',3310491140,1),(52297418,424597254,14969948,439281,1,'2007-09-16 02:02:32',3310491140,1),(52297422,424596905,14970321,439281,1,'2007-09-16 02:02:32',3310491140,1),(52297424,424596905,14970695,439281,1,'2007-09-16 02:02:32',3310491140,1),(52297427,424597304,14971666,439281,1,'2007-09-16 02:02:32',3310491140,1),(52297432,424598075,14973582,439281,1,'2007-09-16 02:02:33',3310491140,1),(52297435,424598748,14974852,439281,1,'2007-09-16 02:02:33',3310491140,1),(52297437,424598897,14975175,439281,1,'2007-09-16 02:02:33',3310491140,1),(52297440,424599021,14975698,439281,1,'2007-09-16 02:02:33',3310491140,1),(52297442,424598922,14975997,439281,1,'2007-09-16 02:02:33',3310491140,1),(52297447,424598673,14976072,439281,1,'2007-09-16 02:02:33',3310491140,1),(52297450,424598001,14975574,439281,1,'2007-09-16 02:02:34',3310491140,1),(52297455,424596955,14974528,439281,1,'2007-09-16 02:02:34',3310491140,1),(52297459,424596482,14974279,439281,1,'2007-09-16 02:02:34',3310491140,1),(52297462,424596233,14974379,439281,1,'2007-09-16 02:02:34',3310491140,1),(52297465,424596109,14974852,439281,1,'2007-09-16 02:02:34',3310491140,1),(52297469,424596557,14975574,439281,1,'2007-09-16 02:02:34',3310491140,1),(52297470,424597453,14977217,439281,1,'2007-09-16 02:02:34',3310491140,1),(52297474,424597827,14977690,439281,1,'2007-09-16 02:02:35',3310491140,1),(52297478,424597901,14978312,439281,1,'2007-09-16 02:02:35',3310491140,1),(52297482,424597752,14978611,439281,1,'2007-09-16 02:02:35',3310491140,1),(52297484,424597428,14978611,439281,1,'2007-09-16 02:02:35',3310491140,1),(52297488,424597030,14978312,439281,1,'2007-09-16 02:02:35',3310491140,1),(52297492,424596457,14978138,439281,1,'2007-09-16 02:02:35',3310491140,1),(52297494,424596034,14977939,439281,1,'2007-09-16 02:02:35',3310491140,1),(52297498,424595636,14978461,439281,1,'2007-09-16 02:02:35',3310491140,1),(52297501,424605173,14969870,27626,1,'2009-04-01 16:02:39',3310491141,5),(52297507,424614360,15017782,439281,1,'2007-09-16 02:02:36',3310491143,1),(52297509,424612677,15018413,439281,1,'2007-09-16 02:02:36',3310491143,1),(52297515,424612361,15018098,439281,1,'2007-09-16 02:02:37',3310491143,1),(52297517,424612151,15017308,439281,1,'2007-09-16 02:02:37',3310491143,1),(52297520,424610257,15012258,439281,1,'2007-09-16 02:02:37',3310491143,1),(52297521,424608784,15008312,439281,1,'2007-09-16 02:02:37',3310491143,1),(52297525,424607521,15004577,439281,1,'2007-09-16 02:02:37',3310491143,1),(52297528,424606521,15000473,439281,1,'2007-09-16 02:02:37',3310491143,1),(52297532,424606431,14999097,439281,1,'2007-09-16 02:02:37',3310491143,1),(52297535,424606566,14996808,439281,1,'2007-09-16 02:02:37',3310491143,1),(52297537,424606768,14994619,439281,1,'2007-09-16 02:02:37',3310491141,1),(52297540,424606768,14992734,439281,1,'2007-09-16 02:02:38',3310491141,1),(52297542,424605850,14991091,439281,1,'2007-09-16 02:02:38',3310491141,1),(52297545,424620095,15023177,439281,1,'2007-09-16 02:02:38',3310491143,1),(52297547,424618293,15019660,439281,1,'2007-09-16 02:02:38',3310491143,1),(52297550,424617006,15016571,439281,1,'2007-09-16 02:02:38',3310491143,1),(52297554,424615591,15012753,439281,1,'2007-09-16 02:02:38',3310491143,1),(52297558,424614218,15009493,439281,1,'2007-09-16 02:02:38',3310491143,1),(52297560,424613360,15006448,439281,1,'2007-09-16 02:02:39',3310491143,1),(52297563,424612245,14999885,439281,1,'2007-09-16 02:02:39',3310491143,1),(52297565,424611730,14997397,439281,1,'2007-09-16 02:02:39',3310491143,1),(52297567,424611515,14995123,439281,1,'2007-09-16 02:02:39',3310491141,1),(52297571,424611172,14992635,439281,1,'2007-09-16 02:02:39',3310491141,1),(52297573,424610872,14989847,439281,1,'2007-09-16 02:02:39',3310491141,1),(52297576,424610829,14987831,439281,1,'2007-09-16 02:02:39',3310491141,1),(52297580,424611129,14986930,439281,1,'2007-09-16 02:02:39',3310491141,1),(52297584,424622242,15022238,439281,1,'2007-09-16 02:02:40',3310491143,1),(52297587,424620843,15020609,439281,1,'2007-09-16 02:02:40',3310491143,1),(52297590,424619406,15018470,439281,1,'2007-09-16 02:02:40',3310491143,1),(52297592,424618337,15016598,439281,1,'2007-09-16 02:02:40',3310491143,1),(52297595,424617223,15014638,439281,1,'2007-09-16 02:02:40',3310491143,1),(52297599,424616733,15013969,439281,1,'2007-09-16 02:02:40',3310491143,1),(52297602,424616081,15014077,439281,1,'2007-09-16 02:02:41',3310491143,1),(52297606,424631521,15016152,439281,1,'2007-09-16 02:02:41',3310491154,1),(52297609,424629450,15013027,439281,1,'2007-09-16 02:02:41',3310491154,1),(52297612,424628142,15010884,439281,1,'2007-09-16 02:02:41',3310491154,1),(52297615,424626652,15008340,439281,1,'2007-09-16 02:02:41',3310491143,1),(52297617,424625562,15005179,439281,1,'2007-09-16 02:02:41',3310491143,1),(52297621,424624944,15002999,439281,1,'2007-09-16 02:02:42',3310491143,1),(52297623,424624254,14999766,439281,1,'2007-09-16 02:02:42',3310491143,1),(52297626,424623963,14995406,439281,1,'2007-09-16 02:02:42',3310491141,1),(52297629,424624363,14991554,439281,1,'2007-09-16 02:02:42',3310491141,1),(52297633,424624690,14989011,439281,1,'2007-09-16 02:02:42',3310491141,1),(52297638,424624581,14987049,439281,1,'2007-09-16 02:02:43',3310491141,1),(52297640,424624218,14985123,439281,1,'2007-09-16 02:02:43',3310491141,1),(52297643,424622982,14981999,439281,1,'2007-09-16 02:02:43',3310491141,1),(52297646,424620875,14977675,439281,1,'2007-09-16 02:02:43',3310491141,1),(52297650,424618166,14972270,27626,1,'2009-04-01 16:02:40',3310491141,5),(52322112,424667190,14927360,439281,1,'2007-09-16 02:48:47',3310490811,1),(52322115,424666587,14925324,439281,1,'2007-09-16 02:48:47',3310490811,1),(52322119,424666875,14924502,439281,1,'2007-09-16 02:48:47',3310490811,1),(52322122,424668200,14930193,439281,1,'2007-09-16 02:48:47',3310490811,1),(52322125,424668922,14933445,439281,1,'2007-09-16 02:48:48',3310490811,1),(52322137,424670157,14936094,439281,1,'2007-09-16 02:48:48',3310490811,1),(52322143,424671362,14938172,439281,1,'2007-09-16 02:48:49',3310490811,1),(52322151,424673797,14940386,439281,1,'2007-09-16 02:48:49',3310490811,1),(52322153,424678046,14943334,439281,1,'2007-09-16 02:48:49',3310491153,1),(52322155,424680735,14946110,439281,1,'2007-09-16 02:48:49',3310491153,1),(52322156,424682773,14947974,439281,1,'2007-09-16 02:48:49',3310491153,1),(52322157,424684420,14949708,439281,1,'2007-09-16 02:48:49',3310491156,1),(52322159,424686241,14950576,439281,1,'2007-09-16 02:48:50',3310491156,1),(52322163,424687846,14950576,439281,1,'2007-09-16 02:48:50',3310491156,1),(52322165,424689190,14949795,439281,1,'2007-09-16 02:48:50',3310491156,1),(52322167,424690317,14948104,439281,1,'2007-09-16 02:48:50',3310491156,1),(52322170,424690968,14946717,439281,1,'2007-09-16 02:48:50',3310491156,1),(52322171,424691705,14946110,439281,1,'2007-09-16 02:48:51',3310491156,1),(52322174,424693179,14946023,439281,1,'2007-09-16 02:48:51',3310491156,1),(52322177,424695000,14945979,439281,1,'2007-09-16 02:48:51',3310491156,1),(52322180,424696605,14945372,439281,1,'2007-09-16 02:48:52',3310491156,1),(52322184,424698252,14944419,439281,1,'2007-09-16 02:48:52',3310491156,1),(52322185,424699943,14943465,439281,1,'2007-09-16 02:48:52',3310491156,1),(52322190,424701071,14943248,439281,1,'2007-09-16 02:48:52',3310491156,1),(52322193,424702025,14944072,439281,1,'2007-09-16 02:48:53',3310491156,1),(52322196,424702848,14946023,439281,1,'2007-09-16 02:48:53',3310491156,1),(52322198,424703022,14948538,439281,1,'2007-09-16 02:48:53',3310491156,1),(52322200,424702675,14950793,439281,1,'2007-09-16 02:48:53',3310491156,1),(52322203,424701895,14953264,439281,1,'2007-09-16 02:48:54',3310491156,1),(52322207,424701071,14955779,439281,1,'2007-09-16 02:48:54',3310491156,1),(52322210,424699727,14957947,439281,1,'2007-09-16 02:48:54',3310491156,1),(52322213,424698079,14959421,439281,1,'2007-09-16 02:48:54',3310491156,1),(52322216,424696084,14960115,439281,1,'2007-09-16 02:48:55',3310491156,1),(52322219,424693960,14960982,439281,1,'2007-09-16 02:48:55',3310491156,1),(52322222,424691228,14960896,439281,1,'2007-09-16 02:48:55',3310491156,1),(52322223,424688236,14960635,439281,1,'2007-09-16 02:48:55',3310491156,1),(52322225,424685244,14960505,439281,1,'2007-09-16 02:48:55',3310491156,1),(52322228,424683163,14960419,439281,1,'2007-09-16 02:48:55',3310491156,1),(52322231,424680240,14959980,439281,1,'2007-09-16 02:48:56',3310491153,1),(52322235,424678464,14959286,439281,1,'2007-09-16 02:48:56',3310491153,1),(52322237,424676161,14958093,439281,1,'2007-09-16 02:48:56',3310491153,1),(52322240,424674773,14957177,439281,1,'2007-09-16 02:48:56',3310491153,1),(52322242,424672886,14956455,439281,1,'2007-09-16 02:48:56',3310491153,1),(52322244,424671499,14955762,439281,1,'2007-09-16 02:48:56',3310491153,1),(52322245,424670750,14955234,439281,1,'2007-09-16 02:48:56',3310491153,1),(52322247,424670028,14954874,439281,1,'2007-09-16 02:48:57',3310491153,1),(52322249,424669445,14954874,439281,1,'2007-09-16 02:48:57',3310491153,1),(52322252,424669168,14955151,439281,1,'2007-09-16 02:48:57',3310491153,1),(52322255,424669085,14955678,439281,1,'2007-09-16 02:48:57',3310491153,1),(52322256,424669418,14956317,439281,1,'2007-09-16 02:48:57',3310491153,1),(52322259,424670500,14957038,439281,1,'2007-09-16 02:48:57',3310491153,1),(52322262,424672054,14958342,439281,1,'2007-09-16 02:48:58',3310491153,1),(52322266,424673663,14959896,439281,1,'2007-09-16 02:48:58',3310491153,1),(52322268,424675384,14962394,439281,1,'2007-09-16 02:48:58',3310491153,1),(52322271,424676300,14963560,439281,1,'2007-09-16 02:48:58',3310491153,1),(52322273,424676688,14964226,439281,1,'2007-09-16 02:48:58',3310491153,1),(52322277,424676716,14964697,439281,1,'2007-09-16 02:48:58',3310491153,1),(52322278,424676522,14964919,439281,1,'2007-09-16 02:48:59',3310491153,1),(52322279,424676189,14965114,439281,1,'2007-09-16 02:48:59',3310491153,1),(52322282,424675745,14965114,439281,1,'2007-09-16 02:48:59',3310491153,1),(52322285,424675356,14964864,439281,1,'2007-09-16 02:48:59',3310491153,1),(52322286,424674884,14964087,439281,1,'2007-09-16 02:48:59',3310491153,1),(52322289,424674163,14963088,439281,1,'2007-09-16 02:48:59',3310491153,1),(52322292,424673469,14962394,439281,1,'2007-09-16 02:48:59',3310491153,1),(52322293,424672220,14961534,439281,1,'2007-09-16 02:49:00',3310491153,1),(52322295,424670972,14961145,439281,1,'2007-09-16 02:49:00',3310491153,1),(52322298,424670101,14960872,439281,1,'2007-09-16 02:49:00',3310491153,1),(52322299,424669140,14960842,439281,1,'2007-09-16 02:49:00',3310491153,1),(52322302,424668479,14961112,439281,1,'2007-09-16 02:49:00',3310491153,1),(52322305,424668022,14961608,439281,1,'2007-09-16 02:49:01',3310491153,1),(52322308,424667977,14962268,439281,1,'2007-09-16 02:49:01',3310491153,1),(52322309,424668343,14962814,439281,1,'2007-09-16 02:49:01',3310491153,1),(52322311,424669438,14963088,439281,1,'2007-09-16 02:49:01',3310491153,1),(52322313,424670610,14963402,439281,1,'2007-09-16 02:49:01',3310491153,1),(52322315,424671809,14964264,439281,1,'2007-09-16 02:49:02',3310491153,1),(52322316,424672464,14965392,439281,1,'2007-09-16 02:49:02',3310491153,1),(52322318,424673412,14967153,439281,1,'2007-09-16 02:49:02',3310491153,1),(52322320,424674630,14968867,439281,1,'2007-09-16 02:49:02',3310491153,1),(52322322,424675627,14969896,439281,1,'2007-09-16 02:49:03',3310491153,1),(52322324,424676801,14970961,439281,1,'2007-09-16 02:49:03',3310491153,1),(52322327,424678028,14971864,439281,1,'2007-09-16 02:49:03',3310491153,1),(52322329,424678552,14972532,439281,1,'2007-09-16 02:49:03',3310491153,1),(52322331,424678624,14972947,439281,1,'2007-09-16 02:49:03',3310491153,1),(52322333,424678570,14973380,439281,1,'2007-09-16 02:49:03',3310491153,1),(52322335,424678317,14973633,439281,1,'2007-09-16 02:49:04',3310491153,1),(52322336,424678028,14973687,439281,1,'2007-09-16 02:49:04',3310491153,1),(52322337,424677541,14973489,439281,1,'2007-09-16 02:49:04',3310491153,1),(52322339,424676783,14973037,439281,1,'2007-09-16 02:49:04',3310491153,1),(52322341,424676006,14972532,439281,1,'2007-09-16 02:49:04',3310491153,1),(52322342,424675230,14972351,439281,1,'2007-09-16 02:49:04',3310491153,1),(52322344,424674635,14972424,439281,1,'2007-09-16 02:49:04',3310491153,1),(52322345,424674201,14972929,439281,1,'2007-09-16 02:49:04',3310491153,1),(52322347,424674039,14973471,439281,1,'2007-09-16 02:49:05',3310491153,1),(52322349,424674183,14974229,439281,1,'2007-09-16 02:49:05',3310491153,1),(52322351,424674598,14975041,439281,1,'2007-09-16 02:49:05',3310491153,1),(52322353,424675826,14975944,439281,1,'2007-09-16 02:49:05',3310491153,1),(52322355,424677126,14976594,439281,1,'2007-09-16 02:49:05',3310491153,1),(52322357,424678512,14976838,439281,1,'2007-09-16 02:49:05',3310491153,1),(52322358,424679831,14976764,439281,1,'2007-09-16 02:49:05',3310491153,1),(52322359,424681662,14976325,439281,1,'2007-09-16 02:49:06',3310491153,1),(52322361,424683616,14975861,439281,1,'2007-09-16 02:49:06',3310491156,1),(52322363,424685300,14975934,439281,1,'2007-09-16 02:49:06',3310491156,1),(52322364,424687132,14976227,439281,1,'2007-09-16 02:49:06',3310491156,1),(52322365,424688548,14976252,439281,1,'2007-09-16 02:49:06',3310491156,1),(52322366,424690355,14976349,439281,1,'2007-09-16 02:49:06',3310491156,1),(52322368,424691673,14976471,439281,1,'2007-09-16 02:49:06',3310491156,1),(52322370,424693136,14977162,439281,1,'2007-09-16 02:49:06',3310491156,1),(52322372,424694086,14978287,439281,1,'2007-09-16 02:49:07',3310491156,1),(52322374,424695035,14979729,439281,1,'2007-09-16 02:49:07',3310491156,1),(52322376,424695879,14980713,439281,1,'2007-09-16 02:49:07',3310491156,1),(52322378,424697145,14981135,439281,1,'2007-09-16 02:49:07',3310491156,1),(52322380,424698551,14981135,439281,1,'2007-09-16 02:49:07',3310491156,1),(52322382,424700063,14981205,439281,1,'2007-09-16 02:49:07',3310491156,1),(52322384,424701821,14981416,439281,1,'2007-09-16 02:49:07',3310491156,1),(52322386,424703720,14981979,439281,1,'2007-09-16 02:49:07',3310491156,1),(52322388,424705443,14982999,439281,1,'2007-09-16 02:49:08',3310491156,1),(52322390,424707412,14984651,439281,1,'2007-09-16 02:49:08',3310491156,1),(52322392,424708783,14986444,439281,1,'2007-09-16 02:49:08',3310491156,1),(52322395,424709908,14987745,439281,1,'2007-09-16 02:49:08',3310491156,1),(52322398,424711314,14988449,439281,1,'2007-09-16 02:49:08',3310491157,1),(52322400,424711877,14989117,439281,1,'2007-09-16 02:49:09',3310491157,1),(52322402,424711842,14989750,439281,1,'2007-09-16 02:49:09',3310491157,1),(52322405,424711631,14990242,439281,1,'2007-09-16 02:49:09',3310491157,1),(52322408,424711139,14990382,439281,1,'2007-09-16 02:49:09',3310491157,1),(52322411,424710013,14990347,439281,1,'2007-09-16 02:49:09',3310491156,1),(52322413,424708396,14990101,439281,1,'2007-09-16 02:49:09',3310491156,1),(52322415,424705970,14989609,439281,1,'2007-09-16 02:49:10',3310491156,1),(52322419,424704282,14989081,439281,1,'2007-09-16 02:49:10',3310491156,1),(52322422,424702313,14988871,439281,1,'2007-09-16 02:49:10',3310491156,1),(52322424,424700309,14988624,439281,1,'2007-09-16 02:49:10',3310491156,1),(52322429,424698797,14988730,439281,1,'2007-09-16 02:49:10',3310491156,1),(52322432,424697285,14988871,439281,1,'2007-09-16 02:49:10',3310491156,1),(52322434,424695598,14988554,439281,1,'2007-09-16 02:49:10',3310491156,1),(52322437,424694050,14988027,439281,1,'2007-09-16 02:49:11',3310491156,1),(52322440,424693031,14987464,439281,1,'2007-09-16 02:49:11',3310491156,1),(52322441,424692292,14987148,439281,1,'2007-09-16 02:49:11',3310491156,1),(52322443,424691695,14987394,439281,1,'2007-09-16 02:49:11',3310491156,1),(52322446,424691554,14988132,439281,1,'2007-09-16 02:49:11',3310491156,1),(52322449,424691730,14988730,439281,1,'2007-09-16 02:49:11',3310491156,1),(52322451,424692855,14989679,439281,1,'2007-09-16 02:49:11',3310491156,1),(52322453,424697088,14992637,439281,1,'2007-09-16 02:49:12',3310491156,1),(52322455,424698765,14993927,439281,1,'2007-09-16 02:49:12',3310491156,1),(52322458,424699926,14995088,439281,1,'2007-09-16 02:49:12',3310491156,1),(52322461,424701173,14997152,439281,1,'2007-09-16 02:49:12',3310491158,1),(52322463,424702506,14999517,439281,1,'2007-09-16 02:49:12',3310491158,1),(52322465,424703753,15000808,439281,1,'2007-09-16 02:49:12',3310491158,1),(52322467,424705688,15002528,439281,1,'2007-09-16 02:49:12',3310491158,1),(52322470,424708527,15004721,439281,1,'2007-09-16 02:49:13',3310491158,1),(52322473,424710462,15006097,439281,1,'2007-09-16 02:49:13',3310491159,1),(52322475,424711924,15007172,439281,1,'2007-09-16 02:49:13',3310491159,1),(52322478,424712870,15008204,439281,1,'2007-09-16 02:49:13',3310491159,1),(52322481,424713472,15009451,439281,1,'2007-09-16 02:49:13',3310491159,1),(52322484,424713816,15010526,439281,1,'2007-09-16 02:49:13',3310491159,1),(52322486,424713945,15011300,439281,1,'2007-09-16 02:49:13',3310491159,1),(52322488,424713816,15012032,439281,1,'2007-09-16 02:49:14',3310491159,1),(52322492,424713386,15012677,439281,1,'2007-09-16 02:49:14',3310491159,1),(52322493,424712698,15013021,439281,1,'2007-09-16 02:49:14',3310491159,1),(52322496,424711537,15012849,439281,1,'2007-09-16 02:49:14',3310491159,1),(52322497,424710247,15012333,439281,1,'2007-09-16 02:49:14',3310491158,1),(52322500,424709000,15012118,439281,1,'2007-09-16 02:49:14',3310491158,1),(52322502,424707709,15012032,439281,1,'2007-09-16 02:49:15',3310491158,1),(52322504,424706849,15011817,439281,1,'2007-09-16 02:49:15',3310491158,1),(52322508,424705258,15010698,439281,1,'2007-09-16 02:49:15',3310491158,1),(52322510,424702936,15009322,439281,1,'2007-09-16 02:49:15',3310491158,1),(52322512,424701560,15008591,439281,1,'2007-09-16 02:49:15',3310491158,1),(52322515,424700485,15008290,439281,1,'2007-09-16 02:49:15',3310491158,1),(52322516,424699152,15008376,439281,1,'2007-09-16 02:49:15',3310491158,1),(52322518,424697518,15008505,439281,1,'2007-09-16 02:49:15',3310491158,1),(52322520,424696615,15008849,439281,1,'2007-09-16 02:49:16',3310491158,1),(52322523,424696141,15009451,439281,1,'2007-09-16 02:49:16',3310491158,1),(52322526,424695840,15010440,439281,1,'2007-09-16 02:49:16',3310491158,1),(52322528,424695840,15011515,439281,1,'2007-09-16 02:49:16',3310491158,1),(52322530,424695969,15012247,439281,1,'2007-09-16 02:49:16',3310491158,1),(52322533,424696400,15012935,439281,1,'2007-09-16 02:49:16',3310491158,1),(52322534,424697174,15013322,439281,1,'2007-09-16 02:49:17',3310491158,1),(52322537,424698507,15013537,439281,1,'2007-09-16 02:49:17',3310491158,1),(52322540,424699582,15013752,439281,1,'2007-09-16 02:49:17',3310491158,1),(52322542,424700356,15013967,439281,1,'2007-09-16 02:49:17',3310491158,1),(52322544,424700786,15014440,439281,1,'2007-09-16 02:49:17',3310491158,1),(52322545,424701216,15015429,439281,1,'2007-09-16 02:49:17',3310491158,1),(52322548,424701259,15016461,439281,1,'2007-09-16 02:49:17',3310491158,1),(52322551,424701087,15017622,439281,1,'2007-09-16 02:49:18',3310491158,1),(52322552,424700958,15018955,439281,1,'2007-09-16 02:49:18',3310491158,1),(52322554,424701001,15020890,439281,1,'2007-09-16 02:49:19',3310491158,1),(52322557,424701001,15024804,439281,1,'2007-09-16 02:49:19',3310491158,1),(52322558,424701142,15026945,439281,1,'2007-09-16 02:49:19',3310491158,1),(52322561,424701584,15029007,439281,1,'2007-09-16 02:49:19',3310491158,1),(52322562,424702153,15030313,439281,1,'2007-09-16 02:49:19',3310491158,1),(52322564,424702890,15031952,439281,1,'2007-09-16 02:49:20',3310491158,1),(52322567,424703636,15033229,439281,1,'2007-09-16 02:49:20',3310491158,1),(52322570,424704559,15034299,439281,1,'2007-09-16 02:49:20',3310491158,1),(52322571,424705698,15035035,439281,1,'2007-09-16 02:49:21',3310491158,1),(52322574,424706719,15035388,439281,1,'2007-09-16 02:49:21',3310491158,1),(52322578,424707818,15035310,439281,1,'2007-09-16 02:49:21',3310491158,1),(52322579,424708997,15034878,439281,1,'2007-09-16 02:49:21',3310491158,1),(52322581,424709900,15034407,439281,1,'2007-09-16 02:49:21',3310491158,1),(52322583,424710607,15034093,439281,1,'2007-09-16 02:49:21',3310491159,1),(52322585,424711510,15034093,439281,1,'2007-09-16 02:49:22',3310491159,1),(52322587,424712531,15034603,439281,1,'2007-09-16 02:49:22',3310491159,1),(52322589,424713356,15035742,439281,1,'2007-09-16 02:49:22',3310491159,1),(52322591,424714455,15038295,439281,1,'2007-09-16 02:49:22',3310491159,1),(52322593,424715712,15040651,439281,1,'2007-09-16 02:49:22',3310491159,1),(52322595,424716380,15041750,439281,1,'2007-09-16 02:49:22',3310491159,1),(52322598,424717283,15042732,439281,1,'2007-09-16 02:49:23',3310491159,1),(52322601,424718343,15042850,439281,1,'2007-09-16 02:49:23',3310491159,1),(52322602,424719836,15042143,439281,1,'2007-09-16 02:49:23',3310491159,1),(52322604,424721131,15041279,439281,1,'2007-09-16 02:49:23',3310491159,1),(52322606,424722310,15040376,439281,1,'2007-09-16 02:49:23',3310491159,1),(52322611,424723331,15039826,439281,1,'2007-09-16 02:49:23',3310491159,1),(52322613,424725019,15040219,439281,1,'2007-09-16 02:49:24',3310491159,1),(52322615,424725726,15040572,439281,1,'2007-09-16 02:49:24',3310491159,1),(52322617,424726889,15040627,439281,1,'2007-09-16 02:49:24',3310491159,1),(52322618,424727894,15039905,439281,1,'2007-09-16 02:49:25',3310491159,1),(52322623,424729025,15038083,439281,1,'2007-09-16 02:49:25',3310491159,1),(52322626,424730596,15035663,439281,1,'2007-09-16 02:49:25',3310491159,1),(52322627,424732010,15032899,439281,1,'2007-09-16 02:49:25',3310491159,1),(52322630,424733112,15031029,439281,1,'2007-09-16 02:49:25',3310491159,1),(52322632,424733609,15030033,439281,1,'2007-09-16 02:49:25',3310491159,1),(52322634,424733836,15028631,439281,1,'2007-09-16 02:49:26',3310491159,1),(52322636,424699396,14968070,439281,1,'2007-09-16 02:49:26',3310491156,1),(52322639,424701038,14966789,439281,1,'2007-09-16 02:49:26',3310491156,1),(52322641,424702716,14965903,439281,1,'2007-09-16 02:49:26',3310491156,1),(52322644,424703638,14965470,439281,1,'2007-09-16 02:49:26',3310491156,1),(52322646,424704708,14965249,439281,1,'2007-09-16 02:49:27',3310491156,1),(52322648,424706220,14965138,439281,1,'2007-09-16 02:49:27',3310491156,1),(52322651,424707364,14965359,439281,1,'2007-09-16 02:49:27',3310491156,1),(52322654,424707733,14966355,439281,1,'2007-09-16 02:49:27',3310491156,1),(52322656,424707438,14966945,439281,1,'2007-09-16 02:49:27',3310491156,1),(52322657,424706479,14967904,439281,1,'2007-09-16 02:49:27',3310491156,1),(52322660,424704966,14968532,439281,1,'2007-09-16 02:49:27',3310491156,1),(52322663,424703048,14969749,439281,1,'2007-09-16 02:49:28',3310491156,1),(52322665,424701462,14971261,439281,1,'2007-09-16 02:49:28',3310491156,1),(52322667,424699433,14973216,439281,1,'2007-09-16 02:49:28',3310491156,1),(52322670,424698031,14974434,439281,1,'2007-09-16 02:49:28',3310491156,1),(52322673,424697441,14974913,439281,1,'2007-09-16 02:49:29',3310491156,1),(52322675,424697441,14975577,439281,1,'2007-09-16 02:49:29',3310491156,1),(52322677,424697662,14976094,439281,1,'2007-09-16 02:49:29',3310491156,1),(52322678,424698326,14976352,439281,1,'2007-09-16 02:49:29',3310491156,1),(52322681,424699249,14976057,439281,1,'2007-09-16 02:49:29',3310491156,1),(52322684,424701167,14975098,439281,1,'2007-09-16 02:49:29',3310491156,1),(52322685,424702679,14974581,439281,1,'2007-09-16 02:49:30',3310491156,1),(52322687,424703970,14974323,439281,1,'2007-09-16 02:49:30',3310491156,1),(52322690,424705151,14974581,439281,1,'2007-09-16 02:49:30',3310491156,1),(52322692,424705888,14975467,439281,1,'2007-09-16 02:49:30',3310491156,1),(52322695,424707212,14977243,439281,1,'2007-09-16 02:49:30',3310491156,1),(52322697,424707460,14977916,439281,1,'2007-09-16 02:49:30',3310491156,1),(52322698,424706787,14978978,439281,1,'2007-09-16 02:49:30',3310491156,1),(52322700,424706043,14978978,439281,1,'2007-09-16 02:49:31',3310491156,1),(52322701,424704875,14979120,439281,1,'2007-09-16 02:49:31',3310491156,1),(52322704,424703529,14979580,439281,1,'2007-09-16 02:49:31',3310491156,1),(52322706,424701723,14980289,439281,1,'2007-09-16 02:49:31',3310491156,1),(52322709,424711666,14983404,439281,1,'2007-09-16 02:49:31',3310491157,1),(52322712,424707614,14978403,439281,1,'2007-09-16 02:49:32',3310491156,1),(52322713,424734301,15026252,439281,1,'2007-09-16 02:49:32',3310491159,1),(52322716,424734817,15024464,439281,1,'2007-09-16 02:49:32',3310491159,1),(52322719,424735952,15022813,439281,1,'2007-09-16 02:49:32',3310491159,1),(52322722,424737293,15020990,439281,1,'2007-09-16 02:49:32',3310491159,1),(52322725,424738875,15018995,439281,1,'2007-09-16 02:49:33',3310491202,1),(52322727,424739735,15017964,439281,1,'2007-09-16 02:49:33',3310491202,1),(52322729,424740595,15016381,439281,1,'2007-09-16 02:49:33',3310491202,1),(52322731,424741386,15014387,439281,1,'2007-09-16 02:49:33',3310491202,1),(52322733,424741730,15013286,439281,1,'2007-09-16 02:49:33',3310491202,1),(52322736,424741902,15011635,439281,1,'2007-09-16 02:49:33',3310491202,1),(52322738,424741455,15010191,439281,1,'2007-09-16 02:49:34',3310491202,1),(52322739,424741248,15008540,439281,1,'2007-09-16 02:49:34',3310491202,1),(52322741,424741420,15007405,439281,1,'2007-09-16 02:49:34',3310491202,1),(52322753,424741936,15006923,439281,1,'2007-09-16 02:49:36',3310491202,1),(52322755,424742521,15006855,439281,1,'2007-09-16 02:49:36',3310491202,1),(52322758,424743002,15007233,439281,1,'2007-09-16 02:49:36',3310491202,1),(52322761,424743209,15008058,439281,1,'2007-09-16 02:49:37',3310491202,1),(52322764,424743209,15010397,439281,1,'2007-09-16 02:49:37',3310491202,1),(52322765,424742899,15013183,439281,1,'2007-09-16 02:49:37',3310491202,1),(52322768,424742280,15016106,439281,1,'2007-09-16 02:49:37',3310491202,1),(52322770,424741386,15018651,439281,1,'2007-09-16 02:49:37',3310491202,1),(52322773,424739460,15022607,439281,1,'2007-09-16 02:49:37',3310491202,1),(52322774,424738463,15025289,439281,1,'2007-09-16 02:49:38',3310491202,1),(52322777,424737775,15028488,439281,1,'2007-09-16 02:49:38',3310491159,1),(52322780,424737775,15030448,439281,1,'2007-09-16 02:49:38',3310491159,1),(52322782,424737706,15031996,439281,1,'2007-09-16 02:49:38',3310491159,1);
INSERT INTO `nodes` VALUES (52322785,424737328,15033234,439281,1,'2007-09-16 02:49:38',3310491159,1),(52322787,424736365,15035366,439281,1,'2007-09-16 02:49:38',3310491159,1),(52322789,424735402,15037877,439281,1,'2007-09-16 02:49:39',3310491159,1),(52322791,424734232,15041626,439281,1,'2007-09-16 02:49:39',3310491159,1),(52322793,424733200,15044721,439281,1,'2007-09-16 02:49:39',3310491159,1),(52322795,424732650,15047782,439281,1,'2007-09-16 02:49:39',3310491159,1),(52322796,424732616,15050602,439281,1,'2007-09-16 02:49:39',3310491159,1),(52322799,424732856,15053250,439281,1,'2007-09-16 02:49:40',3310491165,1),(52322800,424732925,15055142,439281,1,'2007-09-16 02:49:40',3310491165,1),(52322802,424732375,15056827,439281,1,'2007-09-16 02:49:40',3310491165,1),(52322804,424731378,15058444,439281,1,'2007-09-16 02:49:40',3310491165,1),(52322806,424730243,15059682,439281,1,'2007-09-16 02:49:40',3310491165,1),(52322809,424728970,15060473,439281,1,'2007-09-16 02:49:41',3310491165,1),(52322810,424727594,15061092,439281,1,'2007-09-16 02:49:41',3310491165,1),(52322815,424725737,15061711,439281,1,'2007-09-16 02:49:41',3310491165,1),(52322816,424723330,15062124,439281,1,'2007-09-16 02:49:41',3310491165,1),(52322819,424721748,15062296,439281,1,'2007-09-16 02:49:41',3310491165,1),(52322823,424720819,15062640,439281,1,'2007-09-16 02:49:42',3310491165,1),(52322826,424720338,15063740,439281,1,'2007-09-16 02:49:42',3310491165,1),(52322827,424720269,15064875,439281,1,'2007-09-16 02:49:42',3310491165,1),(52322830,424720819,15066354,439281,1,'2007-09-16 02:49:42',3310491165,1),(52322833,424721335,15068039,439281,1,'2007-09-16 02:49:42',3310491165,1),(52322836,424721816,15070412,439281,1,'2007-09-16 02:49:42',3310491165,1),(52322837,424721851,15073645,439281,1,'2007-09-16 02:49:42',3310491165,1),(52322840,424721920,15075193,439281,1,'2007-09-16 02:49:42',3310491165,1),(52322842,424721988,15076947,439281,1,'2007-09-16 02:49:42',3310491165,1),(52322844,424722367,15078942,439281,1,'2007-09-16 02:49:42',3310491165,1),(52322846,424723330,15082072,439281,1,'2007-09-16 02:49:43',3310491165,1),(52322847,424724293,15084720,439281,1,'2007-09-16 02:49:43',3310491165,1),(52322850,424724877,15087024,439281,1,'2007-09-16 02:49:43',3310491165,1),(52322851,424724809,15089741,439281,1,'2007-09-16 02:49:43',3310491165,1),(52322855,424723880,15094212,439281,1,'2007-09-16 02:49:44',3310491165,1),(52322858,424723467,15095863,439281,1,'2007-09-16 02:49:44',3310491165,1),(52322859,424723089,15097307,439281,1,'2007-09-16 02:49:44',3310491165,1),(52322863,424722539,15098442,439281,1,'2007-09-16 02:49:44',3310491165,1),(52322865,424721988,15098993,439281,1,'2007-09-16 02:49:44',3310491165,1),(52322867,424721163,15099302,439281,1,'2007-09-16 02:49:44',3310491165,1),(52322871,424720131,15099577,439281,1,'2007-09-16 02:49:45',3310491165,1),(52322874,424719375,15100196,439281,1,'2007-09-16 02:49:45',3310491165,1),(52322877,424718790,15101056,439281,1,'2007-09-16 02:49:45',3310491165,1),(52322879,424718480,15102329,439281,1,'2007-09-16 02:49:45',3310491165,1),(52322880,424718549,15103636,439281,1,'2007-09-16 02:49:45',3310491165,1),(52322883,424719271,15104599,439281,1,'2007-09-16 02:49:45',3310491165,1),(52322887,424720028,15105115,439281,1,'2007-09-16 02:49:46',3310491165,1),(52322889,424721060,15105149,439281,1,'2007-09-16 02:49:46',3310491165,1),(52322891,424721679,15104736,439281,1,'2007-09-16 02:49:46',3310491165,1),(52322893,424722848,15103533,439281,1,'2007-09-16 02:49:47',3310491165,1),(52322896,424723846,15102398,439281,1,'2007-09-16 02:49:47',3310491165,1),(52322898,424725256,15100196,439281,1,'2007-09-16 02:49:47',3310491165,1),(52322902,424726975,15097514,439281,1,'2007-09-16 02:49:47',3310491165,1),(52322903,424728213,15095313,439281,1,'2007-09-16 02:49:47',3310491165,1),(52322904,424729073,15093731,439281,1,'2007-09-16 02:49:47',3310491165,1),(52322907,424729350,15092379,439281,1,'2007-09-16 02:58:00',3310491165,1),(52322910,424728936,15090910,439281,1,'2007-09-16 02:49:48',3310491165,1),(52322911,424728317,15087849,439281,1,'2007-09-16 02:49:48',3310491165,1),(52322915,424727938,15085476,439281,1,'2007-09-16 02:49:48',3310491165,1),(52322917,424727835,15083344,439281,1,'2007-09-16 02:49:48',3310491165,1),(52322919,424727973,15080386,439281,1,'2007-09-16 02:49:48',3310491165,1),(52322921,424728523,15078013,439281,1,'2007-09-16 02:49:48',3310491165,1),(52322924,424728798,15076431,439281,1,'2007-09-16 02:49:48',3310491165,1),(52322927,424729039,15074918,439281,1,'2007-09-16 02:49:48',3310491165,1),(52322929,424729108,15073577,439281,1,'2007-09-16 02:49:49',3310491165,1),(52322931,424729692,15071822,439281,1,'2007-09-16 02:49:49',3310491165,1),(52322934,424730415,15070791,439281,1,'2007-09-16 02:49:49',3310491165,1),(52322937,424731412,15069587,439281,1,'2007-09-16 02:49:49',3310491165,1),(52322940,424733097,15068590,439281,1,'2007-09-16 02:49:49',3310491165,1),(52322942,424734335,15068039,439281,1,'2007-09-16 02:49:49',3310491165,1),(52322945,424735711,15067867,439281,1,'2007-09-16 02:49:50',3310491165,1),(52322947,424737087,15068418,439281,1,'2007-09-16 02:49:50',3310491165,1),(52322950,424739013,15069312,439281,1,'2007-09-16 02:49:50',3310491208,1),(52322953,424740389,15069793,439281,1,'2007-09-16 02:49:50',3310491208,1),(52322955,424741386,15069690,439281,1,'2007-09-16 02:49:50',3310491208,1),(52322957,424741971,15068658,439281,1,'2007-09-16 02:49:50',3310491208,1),(52322959,424742418,15066698,439281,1,'2007-09-16 02:49:51',3310491208,1),(52322962,424742143,15065253,439281,1,'2007-09-16 02:49:51',3310491208,1),(52322964,424742280,15063534,439281,1,'2007-09-16 02:49:51',3310491208,1),(52322966,424742558,15061503,439281,1,'2007-09-16 02:49:51',3310491208,1),(52322969,424742855,15060136,439281,1,'2007-09-16 02:49:51',3310491208,1),(52322972,424743628,15058650,439281,1,'2007-09-16 02:49:51',3310491208,1),(52322974,424745292,15057224,439281,1,'2007-09-16 02:49:51',3310491208,1),(52322976,424747669,15055322,439281,1,'2007-09-16 02:49:52',3310491208,1),(52322977,424748739,15054668,439281,1,'2007-09-16 02:49:52',3310491208,1),(52322979,424749631,15054906,439281,1,'2007-09-16 02:49:52',3310491208,1),(52322982,424750106,15055084,439281,1,'2007-09-16 02:49:52',3310491208,1),(52327233,424745838,15048585,439281,1,'2007-09-16 02:57:29',3310491202,1),(52327235,424744998,15051169,439281,1,'2007-09-16 02:57:29',3310491202,1),(52327238,424744804,15053204,439281,1,'2007-09-16 02:57:29',3310491208,1),(52327241,424744578,15054367,439281,1,'2007-09-16 02:57:29',3310491208,1),(52327243,424744320,15055466,439281,1,'2007-09-16 02:57:29',3310491208,1),(52327246,424743092,15056726,439281,1,'2007-09-16 02:57:29',3310491208,1),(52327247,424742317,15058212,439281,1,'2007-09-16 02:57:30',3310491208,1),(52327250,424741832,15060796,439281,1,'2007-09-16 02:57:30',3310491208,1),(52327252,424741638,15062961,439281,1,'2007-09-16 02:57:30',3310491208,1),(52327263,424756854,15043267,439281,1,'2007-09-16 02:57:31',3310491202,1),(52327265,424755614,15044391,439281,1,'2007-09-16 02:57:31',3310491202,1),(52327268,424753598,15046834,439281,1,'2007-09-16 02:57:31',3310491202,1),(52327271,424752086,15048694,439281,1,'2007-09-16 02:57:31',3310491202,1),(52327274,424750884,15050051,439281,1,'2007-09-16 02:57:31',3310491202,1),(52327277,424750109,15051331,439281,1,'2007-09-16 02:57:31',3310491202,1),(52327279,424750070,15053075,439281,1,'2007-09-16 02:57:31',3310491208,1),(52327281,424749721,15056215,439281,1,'2007-09-16 02:57:31',3310491208,1),(52327282,424749023,15057533,439281,1,'2007-09-16 02:57:32',3310491208,1),(52327285,424747938,15059937,439281,1,'2007-09-16 02:57:32',3310491208,1),(52327287,424747163,15061720,439281,1,'2007-09-16 02:57:32',3310491208,1),(52327288,424746271,15063930,439281,1,'2007-09-16 02:57:32',3310491208,1),(52327290,424745845,15065597,439281,1,'2007-09-16 02:57:32',3310491208,1),(52327292,424745767,15066992,439281,1,'2007-09-16 02:57:33',3310491208,1),(52327295,424746000,15068272,439281,1,'2007-09-16 02:57:33',3310491208,1),(52327298,424746310,15069202,439281,1,'2007-09-16 02:57:33',3310491208,1),(52327300,424746570,15069818,439281,1,'2007-09-16 02:57:33',3310491208,1),(52327302,424746949,15070577,439281,1,'2007-09-16 02:57:34',3310491208,1),(52327303,424748056,15070766,439281,1,'2007-09-16 02:57:34',3310491208,1),(52327306,424748530,15070577,439281,1,'2007-09-16 02:57:34',3310491208,1),(52327309,424748941,15069470,439281,1,'2007-09-16 02:57:34',3310491208,1),(52327310,424749320,15068364,439281,1,'2007-09-16 02:57:34',3310491208,1),(52327313,424749794,15067289,439281,1,'2007-09-16 02:57:34',3310491208,1),(52327316,424750458,15065646,439281,1,'2007-09-16 02:57:35',3310491208,1),(52327317,424751217,15064476,439281,1,'2007-09-16 02:57:35',3310491208,1),(52327321,424752418,15063243,439281,1,'2007-09-16 02:57:35',3310491208,1),(52327325,424753398,15062295,439281,1,'2007-09-16 02:57:35',3310491208,1),(52327328,424754504,15061789,439281,1,'2007-09-16 02:57:35',3310491208,1),(52327329,424756337,15061663,439281,1,'2007-09-16 02:57:35',3310491208,1),(52327331,424757159,15061663,439281,1,'2007-09-16 02:57:36',3310491208,1),(52327333,424757696,15061884,439281,1,'2007-09-16 02:57:36',3310491208,1),(52327337,424747528,15070839,439281,1,'2007-09-16 02:57:36',3310491208,1),(52327339,424750528,15077400,439281,1,'2007-09-16 02:57:36',3310491208,1),(52327341,424751367,15074659,439281,1,'2007-09-16 02:57:36',3310491208,1),(52327342,424752430,15072058,439281,1,'2007-09-16 02:57:36',3310491208,1),(52327345,424753464,15069681,439281,1,'2007-09-16 02:57:37',3310491208,1),(52327347,424754359,15067640,439281,1,'2007-09-16 02:57:37',3310491208,1),(52327351,424755422,15064787,439281,1,'2007-09-16 02:57:37',3310491208,1),(52327354,424758275,15061040,439281,1,'2007-09-16 02:57:37',3310491208,1),(52327358,424759002,15059530,439281,1,'2007-09-16 02:57:37',3310491208,1),(52327359,424759141,15057460,439281,1,'2007-09-16 02:57:38',3310491208,1),(52327361,424759030,15055111,439281,1,'2007-09-16 02:57:38',3310491208,1),(52327362,424759030,15053182,439281,1,'2007-09-16 02:57:38',3310491208,1),(52327365,424759393,15051867,439281,1,'2007-09-16 02:57:38',3310491208,1),(52327368,424759729,15049965,439281,1,'2007-09-16 02:57:38',3310491202,1),(52327371,424760232,15049294,439281,1,'2007-09-16 02:57:38',3310491202,1),(52327372,424760875,15049182,439281,1,'2007-09-16 02:57:39',3310491202,1),(52327375,424761463,15049406,439281,1,'2007-09-16 02:57:39',3310491202,1),(52327378,424761966,15050077,439281,1,'2007-09-16 02:57:39',3310491202,1),(52327379,424762190,15051560,439281,1,'2007-09-16 02:57:39',3310491208,1),(52327381,424762777,15056202,439281,1,'2007-09-16 02:57:39',3310491208,1),(52327383,424763033,15058957,439281,1,'2007-09-16 02:57:39',3310491208,1),(52327384,424763434,15064366,439281,1,'2007-09-16 02:57:40',3310491208,1),(52327387,424763301,15066722,439281,1,'2007-09-16 02:57:40',3310491208,1),(52327388,424721063,15112879,439281,1,'2007-09-16 02:57:40',3310491167,1),(52327390,424721824,15111678,439281,1,'2007-09-16 02:57:40',3310491167,1),(52327392,424723026,15110917,439281,1,'2007-09-16 02:57:40',3310491167,1),(52327393,424723987,15110476,439281,1,'2007-09-16 02:57:40',3310491167,1),(52327398,424724988,15110036,439281,1,'2007-09-16 02:57:40',3310491167,1),(52327401,424726270,15109835,439281,1,'2007-09-16 02:57:40',3310491167,1),(52327403,424726750,15109195,439281,1,'2007-09-16 02:57:41',3310491167,1),(52327406,424728352,15103868,439281,1,'2007-09-16 02:57:41',3310491165,1),(52327408,424730755,15096980,439281,1,'2007-09-16 02:57:41',3310491165,1),(52327411,424730755,15094216,439281,1,'2007-09-16 02:57:41',3310491165,1),(52327413,424730395,15093575,439281,1,'2007-09-16 02:57:41',3310491165,1),(52327417,424729336,15093034,439281,1,'2007-09-16 02:57:41',3310491165,1),(52327418,424730406,15030447,439281,1,'2007-09-16 02:57:42',3310491159,1),(52327421,424729592,15032123,439281,1,'2007-09-16 02:57:42',3310491159,1),(52327423,424728443,15033727,439281,1,'2007-09-16 02:57:42',3310491159,1),(52327427,424727461,15034924,439281,1,'2007-09-16 02:57:42',3310491159,1),(52327429,424726839,15035954,439281,1,'2007-09-16 02:57:42',3310491159,1),(52327432,424726264,15037008,439281,1,'2007-09-16 02:57:42',3310491159,1),(52327434,424725737,15039139,439281,1,'2007-09-16 02:57:42',3310491159,1),(52328346,424726170,15045714,439281,1,'2007-09-16 02:59:18',3310491159,1),(52328347,424725790,15044674,439281,1,'2007-09-16 02:59:18',3310491159,1),(52328348,424724015,15044193,439281,1,'2007-09-16 02:59:19',3310491159,1),(52328350,424723317,15044193,439281,1,'2007-09-16 02:59:19',3310491159,1),(52328353,424722925,15043812,439281,1,'2007-09-16 02:59:19',3310491159,1),(52328354,424722646,15043356,439281,1,'2007-09-16 02:59:19',3310491159,1),(52328357,424722697,15042672,439281,1,'2007-09-16 02:59:19',3310491159,1),(52328358,424723026,15042165,439281,1,'2007-09-16 02:59:19',3310491159,1),(52328360,424723584,15041911,439281,1,'2007-09-16 02:59:20',3310491159,1),(52328362,424724649,15041886,439281,1,'2007-09-16 02:59:20',3310491159,1),(52328364,424725688,15041886,439281,1,'2007-09-16 02:59:20',3310491159,1),(52328365,424726145,15041455,439281,1,'2007-09-16 02:59:20',3310491159,1),(52328367,424726449,15040694,439281,1,'2007-09-16 02:59:20',3310491159,1),(52328370,424725299,15044319,439281,1,'2007-09-16 02:59:21',3310491159,1),(52328373,424724599,15044210,439281,1,'2007-09-16 02:59:21',3310491159,1),(52329934,424699435,14943807,439281,1,'2007-09-16 03:02:35',3310491156,1),(52329937,424699301,14946435,439281,1,'2007-09-16 03:02:35',3310491156,1),(52329940,424698994,14950009,439281,1,'2007-09-16 03:02:35',3310491156,1),(52329942,424698894,14951282,439281,1,'2007-09-16 03:02:35',3310491156,1),(52329943,424698441,14951936,439281,1,'2007-09-16 03:02:35',3310491156,1),(52329946,424697736,14952187,439281,1,'2007-09-16 03:02:35',3310491156,1),(52329948,424696680,14952187,439281,1,'2007-09-16 03:02:35',3310491156,1),(52329951,424694587,14952187,439281,1,'2007-09-16 03:02:35',3310491156,1),(52329953,424691595,14948897,439281,1,'2007-09-16 03:02:36',3310491156,1),(52329956,424691671,14950323,439281,1,'2007-09-16 03:02:36',3310491156,1),(52329957,424691424,14951520,439281,1,'2007-09-16 03:02:36',3310491156,1),(52329960,424690796,14952281,439281,1,'2007-09-16 03:02:36',3310491156,1),(52329962,424689827,14952946,439281,1,'2007-09-16 03:02:36',3310491156,1),(52329964,424688553,14953897,439281,1,'2007-09-16 03:02:36',3310491156,1),(52329967,424687944,14954638,439281,1,'2007-09-16 03:02:36',3310491156,1),(52329968,424687887,14955456,439281,1,'2007-09-16 03:02:36',3310491156,1),(52329970,424688325,14956311,439281,1,'2007-09-16 03:02:37',3310491156,1),(52329972,424688895,14956920,439281,1,'2007-09-16 03:02:37',3310491156,1),(52329974,424689979,14957300,439281,1,'2007-09-16 03:02:37',3310491156,1),(52329978,424692659,14958156,439281,1,'2007-09-16 03:02:37',3310491156,1),(52329981,424694979,14959049,439281,1,'2007-09-16 03:02:37',3310491156,1),(52330668,424692346,14933331,439281,1,'2007-09-16 03:04:37',3310490814,1),(52330669,424692472,14935143,439281,1,'2007-09-16 03:04:37',3310490814,1),(52330670,424692598,14937529,439281,1,'2007-09-16 03:04:37',3310490814,1),(52330671,424692179,14938952,439281,1,'2007-09-16 03:04:37',3310490814,1),(52330672,424690798,14941421,439281,1,'2007-09-16 03:04:37',3310490814,1),(52330673,424688705,14945397,439281,1,'2007-09-16 03:04:37',3310491156,1),(52330674,424687449,14947615,439281,1,'2007-09-16 03:04:37',3310491156,1),(52330675,424686612,14948411,439281,1,'2007-09-16 03:04:38',3310491156,1),(52330676,424685273,14948704,439281,1,'2007-09-16 03:04:38',3310491156,1),(52330677,424683934,14948704,439281,1,'2007-09-16 03:04:38',3310491156,1),(52330678,424683515,14948704,439281,1,'2007-09-16 03:04:38',3310491156,1),(52578581,424613114,14871296,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578583,424618507,14874900,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578586,424623063,14878054,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578587,424626729,14880620,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578590,424628404,14881772,27626,1,'2009-04-01 15:29:34',3310490808,4),(52578592,424629556,14882924,27626,1,'2009-04-01 15:29:34',3310490808,4),(52578594,424630185,14883815,27626,1,'2009-04-01 15:29:34',3310490808,4),(52578597,424630185,14884705,27626,1,'2009-04-01 15:29:34',3310490808,4),(52578598,424629452,14885071,27626,1,'2009-04-01 15:29:34',3310490808,4),(52578600,424627986,14884600,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578601,424626676,14884076,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578604,424625263,14883553,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578605,424623377,14883500,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578607,424620183,14883605,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578610,424617198,14884181,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578612,424614999,14884129,27626,1,'2009-04-01 15:29:35',3310490797,4),(52578614,424613323,14883448,27626,1,'2009-04-01 15:29:35',3310490797,4),(52578616,424611124,14881615,27626,1,'2009-04-01 15:29:35',3310490797,4),(52578617,424608872,14879573,27626,1,'2009-04-01 15:29:35',3310490797,4),(52578620,424607354,14878892,27626,1,'2009-04-01 15:29:35',3310490797,4),(52578621,424606568,14879521,27626,1,'2009-04-01 15:29:35',3310490797,4),(52578624,424606411,14880673,27626,1,'2009-04-01 15:29:35',3310490797,4),(52578626,424608349,14884914,27626,1,'2009-04-01 15:29:35',3310490797,4),(52578628,424610680,14890205,27626,1,'2009-04-01 15:29:35',3310490799,4),(52578630,424612212,14893779,27626,1,'2009-04-01 15:29:35',3310490799,4),(52578632,424612635,14896016,27626,1,'2009-04-01 15:29:35',3310490799,4),(52578634,424612562,14896306,27626,1,'2009-04-01 15:29:35',3310490799,4),(52578637,424611115,14898904,443749,1,'2007-09-16 13:35:16',3310490799,1),(52578638,424612328,14870489,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578640,424611638,14869552,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578642,424611835,14868763,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578644,424612328,14868024,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578646,424613166,14867826,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578648,424614300,14867974,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578650,424618492,14869355,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578651,424621253,14870686,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578653,424622387,14871179,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578654,424623176,14870933,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578656,424623570,14870193,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578657,424623472,14869355,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578659,424622929,14868517,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578662,424622042,14867136,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578663,424621302,14865805,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578665,424621351,14863980,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578666,424621549,14862353,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578668,424621499,14861121,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578669,424620908,14860282,27626,1,'2009-04-01 15:29:34',3310490797,4),(52578671,424620020,14859839,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578672,424618442,14859543,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578673,424616519,14859493,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578674,424614941,14859592,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578675,424612969,14859839,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578676,424611046,14860282,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578677,424608334,14861860,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578678,424606017,14863241,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578679,424603798,14864671,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578680,424602664,14865065,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578682,424601825,14865065,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578685,424601234,14864375,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578686,424601579,14863685,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578689,424602318,14862698,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578690,424604833,14860874,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578693,424606707,14859198,27626,1,'2009-04-01 15:29:33',3310490797,5),(52578697,424607397,14858704,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578699,424608679,14857620,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578701,424610158,14856634,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578703,424610898,14855795,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578705,424610849,14855105,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578707,424610011,14855006,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578708,424609222,14855302,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578711,424607940,14856338,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578713,424606855,14856880,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578715,424605770,14857028,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578716,424604735,14856979,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578719,424603551,14855992,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578720,424602318,14853281,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578722,424601727,14850618,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578724,424601036,14846723,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578725,424600642,14842581,27626,1,'2009-04-01 15:29:33',3310490797,4),(52578727,424600001,14836959,27626,1,'2009-04-01 15:29:32',3310490796,4),(52578728,424600001,14834494,27626,1,'2009-04-01 15:29:32',3310490796,4),(52578730,424600543,14832078,27626,1,'2009-04-01 15:29:32',3310490796,4),(52578733,424600790,14829958,27626,1,'2009-04-01 15:29:32',3310490791,4),(52578735,424600642,14829415,27626,1,'2009-04-01 15:29:32',3310490791,4),(52578738,424599557,14828577,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578740,424598670,14828478,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578743,424597831,14828281,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578746,424594873,14827591,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578748,424592851,14827344,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578750,424591175,14827098,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578753,424588413,14827394,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578754,424586540,14827591,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578757,424584370,14828133,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578760,424582940,14828528,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578761,424581757,14828676,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578764,424581264,14828281,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578767,424581757,14827049,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578769,424582496,14826408,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578770,424584272,14825619,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578773,424589153,14823104,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578774,424593640,14821822,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578775,424595958,14821230,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578776,424597437,14821181,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578778,424599902,14821575,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578780,424601825,14822118,27626,1,'2009-04-01 15:29:32',3310490791,4),(52578782,424603551,14821871,27626,1,'2009-04-01 15:29:32',3310490791,4),(52578783,424604833,14821082,27626,1,'2009-04-01 15:29:32',3310490791,4),(52578786,424605721,14819455,27626,1,'2009-04-01 15:29:32',3310490791,4),(52578788,424604932,14818715,27626,1,'2009-04-01 15:29:31',3310490791,4),(52578790,424604488,14819258,27626,1,'2009-04-01 15:29:31',3310490791,4),(52578792,424604143,14819652,27626,1,'2009-04-01 15:29:31',3310490791,4),(52578793,424603157,14820343,27626,1,'2009-04-01 15:29:31',3310490791,4),(52578794,424605651,14818831,27626,1,'2009-04-01 15:29:32',3310490791,4),(52578797,424605481,14820274,27626,1,'2009-04-01 15:29:32',3310490791,4),(52578800,424594104,14821703,27626,1,'2009-04-01 15:29:32',3310490790,4),(52578801,424605080,14824435,443749,1,'2007-09-16 13:35:52',3310490791,1),(52578802,424598118,14823026,443749,1,'2007-09-16 13:35:52',3310490790,1),(52578805,424601550,14823723,443749,1,'2007-09-16 13:35:53',3310490791,1),(52578806,424602269,14820441,27626,1,'2009-04-01 15:29:31',3310490791,4),(52578809,424601234,14820096,27626,1,'2009-04-01 15:29:31',3310490791,4),(52578810,424599853,14819356,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578813,424598670,14818420,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578814,424597388,14817187,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578817,424595711,14816447,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578818,424594281,14816102,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578820,424592555,14815905,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578822,424591076,14815856,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578825,424589153,14815510,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578826,424587181,14814919,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578829,424585504,14813587,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578830,424584420,14812157,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578833,424583828,14810234,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578835,424583236,14808163,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578837,424581757,14806487,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578839,424580130,14805895,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578841,424577467,14805008,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578843,424575002,14804416,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578845,424573356,14804177,27626,1,'2009-04-01 15:29:31',3310490790,4),(52578848,424571396,14804177,27626,1,'2009-04-01 15:29:30',3310490787,4),(52578852,424569181,14804177,27626,1,'2009-04-01 15:29:30',3310490787,4),(52578856,424567732,14805115,27626,1,'2009-04-01 15:29:30',3310490787,4),(52578858,424567051,14806563,27626,1,'2009-04-01 15:29:30',3310490787,4),(52578861,424566369,14809460,27626,1,'2009-04-01 15:29:30',3310490787,4),(52578863,424566114,14810227,27626,1,'2009-04-01 15:29:30',3310490787,4),(52578867,424565347,14809886,27626,1,'2009-04-01 15:29:30',3310490787,4),(52578871,424565261,14809375,27626,1,'2009-04-01 15:29:30',3310490787,4),(52578872,424565091,14806904,27626,1,'2009-04-01 15:29:30',3310490787,4),(52578875,424565091,14800343,27626,1,'2009-04-01 15:29:30',3310490787,4),(52578877,424564955,14795517,27626,1,'2009-04-01 15:29:30',3310490787,4),(52579067,424566045,14788810,27626,1,'2009-04-01 15:29:30',3310490787,4),(52579069,424567081,14784175,27626,1,'2009-04-01 15:29:30',3310490787,4),(52579071,424567736,14780630,27626,1,'2009-04-01 15:29:30',3310490787,4),(52579074,424568336,14776758,27626,1,'2009-04-01 15:29:30',3310490785,4),(52579075,424569590,14772669,27626,1,'2009-04-01 15:29:30',3310490785,4),(52579077,424571062,14769397,27626,1,'2009-04-01 15:29:30',3310490785,4),(52579079,424571880,14766398,27626,1,'2009-04-01 15:29:30',3310490785,4),(52579081,424572316,14763998,27626,1,'2009-04-01 15:29:30',3310490785,4),(52579083,424572589,14761817,27626,1,'2009-04-01 15:29:30',3310490785,4),(52579084,424572916,14759308,27626,1,'2009-04-01 15:29:30',3310490785,4),(52579087,424573516,14756909,27626,1,'2009-04-01 15:29:30',3310490788,4),(52579089,424574334,14755001,27626,1,'2009-04-01 15:29:30',3310490788,4),(52579091,424575152,14752983,27626,1,'2009-04-01 15:29:30',3310490788,4),(52579092,424575752,14750420,27626,1,'2009-04-01 15:29:30',3310490788,5),(52579096,424576243,14748457,27626,1,'2009-04-01 15:29:30',3310490788,4),(52579099,424577388,14746330,27626,1,'2009-04-01 15:29:30',3310490788,4),(52579100,424577715,14744749,27626,1,'2009-04-01 15:29:30',3310490788,4),(52579103,424577442,14743604,27626,1,'2009-04-01 15:29:30',3310490788,4),(52579104,424576952,14742731,27626,1,'2009-04-01 15:29:30',3310490788,4),(52579107,424575588,14742131,27626,1,'2009-04-01 15:29:30',3310490788,4),(52579108,424574334,14741913,27626,1,'2009-04-01 15:29:29',3310490788,4),(52579111,424573243,14741313,27626,1,'2009-04-01 15:29:29',3310490788,4),(52579113,424572807,14740495,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579115,424572672,14739065,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579117,424572420,14737585,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579118,424572141,14736273,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579121,424571527,14734542,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579122,424570717,14732755,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579125,424569907,14730884,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579126,424568400,14728567,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579129,424566278,14725942,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579131,424564711,14724410,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579133,424563167,14722480,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579135,424562154,14719971,27626,1,'2009-04-01 15:29:29',3310490763,4),(52579138,424560996,14717125,27626,1,'2009-04-01 15:29:29',3310490763,4),(52579140,424559838,14715340,27626,1,'2009-04-01 15:29:29',3310490763,4),(52579142,424558053,14713024,27626,1,'2009-04-01 15:29:29',3310490763,4),(52579145,424556991,14710756,27626,1,'2009-04-01 15:29:29',3310490763,4),(52579146,424556364,14709888,27626,1,'2009-04-01 15:29:29',3310490763,4),(52579149,424555592,14709936,27626,1,'2009-04-01 15:29:29',3310490763,4),(52579151,424555110,14710515,27626,1,'2009-04-01 15:29:29',3310490763,4),(52579153,424555110,14711480,27626,1,'2009-04-01 15:29:29',3310490763,4),(52579155,424554386,14714230,27626,1,'2009-04-01 15:29:29',3310490763,4),(52579159,424554097,14719103,27626,1,'2009-04-01 15:29:29',3310490763,4),(52579160,424554048,14722094,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579163,424553277,14723252,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579165,424552649,14724989,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579167,424552456,14726677,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579171,424552891,14729813,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579173,424553807,14733576,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579177,424554483,14735313,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579179,424554869,14736712,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579183,424554820,14737581,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579184,424554290,14737919,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579188,424553759,14737581,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579190,424552842,14735651,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579194,424551974,14733866,27626,1,'2009-04-01 15:29:29',3310490785,4),(52579199,424550864,14731164,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579201,424549948,14728993,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579203,424549369,14726533,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579206,424549127,14723976,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579208,424549996,14720984,27626,1,'2009-04-01 15:29:28',3310490763,4),(52579210,424550430,14719440,27626,1,'2009-04-01 15:29:28',3310490763,4),(52579211,424549899,14718813,27626,1,'2009-04-01 15:29:28',3310490763,4),(52579213,424549176,14718958,27626,1,'2009-04-01 15:29:28',3310490763,4),(52579216,424548741,14720212,27626,1,'2009-04-01 15:29:28',3310490763,4),(52579219,424547777,14723783,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579222,424547198,14726677,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579224,424546860,14730585,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579225,424546667,14733818,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579226,424546715,14736037,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579227,424547439,14738883,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579228,424547680,14739704,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579229,424547873,14740669,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579230,424547680,14741344,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579233,424546908,14741633,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579235,424546088,14741296,27626,1,'2009-04-01 15:29:28',3310490785,4),(52579236,424545461,14740476,27626,1,'2009-04-01 15:29:28',3310490784,4),(52579238,424544689,14737870,27626,1,'2009-04-01 15:29:28',3310490784,4),(52579240,424543338,14734011,27626,1,'2009-04-01 15:29:28',3310490784,4),(52579242,424542566,14730392,27626,1,'2009-04-01 15:29:28',3310490784,4),(52579243,424541746,14726388,27626,1,'2009-04-01 15:29:28',3310490784,4),(52579246,424541360,14723541,27626,1,'2009-04-01 15:29:28',3310490784,4),(52579248,424541553,14720888,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579250,424542084,14716980,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579252,424542566,14713603,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579254,424542807,14711190,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579257,424543193,14709164,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579258,424543434,14707283,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579261,424543627,14706125,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579262,424543531,14705256,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579265,424542904,14705063,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579266,424542180,14705835,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579269,424542180,14706366,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579270,424542084,14707958,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579271,424541842,14709068,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579274,424541263,14710274,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579275,424539334,14714278,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579277,424537307,14717848,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579279,424535860,14719778,27626,1,'2009-04-01 15:29:28',3310490762,4),(52579281,424535233,14722625,27626,1,'2009-04-01 15:29:28',3310490784,4),(52579282,424534027,14727208,27626,1,'2009-04-01 15:29:28',3310490784,4),(52579285,424533737,14731598,27626,1,'2009-04-01 15:29:28',3310490784,4),(52579287,424533689,14733094,27626,1,'2009-04-01 15:29:27',3310490784,4),(52579290,424534171,14734927,27626,1,'2009-04-01 15:29:27',3310490784,4),(52579292,424534123,14735796,27626,1,'2009-04-01 15:29:27',3310490784,4),(52579293,424533737,14736423,27626,1,'2009-04-01 15:29:27',3310490784,4),(52579296,424532965,14736519,27626,1,'2009-04-01 15:29:27',3310490784,4),(52579297,424532338,14736182,27626,1,'2009-04-01 15:29:27',3310490784,4),(52579299,424531566,14734155,27626,1,'2009-04-01 15:29:27',3310490784,4),(52579301,424531614,14732033,27626,1,'2009-04-01 15:29:27',3310490784,4),(52579303,424530456,14729041,27626,1,'2009-04-01 15:29:27',3310490784,4),(52579306,424530167,14726484,27626,1,'2009-04-01 15:29:27',3310490784,4),(52579308,424529829,14721997,27626,1,'2009-04-01 15:29:27',3310490784,4),(52579310,424529781,14717366,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579312,424530263,14713265,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579313,424531035,14708633,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579315,424531952,14701590,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579317,424532531,14696958,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579319,424532709,14693081,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579321,424532537,14689897,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579323,424531246,14688176,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579324,424530471,14686368,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579327,424530127,14683357,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579328,424530127,14680689,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579331,424530127,14678968,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579332,424529783,14677591,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579335,424529525,14676731,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579336,424528836,14675182,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579339,424528492,14673116,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579340,424529439,14670277,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579342,424530190,14667681,27626,1,'2009-04-01 15:29:27',3310490762,4),(52579343,424530851,14664993,27626,1,'2009-04-01 15:29:27',3310490760,4),(52579345,424530939,14662702,27626,1,'2009-04-01 15:29:27',3310490760,4),(52579347,424530455,14659882,27626,1,'2009-04-01 15:29:27',3310490760,4),(52579349,424529926,14657503,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579350,424529221,14654375,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579353,424529309,14651952,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579355,424529486,14648075,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579357,424528869,14646268,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579359,424527899,14643096,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579361,424526798,14640673,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579363,424525873,14637985,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579365,424524507,14635870,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579367,424523097,14634504,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579369,424522304,14632742,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579371,424521555,14630583,27626,1,'2009-04-01 15:29:26',3310490760,4),(52579373,424521070,14627103,27626,1,'2009-04-01 15:32:40',3310490760,10),(52579376,424520321,14625649,27626,1,'2009-04-01 15:32:40',3310490760,7),(52579377,424519660,14625516,27626,1,'2009-04-01 15:32:40',3310490760,7),(52579379,424518955,14625693,27626,1,'2009-04-01 15:32:40',3310490760,7),(52579381,424518427,14626354,27626,1,'2009-04-01 15:32:41',3310490760,7),(52579383,424518118,14627323,27626,1,'2009-04-01 15:32:41',3310490077,7),(52579386,424518030,14629173,27626,1,'2009-04-01 15:32:41',3310490077,7),(52579387,424517986,14632346,27626,1,'2009-04-01 15:32:41',3310490077,7),(52579389,424518427,14637192,27626,1,'2009-04-01 15:32:41',3310490760,7),(52579390,424519088,14640893,27626,1,'2009-04-01 15:32:41',3310490760,7),(52579393,424519528,14643977,27626,1,'2009-04-01 15:32:41',3310490760,7),(52579395,424519440,14645651,27626,1,'2009-04-01 15:32:41',3310490760,7),(52579397,424518691,14647149,27626,1,'2009-04-01 15:32:41',3310490760,7),(52579399,424516708,14650586,27626,1,'2009-04-01 15:32:41',3310490077,7),(52579401,424513889,14654639,27626,1,'2009-04-01 15:32:41',3310490077,7),(52579402,424512831,14656358,27626,1,'2009-04-01 15:32:41',3310490077,7),(52579405,424512259,14657988,27626,1,'2009-04-01 15:32:41',3310490077,7),(52579406,424511906,14660543,27626,1,'2009-04-01 15:32:41',3310490077,7),(52579409,424511245,14664156,27626,1,'2009-04-01 15:32:41',3310490077,7),(52579410,424511421,14668958,27626,1,'2009-04-01 15:32:41',3310490079,7),(52579413,424511421,14671954,27626,1,'2009-04-01 15:32:41',3310490079,7),(52579415,424511201,14675038,27626,1,'2009-04-01 15:32:41',3310490079,7),(52579416,424510761,14680370,27626,1,'2009-04-01 15:32:41',3310490079,7),(52579418,424510100,14686626,27626,1,'2009-04-01 15:32:41',3310490079,7),(52579420,424509219,14690767,27626,1,'2009-04-01 15:32:41',3310490079,7),(52594915,424508343,14693237,27626,1,'2009-04-01 15:32:41',3310490079,7),(52594920,424507087,14696692,27626,1,'2009-04-01 15:32:41',3310490079,7),(52594929,424505594,14700619,27626,1,'2009-04-01 15:32:41',3310490079,7),(52594931,424503631,14704231,27626,1,'2009-04-01 15:32:41',3310490079,7),(52594940,424501511,14708550,27626,1,'2009-04-01 15:32:41',3310490079,7),(52594946,424500254,14711848,27626,1,'2009-04-01 15:32:41',3310490079,7),(52594954,424499626,14714832,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594957,424499469,14715539,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594959,424499155,14716089,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594963,424498448,14716481,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594965,424497820,14716010,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594968,424497270,14714440,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594974,424496407,14710670,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594977,424496171,14708864,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594982,424496328,14706351,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594985,424496485,14705252,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594988,424496092,14704781,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594989,424495464,14704781,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594992,424494993,14705252,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594994,424494129,14705409,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594997,424493265,14705330,27626,1,'2009-04-01 15:32:42',3310490079,7),(52594999,424492716,14704702,27626,1,'2009-04-01 15:32:42',3310490079,7),(52595005,424492716,14704231,27626,1,'2009-04-01 15:32:42',3310490079,7),(52595009,424492951,14702974,27626,1,'2009-04-01 15:32:42',3310490079,7),(52595015,424493580,14702268,27626,1,'2009-04-01 15:32:42',3310490079,7),(52595021,424494600,14700461,27626,1,'2009-04-01 15:32:42',3310490079,7),(52595029,424495072,14698969,27626,1,'2009-04-01 15:32:42',3310490079,7),(52595034,424494836,14697634,27626,1,'2009-04-01 15:32:42',3310490079,7),(52595041,424494208,14696692,27626,1,'2009-04-01 15:32:42',3310490079,7),(52595042,424493030,14695985,27626,1,'2009-04-01 15:32:42',3310490079,7),(52595047,424492245,14695907,27626,1,'2009-04-01 15:32:42',3310490079,7),(52595051,424491538,14694886,27626,1,'2009-04-01 15:32:42',3310490079,7),(52595054,424490595,14692530,27626,1,'2009-04-01 15:32:42',3310490078,7),(52595059,424489103,14690959,27626,1,'2009-04-01 15:32:42',3310490078,7),(52595062,424487297,14690017,27626,1,'2009-04-01 15:32:42',3310490078,7),(52595064,424485334,14688525,27626,1,'2009-04-01 15:32:42',3310490078,7),(52595067,424483606,14685934,27626,1,'2009-04-01 15:32:42',3310490078,7),(52595070,424482585,14683185,27626,1,'2009-04-01 15:32:42',3310490078,7),(52595073,424481722,14679494,27626,1,'2009-04-01 15:32:42',3310490078,7),(52595074,424480308,14675175,27626,1,'2009-04-01 15:32:42',3310490078,7),(52595077,424478423,14670385,27626,1,'2009-04-01 15:32:42',3310490078,7),(52595079,424477158,14667499,27626,1,'2009-04-01 15:32:42',3310490078,7),(52595082,424475884,14665941,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595084,424473264,14664242,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595087,424470270,14662429,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595090,424468617,14661239,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595093,424467631,14660050,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595096,424467428,14658716,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595100,424467747,14657730,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595103,424468704,14657382,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595106,424469487,14657382,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595107,424470183,14657266,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595115,424470706,14656802,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595118,424471605,14655961,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595122,424472417,14654974,27626,1,'2009-04-01 15:32:42',3310490076,7),(52595125,424472562,14654249,27626,1,'2009-04-01 15:35:06',3310490076,14),(52595131,424472301,14653756,27626,1,'2009-04-01 15:35:06',3310490076,6),(52595134,424471982,14653524,27626,1,'2009-04-01 15:35:06',3310490076,6),(52595137,424471402,14653582,27626,1,'2009-04-01 15:35:06',3310490076,6),(52595140,424470358,14654394,27626,1,'2009-04-01 15:35:05',3310490076,6),(52595144,424469139,14655032,27626,1,'2009-04-01 15:35:05',3310490076,6),(52595145,424467370,14654829,27626,1,'2009-04-01 15:35:05',3310490076,6),(52595148,424463987,14654429,27626,1,'2009-04-01 15:35:05',3310490076,6),(52595151,424461129,14654429,27626,1,'2009-04-01 15:35:05',3310490073,6),(52595153,424459137,14654083,27626,1,'2009-04-01 15:35:05',3310490073,6),(52595154,424457523,14653740,27626,1,'2009-04-01 15:35:05',3310490073,6),(52595155,424454064,14651745,27626,1,'2009-04-01 15:35:05',3310490073,6),(52595157,424451137,14649971,27626,1,'2009-04-01 15:35:05',3310490073,6),(52595161,424449541,14649439,27626,1,'2009-04-01 15:35:05',3310490073,6),(52595162,424446925,14648818,27626,1,'2009-04-01 15:35:05',3310490073,6),(52595168,424444974,14648907,27626,1,'2009-04-01 15:35:05',3310490073,6),(52595169,424444081,14649774,27626,1,'2009-04-01 15:35:04',3310490073,6),(52595173,424442471,14651077,27626,1,'2009-04-01 15:35:04',3310490073,6),(52595176,424440939,14651537,27626,1,'2009-04-01 15:35:04',3310490073,6),(52595181,424439636,14651153,27626,1,'2009-04-01 15:35:04',3310490073,6),(52595184,424439330,14650081,27626,1,'2009-04-01 15:35:04',3310490073,6),(52595187,424439713,14648931,27626,1,'2009-04-01 15:35:04',3310490073,6),(52595188,424441245,14647475,27626,1,'2009-04-01 15:35:04',3310490073,6),(52595191,424443544,14646020,27626,1,'2009-04-01 15:35:04',3310490073,6),(52595193,424445230,14643874,27626,1,'2009-04-01 15:35:04',3310490073,6),(52595198,424447529,14641958,27626,1,'2009-04-01 15:35:04',3310490073,6),(52595201,424449273,14641024,27626,1,'2009-04-01 15:35:03',3310490073,6),(52595203,424450372,14640200,27626,1,'2009-04-01 15:35:03',3310490073,6),(52595483,424450529,14639102,27626,1,'2009-04-01 15:35:03',3310490073,6),(52595486,424450411,14638670,27626,1,'2009-04-01 15:35:03',3310490073,6),(52595489,424449822,14637807,27626,1,'2009-04-01 15:35:03',3310490073,6),(52595854,424449116,14637768,27626,1,'2009-04-01 15:35:03',3310490073,6),(52595856,424448332,14638396,27626,1,'2009-04-01 15:35:03',3310490073,6),(52595860,424447390,14639102,27626,1,'2009-04-01 15:35:03',3310490073,6),(52595861,424445742,14640122,27626,1,'2009-04-01 15:35:03',3310490073,6),(52595865,424443271,14641338,27626,1,'2009-04-01 15:35:03',3310490073,6),(52595868,424440760,14641691,27626,1,'2009-04-01 15:35:02',3310490073,6),(52595872,424438053,14642280,27626,1,'2009-04-01 15:35:02',3310490073,6),(52595874,424436680,14642240,27626,1,'2009-04-01 15:35:02',3310490073,6),(52595878,424434444,14641377,27626,1,'2009-04-01 15:35:02',3310490072,6),(52595880,424431776,14639416,27626,1,'2009-04-01 15:35:02',3310490072,6),(52596149,424535464,14735997,443749,1,'2007-09-16 14:33:49',3310490784,1),(52596154,424535023,14734423,443749,1,'2007-09-16 14:33:50',3310490784,1),(52596158,424535361,14737772,443749,1,'2007-09-16 14:33:50',3310490784,1),(52596161,424535486,14738669,443749,1,'2007-09-16 14:33:51',3310490784,1),(52596163,424536216,14739878,443749,1,'2007-09-16 14:33:51',3310490784,1),(52596167,424536966,14740879,443749,1,'2007-09-16 14:33:51',3310490784,1),(52596171,424537446,14741921,443749,1,'2007-09-16 14:33:51',3310490784,1),(52596178,424537446,14743151,443749,1,'2007-09-16 14:33:52',3310490784,1),(52596180,424536966,14744298,443749,1,'2007-09-16 14:33:52',3310490784,1),(52596184,424536195,14745590,443749,1,'2007-09-16 14:33:53',3310490784,1),(52596186,424534769,14747800,443749,1,'2007-09-16 14:33:53',3310490784,1),(52596191,424533693,14750477,443749,1,'2007-09-16 14:33:53',3310490784,1),(52596195,424532667,14754656,443749,1,'2007-09-16 14:33:53',3310490784,1),(52596197,424531697,14757468,443749,1,'2007-09-16 14:33:54',3310490784,1),(52596200,424531066,14759119,443749,1,'2007-09-16 14:33:54',3310490784,1),(52596204,424530406,14759749,443749,1,'2007-09-16 14:33:55',3310490784,1),(52596208,424529535,14760170,443749,1,'2007-09-16 14:33:55',3310490784,1),(52596212,424527884,14760410,443749,1,'2007-09-16 14:33:55',3310490784,1),(52596213,424526533,14760860,443749,1,'2007-09-16 14:33:55',3310490784,1),(52596216,424525062,14762361,443749,1,'2007-09-16 14:33:55',3310490784,1),(52596219,424524012,14763853,443749,1,'2007-09-16 14:33:56',3310490784,1),(52596222,424522153,14765625,443749,1,'2007-09-16 14:33:56',3310490784,1),(52596226,424520986,14766360,443749,1,'2007-09-16 14:33:57',3310490784,1),(52596228,424519646,14766706,443749,1,'2007-09-16 14:33:57',3310490784,1),(52596231,424517873,14766533,443749,1,'2007-09-16 14:33:57',3310490101,1),(52596234,424513463,14765150,443749,1,'2007-09-16 14:33:58',3310490101,1),(52596236,424508967,14762686,443749,1,'2007-09-16 14:33:58',3310490101,1),(52596238,424504903,14760048,443749,1,'2007-09-16 14:33:58',3310490101,1),(52596241,424504212,14758103,443749,1,'2007-09-16 14:33:58',3310490101,1),(52596243,424502612,14756633,443749,1,'2007-09-16 14:33:58',3310490101,1),(52596246,424501747,14754904,443749,1,'2007-09-16 14:33:59',3310490101,1),(52596249,424500753,14753563,443749,1,'2007-09-16 14:33:59',3310490101,1),(52596271,424497640,14751575,443749,1,'2007-09-16 14:34:04',3310490101,1),(52596274,424496289,14749621,443749,1,'2007-09-16 14:34:04',3310490101,1),(52596277,424494576,14746893,443749,1,'2007-09-16 14:34:04',3310490101,1),(52596280,424493814,14744926,443749,1,'2007-09-16 14:34:04',3310490101,1),(52596283,424493751,14742451,443749,1,'2007-09-16 14:34:05',3310490101,1),(52596285,424493365,14740501,443749,1,'2007-09-16 14:34:05',3310490101,1),(52596288,424492617,14739104,443749,1,'2007-09-16 14:34:06',3310490101,1),(52596291,424491708,14738032,443749,1,'2007-09-16 14:34:06',3310490101,1),(52596295,424490116,14736635,443749,1,'2007-09-16 14:34:06',3310490100,1),(52596297,424488687,14735400,443749,1,'2007-09-16 14:34:07',3310490100,1),(52596299,424487517,14733613,443749,1,'2007-09-16 14:34:08',3310490100,1),(52596300,424486218,14730300,443749,1,'2007-09-16 14:34:08',3310490100,1),(52596303,424484756,14727863,443749,1,'2007-09-16 14:34:09',3310490100,1),(52596305,424482644,14725167,443749,1,'2007-09-16 14:34:09',3310490100,1),(52596308,424480402,14722828,443749,1,'2007-09-16 14:34:10',3310490100,1),(52596310,424477024,14719676,443749,1,'2007-09-16 14:34:10',3310490078,1),(52596312,424472898,14716233,443749,1,'2007-09-16 14:34:10',3310490078,1),(52596314,424470986,14714822,443749,1,'2007-09-16 14:34:10',3310490078,1),(52596318,424466698,14711983,443749,1,'2007-09-16 14:34:10',3310490078,1),(52596320,424461019,14708796,443749,1,'2007-09-16 14:34:11',3310490075,1),(52596326,424458528,14708043,443749,1,'2007-09-16 14:34:12',3310490075,1),(52596331,424456442,14708507,443749,1,'2007-09-16 14:34:13',3310490075,1),(52596335,424449315,14712157,443749,1,'2007-09-16 14:34:14',3310490075,1),(52596339,424441956,14716387,443749,1,'2007-09-16 14:34:15',3310490075,1),(52596343,424440681,14716271,443749,1,'2007-09-16 14:34:16',3310490075,1),(52596346,424439174,14716039,443749,1,'2007-09-16 14:34:17',3310490075,1),(52596351,424436857,14712852,443749,1,'2007-09-16 14:34:20',3310490075,1),(52603531,424756700,14864202,443749,1,'2007-09-16 14:56:49',3310490856,1),(52603533,424755816,14860409,443749,1,'2007-09-16 14:56:49',3310490856,1),(52603536,424755193,14856407,443749,1,'2007-09-16 14:56:49',3310490856,1),(52603537,424754673,14853757,443749,1,'2007-09-16 14:56:49',3310490856,1),(52603540,424754049,14850743,443749,1,'2007-09-16 14:56:50',3310490856,1),(52603542,424753945,14847418,443749,1,'2007-09-16 14:56:50',3310490856,1),(52612605,424754245,14844324,443749,1,'2007-09-16 15:22:54',3310490856,1),(52612609,424755393,14841383,443749,1,'2007-09-16 15:22:54',3310490856,1),(52612612,424755967,14839088,443749,1,'2007-09-16 15:22:55',3310490856,1),(52612615,424756325,14837438,443749,1,'2007-09-16 15:22:55',3310490856,1),(52612616,424756469,14835358,443749,1,'2007-09-16 15:22:55',3310490856,1),(52612619,424756756,14832777,443749,1,'2007-09-16 15:22:55',3310490856,1),(52612622,424756899,14830912,443749,1,'2007-09-16 15:22:55',3310490850,1),(52612624,424757688,14827326,443749,1,'2007-09-16 15:22:55',3310490850,1),(52612626,424758907,14823525,443749,1,'2007-09-16 15:22:56',3310490850,1),(52612629,424759481,14820154,443749,1,'2007-09-16 15:22:56',3310490850,1),(52612634,424760485,14816639,443749,1,'2007-09-16 15:22:56',3310490850,1),(52612635,424761776,14813771,443749,1,'2007-09-16 15:22:57',3310490850,1),(52612638,424763354,14811332,443749,1,'2007-09-16 15:22:58',3310490850,1),(52612640,424765721,14808391,443749,1,'2007-09-16 15:22:59',3310490851,1),(52612642,424768661,14806455,443749,1,'2007-09-16 15:23:00',3310490851,1),(52612645,424771961,14804016,443749,1,'2007-09-16 15:23:00',3310490851,1),(52612646,424773897,14802223,443749,1,'2007-09-16 15:23:01',3310490851,1),(52612649,424774973,14800717,443749,1,'2007-09-16 15:23:02',3310490851,1),(52612651,424775547,14798422,443749,1,'2007-09-16 15:23:03',3310490851,1),(52612653,424776120,14793474,443749,1,'2007-09-16 15:23:04',3310490851,1),(52612656,424776336,14789601,443749,1,'2007-09-16 15:23:05',3310490851,1),(52612658,424776049,14786947,443749,1,'2007-09-16 15:23:05',3310490851,1),(52612660,424775475,14783935,443749,1,'2007-09-16 15:23:06',3310490851,1),(52612661,424774471,14779918,443749,1,'2007-09-16 15:23:07',3310490851,1),(52612664,424772821,14776978,443749,1,'2007-09-16 15:23:08',3310490851,1),(52612665,424771243,14774611,443749,1,'2007-09-16 15:23:08',3310490849,1),(52612667,424770239,14772388,443749,1,'2007-09-16 15:23:08',3310490849,1),(52612670,424769522,14769447,443749,1,'2007-09-16 15:23:09',3310490849,1),(52612672,424769092,14767511,443749,1,'2007-09-16 15:23:09',3310490849,1),(52612675,424768805,14765144,443749,1,'2007-09-16 15:23:09',3310490849,1),(52612677,424769450,14761629,443749,1,'2007-09-16 15:23:09',3310490849,1),(52612678,424770096,14758402,443749,1,'2007-09-16 15:23:09',3310490849,1),(52612681,424771458,14753955,443749,1,'2007-09-16 15:23:10',3310490849,1),(52612684,424771446,14751162,443749,1,'2007-09-16 15:23:10',3310490849,1),(52612686,424771393,14747577,443749,1,'2007-09-16 15:23:10',3310490849,1),(52612688,424771024,14743305,443749,1,'2007-09-16 15:23:11',3310490849,1),(52612691,424770497,14740669,443749,1,'2007-09-16 15:23:11',3310490849,1),(52612692,424769706,14738190,443749,1,'2007-09-16 15:23:11',3310490849,1),(52612694,424769653,14736555,443749,1,'2007-09-16 15:23:11',3310490849,1),(52612696,424770128,14733972,443749,1,'2007-09-16 15:23:11',3310490849,1),(52612699,424771182,14731757,443749,1,'2007-09-16 15:23:12',3310490849,1),(52612701,424773133,14728962,443749,1,'2007-09-16 15:23:12',3310490849,1),(52612704,424774293,14727433,443749,1,'2007-09-16 15:23:12',3310490849,1),(52612708,424774768,14726114,443749,1,'2007-09-16 15:23:12',3310490849,1),(52612710,424775559,14723689,443749,1,'2007-09-16 15:23:12',3310490849,1),(52612712,424776350,14722634,443749,1,'2007-09-16 15:23:13',3310490849,1),(52612716,424777616,14721790,443749,1,'2007-09-16 15:23:13',3310490827,1),(52612717,424779409,14721105,443749,1,'2007-09-16 15:23:13',3310490827,1),(52612719,424780569,14720472,443749,1,'2007-09-16 15:23:13',3310490827,1),(52612720,424780991,14719628,443749,1,'2007-09-16 15:23:13',3310490827,1),(52612722,424780569,14718204,443749,1,'2007-09-16 15:23:14',3310490827,1),(52612725,424779672,14717202,443749,1,'2007-09-16 15:23:14',3310490827,1),(52612728,424778934,14716253,443749,1,'2007-09-16 15:23:14',3310490827,1),(52612732,424778459,14714091,443749,1,'2007-09-16 15:23:14',3310490827,1),(52612735,424778301,14710611,443749,1,'2007-09-16 15:23:15',3310490827,1),(52612738,424778143,14707605,443749,1,'2007-09-16 15:23:15',3310490827,1),(52612740,424777405,14704863,443749,1,'2007-09-16 15:23:16',3310490827,1),(52612742,424777774,14702490,443749,1,'2007-09-16 15:23:17',3310490827,1),(52612744,424778618,14700012,443749,1,'2007-09-16 15:23:17',3310490827,1),(52612746,424778828,14698324,443749,1,'2007-09-16 15:23:17',3310490827,1),(52612748,424778776,14696057,443749,1,'2007-09-16 15:23:17',3310490827,1),(52612750,424778037,14693315,443749,1,'2007-09-16 15:23:18',3310490827,1),(52612752,424777563,14691891,443749,1,'2007-09-16 15:23:18',3310490827,1),(52612754,424777616,14690203,443749,1,'2007-09-16 15:23:19',3310490827,1),(52612756,424779092,14687619,443749,1,'2007-09-16 15:23:19',3310490827,1),(52612758,424780041,14685932,443749,1,'2007-09-16 15:23:19',3310490827,1),(52612760,424780938,14685194,443749,1,'2007-09-16 15:23:19',3310490827,1),(52612761,424781834,14684983,443749,1,'2007-09-16 15:23:20',3310490827,1),(52612763,424782994,14684772,443749,1,'2007-09-16 15:23:20',3310490827,1),(52612765,424784102,14684666,443749,1,'2007-09-16 15:23:20',3310490827,1),(52612768,424784998,14683717,443749,1,'2007-09-16 15:23:21',3310490827,1),(52612770,424786158,14681661,443749,1,'2007-09-16 15:23:21',3310490827,1),(52612773,424787266,14680289,443749,1,'2007-09-16 15:23:21',3310490827,1),(52612776,424788479,14678813,443749,1,'2007-09-16 15:23:21',3310490827,1),(52612779,424789902,14677178,443749,1,'2007-09-16 15:23:21',3310490827,1),(52612782,424790852,14675122,443749,1,'2007-09-16 15:23:22',3310490827,1),(52612786,424791010,14672643,443749,1,'2007-09-16 15:23:22',3310490827,1),(52612789,424790324,14670218,443749,1,'2007-09-16 15:23:22',3310490827,1),(52612791,424789217,14668477,443749,1,'2007-09-16 15:23:22',3310490827,1),(52612794,424787529,14667792,443749,1,'2007-09-16 15:23:22',3310490827,1),(52612796,424785104,14666843,443749,1,'2007-09-16 15:23:23',3310490825,1),(52612800,424783785,14666263,443749,1,'2007-09-16 15:23:23',3310490825,1),(52612803,424781887,14664786,443749,1,'2007-09-16 15:23:23',3310490825,1),(52612804,424780621,14663046,443749,1,'2007-09-16 15:23:23',3310490825,1),(52612807,424780621,14661253,443749,1,'2007-09-16 15:23:24',3310490825,1),(52612810,424781307,14659460,443749,1,'2007-09-16 15:23:24',3310490825,1),(52612813,424783891,14657034,443749,1,'2007-09-16 15:23:25',3310490825,1),(52612815,424785886,14655511,443749,1,'2007-09-16 15:23:25',3310490825,1),(52612817,424788070,14654251,443749,1,'2007-09-16 15:23:26',3310490825,1),(52612820,424790253,14653915,443749,1,'2007-09-16 15:23:26',3310490825,1),(52612824,424791933,14652991,443749,1,'2007-09-16 15:23:26',3310490825,1),(52612827,424793444,14651228,443749,1,'2007-09-16 15:23:26',3310490828,1),(52612831,424794452,14648372,443749,1,'2007-09-16 15:23:27',3310490828,1),(52612835,424795796,14645097,443749,1,'2007-09-16 15:23:28',3310490828,1),(52612840,424796384,14641990,443749,1,'2007-09-16 15:23:28',3310490828,1),(52612843,424795964,14639471,443749,1,'2007-09-16 15:23:28',3310490828,1),(52612845,424794788,14637959,443749,1,'2007-09-16 15:23:28',3310490828,1),(52612849,424793276,14637455,443749,1,'2007-09-16 15:23:29',3310490828,1),(52612853,424790925,14637539,443749,1,'2007-09-16 15:23:29',3310490825,1),(52612855,424789581,14637539,443749,1,'2007-09-16 15:23:30',3310490825,1),(52612859,424788154,14637287,443749,1,'2007-09-16 15:23:30',3310490825,1),(52612862,424786894,14636028,443749,1,'2007-09-16 15:23:31',3310490825,1),(52612864,424785299,14635188,443749,1,'2007-09-16 15:23:31',3310490825,1),(52612867,424784039,14634180,443749,1,'2007-09-16 15:23:31',3310490825,1),(52612870,424783031,14632584,443749,1,'2007-09-16 15:23:32',3310490825,1),(52612873,424782947,14630401,443749,1,'2007-09-16 15:23:32',3310490825,1),(52612877,424783367,14627714,443749,1,'2007-09-16 15:23:32',3310490825,1),(52612882,424784039,14626202,443749,1,'2007-09-16 15:23:32',3310490825,1),(52612885,424784963,14624355,443749,1,'2007-09-16 15:23:33',3310490825,1),(52612888,424786474,14622759,443749,1,'2007-09-16 15:23:33',3310490825,1),(52612892,424788154,14622003,443749,1,'2007-09-16 15:23:34',3310490825,1),(52612893,424789665,14620743,443749,1,'2007-09-16 15:23:34',3310490825,1),(52612895,424790757,14619400,443749,1,'2007-09-16 15:23:34',3310490825,1),(52612897,424791513,14618728,443749,1,'2007-09-16 15:23:34',3310490825,1),(52612899,424792521,14618308,443749,1,'2007-09-16 15:23:34',3310490825,1),(52612900,424794284,14618308,443749,1,'2007-09-16 15:23:34',3310490828,1),(52612902,424795796,14618308,443749,1,'2007-09-16 15:23:35',3310490828,1),(52612907,424796468,14617636,443749,1,'2007-09-16 15:23:36',3310490828,1),(52612909,424796804,14616377,443749,1,'2007-09-16 15:23:36',3310490828,1),(52612911,424797223,14614361,443749,1,'2007-09-16 15:23:36',3310490828,1),(52612913,424797811,14611926,443749,1,'2007-09-16 15:23:37',3310490822,1),(52612916,424798399,14610498,443749,1,'2007-09-16 15:23:38',3310490822,1),(52612918,424799323,14609994,443749,1,'2007-09-16 15:23:38',3310490822,1),(52612920,424800583,14609490,443749,1,'2007-09-16 15:23:38',3310490822,1),(52612923,424802094,14609154,443749,1,'2007-09-16 15:23:39',3310490822,1),(52612927,424803606,14608567,443749,1,'2007-09-16 15:23:39',3310490822,1),(52612929,424805117,14607643,443749,1,'2007-09-16 15:23:40',3310490822,1),(52612932,424806377,14606467,443749,1,'2007-09-16 15:23:40',3310490822,1),(52612935,424806881,14604200,443749,1,'2007-09-16 15:23:41',3310490822,1),(52612936,424807301,14600841,443749,1,'2007-09-16 15:23:41',3310490822,1),(52612939,424808393,14596054,443749,1,'2007-09-16 15:23:42',3310490822,1),(52612941,424809538,14592416,443749,1,'2007-09-16 15:23:43',3310490822,1),(52612943,424810599,14590004,443749,1,'2007-09-16 15:23:43',3310490822,1),(52612946,424812336,14589136,443749,1,'2007-09-16 15:23:43',3310490822,1),(52612948,424816870,14587496,443749,1,'2007-09-16 15:23:43',3310490822,1),(52612951,424819147,14586936,443749,1,'2007-09-16 15:23:43',3310490822,1),(52612954,424822698,14586087,443749,1,'2007-09-16 15:23:43',3310490823,1),(52612957,424825090,14585443,443749,1,'2007-09-16 21:50:21',3310490823,1),(52612958,424827869,14584634,443749,1,'2007-09-16 21:50:22',3310490823,1),(52612962,424830339,14585084,443749,1,'2007-09-16 15:23:44',3310490823,1),(52612967,424832268,14585238,443749,1,'2007-09-16 15:23:45',3310490823,1),(52612973,424835201,14584466,443749,1,'2007-09-16 15:23:45',3310490823,1),(52612976,424837516,14583154,443749,1,'2007-09-16 15:23:45',3310490823,1),(52612978,424839292,14581225,443749,1,'2007-09-16 15:23:45',3310490823,1),(52612981,424841375,14577829,443749,1,'2007-09-16 15:23:45',3310490823,1),(52612983,424842765,14575205,443749,1,'2007-09-16 15:23:46',3310490823,1),(52612986,424843922,14571731,443749,1,'2007-09-16 15:23:46',3310490823,1),(52612989,424844077,14568876,443749,1,'2007-09-16 15:23:46',3310490823,1),(52612992,424843768,14565634,443749,1,'2007-09-16 15:23:46',3310490823,1),(52612994,424842996,14561543,443749,1,'2007-09-16 15:23:47',3310490823,1),(52612996,424842379,14557298,443749,1,'2007-09-16 15:23:47',3310490823,1),(52612998,424840990,14551124,443749,1,'2007-09-16 15:23:47',3310490821,1),(52613000,424839909,14547728,443749,1,'2007-09-16 15:23:47',3310490821,1),(52613003,424838443,14545104,443749,1,'2007-09-16 15:23:47',3310490821,1),(52613006,424837439,14543251,443749,1,'2007-09-16 15:23:47',3310490821,1),(52613008,424837362,14542017,443749,1,'2007-09-16 15:23:47',3310490821,1),(52613010,424837748,14541168,443749,1,'2007-09-16 15:23:48',3310490821,1),(52613013,424838674,14540704,443749,1,'2007-09-16 15:23:48',3310490821,1),(52613016,424839678,14541013,443749,1,'2007-09-16 15:23:48',3310490821,1),(52613017,424841144,14542325,443749,1,'2007-09-16 15:23:49',3310490821,1),(52613020,424842302,14542634,443749,1,'2007-09-16 15:23:49',3310490821,1),(52613021,424843845,14542557,443749,1,'2007-09-16 15:23:49',3310490821,1),(52613024,424845003,14542171,443749,1,'2007-09-16 15:23:49',3310490821,1),(52613027,424846006,14541399,443749,1,'2007-09-16 15:23:50',3310490821,1),(52613030,424846701,14540087,443749,1,'2007-09-16 15:23:50',3310490821,1),(52613032,424847164,14538003,443749,1,'2007-09-16 15:23:50',3310490821,1),(52613034,424847396,14535379,443749,1,'2007-09-16 15:23:50',3310490821,1),(52613037,424847010,14532832,443749,1,'2007-09-16 15:23:50',3310490821,1),(52613039,424846778,14530362,443749,1,'2007-09-16 15:23:51',3310490821,1),(52613041,424847704,14527584,443749,1,'2007-09-16 15:23:51',3310490821,1),(52613044,424848598,14525989,443749,1,'2007-09-16 15:23:51',3310490832,1),(52613047,424849581,14525268,443749,1,'2007-09-16 15:23:51',3310490832,1),(52613049,424851220,14525858,443749,1,'2007-09-16 15:23:51',3310490832,1),(52613052,424852990,14527366,443749,1,'2007-09-16 15:23:51',3310490832,1),(52613054,424854432,14529201,443749,1,'2007-09-16 15:23:52',3310490832,1),(52613056,424855284,14530185,443749,1,'2007-09-16 15:23:52',3310490832,1),(52613058,424856071,14530709,443749,1,'2007-09-16 15:23:52',3310490832,1),(52613061,424858153,14530764,443749,1,'2007-09-16 15:23:52',3310490832,1),(52613062,424858759,14529988,443749,1,'2007-09-16 15:23:52',3310490832,1),(52613065,424859218,14528415,443749,1,'2007-09-16 15:23:52',3310490832,1),(52613067,424859349,14525727,443749,1,'2007-09-16 15:23:53',3310490832,1),(52613070,424859545,14523564,443749,1,'2007-09-16 15:23:53',3310490832,1),(52613072,424860725,14522384,443749,1,'2007-09-16 15:23:53',3310490832,1);
INSERT INTO `nodes` VALUES (52613074,424861971,14521663,443749,1,'2007-09-16 15:23:53',3310490832,1),(52613076,424862973,14520921,443749,1,'2007-09-16 15:23:53',3310490832,1),(52613080,424856869,14531058,443749,1,'2007-09-16 15:23:54',3310490832,1),(52613083,424863791,14519788,443749,1,'2007-09-16 15:23:54',3310490832,1),(52613086,424864546,14518655,443749,1,'2007-09-16 15:23:54',3310490832,1),(52613088,424864986,14517271,443749,1,'2007-09-16 15:23:54',3310490832,1),(52613091,424865175,14515697,443749,1,'2007-09-16 15:23:55',3310490832,1),(52613092,424865553,14513432,443749,1,'2007-09-16 15:23:55',3310490832,1),(52613094,424865993,14511040,443749,1,'2007-09-16 15:23:55',3310490832,1),(52613097,424866748,14508586,443749,1,'2007-09-16 15:23:55',3310490832,1),(52613099,424867252,14506761,443749,1,'2007-09-16 15:23:55',3310490832,1),(52613101,424867944,14504873,443749,1,'2007-09-16 15:23:55',3310490832,1),(52613104,424868573,14504244,443749,1,'2007-09-16 15:23:56',3310490832,1),(52613107,424869203,14504181,443749,1,'2007-09-16 15:23:56',3310490832,1),(52613110,424869580,14504621,443749,1,'2007-09-16 15:23:57',3310490832,1),(52613113,424869832,14505062,443749,1,'2007-09-16 15:23:57',3310490832,1),(52613115,424869895,14505377,443749,1,'2007-09-16 15:23:57',3310490832,1),(52613117,424869958,14506635,443749,1,'2007-09-16 15:23:57',3310490832,1),(52613119,424870084,14510096,443749,1,'2007-09-16 15:23:57',3310490832,1),(52613121,424870336,14512865,443749,1,'2007-09-16 15:23:58',3310490832,1),(52613124,424871028,14515068,443749,1,'2007-09-16 15:23:58',3310490832,1),(52613126,424871846,14516767,443749,1,'2007-09-16 15:23:58',3310490832,1),(52613129,424872853,14517648,443749,1,'2007-09-16 15:23:58',3310490832,1),(52613132,424874111,14518341,443749,1,'2007-09-16 15:23:58',3310490832,1),(52613135,424875433,14518844,443749,1,'2007-09-16 15:23:58',3310490833,1),(52613139,424876481,14519245,443749,1,'2007-09-16 15:23:58',3310490833,1),(52613142,424877447,14519309,443749,1,'2007-09-16 15:23:59',3310490833,1),(52613145,424878285,14519245,443749,1,'2007-09-16 15:23:59',3310490833,1),(52613148,424879316,14519148,443749,1,'2007-09-16 15:23:59',3310490833,1),(52613149,424880412,14518826,443749,1,'2007-09-16 15:24:00',3310490833,1),(52613151,424881346,14518020,443749,1,'2007-09-16 15:24:00',3310490833,1),(52613154,424882603,14516216,443749,1,'2007-09-16 15:24:00',3310490833,1),(52613157,424883827,14514798,443749,1,'2007-09-16 15:24:00',3310490833,1),(52613159,424885438,14513703,443749,1,'2007-09-16 15:24:01',3310490833,1),(52613162,424888467,14511351,443749,1,'2007-09-16 15:24:02',3310490833,1),(52613163,424890110,14510094,443749,1,'2007-09-16 15:24:02',3310490833,1),(52613166,424891141,14509095,443749,1,'2007-09-16 15:24:03',3310490833,1),(52613167,424891496,14508257,443749,1,'2007-09-16 15:24:04',3310490833,1),(52613170,424892044,14506034,443749,1,'2007-09-16 15:24:04',3310490833,1),(52613172,424892817,14503875,443749,1,'2007-09-16 15:24:05',3310490833,1),(52613173,424893203,14502103,443749,1,'2007-09-16 15:24:05',3310490747,1),(52613175,424893493,14499429,443749,1,'2007-09-16 15:24:06',3310490747,1),(52613176,424894073,14497238,443749,1,'2007-09-16 15:24:07',3310490747,1),(52613178,424894686,14495756,443749,1,'2007-09-16 15:24:07',3310490747,1),(52613179,424895781,14494499,443749,1,'2007-09-16 15:24:07',3310490747,1),(52613182,424897231,14493371,443749,1,'2007-09-16 15:24:08',3310490747,1),(52613184,424899261,14492276,443749,1,'2007-09-16 15:24:09',3310490747,1),(52613186,424901006,14491587,443749,1,'2007-09-16 15:24:09',3310490747,1),(52613189,424902954,14490399,443749,1,'2007-09-16 15:24:10',3310490750,1),(52613192,424904550,14489485,443749,1,'2007-09-16 15:24:10',3310490750,1),(52613196,424905599,14487588,443749,1,'2007-09-16 15:24:11',3310490750,1),(52613199,424906769,14484925,443749,1,'2007-09-16 15:24:11',3310490750,1),(52613201,424907778,14481696,443749,1,'2007-09-16 15:24:11',3310490750,1),(52613204,424908545,14478145,443749,1,'2007-09-16 15:24:11',3310490750,1),(52613212,424911128,14467936,443749,1,'2007-09-16 15:24:12',3310490750,1),(52613214,424912217,14464384,443749,1,'2007-09-16 15:24:12',3310490750,1),(52613217,424912540,14462811,443749,1,'2007-09-16 15:24:13',3310490750,1),(52613221,424913145,14461075,443749,1,'2007-09-16 15:24:13',3310490750,1),(52613223,424914114,14459582,443749,1,'2007-09-16 15:24:13',3310490750,1),(52613224,424915082,14458251,443749,1,'2007-09-16 15:24:14',3310490750,1),(52613226,424916374,14457040,443749,1,'2007-09-16 15:24:14',3310490750,1),(52613228,424917786,14455910,443749,1,'2007-09-16 15:24:14',3310490750,1),(52613231,424919562,14455224,443749,1,'2007-09-16 15:24:14',3310490750,1),(52613233,424921499,14454175,443749,1,'2007-09-16 15:24:14',3310490750,1),(52613235,424923315,14452843,443749,1,'2007-09-16 15:24:14',3310490750,1),(52613237,424924687,14451713,443749,1,'2007-09-16 15:24:14',3310490750,1),(52613238,424926382,14450825,443749,1,'2007-09-16 15:24:15',3310490750,1),(52613244,424930054,14449090,443749,1,'2007-09-16 15:24:15',3310490750,1),(52613246,424931587,14447960,443749,1,'2007-09-16 15:24:16',3310490751,1),(52613249,424933080,14446669,443749,1,'2007-09-16 15:24:16',3310490749,1),(52613252,424934412,14445539,443749,1,'2007-09-16 15:24:16',3310490749,1),(52613256,424935530,14444501,443749,1,'2007-09-16 15:24:16',3310490749,1),(52613258,424937099,14443566,443749,1,'2007-09-16 15:24:16',3310490749,1),(52613260,424938635,14443032,443749,1,'2007-09-16 15:24:17',3310490749,1),(52613262,424941573,14442197,443749,1,'2007-09-16 15:24:17',3310490749,1),(52613264,424943542,14441362,443749,1,'2007-09-16 15:24:17',3310490749,1),(52613267,424945980,14439893,443749,1,'2007-09-16 15:24:17',3310490749,1),(52613270,424949151,14438091,443749,1,'2007-09-16 15:24:17',3310490749,1),(52613272,424951455,14436922,443749,1,'2007-09-16 15:24:18',3310490749,1),(52613274,424953225,14436321,443749,1,'2007-09-16 15:24:18',3310490749,1),(52613277,424954760,14436087,443749,1,'2007-09-16 15:24:18',3310490749,1),(52613279,424956563,14435319,443749,1,'2007-09-16 15:24:18',3310490749,1),(52613282,424957780,14434445,443749,1,'2007-09-16 15:24:18',3310490920,1),(52613285,424958545,14433680,443749,1,'2007-09-16 15:24:19',3310490920,1),(52613288,424959437,14433043,443749,1,'2007-09-16 15:24:19',3310490920,1),(52613289,424960266,14432437,443749,1,'2007-09-16 15:24:20',3310490920,1),(52613292,424960999,14432405,443749,1,'2007-09-16 15:24:20',3310490920,1),(52613295,424961414,14432724,443749,1,'2007-09-16 15:24:20',3310490920,1),(52613297,424961924,14433425,443749,1,'2007-09-16 15:24:20',3310490920,1),(52613300,424963039,14435338,443749,1,'2007-09-16 15:24:20',3310490920,1),(52613301,424963932,14436645,443749,1,'2007-09-16 15:24:21',3310490920,1),(52613303,424965494,14438270,443749,1,'2007-09-16 15:24:21',3310490920,1),(52613304,424967311,14439545,443749,1,'2007-09-16 15:24:21',3310490920,1),(52613306,424968490,14440183,443749,1,'2007-09-16 15:24:21',3310490920,1),(52613309,424969893,14440374,443749,1,'2007-09-16 15:24:22',3310490920,1),(52613310,424971550,14440247,443749,1,'2007-09-16 15:24:22',3310490920,1),(52613312,424972889,14440119,443749,1,'2007-09-16 15:24:22',3310490920,1),(52613314,424974100,14439705,443749,1,'2007-09-16 15:24:23',3310490920,1),(52613317,424975975,14438758,443749,1,'2007-09-16 15:24:23',3310490920,1),(52613318,424976760,14438062,443749,1,'2007-09-16 15:24:23',3310490920,1),(52613320,424977983,14436233,443749,1,'2007-09-16 15:24:23',3310490920,1),(52613323,424978952,14434970,443749,1,'2007-09-16 15:24:23',3310490920,1),(52613325,424979922,14433619,443749,1,'2007-09-16 15:24:23',3310490920,1),(52613330,424980950,14432943,443749,1,'2007-09-16 15:24:24',3310490920,1),(52613332,424982008,14432855,443749,1,'2007-09-16 15:24:24',3310490920,1),(52623167,424979678,14430785,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623169,424978530,14431875,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623170,424976923,14433883,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623173,424975604,14436293,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623176,424973940,14437383,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623178,424972792,14437612,443749,1,'2007-09-16 15:48:29',3310490920,1),(52623180,424971128,14438129,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623182,424969292,14438416,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623185,424968202,14438129,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623187,424966653,14437612,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623190,424965161,14436121,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623193,424964128,14434055,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623196,424963268,14432391,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623199,424963268,14429924,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623201,424962579,14428317,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623203,424961948,14427858,443749,1,'2007-09-16 15:48:31',3310490920,1),(52623205,424960801,14428145,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623207,424959653,14429121,508959,1,'2007-09-24 18:39:59',3310490920,1),(52623209,424957014,14430670,508959,1,'2007-09-24 18:39:59',3310490749,1),(52623212,424953456,14433194,508959,1,'2007-09-24 18:39:59',3310490749,1),(52623215,424951391,14434514,508959,1,'2007-09-24 18:39:59',3310490749,1),(52623218,424949211,14435030,508959,1,'2007-09-24 18:39:59',3310490749,1),(52623226,424946514,14436121,508959,1,'2007-09-24 18:39:59',3310490749,1),(52623229,424943186,14438358,508959,1,'2007-09-24 18:39:59',3310490749,1),(52623231,424940776,14439678,508959,1,'2007-09-24 18:39:59',3310490749,1),(52623233,424937678,14440940,508959,1,'2007-09-24 18:39:59',3310490749,1),(52623236,424934752,14442260,443749,1,'2007-09-16 15:48:34',3310490749,1),(52623240,424932916,14443350,443749,1,'2007-09-16 15:48:34',3310490749,1),(52623242,424930965,14445817,508959,1,'2007-09-24 18:39:59',3310490749,1),(52623245,424929243,14447252,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623247,424927120,14448629,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623250,424925342,14449432,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623252,424919088,14452186,443749,1,'2007-09-16 15:48:35',3310490750,1),(52623255,424917080,14452989,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623259,424915301,14454137,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623261,424914440,14455571,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623265,424913809,14457350,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623268,424913121,14458957,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623273,424912260,14460276,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623276,424910883,14461424,443749,1,'2007-09-16 15:48:37',3310490750,1),(52623278,424909907,14462801,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623282,424908817,14466186,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623285,424907899,14470145,443749,1,'2007-09-16 15:48:37',3310490750,1),(52623287,424907096,14472497,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623290,424906350,14476571,443749,1,'2007-09-16 15:48:38',3310490750,1),(52623294,424905145,14479096,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623296,424904514,14482424,443749,1,'2007-09-16 15:48:38',3310490750,1),(52623299,424904744,14484719,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623301,424904744,14486153,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623303,424904112,14487530,443749,1,'2007-09-16 15:48:39',3310490750,1),(52623305,424903194,14488792,508959,1,'2007-09-24 18:39:59',3310490750,1),(52623308,424901358,14489137,508959,1,'2007-09-24 18:39:59',3310490747,1),(52623310,424899694,14489710,443749,1,'2007-09-16 15:48:39',3310490747,1),(52623315,424897686,14490169,508959,1,'2007-09-24 18:39:59',3310490747,1),(52623317,424896137,14491661,508959,1,'2007-09-24 18:39:59',3310490747,1),(52623321,424894014,14493210,508959,1,'2007-09-24 18:39:59',3310490747,1),(52623324,424892522,14495792,508959,1,'2007-09-24 18:39:59',3310490747,1),(52623329,424891662,14499637,508959,1,'2007-09-24 18:39:59',3310490747,1),(52623333,424890916,14503710,508959,1,'2007-09-24 18:39:59',3310490833,1),(52623334,424890113,14508587,443749,1,'2007-09-16 15:48:41',3310490833,1),(52623339,424889596,14511686,508959,1,'2007-09-24 18:39:59',3310490833,1),(52623344,424888219,14513866,508959,1,'2007-09-24 18:39:59',3310490833,1),(52623348,424886842,14515645,508959,1,'2007-09-24 18:39:59',3310490833,1),(52623351,424885293,14516505,508959,1,'2007-09-24 18:39:59',3310490833,1),(52623354,424883858,14516907,508959,1,'2007-09-24 18:39:59',3310490833,1),(52623358,424878809,14516792,443749,1,'2007-09-16 15:48:43',3310490833,1),(52623360,424876055,14516964,508959,1,'2007-09-24 18:39:59',3310490833,1),(52623363,424874277,14516333,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623364,424872498,14514784,443749,1,'2007-09-16 15:48:43',3310490832,1),(52623367,424871580,14512833,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623371,424871465,14509792,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623373,424871408,14505202,443749,1,'2007-09-16 15:48:44',3310490832,1),(52623375,424871236,14502792,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623378,424870318,14501358,508959,1,'2007-09-24 18:39:59',3310490746,1),(52623383,424869457,14500841,508959,1,'2007-09-24 18:39:59',3310490746,1),(52623385,424868023,14501473,443749,1,'2007-09-16 15:48:45',3310490746,1),(52623389,424866990,14503079,443749,1,'2007-09-16 15:48:45',3310490832,1),(52623392,424866014,14507669,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623394,424864580,14512317,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623398,424864064,14514956,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623402,424863432,14517710,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623403,424862916,14519317,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623407,424861539,14520292,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623413,424860219,14521153,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623416,424859416,14522186,443749,1,'2007-09-16 15:48:47',3310490832,1),(52623417,424859072,14522932,443749,1,'2007-09-16 15:48:47',3310490832,1),(52623420,424858670,14524653,443749,1,'2007-09-16 15:48:47',3310490832,1),(52623424,424858670,14526259,443749,1,'2007-09-16 15:48:47',3310490832,1),(52623427,424858498,14527751,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623431,424858039,14529013,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623434,424857523,14529415,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623436,424856719,14529415,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623438,424855744,14528669,443749,1,'2007-09-16 15:48:48',3310490832,1),(52623441,424854769,14527579,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623444,424852129,14525112,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623446,424850810,14523505,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623449,424849260,14523104,508959,1,'2007-09-24 18:39:59',3310490832,1),(52623453,424847769,14523907,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623457,424847023,14524538,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623463,424846277,14527866,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623465,424845760,14531079,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623471,424846047,14534522,443749,1,'2007-09-16 15:48:51',3310490821,1),(52623475,424845990,14537218,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623478,424845531,14538595,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623482,424844383,14539915,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623485,424843293,14540661,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623487,424841974,14540489,443749,1,'2007-09-16 15:48:52',3310490821,1),(52623489,424840367,14538882,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623492,424838818,14536759,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623494,424837556,14535899,443749,1,'2007-09-16 15:48:53',3310490821,1),(52623497,424836121,14535899,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623500,424834744,14537448,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623503,424833310,14539685,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623506,424832678,14542440,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623509,424833482,14544333,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623513,424835547,14546685,443749,1,'2007-09-16 15:48:55',3310490821,1),(52623516,424837211,14548292,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623517,424838474,14552653,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623522,424839047,14556153,508959,1,'2007-09-24 18:39:59',3310490821,1),(52623526,424840367,14561776,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623530,424840998,14567513,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623533,424840941,14571243,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623535,424840883,14574628,443749,1,'2007-09-16 15:48:56',3310490823,1),(52623538,424840195,14577038,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623541,424839564,14579218,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623543,424838646,14580767,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623545,424837211,14582202,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623548,424835949,14583120,443749,1,'2007-09-16 15:48:58',3310490823,1),(52623550,424834113,14583636,443749,1,'2007-09-16 15:48:58',3310490823,1),(52623553,424832506,14584152,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623556,424830039,14583407,443749,1,'2007-09-16 15:48:58',3310490823,1),(52623559,424828031,14583005,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623562,424826367,14583636,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623565,424823670,14584439,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623567,424821777,14585587,508959,1,'2007-09-24 18:39:59',3310490823,1),(52623570,424819769,14585874,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623573,424817416,14586275,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623576,424815179,14585816,443749,1,'2007-09-16 15:49:00',3310490822,1),(52623578,424813802,14585243,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623581,424811966,14585931,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623584,424810875,14587251,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623587,424809020,14589681,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623589,424807829,14593253,443749,1,'2007-09-16 15:49:01',3310490822,1),(52623590,424806695,14598355,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623593,424806128,14601644,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623597,424805504,14604252,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623599,424804710,14606520,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623602,424803747,14607484,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623605,424802102,14608108,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623610,424799721,14607994,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623613,424797340,14608221,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623617,424796546,14609128,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623618,424796092,14611396,508959,1,'2007-09-24 18:39:59',3310490822,1),(52623621,424795752,14614458,443749,1,'2007-09-16 15:49:03',3310490828,1),(52623624,424795299,14615818,443749,1,'2007-09-16 15:49:03',3310490828,1),(52623627,424794448,14616896,443749,1,'2007-09-16 15:49:03',3310490828,1),(52623630,424793201,14616385,508959,1,'2007-09-24 18:39:59',3310490828,1),(52623633,424792067,14614514,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623636,424791046,14613777,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623638,424790196,14614855,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623641,424789629,14616385,443749,1,'2007-09-16 15:49:04',3310490825,1),(52623644,424789005,14618313,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623647,424788665,14619844,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623649,424787531,14620978,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623653,424784696,14621375,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623655,424783980,14622336,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623657,424783079,14624137,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623660,424781939,14627078,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623664,424781398,14629899,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623667,424781638,14633261,443749,1,'2007-09-16 15:49:06',3310490825,1),(52623670,424782059,14635122,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623674,424783379,14636143,443749,1,'2007-09-16 15:49:08',3310490825,1),(52623675,424785360,14637103,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623679,424788218,14639108,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623684,424789995,14639924,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623687,424791195,14640165,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623690,424793308,14640549,508959,1,'2007-09-24 18:39:59',3310490828,1),(52623692,424794125,14640885,508959,1,'2007-09-24 18:39:59',3310490828,1),(52623694,424794989,14642086,508959,1,'2007-09-24 18:39:59',3310490828,1),(52623698,424794989,14642806,508959,1,'2007-09-24 18:39:59',3310490828,1),(52623701,424794845,14644679,508959,1,'2007-09-24 18:39:59',3310490828,1),(52623702,424793981,14645927,508959,1,'2007-09-24 18:39:59',3310490828,1),(52623705,424793116,14646696,508959,1,'2007-09-24 18:39:59',3310490828,1),(52623707,424792444,14648089,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623712,424792300,14649337,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623713,424792108,14650634,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623715,424791243,14651402,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623717,424790043,14651834,443749,1,'2007-09-16 15:49:13',3310490825,1),(52623719,424788890,14652363,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623720,424786921,14653659,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623722,424785144,14654524,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623725,424782791,14655820,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623726,424780342,14658366,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623728,424779525,14660047,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623730,424778901,14661583,443749,1,'2007-09-16 15:49:14',3310490825,1),(52623732,424779237,14663840,443749,1,'2007-09-16 15:49:14',3310490825,1),(52623733,424780150,14665377,508959,1,'2007-09-24 18:39:59',3310490825,1),(52623736,424782647,14667250,443749,1,'2007-09-16 15:49:15',3310490827,1),(52623739,424785961,14668979,443749,1,'2007-09-16 15:49:15',3310490827,1),(52623741,424788362,14670132,443749,1,'2007-09-16 15:49:15',3310490827,1),(52623743,424788986,14671284,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623746,424789178,14673733,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623749,424788890,14675174,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623750,424788218,14676567,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623752,424786201,14678296,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623753,424783944,14679352,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623755,424781446,14681273,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623757,424778565,14683434,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623758,424778277,14683818,443749,1,'2007-09-16 15:49:18',3310490827,1),(52623759,424776164,14685643,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623760,424774819,14686988,443749,1,'2007-09-16 15:49:18',3310490827,1),(52623762,424774099,14689341,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623763,424774099,14690542,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623765,424774771,14692751,443749,1,'2007-09-16 15:49:19',3310490827,1),(52623767,424775011,14695104,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623768,424774867,14697505,443749,1,'2007-09-16 15:49:19',3310490827,1),(52623769,424774051,14700003,443749,1,'2007-09-16 15:49:19',3310490827,1),(52623771,424773234,14702692,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623772,424773138,14705333,443749,1,'2007-09-16 15:49:20',3310490827,1),(52623773,424773330,14707398,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623776,424774195,14709607,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623777,424774387,14711865,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623778,424774291,14713785,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623779,424773762,14716235,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623780,424773138,14717916,443749,1,'2007-09-16 15:49:22',3310490827,1),(52623781,424771697,14720125,508959,1,'2007-09-24 18:39:59',3310490827,1),(52623782,424770929,14723102,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623783,424769200,14726224,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623784,424767567,14729105,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623785,424766559,14731026,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623786,424766463,14733043,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623788,424766607,14735781,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623791,424767039,14737990,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623792,424768576,14740343,443749,1,'2007-09-16 15:49:24',3310490849,1),(52623795,424769296,14742024,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623798,424769728,14743849,443749,1,'2007-09-16 15:49:25',3310490849,1),(52623800,424769632,14745529,443749,1,'2007-09-16 15:49:25',3310490849,1),(52623802,424769536,14747354,443749,1,'2007-09-16 15:49:26',3310490849,1),(52623805,424769584,14750476,443749,1,'2007-09-16 15:49:26',3310490849,1),(52623806,424769392,14754174,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623808,424769104,14755855,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623809,424767855,14758784,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623811,424766895,14762770,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623814,424766703,14765940,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623816,424767567,14768725,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623819,424768480,14772231,508959,1,'2007-09-24 18:39:59',3310490849,1),(52623823,424769728,14776121,443749,1,'2007-09-16 15:49:28',3310490849,1),(52623844,424771505,14779482,508959,1,'2007-09-24 18:39:59',3310490851,1),(52623846,424772994,14782604,443749,1,'2007-09-16 15:49:34',3310490851,1),(52623849,424773862,14785752,508959,1,'2007-09-24 18:39:59',3310490851,1),(52635897,424774052,14787812,508959,1,'2007-09-24 18:39:59',3310490851,1),(52635898,424774052,14791331,508959,1,'2007-09-24 18:39:59',3310490851,1),(52635899,424773988,14794421,443749,1,'2007-09-16 16:30:36',3310490851,1),(52635900,424773545,14797769,508959,1,'2007-09-24 18:39:59',3310490851,1),(52635902,424772596,14800000,508959,1,'2007-09-24 18:39:59',3310490851,1),(52635903,424771519,14801288,508959,1,'2007-09-24 18:39:59',3310490851,1),(52635904,424769874,14802060,508959,1,'2007-09-24 18:39:59',3310490851,1),(52635905,424767974,14802060,443749,1,'2007-09-16 16:30:36',3310490851,1),(52635907,424765759,14802403,508959,1,'2007-09-24 18:39:59',3310490851,1),(52635909,424763923,14803433,508959,1,'2007-09-24 18:39:59',3310490850,1),(52635910,424761011,14805923,443749,1,'2007-09-16 16:30:36',3310490850,1),(52635912,424757782,14807296,443749,1,'2007-09-16 16:30:36',3310490850,1),(52635914,424756326,14808927,443749,1,'2007-09-16 16:30:36',3310490850,1),(52635916,424755250,14812703,508959,1,'2007-09-24 18:39:59',3310490850,1),(52635917,424754617,14818368,508959,1,'2007-09-24 18:39:59',3310490850,1),(52636119,424754047,14822145,508959,1,'2007-09-24 18:39:59',3310490850,1),(52636120,424753224,14826865,508959,1,'2007-09-24 18:39:59',3310490850,1),(52636122,424751515,14835105,443749,1,'2007-09-16 16:30:36',3310490856,1),(52636124,424750629,14842229,443749,1,'2007-09-16 16:30:36',3310490856,1),(52636127,424749616,14849353,508959,1,'2007-09-24 18:39:59',3310490856,1),(52636128,424749173,14854417,443749,1,'2007-09-16 16:30:36',3310490856,1),(52636131,424749553,14856133,443749,1,'2007-09-16 16:30:36',3310490856,1),(52636132,424750439,14858623,443749,1,'2007-09-16 16:30:36',3310490856,1),(52636133,424751578,14860768,443749,1,'2007-09-16 16:30:36',3310490856,1),(52636134,424753414,14863000,443749,1,'2007-09-16 16:30:36',3310490856,1),(52636135,424755313,14865317,508959,1,'2007-09-24 18:39:59',3310490856,1),(52636136,424756263,14866948,443749,1,'2007-09-16 16:30:36',3310490856,1),(52636137,424756580,14870124,508959,1,'2007-09-24 18:39:59',3310490856,1),(52636139,424756516,14874673,508959,1,'2007-09-24 18:39:59',3310490856,1),(52636140,424756643,14878449,508959,1,'2007-09-24 18:39:59',3310490856,1),(52636141,424757149,14880166,508959,1,'2007-09-24 18:39:59',3310490856,1),(52636142,424758542,14884286,508959,1,'2007-09-24 18:39:59',3310490856,1),(52648095,424759673,14889812,508959,1,'2007-09-24 18:39:59',3310490858,1),(52648138,424760829,14895162,508959,1,'2007-09-24 18:39:59',3310490858,1),(52648149,424761770,14901495,443749,1,'2007-09-16 17:19:04',3310490858,1),(52648164,424762152,14903063,508959,1,'2007-09-24 18:39:59',3310490858,1),(52650131,424837924,14576772,443749,1,'2007-09-16 21:50:23',3310490823,1),(52650158,424836815,14579343,370566,1,'2008-05-09 02:14:21',3310490823,3),(52650659,424836210,14581006,370566,1,'2008-05-09 02:14:21',3310490823,4),(52652127,424836008,14582417,370566,1,'2008-05-09 02:14:21',3310490823,3),(52652273,424836464,14583834,370566,1,'2008-05-09 02:14:21',3310490823,3),(52652319,424834040,14579491,443749,1,'2007-09-16 17:35:49',3310490823,1),(52652351,424838051,14575645,443749,1,'2007-09-16 17:36:05',3310490823,1),(52652477,424838372,14575229,443749,1,'2007-09-16 17:36:39',3310490823,1),(52652555,424838780,14572364,443749,1,'2007-09-16 17:37:01',3310490823,1),(52661498,424838964,14570412,443749,1,'2007-09-16 18:14:44',3310490823,1),(52672004,424839093,14568056,443749,1,'2007-09-16 18:55:22',3310490823,1),(52672499,424838909,14565699,443749,1,'2007-09-16 18:57:11',3310490823,1),(52675912,424838651,14562108,443749,1,'2007-09-16 19:11:19',3310490823,1),(52676235,424838197,14559763,443749,1,'2007-09-16 19:12:14',3310490823,1),(52676253,424837281,14555066,443749,1,'2007-09-16 19:12:16',3310490821,1),(52676260,424836212,14552202,443749,1,'2007-09-16 19:12:16',3310490821,1),(52676267,424835830,14551439,443749,1,'2007-09-16 19:12:17',3310490821,1),(52676295,424835295,14551630,443749,1,'2007-09-16 19:12:20',3310490821,1),(52676338,424835257,14552241,443749,1,'2007-09-16 19:12:32',3310490821,1),(52676349,424835601,14553272,443749,1,'2007-09-16 19:12:33',3310490821,1),(52676434,424836403,14555448,443749,1,'2007-09-16 19:12:51',3310490821,1),(52676891,424836479,14557815,443749,1,'2007-09-16 19:14:23',3310490823,1),(52676911,424835792,14559763,443749,1,'2007-09-16 19:14:27',3310490823,1),(52677089,424835410,14562168,443749,1,'2007-09-16 19:14:58',3310490823,1),(52677154,424835448,14564993,443749,1,'2007-09-16 19:15:10',3310490823,1),(52677211,424835410,14566826,443749,1,'2007-09-16 19:15:18',3310490823,1),(52677635,424835104,14568621,443749,1,'2007-09-16 19:16:26',3310490823,1),(52677662,424834455,14569766,443749,1,'2007-09-16 19:16:33',3310490823,1),(52677757,424833577,14570874,443749,1,'2007-09-16 19:16:49',3310490823,1),(52677811,424832546,14571866,443749,1,'2007-09-16 19:17:02',3310490823,1),(52677844,424831324,14572248,443749,1,'2007-09-16 19:17:09',3310490823,1),(52677862,424830217,14572172,443749,1,'2007-09-16 19:17:14',3310490823,1),(52677872,424829568,14571675,443749,1,'2007-09-16 19:17:18',3310490823,1),(52677878,424829453,14571179,443749,1,'2007-09-16 19:17:19',3310490823,1),(52677908,424829644,14570148,443749,1,'2007-09-16 19:17:24',3310490823,1),(52677912,424830064,14568697,443749,1,'2007-09-16 19:17:25',3310490823,1),(52677918,424831210,14566712,443749,1,'2007-09-16 19:17:26',3310490823,1),(52677922,424832088,14565223,443749,1,'2007-09-16 19:17:26',3310490823,1),(52677929,424832661,14562741,443749,1,'2007-09-16 19:17:28',3310490823,1),(52677934,424832928,14560870,443749,1,'2007-09-16 19:17:29',3310490823,1),(52677939,424832965,14559190,443749,1,'2007-09-16 19:17:30',3310490823,1),(52677945,424832553,14557413,443749,1,'2007-09-16 19:17:32',3310490823,1),(52677993,424831950,14555351,443749,1,'2007-09-16 19:17:45',3310490821,1),(52678005,424830744,14553383,443749,1,'2007-09-16 19:17:47',3310490821,1),(52678200,424830173,14552241,443749,1,'2007-09-16 19:18:20',3310490821,1),(52678225,424829379,14552495,443749,1,'2007-09-16 19:18:25',3310490821,1),(52678243,424829506,14553447,443749,1,'2007-09-16 19:18:27',3310490821,1),(52678266,424829697,14554177,443749,1,'2007-09-16 19:18:31',3310490821,1),(52678278,424830617,14556556,443749,1,'2007-09-16 19:18:32',3310490821,1),(52678285,424830680,14558397,443749,1,'2007-09-16 19:18:32',3310490823,1),(52678294,424830458,14559952,443749,1,'2007-09-16 19:18:34',3310490823,1),(52678450,424829792,14561253,443749,1,'2007-09-16 19:19:08',3310490823,1),(52678519,424828681,14562141,443749,1,'2007-09-16 19:19:18',3310490823,1),(52678582,424827158,14562776,443749,1,'2007-09-16 19:19:27',3310490823,1),(52678634,424825984,14563125,443749,1,'2007-09-16 19:19:36',3310490823,1),(52678741,424824556,14563664,443749,1,'2007-09-16 19:19:53',3310490823,1),(52678786,424823033,14564299,443749,1,'2007-09-16 19:19:59',3310490823,1),(52678860,424821605,14564997,443749,1,'2007-09-16 19:20:12',3310490823,1),(52679237,424820431,14566171,443749,1,'2007-09-16 19:21:29',3310490823,1),(52679255,424819035,14567313,443749,1,'2007-09-16 19:21:32',3310490822,1),(52679261,424818052,14568011,443749,1,'2007-09-16 19:21:32',3310490822,1),(52679265,424817480,14568455,443749,1,'2007-09-16 19:21:33',3310490822,1),(52679271,424816846,14568455,443749,1,'2007-09-16 19:21:34',3310490822,1),(52679365,424816433,14568392,443749,1,'2007-09-16 19:21:44',3310490822,1),(52679445,424816148,14567916,443749,1,'2007-09-16 19:21:57',3310490822,1),(52679499,424816148,14567377,443749,1,'2007-09-16 19:22:04',3310490822,1),(52679531,424816243,14566805,443749,1,'2007-09-16 19:22:07',3310490822,1),(52679731,424816687,14565568,443749,1,'2007-09-16 19:22:24',3310490822,1),(52679744,424817353,14564077,443749,1,'2007-09-16 19:22:25',3310490822,1),(52679804,424818147,14562522,443749,1,'2007-09-16 19:22:29',3310490822,1),(52679809,424820146,14560777,443749,1,'2007-09-16 19:22:30',3310490822,1),(52679815,424822303,14559190,443749,1,'2007-09-16 19:22:31',3310490823,1),(52679821,424823097,14558238,443749,1,'2007-09-16 19:22:32',3310490823,1),(52679879,424823890,14557096,443749,1,'2007-09-16 19:22:42',3310490821,1),(52679882,424824334,14555573,443749,1,'2007-09-16 19:22:42',3310490821,1),(52679888,424824303,14554970,443749,1,'2007-09-16 19:22:43',3310490821,1),(52679894,424823858,14554081,443749,1,'2007-09-16 19:22:44',3310490821,1),(52679900,424823287,14554081,443749,1,'2007-09-16 19:22:44',3310490821,1),(52679906,424822906,14554303,443749,1,'2007-09-16 19:22:45',3310490821,1),(52679911,424822367,14555065,443749,1,'2007-09-16 19:22:45',3310490821,1),(52679979,424821605,14555953,443749,1,'2007-09-16 19:22:52',3310490821,1),(52679994,424820876,14556525,443749,1,'2007-09-16 19:22:53',3310490821,1),(52680005,424819575,14557096,443749,1,'2007-09-16 19:22:55',3310490820,1),(52680012,424817766,14557477,443749,1,'2007-09-16 19:22:55',3310490822,1),(52680017,424815418,14557984,443749,1,'2007-09-16 19:22:56',3310490822,1),(52680024,424813704,14558651,443749,1,'2007-09-16 19:22:56',3310490822,1),(52680029,424811610,14560015,443749,1,'2007-09-16 19:22:57',3310490822,1),(52680039,424810531,14561538,443749,1,'2007-09-16 19:22:57',3310490822,1),(52680048,424809421,14562871,443749,1,'2007-09-16 19:22:58',3310490822,1),(52680059,424808786,14563188,443749,1,'2007-09-16 19:22:58',3310490822,1),(52680077,424808596,14563156,443749,1,'2007-09-16 19:22:59',3310490822,1),(52680086,424808215,14562744,443749,1,'2007-09-16 19:23:00',3310490822,1),(52680095,424808056,14561982,443749,1,'2007-09-16 19:23:01',3310490822,1),(52680105,424808215,14561602,443749,1,'2007-09-16 19:23:01',3310490822,1),(52680117,424808596,14561030,443749,1,'2007-09-16 19:23:02',3310490822,1),(52680128,424809865,14559349,443749,1,'2007-09-16 19:23:02',3310490822,1),(52680141,424811261,14557508,443749,1,'2007-09-16 19:23:03',3310490822,1),(52680157,424813387,14555890,443749,1,'2007-09-16 19:23:04',3310490820,1),(52680171,424815101,14554303,443749,1,'2007-09-16 19:23:05',3310490820,1),(52680195,424815767,14552876,443749,1,'2007-09-16 19:23:07',3310490820,1),(52680202,424815799,14551955,443749,1,'2007-09-16 19:23:08',3310490820,1),(52680255,424815799,14550210,443749,1,'2007-09-16 19:23:12',3310490820,1),(52680269,424815481,14548179,443749,1,'2007-09-16 19:23:12',3310490820,1),(52680280,424815409,14547101,443749,1,'2007-09-16 19:23:13',3310490820,1),(52680289,424815305,14546093,443749,1,'2007-09-16 19:23:13',3310490820,1),(52680402,424815757,14544771,443749,1,'2007-09-16 19:23:21',3310490820,1),(52680426,424817287,14541746,443749,1,'2007-09-16 19:23:22',3310490820,1),(52680437,424817982,14540773,443749,1,'2007-09-16 19:23:23',3310490820,1),(52680448,424818121,14540181,443749,1,'2007-09-16 19:23:24',3310490820,1),(52680465,424817669,14539521,443749,1,'2007-09-16 19:23:25',3310490820,1),(52680561,424817113,14539590,443749,1,'2007-09-16 19:23:29',3310490820,1),(52680566,424816487,14540147,443749,1,'2007-09-16 19:23:29',3310490820,1),(52680570,424815340,14540773,443749,1,'2007-09-16 19:23:30',3310490820,1),(52680574,424813879,14541607,443749,1,'2007-09-16 19:23:30',3310490820,1),(52680577,424813079,14542268,443749,1,'2007-09-16 19:23:30',3310490820,1),(52680579,424812384,14543902,443749,1,'2007-09-16 19:23:30',3310490820,1),(52680583,424812175,14545015,443749,1,'2007-09-16 19:23:31',3310490820,1),(52680592,424811967,14547414,443749,1,'2007-09-16 19:23:31',3310490820,1),(52680597,424811549,14549118,443749,1,'2007-09-16 19:23:31',3310490820,1),(52680599,424811028,14550231,443749,1,'2007-09-16 19:23:32',3310490820,1),(52680606,424810471,14550926,443749,1,'2007-09-16 19:23:32',3310490820,1),(52680610,424809637,14551830,443749,1,'2007-09-16 19:23:33',3310490820,1),(52680616,424807690,14552213,443749,1,'2007-09-16 19:23:33',3310490820,1),(52680618,424806473,14552248,443749,1,'2007-09-16 19:23:34',3310490820,1),(52680624,424804247,14552074,443749,1,'2007-09-16 19:23:34',3310490820,1),(52680637,424802682,14551865,443749,1,'2007-09-16 19:23:36',3310490820,1),(52680643,424802056,14551483,443749,1,'2007-09-16 19:23:37',3310490820,1),(52680648,424801917,14550961,443749,1,'2007-09-16 19:23:37',3310490820,1),(52680653,424802335,14550509,443749,1,'2007-09-16 19:23:39',3310490820,1),(52680657,424803100,14550126,443749,1,'2007-09-16 19:23:40',3310490820,1),(52680660,424803969,14550266,443749,1,'2007-09-16 19:23:41',3310490820,1),(52680663,424804873,14550544,443749,1,'2007-09-16 19:23:42',3310490820,1),(52680674,424805673,14550370,443749,1,'2007-09-16 19:23:43',3310490820,1),(52680676,424806299,14549501,443749,1,'2007-09-16 19:23:44',3310490820,1),(52680679,424806751,14548527,443749,1,'2007-09-16 19:23:44',3310490820,1),(52680683,424806959,14547414,443749,1,'2007-09-16 19:23:45',3310490820,1),(52680692,424806959,14546023,443749,1,'2007-09-16 19:23:47',3310490820,1),(52680695,424806786,14544458,443749,1,'2007-09-16 19:23:47',3310490820,1),(52680698,424806646,14542824,443749,1,'2007-09-16 19:23:48',3310490820,1),(52680703,424806577,14541711,443749,1,'2007-09-16 19:23:48',3310490820,1),(52680706,424806646,14540425,443749,1,'2007-09-16 19:23:49',3310490820,1),(52680712,424807168,14538651,443749,1,'2007-09-16 19:23:50',3310490820,1),(52680715,424807829,14537156,443749,1,'2007-09-16 19:23:51',3310490820,1),(52680717,424808628,14535557,443749,1,'2007-09-16 19:23:51',3310490820,1),(52680719,424809463,14534235,443749,1,'2007-09-16 19:23:51',3310490820,1),(52680722,424810610,14533227,443749,1,'2007-09-16 19:23:52',3310490820,1),(52680727,424811480,14532288,443749,1,'2007-09-16 19:23:54',3310490820,1),(52680731,424812036,14531662,443749,1,'2007-09-16 19:23:54',3310490820,1),(52680735,424812001,14530967,443749,1,'2007-09-16 19:23:55',3310490820,1),(52680736,424811584,14530723,443749,1,'2007-09-16 19:23:55',3310490820,1),(52680739,424810889,14530688,443749,1,'2007-09-16 19:23:56',3310490820,1),(52680744,424809602,14531697,443749,1,'2007-09-16 19:23:58',3310490820,1),(52680747,424807794,14532810,443749,1,'2007-09-16 19:23:59',3310490820,1),(52680751,424806085,14533889,443749,1,'2007-09-16 19:24:01',3310490820,1),(52680753,424804073,14535206,443749,1,'2007-09-16 19:24:01',3310490820,1),(52680755,424802318,14536852,443749,1,'2007-09-16 19:24:02',3310490820,1),(52680757,424800415,14539230,443749,1,'2007-09-16 19:24:02',3310490820,1),(52680759,424799428,14540584,443749,1,'2007-09-16 19:24:02',3310490820,1),(52680760,424798440,14541279,443749,1,'2007-09-16 19:24:02',3310490820,1),(52680763,424797306,14541974,443749,1,'2007-09-16 19:24:03',3310490820,1),(52680767,424796464,14541974,443749,1,'2007-09-16 19:24:03',3310490820,1),(52680769,424795879,14541572,443749,1,'2007-09-16 19:24:04',3310490820,1),(52680773,424795769,14540694,443749,1,'2007-09-16 19:24:04',3310490820,1),(52680776,424796172,14539816,443749,1,'2007-09-16 19:24:05',3310490820,1),(52680780,424796830,14538901,443749,1,'2007-09-16 19:24:05',3310490820,1),(52680782,424799537,14535316,443749,1,'2007-09-16 19:24:06',3310490820,1),(52680784,424801513,14533085,443749,1,'2007-09-16 19:24:06',3310490820,1),(52680787,424802683,14531841,443749,1,'2007-09-16 19:24:06',3310490820,1),(52680789,424803086,14530963,443749,1,'2007-09-16 19:24:06',3310490820,1),(52680794,424802500,14530707,443749,1,'2007-09-16 19:24:06',3310490820,1),(52680797,424801879,14530743,443749,1,'2007-09-16 19:24:07',3310490820,1),(52680799,424800745,14531329,443749,1,'2007-09-16 19:24:07',3310490820,1),(52680803,424796977,14532499,443749,1,'2007-09-16 19:24:07',3310490820,1),(52680806,424795184,14532755,443749,1,'2007-09-16 19:24:07',3310490820,1),(52680810,424793355,14532828,443749,1,'2007-09-16 19:24:08',3310490820,1),(52680813,424792038,14533121,443749,1,'2007-09-16 19:24:08',3310490817,1),(52680815,424790758,14534072,443749,1,'2007-09-16 19:24:08',3310490817,1),(52680818,424789514,14534987,443749,1,'2007-09-16 19:24:09',3310490817,1),(52680820,424789038,14536194,443749,1,'2007-09-16 19:24:09',3310490817,1),(52680823,424788636,14537474,443749,1,'2007-09-16 19:24:09',3310490817,1),(52680825,424788051,14538718,443749,1,'2007-09-16 19:24:10',3310490817,1),(52680828,424787539,14538645,443749,1,'2007-09-16 19:24:10',3310490817,1),(52680830,424787209,14538169,443749,1,'2007-09-16 19:24:10',3310490817,1),(52680832,424786990,14537511,443749,1,'2007-09-16 19:24:10',3310490817,1),(52680836,424787063,14535755,443749,1,'2007-09-16 19:24:11',3310490817,1),(52680838,424787539,14533633,443749,1,'2007-09-16 19:24:11',3310490817,1),(52680839,424788526,14531877,443749,1,'2007-09-16 19:24:11',3310490817,1),(52680842,424789733,14530414,443749,1,'2007-09-16 19:24:12',3310490817,1),(52680844,424790941,14529097,443749,1,'2007-09-16 19:24:12',3310490817,1),(52680847,424792184,14528256,443749,1,'2007-09-16 19:24:13',3310490817,1),(52680850,424793465,14528109,443749,1,'2007-09-16 19:24:14',3310490820,1),(52680852,424795001,14527707,443749,1,'2007-09-16 19:24:14',3310490820,1),(52680855,424796318,14527049,443749,1,'2007-09-16 19:24:14',3310490820,1),(52680858,424797745,14526573,443749,1,'2007-09-16 19:24:14',3310490820,1),(52680860,424798623,14525878,443749,1,'2007-09-16 19:24:15',3310490820,1),(52680866,424798659,14525329,443749,1,'2007-09-16 19:24:16',3310490820,1),(52680869,424798037,14524927,443749,1,'2007-09-16 19:24:16',3310490820,1),(52680871,424797196,14524890,443749,1,'2007-09-16 19:24:16',3310490820,1),(52680874,424794489,14524963,443749,1,'2007-09-16 19:24:17',3310490820,1),(52680877,424793026,14524744,443749,1,'2007-09-16 19:24:17',3310490820,1),(52680879,424791636,14523866,443749,1,'2007-09-16 19:24:17',3310490817,1),(52680883,424790685,14523354,443749,1,'2007-09-16 19:24:18',3310490817,1),(52680913,424789624,14523427,443749,1,'2007-09-16 19:24:27',3310490817,1),(52680960,424788124,14523720,443749,1,'2007-09-16 19:24:33',3310490817,1),(52681009,424787136,14523720,443749,1,'2007-09-16 19:24:40',3310490817,1),(52681026,424785600,14523500,443749,1,'2007-09-16 19:24:43',3310490817,1),(52681028,424784319,14523317,443749,1,'2007-09-16 19:24:43',3310490817,1),(52681343,424782563,14523427,443749,1,'2007-09-16 19:25:38',3310490817,1),(52681347,424780661,14523683,443749,1,'2007-09-16 19:25:38',3310490817,1),(52681350,424779673,14524268,443749,1,'2007-09-16 19:25:38',3310490817,1),(52681355,424778978,14525073,443749,1,'2007-09-16 19:25:39',3310490817,1),(52681357,424777808,14526207,443749,1,'2007-09-16 19:25:39',3310490817,1),(52681361,424775576,14528512,443749,1,'2007-09-16 19:25:39',3310490817,1),(52681362,424773455,14530048,443749,1,'2007-09-16 19:25:39',3310490817,1),(52681366,424772544,14530277,443749,1,'2007-09-16 19:25:40',3310490817,1),(52681368,424771406,14530624,443749,1,'2007-09-16 19:25:40',3310490817,1),(52681372,424769823,14530327,443749,1,'2007-09-16 19:25:40',3310490817,1),(52681374,424768586,14529634,443749,1,'2007-09-16 19:25:41',3310490817,1),(52681375,424767299,14528793,443749,1,'2007-09-16 19:25:41',3310490817,1),(52681378,424766062,14528842,443749,1,'2007-09-16 19:25:41',3310490817,1),(52681380,424764578,14529832,443749,1,'2007-09-16 19:25:42',3310490816,1),(52681382,424763935,14530723,443749,1,'2007-09-16 19:25:42',3310490816,1),(52681384,424763836,14531762,443749,1,'2007-09-16 19:25:42',3310490816,1),(52681386,424764677,14533345,443749,1,'2007-09-16 19:25:42',3310490816,1),(52681390,424765815,14535473,443749,1,'2007-09-16 19:25:43',3310490817,1),(52681392,424766607,14537650,443749,1,'2007-09-16 19:25:43',3310490817,1),(52681393,424767003,14539778,443749,1,'2007-09-16 19:25:43',3310490817,1),(52681394,424767596,14542895,443749,1,'2007-09-16 19:25:43',3310490817,1),(52681395,424767497,14544082,443749,1,'2007-09-16 19:25:43',3310490817,1),(52681398,424766805,14543934,443749,1,'2007-09-16 19:25:44',3310490817,1),(52681400,424766359,14542994,443749,1,'2007-09-16 19:25:45',3310490817,1),(52681405,424765518,14541213,443749,1,'2007-09-16 19:25:45',3310490817,1),(52681407,424763489,14537947,443749,1,'2007-09-16 19:25:46',3310490816,1),(52681409,424762401,14535869,443749,1,'2007-09-16 19:25:46',3310490816,1),(52681412,424761807,14535027,443749,1,'2007-09-16 19:25:47',3310490816,1),(52681414,424761015,14535126,443749,1,'2007-09-16 19:25:47',3310490816,1),(52681416,424761015,14535770,443749,1,'2007-09-16 19:25:48',3310490816,1),(52681417,424761411,14536908,443749,1,'2007-09-16 19:25:48',3310490816,1),(52681420,424761906,14538590,443749,1,'2007-09-16 19:25:48',3310490816,1),(52681422,424762005,14540223,443749,1,'2007-09-16 19:25:48',3310490816,1),(52681423,424761956,14541064,443749,1,'2007-09-16 19:25:48',3310490816,1),(52681425,424760893,14540517,443749,1,'2007-09-16 19:25:48',3310490816,1),(52681427,424760570,14539728,443749,1,'2007-09-16 19:25:48',3310490816,1),(52681429,424761208,14534760,443749,1,'2007-09-16 19:25:49',3310490816,1),(52681431,424761371,14541027,443749,1,'2007-09-16 19:25:49',3310490816,1),(52681432,424759266,14537435,443749,1,'2007-09-16 19:25:49',3310490816,1),(52681434,424757981,14535122,443749,1,'2007-09-16 19:25:50',3310490816,1),(52681439,424757081,14532360,443749,1,'2007-09-16 19:25:50',3310490816,1),(52681462,424756696,14530432,443749,1,'2007-09-16 19:25:54',3310490816,1),(52681464,424756118,14527605,443749,1,'2007-09-16 19:25:54',3310490816,1),(52681465,424756246,14524328,443749,1,'2007-09-16 19:25:54',3310490816,1),(52681466,424756439,14522786,443749,1,'2007-09-16 19:25:55',3310490816,1),(52681468,424757210,14521437,443749,1,'2007-09-16 19:25:55',3310490816,1),(52681471,424758816,14520409,443749,1,'2007-09-16 19:25:55',3310490816,1),(52681474,424760680,14519445,443749,1,'2007-09-16 19:25:56',3310490816,1),(52681476,424762222,14518417,443749,1,'2007-09-16 19:25:56',3310490816,1),(52681478,424763635,14516682,443749,1,'2007-09-16 19:25:56',3310490816,1),(52681481,424764599,14514691,443749,1,'2007-09-16 19:25:57',3310490816,1),(52681484,424765627,14512827,443749,1,'2007-09-16 19:25:57',3310490817,1),(52681487,424767040,14511607,443749,1,'2007-09-16 19:25:57',3310490817,1),(52681492,424767554,14510450,443749,1,'2007-09-16 19:25:59',3310490817,1),(52681493,424767747,14509101,443749,1,'2007-09-16 19:25:59',3310490817,1),(52681496,424767040,14507752,443749,1,'2007-09-16 19:25:59',3310490817,1),(52681499,424765691,14507366,443749,1,'2007-09-16 19:25:59',3310490817,1),(52681500,424764213,14507173,443749,1,'2007-09-16 19:26:00',3310490816,1),(52681503,424761515,14508137,443749,1,'2007-09-16 19:26:00',3310490816,1),(52681508,424759973,14509229,443749,1,'2007-09-16 19:26:00',3310490816,1),(52681510,424758302,14509743,443749,1,'2007-09-16 19:26:00',3310490816,1),(52681511,424756053,14509229,443749,1,'2007-09-16 19:26:01',3310490816,1),(52681514,424753034,14508844,443749,1,'2007-09-16 19:26:01',3310490816,1),(52681516,424752006,14509037,443749,1,'2007-09-16 19:26:01',3310490816,1),(52681518,424751170,14509551,443749,1,'2007-09-16 19:26:01',3310490816,1),(52681521,424750335,14511542,443749,1,'2007-09-16 19:26:02',3310490816,1),(52681526,424748922,14517325,443749,1,'2007-09-16 19:26:03',3310490816,1),(52681528,424748215,14520666,443749,1,'2007-09-16 19:26:03',3310490816,1),(52681531,424747894,14522529,443749,1,'2007-09-16 19:26:04',3310490816,1),(52681533,424747187,14523043,443749,1,'2007-09-16 19:26:04',3310490816,1),(52681535,424746416,14522979,443749,1,'2007-09-16 19:26:05',3310490816,1),(52681537,424746030,14522336,443749,1,'2007-09-16 19:26:05',3310490816,1),(52681539,424745966,14520794,443749,1,'2007-09-16 19:26:06',3310490816,1),(52681541,424745581,14515976,443749,1,'2007-09-16 19:26:07',3310490816,1),(52681544,424745516,14514498,443749,1,'2007-09-16 19:26:07',3310490816,1),(52681547,424745516,14513534,443749,1,'2007-09-16 19:26:07',3310490816,1),(52681551,424744745,14512056,443749,1,'2007-09-16 19:26:08',3310490816,1),(52681553,424743653,14513149,443749,1,'2007-09-16 19:26:08',3310490816,1),(52681557,424743268,14515012,443749,1,'2007-09-16 19:26:08',3310490816,1),(52681568,424742818,14516490,443749,1,'2007-09-16 19:26:10',3310490816,1),(52681571,424744077,14512262,443749,1,'2007-09-16 19:26:10',3310490816,1),(52681576,424745336,14512603,443749,1,'2007-09-16 19:26:11',3310490816,1),(52681578,424742304,14516939,443749,1,'2007-09-16 19:26:11',3310490816,1),(52681582,424741340,14516875,443749,1,'2007-09-16 19:26:11',3310490816,1),(52681586,424740376,14515911,443749,1,'2007-09-16 19:26:12',3310490816,1),(52681589,424739220,14514883,443749,1,'2007-09-16 19:26:12',3310490816,1),(52681593,424737999,14514305,443749,1,'2007-09-16 19:26:12',3310490816,1),(52681596,424736714,14513598,443749,1,'2007-09-16 19:26:13',3310490773,1),(52681598,424735300,14513470,443749,1,'2007-09-16 19:26:13',3310490773,1),(52681600,424734015,14512892,443749,1,'2007-09-16 19:26:13',3310490773,1),(52681603,424732730,14511607,443749,1,'2007-09-16 19:26:14',3310490773,1),(52681605,424731831,14509679,443749,1,'2007-09-16 19:26:14',3310490773,1),(52681608,424731253,14508073,443749,1,'2007-09-16 19:26:15',3310490773,1),(52681610,424730674,14505567,443749,1,'2007-09-16 19:26:15',3310490773,1),(52681613,424729968,14504346,443749,1,'2007-09-16 19:26:15',3310490773,1),(52681615,424728361,14502933,443749,1,'2007-09-16 19:26:15',3310490773,1),(52681619,424727398,14501391,443749,1,'2007-09-16 19:26:16',3310490687,1),(52681648,424726755,14499078,443749,1,'2007-09-16 19:26:21',3310490687,1),(52681683,424725599,14494901,443749,1,'2007-09-16 19:26:28',3310490687,1),(52681949,424725085,14492781,443749,1,'2007-09-16 19:27:21',3310490687,1),(52682039,424725920,14492203,443749,1,'2007-09-16 19:27:35',3310490687,1),(52682044,424726113,14493038,443749,1,'2007-09-16 19:27:36',3310490687,1),(52682047,424726819,14495801,443749,1,'2007-09-16 19:27:36',3310490687,1),(52682050,424725129,14491669,443749,1,'2007-09-16 19:27:36',3310490687,1),(52682055,424725666,14491789,443749,1,'2007-09-16 19:27:36',3310490687,1),(52682060,424724866,14492241,443749,1,'2007-09-16 19:27:37',3310490687,1),(52682065,424727721,14498459,443749,1,'2007-09-16 19:27:37',3310490687,1),(52682068,424728414,14500385,443749,1,'2007-09-16 19:27:38',3310490687,1),(52682070,424729916,14501810,443749,1,'2007-09-16 19:27:38',3310490687,1),(52682072,424731881,14503929,443749,1,'2007-09-16 19:27:38',3310490773,1),(52682091,424733807,14505816,443749,1,'2007-09-16 19:27:43',3310490773,1),(52682096,424734423,14506086,443749,1,'2007-09-16 19:27:43',3310490773,1),(52682101,424735155,14506086,443749,1,'2007-09-16 19:27:44',3310490773,1),(52682123,424735540,14505778,443749,1,'2007-09-16 19:27:47',3310490773,1),(52682126,424735617,14505123,443749,1,'2007-09-16 19:27:47',3310490773,1),(52682128,424735425,14504353,443749,1,'2007-09-16 19:27:48',3310490773,1),(52682132,424734693,14503890,443749,1,'2007-09-16 19:27:48',3310490773,1),(52682135,424733845,14503582,443749,1,'2007-09-16 19:27:48',3310490773,1),(52682140,424732921,14502696,443749,1,'2007-09-16 19:27:48',3310490773,1),(52682143,424731958,14501271,443749,1,'2007-09-16 19:27:49',3310490687,1),(52682146,424731034,14499268,443749,1,'2007-09-16 19:27:49',3310490687,1),(52682150,424730186,14496456,443749,1,'2007-09-16 19:27:49',3310490687,1),(52682152,424729416,14493452,443749,1,'2007-09-16 19:27:49',3310490687,1),(52682156,424728799,14491218,443749,1,'2007-09-16 19:27:49',3310490687,1),(52682160,424728607,14489754,443749,1,'2007-09-16 19:27:49',3310490687,1),(52682164,424728260,14487481,443749,1,'2007-09-16 19:27:50',3310490687,1),(52682168,424727682,14486133,443749,1,'2007-09-16 19:27:50',3310490687,1),(52682170,424726219,14483861,443749,1,'2007-09-16 19:27:50',3310490687,1),(52682174,424725564,14483013,443749,1,'2007-09-16 19:27:51',3310490687,1),(52682178,424724485,14482628,443749,1,'2007-09-16 19:27:51',3310490687,1),(52682180,424722675,14482320,443749,1,'2007-09-16 19:27:51',3310490687,1),(52682184,424721751,14481935,443749,1,'2007-09-16 19:27:52',3310490687,1),(52682186,424719940,14481203,443749,1,'2007-09-16 19:27:52',3310490687,1),(52682190,424718322,14480933,443749,1,'2007-09-16 19:27:52',3310490687,1),(52682195,424716358,14481318,443749,1,'2007-09-16 19:27:53',3310490687,1),(52682197,424714471,14481781,443749,1,'2007-09-16 19:27:53',3310490687,1),(52682200,424712352,14482320,443749,1,'2007-09-16 19:27:54',3310490687,1),(52682202,424710773,14482821,443749,1,'2007-09-16 19:27:54',3310490687,1),(52682204,424709193,14483283,443749,1,'2007-09-16 19:27:54',3310490686,1),(52682207,424708770,14481858,443749,1,'2007-09-16 19:27:54',3310490686,1),(52682210,424709001,14481280,443749,1,'2007-09-16 19:27:55',3310490686,1),(52682212,424710041,14479585,443749,1,'2007-09-16 19:27:55',3310490686,1),(52682215,424709874,14483327,443749,1,'2007-09-16 19:27:55',3310490686,1),(52682216,424708717,14482657,443749,1,'2007-09-16 19:27:55',3310490686,1),(52682221,424711582,14478699,443749,1,'2007-09-16 19:27:56',3310490687,1),(52682224,424713431,14478121,443749,1,'2007-09-16 19:27:56',3310490687,1),(52682227,424716474,14477120,443749,1,'2007-09-16 19:27:56',3310490687,1),(52682231,424720248,14475810,443749,1,'2007-09-16 19:27:57',3310490687,1),(52682235,424722636,14474770,443749,1,'2007-09-16 19:27:58',3310490687,1),(52682238,424723445,14473884,443749,1,'2007-09-16 19:27:58',3310490687,1),(52682240,424723599,14472960,443749,1,'2007-09-16 19:27:58',3310490687,1),(52682243,424723099,14472035,443749,1,'2007-09-16 19:27:59',3310490687,1),(52682244,424721828,14471997,443749,1,'2007-09-16 19:27:59',3310490687,1),(52682247,424720441,14471958,443749,1,'2007-09-16 19:27:59',3310490687,1),(52682250,424719054,14471727,443749,1,'2007-09-16 19:27:59',3310490687,1),(52682253,424717128,14470533,443749,1,'2007-09-16 19:28:00',3310490687,1),(52682255,424715934,14469455,443749,1,'2007-09-16 19:28:00',3310490687,1),(52682257,424714586,14468993,443749,1,'2007-09-16 19:28:00',3310490687,1),(52682259,424712891,14468684,443749,1,'2007-09-16 19:28:00',3310490687,1),(52682262,424711312,14468684,443749,1,'2007-09-16 19:28:00',3310490687,1),(52682265,424709579,14468877,443749,1,'2007-09-16 19:28:01',3310490686,1),(52682270,424707768,14469917,443749,1,'2007-09-16 19:28:02',3310490686,1),(52682272,424706228,14470880,443749,1,'2007-09-16 19:28:02',3310490686,1),(52682274,424705226,14471342,443749,1,'2007-09-16 19:28:02',3310490686,1),(52682277,424703878,14471766,443749,1,'2007-09-16 19:28:02',3310490686,1),(52682524,424702992,14471304,443749,1,'2007-09-16 19:29:00',3310490686,1),(52682546,424702068,14470456,443749,1,'2007-09-16 19:29:04',3310490686,1),(52682558,424701216,14469560,443749,1,'2007-09-16 19:29:12',3310490686,1),(52682617,424699441,14468179,443749,1,'2007-09-16 19:29:21',3310490686,1),(52682663,424697888,14467193,443749,1,'2007-09-16 19:29:32',3310490686,1),(52682673,424696223,14466029,443749,1,'2007-09-16 19:29:34',3310490686,1),(52685135,424653662,14490028,443749,1,'2007-09-16 19:38:11',3310490682,1),(52685138,424652684,14492170,443749,1,'2007-09-16 19:38:11',3310490682,1),(52685142,424651219,14495290,443749,1,'2007-09-16 19:38:12',3310490682,1),(52685145,424649377,14497846,443749,1,'2007-09-16 19:38:12',3310490682,1),(52685147,424647761,14499537,443749,1,'2007-09-16 19:38:12',3310490682,1),(52685151,424646145,14500740,443749,1,'2007-09-16 19:38:13',3310490682,1),(52685154,424644115,14501266,443749,1,'2007-09-16 19:38:13',3310490682,1),(52685157,424642161,14501942,443749,1,'2007-09-16 19:38:14',3310490682,1),(52685160,424640206,14502920,443749,1,'2007-09-16 19:38:14',3310490768,1),(52685162,424638816,14503972,443749,1,'2007-09-16 19:38:14',3310490768,1),(52685166,424637989,14505138,443749,1,'2007-09-16 19:38:15',3310490768,1),(52685169,424637426,14507167,443749,1,'2007-09-16 19:38:16',3310490768,1),(52685171,424636862,14509647,443749,1,'2007-09-16 19:38:16',3310490768,1),(52685184,424636316,14512315,443749,1,'2007-09-16 19:38:18',3310490768,1),(52685190,424636128,14515351,443749,1,'2007-09-16 19:38:19',3310490768,1),(52685195,424636203,14517412,443749,1,'2007-09-16 19:38:20',3310490768,1),(52685199,424636353,14519399,443749,1,'2007-09-16 19:38:20',3310490768,1),(52685202,424636353,14521235,443749,1,'2007-09-16 19:38:20',3310490768,1),(52685204,424636391,14522885,443749,1,'2007-09-16 19:38:21',3310490768,1),(52685207,424636690,14524271,443749,1,'2007-09-16 19:38:21',3310490768,1),(52685211,424637215,14525808,443749,1,'2007-09-16 19:38:21',3310490768,1),(52685217,424638227,14527157,443749,1,'2007-09-16 19:38:23',3310490768,1),(52685220,424638677,14528169,443749,1,'2007-09-16 19:38:23',3310490768,1),(52685226,424638789,14528769,443749,1,'2007-09-16 19:38:25',3310490768,1),(52685229,424638452,14529256,443749,1,'2007-09-16 19:38:25',3310490768,1),(52685232,424637777,14528844,443749,1,'2007-09-16 19:38:25',3310490768,1),(52685236,424636503,14527945,443749,1,'2007-09-16 19:38:26',3310490768,1),(52685238,424635229,14526483,443749,1,'2007-09-16 19:38:26',3310490768,1),(52685243,424633917,14524384,443749,1,'2007-09-16 19:38:27',3310490768,1),(52685247,424632717,14522885,443749,1,'2007-09-16 19:38:27',3310490768,1),(52685258,424631668,14521235,443749,1,'2007-09-16 19:38:30',3310490768,1),(52685262,424629906,14517937,443749,1,'2007-09-16 19:38:30',3310490768,1),(52685269,424629082,14515238,443749,1,'2007-09-16 19:38:30',3310490768,1),(52685275,424627732,14512165,443749,1,'2007-09-16 19:38:31',3310490757,1),(52685277,424626196,14507480,443749,1,'2007-09-16 19:38:31',3310490757,1),(52685282,424625596,14504894,443749,1,'2007-09-16 19:38:32',3310490757,1),(52685296,424625446,14502382,443749,1,'2007-09-16 19:38:33',3310490757,1),(52685299,424625633,14500321,443749,1,'2007-09-16 19:38:33',3310490671,1),(52685307,424626308,14498634,443749,1,'2007-09-16 19:38:34',3310490671,1),(52685313,424627545,14496310,443749,1,'2007-09-16 19:38:35',3310490671,1),(52685696,424837687,14585331,443749,1,'2007-09-16 19:39:22',3310490823,1),(52685701,424838744,14583757,443749,1,'2007-09-16 19:39:23',3310490823,1),(52685707,424839728,14582650,443749,1,'2007-09-16 19:39:23',3310490823,1),(52685710,424840638,14581421,443749,1,'2007-09-16 19:39:23',3310490823,1),(52685714,424841179,14580585,443749,1,'2007-09-16 19:39:23',3310490823,1),(52685717,424841056,14579724,443749,1,'2007-09-16 19:39:24',3310490823,1),(52685723,424840457,14579274,443749,1,'2007-09-16 19:39:25',3310490823,1),(52685727,424836937,14586608,443749,1,'2007-09-16 19:39:25',3310490823,1),(52685732,424835985,14588109,443749,1,'2007-09-16 19:39:26',3310490823,1),(52685739,424834887,14589372,443749,1,'2007-09-16 19:39:27',3310490823,1),(52685761,424834192,14590770,443749,1,'2007-09-16 19:39:29',3310490823,1),(52685764,424834035,14592082,443749,1,'2007-09-16 19:39:30',3310490823,1),(52685771,424834188,14593843,443749,1,'2007-09-16 19:39:30',3310490823,1),(52685779,424834725,14595690,443749,1,'2007-09-16 19:39:30',3310490823,1),(52685789,424835296,14597436,443749,1,'2007-09-16 19:39:32',3310490823,1),(52685802,424816744,14596902,443749,1,'2007-09-16 19:39:32',3310490822,1),(52685814,424821387,14592237,443749,1,'2007-09-16 19:39:34',3310490823,1),(52685832,424823439,14589925,443749,1,'2007-09-16 19:39:35',3310490823,1),(52685840,424824299,14587943,443749,1,'2007-09-16 19:39:36',3310490823,1),(52685847,424835605,14598566,443749,1,'2007-09-16 19:39:37',3310490823,1),(52685851,424835848,14599376,443749,1,'2007-09-16 19:39:37',3310490823,1),(52685859,424835977,14600041,443749,1,'2007-09-16 19:39:38',3310490823,1),(52685862,424836010,14600720,443749,1,'2007-09-16 19:39:38',3310490823,1),(52685869,424835678,14601301,443749,1,'2007-09-16 19:39:39',3310490823,1),(52685873,424835164,14601649,443749,1,'2007-09-16 19:39:39',3310490823,1),(52685877,424834186,14601699,443749,1,'2007-09-16 19:39:39',3310490823,1),(52685881,424832627,14601400,443749,1,'2007-09-16 19:39:40',3310490823,1),(52685886,424831533,14600919,443749,1,'2007-09-16 19:39:41',3310490823,1),(52685894,424830654,14600439,443749,1,'2007-09-16 19:39:42',3310490823,1),(52685905,424830190,14600439,443749,1,'2007-09-16 19:39:43',3310490823,1),(52685911,424829975,14600637,443749,1,'2007-09-16 19:39:43',3310490823,1),(52685917,424829958,14601118,443749,1,'2007-09-16 19:39:44',3310490823,1),(52685920,424830190,14601682,443749,1,'2007-09-16 19:39:44',3310490823,1),(52685923,424831649,14602826,443749,1,'2007-09-16 19:39:44',3310490823,1),(52685926,424834835,14604943,443749,1,'2007-09-16 19:39:45',3310490823,1),(52685929,424837203,14606166,443749,1,'2007-09-16 19:39:45',3310490823,1),(52685931,424838731,14606510,443749,1,'2007-09-16 19:39:45',3310490823,1),(52685934,424841596,14606815,443749,1,'2007-09-16 19:39:45',3310490823,1),(52685939,424843468,14606701,443749,1,'2007-09-16 19:39:46',3310490823,1),(52685943,424844495,14606426,443749,1,'2007-09-16 19:39:46',3310490823,1),(52685946,424844730,14605707,443749,1,'2007-09-16 19:39:47',3310490823,1),(52685950,424844683,14604533,443749,1,'2007-09-16 19:39:47',3310490823,1),(52685966,424844041,14602890,443749,1,'2007-09-16 19:39:49',3310490823,1),(52685971,424843306,14601247,443749,1,'2007-09-16 19:39:50',3310490823,1),(52685975,424842611,14599702,443749,1,'2007-09-16 19:39:51',3310490823,1),(52685978,424842019,14597446,443749,1,'2007-09-16 19:39:51',3310490823,1),(52685980,424841797,14596373,443749,1,'2007-09-16 19:39:51',3310490823,1),(52685982,424841871,14595374,443749,1,'2007-09-16 19:39:51',3310490823,1),(52685986,424842648,14593599,443749,1,'2007-09-16 19:39:51',3310490823,1),(52685990,424843314,14592785,443749,1,'2007-09-16 19:39:52',3310490823,1),(52685993,424843868,14592526,443749,1,'2007-09-16 19:39:53',3310490823,1),(52685996,424844349,14592489,443749,1,'2007-09-16 19:39:53',3310490823,1),(52686002,424844571,14592822,443749,1,'2007-09-16 19:39:55',3310490823,1),(52686474,424844571,14593303,443749,1,'2007-09-16 19:41:37',3310490823,1),(52686478,424844349,14594265,443749,1,'2007-09-16 19:41:37',3310490823,1),(52686480,424844238,14595522,443749,1,'2007-09-16 19:41:37',3310490823,1),(52686486,424844238,14596077,443749,1,'2007-09-16 19:41:38',3310490823,1),(52686490,424844460,14597520,443749,1,'2007-09-16 19:41:38',3310490823,1),(52686495,424845126,14598999,443749,1,'2007-09-16 19:41:39',3310490823,1),(52686501,424845903,14600442,443749,1,'2007-09-16 19:41:39',3310490823,1),(52686505,424847382,14601329,443749,1,'2007-09-16 19:41:40',3310490823,1),(52686510,424848344,14601588,443749,1,'2007-09-16 19:41:41',3310490834,1),(52686511,424849380,14602143,443749,1,'2007-09-16 19:41:41',3310490834,1),(52686514,424850896,14603364,443749,1,'2007-09-16 19:41:42',3310490834,1);
INSERT INTO `nodes` VALUES (52686517,424852265,14604436,443749,1,'2007-09-16 19:41:42',3310490834,1),(52686518,424853448,14605731,443749,1,'2007-09-16 19:41:42',3310490834,1),(52686521,424854003,14606803,443749,1,'2007-09-16 19:41:43',3310490834,1),(52686524,424854632,14607395,443749,1,'2007-09-16 19:41:43',3310490834,1),(52686527,424855298,14607580,557925,1,'2008-01-06 22:29:13',3310490834,2),(52686533,424855889,14607210,443749,1,'2007-09-16 19:41:44',3310490834,1),(52686537,424856111,14606619,443749,1,'2007-09-16 19:41:45',3310490834,1),(52686542,424855815,14605842,443749,1,'2007-09-16 19:41:46',3310490834,1),(52686544,424855409,14604954,443749,1,'2007-09-16 19:41:46',3310490834,1),(52686547,424854225,14603475,443749,1,'2007-09-16 19:41:46',3310490834,1),(52686551,424851895,14601033,443749,1,'2007-09-16 19:41:47',3310490834,1),(52686555,424850341,14599591,443749,1,'2007-09-16 19:41:47',3310490834,1),(52686561,424849971,14598629,443749,1,'2007-09-16 19:41:49',3310490834,1),(52686569,424850119,14598259,443749,1,'2007-09-16 19:41:50',3310490834,1),(52686574,424850711,14598333,443749,1,'2007-09-16 19:41:50',3310490834,1),(52686579,424851192,14598703,443749,1,'2007-09-16 19:41:50',3310490834,1),(52686586,424852782,14599850,443749,1,'2007-09-16 19:41:50',3310490834,1),(52686593,424855815,14602180,443749,1,'2007-09-16 19:41:51',3310490834,1),(52686598,424857036,14603216,443749,1,'2007-09-16 19:41:51',3310490834,1),(52686601,424857739,14604103,443749,1,'2007-09-16 19:41:51',3310490834,1),(52686604,424858737,14604917,443749,1,'2007-09-16 19:41:52',3310490834,1),(52686607,424859440,14605546,443749,1,'2007-09-16 19:41:53',3310490834,1),(52686610,424860254,14606434,443749,1,'2007-09-16 19:41:54',3310490834,1),(52686622,424860809,14607469,443749,1,'2007-09-16 19:41:56',3310490834,1),(52686626,424861475,14609282,443749,1,'2007-09-16 19:41:56',3310490834,1),(52686632,424861696,14610909,443749,1,'2007-09-16 19:41:57',3310490834,1),(52686637,424861622,14612315,443749,1,'2007-09-16 19:41:58',3310490840,1),(52686639,424861475,14613757,443749,1,'2007-09-16 19:41:59',3310490840,1),(52686644,424861216,14615052,443749,1,'2007-09-16 19:42:00',3310490840,1),(52686648,424861327,14615865,443749,1,'2007-09-16 19:42:01',3310490840,1),(52686651,424861881,14616642,443749,1,'2007-09-16 19:42:02',3310490840,1),(52686654,424861992,14617752,443749,1,'2007-09-16 19:42:02',3310490840,1),(52686655,424862066,14618603,443749,1,'2007-09-16 19:42:02',3310490840,1),(52686659,424861475,14619416,443749,1,'2007-09-16 19:42:03',3310490840,1),(52686660,424860624,14620119,443749,1,'2007-09-16 19:42:03',3310490840,1),(52686663,424859218,14621673,443749,1,'2007-09-16 19:42:04',3310490840,1),(52686666,424858848,14622116,443749,1,'2007-09-16 19:42:04',3310490840,1),(52686668,424857924,14622412,443749,1,'2007-09-16 19:42:04',3310490840,1),(52686674,424856925,14622486,443749,1,'2007-09-16 19:42:06',3310490840,1),(52686680,424856111,14622190,443749,1,'2007-09-16 19:42:08',3310490840,1),(52686682,424854632,14621044,443749,1,'2007-09-16 19:42:08',3310490840,1),(52686683,424853448,14620563,443749,1,'2007-09-16 19:42:08',3310490840,1),(52686687,424852080,14620600,443749,1,'2007-09-16 19:42:08',3310490840,1),(52688384,424850896,14620970,443749,1,'2007-09-16 19:46:44',3310490840,1),(52688387,424849343,14621414,443749,1,'2007-09-16 19:46:44',3310490840,1),(52688389,424848196,14622153,443749,1,'2007-09-16 19:46:44',3310490840,1),(52688391,424846827,14623300,443749,1,'2007-09-16 19:46:45',3310490829,1),(52688393,424845496,14624447,443749,1,'2007-09-16 19:46:45',3310490829,1),(52688398,424843425,14625667,443749,1,'2007-09-16 19:46:45',3310490829,1),(52688401,424841834,14626592,443749,1,'2007-09-16 19:46:46',3310490829,1),(52688431,424841020,14626962,443749,1,'2007-09-16 19:46:50',3310490829,1),(52688438,424840540,14627332,443749,1,'2007-09-16 19:46:51',3310490829,1),(52688454,424840170,14627886,443749,1,'2007-09-16 19:46:54',3310490829,1),(52688455,424840207,14628256,443749,1,'2007-09-16 19:46:54',3310490829,1),(52688458,424840392,14628515,443749,1,'2007-09-16 19:46:55',3310490829,1),(52688531,424840651,14628626,443749,1,'2007-09-16 19:47:07',3310490829,1),(52688570,424841094,14628515,443749,1,'2007-09-16 19:47:13',3310490829,1),(52688574,424841982,14628219,443749,1,'2007-09-16 19:47:14',3310490829,1),(52688576,424843462,14627886,443749,1,'2007-09-16 19:47:14',3310490829,1),(52688577,424845496,14627849,443749,1,'2007-09-16 19:47:14',3310490829,1),(52688580,424846753,14627554,443749,1,'2007-09-16 19:47:14',3310490829,1),(52688582,424847604,14627184,443749,1,'2007-09-16 19:47:15',3310490829,1),(52688584,424848862,14627295,443749,1,'2007-09-16 19:47:15',3310490840,1),(52688608,424850082,14627332,443749,1,'2007-09-16 19:47:19',3310490840,1),(52688609,424851451,14627295,443749,1,'2007-09-16 19:47:20',3310490840,1),(52688628,424852006,14627665,443749,1,'2007-09-16 19:47:22',3310490840,1),(52688632,424852154,14627960,443749,1,'2007-09-16 19:47:22',3310490840,1),(52688633,424851599,14628700,443749,1,'2007-09-16 19:47:22',3310490840,1),(52688637,424850267,14629366,443749,1,'2007-09-16 19:47:22',3310490840,1),(52688639,424849010,14629625,443749,1,'2007-09-16 19:47:22',3310490840,1),(52688642,424852028,14628349,443749,1,'2007-09-16 19:47:23',3310490840,1),(52688644,424847616,14630380,443749,1,'2007-09-16 19:47:23',3310490829,1),(52688646,424845712,14631893,443749,1,'2007-09-16 19:47:23',3310490829,1),(52688648,424843515,14633504,443749,1,'2007-09-16 19:47:23',3310490829,1),(52688652,424842100,14635505,443749,1,'2007-09-16 19:47:23',3310490829,1),(52688654,424840733,14637653,443749,1,'2007-09-16 19:47:23',3310490829,1),(52688655,424840196,14639508,443749,1,'2007-09-16 19:47:24',3310490829,1),(52688662,425057314,15310651,443749,1,'2007-09-16 19:47:24',3310491437,1),(52688663,425053517,15312851,443749,1,'2007-09-16 19:47:24',3310491437,1),(52688667,425056708,15326937,443749,1,'2007-09-16 19:47:25',3310491439,1),(52688669,425060615,15324846,443749,1,'2007-09-16 19:47:25',3310491437,1),(52688672,425053738,15274546,3916355,1,'2010-02-19 17:34:14',3310491437,5),(52688676,425053294,15275475,3916355,1,'2010-02-19 17:34:13',3310491437,5),(52688677,425052326,15275408,3916355,1,'2010-02-19 17:34:13',3310491437,5),(52688680,425052053,15274977,3916355,1,'2010-02-19 17:34:13',3310491437,5),(52688683,425051955,15274401,3916355,1,'2010-02-19 17:34:13',3310491437,5),(52688686,425052061,15273850,3916355,1,'2010-02-19 17:34:12',3310491437,5),(52688688,425052378,15273393,3916355,1,'2010-02-19 17:34:12',3310491437,5),(52688692,425053179,15273298,3916355,1,'2010-02-19 17:34:12',3310491437,7),(52688693,425053366,15273436,3916355,1,'2010-02-19 17:34:14',3310491437,5),(52688697,425053618,15273808,3916355,1,'2010-02-19 17:34:14',3310491437,5),(52688698,425054664,15277614,305941,1,'2009-02-09 21:25:15',3310491437,2),(52688701,425053923,15275845,305941,1,'2009-02-09 21:25:15',3310491437,2),(52688703,425053643,15274980,3916355,1,'2010-02-19 17:34:13',3310491437,6),(52688706,425059729,15316721,3916355,1,'2010-02-19 17:34:21',3310491437,5),(52688708,425060596,15316651,3916355,1,'2010-02-19 17:34:21',3310491437,3),(52688711,425060215,15316484,3916355,1,'2010-02-19 17:34:21',3310491437,3),(52688716,425059559,15317020,3916355,1,'2010-02-19 17:34:21',3310491437,3),(52688721,425059490,15317551,3916355,1,'2010-02-19 17:34:21',3310491437,3),(52688724,425059580,15317928,3916355,1,'2010-02-19 17:34:21',3310491437,3),(52688726,425059843,15318283,3916355,1,'2010-02-19 17:34:22',3310491437,3),(52688728,425060185,15318411,3916355,1,'2010-02-19 17:34:22',3310491437,4),(52688732,425060615,15318225,3916355,1,'2010-02-19 17:34:22',3310491437,3),(52688735,425060891,15317644,3916355,1,'2010-02-19 17:34:22',3310491437,3),(52688740,425060899,15317315,3916355,1,'2010-02-19 17:34:20',3310491437,3),(52688741,425053293,15243665,840745,1,'2009-01-26 20:08:19',3310491431,3),(52688744,425057235,15247441,840745,1,'2009-01-26 20:08:19',3310491431,3),(52688747,425059259,15249858,840745,1,'2009-01-26 20:08:19',3310491431,3),(52688750,425060731,15251568,840745,1,'2009-01-26 20:08:19',3310491431,3),(52688753,425061808,15253194,840745,1,'2009-01-26 20:08:20',3310491431,3),(52688756,425063091,15255229,840745,1,'2009-01-26 20:08:20',3310491431,3),(52688759,425063724,15256837,840745,1,'2009-01-26 20:08:20',3310491431,3),(52688763,425064648,15259643,840745,1,'2009-01-26 20:08:20',3310491431,3),(52688767,425065127,15262414,840745,1,'2009-01-26 20:08:21',3310491431,3),(52688771,425065435,15265374,840745,1,'2009-01-26 20:08:21',3310491431,3),(52688773,425065503,15269616,840745,1,'2009-01-26 20:08:21',3310491431,3),(52688774,425064869,15270564,840745,1,'2009-01-26 20:08:21',3310491431,3),(52688778,425061416,15267779,840745,1,'2009-01-26 20:08:21',3310491431,3),(52688781,425060318,15269662,840745,1,'2009-01-26 20:08:21',3310491431,3),(52688783,425058780,15267240,840745,1,'2009-01-26 20:08:21',3310491431,3),(52688788,425057641,15264836,840745,1,'2009-01-26 20:08:22',3310491431,3),(52688790,425055489,15260545,840745,1,'2009-01-26 20:08:22',3310491431,3),(52688795,425053453,15254127,840745,1,'2009-01-26 20:08:22',3310491431,3),(52688797,425052119,15247183,840745,1,'2009-01-26 20:08:22',3310491431,3),(52688801,425051576,15244745,840745,1,'2009-01-26 20:08:22',3310491431,3),(52688802,425051199,15243539,840745,1,'2009-01-26 20:08:22',3310491431,3),(52688807,425051199,15242761,840745,1,'2009-01-26 20:08:22',3310491431,3),(52688810,425066895,15320193,3916355,1,'2010-02-19 17:34:15',3310491437,3),(52688816,425067741,15321356,3916355,1,'2010-02-19 17:34:16',3310491448,4),(52688820,425067559,15321770,3916355,1,'2010-02-19 17:34:16',3310491448,3),(52688824,425067045,15322036,3916355,1,'2010-02-19 17:34:15',3310491437,3),(52688829,425066666,15321854,3916355,1,'2010-02-19 17:34:15',3310491437,4),(52688833,425066459,15321523,3916355,1,'2010-02-19 17:34:15',3310491437,5),(52688838,425066385,15321066,3916355,1,'2010-02-19 17:34:15',3310491437,3),(52688842,425066525,15320530,3916355,1,'2010-02-19 17:34:15',3310491437,3),(52688846,425067352,15320238,3916355,1,'2010-02-19 17:34:14',3310491437,3),(52688849,425067530,15320390,3916355,1,'2010-02-19 17:34:16',3310491448,3),(52688854,425063980,15322880,820251,1,'2009-03-16 23:51:15',3310491437,3),(52688859,425061665,15324233,820251,1,'2009-03-16 23:51:15',3310491437,4),(52688860,425066149,15322742,305941,1,'2009-02-09 21:22:43',3310491437,2),(52688863,425065890,15324522,305941,1,'2009-02-09 21:22:43',3310491437,2),(52688865,425066038,15328637,305941,1,'2009-02-09 21:22:43',3310491439,2),(52688868,425066631,15332159,305941,1,'2009-02-09 21:22:43',3310491439,2),(52688870,425068077,15337090,305941,1,'2009-02-09 21:22:43',3310491450,2),(52688872,425069410,15341569,305941,1,'2009-02-09 21:22:44',3310491450,6),(52688876,425070756,15319990,443749,1,'2007-09-16 19:47:44',3310491448,1),(52688880,425070205,15319053,305941,1,'2009-02-09 21:24:48',3310491448,2),(52688882,425062710,15235378,4652669,1,'2010-05-09 22:02:42',3310491431,2),(52688884,425057667,15238007,4652669,1,'2010-05-09 21:57:58',3310491431,2),(52688886,425054755,15239143,4652669,1,'2010-05-09 22:03:56',3310491431,2),(52688888,425053264,15237722,4652669,1,'2010-05-09 22:03:43',3310491431,2),(52688890,425051346,15233035,4652669,1,'2010-05-09 21:59:17',3310491431,2),(52688892,425049273,15187529,305941,1,'2009-02-09 21:34:26',3310491429,2),(52688894,425049562,15188492,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688896,425050183,15190613,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688899,425050839,15193824,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688903,425051029,15196362,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688904,425051046,15198813,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688905,425051754,15201973,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688908,425052347,15204626,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688912,425053170,15209424,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688914,425054065,15213290,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688916,425054388,15214078,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688920,425054853,15214257,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688923,425055354,15213648,305941,1,'2009-02-09 21:34:27',3310491429,2),(52688929,425053959,15143802,697263,1,'2009-01-01 16:45:34',3310491407,3),(52688931,425056761,15145915,697263,1,'2009-01-01 16:45:34',3310491407,3),(52688934,425058678,15147079,697263,1,'2009-01-01 16:45:34',3310491407,4),(52688936,425024945,15099061,443749,1,'2007-09-16 19:47:49',3310491404,1),(52688938,425021946,15099797,443749,1,'2007-09-16 19:47:49',3310491404,1),(52688942,425021146,15100618,443749,1,'2007-09-16 19:47:49',3310491404,1),(52688945,425020430,15101713,443749,1,'2007-09-16 19:47:49',3310491404,1),(52688948,425019419,15102808,443749,1,'2007-09-16 19:47:50',3310491404,1),(52688951,425018704,15103102,443749,1,'2007-09-16 19:47:50',3310491404,1),(52688953,425018199,15103060,443749,1,'2007-09-16 19:47:50',3310491404,1),(52688956,425017693,15102597,443749,1,'2007-09-16 19:47:50',3310491404,1),(52688958,425017525,15102050,443749,1,'2007-09-16 19:47:51',3310491404,1),(52688962,425016978,15101587,443749,1,'2007-09-16 19:47:51',3310491404,1),(52688963,425015925,15101503,443749,1,'2007-09-16 19:47:51',3310491404,1),(52688967,425015420,15101545,443749,1,'2007-09-16 19:47:51',3310491404,1),(52688969,425015420,15100155,443749,1,'2007-09-16 19:47:51',3310491404,1),(52688973,425014494,15099818,443749,1,'2007-09-16 19:47:52',3310491404,1),(52688975,425013946,15100029,443749,1,'2007-09-16 19:47:52',3310491404,1),(52688978,425013609,15100703,443749,1,'2007-09-16 19:47:52',3310491404,1),(52688981,425012010,15103060,443749,1,'2007-09-16 19:47:52',3310491401,1),(52689010,425011420,15104029,443749,1,'2007-09-16 19:48:02',3310491401,1),(52689011,425012388,15107692,443749,1,'2007-09-16 19:48:02',3310491403,1),(52689013,425014830,15113165,443749,1,'2007-09-16 19:48:02',3310491406,1),(52689016,425019335,15119101,443749,1,'2007-09-16 19:48:03',3310491406,1),(52689017,425022325,15116028,443749,1,'2007-09-16 19:48:03',3310491406,1),(52689019,425024177,15118133,443749,1,'2007-09-16 19:48:03',3310491406,1),(52689020,425025187,15117291,443749,1,'2007-09-16 19:48:03',3310491406,1),(52689024,425026030,15107144,443749,1,'2007-09-16 19:48:04',3310491406,1),(52689026,425026282,15106386,443749,1,'2007-09-16 19:48:05',3310491404,1),(52689028,425026703,15106386,443749,1,'2007-09-16 19:48:05',3310491404,1),(52689032,425027250,15107818,443749,1,'2007-09-16 19:48:06',3310491406,1),(52689035,425029861,15115144,443749,1,'2007-09-16 19:48:07',3310491406,1),(52689036,425032387,15114091,443749,1,'2007-09-16 19:48:07',3310491406,1),(52689039,425032555,15113838,443749,1,'2007-09-16 19:48:08',3310491406,1),(52689041,425028050,15104323,443749,1,'2007-09-16 19:48:08',3310491404,1),(52689048,425025609,15099187,443749,1,'2007-09-16 19:48:09',3310491404,1),(52689055,425024072,15158901,3916355,1,'2010-02-19 17:31:55',3310491406,3),(52689060,425024272,15158920,3916355,1,'2010-02-19 17:31:56',3310491406,3),(52689065,425024860,15160441,3916355,1,'2010-02-19 17:31:56',3310491406,3),(52689066,425024216,15161557,3916355,1,'2010-02-19 17:31:56',3310491428,3),(52689073,425024388,15162329,3916355,1,'2010-02-19 17:31:56',3310491428,3),(52689076,425025847,15162587,3916355,1,'2010-02-19 17:31:56',3310491428,3),(52689081,425026796,15162818,443749,1,'2007-09-16 19:48:13',3310491428,1),(52689083,425028114,15163609,443749,1,'2007-09-16 19:48:13',3310491428,1),(52689086,425029116,15164321,443749,1,'2007-09-16 19:48:14',3310491428,1),(52689090,425029986,15165665,443749,1,'2007-09-16 19:48:15',3310491428,1),(52689092,425030566,15167010,443749,1,'2007-09-16 19:48:16',3310491428,1),(52689094,425029775,15168249,443749,1,'2007-09-16 19:48:16',3310491428,1),(52689095,425028167,15169277,443749,1,'2007-09-16 19:48:16',3310491428,1),(52689097,425024265,15170279,443749,1,'2007-09-16 19:48:17',3310491428,1),(52689102,425019203,15170253,443749,1,'2007-09-16 19:48:18',3310491428,1),(52689104,425017436,15169646,443749,1,'2007-09-16 19:48:19',3310491428,1),(52689106,425017647,15169172,443749,1,'2007-09-16 19:48:19',3310491428,1),(52689107,425018517,15168908,443749,1,'2007-09-16 19:48:19',3310491428,1),(52689110,425019045,15168565,443749,1,'2007-09-16 19:48:19',3310491428,1),(52689111,425019704,15168275,443749,1,'2007-09-16 19:48:19',3310491428,1),(52689114,425020627,15167643,443749,1,'2007-09-16 19:48:20',3310491428,1),(52689115,425021154,15167300,443749,1,'2007-09-16 19:48:20',3310491428,1),(52689118,425021101,15166931,443749,1,'2007-09-16 19:48:20',3310491428,1),(52689120,425019836,15165718,443749,1,'2007-09-16 19:48:21',3310491428,1),(52689141,425018386,15163741,443749,1,'2007-09-16 19:48:25',3310491428,1),(52689142,425016540,15160893,443749,1,'2007-09-16 19:48:25',3310491406,1),(52689145,425014932,15158837,443749,1,'2007-09-16 19:48:26',3310491406,1),(52689148,425014378,15158494,443749,1,'2007-09-16 19:48:26',3310491406,1),(52689150,425013798,15157413,443749,1,'2007-09-16 19:48:26',3310491406,1),(52689154,425013851,15156675,443749,1,'2007-09-16 19:48:26',3310491406,1),(52689156,425013534,15155726,443749,1,'2007-09-16 19:48:27',3310491406,1),(52689157,425012137,15153353,443749,1,'2007-09-16 19:48:27',3310491403,1),(52689160,425011135,15151903,443749,1,'2007-09-16 19:48:27',3310491403,1),(52689162,425009685,15150558,443749,1,'2007-09-16 19:48:27',3310491403,1),(52689165,425012585,15146024,443749,1,'2007-09-16 19:48:27',3310491403,1),(52689167,425015749,15148159,443749,1,'2007-09-16 19:48:27',3310491406,1),(52689173,425016830,15148845,443749,1,'2007-09-16 19:48:28',3310491406,1),(52689178,425018755,15149187,443749,1,'2007-09-16 19:48:28',3310491406,1),(52689180,425018755,15149873,443749,1,'2007-09-16 19:48:28',3310491406,1),(52689184,425018175,15150927,443749,1,'2007-09-16 19:48:28',3310491406,1),(52689187,425017912,15151511,443749,1,'2007-09-16 19:48:29',3310491406,1),(52689189,425017723,15152078,443749,1,'2007-09-16 19:48:29',3310491406,1),(52689194,425017669,15152361,443749,1,'2007-09-16 19:48:30',3310491406,1),(52689197,425017459,15153281,443749,1,'2007-09-16 19:48:30',3310491406,1),(52689201,425018185,15154530,443749,1,'2007-09-16 19:48:30',3310491406,1),(52689204,425019112,15154974,443749,1,'2007-09-16 19:48:30',3310491406,1),(52689208,425019797,15155337,443749,1,'2007-09-16 19:48:31',3310491406,1),(52689210,425020264,15154598,443749,1,'2007-09-16 19:48:31',3310491406,1),(52689214,425021311,15155703,443749,1,'2007-09-16 19:48:32',3310491406,1),(52689217,425022784,15157932,443749,1,'2007-09-16 19:48:32',3310491406,1),(52689218,425023102,15158268,443749,1,'2007-09-16 19:48:33',3310491406,1),(52689226,425037665,15232304,454632,1,'2007-09-17 19:00:43',3310491430,1),(52689230,425040974,15233849,443749,1,'2007-09-16 19:48:35',3310491431,1),(52689232,425042629,15235393,443749,1,'2007-09-16 19:48:35',3310491431,1),(52689236,425043401,15237820,443749,1,'2007-09-16 19:48:35',3310491431,1),(52689239,425044394,15240798,443749,1,'2007-09-16 19:48:35',3310491431,1),(52689242,425044063,15242894,443749,1,'2007-09-16 19:48:36',3310491431,1),(52689243,425042739,15245431,443749,1,'2007-09-16 19:48:36',3310491431,1),(52689245,425042077,15248410,443749,1,'2007-09-16 19:48:36',3310491431,1),(52689248,425041636,15252491,443749,1,'2007-09-16 19:48:36',3310491431,1),(52689249,425042739,15256572,443749,1,'2007-09-16 19:48:36',3310491431,1),(52689251,425043070,15261647,443749,1,'2007-09-16 19:48:37',3310491431,1),(52689253,425041857,15262640,443749,1,'2007-09-16 19:48:37',3310491431,1),(52689255,425039981,15263963,443749,1,'2007-09-16 19:48:37',3310491430,1),(52689257,425040312,15267273,443749,1,'2007-09-16 19:48:37',3310491431,1),(52689259,425041195,15273671,443749,1,'2007-09-16 19:48:37',3310491437,1),(52689262,425041617,15274471,443749,1,'2007-09-16 19:48:38',3310491437,1),(52689263,425043901,15274558,443749,1,'2007-09-16 19:48:38',3310491437,1),(52689265,425045029,15274703,443749,1,'2007-09-16 19:48:38',3310491437,1),(52689267,425045405,15276351,443749,1,'2007-09-16 19:48:39',3310491437,1),(52689270,425046091,15278791,443749,1,'2007-09-16 19:48:39',3310491437,1),(52689273,425047386,15283396,443749,1,'2007-09-16 19:48:39',3310491437,1),(52689275,425048207,15288030,443749,1,'2007-09-16 19:48:40',3310491437,1),(52689278,425049358,15295168,443749,1,'2007-09-16 19:48:40',3310491437,1),(52689279,425047861,15297240,443749,1,'2007-09-16 19:48:40',3310491437,1),(52689280,425046019,15299888,443749,1,'2007-09-16 19:48:40',3310491437,1),(52689282,425046710,15304263,443749,1,'2007-09-16 19:48:41',3310491437,1),(52689285,425049933,15323029,443749,1,'2007-09-16 19:48:41',3310491437,1),(52689288,425051200,15326368,443749,1,'2007-09-16 19:48:41',3310491439,1),(52689290,425057187,15331894,443749,1,'2007-09-16 19:48:41',3310491439,1),(52689292,425058798,15336384,443749,1,'2007-09-16 19:48:41',3310491439,1),(52689294,425060640,15342486,443749,1,'2007-09-16 19:48:41',3310491439,1),(52689295,425062482,15345594,443749,1,'2007-09-16 19:48:41',3310491439,1),(52689303,425065015,15347321,443749,1,'2007-09-16 19:48:42',3310491439,1),(52689304,425065936,15351351,443749,1,'2007-09-16 19:48:42',3310491439,1),(52689308,425067548,15360216,443749,1,'2007-09-16 19:48:43',3310491450,1),(52689311,425068584,15365627,443749,1,'2007-09-16 19:48:43',3310491450,1),(52689316,425069160,15373686,443749,1,'2007-09-16 19:48:43',3310491450,1),(52689319,425070772,15382551,443749,1,'2007-09-16 19:48:44',3310491536,1),(52689321,425072959,15397632,443749,1,'2007-09-16 19:48:44',3310491536,1),(52689323,425074456,15405806,443749,1,'2007-09-16 19:48:44',3310491536,1),(52689326,425076183,15416859,443749,1,'2007-09-16 19:48:45',3310491536,1),(52689328,425077910,15423076,443749,1,'2007-09-16 19:48:45',3310491536,1),(52689330,425078831,15427681,443749,1,'2007-09-16 19:48:45',3310491536,1),(52689333,425080097,15432171,443749,1,'2007-09-16 19:48:45',3310491536,1),(52689336,425082285,15437467,443749,1,'2007-09-16 19:48:45',3310491538,1),(52689338,425083090,15441381,443749,1,'2007-09-16 19:48:46',3310491538,1),(52689340,425083321,15445065,443749,1,'2007-09-16 19:48:46',3310491538,1),(52689343,425082745,15449095,443749,1,'2007-09-16 19:48:46',3310491538,1),(52689345,425081248,15454045,443749,1,'2007-09-16 19:48:46',3310491538,1),(52689348,425079867,15459687,443749,1,'2007-09-16 19:48:46',3310491538,1),(52689350,425079291,15466709,443749,1,'2007-09-16 19:48:47',3310491538,1),(52689351,425081018,15472696,443749,1,'2007-09-16 19:48:47',3310491538,1),(52689353,425081363,15474883,443749,1,'2007-09-16 19:48:47',3310491538,1),(52689355,425077795,15479949,443749,1,'2007-09-16 19:48:47',3310491538,1),(52689358,425075377,15481100,443749,1,'2007-09-16 19:48:48',3310491538,1),(52689359,425072499,15481906,443749,1,'2007-09-16 19:48:48',3310491538,1),(52689361,425070081,15485015,443749,1,'2007-09-16 19:48:48',3310491538,1),(52689363,425070081,15486857,443749,1,'2007-09-16 19:48:48',3310491538,1),(52689365,425067893,15489159,443749,1,'2007-09-16 19:48:49',3310491538,1),(52689366,425065936,15489620,443749,1,'2007-09-16 19:48:49',3310491527,1),(52689367,425065130,15491692,443749,1,'2007-09-16 19:48:49',3310491533,1),(52689371,425062943,15495376,443749,1,'2007-09-16 19:48:49',3310491533,1),(52689372,425058568,15499981,443749,1,'2007-09-16 19:48:49',3310491533,1),(52689375,425052006,15505508,443749,1,'2007-09-16 19:48:50',3310491533,1),(52689377,425046480,15512415,443749,1,'2007-09-16 19:48:50',3310491533,1),(52689379,425042565,15512646,443749,1,'2007-09-16 19:48:50',3310491533,1),(52689382,425044177,15508040,443749,1,'2007-09-16 19:48:51',3310491533,1),(52689385,425048667,15499060,443749,1,'2007-09-16 19:48:51',3310491533,1),(52689387,425054769,15488123,443749,1,'2007-09-16 19:48:51',3310491527,1),(52689390,425056841,15483863,443749,1,'2007-09-16 19:48:52',3310491527,1),(52689392,425059719,15480064,443749,1,'2007-09-16 19:48:52',3310491527,1),(52689394,425061677,15475574,443749,1,'2007-09-16 19:48:52',3310491527,1),(52689396,425063403,15464522,443749,1,'2007-09-16 19:48:53',3310491527,1),(52689398,425064555,15457844,443749,1,'2007-09-16 19:48:53',3310491527,1),(52689402,425063995,15453799,443749,1,'2007-09-16 19:48:53',3310491527,1),(52689405,425062995,15447400,443749,1,'2007-09-16 19:48:53',3310491527,1),(52689406,425061895,15439901,443749,1,'2007-09-16 19:48:54',3310491527,1),(52689409,425060995,15435102,443749,1,'2007-09-16 19:48:54',3310491525,1),(52689410,425057696,15423804,443749,1,'2007-09-16 19:48:54',3310491525,1),(52689412,425056696,15414505,443749,1,'2007-09-16 19:48:54',3310491525,1),(52689414,425060796,15412006,443749,1,'2007-09-16 19:48:54',3310491525,1),(52689416,425058796,15400308,443749,1,'2007-09-16 19:48:54',3310491525,1),(52689419,425055296,15385310,443749,1,'2007-09-16 19:48:54',3310491525,1),(52689420,425048797,15383710,443749,1,'2007-09-16 19:48:55',3310491525,1),(52689423,425045598,15383710,443749,1,'2007-09-16 19:48:55',3310491525,1),(52689425,425040499,15383710,443749,1,'2007-09-16 19:48:55',3310491525,1),(52689427,425033942,15382518,443749,1,'2007-09-16 19:48:55',3310491524,1),(52689429,425033810,15378139,443749,1,'2007-09-16 19:48:55',3310491438,1),(52689432,425030492,15362482,443749,1,'2007-09-16 19:48:56',3310491438,1),(52689433,425029696,15356378,443749,1,'2007-09-16 19:48:56',3310491438,1),(52689436,425027308,15348019,443749,1,'2007-09-16 19:48:56',3310491438,1),(52689437,425026512,15340323,443749,1,'2007-09-16 19:48:56',3310491438,1),(52689440,425022266,15337271,443749,1,'2007-09-16 19:48:56',3310491438,1),(52689443,425018948,15332892,443749,1,'2007-09-16 19:48:57',3310491438,1),(52689445,425017091,15331300,443749,1,'2007-09-16 19:48:57',3310491438,1),(52689447,425016693,15333158,443749,1,'2007-09-16 19:48:58',3310491438,1),(52689450,425018020,15335679,443749,1,'2007-09-16 19:48:58',3310491438,1),(52689451,425019877,15338731,443749,1,'2007-09-16 19:48:58',3310491438,1),(52689452,425021337,15340986,443749,1,'2007-09-16 19:48:58',3310491438,1),(52689455,425021469,15342180,443749,1,'2007-09-16 19:48:58',3310491438,1),(52689456,425020143,15342977,443749,1,'2007-09-16 19:48:59',3310491438,1),(52689459,425018683,15341252,443749,1,'2007-09-16 19:48:59',3310491438,1),(52689461,425016427,15339527,443749,1,'2007-09-16 19:48:59',3310491438,1),(52689464,425012977,15336740,443749,1,'2007-09-16 19:48:59',3310491438,1),(52689484,425011252,15334219,443749,1,'2007-09-16 19:49:03',3310491435,1),(52689486,425010589,15330902,443749,1,'2007-09-16 19:49:03',3310491435,1),(52689488,425008997,15330504,443749,1,'2007-09-16 19:49:03',3310491435,1),(52689491,425009129,15334086,443749,1,'2007-09-16 19:49:03',3310491435,1),(52689493,425009793,15337669,443749,1,'2007-09-16 19:49:03',3310491435,1),(52689494,425012049,15341782,443749,1,'2007-09-16 19:49:04',3310491435,1),(52689496,425014835,15344303,443749,1,'2007-09-16 19:49:04',3310491438,1),(52689497,425016029,15345630,443749,1,'2007-09-16 19:49:04',3310491438,1),(52689499,425017621,15347488,443749,1,'2007-09-16 19:49:04',3310491438,1),(52689501,425017754,15348550,443749,1,'2007-09-16 19:49:04',3310491438,1),(52689503,425015764,15348682,443749,1,'2007-09-16 19:49:05',3310491438,1),(52689505,425014039,15346825,443749,1,'2007-09-16 19:49:05',3310491438,1),(52689508,425011385,15343773,443749,1,'2007-09-16 19:49:05',3310491435,1),(52689513,425008731,15341384,443749,1,'2007-09-16 19:49:06',3310491435,1),(52689516,425005812,15338731,443749,1,'2007-09-16 19:49:06',3310491435,1),(52689518,425003822,15335811,443749,1,'2007-09-16 19:49:06',3310491435,1),(52689522,425002760,15331433,443749,1,'2007-09-16 19:49:06',3310491435,1),(52689524,425002628,15327319,443749,1,'2007-09-16 19:49:07',3310491435,1),(52689527,425003954,15323339,443749,1,'2007-09-16 19:49:07',3310491433,1),(52689528,425005016,15319491,443749,1,'2007-09-16 19:49:07',3310491433,1),(52689532,425006741,15315643,443749,1,'2007-09-16 19:49:08',3310491433,1),(52689534,425005281,15313387,443749,1,'2007-09-16 19:49:08',3310491433,1),(52689537,425003158,15314183,443749,1,'2007-09-16 19:49:08',3310491433,1),(52689538,424995064,15310070,443749,1,'2007-09-16 19:49:08',3310491433,1),(52689540,424993339,15308345,443749,1,'2007-09-16 19:49:08',3310491433,1),(52689545,424992941,15305956,443749,1,'2007-09-16 19:49:08',3310491433,1),(52689549,424994799,15305426,443749,1,'2007-09-16 19:49:09',3310491433,1),(52689552,424999841,15306752,443749,1,'2007-09-16 19:49:09',3310491433,1),(52689553,425004087,15306620,443749,1,'2007-09-16 19:49:09',3310491433,1),(52689556,425006741,15304629,443749,1,'2007-09-16 19:49:10',3310491433,1),(52689558,425007006,15300649,443749,1,'2007-09-16 19:49:10',3310491433,1),(52689560,425004353,15298791,443749,1,'2007-09-16 19:49:10',3310491433,1),(52689562,425002097,15295076,443749,1,'2007-09-16 19:49:10',3310491433,1),(52689565,424997573,15288284,443749,1,'2007-09-16 19:49:11',3310491433,1),(52689567,425001035,15288309,443749,1,'2007-09-16 19:49:11',3310491433,1),(52689570,425012304,15281223,443749,1,'2007-09-16 19:49:11',3310491433,1),(52689572,425016221,15279821,443749,1,'2007-09-16 19:49:11',3310491436,1),(52689573,425017871,15280935,443749,1,'2007-09-16 19:49:11',3310491436,1),(52689576,425020091,15283542,443749,1,'2007-09-16 19:49:12',3310491436,1),(52689579,425021538,15283692,443749,1,'2007-09-16 19:49:12',3310491436,1),(52689580,425021850,15282511,443749,1,'2007-09-16 19:49:12',3310491436,1),(52689583,425020275,15279949,443749,1,'2007-09-16 19:49:13',3310491436,1),(52689584,425017754,15278092,443749,1,'2007-09-16 19:49:13',3310491436,1),(52689585,425014304,15275040,443749,1,'2007-09-16 19:49:13',3310491436,1),(52689586,425010456,15269732,443749,1,'2007-09-16 19:49:13',3310491427,1),(52689589,425007935,15264027,443749,1,'2007-09-16 19:49:13',3310491427,1),(52689591,425004353,15255136,443749,1,'2007-09-16 19:49:13',3310491427,1),(52689593,425006476,15255004,443749,1,'2007-09-16 19:49:13',3310491427,1),(52689594,425009793,15259117,443749,1,'2007-09-16 19:49:13',3310491427,1),(52689596,425012181,15262434,443749,1,'2007-09-16 19:49:13',3310491427,1),(52689600,425015100,15263098,443749,1,'2007-09-16 19:49:14',3310491430,1),(52689603,425019479,15267344,443749,1,'2007-09-16 19:49:14',3310491430,1),(52689604,425020408,15266150,443749,1,'2007-09-16 19:49:14',3310491430,1),(52689607,425016693,15261903,443749,1,'2007-09-16 19:49:14',3310491430,1),(52689608,425015764,15259250,443749,1,'2007-09-16 19:49:14',3310491430,1),(52689609,425013375,15254738,443749,1,'2007-09-16 19:49:14',3310491430,1),(52689610,425010854,15250625,443749,1,'2007-09-16 19:49:15',3310491427,1),(52689612,425007670,15245715,443749,1,'2007-09-16 19:49:15',3310491427,1),(52689613,425003026,15238550,443749,1,'2007-09-16 19:49:15',3310491427,1),(52689615,425001831,15236693,443749,1,'2007-09-16 19:49:15',3310491427,1),(52689617,424997983,15233906,443749,1,'2007-09-16 19:49:15',3310491427,1),(52689618,424995064,15232314,443749,1,'2007-09-16 19:49:15',3310491427,1),(52689619,424993074,15235896,443749,1,'2007-09-16 19:49:15',3310491427,1),(52689621,424992676,15239081,443749,1,'2007-09-16 19:49:15',3310491427,1),(52689624,424990155,15239479,443749,1,'2007-09-16 19:49:16',3310491427,1),(52689627,424986307,15235366,443749,1,'2007-09-16 19:49:16',3310491427,1),(52689629,424981795,15230589,443749,1,'2007-09-16 19:49:16',3310491426,1),(52689631,424980601,15227802,443749,1,'2007-09-16 19:49:17',3310491426,1),(52689635,424979805,15215064,443749,1,'2007-09-16 19:49:17',3310491424,1),(52689639,424976222,15214268,443749,1,'2007-09-16 19:49:17',3310491424,1),(52689643,424969986,15214003,443749,1,'2007-09-16 19:49:18',3310491424,1),(52689647,424975559,15208032,443749,1,'2007-09-16 19:49:18',3310491424,1),(52689650,424980070,15204714,443749,1,'2007-09-16 19:49:18',3310491424,1),(52689653,424985511,15199540,443749,1,'2007-09-16 19:49:18',3310491425,1),(52689656,424987236,15196488,443749,1,'2007-09-16 19:49:18',3310491425,1),(52689659,424990022,15191578,443749,1,'2007-09-16 19:49:19',3310491425,1),(52689661,424991216,15190384,443749,1,'2007-09-16 19:49:19',3310491425,1),(52689663,424992012,15191578,443749,1,'2007-09-16 19:49:19',3310491425,1),(52689665,424991084,15195161,443749,1,'2007-09-16 19:49:19',3310491425,1),(52689666,424990420,15197815,443749,1,'2007-09-16 19:49:19',3310491425,1),(52689670,424988961,15200866,443749,1,'2007-09-16 19:49:20',3310491425,1),(52689673,424988828,15203388,443749,1,'2007-09-16 19:49:20',3310491425,1),(52689676,424989226,15204847,443749,1,'2007-09-16 19:49:20',3310491425,1),(52689679,424992145,15204582,443749,1,'2007-09-16 19:49:20',3310491425,1),(52689681,424994135,15203122,443749,1,'2007-09-16 19:49:20',3310491425,1),(52689684,424995993,15202061,443749,1,'2007-09-16 19:49:20',3310491425,1),(52689687,424998780,15198611,443749,1,'2007-09-16 19:49:21',3310491425,1),(52689689,425000903,15197549,443749,1,'2007-09-16 19:49:21',3310491425,1),(52689692,425002628,15198743,443749,1,'2007-09-16 19:49:21',3310491425,1),(52689696,425004751,15202591,443749,1,'2007-09-16 19:49:21',3310491425,1),(52689699,425005812,15204714,443749,1,'2007-09-16 19:49:22',3310491425,1),(52689701,425008599,15208297,443749,1,'2007-09-16 19:49:22',3310491425,1),(52689705,425015366,15214401,443749,1,'2007-09-16 19:49:22',3310491428,1),(52689707,425019214,15213870,443749,1,'2007-09-16 19:49:22',3310491428,1),(52689709,425021469,15211084,443749,1,'2007-09-16 19:49:23',3310491428,1),(52689713,425022796,15210420,443749,1,'2007-09-16 19:49:23',3310491428,1),(52689714,425023991,15210951,443749,1,'2007-09-16 19:49:23',3310491428,1),(52689718,425025450,15213074,443749,1,'2007-09-16 19:49:23',3310491428,1),(52689720,425028104,15215993,443749,1,'2007-09-16 19:49:23',3310491428,1),(52689723,425030227,15218249,443749,1,'2007-09-16 19:49:23',3310491430,1),(52689724,425028900,15220239,443749,1,'2007-09-16 19:49:23',3310491430,1),(52689728,425027573,15223556,443749,1,'2007-09-16 19:49:23',3310491430,1),(52689731,425028237,15226077,443749,1,'2007-09-16 19:49:24',3310491430,1),(52689733,425031023,15228598,443749,1,'2007-09-16 19:49:24',3310491430,1),(52689737,425011137,15280996,443749,1,'2007-09-16 19:49:24',3310491433,1),(52689739,425009262,15279344,443749,1,'2007-09-16 19:49:24',3310491433,1),(52689742,425007791,15280275,443749,1,'2007-09-16 19:49:24',3310491433,1),(52689743,425006510,15285956,443749,1,'2007-09-16 19:49:24',3310491433,1),(52689747,425005424,15288992,443749,1,'2007-09-16 19:49:24',3310491433,1),(52689748,424999277,15287838,443749,1,'2007-09-16 19:49:24',3310491433,1),(52689751,424997160,15289716,443749,1,'2007-09-16 19:49:24',3310491433,1),(52689755,424998796,15291422,443749,1,'2007-09-16 19:49:24',3310491433,1),(52733171,424953208,15227957,443749,1,'2007-09-16 22:05:47',3310491255,1),(52733173,424959066,15226258,443749,1,'2007-09-16 22:05:48',3310491426,1),(52733177,424963518,15225145,443749,1,'2007-09-16 22:05:48',3310491426,1),(52733181,424966329,15224267,443749,1,'2007-09-16 22:05:48',3310491426,1),(52733186,424969832,15223658,443749,1,'2007-09-16 22:05:49',3310491426,1),(52733193,424972035,15223001,443749,1,'2007-09-16 22:05:50',3310491426,1),(52733201,424973862,15222767,443749,1,'2007-09-16 22:05:52',3310491426,1),(52733204,424975409,15223423,443749,1,'2007-09-16 22:05:52',3310491426,1),(52733206,424975971,15224688,443749,1,'2007-09-16 22:05:52',3310491426,1),(52733209,424978126,15228297,443749,1,'2007-09-16 22:05:53',3310491426,1),(52733212,424981922,15232842,443749,1,'2007-09-16 22:05:54',3310491426,1),(52733215,424984125,15235420,443749,1,'2007-09-16 22:05:55',3310491426,1),(52733218,424985156,15235935,443749,1,'2007-09-16 22:05:55',3310491427,1),(52733223,424986334,15235955,443749,1,'2007-09-16 22:05:56',3310491427,1),(52743859,424949653,15048387,443749,1,'2007-09-16 22:31:34',3310491223,1),(52743862,424950863,15053996,443749,1,'2007-09-16 22:31:34',3310491229,1),(52743866,424956480,15063073,443749,1,'2007-09-16 22:31:34',3310491229,1),(52743871,424958941,15067136,443749,1,'2007-09-16 22:31:34',3310491400,1),(52743874,424964074,15074091,443749,1,'2007-09-16 22:31:34',3310491400,1),(52743875,424967198,15078852,443749,1,'2007-09-16 22:31:35',3310491400,1),(52743878,424969875,15086141,443749,1,'2007-09-16 22:31:35',3310491400,1),(52743880,424974487,15097299,443749,1,'2007-09-16 22:31:35',3310491400,1),(52743882,424977760,15106671,443749,1,'2007-09-16 22:31:35',3310491402,1),(52743884,424984008,15118126,443749,1,'2007-09-16 22:31:35',3310491402,1),(52743887,424987727,15129284,363778,1,'2007-12-19 18:35:06',3310491403,3),(52743889,424988322,15145350,443749,1,'2007-09-16 22:31:36',3310491403,1),(52743892,424986686,15172872,443749,1,'2007-09-16 22:31:36',3310491425,1),(52743895,424986686,15186112,443749,1,'2007-09-16 22:31:36',3310491425,1),(52743896,424972506,15221627,443749,1,'2007-09-16 22:31:36',3310491426,1),(52743899,424979810,15223060,443749,1,'2007-09-16 22:31:37',3310491426,1),(52743900,424950119,15229029,443749,1,'2007-09-16 22:31:37',3310491255,1),(52743901,424955437,15230801,443749,1,'2007-09-16 22:31:37',3310491255,1),(52743902,424957506,15235825,443749,1,'2007-09-16 22:31:37',3310491255,1),(52743904,424956028,15241143,443749,1,'2007-09-16 22:31:37',3310491255,1),(52743907,424952482,15244393,443749,1,'2007-09-16 22:31:38',3310491255,1),(52743909,424957506,15247053,443749,1,'2007-09-16 22:31:38',3310491255,1),(52743910,424962824,15246462,443749,1,'2007-09-16 22:31:38',3310491426,1),(52743913,424966665,15243802,443749,1,'2007-09-16 22:31:38',3310491426,1),(52743916,424969029,15239961,443749,1,'2007-09-16 22:31:39',3310491426,1),(52743919,424971688,15233165,443749,1,'2007-09-16 22:31:40',3310491426,1),(52743921,424976416,15229915,443749,1,'2007-09-16 22:31:40',3310491426,1),(52743924,424982326,15236415,443749,1,'2007-09-16 22:31:40',3310491426,1),(52743925,424988235,15240257,443749,1,'2007-09-16 22:31:41',3310491427,1),(52743927,424993258,15240848,443749,1,'2007-09-16 22:31:41',3310491427,1),(52743928,424995160,15237562,443749,1,'2007-09-16 22:31:41',3310491427,1),(52743930,424996491,15238046,443749,1,'2007-09-16 22:31:41',3310491427,1),(52743933,424999033,15241798,443749,1,'2007-09-16 22:31:42',3310491427,1),(52743936,425002058,15248213,443749,1,'2007-09-16 22:31:42',3310491427,1),(52743937,425002543,15250512,443749,1,'2007-09-16 22:31:42',3310491427,1),(52743940,425001937,15253175,443749,1,'2007-09-16 22:31:42',3310491427,1),(52743941,425001695,15260074,443749,1,'2007-09-16 22:31:42',3310491427,1),(52743943,425003390,15268061,443749,1,'2007-09-16 22:31:43',3310491427,1),(52743946,425002179,15275928,443749,1,'2007-09-16 22:31:43',3310491433,1),(52743947,424999880,15282222,443749,1,'2007-09-16 22:31:43',3310491433,1),(52743950,424997459,15286458,443749,1,'2007-09-16 22:31:44',3310491433,1),(52743951,424996128,15288878,443749,1,'2007-09-16 22:31:44',3310491433,1),(52743954,424996370,15291783,443749,1,'2007-09-16 22:31:44',3310491433,1),(52743955,424998670,15294688,443749,1,'2007-09-16 22:31:44',3310491433,1),(52743958,424997701,15297229,443749,1,'2007-09-16 22:31:44',3310491433,1),(52743959,424994434,15301828,443749,1,'2007-09-16 22:31:44',3310491433,1),(52743961,424991650,15303160,443749,1,'2007-09-16 22:31:44',3310491433,1),(52743964,424988503,15303402,443749,1,'2007-09-16 22:31:45',3310491433,1),(52743966,424985962,15302191,443749,1,'2007-09-16 22:31:45',3310491433,1),(52743967,424984630,15298924,443749,1,'2007-09-16 22:31:45',3310491432,1),(52743969,424984509,15295293,443749,1,'2007-09-16 22:31:45',3310491432,1),(52743971,424986204,15291662,443749,1,'2007-09-16 22:31:46',3310491433,1),(52743972,424989472,15288273,443749,1,'2007-09-16 22:31:46',3310491433,1),(52743973,424990440,15286700,443749,1,'2007-09-16 22:31:46',3310491433,1),(52743976,424991408,15280285,443749,1,'2007-09-16 22:31:46',3310491433,1),(52743980,424991287,15275928,443749,1,'2007-09-16 22:31:47',3310491433,1),(52743981,424987535,15269030,443749,1,'2007-09-16 22:31:47',3310491427,1),(52743984,424983299,15266488,443749,1,'2007-09-16 22:31:47',3310491426,1),(52743986,424981605,15266488,443749,1,'2007-09-16 22:31:47',3310491426,1),(52743987,424977611,15266246,443749,1,'2007-09-16 22:31:48',3310491426,1),(52743988,424973375,15268667,443749,1,'2007-09-16 22:31:48',3310491426,1),(52743991,424971317,15272539,443749,1,'2007-09-16 22:31:48',3310491432,1),(52743992,424975190,15276291,443749,1,'2007-09-16 22:31:48',3310491432,1),(52743995,424977369,15283795,443749,1,'2007-09-16 22:31:48',3310491432,1),(52743997,424980152,15287789,443749,1,'2007-09-16 22:31:49',3310491432,1),(52744001,424983662,15288152,443749,1,'2007-09-16 22:31:49',3310491432,1),(52744002,424983662,15291541,443749,1,'2007-09-16 22:31:49',3310491432,1),(52744005,424982331,15300013,443749,1,'2007-09-16 22:31:49',3310491432,1),(52744007,424982452,15302312,443749,1,'2007-09-16 22:31:50',3310491432,1),(52744009,424987051,15306911,443749,1,'2007-09-16 22:31:50',3310491433,1),(52744012,424980260,15317902,443749,1,'2007-09-16 22:31:50',3310491432,1),(52744014,424970983,15339592,443749,1,'2007-09-16 22:31:51',3310491434,1),(52744016,424964708,15351461,443749,1,'2007-09-16 22:31:51',3310491434,1),(52744019,424964086,15357933,443749,1,'2007-09-16 22:31:51',3310491434,1),(52744021,424963496,15365594,443749,1,'2007-09-16 22:31:51',3310491434,1),(52744022,424957996,15377184,443749,1,'2007-09-16 22:31:52',3310491434,1),(52744025,424950256,15384624,443749,1,'2007-09-16 22:31:52',3310491349,1),(52744028,424945172,15388926,443749,1,'2007-09-16 22:31:52',3310491349,1),(52744030,424943608,15382669,443749,1,'2007-09-16 22:31:52',3310491349,1),(52744032,424939697,15390490,443749,1,'2007-09-16 22:31:52',3310491349,1),(52744035,424934614,15397920,443749,1,'2007-09-16 22:31:53',3310491349,1),(52744036,424928879,15407211,443749,1,'2007-09-16 22:31:53',3310491348,1),(52744038,424925516,15407211,443749,1,'2007-09-16 22:31:54',3310491348,1),(52744042,424923113,15409454,443749,1,'2007-09-16 22:31:54',3310491348,1),(52744043,424921832,15412177,443749,1,'2007-09-16 22:31:54',3310491348,1),(52744046,424921031,15415380,443749,1,'2007-09-16 22:31:54',3310491348,1),(52744049,424919269,15416021,443749,1,'2007-09-16 22:31:54',3310491348,1),(52744050,424916546,15415861,443749,1,'2007-09-16 22:31:54',3310491348,1),(52744052,424915425,15417783,443749,1,'2007-09-16 22:31:55',3310491348,1),(52744053,424915425,15420986,443749,1,'2007-09-16 22:31:55',3310491348,1),(52744054,424915905,15423229,443749,1,'2007-09-16 22:31:55',3310491348,1),(52744056,424914143,15427393,443749,1,'2007-09-16 22:31:55',3310491348,1),(52744057,424910459,15427233,443749,1,'2007-09-16 22:31:55',3310491348,1),(52744059,424909658,15431718,443749,1,'2007-09-16 22:31:56',3310491348,1),(52744062,424903251,15437164,443749,1,'2007-09-16 22:31:56',3310491350,1),(52744064,424902130,15443571,443749,1,'2007-09-16 22:31:56',3310491347,1),(52744066,424897806,15448056,443749,1,'2007-09-16 22:31:56',3310491347,1),(52744067,424893000,15449337,443749,1,'2007-09-16 22:31:56',3310491347,1),(52744070,424891238,15453502,443749,1,'2007-09-16 22:31:56',3310491347,1),(52744072,424886914,15453662,443749,1,'2007-09-16 22:31:57',3310491347,1),(52744073,424885792,15453342,443749,1,'2007-09-16 22:31:57',3310491347,1),(52744074,424885792,15455905,443749,1,'2007-09-16 22:31:57',3310491347,1),(52744075,424883550,15461190,443749,1,'2007-09-16 22:31:57',3310491347,1),(52744078,424880507,15462632,443749,1,'2007-09-16 22:31:57',3310491347,1),(52744081,424879225,15460550,443749,1,'2007-09-16 22:31:58',3310491347,1),(52744082,424878264,15457987,443749,1,'2007-09-16 22:31:58',3310491347,1),(52744084,424877624,15457186,443749,1,'2007-09-16 22:31:58',3310491347,1),(52744086,424873139,15459222,443749,1,'2007-09-16 22:31:58',3310491346,1),(52744087,424861791,15470570,443749,1,'2007-09-16 22:31:58',3310491346,1),(52744089,424859023,15474445,443749,1,'2007-09-16 22:31:59',3310491346,1),(52744091,424861237,15476659,443749,1,'2007-09-16 22:31:59',3310491346,1),(52744093,424852380,15483579,443749,1,'2007-09-16 22:31:59',3310491346,1),(52744094,424845737,15481088,443749,1,'2007-09-16 22:31:59',3310491335,1),(52744096,424840478,15478043,443749,1,'2007-09-16 22:31:59',3310491335,1),(52744097,424829961,15462820,443749,1,'2007-09-16 22:31:59',3310491335,1),(52744099,424821380,15453133,443749,1,'2007-09-16 22:32:00',3310491335,1),(52744100,424814461,15456454,443749,1,'2007-09-16 22:32:00',3310491334,1),(52744101,424805327,15454240,443749,1,'2007-09-16 22:32:00',3310491334,1),(52744102,424797854,15443446,443749,1,'2007-09-16 22:32:00',3310491334,1),(52744104,424806434,15437910,443749,1,'2007-09-16 22:32:00',3310491334,1),(52744106,424811970,15433205,443749,1,'2007-09-16 22:32:00',3310491332,1),(52744108,424814461,15429606,443749,1,'2007-09-16 22:32:01',3310491332,1),(52744110,424810309,15421580,443749,1,'2007-09-16 22:32:01',3310491332,1),(52744111,424825255,15408294,443749,1,'2007-09-16 22:32:01',3310491333,1),(52744114,424823041,15400821,443749,1,'2007-09-16 22:32:01',3310491333,1),(52744116,424817505,15394732,443749,1,'2007-09-16 22:32:01',3310491332,1),(52744118,424813631,15383661,443749,1,'2007-09-16 22:32:01',3310491332,1),(52744120,424813907,15363179,443749,1,'2007-09-16 22:32:01',3310491246,1),(52744122,424817229,15360134,443749,1,'2007-09-16 22:32:01',3310491246,1),(52744124,424819443,15352661,443749,1,'2007-09-16 22:32:02',3310491246,1),(52744126,424816675,15340759,443749,1,'2007-09-16 22:32:02',3310491246,1),(52744128,424815568,15335777,443749,1,'2007-09-16 22:32:02',3310491246,1),(52744130,424810032,15321661,443749,1,'2007-09-16 22:32:02',3310491244,1),(52744133,424808372,15297305,443749,1,'2007-09-16 22:32:02',3310491244,1),(52744134,424809202,15278760,443749,1,'2007-09-16 22:32:03',3310491244,1),(52744136,424809202,15261877,443749,1,'2007-09-16 22:32:03',3310491238,1),(52744138,424808095,15252466,443749,1,'2007-09-16 22:32:03',3310491238,1),(52744141,424807541,15232261,443749,1,'2007-09-16 22:32:03',3310491238,1),(52744144,424807541,15214824,443749,1,'2007-09-16 22:32:03',3310491236,1),(52744147,424803390,15212609,443749,1,'2007-09-16 22:32:04',3310491236,1),(52744149,424796470,15231154,443749,1,'2007-09-16 22:32:04',3310491238,1),(52744152,424792872,15232814,443749,1,'2007-09-16 22:32:04',3310491238,1),(52744155,424785122,15225895,443749,1,'2007-09-16 22:32:04',3310491235,1),(52744158,424780140,15214270,443749,1,'2007-09-16 22:32:04',3310491233,1),(52744159,424782354,15202368,443749,1,'2007-09-16 22:32:05',3310491233,1),(52744161,424786229,15196556,443749,1,'2007-09-16 22:32:05',3310491233,1),(52744163,424793425,15187422,443749,1,'2007-09-16 22:32:05',3310491236,1),(52744165,424796470,15180779,443749,1,'2007-09-16 22:32:05',3310491236,1),(52744166,424795916,15180503,443749,1,'2007-09-16 22:32:05',3310491236,1),(52744172,424799791,15172753,557925,1,'2008-01-06 22:29:13',3310491236,2),(52744174,424799791,15169985,443749,1,'2007-09-16 22:32:06',3310491236,1),(52744177,424801175,15167217,557925,1,'2008-01-06 22:29:13',3310491236,3),(52744180,424802006,15165280,443749,1,'2007-09-16 22:32:06',3310491236,1),(52744181,424802006,15165003,443749,1,'2007-09-16 22:32:07',3310491236,1),(52744184,424801729,15164449,443749,1,'2007-09-16 22:32:07',3310491236,1),(52744187,424802282,15162789,443749,1,'2007-09-16 22:32:07',3310491236,1),(52744189,424793425,15165833,443749,1,'2007-09-16 22:32:07',3310491236,1),(52744190,424782077,15154485,443749,1,'2007-09-16 22:32:07',3310491211,1),(52744193,424777926,15147842,443749,1,'2007-09-16 22:32:08',3310491211,1),(52744196,424778202,15145351,443749,1,'2007-09-16 22:32:08',3310491211,1),(52744198,424779586,15140369,443749,1,'2007-09-16 22:32:08',3310491211,1),(52744201,424781524,15136771,443749,1,'2007-09-16 22:32:08',3310491211,1),(52744202,424782908,15139539,443749,1,'2007-09-16 22:32:09',3310491211,1),(52744205,424787708,15153574,443749,1,'2007-09-16 22:32:09',3310491211,1),(52744206,424789550,15157807,443749,1,'2007-09-16 22:32:09',3310491211,1),(52744209,424796193,15150057,443749,1,'2007-09-16 22:32:09',3310491214,1),(52744212,424799515,15145351,443749,1,'2007-09-16 22:32:09',3310491214,1),(52744213,424802783,15142154,443749,1,'2007-09-16 22:32:09',3310491214,1),(52744214,424803358,15136020,443749,1,'2007-09-16 22:32:09',3310491214,1),(52744218,424803166,15123369,443749,1,'2007-09-16 22:32:09',3310491214,1),(52744219,424803166,15119344,443749,1,'2007-09-16 22:32:10',3310491214,1),(52744222,424800675,15117810,443749,1,'2007-09-16 22:32:10',3310491214,1),(52744223,424798566,15118960,443749,1,'2007-09-16 22:32:10',3310491214,1),(52744227,424798566,15119536,443749,1,'2007-09-16 22:32:10',3310491214,1),(52744228,424799525,15125286,443749,1,'2007-09-16 22:32:10',3310491214,1),(52744231,424797608,15128353,443749,1,'2007-09-16 22:32:10',3310491214,1),(52744232,424794541,15129311,443749,1,'2007-09-16 22:32:11',3310491214,1),(52744236,424790707,15125286,443749,1,'2007-09-16 22:32:11',3310491211,1),(52744237,424790707,15122411,443749,1,'2007-09-16 22:32:11',3310491211,1),(52744238,424796458,15111868,443749,1,'2007-09-16 22:32:11',3310491214,1),(52744240,424798758,15107651,443749,1,'2007-09-16 22:32:11',3310491214,1),(52744241,424796074,15103434,443749,1,'2007-09-16 22:32:11',3310491212,1),(52744245,424800100,15104009,443749,1,'2007-09-16 22:32:11',3310491212,1),(52744246,424801250,15108418,443749,1,'2007-09-16 22:32:12',3310491214,1),(52744249,424803933,15113018,443749,1,'2007-09-16 22:32:12',3310491214,1),(52744250,424805658,15110718,443749,1,'2007-09-16 22:32:12',3310491214,1),(52744253,424804508,15105735,443749,1,'2007-09-16 22:32:12',3310491212,1),(52744254,424801058,15097492,443749,1,'2007-09-16 22:32:12',3310491212,1),(52744257,424799141,15092892,443749,1,'2007-09-16 22:32:12',3310491212,1),(52744259,424800483,15085416,443749,1,'2007-09-16 22:32:12',3310491212,1),(52744260,424802783,15084075,443749,1,'2007-09-16 22:32:12',3310491212,1),(52744262,424803550,15083500,443749,1,'2007-09-16 22:32:13',3310491212,1),(52744264,424799716,15078899,443749,1,'2007-09-16 22:32:13',3310491212,1),(52744265,424799141,15070082,443749,1,'2007-09-16 22:32:13',3310491212,1),(52744268,424799525,15055897,443749,1,'2007-09-16 22:32:13',3310491212,1),(52744270,424798374,15046505,443749,1,'2007-09-16 22:32:13',3310491206,1),(52744272,424795691,15038263,443749,1,'2007-09-16 22:32:13',3310491206,1),(52744274,424792816,15030212,443749,1,'2007-09-16 22:32:14',3310491203,1),(52744277,424785697,15046543,443749,1,'2007-09-16 22:32:14',3310491203,1),(52744279,424783587,15054513,443749,1,'2007-09-16 22:32:14',3310491209,1),(52744281,424779367,15055920,443749,1,'2007-09-16 22:32:14',3310491209,1),(52744284,424781243,15023099,443749,1,'2007-09-16 22:32:14',3310491203,1),(52744286,424776320,15023099,443749,1,'2007-09-16 22:32:14',3310491203,1),(52744289,424776554,15041854,443749,1,'2007-09-16 22:32:15',3310491203,1),(52744292,424776554,15050294,443749,1,'2007-09-16 22:32:15',3310491203,1),(52744294,424773506,15053107,443749,1,'2007-09-16 22:32:15',3310491209,1),(52744296,424770459,15053810,443749,1,'2007-09-16 22:32:15',3310491209,1),(52744298,424760612,15038103,443749,1,'2007-09-16 22:32:15',3310491202,1),(52744301,424758034,15035524,443749,1,'2007-09-16 22:32:16',3310491202,1),(52744303,424755220,15030601,443749,1,'2007-09-16 22:32:16',3310491202,1),(52744306,424749828,15019113,443749,1,'2007-09-16 22:32:16',3310491202,1),(52744308,424744436,15022396,443749,1,'2007-09-16 22:32:16',3310491202,1),(52744309,424743498,15020754,443749,1,'2007-09-16 22:32:16',3310491202,1),(52744312,424745374,15010908,443749,1,'2007-09-16 22:32:17',3310491202,1),(52744313,424740920,15002234,443749,1,'2007-09-16 22:32:17',3310491202,1),(52744315,424735059,15003641,443749,1,'2007-09-16 22:32:17',3310491159,1),(52744318,424732011,15007860,443749,1,'2007-09-16 22:32:17',3310491159,1),(52744320,424720992,14995435,443749,1,'2007-09-16 22:32:17',3310491157,1),(52744323,424712318,14975274,443749,1,'2007-09-16 22:32:17',3310491157,1),(52744326,424710677,14957456,443749,1,'2007-09-16 22:32:17',3310491157,1),(52744329,424708802,14947610,443749,1,'2007-09-16 22:32:18',3310491156,1),(52744330,424711381,14942921,443749,1,'2007-09-16 22:32:18',3310491157,1),(52744333,424715132,14939405,443749,1,'2007-09-16 22:32:18',3310490815,1),(52744334,424717241,14938702,443749,1,'2007-09-16 22:32:18',3310490815,1),(52744337,424723102,14938467,443749,1,'2007-09-16 22:32:18',3310490815,1),(52744339,424735996,14928621,443749,1,'2007-09-16 22:32:19',3310490815,1),(52744342,424732763,14935220,443749,1,'2007-09-16 22:32:19',3310490815,1),(52744344,424738155,14923734,443749,1,'2007-09-16 22:32:19',3310490858,1),(52744346,424739684,14919274,443749,1,'2007-09-16 22:32:19',3310490858,1),(52744349,424742743,14915068,443749,1,'2007-09-16 22:32:20',3310490858,1),(52744350,424747713,14912647,443749,1,'2007-09-16 22:32:20',3310490858,1),(52744352,424751154,14911245,443749,1,'2007-09-16 22:32:20',3310490858,1),(52744356,424754467,14910353,443749,1,'2007-09-16 22:32:21',3310490858,1),(52744359,424759182,14909588,443749,1,'2007-09-16 22:32:21',3310490858,1),(52744360,424769887,14909206,443749,1,'2007-09-16 22:32:21',3310490859,1),(52744364,424772690,14908187,443749,1,'2007-09-16 22:32:21',3310490859,1),(52744365,424777278,14905383,443749,1,'2007-09-16 22:32:21',3310490859,1),(52744368,424781101,14903217,443749,1,'2007-09-16 22:32:22',3310490859,1),(52744370,424788875,14898119,443749,1,'2007-09-16 22:32:22',3310490859,1),(52744372,424792443,14896208,443749,1,'2007-09-16 22:32:22',3310490859,1),(52744375,424796776,14894806,443749,1,'2007-09-16 22:32:22',3310490862,1),(52744378,424802510,14895443,443749,1,'2007-09-16 22:32:22',3310490862,1),(52744379,424806588,14896463,443749,1,'2007-09-16 22:32:22',3310490862,1),(52744383,424813725,14898374,443749,1,'2007-09-16 22:32:23',3310490862,1),(52744385,424818312,14898502,443749,1,'2007-09-16 22:32:23',3310490862,1),(52744387,424822008,14900031,443749,1,'2007-09-16 22:32:23',3310490863,1),(52744390,424831566,14906148,443749,1,'2007-09-16 22:32:23',3310490863,1),(52744392,424836663,14909843,443749,1,'2007-09-16 22:32:23',3310490863,1),(52744394,424837937,14913029,443749,1,'2007-09-16 22:32:23',3310490863,1),(52744396,424838829,14918636,443749,1,'2007-09-16 22:32:24',3310490863,1),(52744399,424840996,14925008,443749,1,'2007-09-16 22:32:24',3310490863,1),(52744400,424844691,14932782,443749,1,'2007-09-16 22:32:24',3310490863,1),(52744402,424849492,14936883,443749,1,'2007-09-16 22:32:24',3310490874,1),(52744405,424851423,14939221,443749,1,'2007-09-16 22:32:25',3310490874,1),(52744409,424853660,14941966,443749,1,'2007-09-16 22:32:25',3310491216,1),(52744411,424859557,14948371,443749,1,'2007-09-16 22:32:25',3310491216,1),(52744413,424863522,14952641,443749,1,'2007-09-16 22:32:25',3310491216,1),(52744416,424867487,14955081,443749,1,'2007-09-16 22:32:25',3310491216,1),(52744418,424870842,14955793,443749,1,'2007-09-16 22:32:26',3310491216,1),(52744420,424874197,14955081,443749,1,'2007-09-16 22:32:26',3310491216,1),(52744423,424877044,14952946,443749,1,'2007-09-16 22:32:26',3310491217,1),(52744426,424878467,14951828,443749,1,'2007-09-16 22:32:26',3310491217,1),(52744429,424881314,14951828,443749,1,'2007-09-16 22:32:26',3310491217,1),(52744432,424884059,14953353,443749,1,'2007-09-16 22:32:27',3310491217,1),(52744434,424885279,14955996,443749,1,'2007-09-16 22:32:27',3310491217,1),(52744437,424885889,14957826,443749,1,'2007-09-16 22:32:27',3310491217,1),(52744439,424887515,14957826,443749,1,'2007-09-16 22:32:27',3310491217,1),(52744440,424891074,14961080,443749,1,'2007-09-16 22:32:27',3310491217,1),(52744443,424894734,14964333,443749,1,'2007-09-16 22:32:27',3310491217,1),(52744446,424898191,14966773,443749,1,'2007-09-16 22:32:28',3310491217,1),(52744447,424901037,14967790,443749,1,'2007-09-16 22:32:28',3310491217,1),(52744450,424906121,14966468,443749,1,'2007-09-16 22:32:28',3310491220,1),(52744452,424907948,14966527,592895,1,'2008-07-25 22:14:24',3310491220,2),(52744455,424911745,14967729,592895,1,'2008-07-25 22:14:24',3310491220,2),(52744457,424914656,14971162,592895,1,'2008-07-25 22:14:24',3310491220,2),(52744460,424922188,14985581,592895,1,'2008-07-25 22:14:24',3310491220,2),(52744462,424926871,14994164,592895,1,'2008-07-25 22:14:24',3310491220,2),(52744464,424934845,15005065,592895,1,'2008-07-25 22:14:24',3310491223,2),(52744468,424938045,15011100,443749,1,'2007-09-16 22:32:29',3310491223,1),(52744471,424943128,15024317,443749,1,'2007-09-16 22:32:29',3310491223,1),(52744473,424947601,15033976,443749,1,'2007-09-16 22:32:30',3310491223,1),(52744475,424949126,15041194,443749,1,'2007-09-16 22:32:30',3310491223,1),(52747815,424649743,14961857,443749,1,'2007-09-16 22:42:22',3310491152,1),(52747820,424656034,14972207,443749,1,'2007-09-16 22:42:22',3310491153,1),(52747826,424662016,14981371,443749,1,'2007-09-16 22:42:23',3310491153,1),(52747832,424670491,14997151,443749,1,'2007-09-16 22:42:23',3310491155,1),(52747838,424677212,15009132,443749,1,'2007-09-16 22:42:24',3310491155,1),(52747841,424686271,15028127,443749,1,'2007-09-16 22:42:24',3310491158,1),(52747846,424690654,15040108,443749,1,'2007-09-16 22:42:25',3310491158,1),(52747849,424693284,15043906,443749,1,'2007-09-16 22:42:25',3310491158,1),(52747852,424697083,15045075,443749,1,'2007-09-16 22:42:26',3310491158,1),(52747855,424697667,15049459,443749,1,'2007-09-16 22:42:26',3310491158,1),(52747857,424697959,15052965,443749,1,'2007-09-16 22:42:27',3310491164,1),(52747861,424700005,15064362,443749,1,'2007-09-16 22:42:27',3310491164,1),(52747863,424706142,15076927,443749,1,'2007-09-16 22:42:27',3310491164,1),(52747865,424706434,15085694,443749,1,'2007-09-16 22:42:28',3310491164,1),(52747867,424713447,15102351,443749,1,'2007-09-16 22:42:28',3310491165,1),(52747869,424718999,15119007,443749,1,'2007-09-16 22:42:28',3310491167,1),(52747872,424730396,15131280,443749,1,'2007-09-16 22:42:28',3310491167,1),(52747876,424737701,15145891,443749,1,'2007-09-16 22:42:29',3310491167,1),(52747878,424738286,15154366,443749,1,'2007-09-16 22:42:29',3310491210,1),(52747881,424738286,15163132,443749,1,'2007-09-16 22:42:29',3310491232,1),(52747884,424734487,15166639,443749,1,'2007-09-16 22:42:30',3310491189,1),(52747885,424726889,15160502,443749,1,'2007-09-16 22:42:30',3310491167,1),(52747888,424726597,15149398,443749,1,'2007-09-16 22:42:31',3310491167,1),(52747890,424721629,15147937,443749,1,'2007-09-16 22:42:31',3310491167,1),(52747893,424720753,15152320,443749,1,'2007-09-16 22:42:31',3310491167,1),(52747898,424720460,15158749,443749,1,'2007-09-16 22:42:32',3310491167,1),(52747901,424717830,15163717,443749,1,'2007-09-16 22:42:32',3310491189,1),(52748785,424716077,15172483,443749,1,'2007-09-16 22:45:33',3310491189,1),(52748790,424717830,15181250,443749,1,'2007-09-16 22:45:33',3310491189,1),(52748831,424714616,15182419,443749,1,'2007-09-16 22:45:42',3310491189,1),(52748833,424713447,15189724,443749,1,'2007-09-16 22:45:42',3310491189,1),(52748835,424713447,15197322,443749,1,'2007-09-16 22:45:43',3310491189,1),(52748837,424717246,15204043,443749,1,'2007-09-16 22:45:43',3310491189,1),(52749087,424723675,15203459,443749,1,'2007-09-16 22:46:34',3310491189,1),(52749143,424729811,15199075,443749,1,'2007-09-16 22:46:46',3310491189,1),(52749145,424740039,15200537,443749,1,'2007-09-16 22:46:46',3310491232,1),(52749150,424741208,15206965,443749,1,'2007-09-16 22:46:46',3310491232,1),(52749155,424745299,15213686,443749,1,'2007-09-16 22:46:47',3310491232,1),(52749158,424745591,15219531,443749,1,'2007-09-16 22:46:47',3310491234,1),(52749159,424748221,15230343,443749,1,'2007-09-16 22:46:48',3310491234,1),(52749162,424753189,15237356,443749,1,'2007-09-16 22:46:48',3310491234,1),(52749165,424749390,15254305,443749,1,'2007-09-16 22:46:48',3310491234,1),(52749169,424744423,15262487,443749,1,'2007-09-16 22:46:50',3310491234,1),(52749171,424735656,15261903,443749,1,'2007-09-16 22:46:50',3310491191,1),(52749174,424726597,15277391,443749,1,'2007-09-16 22:46:50',3310491197,1),(52749175,424728058,15289079,443749,1,'2007-09-16 22:46:50',3310491197,1),(52749183,424723967,15289664,443749,1,'2007-09-16 22:46:52',3310491197,1),(52749184,424717830,15288203,443749,1,'2007-09-16 22:46:52',3310491197,1),(52749185,424717830,15269793,443749,1,'2007-09-16 22:46:52',3310491191,1),(52749189,424720753,15247876,443749,1,'2007-09-16 22:46:53',3310491191,1),(52749191,424718999,15227129,443749,1,'2007-09-16 22:46:53',3310491191,1),(52749208,424712570,15216316,443749,1,'2007-09-16 22:46:55',3310491191,1),(52749211,424699713,15183003,443749,1,'2007-09-16 22:46:55',3310491188,1),(52749214,424691823,15166639,443749,1,'2007-09-16 22:46:56',3310491188,1),(52749218,424687440,15160210,443749,1,'2007-09-16 22:46:56',3310491166,1),(52749220,424676627,15159333,443749,1,'2007-09-16 22:46:57',3310491163,1),(52749224,424656873,15150392,443749,1,'2007-09-16 22:46:57',3310491163,1),(52749225,424657399,15136949,443749,1,'2007-09-16 22:46:57',3310491163,1),(52749228,424664471,15139988,443749,1,'2007-09-16 22:46:57',3310491163,1),(52749231,424672303,15138118,443749,1,'2007-09-16 22:46:57',3310491163,1),(52749233,424682472,15126313,443749,1,'2007-09-16 22:46:57',3310491163,1),(52749238,424683933,15123098,443749,1,'2007-09-16 22:46:58',3310491166,1),(52749240,424672244,15109364,443749,1,'2007-09-16 22:46:58',3310491163,1),(52749243,424666107,15105565,443749,1,'2007-09-16 22:46:59',3310491161,1),(52749244,424661432,15092415,443749,1,'2007-09-16 22:46:59',3310491161,1),(52749247,424655880,15079557,443749,1,'2007-09-16 22:46:59',3310491161,1),(52749251,424657049,15064362,443749,1,'2007-09-16 22:46:59',3310491161,1),(52749255,424657049,15042445,443749,1,'2007-09-16 22:47:00',3310491155,1),(52749256,424652958,15014100,443749,1,'2007-09-16 22:47:00',3310491154,1),(52749259,424642438,14981663,443749,1,'2007-09-16 22:47:01',3310491152,1),(52749261,424640684,14973481,443749,1,'2007-09-16 22:47:01',3310491152,1),(52749263,424643606,14961208,443749,1,'2007-09-16 22:47:02',3310491152,1),(52749266,424599752,15000826,443749,1,'2007-09-16 22:47:02',3310491142,1),(52749268,424599606,15009609,443749,1,'2007-09-16 22:47:02',3310491142,1),(52749271,424599894,15020476,443749,1,'2007-09-16 22:47:02',3310491142,1),(52749275,424598072,15031708,443749,1,'2007-09-16 22:47:03',3310491142,1),(52749276,424598072,15038993,443749,1,'2007-09-16 22:47:03',3310491142,1),(52749280,424600804,15044457,443749,1,'2007-09-16 22:47:03',3310491143,1),(52749282,424606268,15050529,443749,1,'2007-09-16 22:47:04',3310491143,1),(52749284,424607179,15053868,443749,1,'2007-09-16 22:47:04',3310491149,1),(52749285,424608090,15057814,443749,1,'2007-09-16 22:47:05',3310491149,1),(52749288,424607786,15061153,443749,1,'2007-09-16 22:47:06',3310491149,1),(52749289,424609607,15065099,443749,1,'2007-09-16 22:47:06',3310491149,1),(52749309,424610215,15069046,443749,1,'2007-09-16 22:47:11',3310491149,1),(52749310,424608090,15069046,443749,1,'2007-09-16 22:47:12',3310491149,1),(52749312,424604143,15064796,443749,1,'2007-09-16 22:47:12',3310491149,1),(52749314,424604085,15067169,443749,1,'2007-09-16 22:47:12',3310491149,1),(52749316,424609103,15075077,443749,1,'2007-09-16 22:47:12',3310491149,1),(52749321,424610015,15078727,443749,1,'2007-09-16 22:47:13',3310491149,1),(52749324,424600131,15075381,443749,1,'2007-09-16 22:47:13',3310491148,1),(52749326,424599522,15077358,443749,1,'2007-09-16 22:47:13',3310491148,1),(52749328,424600587,15083137,443749,1,'2007-09-16 22:47:13',3310491148,1),(52749331,424602412,15086482,443749,1,'2007-09-16 22:47:14',3310491149,1),(52749334,424601499,15092413,443749,1,'2007-09-16 22:47:14',3310491149,1),(52749340,424600739,15099561,443749,1,'2007-09-16 22:47:14',3310491149,1),(52749341,424602868,15104427,443749,1,'2007-09-16 22:47:14',3310491149,1),(52749343,424604733,15116087,443749,1,'2007-09-16 22:47:14',3310491151,1),(52749347,424609200,15125284,443749,1,'2007-09-16 22:47:14',3310491151,1),(52749349,424610251,15132116,443749,1,'2007-09-16 22:47:15',3310491151,1),(52749352,424607361,15132379,443749,1,'2007-09-16 22:47:15',3310491151,1),(52749354,424604470,15128963,443749,1,'2007-09-16 22:47:15',3310491151,1),(52749357,424604733,15131065,443749,1,'2007-09-16 22:47:16',3310491151,1),(52749359,424604996,15138949,443749,1,'2007-09-16 22:47:16',3310491151,1),(52749363,424602631,15149197,443749,1,'2007-09-16 22:47:16',3310491151,1),(52749366,424602631,15158657,443749,1,'2007-09-16 22:47:16',3310491151,1),(52749368,424604208,15168643,443749,1,'2007-09-16 22:47:16',3310491173,1),(52749371,424612617,15188089,443749,1,'2007-09-16 22:47:16',3310491173,1),(52749376,424615604,15193412,443749,1,'2007-09-16 22:47:17',3310491173,1);
INSERT INTO `nodes` VALUES (52749379,424620599,15195682,443749,1,'2007-09-16 22:47:17',3310491173,1),(52749381,424625140,15191141,443749,1,'2007-09-16 22:47:17',3310491173,1),(52749385,424632405,15189779,443749,1,'2007-09-16 22:47:18',3310491184,1),(52749386,424642395,15188871,443749,1,'2007-09-16 22:47:18',3310491184,1),(52749387,424658742,15182968,443749,1,'2007-09-16 22:47:18',3310491185,1),(52749389,424668278,15172524,443749,1,'2007-09-16 22:47:18',3310491185,1),(52749391,424672819,15165258,443749,1,'2007-09-16 22:47:18',3310491185,1),(52749393,424677359,15165712,443749,1,'2007-09-16 22:47:18',3310491185,1),(52749396,424678268,15171615,443749,1,'2007-09-16 22:47:19',3310491185,1),(52749398,424684625,15185692,443749,1,'2007-09-16 22:47:19',3310491188,1),(52749400,424691436,15196590,443749,1,'2007-09-16 22:47:19',3310491188,1),(52749402,424687803,15217478,443749,1,'2007-09-16 22:47:19',3310491190,1),(52749404,424680992,15252443,443749,1,'2007-09-16 22:47:19',3310491187,1),(52749407,424671910,15291040,443749,1,'2007-09-16 22:47:20',3310491193,1),(52749410,424664645,15315106,443749,1,'2007-09-16 22:47:20',3310491193,1),(52749412,424665553,15335994,443749,1,'2007-09-16 22:47:20',3310491195,1),(52749414,424671456,15352341,443749,1,'2007-09-16 22:47:20',3310491195,1),(52749416,424665099,15360515,443749,1,'2007-09-16 22:47:21',3310491195,1),(52749419,424655563,15349617,443749,1,'2007-09-16 22:47:21',3310491195,1),(52749421,424652385,15344168,443749,1,'2007-09-16 22:47:21',3310491194,1),(52749424,424645119,15347347,443749,1,'2007-09-16 22:47:21',3310491194,1),(52749428,424634221,15365964,443749,1,'2007-09-16 22:47:22',3310491194,1),(52749430,424628318,15383673,443749,1,'2007-09-16 22:47:22',3310491280,1),(52749433,424624686,15397296,443749,1,'2007-09-16 22:47:22',3310491269,1),(52749436,424606976,15392301,443749,1,'2007-09-16 22:47:23',3310491269,1),(52749439,424601073,15394117,443749,1,'2007-09-16 22:47:23',3310491269,1),(52749441,424603798,15405470,443749,1,'2007-09-16 22:47:23',3310491269,1),(52749443,424587905,15429082,443749,1,'2007-09-16 22:47:23',3310491268,1),(52749448,424583364,15423633,443749,1,'2007-09-16 22:47:23',3310491268,1),(52749451,424571103,15410010,443749,1,'2007-09-16 22:47:23',3310491265,1),(52749455,424565200,15372775,443749,1,'2007-09-16 22:47:24',3310491179,1),(52749458,424566563,15343260,443749,1,'2007-09-16 22:47:24',3310491179,1),(52749460,424572466,15340081,443749,1,'2007-09-16 22:47:24',3310491179,1),(52749462,424578369,15332816,443749,1,'2007-09-16 22:47:24',3310491182,1),(52749465,424577915,15313290,443749,1,'2007-09-16 22:47:24',3310491180,1),(52749469,424580639,15296943,443749,1,'2007-09-16 22:47:24',3310491180,1),(52749472,424584726,15291040,443749,1,'2007-09-16 22:47:25',3310491180,1),(52749474,424586996,15284229,443749,1,'2007-09-16 22:47:25',3310491180,1),(52749475,424582910,15253805,443749,1,'2007-09-16 22:47:25',3310491174,1),(52749479,424582910,15237458,443749,1,'2007-09-16 22:47:25',3310491174,1),(52749482,424587905,15226560,443749,1,'2007-09-16 22:47:25',3310491174,1),(52749485,424587451,15216116,443749,1,'2007-09-16 22:47:26',3310491172,1),(52749487,424581093,15212483,443749,1,'2007-09-16 22:47:26',3310491172,1),(52749490,424580185,15178427,443749,1,'2007-09-16 22:47:26',3310491172,1),(52749491,424580185,15143462,443749,1,'2007-09-16 22:47:26',3310491150,1),(52749492,424579277,15124391,443749,1,'2007-09-16 22:47:26',3310491150,1),(52749496,424571103,15110768,443749,1,'2007-09-16 22:47:27',3310491147,1),(52749497,424567017,15095783,443749,1,'2007-09-16 22:47:27',3310491145,1),(52749499,424566563,15078528,443749,1,'2007-09-16 22:47:27',3310491145,1),(52749502,424567925,15054915,443749,1,'2007-09-16 22:47:27',3310491145,1),(52749503,424567925,15037206,443749,1,'2007-09-16 22:47:27',3310491139,1),(52749505,424570649,15030849,443749,1,'2007-09-16 22:47:27',3310491139,1),(52749508,424576552,15024946,443749,1,'2007-09-16 22:47:28',3310491142,1),(52749509,424584272,15014502,443749,1,'2007-09-16 22:47:28',3310491142,1),(52749511,424591991,14999517,443749,1,'2007-09-16 22:47:28',3310491142,1),(52749514,424596532,14994976,443749,1,'2007-09-16 22:47:29',3310491140,1),(52749517,424599711,14995884,443749,1,'2007-09-16 22:47:29',3310491140,1),(52769332,424562951,15382372,443749,1,'2007-09-16 23:39:37',3310491265,1),(52769338,424565812,15388753,443749,1,'2007-09-16 23:39:38',3310491265,1),(52769340,424566392,15397747,443749,1,'2007-09-16 23:39:38',3310491265,1),(52769343,424564651,15402970,443749,1,'2007-09-16 23:39:38',3310491265,1),(52769346,424566682,15408772,443749,1,'2007-09-16 23:39:38',3310491265,1),(52769349,424571179,15418927,443749,1,'2007-09-16 23:39:39',3310491265,1),(52769352,424571324,15428066,443749,1,'2007-09-16 23:39:40',3310491265,1),(52769355,424568423,15437641,443749,1,'2007-09-16 23:39:40',3310491267,1),(52769357,424564216,15444314,443749,1,'2007-09-16 23:39:40',3310491267,1),(52769358,424558848,15457660,443749,1,'2007-09-16 23:39:40',3310491267,1),(52769361,424557253,15463318,443749,1,'2007-09-16 23:39:41',3310491267,1),(52769364,424551740,15465349,443749,1,'2007-09-16 23:39:42',3310491267,1),(52769366,424548404,15465204,443749,1,'2007-09-16 23:39:42',3310491267,1),(52769367,424545937,15461722,443749,1,'2007-09-16 23:39:42',3310491267,1),(52769369,424538974,15462447,443749,1,'2007-09-16 23:39:42',3310491266,1),(52769371,424530560,15465784,443749,1,'2007-09-16 23:39:42',3310491266,1),(52769373,424526063,15473908,443749,1,'2007-09-16 23:39:42',3310491266,1),(52769374,424523887,15465494,443749,1,'2007-09-16 23:39:43',3310491266,1),(52769377,424515473,15475793,443749,1,'2007-09-16 23:39:43',3310490583,1),(52769380,424513007,15478695,443749,1,'2007-09-16 23:39:43',3310490583,1),(52769381,424508220,15472457,443749,1,'2007-09-16 23:39:43',3310490583,1),(52769384,424508220,15469120,443749,1,'2007-09-16 23:39:44',3310490583,1),(52769387,424509235,15464188,443749,1,'2007-09-16 23:39:44',3310490583,1),(52769389,424505609,15460706,443749,1,'2007-09-16 23:39:44',3310490583,1),(52769392,424500096,15459836,443749,1,'2007-09-16 23:39:44',3310490583,1),(52769395,424495309,15457225,443749,1,'2007-09-16 23:39:45',3310490583,1),(52769397,424493423,15453163,443749,1,'2007-09-16 23:39:45',3310490583,1),(52769401,424492118,15446635,443749,1,'2007-09-16 23:39:47',3310490583,1),(52769406,424490545,15437518,443749,1,'2007-09-16 23:39:48',3310490582,1),(52769411,424492984,15430844,443749,1,'2007-09-16 23:39:48',3310490581,1),(52769413,424490417,15425068,443749,1,'2007-09-16 23:39:48',3310490580,1),(52769415,424485797,15421475,443749,1,'2007-09-16 23:39:49',3310490580,1),(52769418,424485540,15410693,443749,1,'2007-09-16 23:39:49',3310490580,1),(52769419,424482203,15400682,443749,1,'2007-09-16 23:39:49',3310490580,1),(52769420,424482331,15391056,443749,1,'2007-09-16 23:39:49',3310490580,1),(52769423,424481561,15370393,443749,1,'2007-09-16 23:39:49',3310490494,1),(52769425,424485540,15360638,443749,1,'2007-09-16 23:39:49',3310490494,1),(52769427,424488235,15351141,443749,1,'2007-09-16 23:39:50',3310490494,1),(52769431,424492086,15344467,443749,1,'2007-09-16 23:39:50',3310490495,1),(52769436,424498631,15342927,443749,1,'2007-09-16 23:39:51',3310490495,1),(52769439,424507231,15347290,443749,1,'2007-09-16 23:39:51',3310490495,1),(52769441,424516600,15349216,443749,1,'2007-09-16 23:39:51',3310490495,1),(52769444,424520835,15346905,443749,1,'2007-09-16 23:39:51',3310491178,1),(52769447,424520835,15340360,443749,1,'2007-09-16 23:39:52',3310491178,1),(52769450,424510054,15331375,443749,1,'2007-09-16 23:39:52',3310490495,1),(52769452,424504022,15328423,443749,1,'2007-09-16 23:39:52',3310490495,1),(52769456,424498375,15318156,443749,1,'2007-09-16 23:39:52',3310490493,1),(52769457,424498375,15312124,443749,1,'2007-09-16 23:39:53',3310490493,1),(52769460,424501070,15309685,443749,1,'2007-09-16 23:39:53',3310490493,1),(52769465,424504022,15312509,443749,1,'2007-09-16 23:39:53',3310490493,1),(52769471,424507616,15319824,443749,1,'2007-09-16 23:39:54',3310490493,1),(52769477,424511723,15325472,443749,1,'2007-09-16 23:39:54',3310490493,1),(52769479,424519295,15328552,443749,1,'2007-09-16 23:39:55',3310491178,1),(52769482,424526739,15332787,443749,1,'2007-09-16 23:39:55',3310491178,1),(52769485,424536878,15335611,443749,1,'2007-09-16 23:39:55',3310491178,1),(52769488,424547916,15347290,443749,1,'2007-09-16 23:39:55',3310491179,1),(52769491,424553820,15362435,443749,1,'2007-09-16 23:39:56',3310491179,1),(52769493,424559981,15374500,443749,1,'2007-09-16 23:39:56',3310491179,1),(52792095,425799592,16443960,495907,1,'2008-07-15 19:51:52',3310504158,2),(52792098,425799592,16448080,495907,1,'2008-07-15 19:51:52',3310504158,2),(52792102,425799844,16450312,495907,1,'2008-07-15 19:51:52',3310504158,2),(52792111,425800160,16452458,495907,1,'2008-07-15 19:51:52',3310504158,2),(52792113,425800540,16454174,495907,1,'2008-07-15 19:51:52',3310504158,2),(52792114,425800540,16455376,495907,1,'2008-07-15 19:51:52',3310504158,2),(52792117,425800287,16456062,495907,1,'2008-07-15 19:51:52',3310504158,2),(52792122,425799718,16456406,495907,1,'2008-07-15 19:51:52',3310504158,2),(52792158,425799336,16440207,443749,1,'2007-09-17 00:34:55',3310504158,1),(52792159,425799827,16436896,443749,1,'2007-09-17 00:34:56',3310504158,1),(52792177,425800808,16433585,443749,1,'2007-09-17 00:34:58',3310504158,1),(52792180,425801625,16430683,443749,1,'2007-09-17 00:34:58',3310504158,1),(52792182,425801952,16428066,443749,1,'2007-09-17 00:34:58',3310504158,1),(52792185,425802279,16425041,443749,1,'2007-09-17 00:34:58',3310504158,1),(52792187,425802893,16421403,443749,1,'2007-09-17 00:34:59',3310504156,1),(52792189,425803710,16415885,443749,1,'2007-09-17 00:34:59',3310504156,1),(52792192,425804610,16411266,443749,1,'2007-09-17 00:34:59',3310504156,1),(52792194,425806163,16405502,443749,1,'2007-09-17 00:34:59',3310504156,1),(52792196,425807635,16399574,443749,1,'2007-09-17 00:34:59',3310504156,1),(52792199,425809392,16391808,443749,1,'2007-09-17 00:35:00',3310504157,1),(52792202,425810905,16386289,443749,1,'2007-09-17 00:35:00',3310504157,1),(52792205,425811641,16383019,443749,1,'2007-09-17 00:35:00',3310504157,1),(52792210,425812744,16381220,443749,1,'2007-09-17 00:35:00',3310504157,1),(52796991,425813848,16380689,443749,1,'2007-09-17 00:44:25',3310504157,1),(52797049,425815115,16381016,443749,1,'2007-09-17 00:44:33',3310504157,1),(52797051,425816709,16380934,443749,1,'2007-09-17 00:44:33',3310504157,1),(52797069,425818140,16380198,443749,1,'2007-09-17 00:44:34',3310504157,1),(52797105,425820511,16378727,443749,1,'2007-09-17 00:44:40',3310504157,1),(52797267,425824926,16377623,443749,1,'2007-09-17 00:45:00',3310504157,1),(52797268,425827542,16376642,443749,1,'2007-09-17 00:45:00',3310504157,1),(52797269,425829341,16376356,443749,1,'2007-09-17 00:45:01',3310504157,1),(52797270,425831180,16376110,443749,1,'2007-09-17 00:45:02',3310504157,1),(52797275,425833265,16376151,443749,1,'2007-09-17 00:45:02',3310504157,1),(52797278,425835064,16376070,443749,1,'2007-09-17 00:45:03',3310504157,1),(52797286,425837026,16375170,443749,1,'2007-09-17 00:45:03',3310504328,1),(52797303,425839274,16374394,443749,1,'2007-09-17 00:45:06',3310504328,1),(52797555,425841195,16373903,443749,1,'2007-09-17 00:45:33',3310504328,1),(52798676,425843403,16373699,443749,1,'2007-09-17 00:47:42',3310504328,1),(52799709,425845855,16374271,443749,1,'2007-09-17 00:49:43',3310504328,1),(52799985,425849167,16375375,443749,1,'2007-09-17 00:50:16',3310504328,1),(52800033,425853418,16376805,443749,1,'2007-09-17 00:50:19',3310504328,1),(52800211,425858201,16378727,538211,1,'2007-09-30 15:36:21',3310504328,1),(52800388,425862370,16381057,443749,1,'2007-09-17 00:51:03',3310504328,1),(52800400,425864905,16382814,443749,1,'2007-09-17 00:51:04',3310504329,1),(52800405,425867316,16385063,443749,1,'2007-09-17 00:51:04',3310504329,1),(52800416,425869483,16386943,443749,1,'2007-09-17 00:51:05',3310504329,1),(52800529,425871609,16388006,443749,1,'2007-09-17 00:51:18',3310504329,1),(52800536,425874675,16389396,443749,1,'2007-09-17 00:51:18',3310504329,1),(52800580,425876187,16390295,443749,1,'2007-09-17 00:51:21',3310504329,1),(52800584,425877413,16390540,443749,1,'2007-09-17 00:51:21',3310504329,1),(52800586,425878149,16390173,443749,1,'2007-09-17 00:51:21',3310504329,1),(52800590,425878721,16389151,443749,1,'2007-09-17 00:51:21',3310504329,1),(52800592,425878558,16388251,443749,1,'2007-09-17 00:51:21',3310504329,1),(52800596,425877372,16387148,443749,1,'2007-09-17 00:51:21',3310504329,1),(52800599,425875696,16386044,443749,1,'2007-09-17 00:51:22',3310504329,1),(52800602,425874470,16384245,443749,1,'2007-09-17 00:51:22',3310504329,1),(52800606,425873121,16381629,443749,1,'2007-09-17 00:51:22',3310504329,1),(52800608,425872508,16380198,443749,1,'2007-09-17 00:51:23',3310504329,1),(52800610,425871200,16378890,443749,1,'2007-09-17 00:51:23',3310504329,1),(52800614,425870096,16377500,443749,1,'2007-09-17 00:51:23',3310504329,1),(52800618,425870055,16376397,443749,1,'2007-09-17 00:51:23',3310504329,1),(52800619,425870546,16376070,443749,1,'2007-09-17 00:51:23',3310504329,1),(52800622,425871241,16376070,443749,1,'2007-09-17 00:51:24',3310504329,1),(52800623,425872181,16376928,443749,1,'2007-09-17 00:51:24',3310504329,1),(52800625,425874020,16379422,443749,1,'2007-09-17 00:51:24',3310504329,1),(52800626,425875615,16381915,443749,1,'2007-09-17 00:51:24',3310504329,1),(52800628,425877045,16383877,443749,1,'2007-09-17 00:51:24',3310504329,1),(52800630,425878190,16384695,443749,1,'2007-09-17 00:51:24',3310504329,1),(52800634,425879212,16384981,443749,1,'2007-09-17 00:51:25',3310504329,1),(52800638,425880765,16384899,443749,1,'2007-09-17 00:51:25',3310504329,1),(52800642,425882932,16384490,443749,1,'2007-09-17 00:51:25',3310504329,1),(52800645,425885017,16384082,443749,1,'2007-09-17 00:51:25',3310504329,1),(52800647,425886611,16383959,443749,1,'2007-09-17 00:51:25',3310504329,1),(52800651,425888287,16383796,443749,1,'2007-09-17 00:51:26',3310504329,1),(52800652,425890331,16382855,443749,1,'2007-09-17 00:51:26',3310504329,1),(52800656,425892743,16381506,443749,1,'2007-09-17 00:51:26',3310504332,1),(52800661,425894459,16380484,443749,1,'2007-09-17 00:51:26',3310504332,1),(52800664,425895645,16379503,443749,1,'2007-09-17 00:51:27',3310504332,1),(52800665,425896749,16378727,443749,1,'2007-09-17 00:51:27',3310504332,1),(52800667,425898425,16377746,443749,1,'2007-09-17 00:51:27',3310504332,1),(52800668,425902022,16376560,443749,1,'2007-09-17 00:51:27',3310504332,1),(52800670,425904883,16375620,443749,1,'2007-09-17 00:51:27',3310504332,1),(52800673,425906151,16375007,443749,1,'2007-09-17 00:51:27',3310504332,1),(52800677,425908113,16373658,443749,1,'2007-09-17 00:51:28',3310504332,1),(52800681,425909462,16372840,443749,1,'2007-09-17 00:51:28',3310504332,1),(52800683,425910688,16372472,443749,1,'2007-09-17 00:51:28',3310504332,1),(52800686,425912078,16372799,443749,1,'2007-09-17 00:51:28',3310504332,1),(52800691,425913059,16373249,443749,1,'2007-09-17 00:51:29',3310504332,1),(52800794,425914449,16374802,443749,1,'2007-09-17 00:51:39',3310504332,1),(52800813,425915266,16375334,443749,1,'2007-09-17 00:51:41',3310504332,1),(52800821,425916207,16375661,443749,1,'2007-09-17 00:51:42',3310504332,1),(52800828,425917147,16375620,443749,1,'2007-09-17 00:51:42',3310504332,1),(52800845,425918210,16374966,443749,1,'2007-09-17 00:51:44',3310504332,1),(52800909,425919068,16373944,443749,1,'2007-09-17 00:51:52',3310504333,1),(52800938,425920213,16372963,443749,1,'2007-09-17 00:51:54',3310504333,1),(52800944,425921112,16372554,443749,1,'2007-09-17 00:51:55',3310504333,1),(52800948,425923401,16372799,443749,1,'2007-09-17 00:51:56',3310504333,1),(52800952,425924382,16373576,443749,1,'2007-09-17 00:51:56',3310504333,1),(52800957,425922198,16372507,443749,1,'2007-09-17 00:51:57',3310504333,1),(52800960,425927816,16376315,443749,1,'2007-09-17 00:51:57',3310504333,1),(52800964,425929042,16377010,443749,1,'2007-09-17 00:51:58',3310504333,1),(52800967,425930023,16377173,443749,1,'2007-09-17 00:51:58',3310504333,1),(52800970,425931372,16377214,443749,1,'2007-09-17 00:51:58',3310504333,1),(52800974,425932680,16377010,443749,1,'2007-09-17 00:51:58',3310504333,1),(52800978,425933784,16376356,443749,1,'2007-09-17 00:51:59',3310504333,1),(52800981,425934970,16375170,443749,1,'2007-09-17 00:51:59',3310504333,1),(52800985,425936408,16373938,443749,1,'2007-09-17 00:51:59',3310504333,1),(52800987,425937736,16373147,443749,1,'2007-09-17 00:52:00',3310504333,1),(52800990,425939293,16372203,443749,1,'2007-09-17 00:52:00',3310504333,1),(52800993,425940952,16371488,443749,1,'2007-09-17 00:52:00',3310504333,1),(52800995,425942177,16371130,443749,1,'2007-09-17 00:52:01',3310504333,1),(52800998,425944475,16370518,443749,1,'2007-09-17 00:52:01',3310504333,1),(52801001,425945420,16370262,443749,1,'2007-09-17 00:52:01',3310504333,1),(52801004,425946390,16370084,443749,1,'2007-09-17 00:52:01',3310504333,1),(52801007,425947743,16369982,443749,1,'2007-09-17 00:52:02',3310504344,1),(52801010,425949121,16370007,443749,1,'2007-09-17 00:52:02',3310504344,1),(52801153,425951189,16370467,538211,1,'2007-09-30 15:36:21',3310504344,1),(52801157,425954712,16371692,443749,1,'2007-09-17 00:52:18',3310504344,1),(52801158,425960174,16373811,443749,1,'2007-09-17 00:52:18',3310504344,1),(52801164,425964080,16375266,443749,1,'2007-09-17 00:52:19',3310504344,1),(52801166,425965357,16375827,443749,1,'2007-09-17 00:52:19',3310504344,1),(52801167,425968650,16377640,443749,1,'2007-09-17 00:52:19',3310504344,1),(52801168,425971100,16379121,443749,1,'2007-09-17 00:52:19',3310504344,1),(52801170,425973398,16380652,443749,1,'2007-09-17 00:52:20',3310504344,1),(52801172,425974827,16381214,443749,1,'2007-09-17 00:52:20',3310504345,1),(52801173,425976002,16381469,443749,1,'2007-09-17 00:52:20',3310504345,1),(52801175,425977891,16381469,443749,1,'2007-09-17 00:52:20',3310504345,1),(52801176,425979320,16381226,443749,1,'2007-09-17 00:52:20',3310504345,1),(52801178,425980518,16380871,443749,1,'2007-09-17 00:52:20',3310504345,1),(52801181,425981490,16380207,443749,1,'2007-09-17 00:52:20',3310504345,1),(52801182,425982318,16379489,443749,1,'2007-09-17 00:52:20',3310504345,1),(52801184,425983147,16378356,443749,1,'2007-09-17 00:52:20',3310504345,1),(52801190,425984141,16377169,443749,1,'2007-09-17 00:52:21',3310504345,1),(52801192,425985081,16376367,443749,1,'2007-09-17 00:52:21',3310504345,1),(52801195,425986020,16375732,443749,1,'2007-09-17 00:52:21',3310504345,1),(52801198,425987180,16375124,443749,1,'2007-09-17 00:52:21',3310504345,1),(52801203,425988091,16374793,443749,1,'2007-09-17 00:52:21',3310504345,1),(52801207,425989390,16374682,443749,1,'2007-09-17 00:52:21',3310504345,1),(52801209,425990937,16374682,443749,1,'2007-09-17 00:52:22',3310504345,1),(52801212,425993036,16375069,443749,1,'2007-09-17 00:52:22',3310504345,1),(52801215,425995246,16375456,443749,1,'2007-09-17 00:52:23',3310504345,1),(52801217,425997207,16376146,443749,1,'2007-09-17 00:52:23',3310504345,1),(52801218,425998892,16376727,443749,1,'2007-09-17 00:52:23',3310504345,1),(52801220,426000632,16377141,443749,1,'2007-09-17 00:52:23',3310504345,1),(52801221,426002345,16377251,443749,1,'2007-09-17 00:52:23',3310504348,1),(52801223,426003200,16379655,443749,1,'2007-09-17 00:52:24',3310504348,1),(52801226,426002561,16379687,443749,1,'2007-09-17 00:52:24',3310504348,1),(52801228,426001603,16380006,443749,1,'2007-09-17 00:52:24',3310504348,1),(52801231,426000645,16380102,443749,1,'2007-09-17 00:52:24',3310504345,1),(52801233,425999464,16379910,443749,1,'2007-09-17 00:52:24',3310504345,1),(52801234,425998665,16379335,443749,1,'2007-09-17 00:52:24',3310504345,1),(52801247,425997835,16379080,443749,1,'2007-09-17 00:52:26',3310504345,1),(52801248,425996047,16379272,443749,1,'2007-09-17 00:52:26',3310504345,1),(52801251,425994258,16379527,443749,1,'2007-09-17 00:52:26',3310504345,1),(52801254,425992885,16379591,443749,1,'2007-09-17 00:52:26',3310504345,1),(52801258,425991416,16379431,443749,1,'2007-09-17 00:52:26',3310504345,1),(52801262,425990522,16379463,443749,1,'2007-09-17 00:52:26',3310504345,1),(52801265,425989596,16380325,443749,1,'2007-09-17 00:52:27',3310504345,1),(52801269,425989149,16381379,443749,1,'2007-09-17 00:52:27',3310504345,1),(52801273,425988510,16382146,443749,1,'2007-09-17 00:52:27',3310504345,1),(52801274,425987616,16382752,443749,1,'2007-09-17 00:52:27',3310504345,1),(52801279,425986690,16382784,443749,1,'2007-09-17 00:52:27',3310504345,1),(52801283,425986019,16382305,443749,1,'2007-09-17 00:52:27',3310504345,1),(52801284,425985349,16382178,443749,1,'2007-09-17 00:52:27',3310504345,1),(52801287,425983752,16382146,443749,1,'2007-09-17 00:52:27',3310504345,1),(52801289,425982092,16382114,443749,1,'2007-09-17 00:52:28',3310504345,1),(52801291,425980878,16382305,443749,1,'2007-09-17 00:52:28',3310504345,1),(52801293,425979952,16382912,443749,1,'2007-09-17 00:52:28',3310504345,1),(52801295,425978387,16383327,443749,1,'2007-09-17 00:52:28',3310504345,1),(52801298,425976280,16383104,443749,1,'2007-09-17 00:52:28',3310504345,1),(52801299,425974012,16382657,443749,1,'2007-09-17 00:52:28',3310504345,1),(52801301,425972256,16381826,443749,1,'2007-09-17 00:52:29',3310504344,1),(52801303,425970851,16380293,443749,1,'2007-09-17 00:52:29',3310504344,1),(52801305,425968009,16378473,443749,1,'2007-09-17 00:52:29',3310504344,1),(52801307,425964049,16376653,443749,1,'2007-09-17 00:52:29',3310504344,1),(52801309,425961750,16375535,443749,1,'2007-09-17 00:52:30',3310504344,1),(52801311,425960568,16375440,443749,1,'2007-09-17 00:52:30',3310504344,1),(52801313,425958812,16375440,443749,1,'2007-09-17 00:52:30',3310504344,1),(52801314,425956417,16375312,443749,1,'2007-09-17 00:52:30',3310504344,1),(52801316,425954597,16375088,443749,1,'2007-09-17 00:52:30',3310504344,1),(52801317,425953160,16373747,443749,1,'2007-09-17 00:52:30',3310504344,1),(52801319,425951307,16372086,443749,1,'2007-09-17 00:52:30',3310504344,1),(52801321,425950158,16371863,443749,1,'2007-09-17 00:52:31',3310504344,1),(52801323,425948912,16372597,443749,1,'2007-09-17 00:52:31',3310504344,1),(52801324,425948050,16372949,443749,1,'2007-09-17 00:52:31',3310504344,1),(52801326,425947252,16373140,443749,1,'2007-09-17 00:52:31',3310504344,1),(52801328,425946517,16373492,443749,1,'2007-09-17 00:52:31',3310504344,1),(52801330,425945559,16374609,443749,1,'2007-09-17 00:52:31',3310504333,1),(52801331,425944953,16375280,443749,1,'2007-09-17 00:52:31',3310504333,1),(52801333,425944186,16375663,443749,1,'2007-09-17 00:52:32',3310504333,1),(52801336,425943771,16375567,443749,1,'2007-09-17 00:52:32',3310504333,1),(52801339,425943356,16375152,443749,1,'2007-09-17 00:52:32',3310504333,1),(52801341,425942462,16374897,443749,1,'2007-09-17 00:52:32',3310504333,1),(52801344,425941855,16374992,443749,1,'2007-09-17 00:52:32',3310504333,1),(52801345,425940322,16374609,443749,1,'2007-09-17 00:52:32',3310504333,1),(52801348,425939204,16374226,443749,1,'2007-09-17 00:52:33',3310504333,1),(52801350,425938374,16374258,443749,1,'2007-09-17 00:52:33',3310504333,1),(52801352,425937512,16374865,443749,1,'2007-09-17 00:52:33',3310504333,1),(52801353,425935692,16375887,443749,1,'2007-09-17 00:52:33',3310504333,1),(52801354,425933648,16377803,443749,1,'2007-09-17 00:52:33',3310504333,1),(52801355,425932115,16378346,443749,1,'2007-09-17 00:52:33',3310504333,1),(52801356,425930327,16378250,443749,1,'2007-09-17 00:52:33',3310504333,1),(52801357,425928507,16378026,443749,1,'2007-09-17 00:52:34',3310504333,1),(52801358,425926591,16377867,443749,1,'2007-09-17 00:52:34',3310504333,1),(52801359,425925377,16378377,443749,1,'2007-09-17 00:52:34',3310504333,1),(52801360,425923780,16377228,443749,1,'2007-09-17 00:52:34',3310504333,1),(52801361,425922599,16375535,443749,1,'2007-09-17 00:52:34',3310504333,1),(52801362,425921290,16374801,443749,1,'2007-09-17 00:52:34',3310504333,1),(52801363,425920395,16374992,443749,1,'2007-09-17 00:52:34',3310504333,1),(52801364,425919278,16375631,443749,1,'2007-09-17 00:52:34',3310504333,1),(52801366,425918639,16376877,443749,1,'2007-09-17 00:52:35',3310504332,1),(52801368,425917968,16377835,443749,1,'2007-09-17 00:52:35',3310504332,1),(52801370,425917202,16378250,443749,1,'2007-09-17 00:52:35',3310504332,1),(52801372,425916276,16378218,443749,1,'2007-09-17 00:52:35',3310504332,1),(52801374,425914935,16377164,443749,1,'2007-09-17 00:52:35',3310504332,1),(52801376,425913594,16375950,443749,1,'2007-09-17 00:52:35',3310504332,1),(52801380,425912188,16374992,443749,1,'2007-09-17 00:52:36',3310504332,1),(52801384,425911039,16374418,443749,1,'2007-09-17 00:52:36',3310504332,1),(52801389,425910049,16374386,443749,1,'2007-09-17 00:52:36',3310504332,1),(52801392,425908963,16374961,443749,1,'2007-09-17 00:52:36',3310504332,1),(52801396,425907590,16376142,443749,1,'2007-09-17 00:52:36',3310504332,1),(52801397,425906824,16377324,443749,1,'2007-09-17 00:52:36',3310504332,1),(52801402,425905291,16377611,443749,1,'2007-09-17 00:52:37',3310504332,1),(52801404,425903566,16377419,443749,1,'2007-09-17 00:52:37',3310504332,1),(52801407,425902768,16377419,443749,1,'2007-09-17 00:52:37',3310504332,1),(52801413,425901746,16378473,443749,1,'2007-09-17 00:52:37',3310504332,1),(52801417,425901076,16379176,443749,1,'2007-09-17 00:52:37',3310504332,1),(52801418,425899159,16379527,443749,1,'2007-09-17 00:52:38',3310504332,1),(52801422,425898074,16379623,443749,1,'2007-09-17 00:52:38',3310504332,1),(52801425,425897116,16380421,443749,1,'2007-09-17 00:52:38',3310504332,1),(52801427,425896381,16381443,443749,1,'2007-09-17 00:52:38',3310504332,1),(52801429,425894401,16383519,443749,1,'2007-09-17 00:52:38',3310504332,1),(52801431,425893284,16384605,443749,1,'2007-09-17 00:52:38',3310504332,1),(52801433,425891463,16385786,443749,1,'2007-09-17 00:52:38',3310504329,1),(52801435,425890952,16386457,443749,1,'2007-09-17 00:52:38',3310504329,1),(52801437,425890569,16387191,443749,1,'2007-09-17 00:52:39',3310504329,1),(52801439,425890058,16387766,443749,1,'2007-09-17 00:52:39',3310504329,1),(52801441,425888973,16388628,443749,1,'2007-09-17 00:52:39',3310504329,1),(52801444,425887983,16388564,443749,1,'2007-09-17 00:52:39',3310504329,1),(52801446,425886578,16388309,443749,1,'2007-09-17 00:52:39',3310504329,1),(52801447,425885364,16388021,443749,1,'2007-09-17 00:52:39',3310504329,1),(52801451,425884374,16387830,443749,1,'2007-09-17 00:52:40',3310504329,1),(52801453,425882777,16388341,443749,1,'2007-09-17 00:52:40',3310504329,1),(52801456,425881213,16389650,443749,1,'2007-09-17 00:52:40',3310504329,1),(52801461,425880287,16389842,443749,1,'2007-09-17 00:52:40',3310504329,1),(52801462,425879105,16389778,443749,1,'2007-09-17 00:52:40',3310504329,1),(52801465,425877317,16389427,443749,1,'2007-09-17 00:52:40',3310504329,1),(52801468,425875465,16388437,443749,1,'2007-09-17 00:52:40',3310504329,1),(52801469,425873197,16387319,443749,1,'2007-09-17 00:52:40',3310504329,1),(52801475,425871281,16386169,443749,1,'2007-09-17 00:52:40',3310504329,1),(52801477,425868822,16383934,443749,1,'2007-09-17 00:52:40',3310504329,1),(52801480,425867321,16382018,443749,1,'2007-09-17 00:52:41',3310504329,1),(52801487,425865980,16379942,443749,1,'2007-09-17 00:52:41',3310504329,1),(52801494,425865437,16378888,443749,1,'2007-09-17 00:52:41',3310504329,1),(52801506,425865118,16378729,443749,1,'2007-09-17 00:52:41',3310504329,1),(52801514,425864352,16378314,443749,1,'2007-09-17 00:52:41',3310504329,1),(52801516,425863585,16378314,443749,1,'2007-09-17 00:52:41',3310504328,1),(52801518,425862723,16378377,443749,1,'2007-09-17 00:52:41',3310504328,1),(52801520,425861158,16378186,443749,1,'2007-09-17 00:52:42',3310504328,1),(52801522,425860392,16377867,443749,1,'2007-09-17 00:52:42',3310504328,1),(52801524,425859625,16376813,443749,1,'2007-09-17 00:52:42',3310504328,1),(52801526,425858284,16375919,443749,1,'2007-09-17 00:52:42',3310504328,1),(52801527,425856656,16375344,443749,1,'2007-09-17 00:52:42',3310504328,1),(52801531,425855442,16374513,443749,1,'2007-09-17 00:52:42',3310504328,1),(52801534,425853558,16373555,443749,1,'2007-09-17 00:52:43',3310504328,1),(52801538,425852632,16372757,443749,1,'2007-09-17 00:52:43',3310504328,1),(52801542,425851387,16371863,443749,1,'2007-09-17 00:52:43',3310504328,1),(52801545,425850141,16371256,443749,1,'2007-09-17 00:52:43',3310504328,1),(52801548,425848960,16371128,443749,1,'2007-09-17 00:52:43',3310504328,1),(52801551,425847874,16371256,443749,1,'2007-09-17 00:52:43',3310504328,1),(52801555,425846596,16371033,443749,1,'2007-09-17 00:52:43',3310504328,1),(52801558,425846181,16370905,443749,1,'2007-09-17 00:52:44',3310504328,1),(52801561,425844904,16369755,443749,1,'2007-09-17 00:52:44',3310504322,1),(52801566,425843882,16369053,443749,1,'2007-09-17 00:52:45',3310504322,1),(52801569,425842573,16368254,443749,1,'2007-09-17 00:52:45',3310504322,1),(52801571,425840290,16368343,443749,1,'2007-09-17 00:52:45',3310504322,1),(52801573,425838608,16368574,443749,1,'2007-09-17 00:52:45',3310504322,1),(52801576,425837479,16368896,443749,1,'2007-09-17 00:52:45',3310504322,1),(52801578,425835868,16369486,443749,1,'2007-09-17 00:52:46',3310504151,1),(52801581,425833978,16370083,443749,1,'2007-09-17 00:52:46',3310504157,1),(52801584,425832684,16370050,443749,1,'2007-09-17 00:52:46',3310504157,1),(52801585,425831324,16369751,443749,1,'2007-09-17 00:52:46',3310504151,1),(52801587,425829798,16369188,443749,1,'2007-09-17 00:52:46',3310504151,1),(52801618,425828438,16369320,443749,1,'2007-09-17 00:52:49',3310504151,1),(52801640,425827111,16369486,443749,1,'2007-09-17 00:52:52',3310504151,1),(52801643,425822666,16369884,443749,1,'2007-09-17 00:52:52',3310504157,1),(52801648,425820642,16370813,443749,1,'2007-09-17 00:52:52',3310504157,1),(52801652,425819083,16370581,443749,1,'2007-09-17 00:52:52',3310504157,1),(52801654,425817126,16370680,443749,1,'2007-09-17 00:52:52',3310504157,1),(52801657,425815567,16371543,443749,1,'2007-09-17 00:52:52',3310504157,1),(52801660,425813510,16372737,443749,1,'2007-09-17 00:52:53',3310504157,1),(52801663,425811619,16373799,443749,1,'2007-09-17 00:52:53',3310504157,1),(52801664,425809994,16374761,443749,1,'2007-09-17 00:52:53',3310504157,1),(52801668,425808799,16375656,443749,1,'2007-09-17 00:52:53',3310504156,1),(52801672,425808235,16377249,443749,1,'2007-09-17 00:52:53',3310504156,1),(52801674,425807771,16379239,443749,1,'2007-09-17 00:52:53',3310504156,1),(52801679,425806942,16380035,443749,1,'2007-09-17 00:52:53',3310504156,1),(52801683,425806345,16380599,443749,1,'2007-09-17 00:52:53',3310504156,1),(52801684,425806212,16381860,443749,1,'2007-09-17 00:52:54',3310504156,1),(52801688,425805913,16382855,443749,1,'2007-09-17 00:52:54',3310504156,1),(52801691,425805084,16384115,443749,1,'2007-09-17 00:52:54',3310504156,1),(52801695,425804387,16384679,443749,1,'2007-09-17 00:52:54',3310504156,1),(52801699,425803193,16383717,443749,1,'2007-09-17 00:52:54',3310504156,1),(52801701,425802231,16383684,443749,1,'2007-09-17 00:52:54',3310504156,1),(52801704,425801136,16385310,443749,1,'2007-09-17 00:52:54',3310504156,1),(52801707,425799975,16386570,443749,1,'2007-09-17 00:52:54',3310504156,1),(52801710,425798914,16386139,443749,1,'2007-09-17 00:52:55',3310504156,1),(52801715,425797952,16385409,443749,1,'2007-09-17 00:52:55',3310504156,1),(52801719,425796890,16385807,443749,1,'2007-09-17 00:52:55',3310504156,1),(52801722,425796426,16386338,443749,1,'2007-09-17 00:52:55',3310504156,1),(52801725,425794739,16389086,443749,1,'2007-09-17 00:52:55',3310504156,1),(52801729,425793687,16391481,443749,1,'2007-09-17 00:52:56',3310504156,1),(52801733,425793220,16393292,443749,1,'2007-09-17 00:52:56',3310504156,1),(52801737,425791993,16394986,443749,1,'2007-09-17 00:52:56',3310504156,1),(52801741,425789607,16398400,454632,1,'2007-09-17 18:07:28',3310504156,1),(52801744,425920507,16379623,443749,1,'2007-09-17 00:52:56',3310504333,1),(52801747,425922786,16377759,443749,1,'2007-09-17 00:52:57',3310504333,1),(52801749,425924501,16376193,443749,1,'2007-09-17 00:52:57',3310504333,1),(52801750,425925943,16374900,443749,1,'2007-09-17 00:52:57',3310504333,1),(52801752,425919810,16380145,443749,1,'2007-09-17 00:52:57',3310504333,1),(52801754,425918965,16380568,443749,1,'2007-09-17 00:52:57',3310504332,1),(52801756,425917648,16380817,443749,1,'2007-09-17 00:52:57',3310504332,1),(52801757,425915883,16380568,443749,1,'2007-09-17 00:52:57',3310504332,1),(52801758,425914814,16380046,443749,1,'2007-09-17 00:52:57',3310504332,1),(52801759,425913496,16379599,443749,1,'2007-09-17 00:52:57',3310504332,1),(52801760,425913074,16379599,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801761,425911980,16380145,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801762,425910265,16381165,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801764,425909121,16381811,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801765,425907878,16382333,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801768,425906113,16382930,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801769,425904945,16383601,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801771,425904100,16384222,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801772,425903876,16384322,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801774,425902832,16385863,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801776,425901042,16388697,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801777,425899973,16390263,443749,1,'2007-09-17 00:52:58',3310504332,1),(52801780,425899998,16390263,443749,1,'2007-09-17 00:52:59',3310504332,1),(52801781,425898730,16391581,443749,1,'2007-09-17 00:52:59',3310504332,1),(52801783,425897860,16392277,443749,1,'2007-09-17 00:52:59',3310504332,1),(52801785,425896642,16392476,443749,1,'2007-09-17 00:52:59',3310504332,1),(52801787,425895498,16392923,443749,1,'2007-09-17 00:52:59',3310504332,1),(52801788,425894230,16394091,443749,1,'2007-09-17 00:52:59',3310504332,1),(52801791,425893733,16394589,443749,1,'2007-09-17 00:52:59',3310504332,1),(52801792,425893062,16395061,443749,1,'2007-09-17 00:52:59',3310504332,1),(52801794,425890899,16396252,443749,1,'2007-09-17 00:52:59',3310504329,1),(52801796,425888413,16397670,557925,1,'2008-01-06 23:25:40',3310504329,2),(52801807,425885888,16398959,557925,1,'2008-01-06 23:25:40',3310504329,2),(52801809,425883465,16400196,443749,1,'2007-09-17 00:53:00',3310504329,1),(52801813,425882145,16400717,443749,1,'2007-09-17 00:53:00',3310504329,1),(52801816,425880537,16401211,443749,1,'2007-09-17 00:53:00',3310504329,1),(52801819,425878929,16401644,443749,1,'2007-09-17 00:53:00',3310504329,1),(52801824,425877593,16401688,443749,1,'2007-09-17 00:53:01',3310504329,1),(52801827,425875143,16401688,443749,1,'2007-09-17 00:53:01',3310504329,1),(52801876,425873287,16400871,443749,1,'2007-09-17 00:53:06',3310504329,1),(52802034,425871258,16400500,538211,1,'2007-09-30 15:36:22',3310504329,1),(52802158,425868631,16400354,443749,1,'2007-09-17 00:53:42',3310504329,1),(52802159,425866805,16400176,443749,1,'2007-09-17 00:53:42',3310504329,1),(52802160,425864800,16399686,443749,1,'2007-09-17 00:53:42',3310504329,1),(52802161,425863375,16399241,443749,1,'2007-09-17 00:53:42',3310504328,1),(52802162,425861861,16399018,443749,1,'2007-09-17 00:53:42',3310504328,1),(52802163,425859590,16398751,443749,1,'2007-09-17 00:53:43',3310504328,1),(52802164,425857585,16397815,443749,1,'2007-09-17 00:53:43',3310504328,1),(52802165,425855180,16396747,443749,1,'2007-09-17 00:53:43',3310504328,1),(52802166,425852820,16396657,443749,1,'2007-09-17 00:53:43',3310504328,1),(52802167,425850638,16396346,443749,1,'2007-09-17 00:53:44',3310504328,1),(52802168,425846273,16396257,443749,1,'2007-09-17 00:53:44',3310504328,1),(52802169,425844536,16395811,443749,1,'2007-09-17 00:53:45',3310504328,1),(52802170,425843645,16395856,443749,1,'2007-09-17 00:53:45',3310504328,1),(52802171,425842220,16396390,443749,1,'2007-09-17 00:53:47',3310504328,1),(52802172,425839993,16397637,443749,1,'2007-09-17 00:53:48',3310504328,1),(52802173,425838301,16398884,443749,1,'2007-09-17 00:53:49',3310504328,1),(52802183,425835985,16400621,443749,1,'2007-09-17 00:53:50',3310504157,1),(52802197,425833669,16402180,443749,1,'2007-09-17 00:53:52',3310504157,1),(52802210,425832155,16404140,443749,1,'2007-09-17 00:53:53',3310504157,1),(52802216,425831264,16407480,443749,1,'2007-09-17 00:53:54',3310504157,1),(52802218,425830106,16413047,443749,1,'2007-09-17 00:53:54',3310504157,1),(52802229,425829393,16418659,443749,1,'2007-09-17 00:53:56',3310504157,1),(52802260,425828992,16423380,443749,1,'2007-09-17 00:53:59',3310504157,1),(52803163,425829037,16430105,538211,1,'2007-09-30 15:36:22',3310504159,1),(52803175,425829171,16437231,443749,1,'2007-09-17 00:55:58',3310504159,1),(52803179,425829705,16442932,443749,1,'2007-09-17 00:55:58',3310504159,1),(52803182,425830284,16446228,443749,1,'2007-09-17 00:55:59',3310504159,1),(52803183,425830729,16448811,443749,1,'2007-09-17 00:55:59',3310504159,1),(52803186,425831175,16451260,443749,1,'2007-09-17 00:55:59',3310504159,1),(52803189,425831576,16452329,443749,1,'2007-09-17 00:55:59',3310504159,1),(52803191,425832377,16453576,443749,1,'2007-09-17 00:55:59',3310504159,1),(52803194,425833268,16455402,443749,1,'2007-09-17 00:56:00',3310504159,1),(52803195,425834203,16458074,443749,1,'2007-09-17 00:56:00',3310504159,1),(52803196,425834693,16461370,443749,1,'2007-09-17 00:56:00',3310504159,1),(52803197,425835183,16464131,443749,1,'2007-09-17 00:56:00',3310504159,1),(52803198,425835317,16465913,443749,1,'2007-09-17 00:56:00',3310504159,1),(52803200,425835495,16467873,443749,1,'2007-09-17 00:56:00',3310504159,1),(52803201,425835896,16469209,443749,1,'2007-09-17 00:56:00',3310504159,1),(52803202,425836742,16470545,443749,1,'2007-09-17 00:56:00',3310504330,1),(52803205,425837455,16471836,443749,1,'2007-09-17 00:56:01',3310504330,1),(52803207,425837811,16473440,443749,1,'2007-09-17 00:56:01',3310504330,1),(52803211,425837855,16475088,443749,1,'2007-09-17 00:56:01',3310504330,1),(52803214,425838167,16477938,443749,1,'2007-09-17 00:56:01',3310504330,1),(52803216,425838301,16480610,443749,1,'2007-09-17 00:56:01',3310504352,1),(52803218,425838702,16483951,443749,1,'2007-09-17 00:56:01',3310504352,1),(52803220,425839993,16486667,443749,1,'2007-09-17 00:56:02',3310504352,1),(52803222,425841418,16488315,443749,1,'2007-09-17 00:56:02',3310504352,1),(52803224,425842576,16489295,443749,1,'2007-09-17 00:56:02',3310504352,1),(52803225,425843155,16490987,443749,1,'2007-09-17 00:56:02',3310504352,1),(52803228,425843022,16492635,443749,1,'2007-09-17 00:56:02',3310504352,1),(52803229,425842487,16494239,443749,1,'2007-09-17 00:56:02',3310504352,1),(52803233,425842398,16495664,443749,1,'2007-09-17 00:56:02',3310504352,1),(52803235,425842754,16497134,443749,1,'2007-09-17 00:56:02',3310504352,1),(52803237,425843022,16498648,443749,1,'2007-09-17 00:56:03',3310504352,1),(52803239,425842977,16499984,443749,1,'2007-09-17 00:56:03',3310504352,1),(52803241,425842398,16501676,443749,1,'2007-09-17 00:56:03',3310504352,1),(52803243,425841686,16503235,443749,1,'2007-09-17 00:56:03',3310504352,1),(52803247,425841107,16505373,443749,1,'2007-09-17 00:56:03',3310504352,1),(52803251,425841151,16508001,443749,1,'2007-09-17 00:56:03',3310504352,1),(52803254,425841018,16510183,443749,1,'2007-09-17 00:56:04',3310504352,1),(52803255,425840795,16513256,443749,1,'2007-09-17 00:56:04',3310504352,1),(52803259,425840483,16515528,443749,1,'2007-09-17 00:56:04',3310504352,1),(52803263,425840528,16516641,443749,1,'2007-09-17 00:56:04',3310504352,1),(52803266,425840283,16518634,443749,1,'2007-09-17 00:56:04',3310504352,1),(52803269,425839621,16520746,443749,1,'2007-09-17 00:56:05',3310504352,1),(52803271,425838833,16522700,443749,1,'2007-09-17 00:56:05',3310504352,1),(52803273,425838108,16526151,443749,1,'2007-09-17 00:56:05',3310504352,1),(52803277,425833197,16398304,443749,1,'2007-09-17 00:56:05',3310504157,1),(52803280,425836075,16396975,443749,1,'2007-09-17 00:56:05',3310504157,1),(52803283,425831957,16399322,443749,1,'2007-09-17 00:56:05',3310504157,1),(52803285,425830363,16400916,443749,1,'2007-09-17 00:56:06',3310504157,1),(52803289,425829434,16403174,538211,1,'2007-09-30 15:36:22',3310504157,1),(52803297,425828460,16405432,443749,1,'2007-09-17 00:56:06',3310504157,1),(52803300,425827485,16407248,443749,1,'2007-09-17 00:56:07',3310504157,1),(52803304,425826246,16409329,443749,1,'2007-09-17 00:56:07',3310504157,1),(52803309,425824386,16411941,443749,1,'2007-09-17 00:56:08',3310504157,1),(52803311,425837669,16396311,443749,1,'2007-09-17 00:56:08',3310504328,1),(52803313,425839484,16395470,443749,1,'2007-09-17 00:56:08',3310504328,1),(52803316,425840901,16394939,443749,1,'2007-09-17 00:56:08',3310504328,1),(52803319,425842539,16394585,443749,1,'2007-09-17 00:56:08',3310504328,1),(52803320,425844001,16394629,443749,1,'2007-09-17 00:56:08',3310504328,1),(52803323,425845727,16395027,443749,1,'2007-09-17 00:56:08',3310504328,1),(52803325,425847321,16395736,443749,1,'2007-09-17 00:56:09',3310504328,1),(52803327,425847808,16396267,443749,1,'2007-09-17 00:56:09',3310504328,1),(52803328,425841761,16390329,443749,1,'2007-09-17 00:56:09',3310504328,1),(52803331,425843905,16391119,443749,1,'2007-09-17 00:56:09',3310504328,1),(52803333,425845785,16391683,443749,1,'2007-09-17 00:56:09',3310504328,1),(52803336,425847665,16391796,443749,1,'2007-09-17 00:56:09',3310504328,1),(52803337,425849245,16391345,443749,1,'2007-09-17 00:56:09',3310504328,1),(52803338,425851012,16391157,443749,1,'2007-09-17 00:56:10',3310504328,1),(52803340,425852178,16391533,443749,1,'2007-09-17 00:56:10',3310504328,1),(52803343,425853795,16392962,443749,1,'2007-09-17 00:56:10',3310504328,1),(52803346,425857556,16395105,443749,1,'2007-09-17 00:56:10',3310504328,1),(52803349,425864851,16398302,443749,1,'2007-09-17 00:56:11',3310504329,1),(52803351,426003763,16377246,443749,1,'2007-09-17 00:56:11',3310504348,1),(52803353,426005675,16376591,443749,1,'2007-09-17 00:56:12',3310504348,1),(52803358,426007587,16375990,443749,1,'2007-09-17 00:56:12',3310504348,1),(52803363,426008953,16375553,443749,1,'2007-09-17 00:56:13',3310504348,1),(52803365,426011193,16375443,443749,1,'2007-09-17 00:56:14',3310504348,1),(52803368,426012865,16375719,443749,1,'2007-09-17 00:56:14',3310504348,1),(52803370,426014473,16376873,443749,1,'2007-09-17 00:56:14',3310504348,1),(52803372,426015592,16377887,443749,1,'2007-09-17 00:56:14',3310504348,1),(52803374,426016816,16378691,443749,1,'2007-09-17 00:56:15',3310504348,1),(52803378,426017900,16379495,443749,1,'2007-09-17 00:56:15',3310504348,1),(52803382,426019578,16380159,443749,1,'2007-09-17 00:56:15',3310504348,1),(52803385,426020977,16380334,443749,1,'2007-09-17 00:56:15',3310504348,1),(52803388,426024229,16380614,443749,1,'2007-09-17 00:56:16',3310504348,1),(52803391,426026536,16380894,443749,1,'2007-09-17 00:56:16',3310504348,1),(52803393,426028494,16381278,443749,1,'2007-09-17 00:56:16',3310504348,1),(52803396,426029369,16381663,443749,1,'2007-09-17 00:56:16',3310504349,1),(52803399,426005627,16380229,443749,1,'2007-09-17 00:56:16',3310504348,1),(52803402,426007026,16380264,443749,1,'2007-09-17 00:56:16',3310504348,1),(52803405,426008319,16381068,443749,1,'2007-09-17 00:56:17',3310504348,1),(52803937,426009823,16382152,443749,1,'2007-09-17 00:57:14',3310504348,1),(52803938,426011676,16382362,443749,1,'2007-09-17 00:57:14',3310504348,1),(52803940,426012445,16381628,443749,1,'2007-09-17 00:57:14',3310504348,1),(52803941,426013424,16380894,443749,1,'2007-09-17 00:57:14',3310504348,1),(52803943,426014543,16380439,443749,1,'2007-09-17 00:57:14',3310504348,1),(52803944,426016221,16380544,443749,1,'2007-09-17 00:57:14',3310504348,1),(52803954,426018424,16381138,443749,1,'2007-09-17 00:57:15',3310504348,1),(52803955,426019613,16381803,443749,1,'2007-09-17 00:57:15',3310504348,1),(52803956,426020767,16382362,443749,1,'2007-09-17 00:57:15',3310504348,1),(52803958,426021571,16382642,443749,1,'2007-09-17 00:57:15',3310504348,1),(52803959,426022375,16382607,443749,1,'2007-09-17 00:57:15',3310504348,1),(52803961,426023354,16382222,443749,1,'2007-09-17 00:57:15',3310504348,1),(52803962,426024159,16381873,443749,1,'2007-09-17 00:57:16',3310504348,1),(52803965,426024998,16381733,443749,1,'2007-09-17 00:57:16',3310504348,1),(52803969,426026676,16382152,443749,1,'2007-09-17 00:57:16',3310504348,1),(52803973,426028285,16382607,443749,1,'2007-09-17 00:57:16',3310504348,1),(52803976,426029194,16382957,443749,1,'2007-09-17 00:57:16',3310504349,1),(52803980,426010673,16382512,443749,1,'2007-09-17 00:57:16',3310504348,1),(52803983,426032432,16382471,443749,1,'2007-09-17 00:57:16',3310504349,1),(52803988,426035622,16384138,443749,1,'2007-09-17 00:57:17',3310504349,1),(52803992,426038377,16385951,443749,1,'2007-09-17 00:57:17',3310504349,1),(52803995,426040973,16387903,443749,1,'2007-09-17 00:57:17',3310504349,1),(52803998,426042272,16388831,443749,1,'2007-09-17 00:57:17',3310504349,1),(52804002,426043247,16389155,443749,1,'2007-09-17 00:57:18',3310504349,1),(52804005,426044500,16389155,443749,1,'2007-09-17 00:57:18',3310504349,1),(52804010,426045660,16388784,443749,1,'2007-09-17 00:57:18',3310504349,1),(52804014,426046727,16388135,443749,1,'2007-09-17 00:57:18',3310504349,1),(52804018,426048583,16386510,443749,1,'2007-09-17 00:57:18',3310504349,1),(52804021,426049604,16385582,443749,1,'2007-09-17 00:57:18',3310504349,1),(52804024,426051089,16384747,443749,1,'2007-09-17 00:57:19',3310504349,1),(52804026,426052620,16384422,443749,1,'2007-09-17 00:57:19',3310504349,1),(52804028,426054662,16384701,443749,1,'2007-09-17 00:57:19',3310504349,1),(52804030,426057910,16385629,443749,1,'2007-09-17 00:57:19',3310504392,1),(52804033,426060880,16386139,443749,1,'2007-09-17 00:57:19',3310504392,1),(52804036,426062782,16386464,443749,1,'2007-09-17 00:57:20',3310504392,1),(52804038,426065381,16386742,443749,1,'2007-09-17 00:57:20',3310504392,1),(52804041,426067005,16386835,443749,1,'2007-09-17 00:57:20',3310504392,1),(52804043,426068258,16386696,443749,1,'2007-09-17 00:57:20',3310504392,1),(52804046,426069836,16386325,443749,1,'2007-09-17 00:57:20',3310504392,1),(52804050,426071784,16385072,443749,1,'2007-09-17 00:57:21',3310504392,1),(52804052,426073362,16383726,443749,1,'2007-09-17 00:57:21',3310504392,1),(52804055,426030811,16384794,443749,1,'2007-09-17 00:57:21',3310504349,1),(52804060,426031739,16385536,443749,1,'2007-09-17 00:57:22',3310504349,1),(52804062,426033131,16386278,443749,1,'2007-09-17 00:57:22',3310504349,1),(52804065,426034616,16386928,443749,1,'2007-09-17 00:57:22',3310504349,1),(52804069,426035497,16387717,443749,1,'2007-09-17 00:57:23',3310504349,1),(52804073,426035683,16388970,443749,1,'2007-09-17 00:57:23',3310504349,1),(52804077,426036379,16390316,443749,1,'2007-09-17 00:57:23',3310504349,1),(52804081,426037910,16390919,443749,1,'2007-09-17 00:57:23',3310504349,1),(52804084,426039024,16391940,443749,1,'2007-09-17 00:57:23',3310504349,1),(52804087,426039720,16392543,443749,1,'2007-09-17 00:57:24',3310504349,1),(52804090,426040927,16393425,443749,1,'2007-09-17 00:57:24',3310504349,1),(52804091,426042133,16393517,443749,1,'2007-09-17 00:57:24',3310504349,1),(52804093,426043711,16393657,443749,1,'2007-09-17 00:57:24',3310504349,1),(52804096,426045056,16393842,443749,1,'2007-09-17 00:57:25',3310504349,1),(52804100,426045892,16394353,443749,1,'2007-09-17 00:57:26',3310504349,1),(52804101,426047377,16395049,443749,1,'2007-09-17 00:57:26',3310504349,1),(52804106,426048537,16395188,443749,1,'2007-09-17 00:57:26',3310504349,1),(52804109,426050393,16396719,443749,1,'2007-09-17 00:57:27',3310504349,1),(52804112,426052110,16397276,443749,1,'2007-09-17 00:57:27',3310504349,1),(52804114,426053595,16397044,443749,1,'2007-09-17 00:57:27',3310504349,1),(52804117,426055311,16396719,443749,1,'2007-09-17 00:57:27',3310504349,1),(52804118,426056843,16396534,443749,1,'2007-09-17 00:57:28',3310504392,1),(52804119,426058049,16396951,443749,1,'2007-09-17 00:57:28',3310504392,1),(52804120,426059627,16396580,443749,1,'2007-09-17 00:57:28',3310504392,1),(52804121,426060973,16395977,443749,1,'2007-09-17 00:57:28',3310504392,1),(52804122,426062690,16394724,443749,1,'2007-09-17 00:57:28',3310504392,1),(52804123,426064082,16393935,443749,1,'2007-09-17 00:57:29',3310504392,1),(52804124,426065474,16392868,443749,1,'2007-09-17 00:57:29',3310504392,1),(52804125,426067237,16391244,443749,1,'2007-09-17 00:57:29',3310504392,1),(52804126,426069232,16390084,443749,1,'2007-09-17 00:57:29',3310504392,1),(52804127,426070392,16389759,443749,1,'2007-09-17 00:57:29',3310504392,1),(52804128,426072017,16389573,443749,1,'2007-09-17 00:57:29',3310504392,1),(52804129,426073316,16390316,443749,1,'2007-09-17 00:57:29',3310504392,1),(52804130,426075218,16382102,443749,1,'2007-09-17 00:57:29',3310504392,1),(52804131,426076935,16380664,443749,1,'2007-09-17 00:57:29',3310504392,1),(52804132,426078095,16379921,443749,1,'2007-09-17 00:57:30',3310504392,1),(52804133,426079859,16379364,443749,1,'2007-09-17 00:57:30',3310504392,1),(52804134,426081158,16379272,443749,1,'2007-09-17 00:57:30',3310504392,1),(52804135,426083803,16379225,443749,1,'2007-09-17 00:57:30',3310504393,1),(52804136,426086077,16379411,443749,1,'2007-09-17 00:57:30',3310504393,1),(52804137,426089000,16380107,443749,1,'2007-09-17 00:57:30',3310504393,1),(52804138,426090717,16380292,443749,1,'2007-09-17 00:57:31',3310504393,1),(52804139,426092944,16380757,443749,1,'2007-09-17 00:57:31',3310504393,1),(52804140,426094429,16380942,443749,1,'2007-09-17 00:57:31',3310504393,1),(52804141,426095960,16380942,443749,1,'2007-09-17 00:57:31',3310504393,1),(52804142,426097074,16380710,443749,1,'2007-09-17 00:57:31',3310504393,1),(52804143,426098466,16380385,443749,1,'2007-09-17 00:57:31',3310504393,1),(52804145,426099626,16380014,443749,1,'2007-09-17 00:57:32',3310504393,1),(52804150,426101482,16379689,443749,1,'2007-09-17 00:57:32',3310504393,1),(52804160,426102967,16379550,443749,1,'2007-09-17 00:57:32',3310504393,1),(52804163,426103895,16379318,443749,1,'2007-09-17 00:57:33',3310504393,1),(52804167,426105751,16378993,443749,1,'2007-09-17 00:57:33',3310504393,1),(52804172,426107051,16378900,443749,1,'2007-09-17 00:57:33',3310504393,1),(52804173,426074429,16390223,443749,1,'2007-09-17 00:57:34',3310504392,1),(52804176,426075172,16389527,443749,1,'2007-09-17 00:57:34',3310504392,1),(52804216,426076471,16388970,443749,1,'2007-09-17 00:57:36',3310504392,1),(52804228,426077538,16388831,443749,1,'2007-09-17 00:57:37',3310504392,1),(52804233,426078745,16388599,443749,1,'2007-09-17 00:57:37',3310504392,1),(52804235,426080091,16388367,443749,1,'2007-09-17 00:57:37',3310504392,1),(52804237,426081483,16388738,443749,1,'2007-09-17 00:57:37',3310504392,1),(52804272,426081993,16389202,443749,1,'2007-09-17 00:57:40',3310504392,1),(52804275,426083478,16389202,443749,1,'2007-09-17 00:57:40',3310504392,1),(52804279,426084684,16389712,443749,1,'2007-09-17 00:57:40',3310504393,1),(52804292,426086123,16390919,443749,1,'2007-09-17 00:57:42',3310504393,1),(52804295,426087469,16391800,443749,1,'2007-09-17 00:57:44',3310504393,1),(52804297,426089046,16392264,443749,1,'2007-09-17 00:57:44',3310504393,1),(52804298,426091367,16392728,443749,1,'2007-09-17 00:57:44',3310504393,1),(52804299,426094383,16391986,443749,1,'2007-09-17 00:57:45',3310504393,1),(52804736,426096749,16390919,443749,1,'2007-09-17 00:58:41',3310504393,1),(52804739,426099301,16388923,443749,1,'2007-09-17 00:58:41',3310504393,1),(52804766,426100693,16388227,443749,1,'2007-09-17 00:58:45',3310504393,1),(52804772,426102039,16388320,443749,1,'2007-09-17 00:58:45',3310504393,1),(52804776,426103014,16387995,443749,1,'2007-09-17 00:58:45',3310504393,1),(52804777,426103478,16387253,443749,1,'2007-09-17 00:58:45',3310504393,1),(52804778,426103988,16386186,443749,1,'2007-09-17 00:58:45',3310504393,1),(52804779,426104823,16385954,443749,1,'2007-09-17 00:58:46',3310504393,1),(52804780,426106123,16386278,443749,1,'2007-09-17 00:58:46',3310504393,1),(52804788,426106865,16386186,443749,1,'2007-09-17 00:58:46',3310504393,1),(52804791,426110020,16385907,443749,1,'2007-09-17 00:58:46',3310504393,1),(52804795,426113547,16384469,443749,1,'2007-09-17 00:58:47',3310504396,1),(52804796,426117723,16382798,443749,1,'2007-09-17 00:58:47',3310504396,1),(52804798,426120368,16381128,443749,1,'2007-09-17 00:58:47',3310504396,1),(52804801,426122503,16378900,443749,1,'2007-09-17 00:58:47',3310504396,1),(52804803,426111784,16378761,443749,1,'2007-09-17 00:58:47',3310504396,1),(52804805,426120693,16378808,443749,1,'2007-09-17 00:58:47',3310504396,1),(52804807,426124962,16376441,443749,1,'2007-09-17 00:58:47',3310504396,1),(52804809,426127143,16374307,443749,1,'2007-09-17 00:58:47',3310504396,1),(52804811,426130995,16368506,443749,1,'2007-09-17 00:58:48',3310504390,1),(52804813,426133315,16365629,443749,1,'2007-09-17 00:58:48',3310504390,1),(52804815,426134985,16363031,443749,1,'2007-09-17 00:58:48',3310504390,1),(52812261,425835780,16632409,443749,1,'2007-09-17 01:24:20',3310504189,1),(52812263,425846183,16639219,443749,1,'2007-09-17 01:24:23',3310504360,1),(52812266,425852853,16644071,443749,1,'2007-09-17 01:24:32',3310504360,1),(52812268,425857238,16647103,443749,1,'2007-09-17 01:24:33',3310504362,1),(52812270,425859337,16648455,443749,1,'2007-09-17 01:25:31',3310504362,1),(52812274,425860457,16649108,443749,1,'2007-09-17 01:26:15',3310504362,1),(52812277,425861996,16649482,443749,1,'2007-09-17 01:26:39',3310504362,1),(52812281,425864235,16650135,443749,1,'2007-09-17 01:26:39',3310504363,1),(52812284,425866428,16651721,443749,1,'2007-09-17 01:26:48',3310504363,1),(52812288,425868527,16652794,443749,1,'2007-09-17 01:26:52',3310504363,1),(52812291,425870113,16653260,443749,1,'2007-09-17 01:26:59',3310504363,1),(52812295,425872072,16653680,443749,1,'2007-09-17 01:27:07',3310504363,1),(52812296,425875524,16654613,443749,1,'2007-09-17 01:27:15',3310504363,1),(52812299,425877343,16655639,443749,1,'2007-09-17 01:27:18',3310504363,1),(52812303,425879396,16657738,443749,1,'2007-09-17 01:27:19',3310504363,1),(52812305,425882474,16661610,443749,1,'2007-09-17 01:27:19',3310504363,1),(52812309,425883967,16663429,443749,1,'2007-09-17 01:27:20',3310504363,1),(52812311,425885273,16664689,443749,1,'2007-09-17 01:27:21',3310504363,1),(52812315,425887086,16665337,443749,1,'2007-09-17 01:27:22',3310504363,1),(52812318,425888772,16666368,443749,1,'2007-09-17 01:27:22',3310504363,1),(52812321,425889938,16667441,443749,1,'2007-09-17 01:27:23',3310504363,1),(52812323,425891477,16668281,443749,1,'2007-09-17 01:27:24',3310504363,1),(52812326,425893157,16669354,443749,1,'2007-09-17 01:27:24',3310504366,1),(52812329,425894463,16670940,443749,1,'2007-09-17 01:27:24',3310504366,1),(52812331,425896002,16672152,443749,1,'2007-09-17 01:27:24',3310504366,1),(52812333,425897168,16672992,443749,1,'2007-09-17 01:27:25',3310504366,1),(52812335,425898055,16675184,443749,1,'2007-09-17 01:27:25',3310504366,1),(52812338,425898614,16676071,443749,1,'2007-09-17 01:27:25',3310504366,1),(52812341,425900014,16677144,443749,1,'2007-09-17 01:27:25',3310504366,1),(52812343,425900854,16678310,443749,1,'2007-09-17 01:27:27',3310504366,1),(52812347,425901320,16679103,443749,1,'2007-09-17 01:27:29',3310504366,1),(52812350,425902393,16680502,443749,1,'2007-09-17 01:27:29',3310504366,1),(52812353,425903652,16681715,443749,1,'2007-09-17 01:27:29',3310504366,1),(52812356,425905145,16683021,443749,1,'2007-09-17 01:27:30',3310504366,1),(52812360,425906405,16684141,443749,1,'2007-09-17 01:27:30',3310504366,1),(52812363,425907897,16684934,443749,1,'2007-09-17 01:27:30',3310504366,1),(52812365,425909390,16686193,443749,1,'2007-09-17 01:27:31',3310504366,1),(52812366,425911209,16687873,443749,1,'2007-09-17 01:27:32',3310504366,1),(52812367,425913029,16689645,443749,1,'2007-09-17 01:27:32',3310504366,1),(52812369,425915547,16691371,443749,1,'2007-09-17 01:27:32',3310504366,1),(52812372,425916574,16693284,443749,1,'2007-09-17 01:27:33',3310504366,1),(52812376,425917413,16695056,443749,1,'2007-09-17 01:27:33',3310504366,1),(52812379,425918626,16697016,443749,1,'2007-09-17 01:27:33',3310504366,1),(52812380,425920492,16700561,443749,1,'2007-09-17 01:27:33',3310504709,1),(52812383,425922171,16703686,443749,1,'2007-09-17 01:27:33',3310504709,1),(52812385,425923384,16705505,443749,1,'2007-09-17 01:27:34',3310504709,1),(52812387,425924690,16706951,443749,1,'2007-09-17 01:27:34',3310504709,1),(52812389,425926043,16707884,443749,1,'2007-09-17 01:27:34',3310504709,1),(52812391,425927443,16709517,443749,1,'2007-09-17 01:27:34',3310504709,1),(52812395,425929822,16712736,443749,1,'2007-09-17 01:27:34',3310504709,1),(52812397,425932481,16716841,443749,1,'2007-09-17 01:27:35',3310504709,1),(52812399,425933740,16718473,443749,1,'2007-09-17 01:27:35',3310504709,1),(52812403,425935373,16720293,443749,1,'2007-09-17 01:27:36',3310504709,1),(52812405,425936819,16721412,443749,1,'2007-09-17 01:27:36',3310504709,1),(52812406,425938778,16722578,443749,1,'2007-09-17 01:27:37',3310504709,1),(52812407,425941903,16725237,443749,1,'2007-09-17 01:27:37',3310504709,1),(52812409,425945589,16729202,443749,1,'2007-09-17 01:27:37',3310504709,1),(52812410,425944226,16727392,443749,1,'2007-09-17 01:27:37',3310504709,1),(52812411,425948714,16732608,443749,1,'2007-09-17 01:27:37',3310504720,1),(52812413,425951326,16736153,443749,1,'2007-09-17 01:27:37',3310504720,1),(52812414,425952520,16737529,443749,1,'2007-09-17 01:27:38',3310504720,1),(52812415,425953280,16739193,443749,1,'2007-09-17 01:27:38',3310504720,1),(52812417,425953661,16740334,443749,1,'2007-09-17 01:27:38',3310504720,1),(52812418,425954707,16741523,443749,1,'2007-09-17 01:27:38',3310504720,1),(52812421,425957512,16743758,443749,1,'2007-09-17 01:27:38',3310504720,1),(52812425,425959651,16745612,443749,1,'2007-09-17 01:27:38',3310504720,1),(52812428,425961220,16747466,443749,1,'2007-09-17 01:27:38',3310504720,1),(52812440,425962551,16749748,443749,1,'2007-09-17 01:27:39',3310504720,1),(52812444,425963978,16751935,443749,1,'2007-09-17 01:27:39',3310504720,1),(52812447,425964929,16753694,443749,1,'2007-09-17 01:27:39',3310504720,1),(52812450,425966355,16755396,443749,1,'2007-09-17 01:11:58',3310504722,1),(52812453,425967971,16757916,443749,1,'2007-09-17 01:11:58',3310504722,1),(52812457,425969731,16760293,443749,1,'2007-09-17 01:11:58',3310504722,1),(52812460,425972393,16762575,443749,1,'2007-09-17 01:11:58',3310504722,1),(52812464,425974628,16764097,443749,1,'2007-09-17 01:11:58',3310504723,1),(52812468,425976767,16765475,443749,1,'2007-09-17 01:11:58',3310504723,1),(52812472,425978193,16766902,443749,1,'2007-09-17 01:11:59',3310504723,1),(52812475,425979131,16767382,443749,1,'2007-09-17 01:11:59',3310504723,1),(52812478,425980183,16767887,443749,1,'2007-09-17 01:11:59',3310504723,1),(52812481,425981193,16768097,443749,1,'2007-09-17 01:11:59',3310504723,1),(52812485,425981781,16768097,443749,1,'2007-09-17 01:11:59',3310504723,1),(52812487,425982034,16767803,443749,1,'2007-09-17 01:11:59',3310504723,1),(52812491,425981950,16767214,443749,1,'2007-09-17 01:12:00',3310504723,1),(52812494,425981655,16766120,443749,1,'2007-09-17 01:12:00',3310504723,1),(52812497,425980477,16763597,443749,1,'2007-09-17 01:12:00',3310504723,1),(52812501,425979258,16760274,443749,1,'2007-09-17 01:12:00',3310504723,1),(52812505,425978332,16758339,443749,1,'2007-09-17 01:12:00',3310504723,1),(52812507,425977112,16755689,443749,1,'2007-09-17 01:12:01',3310504723,1),(52812511,425976776,16754637,443749,1,'2007-09-17 01:12:01',3310504723,1),(52812514,425977112,16754048,443749,1,'2007-09-17 01:12:01',3310504721,1),(52812517,425977533,16754006,443749,1,'2007-09-17 01:12:01',3310504721,1),(52812520,425979089,16755520,443749,1,'2007-09-17 01:12:01',3310504723,1),(52812522,425988512,16762797,443749,1,'2007-09-17 01:12:02',3310504723,1),(52812526,425966765,16758423,443749,1,'2007-09-17 01:12:02',3310504722,1),(52812530,425968147,16761134,443749,1,'2007-09-17 01:12:03',3310504722,1),(52812531,425969437,16762765,443749,1,'2007-09-17 01:12:03',3310504722,1),(52812534,425971447,16764245,443749,1,'2007-09-17 01:12:03',3310504722,1),(52812536,425973306,16766293,443749,1,'2007-09-17 01:12:03',3310504722,1),(52812537,425975392,16769289,443749,1,'2007-09-17 01:12:03',3310504723,1),(52812540,425979109,16776762,443749,1,'2007-09-17 01:12:04',3310504723,1),(52812541,425981764,16782110,443749,1,'2007-09-17 01:12:04',3310504723,1),(52812543,425982826,16784082,443749,1,'2007-09-17 01:12:04',3310504723,1),(52812545,425983661,16786434,443749,1,'2007-09-17 01:12:04',3310504723,1),(52812547,425985140,16792541,443749,1,'2007-09-17 01:12:04',3310504723,1),(52812549,425986240,16796106,443749,1,'2007-09-17 01:12:04',3310504723,1),(52812551,425986771,16799444,443749,1,'2007-09-17 01:12:04',3310504723,1),(52812553,425987188,16801682,443749,1,'2007-09-17 01:12:05',3310504723,1),(52812555,425989919,16807447,443749,1,'2007-09-17 01:12:05',3310504723,1),(52812558,425992157,16812378,443749,1,'2007-09-17 01:12:05',3310504729,1),(52812562,425992764,16814958,443749,1,'2007-09-17 01:12:05',3310504729,1),(52812564,425995533,16820116,443749,1,'2007-09-17 01:12:06',3310504729,1),(52812566,426000919,16827209,443749,1,'2007-09-17 01:12:06',3310504729,1),(52812569,426004224,16831488,443749,1,'2007-09-17 01:12:06',3310504732,1),(52812572,426006496,16833577,443749,1,'2007-09-17 01:12:06',3310504732,1),(52812574,426008610,16834986,443749,1,'2007-09-17 01:12:06',3310504732,1),(52812577,426010321,16835943,443749,1,'2007-09-17 01:12:07',3310504732,1),(52812580,426011983,16837453,443749,1,'2007-09-17 01:12:07',3310504732,1),(52812582,426013191,16839768,443749,1,'2007-09-17 01:12:07',3310504732,1),(52812585,426016865,16850188,443749,1,'2007-09-17 01:12:07',3310504732,1),(52812587,426019080,16856480,443749,1,'2007-09-17 01:12:07',3310504732,1),(52812590,426020641,16860643,443749,1,'2007-09-17 01:12:08',3310504732,1),(52812592,426021161,16862759,443749,1,'2007-09-17 01:12:08',3310504732,1),(52812595,426021124,16865060,443749,1,'2007-09-17 01:12:08',3310504734,1),(52812597,426020753,16869736,443749,1,'2007-09-17 01:12:08',3310504734,1),(52812598,426020217,16871115,443749,1,'2007-09-17 01:12:08',3310504734,1),(52818308,425907748,16657043,443749,1,'2007-09-17 01:20:30',3310504366,1),(52818311,425906088,16656779,443749,1,'2007-09-17 01:20:30',3310504366,1),(52818312,425903975,16655534,443749,1,'2007-09-17 01:20:30',3310504366,1),(52818315,425902693,16654063,443749,1,'2007-09-17 01:20:31',3310504366,1),(52818317,425901976,16653837,443749,1,'2007-09-17 01:20:31',3310504366,1),(52818320,425901335,16654327,443749,1,'2007-09-17 01:20:31',3310504366,1),(52818322,425900165,16655006,443749,1,'2007-09-17 01:20:31',3310504366,1),(52818324,425899185,16655496,443749,1,'2007-09-17 01:20:31',3310504366,1),(52818326,425898204,16656100,443749,1,'2007-09-17 01:20:31',3310504366,1),(52818330,425897902,16656175,443749,1,'2007-09-17 01:20:32',3310504366,1),(52818332,425896959,16656175,443749,1,'2007-09-17 01:20:32',3310504366,1),(52818334,425896318,16656930,443749,1,'2007-09-17 01:20:32',3310504366,1),(52818337,425895903,16657496,443749,1,'2007-09-17 01:20:32',3310504366,1),(52818340,425895224,16658288,443749,1,'2007-09-17 01:20:32',3310504366,1),(52818343,425894054,16659306,443749,1,'2007-09-17 01:20:32',3310504366,1),(52818346,425893111,16660325,443749,1,'2007-09-17 01:20:33',3310504366,1),(52818348,425892319,16661192,443749,1,'2007-09-17 01:20:33',3310504366,1),(52818350,425890358,16661381,443749,1,'2007-09-17 01:20:33',3310504363,1),(52818352,425889528,16661758,443749,1,'2007-09-17 01:20:33',3310504363,1),(52818355,425828906,16634379,443749,1,'2007-09-17 01:20:33',3310504189,1),(52818358,425831329,16634825,443749,1,'2007-09-17 01:20:33',3310504189,1),(52818362,425834008,16636101,443749,1,'2007-09-17 01:20:34',3310504189,1),(52818365,425836177,16636483,443749,1,'2007-09-17 01:20:34',3310504189,1),(52818368,425837516,16637504,443749,1,'2007-09-17 01:20:34',3310504360,1),(52818370,425839748,16639991,443749,1,'2007-09-17 01:20:34',3310504360,1),(52818373,425841598,16643180,443749,1,'2007-09-17 01:20:34',3310504360,1),(52818377,425842746,16645285,443749,1,'2007-09-17 01:20:35',3310504362,1),(52818379,425843511,16647389,443749,1,'2007-09-17 01:20:35',3310504362,1),(52818382,425844723,16648984,443749,1,'2007-09-17 01:20:35',3310504362,1),(52818384,425845999,16649686,443749,1,'2007-09-17 01:20:35',3310504362,1),(52818385,425847274,16649749,443749,1,'2007-09-17 01:20:35',3310504362,1),(52818387,425848550,16649558,443749,1,'2007-09-17 01:20:35',3310504362,1),(52818389,425850335,16648601,443749,1,'2007-09-17 01:20:36',3310504362,1);
INSERT INTO `nodes` VALUES (52818390,425852440,16648027,443749,1,'2007-09-17 01:20:36',3310504362,1),(52818391,425854991,16648282,443749,1,'2007-09-17 01:20:36',3310504362,1),(52818392,425856713,16648729,443749,1,'2007-09-17 01:20:36',3310504362,1),(52818393,425857415,16650323,443749,1,'2007-09-17 01:20:36',3310504362,1),(52818394,425858627,16652938,443749,1,'2007-09-17 01:20:36',3310504362,1),(52818396,425859839,16655808,443749,1,'2007-09-17 01:20:36',3310504362,1),(52818397,425860540,16656829,443749,1,'2007-09-17 01:20:36',3310504362,1),(52818398,425861816,16658423,443749,1,'2007-09-17 01:20:37',3310504362,1),(52818399,425863857,16658933,443749,1,'2007-09-17 01:20:37',3310504362,1),(52818402,425865961,16660081,443749,1,'2007-09-17 01:20:37',3310504363,1),(52818404,425867492,16662122,443749,1,'2007-09-17 01:20:37',3310504363,1),(52818405,425869150,16664227,443749,1,'2007-09-17 01:20:37',3310504363,1),(52818406,425871446,16666714,443749,1,'2007-09-17 01:20:37',3310504363,1),(52818407,425872658,16668054,443749,1,'2007-09-17 01:20:37',3310504363,1),(52818409,425874061,16668437,443749,1,'2007-09-17 01:20:37',3310504363,1),(52818413,425875337,16668437,443749,1,'2007-09-17 01:20:38',3310504363,1),(52818415,425877123,16668883,443749,1,'2007-09-17 01:20:38',3310504363,1),(52818417,425878972,16670605,443749,1,'2007-09-17 01:20:38',3310504363,1),(52818420,425880120,16671434,443749,1,'2007-09-17 01:20:38',3310504363,1),(52818424,425880758,16673092,443749,1,'2007-09-17 01:20:38',3310504363,1),(52818427,425882289,16675006,443749,1,'2007-09-17 01:20:38',3310504363,1),(52818428,425885414,16677110,443749,1,'2007-09-17 01:20:39',3310504363,1),(52818432,425887837,16679024,443749,1,'2007-09-17 01:20:39',3310504363,1),(52818434,425889304,16681511,443749,1,'2007-09-17 01:20:39',3310504363,1),(52818437,425890771,16683807,443749,1,'2007-09-17 01:20:39',3310504363,1),(52818440,425892812,16686486,443749,1,'2007-09-17 01:20:39',3310504366,1),(52818441,425895108,16687953,443749,1,'2007-09-17 01:20:39',3310504366,1),(52818445,425897277,16688654,443749,1,'2007-09-17 01:20:40',3310504366,1),(52818446,425898807,16689994,443749,1,'2007-09-17 01:20:40',3310504366,1),(52818448,425899509,16690823,443749,1,'2007-09-17 01:20:40',3310504366,1),(52818450,425900912,16690823,443749,1,'2007-09-17 01:20:40',3310504366,1),(52818451,425902315,16690695,443749,1,'2007-09-17 01:20:40',3310504366,1),(52818452,425903846,16690695,443749,1,'2007-09-17 01:20:40',3310504366,1),(52818453,425905504,16691397,443749,1,'2007-09-17 01:20:40',3310504366,1),(52818454,425906461,16692417,443749,1,'2007-09-17 01:20:40',3310504366,1),(52818455,425907481,16694267,443749,1,'2007-09-17 01:20:41',3310504366,1),(52818456,425907992,16695606,443749,1,'2007-09-17 01:20:41',3310504366,1),(52818457,425908629,16696244,443749,1,'2007-09-17 01:20:41',3310504366,1),(52818458,425909905,16697328,443749,1,'2007-09-17 01:20:41',3310504366,1),(52818461,425911117,16698795,443749,1,'2007-09-17 01:20:41',3310504366,1),(52818463,425911882,16701665,443749,1,'2007-09-17 01:20:41',3310504708,1),(52818465,425912775,16706257,443749,1,'2007-09-17 01:20:41',3310504708,1),(52818470,425913221,16711041,443749,1,'2007-09-17 01:20:42',3310504708,1),(52818472,425913859,16712699,443749,1,'2007-09-17 01:20:42',3310504708,1),(52818475,425915581,16714995,443749,1,'2007-09-17 01:20:42',3310504708,1),(52818478,425916857,16716909,443749,1,'2007-09-17 01:20:42',3310504708,1),(52818479,425918005,16718567,443749,1,'2007-09-17 01:20:42',3310504708,1),(52818483,425918898,16720225,443749,1,'2007-09-17 01:20:42',3310504708,1),(52818485,425919663,16722585,443749,1,'2007-09-17 01:20:43',3310504709,1),(52818487,425921640,16723095,443749,1,'2007-09-17 01:20:43',3310504709,1),(52818489,425922023,16723478,443749,1,'2007-09-17 01:20:43',3310504709,1),(52818490,425924319,16726220,443749,1,'2007-09-17 01:20:43',3310504709,1),(52818491,425926551,16729409,443749,1,'2007-09-17 01:20:43',3310504709,1),(52818493,425929294,16731705,443749,1,'2007-09-17 01:20:43',3310504709,1),(52818495,425931016,16732215,443749,1,'2007-09-17 01:20:43',3310504709,1),(52818498,425931972,16732407,443749,1,'2007-09-17 01:20:44',3310504709,1),(52818501,425933121,16733363,443749,1,'2007-09-17 01:20:44',3310504709,1),(52818503,425935991,16737126,443749,1,'2007-09-17 01:20:44',3310504709,1),(52818505,425937649,16739486,443749,1,'2007-09-17 01:20:44',3310504709,1),(52818508,425938414,16740443,443749,1,'2007-09-17 01:20:44',3310504709,1),(52818511,425941157,16742293,443749,1,'2007-09-17 01:20:45',3310504709,1),(52818514,425943708,16744206,443749,1,'2007-09-17 01:20:45',3310504709,1),(52818516,425945302,16745418,443749,1,'2007-09-17 01:20:45',3310504709,1),(52818518,425946961,16745673,443749,1,'2007-09-17 01:20:45',3310504720,1),(52818520,425947790,16745418,443749,1,'2007-09-17 01:20:45',3310504720,1),(52818522,425949257,16745673,443749,1,'2007-09-17 01:20:45',3310504720,1),(52818524,425950341,16746374,443749,1,'2007-09-17 01:20:45',3310504720,1),(52818527,425951616,16748352,443749,1,'2007-09-17 01:20:45',3310504720,1),(52818529,425952382,16749117,443749,1,'2007-09-17 01:20:45',3310504720,1),(52818533,425952892,16750010,443749,1,'2007-09-17 01:20:45',3310504720,1),(52818536,425954550,16749500,443749,1,'2007-09-17 01:20:46',3310504720,1),(52818538,425956017,16748670,443749,1,'2007-09-17 01:20:46',3310504720,1),(52818539,425956719,16749181,443749,1,'2007-09-17 01:20:46',3310504720,1),(52818542,425957675,16750711,443749,1,'2007-09-17 01:20:46',3310504720,1),(52818550,425958696,16753071,443749,1,'2007-09-17 01:20:46',3310504720,1),(52818553,425958760,16754921,443749,1,'2007-09-17 01:20:46',3310504722,1),(52818555,425958823,16756388,443749,1,'2007-09-17 01:20:47',3310504722,1),(52818557,425959142,16758556,443749,1,'2007-09-17 01:20:47',3310504722,1),(52818561,425959971,16759704,443749,1,'2007-09-17 01:20:47',3310504722,1),(52818563,425961375,16760725,443749,1,'2007-09-17 01:20:47',3310504722,1),(52818564,425962012,16761809,443749,1,'2007-09-17 01:20:47',3310504722,1),(52818566,425963160,16764934,443749,1,'2007-09-17 01:20:47',3310504722,1),(52818567,425963288,16766592,443749,1,'2007-09-17 01:20:47',3310504722,1),(52818569,425963097,16767549,443749,1,'2007-09-17 01:20:47',3310504722,1),(52818572,425962841,16769271,443749,1,'2007-09-17 01:20:47',3310504722,1),(52818574,425963224,16771121,443749,1,'2007-09-17 01:20:48',3310504722,1),(52818577,425963671,16772779,443749,1,'2007-09-17 01:20:48',3310504722,1),(52818581,425964691,16774437,443749,1,'2007-09-17 01:20:48',3310504722,1),(52818582,425966222,16775458,443749,1,'2007-09-17 01:20:48',3310504722,1),(52818585,425967816,16776287,443749,1,'2007-09-17 01:20:48',3310504722,1),(52818587,425968645,16776287,443749,1,'2007-09-17 01:20:48',3310504722,1),(52818590,425969411,16776924,443749,1,'2007-09-17 01:20:49',3310504722,1),(52818592,425970304,16777562,443749,1,'2007-09-17 01:20:49',3310504722,1),(52818594,425970750,16777562,443749,1,'2007-09-17 01:20:49',3310504722,1),(52818598,425971452,16777116,443749,1,'2007-09-17 01:20:49',3310504722,1),(52818600,425972153,16777116,443749,1,'2007-09-17 01:20:50',3310504722,1),(52818603,425972982,16777945,443749,1,'2007-09-17 01:20:50',3310504722,1),(52818605,425973301,16779093,443749,1,'2007-09-17 01:20:50',3310504722,1),(52818609,425973237,16779858,443749,1,'2007-09-17 01:20:50',3310504722,1),(52818612,425973237,16781389,443749,1,'2007-09-17 01:20:51',3310504722,1),(52818615,425972345,16783621,443749,1,'2007-09-17 01:20:51',3310504722,1),(52818618,425971515,16785280,443749,1,'2007-09-17 01:20:51',3310504722,1),(52818620,425971260,16786746,443749,1,'2007-09-17 01:20:51',3310504722,1),(52818622,425971707,16789106,443749,1,'2007-09-17 01:20:51',3310504722,1),(52818623,425971643,16790190,443749,1,'2007-09-17 01:20:51',3310504722,1),(52818627,425971771,16791020,443749,1,'2007-09-17 01:20:52',3310504722,1),(52818629,425972472,16791339,443749,1,'2007-09-17 01:20:52',3310504722,1),(52818631,425972982,16792040,443749,1,'2007-09-17 01:20:52',3310504722,1),(52818633,425973237,16793507,443749,1,'2007-09-17 01:20:52',3310504722,1),(52818635,425973046,16795420,443749,1,'2007-09-17 01:20:52',3310504722,1),(52818636,425972855,16796696,443749,1,'2007-09-17 01:20:53',3310504722,1),(52818639,425972536,16798035,443749,1,'2007-09-17 01:20:53',3310504722,1),(52818641,425973110,16799757,443749,1,'2007-09-17 01:20:53',3310504722,1),(52818642,425974194,16801926,443749,1,'2007-09-17 01:20:53',3310504723,1),(52818644,425974513,16802946,443749,1,'2007-09-17 01:20:53',3310504723,1),(52818647,425975597,16804031,443749,1,'2007-09-17 01:20:54',3310504723,1),(52818648,425976618,16804605,443749,1,'2007-09-17 01:20:54',3310504723,1),(52818651,425977574,16805625,443749,1,'2007-09-17 01:20:54',3310504723,1),(52818652,425979041,16808176,443749,1,'2007-09-17 01:20:54',3310504723,1),(52818655,425980253,16810919,443749,1,'2007-09-17 01:20:54',3310504729,1),(52818657,425980827,16812386,443749,1,'2007-09-17 01:20:54',3310504729,1),(52818659,425981656,16813916,443749,1,'2007-09-17 01:20:54',3310504729,1),(52818661,425983442,16817360,443749,1,'2007-09-17 01:20:54',3310504729,1),(52818663,425983570,16818636,443749,1,'2007-09-17 01:20:55',3310504729,1),(52818669,425984016,16819529,443749,1,'2007-09-17 01:20:56',3310504729,1),(52818671,425985228,16821059,443749,1,'2007-09-17 01:20:56',3310504729,1),(52818673,425986312,16822271,443749,1,'2007-09-17 01:20:56',3310504729,1),(52818675,425987269,16822335,443749,1,'2007-09-17 01:20:56',3310504729,1),(52818677,425988736,16822016,443749,1,'2007-09-17 01:20:56',3310504729,1),(52818679,425989820,16822782,443749,1,'2007-09-17 01:20:56',3310504729,1),(52818681,425990777,16823930,443749,1,'2007-09-17 01:20:56',3310504729,1),(52818685,425992558,16826246,443749,1,'2007-09-17 01:20:57',3310504729,1),(52818687,425994236,16828402,443749,1,'2007-09-17 01:20:57',3310504729,1),(52818690,425995354,16831038,443749,1,'2007-09-17 01:20:57',3310504729,1),(52818692,425997111,16833674,443749,1,'2007-09-17 01:20:57',3310504729,1),(52818694,425998709,16835272,443749,1,'2007-09-17 01:20:58',3310504729,1),(52818720,425999827,16837029,443749,1,'2007-09-17 01:21:00',3310504729,1),(52818722,426000227,16838946,443749,1,'2007-09-17 01:21:00',3310504729,1),(52818724,425999588,16841502,443749,1,'2007-09-17 01:21:01',3310504729,1),(52818727,425999907,16842461,443749,1,'2007-09-17 01:21:01',3310504729,1),(52818729,426001585,16843499,443749,1,'2007-09-17 01:21:01',3310504732,1),(52818731,426003182,16845097,443749,1,'2007-09-17 01:21:01',3310504732,1),(52818733,426004460,16846055,443749,1,'2007-09-17 01:21:01',3310504732,1),(52818747,426005419,16847972,443749,1,'2007-09-17 01:21:03',3310504732,1),(52818757,426006377,16849410,443749,1,'2007-09-17 01:21:06',3310504732,1),(52818771,426008294,16851487,443749,1,'2007-09-17 01:21:08',3310504732,1),(52818775,426009253,16852286,443749,1,'2007-09-17 01:21:11',3310504732,1),(52818781,426010211,16853803,443749,1,'2007-09-17 01:21:11',3310504732,1),(52818791,426012608,16855880,443749,1,'2007-09-17 01:21:13',3310504732,1),(52818794,426014365,16857877,443749,1,'2007-09-17 01:21:13',3310504732,1),(52818796,426016122,16859315,443749,1,'2007-09-17 01:21:14',3310504732,1),(52818800,426017241,16860593,443749,1,'2007-09-17 01:21:14',3310504732,1),(52818803,426018598,16862830,443749,1,'2007-09-17 01:21:14',3310504732,1),(52818808,426018838,16865945,443749,1,'2007-09-17 01:21:14',3310504734,1),(52818809,426019477,16868980,443749,1,'2007-09-17 01:21:14',3310504734,1),(52818810,426020356,16872335,443749,1,'2007-09-17 01:21:15',3310504734,1),(52818812,426020356,16873453,443749,1,'2007-09-17 01:21:15',3310504734,1),(52818813,426020436,16874891,443749,1,'2007-09-17 01:21:15',3310504734,1),(52818824,426019557,16877527,443749,1,'2007-09-17 01:21:16',3310504734,1),(52818840,426018678,16879125,443749,1,'2007-09-17 01:21:18',3310504734,1),(52818846,426018279,16880483,443749,1,'2007-09-17 01:21:20',3310504734,1),(52818850,426018838,16882639,443749,1,'2007-09-17 01:21:20',3310504734,1),(52818853,426018918,16884397,443749,1,'2007-09-17 01:21:20',3310504734,1),(52818857,426018918,16885595,443749,1,'2007-09-17 01:21:20',3310504734,1),(52818862,426017400,16887671,443749,1,'2007-09-17 01:21:21',3310504734,1),(52818864,426015963,16889349,443749,1,'2007-09-17 01:21:21',3310504734,1),(52818867,426015643,16890228,443749,1,'2007-09-17 01:21:21',3310504734,1),(52818870,426032337,16875770,443749,1,'2007-09-17 01:21:21',3310504735,1),(52818872,426030261,16874332,443749,1,'2007-09-17 01:21:21',3310504735,1),(52818874,426028903,16873773,443749,1,'2007-09-17 01:21:21',3310504735,1),(52818876,426027066,16872655,443749,1,'2007-09-17 01:21:22',3310504734,1),(52818878,426025388,16872415,443749,1,'2007-09-17 01:21:22',3310504734,1),(52818879,426023711,16872415,443749,1,'2007-09-17 01:21:22',3310504734,1),(52818881,426022193,16873134,443749,1,'2007-09-17 01:21:22',3310504734,1),(52818884,426021794,16873134,443749,1,'2007-09-17 01:21:22',3310504734,1),(52824397,425782274,16586279,443749,1,'2007-09-17 01:31:57',3310504182,1),(52824401,425782950,16590169,443749,1,'2007-09-17 01:31:57',3310504188,1),(52824404,425784304,16594821,443749,1,'2007-09-17 01:31:58',3310504188,1),(52824407,425785488,16598119,443749,1,'2007-09-17 01:31:58',3310504188,1),(52824410,425787433,16603616,443749,1,'2007-09-17 01:31:58',3310504188,1),(52824414,425788701,16606576,443749,1,'2007-09-17 01:31:58',3310504188,1),(52824418,425790816,16610297,443749,1,'2007-09-17 01:31:58',3310504188,1),(52824420,425793014,16613596,443749,1,'2007-09-17 01:31:58',3310504188,1),(52824423,425794283,16617486,443749,1,'2007-09-17 01:31:59',3310504188,1),(52824433,425794706,16620700,443749,1,'2007-09-17 01:31:59',3310504188,1),(52824446,425793606,16621799,443749,1,'2007-09-17 01:32:00',3310504188,1),(52824449,425792338,16621884,443749,1,'2007-09-17 01:32:00',3310504188,1),(52824464,425791154,16621123,443749,1,'2007-09-17 01:32:01',3310504188,1),(52824474,425787771,16617571,443749,1,'2007-09-17 01:32:03',3310504188,1),(52824478,425784388,16612581,443749,1,'2007-09-17 01:32:03',3310504188,1),(52824483,425782950,16610805,443749,1,'2007-09-17 01:32:03',3310504188,1),(52824486,425781936,16610805,443749,1,'2007-09-17 01:32:04',3310504188,1),(52824489,425782189,16612412,443749,1,'2007-09-17 01:32:04',3310504188,1),(52824491,425783373,16616217,443749,1,'2007-09-17 01:32:04',3310504188,1),(52824494,425786925,16626197,443749,1,'2007-09-17 01:32:04',3310504188,1),(52824496,425788786,16630595,443749,1,'2007-09-17 01:32:04',3310504188,1),(52824499,425792253,16633385,443749,1,'2007-09-17 01:32:05',3310504188,1),(52824502,425794790,16634569,443749,1,'2007-09-17 01:32:05',3310504188,1),(52824509,425796651,16636261,443749,1,'2007-09-17 01:32:05',3310504188,1),(52824529,425801298,16633436,443749,1,'2007-09-17 01:32:07',3310504188,1),(52824530,425800798,16634623,443749,1,'2007-09-17 01:32:07',3310504188,1),(52824533,425801735,16635810,443749,1,'2007-09-17 01:32:08',3310504188,1),(52824535,425806171,16638933,443749,1,'2007-09-17 01:32:08',3310504188,1),(52824538,425809357,16640807,443749,1,'2007-09-17 01:32:08',3310504189,1),(52824541,425812356,16641807,443749,1,'2007-09-17 01:32:08',3310504189,1),(52824544,425812668,16642994,443749,1,'2007-09-17 01:32:08',3310504189,1),(52824546,425833097,16637684,443749,1,'2007-09-17 01:32:08',3310504189,1),(52824548,425831410,16638371,443749,1,'2007-09-17 01:32:09',3310504189,1),(52824552,425829036,16638933,443749,1,'2007-09-17 01:32:09',3310504189,1),(52824553,425825975,16638308,443749,1,'2007-09-17 01:32:09',3310504189,1),(52824558,425823038,16637496,443749,1,'2007-09-17 01:32:09',3310504189,1),(52824561,425820602,16637434,443749,1,'2007-09-17 01:32:09',3310504189,1),(52824564,425819103,16637559,443749,1,'2007-09-17 01:32:10',3310504189,1),(52824567,425818166,16638246,443749,1,'2007-09-17 01:32:10',3310504189,1),(52824569,425817875,16639371,443749,1,'2007-09-17 01:32:10',3310504189,1),(52824574,425818185,16640681,443749,1,'2007-09-17 01:32:10',3310504189,1),(52824576,425819415,16641807,443749,1,'2007-09-17 01:32:10',3310504189,1),(52824579,425821414,16641620,443749,1,'2007-09-17 01:32:11',3310504189,1),(52824581,425822726,16641994,443749,1,'2007-09-17 01:32:11',3310504189,1),(52824584,425823288,16642557,443749,1,'2007-09-17 01:32:11',3310504189,1),(52824586,425823538,16644431,443749,1,'2007-09-17 01:32:11',3310504189,1),(52824949,425821820,16614477,443749,1,'2007-09-17 01:32:57',3310504189,1),(52824952,425825633,16618364,443749,1,'2007-09-17 01:33:02',3310504189,1),(52824953,425828399,16621654,443749,1,'2007-09-17 01:33:02',3310504189,1),(52824954,425829296,16623074,443749,1,'2007-09-17 01:33:02',3310504189,1),(52824955,425829446,16624270,443749,1,'2007-09-17 01:33:02',3310504189,1),(52831541,425805830,16484201,443749,1,'2007-09-17 01:44:29',3310504180,1),(52831545,425804851,16486142,443749,1,'2007-09-17 01:44:29',3310504180,1),(52831548,425803769,16487167,443749,1,'2007-09-17 01:44:29',3310504180,1),(52831550,425803264,16488461,443749,1,'2007-09-17 01:44:29',3310504180,1),(52831552,425802976,16490201,443749,1,'2007-09-17 01:44:30',3310504180,1),(52831554,425802626,16491397,443749,1,'2007-09-17 01:44:30',3310504180,1),(52831559,425800133,16493970,443749,1,'2007-09-17 01:44:30',3310504180,1),(52831563,425797380,16495974,495907,1,'2008-07-15 19:52:54',3310504180,2),(52831566,425795294,16497090,495907,1,'2008-07-15 19:52:54',3310504180,2),(52831569,425794727,16499552,443749,1,'2007-09-17 01:44:31',3310504180,1),(52831574,425799301,16499704,443749,1,'2007-09-17 01:44:31',3310504180,1),(52831577,425797700,16500162,443749,1,'2007-09-17 01:44:31',3310504180,1),(52831582,425796137,16500009,443749,1,'2007-09-17 01:44:31',3310504180,1),(52831585,425794651,16499590,443749,1,'2007-09-17 01:44:32',3310504180,1),(52831588,425793279,16499743,443749,1,'2007-09-17 01:44:32',3310504180,1),(52831590,425791944,16500619,443749,1,'2007-09-17 01:44:32',3310504180,1),(52831593,425791068,16501915,443749,1,'2007-09-17 01:44:32',3310504180,1),(52831595,425790877,16504088,443749,1,'2007-09-17 01:44:32',3310504180,1),(52831598,425791144,16507061,443749,1,'2007-09-17 01:44:32',3310504180,1),(52831601,425791868,16509577,443749,1,'2007-09-17 01:44:33',3310504180,1),(52831603,425793279,16515028,443749,1,'2007-09-17 01:44:33',3310504180,1),(52831605,425803723,16504821,370566,1,'2008-05-09 02:14:21',3310504180,2),(52831608,425802122,16504889,443749,1,'2007-09-17 01:44:33',3310504180,1),(52831611,425800636,16505346,443749,1,'2007-09-17 01:44:33',3310504180,1),(52831613,425799035,16506566,443749,1,'2007-09-17 01:44:33',3310504180,1),(52831614,425797700,16507824,443749,1,'2007-09-17 01:44:33',3310504180,1),(52831615,425797662,16508586,443749,1,'2007-09-17 01:44:34',3310504180,1),(52831616,425794803,16508510,443749,1,'2007-09-17 01:44:34',3310504180,1),(52831617,425792859,16508815,443749,1,'2007-09-17 01:44:34',3310504180,1),(52831618,425802160,16509920,370566,1,'2008-05-09 02:14:22',3310504180,2),(52831619,425801055,16509920,443749,1,'2007-09-17 01:44:34',3310504180,1),(52831620,425799187,16509997,370566,1,'2008-05-09 02:14:22',3310504180,3),(52831621,425798120,16509425,443749,1,'2007-09-17 01:44:34',3310504180,1),(52831625,425798348,16511598,370566,1,'2008-05-09 02:14:22',3310504180,3),(52831627,425797281,16512741,370566,1,'2008-05-09 02:14:22',3310504180,3),(52831630,425796214,16513161,370566,1,'2008-05-09 02:14:22',3310504180,3),(52831633,425794193,16512779,370566,1,'2008-05-09 02:14:22',3310504180,3),(52831636,425793317,16512779,370566,1,'2008-05-09 02:14:22',3310504180,3),(52831638,425793088,16513008,370566,1,'2008-05-09 02:14:22',3310504180,3),(52831641,425791068,16505994,443749,1,'2007-09-17 01:44:35',3310504180,1),(52831644,425801857,16492333,370566,1,'2008-05-09 02:14:22',3310504180,2),(52832041,425802673,16493319,443749,1,'2007-09-17 01:45:34',3310504180,1),(52832042,425802780,16494282,443749,1,'2007-09-17 01:45:34',3310504180,1),(52832043,425802032,16496046,443749,1,'2007-09-17 01:45:34',3310504180,1),(52832044,425801497,16498131,443749,1,'2007-09-17 01:45:34',3310504180,1),(52832045,425801626,16499094,370566,1,'2008-05-09 02:14:21',3310504180,2),(52832046,425802249,16500488,443749,1,'2007-09-17 01:45:35',3310504180,1),(52832047,425803234,16501638,443749,1,'2007-09-17 01:45:35',3310504180,1),(52832471,425803891,16503280,443749,1,'2007-09-17 01:46:22',3310504180,1),(52834371,425801619,16512203,538211,1,'2007-09-30 15:36:21',3310504180,1),(52834531,425800661,16514365,443749,1,'2007-09-17 01:50:50',3310504180,1),(52834678,425798335,16516768,443749,1,'2007-09-17 01:51:08',3310504180,1),(52834735,425796088,16519448,443749,1,'2007-09-17 01:51:13',3310504180,1),(52834737,425794748,16522247,443749,1,'2007-09-17 01:51:13',3310504180,1),(52834749,425793217,16527324,443749,1,'2007-09-17 01:51:15',3310504180,1),(52834758,425792193,16533410,443749,1,'2007-09-17 01:51:15',3310504180,1),(52834763,425790264,16545461,443749,1,'2007-09-17 01:51:16',3310504182,1),(52834768,425789722,16549197,443749,1,'2007-09-17 01:51:17',3310504182,1),(52834775,425789722,16550522,443749,1,'2007-09-17 01:51:17',3310504182,1),(52834778,425790084,16551306,443749,1,'2007-09-17 01:51:18',3310504182,1),(52834779,425790807,16551607,443749,1,'2007-09-17 01:51:18',3310504182,1),(52834783,425791349,16551426,443749,1,'2007-09-17 01:51:19',3310504182,1),(52834784,425792193,16550402,443749,1,'2007-09-17 01:51:19',3310504182,1),(52834785,425794181,16546304,443749,1,'2007-09-17 01:51:19',3310504182,1),(52834786,425795928,16541725,443749,1,'2007-09-17 01:51:19',3310504182,1),(52834787,425796953,16537507,443749,1,'2007-09-17 01:51:19',3310504182,1),(52834788,425798158,16530638,443749,1,'2007-09-17 01:51:19',3310504180,1),(52834790,425799062,16527746,443749,1,'2007-09-17 01:51:20',3310504180,1),(52834792,425801291,16524130,443749,1,'2007-09-17 01:51:20',3310504180,1),(52834794,425804485,16520455,443749,1,'2007-09-17 01:51:20',3310504180,1),(52834795,425806112,16518587,443749,1,'2007-09-17 01:51:20',3310504180,1),(52834797,425807678,16516417,443749,1,'2007-09-17 01:51:20',3310504180,1),(52834799,425808763,16513224,443749,1,'2007-09-17 01:51:20',3310504180,1),(52834802,425808823,16509729,443749,1,'2007-09-17 01:51:20',3310504180,1),(52834805,425808703,16504366,443749,1,'2007-09-17 01:51:20',3310504180,1),(52834808,425808763,16500510,443749,1,'2007-09-17 01:51:21',3310504180,1),(52834811,425809607,16498100,443749,1,'2007-09-17 01:51:21',3310504181,1),(52834813,425810390,16497136,443749,1,'2007-09-17 01:51:21',3310504181,1),(52834816,425811113,16497196,443749,1,'2007-09-17 01:51:21',3310504181,1),(52834819,425811716,16498461,443749,1,'2007-09-17 01:51:21',3310504181,1),(52834822,425811716,16501173,443749,1,'2007-09-17 01:51:21',3310504181,1),(52834825,425812017,16515453,443749,1,'2007-09-17 01:51:21',3310504181,1),(52835977,425812017,16520394,443749,1,'2007-09-17 01:53:29',3310504181,1),(52835980,425810812,16524612,443749,1,'2007-09-17 01:53:29',3310504181,1),(52835984,425809607,16526239,443749,1,'2007-09-17 01:53:29',3310504181,1),(52835987,425807678,16529252,443749,1,'2007-09-17 01:53:29',3310504180,1),(52836001,425806172,16530578,443749,1,'2007-09-17 01:53:30',3310504180,1),(52836004,425804726,16532385,443749,1,'2007-09-17 01:53:30',3310504180,1),(52836007,425804123,16534374,443749,1,'2007-09-17 01:53:30',3310504180,1),(52836010,425805148,16537989,443749,1,'2007-09-17 01:53:31',3310504182,1),(52836012,425806112,16537869,443749,1,'2007-09-17 01:53:31',3310504182,1),(52836016,425808341,16536784,443749,1,'2007-09-17 01:53:31',3310504182,1),(52836020,425809607,16533590,443749,1,'2007-09-17 01:53:31',3310504181,1),(52836023,425792367,16532113,443749,1,'2007-09-17 01:53:31',3310504180,1),(52836027,425793699,16534169,443749,1,'2007-09-17 01:53:31',3310504180,1),(52836030,425794277,16535519,443749,1,'2007-09-17 01:53:32',3310504182,1),(52836034,425793892,16538748,443749,1,'2007-09-17 01:53:32',3310504182,1),(52836036,425792814,16545962,443749,1,'2007-09-17 01:53:32',3310504182,1),(52836038,425792526,16547091,443749,1,'2007-09-17 01:53:32',3310504182,1),(52836042,425792638,16530457,443749,1,'2007-09-17 01:53:32',3310504180,1),(52836044,425790469,16529879,443749,1,'2007-09-17 01:53:32',3310504180,1),(52836048,425787770,16529782,443749,1,'2007-09-17 01:53:33',3310504180,1),(52836052,425785697,16529879,443749,1,'2007-09-17 01:53:33',3310504180,1),(52836056,425782708,16532144,443749,1,'2007-09-17 01:53:33',3310504180,1),(52836058,425780202,16535519,443749,1,'2007-09-17 01:53:33',3310504179,1),(52836061,425779141,16538652,443749,1,'2007-09-17 01:53:34',3310504179,1),(52836065,425777743,16538748,443749,1,'2007-09-17 01:53:34',3310504179,1),(52836069,425790116,16546481,443749,1,'2007-09-17 01:53:34',3310504182,1),(52836073,425793594,16547514,443749,1,'2007-09-17 01:53:34',3310504182,1),(53273667,425642165,16780934,454632,1,'2007-09-17 18:04:32',3310504514,1),(53273668,425645963,16780340,454632,1,'2007-09-17 18:04:33',3310504515,1),(53273669,425649881,16781646,454632,1,'2007-09-17 18:04:33',3310504515,1),(53273670,425652730,16783308,454632,1,'2007-09-17 18:04:33',3310504515,1),(53273671,425655579,16783902,454632,1,'2007-09-17 18:04:34',3310504515,1),(53273672,425658547,16783545,454632,1,'2007-09-17 18:04:34',3310504515,1),(53273673,425661159,16781646,454632,1,'2007-09-17 18:04:34',3310504515,1),(53273674,425662465,16779509,454632,1,'2007-09-17 18:04:34',3310504515,1),(53273675,425662346,16776897,454632,1,'2007-09-17 18:04:35',3310504515,1),(53273676,425661990,16774048,454632,1,'2007-09-17 18:04:35',3310504515,1),(53273677,425663652,16771080,454632,1,'2007-09-17 18:04:35',3310504515,1),(53273678,425665077,16769893,454632,1,'2007-09-17 18:04:35',3310504515,1),(53273679,425667451,16770249,454632,1,'2007-09-17 18:04:35',3310504515,1),(53273680,425669350,16770962,454632,1,'2007-09-17 18:04:36',3310504515,1),(53273681,425671606,16770487,454632,1,'2007-09-17 18:04:36',3310504515,1),(53273682,425673861,16769418,454632,1,'2007-09-17 18:04:36',3310504518,1),(53273683,425676007,16769020,454632,1,'2007-09-17 18:04:36',3310504518,1),(53273684,425678621,16768899,454632,1,'2007-09-17 18:04:36',3310504518,1),(53273685,425681295,16767805,454632,1,'2007-09-17 18:04:36',3310504518,1),(53273686,425686036,16764401,454632,1,'2007-09-17 18:04:36',3310504518,1),(53273687,425693573,16758870,454632,1,'2007-09-17 18:04:37',3310504518,1),(53273688,425696673,16759113,454632,1,'2007-09-17 18:04:37',3310504518,1),(53273689,425699043,16759113,454632,1,'2007-09-17 18:04:37',3310504518,1),(53273690,425702265,16759660,454632,1,'2007-09-17 18:04:37',3310504519,1),(53273691,425704149,16758931,454632,1,'2007-09-17 18:04:38',3310504519,1),(53273692,425705121,16758201,454632,1,'2007-09-17 18:04:38',3310504519,1),(53273693,425706337,16755891,454632,1,'2007-09-17 18:04:38',3310504519,1),(53273694,425707917,16754433,454632,1,'2007-09-17 18:04:39',3310504519,1),(53273695,425709376,16753703,454632,1,'2007-09-17 18:04:39',3310504517,1),(53273696,425710592,16753825,454632,1,'2007-09-17 18:04:39',3310504517,1),(53273697,425711625,16754311,454632,1,'2007-09-17 18:04:39',3310504517,1),(53273698,425713023,16754919,454632,1,'2007-09-17 18:04:39',3310504519,1),(53273699,425714482,16755041,454632,1,'2007-09-17 18:04:39',3310504519,1),(53273700,425716488,16753643,454632,1,'2007-09-17 18:04:39',3310504517,1),(53273701,425717643,16752305,454632,1,'2007-09-17 18:04:40',3310504517,1),(53273702,425719041,16749935,454632,1,'2007-09-17 18:04:40',3310504517,1),(53273703,425719892,16745315,454632,1,'2007-09-17 18:04:40',3310504517,1),(53273704,425720439,16740757,454632,1,'2007-09-17 18:04:41',3310504517,1),(53273705,425722201,16736380,454632,1,'2007-09-17 18:04:41',3310504517,1),(53273706,425724815,16733037,454632,1,'2007-09-17 18:04:42',3310504517,1),(53273707,425728887,16728540,454632,1,'2007-09-17 18:04:42',3310504528,1),(53273708,425732352,16723799,454632,1,'2007-09-17 18:04:42',3310504528,1),(53273709,425736910,16716383,454632,1,'2007-09-17 18:04:42',3310504528,1),(53273710,425739463,16713770,454632,1,'2007-09-17 18:04:43',3310504528,1),(53273711,425742624,16711156,454632,1,'2007-09-17 18:04:43',3310504528,1),(53273712,425746149,16706354,454632,1,'2007-09-17 18:04:43',3310504528,1),(53273713,425748702,16702342,454632,1,'2007-09-17 18:04:43',3310504528,1),(53273714,425751377,16696933,454632,1,'2007-09-17 18:04:43',3310504186,1),(53273715,425752896,16691402,454632,1,'2007-09-17 18:04:43',3310504186,1),(53273716,425753018,16688545,454632,1,'2007-09-17 18:04:44',3310504186,1),(53273719,425752835,16686478,454632,1,'2007-09-17 18:04:44',3310504186,1),(53273723,425752835,16684108,454632,1,'2007-09-17 18:04:44',3310504186,1),(53273724,425752714,16680583,454632,1,'2007-09-17 18:04:44',3310504186,1),(53273725,425753261,16676753,454632,1,'2007-09-17 18:04:44',3310504186,1),(53273726,425753929,16673714,454632,1,'2007-09-17 18:04:44',3310504186,1),(53273727,425754841,16669338,454632,1,'2007-09-17 18:04:45',3310504187,1),(53273728,425754963,16666177,454632,1,'2007-09-17 18:04:45',3310504187,1),(53273729,425754659,16663138,454632,1,'2007-09-17 18:04:45',3310504187,1),(53273730,425754720,16659430,454632,1,'2007-09-17 18:04:46',3310504187,1),(53273731,425755449,16656391,454632,1,'2007-09-17 18:04:46',3310504187,1),(53273732,425756665,16651164,454632,1,'2007-09-17 18:04:46',3310504187,1),(53273733,425758427,16645511,454632,1,'2007-09-17 18:04:46',3310504187,1),(53273734,425758549,16640406,454632,1,'2007-09-17 18:04:47',3310504185,1),(53273735,425758792,16635847,454632,1,'2007-09-17 18:04:48',3310504185,1),(53273736,425759643,16628067,454632,1,'2007-09-17 18:04:48',3310504185,1),(53273737,425760312,16620044,454632,1,'2007-09-17 18:04:48',3310504185,1),(53273738,425760312,16615485,454632,1,'2007-09-17 18:04:48',3310504185,1),(53273739,425760190,16610562,454632,1,'2007-09-17 18:04:48',3310504185,1),(53273740,425759521,16607036,454632,1,'2007-09-17 18:04:48',3310504185,1),(53273741,425759643,16604180,454632,1,'2007-09-17 18:04:48',3310504185,1),(53273742,425760676,16598891,454632,1,'2007-09-17 18:05:38',3310504185,1),(53273743,425761649,16592266,454632,1,'2007-09-17 18:05:38',3310504185,1),(53273744,425762135,16588255,454632,1,'2007-09-17 18:05:39',3310504179,1),(53273745,425761831,16585337,454632,1,'2007-09-17 18:05:39',3310504179,1),(53273746,425761345,16581933,454632,1,'2007-09-17 18:05:39',3310504179,1),(53273747,425761953,16579563,454632,1,'2007-09-17 18:05:39',3310504179,1),(53273748,425762986,16575977,454632,1,'2007-09-17 18:05:40',3310504179,1),(53273749,425764749,16570932,454632,1,'2007-09-17 18:05:40',3310504179,1),(53273750,425766451,16568136,454632,1,'2007-09-17 18:05:40',3310504179,1),(53273751,425766998,16564793,454632,1,'2007-09-17 18:05:40',3310504179,1),(53273752,425766998,16561814,454632,1,'2007-09-17 18:05:40',3310504179,1),(53273753,425768031,16557377,454632,1,'2007-09-17 18:05:41',3310504179,1),(53273754,425769611,16554946,454632,1,'2007-09-17 18:05:41',3310504179,1),(53273755,425771556,16553427,454632,1,'2007-09-17 18:05:41',3310504179,1),(53273756,425773744,16552940,454632,1,'2007-09-17 18:05:41',3310504179,1),(53273757,425826191,16634427,454632,1,'2007-09-17 18:05:41',3310504189,1),(53273758,425823992,16633694,454632,1,'2007-09-17 18:05:41',3310504189,1),(53273759,425821792,16632123,454632,1,'2007-09-17 18:05:42',3310504189,1),(53273760,425819907,16630342,454632,1,'2007-09-17 18:05:42',3310504189,1),(53273761,425818126,16628352,454632,1,'2007-09-17 18:05:42',3310504189,1),(53273762,425817288,16626990,454632,1,'2007-09-17 18:05:42',3310504189,1),(53273763,425816241,16625733,454632,1,'2007-09-17 18:05:42',3310504189,1),(53273764,425814984,16625419,454632,1,'2007-09-17 18:05:42',3310504189,1),(53273765,425813936,16622591,454632,1,'2007-09-17 18:05:43',3310504189,1),(53273766,425811842,16621439,454632,1,'2007-09-17 18:05:43',3310504189,1),(53273767,425810019,16620471,454632,1,'2007-09-17 18:05:43',3310504189,1),(53273768,425808276,16619197,454632,1,'2007-09-17 18:05:43',3310504188,1),(53273769,425806868,16616985,454632,1,'2007-09-17 18:05:43',3310504188,1),(53273770,425804187,16612226,454632,1,'2007-09-17 18:05:43',3310504188,1),(53273771,425799763,16606796,454632,1,'2007-09-17 18:05:43',3310504188,1),(53273772,425796143,16602640,454632,1,'2007-09-17 18:05:44',3310504188,1),(53273773,425793461,16600562,454632,1,'2007-09-17 18:05:44',3310504188,1),(53273774,425790378,16596607,454632,1,'2007-09-17 18:05:44',3310504188,1),(53273775,425789506,16595802,454632,1,'2007-09-17 18:05:44',3310504188,1),(53273776,425781931,16574485,454632,1,'2007-09-17 18:05:44',3310504182,1),(53273777,425780524,16572541,454632,1,'2007-09-17 18:05:45',3310504179,1),(53273778,425778982,16570530,454632,1,'2007-09-17 18:05:45',3310504179,1),(53273779,425777976,16567446,454632,1,'2007-09-17 18:05:46',3310504179,1),(53273780,425776502,16562754,454632,1,'2007-09-17 18:05:46',3310504179,1),(53273781,425774155,16555313,454632,1,'2007-09-17 18:05:46',3310504179,1),(53273782,425773771,16548337,454632,1,'2007-09-17 18:05:46',3310504179,1),(53273783,425773828,16545519,454632,1,'2007-09-17 18:05:46',3310504179,1),(53273784,425773771,16541207,454632,1,'2007-09-17 18:05:46',3310504179,1),(53273785,425774173,16538102,454632,1,'2007-09-17 18:05:46',3310504179,1),(53273786,425774691,16535399,454632,1,'2007-09-17 18:05:47',3310504179,1),(53273787,425775669,16531144,454632,1,'2007-09-17 18:05:47',3310504177,1),(53273788,425777049,16524646,454632,1,'2007-09-17 18:05:47',3310504177,1),(53273789,425778256,16520448,454632,1,'2007-09-17 18:05:47',3310504177,1),(53273790,425780671,16514641,454632,1,'2007-09-17 18:05:47',3310504177,1),(53273791,425782856,16510845,454632,1,'2007-09-17 18:05:48',3310504180,1),(53273792,425784064,16507108,454632,1,'2007-09-17 18:05:48',3310504180,1),(53273793,425784294,16504693,454632,1,'2007-09-17 18:05:48',3310504180,1),(53273794,425784294,16502220,454632,1,'2007-09-17 18:05:48',3310504180,1),(53273795,425784294,16499403,454632,1,'2007-09-17 18:05:48',3310504180,1),(53273796,425784179,16495320,454632,1,'2007-09-17 18:05:49',3310504180,1),(53273797,425783604,16490547,454632,1,'2007-09-17 18:05:49',3310504180,1),(53273798,425782971,16485544,454632,1,'2007-09-17 18:05:49',3310504180,1),(53273799,425784294,16484164,454632,1,'2007-09-17 18:05:49',3310504180,1),(53273800,425785674,16485027,454632,1,'2007-09-17 18:05:49',3310504180,1),(53273801,425787054,16485314,454632,1,'2007-09-17 18:05:49',3310504180,1),(53273802,425789412,16484854,454632,1,'2007-09-17 18:05:50',3310504180,1),(53273803,425791654,16482957,454632,1,'2007-09-17 18:05:50',3310504180,1),(53273804,425794529,16479219,454632,1,'2007-09-17 18:05:50',3310504158,1),(53273805,425797117,16475194,454632,1,'2007-09-17 18:05:50',3310504158,1),(53273806,425797922,16472089,454632,1,'2007-09-17 18:05:51',3310504158,1),(53273807,425798037,16469444,454632,1,'2007-09-17 18:05:51',3310504158,1),(53273808,425797404,16465591,454632,1,'2007-09-17 18:05:51',3310504158,1),(53273810,425796427,16463119,454632,1,'2007-09-17 18:05:52',3310504158,1),(53273811,425794529,16461163,454632,1,'2007-09-17 18:05:52',3310504158,1),(53273812,425793207,16457828,454632,1,'2007-09-17 18:05:52',3310504158,1),(53273813,425793092,16453918,454632,1,'2007-09-17 18:05:52',3310504158,1),(53273814,425793264,16449318,454632,1,'2007-09-17 18:05:52',3310504158,1),(53273815,425792574,16446385,454632,1,'2007-09-17 18:05:52',3310504158,1),(53273816,425790792,16442648,454632,1,'2007-09-17 18:05:52',3310504158,1),(53273817,425789067,16440060,454632,1,'2007-09-17 18:05:53',3310504158,1),(53273818,425788319,16438623,454632,1,'2007-09-17 18:05:53',3310504158,1),(53273819,425788319,16436035,454632,1,'2007-09-17 18:05:53',3310504158,1),(53273820,425789527,16434080,454632,1,'2007-09-17 18:05:53',3310504158,1),(53273821,425791367,16430975,454632,1,'2007-09-17 18:05:53',3310504158,1),(53273822,425792344,16429135,454632,1,'2007-09-17 18:05:54',3310504158,1),(53273823,425792517,16427985,454632,1,'2007-09-17 18:05:54',3310504158,1),(53273824,425792517,16427007,454632,1,'2007-09-17 18:05:54',3310504158,1),(53273825,425791654,16425110,454632,1,'2007-09-17 18:05:54',3310504158,1),(53273826,425789527,16420739,454632,1,'2007-09-17 18:05:54',3310504156,1),(53273827,425787801,16416369,454632,1,'2007-09-17 18:05:54',3310504156,1),(53273828,425786824,16412804,454632,1,'2007-09-17 18:05:55',3310504156,1),(53273829,425786881,16410504,454632,1,'2007-09-17 18:05:55',3310504156,1),(53273830,425787801,16407744,454632,1,'2007-09-17 18:05:55',3310504156,1),(53273831,425788608,16405749,454632,1,'2007-09-17 18:05:55',3310504156,1),(53273832,425788873,16404777,454632,1,'2007-09-17 18:05:55',3310504156,1),(53273833,425788799,16402492,454632,1,'2007-09-17 18:05:55',3310504156,1),(53273834,425790238,16395037,495907,1,'2008-07-15 19:50:23',3310504156,2),(53273836,425787788,16395091,454632,1,'2007-09-17 18:05:56',3310504156,1),(53273838,425788335,16396580,454632,1,'2007-09-17 18:05:56',3310504156,1),(53273839,425788655,16397804,454632,1,'2007-09-17 18:05:56',3310504156,1),(53273841,425789409,16399726,454632,1,'2007-09-17 18:05:56',3310504156,1),(53273843,425789371,16400894,454632,1,'2007-09-17 18:05:56',3310504156,1),(53273844,425789220,16401535,454632,1,'2007-09-17 18:05:56',3310504156,1),(53273846,425788373,16402081,454632,1,'2007-09-17 18:05:57',3310504156,1),(53273848,425788033,16402006,454632,1,'2007-09-17 18:05:57',3310504156,1),(53273849,425787883,16401950,454632,1,'2007-09-17 18:05:57',3310504156,1),(53273851,425787261,16401677,454632,1,'2007-09-17 18:05:57',3310504156,1),(53273852,425787059,16401216,454632,1,'2007-09-17 18:05:57',3310504156,1),(53273853,425786524,16400995,454632,1,'2007-09-17 18:05:58',3310504156,1),(53273854,425786358,16400461,454632,1,'2007-09-17 18:05:58',3310504156,1),(53273855,425786008,16399594,454632,1,'2007-09-17 18:05:58',3310504156,1),(53273856,425785602,16398875,454632,1,'2007-09-17 18:05:58',3310504156,1),(53273857,425785547,16398193,454632,1,'2007-09-17 18:05:58',3310504156,1),(53273858,425786303,16395741,454632,1,'2007-09-17 18:05:58',3310504156,1),(53273859,425786690,16394911,454632,1,'2007-09-17 18:05:59',3310504156,1),(53273860,425787759,16395003,454632,1,'2007-09-17 18:05:59',3310504156,1),(53273861,425787543,16401869,454632,1,'2007-09-17 18:05:59',3310504156,1),(53273862,425806928,16363647,454632,1,'2007-09-17 18:05:59',3310504150,1),(53273863,425807531,16365751,454632,1,'2007-09-17 18:05:59',3310504150,1),(53273864,425808244,16366385,454632,1,'2007-09-17 18:05:59',3310504150,1),(53273865,425809323,16366655,454632,1,'2007-09-17 18:06:00',3310504151,1),(53273866,425810805,16367104,454632,1,'2007-09-17 18:06:00',3310504151,1),(53273867,425812737,16367194,454632,1,'2007-09-17 18:06:00',3310504151,1),(53273868,425814759,16366790,454632,1,'2007-09-17 18:06:00',3310504151,1),(53273869,425816646,16366161,454632,1,'2007-09-17 18:06:00',3310504151,1),(53273870,425818443,16366026,454632,1,'2007-09-17 18:06:00',3310504151,1),(53273871,425821364,16366475,454632,1,'2007-09-17 18:06:00',3310504151,1),(53273872,425823251,16367554,454632,1,'2007-09-17 18:06:01',3310504151,1),(53273873,425824554,16368946,454632,1,'2007-09-17 18:06:01',3310504151,1),(53273874,425825093,16370429,454632,1,'2007-09-17 18:06:01',3310504157,1),(53273875,425825183,16371507,454632,1,'2007-09-17 18:06:01',3310504157,1),(53273876,425824419,16372316,454632,1,'2007-09-17 18:06:01',3310504157,1),(53273877,425822756,16373799,454632,1,'2007-09-17 18:06:01',3310504157,1),(53273878,425819342,16376090,454632,1,'2007-09-17 18:06:01',3310504157,1),(53273879,425806601,16360619,454632,1,'2007-09-17 18:06:01',3310504150,1),(53273880,425806436,16357982,454632,1,'2007-09-17 18:06:02',3310504150,1),(53273881,425806271,16356498,454632,1,'2007-09-17 18:06:02',3310504150,1),(53273882,425805447,16354630,454632,1,'2007-09-17 18:06:02',3310504150,1),(53273883,425803524,16352047,454632,1,'2007-09-17 18:06:02',3310504150,1),(53273884,425801545,16349739,454632,1,'2007-09-17 18:06:02',3310504150,1),(53273885,425800996,16348970,454632,1,'2007-09-17 18:06:02',3310504150,1),(53273886,425800776,16348200,454632,1,'2007-09-17 18:06:02',3310504150,1),(53273887,425800556,16347486,454632,1,'2007-09-17 18:06:03',3310504150,1),(53273888,425800337,16346552,454632,1,'2007-09-17 18:06:03',3310504150,1),(53273889,425799457,16345453,454632,1,'2007-09-17 18:06:03',3310504150,1),(53273890,425798358,16344738,454632,1,'2007-09-17 18:06:03',3310504150,1),(53273891,425797919,16343474,454632,1,'2007-09-17 18:06:03',3310504150,1),(53273892,425797974,16342046,454632,1,'2007-09-17 18:06:03',3310504150,1),(53273893,425798193,16340507,454632,1,'2007-09-17 18:06:03',3310504150,1),(53273894,425798688,16338034,454632,1,'2007-09-17 18:06:03',3310504150,1),(53273895,425799622,16335122,454632,1,'2007-09-17 18:06:04',3310504150,1),(53273896,425800721,16333199,454632,1,'2007-09-17 18:06:04',3310504150,1),(53273897,425801875,16331715,454632,1,'2007-09-17 18:06:04',3310504150,1),(53273898,425802535,16330781,454632,1,'2007-09-17 18:06:04',3310504150,1),(53273899,425803139,16329462,454632,1,'2007-09-17 18:06:04',3310504150,1),(53273900,425803249,16327868,454632,1,'2007-09-17 18:06:04',3310504150,1),(53273901,425803497,16325538,454632,1,'2007-09-17 18:06:04',3310504150,1),(53273902,425803857,16323333,454632,1,'2007-09-17 18:06:04',3310504150,1),(53273903,425804555,16321397,454632,1,'2007-09-17 18:06:05',3310504150,1),(53273904,425805545,16319596,454632,1,'2007-09-17 18:06:05',3310504150,1),(53273905,425806558,16318133,454632,1,'2007-09-17 18:06:05',3310504150,1),(53273906,425807278,16317413,454632,1,'2007-09-17 18:06:05',3310504150,1),(53273907,425807954,16317480,454632,1,'2007-09-17 18:06:05',3310504150,1),(53273908,425808359,16317931,454632,1,'2007-09-17 18:06:05',3310504150,1),(53273909,425808471,16318426,454632,1,'2007-09-17 18:06:05',3310504150,1),(53273910,425808449,16318673,454632,1,'2007-09-17 18:06:05',3310504150,1),(53273911,425808291,16319641,454632,1,'2007-09-17 18:06:06',3310504150,1),(53273912,425807684,16320564,454632,1,'2007-09-17 18:06:06',3310504150,1),(53273913,425806986,16321937,454632,1,'2007-09-17 18:06:06',3310504150,1),(53273914,425806468,16323940,454632,1,'2007-09-17 18:06:06',3310504150,1),(53273915,425806581,16325786,454632,1,'2007-09-17 18:06:06',3310504150,1),(53273916,425807368,16327767,454632,1,'2007-09-17 18:06:06',3310504150,1),(53273917,425807967,16328968,454632,1,'2007-09-17 18:06:06',3310504150,1),(53273918,425808564,16330013,454632,1,'2007-09-17 18:06:07',3310504150,1),(53273919,425809311,16330461,454632,1,'2007-09-17 18:06:07',3310504151,1),(53273920,425811044,16329386,454632,1,'2007-09-17 18:06:07',3310504151,1),(53273921,425812209,16328191,454632,1,'2007-09-17 18:06:07',3310504151,1),(53273922,425812746,16326488,454632,1,'2007-09-17 18:06:07',3310504151,1),(53273923,425813165,16324427,454632,1,'2007-09-17 18:06:07',3310504151,1),(53273924,425813822,16321858,454632,1,'2007-09-17 18:06:07',3310504151,1),(53273925,425814449,16320903,454632,1,'2007-09-17 18:06:07',3310504151,1),(53273926,425814957,16320992,454632,1,'2007-09-17 18:06:08',3310504151,1),(53273927,425815375,16321351,454632,1,'2007-09-17 18:06:08',3310504151,1),(53273928,425815345,16321918,454632,1,'2007-09-17 18:06:08',3310504151,1),(53273929,425820005,16335091,454632,1,'2007-09-17 18:06:08',3310504151,1),(53273930,425820184,16336883,454632,1,'2007-09-17 18:06:08',3310504151,1),(53273931,425820065,16337899,454632,1,'2007-09-17 18:06:08',3310504151,1),(53273932,425819736,16339392,454632,1,'2007-09-17 18:06:08',3310504151,1),(53273933,425819318,16341692,454632,1,'2007-09-17 18:06:09',3310504151,1),(53273934,425819109,16342947,454632,1,'2007-09-17 18:06:09',3310504151,1),(53273935,425819019,16343783,454632,1,'2007-09-17 18:06:09',3310504151,1),(53273936,425818511,16344112,454632,1,'2007-09-17 18:06:09',3310504151,1),(53273937,425817914,16343753,454632,1,'2007-09-17 18:06:09',3310504151,1),(53273938,425817466,16342439,454632,1,'2007-09-17 18:06:09',3310504151,1),(53273939,425817078,16341453,454632,1,'2007-09-17 18:06:09',3310504151,1),(53273940,425816271,16341185,454632,1,'2007-09-17 18:06:10',3310504151,1),(53273941,425815435,16340527,454632,1,'2007-09-17 18:06:10',3310504151,1),(53273942,425815046,16339572,454632,1,'2007-09-17 18:06:10',3310504151,1),(53273943,425814778,16339273,454632,1,'2007-09-17 18:06:10',3310504151,1),(53273944,425813523,16339004,454632,1,'2007-09-17 18:06:10',3310504151,1),(53273945,425812746,16338616,454632,1,'2007-09-17 18:06:10',3310504151,1),(53273946,425812179,16337869,454632,1,'2007-09-17 18:06:10',3310504151,1),(53273947,425811940,16337630,454632,1,'2007-09-17 18:06:10',3310504151,1),(53273948,425811313,16337600,454632,1,'2007-09-17 18:06:10',3310504151,1),(53273949,425810864,16337720,454632,1,'2007-09-17 18:06:11',3310504151,1),(53273950,425810267,16338765,454632,1,'2007-09-17 18:06:11',3310504151,1),(53273951,425809640,16340527,454632,1,'2007-09-17 18:06:11',3310504151,1),(53273952,425809610,16341752,454632,1,'2007-09-17 18:06:11',3310504151,1),(53273953,425809550,16342887,454632,1,'2007-09-17 18:06:11',3310504151,1),(53273954,425809251,16343455,454632,1,'2007-09-17 18:06:11',3310504151,1),(53273955,425808415,16342768,454632,1,'2007-09-17 18:06:11',3310504150,1),(53273956,425808057,16341603,454632,1,'2007-09-17 18:06:11',3310504150,1),(53273957,425807967,16339661,454632,1,'2007-09-17 18:06:12',3310504150,1),(53273958,425808415,16337242,454632,1,'2007-09-17 18:06:12',3310504150,1),(53273959,425808953,16334972,454632,1,'2007-09-17 18:06:12',3310504150,1),(53273960,425809789,16330700,454632,1,'2007-09-17 18:06:12',3310504151,1),(53273961,425809819,16330312,454632,1,'2007-09-17 18:06:12',3310504151,1),(53273962,425789719,16370883,454632,1,'2007-09-17 18:06:12',3310504156,1),(53273963,425790233,16370575,454632,1,'2007-09-17 18:06:12',3310504156,1),(53273964,425790684,16370456,454632,1,'2007-09-17 18:06:12',3310504156,1),(53273965,425790827,16370694,454632,1,'2007-09-17 18:06:12',3310504156,1),(53273966,425790850,16371264,454632,1,'2007-09-17 18:06:12',3310504156,1),(53273967,425790803,16372001,454632,1,'2007-09-17 18:06:13',3310504156,1),(53273968,425785968,16381042,454632,1,'2007-09-17 18:06:13',3310504156,1),(53273969,425786129,16385827,454632,1,'2007-09-17 18:06:13',3310504156,1),(53273970,425787255,16394794,454632,1,'2007-09-17 18:06:13',3310504156,1),(53273971,425786446,16378201,454632,1,'2007-09-17 18:06:13',3310504156,1),(53273972,425786053,16376382,454632,1,'2007-09-17 18:06:13',3310504156,1),(53273973,425784676,16374119,454632,1,'2007-09-17 18:06:13',3310504156,1),(53273974,425783790,16371710,454632,1,'2007-09-17 18:06:13',3310504156,1),(53273975,425782905,16367234,454632,1,'2007-09-17 18:06:13',3310504150,1),(53273976,425782413,16363250,454632,1,'2007-09-17 18:06:14',3310504150,1),(53273977,425782413,16359857,454632,1,'2007-09-17 18:06:14',3310504150,1),(53273978,425782020,16356808,454632,1,'2007-09-17 18:06:14',3310504150,1),(53273979,425781184,16354988,454632,1,'2007-09-17 18:06:14',3310504147,1),(53273980,425780397,16349136,454632,1,'2007-09-17 18:06:14',3310504147,1),(53273981,425780151,16345693,454632,1,'2007-09-17 18:06:14',3310504147,1),(53273982,425779413,16341119,454632,1,'2007-09-17 18:06:14',3310504147,1),(53273983,425779315,16337922,454632,1,'2007-09-17 18:06:14',3310504147,1),(53273984,425778971,16332021,454632,1,'2007-09-17 18:06:14',3310504147,1),(53273985,425779266,16328185,454632,1,'2007-09-17 18:06:15',3310504147,1),(53273986,425779856,16322332,454632,1,'2007-09-17 18:06:15',3310504147,1),(53273987,425780741,16318102,454632,1,'2007-09-17 18:06:15',3310504147,1),(53273988,425781528,16314266,454632,1,'2007-09-17 18:06:15',3310504145,1),(53273989,425782069,16310529,454632,1,'2007-09-17 18:06:15',3310504148,1),(53273990,425781872,16307430,454632,1,'2007-09-17 18:06:15',3310504148,1),(53273991,425781872,16304529,454632,1,'2007-09-17 18:06:16',3310504148,1),(53273992,425781922,16302660,454632,1,'2007-09-17 18:06:16',3310504148,1),(53273993,425781331,16301037,454632,1,'2007-09-17 18:06:16',3310504145,1),(53273994,425779217,16298086,454632,1,'2007-09-17 18:06:16',3310504145,1),(53273995,425777102,16295824,454632,1,'2007-09-17 18:06:17',3310504145,1),(53273996,425775774,16293856,454632,1,'2007-09-17 18:06:17',3310504145,1),(53273997,425775430,16290463,454632,1,'2007-09-17 18:06:17',3310504145,1),(53273998,425775282,16288594,454632,1,'2007-09-17 18:06:17',3310504145,1),(53274000,425788856,16282446,454632,1,'2007-09-17 18:06:17',3310504148,1),(53274002,425788856,16286037,454632,1,'2007-09-17 18:06:17',3310504148,1),(53274003,425788807,16289086,454632,1,'2007-09-17 18:06:18',3310504148,1),(53274004,425788561,16290119,454632,1,'2007-09-17 18:06:18',3310504148,1),(53274005,425788118,16291250,454632,1,'2007-09-17 18:06:18',3310504148,1),(53274006,425788709,16294201,454632,1,'2007-09-17 18:06:18',3310504148,1),(53274007,425789692,16297447,454632,1,'2007-09-17 18:06:18',3310504148,1),(53274008,425790873,16300988,454632,1,'2007-09-17 18:06:18',3310504148,1),(53274009,425791463,16303742,454632,1,'2007-09-17 18:06:18',3310504148,1),(53274010,425791709,16308414,454632,1,'2007-09-17 18:06:19',3310504148,1),(53274011,425791364,16310971,454632,1,'2007-09-17 18:06:19',3310504148,1),(53274012,425790332,16315004,454632,1,'2007-09-17 18:06:19',3310504150,1),(53274013,425788315,16318545,454632,1,'2007-09-17 18:06:19',3310504150,1),(53274014,425786545,16321299,454632,1,'2007-09-17 18:06:19',3310504150,1),(53274015,425785856,16323660,454632,1,'2007-09-17 18:06:19',3310504150,1),(53274016,425784929,16329205,495907,1,'2008-07-15 19:49:19',3310504150,3),(53274017,425784550,16332466,495907,1,'2008-07-15 19:49:19',3310504150,3),(53274018,425784107,16338818,495907,1,'2008-07-15 19:49:19',3310504150,3),(53274019,425783981,16342852,495907,1,'2008-07-15 19:49:19',3310504150,3),(53274020,425784044,16345770,495907,1,'2008-07-15 19:49:19',3310504150,3),(53274021,425783539,16346628,495907,1,'2008-07-15 19:48:55',3310504150,2),(53274022,425783286,16346542,495907,1,'2008-07-15 19:48:35',3310504150,2),(53274023,425773850,16283044,454632,1,'2007-09-17 18:06:20',3310504145,1),(53274024,425773026,16279473,454632,1,'2007-09-17 18:06:20',3310504145,1),(53274025,425773105,16277786,454632,1,'2007-09-17 18:06:21',3310504145,1),(53274026,425774046,16274687,454632,1,'2007-09-17 18:06:21',3310504145,1),(53274027,425775223,16271979,454632,1,'2007-09-17 18:06:21',3310504145,1),(53274028,425775773,16268880,454632,1,'2007-09-17 18:06:21',3310504145,1),(53274029,425775420,16266094,454632,1,'2007-09-17 18:06:21',3310504145,1),(53274030,425774125,16263818,454632,1,'2007-09-17 18:06:21',3310504145,1),(53274031,425772673,16261385,454632,1,'2007-09-17 18:06:22',3310504145,1),(53274883,425769476,16258599,454632,1,'2007-09-17 18:30:03',3310504059,1),(53274884,425766090,16256547,454632,1,'2007-09-17 18:30:03',3310504059,1),(53274885,425762807,16253264,454632,1,'2007-09-17 18:30:03',3310504059,1),(53274886,425760242,16250904,454632,1,'2007-09-17 18:30:03',3310504059,1),(53274888,425757779,16247723,557925,1,'2008-01-06 23:25:40',3310504059,2),(53274890,425756138,16243619,454632,1,'2007-09-17 18:30:04',3310504059,1),(53274891,425756343,16240233,454632,1,'2007-09-17 18:30:04',3310504059,1),(53274892,425756548,16234590,454632,1,'2007-09-17 18:30:04',3310504059,1),(53274893,425756343,16231307,454632,1,'2007-09-17 18:30:04',3310504059,1),(53274894,425754906,16227203,454632,1,'2007-09-17 18:30:04',3310504059,1),(53274895,425752957,16223919,454632,1,'2007-09-17 18:30:04',3310504058,1),(53274896,425749058,16220739,454632,1,'2007-09-17 18:30:04',3310504058,1),(53274898,425745569,16217455,454632,1,'2007-09-17 18:30:05',3310504058,1),(53274899,425742081,16213043,454632,1,'2007-09-17 18:30:05',3310504058,1),(53274900,425738798,16209042,454632,1,'2007-09-17 18:30:05',3310504058,1),(53274901,425736848,16204732,454632,1,'2007-09-17 18:30:05',3310504056,1),(53274902,425736951,16200628,454632,1,'2007-09-17 18:30:05',3310504056,1),(53274903,425738182,16195601,454632,1,'2007-09-17 18:30:05',3310504056,1),(53274904,425739003,16190881,454632,1,'2007-09-17 18:30:06',3310504056,1),(53274906,425738079,16188213,454632,1,'2007-09-17 18:30:06',3310504056,1),(53274907,425735822,16186777,454632,1,'2007-09-17 18:30:06',3310504056,1),(53274908,425733257,16184519,454632,1,'2007-09-17 18:30:06',3310504056,1),(53274909,425731410,16180928,454632,1,'2007-09-17 18:30:06',3310504056,1),(53274910,425729050,16174567,454632,1,'2007-09-17 18:30:06',3310504056,1),(53274911,425727306,16167590,454632,1,'2007-09-17 18:30:06',3310504056,1),(53274912,425726485,16162665,454632,1,'2007-09-17 18:30:06',3310504045,1),(53274913,425725870,16158253,454632,1,'2007-09-17 18:30:06',3310504045,1),(53274915,425723715,16153225,454632,1,'2007-09-17 18:30:07',3310504045,1),(53274916,425720945,16148608,454632,1,'2007-09-17 18:30:07',3310504039,1),(53274917,425716840,16143786,454632,1,'2007-09-17 18:30:07',3310504039,1),(53274918,425715609,16141631,454632,1,'2007-09-17 18:30:07',3310504039,1),(53274919,425715301,16139066,454632,1,'2007-09-17 18:30:07',3310504039,1),(53274920,425716122,16134962,454632,1,'2007-09-17 18:30:07',3310504039,1),(53274921,425717456,16130447,454632,1,'2007-09-17 18:30:07',3310504039,1),(53274922,425717456,16127780,454632,1,'2007-09-17 18:30:07',3310504039,1),(53274924,425716840,16124496,454632,1,'2007-09-17 18:30:08',3310504039,1),(53274925,425714788,16119982,454632,1,'2007-09-17 18:30:08',3310504039,1),(53274926,425713249,16115980,454632,1,'2007-09-17 18:30:08',3310504039,1),(53274927,425711300,16111876,454632,1,'2007-09-17 18:30:08',3310504039,1),(53274928,425709199,16107483,454632,1,'2007-09-17 18:30:08',3310504039,1),(53274929,425707770,16105129,454632,1,'2007-09-17 18:30:08',3310504039,1),(53274931,425707308,16103280,454632,1,'2007-09-17 18:30:09',3310504039,1),(53274932,425707770,16101557,454632,1,'2007-09-17 18:30:09',3310504039,1),(53274933,425709704,16098237,454632,1,'2007-09-17 18:30:09',3310504039,1),(53274934,425711090,16095127,454632,1,'2007-09-17 18:30:09',3310504037,1),(53274935,425711259,16093110,454632,1,'2007-09-17 18:30:09',3310504037,1),(53274936,425710754,16089580,454632,1,'2007-09-17 18:30:09',3310504037,1),(53274937,425709620,16086974,454632,1,'2007-09-17 18:30:10',3310504037,1),(53274939,425707896,16084116,454632,1,'2007-09-17 18:30:10',3310504037,1),(53274940,425706215,16082183,454632,1,'2007-09-17 18:30:10',3310504037,1),(53274941,425703736,16079998,454632,1,'2007-09-17 18:30:10',3310504037,1),(53274942,425701634,16078401,454632,1,'2007-09-17 18:30:10',3310504037,1),(53274943,425700416,16076467,454632,1,'2007-09-17 18:30:10',3310504037,1),(53274944,425700206,16075207,454632,1,'2007-09-17 18:30:11',3310504037,1),(53274946,425700542,16073820,454632,1,'2007-09-17 18:30:11',3310504037,1),(53274947,425701004,16071550,454632,1,'2007-09-17 18:30:11',3310504037,1),(53274948,425701088,16065793,454632,1,'2007-09-17 18:30:11',3310504037,1),(53274949,425701508,16062262,454632,1,'2007-09-17 18:30:11',3310504037,1),(53274950,425701971,16057934,454632,1,'2007-09-17 18:30:11',3310504037,1),(53274951,425701971,16055034,454632,1,'2007-09-17 18:30:11',3310504037,1),(53274952,425701550,16053059,454632,1,'2007-09-17 18:30:12',3310504037,1),(53274954,425699701,16051546,454632,1,'2007-09-17 18:30:12',3310504037,1),(53274955,425696928,16050579,454632,1,'2007-09-17 18:30:12',3310504036,1),(53274956,425691632,16049192,454632,1,'2007-09-17 18:30:12',3310504036,1),(53274957,425687892,16048730,454632,1,'2007-09-17 18:30:12',3310504036,1),(53274958,425685333,16048006,454632,1,'2007-09-17 18:30:12',3310504036,1),(53274959,425683431,16047107,454632,1,'2007-09-17 18:30:12',3310504036,1),(53274960,425682324,16046035,454632,1,'2007-09-17 18:30:12',3310504036,1),(53274961,425680457,16043580,454632,1,'2007-09-17 18:30:13',3310504036,1),(53274963,425678796,16039626,454632,1,'2007-09-17 18:30:13',3310504014,1),(53274964,425678426,16036049,454632,1,'2007-09-17 18:30:13',3310504014,1),(53274965,425677991,16031632,454632,1,'2007-09-17 18:30:13',3310504014,1),(53274966,425677031,16026568,454632,1,'2007-09-17 18:30:13',3310504014,1),(53274967,425676158,16023425,454632,1,'2007-09-17 18:30:14',3310504014,1),(53274968,425673666,16013358,4963967,1,'2010-06-11 20:09:43',3310504014,2),(53274970,425672940,16014785,4963967,1,'2010-06-11 20:09:44',3310504014,2),(53274971,425673691,16013744,4963967,1,'2010-06-11 20:09:43',3310504014,2),(53274972,425672730,16014605,454632,1,'2007-09-17 18:30:14',3310504014,1),(53274973,425669451,16020624,454632,1,'2007-09-17 18:30:14',3310504011,1),(53274974,425668285,16022581,454632,1,'2007-09-17 18:30:15',3310504011,1),(53274976,425667449,16023791,454632,1,'2007-09-17 18:30:15',3310504011,1),(53274977,425666613,16024483,454632,1,'2007-09-17 18:30:15',3310504011,1),(53274978,425665806,16024483,454632,1,'2007-09-17 18:30:15',3310504011,1),(53274979,425664970,16024080,454632,1,'2007-09-17 18:30:15',3310504011,1),(53274980,425663269,16022523,454632,1,'2007-09-17 18:30:15',3310504011,1),(53274981,425661827,16021254,454632,1,'2007-09-17 18:30:16',3310504011,1),(53274983,425660761,16020649,454632,1,'2007-09-17 18:30:16',3310504011,1),(53274984,425660011,16020793,454632,1,'2007-09-17 18:30:16',3310504011,1),(53274985,425659723,16021312,454632,1,'2007-09-17 18:30:16',3310504011,1),(53274986,425659146,16022408,454632,1,'2007-09-17 18:30:16',3310504011,1),(53274987,425659146,16023157,454632,1,'2007-09-17 18:30:16',3310504011,1),(53274988,425659694,16023849,454632,1,'2007-09-17 18:30:16',3310504011,1),(53274989,425663817,16027539,454632,1,'2007-09-17 18:30:16',3310504011,1),(53274990,425664480,16028462,454632,1,'2007-09-17 18:30:16',3310504011,1),(53274991,425664480,16029586,454632,1,'2007-09-17 18:30:17',3310504011,1),(53274992,425664076,16030739,454632,1,'2007-09-17 18:30:17',3310504011,1),(53274993,425663471,16031316,454632,1,'2007-09-17 18:30:17',3310504011,1),(53274995,425662865,16031547,454632,1,'2007-09-17 18:30:17',3310504011,1),(53274996,425661972,16031085,454632,1,'2007-09-17 18:30:17',3310504011,1),(53274997,425656667,16026069,454632,1,'2007-09-17 18:30:17',3310504011,1),(53274998,425674193,16019029,454632,1,'2007-09-17 18:30:18',3310504014,1),(53274999,425672577,16016267,454632,1,'2007-09-17 18:30:18',3310504014,1),(53275001,425670432,16013451,454632,1,'2007-09-17 18:30:18',3310504011,1),(53275002,425668776,16012292,454632,1,'2007-09-17 18:30:18',3310504011,1),(53275003,425666458,16010222,454632,1,'2007-09-17 18:30:18',3310504011,1),(53275004,425663146,16006248,454632,1,'2007-09-17 18:30:18',3310504011,1),(53275005,425660537,16001197,454632,1,'2007-09-17 18:30:19',3310504011,1),(53275006,425654824,16018792,454632,1,'2007-09-17 18:30:19',3310504011,1),(53275008,425659324,15999062,454632,1,'2007-09-17 18:30:19',3310504011,1),(53275009,425660455,16003184,454632,1,'2007-09-17 18:30:19',3310504011,1),(53275010,425666415,16011640,454632,1,'2007-09-17 18:30:19',3310504011,1),(53275011,425670556,16015480,454632,1,'2007-09-17 18:30:19',3310504011,1),(53275012,425671749,16016405,454632,1,'2007-09-17 18:30:19',3310504011,1),(53275014,425671521,16016823,454632,1,'2007-09-17 18:30:20',3310504011,1),(53275015,425663724,16008797,454632,1,'2007-09-17 18:30:20',3310504011,1),(53275016,425661971,16006170,454632,1,'2007-09-17 18:30:20',3310504011,1),(53275017,425657675,16008539,454632,1,'2007-09-17 18:30:20',3310504011,1),(53275018,425656568,15999695,454632,1,'2007-09-17 18:30:20',3310504011,1),(53275019,425653344,16000415,454632,1,'2007-09-17 18:30:20',3310504011,1),(53275020,425651081,16000244,454632,1,'2007-09-17 18:30:20',3310504011,1),(53275022,425649537,15999318,454632,1,'2007-09-17 18:30:21',3310504011,1),(53275023,425647548,15997020,454632,1,'2007-09-17 18:30:21',3310504011,1),(53275024,425646176,15994584,454632,1,'2007-09-17 18:30:21',3310504011,1),(53275026,425667647,16001601,4963967,1,'2010-06-11 20:09:45',3310504011,3),(53275027,425666974,16002095,4963967,1,'2010-06-11 20:09:46',3310504011,3),(53275028,425666624,16001664,4963967,1,'2010-06-11 20:09:46',3310504011,3),(53275030,425666602,16001209,4963967,1,'2010-06-11 20:09:46',3310504011,3),(53275031,425666833,16000771,4963967,1,'2010-06-11 20:09:45',3310504011,3),(53275032,425667200,16000659,4963967,1,'2010-06-11 20:09:45',3310504011,3),(53275033,425667578,16000980,4963967,1,'2010-06-11 20:09:45',3310504011,3),(53275034,425672452,16015114,454632,1,'2007-09-17 18:30:22',3310504014,1),(53275035,425663533,16000181,454632,1,'2007-09-17 18:30:22',3310504011,1),(53275036,425665236,16001155,454632,1,'2007-09-17 18:30:23',3310504011,1),(53275038,425653887,15978587,454632,1,'2007-09-17 18:30:23',3310504009,1),(53275039,425658368,15989734,454632,1,'2007-09-17 18:30:23',3310504011,1),(53275040,425661408,15998269,454632,1,'2007-09-17 18:30:23',3310504011,1),(53275506,425672193,15979031,454632,1,'2007-09-17 19:11:34',3310504012,1),(53275507,425673702,15978701,454632,1,'2007-09-17 18:40:28',3310504012,1),(53275508,425675179,15978701,454632,1,'2007-09-17 18:40:28',3310504012,1),(53275510,425675401,15979329,454632,1,'2007-09-17 18:40:29',3310504012,1),(53275511,425674995,15980844,454632,1,'2007-09-17 18:40:29',3310504012,1),(53275512,425673739,15982949,454632,1,'2007-09-17 18:40:29',3310504012,1),(53275514,425671116,15987899,454632,1,'2007-09-17 18:40:29',3310504011,1),(53275515,425669232,15991076,454632,1,'2007-09-17 18:40:29',3310504011,1),(53275516,425669158,15992701,454632,1,'2007-09-17 18:40:30',3310504011,1),(53275517,425668346,15994696,454632,1,'2007-09-17 18:40:30',3310504011,1),(53275518,425667755,15997318,454632,1,'2007-09-17 18:40:30',3310504011,1),(53275519,425667348,15999498,454632,1,'2007-09-17 18:40:30',3310504011,1),(53275520,425670840,15979638,454632,1,'2007-09-17 18:40:30',3310504009,1),(53275521,425669973,15979681,454632,1,'2007-09-17 18:40:31',3310504009,1),(53275522,425668585,15979291,454632,1,'2007-09-17 18:40:31',3310504009,1),(53275523,425667457,15978250,454632,1,'2007-09-17 18:40:31',3310504009,1),(53275524,425666676,15976862,454632,1,'2007-09-17 18:40:31',3310504009,1),(53275525,425665419,15974737,454632,1,'2007-09-17 18:40:32',3310504009,1),(53275526,425664811,15973826,454632,1,'2007-09-17 18:40:32',3310504009,1),(53275527,425664074,15972785,454632,1,'2007-09-17 18:40:32',3310504009,1),(53275528,425663380,15970703,454632,1,'2007-09-17 18:40:33',3310504009,1),(53275529,425662686,15969619,454632,1,'2007-09-17 18:40:33',3310504009,1),(53275530,425661125,15968882,454632,1,'2007-09-17 18:40:33',3310504009,1),(53275531,425660431,15967581,454632,1,'2007-09-17 18:40:33',3310504009,1),(53275533,425659355,15994564,454632,1,'2007-09-17 18:40:34',3310504011,1),(53275534,425658693,15992911,454632,1,'2007-09-17 18:40:34',3310504011,1),(53275535,425656960,15989699,454632,1,'2007-09-17 18:50:21',3310504011,1),(53275536,425654313,15983984,454632,1,'2007-09-17 18:40:34',3310504009,1),(53275537,425652825,15981008,454632,1,'2007-09-17 18:40:34',3310504009,1),(53275538,425651502,15976710,454632,1,'2007-09-17 18:40:35',3310504009,1),(53275539,425651172,15973652,454632,1,'2007-09-17 18:40:35',3310504009,1),(53275540,425651502,15971420,454632,1,'2007-09-17 18:40:35',3310504009,1),(53275541,425654147,15967866,454632,1,'2007-09-17 18:40:36',3310504009,1),(53275542,425655801,15964560,454632,1,'2007-09-17 18:40:36',3310504009,1),(53275543,425657784,15961419,454632,1,'2007-09-17 18:40:36',3310504009,1),(53275544,425659107,15958526,454632,1,'2007-09-17 18:40:36',3310504009,1),(53275545,425660512,15954063,454632,1,'2007-09-17 18:40:37',3310504009,1),(53275546,425661338,15950509,454632,1,'2007-09-17 18:40:37',3310504009,1),(53275547,425661173,15947203,454632,1,'2007-09-17 18:40:37',3310504009,1),(53275548,425660016,15945136,454632,1,'2007-09-17 18:40:37',3310504009,1),(53275549,425657536,15944062,454632,1,'2007-09-17 18:40:37',3310504009,1),(53275550,425655883,15942905,454632,1,'2007-09-17 18:40:38',3310504009,1),(53275551,425655305,15940755,454632,1,'2007-09-17 18:40:38',3310504009,1),(53275552,425654084,15937833,454632,1,'2007-09-17 18:40:38',3310504009,1),(53275554,425653290,15936087,454632,1,'2007-09-17 18:40:38',3310504009,1),(53275555,425652148,15935167,454632,1,'2007-09-17 18:40:39',3310504009,1),(53275556,425649767,15934437,454632,1,'2007-09-17 18:40:39',3310504009,1),(53275557,425648022,15934278,454632,1,'2007-09-17 18:40:39',3310504009,1),(53275558,425646054,15934214,454632,1,'2007-09-17 18:40:39',3310504009,1),(53275559,425644435,15934119,454632,1,'2007-09-17 18:40:39',3310504009,1),(53275560,425643515,15933580,454632,1,'2007-09-17 18:40:39',3310504008,1),(53275561,425642531,15932501,454632,1,'2007-09-17 18:40:40',3310504008,1);
INSERT INTO `nodes` VALUES (53275562,425641991,15930787,454632,1,'2007-09-17 18:40:40',3310504008,1),(53275563,425641579,15929549,454632,1,'2007-09-17 18:40:40',3310504002,1),(53275565,425640531,15927010,454632,1,'2007-09-17 18:40:41',3310504002,1),(53275567,425639516,15925645,454632,1,'2007-09-17 18:40:41',3310504002,1),(53275568,425638373,15924217,454632,1,'2007-09-17 18:40:41',3310504002,1),(53275569,425637706,15922566,454632,1,'2007-09-17 18:40:41',3310504002,1),(53275570,425637724,15919540,454632,1,'2007-09-17 18:40:41',3310504002,1),(53275572,425637780,15916435,454632,1,'2007-09-17 18:40:42',3310504002,1),(53275573,425637554,15914346,454632,1,'2007-09-17 18:40:42',3310504002,1),(53275574,425635861,15912539,454632,1,'2007-09-17 18:40:42',3310504002,1),(53275575,425632699,15910394,454632,1,'2007-09-17 18:40:42',3310504002,1),(53275576,425630610,15909152,454632,1,'2007-09-17 18:40:42',3310504002,1),(53275577,425628804,15908813,454632,1,'2007-09-17 18:40:42',3310504002,1),(53275578,425626941,15907063,454632,1,'2007-09-17 18:40:43',3310504002,1),(53275579,425622707,15906837,454632,1,'2007-09-17 18:40:43',3310504002,1),(53275580,425618021,15906950,454632,1,'2007-09-17 18:40:43',3310504002,1),(53275581,425613843,15907345,454632,1,'2007-09-17 18:40:43',3310503959,1),(53275582,425609778,15907740,454632,1,'2007-09-17 18:40:44',3310503959,1),(53275583,425607407,15907684,454632,1,'2007-09-17 18:40:44',3310503959,1),(53275584,425604415,15907007,454632,1,'2007-09-17 18:40:44',3310503959,1),(53275585,425602552,15906047,454632,1,'2007-09-17 18:40:44',3310503959,1),(53275586,425599786,15903450,454632,1,'2007-09-17 18:40:44',3310503959,1),(53275587,425597753,15901305,454632,1,'2007-09-17 18:40:44',3310503959,1),(53275588,425593350,15901022,454632,1,'2007-09-17 18:40:45',3310503959,1),(53275589,425591374,15901079,454632,1,'2007-09-17 18:40:45',3310503959,1),(53275590,425589624,15900288,454632,1,'2007-09-17 18:40:45',3310503959,1),(53275591,425588720,15899893,454632,1,'2007-09-17 18:40:45',3310503958,1),(53275592,425587761,15897861,454632,1,'2007-09-17 18:40:46',3310503958,1),(53275593,425584712,15896111,454632,1,'2007-09-17 18:40:46',3310503958,1),(53275594,425582171,15896506,454632,1,'2007-09-17 18:40:46',3310503958,1),(53275595,425579349,15898312,454632,1,'2007-09-17 18:40:46',3310503958,1),(53275596,425578445,15898369,454632,1,'2007-09-17 18:40:46',3310503958,1),(53275597,425576413,15897522,454632,1,'2007-09-17 18:40:47',3310503958,1),(53275598,425575961,15894981,454632,1,'2007-09-17 18:40:47',3310503958,1),(53275599,425575114,15893288,454632,1,'2007-09-17 18:40:47',3310503958,1),(53275600,425574268,15892441,454632,1,'2007-09-17 18:40:48',3310503958,1),(53275601,425571727,15891933,454632,1,'2007-09-17 18:40:48',3310503958,1),(53275602,425567945,15891030,454632,1,'2007-09-17 18:40:48',3310503958,1),(53275603,425566821,15890662,454632,1,'2007-09-17 18:40:48',3310503958,1),(53275604,425565224,15890401,454632,1,'2007-09-17 18:40:48',3310503958,1),(53275605,425564214,15889880,454632,1,'2007-09-17 18:40:48',3310503958,1),(53275606,425561249,15891867,454632,1,'2007-09-17 18:40:49',3310503955,1),(53275607,425560272,15892421,454632,1,'2007-09-17 18:40:49',3310503955,1),(53275608,425559197,15891998,454632,1,'2007-09-17 18:40:49',3310503955,1),(53275609,425556786,15889847,454632,1,'2007-09-17 18:40:49',3310503955,1),(53275610,425554994,15889130,454632,1,'2007-09-17 18:40:50',3310503955,1),(53275611,425552909,15888642,454632,1,'2007-09-17 18:40:50',3310503955,1),(53275612,425550660,15888577,454632,1,'2007-09-17 18:40:50',3310503955,1),(53275613,425548836,15889261,454632,1,'2007-09-17 18:40:50',3310503955,1),(53275614,425546588,15891248,454632,1,'2007-09-17 18:40:50',3310503955,1),(53275615,425544437,15893301,454632,1,'2007-09-17 18:40:51',3310503955,1),(53275616,425543558,15893301,454632,1,'2007-09-17 18:40:51',3310503955,1),(53275617,425542352,15892128,454632,1,'2007-09-17 18:40:51',3310503955,1),(53275618,425540039,15888544,454632,1,'2007-09-17 18:40:51',3310503955,1),(53275619,425536618,15884178,454632,1,'2007-09-17 18:40:51',3310503955,1),(53275620,425534077,15882288,454632,1,'2007-09-17 18:40:51',3310503954,1),(53275621,425531568,15881865,454632,1,'2007-09-17 18:40:52',3310503954,1),(53275622,425529026,15881800,454632,1,'2007-09-17 18:40:52',3310503954,1),(53275623,425527234,15883005,454632,1,'2007-09-17 18:40:52',3310503954,1),(53275624,425524173,15884799,454632,1,'2007-09-17 18:40:52',3310503954,1),(53275625,425520787,15886017,454632,1,'2007-09-17 18:40:53',3310503954,1),(53275626,425518446,15886297,454632,1,'2007-09-17 18:40:53',3310503954,1),(53275627,425516575,15886147,454632,1,'2007-09-17 18:40:53',3310503954,1),(53275628,425513917,15887532,454632,1,'2007-09-17 18:40:53',3310503954,1),(53275629,425510998,15889890,454632,1,'2007-09-17 18:40:54',3310503954,1),(53275630,425508453,15890863,454632,1,'2007-09-17 18:40:54',3310503954,1),(53275631,425505968,15893262,454632,1,'2007-09-17 18:40:54',3310503943,1),(53275632,425504028,15896496,454632,1,'2007-09-17 18:40:54',3310503943,1),(53275633,425500988,15899342,454632,1,'2007-09-17 18:40:54',3310503943,1),(53275634,425496137,15901670,454632,1,'2007-09-17 18:40:55',3310503943,1),(53275635,425491156,15905810,454632,1,'2007-09-17 18:40:55',3310503943,1),(53275636,425487470,15906198,454632,1,'2007-09-17 18:40:55',3310503943,1),(53275637,425485077,15906133,454632,1,'2007-09-17 18:40:55',3310503943,1),(53275638,425483395,15906068,454632,1,'2007-09-17 18:40:56',3310503943,1),(53275639,425481972,15906909,454632,1,'2007-09-17 18:40:56',3310503943,1),(53275640,425479837,15907555,454632,1,'2007-09-17 18:40:56',3310503943,1),(53275642,425476164,15907283,454632,1,'2007-09-17 18:40:56',3310503942,1),(53275643,425475051,15906613,454632,1,'2007-09-17 18:40:57',3310503942,1),(53275644,425472787,15906392,454632,1,'2007-09-17 18:40:57',3310503942,1),(53275645,425469942,15906456,454632,1,'2007-09-17 18:40:57',3310503942,1),(53275646,425468713,15906068,454632,1,'2007-09-17 18:40:57',3310503942,1),(53275647,425467872,15903999,454632,1,'2007-09-17 18:40:57',3310503942,1),(53275648,425466902,15903028,454632,1,'2007-09-17 18:40:58',3310503942,1),(53275649,425465026,15902446,454632,1,'2007-09-17 18:40:58',3310503942,1),(53275650,425463732,15901088,454632,1,'2007-09-17 18:40:58',3310503942,1),(53275651,425462245,15901088,454632,1,'2007-09-17 18:40:59',3310503942,1),(53275652,425460757,15902123,454632,1,'2007-09-17 18:40:59',3310503942,1),(53275653,425457006,15901541,454632,1,'2007-09-17 18:40:59',3310503942,1),(53275654,425454936,15901282,454632,1,'2007-09-17 18:40:59',3310503942,1),(53275655,425452931,15901282,454632,1,'2007-09-17 18:41:00',3310503942,1),(53275656,425450085,15902382,454632,1,'2007-09-17 18:41:00',3310503939,1),(53275657,425447239,15903093,454632,1,'2007-09-17 18:41:00',3310503939,1),(53275658,425443811,15904387,454632,1,'2007-09-17 18:41:00',3310503939,1),(53275659,425441676,15904387,454632,1,'2007-09-17 18:41:01',3310503939,1),(53275660,425438378,15904128,454632,1,'2007-09-17 18:41:01',3310503939,1),(53275661,425435920,15903158,454632,1,'2007-09-17 18:41:01',3310503939,1),(53275662,425433980,15902252,454632,1,'2007-09-17 18:41:01',3310503939,1),(53275663,425433721,15902382,454632,1,'2007-09-17 18:41:01',3310503939,1),(53275664,425432751,15903028,454632,1,'2007-09-17 18:41:02',3310503939,1),(53275665,425430252,15903836,454632,1,'2007-09-17 18:41:02',3310503939,1),(53275666,425427964,15904063,454632,1,'2007-09-17 18:41:02',3310503939,1),(53275667,425426735,15904128,454632,1,'2007-09-17 18:41:02',3310503939,1),(53275668,425425442,15904193,454632,1,'2007-09-17 18:41:02',3310503939,1),(53275669,425423372,15904839,454632,1,'2007-09-17 18:41:03',3310503938,1),(53275670,425420073,15905874,454632,1,'2007-09-17 18:41:03',3310503938,1),(53276316,425660491,15998668,454632,1,'2007-09-17 19:11:34',3310504011,1),(53276317,425659441,15999022,454632,1,'2007-09-17 19:11:34',3310504011,1),(53276347,425644886,15991244,454632,1,'2007-09-17 18:52:58',3310504011,1),(53276348,425643685,15987296,454632,1,'2007-09-17 18:52:58',3310504010,1),(53276349,425642610,15982833,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276350,425642610,15980258,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276351,425643053,15977854,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276352,425644254,15974421,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276353,425645139,15971846,454632,1,'2007-09-17 18:52:58',3310504009,1),(53276354,425645518,15969271,454632,1,'2007-09-17 18:52:58',3310504009,1),(53276355,425645139,15965752,454632,1,'2007-09-17 18:52:58',3310504009,1),(53276356,425643369,15960860,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276357,425641725,15955195,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276358,425640587,15950818,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276359,425638817,15945754,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276360,425636668,15942578,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276361,425633128,15939231,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276362,425628955,15936141,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276363,425625162,15934252,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276364,425622444,15933480,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276365,425620295,15934338,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276366,425618019,15936827,454632,1,'2007-09-17 18:52:58',3310504008,1),(53276367,425615996,15937943,454632,1,'2007-09-17 18:52:58',3310503965,1),(53276368,425612708,15937514,454632,1,'2007-09-17 18:52:58',3310503965,1),(53276369,425609611,15936913,454632,1,'2007-09-17 18:52:58',3310503965,1),(53276370,425606134,15937085,454632,1,'2007-09-17 18:52:58',3310503965,1),(53276371,425604047,15938286,454632,1,'2007-09-17 18:52:58',3310503965,1),(53276372,425602151,15939059,454632,1,'2007-09-17 18:52:58',3310503965,1),(53276373,425599179,15938286,454632,1,'2007-09-17 18:52:58',3310503965,1),(53276374,425596334,15937686,454632,1,'2007-09-17 18:52:58',3310503965,1),(53276380,425634519,16020856,454632,1,'2007-09-17 18:52:05',3310504010,1),(53276381,425635214,16015620,454632,1,'2007-09-17 18:52:05',3310504010,1),(53276382,425634266,16013989,454632,1,'2007-09-17 18:52:05',3310504010,1),(53276383,425631105,16008839,454632,1,'2007-09-17 18:52:05',3310504010,1),(53276384,425629272,16004548,454632,1,'2007-09-17 18:52:05',3310504010,1),(53276385,425628703,16003689,454632,1,'2007-09-17 18:52:05',3310504010,1),(53276386,425627818,16003604,454632,1,'2007-09-17 18:52:05',3310504010,1),(53276387,425626806,16004977,454632,1,'2007-09-17 18:52:05',3310504010,1),(53276388,425626174,16006694,454632,1,'2007-09-17 18:52:05',3310504010,1),(53276389,425625162,16007809,454632,1,'2007-09-17 18:52:05',3310504010,1),(53276390,425623898,16008410,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276392,425623013,16007209,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276393,425621812,16004634,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276394,425619093,15997166,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276395,425617197,15990815,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276396,425617070,15987124,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276397,425617766,15983090,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276398,425619283,15978541,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276399,425619979,15975022,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276400,425620295,15970473,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276401,425620105,15963521,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276402,425620737,15957255,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276403,425622002,15954079,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276404,425623203,15952449,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276406,425624277,15952363,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276407,425624973,15952878,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276408,425625352,15954079,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276410,425625668,15956225,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276411,425626427,15958800,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276412,425626996,15960002,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276413,425628070,15960087,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276414,425628829,15959658,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276415,425629208,15958371,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276416,425631294,15950389,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276418,425632116,15946784,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276419,425631927,15944295,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276424,425621622,15935969,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276426,425620042,15934767,454632,1,'2007-09-17 19:00:22',3310504008,1),(53276459,425589949,16024203,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276460,425595892,16017766,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276461,425597536,16016478,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276462,425598168,16016392,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276463,425598863,16016478,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276464,425600001,16017508,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276465,425601961,16019826,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276466,425603858,16021199,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276467,425606007,16022143,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276468,425607651,16022830,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276469,425609168,16023945,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276470,425610875,16026864,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276471,425612139,16030383,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276472,425613973,16033559,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276473,425615174,16035103,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276474,425616122,16035447,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276475,425616754,16034932,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276476,425616754,16033816,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276477,425616502,16032700,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276478,425615427,16032357,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276479,425614036,16030812,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276480,425613341,16029439,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276481,425613088,16027465,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276482,425613088,16026091,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276483,425612329,16023431,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276484,425610749,16019997,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276485,425607651,16013817,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276486,425606639,16010985,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276487,425606450,16008067,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276488,425606639,16005921,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276489,425607082,16003174,454632,1,'2007-09-17 18:53:58',3310503967,1),(53276490,425607588,16001286,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276491,425607841,15999398,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276492,425607651,15997510,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276493,425607208,15995965,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276494,425607335,15995192,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276495,425607714,15994849,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276496,425608283,15994935,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276497,425608726,15995621,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276498,425608726,15997510,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276499,425608852,16001115,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276500,425609295,16004548,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276501,425610243,16006694,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276502,425611760,16008839,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276503,425613277,16010556,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276504,425615047,16012101,454632,1,'2007-09-17 19:00:22',3310503967,1),(53276505,425617323,16013045,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276506,425620990,16014418,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276507,425624341,16015620,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276508,425626047,16017079,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276509,425627059,16018710,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276510,425628197,16019997,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276511,425629019,16019997,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276512,425629967,16019053,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276513,425629967,16018023,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276514,425629777,16015706,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276515,425629019,16013045,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276516,425627754,16010728,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276517,425625605,16009698,454632,1,'2007-09-17 19:00:22',3310504010,1),(53276518,425582995,16030039,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276519,425582236,16026606,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276520,425582046,16022486,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276521,425582236,16020941,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276522,425581667,16019396,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276523,425580276,16018366,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276524,425578885,16019053,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276525,425577305,16020255,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276526,425576356,16020341,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276527,425575977,16019568,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276528,425575914,16018710,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276529,425576609,16018023,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276530,425580339,16015105,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276531,425581414,16014676,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276532,425582995,16015706,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276533,425583564,16018109,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276534,425585081,16023173,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276535,425586093,16025405,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276536,425587863,16025748,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276537,425588938,16025405,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276538,425587736,16035018,454632,1,'2007-09-17 18:54:40',3310503966,1),(53276539,425586725,16035275,454632,1,'2007-09-17 18:54:40',3310503966,1),(53276540,425586093,16033816,454632,1,'2007-09-17 18:54:40',3310503966,1),(53276541,425584955,16031155,454632,1,'2007-09-17 18:54:40',3310503966,1),(53276542,425583690,16028409,454632,1,'2007-09-17 18:54:40',3310503966,1),(53276543,425582173,16023345,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276588,425602783,16078791,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276589,425600128,16074929,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276590,425597030,16073041,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276592,425594375,16073212,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276593,425590581,16075015,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276594,425586851,16076646,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276595,425584006,16078190,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276597,425581920,16079907,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276598,425579644,16080680,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276599,425577305,16081710,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276600,425575218,16083512,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276601,425574144,16084971,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276602,425573385,16085572,454632,1,'2007-09-17 18:56:36',3310503988,1),(53276604,425572626,16085314,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276605,425572373,16084199,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276606,425572373,16083254,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276608,425573006,16082225,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276609,425584006,16068492,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276610,425587484,16064028,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276611,425591846,16061024,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276612,425594375,16060080,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276613,425597662,16059909,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276614,425601519,16059909,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276616,425605122,16060767,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276617,425607208,16062398,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276618,425609358,16064973,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276619,425609927,16065831,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276620,425610559,16065144,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276621,425610812,16063943,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276622,425610369,16061711,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276623,425608536,16058449,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276624,425606197,16056218,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276625,425604427,16054501,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276627,425603225,16052012,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276628,425601835,16048493,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276630,425600254,16047377,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276631,425598231,16046691,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276632,425590708,16047549,454632,1,'2007-09-17 19:00:22',3310503989,1),(53276633,425587610,16048064,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276634,425585397,16049266,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276635,425584322,16049609,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276636,425583690,16049609,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276637,425583184,16048751,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276639,425582995,16047892,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276641,425583058,16046776,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276643,425583753,16044373,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276645,425584386,16041283,454632,1,'2007-09-17 19:00:22',3310503988,1),(53276646,425584386,16036992,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276647,425584322,16035790,454632,1,'2007-09-17 19:00:22',3310503966,1),(53276648,425583753,16033215,454632,1,'2007-09-17 19:00:22',3310503966,1),(53277160,425603547,16080392,454632,1,'2007-09-17 19:10:42',3310503989,1),(53277161,425603701,16081548,454632,1,'2007-09-17 19:10:42',3310503989,1),(53277162,425603200,16082280,454632,1,'2007-09-17 19:10:42',3310503989,1),(53277163,425602545,16082435,454632,1,'2007-09-17 19:10:42',3310503989,1),(53277164,425601659,16082049,454632,1,'2007-09-17 19:10:42',3310503989,1),(53277165,425600734,16080623,454632,1,'2007-09-17 19:10:42',3310503989,1),(53277166,425599385,16079082,454632,1,'2007-09-17 19:10:43',3310503989,1),(53277167,425597535,16078465,454632,1,'2007-09-17 19:10:43',3310503989,1),(53277168,425595531,16078311,454632,1,'2007-09-17 19:10:43',3310503989,1),(53277169,425593643,16079352,454632,1,'2007-09-17 19:10:43',3310503989,1),(53277170,425591562,16081240,454632,1,'2007-09-17 19:10:43',3310503989,1),(53277171,425587014,16086519,454632,1,'2007-09-17 19:10:43',3310503988,1),(53277172,425583623,16092146,454632,1,'2007-09-17 19:10:44',3310503988,1),(53277173,425579309,16097856,454632,1,'2007-09-17 19:10:44',3310503990,1),(53277174,425631092,15942403,454632,1,'2007-09-17 19:10:44',3310504008,1),(53277175,425629182,15940430,454632,1,'2007-09-17 19:10:44',3310504008,1),(53277176,425627125,15938142,454632,1,'2007-09-17 19:10:44',3310504008,1),(53277177,425625194,15936190,454632,1,'2007-09-17 19:10:44',3310504008,1),(53277178,425623767,15935602,454632,1,'2007-09-17 19:10:45',3310504008,1),(53277179,425659528,15972911,454632,1,'2007-09-17 19:10:45',3310504009,1),(53277180,425662049,15972430,454632,1,'2007-09-17 19:10:45',3310504009,1),(53277181,425663756,15971581,454632,1,'2007-09-17 19:10:45',3310504009,1),(53277182,425669010,15967564,454632,1,'2007-09-17 19:10:45',3310504009,1),(53277183,425669248,15970862,454632,1,'2007-09-17 19:10:45',3310504009,1),(53277184,425670064,15973208,454632,1,'2007-09-17 19:10:45',3310504009,1),(53277185,425670676,15973718,454632,1,'2007-09-17 19:10:45',3310504009,1),(53277186,425671696,15974194,454632,1,'2007-09-17 19:10:46',3310504009,1),(53277187,425671893,15974570,454632,1,'2007-09-17 19:10:46',3310504012,1),(53277189,425671313,15973955,454632,1,'2007-09-17 19:10:46',3310504009,1),(53277190,425666834,15967496,454632,1,'2007-09-17 19:10:46',3310504009,1),(53277191,425667990,15972936,454632,1,'2007-09-17 19:10:46',3310504009,1),(53277192,425667990,15974568,454632,1,'2007-09-17 19:10:47',3310504009,1),(53277193,425702256,15948039,454632,1,'2007-09-17 19:10:47',3310504013,1),(53277194,425700435,15951681,454632,1,'2007-09-17 19:10:47',3310504013,1),(53277195,425699319,15953898,454632,1,'2007-09-17 19:10:47',3310504013,1),(53277196,425698153,15957114,454632,1,'2007-09-17 19:10:47',3310504012,1),(53277197,425697687,15960704,454632,1,'2007-09-17 19:10:48',3310504012,1),(53277198,425697361,15964200,454632,1,'2007-09-17 19:10:48',3310504012,1),(53277199,425696662,15969001,454632,1,'2007-09-17 19:10:48',3310504012,1),(53277200,425696102,15973569,454632,1,'2007-09-17 19:10:48',3310504012,1),(53277201,425694657,15976412,454632,1,'2007-09-17 19:10:48',3310504012,1),(53277202,425692886,15978277,454632,1,'2007-09-17 19:10:49',3310504012,1),(53277203,425691208,15978510,454632,1,'2007-09-17 19:10:49',3310504012,1),(53277204,425689670,15977671,454632,1,'2007-09-17 19:10:49',3310504012,1),(53277205,425686500,15976366,454632,1,'2007-09-17 19:10:49',3310504012,1),(53277206,425683703,15976039,454632,1,'2007-09-17 19:10:49',3310504012,1),(53277207,425681093,15976272,454632,1,'2007-09-17 19:10:49',3310504012,1),(53277208,425678762,15976412,454632,1,'2007-09-17 19:10:50',3310504012,1),(53277209,425677270,15977298,454632,1,'2007-09-17 19:10:50',3310504012,1),(53277210,425672423,15981307,454632,1,'2007-09-17 19:10:50',3310504012,1),(53277211,425670465,15984989,454632,1,'2007-09-17 19:10:50',3310504009,1),(53277212,425667901,15989418,454632,1,'2007-09-17 19:10:50',3310504011,1),(53277213,425666037,15991562,454632,1,'2007-09-17 19:10:50',3310504011,1),(53277214,425661748,15995943,454632,1,'2007-09-17 19:10:51',3310504011,1),(53277215,425659423,15996934,370566,1,'2008-05-09 02:14:23',3310504011,2),(53277216,425705850,15941318,454632,1,'2007-09-17 19:10:51',3310504013,1),(53277217,425707892,15938087,454632,1,'2007-09-17 19:10:51',3310504013,1),(53277218,425710601,15933574,454632,1,'2007-09-17 19:10:51',3310504013,1),(53277219,425713641,15927493,454632,1,'2007-09-17 19:10:51',3310504007,1),(53277220,425715114,15925212,454632,1,'2007-09-17 19:10:52',3310504007,1),(53277221,425717964,15922029,454632,1,'2007-09-17 19:10:52',3310504007,1),(53277222,425720197,15921459,454632,1,'2007-09-17 19:10:52',3310504007,1),(53277223,425722383,15920936,454632,1,'2007-09-17 19:10:52',3310504007,1),(53277224,425723998,15919178,454632,1,'2007-09-17 19:10:52',3310504007,1),(53277225,425726136,15913715,454632,1,'2007-09-17 19:10:52',3310504007,1),(53277226,425729082,15906874,454632,1,'2007-09-17 19:10:53',3310504018,1),(53277227,425729557,15906018,454632,1,'2007-09-17 19:10:53',3310504018,1),(53277228,425734878,15895186,454632,1,'2007-09-17 19:10:53',3310504018,1),(53277229,425736427,15892517,454632,1,'2007-09-17 19:10:53',3310504018,1),(53277230,425737404,15892061,454632,1,'2007-09-17 19:10:54',3310504018,1),(53277231,425737664,15890369,454632,1,'2007-09-17 19:10:54',3310504018,1),(53277232,425737794,15888872,454632,1,'2007-09-17 19:10:54',3310504018,1),(53277233,425740397,15888417,454632,1,'2007-09-17 19:10:54',3310504018,1),(53277234,425740983,15886855,454632,1,'2007-09-17 19:10:54',3310504018,1),(53277235,425741634,15885163,454632,1,'2007-09-17 19:10:54',3310504018,1),(53277236,425741439,15883991,454632,1,'2007-09-17 19:10:54',3310504018,1),(53277237,425742870,15881583,454632,1,'2007-09-17 19:10:55',3310504018,1),(53277238,425745408,15880412,454632,1,'2007-09-17 19:10:55',3310504018,1),(53277239,425745669,15880347,454632,1,'2007-09-17 19:10:55',3310504018,1),(53277240,425746775,15880412,454632,1,'2007-09-17 19:10:55',3310504018,1),(53277241,425748662,15879826,454632,1,'2007-09-17 19:10:56',3310504018,1),(53277242,425750485,15877939,454632,1,'2007-09-17 19:10:56',3310504018,1),(53277243,425751266,15877418,454632,1,'2007-09-17 19:10:56',3310504018,1),(53277244,425752828,15878134,454632,1,'2007-09-17 19:10:56',3310504018,1),(53277245,425755821,15876898,454632,1,'2007-09-17 19:10:57',3310504019,1),(53277246,425756407,15876898,454632,1,'2007-09-17 19:10:58',3310504019,1),(53277247,425757253,15877744,454632,1,'2007-09-17 19:10:58',3310504019,1),(53277248,425758294,15876768,454632,1,'2007-09-17 19:10:58',3310504019,1),(53277249,425759661,15876442,454632,1,'2007-09-17 19:10:58',3310504019,1),(53277250,425761028,15876312,454632,1,'2007-09-17 19:10:58',3310504019,1),(53277251,425762134,15875531,454632,1,'2007-09-17 19:10:58',3310504019,1),(53277252,425763240,15876052,454632,1,'2007-09-17 19:10:58',3310504019,1),(53277253,425764021,15876052,454632,1,'2007-09-17 19:10:59',3310504019,1),(53277254,425764672,15875531,454632,1,'2007-09-17 19:10:59',3310504019,1),(53277255,425765713,15874880,454632,1,'2007-09-17 19:10:59',3310504017,1),(53277256,425766820,15874880,454632,1,'2007-09-17 19:10:59',3310504017,1),(53277257,425767796,15875141,454632,1,'2007-09-17 19:10:59',3310504017,1),(53277258,425768512,15875141,454632,1,'2007-09-17 19:10:59',3310504017,1),(53277259,425770594,15875141,454632,1,'2007-09-17 19:10:59',3310504017,1),(53277260,425771766,15875141,454632,1,'2007-09-17 19:11:00',3310504017,1),(53277261,425772547,15875010,454632,1,'2007-09-17 19:11:00',3310504017,1),(53277262,425773197,15874034,454632,1,'2007-09-17 19:11:00',3310504017,1),(53277263,425775931,15871301,454632,1,'2007-09-17 19:11:00',3310504017,1),(53277264,425775735,15870195,454632,1,'2007-09-17 19:11:00',3310504017,1),(53277265,425776126,15869479,454632,1,'2007-09-17 19:11:00',3310504017,1),(53277266,425776907,15869088,454632,1,'2007-09-17 19:11:00',3310504017,1),(53277267,425777428,15867852,454632,1,'2007-09-17 19:11:00',3310504017,1),(53277268,425777948,15866550,454632,1,'2007-09-17 19:11:01',3310504017,1),(53277269,425779705,15864468,454632,1,'2007-09-17 19:11:01',3310504017,1),(53277270,425780486,15862515,454632,1,'2007-09-17 19:11:01',3310504017,1),(53277271,425780747,15861994,454632,1,'2007-09-17 19:11:01',3310504017,1),(53277272,425781658,15860368,454632,1,'2007-09-17 19:11:01',3310504020,1),(53277273,425785888,15860368,454632,1,'2007-09-17 19:11:01',3310504020,1),(53277274,425789597,15859977,454632,1,'2007-09-17 19:11:01',3310504020,1),(53277275,425790834,15859782,454632,1,'2007-09-17 19:11:02',3310504020,1),(53277276,425793437,15859261,454632,1,'2007-09-17 19:11:02',3310504020,1),(53277277,425794934,15858675,454632,1,'2007-09-17 19:11:02',3310504020,1),(53277278,425798578,15857829,454632,1,'2007-09-17 19:11:02',3310504020,1),(53277279,425805932,15857894,454632,1,'2007-09-17 19:11:03',3310504020,1),(53277280,425808666,15857699,454632,1,'2007-09-17 19:11:03',3310504020,1),(53277281,425814132,15857309,454632,1,'2007-09-17 19:11:03',3310504021,1),(53277282,425818428,15855942,454632,1,'2007-09-17 19:11:03',3310504021,1),(53277283,425823048,15854250,454632,1,'2007-09-17 19:11:04',3310504021,1),(53277284,425828710,15852558,454632,1,'2007-09-17 19:11:04',3310504021,1),(53277285,425833461,15851061,454632,1,'2007-09-17 19:11:05',3310504021,1),(53277286,425836324,15850671,454632,1,'2007-09-17 19:11:05',3310504021,1),(53277287,425841075,15850671,454632,1,'2007-09-17 19:11:05',3310504192,1),(53277288,425844720,15850801,454632,1,'2007-09-17 19:11:05',3310504192,1),(53277289,425846672,15852428,454632,1,'2007-09-17 19:11:05',3310504192,1),(53277290,425847193,15852233,454632,1,'2007-09-17 19:11:06',3310504192,1),(53277291,425848234,15850606,454632,1,'2007-09-17 19:11:06',3310504192,1),(53277292,425850186,15851256,454632,1,'2007-09-17 19:11:06',3310504192,1),(53277293,425852334,15851061,454632,1,'2007-09-17 19:11:06',3310504192,1),(53277294,425853505,15851712,454632,1,'2007-09-17 19:11:06',3310504192,1),(53277295,425855197,15853274,454632,1,'2007-09-17 19:11:07',3310504192,1),(53277296,425857085,15854250,454632,1,'2007-09-17 19:11:07',3310504192,1),(53277297,425859297,15854120,454632,1,'2007-09-17 19:11:07',3310504192,1),(53277298,425860729,15853599,454632,1,'2007-09-17 19:11:07',3310504192,1),(53277299,425862812,15851191,454632,1,'2007-09-17 19:11:08',3310504192,1),(53277300,425863463,15851061,454632,1,'2007-09-17 19:11:08',3310504192,1),(53277301,425865870,15849825,454632,1,'2007-09-17 19:11:09',3310504193,1),(53277302,425868083,15848848,454632,1,'2007-09-17 19:11:09',3310504193,1),(53277303,425871923,15847742,454632,1,'2007-09-17 19:11:09',3310504193,1),(53277304,425874201,15847872,454632,1,'2007-09-17 19:11:10',3310504193,1),(53277305,425875567,15849434,454632,1,'2007-09-17 19:11:10',3310504193,1),(53277306,425876869,15849760,454632,1,'2007-09-17 19:11:10',3310504193,1),(53277307,425878496,15849174,454632,1,'2007-09-17 19:11:11',3310504193,1),(53277308,425881685,15848133,454632,1,'2007-09-17 19:11:11',3310504193,1),(53277309,425882921,15848133,454632,1,'2007-09-17 19:11:12',3310504193,1),(53277310,425884093,15848133,454632,1,'2007-09-17 19:11:12',3310504193,1),(53277311,425885394,15848393,454632,1,'2007-09-17 19:11:12',3310504193,1),(53277312,425889429,15844814,454632,1,'2007-09-17 19:11:12',3310504193,1),(53277313,425890080,15844293,454632,1,'2007-09-17 19:11:12',3310504193,1),(53278142,425709215,16679923,454632,1,'2007-09-17 19:28:51',3310504175,1),(53278144,425712862,16683844,454632,1,'2007-09-17 19:28:51',3310504175,1),(53278146,425715233,16686579,454632,1,'2007-09-17 19:28:52',3310504175,1),(53278147,425718151,16689041,454632,1,'2007-09-17 19:28:52',3310504175,1),(53278148,425721251,16689588,454632,1,'2007-09-17 19:28:52',3310504175,1),(53278149,425724625,16690591,454632,1,'2007-09-17 19:28:52',3310504175,1),(53278150,425726996,16692050,454632,1,'2007-09-17 19:28:53',3310504186,1),(53278151,425730005,16693965,454632,1,'2007-09-17 19:28:53',3310504186,1),(53278152,425734108,16693874,454632,1,'2007-09-17 19:28:53',3310504186,1),(53278153,425735567,16693418,454632,1,'2007-09-17 19:28:53',3310504186,1),(53278154,425738850,16685667,454632,1,'2007-09-17 19:28:54',3310504186,1),(53278155,425738576,16682841,454632,1,'2007-09-17 19:28:54',3310504186,1),(53278156,425737482,16680379,454632,1,'2007-09-17 19:28:54',3310504186,1),(53278157,425735294,16679467,454632,1,'2007-09-17 19:28:54',3310504186,1),(53278158,425733561,16679558,454632,1,'2007-09-17 19:28:55',3310504186,1),(53278159,425731555,16678281,454632,1,'2007-09-17 19:28:55',3310504186,1),(53278160,425729914,16678008,454632,1,'2007-09-17 19:28:55',3310504186,1),(53278161,425727543,16678464,454632,1,'2007-09-17 19:28:55',3310504186,1),(53278162,425725810,16678190,454632,1,'2007-09-17 19:28:56',3310504175,1),(53278163,425725081,16676458,454632,1,'2007-09-17 19:28:56',3310504175,1),(53278164,425721525,16674999,454632,1,'2007-09-17 19:28:57',3310504175,1),(53278165,425718242,16674269,454632,1,'2007-09-17 19:28:57',3310504175,1),(53278166,425716054,16674816,454632,1,'2007-09-17 19:28:57',3310504175,1),(53278167,425708394,16676549,454632,1,'2007-09-17 19:28:57',3310504175,1),(53278168,425644016,16646532,454632,1,'2007-09-17 19:28:58',3310504170,1),(53278169,425660822,16651807,4106774,1,'2010-03-12 16:31:14',3310504171,2),(53278170,425705134,16665947,4106774,1,'2010-03-12 16:31:14',3310504175,2),(53278171,425715364,16668954,4106774,1,'2010-03-12 16:31:14',3310504175,2),(53278172,425720281,16670684,4106774,1,'2010-03-12 16:31:14',3310504175,2),(53278173,425741793,16677959,454632,1,'2007-09-17 19:28:59',3310504186,1),(53278174,425747662,16679717,4106774,1,'2010-03-12 16:31:14',3310504186,2),(53278175,425761620,16683807,4106774,1,'2010-03-12 16:31:15',3310504187,3),(53278176,425676155,16660424,454632,1,'2007-09-17 19:29:00',3310504174,1),(53278177,425681652,16661776,454632,1,'2007-09-17 19:29:00',3310504174,1),(53278178,425688410,16665650,454632,1,'2007-09-17 19:29:00',3310504174,1),(53278179,425690122,16665650,454632,1,'2007-09-17 19:29:01',3310504174,1),(53278180,425689671,16670156,454632,1,'2007-09-17 19:29:01',3310504174,1),(53278181,425687058,16674481,454632,1,'2007-09-17 19:29:01',3310504174,1),(53278182,425682012,16678806,454632,1,'2007-09-17 19:29:01',3310504174,1),(53278183,425678137,16679887,454632,1,'2007-09-17 19:29:02',3310504174,1),(53278185,425672280,16679166,454632,1,'2007-09-17 19:29:02',3310504174,1),(53278186,425669127,16678445,454632,1,'2007-09-17 19:29:02',3310504171,1),(53278188,425667595,16676193,454632,1,'2007-09-17 19:29:02',3310504171,1),(53278190,425665613,16672498,454632,1,'2007-09-17 19:29:03',3310504171,1),(53278192,425665973,16670066,454632,1,'2007-09-17 19:29:03',3310504171,1),(53278194,425667685,16669525,454632,1,'2007-09-17 19:29:03',3310504171,1),(53278196,425668856,16669345,454632,1,'2007-09-17 19:29:04',3310504171,1),(53278197,425668406,16668083,454632,1,'2007-09-17 19:29:04',3310504171,1),(53278199,425668946,16666101,454632,1,'2007-09-17 19:29:04',3310504171,1),(53278200,425670298,16663938,454632,1,'2007-09-17 19:29:04',3310504171,1),(53278201,425665252,16663848,454632,1,'2007-09-17 19:29:04',3310504171,1),(53278202,425665342,16661595,454632,1,'2007-09-17 19:29:05',3310504171,1),(53278203,425665432,16657721,454632,1,'2007-09-17 19:29:05',3310504171,1),(53278204,425692714,16676203,454632,1,'2007-09-17 19:29:05',3310504174,1),(53278205,425685632,16679238,454632,1,'2007-09-17 19:29:05',3310504174,1),(53278206,425676123,16687736,454632,1,'2007-09-17 19:29:05',3310504174,1),(53278207,425670053,16691176,454632,1,'2007-09-17 19:29:07',3310504171,1),(53278208,425666208,16695627,454632,1,'2007-09-17 19:29:07',3310504171,1),(53278210,425665803,16701293,454632,1,'2007-09-17 19:29:07',3310504513,1),(53278211,425671469,16703114,454632,1,'2007-09-17 19:29:07',3310504513,1),(53278212,425675313,16702507,454632,1,'2007-09-17 19:29:07',3310504516,1),(53278213,425684216,16697448,454632,1,'2007-09-17 19:29:08',3310504174,1),(53278214,425690286,16693199,454632,1,'2007-09-17 19:29:08',3310504174,1),(53278215,425695951,16687331,454632,1,'2007-09-17 19:29:08',3310504174,1),(53278216,425699391,16683285,454632,1,'2007-09-17 19:29:08',3310504175,1),(53278217,425701212,16676001,454632,1,'2007-09-17 19:29:08',3310504175,1),(53278218,425702270,16684514,454632,1,'2007-09-17 19:29:08',3310504175,1),(53278219,425710054,16689536,454632,1,'2007-09-17 19:29:09',3310504175,1),(53278220,425715201,16694181,454632,1,'2007-09-17 19:29:09',3310504175,1),(53278221,425720349,16697948,454632,1,'2007-09-17 19:29:09',3310504175,1),(53278222,425728259,16698826,454632,1,'2007-09-17 19:29:10',3310504186,1),(53278223,425730770,16701086,454632,1,'2007-09-17 19:29:10',3310504528,1),(53278224,425722232,16716278,454632,1,'2007-09-17 19:29:10',3310504517,1),(53278226,425711184,16733604,454632,1,'2007-09-17 19:29:10',3310504517,1),(53278232,425696243,16745280,454632,1,'2007-09-17 19:29:13',3310504516,1),(53278233,425683186,16751809,454632,1,'2007-09-17 19:29:16',3310504516,1),(53278234,425667994,16758338,454632,1,'2007-09-17 19:29:17',3310504515,1),(53278235,425629701,16778552,454632,1,'2007-09-17 19:29:17',3310504514,1),(53278236,425620661,16787089,454632,1,'2007-09-17 19:29:17',3310504514,1),(53278237,425606599,16804917,454632,1,'2007-09-17 19:29:18',3310504471,1),(53278238,425602205,16813329,454632,1,'2007-09-17 19:29:18',3310504477,1),(53278239,425582242,16790981,454632,1,'2007-09-17 19:29:18',3310504470,1),(53278240,425596681,16763109,454632,1,'2007-09-17 19:29:18',3310504471,1),(53278241,425609487,16751432,454632,1,'2007-09-17 19:29:18',3310504469,1),(53278242,425632588,16731093,454632,1,'2007-09-17 19:29:18',3310504512,1),(53278252,425644139,16720547,454632,1,'2007-09-17 19:29:22',3310504512,1),(53278253,425653430,16711884,454632,1,'2007-09-17 19:29:22',3310504513,1),(53278255,425660210,16706485,454632,1,'2007-09-17 19:29:22',3310504513,1),(53278256,425676155,16705732,454632,1,'2007-09-17 19:29:22',3310504516,1),(53278257,425682683,16701589,454632,1,'2007-09-17 19:29:22',3310504516,1),(53278258,425747198,16263155,454632,1,'2007-09-17 19:29:23',3310504144,1),(53278259,425756075,16279306,454632,1,'2007-09-17 19:29:23',3310504145,1),(53278261,425763181,16276745,454632,1,'2007-09-17 19:29:23',3310504145,1),(53278263,425770166,16279306,454632,1,'2007-09-17 19:29:23',3310504145,1),(53278264,425770399,16287688,454632,1,'2007-09-17 19:29:23',3310504145,1),(53278265,425775987,16299795,454632,1,'2007-09-17 19:29:23',3310504145,1),(53278267,425780411,16309341,454632,1,'2007-09-17 19:29:24',3310504145,1),(53278268,425778315,16320750,454632,1,'2007-09-17 19:29:24',3310504147,1),(53278269,425776453,16338678,454632,1,'2007-09-17 19:29:24',3310504147,1),(53278271,425779247,16357770,454632,1,'2007-09-17 19:29:24',3310504147,1),(53278272,425781575,16374533,454632,1,'2007-09-17 19:29:24',3310504153,1),(53278273,425782506,16417839,454632,1,'2007-09-17 19:29:25',3310504156,1),(53278274,425781575,16441821,454632,1,'2007-09-17 19:29:25',3310504155,1),(53278275,425776918,16460680,454632,1,'2007-09-17 19:29:25',3310504155,1),(53278276,425770399,16476512,454632,1,'2007-09-17 19:29:26',3310504155,1),(53278277,425755032,16492112,454632,1,'2007-09-17 19:29:26',3310504177,1),(53278278,425748280,16494440,454632,1,'2007-09-17 19:29:26',3310504176,1),(53278280,425738734,16489551,454632,1,'2007-09-17 19:29:26',3310504176,1),(53278282,425726860,16485127,454632,1,'2007-09-17 19:29:26',3310504176,1),(53278283,425719177,16483497,454632,1,'2007-09-17 19:29:27',3310504165,1),(53278285,425697989,16486524,454632,1,'2007-09-17 19:29:27',3310504164,1),(53278286,425688210,16487688,454632,1,'2007-09-17 19:29:27',3310504164,1),(53278287,425686581,16477909,454632,1,'2007-09-17 19:29:27',3310504142,1),(53278289,425684252,16461844,454632,1,'2007-09-17 19:29:27',3310504142,1),(53278290,425683787,16436466,454632,1,'2007-09-17 19:29:27',3310504142,1),(53278291,425687978,16419935,454632,1,'2007-09-17 19:29:28',3310504140,1),(53278292,425701714,16414580,454632,1,'2007-09-17 19:29:28',3310504141,1),(53278293,425703111,16406431,454632,1,'2007-09-17 19:29:28',3310504141,1),(53278294,425697989,16403637,454632,1,'2007-09-17 19:29:28',3310504140,1),(53278296,425686813,16405267,454632,1,'2007-09-17 19:29:28',3310504140,1),(53278298,425674706,16410622,454632,1,'2007-09-17 19:29:29',3310504140,1),(53278299,425676569,16412252,454632,1,'2007-09-17 19:29:29',3310504140,1),(53278301,425663298,16407129,454632,1,'2007-09-17 19:29:30',3310504137,1),(53278302,425674473,16390831,454632,1,'2007-09-17 19:29:30',3310504140,1),(53278304,425679596,16380587,454632,1,'2007-09-17 19:29:30',3310504140,1),(53278305,425687512,16373602,454632,1,'2007-09-17 19:29:30',3310504140,1),(53278306,425678432,16372671,454632,1,'2007-09-17 19:29:31',3310504140,1),(53278308,425668420,16379655,454632,1,'2007-09-17 19:29:31',3310504137,1),(53278309,425656313,16395255,454632,1,'2007-09-17 19:29:31',3310504137,1),(53278311,425647931,16400144,454632,1,'2007-09-17 19:29:32',3310504137,1),(53278312,425638618,16378491,454632,1,'2007-09-17 19:29:32',3310504136,1),(53278314,425638618,16364754,454632,1,'2007-09-17 19:29:32',3310504130,1),(53278315,425648164,16352647,454632,1,'2007-09-17 19:29:32',3310504131,1),(53278316,425654450,16341472,454632,1,'2007-09-17 19:29:32',3310504131,1),(53278317,425655614,16328433,454632,1,'2007-09-17 19:29:33',3310504131,1),(53278319,425651423,16297933,454632,1,'2007-09-17 19:29:33',3310504129,1),(53278321,425650026,16275348,454632,1,'2007-09-17 19:29:33',3310504129,1),(53278324,425648629,16252997,454632,1,'2007-09-17 19:29:33',3310504043,1),(53278327,425645137,16238561,454632,1,'2007-09-17 19:29:33',3310504043,1),(53278328,425641877,16231343,454632,1,'2007-09-17 19:29:34',3310504042,1),(53278330,425635125,16233206,454632,1,'2007-09-17 19:29:34',3310504042,1),(53278332,425628656,16224038,454632,1,'2007-09-17 19:29:34',3310504042,1),(53278333,425629059,16210761,454632,1,'2007-09-17 19:29:34',3310504042,1),(53278336,425626645,16205129,454632,1,'2007-09-17 19:29:35',3310504042,1),(53278337,425612563,16207945,454632,1,'2007-09-17 19:29:35',3310503999,1),(53278338,425601298,16221222,454632,1,'2007-09-17 19:29:35',3310503999,1),(53278341,425588021,16234499,454632,1,'2007-09-17 19:29:36',3310503998,1),(53278342,425582791,16230878,454632,1,'2007-09-17 19:29:36',3310503998,1),(53278343,425569514,16253408,454632,1,'2007-09-17 19:29:36',3310503998,1),(53278346,425565491,16266283,454632,1,'2007-09-17 19:29:37',3310504084,1),(53278347,425560663,16267087,454632,1,'2007-09-17 19:29:37',3310504081,1),(53278348,425559858,16253006,454632,1,'2007-09-17 19:29:37',3310503995,1),(53278350,425575951,16222429,454632,1,'2007-09-17 19:29:37',3310503998,1),(53278351,425588424,16203117,454632,1,'2007-09-17 19:29:37',3310503996,1),(53278353,425592849,16178575,454632,1,'2007-09-17 19:29:37',3310503997,1),(53278355,425604114,16156447,454632,1,'2007-09-17 19:29:38',3310503997,1),(53278356,425606126,16125065,454632,1,'2007-09-17 19:29:38',3310503991,1),(53278358,425600493,16120640,454632,1,'2007-09-17 19:29:38',3310503991,1),(53278360,425603039,16103200,454632,1,'2007-09-17 19:29:38',3310503991,1),(53278361,425607522,16093180,454632,1,'2007-09-17 19:29:38',3310503989,1),(53278362,425625583,16063781,454632,1,'2007-09-17 19:29:38',3310504032,1),(53278364,425641667,16040842,454632,1,'2007-09-17 19:29:39',3310504032,1),(53278366,425660256,16034909,454632,1,'2007-09-17 19:29:39',3310504011,1),(53278367,425668166,16035964,454632,1,'2007-09-17 19:29:39',3310504011,1),(53278368,425679108,16045852,454632,1,'2007-09-17 19:29:39',3310504036,1),(53278369,425684513,16052443,454632,1,'2007-09-17 19:29:39',3310504036,1),(53278371,425690446,16055080,454632,1,'2007-09-17 19:29:40',3310504036,1),(53278374,425695324,16060749,454632,1,'2007-09-17 19:29:40',3310504036,1),(53278375,425698092,16068132,454632,1,'2007-09-17 19:29:41',3310504036,1),(53278376,425699279,16077228,454632,1,'2007-09-17 19:29:41',3310504037,1),(53278377,425704157,16082370,454632,1,'2007-09-17 19:29:41',3310504037,1),(53278379,425707716,16087248,454632,1,'2007-09-17 19:29:41',3310504037,1),(53278383,425708903,16092653,454632,1,'2007-09-17 19:29:41',3310504037,1),(53278387,425707321,16098058,454632,1,'2007-09-17 19:29:42',3310504039,1),(53278390,425707980,16108605,454632,1,'2007-09-17 19:29:42',3310504039,1),(53278395,425710485,16118756,454632,1,'2007-09-17 19:29:42',3310504039,1),(53278401,425713192,16131077,454632,1,'2007-09-17 19:29:43',3310504039,1),(53278404,425713637,16141553,454632,1,'2007-09-17 19:29:43',3310504039,1),(53278409,425718541,16150246,454632,1,'2007-09-17 19:29:43',3310504045,1),(53278412,425726120,16165181,454632,1,'2007-09-17 19:29:44',3310504045,1),(53278418,425727457,16172314,454632,1,'2007-09-17 19:29:44',3310504056,1),(53278420,425734367,16195941,454632,1,'2007-09-17 19:29:44',3310504056,1),(53278423,425739048,16220014,454632,1,'2007-09-17 19:29:44',3310504058,1),(53278426,425738157,16231159,454632,1,'2007-09-17 19:29:45',3310504058,1),(53278429,425742392,16250329,454632,1,'2007-09-17 19:29:45',3310504058,1),(53281369,425558721,16162295,454632,1,'2007-09-17 19:41:03',3310503993,1),(53281374,425563031,16156468,454632,1,'2007-09-17 19:41:04',3310503996,1),(53281378,425567422,16150121,454632,1,'2007-09-17 19:41:04',3310503990,1),(53281382,425573488,16140782,454632,1,'2007-09-17 19:41:04',3310503990,1),(53281386,425581311,16129048,454632,1,'2007-09-17 19:41:04',3310503990,1),(53281388,425590052,16116315,454632,1,'2007-09-17 19:41:05',3310503991,1),(53281393,425599990,16101667,454632,1,'2007-09-17 19:41:05',3310503991,1),(53281395,425601427,16099353,454632,1,'2007-09-17 19:41:05',3310503991,1),(53281399,425616083,16077259,454632,1,'2007-09-17 19:41:05',3310503989,1),(53281402,425634996,16049762,454632,1,'2007-09-17 19:41:05',3310504032,1),(53281403,425657390,16016703,454632,1,'2007-09-17 19:41:05',3310504011,1),(53281406,425571653,15973792,320551,1,'2008-12-11 14:24:02',3310503964,3),(53281412,425570979,15986944,320551,1,'2008-12-11 14:23:59',3310503966,2),(53281415,425568281,15995375,320551,1,'2008-12-11 14:24:00',3310503966,2),(53281420,425564909,16008527,320551,1,'2008-12-11 14:24:00',3310503966,2),(53281424,425564572,16017295,320551,1,'2008-12-11 14:24:00',3310503966,2),(53281426,425568618,16026738,320551,1,'2008-12-11 14:24:00',3310503966,2),(53281430,425570305,16037529,320551,1,'2008-12-11 14:24:00',3310503966,2),(53281433,425564234,16055403,320551,1,'2008-12-11 14:24:00',3310503988,2),(53281436,425556815,16072939,320551,1,'2008-12-11 14:24:00',3310503985,2),(53281440,425549396,16089464,320551,1,'2008-12-11 14:24:00',3310503985,2),(53281444,425541302,16109698,320551,1,'2008-12-11 14:24:00',3310503987,2),(53282638,425537930,16122850,320551,1,'2008-12-11 14:24:00',3310503987,2),(53282705,425530511,16130944,320551,1,'2008-12-11 14:24:00',3310503986,2),(53282708,425525789,16132293,320551,1,'2008-12-11 14:24:00',3310503986,2),(53282709,425522417,16134316,320551,1,'2008-12-11 14:24:00',3310503986,2),(53282712,425514998,16133304,320551,1,'2008-12-11 14:24:00',3310503986,2),(53282714,425506904,16132967,320551,1,'2008-12-11 14:24:00',3310503975,2),(53282716,425498136,16137351,320551,1,'2008-12-11 14:24:00',3310503975,2),(53282719,425492740,16145782,320551,1,'2008-12-11 14:24:00',3310503975,2),(53282721,425492066,16158260,320551,1,'2008-12-11 14:24:00',3310503981,2),(53282723,425485658,16167365,320551,1,'2008-12-11 14:24:00',3310503981,2),(53282725,425477902,16167365,320551,1,'2008-12-11 14:24:00',3310503980,2),(53282727,425471157,16158597,320551,1,'2008-12-11 14:24:00',3310503980,2),(53282729,425460028,16154213,320551,1,'2008-12-11 14:24:00',3310503980,2),(53282730,425458342,16139037,320551,1,'2008-12-11 14:24:00',3310503974,2),(53282731,425459017,16134990,320551,1,'2008-12-11 14:24:00',3310503974,2),(53282734,425449574,16125885,320551,1,'2008-12-11 14:24:00',3310503971,2),(53282735,425448225,16120827,320551,1,'2008-12-11 14:24:00',3310503971,2),(53282738,425447551,16114419,320551,1,'2008-12-11 14:24:00',3310503971,2),(53282741,425441818,16113070,320551,1,'2008-12-11 14:24:00',3310503971,2),(53282743,425447551,16090475,320551,1,'2008-12-11 14:24:00',3310503969,2),(53282745,425439120,16091487,320551,1,'2008-12-11 14:24:00',3310503969,2),(53282748,425429340,16096208,320551,1,'2008-12-11 14:24:00',3310503971,2),(53282751,425426642,16100592,320551,1,'2008-12-11 14:24:01',3310503971,2),(53282753,425433387,16108012,320551,1,'2008-12-11 14:24:01',3310503971,2),(53282756,425431363,16115431,320551,1,'2008-12-11 14:24:01',3310503971,2),(53282759,425434061,16127571,320551,1,'2008-12-11 14:24:01',3310503971,2),(53282761,425434061,16140049,320551,1,'2008-12-11 14:24:01',3310503971,2),(53282764,425430014,16149492,320551,1,'2008-12-11 14:24:01',3310503971,2),(53282767,425421921,16155899,320551,1,'2008-12-11 14:24:01',3310503976,2),(53282768,425425293,16165679,320551,1,'2008-12-11 14:24:01',3310503977,2),(53282769,425429677,16172086,320551,1,'2008-12-11 14:24:01',3310503977,2),(53282772,425425967,16188948,320551,1,'2008-12-11 14:24:01',3310503977,2),(53282773,425427654,16205473,320551,1,'2008-12-11 14:24:01',3310503979,2),(53282777,425424956,16214915,320551,1,'2008-12-11 14:24:01',3310503979,2),(53282780,425415513,16208171,320551,1,'2008-12-11 14:24:01',3310503978,2),(53282784,425409106,16202438,320551,1,'2008-12-11 14:24:01',3310503976,2),(53282787,425404047,16199403,320551,1,'2008-12-11 14:24:01',3310503976,2),(53282789,425401012,16188611,320551,1,'2008-12-11 14:24:01',3310503976,2),(53282791,425397302,16165342,320551,1,'2008-12-11 14:24:01',3310503976,2),(53282794,425400338,16151852,320551,1,'2008-12-11 14:24:01',3310503976,2),(53282796,425397977,16146794,320551,1,'2008-12-11 14:24:02',3310503970,2),(53282803,425388872,16135665,320551,1,'2008-12-11 14:24:02',3310493047,2),(53282804,425378080,16130269,320551,1,'2008-12-11 14:24:02',3310493047,2),(53282808,425370998,16122175,320551,1,'2008-12-11 14:24:02',3310493047,2),(53282811,425371335,16104976,320551,1,'2008-12-11 14:24:02',3310493047,2),(53282814,425377743,16094522,320551,1,'2008-12-11 14:24:02',3310493045,2),(53282815,425376731,16076649,320551,1,'2008-12-11 14:24:02',3310493045,2),(53282817,425372684,16024040,320551,1,'2008-12-11 14:24:02',3310493023,2),(53282818,425366277,15951534,320551,1,'2008-12-11 14:24:02',3310493020,2),(53282819,425364928,15911740,320551,1,'2008-12-11 14:24:02',3310493014,2),(53282820,425372347,15913089,320551,1,'2008-12-11 14:24:02',3310493015,2),(53282822,425378080,15916124,320551,1,'2008-12-11 14:24:02',3310493015,2),(53282825,425389546,15921183,320551,1,'2008-12-11 14:24:02',3310493015,2),(53282827,425400675,15922194,320551,1,'2008-12-11 14:24:02',3310503938,2),(53282829,425406408,15926241,320551,1,'2008-12-11 14:24:02',3310503938,2),(53282831,425415176,15924892,320551,1,'2008-12-11 14:24:02',3310503938,2),(53282834,425420909,15920171,320551,1,'2008-12-11 14:24:02',3310503938,2),(53282839,425428665,15919159,320551,1,'2008-12-11 14:24:02',3310503939,2),(53282840,425441143,15921857,320551,1,'2008-12-11 14:24:02',3310503939,2),(53282842,425448225,15920846,320551,1,'2008-12-11 14:24:02',3310503939,2),(53282843,425455981,15917810,320551,1,'2008-12-11 14:24:02',3310503942,2),(53282846,425464412,15918148,320551,1,'2008-12-11 14:24:02',3310503942,2),(53282849,425471157,15920508,320551,1,'2008-12-11 14:24:02',3310503942,2),(53282852,425482623,15920508,320551,1,'2008-12-11 14:24:02',3310503943,2),(53282854,425502183,15919834,320551,1,'2008-12-11 14:24:02',3310503943,2),(53282856,425527781,15914072,320551,1,'2008-12-11 14:24:02',3310503954,2),(53282858,425549396,15920846,320551,1,'2008-12-11 14:24:02',3310503955,2),(53282860,425554454,15933661,320551,1,'2008-12-11 14:24:02',3310503961,2),(53282920,425555466,15941754,320551,1,'2008-12-11 14:24:02',3310503961,2),(53282925,425565583,15951197,320551,1,'2008-12-11 14:24:02',3310503964,2),(53282927,425569967,15956930,320551,1,'2008-12-11 14:24:02',3310503964,2),(53282932,425557833,15903245,454632,1,'2007-09-17 19:45:22',3310503955,1),(53282936,425556218,15905551,454632,1,'2007-09-17 19:45:22',3310503955,1),(53282940,425554880,15906612,454632,1,'2007-09-17 19:45:22',3310503955,1),(53282941,425553773,15907028,454632,1,'2007-09-17 19:45:22',3310503955,1),(53282943,425551097,15906243,454632,1,'2007-09-17 19:45:23',3310503955,1),(53282946,425548883,15906105,454632,1,'2007-09-17 19:45:23',3310503955,1),(53282948,425544500,15905690,454632,1,'2007-09-17 19:45:23',3310503955,1),(53282950,425542793,15905413,454632,1,'2007-09-17 19:45:24',3310503955,1),(53282952,425540994,15904859,454632,1,'2007-09-17 19:45:24',3310503955,1),(53282953,425538641,15904675,454632,1,'2007-09-17 19:45:24',3310503955,1),(53282957,425536565,15905136,454632,1,'2007-09-17 19:45:24',3310503955,1),(53282958,425534028,15906013,454632,1,'2007-09-17 19:45:25',3310503954,1),(53282959,425532090,15907443,454632,1,'2007-09-17 19:45:25',3310503954,1),(53282960,425530845,15908965,454632,1,'2007-09-17 19:45:25',3310503954,1),(53282963,425529738,15909934,454632,1,'2007-09-17 19:45:25',3310503954,1),(53282966,425528769,15909934,454632,1,'2007-09-17 19:45:26',3310503954,1),(53282968,425528123,15909011,454632,1,'2007-09-17 19:45:26',3310503954,1),(53282970,425527846,15907812,454632,1,'2007-09-17 19:45:27',3310503954,1),(53282972,425528677,15904629,454632,1,'2007-09-17 19:45:27',3310503954,1),(53282974,425530061,15903014,454632,1,'2007-09-17 19:45:27',3310503954,1),(53282976,425533428,15898954,454632,1,'2007-09-17 19:45:27',3310503954,1),(53282979,425534489,15896740,454632,1,'2007-09-17 19:45:28',3310503955,1),(53282983,425535504,15894664,454632,1,'2007-09-17 19:45:28',3310503955,1),(53282985,425535458,15893142,454632,1,'2007-09-17 19:45:28',3310503955,1),(53282987,425534812,15892542,454632,1,'2007-09-17 19:45:28',3310503955,1),(53282989,425533797,15893188,454632,1,'2007-09-17 19:45:28',3310503954,1),(53282991,425532967,15894987,454632,1,'2007-09-17 19:45:28',3310503954,1),(53282996,425532044,15896371,454632,1,'2007-09-17 19:45:28',3310503954,1),(53282998,425529046,15899139,454632,1,'2007-09-17 19:45:29',3310503954,1),(53283003,425526093,15902137,454632,1,'2007-09-17 19:45:29',3310503954,1),(53283007,425522633,15905459,454632,1,'2007-09-17 19:45:30',3310503954,1),(53283011,425518343,15907673,454632,1,'2007-09-17 19:45:30',3310503954,1),(53288119,425339794,15751749,188228,1,'2008-06-16 20:04:59',3310491641,2),(53288123,425341159,15758337,502899,1,'2007-09-23 18:56:14',3310491641,1),(53288126,425343652,15765997,188228,1,'2008-06-16 20:03:59',3310491646,2),(53288128,425344838,15773008,188228,1,'2008-06-16 20:04:22',3310491646,3),(53288129,425344868,15773649,188228,1,'2008-06-16 20:04:22',3310491646,2),(53288131,425344175,15773932,188228,1,'2008-06-16 20:04:22',3310491646,2),(53288134,425343867,15773724,188228,1,'2008-06-16 20:04:22',3310491646,2),(53288136,425343742,15773290,188228,1,'2008-06-16 20:04:22',3310491646,2),(53288138,425343974,15772875,188228,1,'2008-06-16 20:04:22',3310491646,2),(53288140,425344264,15772754,188228,1,'2008-06-16 20:04:22',3310491646,2),(53288141,425344318,15768970,454632,1,'2007-09-17 19:58:20',3310491646,1),(53288143,425344980,15770889,188228,1,'2008-06-16 20:03:59',3310491646,2),(53288147,425345044,15771919,188228,1,'2008-06-16 20:03:59',3310491646,2),(53288148,425344680,15772820,188228,1,'2008-06-16 20:04:22',3310491646,2),(53288150,425338534,15745675,454632,1,'2007-09-17 19:58:21',3310491641,1),(53288152,425337760,15740784,370566,1,'2008-05-09 02:14:25',3310491641,2),(53288157,425336316,15733553,188228,1,'2008-06-16 19:47:46',3310491641,2),(53288160,425335353,15727110,454632,1,'2007-09-17 19:58:21',3310491641,1),(53288161,425335926,15726173,454632,1,'2007-09-17 19:58:22',3310491641,1),(53288164,425337539,15724247,454632,1,'2007-09-17 19:58:22',3310491641,1),(53288166,425340402,15721592,454632,1,'2007-09-17 19:58:22',3310491641,1),(53288168,425340663,15719614,454632,1,'2007-09-17 19:58:22',3310491641,1),(53288171,425340559,15718990,454632,1,'2007-09-17 19:58:22',3310491641,1),(53288173,425339986,15718157,454632,1,'2007-09-17 19:58:23',3310491641,1),(53288174,425338476,15717845,454632,1,'2007-09-17 19:58:23',3310491641,1),(53288176,425337123,15717220,454632,1,'2007-09-17 19:58:23',3310491641,1),(53288178,425336030,15715450,454632,1,'2007-09-17 19:58:23',3310491641,1),(53288180,425334416,15708527,454632,1,'2007-09-17 19:58:23',3310491635,1),(53288182,425333896,15706133,454632,1,'2007-09-17 19:58:23',3310491635,1),(53288184,425334364,15704259,454632,1,'2007-09-17 19:58:23',3310491635,1),(53288187,425334885,15702281,454632,1,'2007-09-17 19:58:24',3310491635,1),(53288189,425334885,15701135,454632,1,'2007-09-17 19:58:24',3310491635,1),(53288191,425334312,15699678,454632,1,'2007-09-17 19:58:24',3310491635,1),(53288194,425332490,15698377,454632,1,'2007-09-17 19:58:25',3310491635,1),(53288196,425331814,15698272,454632,1,'2007-09-17 19:58:25',3310491635,1),(53288198,425330356,15698793,454632,1,'2007-09-17 19:58:25',3310491635,1),(53288199,425328951,15698689,454632,1,'2007-09-17 19:58:25',3310491635,1),(53288201,425327441,15697648,454632,1,'2007-09-17 19:58:26',3310491635,1),(53288203,425327285,15697023,454632,1,'2007-09-17 19:58:26',3310491635,1),(53288206,425326140,15695878,454632,1,'2007-09-17 19:58:26',3310491635,1),(53288209,425325047,15695826,454632,1,'2007-09-17 19:58:26',3310491635,1),(53288210,425323277,15696086,454632,1,'2007-09-17 19:58:26',3310491635,1),(53288213,425321975,15695878,454632,1,'2007-09-17 19:58:26',3310491635,1),(53288216,425320830,15694837,454632,1,'2007-09-17 19:58:27',3310491635,1),(53288219,425320310,15693327,454632,1,'2007-09-17 19:58:27',3310491635,1),(53288220,425320414,15691922,454632,1,'2007-09-17 19:58:27',3310491635,1),(53288223,425321403,15690621,454632,1,'2007-09-17 19:58:27',3310491635,1),(53288225,425324994,15687497,454632,1,'2007-09-17 19:58:27',3310491635,1),(53288227,425327337,15686248,454632,1,'2007-09-17 19:58:27',3310491635,1),(53288228,425328534,15685936,454632,1,'2007-09-17 19:58:28',3310491635,1),(53288229,425329523,15685780,454632,1,'2007-09-17 19:58:28',3310491635,1),(53288231,425330252,15685103,454632,1,'2007-09-17 19:58:28',3310491635,1),(53288235,425330460,15683906,454632,1,'2007-09-17 19:58:28',3310491635,1),(53288238,425329679,15682969,454632,1,'2007-09-17 19:58:28',3310491635,1),(53288239,425328326,15682760,454632,1,'2007-09-17 19:58:28',3310491635,1),(53288242,425325879,15682136,454632,1,'2007-09-17 19:58:29',3310491635,1),(53288245,425320674,15680314,454632,1,'2007-09-17 19:58:29',3310491635,1),(53288247,425318232,15678954,454632,1,'2007-09-17 19:58:29',3310491635,1),(53288250,425315704,15677149,454632,1,'2007-09-17 19:58:29',3310491635,1),(53288253,425314930,15675498,454632,1,'2007-09-17 19:58:29',3310491635,1),(53288255,425314569,15673280,454632,1,'2007-09-17 19:58:29',3310491634,1),(53288257,425314724,15667607,454632,1,'2007-09-17 19:58:30',3310491635,1),(53288259,425316839,15661056,454632,1,'2007-09-17 19:58:30',3310491635,1),(53288261,425320192,15654196,454632,1,'2007-09-17 19:58:30',3310491633,1),(53288262,425320525,15653271,454632,1,'2007-09-17 19:58:30',3310491633,1),(53288263,425319833,15652232,454632,1,'2007-09-17 19:58:30',3310491633,1),(53288266,425319227,15652145,454632,1,'2007-09-17 19:58:31',3310491633,1),(53288269,425318014,15652448,454632,1,'2007-09-17 19:58:31',3310491633,1),(53288271,425316846,15652492,454632,1,'2007-09-17 19:58:31',3310491633,1),(53288273,425315893,15651712,454632,1,'2007-09-17 19:58:31',3310491633,1),(53288276,425314638,15651106,454632,1,'2007-09-17 19:58:31',3310491632,1),(53288278,425314594,15650500,454632,1,'2007-09-17 19:58:32',3310491632,1),(53288280,425314335,15648552,454632,1,'2007-09-17 19:58:32',3310491632,1),(53288281,425314551,15647080,454632,1,'2007-09-17 19:58:32',3310491632,1),(53288282,425315157,15646171,454632,1,'2007-09-17 19:58:32',3310491633,1),(53288286,425315936,15646085,454632,1,'2007-09-17 19:58:32',3310491633,1),(53288290,425317885,15646561,454632,1,'2007-09-17 19:58:32',3310491633,1),(53288292,425319400,15646691,454632,1,'2007-09-17 19:58:33',3310491633,1),(53288294,425320525,15646344,454632,1,'2007-09-17 19:58:33',3310491633,1),(53288296,425321435,15645652,454632,1,'2007-09-17 19:58:33',3310491633,1),(53288298,425321738,15644613,454632,1,'2007-09-17 19:58:33',3310491633,1),(53288300,425322450,15642714,454632,1,'2007-09-17 19:58:33',3310491633,1),(53288302,425323634,15641837,454632,1,'2007-09-17 19:58:33',3310491633,1),(53288303,425324205,15641134,454632,1,'2007-09-17 19:58:34',3310491633,1),(53288305,425324205,15640652,454632,1,'2007-09-17 19:58:34',3310491633,1),(53288308,425323547,15640389,454632,1,'2007-09-17 19:58:34',3310491633,1),(53288309,425322493,15641091,454632,1,'2007-09-17 19:58:34',3310491633,1),(53288310,425321616,15641661,454632,1,'2007-09-17 19:58:34',3310491633,1),(53288313,425320826,15642275,454632,1,'2007-09-17 19:58:35',3310491633,1),(53288317,425319904,15642407,454632,1,'2007-09-17 19:58:35',3310491633,1),(53288318,425318939,15641398,454632,1,'2007-09-17 19:58:36',3310491633,1),(53288321,425299587,15652080,454632,1,'2007-09-17 19:58:36',3310491632,1),(53288323,425301722,15653099,454632,1,'2007-09-17 19:58:36',3310491632,1),(53288326,425304052,15655622,454632,1,'2007-09-17 19:58:36',3310491632,1),(53288329,425306624,15659165,454632,1,'2007-09-17 19:58:37',3310491634,1),(53288332,425307783,15660307,454632,1,'2007-09-17 19:58:37',3310491634,1),(53288334,425308516,15660577,454632,1,'2007-09-17 19:58:37',3310491634,1),(53288336,425309778,15659870,454632,1,'2007-09-17 19:58:37',3310491634,1),(53288338,425315650,15654555,454632,1,'2007-09-17 19:58:37',3310491633,1),(53288339,425317106,15653875,454632,1,'2007-09-17 19:58:38',3310491633,1),(53288343,425318368,15654360,454632,1,'2007-09-17 19:58:38',3310491633,1),(53288346,425319484,15655428,454632,1,'2007-09-17 19:58:38',3310491633,1);
INSERT INTO `nodes` VALUES (53288348,425304664,15678441,454632,1,'2007-09-17 19:58:38',3310491634,1),(53288349,425305689,15678403,454632,1,'2007-09-17 19:58:38',3310491634,1),(53288350,425306335,15680112,454632,1,'2007-09-17 19:58:38',3310491634,1),(53288351,425308044,15684898,454632,1,'2007-09-17 19:58:39',3310491634,1),(53288352,425310058,15688621,454632,1,'2007-09-17 19:58:39',3310491634,1),(53288353,425311463,15690862,454632,1,'2007-09-17 19:58:39',3310491634,1),(53288354,425312185,15691774,454632,1,'2007-09-17 19:58:39',3310491634,1),(53288355,425313780,15691888,454632,1,'2007-09-17 19:58:39',3310491634,1),(53288356,425315832,15692002,454632,1,'2007-09-17 19:58:39',3310491635,1),(53288357,425318339,15692875,454632,1,'2007-09-17 19:58:39',3310491635,1),(53288358,425358462,15703475,454632,1,'2007-09-17 19:58:40',3310491638,1),(53288360,425357875,15714429,454632,1,'2007-09-17 19:58:40',3310491644,1),(53288364,425357484,15717950,454632,1,'2007-09-17 19:58:40',3310491644,1),(53288366,425356115,15719646,454632,1,'2007-09-17 19:58:40',3310491644,1),(53288368,425354289,15719254,454632,1,'2007-09-17 19:58:41',3310491644,1),(53288370,425353768,15718407,454632,1,'2007-09-17 19:58:41',3310491644,1),(53288373,425353507,15714429,454632,1,'2007-09-17 19:58:41',3310491644,1),(53288375,425353833,15704649,454632,1,'2007-09-17 19:58:41',3310491638,1),(53288378,425353833,15701975,454632,1,'2007-09-17 19:58:42',3310491638,1),(53288381,425353116,15699954,454632,1,'2007-09-17 19:58:42',3310491638,1),(53288383,425351746,15700345,454632,1,'2007-09-17 19:58:42',3310491638,1),(53288388,425350834,15702953,454632,1,'2007-09-17 19:58:42',3310491638,1),(53288391,425350442,15712212,454632,1,'2007-09-17 19:58:42',3310491644,1),(53288393,425349138,15716972,454632,1,'2007-09-17 19:58:43',3310491644,1),(53288394,425347117,15719189,454632,1,'2007-09-17 19:58:43',3310491644,1),(53288396,425346595,15721667,454632,1,'2007-09-17 19:58:43',3310491644,1),(53288399,425347313,15724014,454632,1,'2007-09-17 19:58:43',3310491644,1),(53288402,425348877,15725840,454632,1,'2007-09-17 19:58:43',3310491644,1),(53288403,425349073,15727796,454632,1,'2007-09-17 19:58:44',3310491644,1),(53288404,425347378,15729556,454632,1,'2007-09-17 19:58:44',3310491644,1),(53288407,425339097,15735816,454632,1,'2007-09-17 19:58:44',3310491641,1),(53288410,425338054,15736664,454632,1,'2007-09-17 19:58:44',3310491641,1),(53288413,425338575,15740054,454632,1,'2007-09-17 19:58:45',3310491641,1),(53288419,425344777,15732435,454632,1,'2007-09-17 19:58:45',3310491644,1),(53292901,425317700,15638777,454632,1,'2007-09-17 20:12:20',3310491633,1),(53292938,425316338,15636126,454632,1,'2007-09-17 20:12:29',3310491633,1),(53292997,425314829,15633917,454632,1,'2007-09-17 20:12:44',3310491633,1),(53293001,425313061,15631450,454632,1,'2007-09-17 20:12:44',3310491632,1),(53293003,425311773,15628652,454632,1,'2007-09-17 20:12:44',3310491632,1),(53293007,425311478,15626958,454632,1,'2007-09-17 20:12:44',3310491632,1),(53293010,425312104,15626590,454632,1,'2007-09-17 20:12:45',3310491632,1),(53293011,425312730,15626995,454632,1,'2007-09-17 20:12:45',3310491632,1),(53293015,425313282,15628100,454632,1,'2007-09-17 20:12:45',3310491632,1),(53293017,425313945,15629131,454632,1,'2007-09-17 20:12:45',3310491632,1),(53293018,425316117,15630346,454632,1,'2007-09-17 20:12:45',3310491633,1),(53293022,425317958,15631266,454632,1,'2007-09-17 20:12:46',3310491633,1),(53293025,425319725,15632518,454632,1,'2007-09-17 20:12:46',3310491633,1),(53293027,425320499,15633107,454632,1,'2007-09-17 20:12:46',3310491633,1),(53293029,425321714,15633107,454632,1,'2007-09-17 20:12:46',3310491633,1),(53293032,425322413,15632555,454632,1,'2007-09-17 20:12:46',3310491633,1),(53293034,425323702,15632444,454632,1,'2007-09-17 20:12:47',3310491633,1),(53293037,425324475,15632076,454632,1,'2007-09-17 20:12:47',3310491633,1),(53293039,425325101,15630861,454632,1,'2007-09-17 20:12:47',3310491633,1),(53293043,425326647,15626848,454632,1,'2007-09-17 20:12:48',3310491633,1),(53293046,425328338,15622875,454632,1,'2007-09-17 20:12:48',3310491633,1),(53293058,425330425,15619923,454632,1,'2007-09-17 20:12:50',3310491633,1),(53293060,425332308,15616920,454632,1,'2007-09-17 20:12:50',3310491633,1),(53293062,425332919,15615240,454632,1,'2007-09-17 20:12:50',3310491633,1),(53293063,425332410,15614171,454632,1,'2007-09-17 20:12:50',3310491633,1),(53293066,425331493,15613968,454632,1,'2007-09-17 20:12:50',3310491633,1),(53293067,425330577,15614935,454632,1,'2007-09-17 20:12:50',3310491633,1),(53293069,425330781,15616309,454632,1,'2007-09-17 20:12:50',3310491633,1),(53293073,425330323,15617531,454632,1,'2007-09-17 20:12:50',3310491633,1),(53293076,425329152,15618752,454632,1,'2007-09-17 20:12:51',3310491633,1),(53293077,425327014,15620177,454632,1,'2007-09-17 20:12:51',3310491633,1),(53293080,425324622,15621195,454632,1,'2007-09-17 20:12:51',3310491633,1),(53293082,425322332,15621704,454632,1,'2007-09-17 20:12:51',3310491633,1),(53293083,425320601,15621704,454632,1,'2007-09-17 20:12:51',3310491633,1),(53293087,425319990,15620890,454632,1,'2007-09-17 20:12:51',3310491633,1),(53293089,425320398,15619770,454632,1,'2007-09-17 20:12:52',3310491633,1),(53293092,425321263,15619719,454632,1,'2007-09-17 20:12:52',3310491633,1),(53293095,425322230,15619668,454632,1,'2007-09-17 20:12:52',3310491633,1),(53293097,425323706,15618600,454632,1,'2007-09-17 20:12:52',3310491633,1),(53293098,425325437,15617531,454632,1,'2007-09-17 20:12:53',3310491633,1),(53293102,425326200,15616818,454632,1,'2007-09-17 20:12:53',3310491633,1),(53293105,425325895,15615546,454632,1,'2007-09-17 20:12:53',3310491633,1),(53293108,425325335,15615393,454632,1,'2007-09-17 20:12:54',3310491633,1),(53293109,425324164,15615698,454632,1,'2007-09-17 20:12:54',3310491633,1),(53293111,425322637,15615902,454632,1,'2007-09-17 20:12:54',3310491633,1),(53293114,425320652,15615902,454632,1,'2007-09-17 20:12:54',3310491633,1),(53293117,425319431,15615597,454632,1,'2007-09-17 20:12:55',3310491633,1),(53293119,425318413,15615088,454632,1,'2007-09-17 20:12:55',3310491633,1),(53293123,425317700,15613917,454632,1,'2007-09-17 20:12:55',3310491633,1),(53293124,425317089,15612085,454632,1,'2007-09-17 20:12:55',3310491633,1),(53293127,425316988,15610609,454632,1,'2007-09-17 20:12:55',3310491633,1),(53293130,425317038,15608318,454632,1,'2007-09-17 20:12:56',3310491633,1),(53293132,425316835,15607249,454632,1,'2007-09-17 20:12:56',3310491633,1),(53293136,425315664,15604806,454632,1,'2007-09-17 20:12:56',3310491633,1),(53293137,425312407,15599869,454632,1,'2007-09-17 20:12:56',3310491610,1),(53293142,425311236,15597986,454632,1,'2007-09-17 20:12:57',3310491610,1),(53293144,425311592,15597171,454632,1,'2007-09-17 20:12:57',3310491610,1),(53293147,425312356,15597171,454632,1,'2007-09-17 20:12:57',3310491610,1),(53293148,425312814,15597884,454632,1,'2007-09-17 20:12:57',3310491610,1),(53293150,425313628,15599258,454632,1,'2007-09-17 20:12:57',3310491610,1),(53293153,425314697,15600022,454632,1,'2007-09-17 20:12:58',3310491610,1),(53293155,425315817,15600073,454632,1,'2007-09-17 20:12:58',3310491611,1),(53293157,425316784,15600378,454632,1,'2007-09-17 20:12:58',3310491611,1),(53293158,425317802,15602414,454632,1,'2007-09-17 20:12:58',3310491633,1),(53293162,425318667,15603534,454632,1,'2007-09-17 20:12:59',3310491633,1),(53293164,425320449,15604246,454632,1,'2007-09-17 20:12:59',3310491633,1),(53293167,425321772,15604246,454632,1,'2007-09-17 20:12:59',3310491633,1),(53293169,425322739,15603839,454632,1,'2007-09-17 20:12:59',3310491633,1),(53293172,425323502,15602312,454632,1,'2007-09-17 20:12:59',3310491633,1),(53293174,425323452,15600327,454632,1,'2007-09-17 20:12:59',3310491611,1),(53293177,425322485,15598342,454632,1,'2007-09-17 20:12:59',3310491611,1),(53293179,425321772,15597324,454632,1,'2007-09-17 20:12:59',3310491611,1),(53293183,425322179,15596103,454632,1,'2007-09-17 20:13:00',3310491611,1),(53293185,425322790,15595899,454632,1,'2007-09-17 20:13:00',3310491611,1),(53293188,425323706,15595899,454632,1,'2007-09-17 20:13:00',3310491611,1),(53293189,425324928,15596103,454632,1,'2007-09-17 20:13:00',3310491611,1),(53293192,425325487,15595848,454632,1,'2007-09-17 20:13:00',3310491611,1),(53293193,425325742,15594423,454632,1,'2007-09-17 20:13:00',3310491611,1),(53293197,425325335,15593405,454632,1,'2007-09-17 20:13:01',3310491611,1),(53293198,425324877,15593100,454632,1,'2007-09-17 20:13:01',3310491611,1),(53293200,425325284,15592133,454632,1,'2007-09-17 20:13:01',3310491611,1),(53293202,425325996,15591522,454632,1,'2007-09-17 20:13:01',3310491611,1),(53293205,425328745,15592031,454632,1,'2007-09-17 20:13:02',3310491611,1),(53293212,425331086,15592896,454632,1,'2007-09-17 20:13:03',3310491611,1),(53293217,425332410,15592794,454632,1,'2007-09-17 20:13:03',3310491611,1),(53293220,425332868,15591369,454632,1,'2007-09-17 20:13:03',3310491611,1),(53293232,425332308,15589995,454632,1,'2007-09-17 20:13:06',3310491611,1),(53293500,425329254,15588010,454632,1,'2007-09-17 20:14:04',3310491611,1),(53293505,425324368,15586890,454632,1,'2007-09-17 20:14:06',3310491611,1),(53293507,425320499,15586279,454632,1,'2007-09-17 20:14:06',3310491611,1),(53293510,425318922,15586177,454632,1,'2007-09-17 20:14:06',3310491611,1),(53294141,425315308,15585618,454632,1,'2007-09-17 20:16:13',3310491611,1),(53294144,425313781,15585363,454632,1,'2007-09-17 20:16:14',3310491610,1),(53294147,425312152,15584701,454632,1,'2007-09-17 20:16:14',3310491610,1),(53294149,425310167,15582971,454632,1,'2007-09-17 20:16:14',3310491610,1),(53294152,425308640,15581597,454632,1,'2007-09-17 20:16:14',3310491610,1),(53294154,425307266,15581393,454632,1,'2007-09-17 20:16:15',3310491610,1),(53294157,425306248,15581851,454632,1,'2007-09-17 20:16:15',3310491610,1),(53294160,425303856,15583582,454632,1,'2007-09-17 20:16:16',3310491610,1),(53294162,425302991,15584294,454632,1,'2007-09-17 20:16:16',3310491610,1),(53294165,425302125,15584905,454632,1,'2007-09-17 20:16:16',3310491610,1),(53294166,425301464,15584701,454632,1,'2007-09-17 20:16:17',3310491610,1),(53294168,425301107,15584142,454632,1,'2007-09-17 20:16:17',3310491610,1),(53294169,425301005,15583124,454632,1,'2007-09-17 20:16:17',3310491610,1),(53294170,425301667,15582157,454632,1,'2007-09-17 20:16:17',3310491610,1),(53294171,425305485,15577881,454632,1,'2007-09-17 20:16:18',3310491610,1),(53294174,425306850,15576674,454632,1,'2007-09-17 20:16:18',3310491610,1),(53294177,425308131,15576252,454632,1,'2007-09-17 20:16:18',3310491610,1),(53294180,425309302,15576965,454632,1,'2007-09-17 20:16:18',3310491610,1),(53294181,425311389,15577118,454632,1,'2007-09-17 20:16:19',3310491610,1),(53294184,425313272,15577270,454632,1,'2007-09-17 20:16:19',3310491610,1),(53294186,425314290,15576965,454632,1,'2007-09-17 20:16:19',3310491610,1),(53294189,425314799,15576354,454632,1,'2007-09-17 20:16:19',3310491611,1),(53294192,425314748,15575692,454632,1,'2007-09-17 20:16:19',3310491611,1),(53294194,425313934,15574573,454632,1,'2007-09-17 20:16:19',3310491610,1),(53294195,425313425,15574166,454632,1,'2007-09-17 20:16:19',3310491610,1),(53294197,425312559,15572231,454632,1,'2007-09-17 20:16:20',3310491610,1),(53294199,425312136,15569920,454632,1,'2007-09-17 20:16:20',3310491610,1),(53294202,425312356,15569279,454632,1,'2007-09-17 20:16:20',3310491610,1),(53294205,425312862,15569071,454632,1,'2007-09-17 20:16:20',3310491610,1),(53294207,425313781,15570450,454632,1,'2007-09-17 20:16:20',3310491610,1),(53294209,425314290,15571315,454632,1,'2007-09-17 20:16:21',3310491610,1),(53294212,425315053,15572028,454632,1,'2007-09-17 20:16:21',3310491611,1),(53294213,425315410,15571213,454632,1,'2007-09-17 20:16:21',3310491611,1),(53294215,425315511,15570246,454632,1,'2007-09-17 20:16:21',3310491611,1),(53294218,425315461,15568770,454632,1,'2007-09-17 20:16:21',3310491611,1),(53294219,425315919,15567651,454632,1,'2007-09-17 20:16:21',3310491611,1),(53294221,425315664,15565971,454632,1,'2007-09-17 20:16:22',3310491611,1),(53294223,425315401,15571650,454632,1,'2007-09-17 20:16:22',3310491611,1),(53294226,425314524,15562751,454632,1,'2007-09-17 20:16:22',3310491610,1),(53294228,425313407,15560309,454632,1,'2007-09-17 20:16:22',3310491610,1),(53294231,425312662,15558612,454632,1,'2007-09-17 20:16:22',3310491610,1),(53294233,425312951,15557577,454632,1,'2007-09-17 20:16:23',3310491610,1),(53294235,425313738,15556998,454632,1,'2007-09-17 20:16:23',3310491610,1),(53294236,425314441,15557536,454632,1,'2007-09-17 20:16:23',3310491610,1),(53294239,425315104,15559315,454632,1,'2007-09-17 20:16:24',3310491611,1),(53294241,425316428,15561757,454632,1,'2007-09-17 20:16:24',3310491611,1),(53294244,425318953,15565317,454632,1,'2007-09-17 20:16:24',3310491611,1),(53294245,425319780,15566227,454632,1,'2007-09-17 20:16:24',3310491611,1),(53294248,425321063,15566268,454632,1,'2007-09-17 20:16:24',3310491611,1),(53294251,425321684,15565482,454632,1,'2007-09-17 20:16:24',3310491611,1),(53294253,425322305,15563702,454632,1,'2007-09-17 20:16:25',3310491611,1),(53294255,425322263,15562751,454632,1,'2007-09-17 20:16:25',3310491611,1),(53294258,425321932,15561426,454632,1,'2007-09-17 20:16:25',3310491611,1),(53294260,425321353,15560598,454632,1,'2007-09-17 20:16:25',3310491611,1),(53294262,425320608,15559398,454632,1,'2007-09-17 20:16:25',3310491611,1),(53294264,425319723,15557916,454632,1,'2007-09-17 20:16:25',3310491611,1),(53294267,425318368,15554992,454632,1,'2007-09-17 20:16:25',3310491611,1),(53294268,425317583,15552210,454632,1,'2007-09-17 20:16:25',3310491611,1),(53294270,425316656,15549357,454632,1,'2007-09-17 20:16:26',3310491611,1),(53294273,425315016,15547147,454632,1,'2007-09-17 20:16:26',3310491611,1),(53294277,425313304,15546077,454632,1,'2007-09-17 20:16:26',3310491610,1),(53294279,425310879,15545863,454632,1,'2007-09-17 20:16:27',3310491608,1),(53294284,425308525,15545649,454632,1,'2007-09-17 20:16:28',3310491608,1),(53294285,425305387,15544936,454632,1,'2007-09-17 20:16:28',3310491608,1),(53294290,425301964,15543295,454632,1,'2007-09-17 20:16:28',3310491608,1),(53294293,425299040,15541726,454632,1,'2007-09-17 20:16:28',3310491608,1),(53294297,425297098,15541445,454632,1,'2007-09-17 20:16:29',3310491608,1),(53294300,425294718,15541105,454632,1,'2007-09-17 20:16:29',3310491608,1),(53294304,425292830,15540916,454632,1,'2007-09-17 20:16:29',3310491608,1),(53294308,425291773,15540123,454632,1,'2007-09-17 20:16:30',3310491608,1),(53294311,425291018,15538462,454632,1,'2007-09-17 20:16:30',3310491608,1),(53294314,425290904,15537027,454632,1,'2007-09-17 20:16:30',3310491608,1),(53294317,425292302,15534043,454632,1,'2007-09-17 20:16:30',3310491608,1),(53294320,425293397,15533477,454632,1,'2007-09-17 20:16:31',3310491608,1),(53294323,425295247,15534496,454632,1,'2007-09-17 20:16:31',3310491608,1),(53294327,425297060,15536158,454632,1,'2007-09-17 20:16:31',3310491608,1),(53294331,425299477,15536762,454632,1,'2007-09-17 20:16:31',3310491608,1),(53294335,425301289,15536649,454632,1,'2007-09-17 20:16:32',3310491608,1),(53294337,425303442,15536158,454632,1,'2007-09-17 20:16:32',3310491608,1),(53294341,425306085,15534647,454632,1,'2007-09-17 20:16:32',3310491608,1),(53294344,425308049,15534270,454632,1,'2007-09-17 20:16:32',3310491608,1),(53294347,425310768,15534723,454632,1,'2007-09-17 20:16:32',3310491608,1),(53294350,425314393,15535931,454632,1,'2007-09-17 20:16:33',3310491608,1),(53294352,425318850,15540010,454632,1,'2007-09-17 20:16:33',3310491609,1),(53294354,425320398,15541332,454632,1,'2007-09-17 20:16:33',3310491609,1),(53294357,425321871,15544088,454632,1,'2007-09-17 20:16:33',3310491609,1),(53294362,425322815,15546430,454632,1,'2007-09-17 20:16:33',3310491611,1),(53294364,425324930,15549640,454632,1,'2007-09-17 20:16:33',3310491611,1),(53294366,425326818,15550924,454632,1,'2007-09-17 20:16:33',3310491611,1),(53294371,425328139,15550697,454632,1,'2007-09-17 20:16:34',3310491611,1),(53294374,425328970,15549942,454632,1,'2007-09-17 20:16:34',3310491611,1),(53294377,425329084,15548998,454632,1,'2007-09-17 20:16:34',3310491611,1),(53294382,425328933,15547525,454632,1,'2007-09-17 20:16:35',3310491611,1),(53294385,425327460,15546467,454632,1,'2007-09-17 20:16:35',3310491611,1),(53294389,425325685,15545372,454632,1,'2007-09-17 20:16:36',3310491609,1),(53294392,425324552,15544164,454632,1,'2007-09-17 20:16:36',3310491609,1),(53294394,425323457,15541143,454632,1,'2007-09-17 20:16:36',3310491609,1),(53294396,425321795,15538915,454632,1,'2007-09-17 20:16:36',3310491609,1),(53294401,425319454,15532721,454632,1,'2007-09-17 20:16:36',3310491609,1),(53294404,425317756,15529166,454632,1,'2007-09-17 20:16:36',3310491609,1),(53294409,425314205,15525875,454632,1,'2007-09-17 20:16:36',3310491608,1),(53294411,425311087,15523970,454632,1,'2007-09-17 20:16:36',3310491608,1),(53294416,425308056,15524143,454632,1,'2007-09-17 20:16:37',3310491608,1),(53294418,425305585,15524659,454632,1,'2007-09-17 20:16:37',3310491608,1),(53294420,425303314,15524801,454632,1,'2007-09-17 20:16:37',3310491608,1),(53294423,425301470,15523595,454632,1,'2007-09-17 20:16:37',3310491608,1),(53294425,425299306,15521431,454632,1,'2007-09-17 20:16:37',3310491608,1),(53294429,425297568,15518628,454632,1,'2007-09-17 20:16:38',3310491608,1),(53294430,425295865,15515578,454632,1,'2007-09-17 20:16:38',3310491608,1),(53294433,425293666,15513662,454632,1,'2007-09-17 20:16:38',3310491608,1),(53294434,425289693,15511463,454632,1,'2007-09-17 20:16:38',3310491608,1),(53294436,425285791,15510860,454632,1,'2007-09-17 20:16:38',3310491597,1),(53294443,425283237,15510966,454632,1,'2007-09-17 20:16:39',3310491597,1),(53294444,425281499,15511995,454632,1,'2007-09-17 20:16:39',3310491597,1),(53294448,425280648,15513662,454632,1,'2007-09-17 20:16:39',3310491597,1),(53294450,425278499,15517625,454632,1,'2007-09-17 20:16:39',3310491597,1),(53294455,425276549,15519668,454632,1,'2007-09-17 20:16:40',3310491597,1),(53294458,425274924,15520782,454632,1,'2007-09-17 20:16:40',3310491597,1),(53294463,425273810,15520039,454632,1,'2007-09-17 20:16:40',3310491597,1),(53294466,425273392,15518368,454632,1,'2007-09-17 20:16:41',3310491597,1),(53294469,425274831,15515954,454632,1,'2007-09-17 20:16:41',3310491597,1),(53294474,425276595,15513307,454632,1,'2007-09-17 20:16:41',3310491597,1),(53294475,425276735,15510196,454632,1,'2007-09-17 20:16:41',3310491597,1),(53294479,425276828,15505321,454632,1,'2007-09-17 20:16:42',3310491597,1),(53294483,425278731,15503139,454632,1,'2007-09-17 20:16:42',3310491597,1),(53294487,425282538,15500446,454632,1,'2007-09-17 20:16:42',3310491597,1),(53294490,425285788,15498589,454632,1,'2007-09-17 20:16:43',3310491597,1),(53294493,425288945,15497707,454632,1,'2007-09-17 20:16:43',3310491608,1),(53294496,425291406,15497057,454632,1,'2007-09-17 20:16:43',3310491608,1),(53294500,425294331,15497243,454632,1,'2007-09-17 20:16:43',3310491608,1),(53294503,425297024,15498311,454632,1,'2007-09-17 20:16:43',3310491608,1),(53294508,425298835,15500261,454632,1,'2007-09-17 20:16:44',3310491608,1),(53294512,425301063,15503046,454632,1,'2007-09-17 20:16:44',3310491608,1),(53294515,425304546,15505553,454632,1,'2007-09-17 20:16:44',3310491608,1),(53294520,425305242,15504857,454632,1,'2007-09-17 20:16:45',3310491608,1),(53294523,425305567,15504021,454632,1,'2007-09-17 20:16:45',3310491608,1),(53294526,425305335,15501282,454632,1,'2007-09-17 20:16:45',3310491608,1),(53294530,425304406,15500307,454632,1,'2007-09-17 20:16:45',3310491608,1),(53294531,425303013,15500168,454632,1,'2007-09-17 20:16:46',3310491608,1),(53294534,425301342,15498728,454632,1,'2007-09-17 20:16:46',3310491608,1),(53294537,425298974,15495850,454632,1,'2007-09-17 20:16:46',3310491608,1),(53294540,425297131,15493100,454632,1,'2007-09-17 20:16:46',3310491608,1),(53294541,425294579,15489698,454632,1,'2007-09-17 20:16:47',3310491602,1),(53294545,425291832,15488194,454632,1,'2007-09-17 20:16:47',3310491602,1),(53294548,425288627,15487147,454632,1,'2007-09-17 20:16:47',3310491602,1),(53294552,425286337,15487736,454632,1,'2007-09-17 20:16:47',3310491591,1),(53294557,425284178,15487605,454632,1,'2007-09-17 20:16:48',3310491591,1),(53294560,425282020,15485904,454632,1,'2007-09-17 20:16:48',3310491591,1),(53294562,425280319,15484596,454632,1,'2007-09-17 20:16:48',3310491591,1),(53294566,425278945,15484530,454632,1,'2007-09-17 20:16:48',3310491591,1),(53294570,425276982,15485904,454632,1,'2007-09-17 20:16:49',3310491591,1),(53294573,425275936,15487016,454632,1,'2007-09-17 20:16:49',3310491591,1),(53294577,425273515,15488128,454632,1,'2007-09-17 20:16:49',3310491591,1),(53294581,425272076,15488848,454632,1,'2007-09-17 20:16:50',3310491591,1),(53294584,425270310,15488455,864892,1,'2009-03-28 17:17:00',3310491591,3),(53294588,425269917,15487605,864892,1,'2009-03-28 17:17:00',3310491591,3),(53294591,425270637,15486362,864892,1,'2009-03-28 17:17:00',3310491591,3),(53294595,425272861,15484726,864892,1,'2009-03-28 17:17:00',3310491591,3),(53294596,425275151,15482699,864892,1,'2009-03-28 17:17:00',3310491591,3),(53294601,425277506,15479101,864892,1,'2009-03-28 17:17:00',3310491591,3),(53294602,425279534,15474391,864892,1,'2009-03-28 17:17:00',3310491591,3),(53294607,425283001,15465886,864892,1,'2009-03-28 17:17:00',3310491591,3),(53294610,425285356,15462158,864892,1,'2009-03-28 17:17:00',3310491591,3),(53294613,425289019,15459476,864892,1,'2009-03-28 17:17:00',3310491602,3),(53294616,425293402,15458887,864892,1,'2009-03-28 17:17:00',3310491602,3),(53294620,425297769,15458865,864892,1,'2009-03-28 17:16:59',3310491602,3),(53294623,425300588,15460275,864892,1,'2009-03-28 17:16:59',3310491602,3),(53294625,425304111,15462106,864892,1,'2009-03-28 17:16:59',3310491602,3),(53294630,425306365,15462106,864892,1,'2009-03-28 17:16:59',3310491602,3),(53294634,425310211,15460446,864892,1,'2009-03-28 17:16:59',3310491602,3),(53294637,425314035,15457921,864892,1,'2009-03-28 17:16:59',3310491602,3),(53294640,425318148,15455756,864892,1,'2009-03-28 17:16:59',3310491603,3),(53294645,425321033,15454746,864892,1,'2009-03-28 17:16:59',3310491603,3),(53294648,425325506,15454819,864892,1,'2009-03-28 17:16:59',3310491603,3),(53294652,425330485,15455829,864892,1,'2009-03-28 17:16:59',3310491603,3),(53294655,425336328,15455901,864892,1,'2009-03-28 17:16:59',3310491603,3),(53294659,425343038,15455973,864892,1,'2009-03-28 17:16:59',3310491606,3),(53294661,425345852,15456189,864892,1,'2009-03-28 17:16:59',3310491606,3),(53294665,425348810,15457849,864892,1,'2009-03-28 17:16:59',3310491606,3),(53294669,425351768,15460951,864892,1,'2009-03-28 17:16:59',3310491606,3),(53294671,425354942,15465785,864892,1,'2009-03-28 17:16:59',3310491606,3),(53294675,425357900,15469248,864892,1,'2009-03-28 17:16:59',3310491606,3),(53294677,425360930,15472494,864892,1,'2009-03-28 17:16:59',3310491606,3),(53294679,425364538,15475092,864892,1,'2009-03-28 17:16:59',3310491606,3),(53294684,425369011,15477256,864892,1,'2009-03-28 17:16:59',3310491606,3),(53294689,425372113,15480863,864892,1,'2009-03-28 17:16:59',3310491607,3),(53294691,425374710,15484543,864892,1,'2009-03-28 17:16:58',3310491607,3),(53294695,425376370,15488006,864892,1,'2009-03-28 17:16:58',3310491607,3),(53294698,425377524,15489954,864892,1,'2009-03-28 17:16:58',3310491607,3),(53294702,425378390,15490675,864892,1,'2009-03-28 17:16:58',3310491607,3),(53294704,425379833,15490675,864892,1,'2009-03-28 17:16:58',3310491607,3),(53294709,425380626,15489954,864892,1,'2009-03-28 17:17:43',3310491607,5),(53294712,425380121,15488944,864892,1,'2009-03-28 17:16:58',3310491607,3),(53294714,425379039,15487212,864892,1,'2009-03-28 17:16:58',3310491607,3),(53294716,425376153,15481368,864892,1,'2009-03-28 17:16:58',3310491607,3),(53294718,425372330,15473144,864892,1,'2009-03-28 17:16:58',3310491607,3),(53294721,425369804,15469464,864892,1,'2009-03-28 17:16:58',3310491607,3),(53294728,425367207,15466001,864892,1,'2009-03-28 17:16:58',3310491606,3),(53294730,425364971,15462177,864892,1,'2009-03-28 17:16:58',3310491606,3),(53294735,425362806,15457488,864892,1,'2009-03-28 17:16:58',3310491606,3),(53294737,425362013,15454458,864892,1,'2009-03-28 17:16:57',3310491606,3),(53294740,425362518,15451572,864892,1,'2009-03-28 17:16:57',3310491606,3),(53294745,425363167,15449263,864892,1,'2009-03-28 17:16:57',3310491606,3),(53294748,425363672,15447027,864892,1,'2009-03-28 17:16:57',3310491606,3),(53294752,425363239,15444502,864892,1,'2009-03-28 17:16:57',3310491606,3),(53294755,425362662,15440173,864892,1,'2009-03-28 17:16:57',3310491606,3),(53294756,425362013,15433463,864892,1,'2009-03-28 17:16:57',3310491604,3),(53294758,425361435,15429423,864892,1,'2009-03-28 17:16:57',3310491604,3),(53294761,425360570,15427908,864892,1,'2009-03-28 17:16:57',3310491604,3),(53294764,425359271,15426753,864892,1,'2009-03-28 17:16:57',3310491604,3),(53294767,425355087,15427042,864892,1,'2009-03-28 17:16:57',3310491604,3),(53294770,425346357,15426465,864892,1,'2009-03-28 17:16:57',3310491604,3),(53294776,425339791,15425166,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294777,425335901,15424201,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294782,425332447,15423093,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294785,425329505,15421728,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294786,425326904,15420194,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294790,425324858,15418744,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294792,425323621,15416868,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294795,425323238,15415418,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294800,425323195,15414651,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294803,425323962,15413969,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294805,425325028,15414054,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294807,425326904,15415418,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294810,425329079,15415759,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294813,425331552,15415248,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294816,425334366,15413670,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294820,425336839,15411709,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294823,425338331,15410217,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294826,425340292,15409023,864892,1,'2009-03-28 17:16:56',3310491601,3),(53294829,425343149,15407872,864892,1,'2009-03-28 17:16:56',3310491604,3),(53294830,425346975,15407911,864892,1,'2009-03-28 17:16:56',3310491604,3),(53294834,425349420,15408563,864892,1,'2009-03-28 17:16:56',3310491604,3),(53294838,425352407,15408292,864892,1,'2009-03-28 17:16:56',3310491604,3),(53294843,425355721,15407585,864892,1,'2009-03-28 17:16:56',3310491604,3),(53294847,425359197,15405141,864892,1,'2009-03-28 17:16:56',3310491604,3),(53294849,425362511,15404272,864892,1,'2009-03-28 17:16:56',3310491604,3),(53294851,425366965,15402588,864892,1,'2009-03-28 17:16:56',3310491604,3),(53294855,425369083,15401719,864892,1,'2009-03-28 17:16:56',3310491604,3),(53294856,425371365,15400796,864892,1,'2009-03-28 17:16:56',3310491605,3),(53294860,425372668,15399926,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294866,425374081,15400633,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294867,425374298,15401230,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294872,425374461,15402751,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294874,425374895,15404163,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294877,425376145,15408835,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294880,425378861,15415136,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294884,425380979,15418232,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294887,425381359,15420676,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294891,425381631,15422360,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294894,425382228,15424098,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294898,425382935,15424207,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294900,425383478,15423935,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294904,425383912,15422523,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294906,425383695,15419699,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294910,425382772,15415788,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294913,425380979,15412528,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294917,425380816,15410084,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294919,425381033,15401828,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294922,425381359,15395853,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294924,425380653,15392376,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294929,425379838,15390258,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294930,425377666,15387270,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294933,425374515,15386238,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294937,425371093,15386564,864892,1,'2009-03-28 17:16:55',3310491605,3),(53294939,425369068,15387042,864892,1,'2009-03-28 17:16:55',3310491604,3),(53294943,425367017,15386700,864892,1,'2009-03-28 17:16:55',3310491604,3),(53294946,425363988,15384892,864892,1,'2009-03-28 17:16:55',3310491604,3),(53294950,425361888,15383036,864892,1,'2009-03-28 17:16:55',3310491604,3),(53294953,425359836,15381913,864892,1,'2009-03-28 17:16:54',3310491604,3),(53294958,425356759,15380545,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294961,425354463,15379519,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294963,425352021,15378884,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294965,425350751,15378542,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294968,425350311,15377028,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294971,425350555,15375465,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294974,425351532,15372094,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294979,425352008,15369921,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294981,425352604,15367041,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294983,425352653,15365701,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294986,425351809,15364360,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294989,425350717,15363467,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294992,425349029,15362970,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294994,425347341,15362970,864892,1,'2009-03-28 17:16:54',3310491518,3),(53294998,425346696,15362077,454632,1,'2007-09-17 20:17:23',3310491518,1),(53295002,425347043,15361034,454632,1,'2007-09-17 20:17:24',3310491518,1),(53295004,425348135,15360438,454632,1,'2007-09-17 20:17:24',3310491518,1),(53295006,425349277,15360190,454632,1,'2007-09-17 20:17:24',3310491518,1),(53295010,425351412,15360041,454632,1,'2007-09-17 20:17:24',3310491518,1),(53295011,425352405,15360091,454632,1,'2007-09-17 20:17:24',3310491518,1),(53295014,425353547,15361431,454632,1,'2007-09-17 20:17:25',3310491518,1),(53295016,425353994,15362523,454632,1,'2007-09-17 20:17:25',3310491518,1),(53295019,425354888,15363070,454632,1,'2007-09-17 20:17:25',3310491518,1),(53295022,425355533,15362474,454632,1,'2007-09-17 20:17:26',3310491518,1),(53295026,425355781,15361183,454632,1,'2007-09-17 20:17:26',3310491518,1),(53295029,425355781,15358800,454632,1,'2007-09-17 20:17:26',3310491518,1),(53295033,425356030,15356764,454632,1,'2007-09-17 20:17:26',3310491518,1),(53295035,425356526,15352346,454632,1,'2007-09-17 20:17:26',3310491518,1),(53295038,425355831,15350757,454632,1,'2007-09-17 20:17:26',3310491518,1),(53295040,425354242,15348969,454632,1,'2007-09-17 20:17:26',3310491518,1),(53295043,425356383,15354687,454632,1,'2007-09-17 20:17:27',3310491518,1),(53295045,425349917,15345329,454632,1,'2007-09-17 20:17:27',3310491518,1),(53295047,425348548,15343019,454632,1,'2007-09-17 20:17:27',3310491518,1),(53295051,425348034,15340538,454632,1,'2007-09-17 20:17:27',3310491518,1),(53295054,425347179,15336773,454632,1,'2007-09-17 20:17:27',3310491518,1),(53295057,425346494,15330356,454632,1,'2007-09-17 20:17:28',3310491518,1),(53295059,425345724,15323598,454632,1,'2007-09-17 20:17:28',3310491516,1),(53295063,425344698,15317523,454632,1,'2007-09-17 20:17:28',3310491516,1),(53295067,425342730,15312219,454632,1,'2007-09-17 20:17:29',3310491516,1),(53295071,425340677,15307342,454632,1,'2007-09-17 20:17:29',3310491513,1),(53295073,425340249,15305374,454632,1,'2007-09-17 20:17:29',3310491513,1),(53295077,425339564,15302380,454632,1,'2007-09-17 20:17:30',3310491513,1),(53295079,425337853,15301011,454632,1,'2007-09-17 20:17:30',3310491513,1),(53295083,425337083,15301011,454632,1,'2007-09-17 20:17:30',3310491513,1),(53295085,425334859,15302465,454632,1,'2007-09-17 20:17:30',3310491513,1),(53295090,425329725,15305117,454632,1,'2007-09-17 20:17:31',3310491513,1),(53295093,425328442,15306914,454632,1,'2007-09-17 20:17:31',3310491513,1),(53295097,425327586,15309224,454632,1,'2007-09-17 20:17:31',3310491513,1),(53295102,425322106,15316993,454632,1,'2007-09-17 20:17:32',3310491513,1),(53295103,425319547,15320497,454632,1,'2007-09-17 20:17:32',3310491513,1),(53295107,425318811,15321023,454632,1,'2007-09-17 20:17:32',3310491513,1),(53295110,425318251,15320883,454632,1,'2007-09-17 20:17:33',3310491513,1),(53295113,425317865,15320217,454632,1,'2007-09-17 20:17:33',3310491513,1),(53295117,425318671,15318955,454632,1,'2007-09-17 20:17:33',3310491513,1),(53295122,425320423,15316257,454632,1,'2007-09-17 20:17:34',3310491513,1),(53295125,425322246,15312157,454632,1,'2007-09-17 20:17:34',3310491513,1),(53295128,425324547,15305906,454632,1,'2007-09-17 20:17:35',3310491513,1),(53295132,425328686,15297384,454632,1,'2007-09-17 20:17:35',3310491513,1),(53295133,425333705,15291490,454632,1,'2007-09-17 20:17:35',3310491513,1),(53295137,425341820,15281437,454632,1,'2007-09-17 20:17:35',3310491513,1),(53295141,425342681,15280718,454632,1,'2007-09-17 20:17:36',3310491516,1),(53295143,425344836,15280718,454632,1,'2007-09-17 20:17:36',3310491516,1),(53295147,425346415,15281939,454632,1,'2007-09-17 20:17:36',3310491516,1),(53295149,425349144,15285386,454632,1,'2007-09-17 20:17:36',3310491516,1),(53295153,425352447,15288545,454632,1,'2007-09-17 20:17:36',3310491516,1),(53295157,425354171,15291418,454632,1,'2007-09-17 20:17:37',3310491516,1),(53295158,425355176,15295654,454632,1,'2007-09-17 20:17:37',3310491516,1),(53295161,425356468,15299819,454632,1,'2007-09-17 20:17:37',3310491516,1),(53295165,425358264,15301974,454632,1,'2007-09-17 20:17:37',3310491516,1),(53295169,425362069,15303984,454632,1,'2007-09-17 20:17:37',3310491516,1),(53295172,425364726,15305061,454632,1,'2007-09-17 20:17:38',3310491516,1),(53295175,425365875,15306210,454632,1,'2007-09-17 20:17:38',3310491516,1),(53295178,425366234,15308867,454632,1,'2007-09-17 20:17:38',3310491516,1),(53295182,425366522,15309442,454632,1,'2007-09-17 20:17:38',3310491516,1),(53295186,425367599,15309442,454632,1,'2007-09-17 20:17:38',3310491516,1),(53295188,425367886,15306857,454632,1,'2007-09-17 20:17:39',3310491516,1),(53295190,425367168,15304774,454632,1,'2007-09-17 20:17:39',3310491516,1),(53295193,425365875,15302548,454632,1,'2007-09-17 20:17:39',3310491516,1),(53295197,425364080,15300896,454632,1,'2007-09-17 20:17:40',3310491516,1),(53295202,425363290,15299676,454632,1,'2007-09-17 20:17:41',3310491516,1),(53295208,425362500,15297162,454632,1,'2007-09-17 20:17:42',3310491516,1),(53295211,425361639,15294865,454632,1,'2007-09-17 20:17:42',3310491516,1),(53295218,425360992,15290915,454632,1,'2007-09-17 20:17:42',3310491516,1),(53295222,425360849,15288689,454632,1,'2007-09-17 20:17:42',3310491516,1),(53295224,425359700,15285386,454632,1,'2007-09-17 20:17:42',3310491516,1),(53295228,425357689,15280575,454632,1,'2007-09-17 20:17:43',3310491516,1),(53295233,425354745,15276913,454632,1,'2007-09-17 20:17:43',3310491516,1),(53295236,425352734,15273753,454632,1,'2007-09-17 20:17:44',3310491516,1),(53295241,425351945,15272532,454632,1,'2007-09-17 20:17:44',3310491516,1),(53295243,425352160,15271455,454632,1,'2007-09-17 20:17:44',3310491516,1),(53295245,425353093,15271455,454632,1,'2007-09-17 20:17:44',3310491516,1),(53295249,425354314,15272676,454632,1,'2007-09-17 20:17:45',3310491516,1),(53295251,425356397,15274902,454632,1,'2007-09-17 20:17:45',3310491516,1),(53295253,425358551,15277200,454632,1,'2007-09-17 20:17:45',3310491516,1),(53295257,425360705,15278708,454632,1,'2007-09-17 20:17:46',3310491516,1),(53295259,425362462,15281428,327248,1,'2009-04-08 23:30:33',3310491516,6),(53295264,425364169,15282973,327248,1,'2009-04-08 23:30:33',3310491516,6),(53295267,425370855,15311725,327248,1,'2009-04-08 23:18:54',3310491517,8),(53295272,425368176,15308637,327248,1,'2009-04-08 23:18:54',3310491516,8),(53295276,425371718,15313950,327248,1,'2009-04-08 23:18:54',3310491517,8),(53295277,425372808,15315449,327248,1,'2009-04-08 23:18:54',3310491517,8),(53295281,425375170,15317175,327248,1,'2009-04-08 23:18:53',3310491517,8),(53295283,425376487,15318174,327248,1,'2009-04-08 23:18:53',3310491517,8),(53295287,425377625,15319796,327248,1,'2009-04-08 23:18:53',3310491517,8),(53295291,425378068,15320912,327248,1,'2009-04-08 23:18:53',3310491517,9),(53295292,425376759,15322307,327248,1,'2009-04-08 23:18:53',3310491517,8),(53295294,425375351,15322170,327248,1,'2009-04-08 23:18:53',3310491517,8),(53295298,425374307,15321625,327248,1,'2009-04-08 23:18:53',3310491517,8),(53295299,425373081,15320490,327248,1,'2009-04-08 23:18:53',3310491517,8),(53295301,425372082,15319037,327248,1,'2009-04-08 23:18:52',3310491517,8),(53295305,425371301,15318251,327248,1,'2009-04-08 23:18:52',3310491517,8),(53295308,425370352,15318080,327248,1,'2009-04-08 23:18:52',3310491517,8),(53295310,425369530,15318938,327248,1,'2009-04-08 23:18:52',3310491516,9),(53295312,425369594,15320054,327248,1,'2009-04-08 23:18:52',3310491516,8),(53295314,425369910,15321255,327248,1,'2009-04-08 23:18:52',3310491517,8),(53295315,425371219,15323351,327248,1,'2009-04-08 23:18:52',3310491517,8),(53295319,425372990,15326031,327248,1,'2009-04-08 23:18:52',3310491517,8),(53295321,425375475,15328122,327248,1,'2009-04-08 23:18:52',3310491519,8),(53295325,425376487,15329152,327248,1,'2009-04-08 23:18:52',3310491519,8),(53295327,425376740,15330611,327248,1,'2009-04-08 23:18:52',3310491519,8),(53295329,425375896,15331208,327248,1,'2009-04-08 23:18:52',3310491519,8),(53295332,425374779,15330868,327248,1,'2009-04-08 23:18:51',3310491519,8),(53295336,425373641,15330268,327248,1,'2009-04-08 23:18:51',3310491519,8),(53295339,425372313,15329238,327248,1,'2009-04-08 23:18:51',3310491519,8),(53295343,425370858,15327349,327248,1,'2009-04-08 23:18:51',3310491519,8),(53295347,425369175,15324804,327248,1,'2009-04-08 23:18:51',3310491516,8),(53295349,425368085,15323169,327248,1,'2009-04-08 23:18:51',3310491516,8),(53295353,425367313,15322261,327248,1,'2009-04-08 23:18:51',3310491516,8),(53295356,425366431,15322886,327248,1,'2009-04-08 23:18:51',3310491516,10),(53295359,425366305,15323916,327248,1,'2009-04-08 23:18:51',3310491516,8),(53295361,425366558,15325204,327248,1,'2009-04-08 23:18:51',3310491516,8),(53295363,425368585,15328937,327248,1,'2009-04-08 23:18:51',3310491518,8),(53295365,425371900,15334205,327248,1,'2009-04-08 23:18:51',3310491519,8),(53295370,425372400,15335567,327248,1,'2009-04-08 23:18:51',3310491519,8),(53295371,425372354,15337021,327248,1,'2009-04-08 23:18:51',3310491519,8),(53295375,425371219,15337747,327248,1,'2009-04-08 23:18:51',3310491519,8),(53295377,425369675,15337112,327248,1,'2009-04-08 23:18:51',3310491519,8),(53295379,425368676,15334296,327248,1,'2009-04-08 23:18:51',3310491518,8),(53295382,425365905,15329527,327248,1,'2009-04-08 23:18:51',3310491518,8),(53295385,425364089,15326485,327248,1,'2009-04-08 23:18:51',3310491518,8),(53295388,425361909,15325122,327248,1,'2009-04-08 23:18:51',3310491516,8),(53295391,425360410,15324941,327248,1,'2009-04-08 23:18:51',3310491516,8),(53306527,425342376,15239117,327248,1,'2009-04-08 23:30:34',3310491510,5),(53306532,425341080,15243006,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306534,425339843,15246247,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306537,425338311,15248663,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306540,425336248,15249605,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306542,425333715,15249664,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306543,425332242,15250136,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306545,425331181,15251609,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306547,425330180,15252964,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306550,425329119,15253612,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306552,425327705,15253848,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306554,425325937,15253435,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306556,425323816,15252551,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306559,425322048,15251078,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306562,425320458,15249605,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306564,425320104,15248309,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306565,425320104,15243477,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306566,425319927,15241297,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306568,425319102,15237585,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306569,425317276,15233520,454632,1,'2007-09-17 20:41:12',3310491507,1),(53306573,425316569,15232872,454632,1,'2007-09-17 20:41:12',3310491507,1),(53306575,425314094,15231634,454632,1,'2007-09-17 20:41:12',3310491506,1),(53306579,425311737,15231458,454632,1,'2007-09-17 20:41:13',3310491506,1),(53306582,425308261,15232636,454632,1,'2007-09-17 20:41:13',3310491506,1),(53306585,425306199,15234109,454632,1,'2007-09-17 20:41:13',3310491506,1),(53306588,425302310,15238410,454632,1,'2007-09-17 20:41:13',3310491506,1),(53306590,425300542,15239765,454632,1,'2007-09-17 20:41:14',3310491506,1),(53306592,425297773,15240590,454632,1,'2007-09-17 20:41:14',3310491506,1),(53306595,425294591,15240649,454632,1,'2007-09-17 20:41:14',3310491506,1),(53306597,425292795,15240491,454632,1,'2007-09-17 20:41:14',3310491506,1),(53306600,425289345,15240604,454632,1,'2007-09-17 20:41:14',3310491506,1),(53306603,425317174,15231385,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306606,425315421,15229744,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306607,425314572,15229405,327248,1,'2009-04-08 23:30:35',3310491506,5),(53306609,425312706,15229348,327248,1,'2009-04-08 23:30:35',3310491506,5),(53306611,425310839,15229348,327248,1,'2009-04-08 23:30:35',3310491506,5),(53306613,425309821,15229348,327248,1,'2009-04-08 23:30:35',3310491506,5),(53306617,425309312,15228726,327248,1,'2009-04-08 23:30:35',3310491506,5),(53306620,425309538,15227821,327248,1,'2009-04-08 23:30:35',3310491506,5),(53306623,425311122,15227199,327248,1,'2009-04-08 23:30:35',3310491506,5),(53306626,425315421,15227142,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306628,425317174,15227029,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306631,425319550,15228839,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306633,425321417,15232346,327248,1,'2009-04-08 23:30:35',3310491507,5),(53306635,425322152,15234552,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306638,425322774,15235457,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306641,425323283,15235118,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306644,425323962,15234100,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306647,425325829,15231894,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306650,425327356,15231611,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306652,425329562,15231328,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306654,425330693,15231102,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306657,425332107,15229235,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306660,425333917,15224823,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306662,425337311,15220411,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306665,425340422,15217866,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306668,425341554,15217526,327248,1,'2009-04-08 23:30:37',3310491507,7),(53306670,425342798,15217639,226881,1,'2009-04-05 17:13:36',3310491510,4),(53306671,425343251,15218884,226881,1,'2009-04-05 17:13:36',3310491510,4),(53306672,425343760,15219393,226881,1,'2009-04-05 17:13:36',3310491510,4),(53306673,425344778,15220298,226881,1,'2009-04-05 17:13:36',3310491510,4),(53306675,425345909,15220637,226881,1,'2009-04-05 17:13:35',3310491510,4),(53306677,425346814,15220468,226881,1,'2009-04-05 17:13:35',3310491510,4),(53306679,425347070,15220262,226881,1,'2009-04-05 17:13:57',3310491510,6),(53306680,425348511,15217866,226881,1,'2009-04-05 17:13:57',3310491510,5),(53306683,425348850,15215773,226881,1,'2009-04-05 17:13:03',3310491508,3),(53306685,425348454,15211644,226881,1,'2009-04-05 17:13:03',3310491508,3),(53306687,425346701,15207175,226881,1,'2009-04-05 17:13:03',3310491508,3),(53306689,425344269,15201971,226881,1,'2009-04-05 17:09:50',3310491508,4),(53306691,425340875,15198294,226881,1,'2009-04-05 17:09:50',3310491505,4),(53306693,425335332,15197163,226881,1,'2009-04-05 17:09:50',3310491505,4),(53306695,425326521,15220199,454632,1,'2007-09-17 20:41:22',3310491507,1),(53306696,425333027,15219532,454632,1,'2007-09-17 20:41:22',3310491507,1),(53306697,425339157,15218948,327248,1,'2009-04-08 23:30:36',3310491507,5),(53306699,425343685,15235832,327248,1,'2009-04-08 23:30:34',3310491510,5),(53306702,425344493,15234089,327248,1,'2009-04-08 23:30:34',3310491510,5),(53306704,425345343,15233494,327248,1,'2009-04-08 23:30:34',3310491510,5),(53306706,425345938,15233494,327248,1,'2009-04-08 23:30:34',3310491510,5),(53306708,425346575,15234514,327248,1,'2009-04-08 23:30:34',3310491510,5),(53306710,425346108,15235491,327248,1,'2009-04-08 23:30:34',3310491510,5),(53306712,425345428,15237999,327248,1,'2009-04-08 23:30:34',3310491510,5),(53306713,425344748,15241400,327248,1,'2009-04-08 23:30:34',3310491510,5),(53306715,425344238,15244078,327248,1,'2009-04-08 23:30:34',3310491510,6),(53306717,425343898,15246585,327248,1,'2009-04-08 23:30:34',3310491510,5),(53306720,425343175,15250326,327248,1,'2009-04-08 23:30:34',3310491510,5),(53306723,425341985,15252068,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306724,425339392,15253939,327248,1,'2009-04-08 23:30:34',3310491507,5),(53306726,425335907,15256276,327248,1,'2009-04-08 23:30:33',3310491507,5),(53306727,425334631,15257254,327248,1,'2009-04-08 23:30:33',3310491507,5),(53306730,425334461,15258274,327248,1,'2009-04-08 23:30:33',3310491507,5),(53306733,425334844,15258954,327248,1,'2009-04-08 23:30:33',3310491507,5),(53306734,425335099,15259039,327248,1,'2009-04-08 23:30:33',3310491507,5),(53306737,425335694,15258869,327248,1,'2009-04-08 23:30:33',3310491507,5),(53306738,425337012,15258019,327248,1,'2009-04-08 23:30:33',3310491507,5),(53306740,425338627,15257339,327248,1,'2009-04-08 23:30:33',3310491507,5),(53306742,425340880,15257424,327248,1,'2009-04-08 23:30:33',3310491507,5),(53306743,425344450,15258402,327248,1,'2009-04-08 23:30:33',3310491510,5),(53306746,425347510,15259379,327248,1,'2009-04-08 23:30:33',3310491510,5),(53306749,425349168,15260995,327248,1,'2009-04-08 23:30:33',3310491510,5),(53306752,425352399,15265033,327248,1,'2009-04-08 23:30:33',3310491510,5),(53306755,425356522,15270643,327248,1,'2009-04-08 23:30:33',3310491510,5),(53306758,425360772,15276339,327248,1,'2009-04-08 23:30:33',3310491516,5),(53306761,425362855,15279952,327248,1,'2009-04-08 23:30:33',3310491516,5),(53306764,425365502,15285562,454632,1,'2007-09-17 20:41:28',3310491516,1),(53306767,425367828,15287858,454632,1,'2007-09-17 20:41:28',3310491516,1),(53306769,425369273,15290690,454632,1,'2007-09-17 20:41:28',3310491516,1),(53306771,425370351,15292128,454632,1,'2007-09-17 20:41:29',3310491517,1),(53306774,425371848,15294044,454632,1,'2007-09-17 20:41:29',3310491517,1),(53306775,425374843,15295960,454632,1,'2007-09-17 20:41:29',3310491517,1),(53306778,425377238,15298775,454632,1,'2007-09-17 20:41:29',3310491517,1),(53306780,425378975,15301171,454632,1,'2007-09-17 20:41:29',3310491517,1),(53306781,425379694,15301889,454632,1,'2007-09-17 20:41:30',3310491517,1),(53306782,425381011,15302428,454632,1,'2007-09-17 20:41:30',3310491517,1),(53306786,425381550,15302249,454632,1,'2007-09-17 20:41:30',3310491517,1),(53306787,425382736,15301032,1074615,1,'2009-05-04 17:34:16',3310491517,2),(53306788,425382928,15300392,454632,1,'2007-09-17 20:41:30',3310491517,1),(53306789,425382748,15298596,454632,1,'2007-09-17 20:41:31',3310491517,1),(53306790,425381371,15290870,454632,1,'2007-09-17 20:41:31',3310491517,1),(53306791,425380772,15287456,454632,1,'2007-09-17 20:41:31',3310491517,1),(53306792,425381011,15284642,454632,1,'2007-09-17 20:41:31',3310491517,1),(53306794,425381909,15279791,454632,1,'2007-09-17 20:41:31',3310491517,1),(53306795,425381909,15276437,454632,1,'2007-09-17 20:41:31',3310491517,1),(53306796,425382089,15272065,454632,1,'2007-09-17 20:41:31',3310491517,1),(53306799,425381670,15268711,454632,1,'2007-09-17 20:41:32',3310491511,1),(53306800,425381191,15266496,454632,1,'2007-09-17 20:41:32',3310491511,1),(53306803,425380640,15264759,454632,1,'2007-09-17 20:41:32',3310491511,1),(53306804,425380393,15262903,454632,1,'2007-09-17 20:41:32',3310491511,1),(53306806,425380787,15261695,454632,1,'2007-09-17 20:41:32',3310491511,1),(53306808,425386743,15264732,454632,1,'2007-09-17 20:41:32',3310491511,1),(53306810,425386233,15266484,454632,1,'2007-09-17 20:41:32',3310491511,1),(53306813,425386902,15270275,454632,1,'2007-09-17 20:41:32',3310491511,1),(53306814,425387953,15272887,454632,1,'2007-09-17 20:41:33',3310491517,1),(53306817,425388526,15273619,454632,1,'2007-09-17 20:41:33',3310491517,1),(53306819,425388367,15276581,454632,1,'2007-09-17 20:41:33',3310491517,1),(53306821,425387953,15279639,454632,1,'2007-09-17 20:41:33',3310491517,1),(53306823,425386711,15281710,454632,1,'2007-09-17 20:41:33',3310491517,1),(53306825,425385564,15284035,454632,1,'2007-09-17 20:41:34',3310491517,1),(53306828,425384672,15285596,454632,1,'2007-09-17 20:41:34',3310491517,1),(53306831,425384290,15287029,454632,1,'2007-09-17 20:41:34',3310491517,1),(53306833,425384290,15288048,454632,1,'2007-09-17 20:41:34',3310491517,1),(53306836,425384063,15288780,454632,1,'2007-09-17 20:41:34',3310491517,1),(53306838,425383599,15289074,454632,1,'2007-09-17 20:41:34',3310491517,1),(53306841,425383109,15289000,454632,1,'2007-09-17 20:41:35',3310491517,1),(53306843,425382449,15288389,454632,1,'2007-09-17 20:41:35',3310491517,1),(53306845,425382424,15287117,454632,1,'2007-09-17 20:41:35',3310491517,1),(53306846,425382302,15286383,454632,1,'2007-09-17 20:41:35',3310491517,1),(53306848,425381715,15286383,454632,1,'2007-09-17 20:41:35',3310491517,1),(53306849,425381691,15286994,454632,1,'2007-09-17 20:41:36',3310491517,1),(53306852,425381691,15288071,454632,1,'2007-09-17 20:41:36',3310491517,1),(53306853,425382131,15291691,454632,1,'2007-09-17 20:41:36',3310491517,1),(53306856,425382522,15294015,454632,1,'2007-09-17 20:41:36',3310491517,1),(53306858,425383232,15295116,454632,1,'2007-09-17 20:41:36',3310491517,1),(53306862,425383281,15295654,454632,1,'2007-09-17 20:41:36',3310491517,1),(53306863,425382791,15296535,454632,1,'2007-09-17 20:41:36',3310491517,1),(53306866,425382376,15296877,454632,1,'2007-09-17 20:41:37',3310491517,1),(53306869,425387144,15290358,454632,1,'2007-09-17 20:41:37',3310491517,1),(53306871,425382191,15259320,454632,1,'2007-09-17 20:41:37',3310491511,1),(53306873,425384474,15257330,454632,1,'2007-09-17 20:41:37',3310491511,1),(53306874,425386640,15255456,454632,1,'2007-09-17 20:41:37',3310491511,1),(53306875,425387987,15253817,454632,1,'2007-09-17 20:41:37',3310491511,1),(53306876,425389509,15251797,454632,1,'2007-09-17 20:41:37',3310491511,1),(53306878,425392612,15248342,454632,1,'2007-09-17 20:41:38',3310491511,1),(53306881,425396682,15244332,454632,1,'2007-09-17 20:41:38',3310491511,1),(53306882,425398994,15242166,454632,1,'2007-09-17 20:41:38',3310502434,1),(53306885,425401131,15240526,454632,1,'2007-09-17 20:41:38',3310502434,1),(53306886,425403236,15239413,454632,1,'2007-09-17 20:41:38',3310502434,1),(53306887,425405858,15237908,454632,1,'2007-09-17 20:41:38',3310502434,1),(53306888,425408529,15235577,454632,1,'2007-09-17 20:41:38',3310502434,1),(53306889,425410277,15233343,454632,1,'2007-09-17 20:41:39',3310502434,1),(53306892,425412074,15231740,454632,1,'2007-09-17 20:41:39',3310502434,1),(53306893,425414745,15230040,454632,1,'2007-09-17 20:41:39',3310502434,1),(53306897,425417076,15228826,454632,1,'2007-09-17 20:41:39',3310502434,1),(53306899,425419261,15228438,454632,1,'2007-09-17 20:41:39',3310502434,1),(53306901,425420864,15228729,454632,1,'2007-09-17 20:41:39',3310502434,1),(53306904,425423244,15228972,454632,1,'2007-09-17 20:41:40',3310502434,1),(53306906,425425575,15229555,454632,1,'2007-09-17 20:41:40',3310502435,1),(53306907,425427760,15229603,454632,1,'2007-09-17 20:41:40',3310502435,1),(53306910,425428780,15229409,454632,1,'2007-09-17 20:41:40',3310502435,1),(53306911,425431429,15231442,725665,1,'2009-03-02 22:19:39',3310502435,5),(53306912,425436151,15233743,725665,1,'2009-03-02 22:19:39',3310502435,5),(53306913,425441103,15235423,725665,1,'2009-03-02 22:19:39',3310502435,6),(53306917,425446288,15238170,725665,1,'2009-03-02 22:19:39',3310502435,6),(53306921,425455281,15243247,725665,1,'2009-03-02 22:19:39',3310502438,5),(53306923,425462606,15247363,725665,1,'2009-03-02 22:19:39',3310502438,5),(53306925,425465209,15247424,725665,1,'2009-03-02 22:19:39',3310502438,5),(53306928,425469446,15246879,725665,1,'2009-03-02 22:19:39',3310502438,5),(53306930,425472473,15246698,725665,1,'2009-03-02 22:19:39',3310502438,5),(53306932,425475197,15247242,725665,1,'2009-03-02 22:19:39',3310502438,5),(53306935,425477982,15248877,725665,1,'2009-03-02 22:19:39',3310502438,5),(53306936,425479858,15250814,725665,1,'2009-03-02 22:19:39',3310502439,5),(53306938,425482098,15252570,725665,1,'2009-03-02 22:19:39',3310502439,5),(53306940,425484641,15253478,725665,1,'2009-03-02 22:19:39',3310502439,5),(53306943,425487668,15253962,725665,1,'2009-03-02 22:19:39',3310502439,5),(53306944,425490210,15254688,725665,1,'2009-03-02 22:19:39',3310502439,5),(53306946,425495961,15257413,725665,1,'2009-03-02 22:19:39',3310502439,5),(53306949,425499230,15259410,725665,1,'2009-03-02 22:19:39',3310502439,5),(53306952,425503104,15262437,725665,1,'2009-03-02 22:19:39',3310502439,5),(53306954,425507584,15265524,725665,1,'2009-03-02 22:19:39',3310502450,5),(53306956,425511156,15267159,725665,1,'2009-03-02 22:19:39',3310502450,5),(53306959,425513349,15266199,725665,1,'2009-03-02 22:22:38',3310502450,10),(53306963,425463187,15250873,454632,1,'2007-09-17 20:41:45',3310502438,1),(53306966,425462700,15251577,454632,1,'2007-09-17 20:41:45',3310502438,1),(53306970,425461887,15252119,454632,1,'2007-09-17 20:41:45',3310502438,1),(53306973,425460586,15251685,454632,1,'2007-09-17 20:41:46',3310502438,1),(53306975,425458527,15250114,454632,1,'2007-09-17 20:41:46',3310502438,1),(53306978,425454193,15247242,454632,1,'2007-09-17 20:41:46',3310502438,1),(53306979,425451104,15245834,454632,1,'2007-09-17 20:41:46',3310502435,1),(53306980,425448881,15239715,725665,1,'2009-03-02 22:19:39',3310502435,7),(53306983,425448839,15244587,454632,1,'2007-09-17 20:41:46',3310502435,1),(53306984,425448969,15245801,454632,1,'2007-09-17 20:41:47',3310502435,1),(53306988,425450140,15249356,454632,1,'2007-09-17 20:41:47',3310502435,1),(53306989,425451354,15252780,454632,1,'2007-09-17 20:41:47',3310502435,1),(53306991,425452784,15254384,454632,1,'2007-09-17 20:41:47',3310502438,1),(53306992,425455862,15255858,454632,1,'2007-09-17 20:41:47',3310502438,1),(53306994,425459850,15257895,454632,1,'2007-09-17 20:41:47',3310502438,1),(53309350,425446288,15244693,423843,1,'2008-07-08 00:16:11',3310502435,2),(53309352,425445010,15244239,454632,1,'2007-09-17 20:47:54',3310502435,1),(53309354,425443070,15243528,454632,1,'2007-09-17 20:47:54',3310502435,1),(53309356,425440742,15242170,454632,1,'2007-09-17 20:47:55',3310502435,1),(53309360,425437703,15241911,454632,1,'2007-09-17 20:47:55',3310502435,1),(53309365,425433953,15241394,454632,1,'2007-09-17 20:47:55',3310502435,1),(53309368,425431681,15241174,423843,1,'2008-07-08 00:19:31',3310502435,3),(53309369,425427317,15240316,423843,1,'2008-07-08 00:19:31',3310502435,2),(53309370,425424900,15240101,454632,1,'2007-09-17 20:47:56',3310502435,1),(53309371,425422005,15240573,423843,1,'2008-07-08 00:19:31',3310502434,2),(53309374,425419533,15240941,454632,1,'2007-09-17 20:47:57',3310502434,1),(53309376,425417981,15240941,454632,1,'2007-09-17 20:47:57',3310502434,1),(53309379,425415175,15239200,423843,1,'2008-07-08 00:19:31',3310502434,2),(53309380,425448059,15229125,454632,1,'2007-09-17 20:47:58',3310502435,1),(53309382,425444834,15237312,725665,1,'2009-03-02 22:19:39',3310502435,6),(53309384,425434463,15225810,423843,1,'2008-07-08 00:10:55',3310502435,4),(53309386,425444900,15247478,427200,1,'2008-05-12 16:43:07',3310502435,2),(53309389,425441120,15248118,427200,1,'2008-05-12 16:43:07',3310502435,2),(53309392,425449284,15247192,439103,1,'2008-05-14 00:34:52',3310502435,2),(53309393,425438864,15248212,454632,1,'2007-09-17 20:48:00',3310502435,1),(53309395,425435426,15248291,454632,1,'2007-09-17 20:48:00',3310502435,1),(53309397,425432661,15247658,454632,1,'2007-09-17 20:48:00',3310502435,1),(53309398,425429381,15246750,454632,1,'2007-09-17 20:48:00',3310502435,1),(53309400,425426576,15246197,454632,1,'2007-09-17 20:48:00',3310502435,1),(53309402,425423929,15246197,454632,1,'2007-09-17 20:48:01',3310502434,1),(53309405,425421598,15246592,454632,1,'2007-09-17 20:48:01',3310502434,1),(53309407,425419543,15247066,454632,1,'2007-09-17 20:48:02',3310502434,1),(53309409,425418397,15247698,454632,1,'2007-09-17 20:48:02',3310502434,1),(53309412,425418397,15248409,454632,1,'2007-09-17 20:48:02',3310502434,1),(53309414,425418990,15248804,454632,1,'2007-09-17 20:48:02',3310502434,1),(53309417,425419820,15248883,454632,1,'2007-09-17 20:48:03',3310502434,1),(53309419,425418982,15247236,454632,1,'2007-09-17 20:48:03',3310502434,1),(53309421,425424996,15249911,454632,1,'2007-09-17 20:48:03',3310502435,1),(53309423,425428275,15251056,454632,1,'2007-09-17 20:48:03',3310502435,1),(53309425,425431910,15252637,454632,1,'2007-09-17 20:48:03',3310502435,1),(53309427,425434676,15254415,454632,1,'2007-09-17 20:48:04',3310502435,1),(53309431,425437441,15256153,454632,1,'2007-09-17 20:48:04',3310502435,1),(53309433,425440207,15256667,454632,1,'2007-09-17 20:48:04',3310502435,1),(53309436,425442696,15256706,454632,1,'2007-09-17 20:48:05',3310502435,1),(53309438,425446015,15257734,454632,1,'2007-09-17 20:48:05',3310502435,1),(53309440,425448702,15258998,454632,1,'2007-09-17 20:48:06',3310502435,1),(53309443,425451942,15260736,454632,1,'2007-09-17 20:48:06',3310502435,1),(53309446,425455814,15264253,454632,1,'2007-09-17 20:48:06',3310502438,1),(53309449,425458738,15268046,454632,1,'2007-09-17 20:48:06',3310502438,1),(53309453,425461029,15270061,454632,1,'2007-09-17 20:48:06',3310502438,1),(53309457,425462136,15272985,454632,1,'2007-09-17 20:48:07',3310502444,1),(53309460,425463439,15275276,454632,1,'2007-09-17 20:48:07',3310502444,1),(53309462,425464506,15277015,454632,1,'2007-09-17 20:48:07',3310502444,1),(53309464,425467074,15279306,454632,1,'2007-09-17 20:48:07',3310502444,1),(53309466,425468023,15281045,454632,1,'2007-09-17 20:48:07',3310502444,1),(53309469,425468102,15282467,454632,1,'2007-09-17 20:48:08',3310502444,1),(53309473,425467667,15284087,454632,1,'2007-09-17 20:48:08',3310502444,1),(53309476,425466956,15286063,454632,1,'2007-09-17 20:48:08',3310502444,1),(53309477,425466798,15288275,454632,1,'2007-09-17 20:48:08',3310502444,1),(53309480,425467430,15290962,454632,1,'2007-09-17 20:48:09',3310502444,1),(53309482,425468220,15294241,454632,1,'2007-09-17 20:48:09',3310502444,1),(53309483,425469169,15297758,454632,1,'2007-09-17 20:48:09',3310502444,1),(53309485,425470709,15303171,454632,1,'2007-09-17 20:48:10',3310502444,1),(53315413,425565971,15347129,454632,1,'2007-09-17 21:04:42',3310502462,1),(53315705,425566654,15347695,498434,1,'2008-05-22 18:38:15',3310502462,4),(53315884,425566717,15349669,498434,1,'2008-05-22 18:38:00',3310502462,2),(53315943,425564947,15350098,498434,1,'2008-05-22 18:38:48',3310502462,2),(53315948,425563556,15351043,498434,1,'2008-05-22 18:38:48',3310502462,2),(53315952,425562734,15351987,498434,1,'2008-05-22 18:38:48',3310502462,2),(53315955,425562481,15353360,498434,1,'2008-05-22 18:38:48',3310502462,2),(53316065,425562355,15355763,498434,1,'2008-05-22 18:38:48',3310502462,2),(53316068,425561383,15361459,454632,1,'2007-09-17 21:06:31',3310502459,1),(53316074,425561191,15362550,454632,1,'2007-09-17 21:06:32',3310502459,1),(53316105,425550796,15363384,454632,1,'2007-09-17 21:06:39',3310502459,1),(53319479,425557992,15358167,498434,1,'2008-05-22 18:39:02',3310502459,2),(53319482,425562102,15358338,498434,1,'2008-05-22 18:39:02',3310502462,2),(53319484,425561067,15366284,454632,1,'2007-09-17 21:16:42',3310502459,1),(53319487,425547388,15367865,454632,1,'2007-09-17 21:16:42',3310502459,1),(53319489,425561013,15366339,454632,1,'2007-09-17 21:16:43',3310502459,1),(53319491,425431049,15168599,174860,1,'2008-12-06 16:03:50',3310502433,2),(53319492,425427698,15168427,174860,1,'2008-12-06 16:03:50',3310502433,2),(53319495,425424903,15167833,174860,1,'2008-12-06 16:03:50',3310502433,2),(53319497,425424012,15166263,174860,1,'2008-12-06 16:03:50',3310502432,2),(53319500,425424988,15165202,174860,1,'2008-12-06 16:03:50',3310502433,2),(53319503,425427364,15164269,174860,1,'2008-12-06 16:03:50',3310502433,2),(53319505,425428679,15162614,174860,1,'2008-12-06 16:03:50',3310502433,2),(53319509,425429061,15161681,174860,1,'2008-12-06 16:03:50',3310502433,2),(53319512,425426515,15150650,844916,1,'2009-01-27 19:52:23',3310502411,6),(53319514,425402915,15191242,454632,1,'2007-09-17 21:16:45',3310502432,1),(53319515,425405899,15191242,454632,1,'2007-09-17 21:16:45',3310502432,1),(53319517,425408169,15190205,454632,1,'2007-09-17 21:16:45',3310502432,1),(53319520,425410180,15187610,454632,1,'2007-09-17 21:16:46',3310502432,1),(53319521,425412710,15181254,454632,1,'2007-09-17 21:16:46',3310502432,1),(53319523,425415112,15175546,454632,1,'2007-09-17 21:16:46',3310502432,1),(53319525,425416751,15173552,454632,1,'2007-09-17 21:16:46',3310502432,1),(53319529,425418615,15172348,454632,1,'2007-09-17 21:16:46',3310502432,1),(53319532,425421790,15169773,454632,1,'2007-09-17 21:16:47',3310502432,1),(53319533,425424385,15167308,174860,1,'2008-12-06 16:03:50',3310502432,2),(53319535,425402887,15188047,454632,1,'2007-09-17 21:16:48',3310502432,1),(53319536,425405694,15187977,454632,1,'2007-09-17 21:16:48',3310502432,1),(53319538,425407308,15186573,454632,1,'2007-09-17 21:16:49',3310502432,1),(53319539,425408712,15184397,454632,1,'2007-09-17 21:16:49',3310502432,1),(53319541,425410607,15179835,454632,1,'2007-09-17 21:16:50',3310502432,1),(53319543,425412643,15174150,454632,1,'2007-09-17 21:16:50',3310502432,1),(53319545,425414327,15171062,454632,1,'2007-09-17 21:16:51',3310502432,1),(53319547,425416714,15168465,454632,1,'2007-09-17 21:16:51',3310502432,1),(53319548,425418889,15166219,454632,1,'2007-09-17 21:16:52',3310502432,1),(53319551,425421697,15163973,454632,1,'2007-09-17 21:16:52',3310502432,1),(53319552,425425066,15161376,454632,1,'2007-09-17 21:16:53',3310502433,1),(53319554,425428505,15158077,174860,1,'2008-12-06 16:03:50',3310502411,2),(53319555,425417658,15163247,327248,1,'2009-04-08 23:43:26',3310502432,2),(53319557,425427818,15155261,327248,1,'2009-04-08 23:43:27',3310502411,3),(53319560,425428101,15148453,787878,1,'2009-01-15 00:29:04',3310502411,2),(53319563,425429042,15147303,787878,1,'2009-01-15 00:29:04',3310502411,2),(53319564,425431498,15147251,787878,1,'2009-01-15 00:29:04',3310502411,2),(53319566,425433275,15147878,787878,1,'2009-01-15 00:29:04',3310502411,2),(53319568,425435522,15148244,787878,1,'2009-01-15 00:29:04',3310502411,2),(53319570,425437665,15148244,787878,1,'2009-01-15 00:29:04',3310502411,2),(53319571,425439285,15147565,787878,1,'2009-01-15 00:29:04',3310502411,2),(53319573,425442212,15145213,787878,1,'2009-01-15 00:29:03',3310502411,2),(53319576,425443884,15143645,725665,1,'2009-03-02 22:10:41',3310502411,3),(53319578,425444668,15141241,787878,1,'2009-01-15 00:29:03',3310502411,2),(53319581,425337097,15191335,454632,1,'2007-09-17 21:16:58',3310491505,1),(53319582,425337629,15192358,454632,1,'2007-09-17 21:16:59',3310491505,1),(53319584,425336116,15190231,454632,1,'2007-09-17 21:17:00',3310491505,1),(53319587,425333375,15188799,454632,1,'2007-09-17 21:17:00',3310491505,1);
INSERT INTO `nodes` VALUES (53319589,425330266,15187490,454632,1,'2007-09-17 21:17:01',3310491505,1),(53319592,425328793,15187408,454632,1,'2007-09-17 21:17:01',3310491505,1),(53319593,425326093,15188267,454632,1,'2007-09-17 21:17:02',3310491505,1),(53319596,425324743,15188676,454632,1,'2007-09-17 21:17:02',3310491505,1),(53319598,425323557,15188472,454632,1,'2007-09-17 21:17:02',3310491505,1),(53319600,425322616,15187981,454632,1,'2007-09-17 21:17:02',3310491505,1),(53319601,425322411,15186754,454632,1,'2007-09-17 21:17:03',3310491505,1),(53319603,425322330,15185240,454632,1,'2007-09-17 21:17:05',3310491505,1),(53319605,425324048,15180740,454632,1,'2007-09-17 21:17:06',3310491505,1),(53319607,425325316,15178367,454632,1,'2007-09-17 21:17:06',3310491505,1),(53319609,425326502,15177263,454632,1,'2007-09-17 21:17:06',3310491505,1),(53319610,425328589,15176527,454632,1,'2007-09-17 21:17:07',3310491505,1),(53319611,425330634,15175299,454632,1,'2007-09-17 21:17:07',3310491505,1),(53319612,425331861,15173867,454632,1,'2007-09-17 21:17:07',3310491505,1),(53319613,425331984,15172681,454632,1,'2007-09-17 21:17:07',3310491505,1),(53319616,425331166,15171617,454632,1,'2007-09-17 21:17:08',3310491505,1),(53319617,425327934,15170881,454632,1,'2007-09-17 21:17:08',3310491505,1),(53319619,425325357,15170799,454632,1,'2007-09-17 21:17:08',3310491505,1),(53319621,425323884,15171699,454632,1,'2007-09-17 21:17:08',3310491505,1),(53319624,425322411,15173499,454632,1,'2007-09-17 21:17:09',3310491505,1),(53319625,425321007,15175256,454632,1,'2007-09-17 21:17:09',3310491505,1),(53319627,425319214,15177633,454632,1,'2007-09-17 21:17:09',3310491505,1),(53319629,425318047,15179009,454632,1,'2007-09-17 21:17:10',3310491505,1),(53319631,425316129,15180802,454632,1,'2007-09-17 21:17:10',3310491505,1),(53319632,425314670,15181385,454632,1,'2007-09-17 21:17:10',3310491504,1),(53319634,425312835,15181302,454632,1,'2007-09-17 21:17:11',3310491504,1),(53319636,425311292,15179509,454632,1,'2007-09-17 21:17:11',3310491504,1),(53319638,425310834,15176757,454632,1,'2007-09-17 21:17:12',3310491504,1),(53319639,425311876,15170878,454632,1,'2007-09-17 21:17:12',3310491504,1),(53319642,425313252,15167043,454632,1,'2007-09-17 21:17:12',3310491504,1),(53319643,425316796,15163999,454632,1,'2007-09-17 21:17:12',3310491505,1),(53319645,425318756,15163665,454632,1,'2007-09-17 21:17:13',3310491505,1),(53319646,425314512,15164899,454632,1,'2007-09-17 21:17:13',3310491504,1),(53319648,425322193,15163589,454632,1,'2007-09-17 21:17:13',3310491505,1),(53319649,425325911,15163390,454632,1,'2007-09-17 21:17:14',3310491505,1),(53319651,425328634,15163324,454632,1,'2007-09-17 21:17:14',3310491505,1),(53319652,425332485,15162660,454632,1,'2007-09-17 21:17:14',3310491505,1),(53319657,425335340,15162328,454632,1,'2007-09-17 21:17:15',3310491505,1),(53319658,425336934,15161398,454632,1,'2007-09-17 21:17:15',3310491505,1),(53319659,425338328,15159473,454632,1,'2007-09-17 21:17:15',3310491483,1),(53319661,425340785,15158078,454632,1,'2007-09-17 21:17:16',3310491483,1),(53319663,425344503,15157613,454632,1,'2007-09-17 21:17:16',3310491486,1),(53319664,425348819,15157547,454632,1,'2007-09-17 21:17:16',3310491486,1),(53319665,425353002,15158543,454632,1,'2007-09-17 21:17:16',3310491486,1),(53319666,425355725,15160336,454632,1,'2007-09-17 21:17:17',3310491486,1),(53319667,425358978,15162129,454632,1,'2007-09-17 21:17:17',3310491508,1),(53319669,425361900,15164386,454632,1,'2007-09-17 21:17:17',3310491508,1),(53319670,425362896,15165183,454632,1,'2007-09-17 21:17:17',3310491508,1),(53319672,425363826,15165648,454632,1,'2007-09-17 21:17:17',3310491508,1),(53319675,425364822,15165581,454632,1,'2007-09-17 21:17:18',3310491508,1),(53319678,425367146,15164785,454632,1,'2007-09-17 21:17:18',3310491508,1),(53319681,425369204,15164054,454632,1,'2007-09-17 21:17:18',3310491508,1),(53319682,425370665,15162660,454632,1,'2007-09-17 21:17:18',3310491509,1),(53319684,425371679,15161533,454632,1,'2007-09-17 21:35:49',3310491509,1),(53319686,425373852,15160668,454632,1,'2007-09-17 21:17:19',3310491487,1),(53319687,425375711,15160668,104780,1,'2009-02-04 00:29:51',3310491487,2),(53319688,425378234,15162195,454632,1,'2007-09-17 21:17:19',3310491509,1),(53319690,425382085,15163988,454632,1,'2007-09-17 21:17:20',3310491509,1),(53319693,425386069,15165249,454632,1,'2007-09-17 21:17:20',3310491509,1),(53319695,425390186,15165714,454632,1,'2007-09-17 21:17:20',3310491509,1),(53319697,425393639,15166046,454632,1,'2007-09-17 21:17:20',3310491509,1),(53319700,425397623,15165183,454632,1,'2007-09-17 21:17:21',3310502432,1),(53319701,425401474,15164453,454632,1,'2007-09-17 21:17:21',3310502432,1),(53319702,425405525,15162394,454632,1,'2007-09-17 21:17:21',3310502432,1),(53319703,425408977,15159539,454632,1,'2007-09-17 21:17:21',3310502410,1),(53319705,425414887,15155887,844916,1,'2009-01-27 19:52:23',3310502410,4),(53319707,425410991,15151349,844916,1,'2009-01-27 19:52:23',3310502410,4),(53319708,425417533,15157215,844916,1,'2009-01-27 19:52:23',3310502410,4),(53319710,425419292,15157530,844916,1,'2009-01-27 19:52:23',3310502410,4),(53319712,425421007,15156899,844916,1,'2009-01-27 19:52:23',3310502410,4),(53319714,425423669,15154147,844916,1,'2009-01-27 19:52:23',3310502410,4),(53319717,425409176,15148884,844916,1,'2009-01-27 19:52:23',3310502410,4),(53319718,425408583,15146827,844916,1,'2009-01-27 19:52:23',3310502410,4),(53319720,425408375,15145987,844916,1,'2009-01-27 19:52:23',3310502410,5),(53319721,425410323,15140340,844916,1,'2009-01-27 19:52:23',3310502410,4),(53319724,425415900,15131243,844916,1,'2009-01-27 19:52:23',3310502410,4),(53319725,425422031,15123570,844916,1,'2009-01-27 19:52:23',3310502410,4),(53319726,425426225,15118832,844916,1,'2009-01-27 19:52:23',3310502411,4),(53319727,425429536,15114342,844916,1,'2009-01-27 19:52:23',3310502411,4),(53319731,425431350,15110940,844916,1,'2009-01-27 19:52:23',3310502411,4),(53319732,425433300,15106088,844916,1,'2009-01-27 19:52:23',3310502409,4),(53319735,425434525,15103321,844916,1,'2009-01-27 19:52:23',3310502409,4),(53319737,425440783,15095974,844916,1,'2009-01-27 19:52:23',3310502409,4),(53319740,425443913,15093298,844916,1,'2009-01-27 19:52:23',3310502409,4),(53319741,425448312,15092573,844916,1,'2009-01-27 19:52:23',3310502409,4),(53319742,425453618,15091529,844916,1,'2009-01-27 19:52:23',3310502412,4),(53319744,425455296,15091031,844916,1,'2009-01-27 19:52:23',3310502412,4),(53319747,425455970,15090330,844916,1,'2009-01-27 19:52:23',3310502412,5),(53319749,425454752,15088264,454632,1,'2007-09-17 21:17:27',3310502412,1),(53319750,425452802,15087357,454632,1,'2007-09-17 21:17:27',3310502412,1),(53319752,425450443,15087901,454632,1,'2007-09-17 21:17:28',3310502409,1),(53319753,425448312,15087765,454632,1,'2007-09-17 21:17:28',3310502409,1),(53319755,425445228,15086813,454632,1,'2007-09-17 21:17:29',3310502409,1),(53319756,425443640,15086677,454632,1,'2007-09-17 21:17:30',3310502409,1),(53319758,425440420,15088355,454632,1,'2007-09-17 21:17:30',3310502409,1),(53319759,425438062,15090622,454632,1,'2007-09-17 21:17:31',3310502409,1),(53319761,425434221,15093245,454632,1,'2007-09-17 21:17:31',3310502409,1),(53319765,425430491,15095679,454632,1,'2007-09-17 21:17:32',3310502409,1),(53319768,425427429,15096936,454632,1,'2007-09-17 21:17:32',3310502409,1),(53319770,425424366,15097996,454632,1,'2007-09-17 21:17:32',3310502408,1),(53319773,425422482,15097996,454632,1,'2007-09-17 21:17:32',3310502408,1),(53319774,425416750,15097751,454632,1,'2007-09-17 21:17:32',3310502408,1),(53319777,425415944,15096334,454632,1,'2007-09-17 21:17:33',3310502408,1),(53319778,425416694,15094556,454632,1,'2007-09-17 21:17:33',3310502408,1),(53319781,425417166,15093916,454632,1,'2007-09-17 21:17:33',3310502408,1),(53319782,425419723,15093305,454632,1,'2007-09-17 21:17:33',3310502408,1),(53319784,425421446,15093277,454632,1,'2007-09-17 21:17:33',3310502408,1),(53319786,425438027,15102334,454632,1,'2007-09-17 21:17:33',3310502409,1),(53319787,425436570,15100548,844916,1,'2009-01-27 19:52:23',3310502409,4),(53319789,425437228,15109475,454632,1,'2007-09-17 21:17:34',3310502411,1),(53319790,425439342,15106515,454632,1,'2007-09-17 21:17:34',3310502411,1),(53319793,425444463,15100830,454632,1,'2007-09-17 21:17:34',3310502409,1),(53319796,425447188,15098998,454632,1,'2007-09-17 21:17:34',3310502409,1),(53319797,425448739,15098716,454632,1,'2007-09-17 21:17:35',3310502409,1),(53319800,425449772,15099703,454632,1,'2007-09-17 21:17:35',3310502409,1),(53319801,425450148,15101394,454632,1,'2007-09-17 21:17:35',3310502409,1),(53319804,425449444,15103179,454632,1,'2007-09-17 21:17:35',3310502409,1),(53319806,425445779,15107737,454632,1,'2007-09-17 21:17:35',3310502411,1),(53319807,425442255,15112435,454632,1,'2007-09-17 21:17:35',3310502411,1),(53319809,425319389,15149734,454632,1,'2007-09-17 21:17:36',3310491483,1),(53319811,425317115,15150013,454632,1,'2007-09-17 21:17:36',3310491483,1),(53319813,425315630,15150199,454632,1,'2007-09-17 21:17:36',3310491483,1),(53319815,425314191,15151034,454632,1,'2007-09-17 21:17:36',3310491482,1),(53319816,425312705,15151684,454632,1,'2007-09-17 21:17:36',3310491482,1),(53319817,425311498,15151313,454632,1,'2007-09-17 21:17:37',3310491482,1),(53319818,425310849,15150013,454632,1,'2007-09-17 21:17:37',3310491482,1),(53319819,425310941,15148249,454632,1,'2007-09-17 21:17:37',3310491482,1),(53319820,425315537,15145650,454632,1,'2007-09-17 21:17:37',3310491483,1),(53319821,425317301,15144953,454632,1,'2007-09-17 21:17:37',3310491483,1),(53319822,425318739,15144814,454632,1,'2007-09-17 21:17:37',3310491483,1),(53319823,425319946,15145046,454632,1,'2007-09-17 21:17:37',3310491483,1),(53319826,425321060,15145742,454632,1,'2007-09-17 21:17:37',3310491483,1),(53319828,425322638,15143376,181856,1,'2009-04-04 22:09:19',3310491483,5),(53319829,425319852,15128638,181856,1,'2009-04-04 22:08:18',3310491483,5),(53319832,425319586,15131563,181856,1,'2009-04-04 22:08:18',3310491483,5),(53319833,425319719,15135817,181856,1,'2009-04-04 22:08:19',3310491483,5),(53319835,425320350,15138742,181856,1,'2009-04-04 22:09:19',3310491483,7),(53319838,425321242,15141244,181856,1,'2009-04-04 22:09:19',3310491483,5),(53319839,425326194,15145404,181856,1,'2009-04-04 22:09:19',3310491483,5),(53325641,425330135,15147493,181856,1,'2009-04-04 22:09:20',3310491483,5),(53325645,425334581,15150732,181856,1,'2009-04-04 22:09:20',3310491483,5),(53325649,425338900,15153908,181856,1,'2009-04-04 22:09:20',3310491483,5),(53325657,425342203,15155877,181856,1,'2009-04-04 22:09:20',3310491486,5),(53325659,425343283,15156893,181856,1,'2009-04-04 22:09:21',3310491486,5),(53325663,425343601,15157846,181856,1,'2009-04-04 22:09:21',3310491486,5),(53325664,425381525,15133789,104780,1,'2009-02-04 00:33:00',3310491487,2),(53325666,425378707,15144167,104780,1,'2009-02-04 00:33:00',3310491487,2),(53325669,425377449,15149147,104780,1,'2009-02-04 00:33:00',3310491487,2),(53325671,425376054,15150384,104780,1,'2009-02-04 00:33:00',3310491487,2),(53325672,425372865,15153652,104780,1,'2009-02-04 00:33:00',3310491487,2),(53325674,425366446,15164956,104780,1,'2009-02-04 00:33:00',3310491508,2),(53325677,425387276,15148156,104780,1,'2009-02-04 00:29:50',3310491487,2),(53325680,425383444,15150851,104780,1,'2009-02-04 00:29:51',3310491487,2),(53325681,425381759,15153251,104780,1,'2009-02-04 00:29:51',3310491487,2),(53325699,425380075,15156115,104780,1,'2009-02-04 00:29:51',3310491487,2),(53325706,425377548,15158515,104780,1,'2009-02-04 00:29:51',3310491487,2),(53325709,425400217,15129422,306164,1,'2008-05-01 18:30:33',3310502410,2),(53325711,425394235,15133655,454632,1,'2007-09-17 21:35:16',3310491487,1),(53325715,425387951,15137724,454632,1,'2007-09-17 21:35:17',3310491487,1),(53325718,425385118,15139372,454632,1,'2007-09-17 21:35:17',3310491487,1),(53325720,425384243,15140711,454632,1,'2007-09-17 21:35:17',3310491487,1),(53325722,425383419,15144935,454632,1,'2007-09-17 21:35:18',3310491487,1),(53325723,425382904,15146222,454632,1,'2007-09-17 21:35:18',3310491487,1),(53325724,425381873,15148283,454632,1,'2007-09-17 21:35:18',3310491487,1),(53325725,425379504,15151321,454632,1,'2007-09-17 21:35:19',3310491487,1),(53325726,425376414,15155699,454632,1,'2007-09-17 21:35:19',3310491487,1),(53325729,425373684,15158687,454632,1,'2007-09-17 21:35:19',3310491487,1),(53325732,425372609,15160973,454632,1,'2007-09-17 21:35:19',3310491487,1),(53325735,425401988,15132426,306164,1,'2008-05-01 18:30:58',3310502410,2),(53325736,425404265,15137318,306164,1,'2008-05-01 18:30:58',3310502410,2),(53325739,425404667,15139744,454632,1,'2007-09-17 21:35:20',3310502410,1),(53325742,425405340,15141266,306164,1,'2008-05-01 18:34:56',3310502410,2),(53325743,425406045,15142768,454632,1,'2007-09-17 21:35:21',3310502410,1),(53325746,425407237,15144270,306164,1,'2008-05-01 18:34:56',3310502410,2),(53325748,425422920,15116118,306164,1,'2008-05-01 18:29:59',3310502410,2),(53325750,425419821,15117835,306164,1,'2008-05-01 18:29:59',3310502410,2),(53325752,425417988,15118865,306164,1,'2008-05-01 18:29:59',3310502410,2),(53325792,425417229,15120066,306164,1,'2008-05-01 18:31:34',3310502410,3),(53325795,425417102,15121525,306164,1,'2008-05-01 18:31:34',3310502410,3),(53325798,425416027,15122384,306164,1,'2008-05-01 18:29:59',3310502410,3),(53325801,425414573,15122813,306164,1,'2008-05-01 18:29:59',3310502410,3),(53325802,425412992,15125388,306164,1,'2008-05-01 18:23:25',3310502410,2),(53325805,425410968,15127276,306164,1,'2008-05-01 18:25:57',3310502410,2),(53325807,425409071,15128392,306164,1,'2008-05-01 18:25:57',3310502410,2),(53325809,425406731,15129937,306164,1,'2008-05-01 18:31:34',3310502410,3),(53325813,425406162,15131653,306164,1,'2008-05-01 18:31:34',3310502410,3),(53325815,425406099,15134228,370566,1,'2008-05-09 01:42:33',3310502410,4),(53325817,425403190,15134228,306164,1,'2008-05-01 18:30:58',3310502410,3),(53325818,425414261,15133916,844916,1,'2009-01-27 19:52:23',3310502410,4),(53325820,425410146,15135258,306164,1,'2008-05-01 18:33:36',3310502410,2),(53325823,425425462,15110073,454632,1,'2007-09-17 21:35:32',3310502411,1),(53325827,425428724,15108079,454632,1,'2007-09-17 21:35:32',3310502411,1),(53325829,425430465,15106666,454632,1,'2007-09-17 21:35:32',3310502411,1),(53325840,425431806,15104780,454632,1,'2007-09-17 21:35:35',3310502409,1),(53325843,425433655,15103620,454632,1,'2007-09-17 21:35:35',3310502409,1),(53325846,425400505,15126786,454632,1,'2007-09-17 21:35:35',3310502410,1),(53325848,425401585,15124672,454632,1,'2007-09-17 21:35:35',3310502410,1),(53325850,425404834,15121611,306164,1,'2008-05-01 18:30:33',3310502410,2),(53325852,425407363,15119895,306164,1,'2008-05-01 18:30:33',3310502410,2),(53327620,425445466,15138893,787878,1,'2009-01-15 00:29:03',3310502411,2),(53327622,425447338,15137254,454632,1,'2007-09-17 21:41:21',3310502411,1),(53327626,425450966,15135558,844916,1,'2009-01-27 20:10:20',3310502411,3),(53327629,425498361,15157348,454632,1,'2007-09-17 21:41:22',3310502415,1),(53327630,425498991,15153971,454632,1,'2007-09-17 21:41:22',3310502415,1),(53327633,425499334,15152654,454632,1,'2007-09-17 21:41:22',3310502415,1),(53327636,425499334,15151566,454632,1,'2007-09-17 21:41:22',3310502415,1),(53327637,425498705,15150536,454632,1,'2007-09-17 21:41:22',3310502415,1),(53327639,425497961,15149448,454632,1,'2007-09-17 21:41:22',3310502415,1),(53327642,425497102,15148532,454632,1,'2007-09-17 21:41:22',3310502415,1),(53327646,425496472,15148475,454632,1,'2007-09-17 21:41:23',3310502415,1),(53327649,425496129,15149162,454632,1,'2007-09-17 21:41:23',3310502415,1),(53327652,425496358,15150708,454632,1,'2007-09-17 21:41:23',3310502415,1),(53327654,425496758,15152425,454632,1,'2007-09-17 21:41:23',3310502415,1),(53327657,425496873,15153169,454632,1,'2007-09-17 21:41:23',3310502415,1),(53327661,425496873,15153742,454632,1,'2007-09-17 21:41:23',3310502415,1),(53327664,425496472,15154142,454632,1,'2007-09-17 21:41:24',3310502415,1),(53327667,425495843,15154257,454632,1,'2007-09-17 21:41:24',3310502415,1),(53327669,425495385,15153971,454632,1,'2007-09-17 21:41:24',3310502415,1),(53327672,425494812,15152826,454632,1,'2007-09-17 21:41:24',3310502415,1),(53327675,425493209,15146758,454632,1,'2007-09-17 21:41:25',3310502415,1),(53327678,425492694,15146186,454632,1,'2007-09-17 21:41:25',3310502415,1),(53327682,425492122,15146357,454632,1,'2007-09-17 21:41:25',3310502415,1),(53327685,425492179,15146815,454632,1,'2007-09-17 21:41:25',3310502415,1),(53327686,425492236,15150078,454632,1,'2007-09-17 21:41:25',3310502415,1),(53327689,425492580,15153284,454632,1,'2007-09-17 21:41:25',3310502415,1),(53327693,425492637,15155001,454632,1,'2007-09-17 21:41:25',3310502415,1),(53327696,425492179,15155688,454632,1,'2007-09-17 21:41:25',3310502415,1),(53327697,425491492,15155631,454632,1,'2007-09-17 21:41:26',3310502415,1),(53327700,425490977,15155344,454632,1,'2007-09-17 21:41:26',3310502415,1),(53327703,425490576,15153856,454632,1,'2007-09-17 21:41:26',3310502415,1),(53327705,425489546,15149162,454632,1,'2007-09-17 21:41:26',3310502415,1),(53327706,425488973,15148532,454632,1,'2007-09-17 21:41:26',3310502415,1),(53327708,425488229,15149391,454632,1,'2007-09-17 21:41:27',3310502415,1),(53327710,425488057,15151395,454632,1,'2007-09-17 21:41:27',3310502415,1),(53327712,425487370,15154142,454632,1,'2007-09-17 21:41:27',3310502415,1),(53327716,425487142,15155402,454632,1,'2007-09-17 21:41:27',3310502415,1),(53327717,425486741,15156031,454632,1,'2007-09-17 21:41:27',3310502415,1),(53327720,425486054,15156203,454632,1,'2007-09-17 21:41:28',3310502415,1),(53327721,425485539,15155802,454632,1,'2007-09-17 21:41:28',3310502415,1),(53327724,425485481,15155058,454632,1,'2007-09-17 21:41:28',3310502415,1),(53327726,425487256,15144525,454632,1,'2007-09-17 21:41:28',3310502415,1),(53327728,425487142,15143438,454632,1,'2007-09-17 21:41:28',3310502415,1),(53327730,425486283,15142923,454632,1,'2007-09-17 21:41:28',3310502415,1),(53327733,425485596,15143266,454632,1,'2007-09-17 21:41:28',3310502415,1),(53327734,425485252,15144010,454632,1,'2007-09-17 21:41:28',3310502415,1),(53327735,425483535,15152196,454632,1,'2007-09-17 21:41:29',3310502415,1),(53327736,425482905,15154028,454632,1,'2007-09-17 21:41:29',3310502415,1),(53327737,425482161,15154600,454632,1,'2007-09-17 21:41:29',3310502415,1),(53327738,425481474,15154829,454632,1,'2007-09-17 21:41:29',3310502415,1),(53327739,425480158,15154486,454632,1,'2007-09-17 21:41:29',3310502415,1),(53327741,425479299,15154429,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327743,425478154,15154829,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327746,425477639,15154543,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327748,425477639,15153799,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327749,425478040,15153055,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327752,425479070,15152769,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327753,425480272,15151738,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327755,425480845,15150765,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327756,425481360,15149849,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327757,425481417,15148647,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327758,425480616,15148189,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327759,425480501,15148590,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327760,425480101,15149735,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327763,425479585,15150364,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327765,425478784,15150937,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327768,425477525,15150937,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327769,425477296,15150536,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327771,425477238,15149906,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327772,425477639,15149620,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327775,425478555,15148590,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327779,425478841,15148246,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327782,425479242,15147330,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327789,425479185,15145728,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327791,425479528,15143495,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327794,425479299,15142121,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327799,425479185,15139946,174860,1,'2008-12-06 15:53:58',3310502414,2),(53327804,425479814,15138400,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327808,425481474,15134966,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327812,425482362,15131804,174860,1,'2008-12-06 15:53:58',3310502415,2),(53327814,425480288,15126795,454632,1,'2007-09-17 21:41:38',3310502415,1),(53327815,425478237,15129268,454632,1,'2007-09-17 21:41:38',3310502414,1),(53327818,425481867,15125585,454632,1,'2007-09-17 21:41:38',3310502415,1),(53327821,425482919,15124007,454632,1,'2007-09-17 21:41:39',3310502415,1),(53327824,425483235,15122587,454632,1,'2007-09-17 21:41:39',3310502415,1),(53327826,425482445,15121692,454632,1,'2007-09-17 21:41:39',3310502415,1),(53327830,425481551,15121640,454632,1,'2007-09-17 21:41:39',3310502415,1),(53327833,425479026,15123376,454632,1,'2007-09-17 21:41:40',3310502414,1),(53327836,425476448,15124954,454632,1,'2007-09-17 21:41:40',3310502414,1),(53327838,425473344,15126427,454632,1,'2007-09-17 21:41:40',3310502414,1),(53327844,425470135,15127953,454632,1,'2007-09-17 21:41:41',3310502414,1),(53327851,425467136,15130005,454632,1,'2007-09-17 21:41:41',3310502414,1),(53327853,425463716,15131425,454632,1,'2007-09-17 21:41:42',3310502414,1),(53327855,425461243,15132214,454632,1,'2007-09-17 21:41:42',3310502414,1),(53327873,425460244,15133161,454632,1,'2007-09-17 21:41:44',3310502414,1),(53327875,425459034,15134792,454632,1,'2007-09-17 21:41:44',3310502414,1),(53327877,425457982,15134792,454632,1,'2007-09-17 21:41:44',3310502414,1),(53327879,425456929,15133214,454632,1,'2007-09-17 21:41:44',3310502414,1),(53327880,425457298,15131793,454632,1,'2007-09-17 21:41:44',3310502414,1),(53327882,425459297,15129426,454632,1,'2007-09-17 21:41:45',3310502414,1),(53330420,425436125,15153073,725665,1,'2009-03-02 22:10:40',3310502411,2),(53330432,425438028,15152887,725665,1,'2009-03-02 22:10:41',3310502411,2),(53330444,425440813,15150845,725665,1,'2009-03-02 22:10:41',3310502411,2),(53330446,425442206,15149266,725665,1,'2009-03-02 22:10:41',3310502411,2),(53330448,425442809,15146853,725665,1,'2009-03-02 22:10:41',3310502411,2),(53330450,425452747,15139835,454632,1,'2007-09-17 21:47:48',3310502414,1),(53330453,425454584,15144107,454632,1,'2007-09-17 21:47:48',3310502414,1),(53332056,425320561,15127157,181856,1,'2009-04-04 22:08:18',3310491483,5),(53332059,425321075,15124588,181856,1,'2009-04-04 22:08:17',3310491483,5),(53332062,425320635,15122900,181856,1,'2009-04-04 22:08:17',3310491483,5),(53332065,425318140,15120918,181856,1,'2009-04-04 22:08:16',3310491483,5),(53332068,425316231,15118496,181856,1,'2009-04-04 22:08:16',3310491483,5),(53332070,425314470,15114533,181856,1,'2009-04-04 22:08:15',3310491482,5),(53332072,425311975,15107634,181856,1,'2009-04-04 22:08:15',3310491482,5),(53332075,425311828,15105433,181856,1,'2009-04-04 22:08:15',3310491480,5),(53332078,425311828,15101763,181856,1,'2009-04-04 22:08:14',3310491480,5),(53332079,425311388,15098607,181856,1,'2009-04-04 22:25:06',3310491480,11),(53332081,425309846,15095598,181856,1,'2009-04-04 22:25:06',3310491480,7),(53332083,425309112,15093030,181856,1,'2009-04-04 22:25:06',3310491480,7),(53332086,425309479,15090314,181856,1,'2009-04-04 22:25:06',3310491480,7),(53332089,425310361,15087819,181856,1,'2009-04-04 22:25:05',3310491480,7),(53332091,425311059,15085126,181856,1,'2009-04-04 22:25:05',3310491480,7),(53332094,425311558,15083430,181856,1,'2009-04-04 22:25:05',3310491480,7),(53332097,425311359,15081884,181856,1,'2009-04-04 22:25:05',3310491480,7),(53332100,425310012,15080139,181856,1,'2009-04-04 22:25:05',3310491480,7),(53332102,425309015,15078194,181856,1,'2009-04-04 22:25:05',3310491480,7),(53332105,425308865,15076449,181856,1,'2009-04-04 22:25:05',3310491480,7),(53332107,425308766,15073756,181856,1,'2009-04-04 22:25:05',3310491480,7),(53332109,425309065,15071811,181856,1,'2009-04-04 22:25:05',3310491480,7),(53332111,425310012,15069019,181856,1,'2009-04-04 22:25:05',3310491480,7),(53332113,425311758,15065777,181856,1,'2009-04-04 22:25:05',3310491480,7),(53332117,425312828,15063919,181856,1,'2009-04-04 22:25:05',3310491480,8),(53332120,425313049,15062173,181856,1,'2009-04-04 22:25:04',3310491480,8),(53332123,425313216,15060190,181856,1,'2009-04-04 22:25:04',3310491480,8),(53334410,425476417,15203842,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334413,425476150,15207044,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334414,425475616,15208538,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334417,425474656,15208912,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334419,425473695,15208698,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334421,425473161,15207311,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334422,425472201,15204696,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334423,425471560,15200639,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334424,425471827,15195142,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334427,425471774,15192527,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334428,425470920,15191140,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334431,425469746,15190659,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334432,425468785,15191140,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334433,425467984,15192527,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334437,425467611,15194449,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334441,425468038,15198398,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334442,425469159,15203094,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334444,425469319,15206777,498434,1,'2008-05-22 19:58:22',3310502436,2),(53334448,425470600,15210886,498434,1,'2008-05-22 19:58:22',3310502436,2),(53335700,425186391,15656546,708302,1,'2008-01-29 23:52:04',3310491618,2),(53335702,425179661,15663348,454632,1,'2007-09-17 21:59:06',3310491618,1),(53335703,425181737,15667500,454632,1,'2007-09-17 21:59:06',3310491618,1),(53335707,425182310,15669004,454632,1,'2007-09-17 21:59:06',3310491618,1),(53335710,425182167,15672655,454632,1,'2007-09-17 21:59:06',3310491618,1),(53335714,425183098,15675662,454632,1,'2007-09-17 21:59:07',3310491618,1),(53335715,425189971,15687189,454632,1,'2007-09-17 21:59:07',3310491618,1),(53335717,425196844,15697355,454632,1,'2007-09-17 21:59:07',3310491618,1),(53335718,425199421,15700648,454632,1,'2007-09-17 21:59:07',3310491618,1),(53335719,425203717,15703798,454632,1,'2007-09-17 21:59:07',3310491618,1),(53335720,425208155,15706018,454632,1,'2007-09-17 21:59:08',3310491619,1),(53335721,425210948,15707235,454632,1,'2007-09-17 21:59:08',3310491619,1),(53335722,425212594,15707736,454632,1,'2007-09-17 21:59:08',3310491619,1),(53335723,425214384,15707664,454632,1,'2007-09-17 21:59:08',3310491619,1),(53335724,425214957,15706948,454632,1,'2007-09-17 21:59:08',3310491619,1),(53335727,425215243,15705373,454632,1,'2007-09-17 21:59:08',3310491619,1),(53335730,425214599,15703011,454632,1,'2007-09-17 21:59:08',3310491619,1),(53335733,425214456,15701293,454632,1,'2007-09-17 21:59:09',3310491619,1),(53335738,425214241,15699145,454632,1,'2007-09-17 21:59:09',3310491619,1),(53335740,425213811,15697283,454632,1,'2007-09-17 21:59:09',3310491619,1),(53335742,425212308,15695493,454632,1,'2007-09-17 21:59:09',3310491619,1),(53335743,425210733,15694563,454632,1,'2007-09-17 21:59:10',3310491619,1),(53335744,425209802,15693202,454632,1,'2007-09-17 21:59:10',3310491619,1),(53335745,425208370,15691985,454632,1,'2007-09-17 21:59:10',3310491619,1),(53335746,425207082,15689766,454632,1,'2007-09-17 21:59:10',3310491619,1),(53335747,425206079,15687189,454632,1,'2007-09-17 21:59:10',3310491619,1),(53335750,425205363,15684038,454632,1,'2007-09-17 21:59:10',3310491619,1),(53335752,425203573,15681389,454632,1,'2007-09-17 21:59:11',3310491618,1),(53335755,425202500,15679743,454632,1,'2007-09-17 21:59:11',3310491618,1),(53335756,425202213,15677810,454632,1,'2007-09-17 21:59:11',3310491618,1),(53335759,425200996,15675948,454632,1,'2007-09-17 21:59:11',3310491618,1),(53335762,425200065,15675447,454632,1,'2007-09-17 21:59:11',3310491618,1),(53335764,425198705,15673013,454632,1,'2007-09-17 21:59:11',3310491618,1),(53335766,425197416,15670078,454632,1,'2007-09-17 21:59:12',3310491618,1),(53335768,425196342,15667787,454632,1,'2007-09-17 21:59:12',3310491618,1),(53335771,425194911,15666283,454632,1,'2007-09-17 21:59:12',3310491618,1),(53335776,425193622,15664780,454632,1,'2007-09-17 21:59:13',3310491618,1),(53335779,425191044,15662990,454632,1,'2007-09-17 21:59:13',3310491618,1),(53335782,425187536,15660627,454632,1,'2007-09-17 21:59:13',3310491618,1),(53335783,425186534,15658408,454632,1,'2007-09-17 21:59:13',3310491618,1),(53343318,425153486,15545410,454632,1,'2007-09-17 22:24:37',3310491549,1),(53343339,425154776,15553171,454632,1,'2007-09-17 22:24:42',3310491551,1),(53343344,425158165,15557727,454632,1,'2007-09-17 22:24:42',3310491551,1),(53343348,425163077,15564407,454632,1,'2007-09-17 22:24:43',3310491551,1),(53343353,425167203,15564211,454632,1,'2007-09-17 22:24:43',3310491551,1),(53343358,425171722,15567354,454632,1,'2007-09-17 22:24:44',3310491551,1),(53343364,425175455,15570891,454632,1,'2007-09-17 22:24:44',3310491551,1),(53343367,425179777,15570694,454632,1,'2007-09-17 22:24:45',3310491594,1),(53343377,425179384,15563818,454632,1,'2007-09-17 22:24:47',3310491594,1),(53343553,425178795,15560478,454632,1,'2007-09-17 22:25:27',3310491594,1),(53344982,425180956,15560281,454632,1,'2007-09-17 22:31:12',3310491594,1),(53350051,425192155,15571480,454632,1,'2007-09-17 22:51:44',3310491594,1),(53351880,425198050,15576392,454632,1,'2007-09-17 22:57:04',3310491594,1),(53352405,425203748,15579929,454632,1,'2007-09-17 22:58:37',3310491594,1),(53352410,425208856,15586216,454632,1,'2007-09-17 22:58:38',3310491595,1),(53352414,425213178,15592110,454632,1,'2007-09-17 22:58:38',3310491595,1),(53352419,425218287,15597022,454632,1,'2007-09-17 22:58:39',3310491595,1),(53352422,425220252,15603113,454632,1,'2007-09-17 22:58:39',3310491617,1),(53352426,425232237,15619224,454632,1,'2007-09-17 22:58:40',3310491617,1),(53352429,425237738,15622368,454632,1,'2007-09-17 22:58:40',3310491620,1),(53352435,425242060,15625511,454632,1,'2007-09-17 22:58:41',3310491620,1),(53352441,425244615,15630030,363778,1,'2007-12-19 18:35:48',3310491620,3),(53352444,425245990,15636711,454632,1,'2007-09-17 22:58:42',3310491620,1),(53352447,425247562,15641426,454632,1,'2007-09-17 22:58:42',3310491620,1),(53352452,425249723,15644766,454632,1,'2007-09-17 22:58:42',3310491620,1),(53352461,425252081,15650857,454632,1,'2007-09-17 22:58:44',3310491620,1),(53352483,425254078,15660320,454632,1,'2007-09-17 22:58:47',3310491622,1),(53352488,425259547,15665593,454632,1,'2007-09-17 22:58:48',3310491622,1),(53352494,425266234,15674158,188228,1,'2008-06-16 19:34:38',3310491623,2),(53352499,425270535,15680596,188228,1,'2008-06-16 19:35:14',3310491623,2),(53352505,425271925,15687205,454632,1,'2007-09-17 22:58:50',3310491623,1),(53352508,425278315,15693899,188228,1,'2008-06-16 19:35:37',3310491623,2),(53352511,425282174,15693899,188228,1,'2008-06-16 19:38:10',3310491623,2),(53352516,425277623,15697029,454632,1,'2007-09-17 22:58:52',3310491623,1),(53352521,425272907,15697225,454632,1,'2007-09-17 22:58:53',3310491623,1),(53352527,425273693,15702923,454632,1,'2007-09-17 22:58:54',3310491623,1),(53352530,425277819,15709014,454632,1,'2007-09-17 22:58:54',3310491623,1),(53352537,425283320,15712943,454632,1,'2007-09-17 22:58:55',3310491629,1),(53352541,425287643,15713533,454632,1,'2007-09-17 22:58:55',3310491640,1),(53352546,425290787,15721785,454632,1,'2007-09-17 22:58:56',3310491640,1),(53352552,425293537,15730233,454632,1,'2007-09-17 22:58:57',3310491640,1),(53352557,425298253,15735735,454632,1,'2007-09-17 22:58:58',3310491640,1),(53352561,425301593,15743004,454632,1,'2007-09-17 22:58:58',3310491640,1),(53352568,425295895,15745951,454632,1,'2007-09-17 22:58:58',3310491640,1),(53352574,425300217,15758722,454632,1,'2007-09-17 22:58:59',3310491640,1),(53352578,425298646,15765795,454632,1,'2007-09-17 22:59:00',3310491642,1),(53352584,425299039,15772869,454632,1,'2007-09-17 22:59:00',3310491642,1),(53352587,425303754,15773065,454632,1,'2007-09-17 22:59:01',3310491642,1),(53352594,425306898,15784068,454632,1,'2007-09-17 22:59:01',3310491642,1),(53352599,425307684,15793106,454632,1,'2007-09-17 22:59:02',3310491642,1),(53352605,425308862,15801554,454632,1,'2007-09-17 22:59:03',3310491642,1),(53352619,425312202,15803912,454632,1,'2007-09-17 22:59:05',3310491642,1),(53352632,425314364,15816486,454632,1,'2007-09-17 22:59:07',3310491642,1),(53352636,425316527,15833582,454632,1,'2007-09-17 22:59:07',3310493009,1),(53352638,425317192,15845098,363778,1,'2007-12-19 18:35:38',3310493009,2),(53352642,425316749,15858164,454632,1,'2007-09-17 22:59:08',3310493009,1),(53352645,425315198,15873445,454632,1,'2007-09-17 22:59:08',3310493009,1),(53352648,425312762,15888062,454632,1,'2007-09-17 22:59:08',3310493010,1),(53352650,425310105,15918181,454632,1,'2007-09-17 22:59:08',3310493010,1),(53352704,425313205,15924825,454632,1,'2007-09-17 22:59:15',3310493010,1),(53352708,425325607,15931026,454632,1,'2007-09-17 22:59:15',3310493017,1),(53352723,425328929,15942763,454632,1,'2007-09-17 22:59:17',3310493017,1),(53352737,425311876,15973989,454632,1,'2007-09-17 22:59:19',3310493016,1),(53352766,425306561,15983291,454632,1,'2007-09-17 22:59:22',3310493016,1),(53352774,425299566,15998522,454632,1,'2007-09-17 22:59:23',3310493018,1),(53352779,425304116,16010548,454632,1,'2007-09-17 22:59:24',3310493018,1),(53352796,425309967,16025825,454632,1,'2007-09-17 22:59:26',3310493018,1),(53352802,425309967,16052477,454632,1,'2007-09-17 22:59:27',3310493040,1),(53352807,425303141,16068729,454632,1,'2007-09-17 22:59:27',3310493040,1),(53352812,425293065,16070679,454632,1,'2007-09-17 22:59:27',3310493040,1),(53352849,425286239,16084006,454632,1,'2007-09-17 22:59:32',3310493029,1),(53352853,425275513,16090506,454632,1,'2007-09-17 22:59:32',3310493029,1),(53352860,425274863,16113259,454632,1,'2007-09-17 22:59:33',3310493031,1),(53352863,425281364,16111309,454632,1,'2007-09-17 22:59:34',3310493031,1),(53352868,425288515,16098957,454632,1,'2007-09-17 22:59:34',3310493042,1),(53352871,425295015,16095382,454632,1,'2007-09-17 22:59:34',3310493042,1),(53352873,425305416,16098632,454632,1,'2007-09-17 22:59:35',3310493042,1),(53352876,425310617,16100582,454632,1,'2007-09-17 22:59:35',3310493042,1),(53352878,425311592,16118459,454632,1,'2007-09-17 22:59:35',3310493042,1),(53352883,425315817,16118784,454632,1,'2007-09-17 22:59:36',3310493043,1),(53352887,425315817,16097332,454632,1,'2007-09-17 22:59:36',3310493043,1),(53352890,425333369,16074255,454632,1,'2007-09-17 22:59:36',3310493041,1),(53352894,425337595,16080430,454632,1,'2007-09-17 22:59:37',3310493041,1),(53352896,425340520,16100582,454632,1,'2007-09-17 22:59:37',3310493043,1),(53352899,425339545,16141212,454632,1,'2007-09-17 22:59:38',3310493043,1),(53352904,425344745,16178591,454632,1,'2007-09-17 22:59:39',3310493052,1),(53352906,425345071,16191917,454632,1,'2007-09-17 22:59:39',3310493052,1),(53352907,425346221,16219056,454632,1,'2007-09-17 22:59:39',3310493054,1),(53352912,425345061,16232970,454632,1,'2007-09-17 22:59:40',3310493054,1),(53352934,425348540,16263117,454632,1,'2007-09-17 22:59:44',3310493140,1),(53352938,425353094,16286460,454632,1,'2007-09-17 22:59:44',3310493140,1),(53352942,425351907,16295721,454632,1,'2007-09-17 22:59:45',3310493140,1),(53352946,425350720,16331103,454632,1,'2007-09-17 22:59:45',3310493142,1),(53352948,425341459,16333240,454632,1,'2007-09-17 22:59:45',3310493139,1),(53352951,425329585,16340364,454632,1,'2007-09-17 22:59:46',3310493139,1),(53352954,425313913,16362685,454632,1,'2007-09-17 22:59:46',3310493138,1),(53352957,425299903,16351999,454632,1,'2007-09-17 22:59:46',3310493138,1),(53352960,425288505,16329678,454632,1,'2007-09-17 22:59:46',3310493138,1),(53352963,425265708,16313531,454632,1,'2007-09-17 22:59:46',3310493125,1),(53352966,425246413,16309632,454632,1,'2007-09-17 22:59:47',3310493124,1),(53352969,425227322,16356241,454632,1,'2007-09-17 22:59:47',3310493123,1),(53352974,425218437,16375849,454632,1,'2007-09-17 22:59:47',3310493129,1),(53352975,425208326,16360530,454632,1,'2007-09-17 22:59:47',3310493123,1),(53353016,425176769,16367271,454632,1,'2007-09-17 22:59:54',3310493079,1),(53353021,425160837,16352871,454632,1,'2007-09-17 22:59:55',3310493079,1),(53353024,425151645,16311815,454632,1,'2007-09-17 22:59:55',3310493077,1),(53353034,425158999,16269841,454632,1,'2007-09-17 22:59:56',3310493077,1),(53353040,425161143,16206114,454632,1,'2007-09-17 22:59:56',3310492991,1),(53353043,425156241,16167509,454632,1,'2007-09-17 22:59:57',3310492989,1),(53353047,425130811,16121859,454632,1,'2007-09-17 22:59:57',3310492982,1),(53353051,425121926,16089382,454632,1,'2007-09-17 22:59:57',3310492977,1),(53353055,425110590,16051084,454632,1,'2007-09-17 22:59:58',3310492977,1),(53353086,425098578,16003700,454632,1,'2007-09-17 23:00:02',3310492955,1),(53353092,425102160,15976523,454632,1,'2007-09-17 23:00:02',3310492953,1),(53353108,425098207,15948852,454632,1,'2007-09-17 23:00:05',3310492953,1),(53353111,425108090,15923651,454632,1,'2007-09-17 23:00:05',3310492947,1),(53353121,425117478,15918710,454632,1,'2007-09-17 23:00:06',3310492947,1),(53353126,425122914,15890544,454632,1,'2007-09-17 23:00:06',3310492950,1),(53353132,425130326,15872261,454632,1,'2007-09-17 23:00:07',3310492948,1),(53353137,425130326,15856943,363778,1,'2007-12-19 18:35:48',3310492948,2),(53353141,425125384,15839648,454632,1,'2007-09-17 23:00:07',3310492948,1),(53353144,425092772,15840142,454632,1,'2007-09-17 23:00:07',3310492944,1),(53353148,425078936,15861884,454632,1,'2007-09-17 23:00:08',3310492944,1),(53353151,425068559,15866331,454632,1,'2007-09-17 23:00:08',3310492944,1),(53353155,425054723,15848543,454632,1,'2007-09-17 23:00:09',3310492933,1),(53353160,425043852,15832236,454632,1,'2007-09-17 23:00:09',3310492933,1),(53353163,425036440,15770470,454632,1,'2007-09-17 23:00:09',3310491566,1),(53353167,425031993,15763058,454632,1,'2007-09-17 23:00:10',3310491564,1),(53353170,425016675,15760587,454632,1,'2007-09-17 23:00:10',3310491564,1),(53353174,424996416,15758116,454632,1,'2007-09-17 23:00:10',3310491561,1),(53353179,424984062,15750704,454632,1,'2007-09-17 23:00:11',3310491560,1),(53353181,424965779,15741316,454632,1,'2007-09-17 23:00:11',3310491560,1),(53353183,424971709,15704256,454632,1,'2007-09-17 23:00:11',3310491554,1),(53353186,424979121,15670161,454632,1,'2007-09-17 23:00:11',3310491554,1),(53353189,424984062,15621241,454632,1,'2007-09-17 23:00:13',3310491552,1),(53353193,424991474,15565899,454632,1,'2007-09-17 23:00:13',3310491531,1),(53353198,425016675,15543663,454632,1,'2007-09-17 23:00:13',3310491532,1),(53353199,425033970,15532792,454632,1,'2007-09-17 23:00:14',3310491532,1),(53353203,425044346,15528839,454632,1,'2007-09-17 23:00:14',3310491533,1),(53353205,425062629,15523403,454632,1,'2007-09-17 23:00:15',3310491533,1),(53353208,425075477,15520438,454632,1,'2007-09-17 23:00:15',3310491544,1),(53353211,425077453,15526368,454632,1,'2007-09-17 23:00:15',3310491544,1),(53353223,425087830,15541686,363778,1,'2007-12-19 18:35:48',3310491544,3),(53353237,425092277,15556016,454632,1,'2007-09-17 23:00:18',3310491546,1),(53353302,425092277,15568369,454632,1,'2007-09-17 23:00:25',3310491546,1),(53353307,425086348,15580723,454632,1,'2007-09-17 23:00:25',3310491546,1),(53353314,425077948,15595052,454632,1,'2007-09-17 23:00:26',3310491546,1),(53353319,425063124,15610865,454632,1,'2007-09-17 23:00:26',3310491557,1),(53353324,425067571,15621241,454632,1,'2007-09-17 23:00:27',3310491568,1),(53353328,425085360,15621241,454632,1,'2007-09-17 23:00:27',3310491568,1),(53353333,425087336,15646442,454632,1,'2007-09-17 23:00:27',3310491568,1),(53353340,425094748,15666702,454632,1,'2007-09-17 23:00:28',3310491570,1),(53353343,425109078,15665713,454632,1,'2007-09-17 23:00:28',3310491571,1),(53353345,425114513,15654348,454632,1,'2007-09-17 23:00:29',3310491569,1),(53353350,425128843,15655831,454632,1,'2007-09-17 23:00:29',3310491574,1),(53353359,425135267,15653360,454632,1,'2007-09-17 23:00:30',3310491572,1),(53353366,425125878,15637054,454632,1,'2007-09-17 23:00:30',3310491572,1),(53353369,425131314,15632607,454632,1,'2007-09-17 23:00:30',3310491572,1),(53353372,425136255,15627171,454632,1,'2007-09-17 23:00:31',3310491572,1),(53353375,425126373,15602959,454632,1,'2007-09-17 23:00:31',3310491572,1),(53353383,425121925,15601970,454632,1,'2007-09-17 23:00:31',3310491569,1),(53353388,425124396,15582699,454632,1,'2007-09-17 23:00:31',3310491550,1),(53353391,425116490,15577264,454632,1,'2007-09-17 23:00:31',3310491547,1),(53353393,425103325,15559987,454632,1,'2007-09-17 23:00:32',3310491547,1),(53353395,425102516,15544403,454632,1,'2007-09-17 23:00:32',3310491545,1),(53353404,425102516,15528818,454632,1,'2007-09-17 23:00:33',3310491545,1),(53353407,425105957,15515257,454632,1,'2007-09-17 23:00:33',3310491545,1),(53353413,425112231,15507769,454632,1,'2007-09-17 23:00:34',3310491545,1),(53353421,425120529,15506352,454632,1,'2007-09-17 23:00:34',3310491545,1),(53353427,425127411,15515865,454632,1,'2007-09-17 23:00:35',3310491548,1),(53353431,425131256,15523961,454632,1,'2007-09-17 23:00:35',3310491548,1),(53353435,425137530,15532259,454632,1,'2007-09-17 23:00:35',3310491548,1),(53368899,425435824,14735647,454632,1,'2007-09-17 23:47:00',3310502049,1),(53368914,425444025,14750192,454632,1,'2007-09-17 23:47:02',3310502049,1),(53368932,425446448,14754531,454632,1,'2007-09-17 23:47:05',3310502049,1),(53368942,425437504,14756563,454632,1,'2007-09-17 23:47:06',3310502049,1),(53368953,425437462,14751597,454632,1,'2007-09-17 23:47:08',3310502049,1),(53368973,425417580,14712082,538211,1,'2007-09-30 15:36:23',3310502026,1),(53368998,425421094,14712082,454632,1,'2007-09-17 23:47:14',3310502026,1),(53369007,425422832,14712203,454632,1,'2007-09-17 23:47:15',3310502026,1),(53369015,425424286,14712970,454632,1,'2007-09-17 23:47:16',3310502026,1),(53369038,425425255,14714101,454632,1,'2007-09-17 23:47:21',3310502027,1),(53370808,425425942,14715596,454632,1,'2007-09-17 23:53:19',3310502027,1),(53370819,425426871,14716727,454632,1,'2007-09-17 23:53:20',3310502027,1),(53370838,425428730,14717980,454632,1,'2007-09-17 23:53:23',3310502027,1),(53370844,425430507,14719636,454632,1,'2007-09-17 23:53:24',3310502027,1),(53370871,425431800,14720888,454632,1,'2007-09-17 23:53:29',3310502027,1),(53370880,425432204,14721696,454632,1,'2007-09-17 23:53:32',3310502027,1),(53370887,425432163,14722585,454632,1,'2007-09-17 23:53:33',3310502049,1),(53370890,425431881,14723191,454632,1,'2007-09-17 23:53:34',3310502049,1),(53370895,425431194,14723514,454632,1,'2007-09-17 23:53:35',3310502049,1),(53370900,425430103,14723635,454632,1,'2007-09-17 23:53:36',3310502049,1),(53370906,425429255,14723555,454632,1,'2007-09-17 23:53:37',3310502049,1),(53370914,425428770,14724080,454632,1,'2007-09-17 23:53:38',3310502049,1),(53370920,425428730,14725251,454632,1,'2007-09-17 23:53:38',3310502049,1),(53370935,425429134,14726423,454632,1,'2007-09-17 23:53:44',3310502049,1),(53370942,425430386,14727110,454632,1,'2007-09-17 23:53:46',3310502049,1),(53370949,425432083,14727514,454632,1,'2007-09-17 23:53:48',3310502049,1),(53370956,425434628,14728200,454632,1,'2007-09-17 23:53:49',3310502049,1),(53370959,425435638,14728766,454632,1,'2007-09-17 23:53:50',3310502049,1),(53371037,425437254,14730139,454632,1,'2007-09-17 23:54:06',3310502049,1),(53371050,425438587,14731876,454632,1,'2007-09-17 23:54:08',3310502049,1),(53371067,425440930,14737007,454632,1,'2007-09-17 23:54:11',3310502049,1),(53371073,425443192,14741047,454632,1,'2007-09-17 23:54:12',3310502049,1),(53371079,425445091,14744521,454632,1,'2007-09-17 23:54:12',3310502049,1),(53371084,425445899,14746258,454632,1,'2007-09-17 23:54:13',3310502049,1),(53371089,425446262,14746824,454632,1,'2007-09-17 23:54:13',3310502049,1),(53371093,425446747,14746904,454632,1,'2007-09-17 23:54:14',3310502049,1),(53371101,425447232,14746662,454632,1,'2007-09-17 23:54:15',3310502049,1),(53371106,425447515,14745733,454632,1,'2007-09-17 23:54:16',3310502049,1),(53371115,425447515,14744521,454632,1,'2007-09-17 23:54:18',3310502049,1),(53371121,425447757,14743349,454632,1,'2007-09-17 23:54:19',3310502049,1),(53371129,425448220,14742921,454632,1,'2007-09-17 23:54:20',3310502049,1),(53371134,425416509,14695680,454632,1,'2007-09-17 23:54:21',3310502026,1),(53371138,425415521,14694857,454632,1,'2007-09-17 23:54:21',3310502026,1),(53371141,425413998,14694527,454632,1,'2007-09-17 23:54:22',3310502026,1),(53371144,425412762,14695227,454632,1,'2007-09-17 23:54:23',3310502026,1),(53371154,425411815,14696956,454632,1,'2007-09-17 23:54:25',3310502026,1),(53371160,425411074,14699880,454632,1,'2007-09-17 23:54:26',3310502026,1),(53371174,425410498,14702103,454632,1,'2007-09-17 23:54:28',3310502026,1),(53371181,425409963,14703297,454632,1,'2007-09-17 23:54:29',3310502026,1),(53371551,425408398,14704450,454632,1,'2007-09-17 23:55:56',3310502026,1),(53371691,425406463,14705150,454632,1,'2007-09-17 23:56:31',3310502026,1),(53371748,425404939,14705356,454632,1,'2007-09-17 23:56:40',3310502026,1),(53371756,425401192,14706509,454632,1,'2007-09-17 23:56:42',3310502026,1),(53371761,425400451,14707209,454632,1,'2007-09-17 23:56:42',3310502026,1),(53371763,425400081,14708856,454632,1,'2007-09-17 23:56:43',3310502026,1),(53371771,425400369,14710667,454632,1,'2007-09-17 23:56:44',3310502026,1),(53371778,425401069,14712397,454632,1,'2007-09-17 23:56:45',3310502026,1),(53371784,425403499,14715348,454632,1,'2007-09-17 23:56:45',3310502026,1),(53371787,425406279,14718810,454632,1,'2007-09-17 23:56:46',3310502026,1),(53371793,425408745,14723216,454632,1,'2007-09-17 23:56:47',3310502048,1),(53371799,425410948,14728620,454632,1,'2007-09-17 23:56:48',3310502048,1),(53371804,425392903,14703912,454632,1,'2007-09-17 23:56:49',3310491103,1),(53371810,425392064,14703965,454632,1,'2007-09-17 23:56:50',3310491103,1),(53371816,425392064,14704962,454632,1,'2007-09-17 23:56:50',3310491103,1),(53371823,425392168,14706483,454632,1,'2007-09-17 23:56:51',3310491103,1),(53371827,425393218,14707165,454632,1,'2007-09-17 23:56:52',3310491103,1),(53371833,425394791,14707532,454632,1,'2007-09-17 23:56:52',3310491103,1),(53371840,425396994,14707479,454632,1,'2007-09-17 23:56:53',3310491103,1),(53371845,425398883,14707060,454632,1,'2007-09-17 23:56:54',3310502026,1),(53371850,425400562,14705591,454632,1,'2007-09-17 23:56:54',3310502026,1),(53371856,425401663,14705591,454632,1,'2007-09-17 23:56:55',3310502026,1),(53371859,425403079,14705591,454632,1,'2007-09-17 23:56:56',3310502026,1),(53371862,425412944,14733781,454632,1,'2007-09-17 23:56:56',3310502048,1),(53371868,425414557,14740102,454632,1,'2007-09-17 23:56:57',3310502048,1),(53371873,425415211,14745857,454632,1,'2007-09-17 23:56:58',3310502048,1),(53371881,425415036,14751219,454632,1,'2007-09-17 23:56:59',3310502048,1),(53371890,425414739,14753687,454632,1,'2007-09-17 23:57:00',3310502048,1),(53371908,425414045,14756811,454632,1,'2007-09-17 23:57:05',3310502048,1),(53371942,425412483,14760543,454632,1,'2007-09-17 23:57:12',3310502048,1),(53371951,425409272,14766097,454632,1,'2007-09-17 23:57:14',3310502048,1),(53371955,425406235,14771227,454632,1,'2007-09-17 23:57:14',3310502048,1),(53371958,425403791,14775715,454632,1,'2007-09-17 23:57:15',3310502048,1),(53371963,425402902,14777048,454632,1,'2007-09-17 23:57:15',3310502050,1),(53371969,425401925,14778203,454632,1,'2007-09-17 23:57:16',3310502050,1),(53371993,425400414,14778869,454632,1,'2007-09-17 23:57:20',3310502050,1),(53371998,425397748,14778780,454632,1,'2007-09-17 23:57:20',3310502050,1),(53372005,425395527,14779002,454632,1,'2007-09-17 23:57:21',3310491127,1),(53372015,425393616,14780202,454632,1,'2007-09-17 23:57:22',3310491127,1),(53372021,425391617,14782557,454632,1,'2007-09-17 23:57:23',3310491127,1),(53372044,425390239,14784023,454632,1,'2007-09-17 23:57:26',3310491127,1),(53372056,425389040,14784556,454632,1,'2007-09-17 23:57:28',3310491127,1),(53372063,425386818,14784423,454632,1,'2007-09-17 23:57:29',3310491127,1),(53372072,425384997,14784423,454632,1,'2007-09-17 23:57:31',3310491127,1),(53372078,425383308,14785178,454632,1,'2007-09-17 23:57:32',3310491127,1),(53372086,425381309,14787844,454632,1,'2007-09-17 23:57:33',3310491127,1),(53372094,425379823,14790608,454632,1,'2007-09-17 23:57:34',3310491127,1),(53372108,425377525,14794423,454632,1,'2007-09-17 23:57:35',3310491127,1),(53372121,425375617,14797284,454632,1,'2007-09-17 23:57:36',3310491127,1),(53372132,425373927,14800189,454632,1,'2007-09-17 23:57:38',3310491127,1),(53372138,425372713,14803224,454632,1,'2007-09-17 23:57:39',3310491127,1),(53372143,425370979,14810204,454632,1,'2007-09-17 23:57:39',3310491127,1),(53372151,425370328,14814279,454632,1,'2007-09-17 23:57:40',3310491127,1),(53372163,425370849,14818918,454632,1,'2007-09-17 23:57:42',3310491127,1),(53372180,425372323,14823427,454632,1,'2007-09-17 23:57:45',3310491127,1),(53372190,425372496,14824164,454632,1,'2007-09-17 23:57:46',3310491127,1),(53372197,425372106,14825378,454632,1,'2007-09-17 23:57:47',3310491127,1),(53372208,425370458,14825248,454632,1,'2007-09-17 23:57:48',3310491127,1),(53372217,425369938,14823991,454632,1,'2007-09-17 23:57:49',3310491127,1),(53372225,425369201,14821129,454632,1,'2007-09-17 23:57:50',3310491126,1),(53372232,425368161,14816057,454632,1,'2007-09-17 23:57:51',3310491126,1),(53372242,425367510,14807343,454632,1,'2007-09-17 23:57:52',3310491126,1),(53372246,425366990,14801316,454632,1,'2007-09-17 23:57:52',3310491126,1),(53372255,425367857,14794076,454632,1,'2007-09-17 23:57:53',3310491126,1),(53372261,425369461,14785839,454632,1,'2007-09-17 23:57:54',3310491126,1),(53372271,425370198,14779162,454632,1,'2007-09-17 23:57:55',3310491127,1),(53372278,425371586,14775000,454632,1,'2007-09-17 23:57:55',3310491125,1),(53372284,425373710,14771272,454632,1,'2007-09-17 23:57:56',3310491125,1),(53372290,425376831,14767890,454632,1,'2007-09-17 23:57:56',3310491125,1),(53372297,425379910,14765809,454632,1,'2007-09-17 23:57:58',3310491125,1),(53372305,425382889,14765031,454632,1,'2007-09-17 23:57:58',3310491125,1),(53372352,425385356,14764777,454632,1,'2007-09-17 23:58:04',3310491125,1),(53372357,425387478,14764132,454632,1,'2007-09-17 23:58:05',3310491125,1),(53372365,425389807,14763094,454632,1,'2007-09-17 23:58:06',3310491125,1),(53372381,425391859,14761734,454632,1,'2007-09-17 23:58:08',3310491125,1),(53372404,425393634,14759497,454632,1,'2007-09-17 23:58:11',3310491125,1),(53372410,425394534,14756914,454632,1,'2007-09-17 23:58:12',3310491125,1),(53372412,425394718,14753179,454632,1,'2007-09-17 23:58:12',3310491125,1),(53372413,425394026,14750620,454632,1,'2007-09-17 23:58:13',3310491125,1),(53372418,425393035,14748198,454632,1,'2007-09-17 23:58:13',3310491125,1),(53372422,425391190,14746238,454632,1,'2007-09-17 23:58:13',3310491125,1),(53372427,425386602,14742641,454632,1,'2007-09-17 23:58:14',3310491125,1),(53372432,425379419,14737400,454632,1,'2007-09-17 23:58:15',3310491125,1),(53372437,425374912,14733866,454632,1,'2007-09-17 23:58:15',3310491125,1),(53372442,425370038,14729115,454632,1,'2007-09-17 23:58:15',3310491125,1),(53372446,425365937,14725663,454632,1,'2007-09-17 23:58:15',3310491124,1),(53372456,425362647,14723348,454632,1,'2007-09-17 23:58:17',3310491124,1),(53372458,425359845,14722089,454632,1,'2007-09-17 23:58:17',3310491124,1),(53372462,425356637,14720871,454632,1,'2007-09-17 23:58:17',3310491102,1),(53372466,425354078,14718597,454632,1,'2007-09-17 23:58:17',3310491102,1),(53372476,425350992,14713520,454632,1,'2007-09-17 23:58:18',3310491102,1),(53372487,425348628,14709630,454632,1,'2007-09-17 23:58:19',3310491102,1),(53372493,425345212,14703495,454632,1,'2007-09-17 23:58:19',3310491102,1),(53372501,425343161,14698240,454632,1,'2007-09-17 23:58:20',3310491102,1),(53372509,425341068,14690421,454632,1,'2007-09-17 23:58:21',3310491099,1),(53372513,425338846,14679484,454632,1,'2007-09-17 23:58:21',3310491099,1),(53372518,425336240,14666753,454632,1,'2007-09-17 23:58:22',3310491097,1),(53372522,425335932,14663343,454632,1,'2007-09-17 23:58:22',3310491097,1),(53372527,425336534,14661112,454632,1,'2007-09-17 23:58:23',3310491097,1),(53372535,425338127,14659094,454632,1,'2007-09-17 23:58:23',3310491097,1),(53372541,425340854,14656438,454632,1,'2007-09-17 23:58:24',3310491097,1),(53372544,425343155,14653783,454632,1,'2007-09-17 23:58:24',3310491100,1),(53372549,425344713,14651127,454632,1,'2007-09-17 23:58:24',3310491100,1),(53372555,425346059,14647905,454632,1,'2007-09-17 23:58:25',3310491100,1),(53372562,425347085,14644931,454632,1,'2007-09-17 23:58:26',3310491100,1),(53372568,425348077,14643054,454632,1,'2007-09-17 23:58:27',3310491100,1),(53372577,425349564,14642063,454632,1,'2007-09-17 23:58:28',3310491100,1),(53372587,425351582,14641744,454632,1,'2007-09-17 23:58:29',3310491100,1),(53372608,425352644,14642063,454632,1,'2007-09-17 23:58:31',3310491100,1),(53372614,425355796,14644258,454632,1,'2007-09-17 23:58:31',3310491100,1),(53372629,425359867,14646666,454632,1,'2007-09-17 23:58:33',3310491100,1),(53372637,425362629,14648649,454632,1,'2007-09-17 23:58:34',3310491100,1),(53372777,425364364,14649782,454632,1,'2007-09-17 23:58:52',3310491100,1),(53372794,425365780,14650171,454632,1,'2007-09-17 23:58:55',3310491100,1),(53372806,425367055,14649888,454632,1,'2007-09-17 23:58:55',3310491100,1),(53372815,425368578,14648790,454632,1,'2007-09-17 23:58:56',3310491100,1),(53372828,425369640,14647091,454632,1,'2007-09-17 23:58:57',3310491100,1),(53372832,425370313,14644789,454632,1,'2007-09-17 23:58:58',3310491101,1),(53372838,425370525,14641957,454632,1,'2007-09-17 23:58:58',3310491101,1),(53372843,425370171,14637318,454632,1,'2007-09-17 23:58:59',3310491101,1),(53372852,425369215,14632432,454632,1,'2007-09-17 23:59:00',3310491100,1),(53372858,425367947,14625506,454632,1,'2007-09-17 23:59:00',3310491100,1),(53372863,425367016,14620709,454632,1,'2007-09-17 23:59:01',3310491100,1),(53372873,425366146,14617690,454632,1,'2007-09-17 23:59:02',3310491100,1),(53372879,425364650,14613666,454632,1,'2007-09-17 23:59:02',3310491100,1),(53372887,425363753,14610620,454632,1,'2007-09-17 23:59:03',3310491094,1),(53372892,425363399,14608880,454632,1,'2007-09-17 23:59:04',3310491094,1),(53372903,425363263,14607058,454632,1,'2007-09-17 23:59:05',3310491094,1),(53372912,425363726,14605209,454632,1,'2007-09-17 23:59:06',3310491094,1),(53372917,425365439,14602027,454632,1,'2007-09-17 23:59:07',3310491094,1),(53372927,425367995,14597812,454632,1,'2007-09-17 23:59:08',3310491094,1),(53372935,425370769,14593217,454632,1,'2007-09-17 23:59:09',3310491095,1),(53372942,425372237,14590905,454632,1,'2007-09-17 23:59:10',3310491095,1),(53372956,425373134,14590089,454632,1,'2007-09-17 23:59:12',3310491095,1),(53372965,425375092,14589246,454632,1,'2007-09-17 23:59:13',3310491095,1),(53372978,425377295,14588376,454632,1,'2007-09-17 23:59:17',3310491095,1),(53372982,425379525,14586690,454632,1,'2007-09-17 23:59:17',3310491095,1),(53372991,425382353,14583944,454632,1,'2007-09-17 23:59:18',3310491095,1),(53373005,425385181,14581877,454632,1,'2007-09-17 23:59:19',3310491095,1),(53373016,425386595,14581224,454632,1,'2007-09-17 23:59:21',3310491095,1),(53373029,425389613,14580681,454632,1,'2007-09-17 23:59:22',3310491095,1),(53373035,425394021,14580425,454632,1,'2007-09-17 23:59:23',3310491095,1),(53373049,425397450,14580317,454632,1,'2007-09-17 23:59:24',3310502018,1),(53373068,425399723,14580533,454632,1,'2007-09-17 23:59:26',3310502018,1),(53373079,425402105,14581327,454632,1,'2007-09-17 23:59:27',3310502018,1),(53373094,425404342,14582302,454632,1,'2007-09-17 23:59:28',3310502018,1),(53373107,425405461,14582590,454632,1,'2007-09-17 23:59:30',3310502018,1),(53373114,425406544,14582266,454632,1,'2007-09-17 23:59:31',3310502018,1),(53373121,425408023,14581291,454632,1,'2007-09-17 23:59:32',3310502018,1),(53373130,425409431,14578909,454632,1,'2007-09-17 23:59:34',3310502018,1),(53373163,425411560,14575589,454632,1,'2007-09-17 23:59:37',3310502018,1),(53373182,425413545,14572305,454632,1,'2007-09-17 23:59:39',3310502018,1),(53373197,425415133,14569887,454632,1,'2007-09-17 23:59:40',3310502018,1),(53373203,425417117,14568372,454632,1,'2007-09-17 23:59:40',3310502018,1),(53373215,425419211,14567614,454632,1,'2007-09-17 23:59:41',3310502018,1),(53373224,425421087,14566928,454632,1,'2007-09-17 23:59:42',3310502018,1),(53373230,425423252,14565088,454632,1,'2007-09-17 23:59:42',3310502018,1),(53373233,425426951,14562456,454632,1,'2007-09-17 23:59:43',3310502019,1),(53373241,425430303,14559762,454632,1,'2007-09-17 23:59:43',3310502019,1),(53373246,425432758,14556888,454632,1,'2007-09-17 23:59:44',3310502017,1),(53373251,425437368,14550243,454632,1,'2007-09-17 23:59:44',3310502017,1),(53373259,425440002,14546592,454632,1,'2007-09-17 23:59:45',3310502017,1),(53373266,425442528,14542760,454632,1,'2007-09-17 23:59:45',3310502017,1),(53373270,425444252,14539312,454632,1,'2007-09-17 23:59:46',3310502017,1),(53373275,425445545,14536630,454632,1,'2007-09-17 23:59:46',3310502017,1),(53373280,425447413,14534523,454632,1,'2007-09-17 23:59:48',3310502017,1),(53373289,425449951,14532847,454632,1,'2007-09-17 23:59:48',3310502017,1),(53373297,425457557,14529667,454632,1,'2007-09-17 23:59:49',3310502020,1),(53373303,425461373,14527965,454632,1,'2007-09-17 23:59:50',3310502020,1),(53373308,425465419,14527414,454632,1,'2007-09-17 23:59:51',3310502020,1),(53373311,425477648,14526540,454632,1,'2007-09-17 23:59:51',3310502020,1),(53373318,425480453,14526678,454632,1,'2007-09-17 23:59:52',3310502021,1),(53373327,425482752,14527460,454632,1,'2007-09-17 23:59:53',3310502021,1),(53373335,425487763,14529667,454632,1,'2007-09-17 23:59:54',3310502021,1),(53373343,425490154,14531092,454632,1,'2007-09-17 23:59:55',3310502021,1),(53373348,425492085,14532103,454632,1,'2007-09-17 23:59:55',3310502021,1),(53373356,425494660,14533575,454632,1,'2007-09-17 23:59:56',3310502021,1),(53373365,425496729,14533804,454632,1,'2007-09-17 23:59:58',3310502021,1),(53373376,425499671,14534126,454632,1,'2007-09-18 00:00:02',3310502021,1),(53373382,425502798,14535506,454632,1,'2007-09-18 00:00:03',3310502021,1),(53373386,425505510,14537437,454632,1,'2007-09-18 00:00:04',3310502021,1),(53373392,425508729,14539414,454632,1,'2007-09-18 00:00:05',3310502032,1),(53373399,425510568,14540103,454632,1,'2007-09-18 00:00:06',3310502032,1),(53373402,425511918,14540251,454632,1,'2007-09-18 00:00:07',3310502032,1),(53373406,425513828,14541325,454632,1,'2007-09-18 00:00:07',3310502032,1),(53373410,425515739,14542639,454632,1,'2007-09-18 00:00:07',3310502032,1),(53373416,425517649,14542758,454632,1,'2007-09-18 00:00:07',3310502032,1),(53373457,425519798,14542579,454632,1,'2007-09-18 00:00:12',3310502032,1),(53373463,425521888,14540907,454632,1,'2007-09-18 00:00:13',3310502032,1),(53373467,425525171,14538878,454632,1,'2007-09-18 00:00:14',3310502032,1),(53373472,425527560,14536728,454632,1,'2007-09-18 00:00:14',3310502032,1),(53373475,425529768,14533206,454632,1,'2007-09-18 00:00:14',3310502032,1),(53373479,425531321,14530161,454632,1,'2007-09-18 00:00:15',3310502032,1),(53373480,425533709,14526281,454632,1,'2007-09-18 00:00:15',3310502032,1),(53373484,425535380,14522818,454632,1,'2007-09-18 00:00:16',3310502033,1),(53373499,425536216,14520848,454632,1,'2007-09-18 00:00:18',3310502033,1),(53373501,425536694,14518639,454632,1,'2007-09-18 00:00:18',3310502033,1),(53373507,425537171,14514699,454632,1,'2007-09-18 00:00:19',3310502033,1),(53373512,425537291,14512371,454632,1,'2007-09-18 00:00:19',3310502033,1),(53373516,425536933,14510221,454632,1,'2007-09-18 00:00:19',3310502033,1),(53373521,425535977,14507535,454632,1,'2007-09-18 00:00:19',3310502033,1),(53373529,425535112,14504937,454632,1,'2007-09-18 00:00:20',3310502033,1),(53373532,425534727,14502902,454632,1,'2007-09-18 00:00:20',3310502033,1),(53373536,425534476,14501388,454632,1,'2007-09-18 00:00:20',3310501947,1),(53373543,425534406,14499733,454632,1,'2007-09-18 00:00:21',3310501946,1),(53373545,425534476,14497549,454632,1,'2007-09-18 00:00:22',3310501947,1),(53373549,425534723,14494908,454632,1,'2007-09-18 00:00:22',3310501947,1),(53374387,425534828,14492056,454632,1,'2007-09-18 00:02:54',3310501947,1),(53374403,425534582,14489274,454632,1,'2007-09-18 00:02:56',3310501947,1),(53374521,425533561,14485366,454632,1,'2007-09-18 00:03:18',3310501946,1),(53374531,425532702,14482999,454632,1,'2007-09-18 00:03:19',3310501946,1),(53374534,425531456,14480273,454632,1,'2007-09-18 00:03:19',3310501946,1),(53374537,425530677,14477898,454632,1,'2007-09-18 00:03:20',3310501946,1),(53374542,425530288,14475094,454632,1,'2007-09-18 00:03:20',3310501946,1),(53374635,425530794,14472368,454632,1,'2007-09-18 00:03:39',3310501946,1),(53374797,425531846,14470771,454632,1,'2007-09-18 00:04:17',3310501946,1),(53374856,425534104,14469292,454632,1,'2007-09-18 00:04:29',3310501946,1),(53374862,425536051,14468279,454632,1,'2007-09-18 00:04:29',3310501947,1),(53374867,425538115,14467734,454632,1,'2007-09-18 00:04:31',3310501947,1),(53374883,425539362,14467851,454632,1,'2007-09-18 00:04:33',3310501947,1),(53374887,425541114,14468318,454632,1,'2007-09-18 00:04:33',3310501947,1),(53374892,425542828,14468902,454632,1,'2007-09-18 00:04:34',3310501947,1),(53374894,425544463,14469525,454632,1,'2007-09-18 00:04:34',3310501947,1),(53374897,425545748,14469798,454632,1,'2007-09-18 00:04:35',3310501947,1),(53374901,425547462,14469681,454632,1,'2007-09-18 00:04:37',3310501947,1),(53374925,425548825,14469876,454632,1,'2007-09-18 00:04:42',3310501947,1),(53374929,425550227,14470810,454632,1,'2007-09-18 00:04:43',3310501947,1),(53375001,425553654,14472952,454632,1,'2007-09-18 00:04:59',3310501947,1),(53375004,425557470,14475250,454632,1,'2007-09-18 00:05:00',3310501947,1),(53375007,425559690,14476613,454632,1,'2007-09-18 00:05:00',3310501947,1),(53375010,425561325,14477431,454632,1,'2007-09-18 00:05:01',3310501947,1),(53375014,425562922,14477898,454632,1,'2007-09-18 00:05:01',3310501950,1),(53375016,425564519,14478210,454632,1,'2007-09-18 00:05:02',3310501950,1),(53375019,425566660,14477937,454632,1,'2007-09-18 00:05:02',3310501950,1),(53375022,425568530,14477625,454632,1,'2007-09-18 00:05:03',3310501950,1),(53375026,425570438,14477119,454632,1,'2007-09-18 00:05:03',3310501950,1),(53375056,425572034,14475873,454632,1,'2007-09-18 00:05:09',3310501950,1),(53375086,425573670,14474276,454632,1,'2007-09-18 00:05:14',3310501950,1),(53375126,425576201,14472563,454632,1,'2007-09-18 00:05:21',3310501950,1),(53375501,425577837,14471472,454632,1,'2007-09-18 00:06:48',3310501950,1),(53376238,425579511,14469798,454632,1,'2007-09-18 00:08:28',3310501950,1),(53376244,425581342,14467500,454632,1,'2007-09-18 00:08:28',3310501950,1),(53376247,425582783,14465748,454632,1,'2007-09-18 00:08:29',3310501950,1),(53376253,425583912,14464385,454632,1,'2007-09-18 00:08:30',3310501950,1),(53376257,425584613,14462555,454632,1,'2007-09-18 00:08:31',3310501950,1),(53376264,425585392,14460685,454632,1,'2007-09-18 00:08:31',3310501950,1),(53376267,425586755,14460023,454632,1,'2007-09-18 00:08:32',3310501950,1),(53376272,425588235,14459790,454632,1,'2007-09-18 00:08:32',3310501950,1),(53376275,425590065,14460218,454632,1,'2007-09-18 00:08:33',3310501951,1),(53376314,425593297,14460763,454632,1,'2007-09-18 00:08:39',3310501951,1),(53376323,425597075,14460919,454632,1,'2007-09-18 00:08:41',3310501951,1),(53376331,425599255,14460880,454632,1,'2007-09-18 00:08:42',3310501951,1),(53376354,425600657,14460335,454632,1,'2007-09-18 00:08:44',3310501951,1),(53376363,425601280,14458582,454632,1,'2007-09-18 00:08:45',3310501951,1),(53376376,425601164,14456713,454632,1,'2007-09-18 00:08:46',3310501951,1),(53376378,425601047,14454571,454632,1,'2007-09-18 00:08:46',3310501951,1),(53376383,425601514,14451806,454632,1,'2007-09-18 00:08:47',3310501951,1),(53376386,425601670,14449158,454632,1,'2007-09-18 00:08:47',3310501951,1),(53376390,425601436,14446978,454632,1,'2007-09-18 00:08:48',3310501949,1),(53376392,425601241,14445342,454632,1,'2007-09-18 00:08:48',3310501949,1);
INSERT INTO `nodes` VALUES (53376394,425600852,14442499,454632,1,'2007-09-18 00:08:49',3310501949,1),(53376397,425600268,14441019,454632,1,'2007-09-18 00:08:49',3310501949,1),(53376399,425599489,14438332,454632,1,'2007-09-18 00:08:49',3310501949,1),(53376401,425599917,14435918,454632,1,'2007-09-18 00:08:50',3310501949,1),(53376405,425600385,14433387,454632,1,'2007-09-18 00:08:50',3310501949,1),(53376408,425600891,14430700,454632,1,'2007-09-18 00:08:51',3310501949,1),(53376414,425600930,14427389,454632,1,'2007-09-18 00:08:51',3310501949,1),(53376419,425601226,14422163,454632,1,'2007-09-18 00:08:52',3310501949,1),(53376421,425601179,14418845,454632,1,'2007-09-18 00:08:52',3310501949,1),(53376423,425600805,14417584,454632,1,'2007-09-18 00:08:53',3310501949,1),(53376428,425600525,14416415,454632,1,'2007-09-18 00:08:53',3310501949,1),(53376431,425600338,14414359,454632,1,'2007-09-18 00:08:53',3310501949,1),(53376435,425600104,14412396,454632,1,'2007-09-18 00:08:54',3310501949,1),(53376437,425600104,14410107,454632,1,'2007-09-18 00:08:54',3310501949,1),(53376438,425600338,14407443,454632,1,'2007-09-18 00:08:54',3310501949,1),(53376440,425600151,14405807,454632,1,'2007-09-18 00:08:54',3310501949,1),(53376442,425599357,14404779,454632,1,'2007-09-18 00:08:54',3310501949,1),(53376444,425597861,14403611,454632,1,'2007-09-18 00:08:55',3310501949,1),(53376448,425595571,14402209,454632,1,'2007-09-18 00:08:55',3310501949,1),(53376451,425592627,14400573,454632,1,'2007-09-18 00:08:55',3310501949,1),(53376626,425590805,14399732,454632,1,'2007-09-18 00:09:15',3310501949,1),(53376629,425589309,14398891,454632,1,'2007-09-18 00:09:16',3310501948,1),(53376632,425588375,14397910,454632,1,'2007-09-18 00:09:16',3310501948,1),(53376634,425588001,14396601,454632,1,'2007-09-18 00:09:16',3310501948,1),(53376637,425588048,14394452,454632,1,'2007-09-18 00:09:16',3310501948,1),(53376658,425588655,14391414,454632,1,'2007-09-18 00:09:19',3310501942,1),(53376660,425589403,14387816,454632,1,'2007-09-18 00:09:19',3310501943,1),(53376663,425589496,14385993,454632,1,'2007-09-18 00:09:19',3310501943,1),(53376664,425588468,14383563,454632,1,'2007-09-18 00:09:19',3310501942,1),(53376666,425587300,14380666,454632,1,'2007-09-18 00:09:19',3310501942,1),(53376670,425584870,14378376,454632,1,'2007-09-18 00:09:20',3310501942,1),(53376674,425582632,14376263,454632,1,'2007-09-18 00:09:20',3310501942,1),(53376677,425581281,14375201,454632,1,'2007-09-18 00:09:20',3310501942,1),(53376682,425580413,14373947,454632,1,'2007-09-18 00:09:21',3310501942,1),(53376683,425580316,14372693,454632,1,'2007-09-18 00:09:21',3310501942,1),(53376686,425580461,14370957,454632,1,'2007-09-18 00:09:21',3310501942,1),(53376689,425582583,14365795,454632,1,'2007-09-18 00:09:22',3310501942,1),(53376692,425583162,14363335,454632,1,'2007-09-18 00:09:22',3310501942,1),(53376695,425583452,14361599,454632,1,'2007-09-18 00:09:22',3310501942,1),(53376699,425583210,14359911,454632,1,'2007-09-18 00:09:23',3310501942,1),(53376702,425582439,14358367,454632,1,'2007-09-18 00:09:23',3310501942,1),(53376704,425580895,14356004,454632,1,'2007-09-18 00:09:23',3310501942,1),(53376709,425580027,14354267,454632,1,'2007-09-18 00:09:24',3310501942,1),(53376715,425579255,14351855,454632,1,'2007-09-18 00:09:25',3310501942,1),(53376719,425579207,14347225,454632,1,'2007-09-18 00:09:25',3310501942,1),(53376723,425579207,14345102,454632,1,'2007-09-18 00:09:25',3310501942,1),(53376729,425578869,14343655,454632,1,'2007-09-18 00:09:25',3310501942,1),(53376733,425578242,14342787,454632,1,'2007-09-18 00:09:26',3310501942,1),(53376737,425577875,14341461,454632,1,'2007-09-18 00:09:26',3310501942,1),(53376740,425576924,14338642,454632,1,'2007-09-18 00:09:26',3310501942,1),(53376743,425576301,14335168,454632,1,'2007-09-18 00:09:26',3310501940,1),(53376746,425576072,14333333,454632,1,'2007-09-18 00:09:26',3310501940,1),(53376748,425575023,14331956,454632,1,'2007-09-18 00:09:27',3310501940,1),(53376750,425572860,14330678,454632,1,'2007-09-18 00:09:27',3310501940,1),(53376751,425569058,14328613,454632,1,'2007-09-18 00:09:27',3310501940,1),(53376753,425567092,14326974,454632,1,'2007-09-18 00:09:27',3310501940,1),(53376754,425565191,14326221,454632,1,'2007-09-18 00:09:28',3310501940,1),(53376756,425561749,14325401,454632,1,'2007-09-18 00:09:28',3310501937,1),(53376757,425558701,14325172,454632,1,'2007-09-18 00:09:28',3310501937,1),(53376761,425555522,14325172,454632,1,'2007-09-18 00:09:28',3310501937,1),(53376764,425552146,14325237,454632,1,'2007-09-18 00:09:28',3310501937,1),(53376766,425550671,14324942,454632,1,'2007-09-18 00:09:28',3310501937,1),(53376768,425548738,14324615,454632,1,'2007-09-18 00:09:28',3310501937,1),(53376771,425547099,14323762,454632,1,'2007-09-18 00:09:29',3310501937,1),(53376772,425545460,14322583,454632,1,'2007-09-18 00:09:29',3310501937,1),(53376775,425544477,14321730,454632,1,'2007-09-18 00:09:29',3310501937,1),(53376777,425543428,14319567,454632,1,'2007-09-18 00:09:29',3310501937,1),(53376780,425542904,14316945,454632,1,'2007-09-18 00:09:29',3310501937,1),(53376782,425542707,14313602,454632,1,'2007-09-18 00:09:30',3310501937,1),(53376784,425542543,14309276,454632,1,'2007-09-18 00:09:30',3310501937,1),(53376788,425542707,14305310,454632,1,'2007-09-18 00:09:30',3310501937,1),(53376797,425543559,14301082,454632,1,'2007-09-18 00:09:31',3310501937,1),(53376799,425544706,14297280,454632,1,'2007-09-18 00:09:31',3310501937,1),(53376802,425545738,14294435,454632,1,'2007-09-18 00:09:31',3310501937,1),(53376806,425546260,14291740,454632,1,'2007-09-18 00:09:32',3310501937,1),(53376810,425546608,14289198,454632,1,'2007-09-18 00:09:32',3310501937,1),(53376814,425547095,14285412,454632,1,'2007-09-18 00:09:32',3310501937,1),(53376816,425546914,14282574,454632,1,'2007-09-18 00:09:32',3310501937,1),(53376820,425545923,14279555,454632,1,'2007-09-18 00:09:32',3310501915,1),(53376827,425544301,14273922,454632,1,'2007-09-18 00:09:33',3310501915,1),(53376830,425541417,14264144,454632,1,'2007-09-18 00:09:33',3310501915,1),(53376834,425540696,14260585,454632,1,'2007-09-18 00:09:34',3310501915,1),(53376837,425538894,14253826,454632,1,'2007-09-18 00:09:34',3310501915,1),(53376840,425537767,14250537,454632,1,'2007-09-18 00:09:34',3310501915,1),(53376847,425535379,14247292,454632,1,'2007-09-18 00:09:35',3310501915,1),(53376853,425531594,14244679,454632,1,'2007-09-18 00:09:36',3310501914,1),(53376856,425530017,14243958,454632,1,'2007-09-18 00:09:36',3310501914,1),(53376859,425525962,14243147,454632,1,'2007-09-18 00:09:36',3310501914,1),(53376862,425523484,14243012,454632,1,'2007-09-18 00:09:36',3310501914,1),(53376864,425520510,14242832,454632,1,'2007-09-18 00:09:37',3310501914,1),(53376873,425515598,14243012,454632,1,'2007-09-18 00:09:37',3310501914,1),(53376881,425512850,14243237,454632,1,'2007-09-18 00:09:38',3310501914,1),(53376883,425507262,14243192,454632,1,'2007-09-18 00:09:38',3310501914,1),(53376887,425503568,14242426,454632,1,'2007-09-18 00:09:38',3310501903,1),(53376891,425501810,14241975,454632,1,'2007-09-18 00:09:38',3310501903,1),(53376895,425497079,14239587,454632,1,'2007-09-18 00:09:39',3310501903,1),(53376898,425494511,14237740,454632,1,'2007-09-18 00:09:39',3310501903,1),(53376899,425491537,14233685,454632,1,'2007-09-18 00:09:39',3310501903,1),(53376955,425376012,14835521,454632,1,'2007-09-18 00:09:45',3310491133,1),(53376959,425373865,14831300,454632,1,'2007-09-18 00:09:45',3310491127,1),(53376962,425372228,14827735,454632,1,'2007-09-18 00:09:45',3310491127,1),(53376964,425371391,14825552,454632,1,'2007-09-18 00:09:45',3310491127,1),(53376968,425378522,14840469,454632,1,'2007-09-18 00:09:45',3310491133,1),(53376972,425379723,14843853,454632,1,'2007-09-18 00:09:46',3310491133,1),(53376975,425380341,14846800,454632,1,'2007-09-18 00:09:46',3310491133,1),(53376979,425381033,14849747,454632,1,'2007-09-18 00:09:46',3310491133,1),(53376983,425382379,14854259,454632,1,'2007-09-18 00:09:47',3310491133,1),(53376987,425384307,14860880,454632,1,'2007-09-18 00:09:47',3310491133,1),(53376989,425385690,14864628,454632,1,'2007-09-18 00:09:47',3310491133,1),(53376996,425387000,14868121,454632,1,'2007-09-18 00:09:48',3310491133,1),(53377001,425389619,14873760,454632,1,'2007-09-18 00:09:48',3310491133,1),(53377006,425391548,14877799,454632,1,'2007-09-18 00:09:48',3310491133,1),(53377009,425393476,14881583,454632,1,'2007-09-18 00:09:49',3310491133,1),(53377015,425394604,14883984,454632,1,'2007-09-18 00:09:49',3310491133,1),(53377018,425395732,14887877,454632,1,'2007-09-18 00:09:49',3310491135,1),(53377021,425395914,14891952,454632,1,'2007-09-18 00:09:49',3310491135,1),(53377027,425395841,14894426,454632,1,'2007-09-18 00:09:50',3310491135,1),(53377032,425396314,14899665,454632,1,'2007-09-18 00:09:50',3310491135,1),(53377035,425397660,14904177,454632,1,'2007-09-18 00:09:50',3310502058,1),(53377040,425401189,14910435,454632,1,'2007-09-18 00:09:50',3310502058,1),(53377045,425404755,14916184,454632,1,'2007-09-18 00:09:50',3310502058,1),(53377047,425407811,14919385,454632,1,'2007-09-18 00:09:51',3310502058,1),(53377049,425410685,14921896,454632,1,'2007-09-18 00:09:51',3310502058,1),(53377051,425413887,14923679,454632,1,'2007-09-18 00:09:51',3310502058,1),(53377053,425418290,14925352,454632,1,'2007-09-18 00:09:51',3310502058,1),(53377058,425421892,14927353,454632,1,'2007-09-18 00:09:52',3310502058,1),(53377061,425424911,14930082,454632,1,'2007-09-18 00:09:52',3310502059,1),(53377065,425427604,14933648,454632,1,'2007-09-18 00:09:52',3310502059,1),(53377068,425428695,14937322,454632,1,'2007-09-18 00:09:53',3310502059,1),(53377070,425428259,14939906,454632,1,'2007-09-18 00:09:53',3310502059,1),(53377077,425427786,14940815,454632,1,'2007-09-18 00:09:53',3310502059,1),(53377080,425426294,14941798,454632,1,'2007-09-18 00:09:54',3310502401,1),(53377090,425424366,14941725,454632,1,'2007-09-18 00:09:55',3310502400,1),(53377093,425421782,14941288,454632,1,'2007-09-18 00:09:55',3310502058,1),(53377098,425418945,14940561,454632,1,'2007-09-18 00:09:55',3310502058,1),(53377104,425411995,14939505,454632,1,'2007-09-18 00:09:56',3310502058,1),(53377113,425409921,14939505,454632,1,'2007-09-18 00:09:56',3310502058,1),(53377119,425407193,14940015,454632,1,'2007-09-18 00:09:57',3310502058,1),(53377124,425403336,14941325,454632,1,'2007-09-18 00:09:57',3310502058,1),(53377128,425399734,14942962,454632,1,'2007-09-18 00:09:58',3310502400,1),(53377133,425394749,14944817,454632,1,'2007-09-18 00:09:58',3310491477,1),(53377138,425390965,14946200,454632,1,'2007-09-18 00:09:59',3310491477,1),(53377141,425387873,14947001,454632,1,'2007-09-18 00:09:59',3310491477,1),(53377146,425385290,14946928,454632,1,'2007-09-18 00:10:00',3310491477,1),(53377151,425381287,14945509,454632,1,'2007-09-18 00:10:00',3310491477,1),(53377156,425377504,14943107,454632,1,'2007-09-18 00:10:01',3310491477,1),(53377163,425375697,14940890,454632,1,'2007-09-18 00:10:01',3310491135,1),(53377168,425374565,14937369,454632,1,'2007-09-18 00:10:01',3310491135,1),(53377175,425372930,14932528,454632,1,'2007-09-18 00:10:02',3310491135,1),(53377178,425370290,14928630,454632,1,'2007-09-18 00:10:03',3310491135,1),(53377180,425366706,14924669,454632,1,'2007-09-18 00:10:03',3310491134,1),(53377183,425364443,14921337,454632,1,'2007-09-18 00:10:03',3310491134,1),(53377186,425363248,14917502,454632,1,'2007-09-18 00:10:04',3310491134,1),(53377191,425363311,14914170,454632,1,'2007-09-18 00:10:06',3310491134,1),(53377195,425365009,14912472,454632,1,'2007-09-18 00:10:06',3310491134,1),(53380473,425366895,14912472,538211,1,'2007-09-30 15:36:19',3310491134,1),(53380480,425374439,14915050,454632,1,'2007-09-18 00:20:15',3310491135,1),(53380485,425381166,14918508,454632,1,'2007-09-18 00:20:16',3310491135,1),(53380489,425385379,14922846,454632,1,'2007-09-18 00:20:17',3310491135,1),(53380491,425390723,14926430,454632,1,'2007-09-18 00:20:18',3310491135,1),(53380499,425394369,14928945,454632,1,'2007-09-18 00:20:19',3310491135,1),(53380503,425396444,14932591,454632,1,'2007-09-18 00:20:20',3310491135,1),(53381711,425396004,14937118,454632,1,'2007-09-18 00:24:28',3310491135,1),(53381723,425394746,14939318,454632,1,'2007-09-18 00:24:31',3310491135,1),(53381733,425389717,14941519,454632,1,'2007-09-18 00:24:33',3310491135,1),(53381738,425385190,14943153,454632,1,'2007-09-18 00:24:34',3310491477,1),(53381779,425382047,14944285,454632,1,'2007-09-18 00:24:40',3310491477,1),(53381787,425379406,14914296,454632,1,'2007-09-18 00:24:41',3310491135,1),(53381798,425383681,14918068,454632,1,'2007-09-18 00:24:44',3310491135,1),(53381809,425387202,14921274,454632,1,'2007-09-18 00:24:46',3310491135,1),(53381818,425390786,14923601,454632,1,'2007-09-18 00:24:48',3310491135,1),(53381825,425394495,14925298,454632,1,'2007-09-18 00:24:48',3310491135,1),(53381829,425396821,14928819,454632,1,'2007-09-18 00:24:49',3310491135,1),(53381832,425398644,14932780,454632,1,'2007-09-18 00:24:49',3310502058,1),(53381834,425398959,14936112,454632,1,'2007-09-18 00:24:50',3310502058,1),(53381837,425395815,14934666,454632,1,'2007-09-18 00:24:50',3310491135,1),(53381842,425395375,14931648,454632,1,'2007-09-18 00:24:50',3310491135,1),(53381844,425392860,14928819,454632,1,'2007-09-18 00:24:51',3310491135,1),(53381850,425390660,14927373,454632,1,'2007-09-18 00:24:52',3310491135,1),(53381892,425387391,14925424,454632,1,'2007-09-18 00:25:00',3310491135,1),(53381925,425385127,14923663,454632,1,'2007-09-18 00:25:06',3310491135,1),(53381944,425383241,14921652,454632,1,'2007-09-18 00:25:10',3310491135,1),(53381947,425381103,14919765,454632,1,'2007-09-18 00:25:11',3310491135,1),(53381978,425377646,14917754,454632,1,'2007-09-18 00:25:21',3310491135,1),(53381995,425370478,14914862,454632,1,'2007-09-18 00:25:28',3310491135,1),(53382002,425371358,14910964,454632,1,'2007-09-18 00:25:29',3310491135,1),(53382009,425365816,14920445,454632,1,'2007-09-18 00:25:31',3310491134,1),(53382019,425367235,14923449,454632,1,'2007-09-18 00:25:35',3310491134,1),(53382028,425369071,14925618,454632,1,'2007-09-18 00:25:36',3310491134,1),(53382033,425371323,14928121,454632,1,'2007-09-18 00:25:38',3310491135,1),(53382041,425373576,14931542,454632,1,'2007-09-18 00:25:39',3310491135,1),(53382044,425375495,14937216,454632,1,'2007-09-18 00:25:40',3310491135,1),(53382047,425376163,14939636,454632,1,'2007-09-18 00:25:41',3310491135,1),(53382052,425377581,14942222,454632,1,'2007-09-18 00:25:42',3310491477,1),(53382055,425379750,14943724,454632,1,'2007-09-18 00:25:43',3310491477,1),(53382059,425380501,14943641,454632,1,'2007-09-18 00:25:44',3310491477,1),(53382064,425381336,14942806,454632,1,'2007-09-18 00:25:44',3310491477,1),(53382089,425382504,14941555,454632,1,'2007-09-18 00:25:49',3310491135,1),(53382106,425385257,14941221,454632,1,'2007-09-18 00:25:53',3310491135,1),(53382126,425388011,14940553,454632,1,'2007-09-18 00:25:56',3310491135,1),(53382156,425391348,14939385,454632,1,'2007-09-18 00:26:02',3310491135,1),(53382223,425393684,14938050,454632,1,'2007-09-18 00:26:16',3310491135,1),(53382318,425395103,14936382,454632,1,'2007-09-18 00:26:35',3310491135,1),(53382504,425395770,14934629,454632,1,'2007-09-18 00:27:16',3310491135,1),(53382509,425395384,14932168,454632,1,'2007-09-18 00:27:17',3310491135,1),(53382959,425394684,14930812,454632,1,'2007-09-18 00:28:30',3310491135,1),(53383168,425390856,14927444,454632,1,'2007-09-18 00:29:04',3310491135,1),(53383242,425385519,14924010,538211,1,'2007-09-30 15:36:20',3310491135,1),(53383258,425384185,14922676,538211,1,'2007-09-30 15:36:20',3310491135,1),(53383280,425381801,14920357,538211,1,'2007-09-30 15:36:20',3310491135,1),(53383286,425379789,14919089,538211,1,'2007-09-30 15:36:20',3310491135,1),(53383289,425377302,14917659,538211,1,'2007-09-30 15:36:20',3310491135,1),(53383297,425375298,14916790,538211,1,'2007-09-30 15:36:20',3310491135,1),(53383310,425370778,14914832,454632,1,'2007-09-18 00:29:29',3310491135,1),(53383321,425369055,14914197,454632,1,'2007-09-18 00:29:31',3310491134,1),(53383324,425366968,14913622,538211,1,'2007-09-30 15:36:19',3310491134,1),(53383336,425365759,14913773,538211,1,'2007-09-30 15:36:19',3310491134,1),(53383341,425364973,14914711,538211,1,'2007-09-30 15:36:19',3310491134,1),(53383350,425364912,14915588,538211,1,'2007-09-30 15:36:19',3310491134,1),(53383356,425365215,14918853,538211,1,'2007-09-30 15:36:19',3310491134,1),(53383364,425379384,14851309,454632,1,'2007-09-18 00:29:36',3310491133,1),(53383369,425375668,14854925,454632,1,'2007-09-18 00:29:36',3310491133,1),(53383373,425372884,14858552,454632,1,'2007-09-18 00:29:36',3310491133,1),(53383379,425369206,14863864,454632,1,'2007-09-18 00:29:37',3310491132,1),(53383384,425364353,14870556,454632,1,'2007-09-18 00:29:37',3310491132,1),(53383388,425358419,14878355,454632,1,'2007-09-18 00:29:38',3310491132,1),(53383393,425353176,14885452,454632,1,'2007-09-18 00:29:38',3310491132,1),(53383398,425348198,14891913,454632,1,'2007-09-18 00:29:39',3310491134,1),(53383403,425347933,14883545,454632,1,'2007-09-18 00:29:40',3310491132,1),(53383409,425356830,14872688,454632,1,'2007-09-18 00:29:40',3310491132,1),(53383415,425362126,14865062,454632,1,'2007-09-18 00:29:41',3310491132,1),(53383419,425368269,14857118,454632,1,'2007-09-18 00:29:42',3310491132,1),(53383424,425377484,14844885,454632,1,'2007-09-18 00:29:42',3310491133,1),(53383429,425337114,14701265,454632,1,'2007-09-18 00:29:42',3310491099,1),(53383434,425308725,14733734,454632,1,'2007-09-18 00:29:43',3310491120,1),(53383440,425306902,14729827,454632,1,'2007-09-18 00:29:44',3310491120,1),(53383445,425306294,14723837,454632,1,'2007-09-18 00:29:44',3310491120,1),(53383451,425305773,14718888,454632,1,'2007-09-18 00:29:45',3310491098,1),(53383455,425303603,14713332,454632,1,'2007-09-18 00:29:46',3310491098,1),(53383459,425303950,14710381,454632,1,'2007-09-18 00:29:47',3310491098,1),(53383468,425306468,14704651,454632,1,'2007-09-18 00:29:48',3310491098,1),(53383474,425308899,14701439,454632,1,'2007-09-18 00:29:49',3310491098,1),(53383480,425312545,14698574,454632,1,'2007-09-18 00:29:50',3310491098,1),(53383487,425316191,14697792,454632,1,'2007-09-18 00:29:52',3310491099,1),(53383494,425321400,14699095,454632,1,'2007-09-18 00:29:54',3310491099,1),(53383497,425324265,14700397,454632,1,'2007-09-18 00:29:54',3310491099,1),(53383499,425326956,14701439,454632,1,'2007-09-18 00:29:54',3310491099,1),(53383505,425331644,14701178,454632,1,'2007-09-18 00:29:55',3310491099,1),(53383508,425333033,14700050,454632,1,'2007-09-18 00:29:55',3310491099,1),(53383523,425335985,14700223,454632,1,'2007-09-18 00:29:58',3310491099,1),(53383556,425327169,14743141,454632,1,'2007-09-18 00:30:04',3310491121,1),(53383559,425321397,14744855,454632,1,'2007-09-18 00:30:04',3310491121,1),(53383561,425313984,14748336,454632,1,'2007-09-18 00:30:05',3310491120,1),(53383562,425318385,14757932,454632,1,'2007-09-18 00:30:06',3310491121,1),(53383566,425321920,14765002,454632,1,'2007-09-18 00:30:06',3310491121,1),(53383579,425324012,14773082,454632,1,'2007-09-18 00:30:10',3310491121,1),(53383582,425325672,14776185,454632,1,'2007-09-18 00:30:12',3310491121,1),(53383584,425327187,14778782,454632,1,'2007-09-18 00:30:12',3310491123,1),(53383597,425330145,14780514,454632,1,'2007-09-18 00:30:16',3310491123,1),(53383600,425342266,14784915,454632,1,'2007-09-18 00:30:16',3310491126,1),(53383603,425352871,14789171,454632,1,'2007-09-18 00:30:16',3310491126,1),(53383605,425356479,14790109,454632,1,'2007-09-18 00:30:17',3310491126,1),(53383606,425359437,14788955,454632,1,'2007-09-18 00:30:17',3310491126,1),(53383610,425362178,14785420,454632,1,'2007-09-18 00:30:17',3310491126,1),(53383612,425363982,14781019,454632,1,'2007-09-18 00:30:17',3310491126,1),(53383614,425364992,14776618,454632,1,'2007-09-18 00:30:17',3310491124,1),(53383617,425364920,14774381,454632,1,'2007-09-18 00:30:17',3310491124,1),(53383620,425363765,14770197,454632,1,'2007-09-18 00:30:18',3310491124,1),(53383622,425362972,14767094,454632,1,'2007-09-18 00:30:18',3310491124,1),(53383624,425361024,14762549,454632,1,'2007-09-18 00:30:18',3310491124,1),(53383626,425357633,14759230,454632,1,'2007-09-18 00:30:19',3310491124,1),(53383628,425352655,14756561,454632,1,'2007-09-18 00:30:19',3310491124,1),(53383631,425349336,14753747,454632,1,'2007-09-18 00:30:19',3310491124,1),(53383634,425344719,14749779,454632,1,'2007-09-18 00:30:19',3310491124,1),(53383636,425333897,14739967,454632,1,'2007-09-18 00:30:20',3310491121,1),(53383639,425338506,14715813,454632,1,'2007-09-18 00:30:20',3310491099,1),(53383643,425339388,14720592,454632,1,'2007-09-18 00:30:21',3310491099,1),(53383646,425339315,14724931,454632,1,'2007-09-18 00:30:22',3310491121,1),(53383670,425337991,14729343,454632,1,'2007-09-18 00:30:27',3310491121,1),(53383680,425335785,14734564,454632,1,'2007-09-18 00:30:29',3310491121,1),(53383685,425334241,14735740,454632,1,'2007-09-18 00:30:29',3310491121,1),(53383688,425331594,14735961,454632,1,'2007-09-18 00:30:29',3310491121,1),(53383691,425329314,14737432,454632,1,'2007-09-18 00:30:29',3310491121,1),(53383694,425325858,14739123,454632,1,'2007-09-18 00:30:30',3310491121,1),(53383698,425322255,14741476,454632,1,'2007-09-18 00:30:30',3310491121,1),(53383728,425317476,14742800,454632,1,'2007-09-18 00:30:35',3310491121,1),(53383735,425313946,14743755,454632,1,'2007-09-18 00:30:37',3310491120,1),(53383739,425311299,14739564,454632,1,'2007-09-18 00:30:38',3310491120,1),(53383762,425320343,14730887,454632,1,'2007-09-18 00:30:42',3310491121,1),(53383772,425323799,14726843,454632,1,'2007-09-18 00:30:43',3310491121,1),(53383793,425326961,14722578,454632,1,'2007-09-18 00:30:46',3310491121,1),(53383842,425329461,14720960,454632,1,'2007-09-18 00:30:54',3310491099,1),(53383953,425335197,14713386,454632,1,'2007-09-18 00:31:08',3310491099,1),(53383956,425337256,14711107,454632,1,'2007-09-18 00:31:09',3310491099,1),(53383958,425297457,14678657,454632,1,'2007-09-18 00:31:10',3310491098,1),(53383961,425302101,14682161,454632,1,'2007-09-18 00:31:10',3310491098,1),(53383970,425308579,14684891,454632,1,'2007-09-18 00:31:12',3310491098,1),(53383987,425308008,14687783,454632,1,'2007-09-18 00:31:15',3310491098,1),(53383990,425305197,14693364,454632,1,'2007-09-18 00:31:15',3310491098,1),(53384000,425302386,14700127,454632,1,'2007-09-18 00:31:17',3310491098,1),(53384003,425301449,14700209,454632,1,'2007-09-18 00:31:17',3310491098,1),(53384008,425300838,14699842,454632,1,'2007-09-18 00:31:18',3310491098,1),(53384011,425298068,14695605,454632,1,'2007-09-18 00:31:18',3310491098,1),(53384013,425294972,14690716,454632,1,'2007-09-18 00:31:19',3310491098,1),(53384016,425293749,14686153,454632,1,'2007-09-18 00:31:19',3310491098,1),(53384020,425292772,14681631,454632,1,'2007-09-18 00:31:19',3310491098,1),(53384024,425292894,14678698,454632,1,'2007-09-18 00:31:20',3310491098,1),(53384026,425294646,14678413,454632,1,'2007-09-18 00:31:20',3310491098,1),(53384030,425331408,14794176,454632,1,'2007-09-18 00:31:20',3310491123,1),(53384033,425333312,14801793,454632,1,'2007-09-18 00:31:21',3310491123,1),(53384036,425335812,14809292,454632,1,'2007-09-18 00:31:22',3310491123,1),(53384038,425339382,14820242,454632,1,'2007-09-18 00:31:22',3310491123,1),(53384040,425343786,14828693,454632,1,'2007-09-18 00:31:23',3310491126,1),(53384065,425348309,14833811,454632,1,'2007-09-18 00:31:27',3310491132,1),(53384068,425353785,14837739,454632,1,'2007-09-18 00:31:27',3310491132,1),(53384120,425357474,14840834,454632,1,'2007-09-18 00:31:39',3310491132,1),(53384283,425360688,14839763,454632,1,'2007-09-18 00:32:11',3310491132,1),(53384287,425364497,14836073,454632,1,'2007-09-18 00:32:12',3310491132,1),(53384302,425367234,14834764,454632,1,'2007-09-18 00:32:16',3310491132,1),(53384325,425369615,14838572,454632,1,'2007-09-18 00:32:22',3310491132,1),(53384330,425365806,14841905,454632,1,'2007-09-18 00:32:24',3310491132,1),(53384332,425362473,14845833,454632,1,'2007-09-18 00:32:24',3310491132,1),(53384335,425361164,14849047,454632,1,'2007-09-18 00:32:25',3310491132,1),(53384338,425359141,14849047,454632,1,'2007-09-18 00:32:26',3310491132,1),(53384375,425357831,14848094,538211,1,'2007-09-30 15:36:19',3310491132,1),(53385461,425353070,14843929,454632,1,'2007-09-18 00:37:46',3310491132,1),(53385467,425350333,14840953,454632,1,'2007-09-18 00:37:47',3310491132,1),(53385484,425348190,14839882,454632,1,'2007-09-18 00:37:50',3310491132,1),(53385511,425346524,14839644,454632,1,'2007-09-18 00:37:55',3310491132,1),(53387182,425344501,14837620,538211,1,'2007-09-30 15:36:20',3310491132,1),(53388340,425338192,14827384,454632,1,'2007-09-18 00:48:16',3310491123,1),(53388543,425334979,14820242,454632,1,'2007-09-18 00:48:59',3310491123,1),(53389302,425332598,14810958,454632,1,'2007-09-18 00:51:38',3310491123,1),(53389827,425331408,14805602,454632,1,'2007-09-18 00:53:37',3310491123,1),(53390266,425329384,14798937,454632,1,'2007-09-18 00:55:18',3310491123,1),(53390450,425325814,14792628,454632,1,'2007-09-18 00:55:58',3310491123,1),(53390493,425325218,14787272,454632,1,'2007-09-18 00:56:06',3310491123,1),(53390505,425324266,14781559,454632,1,'2007-09-18 00:56:09',3310491123,1),(53390513,425319624,14772156,454632,1,'2007-09-18 00:56:11',3310491121,1),(53390521,425317363,14764419,454632,1,'2007-09-18 00:56:12',3310491121,1),(53390534,425313197,14755373,454632,1,'2007-09-18 00:56:14',3310491120,1),(53390548,425306769,14746804,454632,1,'2007-09-18 00:56:16',3310491120,1),(53390624,425304508,14743114,454632,1,'2007-09-18 00:56:32',3310491120,1),(53390658,425306412,14740495,454632,1,'2007-09-18 00:56:39',3310491120,1),(53390732,425313554,14750136,454632,1,'2007-09-18 00:56:54',3310491120,1),(53390740,425316887,14756921,454632,1,'2007-09-18 00:56:56',3310491121,1),(53390749,425320934,14766086,454632,1,'2007-09-18 00:56:57',3310491121,1),(53390776,425325456,14776917,454632,1,'2007-09-18 00:57:04',3310491123,1),(53390786,425321066,14695137,454632,1,'2007-09-18 00:57:06',3310491099,1),(53392096,425316926,14694309,454632,1,'2007-09-18 01:00:37',3310491099,1),(53392102,425314752,14694257,454632,1,'2007-09-18 01:00:38',3310491099,1),(53392109,425312423,14694775,454632,1,'2007-09-18 01:00:39',3310491098,1),(53392116,425313251,14689806,454632,1,'2007-09-18 01:00:40',3310491098,1),(53392136,425315425,14689599,454632,1,'2007-09-18 01:00:45',3310491099,1),(53392141,425320704,14691204,454632,1,'2007-09-18 01:00:46',3310491099,1),(53392147,425328209,14696173,454632,1,'2007-09-18 01:00:47',3310491099,1),(53392151,425327899,14697156,454632,1,'2007-09-18 01:00:48',3310491099,1),(53392160,425326450,14697674,454632,1,'2007-09-18 01:00:50',3310491099,1),(53392164,425323913,14696845,454632,1,'2007-09-18 01:00:50',3310491099,1),(53392166,425322930,14696017,454632,1,'2007-09-18 01:00:50',3310491099,1),(53392168,425322671,14695448,454632,1,'2007-09-18 01:00:50',3310491099,1),(53392180,425322671,14693792,454632,1,'2007-09-18 01:00:51',3310491099,1),(53392185,425322878,14693119,454632,1,'2007-09-18 01:00:53',3310491099,1),(53392195,425323344,14693015,454632,1,'2007-09-18 01:00:54',3310491099,1),(53392200,425324379,14693688,454632,1,'2007-09-18 01:00:55',3310491099,1),(53392203,425324897,14693947,454632,1,'2007-09-18 01:00:56',3310491099,1),(53392207,425309105,14691843,454632,1,'2007-09-18 01:00:56',3310491098,1),(53392208,425306473,14695745,454632,1,'2007-09-18 01:00:56',3310491098,1),(53392215,425304885,14699512,454632,1,'2007-09-18 01:00:57',3310491098,1),(53392222,425304250,14702870,454632,1,'2007-09-18 01:00:58',3310491098,1),(53392224,425306473,14700192,454632,1,'2007-09-18 01:00:58',3310491098,1),(53392227,425309105,14696154,454632,1,'2007-09-18 01:00:58',3310491098,1),(53392235,425311238,14695110,454632,1,'2007-09-18 01:00:58',3310491098,1),(53392239,425311783,14690209,454632,1,'2007-09-18 01:00:59',3310491098,1),(57603545,424579031,14513385,494030,1,'2007-09-22 21:27:14',3310490756,1),(57603546,424582197,14528405,494030,1,'2007-09-22 21:27:14',3310490756,1),(57603547,424585363,14534413,494030,1,'2007-09-22 21:27:14',3310490756,1),(57603548,424591379,14537847,494030,1,'2007-09-22 21:27:14',3310490756,1),(57603549,424598977,14553296,494030,1,'2007-09-22 21:27:14',3310490756,1),(57603550,424609742,14571750,494030,1,'2007-09-22 21:27:14',3310490759,1),(57603551,424618290,14585054,494030,1,'2007-09-22 21:27:14',3310490759,1),(57603552,424622406,14572179,494030,1,'2007-09-22 21:27:14',3310490759,1),(57603553,424630954,14579904,494030,1,'2007-09-22 21:27:14',3310490770,1),(57603554,424637602,14586341,494030,1,'2007-09-22 21:27:14',3310490770,1),(57603555,424639502,14593637,494030,1,'2007-09-22 21:27:14',3310490770,1),(57603556,424645200,14599645,494030,1,'2007-09-22 21:27:14',3310490770,1),(57603557,424647733,14606082,494030,1,'2007-09-22 21:27:14',3310490770,1),(57603559,424649949,14610374,494030,1,'2007-09-22 21:27:14',3310490770,1),(57603560,424657547,14629256,494030,1,'2007-09-22 21:27:14',3310490777,1),(57603561,424656281,14638269,494030,1,'2007-09-22 21:27:14',3310490777,1),(57603562,424665461,14655006,494030,1,'2007-09-22 21:27:14',3310490777,1),(57603563,424663879,14662730,494030,1,'2007-09-22 21:27:14',3310490777,1),(57603564,424659446,14658010,494030,1,'2007-09-22 21:27:14',3310490777,1),(57603565,424661029,14680326,494030,1,'2007-09-22 21:27:14',3310490779,1),(57603566,424671476,14694488,494030,1,'2007-09-22 21:27:14',3310490779,1),(57603567,424672743,14720666,494030,1,'2007-09-22 21:27:14',3310490779,1),(57603568,424674959,14741695,494030,1,'2007-09-22 21:27:14',3310490801,1),(57603569,424668627,14758431,494030,1,'2007-09-22 21:27:14',3310490801,1),(57603570,424665145,14767873,494030,1,'2007-09-22 21:27:14',3310490801,1),(57603571,424664512,14784610,494030,1,'2007-09-22 21:27:14',3310490803,1),(57603572,424668311,14797484,494030,1,'2007-09-22 21:27:14',3310490803,1),(57603573,424674642,14810359,494030,1,'2007-09-22 21:27:14',3310490803,1),(57603574,424678441,14826667,494030,1,'2007-09-22 21:27:14',3310490803,1),(57603575,424690154,14845120,494030,1,'2007-09-22 21:27:14',3310490812,1),(57603994,424692180,14850099,494030,1,'2007-09-22 21:27:14',3310490812,1),(57603995,424692053,14852416,494030,1,'2007-09-22 21:27:14',3310490812,1),(57603996,424696612,14850442,494030,1,'2007-09-22 21:27:14',3310490812,1),(57603997,424698891,14852674,494030,1,'2007-09-22 21:27:14',3310490812,1),(57603998,424699334,14858853,494030,1,'2007-09-22 21:27:14',3310490812,1),(57603999,424704399,14864175,494030,1,'2007-09-22 21:27:14',3310490812,1),(57604000,424707374,14867265,494030,1,'2007-09-22 21:27:14',3310490812,1),(57604001,424710413,14872415,494030,1,'2007-09-22 21:27:14',3310490812,1),(57604002,424713072,14877307,494030,1,'2007-09-22 21:27:14',3310490813,1),(57604003,424715288,14885203,494030,1,'2007-09-22 21:27:14',3310490813,1),(57604004,424718201,14888894,494030,1,'2007-09-22 21:27:14',3310490815,1),(57604005,424720353,14891469,494030,1,'2007-09-22 21:27:14',3310490815,1),(57604006,424719593,14896190,494030,1,'2007-09-22 21:27:14',3310490815,1),(57607196,424718517,14903743,494030,1,'2007-09-22 21:27:14',3310490815,1),(57607197,424716491,14913613,494030,1,'2007-09-22 21:27:14',3310490815,1),(57607198,424709337,14918592,494030,1,'2007-09-22 21:27:14',3310490814,1),(57607199,424706362,14922626,494030,1,'2007-09-22 21:27:14',3310490814,1),(57607200,424705538,14927175,494030,1,'2007-09-22 21:27:14',3310490814,1),(57607201,424706615,14928033,494030,1,'2007-09-22 21:27:14',3310490814,1),(57607202,424708261,14926660,494030,1,'2007-09-22 21:27:14',3310490814,1),(57607203,424711046,14924600,494030,1,'2007-09-22 21:27:14',3310490815,1),(57607204,424714592,14922883,494030,1,'2007-09-22 21:27:14',3310490815,1),(57607205,424718011,14921166,494030,1,'2007-09-22 21:27:14',3310490815,1),(57607206,424719783,14920480,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608723,424721556,14920737,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608724,424722949,14921166,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608725,424724341,14923656,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608726,424725924,14924256,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608727,424727190,14924171,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608728,424728013,14923398,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608729,424727254,14920737,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608730,424729659,14919879,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608731,424730103,14922025,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608732,424731875,14918334,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608735,424733141,14916617,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608736,424734851,14913871,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608737,424736750,14909494,494030,1,'2007-09-22 21:27:14',3310490815,1),(57608738,424740675,14906146,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608739,424742891,14904258,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608740,424741815,14900653,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608741,424744600,14899795,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608742,424745866,14900224,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608743,424748462,14898593,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608744,424748209,14894645,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608745,424754792,14891383,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608746,424755995,14891126,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608748,424756628,14895417,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608750,424757831,14894216,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608751,424758337,14888465,494030,1,'2007-09-22 21:27:14',3310490858,1),(57608752,424757388,14882886,494030,1,'2007-09-22 21:27:14',3310490856,1),(57608754,424755995,14877393,494030,1,'2007-09-22 21:27:14',3310490856,1),(57608755,424756185,14869840,494030,1,'2007-09-22 21:27:14',3310490856,1),(57608756,424755805,14867093,494030,1,'2007-09-22 21:27:14',3310490856,1),(57608757,424753969,14864432,494030,1,'2007-09-22 21:27:14',3310490856,1),(57608758,424750551,14859883,494030,1,'2007-09-22 21:27:14',3310490856,1),(57608759,424749031,14856708,494030,1,'2007-09-22 21:27:14',3310490856,1),(57608760,424748778,14852931,494030,1,'2007-09-22 21:27:14',3310490856,1),(57608761,424749665,14844434,494030,1,'2007-09-22 21:27:14',3310490856,1),(57608762,424751564,14833104,494030,1,'2007-09-22 21:27:14',3310490856,1),(57608763,424753906,14820487,494030,1,'2007-09-22 21:27:14',3310490850,1),(57608764,424754349,14812848,494030,1,'2007-09-22 21:27:14',3310490850,1),(57608765,424755679,14808557,494030,1,'2007-09-22 21:27:14',3310490850,1),(57608766,424756945,14806840,494030,1,'2007-09-22 21:27:14',3310490850,1),(57608767,424761883,14804008,494030,1,'2007-09-22 21:27:14',3310490850,1),(57608768,424766947,14801261,494030,1,'2007-09-22 21:27:14',3310490851,1),(57608769,424770112,14801347,494030,1,'2007-09-22 21:27:14',3310490851,1),(57608770,424772265,14799716,494030,1,'2007-09-22 21:27:14',3310490851,1),(57608771,424773277,14795940,494030,1,'2007-09-22 21:27:14',3310490851,1),(57608772,424773467,14792850,494030,1,'2007-09-22 21:27:14',3310490851,1),(57608774,424773467,14787786,494030,1,'2007-09-22 21:27:14',3310490851,1),(57608776,424772518,14782636,494030,1,'2007-09-22 21:27:14',3310490851,1),(57608777,424770302,14778945,494030,1,'2007-09-22 21:27:14',3310490851,1),(57608778,424768656,14774739,494030,1,'2007-09-22 21:27:14',3310490849,1),(57611783,424783279,14679210,494030,1,'2007-09-22 21:27:14',3310490827,1),(57611874,424766757,14768302,494030,1,'2007-09-22 21:27:14',3310490849,1),(57611875,424766124,14764869,494030,1,'2007-09-22 21:27:14',3310490849,1),(57611876,424767137,14759376,494030,1,'2007-09-22 21:27:14',3310490849,1),(57611877,424769036,14754741,494030,1,'2007-09-22 21:27:14',3310490849,1),(57611878,424769353,14747016,494030,1,'2007-09-22 21:27:14',3310490849,1),(57611879,424768530,14742038,494030,1,'2007-09-22 21:27:14',3310490849,1),(57611880,424766820,14738261,494030,1,'2007-09-22 21:27:14',3310490849,1),(57611881,424766187,14733712,494030,1,'2007-09-22 21:27:14',3310490849,1),(57611882,424766441,14729163,494030,1,'2007-09-22 21:27:14',3310490849,1),(57611883,424769416,14723928,494030,1,'2007-09-22 21:27:14',3310490849,1),(57611884,424772391,14717748,494030,1,'2007-09-22 21:27:14',3310490827,1),(57611885,424773847,14713199,494030,1,'2007-09-22 21:27:14',3310490827,1),(57611886,424772771,14706246,494030,1,'2007-09-22 21:27:14',3310490827,1),(57611887,424773341,14700667,494030,1,'2007-09-22 21:27:14',3310490827,1),(57611888,424774670,14695432,494030,1,'2007-09-22 21:27:14',3310490827,1),(57611889,424773594,14691312,494030,1,'2007-09-22 21:27:14',3310490827,1),(57611890,424773531,14687707,494030,1,'2007-09-22 21:27:14',3310490827,1),(57611891,424775113,14685475,494030,1,'2007-09-22 21:27:14',3310490827,1),(57627518,424789863,14372193,494030,1,'2007-09-22 21:27:14',3310490723,1),(57627519,424781950,14381635,494030,1,'2007-09-22 21:27:14',3310490723,1),(57627521,424775936,14390647,494030,1,'2007-09-22 21:27:14',3310490723,1),(58865012,425232394,15214414,461502,1,'2008-05-16 18:38:38',3310491492,2),(58865013,425228789,15216302,461502,1,'2008-05-16 18:38:38',3310491491,2),(58957648,425069391,15212467,2395774,1,'2009-09-06 23:32:08',3310491440,19),(58963219,425561500,15334945,225225,1,'2008-04-23 01:45:02',3310502459,3),(59015921,425362733,15740530,502899,1,'2007-09-23 18:56:30',3310491644,1),(59015924,425364441,15746109,502899,1,'2007-09-23 18:56:30',3310491644,1),(59015925,425365136,15749886,502899,1,'2007-09-23 18:56:30',3310491644,1),(59015926,425364694,15751259,502899,1,'2007-09-23 18:56:35',3310491644,1),(59015927,425362860,15750830,502899,1,'2007-09-23 18:56:30',3310491644,1),(59015928,425359002,15749886,502899,1,'2007-09-23 18:56:30',3310491644,1),(59015929,425355903,15750401,502899,1,'2007-09-23 18:56:30',3310491644,1),(59015930,425352108,15752718,502899,1,'2007-09-23 18:56:30',3310491644,1),(59015931,425349452,15753920,502899,1,'2007-09-23 18:56:30',3310491644,1),(59015932,425344455,15754606,502899,1,'2007-09-23 18:56:30',3310491644,1),(59015933,425342305,15755550,502899,1,'2007-09-23 18:56:30',3310491644,1),(59015934,425341015,15757717,370566,1,'2008-05-09 02:01:18',3310491641,2),(59016173,425364378,15766966,502899,1,'2007-09-23 18:56:35',3310491646,1),(59016174,425365010,15761215,502899,1,'2007-09-23 18:56:35',3310491644,1),(59016175,425365326,15754435,502899,1,'2007-09-23 18:56:35',3310491644,1),(59632226,424762308,14904936,538211,1,'2007-09-30 15:36:19',3310490858,1),(64796296,425132657,15354227,104599,1,'2007-10-11 20:25:12',3310491454,1),(64796297,425132424,15356646,104599,1,'2007-10-11 20:25:13',3310491454,1),(64796301,425130935,15357996,104599,1,'2007-10-11 20:25:13',3310491454,1),(64796302,425129167,15359205,104599,1,'2007-10-11 20:25:13',3310491454,1),(64796303,425127818,15359391,104599,1,'2007-10-11 20:25:13',3310491454,1),(64796304,425126283,15359578,104599,1,'2007-10-11 20:25:13',3310491454,1),(64796308,425125445,15359857,104599,1,'2007-10-11 20:25:13',3310491454,1),(64796309,425124235,15361113,104599,1,'2007-10-11 20:25:13',3310491454,1),(64796310,425122607,15362276,104599,1,'2007-10-11 20:25:13',3310491454,1),(64796311,425121025,15362555,104599,1,'2007-10-11 20:25:13',3310491451,1),(64796315,425119304,15362695,104599,1,'2007-10-11 20:25:13',3310491451,1),(64796316,425116559,15363579,104599,1,'2007-10-11 20:25:13',3310491451,1),(64796317,425131819,15354227,104599,1,'2007-10-11 20:25:14',3310491454,1),(64796318,425131168,15356228,104599,1,'2007-10-11 20:25:14',3310491454,1),(64796322,425129586,15357391,104599,1,'2007-10-11 20:25:14',3310491454,1),(64796323,425128144,15357530,104599,1,'2007-10-11 20:25:14',3310491454,1),(64796324,425126376,15357996,104599,1,'2007-10-11 20:25:14',3310491454,1),(64796325,425125399,15358926,104599,1,'2007-10-11 20:25:14',3310491454,1),(64796329,425123770,15359950,104599,1,'2007-10-11 20:25:14',3310491454,1),(64796330,425122188,15360787,104599,1,'2007-10-11 20:25:14',3310491451,1),(64796331,425120467,15361113,104599,1,'2007-10-11 20:25:14',3310491451,1),(64796332,425119350,15361159,104599,1,'2007-10-11 20:25:14',3310491451,1),(64796335,425116419,15362043,104599,1,'2007-10-11 20:25:14',3310491451,1),(64796337,425115302,15362881,104599,1,'2007-10-11 20:25:14',3310491451,1),(64796338,425114560,15365030,104599,1,'2007-10-11 20:25:14',3310491451,1),(64796339,425115096,15362872,104599,1,'2007-10-11 20:25:15',3310491451,1),(64796340,425133413,15345948,104599,1,'2007-10-11 20:25:15',3310491454,1),(64796344,425133767,15342620,104599,1,'2007-10-11 20:25:15',3310491454,1),(64796345,425133884,15340618,104599,1,'2007-10-11 20:25:15',3310491454,1),(64796346,425133590,15339145,104599,1,'2007-10-11 20:25:15',3310491454,1),(64796349,425132682,15336256,104599,1,'2007-10-11 20:25:15',3310491454,1),(64796351,425131919,15333559,104599,1,'2007-10-11 20:25:15',3310491454,1),(64796352,425132021,15332236,104599,1,'2007-10-11 20:25:15',3310491454,1),(64796353,425134413,15329132,104599,1,'2007-10-11 20:25:15',3310491454,1),(64796356,425138128,15324297,104599,1,'2007-10-11 20:25:15',3310491452,1),(64796358,425141944,15319412,104599,1,'2007-10-11 20:25:15',3310491452,1),(64796359,425145507,15315493,104599,1,'2007-10-11 20:25:16',3310491452,1),(64796360,425148051,15312236,104599,1,'2007-10-11 20:25:16',3310491452,1),(64796363,425150545,15308470,104599,1,'2007-10-11 20:25:16',3310491453,1),(64796365,425153140,15303941,104599,1,'2007-10-11 20:25:16',3310491453,1),(64796366,425154565,15299514,104599,1,'2007-10-11 20:25:16',3310491453,1),(64796367,425156702,15296409,104599,1,'2007-10-11 20:25:16',3310491453,1),(64796368,425132394,15348907,104599,1,'2007-10-11 20:25:16',3310491454,1),(64796372,425132941,15344426,104599,1,'2007-10-11 20:25:16',3310491454,1),(64796373,425133175,15341971,104599,1,'2007-10-11 20:25:16',3310491454,1),(64796374,425132800,15339307,104599,1,'2007-10-11 20:25:16',3310491454,1),(64796375,425131787,15335856,104599,1,'2007-10-11 20:25:16',3310491454,1),(64796376,425131524,15333679,104599,1,'2007-10-11 20:25:16',3310491454,1),(64796377,425131562,15331803,104599,1,'2007-10-11 20:25:16',3310491454,1),(64796381,425134526,15327564,104599,1,'2007-10-11 20:25:17',3310491454,1),(64796382,425136890,15324750,104599,1,'2007-10-11 20:25:17',3310491452,1),(64796383,425145032,15314882,104599,1,'2007-10-11 20:25:17',3310491452,1),(64796385,425146608,15312631,104599,1,'2007-10-11 20:25:17',3310491452,1),(64796388,425149234,15309029,104599,1,'2007-10-11 20:25:17',3310491452,1),(64798267,425151141,15305949,104599,1,'2007-10-11 20:28:37',3310491453,1),(64798268,425152543,15303081,104599,1,'2007-10-11 20:28:37',3310491453,1),(64798270,425153372,15300595,104599,1,'2007-10-11 20:28:38',3310491453,1),(64798271,425154073,15298364,104599,1,'2007-10-11 20:28:38',3310491453,1),(64798274,425156718,15294923,104599,1,'2007-10-11 20:28:38',3310491453,1),(64798275,425160446,15290206,104599,1,'2007-10-11 20:28:38',3310491453,1),(64798277,425162538,15287952,104599,1,'2007-10-11 20:28:38',3310491453,1),(64798278,425163592,15285931,104599,1,'2007-10-11 20:28:38',3310491453,1),(64798280,425163987,15283208,104599,1,'2007-10-11 20:28:38',3310491453,1),(64798282,425164119,15280879,104599,1,'2007-10-11 20:28:38',3310491453,1),(64798283,425165613,15277013,104599,1,'2007-10-11 20:28:38',3310491453,1),(64798285,425168161,15271829,104599,1,'2007-10-11 20:28:38',3310491453,1),(64798286,425169611,15268886,104599,1,'2007-10-11 20:28:38',3310491447,1),(64798289,425170973,15266206,104599,1,'2007-10-11 20:28:38',3310491447,1),(64798290,425172598,15261900,104599,1,'2007-10-11 20:28:38',3310491447,1),(64798291,425173565,15259089,104599,1,'2007-10-11 20:28:39',3310491447,1),(64798293,425174399,15257815,104599,1,'2007-10-11 20:28:39',3310491447,1),(64798295,425176101,15256038,104599,1,'2007-10-11 20:28:39',3310491447,1),(64798297,425159023,15293664,104599,1,'2007-10-11 20:28:39',3310491453,1),(64798298,425161571,15290764,104599,1,'2007-10-11 20:28:39',3310491453,1),(64798300,425164163,15287469,104599,1,'2007-10-11 20:28:39',3310491453,1),(64798301,425164646,15285975,104599,1,'2007-10-11 20:28:39',3310491453,1),(64798304,425164954,15284438,104599,1,'2007-10-11 20:28:39',3310491453,1),(64798305,425165086,15282065,104599,1,'2007-10-11 20:28:39',3310491453,1),(64798306,425165393,15279957,104599,1,'2007-10-11 20:28:39',3310491453,1),(64798308,425166755,15276530,104599,1,'2007-10-11 20:28:39',3310491453,1),(64798310,425170446,15268974,104599,1,'2007-10-11 20:28:39',3310491447,1),(64798312,425172906,15262999,104599,1,'2007-10-11 20:28:39',3310491447,1),(64798313,425174619,15259528,104599,1,'2007-10-11 20:28:39',3310491447,1),(64798315,425176978,15256814,461502,1,'2008-05-16 18:46:06',3310491447,3),(64798316,425178244,15255269,461502,1,'2008-05-16 18:46:06',3310491490,3),(64798319,425179193,15254325,461502,1,'2008-05-16 18:45:35',3310491490,2),(64798320,425179635,15253553,461502,1,'2008-05-16 18:45:35',3310491490,2),(64798321,425180078,15253209,461502,1,'2008-05-16 18:45:35',3310491490,2),(64798323,425181187,15251602,104599,1,'2007-10-11 20:28:40',3310491490,1),(64798324,425182531,15249997,104599,1,'2007-10-11 20:28:40',3310491490,1),(64798327,425184886,15246772,461502,1,'2008-05-16 18:44:26',3310491490,2),(64798328,425187796,15241708,461502,1,'2008-05-16 18:48:52',3310491490,3),(64798329,425189504,15239476,461502,1,'2008-05-16 18:43:30',3310491490,2),(64798331,425192035,15237588,461502,1,'2008-05-16 18:43:30',3310491490,2),(64798333,425193363,15236987,461502,1,'2008-05-16 18:43:30',3310491490,2),(64798335,425196210,15236558,461502,1,'2008-05-16 18:40:59',3310491490,2),(64798336,425177105,15254497,461502,1,'2008-05-16 18:45:35',3310491447,2),(64798337,425178433,15253038,461502,1,'2008-05-16 18:45:35',3310491490,2),(64798339,425180516,15251117,104599,1,'2007-10-11 20:28:41',3310491490,1),(64798342,425181850,15249261,461502,1,'2008-05-16 18:44:26',3310491490,2),(64798343,425183305,15247373,461502,1,'2008-05-16 18:44:26',3310491490,2),(64798344,425184570,15245485,461502,1,'2008-05-16 18:44:26',3310491490,2),(64798345,425186341,15242652,461502,1,'2008-05-16 18:48:52',3310491490,3),(64798347,425187290,15240850,461502,1,'2008-05-16 18:48:52',3310491490,3),(64798350,425188302,15239047,461502,1,'2008-05-16 18:48:52',3310491490,3),(64798351,425189568,15238017,461502,1,'2008-05-16 18:43:30',3310491490,2),(64798352,425190327,15237502,461502,1,'2008-05-16 18:43:30',3310491490,2),(64801605,425191086,15236902,461502,1,'2008-05-16 18:43:30',3310491490,2),(64801639,425192161,15236301,461502,1,'2008-05-16 18:43:30',3310491490,2),(64801640,425193110,15235786,461502,1,'2008-05-16 18:43:30',3310491490,2),(64801644,425194565,15235442,461502,1,'2008-05-16 18:43:30',3310491490,2),(64801645,425196337,15235271,461502,1,'2008-05-16 18:40:59',3310491490,2),(64801646,425198108,15234756,461502,1,'2008-05-16 18:40:59',3310491490,2),(64801648,425200196,15234327,461502,1,'2008-05-16 18:40:59',3310491490,2),(64801651,425202093,15233983,461502,1,'2008-05-16 18:40:59',3310491490,2),(64801652,425203106,15233640,461502,1,'2008-05-16 18:40:59',3310491490,2),(64801654,425203928,15232868,461502,1,'2008-05-16 18:40:59',3310491490,2),(64801657,425205003,15232095,461502,1,'2008-05-16 18:40:59',3310491491,2),(64801659,425205912,15231953,104599,1,'2007-10-11 20:34:37',3310491491,1),(64801660,425207470,15231065,461502,1,'2008-05-16 18:38:58',3310491491,2),(64801663,425209558,15230636,461502,1,'2008-05-16 18:38:58',3310491491,2),(64801667,425210760,15229778,461502,1,'2008-05-16 18:38:58',3310491491,2),(64801670,425212238,15228480,104599,1,'2007-10-11 20:34:41',3310491491,1),(64801672,425213018,15227161,104599,1,'2007-10-11 20:34:41',3310491491,1),(64801673,425214391,15224577,104599,1,'2007-10-11 20:34:41',3310491491,1),(64801675,425215414,15222235,104599,1,'2007-10-11 20:34:41',3310491491,1),(64801678,425217110,15220486,104599,1,'2007-10-11 20:34:41',3310491491,1),(64801679,425198298,15235957,461502,1,'2008-05-16 18:40:59',3310491490,2),(64801681,425200702,15235786,461502,1,'2008-05-16 18:40:59',3310491490,2),(64801684,425202144,15235344,104599,1,'2007-10-11 20:34:42',3310491490,1),(64801685,425204001,15234133,104599,1,'2007-10-11 20:34:42',3310491490,1),(64801686,425205347,15232975,104599,1,'2007-10-11 20:34:42',3310491491,1),(64801688,425207204,15232356,104599,1,'2007-10-11 20:34:42',3310491491,1),(64801690,425207446,15232222,104599,1,'2007-10-11 20:34:42',3310491491,1),(64801693,425208989,15231752,461502,1,'2008-05-16 18:38:58',3310491491,2),(64801694,425211076,15230893,461502,1,'2008-05-16 18:38:58',3310491491,2),(64801695,425211969,15230041,104599,1,'2007-10-11 20:34:42',3310491491,1),(64801697,425213503,15228319,104599,1,'2007-10-11 20:34:42',3310491491,1),(64801702,425214176,15226542,104599,1,'2007-10-11 20:34:42',3310491491,1),(64801703,425215226,15224227,104599,1,'2007-10-11 20:34:43',3310491491,1),(64801704,425215683,15223447,104599,1,'2007-10-11 20:34:43',3310491491,1),(64801705,425216921,15221374,104599,1,'2007-10-11 20:34:43',3310491491,1),(64801709,425217487,15220889,104599,1,'2007-10-11 20:34:43',3310491491,1),(64801710,425218563,15220997,104599,1,'2007-10-11 20:34:43',3310491491,1),(64801711,425220017,15219974,104599,1,'2007-10-11 20:34:43',3310491491,1),(64801712,425221794,15218521,104599,1,'2007-10-11 20:34:43',3310491491,1),(64801714,425222978,15218117,104599,1,'2007-10-11 20:34:43',3310491491,1),(64801717,425224243,15217686,104599,1,'2007-10-11 20:34:43',3310491491,1),(64801718,425225499,15217246,461502,1,'2008-05-16 18:37:37',3310491491,2),(64801719,425227144,15216388,461502,1,'2008-05-16 18:37:37',3310491491,2),(64801721,425229485,15215186,461502,1,'2008-05-16 18:37:37',3310491489,2),(64801724,425232964,15213384,461502,1,'2008-05-16 18:37:37',3310491492,2),(64801725,425236000,15211238,461502,1,'2008-05-16 18:37:37',3310491492,2),(64801729,425219479,15218628,104599,1,'2007-10-11 20:34:44',3310491491,1),(64801739,425221363,15217013,104599,1,'2007-10-11 20:34:45',3310491491,1),(64801740,425222526,15216646,461502,1,'2008-05-16 18:37:37',3310491491,2),(64801741,425223222,15216560,461502,1,'2008-05-16 18:37:37',3310491491,2),(64801745,425225246,15216131,461502,1,'2008-05-16 18:37:37',3310491489,2),(64801746,425227966,15214414,461502,1,'2008-05-16 18:37:37',3310491489,2),(64801747,425230750,15212869,461502,1,'2008-05-16 18:37:37',3310491489,2),(64801748,425233660,15211324,461502,1,'2008-05-16 18:37:37',3310491492,2),(64801751,425235494,15210037,461502,1,'2008-05-16 18:37:37',3310491492,2),(64801753,425236443,15208921,461502,1,'2008-05-16 18:37:37',3310491492,2),(64801754,425237514,15207296,104599,1,'2007-10-11 20:34:46',3310491492,1),(64801758,425239258,15205576,104599,1,'2007-10-11 20:34:46',3310491492,1),(64801759,425241470,15204825,104599,1,'2007-10-11 20:34:46',3310491492,1),(64801761,425243999,15204588,104599,1,'2007-10-11 20:34:46',3310491492,1),(64801762,425245935,15205062,104599,1,'2007-10-11 20:34:46',3310491492,1),(64801766,425249885,15207511,104599,1,'2007-10-11 20:34:46',3310491492,1),(64801770,425253441,15209131,104599,1,'2007-10-11 20:34:48',3310491492,1),(64801773,425237796,15208934,104599,1,'2007-10-11 20:34:48',3310491492,1),(64801774,425238784,15207709,104599,1,'2007-10-11 20:34:49',3310491492,1),(64801778,425240483,15206129,104599,1,'2007-10-11 20:34:50',3310491492,1),(64801779,425243209,15205259,104599,1,'2007-10-11 20:34:50',3310491492,1),(64801780,425244987,15206089,104599,1,'2007-10-11 20:34:50',3310491492,1),(64801785,425247950,15207906,104599,1,'2007-10-11 20:34:50',3310491492,1),(64801795,425250912,15209447,104599,1,'2007-10-11 20:34:52',3310491492,1),(64801802,425253520,15210435,104599,1,'2007-10-11 20:34:52',3310491492,1),(64801803,425256443,15210909,104599,1,'2007-10-11 20:34:53',3310491492,1),(64801804,425258972,15210672,104599,1,'2007-10-11 20:34:53',3310491492,1),(64801805,425262290,15209566,104599,1,'2007-10-11 20:34:53',3310491493,1),(64801809,425255416,15209763,104599,1,'2007-10-11 20:34:54',3310491492,1),(64801810,425257589,15209645,104599,1,'2007-10-11 20:34:54',3310491492,1),(64801811,425260236,15209052,104599,1,'2007-10-11 20:34:54',3310491493,1),(64801812,425264029,15207985,104599,1,'2007-10-11 20:34:54',3310491493,1),(64801816,425268493,15207235,104599,1,'2007-10-11 20:34:54',3310491493,1),(64801817,425272127,15207156,104599,1,'2007-10-11 20:34:54',3310491493,1),(64801818,425274695,15207788,104599,1,'2007-10-11 20:34:54',3310491493,1),(64801819,425276671,15209882,104599,1,'2007-10-11 20:34:54',3310491493,1),(64803147,425278465,15210401,104599,1,'2007-10-11 20:37:49',3310491493,1),(64803150,425280929,15210715,104599,1,'2007-10-11 20:37:49',3310491493,1),(64803152,425283079,15211292,104599,1,'2007-10-11 20:37:49',3310491493,1),(64803153,425284547,15212498,104599,1,'2007-10-11 20:37:49',3310491493,1),(64803154,425285386,15213232,104599,1,'2007-10-11 20:37:49',3310491493,1),(64803157,425287588,15214490,104599,1,'2007-10-11 20:37:49',3310491504,1),(64803159,425288793,15214805,104599,1,'2007-10-11 20:37:49',3310491504,1),(64803160,425289265,15215434,104599,1,'2007-10-11 20:37:49',3310491504,1),(64803161,425291362,15217898,104599,1,'2007-10-11 20:37:50',3310491506,1),(64803162,425292254,15218580,104599,1,'2007-10-11 20:37:50',3310491506,1),(64803165,425294613,15218632,104599,1,'2007-10-11 20:37:50',3310491506,1),(64803167,425297130,15217950,104599,1,'2007-10-11 20:37:50',3310491506,1),(64803168,425290542,15216407,104599,1,'2007-10-11 20:37:50',3310491506,1),(64803169,425264994,15208918,104599,1,'2007-10-11 20:37:50',3310491493,1),(64803172,425268451,15208080,104599,1,'2007-10-11 20:37:50',3310491493,1),(64803174,425271372,15207865,104599,1,'2007-10-11 20:37:50',3310491493,1),(64803175,425273992,15208230,104599,1,'2007-10-11 20:37:50',3310491493,1),(64803176,425275259,15209626,104599,1,'2007-10-11 20:37:50',3310491493,1),(64803177,425276719,15211108,104599,1,'2007-10-11 20:37:50',3310491493,1),(64803180,425278695,15211602,104599,1,'2007-10-11 20:37:50',3310491493,1),(64803182,425280992,15211774,104599,1,'2007-10-11 20:37:50',3310491493,1),(64803183,425283054,15212289,104599,1,'2007-10-11 20:37:50',3310491493,1),(64803184,425284557,15213492,104599,1,'2007-10-11 20:37:51',3310491493,1),(64803185,425286189,15215210,104599,1,'2007-10-11 20:37:51',3310491493,1),(64803188,425287993,15215918,104599,1,'2007-10-11 20:37:51',3310491504,1),(64803190,425289411,15216541,104599,1,'2007-10-11 20:37:51',3310491506,1),(64803191,425290742,15217830,104599,1,'2007-10-11 20:37:51',3310491506,1),(64803192,425291558,15219591,104599,1,'2007-10-11 20:37:51',3310491506,1),(64803195,425292610,15220192,104599,1,'2007-10-11 20:37:51',3310491506,1),(64803197,425294908,15220213,104599,1,'2007-10-11 20:37:51',3310491506,1),(64803198,425296003,15219698,104599,1,'2007-10-11 20:37:51',3310491506,1),(64803199,425297249,15218517,104599,1,'2007-10-11 20:37:51',3310491506,1),(64840709,425298921,15215927,104599,1,'2007-10-11 21:16:14',3310491504,1),(64840717,425300252,15214684,104599,1,'2007-10-11 21:16:14',3310491504,1),(64840721,425301628,15214574,104599,1,'2007-10-11 21:16:14',3310491504,1),(64840726,425303269,15213997,104599,1,'2007-10-11 21:16:14',3310491504,1),(64840730,425305577,15213065,104599,1,'2007-10-11 21:16:15',3310491504,1),(64840732,425306486,15212133,104599,1,'2007-10-11 21:16:15',3310491504,1),(64840738,425308417,15210669,104599,1,'2007-10-11 21:16:15',3310491504,1),(64840741,425309850,15209532,104599,1,'2007-10-11 21:16:15',3310491504,1),(64840744,425312661,15208126,104599,1,'2007-10-11 21:16:15',3310491504,1),(64840746,425315441,15207519,104599,1,'2007-10-11 21:16:15',3310491505,1),(64840750,425316686,15207551,104599,1,'2007-10-11 21:16:15',3310491505,1),(64840753,425320456,15209436,104599,1,'2007-10-11 21:16:15',3310491505,1),(64840755,425323747,15211609,104599,1,'2007-10-11 21:16:15',3310491505,1),(64840758,425325600,15212184,104599,1,'2007-10-11 21:16:15',3310491505,1),(64840759,425327836,15211864,104599,1,'2007-10-11 21:16:15',3310491505,1),(64840761,425330200,15210139,104599,1,'2007-10-11 21:16:15',3310491505,1),(64840762,425333906,15206465,104599,1,'2007-10-11 21:16:15',3310491505,1),(64840767,425334545,15205347,104599,1,'2007-10-11 21:16:15',3310491505,1),(64840769,425336206,15204996,104599,1,'2007-10-11 21:16:16',3310491505,1),(64840773,425338091,15205922,104599,1,'2007-10-11 21:16:16',3310491505,1),(64840778,425340104,15207264,104599,1,'2007-10-11 21:16:16',3310491505,1),(64840781,425299978,15215985,104599,1,'2007-10-11 21:16:16',3310491504,1),(64840785,425301543,15215251,104599,1,'2007-10-11 21:16:16',3310491504,1),(64840790,425303205,15215251,104599,1,'2007-10-11 21:16:16',3310491504,1),(64840792,425304451,15214899,104599,1,'2007-10-11 21:16:16',3310491504,1),(64840793,425307294,15213110,104599,1,'2007-10-11 21:16:16',3310491504,1),(64840797,425309530,15211002,104599,1,'2007-10-11 21:16:16',3310491504,1),(64840799,425312469,15209756,104599,1,'2007-10-11 21:16:16',3310491504,1),(64840802,425315121,15208829,104599,1,'2007-10-11 21:16:16',3310491505,1),(64840806,425316974,15208638,104599,1,'2007-10-11 21:16:16',3310491505,1),(64840812,425319051,15209660,104599,1,'2007-10-11 21:16:16',3310491505,1),(64840816,425322437,15212088,104599,1,'2007-10-11 21:16:17',3310491505,1),(64840820,425324993,15213206,104599,1,'2007-10-11 21:16:17',3310491505,1),(64840823,425326814,15213110,104599,1,'2007-10-11 21:16:17',3310491505,1),(64840828,425328315,15212759,104599,1,'2007-10-11 21:16:17',3310491505,1),(64840832,425330200,15210906,104599,1,'2007-10-11 21:16:17',3310491505,1),(64840836,425332980,15208414,104599,1,'2007-10-11 21:16:17',3310491505,1),(64840839,425335280,15205986,104599,1,'2007-10-11 21:16:17',3310491505,1),(64840843,425336494,15205762,104599,1,'2007-10-11 21:16:17',3310491505,1),(64840848,425338027,15206561,104599,1,'2007-10-11 21:16:17',3310491505,1),(64840849,425340040,15207743,104599,1,'2007-10-11 21:16:17',3310491505,1),(64840854,425343871,15209679,104599,1,'2007-10-11 21:16:17',3310491508,1),(64840858,425345437,15211839,104599,1,'2007-10-11 21:16:18',3310491508,1),(64840861,425346410,15214972,104599,1,'2007-10-11 21:16:18',3310491508,1),(64840865,425347004,15217079,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840868,425348462,15219888,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840872,425349921,15221508,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840877,425352621,15222750,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840882,425354026,15223182,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840886,425355808,15224641,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840890,425358833,15227288,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840895,425361426,15229826,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840899,425363046,15229880,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840903,425363424,15229016,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840907,425363694,15227720,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840911,425365801,15223885,104599,1,'2007-10-11 21:16:18',3310491510,1),(64840916,425368070,15222210,104599,1,'2007-10-11 21:16:19',3310491510,1),(64840918,425343021,15209781,104599,1,'2007-10-11 21:16:19',3310491508,1),(64840922,425344930,15211717,104599,1,'2007-10-11 21:16:19',3310491508,1),(64840923,425345621,15213929,104599,1,'2007-10-11 21:16:19',3310491508,1),(64840926,425346036,15216888,104599,1,'2007-10-11 21:16:19',3310491510,1),(64840929,425347585,15220235,104599,1,'2007-10-11 21:16:19',3310491510,1),(64840932,425348552,15222087,104599,1,'2007-10-11 21:16:19',3310491510,1),(64840933,425350295,15223691,104599,1,'2007-10-11 21:16:19',3310491510,1),(64840934,425353724,15224853,104599,1,'2007-10-11 21:16:19',3310491510,1),(64840936,425355632,15225959,104599,1,'2007-10-11 21:16:19',3310491510,1),(64840940,425357845,15227785,104599,1,'2007-10-11 21:16:19',3310491510,1),(64840946,425359790,15230538,104599,1,'2007-10-11 21:16:19',3310491510,1),(64840950,425362080,15231560,104599,1,'2007-10-11 21:16:19',3310491510,1),(64840954,425363102,15230961,104599,1,'2007-10-11 21:16:19',3310491510,1),(64840959,425364264,15228847,104599,1,'2007-10-11 21:16:20',3310491510,1),(64840961,425365568,15226839,104599,1,'2007-10-11 21:16:20',3310491510,1),(64840965,425367647,15224020,104599,1,'2007-10-11 21:16:20',3310491510,1),(64840968,425368669,15222998,104599,1,'2007-10-11 21:16:20',3310491510,1),(64840971,425370392,15220659,104599,1,'2007-10-11 21:16:20',3310491511,1),(64840975,425372679,15220326,104599,1,'2007-10-11 21:16:20',3310491511,1),(64840979,425374681,15219659,104599,1,'2007-10-11 21:16:20',3310491511,1),(64840982,425376301,15217991,104599,1,'2007-10-11 21:16:20',3310491511,1),(64840985,425378255,15214941,104599,1,'2007-10-11 21:16:20',3310491509,1),(64840987,425381973,15210508,104599,1,'2007-10-11 21:16:20',3310491509,1),(64840992,425383545,15209269,104599,1,'2007-10-11 21:16:20',3310491509,1),(64840996,425386119,15207935,104599,1,'2007-10-11 21:16:20',3310491509,1),(64840997,425388264,15207172,104599,1,'2007-10-11 21:16:20',3310491509,1),(64840998,425389360,15207554,104599,1,'2007-10-11 21:16:20',3310491509,1),(64841000,425392505,15207506,104599,1,'2007-10-11 21:16:21',3310491509,1),(64841005,425395746,15207506,104599,1,'2007-10-11 21:16:21',3310491509,1),(64841007,425397319,15208602,104599,1,'2007-10-11 21:16:21',3310502432,1),(64841008,425399320,15209793,104599,1,'2007-10-11 21:16:21',3310502432,1),(64841013,425401608,15209936,104599,1,'2007-10-11 21:16:21',3310502432,1),(64841018,425402656,15209793,104599,1,'2007-10-11 21:16:21',3310502432,1),(64841023,425405182,15207887,104599,1,'2007-10-11 21:16:21',3310502432,1),(64841026,425406802,15206696,104599,1,'2007-10-11 21:16:21',3310502432,1),(64841028,425407660,15205457,104599,1,'2007-10-11 21:16:21',3310502432,1),(64841033,425369963,15222042,104599,1,'2007-10-11 21:16:21',3310491511,1),(64841037,425372251,15221613,104599,1,'2007-10-11 21:16:21',3310491511,1),(64841039,425375587,15220659,104599,1,'2007-10-11 21:16:21',3310491511,1),(64841042,425377207,15218658,104599,1,'2007-10-11 21:16:21',3310491511,1),(64841046,425379876,15214655,104599,1,'2007-10-11 21:16:22',3310491509,1),(64841049,425383021,15211080,104599,1,'2007-10-11 21:16:22',3310491509,1),(64841051,425384975,15209651,104599,1,'2007-10-11 21:16:22',3310491509,1),(64841053,425386167,15208936,104599,1,'2007-10-11 21:16:22',3310491509,1),(64841057,425388978,15208507,104599,1,'2007-10-11 21:16:22',3310491509,1),(64841061,425392886,15208602,104599,1,'2007-10-11 21:16:22',3310491509,1),(64841066,425395698,15208888,104599,1,'2007-10-11 21:16:22',3310491509,1),(64841070,425397128,15209889,104599,1,'2007-10-11 21:16:22',3310502432,1),(64841074,425399749,15211271,104599,1,'2007-10-11 21:16:22',3310502432,1),(64841080,425401369,15211509,104599,1,'2007-10-11 21:16:22',3310502432,1),(64841084,425403180,15211509,104599,1,'2007-10-11 21:16:22',3310502432,1),(64841088,425405134,15210032,104599,1,'2007-10-11 21:16:22',3310502432,1),(64841091,425407279,15207697,104599,1,'2007-10-11 21:16:22',3310502432,1),(64841092,425408232,15206505,104599,1,'2007-10-11 21:16:22',3310502432,1),(64841094,425409270,15203779,104599,1,'2007-10-11 21:16:23',3310502432,1),(64841097,425410322,15201998,104599,1,'2007-10-11 21:16:23',3310502432,1),(64841099,425412710,15199853,104599,1,'2007-10-11 21:16:23',3310502432,1),(64841100,425415018,15196574,104599,1,'2007-10-11 21:16:23',3310502432,1),(64841101,425418094,15192445,104599,1,'2007-10-11 21:16:23',3310502432,1),(64841105,425420523,15188802,104599,1,'2007-10-11 21:16:23',3310502432,1),(64841106,425422304,15186373,104599,1,'2007-10-11 21:16:23',3310502432,1),(64841108,425423963,15185442,104599,1,'2007-10-11 21:16:23',3310502432,1),(64841109,425425258,15185442,104599,1,'2007-10-11 21:16:23',3310502433,1),(64841113,425428659,15185240,104599,1,'2007-10-11 21:16:23',3310502433,1),(64841115,425430359,15185078,104599,1,'2007-10-11 21:16:23',3310502433,1),(64841118,425432423,15183742,104599,1,'2007-10-11 21:16:23',3310502433,1),(64841119,425435216,15180828,104599,1,'2007-10-11 21:16:23',3310502433,1),(64841120,425437361,15177671,104599,1,'2007-10-11 21:16:24',3310502433,1),(64841123,425439345,15175728,104599,1,'2007-10-11 21:16:24',3310502433,1),(64841125,425441085,15175566,104599,1,'2007-10-11 21:16:24',3310502433,1),(64841128,425442057,15175242,104599,1,'2007-10-11 21:16:24',3310502433,1),(64841129,425443433,15174271,104599,1,'2007-10-11 21:16:24',3310502433,1),(64841132,425445295,15173178,104599,1,'2007-10-11 21:16:24',3310502433,1),(64841134,425446590,15172328,104599,1,'2007-10-11 21:16:24',3310502433,1),(64841136,425448209,15170304,104599,1,'2007-10-11 21:16:24',3310502433,1),(64841139,425449262,15169049,104599,1,'2007-10-11 21:16:24',3310502433,1);
INSERT INTO `nodes` VALUES (64841145,425450881,15167551,104599,1,'2007-10-11 21:16:24',3310502433,1),(64841148,425409909,15204469,104599,1,'2007-10-11 21:16:24',3310502432,1),(64841151,425412760,15201425,104599,1,'2007-10-11 21:16:25',3310502432,1),(64841154,425414593,15199362,104599,1,'2007-10-11 21:16:25',3310502432,1),(64841158,425416914,15196296,104599,1,'2007-10-11 21:16:25',3310502432,1),(64841162,425419550,15192601,104599,1,'2007-10-11 21:16:25',3310502432,1),(64841165,425421613,15189363,104599,1,'2007-10-11 21:16:25',3310502432,1),(64841166,425423274,15187186,104599,1,'2007-10-11 21:16:25',3310502432,1),(64841169,425424306,15186441,104599,1,'2007-10-11 21:16:25',3310502432,1),(64841177,425426168,15186326,104599,1,'2007-10-11 21:16:25',3310502433,1),(64841180,425428202,15186670,104599,1,'2007-10-11 21:16:25',3310502433,1),(64841183,425429864,15186641,104599,1,'2007-10-11 21:16:25',3310502433,1),(64841185,425432671,15184779,104599,1,'2007-10-11 21:16:25',3310502433,1),(64841188,425436482,15180940,104599,1,'2007-10-11 21:16:25',3310502433,1),(64841191,425439003,15178046,104599,1,'2007-10-11 21:16:25',3310502433,1),(64841194,425441381,15176557,104599,1,'2007-10-11 21:16:25',3310502433,1),(64841197,425443386,15175840,104599,1,'2007-10-11 21:16:26',3310502433,1),(64841198,425444876,15174981,104599,1,'2007-10-11 21:16:26',3310502433,1),(64841202,425446337,15173950,104599,1,'2007-10-11 21:16:26',3310502433,1),(64841205,425447856,15172947,104599,1,'2007-10-11 21:16:26',3310502433,1),(64841208,425449174,15171142,104599,1,'2007-10-11 21:16:26',3310502433,1),(64841211,425450893,15169452,104599,1,'2007-10-11 21:16:26',3310502433,1),(64841215,425453643,15166300,104599,1,'2007-10-11 21:16:26',3310502436,1),(64841220,425456737,15162977,104599,1,'2007-10-11 21:16:26',3310502436,1),(64841224,425458084,15160484,104599,1,'2007-10-11 21:16:26',3310502414,1),(64841229,425458571,15158622,104599,1,'2007-10-11 21:16:26',3310502414,1),(64841233,425453029,15165631,104599,1,'2007-10-11 21:16:26',3310502436,1),(64841236,425454412,15164005,104599,1,'2007-10-11 21:16:26',3310502436,1),(64841238,425455608,15162211,104599,1,'2007-10-11 21:16:26',3310502436,1),(64841243,425457141,15159632,104599,1,'2007-10-11 21:16:26',3310502414,1),(64841245,425458262,15157651,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841248,425460267,15155052,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841254,425461924,15154366,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841257,425463696,15154309,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841260,425464696,15153566,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841263,425465610,15150738,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841266,425467010,15147309,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841268,425468724,15144195,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841271,425469724,15142738,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841274,425471210,15141909,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841278,425472924,15140909,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841281,425474638,15139424,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841282,425476524,15137366,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841286,425477410,15135509,104599,1,'2007-10-11 21:16:27',3310502414,1),(64841290,425460290,15156192,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841293,425461210,15155509,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841297,425463051,15155242,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841301,425464386,15154975,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841307,425465425,15154025,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841311,425466078,15152096,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841315,425466612,15149900,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841316,425467473,15147882,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841319,425468719,15145210,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841321,425470292,15143252,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841324,425472044,15142450,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841329,425473795,15141293,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841333,425475190,15139512,104599,1,'2007-10-11 21:16:28',3310502414,1),(64841337,425476881,15137434,104599,1,'2007-10-11 21:16:29',3310502414,1),(64841341,425477772,15135624,104599,1,'2007-10-11 21:16:29',3310502414,1),(64841344,425447439,15184979,104599,1,'2007-10-11 21:16:29',3310502433,1),(64841346,425446094,15181328,104599,1,'2007-10-11 21:16:29',3310502433,1),(64841351,425445325,15179070,104599,1,'2007-10-11 21:16:29',3310502433,1),(64841356,425444541,15177516,104599,1,'2007-10-11 21:16:29',3310502433,1),(64841360,425443110,15177472,104599,1,'2007-10-11 21:16:29',3310502433,1),(64841365,425444577,15179561,263367,1,'2008-04-26 15:44:04',3310502433,2),(64841367,425446094,15183423,263367,1,'2008-04-26 15:44:04',3310502433,2),(64841370,425447513,15187434,104599,1,'2007-10-11 21:16:29',3310502433,1),(64841373,425449066,15190719,263367,1,'2008-04-26 15:44:04',3310502433,2),(64841375,425450046,15193190,104599,1,'2007-10-11 21:16:29',3310502433,1),(64841376,425450415,15196806,104599,1,'2007-10-11 21:16:29',3310502433,1),(64841379,425451055,15198896,104599,1,'2007-10-11 21:16:29',3310502433,1),(64841383,425452752,15201823,104599,1,'2007-10-11 21:16:30',3310502436,1),(64841386,425455416,15204473,513066,1,'2008-05-24 16:09:07',3310502436,3),(64841388,425456323,15207218,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841390,425456811,15210629,104599,1,'2007-10-11 21:16:30',3310502436,1),(64841393,425456934,15211761,104599,1,'2007-10-11 21:16:30',3310502436,1),(64841396,425457398,15212969,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841399,425458473,15214256,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841407,425460749,15215115,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841415,425449157,15188241,104599,1,'2007-10-11 21:16:30',3310502433,1),(64841424,425450347,15190408,104599,1,'2007-10-11 21:16:30',3310502433,1),(64841431,425452781,15198120,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841433,425454362,15201468,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841434,425456680,15204387,513066,1,'2008-05-24 16:09:07',3310502436,4),(64841436,425457275,15208430,104599,1,'2007-10-11 21:16:31',3310502436,1),(64841439,425458093,15210995,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841441,425458473,15212111,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841444,425459168,15212711,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841446,425460559,15213398,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841451,425463089,15216059,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841452,425464606,15216402,498434,1,'2008-05-22 19:52:51',3310502438,2),(64841454,425466503,15216230,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841456,425467901,15215911,104599,1,'2007-10-11 21:16:31',3310502436,1),(64841461,425469389,15216463,104599,1,'2007-10-11 21:16:31',3310502438,1),(64841463,425471056,15218290,498434,1,'2008-05-22 19:52:51',3310502438,2),(64841468,425472953,15219664,498434,1,'2008-05-22 19:52:51',3310502438,2),(64841472,425474319,15220841,104599,1,'2007-10-11 21:16:31',3310502438,1),(64841473,425475679,15221138,104599,1,'2007-10-11 21:16:31',3310502438,1),(64841478,425477847,15223816,104599,1,'2007-10-11 21:16:32',3310502438,1),(64841481,425480440,15225941,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841483,425481715,15228109,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841487,425482796,15231510,513066,1,'2008-05-24 16:05:33',3310502439,2),(64841488,425483075,15232785,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841491,425483118,15233847,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841497,425484265,15236057,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841499,425485625,15237800,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841502,425486985,15238480,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841507,425488473,15238990,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841511,425490216,15238778,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841514,425491278,15238565,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841518,425494041,15238183,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841521,425495104,15238310,104599,1,'2007-10-11 21:16:32',3310502439,1),(64841525,425495741,15239288,104599,1,'2007-10-11 21:16:33',3310502439,1),(64841529,425462836,15214171,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841532,425464164,15214686,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841537,425465808,15214771,498434,1,'2008-05-22 19:52:51',3310502436,2),(64841541,425467264,15214890,104599,1,'2007-10-11 21:16:33',3310502436,1),(64841547,425467944,15214805,104599,1,'2007-10-11 21:16:33',3310502436,1),(64841550,425469431,15215358,104599,1,'2007-10-11 21:16:33',3310502436,1),(64841551,425471429,15217186,104599,1,'2007-10-11 21:16:33',3310502438,1),(64841553,425472662,15218376,104599,1,'2007-10-11 21:16:33',3310502438,1),(64841557,425473894,15218886,104599,1,'2007-10-11 21:16:33',3310502438,1),(64841561,425475212,15219778,104599,1,'2007-10-11 21:16:33',3310502438,1),(64841566,425476997,15221436,104599,1,'2007-10-11 21:16:33',3310502438,1),(64841570,425479250,15223476,104599,1,'2007-10-11 21:16:33',3310502438,1),(64841573,425480907,15225091,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841579,425482140,15227302,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841582,425482480,15228248,513066,1,'2008-05-24 16:05:33',3310502439,2),(64841584,425482735,15229257,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841587,425483925,15232615,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841591,425485200,15235250,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841597,425486730,15236567,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841600,425488261,15236907,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841603,425490896,15237162,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841606,425493191,15236865,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841612,425494849,15236907,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841617,425496825,15239084,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841620,425498413,15241611,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841623,425500615,15244607,104599,1,'2007-10-11 21:16:34',3310502439,1),(64841627,425504445,15248009,183661,1,'2008-04-18 18:37:07',3310502439,2),(64841630,425508774,15252946,104599,1,'2007-10-11 21:16:35',3310502450,1),(64841635,425511084,15253931,183661,1,'2008-04-18 18:37:07',3310502450,2),(64841638,425497944,15243380,104599,1,'2007-10-11 21:16:35',3310502439,1),(64841640,425500182,15245329,104599,1,'2007-10-11 21:16:35',3310502439,1),(64841645,425503142,15248325,104599,1,'2007-10-11 21:16:35',3310502439,1),(64841649,425504117,15249517,104599,1,'2007-10-11 21:16:35',3310502439,1),(64841652,425505778,15251538,104599,1,'2007-10-11 21:16:35',3310502439,1),(64841654,425508846,15254174,104599,1,'2007-10-11 21:16:35',3310502450,1),(64954372,424826042,14641485,312325,1,'2009-04-07 23:03:07',3310490829,4),(64954377,424536046,14934515,312325,1,'2009-04-07 23:03:08',3310490794,6),(64954382,424380788,14944340,312325,1,'2009-04-07 23:03:09',3310490436,5),(64954385,424684764,14988114,312325,1,'2009-04-07 23:03:09',3310491156,6),(64954389,425343610,15254826,327248,1,'2009-04-08 23:21:24',3310491510,7),(64954396,425168287,15413834,312325,1,'2009-04-07 23:03:11',3310491541,6),(64954400,424836288,14566808,312325,1,'2009-04-07 23:03:11',3310490823,5),(64954404,425800293,16519056,312325,1,'2009-04-07 23:03:12',3310504180,7),(64954409,425614772,15944268,312325,1,'2009-04-07 23:03:12',3310503965,6),(64954415,425338717,15156270,312325,1,'2009-04-07 23:03:13',3310491483,5),(64954417,425824623,16316773,312325,1,'2009-04-07 23:03:13',3310504151,5),(64954422,425795551,16278149,312325,1,'2009-04-07 23:03:14',3310504148,6),(64954429,425831185,16499828,312325,1,'2009-04-07 23:03:14',3310504181,6),(64954433,425667074,15980302,312325,1,'2009-04-07 23:03:15',3310504009,6),(64954435,425649323,15274027,312325,1,'2009-04-07 23:03:15',3310502505,8),(64954441,425710971,16163247,312325,1,'2009-04-07 23:03:16',3310504045,5),(64954447,425439332,15230016,312325,1,'2009-04-07 23:03:16',3310502435,7),(64954451,426188902,15413399,312325,1,'2009-04-07 23:03:17',3310502864,5),(64954457,425812936,16351458,312325,1,'2009-04-07 23:03:18',3310504151,7),(64954460,425476987,15155550,312325,1,'2009-04-07 23:03:18',3310502414,7),(64954464,425318538,15666248,312325,1,'2009-04-07 23:03:18',3310491635,5),(64954467,425617130,14968902,312325,1,'2009-04-07 23:03:19',3310502464,6),(64954472,425690218,15221532,312325,1,'2009-04-07 23:03:19',3310502502,8),(64954477,425135389,15382077,312325,1,'2009-04-07 23:03:19',3310491540,5),(64954483,425720821,14844029,312325,1,'2009-04-07 23:03:20',3310502125,6),(64954486,424666593,14920555,312325,1,'2009-04-07 23:03:20',3310490811,7),(64954492,425385245,15844704,312325,1,'2009-04-07 23:03:21',3310493013,5),(64954503,425659682,14921134,312325,1,'2009-04-07 23:03:21',3310502123,4),(64954508,424537756,14631361,312325,1,'2009-04-07 23:03:21',3310490760,6),(64954512,425009937,15084001,312325,1,'2009-04-07 23:03:22',3310491401,6),(64954515,425465557,14755512,312325,1,'2009-04-07 23:03:22',3310502052,6),(64954521,425535743,14862801,312325,1,'2009-04-07 23:03:23',3310502073,6),(64954525,424765348,14914551,312325,1,'2009-04-07 23:03:23',3310490858,5),(64954531,425962642,15261846,2191272,1,'2009-08-18 19:32:39',3310502706,6),(64954538,425769444,16671670,312325,1,'2009-04-07 23:03:24',3310504187,7),(64954542,425707740,14930380,312325,1,'2009-04-07 23:03:25',3310502127,5),(64954546,425755678,15193446,312325,1,'2009-04-07 23:03:25',3310502513,8),(64954554,424727815,15116860,312325,1,'2009-04-07 23:03:26',3310491167,5),(64954560,425825312,15180695,312325,1,'2009-04-07 23:03:26',3310502517,8),(64954563,425442014,15163754,312325,1,'2009-04-07 23:03:26',3310502433,8),(64954565,425468617,15089987,312325,1,'2009-04-07 23:03:28',3310502412,9),(64954570,425570637,15380568,312325,1,'2009-04-07 23:03:28',3310502462,6),(64954584,425337179,15812088,312325,1,'2009-04-07 23:03:29',3310491643,4),(64954589,425090019,15404067,312325,1,'2009-04-07 23:03:29',3310491536,7),(64954593,424627768,15017489,312325,1,'2009-04-07 23:03:30',3310491143,7),(64954598,424760101,15080811,312325,1,'2009-04-07 23:03:30',3310491208,6),(64954601,425526636,15898923,312325,1,'2009-04-07 23:03:31',3310503954,6),(144217502,424392304,14766835,653218,1,'2007-11-30 17:53:23',3310490085,2),(144217504,424408520,14774560,653218,1,'2007-11-30 17:53:23',3310490096,2),(144217505,424416944,14781856,653218,1,'2007-11-30 17:53:23',3310490098,2),(144217506,424420871,14789580,653218,1,'2007-11-30 17:53:23',3310490098,2),(144217507,424425812,14794559,653218,1,'2007-11-30 17:53:23',3310490098,2),(144217508,424429739,14797992,653218,1,'2007-11-30 17:53:23',3310490098,2),(144217510,424444433,14813871,653218,1,'2007-11-30 17:53:23',3310490099,2),(144217512,424452033,14817905,653218,1,'2007-11-30 17:53:23',3310490099,2),(144217513,424460647,14820737,653218,1,'2007-11-30 17:53:23',3310490099,2),(144217514,424475974,14820308,653218,1,'2007-11-30 17:53:23',3310490102,2),(144217515,424480281,14821767,653218,1,'2007-11-30 17:53:23',3310490102,2),(144217517,424482814,14822883,653218,1,'2007-11-30 17:53:23',3310490102,2),(144217519,424489591,14830608,653218,1,'2007-11-30 17:53:23',3310490102,2),(148874198,425407167,15732033,5077512,1,'2010-06-26 01:37:05',3310502568,48),(206330752,425400605,17212856,206510,1,'2008-12-06 20:14:04',3310504578,4),(206330773,425401330,17195685,206510,1,'2008-12-06 20:14:09',3310504578,4),(206332846,425402106,17194036,4055320,1,'2010-03-06 23:55:56',3310504578,6),(206333041,425401566,17211208,206510,1,'2008-12-06 20:14:03',3310504578,4),(206333043,425401465,17211757,206510,1,'2008-12-06 20:14:03',3310504578,4),(206333048,425400250,17203400,206510,1,'2008-12-06 20:14:02',3310504578,4),(206333118,425400824,17207338,206510,1,'2008-12-06 20:14:03',3310504578,4),(206333119,425401583,17210200,206510,1,'2008-12-06 20:14:03',3310504578,4),(206333120,425401364,17209353,206510,1,'2008-12-06 20:14:03',3310504578,4),(206333124,425401009,17208094,206510,1,'2008-12-06 20:14:03',3310504578,4),(206333171,425398783,17211986,206510,1,'2008-12-06 20:14:04',3310504578,4),(206333191,425400959,17196898,206510,1,'2008-12-06 20:14:09',3310504578,4),(206333194,425401600,17210590,206510,1,'2008-12-06 20:14:03',3310504578,4),(206333343,425400250,17200058,206510,1,'2008-12-06 20:14:09',3310504578,6),(206333344,425399289,17212559,206510,1,'2008-12-06 20:14:04',3310504578,4),(206333347,425400689,17198020,206510,1,'2008-12-06 20:14:09',3310504578,4),(206333352,425400200,17201592,206510,1,'2008-12-06 20:14:02',3310504578,4),(206333353,425399711,17212787,206510,1,'2008-12-06 20:14:04',3310504578,4),(206333355,425400385,17204934,206510,1,'2008-12-06 20:14:03',3310504578,4),(206333356,425400470,17205759,206510,1,'2008-12-06 20:14:03',3310504578,4),(206333525,425400942,17212604,206510,1,'2008-12-06 20:14:03',3310504578,4),(206333534,425400149,17212925,206510,1,'2008-12-06 20:14:04',3310504578,4),(206333617,425398260,17210979,206510,1,'2008-12-06 20:14:04',3310504578,4),(206333618,425401263,17212169,206510,1,'2008-12-06 20:14:03',3310504578,4),(247045685,425580784,16809907,197512,1,'2008-04-20 03:23:33',3310504476,5),(247045686,425580784,16828753,91631,1,'2008-02-10 16:57:04',3310504476,3),(247045688,425568714,16834488,91631,1,'2008-02-10 16:57:04',3310504476,3),(247045690,425553625,16855791,91631,1,'2008-02-10 16:57:04',3310504473,3),(247045691,425544571,16871359,91631,1,'2008-02-10 16:57:04',3310504475,3),(247045693,425513789,16936908,91631,1,'2008-02-10 16:57:04',3310504496,3),(247045695,425475157,16947559,91631,1,'2008-02-10 16:57:04',3310504484,3),(247045696,425446786,16941824,91631,1,'2008-02-10 16:57:04',3310504481,3),(247045698,425403924,16959030,91631,1,'2008-02-10 16:57:04',3310504480,3),(247045700,425363475,16955753,91631,1,'2008-02-10 16:57:04',3310493556,3),(247045701,425366494,16935269,91631,1,'2008-02-10 16:57:04',3310493556,3),(247045703,425388228,16928714,91631,1,'2008-02-10 16:57:04',3310493557,3),(247045712,425416602,16914785,91631,1,'2008-02-10 16:57:04',3310504458,3),(247045718,425451012,16894301,91631,1,'2008-02-10 16:57:04',3310504459,3),(247045724,425475761,16868901,91631,1,'2008-02-10 16:57:04',3310504462,3),(247045732,425497491,16838585,91631,1,'2008-02-10 16:57:04',3310504461,3),(247045739,425498095,16808269,91631,1,'2008-02-10 16:57:04',3310504455,3),(247045741,425516203,16808269,91631,1,'2008-02-10 16:57:04',3310504466,3),(247045742,425546986,16790243,91631,1,'2008-02-10 16:57:04',3310504467,3),(247045744,425565092,16764023,91631,1,'2008-02-10 16:57:04',3310504470,3),(247046008,424971326,15694847,91631,1,'2008-02-10 16:54:21',3310491554,1),(247046009,424984469,15646465,91631,1,'2008-02-10 16:54:21',3310491552,1),(247046010,424927203,15632459,91631,1,'2008-02-10 16:54:21',3310491380,1),(247046011,424884955,15647738,91631,1,'2008-02-10 16:54:21',3310491377,1),(247046012,424832376,15670656,91631,1,'2008-02-10 16:54:21',3310491367,1),(247046013,424830498,15775059,91631,1,'2008-02-10 16:54:21',3310491375,1),(247046014,424848338,15754688,91631,1,'2008-02-10 16:54:22',3310491384,1),(247046015,424857727,15838720,91631,1,'2008-02-10 16:54:22',3310492752,1),(247046016,424850216,15876916,91631,1,'2008-02-10 16:54:22',3310492754,1),(247046017,424832376,15958401,91631,1,'2008-02-10 16:54:22',3310492749,1),(247046018,424819230,15992778,91631,1,'2008-02-10 16:54:22',3310492750,1),(247046019,424822986,16062805,91631,1,'2008-02-10 16:54:22',3310492773,1),(247046020,424864299,16024608,91631,1,'2008-02-10 16:54:22',3310492762,1),(247046021,424894344,15968587,91631,1,'2008-02-10 16:54:22',3310492761,1),(247046022,424929081,15911293,91631,1,'2008-02-10 16:54:22',3310492758,1),(247046023,424943163,15862911,91631,1,'2008-02-10 16:54:22',3310492757,1),(247046024,424972265,15773786,91631,1,'2008-02-10 16:54:22',3310491562,1),(247046025,424959123,15757234,91631,1,'2008-02-10 16:54:22',3310491560,1),(247046026,424958184,15726677,91631,1,'2008-02-10 16:54:22',3310491560,1),(247046027,424964755,15705033,91631,1,'2008-02-10 16:54:23',3310491554,1),(247046028,425106221,14700816,91631,1,'2008-02-10 16:54:23',3310491035,1),(247046029,425133722,14759211,91631,1,'2008-02-10 16:54:23',3310491060,1),(247046030,425127743,14798142,91631,1,'2008-02-10 16:54:23',3310491062,1),(247046031,425150461,14835450,91631,1,'2008-02-10 16:54:23',3310491069,1),(247046032,425145678,14885735,91631,1,'2008-02-10 16:54:23',3310491068,1),(247046033,425144483,14926287,91631,1,'2008-02-10 16:54:23',3310491070,1),(247046034,425148070,14965218,91631,1,'2008-02-10 16:54:23',3310491412,1),(247046035,425106221,15049567,91631,1,'2008-02-10 16:54:23',3310491411,1),(247046036,425103829,15125805,91631,1,'2008-02-10 16:54:23',3310491419,1),(247046037,425112199,15240974,91631,1,'2008-02-10 16:54:23',3310491443,1),(247046038,425154048,15383718,91631,1,'2008-02-10 16:54:23',3310491541,1),(247046039,425278382,15531329,91631,1,'2008-02-10 16:54:23',3310491597,1),(247046040,425313048,15380474,91631,1,'2008-02-10 16:54:24',3310491514,1),(247046041,425321415,15210154,91631,1,'2008-02-10 16:54:24',3310491505,1),(247046042,425304680,15184201,91631,1,'2008-02-10 16:54:24',3310491504,1),(247046043,425303485,15117695,91631,1,'2008-02-10 16:54:24',3310491482,1),(247046044,425303485,15064165,91631,1,'2008-02-10 16:54:24',3310491480,1),(247046045,425291531,14981439,91631,1,'2008-02-10 16:54:24',3310491472,1),(247046046,425272405,14898712,91631,1,'2008-02-10 16:54:24',3310491119,1),(247046047,425243715,14777054,91631,1,'2008-02-10 16:54:24',3310491110,1),(247046048,425226978,14682973,91631,1,'2008-02-10 16:54:24',3310491083,1),(247046072,424840712,14345577,91631,1,'2008-02-10 16:54:26',3310490727,1),(247046073,424863440,14369908,91631,1,'2008-02-10 16:54:26',3310490738,1),(247046074,424884971,14433170,91631,1,'2008-02-10 16:54:26',3310490745,1),(247046075,424931619,14493188,91631,1,'2008-02-10 16:54:26',3310490751,1),(247046076,424979460,14515897,91631,1,'2008-02-10 16:54:26',3310491008,1),(247046077,425009359,14524008,91631,1,'2008-02-10 16:54:27',3310491009,1),(247046078,425050019,14600246,91631,1,'2008-02-10 16:54:27',3310491015,1),(247046079,425093067,14684595,91631,1,'2008-02-10 16:54:27',3310491034,1),(258352118,425509377,15253073,183661,1,'2008-04-18 18:38:19',3310502450,1),(258353529,425491925,15112311,183661,1,'2008-04-18 18:54:27',3310502415,1),(258353530,425488764,15113169,183661,1,'2008-04-18 18:54:27',3310502415,1),(258353531,425486740,15114628,183661,1,'2008-04-18 18:54:27',3310502415,1),(258353532,425485792,15117031,183661,1,'2008-04-18 18:54:27',3310502415,1),(258353533,425484970,15120035,183661,1,'2008-04-18 18:54:27',3310502415,1),(258353534,425485160,15122353,183661,1,'2008-04-18 18:54:27',3310502415,1),(258353535,425484717,15125614,183661,1,'2008-04-18 18:54:27',3310502415,1),(258353536,425482820,15127760,183661,1,'2008-04-18 18:54:27',3310502415,1),(258353537,425480417,15129906,183661,1,'2008-04-18 18:54:27',3310502415,1),(258353538,425479026,15132052,183661,1,'2008-04-18 18:54:27',3310502414,1),(258353539,425477590,15135615,370566,1,'2008-05-09 02:14:23',3310502414,2),(258355185,425429513,14734913,183661,1,'2008-04-18 19:02:24',3310502049,1),(258356188,425355521,14914299,183661,1,'2008-04-18 19:13:36',3310491134,2),(258356379,425738036,14690281,183661,1,'2008-04-18 19:15:01',3310502106,1),(258357981,426287057,15006138,183661,1,'2008-04-18 19:41:04',3310503426,1),(258361905,425368991,17017913,225225,1,'2008-04-23 01:47:15',3310493558,3),(258823161,425800625,16639043,198831,1,'2008-04-20 16:24:53',3310504188,1),(259406445,425171577,15541348,232546,1,'2008-04-23 11:29:21',3310491549,1),(259406446,425169933,15540318,232546,1,'2008-04-23 11:29:21',3310491549,1),(259406447,425167845,15539717,232546,1,'2008-04-23 11:29:21',3310491549,1),(259406448,425166010,15540061,232546,1,'2008-04-23 11:29:21',3310491549,1),(259406449,425163733,15540747,232546,1,'2008-04-23 11:29:21',3310491549,1),(259406450,425160696,15542292,232546,1,'2008-04-23 11:29:21',3310491549,1),(259406451,425158482,15542206,232546,1,'2008-04-23 11:29:21',3310491549,1),(259406452,425156078,15541691,232546,1,'2008-04-23 11:29:21',3310491549,1),(259406453,425151143,15538859,232546,1,'2008-04-23 11:29:21',3310491549,1),(259406454,425142222,15533022,232546,1,'2008-04-23 11:29:21',3310491548,1),(259406455,425138173,15529761,232546,1,'2008-04-23 11:29:21',3310491548,1),(259406456,425135326,15526499,232546,1,'2008-04-23 11:34:21',3310491548,3),(259406980,425335279,15851654,232546,1,'2008-04-23 11:34:59',3310493009,1),(259475446,425429563,15171130,370566,1,'2008-05-09 02:14:21',3310502433,4),(259475447,425429942,15172191,306164,1,'2008-05-01 17:57:27',3310502433,2),(259475448,425430500,15172350,239859,1,'2008-04-23 20:00:56',3310502433,1),(259475449,425431552,15172343,239859,1,'2008-04-23 20:00:56',3310502433,1),(259475450,425434052,15171418,306164,1,'2008-05-01 17:57:27',3310502433,2),(259475451,425436139,15169959,306164,1,'2008-05-01 17:57:27',3310502433,2),(259475452,425440123,15166182,306164,1,'2008-05-01 17:57:27',3310502433,2),(259475453,425443567,15165305,239859,1,'2008-04-23 20:00:56',3310502433,1),(259475454,425444895,15164962,239859,1,'2008-04-23 20:00:56',3310502433,1),(259475455,425446539,15164618,239859,1,'2008-04-23 20:00:56',3310502433,1),(259475493,425447080,15160580,239859,1,'2008-04-23 20:01:45',3310502411,1),(259475494,425447420,15155130,239859,1,'2008-04-23 20:01:45',3310502411,1),(259475495,425447361,15154404,239859,1,'2008-04-23 20:01:45',3310502411,1),(259476084,425446602,15155606,239859,1,'2008-04-23 20:07:10',3310502411,1),(259983829,425416620,15228965,263367,1,'2008-04-26 15:22:11',3310502434,1),(259984359,425444634,15180986,263367,1,'2008-04-26 15:31:22',3310502433,2),(259985586,425442863,15181329,263367,1,'2008-04-26 15:37:22',3310502433,2),(259985587,425439750,15181900,263367,1,'2008-04-26 15:37:07',3310502433,1),(259985588,425435085,15183818,263367,1,'2008-04-26 15:37:07',3310502433,1),(259985589,425433000,15186660,263367,1,'2008-04-26 15:37:07',3310502433,1),(259985590,425428280,15188760,263367,1,'2008-04-26 15:37:07',3310502433,1),(259985592,425424980,15192510,263367,1,'2008-04-26 15:37:07',3310502433,1),(259985593,425422950,15196880,263367,1,'2008-04-26 15:37:07',3310502432,1),(259985594,425422830,15198500,263367,1,'2008-04-26 15:37:07',3310502432,1),(259985595,425422000,15199760,263367,1,'2008-04-26 15:37:07',3310502432,1),(259985596,425421650,15202260,263367,1,'2008-04-26 15:37:07',3310502432,1),(259985597,425421830,15203830,263367,1,'2008-04-26 15:37:07',3310502432,1),(259985598,425421340,15205800,263367,1,'2008-04-26 15:37:07',3310502432,1),(259985599,425421800,15211750,263367,1,'2008-04-26 15:37:07',3310502432,1),(259985600,425420980,15215650,263367,1,'2008-04-26 15:37:07',3310502432,1),(259985601,425421750,15218830,263367,1,'2008-04-26 15:37:07',3310502434,1),(259985602,425421900,15223160,263367,1,'2008-04-26 15:37:07',3310502434,1),(259985603,425421110,15226380,263367,1,'2008-04-26 15:37:07',3310502434,1),(259985604,425421680,15227700,263367,1,'2008-04-26 15:37:07',3310502434,1),(259985605,425419212,15227420,263367,1,'2008-04-26 15:37:07',3310502434,1),(259985606,425416750,15228060,263367,1,'2008-04-26 15:37:07',3310502434,1),(259986453,425435271,15222983,1075389,1,'2009-05-04 18:49:37',3310502435,2),(259986454,425436030,15221609,1075389,1,'2009-05-04 18:49:37',3310502435,2),(259986455,425436725,15220064,1075389,1,'2009-05-04 18:51:49',3310502435,3),(259986456,425437611,15218090,1075389,1,'2009-05-04 18:50:26',3310502435,2),(259986457,425438496,15216889,1075389,1,'2009-05-04 18:50:26',3310502435,2),(259986458,425439191,15215859,1075389,1,'2009-05-04 18:50:26',3310502433,2),(259986459,425440014,15215086,1075389,1,'2009-05-04 18:50:26',3310502433,2),(259986460,425441940,15214200,327248,1,'2009-04-08 23:42:55',3310502433,5),(259986461,425443180,15212980,327248,1,'2009-04-08 23:42:55',3310502433,5),(259986462,425443500,15210010,327248,1,'2009-04-08 23:42:55',3310502433,5),(259986463,425442830,15207880,327248,1,'2009-04-08 23:42:55',3310502433,5),(259986464,425444910,15207010,327248,1,'2009-04-08 23:42:55',3310502433,5),(259986465,425445530,15201350,327248,1,'2009-04-08 23:42:55',3310502433,5),(259986466,425446710,15197180,327248,1,'2009-04-08 23:42:55',3310502433,5),(259986467,425445700,15192060,327248,1,'2009-04-08 23:42:54',3310502433,5),(259986468,425445670,15189860,327248,1,'2009-04-08 23:42:54',3310502433,5),(259986469,425446150,15187850,327248,1,'2009-04-08 23:42:54',3310502433,6),(259986470,425445301,15184030,206510,1,'2008-12-06 19:49:43',3310502433,4),(259986747,425444830,15180934,263367,1,'2008-04-26 15:48:52',3310502433,1),(260984109,425370080,15199010,306164,1,'2008-05-01 16:46:35',3310491509,1),(260984110,425368880,15199080,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984111,425364430,15201600,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984112,425362230,15203730,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984113,425360500,15206630,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984114,425359630,15206780,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984115,425356460,15204030,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984116,425353830,15199510,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984117,425352280,15197950,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984118,425352180,15196390,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984120,425353500,15196560,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984121,425359280,15200250,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984122,425360940,15199900,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984123,425363150,15198110,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984124,425363360,15197440,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984125,425362680,15196830,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984126,425357682,15195607,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984127,425356164,15194233,306164,1,'2008-05-01 16:46:35',3310491508,1),(260984128,425354646,15192173,306164,1,'2008-05-01 16:46:35',3310491508,1),(260989290,425472524,15139645,306164,1,'2008-05-01 17:05:59',3310502414,1),(260989291,425475243,15136898,306164,1,'2008-05-01 17:05:59',3310502414,1),(260995478,425520197,15107824,329152,1,'2008-05-04 19:09:05',3310502426,3),(260996387,425500300,15116300,306164,1,'2008-05-01 17:31:51',3310502415,1),(260996388,425506050,15121550,306164,1,'2008-05-01 17:31:51',3310502415,1),(260996389,425507650,15121880,306164,1,'2008-05-01 17:31:51',3310502426,1),(260996390,425511900,15114760,306164,1,'2008-05-01 17:31:51',3310502426,1),(260996391,425518710,15109460,306164,1,'2008-05-01 17:31:51',3310502426,1),(260996392,425519630,15110160,370566,1,'2008-05-09 01:42:21',3310502426,2),(260996399,425516150,15115200,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996400,425510050,15128050,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996401,425509360,15129910,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996402,425509310,15135630,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996403,425509540,15139130,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996405,425511210,15143660,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996406,425512250,15148740,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996407,425512500,15156930,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996408,425513030,15158950,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996409,425514230,15160210,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996410,425514980,15162100,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996411,425515960,15183380,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996413,425515680,15185490,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996414,425514230,15188860,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996415,425514410,15190730,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996416,425520660,15208150,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996417,425522000,15210210,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996418,425522880,15210060,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996419,425521810,15195690,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996421,425523050,15180210,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996422,425523350,15179500,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996423,425526360,15182410,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996425,425527950,15182380,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996426,425530610,15180000,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996427,425532030,15175600,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996429,425534080,15164310,306164,1,'2008-05-01 17:31:53',3310502448,1),(260996430,425538150,15158760,306164,1,'2008-05-01 17:31:53',3310502427,1),(260996431,425540230,15154810,306164,1,'2008-05-01 17:31:53',3310502427,1),(260996432,425540150,15153200,306164,1,'2008-05-01 17:31:53',3310502427,1),(260996434,425538680,15151900,306164,1,'2008-05-01 17:31:53',3310502427,1),(260996435,425530250,15149010,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996436,425528910,15148010,306164,1,'2008-05-01 17:31:53',3310502426,1),(260996437,425527670,15146150,306164,1,'2008-05-01 17:31:53',3310502426,1),(260997624,425446217,15179569,441038,1,'2008-07-09 18:16:13',3310502433,2),(260997625,425444929,15176310,306164,1,'2008-05-01 17:37:06',3310502433,1),(260997626,425444486,15172448,306164,1,'2008-05-01 17:46:13',3310502433,3),(260997627,425444929,15169101,306164,1,'2008-05-01 17:37:06',3310502433,1),(261001744,425442835,15170125,362976,1,'2008-05-08 16:09:30',3310502433,2),(261001745,425439760,15170980,306164,1,'2008-05-01 17:50:16',3310502433,1),(261001746,425436130,15172750,306164,1,'2008-05-01 17:50:16',3310502433,1),(261001747,425421540,15183410,306164,1,'2008-05-01 17:50:16',3310502432,1),(261001748,425415330,15191710,306164,1,'2008-05-01 17:50:16',3310502432,1),(261001749,425410780,15198930,306164,1,'2008-05-01 17:50:16',3310502432,1),(261001750,425409610,15199850,306164,1,'2008-05-01 17:50:16',3310502432,1),(261001751,425405480,15201210,306164,1,'2008-05-01 17:50:16',3310502432,1),(261001752,425398810,15199350,306164,1,'2008-05-01 17:50:16',3310502432,1),(261001753,425393450,15199160,306164,1,'2008-05-01 17:50:16',3310491509,1),(261002668,425378680,15202910,306164,1,'2008-05-01 17:53:01',3310491509,1),(261002669,425374510,15204450,306164,1,'2008-05-01 17:53:01',3310491509,1),(261002671,425371660,15204550,306164,1,'2008-05-01 17:53:01',3310491509,1),(261002672,425367810,15207130,306164,1,'2008-05-01 17:53:01',3310491508,1),(261002673,425363500,15211880,306164,1,'2008-05-01 17:53:01',3310491508,1),(261002674,425359380,15214750,306164,1,'2008-05-01 17:53:01',3310491508,1),(261002675,425357910,15217010,306164,1,'2008-05-01 17:53:01',3310491510,1),(261003171,425357260,15215650,306164,1,'2008-05-01 17:53:35',3310491508,1),(261003172,425357784,15212617,306164,1,'2008-05-01 17:53:35',3310491508,1),(261004007,425425389,15175366,306164,1,'2008-05-01 17:56:44',3310502433,1),(261004008,425428907,15172112,370566,1,'2008-05-09 02:14:23',3310502433,2),(261006066,425362440,15165675,306164,1,'2008-05-01 18:03:49',3310491508,1),(261006067,425364580,15168240,306164,1,'2008-05-01 18:03:49',3310491508,1),(261006068,425364610,15171780,306164,1,'2008-05-01 18:03:49',3310491508,1),(261006069,425368150,15175800,306164,1,'2008-05-01 18:03:49',3310491508,1),(261006070,425368730,15178310,306164,1,'2008-05-01 18:03:49',3310491508,1),(261006071,425368660,15188090,306164,1,'2008-05-01 18:03:49',3310491508,1),(261006072,425370160,15189510,306164,1,'2008-05-01 18:03:49',3310491509,1),(261006073,425370610,15190550,306164,1,'2008-05-01 18:03:49',3310491509,1),(261006074,425370150,15191850,306164,1,'2008-05-01 18:03:49',3310491509,1),(261006075,425365480,15196280,306164,1,'2008-05-01 18:03:49',3310491508,1),(261006076,425363705,15197089,306164,1,'2008-05-01 18:03:49',3310491508,1),(261012133,425409893,15118607,306164,1,'2008-05-01 18:30:33',3310502410,2),(261012134,425412802,15116890,306164,1,'2008-05-01 18:30:33',3310502410,2),(261012135,425415711,15115260,306164,1,'2008-05-01 18:27:11',3310502410,1),(261012136,425419189,15113371,306164,1,'2008-05-01 18:27:11',3310502410,1),(261012137,425422225,15111826,306164,1,'2008-05-01 18:27:11',3310502410,1),(261013457,425413624,15133284,306164,1,'2008-05-01 18:33:36',3310502410,1),(261013458,425412106,15134657,306164,1,'2008-05-01 18:33:36',3310502410,1),(261013459,425408438,15135087,306164,1,'2008-05-01 18:33:36',3310502410,1),(262151572,425519312,15109455,329152,1,'2008-05-04 19:08:39',3310502426,1),(262151641,425519312,15111086,329152,1,'2008-05-04 19:09:08',3310502426,1),(262459990,425400677,15126424,352026,1,'2008-05-06 15:59:55',3310502410,1),(262459991,425398211,15122733,352026,1,'2008-05-06 15:59:55',3310502410,1),(262459992,425395744,15120330,352026,1,'2008-05-06 15:59:55',3310491487,1),(262459993,425394290,15118871,352026,1,'2008-05-06 15:59:55',3310491487,1),(262459994,425392962,15116897,352026,1,'2008-05-06 15:59:55',3310491487,1),(262459995,425390685,15114065,352026,1,'2008-05-06 15:59:55',3310491487,1),(262459997,425389230,15111661,352026,1,'2008-05-06 15:59:55',3310491487,1),(262459998,425390053,15112005,352026,1,'2008-05-06 15:59:55',3310491487,1),(262459999,425390622,15112005,352026,1,'2008-05-06 15:59:55',3310491487,1),(262460047,425403586,15116210,352026,1,'2008-05-06 16:00:14',3310502410,1),(262460177,425400740,15110031,352026,1,'2008-05-06 16:01:58',3310502410,1),(262460178,425398906,15112605,352026,1,'2008-05-06 16:01:58',3310502410,1),(262460179,425398590,15113292,352026,1,'2008-05-06 16:01:58',3310502410,1),(262460180,425398527,15114065,352026,1,'2008-05-06 16:01:58',3310502410,1),(262460181,425398590,15115180,352026,1,'2008-05-06 16:01:58',3310502410,1),(262460920,425466039,15091055,844916,1,'2009-01-27 19:53:21',3310502412,9),(262460921,425465280,15090969,844916,1,'2009-01-27 19:53:21',3310502412,5),(262460922,425464332,15091055,844916,1,'2009-01-27 19:53:21',3310502412,18),(262461658,425456982,15089214,844916,1,'2009-01-27 19:52:23',3310502412,4),(262461659,425457730,15087610,844916,1,'2009-01-27 19:52:23',3310502412,4),(262461660,425458880,15081580,844916,1,'2009-01-27 19:52:23',3310502412,4),(262461661,425459780,15080560,844916,1,'2009-01-27 19:52:23',3310502412,4),(262461662,425460340,15080590,844916,1,'2009-01-27 19:52:23',3310502412,4),(262461663,425461880,15082030,844916,1,'2009-01-27 19:52:23',3310502412,4),(262461664,425463280,15088460,844916,1,'2009-01-27 19:52:23',3310502412,4),(262461792,425466292,15091398,844916,1,'2009-01-27 19:52:38',3310502412,4),(262461793,425464522,15093372,844916,1,'2009-01-27 19:52:38',3310502412,4),(262461794,425466355,15093544,844916,1,'2009-01-27 19:52:38',3310502412,4),(262461823,425469311,15081452,844916,1,'2009-01-27 19:52:46',3310502412,3),(262461824,425469421,15078052,844916,1,'2009-01-27 19:52:46',3310502412,3),(262461825,425467531,15067262,844916,1,'2009-01-27 19:52:46',3310502412,3),(262461826,425465961,15064172,844916,1,'2009-01-27 19:52:46',3310502412,3),(262461827,425464181,15063072,844916,1,'2009-01-27 19:52:46',3310502412,3),(262461828,425463861,15063432,844916,1,'2009-01-27 19:52:46',3310502412,3),(262462280,425468252,15091656,844916,1,'2009-01-27 19:58:51',3310502412,3),(262462281,425466608,15090969,844916,1,'2009-01-27 19:52:46',3310502412,4),(262464083,425822713,15190758,19873,1,'2008-06-02 18:28:19',3310502517,4),(262464084,425822830,15190260,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464085,425823650,15186260,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464086,425823380,15184480,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464087,425822530,15183800,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464088,425818260,15182800,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464089,425817480,15181260,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464090,425818310,15179960,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464091,425824200,15177560,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464092,425824760,15176530,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464093,425823760,15175640,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464094,425816760,15175960,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464095,425816080,15174400,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464096,425816560,15173260,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464097,425817490,15172700,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464098,425828350,15171580,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464099,425835060,15173610,352026,1,'2008-05-06 16:30:59',3310502517,1),(262464100,425838660,15175230,352026,1,'2008-05-06 16:30:59',3310502688,1),(262464101,425850180,15183300,352026,1,'2008-05-06 16:30:59',3310502688,1),(262464355,425822018,15194449,19873,1,'2008-06-02 18:31:13',3310502517,2),(262465820,425742574,15182803,352026,1,'2008-05-06 16:42:55',3310502512,1),(262466673,425745545,15193017,352026,1,'2008-05-06 16:48:44',3310502512,2),(262466981,425743206,15184005,352026,1,'2008-05-06 16:49:21',3310502512,1),(262466982,425743522,15185121,352026,1,'2008-05-06 16:49:21',3310502512,1),(262467014,425743902,15186837,352026,1,'2008-05-06 16:49:31',3310502512,1),(262467026,425751233,15186151,352026,1,'2008-05-06 16:49:34',3310502512,1),(262467028,425744250,15188990,370566,1,'2008-05-09 01:38:47',3310502512,2),(262467056,425743530,15190140,352026,1,'2008-05-06 16:50:08',3310502512,1),(262467057,425742310,15194880,352026,1,'2008-05-06 16:50:08',3310502512,1),(262467058,425745500,15200760,352026,1,'2008-05-06 16:50:08',3310502512,1),(262467059,425745130,15201910,352026,1,'2008-05-06 16:50:08',3310502512,1),(262467060,425742830,15204860,352026,1,'2008-05-06 16:50:08',3310502512,1),(262467061,425742180,15207290,352026,1,'2008-05-06 16:50:08',3310502512,1),(262472865,425549682,15722207,1293006,1,'2009-05-23 12:53:21',3310502585,7),(262473157,425689970,15878082,437032,1,'2008-05-13 19:23:17',3310504006,5),(262473680,425621207,16028493,352026,1,'2008-05-06 17:59:41',3310504010,2),(262892996,425663043,15990444,370566,1,'2008-05-09 02:14:09',3310504011,1),(262892997,425665181,15995823,370566,1,'2008-05-09 02:14:09',3310504011,1),(262892998,425660320,15995138,370566,1,'2008-05-09 02:14:09',3310504011,1),(262892999,425661022,15997276,370566,1,'2008-05-09 02:14:09',3310504011,1),(262893000,424836334,14583281,370566,1,'2008-05-09 02:14:09',3310490823,1),(262893001,425479113,15133389,370566,1,'2008-05-09 02:14:09',3310502414,1),(262893002,425477502,15133837,370566,1,'2008-05-09 02:14:10',3310502414,1),(262893003,425769287,14799812,19873,1,'2008-06-02 18:58:22',3310502131,2),(264053269,425567995,15484843,426052,1,'2008-05-12 18:07:48',3310502550,1),(264053391,425590882,15566640,426052,1,'2008-05-12 18:10:46',3310502559,1),(264054001,425588410,15566630,426052,1,'2008-05-12 18:14:17',3310502558,1),(264054002,425587010,15565850,426052,1,'2008-05-12 18:14:17',3310502558,1),(264054003,425586080,15561550,426052,1,'2008-05-12 18:14:17',3310502558,1),(264054004,425584900,15547850,426052,1,'2008-05-12 18:14:17',3310502558,1),(264054005,425585000,15541480,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054006,425584660,15539180,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054007,425582250,15532260,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054008,425581390,15526460,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054009,425581180,15520760,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054010,425580893,15519948,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054011,425580260,15519810,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054012,425575310,15520560,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054013,425574697,15520291,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054014,425574080,15519710,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054016,425573680,15518850,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054017,425573400,15516680,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054018,425573630,15505830,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054019,425572430,15499710,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054020,425571950,15492650,426052,1,'2008-05-12 18:14:17',3310502556,1),(264054021,425571080,15489760,426052,1,'2008-05-12 18:14:17',3310502550,1),(264054022,425569702,15487504,426052,1,'2008-05-12 18:14:17',3310502550,1),(264054023,425568438,15486302,426052,1,'2008-05-12 18:14:17',3310502550,1),(264054024,425567995,15485530,426052,1,'2008-05-12 18:14:17',3310502550,1),(264271683,425689410,15872840,437032,1,'2008-05-13 19:29:33',3310504004,1),(264271684,425688300,15874230,437032,1,'2008-05-13 19:29:33',3310504004,1),(264271685,425687510,15873740,437032,1,'2008-05-13 19:29:33',3310504004,1),(264271686,425685660,15870280,437032,1,'2008-05-13 19:29:33',3310504004,1),(264271687,425681010,15864760,437032,1,'2008-05-13 19:29:33',3310504004,1),(264271688,425679080,15863410,437032,1,'2008-05-13 19:29:33',3310504004,1),(264271689,425677330,15860530,437032,1,'2008-05-13 19:29:33',3310504004,1),(264271690,425675250,15859500,437032,1,'2008-05-13 19:29:33',3310504004,1),(264271691,425673600,15859380,437032,1,'2008-05-13 19:29:33',3310504004,1),(264271692,425672380,15858250,437032,1,'2008-05-13 19:29:33',3310504004,1),(264271693,425669910,15857580,437032,1,'2008-05-13 19:29:33',3310504001,1),(264271694,425666910,15855480,437032,1,'2008-05-13 19:29:33',3310504001,1),(264271695,425664210,15855830,437032,1,'2008-05-13 19:29:33',3310504001,1),(264271696,425666200,15859280,437032,1,'2008-05-13 19:29:33',3310504001,1),(264271697,425665510,15859760,437032,1,'2008-05-13 19:29:33',3310504001,1),(264271698,425666830,15863800,437032,1,'2008-05-13 19:29:33',3310504001,1),(264271699,425666060,15864910,437032,1,'2008-05-13 19:29:33',3310504001,1),(264271700,425666550,15866780,437032,1,'2008-05-13 19:29:33',3310504001,1),(264271701,425664850,15867490,437032,1,'2008-05-13 19:29:33',3310504001,1),(264272401,425689906,15876280,437032,1,'2008-05-13 19:34:04',3310504006,1),(264272402,425689590,15874735,437032,1,'2008-05-13 19:34:04',3310504004,1),(264272403,425689763,15873478,443527,1,'2008-05-14 12:03:54',3310504004,2),(264273116,425647427,15804566,437032,1,'2008-05-13 19:42:40',3310502635,1),(264273117,425645404,15803107,437032,1,'2008-05-13 19:42:40',3310502635,1),(264274288,425638513,15836924,437032,1,'2008-05-13 19:59:51',3310504000,1),(264274289,425639209,15836238,437032,1,'2008-05-13 19:59:51',3310504000,1),(264274290,425640060,15835836,437032,1,'2008-05-13 19:59:51',3310504000,1),(264274291,425641232,15835894,437032,1,'2008-05-13 19:59:51',3310504000,1),(264274292,425642053,15836152,437032,1,'2008-05-13 19:59:51',3310504000,1),(264274293,425642496,15836495,437032,1,'2008-05-13 19:59:51',3310504000,1),(264274294,425642938,15836152,437032,1,'2008-05-13 19:59:51',3310504000,1),(264274295,425643370,15835446,437032,1,'2008-05-13 19:59:51',3310504000,1),(264274296,425647710,15822286,437032,1,'2008-05-13 19:59:51',3310504001,1),(264274297,425647869,15821389,437032,1,'2008-05-13 19:59:51',3310504001,1),(264274298,425648059,15820359,437032,1,'2008-05-13 19:59:51',3310502635,1),(264274299,425648059,15819243,437032,1,'2008-05-13 19:59:51',3310502635,1),(264274300,425647910,15818316,437032,1,'2008-05-13 19:59:51',3310502635,1),(264274301,425645783,15806025,437032,1,'2008-05-13 19:59:51',3310502635,1),(264274302,425645404,15803794,437032,1,'2008-05-13 19:59:51',3310502635,1),(264274303,425645190,15801836,437032,1,'2008-05-13 19:59:51',3310502635,1),(264274304,425645467,15799759,437032,1,'2008-05-13 19:59:51',3310502635,1),(264274305,425645024,15797270,437032,1,'2008-05-13 19:59:51',3310502635,1),(264274306,425644220,15795186,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274307,425642369,15792121,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274308,425640473,15789202,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274309,425639461,15786542,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274310,425638197,15782422,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274311,425638007,15781134,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274312,425638007,15779589,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274313,425638576,15773581,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274314,425638703,15772637,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274315,425638513,15771865,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274316,425637881,15770663,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274317,425637010,15769746,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274318,425635858,15768775,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274319,425634973,15768946,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274320,425631870,15770216,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274321,425631496,15770320,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274322,425630990,15769976,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274323,425630485,15769290,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274324,425630232,15768345,437032,1,'2008-05-13 19:59:51',3310502634,1),(264274325,425627387,15761136,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274326,425626881,15760192,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274327,425626186,15759762,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274328,425625933,15759076,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274329,425625870,15758217,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274330,425626249,15756844,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274331,425629031,15749463,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274332,425629663,15748089,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274333,425630270,15747316,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274334,425635070,15744446,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274335,425636060,15744566,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274336,425637881,15746287,437032,1,'2008-05-13 19:59:51',3310502632,1),(264274337,425638420,15746446,437032,1,'2008-05-13 19:59:51',3310502632,1),(264278117,425132719,15296813,437032,1,'2008-05-13 20:22:48',3310491452,1),(264278118,425132023,15298014,437032,1,'2008-05-13 20:22:48',3310491452,1),(264278119,425131581,15298701,437032,1,'2008-05-13 20:22:48',3310491452,1),(264278120,425131454,15299645,437032,1,'2008-05-13 20:22:48',3310491452,1),(264278121,425131327,15300675,437032,1,'2008-05-13 20:22:48',3310491452,1),(264278122,425131327,15301877,437032,1,'2008-05-13 20:22:48',3310491452,1),(264278123,425131327,15302735,437032,1,'2008-05-13 20:22:48',3310491452,1),(264278124,425131264,15303765,437032,1,'2008-05-13 20:22:48',3310491452,1),(264278152,425130189,15318957,437032,1,'2008-05-13 20:23:23',3310491452,1),(264278153,425129682,15316983,437032,1,'2008-05-13 20:23:23',3310491452,1),(264278154,425129176,15314494,437032,1,'2008-05-13 20:23:23',3310491452,1),(264278155,425128670,15312176,437032,1,'2008-05-13 20:23:23',3310491452,1),(264278156,425128480,15310631,437032,1,'2008-05-13 20:23:23',3310491452,1),(264278157,425128164,15310031,437032,1,'2008-05-13 20:23:23',3310491452,1),(264278158,425127784,15309602,437032,1,'2008-05-13 20:23:23',3310491452,1),(264278159,425126519,15307627,437032,1,'2008-05-13 20:23:23',3310491452,1),(264279592,425112537,15285226,437032,1,'2008-05-13 20:27:32',3310491449,1),(264279593,425101275,15255271,437032,1,'2008-05-13 20:27:32',3310491443,1),(264281365,425102667,15268832,437032,1,'2008-05-13 20:34:15',3310491443,1),(264283312,425105008,15284024,437032,1,'2008-05-13 20:39:16',3310491449,1),(264289240,425099630,15334664,437032,1,'2008-05-13 21:06:50',3310491451,1),(264289241,425099494,15333963,188228,1,'2008-06-16 18:36:11',3310491451,2),(264289242,425099114,15333190,188228,1,'2008-06-16 18:35:49',3310491451,2),(264289243,425098671,15331645,188228,1,'2008-06-16 18:35:49',3310491451,2),(264289244,425098292,15330015,188228,1,'2008-06-16 18:35:49',3310491451,2),(264289245,425097415,15327025,437032,1,'2008-05-13 21:06:50',3310491451,1),(264289246,425096972,15324622,437032,1,'2008-05-13 21:06:50',3310491449,1),(264289247,425096150,15321103,437032,1,'2008-05-13 21:12:44',3310491449,2),(264289248,425095707,15319644,437032,1,'2008-05-13 21:12:44',3310491449,2),(264289249,425094505,15316468,437032,1,'2008-05-13 21:12:44',3310491448,2),(264289250,425093239,15313378,437032,1,'2008-05-13 21:12:44',3310491448,2),(264289251,425091974,15310202,437032,1,'2008-05-13 21:12:44',3310491448,2),(264290433,425090139,15306941,437032,1,'2008-05-13 21:08:55',3310491448,1),(264290434,425090708,15306941,437032,1,'2008-05-13 21:11:45',3310491448,2),(264290436,425091151,15306683,437032,1,'2008-05-13 21:11:45',3310491448,2),(264290437,425091721,15306168,437032,1,'2008-05-13 21:08:55',3310491448,1),(264290438,425092037,15305396,437032,1,'2008-05-13 21:11:45',3310491448,2),(264290439,425092227,15304623,437032,1,'2008-05-13 21:11:45',3310491448,2),(264290442,425091404,15306340,437032,1,'2008-05-13 21:08:56',3310491448,1),(264292663,425091974,15309258,437032,1,'2008-05-13 21:10:55',3310491448,1),(264292664,425091910,15308400,437032,1,'2008-05-13 21:12:44',3310491448,2),(264292665,425092163,15307627,437032,1,'2008-05-13 21:12:44',3310491448,2),(264292666,425092543,15306769,437032,1,'2008-05-13 21:12:44',3310491448,2),(264292667,425092543,15305653,437032,1,'2008-05-13 21:12:44',3310491448,2),(264292669,425092543,15304537,437032,1,'2008-05-13 21:10:55',3310491448,1),(264292670,425092163,15303593,437032,1,'2008-05-13 21:10:55',3310491448,1),(264292671,425091657,15301791,437032,1,'2008-05-13 21:10:55',3310491448,1),(264292672,425091151,15299388,437032,1,'2008-05-13 21:10:55',3310491448,1),(264292673,425090898,15295354,820251,1,'2009-03-16 23:53:41',3310491448,3),(264294525,425095201,15320245,437032,1,'2008-05-13 21:13:33',3310491449,1),(264294716,425099880,15335288,3916355,1,'2010-02-19 17:33:05',3310491451,4),(264304664,425097795,15331832,437032,1,'2008-05-13 21:28:42',3310491451,2),(264304665,425098355,15333362,188228,1,'2008-06-16 18:36:12',3310491451,3),(264304666,425098798,15334649,188228,1,'2008-06-16 18:36:12',3310491451,2),(264304667,425099250,15336638,437032,1,'2008-05-13 21:26:09',3310491451,1),(264304668,425099946,15338269,437032,1,'2008-05-13 21:26:09',3310491451,1),(264304669,425102606,15342314,462438,1,'2008-07-11 13:00:24',3310491451,2),(264305363,425096782,15327712,437032,1,'2008-05-13 21:27:06',3310491451,1),(264330869,425107551,15329632,437032,1,'2008-05-13 22:10:59',3310491451,4),(264330870,425100852,15336003,3916355,1,'2010-02-19 17:33:04',3310491451,5),(264331301,425185203,15243081,461502,1,'2008-05-16 18:49:51',3310491490,2),(264331302,425171577,15242943,437032,1,'2008-05-13 22:10:33',3310491447,1),(264331303,425158292,15248350,437032,1,'2008-05-13 22:10:33',3310491447,1),(264331304,425143804,15266117,437032,1,'2008-05-13 22:10:33',3310491446,1),(264331305,425132163,15289978,437032,1,'2008-05-13 22:10:33',3310491452,1),(264331306,425122040,15312895,2895121,1,'2009-10-19 19:14:32',3310491449,2),(264331307,425118054,15320018,437032,1,'2008-05-13 22:10:33',3310491449,1),(264331308,425115333,15323452,437032,1,'2008-05-13 22:10:33',3310491449,1),(264331309,425111094,15326885,437032,1,'2008-05-13 22:10:33',3310491451,1),(264465123,425995626,15317229,443527,1,'2008-05-14 12:03:47',3310502713,1),(264465124,425997574,15320696,206510,1,'2008-12-06 19:38:06',3310502713,4),(264465125,425632317,15276087,498434,1,'2008-05-22 18:10:41',3310502504,5),(264465126,425538879,15886285,443527,1,'2008-05-14 12:03:47',3310503955,1),(264465127,424889567,14510513,443527,1,'2008-05-14 12:03:47',3310490833,1),(264465128,424881879,14517173,443527,1,'2008-05-14 12:03:47',3310490833,1),(264465129,424882282,14516622,443527,1,'2008-05-14 12:03:47',3310490833,1),(264465130,425800616,14794715,443527,1,'2008-05-14 12:03:47',3310502134,1),(264495540,425469136,15246836,725665,1,'2009-03-02 22:19:39',3310502438,5),(264495541,425468441,15245806,448710,1,'2008-05-14 16:55:56',3310502438,1),(264495542,425467113,15244433,448710,1,'2008-05-14 16:55:56',3310502438,1),(264495543,425465659,15243145,448710,1,'2008-05-14 16:55:56',3310502438,1),(264495544,425463635,15241772,448710,1,'2008-05-14 16:55:56',3310502438,1),(264495938,425459715,15234991,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495939,425460600,15234390,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495940,425461738,15234305,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495941,425463003,15234734,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495942,425464141,15235163,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495943,425465279,15235935,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495944,425466670,15237223,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495945,425467998,15238253,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495946,425469326,15238939,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495947,425470464,15239369,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495948,425471792,15240227,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495949,425472678,15241514,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495950,425473247,15242888,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495951,425473752,15244518,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495952,425474069,15245892,448710,1,'2008-05-14 17:02:06',3310502438,1),(264495953,425474005,15247008,725665,1,'2009-03-02 22:19:39',3310502438,5),(264496511,425389647,15263830,448710,1,'2008-05-14 17:09:29',3310491511,1),(264496540,425388825,15285288,448710,1,'2008-05-14 17:10:59',3310491517,1),(264501521,425456758,15243898,725665,1,'2009-03-02 22:19:39',3310502438,5),(264501522,425457201,15242267,448710,1,'2008-05-14 18:16:46',3310502438,1),(264501523,425457580,15241237,448710,1,'2008-05-14 18:16:46',3310502438,1),(264501524,425457707,15240293,448710,1,'2008-05-14 18:16:46',3310502438,1),(264501525,425457137,15239607,448710,1,'2008-05-14 18:16:46',3310502438,1),(264501526,425456505,15239177,448710,1,'2008-05-14 18:16:46',3310502438,1),(264501527,425448727,15233598,448710,1,'2008-05-14 18:16:46',3310502435,1),(264501528,425446830,15232225,448710,1,'2008-05-14 18:16:46',3310502435,1),(264502059,425446008,15231281,448710,1,'2008-05-14 18:24:01',3310502435,1),(264502060,425445123,15230594,448710,1,'2008-05-14 18:24:01',3310502435,1),(264502061,425443415,15229479,448710,1,'2008-05-14 18:24:01',3310502435,1),(264502062,425442340,15228706,448710,1,'2008-05-14 18:24:01',3310502435,1),(264502063,425441545,15228214,423843,1,'2008-07-08 00:15:45',3310502435,2),(264502064,425441139,15227676,448710,1,'2008-05-14 18:24:01',3310502435,1),(264502065,425440949,15227247,448710,1,'2008-05-14 18:24:01',3310502435,1),(264502898,425455911,15173972,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502899,425456860,15174830,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502900,425457176,15175259,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502901,425457239,15175946,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502902,425456986,15188134,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502903,425457050,15188820,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502904,425457239,15189164,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502905,425457556,15189250,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502906,425457935,15188563,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502907,425458125,15187447,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502908,425458314,15186160,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502909,425458504,15185301,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502910,425458884,15183070,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502912,425459579,15180151,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502914,425460338,15177834,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502916,425461033,15175946,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502918,425461856,15174315,448710,1,'2008-05-14 18:40:23',3310502436,1),(264502985,425456923,15189765,448710,1,'2008-05-14 18:41:02',3310502436,1),(264502987,425456607,15189850,448710,1,'2008-05-14 18:41:02',3310502436,1),(264502988,425456417,15190279,448710,1,'2008-05-14 18:41:02',3310502436,1),(264502989,425456354,15190794,448710,1,'2008-05-14 18:41:02',3310502436,1),(264502990,425456417,15191309,448710,1,'2008-05-14 18:41:02',3310502436,1),(264906169,425223602,15218620,461502,1,'2008-05-16 18:38:38',3310491491,1),(264906170,425220755,15220422,461502,1,'2008-05-16 18:38:38',3310491491,1),(264906764,425189251,15240936,461502,1,'2008-05-16 18:44:51',3310491490,2),(264907017,425182799,15251064,461502,1,'2008-05-16 18:45:49',3310491490,1),(264908763,425189504,15242824,461502,1,'2008-05-16 18:54:16',3310491490,1),(264908764,425202346,15235957,461502,1,'2008-05-16 18:54:16',3310491490,1),(264908765,425199626,15237331,461502,1,'2008-05-16 18:54:16',3310491490,1),(264908766,425198234,15238017,461502,1,'2008-05-16 18:54:16',3310491490,1),(264908767,425195894,15239391,461502,1,'2008-05-16 18:54:16',3310491490,1),(264908768,425194565,15240163,461502,1,'2008-05-16 18:56:23',3310491490,2),(264908769,425193047,15241021,461502,1,'2008-05-16 18:54:16',3310491490,1),(264908770,425191465,15242051,461502,1,'2008-05-16 18:54:16',3310491490,1),(264908771,425190453,15242481,461502,1,'2008-05-16 18:54:16',3310491490,1),(264909485,425195831,15240421,461502,1,'2008-05-16 19:10:03',3310491490,2),(264909486,425194059,15241622,461502,1,'2008-05-16 19:10:03',3310491490,2),(264909487,425192667,15242738,461502,1,'2008-05-16 19:10:03',3310491490,2),(264909488,425190010,15244798,461502,1,'2008-05-16 19:02:56',3310491490,1),(264909489,425188429,15246515,461502,1,'2008-05-16 19:02:56',3310491490,1),(264909490,425186341,15248746,461502,1,'2008-05-16 19:02:56',3310491490,1),(264909491,425184823,15250205,461502,1,'2008-05-16 19:02:56',3310491490,1),(264909492,425183933,15250856,56648,1,'2008-06-05 19:24:05',3310491490,2),(264909493,425179382,15254926,461502,1,'2008-05-16 19:02:56',3310491490,1),(264910379,425168122,15278186,461502,1,'2008-05-16 19:07:25',3310491453,1),(264910825,425196906,15238790,461502,1,'2008-05-16 19:10:03',3310491490,1),(264932311,426460461,15840646,459604,1,'2008-05-16 21:20:51',3310504980,1),(264932314,426459261,15850492,459604,1,'2008-05-16 21:20:51',3310504980,1),(264932315,426456859,15849532,459604,1,'2008-05-16 21:20:51',3310504980,1),(264932316,426453016,15842087,459604,1,'2008-05-16 21:20:51',3310504980,1),(264932317,426449654,15841847,459604,1,'2008-05-16 21:20:51',3310504980,1),(264932318,426448213,15845689,459604,1,'2008-05-16 21:20:51',3310504980,1),(264932319,426446772,15848571,459604,1,'2008-05-16 21:20:51',3310504980,1),(264932321,426439620,15854549,459604,1,'2008-05-16 21:20:51',3310504977,1),(264932322,426439423,15859270,459604,1,'2008-05-16 21:20:51',3310504977,1),(264932325,426440505,15877272,459604,1,'2008-05-16 21:20:52',3310504979,1),(264932326,426442079,15878354,459604,1,'2008-05-16 21:20:52',3310504982,1),(264932327,426444440,15877272,459604,1,'2008-05-16 21:20:52',3310504982,1),(264932328,426451818,15864484,459604,1,'2008-05-16 21:20:52',3310504980,1),(264932329,426452900,15861828,459604,1,'2008-05-16 21:20:52',3310504980,1),(264932330,426455261,15862516,459604,1,'2008-05-16 21:20:52',3310504980,1),(264932340,426463917,15830743,459604,1,'2008-05-16 21:20:52',3310504980,1),(264932341,426462638,15828284,459604,1,'2008-05-16 21:20:53',3310504980,1),(264932342,426461163,15828776,459604,1,'2008-05-16 21:20:53',3310504980,1),(264932343,426460376,15831334,459604,1,'2008-05-16 21:20:53',3310504980,1),(264932344,426342071,16020551,459604,1,'2008-05-16 21:20:53',3310504974,1),(264932345,426342071,16023941,459604,1,'2008-05-16 21:20:53',3310504974,1),(264932347,426335799,16023772,459604,1,'2008-05-16 21:20:53',3310504974,1),(264932348,426332409,16021059,459604,1,'2008-05-16 21:20:53',3310504974,1),(264932349,426333426,16016144,459604,1,'2008-05-16 21:20:53',3310504974,1),(264932350,426334951,16013601,459604,1,'2008-05-16 21:20:53',3310504974,1),(264932351,426337325,16013431,459604,1,'2008-05-16 21:20:53',3310504974,1),(264932352,426339528,16015296,459604,1,'2008-05-16 21:20:53',3310504974,1),(264932353,426340376,16017330,459604,1,'2008-05-16 21:20:53',3310504974,1),(264932354,426148324,15412858,459604,1,'2008-05-16 21:20:53',3310502853,1),(264932355,426122272,15399290,459604,1,'2008-05-16 21:20:53',3310502852,1);
INSERT INTO `nodes` VALUES (264932356,426103277,15390606,459604,1,'2008-05-16 21:20:54',3310502849,1),(264932357,426089709,15394948,459604,1,'2008-05-16 21:20:54',3310502849,1),(264932359,426072341,15411773,459604,1,'2008-05-16 21:20:54',3310502848,1),(264932360,426051718,15399833,459604,1,'2008-05-16 21:20:54',3310502805,1),(264932361,426031094,15378123,459604,1,'2008-05-16 21:20:54',3310502719,1),(264932362,426021325,15361841,459604,1,'2008-05-16 21:20:54',3310502718,1),(264932363,426004500,15348273,459604,1,'2008-05-16 21:20:54',3310502718,1),(264932364,426001244,15327649,459604,1,'2008-05-16 21:20:54',3310502715,1),(264932365,425990932,15318966,459604,1,'2008-05-16 21:20:54',3310502713,1),(264932366,425967594,15302684,459604,1,'2008-05-16 21:20:54',3310502712,1),(264932367,425957282,15286945,459604,1,'2008-05-16 21:20:54',3310502712,1),(264932368,425945885,15285859,459604,1,'2008-05-16 21:20:54',3310502701,1),(264932370,425933945,15277176,459604,1,'2008-05-16 21:20:54',3310502701,1),(264932371,425921462,15278804,459604,1,'2008-05-16 21:20:54',3310502701,1),(264932372,425908437,15269035,459604,1,'2008-05-16 21:20:55',3310502694,1),(264932373,425880215,15262522,459604,1,'2008-05-16 21:20:55',3310502691,1),(264932374,425865018,15256552,459604,1,'2008-05-16 21:20:55',3310502691,1),(264932375,425850365,15253838,459604,1,'2008-05-16 21:20:55',3310502690,1),(264932376,425836796,15244612,459604,1,'2008-05-16 21:20:55',3310502690,1),(264932377,425830284,15221817,459604,1,'2008-05-16 21:20:55',3310502519,1),(264932379,425819429,15213676,459604,1,'2008-05-16 21:20:55',3310502517,1),(264932380,425808574,15204992,459604,1,'2008-05-16 21:20:55',3310502516,1),(264932381,425780352,15193052,459604,1,'2008-05-16 21:20:55',3310502513,1),(264932382,425767870,15193052,459604,1,'2008-05-16 21:20:55',3310502513,1),(264932383,425755930,15193595,459604,1,'2008-05-16 21:20:55',3310502513,1),(264932384,425716853,15210420,459604,1,'2008-05-16 21:20:55',3310502501,1),(264932386,425713597,15223445,459604,1,'2008-05-16 21:20:56',3310502503,1),(264932387,425706541,15227787,459604,1,'2008-05-16 21:20:56',3310502503,1),(264932388,425684289,15248411,459604,1,'2008-05-16 21:20:56',3310502502,1),(264932390,425653896,15270663,459604,1,'2008-05-16 21:20:56',3310502499,1),(264932393,425630559,15310825,459604,1,'2008-05-16 21:20:56',3310502504,1),(264932395,425619162,15336876,459604,1,'2008-05-16 21:20:56',3310502506,1),(264932396,425624046,15371611,459604,1,'2008-05-16 21:20:56',3310502506,1),(264932397,425628388,15394405,459604,1,'2008-05-16 21:20:56',3310502592,1),(264932398,425656067,15402546,459604,1,'2008-05-16 21:20:56',3310502593,1),(264932399,425687546,15416657,459604,1,'2008-05-16 21:20:57',3310502596,1),(264932400,425710883,15421542,459604,1,'2008-05-16 21:20:57',3310502597,1),(264932401,425726079,15423713,459604,1,'2008-05-16 21:20:57',3310502597,1),(264932402,425747789,15444336,459604,1,'2008-05-16 21:20:57',3310502610,1),(264932404,425784627,15452995,459604,1,'2008-05-16 21:20:57',3310502614,1),(264932405,425823348,15471664,459604,1,'2008-05-16 21:20:57',3310502615,1),(264932406,425838560,15491716,459604,1,'2008-05-16 21:20:57',3310502792,1),(264932407,425879356,15500705,459604,1,'2008-05-16 21:20:57',3310502793,1),(264932408,425882122,15486184,459604,1,'2008-05-16 21:20:57',3310502787,1),(264932409,425882122,15470281,459604,1,'2008-05-16 21:20:57',3310502787,1),(264932410,425892493,15424645,459604,1,'2008-05-16 21:20:57',3310502788,1),(264932411,425882122,15400445,459604,1,'2008-05-16 21:20:57',3310502785,1),(264932412,425871750,15383158,459604,1,'2008-05-16 21:20:58',3310502785,1),(264932414,425884196,15363106,459604,1,'2008-05-16 21:20:58',3310502699,1),(264932415,425903557,15399062,459604,1,'2008-05-16 21:20:58',3310502788,1),(264932416,425912545,15407359,459604,1,'2008-05-16 21:20:58',3310502788,1),(264932417,425927066,15407359,459604,1,'2008-05-16 21:20:58',3310502789,1),(264932420,425936746,15431560,459604,1,'2008-05-16 21:20:58',3310502789,1),(264932427,425938129,15467515,459604,1,'2008-05-16 21:20:58',3310502791,1),(264932428,425960255,15479270,459604,1,'2008-05-16 21:20:58',3310502802,1),(264932429,425980307,15502088,459604,1,'2008-05-16 21:20:58',3310502809,1),(264932430,425966478,15554638,459604,1,'2008-05-16 21:20:58',3310502810,1),(264932431,425964404,15585753,459604,1,'2008-05-16 21:20:59',3310502810,1),(264932432,425965096,15617560,459604,1,'2008-05-16 21:20:59',3310502832,1),(264932433,425967861,15654207,459604,1,'2008-05-16 21:20:59',3310502832,1),(264932435,425985839,15652824,459604,1,'2008-05-16 21:20:59',3310502833,1),(264932436,425998285,15637612,459604,1,'2008-05-16 21:20:59',3310502833,1),(264932437,426007274,15599582,459604,1,'2008-05-16 21:20:59',3310502814,1),(264932438,426005200,15547723,459604,1,'2008-05-16 21:20:59',3310502814,1),(264932439,426011423,15516608,459604,1,'2008-05-16 21:20:59',3310502812,1),(264932440,426023177,15518682,459604,1,'2008-05-16 21:20:59',3310502812,1),(264932441,426032166,15544958,459604,1,'2008-05-16 21:20:59',3310502813,1),(264932442,426035623,15590593,459604,1,'2008-05-16 21:20:59',3310502815,1),(264932444,426051527,15582296,459604,1,'2008-05-16 21:21:00',3310502815,1),(264932445,426052218,15535969,459604,1,'2008-05-16 21:21:00',3310502813,1),(264932446,426051527,15513151,459604,1,'2008-05-16 21:21:00',3310502813,1),(264932447,426067430,15484801,459604,1,'2008-05-16 21:21:00',3310502850,1),(264932448,426081259,15482036,459604,1,'2008-05-16 21:21:00',3310502850,1),(264932449,426093705,15506928,459604,1,'2008-05-16 21:21:00',3310502857,1),(264932450,426108226,15510385,459604,1,'2008-05-16 21:21:00',3310502857,1),(264932451,426110300,15526980,459604,1,'2008-05-16 21:21:00',3310502857,1),(264932452,426124129,15558787,459604,1,'2008-05-16 21:21:00',3310502862,1),(264932453,426131043,15576764,459604,1,'2008-05-16 21:21:00',3310502862,1),(264932454,426147638,15562244,459604,1,'2008-05-16 21:21:00',3310502863,1),(264932456,426155936,15549106,459604,1,'2008-05-16 21:21:00',3310502863,1),(264932457,426159393,15560169,459604,1,'2008-05-16 21:21:00',3310502863,1),(264932458,426098545,15658355,459604,1,'2008-05-16 21:21:00',3310502883,1),(264932459,426122746,15692928,459604,1,'2008-05-16 21:21:00',3310502886,1),(264932460,426146947,15706065,459604,1,'2008-05-16 21:21:01',3310502887,1),(264932461,426173222,15714363,459604,1,'2008-05-16 21:21:01',3310502904,1),(264932462,426193965,15730266,459604,1,'2008-05-16 21:21:01',3310502905,1),(264932463,426217474,15742712,459604,1,'2008-05-16 21:21:01',3310502905,1),(264932464,426235452,15734415,459604,1,'2008-05-16 21:21:01',3310502908,1),(264932465,426227846,15693619,459604,1,'2008-05-16 21:21:01',3310502902,1),(264932466,426212634,15605114,459604,1,'2008-05-16 21:21:01',3310502897,1),(264932467,426210560,15565010,459604,1,'2008-05-16 21:21:01',3310502875,1),(264932469,426216783,15533894,459604,1,'2008-05-16 21:21:01',3310502873,1),(264932470,426220240,15520757,459604,1,'2008-05-16 21:21:01',3310502873,1),(264932471,426236144,15534586,459604,1,'2008-05-16 21:21:01',3310502876,1),(264932472,426241675,15556021,459604,1,'2008-05-16 21:21:01',3310502878,1),(264932473,426256196,15631389,459604,1,'2008-05-16 21:21:01',3310502901,1),(264932474,426265876,15654898,459604,1,'2008-05-16 21:21:01',3310502901,1),(264932475,426278322,15673567,459604,1,'2008-05-16 21:21:02',3310503586,1),(264932476,426328106,15689470,459604,1,'2008-05-16 21:21:02',3310503587,1),(264932477,426324649,15656972,459604,1,'2008-05-16 21:21:02',3310503587,1),(264932478,426335712,15661121,459604,1,'2008-05-16 21:21:02',3310503590,1),(264932479,426345393,15678407,459604,1,'2008-05-16 21:21:02',3310503590,1),(264932481,426350233,15691545,459604,1,'2008-05-16 21:21:02',3310503590,1),(264932482,426369593,15673567,459604,1,'2008-05-16 21:21:02',3310503591,1),(264932483,426375125,15652132,459604,1,'2008-05-16 21:21:03',3310503589,1),(264932484,426384805,15652824,459604,1,'2008-05-16 21:21:03',3310503589,1),(264932486,426385497,15674950,459604,1,'2008-05-16 21:21:03',3310503591,1),(264932487,426413846,15660430,459604,1,'2008-05-16 21:21:03',3310503603,1),(264932488,426404857,15659738,459604,1,'2008-05-16 21:21:03',3310503602,1),(264932489,426412463,15642452,459604,1,'2008-05-16 21:21:03',3310503600,1),(264932490,426413155,15621017,459604,1,'2008-05-16 21:21:03',3310503600,1),(264932491,426383422,15606497,459604,1,'2008-05-16 21:21:03',3310503589,1),(264932492,426356456,15608571,459604,1,'2008-05-16 21:21:03',3310503588,1),(264932493,426318426,15603731,459604,1,'2008-05-16 21:21:03',3310503585,1),(264932495,426274865,15587136,459604,1,'2008-05-16 21:21:03',3310502879,1),(264932496,426269333,15559478,459604,1,'2008-05-16 21:21:03',3310502879,1),(264932497,426259850,15523240,459604,1,'2008-05-16 21:21:03',3310502877,1),(264932498,426244581,15485654,459604,1,'2008-05-16 21:21:03',3310502870,1),(264932499,426226962,15451592,459604,1,'2008-05-16 21:21:04',3310502870,1),(264932500,426217566,15439259,459604,1,'2008-05-16 21:21:04',3310502867,1),(264932501,426204646,15431624,459604,1,'2008-05-16 21:21:04',3310502865,1),(264932503,426216126,15395037,862435,1,'2009-03-27 00:59:22',3310502865,2),(264932504,426229311,15430450,862435,1,'2009-03-27 00:59:23',3310502868,2),(264932505,426257501,15426926,862435,1,'2009-03-27 00:59:23',3310502869,2),(264932506,426266897,15406959,862435,1,'2009-03-27 00:59:23',3310502869,2),(264932507,426278056,15366436,862435,1,'2009-03-27 00:59:23',3310503466,2),(264932509,426303797,15329120,862435,1,'2009-03-27 00:59:23',3310503467,2),(264932510,426316246,15289610,862435,1,'2009-03-27 00:59:24',3310503465,2),(264932512,426324906,15236569,862435,1,'2009-03-27 00:59:24',3310503459,2),(264932513,426333565,15221955,862435,1,'2009-03-27 00:59:24',3310503462,2),(264932515,426340601,15230615,862435,1,'2009-03-27 00:59:24',3310503462,2),(264932516,426350344,15269043,862435,1,'2009-03-27 00:59:24',3310503462,2),(264932517,426367122,15290692,862435,1,'2009-03-27 00:59:24',3310503469,2),(264932518,426377947,15285821,862435,1,'2009-03-27 00:59:24',3310503469,2),(264932519,426377406,15263630,862435,1,'2009-03-27 00:59:24',3310503463,2),(264932520,426360627,15218708,862435,1,'2009-03-27 00:59:25',3310503463,2),(264932521,426349261,15191646,862435,1,'2009-03-27 00:59:25',3310503460,2),(264932522,426347161,15172847,862435,1,'2009-03-27 00:59:25',3310503460,2),(264932523,426357091,15132467,862435,1,'2009-03-27 00:59:25',3310503438,2),(264932524,426369668,15092087,862435,1,'2009-03-27 00:59:25',3310503437,2),(264932526,426351133,15066271,862435,1,'2009-03-27 00:59:25',3310503436,3),(264932529,426302148,15024567,459604,1,'2008-05-16 21:21:05',3310503426,1),(264932531,426281627,15027215,459604,1,'2008-05-16 21:21:05',3310503426,1),(264932532,426243233,15040454,459604,1,'2008-05-16 21:21:06',3310502742,1),(264932534,426226684,15047735,459604,1,'2008-05-16 21:21:06',3310502742,1),(264932535,426241247,15061637,459604,1,'2008-05-16 21:21:06',3310502748,1),(264932536,426241909,15082820,459604,1,'2008-05-16 21:21:06',3310502748,1),(264932537,426244557,15120552,459604,1,'2008-05-16 21:21:06',3310502750,1),(264932538,426234627,15144382,459604,1,'2008-05-16 21:21:06',3310502750,1),(264932539,426206825,15166227,459604,1,'2008-05-16 21:21:06',3310502769,1),(264932540,426214106,15194030,459604,1,'2008-05-16 21:21:06',3310502769,1),(264932541,426171741,15158946,459604,1,'2008-05-16 21:21:06',3310502746,1),(264932543,426155191,15188072,459604,1,'2008-05-16 21:21:06',3310502757,1),(264932544,426134009,15229114,459604,1,'2008-05-16 21:21:06',3310502758,1),(264932545,426139966,15269494,459604,1,'2008-05-16 21:21:06',3310502759,1),(264932546,426132685,15317817,459604,1,'2008-05-16 21:21:06',3310502764,1),(264932547,426128051,15340986,459604,1,'2008-05-16 21:21:06',3310502766,1),(264932548,426116797,15346282,459604,1,'2008-05-16 21:21:06',3310502766,1),(264932549,426096938,15338338,459604,1,'2008-05-16 21:21:07',3310502763,1),(264932550,426106868,15313183,459604,1,'2008-05-16 21:21:07',3310502761,1),(264932551,426108120,15289196,459604,1,'2008-05-16 21:21:07',3310502761,1),(264932552,426225808,15363545,862435,1,'2009-03-27 00:59:22',3310502782,2),(264932554,426235866,15338858,862435,1,'2009-03-27 00:59:22',3310502782,2),(264932555,426252781,15302741,862435,1,'2009-03-27 00:59:22',3310502781,2),(264932556,426269697,15281712,862435,1,'2009-03-27 00:59:21',3310502781,2),(264932557,426277469,15267996,862435,1,'2009-03-27 00:59:21',3310503458,2),(264932558,426282498,15254738,862435,1,'2009-03-27 00:59:21',3310503458,2),(264932559,426296213,15235080,862435,1,'2009-03-27 00:59:21',3310503458,2),(264932560,426305356,15218622,862435,1,'2009-03-27 00:59:20',3310503459,2),(264932561,426312671,15193477,862435,1,'2009-03-27 00:59:20',3310503457,2),(264932563,426319529,15169704,862435,1,'2009-03-27 00:59:20',3310503457,2),(264932564,426324557,15142274,862435,1,'2009-03-27 00:59:20',3310503435,2),(264932565,426325015,15121244,862435,1,'2009-03-27 00:59:17',3310503435,2),(264932566,426340101,15084670,862435,1,'2009-03-27 00:59:16',3310503436,2),(264932567,426091047,15271804,459604,1,'2008-05-16 21:21:08',3310502761,1),(264932568,426081027,15256775,459604,1,'2008-05-16 21:21:08',3310502754,1),(264932569,426081027,15241745,459604,1,'2008-05-16 21:21:08',3310502754,1),(264932570,426094805,15223583,459604,1,'2008-05-16 21:21:08',3310502755,1),(264932572,426094805,15207927,459604,1,'2008-05-16 21:21:08',3310502753,1),(264932573,426072886,15173484,459604,1,'2008-05-16 21:21:08',3310502752,1),(264932574,426055351,15155949,459604,1,'2008-05-16 21:21:08',3310502687,1),(264932575,426042826,15154696,459604,1,'2008-05-16 21:21:08',3310502687,1),(264932576,426030301,15150939,459604,1,'2008-05-16 21:21:08',3310502687,1),(264932577,426036564,15135909,459604,1,'2008-05-16 21:21:09',3310502687,1),(264932578,426037816,15103970,459604,1,'2008-05-16 21:21:09',3310502685,1),(264932579,426019029,15067022,459604,1,'2008-05-16 21:21:09',3310502684,1),(264932581,426006504,15068274,459604,1,'2008-05-16 21:21:09',3310502684,1),(264932582,426000242,15078921,459604,1,'2008-05-16 21:21:09',3310502681,1),(264932583,425984711,15083304,459604,1,'2008-05-16 21:21:09',3310502681,1),(264932584,425968929,15083304,459604,1,'2008-05-16 21:21:09',3310502680,1),(264932585,425962917,15077292,459604,1,'2008-05-16 21:21:09',3310502680,1),(264932586,425953148,15071280,459604,1,'2008-05-16 21:21:09',3310502680,1),(264932587,425934360,15072032,459604,1,'2008-05-16 21:21:09',3310502669,1),(264932589,425914070,15084056,459604,1,'2008-05-16 21:21:09',3310502668,1),(264932590,425885513,15114116,459604,1,'2008-05-16 21:21:09',3310502667,1),(264932591,425885062,15143123,459604,1,'2008-05-16 21:21:10',3310502667,1),(264932592,425893479,15187011,459604,1,'2008-05-16 21:21:10',3310502692,1),(264932593,425917527,15220437,459604,1,'2008-05-16 21:21:10',3310502694,1),(264932594,425935563,15244245,459604,1,'2008-05-16 21:21:10',3310502695,1),(264932595,425957927,15226209,459604,1,'2008-05-16 21:21:10',3310502706,1),(264932596,425970913,15230537,459604,1,'2008-05-16 21:21:10',3310502706,1),(264932598,425973077,15252180,459604,1,'2008-05-16 21:21:10',3310502706,1),(264932599,425984620,15273823,459604,1,'2008-05-16 21:21:10',3310502713,1),(264932600,426010592,15313502,459604,1,'2008-05-16 21:21:10',3310502716,1),(264932601,426030792,15336588,459604,1,'2008-05-16 21:21:10',3310502719,1),(264932602,426050993,15343081,459604,1,'2008-05-16 21:21:11',3310502719,1),(264932603,426084179,15357510,459604,1,'2008-05-16 21:21:11',3310502763,1),(264932604,426102936,15374103,459604,1,'2008-05-16 21:21:11',3310502763,1),(264932605,426130350,15370496,459604,1,'2008-05-16 21:21:11',3310502766,1),(264932606,426167144,15371939,459604,1,'2008-05-16 21:21:11',3310502778,1),(264932608,426188065,15345967,459604,1,'2008-05-16 21:21:11',3310502778,1),(264932609,426197444,15323603,459604,1,'2008-05-16 21:21:11',3310502777,1),(264932610,426221251,15305567,459604,1,'2008-05-16 21:21:11',3310502780,1),(264932611,426234237,15278874,459604,1,'2008-05-16 21:21:11',3310502780,1),(264932612,426258766,15250016,459604,1,'2008-05-16 21:21:11',3310502775,1),(264932613,426281131,15206730,459604,1,'2008-05-16 21:21:12',3310503456,1),(264932614,426305227,15173111,459604,1,'2008-05-16 21:21:12',3310503457,1),(264932615,426313018,15138482,459604,1,'2008-05-16 21:21:12',3310503435,1),(264932616,426316481,15068359,459604,1,'2008-05-16 21:21:12',3310503433,1),(264932617,426310421,15038924,459604,1,'2008-05-16 21:21:12',3310503427,1),(264932619,425960809,16112758,459604,1,'2008-05-16 21:21:12',3310504242,1),(264932620,425934839,16107157,459604,1,'2008-05-16 21:21:12',3310504231,1),(264932621,425917526,16108684,459604,1,'2008-05-16 21:21:12',3310504230,1),(264932622,425893083,16108684,459604,1,'2008-05-16 21:21:12',3310504230,1),(264932623,425883408,16108684,459604,1,'2008-05-16 21:21:12',3310504227,1),(264932624,425869150,16111740,459604,1,'2008-05-16 21:21:12',3310504227,1),(264932625,425864567,16124979,459604,1,'2008-05-16 21:21:12',3310504227,1),(264932626,425861002,16130581,459604,1,'2008-05-16 21:21:12',3310504226,1),(264932627,425841652,16131599,459604,1,'2008-05-16 21:21:13',3310504226,1),(264932628,425830958,16118359,459604,1,'2008-05-16 21:21:13',3310504055,1),(264932629,425836560,16110721,459604,1,'2008-05-16 21:21:13',3310504055,1),(264932631,425856929,16103592,459604,1,'2008-05-16 21:21:13',3310504226,1),(264932632,425875770,16079659,459604,1,'2008-05-16 21:21:13',3310504225,1),(264932633,425872205,16059290,459604,1,'2008-05-16 21:21:13',3310504225,1),(264932634,425848272,16054198,459604,1,'2008-05-16 21:21:13',3310504224,1),(264932635,425821793,16054707,459604,1,'2008-05-16 21:21:13',3310504053,1),(264932636,425804479,16057762,459604,1,'2008-05-16 21:21:13',3310504052,1),(264932637,425792258,16067947,459604,1,'2008-05-16 21:21:13',3310504052,1),(264932638,425774944,16088825,459604,1,'2008-05-16 21:21:13',3310504049,1),(264932639,425772907,16119887,459604,1,'2008-05-16 21:21:13',3310504051,1),(264932641,425761705,16121924,459604,1,'2008-05-16 21:21:14',3310504051,1),(264932642,425768324,16130072,459604,1,'2008-05-16 21:21:14',3310504051,1),(264932643,425784110,16149422,459604,1,'2008-05-16 21:21:14',3310504054,1),(264932644,425799896,16167754,459604,1,'2008-05-16 21:21:14',3310504060,1),(264932645,425797859,16210019,459604,1,'2008-05-16 21:21:14',3310504062,1),(264932646,425810080,16233952,459604,1,'2008-05-16 21:21:14',3310504063,1),(264932647,425829940,16232934,459604,1,'2008-05-16 21:21:14',3310504063,1),(264932649,425848272,16216130,459604,1,'2008-05-16 21:21:14',3310504234,1),(264932650,425865585,16210019,459604,1,'2008-05-16 21:21:14',3310504235,1),(264932651,425887482,16209001,459604,1,'2008-05-16 21:21:14',3310504235,1),(264932652,425904286,16200853,459604,1,'2008-05-16 21:21:14',3310504236,1),(264932653,425903777,16185576,459604,1,'2008-05-16 21:21:14',3310504236,1),(264932654,425887482,16183030,459604,1,'2008-05-16 21:21:15',3310504233,1),(264932655,425857947,16172846,459604,1,'2008-05-16 21:21:15',3310504232,1),(264932656,425853364,16157569,459604,1,'2008-05-16 21:21:15',3310504232,1),(264932657,425856929,16147385,459604,1,'2008-05-16 21:21:15',3310504226,1),(264932658,425872205,16143311,459604,1,'2008-05-16 21:21:15',3310504227,1),(264932659,425892574,16142293,459604,1,'2008-05-16 21:21:15',3310504230,1),(264932660,425914470,16142293,459604,1,'2008-05-16 21:21:15',3310504230,1),(264932661,425941968,16136691,459604,1,'2008-05-16 21:21:15',3310504231,1),(264932662,425957754,16130072,459604,1,'2008-05-16 21:21:15',3310504242,1),(264932663,426160001,16385750,459604,1,'2008-05-16 21:21:15',3310504397,1),(264932665,426130751,16388675,459604,1,'2008-05-16 21:21:15',3310504396,1),(264932666,426114956,16394525,459604,1,'2008-05-16 21:21:16',3310504396,1),(264932667,426092725,16402716,459604,1,'2008-05-16 21:21:16',3310504393,1),(264932668,426057040,16405641,459604,1,'2008-05-16 21:21:16',3310504392,1),(264932669,426051775,16405641,459604,1,'2008-05-16 21:21:16',3310504349,1),(264932670,426048265,16397451,459604,1,'2008-05-16 21:21:16',3310504349,1),(264932671,426040660,16387505,459604,1,'2008-05-16 21:21:16',3310504349,1),(264932672,426026253,16386405,459604,1,'2008-05-16 21:21:16',3310504348,1),(264932673,426018585,16387363,459604,1,'2008-05-16 21:21:16',3310504348,1),(264932675,426009767,16394839,459604,1,'2008-05-16 21:21:16',3310504348,1),(264932676,426003824,16399632,459604,1,'2008-05-16 21:21:16',3310504348,1),(264932677,425999152,16398116,459604,1,'2008-05-16 21:21:16',3310504345,1),(264932678,425984645,16393281,459604,1,'2008-05-16 21:21:16',3310504345,1),(264932679,425977172,16385807,459604,1,'2008-05-16 21:21:16',3310504345,1),(264932680,425963545,16382730,459604,1,'2008-05-16 21:21:16',3310504344,1),(264932681,425945521,16380532,459604,1,'2008-05-16 21:21:17',3310504333,1),(264932682,425927497,16384928,459604,1,'2008-05-16 21:21:17',3310504333,1),(264932684,425916068,16391962,459604,1,'2008-05-16 21:21:17',3310504332,1),(264932685,425909473,16399875,459604,1,'2008-05-16 21:21:17',3310504332,1),(264932686,425901561,16404710,459604,1,'2008-05-16 21:21:17',3310504332,1),(264932687,425893648,16404271,459604,1,'2008-05-16 21:21:17',3310504332,1),(264932688,425875624,16387566,459604,1,'2008-05-16 21:21:17',3310504329,1),(264932689,425859359,16382730,459604,1,'2008-05-16 21:21:17',3310504328,1),(264932690,425848808,16379653,459604,1,'2008-05-16 21:21:17',3310504328,1),(264932691,425832543,16379653,459604,1,'2008-05-16 21:21:17',3310504157,1),(264932693,425814080,16392401,459604,1,'2008-05-16 21:21:17',3310504157,1),(264932694,425830345,16417459,459604,1,'2008-05-16 21:21:17',3310504157,1),(264932695,425833422,16447791,459604,1,'2008-05-16 21:21:17',3310504159,1),(264932696,425837818,16464936,459604,1,'2008-05-16 21:21:18',3310504330,1),(264932697,425848369,16498785,459604,1,'2008-05-16 21:21:18',3310504352,1),(264932698,425847490,16521205,459604,1,'2008-05-16 21:21:18',3310504352,1),(264932699,425838698,16537470,459604,1,'2008-05-16 21:21:18',3310504354,1),(264932701,425838698,16557692,459604,1,'2008-05-16 21:21:18',3310504354,1),(264932702,425840456,16570880,459604,1,'2008-05-16 21:21:18',3310504354,1),(264932703,425852765,16574836,459604,1,'2008-05-16 21:21:18',3310504354,1),(264932704,425856282,16570880,459604,1,'2008-05-16 21:21:18',3310504354,1),(264932705,425860678,16559890,459604,1,'2008-05-16 21:21:18',3310504354,1),(264932706,425867272,16533074,459604,1,'2008-05-16 21:21:18',3310504353,1),(264932707,425879141,16484718,459604,1,'2008-05-16 21:21:18',3310504353,1),(264932708,425880460,16463617,459604,1,'2008-05-16 21:21:18',3310504331,1),(264932710,425897165,16489553,459604,1,'2008-05-16 21:21:19',3310504356,1),(264932711,425915628,16484718,459604,1,'2008-05-16 21:21:19',3310504356,1),(264932712,425934970,16483399,459604,1,'2008-05-16 21:21:19',3310504357,1),(264932713,425938927,16483399,459604,1,'2008-05-16 21:21:19',3310504357,1),(264932714,425964424,16485597,459604,1,'2008-05-16 21:21:19',3310504368,1),(264932715,425987283,16483839,459604,1,'2008-05-16 21:21:19',3310504369,1),(264932716,426004428,16483839,459604,1,'2008-05-16 21:21:19',3310504372,1),(264932717,426035639,16509336,459604,1,'2008-05-16 21:21:19',3310504373,1),(264932718,426048388,16518128,459604,1,'2008-05-16 21:21:19',3310504373,1),(264932719,426080039,16524722,459604,1,'2008-05-16 21:21:19',3310504416,1),(264932720,426109492,16521205,459604,1,'2008-05-16 21:21:19',3310504417,1),(264932722,426134989,16502742,459604,1,'2008-05-16 21:21:19',3310504420,1),(264932723,426129714,16477245,459604,1,'2008-05-16 21:21:19',3310504398,1),(264932724,426118724,16457902,459604,1,'2008-05-16 21:21:19',3310504398,1),(264932725,426138067,16438560,459604,1,'2008-05-16 21:21:20',3310504398,1),(264932726,426152573,16412623,459604,1,'2008-05-16 21:21:20',3310504397,1),(264932727,426148082,16341682,459604,1,'2008-05-16 21:21:20',3310504391,1),(264932728,426118937,16332574,459604,1,'2008-05-16 21:21:20',3310504390,1),(264932729,426094800,16336217,459604,1,'2008-05-16 21:21:20',3310504387,1),(264932731,426079316,16337583,459604,1,'2008-05-16 21:21:20',3310504386,1),(264932732,426046983,16338494,459604,1,'2008-05-16 21:21:20',3310504343,1),(264932733,426024213,16330297,459604,1,'2008-05-16 21:21:20',3310504342,1),(264932734,425985504,16316179,459604,1,'2008-05-16 21:21:20',3310504339,1),(264932735,425970931,16313902,459604,1,'2008-05-16 21:21:20',3310504336,1),(264932736,425948161,16318001,459604,1,'2008-05-16 21:21:20',3310504338,1),(264932737,425940874,16319823,459604,1,'2008-05-16 21:21:20',3310504327,1),(264932738,425907630,16322100,459604,1,'2008-05-16 21:21:20',3310504326,1),(264932739,425882127,16323921,459604,1,'2008-05-16 21:21:20',3310504323,1),(264932740,425858902,16323921,459604,1,'2008-05-16 21:21:20',3310504322,1),(264932742,425842052,16332119,459604,1,'2008-05-16 21:21:21',3310504322,1),(264932743,425822925,16357621,459604,1,'2008-05-16 21:21:21',3310504151,1),(264932744,425846150,16364452,459604,1,'2008-05-16 21:21:21',3310504322,1),(264932745,425866643,16377659,459604,1,'2008-05-16 21:21:21',3310504329,1),(264932746,425885770,16381302,459604,1,'2008-05-16 21:21:21',3310504329,1),(264932747,425908540,16370828,459604,1,'2008-05-16 21:21:21',3310504332,1),(264932748,425924935,16370828,459604,1,'2008-05-16 21:21:21',3310504333,1),(264932749,425947250,16370372,459604,1,'2008-05-16 21:21:21',3310504344,1),(264932750,425964100,16369462,459604,1,'2008-05-16 21:21:21',3310504338,1),(264932752,425975940,16377203,459604,1,'2008-05-16 21:21:21',3310504345,1),(264932753,426004175,16370828,459604,1,'2008-05-16 21:21:21',3310504348,1),(264932754,426011006,16373560,459604,1,'2008-05-16 21:21:21',3310504348,1),(264932755,426022847,16376748,459604,1,'2008-05-16 21:21:21',3310504348,1),(264932756,426039696,16382213,459604,1,'2008-05-16 21:21:22',3310504349,1),(264932757,426057457,16382668,459604,1,'2008-05-16 21:21:22',3310504392,1),(264932759,426069753,16380847,459604,1,'2008-05-16 21:21:22',3310504392,1),(264932760,426080227,16379480,459604,1,'2008-05-16 21:21:22',3310504392,1),(264932761,426096166,16376293,459604,1,'2008-05-16 21:21:22',3310504393,1),(264932762,426108007,16376293,459604,1,'2008-05-16 21:21:22',3310504393,1),(264932763,426123035,16370828,459604,1,'2008-05-16 21:21:22',3310504396,1),(264932764,426129866,16362175,459604,1,'2008-05-16 21:21:22',3310504390,1),(264932765,425757309,16509404,459604,1,'2008-05-16 21:21:22',3310504177,1),(264932766,425748520,16529913,459604,1,'2008-05-16 21:21:22',3310504176,1),(264932767,425748101,16544980,459604,1,'2008-05-16 21:21:22',3310504178,1),(264932769,425754379,16567163,459604,1,'2008-05-16 21:21:22',3310504179,1),(264932770,425757728,16583486,459604,1,'2008-05-16 21:21:22',3310504179,1),(264932771,425756472,16624504,459604,1,'2008-05-16 21:21:22',3310504185,1),(264932772,425756472,16646687,459604,1,'2008-05-16 21:21:23',3310504187,1),(264932773,425753542,16666777,459604,1,'2008-05-16 21:21:23',3310504186,1),(264932774,425749357,16673892,459604,1,'2008-05-16 21:21:23',3310504186,1),(264932775,425737219,16668032,459604,1,'2008-05-16 21:21:23',3310504186,1),(264932776,425712943,16656732,459604,1,'2008-05-16 21:21:23',3310504175,1),(264932777,425699969,16652128,459604,1,'2008-05-16 21:21:23',3310504175,1),(264932779,425695783,16655476,459604,1,'2008-05-16 21:21:23',3310504174,1),(264932780,425692435,16658824,459604,1,'2008-05-16 21:21:23',3310504174,1),(264932781,425679041,16654221,459604,1,'2008-05-16 21:21:23',3310504174,1),(264932782,425665648,16650454,459604,1,'2008-05-16 21:21:23',3310504171,1),(264932783,425658114,16639990,459604,1,'2008-05-16 21:21:23',3310504169,1),(264932784,425659788,16604414,459604,1,'2008-05-16 21:21:23',3310504169,1),(264932785,425660625,16576371,459604,1,'2008-05-16 21:21:23',3310504163,1),(264932786,425663555,16553770,459604,1,'2008-05-16 21:21:24',3310504163,1),(264932787,425666066,16534517,459604,1,'2008-05-16 21:21:24',3310504161,1),(264932788,425678623,16511497,459604,1,'2008-05-16 21:21:24',3310504164,1),(264932789,425689086,16497266,459604,1,'2008-05-16 21:21:24',3310504164,1),(264932791,425709176,16493918,459604,1,'2008-05-16 21:21:24',3310504165,1),(264932792,425725081,16496429,459604,1,'2008-05-16 21:21:24',3310504165,1),(264932793,425728011,16499359,459604,1,'2008-05-16 21:21:24',3310504176,1),(264932794,425734289,16501870,459604,1,'2008-05-16 21:21:24',3310504176,1),(264932795,425745171,16503126,459604,1,'2008-05-16 21:21:24',3310504176,1),(264932796,425785888,16653751,459604,1,'2008-05-16 21:21:24',3310504190,1),(264932797,425804071,16648837,459604,1,'2008-05-16 21:21:24',3310504190,1),(264932798,425821763,16656208,459604,1,'2008-05-16 21:21:24',3310504191,1),(264932800,425835522,16665545,459604,1,'2008-05-16 21:21:24',3310504191,1),(264932801,425849774,16672917,459604,1,'2008-05-16 21:21:24',3310504362,1),(264932802,425869431,16679305,459604,1,'2008-05-16 21:21:25',3310504363,1),(264932803,425878277,16685203,459604,1,'2008-05-16 21:21:25',3310504363,1),(264932804,425890071,16696997,459604,1,'2008-05-16 21:21:25',3310504363,1),(264932805,425898917,16708300,459604,1,'2008-05-16 21:21:25',3310504708,1),(264932806,425917100,16723043,459604,1,'2008-05-16 21:21:25',3310504708,1),(264932807,425937740,16749580,459604,1,'2008-05-16 21:21:25',3310504709,1),(264932808,425947077,16760391,459604,1,'2008-05-16 21:21:25',3310504722,1),(264932809,425953465,16783488,459604,1,'2008-05-16 21:21:25',3310504722,1),(264932811,425960837,16797248,459604,1,'2008-05-16 21:21:25',3310504722,1),(264932812,425980494,16818871,459604,1,'2008-05-16 21:21:25',3310504729,1),(264932813,425989831,16847374,459604,1,'2008-05-16 21:21:25',3310504729,1),(264932814,426002117,16872928,459604,1,'2008-05-16 21:21:25',3310504734,1),(264932815,426009488,16893077,459604,1,'2008-05-16 21:21:25',3310504734,1),(264932816,426016368,16925511,459604,1,'2008-05-16 21:21:26',3310504756,1),(264932817,426014402,16950574,459604,1,'2008-05-16 21:21:26',3310504756,1),(264932818,426005065,16972197,459604,1,'2008-05-16 21:21:26',3310504756,1),(264932820,426008505,17004140,459604,1,'2008-05-16 21:21:26',3310504758,1),(264932821,426001134,17022814,459604,1,'2008-05-16 21:21:26',3310504755,1),(264932822,426001134,17047877,459604,1,'2008-05-16 21:21:26',3310504761,1),(264932823,425997694,17080311,459604,1,'2008-05-16 21:21:26',3310504761,1),(264932824,425982951,17058688,459604,1,'2008-05-16 21:21:26',3310504761,1),(264932825,425953465,17057214,459604,1,'2008-05-16 21:21:26',3310504760,1),(264932826,425948060,17064094,459604,1,'2008-05-16 21:21:26',3310504760,1),(264932827,425942162,17072448,459604,1,'2008-05-16 21:21:26',3310504749,1),(264932828,425940197,17101934,459604,1,'2008-05-16 21:21:26',3310504751,1),(264932829,425929877,17134860,459604,1,'2008-05-16 21:21:26',3310504751,1),(264932831,425918574,17131911,459604,1,'2008-05-16 21:21:26',3310504750,1),(264932832,425913660,17119625,459604,1,'2008-05-16 21:21:27',3310504750,1),(264932833,425899408,17042963,459604,1,'2008-05-16 21:21:27',3310504748,1),(264932834,425910711,17023797,459604,1,'2008-05-16 21:21:27',3310504742,1),(264932835,425936265,16987431,459604,1,'2008-05-16 21:21:27',3310504743,1),(264932836,425945111,16959911,459604,1,'2008-05-16 21:21:27',3310504741,1),(264932837,425941671,16909294,459604,1,'2008-05-16 21:21:27',3310504719,1),(264932838,425924962,16892094,459604,1,'2008-05-16 21:21:27',3310504719,1),(264932839,425904814,16901431,459604,1,'2008-05-16 21:21:27',3310504718,1),(264932840,425865991,16903397,459604,1,'2008-05-16 21:21:27',3310504715,1),(264932841,425866482,16885705,459604,1,'2008-05-16 21:21:27',3310504715,1),(264932842,425846334,16805603,459604,1,'2008-05-16 21:21:27',3310504706,1),(264932843,425824220,16811500,459604,1,'2008-05-16 21:21:27',3310504541,1),(264932844,425813900,16811991,459604,1,'2008-05-16 21:21:27',3310504541,1),(264932846,425801123,16816905,459604,1,'2008-05-16 21:21:28',3310504540,1),(264932847,425784905,16829683,459604,1,'2008-05-16 21:21:28',3310504540,1),(264932848,425778517,16843443,459604,1,'2008-05-16 21:21:28',3310504537,1),(264932849,425777043,16880300,459604,1,'2008-05-16 21:21:28',3310504539,1),(264932850,425752471,16898483,459604,1,'2008-05-16 21:21:28',3310504538,1),(264932851,425738711,16896025,459604,1,'2008-05-16 21:21:28',3310504538,1),(264932852,425720037,16892094,459604,1,'2008-05-16 21:21:28',3310504527,1),(264932853,425692517,16890620,459604,1,'2008-05-16 21:21:28',3310504526,1),(264932855,425666471,16890620,459604,1,'2008-05-16 21:21:28',3310504523,1),(264932856,425643865,16897008,459604,1,'2008-05-16 21:21:28',3310504522,1),(264932857,425624700,16915683,459604,1,'2008-05-16 21:21:28',3310504522,1),(264932858,425606025,16936323,459604,1,'2008-05-16 21:21:28',3310504501,1),(264932859,425588825,16934848,459604,1,'2008-05-16 21:21:28',3310504500,1),(264932860,425587843,16905363,459604,1,'2008-05-16 21:21:29',3310504478,1),(264932861,425597671,16885214,459604,1,'2008-05-16 21:21:29',3310504479,1),(264932862,425608974,16862117,459604,1,'2008-05-16 21:21:29',3310504477,1),(264932864,425638951,16814448,459604,1,'2008-05-16 21:21:29',3310504520,1),(264932865,425666963,16808060,459604,1,'2008-05-16 21:21:29',3310504515,1),(264932866,425719054,16791351,459604,1,'2008-05-16 21:21:29',3310504519,1),(264932867,425742643,16764323,459604,1,'2008-05-16 21:21:29',3310504530,1),(264932868,425780974,16717637,459604,1,'2008-05-16 21:21:29',3310504529,1),(264932869,425792277,16694540,459604,1,'2008-05-16 21:21:29',3310504190,1),(264932870,425800631,16703877,459604,1,'2008-05-16 21:21:29',3310504532,1),(264932871,425806528,16688151,459604,1,'2008-05-16 21:21:29',3310504190,1),(265050188,425101882,15336032,462689,1,'2008-05-17 12:19:49',3310491451,1),(265518806,425101014,15339653,470312,1,'2008-05-18 12:17:16',3310491451,1),(266322580,425779470,15180282,498434,1,'2008-05-22 17:17:09',3310502513,2),(266322581,425779028,15181227,498434,1,'2008-05-22 17:15:18',3310502513,1),(266322582,425778838,15181656,498434,1,'2008-05-22 17:15:18',3310502513,1),(266322583,425778206,15180797,498434,1,'2008-05-22 17:15:18',3310502513,1),(266322584,425777385,15179682,498434,1,'2008-05-22 17:15:18',3310502513,1),(266322585,425776563,15178909,498434,1,'2008-05-22 17:15:18',3310502513,1),(266322586,425775931,15178223,498434,1,'2008-05-22 17:15:18',3310502513,1),(266322587,425775236,15178394,498434,1,'2008-05-22 17:15:18',3310502513,1),(266322588,425774477,15178566,498434,1,'2008-05-22 17:15:18',3310502513,1),(266322589,425773782,15178909,498434,1,'2008-05-22 17:15:18',3310502513,1),(266322590,425773403,15179253,498434,1,'2008-05-22 17:15:18',3310502513,1),(266322676,425779091,15182686,498434,1,'2008-05-22 17:15:50',3310502513,1),(266322954,425779913,15179596,498434,1,'2008-05-22 17:17:09',3310502513,1),(266324553,425776121,15180111,498434,1,'2008-05-22 17:26:34',3310502513,1),(266324699,425779660,15183029,498434,1,'2008-05-22 17:27:37',3310502513,2),(266325046,425686489,15217155,498434,1,'2008-05-22 17:32:54',3310502502,1),(266325047,425687627,15218271,498434,1,'2008-05-22 17:32:54',3310502502,1),(266325048,425688385,15219215,498434,1,'2008-05-22 17:32:54',3310502502,1),(266325224,425686362,15225910,498434,1,'2008-05-22 17:35:02',3310502502,1),(266325225,425686236,15225395,498434,1,'2008-05-22 17:35:02',3310502502,1),(266325226,425686742,15223163,498434,1,'2008-05-22 17:35:02',3310502502,1),(266325227,425687437,15221275,498434,1,'2008-05-22 17:35:02',3310502502,1),(266325228,425689270,15218614,498434,1,'2008-05-22 17:35:02',3310502502,1),(266325229,425690471,15217756,498434,1,'2008-05-22 17:35:02',3310502502,1),(266325230,425691988,15216812,498434,1,'2008-05-22 17:35:02',3310502502,1),(266325231,425692557,15216726,498434,1,'2008-05-22 17:35:02',3310502502,1),(266325232,425694264,15216812,498434,1,'2008-05-22 17:35:02',3310502502,1),(266325399,425685414,15216211,498434,1,'2008-05-22 17:37:33',3310502500,1),(266325427,425690155,15219730,498434,1,'2008-05-22 17:38:53',3310502502,1),(266325428,425689649,15218357,498434,1,'2008-05-22 17:38:53',3310502502,1),(266326164,425633013,15276773,498434,1,'2008-05-22 17:52:10',3310502504,1),(266326319,425632823,15276258,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326320,425633835,15276173,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326321,425635162,15276001,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326322,425637059,15276001,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326323,425638576,15276001,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326324,425639777,15276087,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326325,425640789,15276344,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326326,425641421,15276430,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326327,425642116,15276258,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326328,425642369,15275743,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326329,425642369,15275057,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326330,425642116,15274370,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326331,425641800,15273855,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326332,425641484,15273426,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326333,425640915,15272825,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326334,425640662,15271881,498434,1,'2008-05-22 17:56:24',3310502504,1),(266326335,425640852,15270937,498434,1,'2008-05-22 17:56:24',3310502498,1),(266326336,425641294,15270422,498434,1,'2008-05-22 17:56:24',3310502498,1),(266326337,425641926,15269907,498434,1,'2008-05-22 17:56:24',3310502498,1),(266326338,425642622,15269564,498434,1,'2008-05-22 17:56:24',3310502498,1),(266326339,425643507,15269478,498434,1,'2008-05-22 17:56:24',3310502498,1),(266326340,425644518,15269392,498434,1,'2008-05-22 17:56:24',3310502499,1),(266326341,425645150,15269564,498434,1,'2008-05-22 17:56:24',3310502499,1),(266326342,425645466,15270164,498434,1,'2008-05-22 17:56:24',3310502499,1),(266326343,425645656,15271023,498434,1,'2008-05-22 17:56:24',3310502499,1),(266326344,425645846,15272138,498434,1,'2008-05-22 17:56:24',3310502505,1),(266326345,425645909,15273168,498434,1,'2008-05-22 17:56:24',3310502505,1),(266326346,425645846,15274113,498434,1,'2008-05-22 17:56:24',3310502505,1),(266326347,425645909,15274971,498434,1,'2008-05-22 17:56:24',3310502505,1),(266326348,425646162,15275658,498434,1,'2008-05-22 17:56:24',3310502505,1),(266326349,425646668,15276173,498434,1,'2008-05-22 17:56:24',3310502505,1),(266326350,425647426,15276687,498434,1,'2008-05-22 17:56:24',3310502505,1),(266326393,425646541,15272825,498434,1,'2008-05-22 17:58:10',3310502505,1),(266326394,425647742,15272482,498434,1,'2008-05-22 17:58:10',3310502505,1),(266326395,425648880,15272224,498434,1,'2008-05-22 17:58:10',3310502505,1),(266326396,425649828,15271967,498434,1,'2008-05-22 17:58:10',3310502505,1),(266326397,425650397,15271452,498434,1,'2008-05-22 17:58:10',3310502505,1),(266326398,425650650,15270937,498434,1,'2008-05-22 17:58:10',3310502499,1),(266326399,425650840,15270422,498434,1,'2008-05-22 17:58:10',3310502499,1),(266326487,425642559,15276516,498434,1,'2008-05-22 18:00:45',3310502504,1),(266326488,425643001,15277460,498434,1,'2008-05-22 18:00:45',3310502504,1),(266326489,425643570,15278232,498434,1,'2008-05-22 18:00:45',3310502504,1),(266326490,425644202,15278833,498434,1,'2008-05-22 18:00:45',3310502504,1),(266326491,425644834,15279520,498434,1,'2008-05-22 18:00:45',3310502505,1),(266326492,425645277,15280121,498434,1,'2008-05-22 18:00:45',3310502505,1),(266326493,425645783,15280893,498434,1,'2008-05-22 18:00:45',3310502505,1),(266326494,425645846,15281237,498434,1,'2008-05-22 18:00:45',3310502505,1),(266326495,425645719,15281666,498434,1,'2008-05-22 18:00:45',3310502505,1),(266326496,425645340,15281752,498434,1,'2008-05-22 18:00:45',3310502505,1),(266326497,425644898,15281666,498434,1,'2008-05-22 18:00:45',3310502505,1),(266326498,425644076,15281494,498434,1,'2008-05-22 18:00:45',3310502504,1),(266326499,425643064,15281151,498434,1,'2008-05-22 18:00:45',3310502504,1),(266326500,425642369,15280979,498434,1,'2008-05-22 18:00:45',3310502504,1),(266326501,425641674,15280893,498434,1,'2008-05-22 18:00:45',3310502504,1),(266326502,425641041,15281151,498434,1,'2008-05-22 18:00:45',3310502504,1),(266326503,425640156,15281666,498434,1,'2008-05-22 18:00:45',3310502504,1),(266326504,425639145,15282266,498434,1,'2008-05-22 18:00:45',3310502504,1),(266326505,425638513,15282781,498434,1,'2008-05-22 18:00:45',3310502504,1),(266327105,425631496,15278061,498434,1,'2008-05-22 18:08:07',3310502504,1),(266327106,425632065,15276602,498434,1,'2008-05-22 18:08:07',3310502504,1),(266328657,425554831,15326753,498434,1,'2008-05-22 18:23:35',3310502459,1),(266328658,425554136,15325379,498434,1,'2008-05-22 18:23:35',3310502457,1),(266328659,425553566,15323920,498434,1,'2008-05-22 18:23:35',3310502457,1),(266328660,425553250,15322289,498434,1,'2008-05-22 18:23:35',3310502457,1),(266328661,425553250,15320573,498434,1,'2008-05-22 18:23:35',3310502457,1),(266328662,425553250,15318770,498434,1,'2008-05-22 18:23:35',3310502457,1),(266328663,425553377,15317225,498434,1,'2008-05-22 18:23:35',3310502457,1),(266328664,425553566,15315680,498434,1,'2008-05-22 18:23:35',3310502457,1),(266328665,425553693,15314650,498434,1,'2008-05-22 18:23:35',3310502457,1),(266328829,425553250,15319371,498434,1,'2008-05-22 18:25:06',3310502457,1),(266328830,425551859,15319371,498434,1,'2008-05-22 18:25:06',3310502457,1),(266328831,425550089,15319285,498434,1,'2008-05-22 18:25:06',3310502457,1),(266328832,425548256,15319114,498434,1,'2008-05-22 18:25:06',3310502457,1),(266328833,425546296,15318942,498434,1,'2008-05-22 18:25:06',3310502457,1),(266328834,425543387,15318427,498434,1,'2008-05-22 18:25:06',3310502457,1),(266328982,425555716,15334821,72964,1,'2008-08-05 20:37:35',3310502459,3),(266329104,425564884,15346751,498434,1,'2008-05-22 18:32:56',3310502462,1),(266329120,425566970,15349583,498434,1,'2008-05-22 18:33:39',3310502462,1),(266329121,425567476,15349498,498434,1,'2008-05-22 18:33:39',3310502462,1),(266329122,425567729,15348811,498434,1,'2008-05-22 18:33:39',3310502462,1),(266329123,425567665,15348124,498434,1,'2008-05-22 18:33:39',3310502462,1),(266329124,425567349,15347781,498434,1,'2008-05-22 18:33:39',3310502462,1),(266329307,425566527,15348639,498434,1,'2008-05-22 18:38:15',3310502462,1),(266329457,425561090,15369410,498434,1,'2008-05-22 18:39:57',3310502459,1),(266329707,425571901,15366235,498434,1,'2008-05-22 19:36:41',3310502462,2),(266329708,425572218,15368466,498434,1,'2008-05-22 18:44:19',3310502462,1),(266329709,425572787,15370354,498434,1,'2008-05-22 18:44:19',3310502462,1),(266329710,425573356,15372500,498434,1,'2008-05-22 18:44:19',3310502462,1),(266329711,425574114,15373959,498434,1,'2008-05-22 18:44:19',3310502462,1),(266329712,425574430,15374904,498434,1,'2008-05-22 18:44:19',3310502462,1),(266329713,425574494,15375676,498434,1,'2008-05-22 18:44:19',3310502462,1),(266329714,425574430,15376448,498434,1,'2008-05-22 18:44:19',3310502462,1),(266329715,425574051,15377564,498434,1,'2008-05-22 18:44:19',3310502462,1),(266329716,425573672,15378852,498434,1,'2008-05-22 18:44:19',3310502462,1),(266329717,425573608,15380053,498434,1,'2008-05-22 18:44:19',3310502462,1),(266329718,425573545,15382285,498434,1,'2008-05-22 18:44:19',3310502548,1),(266329719,425573861,15383830,498434,1,'2008-05-22 18:44:19',3310502548,1),(266329720,425574430,15385632,498434,1,'2008-05-22 18:44:19',3310502548,1),(266329721,425574999,15387263,498434,1,'2008-05-22 18:44:19',3310502548,1),(266329722,425576264,15390181,498434,1,'2008-05-22 18:44:19',3310502548,1),(266329723,425577275,15392670,498434,1,'2008-05-22 18:44:19',3310502548,1),(266329724,425578034,15395074,498434,1,'2008-05-22 18:44:19',3310502548,1),(266329725,425578603,15397477,498434,1,'2008-05-22 18:44:19',3310502548,1),(266329726,425578982,15398335,498434,1,'2008-05-22 18:44:19',3310502548,1),(266329727,425567918,15350270,498434,1,'2008-05-22 19:36:41',3310502462,2),(266329728,425568614,15352244,498434,1,'2008-05-22 19:38:30',3310502462,3),(266329729,425568867,15354047,498434,1,'2008-05-22 19:38:30',3310502462,3),(266329730,425568993,15355677,498434,1,'2008-05-22 19:36:41',3310502462,2),(266329731,425569056,15358081,498434,1,'2008-05-22 19:36:41',3310502462,2),(266329732,425568993,15361256,498434,1,'2008-05-22 19:36:41',3310502462,2),(266329733,425569373,15362286,498434,1,'2008-05-22 19:38:30',3310502462,3),(266329734,425570005,15363059,498434,1,'2008-05-22 19:36:41',3310502462,2),(266329735,425571206,15364518,498434,1,'2008-05-22 19:36:41',3310502462,2),(266330464,425573482,15375590,498434,1,'2008-05-22 19:33:13',3310502462,2),(266330465,425572534,15375161,498434,1,'2008-05-22 18:48:59',3310502462,1),(266330466,425571775,15374560,498434,1,'2008-05-22 18:48:59',3310502462,1),(266330467,425570953,15373959,498434,1,'2008-05-22 18:48:59',3310502462,1),(266330468,425569942,15372586,498434,1,'2008-05-22 18:48:59',3310502462,1),(266330469,425568993,15371041,498434,1,'2008-05-22 18:48:59',3310502462,1),(266330470,425568108,15370183,498434,1,'2008-05-22 18:48:59',3310502462,1),(266330471,425567096,15369925,498434,1,'2008-05-22 18:48:59',3310502462,1),(266330472,425565832,15369754,498434,1,'2008-05-22 18:48:59',3310502462,1),(266330473,425564504,15369668,498434,1,'2008-05-22 18:48:59',3310502462,1),(266330475,425561146,15370222,2836771,1,'2009-10-13 18:40:26',3310502459,2),(266330476,425559130,15370784,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330477,425557613,15370784,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330478,425555526,15371041,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330479,425552997,15371470,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330480,425550026,15371985,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330481,425547813,15372329,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330482,425545600,15372157,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330483,425544652,15371899,2895121,1,'2009-10-19 19:03:33',3310502459,2),(266330484,425543071,15371556,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330485,425541870,15371556,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330486,425540289,15371556,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330487,425538645,15371127,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330488,425536812,15370612,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330489,425535041,15370526,498434,1,'2008-05-22 18:48:59',3310502459,1),(266330490,425533650,15370612,498434,1,'2008-05-22 18:48:59',3310502458,1),(266330491,425532196,15369496,498434,1,'2008-05-22 18:48:59',3310502458,1),(266330492,425531058,15368810,498434,1,'2008-05-22 18:48:59',3310502458,1),(266330493,425529983,15367865,498434,1,'2008-05-22 18:48:59',3310502458,1),(266330494,425528213,15366406,498434,1,'2008-05-22 18:48:59',3310502458,1),(266330495,425526885,15364776,498434,1,'2008-05-22 18:48:59',3310502458,1),(266330502,425527328,15372672,498434,1,'2008-05-22 18:49:24',3310502458,1),(266330503,425527960,15371299,498434,1,'2008-05-22 18:49:24',3310502458,1),(266330504,425528908,15370011,498434,1,'2008-05-22 18:49:24',3310502458,1),(266330505,425529477,15368895,498434,1,'2008-05-22 18:49:24',3310502458,1),(266330517,425526632,15369840,498434,1,'2008-05-22 18:50:32',3310502458,1),(266330518,425527770,15371728,498434,1,'2008-05-22 18:50:32',3310502458,1),(266330793,425545284,15370698,498434,1,'2008-05-22 18:55:14',3310502459,1),(266330794,425545916,15369496,498434,1,'2008-05-22 18:55:14',3310502459,1),(266330795,425546675,15368466,498434,1,'2008-05-22 18:55:14',3310502459,1),(266330955,425550152,15362887,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330956,425549899,15362029,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330957,425550089,15361171,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330958,425550532,15360741,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330959,425551543,15360312,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330960,425552555,15359883,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330961,425553250,15359454,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330962,425553756,15358596,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330963,425554515,15358338,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330964,425555337,15358338,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330965,425556095,15358424,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330966,425556854,15358424,498434,1,'2008-05-22 18:59:17',3310502459,1),(266330991,425557360,15342889,498434,1,'2008-05-22 19:00:25',3310502459,1),(266330992,425556538,15343060,498434,1,'2008-05-22 19:00:25',3310502459,1),(266330993,425555843,15342631,498434,1,'2008-05-22 19:00:25',3310502459,1),(266330994,425555084,15341687,498434,1,'2008-05-22 19:00:25',3310502459,1),(266330995,425554452,15341172,498434,1,'2008-05-22 19:00:25',3310502459,1),(266330996,425553756,15341172,498434,1,'2008-05-22 19:00:25',3310502459,1),(266330997,425553187,15341515,498434,1,'2008-05-22 19:00:25',3310502459,1),(266330998,425552555,15342460,498434,1,'2008-05-22 19:00:25',3310502459,1),(266330999,425552049,15343575,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331000,425552555,15344262,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331001,425553250,15345120,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331002,425554578,15346579,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331003,425556348,15348554,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331004,425557107,15349412,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331005,425557297,15350613,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331006,425557107,15351300,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331007,425556728,15351901,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331008,425556538,15352588,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331009,425556854,15353017,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331010,425557297,15352759,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331011,425557423,15351987,498434,1,'2008-05-22 19:00:25',3310502459,1),(266331017,425551164,15342889,498434,1,'2008-05-22 19:00:53',3310502459,1),(266331018,425550405,15342202,498434,1,'2008-05-22 19:00:53',3310502459,1),(266331019,425549710,15341430,498434,1,'2008-05-22 19:00:53',3310502459,1),(266331020,425548888,15340571,498434,1,'2008-05-22 19:00:53',3310502459,1),(266331021,425548319,15339455,498434,1,'2008-05-22 19:00:53',3310502459,1),(266331022,425547939,15338683,498434,1,'2008-05-22 19:00:53',3310502459,1),(266331023,425547939,15337396,498434,1,'2008-05-22 19:00:53',3310502459,1),(266331091,425558119,15342631,498434,1,'2008-05-22 19:02:20',3310502459,1),(266331233,425557234,15339713,498434,1,'2008-05-22 19:03:35',3310502459,1),(266331234,425558119,15339112,498434,1,'2008-05-22 19:03:35',3310502459,1),(266331235,425558751,15338940,498434,1,'2008-05-22 19:03:35',3310502459,1),(266331236,425559257,15339112,498434,1,'2008-05-22 19:03:35',3310502459,1),(266331237,425559699,15339627,498434,1,'2008-05-22 19:03:35',3310502459,1),(266331238,425560142,15340485,498434,1,'2008-05-22 19:03:35',3310502459,1),(266331239,425560584,15341430,498434,1,'2008-05-22 19:03:35',3310502459,1),(266331240,425560711,15342374,498434,1,'2008-05-22 19:03:35',3310502459,1),(266331241,425560964,15343404,498434,1,'2008-05-22 19:03:35',3310502459,1),(266331242,425561153,15344262,498434,1,'2008-05-22 19:03:35',3310502459,1),(266331243,425561406,15345120,498434,1,'2008-05-22 19:03:35',3310502459,1),(266331332,425554199,15342030,498434,1,'2008-05-22 19:04:03',3310502459,1),(266331333,425552871,15344519,498434,1,'2008-05-22 19:04:03',3310502459,1),(266331567,425553819,15344605,498434,1,'2008-05-22 19:07:44',3310502459,1),(266331568,425554894,15342545,498434,1,'2008-05-22 19:07:44',3310502459,1),(266331569,425553946,15341687,498434,1,'2008-05-22 19:07:44',3310502459,1),(266331570,425552745,15343575,498434,1,'2008-05-22 19:07:44',3310502459,1),(266331607,425549773,15337052,498434,1,'2008-05-22 19:09:02',3310502459,1),(266331608,425549077,15338254,498434,1,'2008-05-22 19:09:02',3310502459,1),(266331609,425552808,15342116,498434,1,'2008-05-22 19:09:02',3310502459,1),(266331623,425553756,15339799,498434,1,'2008-05-22 19:09:45',3310502459,1),(266331624,425549330,15334992,498434,1,'2008-05-22 19:09:45',3310502459,1),(266331625,425548445,15336623,498434,1,'2008-05-22 19:09:45',3310502459,1),(266331626,425548508,15338597,498434,1,'2008-05-22 19:09:45',3310502459,1),(266331627,425549204,15339970,498434,1,'2008-05-22 19:09:45',3310502459,1),(266331628,425551859,15342631,498434,1,'2008-05-22 19:09:45',3310502459,1),(266331736,425550911,15339026,498434,1,'2008-05-22 19:10:59',3310502459,1),(266331970,425554009,15343318,498434,1,'2008-05-22 19:12:00',3310502459,1),(266331984,425556601,15331902,498434,1,'2008-05-22 19:12:28',3310502459,1),(266331986,425559130,15330958,498434,1,'2008-05-22 19:12:28',3310502459,1),(266331987,425560268,15330615,498434,1,'2008-05-22 19:12:28',3310502459,1),(266331988,425561217,15330443,498434,1,'2008-05-22 19:12:28',3310502459,1),(266331989,425562418,15329757,498434,1,'2008-05-22 19:12:28',3310502462,1),(266332075,425558055,15330357,498434,1,'2008-05-22 19:19:03',3310502459,2),(266332076,425558877,15327782,787878,1,'2009-01-15 00:13:52',3310502459,3),(266332077,425559826,15325894,787878,1,'2009-01-15 00:13:52',3310502457,4),(266332078,425560142,15324006,787878,1,'2009-01-15 00:13:52',3310502457,3),(266332079,425560395,15322118,787878,1,'2009-01-15 00:13:53',3310502457,3),(266332080,425560774,15320058,787878,1,'2009-01-15 00:13:53',3310502457,3),(266332081,425561027,15318169,787878,1,'2009-01-15 00:13:53',3310502457,3),(266332082,425561153,15316281,787878,1,'2009-01-15 00:13:53',3310502457,3),(266332083,425560774,15314565,787878,1,'2009-01-15 00:13:53',3310502457,4),(266332084,425560395,15313020,787878,1,'2009-01-15 00:13:53',3310502457,3),(266332085,425560079,15311475,787878,1,'2009-01-15 00:13:53',3310502457,3),(266332086,425559573,15309844,787878,1,'2009-01-15 00:13:53',3310502457,3),(266332087,425558624,15307698,787878,1,'2009-01-15 00:14:32',3310502457,5),(266332790,425557866,15331387,498434,1,'2008-05-22 19:22:39',3310502459,2),(266332950,425557992,15331387,498434,1,'2008-05-22 19:19:44',3310502459,1),(266333823,425558372,15316624,498434,1,'2008-05-22 19:24:02',3310502457,1),(266333914,425557423,15326152,498434,1,'2008-05-22 19:24:40',3310502457,1),(266333915,425557423,15324435,498434,1,'2008-05-22 19:24:40',3310502457,1),(266333916,425557234,15323834,498434,1,'2008-05-22 19:24:40',3310502457,1),(266333917,425556538,15323663,725665,1,'2009-03-02 22:27:41',3310502457,13),(266333981,425558435,15326066,498434,1,'2008-05-22 19:25:06',3310502457,1),(266333982,425559446,15326924,787878,1,'2009-01-15 00:13:52',3310502459,4),(266334276,425558245,15328126,498434,1,'2008-05-22 19:26:33',3310502459,1),(266334277,425559193,15325637,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334278,425559762,15322976,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334279,425560332,15319543,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334280,425560584,15316624,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334281,425559510,15316024,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334282,425558498,15315509,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334283,425557486,15315251,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334284,425557550,15317054,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334285,425557486,15318599,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334286,425557423,15320487,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334287,425557297,15322289,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334288,425557044,15324521,498434,1,'2008-05-22 19:26:33',3310502457,1),(266334289,425556917,15326667,498434,1,'2008-05-22 19:30:08',3310502459,2),(266334290,425556917,15327525,498434,1,'2008-05-22 19:30:08',3310502459,2),(266334665,425551101,15327353,498434,1,'2008-05-22 19:28:13',3310502459,1),(266334666,425550532,15327954,498434,1,'2008-05-22 19:28:13',3310502459,1),(266334668,425550216,15328469,498434,1,'2008-05-22 19:28:13',3310502459,1),(266334669,425550089,15329242,498434,1,'2008-05-22 19:28:13',3310502459,1),(266334670,425550279,15330014,498434,1,'2008-05-22 19:28:13',3310502459,1),(266334671,425550595,15330615,498434,1,'2008-05-22 19:28:13',3310502459,1),(266334672,425551101,15331645,498434,1,'2008-05-22 19:28:13',3310502459,1),(266334931,425556285,15326066,725665,1,'2009-03-02 22:27:42',3310502457,12),(266334932,425556285,15327267,725665,1,'2009-03-02 22:27:42',3310502459,13),(266336448,425573545,15383658,498434,1,'2008-05-22 19:41:16',3310502548,2),(266336449,425572597,15382972,498434,1,'2008-05-22 19:35:31',3310502548,1),(266336450,425572218,15382371,498434,1,'2008-05-22 19:35:31',3310502548,1),(266336451,425572028,15381512,498434,1,'2008-05-22 19:35:31',3310502548,1),(266336452,425572028,15380568,498434,1,'2008-05-22 19:35:31',3310502462,1),(266336453,425571965,15379624,498434,1,'2008-05-22 19:35:31',3310502462,1),(266336454,425571965,15377993,498434,1,'2008-05-22 19:35:31',3310502462,1),(266336455,425571838,15376963,498434,1,'2008-05-22 19:35:31',3310502462,1),(266336456,425571712,15376363,498434,1,'2008-05-22 19:35:31',3310502462,1),(266336457,425571649,15375590,498434,1,'2008-05-22 19:35:31',3310502462,1),(266336982,425568361,15351300,498434,1,'2008-05-22 19:38:30',3310502462,1),(266337369,425567413,15350613,498434,1,'2008-05-22 19:46:28',3310502462,2),(266337370,425567918,15351643,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337371,425568234,15353360,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337372,425568361,15355077,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337373,425568361,15357308,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337374,425568361,15359883,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337375,425568487,15362029,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337377,425569120,15365205,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337378,425570384,15367780,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337379,425572534,15372071,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337380,425573672,15374303,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337381,425573925,15374989,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337382,425573925,15376363,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337384,425573482,15377736,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337386,425573103,15379109,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337388,425572913,15380654,498434,1,'2008-05-22 19:40:52',3310502462,1),(266337389,425572976,15382542,498434,1,'2008-05-22 19:40:52',3310502548,1),(266337390,425573672,15385203,498434,1,'2008-05-22 19:40:52',3310502548,1),(266337391,425574114,15386319,498434,1,'2008-05-22 19:40:52',3310502548,1),(266337392,425575252,15389752,498434,1,'2008-05-22 19:40:52',3310502548,1),(266337393,425576264,15391898,498434,1,'2008-05-22 19:40:52',3310502548,1),(266337394,425577212,15394902,498434,1,'2008-05-22 19:40:52',3310502548,1),(266337395,425577971,15397906,498434,1,'2008-05-22 19:40:52',3310502548,1),(266337396,425579551,15402112,498434,1,'2008-05-22 19:40:52',3310502548,1),(266337397,425579741,15402970,498434,1,'2008-05-22 19:40:52',3310502548,1),(266338686,425565579,15351386,498434,1,'2008-05-22 19:46:00',3310502462,1),(266340072,425455858,15205846,513066,1,'2008-05-24 16:09:07',3310502436,3),(266340199,425464986,15213055,498434,1,'2008-05-22 19:53:32',3310502436,1),(266340717,425472321,15217175,498434,1,'2008-05-22 20:01:08',3310502438,2),(266340718,425471562,15219406,498434,1,'2008-05-22 20:01:08',3310502438,2),(266340719,425471436,15220436,498434,1,'2008-05-22 19:55:12',3310502438,1),(266340720,425471625,15221037,498434,1,'2008-05-22 19:55:12',3310502438,1),(266340721,425472131,15221466,498434,1,'2008-05-22 19:55:12',3310502438,1),(266340722,425472763,15221895,498434,1,'2008-05-22 19:55:12',3310502438,1),(266340993,425471119,15218891,498434,1,'2008-05-22 19:57:05',3310502438,1),(266340994,425469981,15217690,498434,1,'2008-05-22 19:57:05',3310502438,1),(266340995,425469159,15216917,498434,1,'2008-05-22 19:57:05',3310502438,1),(266340996,425468084,15216488,498434,1,'2008-05-22 19:57:05',3310502438,1),(266340998,425466630,15216660,498434,1,'2008-05-22 19:57:05',3310502438,1),(266340999,425464670,15216831,498434,1,'2008-05-22 19:57:05',3310502438,1),(266341000,425464037,15216831,498434,1,'2008-05-22 19:57:05',3310502438,1),(266341001,425464417,15220093,498434,1,'2008-05-22 19:57:05',3310502438,1),(266341002,425465681,15221037,498434,1,'2008-05-22 19:57:05',3310502438,1),(266341003,425466946,15221552,498434,1,'2008-05-22 19:57:05',3310502438,1),(266341004,425468400,15221380,498434,1,'2008-05-22 19:57:05',3310502438,1),(266341005,425469159,15221123,498434,1,'2008-05-22 19:57:05',3310502438,1),(266341006,425470297,15221123,498434,1,'2008-05-22 19:57:05',3310502438,1),(266341007,425471119,15220608,498434,1,'2008-05-22 19:57:05',3310502438,1),(266341806,425472574,15216059,498434,1,'2008-05-22 20:01:08',3310502436,1),(266380119,425457461,15203356,501202,1,'2008-05-22 22:30:34',3310502436,1),(266380259,425456997,15205503,513066,1,'2008-05-24 16:09:07',3310502436,2),(266380260,425456238,15203615,513066,1,'2008-05-24 16:09:07',3310502436,2),(266380266,425457398,15204300,501202,1,'2008-05-22 22:31:58',3310502436,1),(266380267,425457904,15203957,501202,1,'2008-05-22 22:31:58',3310502436,1),(266380268,425455754,15205502,501202,1,'2008-05-22 22:31:58',3310502436,1),(266619895,425493545,15244813,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619896,425492850,15244899,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619897,425492154,15244813,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619898,425491585,15244384,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619899,425491142,15243955,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619900,425490637,15243182,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619901,425490068,15242839,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619902,425489372,15242753,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619903,425488550,15242667,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619904,425487728,15242667,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619905,425486779,15242496,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619906,425485578,15242324,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619907,425483808,15242067,513066,1,'2008-05-24 15:58:10',3310502439,1),(266619908,425481721,15241809,513066,1,'2008-05-24 16:04:48',3310502439,2),(266619909,425479445,15241466,513066,1,'2008-05-24 16:04:48',3310502438,2),(266619955,425485009,15240608,513066,1,'2008-05-24 15:58:45',3310502439,1),(266619956,425484440,15240264,513066,1,'2008-05-24 15:58:45',3310502439,1),(266620040,425490447,15240779,513066,1,'2008-05-24 15:59:29',3310502439,1),(266620041,425491142,15241294,513066,1,'2008-05-24 15:59:29',3310502439,1),(266620042,425491712,15241809,513066,1,'2008-05-24 15:59:29',3310502439,1),(266620043,425492028,15242667,513066,1,'2008-05-24 15:59:29',3310502439,1),(266620044,425492154,15243697,513066,1,'2008-05-24 15:59:29',3310502439,1),(266622050,425734780,15185578,513066,1,'2008-05-24 16:12:30',3310502512,1),(266622051,425734338,15183518,513066,1,'2008-05-24 16:12:30',3310502512,1),(266622052,425733706,15182403,513066,1,'2008-05-24 16:12:30',3310502512,1),(266622053,425732947,15181287,513066,1,'2008-05-24 16:12:30',3310502512,1),(266622054,425732252,15180600,513066,1,'2008-05-24 16:12:30',3310502512,1),(266622055,425731241,15180429,513066,1,'2008-05-24 16:12:30',3310502512,1),(266622056,425730419,15180686,513066,1,'2008-05-24 16:12:30',3310502512,1),(266622057,425723592,15183003,513066,1,'2008-05-24 16:12:30',3310502501,1),(266622058,425722644,15182918,513066,1,'2008-05-24 16:12:30',3310502501,1),(266622059,425722328,15181716,513066,1,'2008-05-24 16:12:30',3310502501,1),(266622060,425722518,15180600,513066,1,'2008-05-24 16:12:30',3310502501,1),(266622061,425723466,15179742,513066,1,'2008-05-24 16:12:30',3310502501,1),(266622062,425730229,15176995,513066,1,'2008-05-24 16:12:30',3310502512,1),(266622086,425735855,15183003,513066,1,'2008-05-24 16:13:11',3310502512,1),(266622348,425539542,15295997,725665,1,'2009-03-02 22:31:54',3310502457,3),(266622349,425538151,15295482,725665,1,'2009-03-02 22:31:54',3310502457,3),(266622350,425535432,15294367,725665,1,'2009-03-02 22:31:53',3310502457,3),(266622351,425532587,15292564,725665,1,'2009-03-02 22:31:53',3310502456,3);
INSERT INTO `nodes` VALUES (266622352,425530184,15289646,725665,1,'2009-03-02 22:31:53',3310502456,3),(266622353,425526707,15285354,725665,1,'2009-03-02 22:31:53',3310502456,3),(266622354,425524114,15283123,725665,1,'2009-03-02 22:31:53',3310502456,3),(266622355,425522723,15281406,725665,1,'2009-03-02 22:31:53',3310502456,3),(266622356,425522091,15280033,725665,1,'2009-03-02 22:31:52',3310502456,3),(266622357,425521901,15278917,725665,1,'2009-03-02 22:31:52',3310502456,3),(266622358,425522344,15278488,725665,1,'2009-03-02 22:31:52',3310502456,3),(266622359,425523609,15278488,725665,1,'2009-03-02 22:31:52',3310502456,3),(266622360,425525126,15279346,725665,1,'2009-03-02 22:31:52',3310502456,3),(266622361,425527845,15281406,725665,1,'2009-03-02 22:31:51',3310502456,3),(266622362,425529868,15283552,725665,1,'2009-03-02 22:31:51',3310502456,3),(266622363,425531765,15285183,725665,1,'2009-03-02 22:31:51',3310502456,3),(266622364,425533346,15286556,725665,1,'2009-03-02 22:31:51',3310502456,3),(266622365,425534990,15287414,725665,1,'2009-03-02 22:31:51',3310502457,3),(266622366,425536301,15287142,725665,1,'2009-03-02 22:33:31',3310502457,5),(266622367,425535922,15284653,725665,1,'2009-03-02 22:33:50',3310502457,15),(266622460,425537772,15291363,513066,1,'2008-05-24 16:17:44',3310502457,1),(266622461,425537013,15294882,725665,1,'2009-03-02 22:31:53',3310502457,3),(266622567,425537961,15294281,513066,1,'2008-05-24 16:19:47',3310502457,1),(266622568,425538657,15291019,513066,1,'2008-05-24 16:19:47',3310502457,1),(266622569,425537329,15290161,513066,1,'2008-05-24 16:19:47',3310502457,1),(266622570,425536697,15292564,513066,1,'2008-05-24 16:19:47',3310502457,1),(266622572,425537076,15293079,513066,1,'2008-05-24 16:19:47',3310502457,1),(266622573,425536823,15293938,513066,1,'2008-05-24 16:19:47',3310502457,1),(266622595,425538088,15291878,513066,1,'2008-05-24 16:20:09',3310502457,1),(266622986,425797454,15188075,513066,1,'2008-05-24 16:28:02',3310502516,1),(266623545,425795368,15186187,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623546,425794673,15185500,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623547,425794041,15184728,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623548,425793472,15184213,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623549,425792145,15183612,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623550,425790818,15182925,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623551,425789870,15182153,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623552,425788858,15181123,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623553,425787847,15179234,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623554,425786773,15176831,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623555,425786393,15175887,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623556,425786267,15175029,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623557,425786267,15174085,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623558,425786773,15173655,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623559,425787341,15173741,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623560,425788100,15174256,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623561,425789301,15175458,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623562,425790691,15176745,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623563,425792082,15177604,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623564,425792650,15177947,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623565,425793219,15177689,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623566,425793598,15177174,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623567,425793725,15176660,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623568,425793535,15176145,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623569,425792714,15174943,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623570,425791386,15173055,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623571,425790249,15170995,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623572,425789301,15169278,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623573,425788416,15167046,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623574,425787405,15165587,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623575,425786520,15164729,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623576,425784940,15163785,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623577,425782412,15162841,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623578,425780136,15162154,513066,1,'2008-05-24 16:34:00',3310502513,1),(266623579,425777798,15161639,513066,1,'2008-05-24 16:34:00',3310502513,1),(266623580,425776281,15160952,513066,1,'2008-05-24 16:34:00',3310502491,1),(266623581,425774764,15160523,513066,1,'2008-05-24 16:34:00',3310502491,1),(266623582,425773753,15160180,513066,1,'2008-05-24 16:34:00',3310502491,1),(266623583,425773058,15159923,513066,1,'2008-05-24 16:34:00',3310502491,1),(266623584,425772299,15159408,513066,1,'2008-05-24 16:34:00',3310502491,1),(266623585,425771857,15158635,513066,1,'2008-05-24 16:34:00',3310502491,1),(266623586,425771541,15157691,513066,1,'2008-05-24 16:34:00',3310502491,1),(266623587,425771478,15157090,513066,1,'2008-05-24 16:34:00',3310502491,1),(266623588,425770972,15156661,513066,1,'2008-05-24 16:34:00',3310502491,1),(266623589,425769392,15156232,513066,1,'2008-05-24 16:34:00',3310502491,1),(266623590,425797454,15187303,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623591,425797011,15186959,513066,1,'2008-05-24 16:34:00',3310502516,1),(266623592,425796126,15186444,513066,1,'2008-05-24 16:34:00',3310502516,1),(268081065,425822138,15190634,19873,1,'2008-06-02 18:28:51',3310502517,1),(268081234,425821954,15195994,19873,1,'2008-06-02 18:29:59',3310502517,1),(268081236,425822081,15197281,19873,1,'2008-06-02 18:29:59',3310502517,1),(268081237,425822460,15198826,19873,1,'2008-06-02 18:29:59',3310502517,1),(268081238,425823029,15200800,19873,1,'2008-06-02 18:29:59',3310502517,1),(268081239,425823155,15202002,19873,1,'2008-06-02 18:31:13',3310502517,2),(268081241,425823155,15203032,19873,1,'2008-06-02 18:29:59',3310502517,1),(268081242,425823092,15204062,19873,1,'2008-06-02 18:29:59',3310502517,1),(268081243,425822902,15205006,19873,1,'2008-06-02 18:31:20',3310502517,2),(268081244,425822523,15206465,19873,1,'2008-06-02 18:31:13',3310502517,2),(268081245,425822460,15207409,19873,1,'2008-06-02 18:29:59',3310502517,1),(268081246,425822650,15207839,19873,1,'2008-06-02 18:29:59',3310502517,1),(268081464,425822270,15192647,19873,1,'2008-06-02 18:31:13',3310502517,1),(268082898,425440876,15104812,19873,1,'2008-06-02 18:40:07',3310502409,1),(268082899,425439554,15103812,19873,1,'2008-06-02 18:40:07',3310502409,1),(268084313,425782875,14790027,19873,1,'2008-06-02 18:53:32',3310502134,1),(268085831,425772194,14799383,19873,1,'2008-06-02 18:58:22',3310502131,1),(268091938,425656142,14914782,21109,1,'2008-06-02 23:05:27',3310502123,1),(268091940,425654625,14916327,21109,1,'2008-06-02 23:05:27',3310502123,1),(268091942,425652286,14919503,21109,1,'2008-06-02 23:05:27',3310502123,1),(268091944,425649820,14922250,21109,1,'2008-06-02 23:05:27',3310502123,1),(268091946,425647608,14924653,21109,1,'2008-06-02 23:05:27',3310502123,1),(268091948,425645838,14926455,21109,1,'2008-06-02 23:05:27',3310502123,1),(268091950,425644131,14929545,21109,1,'2008-06-02 23:05:27',3310502122,1),(268092433,425657975,14911178,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092434,425657849,14912379,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092435,425657406,14913667,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092436,425656774,14915469,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092437,425655762,14917100,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092438,425654119,14919761,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092439,425652349,14921906,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092441,425650263,14924052,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092442,425648619,14925940,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092443,425648050,14926627,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092444,425647861,14927657,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092445,425647987,14928773,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092446,425648493,14929631,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092447,425649441,14929459,21109,1,'2008-06-02 23:11:39',3310502123,2),(268092448,425650389,14928687,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092449,425654941,14924138,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092450,425656205,14922078,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092451,425658354,14918216,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092452,425660377,14914353,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092453,425663032,14909804,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092454,425663854,14908860,21109,1,'2008-06-02 23:06:49',3310502123,1),(268092455,425664992,14908259,25362,1,'2008-06-03 01:06:15',3310502123,2),(268092682,425654309,14926799,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092683,425654182,14927829,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092684,425653740,14928859,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092685,425653234,14929889,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092686,425652918,14930747,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092687,425652791,14931434,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092688,425652981,14931949,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092689,425653613,14931691,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092691,425653992,14930575,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092692,425654688,14929631,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092693,425655636,14928687,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092694,425656268,14928344,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092695,425656711,14928601,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092696,425656900,14929288,21109,1,'2008-06-02 23:07:40',3310502123,1),(268092812,425657150,14914396,21109,1,'2008-06-02 23:08:02',3310502123,1),(268093053,425657554,14908874,25362,1,'2008-06-03 01:01:40',3310502123,2),(268093279,425654656,14924423,21109,1,'2008-06-02 23:09:25',3310502123,1),(268093281,425654561,14925855,21109,1,'2008-06-02 23:09:25',3310502123,1),(268095978,425698385,14880562,21109,1,'2008-06-02 23:19:14',3310502124,1),(268095979,425698701,14881592,21109,1,'2008-06-02 23:19:14',3310502124,1),(268095980,425698764,14882278,21109,1,'2008-06-02 23:19:14',3310502124,1),(268095981,425698195,14883394,21109,1,'2008-06-02 23:19:14',3310502124,1),(268095982,425697247,14884596,21109,1,'2008-06-02 23:19:14',3310502124,1),(268095983,425694592,14886570,21109,1,'2008-06-02 23:19:14',3310502124,1),(268095984,425690294,14889574,21109,1,'2008-06-02 23:19:14',3310502126,1),(268095985,425687133,14892406,21109,1,'2008-06-02 23:19:14',3310502126,1),(268095986,425684857,14894466,21109,1,'2008-06-02 23:19:14',3310502126,1),(268095987,425682582,14896784,21109,1,'2008-06-02 23:19:14',3310502126,1),(268096149,425682835,14897556,21109,1,'2008-06-02 23:21:47',3310502126,1),(268096150,425683024,14899187,21109,1,'2008-06-02 23:21:47',3310502126,1),(268096151,425683720,14899874,21109,1,'2008-06-02 23:21:47',3310502126,1),(268096152,425684478,14899702,21109,1,'2008-06-02 23:21:47',3310502126,1),(268096153,425684921,14898672,21109,1,'2008-06-02 23:21:47',3310502126,1),(268096154,425683656,14896612,21109,1,'2008-06-02 23:21:47',3310502126,1),(268096174,425684921,14896011,21109,1,'2008-06-02 23:22:11',3310502126,1),(268096306,425697251,14878938,21109,1,'2008-06-02 23:23:02',3310502124,1),(268100719,425709699,14865063,21109,1,'2008-06-02 23:33:51',3310502125,1),(268100720,425709573,14866179,21109,1,'2008-06-02 23:33:51',3310502125,1),(268100721,425708372,14868067,21109,1,'2008-06-02 23:33:51',3310502125,1),(268100722,425707297,14870042,21109,1,'2008-06-02 23:33:51',3310502125,1),(268100723,425706412,14872874,21109,1,'2008-06-02 23:33:51',3310502125,1),(268100724,425705275,14877852,21109,1,'2008-06-02 23:51:15',3310502125,2),(268100725,425704769,14880770,21109,1,'2008-06-02 23:33:51',3310502125,1),(268100727,425704326,14883174,21109,1,'2008-06-02 23:51:15',3310502125,2),(268100728,425703315,14885234,21109,1,'2008-06-02 23:51:15',3310502125,3),(268100729,425696804,14892529,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100730,425695540,14894503,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100731,425694782,14895791,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100732,425694845,14897507,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100733,425694782,14898966,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100735,425694655,14901799,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100736,425694908,14904374,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100737,425694908,14905747,21109,1,'2008-06-02 23:51:15',3310502126,2),(268100738,425694402,14907464,21109,1,'2008-06-02 23:51:15',3310502126,2),(268100739,425693581,14907979,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100740,425692822,14908064,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100741,425690736,14907979,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100742,425689093,14908665,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100743,425687449,14909609,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100744,425686248,14910382,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100746,425684415,14911755,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100747,425682329,14913386,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100748,425680622,14914158,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100749,425679990,14914673,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100750,425679864,14915532,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100752,425680433,14916390,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100753,425681318,14916476,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100754,425685869,14915532,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100755,425689725,14914330,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100757,425691368,14914073,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100758,425693834,14914588,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100759,425695667,14915618,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100760,425696994,14917248,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100761,425698385,14918879,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100762,425700534,14919823,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100764,425701735,14919909,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100765,425702367,14919222,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100766,425702809,14916133,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100767,425703884,14908150,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100768,425704010,14907292,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100769,425704706,14906949,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100771,425705085,14907807,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100772,425704895,14908751,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100773,425704579,14910382,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100775,425704895,14913214,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100776,425705338,14916133,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100777,425706096,14920167,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100778,425706855,14922999,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100779,425707108,14924372,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100781,425707108,14925402,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100782,425706539,14926175,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100783,425705338,14926432,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100784,425703189,14926947,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100785,425702051,14926432,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100786,425700660,14925231,21109,1,'2008-06-02 23:33:51',3310502127,1),(268100787,425698385,14923514,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100789,425695983,14921797,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100790,425693834,14920424,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100791,425692569,14919909,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100792,425691305,14919823,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100793,425689472,14920167,21109,1,'2008-06-02 23:33:51',3310502126,1),(268100794,425688271,14920682,21109,1,'2008-06-02 23:33:51',3310502126,1),(268101444,425705662,14875625,21109,1,'2008-06-02 23:35:16',3310502125,1),(268101446,425706981,14876307,21109,1,'2008-06-02 23:35:16',3310502125,1),(268101448,425707803,14876050,21109,1,'2008-06-02 23:35:16',3310502125,1),(268101451,425708372,14875277,21109,1,'2008-06-02 23:35:16',3310502125,1),(268101453,425709762,14872531,21109,1,'2008-06-02 23:35:16',3310502125,1),(268101454,425710458,14871415,21109,1,'2008-06-02 23:35:16',3310502125,1),(268101456,425710900,14871243,21109,1,'2008-06-02 23:35:16',3310502125,1),(268101669,425695161,14891757,21109,1,'2008-06-02 23:36:16',3310502126,1),(268101670,425697255,14892028,21109,1,'2008-06-02 23:36:16',3310502126,1),(268103219,425696488,14897936,21109,1,'2008-06-02 23:43:12',3310502126,1),(268103220,425697500,14896907,21109,1,'2008-06-02 23:43:12',3310502126,1),(268103434,425700058,14919614,21109,1,'2008-06-02 23:44:43',3310502127,1),(268103435,425701672,14908236,21109,1,'2008-06-02 23:44:43',3310502127,1),(268103436,425701861,14906348,21109,1,'2008-06-02 23:44:43',3310502127,1),(268103437,425702557,14904030,21109,1,'2008-06-02 23:44:43',3310502127,1),(268103438,425702873,14902743,21109,1,'2008-06-02 23:44:43',3310502127,1),(268103842,425702362,14886341,21109,1,'2008-06-02 23:51:15',3310502125,4),(268103843,425701292,14886864,21109,1,'2008-06-02 23:45:55',3310502127,1),(268103844,425700407,14887551,21109,1,'2008-06-02 23:45:55',3310502127,1),(268103845,425698385,14889353,21109,1,'2008-06-02 23:45:55',3310502126,1),(268103846,425697057,14890469,21109,1,'2008-06-02 23:45:55',3310502126,1),(268103847,425696236,14890813,21109,1,'2008-06-02 23:45:55',3310502126,1),(268103848,425695477,14890898,21109,1,'2008-06-02 23:45:55',3310502126,1),(268103850,425695098,14891070,21109,1,'2008-06-02 23:45:55',3310502126,1),(268104321,425701040,14886435,21109,1,'2008-06-02 23:48:21',3310502125,1),(268104322,425700534,14886349,21109,1,'2008-06-02 23:48:21',3310502125,1),(268104323,425698701,14887208,21109,1,'2008-06-02 23:48:21',3310502126,1),(268104324,425696804,14888838,21109,1,'2008-06-02 23:48:21',3310502126,1),(268104325,425695098,14889611,21109,1,'2008-06-02 23:48:21',3310502126,1),(268104326,425694971,14891328,21109,1,'2008-06-02 23:48:21',3310502126,1),(268104327,425696236,14891242,21109,1,'2008-06-02 23:48:21',3310502126,1),(268104328,425697184,14891242,21109,1,'2008-06-02 23:48:21',3310502126,1),(268104329,425700471,14887980,21109,1,'2008-06-02 23:48:21',3310502127,1),(268104831,425694845,14906777,21109,1,'2008-06-02 23:51:15',3310502126,1),(268123180,425679299,14886214,25362,1,'2008-06-03 00:57:57',3310502124,1),(268123181,425679678,14887759,25362,1,'2008-06-03 00:57:57',3310502126,1),(268123182,425679744,14888627,25362,1,'2008-06-03 00:57:57',3310502126,1),(268123183,425671208,14883897,25362,1,'2008-06-03 01:00:29',3310502121,2),(268123184,425672725,14883725,25362,1,'2008-06-03 00:57:57',3310502124,1),(268123185,425673926,14883468,25362,1,'2008-06-03 00:57:57',3310502124,1),(268123186,425675823,14882695,25362,1,'2008-06-03 00:57:57',3310502124,1),(268123187,425677024,14882180,25362,1,'2008-06-03 00:57:57',3310502124,1),(268123188,425677592,14882352,25362,1,'2008-06-03 00:57:57',3310502124,1),(268123189,425678098,14882867,25362,1,'2008-06-03 00:57:57',3310502124,1),(268123190,425678541,14883725,25362,1,'2008-06-03 00:57:57',3310502124,1),(268123192,425678920,14884841,25362,1,'2008-06-03 00:57:57',3310502124,1),(268123710,425680121,14888446,25362,1,'2008-06-03 00:58:44',3310502126,1),(268123711,425679046,14888961,25362,1,'2008-06-03 00:58:44',3310502126,1),(268124663,425648704,14912736,25362,1,'2008-06-03 01:01:57',3310502123,1),(268124664,425649273,14912736,25362,1,'2008-06-03 01:01:57',3310502123,1),(268124667,425649652,14913251,25362,1,'2008-06-03 01:01:57',3310502123,1),(268124757,425650411,14915053,25362,1,'2008-06-03 01:02:54',3310502123,1),(268124758,425650989,14915585,25362,1,'2008-06-03 01:02:54',3310502123,1),(268124759,425649778,14914023,25362,1,'2008-06-03 01:02:54',3310502123,1),(268129594,425721127,14838247,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129595,425720747,14837218,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129596,425720558,14836016,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129597,425720431,14835158,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129598,425720811,14834471,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129599,425721190,14834299,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129600,425721695,14834385,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129601,425722454,14834643,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129602,425723023,14834728,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129603,425723339,14834471,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129605,425723465,14833784,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129607,425723402,14832668,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129608,425721885,14827690,25362,1,'2008-06-03 01:18:25',3310502119,1),(268129609,425721000,14825115,25362,1,'2008-06-03 01:18:25',3310502119,1),(268129610,425720684,14824085,25362,1,'2008-06-03 01:18:25',3310502119,1),(268129611,425720242,14824171,25362,1,'2008-06-03 01:18:25',3310502119,1),(268129612,425719357,14825287,25362,1,'2008-06-03 01:20:10',3310502119,2),(268129614,425719041,14825974,25362,1,'2008-06-03 01:18:25',3310502119,1),(268129615,425718598,14827261,25362,1,'2008-06-03 01:18:25',3310502119,1),(268129616,425718472,14828034,25362,1,'2008-06-03 01:18:25',3310502119,1),(268129618,425718598,14829407,25362,1,'2008-06-03 01:18:25',3310502119,1),(268129619,425719104,14832668,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129620,425719420,14833098,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129621,425719989,14832840,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129622,425720747,14831810,25362,1,'2008-06-03 01:18:25',3310502125,1),(268129624,425721253,14831038,25362,1,'2008-06-03 01:18:25',3310502119,1),(268129625,425721443,14829836,25362,1,'2008-06-03 01:18:25',3310502119,1),(268129626,425721379,14828720,25362,1,'2008-06-03 01:18:25',3310502119,1),(268129627,425721316,14827862,25362,1,'2008-06-03 01:18:25',3310502119,1),(268130240,425720400,14832282,25362,1,'2008-06-03 01:20:10',3310502125,1),(268131748,425722751,14830533,25362,1,'2008-06-03 01:31:33',3310502119,1),(268131749,425721443,14832411,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131750,425720684,14833269,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131751,425720178,14834128,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131752,425719610,14835501,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131753,425718661,14835758,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131755,425717587,14836531,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131756,425716323,14837561,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131757,425715059,14838762,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131758,425714427,14840050,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131759,425714300,14842282,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131760,425714363,14843741,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131761,425714300,14844685,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131762,425714174,14845715,25362,1,'2008-06-03 01:31:33',3310502125,1),(268131763,425713858,14846487,25362,1,'2008-06-03 01:31:33',3310502125,1),(268132090,425714616,14852667,25362,1,'2008-06-03 01:33:07',3310502125,1),(268132091,425715423,14853174,25362,1,'2008-06-03 01:33:07',3310502125,1),(268132095,425709753,14852935,2369737,1,'2009-09-04 17:22:13',3310502125,2),(268132096,425710634,14853440,25362,1,'2008-06-03 01:33:07',3310502125,1),(268132097,425711203,14853268,25362,1,'2008-06-03 01:33:07',3310502125,1),(268132098,425712151,14852410,25362,1,'2008-06-03 01:33:07',3310502125,1),(268132099,425713036,14852238,25362,1,'2008-06-03 01:33:07',3310502125,1),(268132100,425713478,14852238,25362,1,'2008-06-03 01:33:07',3310502125,1),(268132455,425718409,14835072,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132456,425716133,14835501,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132457,425713984,14836874,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132458,425712530,14837990,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132459,425711076,14839535,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132460,425709433,14841080,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132461,425709370,14843397,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132462,425708232,14843569,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132463,425708358,14844599,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132464,425711076,14843826,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132465,425712783,14843226,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132466,425714806,14842282,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132467,425716007,14840393,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132468,425717334,14838419,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132469,425719041,14837561,25362,1,'2008-06-03 01:36:54',3310502125,1),(268132982,425713668,14846230,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132983,425713858,14844942,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132985,425713858,14843397,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132986,425712277,14843998,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132987,425708611,14845200,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132989,425707916,14848805,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132990,425707474,14850607,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132991,425707790,14852324,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132992,425708611,14853783,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132993,425709559,14853440,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132994,425710002,14852324,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132996,425711076,14852410,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132997,425713668,14850435,25362,1,'2008-06-03 01:38:51',3310502125,1),(268132998,425714174,14846916,25362,1,'2008-06-03 01:38:51',3310502125,1),(268133215,425722264,14827433,675187,1,'2008-12-30 16:02:49',3310502119,3),(268133216,425722707,14827175,675187,1,'2008-12-30 16:02:48',3310502119,2),(268133217,425721190,14822798,675187,1,'2008-12-30 16:02:48',3310502119,2),(268133218,425719546,14823313,675187,1,'2008-12-30 16:02:49',3310502119,2),(268133219,425717777,14826231,675187,1,'2008-12-30 16:02:49',3310502119,2),(268133221,425717524,14827690,675187,1,'2008-12-30 16:02:49',3310502119,2),(268133222,425718156,14833012,675187,1,'2008-12-30 16:02:49',3310502125,2),(268133223,425719357,14834213,675187,1,'2008-12-30 16:02:49',3310502125,2),(268133224,425721948,14830523,675187,1,'2008-12-30 16:02:49',3310502119,2),(268133225,425721759,14828549,675187,1,'2008-12-30 16:02:49',3310502119,2),(268133712,425721063,14835072,25362,1,'2008-06-03 01:42:02',3310502125,1),(268133714,425721569,14835930,25362,1,'2008-06-03 01:42:02',3310502125,1),(268133715,425723276,14835930,25362,1,'2008-06-03 01:42:02',3310502125,1),(268133716,425724287,14835415,25362,1,'2008-06-03 01:42:02',3310502125,1),(268133717,425724603,14834213,25362,1,'2008-06-03 01:42:02',3310502125,1),(268133718,425723276,14829407,25362,1,'2008-06-03 01:42:02',3310502119,1),(268133719,425720115,14833784,25362,1,'2008-06-03 01:42:02',3310502125,1),(268133883,425719917,14834759,25362,1,'2008-06-03 01:42:43',3310502125,1),(268134045,425721300,14838863,2369619,1,'2009-09-04 17:10:07',3310502125,2),(268148594,425709352,14864112,33354,1,'2008-06-03 03:20:22',3310502125,1),(268612922,425922022,15251371,56648,1,'2008-06-05 18:37:38',3310502695,1),(268612923,425922591,15251285,56648,1,'2008-06-05 18:37:38',3310502695,1),(268613131,425931247,15255577,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613132,425932006,15256177,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613133,425932448,15256950,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613134,425932701,15257894,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613135,425933017,15258838,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613136,425933017,15259525,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613137,425932511,15260297,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613138,425931943,15260726,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613139,425931121,15261156,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613140,425930489,15262100,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613141,425930679,15262786,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613142,425931374,15263902,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613143,425932448,15265705,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613144,425933396,15267078,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613145,425933775,15267850,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613146,425933649,15269309,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613147,425933333,15270425,56648,1,'2008-06-05 18:38:28',3310502695,1),(268613536,425930742,15268794,56648,1,'2008-06-05 18:40:23',3310502695,1),(268613537,425931753,15269395,56648,1,'2008-06-05 18:40:23',3310502695,1),(268613538,425932258,15270254,56648,1,'2008-06-05 18:40:23',3310502695,1),(268613539,425934533,15271112,56648,1,'2008-06-05 18:40:23',3310502695,1),(268613540,425936050,15271970,56648,1,'2008-06-05 18:40:23',3310502701,1),(268613541,425936808,15272399,56648,1,'2008-06-05 18:40:23',3310502701,1),(268613542,425937313,15272485,56648,1,'2008-06-05 18:40:23',3310502701,1),(268613543,425937819,15272399,56648,1,'2008-06-05 18:40:23',3310502701,1),(268613544,425938324,15272657,56648,1,'2008-06-05 18:40:23',3310502701,1),(268613545,425939398,15273172,56648,1,'2008-06-05 18:40:23',3310502701,1),(268613546,425940915,15273773,56648,1,'2008-06-05 18:40:23',3310502701,1),(268613547,425942495,15274545,56648,1,'2008-06-05 18:40:23',3310502701,1),(268613548,425943821,15274888,56648,1,'2008-06-05 18:40:23',3310502701,1),(268613549,425944769,15274888,56648,1,'2008-06-05 18:40:23',3310502701,1),(268613550,425946159,15275489,56648,1,'2008-06-05 18:40:23',3310502701,1),(268613551,425947613,15276090,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613552,425949445,15277206,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613553,425950519,15277893,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613554,425951151,15278236,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613555,425951593,15278922,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613556,425952288,15279695,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613557,425952667,15280210,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613558,425953299,15281154,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613559,425954437,15281755,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613560,425955637,15282356,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613561,425957027,15282785,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613562,425958038,15283214,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613563,425958859,15283643,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613564,425959681,15284330,56648,1,'2008-06-05 18:40:23',3310502712,1),(268613691,425960439,15267421,56648,1,'2008-06-05 18:41:22',3310502706,1),(268613692,425960123,15268537,56648,1,'2008-06-05 18:41:22',3310502706,1),(268613693,425959681,15269653,56648,1,'2008-06-05 18:41:22',3310502706,1),(268613694,425959175,15270769,56648,1,'2008-06-05 18:41:22',3310502706,1),(268613695,425958228,15273086,56648,1,'2008-06-05 18:41:22',3310502712,1),(268613696,425957722,15275318,56648,1,'2008-06-05 18:41:22',3310502712,1),(268613697,425957722,15276863,56648,1,'2008-06-05 18:41:22',3310502712,1),(268613698,425957848,15277893,56648,1,'2008-06-05 18:41:22',3310502712,1),(268613699,425958101,15279266,56648,1,'2008-06-05 18:41:22',3310502712,1),(268613700,425958607,15280553,56648,1,'2008-06-05 18:41:22',3310502712,1),(268613701,425958733,15281412,56648,1,'2008-06-05 18:41:22',3310502712,1),(268613703,425958733,15281927,56648,1,'2008-06-05 18:41:22',3310502712,1),(268613704,425958796,15283128,56648,1,'2008-06-05 18:41:22',3310502712,1),(268614412,425930368,15254683,56648,1,'2008-06-05 18:44:20',3310502695,1),(268615558,425960895,15265943,56648,1,'2008-06-05 18:49:46',3310502706,1),(268615700,425962323,15266456,2191328,1,'2009-08-18 19:37:18',3310502706,3),(268615701,425962260,15265512,2191328,1,'2009-08-18 19:37:18',3310502706,3),(268615702,425962019,15264503,56648,1,'2008-06-05 18:52:35',3310502706,2),(268615703,425961576,15263730,56648,1,'2008-06-05 18:52:35',3310502706,2),(268615704,425961134,15262958,56648,1,'2008-06-05 18:50:53',3310502706,1),(268615705,425961260,15262014,56648,1,'2008-06-05 18:50:53',3310502706,1),(268615706,425961387,15258752,56648,1,'2008-06-05 18:50:53',3310502706,1),(268615707,425961387,15257036,56648,1,'2008-06-05 18:50:53',3310502706,1),(268615782,425962019,15258581,56648,1,'2008-06-05 18:51:53',3310502706,1),(268615783,425962650,15258666,56648,1,'2008-06-05 18:51:53',3310502706,1),(268615784,425963030,15259353,56648,1,'2008-06-05 18:51:53',3310502706,1),(268615786,425963598,15260469,56648,1,'2008-06-05 18:51:53',3310502706,1),(268615787,425964293,15261585,56648,1,'2008-06-05 18:51:53',3310502706,1),(268615788,425965304,15262700,56648,1,'2008-06-05 18:51:53',3310502706,1),(268615789,425965936,15263387,56648,1,'2008-06-05 18:51:53',3310502706,1),(268615790,425966568,15264417,56648,1,'2008-06-05 18:51:53',3310502706,1),(268615948,425962433,15269187,56648,1,'2008-06-05 18:53:05',3310502706,1),(268616479,425964104,15262014,56648,1,'2008-06-05 18:59:25',3310502706,1),(268616480,425964925,15263301,56648,1,'2008-06-05 18:59:25',3310502706,1),(268616481,425964420,15263301,56648,1,'2008-06-05 18:59:25',3310502706,1),(268616482,425964104,15263559,56648,1,'2008-06-05 18:59:25',3310502706,1),(268616483,425964040,15264417,56648,1,'2008-06-05 18:59:25',3310502706,1),(268616484,425963598,15264932,56648,1,'2008-06-05 18:59:25',3310502706,1),(268616485,425963030,15265190,56648,1,'2008-06-05 18:59:25',3310502706,1),(268616486,425962587,15265190,56648,1,'2008-06-05 18:59:25',3310502706,1),(268616487,425962205,15265059,56648,1,'2008-06-05 18:59:25',3310502706,1),(268616713,425960945,15262014,56648,1,'2008-06-05 19:01:56',3310502706,1),(268616714,425960502,15262186,56648,1,'2008-06-05 19:01:56',3310502706,1),(268616715,425960060,15262186,56648,1,'2008-06-05 19:01:56',3310502706,1),(268616716,425959997,15261327,56648,1,'2008-06-05 19:01:56',3310502706,1),(268616717,425958796,15260984,56648,1,'2008-06-05 19:01:56',3310502706,1),(268616718,425958417,15262700,56648,1,'2008-06-05 19:01:56',3310502706,1),(268616719,425960629,15263730,56648,1,'2008-06-05 19:01:56',3310502706,1),(268616892,425961059,15266542,2191328,1,'2009-08-18 19:38:23',3310502706,2),(268616893,425960870,15267143,2191328,1,'2009-08-18 19:40:09',3310502706,3),(268616894,425961691,15268087,2191328,1,'2009-08-18 19:40:10',3310502706,3),(268616895,425961944,15267572,2191328,1,'2009-08-18 19:38:23',3310502706,2),(268617407,425984827,15294544,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617408,425985775,15295230,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617409,425986660,15296003,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617410,425987355,15297033,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617411,425987671,15298835,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617412,425987923,15299779,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617413,425988429,15300209,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617414,425989124,15300037,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617415,425989440,15300809,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617416,425989629,15302268,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617417,425989945,15305616,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617418,425990198,15306388,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617419,425990893,15307247,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617420,425992093,15308534,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617421,425993294,15309392,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617422,425994620,15310680,56648,1,'2008-06-05 19:08:04',3310502713,1),(268617493,425993926,15306817,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617494,425993294,15306302,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617495,425992599,15305273,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617496,425991777,15303985,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617497,425991146,15302011,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617498,425990766,15299951,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617499,425990387,15298406,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617500,425990261,15296861,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617501,425989882,15296174,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617502,425989440,15295831,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617503,425989061,15295745,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617504,425988808,15296260,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617505,425988871,15297634,56648,1,'2008-06-05 19:08:31',3310502713,1),(268617677,425984051,15294654,56648,1,'2008-06-05 19:09:23',3310502713,1),(268617808,425984575,15297977,56648,1,'2008-06-05 19:10:24',3310502713,1),(268617809,425985184,15297393,56648,1,'2008-06-05 19:10:24',3310502713,1),(268618417,425617257,14967271,56648,1,'2008-06-05 19:14:47',3310502464,1),(268619784,425181160,15252916,56648,1,'2008-06-05 19:24:05',3310491490,1),(268630128,425039497,15191226,56648,1,'2008-06-05 20:27:56',3310491428,1),(268630910,425036101,15193555,3916355,1,'2010-02-19 17:31:54',3310491428,2),(268630911,425036007,15194595,3916355,1,'2010-02-19 17:31:54',3310491428,2),(268630913,425037177,15194755,3916355,1,'2010-02-19 17:31:55',3310491428,2),(268630914,425037294,15193887,3916355,1,'2010-02-19 17:31:55',3310491428,2),(268631096,425037167,15192720,305941,1,'2009-02-09 21:32:54',3310491428,2),(268631795,425036172,15191573,3916355,1,'2010-02-19 17:34:23',3310491428,3),(268633715,425083110,15328453,305941,1,'2009-02-09 21:17:59',3310491450,5),(270716339,425455379,15153915,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716340,425455949,15153229,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716341,425456581,15152971,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716342,425457466,15153314,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716343,425458541,15152628,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716344,425459426,15151684,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716346,425459174,15150482,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716347,425458857,15149710,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716348,425459110,15148765,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716349,425459616,15147135,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716350,425459932,15145847,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716351,425460691,15144302,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716352,425462146,15142671,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716353,425463537,15141212,188228,1,'2008-06-16 17:53:47',3310502414,1),(270716354,425463913,15139731,174860,1,'2008-12-06 16:19:29',3310502414,2),(270717286,425458099,15148336,188228,1,'2008-06-16 17:58:16',3310502414,1),(270717287,425457719,15148079,188228,1,'2008-06-16 17:58:16',3310502414,1),(270717288,425457150,15147478,188228,1,'2008-06-16 17:58:16',3310502414,1),(270717289,425456232,15147580,174860,1,'2008-12-06 16:19:28',3310502414,2),(270717898,425429895,15163271,188228,1,'2008-06-16 18:02:15',3310502433,1),(270717899,425431350,15162928,188228,1,'2008-06-16 18:02:15',3310502433,1),(270723120,425097469,15332761,188228,1,'2008-06-16 18:36:30',3310491451,1),(270723241,425098608,15341258,188228,1,'2008-06-16 18:38:03',3310491451,1),(270723242,425098482,15342717,188228,1,'2008-06-16 18:38:03',3310491451,1),(270723243,425098482,15346408,188228,1,'2008-06-16 18:38:03',3310491451,1),(270723244,425100063,15372072,188228,1,'2008-06-16 18:38:03',3310491451,1),(270723325,425101898,15388551,188228,1,'2008-06-16 19:09:56',3310491537,3),(270723368,425101012,15386920,188228,1,'2008-06-16 18:44:23',3310491537,3),(270723369,425100696,15387435,188228,1,'2008-06-16 19:09:56',3310491537,4),(270723412,425101961,15387779,188228,1,'2008-06-16 18:44:23',3310491537,2),(270723413,425101645,15387092,188228,1,'2008-06-16 19:09:31',3310491537,3),(270723459,425101329,15389238,188228,1,'2008-06-16 19:09:56',3310491537,3),(270723912,425100823,15388980,188228,1,'2008-06-16 19:09:56',3310491537,2),(270723936,425101076,15395503,188228,1,'2008-06-16 18:44:40',3310491537,1),(270723937,425098671,15400911,188228,1,'2008-06-16 18:45:06',3310491537,2),(270724218,425098671,15464082,188228,1,'2008-06-16 18:48:34',3310491539,1),(270724708,425120373,15501504,188228,1,'2008-06-16 18:52:32',3310491545,1),(270724742,425120289,15503426,840745,1,'2009-01-26 19:29:54',3310491545,2),(270725821,425096700,15403380,3916355,1,'2010-02-19 17:34:16',3310491537,2),(270725822,425097013,15402794,3916355,1,'2010-02-19 17:34:17',3310491537,2),(270725823,425096963,15401983,3916355,1,'2010-02-19 17:34:17',3310491537,2),(270725825,425096539,15401449,3916355,1,'2010-02-19 17:34:17',3310491537,2),(270725826,425095501,15401979,3916355,1,'2010-02-19 17:34:17',3310491537,2),(270725827,425095450,15402797,3916355,1,'2010-02-19 17:34:18',3310491537,2),(270725828,425095729,15403347,3916355,1,'2010-02-19 17:34:18',3310491537,2),(270725839,425096199,15403580,3916355,1,'2010-02-19 17:34:18',3310491537,2),(270725952,425095931,15401444,3916355,1,'2010-02-19 17:34:17',3310491537,2),(270726179,425093546,15387779,188228,1,'2008-06-16 19:02:49',3310491536,2),(270726764,425095707,15388473,3916355,1,'2010-02-19 17:34:19',3310491537,6),(270726765,425095796,15387837,3916355,1,'2010-02-19 17:34:19',3310491537,3),(270726766,425095505,15387272,3916355,1,'2010-02-19 17:34:19',3310491537,4),(270726767,425094964,15387193,3916355,1,'2010-02-19 17:34:19',3310491536,5),(270726768,425094547,15387861,3916355,1,'2010-02-19 17:34:20',3310491536,4),(270726770,425094783,15388687,3916355,1,'2010-02-19 17:34:20',3310491536,5),(270726771,425095299,15388852,3916355,1,'2010-02-19 17:34:20',3310491537,4),(270727242,425091849,15336838,840745,1,'2009-01-26 20:10:50',3310491450,4),(270729579,425263767,15670124,188228,1,'2008-06-16 19:35:06',3310491623,1),(270730270,425291978,15696903,188228,1,'2008-06-16 19:39:37',3310491634,1),(270730467,425295028,15714489,4963967,1,'2010-06-11 20:09:40',3310491640,2),(270730923,425294023,15713492,4963967,1,'2010-06-11 20:09:40',3310491640,2),(270730924,425295583,15714155,188228,1,'2008-06-16 19:45:37',3310491640,1),(270730925,425295836,15712782,188228,1,'2008-06-16 19:45:37',3310491640,1),(270730926,425300896,15704113,188228,1,'2008-06-16 19:45:37',3310491634,1),(270730927,425301402,15703598,188228,1,'2008-06-16 19:45:37',3310491634,1),(270730928,425302098,15703512,188228,1,'2008-06-16 19:45:37',3310491634,1),(270730929,425302857,15703770,188228,1,'2008-06-16 19:45:37',3310491634,1),(270730930,425304628,15705229,188228,1,'2008-06-16 19:45:37',3310491634,1),(270730931,425306968,15706259,188228,1,'2008-06-16 19:45:37',3310491634,1),(270730932,425313483,15708147,188228,1,'2008-06-16 19:45:37',3310491634,1),(270730933,425321010,15712181,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730934,425324235,15714069,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730935,425325310,15715014,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730936,425326512,15717159,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730937,425328663,15721708,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730938,425329801,15725313,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730939,425331129,15727717,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730940,425332963,15729605,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730941,425334165,15731493,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730942,425335051,15733896,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730943,425335304,15736300,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730944,425335430,15737587,188228,1,'2008-06-16 19:45:37',3310491641,1),(270730945,425335936,15738188,188228,1,'2008-06-16 19:45:37',3310491641,1),(270731114,425336948,15739046,188228,1,'2008-06-16 20:05:18',3310491641,2),(270731115,425337517,15739132,188228,1,'2008-06-16 19:47:21',3310491641,1),(270731116,425337707,15738445,188228,1,'2008-06-16 19:47:21',3310491641,1),(270731117,425337644,15737759,188228,1,'2008-06-16 19:47:21',3310491641,1),(270731118,425337391,15737415,188228,1,'2008-06-16 20:05:18',3310491641,2),(270731119,425337011,15737415,188228,1,'2008-06-16 19:49:35',3310491641,2),(270731143,425336758,15738360,188228,1,'2008-06-16 19:49:35',3310491641,3),(270733583,425319239,15736300,188228,1,'2008-06-16 20:02:41',3310491641,1),(270733584,425327398,15762135,188228,1,'2008-06-16 20:02:41',3310491641,1),(270733631,425332399,15776831,188228,1,'2008-06-16 20:02:58',3310491643,1),(271938772,425073597,15225081,258909,1,'2008-06-22 19:25:20',3310491442,1),(271938773,425071485,15224951,258909,1,'2008-06-22 19:25:20',3310491442,1),(271938774,425069817,15221849,258909,1,'2008-06-22 19:25:20',3310491442,1),(271938778,425067200,15215540,258909,1,'2008-06-22 19:25:20',3310491429,1),(271939031,425795800,16400616,3475126,1,'2009-12-28 21:41:30',3310504156,3),(271939032,425399438,17192126,258909,1,'2008-06-22 19:28:24',3310504576,1),(271939033,425387081,17176253,258909,1,'2008-06-22 19:28:24',3310493653,1),(271939034,425375443,17160301,258909,1,'2008-06-22 19:28:24',3310493653,1),(276993930,426528772,15636298,4114763,1,'2010-03-13 15:42:56',3310503649,5),(276995290,426528835,15634839,423843,1,'2008-07-07 23:49:54',3310503649,1),(276995291,426528709,15635268,423843,1,'2008-07-07 23:49:54',3310503649,1),(276995292,426528646,15635698,423843,1,'2008-07-07 23:49:54',3310503649,1),(276995293,426528456,15636041,423843,1,'2008-07-07 23:49:54',3310503649,1),(276995294,426528393,15636470,423843,1,'2008-07-07 23:49:54',3310503649,1),(276998391,425448312,15239457,725665,1,'2009-03-02 22:19:39',3310502435,6),(276998392,425448249,15242118,423843,1,'2008-07-08 00:06:13',3310502435,1),(276998393,425448059,15243577,423843,1,'2008-07-08 00:06:13',3310502435,1),(276998394,425447363,15244436,423843,1,'2008-07-08 00:16:11',3310502435,2),(276998671,425437815,15231132,423843,1,'2008-07-08 00:10:55',3310502435,2),(276999219,425434702,15224356,1075389,1,'2009-05-04 18:49:38',3310502435,2),(277000148,425435728,15227184,423843,1,'2008-07-08 00:13:18',3310502435,2),(277000149,425436676,15228471,423843,1,'2008-07-08 00:10:55',3310502435,1),(277000665,425437625,15228729,423843,1,'2008-07-08 00:11:51',3310502435,1),(277000666,425438637,15227956,423843,1,'2008-07-08 00:11:51',3310502435,1),(277000667,425439522,15227870,423843,1,'2008-07-08 00:11:51',3310502435,1),(277000669,425440407,15227870,423843,1,'2008-07-08 00:11:51',3310502435,1),(277001703,425434766,15233068,2369619,1,'2009-09-04 17:10:07',3310502435,2),(277001727,425436929,15229072,2369619,1,'2009-09-04 17:10:07',3310502435,2),(277003121,425430479,15241174,423843,1,'2008-07-08 00:19:31',3310502435,1),(277003126,425416503,15240230,423843,1,'2008-07-08 00:19:31',3310502434,1),(277003680,425429847,15239801,423843,1,'2008-07-08 00:20:56',3310502435,1),(277003681,425425610,15237483,423843,1,'2008-07-08 00:20:56',3310502435,1),(277003682,425418843,15237140,423843,1,'2008-07-08 00:20:56',3310502434,1),(277003683,425417009,15236625,423843,1,'2008-07-08 00:20:56',3310502434,1),(277003684,425415239,15235681,423843,1,'2008-07-08 00:20:56',3310502434,1),(277375056,425759909,15186981,440632,1,'2008-07-09 16:26:46',3310502513,1),(277375057,425759850,15187352,440632,1,'2008-07-09 16:26:46',3310502513,1),(277375058,425759597,15188382,440632,1,'2008-07-09 16:26:46',3310502513,1),(277375059,425758712,15189755,440632,1,'2008-07-09 16:26:46',3310502513,1),(277375060,425757195,15191557,440632,1,'2008-07-09 16:26:46',3310502513,1),(277375061,425756310,15192330,440632,1,'2008-07-09 16:26:46',3310502513,1),(277375062,425754856,15192931,440632,1,'2008-07-09 16:26:46',3310502513,1),(277375063,425753340,15193188,440632,1,'2008-07-09 16:26:46',3310502512,1),(277375064,425752455,15189583,440632,1,'2008-07-09 16:26:46',3310502512,1),(277377767,425845906,15654753,440632,1,'2008-07-09 16:47:10',3310502816,1),(277377889,425873712,15702990,440632,1,'2008-07-09 16:49:41',3310502819,1),(277377892,425858229,15691746,440632,1,'2008-07-09 16:51:48',3310502818,3),(277378560,425948590,15751399,440632,1,'2008-07-09 16:54:11',3310502840,1),(277386816,425447165,15181286,441038,1,'2008-07-09 18:15:08',3310502433,1),(277386817,425448177,15183088,441038,1,'2008-07-09 18:15:08',3310502433,1),(277386818,425449189,15184376,441038,1,'2008-07-09 18:15:08',3310502433,1),(277386819,425450390,15186350,441038,1,'2008-07-09 18:15:08',3310502433,1),(277386820,425451465,15188839,844916,1,'2009-01-27 20:20:59',3310502433,3),(277386821,425452034,15189182,844916,1,'2009-01-27 20:20:59',3310502433,3),(277386822,425452351,15189955,844916,1,'2009-01-27 20:20:59',3310502436,3),(277386823,425452667,15191242,844916,1,'2009-01-27 20:20:59',3310502436,3),(277386824,425453742,15195276,844916,1,'2009-01-27 20:20:59',3310502436,3),(277386825,425454501,15197937,844916,1,'2009-01-27 20:20:59',3310502436,3),(277386826,425455323,15199739,844916,1,'2009-01-27 20:20:59',3310502436,3),(277386827,425456163,15200104,844916,1,'2009-01-27 20:20:59',3310502436,3),(277386930,425450770,15184204,441038,1,'2008-07-09 18:16:19',3310502433,1),(277386931,425451529,15183775,441038,1,'2008-07-09 18:16:19',3310502433,1),(277694080,425088502,15307498,305941,1,'2009-02-09 21:18:56',3310491448,2),(277694081,425091228,15316676,820251,1,'2009-03-16 23:48:45',3310491448,4),(277694146,425084763,15306437,462438,1,'2008-07-11 12:57:28',3310491448,1),(277695163,425121314,15367394,3916355,1,'2010-02-19 17:33:25',3310491451,5),(277695164,425122217,15368066,3916355,1,'2010-02-19 17:33:25',3310491451,5),(277695165,425123077,15367517,3916355,1,'2010-02-19 17:33:26',3310491454,5),(277695167,425123309,15366357,3916355,1,'2010-02-19 17:33:26',3310491454,4),(277695168,425122436,15365128,3916355,1,'2010-02-19 17:33:27',3310491451,3),(277695169,425121319,15365762,3916355,1,'2010-02-19 17:33:25',3310491451,6),(277695545,425120574,15369265,462438,1,'2008-07-11 13:06:36',3310491451,1),(277697265,424845097,14903871,462438,1,'2008-07-11 13:26:25',3310490863,1),(277697266,424846173,14901038,462438,1,'2008-07-11 13:26:25',3310490863,1),(277697267,424847629,14898206,462438,1,'2008-07-11 13:26:25',3310490863,1),(277697268,424848705,14899064,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697269,424848515,14904214,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697270,424849148,14907475,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697271,424853326,14909020,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697272,424858389,14909879,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697273,424861997,14912196,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697274,424864086,14911595,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697275,424861681,14908505,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697276,424858516,14905072,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697277,424855478,14900437,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697278,424852060,14896317,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697279,424850414,14893313,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697280,424850604,14890738,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697281,424853326,14891339,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697282,424855035,14893914,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697283,424857883,14893571,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697284,424860098,14892884,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697285,424862947,14894172,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697286,424865985,14898034,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697287,424869149,14899922,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697288,424873074,14901639,462438,1,'2008-07-11 13:26:25',3310490874,1),(277697289,424875732,14902497,462438,1,'2008-07-11 13:26:25',3310490875,1),(277697480,424865478,14910909,462438,1,'2008-07-11 13:28:00',3310490874,1),(277697481,424865985,14909621,462438,1,'2008-07-11 13:28:00',3310490874,1),(277697482,424864719,14907304,462438,1,'2008-07-11 13:28:00',3310490874,1),(277697483,424860288,14901639,462438,1,'2008-07-11 13:28:00',3310490874,1),(277697484,424858643,14902154,462438,1,'2008-07-11 13:28:00',3310490874,1),(277697485,424856791,14902440,462438,1,'2008-07-11 13:28:00',3310490874,1),(277697847,424844717,14908505,462438,1,'2008-07-11 13:31:19',3310490863,1),(278721406,425105212,15391730,2369619,1,'2009-09-04 17:10:07',3310491537,2),(278721797,425103266,15389863,2369619,1,'2009-09-04 17:10:07',3310491537,2),(278722158,425101314,15409645,2369619,1,'2009-09-04 17:10:07',3310491537,3),(278748035,425761102,16234448,495907,1,'2008-07-15 19:48:35',3310504059,1),(278748036,425784234,16323883,495907,1,'2008-07-15 19:48:35',3310504150,1),(278748279,425788089,16387140,495907,1,'2008-07-15 19:50:23',3310504156,1),(278748316,425799781,16412632,495907,1,'2008-07-15 19:50:57',3310504156,1),(278748317,425797506,16419499,495907,1,'2008-07-15 19:51:34',3310504156,2),(278748365,425796874,16424820,495907,1,'2008-07-15 19:51:34',3310504158,1),(278748559,425797316,16493399,495907,1,'2008-07-15 19:52:43',3310504180,1),(278748954,425786806,16506930,495907,1,'2008-07-15 19:53:29',3310504180,1),(278752060,425785182,16506102,495907,1,'2008-07-15 20:01:27',3310504180,2),(278752061,425783539,16505415,495907,1,'2008-07-15 19:59:39',3310504180,1),(278752062,425782022,16504557,495907,1,'2008-07-15 19:59:39',3310504180,1),(278752063,425781326,16503956,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752064,425781010,16502668,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752066,425781263,16501038,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752067,425781895,16499407,495907,1,'2008-07-15 19:59:39',3310504180,1),(278752068,425782148,16497690,495907,1,'2008-07-15 19:59:39',3310504180,1),(278752069,425781958,16496317,495907,1,'2008-07-15 19:59:39',3310504180,1),(278752070,425781263,16495545,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752071,425780758,16495716,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752072,425780315,16497175,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752073,425780631,16499321,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752074,425780378,16501553,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752075,425779999,16504728,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752076,425779999,16506016,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752077,425779241,16507990,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752078,425778546,16509964,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752079,425777092,16510908,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752080,425775196,16511595,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752081,425772921,16512110,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752083,425771973,16512539,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752084,425771404,16513483,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752085,425771909,16514427,495907,1,'2008-07-15 19:59:39',3310504177,1),(278752325,425771024,16514170,495907,1,'2008-07-15 20:02:55',3310504177,3),(278752327,425776902,16512110,495907,1,'2008-07-15 20:02:55',3310504177,2),(278752328,425777661,16516401,495907,1,'2008-07-15 20:02:55',3310504177,2),(278752329,425771657,16518290,495907,1,'2008-07-15 20:02:55',3310504177,2),(278752636,425776839,16506788,495907,1,'2008-07-15 20:01:13',3310504177,1),(278757467,425775701,16633390,495907,1,'2008-07-15 20:10:14',3310504185,1),(278757468,425775133,16635107,495907,1,'2008-07-15 20:10:14',3310504185,1),(278757469,425769832,16662769,495907,1,'2008-07-15 20:10:14',3310504187,1),(278759738,425771783,16663688,495907,1,'2008-07-15 20:16:37',3310504187,1),(278759739,425773805,16664117,495907,1,'2008-07-15 20:16:37',3310504187,1),(278759740,425774880,16663259,495907,1,'2008-07-15 20:16:37',3310504187,1),(278759742,425775765,16660598,495907,1,'2008-07-15 20:16:37',3310504187,1),(278759743,425776649,16657594,495907,1,'2008-07-15 20:16:37',3310504187,1),(278759744,425777724,16655706,495907,1,'2008-07-15 20:16:37',3310504187,1),(278759745,425778672,16654418,495907,1,'2008-07-15 20:16:37',3310504187,1),(278759746,425780505,16652273,495907,1,'2008-07-15 20:16:37',3310504187,1),(278759747,425782211,16649955,495907,1,'2008-07-15 20:16:37',3310504190,1),(278759748,425783854,16647209,495907,1,'2008-07-15 20:16:37',3310504190,1),(278759749,425784550,16646780,495907,1,'2008-07-15 20:16:37',3310504190,1),(278759750,425785182,16646780,495907,1,'2008-07-15 20:16:37',3310504190,1),(278759752,425785498,16647380,495907,1,'2008-07-15 20:16:37',3310504190,1),(278759753,425785308,16648325,495907,1,'2008-07-15 20:16:37',3310504190,1),(278759754,425784739,16649183,495907,1,'2008-07-15 20:16:37',3310504190,1),(278759755,425783918,16650556,495907,1,'2008-07-15 20:16:37',3310504190,1),(278759756,425783412,16652273,495907,1,'2008-07-15 20:16:37',3310504190,1),(278759757,425782970,16656478,495907,1,'2008-07-15 20:16:37',3310504190,1),(278759758,425782338,16660856,495907,1,'2008-07-15 20:16:37',3310504190,1),(278759759,425780694,16665834,495907,1,'2008-07-15 20:16:37',3310504187,1),(278760483,425766031,16684202,495907,1,'2008-07-15 20:17:56',3310504187,1),(278760711,425766663,16681970,495907,1,'2008-07-15 20:18:38',3310504187,1),(278760995,425764198,16681283,495907,1,'2008-07-15 20:19:51',3310504187,1),(278760996,425763756,16680082,495907,1,'2008-07-15 20:19:51',3310504187,1),(278760997,425763819,16678022,495907,1,'2008-07-15 20:19:51',3310504187,1),(278760998,425763566,16676391,495907,1,'2008-07-15 20:19:51',3310504187,1),(278760999,425763377,16671585,495907,1,'2008-07-15 20:19:51',3310504187,1),(278761000,425763630,16667465,495907,1,'2008-07-15 20:19:51',3310504187,1),(278761001,425764198,16666349,495907,1,'2008-07-15 20:19:51',3310504187,1),(278761002,425768559,16668213,495907,1,'2008-07-15 20:19:51',3310504187,1),(278761189,425765083,16665662,495907,1,'2008-07-15 20:20:20',3310504187,1),(278761190,425766031,16665319,495907,1,'2008-07-15 20:20:20',3310504187,1),(278761435,425762871,16676391,495907,1,'2008-07-15 20:20:45',3310504187,1),(278761436,425762492,16676906,495907,1,'2008-07-15 20:20:45',3310504187,1),(278761437,425762302,16678108,495907,1,'2008-07-15 20:20:45',3310504187,1),(278761438,425762429,16679395,495907,1,'2008-07-15 20:20:45',3310504187,1),(278761439,425762808,16680082,495907,1,'2008-07-15 20:20:45',3310504187,1),(278761684,425762113,16681198,495907,1,'2008-07-15 20:21:11',3310504187,1),(278762963,425764830,16680511,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762964,425764704,16676820,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762965,425764578,16672615,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762966,425764578,16668924,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762967,425765020,16667293,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762968,425766221,16666091,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762969,425766916,16666177,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762970,425766916,16664375,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762971,425763819,16664375,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762972,425762555,16665233,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762973,425761481,16668066,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762974,425761354,16671499,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762975,425761228,16675876,495907,1,'2008-07-15 20:24:16',3310504187,1),(278762976,425761733,16680511,495907,1,'2008-07-15 20:24:16',3310504187,1),(278763284,425741508,16740335,495907,1,'2008-07-15 20:26:14',3310504528,1),(281039653,424856617,14894172,592895,1,'2008-07-25 21:09:57',3310490874,1),(281039980,424878644,14906188,592895,1,'2008-07-25 21:10:59',3310490875,1),(281039982,424879276,14905158,592895,1,'2008-07-25 21:10:59',3310490875,1),(281039983,424878580,14904385,592895,1,'2008-07-25 21:11:42',3310490875,2),(281039984,424877568,14903871,592895,1,'2008-07-25 21:10:59',3310490875,1),(281040020,424877568,14904815,592895,1,'2008-07-25 21:11:15',3310490875,1),(281040022,424879213,14905930,592895,1,'2008-07-25 21:11:15',3310490875,1),(281040156,424877821,14905930,592895,1,'2008-07-25 21:11:29',3310490875,1),(281040439,424883960,14905072,592895,1,'2008-07-25 21:12:46',3310490875,1),(281040441,424881302,14905587,592895,1,'2008-07-25 21:12:46',3310490875,1),(281041274,424882504,14905501,592895,1,'2008-07-25 21:17:55',3310490875,1),(281041761,424885036,14905330,592895,1,'2008-07-25 21:21:32',3310490875,1),(281041762,424886302,14904815,592895,1,'2008-07-25 21:21:32',3310490875,1),(281041763,424887061,14904300,592895,1,'2008-07-25 21:21:32',3310490875,1),(281041764,424887061,14901639,592895,1,'2008-07-25 21:21:32',3310490875,1),(281041765,424883201,14901553,592895,1,'2008-07-25 21:21:32',3310490875,1),(281041766,424883137,14903098,592895,1,'2008-07-25 21:21:32',3310490875,1),(281041767,424883834,14903956,592895,1,'2008-07-25 21:21:32',3310490875,1),(281042331,424846869,14921637,592895,1,'2008-07-25 22:01:08',3310490863,4),(281042332,424847629,14921809,592895,1,'2008-07-25 22:00:32',3310490863,3),(281042336,424849148,14918204,592895,1,'2008-07-25 22:02:15',3310490874,3),(281042337,424848515,14917603,592895,1,'2008-07-25 21:28:02',3310490874,2),(281042725,424846173,14918033,592895,1,'2008-07-25 21:28:02',3310490863,2),(281042726,424846481,14919113,592895,1,'2008-07-25 23:38:32',3310490863,3),(281043016,424848317,14921516,305941,1,'2009-02-09 21:29:38',3310490874,4),(281043351,424847629,14923612,592895,1,'2008-07-25 22:01:08',3310490863,3),(281043353,424849401,14928590,592895,1,'2008-07-25 21:33:33',3310490874,2),(281043354,424854528,14937173,592895,1,'2008-07-25 21:28:56',3310490874,1),(281043356,424865216,14947007,592895,1,'2008-07-25 23:31:50',3310491216,2),(281043360,424883002,14951385,305941,1,'2009-02-09 21:30:44',3310491217,3),(281043618,424865288,14946357,592895,1,'2008-07-25 21:30:10',3310491216,1),(281043619,424869086,14947472,592895,1,'2008-07-25 21:30:10',3310491216,1),(281043621,424875407,14946922,592895,1,'2008-07-25 23:31:24',3310491217,2),(281043622,424879964,14947522,305941,1,'2009-02-09 21:30:35',3310491217,4),(281043623,424883454,14950992,305941,1,'2009-02-09 21:30:35',3310491217,2),(281043789,424850469,14927696,305941,1,'2009-02-09 21:29:38',3310490874,3),(281043790,424855406,14935935,305941,1,'2009-02-09 21:29:38',3310490874,3),(281043792,424860279,14941514,305941,1,'2009-02-09 21:29:37',3310490874,3),(281043794,424869331,14946750,305941,1,'2009-02-09 21:29:37',3310491216,3),(281043795,424875470,14946149,305941,1,'2009-02-09 21:29:37',3310491217,3),(281044538,424859908,14943095,592895,1,'2008-07-25 21:33:33',3310491216,1),(281044540,424875280,14947694,592895,1,'2008-07-25 23:31:50',3310491217,2),(281044597,424848443,14923833,592895,1,'2008-07-25 23:32:42',3310490874,3),(281044599,424854971,14936658,592895,1,'2008-07-25 21:34:02',3310490874,1),(281044619,424880217,14946836,305941,1,'2009-02-09 21:29:37',3310491217,6),(281044620,424865596,14945548,305941,1,'2009-02-09 21:29:37',3310491216,3),(281044641,424883834,14950906,305941,1,'2009-02-09 21:29:11',3310491217,2),(281048516,424849148,14924212,305941,1,'2009-02-09 21:29:38',3310490874,3),(281048956,424869204,14948123,592895,1,'2008-07-25 23:31:50',3310491216,2),(281048992,424849899,14928125,592895,1,'2008-07-25 23:32:42',3310490874,2),(281049120,424879656,14948245,305941,1,'2009-02-09 21:30:44',3310491217,3),(281049690,424846490,14920178,592895,1,'2008-07-25 22:02:15',3310490863,1),(281049691,424848760,14921001,592895,1,'2008-07-25 23:33:03',3310490874,2),(281050352,424849338,14921637,592895,1,'2008-07-25 22:03:34',3310490874,1);
INSERT INTO `nodes` VALUES (281050354,424855225,14925757,592895,1,'2008-07-25 22:03:34',3310490874,1),(281050357,424876365,14935628,592895,1,'2008-07-25 22:03:34',3310490875,1),(281050523,424907152,14952198,592895,1,'2008-07-25 22:07:05',3310491220,2),(281051136,424865732,14929706,592895,1,'2008-07-25 22:04:59',3310490874,1),(281051138,424901998,14950047,592895,1,'2008-07-25 22:04:59',3310491217,1),(281051139,424906935,14952966,592895,1,'2008-07-25 22:07:05',3310491220,2),(281051762,424907758,14951249,592895,1,'2008-07-25 22:07:05',3310491220,1),(281051764,424907884,14954253,592895,1,'2008-07-25 22:08:49',3310491220,2),(281051765,424908770,14954339,592895,1,'2008-07-25 22:07:05',3310491220,1),(281051766,424909340,14953566,592895,1,'2008-07-25 22:07:05',3310491220,1),(281051966,424909277,14952279,592895,1,'2008-07-25 22:08:49',3310491220,1),(281051967,424909024,14951335,592895,1,'2008-07-25 22:08:49',3310491220,1),(281051968,424908327,14951077,592895,1,'2008-07-25 22:08:49',3310491220,1),(281051969,424907378,14953824,592895,1,'2008-07-25 22:08:49',3310491220,1),(281052233,424910543,14963523,592895,1,'2008-07-25 22:24:15',3310491220,2),(281052234,424908834,14962836,592895,1,'2008-07-25 22:24:15',3310491220,2),(281052236,424898138,14961549,592895,1,'2008-07-25 22:10:54',3310491217,1),(281052237,424895100,14959060,592895,1,'2008-07-25 22:10:54',3310491217,1),(281052341,424901555,14962321,592895,1,'2008-07-25 22:11:40',3310491217,1),(281052343,424911175,14962836,592895,1,'2008-07-25 22:11:40',3310491220,1),(281052458,424886239,14952622,592895,1,'2008-07-25 22:12:56',3310491217,1),(281052509,424890226,14955111,592895,1,'2008-07-25 22:13:14',3310491217,1),(281052580,424894910,14963351,592895,1,'2008-07-25 22:13:40',3310491217,1),(281052582,424902062,14964381,592895,1,'2008-07-25 22:13:40',3310491217,1),(281052585,424912622,14966577,592895,1,'2008-07-25 23:29:27',3310491220,2),(281053771,424897062,14964467,592895,1,'2008-07-25 22:18:59',3310491217,1),(281053773,424915597,14971298,592895,1,'2008-07-25 23:29:27',3310491220,2),(281053776,424930090,14997047,592895,1,'2008-07-25 23:29:27',3310491222,2),(281053777,424933580,15001803,592895,1,'2008-07-25 22:18:59',3310491223,1),(281053833,424885344,14954131,592895,1,'2008-07-25 23:31:04',3310491217,2),(281053836,424927179,14992498,592895,1,'2008-07-25 23:29:27',3310491220,2),(281053935,424860035,14942323,592895,1,'2008-07-25 22:21:29',3310491216,1),(281053938,424897125,14963694,592895,1,'2008-07-25 22:21:29',3310491217,1),(281053939,424908707,14963694,592895,1,'2008-07-25 22:21:30',3310491220,1),(281053940,424912884,14966012,592895,1,'2008-07-25 22:21:30',3310491220,1),(281053941,424921808,14980346,592895,1,'2008-07-25 22:21:30',3310491220,1),(281053942,424927504,14992019,592895,1,'2008-07-25 22:21:30',3310491220,1),(281053943,424930162,14996224,592895,1,'2008-07-25 22:21:30',3310491220,1),(281053944,424938128,15007604,592895,1,'2008-07-25 23:28:00',3310491223,2),(281053945,424938623,15009280,592895,1,'2008-07-25 22:21:30',3310491223,1),(281053946,424908644,14964553,592895,1,'2008-07-25 22:21:31',3310491220,1),(281055053,424885479,14953566,592895,1,'2008-07-25 22:23:55',3310491217,1),(281055773,424938318,15006831,592895,1,'2008-07-25 23:28:18',3310491223,3),(281055776,424927875,14991296,592895,1,'2008-07-25 23:28:18',3310491220,2),(281055778,424913074,14965154,592895,1,'2008-07-25 22:25:08',3310491220,1),(281056115,424930596,14995759,592895,1,'2008-07-25 23:28:18',3310491221,2),(281056116,424922314,14979831,592895,1,'2008-07-25 22:25:47',3310491220,1),(281056804,424885794,14953864,592895,1,'2008-07-25 22:27:13',3310491217,1),(281057175,424914340,14960690,592895,1,'2008-07-25 22:27:53',3310491220,1),(281057998,424895036,14962579,592895,1,'2008-07-25 22:29:27',3310491217,1),(281058251,424921365,14980861,592895,1,'2008-07-25 22:29:39',3310491220,1),(281059700,424951237,15037509,592895,1,'2008-07-25 22:37:44',3310491223,1),(281059701,424950604,15038196,592895,1,'2008-07-25 22:37:44',3310491223,1),(281059703,424950857,15040427,592895,1,'2008-07-25 22:37:44',3310491223,1),(281059704,424951680,15040599,592895,1,'2008-07-25 22:37:44',3310491223,1),(281060136,424950414,15039397,592895,1,'2008-07-25 22:40:16',3310491223,1),(281060138,424952123,15039826,592895,1,'2008-07-25 22:40:16',3310491223,1),(281060139,424952313,15038539,592895,1,'2008-07-25 22:40:16',3310491223,1),(281063471,425001159,15082448,592895,1,'2008-07-25 23:02:12',3310491401,2),(281063820,425002424,15081247,592895,1,'2008-07-25 23:02:12',3310491401,1),(281063821,425004512,15079444,592895,1,'2008-07-25 23:02:12',3310491401,1),(281063822,425003310,15077127,592895,1,'2008-07-25 23:02:12',3310491401,1),(281063857,425000006,15079938,2369619,1,'2009-09-04 17:10:07',3310491401,2),(281063895,424999260,15058416,592895,1,'2008-07-25 23:03:18',3310491401,1),(281063913,424992363,15063909,592895,1,'2008-07-25 23:03:33',3310491401,1),(281063929,424976690,15032276,592895,1,'2008-07-25 23:03:57',3310491394,1),(281064107,424979706,15029233,592895,1,'2008-07-25 23:05:13',3310491394,1),(281064124,424966636,15012042,592895,1,'2008-07-25 23:05:42',3310491394,1),(281064259,424985591,15012840,592895,1,'2008-07-25 23:08:45',3310491395,2),(281064260,424988249,15014556,592895,1,'2008-07-25 23:06:40',3310491395,1),(281064261,424991287,15016702,592895,1,'2008-07-25 23:06:40',3310491395,1),(281064262,424995780,15019964,592895,1,'2008-07-25 23:06:40',3310491395,1),(281064263,424998248,15023311,592895,1,'2008-07-25 23:06:40',3310491395,1),(281064270,424982617,15010093,592895,1,'2008-07-25 23:06:40',3310491394,1),(281064271,424984199,15012153,592895,1,'2008-07-25 23:06:40',3310491394,1),(281064525,424973125,15007089,592895,1,'2008-07-25 23:08:45',3310491394,1),(281064526,424976922,15006402,592895,1,'2008-07-25 23:08:45',3310491394,1),(281064529,424979643,15007346,592895,1,'2008-07-25 23:08:45',3310491394,1),(281064533,424984136,15026830,592895,1,'2008-07-25 23:08:45',3310491394,1),(281064535,424982554,15027345,592895,1,'2008-07-25 23:10:34',3310491394,2),(281064537,424981162,15028203,592895,1,'2008-07-25 23:08:45',3310491394,1),(281064540,424979833,15027517,592895,1,'2008-07-25 23:08:46',3310491394,1),(281064542,424976985,15021938,592895,1,'2008-07-25 23:08:46',3310491394,1),(281064784,424968125,15010522,592895,1,'2008-07-25 23:10:34',3310491394,1),(281064785,424978504,15006231,592895,1,'2008-07-25 23:10:34',3310491394,1),(281064788,424983566,15026916,592895,1,'2008-07-25 23:10:34',3310491394,1),(281064789,424980655,15028117,592895,1,'2008-07-25 23:10:34',3310491394,1),(281065006,424980529,15023654,592895,1,'2008-07-25 23:11:46',3310491394,1),(281065304,424978630,15004085,592895,1,'2008-07-25 23:12:33',3310491394,1),(281065306,424975593,14993699,592895,1,'2008-07-25 23:12:33',3310491392,1),(281065308,424971542,14983743,592895,1,'2008-07-25 23:12:33',3310491392,1),(281065961,424994324,15017646,592895,1,'2008-07-25 23:16:12',3310491395,1),(281065962,424992742,15015672,592895,1,'2008-07-25 23:16:12',3310491395,1),(281065963,424991730,15013784,592895,1,'2008-07-25 23:16:12',3310491395,1),(281065964,424991034,15011724,592895,1,'2008-07-25 23:16:12',3310491395,1),(281065978,424984832,15025285,592895,1,'2008-07-25 23:16:17',3310491394,1),(281065980,424981541,15009836,592895,1,'2008-07-25 23:16:17',3310491394,1),(281066086,424977681,14999536,592895,1,'2008-07-25 23:17:34',3310491394,1),(281066153,424977997,15023826,592895,1,'2008-07-25 23:17:52',3310491394,1),(281066192,424984642,15026229,592895,1,'2008-07-25 23:18:32',3310491394,1),(281066279,424984579,15031122,592895,1,'2008-07-25 23:18:55',3310491394,1),(281066349,424973631,14988035,592895,1,'2008-07-25 23:20:09',3310491392,1),(281066356,424967185,15011482,592895,1,'2008-07-25 23:20:15',3310491394,1),(281066600,424968948,15000308,592895,1,'2008-07-25 23:21:18',3310491394,1),(281066604,424966480,14986490,592895,1,'2008-07-25 23:21:18',3310491392,1),(281066606,424963189,14987520,592895,1,'2008-07-25 23:21:18',3310491392,1),(281066607,424961860,14987777,592895,1,'2008-07-25 23:21:18',3310491392,1),(281066608,424960594,14987348,592895,1,'2008-07-25 23:21:18',3310491392,1),(281066609,424959455,14986661,592895,1,'2008-07-25 23:21:18',3310491392,1),(281066610,424958569,14986490,592895,1,'2008-07-25 23:21:18',3310491392,1),(281066612,424955342,14982112,592895,1,'2008-07-25 23:21:18',3310491221,1),(281066613,424954772,14981254,592895,1,'2008-07-25 23:21:18',3310491221,1),(281066614,424953759,14980996,592895,1,'2008-07-25 23:21:18',3310491221,1),(281066629,424950469,14978936,592895,1,'2008-07-25 23:21:36',3310491221,1),(281066631,424951544,14976276,592895,1,'2008-07-25 23:21:36',3310491221,1),(281066633,424954456,14973958,592895,1,'2008-07-25 23:21:37',3310491221,1),(281066666,424966796,14983486,592895,1,'2008-07-25 23:22:28',3310491392,1),(281066671,424966543,14976533,592895,1,'2008-07-25 23:22:28',3310491392,1),(281066673,424963885,14972671,592895,1,'2008-07-25 23:22:28',3310491392,1),(281066675,424962113,14968379,592895,1,'2008-07-25 23:22:28',3310491392,1),(281066676,424961860,14966577,592895,1,'2008-07-25 23:22:28',3310491392,1),(281066881,424967113,15010351,592895,1,'2008-07-25 23:23:18',3310491394,1),(281066882,424967809,15008205,592895,1,'2008-07-25 23:23:18',3310491394,1),(281066883,424968758,15005630,592895,1,'2008-07-25 23:23:19',3310491394,1),(281066884,424969328,15003227,592895,1,'2008-07-25 23:23:19',3310491394,1),(281066889,424957557,14985202,592895,1,'2008-07-25 23:23:19',3310491221,1),(281067272,424967049,14979709,592895,1,'2008-07-25 23:25:35',3310491392,1),(281067274,424965847,14975589,592895,1,'2008-07-25 23:25:35',3310491392,1),(281067289,424965024,14986404,592895,1,'2008-07-25 23:25:39',3310491392,1),(281067291,424967113,14991039,592895,1,'2008-07-25 23:25:39',3310491392,1),(281067340,424967682,14996532,592895,1,'2008-07-25 23:25:50',3310491392,1),(281067341,424967049,14987605,592895,1,'2008-07-25 23:25:50',3310491392,1),(281067342,424967049,14978164,592895,1,'2008-07-25 23:25:50',3310491392,1),(281067343,424962746,14970954,592895,1,'2008-07-25 23:25:50',3310491392,1),(281069194,424846608,14920915,592895,1,'2008-07-25 23:36:48',3310490863,1),(281069787,424950595,14977477,592895,1,'2008-07-25 23:39:24',3310491221,1),(281069788,424953443,14975074,592895,1,'2008-07-25 23:39:24',3310491221,1),(281070673,425010213,15102208,592895,1,'2008-07-25 23:43:00',3310491401,1),(281070966,425010587,15099014,592895,1,'2008-07-25 23:44:57',3310491401,1),(281070968,425011600,15091289,592895,1,'2008-07-25 23:44:57',3310491401,1),(281071349,425011220,15096010,592895,1,'2008-07-25 23:48:10',3310491401,1),(281072460,425084684,15227760,592895,1,'2008-07-25 23:51:45',3310491442,1),(281072599,425078230,15232480,592895,1,'2008-07-25 23:52:38',3310491442,1),(281072600,425079179,15231193,592895,1,'2008-07-25 23:52:38',3310491442,1),(281072602,425081141,15230935,592895,1,'2008-07-25 23:52:38',3310491442,1),(281073498,425083671,15214885,592895,1,'2008-07-25 23:57:57',3310491440,1),(281073499,425081141,15211967,592895,1,'2008-07-25 23:57:57',3310491440,1),(281073500,425080381,15211023,592895,1,'2008-07-25 23:57:57',3310491440,1),(281073501,425079306,15212396,592895,1,'2008-07-25 23:57:57',3310491440,1),(281073502,425077534,15214971,592895,1,'2008-07-25 23:57:57',3310491440,1),(281073503,425079242,15217460,592895,1,'2008-07-25 23:57:57',3310491442,1),(281073504,425080761,15219348,592895,1,'2008-07-25 23:57:57',3310491442,1),(281073607,425081710,15231794,592895,1,'2008-07-25 23:58:57',3310491442,1),(281073608,425080128,15230335,592895,1,'2008-07-25 23:58:57',3310491442,1),(281076210,425063044,15159782,592895,1,'2008-07-26 00:12:00',3310491407,1),(281076211,425062791,15162013,592895,1,'2008-07-26 00:12:00',3310491429,1),(281076212,425062981,15164502,592895,1,'2008-07-26 00:12:00',3310491429,1),(281076213,425063550,15167507,592895,1,'2008-07-26 00:12:00',3310491429,1),(281076688,425065449,15167592,592895,1,'2008-07-26 00:15:23',3310491429,1),(281076689,425065449,15165275,592895,1,'2008-07-26 00:15:23',3310491429,1),(281076690,425065322,15163387,592895,1,'2008-07-26 00:15:23',3310491429,1),(281076691,425064753,15161842,592895,1,'2008-07-26 00:15:23',3310491429,1),(281076692,425063819,15160217,592895,1,'2008-07-26 00:15:23',3310491407,1),(281076908,425063804,15155662,592895,1,'2008-07-26 00:18:03',3310491407,1),(281076910,425063297,15148538,592895,1,'2008-07-26 00:18:03',3310491407,1),(281076912,425059627,15143731,592895,1,'2008-07-26 00:32:32',3310491407,2),(281079386,425063614,15151370,592895,1,'2008-07-26 00:29:13',3310491407,1),(281079387,425061716,15146306,592895,1,'2008-07-26 00:29:13',3310491407,1),(281079396,425056780,15139268,592895,1,'2008-07-26 00:32:32',3310491407,2),(281080196,425054629,15136951,592895,1,'2008-07-26 00:32:46',3310491407,1),(281080244,425052604,15132831,592895,1,'2008-07-26 00:33:05',3310491407,1),(281694408,425558367,15352907,615859,1,'2008-07-28 14:01:21',3310502459,1),(283678401,425558809,15320788,72964,1,'2008-08-05 20:27:04',3310502457,1),(283680492,425569178,15347739,72964,1,'2008-08-05 20:37:36',3310502462,1),(287395969,425328921,15197058,210114,1,'2008-08-12 23:44:51',3310491505,2),(287396015,425330122,15196543,174860,1,'2008-12-06 16:19:27',3310491505,3),(287396438,425331324,15198087,226881,1,'2009-04-05 17:09:50',3310491505,6),(287397023,425329869,15197830,226881,1,'2009-04-05 17:09:50',3310491505,4),(287397028,425329047,15197573,210114,1,'2008-08-12 23:44:51',3310491505,2),(287397030,425329680,15196199,210114,1,'2008-08-12 23:44:51',3310491505,2),(287397098,425333285,15197143,226881,1,'2009-04-05 17:09:50',3310491505,5),(287397484,425332273,15197401,226881,1,'2009-04-05 17:09:50',3310491505,4),(287397486,425330692,15198259,226881,1,'2009-04-05 17:09:50',3310491505,4),(287399090,425330186,15197229,210114,1,'2008-08-12 23:44:51',3310491505,1),(287399091,425329427,15197830,210114,1,'2008-08-12 23:44:51',3310491505,1),(287399092,425329174,15196371,210114,1,'2008-08-12 23:44:51',3310491505,1),(287401324,425371101,15200900,210114,1,'2008-08-12 23:49:34',3310491509,1),(287403168,425429223,15172596,210114,1,'2008-08-12 23:52:58',3310502433,1),(287403171,425429223,15173197,210114,1,'2008-08-12 23:52:58',3310502433,1),(287403173,425424986,15177145,210114,1,'2008-08-12 23:52:58',3310502433,1),(287403175,425424101,15175342,210114,1,'2008-08-12 23:52:58',3310502432,1),(287403179,425428085,15172252,210114,1,'2008-08-12 23:52:59',3310502433,1),(291063328,426257932,15515967,404186,1,'2008-08-26 00:23:20',3310502877,1),(291063330,426259890,15520602,404186,1,'2008-08-26 00:23:21',3310502877,1),(291063331,426257427,15523177,404186,1,'2008-08-26 00:23:21',3310502877,1),(291063333,426255785,15524292,404186,1,'2008-08-26 00:23:21',3310502877,1),(291063334,426250354,15524464,404186,1,'2008-08-26 00:23:21',3310502877,1),(291063335,426248901,15523949,404186,1,'2008-08-26 00:23:21',3310502877,1),(291063336,426247954,15519743,404186,1,'2008-08-26 00:23:21',3310502876,1),(291063337,426248775,15513478,404186,1,'2008-08-26 00:23:21',3310502877,1),(291063338,426254522,15514250,404186,1,'2008-08-26 00:23:21',3310502877,1),(292503717,425466649,17306629,478731,1,'2008-08-31 13:56:45',3310504590,1),(316946989,425436551,15164222,174860,1,'2008-12-06 15:58:00',3310502433,1),(316946990,425434591,15161561,174860,1,'2008-12-06 15:58:00',3310502433,1),(316946991,425432500,15159700,174860,1,'2008-12-06 15:58:00',3310502411,1),(316946992,425432946,15158900,787878,1,'2009-01-15 00:31:30',3310502411,4),(316947014,425435070,15159300,174860,1,'2008-12-06 16:20:04',3310502411,2),(316947015,425438480,15158270,174860,1,'2008-12-06 16:20:04',3310502411,2),(316947016,425442259,15154852,174860,1,'2008-12-06 16:20:04',3310502411,2),(316947017,425444029,15152621,174860,1,'2008-12-06 16:20:04',3310502411,4),(316949603,425444050,15151230,174860,1,'2008-12-06 16:19:26',3310502411,2),(316949604,425447630,15145580,174860,1,'2008-12-06 16:19:26',3310502411,2),(316949605,425449650,15144300,174860,1,'2008-12-06 16:19:26',3310502411,2),(316950996,425445041,15152020,174860,1,'2008-12-06 16:19:26',3310502411,1),(316950997,425446950,15150920,174860,1,'2008-12-06 16:19:26',3310502411,1),(316950998,425448835,15150046,174860,1,'2008-12-06 16:19:26',3310502411,1),(316950999,425450450,15149200,174860,1,'2008-12-06 16:19:26',3310502411,1),(316951000,425452380,15149830,174860,1,'2008-12-06 16:19:26',3310502414,1),(316951001,425452913,15151460,174860,1,'2008-12-06 16:19:28',3310502414,2),(316961219,426057100,15359760,437534,1,'2008-12-17 18:58:15',3310502762,6),(316961221,426056440,15359790,174860,1,'2008-12-06 17:05:27',3310502762,1),(316961223,426055619,15359017,174860,1,'2008-12-06 17:05:27',3310502719,1),(316961225,426054924,15357987,174860,1,'2008-12-06 17:05:27',3310502719,1),(316961244,426098007,15379359,174860,1,'2008-12-06 17:05:49',3310502763,1),(316961245,426101910,15380960,437534,1,'2008-12-17 19:04:10',3310502763,10),(316961246,426104956,15382192,437534,1,'2008-12-17 19:04:10',3310502849,10),(316961247,426105524,15383308,437534,1,'2008-12-17 19:04:10',3310502849,12),(316961289,426089479,15362108,437534,1,'2008-12-17 19:04:10',3310502763,13),(316961291,426089360,15362680,437534,1,'2008-12-17 19:04:10',3310502763,6),(316961294,426090365,15364424,437534,1,'2008-12-17 19:04:10',3310502763,6),(316961331,426096300,15380380,437534,1,'2008-12-17 18:58:15',3310502763,5),(316961332,426095080,15379760,437534,1,'2008-12-17 18:58:15',3310502763,5),(316961335,426092410,15375180,437534,1,'2008-12-17 18:58:15',3310502763,5),(316961337,426089060,15372100,437534,1,'2008-12-17 18:58:15',3310502763,5),(316961339,426082950,15364660,437534,1,'2008-12-17 18:58:15',3310502762,5),(316961341,426081350,15364130,437534,1,'2008-12-17 18:58:15',3310502762,5),(316961342,426077980,15364780,437534,1,'2008-12-17 18:58:15',3310502762,5),(316961343,426067600,15369730,437534,1,'2008-12-17 18:58:15',3310502762,5),(316961344,426056430,15358660,437534,1,'2008-12-17 18:58:15',3310502762,5),(316961345,426056360,15357210,437534,1,'2008-12-17 18:58:15',3310502762,5),(316961346,426056780,15356460,437534,1,'2008-12-17 18:58:15',3310502762,6),(316961349,426084200,15359910,174860,1,'2008-12-06 17:18:43',3310502763,5),(316961350,426080480,15359880,174860,1,'2008-12-06 17:18:43',3310502762,5),(316961351,426073680,15363210,174860,1,'2008-12-06 17:18:43',3310502762,5),(316961352,426071710,15363600,174860,1,'2008-12-06 17:18:43',3310502762,6),(316961375,426092448,15354297,437534,1,'2008-12-17 18:33:59',3310502763,7),(316961406,426090360,15355630,174860,1,'2008-12-06 17:15:19',3310502763,3),(316961407,426092860,15354880,437534,1,'2008-12-17 19:00:45',3310502763,5),(316961408,426095354,15355928,174860,1,'2008-12-06 17:07:25',3310502763,2),(316961409,426099780,15356780,174860,1,'2008-12-06 17:07:25',3310502763,2),(316961410,426102429,15359103,174860,1,'2008-12-06 17:06:48',3310502763,1),(316961411,426105600,15361580,174860,1,'2008-12-06 17:07:25',3310502763,2),(316961412,426108040,15362300,174860,1,'2008-12-06 17:07:25',3310502763,2),(316961413,426109910,15361650,174860,1,'2008-12-06 17:07:25',3310502763,2),(316961414,426113780,15359130,174860,1,'2008-12-06 17:07:25',3310502766,2),(316961415,426115250,15358860,174860,1,'2008-12-06 17:07:26',3310502766,2),(316961416,426115580,15357860,174860,1,'2008-12-06 17:07:26',3310502766,2),(316961417,426109060,15356390,174860,1,'2008-12-06 17:07:26',3310502763,2),(316961418,426108080,15356860,174860,1,'2008-12-06 17:07:26',3310502763,2),(316961419,426101355,15350177,174860,1,'2008-12-06 17:07:26',3310502763,2),(316961420,426100534,15349490,174860,1,'2008-12-06 17:07:26',3310502763,2),(316961421,426100093,15348610,174860,1,'2008-12-06 17:07:26',3310502763,3),(316961468,426110010,15348760,174860,1,'2008-12-06 17:07:11',3310502763,1),(316961469,426106535,15349576,174860,1,'2008-12-06 17:07:12',3310502763,1),(316961471,426101418,15348718,174860,1,'2008-12-06 17:07:13',3310502763,1),(316961473,426094550,15348160,174860,1,'2008-12-06 17:07:14',3310502763,1),(316961475,426093660,15348630,174860,1,'2008-12-06 17:07:14',3310502763,1),(316961477,426093880,15350230,174860,1,'2008-12-06 17:07:14',3310502763,1),(316961478,426099210,15351910,174860,1,'2008-12-06 17:07:14',3310502763,1),(316961480,426102500,15354060,174860,1,'2008-12-06 17:07:15',3310502763,1),(316961481,426103700,15355800,174860,1,'2008-12-06 17:07:15',3310502763,1),(316961483,426103630,15357450,174860,1,'2008-12-06 17:07:15',3310502763,1),(316961484,426102700,15358780,174860,1,'2008-12-06 17:07:15',3310502763,1),(316961486,426102366,15363051,174860,1,'2008-12-06 17:07:15',3310502763,1),(316961518,426098324,15365196,437534,1,'2008-12-17 19:00:45',3310502763,4),(316962617,426057980,15356260,174860,1,'2008-12-06 17:15:19',3310502762,1),(316962618,426068510,15363160,174860,1,'2008-12-06 17:15:19',3310502762,1),(316962619,426070230,15363660,174860,1,'2008-12-06 17:17:23',3310502762,2),(316962620,426070450,15362730,174860,1,'2008-12-06 17:15:19',3310502762,1),(316962621,426069150,15361330,174860,1,'2008-12-06 17:15:19',3310502762,1),(316962622,426068150,15358360,174860,1,'2008-12-06 17:15:19',3310502762,1),(316962623,426065300,15353850,174860,1,'2008-12-06 17:15:19',3310502762,1),(316962624,426065830,15352910,174860,1,'2008-12-06 17:15:19',3310502762,1),(316962625,426071260,15356000,174860,1,'2008-12-06 17:15:19',3310502762,1),(316962626,426073660,15356310,174860,1,'2008-12-06 17:15:19',3310502762,1),(316962627,426075930,15356030,174860,1,'2008-12-06 17:15:19',3310502762,1),(316962628,426079810,15354400,174860,1,'2008-12-06 17:15:19',3310502762,1),(316963054,426087557,15361307,437534,1,'2008-12-17 19:00:45',3310502763,8),(316985105,426103250,15366914,206510,1,'2008-12-06 19:26:01',3310502763,1),(316985238,426105272,15384595,206510,1,'2008-12-06 19:28:52',3310502849,3),(316985239,426105051,15385582,206510,1,'2008-12-06 19:38:08',3310502849,3),(319538722,426092197,15355583,437534,1,'2008-12-17 19:00:45',3310502763,3),(319538724,426092323,15356442,437534,1,'2008-12-17 19:00:45',3310502763,3),(319538726,426094471,15357815,437534,1,'2008-12-17 19:00:45',3310502763,3),(319538728,426097630,15360390,437534,1,'2008-12-17 19:00:45',3310502763,3),(319538731,426098261,15361935,437534,1,'2008-12-17 19:00:45',3310502763,3),(319538733,426098893,15363480,437534,1,'2008-12-17 19:00:45',3310502763,3),(319538735,426098767,15364338,437534,1,'2008-12-17 19:00:45',3310502763,3),(319541439,426099525,15367771,437534,1,'2008-12-17 19:01:56',3310502763,6),(319541441,426099904,15369831,437534,1,'2008-12-17 19:01:56',3310502763,6),(319541444,426099461,15371548,437534,1,'2008-12-17 19:01:56',3310502763,6),(319541446,426098830,15373093,437534,1,'2008-12-17 19:01:56',3310502763,6),(319541448,426098577,15374724,437534,1,'2008-12-17 19:01:56',3310502763,6),(319541450,426099651,15380045,437534,1,'2008-12-17 19:04:10',3310502763,5),(319543280,426099082,15366741,437534,1,'2008-12-17 19:01:56',3310502763,1),(319543646,426091755,15366141,437534,1,'2008-12-17 19:04:10',3310502763,1),(321651052,424419897,15513121,372139,1,'2009-04-10 12:07:19',3310490584,2),(321651053,424421925,15514429,372139,1,'2009-04-10 12:07:19',3310490584,2),(321651054,424427748,15517897,372139,1,'2009-04-10 12:07:19',3310490584,2),(321651055,424432460,15521234,372139,1,'2009-04-10 12:07:19',3310490584,2),(321651056,424434422,15523459,372139,1,'2009-04-10 12:07:19',3310490584,2),(321651057,424434750,15527319,372139,1,'2009-04-10 12:07:19',3310490584,2),(321651059,424434619,15530460,372139,1,'2009-04-10 12:07:19',3310490584,2),(321651060,424434226,15536022,372139,1,'2009-04-10 12:07:19',3310490584,2),(321651080,424482604,15604502,372139,1,'2009-04-10 12:07:19',3310490612,2),(321651081,424485739,15603902,372139,1,'2009-04-10 12:07:19',3310490612,2),(321651082,424487806,15603035,372139,1,'2009-04-10 12:07:19',3310490612,2),(321651083,424489673,15601368,372139,1,'2009-04-10 12:07:19',3310490612,2),(321651084,424493141,15601368,372139,1,'2009-04-10 12:07:19',3310490613,2),(321651085,424495542,15601768,372139,1,'2009-04-10 12:07:19',3310490613,2),(321651086,424498210,15600834,372139,1,'2009-04-10 12:07:19',3310490613,2),(321651088,424501344,15596766,372139,1,'2009-04-10 12:07:19',3310490591,2),(321651089,424504545,15592365,372139,1,'2009-04-10 12:07:19',3310490591,2),(321651090,424509080,15590031,372139,1,'2009-04-10 12:07:19',3310490591,2),(321651091,424512881,15587963,372139,1,'2009-04-10 12:07:20',3310490591,2),(321651092,424516549,15587763,372139,1,'2009-04-10 12:07:20',3310490591,2),(321651093,424519217,15588563,372139,1,'2009-04-10 12:07:20',3310491274,2),(321651094,424529687,15588097,372139,1,'2009-04-10 12:07:20',3310491274,2),(321651095,424535289,15586829,372139,1,'2009-04-10 12:07:20',3310491274,2),(321651096,424550561,15581094,372139,1,'2009-04-10 12:07:20',3310491275,2),(321651097,424554695,15581428,372139,1,'2009-04-10 12:07:20',3310491275,2),(321651098,424557563,15583428,372139,1,'2009-04-10 12:07:20',3310491275,2),(321651099,424559564,15587496,372139,1,'2009-04-10 12:07:20',3310491275,2),(321651100,424560564,15590431,372139,1,'2009-04-10 12:07:20',3310491275,2),(321651101,424564565,15594032,372139,1,'2009-04-10 12:07:20',3310491275,2),(321651103,424568900,15595566,372139,1,'2009-04-10 12:07:20',3310491275,2),(321651104,424573635,15597433,372139,1,'2009-04-10 12:07:20',3310491278,2),(321651105,424579304,15600901,372139,1,'2009-04-10 12:07:20',3310491300,2),(321651106,424581371,15604302,372139,1,'2009-04-10 12:07:20',3310491300,2),(321651107,424584572,15608103,372139,1,'2009-04-10 12:07:20',3310491300,2),(321651108,424586906,15609971,372139,1,'2009-04-10 12:07:20',3310491300,2),(321651109,424587380,15610294,599374,1,'2008-12-25 21:58:55',3310491300,1),(321679128,424586858,15610012,621592,1,'2008-12-26 01:04:53',3310491300,1),(321679131,424586568,15610346,621592,1,'2008-12-26 01:04:53',3310491300,1),(321679133,424586026,15610554,621592,1,'2008-12-26 01:04:53',3310491300,1),(321679135,424585157,15611108,621592,1,'2008-12-26 01:04:53',3310491300,1),(321679137,424584332,15611625,621592,1,'2008-12-26 01:04:53',3310491300,1),(321679139,424583506,15612394,621592,1,'2008-12-26 01:04:54',3310491300,1),(321679141,424582914,15613276,621592,1,'2008-12-26 01:04:54',3310491300,1),(321679143,424582303,15614234,621592,1,'2008-12-26 01:04:54',3310491300,1),(321679145,424581711,15615342,621592,1,'2008-12-26 01:04:54',3310491300,1),(321679147,424581257,15616615,621592,1,'2008-12-26 01:04:55',3310491300,1),(321679148,424580545,15618291,621592,1,'2008-12-26 01:04:55',3310491300,1),(321679150,424579860,15620151,621592,1,'2008-12-26 01:04:55',3310491300,1),(321679151,424579742,15621503,621592,1,'2008-12-26 01:04:55',3310491300,1),(321679152,424579860,15622719,621592,1,'2008-12-26 01:04:55',3310491300,1),(321679154,424580105,15625322,621592,1,'2008-12-26 01:04:56',3310491300,1),(321679155,424580105,15626856,621592,1,'2008-12-26 01:04:56',3310491300,1),(321679156,424580087,15628208,621592,1,'2008-12-26 01:04:56',3310491300,1),(321679157,424580114,15630821,621592,1,'2008-12-26 01:04:56',3310491300,1),(321679159,424580486,15632680,621592,1,'2008-12-26 01:04:56',3310491300,1),(321679160,424581067,15634341,621592,1,'2008-12-26 01:04:56',3310491300,1),(321679161,424582346,15637090,621592,1,'2008-12-26 01:04:57',3310491300,1),(321679162,424582664,15637988,621592,1,'2008-12-26 01:04:57',3310491300,1),(321679163,424583036,15638941,621592,1,'2008-12-26 01:04:57',3310491300,1),(321679164,424583263,15639186,621592,1,'2008-12-26 01:04:57',3310491300,1),(321679165,424583417,15639095,621592,1,'2008-12-26 01:04:57',3310491300,1),(321679166,424583462,15638805,621592,1,'2008-12-26 01:04:58',3310491300,1),(321679170,424583644,15637562,621592,1,'2008-12-26 01:04:58',3310491300,1),(321679176,424584124,15636273,621592,1,'2008-12-26 01:04:58',3310491300,1),(321679180,424585286,15634286,621592,1,'2008-12-26 01:04:58',3310491300,1),(321679181,424586926,15633795,621592,1,'2008-12-26 01:04:58',3310491300,1),(321679182,424587732,15633435,621592,1,'2008-12-26 01:04:59',3310491300,1),(321679183,424589180,15632445,621592,1,'2008-12-26 01:04:59',3310491300,1),(321679184,424590802,15630245,621592,1,'2008-12-26 01:04:59',3310491300,1),(321679185,424591989,15628982,621592,1,'2008-12-26 01:04:59',3310491300,1),(321679186,424594329,15627251,621592,1,'2008-12-26 01:04:59',3310491300,1),(321679188,424596627,15625629,621592,1,'2008-12-26 01:04:59',3310491300,1),(321679189,424598554,15624344,621592,1,'2008-12-26 01:05:00',3310491300,1),(321679190,424600884,15623299,621592,1,'2008-12-26 01:05:00',3310491301,1),(321679191,424604074,15621165,621592,1,'2008-12-26 01:05:00',3310491301,1),(321679196,424606120,15619249,621592,1,'2008-12-26 01:05:00',3310491301,1),(321679197,424608439,15617017,621592,1,'2008-12-26 01:05:00',3310491301,1),(321679198,424611020,15614241,621592,1,'2008-12-26 01:05:00',3310491301,1),(321679199,424612827,15611987,621592,1,'2008-12-26 01:05:01',3310491301,1),(321679200,424614841,15610724,621592,1,'2008-12-26 01:05:01',3310491301,1),(321679202,424615919,15610452,621592,1,'2008-12-26 01:05:01',3310491301,1),(321679203,424616855,15610463,621592,1,'2008-12-26 01:05:01',3310491301,1),(321679204,424618183,15610224,621592,1,'2008-12-26 01:05:01',3310491301,1),(321679205,424619708,15609483,621592,1,'2008-12-26 01:05:02',3310491301,1),(321679206,424621776,15609233,621592,1,'2008-12-26 01:05:02',3310491301,1),(321679207,424623845,15609004,621592,1,'2008-12-26 01:05:02',3310491301,1),(321679208,424625162,15608732,621592,1,'2008-12-26 01:05:02',3310491301,1),(321679209,424627274,15609266,621592,1,'2008-12-26 01:05:02',3310491301,1),(321679210,424629260,15609869,621592,1,'2008-12-26 01:05:02',3310491312,1),(321679212,424630279,15610481,621592,1,'2008-12-26 01:05:03',3310491312,1),(321679213,424632191,15610888,621592,1,'2008-12-26 01:05:03',3310491312,1),(321679214,424636597,15611515,621592,1,'2008-12-26 01:05:03',3310491312,1),(321679215,424637741,15611766,621592,1,'2008-12-26 01:05:03',3310491312,1),(321679216,424639027,15612142,621592,1,'2008-12-26 01:05:03',3310491312,1),(321679217,424640328,15612628,621592,1,'2008-12-26 01:05:03',3310491312,1),(321679218,424642429,15612283,621592,1,'2008-12-26 01:05:04',3310491312,1),(321679219,424644953,15611923,621592,1,'2008-12-26 01:05:04',3310491312,1),(321679220,424645737,15611970,621592,1,'2008-12-26 01:05:04',3310491312,1),(321679221,424646505,15611562,621592,1,'2008-12-26 01:05:04',3310491312,1),(321679223,424647383,15611688,621592,1,'2008-12-26 01:05:04',3310491312,1),(321679224,424649594,15610967,621592,1,'2008-12-26 01:05:05',3310491312,1),(321679225,424651381,15610145,621592,1,'2008-12-26 01:05:05',3310491312,1),(321679226,424653714,15608170,621592,1,'2008-12-26 01:05:05',3310491312,1),(321679227,424657345,15604859,621592,1,'2008-12-26 01:05:05',3310491313,1),(321679228,424659602,15602770,621592,1,'2008-12-26 01:05:05',3310491313,1),(321679229,424661333,15599252,621592,1,'2008-12-26 01:05:06',3310491291,1),(321679230,424661879,15597785,621592,1,'2008-12-26 01:05:06',3310491291,1),(321679231,424663252,15596204,621592,1,'2008-12-26 01:05:06',3310491291,1),(321679233,424664343,15593683,621592,1,'2008-12-26 01:05:06',3310491291,1),(321679234,424664832,15592442,621592,1,'2008-12-26 01:05:06',3310491291,1),(321679236,424665566,15591106,621592,1,'2008-12-26 01:05:06',3310491291,1),(321679237,424665416,15592874,621592,1,'2008-12-26 01:05:07',3310491291,1),(321679238,424665547,15594229,621592,1,'2008-12-26 01:05:07',3310491291,1),(321679240,424666112,15596073,621592,1,'2008-12-26 01:05:07',3310491291,1),(321679242,424666375,15596901,621592,1,'2008-12-26 01:05:07',3310491291,1),(321679245,424667071,15597070,621592,1,'2008-12-26 01:05:07',3310491291,1),(321679247,424667617,15596750,621592,1,'2008-12-26 01:05:07',3310491291,1),(321679250,424668106,15596016,621592,1,'2008-12-26 01:05:08',3310491291,1),(321679252,424670458,15591971,621592,1,'2008-12-26 01:05:08',3310491291,1),(321679254,424671511,15591915,621592,1,'2008-12-26 01:05:08',3310491291,1),(321679255,424672471,15590993,621592,1,'2008-12-26 01:05:08',3310491291,1),(321679257,424674201,15590354,621592,1,'2008-12-26 01:05:08',3310491291,1),(321679260,424674841,15591012,621592,1,'2008-12-26 01:05:09',3310491291,1),(321679263,424675801,15591369,621592,1,'2008-12-26 01:05:09',3310491291,1),(321679266,424677701,15591840,621592,1,'2008-12-26 01:05:09',3310491291,1),(321679268,424678585,15591144,621592,1,'2008-12-26 01:05:09',3310491291,1),(321679271,424679789,15588980,621592,1,'2008-12-26 01:05:09',3310491291,1),(321679273,424681181,15587042,621592,1,'2008-12-26 01:05:09',3310491291,1),(321679275,424683062,15585782,621592,1,'2008-12-26 01:05:10',3310491294,1),(321679278,424686336,15585500,621592,1,'2008-12-26 01:05:10',3310491294,1),(321679281,424687822,15586327,621592,1,'2008-12-26 01:05:10',3310491294,1),(321679283,424689346,15587569,621592,1,'2008-12-26 01:05:10',3310491294,1),(321679286,424689666,15588472,621592,1,'2008-12-26 01:05:10',3310491294,1),(321679288,424689591,15590918,621592,1,'2008-12-26 01:05:10',3310491294,1),(321679290,424689628,15595602,621592,1,'2008-12-26 01:05:11',3310491294,1),(321679293,424690757,15599835,621592,1,'2008-12-26 01:05:11',3310491294,1),(321679295,424692732,15603353,621592,1,'2008-12-26 01:05:11',3310491316,1),(321679296,424694840,15606928,621592,1,'2008-12-26 01:05:11',3310491316,1),(321679298,424695009,15608283,621592,1,'2008-12-26 01:05:11',3310491316,1),(321679300,424694877,15610898,621592,1,'2008-12-26 01:05:11',3310491316,1),(321679302,424695517,15613851,621592,1,'2008-12-26 01:05:12',3310491316,1),(321679304,424697041,15615751,621592,1,'2008-12-26 01:05:12',3310491316,1),(321679306,424699580,15618178,621592,1,'2008-12-26 01:05:12',3310491316,1),(321679308,424700145,15617445,621592,1,'2008-12-26 01:05:12',3310491316,1),(321679309,424701142,15617896,621592,1,'2008-12-26 01:05:12',3310491316,1),(321679311,424703080,15619439,621592,1,'2008-12-26 01:05:12',3310491316,1),(321679313,424703531,15620662,621592,1,'2008-12-26 01:05:13',3310491316,1),(321679316,424703512,15622280,621592,1,'2008-12-26 01:05:13',3310491316,1),(321679318,424702986,15626005,621592,1,'2008-12-26 01:05:13',3310491316,1),(321679320,424702534,15629466,621592,1,'2008-12-26 01:05:13',3310491316,1),(321679322,424701349,15633060,621592,1,'2008-12-26 01:05:13',3310491316,1),(321679324,424700634,15636991,621592,1,'2008-12-26 01:05:14',3310491316,1),(321679326,424699599,15639080,621592,1,'2008-12-26 01:05:14',3310491316,1),(321679328,424699072,15638497,621592,1,'2008-12-26 01:05:14',3310491316,1),(321679330,424698452,15638120,621592,1,'2008-12-26 01:05:14',3310491316,1),(321679332,424697511,15639005,621592,1,'2008-12-26 01:05:14',3310491316,1),(321679334,424697172,15640039,621592,1,'2008-12-26 01:05:14',3310491316,1),(321679336,424695724,15643237,621592,1,'2008-12-26 01:05:15',3310491316,1),(321679340,424695197,15645570,621592,1,'2008-12-26 01:05:15',3310491316,1),(321679342,424694538,15649201,621592,1,'2008-12-26 01:05:15',3310491316,1),(321679344,424693410,15653303,621592,1,'2008-12-26 01:05:15',3310491316,1),(321679346,424692555,15657288,621592,1,'2008-12-26 01:05:15',3310491318,1),(321679348,424692005,15660799,621592,1,'2008-12-26 01:05:15',3310491318,1),(321679349,424690334,15663611,621592,1,'2008-12-26 01:05:16',3310491318,1),(321679350,424684921,15672472,621592,1,'2008-12-26 01:05:16',3310491318,1),(321679351,424684328,15673762,621592,1,'2008-12-26 01:05:16',3310491318,1),(321679353,424684286,15675433,621592,1,'2008-12-26 01:05:16',3310491318,1),(321679355,424685111,15677717,621592,1,'2008-12-26 01:05:16',3310491318,1),(321679357,424686781,15681566,621592,1,'2008-12-26 01:05:16',3310491318,1),(321679359,424687310,15683490,621592,1,'2008-12-26 01:05:17',3310491318,1),(321679361,424687522,15688544,621592,1,'2008-12-26 01:05:17',3310491318,1),(321679362,424687670,15689834,621592,1,'2008-12-26 01:05:17',3310491318,1),(321679365,424691032,15694825,621592,1,'2008-12-26 01:05:17',3310491318,1),(321679367,424692978,15699435,621592,1,'2008-12-26 01:05:17',3310491318,1),(321679369,424694902,15702459,621592,1,'2008-12-26 01:05:17',3310491318,1),(321679371,424697968,15705610,621592,1,'2008-12-26 01:05:18',3310491318,1),(321679373,424702198,15708740,621592,1,'2008-12-26 01:05:18',3310491318,1),(321679375,424706004,15711130,621592,1,'2008-12-26 01:05:18',3310491324,1),(321679378,424711947,15710960,621592,1,'2008-12-26 01:05:18',3310491325,1),(321679381,424713787,15711256,621592,1,'2008-12-26 01:05:18',3310491325,1),(321679383,424715056,15712250,621592,1,'2008-12-26 01:05:19',3310491325,1),(321679385,424715669,15714006,621592,1,'2008-12-26 01:05:19',3310491325,1),(321679387,424716282,15717305,621592,1,'2008-12-26 01:05:19',3310491325,1),(321679389,424719285,15723945,621592,1,'2008-12-26 01:05:19',3310491325,1),(321679391,424724720,15729570,621592,1,'2008-12-26 01:05:19',3310491325,1),(321679393,424729119,15733165,621592,1,'2008-12-26 01:05:19',3310491325,1),(321679394,424735103,15735576,621592,1,'2008-12-26 01:05:20',3310491325,1),(321679397,424739904,15736506,621592,1,'2008-12-26 01:05:20',3310491368,1),(321679398,424743985,15737077,621592,1,'2008-12-26 01:05:20',3310491368,1),(321679400,424748151,15739615,621592,1,'2008-12-26 01:05:20',3310491368,1),(321679402,424750181,15743041,621592,1,'2008-12-26 01:05:20',3310491368,1),(321679405,424750689,15744902,621592,1,'2008-12-26 01:05:20',3310491368,1),(321679408,424749526,15747144,621592,1,'2008-12-26 01:05:21',3310491368,1),(321679411,424749082,15751711,621592,1,'2008-12-26 01:05:21',3310491368,1),(321679413,424747052,15759240,621592,1,'2008-12-26 01:05:21',3310491368,1),(321679416,424746840,15760614,621592,1,'2008-12-26 01:05:21',3310491368,1),(321679418,424747622,15763681,621592,1,'2008-12-26 01:05:21',3310491368,1),(321679421,424748236,15767509,621592,1,'2008-12-26 01:05:22',3310491370,1),(321679422,424748955,15770385,621592,1,'2008-12-26 01:05:22',3310491370,1),(321679424,424749906,15774064,621592,1,'2008-12-26 01:05:22',3310491370,1),(321679426,424750795,15779330,621592,1,'2008-12-26 01:05:22',3310491370,1),(321679429,424751662,15784553,621592,1,'2008-12-26 01:05:22',3310491370,1),(321679431,424752994,15792103,621592,1,'2008-12-26 01:05:22',3310491370,1),(321679433,424753501,15793985,621592,1,'2008-12-26 01:05:23',3310491370,1),(321679435,424755426,15796777,621592,1,'2008-12-26 01:05:23',3310491370,1),(321679436,424758302,15800731,621592,1,'2008-12-26 01:05:23',3310491370,1),(321679437,424759127,15803713,621592,1,'2008-12-26 01:05:23',3310491370,1),(321679438,424758915,15806124,621592,1,'2008-12-26 01:05:23',3310491370,1),(321679439,424758704,15808725,621592,1,'2008-12-26 01:05:24',3310491370,1),(321679440,424760121,15812870,621592,1,'2008-12-26 01:05:24',3310491370,1),(321679441,424761580,15818368,621592,1,'2008-12-26 01:05:24',3310491370,1),(321679442,424762066,15820588,621592,1,'2008-12-26 01:05:24',3310492736,1),(321679443,424764033,15823084,621592,1,'2008-12-26 01:05:24',3310492736,1),(321679444,424766021,15824776,621592,1,'2008-12-26 01:05:25',3310492737,1),(321679445,424770462,15827483,621592,1,'2008-12-26 01:05:25',3310492737,1),(321679446,424771033,15828180,621592,1,'2008-12-26 01:05:25',3310492737,1),(321679447,424771138,15829534,621592,1,'2008-12-26 01:05:25',3310492737,1),(321679448,424770948,15831247,621592,1,'2008-12-26 01:05:25',3310492737,1),(321679449,424771244,15834186,621592,1,'2008-12-26 01:05:26',3310492737,1),(321679450,424772005,15836386,621592,1,'2008-12-26 01:05:26',3310492737,1),(321679451,424773845,15838796,621592,1,'2008-12-26 01:05:26',3310492737,1),(321679452,424775220,15840573,621592,1,'2008-12-26 01:05:26',3310492737,1),(321679453,424775622,15842518,621592,1,'2008-12-26 01:05:26',3310492737,1),(321679454,424776129,15844506,621592,1,'2008-12-26 01:05:27',3310492737,1),(321679455,424777187,15845585,621592,1,'2008-12-26 01:05:27',3310492737,1),(321679457,424777483,15845712,621592,1,'2008-12-26 01:05:27',3310492737,1),(321679458,424778138,15844802,621592,1,'2008-12-26 01:05:27',3310492737,1),(321679459,424779618,15842455,621592,1,'2008-12-26 01:05:27',3310492737,1),(321679460,424780507,15840911,621592,1,'2008-12-26 01:05:27',3310492737,1),(321679462,424781141,15840911,621592,1,'2008-12-26 01:05:28',3310492737,1),(321679465,424781881,15841461,621592,1,'2008-12-26 01:05:28',3310492737,1),(321679466,424783425,15843364,621592,1,'2008-12-26 01:05:28',3310492737,1),(321679467,424784842,15845733,621592,1,'2008-12-26 01:05:28',3310492737,1),(321679468,424785582,15847298,621592,1,'2008-12-26 01:05:28',3310492737,1),(321679469,424786491,15848841,621592,1,'2008-12-26 01:05:29',3310492737,1),(321679470,424786872,15849835,621592,1,'2008-12-26 01:05:29',3310492737,1),(321679471,424786661,15850723,621592,1,'2008-12-26 01:05:29',3310492737,1),(321679472,424786639,15852310,621592,1,'2008-12-26 01:05:29',3310492737,1),(321679473,424786155,15852204,621592,1,'2008-12-26 01:05:29',3310492737,1),(321679474,424785612,15851713,621592,1,'2008-12-26 01:05:30',3310492737,1),(321679478,424785068,15851868,621592,1,'2008-12-26 01:05:30',3310492737,1),(321679479,424784913,15852877,621592,1,'2008-12-26 01:05:30',3310492737,1),(321679480,424785508,15855386,621592,1,'2008-12-26 01:05:30',3310492737,1),(321679481,424786284,15857558,621592,1,'2008-12-26 01:05:31',3310492737,1),(321679482,424787344,15860222,621592,1,'2008-12-26 01:05:31',3310492737,1),(321679483,424788586,15862550,621592,1,'2008-12-26 01:05:31',3310492737,1),(321679484,424789827,15865059,621592,1,'2008-12-26 01:05:31',3310492737,1),(321679485,424793940,15867982,621592,1,'2008-12-26 01:05:31',3310492740,1),(321679486,424796423,15868421,621592,1,'2008-12-26 01:05:32',3310492740,1),(321679487,424797690,15868939,621592,1,'2008-12-26 01:05:32',3310492740,1),(321679488,424798932,15870879,621592,1,'2008-12-26 01:05:32',3310492740,1),(321679489,424799992,15872275,621592,1,'2008-12-26 01:05:32',3310492740,1),(321679490,424799295,15873647,621592,1,'2008-12-26 01:05:32',3310492740,1),(321679491,424798013,15875902,621592,1,'2008-12-26 01:05:33',3310492742,1),(321679492,424797306,15877714,621592,1,'2008-12-26 01:05:33',3310492742,1),(321679493,424796776,15880720,621592,1,'2008-12-26 01:05:33',3310492742,1),(321679494,424796687,15883151,621592,1,'2008-12-26 01:05:33',3310492742,1),(321679495,424797395,15885759,621592,1,'2008-12-26 01:05:33',3310492742,1),(321679496,424798544,15889207,621592,1,'2008-12-26 01:05:34',3310492742,1),(321679497,424799340,15892301,621592,1,'2008-12-26 01:05:34',3310492742,1),(321679498,424800312,15896766,621592,1,'2008-12-26 01:05:34',3310492742,1),(321679499,424801594,15900700,621592,1,'2008-12-26 01:05:34',3310492742,1),(321679500,424803097,15905076,621592,1,'2008-12-26 01:05:34',3310492742,1),(321679501,424803495,15908966,621592,1,'2008-12-26 01:05:35',3310492742,1),(321679502,424803716,15912458,621592,1,'2008-12-26 01:05:35',3310492742,1),(321679503,424803716,15915111,621592,1,'2008-12-26 01:05:35',3310492742,1),(321679505,424803495,15919001,621592,1,'2008-12-26 01:05:35',3310492742,1),(321679507,424803318,15922095,621592,1,'2008-12-26 01:05:35',3310492742,1),(321679508,424802920,15924747,621592,1,'2008-12-26 01:05:36',3310492742,1),(321679509,424801373,15934472,621592,1,'2008-12-26 01:05:36',3310492748,1),(321679510,424800445,15939998,621592,1,'2008-12-26 01:05:36',3310492748,1),(321679511,424799163,15944374,621592,1,'2008-12-26 01:05:36',3310492748,1),(321679512,424798146,15947777,621592,1,'2008-12-26 01:05:36',3310492748,1),(321679513,424795538,15955955,621592,1,'2008-12-26 01:05:37',3310492748,1),(321679514,424793460,15962763,621592,1,'2008-12-26 01:05:37',3310492748,1),(321679515,424790145,15972222,621592,1,'2008-12-26 01:05:37',3310492745,1),(321679516,424788819,15977085,621592,1,'2008-12-26 01:05:37',3310492745,1),(321679517,424788333,15983981,621592,1,'2008-12-26 01:05:37',3310492745,1),(321679518,424802143,15869086,621592,1,'2008-12-26 01:05:37',3310492740,1),(321679519,424803329,15866714,621592,1,'2008-12-26 01:05:38',3310492740,1),(321679520,424803482,15863958,621592,1,'2008-12-26 01:05:38',3310492740,1),(321679521,424802717,15860591,621592,1,'2008-12-26 01:05:38',3310492740,1),(321679522,424801033,15854583,621592,1,'2008-12-26 01:05:38',3310492740,1),(321679523,424799617,15848078,621592,1,'2008-12-26 01:05:38',3310492740,1),(321679524,424799656,15846203,621592,1,'2008-12-26 01:05:38',3310492740,1),(321679525,424800727,15844405,621592,1,'2008-12-26 01:05:39',3310492740,1),(321679526,424801416,15843524,621592,1,'2008-12-26 01:05:39',3310492740,1),(321679527,424802066,15841879,621592,1,'2008-12-26 01:05:39',3310492740,1),(321679528,424804247,15840234,621592,1,'2008-12-26 01:05:39',3310492740,1),(321679529,424806696,15837478,621592,1,'2008-12-26 01:05:39',3310492740,1),(321679530,424807462,15835756,621592,1,'2008-12-26 01:05:39',3310492740,1),(321679536,424807883,15832695,621592,1,'2008-12-26 01:05:40',3310492740,1),(321679543,424807309,15828065,621592,1,'2008-12-26 01:05:40',3310492740,1),(321679544,424806122,15826726,621592,1,'2008-12-26 01:05:40',3310492740,1),(321679545,424804401,15818728,621592,1,'2008-12-26 01:05:40',3310491374,1),(321679546,424802640,15813983,621592,1,'2008-12-26 01:05:40',3310491374,1),(321679549,424802640,15812835,621592,1,'2008-12-26 01:05:41',3310491374,1),(321679550,424802028,15811993,621592,1,'2008-12-26 01:05:41',3310491374,1),(321679551,424801492,15811764,621592,1,'2008-12-26 01:05:41',3310491374,1),(321679552,424801071,15809544,621592,1,'2008-12-26 01:05:41',3310491374,1),(321679553,424800727,15808396,621592,1,'2008-12-26 01:05:41',3310491374,1),(321679554,424801186,15806980,621592,1,'2008-12-26 01:05:41',3310491374,1),(321679555,424801263,15804761,621592,1,'2008-12-26 01:05:42',3310491374,1),(321679556,424800536,15803957,621592,1,'2008-12-26 01:05:42',3310491374,1),(321679557,424797819,15801240,621592,1,'2008-12-26 01:05:42',3310491374,1),(321679558,424796326,15798026,621592,1,'2008-12-26 01:05:42',3310491374,1),(321679559,424795178,15794620,621592,1,'2008-12-26 01:05:42',3310491374,1),(321679560,424793992,15792324,621592,1,'2008-12-26 01:05:42',3310491374,1),(321679561,424793839,15789416,621592,1,'2008-12-26 01:05:43',3310491374,1),(321679562,424794298,15786661,621592,1,'2008-12-26 01:05:43',3310491374,1),(321679563,424795370,15784403,621592,1,'2008-12-26 01:05:43',3310491374,1),(321679564,424795944,15782949,621592,1,'2008-12-26 01:05:43',3310491374,1),(321679565,424797781,15778128,621592,1,'2008-12-26 01:05:43',3310491374,1),(321679566,424800344,15772464,621592,1,'2008-12-26 01:05:43',3310491374,1),(321679567,424803214,15768217,621592,1,'2008-12-26 01:05:44',3310491374,1),(321679568,424805510,15764582,621592,1,'2008-12-26 01:05:44',3310491372,1),(321679569,424806505,15760832,621592,1,'2008-12-26 01:05:44',3310491372,1),(321679570,424806696,15759569,621592,1,'2008-12-26 01:05:44',3310491372,1),(321679571,424806161,15758306,621592,1,'2008-12-26 01:05:44',3310491372,1),(321679572,424805051,15758765,621592,1,'2008-12-26 01:05:44',3310491372,1),(321679573,424804171,15758765,621592,1,'2008-12-26 01:05:45',3310491372,1),(321679574,424803444,15757962,621592,1,'2008-12-26 01:05:45',3310491372,1),(321679575,424803712,15755015,621592,1,'2008-12-26 01:05:45',3310491372,1),(321679576,424803482,15754020,621592,1,'2008-12-26 01:05:45',3310491372,1),(321679577,424803980,15752643,621592,1,'2008-12-26 01:05:45',3310491372,1),(321679578,424805089,15748625,621592,1,'2008-12-26 01:05:45',3310491372,1),(321679579,424805166,15747209,621592,1,'2008-12-26 01:05:46',3310491372,1),(321679580,424804515,15744836,621592,1,'2008-12-26 01:05:46',3310491372,1),(321679581,424804133,15742464,621592,1,'2008-12-26 01:05:46',3310491372,1),(321679582,424802793,15741354,621592,1,'2008-12-26 01:05:46',3310491372,1),(321679583,424801837,15739709,621592,1,'2008-12-26 01:05:46',3310491372,1),(321679584,424802066,15737719,621592,1,'2008-12-26 01:05:47',3310491372,1),(321679586,424802870,15736647,621592,1,'2008-12-26 01:05:47',3310491372,1),(321679587,424802946,15735270,621592,1,'2008-12-26 01:05:47',3310491372,1),(321679588,424802411,15731864,621592,1,'2008-12-26 01:05:47',3310491372,1),(321679589,424801798,15730448,621592,1,'2008-12-26 01:05:47',3310491372,1),(321679590,424800689,15729032,621592,1,'2008-12-26 01:05:47',3310491372,1),(321679591,424800995,15726354,621592,1,'2008-12-26 01:05:48',3310491372,1),(321679592,424800650,15724326,621592,1,'2008-12-26 01:05:48',3310491372,1),(321679593,424799502,15720193,621592,1,'2008-12-26 01:05:48',3310491372,1),(321679594,424799273,15718356,621592,1,'2008-12-26 01:05:48',3310491372,1),(321679595,424798163,15717247,621592,1,'2008-12-26 01:05:48',3310491372,1),(321679596,424797207,15715333,621592,1,'2008-12-26 01:05:48',3310491372,1),(321679597,424797168,15713305,621592,1,'2008-12-26 01:05:49',3310491372,1),(321679598,424798010,15709134,621592,1,'2008-12-26 01:05:49',3310491366,1),(321679599,424797436,15708331,621592,1,'2008-12-26 01:05:49',3310491366,1),(321679600,424797513,15705767,621592,1,'2008-12-26 01:05:49',3310491366,1),(321679601,424798354,15704198,621592,1,'2008-12-26 01:05:49',3310491366,1),(321679602,424798201,15702935,621592,1,'2008-12-26 01:05:50',3310491366,1),(321679603,424799196,15700830,621592,1,'2008-12-26 01:05:50',3310491366,1),(321679604,424798661,15699836,621592,1,'2008-12-26 01:05:50',3310491366,1),(321679605,424797474,15697884,621592,1,'2008-12-26 01:05:50',3310491366,1),(321679606,424797819,15696085,621592,1,'2008-12-26 01:05:50',3310491366,1),(321679607,424798546,15694937,621592,1,'2008-12-26 01:05:51',3310491366,1),(321679608,424800038,15692909,621592,1,'2008-12-26 01:05:51',3310491366,1),(321679609,424801148,15690499,621592,1,'2008-12-26 01:05:51',3310491366,1),(321679610,424801033,15689351,621592,1,'2008-12-26 01:05:51',3310491366,1),(321679611,424800038,15688317,621592,1,'2008-12-26 01:05:52',3310491366,1),(321679612,424799809,15687208,621592,1,'2008-12-26 01:05:52',3310491366,1),(321679613,424800765,15685945,621592,1,'2008-12-26 01:05:52',3310491366,1),(321679614,424802066,15685754,621592,1,'2008-12-26 01:05:52',3310491366,1),(321679615,424803138,15684606,621592,1,'2008-12-26 01:05:52',3310491366,1),(321679616,424803980,15682348,621592,1,'2008-12-26 01:05:53',3310491366,1),(321679617,424805357,15680741,621592,1,'2008-12-26 01:05:53',3310491366,1),(321679618,424806735,15678789,621592,1,'2008-12-26 01:05:53',3310491366,1),(321679619,424811327,15676914,621592,1,'2008-12-26 01:05:53',3310491366,1),(321679620,424813049,15675192,621592,1,'2008-12-26 01:05:53',3310491366,1),(321679621,424815459,15673623,621592,1,'2008-12-26 01:05:54',3310491366,1),(321679622,424816990,15670524,621592,1,'2008-12-26 01:05:54',3310491366,1),(321679623,424819477,15668266,621592,1,'2008-12-26 01:05:54',3310491366,1),(321679624,424820702,15668228,621592,1,'2008-12-26 01:05:54',3310491367,1),(321679626,424822079,15667309,621592,1,'2008-12-26 01:05:54',3310491367,1),(321679627,424825102,15666314,621592,1,'2008-12-26 01:05:54',3310491367,1),(321679628,424826442,15666161,621592,1,'2008-12-26 01:05:55',3310491367,1),(321679629,424827322,15664975,621592,1,'2008-12-26 01:05:55',3310491367,1),(321679630,424827437,15663865,621592,1,'2008-12-26 01:05:55',3310491367,1),(321679631,424828546,15663177,621592,1,'2008-12-26 01:05:55',3310491367,1),(321679632,424830421,15661952,621592,1,'2008-12-26 01:05:55',3310491367,1),(321679633,424831837,15661608,621592,1,'2008-12-26 01:05:55',3310491367,1),(321679634,424835434,15660115,621592,1,'2008-12-26 01:05:56',3310491367,1),(321679635,424835817,15658929,621592,1,'2008-12-26 01:05:56',3310491367,1),(321679636,424838419,15656136,621592,1,'2008-12-26 01:05:56',3310491367,1),(321679637,424840447,15652539,621592,1,'2008-12-26 01:05:56',3310491365,1),(321679638,424842322,15648865,621592,1,'2008-12-26 01:05:56',3310491365,1),(321679639,424845460,15647220,621592,1,'2008-12-26 01:05:56',3310491365,1),(321679640,424847986,15645498,621592,1,'2008-12-26 01:05:57',3310491376,1),(321679641,424852386,15644618,621592,1,'2008-12-26 01:05:57',3310491376,1),(321679642,424854414,15644082,621592,1,'2008-12-26 01:05:57',3310491376,1),(321679643,424858279,15642283,621592,1,'2008-12-26 01:05:57',3310491376,1),(321679644,424859733,15642054,621592,1,'2008-12-26 01:05:57',3310491376,1),(321679645,424861953,15640179,621592,1,'2008-12-26 01:05:57',3310491376,1),(321679646,424863407,15638954,621592,1,'2008-12-26 01:05:58',3310491376,1),(321679647,424864096,15636544,621592,1,'2008-12-26 01:05:58',3310491376,1),(321679648,424866698,15635357,621592,1,'2008-12-26 01:05:58',3310491376,1),(321679649,424869070,15634401,621592,1,'2008-12-26 01:05:58',3310491376,1),(321679650,424870256,15632908,621592,1,'2008-12-26 01:05:58',3310491376,1),(321679651,424872399,15631531,621592,1,'2008-12-26 01:05:58',3310491376,1),(321679652,424873585,15632487,621592,1,'2008-12-26 01:05:59',3310491376,1),(321679653,424877412,15630153,621592,1,'2008-12-26 01:05:59',3310491377,1),(321679654,424879172,15627781,621592,1,'2008-12-26 01:05:59',3310491377,1),(321679655,424881889,15626824,621592,1,'2008-12-26 01:05:59',3310491377,1),(321679656,424882846,15626862,621592,1,'2008-12-26 01:05:59',3310491377,1),(321679657,424883114,15626212,621592,1,'2008-12-26 01:05:59',3310491377,1),(321679658,424884415,15626135,621592,1,'2008-12-26 01:06:00',3310491377,1),(321679659,424887591,15627015,621592,1,'2008-12-26 01:06:00',3310491377,1),(321679660,424889887,15626556,621592,1,'2008-12-26 01:06:00',3310491377,1),(321679661,424896162,15623533,621592,1,'2008-12-26 01:06:00',3310491377,1),(321679662,424896507,15622117,621592,1,'2008-12-26 01:06:00',3310491377,1),(321679663,424898114,15621811,621592,1,'2008-12-26 01:06:00',3310491377,1),(321679664,424899568,15620548,621592,1,'2008-12-26 01:06:01',3310491377,1),(321679665,424901443,15622500,621592,1,'2008-12-26 01:06:01',3310491377,1),(321679666,424902897,15622691,621592,1,'2008-12-26 01:06:01',3310491380,1),(321679667,424906533,15622041,621592,1,'2008-12-26 01:06:01',3310491380,1),(321679668,424907489,15621237,621592,1,'2008-12-26 01:06:01',3310491380,1),(321679669,424908446,15621428,621592,1,'2008-12-26 01:06:01',3310491380,1),(321679670,424911239,15621084,621592,1,'2008-12-26 01:06:02',3310491380,1),(321679671,424916290,15620510,621592,1,'2008-12-26 01:06:02',3310491380,1),(321679672,424917438,15619783,621592,1,'2008-12-26 01:06:02',3310491380,1),(321679673,424919658,15619668,621592,1,'2008-12-26 01:06:02',3310491380,1),(321679674,424923714,15620013,621592,1,'2008-12-26 01:06:02',3310491380,1),(321679675,424927043,15617143,621592,1,'2008-12-26 01:06:02',3310491380,1),(321679676,424928803,15615497,621592,1,'2008-12-26 01:06:03',3310491380,1),(321679677,424933701,15615995,621592,1,'2008-12-26 01:06:03',3310491381,1),(321679678,424936533,15614694,621592,1,'2008-12-26 01:06:03',3310491381,1),(321679679,424937949,15614732,621592,1,'2008-12-26 01:06:03',3310491381,1),(321679681,424942579,15613201,621592,1,'2008-12-26 01:06:03',3310491381,1),(321679682,424944378,15612130,621592,1,'2008-12-26 01:06:03',3310491381,1),(321679683,424945908,15612168,621592,1,'2008-12-26 01:06:04',3310491381,1),(321679684,424947439,15611250,621592,1,'2008-12-26 01:06:04',3310491381,1),(321679685,424950309,15609681,621592,1,'2008-12-26 01:06:04',3310491381,1),(321679686,424955628,15610676,621592,1,'2008-12-26 01:06:04',3310491381,1),(321679687,424960411,15610293,621592,1,'2008-12-26 01:06:04',3310491552,1),(321679688,424963855,15610217,621592,1,'2008-12-26 01:06:04',3310491552,1),(321679689,424966228,15609375,621592,1,'2008-12-26 01:06:05',3310491552,1),(321679690,424972848,15610752,621592,1,'2008-12-26 01:06:05',3310491552,1),(321679691,424973881,15610140,621592,1,'2008-12-26 01:06:05',3310491552,1),(321679692,424974455,15608112,621592,1,'2008-12-26 01:06:05',3310491552,1),(321679693,424974723,15604974,621592,1,'2008-12-26 01:06:05',3310491552,1),(321679694,424975832,15602793,621592,1,'2008-12-26 01:06:05',3310491552,1),(321679695,424976980,15602563,621592,1,'2008-12-26 01:06:06',3310491552,1),(321679696,424978664,15603214,621592,1,'2008-12-26 01:06:06',3310491552,1),(321679697,424978626,15600803,621592,1,'2008-12-26 01:06:06',3310491530,1),(321679698,424978779,15598431,621592,1,'2008-12-26 01:06:06',3310491530,1),(321679699,424979927,15596135,621592,1,'2008-12-26 01:06:06',3310491530,1),(321679700,424980080,15594719,621592,1,'2008-12-26 01:06:06',3310491530,1),(321679701,424981687,15592805,621592,1,'2008-12-26 01:06:07',3310491530,1),(321679702,424981725,15590089,621592,1,'2008-12-26 01:06:07',3310491530,1),(321679703,424982682,15588558,621592,1,'2008-12-26 01:06:07',3310491530,1),(321679704,424983179,15586874,621592,1,'2008-12-26 01:06:07',3310491530,1),(321679710,424982491,15585918,621592,1,'2008-12-26 01:06:07',3310491530,1),(321679711,424982873,15584770,621592,1,'2008-12-26 01:06:07',3310491530,1),(321679712,424983600,15584043,621592,1,'2008-12-26 01:06:08',3310491530,1),(321679713,424983141,15582895,621592,1,'2008-12-26 01:06:08',3310491530,1),(321679714,424982337,15582588,621592,1,'2008-12-26 01:06:08',3310491530,1),(321679715,424982070,15580943,621592,1,'2008-12-26 01:06:08',3310491530,1),(321679716,424983179,15579412,621592,1,'2008-12-26 01:06:08',3310491530,1),(321679717,424984710,15577499,621592,1,'2008-12-26 01:06:08',3310491530,1),(321679718,424985858,15576045,621592,1,'2008-12-26 01:06:09',3310491531,1),(321679719,424987465,15572678,621592,1,'2008-12-26 01:06:09',3310491531,1),(321679720,424987924,15570917,621592,1,'2008-12-26 01:06:09',3310491531,1),(321679721,424990105,15568927,621592,1,'2008-12-26 01:06:09',3310491531,1),(321679722,424990909,15565981,621592,1,'2008-12-26 01:06:09',3310491531,1),(321679723,424992142,15564242,621592,1,'2008-12-26 01:06:09',3310491531,1),(321679724,424995547,15563391,621592,1,'2008-12-26 01:06:10',3310491531,1),(321679725,424996667,15563301,621592,1,'2008-12-26 01:06:10',3310491531,1),(321679726,424997205,15562809,621592,1,'2008-12-26 01:06:10',3310491531,1),(321679727,424997742,15561554,621592,1,'2008-12-26 01:06:10',3310491531,1),(321679728,424998773,15560658,621592,1,'2008-12-26 01:06:10',3310491531,1),(321679729,425001103,15557835,621592,1,'2008-12-26 01:06:10',3310491531,1),(321679731,425001775,15556132,621592,1,'2008-12-26 01:06:11',3310491531,1),(321679732,425003657,15554475,621592,1,'2008-12-26 01:06:11',3310491531,1),(321679733,425005449,15553086,621592,1,'2008-12-26 01:06:11',3310491531,1),(321679734,425004822,15550845,621592,1,'2008-12-26 01:06:11',3310491531,1),(321679735,425005807,15549232,621592,1,'2008-12-26 01:06:11',3310491531,1),(321679738,425007196,15547888,621592,1,'2008-12-26 01:06:11',3310491531,1),(321679745,425007376,15546365,621592,1,'2008-12-26 01:06:12',3310491531,1),(321679746,425008630,15544348,621592,1,'2008-12-26 01:06:12',3310491529,1),(321679747,425008137,15542198,621592,1,'2008-12-26 01:06:12',3310491529,1),(321679748,425007107,15540271,621592,1,'2008-12-26 01:06:12',3310491529,1),(321679749,425007376,15537672,621592,1,'2008-12-26 01:06:12',3310491529,1),(321679750,425008765,15536239,621592,1,'2008-12-26 01:06:12',3310491529,1),(321679751,425011946,15534088,621592,1,'2008-12-26 01:06:13',3310491529,1),(321679752,425014276,15532027,621592,1,'2008-12-26 01:06:13',3310491532,1),(321679753,425018712,15528487,621592,1,'2008-12-26 01:06:13',3310491532,1),(321679754,425023551,15524634,621592,1,'2008-12-26 01:06:13',3310491532,1),(321679755,425026732,15522035,621592,1,'2008-12-26 01:06:13',3310491532,1),(321679756,425027628,15520915,621592,1,'2008-12-26 01:06:13',3310491532,1),(321679757,425028658,15518047,621592,1,'2008-12-26 01:06:14',3310491532,1),(321679759,425029734,15516210,621592,1,'2008-12-26 01:06:14',3310491532,1),(321679761,425031795,15514956,621592,1,'2008-12-26 01:06:14',3310491532,1),(321679762,425032781,15514597,621592,1,'2008-12-26 01:06:14',3310491532,1),(321679764,425032557,15515897,621592,1,'2008-12-26 01:06:14',3310491532,1),(321679766,425034304,15515897,621592,1,'2008-12-26 01:06:14',3310491532,1),(321679767,425035783,15515897,621592,1,'2008-12-26 01:06:15',3310491532,1),(321679769,425037351,15514956,621592,1,'2008-12-26 01:06:15',3310491532,1),(321679771,425038471,15513836,621592,1,'2008-12-26 01:06:15',3310491532,1),(321679773,425039457,15513656,621592,1,'2008-12-26 01:06:15',3310491532,1),(321679774,425040308,15512850,621592,1,'2008-12-26 01:06:15',3310491533,1),(321679776,425043086,15510072,621592,1,'2008-12-26 01:06:15',3310491533,1),(321679779,424782021,15983952,621592,1,'2008-12-26 01:06:16',3310492745,1),(321681942,425313605,15056438,181856,1,'2009-04-04 22:25:04',3310491480,8),(321681943,425315488,15053537,181856,1,'2009-04-04 22:25:04',3310491481,7),(321681944,425315603,15051476,181856,1,'2009-04-04 22:25:04',3310491475,7),(321681945,425314000,15049187,181856,1,'2009-04-04 22:25:04',3310491474,7),(321681946,425312912,15046840,181856,1,'2009-04-04 22:25:03',3310491474,7),(321681947,425312340,15044092,181856,1,'2009-04-04 22:25:03',3310491474,7),(321681949,425311252,15041574,181856,1,'2009-04-04 22:25:03',3310491474,7),(321681950,425309363,15037968,181856,1,'2009-04-04 22:25:03',3310491474,7),(321681951,425308734,15034762,181856,1,'2009-04-04 22:25:03',3310491474,7),(321681953,425308963,15031042,181856,1,'2009-04-04 22:25:03',3310491474,7),(321681957,425310222,15028065,181856,1,'2009-04-04 22:25:03',3310491474,7),(321681958,425312397,15024173,181856,1,'2009-04-04 22:25:02',3310491474,7),(321681961,425314057,15022284,181856,1,'2009-04-04 22:25:02',3310491474,7),(321681962,425314172,15020452,181856,1,'2009-04-04 22:25:02',3310491474,7),(321681963,425313256,15018906,181856,1,'2009-04-04 22:25:02',3310491474,7),(321681964,425310966,15016903,181856,1,'2009-04-04 22:25:02',3310491474,7),(321681965,425309020,15015186,181856,1,'2009-04-04 22:25:02',3310491474,7),(321681966,425307131,15011637,181856,1,'2009-04-04 22:25:02',3310491474,7),(321681967,425306902,15009176,181856,1,'2009-04-04 22:25:02',3310491474,7),(321681968,425306616,15005798,181856,1,'2009-04-04 22:25:01',3310491474,7),(321681969,425306959,14997269,181856,1,'2009-04-04 22:25:01',3310491474,7),(321681970,425306902,14995037,181856,1,'2009-04-04 22:25:01',3310491472,7),(321681971,425307074,14993320,181856,1,'2009-04-04 22:25:01',3310491472,7),(321681972,425307532,14992061,181856,1,'2009-04-04 22:25:01',3310491472,7),(321681974,425307990,14990858,181856,1,'2009-04-04 22:25:01',3310491472,7),(321681975,425307589,14989885,181856,1,'2009-04-04 22:25:01',3310491472,7),(321681976,425306616,14989485,181856,1,'2009-04-04 22:25:00',3310491472,7),(321681977,425305643,14989485,181856,1,'2009-04-04 22:25:00',3310491472,7),(321681978,425304612,14989141,181856,1,'2009-04-04 22:25:00',3310491472,7),(321681979,425303754,14988225,181856,1,'2009-04-04 22:25:00',3310491472,7),(321681980,425303582,14987023,181856,1,'2009-04-04 22:25:00',3310491472,7),(321681981,425302781,14985478,181856,1,'2009-04-04 22:24:59',3310491472,7),(321681982,425301178,14983818,181856,1,'2009-04-04 22:24:59',3310491472,7),(321681986,425299346,14982444,181856,1,'2009-04-04 22:24:59',3310491472,7),(321681987,425297744,14981929,181856,1,'2009-04-04 22:24:59',3310491472,7),(321681988,425296484,14981528,181856,1,'2009-04-04 22:24:59',3310491472,7),(321681989,425295397,14980097,181856,1,'2009-04-04 22:24:59',3310491472,7),(321681990,425293565,14976892,181856,1,'2009-04-04 22:24:58',3310491472,7),(321681991,425292592,14974201,181856,1,'2009-04-04 22:24:58',3310491472,7),(321681992,425292306,14969794,181856,1,'2009-04-04 22:24:57',3310491472,7),(321681993,425291561,14966703,181856,1,'2009-04-04 22:24:57',3310491472,7),(321681994,425290646,14963039,181856,1,'2009-04-04 22:24:57',3310491472,7),(321681995,425290417,14958975,181856,1,'2009-04-04 22:24:57',3310491472,7),(321681996,425290188,14956457,181856,1,'2009-04-04 22:24:57',3310491472,7),(321681997,425288986,14953366,181856,1,'2009-04-04 22:24:57',3310491472,7),(321681998,425288470,14952106,181856,1,'2009-04-04 22:24:57',3310491472,7),(321681999,425288470,14949244,181856,1,'2009-04-04 22:24:57',3310491472,7),(321682000,425286639,14947184,181856,1,'2009-04-04 22:24:57',3310491461,7),(321682002,425283605,14944207,181856,1,'2009-04-04 22:24:57',3310491461,8),(321682003,425283319,14942948,181856,1,'2009-04-04 22:12:29',3310491461,4),(321682005,425283137,14940490,181856,1,'2009-04-04 22:12:28',3310491119,4),(321682007,425283079,14939289,181856,1,'2009-04-04 22:12:28',3310491119,4),(321682009,425283343,14938322,181856,1,'2009-04-04 22:12:28',3310491119,4),(321682012,425284339,14937823,181856,1,'2009-04-04 22:12:27',3310491119,4),(321682016,425284984,14938439,181856,1,'2009-04-04 22:12:27',3310491119,4);
INSERT INTO `nodes` VALUES (321682018,425285394,14939406,181856,1,'2009-04-04 22:12:27',3310491119,4),(321682021,425285746,14940227,181856,1,'2009-04-04 22:12:26',3310491119,4),(321682024,425288325,14941575,181856,1,'2009-04-04 22:12:26',3310491130,4),(321682028,425290845,14942483,181856,1,'2009-04-04 22:12:26',3310491472,4),(321682035,425293161,14943069,181856,1,'2009-04-04 22:12:26',3310491472,4),(321682038,425294216,14943802,181856,1,'2009-04-04 22:12:25',3310491472,4),(321682039,425296941,14943978,181856,1,'2009-04-04 22:12:25',3310491472,4),(321682040,425297439,14945004,181856,1,'2009-04-04 22:12:24',3310491472,4),(321682041,425297762,14946586,181856,1,'2009-04-04 22:12:24',3310491472,4),(321682042,425298201,14947846,181856,1,'2009-04-04 22:12:24',3310491472,4),(321682043,425298465,14948696,181856,1,'2009-04-04 22:12:23',3310491472,4),(321682044,425299462,14949107,181856,1,'2009-04-04 22:12:23',3310491472,4),(321682045,425300077,14948696,181856,1,'2009-04-04 22:12:22',3310491472,4),(321682046,425300048,14947495,181856,1,'2009-04-04 22:12:22',3310491472,4),(321682047,425299901,14945941,181856,1,'2009-04-04 22:12:22',3310491472,4),(321682048,425299872,14944711,181856,1,'2009-04-04 22:12:21',3310491472,4),(321682049,425299872,14943538,181856,1,'2009-04-04 22:12:21',3310491472,4),(321682050,425298729,14940666,181856,1,'2009-04-04 22:12:21',3310491130,4),(321682051,425296912,14938439,181856,1,'2009-04-04 22:12:20',3310491130,4),(321682052,425295476,14935860,181856,1,'2009-04-04 22:12:20',3310491130,4),(321682053,425293542,14933310,181856,1,'2009-04-04 22:12:19',3310491130,4),(321682054,425292868,14930702,181856,1,'2009-04-04 22:12:19',3310491130,4),(321682055,425292457,14927888,181856,1,'2009-04-04 22:12:19',3310491130,4),(321682059,425291519,14922232,181856,1,'2009-04-04 22:12:18',3310491130,4),(321682061,425291578,14920210,181856,1,'2009-04-04 22:12:18',3310491130,4),(321682062,425291812,14918598,181856,1,'2009-04-04 22:12:18',3310491130,4),(321682063,425292106,14916576,181856,1,'2009-04-04 22:12:17',3310491130,4),(321682064,425291812,14915579,181856,1,'2009-04-04 22:12:17',3310491130,4),(321682065,425291050,14914876,181856,1,'2009-04-04 22:12:17',3310491130,4),(321682066,425289526,14914231,181856,1,'2009-04-04 22:12:16',3310491130,4),(321682067,425287973,14914231,181856,1,'2009-04-04 22:12:16',3310491130,4),(321682068,425286772,14913528,181856,1,'2009-04-04 22:12:15',3310491119,4),(321682069,425285160,14911388,181856,1,'2009-04-04 22:12:15',3310491119,4),(321682070,425282522,14906670,181856,1,'2009-04-04 22:12:14',3310491119,4),(321682071,425281789,14904413,181856,1,'2009-04-04 22:12:14',3310491119,4),(321682072,425281233,14902948,181856,1,'2009-04-04 22:12:13',3310491119,4),(321682073,425280119,14900925,181856,1,'2009-04-04 22:12:13',3310491119,4),(321682074,425279181,14900398,181856,1,'2009-04-04 22:12:13',3310491119,4),(321682075,425278155,14899988,181856,1,'2009-04-04 22:12:12',3310491119,4),(321682076,425277012,14898962,181856,1,'2009-04-04 22:12:12',3310491119,4),(321682077,425275547,14895826,181856,1,'2009-04-04 22:12:11',3310491119,4),(321682078,425273876,14893569,181856,1,'2009-04-04 22:12:11',3310491119,4),(321682079,425271532,14890551,181856,1,'2009-04-04 22:12:11',3310491119,4),(321682080,425270447,14888411,181856,1,'2009-04-04 22:12:10',3310491119,4),(321682081,425269949,14885334,181856,1,'2009-04-04 22:12:10',3310491117,4),(321682082,425269803,14883019,181856,1,'2009-04-04 22:12:09',3310491117,4),(321682083,425270184,14881964,181856,1,'2009-04-04 22:12:09',3310491117,4),(321682084,425270858,14881290,181856,1,'2009-04-04 22:12:08',3310491117,4),(321682085,425271883,14881290,181856,1,'2009-04-04 22:12:08',3310491117,4),(321682086,425273876,14882139,181856,1,'2009-04-04 22:12:08',3310491117,4),(321682087,425277247,14883312,181856,1,'2009-04-04 22:12:07',3310491117,4),(321682088,425280295,14884279,181856,1,'2009-04-04 22:12:07',3310491117,4),(321682089,425282288,14884924,181856,1,'2009-04-04 22:12:06',3310491117,4),(321682090,425283225,14884338,181856,1,'2009-04-04 22:12:06',3310491117,4),(321682091,425283401,14882784,181856,1,'2009-04-04 22:12:06',3310491117,4),(321682092,425283079,14880440,181856,1,'2009-04-04 22:12:05',3310491117,4),(321682093,425282170,14877743,181856,1,'2009-04-04 22:12:05',3310491117,4),(321682094,425280383,14873816,181856,1,'2009-04-04 22:12:04',3310491117,4),(321682095,425278360,14869918,181856,1,'2009-04-04 22:12:04',3310491117,4),(321682096,425276690,14868219,181856,1,'2009-04-04 22:12:03',3310491117,4),(321682097,425274228,14867163,181856,1,'2009-04-04 22:12:03',3310491117,4),(321682098,425272733,14866489,181856,1,'2009-04-04 22:12:02',3310491117,4),(321682099,425272030,14864819,181856,1,'2009-04-04 22:12:02',3310491117,4),(321682100,425271239,14861947,181856,1,'2009-04-04 22:12:02',3310491117,4),(321682101,425270389,14858342,181856,1,'2009-04-04 22:12:01',3310491117,4),(321682102,425269392,14855939,181856,1,'2009-04-04 22:12:01',3310491117,4),(321682103,425268396,14853477,181856,1,'2009-04-04 22:12:01',3310491117,4),(321682104,425268572,14852510,181856,1,'2009-04-04 22:12:00',3310491117,4),(321682105,425267077,14851074,181856,1,'2009-04-04 22:12:00',3310491117,4),(321682106,425265084,14848846,181856,1,'2009-04-04 22:11:59',3310491117,4),(321682107,425263912,14846941,181856,1,'2009-04-04 22:11:59',3310491117,4),(321682108,425263296,14843923,181856,1,'2009-04-04 22:11:59',3310491117,4),(321682109,425263355,14841842,181856,1,'2009-04-04 22:11:59',3310491117,4),(321682110,425263619,14840377,181856,1,'2009-04-04 22:11:58',3310491117,4),(321682111,425264352,14839322,181856,1,'2009-04-04 22:11:58',3310491117,4),(321682112,425264791,14838384,181856,1,'2009-04-04 22:11:58',3310491117,4),(321682113,425264791,14837182,181856,1,'2009-04-04 22:11:57',3310491117,4),(321682114,425263296,14835013,181856,1,'2009-04-04 22:11:57',3310491117,4),(321682115,425262974,14833548,181856,1,'2009-04-04 22:11:57',3310491117,4),(321682116,425262652,14830529,181856,1,'2009-04-04 22:11:57',3310491111,4),(321682117,425261567,14828068,181856,1,'2009-04-04 22:11:56',3310491111,4),(321682118,425260131,14825489,181856,1,'2009-04-04 22:11:56',3310491111,4),(321682119,425258812,14822528,181856,1,'2009-04-04 22:11:56',3310491110,4),(321682120,425256790,14819363,181856,1,'2009-04-04 22:11:55',3310491110,4),(321682121,425255120,14817605,181856,1,'2009-04-04 22:11:55',3310491110,4),(321682122,425250841,14813385,181856,1,'2009-04-04 22:11:54',3310491110,4),(321682123,425248760,14812124,181856,1,'2009-04-04 22:11:54',3310491110,4),(321682124,425247324,14812886,181856,1,'2009-04-04 22:11:54',3310491110,4),(321682125,425246240,14813531,181856,1,'2009-04-04 22:11:54',3310491110,4),(321682126,425245829,14812886,181856,1,'2009-04-04 22:11:53',3310491110,4),(321682127,425245888,14811978,181856,1,'2009-04-04 22:11:53',3310491110,4),(321682128,425246034,14808139,181856,1,'2009-04-04 22:11:53',3310491110,4),(321682129,425245712,14806497,181856,1,'2009-04-04 22:11:52',3310491110,4),(321682130,425244159,14804534,181856,1,'2009-04-04 22:11:52',3310491110,4),(321682131,425243338,14801574,181856,1,'2009-04-04 22:11:52',3310491110,4),(321682133,425242899,14799610,181856,1,'2009-04-04 22:11:51',3310491110,4),(321682134,425241990,14795331,181856,1,'2009-04-04 22:11:51',3310491110,4),(321682135,425240964,14792987,181856,1,'2009-04-04 22:11:51',3310491110,4),(321682136,425239645,14792313,181856,1,'2009-04-04 22:11:50',3310491110,4),(321682137,425238913,14790730,181856,1,'2009-04-04 22:11:50',3310491110,4),(321682138,425238209,14788679,181856,1,'2009-04-04 22:11:49',3310491110,4),(321682139,425237301,14786246,181856,1,'2009-04-04 22:11:49',3310491110,4),(321682140,425236685,14782231,181856,1,'2009-04-04 22:11:48',3310491110,4),(321682141,425236275,14778333,181856,1,'2009-04-04 22:11:48',3310491110,4),(321682142,425235308,14772267,181856,1,'2009-04-04 22:11:48',3310491108,4),(321682143,425234370,14768222,181856,1,'2009-04-04 22:11:47',3310491108,4),(321682146,425232876,14765790,181856,1,'2009-04-04 22:11:47',3310491108,4),(321682149,425232524,14762976,181856,1,'2009-04-04 22:11:46',3310491108,4),(321682150,425232143,14760309,181856,1,'2009-04-04 22:11:46',3310491105,4),(321682151,425231703,14758170,181856,1,'2009-04-04 22:11:46',3310491105,4),(321682152,425230531,14756060,181856,1,'2009-04-04 22:11:45',3310491105,4),(321682154,425229740,14755005,181856,1,'2009-04-04 22:11:45',3310491105,4),(321682155,425229681,14753627,181856,1,'2009-04-04 22:11:44',3310491105,4),(321682156,425229036,14752572,181856,1,'2009-04-04 22:11:44',3310491105,4),(321682157,425230033,14751400,181856,1,'2009-04-04 22:11:43',3310491105,4),(321682158,425229447,14750198,181856,1,'2009-04-04 22:11:43',3310491105,4),(321682159,425228802,14747766,181856,1,'2009-04-04 22:11:43',3310491105,4),(321682160,425227659,14745743,181856,1,'2009-04-04 22:11:42',3310491105,4),(321682161,425226076,14742813,181856,1,'2009-04-04 22:11:42',3310491105,4),(321682162,425225197,14741582,181856,1,'2009-04-04 22:11:42',3310491105,4),(321682163,425220420,14740263,181856,1,'2009-04-04 22:11:41',3310491105,4),(321682164,425216757,14740937,181856,1,'2009-04-04 22:11:41',3310491105,4),(321682165,425213679,14741172,181856,1,'2009-04-04 22:11:40',3310491105,4),(321682166,425212155,14739941,181856,1,'2009-04-04 22:11:40',3310491105,4),(321682167,425210368,14738006,181856,1,'2009-04-04 22:11:39',3310491105,4),(321682168,425208521,14737156,181856,1,'2009-04-04 22:11:39',3310491105,4),(321682169,425207114,14736219,181856,1,'2009-04-04 22:11:38',3310491105,4),(321682170,425205854,14733229,181856,1,'2009-04-04 22:11:38',3310491105,4),(321682172,425205151,14730826,181856,1,'2009-04-04 22:11:37',3310491105,4),(321682174,425203979,14730123,181856,1,'2009-04-04 22:11:36',3310491104,4),(321682178,425202455,14729771,181856,1,'2009-04-04 22:11:35',3310491104,4),(321682179,425201487,14728569,181856,1,'2009-04-04 22:11:35',3310491104,4),(321682180,425200813,14726928,181856,1,'2009-04-04 22:11:34',3310491104,4),(321682182,425200169,14726313,181856,1,'2009-04-04 22:11:34',3310491104,4),(321682184,425200550,14724466,181856,1,'2009-04-04 22:11:33',3310491104,4),(321682185,425199553,14722767,181856,1,'2009-04-04 22:11:33',3310491104,4),(321682186,425198234,14720217,181856,1,'2009-04-04 22:11:32',3310491082,4),(321682187,425197472,14718458,181856,1,'2009-04-04 22:11:32',3310491082,4),(321682188,425196036,14716407,181856,1,'2009-04-04 22:11:31',3310491082,4),(321682189,425195802,14714004,181856,1,'2009-04-04 22:11:31',3310491082,4),(321682190,425195421,14712333,181856,1,'2009-04-04 22:11:30',3310491082,4),(321682191,425195567,14709344,181856,1,'2009-04-04 22:11:28',3310491082,4),(321682192,425196593,14707029,181856,1,'2009-04-04 22:11:27',3310491082,4),(321682193,425197443,14705299,181856,1,'2009-04-04 22:11:27',3310491082,4),(321682194,425198293,14704772,181856,1,'2009-04-04 22:11:26',3310491082,4),(321682195,425199582,14704889,181856,1,'2009-04-04 22:11:26',3310491082,4),(321682196,425202689,14706120,181856,1,'2009-04-04 22:11:25',3310491082,4),(321682197,425205913,14707527,181856,1,'2009-04-04 22:11:23',3310491083,4),(321682198,425209547,14708084,181856,1,'2009-04-04 22:11:22',3310491083,4),(321682199,425210778,14708259,181856,1,'2009-04-04 22:11:22',3310491083,4),(321682200,425212038,14709402,181856,1,'2009-04-04 22:11:21',3310491083,4),(321682201,425213503,14710516,181856,1,'2009-04-04 22:11:20',3310491083,4),(321682202,425214441,14710340,181856,1,'2009-04-04 22:11:20',3310491083,4),(321682203,425215203,14709432,181856,1,'2009-04-04 22:11:19',3310491083,4),(321682204,425215614,14708142,181856,1,'2009-04-04 22:11:18',3310491083,4),(321682205,425215057,14706618,181856,1,'2009-04-04 22:11:18',3310491083,4),(321682206,425213972,14705153,181856,1,'2009-04-04 22:11:17',3310491083,4),(321682207,425213386,14704244,181856,1,'2009-04-04 22:11:17',3310491083,4),(321682208,425213240,14702457,181856,1,'2009-04-04 22:11:17',3310491083,4),(321682209,425212038,14701343,181856,1,'2009-04-04 22:11:16',3310491083,4),(321682210,425210309,14700434,181856,1,'2009-04-04 22:11:16',3310491083,4),(321682211,425209107,14699321,181856,1,'2009-04-04 22:11:15',3310491083,4),(321682212,425208609,14696683,181856,1,'2009-04-04 22:11:15',3310491083,4),(321682213,425207525,14694426,181856,1,'2009-04-04 22:11:15',3310491083,4),(321682214,425206001,14691672,181856,1,'2009-04-04 22:11:14',3310491083,4),(321682215,425205297,14689620,181856,1,'2009-04-04 22:11:14',3310491083,4),(321682216,425204213,14688536,181856,1,'2009-04-04 22:11:13',3310491082,4),(321682217,425204184,14687041,181856,1,'2009-04-04 22:11:13',3310491082,4),(321682218,425202103,14684931,181856,1,'2009-04-04 22:11:13',3310491082,4),(321682219,425197853,14681297,181856,1,'2009-04-04 22:11:13',3310491082,4),(321682220,425193487,14676520,181856,1,'2009-04-04 22:11:12',3310491082,4),(321682221,425188416,14671450,181856,1,'2009-04-04 22:11:12',3310491082,4),(321682222,425187508,14668724,181856,1,'2009-04-04 22:11:11',3310491082,4),(321682223,425185837,14666233,181856,1,'2009-04-04 22:11:11',3310491080,4),(321682224,425181764,14661807,181856,1,'2009-04-04 22:11:10',3310491080,4),(321682225,425178745,14658115,181856,1,'2009-04-04 22:11:10',3310491080,4),(321682226,425176723,14656151,181856,1,'2009-04-04 22:11:10',3310491037,4),(321682227,425174818,14655711,181856,1,'2009-04-04 22:11:09',3310491037,4),(321682228,425173411,14654979,181856,1,'2009-04-04 22:11:09',3310491037,4),(321682229,425172034,14655037,181856,1,'2009-04-04 22:11:08',3310491037,4),(321682230,425171184,14653894,181856,1,'2009-04-04 22:11:08',3310491037,4),(321682231,425169748,14651286,181856,1,'2009-04-04 22:11:07',3310491037,4),(321682232,425167989,14649791,181856,1,'2009-04-04 22:11:07',3310491037,4),(321682233,425166641,14649117,181856,1,'2009-04-04 22:11:06',3310491037,4),(321682234,425164590,14646480,181856,1,'2009-04-04 22:11:06',3310491037,4),(321682235,425163505,14644545,181856,1,'2009-04-04 22:11:05',3310491037,4),(321682236,425163300,14643197,181856,1,'2009-04-04 22:11:05',3310491037,4),(321682237,425164502,14643051,181856,1,'2009-04-04 22:11:04',3310491037,4),(321682640,425312528,15064852,181856,1,'2009-04-04 22:25:05',3310491480,7),(321683315,425458640,15081609,621592,1,'2008-12-26 01:49:44',3310502412,1),(321683317,425457736,15081724,621592,1,'2008-12-26 01:49:45',3310502412,1),(321683319,425456785,15081585,621592,1,'2008-12-26 01:49:45',3310502412,1),(321683321,425456089,15081446,621592,1,'2008-12-26 01:49:45',3310502412,1),(321683323,425454860,15080751,621592,1,'2008-12-26 01:49:45',3310502412,1),(321683326,425453747,15079893,621592,1,'2008-12-26 01:49:46',3310502412,1),(321683328,425452959,15078942,621592,1,'2008-12-26 01:49:46',3310502412,1),(321683330,425452541,15078107,621592,1,'2008-12-26 01:49:46',3310502412,1),(321683332,425451823,15077458,621592,1,'2008-12-26 01:49:46',3310502409,1),(321683334,425451034,15076716,621592,1,'2008-12-26 01:49:47',3310502409,1),(321683336,425450107,15075904,621592,1,'2008-12-26 01:49:47',3310502409,1),(321683338,425449434,15075000,621592,1,'2008-12-26 01:49:47',3310502409,1),(321683341,425447579,15073608,621592,1,'2008-12-26 01:49:47',3310502409,1),(321683343,425447393,15072959,621592,1,'2008-12-26 01:49:48',3310502409,1),(321683345,425447533,15071289,621592,1,'2008-12-26 01:49:48',3310502409,1),(321683347,425448020,15069110,621592,1,'2008-12-26 01:49:48',3310502409,1),(321683349,425448507,15067255,621592,1,'2008-12-26 01:49:48',3310502409,1),(321683351,425448738,15065121,621592,1,'2008-12-26 01:49:48',3310502409,1),(321683353,425448994,15063823,621592,1,'2008-12-26 01:49:48',3310502409,1),(321683355,425449272,15062060,621592,1,'2008-12-26 01:49:49',3310502409,1),(321683357,425449643,15060576,621592,1,'2008-12-26 01:49:49',3310502409,1),(321683358,425449434,15059463,621592,1,'2008-12-26 01:49:49',3310502409,1),(321683359,425448947,15057515,621592,1,'2008-12-26 01:49:49',3310502409,1),(321683360,425448483,15055312,621592,1,'2008-12-26 01:49:49',3310502409,1),(321683361,425447904,15052808,621592,1,'2008-12-26 01:49:50',3310502409,1),(321683362,425447533,15050976,621592,1,'2008-12-26 01:49:50',3310502403,1),(321683363,425447138,15048819,621592,1,'2008-12-26 01:49:50',3310502403,1),(321683364,425446767,15046918,621592,1,'2008-12-26 01:49:50',3310502403,1),(321683365,425446559,15047011,621592,1,'2008-12-26 01:49:51',3310502403,1),(321683366,425446489,15048309,621592,1,'2008-12-26 01:49:51',3310502403,1),(321683367,425446860,15050164,621592,1,'2008-12-26 01:49:51',3310502403,1),(321683368,425446837,15051672,621592,1,'2008-12-26 01:49:51',3310502409,1),(321683369,425446605,15052599,621592,1,'2008-12-26 01:49:51',3310502409,1),(321683370,425445886,15053643,621592,1,'2008-12-26 01:49:52',3310502409,1),(321683371,425445191,15054733,621592,1,'2008-12-26 01:49:52',3310502409,1),(321683372,425444773,15055869,621592,1,'2008-12-26 01:49:52',3310502409,1),(321683373,425444240,15057283,621592,1,'2008-12-26 01:49:52',3310502409,1),(321683374,425443985,15057631,621592,1,'2008-12-26 01:49:53',3310502409,1),(321683375,425443614,15057399,621592,1,'2008-12-26 01:49:53',3310502409,1),(321683376,425443359,15056704,621592,1,'2008-12-26 01:49:53',3310502409,1),(321683377,425442709,15053388,621592,1,'2008-12-26 01:49:53',3310502409,1),(321683378,425442431,15051857,621592,1,'2008-12-26 01:49:53',3310502409,1),(321683379,425442176,15051880,621592,1,'2008-12-26 01:49:54',3310502409,1),(321683380,425442176,15053318,621592,1,'2008-12-26 01:49:54',3310502409,1),(321683381,425442222,15054408,621592,1,'2008-12-26 01:49:54',3310502409,1),(321683382,425442083,15055336,621592,1,'2008-12-26 01:49:54',3310502409,1),(321683383,425441619,15056008,621592,1,'2008-12-26 01:49:54',3310502409,1),(321683384,425441295,15055938,621592,1,'2008-12-26 01:49:54',3310502409,1),(321683385,425441017,15055080,621592,1,'2008-12-26 01:49:55',3310502409,1),(321683386,425440993,15052808,621592,1,'2008-12-26 01:49:55',3310502409,1),(321683387,425440831,15051625,621592,1,'2008-12-26 01:49:55',3310502409,1),(321683388,425440506,15051602,621592,1,'2008-12-26 01:49:55',3310502409,1),(321683389,425440159,15052414,621592,1,'2008-12-26 01:49:56',3310502409,1),(321683390,425439532,15054107,621592,1,'2008-12-26 01:49:56',3310502409,1),(321683391,425438698,15055915,621592,1,'2008-12-26 01:49:56',3310502409,1),(321683392,425438234,15056936,621592,1,'2008-12-26 01:49:56',3310502409,1),(321683393,425437701,15056982,621592,1,'2008-12-26 01:49:56',3310502409,1),(321683394,425437144,15056773,621592,1,'2008-12-26 01:49:57',3310502409,1),(321683395,425437144,15056031,621592,1,'2008-12-26 01:49:57',3310502409,1),(321683396,425437214,15055057,621592,1,'2008-12-26 01:49:57',3310502409,1),(321683397,425437121,15054246,621592,1,'2008-12-26 01:49:57',3310502409,1),(321683398,425436773,15054269,621592,1,'2008-12-26 01:49:57',3310502409,1),(321683399,425436448,15054918,621592,1,'2008-12-26 01:49:57',3310502409,1),(321683400,425436100,15055521,621592,1,'2008-12-26 01:49:58',3310502409,1),(321683401,425435614,15055938,621592,1,'2008-12-26 01:49:58',3310502409,1),(321683402,425435196,15055637,621592,1,'2008-12-26 01:49:58',3310502409,1),(321683403,425435127,15054408,621592,1,'2008-12-26 01:49:58',3310502409,1),(321683405,425435103,15053457,621592,1,'2008-12-26 01:49:58',3310502409,1),(321683407,425435011,15052622,621592,1,'2008-12-26 01:49:59',3310502409,1),(321683408,425434524,15051301,621592,1,'2008-12-26 01:49:59',3310502403,1),(321683409,425434222,15050721,621592,1,'2008-12-26 01:49:59',3310502403,1),(321683410,425433874,15050744,621592,1,'2008-12-26 01:49:59',3310502403,1),(321683411,425433712,15051486,621592,1,'2008-12-26 01:49:59',3310502403,1),(321683412,425433457,15052205,621592,1,'2008-12-26 01:50:00',3310502409,1),(321683413,425433202,15052275,621592,1,'2008-12-26 01:50:00',3310502409,1),(321683414,425432808,15051904,621592,1,'2008-12-26 01:50:00',3310502409,1),(321683415,425432576,15050419,621592,1,'2008-12-26 01:50:00',3310502403,1),(321683416,425432158,15049051,621592,1,'2008-12-26 01:50:00',3310502403,1),(321683417,425431787,15048263,621592,1,'2008-12-26 01:50:01',3310502403,1),(321683418,425431300,15048031,621592,1,'2008-12-26 01:50:01',3310502403,1),(321683419,425431115,15049121,621592,1,'2008-12-26 01:50:01',3310502403,1),(321683420,425430929,15050002,621592,1,'2008-12-26 01:50:01',3310502403,1),(321683421,425430048,15051254,621592,1,'2008-12-26 01:50:01',3310502403,1),(321683422,425429700,15052089,621592,1,'2008-12-26 01:50:02',3310502409,1),(321683423,425429306,15052808,621592,1,'2008-12-26 01:50:02',3310502409,1),(321683424,425428634,15053736,621592,1,'2008-12-26 01:50:02',3310502409,1),(321683425,425428286,15054153,621592,1,'2008-12-26 01:50:02',3310502409,1),(321683426,425427729,15054825,621592,1,'2008-12-26 01:50:02',3310502409,1),(321683427,425427312,15054825,621592,1,'2008-12-26 01:50:03',3310502409,1),(321683428,425427196,15054014,621592,1,'2008-12-26 01:50:03',3310502409,1),(321683429,425427196,15053434,621592,1,'2008-12-26 01:50:03',3310502409,1),(321683430,425426825,15053364,621592,1,'2008-12-26 01:50:03',3310502409,1),(321683431,425426431,15053851,621592,1,'2008-12-26 01:50:04',3310502409,1),(321683432,425425990,15053712,621592,1,'2008-12-26 01:50:04',3310502409,1),(321683434,425425387,15053133,621592,1,'2008-12-26 01:50:04',3310502409,1),(321683436,425425086,15052251,621592,1,'2008-12-26 01:50:04',3310502409,1),(321683438,425424970,15051718,621592,1,'2008-12-26 01:50:04',3310502409,1),(321683440,425424529,15051764,621592,1,'2008-12-26 01:50:05',3310502408,1),(321683441,425424436,15052762,621592,1,'2008-12-26 01:50:05',3310502408,1),(321683443,425424158,15052854,621592,1,'2008-12-26 01:50:05',3310502408,1),(321683445,425423555,15052344,621592,1,'2008-12-26 01:50:05',3310502408,1),(321683447,425423370,15051277,621592,1,'2008-12-26 01:50:06',3310502402,1),(321683448,425423393,15050605,621592,1,'2008-12-26 01:50:06',3310502402,1),(321683449,425422976,15050396,621592,1,'2008-12-26 01:50:06',3310502402,1),(321683450,425422442,15050651,621592,1,'2008-12-26 01:50:06',3310502402,1),(321683451,425421747,15050976,621592,1,'2008-12-26 01:50:06',3310502402,1),(321683452,425421213,15050744,621592,1,'2008-12-26 01:50:07',3310502402,1),(321683453,425421120,15050025,621592,1,'2008-12-26 01:50:07',3310502402,1),(321683454,425421399,15049353,621592,1,'2008-12-26 01:50:07',3310502402,1),(321683455,425421886,15048727,621592,1,'2008-12-26 01:50:07',3310502402,1),(321683456,425421515,15047892,621592,1,'2008-12-26 01:50:07',3310502402,1),(321683457,425421097,15047567,621592,1,'2008-12-26 01:50:08',3310502402,1),(321683458,425420494,15047359,621592,1,'2008-12-26 01:50:08',3310502402,1),(321683459,425419706,15047753,621592,1,'2008-12-26 01:50:08',3310502402,1),(321683460,425419080,15047753,621592,1,'2008-12-26 01:50:08',3310502402,1),(321683461,425418523,15047080,621592,1,'2008-12-26 01:50:09',3310502402,1),(321683462,425418384,15046176,621592,1,'2008-12-26 01:50:09',3310502402,1),(321683463,425418616,15045202,621592,1,'2008-12-26 01:50:09',3310502402,1),(321683464,425418732,15044460,621592,1,'2008-12-26 01:50:09',3310502402,1),(321683465,425418547,15043602,621592,1,'2008-12-26 01:50:09',3310502402,1),(321683466,425417735,15042698,621592,1,'2008-12-26 01:50:10',3310502402,1),(321683467,425416970,15041747,621592,1,'2008-12-26 01:50:10',3310502402,1),(321683468,425416181,15041608,621592,1,'2008-12-26 01:50:10',3310502402,1),(321683469,425415370,15042280,621592,1,'2008-12-26 01:50:10',3310502402,1),(321683470,425414071,15043092,621592,1,'2008-12-26 01:50:11',3310502402,1),(321683471,425413375,15042860,621592,1,'2008-12-26 01:50:11',3310502402,1),(321683472,425412541,15042234,621592,1,'2008-12-26 01:50:11',3310502402,1),(321683473,425411451,15041631,621592,1,'2008-12-26 01:50:11',3310502402,1),(321683474,425410338,15041422,621592,1,'2008-12-26 01:50:11',3310502402,1),(321683475,425409410,15040587,621592,1,'2008-12-26 01:50:12',3310502402,1),(321683476,425408367,15038732,621592,1,'2008-12-26 01:50:12',3310502402,1),(321683477,425407230,15037202,621592,1,'2008-12-26 01:50:12',3310502402,1),(321683478,425406210,15035787,621592,1,'2008-12-26 01:50:12',3310502402,1),(321683479,425405259,15034767,621592,1,'2008-12-26 01:50:12',3310502402,1),(321683480,425404100,15034048,621592,1,'2008-12-26 01:50:13',3310502402,1),(321683481,425403126,15033306,621592,1,'2008-12-26 01:50:13',3310502402,1),(321683482,425401990,15033468,621592,1,'2008-12-26 01:50:13',3310502402,1),(321683483,425400830,15033747,621592,1,'2008-12-26 01:50:13',3310502402,1),(321683484,425399740,15033260,621592,1,'2008-12-26 01:50:14',3310502402,1),(321683485,425398650,15033260,621592,1,'2008-12-26 01:50:14',3310502402,1),(321683486,425397445,15033723,621592,1,'2008-12-26 01:50:14',3310502402,1),(321683487,425396100,15033909,621592,1,'2008-12-26 01:50:15',3310491479,1),(321683488,425394824,15034071,621592,1,'2008-12-26 01:50:15',3310491479,1),(321683489,425393503,15033839,621592,1,'2008-12-26 01:50:15',3310491479,1),(321683490,425391949,15032796,621592,1,'2008-12-26 01:50:15',3310491479,1),(321683491,425391462,15032123,621592,1,'2008-12-26 01:50:15',3310491479,1),(321683492,425390673,15032054,621592,1,'2008-12-26 01:50:16',3310491479,1),(321683493,425389630,15033121,621592,1,'2008-12-26 01:50:16',3310491479,1),(321683494,425388262,15034373,621592,1,'2008-12-26 01:50:16',3310491479,1),(321683495,425387427,15035416,621592,1,'2008-12-26 01:50:16',3310491479,1),(321683496,425386407,15035579,621592,1,'2008-12-26 01:50:16',3310491479,1),(321683497,425384482,15036460,621592,1,'2008-12-26 01:50:17',3310491479,1),(321683498,425383485,15036668,621592,1,'2008-12-26 01:50:17',3310491479,1),(321683499,425381978,15037225,621592,1,'2008-12-26 01:50:17',3310491479,1),(321683500,425381027,15036854,621592,1,'2008-12-26 01:50:17',3310491479,1),(321683501,425380030,15036367,621592,1,'2008-12-26 01:50:18',3310491479,1),(321683502,425379218,15034906,621592,1,'2008-12-26 01:50:18',3310491479,1),(321683503,425378708,15033445,621592,1,'2008-12-26 01:50:18',3310491479,1),(321683504,425377873,15032170,621592,1,'2008-12-26 01:50:19',3310491479,1),(321683505,425377224,15031126,621592,1,'2008-12-26 01:50:19',3310491479,1),(321683506,425377386,15029410,621592,1,'2008-12-26 01:50:19',3310491479,1),(321683507,425378105,15026744,621592,1,'2008-12-26 01:50:19',3310491479,1),(321683508,425378476,15024494,621592,1,'2008-12-26 01:50:19',3310491479,1),(321683509,425378685,15021086,621592,1,'2008-12-26 01:50:19',3310491479,1),(321683510,425379844,15017491,621592,1,'2008-12-26 01:50:20',3310491479,1),(321683511,425381259,15013503,621592,1,'2008-12-26 01:50:20',3310491479,1),(321683512,425382441,15009630,621592,1,'2008-12-26 01:50:20',3310491479,1),(321683513,425383091,15007868,621592,1,'2008-12-26 01:50:20',3310491479,1),(321683514,425383601,15004807,621592,1,'2008-12-26 01:50:20',3310491479,1),(321683515,425384737,15000424,621592,1,'2008-12-26 01:50:21',3310491479,1),(321683516,425386105,14995439,621592,1,'2008-12-26 01:50:21',3310491477,1),(321683517,425386221,14992726,621592,1,'2008-12-26 01:50:21',3310491477,1),(321683518,425386685,14991172,621592,1,'2008-12-26 01:50:21',3310491477,1),(321683519,425386662,14989572,621592,1,'2008-12-26 01:50:21',3310491477,1),(321683520,425386731,14988227,621592,1,'2008-12-26 01:50:21',3310491477,1),(321683521,425388262,14984053,621592,1,'2008-12-26 01:50:22',3310491477,1),(321683522,425389329,14980273,621592,1,'2008-12-26 01:50:22',3310491477,1),(321683523,425389700,14978975,621592,1,'2008-12-26 01:50:22',3310491477,1),(321683524,425391462,14976748,621592,1,'2008-12-26 01:50:22',3310491477,1),(321683525,425392134,14975543,621592,1,'2008-12-26 01:50:22',3310491477,1),(321683526,425392505,14974082,621592,1,'2008-12-26 01:50:23',3310491477,1),(321683527,425393410,14972853,621592,1,'2008-12-26 01:50:23',3310491477,1),(321683528,425395242,14970882,621592,1,'2008-12-26 01:50:23',3310491477,1),(321683529,425395520,14969560,621592,1,'2008-12-26 01:50:23',3310491477,1),(321683530,425394987,14968192,621592,1,'2008-12-26 01:50:23',3310491477,1),(321683532,425395358,14965432,621592,1,'2008-12-26 01:50:23',3310491477,1),(321683533,425395775,14962116,621592,1,'2008-12-26 01:50:24',3310491477,1),(321683534,425396332,14960609,621592,1,'2008-12-26 01:50:24',3310491477,1),(321683535,425396934,14959125,621592,1,'2008-12-26 01:50:24',3310491477,1),(321683536,425397885,14957989,621592,1,'2008-12-26 01:50:24',3310502400,1),(321683537,425398581,14956644,621592,1,'2008-12-26 01:50:25',3310502400,1),(321683538,425399346,14954557,621592,1,'2008-12-26 01:50:25',3310502400,1),(321683539,425400204,14952678,621592,1,'2008-12-26 01:50:25',3310502400,1),(321683540,425400969,14950522,621592,1,'2008-12-26 01:50:25',3310502400,1),(321683541,425402685,14947043,621592,1,'2008-12-26 01:50:25',3310502400,1),(321683542,425405012,14943620,621592,1,'2008-12-26 01:50:26',3310502400,1),(321683543,425406022,14941793,621592,1,'2008-12-26 01:50:26',3310502400,1),(321683544,425406647,14940110,621592,1,'2008-12-26 01:50:26',3310502058,1),(321683609,425406511,14940740,621592,1,'2008-12-26 01:51:55',3310502058,1),(323129883,425471289,15137913,675187,1,'2008-12-30 15:54:19',3310502414,1),(323129885,425368590,14909604,675187,1,'2008-12-30 15:54:19',3310491134,1),(323130871,425722862,14812695,4161539,1,'2010-03-18 16:04:24',3310502119,5),(323130873,425731228,14712728,4161539,1,'2010-03-18 16:04:24',3310502106,5),(323131766,425725562,14835446,675187,1,'2008-12-30 16:00:59',3310502125,1),(323131768,425725625,14837506,675187,1,'2008-12-30 16:00:59',3310502125,1),(324270172,425044221,15136989,697263,1,'2009-01-01 16:45:34',3310491407,1),(324270173,425048967,15144284,697263,1,'2009-01-01 16:45:35',3310491407,1),(324270174,425056877,15152610,697263,1,'2009-01-01 16:45:35',3310491407,1),(332119070,425565350,15297020,787878,1,'2009-01-15 00:22:38',3310502460,3),(332119071,425563900,15295380,787878,1,'2009-01-15 00:22:38',3310502460,2),(332119072,425562130,15294800,787878,1,'2009-01-15 00:22:38',3310502460,2),(332119073,425561409,15294708,787878,1,'2009-01-15 00:22:38',3310502457,2),(332119074,425559650,15294270,787878,1,'2009-01-15 00:22:38',3310502457,2),(332119075,425556180,15292320,787878,1,'2009-01-15 00:22:38',3310502457,2),(332119076,425554930,15290880,787878,1,'2009-01-15 00:22:38',3310502457,4),(332119286,425561180,15311580,787878,1,'2009-01-15 00:12:00',3310502457,1),(332119287,425562220,15308300,787878,1,'2009-01-15 00:12:01',3310502460,1),(332119288,425562530,15304730,787878,1,'2009-01-15 00:12:01',3310502460,1),(332119289,425563900,15300280,787878,1,'2009-01-15 00:12:01',3310502460,1),(332119290,425563950,15299370,787878,1,'2009-01-15 00:12:01',3310502460,1),(332119414,425557616,15305179,787878,1,'2009-01-15 00:14:32',3310502457,2),(332119415,425557047,15303463,787878,1,'2009-01-15 00:14:32',3310502457,2),(332119416,425556098,15300373,787878,1,'2009-01-15 00:14:32',3310502457,2),(332119417,425555466,15297970,787878,1,'2009-01-15 00:14:32',3310502457,2),(332119418,425555150,15294880,787878,1,'2009-01-15 00:14:32',3310502457,2),(332121136,425516568,15264062,725665,1,'2009-03-02 22:29:56',3310502450,10),(332121137,425518970,15265007,725665,1,'2009-03-02 22:29:56',3310502450,11),(332122179,425553935,15288782,787878,1,'2009-01-15 00:22:38',3310502457,1),(332122180,425553050,15287350,787878,1,'2009-01-15 00:22:38',3310502457,1),(332122181,425552530,15287100,787878,1,'2009-01-15 00:22:38',3310502457,1),(332122182,425550920,15284900,787878,1,'2009-01-15 00:22:38',3310502457,1),(332122183,425547150,15282000,787878,1,'2009-01-15 00:22:38',3310502457,1),(332122184,425541830,15279920,787878,1,'2009-01-15 00:22:38',3310502457,1),(332122185,425536000,15274450,787878,1,'2009-01-15 00:22:38',3310502457,1),(332122186,425532800,15270670,787878,1,'2009-01-15 00:22:38',3310502450,1),(332122187,425530050,15268400,787878,1,'2009-01-15 00:22:38',3310502450,1),(332122188,425528470,15267430,787878,1,'2009-01-15 00:22:38',3310502450,1),(332122189,425521100,15265820,787878,1,'2009-01-15 00:22:38',3310502450,1),(332125718,425427104,15149834,787878,1,'2009-01-15 00:31:07',3310502411,2),(332126612,425429581,15154224,787878,1,'2009-01-15 00:31:30',3310502411,2),(332126613,425429012,15153023,787878,1,'2009-01-15 00:31:07',3310502411,1),(332126614,425428506,15152079,787878,1,'2009-01-15 00:31:07',3310502411,1),(332126615,425428000,15151134,787878,1,'2009-01-15 00:31:07',3310502411,1),(332126684,425432300,15158602,787878,1,'2009-01-15 00:31:30',3310502411,1),(332126685,425431720,15158020,787878,1,'2009-01-15 00:31:30',3310502411,1),(332126688,425430656,15156198,787878,1,'2009-01-15 00:31:30',3310502411,1),(332126689,425430023,15154997,787878,1,'2009-01-15 00:31:30',3310502411,1),(335320657,425512717,15266972,725665,1,'2009-03-02 22:19:38',3310502450,4),(337729044,425052452,15269986,840745,1,'2009-01-26 20:00:24',3310491431,3),(337733739,425052705,15277883,840745,1,'2009-01-26 19:28:30',3310491437,1),(337739581,425084153,15340807,305941,1,'2009-02-09 21:19:42',3310491450,9),(337742674,425051483,15260942,840745,1,'2009-01-26 20:04:34',3310491431,3),(337743301,425063835,15277017,981792,1,'2009-04-27 01:30:07',3310491437,3),(337745019,425057071,15318395,840745,1,'2009-01-26 19:37:27',3310491437,1),(337767559,425084147,15340729,305941,1,'2009-02-09 21:17:59',3310491450,7),(337775423,425052705,15260888,840745,1,'2009-01-26 20:04:34',3310491431,1),(337775425,425054720,15260870,840745,1,'2009-01-26 20:04:34',3310491431,1),(337775428,425059349,15269986,840745,1,'2009-01-26 20:04:34',3310491431,1),(337779059,425051503,15242692,840745,1,'2009-01-26 20:08:19',3310491431,1),(337781593,425092052,15340147,104780,1,'2009-02-04 00:33:41',3310491450,3),(337782221,425096920,15338630,104780,1,'2009-02-04 00:33:41',3310491451,2),(337782224,425093020,15339970,104780,1,'2009-02-04 00:33:41',3310491450,2),(337833707,425445905,15121785,840745,1,'2009-01-26 21:16:49',3310502411,2),(337833711,425444577,15120669,840745,1,'2009-01-26 21:16:49',3310502411,2),(337833715,425442996,15119381,840745,1,'2009-01-26 21:18:10',3310502411,5),(337840780,425446420,15137720,840745,1,'2009-01-26 21:17:32',3310502411,1),(337840784,425446470,15137350,840745,1,'2009-01-26 21:17:32',3310502411,1),(337840789,425445850,15135870,840745,1,'2009-01-26 21:17:32',3310502411,1),(337840791,425445970,15135770,840745,1,'2009-01-26 21:17:33',3310502411,1),(337840797,425444600,15133100,840745,1,'2009-01-26 21:17:33',3310502411,1),(337840800,425443881,15130282,840745,1,'2009-01-26 21:17:33',3310502411,1),(337840804,425443502,15127106,840745,1,'2009-01-26 21:17:34',3310502411,1),(337840809,425443439,15126076,840745,1,'2009-01-26 21:17:34',3310502411,1),(337840812,425443123,15124875,840745,1,'2009-01-26 21:17:34',3310502411,1),(337840815,425443186,15123072,840745,1,'2009-01-26 21:17:34',3310502411,1),(337840821,425442770,15120300,840745,1,'2009-01-26 21:17:35',3310502411,1),(337840888,425441850,15115670,844916,1,'2009-01-27 20:17:20',3310502411,4),(337840981,425440820,15114280,844916,1,'2009-01-27 20:17:20',3310502411,2),(337840986,425439030,15113180,844916,1,'2009-01-27 20:17:20',3310502411,2),(337840989,425437730,15112280,844916,1,'2009-01-27 20:17:20',3310502411,3),(337841272,425437150,15111430,840745,1,'2009-01-26 21:18:19',3310502411,1),(337841280,425434830,15109250,844916,1,'2009-01-27 20:17:54',3310502411,3),(337841383,425433600,15106300,844916,1,'2009-01-27 20:17:54',3310502409,2),(337841643,425432150,15103770,840745,1,'2009-01-26 21:18:52',3310502409,1),(337841646,425431520,15102370,840745,1,'2009-01-26 21:18:52',3310502409,1),(337841651,425431270,15100780,840745,1,'2009-01-26 21:18:52',3310502409,1),(337841655,425430200,15098030,840745,1,'2009-01-26 21:18:53',3310502409,1),(337841658,425429300,15096580,840745,1,'2009-01-26 21:18:53',3310502409,1),(337841661,425429330,15096300,840745,1,'2009-01-26 21:18:53',3310502409,1),(338418931,425463501,15090135,844916,1,'2009-01-27 19:52:23',3310502412,3),(338418932,425463763,15090883,844916,1,'2009-01-27 19:52:23',3310502412,5),(338420420,425462932,15093826,104780,1,'2009-02-04 00:28:27',3310502412,4),(338420421,425461414,15107473,104780,1,'2009-02-04 00:28:27',3310502414,3),(338420422,425461161,15108074,104780,1,'2009-02-04 00:28:27',3310502414,3),(338420423,425460972,15108159,104780,1,'2009-02-04 00:28:27',3310502414,3),(338420424,425460213,15107988,104780,1,'2009-02-04 00:28:27',3310502414,3),(338420425,425459897,15106958,104780,1,'2009-02-04 00:28:27',3310502414,3),(338420426,425460655,15094255,104780,1,'2009-02-04 00:28:27',3310502412,3),(338420688,425463680,15092330,844916,1,'2009-01-27 19:52:14',3310502412,2),(338420689,425463248,15095542,844916,1,'2009-01-27 19:52:14',3310502412,2),(338420690,425462995,15097516,844916,1,'2009-01-27 19:52:14',3310502412,2),(338420691,425462869,15099319,844916,1,'2009-01-27 19:52:14',3310502412,2),(338420692,425462489,15102666,844916,1,'2009-01-27 19:52:14',3310502412,2),(338420693,425462080,15105800,844916,1,'2009-01-27 19:52:15',3310502412,2),(338420694,425461800,15107250,844916,1,'2009-01-27 19:52:15',3310502414,2),(338420695,425461370,15108700,844916,1,'2009-01-27 19:52:15',3310502414,2),(338420696,425461030,15109070,844916,1,'2009-01-27 19:52:15',3310502414,2),(338420697,425460800,15108950,844916,1,'2009-01-27 19:52:15',3310502414,2),(338420698,425460530,15108580,844916,1,'2009-01-27 19:52:15',3310502414,2),(338420699,425460370,15107470,844916,1,'2009-01-27 19:52:15',3310502414,2),(338420700,425460700,15106820,844916,1,'2009-01-27 19:52:15',3310502414,2),(338420701,425461300,15106920,844916,1,'2009-01-27 19:52:15',3310502414,2),(338420702,425461020,15106450,844916,1,'2009-01-27 19:46:28',3310502414,1),(338422550,425469400,15093800,844916,1,'2009-01-27 19:58:51',3310502412,2),(338422551,425470300,15094430,844916,1,'2009-01-27 20:16:07',3310502412,3),(338425045,425449729,15130615,844916,1,'2009-01-27 20:10:19',3310502411,3),(338425046,425451970,15129950,844916,1,'2009-01-27 20:11:54',3310502411,6),(338425186,425450488,15133705,844916,1,'2009-01-27 20:10:20',3310502411,5),(338425409,425451183,15133190,844916,1,'2009-01-27 20:08:49',3310502411,2),(338425484,425449600,15127830,844916,1,'2009-01-27 20:11:15',3310502411,5),(338425485,425449729,15124521,844916,1,'2009-01-27 20:11:15',3310502411,2),(338425486,425450045,15122032,844916,1,'2009-01-27 20:11:15',3310502411,2),(338425556,425449600,15129150,844916,1,'2009-01-27 20:10:19',3310502411,2),(338425558,425450108,15131387,844916,1,'2009-01-27 20:10:19',3310502411,2),(338425560,425450120,15132130,844916,1,'2009-01-27 20:10:19',3310502411,2),(338425561,425450298,15132932,844916,1,'2009-01-27 20:10:19',3310502411,2),(338425562,425450570,15134470,844916,1,'2009-01-27 20:10:20',3310502411,2),(338425567,425450150,15127780,844916,1,'2009-01-27 20:10:15',3310502411,1),(338425636,425458870,15114850,844916,1,'2009-01-27 20:16:08',3310502414,2),(338425637,425456980,15116950,844916,1,'2009-01-27 20:11:39',3310502414,1),(338425638,425456480,15118700,844916,1,'2009-01-27 20:11:39',3310502414,1),(338425639,425456570,15119850,844916,1,'2009-01-27 20:11:39',3310502414,1),(338425640,425456230,15120320,844916,1,'2009-01-27 20:11:39',3310502414,1),(338425642,425455450,15124980,844916,1,'2009-01-27 20:11:39',3310502414,1),(338425643,425455600,15127380,844916,1,'2009-01-27 20:11:39',3310502414,1),(338425644,425456170,15129770,844916,1,'2009-01-27 20:11:39',3310502414,1),(338425645,425456100,15130380,844916,1,'2009-01-27 20:11:39',3310502414,1),(338425647,425453920,15130320,844916,1,'2009-01-27 20:11:39',3310502414,1),(338425648,425453300,15129980,844916,1,'2009-01-27 20:11:54',3310502414,2),(338425715,425452830,15129330,844916,1,'2009-01-27 20:11:54',3310502414,1),(338425717,425452150,15129500,844916,1,'2009-01-27 20:11:54',3310502414,1),(338426328,425470533,15095081,844916,1,'2009-01-27 20:16:07',3310502412,1),(338426330,425470530,15095780,844916,1,'2009-01-27 20:16:07',3310502412,1),(338426331,425469070,15098370,844916,1,'2009-01-27 20:16:07',3310502412,1),(338426332,425468330,15100420,844916,1,'2009-01-27 20:16:07',3310502412,1),(338426338,425467970,15102370,844916,1,'2009-01-27 20:16:07',3310502412,1),(338426339,425467520,15102820,844916,1,'2009-01-27 20:16:08',3310502412,1),(338426340,425466180,15103400,844916,1,'2009-01-27 20:16:08',3310502412,1),(338426341,425465270,15104230,844916,1,'2009-01-27 20:16:08',3310502412,1),(338426342,425464670,15105180,844916,1,'2009-01-27 20:16:08',3310502412,1),(338426343,425463930,15107380,844916,1,'2009-01-27 20:16:08',3310502414,1),(338426344,425464020,15108480,844916,1,'2009-01-27 20:16:08',3310502414,1),(338426345,425463150,15109820,844916,1,'2009-01-27 20:16:08',3310502414,1),(338426346,425461880,15111480,844916,1,'2009-01-27 20:16:08',3310502414,1),(338426347,425460500,15112520,844916,1,'2009-01-27 20:16:08',3310502414,1),(339066904,425471266,15632572,854025,1,'2009-01-30 08:42:31',3310502564,1),(339066905,425279007,16693439,854025,1,'2009-01-30 08:42:48',3310493167,1),(340304066,425073120,15380097,104780,1,'2009-02-04 00:39:24',3310491450,1),(340304067,425077359,15380268,104780,1,'2009-02-04 00:39:24',3310491450,1),(340304068,425077359,15383358,104780,1,'2009-02-04 00:39:24',3310491536,1),(340304069,425073563,15383358,104780,1,'2009-02-04 00:39:24',3310491536,1),(340304325,425075841,15356922,104780,1,'2009-02-04 00:41:33',3310491450,1),(340304326,425075967,15362931,104780,1,'2009-02-04 00:41:33',3310491450,1),(340304327,425076473,15367050,104780,1,'2009-02-04 00:41:33',3310491450,1),(340304328,425072677,15368252,104780,1,'2009-02-04 00:41:34',3310491450,1),(340304329,425070779,15356236,104780,1,'2009-02-04 00:41:34',3310491450,1),(343733031,425058567,15210324,305941,1,'2009-02-09 21:34:27',3310491429,1),(349145208,424472720,14653330,27626,1,'2009-04-01 15:33:06',3310490076,5),(349145210,424472070,14642500,27626,1,'2009-04-01 15:33:06',3310490076,5),(349145211,424471000,14636820,27626,1,'2009-04-01 15:33:06',3310490076,5),(349145213,424469270,14631530,27626,1,'2009-04-01 15:33:06',3310490076,5),(349145214,424466300,14625170,27626,1,'2009-04-01 15:33:06',3310490076,5),(349145215,424463380,14620670,27626,1,'2009-04-01 15:33:06',3310490076,5),(349145217,424459830,14613980,27626,1,'2009-04-01 15:33:06',3310490073,5),(349145218,424459270,14612200,27626,1,'2009-04-01 15:33:07',3310490073,5),(349145220,424459000,14610320,27626,1,'2009-04-01 15:33:07',3310490067,5),(349145221,424460130,14602730,27626,1,'2009-04-01 15:33:07',3310490067,5),(349145223,424459920,14598770,27626,1,'2009-04-01 15:33:07',3310490067,5),(349145224,424460230,14597380,27626,1,'2009-04-01 15:33:07',3310490067,5),(349145226,424463780,14590920,27626,1,'2009-04-01 15:33:07',3310490070,5),(349145227,424466170,14590030,27626,1,'2009-04-01 15:33:07',3310490070,5),(349145229,424469070,14590330,27626,1,'2009-04-01 15:33:07',3310490070,5),(349145230,424473680,14593270,27626,1,'2009-04-01 15:33:07',3310490070,5),(349145232,424475520,14593850,27626,1,'2009-04-01 15:33:07',3310490070,5),(349145233,424485500,14592430,27626,1,'2009-04-01 15:33:07',3310490070,5),(349145235,424487950,14590920,27626,1,'2009-04-01 15:33:07',3310490070,5),(349145236,424493630,14585950,27626,1,'2009-04-01 15:33:07',3310490071,5),(349145237,424498480,14583450,27626,1,'2009-04-01 15:33:07',3310490071,5),(349145239,424501070,14580220,27626,1,'2009-04-01 15:33:07',3310490071,5),(349145240,424504400,14572870,27626,1,'2009-04-01 15:33:07',3310490071,5),(349145242,424506820,14558780,27626,1,'2009-04-01 15:33:07',3310490071,5),(349145243,424508120,14555030,27626,1,'2009-04-01 15:33:07',3310490069,5),(349145245,424509520,14547480,27626,1,'2009-04-01 15:33:07',3310490069,5),(349145246,424513170,14535200,27626,1,'2009-04-01 15:33:07',3310490069,5),(349145248,424513350,14530570,27626,1,'2009-04-01 15:33:07',3310490069,5),(349145249,424516320,14521480,27626,1,'2009-04-01 15:33:07',3310490069,5),(349145250,424516450,14520130,27626,1,'2009-04-01 15:33:07',3310490069,5),(349145281,424552030,14511400,27626,1,'2009-04-01 15:33:08',3310490753,5),(349145282,424555730,14511780,27626,1,'2009-04-01 15:33:08',3310490753,5),(349145283,424558700,14515520,27626,1,'2009-04-01 15:33:08',3310490753,5),(349145284,424559900,14513600,27626,1,'2009-04-01 15:33:08',3310490753,5),(349145285,424559330,14509670,27626,1,'2009-04-01 15:33:08',3310490753,5),(349146313,424579650,14510630,609884,1,'2009-02-22 17:56:37',3310490756,1),(349146314,424580300,14516250,609884,1,'2009-02-22 17:56:37',3310490756,1),(349146315,424581270,14514850,609884,1,'2009-02-22 17:56:37',3310490756,1),(349146316,424581780,14508830,609884,1,'2009-02-22 17:56:37',3310490756,1),(354962410,425511832,15263367,725665,1,'2009-03-02 22:21:42',3310502450,6),(354962603,425514551,15264139,725665,1,'2009-03-02 22:19:05',3310502450,3),(354962604,425514424,15264826,725665,1,'2009-03-02 22:21:27',3310502450,4),(354962605,425513981,15265169,725665,1,'2009-03-02 22:22:38',3310502450,5),(354962608,425513539,15265169,725665,1,'2009-03-02 22:19:05',3310502450,2),(354962610,425513096,15264998,725665,1,'2009-03-02 22:22:09',3310502450,4),(354962612,425512843,15264311,725665,1,'2009-03-02 22:21:42',3310502450,4),(354962614,425512843,15263539,725665,1,'2009-03-02 22:19:05',3310502450,2),(354962618,425513286,15262938,725665,1,'2009-03-02 22:21:33',3310502450,4),(354962620,425513918,15263024,725665,1,'2009-03-02 22:19:05',3310502450,2),(354962622,425514424,15263367,725665,1,'2009-03-02 22:21:18',3310502450,5),(354966294,425535238,15284029,725665,1,'2009-03-02 22:29:54',3310502457,3),(354966710,425538387,15286885,725665,1,'2009-03-02 22:34:24',3310502457,4),(354966711,425539336,15287657,725665,1,'2009-03-02 22:27:38',3310502457,2),(354966915,425537755,15286284,725665,1,'2009-03-02 22:34:09',3310502457,15),(354966917,425537502,15286799,725665,1,'2009-03-02 22:34:24',3310502457,10),(354966919,425536996,15286799,725665,1,'2009-03-02 22:34:08',3310502457,10),(354966921,425536554,15286370,725665,1,'2009-03-02 22:34:08',3310502457,10),(354966923,425536427,15285683,725665,1,'2009-03-02 22:34:08',3310502457,11),(354966925,425536680,15285168,725665,1,'2009-03-02 22:34:08',3310502457,8),(354966927,425537123,15284825,725665,1,'2009-03-02 22:34:08',3310502457,11),(354966929,425537565,15285082,725665,1,'2009-03-02 22:34:08',3310502457,8),(354966931,425537882,15285597,725665,1,'2009-03-02 22:34:23',3310502457,10),(354968366,425535669,15287571,725665,1,'2009-03-02 22:31:50',3310502457,1),(364104064,425518067,14880767,837556,1,'2009-03-20 18:52:04',3310502072,1),(366060792,426315000,14811600,864892,1,'2009-03-28 14:33:30',3310503075,2),(366060794,426317300,14813300,864892,1,'2009-03-28 14:33:30',3310503075,2),(366060795,426320200,14812900,864892,1,'2009-03-28 14:33:30',3310503075,2),(366060796,426322500,14810600,864892,1,'2009-03-28 14:33:30',3310503075,2),(366060797,426336300,14824100,864892,1,'2009-03-28 14:33:31',3310503078,2),(366060798,426340100,14826000,864892,1,'2009-03-28 14:33:31',3310503078,2),(366060800,426343200,14826700,864892,1,'2009-03-28 14:33:31',3310503078,2),(366060801,426345400,14829000,864892,1,'2009-03-28 14:33:31',3310503078,2),(366060803,426351900,14838500,864892,1,'2009-03-28 14:33:31',3310503084,2),(366060804,426355500,14841700,864892,1,'2009-03-28 14:33:31',3310503084,2),(366060805,426358200,14851400,864892,1,'2009-03-28 14:33:31',3310503084,2),(366060807,426356500,14863000,864892,1,'2009-03-28 14:33:31',3310503084,2),(366060808,426357400,14864100,864892,1,'2009-03-28 14:33:31',3310503084,2),(366060810,426358500,14864400,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060811,426359700,14867200,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060812,426361600,14868300,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060813,426362800,14868200,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060815,426363100,14865800,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060816,426370900,14864900,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060818,426374100,14865200,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060819,426376700,14864700,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060820,426377600,14865300,864892,1,'2009-03-28 14:33:32',3310503085,3),(366060821,426380400,14863700,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060822,426383100,14861900,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060823,426385200,14854800,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060824,426385100,14853500,864892,1,'2009-03-28 14:33:31',3310503085,2),(366060825,426386400,14851400,864892,1,'2009-03-28 14:33:31',3310503096,2),(366060826,426388700,14850100,864892,1,'2009-03-28 14:33:31',3310503096,2),(366060827,426390900,14850000,864892,1,'2009-03-28 14:33:31',3310503096,2),(366060828,426391500,14849200,864892,1,'2009-03-28 14:33:31',3310503096,2),(366060829,426391700,14852500,864892,1,'2009-03-28 14:33:31',3310503096,2),(366060830,426393800,14854500,864892,1,'2009-03-28 14:33:31',3310503096,2),(366060833,426400300,14854000,864892,1,'2009-03-28 14:33:31',3310503096,2),(366060834,426401400,14853500,864892,1,'2009-03-28 14:33:31',3310503096,2),(366060836,426404000,14856600,864892,1,'2009-03-28 14:33:31',3310503096,2),(366060838,426408800,14860500,864892,1,'2009-03-28 14:33:31',3310503096,2),(366060840,426414700,14862900,864892,1,'2009-03-28 14:33:31',3310503097,2),(366060841,426416700,14862600,864892,1,'2009-03-28 14:33:31',3310503097,2),(366060843,426419700,14860400,864892,1,'2009-03-28 14:33:31',3310503097,2),(366060845,426423300,14854200,864892,1,'2009-03-28 14:33:31',3310503097,2),(366060846,426426400,14853800,864892,1,'2009-03-28 14:33:31',3310503097,2),(366060848,426429800,14854800,864892,1,'2009-03-28 14:33:31',3310503097,2),(366060850,426434700,14855200,864892,1,'2009-03-28 14:33:31',3310503097,2),(366060852,426427100,14859600,864892,1,'2009-03-28 14:33:31',3310503097,2),(366060854,426426400,14861500,864892,1,'2009-03-28 14:33:31',3310503097,2),(366060856,426421300,14865500,864892,1,'2009-03-28 14:33:31',3310503097,2),(366060857,426418100,14866300,864892,1,'2009-03-28 14:33:32',3310503097,2),(366060858,426417700,14866800,864892,1,'2009-03-28 14:33:32',3310503097,2),(366060859,426414200,14866200,864892,1,'2009-03-28 14:33:32',3310503097,2),(366060861,426411600,14867800,864892,1,'2009-03-28 14:33:32',3310503096,2),(366060862,426412500,14868700,864892,1,'2009-03-28 14:33:32',3310503096,2),(366060863,426412200,14869500,864892,1,'2009-03-28 14:33:32',3310503096,2),(366060864,426404800,14870400,864892,1,'2009-03-28 14:33:32',3310503096,2),(366060865,426402400,14872700,864892,1,'2009-03-28 14:33:32',3310503096,2),(366060866,426397200,14874200,864892,1,'2009-03-28 14:33:32',3310503096,2),(366060867,426394400,14872800,864892,1,'2009-03-28 14:33:32',3310503096,2),(366060868,426390800,14872100,864892,1,'2009-03-28 14:33:32',3310503096,2),(366060869,426386600,14869900,864892,1,'2009-03-28 14:33:32',3310503096,2),(366060870,426382300,14869000,864892,1,'2009-03-28 14:33:32',3310503085,2),(366060871,426380800,14865600,864892,1,'2009-03-28 14:33:32',3310503085,2),(366060968,426332200,15114200,862435,1,'2009-03-27 00:58:40',3310503438,2),(366060970,426333200,15114500,862435,1,'2009-03-27 00:58:40',3310503438,2),(366060971,426333700,15117800,862435,1,'2009-03-27 00:58:41',3310503438,2),(366060973,426331900,15126900,862435,1,'2009-03-27 00:58:41',3310503438,2),(366060975,426332200,15131000,862435,1,'2009-03-27 00:58:41',3310503438,2),(366060977,426333200,15135400,862435,1,'2009-03-27 00:58:42',3310503438,2),(366060978,426336100,15138900,862435,1,'2009-03-27 00:58:42',3310503438,2),(366060980,426338000,15143400,862435,1,'2009-03-27 00:58:42',3310503438,2),(366060982,426339100,15144300,862435,1,'2009-03-27 00:58:42',3310503438,2),(366060984,426339800,15146800,862435,1,'2009-03-27 00:58:42',3310503438,2),(366060986,426340700,15147300,862435,1,'2009-03-27 00:58:43',3310503438,2),(366060987,426343200,15150800,862435,1,'2009-03-27 00:58:43',3310503438,2),(366060989,426345200,15155700,862435,1,'2009-03-27 00:58:43',3310503438,2),(366060992,426346000,15159900,862435,1,'2009-03-27 00:58:43',3310503438,2),(366060994,426348500,15165700,862435,1,'2009-03-27 00:58:44',3310503460,2),(366060995,426348100,15168300,862435,1,'2009-03-27 00:58:44',3310503460,2),(366060997,426348700,15174100,862435,1,'2009-03-27 00:58:44',3310503460,2),(366060999,426349200,15175100,862435,1,'2009-03-27 00:58:44',3310503460,2),(366061000,426350100,15180100,862435,1,'2009-03-27 00:58:45',3310503460,2),(366061002,426349700,15181700,862435,1,'2009-03-27 00:58:45',3310503460,2),(366061004,426352900,15189100,862435,1,'2009-03-27 00:58:45',3310503460,2),(366061007,426353700,15192900,862435,1,'2009-03-27 00:58:45',3310503460,2),(366061009,426355400,15193400,862435,1,'2009-03-27 00:58:46',3310503460,2),(366061012,426354700,15194200,862435,1,'2009-03-27 00:58:46',3310503460,2),(366061015,426356700,15193600,862435,1,'2009-03-27 00:58:46',3310503460,2),(366061016,426360000,15194300,862435,1,'2009-03-27 00:58:46',3310503461,2),(366061018,426368300,15203500,862435,1,'2009-03-27 00:58:47',3310503461,2),(366061020,426371000,15209200,862435,1,'2009-03-27 00:58:47',3310503461,2),(366061021,426372100,15209000,862435,1,'2009-03-27 00:58:48',3310503461,2),(366061023,426374200,15214200,862435,1,'2009-03-27 00:58:48',3310503461,2),(366061025,426373900,15216000,862435,1,'2009-03-27 00:58:48',3310503461,2),(366061027,426373000,15217100,862435,1,'2009-03-27 00:58:49',3310503463,2),(366061029,426374300,15222900,862435,1,'2009-03-27 00:58:49',3310503463,2),(366061031,426376000,15221600,862435,1,'2009-03-27 00:58:49',3310503463,2),(366061032,426375900,15225700,862435,1,'2009-03-27 00:58:50',3310503463,2),(366061034,426376700,15226600,862435,1,'2009-03-27 00:58:50',3310503463,2),(366061036,426376100,15227200,862435,1,'2009-03-27 00:58:51',3310503463,2),(366061037,426380700,15231300,862435,1,'2009-03-27 00:58:51',3310503463,2),(366061038,426380400,15231500,862435,1,'2009-03-27 00:58:51',3310503463,2),(366061040,426384500,15231900,862435,1,'2009-03-27 00:58:51',3310503463,2),(366061042,426386200,15232600,862435,1,'2009-03-27 00:58:52',3310503474,2),(366061044,426388900,15232400,862435,1,'2009-03-27 00:58:52',3310503474,2),(366061045,426389900,15232800,862435,1,'2009-03-27 00:58:52',3310503474,2),(366061047,426394800,15230200,862435,1,'2009-03-27 00:58:52',3310503474,2),(366061049,426397400,15230800,862435,1,'2009-03-27 00:58:53',3310503474,2),(366061050,426399900,15229400,862435,1,'2009-03-27 00:58:53',3310503474,2),(366061051,426401500,15230100,862435,1,'2009-03-27 00:58:53',3310503474,2),(366061052,426404300,15233100,862435,1,'2009-03-27 00:58:54',3310503474,2),(366061054,426410700,15236300,862435,1,'2009-03-27 00:58:54',3310503474,2),(366061055,426418700,15235900,862435,1,'2009-03-27 00:58:54',3310503475,2),(366061056,426428600,15238500,862435,1,'2009-03-27 00:58:55',3310503475,2),(366061057,426432400,15240300,862435,1,'2009-03-27 00:58:55',3310503475,2),(366061058,426440200,15250900,862435,1,'2009-03-27 00:58:56',3310503475,2),(366061060,426440300,15253800,862435,1,'2009-03-27 00:58:56',3310503475,2),(366061061,426443400,15257200,862435,1,'2009-03-27 00:58:57',3310503478,2),(366061063,426443800,15260700,862435,1,'2009-03-27 00:58:57',3310503478,2),(366061065,426443200,15262300,862435,1,'2009-03-27 00:58:57',3310503478,2),(366061067,426440100,15261200,862435,1,'2009-03-27 00:58:58',3310503475,2),(366061071,426438600,15261900,862435,1,'2009-03-27 00:58:58',3310503475,2),(366061073,426438200,15264700,862435,1,'2009-03-27 00:58:58',3310503475,2),(366061076,426436800,15267200,862435,1,'2009-03-27 00:58:59',3310503475,2),(366061079,426439500,15276400,862435,1,'2009-03-27 00:58:59',3310503481,2),(366061081,426439400,15278900,862435,1,'2009-03-27 00:58:59',3310503481,2),(366061083,426440500,15282600,862435,1,'2009-03-27 00:59:00',3310503481,2),(366061085,426445400,15290500,862435,1,'2009-03-27 00:59:00',3310503484,2),(366061087,426448300,15293200,862435,1,'2009-03-27 00:59:00',3310503484,2),(366061088,426449300,15296400,862435,1,'2009-03-27 00:59:01',3310503484,2),(366061090,426450200,15301600,862435,1,'2009-03-27 00:59:02',3310503484,2),(366061092,426449700,15303700,862435,1,'2009-03-27 00:59:02',3310503484,2),(366061094,426450200,15306500,862435,1,'2009-03-27 00:59:03',3310503484,2),(366061095,426450800,15307600,862435,1,'2009-03-27 00:59:03',3310503484,2),(366061097,426450600,15311000,862435,1,'2009-03-27 00:59:03',3310503484,2),(366061099,426453000,15317800,862435,1,'2009-03-27 00:59:04',3310503484,2),(366061101,426454300,15325200,862435,1,'2009-03-27 00:59:04',3310503484,2),(366061102,426456600,15331500,862435,1,'2009-03-27 00:59:04',3310503486,2),(366061104,426460100,15332400,862435,1,'2009-03-27 00:59:05',3310503486,2),(366061106,426460600,15333800,862435,1,'2009-03-27 00:59:05',3310503486,2),(366061109,426462200,15335900,862435,1,'2009-03-27 00:59:05',3310503486,2),(366061111,426463400,15335900,862435,1,'2009-03-27 00:59:06',3310503486,2),(366061113,426464600,15337000,862435,1,'2009-03-27 00:59:06',3310503486,2),(366061115,426465200,15339200,862435,1,'2009-03-27 00:59:07',3310503486,2),(366061117,426466100,15340400,862435,1,'2009-03-27 00:59:07',3310503486,2),(366061119,426467300,15340800,862435,1,'2009-03-27 00:59:08',3310503486,2),(366061122,426469900,15340400,862435,1,'2009-03-27 00:59:08',3310503487,2),(366061124,426470600,15339100,862435,1,'2009-03-27 00:59:09',3310503487,2),(366061126,426473000,15339800,862435,1,'2009-03-27 00:59:09',3310503487,2),(366061128,426476900,15338900,862435,1,'2009-03-27 00:59:10',3310503487,2),(366061130,426477900,15339000,862435,1,'2009-03-27 00:59:10',3310503487,2),(366061132,426477900,15339700,862435,1,'2009-03-27 00:59:10',3310503487,2),(366061135,426478900,15339600,862435,1,'2009-03-27 00:59:10',3310503487,2),(366061137,426479400,15340700,862435,1,'2009-03-27 00:59:11',3310503487,2),(366061139,426482600,15341900,862435,1,'2009-03-27 00:59:11',3310503487,2),(366061141,426483200,15341100,862435,1,'2009-03-27 00:59:11',3310503487,2),(366061144,426488800,15340800,862435,1,'2009-03-27 00:59:12',3310503487,2),(366061145,426492400,15339700,862435,1,'2009-03-27 00:59:12',3310503487,2),(366061147,426496500,15342000,862435,1,'2009-03-27 00:59:12',3310503530,2),(366061148,426496800,15343500,862435,1,'2009-03-27 00:59:13',3310503530,2),(366061149,426498300,15342900,862435,1,'2009-03-27 00:59:13',3310503530,2),(366061154,426326124,15118555,862435,1,'2009-03-27 00:59:17',3310503435,2),(366076279,425833300,14697800,863220,1,'2009-03-27 04:34:37',3310502111,2),(366076280,425838000,14686500,863220,1,'2009-03-27 04:33:38',3310502282,1),(366076281,425838800,14683300,863220,1,'2009-03-27 04:33:40',3310502282,1),(366076282,425838900,14680700,863220,1,'2009-03-27 04:33:40',3310502282,1),(366076283,425837600,14679600,863220,1,'2009-03-27 04:33:40',3310502282,1),(366076284,425838700,14677000,863220,1,'2009-03-27 04:33:40',3310502282,1),(366076286,425839100,14676100,863220,1,'2009-03-27 04:33:40',3310502282,1),(366076287,425840700,14676800,863220,1,'2009-03-27 04:33:40',3310502282,1),(366076288,425839400,14672100,863220,1,'2009-03-27 04:33:40',3310502282,1),(366076289,425839500,14668100,863220,1,'2009-03-27 04:33:40',3310502282,1),(366076290,425839300,14668700,863220,1,'2009-03-27 04:33:40',3310502282,1),(366076291,425838800,14667300,863220,1,'2009-03-27 04:33:40',3310502282,1),(366076292,425838400,14667800,863220,1,'2009-03-27 04:33:40',3310502282,1),(366076293,425837800,14664900,863220,1,'2009-03-27 04:33:40',3310502280,1),(366076294,425837700,14659600,863220,1,'2009-03-27 04:33:40',3310502280,1),(366076295,425838700,14657600,863220,1,'2009-03-27 04:33:40',3310502280,1),(366076296,425839500,14652500,863220,1,'2009-03-27 04:33:41',3310502280,1),(366076297,425838900,14650600,863220,1,'2009-03-27 04:33:41',3310502280,1),(366076298,425836300,14650000,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076299,425831800,14645100,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076300,425831300,14647400,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076301,425829400,14651500,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076302,425828000,14648900,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076303,425826600,14648100,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076304,425825700,14646700,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076305,425824500,14647800,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076306,425823300,14647700,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076307,425823300,14646100,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076308,425824100,14643400,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076309,425822900,14642000,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076310,425822800,14640700,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076311,425819400,14643500,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076312,425818500,14642700,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076313,425818500,14641400,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076314,425820000,14639400,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076315,425821000,14637000,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076316,425820700,14633500,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076317,425821500,14630900,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076318,425821300,14624200,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076319,425818200,14618000,863220,1,'2009-03-27 04:33:41',3310502109,1),(366076320,425816800,14610300,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076321,425817700,14602900,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076322,425817700,14599500,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076323,425816600,14591500,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076324,425815600,14590000,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076325,425815500,14587000,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076326,425814600,14584400,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076327,425814700,14577300,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076328,425813200,14576000,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076329,425813100,14569500,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076331,425813600,14567400,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076332,425812000,14561300,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076333,425811700,14558500,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076334,425810600,14558100,863220,1,'2009-03-27 04:33:42',3310502103,1),(366076335,425809300,14549100,863220,1,'2009-03-27 04:33:42',3310502101,1),(366076336,425808000,14543800,863220,1,'2009-03-27 04:33:42',3310502100,1),(366076337,425806600,14541100,863220,1,'2009-03-27 04:33:42',3310502100,1),(366076338,425806500,14538900,863220,1,'2009-03-27 04:33:42',3310502100,1),(366076339,425805800,14538500,863220,1,'2009-03-27 04:33:42',3310502100,1),(366076340,425805500,14536400,863220,1,'2009-03-27 04:33:42',3310502100,1),(366076341,425804900,14537600,863220,1,'2009-03-27 04:33:42',3310502100,1),(366076342,425804700,14536000,863220,1,'2009-03-27 04:33:42',3310502100,1),(366076343,425804200,14535800,863220,1,'2009-03-27 04:33:43',3310502100,1),(366076344,425804000,14532500,863220,1,'2009-03-27 04:33:43',3310502100,1),(366076345,425802000,14527000,863220,1,'2009-03-27 04:33:43',3310502100,1),(366076346,425798100,14520800,863220,1,'2009-03-27 04:33:43',3310502100,1),(366076347,425797700,14518300,863220,1,'2009-03-27 04:33:43',3310502100,1),(366076348,425797700,14515600,863220,1,'2009-03-27 04:33:43',3310502100,1),(366076349,425798400,14514300,863220,1,'2009-03-27 04:33:43',3310502100,1),(366076350,425797800,14512600,863220,1,'2009-03-27 04:33:43',3310502100,1),(366076351,425798900,14512400,863220,1,'2009-03-27 04:33:43',3310502100,1),(366076352,425799400,14511200,863220,1,'2009-03-27 04:33:43',3310502100,1),(366076353,425799400,14507900,863220,1,'2009-03-27 04:33:43',3310502100,1),(366076354,425800500,14497700,863220,1,'2009-03-27 04:33:43',3310502014,1),(366076355,425800600,14487700,863220,1,'2009-03-27 04:33:43',3310502014,1),(366076356,425801400,14483400,863220,1,'2009-03-27 04:33:43',3310502014,1),(366076357,425802900,14481200,863220,1,'2009-03-27 04:33:43',3310502014,1),(366076358,425804500,14476200,863220,1,'2009-03-27 04:33:43',3310502014,1),(366076359,425803800,14472400,863220,1,'2009-03-27 04:33:43',3310502014,1),(366076360,425804000,14463200,863220,1,'2009-03-27 04:33:43',3310502014,1),(366076361,425802500,14450900,863220,1,'2009-03-27 04:33:43',3310502014,1),(366076362,425802200,14439900,863220,1,'2009-03-27 04:33:43',3310502012,1),(366076363,425801100,14436900,863220,1,'2009-03-27 04:33:43',3310502012,1);
INSERT INTO `nodes` VALUES (366076364,425800600,14432700,863220,1,'2009-03-27 04:33:43',3310502012,1),(366076365,425801100,14424300,863220,1,'2009-03-27 04:33:43',3310502012,1),(366076366,425802000,14417500,863220,1,'2009-03-27 04:33:43',3310502012,1),(366076367,425801500,14411900,863220,1,'2009-03-27 04:33:43',3310502012,1),(366076368,425801500,14406000,863220,1,'2009-03-27 04:33:43',3310502012,1),(366076369,425799700,14394500,863220,1,'2009-03-27 04:33:44',3310502012,1),(366076370,425799400,14383500,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076371,425800000,14379500,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076372,425801600,14376500,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076373,425802200,14374600,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076374,425802200,14373000,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076375,425803700,14370100,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076376,425806900,14367600,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076378,425807100,14366700,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076379,425806600,14364900,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076380,425807900,14354200,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076381,425807500,14350600,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076382,425808200,14348900,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076383,425808300,14346800,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076384,425809100,14345300,863220,1,'2009-03-27 04:33:44',3310502006,1),(366076385,425809200,14342400,863220,1,'2009-03-27 04:33:44',3310502007,1),(366076386,425809900,14339100,863220,1,'2009-03-27 04:33:44',3310502007,1),(366076387,425811500,14338400,863220,1,'2009-03-27 04:33:44',3310502007,1),(366076388,425812900,14338700,863220,1,'2009-03-27 04:33:44',3310502007,1),(366076389,425814500,14335600,863220,1,'2009-03-27 04:33:44',3310502005,1),(366076390,425816100,14331100,863220,1,'2009-03-27 04:33:44',3310502005,1),(366076391,425820100,14324600,863220,1,'2009-03-27 04:33:44',3310502005,1),(366076392,425822000,14331200,863220,1,'2009-03-27 04:33:44',3310502005,1),(366076393,425821700,14332800,863220,1,'2009-03-27 04:33:44',3310502005,1),(366076394,425823700,14335500,863220,1,'2009-03-27 04:33:44',3310502005,1),(366076395,425824700,14335000,863220,1,'2009-03-27 04:33:44',3310502005,1),(366076396,425825700,14337300,863220,1,'2009-03-27 04:33:44',3310502005,1),(366076397,425828900,14341400,863220,1,'2009-03-27 04:33:44',3310502007,1),(366076398,425830900,14340800,863220,1,'2009-03-27 04:33:44',3310502007,1),(366076399,425837300,14346900,863220,1,'2009-03-27 04:33:44',3310502178,1),(366076400,425844700,14351500,863220,1,'2009-03-27 04:33:45',3310502178,1),(366076401,425845100,14353900,863220,1,'2009-03-27 04:33:45',3310502178,1),(366076402,425847700,14361000,863220,1,'2009-03-27 04:33:45',3310502178,1),(366076403,425849600,14360800,863220,1,'2009-03-27 04:33:45',3310502178,1),(366076404,425853500,14363100,863220,1,'2009-03-27 04:33:45',3310502178,1),(366076405,425854500,14362700,863220,1,'2009-03-27 04:33:45',3310502178,1),(366076406,425856700,14363700,863220,1,'2009-03-27 04:33:45',3310502178,1),(366076407,425858700,14366300,863220,1,'2009-03-27 04:33:45',3310502178,1),(366076408,425867100,14370700,863220,1,'2009-03-27 04:33:45',3310502179,1),(366076409,425869900,14374000,863220,1,'2009-03-27 04:33:45',3310502179,1),(366076410,425867600,14381400,863220,1,'2009-03-27 04:33:45',3310502179,1),(366076411,425865400,14386000,863220,1,'2009-03-27 04:33:45',3310502179,1),(366076412,425866800,14393100,863220,1,'2009-03-27 04:33:45',3310502185,1),(366076413,425867800,14393500,863220,1,'2009-03-27 04:33:45',3310502185,1),(366076414,425868800,14394800,863220,1,'2009-03-27 04:33:45',3310502185,1),(366076415,425868800,14396400,863220,1,'2009-03-27 04:33:45',3310502185,1),(366076416,425871300,14397600,863220,1,'2009-03-27 04:33:45',3310502185,1),(366076417,425872500,14401700,863220,1,'2009-03-27 04:33:45',3310502185,1),(366076418,425873700,14402800,863220,1,'2009-03-27 04:33:45',3310502185,1),(366076419,425875400,14407800,863220,1,'2009-03-27 04:33:45',3310502185,1),(366076420,425886400,14423000,863220,1,'2009-03-27 04:33:45',3310502185,1),(366076421,425889100,14425100,863220,1,'2009-03-27 04:33:45',3310502185,1),(366076422,425890200,14426600,863220,1,'2009-03-27 04:33:45',3310502185,1),(366076423,425894400,14428800,863220,1,'2009-03-27 04:33:45',3310502188,1),(366076424,425897700,14431500,863220,1,'2009-03-27 04:33:45',3310502188,1),(366076425,425901700,14433300,863220,1,'2009-03-27 04:33:45',3310502188,1),(366076426,425903000,14433000,863220,1,'2009-03-27 04:33:45',3310502188,1),(366076427,425906000,14435000,863220,1,'2009-03-27 04:33:45',3310502188,1),(366076428,425907200,14435300,863220,1,'2009-03-27 04:33:45',3310502188,1),(366076429,425909600,14434500,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076430,425911300,14434600,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076431,425913100,14435600,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076432,425914800,14434100,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076433,425918200,14436800,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076434,425919300,14434300,863220,1,'2009-03-27 04:33:46',3310502189,1),(366076436,425920500,14432700,863220,1,'2009-03-27 04:33:46',3310502189,1),(366076437,425921400,14432300,863220,1,'2009-03-27 04:33:46',3310502189,1),(366076438,425920800,14431300,863220,1,'2009-03-27 04:33:46',3310502189,1),(366076439,425921200,14428000,863220,1,'2009-03-27 04:33:46',3310502189,1),(366076440,425919900,14421300,863220,1,'2009-03-27 04:33:46',3310502189,1),(366076441,425919400,14420300,863220,1,'2009-03-27 04:33:46',3310502189,1),(366076442,425917200,14419000,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076443,425915900,14417100,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076444,425915400,14414900,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076445,425916100,14411900,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076446,425915600,14408600,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076447,425912500,14401700,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076448,425913400,14397000,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076449,425913242,14393409,863220,1,'2009-03-27 04:33:46',3310502188,1),(366076544,425724900,14843700,863220,1,'2009-03-27 04:34:30',3310502125,1),(366076545,425729500,14841400,863220,1,'2009-03-27 04:34:30',3310502136,1),(366076546,425733600,14841800,863220,1,'2009-03-27 04:34:30',3310502136,1),(366076547,425735300,14842900,863220,1,'2009-03-27 04:34:30',3310502136,1),(366076548,425735600,14843600,863220,1,'2009-03-27 04:34:30',3310502136,1),(366076549,425737800,14843200,863220,1,'2009-03-27 04:34:30',3310502136,1),(366076550,425740700,14844500,863220,1,'2009-03-27 04:34:30',3310502136,1),(366076551,425743200,14844800,863220,1,'2009-03-27 04:34:30',3310502136,1),(366076552,425751000,14843200,863220,1,'2009-03-27 04:34:31',3310502136,1),(366076553,425755600,14843500,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076554,425755400,14842500,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076555,425756400,14844100,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076556,425759100,14846000,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076557,425760900,14845700,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076558,425765600,14841700,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076559,425768800,14851900,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076560,425771000,14854100,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076561,425769900,14858300,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076562,425772000,14858500,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076563,425771800,14864900,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076564,425773100,14864900,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076565,425773900,14865600,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076566,425773700,14867000,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076567,425774600,14869800,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076568,425774700,14869200,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076569,425776100,14869800,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076570,425776400,14871000,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076571,425778500,14869100,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076572,425778900,14866800,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076573,425780500,14865000,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076574,425781500,14862900,863220,1,'2009-03-27 04:34:31',3310502137,1),(366076575,425787200,14861600,863220,1,'2009-03-27 04:34:31',3310502140,1),(366076576,425786800,14862200,863220,1,'2009-03-27 04:34:31',3310502140,1),(366076577,425787300,14861900,863220,1,'2009-03-27 04:34:31',3310502140,1),(366076578,425788800,14863100,863220,1,'2009-03-27 04:34:32',3310502140,1),(366076579,425789300,14864600,863220,1,'2009-03-27 04:34:32',3310502140,1),(366076580,425790700,14865700,863220,1,'2009-03-27 04:34:32',3310502140,1),(366076581,425792300,14868600,863220,1,'2009-03-27 04:34:32',3310502140,1),(366076582,425795000,14871100,863220,1,'2009-03-27 04:34:32',3310502140,1),(366076583,425796000,14874900,863220,1,'2009-03-27 04:34:32',3310502140,1),(366076584,425795500,14876300,863220,1,'2009-03-27 04:34:32',3310502140,1),(366076585,425797100,14881200,863220,1,'2009-03-27 04:34:32',3310502140,1),(366076586,425799400,14882900,863220,1,'2009-03-27 04:34:32',3310502140,1),(366076587,425801800,14882800,863220,1,'2009-03-27 04:34:32',3310502140,1),(366076588,425803700,14884900,863220,1,'2009-03-27 04:34:32',3310502140,1),(366076589,425805400,14888200,863220,1,'2009-03-27 04:34:32',3310502142,1),(366076590,425806200,14888300,863220,1,'2009-03-27 04:34:32',3310502142,1),(366076591,425804800,14891100,863220,1,'2009-03-27 04:34:32',3310502142,1),(366076592,425805800,14892200,863220,1,'2009-03-27 04:34:32',3310502142,1),(366076593,425807100,14892000,863220,1,'2009-03-27 04:34:32',3310502142,1),(366076594,425808300,14892800,863220,1,'2009-03-27 04:34:32',3310502142,1),(366076595,425812600,14890100,863220,1,'2009-03-27 04:34:32',3310502143,1),(366076596,425812200,14888900,863220,1,'2009-03-27 04:34:32',3310502143,1),(366076597,425812600,14887800,863220,1,'2009-03-27 04:34:32',3310502143,1),(366076598,425817000,14883100,863220,1,'2009-03-27 04:34:32',3310502141,1),(366076599,425819200,14881500,863220,1,'2009-03-27 04:34:32',3310502141,1),(366076600,425820100,14876600,863220,1,'2009-03-27 04:34:32',3310502141,1),(366076601,425822500,14873400,863220,1,'2009-03-27 04:34:32',3310502141,1),(366076602,425827200,14870200,863220,1,'2009-03-27 04:34:32',3310502141,1),(366076603,425831400,14869600,863220,1,'2009-03-27 04:34:33',3310502141,1),(366076604,425834600,14867100,863220,1,'2009-03-27 04:34:33',3310502141,1),(366076605,425837200,14865800,863220,1,'2009-03-27 04:34:33',3310502312,1),(366076606,425840300,14867300,863220,1,'2009-03-27 04:34:33',3310502312,1),(366076607,425843100,14866500,863220,1,'2009-03-27 04:34:33',3310502312,1),(366076608,425845700,14863600,863220,1,'2009-03-27 04:34:33',3310502312,1),(366076609,425851200,14853500,863220,1,'2009-03-27 04:34:33',3310502312,1),(366076610,425853400,14851200,863220,1,'2009-03-27 04:34:33',3310502312,1),(366076611,425857900,14849800,863220,1,'2009-03-27 04:34:33',3310502312,1),(366076612,425861900,14847100,863220,1,'2009-03-27 04:34:33',3310502312,1),(366076613,425865800,14845700,863220,1,'2009-03-27 04:34:33',3310502313,1),(366076614,425871900,14844700,863220,1,'2009-03-27 04:34:33',3310502313,1),(366076615,425876100,14843300,863220,1,'2009-03-27 04:34:33',3310502313,1),(366076617,425878700,14839800,863220,1,'2009-03-27 04:34:33',3310502313,1),(366076618,425881700,14837700,863220,1,'2009-03-27 04:34:33',3310502313,1),(366076619,425882800,14834300,863220,1,'2009-03-27 04:34:34',3310502313,1),(366076620,425882000,14830100,863220,1,'2009-03-27 04:34:34',3310502307,1),(366076621,425880200,14825700,863220,1,'2009-03-27 04:34:34',3310502307,1),(366076622,425880000,14823200,863220,1,'2009-03-27 04:34:34',3310502307,1),(366076623,425878700,14820200,863220,1,'2009-03-27 04:34:34',3310502307,1),(366076624,425876000,14815900,863220,1,'2009-03-27 04:34:34',3310502307,1),(366076625,425873700,14807300,863220,1,'2009-03-27 04:34:34',3310502307,1),(366076626,425871600,14803600,863220,1,'2009-03-27 04:34:34',3310502307,1),(366076627,425867200,14798600,863220,1,'2009-03-27 04:34:34',3310502307,1),(366076628,425866600,14796600,863220,1,'2009-03-27 04:34:34',3310502307,1),(366076629,425866900,14796500,863220,1,'2009-03-27 04:34:34',3310502307,1),(366076630,425864800,14791700,863220,1,'2009-03-27 04:34:34',3310502307,1),(366076631,425861600,14786800,863220,1,'2009-03-27 04:34:34',3310502306,1),(366076632,425859700,14779900,863220,1,'2009-03-27 04:34:34',3310502306,1),(366076633,425861600,14769800,863220,1,'2009-03-27 04:34:34',3310502304,1),(366076634,425863400,14765600,863220,1,'2009-03-27 04:34:34',3310502304,1),(366076635,425864600,14761500,863220,1,'2009-03-27 04:34:34',3310502305,1),(366076636,425864200,14758500,863220,1,'2009-03-27 04:34:34',3310502305,1),(366076637,425864500,14754100,863220,1,'2009-03-27 04:34:34',3310502305,1),(366076638,425867700,14746200,863220,1,'2009-03-27 04:34:34',3310502305,1),(366076639,425868500,14742500,863220,1,'2009-03-27 04:34:34',3310502305,1),(366076640,425875800,14736600,863220,1,'2009-03-27 04:34:34',3310502305,1),(366076641,425881300,14721800,863220,1,'2009-03-27 04:34:34',3310502283,1),(366076642,425883500,14714000,863220,1,'2009-03-27 04:34:35',3310502283,1),(366076643,425884500,14708000,863220,1,'2009-03-27 04:34:35',3310502283,1),(366076644,425886100,14704700,863220,1,'2009-03-27 04:34:35',3310502283,1),(366076645,425890200,14701300,863220,1,'2009-03-27 04:34:35',3310502283,1),(366076646,425891100,14699800,863220,1,'2009-03-27 04:34:35',3310502283,1),(366076647,425892400,14696600,863220,1,'2009-03-27 04:34:35',3310502286,1),(366076648,425898000,14686500,863220,1,'2009-03-27 04:34:35',3310502286,1),(366076649,425899800,14682100,863220,1,'2009-03-27 04:34:35',3310502286,1),(366076650,425900800,14677500,863220,1,'2009-03-27 04:34:35',3310502286,1),(366076651,425903900,14668400,863220,1,'2009-03-27 04:34:35',3310502286,1),(366076652,425905800,14660000,863220,1,'2009-03-27 04:34:35',3310502284,1),(366076653,425906100,14658200,863220,1,'2009-03-27 04:34:35',3310502284,1),(366076654,425905600,14653900,863220,1,'2009-03-27 04:34:35',3310502284,1),(366076655,425905900,14650800,863220,1,'2009-03-27 04:34:35',3310502284,1),(366076656,425907500,14648100,863220,1,'2009-03-27 04:34:35',3310502284,1),(366076657,425909000,14643900,863220,1,'2009-03-27 04:34:35',3310502284,1),(366076658,425910300,14638900,863220,1,'2009-03-27 04:34:35',3310502284,1),(366076659,425910100,14635600,863220,1,'2009-03-27 04:34:35',3310502284,1),(366076660,425910600,14633400,863220,1,'2009-03-27 04:34:35',3310502284,1),(366076661,425911800,14630200,863220,1,'2009-03-27 04:34:35',3310502284,1),(366076662,425913400,14628300,863220,1,'2009-03-27 04:34:35',3310502284,1),(366076663,425911600,14623000,863220,1,'2009-03-27 04:34:36',3310502284,1),(366076664,425911000,14622300,863220,1,'2009-03-27 04:34:36',3310502284,1),(366076665,425906100,14623300,863220,1,'2009-03-27 04:34:36',3310502284,1),(366076666,425903200,14622000,863220,1,'2009-03-27 04:34:36',3310502284,1),(366076667,425901300,14620100,863220,1,'2009-03-27 04:34:36',3310502284,1),(366076668,425898400,14615900,863220,1,'2009-03-27 04:34:36',3310502284,1),(366076669,425897500,14616900,863220,1,'2009-03-27 04:34:36',3310502284,1),(366076670,425895800,14621900,863220,1,'2009-03-27 04:34:36',3310502284,1),(366076671,425893100,14627000,863220,1,'2009-03-27 04:34:36',3310502284,1),(366076672,425886800,14632800,863220,1,'2009-03-27 04:34:36',3310502281,1),(366076673,425884700,14635800,863220,1,'2009-03-27 04:34:36',3310502281,1),(366076674,425880000,14639400,863220,1,'2009-03-27 04:34:36',3310502281,1),(366076675,425872200,14647900,863220,1,'2009-03-27 04:34:36',3310502281,1),(366076676,425870500,14657700,863220,1,'2009-03-27 04:34:36',3310502281,1),(366076677,425870300,14664100,863220,1,'2009-03-27 04:34:36',3310502281,1),(366076678,425869700,14667100,863220,1,'2009-03-27 04:34:36',3310502283,1),(366076679,425868700,14668700,863220,1,'2009-03-27 04:34:36',3310502283,1),(366076680,425868300,14671800,863220,1,'2009-03-27 04:34:36',3310502283,1),(366076681,425867100,14673600,863220,1,'2009-03-27 04:34:36',3310502283,1),(366076682,425863900,14675000,863220,1,'2009-03-27 04:34:36',3310502282,1),(366076683,425863700,14679300,863220,1,'2009-03-27 04:34:36',3310502282,1),(366076684,425862700,14682400,863220,1,'2009-03-27 04:34:36',3310502282,1),(366076685,425860200,14687500,863220,1,'2009-03-27 04:34:36',3310502282,1),(366076687,425858100,14696000,863220,1,'2009-03-27 04:34:36',3310502282,1),(366076688,425855500,14700800,863220,1,'2009-03-27 04:34:36',3310502282,1),(366076689,425852400,14704300,863220,1,'2009-03-27 04:34:36',3310502282,1),(366076690,425849700,14708400,863220,1,'2009-03-27 04:34:37',3310502282,1),(366076691,425846300,14708400,863220,1,'2009-03-27 04:34:37',3310502282,1),(366076692,425844800,14707000,863220,1,'2009-03-27 04:34:37',3310502282,1),(366076693,425843400,14707500,863220,1,'2009-03-27 04:34:37',3310502282,1),(366076694,425841200,14709200,863220,1,'2009-03-27 04:34:37',3310502282,1),(366076695,425840400,14711900,863220,1,'2009-03-27 04:34:37',3310502282,1),(366076696,425838400,14714700,863220,1,'2009-03-27 04:34:37',3310502282,1),(366076697,425833700,14718700,863220,1,'2009-03-27 04:34:37',3310502111,1),(366076698,425832200,14721600,863220,1,'2009-03-27 04:34:37',3310502111,1),(366076700,425832000,14719400,863220,1,'2009-03-27 04:34:37',3310502111,1),(366076701,425830700,14719700,863220,1,'2009-03-27 04:34:37',3310502111,1),(366076702,425828800,14721800,863220,1,'2009-03-27 04:34:37',3310502111,1),(366076704,425830700,14712700,863220,1,'2009-03-27 04:34:37',3310502111,1),(366076705,425833000,14706900,863220,1,'2009-03-27 04:34:37',3310502111,1),(366076706,425832700,14699800,863220,1,'2009-03-27 04:34:37',3310502111,1),(366076707,425829600,14705300,863220,1,'2009-03-27 04:34:37',3310502111,1),(366076708,425825400,14709800,863220,1,'2009-03-27 04:34:37',3310502111,1),(366076709,425816300,14716700,863220,1,'2009-03-27 04:34:37',3310502111,1),(366076710,425813300,14722500,863220,1,'2009-03-27 04:34:37',3310502133,1),(366076711,425812000,14728400,863220,1,'2009-03-27 04:34:37',3310502133,1),(366076712,425814000,14735500,863220,1,'2009-03-27 04:34:37',3310502133,1),(366076713,425811600,14743500,863220,1,'2009-03-27 04:34:37',3310502133,1),(366076714,425811400,14747400,863220,1,'2009-03-27 04:34:37',3310502133,1),(366076715,425812100,14752500,863220,1,'2009-03-27 04:34:37',3310502133,1),(366076716,425814300,14761000,863220,1,'2009-03-27 04:34:37',3310502133,1),(366076717,425812600,14767200,863220,1,'2009-03-27 04:34:37',3310502133,1),(366076718,425807000,14780500,863220,1,'2009-03-27 04:34:37',3310502134,1),(366076719,425805300,14790700,863220,1,'2009-03-27 04:34:37',3310502134,1),(366076720,425802600,14794400,863220,1,'2009-03-27 04:34:38',3310502134,1),(366076721,425801300,14794400,863220,1,'2009-03-27 04:34:38',3310502134,1),(366076722,425798700,14786500,863220,1,'2009-03-27 04:34:38',3310502134,1),(366076723,425795400,14786100,863220,1,'2009-03-27 04:34:38',3310502134,1),(366538118,425562200,15718400,864892,1,'2009-03-28 14:31:35',3310502588,1),(366538119,425562300,15722800,864892,1,'2009-03-28 14:31:35',3310502588,1),(366538120,425564200,15722900,864892,1,'2009-03-28 14:31:35',3310502588,1),(366538122,425566300,15723800,864892,1,'2009-03-28 14:31:35',3310502588,1),(366538124,425570500,15729200,864892,1,'2009-03-28 14:31:35',3310502588,1),(366538127,425573100,15731300,864892,1,'2009-03-28 14:31:36',3310502588,1),(366538128,425577600,15733500,864892,1,'2009-03-28 14:31:36',3310502588,1),(366538130,425584100,15733000,864892,1,'2009-03-28 14:31:36',3310502588,1),(366538131,425586400,15731300,864892,1,'2009-03-28 14:31:36',3310502588,1),(366538133,425589200,15730900,864892,1,'2009-03-28 14:31:36',3310502588,1),(366538134,425599500,15726500,864892,1,'2009-03-28 14:31:36',3310502589,1),(366538135,425601700,15724400,864892,1,'2009-03-28 14:31:36',3310502589,1),(366538137,425607200,15721400,864892,1,'2009-03-28 14:31:36',3310502589,1),(366538138,425612000,15721200,864892,1,'2009-03-28 14:31:36',3310502589,1),(366538139,425623500,15708400,864892,1,'2009-03-28 14:31:36',3310502626,1),(366538140,425625200,15705100,864892,1,'2009-03-28 14:31:36',3310502626,1),(366538141,425630300,15699700,864892,1,'2009-03-28 14:31:36',3310502626,1),(366538142,425635500,15691900,864892,1,'2009-03-28 14:31:36',3310502626,1),(366538144,425636400,15688800,864892,1,'2009-03-28 14:31:36',3310502626,1),(366538145,425638200,15686600,864892,1,'2009-03-28 14:31:36',3310502626,1),(366538146,425640400,15685300,864892,1,'2009-03-28 14:31:37',3310502626,1),(366538147,425644700,15683100,864892,1,'2009-03-28 14:31:37',3310502627,1),(366538148,425650600,15682600,864892,1,'2009-03-28 14:31:37',3310502627,1),(366538152,425652800,15682700,864892,1,'2009-03-28 14:31:37',3310502627,1),(366538153,425662000,15679600,864892,1,'2009-03-28 14:31:37',3310502627,1),(366538154,425666400,15677000,864892,1,'2009-03-28 14:31:37',3310502627,1),(366538155,425673700,15677700,864892,1,'2009-03-28 14:31:37',3310502630,1),(366538156,425677900,15676400,864892,1,'2009-03-28 14:31:37',3310502630,1),(366538157,425685500,15672500,864892,1,'2009-03-28 14:31:37',3310502630,1),(366538159,425691100,15668900,864892,1,'2009-03-28 14:31:37',3310502630,1),(366538160,425692200,15667700,864892,1,'2009-03-28 14:31:37',3310502630,1),(366538161,425704400,15660100,864892,1,'2009-03-28 14:31:37',3310502631,1),(366538162,425711400,15658000,864892,1,'2009-03-28 14:31:37',3310502631,1),(366538163,425723500,15656800,864892,1,'2009-03-28 14:31:37',3310502631,1),(366538164,425737800,15657200,864892,1,'2009-03-28 14:31:37',3310502642,1),(366538165,425744400,15660300,864892,1,'2009-03-28 14:31:37',3310502642,1),(366538166,425747900,15663300,864892,1,'2009-03-28 14:31:37',3310502642,1),(366538168,425750500,15664700,864892,1,'2009-03-28 14:31:37',3310502642,1),(366538169,425753000,15664300,864892,1,'2009-03-28 14:31:37',3310502642,1),(366538170,425755000,15666100,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538171,425756200,15666200,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538172,425756900,15665300,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538173,425758100,15666800,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538175,425759200,15666700,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538176,425760200,15665100,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538177,425762100,15663600,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538178,425762800,15664000,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538180,425763000,15667700,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538181,425765500,15666900,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538182,425771600,15669600,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538183,425774400,15666600,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538185,425776200,15669700,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538186,425776900,15669900,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538187,425777600,15668900,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538188,425779000,15669300,864892,1,'2009-03-28 14:31:37',3310502643,1),(366538190,425781000,15668200,864892,1,'2009-03-28 14:31:38',3310502643,1),(366538192,425783200,15666000,864892,1,'2009-03-28 14:31:38',3310502646,1),(366538193,425785700,15664600,864892,1,'2009-03-28 14:31:38',3310502646,1),(366538194,425793000,15662200,864892,1,'2009-03-28 14:31:38',3310502646,1),(366538195,425795100,15661900,864892,1,'2009-03-28 14:31:38',3310502646,1),(366538196,425799900,15662500,864892,1,'2009-03-28 14:31:38',3310502646,1),(366538198,425801300,15664000,864892,1,'2009-03-28 14:31:38',3310502646,1),(366538199,425807700,15664900,864892,1,'2009-03-28 14:31:38',3310502646,1),(366538200,425811200,15664800,864892,1,'2009-03-28 14:31:38',3310502647,1),(366538201,425813300,15664500,864892,1,'2009-03-28 14:31:38',3310502647,1),(366538203,425821000,15659900,864892,1,'2009-03-28 14:31:38',3310502647,1),(366538204,425831700,15655000,864892,1,'2009-03-28 14:31:38',3310502645,1),(366538206,425835300,15655500,864892,1,'2009-03-28 14:31:38',3310502645,1),(366538207,425842100,15654600,864892,1,'2009-03-28 14:31:38',3310502816,1),(366538208,425846000,15655100,864892,1,'2009-03-28 14:31:38',3310502816,1),(366540716,426217621,15595243,864892,1,'2009-03-28 14:44:22',3310502875,1),(366540717,426218632,15603226,864892,1,'2009-03-28 14:44:22',3310502897,1),(366540718,426218884,15612238,864892,1,'2009-03-28 14:44:23',3310502897,1),(366540719,426221916,15623567,864892,1,'2009-03-28 14:44:23',3310502900,1),(366540720,426225074,15635240,864892,1,'2009-03-28 14:44:23',3310502900,1),(366540721,426225579,15646398,864892,1,'2009-03-28 14:44:23',3310502900,1),(366540722,426224700,15656400,864892,1,'2009-03-28 14:44:23',3310502902,1),(366540723,426225500,15672700,864892,1,'2009-03-28 14:44:23',3310502902,1),(366540724,426224000,15681700,864892,1,'2009-03-28 14:44:23',3310502902,1),(366540725,426224900,15689400,864892,1,'2009-03-28 14:44:23',3310502902,1),(366540726,426224500,15694100,864892,1,'2009-03-28 14:44:23',3310502902,1),(366540727,426225300,15696500,864892,1,'2009-03-28 14:44:23',3310502902,1),(366540728,426228100,15701000,864892,1,'2009-03-28 14:44:23',3310502902,1),(366540730,426228300,15704700,864892,1,'2009-03-28 14:44:23',3310502902,1),(366540731,426227700,15706800,864892,1,'2009-03-28 14:44:23',3310502902,1),(366540732,426228300,15709600,864892,1,'2009-03-28 14:44:23',3310502902,1),(366540733,426231600,15713000,864892,1,'2009-03-28 14:44:23',3310502908,1),(366540734,426234100,15718400,864892,1,'2009-03-28 14:44:23',3310502908,1),(366540735,426234100,15719900,864892,1,'2009-03-28 14:44:23',3310502908,1),(366540736,426235800,15727000,864892,1,'2009-03-28 14:44:23',3310502908,1),(366540737,426239700,15731500,864892,1,'2009-03-28 14:44:23',3310502908,1),(366540738,426240800,15734100,864892,1,'2009-03-28 14:44:23',3310502908,1),(366540739,426241200,15739000,864892,1,'2009-03-28 14:44:24',3310502908,1),(366540740,426240600,15743300,864892,1,'2009-03-28 14:44:24',3310502908,1),(366540741,426239700,15745900,864892,1,'2009-03-28 14:44:24',3310502908,1),(366540742,426239500,15749100,864892,1,'2009-03-28 14:44:24',3310502908,1),(366540743,426237800,15754900,864892,1,'2009-03-28 14:44:24',3310502908,1),(366540744,426237600,15757000,864892,1,'2009-03-28 14:44:24',3310502908,1),(366540745,426236900,15758300,864892,1,'2009-03-28 14:44:24',3310502908,1),(366540746,426235400,15766500,864892,1,'2009-03-28 14:44:24',3310502910,1),(366540747,426232000,15768400,864892,1,'2009-03-28 14:44:24',3310502910,1),(366540748,426228500,15768800,864892,1,'2009-03-28 14:44:24',3310502910,1),(366540749,426225100,15770300,864892,1,'2009-03-28 14:44:24',3310502910,1),(366540750,426223000,15770300,864892,1,'2009-03-28 14:44:24',3310502910,1),(366540751,426223000,15773500,864892,1,'2009-03-28 14:44:24',3310502910,1),(366540752,426221700,15775900,864892,1,'2009-03-28 14:44:24',3310502910,1),(366540754,426222300,15777200,864892,1,'2009-03-28 14:44:24',3310502910,1),(366540755,426220600,15781900,864892,1,'2009-03-28 14:44:24',3310502907,1),(366540756,426221300,15782800,864892,1,'2009-03-28 14:44:24',3310502910,1),(366540757,426220400,15782500,864892,1,'2009-03-28 14:44:24',3310502907,1),(366540758,426219700,15783400,864892,1,'2009-03-28 14:44:24',3310502907,1),(366540759,426217600,15787700,864892,1,'2009-03-28 14:44:24',3310502907,1),(366540760,426217400,15789000,864892,1,'2009-03-28 14:44:24',3310502907,1),(366540761,426216700,15789800,864892,1,'2009-03-28 14:44:24',3310502907,1),(366540762,426215200,15794800,864892,1,'2009-03-28 14:44:37',3310502907,2),(366540763,426213300,15796500,864892,1,'2009-03-28 14:44:24',3310502907,1),(366540764,426210700,15797100,864892,1,'2009-03-28 14:44:25',3310502907,1),(366540765,426213300,15800100,864892,1,'2009-03-28 14:44:25',3310502907,1),(366540766,426210700,15804600,864892,1,'2009-03-28 14:44:25',3310502907,1),(366540767,426209000,15809200,864892,1,'2009-03-28 14:44:25',3310502907,1),(366540768,426208800,15811700,864892,1,'2009-03-28 14:44:25',3310502907,1),(366540769,426203700,15822000,864892,1,'2009-03-28 14:44:25',3310504273,1),(366540770,426197600,15830600,864892,1,'2009-03-28 14:44:25',3310504273,1),(366540771,426196600,15834500,864892,1,'2009-03-28 14:44:25',3310504273,1),(366540772,426195500,15835300,864892,1,'2009-03-28 14:44:25',3310504273,1),(366540773,426193100,15838300,864892,1,'2009-03-28 14:44:25',3310504272,1),(366540774,426192700,15839400,864892,1,'2009-03-28 14:44:25',3310504272,1),(366540775,426189700,15842600,864892,1,'2009-03-28 14:44:25',3310504272,1),(366540776,426188900,15845200,864892,1,'2009-03-28 14:44:25',3310504272,1),(366540777,426186500,15861100,864892,1,'2009-03-28 14:44:25',3310504272,1),(366540778,426188200,15864900,864892,1,'2009-03-28 14:44:25',3310504272,1),(366540779,426188400,15868200,864892,1,'2009-03-28 14:44:25',3310504272,1),(366540780,426187600,15869200,864892,1,'2009-03-28 14:44:25',3310504272,1),(366540782,426187800,15871800,864892,1,'2009-03-28 14:44:25',3310504272,1),(366540783,426188200,15872900,864892,1,'2009-03-28 14:44:25',3310504272,1),(366540784,426190600,15875200,864892,1,'2009-03-28 14:44:25',3310504272,1),(366540785,426192700,15878200,864892,1,'2009-03-28 14:44:25',3310504274,1),(366540786,426192900,15881300,864892,1,'2009-03-28 14:44:25',3310504274,1),(366540787,426193400,15882800,864892,1,'2009-03-28 14:44:25',3310504274,1),(366540788,426193100,15884500,864892,1,'2009-03-28 14:44:26',3310504274,1),(366540789,426194400,15890500,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540792,426194900,15892600,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540793,426197200,15902100,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540794,426199600,15907000,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540795,426199400,15911300,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540796,426199800,15912400,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540798,426200400,15913400,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540800,426202800,15914300,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540801,426203700,15914100,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540802,426204300,15915200,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540803,426203700,15917900,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540804,426205600,15917100,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540805,426206400,15917700,864892,1,'2009-03-28 14:44:26',3310504275,1),(366540806,426204900,15920500,864892,1,'2009-03-28 14:44:27',3310504275,1),(366540807,426205600,15921600,864892,1,'2009-03-28 14:44:27',3310504275,1),(366540808,426205600,15922900,864892,1,'2009-03-28 14:44:27',3310504275,1),(366540809,426206900,15925200,864892,1,'2009-03-28 14:44:27',3310504275,1),(366540810,426209700,15925000,864892,1,'2009-03-28 14:44:27',3310504275,1),(366540811,426210100,15926300,864892,1,'2009-03-28 14:44:27',3310504275,1),(366540812,426209400,15927200,864892,1,'2009-03-28 14:44:27',3310504275,1),(366540813,426209200,15928500,864892,1,'2009-03-28 14:44:27',3310504275,1),(366540814,426210100,15928900,864892,1,'2009-03-28 14:44:27',3310504275,1),(366540815,426212200,15928200,864892,1,'2009-03-28 14:44:27',3310504275,1),(366540816,426211800,15930200,864892,1,'2009-03-28 14:44:27',3310504275,1),(366540817,426210100,15932100,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540818,426211000,15932300,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540820,426210500,15933600,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540821,426209700,15934300,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540822,426210700,15934700,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540823,426210500,15936000,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540824,426209700,15936800,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540825,426207900,15941800,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540826,426207100,15942600,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540827,426208200,15944600,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540828,426208600,15947600,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540829,426210300,15951600,864892,1,'2009-03-28 14:44:27',3310504281,1),(366540830,426210500,15952900,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540831,426209700,15957400,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540832,426210100,15958500,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540833,426212000,15960000,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540834,426211400,15962400,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540835,426211800,15964900,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540836,426212900,15965600,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540837,426213500,15966700,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540838,426213100,15969700,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540839,426216300,15970700,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540840,426215500,15973500,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540841,426217600,15973700,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540842,426217800,15975000,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540843,426216700,15979100,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540845,426219700,15980200,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540846,426219700,15981500,864892,1,'2009-03-28 14:44:28',3310504281,1),(366540847,426218200,15987500,864892,1,'2009-03-28 14:44:28',3310504283,1),(366540848,426224300,15993500,864892,1,'2009-03-28 14:44:28',3310504286,1),(366540849,426232600,16005500,864892,1,'2009-03-28 14:44:28',3310504286,1),(366540850,426234300,16000100,864892,1,'2009-03-28 14:44:28',3310504286,1),(366540851,426235400,15998000,864892,1,'2009-03-28 14:44:28',3310504286,1),(366540852,426236300,16000300,864892,1,'2009-03-28 14:44:28',3310504286,1),(366540853,426237300,15998000,864892,1,'2009-03-28 14:44:28',3310504286,1),(366540854,426239100,16001800,864892,1,'2009-03-28 14:44:29',3310504286,1),(366540855,426240100,15998800,864892,1,'2009-03-28 14:44:29',3310504286,1),(366540856,426240800,15998000,864892,1,'2009-03-28 14:44:29',3310504286,1),(366540857,426242700,16005900,864892,1,'2009-03-28 14:44:29',3310504286,1),(366540858,426243400,16007200,864892,1,'2009-03-28 14:44:29',3310504286,1),(366540859,426243800,16006100,864892,1,'2009-03-28 14:44:29',3310504286,1),(366540860,426244600,16006800,864892,1,'2009-03-28 14:44:29',3310504286,1),(366540861,426246100,16012800,864892,1,'2009-03-28 14:44:29',3310504286,1),(366540862,426246100,16014100,864892,1,'2009-03-28 14:44:29',3310504286,1),(366540863,426247200,16016400,864892,1,'2009-03-28 14:44:29',3310504286,1),(366540864,426249100,16010900,864892,1,'2009-03-28 14:44:29',3310504287,1),(366540865,426250200,16013600,864892,1,'2009-03-28 14:44:29',3310504287,1),(366540866,426250200,16015100,864892,1,'2009-03-28 14:44:29',3310504287,1),(366540867,426251100,16014700,864892,1,'2009-03-28 14:44:29',3310504287,1),(366540868,426251500,16013400,864892,1,'2009-03-28 14:44:29',3310504287,1),(366540869,426253400,16020100,864892,1,'2009-03-28 14:44:29',3310504287,1),(366540870,426254300,16020700,864892,1,'2009-03-28 14:44:29',3310504287,1),(366540871,426254900,16023100,864892,1,'2009-03-28 14:44:29',3310504287,1),(366540873,426255800,16024200,864892,1,'2009-03-28 14:44:29',3310504287,1),(366540874,426255200,16026500,864892,1,'2009-03-28 14:44:29',3310504287,1),(366540875,426254900,16030200,864892,1,'2009-03-28 14:44:29',3310504287,1),(366540876,426255200,16031500,864892,1,'2009-03-28 14:44:36',3310504287,2),(366540883,426254700,16030400,864892,1,'2009-03-28 14:44:36',3310504287,1),(366540884,426254700,16026300,864892,1,'2009-03-28 14:44:36',3310504287,1),(366540885,426255600,16025900,864892,1,'2009-03-28 14:44:36',3310504287,1),(366540886,426256200,16021200,864892,1,'2009-03-28 14:44:36',3310504287,1),(366540887,426256700,16008900,864892,1,'2009-03-28 14:44:36',3310504287,1),(366540888,426254900,16003300,864892,1,'2009-03-28 14:44:36',3310504287,1),(366540889,426250200,15993900,864892,1,'2009-03-28 14:44:36',3310504287,1),(366540890,426250400,15992600,864892,1,'2009-03-28 14:44:36',3310504287,1),(366540891,426248100,15989600,864892,1,'2009-03-28 14:44:36',3310504286,1),(366540892,426247900,15988300,864892,1,'2009-03-28 14:44:36',3310504286,1),(366540893,426245900,15983800,864892,1,'2009-03-28 14:44:36',3310504284,1),(366540894,426243600,15980800,864892,1,'2009-03-28 14:44:36',3310504284,1),(366540895,426243600,15979500,864892,1,'2009-03-28 14:44:36',3310504284,1),(366540896,426242900,15978000,864892,1,'2009-03-28 14:44:36',3310504284,1),(366540897,426241400,15977000,864892,1,'2009-03-28 14:44:36',3310504284,1),(366540898,426239500,15973300,864892,1,'2009-03-28 14:44:36',3310504284,1),(366540899,426238600,15972400,864892,1,'2009-03-28 14:44:36',3310504284,1),(366540900,426230500,15971400,864892,1,'2009-03-28 14:44:36',3310504284,1),(366540901,426221500,15967100,864892,1,'2009-03-28 14:44:36',3310504284,1),(366540902,426218700,15964500,864892,1,'2009-03-28 14:44:36',3310504281,1),(366540903,426210300,15948200,864892,1,'2009-03-28 14:44:36',3310504281,1),(366540904,426209700,15929500,864892,1,'2009-03-28 14:44:36',3310504275,1),(366540905,426207700,15925000,864892,1,'2009-03-28 14:44:36',3310504275,1),(366540906,426206200,15923300,864892,1,'2009-03-28 14:44:36',3310504275,1),(366540907,426204500,15919900,864892,1,'2009-03-28 14:44:36',3310504275,1),(366540908,426203700,15917500,864892,1,'2009-03-28 14:44:36',3310504275,1),(366540909,426201300,15904900,864892,1,'2009-03-28 14:44:36',3310504275,1),(366540910,426200900,15899700,864892,1,'2009-03-28 14:44:36',3310504275,1),(366540911,426202600,15882100,864892,1,'2009-03-28 14:44:37',3310504275,1),(366540912,426202200,15875200,864892,1,'2009-03-28 14:44:37',3310504273,1),(366540913,426201500,15869000,864892,1,'2009-03-28 14:44:37',3310504273,1),(366540914,426199800,15862200,864892,1,'2009-03-28 14:44:37',3310504273,1),(366540915,426198300,15847600,864892,1,'2009-03-28 14:44:37',3310504273,1),(366540916,426197400,15843500,864892,1,'2009-03-28 14:44:37',3310504273,1),(366540917,426199200,15835800,864892,1,'2009-03-28 14:44:37',3310504273,1),(366540918,426202800,15825500,864892,1,'2009-03-28 14:44:37',3310504273,1),(366540920,426209700,15813400,864892,1,'2009-03-28 14:44:37',3310502907,1),(366540921,426212000,15807000,864892,1,'2009-03-28 14:44:37',3310502907,1),(366540922,426214200,15803600,864892,1,'2009-03-28 14:44:37',3310502907,1),(366540923,426215500,15803400,864892,1,'2009-03-28 14:44:37',3310502907,1),(366577779,425292990,15456390,327248,1,'2009-04-08 23:29:10',3310491602,4),(366577781,425288270,15452530,327248,1,'2009-04-08 23:29:10',3310491602,4),(366577782,425287630,15450600,327248,1,'2009-04-08 23:29:10',3310491602,4),(366577783,425295350,15447810,327248,1,'2009-04-08 23:29:11',3310491602,4),(366577784,425317450,15431280,327248,1,'2009-04-08 23:29:11',3310491601,4),(366577785,425322390,15422700,327248,1,'2009-04-08 23:29:11',3310491601,4),(366577786,425318740,15414330,327248,1,'2009-04-08 23:29:11',3310491601,4),(366577787,425324960,15398880,327248,1,'2009-04-08 23:29:11',3310491601,4),(366577788,425328180,15394160,327248,1,'2009-04-08 23:29:11',3310491601,4),(366577789,425321960,15389660,327248,1,'2009-04-08 23:29:11',3310491601,4),(366577790,425316810,15380220,327248,1,'2009-04-08 23:29:11',3310491515,4),(366577792,425326250,15370990,327248,1,'2009-04-08 23:29:11',3310491515,4),(366577793,425326680,15361550,327248,1,'2009-04-08 23:29:11',3310491515,4),(366577794,425324540,15359830,327248,1,'2009-04-08 23:29:11',3310491515,4),(366577795,425321960,15360900,327248,1,'2009-04-08 23:29:11',3310491515,4),(366577796,425312300,15367770,327248,1,'2009-04-08 23:29:11',3310491514,4),(366577797,425303290,15364770,327248,1,'2009-04-08 23:29:11',3310491514,4),(366577798,425308870,15357470,327248,1,'2009-04-08 23:29:11',3310491514,4),(366577799,425306300,15354680,327248,1,'2009-04-08 23:29:11',3310491514,4),(366577800,425299860,15355540,327248,1,'2009-04-08 23:29:11',3310491514,4),(366577802,425295780,15347600,327248,1,'2009-04-08 23:29:11',3310491514,4),(366577803,425293640,15346100,327248,1,'2009-04-08 23:29:11',3310491514,4),(366577804,425292130,15341590,327248,1,'2009-04-08 23:29:11',3310491514,4),(366577805,425295350,15318420,327248,1,'2009-04-08 23:29:12',3310491512,4),(366577806,425288920,15294170,327248,1,'2009-04-08 23:29:12',3310491512,4),(366577807,425292130,15285590,327248,1,'2009-04-08 23:29:12',3310491512,4),(366577808,425289340,15279150,327248,1,'2009-04-08 23:29:12',3310491512,4),(366577809,425287840,15278510,327248,1,'2009-04-08 23:29:12',3310491512,4),(366577810,425288270,15264770,327248,1,'2009-04-08 23:29:12',3310491506,4),(366577812,425291920,15255120,327248,1,'2009-04-08 23:29:12',3310491506,4),(366577813,425303290,15257480,327248,1,'2009-04-08 23:29:12',3310491506,4),(366577814,425306730,15261980,327248,1,'2009-04-08 23:29:12',3310491506,4),(366577815,425312950,15286450,327248,1,'2009-04-08 23:29:12',3310491512,4),(366577816,425316170,15281720,327248,1,'2009-04-08 23:29:12',3310491513,4),(366577817,425322180,15275930,327248,1,'2009-04-08 23:29:12',3310491513,4),(366577818,425333111,15269503,327248,1,'2009-04-08 23:29:59',3310491507,5),(366577819,425339340,15264560,327248,1,'2009-04-08 23:29:59',3310491507,5),(366577820,425346772,15262207,327248,1,'2009-04-08 23:29:59',3310491510,5),(366577821,425349896,15261904,327248,1,'2009-04-08 23:30:33',3310491510,9),(366577907,425383760,15493510,864892,1,'2009-03-28 17:17:43',3310491613,3),(366577908,425387620,15496090,864892,1,'2009-03-28 17:17:43',3310491613,3),(366577910,425390620,15495230,864892,1,'2009-03-28 17:17:43',3310491613,3),(366577912,425400070,15486430,864892,1,'2009-03-28 17:17:43',3310502530,3),(366577913,425403070,15487720,864892,1,'2009-03-28 17:17:43',3310502530,3),(366577914,425406930,15497590,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577915,425411220,15502310,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577917,425421520,15505740,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577918,425420880,15507670,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577919,425410150,15508100,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577920,425405430,15505530,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577922,425409290,15510030,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577924,425419590,15514110,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577925,425419380,15516260,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577926,425417880,15516690,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577927,425415090,15514760,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577928,425407580,15514540,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577929,425398140,15507460,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577930,425398140,15509390,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577931,425408010,15519480,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577932,425415090,15522480,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577934,425422380,15531920,864892,1,'2009-03-28 17:17:43',3310502536,3),(366577935,425430110,15532140,864892,1,'2009-03-28 17:17:43',3310502537,3),(366577936,425434610,15528700,864892,1,'2009-03-28 17:17:43',3310502537,3),(366577937,425439980,15521840,864892,1,'2009-03-28 17:17:43',3310502537,3),(366577938,425445130,15518190,864892,1,'2009-03-28 17:17:43',3310502537,3),(366577939,425448130,15509610,864892,1,'2009-03-28 17:17:43',3310502537,3),(366577940,425450490,15508100,864892,1,'2009-03-28 17:17:44',3310502537,3),(366577941,425459930,15505960,864892,1,'2009-03-28 17:17:44',3310502540,3),(366577943,425464010,15503170,864892,1,'2009-03-28 17:17:44',3310502540,3),(366577944,425464440,15504670,864892,1,'2009-03-28 17:17:44',3310502540,3),(366577945,425460580,15509390,864892,1,'2009-03-28 17:17:44',3310502540,3),(366577946,425461220,15509820,864892,1,'2009-03-28 17:17:44',3310502540,3),(366577947,425468090,15505530,864892,1,'2009-03-28 17:17:44',3310502540,3),(366577948,425470880,15502740,864892,1,'2009-03-28 17:17:44',3310502540,3),(366577949,425472160,15494590,864892,1,'2009-03-28 17:17:44',3310502540,3),(366577950,425474310,15498880,864892,1,'2009-03-28 17:17:44',3310502540,3),(366577952,425489330,15494160,864892,1,'2009-03-28 17:17:44',3310502541,3),(366577953,425494910,15495440,864892,1,'2009-03-28 17:17:44',3310502541,3),(366577954,425506070,15515830,864892,1,'2009-03-28 17:17:44',3310502541,3),(366577955,425514220,15521620,864892,1,'2009-03-28 17:17:44',3310502552,3),(366577980,425545760,15710230,864892,1,'2009-03-28 17:18:56',3310502579,4),(366577981,425535890,15710230,864892,1,'2009-03-28 17:18:56',3310502579,4),(366577982,425532250,15709380,864892,1,'2009-03-28 17:18:56',3310502578,4),(366577983,425526880,15705080,864892,1,'2009-03-28 17:18:56',3310502578,4),(366577984,425512080,15705940,864892,1,'2009-03-28 17:18:56',3310502578,4),(366577985,425508430,15702300,864892,1,'2009-03-28 17:18:56',3310502578,4),(366577987,425502420,15712810,864892,1,'2009-03-28 17:18:57',3310502573,4),(366577988,425497060,15713880,864892,1,'2009-03-28 17:18:57',3310502573,4),(366577989,425494690,15712590,864892,1,'2009-03-28 17:18:57',3310502573,4),(366577990,425491050,15705300,864892,1,'2009-03-28 17:18:57',3310502567,4),(366577991,425490620,15700790,864892,1,'2009-03-28 17:18:57',3310502567,4),(366577992,425487830,15698000,864892,1,'2009-03-28 17:18:57',3310502567,4),(366577994,425489540,15687270,864892,1,'2009-03-28 17:18:57',3310502567,4),(366577996,425486110,15689640,864892,1,'2009-03-28 17:18:57',3310502567,4),(366577997,425484180,15688990,864892,1,'2009-03-28 17:18:57',3310502567,4),(366577998,425484820,15681050,864892,1,'2009-03-28 17:18:57',3310502567,4),(366578000,425480530,15671610,864892,1,'2009-03-28 17:18:57',3310502567,4),(366578001,425480530,15663670,864892,1,'2009-03-28 17:18:57',3310502567,4),(366578003,425476880,15662380,864892,1,'2009-03-28 17:18:57',3310502566,4),(366578004,425475600,15660240,864892,1,'2009-03-28 17:18:57',3310502566,4),(366578006,425477100,15651870,864892,1,'2009-03-28 17:18:57',3310502564,4),(366578007,425474100,15638570,864892,1,'2009-03-28 17:18:57',3310502564,4),(366578013,425468090,15639640,864892,1,'2009-03-28 17:18:39',3310502564,4),(366578014,425472380,15636210,864892,1,'2009-03-28 17:18:57',3310502564,6),(366578016,425469590,15630840,864892,1,'2009-03-28 17:18:37',3310502564,4),(366578018,425463800,15611100,864892,1,'2009-03-28 17:18:37',3310502564,4),(366578019,425461650,15607880,864892,1,'2009-03-28 17:18:37',3310502564,4),(366578020,425459070,15606380,864892,1,'2009-03-28 17:18:37',3310502564,4),(366578021,425456930,15601870,864892,1,'2009-03-28 17:18:37',3310502564,4),(366578022,425457790,15600370,864892,1,'2009-03-28 17:18:37',3310502542,4),(366578024,425456710,15597580,864892,1,'2009-03-28 17:18:38',3310502542,4),(366578025,425453070,15594150,864892,1,'2009-03-28 17:18:38',3310502542,4),(366578026,425429030,15591140,864892,1,'2009-03-28 17:18:38',3310502539,4),(366578027,425405000,15581700,864892,1,'2009-03-28 17:18:38',3310502538,4),(366578029,425405000,15570760,864892,1,'2009-03-28 17:18:38',3310502538,4),(366578031,425399640,15568400,864892,1,'2009-03-28 17:18:38',3310502538,4),(366578032,425388910,15555310,864892,1,'2009-03-28 17:18:38',3310491615,4),(366578033,425370450,15538790,864892,1,'2009-03-28 17:18:38',3310491613,4),(366578035,425358220,15535350,864892,1,'2009-03-28 17:18:38',3310491612,4),(366578036,425354790,15525480,864892,1,'2009-03-28 17:18:38',3310491612,4),(366578037,425350930,15526990,864892,1,'2009-03-28 17:18:38',3310491612,4),(366578040,425342990,15518190,864892,1,'2009-03-28 17:18:38',3310491612,4),(366578041,425343420,15516260,864892,1,'2009-03-28 17:18:38',3310491612,4),(366578042,425340630,15511750,864892,1,'2009-03-28 17:18:38',3310491609,4),(366578043,425341490,15511320,864892,1,'2009-03-28 17:18:38',3310491609,4),(366578044,425339340,15504880,864892,1,'2009-03-28 17:18:38',3310491609,4),(366578045,425324750,15486430,864892,1,'2009-03-28 17:18:38',3310491603,4),(366578046,425303510,15470770,864892,1,'2009-03-28 17:18:38',3310491602,4),(366578048,425299430,15473340,864892,1,'2009-03-28 17:18:38',3310491602,4),(366578049,425297710,15478060,864892,1,'2009-03-28 17:18:38',3310491602,4),(366578050,425293210,15476780,864892,1,'2009-03-28 17:18:38',3310491602,4),(366578052,425291060,15472910,864892,1,'2009-03-28 17:18:39',3310491602,4),(366578053,425287410,15470550,864892,1,'2009-03-28 17:18:39',3310491602,4),(366578054,425280025,15473186,864892,1,'2009-03-28 17:18:39',3310491591,6),(366578105,425292221,15459046,327248,1,'2009-04-08 23:29:10',3310491602,4),(366578338,425466575,15638519,864892,1,'2009-03-28 17:18:39',3310502564,1),(367676808,425414241,14408646,216961,1,'2009-04-05 17:52:17',3310501928,2),(367676825,425415595,14408347,216961,1,'2009-04-05 17:52:18',3310501928,2),(367676852,425416696,14407920,216961,1,'2009-04-05 17:52:18',3310501928,2),(367676869,425418175,14407365,216961,1,'2009-04-05 17:52:19',3310501928,2),(367676884,425418962,14407066,216961,1,'2009-04-05 17:52:19',3310501928,2),(367676899,425420158,14407194,216961,1,'2009-04-05 17:52:20',3310501928,2),(367676910,425420977,14407322,216961,1,'2009-04-05 17:52:20',3310501928,2),(367676924,425422267,14407407,216961,1,'2009-04-05 17:52:20',3310501928,2),(367676937,425423369,14407194,216961,1,'2009-04-05 17:52:21',3310501928,2),(367676948,425424376,14406382,216961,1,'2009-04-05 17:52:22',3310501928,2),(367676960,425425540,14405528,216961,1,'2009-04-05 17:52:22',3310501929,2),(367676970,425427177,14405015,216961,1,'2009-04-05 17:52:22',3310501929,2),(367676981,425428719,14404844,216961,1,'2009-04-05 17:52:23',3310501929,2),(367677010,425428940,14403520,870814,1,'2009-03-31 00:46:58',3310501929,1),(367677022,425429317,14402751,870814,1,'2009-03-31 00:46:59',3310501929,1),(367677032,425429632,14402409,870814,1,'2009-03-31 00:46:59',3310501929,1),(367677043,425429569,14401427,870814,1,'2009-03-31 00:47:00',3310501929,1),(367677058,425429726,14400359,870814,1,'2009-03-31 00:47:00',3310501929,1),(367677076,425430010,14399590,870814,1,'2009-03-31 00:47:01',3310501929,1),(367677090,425430356,14398949,870814,1,'2009-03-31 00:47:02',3310501929,1),(367677101,425430828,14398522,870814,1,'2009-03-31 00:47:02',3310501929,1),(367677116,425431206,14398308,870814,1,'2009-03-31 00:47:03',3310501929,1),(367677123,425431961,14398949,870814,1,'2009-03-31 00:47:03',3310501929,1),(367677127,425434133,14399077,870814,1,'2009-03-31 00:47:04',3310501929,1),(367677134,425434542,14399376,870814,1,'2009-03-31 00:47:04',3310501929,1),(367677152,425434825,14399932,870814,1,'2009-03-31 00:47:05',3310501929,1),(367677173,425435767,14400330,870814,1,'2009-03-31 00:47:06',3310501929,1),(367677207,425436774,14401150,870814,1,'2009-03-31 00:47:07',3310501929,1),(367677224,425437318,14401478,870814,1,'2009-03-31 00:47:09',3310501929,1),(367677245,425437821,14401615,870814,1,'2009-03-31 00:47:10',3310501929,1),(367677261,425438164,14401451,870814,1,'2009-03-31 00:47:11',3310501929,1),(367677271,425438567,14400822,870814,1,'2009-03-31 00:47:12',3310501929,1),(367677289,425438829,14400548,870814,1,'2009-03-31 00:47:13',3310501929,1),(367677308,425439191,14400466,870814,1,'2009-03-31 00:47:14',3310501929,1),(367677322,425439614,14400466,870814,1,'2009-03-31 00:47:14',3310501929,1),(367677341,425440581,14401150,870814,1,'2009-03-31 00:47:15',3310501929,1),(367677395,425440883,14401888,870814,1,'2009-03-31 00:47:18',3310501929,1),(367677405,425441085,14402298,870814,1,'2009-03-31 00:47:19',3310501929,1),(367677418,425441407,14402490,870814,1,'2009-03-31 00:47:20',3310501929,1),(367677434,425441910,14402544,870814,1,'2009-03-31 00:47:21',3310501929,1),(367677448,425442615,14402189,870814,1,'2009-03-31 00:47:21',3310501929,1),(367677464,425443139,14401697,870814,1,'2009-03-31 00:47:22',3310501929,1),(367677476,425443401,14401259,870814,1,'2009-03-31 00:47:22',3310501929,1),(367677490,425443663,14401205,870814,1,'2009-03-31 00:47:23',3310501929,1),(367677502,425443925,14401505,870814,1,'2009-03-31 00:47:23',3310501929,1),(367677515,425444610,14401779,870814,1,'2009-03-31 00:47:24',3310501929,1),(367677526,425444992,14401751,870814,1,'2009-03-31 00:47:24',3310501929,1),(367677538,425445234,14401533,870814,1,'2009-03-31 00:47:25',3310501929,1),(367677639,425445375,14401041,870814,1,'2009-03-31 00:47:34',3310501929,1),(367677777,425445536,14400357,870814,1,'2009-03-31 00:47:50',3310501929,1),(367677784,425445738,14399892,870814,1,'2009-03-31 00:47:51',3310501929,1),(367677801,425446080,14399564,870814,1,'2009-03-31 00:47:55',3310501929,1),(367677832,425446584,14399537,870814,1,'2009-03-31 00:47:57',3310501929,1),(367677910,425447168,14399701,870814,1,'2009-03-31 00:48:05',3310501929,1),(367677917,425447691,14399947,870814,1,'2009-03-31 00:48:05',3310501929,1),(367677926,425448155,14400466,870814,1,'2009-03-31 00:48:06',3310501929,1),(367677937,425448457,14401013,870814,1,'2009-03-31 00:48:06',3310501929,1),(367677977,425448759,14401259,870814,1,'2009-03-31 00:48:10',3310501929,1),(367677996,425449242,14401341,870814,1,'2009-03-31 00:48:10',3310501929,1),(367678009,425449746,14401533,870814,1,'2009-03-31 00:48:11',3310501929,1),(367678022,425450733,14401943,870814,1,'2009-03-31 00:48:11',3310501929,1),(367678041,425452264,14402572,870814,1,'2009-03-31 00:48:12',3310501932,1),(367678052,425453472,14402708,870814,1,'2009-03-31 00:48:13',3310501932,1),(367678060,425454661,14402736,870814,1,'2009-03-31 00:48:13',3310501932,1),(367678071,425455225,14402462,870814,1,'2009-03-31 00:48:14',3310501932,1),(367678076,425455688,14402107,870814,1,'2009-03-31 00:48:15',3310501932,1),(367678085,425456433,14402025,870814,1,'2009-03-31 00:48:15',3310501932,1),(367678093,425456594,14402243,870814,1,'2009-03-31 00:48:16',3310501932,1),(367678136,425456735,14402818,870814,1,'2009-03-31 00:48:19',3310501932,1),(367678147,425456876,14403446,870814,1,'2009-03-31 00:48:20',3310501932,1),(367678187,425457400,14403993,870814,1,'2009-03-31 00:48:25',3310501932,1),(367678204,425458125,14404048,870814,1,'2009-03-31 00:48:26',3310501932,1),(367678210,425458629,14404130,870814,1,'2009-03-31 00:48:26',3310501932,1),(367678218,425459374,14404458,870814,1,'2009-03-31 00:48:27',3310501932,1),(367678223,425460703,14405087,870814,1,'2009-03-31 00:48:28',3310501932,1),(367678236,425462275,14405661,870814,1,'2009-03-31 00:48:30',3310501932,1),(367678270,425463523,14405688,870814,1,'2009-03-31 00:48:34',3310501932,1),(367678278,425465336,14405087,870814,1,'2009-03-31 00:48:35',3310501932,1),(367678291,425466666,14404923,870814,1,'2009-03-31 00:48:36',3310501932,1),(367678297,425468579,14405032,870814,1,'2009-03-31 00:48:37',3310501932,1),(367678306,425471419,14405278,870814,1,'2009-03-31 00:48:40',3310501932,1),(367678312,425473292,14405552,870814,1,'2009-03-31 00:48:41',3310501932,1),(367678321,425475367,14405470,870814,1,'2009-03-31 00:48:42',3310501932,1),(367678325,425476938,14405524,870814,1,'2009-03-31 00:48:43',3310501932,1),(367678340,425481288,14406344,870814,1,'2009-03-31 00:48:45',3310501933,1),(367678352,425483947,14406317,870814,1,'2009-03-31 00:48:46',3310501933,1),(367678376,425485699,14406235,870814,1,'2009-03-31 00:48:48',3310501933,1),(367678479,425487875,14406098,870814,1,'2009-03-31 00:49:05',3310501933,1),(367678487,425494159,14406755,870814,1,'2009-03-31 00:49:05',3310501933,1),(367678495,425495367,14406727,870814,1,'2009-03-31 00:49:06',3310501933,1),(367678507,425496415,14406262,870814,1,'2009-03-31 00:49:08',3310501933,1),(367678516,425497522,14405825,870814,1,'2009-03-31 00:49:09',3310501933,1),(367678522,425498308,14405524,870814,1,'2009-03-31 00:49:11',3310501933,1),(367678531,425499879,14404649,870814,1,'2009-03-31 00:49:11',3310501933,1),(367678537,425505800,14400931,870814,1,'2009-03-31 00:49:15',3310501933,1),(367678542,425506344,14400876,870814,1,'2009-03-31 00:49:16',3310501933,1),(367678550,425506888,14401041,870814,1,'2009-03-31 00:49:16',3310501933,1),(367678557,425507250,14401341,870814,1,'2009-03-31 00:49:17',3310501944,1),(367678565,425507714,14402216,870814,1,'2009-03-31 00:49:18',3310501944,1),(367678572,425508016,14403474,870814,1,'2009-03-31 00:49:19',3310501944,1),(367678591,425507975,14404485,870814,1,'2009-03-31 00:49:21',3310501944,1),(367678599,425507855,14405415,870814,1,'2009-03-31 00:49:22',3310501944,1),(367678605,425507573,14406618,870814,1,'2009-03-31 00:49:22',3310501944,1),(367678629,425507069,14407821,870814,1,'2009-03-31 00:49:26',3310501944,1),(367678634,425506566,14408504,870814,1,'2009-03-31 00:49:26',3310501933,1),(367678639,425506062,14409215,870814,1,'2009-03-31 00:49:27',3310501933,1),(367678644,425505579,14409543,870814,1,'2009-03-31 00:49:27',3310501933,1),(367678654,425504813,14409680,870814,1,'2009-03-31 00:49:28',3310501933,1),(367678663,425504411,14409598,870814,1,'2009-03-31 00:49:29',3310501933,1),(367678669,425503867,14409625,870814,1,'2009-03-31 00:49:29',3310501933,1),(367678677,425503242,14409762,870814,1,'2009-03-31 00:49:30',3310501933,1),(367678702,425502235,14410063,870814,1,'2009-03-31 00:49:32',3310501933,1),(367678712,425501148,14410281,870814,1,'2009-03-31 00:49:32',3310501933,1),(367678720,425499959,14410746,870814,1,'2009-03-31 00:49:33',3310501933,1),(367678727,425495569,14412441,870814,1,'2009-03-31 00:49:34',3310501933,1),(367678735,425491178,14414218,870814,1,'2009-03-31 00:49:34',3310501933,1),(367678745,425489567,14414902,870814,1,'2009-03-31 00:49:35',3310501933,1),(367678755,425488076,14415203,870814,1,'2009-03-31 00:49:35',3310501933,1),(367678769,425477099,14416980,870814,1,'2009-03-31 00:49:36',3310501932,1),(367678779,425465417,14419085,870814,1,'2009-03-31 00:49:37',3310501932,1),(367678793,425453271,14421354,870814,1,'2009-03-31 00:49:37',3310501932,1),(367678802,425451740,14421764,870814,1,'2009-03-31 00:49:38',3310501929,1),(367678814,425448396,14422858,870814,1,'2009-03-31 00:49:39',3310501929,1),(367678847,425447389,14423323,870814,1,'2009-03-31 00:49:40',3310501929,1),(367678865,425446745,14423787,870814,1,'2009-03-31 00:49:41',3310501929,1),(367678880,425446503,14424334,870814,1,'2009-03-31 00:49:42',3310501929,1),(367678890,425446342,14424963,870814,1,'2009-03-31 00:49:42',3310501929,1),(367678906,425446443,14425838,870814,1,'2009-03-31 00:49:43',3310501929,1),(367678922,425446805,14426740,870814,1,'2009-03-31 00:49:43',3310501929,1),(367678939,425448960,14431087,870814,1,'2009-03-31 00:49:44',3310501929,1),(367678954,425454197,14441941,870814,1,'2009-03-31 00:49:44',3310501932,1),(367678966,425454399,14442597,870814,1,'2009-03-31 00:49:45',3310501932,1),(367678977,425454399,14443335,870814,1,'2009-03-31 00:49:45',3310501932,1),(367678987,425454278,14443691,870814,1,'2009-03-31 00:49:46',3310501932,1),(367678996,425453895,14443992,870814,1,'2009-03-31 00:49:46',3310501932,1),(367679008,425453351,14444019,870814,1,'2009-03-31 00:49:47',3310501932,1),(367679021,425452485,14443745,870814,1,'2009-03-31 00:49:47',3310501932,1),(367679030,425449827,14442679,870814,1,'2009-03-31 00:49:48',3310501929,1),(367679046,425448920,14442078,870814,1,'2009-03-31 00:49:48',3310501929,1),(367679058,425448074,14441367,870814,1,'2009-03-31 00:49:49',3310501929,1),(367679071,425446584,14439617,870814,1,'2009-03-31 00:49:50',3310501929,1),(367679081,425445677,14438578,870814,1,'2009-03-31 00:49:51',3310501929,1),(367679089,425445174,14438250,870814,1,'2009-03-31 00:49:51',3310501929,1),(367679104,425444670,14438113,870814,1,'2009-03-31 00:49:52',3310501929,1),(367679117,425444227,14438387,870814,1,'2009-03-31 00:49:53',3310501929,1),(367679128,425443824,14439125,870814,1,'2009-03-31 00:49:53',3310501929,1),(367679147,425443784,14439945,870814,1,'2009-03-31 00:49:54',3310501929,1),(367679155,425443945,14440656,870814,1,'2009-03-31 00:49:56',3310501929,1),(367679176,425444388,14441504,870814,1,'2009-03-31 00:49:57',3310501929,1),(367679191,425445194,14442460,870814,1,'2009-03-31 00:49:59',3310501929,1),(367679205,425447289,14444784,870814,1,'2009-03-31 00:49:59',3310501929,1),(367679214,425449988,14448366,870814,1,'2009-03-31 00:50:00',3310501931,1),(367679221,425453090,14453232,870814,1,'2009-03-31 00:50:00',3310501934,1),(367679236,425455164,14457306,870814,1,'2009-03-31 00:50:01',3310501934,1),(367679246,425456957,14461899,870814,1,'2009-03-31 00:50:02',3310501934,1),(367679257,425458931,14467641,870814,1,'2009-03-31 00:50:02',3310501934,1),(367679266,425460139,14470347,870814,1,'2009-03-31 00:50:03',3310501934,1),(367679278,425461288,14472070,870814,1,'2009-03-31 00:50:04',3310501934,1),(367679287,425462174,14472917,870814,1,'2009-03-31 00:50:04',3310501934,1),(367679292,425464309,14474065,870814,1,'2009-03-31 00:50:05',3310501934,1),(367679302,425467894,14475460,870814,1,'2009-03-31 00:50:06',3310501934,1),(367679315,425469344,14476171,870814,1,'2009-03-31 00:50:08',3310501934,1),(367679329,425470956,14477100,870814,1,'2009-03-31 00:50:09',3310501934,1),(367679336,425474722,14480190,870814,1,'2009-03-31 00:50:10',3310501934,1),(367679344,425480765,14484865,870814,1,'2009-03-31 00:50:11',3310501935,1),(367679349,425488902,14490005,870814,1,'2009-03-31 00:50:12',3310501935,1),(367679356,425493835,14494528,870814,1,'2009-03-31 00:50:13',3310501935,1),(367679361,425495822,14496069,870814,1,'2009-03-31 00:50:14',3310501935,1),(367679371,425497893,14497378,870814,1,'2009-03-31 00:50:16',3310501935,1),(367679385,425499352,14497821,870814,1,'2009-03-31 00:50:17',3310501935,1),(367679611,425500213,14497900,870814,1,'2009-03-31 00:50:41',3310501935,1),(367679614,425500666,14497869,870814,1,'2009-03-31 00:50:41',3310501935,1),(367679617,425501212,14497806,870814,1,'2009-03-31 00:50:43',3310501935,1),(367679635,425501863,14497885,870814,1,'2009-03-31 00:50:46',3310501935,1),(367679639,425502189,14498074,870814,1,'2009-03-31 00:50:47',3310501935,1),(367679650,425502433,14498311,870814,1,'2009-03-31 00:50:49',3310501935,1),(367679669,425502537,14498737,870814,1,'2009-03-31 00:50:55',3310501935,1),(367679673,425502595,14499194,870814,1,'2009-03-31 00:50:55',3310501935,1),(367679679,425502526,14499589,870814,1,'2009-03-31 00:50:57',3310501935,1),(367679681,425502340,14499873,870814,1,'2009-03-31 00:50:59',3310501935,1),(367679684,425501991,14500062,870814,1,'2009-03-31 00:51:00',3310501935,1),(367679690,425501735,14500125,870814,1,'2009-03-31 00:51:02',3310501935,1),(367679748,425500898,14500157,870814,1,'2009-03-31 00:51:15',3310501935,1),(367679754,425500247,14500030,870814,1,'2009-03-31 00:51:17',3310501935,1),(367679763,425496435,14499115,870814,1,'2009-03-31 00:51:18',3310501935,1),(367679770,425491820,14498137,870814,1,'2009-03-31 00:51:20',3310501935,1),(367679774,425487624,14497127,870814,1,'2009-03-31 00:51:22',3310501935,1),(367679778,425486880,14497001,870814,1,'2009-03-31 00:51:23',3310501935,1),(367679786,425486055,14496891,870814,1,'2009-03-31 00:51:24',3310501935,1),(367679794,425485102,14496922,870814,1,'2009-03-31 00:51:26',3310501935,1),(367679801,425476523,14497206,870814,1,'2009-03-31 00:51:27',3310501934,1),(367679813,425472513,14497459,870814,1,'2009-03-31 00:51:29',3310501934,1),(367679818,425469235,14497837,870814,1,'2009-03-31 00:51:30',3310501934,1),(367679826,425463620,14498973,870814,1,'2009-03-31 00:51:32',3310501934,1),(367679843,425455820,14501040,870814,1,'2009-03-31 00:51:37',3310501934,1),(367679850,425448648,14503375,870814,1,'2009-03-31 00:51:38',3310502017,1),(367679856,425446370,14504149,870814,1,'2009-03-31 00:51:39',3310502017,1),(367679861,425444859,14504227,870814,1,'2009-03-31 00:51:39',3310502017,1),(367679877,425443801,14503928,870814,1,'2009-03-31 00:51:42',3310502017,1),(367679892,425442894,14503486,870814,1,'2009-03-31 00:51:44',3310502017,1),(367679899,425441406,14502508,870814,1,'2009-03-31 00:51:45',3310502017,1),(367679904,425439662,14500867,870814,1,'2009-03-31 00:51:45',3310501931,1),(367679910,425438163,14499399,870814,1,'2009-03-31 00:51:46',3310501931,1),(367679915,425437442,14498847,870814,1,'2009-03-31 00:51:47',3310501931,1);
INSERT INTO `nodes` VALUES (367679927,425436721,14498405,870814,1,'2009-03-31 00:51:48',3310501931,1),(367679934,425435954,14497758,870814,1,'2009-03-31 00:51:49',3310501931,1),(367679939,425435431,14497064,870814,1,'2009-03-31 00:51:50',3310501931,1),(367679943,425435036,14496433,870814,1,'2009-03-31 00:51:51',3310501931,1),(367679962,425433362,14493230,870814,1,'2009-03-31 00:51:53',3310501931,1),(367679973,425432734,14491258,870814,1,'2009-03-31 00:51:53',3310501931,1),(367679979,425430769,14485136,870814,1,'2009-03-31 00:51:54',3310501931,1),(367679988,425429560,14479755,870814,1,'2009-03-31 00:51:55',3310501931,1),(367679994,425428793,14476363,870814,1,'2009-03-31 00:51:56',3310501931,1),(367680003,425428468,14475700,870814,1,'2009-03-31 00:51:57',3310501931,1),(367680016,425428026,14475085,870814,1,'2009-03-31 00:51:59',3310501931,1),(367680026,425427631,14474817,870814,1,'2009-03-31 00:52:00',3310501931,1),(367680034,425427177,14474612,870814,1,'2009-03-31 00:52:01',3310501931,1),(367680039,425426666,14474596,870814,1,'2009-03-31 00:52:01',3310501931,1),(367680045,425426224,14474817,870814,1,'2009-03-31 00:52:02',3310501931,1),(367680054,425425875,14475085,870814,1,'2009-03-31 00:52:03',3310501931,1),(367680063,425425561,14475448,870814,1,'2009-03-31 00:52:04',3310501931,1),(367680074,425425399,14476048,870814,1,'2009-03-31 00:52:04',3310501931,1),(367680085,425425364,14476631,870814,1,'2009-03-31 00:52:05',3310501931,1),(367680092,425425434,14477326,870814,1,'2009-03-31 00:52:06',3310501931,1),(367680095,425425736,14478115,870814,1,'2009-03-31 00:52:06',3310501931,1),(367680103,425426468,14479519,870814,1,'2009-03-31 00:52:07',3310501931,1),(367680112,425426852,14480323,870814,1,'2009-03-31 00:52:07',3310501931,1),(367680121,425427317,14481507,870814,1,'2009-03-31 00:52:08',3310501931,1),(367680135,425427654,14482927,870814,1,'2009-03-31 00:52:09',3310501931,1),(367680145,425427840,14484615,870814,1,'2009-03-31 00:52:11',3310501931,1),(367680154,425428096,14489143,870814,1,'2009-03-31 00:52:12',3310501931,1),(367680180,425428514,14492867,870814,1,'2009-03-31 00:52:16',3310501931,1),(367680191,425429026,14496054,870814,1,'2009-03-31 00:52:18',3310501931,1),(367680197,425430235,14501482,870814,1,'2009-03-31 00:52:19',3310501931,1),(367680206,425431664,14505868,870814,1,'2009-03-31 00:52:19',3310502017,1),(367680220,425434257,14511848,870814,1,'2009-03-31 00:52:21',3310502017,1),(367680228,425435419,14514010,870814,1,'2009-03-31 00:52:22',3310502017,1),(367680235,425437233,14516377,870814,1,'2009-03-31 00:52:23',3310502017,1),(367680239,425437965,14517734,870814,1,'2009-03-31 00:52:23',3310502017,1),(367680244,425438837,14519201,870814,1,'2009-03-31 00:52:24',3310502017,1),(367680258,425440127,14520574,870814,1,'2009-03-31 00:52:24',3310502017,1),(367680266,425440732,14521347,870814,1,'2009-03-31 00:52:25',3310502017,1),(367680270,425441278,14522688,870814,1,'2009-03-31 00:52:26',3310502017,1),(367680273,425443347,14527532,870814,1,'2009-03-31 00:52:30',3310502017,1),(367680291,425444219,14530403,870814,1,'2009-03-31 00:52:33',3310502017,1),(367680297,425445068,14532013,870814,1,'2009-03-31 00:52:34',3310502017,1),(367680427,425446637,14535342,870814,1,'2009-03-31 00:52:56',3310502017,1),(367680434,425446593,14533951,870814,1,'2009-03-31 00:52:59',3310502017,1),(367680440,425445051,14533714,870814,1,'2009-03-31 00:53:01',3310502017,1),(367680443,425444686,14535181,870814,1,'2009-03-31 00:53:01',3310502017,1),(367680445,425444368,14535699,870814,1,'2009-03-31 00:53:02',3310502017,1),(367680449,425443382,14536864,870814,1,'2009-03-31 00:53:02',3310502017,1),(367680460,425442174,14537856,870814,1,'2009-03-31 00:53:03',3310502017,1),(367680463,425441571,14538395,870814,1,'2009-03-31 00:53:04',3310502017,1),(367680466,425441110,14538503,870814,1,'2009-03-31 00:53:04',3310502017,1),(367680470,425440744,14538374,870814,1,'2009-03-31 00:53:04',3310502017,1),(367680475,425440267,14537662,870814,1,'2009-03-31 00:53:04',3310502017,1),(367680481,425439806,14537360,870814,1,'2009-03-31 00:53:05',3310502017,1),(367680486,425439266,14537317,870814,1,'2009-03-31 00:53:05',3310502017,1),(367680498,425438678,14537511,870814,1,'2009-03-31 00:53:06',3310502017,1),(367680503,425438185,14537899,870814,1,'2009-03-31 00:53:07',3310502017,1),(367680513,425437661,14538503,870814,1,'2009-03-31 00:53:08',3310502017,1),(367680522,425437375,14539150,870814,1,'2009-03-31 00:53:09',3310502017,1),(367680528,425436882,14540229,870814,1,'2009-03-31 00:53:10',3310502017,1),(367680536,425436516,14540984,870814,1,'2009-03-31 00:53:11',3310502017,1),(367680577,425436214,14542322,870814,1,'2009-03-31 00:53:17',3310502017,1),(367680583,425435785,14543508,870814,1,'2009-03-31 00:53:17',3310502017,1),(367680601,425434323,14545665,870814,1,'2009-03-31 00:53:20',3310502017,1),(367680690,425433751,14546442,870814,1,'2009-03-31 00:53:40',3310502017,1),(367680699,425433179,14546960,870814,1,'2009-03-31 00:53:41',3310502017,1),(367680708,425432400,14547348,870814,1,'2009-03-31 00:53:42',3310502017,1),(367680716,425431160,14547564,870814,1,'2009-03-31 00:53:43',3310502017,1),(367680726,425430270,14547650,870814,1,'2009-03-31 00:53:44',3310502017,1),(367680747,425429634,14547866,870814,1,'2009-03-31 00:53:46',3310502017,1),(367680753,425428426,14548535,870814,1,'2009-03-31 00:53:47',3310502017,1),(367680901,425427457,14549225,870814,1,'2009-03-31 00:53:58',3310502017,1),(367680914,425426185,14550066,870814,1,'2009-03-31 00:53:59',3310502017,1),(367680923,425424675,14550713,870814,1,'2009-03-31 00:54:00',3310502017,1),(367680933,425423261,14551102,870814,1,'2009-03-31 00:54:01',3310502016,1),(367680940,425422275,14551166,870814,1,'2009-03-31 00:54:02',3310502016,1),(367680947,425421178,14551318,870814,1,'2009-03-31 00:54:04',3310502016,1),(367680956,425419557,14551598,870814,1,'2009-03-31 00:54:05',3310502016,1),(367680960,425417618,14551749,870814,1,'2009-03-31 00:54:05',3310502016,1),(367680964,425417014,14551943,870814,1,'2009-03-31 00:54:06',3310502016,1),(367680970,425416505,14552353,870814,1,'2009-03-31 00:54:07',3310502016,1),(367680975,425415711,14553173,870814,1,'2009-03-31 00:54:07',3310502016,1),(367680978,425415361,14553518,870814,1,'2009-03-31 00:54:08',3310502016,1),(367680983,425415075,14553712,870814,1,'2009-03-31 00:54:08',3310502016,1),(367680990,425414550,14553820,870814,1,'2009-03-31 00:54:09',3310502016,1),(367681000,425413470,14554295,870814,1,'2009-03-31 00:54:10',3310502016,1),(367681004,425411626,14554877,870814,1,'2009-03-31 00:54:10',3310502016,1),(367681008,425410529,14555395,870814,1,'2009-03-31 00:54:11',3310502016,1),(367681012,425410005,14555632,870814,1,'2009-03-31 00:54:12',3310502016,1),(367681029,425409321,14556409,870814,1,'2009-03-31 00:54:18',3310502016,1),(367681033,425406619,14558523,870814,1,'2009-03-31 00:54:18',3310502018,1),(367681059,425406158,14559041,870814,1,'2009-03-31 00:54:24',3310502018,1),(367681064,425405030,14560486,870814,1,'2009-03-31 00:54:25',3310502018,1),(367681082,425403424,14563161,870814,1,'2009-03-31 00:54:32',3310502018,1),(367681083,425402645,14564196,870814,1,'2009-03-31 00:54:33',3310502018,1),(367681084,425400452,14563916,870814,1,'2009-03-31 00:54:34',3310502018,1),(367681087,425399752,14563377,870814,1,'2009-03-31 00:54:34',3310502018,1),(367681092,425398703,14562924,870814,1,'2009-03-31 00:54:35',3310502018,1),(367681096,425396891,14561759,870814,1,'2009-03-31 00:54:37',3310491095,1),(367681118,425395938,14560853,870814,1,'2009-03-31 00:54:41',3310491095,1),(367681124,425395000,14560205,870814,1,'2009-03-31 00:54:42',3310491095,1),(367681129,425394046,14559688,870814,1,'2009-03-31 00:54:42',3310491095,1),(367681130,425392775,14559019,870814,1,'2009-03-31 00:54:43',3310491095,1),(367681143,425392266,14558717,870814,1,'2009-03-31 00:54:45',3310491095,1),(367681147,425391694,14558739,870814,1,'2009-03-31 00:54:45',3310491095,1),(367681150,425390740,14558890,870814,1,'2009-03-31 00:54:46',3310491095,1),(367681156,425389198,14559041,870814,1,'2009-03-31 00:54:47',3310491095,1),(367681162,425387005,14559494,870814,1,'2009-03-31 00:54:48',3310491095,1),(367681174,425384382,14559774,870814,1,'2009-03-31 00:54:49',3310491095,1),(367681183,425383253,14559990,870814,1,'2009-03-31 00:54:50',3310491095,1),(367681190,425382745,14560270,870814,1,'2009-03-31 00:54:52',3310491095,1),(367681198,425382252,14560551,870814,1,'2009-03-31 00:54:53',3310491095,1),(367681204,425381743,14560723,870814,1,'2009-03-31 00:54:54',3310491095,1),(367681212,425380805,14560917,870814,1,'2009-03-31 00:54:54',3310491095,1),(367681216,425379566,14560788,870814,1,'2009-03-31 00:54:55',3310491095,1),(367681225,425378962,14560961,870814,1,'2009-03-31 00:54:56',3310491095,1),(367681230,425378389,14561219,870814,1,'2009-03-31 00:54:57',3310491095,1),(367681236,425377324,14561867,870814,1,'2009-03-31 00:54:57',3310491095,1),(367681256,425376927,14562233,870814,1,'2009-03-31 00:55:01',3310491095,1),(367681261,425375035,14564218,870814,1,'2009-03-31 00:55:02',3310491095,1),(367681429,425372842,14566009,870814,1,'2009-03-31 00:55:26',3310491095,1),(367681439,425370553,14567670,870814,1,'2009-03-31 00:55:27',3310491095,1),(367681447,425370092,14568015,870814,1,'2009-03-31 00:55:29',3310491095,1),(367681453,425369520,14568274,870814,1,'2009-03-31 00:55:30',3310491094,1),(367681456,425368327,14568597,870814,1,'2009-03-31 00:55:30',3310491094,1),(367681461,425367930,14568640,870814,1,'2009-03-31 00:55:31',3310491094,1),(367681465,425367437,14568576,870814,1,'2009-03-31 00:55:32',3310491094,1),(367681477,425366340,14567907,870814,1,'2009-03-31 00:55:33',3310491094,1),(367681482,425365768,14567626,870814,1,'2009-03-31 00:55:34',3310491094,1),(367681490,425365260,14567648,870814,1,'2009-03-31 00:55:35',3310491094,1),(367681497,425364656,14567777,870814,1,'2009-03-31 00:55:36',3310491094,1),(367681504,425364020,14568166,870814,1,'2009-03-31 00:55:37',3310491094,1),(367681514,425362986,14568640,870814,1,'2009-03-31 00:55:38',3310491094,1),(367681521,425361921,14569309,870814,1,'2009-03-31 00:55:38',3310491094,1),(367681533,425360618,14570301,870814,1,'2009-03-31 00:55:39',3310491094,1),(367681539,425360077,14570755,870814,1,'2009-03-31 00:55:39',3310491094,1),(367681545,425359648,14571121,870814,1,'2009-03-31 00:55:40',3310491094,1),(367681552,425359394,14571574,870814,1,'2009-03-31 00:55:40',3310491094,1),(367681555,425358949,14571919,870814,1,'2009-03-31 00:55:40',3310491094,1),(367681560,425358520,14572006,870814,1,'2009-03-31 00:55:41',3310491094,1),(367681574,425357486,14571682,870814,1,'2009-03-31 00:55:43',3310491094,1),(367681579,425356077,14571236,870814,1,'2009-03-31 00:55:43',3310491094,1),(367681584,425355505,14571167,870814,1,'2009-03-31 00:55:43',3310491094,1),(367681590,425354883,14570733,870814,1,'2009-03-31 00:55:44',3310491094,1),(367681596,425352425,14569500,870814,1,'2009-03-31 00:55:44',3310491094,1),(367681601,425351432,14568860,870814,1,'2009-03-31 00:55:45',3310491094,1),(367681607,425350810,14568655,870814,1,'2009-03-31 00:55:45',3310491094,1),(367681613,425350221,14568563,870814,1,'2009-03-31 00:55:46',3310491094,1),(367681617,425348992,14568677,870814,1,'2009-03-31 00:55:47',3310491094,1),(367681624,425348049,14568723,870814,1,'2009-03-31 00:55:47',3310491094,1),(367681630,425346434,14569203,870814,1,'2009-03-31 00:55:48',3310491094,1),(367681635,425345474,14569385,870814,1,'2009-03-31 00:55:48',3310491094,1),(367681640,425344313,14569614,870814,1,'2009-03-31 00:55:49',3310491094,1),(367681644,425343371,14569979,870814,1,'2009-03-31 00:55:49',3310491094,1),(367681647,425342866,14570413,870814,1,'2009-03-31 00:55:50',3310491094,1),(367681651,425342681,14570824,870814,1,'2009-03-31 00:55:50',3310491094,1),(367681655,425342428,14571555,870814,1,'2009-03-31 00:55:51',3310491094,1),(367681663,425342277,14572880,870814,1,'2009-03-31 00:55:52',3310491094,1),(367681671,425342226,14575667,870814,1,'2009-03-31 00:55:53',3310491094,1),(367681676,425342176,14577722,870814,1,'2009-03-31 00:55:53',3310491091,1),(367681681,425342226,14578659,870814,1,'2009-03-31 00:55:53',3310491094,1),(367681687,425342361,14579709,870814,1,'2009-03-31 00:55:54',3310491094,1),(367681691,425342411,14580760,870814,1,'2009-03-31 00:55:54',3310491094,1),(367681694,425342327,14581719,870814,1,'2009-03-31 00:55:54',3310491094,1),(367681697,425342108,14583250,870814,1,'2009-03-31 00:55:55',3310491091,1),(367681701,425341738,14584871,870814,1,'2009-03-31 00:55:55',3310491091,1),(367681708,425341351,14586036,870814,1,'2009-03-31 00:55:58',3310491091,1),(367681722,425340947,14587018,870814,1,'2009-03-31 00:56:00',3310491091,1),(367681730,425340408,14588069,870814,1,'2009-03-31 00:56:00',3310491091,1),(367681735,425339954,14588823,870814,1,'2009-03-31 00:56:02',3310491091,1),(367681739,425339415,14589622,870814,1,'2009-03-31 00:56:03',3310491091,1),(367681745,425338523,14590581,870814,1,'2009-03-31 00:56:03',3310491091,1),(367681753,425337783,14591107,870814,1,'2009-03-31 00:56:04',3310491091,1),(367681758,425336706,14591723,870814,1,'2009-03-31 00:56:04',3310491091,1),(367681766,425335679,14592157,870814,1,'2009-03-31 00:56:05',3310491091,1),(367681773,425333895,14592843,870814,1,'2009-03-31 00:56:05',3310491091,1),(367681779,425331943,14593733,870814,1,'2009-03-31 00:56:06',3310491091,1),(367681894,425330815,14594350,870814,1,'2009-03-31 00:56:22',3310491091,1),(367681900,425329502,14595355,870814,1,'2009-03-31 00:56:22',3310491091,1),(367681907,425328644,14596360,870814,1,'2009-03-31 00:56:23',3310491091,1),(367681915,425327634,14597936,870814,1,'2009-03-31 00:56:24',3310491091,1),(367681939,425327297,14598598,870814,1,'2009-03-31 00:56:25',3310491091,1),(367681946,425326826,14599329,870814,1,'2009-03-31 00:56:26',3310491091,1),(367681956,425326170,14599969,870814,1,'2009-03-31 00:56:27',3310491091,1),(367681967,425325682,14600631,870814,1,'2009-03-31 00:56:27',3310491091,1),(367681972,425324722,14601956,870814,1,'2009-03-31 00:56:27',3310491091,1),(367681980,425322837,14605199,870814,1,'2009-03-31 00:56:28',3310491091,1),(367681989,425321356,14607803,870814,1,'2009-03-31 00:56:28',3310491091,1),(367681997,425320582,14608739,870814,1,'2009-03-31 00:56:28',3310491091,1),(367682006,425320043,14609333,870814,1,'2009-03-31 00:56:29',3310491091,1),(367682014,425319404,14609904,870814,1,'2009-03-31 00:56:29',3310491091,1),(367682022,425318394,14610475,870814,1,'2009-03-31 00:56:29',3310491091,1),(367682032,425317771,14610704,870814,1,'2009-03-31 00:56:30',3310491091,1),(367682040,425316037,14611092,870814,1,'2009-03-31 00:56:30',3310491091,1),(367682054,425314842,14611389,870814,1,'2009-03-31 00:56:33',3310491091,1),(367682060,425313917,14611846,870814,1,'2009-03-31 00:56:34',3310491090,1),(367682068,425311931,14613170,870814,1,'2009-03-31 00:56:34',3310491096,1),(367682073,425309860,14614244,870814,1,'2009-03-31 00:56:34',3310491096,1),(367682101,425308110,14615295,870814,1,'2009-03-31 00:56:36',3310491096,1),(367682111,425307083,14616163,870814,1,'2009-03-31 00:56:37',3310491096,1),(367682123,425306418,14616824,870814,1,'2009-03-31 00:56:38',3310491096,1),(367682130,425305332,14618051,870814,1,'2009-03-31 00:56:38',3310491096,1),(367682139,425304273,14619177,870814,1,'2009-03-31 00:56:39',3310491096,1),(367682148,425303193,14620229,870814,1,'2009-03-31 00:56:39',3310491096,1),(367682156,425302890,14620605,870814,1,'2009-03-31 00:56:40',3310491096,1),(367682164,425302633,14621071,870814,1,'2009-03-31 00:56:40',3310491096,1),(367682172,425302175,14622033,870814,1,'2009-03-31 00:56:41',3310491096,1),(367682183,425301669,14623195,870814,1,'2009-03-31 00:56:42',3310491096,1),(367682193,425300879,14624742,870814,1,'2009-03-31 00:56:42',3310491096,1),(367682230,425300718,14625053,870814,1,'2009-03-31 00:56:44',3310491096,1),(367682241,425300495,14625365,870814,1,'2009-03-31 00:56:44',3310491096,1),(367682252,425300151,14625694,870814,1,'2009-03-31 00:56:44',3310491096,1),(367682263,425299949,14626024,870814,1,'2009-03-31 00:56:45',3310491096,1),(367682269,425299355,14627204,870814,1,'2009-03-31 00:56:45',3310491096,1),(367682279,425298606,14629044,870814,1,'2009-03-31 00:56:45',3310491096,1),(367682505,425298343,14629786,870814,1,'2009-03-31 00:56:56',3310491096,1),(367682512,425298147,14630216,870814,1,'2009-03-31 00:56:57',3310491096,1),(367682529,425297399,14631415,870814,1,'2009-03-31 00:56:57',3310491096,1),(367682541,425293587,14637274,870814,1,'2009-03-31 00:56:58',3310491096,1),(367682547,425292623,14638711,870814,1,'2009-03-31 00:56:58',3310491096,1),(367682550,425292488,14638949,870814,1,'2009-03-31 00:56:58',3310491096,1),(367682554,425291955,14640120,870814,1,'2009-03-31 00:56:58',3310491096,1),(367682560,425291577,14641091,870814,1,'2009-03-31 00:56:59',3310491096,1),(367682567,425291449,14641539,870814,1,'2009-03-31 00:56:59',3310491096,1),(367682571,425290565,14645485,870814,1,'2009-03-31 00:56:59',3310491096,1),(367682574,425290329,14646281,870814,1,'2009-03-31 00:56:59',3310491096,1),(367682578,425290073,14647105,870814,1,'2009-03-31 00:57:00',3310491096,1),(367682582,425288919,14649814,870814,1,'2009-03-31 00:57:00',3310491096,1),(367682587,425288015,14651929,870814,1,'2009-03-31 00:57:00',3310491096,1),(367682591,425286882,14655142,870814,1,'2009-03-31 00:57:00',3310491085,1),(367682595,425286788,14655535,870814,1,'2009-03-31 00:57:01',3310491085,1),(367682600,425286653,14656240,870814,1,'2009-03-31 00:57:02',3310491085,1),(367682607,425286552,14657568,870814,1,'2009-03-31 00:57:02',3310491085,1),(367682612,425286525,14658602,870814,1,'2009-03-31 00:57:02',3310491085,1),(367682618,425286464,14659288,870814,1,'2009-03-31 00:57:03',3310491085,1),(367682624,425286342,14660030,870814,1,'2009-03-31 00:57:03',3310491085,1),(367682629,425286127,14660900,870814,1,'2009-03-31 00:57:03',3310491085,1),(367682636,425285911,14661559,870814,1,'2009-03-31 00:57:03',3310491085,1),(367682639,425285506,14662428,870814,1,'2009-03-31 00:57:04',3310491085,1),(367682645,425282781,14667060,870814,1,'2009-03-31 00:57:04',3310491087,1),(367682650,425282551,14667463,870814,1,'2009-03-31 00:57:04',3310491087,1),(367682653,425282201,14668360,870814,1,'2009-03-31 00:57:05',3310491087,1),(367682657,425282072,14668671,870814,1,'2009-03-31 00:57:05',3310491087,1),(367682670,425281971,14668982,870814,1,'2009-03-31 00:57:07',3310491087,1),(367682675,425281917,14669358,870814,1,'2009-03-31 00:57:07',3310491087,1),(367682678,425281843,14670136,870814,1,'2009-03-31 00:57:08',3310491087,1),(367682684,425281877,14670419,870814,1,'2009-03-31 00:57:08',3310491087,1),(367682688,425282005,14670767,870814,1,'2009-03-31 00:57:08',3310491087,1),(367682691,425282201,14671298,870814,1,'2009-03-31 00:57:08',3310491087,1),(367682694,425282369,14671930,870814,1,'2009-03-31 00:57:09',3310491087,1),(367682698,425282679,14673513,870814,1,'2009-03-31 00:57:09',3310491087,1),(367682700,425282929,14675326,870814,1,'2009-03-31 00:57:09',3310491087,1),(367682704,425283583,14680324,870814,1,'2009-03-31 00:57:09',3310491087,1),(367682708,425283698,14681660,870814,1,'2009-03-31 00:57:09',3310491087,1),(367682711,425283786,14684324,870814,1,'2009-03-31 00:57:10',3310491087,1),(367682716,425283894,14686503,870814,1,'2009-03-31 00:57:10',3310491087,1),(367682724,425284157,14688535,870814,1,'2009-03-31 00:57:10',3310491087,1),(367682732,425284589,14690787,870814,1,'2009-03-31 00:57:10',3310491087,1),(367682739,425285452,14693478,870814,1,'2009-03-31 00:57:11',3310491087,1),(367682743,425286464,14695940,870814,1,'2009-03-31 00:57:12',3310491087,1),(367682748,425288521,14700462,870814,1,'2009-03-31 00:57:12',3310491098,1),(367682754,425289290,14702439,870814,1,'2009-03-31 00:57:13',3310491098,1),(367682760,425289844,14704234,870814,1,'2009-03-31 00:57:13',3310491098,1),(367682767,425290376,14706861,870814,1,'2009-03-31 00:57:13',3310491098,1),(367682772,425290768,14709323,870814,1,'2009-03-31 00:57:14',3310491098,1),(367682777,425291496,14712637,870814,1,'2009-03-31 00:57:14',3310491098,1),(367682784,425292259,14715099,870814,1,'2009-03-31 00:57:15',3310491098,1),(367682789,425293034,14717195,870814,1,'2009-03-31 00:57:15',3310491098,1),(367682795,425296616,14724152,870814,1,'2009-03-31 00:57:15',3310491120,1),(367682800,425297405,14725965,870814,1,'2009-03-31 00:57:16',3310491120,1),(367682806,425298282,14728647,870814,1,'2009-03-31 00:57:17',3310491120,1),(367682813,425298856,14730844,870814,1,'2009-03-31 00:57:18',3310491120,1),(367682819,425299982,14734780,870814,1,'2009-03-31 00:57:18',3310491120,1),(367682825,425301399,14739119,870814,1,'2009-03-31 00:57:18',3310491120,1),(367682830,425302242,14741215,870814,1,'2009-03-31 00:57:19',3310491120,1),(367682837,425302998,14742570,870814,1,'2009-03-31 00:57:20',3310491120,1),(367682842,425305136,14745444,870814,1,'2009-03-31 00:57:21',3310491120,1),(367682845,425305804,14746469,870814,1,'2009-03-31 00:57:22',3310491120,1),(367682852,425306451,14747815,870814,1,'2009-03-31 00:57:22',3310491120,1),(367682859,425307031,14749353,870814,1,'2009-03-31 00:57:23',3310491120,1),(367682865,425308003,14751733,870814,1,'2009-03-31 00:57:23',3310491120,1),(367682873,425309008,14753829,870814,1,'2009-03-31 00:57:23',3310491120,1),(367682879,425311220,14757957,870814,1,'2009-03-31 00:57:24',3310491120,1),(367682885,425311564,14758799,870814,1,'2009-03-31 00:57:24',3310491120,1),(367682891,425311801,14759532,870814,1,'2009-03-31 00:57:24',3310491120,1),(367682900,425311989,14760429,870814,1,'2009-03-31 00:57:25',3310491120,1),(367682906,425312354,14762690,870814,1,'2009-03-31 00:57:25',3310491120,1),(367682911,425312860,14766104,870814,1,'2009-03-31 00:57:25',3310491120,1),(367682916,425313588,14769765,870814,1,'2009-03-31 00:57:26',3310491120,1),(367682920,425315248,14777885,870814,1,'2009-03-31 00:57:26',3310491123,1),(367682927,425315990,14781537,870814,1,'2009-03-31 00:57:27',3310491123,1),(367682932,425316273,14782544,870814,1,'2009-03-31 00:57:28',3310491123,1),(367682940,425316900,14784247,870814,1,'2009-03-31 00:57:28',3310491123,1),(367682947,425317467,14785721,870814,1,'2009-03-31 00:57:29',3310491123,1),(367682953,425317777,14786709,870814,1,'2009-03-31 00:57:29',3310491123,1),(367682961,425318013,14787588,870814,1,'2009-03-31 00:57:30',3310491123,1),(367682968,425318141,14788366,870814,1,'2009-03-31 00:57:31',3310491123,1),(367682978,425318724,14793612,870814,1,'2009-03-31 00:57:32',3310491123,1),(367682985,425318891,14795038,870814,1,'2009-03-31 00:57:32',3310491123,1),(367682989,425319152,14796565,870814,1,'2009-03-31 00:57:33',3310491123,1),(367682996,425319487,14797991,870814,1,'2009-03-31 00:57:33',3310491123,1),(367683000,425320249,14800817,870814,1,'2009-03-31 00:57:34',3310491123,1),(367683005,425320919,14803114,870814,1,'2009-03-31 00:57:34',3310491123,1),(367683011,425321942,14807102,870814,1,'2009-03-31 00:57:34',3310491123,1),(367683017,425322286,14808742,870814,1,'2009-03-31 00:57:35',3310491123,1),(367683026,425323039,14812288,870814,1,'2009-03-31 00:57:35',3310491123,1),(367683034,425323941,14815986,870814,1,'2009-03-31 00:57:37',3310491123,1),(367683042,425325168,14821702,870814,1,'2009-03-31 00:57:37',3310491123,1),(367683051,425325838,14824718,870814,1,'2009-03-31 00:57:38',3310491123,1),(367683060,425326619,14828946,870814,1,'2009-03-31 00:57:38',3310491123,1),(367683065,425327372,14833994,870814,1,'2009-03-31 00:57:39',3310491129,1),(367683069,425327465,14834675,870814,1,'2009-03-31 00:57:39',3310491129,1),(367683074,425327763,14835306,870814,1,'2009-03-31 00:57:39',3310491129,1),(367683080,425328051,14835874,870814,1,'2009-03-31 00:57:40',3310491129,1),(367683084,425328302,14836783,870814,1,'2009-03-31 00:57:40',3310491129,1),(367683091,425329706,14841868,870814,1,'2009-03-31 00:57:40',3310491129,1),(367683097,425330766,14845187,870814,1,'2009-03-31 00:57:41',3310491129,1),(367683102,425331185,14846310,870814,1,'2009-03-31 00:57:42',3310491129,1),(367683107,425332040,14848001,870814,1,'2009-03-31 00:57:42',3310491129,1),(367683114,425333128,14849680,870814,1,'2009-03-31 00:57:42',3310491129,1),(367683120,425334607,14851396,870814,1,'2009-03-31 00:57:43',3310491129,1),(367683128,425336876,14853390,870814,1,'2009-03-31 00:57:43',3310491129,1),(367683134,425338103,14854551,870814,1,'2009-03-31 00:57:43',3310491129,1),(367683139,425339349,14856027,870814,1,'2009-03-31 00:57:44',3310491129,1),(367683144,425340940,14858147,870814,1,'2009-03-31 00:57:44',3310491129,1),(367683147,425341962,14859977,870814,1,'2009-03-31 00:57:44',3310491129,1),(367683155,425342837,14861933,870814,1,'2009-03-31 00:57:45',3310491132,1),(367683161,425344817,14867485,870814,1,'2009-03-31 00:57:45',3310491132,1),(367683168,425346119,14870817,870814,1,'2009-03-31 00:57:45',3310491132,1),(367683176,425346398,14871902,870814,1,'2009-03-31 00:57:45',3310491132,1),(367683182,425346547,14872950,870814,1,'2009-03-31 00:57:46',3310491132,1),(367683188,425346621,14874615,870814,1,'2009-03-31 00:57:47',3310491132,1),(367683198,425346723,14879070,870814,1,'2009-03-31 00:57:47',3310491132,1),(367683208,425346863,14880799,870814,1,'2009-03-31 00:57:48',3310491132,1),(367683212,425347486,14886591,870814,1,'2009-03-31 00:57:48',3310491132,1),(367683222,425348165,14896561,870814,1,'2009-03-31 00:57:48',3310491134,1),(367683232,425348304,14897747,870814,1,'2009-03-31 00:57:48',3310491134,1),(367683242,425348453,14898327,870814,1,'2009-03-31 00:57:49',3310491134,1),(367683249,425349206,14899728,870814,1,'2009-03-31 00:57:49',3310491134,1),(367683260,425349597,14900574,870814,1,'2009-03-31 00:57:50',3310491134,1),(367683266,425349876,14901381,870814,1,'2009-03-31 00:57:50',3310491134,1),(367683274,425350118,14902151,870814,1,'2009-03-31 00:57:51',3310491134,1),(367683286,425350285,14902807,870814,1,'2009-03-31 00:57:52',3310491134,1),(367683291,425350378,14903539,870814,1,'2009-03-31 00:57:52',3310491134,1),(367683298,425350434,14904372,870814,1,'2009-03-31 00:57:53',3310491134,1),(367683303,425350545,14905773,870814,1,'2009-03-31 00:57:53',3310491134,1),(367683309,425350806,14906883,870814,1,'2009-03-31 00:57:53',3310491134,1),(367683318,425351289,14908006,870814,1,'2009-03-31 00:57:54',3310491134,1),(367683330,425352926,14910972,870814,1,'2009-03-31 00:57:55',3310491134,1),(367683340,425353800,14912133,870814,1,'2009-03-31 00:57:56',3310491134,1),(367683346,425357547,14915856,870814,1,'2009-03-31 00:57:56',3310491134,1),(367683352,425361313,14919023,870814,1,'2009-03-31 00:57:56',3310491134,1),(367683359,425364521,14922266,870814,1,'2009-03-31 00:57:57',3310491134,1),(367683366,425366111,14923806,870814,1,'2009-03-31 00:57:57',3310491134,1),(367683372,425445480,14532766,870814,1,'2009-03-31 00:57:58',3310502017,1),(368207292,424540415,14648527,27626,1,'2009-04-01 15:29:25',3310490760,2),(368207293,424540479,14644063,27626,1,'2009-04-01 15:29:25',3310490760,2),(368207294,424540922,14639171,27626,1,'2009-04-01 15:29:25',3310490760,2),(368207295,424540289,14632391,27626,1,'2009-04-01 15:29:25',3310490760,2),(368207296,424539465,14627412,27626,1,'2009-04-01 15:29:25',3310490760,2),(368207297,424537502,14624666,27626,1,'2009-04-01 15:29:26',3310490760,2),(368207298,424535096,14623035,27626,1,'2009-04-01 15:29:26',3310490760,2),(368207299,424530916,14621748,27626,1,'2009-04-01 15:29:26',3310490760,2),(368207300,424529143,14621919,27626,1,'2009-04-01 15:29:26',3310490760,2),(368207301,424527243,14623035,27626,1,'2009-04-01 15:29:26',3310490760,2),(368207302,424525660,14623807,27626,1,'2009-04-01 15:29:26',3310490760,2),(368207303,424523950,14623378,27626,1,'2009-04-01 15:29:26',3310490760,2),(368207305,424521733,14623292,27626,1,'2009-04-01 15:29:26',3310490760,2),(368207306,424521164,14624322,27626,1,'2009-04-01 15:29:26',3310490760,2),(368212962,424447015,15305761,27626,1,'2009-04-01 16:02:27',3310490489,1),(368212966,424447649,15305761,27626,1,'2009-04-01 16:02:27',3310490489,1),(368212967,424448092,15306534,27626,1,'2009-04-01 16:02:27',3310490489,1),(370003141,425345681,15204993,226881,1,'2009-04-05 17:13:03',3310491508,5),(370003845,425343240,15215388,327248,1,'2009-04-08 23:30:37',3310491508,5),(370003846,425343999,15213929,226881,1,'2009-04-05 17:11:58',3310491508,3),(370003848,425344758,15212040,226881,1,'2009-04-05 17:11:58',3310491508,3),(370003849,425345264,15209723,226881,1,'2009-04-05 17:11:58',3310491508,3),(370003853,425345580,15207491,226881,1,'2009-04-05 17:11:58',3310491508,4),(370902435,425357261,15320483,327248,1,'2009-04-08 23:11:52',3310491516,1),(370902436,425357957,15323058,327248,1,'2009-04-08 23:18:51',3310491516,7),(370902438,425359095,15324259,327248,1,'2009-04-08 23:18:51',3310491516,7),(370903026,425365230,15320740,327248,1,'2009-04-08 23:14:40',3310491516,2),(370903027,425363712,15318938,327248,1,'2009-04-08 23:14:40',3310491516,2),(370903028,425362700,15317565,327248,1,'2009-04-08 23:14:40',3310491516,2),(370903029,425361688,15316191,327248,1,'2009-04-08 23:14:40',3310491516,2),(370903030,425360929,15314646,327248,1,'2009-04-08 23:14:06',3310491516,1),(370903788,425368202,15316363,327248,1,'2009-04-08 23:16:00',3310491516,1),(370903791,425367127,15314990,327248,1,'2009-04-08 23:16:00',3310491516,1),(370903794,425365989,15313616,327248,1,'2009-04-08 23:16:01',3310491516,1),(370903796,425364661,15312072,327248,1,'2009-04-08 23:16:01',3310491516,1),(370904235,425377689,15321856,327248,1,'2009-04-08 23:18:53',3310491517,2),(370904334,425379143,15321685,327248,1,'2009-04-08 23:18:01',3310491517,1),(370904336,425380092,15322629,327248,1,'2009-04-08 23:18:01',3310491517,1),(370904339,425380851,15323830,327248,1,'2009-04-08 23:18:02',3310491517,1),(370904341,425381167,15325032,327248,1,'2009-04-08 23:18:02',3310491517,1),(370906892,425324573,15274223,327248,1,'2009-04-08 23:29:58',3310491513,5),(370908030,425327419,15272678,327248,1,'2009-04-08 23:29:58',3310491513,2),(370908032,425330391,15270962,327248,1,'2009-04-08 23:29:59',3310491507,2),(370908035,425336147,15267529,327248,1,'2009-04-08 23:29:59',3310491507,2),(370909129,425348101,15262035,327248,1,'2009-04-08 23:29:59',3310491510,1),(370909130,425349112,15262550,327248,1,'2009-04-08 23:29:59',3310491510,1),(370909276,425349573,15261501,327248,1,'2009-04-08 23:30:40',3310491510,2),(370909282,425348400,15247200,327248,1,'2009-04-08 23:30:39',3310491510,1),(370909283,425348800,15247130,327248,1,'2009-04-08 23:30:39',3310491510,1),(370909284,425349880,15247900,327248,1,'2009-04-08 23:30:40',3310491510,1),(370909285,425350400,15249120,327248,1,'2009-04-08 23:30:40',3310491510,1),(370909286,425350350,15255420,327248,1,'2009-04-08 23:30:40',3310491510,1),(370909287,425349920,15259930,327248,1,'2009-04-08 23:30:40',3310491510,1),(370909951,425349998,15253195,327248,1,'2009-04-08 23:32:51',3310491510,1),(370909953,425348480,15253023,327248,1,'2009-04-08 23:32:51',3310491510,1),(370909956,425348354,15255255,327248,1,'2009-04-08 23:32:51',3310491510,1),(370909959,425349808,15255426,327248,1,'2009-04-08 23:32:52',3310491510,1),(370911870,425349808,15245899,1111251,1,'2009-05-08 00:02:40',3310491510,2),(371357928,424445692,14928518,372139,1,'2009-04-10 12:07:13',3310490107,4),(371358341,424355080,15172080,372139,1,'2009-04-10 12:07:10',3310490468,2),(371358401,424364950,15002350,372139,1,'2009-04-10 12:07:11',3310490438,2),(371358405,424370310,15001270,372139,1,'2009-04-10 12:07:11',3310490438,2),(371358406,424384050,14995690,372139,1,'2009-04-10 12:07:11',3310490437,2),(371358407,424386410,14995910,372139,1,'2009-04-10 12:07:11',3310490437,2),(371358408,424389200,14994620,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358409,424391980,14992480,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358410,424394560,14989470,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358411,424396060,14985820,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358412,424399920,14981320,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358413,424399920,14980460,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358414,424398420,14979170,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358415,424398210,14977880,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358416,424402710,14975950,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358419,424403360,14969300,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358420,424404220,14969300,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358421,424404220,14967370,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358422,424403140,14966300,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358423,424404220,14961150,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358424,424404000,14957070,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358425,424405500,14953420,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358426,424407430,14951280,372139,1,'2009-04-10 12:07:12',3310490437,2),(371358429,424415160,14946340,372139,1,'2009-04-10 12:07:12',3310490448,2),(371358430,424421810,14943550,372139,1,'2009-04-10 12:07:12',3310490448,2),(371358431,424423530,14941840,372139,1,'2009-04-10 12:07:12',3310490448,2),(371358432,424425670,14938620,372139,1,'2009-04-10 12:07:12',3310490106,2),(371358433,424426960,14937970,372139,1,'2009-04-10 12:07:12',3310490106,2),(371358434,424428250,14934750,372139,1,'2009-04-10 12:07:12',3310490106,2),(371358435,424429750,14933680,372139,1,'2009-04-10 12:07:12',3310490106,2),(371358436,424429540,14932390,372139,1,'2009-04-10 12:07:12',3310490106,2),(371358437,424429970,14931960,372139,1,'2009-04-10 12:07:12',3310490106,2),(371358439,424436830,14931320,372139,1,'2009-04-10 12:07:12',3310490107,2),(371358441,424440050,14933900,372139,1,'2009-04-10 12:07:12',3310490107,2),(371358442,424443050,14939480,372139,1,'2009-04-10 12:07:12',3310490107,2),(371358443,424444560,14940550,372139,1,'2009-04-10 12:07:12',3310490107,2),(371358444,424443910,14934750,372139,1,'2009-04-10 12:07:13',3310490107,2),(371358445,424444990,14930030,372139,1,'2009-04-10 12:07:13',3310490107,2),(385582099,425039917,15191701,981792,1,'2009-04-27 01:28:18',3310491428,1),(385582100,425040360,15194791,981792,1,'2009-04-27 01:28:18',3310491429,1),(385582101,425043524,15202516,981792,1,'2009-04-27 01:28:18',3310491429,1),(385582102,425047194,15209382,981792,1,'2009-04-27 01:28:18',3310491429,1),(385582103,425049029,15215820,981792,1,'2009-04-27 01:28:18',3310491429,1),(385582104,425051497,15215391,981792,1,'2009-04-27 01:28:18',3310491429,1),(385582105,425044979,15188955,981792,1,'2009-04-27 01:28:18',3310491429,1),(385582153,425045485,15200456,981792,1,'2009-04-27 01:30:41',3310491429,2),(385743984,425346979,15324328,986514,1,'2009-04-27 12:35:09',3310491516,1),(385743985,425349003,15325186,986514,1,'2009-04-27 12:35:09',3310491516,1),(385743986,425350647,15326473,986514,1,'2009-04-27 12:35:09',3310491518,1),(385743987,425352291,15328190,986514,1,'2009-04-27 12:35:09',3310491518,1),(385743988,425354315,15331194,986514,1,'2009-04-27 12:35:09',3310491518,1),(385743989,425356972,15336086,986514,1,'2009-04-27 12:35:09',3310491518,1),(385743990,425358300,15339605,986514,1,'2009-04-27 12:35:09',3310491518,1),(385743991,425360956,15344669,986514,1,'2009-04-27 12:35:09',3310491518,1),(385743992,425363746,15349778,1075282,1,'2009-05-04 18:27:52',3310491518,2),(385743993,425366086,15354070,1075282,1,'2009-05-04 18:28:06',3310491518,3),(390327159,425408180,15216400,1423654,1,'2009-06-04 22:58:39',3310502434,2),(390327162,425407600,15216470,1074360,1,'2009-05-04 16:59:05',3310502434,1),(390327165,425404930,15217300,1074360,1,'2009-05-04 16:59:05',3310502434,1),(390327166,425403950,15216800,1074360,1,'2009-05-04 16:59:05',3310502434,1),(390327168,425401680,15216420,1074360,1,'2009-05-04 16:59:05',3310502434,1),(390327171,425399470,15215250,1074360,1,'2009-05-04 16:59:05',3310502432,1),(390327172,425396650,15215000,1074360,1,'2009-05-04 16:59:05',3310491509,1),(390327175,425393870,15215870,1074360,1,'2009-05-04 16:59:05',3310491509,1),(390327177,425393270,15215670,1074360,1,'2009-05-04 16:59:06',3310491509,1),(390327179,425392120,15214580,1074360,1,'2009-05-04 16:59:06',3310491509,1),(390327180,425391530,15214430,1074360,1,'2009-05-04 16:59:06',3310491509,1),(390327181,425388070,15215080,1074360,1,'2009-05-04 16:59:06',3310491509,1),(390327182,425386420,15217600,1074360,1,'2009-05-04 16:59:06',3310491511,1),(390327183,425386400,15218220,1074360,1,'2009-05-04 16:59:06',3310491511,1),(390327184,425385880,15219270,1074360,1,'2009-05-04 16:59:06',3310491511,1),(390327185,425383670,15221000,1074360,1,'2009-05-04 16:59:06',3310491511,1),(390327186,425382720,15223370,1074360,1,'2009-05-04 16:59:06',3310491511,1),(390327187,425381680,15224530,1074360,1,'2009-05-04 16:59:06',3310491511,1),(390327188,425381320,15224600,1074360,1,'2009-05-04 16:59:06',3310491511,1),(390327189,425381370,15224870,1074360,1,'2009-05-04 16:59:06',3310491511,1),(390327190,425380080,15225270,1074360,1,'2009-05-04 16:59:06',3310491511,1),(390327191,425378970,15226670,1074360,1,'2009-05-04 16:59:07',3310491511,1),(390327192,425377950,15228500,1074360,1,'2009-05-04 16:59:07',3310491511,1),(390327193,425376400,15230370,1074360,1,'2009-05-04 16:59:07',3310491511,1),(390327194,425376330,15230730,1074360,1,'2009-05-04 16:59:07',3310491511,1),(390327195,425376600,15231180,1074360,1,'2009-05-04 16:59:07',3310491511,1),(390327196,425376380,15231400,1074360,1,'2009-05-04 16:59:07',3310491511,1),(390327197,425376200,15232450,1074360,1,'2009-05-04 16:59:07',3310491511,1),(390327198,425375250,15233670,1074360,1,'2009-05-04 16:59:07',3310491511,1),(390327199,425374330,15236370,1074360,1,'2009-05-04 16:59:07',3310491511,1),(390327200,425374230,15237250,1074360,1,'2009-05-04 16:59:07',3310491511,1),(390327202,425374500,15238280,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327204,425374120,15239420,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327205,425374200,15240250,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327207,425373930,15240620,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327208,425373530,15242480,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327210,425373250,15242700,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327212,425374200,15246100,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327214,425374380,15247850,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327215,425374180,15248780,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327217,425374250,15250200,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327219,425371930,15253250,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327220,425371700,15252630,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327222,425371950,15251250,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327223,425371820,15250750,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327224,425371030,15251380,1074360,1,'2009-05-04 16:59:08',3310491511,1),(390327225,425370670,15250780,1074360,1,'2009-05-04 16:59:09',3310491511,1),(390327227,425370030,15250750,1074360,1,'2009-05-04 16:59:09',3310491511,1),(390327229,425370070,15250070,1074360,1,'2009-05-04 16:59:09',3310491511,1),(390327231,425369770,15249850,1074360,1,'2009-05-04 16:59:09',3310491511,1),(390327232,425369350,15249720,1074360,1,'2009-05-04 16:59:09',3310491510,1),(390327233,425369100,15250100,1074360,1,'2009-05-04 16:59:09',3310491510,1),(390327234,425368450,15250220,1074360,1,'2009-05-04 16:59:09',3310491510,1),(390327236,425368630,15250000,1074360,1,'2009-05-04 16:59:09',3310491510,1),(390336072,425350020,15236670,1074615,1,'2009-05-04 17:28:49',3310491510,1),(390336073,425348050,15237315,1074615,1,'2009-05-04 17:28:49',3310491510,1),(390336447,425350220,15246570,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336448,425350430,15245770,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336449,425350270,15244250,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336450,425349430,15242500,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336451,425349100,15240550,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336452,425349230,15237100,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336453,425351850,15237850,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336454,425353430,15239700,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336455,425353650,15240070,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336456,425354470,15244180,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336457,425354870,15245130,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336458,425355770,15246070,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336459,425356180,15245670,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336460,425355820,15244630,1074615,1,'2009-05-04 17:29:51',3310491510,1),(390336461,425355880,15243280,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336462,425355670,15242470,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336463,425355670,15241920,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336464,425355900,15241570,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336465,425356130,15241600,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336466,425356580,15242400,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336467,425356980,15242070,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336468,425357470,15242080,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336469,425357480,15242480,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336470,425358880,15243200,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336471,425359080,15243980,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336472,425359670,15243730,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336473,425360370,15244430,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336474,425360970,15243800,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336475,425361020,15243130,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336476,425361600,15243870,1074615,1,'2009-05-04 17:29:52',3310491510,1),(390336477,425363020,15244600,1074615,1,'2009-05-04 17:29:53',3310491510,1),(390336479,425363380,15245370,1074615,1,'2009-05-04 17:29:53',3310491510,1),(390336481,425363830,15245730,1074615,1,'2009-05-04 17:29:53',3310491510,1),(390336483,425364070,15246380,1074615,1,'2009-05-04 17:29:53',3310491510,1),(390336485,425364100,15247480,1074615,1,'2009-05-04 17:29:53',3310491510,1),(390336487,425364700,15248300,1074615,1,'2009-05-04 17:29:53',3310491510,1),(390336489,425365520,15248280,1074615,1,'2009-05-04 17:29:53',3310491510,1),(390336491,425367450,15249930,1074615,1,'2009-05-04 17:29:53',3310491510,1),(390336493,425367620,15249850,1074615,1,'2009-05-04 17:29:53',3310491510,1),(390336494,425367970,15251050,1074615,1,'2009-05-04 17:29:53',3310491510,1),(390336495,425368330,15250950,1074615,1,'2009-05-04 17:29:53',3310491510,1),(390336730,425363258,15231766,1074615,1,'2009-05-04 17:32:19',3310491510,1),(390336731,425363827,15234341,1074615,1,'2009-05-04 17:32:19',3310491510,1),(390336732,425365724,15240521,1074615,1,'2009-05-04 17:32:19',3310491510,1),(390336733,425366989,15244727,1074615,1,'2009-05-04 17:32:19',3310491510,1),(390336734,425367938,15249448,1074615,1,'2009-05-04 17:32:19',3310491510,1),(390336735,425368760,15253052,1074615,1,'2009-05-04 17:32:19',3310491510,1),(390336737,425370910,15260005,1074615,1,'2009-05-04 17:32:19',3310491511,1),(390336738,425372491,15264296,1074615,1,'2009-05-04 17:32:19',3310491511,1),(390336740,425372997,15267987,1074615,1,'2009-05-04 17:32:19',3310491511,1),(390336742,425372997,15273137,1074615,1,'2009-05-04 17:32:19',3310491517,1),(390336745,425373946,15277342,1074615,1,'2009-05-04 17:32:20',3310491517,1),(390336747,425376286,15284037,1074615,1,'2009-05-04 17:32:20',3310491517,1),(390336748,425376475,15286355,1074615,1,'2009-05-04 17:32:20',3310491517,1),(390336750,425377551,15292363,1074615,1,'2009-05-04 17:32:20',3310491517,1),(390336752,425380333,15297513,1074615,1,'2009-05-04 17:32:20',3310491517,1),(390336754,425381788,15300688,1074615,1,'2009-05-04 17:33:50',3310491517,2),(390336755,425383812,15304036,1074615,1,'2009-05-04 17:33:50',3310491517,2),(390336757,425386215,15307727,1074615,1,'2009-05-04 17:32:20',3310491517,1),(390336904,425362881,15231090,1074615,1,'2009-05-04 17:33:11',3310491510,1),(390337187,425382104,15301890,1074615,1,'2009-05-04 17:34:16',3310491517,1),(390346965,425326370,15287980,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346966,425326000,15287670,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346967,425325500,15287750,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346968,425324470,15288550,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346969,425324370,15288870,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346970,425324080,15288830,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346971,425324830,15286750,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346972,425326100,15284720,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346973,425326500,15284870,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346974,425327250,15284350,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346975,425331250,15280370,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346976,425332050,15279900,1074995,1,'2009-05-04 18:02:12',3310491513,1),(390346977,425333630,15275920,1074995,1,'2009-05-04 18:02:13',3310491513,1),(390346978,425334420,15274250,1074995,1,'2009-05-04 18:02:13',3310491513,1),(390346979,425334920,15273700,1074995,1,'2009-05-04 18:02:13',3310491513,1),(390346980,425335103,15272377,1074995,1,'2009-05-04 18:02:13',3310491513,1),(390351766,425331946,15291605,1075171,1,'2009-05-04 18:16:08',3310491513,1),(390351767,425330238,15291862,1075171,1,'2009-05-04 18:16:08',3310491513,1),(390351768,425328594,15292120,1075171,1,'2009-05-04 18:16:08',3310491513,1),(390351769,425327645,15291777,1075171,1,'2009-05-04 18:16:08',3310491513,1),(390351770,425328214,15290403,1075171,1,'2009-05-04 18:16:08',3310491513,1),(390351771,425328341,15289802,1075171,1,'2009-05-04 18:16:08',3310491513,1),(390351772,425327961,15289545,1075171,1,'2009-05-04 18:16:09',3310491513,1),(390351773,425326380,15290832,1075171,1,'2009-05-04 18:16:09',3310491513,1),(390351774,425325370,15291030,1075171,1,'2009-05-04 18:16:09',3310491513,1),(390351775,425325495,15289631,1075171,1,'2009-05-04 18:16:09',3310491513,1),(390351776,425326127,15288601,1075171,1,'2009-05-04 18:16:09',3310491513,1),(390353660,425343844,15281944,1075235,1,'2009-05-04 18:23:50',3310491516,1),(390353661,425344600,15282870,1075235,1,'2009-05-04 18:23:50',3310491516,1),(390353662,425344856,15283832,1075235,1,'2009-05-04 18:23:50',3310491516,1),(390353663,425343908,15284347,1075235,1,'2009-05-04 18:23:50',3310491516,1),(390353664,425342200,15284200,1075235,1,'2009-05-04 18:23:50',3310491516,1),(390353665,425340935,15285377,1075235,1,'2009-05-04 18:23:50',3310491513,1),(390353666,425339900,15287000,1075235,1,'2009-05-04 18:23:50',3310491513,1),(390353667,425339607,15288038,1075235,1,'2009-05-04 18:23:50',3310491513,1),(390353668,425339986,15288553,1075235,1,'2009-05-04 18:23:50',3310491513,1),(390353669,425340998,15288896,1075235,1,'2009-05-04 18:23:50',3310491513,1),(390353670,425341579,15289787,1075235,1,'2009-05-04 18:23:50',3310491513,1),(390353671,425343030,15293980,1075235,1,'2009-05-04 18:23:51',3310491516,1),(390353672,425343830,15297870,1075235,1,'2009-05-04 18:23:51',3310491516,1),(390353673,425346180,15301130,1075235,1,'2009-05-04 18:23:51',3310491516,1),(390353674,425350250,15311350,1075235,1,'2009-05-04 18:23:51',3310491516,1),(390353675,425350430,15316570,1075235,1,'2009-05-04 18:23:51',3310491516,1),(390353676,425351170,15320480,1075235,1,'2009-05-04 18:23:51',3310491516,1),(390353677,425354150,15324270,1075235,1,'2009-05-04 18:23:51',3310491516,1),(390356561,425355082,15325660,1075282,1,'2009-05-04 18:32:03',3310491516,1),(390356562,425355670,15326470,1075282,1,'2009-05-04 18:32:03',3310491518,1),(390356563,425355880,15327230,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356564,425356650,15328300,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356565,425357850,15328870,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356566,425359730,15329150,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356567,425360520,15329650,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356568,425361420,15330770,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356569,425362870,15334100,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356570,425363380,15334620,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356571,425364070,15339900,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356572,425364430,15341220,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356573,425365380,15342850,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356574,425366580,15345730,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356575,425366870,15346980,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356576,425366970,15350650,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356578,425365897,15356387,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390356579,425365833,15361022,1075282,1,'2009-05-04 18:32:04',3310491518,1),(390361836,425429500,15228780,1075389,1,'2009-05-04 18:49:12',3310502435,1),(390361837,425429930,15227180,1075389,1,'2009-05-04 18:49:12',3310502435,1),(390361838,425431630,15223530,1075389,1,'2009-05-04 18:49:12',3310502435,1),(390361839,425432080,15221950,1075389,1,'2009-05-04 18:49:12',3310502435,1),(390361840,425433550,15220450,1075389,1,'2009-05-04 18:49:12',3310502435,1),(394815197,424488770,14909350,1165813,1,'2009-05-12 19:59:07',3310490110,2),(394815198,424491780,14916430,1165813,1,'2009-05-12 19:59:07',3310490111,2),(394815199,424493980,14919480,1165813,1,'2009-05-12 19:59:07',3310490111,2),(394815200,424497293,14920929,1165813,1,'2009-05-12 19:59:07',3310490111,2),(394816282,424511070,14945388,1165753,1,'2009-05-12 19:56:36',3310490453,1),(394816283,424509350,14944620,1165753,1,'2009-05-12 19:56:36',3310490453,1),(394816284,424507450,14943270,1165753,1,'2009-05-12 19:56:36',3310490453,1),(394816285,424504680,14938300,1165753,1,'2009-05-12 19:56:36',3310490111,1),(394816286,424503430,14934770,1165753,1,'2009-05-12 19:56:36',3310490111,1),(394816287,424502140,14927706,1165753,1,'2009-05-12 19:56:36',3310490111,1),(394816288,424501180,14924180,1165753,1,'2009-05-12 19:56:36',3310490111,1),(394816289,424500480,14922700,1165753,1,'2009-05-12 19:56:36',3310490111,1),(394816290,424499607,14921956,1165753,1,'2009-05-12 19:56:36',3310490111,1),(394816825,424497800,14921358,1165813,1,'2009-05-12 20:00:45',3310490111,1),(394816826,424497800,14921959,1165813,1,'2009-05-12 20:00:45',3310490111,1),(394816827,424497420,14922302,1165813,1,'2009-05-12 20:00:45',3310490111,1),(394816828,424496787,14922045,1165813,1,'2009-05-12 20:00:45',3310490111,1),(394816829,424496217,14921616,1165813,1,'2009-05-12 20:00:45',3310490111,1),(394816830,424495280,14921350,1165813,1,'2009-05-12 20:00:45',3310490111,1),(394816831,424492000,14920220,1165813,1,'2009-05-12 20:00:45',3310490111,1),(394816832,424489007,14916125,1166143,1,'2009-05-12 20:31:07',3310490110,2),(394820721,424485330,14913675,1166091,1,'2009-05-12 20:25:27',3310490110,1),(394820722,424486790,14914837,1166143,1,'2009-05-12 20:29:55',3310490110,2),(394820724,424486977,14919168,1166091,1,'2009-05-12 20:25:38',3310490110,1),(394820725,424482480,14915048,1166091,1,'2009-05-12 20:25:38',3310490110,1),(394820726,424481930,14913770,1166091,1,'2009-05-12 20:25:38',3310490110,1),(394820727,424482150,14912550,1166091,1,'2009-05-12 20:25:38',3310490110,1),(394820728,424483120,14912220,1166091,1,'2009-05-12 20:25:38',3310490110,1),(394820729,424483920,14912250,1166091,1,'2009-05-12 20:25:38',3310490110,1),(394822862,424487930,14915953,1166143,1,'2009-05-12 20:29:55',3310490110,1),(394823920,424489941,14917998,1166143,1,'2009-05-12 20:31:07',3310490110,1),(394823921,424488500,14915524,1166143,1,'2009-05-12 20:31:07',3310490110,1),(394823922,424488373,14917584,1166143,1,'2009-05-12 20:31:07',3310490110,1),(394823923,424489197,14918442,1166143,1,'2009-05-12 20:31:07',3310490110,1),(394823924,424490820,14921870,1166143,1,'2009-05-12 20:31:07',3310490111,1),(394823925,424496200,14925570,1166143,1,'2009-05-12 20:31:07',3310490111,1),(394823926,424497250,14927020,1166143,1,'2009-05-12 20:31:07',3310490111,1),(394823927,424498980,14932080,1166143,1,'2009-05-12 20:31:07',3310490111,1),(394823928,424499950,14940050,1166143,1,'2009-05-12 20:31:07',3310490111,1),(394831766,424500143,14942127,1166268,1,'2009-05-12 20:57:11',3310490453,1),(394831767,424500500,14943950,1166268,1,'2009-05-12 20:57:11',3310490453,1),(394831768,424501093,14945818,1166268,1,'2009-05-12 20:57:11',3310490453,1),(394832384,424500120,14944230,1166268,1,'2009-05-12 20:58:50',3310490453,1),(394832388,424499670,14943650,1166268,1,'2009-05-12 20:58:50',3310490453,1),(394832391,424497990,14938608,1166268,1,'2009-05-12 20:58:50',3310490111,1),(394832396,424496407,14933029,1166268,1,'2009-05-12 20:58:50',3310490111,1),(394832401,424495670,14931730,1166268,1,'2009-05-12 20:58:51',3310490111,1),(394832404,424494050,14931800,1166268,1,'2009-05-12 20:58:51',3310490111,1),(394832407,424493370,14933080,1166268,1,'2009-05-12 20:58:51',3310490111,1),(394832411,424493320,14934850,1166268,1,'2009-05-12 20:58:51',3310490111,1),(394832416,424494370,14938830,1166268,1,'2009-05-12 20:58:51',3310490111,1),(394832428,424494570,14940153,1166268,1,'2009-05-12 20:58:51',3310490111,1),(394840157,424530295,14965368,2138435,1,'2009-08-14 08:44:22',3310491136,2),(394840530,424516200,14972030,1166650,1,'2009-05-12 21:14:35',3310490453,1),(394840531,424515476,14971118,1166650,1,'2009-05-12 21:14:35',3310490453,1),(394840532,424514209,14969917,1166650,1,'2009-05-12 21:14:35',3310490453,1),(394840533,424510980,14967084,1166650,1,'2009-05-12 21:14:35',3310490453,1),(394840534,424507940,14963994,1166650,1,'2009-05-12 21:14:35',3310490453,1),(394840995,424502930,14947380,1166650,1,'2009-05-12 21:15:32',3310490453,1),(394840996,424506850,14950020,1166650,1,'2009-05-12 21:15:32',3310490453,1),(394840997,424510070,14953030,1166650,1,'2009-05-12 21:15:32',3310490453,1),(394840998,424512920,14954720,1166650,1,'2009-05-12 21:15:32',3310490453,1),(394840999,424515673,14958322,1166650,1,'2009-05-12 21:15:32',3310490453,1),(394841000,424516363,14958930,1166650,1,'2009-05-12 21:15:32',3310490453,1),(394841001,424517313,14959102,1166650,1,'2009-05-12 21:15:32',3310490453,1),(394841002,424524150,14959350,1166650,1,'2009-05-12 21:15:33',3310491136,1),(394841006,424530980,14960630,1166650,1,'2009-05-12 21:15:33',3310491136,1),(394841007,424533930,14962620,1166650,1,'2009-05-12 21:15:33',3310491136,1),(394841008,424534480,14964230,1166650,1,'2009-05-12 21:15:33',3310491136,1),(394841009,424533980,14965900,1166650,1,'2009-05-12 21:15:33',3310491136,1),(394841010,424528050,14967650,1166650,1,'2009-05-12 21:15:34',3310491136,1),(394841011,424518780,14973120,1166650,1,'2009-05-12 21:15:34',3310491136,1),(394841012,424512930,14972720,1166650,1,'2009-05-12 21:15:34',3310490453,1),(394841013,424511030,14972420,1166650,1,'2009-05-12 21:15:34',3310490453,1),(394841014,424505204,14968649,1166650,1,'2009-05-12 21:15:34',3310490453,1),(394841015,424504900,14968801,1166650,1,'2009-05-12 21:15:34',3310490453,1),(394841016,424504920,14969430,1166650,1,'2009-05-12 21:15:35',3310490453,1),(394841017,424507520,14972700,1166650,1,'2009-05-12 21:15:35',3310490453,1),(394841018,424509050,14976880,1166650,1,'2009-05-12 21:15:35',3310490453,1),(394841019,424509230,14982050,1166650,1,'2009-05-12 21:15:35',3310490453,1),(394841020,424508670,14986420,1166650,1,'2009-05-12 21:15:35',3310490453,1),(394841021,424508230,14987330,1166650,1,'2009-05-12 21:15:35',3310490453,1),(394841022,424507680,14986720,1166650,1,'2009-05-12 21:15:35',3310490453,1),(394841023,424507150,14983130,1166650,1,'2009-05-12 21:15:36',3310490453,1),(394841024,424505800,14980350,1166650,1,'2009-05-12 21:15:36',3310490453,1),(394841026,424505153,14980045,1166650,1,'2009-05-12 21:15:36',3310490453,1),(394841027,424504700,14980870,1166650,1,'2009-05-12 21:15:36',3310490453,1),(394841028,424505900,14986300,1166650,1,'2009-05-12 21:15:36',3310490453,1),(394841029,424505786,14986997,1166650,1,'2009-05-12 21:15:37',3310490453,1),(394841030,424505220,14987270,1166650,1,'2009-05-12 21:15:37',3310490453,1),(394841031,424499670,14978730,1166650,1,'2009-05-12 21:15:37',3310490453,1),(394841032,424496400,14975350,1166650,1,'2009-05-12 21:15:37',3310490453,1),(394841033,424494330,14974350,1166650,1,'2009-05-12 21:15:37',3310490453,1),(394841034,424489870,14973950,1166650,1,'2009-05-12 21:15:37',3310490452,1),(394841035,424488630,14973050,1166650,1,'2009-05-12 21:15:38',3310490452,1),(394841036,424484600,14967700,1166792,1,'2009-05-12 21:27:16',3310490452,2),(394845193,424500396,14979848,1166792,1,'2009-05-12 21:20:47',3310490453,1),(394847583,424500070,14979830,1166792,1,'2009-05-12 21:23:22',3310490453,1),(394847585,424498470,14978920,1166792,1,'2009-05-12 21:23:22',3310490453,1),(394847587,424497030,14979130,1166792,1,'2009-05-12 21:23:22',3310490453,1),(394847589,424496280,14980250,1166792,1,'2009-05-12 21:23:22',3310490453,1),(394847590,424496230,14981080,1166792,1,'2009-05-12 21:23:22',3310490453,1),(394847591,424497480,14988580,1166792,1,'2009-05-12 21:23:22',3310490453,1),(394847592,424499320,14993130,1166792,1,'2009-05-12 21:23:22',3310490453,1),(394847593,424500370,14993420,1166792,1,'2009-05-12 21:23:22',3310490453,1),(394848317,424501583,14993191,1166792,1,'2009-05-12 21:24:15',3310490453,1),(394848319,424502470,14992762,1166792,1,'2009-05-12 21:24:15',3310490453,1),(408986116,425641935,15274809,1276166,1,'2009-05-21 17:05:04',3310502504,1),(408986118,425641809,15275753,1276166,1,'2009-05-21 17:05:04',3310502504,1),(408986121,425640671,15275668,1276166,1,'2009-05-21 17:05:04',3310502504,1),(408986124,425639659,15275410,1276166,1,'2009-05-21 17:05:04',3310502504,1),(408986126,425639976,15273693,1276166,1,'2009-05-21 17:05:05',3310502504,1),(408986129,425640544,15273865,1276166,1,'2009-05-21 17:05:05',3310502504,1),(408986131,425641113,15274294,1276166,1,'2009-05-21 17:05:05',3310502504,1),(408987613,425641556,15275238,1276166,1,'2009-05-21 17:07:30',3310502504,1),(415767140,425401200,15223700,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767141,425405500,15234000,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767142,425403300,15221600,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767143,425404400,15230400,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767144,425405400,15234500,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767145,425402300,15224700,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767146,425404000,15220700,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767147,425404100,15229500,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767148,425408841,15235176,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767149,425406000,15234900,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767150,425402800,15221700,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767151,425408400,15235200,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767152,425403700,15229000,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767153,425405500,15220300,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767154,425408600,15216900,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767155,425405100,15233700,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767156,425400600,15223600,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767157,425404300,15231100,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767158,425407700,15218700,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767159,425403500,15227100,1423654,1,'2009-06-04 22:58:38',3310502434,1),(415767160,425405100,15233000,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767161,425401000,15222000,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767162,425402900,15226200,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767163,425400200,15222000,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767164,425405034,15233155,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767165,425403000,15225800,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767166,425408100,15217500,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767167,425399900,15223000,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767168,425405100,15233300,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767169,425403500,15227900,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767170,425404600,15231300,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767171,425401300,15221800,1423654,1,'2009-06-04 22:58:39',3310502434,1),(415767172,425407300,15219300,1423654,1,'2009-06-04 22:58:39',3310502434,1),(441154305,425391557,15253450,1816099,1,'2009-07-13 15:48:57',3310491511,1),(441154306,425394213,15251476,1816099,1,'2009-07-13 15:48:58',3310491511,1),(441154307,425396110,15250360,1816099,1,'2009-07-13 15:48:58',3310491511,1),(441154308,425396869,15249931,1816099,1,'2009-07-13 15:48:59',3310491511,1),(441154951,425387726,15254134,1816161,1,'2009-07-13 15:53:33',3310491511,1),(441154982,425388197,15254777,1816161,1,'2009-07-13 15:54:16',3310491511,1),(441154983,425388766,15254863,1816161,1,'2009-07-13 15:54:16',3310491511,1),(441154984,425389904,15254005,1816161,1,'2009-07-13 15:54:17',3310491511,1),(441157250,425387052,15256178,1816208,1,'2009-07-13 16:01:58',3310491511,1),(441157251,425385218,15257809,1816208,1,'2009-07-13 16:01:58',3310491511,1),(441157252,425383320,15259268,1816208,1,'2009-07-13 16:01:59',3310491511,1),(441157253,425382688,15260555,1816208,1,'2009-07-13 16:01:59',3310491511,1),(441157255,425381992,15263560,1816208,1,'2009-07-13 16:02:00',3310491511,1),(441157257,425381880,15264650,1816208,1,'2009-07-13 16:02:01',3310491511,1),(441157259,425382308,15265705,1816208,1,'2009-07-13 16:02:02',3310491511,1),(441157261,425382830,15266620,1816208,1,'2009-07-13 16:02:02',3310491511,1),(441157265,425385950,15269970,1816208,1,'2009-07-13 16:02:05',3310491511,1),(441157267,425388477,15274537,1816208,1,'2009-07-13 16:02:06',3310491517,1),(442879444,425433752,15234253,1851615,1,'2009-07-17 11:50:12',3310502435,1),(442880086,425433878,15237171,1851615,1,'2009-07-17 11:51:42',3310502435,1),(442880684,425435396,15234167,1851615,1,'2009-07-17 11:55:48',3310502435,1),(442880685,425434447,15238201,1851615,1,'2009-07-17 11:55:48',3310502435,1),(442880686,425432361,15237085,1851615,1,'2009-07-17 11:55:48',3310502435,1),(442880687,425433246,15233051,1851615,1,'2009-07-17 11:55:48',3310502435,1),(442881217,425474349,15135634,1851615,1,'2009-07-17 11:58:40',3310502414,1),(442881670,425469796,15138552,1851615,1,'2009-07-17 11:59:09',3310502414,1),(442881710,425471377,15150568,1851615,1,'2009-07-17 11:59:35',3310502414,1),(442881842,425426353,15170824,1851615,1,'2009-07-17 12:00:21',3310502433,1),(442881998,425467456,15142328,1851615,1,'2009-07-17 12:01:25',3310502414,1),(442882169,425466634,15145075,1851615,1,'2009-07-17 12:02:05',3310502414,1),(442882272,425366401,15167992,1851615,1,'2009-07-17 12:02:57',3310491508,1),(442882442,425466128,15219662,1851615,1,'2009-07-17 12:04:21',3310502438,1),(442882581,425442858,15231163,1851615,1,'2009-07-17 12:05:30',3310502435,1),(444324773,425307320,16005116,1882243,1,'2009-07-20 12:45:02',3310493018,1),(458761736,425903956,15174762,2074125,1,'2009-08-08 14:42:15',3310502692,1),(458761931,425899474,15150645,2190495,1,'2009-08-18 18:21:57',3310502670,2),(458761932,425901530,15151870,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761933,425903470,15152280,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761934,425904900,15153670,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761935,425906130,15153530,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761937,425908120,15154980,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761938,425910520,15155320,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761939,425911130,15154600,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761940,425911730,15155620,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761941,425913070,15156050,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761942,425914430,15155470,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761943,425914230,15156050,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761944,425917320,15157470,2074125,1,'2009-08-08 14:44:13',3310502670,1),(458761945,425921820,15157070,2074125,1,'2009-08-08 14:44:13',3310502671,1),(458761946,425924180,15158320,2074125,1,'2009-08-08 14:44:13',3310502671,1),(458761947,425927100,15158550,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761948,425927820,15157750,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761949,425927350,15155830,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761950,425931980,15153200,2074125,1,'2009-08-08 14:44:14',3310502671,1);
INSERT INTO `nodes` VALUES (458761951,425933020,15153230,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761952,425934580,15150500,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761953,425933420,15147120,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761954,425930870,15146820,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761955,425929520,15145600,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761956,425929030,15144700,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761957,425929630,15143870,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761958,425929250,15142520,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761959,425927720,15141280,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761960,425925480,15141770,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761961,425923930,15139970,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761962,425924920,15138470,2074125,1,'2009-08-08 14:44:14',3310502671,1),(458761963,425924670,15137280,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761964,425925520,15135100,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761965,425925180,15135430,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761966,425925150,15134920,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761967,425926180,15134870,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761968,425929700,15131500,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761969,425935750,15130020,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761970,425938250,15128850,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761971,425939250,15128950,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761972,425941880,15126870,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761973,425943200,15127020,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761974,425944580,15126120,2074125,1,'2009-08-08 14:44:15',3310502671,1),(458761975,425947700,15125620,2074125,1,'2009-08-08 14:44:15',3310502682,1),(458761977,425948520,15126070,2074125,1,'2009-08-08 14:44:15',3310502682,1),(458761978,425948730,15126900,2074125,1,'2009-08-08 14:44:16',3310502682,1),(458761979,425950830,15129400,2074125,1,'2009-08-08 14:44:16',3310502682,1),(458761980,425955170,15130270,2074125,1,'2009-08-08 14:44:16',3310502682,1),(458761981,425958500,15129870,2074125,1,'2009-08-08 14:44:16',3310502682,1),(458761982,425959650,15130950,2074125,1,'2009-08-08 14:44:16',3310502682,1),(458761983,425962550,15132050,2074125,1,'2009-08-08 14:44:16',3310502682,1),(458761984,425965520,15135200,2074125,1,'2009-08-08 14:44:16',3310502682,1),(458762722,425968785,15145408,2074125,1,'2009-08-08 14:47:36',3310502682,1),(458764071,425967620,15135850,2074345,1,'2009-08-08 14:51:28',3310502682,1),(458764072,425970980,15132900,2074345,1,'2009-08-08 14:51:28',3310502682,1),(458764073,425974380,15125330,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764074,425978730,15117800,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764075,425979100,15118350,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764076,425980200,15118120,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764077,425980750,15119930,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764078,425981430,15120170,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764079,425982120,15122330,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764080,425982070,15124170,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764081,425983370,15125880,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764082,425983630,15127050,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764083,425983650,15134350,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764084,425982550,15134600,2074345,1,'2009-08-08 14:51:28',3310502683,1),(458764085,425982920,15137420,2074345,1,'2009-08-08 14:51:29',3310502683,1),(458764086,425981500,15143920,2074345,1,'2009-08-08 14:51:29',3310502683,1),(458764087,425981820,15146400,2074345,1,'2009-08-08 14:51:29',3310502683,1),(458764088,425982500,15148130,2074345,1,'2009-08-08 14:51:29',3310502683,1),(458764089,425982330,15149070,2074345,1,'2009-08-08 14:51:29',3310502683,1),(458764090,425982980,15149670,2074345,1,'2009-08-08 14:51:29',3310502683,1),(458764091,425987030,15150480,2074345,1,'2009-08-08 14:51:29',3310502683,1),(458764092,425988920,15153730,2074345,1,'2009-08-08 14:51:29',3310502683,1),(458764093,425986550,15160780,2074345,1,'2009-08-08 14:51:29',3310502683,1),(458764094,425987120,15162150,2074345,1,'2009-08-08 14:51:29',3310502705,1),(458764095,425988230,15161650,2074345,1,'2009-08-08 14:51:29',3310502705,1),(458764096,425988450,15162400,2074345,1,'2009-08-08 14:51:29',3310502705,1),(458764097,425988850,15161970,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764098,425988420,15163220,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764099,425988930,15164400,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764100,425987450,15166920,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764101,425989250,15166970,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764102,425989270,15168170,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764103,425990170,15169080,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764104,425991320,15168750,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764105,425991650,15170000,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764106,425991150,15172050,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764107,425992320,15172430,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764108,425992430,15173480,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764109,425991730,15174670,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764110,425991920,15175030,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764111,425991030,15177700,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764112,425992450,15177630,2074345,1,'2009-08-08 14:51:30',3310502705,1),(458764113,425992000,15179300,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764114,425990400,15181150,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764115,425986580,15183380,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764116,425987120,15183870,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764118,425987250,15184900,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764119,425986520,15184680,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764120,425985980,15185120,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764121,425986700,15184480,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764122,425988320,15185270,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764123,425987430,15186300,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764124,425988080,15185520,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764125,425987450,15185230,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764126,425986550,15186250,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764127,425988970,15186100,2074345,1,'2009-08-08 14:51:31',3310502705,1),(458764128,425993770,15187030,2074345,1,'2009-08-08 14:51:32',3310502705,1),(458764129,425995850,15188900,2074345,1,'2009-08-08 14:51:32',3310502705,1),(458764130,425995920,15189850,2074345,1,'2009-08-08 14:51:32',3310502705,1),(458764131,425994520,15191620,2074345,1,'2009-08-08 14:51:32',3310502705,1),(458764132,425993550,15191880,2074345,1,'2009-08-08 14:51:32',3310502705,1),(458764133,425991700,15193720,2074345,1,'2009-08-08 14:51:32',3310502705,1),(458764134,425990820,15193180,2074345,1,'2009-08-08 14:51:32',3310502705,1),(458764135,425988780,15194530,2074345,1,'2009-08-08 14:51:32',3310502705,1),(458764136,425988200,15195970,2074345,1,'2009-08-08 14:51:33',3310502705,1),(458764139,425985550,15198500,2074345,1,'2009-08-08 14:51:33',3310502705,1),(458764150,425984650,15200600,2074345,1,'2009-08-08 14:51:33',3310502705,1),(458764156,425982670,15202970,2074345,1,'2009-08-08 14:51:33',3310502705,1),(458764162,425981400,15203750,2074345,1,'2009-08-08 14:51:33',3310502705,1),(458764166,425979500,15207830,2074345,1,'2009-08-08 14:51:34',3310502705,1),(458764167,425977750,15210550,2074345,1,'2009-08-08 14:51:34',3310502705,1),(458764168,425977400,15210480,2074345,1,'2009-08-08 14:51:34',3310502705,1),(458764169,425977450,15211200,2074345,1,'2009-08-08 14:51:34',3310502705,1),(458764170,425975380,15212580,2074345,1,'2009-08-08 14:51:34',3310502705,1),(458764171,425973120,15215000,2074345,1,'2009-08-08 14:51:34',3310502704,1),(458764172,425972150,15216750,2074345,1,'2009-08-08 14:51:34',3310502706,1),(458764173,425967270,15221370,2074345,1,'2009-08-08 14:51:34',3310502706,1),(458764174,425962730,15228480,2074345,1,'2009-08-08 14:51:34',3310502706,1),(458764175,425963180,15228850,2074345,1,'2009-08-08 14:51:34',3310502706,1),(458764176,425961070,15232700,2074345,1,'2009-08-08 14:51:35',3310502706,1),(458764177,425961000,15236480,2074345,1,'2009-08-08 14:51:35',3310502706,1),(458764178,425960700,15237080,2074345,1,'2009-08-08 14:51:35',3310502706,1),(458764179,425960480,15236779,2074369,1,'2009-08-08 14:56:47',3310502706,2),(458765020,425961307,15260807,2074369,1,'2009-08-08 14:55:39',3310502706,1),(458765074,425959469,15262185,2074369,1,'2009-08-08 14:55:57',3310502706,1),(458765127,425960038,15262614,2074369,1,'2009-08-08 14:56:31',3310502706,1),(458765128,425959027,15262185,2074369,1,'2009-08-08 14:56:31',3310502706,1),(458765312,425958250,15258180,2074369,1,'2009-08-08 14:56:45',3310502706,1),(458765314,425959180,15258920,2074369,1,'2009-08-08 14:56:45',3310502706,1),(458765317,425959480,15260380,2074369,1,'2009-08-08 14:56:45',3310502706,1),(458765319,425960164,15260726,2074369,1,'2009-08-08 14:56:46',3310502706,1),(458765321,425960796,15260812,2074369,1,'2009-08-08 14:56:46',3310502706,1),(458765361,425960038,15235921,2074369,1,'2009-08-08 14:56:47',3310502706,1),(458765365,425960670,15237551,2074369,1,'2009-08-08 14:56:47',3310502706,1),(458765368,425960796,15238152,2074369,1,'2009-08-08 14:56:47',3310502706,1),(458765373,425960700,15238870,2074369,1,'2009-08-08 14:56:47',3310502706,1),(458765375,425959100,15242330,2074369,1,'2009-08-08 14:56:48',3310502706,1),(458765377,425958100,15247980,2074369,1,'2009-08-08 14:56:48',3310502706,1),(458765379,425958395,15249739,2074369,1,'2009-08-08 14:56:48',3310502706,1),(458765381,425958900,15251470,2074369,1,'2009-08-08 14:56:48',3310502706,1),(458765383,425958330,15252850,2074369,1,'2009-08-08 14:56:48',3310502706,1),(458765386,425958400,15255380,2074369,1,'2009-08-08 14:56:48',3310502706,1),(458765388,425957900,15257200,2074369,1,'2009-08-08 14:56:48',3310502706,1),(470343713,425897470,15144530,2190404,1,'2009-08-18 18:09:47',3310502670,1),(470343719,425898100,15149950,2190404,1,'2009-08-18 18:09:47',3310502670,1),(470343724,425896850,15151950,2190404,1,'2009-08-18 18:09:47',3310502670,1),(470343733,425896300,15151500,2190404,1,'2009-08-18 18:09:48',3310502670,1),(470343737,425895820,15158200,2190404,1,'2009-08-18 18:09:48',3310502670,1),(470343746,425897600,15167080,2190404,1,'2009-08-18 18:09:48',3310502692,1),(470343752,425897770,15170650,2190404,1,'2009-08-18 18:09:48',3310502692,1),(470343759,425898820,15173620,2190404,1,'2009-08-18 18:09:49',3310502692,1),(470343766,425898620,15178080,2190404,1,'2009-08-18 18:12:21',3310502692,2),(470343771,425899450,15178430,2190404,1,'2009-08-18 18:09:49',3310502692,1),(470343785,425899550,15179680,2190404,1,'2009-08-18 18:09:50',3310502692,1),(470343793,425900530,15180780,2190404,1,'2009-08-18 18:09:50',3310502692,1),(470343798,425902920,15180050,2190404,1,'2009-08-18 18:09:50',3310502692,1),(470343805,425903530,15180350,2190404,1,'2009-08-18 18:09:50',3310502692,1),(470343810,425903020,15182500,2190404,1,'2009-08-18 18:09:51',3310502692,1),(470343811,425904180,15184680,2190404,1,'2009-08-18 18:09:51',3310502692,1),(470343812,425905070,15185370,2190404,1,'2009-08-18 18:09:51',3310502692,1),(470343814,425904480,15186450,2190404,1,'2009-08-18 18:09:51',3310502692,1),(470343816,425905130,15187100,2190404,1,'2009-08-18 18:09:51',3310502692,1),(470343817,425905030,15187800,2190404,1,'2009-08-18 18:09:52',3310502692,1),(470343819,425905770,15189130,2190404,1,'2009-08-18 18:09:52',3310502692,1),(470343820,425906880,15189580,2190404,1,'2009-08-18 18:09:53',3310502692,1),(470343822,425907580,15188820,2190404,1,'2009-08-18 18:09:53',3310502692,1),(470343823,425909220,15188680,2190404,1,'2009-08-18 18:09:54',3310502692,1),(470343825,425909320,15190750,2190404,1,'2009-08-18 18:09:54',3310502692,1),(470343827,425910570,15192520,2190404,1,'2009-08-18 18:09:54',3310502692,1),(470343828,425912350,15192800,2190404,1,'2009-08-18 18:09:54',3310502692,1),(470343830,425913680,15192300,2190404,1,'2009-08-18 18:09:55',3310502692,1),(470343831,425915520,15193080,2190404,1,'2009-08-18 18:09:55',3310502692,1),(470343832,425916000,15194180,2190404,1,'2009-08-18 18:09:55',3310502692,1),(470343833,425915030,15194580,2190404,1,'2009-08-18 18:09:56',3310502692,1),(470343834,425915020,15195720,2190404,1,'2009-08-18 18:09:56',3310502692,1),(470343835,425913730,15196680,2190404,1,'2009-08-18 18:09:57',3310502692,1),(470343836,425913900,15197370,2190404,1,'2009-08-18 18:09:57',3310502692,1),(470343837,425913120,15198730,2190404,1,'2009-08-18 18:09:57',3310502692,1),(470343838,425913700,15200000,2190404,1,'2009-08-18 18:09:58',3310502692,1),(470343839,425916520,15200730,2190404,1,'2009-08-18 18:09:58',3310502692,1),(470343840,425919480,15203520,2190404,1,'2009-08-18 18:09:59',3310502693,1),(470343841,425919620,15204650,2190404,1,'2009-08-18 18:09:59',3310502693,1),(470343842,425918750,15204850,2190404,1,'2009-08-18 18:09:59',3310502692,1),(470343844,425918120,15205970,2190404,1,'2009-08-18 18:09:59',3310502692,1),(470343850,425918320,15207320,2190404,1,'2009-08-18 18:10:01',3310502692,1),(470343852,425917920,15209420,2190404,1,'2009-08-18 18:10:01',3310502692,1),(470343853,425921000,15211420,2190404,1,'2009-08-18 18:10:01',3310502693,1),(470343854,425922280,15211580,2190404,1,'2009-08-18 18:10:02',3310502693,1),(470343856,425923500,15213270,2190404,1,'2009-08-18 18:10:02',3310502693,1),(470343857,425926430,15215180,2190404,1,'2009-08-18 18:10:02',3310502693,1),(470343858,425926370,15215700,2190404,1,'2009-08-18 18:10:03',3310502693,1),(470343859,425927400,15216970,2190404,1,'2009-08-18 18:10:03',3310502695,1),(470343860,425927280,15218000,2190404,1,'2009-08-18 18:10:03',3310502695,1),(470343861,425932430,15224400,2190404,1,'2009-08-18 18:10:03',3310502695,1),(470343862,425931680,15224480,2190404,1,'2009-08-18 18:10:04',3310502695,1),(470343863,425931080,15226030,2190404,1,'2009-08-18 18:10:04',3310502695,1),(470343864,425932070,15227580,2190404,1,'2009-08-18 18:10:04',3310502695,1),(470343865,425937780,15229320,2190404,1,'2009-08-18 18:10:05',3310502695,1),(470343866,425939450,15231420,2190404,1,'2009-08-18 18:10:05',3310502695,1),(470343867,425941370,15232530,2190404,1,'2009-08-18 18:10:05',3310502695,1),(470343868,425940080,15232780,2190404,1,'2009-08-18 18:10:06',3310502695,1),(470343869,425939480,15233520,2190404,1,'2009-08-18 18:10:06',3310502695,1),(470343870,425941780,15236670,2190404,1,'2009-08-18 18:10:06',3310502695,1),(470343871,425941520,15240150,2190404,1,'2009-08-18 18:10:06',3310502695,1),(470343872,425941830,15241230,2190404,1,'2009-08-18 18:10:07',3310502695,1),(470343873,425942930,15242170,2190404,1,'2009-08-18 18:10:07',3310502695,1),(470343874,425944570,15242380,2190404,1,'2009-08-18 18:10:08',3310502695,1),(470343875,425945450,15241750,2190404,1,'2009-08-18 18:10:08',3310502695,1),(470343876,425947050,15242430,2190404,1,'2009-08-18 18:10:08',3310502706,1),(470343877,425948850,15241770,2190404,1,'2009-08-18 18:10:08',3310502706,1),(470343878,425951100,15238980,2190404,1,'2009-08-18 18:10:09',3310502706,1),(470343879,425956320,15237470,2190404,1,'2009-08-18 18:10:09',3310502706,1),(470343880,425956970,15236230,2190404,1,'2009-08-18 18:10:09',3310502706,1),(470343881,425956950,15235350,2190404,1,'2009-08-18 18:10:09',3310502706,1),(470343882,425958050,15233900,2190404,1,'2009-08-18 18:10:09',3310502706,1),(470343883,425959780,15234720,2190404,1,'2009-08-18 18:10:10',3310502706,1),(470347019,425899200,15146780,2190495,1,'2009-08-18 18:21:42',3310502670,1),(470348213,425806000,15133400,2190594,1,'2009-08-18 18:26:49',3310502494,1),(470348216,425807070,15134480,2190594,1,'2009-08-18 18:26:50',3310502494,1),(470348218,425807120,15133370,2190594,1,'2009-08-18 18:26:50',3310502494,1),(470348220,425807570,15132850,2190594,1,'2009-08-18 18:26:50',3310502494,1),(470348222,425808430,15133250,2190594,1,'2009-08-18 18:26:51',3310502494,1),(470348224,425809870,15132800,2190594,1,'2009-08-18 18:26:51',3310502495,1),(470348227,425811670,15130570,2190594,1,'2009-08-18 18:26:52',3310502495,1),(470348228,425812150,15129220,2190594,1,'2009-08-18 18:26:53',3310502495,1),(470348229,425811380,15129580,2190594,1,'2009-08-18 18:26:53',3310502495,1),(470348231,425812050,15127500,2190594,1,'2009-08-18 18:26:54',3310502495,1),(470348233,425814200,15125900,2190594,1,'2009-08-18 18:26:54',3310502495,1),(470348236,425816020,15125720,2190594,1,'2009-08-18 18:26:54',3310502495,1),(470348239,425816820,15124630,2190594,1,'2009-08-18 18:26:55',3310502495,1),(470348241,425818380,15124450,2190594,1,'2009-08-18 18:26:55',3310502495,1),(470348244,425820920,15121970,2190594,1,'2009-08-18 18:26:56',3310502495,1),(470348245,425821970,15121430,2190594,1,'2009-08-18 18:26:56',3310502495,1),(470348248,425828480,15122200,2190594,1,'2009-08-18 18:26:56',3310502495,1),(470348249,425828930,15120250,2190594,1,'2009-08-18 18:26:56',3310502495,1),(470348250,425830870,15119670,2190594,1,'2009-08-18 18:26:57',3310502495,1),(470348254,425831520,15118380,2190594,1,'2009-08-18 18:26:58',3310502495,1),(470348257,425834500,15117980,2190594,1,'2009-08-18 18:26:58',3310502495,1),(470348260,425836450,15114580,2190594,1,'2009-08-18 18:26:58',3310502495,1),(470348263,425836350,15113970,2190594,1,'2009-08-18 18:26:59',3310502495,1),(470348264,425837480,15113620,2190594,1,'2009-08-18 18:26:59',3310502666,1),(470348269,425839080,15109520,2190594,1,'2009-08-18 18:27:00',3310502666,1),(470348271,425839730,15109170,2190594,1,'2009-08-18 18:27:00',3310502666,1),(470348272,425839330,15107380,2190594,1,'2009-08-18 18:27:01',3310502666,1),(470348273,425839450,15105030,2190594,1,'2009-08-18 18:27:01',3310502664,1),(470348274,425839000,15103700,2190594,1,'2009-08-18 18:27:01',3310502664,1),(470348275,425839500,15104600,2190594,1,'2009-08-18 18:27:02',3310502664,1),(470348277,425841000,15104870,2190594,1,'2009-08-18 18:27:02',3310502664,1),(470348279,425841730,15105700,2190594,1,'2009-08-18 18:27:03',3310502664,1),(470348280,425844020,15104500,2190594,1,'2009-08-18 18:27:03',3310502664,1),(470348281,425844470,15104780,2190594,1,'2009-08-18 18:27:04',3310502664,1),(470348282,425844450,15104070,2190594,1,'2009-08-18 18:27:04',3310502664,1),(470348283,425845120,15104030,2190594,1,'2009-08-18 18:27:04',3310502664,1),(470348286,425845470,15104170,2190594,1,'2009-08-18 18:27:05',3310502664,1),(470348288,425845670,15106770,2190594,1,'2009-08-18 18:27:05',3310502666,1),(470348290,425845620,15107450,2190594,1,'2009-08-18 18:27:06',3310502666,1),(470348292,425845180,15106700,2190594,1,'2009-08-18 18:27:06',3310502666,1),(470348294,425845180,15107400,2190594,1,'2009-08-18 18:27:06',3310502666,1),(470348299,425845970,15112020,2190594,1,'2009-08-18 18:27:06',3310502666,1),(470348301,425847380,15113820,2190594,1,'2009-08-18 18:27:08',3310502666,1),(470348302,425848800,15117380,2190594,1,'2009-08-18 18:27:08',3310502666,1),(470348303,425849770,15118400,2190594,1,'2009-08-18 18:27:08',3310502666,1),(470348304,425850850,15121230,2190594,1,'2009-08-18 18:27:08',3310502666,1),(470348305,425850480,15121770,2190594,1,'2009-08-18 18:27:09',3310502666,1),(470348306,425850480,15123320,2190594,1,'2009-08-18 18:27:09',3310502666,1),(470348307,425854880,15129180,2190594,1,'2009-08-18 18:27:09',3310502666,1),(470348308,425856700,15133070,2190594,1,'2009-08-18 18:27:10',3310502666,1),(470348309,425861480,15137770,2190594,1,'2009-08-18 18:27:10',3310502666,1),(470348310,425865150,15138200,2190594,1,'2009-08-18 18:27:10',3310502667,1),(470348311,425866150,15137570,2190594,1,'2009-08-18 18:27:11',3310502667,1),(470348312,425869680,15137030,2190594,1,'2009-08-18 18:27:11',3310502667,1),(470348314,425873780,15132430,2190594,1,'2009-08-18 18:27:12',3310502667,1),(470348315,425875300,15132050,2190594,1,'2009-08-18 18:27:13',3310502667,1),(470348316,425877170,15133000,2190594,1,'2009-08-18 18:27:14',3310502667,1),(470348318,425879320,15133120,2190594,1,'2009-08-18 18:27:14',3310502667,1),(470348319,425879530,15132570,2190594,1,'2009-08-18 18:27:14',3310502667,1),(470348321,425880450,15132550,2190594,1,'2009-08-18 18:27:15',3310502667,1),(470348322,425881470,15130420,2190594,1,'2009-08-18 18:27:15',3310502667,1),(470348325,425882700,15129050,2190594,1,'2009-08-18 18:27:15',3310502667,1),(470348326,425884850,15128030,2190594,1,'2009-08-18 18:27:16',3310502667,1),(470348327,425886320,15126400,2190594,1,'2009-08-18 18:27:16',3310502667,1),(470348328,425888670,15125580,2190594,1,'2009-08-18 18:27:16',3310502667,1),(470348329,425891950,15127820,2190594,1,'2009-08-18 18:27:16',3310502670,1),(470348330,425893030,15126700,2190594,1,'2009-08-18 18:27:17',3310502670,1),(470348332,425894080,15127180,2190594,1,'2009-08-18 18:27:18',3310502670,1),(470348333,425893920,15128350,2190594,1,'2009-08-18 18:27:18',3310502670,1),(470348335,425892720,15128850,2190594,1,'2009-08-18 18:27:18',3310502670,1),(470348337,425892850,15131700,2190594,1,'2009-08-18 18:27:19',3310502670,1),(470348338,425893820,15134300,2190594,1,'2009-08-18 18:27:19',3310502670,1),(470348339,425893700,15137350,2190594,1,'2009-08-18 18:27:19',3310502670,1),(470348341,425896670,15142450,2190594,1,'2009-08-18 18:27:20',3310502670,1),(470349572,425896769,15124323,2190594,1,'2009-08-18 18:33:11',3310502670,1),(470349573,425895316,15126040,2190594,1,'2009-08-18 18:33:11',3310502670,1),(470349575,425892851,15127842,2190594,1,'2009-08-18 18:33:12',3310502670,1),(470349576,425891335,15129387,2190594,1,'2009-08-18 18:33:12',3310502667,1),(470349578,425889818,15130932,2190594,1,'2009-08-18 18:33:12',3310502667,1),(470349580,425887923,15133507,2190594,1,'2009-08-18 18:33:13',3310502667,1),(470349603,425886848,15135223,2190594,1,'2009-08-18 18:33:14',3310502667,1),(470349632,425899486,15122177,2190594,1,'2009-08-18 18:33:16',3310502670,1),(470351662,425807150,15134920,2190782,1,'2009-08-18 18:45:43',3310502494,1),(470351674,425808430,15134800,2190782,1,'2009-08-18 18:45:44',3310502494,1),(470351687,425808970,15135480,2190782,1,'2009-08-18 18:45:44',3310502494,1),(470351695,425808850,15135830,2190782,1,'2009-08-18 18:45:45',3310502494,1),(470351696,425810230,15136150,2190782,1,'2009-08-18 18:45:45',3310502495,1),(470351698,425808850,15139720,2190782,1,'2009-08-18 18:45:46',3310502494,1),(470351699,425807550,15140500,2190782,1,'2009-08-18 18:45:46',3310502494,1),(470351700,425808000,15141480,2190782,1,'2009-08-18 18:45:48',3310502494,1),(470351702,425808700,15140920,2190782,1,'2009-08-18 18:45:48',3310502494,1),(470351703,425809300,15142050,2190782,1,'2009-08-18 18:45:49',3310502495,1),(470351704,425810030,15141450,2190782,1,'2009-08-18 18:45:49',3310502495,1),(470351705,425811630,15141500,2190782,1,'2009-08-18 18:45:49',3310502495,1),(470351706,425812470,15141770,2190782,1,'2009-08-18 18:45:50',3310502495,1),(470352988,425826484,15171772,2190826,1,'2009-08-18 18:50:13',3310502517,1),(470352989,425826330,15170480,2190826,1,'2009-08-18 18:50:13',3310502517,1),(470352990,425822080,15166850,2190826,1,'2009-08-18 18:50:14',3310502517,1),(470352991,425821630,15165480,2190826,1,'2009-08-18 18:50:14',3310502517,1),(470352992,425820630,15164370,2190826,1,'2009-08-18 18:50:14',3310502517,1),(470352993,425819880,15161650,2190826,1,'2009-08-18 18:50:14',3310502517,1),(470352995,425818280,15159650,2190826,1,'2009-08-18 18:50:15',3310502495,1),(470352996,425818420,15157650,2190826,1,'2009-08-18 18:50:15',3310502495,1),(470352997,425818920,15156620,2190826,1,'2009-08-18 18:50:16',3310502495,1),(470352998,425819270,15156770,2190826,1,'2009-08-18 18:50:16',3310502495,1),(470352999,425819530,15153970,2190826,1,'2009-08-18 18:50:16',3310502495,1),(470353000,425819220,15153400,2190826,1,'2009-08-18 18:50:16',3310502495,1),(470353001,425819570,15152550,2190826,1,'2009-08-18 18:50:16',3310502495,1),(470353002,425819230,15152000,2190826,1,'2009-08-18 18:50:16',3310502495,1),(470353003,425819720,15150870,2190826,1,'2009-08-18 18:50:17',3310502495,1),(470353004,425818370,15145650,2190826,1,'2009-08-18 18:50:17',3310502495,1),(470353005,425815370,15140980,2190826,1,'2009-08-18 18:50:17',3310502495,1),(470353006,425815300,15142000,2190826,1,'2009-08-18 18:50:17',3310502495,1),(470353007,425814620,15142650,2190826,1,'2009-08-18 18:50:18',3310502495,1),(470353008,425814300,15142250,2190826,1,'2009-08-18 18:50:18',3310502495,1),(470353009,425814030,15143280,2190826,1,'2009-08-18 18:50:19',3310502495,1),(470353010,425813220,15142330,2190826,1,'2009-08-18 18:50:19',3310502495,1),(470353011,425812470,15142450,2190826,1,'2009-08-18 18:50:19',3310502495,1),(470356873,425823291,15172101,2191053,1,'2009-08-18 19:08:40',3310502517,1),(470357335,425823723,15172878,2191053,1,'2009-08-18 19:10:23',3310502517,1),(470357336,425824114,15173574,2191053,1,'2009-08-18 19:10:23',3310502517,1),(470357338,425823987,15174175,2191053,1,'2009-08-18 19:10:23',3310502517,1),(470357340,425823300,15175230,2191053,1,'2009-08-18 19:10:24',3310502517,1),(470357348,425823293,15175661,2191053,1,'2009-08-18 19:10:26',3310502517,1),(470358230,425823716,15181204,2191112,1,'2009-08-18 19:14:56',3310502517,1),(470358231,425823527,15182320,2191112,1,'2009-08-18 19:14:56',3310502517,1),(470358232,425823400,15183779,2191112,1,'2009-08-18 19:16:02',3310502517,2),(470358240,425824222,15177942,2191112,1,'2009-08-18 19:15:02',3310502517,1),(470358241,425824159,15178886,2191112,1,'2009-08-18 19:15:02',3310502517,1),(470358242,425823969,15180002,2191112,1,'2009-08-18 19:15:03',3310502517,1),(470358581,425823780,15181633,2191112,1,'2009-08-18 19:17:42',3310502517,2),(470358582,425824348,15181805,2191112,1,'2009-08-18 19:17:43',3310502517,2),(470358583,425824222,15183178,2191112,1,'2009-08-18 19:17:43',3310502517,2),(470358584,425823527,15183092,2191112,1,'2009-08-18 19:17:43',3310502517,2),(470362088,425825130,15213350,2191272,1,'2009-08-18 19:31:26',3310502517,1),(470362090,425833270,15221230,2191272,1,'2009-08-18 19:31:26',3310502519,1),(470362091,425837450,15227400,2191272,1,'2009-08-18 19:31:26',3310502690,1),(470362096,425839020,15229020,2191272,1,'2009-08-18 19:31:27',3310502690,1),(470362099,425844050,15230230,2191272,1,'2009-08-18 19:31:27',3310502690,1),(470362102,425847100,15231770,2191272,1,'2009-08-18 19:31:28',3310502690,1),(470362105,425856980,15231280,2191272,1,'2009-08-18 19:31:28',3310502690,1),(470362109,425859030,15232420,2191272,1,'2009-08-18 19:31:28',3310502690,1),(470362112,425861300,15232600,2191272,1,'2009-08-18 19:31:29',3310502690,1),(470362115,425862120,15233900,2191272,1,'2009-08-18 19:31:29',3310502690,1),(470362117,425864050,15240300,2191272,1,'2009-08-18 19:31:29',3310502691,1),(470362120,425864750,15240970,2191272,1,'2009-08-18 19:31:30',3310502691,1),(470362123,425867830,15239420,2191272,1,'2009-08-18 19:31:30',3310502691,1),(470362131,425869650,15239100,2191272,1,'2009-08-18 19:31:30',3310502691,1),(470362132,425878250,15242230,2191272,1,'2009-08-18 19:31:31',3310502691,1),(470362134,425882300,15246750,2191272,1,'2009-08-18 19:31:32',3310502691,1),(470362136,425883880,15247500,2191272,1,'2009-08-18 19:31:32',3310502691,1),(470362138,425885270,15247000,2191272,1,'2009-08-18 19:31:33',3310502691,1),(470362140,425886120,15247250,2191272,1,'2009-08-18 19:31:33',3310502691,1),(470362142,425888250,15253220,2191272,1,'2009-08-18 19:31:33',3310502691,1),(470362143,425892530,15256650,2191272,1,'2009-08-18 19:31:33',3310502694,1),(470362144,425896770,15257050,2191272,1,'2009-08-18 19:31:34',3310502694,1),(470362145,425905750,15260270,2191272,1,'2009-08-18 19:31:34',3310502694,1),(470362147,425909870,15260480,2191272,1,'2009-08-18 19:31:34',3310502694,1),(470362152,425911150,15261380,2191272,1,'2009-08-18 19:31:35',3310502694,1),(470362154,425914480,15265770,2191272,1,'2009-08-18 19:31:36',3310502694,1),(470362156,425917080,15268020,2191272,1,'2009-08-18 19:31:36',3310502694,1),(470362158,425917750,15269150,2191272,1,'2009-08-18 19:31:36',3310502694,1),(470362160,425920380,15271250,2191272,1,'2009-08-18 19:31:36',3310502701,1),(470362162,425921100,15271270,2191272,1,'2009-08-18 19:31:36',3310502701,1),(470362163,425923530,15268970,2191272,1,'2009-08-18 19:31:37',3310502695,1),(470362164,425925220,15268230,2191272,1,'2009-08-18 19:31:37',3310502695,1),(470363726,425969230,15270400,2191328,1,'2009-08-18 19:36:58',3310502706,1),(470363727,425974680,15279280,2191328,1,'2009-08-18 19:36:58',3310502713,1),(470363728,425974670,15279880,2191328,1,'2009-08-18 19:36:58',3310502713,1),(470363729,425974180,15279920,2191328,1,'2009-08-18 19:36:59',3310502713,1),(470363730,425970570,15277620,2191328,1,'2009-08-18 19:36:59',3310502712,1),(470363731,425969594,15277791,2191328,1,'2009-08-18 19:36:59',3310502712,1),(470364200,425961249,15267400,2191328,1,'2009-08-18 19:38:39',3310502706,1),(470364482,425960996,15265598,2191328,1,'2009-08-18 19:39:28',3310502706,1),(470364483,425962007,15266885,2191328,1,'2009-08-18 19:39:28',3310502706,1),(470364484,425962070,15266113,2191328,1,'2009-08-18 19:39:28',3310502706,1),(470364486,425961249,15265169,2191328,1,'2009-08-18 19:39:28',3310502706,1),(470364488,425961628,15265856,2191328,1,'2009-08-18 19:39:36',3310502706,1),(470365193,425960427,15250063,2191328,1,'2009-08-18 19:42:34',3310502706,1),(470365194,425959985,15253067,2191328,1,'2009-08-18 19:42:34',3310502706,1),(470365195,425959290,15256414,2191328,1,'2009-08-18 19:42:35',3310502706,1),(470365202,425958342,15260019,2191328,1,'2009-08-18 19:42:35',3310502706,1),(470365211,425957458,15264053,2191328,1,'2009-08-18 19:42:35',3310502706,1),(470365221,425957079,15266285,2191328,1,'2009-08-18 19:42:36',3310502706,1),(470365232,425955689,15271606,2191328,1,'2009-08-18 19:42:36',3310502712,1),(470365242,425954299,15276584,2191328,1,'2009-08-18 19:42:36',3310502712,1),(470365262,425958076,15264835,2191328,1,'2009-08-18 19:42:42',3310502706,1),(470365699,425997656,15196688,2357704,1,'2009-09-03 13:36:35',3310502705,2),(470365700,425991022,15201151,2357704,1,'2009-09-03 13:36:35',3310502705,2),(470365701,425986599,15205271,2357704,1,'2009-09-03 13:36:35',3310502705,2),(470365703,425982415,15210409,2191328,1,'2009-08-18 19:45:22',3310502705,1),(470365704,425978940,15213155,2191328,1,'2009-08-18 19:45:22',3310502705,1),(470365706,425975591,15217189,2191328,1,'2009-08-18 19:45:22',3310502707,1),(470365708,425973443,15219078,2191328,1,'2009-08-18 19:45:22',3310502706,1),(470365709,425969842,15221395,2191328,1,'2009-08-18 19:45:23',3310502706,1),(470365710,425966998,15223798,2191328,1,'2009-08-18 19:45:23',3310502706,1),(470365711,425964661,15226974,2191328,1,'2009-08-18 19:45:23',3310502706,1),(470365712,425963523,15229206,2191328,1,'2009-08-18 19:45:23',3310502706,1),(470365713,425962512,15231781,2191328,1,'2009-08-18 19:45:24',3310502706,1),(470365714,425961881,15234871,2191328,1,'2009-08-18 19:45:24',3310502706,1),(470365715,425961375,15237961,2191328,1,'2009-08-18 19:45:24',3310502706,1),(470365716,425961438,15242252,2191328,1,'2009-08-18 19:45:24',3310502706,1),(470365717,425960806,15246629,2191328,1,'2009-08-18 19:45:25',3310502706,1),(482113340,426251662,14999719,2357182,1,'2009-09-03 12:35:53',3310502743,1),(482113341,426252041,14996715,2357182,1,'2009-09-03 12:35:53',3310502743,1),(482113342,426251536,14991909,2357182,1,'2009-09-03 12:35:53',3310502741,1),(482113343,426250399,14987188,2357182,1,'2009-09-03 12:35:53',3310502741,1),(482113344,426248252,14982553,2357182,1,'2009-09-03 12:35:53',3310502740,1),(482113345,426246610,14980064,2357182,1,'2009-09-03 12:35:53',3310502740,1),(482113739,426240168,15069929,2357182,1,'2009-09-03 12:37:28',3310502748,1),(482113740,426239663,15066324,2357182,1,'2009-09-03 12:37:29',3310502748,1),(482113741,426237642,15061002,2357182,1,'2009-09-03 12:37:29',3310502748,1),(482113742,426235242,15057312,2357182,1,'2009-09-03 12:37:29',3310502748,1),(482113743,426232905,15054737,2357182,1,'2009-09-03 12:37:29',3310502748,1),(482113744,426229368,15049329,2357182,1,'2009-09-03 12:40:31',3310502742,2),(482113745,426225958,15047441,2357182,1,'2009-09-03 12:37:29',3310502742,1),(482113746,426223432,15046154,2357182,1,'2009-09-03 12:37:29',3310502742,1),(482113747,426220084,15043836,2357182,1,'2009-09-03 12:37:29',3310502739,1),(482113748,426219200,15042291,2357182,1,'2009-09-03 12:37:29',3310502739,1),(482113749,426218695,15041004,2357182,1,'2009-09-03 12:40:31',3310502739,2),(482113750,426220274,15038686,2357182,1,'2009-09-03 12:37:29',3310502739,1),(482113751,426219326,15037570,2357182,1,'2009-09-03 12:37:29',3310502739,1),(482113752,426217432,15036712,2357182,1,'2009-09-03 12:40:31',3310502739,2),(482113753,426215537,15034137,2357182,1,'2009-09-03 12:40:31',3310502739,2),(482113754,426214779,15030275,2357182,1,'2009-09-03 12:40:31',3310502739,2),(482113755,426216042,15028730,2357182,1,'2009-09-03 12:37:30',3310502739,1),(482113756,426218063,15026670,2357182,1,'2009-09-03 12:37:30',3310502739,1),(482113757,426220905,15024953,2357182,1,'2009-09-03 12:37:30',3310502739,1),(482113758,426221095,15022722,2357182,1,'2009-09-03 12:37:30',3310502739,1),(482113759,426220716,15020662,2357182,1,'2009-09-03 12:37:30',3310502739,1),(482113760,426219958,15019289,2357182,1,'2009-09-03 12:37:30',3310502739,1),(482113761,426219832,15016113,2357182,1,'2009-09-03 12:37:30',3310502739,1),(482113762,426220084,15013280,2357182,1,'2009-09-03 12:40:31',3310502739,2),(482113763,426221853,15010362,2357182,1,'2009-09-03 12:37:30',3310502742,1),(482113764,426224379,15007272,2357182,1,'2009-09-03 12:37:31',3310502742,1),(482113765,426228042,15005212,2357182,1,'2009-09-03 12:37:31',3310502742,1),(482113766,426231326,15005813,2357182,1,'2009-09-03 12:37:31',3310502742,1),(482113767,426235431,15007787,2357182,1,'2009-09-03 12:37:31',3310502742,1),(482113768,426239410,15008817,2357182,1,'2009-09-03 12:37:31',3310502742,1),(482113769,426241557,15008131,2357182,1,'2009-09-03 12:37:31',3310502742,1),(482113770,426244463,15007530,2357182,1,'2009-09-03 12:37:31',3310502742,1),(482113771,426246799,15005212,2357182,1,'2009-09-03 12:37:31',3310502742,1),(482113772,426248504,15003496,2357182,1,'2009-09-03 12:37:31',3310502742,1),(482113773,426232531,15053317,2357182,1,'2009-09-03 12:37:32',3310502748,1),(482114101,426231137,15052076,2357182,1,'2009-09-03 12:40:30',3310502748,1),(482114102,426221979,15045724,2357182,1,'2009-09-03 12:40:31',3310502742,1),(482114103,426214779,15032335,2357182,1,'2009-09-03 12:40:31',3310502739,1),(482114225,426230379,15066753,2357182,1,'2009-09-03 12:41:46',3310502748,1),(482114227,426232589,15066839,2357182,1,'2009-09-03 12:41:46',3310502748,1),(482114229,426234294,15067354,2357182,1,'2009-09-03 12:41:46',3310502748,1),(482114231,426236000,15067697,2357182,1,'2009-09-03 12:41:46',3310502748,1),(482114232,426237642,15068212,2357182,1,'2009-09-03 12:41:46',3310502748,1),(482114235,426239157,15069500,2357182,1,'2009-09-03 12:41:47',3310502748,1),(482114237,426242505,15071044,2357182,1,'2009-09-03 12:41:47',3310502748,1),(482124370,426192610,15089412,2357182,1,'2009-09-03 12:50:02',3310502744,1),(482124371,426192358,15088211,2357182,1,'2009-09-03 12:50:03',3310502744,1),(482124373,426193558,15088554,2357182,1,'2009-09-03 12:50:03',3310502744,1),(482124375,426194821,15090528,2357182,1,'2009-09-03 12:50:03',3310502745,1),(482124378,426196084,15091815,2357182,1,'2009-09-03 12:50:03',3310502745,1),(482124380,426197031,15090786,2357182,1,'2009-09-03 12:50:03',3310502745,1),(482124381,426198610,15090700,2357182,1,'2009-09-03 12:50:03',3310502745,1),(482124383,426200189,15090442,2357182,1,'2009-09-03 12:50:03',3310502745,1),(482124388,426201074,15091386,2357182,1,'2009-09-03 12:50:03',3310502745,1),(482124389,426202526,15092845,2357182,1,'2009-09-03 12:50:03',3310502745,1),(482124392,426203663,15092674,2357182,1,'2009-09-03 12:50:03',3310502745,1),(482124395,426205242,15092330,2357182,1,'2009-09-03 12:50:04',3310502745,1),(482124397,426206947,15090786,2357182,1,'2009-09-03 12:50:04',3310502745,1),(482124398,426209284,15088726,2357182,1,'2009-09-03 12:50:04',3310502745,1),(482124399,426210168,15087266,2357182,1,'2009-09-03 12:50:04',3310502745,1),(482124402,426211684,15085807,2357182,1,'2009-09-03 12:50:04',3310502745,1),(482124404,426212442,15085035,2357182,1,'2009-09-03 12:50:04',3310502745,1),(482124407,426213768,15085121,2357182,1,'2009-09-03 12:50:04',3310502745,1),(482124408,426215347,15084606,2357182,1,'2009-09-03 12:50:04',3310502745,1),(482124409,426216674,15084520,2357182,1,'2009-09-03 12:50:04',3310502745,1),(482124415,426218884,15084091,2357182,1,'2009-09-03 12:50:04',3310502745,1),(482124418,426220400,15083318,2357182,1,'2009-09-03 12:50:05',3310502745,1),(482124421,426221158,15082546,2357182,1,'2009-09-03 12:50:05',3310502748,1),(482124424,426222232,15084606,2357182,1,'2009-09-03 12:50:05',3310502748,1),(482124425,426222737,15083576,2357182,1,'2009-09-03 12:50:05',3310502748,1),(482124427,426223179,15082374,2357182,1,'2009-09-03 12:50:05',3310502748,1),(482124430,426223937,15081087,2357182,1,'2009-09-03 12:50:05',3310502748,1),(482124432,426224695,15081172,2357182,1,'2009-09-03 12:50:05',3310502748,1),(482124434,426225579,15081687,2357182,1,'2009-09-03 12:50:05',3310502748,1),(482124435,426226274,15080743,2357182,1,'2009-09-03 12:50:05',3310502748,1),(482124441,426226716,15080143,2357182,1,'2009-09-03 12:50:05',3310502748,1),(482124443,426227916,15080143,2357182,1,'2009-09-03 12:50:06',3310502748,1),(482124445,426228610,15078941,2357182,1,'2009-09-03 12:50:06',3310502748,1),(482124448,426228547,15077653,2357182,1,'2009-09-03 12:50:06',3310502748,1),(482124450,426228989,15077053,2357182,1,'2009-09-03 12:50:06',3310502748,1),(482124451,426229621,15077310,2357182,1,'2009-09-03 12:50:06',3310502748,1),(482124454,426230252,15076795,2357182,1,'2009-09-03 12:50:06',3310502748,1),(482124457,426230316,15076108,2357182,1,'2009-09-03 12:50:06',3310502748,1),(482124459,426230316,15074821,2357182,1,'2009-09-03 12:50:06',3310502748,1),(482124460,426230758,15073276,2357182,1,'2009-09-03 12:50:06',3310502748,1),(482124466,426231516,15072589,2357182,1,'2009-09-03 12:50:06',3310502748,1),(482124468,426231326,15071645,2357182,1,'2009-09-03 12:50:07',3310502748,1),(482124470,426231642,15070873,2357182,1,'2009-09-03 12:50:07',3310502748,1),(482124473,426231768,15070358,2357182,1,'2009-09-03 12:50:07',3310502748,1),(482124475,426230631,15067611,2357182,1,'2009-09-03 12:50:07',3310502748,1),(482143961,426064930,15164677,2357481,1,'2009-09-03 13:05:01',3310502752,1),(482143969,426066004,15164677,2357481,1,'2009-09-03 13:05:01',3310502752,1),(482143974,426067268,15164763,2357481,1,'2009-09-03 13:05:01',3310502752,1),(482143976,426067900,15164935,2357481,1,'2009-09-03 13:05:02',3310502752,1),(482143978,426068721,15164591,2357481,1,'2009-09-03 13:05:02',3310502752,1),(482143984,426069858,15163733,2357481,1,'2009-09-03 13:05:02',3310502752,1),(482143987,426070363,15163047,2357481,1,'2009-09-03 13:05:02',3310502752,1),(482143992,426071121,15162446,2357481,1,'2009-09-03 13:05:02',3310502752,1),(482143997,426071816,15162703,2357481,1,'2009-09-03 13:05:02',3310502752,1),(482144000,426072701,15162789,2357481,1,'2009-09-03 13:05:02',3310502752,1),(482144005,426073711,15162532,2357481,1,'2009-09-03 13:05:03',3310502752,1),(482144009,426074406,15162446,2357481,1,'2009-09-03 13:05:03',3310502752,1),(482144019,426074849,15162875,2357481,1,'2009-09-03 13:05:03',3310502752,1),(482144023,426075480,15162789,2357481,1,'2009-09-03 13:05:03',3310502752,1),(482144027,426076428,15163047,2357481,1,'2009-09-03 13:05:03',3310502752,1),(482144030,426077186,15163561,2357481,1,'2009-09-03 13:05:03',3310502752,1),(482144032,426077502,15163218,2357481,1,'2009-09-03 13:05:03',3310502752,1),(482144036,426079271,15163047,2357481,1,'2009-09-03 13:05:04',3310502752,1),(482144040,426079965,15162961,2357481,1,'2009-09-03 13:05:04',3310502752,1),(482144044,426080724,15162961,2357481,1,'2009-09-03 13:05:04',3310502752,1),(482144048,426081292,15163132,2357481,1,'2009-09-03 13:05:04',3310502752,1),(482144052,426081671,15163304,2357481,1,'2009-09-03 13:05:04',3310502752,1),(482144069,426081987,15162617,2357481,1,'2009-09-03 13:05:05',3310502752,1),(482144078,426082113,15161759,2357481,1,'2009-09-03 13:05:05',3310502752,1),(482144087,426082240,15161072,2357481,1,'2009-09-03 13:05:05',3310502730,1),(482148188,426081734,15161587,2357481,1,'2009-09-03 13:08:11',3310502752,1),(482148191,426082303,15163819,2357481,1,'2009-09-03 13:08:11',3310502752,1),(482148194,426082240,15165621,2357481,1,'2009-09-03 13:08:11',3310502752,1),(482148198,426082050,15167252,2357481,1,'2009-09-03 13:08:11',3310502752,1),(482148201,426081671,15170085,2357481,1,'2009-09-03 13:08:11',3310502752,1),(482148204,426081103,15173432,2357481,1,'2009-09-03 13:08:11',3310502752,1),(482148213,426080155,15176179,2357481,1,'2009-09-03 13:08:12',3310502752,1),(482148217,426078828,15177895,2357481,1,'2009-09-03 13:08:12',3310502752,1),(482148220,426077565,15179526,2357481,1,'2009-09-03 13:08:12',3310502752,1),(482148223,426075480,15181672,2357481,1,'2009-09-03 13:08:12',3310502752,1),(482148226,426072638,15184848,2357481,1,'2009-09-03 13:08:12',3310502752,1),(482148228,426070300,15190341,2357481,1,'2009-09-03 13:08:12',3310502752,1),(482148231,426069984,15192744,2357481,1,'2009-09-03 13:08:12',3310502752,1),(482148234,426069668,15194976,2357481,1,'2009-09-03 13:08:12',3310502752,1),(482150309,426192717,15090090,2357481,1,'2009-09-03 13:10:34',3310502744,1),(482158226,426019330,15181650,2357704,1,'2009-09-03 13:35:42',3310502708,1),(482158227,426018030,15183970,2357704,1,'2009-09-03 13:35:42',3310502708,1),(482158228,426017530,15186270,2357704,1,'2009-09-03 13:35:42',3310502708,1),(482158229,426013520,15190680,2357704,1,'2009-09-03 13:35:42',3310502708,1),(482158230,426009430,15192520,2357704,1,'2009-09-03 13:35:42',3310502708,1),(482158231,426006580,15195150,2357704,1,'2009-09-03 13:35:42',3310502708,1),(482158232,426004000,15196680,2357704,1,'2009-09-03 13:35:42',3310502708,1),(482158233,426002850,15198480,2357704,1,'2009-09-03 13:35:42',3310502708,1),(482158234,425998450,15199400,2357704,1,'2009-09-03 13:35:43',3310502705,1),(482158235,425995720,15201780,2357704,1,'2009-09-03 13:35:43',3310502705,1),(482158236,425994480,15201580,2357704,1,'2009-09-03 13:35:43',3310502705,1),(482158237,425992130,15202600,2357704,1,'2009-09-03 13:35:43',3310502705,1),(482158238,425988000,15206220,2357704,1,'2009-09-03 13:35:43',3310502705,1),(482158239,425985020,15209950,2357704,1,'2009-09-03 13:35:43',3310502705,1),(482158240,425982070,15214780,2357704,1,'2009-09-03 13:35:43',3310502705,1),(482158241,425979120,15224280,2357704,1,'2009-09-03 13:35:43',3310502707,1),(482158243,425977250,15227000,2357704,1,'2009-09-03 13:35:44',3310502707,1),(482158246,425974130,15233880,2357704,1,'2009-09-03 13:35:44',3310502707,1),(482158248,425973950,15236730,2357704,1,'2009-09-03 13:35:44',3310502707,1),(482158251,425972480,15234530,2357704,1,'2009-09-03 13:35:44',3310502706,1),(482158252,425971370,15236650,2357704,1,'2009-09-03 13:35:44',3310502706,1),(482158253,425970750,15236400,2357704,1,'2009-09-03 13:35:44',3310502706,1),(482158254,425970150,15236950,2357704,1,'2009-09-03 13:35:44',3310502706,1),(482158255,425967730,15237250,2357704,1,'2009-09-03 13:35:44',3310502706,1),(482158256,425965400,15239780,2357704,1,'2009-09-03 13:35:44',3310502706,1),(482158257,425964920,15239520,2357704,1,'2009-09-03 13:35:44',3310502706,1),(482158258,425964350,15240200,2357704,1,'2009-09-03 13:35:44',3310502706,1),(482158259,425964230,15242450,2357704,1,'2009-09-03 13:35:45',3310502706,1),(482158260,425965420,15246180,2357704,1,'2009-09-03 13:35:45',3310502706,1),(482158261,425965300,15246780,2357704,1,'2009-09-03 13:35:45',3310502706,1),(482158262,425966330,15248430,2357704,1,'2009-09-03 13:35:45',3310502706,1),(482158263,425965070,15250270,2357704,1,'2009-09-03 13:35:45',3310502706,1),(482158264,425966230,15253370,2357704,1,'2009-09-03 13:35:45',3310502706,1),(482158265,425965900,15253780,2357704,1,'2009-09-03 13:35:45',3310502706,1),(482158266,425961820,15251830,2357704,1,'2009-09-03 13:35:45',3310502706,1),(482158267,425960430,15252150,2357704,1,'2009-09-03 13:35:45',3310502706,1),(482158268,425960220,15253470,2357704,1,'2009-09-03 13:35:45',3310502706,1),(482158269,425961270,15256380,2357704,1,'2009-09-03 13:35:45',3310502706,1),(482158872,425966002,15252134,2357704,1,'2009-09-03 13:37:50',3310502706,1),(482158873,425964170,15252649,2357704,1,'2009-09-03 13:37:51',3310502706,1),(482159051,426022359,15179521,2357704,1,'2009-09-03 13:39:07',3310502708,1),(482159053,426021348,15180208,2357704,1,'2009-09-03 13:39:07',3310502708,1),(485577918,426546300,15392830,2387382,1,'2009-09-06 10:39:29',3310503617,1),(485577920,426543500,15392500,2387382,1,'2009-09-06 10:39:29',3310503617,1),(485577921,426538900,15399430,2387382,1,'2009-09-06 10:39:29',3310503617,1),(485577922,426537250,15410450,2387382,1,'2009-09-06 10:39:29',3310503617,1),(485577923,426536240,15408790,2387382,1,'2009-09-06 10:39:29',3310503617,1),(485577924,426534830,15409070,2387382,1,'2009-09-06 10:39:29',3310503617,1),(485577925,426534350,15406870,2387382,1,'2009-09-06 10:39:29',3310503617,1),(485577926,426533700,15408210,2387382,1,'2009-09-06 10:39:29',3310503617,1),(485577927,426531870,15406500,2387382,1,'2009-09-06 10:39:30',3310503617,1),(485577928,426531050,15404280,2387382,1,'2009-09-06 10:39:30',3310503617,1),(485577929,426530980,15401530,2387382,1,'2009-09-06 10:39:30',3310503617,1),(485577930,426528560,15399330,2387382,1,'2009-09-06 10:39:30',3310503617,1),(485577931,426527470,15399190,2387382,1,'2009-09-06 10:39:30',3310503617,1),(485577932,426526720,15400490,2387382,1,'2009-09-06 10:39:30',3310503617,1),(485577933,426528130,15409840,2387382,1,'2009-09-06 10:39:30',3310503617,1),(485577934,426527690,15420010,2387382,1,'2009-09-06 10:39:30',3310503617,1),(485577936,426529370,15423670,2387382,1,'2009-09-06 10:39:30',3310503617,1),(485577937,426531980,15425310,2387382,1,'2009-09-06 10:39:30',3310503617,1),(485577938,426536550,15431620,2387382,1,'2009-09-06 10:39:30',3310503617,1),(485577939,426538230,15436230,2387382,1,'2009-09-06 10:39:30',3310503619,1),(485577940,426537920,15448300,2387382,1,'2009-09-06 10:39:30',3310503619,1),(485577941,426534840,15459510,2387382,1,'2009-09-06 10:39:30',3310503619,1),(485577942,426539470,15480160,2387382,1,'2009-09-06 10:39:30',3310503619,1),(485577943,426540510,15500040,2387382,1,'2009-09-06 10:39:30',3310503625,1),(485577944,426541710,15505740,2387382,1,'2009-09-06 10:39:30',3310503625,1),(485577945,426541060,15514880,2387382,1,'2009-09-06 10:39:30',3310503625,1),(485577946,426544120,15525340,2387382,1,'2009-09-06 10:39:30',3310503625,1),(485577947,426544010,15526510,2387382,1,'2009-09-06 10:39:30',3310503625,1),(485577948,426543090,15523550,2387382,1,'2009-09-06 10:39:30',3310503625,1),(485577949,426540810,15526250,2387382,1,'2009-09-06 10:39:30',3310503625,1),(485577950,426539630,15525670,2387382,1,'2009-09-06 10:39:30',3310503625,1),(485577951,426538690,15527990,2387382,1,'2009-09-06 10:39:30',3310503625,1),(485577953,426535260,15543760,2387382,1,'2009-09-06 10:39:30',3310503625,1),(485577954,426530380,15554720,2387382,1,'2009-09-06 10:39:30',3310503627,1),(485577955,426529280,15559980,2387382,1,'2009-09-06 10:39:30',3310503627,1),(485577956,426525030,15566760,2387382,1,'2009-09-06 10:39:30',3310503627,1),(485577957,426522590,15573080,2387382,1,'2009-09-06 10:39:30',3310503626,1),(485577958,426521540,15577940,2387382,1,'2009-09-06 10:39:31',3310503626,1),(485577959,426519680,15582400,2387382,1,'2009-09-06 10:39:31',3310503626,1),(485577960,426520140,15584670,2387382,1,'2009-09-06 10:39:31',3310503626,1),(485577961,426528360,15597540,2387382,1,'2009-09-06 10:39:31',3310503627,1),(485577962,426532120,15605310,2387382,1,'2009-09-06 10:39:31',3310503649,1),(485577963,426534650,15620770,2387382,1,'2009-09-06 10:39:31',3310503649,1),(485577964,426533860,15624670,2387382,1,'2009-09-06 10:39:31',3310503649,1),(485577965,426528660,15634370,2387382,1,'2009-09-06 10:39:31',3310503649,1),(485577966,426528060,15637640,2387382,1,'2009-09-06 10:39:31',3310503649,1),(485577968,426525630,15647440,2387382,1,'2009-09-06 10:39:31',3310503649,1),(485577969,426523260,15648480,2387382,1,'2009-09-06 10:39:31',3310503649,1),(485577970,426523380,15651020,2387382,1,'2009-09-06 10:39:31',3310503649,1),(485577971,426519440,15651900,2387382,1,'2009-09-06 10:39:31',3310503648,1),(485577972,426517210,15656080,2387382,1,'2009-09-06 10:39:31',3310503650,1),(485577973,426516940,15658210,2387382,1,'2009-09-06 10:39:31',3310503650,1),(485577974,426514250,15659690,2387382,1,'2009-09-06 10:39:31',3310503650,1),(485577975,426511860,15663100,2387382,1,'2009-09-06 10:39:31',3310503650,1),(485577976,426505100,15666610,2387382,1,'2009-09-06 10:39:31',3310503650,1),(485577977,426502700,15666080,2387382,1,'2009-09-06 10:39:31',3310503650,1),(485577978,426499760,15666250,2387382,1,'2009-09-06 10:39:31',3310503650,1),(485577979,426499690,15668090,2387382,1,'2009-09-06 10:39:31',3310503650,1),(485577981,426497010,15674700,2387382,1,'2009-09-06 10:39:31',3310503650,1),(485577982,426492740,15679530,2387382,1,'2009-09-06 10:39:32',3310503607,1),(485577984,426484080,15696210,2387382,1,'2009-09-06 10:39:32',3310503607,1),(485577985,426483390,15697030,2387382,1,'2009-09-06 10:39:32',3310503607,1),(485577986,426481720,15696090,2387382,1,'2009-09-06 10:39:32',3310503607,1),(485577987,426480980,15696290,2387382,1,'2009-09-06 10:39:32',3310503607,1),(485577988,426481030,15698730,2387382,1,'2009-09-06 10:39:32',3310503607,1),(485577989,426482970,15706050,2387382,1,'2009-09-06 10:39:32',3310503607,1),(485577990,426482740,15709830,2387382,1,'2009-09-06 10:39:32',3310503607,1),(485577991,426484880,15714190,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485577992,426484340,15714910,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485577993,426481710,15712670,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485577994,426479210,15712290,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485577995,426479110,15718370,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485577996,426479800,15718700,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485577997,426479730,15720080,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485577998,426480560,15725350,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485577999,426480080,15730220,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485578000,426478200,15735710,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485578001,426471070,15741260,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485578003,426469180,15744010,2387382,1,'2009-09-06 10:39:32',3310503613,1),(485578004,426464950,15756380,2387382,1,'2009-09-06 10:39:32',3310503612,1),(485578005,426461980,15759260,2387382,1,'2009-09-06 10:39:32',3310503612,1),(485578006,426456940,15760370,2387382,1,'2009-09-06 10:39:33',3310503612,1),(485578007,426450760,15760350,2387382,1,'2009-09-06 10:39:33',3310503612,1),(485578008,426446200,15765340,2387382,1,'2009-09-06 10:39:33',3310503612,1),(485578009,426433740,15770520,2387382,1,'2009-09-06 10:39:33',3310503611,1),(485578010,426433130,15771940,2387382,1,'2009-09-06 10:39:33',3310503611,1),(485578011,426426470,15776150,2387382,1,'2009-09-06 10:39:33',3310503611,1),(485578012,426423540,15784000,2387382,1,'2009-09-06 10:39:33',3310503611,1),(485578013,426424510,15790190,2387382,1,'2009-09-06 10:39:33',3310503611,1),(485578014,426423740,15797560,2387382,1,'2009-09-06 10:39:33',3310503611,1),(485578016,426420000,15810690,2387382,1,'2009-09-06 10:39:33',3310503611,1),(485578017,426414930,15820800,2387382,1,'2009-09-06 10:39:33',3310504977,1),(485578018,426413540,15827160,2387382,1,'2009-09-06 10:39:33',3310504977,1),(485578019,426411060,15826070,2387382,1,'2009-09-06 10:39:33',3310504976,1),(485578020,426408550,15826460,2387382,1,'2009-09-06 10:39:33',3310504976,1),(485578021,426404240,15833110,2387382,1,'2009-09-06 10:39:33',3310504976,1),(485578022,426399540,15857220,2387382,1,'2009-09-06 10:39:33',3310504976,1),(485578023,426395790,15862690,2387382,1,'2009-09-06 10:39:33',3310504976,1),(485578024,426393830,15872360,2387382,1,'2009-09-06 10:39:33',3310504976,1),(485578025,426392130,15875910,2387382,1,'2009-09-06 10:39:33',3310504978,1),(485578026,426390350,15886660,2387382,1,'2009-09-06 10:39:33',3310504978,1),(485578027,426387230,15891700,2387382,1,'2009-09-06 10:39:33',3310504978,1),(485578028,426386320,15892640,2387382,1,'2009-09-06 10:39:33',3310504978,1),(485578029,426387090,15892820,2387382,1,'2009-09-06 10:39:33',3310504978,1),(485578030,426387360,15899350,2387382,1,'2009-09-06 10:39:33',3310504978,1),(485578031,426386060,15906640,2387382,1,'2009-09-06 10:39:33',3310504978,1),(485578032,426388500,15912790,2387382,1,'2009-09-06 10:39:33',3310504978,1),(485578033,426386510,15915900,2387382,1,'2009-09-06 10:39:33',3310504978,1),(485578035,426384040,15917710,2387382,1,'2009-09-06 10:39:33',3310504967,1),(485578036,426383450,15929800,2387382,1,'2009-09-06 10:39:34',3310504967,1),(485578037,426385590,15933940,2387382,1,'2009-09-06 10:39:34',3310504973,1),(485578038,426387260,15935210,2387382,1,'2009-09-06 10:39:34',3310504984,1),(485578039,426387160,15945070,2387382,1,'2009-09-06 10:39:34',3310504984,1),(485578040,426384280,15952690,2387382,1,'2009-09-06 10:39:34',3310504973,1),(485578041,426381920,15955700,2387382,1,'2009-09-06 10:39:34',3310504973,1),(485578042,426381100,15965500,2387382,1,'2009-09-06 10:39:34',3310504973,1),(485578043,426381870,15967690,2387382,1,'2009-09-06 10:39:34',3310504973,1),(485578044,426379010,15978020,2387382,1,'2009-09-06 10:39:34',3310504973,1),(485578045,426381120,15985720,2387382,1,'2009-09-06 10:39:34',3310504975,1),(485578046,426374760,15992360,2387382,1,'2009-09-06 10:39:34',3310504975,1),(485578048,426372880,15998550,2387382,1,'2009-09-06 10:39:34',3310504975,1),(485578049,426371000,15997230,2387382,1,'2009-09-06 10:39:34',3310504975,1),(485578050,426368680,15998520,2387382,1,'2009-09-06 10:39:34',3310504975,1),(485578051,426367300,16001320,2387382,1,'2009-09-06 10:39:34',3310504975,1),(485578052,426359450,16001280,2387382,1,'2009-09-06 10:39:34',3310504975,1),(485578053,426355210,16008520,2387382,1,'2009-09-06 10:39:34',3310504974,1),(485578054,426356690,16017610,2387382,1,'2009-09-06 10:39:34',3310504974,1),(485578055,426357770,16027260,2387382,1,'2009-09-06 10:39:34',3310504974,1),(485578056,426361160,16031810,2387382,1,'2009-09-06 10:39:34',3310504975,1),(485578057,426361480,16036730,2387382,1,'2009-09-06 10:39:34',3310504975,1),(485578058,426367230,16039200,2387382,1,'2009-09-06 10:39:34',3310504975,1),(485578059,426367870,16041840,2387382,1,'2009-09-06 10:39:34',3310504997,1),(485578060,426370360,16041370,2387382,1,'2009-09-06 10:39:34',3310504997,1),(485578062,426371160,16043940,2387382,1,'2009-09-06 10:39:34',3310504997,1),(485578063,426374390,16045530,2387382,1,'2009-09-06 10:39:34',3310504997,1),(485578064,426380360,16046070,2387382,1,'2009-09-06 10:39:34',3310504997,1),(485578065,426381360,16049700,2387382,1,'2009-09-06 10:39:35',3310504997,1),(485578066,426385870,16052730,2387382,1,'2009-09-06 10:39:35',3310504997,1),(485578067,426390660,16065640,2387382,1,'2009-09-06 10:39:35',3310505008,1),(485578068,426394750,16069360,2387382,1,'2009-09-06 10:39:35',3310505008,1),(485578070,426395550,16073010,2387382,1,'2009-09-06 10:39:35',3310505008,1),(485578071,426392590,16077230,2387382,1,'2009-09-06 10:39:35',3310505008,1),(485578072,426390240,16082900,2387382,1,'2009-09-06 10:39:35',3310505008,1),(485578073,426389860,16089310,2387382,1,'2009-09-06 10:39:35',3310505008,1),(485578074,426386940,16092710,2387382,1,'2009-09-06 10:39:35',3310505008,1),(485578075,426386570,16102250,2387382,1,'2009-09-06 10:39:35',3310505010,1),(485578076,426383820,16112880,2387382,1,'2009-09-06 10:39:35',3310504999,1),(485578077,426383230,16113630,2387382,1,'2009-09-06 10:39:35',3310504999,1),(485578079,426383960,16120770,2387382,1,'2009-09-06 10:39:35',3310504999,1),(485578080,426380830,16122560,2387382,1,'2009-09-06 10:39:35',3310504999,1),(485578081,426380510,16124880,2387382,1,'2009-09-06 10:39:35',3310504999,1),(485578082,426375500,16134020,2387382,1,'2009-09-06 10:39:35',3310504999,1),(485578083,426370260,16158950,2387382,1,'2009-09-06 10:39:35',3310505005,1),(485578084,426365460,16164680,2387382,1,'2009-09-06 10:39:35',3310505005,1),(485578085,426362480,16171590,2387382,1,'2009-09-06 10:39:36',3310505005,1),(485578086,426359630,16172630,2387382,1,'2009-09-06 10:39:36',3310505005,1),(485578087,426356950,16177620,2387382,1,'2009-09-06 10:39:36',3310505004,1),(485578088,426353780,16177570,2387382,1,'2009-09-06 10:39:36',3310505004,1),(485578089,426352330,16179450,2387382,1,'2009-09-06 10:39:36',3310505004,1),(485578090,426348550,16179910,2387382,1,'2009-09-06 10:39:36',3310505004,1),(485578091,426343240,16186310,2387382,1,'2009-09-06 10:39:36',3310505004,1),(485578092,426342680,16188760,2387382,1,'2009-09-06 10:39:36',3310505004,1),(485578093,426336720,16195880,2387382,1,'2009-09-06 10:39:36',3310505004,1),(485578095,426333560,16205040,2387382,1,'2009-09-06 10:39:36',3310505004,1),(485578096,426333710,16210230,2387382,1,'2009-09-06 10:39:36',3310505006,1),(485578097,426331500,16216190,2387382,1,'2009-09-06 10:39:36',3310505006,1),(485578098,426330670,16223400,2387382,1,'2009-09-06 10:39:36',3310505003,1),(485578099,426330550,16234180,2387382,1,'2009-09-06 10:39:36',3310505003,1),(485578100,426328480,16238180,2387382,1,'2009-09-06 10:39:36',3310505003,1),(485578101,426328670,16241030,2387382,1,'2009-09-06 10:39:36',3310505003,1),(485578102,426330090,16243020,2387382,1,'2009-09-06 10:39:36',3310505003,1),(485578103,426329760,16245700,2387382,1,'2009-09-06 10:39:36',3310505003,1),(485578104,426331540,16248330,2387382,1,'2009-09-06 10:39:36',3310505006,1),(485578105,426330590,16252500,2387382,1,'2009-09-06 10:39:36',3310505003,1),(485578106,426328800,16254840,2387382,1,'2009-09-06 10:39:36',3310505003,1),(485578107,426330970,16257000,2387382,1,'2009-09-06 10:39:36',3310505006,1),(485578108,426330300,16259910,2387382,1,'2009-09-06 10:39:36',3310505003,1),(485578109,426331620,16260580,2387382,1,'2009-09-06 10:39:36',3310505092,1),(485578111,426330030,16261650,2387382,1,'2009-09-06 10:39:36',3310505089,1),(485578112,426329220,16267420,2387382,1,'2009-09-06 10:39:36',3310505089,1),(485578113,426330070,16270090,2387382,1,'2009-09-06 10:39:36',3310505089,1),(485578114,426331220,16272230,2387382,1,'2009-09-06 10:39:36',3310505092,1),(485578115,426327620,16281040,2387382,1,'2009-09-06 10:39:36',3310505089,1),(485578116,426329120,16288640,2387382,1,'2009-09-06 10:39:36',3310505089,1),(485578117,426326800,16295690,2387382,1,'2009-09-06 10:39:37',3310505089,1),(485578118,426326510,16300610,2387382,1,'2009-09-06 10:39:37',3310505089,1),(485578119,426327520,16302720,2387382,1,'2009-09-06 10:39:37',3310505089,1),(485578120,426330820,16302320,2387382,1,'2009-09-06 10:39:37',3310505089,1),(485578121,426332970,16303530,2387382,1,'2009-09-06 10:39:37',3310505092,1),(485578122,426333860,16302390,2387382,1,'2009-09-06 10:39:37',3310505092,1),(485578124,426336330,16310810,2387382,1,'2009-09-06 10:39:37',3310505092,1),(485578125,426338160,16310840,2387382,1,'2009-09-06 10:39:37',3310505092,1),(485578126,426338610,16313250,2387382,1,'2009-09-06 10:39:37',3310505092,1),(485578127,426340690,16313850,2387382,1,'2009-09-06 10:39:37',3310505092,1),(485578128,426340850,16315510,2387382,1,'2009-09-06 10:39:37',3310505094,1),(485578129,426342800,16316160,2387382,1,'2009-09-06 10:39:37',3310505094,1),(485578130,426340870,16323210,2387382,1,'2009-09-06 10:39:37',3310505094,1),(485578133,426338270,16338910,2387382,1,'2009-09-06 10:39:37',3310505094,1),(485578134,426332580,16344260,2387382,1,'2009-09-06 10:39:37',3310505094,1),(485578135,426329920,16349200,2387382,1,'2009-09-06 10:39:37',3310505091,1),(485578136,426330700,16349230,2387382,1,'2009-09-06 10:39:37',3310505091,1),(485578137,426331300,16351000,2387382,1,'2009-09-06 10:39:37',3310505094,1),(485578138,426330280,16351000,2387382,1,'2009-09-06 10:39:37',3310505091,1),(485578139,426332220,16353130,2387382,1,'2009-09-06 10:39:37',3310505094,1),(485578140,426331260,16353800,2387382,1,'2009-09-06 10:39:37',3310505094,1),(485578142,426333040,16357040,2387382,1,'2009-09-06 10:39:37',3310505094,1),(485578143,426332240,16364250,2387382,1,'2009-09-06 10:39:37',3310505094,1),(485578146,426330530,16369800,2387382,1,'2009-09-06 10:39:38',3310505091,1),(485578159,426320020,16413160,2387382,1,'2009-09-06 10:39:38',3310505097,1),(485578160,426316910,16418010,2387382,1,'2009-09-06 10:39:38',3310505097,1),(485578161,426314540,16419620,2387382,1,'2009-09-06 10:39:38',3310505097,1),(485578162,426315620,16424580,2387382,1,'2009-09-06 10:39:38',3310505097,1),(485578163,426313160,16431450,2387382,1,'2009-09-06 10:39:38',3310505099,1),(485578164,426314740,16437390,2387382,1,'2009-09-06 10:39:39',3310505099,1),(515429490,425374178,17280820,2695454,1,'2009-10-01 05:43:20',3310493661,1),(515429491,425373204,17273302,2695454,1,'2009-10-01 05:43:20',3310493661,1),(515429492,425397413,17286852,2695454,1,'2009-10-01 05:43:20',3310504584,1),(515429493,425419738,17296659,2695454,1,'2009-10-01 05:43:20',3310504584,1),(515429494,425442923,17293904,2695454,1,'2009-10-01 05:43:20',3310504585,1),(515429495,425461465,17289945,2695454,1,'2009-10-01 05:43:20',3310504588,1),(515429496,425476443,17312384,2695454,1,'2009-10-01 05:43:20',3310504590,1),(515429497,425487620,17319796,2695454,1,'2009-10-01 05:43:20',3310504591,1),(519515756,425943579,16743492,2730324,1,'2009-10-04 02:19:39',3310504709,1),(519515757,425932413,16738599,2730324,1,'2009-10-04 02:19:40',3310504709,1),(519515758,425919314,16722418,2730324,1,'2009-10-04 02:19:40',3310504709,1),(519515759,425907122,16702459,2730324,1,'2009-10-04 02:19:40',3310504708,1),(519515760,425892157,16682533,2730324,1,'2009-10-04 02:19:40',3310504366,1),(519515761,425873506,16668932,2730324,1,'2009-10-04 02:19:40',3310504363,1),(519515762,425848387,16660435,2730324,1,'2009-10-04 02:19:40',3310504362,1),(519515763,425857910,16652183,2730324,1,'2009-10-04 02:19:40',3310504362,1),(519515764,425853665,16637764,2730324,1,'2009-10-04 02:19:40',3310504360,1),(519515765,425855587,16623926,2730324,1,'2009-10-04 02:19:41',3310504360,1),(519515766,425872336,16631266,2730324,1,'2009-10-04 02:19:41',3310504361,1),(519515767,425899283,16635981,2730324,1,'2009-10-04 02:19:41',3310504364,1),(519515768,425917990,16658369,2730324,1,'2009-10-04 02:19:41',3310504366,1),(519515769,425919069,16683484,2730324,1,'2009-10-04 02:19:41',3310504367,1),(519515770,425931230,16698414,2730324,1,'2009-10-04 02:19:41',3310504367,1),(519515771,425933890,16701954,2730324,1,'2009-10-04 02:19:41',3310504709,1),(519515772,425946206,16718342,2730324,1,'2009-10-04 02:19:41',3310504709,1),(521134858,425724747,14829230,2746094,1,'2009-10-05 10:26:44',3310502119,1),(521135636,425722408,14836611,2746094,1,'2009-10-05 10:27:20',3310502125,1),(521143390,425717166,14842276,2746135,1,'2009-10-05 10:33:14',3310502125,1),(521144650,425713942,14859614,2746135,1,'2009-10-05 10:34:10',3310502125,1),(521146418,425695043,14892573,2746135,1,'2009-10-05 10:36:15',3310502126,1),(521153185,425733148,14711057,4101446,1,'2010-03-11 22:58:46',3310502106,3),(521153188,425768495,14798575,4101446,1,'2010-03-11 22:58:46',3310502131,3),(521349887,425672011,14336387,2747796,1,'2009-10-05 13:48:01',3310501988,1),(521349888,425666338,14338480,2747796,1,'2009-10-05 13:48:01',3310501987,1),(521349889,425638696,14315282,2747796,1,'2009-10-05 13:48:01',3310501984,1),(521349890,425628478,14287319,2747796,1,'2009-10-05 13:48:01',3310501984,1),(521349907,425668985,14296040,2747796,1,'2009-10-05 13:48:01',3310501985,1),(521349908,425669784,14317424,2747796,1,'2009-10-05 13:48:01',3310501985,1),(522254633,425647676,14897282,2756081,1,'2009-10-06 02:46:58',3310502123,1),(522254634,425644280,14875442,2756081,1,'2009-10-06 02:46:58',3310502120,1),(522254635,425607712,14803109,2756081,1,'2009-10-06 02:46:58',3310502071,1),(522254636,425586107,14664202,2756081,1,'2009-10-06 02:46:58',3310502044,1),(522254637,425599360,14645873,2756081,1,'2009-10-06 02:46:58',3310502045,1),(522254638,425600809,14656591,2756081,1,'2009-10-06 02:46:58',3310502045,1);
INSERT INTO `nodes` VALUES (522254639,425611035,14686810,2756081,1,'2009-10-06 02:46:58',3310502047,1),(522254640,425621114,14699033,2756081,1,'2009-10-06 02:46:58',3310502090,1),(522254641,425650454,14727844,2756081,1,'2009-10-06 02:46:58',3310502113,1),(522254642,425658915,14745718,2756081,1,'2009-10-06 02:46:58',3310502113,1),(522254643,425659286,14745460,2756081,1,'2009-10-06 02:46:58',3310502113,1),(522254644,425682998,14765824,2756081,1,'2009-10-06 02:46:58',3310502116,1),(522254645,425692595,14776927,2756081,1,'2009-10-06 02:46:58',3310502118,1),(522254646,425696842,14802385,2756081,1,'2009-10-06 02:46:58',3310502118,1),(522254647,425700086,14821821,2756081,1,'2009-10-06 02:46:59',3310502119,1),(522254648,425701508,14850731,2756081,1,'2009-10-06 02:46:59',3310502125,1),(522254649,425688624,14873419,2756081,1,'2009-10-06 02:46:59',3310502124,1),(522254650,425676854,14888055,2756081,1,'2009-10-06 02:46:59',3310502126,1),(522256224,425201666,17013324,2756091,1,'2009-10-06 02:48:31',3310493538,1),(522256225,425204499,16991550,2756091,1,'2009-10-06 02:48:31',3310493538,1),(522256226,425210929,16980183,2756091,1,'2009-10-06 02:48:31',3310493539,1),(522256227,425217351,16967571,2756091,1,'2009-10-06 02:48:31',3310493537,1),(522256228,425207895,16938816,2756091,1,'2009-10-06 02:48:31',3310493537,1),(522256229,425222630,16919837,2756091,1,'2009-10-06 02:48:31',3310493537,1),(522256230,425237340,16897087,2756091,1,'2009-10-06 02:48:31',3310493518,1),(522256231,425264200,16888010,2756091,1,'2009-10-06 02:48:31',3310493519,1),(522256232,425284654,16894056,2756091,1,'2009-10-06 02:48:31',3310493519,1),(522256233,425299533,16898906,2756091,1,'2009-10-06 02:48:31',3310493530,1),(522256234,425302492,16927729,2756091,1,'2009-10-06 02:48:31',3310493552,1),(522256235,425296161,16955411,2756091,1,'2009-10-06 02:48:31',3310493552,1),(522256236,425293476,16971747,2756091,1,'2009-10-06 02:48:31',3310493552,1),(522256237,425272152,16975745,2756091,1,'2009-10-06 02:48:31',3310493543,1),(522256238,425257318,16978420,2756091,1,'2009-10-06 02:48:31',3310493542,1),(522256239,425254656,16998525,2756091,1,'2009-10-06 02:48:31',3310493542,1),(522256240,425260358,17021042,2756091,1,'2009-10-06 02:48:31',3310493543,1),(522256241,425266019,17034782,2756091,1,'2009-10-06 02:48:31',3310493549,1),(522256242,425250067,17042027,2756091,1,'2009-10-06 02:48:31',3310493548,1),(522256243,425233347,17027597,2756091,1,'2009-10-06 02:48:31',3310493542,1),(522256245,425219987,17017622,2756091,1,'2009-10-06 02:48:31',3310493539,1),(522787948,425781875,14797015,2759915,1,'2009-10-06 15:48:38',3310502134,1),(522787954,425778715,14801650,2759915,1,'2009-10-06 15:48:39',3310502131,1),(522787964,425728278,14696250,2759915,1,'2009-10-06 15:48:40',3310502106,1),(522787974,425728404,14692302,2759915,1,'2009-10-06 15:48:41',3310502106,1),(522787985,425725560,14692302,2759915,1,'2009-10-06 15:48:42',3310502095,1),(522788283,425771889,14797788,2759915,1,'2009-10-06 15:49:42',3310502131,1),(522788287,425777009,14782596,2759915,1,'2009-10-06 15:49:43',3310502131,1),(522800785,425699987,14878878,3388565,1,'2009-12-16 20:20:11',3310502125,2),(522800788,425720214,14838795,2760016,1,'2009-10-06 15:58:14',3310502125,1),(526428059,426334786,16929614,2788590,1,'2009-10-09 02:31:16',3310505508,1),(526428060,426324101,16929733,2788590,1,'2009-10-09 02:31:16',3310505505,1),(526428062,426314642,16937880,2788590,1,'2009-10-09 02:31:16',3310505505,1),(526428066,426302776,16939623,2788590,1,'2009-10-09 02:31:16',3310505504,1),(526428067,426290314,16942977,2788590,1,'2009-10-09 02:31:16',3310505504,1),(526428069,426284932,16936606,2788590,1,'2009-10-09 02:31:16',3310505504,1),(526428070,426285469,16926948,2788590,1,'2009-10-09 02:31:16',3310505504,1),(526428071,426283581,16910072,2788590,1,'2009-10-09 02:31:16',3310505482,1),(526428073,426289465,16901159,2788590,1,'2009-10-09 02:31:16',3310505482,1),(526428074,426297822,16907496,2788590,1,'2009-10-09 02:31:17',3310505482,1),(526428076,426299065,16916338,2788590,1,'2009-10-09 02:31:17',3310505482,1),(526428077,426307383,16916245,2788590,1,'2009-10-09 02:31:17',3310505483,1),(526428078,426313272,16908130,2788590,1,'2009-10-09 02:31:17',3310505483,1),(526428080,426316217,16903270,2788590,1,'2009-10-09 02:31:17',3310505483,1),(526428081,426326332,16907178,2788590,1,'2009-10-09 02:31:17',3310505483,1),(526428083,426326249,16893505,2788590,1,'2009-10-09 02:31:17',3310505483,1),(526428084,426316699,16884764,2788590,1,'2009-10-09 02:31:17',3310505483,1),(526428086,426316630,16873500,2788590,1,'2009-10-09 02:31:17',3310505483,1),(526428090,426317487,16846689,2788590,1,'2009-10-09 02:31:17',3310505481,1),(526428091,426316310,16841427,2788590,1,'2009-10-09 02:31:17',3310505481,1),(526429982,426479632,15719113,2788599,1,'2009-10-09 02:32:30',3310503613,1),(526429983,426481291,15700113,2788599,1,'2009-10-09 02:32:30',3310503607,1),(526429985,426484084,15688960,2788599,1,'2009-10-09 02:32:30',3310503607,1),(526429986,426497333,15670703,2788599,1,'2009-10-09 02:32:30',3310503650,1),(526429988,426502245,15666987,2788599,1,'2009-10-09 02:32:30',3310503650,1),(526429992,426510532,15664246,2788599,1,'2009-10-09 02:32:30',3310503650,1),(526429993,426523387,15670516,2788599,1,'2009-10-09 02:32:30',3310503651,1),(526431633,426238989,14631757,2788603,1,'2009-10-09 02:33:33',3310502364,1),(526431634,426235821,14635537,2788603,1,'2009-10-09 02:33:33',3310502364,1),(526431636,426234495,14640839,2788603,1,'2009-10-09 02:33:33',3310502364,1),(526431637,426232709,14646141,2788603,1,'2009-10-09 02:33:34',3310502364,1),(526431639,426231602,14650816,2788603,1,'2009-10-09 02:33:34',3310502364,1),(526431640,426226131,14658559,2788603,1,'2009-10-09 02:33:34',3310502364,1),(526431642,426217893,14668335,2788603,1,'2009-10-09 02:33:34',3310502363,1),(526431643,426208398,14668478,2788603,1,'2009-10-09 02:33:34',3310502363,1),(526431645,426201218,14662148,2788603,1,'2009-10-09 02:33:34',3310502361,1),(526431646,426191731,14664707,2788603,1,'2009-10-09 02:33:34',3310502360,1),(526431648,426184597,14664009,2788603,1,'2009-10-09 02:33:34',3310502360,1),(526431649,426188865,14657485,2788603,1,'2009-10-09 02:33:34',3310502360,1),(526431651,426189751,14654675,2788603,1,'2009-10-09 02:33:34',3310502360,1),(526431652,426188339,14649430,2788603,1,'2009-10-09 02:33:34',3310502360,1),(526431654,426186952,14647277,2788603,1,'2009-10-09 02:33:34',3310502360,1),(526431655,426183731,14646095,2788603,1,'2009-10-09 02:33:34',3310502360,1),(526431656,426181442,14646137,2788603,1,'2009-10-09 02:33:34',3310502360,1),(526431658,426177543,14644349,2788603,1,'2009-10-09 02:33:34',3310502360,1),(526431663,426177272,14640013,2788603,1,'2009-10-09 02:33:34',3310502360,1),(526431664,426177699,14635972,2788603,1,'2009-10-09 02:33:34',3310502360,1),(526431666,426177900,14633172,2788603,1,'2009-10-09 02:33:35',3310502360,1),(526431667,426179482,14630351,2788603,1,'2009-10-09 02:33:35',3310502360,1),(526431669,426183118,14627500,2788603,1,'2009-10-09 02:33:35',3310502360,1),(526431671,426189263,14623972,2788603,1,'2009-10-09 02:33:35',3310502360,1),(526431672,426191779,14622688,2788603,1,'2009-10-09 02:33:35',3310502360,1),(526431674,426194050,14620473,2788603,1,'2009-10-09 02:33:35',3310502361,1),(526431798,426273549,16577577,2788608,1,'2009-10-09 02:33:40',3310504439,1),(526431800,426269427,16582451,2788608,1,'2009-10-09 02:33:40',3310504439,1),(526431801,426262915,16585742,2788608,1,'2009-10-09 02:33:40',3310504439,1),(526431803,426258766,16588208,2788608,1,'2009-10-09 02:33:40',3310504439,1),(526431804,426252772,16579424,2788608,1,'2009-10-09 02:33:40',3310504439,1),(526431806,426246782,16571453,2788608,1,'2009-10-09 02:33:40',3310504438,1),(526431807,426243736,16560225,2788608,1,'2009-10-09 02:33:40',3310504438,1),(526431809,426236593,16557900,2788608,1,'2009-10-09 02:33:40',3310504438,1),(526431810,426226976,16554905,2788608,1,'2009-10-09 02:33:40',3310504438,1),(526431812,426225771,16555998,2788608,1,'2009-10-09 02:33:40',3310504438,1),(526431813,426222657,16558831,2788608,1,'2009-10-09 02:33:40',3310504438,1),(526431817,426221142,16562345,2788608,1,'2009-10-09 02:33:41',3310504438,1),(526431818,426224026,16579867,2788608,1,'2009-10-09 02:33:41',3310504438,1),(526431820,426234132,16582021,2788608,1,'2009-10-09 02:33:41',3310504438,1),(526431821,426239230,16591066,2788608,1,'2009-10-09 02:33:41',3310504444,1),(526431823,426238518,16611564,2788608,1,'2009-10-09 02:33:41',3310504444,1),(526431824,426239447,16625203,2788608,1,'2009-10-09 02:33:41',3310504444,1),(526431826,426242045,16636558,2788608,1,'2009-10-09 02:33:41',3310504444,1),(526431827,426250545,16651257,2788608,1,'2009-10-09 02:33:41',3310504447,1),(526431828,426257294,16656864,2788608,1,'2009-10-09 02:33:41',3310504447,1),(526431830,426253218,16676261,2788608,1,'2009-10-09 02:33:41',3310504447,1),(526431831,426255815,16687609,2788608,1,'2009-10-09 02:33:41',3310504447,1),(526431833,426258372,16694412,2788608,1,'2009-10-09 02:33:41',3310504447,1),(526431834,426258465,16709209,2788608,1,'2009-10-09 02:33:41',3310504789,1),(526431836,426256892,16725158,2788608,1,'2009-10-09 02:33:41',3310504789,1),(526431837,426256114,16735412,2788608,1,'2009-10-09 02:33:41',3310504789,1),(526431839,426266208,16737569,2788608,1,'2009-10-09 02:33:41',3310504789,1),(526431840,426278813,16737424,2788608,1,'2009-10-09 02:33:41',3310505472,1),(526431842,426283850,16735094,2788608,1,'2009-10-09 02:33:41',3310505472,1),(526431858,426289279,16797632,2788608,1,'2009-10-09 02:33:42',3310505474,1),(526431859,426285168,16813609,2788608,1,'2009-10-09 02:33:42',3310505480,1),(526431860,426293715,16836277,2788608,1,'2009-10-09 02:33:42',3310505480,1),(526431861,426299667,16847589,2788608,1,'2009-10-09 02:33:42',3310505480,1),(526431863,426288801,16856817,2788608,1,'2009-10-09 02:33:42',3310505480,1),(526431865,426276126,16845581,2788608,1,'2009-10-09 02:33:42',3310505480,1),(526431866,426261093,16861681,2788608,1,'2009-10-09 02:33:42',3310504797,1),(526431868,426270475,16883206,2788608,1,'2009-10-09 02:33:42',3310504799,1),(526431869,426265549,16903744,2788608,1,'2009-10-09 02:33:42',3310504799,1),(526431870,426256408,16919777,2788608,1,'2009-10-09 02:33:43',3310504821,1),(526431872,426248097,16935807,2788608,1,'2009-10-09 02:33:43',3310504820,1),(526431873,426249877,16951717,2788608,1,'2009-10-09 02:33:43',3310504821,1),(526431875,426253329,16967617,2788608,1,'2009-10-09 02:33:43',3310504821,1),(526431876,426255964,16985798,2788608,1,'2009-10-09 02:33:43',3310504823,1),(526431878,426250206,17006344,2788608,1,'2009-10-09 02:33:43',3310504823,1),(526431879,426245268,17023468,2788608,1,'2009-10-09 02:33:43',3310504822,1),(526431881,426243700,17042835,2788608,1,'2009-10-09 02:33:43',3310504828,1),(526431882,426247110,17051903,2788608,1,'2009-10-09 02:33:43',3310504828,1),(526431884,426239650,17067914,2788608,1,'2009-10-09 02:33:43',3310504828,1),(526431885,426228819,17085101,2788608,1,'2009-10-09 02:33:43',3310504830,1),(526431887,426219641,17095445,2788608,1,'2009-10-09 02:33:43',3310504827,1),(526431888,426213840,17109165,2788608,1,'2009-10-09 02:33:43',3310504827,1),(526431892,426205420,17106983,2788608,1,'2009-10-09 02:33:43',3310504827,1),(526431893,426201257,17114992,2788608,1,'2009-10-09 02:33:43',3310504827,1),(526431895,426198042,17138928,2788608,1,'2009-10-09 02:33:43',3310504827,1),(526431896,426193864,17142385,2788608,1,'2009-10-09 02:33:43',3310504913,1),(526431898,426183806,17148177,2788608,1,'2009-10-09 02:33:43',3310504912,1),(526431899,426183144,17178916,2788608,1,'2009-10-09 02:33:43',3310504912,1),(526431901,426184125,17202798,2788608,1,'2009-10-09 02:33:43',3310504914,1),(526431902,426193545,17232289,2788608,1,'2009-10-09 02:33:43',3310504914,1),(526431903,426201241,17254969,2788608,1,'2009-10-09 02:33:44',3310504921,1),(526431930,426171559,17360720,2788608,1,'2009-10-09 02:33:44',3310504944,1),(526431932,426167066,17360159,2788608,1,'2009-10-09 02:33:44',3310504944,1),(526431933,426153112,17361831,2788608,1,'2009-10-09 02:33:44',3310504933,1),(526431935,426151622,17362492,2788608,1,'2009-10-09 02:33:44',3310504933,1),(526432055,425976782,17315071,2788608,1,'2009-10-09 02:33:48',3310504859,1),(526432057,425969218,17301643,2788608,1,'2009-10-09 02:33:48',3310504856,1),(526432058,425952563,17296189,2788608,1,'2009-10-09 02:33:48',3310504856,1),(526432060,425936045,17316621,2788608,1,'2009-10-09 02:33:48',3310504847,1),(526432061,425929491,17334699,2788608,1,'2009-10-09 02:33:48',3310504847,1),(526432063,425924597,17350504,2788608,1,'2009-10-09 02:33:48',3310504847,1),(526432064,425928890,17375222,2788608,1,'2009-10-09 02:33:48',3310504869,1),(526432067,425930670,17394338,2788608,1,'2009-10-09 02:33:48',3310504869,1),(526432069,425931850,17406852,2788608,1,'2009-10-09 02:33:48',3310504869,1),(526432070,425931656,17406841,2788608,1,'2009-10-09 02:33:48',3310504869,1),(526432072,425925886,17415904,2788608,1,'2009-10-09 02:33:48',3310504871,1),(526432073,425918472,17428360,2788608,1,'2009-10-09 02:33:48',3310504870,1),(526432075,425904355,17431881,2788608,1,'2009-10-09 02:33:48',3310504870,1),(526432076,425888449,17412912,2788608,1,'2009-10-09 02:33:49',3310504865,1),(526432078,425880209,17426501,2788608,1,'2009-10-09 02:33:49',3310504867,1),(526432079,425869475,17440116,2788608,1,'2009-10-09 02:33:49',3310504867,1),(526432081,425868017,17443269,2788608,1,'2009-10-09 02:33:49',3310504867,1),(526432082,425856857,17414362,2788608,1,'2009-10-09 02:33:49',3310504866,1),(526432084,425842417,17360496,2788608,1,'2009-10-09 02:33:49',3310504864,1),(526432085,425853208,17357008,2788608,1,'2009-10-09 02:33:49',3310504842,1),(526432087,425847196,17323311,2788608,1,'2009-10-09 02:33:49',3310504842,1),(526432088,425845340,17289571,2788608,1,'2009-10-09 02:33:49',3310504840,1),(526432089,425861925,17281520,2788608,1,'2009-10-09 02:33:49',3310504840,1),(526432091,425851733,17244491,2788608,1,'2009-10-09 02:33:49',3310504834,1),(526432092,425844080,17215314,2788608,1,'2009-10-09 02:33:49',3310504834,1),(526432096,425833985,17195166,2788608,1,'2009-10-09 02:33:49',3310504663,1),(526432097,425811495,17188654,2788608,1,'2009-10-09 02:33:49',3310504661,1),(526432099,425795689,17187697,2788608,1,'2009-10-09 02:33:49',3310504660,1),(526432100,425790661,17180999,2788608,1,'2009-10-09 02:33:49',3310504660,1),(526432102,425782821,17180641,2788608,1,'2009-10-09 02:33:49',3310504660,1),(526432103,425782658,17180139,2788608,1,'2009-10-09 02:33:49',3310504660,1),(526432105,425765856,17166945,2788608,1,'2009-10-09 02:33:49',3310504657,1),(526432106,425765706,17141234,2788608,1,'2009-10-09 02:33:49',3310504657,1),(526432108,425768638,17122681,2788608,1,'2009-10-09 02:33:49',3310504571,1),(526432109,425776824,17092764,2788608,1,'2009-10-09 02:33:49',3310504571,1),(526432111,425774485,17082499,2788608,1,'2009-10-09 02:33:50',3310504569,1),(526432112,425765983,17058929,2788608,1,'2009-10-09 02:33:50',3310504569,1),(526432114,425755301,17053904,2788608,1,'2009-10-09 02:33:50',3310504569,1),(526432115,425743762,17031401,2788608,1,'2009-10-09 02:33:50',3310504568,1),(526432117,425729237,17018188,2788608,1,'2009-10-09 02:33:50',3310504562,1),(526432118,425713283,17019388,2788608,1,'2009-10-09 02:33:50',3310504551,1),(526432120,425708609,16999894,2788608,1,'2009-10-09 02:33:50',3310504551,1),(526432121,425721367,16973010,2788608,1,'2009-10-09 02:33:50',3310504549,1),(526432122,425735713,16956397,2788608,1,'2009-10-09 02:33:50',3310504560,1),(526432126,425768439,16961176,2788608,1,'2009-10-09 02:33:50',3310504561,1),(526432127,425786814,16983604,2788608,1,'2009-10-09 02:33:50',3310504566,1),(526432129,425808032,16971029,2788608,1,'2009-10-09 02:33:50',3310504564,1),(526432130,425833124,16971778,2788608,1,'2009-10-09 02:33:50',3310504565,1),(526432132,425846837,16976768,2788608,1,'2009-10-09 02:33:50',3310504738,1),(526432133,425867464,16993007,2788608,1,'2009-10-09 02:33:50',3310504739,1),(526432135,425883530,17010322,2788608,1,'2009-10-09 02:33:50',3310504739,1),(526432136,425896942,17030653,2788608,1,'2009-10-09 02:33:50',3310504748,1),(526432137,425884389,17045199,2788608,1,'2009-10-09 02:33:50',3310504745,1),(526432139,425871853,17062440,2788608,1,'2009-10-09 02:33:50',3310504745,1),(526432140,425870667,17085861,2788608,1,'2009-10-09 02:33:50',3310504747,1),(526432142,425877492,17116397,2788608,1,'2009-10-09 02:33:50',3310504747,1),(526432143,425890793,17114453,2788608,1,'2009-10-09 02:33:51',3310504747,1),(526432145,425910832,17126299,2788608,1,'2009-10-09 02:33:51',3310504750,1),(526432146,425913952,17139642,2788608,1,'2009-10-09 02:33:51',3310504836,1),(526432148,425912582,17164350,2788608,1,'2009-10-09 02:33:51',3310504836,1),(526432149,425919585,17193086,2788608,1,'2009-10-09 02:33:51',3310504837,1),(526432151,425930327,17210465,2788608,1,'2009-10-09 02:33:51',3310504839,1),(526432154,425946323,17214413,2788608,1,'2009-10-09 02:33:51',3310504839,1),(526432156,425958412,17200907,2788608,1,'2009-10-09 02:33:51',3310504850,1),(526432157,425955215,17174187,2788608,1,'2009-10-09 02:33:51',3310504848,1),(526432159,425952047,17152609,2788608,1,'2009-10-09 02:33:51',3310504848,1),(526432160,425956495,17134034,2788608,1,'2009-10-09 02:33:51',3310504762,1),(526432162,425973880,17116352,2788608,1,'2009-10-09 02:33:51',3310504762,1),(526432163,425982920,17101851,2788608,1,'2009-10-09 02:33:51',3310504763,1),(526432165,425998984,17119173,2788608,1,'2009-10-09 02:33:51',3310504763,1),(526432166,426011963,17127268,2788608,1,'2009-10-09 02:33:51',3310504766,1),(526432168,426025015,17149768,2788608,1,'2009-10-09 02:33:51',3310504852,1),(526432169,426025934,17176515,2788608,1,'2009-10-09 02:33:51',3310504852,1),(526432171,426027569,17197079,2788608,1,'2009-10-09 02:33:51',3310504854,1),(526432172,426043595,17206170,2788608,1,'2009-10-09 02:33:51',3310504855,1),(526432174,426052112,17232845,2788608,1,'2009-10-09 02:33:51',3310504855,1),(526432175,426067262,17224449,2788608,1,'2009-10-09 02:33:51',3310504898,1),(526432176,426077867,17216100,2788608,1,'2009-10-09 02:33:52',3310504898,1),(526432178,426086181,17207776,2788608,1,'2009-10-09 02:33:52',3310504899,1),(526432179,426087589,17189237,2788608,1,'2009-10-09 02:33:52',3310504897,1),(526432183,426082900,17166645,2788608,1,'2009-10-09 02:33:52',3310504896,1),(526432185,426075175,17147170,2788608,1,'2009-10-09 02:33:52',3310504896,1),(526432186,426065922,17123595,2788608,1,'2009-10-09 02:33:52',3310504810,1),(526432188,426068031,17094754,2788608,1,'2009-10-09 02:33:52',3310504810,1),(526432189,426071671,17066921,2788608,1,'2009-10-09 02:33:52',3310504808,1),(526432190,426073058,17045298,2788608,1,'2009-10-09 02:33:52',3310504808,1),(526432192,426073600,17008237,2788608,1,'2009-10-09 02:33:52',3310504802,1),(526432193,426084924,16994733,2788608,1,'2009-10-09 02:33:52',3310504803,1),(526432195,426107701,16989331,2788608,1,'2009-10-09 02:33:52',3310504803,1),(526432196,426121525,17012855,2788608,1,'2009-10-09 02:33:52',3310504806,1),(526432198,426133003,17025085,2788608,1,'2009-10-09 02:33:52',3310504806,1),(526432199,426138477,17050754,2788608,1,'2009-10-09 02:33:52',3310504812,1),(526432200,426149985,17068129,2788608,1,'2009-10-09 02:33:52',3310504813,1),(526432202,426154614,17078375,2788608,1,'2009-10-09 02:33:52',3310504813,1),(526432203,426166088,17097666,2788608,1,'2009-10-09 02:33:52',3310504815,1),(526432205,426173296,17088340,2788608,1,'2009-10-09 02:33:52',3310504826,1),(526432206,426197277,17041792,2788608,1,'2009-10-09 02:33:52',3310504825,1),(526432208,426203968,17028814,2788608,1,'2009-10-09 02:33:52',3310504819,1),(526432212,426207390,17019095,2788608,1,'2009-10-09 02:33:53',3310504819,1),(526432213,426211883,17006339,2788608,1,'2009-10-09 02:33:53',3310504819,1),(526432214,426215438,17000220,2788608,1,'2009-10-09 02:33:53',3310504819,1),(526432216,426220668,16996393,2788608,1,'2009-10-09 02:33:53',3310504819,1),(526432217,426226006,16986037,2788608,1,'2009-10-09 02:33:53',3310504822,1),(526432219,426225270,16977571,2788608,1,'2009-10-09 02:33:53',3310504822,1),(526432220,426225806,16975300,2788608,1,'2009-10-09 02:33:53',3310504822,1),(526432222,426223311,16965357,2788608,1,'2009-10-09 02:33:53',3310504820,1),(526432223,426223422,16961525,2788608,1,'2009-10-09 02:33:53',3310504820,1),(526432225,426223505,16958454,2788608,1,'2009-10-09 02:33:53',3310504820,1),(526432226,426222606,16947155,2788608,1,'2009-10-09 02:33:53',3310504820,1),(526432228,426208192,16950720,2788608,1,'2009-10-09 02:33:53',3310504817,1),(526432229,426198288,16963217,2788608,1,'2009-10-09 02:33:53',3310504817,1),(526432231,426187519,16970091,2788608,1,'2009-10-09 02:33:53',3310504816,1),(526432232,426173329,16962368,2788608,1,'2009-10-09 02:33:53',3310504816,1),(526432234,426159007,16930998,2788608,1,'2009-10-09 02:33:53',3310504805,1),(526432235,426166038,16896602,2788608,1,'2009-10-09 02:33:53',3310504783,1),(526432237,426170311,16875702,2788608,1,'2009-10-09 02:33:53',3310504794,1),(526432240,426159323,16846554,2788608,1,'2009-10-09 02:33:53',3310504781,1),(526432242,426150853,16821877,2788608,1,'2009-10-09 02:33:54',3310504781,1),(526432243,426131720,16820968,2788608,1,'2009-10-09 02:33:54',3310504780,1),(526432245,426127372,16789490,2788608,1,'2009-10-09 02:33:54',3310504774,1),(526432246,426139702,16766835,2788608,1,'2009-10-09 02:33:54',3310504775,1),(526432248,426153789,16757670,2788608,1,'2009-10-09 02:33:54',3310504775,1),(526432249,426152814,16736290,2788608,1,'2009-10-09 02:33:54',3310504773,1),(526432251,426163529,16719275,2788608,1,'2009-10-09 02:33:54',3310504773,1),(526432252,426175013,16694369,2788608,1,'2009-10-09 02:33:54',3310504442,1),(526432254,426167434,16679821,2788608,1,'2009-10-09 02:33:54',3310504442,1),(526432255,426154013,16660834,2788608,1,'2009-10-09 02:33:54',3310504431,1),(526432257,426160565,16646122,2788608,1,'2009-10-09 02:33:54',3310504431,1),(526432258,426156355,16637166,2788608,1,'2009-10-09 02:33:54',3310504429,1),(526432260,426141360,16633959,2788608,1,'2009-10-09 02:33:54',3310504429,1),(526432261,426124794,16643163,2788608,1,'2009-10-09 02:33:54',3310504428,1),(526432263,426113004,16619654,2788608,1,'2009-10-09 02:33:54',3310504428,1),(526432264,426120380,16603808,2788608,1,'2009-10-09 02:33:54',3310504428,1),(526432266,426132746,16585647,2788608,1,'2009-10-09 02:33:54',3310504422,1),(526432269,426150164,16579813,2788608,1,'2009-10-09 02:33:54',3310504423,1),(526432271,426158424,16570711,2788608,1,'2009-10-09 02:33:54',3310504423,1),(526432272,426160807,16553798,2788608,1,'2009-10-09 02:33:55',3310504423,1),(526432274,426170677,16536789,2788608,1,'2009-10-09 02:33:55',3310504434,1),(526432275,426177297,16531080,2788608,1,'2009-10-09 02:33:55',3310504432,1),(526432277,426173028,16513120,2788608,1,'2009-10-09 02:33:55',3310504432,1),(526432278,426186271,16503951,2788608,1,'2009-10-09 02:33:55',3310504432,1),(526432279,426197874,16498182,2788608,1,'2009-10-09 02:33:55',3310504433,1),(526432281,426198646,16489167,2788608,1,'2009-10-09 02:33:55',3310504433,1),(526432282,426210228,16480024,2788608,1,'2009-10-09 02:33:55',3310504433,1),(526432284,426212621,16463101,2788608,1,'2009-10-09 02:33:55',3310504411,1),(526432286,426217520,16450093,2788608,1,'2009-10-09 02:33:55',3310504411,1),(526432287,426224934,16438748,2788608,1,'2009-10-09 02:33:55',3310504414,1),(526432289,426230848,16436893,2788608,1,'2009-10-09 02:33:55',3310504414,1),(526432290,426239401,16455514,2788608,1,'2009-10-09 02:33:55',3310504414,1),(526432292,426251925,16463247,2788608,1,'2009-10-09 02:33:55',3310504415,1),(526432293,426273318,16428082,2788608,1,'2009-10-09 02:33:55',3310504415,1),(526432295,426276556,16414529,2788608,1,'2009-10-09 02:33:55',3310505096,1),(526432296,426258136,16395606,2788608,1,'2009-10-09 02:33:55',3310504413,1),(526432300,426258025,16378716,2788608,1,'2009-10-09 02:33:55',3310504413,1),(526432302,426262874,16357261,2788608,1,'2009-10-09 02:33:55',3310504407,1),(526432303,426265879,16308800,2788608,1,'2009-10-09 02:33:55',3310504405,1),(526432304,426251608,16288704,2788608,1,'2009-10-09 02:33:55',3310504405,1),(526432306,426245970,16288979,2788608,1,'2009-10-09 02:33:56',3310504404,1),(526432307,426247921,16268426,2788608,1,'2009-10-09 02:33:56',3310504404,1),(526432309,426254487,16254832,2788608,1,'2009-10-09 02:33:56',3310504319,1),(526432311,426265049,16261452,2788608,1,'2009-10-09 02:33:56',3310504405,1),(526432312,426265700,16258069,2788608,1,'2009-10-09 02:33:56',3310504319,1),(526432314,426266083,16256628,2788608,1,'2009-10-09 02:33:56',3310504319,1),(526432315,426267573,16251099,2788608,1,'2009-10-09 02:33:56',3310504319,1),(526432317,426268876,16237881,2788608,1,'2009-10-09 02:33:56',3310504319,1),(526432318,426271521,16230552,2788608,1,'2009-10-09 02:33:56',3310504319,1),(526432320,426273067,16224992,2788608,1,'2009-10-09 02:33:56',3310504319,1),(526432321,426273560,16223230,2788608,1,'2009-10-09 02:33:56',3310504319,1),(526432323,426272991,16222006,2788608,1,'2009-10-09 02:33:56',3310504319,1),(526432324,426269619,16214766,2788608,1,'2009-10-09 02:33:56',3310504319,1),(526432326,426268132,16212223,2788608,1,'2009-10-09 02:33:56',3310504319,1),(526432328,426258263,16195328,2788608,1,'2009-10-09 02:33:56',3310504317,1),(526432329,426240610,16169425,2788608,1,'2009-10-09 02:33:56',3310504316,1),(526432330,426218774,16139289,2788608,1,'2009-10-09 02:33:56',3310504307,1),(526432331,426203050,16149623,2788608,1,'2009-10-09 02:33:56',3310504307,1),(526432332,426178106,16151058,2788608,1,'2009-10-09 02:33:56',3310504312,1),(526432333,426153272,16167128,2788608,1,'2009-10-09 02:33:56',3310504301,1),(526432334,426142532,16177398,2788608,1,'2009-10-09 02:33:57',3310504301,1),(526432335,426126065,16202367,2788608,1,'2009-10-09 02:33:57',3310504300,1),(526432336,426120350,16217080,2788608,1,'2009-10-09 02:33:57',3310504302,1),(526432337,426123838,16241801,2788608,1,'2009-10-09 02:33:57',3310504302,1),(526432338,426120674,16265486,2788608,1,'2009-10-09 02:33:57',3310504388,1),(526432339,426107460,16280283,2788608,1,'2009-10-09 02:33:57',3310504385,1),(526432340,426107250,16280229,2788608,1,'2009-10-09 02:33:57',3310504385,1),(526432341,426059116,16230265,2788608,1,'2009-10-09 02:33:57',3310504298,1),(526432342,426042850,16228930,2788608,1,'2009-10-09 02:33:57',3310504255,1),(526432343,426033920,16226025,2788608,1,'2009-10-09 02:33:57',3310504255,1),(526432344,426023737,16195753,2788608,1,'2009-10-09 02:33:57',3310504252,1),(526432345,426006912,16167822,2788608,1,'2009-10-09 02:33:57',3310504252,1),(526432349,426007536,16137418,2788608,1,'2009-10-09 02:33:57',3310504246,1),(526432350,426024040,16118082,2788608,1,'2009-10-09 02:33:57',3310504246,1),(526432352,426021464,16105730,2788608,1,'2009-10-09 02:33:57',3310504246,1),(526432353,426042989,16091952,2788608,1,'2009-10-09 02:33:57',3310504245,1),(526432355,426035356,16070661,2788608,1,'2009-10-09 02:33:57',3310504245,1),(526432356,426050997,16046820,2788608,1,'2009-10-09 02:33:57',3310504245,1),(526432358,426052440,16015279,2788608,1,'2009-10-09 02:33:57',3310504223,1),(526432359,426039751,15983925,2788608,1,'2009-10-09 02:33:57',3310504221,1),(526432361,426010412,15950529,2788608,1,'2009-10-09 02:33:57',3310504220,1),(526432363,425984919,15940881,2788608,1,'2009-10-09 02:33:58',3310504217,1),(526432364,425973437,15963545,2788608,1,'2009-10-09 02:33:58',3310504216,1),(526432366,425963679,15995180,2788608,1,'2009-10-09 02:33:58',3310504218,1),(526432367,425957218,16023407,2788608,1,'2009-10-09 02:33:58',3310504218,1),(526432369,425939862,16039382,2788608,1,'2009-10-09 02:33:58',3310504207,1),(526432370,425925583,16018179,2788608,1,'2009-10-09 02:33:58',3310504207,1),(526432372,425924769,16011927,2788608,1,'2009-10-09 02:33:58',3310504207,1),(526432373,425932664,15979710,2788608,1,'2009-10-09 02:33:58',3310504205,1),(526432374,425918434,15966386,2788608,1,'2009-10-09 02:33:58',3310504204,1),(526432378,425936602,15948146,2788608,1,'2009-10-09 02:33:58',3310504205,1),(526432380,425933189,15935809,2788608,1,'2009-10-09 02:33:58',3310504205,1),(526432381,425938978,15931233,2788608,1,'2009-10-09 02:33:58',3310504205,1),(526432383,425956424,15928758,2788608,1,'2009-10-09 02:33:58',3310504210,1),(526432384,425964660,15917397,2788608,1,'2009-10-09 02:33:58',3310504210,1),(526432385,425969216,15906364,2788608,1,'2009-10-09 02:33:58',3310504210,1),(526432387,425977108,15894694,2788608,1,'2009-10-09 02:33:58',3310504211,1),(526432389,425975847,15862348,2788608,1,'2009-10-09 02:33:58',3310504209,1),(526432390,425975618,15829989,2788608,1,'2009-10-09 02:33:58',3310504209,1),(526432391,425977515,15804644,2788608,1,'2009-10-09 02:33:58',3310502843,1),(526432393,425964913,15787921,2788608,1,'2009-10-09 02:33:58',3310502842,1),(526432395,425941027,15789639,2788608,1,'2009-10-09 02:33:58',3310502831,1),(526432396,425929680,15802450,2788608,1,'2009-10-09 02:33:59',3310502831,1),(526432398,425917490,15813441,2788608,1,'2009-10-09 02:33:59',3310502830,1),(526432399,425895936,15822730,2788608,1,'2009-10-09 02:33:59',3310504196,1),(526432401,425876875,15831979,2788608,1,'2009-10-09 02:33:59',3310504193,1),(526432402,425869292,15818573,2788608,1,'2009-10-09 02:33:59',3310502827,1),(526432404,425869915,15789307,2788608,1,'2009-10-09 02:33:59',3310502827,1),(526432408,425875506,15756597,2788608,1,'2009-10-09 02:33:59',3310502825,1),(526432409,425882831,15733995,2788608,1,'2009-10-09 02:33:59',3310502825,1),(526432411,425876900,15719436,2788608,1,'2009-10-09 02:33:59',3310502825,1),(526432412,425867084,15709259,2788608,1,'2009-10-09 02:33:59',3310502819,1),(526432414,425873536,15691940,2788608,1,'2009-10-09 02:33:59',3310502819,1),(526432415,425879359,15679110,2788608,1,'2009-10-09 02:33:59',3310502819,1),(526432417,425941368,15571673,2788608,1,'2009-10-09 02:33:59',3310502799,1),(526432418,425948341,15564287,2788608,1,'2009-10-09 02:33:59',3310502810,1),(526432420,425962228,15535537,2788608,1,'2009-10-09 02:33:59',3310502808,1),(526432421,425967580,15539067,2788608,1,'2009-10-09 02:33:59',3310502808,1),(526432423,425967226,15579692,2788608,1,'2009-10-09 02:33:59',3310502810,1),(526432424,425966872,15644980,2788608,1,'2009-10-09 02:33:59',3310502832,1),(526432426,425977730,15651589,2788608,1,'2009-10-09 02:33:59',3310502833,1),(526432427,425988004,15652321,2788608,1,'2009-10-09 02:33:59',3310502833,1),(526432429,425987899,15659582,2788608,1,'2009-10-09 02:33:59',3310502835,1),(526432430,426002528,15669241,2788608,1,'2009-10-09 02:34:00',3310502838,1),(526432432,426018036,15657776,2788608,1,'2009-10-09 02:34:00',3310502838,1),(526432433,426027079,15615445,2788608,1,'2009-10-09 02:34:00',3310502836,1),(526432435,426039467,15602614,2788608,1,'2009-10-09 02:34:00',3310502837,1),(526432438,426049650,15585231,2788608,1,'2009-10-09 02:34:00',3310502815,1),(526432440,426057969,15593108,2788608,1,'2009-10-09 02:34:00',3310502858,1),(526432441,426068910,15610974,2788608,1,'2009-10-09 02:34:00',3310502880,1),(526432443,426086331,15605111,2788608,1,'2009-10-09 02:34:00',3310502881,1),(526432444,426093938,15621897,2788608,1,'2009-10-09 02:34:00',3310502881,1),(526432446,426108083,15622834,2788608,1,'2009-10-09 02:34:00',3310502881,1),(526432447,426111190,15620515,2788608,1,'2009-10-09 02:34:00',3310502881,1),(526432449,426113936,15627259,2788608,1,'2009-10-09 02:34:00',3310502884,1),(526432450,426095880,15660149,2788608,1,'2009-10-09 02:34:00',3310502883,1),(526432452,426105633,15672287,2788608,1,'2009-10-09 02:34:00',3310502883,1),(526432453,426099322,15686245,2788608,1,'2009-10-09 02:34:00',3310502883,1),(526432455,426092283,15718707,2788608,1,'2009-10-09 02:34:00',3310502889,1),(526432456,426071708,15748535,2788608,1,'2009-10-09 02:34:00',3310502888,1),(526432458,426072992,15783697,2788608,1,'2009-10-09 02:34:00',3310502890,1),(526432459,426079513,15823015,2788608,1,'2009-10-09 02:34:00',3310504256,1),(526432461,426093087,15831280,2788608,1,'2009-10-09 02:34:00',3310504257,1),(526432462,426121118,15826691,2788608,1,'2009-10-09 02:34:00',3310504260,1),(526432464,426133438,15805421,2788608,1,'2009-10-09 02:34:01',3310502894,1),(526432467,426152179,15809402,2788608,1,'2009-10-09 02:34:01',3310502895,1),(526432469,426183280,15797734,2788608,1,'2009-10-09 02:34:01',3310502906,1),(526432470,426187734,15838493,2788608,1,'2009-10-09 02:34:01',3310504272,1),(526432472,426166152,15873958,2788608,1,'2009-10-09 02:34:01',3310504261,1),(526432473,426168439,15896039,2788608,1,'2009-10-09 02:34:01',3310504274,1),(526432475,426159261,15918273,2788608,1,'2009-10-09 02:34:01',3310504263,1),(526432476,426157058,15959961,2788608,1,'2009-10-09 02:34:01',3310504269,1),(526432478,426152978,15971272,2788608,1,'2009-10-09 02:34:01',3310504269,1),(526432479,426159709,15982446,2788608,1,'2009-10-09 02:34:01',3310504269,1),(526432481,426154884,16006152,2788608,1,'2009-10-09 02:34:01',3310504271,1),(526432482,426169953,16020598,2788608,1,'2009-10-09 02:34:01',3310504282,1),(526432484,426190842,16034971,2788608,1,'2009-10-09 02:34:01',3310504282,1),(526432485,426214133,16035802,2788608,1,'2009-10-09 02:34:01',3310504283,1),(526432486,426213962,16011032,2788608,1,'2009-10-09 02:34:01',3310504283,1),(526432488,426237764,15965686,2788608,1,'2009-10-09 02:34:01',3310504284,1),(526432489,426242643,15949858,2788608,1,'2009-10-09 02:34:01',3310504284,1),(526432491,426280086,15952757,2788608,1,'2009-10-09 02:34:01',3310504968,1),(526432492,426313167,15926430,2788608,1,'2009-10-09 02:34:02',3310504963,1),(526432496,426293733,15882758,2788608,1,'2009-10-09 02:34:02',3310504962,1),(526432497,426312747,15866745,2788608,1,'2009-10-09 02:34:02',3310504961,1),(526432499,426314259,15845327,2788608,1,'2009-10-09 02:34:02',3310504961,1),(526432500,426321591,15823833,2788608,1,'2009-10-09 02:34:02',3310504961,1),(526432502,426321949,15805240,2788608,1,'2009-10-09 02:34:02',3310503595,1),(526432503,426329746,15801201,2788608,1,'2009-10-09 02:34:02',3310503595,1),(526432505,426327866,15770816,2788608,1,'2009-10-09 02:34:02',3310503595,1),(526432506,426322005,15765262,2788608,1,'2009-10-09 02:34:02',3310503593,1),(526432507,426320100,15731499,2788608,1,'2009-10-09 02:34:02',3310503593,1),(526432509,426318554,15719653,2788608,1,'2009-10-09 02:34:02',3310503593,1),(526432511,426326122,15711402,2788608,1,'2009-10-09 02:34:02',3310503593,1),(526432527,426332046,15669082,2788613,1,'2009-10-09 02:34:04',3310503590,1),(526432529,426347565,15659024,2788613,1,'2009-10-09 02:34:04',3310503590,1),(526432530,426379679,15643112,2788613,1,'2009-10-09 02:34:04',3310503589,1),(526432531,426397428,15654134,2788613,1,'2009-10-09 02:34:04',3310503600,1),(526432532,426396742,15702015,2788613,1,'2009-10-09 02:34:04',3310503602,1),(526432534,426401199,15744202,2788613,1,'2009-10-09 02:34:04',3310503608,1),(526432537,426407611,15768050,2788613,1,'2009-10-09 02:34:04',3310503610,1),(526432538,426400048,15792051,2788613,1,'2009-10-09 02:34:04',3310503610,1),(526432539,426392527,15811040,2788613,1,'2009-10-09 02:34:04',3310503610,1),(526432540,426386647,15819160,2788613,1,'2009-10-09 02:34:04',3310503610,1),(526432541,426387985,15841675,2788613,1,'2009-10-09 02:34:04',3310504976,1),(526432543,426379147,15850639,2788613,1,'2009-10-09 02:34:04',3310504965,1),(526432544,426368495,15857216,2788613,1,'2009-10-09 02:34:04',3310504965,1),(526432546,426369169,15868466,2788613,1,'2009-10-09 02:34:04',3310504965,1),(526432547,426372819,15879685,2788613,1,'2009-10-09 02:34:05',3310504967,1),(526432549,426378258,15893290,2788613,1,'2009-10-09 02:34:05',3310504967,1),(526432550,426383691,15906091,2788613,1,'2009-10-09 02:34:05',3310504967,1),(526432552,426388563,15923733,2788613,1,'2009-10-09 02:34:05',3310504978,1),(526432553,426381509,15934284,2788613,1,'2009-10-09 02:34:05',3310504973,1),(526432555,426369078,15940069,2788613,1,'2009-10-09 02:34:05',3310504973,1),(526432556,426361400,15946606,2788613,1,'2009-10-09 02:34:05',3310504973,1),(526432558,426358538,15961124,2788613,1,'2009-10-09 02:34:05',3310504973,1),(526432559,426349699,15971697,2788613,1,'2009-10-09 02:34:05',3310504972,1),(526432561,426339035,15976660,2788613,1,'2009-10-09 02:34:05',3310504972,1),(526432564,426322429,15979282,2788613,1,'2009-10-09 02:34:05',3310504969,1),(526432566,426314756,15986623,2788613,1,'2009-10-09 02:34:05',3310504971,1),(526432567,426316602,15995448,2788613,1,'2009-10-09 02:34:05',3310504971,1),(526432569,426314918,16009949,2788613,1,'2009-10-09 02:34:05',3310504971,1),(526432570,426322140,16023532,2788613,1,'2009-10-09 02:34:05',3310504971,1),(526432572,426322830,16037206,2788613,1,'2009-10-09 02:34:05',3310504971,1),(526432573,426329462,16051602,2788613,1,'2009-10-09 02:34:05',3310504993,1),(526432575,426334877,16061986,2788613,1,'2009-10-09 02:34:05',3310504996,1),(526432576,426337334,16073220,2788613,1,'2009-10-09 02:34:05',3310504996,1),(526432578,426336833,16086901,2788613,1,'2009-10-09 02:34:05',3310504996,1),(526432579,426330989,16100650,2788613,1,'2009-10-09 02:34:05',3310504998,1),(526432581,426317940,16103231,2788613,1,'2009-10-09 02:34:05',3310504995,1),(526432582,426303685,16103409,2788613,1,'2009-10-09 02:34:06',3310504995,1),(526432584,426298970,16109906,2788613,1,'2009-10-09 02:34:06',3310504994,1),(526432585,426300826,16120334,2788613,1,'2009-10-09 02:34:06',3310504994,1),(526432587,426305634,16129130,2788613,1,'2009-10-09 02:34:06',3310504995,1),(526432588,426304003,16150060,2788613,1,'2009-10-09 02:34:06',3310504995,1),(526432590,426299282,16155751,2788613,1,'2009-10-09 02:34:06',3310505000,1),(526432593,426296400,16167857,2788613,1,'2009-10-09 02:34:06',3310505000,1),(526432595,426299462,16182299,2788613,1,'2009-10-09 02:34:06',3310505000,1),(526432596,426297742,16191974,2788613,1,'2009-10-09 02:34:06',3310505000,1),(526432598,426296269,16211541,2788613,1,'2009-10-09 02:34:06',3310505002,1),(526432600,426297381,16224958,2788613,1,'2009-10-09 02:34:06',3310505002,1),(526432601,426303400,16236947,2788613,1,'2009-10-09 02:34:06',3310505002,1),(526432603,426311171,16244095,2788613,1,'2009-10-09 02:34:06',3310505003,1),(526432604,426307757,16267465,2788613,1,'2009-10-09 02:34:06',3310505089,1),(526432606,426317166,16276091,2788613,1,'2009-10-09 02:34:06',3310505089,1),(526432607,426318789,16278861,2788613,1,'2009-10-09 02:34:06',3310505089,1),(526432609,426324763,16282489,2788613,1,'2009-10-09 02:34:06',3310505089,1),(526432610,426328229,16287091,2788613,1,'2009-10-09 02:34:06',3310505089,1),(526432611,426331012,16292013,2788613,1,'2009-10-09 02:34:06',3310505092,1),(526432613,426334488,16298166,2788613,1,'2009-10-09 02:34:06',3310505092,1),(526432614,426336819,16304340,2788613,1,'2009-10-09 02:34:06',3310505092,1),(526432616,426337553,16311773,2788613,1,'2009-10-09 02:34:07',3310505092,1),(526432618,426338739,16317961,2788613,1,'2009-10-09 02:34:07',3310505094,1),(526432619,426341045,16320411,2788613,1,'2009-10-09 02:34:07',3310505094,1),(526432642,426324069,16382720,2788613,1,'2009-10-09 02:34:07',3310505097,1),(526432643,426318802,16382495,2788613,1,'2009-10-09 02:34:07',3310505097,1),(526432645,426311003,16398277,2788613,1,'2009-10-09 02:34:07',3310505097,1),(526432647,426314061,16412728,2788613,1,'2009-10-09 02:34:07',3310505097,1),(526432648,426317678,16419921,2788613,1,'2009-10-09 02:34:07',3310505097,1),(526433326,425836517,17663623,2788613,1,'2009-10-09 02:34:35',3310510167,1),(526433329,425836412,17646263,2788613,1,'2009-10-09 02:34:35',3310510167,1),(526433330,425840207,17627610,2788613,1,'2009-10-09 02:34:35',3310510336,1),(526433332,425847187,17608615,2788613,1,'2009-10-09 02:34:35',3310510336,1),(526433334,425855988,17586175,2788613,1,'2009-10-09 02:34:35',3310510336,1),(526433335,425858330,17581367,2788613,1,'2009-10-09 02:34:35',3310510336,1),(526433336,425864813,17568079,2788613,1,'2009-10-09 02:34:35',3310504875,1),(526433338,425870043,17561814,2788613,1,'2009-10-09 02:34:35',3310504875,1),(526433339,425877100,17557072,2788613,1,'2009-10-09 02:34:35',3310504875,1),(526433343,425879603,17553006,2788613,1,'2009-10-09 02:34:35',3310504875,1),(526433344,425893195,17534276,2788613,1,'2009-10-09 02:34:35',3310504878,1),(526433351,425916937,17467635,2788613,1,'2009-10-09 02:34:36',3310504870,1),(526433352,425925154,17449541,2788613,1,'2009-10-09 02:34:36',3310504871,1),(526433354,425933320,17422446,2788613,1,'2009-10-09 02:34:36',3310504871,1),(526433355,425938051,17377376,2788613,1,'2009-10-09 02:34:36',3310504869,1),(526433357,425948016,17375024,2788613,1,'2009-10-09 02:34:36',3310504880,1),(526433358,425957062,17356920,2788613,1,'2009-10-09 02:34:36',3310504858,1),(526433360,425966989,17347815,2788613,1,'2009-10-09 02:34:36',3310504858,1),(526435772,425171383,17217950,2788623,1,'2009-10-09 02:36:04',3310493591,1),(526435773,425154623,17195648,2788623,1,'2009-10-09 02:36:04',3310493591,1),(526435775,425142793,17163179,2788623,1,'2009-10-09 02:36:04',3310493588,1),(526435776,425131746,17122836,2788623,1,'2009-10-09 02:36:04',3310493502,1),(526435778,425136622,17103676,2788623,1,'2009-10-09 02:36:04',3310493502,1),(526435779,425162291,17085415,2788623,1,'2009-10-09 02:36:04',3310493503,1),(526435781,425163055,17074167,2788623,1,'2009-10-09 02:36:04',3310493501,1),(526435783,425181274,17061605,2788623,1,'2009-10-09 02:36:04',3310493544,1),(526435784,425186209,17052559,2788623,1,'2009-10-09 02:36:04',3310493544,1),(526435785,425182796,17037984,2788623,1,'2009-10-09 02:36:04',3310493544,1),(526435787,425169479,17035881,2788623,1,'2009-10-09 02:36:04',3310493501,1),(526435788,425159515,17038238,2788623,1,'2009-10-09 02:36:05',3310493501,1),(526435790,425132077,17038537,2788623,1,'2009-10-09 02:36:05',3310493500,1),(526435791,425106457,17064666,2788623,1,'2009-10-09 02:36:05',3310493497,1),(526435793,425082405,17075042,2788623,1,'2009-10-09 02:36:05',3310493496,1),(526435794,425064944,17075231,2788623,1,'2009-10-09 02:36:05',3310493485,1),(526435796,425052352,17055139,2788623,1,'2009-10-09 02:36:05',3310493485,1),(526435798,425043052,17029394,2788623,1,'2009-10-09 02:36:05',3310493485,1),(526435800,425038816,17022075,2788623,1,'2009-10-09 02:36:05',3310493478,1),(526435802,425040374,17016220,2788623,1,'2009-10-09 02:36:05',3310493479,1),(526435808,425042731,16993714,2788623,1,'2009-10-09 02:36:05',3310493479,1),(526435811,425050891,16967776,2788623,1,'2009-10-09 02:36:05',3310493477,1),(526435812,425055684,16936262,2788623,1,'2009-10-09 02:36:05',3310493477,1),(526435815,425045611,16920636,2788623,1,'2009-10-09 02:36:06',3310493477,1),(526435816,425026398,16906242,2788623,1,'2009-10-09 02:36:06',3310493454,1),(526435818,425022938,16883808,2788623,1,'2009-10-09 02:36:06',3310493454,1),(526435820,425042021,16876853,2788623,1,'2009-10-09 02:36:06',3310493455,1),(526435821,425057747,16864314,2788623,1,'2009-10-09 02:36:06',3310493455,1),(526435824,425061838,16854158,2788623,1,'2009-10-09 02:36:06',3310493453,1),(526435826,425071649,16827076,2788623,1,'2009-10-09 02:36:06',3310493464,1),(526435827,425061568,16810329,2788623,1,'2009-10-09 02:36:06',3310493453,1),(526435828,425044935,16810516,2788623,1,'2009-10-09 02:36:06',3310493453,1),(526435830,425031559,16798305,2788623,1,'2009-10-09 02:36:06',3310493446,1),(526435831,425023878,16766933,2788623,1,'2009-10-09 02:36:06',3310493446,1),(526435851,424996365,16660950,2788623,1,'2009-10-09 02:36:07',3310493099,1),(526435853,424997470,16659944,2788623,1,'2009-10-09 02:36:07',3310493099,1),(526435854,425168968,16611762,2788623,1,'2009-10-09 02:36:07',3310493117,1),(526435856,425332962,16653895,2788623,1,'2009-10-09 02:36:07',3310493179,1),(526435858,425331734,16665611,2788623,1,'2009-10-09 02:36:07',3310493179,1),(526435859,425340185,16686874,2788623,1,'2009-10-09 02:36:07',3310493179,1),(526435861,425353584,16702466,2788623,1,'2009-10-09 02:36:07',3310493524,1),(526435862,425347074,16723902,2788623,1,'2009-10-09 02:36:07',3310493524,1),(526435864,425339714,16744225,2788623,1,'2009-10-09 02:36:07',3310493521,1),(526435865,425342311,16761056,2788623,1,'2009-10-09 02:36:07',3310493526,1),(526435867,425342451,16783547,2788623,1,'2009-10-09 02:36:07',3310493526,1),(526435880,425330100,16802794,2788624,1,'2009-10-09 02:36:09',3310493523,1),(526435881,425305877,16786208,2788624,1,'2009-10-09 02:36:09',3310493522,1),(526435883,425292465,16768369,2788624,1,'2009-10-09 02:36:09',3310493522,1),(526435884,425291600,16762757,2788624,1,'2009-10-09 02:36:09',3310493522,1),(526435885,425275846,16770812,2788624,1,'2009-10-09 02:36:09',3310493511,1),(526435887,425258331,16760889,2788624,1,'2009-10-09 02:36:09',3310493510,1),(526435888,425246468,16725054,2788624,1,'2009-10-09 02:36:09',3310493508,1),(526435889,425238784,16693663,2788624,1,'2009-10-09 02:36:09',3310493166,1),(526435891,425222953,16689346,2788624,1,'2009-10-09 02:36:09',3310493163,1),(526435892,425209541,16671521,2788624,1,'2009-10-09 02:36:09',3310493163,1),(526435894,425188762,16672883,2788624,1,'2009-10-09 02:36:09',3310493162,1),(526435895,425172101,16668576,2788624,1,'2009-10-09 02:36:09',3310493119,1),(526435896,425155383,16655282,2788624,1,'2009-10-09 02:36:09',3310493119,1),(526435898,425137981,16663349,2788624,1,'2009-10-09 02:36:09',3310493118,1),(526435899,425133100,16681391,2788624,1,'2009-10-09 02:36:09',3310493118,1),(526435901,425151571,16709277,2788624,1,'2009-10-09 02:36:09',3310493461,1),(526435902,425141692,16725130,2788624,1,'2009-10-09 02:36:09',3310493460,1),(526435903,425128491,16741014,2788624,1,'2009-10-09 02:36:09',3310493460,1),(526435905,425123623,16761300,2788624,1,'2009-10-09 02:36:09',3310493462,1),(526435906,425128806,16791583,2788624,1,'2009-10-09 02:36:09',3310493462,1),(526435907,425128966,16817433,2788624,1,'2009-10-09 02:36:10',3310493468,1),(526435908,425117425,16833303,2788624,1,'2009-10-09 02:36:10',3310493465,1),(526435909,425122602,16864710,2788624,1,'2009-10-09 02:36:10',3310493470,1),(526435910,425116873,16880514,2788624,1,'2009-10-09 02:36:10',3310493467,1),(526435912,425105317,16894130,2788624,1,'2009-10-09 02:36:10',3310493467,1),(526435913,425098803,16915554,2788624,1,'2009-10-09 02:36:10',3310493467,1),(526435914,425091502,16945976,2788624,1,'2009-10-09 02:36:10',3310493488,1),(526435916,425085820,16969643,2788624,1,'2009-10-09 02:36:10',3310493488,1),(526435917,425084301,16993257,2788624,1,'2009-10-09 02:36:10',3310493490,1),(526435918,425089437,17016805,2788624,1,'2009-10-09 02:36:10',3310493490,1),(526435920,425100258,17018932,2788624,1,'2009-10-09 02:36:10',3310493491,1),(526435921,425118484,17007491,2788624,1,'2009-10-09 02:36:10',3310493491,1),(526435923,425139283,17009516,2788624,1,'2009-10-09 02:36:10',3310493494,1),(526435924,425157599,17014937,2788624,1,'2009-10-09 02:36:10',3310493495,1),(526435926,425181772,17023662,2788624,1,'2009-10-09 02:36:10',3310493538,1),(526435927,425236944,17073649,2788624,1,'2009-10-09 02:36:10',3310493548,1),(526435928,425233117,17081178,2788624,1,'2009-10-09 02:36:10',3310493548,1),(526435930,425225439,17096253,2788624,1,'2009-10-09 02:36:10',3310493547,1),(526435931,425222183,17107532,2788624,1,'2009-10-09 02:36:10',3310493547,1),(526435933,425203204,17132461,2788624,1,'2009-10-09 02:36:10',3310493546,1),(526435934,425195831,17151651,2788624,1,'2009-10-09 02:36:10',3310493632,1),(526435935,425195145,17176389,2788624,1,'2009-10-09 02:36:11',3310493632,1),(526435937,425187771,17195578,2788624,1,'2009-10-09 02:36:11',3310493634,1),(526435953,425192896,17218002,2788624,1,'2009-10-09 02:36:11',3310493634,1),(526435954,425195607,17226864,2788624,1,'2009-10-09 02:36:13',3310493634,1),(526435955,425203813,17232847,2788624,1,'2009-10-09 02:36:13',3310493634,1),(526435956,425211451,17239753,2788624,1,'2009-10-09 02:36:13',3310493635,1),(526436136,425632841,14524924,2788624,1,'2009-10-09 02:36:19',3310502080,1),(526436137,425622011,14512987,2788624,1,'2009-10-09 02:36:19',3310502080,1),(526436139,425615122,14507952,2788624,1,'2009-10-09 02:36:19',3310502037,1),(526436141,425605168,14498850,2788624,1,'2009-10-09 02:36:19',3310501951,1),(526436142,425598089,14471186,2788624,1,'2009-10-09 02:36:19',3310501951,1),(526436144,425586548,14454912,2788624,1,'2009-10-09 02:36:19',3310501950,1),(526436145,425577678,14459975,2788624,1,'2009-10-09 02:36:19',3310501950,1),(526436146,425580264,14431041,2788624,1,'2009-10-09 02:36:19',3310501948,1),(526436148,425583315,14414892,2788624,1,'2009-10-09 02:36:19',3310501948,1),(526436149,425582442,14392609,2788624,1,'2009-10-09 02:36:19',3310501948,1),(526436151,425594096,14308302,2788624,1,'2009-10-09 02:36:19',3310501941,1),(526436152,425594910,14302421,2788624,1,'2009-10-09 02:36:19',3310501941,1),(526436154,425597252,14285510,2788624,1,'2009-10-09 02:36:19',3310501941,1),(526436155,425617253,14335743,2788624,1,'2009-10-09 02:36:19',3310501984,1),(526436157,425639367,14393897,2788624,1,'2009-10-09 02:36:19',3310501992,1),(526436158,425642382,14409453,2788624,1,'2009-10-09 02:36:20',3310501992,1),(526436160,425645460,14408747,2788624,1,'2009-10-09 02:36:20',3310501993,1),(526436161,425655235,14395226,2788624,1,'2009-10-09 02:36:20',3310501993,1),(526436162,425670354,14385736,2788624,1,'2009-10-09 02:36:20',3310501987,1),(526436163,425678120,14404128,2788624,1,'2009-10-09 02:36:20',3310501996,1),(526436164,425675182,14416519,2788624,1,'2009-10-09 02:36:20',3310501996,1),(526436165,425659350,14433217,2788624,1,'2009-10-09 02:36:20',3310501993,1),(526436167,425655824,14465161,2788624,1,'2009-10-09 02:36:20',3310501995,1),(526436168,425649905,14484795,2788624,1,'2009-10-09 02:36:20',3310501995,1),(526436169,425637928,14507604,2788624,1,'2009-10-09 02:36:20',3310502080,1),(526826196,426552316,15644353,2791232,1,'2009-10-09 12:38:34',3310503652,1),(526826197,426558720,15626565,2791232,1,'2009-10-09 12:38:34',3310503652,1),(526826198,426559810,15612870,2791232,1,'2009-10-09 12:38:34',3310503652,1),(526826199,426553154,15596054,2791232,1,'2009-10-09 12:38:34',3310503630,1),(526826200,426557225,15584738,2791232,1,'2009-10-09 12:38:34',3310503630,1),(526827378,426544354,15516754,2791237,1,'2009-10-09 12:39:53',3310503625,1),(526827379,426539487,15528036,2791237,1,'2009-10-09 12:39:54',3310503625,1),(526827380,426537618,15533437,2791237,1,'2009-10-09 12:39:54',3310503625,1),(526827381,426534155,15543415,2791237,1,'2009-10-09 12:39:54',3310503625,1),(526827382,426524944,15569979,2791237,1,'2009-10-09 12:39:54',3310503627,1),(526827383,426523181,15572998,2791237,1,'2009-10-09 12:39:54',3310503626,1),(526827384,426521873,15575236,2791237,1,'2009-10-09 12:39:54',3310503626,1),(526827385,426520552,15578904,2791237,1,'2009-10-09 12:39:54',3310503626,1),(526827386,426521482,15583150,2791237,1,'2009-10-09 12:39:54',3310503626,1),(526827387,426532511,15603897,2791237,1,'2009-10-09 12:39:54',3310503649,1),(526827388,426533383,15606410,2791237,1,'2009-10-09 12:39:54',3310503649,1),(526827389,426533461,15607953,2791237,1,'2009-10-09 12:39:54',3310503649,1),(526827390,426533841,15615346,2791237,1,'2009-10-09 12:39:54',3310503649,1),(526827391,426534656,15617852,2791237,1,'2009-10-09 12:39:54',3310503649,1),(526827392,426534454,15619391,2791237,1,'2009-10-09 12:39:54',3310503649,1),(526827393,426533873,15621315,2791237,1,'2009-10-09 12:39:54',3310503649,1),(526827394,426534734,15623995,2791237,1,'2009-10-09 12:39:54',3310503649,1),(526827395,426524093,15642532,2791237,1,'2009-10-09 12:39:54',3310503649,1),(526827396,426511720,15636112,2791237,1,'2009-10-09 12:39:54',3310503648,1),(526827397,426493114,15638527,2791237,1,'2009-10-09 12:39:54',3310503605,1),(526827398,426478783,15643767,2791237,1,'2009-10-09 12:39:54',3310503605,1),(526827399,426456978,15646217,2791237,1,'2009-10-09 12:39:54',3310503604,1),(526827400,426445888,15658621,2791237,1,'2009-10-09 12:39:54',3310503606,1),(526827401,426436448,15678932,2791237,1,'2009-10-09 12:39:54',3310503603,1),(526827402,426430020,15673254,2791237,1,'2009-10-09 12:39:54',3310503603,1),(526827403,426429414,15662444,2791237,1,'2009-10-09 12:39:55',3310503603,1),(526827405,426422311,15636591,2791237,1,'2009-10-09 12:39:55',3310503601,1),(526827406,426408909,15624514,2791237,1,'2009-10-09 12:39:55',3310503600,1),(526827407,426413080,15611481,2791237,1,'2009-10-09 12:39:55',3310503600,1),(526827410,426424771,15609158,2791237,1,'2009-10-09 12:39:55',3310503601,1),(526827411,426433734,15597504,2791237,1,'2009-10-09 12:39:56',3310503579,1),(526827412,426441119,15588031,2791237,1,'2009-10-09 12:39:56',3310503582,1),(526827413,426446835,15569935,2791237,1,'2009-10-09 12:39:56',3310503582,1),(526827414,426446607,15538934,2791237,1,'2009-10-09 12:39:56',3310503580,1),(526827415,426449609,15512214,2791237,1,'2009-10-09 12:39:56',3310503580,1),(526827416,426451538,15486239,2791237,1,'2009-10-09 12:39:56',3310503574,1),(526827417,426453398,15449445,2791237,1,'2009-10-09 12:39:56',3310503574,1),(526827418,426462988,15451473,2791237,1,'2009-10-09 12:39:56',3310503574,1),(526827419,426473219,15467194,2791237,1,'2009-10-09 12:39:56',3310503575,1),(526827420,426474473,15492412,2791237,1,'2009-10-09 12:39:56',3310503581,1),(526827421,426485162,15498760,2791237,1,'2009-10-09 12:39:56',3310503581,1),(526827422,426495147,15481319,2791237,1,'2009-10-09 12:39:56',3310503575,1),(526827424,426505271,15464430,2791237,1,'2009-10-09 12:39:56',3310503618,1),(526827425,426521953,15472088,2791237,1,'2009-10-09 12:39:56',3310503618,1),(526827426,426535374,15486551,2791237,1,'2009-10-09 12:39:56',3310503619,1),(526827607,426418237,15589060,2791237,1,'2009-10-09 12:40:06',3310503579,1),(526827608,426416479,15566732,2791237,1,'2009-10-09 12:40:06',3310503579,1),(526827609,426413419,15561186,2791237,1,'2009-10-09 12:40:06',3310503579,1),(526827610,426419581,15559582,2791237,1,'2009-10-09 12:40:06',3310503579,1),(526827611,426420279,15541555,2791237,1,'2009-10-09 12:40:06',3310503577,1),(526827612,426417588,15514556,2791237,1,'2009-10-09 12:40:06',3310503577,1),(526827613,426405790,15493315,2791237,1,'2009-10-09 12:40:06',3310503576,1),(526827614,426398824,15451727,2791237,1,'2009-10-09 12:40:06',3310503570,1),(526827615,426410405,15443685,2791237,1,'2009-10-09 12:40:06',3310503570,1),(526827616,426439466,15437372,2791237,1,'2009-10-09 12:40:06',3310503571,1),(526828351,426401318,15564337,2791248,1,'2009-10-09 12:40:52',3310503578,1),(526828352,426393735,15549797,2791248,1,'2009-10-09 12:40:52',3310503578,1),(526828354,426381968,15534189,2791248,1,'2009-10-09 12:40:53',3310503565,1),(526828355,426376071,15523002,2791248,1,'2009-10-09 12:40:53',3310503565,1),(526828356,426366856,15514119,2791248,1,'2009-10-09 12:40:53',3310503565,1),(526828357,426365851,15490475,2791248,1,'2009-10-09 12:40:53',3310503559,1),(526828358,426363972,15461218,2791248,1,'2009-10-09 12:40:53',3310503559,1),(526828359,426347270,15452431,2791248,1,'2009-10-09 12:40:53',3310503558,1),(526828360,426370831,15503427,5709666,1,'2010-09-07 19:40:44',3310503565,2),(526828361,426362830,15419561,2791248,1,'2009-10-09 12:40:53',3310503557,1),(526828362,426363577,15408285,2791248,1,'2009-10-09 12:40:53',3310503557,1),(526828363,426372564,15386762,2791248,1,'2009-10-09 12:40:53',3310503557,1),(526828364,426373242,15366478,2791248,1,'2009-10-09 12:40:53',3310503471,1),(526828365,426360659,15353135,2791248,1,'2009-10-09 12:40:53',3310503471,1),(526828366,426343882,15333094,2791248,1,'2009-10-09 12:40:53',3310503470,1),(526828367,426352800,15302556,2791248,1,'2009-10-09 12:40:53',3310503468,1),(526828368,426380258,15305556,2791248,1,'2009-10-09 12:40:54',3310503469,1),(526828369,426394631,15335766,2791248,1,'2009-10-09 12:40:54',3310503482,1),(526828370,426401480,15362705,2791248,1,'2009-10-09 12:40:54',3310503482,1),(526828371,426409111,15381750,2791248,1,'2009-10-09 12:40:54',3310503568,1),(526828372,426410077,15399762,2791248,1,'2009-10-09 12:40:54',3310503568,1),(526828373,426411974,15431271,2791248,1,'2009-10-09 12:40:54',3310503568,1),(526829149,426245218,17130607,2791251,1,'2009-10-09 12:41:46',3310504830,1),(526829150,426241953,17119448,2791251,1,'2009-10-09 12:41:46',3310504830,1),(526829151,426240327,17114054,2791251,1,'2009-10-09 12:41:46',3310504830,1),(526829153,426238964,17109372,2791251,1,'2009-10-09 12:41:47',3310504830,1),(526829154,426238633,17098903,2791251,1,'2009-10-09 12:41:47',3310504830,1),(526829155,426241272,17093463,2791251,1,'2009-10-09 12:41:47',3310504830,1),(526829156,426244170,17088012,2791251,1,'2009-10-09 12:41:47',3310504830,1),(526829157,426247332,17081845,2791251,1,'2009-10-09 12:41:47',3310504828,1),(526829158,426251576,17078189,2791251,1,'2009-10-09 12:41:47',3310504829,1),(526829159,426253698,17076357,2791251,1,'2009-10-09 12:41:47',3310504829,1),(526829161,426258760,17076302,2791251,1,'2009-10-09 12:41:47',3310504829,1),(526829168,426266344,17050948,2791251,1,'2009-10-09 12:41:47',3310504829,1),(526829170,426267639,17044071,2791251,1,'2009-10-09 12:41:47',3310504829,1),(526829171,426272393,17037521,2791251,1,'2009-10-09 12:41:47',3310504829,1),(526829550,426076953,16975818,2791253,1,'2009-10-09 12:42:11',3310504802,1),(526829551,426064349,16955694,2791253,1,'2009-10-09 12:42:11',3310504800,1),(526829552,426047569,16929987,2791253,1,'2009-10-09 12:42:11',3310504757,1),(526829553,426035820,16912104,2791253,1,'2009-10-09 12:42:11',3310504735,1),(526829554,426019397,16926661,2791253,1,'2009-10-09 12:42:11',3310504756,1),(526829555,426017279,16906871,2791253,1,'2009-10-09 12:42:11',3310504734,1),(526829556,426012401,16870907,2791253,1,'2009-10-09 12:42:11',3310504734,1),(526829557,425998912,16840435,2791253,1,'2009-10-09 12:42:11',3310504729,1),(526829559,425983464,16816300,2791253,1,'2009-10-09 12:42:12',3310504729,1),(526829560,425971393,16801129,2791253,1,'2009-10-09 12:42:12',3310504722,1),(526829562,425954653,16784212,2791253,1,'2009-10-09 12:42:12',3310504722,1),(526829563,425945893,16765404,2791253,1,'2009-10-09 12:42:12',3310504711,1),(526829564,425945116,16693226,2791253,1,'2009-10-09 12:42:12',3310504367,1),(526829565,425967459,16703019,2791253,1,'2009-10-09 12:42:12',3310504720,1),(526829566,425975897,16716740,2791253,1,'2009-10-09 12:42:12',3310504721,1),(526829567,425986249,16740490,2791253,1,'2009-10-09 12:42:12',3310504721,1),(526829569,425989145,16756790,2791253,1,'2009-10-09 12:42:12',3310504723,1),(526829570,425998518,16773017,2791253,1,'2009-10-09 12:42:12',3310504723,1),(526829571,426011625,16790455,2791253,1,'2009-10-09 12:42:12',3310504726,1),(526829574,426023807,16809158,2791253,1,'2009-10-09 12:42:12',3310504726,1),(526829575,426046014,16798855,2791253,1,'2009-10-09 12:42:12',3310504727,1),(526829576,426058018,16788675,2791253,1,'2009-10-09 12:42:12',3310504770,1),(526829577,426054108,16757303,2791253,1,'2009-10-09 12:42:12',3310504727,1),(526829578,426041995,16749904,2791253,1,'2009-10-09 12:42:12',3310504725,1),(526829579,426025230,16740045,2791253,1,'2009-10-09 12:42:12',3310504724,1),(526829580,426015759,16710007,2791253,1,'2009-10-09 12:42:12',3310504724,1),(526829581,426003543,16686278,2791253,1,'2009-10-09 12:42:12',3310504382,1),(526829582,425995349,16668390,2791253,1,'2009-10-09 12:42:12',3310504379,1),(526829584,426014315,16662450,2791253,1,'2009-10-09 12:42:13',3310504382,1),(526829585,426025060,16652199,2791253,1,'2009-10-09 12:42:13',3310504382,1),(526829586,426042471,16645243,2791253,1,'2009-10-09 12:42:13',3310504383,1),(526829587,426060845,16657414,2791253,1,'2009-10-09 12:42:13',3310504426,1),(526829589,426058537,16686707,2791253,1,'2009-10-09 12:42:13',3310504426,1),(526829590,426068686,16713608,2791253,1,'2009-10-09 12:42:13',3310504768,1),(526829591,426073029,16743958,2791253,1,'2009-10-09 12:42:13',3310504768,1),(526829592,426078254,16781045,2791253,1,'2009-10-09 12:42:13',3310504770,1),(526829594,426075944,16810338,2791253,1,'2009-10-09 12:42:13',3310504776,1),(526829595,426069510,16846440,2791253,1,'2009-10-09 12:42:13',3310504776,1),(526829596,426069696,16876830,2791253,1,'2009-10-09 12:42:13',3310504778,1),(526829597,426087230,16887894,2791253,1,'2009-10-09 12:42:13',3310504779,1),(526829598,426107255,16898930,2791253,1,'2009-10-09 12:42:13',3310504779,1),(526829599,426128166,16918962,2791253,1,'2009-10-09 12:42:13',3310504782,1),(526829600,426136701,16954893,2791253,1,'2009-10-09 12:42:13',3310504804,1),(526829601,426146822,16978421,2791253,1,'2009-10-09 12:42:13',3310504807,1),(526829603,426158557,16994059,2791253,1,'2009-10-09 12:42:13',3310504807,1),(526829604,426183666,17021931,2791253,1,'2009-10-09 12:42:13',3310504818,1),(526830271,426038302,16319017,2791257,1,'2009-10-09 12:42:50',3310504343,1),(526830272,426025346,16325458,2791257,1,'2009-10-09 12:42:50',3310504342,1),(526830274,426005819,16319412,2791257,1,'2009-10-09 12:42:51',3310504342,1),(526830275,425978862,16313458,2791257,1,'2009-10-09 12:42:51',3310504337,1),(526830276,425964902,16307345,2791257,1,'2009-10-09 12:42:51',3310504336,1),(526830277,425951896,16306250,2791257,1,'2009-10-09 12:42:51',3310504336,1),(526830278,425938860,16298873,2791257,1,'2009-10-09 12:42:51',3310504325,1),(526830279,425923910,16283977,2791257,1,'2009-10-09 12:42:51',3310504325,1),(526830280,425913780,16296665,2791257,1,'2009-10-09 12:42:51',3310504324,1),(526830281,425909270,16315565,2791257,1,'2009-10-09 12:42:51',3310504326,1),(526830283,425897179,16311937,2791257,1,'2009-10-09 12:42:51',3310504324,1),(526830284,425882288,16305844,2791257,1,'2009-10-09 12:42:51',3310504321,1),(526830285,425864529,16287217,2791257,1,'2009-10-09 12:42:51',3310504321,1),(526830286,425856909,16257165,2791257,1,'2009-10-09 12:42:51',3310504234,1),(526830287,425840095,16242303,2791257,1,'2009-10-09 12:42:51',3310504234,1),(526830288,425838075,16217211,2791257,1,'2009-10-09 12:42:51',3310504234,1),(526830289,425856681,16223263,2791257,1,'2009-10-09 12:42:51',3310504234,1),(526830290,425861257,16214412,2791257,1,'2009-10-09 12:42:51',3310504234,1),(526830291,425871446,16210518,2791257,1,'2009-10-09 12:42:52',3310504235,1),(526830292,425896464,16205181,2791257,1,'2009-10-09 12:42:52',3310504238,1),(526830293,425911245,16194957,2791257,1,'2009-10-09 12:42:52',3310504236,1),(526830294,425903730,16182487,2791257,1,'2009-10-09 12:42:52',3310504236,1),(526830295,425881453,16181509,2791257,1,'2009-10-09 12:42:52',3310504233,1),(526830297,425861892,16170443,2791257,1,'2009-10-09 12:42:52',3310504232,1),(526830298,425855308,16157969,2791257,1,'2009-10-09 12:42:52',3310504232,1),(526830299,425865425,16145281,2791257,1,'2009-10-09 12:42:52',3310504227,1),(526830300,425897865,16138595,2791257,1,'2009-10-09 12:42:52',3310504230,1),(526830301,425920178,16143346,2791257,1,'2009-10-09 12:42:52',3310504231,1),(526830302,425944188,16126715,2791257,1,'2009-10-09 12:42:52',3310504231,1),(526830303,425943517,16146959,2791257,1,'2009-10-09 12:42:52',3310504231,1),(526830304,425950972,16173598,2791257,1,'2009-10-09 12:42:52',3310504248,1),(526830305,425955410,16215756,2791257,1,'2009-10-09 12:42:52',3310504250,1),(526830306,425941944,16222957,2791257,1,'2009-10-09 12:42:52',3310504239,1),(526830307,425923337,16238659,2791257,1,'2009-10-09 12:42:52',3310504239,1),(526830308,425935941,16256796,2791257,1,'2009-10-09 12:42:52',3310504239,1),(526830309,425952686,16274875,2791257,1,'2009-10-09 12:42:52',3310504336,1),(526830310,425969282,16269050,2791257,1,'2009-10-09 12:42:52',3310504336,1),(526830312,425994234,16268745,2791257,1,'2009-10-09 12:42:52',3310504337,1),(526830313,426006826,16286877,2791257,1,'2009-10-09 12:42:52',3310504340,1),(526830314,426022472,16295134,2791257,1,'2009-10-09 12:42:52',3310504340,1),(526830315,426033919,16296400,2791257,1,'2009-10-09 12:42:52',3310504341,1),(526831529,425713095,14766183,2791267,1,'2009-10-09 12:44:07',3310502117,1),(526831530,425706072,14779142,2791267,1,'2009-10-09 12:44:07',3310502119,1),(526831531,425574208,14587765,2791267,1,'2009-10-09 12:44:07',3310502038,1),(526831532,425583892,14592759,2791267,1,'2009-10-09 12:44:07',3310502038,1),(526831533,425593847,14600838,2791267,1,'2009-10-09 12:44:07',3310502039,1),(526831534,425603622,14588345,2791267,1,'2009-10-09 12:44:07',3310502039,1),(526831535,425618177,14601495,2791267,1,'2009-10-09 12:44:07',3310502082,1),(526831536,425623386,14588046,2791267,1,'2009-10-09 12:44:07',3310502082,1),(526831537,425630054,14566345,2791267,1,'2009-10-09 12:44:07',3310502082,1),(526831538,425634729,14557512,2791267,1,'2009-10-09 12:44:07',3310502082,1),(526831539,425640677,14564126,2791267,1,'2009-10-09 12:44:07',3310502082,1),(526831540,425655927,14569043,2791267,1,'2009-10-09 12:44:07',3310502083,1),(526831541,425665573,14541122,2791267,1,'2009-10-09 12:44:07',3310502081,1),(526831542,425678263,14512129,2791267,1,'2009-10-09 12:44:07',3310502084,1),(526831543,425695775,14514952,2791267,1,'2009-10-09 12:44:07',3310502084,1),(526831544,425702226,14559084,2791267,1,'2009-10-09 12:44:07',3310502087,1),(526831545,425711646,14595967,2791267,1,'2009-10-09 12:44:07',3310502087,1);
INSERT INTO `nodes` VALUES (526831546,425727091,14624536,2791267,1,'2009-10-09 12:44:07',3310502104,1),(526831547,425730454,14663578,2791267,1,'2009-10-09 12:44:07',3310502104,1),(526831548,425735179,14684086,2791267,1,'2009-10-09 12:44:07',3310502106,1),(526831549,425736857,14702574,2791267,1,'2009-10-09 12:44:08',3310502106,1),(526831550,425743841,14717939,2791267,1,'2009-10-09 12:44:08',3310502106,1),(526831551,425740443,14719698,2791267,1,'2009-10-09 12:44:08',3310502106,1),(526831552,425728612,14725228,2791267,1,'2009-10-09 12:44:08',3310502128,1),(526831553,425706556,14740561,2791267,1,'2009-10-09 12:44:08',3310502117,1),(529940889,425562347,15367648,2836771,1,'2009-10-13 18:43:08',3310502462,1),(529941178,425565635,15340525,2836771,1,'2009-10-13 18:54:58',3310502462,2),(529943807,425567658,15328852,2836771,1,'2009-10-13 18:54:44',3310502462,1),(529948761,425544851,15372590,2895121,1,'2009-10-19 19:03:33',3310502459,2),(529948762,425545167,15373362,2895121,1,'2009-10-19 19:03:33',3310502459,3),(529948763,425545546,15373877,2895121,1,'2009-10-19 19:03:34',3310502459,4),(529948764,425547569,15374564,2895121,1,'2009-10-19 19:03:34',3310502459,3),(529948765,425548518,15374392,2895121,1,'2009-10-19 19:03:33',3310502459,3),(529948766,425549213,15373877,2895121,1,'2009-10-19 19:03:33',3310502459,3),(535384824,425151799,15256312,2895121,1,'2009-10-19 19:15:15',3310491447,1),(535385847,425099202,15480651,2895121,1,'2009-10-19 19:17:29',3310491539,1),(535386385,425098823,15479793,2895121,1,'2009-10-19 19:20:25',3310491539,2),(535387283,425099582,15480651,2895121,1,'2009-10-19 19:20:05',3310491539,1),(535387288,425099772,15479535,2895121,1,'2009-10-19 19:20:05',3310491539,1),(535387292,425099455,15479278,2895121,1,'2009-10-19 19:20:05',3310491539,1),(535387294,425099076,15479278,2895121,1,'2009-10-19 19:20:25',3310491539,2),(535387296,425098886,15480393,2895121,1,'2009-10-19 19:20:05',3310491539,1),(567007523,425775904,16490101,4108069,1,'2010-03-12 19:04:14',3310504177,3),(579971414,424434795,15530422,3283462,1,'2009-12-03 21:50:21',3310490584,1),(579971423,424460911,15548364,3283462,1,'2009-12-03 21:50:21',3310490587,1),(579971445,424464032,15551386,3283462,1,'2009-12-03 21:50:22',3310490590,1),(579971453,424467646,15557849,3283462,1,'2009-12-03 21:50:23',3310490590,1),(579971472,424474615,15581817,3283462,1,'2009-12-03 21:50:23',3310490590,1),(579971480,424477445,15587614,3283462,1,'2009-12-03 21:50:24',3310490590,1),(579971484,424483022,15596772,3283462,1,'2009-12-03 21:50:24',3310490590,1),(579971485,424486403,15600057,3283462,1,'2009-12-03 21:50:24',3310490590,1),(579971492,424507397,15590642,3283462,1,'2009-12-03 21:50:25',3310490591,1),(579971493,424489591,15601383,3283462,1,'2009-12-03 21:50:25',3310490612,1),(579971494,424493182,15601644,3283462,1,'2009-12-03 21:50:26',3310490613,1),(579971697,424765721,14398064,3283462,1,'2009-12-03 21:50:51',3310490729,1),(579971713,424754801,14410304,3283462,1,'2009-12-03 21:50:51',3310490728,1),(579971721,424749943,14412514,3283462,1,'2009-12-03 21:50:52',3310490728,1),(579971757,424948182,14410755,3283462,1,'2009-12-03 21:50:54',3310490749,1),(579971802,424952163,14433423,3283462,1,'2009-12-03 21:50:56',3310490749,1),(579971887,425052441,14609800,3283462,1,'2009-12-03 21:51:00',3310491015,1),(579971891,425052725,14607144,3283462,1,'2009-12-03 21:51:00',3310491015,1),(579971895,425040155,14590065,3283462,1,'2009-12-03 21:51:00',3310491015,1),(579971896,425035047,14577898,3283462,1,'2009-12-03 21:51:01',3310491014,1),(579971897,425027917,14564492,3283462,1,'2009-12-03 21:51:01',3310491014,1),(579971898,425021840,14556394,3283462,1,'2009-12-03 21:51:01',3310491012,1),(579971902,425016240,14547600,3283462,1,'2009-12-03 21:51:01',3310491012,1),(579971909,425000569,14515337,3283462,1,'2009-12-03 21:51:02',3310491009,1),(579971916,425115594,14680381,3283462,1,'2009-12-03 21:51:02',3310491035,1),(579971917,425107757,14691991,3283462,1,'2009-12-03 21:51:03',3310491035,1),(579971921,425094457,14668285,3283462,1,'2009-12-03 21:51:03',3310491034,1),(579971959,425066258,14624900,3283462,1,'2009-12-03 21:51:04',3310491021,1),(579971967,425138276,14652914,3283462,1,'2009-12-03 21:51:05',3310491036,1),(579971988,425127348,14665278,3283462,1,'2009-12-03 21:51:05',3310491036,1),(579972040,425234718,14599545,3283462,1,'2009-12-03 21:51:09',3310491078,1),(579972062,425187028,14635702,3283462,1,'2009-12-03 21:51:10',3310491080,1),(579972081,425389455,14512692,3283462,1,'2009-12-03 21:51:10',3310491093,1),(579972127,425385107,14522610,3283462,1,'2009-12-03 21:51:12',3310491093,1),(579972135,425381847,14525421,3283462,1,'2009-12-03 21:51:12',3310491093,1),(579972136,425377929,14526603,3283462,1,'2009-12-03 21:51:12',3310491093,1),(579972138,425374611,14526245,3283462,1,'2009-12-03 21:51:13',3310491093,1),(579972142,425364135,14522456,3283462,1,'2009-12-03 21:51:14',3310491092,1),(579972190,424518414,15587553,3283462,1,'2009-12-03 21:51:17',3310491274,1),(579972196,424521224,15584839,3283462,1,'2009-12-03 21:51:17',3310491274,1),(579972201,424523911,15580658,3283462,1,'2009-12-03 21:51:17',3310491274,1),(579972206,424528572,15578930,3283462,1,'2009-12-03 21:51:18',3310491274,1),(579972215,424535005,15571130,3283462,1,'2009-12-03 21:51:18',3310491274,1),(579972234,424539188,15570097,3283462,1,'2009-12-03 21:51:19',3310491274,1),(579972248,424544211,15570583,3283462,1,'2009-12-03 21:51:20',3310491274,1),(579972256,424549926,15574038,3283462,1,'2009-12-03 21:51:20',3310491275,1),(579972263,424556228,15580818,3283462,1,'2009-12-03 21:51:20',3310491275,1),(579972264,424565085,15701828,3283462,1,'2009-12-03 21:51:20',3310491299,1),(579972270,424583055,15601249,3283462,1,'2009-12-03 21:51:21',3310491300,1),(579972277,424585858,15605466,3283462,1,'2009-12-03 21:51:21',3310491300,1),(579972294,424586959,15611746,3283462,1,'2009-12-03 21:51:22',3310491300,1),(579972301,424586855,15616602,3283462,1,'2009-12-03 21:51:22',3310491300,1),(579972312,424581415,15633350,3283462,1,'2009-12-03 21:51:22',3310491300,1),(579972313,424585535,15654198,3283462,1,'2009-12-03 21:51:23',3310491300,1),(579972314,424588124,15659250,3283462,1,'2009-12-03 21:51:23',3310491302,1),(579972316,424589387,15663719,3283462,1,'2009-12-03 21:51:23',3310491302,1),(579972323,424589863,15669833,3283462,1,'2009-12-03 21:51:23',3310491302,1),(579972329,424588776,15674495,3283462,1,'2009-12-03 21:51:23',3310491302,1),(579972335,424584330,15684384,3283462,1,'2009-12-03 21:51:24',3310491302,1),(579972342,424574863,15695975,3283462,1,'2009-12-03 21:51:24',3310491302,1),(579972344,424567322,15699924,3283462,1,'2009-12-03 21:51:24',3310491299,1),(579972345,424558877,15710737,3283462,1,'2009-12-03 21:51:24',3310491305,1),(579972349,424555434,15713525,3283462,1,'2009-12-03 21:51:25',3310491305,1),(579972407,424556556,15824974,3283462,1,'2009-12-03 21:51:27',3310492673,1),(579972412,424560695,15825033,3283462,1,'2009-12-03 21:51:28',3310492673,1),(579972420,424565060,15826203,3283462,1,'2009-12-03 21:51:28',3310492673,1),(579972426,424569772,15829952,3283462,1,'2009-12-03 21:51:28',3310492673,1),(579972437,424573589,15835823,3283462,1,'2009-12-03 21:51:29',3310492676,1),(579972439,424577199,15840100,3283462,1,'2009-12-03 21:51:29',3310492676,1),(579972444,424599242,15853991,3283462,1,'2009-12-03 21:51:29',3310492676,1),(579972446,424604895,15856715,3283462,1,'2009-12-03 21:51:29',3310492677,1),(579972453,424611642,15861342,3283462,1,'2009-12-03 21:51:31',3310492677,1),(579972459,424617443,15867117,3283462,1,'2009-12-03 21:51:31',3310492677,1),(579972466,424626424,15881149,3283462,1,'2009-12-03 21:51:32',3310492679,1),(579972473,424630317,15894080,3283462,1,'2009-12-03 21:51:32',3310492690,1),(579972478,424634267,15903367,3283462,1,'2009-12-03 21:51:32',3310492690,1),(579972488,424647078,15922909,3283462,1,'2009-12-03 21:51:33',3310492690,1),(579972496,424658867,15947727,3283462,1,'2009-12-03 21:51:33',3310492697,1),(579972502,424666286,15960309,3283462,1,'2009-12-03 21:51:33',3310492697,1),(579972508,424673057,15968831,3283462,1,'2009-12-03 21:51:34',3310492697,1),(579972515,424676186,15976114,3283462,1,'2009-12-03 21:51:34',3310492697,1),(579972520,424676456,15987321,3283462,1,'2009-12-03 21:51:34',3310492699,1),(579972522,424669267,16000412,3283462,1,'2009-12-03 21:51:35',3310492699,1),(579972524,424668330,16005815,3283462,1,'2009-12-03 21:51:35',3310492699,1),(579972528,424664488,16014045,3283462,1,'2009-12-03 21:51:35',3310492699,1),(579972529,424661733,16017613,3283462,1,'2009-12-03 21:51:35',3310492699,1),(579972530,424655429,16037821,3283462,1,'2009-12-03 21:51:36',3310492698,1),(579972533,424676976,15983346,3283462,1,'2009-12-03 21:51:36',3310492697,1),(579972540,424651710,16045209,3283462,1,'2009-12-03 21:51:36',3310492720,1),(579972544,424647167,16050711,3283462,1,'2009-12-03 21:51:36',3310492720,1),(579972545,424644813,16055524,3283462,1,'2009-12-03 21:51:37',3310492720,1),(579972546,424645759,16058876,3283462,1,'2009-12-03 21:51:37',3310492720,1),(579972547,424647414,16080399,3283462,1,'2009-12-03 21:51:37',3310492720,1),(579972553,424650408,16093265,3283462,1,'2009-12-03 21:51:37',3310492720,1),(579972562,424652896,16098554,3283462,1,'2009-12-03 21:51:38',3310492722,1),(579972575,424652722,16105108,3283462,1,'2009-12-03 21:51:38',3310492722,1),(579972579,424655243,16125235,3283462,1,'2009-12-03 21:51:39',3310492722,1),(579972589,424655532,16131458,3283462,1,'2009-12-03 21:51:39',3310492723,1),(579972599,424653382,16142365,3283462,1,'2009-12-03 21:51:39',3310492722,1),(579972612,424655015,16150997,3283462,1,'2009-12-03 21:51:39',3310492728,1),(579972640,424650881,16168688,3283462,1,'2009-12-03 21:51:40',3310492728,1),(579972651,424651333,16173099,3283462,1,'2009-12-03 21:51:40',3310492728,1),(579972662,424657535,16188998,3283462,1,'2009-12-03 21:51:41',3310492729,1),(579972678,424656051,16210168,3283462,1,'2009-12-03 21:51:41',3310492731,1),(579972691,424657045,16218997,3283462,1,'2009-12-03 21:51:41',3310492731,1),(579972712,424656776,16225665,3283462,1,'2009-12-03 21:51:42',3310492731,1),(579972748,424655281,16233701,3283462,1,'2009-12-03 21:51:43',3310492730,1),(579972759,424648848,16254749,3283462,1,'2009-12-03 21:51:43',3310492730,1),(579972893,424664226,16328720,3283462,1,'2009-12-03 21:51:48',3310492819,1),(579972911,424670848,16343072,3283462,1,'2009-12-03 21:51:48',3310492819,1),(579972934,424672080,16350459,3283462,1,'2009-12-03 21:51:49',3310492819,1),(579973009,424837366,16619331,3283462,1,'2009-12-03 21:52:03',3310492909,1),(579973010,424841101,16618271,3283462,1,'2009-12-03 21:52:05',3310492909,1),(579973012,424877792,16625989,3283462,1,'2009-12-03 21:52:06',3310492921,1),(579973015,424891140,16623212,3283462,1,'2009-12-03 21:52:06',3310492921,1),(579973018,424901612,16622532,3283462,1,'2009-12-03 21:52:07',3310492921,1),(579973019,424918041,16628134,3283462,1,'2009-12-03 21:52:07',3310492924,1),(579973021,424928851,16623587,3283462,1,'2009-12-03 21:52:07',3310492924,1),(579973023,424931384,16623289,3283462,1,'2009-12-03 21:52:08',3310492925,1),(579973025,424935524,16625543,3283462,1,'2009-12-03 21:52:08',3310492925,1),(579973026,424943920,16633833,3283462,1,'2009-12-03 21:52:09',3310492925,1),(579973027,424958573,16654268,3283462,1,'2009-12-03 21:52:09',3310493098,1),(579973028,424964818,16657896,3283462,1,'2009-12-03 21:52:09',3310493098,1),(579973029,424980656,16658103,3283462,1,'2009-12-03 21:52:10',3310493098,1),(579973030,424984950,16658788,3283462,1,'2009-12-03 21:52:10',3310493098,1),(579973031,424987220,16660539,3283462,1,'2009-12-03 21:52:10',3310493099,1),(579973032,424998156,16677171,3283462,1,'2009-12-03 21:52:11',3310493099,1),(579973033,425027937,16690951,3283462,1,'2009-12-03 21:52:11',3310493102,1),(579973034,425034516,16695213,3283462,1,'2009-12-03 21:52:12',3310493102,1),(579973454,425039210,16699336,3283462,1,'2009-12-03 21:52:39',3310493102,1),(579973464,425041659,16703290,3283462,1,'2009-12-03 21:52:39',3310493445,1),(579973477,425029940,16716895,3283462,1,'2009-12-03 21:52:40',3310493444,1),(579974160,425587107,14261635,3283462,1,'2009-12-03 21:53:19',3310501918,1),(579974175,425567307,14245131,3283462,1,'2009-12-03 21:53:20',3310501918,1),(579974193,425555830,14234576,3283462,1,'2009-12-03 21:53:21',3310501915,1),(579974203,425551879,14231983,3283462,1,'2009-12-03 21:53:23',3310501915,1),(579974208,425536188,14227950,3283462,1,'2009-12-03 21:53:24',3310501915,1),(579974213,425532393,14225976,3283462,1,'2009-12-03 21:53:25',3310501912,1),(579974233,425417944,14351812,3283462,1,'2009-12-03 21:53:29',3310501922,1),(579974236,425427875,14362744,3283462,1,'2009-12-03 21:53:29',3310501923,1),(579974239,425431193,14367728,3283462,1,'2009-12-03 21:53:29',3310501923,1),(579974243,425433419,14373000,3283462,1,'2009-12-03 21:53:30',3310501923,1),(579974248,425436767,14386509,3283462,1,'2009-12-03 21:53:30',3310501923,1),(579974253,425436919,14396504,3283462,1,'2009-12-03 21:53:30',3310501929,1),(579974258,425435984,14406666,3283462,1,'2009-12-03 21:53:31',3310501929,1),(579974267,425432677,14410692,3283462,1,'2009-12-03 21:53:31',3310501929,1),(579974272,425431222,14415703,3283462,1,'2009-12-03 21:53:33',3310501929,1),(579974276,425426153,14437259,3283462,1,'2009-12-03 21:53:34',3310501929,1),(579974280,425412605,14468439,3283462,1,'2009-12-03 21:53:34',3310501930,1),(579974284,425605410,14307507,3283462,1,'2009-12-03 21:53:35',3310501941,1),(579974288,425632716,14376553,3283462,1,'2009-12-03 21:53:35',3310501986,1),(579974296,425632044,14370659,3283462,1,'2009-12-03 21:53:36',3310501986,1),(579974298,425630938,14366683,3283462,1,'2009-12-03 21:53:37',3310501986,1),(579974308,425621200,14348453,3283462,1,'2009-12-03 21:53:39',3310501986,1),(579974311,425651897,14422860,3283462,1,'2009-12-03 21:53:39',3310501993,1),(579974316,425643177,14410913,3283462,1,'2009-12-03 21:53:40',3310501992,1),(579974321,425638715,14400608,3283462,1,'2009-12-03 21:53:40',3310501992,1),(579974336,425666416,14445451,3283462,1,'2009-12-03 21:53:41',3310501993,1),(579974346,425667976,14447024,3283462,1,'2009-12-03 21:53:44',3310501993,1),(579974347,425669266,14448720,3283462,1,'2009-12-03 21:53:44',3310501995,1),(579974361,425391619,14505663,3283462,1,'2009-12-03 21:53:47',3310491093,1),(590463652,425658673,14904344,3373117,1,'2009-12-14 18:44:31',3310502123,1),(590463653,425718009,14841246,3373117,1,'2009-12-14 18:44:31',3310502125,1),(590463654,425718474,14840703,3373117,1,'2009-12-14 18:44:31',3310502125,1),(590463655,425717801,14841978,3373117,1,'2009-12-14 18:44:31',3310502125,1),(590463656,425714552,14858474,3373117,1,'2009-12-14 18:44:31',3310502125,1),(590463659,425739247,14821438,3373535,1,'2009-12-14 19:37:28',3310502130,2),(590463661,425743700,14815300,3373117,1,'2009-12-14 18:44:31',3310502130,1),(590463663,425773866,14786909,3373181,1,'2009-12-14 18:51:21',3310502131,2),(590463666,425732300,14838800,3373117,1,'2009-12-14 18:44:32',3310502136,1),(590463669,425738700,14836200,3373117,1,'2009-12-14 18:44:32',3310502136,1),(590538923,425632000,14897400,3373535,1,'2009-12-14 19:37:28',3310502122,1),(590538926,425741061,14830593,3373535,1,'2009-12-14 19:37:28',3310502130,1),(593870539,425733500,14706500,3388565,1,'2009-12-16 20:20:10',3310502106,1),(593870540,425724333,14716333,3388565,1,'2009-12-16 20:20:10',3310502095,1),(593870541,425729167,14713333,3388565,1,'2009-12-16 20:20:10',3310502106,1),(593870542,425728333,14708667,3388565,1,'2009-12-16 20:20:10',3310502106,1),(593870543,425729333,14708667,3388565,1,'2009-12-16 20:20:10',3310502106,1),(593870544,425732333,14708500,3388565,1,'2009-12-16 20:20:10',3310502106,1),(593870545,425730167,14713167,5833623,1,'2010-09-21 01:50:00',3310502106,2),(593870546,425718500,14840667,3388565,1,'2009-12-16 20:20:10',3310502125,1),(593870547,425697000,14875167,3388565,1,'2009-12-16 20:20:10',3310502124,1),(593870548,425698000,14875833,3388565,1,'2009-12-16 20:20:10',3310502124,1),(593870549,425695833,14878833,3388565,1,'2009-12-16 20:20:10',3310502124,1),(593870550,425695167,14878000,3388565,1,'2009-12-16 20:20:11',3310502124,1),(593870551,425700500,14874333,3388565,1,'2009-12-16 20:20:11',3310502125,1),(593870552,425733667,14733500,3388565,1,'2009-12-16 20:20:11',3310502128,1),(593870553,425734333,14831000,3388565,1,'2009-12-16 20:20:11',3310502130,1),(593870554,425721167,14837000,3388565,1,'2009-12-16 20:20:11',3310502125,1),(593870555,425721260,14836976,3388565,1,'2009-12-16 20:20:11',3310502125,1),(593870556,425726333,14840167,3388565,1,'2009-12-16 20:20:11',3310502125,1),(593870557,425725000,14839167,3388565,1,'2009-12-16 20:20:11',3310502125,1),(593870558,425724667,14840333,3388565,1,'2009-12-16 20:20:11',3310502125,1),(593870559,425733000,14837000,3388565,1,'2009-12-16 20:20:11',3310502136,1),(593870560,425731833,14833167,3388565,1,'2009-12-16 20:20:11',3310502136,1),(613344821,426309927,14833164,4092807,1,'2010-03-10 21:54:57',3310503081,2),(613344822,426179767,14856325,4092807,1,'2010-03-10 21:54:57',3310502392,2),(613344823,426312102,15001087,4161868,1,'2010-03-18 16:48:01',3310503427,3),(613344824,426181795,14866330,4161868,1,'2010-03-18 16:48:00',3310502392,3),(613344825,426276943,14980822,4092743,1,'2010-03-10 21:47:17',3310503424,3),(613344826,426256129,14978080,4161868,1,'2010-03-18 16:48:01',3310502741,2),(613344827,426200273,15021743,4083024,1,'2010-03-09 20:10:05',3310502739,2),(613345211,426202280,14887525,4161868,1,'2010-03-18 16:48:01',3310502395,2),(620937034,425490567,16475639,3724172,1,'2010-01-27 00:45:27',3310504079,1),(620937036,425489241,16467444,3724172,1,'2010-01-27 00:45:27',3310504079,1),(620937038,425465456,16579773,3724172,1,'2010-01-27 00:45:27',3310504102,1),(620937040,425546441,16537133,4108069,1,'2010-03-12 19:04:14',3310504115,2),(620937041,425535870,16624044,3724172,1,'2010-01-27 00:45:27',3310504121,1),(620937043,425532949,16628782,3724172,1,'2010-01-27 00:45:27',3310504120,1),(620937044,425588381,16552939,3724172,1,'2010-01-27 00:45:27',3310504118,1),(620937046,425664340,16419677,4106774,1,'2010-03-12 16:31:14',3310504137,2),(620937047,425669951,16422624,4107810,1,'2010-03-12 18:34:26',3310504137,2),(620937049,425658012,16601209,4107810,1,'2010-03-12 18:34:27',3310504169,2),(620937051,425656322,16601255,4107810,1,'2010-03-12 18:34:27',3310504169,2),(620937056,425644357,16605225,4107810,1,'2010-03-12 18:34:27',3310504169,2),(620937058,425626968,16656863,4107810,1,'2010-03-12 18:34:27',3310504170,2),(620937059,425637171,16601673,4107810,1,'2010-03-12 18:34:27',3310504168,2),(620937061,425626667,16675380,4107810,1,'2010-03-12 18:34:27',3310504170,2),(620937063,425618908,16690082,4107810,1,'2010-03-12 18:34:27',3310504170,2),(620937064,425613037,16698459,3724172,1,'2010-01-27 00:45:28',3310504127,1),(620937066,425628345,16661317,3724172,1,'2010-01-27 00:45:28',3310504170,1),(620937068,425626900,16662228,3724172,1,'2010-01-27 00:45:28',3310504170,1),(620937069,425621939,16664281,3724172,1,'2010-01-27 00:45:28',3310504170,1),(620937071,425616804,16666130,3724172,1,'2010-01-27 00:45:28',3310504127,1),(620937072,425641383,16647821,4106774,1,'2010-03-12 16:31:14',3310504170,2),(620937074,425641393,16652161,4133447,1,'2010-03-15 12:47:11',3310504170,2),(620937076,425639172,16647747,3724172,1,'2010-01-27 00:45:28',3310504170,1),(620937078,425638330,16650764,3724172,1,'2010-01-27 00:45:28',3310504170,1),(620937079,425639147,16656290,3724172,1,'2010-01-27 00:45:28',3310504170,1),(620937081,425640717,16658180,3724172,1,'2010-01-27 00:45:28',3310504170,1),(620937082,425642679,16657855,3724172,1,'2010-01-27 00:45:28',3310504170,1),(620937084,425644124,16656297,3724172,1,'2010-01-27 00:45:28',3310504170,1),(620937086,425645964,16652749,3724172,1,'2010-01-27 00:45:28',3310504171,1),(620937087,425648408,16650717,3724172,1,'2010-01-27 00:45:28',3310504171,1),(620937089,425645861,16664845,3724172,1,'2010-01-27 00:45:28',3310504171,1),(620937091,425648590,16665776,3724172,1,'2010-01-27 00:45:28',3310504171,1),(620937092,425660814,16649774,4106774,1,'2010-03-12 16:31:14',3310504171,2),(620937094,425655149,16663372,3724172,1,'2010-01-27 00:45:29',3310504171,1),(620937095,425662866,16666177,3724172,1,'2010-01-27 00:45:29',3310504171,1),(620937097,425675985,16655921,4106774,1,'2010-03-12 16:31:14',3310504174,2),(620937099,425683808,16657821,4106774,1,'2010-03-12 16:31:14',3310504174,2),(620937100,425692283,16661768,3724172,1,'2010-01-27 00:45:29',3310504174,1),(620937102,425664661,16673264,4106774,1,'2010-03-12 16:31:14',3310504171,2),(620937108,425671549,16682837,4106774,1,'2010-03-12 16:31:14',3310504171,2),(620937109,425675549,16683514,4106774,1,'2010-03-12 16:31:14',3310504174,2),(620937111,425680348,16681251,4106774,1,'2010-03-12 16:31:14',3310504174,2),(620937113,425690353,16674144,3724172,1,'2010-01-27 00:45:29',3310504174,1),(620937114,425691073,16693343,3724172,1,'2010-01-27 00:45:29',3310504174,1),(620937116,425698347,16665259,3724172,1,'2010-01-27 00:45:29',3310504174,1),(620937117,425705841,16665947,3724172,1,'2010-01-27 00:45:29',3310504175,1),(620937119,425715975,16667087,3724172,1,'2010-01-27 00:45:29',3310504175,1),(620937120,425718088,16653948,3724172,1,'2010-01-27 00:45:29',3310504175,1),(620937122,425701874,16683549,3724172,1,'2010-01-27 00:45:30',3310504175,1),(620937124,425711234,16672145,3724172,1,'2010-01-27 00:45:30',3310504175,1),(620937125,425719928,16639866,4106774,1,'2010-03-12 16:31:14',3310504173,2),(620937127,425722206,16629650,4106774,1,'2010-03-12 16:31:14',3310504173,2),(620937130,425725257,16630082,3731851,1,'2010-01-27 23:40:26',3310504173,2),(620937132,425726892,16634407,3724172,1,'2010-01-27 00:45:30',3310504184,1),(620937133,425723028,16626720,3724172,1,'2010-01-27 00:45:30',3310504173,1),(620937135,425732707,16670972,3724172,1,'2010-01-27 00:45:30',3310504186,1),(620937136,425732954,16655552,3724172,1,'2010-01-27 00:45:30',3310504186,1),(620937138,425734579,16665703,3724172,1,'2010-01-27 00:45:30',3310504186,1),(620937139,425746376,16681917,4106774,1,'2010-03-12 16:31:14',3310504186,2),(620937141,425744698,16674841,4106774,1,'2010-03-12 16:31:14',3310504186,2),(620937143,425741387,16697542,3724172,1,'2010-01-27 00:45:30',3310504186,1),(620937144,425745998,16691332,3724172,1,'2010-01-27 00:45:30',3310504186,1),(620937146,425748221,16685068,3724172,1,'2010-01-27 00:45:30',3310504186,1),(620937149,425748094,16687394,3724172,1,'2010-01-27 00:45:30',3310504186,1),(620937151,425606217,16705774,3724172,1,'2010-01-27 00:45:30',3310504469,1),(620937156,425600950,16710488,4107810,1,'2010-03-12 18:34:27',3310504469,2),(620937181,425607973,16737162,4108069,1,'2010-03-12 19:04:16',3310504469,2),(620937182,425617028,16732911,4107810,1,'2010-03-12 18:34:28',3310504512,2),(620937183,425625345,16730122,4107810,1,'2010-03-12 18:34:28',3310504512,2),(620937185,425634023,16725309,4107810,1,'2010-03-12 18:34:27',3310504512,2),(620937186,425644827,16714808,4107810,1,'2010-03-12 18:34:28',3310504513,2),(620937187,425601415,16712286,4107810,1,'2010-03-12 18:34:27',3310504469,2),(620937188,425656438,16703559,4107810,1,'2010-03-12 18:34:28',3310504513,2),(620937189,425663730,16724364,3724172,1,'2010-01-27 00:45:31',3310504513,1),(620937190,425661805,16727410,3724172,1,'2010-01-27 00:45:31',3310504513,1),(620937191,425660918,16729816,3724172,1,'2010-01-27 00:45:32',3310504513,1),(620937192,425661730,16732186,3724172,1,'2010-01-27 00:45:32',3310504513,1),(620937193,425664164,16733548,3724172,1,'2010-01-27 00:45:32',3310504513,1),(620937195,425671545,16704229,3724172,1,'2010-01-27 00:45:32',3310504513,1),(620937196,425675346,16703808,3724172,1,'2010-01-27 00:45:32',3310504516,1),(620937198,425683492,16699503,3724172,1,'2010-01-27 00:45:32',3310504516,1),(620937199,425666857,16711878,4107810,1,'2010-03-12 18:34:28',3310504513,2),(620937201,425667094,16715893,3724172,1,'2010-01-27 00:45:32',3310504513,1),(620937203,425666284,16719270,3724172,1,'2010-01-27 00:45:32',3310504513,1),(620937204,425668294,16734698,3724172,1,'2010-01-27 00:45:32',3310504513,1),(620937206,425678853,16732350,3724172,1,'2010-01-27 00:45:32',3310504516,1),(620937211,425702431,16725746,3724172,1,'2010-01-27 00:45:32',3310504517,1),(620937212,425713582,16718170,3724172,1,'2010-01-27 00:45:32',3310504517,1),(620937214,425723168,16710892,3724172,1,'2010-01-27 00:45:32',3310504517,1),(620937216,425733378,16706606,3724172,1,'2010-01-27 00:45:32',3310504528,1),(621164963,425275938,16871896,3727238,1,'2010-01-27 14:00:39',3310493519,1),(621164964,425270952,16876198,3727238,1,'2010-01-27 14:00:39',3310493519,1),(621164965,425267931,16877381,3727238,1,'2010-01-27 14:00:39',3310493519,1),(621164966,425265183,16878372,3727238,1,'2010-01-27 14:00:39',3310493519,1),(621164967,425262997,16880190,3727238,1,'2010-01-27 14:00:39',3310493519,1),(621164968,425261314,16883769,3727238,1,'2010-01-27 14:00:39',3310493519,1),(621164969,425261766,16887116,3727238,1,'2010-01-27 14:00:40',3310493519,1),(621164970,425264775,16890783,3727238,1,'2010-01-27 14:00:40',3310493519,1),(621164971,425270036,16892444,3727238,1,'2010-01-27 14:00:40',3310493519,1),(621164972,425278351,16895719,3727238,1,'2010-01-27 14:00:40',3310493519,1),(621164973,425380680,16757245,3727238,1,'2010-01-27 14:00:40',3310493527,1),(621164974,425388676,16702138,3727238,1,'2010-01-27 14:00:40',3310493525,1),(621164975,425386304,16706845,3727238,1,'2010-01-27 14:00:40',3310493525,1),(621164976,425381464,16712023,3727238,1,'2010-01-27 14:00:40',3310493525,1),(621164977,425379250,16715234,3727238,1,'2010-01-27 14:00:40',3310493525,1),(621164978,425378065,16723378,3727238,1,'2010-01-27 14:00:40',3310493525,1),(621164979,425376703,16735286,3727238,1,'2010-01-27 14:00:40',3310493525,1),(621164980,425377909,16744035,3727238,1,'2010-01-27 14:00:40',3310493525,1),(621164981,425379705,16750384,3727238,1,'2010-01-27 14:00:40',3310493525,1),(621164982,425381749,16755295,3727238,1,'2010-01-27 14:00:40',3310493527,1),(621164983,425303940,16847896,3727238,1,'2010-01-27 14:00:40',3310493528,1),(621164984,425300542,16852258,3727238,1,'2010-01-27 14:00:40',3310493528,1),(621164985,425298210,16853427,3727238,1,'2010-01-27 14:00:40',3310493528,1),(621164986,425295254,16854235,3727238,1,'2010-01-27 14:00:40',3310493528,1),(621164987,425293065,16855867,3727238,1,'2010-01-27 14:00:41',3310493528,1),(621164988,425292283,16859800,3727238,1,'2010-01-27 14:00:41',3310493528,1),(621164989,425290860,16861975,3727238,1,'2010-01-27 14:00:41',3310493528,1),(621164990,425289155,16863690,3727238,1,'2010-01-27 14:00:41',3310493528,1),(621164991,425334273,16834477,3727238,1,'2010-01-27 14:00:41',3310493529,1),(621164992,425330908,16835761,3727238,1,'2010-01-27 14:00:41',3310493529,1),(621164993,425327056,16836682,3727238,1,'2010-01-27 14:00:41',3310493529,1),(621164994,425321663,16835583,3727238,1,'2010-01-27 14:00:41',3310493529,1),(621164995,425317374,16834555,3727238,1,'2010-01-27 14:00:41',3310493529,1),(621164996,425313734,16835938,3727238,1,'2010-01-27 14:00:41',3310493528,1),(621164997,425309367,16840041,3727238,1,'2010-01-27 14:00:41',3310493528,1),(621164998,425282999,16868203,3727238,1,'2010-01-27 14:00:41',3310493519,1),(621164999,425291044,16901793,3727238,1,'2010-01-27 14:00:41',3310493530,1),(621165000,425310057,16913924,3727238,1,'2010-01-27 14:00:41',3310493530,1),(621165001,425343219,16824545,3727238,1,'2010-01-27 14:00:41',3310493532,1),(621165002,425350167,16833309,3727238,1,'2010-01-27 14:00:41',3310493532,1),(621165003,425352057,16832040,3727238,1,'2010-01-27 14:00:41',3310493532,1),(621165004,425357743,16831687,3727238,1,'2010-01-27 14:00:41',3310493532,1),(621165005,425375270,16841225,3727238,1,'2010-01-27 14:00:41',3310493533,1),(621165006,425389706,16844417,3727238,1,'2010-01-27 14:00:42',3310493533,1),(621165007,425343559,16826352,3727238,1,'2010-01-27 14:00:42',3310493532,1),(621165008,425339401,16830638,3727238,1,'2010-01-27 14:00:42',3310493529,1),(621165009,425337704,16833005,3727238,1,'2010-01-27 14:00:42',3310493529,1),(621165010,425261162,17127004,3727238,1,'2010-01-27 14:00:42',3310493551,1),(621165011,425266114,17125722,3727238,1,'2010-01-27 14:00:42',3310493551,1),(621165012,425266615,17112890,3727238,1,'2010-01-27 14:00:42',3310493551,1),(621165013,425267688,17093488,3727238,1,'2010-01-27 14:00:42',3310493551,1),(621165014,425269366,17079902,3727238,1,'2010-01-27 14:00:42',3310493549,1),(621165015,425273553,17069032,3727238,1,'2010-01-27 14:00:42',3310493549,1),(621165016,425265355,17130201,3727238,1,'2010-01-27 14:00:42',3310493551,1),(621165017,425280553,17125423,3727238,1,'2010-01-27 14:00:42',3310493551,1),(621165018,425303834,16969205,3727238,1,'2010-01-27 14:00:42',3310493552,1),(621165019,425298384,16973046,3727238,1,'2010-01-27 14:00:43',3310493552,1),(621165020,425307734,16970568,3727238,1,'2010-01-27 14:00:43',3310493552,1),(621165021,425300727,16968147,3727238,1,'2010-01-27 14:00:43',3310493552,1),(621165022,425308069,16941180,3727238,1,'2010-01-27 14:00:43',3310493552,1),(621165023,425295322,17012187,3727238,1,'2010-01-27 14:00:43',3310493554,1),(621165024,425302720,16971231,3727238,1,'2010-01-27 14:00:43',3310493552,1),(621165025,425321936,17002159,3727238,1,'2010-01-27 14:00:43',3310493555,1),(621165026,425286608,17032478,3727238,1,'2010-01-27 14:00:43',3310493549,1),(621165027,425283749,17122151,3727238,1,'2010-01-27 14:00:43',3310493551,1),(621165028,425300993,17093670,3727238,1,'2010-01-27 14:00:43',3310493562,1),(621165029,425304985,17084553,3727238,1,'2010-01-27 14:00:43',3310493562,1),(621165030,425255893,17234825,3727238,1,'2010-01-27 14:00:43',3310493638,1),(621165031,425254981,17237419,3727238,1,'2010-01-27 14:00:43',3310493638,1),(621165032,425259184,17237478,3727238,1,'2010-01-27 14:00:43',3310493638,1),(621165033,425262694,17233326,3727238,1,'2010-01-27 14:00:43',3310493639,1),(621165034,425266612,17217509,3727238,1,'2010-01-27 14:00:43',3310493639,1),(621165035,425268466,17200277,3727238,1,'2010-01-27 14:00:43',3310493639,1),(621165036,425268719,17184535,3727238,1,'2010-01-27 14:00:43',3310493637,1),(621165037,425265876,17171334,3727238,1,'2010-01-27 14:00:43',3310493637,1),(621165038,425263770,17156661,3727238,1,'2010-01-27 14:00:43',3310493637,1),(621165039,425263487,17141222,3727238,1,'2010-01-27 14:00:44',3310493637,1),(621165040,425412704,16609272,3727238,1,'2010-01-27 14:00:44',3310504104,1),(621165041,425411079,16609964,3727238,1,'2010-01-27 14:00:44',3310504104,1),(621165042,425409941,16610824,3727238,1,'2010-01-27 14:00:44',3310504104,1),(621165043,425410187,16612908,3727238,1,'2010-01-27 14:00:44',3310504104,1),(621165044,425410620,16615944,3727238,1,'2010-01-27 14:00:44',3310504104,1),(621165045,425410248,16621862,3727238,1,'2010-01-27 14:00:44',3310504104,1),(621165046,425409565,16631308,3727238,1,'2010-01-27 14:00:44',3310504104,1),(621165047,425409269,16636210,3727238,1,'2010-01-27 14:00:44',3310504104,1),(621165048,425409622,16643724,3727238,1,'2010-01-27 14:00:44',3310504104,1),(621165049,425432353,16616643,4133447,1,'2010-03-15 12:47:11',3310504105,2),(621165050,425429517,16612432,3727238,1,'2010-01-27 14:00:44',3310504105,1),(621165051,425426839,16609982,3727238,1,'2010-01-27 14:00:44',3310504105,1),(621165052,425419729,16609718,3727238,1,'2010-01-27 14:00:44',3310504104,1),(621165053,425408453,16653181,3727238,1,'2010-01-27 14:00:44',3310504106,1),(621165054,425406765,16659784,3727238,1,'2010-01-27 14:00:44',3310504106,1),(621165055,425401526,16672314,3727238,1,'2010-01-27 14:00:44',3310504106,1),(621165056,425395952,16682581,3727238,1,'2010-01-27 14:00:44',3310493183,1),(621165057,425391611,16692584,3727238,1,'2010-01-27 14:00:45',3310493183,1),(621165058,425465936,16596928,3727238,1,'2010-01-27 14:00:45',3310504108,1),(621165059,425634815,16602674,3727238,1,'2010-01-27 14:00:45',3310504168,1),(621165060,425623054,16623590,3727238,1,'2010-01-27 14:00:45',3310504168,1),(621165061,425405409,16845367,3727238,1,'2010-01-27 14:00:45',3310504456,1),(621165062,425423905,16841711,3727238,1,'2010-01-27 14:00:45',3310504456,1),(621165063,425446257,16836107,3727238,1,'2010-01-27 14:00:45',3310504457,1),(621165064,425461664,16833798,3727238,1,'2010-01-27 14:00:45',3310504460,1),(621165065,425465603,16831499,3727238,1,'2010-01-27 14:00:45',3310504460,1),(621165066,425488730,16810835,3727238,1,'2010-01-27 14:00:45',3310504461,1),(621165067,425536144,16804984,3727238,1,'2010-01-27 14:00:45',3310504467,1),(621165068,425522020,16807751,3727238,1,'2010-01-27 14:00:45',3310504466,1),(621165069,425502753,16800742,3727238,1,'2010-01-27 14:00:45',3310504455,1),(621165070,425511162,16797298,3727238,1,'2010-01-27 14:00:45',3310504466,1),(621165071,425523512,16796000,4106774,1,'2010-03-12 16:31:16',3310504466,3),(621166567,425715889,16663052,4106774,1,'2010-03-12 16:31:14',3310504175,2),(621413194,425489497,16469665,3730430,1,'2010-01-27 20:41:49',3310504079,1),(621413197,425492510,16468459,3731851,1,'2010-01-27 23:40:26',3310504079,2),(621413198,425500827,16460707,4108069,1,'2010-03-12 19:04:13',3310504079,2),(621413199,425510608,16447225,4108069,1,'2010-03-12 19:04:13',3310504090,2),(621413200,425517548,16440728,4106774,1,'2010-03-12 16:31:12',3310504090,2),(621413201,425526512,16430061,4106774,1,'2010-03-12 16:31:12',3310504090,2),(621413202,425531148,16424216,4108069,1,'2010-03-12 19:04:13',3310504088,3),(621413203,425542596,16399267,4106774,1,'2010-03-12 16:31:12',3310504089,2),(621413204,425545970,16393722,4106774,1,'2010-03-12 16:31:12',3310504089,2),(621413205,425568794,16476915,4106774,1,'2010-03-12 16:31:12',3310504094,2),(621413206,425573601,16470175,4106774,1,'2010-03-12 16:31:12',3310504094,2),(621413207,425578005,16464073,4106774,1,'2010-03-12 16:31:12',3310504094,2),(621413208,425584278,16455120,4106774,1,'2010-03-12 16:31:12',3310504094,2),(621413209,425588855,16452784,3730430,1,'2010-01-27 20:41:50',3310504094,1),(621413210,425610080,16432039,4106774,1,'2010-03-12 16:31:12',3310504095,3),(621413211,425552740,16395741,4106774,1,'2010-03-12 16:31:12',3310504089,2),(621413212,425559431,16397920,4106774,1,'2010-03-12 16:31:12',3310504089,2),(621413213,425578933,16407456,4106774,1,'2010-03-12 16:31:12',3310504092,3),(621413214,425490676,16470736,4106774,1,'2010-03-12 16:31:12',3310504079,2),(621413215,425494965,16468789,4106774,1,'2010-03-12 16:31:12',3310504079,2),(621413216,425496506,16468710,4106774,1,'2010-03-12 16:31:12',3310504079,2),(621413217,425497652,16469693,4106774,1,'2010-03-12 16:31:12',3310504079,2),(621413218,425498027,16471905,4106774,1,'2010-03-12 16:31:12',3310504079,2),(621413219,425499336,16476335,4106774,1,'2010-03-12 16:31:12',3310504079,2),(621413220,425540221,16494813,4106774,1,'2010-03-12 16:31:13',3310504113,2),(621413221,425549802,16497603,4106774,1,'2010-03-12 16:31:13',3310504113,2),(621413222,425561768,16487189,4106774,1,'2010-03-12 16:31:13',3310504113,2),(621413223,425672030,16419152,4106774,1,'2010-03-12 16:31:14',3310504140,3),(621453850,425542422,16531705,4108069,1,'2010-03-12 19:04:14',3310504113,4),(621467407,425491135,16472287,3731738,1,'2010-01-27 23:25:10',3310504079,1),(621467409,425494164,16483446,3731738,1,'2010-01-27 23:25:10',3310504101,1),(621467411,425464871,16581415,4106774,1,'2010-03-12 16:31:12',3310504102,2),(621467412,425465635,16588900,3731738,1,'2010-01-27 23:25:10',3310504102,1),(621467413,425432561,16609799,3731738,1,'2010-01-27 23:25:10',3310504105,1),(621467414,425436413,16608895,3731738,1,'2010-01-27 23:25:11',3310504105,1),(621467415,425445499,16602580,3731738,1,'2010-01-27 23:25:11',3310504105,1),(621467416,425442824,16645884,4106774,1,'2010-03-12 16:31:12',3310504107,2),(621467417,425444104,16679903,3731738,1,'2010-01-27 23:25:11',3310504107,1),(621467419,425437548,16657539,3731738,1,'2010-01-27 23:25:11',3310504107,1),(621467420,425436370,16670480,4106774,1,'2010-03-12 16:31:12',3310504107,2),(621467421,425435228,16687672,3731738,1,'2010-01-27 23:25:11',3310504107,1),(621467422,425465150,16593466,3731738,1,'2010-01-27 23:25:11',3310504108,1),(621467423,425462386,16598991,3731738,1,'2010-01-27 23:25:11',3310504108,1),(621467424,425447470,16613879,4106774,1,'2010-03-12 16:31:12',3310504105,2),(621467425,425446444,16603156,3731738,1,'2010-01-27 23:25:11',3310504105,1),(621467426,425447309,16606346,3731738,1,'2010-01-27 23:25:11',3310504105,1),(621467427,425451135,16623291,4106774,1,'2010-03-12 16:31:13',3310504105,2),(621467428,425455796,16630668,4106774,1,'2010-03-12 16:31:12',3310504108,2),(621467429,425457916,16635510,4106774,1,'2010-03-12 16:31:12',3310504108,2),(621467430,425446869,16625583,4106774,1,'2010-03-12 16:31:13',3310504105,2),(621467431,425467717,16596319,3731738,1,'2010-01-27 23:25:11',3310504108,1),(621467432,425468101,16599576,3731738,1,'2010-01-27 23:25:12',3310504108,1),(621467433,425468804,16600727,3731738,1,'2010-01-27 23:25:12',3310504108,1),(621467434,425483674,16596791,3731738,1,'2010-01-27 23:25:12',3310504109,1),(621467435,425501195,16583419,4106774,1,'2010-03-12 16:31:13',3310504103,2),(621467436,425459871,16644945,4106774,1,'2010-03-12 16:31:13',3310504110,2),(621467437,425461804,16650673,4106774,1,'2010-03-12 16:31:13',3310504110,2),(621467438,425462370,16653913,4106774,1,'2010-03-12 16:31:13',3310504110,2),(621467439,425461444,16658654,3731738,1,'2010-01-27 23:25:12',3310504110,1),(621467441,425461919,16661480,3731738,1,'2010-01-27 23:25:12',3310504110,1),(621467442,425463094,16672194,4106774,1,'2010-03-12 16:31:13',3310504110,2),(621467443,425464335,16679338,3731738,1,'2010-01-27 23:25:12',3310504110,1),(621467444,425465336,16684690,3731738,1,'2010-01-27 23:25:12',3310504110,1),(621467445,425465044,16692682,3731738,1,'2010-01-27 23:25:12',3310504110,1),(621467446,425464656,16697317,3731738,1,'2010-01-27 23:25:12',3310504110,1),(621467447,425510360,16511992,3731738,1,'2010-01-27 23:25:12',3310504112,1),(621467448,425517010,16519535,4108069,1,'2010-03-12 19:04:14',3310504112,2),(621467449,425537728,16532075,4108069,1,'2010-03-12 19:04:14',3310504113,2),(621467450,425506940,16582753,4106774,1,'2010-03-12 16:31:13',3310504103,2),(621467451,425511408,16584493,4106774,1,'2010-03-12 16:31:13',3310504114,2),(621467452,425543051,16537807,3731738,1,'2010-01-27 23:25:12',3310504115,1),(621467453,425546413,16562239,3731738,1,'2010-01-27 23:25:12',3310504115,1),(621467454,425546131,16565303,3731738,1,'2010-01-27 23:25:12',3310504115,1),(621467455,425544881,16579039,3731738,1,'2010-01-27 23:25:12',3310504115,1),(621467456,425543723,16588618,3731738,1,'2010-01-27 23:25:13',3310504115,1),(621467457,425549453,16534178,4108069,1,'2010-03-12 19:04:14',3310504113,3),(621467461,425568399,16552171,4106774,1,'2010-03-12 16:31:13',3310504118,2),(621467462,425570493,16563235,4106774,1,'2010-03-12 16:31:14',3310504118,2),(621467463,425571988,16578700,4106774,1,'2010-03-12 16:31:14',3310504118,2),(621467464,425568238,16581408,4106774,1,'2010-03-12 16:31:14',3310504118,2),(621467468,425587581,16555073,3731738,1,'2010-01-27 23:25:13',3310504118,1),(621467469,425590590,16558740,3731738,1,'2010-01-27 23:25:13',3310504119,1),(621467470,425592307,16558050,3731738,1,'2010-01-27 23:25:13',3310504119,1),(621467471,425603076,16553866,4108069,1,'2010-03-12 19:04:14',3310504119,2),(621467472,425605648,16553469,4108069,1,'2010-03-12 19:04:14',3310504119,2),(621467473,425607964,16554539,4108069,1,'2010-03-12 19:04:14',3310504119,2),(621467474,425516709,16590355,4106774,1,'2010-03-12 16:31:14',3310504120,2),(621467475,425523972,16599537,3731738,1,'2010-01-27 23:25:13',3310504120,1),(621467476,425527826,16604701,3731738,1,'2010-01-27 23:25:13',3310504120,1),(621467477,425542296,16593425,3731738,1,'2010-01-27 23:25:13',3310504121,1),(621467478,425538327,16601249,3731738,1,'2010-01-27 23:25:13',3310504121,1),(621467479,425534045,16612519,3731738,1,'2010-01-27 23:25:13',3310504120,1),(621467480,425533728,16615583,3731738,1,'2010-01-27 23:25:14',3310504120,1),(621467481,425539161,16624718,4106774,1,'2010-03-12 16:31:14',3310504121,2),(621467482,425555368,16595517,4106774,1,'2010-03-12 16:31:14',3310504121,2),(621467483,425552905,16607028,4106774,1,'2010-03-12 16:31:14',3310504121,2),(621467484,425548359,16612251,4106774,1,'2010-03-12 16:31:14',3310504121,2),(621467485,425541749,16619626,4106774,1,'2010-03-12 16:31:14',3310504121,2),(621467486,425541114,16629478,3731738,1,'2010-01-27 23:25:14',3310504121,1),(621467487,425544780,16633248,3731738,1,'2010-01-27 23:25:14',3310504121,1),(621467488,425550120,16640130,3731738,1,'2010-01-27 23:25:14',3310504121,1),(621467489,425530872,16614432,3731738,1,'2010-01-27 23:25:14',3310504120,1),(621467490,425533794,16622151,3731738,1,'2010-01-27 23:25:14',3310504120,1),(621467491,425578195,16597897,4107810,1,'2010-03-12 18:34:26',3310504124,2),(621467492,425558497,16588757,4106774,1,'2010-03-12 16:31:13',3310504115,2),(621467493,425582675,16606305,4107810,1,'2010-03-12 18:34:26',3310504124,2),(621467494,425588246,16617789,3731738,1,'2010-01-27 23:25:14',3310504124,1),(621467495,425590672,16625915,4107810,1,'2010-03-12 18:34:26',3310504125,2),(621467496,425593023,16632114,4107810,1,'2010-03-12 18:34:26',3310504125,2),(621467497,425597605,16644100,3731738,1,'2010-01-27 23:25:14',3310504125,1),(621467499,425606739,16641544,4107810,1,'2010-03-12 18:34:26',3310504125,2),(621467501,425610074,16638433,3731738,1,'2010-01-27 23:25:15',3310504125,1),(621467502,425557793,16647429,3731738,1,'2010-01-27 23:25:15',3310504123,1),(621467503,425561131,16652605,3731738,1,'2010-01-27 23:25:15',3310504123,1),(621467504,425563271,16658624,3731738,1,'2010-01-27 23:25:15',3310504126,1),(621467505,425566085,16670692,3731738,1,'2010-01-27 23:25:15',3310504126,1),(621467506,425574167,16690812,3731738,1,'2010-01-27 23:25:15',3310504126,1),(621467507,425578982,16697006,3731738,1,'2010-01-27 23:25:15',3310504126,1),(621467508,425599525,16647952,4107810,1,'2010-03-12 18:34:26',3310504127,2),(621467509,425601502,16648572,4107810,1,'2010-03-12 18:34:26',3310504127,2),(621467510,425604327,16647217,4107810,1,'2010-03-12 18:34:26',3310504127,2),(621467513,425683956,16474947,3731738,1,'2010-01-27 23:25:15',3310504142,1),(621467519,425611341,16557731,3731738,1,'2010-01-27 23:25:16',3310504119,1),(621467520,425615039,16561384,3731738,1,'2010-01-27 23:25:16',3310504119,1),(621467521,425617386,16561519,3731738,1,'2010-01-27 23:25:16',3310504162,1),(621467522,425620963,16566481,3731738,1,'2010-01-27 23:25:16',3310504162,1),(621467523,425623731,16573046,3731738,1,'2010-01-27 23:25:16',3310504162,1),(621467524,425625427,16576555,3731738,1,'2010-01-27 23:25:16',3310504162,1),(621467526,425628904,16578906,3731738,1,'2010-01-27 23:25:16',3310504162,1),(621467527,425634066,16577954,3731738,1,'2010-01-27 23:25:16',3310504162,1),(621467529,425638775,16579532,3731738,1,'2010-01-27 23:25:16',3310504162,1),(621467530,425642480,16583651,3731738,1,'2010-01-27 23:25:16',3310504162,1),(621467531,425644265,16588838,3731738,1,'2010-01-27 23:25:16',3310504162,1),(621467540,425685862,16481311,4107810,1,'2010-03-12 18:34:26',3310504164,2),(621467541,425688748,16502190,4107810,1,'2010-03-12 18:34:26',3310504164,2),(621467543,425690496,16510134,4107810,1,'2010-03-12 18:34:26',3310504164,2),(621467544,425690288,16514360,4107810,1,'2010-03-12 18:34:26',3310504164,2),(621467545,425688700,16518425,4107810,1,'2010-03-12 18:34:26',3310504164,2),(621467546,425686151,16523728,4107810,1,'2010-03-12 18:34:26',3310504164,2),(621467547,425684272,16526723,4107810,1,'2010-03-12 18:34:26',3310504164,2),(621467549,425684872,16530335,3731738,1,'2010-01-27 23:25:17',3310504164,1),(621467550,425686118,16533574,3731738,1,'2010-01-27 23:25:17',3310504164,1),(621467552,425690084,16540837,3731738,1,'2010-01-27 23:25:17',3310504166,1),(621467554,425694190,16545414,3731738,1,'2010-01-27 23:25:17',3310504166,1),(621467555,425696150,16550737,3731738,1,'2010-01-27 23:25:17',3310504166,1),(621467557,425698067,16559678,3731738,1,'2010-01-27 23:25:17',3310504166,1),(621467558,425699463,16568396,3731738,1,'2010-01-27 23:25:17',3310504167,1),(621467559,425700357,16578409,3731738,1,'2010-01-27 23:25:17',3310504167,1),(621467560,425700105,16586230,3731738,1,'2010-01-27 23:25:17',3310504167,1),(621467561,425622584,16624654,3731738,1,'2010-01-27 23:25:17',3310504168,1),(621467562,425623073,16628644,3731738,1,'2010-01-27 23:25:17',3310504168,1),(621467563,425617517,16633844,4107810,1,'2010-03-12 18:34:27',3310504168,2),(621467565,425621366,16631774,4107810,1,'2010-03-12 18:34:27',3310504168,2),(621467566,425623405,16630613,4107810,1,'2010-03-12 18:34:27',3310504168,2),(621467568,425627106,16625853,4107810,1,'2010-03-12 18:34:27',3310504168,2),(621467569,425634874,16608394,4107810,1,'2010-03-12 18:34:26',3310504168,2),(621467570,425611445,16646895,4107810,1,'2010-03-12 18:34:27',3310504127,2),(621467571,425613042,16672931,3731738,1,'2010-01-27 23:25:18',3310504127,1),(621467572,425701005,16589477,3731738,1,'2010-01-27 23:25:18',3310504167,1),(621467573,425702835,16591456,4107810,1,'2010-03-12 18:34:27',3310504173,2),(621467574,425708196,16593126,4107810,1,'2010-03-12 18:34:27',3310504173,2),(621467575,425710656,16598642,4107810,1,'2010-03-12 18:34:27',3310504173,2),(621467576,425714808,16607758,4107810,1,'2010-03-12 18:34:27',3310504173,2),(621467577,425719561,16618508,4107810,1,'2010-03-12 18:34:27',3310504173,2),(621467582,425441245,16699822,4106774,1,'2010-03-12 16:31:16',3310504449,2),(621467586,425466800,16706002,3731738,1,'2010-01-27 23:25:22',3310504452,1),(621467587,425468677,16715568,4106774,1,'2010-03-12 16:31:16',3310504452,2),(621467589,425472275,16725832,4106774,1,'2010-03-12 16:31:16',3310504452,2),(621467590,425477156,16734995,4106774,1,'2010-03-12 16:31:16',3310504452,2),(621467592,425450951,16700535,4106774,1,'2010-03-12 16:31:16',3310504449,2),(621467593,425461976,16720938,4106774,1,'2010-03-12 16:31:16',3310504452,2),(621467595,425471602,16729225,4106774,1,'2010-03-12 16:31:16',3310504452,2),(621467596,425492788,16759322,4106774,1,'2010-03-12 16:31:16',3310504455,2),(621467598,425449350,16710590,4106774,1,'2010-03-12 16:31:16',3310504449,2),(621467599,425503172,16773917,4106774,1,'2010-03-12 16:31:16',3310504455,2),(621467600,425584790,16707029,3731738,1,'2010-01-27 23:25:22',3310504468,1),(621467601,425587752,16713137,4107810,1,'2010-03-12 18:34:27',3310504468,2),(621467603,425604193,16701307,3731738,1,'2010-01-27 23:25:22',3310504469,1),(621467612,425601491,16702019,4107810,1,'2010-03-12 18:34:27',3310504469,2),(621467615,425589960,16717786,4107810,1,'2010-03-12 18:34:27',3310504469,2),(621473071,425320767,16959540,3731851,1,'2010-01-27 23:40:25',3310493553,1),(621473074,425488496,16468920,3731851,1,'2010-01-27 23:40:26',3310504079,1),(621473077,425429266,16613496,3731851,1,'2010-01-27 23:40:26',3310504105,1),(621473079,425423599,16611370,4133447,1,'2010-03-15 12:47:10',3310504104,2),(621473081,425545972,16535877,3731851,1,'2010-01-27 23:40:26',3310504115,1),(621473083,425723576,16625185,3731851,1,'2010-01-27 23:40:26',3310504173,1),(623510069,425296191,17193248,4763364,1,'2010-05-21 10:18:41',3310493648,2),(643575021,426433585,15759863,3903073,1,'2010-02-17 20:32:18',3310503609,1),(643575023,426429433,15763263,3903073,1,'2010-02-17 20:32:18',3310503609,1),(643575025,426433853,15775498,3903073,1,'2010-02-17 20:32:18',3310503611,1),(643575026,426442585,15759555,3903073,1,'2010-02-17 20:32:18',3310503612,1),(643575027,426484660,15736207,3903073,1,'2010-02-17 20:32:18',3310503613,1),(643575028,426479954,15729593,3903073,1,'2010-02-17 20:32:18',3310503613,1),(643575029,426472015,15751185,3903073,1,'2010-02-17 20:32:18',3310503613,1),(643575030,426468319,15752275,3903073,1,'2010-02-17 20:32:19',3310503613,1),(643575031,426467277,15752585,3903073,1,'2010-02-17 20:32:19',3310503612,1),(643575032,426480453,15745949,3903073,1,'2010-02-17 20:32:19',3310503613,1),(643575034,426480271,15748742,3903073,1,'2010-02-17 20:32:19',3310503613,1),(643575035,426445232,15789034,3903073,1,'2010-02-17 20:32:19',3310503614,1),(643575040,426441737,15797930,3903073,1,'2010-02-17 20:32:19',3310503614,1),(643575042,426440049,15811630,3903073,1,'2010-02-17 20:32:19',3310503611,1),(643575043,426445169,15780178,3903073,1,'2010-02-17 20:32:19',3310503614,1),(643575061,426428969,15924423,3903073,1,'2010-02-17 20:32:20',3310504979,1),(643575062,426422368,15914852,3903073,1,'2010-02-17 20:32:20',3310504979,1),(643575063,426419876,15898790,3903073,1,'2010-02-17 20:32:20',3310504979,1),(643575065,426428176,15896265,3903073,1,'2010-02-17 20:32:20',3310504979,1),(643575066,426443847,15843763,3903073,1,'2010-02-17 20:32:20',3310504980,1),(643575069,426444379,15834906,3903073,1,'2010-02-17 20:32:20',3310504980,1),(643575071,426441331,15824484,3903073,1,'2010-02-17 20:32:20',3310504980,1),(643575074,426436921,15852695,3903073,1,'2010-02-17 20:32:20',3310504977,1),(643575075,426438256,15894531,3903073,1,'2010-02-17 20:32:20',3310504979,1),(643575077,426442942,15884009,3903073,1,'2010-02-17 20:32:20',3310504982,1),(643575080,426438070,15876833,3903073,1,'2010-02-17 20:32:20',3310504979,1),(643575092,426431557,15955766,3903073,1,'2010-02-17 20:32:20',3310504985,1),(643575094,426432617,15937247,3903073,1,'2010-02-17 20:32:20',3310504985,1),(643575096,426401222,16034602,3903073,1,'2010-02-17 20:32:20',3310504986,1),(643575118,426324153,16127051,3903073,1,'2010-02-17 20:32:21',3310504995,1),(643575120,426321295,16144159,3903073,1,'2010-02-17 20:32:21',3310504995,1),(643575122,426321269,16140435,3903073,1,'2010-02-17 20:32:21',3310504995,1),(643575124,426321007,16134851,3903073,1,'2010-02-17 20:32:21',3310504995,1),(643575126,426321651,16128952,3903073,1,'2010-02-17 20:32:21',3310504995,1),(643575127,426347810,16129401,3903073,1,'2010-02-17 20:32:21',3310504998,1),(643575129,426356700,16126074,3903073,1,'2010-02-17 20:32:21',3310504998,1),(643575131,426370278,16113840,3903073,1,'2010-02-17 20:32:21',3310504999,1),(643575134,426328037,16126987,3903073,1,'2010-02-17 20:32:21',3310504995,1),(643575135,426330789,16127257,3903073,1,'2010-02-17 20:32:21',3310504995,1),(643575138,426334673,16125642,3903073,1,'2010-02-17 20:32:21',3310504998,1),(643575147,426315681,16158831,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575150,426314095,16161648,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575152,426320432,16150996,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575154,426318626,16154439,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575156,426316475,16174951,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575159,426319712,16178931,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575160,426312755,16166012,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575163,426313004,16169726,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575165,426323837,16181351,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575167,426321781,16232700,3903073,1,'2010-02-17 20:32:22',3310505003,1),(643575169,426319926,16222263,3903073,1,'2010-02-17 20:32:22',3310505003,1),(643575171,426328665,16183138,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575173,426330952,16184349,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575174,426326369,16182247,3903073,1,'2010-02-17 20:32:22',3310505001,1),(643575176,426335363,16192655,3903073,1,'2010-02-17 20:32:22',3310505004,1),(643575177,426334718,16198562,3903073,1,'2010-02-17 20:32:22',3310505004,1),(643575178,426333029,16186178,3903073,1,'2010-02-17 20:32:22',3310505004,1),(643575179,426334193,16188953,3903073,1,'2010-02-17 20:32:22',3310505004,1),(643575180,426333368,16201376,3903073,1,'2010-02-17 20:32:23',3310505004,1),(643575181,426329057,16207959,3903073,1,'2010-02-17 20:32:23',3310505003,1),(643575184,426330423,16205761,3903073,1,'2010-02-17 20:32:23',3310505003,1),(643575186,426328357,16239057,3903073,1,'2010-02-17 20:32:23',3310505003,1),(643575187,426340049,16238442,3903073,1,'2010-02-17 20:32:23',3310505006,1),(643575190,426343270,16244970,3903073,1,'2010-02-17 20:32:23',3310505006,1),(643575192,426340949,16240354,3903073,1,'2010-02-17 20:32:23',3310505006,1),(643575196,426387222,16071786,3903073,1,'2010-02-17 20:32:23',3310505008,1),(643575199,426387083,16051673,3903073,1,'2010-02-17 20:32:23',3310505008,1),(643575200,426396585,16052359,3903073,1,'2010-02-17 20:32:23',3310505008,1),(643575203,426389172,16095898,3903073,1,'2010-02-17 20:32:23',3310505010,1),(643575204,426379741,16107283,3903073,1,'2010-02-17 20:32:23',3310504999,1),(643575264,426380140,16164240,3903073,1,'2010-02-17 20:32:24',3310505005,1),(643575498,426338101,16274329,3903073,1,'2010-02-17 20:32:30',3310505092,1),(643575500,426335635,16261490,3903073,1,'2010-02-17 20:32:30',3310505092,1),(643575502,426346729,16280427,3903073,1,'2010-02-17 20:32:30',3310505092,1),(646807552,425036300,15193338,3916355,1,'2010-02-19 17:31:54',3310491428,1),(646807563,425035977,15193837,3916355,1,'2010-02-19 17:31:54',3310491428,1),(646807568,425035932,15194160,3916355,1,'2010-02-19 17:31:54',3310491428,1),(646807575,425036151,15194859,3916355,1,'2010-02-19 17:31:54',3310491428,1),(646807589,425036353,15195039,3916355,1,'2010-02-19 17:31:54',3310491428,1),(646807600,425036924,15195028,3916355,1,'2010-02-19 17:31:54',3310491428,1),(646807608,425037292,15194466,3916355,1,'2010-02-19 17:31:55',3310491428,1),(646807611,425037326,15194141,3916355,1,'2010-02-19 17:31:55',3310491428,1),(646807615,425037183,15193596,3916355,1,'2010-02-19 17:31:55',3310491428,1),(646807618,425037004,15193374,3916355,1,'2010-02-19 17:31:55',3310491428,1),(646807620,425036781,15193248,3916355,1,'2010-02-19 17:31:55',3310491428,1),(646807701,425063084,15216894,3916355,1,'2010-02-19 17:31:58',3310491431,1),(646807706,425062741,15216284,3916355,1,'2010-02-19 17:31:58',3310491429,1),(646807713,425062226,15216020,3916355,1,'2010-02-19 17:31:58',3310491429,1),(646807720,425061579,15216243,3916355,1,'2010-02-19 17:31:59',3310491429,1),(646807752,425061634,15218582,3916355,1,'2010-02-19 17:31:59',3310491431,1),(646807770,425062768,15218467,3916355,1,'2010-02-19 17:32:00',3310491431,1),(646807785,425063091,15217859,3916355,1,'2010-02-19 17:32:00',3310491431,1),(646807844,425054728,15182544,3916355,1,'2010-02-19 17:32:03',3310491429,1),(646807845,425054353,15181852,3916355,1,'2010-02-19 17:32:03',3310491429,1),(646807846,425053653,15181586,3916355,1,'2010-02-19 17:32:03',3310491429,1),(646807847,425053017,15181974,3916355,1,'2010-02-19 17:32:03',3310491429,1),(646807848,425052706,15182781,3916355,1,'2010-02-19 17:32:03',3310491429,1),(646807849,425052899,15183844,3916355,1,'2010-02-19 17:32:04',3310491429,1),(646807852,425054271,15184218,3916355,1,'2010-02-19 17:32:04',3310491429,1),(646807855,425054547,15183897,3916355,1,'2010-02-19 17:32:04',3310491429,1),(646808595,425098026,15337848,3916355,1,'2010-02-19 17:33:03',3310491451,1),(646808596,425098411,15338940,3916355,1,'2010-02-19 17:33:03',3310491451,1),(646808597,425099698,15339687,3916355,1,'2010-02-19 17:33:03',3310491451,1),(646808603,425100637,15339222,3916355,1,'2010-02-19 17:33:04',3310491451,1),(646808608,425101186,15338159,3916355,1,'2010-02-19 17:33:04',3310491451,1),(646808624,425098579,15335788,3916355,1,'2010-02-19 17:33:05',3310491451,1),(646808843,425127882,15353490,3916355,1,'2010-02-19 17:33:23',3310491454,1),(646808846,425127746,15353084,3916355,1,'2010-02-19 17:33:23',3310491454,1),(646808852,425126943,15352528,3916355,1,'2010-02-19 17:33:23',3310491454,1),(646808857,425126419,15352765,3916355,1,'2010-02-19 17:33:23',3310491454,1),(646808861,425126189,15353082,3916355,1,'2010-02-19 17:33:23',3310491454,1),(646808867,425126021,15353840,3916355,1,'2010-02-19 17:33:23',3310491454,1),(646808879,425126210,15354580,3916355,1,'2010-02-19 17:33:24',3310491454,1),(646808882,425126662,15355025,3916355,1,'2010-02-19 17:33:24',3310491454,1),(646808883,425126986,15355093,3916355,1,'2010-02-19 17:33:24',3310491454,1),(646808884,425127778,15354470,3916355,1,'2010-02-19 17:33:24',3310491454,1),(646808885,425121167,15366233,3916355,1,'2010-02-19 17:33:25',3310491451,1),(646808886,425121143,15366747,3916355,1,'2010-02-19 17:33:25',3310491451,1),(646808887,425121573,15367770,3916355,1,'2010-02-19 17:33:25',3310491451,1),(646808888,425121912,15368002,3916355,1,'2010-02-19 17:33:25',3310491451,1),(646808889,425122591,15367982,3916355,1,'2010-02-19 17:33:25',3310491454,1),(646808890,425122922,15367729,3916355,1,'2010-02-19 17:33:26',3310491454,1),(646808892,425123261,15367067,3916355,1,'2010-02-19 17:33:26',3310491454,1),(646808893,425123186,15365870,3916355,1,'2010-02-19 17:33:26',3310491454,1),(646808895,425122949,15365469,3916355,1,'2010-02-19 17:33:26',3310491454,1),(646808896,425122624,15365202,3916355,1,'2010-02-19 17:33:26',3310491454,1),(646808900,425122056,15365120,3916355,1,'2010-02-19 17:33:27',3310491451,1),(646808903,425121698,15365288,3916355,1,'2010-02-19 17:33:27',3310491451,1),(646809553,425052682,15273233,3916355,1,'2010-02-19 17:34:12',3310491437,1),(646809558,425052994,15275620,3916355,1,'2010-02-19 17:34:13',3310491437,1),(646809563,425053532,15275204,3916355,1,'2010-02-19 17:34:13',3310491437,1),(646809578,425053715,15274126,3916355,1,'2010-02-19 17:34:14',3310491437,1),(646809579,425067118,15320162,3916355,1,'2010-02-19 17:34:14',3310491437,1),(646809584,425066678,15320331,3916355,1,'2010-02-19 17:34:15',3310491437,1),(646809589,425066415,15320820,3916355,1,'2010-02-19 17:34:15',3310491437,1),(646809604,425066881,15321999,3916355,1,'2010-02-19 17:34:15',3310491437,1),(646809608,425067283,15321994,3916355,1,'2010-02-19 17:34:16',3310491437,1),(646809614,425067766,15321032,3916355,1,'2010-02-19 17:34:16',3310491448,1),(646809632,425096900,15403108,3916355,1,'2010-02-19 17:34:17',3310491537,1),(646809636,425097046,15402412,3916355,1,'2010-02-19 17:34:17',3310491537,1),(646809642,425096795,15401673,3916355,1,'2010-02-19 17:34:17',3310491537,1),(646809643,425096262,15401367,3916355,1,'2010-02-19 17:34:17',3310491537,1),(646809644,425095690,15401645,3916355,1,'2010-02-19 17:34:17',3310491537,1),(646809645,425095420,15402348,3916355,1,'2010-02-19 17:34:17',3310491537,1),(646809646,425095579,15403140,3916355,1,'2010-02-19 17:34:18',3310491537,1),(646809647,425095979,15403527,3916355,1,'2010-02-19 17:34:18',3310491537,1),(646809648,425096480,15403529,3916355,1,'2010-02-19 17:34:18',3310491537,1),(646809649,425095793,15388197,3916355,1,'2010-02-19 17:34:19',3310491537,1),(646809650,425095716,15387559,3916355,1,'2010-02-19 17:34:19',3310491537,1),(646809651,425095299,15387162,3916355,1,'2010-02-19 17:34:19',3310491537,1),(646809652,425095079,15387154,3916355,1,'2010-02-19 17:34:19',3310491537,1),(646809653,425094771,15387339,3916355,1,'2010-02-19 17:34:19',3310491536,1),(646809654,425094627,15387566,3916355,1,'2010-02-19 17:34:20',3310491536,1),(646809655,425094548,15388160,3916355,1,'2010-02-19 17:34:20',3310491536,1),(646809656,425094624,15388441,3916355,1,'2010-02-19 17:34:20',3310491536,1),(646809657,425094978,15388827,3916355,1,'2010-02-19 17:34:20',3310491536,1),(646809658,425095504,15388742,3916355,1,'2010-02-19 17:34:20',3310491537,1),(646809672,425060696,15316764,3916355,1,'2010-02-19 17:34:21',3310491437,1),(646809674,425060371,15316514,3916355,1,'2010-02-19 17:34:21',3310491437,1),(646809678,425059971,15316533,3916355,1,'2010-02-19 17:34:21',3310491437,1),(646809684,425059490,15317341,3916355,1,'2010-02-19 17:34:21',3310491437,1),(646809689,425059738,15318184,3916355,1,'2010-02-19 17:34:22',3310491437,1),(646809695,425060429,15318358,3916355,1,'2010-02-19 17:34:22',3310491437,1),(646809706,425060786,15317984,3916355,1,'2010-02-19 17:34:22',3310491437,1),(646809720,425036528,15180066,3916355,1,'2010-02-19 17:34:23',3310491428,1),(646809729,425036667,15192431,3916355,1,'2010-02-19 17:34:26',3310491428,1),(663075945,425350919,14888980,4076773,1,'2010-03-09 00:21:26',3310491134,1),(663075946,425364521,14901933,4076773,1,'2010-03-09 00:21:27',3310491134,1),(663078911,425305403,14743589,4099383,1,'2010-03-11 19:09:03',3310491120,2),(663078912,425364963,14897914,4076872,1,'2010-03-09 00:33:55',3310491134,1),(663080312,425348713,14881373,4076934,1,'2010-03-09 00:40:43',3310491132,1),(663080313,425375895,14845831,4076934,1,'2010-03-09 00:40:43',3310491133,1),(663084327,425305570,14743394,4077060,1,'2010-03-09 00:55:20',3310491120,1),(663084328,425374897,14837366,4077060,1,'2010-03-09 00:55:20',3310491133,1),(663086638,425337908,14700074,4077132,1,'2010-03-09 01:04:51',3310491099,1),(663086639,425305248,14737749,4077132,1,'2010-03-09 01:04:51',3310491120,1),(663092389,425349965,14528820,4161911,1,'2010-03-18 16:53:24',3310491092,2),(663092390,425444649,14524549,4077213,1,'2010-03-09 01:15:07',3310502017,1),(663093429,425388591,14520891,4099383,1,'2010-03-11 19:09:03',3310491093,2),(663093430,425461551,14457107,4099383,1,'2010-03-11 19:09:03',3310501934,2),(663095052,425339072,14688950,4161911,1,'2010-03-18 16:53:24',3310491099,2),(663339197,426242409,15042758,4082908,1,'2010-03-09 19:56:14',3310502742,1),(663339199,426309688,15010315,4082908,1,'2010-03-09 19:56:15',3310503427,1),(663345420,426196539,15035976,4161868,1,'2010-03-18 16:48:01',3310502739,2),(663345421,426310907,15004789,4083006,1,'2010-03-09 20:07:11',3310503427,1),(663372539,425700874,14512465,4161539,1,'2010-03-18 16:04:24',3310502085,2),(663372540,425724358,14707197,4161539,1,'2010-03-18 16:04:24',3310502095,2),(663373401,425727343,14658685,4101592,1,'2010-03-11 23:12:19',3310502104,2),(663373402,425746083,14703624,4101592,1,'2010-03-11 23:12:19',3310502106,2),(663802644,426246755,14975797,4092743,1,'2010-03-10 21:47:17',3310502740,1),(663802645,426276533,14979749,4092743,1,'2010-03-10 21:47:17',3310503424,1),(663803593,426249538,14973830,4092770,1,'2010-03-10 21:50:18',3310502741,1),(663803594,426273575,14976629,4092770,1,'2010-03-10 21:50:21',3310502741,1),(663810387,426243099,15025738,4161868,1,'2010-03-18 16:48:01',3310502742,2),(663810389,426242718,15020443,4161868,1,'2010-03-18 16:48:01',3310502742,2),(663810390,426240402,15039575,4092963,1,'2010-03-10 22:12:46',3310502742,1),(663810391,426242852,15033117,4161868,1,'2010-03-18 16:48:01',3310502742,2),(663810392,426254140,15014955,4092963,1,'2010-03-10 22:12:46',3310502743,1),(663810393,426247089,15016457,4161868,1,'2010-03-18 16:48:01',3310502742,2),(663810394,426262747,15023614,4161868,1,'2010-03-18 16:48:01',3310502743,2),(663810395,426288818,15012708,4161868,1,'2010-03-18 16:48:01',3310503426,2),(663810396,426311083,15008174,4161868,1,'2010-03-18 16:48:01',3310503427,2),(663952666,426289238,14865416,4096040,1,'2010-03-11 10:54:37',3310503080,1),(663952667,426292187,14888431,4096040,1,'2010-03-11 10:54:37',3310503082,1),(663953196,426323880,14960295,4096072,1,'2010-03-11 11:00:51',3310503425,1),(663953551,426324578,14960537,4096095,1,'2010-03-11 11:05:32',3310503425,1),(663953552,426333575,14962751,4096095,1,'2010-03-11 11:05:32',3310503428,1),(663953553,426337339,14972403,4096095,1,'2010-03-11 11:05:32',3310503428,1),(663955433,426319069,14877921,4161868,1,'2010-03-18 16:48:01',3310503081,2),(663955434,426316037,14826937,4161868,1,'2010-03-18 16:48:01',3310503075,2),(663955435,426317929,14869948,4161868,1,'2010-03-18 16:48:01',3310503081,2),(663955436,426275899,14932985,4096166,1,'2010-03-11 11:18:38',3310502399,1),(663955437,426275554,14934126,4096166,1,'2010-03-11 11:18:38',3310502399,1),(663955438,426279293,14933248,4096166,1,'2010-03-11 11:18:38',3310503082,1),(663955439,426281962,14938572,4096166,1,'2010-03-11 11:18:38',3310503082,1),(663955440,426281184,14932654,4096166,1,'2010-03-11 11:18:38',3310503082,1),(663955441,426289146,14934924,4096166,1,'2010-03-11 11:18:38',3310503082,1),(663955442,426283777,14932685,4096166,1,'2010-03-11 11:18:38',3310503082,1),(663955443,426320774,14886521,4096166,1,'2010-03-11 11:18:38',3310503081,1),(663955444,426326907,14918373,4096166,1,'2010-03-11 11:18:38',3310503083,1),(663955445,426330004,14905471,4096166,1,'2010-03-11 11:18:38',3310503083,1),(663955446,426328398,14898584,4096166,1,'2010-03-11 11:18:38',3310503083,1),(663955447,426326662,14932262,4096166,1,'2010-03-11 11:18:38',3310503083,1),(663955448,426279526,14944468,4096166,1,'2010-03-11 11:18:38',3310503424,1),(663955449,426279593,14942972,4096166,1,'2010-03-11 11:18:38',3310503424,1),(663955450,426280794,14942200,4096166,1,'2010-03-11 11:18:38',3310503424,1),(663955451,426282596,14947099,4096166,1,'2010-03-11 11:18:39',3310503424,1),(663955452,426282162,14953268,4096166,1,'2010-03-11 11:18:39',3310503424,1),(663955453,426283230,14949957,4096166,1,'2010-03-11 11:18:39',3310503424,1),(663955454,426279559,14957124,4096166,1,'2010-03-11 11:18:39',3310503424,1),(663955455,426278358,14958666,4096166,1,'2010-03-11 11:18:39',3310503424,1),(663955456,426286568,14943017,4096166,1,'2010-03-11 11:18:39',3310503424,1),(663955457,426285233,14945194,4096166,1,'2010-03-11 11:18:39',3310503424,1);
INSERT INTO `nodes` VALUES (663955458,426289805,14948823,4096166,1,'2010-03-11 11:18:39',3310503424,1),(663955459,426295563,14942965,4096166,1,'2010-03-11 11:18:39',3310503424,1),(663955460,426290372,14946147,4096166,1,'2010-03-11 11:18:39',3310503424,1),(663955461,426290740,14947961,4096166,1,'2010-03-11 11:18:39',3310503424,1),(663955462,426303828,14957113,4096166,1,'2010-03-11 11:18:39',3310503425,1),(663955463,426319872,14962699,4096166,1,'2010-03-11 11:18:39',3310503425,1),(663955464,426323838,14957403,4096166,1,'2010-03-11 11:18:39',3310503425,1),(663955465,426313798,14963496,4096166,1,'2010-03-11 11:18:39',3310503425,1),(663955466,426325133,14944050,4096166,1,'2010-03-11 11:18:39',3310503425,1),(663956152,426292908,14889899,4096186,1,'2010-03-11 11:22:31',3310503082,1),(663956153,426294190,14898869,4096186,1,'2010-03-11 11:22:31',3310503082,1),(663956154,426296240,14901743,4096186,1,'2010-03-11 11:22:31',3310503082,1),(663956155,426299465,14902759,4096186,1,'2010-03-11 11:22:32',3310503082,1),(663956156,426300675,14906104,4096186,1,'2010-03-11 11:22:32',3310503082,1),(663956157,426303887,14909280,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956158,426308726,14906558,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956159,426311730,14903780,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956160,426311688,14908656,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956161,426312564,14912058,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956162,426312564,14914496,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956163,426314191,14916197,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956164,426317320,14916821,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956165,426324203,14902759,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956166,426321283,14903666,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956167,426301176,14903836,4096186,1,'2010-03-11 11:22:32',3310503082,1),(663956168,426325454,14906161,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956169,426327457,14905594,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956170,426328666,14907182,4096186,1,'2010-03-11 11:22:32',3310503083,1),(663956738,426179584,14858670,4161868,1,'2010-03-18 16:48:00',3310502392,2),(663956739,426188018,14857526,4161868,1,'2010-03-18 16:48:01',3310502392,2),(663956740,426193223,14863153,4096227,1,'2010-03-11 11:29:18',3310502392,1),(663956742,426202937,14861469,4096227,1,'2010-03-11 11:29:18',3310502393,1),(663956743,426214981,14862001,4096227,1,'2010-03-11 11:29:18',3310502393,1),(663956744,426220115,14854249,4096227,1,'2010-03-11 11:29:18',3310502393,1),(663956745,426227041,14851037,4096227,1,'2010-03-11 11:29:18',3310502396,1),(663956746,426228426,14845390,4096227,1,'2010-03-11 11:29:18',3310502396,1),(663956747,426233397,14841956,4096227,1,'2010-03-11 11:29:18',3310502396,1),(663956748,426240079,14831547,4096227,1,'2010-03-11 11:29:18',3310502390,1),(663956749,426243909,14833097,4096227,1,'2010-03-11 11:29:18',3310502396,1),(663956750,426262324,14849376,4096227,1,'2010-03-11 11:29:18',3310502397,1),(663956751,426272102,14849930,4096227,1,'2010-03-11 11:29:18',3310502397,1),(663956752,426293776,14864770,4096227,1,'2010-03-11 11:29:18',3310503080,1),(663956753,426280332,14859011,4096227,1,'2010-03-11 11:29:18',3310503080,1),(663956754,426313005,14871414,4096227,1,'2010-03-11 11:29:18',3310503081,1),(663956755,426318301,14887915,4096227,1,'2010-03-11 11:29:18',3310503083,1),(663956756,426327507,14904415,4096227,1,'2010-03-11 11:29:18',3310503083,1),(663957559,426250466,14914536,4161868,1,'2010-03-18 16:48:01',3310502399,2),(663957562,426227493,14850256,4161868,1,'2010-03-18 16:48:01',3310502396,2),(664061744,425682046,16425324,4098619,1,'2010-03-11 17:30:56',3310504142,1),(664061745,425684920,16466451,4098619,1,'2010-03-11 17:30:56',3310504142,1),(664061746,425684937,16466221,4098619,1,'2010-03-11 17:30:56',3310504142,1),(664061747,425774383,16486767,4098619,1,'2010-03-11 17:30:56',3310504177,1),(664061748,425775092,16489805,4098619,1,'2010-03-11 17:30:56',3310504177,1),(664085275,425331110,14714962,4098931,1,'2010-03-11 18:10:53',3310491099,1),(664085276,425339621,14718488,4098931,1,'2010-03-11 18:10:53',3310491099,1),(664085277,425339621,14714233,4098931,1,'2010-03-11 18:10:53',3310491099,1),(664085278,425339621,14708154,4098931,1,'2010-03-11 18:10:53',3310491099,1),(664085279,425338994,14701102,4098931,1,'2010-03-11 18:10:53',3310491099,1),(664085280,425335768,14708883,4098931,1,'2010-03-11 18:10:53',3310491099,1),(664085281,425337919,14703777,4098931,1,'2010-03-11 18:10:53',3310491099,1),(664085282,425338635,14701467,4098931,1,'2010-03-11 18:10:53',3310491099,1),(664085283,425338366,14700494,4098931,1,'2010-03-11 18:10:53',3310491099,1),(664085284,425304236,14741774,4098931,1,'2010-03-11 18:10:53',3310491120,1),(664085285,425307970,14744579,4098931,1,'2010-03-11 18:10:53',3310491120,1),(664085286,425304590,14741223,4098931,1,'2010-03-11 18:10:53',3310491120,1),(664085287,425305486,14740251,4098931,1,'2010-03-11 18:10:53',3310491120,1),(664085288,425306741,14736117,4098931,1,'2010-03-11 18:10:53',3310491120,1),(664085289,425311141,14748690,4098931,1,'2010-03-11 18:10:53',3310491120,1),(664085290,425309877,14744020,4098931,1,'2010-03-11 18:10:53',3310491120,1),(664085291,425314446,14745478,4098931,1,'2010-03-11 18:10:53',3310491120,1),(664085292,425317940,14744627,4098931,1,'2010-03-11 18:10:53',3310491121,1),(664085293,425310683,14737211,4098931,1,'2010-03-11 18:10:53',3310491120,1),(664085294,425315790,14733321,4098931,1,'2010-03-11 18:10:53',3310491121,1),(664085296,425320180,14729187,4098931,1,'2010-03-11 18:10:53',3310491121,1),(664085297,425323942,14742804,4098931,1,'2010-03-11 18:10:53',3310491121,1),(664085298,425331468,14739156,4098931,1,'2010-03-11 18:10:54',3310491121,1),(664085299,425325645,14722500,4098931,1,'2010-03-11 18:10:54',3310491121,1),(664085300,425313912,14753981,4098931,1,'2010-03-11 18:10:54',3310491120,1),(664085301,425317083,14760291,4098931,1,'2010-03-11 18:10:54',3310491121,1),(664085302,425321252,14770569,4098931,1,'2010-03-11 18:10:54',3310491121,1),(664085303,425327857,14788547,4098931,1,'2010-03-11 18:10:54',3310491123,1),(664085304,425324480,14778183,4098931,1,'2010-03-11 18:10:54',3310491123,1),(664085305,425326451,14780007,4098931,1,'2010-03-11 18:10:54',3310491123,1),(664085306,425333349,14783776,4098931,1,'2010-03-11 18:10:54',3310491123,1),(664085307,425334425,14810086,4098931,1,'2010-03-11 18:10:54',3310491123,1),(664085308,425335948,14737211,4098931,1,'2010-03-11 18:10:54',3310491121,1),(664085309,425338098,14733321,4098931,1,'2010-03-11 18:10:54',3310491121,1),(664085310,425339710,14728457,4098931,1,'2010-03-11 18:10:54',3310491121,1),(664085311,425340248,14723229,4098931,1,'2010-03-11 18:10:54',3310491121,1),(664085312,425339531,14785843,4098931,1,'2010-03-11 18:10:54',3310491123,1),(664085313,425344996,14787180,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085314,425347236,14788031,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085315,425348938,14789976,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085316,425357180,14802256,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085317,425357628,14800432,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085318,425358524,14800311,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085319,425359061,14801162,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085320,425359151,14802621,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085321,425350461,14793745,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085322,425351446,14798730,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085323,425340803,14825940,4098931,1,'2010-03-11 18:10:54',3310491123,1),(664085324,425354761,14826329,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085325,425355657,14820493,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085326,425356642,14812712,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085327,425356822,14806876,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085328,425359599,14806146,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085329,425360942,14812833,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085330,425362913,14821709,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085331,425353328,14804080,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085332,425355119,14808578,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085333,425355926,14810523,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085334,425364705,14826572,4098931,1,'2010-03-11 18:10:54',3310491126,1),(664085335,425347182,14836736,4098931,1,'2010-03-11 18:10:54',3310491132,1),(664085336,425352056,14840237,4098931,1,'2010-03-11 18:10:54',3310491132,1),(664085337,425357502,14843252,4098931,1,'2010-03-11 18:10:54',3310491132,1),(664085338,425360799,14843447,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085339,425354492,14856237,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085340,425356105,14847240,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085341,425356284,14839459,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085342,425354671,14832043,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085344,425349207,14884443,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085345,425351715,14883836,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085346,425356553,14876662,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085348,425351984,14874960,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085354,425353686,14865720,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085355,425364024,14840140,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085357,425367106,14838195,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085358,425366676,14831678,4098931,1,'2010-03-11 18:10:55',3310491126,1),(664085360,425369095,14834961,4098931,1,'2010-03-11 18:10:55',3310491132,1),(664085361,425370833,14838681,4098931,1,'2010-03-11 18:10:55',3310491133,1),(664085362,425376494,14842085,4098931,1,'2010-03-11 18:10:55',3310491133,1),(664085364,425375186,14840432,4098931,1,'2010-03-11 18:10:55',3310491133,1),(664085365,425372857,14856115,4098931,1,'2010-03-11 18:10:55',3310491133,1),(664085367,425375724,14850523,4098931,1,'2010-03-11 18:10:55',3310491133,1),(664085368,425378770,14855872,4098931,1,'2010-03-11 18:10:55',3310491133,1),(664085369,425378949,14852590,4098931,1,'2010-03-11 18:10:56',3310491133,1),(664085371,425378322,14848578,4098931,1,'2010-03-11 18:10:56',3310491133,1),(664085372,425377247,14843958,4098931,1,'2010-03-11 18:10:56',3310491133,1),(664085373,425377068,14844079,4098931,1,'2010-03-11 18:10:56',3310491133,1),(664085375,425373305,14882741,4098931,1,'2010-03-11 18:10:56',3310491133,1),(664085376,425375007,14873258,4098931,1,'2010-03-11 18:10:56',3310491133,1),(664085377,425363540,14868517,4098931,1,'2010-03-11 18:10:56',3310491132,1),(664085379,425368647,14862559,4098931,1,'2010-03-11 18:10:56',3310491132,1),(664085380,425377068,14863653,4098931,1,'2010-03-11 18:10:56',3310491133,1),(664085381,425348848,14888577,4098931,1,'2010-03-11 18:10:56',3310491134,1),(664085382,425350103,14887604,4098931,1,'2010-03-11 18:10:56',3310491134,1),(664085383,425349834,14890644,4098931,1,'2010-03-11 18:10:56',3310491134,1),(664085384,425350103,14894291,4098931,1,'2010-03-11 18:10:56',3310491134,1),(664085385,425352253,14898303,4098931,1,'2010-03-11 18:10:56',3310491134,1),(664085386,425354940,14901100,4098931,1,'2010-03-11 18:10:56',3310491134,1),(664085387,425357538,14902559,4098931,1,'2010-03-11 18:10:56',3310491134,1),(664085388,425360763,14902559,4098931,1,'2010-03-11 18:10:56',3310491134,1),(664085389,425362913,14902559,4098931,1,'2010-03-11 18:10:56',3310491134,1),(664085390,425366228,14903288,4098931,1,'2010-03-11 18:10:56',3310491134,1),(664085392,425370707,14890887,4098931,1,'2010-03-11 18:10:56',3310491135,1),(664085393,425364526,14902072,4098931,1,'2010-03-11 18:10:56',3310491134,1),(664115756,425265974,14581203,4099383,1,'2010-03-11 19:08:50',3310491079,1),(664115763,425275854,14571334,4099383,1,'2010-03-11 19:08:50',3310491079,1),(664115765,425275471,14601750,4099383,1,'2010-03-11 19:08:50',3310491079,1),(664115766,425279145,14605641,4099383,1,'2010-03-11 19:08:50',3310491079,1),(664115767,425280758,14609045,4099383,1,'2010-03-11 19:08:50',3310491079,1),(664115768,425269737,14589957,4099383,1,'2010-03-11 19:08:50',3310491079,1),(664115769,425276009,14605519,4099383,1,'2010-03-11 19:08:50',3310491079,1),(664115770,425273321,14598346,4099383,1,'2010-03-11 19:08:50',3310491079,1),(664115771,425279593,14659500,4099383,1,'2010-03-11 19:08:50',3310491085,1),(664115772,425279145,14614273,4099383,1,'2010-03-11 19:08:50',3310491085,1),(664115773,425278607,14611963,4099383,1,'2010-03-11 19:08:50',3310491079,1),(664115774,425277980,14632145,4099383,1,'2010-03-11 19:08:50',3310491085,1),(664115775,425278159,14626674,4099383,1,'2010-03-11 19:08:50',3310491085,1),(664115776,425278966,14620352,4099383,1,'2010-03-11 19:08:50',3310491085,1),(664115777,425279145,14616704,4099383,1,'2010-03-11 19:08:50',3310491085,1),(664115778,425277622,14650503,4099383,1,'2010-03-11 19:08:50',3310491085,1),(664115779,425276636,14646005,4099383,1,'2010-03-11 19:08:50',3310491085,1),(664115780,425276636,14642236,4099383,1,'2010-03-11 19:08:50',3310491085,1),(664115781,425277353,14638224,4099383,1,'2010-03-11 19:08:50',3310491085,1),(664115789,425320041,14542156,4099383,1,'2010-03-11 19:08:50',3310491089,1),(664115790,425317942,14548425,4099383,1,'2010-03-11 19:08:50',3310491089,1),(664115791,425316262,14554504,4099383,1,'2010-03-11 19:08:50',3310491089,1),(664115792,425321196,14539604,4099383,1,'2010-03-11 19:08:50',3310491089,1),(664115793,425329508,14549102,4099383,1,'2010-03-11 19:08:50',3310491089,1),(664115800,425282573,14580832,4099383,1,'2010-03-11 19:08:51',3310491079,1),(664115801,425308003,14574641,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115802,425307023,14576540,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115803,425306603,14579960,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115804,425288873,14589761,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115805,425292793,14597930,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115806,425294753,14600399,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115807,425298113,14601539,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115808,425297833,14604958,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115809,425297833,14608758,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115810,425300773,14600209,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115811,425305063,14585279,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115812,425302963,14591168,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115813,425301703,14595157,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115814,425299323,14600476,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115815,425296803,14604276,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115816,425295403,14609405,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115817,425314302,14562103,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115818,425311922,14568562,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115819,425310662,14570081,4099383,1,'2010-03-11 19:08:51',3310491090,1),(664115822,425347746,14522941,4099383,1,'2010-03-11 19:08:51',3310491092,1),(664115823,425352777,14522941,4099383,1,'2010-03-11 19:08:51',3310491092,1),(664115824,425358026,14524722,4099383,1,'2010-03-11 19:08:51',3310491092,1),(664115825,425360651,14524722,4099383,1,'2010-03-11 19:08:51',3310491092,1),(664115826,425365462,14524425,4099383,1,'2010-03-11 19:08:51',3310491092,1),(664115827,425370712,14524129,4099383,1,'2010-03-11 19:08:51',3310491093,1),(664115828,425376617,14525019,4099383,1,'2010-03-11 19:08:51',3310491093,1),(664115829,425380991,14525910,4099383,1,'2010-03-11 19:08:51',3310491093,1),(664115830,425384272,14525910,4099383,1,'2010-03-11 19:08:51',3310491093,1),(664115831,425387333,14527097,4099383,1,'2010-03-11 19:08:51',3310491093,1),(664115832,425389662,14528772,4099383,1,'2010-03-11 19:08:51',3310491093,1),(664115833,425388449,14522891,4099383,1,'2010-03-11 19:08:51',3310491093,1),(664115834,425388831,14524006,4099383,1,'2010-03-11 19:08:51',3310491093,1),(664115835,425389447,14524803,4099383,1,'2010-03-11 19:08:51',3310491093,1),(664115836,425390592,14525241,4099383,1,'2010-03-11 19:08:51',3310491093,1),(664115837,425389739,14529768,4099383,1,'2010-03-11 19:08:51',3310491093,1),(664115838,425336726,14558303,4099383,1,'2010-03-11 19:08:52',3310491091,1),(664115839,425343506,14568989,4099383,1,'2010-03-11 19:08:52',3310491094,1),(664115840,425350287,14581456,4099383,1,'2010-03-11 19:08:52',3310491094,1),(664115841,425355098,14590657,4099383,1,'2010-03-11 19:08:52',3310491094,1),(664115842,425358598,14598078,4099383,1,'2010-03-11 19:08:52',3310491094,1),(664115843,425360566,14606983,4099383,1,'2010-03-11 19:08:52',3310491094,1),(664115844,425282102,14612084,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115845,425282102,14614030,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115846,425281923,14616704,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115847,425281475,14619136,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115848,425281475,14620960,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115849,425281743,14623148,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115850,425281385,14625458,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115851,425293863,14615104,4099383,1,'2010-03-11 19:08:52',3310491096,1),(664115852,425291763,14620233,4099383,1,'2010-03-11 19:08:52',3310491096,1),(664115853,425280937,14628741,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115854,425280937,14631780,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115855,425281564,14636157,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115856,425286724,14635050,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115857,425285604,14638280,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115858,425290084,14625552,4099383,1,'2010-03-11 19:08:52',3310491096,1),(664115859,425288404,14630681,4099383,1,'2010-03-11 19:08:52',3310491096,1),(664115860,425299093,14615027,4099383,1,'2010-03-11 19:08:52',3310491096,1),(664115861,425302732,14621865,4099383,1,'2010-03-11 19:08:52',3310491096,1),(664115862,425307352,14627944,4099383,1,'2010-03-11 19:08:52',3310491096,1),(664115863,425282281,14639318,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115864,425283177,14643209,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115865,425284790,14647707,4099383,1,'2010-03-11 19:08:52',3310491085,1),(664115866,425287030,14651598,4099383,1,'2010-03-11 19:08:53',3310491085,1),(664115867,425284624,14642459,4099383,1,'2010-03-11 19:08:53',3310491085,1),(664115868,425284344,14650628,4099383,1,'2010-03-11 19:08:53',3310491085,1),(664115869,425281116,14665944,4099383,1,'2010-03-11 19:08:53',3310491085,1),(664115870,425284204,14658986,4099383,1,'2010-03-11 19:08:53',3310491085,1),(664115871,425284904,14664875,4099383,1,'2010-03-11 19:08:53',3310491085,1),(664115872,425289538,14655853,4099383,1,'2010-03-11 19:08:53',3310491096,1),(664115873,425291868,14660716,4099383,1,'2010-03-11 19:08:53',3310491096,1),(664115874,425294556,14664363,4099383,1,'2010-03-11 19:08:53',3310491096,1),(664115875,425312252,14635543,4099383,1,'2010-03-11 19:08:53',3310491096,1),(664115876,425317431,14642952,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115877,425320371,14647701,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115878,425330661,14665214,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115879,425330393,14661689,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115880,425330393,14659257,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115881,425330930,14659257,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115882,425331468,14660108,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115883,425332901,14664485,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115884,425322051,14651310,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115885,425323591,14653590,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115886,425327230,14656439,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115887,425330730,14658529,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115888,425334320,14653584,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115889,425330820,14657740,4099383,1,'2010-03-11 19:08:53',3310491097,1),(664115890,425282818,14669227,4099383,1,'2010-03-11 19:08:53',3310491087,1),(664115891,425285865,14671537,4099383,1,'2010-03-11 19:08:53',3310491087,1),(664115892,425286024,14673044,4099383,1,'2010-03-11 19:08:53',3310491087,1),(664115893,425283714,14675184,4099383,1,'2010-03-11 19:08:53',3310491087,1),(664115894,425283325,14678352,4099383,1,'2010-03-11 19:08:53',3310491087,1),(664115895,425285884,14679503,4099383,1,'2010-03-11 19:08:53',3310491087,1),(664115896,425289359,14674211,4099383,1,'2010-03-11 19:08:53',3310491098,1),(664115897,425291957,14675549,4099383,1,'2010-03-11 19:08:53',3310491098,1),(664115898,425294018,14675549,4099383,1,'2010-03-11 19:08:53',3310491098,1),(664115899,425283745,14683085,4099383,1,'2010-03-11 19:08:53',3310491087,1),(664115900,425284431,14688558,4099383,1,'2010-03-11 19:08:53',3310491087,1),(664115901,425285884,14684632,4099383,1,'2010-03-11 19:08:53',3310491087,1),(664115902,425285044,14689951,4099383,1,'2010-03-11 19:08:53',3310491087,1),(664115903,425288373,14683816,4099383,1,'2010-03-11 19:08:53',3310491098,1),(664115904,425292674,14690989,4099383,1,'2010-03-11 19:08:53',3310491098,1),(664115905,425306561,14692691,4099383,1,'2010-03-11 19:08:53',3310491098,1),(664115906,425297243,14676643,4099383,1,'2010-03-11 19:08:53',3310491098,1),(664115907,425301275,14678710,4099383,1,'2010-03-11 19:08:53',3310491098,1),(664115908,425305486,14681020,4099383,1,'2010-03-11 19:08:53',3310491098,1),(664115909,425299394,14669348,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115910,425304053,14673482,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115911,425286724,14695840,4099383,1,'2010-03-11 19:08:54',3310491087,1),(664115912,425289104,14701539,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115913,425290644,14706288,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115914,425290784,14710277,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115915,425291763,14715217,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115916,425294003,14719966,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115917,425301723,14717493,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115918,425302261,14710807,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115919,425303425,14703512,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115920,425304949,14696582,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115921,425296527,14696947,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115922,425300648,14703269,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115923,425302440,14704363,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115924,425303963,14704849,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115925,425306382,14703998,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115926,425307368,14701810,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115927,425314177,14677008,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115928,425314087,14675792,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115929,425314535,14674576,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115930,425309607,14677372,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115931,425311847,14679561,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115932,425313911,14679931,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115933,425315252,14674941,4099383,1,'2010-03-11 19:08:54',3310491099,1),(664115935,425315789,14675913,4099383,1,'2010-03-11 19:08:54',3310491099,1),(664115936,425316237,14678345,4099383,1,'2010-03-11 19:08:54',3310491099,1),(664115938,425309159,14689044,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115940,425311937,14687099,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115941,425313549,14686612,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115943,425314177,14685275,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115945,425314625,14683087,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115947,425314714,14680655,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115948,425308532,14681992,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115950,425310503,14682965,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115952,425312116,14684545,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115953,425314087,14685153,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115955,425314266,14682600,4099383,1,'2010-03-11 19:08:54',3310491098,1),(664115957,425317402,14681749,4099383,1,'2010-03-11 19:08:54',3310491099,1),(664115958,425318925,14684424,4099383,1,'2010-03-11 19:08:54',3310491099,1),(664115960,425320717,14687099,4099383,1,'2010-03-11 19:08:54',3310491099,1),(664115961,425321882,14688314,4099383,1,'2010-03-11 19:08:54',3310491099,1),(664115962,425315521,14686734,4099383,1,'2010-03-11 19:08:54',3310491099,1),(664115963,425317402,14687707,4099383,1,'2010-03-11 19:08:54',3310491099,1),(664115964,425320090,14688801,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115965,425323225,14688314,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115966,425324121,14685640,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115967,425325196,14682357,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115968,425327705,14677494,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115970,425329138,14674454,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115971,425330572,14669834,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115973,425334424,14670199,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115974,425335589,14675549,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115976,425335678,14680777,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115977,425324480,14690503,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115978,425327436,14692691,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115980,425329766,14694150,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115981,425308980,14699135,4099383,1,'2010-03-11 19:08:55',3310491098,1),(664115983,425310862,14698041,4099383,1,'2010-03-11 19:08:55',3310491098,1),(664115984,425312922,14696825,4099383,1,'2010-03-11 19:08:55',3310491098,1),(664115985,425315789,14696460,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115986,425320896,14697190,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115987,425324569,14698284,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115988,425327257,14699257,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115989,425329676,14699257,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115990,425332274,14698770,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115991,425334603,14698770,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115992,425331826,14695488,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115993,425334962,14697068,4099383,1,'2010-03-11 19:08:55',3310491099,1),(664115994,425347443,14636665,4099383,1,'2010-03-11 19:08:55',3310491100,1),(664115995,425344381,14637852,4099383,1,'2010-03-11 19:08:55',3310491100,1),(664115996,425362097,14613216,4099383,1,'2010-03-11 19:08:55',3310491100,1),(664115997,425361441,14636962,4099383,1,'2010-03-11 19:08:55',3310491100,1),(664115998,425356848,14638743,4099383,1,'2010-03-11 19:08:55',3310491100,1),(664115999,425354005,14636665,4099383,1,'2010-03-11 19:08:55',3310491100,1),(664116000,425351162,14635775,4099383,1,'2010-03-11 19:08:55',3310491100,1),(664116001,425343069,14641117,4099383,1,'2010-03-11 19:08:55',3310491100,1),(664116002,425341538,14645273,4099383,1,'2010-03-11 19:08:55',3310491097,1),(664116003,425337601,14649428,4099383,1,'2010-03-11 19:08:55',3310491097,1),(664116004,425364066,14617075,4099383,1,'2010-03-11 19:08:56',3310491100,1),(664116005,425365378,14623011,4099383,1,'2010-03-11 19:08:56',3310491100,1),(664116006,425366034,14628651,4099383,1,'2010-03-11 19:08:56',3310491100,1),(664116007,425364503,14634587,4099383,1,'2010-03-11 19:08:56',3310491100,1),(664116008,425336037,14686126,4099383,1,'2010-03-11 19:08:56',3310491099,1),(664116009,425336395,14691597,4099383,1,'2010-03-11 19:08:56',3310491099,1),(664116011,425336933,14695731,4099383,1,'2010-03-11 19:08:56',3310491099,1),(664116012,425338277,14698527,4099383,1,'2010-03-11 19:08:56',3310491099,1),(664116013,425338366,14699621,4099383,1,'2010-03-11 19:08:56',3310491099,1),(664116014,425337739,14699013,4099383,1,'2010-03-11 19:08:56',3310491099,1),(664116015,425296943,14723765,4099383,1,'2010-03-11 19:08:56',3310491120,1),(664116016,425298623,14728514,4099383,1,'2010-03-11 19:08:56',3310491120,1),(664116017,425300723,14732694,4099383,1,'2010-03-11 19:08:56',3310491120,1),(664116018,425302440,14730746,4099383,1,'2010-03-11 19:08:56',3310491120,1),(664116019,425302440,14721992,4099383,1,'2010-03-11 19:08:56',3310491120,1),(664116020,425302440,14736946,4099383,1,'2010-03-11 19:08:56',3310491120,1),(664116021,425301983,14737823,4099383,1,'2010-03-11 19:08:56',3310491120,1),(664116022,425303873,14743390,4099383,1,'2010-03-11 19:08:56',3310491120,1),(664116023,425307368,14750928,4099383,1,'2010-03-11 19:08:56',3310491120,1),(664116024,425311310,14760532,4099383,1,'2010-03-11 19:08:56',3310491120,1),(664116025,425313997,14771596,4099383,1,'2010-03-11 19:08:56',3310491120,1),(664116026,425317581,14785699,4099383,1,'2010-03-11 19:08:56',3310491123,1),(664116027,425320896,14802113,4099383,1,'2010-03-11 19:08:56',3310491123,1),(664116028,425324211,14816337,4099383,1,'2010-03-11 19:08:56',3310491123,1),(664116029,425327257,14830076,4099383,1,'2010-03-11 19:08:56',3310491123,1),(664116030,425329766,14842234,4099383,1,'2010-03-11 19:08:56',3310491129,1),(664116031,425331737,14847218,4099383,1,'2010-03-11 19:08:56',3310491129,1),(664116032,425333528,14850015,4099383,1,'2010-03-11 19:08:56',3310491129,1),(664116033,425336395,14852689,4099383,1,'2010-03-11 19:08:56',3310491129,1),(664116034,425340068,14856702,4099383,1,'2010-03-11 19:08:56',3310491129,1),(664116035,425342398,14859619,4099383,1,'2010-03-11 19:08:56',3310491132,1),(664116036,425344100,14863510,4099383,1,'2010-03-11 19:08:57',3310491132,1),(664116037,425346429,14870318,4099383,1,'2010-03-11 19:08:57',3310491132,1),(664116038,425346877,14876641,4099383,1,'2010-03-11 19:08:57',3310491132,1),(664116039,425347683,14884178,4099383,1,'2010-03-11 19:08:57',3310491132,1),(664116040,425347863,14889893,4099383,1,'2010-03-11 19:08:57',3310491134,1),(664116041,425408644,14497732,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116042,425410075,14493002,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116043,425411873,14486926,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116044,425413378,14481050,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116045,425414882,14473381,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116046,425416130,14468849,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116047,425417010,14465562,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116048,425417487,14463919,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116049,425417927,14462525,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116050,425418331,14461529,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116051,425419212,14460583,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116052,425421413,14458690,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116053,425423284,14457395,4099383,1,'2010-03-11 19:08:57',3310501930,1),(664116054,425425853,14455852,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116055,425426880,14455503,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116056,425428164,14455105,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116057,425430255,14453860,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116058,425445506,14474262,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116059,425431980,14453013,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116060,425433778,14452565,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116061,425436603,14451669,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116062,425438694,14450872,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116063,425440529,14450473,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116064,425442473,14450324,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116065,425444014,14450424,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116066,425438727,14495930,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116067,425440039,14489697,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116068,425442008,14483464,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116069,425443757,14478121,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116070,425445812,14451121,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116071,425447096,14451669,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116072,425449114,14452665,4099383,1,'2010-03-11 19:08:57',3310501931,1),(664116073,425450692,14453461,4099383,1,'2010-03-11 19:08:58',3310501931,1),(664116074,425451609,14454158,4099383,1,'2010-03-11 19:08:58',3310501931,1),(664116075,425452599,14454706,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116076,425453920,14455154,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116077,425455498,14455154,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116078,425457369,14455154,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116079,425458616,14455055,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116080,425448568,14471294,4099383,1,'2010-03-11 19:08:58',3310501931,1),(664116081,425451848,14468326,4099383,1,'2010-03-11 19:08:58',3310501931,1),(664116082,425455566,14465951,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116083,425459502,14462389,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116084,425461908,14459421,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116085,425459607,14454656,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116086,425460671,14454158,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116087,425461918,14454059,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116088,425462652,14454258,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116089,425463349,14454756,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116090,425463547,14456533,4099383,1,'2010-03-11 19:08:58',3310501934,1),(664116091,425657374,14446366,4100909,1,'2010-03-11 22:03:01',3310501993,2),(664116093,425392324,14525241,4099383,1,'2010-03-11 19:08:58',3310491093,1),(664116094,425394232,14524723,4099383,1,'2010-03-11 19:08:58',3310491093,1),(664116095,425396375,14523927,4099383,1,'2010-03-11 19:08:58',3310491093,1),(664116096,425398224,14522931,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116097,425399956,14521815,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116098,425401306,14520899,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116099,425402803,14519664,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116100,425404271,14519066,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116101,425400132,14521437,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116102,425402444,14516805,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116103,425406179,14518508,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116104,425408322,14518628,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116105,425410406,14518748,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116106,425414134,14519265,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116107,425404902,14510780,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116108,425406920,14504206,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116109,425391489,14532737,4099383,1,'2010-03-11 19:08:58',3310491093,1),(664116110,425392364,14534814,4099383,1,'2010-03-11 19:08:58',3310491093,1),(664116111,425393457,14537486,4099383,1,'2010-03-11 19:08:58',3310491093,1),(664116112,425395207,14537486,4099383,1,'2010-03-11 19:08:58',3310491093,1),(664116113,425397831,14537486,4099383,1,'2010-03-11 19:08:58',3310502016,1),(664116114,425402861,14536298,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116115,425392414,14529768,4099383,1,'2010-03-11 19:08:59',3310491093,1),(664116116,425394615,14530328,4099383,1,'2010-03-11 19:08:59',3310491093,1),(664116117,425395716,14530328,4099383,1,'2010-03-11 19:08:59',3310491093,1),(664116118,425396358,14530640,4099383,1,'2010-03-11 19:08:59',3310491093,1),(664116119,425398973,14531138,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116120,425401128,14531822,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116121,425402412,14532134,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116122,425404339,14532694,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116123,425405486,14535111,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116124,425408766,14534814,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116125,425405669,14532881,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116126,425407412,14533503,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116127,425409659,14534250,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116128,425413578,14533924,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116129,425416639,14534221,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116130,425418360,14519863,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116131,425422587,14519983,4099383,1,'2010-03-11 19:08:59',3310502016,1),(664116132,425426990,14520381,4099383,1,'2010-03-11 19:08:59',3310502017,1),(664116133,425429074,14520222,4099383,1,'2010-03-11 19:08:59',3310502017,1),(664116134,425431716,14520381,4099383,1,'2010-03-11 19:08:59',3310502017,1),(664116135,425438509,14502461,4099383,1,'2010-03-11 19:08:59',3310502017,1),(664116136,425440258,14513146,4099383,1,'2010-03-11 19:08:59',3310502017,1),(664116137,425438946,14510178,4099383,1,'2010-03-11 19:08:59',3310502017,1),(664116138,425438727,14507210,4099383,1,'2010-03-11 19:08:59',3310502017,1),(664116139,425434328,14520660,4099383,1,'2010-03-11 19:08:59',3310502017,1),(664116140,425436500,14520779,4099383,1,'2010-03-11 19:08:59',3310502017,1),(664116141,425445506,14519083,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116142,425443757,14517895,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116143,425441570,14515818,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116144,425438819,14520859,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116145,425440022,14520939,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116146,425441431,14521457,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116147,425442429,14521974,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116148,425443574,14522453,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116149,425444924,14523010,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116150,425422763,14535111,4099383,1,'2010-03-11 19:09:00',3310502016,1),(664116151,425426043,14535111,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116152,425430198,14534814,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116153,425436322,14533033,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116154,425439821,14531549,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116155,425443320,14529768,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116156,425445725,14527987,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116157,425447037,14525019,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116158,425447037,14522941,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116159,425446163,14520864,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116160,425446157,14523010,4099383,1,'2010-03-11 19:09:00',3310502017,1),(664116161,425455811,14522224,4100909,1,'2010-03-11 22:03:01',3310502020,2),(664192679,425543688,14488592,4100909,1,'2010-03-11 22:02:58',3310501947,1),(664192680,425656069,14446851,4100909,1,'2010-03-11 22:03:01',3310501993,1),(664192681,425457689,14521505,4100909,1,'2010-03-11 22:03:01',3310502020,1),(664195007,425648101,14489414,4100978,1,'2010-03-11 22:09:38',3310501995,1),(664195008,425639202,14519398,4100978,1,'2010-03-11 22:09:38',3310502080,1),(664198471,425640150,14519681,4101078,1,'2010-03-11 22:19:38',3310502080,1),(664198472,425643874,14519400,4101078,1,'2010-03-11 22:19:38',3310502080,1),(664198473,425654425,14524550,4101078,1,'2010-03-11 22:19:38',3310502081,1),(664198474,425660907,14529700,4101078,1,'2010-03-11 22:19:38',3310502081,1),(664198475,425666286,14531854,4101078,1,'2010-03-11 22:19:38',3310502081,1),(664198476,425670010,14536067,4101078,1,'2010-03-11 22:19:38',3310502081,1),(664198477,425673803,14538689,4101078,1,'2010-03-11 22:19:38',3310502084,1),(664198478,425675734,14541124,4101078,1,'2010-03-11 22:19:38',3310502084,1),(664198479,425677803,14541124,4101078,1,'2010-03-11 22:19:38',3310502084,1),(664198480,425679596,14543558,4101078,1,'2010-03-11 22:19:38',3310502084,1),(664205614,425662626,14457254,4101245,1,'2010-03-11 22:37:03',3310501995,1),(664205619,425663057,14458955,4101245,1,'2010-03-11 22:37:03',3310501995,1),(664205621,425664749,14465627,4101245,1,'2010-03-11 22:37:04',3310501995,1),(664205624,425666771,14473605,4101245,1,'2010-03-11 22:37:04',3310501995,1),(664205627,425669107,14482818,4101245,1,'2010-03-11 22:37:04',3310501995,1),(664205630,425670324,14487619,4101245,1,'2010-03-11 22:37:04',3310501995,1),(664205633,425671576,14492558,4101245,1,'2010-03-11 22:37:04',3310501995,1),(664205635,425673227,14499071,4101245,1,'2010-03-11 22:37:04',3310501998,1),(664205638,425678833,14521188,4101245,1,'2010-03-11 22:37:04',3310502084,1),(664205641,425675883,14509549,4101245,1,'2010-03-11 22:37:04',3310502084,1),(664205644,425678218,14518759,4101245,1,'2010-03-11 22:37:04',3310502084,1),(664211795,425749986,14702011,4101313,1,'2010-03-11 22:45:09',3310502106,1),(664211796,425755003,14706072,4101313,1,'2010-03-11 22:45:09',3310502107,1),(664211797,425755099,14708038,4101313,1,'2010-03-11 22:45:09',3310502107,1),(664211798,425751240,14708038,4101313,1,'2010-03-11 22:45:10',3310502106,1),(664211799,425748828,14713409,4101313,1,'2010-03-11 22:45:10',3310502106,1),(664211800,425749311,14719436,4101313,1,'2010-03-11 22:45:10',3310502106,1),(664211801,425753459,14715112,4101313,1,'2010-03-11 22:45:10',3310502106,1),(664211802,425756450,14715636,4101313,1,'2010-03-11 22:45:10',3310502107,1),(664211803,425756353,14718257,4101313,1,'2010-03-11 22:45:10',3310502107,1),(664211804,425753749,14721794,4101313,1,'2010-03-11 22:45:10',3310502106,1),(664211805,425755196,14728738,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211806,425756836,14725593,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211807,425760309,14725855,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211808,425760791,14743673,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211809,425761370,14746031,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211810,425752832,14727558,4101313,1,'2010-03-11 22:45:10',3310502128,1),(664211811,425763010,14726772,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211812,425763107,14728476,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211813,425762335,14732406,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211814,425762721,14735419,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211815,425763589,14746162,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211816,425766387,14742625,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211817,425768606,14739088,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211818,425771789,14737646,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211819,425774201,14735288,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211820,425772368,14742494,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211821,425770728,14747472,4101313,1,'2010-03-11 22:45:10',3310502129,1),(664211822,425770728,14750224,4101313,1,'2010-03-11 22:45:11',3310502129,1),(664211823,425772947,14750093,4101313,1,'2010-03-11 22:45:11',3310502129,1),(664211824,425774008,14774723,4101313,1,'2010-03-11 22:45:11',3310502129,1),(664211825,425772465,14782846,4101313,1,'2010-03-11 22:45:11',3310502131,1),(664211826,425771596,14786121,4101313,1,'2010-03-11 22:45:11',3310502131,1),(664211827,425769469,14788897,4101313,1,'2010-03-11 22:45:11',3310502131,1),(664211828,425772217,14778554,4101313,1,'2010-03-11 22:45:11',3310502131,1),(664211829,425769381,14795777,4101313,1,'2010-03-11 22:45:11',3310502131,1),(664211830,425770645,14797452,4101313,1,'2010-03-11 22:45:11',3310502131,1),(664211831,425768481,14792062,4101313,1,'2010-03-11 22:45:11',3310502131,1),(664211832,425775745,14735550,4101313,1,'2010-03-11 22:45:11',3310502129,1),(664211833,425775648,14737384,4101313,1,'2010-03-11 22:45:11',3310502129,1),(664211834,425775166,14747341,4101313,1,'2010-03-11 22:45:11',3310502129,1),(664211835,425777288,14746031,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664211836,425779893,14743935,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664211837,425780858,14745114,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664211838,425779411,14748651,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664211839,425777964,14752582,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664211840,425775745,14757298,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664211841,425776131,14759394,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664211842,425778639,14757167,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664211843,425780761,14754285,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664211844,425783559,14751796,4101313,1,'2010-03-11 22:45:12',3310502132,1),(664211845,425784427,14752975,4101313,1,'2010-03-11 22:45:12',3310502132,1),(664211846,425781919,14760180,4101313,1,'2010-03-11 22:45:12',3310502132,1),(664211847,425780279,14761884,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664211848,425778542,14768827,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664211849,425775938,14773151,4101313,1,'2010-03-11 22:45:12',3310502129,1),(664225476,425736171,14718541,4101446,1,'2010-03-11 22:58:45',3310502106,1),(664225514,425734239,14713759,4101446,1,'2010-03-11 22:58:46',3310502106,1),(664225516,425745932,14742710,4101446,1,'2010-03-11 22:58:46',3310502128,1),(664225519,425740295,14728752,4101446,1,'2010-03-11 22:58:46',3310502128,1),(664225521,425756921,14769918,4101446,1,'2010-03-11 22:58:46',3310502129,1),(664225523,425752472,14758902,4101446,1,'2010-03-11 22:58:46',3310502128,1),(664225525,425749404,14751305,4101446,1,'2010-03-11 22:58:46',3310502128,1),(664225527,425764772,14789356,4101446,1,'2010-03-11 22:58:46',3310502131,1),(664225529,425761732,14781829,4101446,1,'2010-03-11 22:58:46',3310502131,1),(664225531,425767964,14797258,4101446,1,'2010-03-11 22:58:46',3310502131,1),(664236924,425728306,14660994,4101592,1,'2010-03-11 23:12:19',3310502104,1),(664236925,425732739,14671625,4101592,1,'2010-03-11 23:12:19',3310502106,1),(664236926,425740416,14690035,4101592,1,'2010-03-11 23:12:19',3310502106,1),(664236927,425737512,14683069,4101592,1,'2010-03-11 23:12:19',3310502106,1),(664236928,425743704,14697918,4101592,1,'2010-03-11 23:12:19',3310502106,1),(664559648,425389200,16613475,4106774,1,'2010-03-12 16:30:45',3310493181,1),(664559649,425389697,16615364,4106774,1,'2010-03-12 16:30:45',3310493181,1),(664559650,425383037,16753500,4106774,1,'2010-03-12 16:30:45',3310493525,1),(664559651,425500356,16146954,4106774,1,'2010-03-12 16:30:45',3310503975,1),(664559652,425497971,16145875,4106774,1,'2010-03-12 16:30:46',3310503975,1),(664559653,425496858,16144795,4106774,1,'2010-03-12 16:30:46',3310503975,1),(664559654,425496381,16143285,4106774,1,'2010-03-12 16:30:46',3310503975,1),(664559655,425496858,16141234,4106774,1,'2010-03-12 16:30:46',3310503975,1),(664559656,425498448,16139507,4106774,1,'2010-03-12 16:30:46',3310503975,1),(664559657,425458855,16172962,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559658,425459014,16169833,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559659,425458616,16167782,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559660,425457980,16164437,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559661,425458775,16161955,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559662,425459968,16159472,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559663,425461399,16158285,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559664,425462512,16158285,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559665,425465613,16160228,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559666,425469191,16162386,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559667,425471496,16163789,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559668,425465056,16204043,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559669,425463307,16199402,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559670,425462274,16194330,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559671,425461001,16188718,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559672,425459491,16179545,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559673,425473802,16164437,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559674,425475472,16164868,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559675,425477539,16167135,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559676,425478493,16169401,4106774,1,'2010-03-12 16:30:46',3310503980,1),(664559677,425480560,16171451,4106774,1,'2010-03-12 16:30:47',3310503981,1),(664559678,425482229,16171991,4106774,1,'2010-03-12 16:30:47',3310503981,1),(664559679,425484138,16171559,4106774,1,'2010-03-12 16:30:47',3310503981,1),(664559680,425486761,16169725,4106774,1,'2010-03-12 16:30:47',3310503981,1),(664559681,425488828,16167782,4106774,1,'2010-03-12 16:30:47',3310503981,1),(664559682,425490418,16165408,4106774,1,'2010-03-12 16:30:47',3310503981,1),(664559683,425493678,16158609,4106774,1,'2010-03-12 16:30:47',3310503981,1),(664559684,425495109,16155911,4106774,1,'2010-03-12 16:30:47',3310503981,1),(664559685,425497574,16153645,4106774,1,'2010-03-12 16:30:47',3310503981,1),(664559686,425499800,16151163,4106774,1,'2010-03-12 16:30:47',3310503981,1),(664559687,425492114,16161756,4106774,1,'2010-03-12 16:30:47',3310503981,1),(664559688,425471417,16210950,4106774,1,'2010-03-12 16:30:47',3310503982,1),(664559689,425467680,16207928,4106774,1,'2010-03-12 16:30:47',3310503982,1),(664559690,425497574,16238577,4106774,1,'2010-03-12 16:30:47',3310503983,1),(664559691,425493758,16233181,4106774,1,'2010-03-12 16:30:47',3310503983,1),(664559692,425491134,16229727,4106774,1,'2010-03-12 16:30:47',3310503983,1),(664559693,425487795,16226274,4106774,1,'2010-03-12 16:30:47',3310503983,1),(664559694,425484615,16223468,4106774,1,'2010-03-12 16:30:47',3310503983,1),(664559695,425481673,16220338,4106774,1,'2010-03-12 16:30:47',3310503983,1),(664559696,425478334,16217101,4106774,1,'2010-03-12 16:30:47',3310503982,1),(664559697,425474756,16214187,4106774,1,'2010-03-12 16:30:47',3310503982,1),(664559698,425501151,16149544,4106774,1,'2010-03-12 16:30:47',3310503975,1),(664559699,425501231,16148357,4106774,1,'2010-03-12 16:30:47',3310503975,1),(664559700,425500992,16147601,4106774,1,'2010-03-12 16:30:47',3310503975,1),(664559701,425500515,16137889,4106774,1,'2010-03-12 16:30:47',3310503975,1),(664559702,425504570,16135622,4106774,1,'2010-03-12 16:30:47',3310503975,1),(664559703,425507909,16134651,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559704,425511407,16134651,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559705,425513394,16134867,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559706,425514189,16135083,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559707,425515859,16135083,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559708,425517528,16134543,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559709,425519675,16134543,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559710,425521503,16134651,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559711,425523968,16135514,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559712,425525319,16136594,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559713,425526591,16136162,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559714,425528658,16134867,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559715,425530566,16133140,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559716,425532156,16131090,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559717,425533349,16129363,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559718,425533985,16128824,4106774,1,'2010-03-12 16:30:47',3310503986,1),(664559719,425532539,16135988,4106774,1,'2010-03-12 16:30:48',3310503986,1),(664559720,425532234,16133778,4106774,1,'2010-03-12 16:30:48',3310503986,1),(664559721,425533150,16132604,4106774,1,'2010-03-12 16:30:48',3310503986,1),(664559722,425533913,16131913,4106774,1,'2010-03-12 16:30:48',3310503986,1),(664559723,425535970,16132907,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559724,425535549,16132750,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559725,425534939,16128284,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559726,425535734,16128716,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559727,425536290,16129147,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559728,425536449,16130226,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559729,425537678,16132189,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559730,425535693,16131499,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559731,425532941,16149106,4106774,1,'2010-03-12 16:30:48',3310503986,1),(664559732,425532941,16144890,4106774,1,'2010-03-12 16:30:48',3310503986,1),(664559733,425533313,16141349,4106774,1,'2010-03-12 16:30:48',3310503986,1),(664559734,425534059,16137471,4106774,1,'2010-03-12 16:30:48',3310503986,1),(664559735,425533506,16138060,4106774,1,'2010-03-12 16:30:48',3310503986,1),(664559736,425539611,16148351,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559737,425538187,16145934,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559738,425536813,16143309,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559739,425534879,16140546,4106774,1,'2010-03-12 16:30:48',3310503987,1),(664559740,425535425,16174062,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559741,425535798,16167486,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559742,425536170,16162933,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559743,425536170,16158212,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559744,425535177,16155682,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559745,425533935,16151973,4106774,1,'2010-03-12 16:30:48',3310503992,1),(664559746,425541392,16150976,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559747,425555078,16159126,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559748,425555231,16160921,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559749,425553908,16161474,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559750,425552432,16161474,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559751,425550295,16161198,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559752,425549125,16160300,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559753,425547904,16159402,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559754,425546581,16157537,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559755,425545004,16155672,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559756,425543122,16153117,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559757,425534431,16199018,4106774,1,'2010-03-12 16:30:48',3310503992,1),(664559758,425532941,16196489,4106774,1,'2010-03-12 16:30:48',3310503992,1),(664559759,425533562,16189744,4106774,1,'2010-03-12 16:30:48',3310503992,1),(664559760,425535052,16186034,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559761,425535798,16182999,4106774,1,'2010-03-12 16:30:48',3310503993,1),(664559762,425535798,16178952,4106774,1,'2010-03-12 16:30:49',3310503993,1),(664559763,425537583,16203783,4106774,1,'2010-03-12 16:30:49',3310503993,1),(664559764,425532526,16192560,4106774,1,'2010-03-12 16:30:49',3310503992,1),(664559765,425532471,16195866,4106774,1,'2010-03-12 16:30:49',3310503992,1),(664559766,425523003,16255676,4106774,1,'2010-03-12 16:30:49',3310503994,1),(664559767,425524618,16246739,4106774,1,'2010-03-12 16:30:49',3310503994,1),(664559768,425526357,16241511,4106774,1,'2010-03-12 16:30:49',3310503994,1),(664559769,425508227,16257247,4106774,1,'2010-03-12 16:30:49',3310503994,1),(664559770,425504649,16250987,4106774,1,'2010-03-12 16:30:49',3310503983,1),(664559771,425500595,16243325,4106774,1,'2010-03-12 16:30:49',3310503983,1),(664559772,425529835,16236453,4106774,1,'2010-03-12 16:30:49',3310503994,1),(664559773,425534183,16231057,4106774,1,'2010-03-12 16:30:49',3310503994,1),(664559774,425536791,16225661,4106774,1,'2010-03-12 16:30:49',3310503995,1),(664559775,425538406,16219759,4106774,1,'2010-03-12 16:30:49',3310503995,1),(664559776,425538779,16212339,4106774,1,'2010-03-12 16:30:49',3310503995,1),(664559777,425537909,16206269,4106774,1,'2010-03-12 16:30:49',3310503995,1),(664559778,425492253,16463604,4106774,1,'2010-03-12 16:30:49',3310504079,1),(664559779,425490381,16464377,4106774,1,'2010-03-12 16:30:49',3310504079,1),(664559780,425492742,16459073,4106774,1,'2010-03-12 16:30:49',3310504079,1),(664559781,425496242,16454100,4106774,1,'2010-03-12 16:30:49',3310504079,1),(664559782,425494873,16464595,4106774,1,'2010-03-12 16:30:49',3310504079,1),(664559783,425496256,16461906,4108069,1,'2010-03-12 19:04:13',3310504079,2),(664559784,425499246,16456366,4106774,1,'2010-03-12 16:30:49',3310504079,1),(664559785,425491494,16467833,4106774,1,'2010-03-12 16:30:49',3310504079,1),(664559786,425491296,16469586,4106774,1,'2010-03-12 16:30:49',3310504079,1),(664559787,425489541,16476284,4106774,1,'2010-03-12 16:30:49',3310504079,1),(664559788,425495171,16467428,4106774,1,'2010-03-12 16:30:49',3310504079,1),(664559789,425497656,16466619,4106774,1,'2010-03-12 16:30:50',3310504079,1),(664559790,425498948,16467563,4106774,1,'2010-03-12 16:30:50',3310504079,1),(664559791,425514110,16268794,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559792,425512202,16265448,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559793,425510850,16262211,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559794,425526567,16280712,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559795,425528709,16286162,4133447,1,'2010-03-15 12:47:10',3310504080,2),(664559796,425526088,16284818,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559797,425520892,16276247,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559798,425521513,16266805,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559799,425526114,16283255,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559800,425523968,16280665,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559801,425521583,16277751,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559802,425519277,16275701,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559803,425516336,16273111,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559804,425527870,16312513,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559805,425527870,16309543,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559806,425527838,16307704,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559807,425527827,16305488,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559808,425527699,16302562,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559809,425527550,16298868,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559810,425527369,16294972,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559811,425526899,16290713,4106774,1,'2010-03-12 16:30:50',3310504080,1),(664559812,425527666,16330386,4106774,1,'2010-03-12 16:30:50',3310504082,1),(664559813,425527585,16321655,4106774,1,'2010-03-12 16:30:50',3310504082,1),(664559814,425527788,16315301,4106774,1,'2010-03-12 16:30:50',3310504082,1),(664559815,425528602,16366632,4106774,1,'2010-03-12 16:30:50',3310504082,1),(664559816,425528236,16351327,4106774,1,'2010-03-12 16:30:50',3310504082,1),(664559817,425519607,16420837,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559818,425521723,16416859,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559819,425523026,16414759,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559820,425525428,16411665,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559821,425527178,16409123,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559822,425525580,16422507,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559823,425527866,16419674,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559824,425528440,16379783,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559825,425528562,16376081,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559826,425529823,16378291,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559827,425529864,16394978,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559828,425529661,16392989,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559829,425530068,16391828,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559830,425531085,16390723,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559831,425532103,16390337,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559832,425533243,16390226,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559833,425530678,16390723,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559834,425529661,16387077,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559835,425529132,16383430,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559836,425534425,16392425,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559837,425533630,16391885,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559838,425533033,16390806,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559839,425533033,16388782,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559840,425533630,16387029,4106774,1,'2010-03-12 16:30:51',3310504088,1),(664559841,425537306,16395662,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559842,425535716,16393774,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559843,425535120,16386624,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559844,425537704,16385949,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559845,425539791,16385815,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559846,425540784,16384600,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559847,425534822,16389727,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559848,425539592,16389592,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559849,425541977,16381633,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559850,425543964,16378395,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559851,425545753,16377451,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559852,425547244,16377451,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559853,425548237,16378125,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559854,425548933,16379205,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559855,425548933,16380554,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559856,425548833,16382307,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559857,425543368,16389187,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559858,425545852,16389592,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559859,425548833,16384061,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559860,425549132,16386489,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559861,425550125,16388108,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559862,425552113,16390671,4106774,1,'2010-03-12 16:30:51',3310504089,1),(664559863,425549728,16390401,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559864,425554994,16390671,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559865,425548933,16393369,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559866,425537394,16398569,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559867,425528317,16407134,4106774,1,'2010-03-12 16:30:52',3310504088,1),(664559868,425528969,16404979,4106774,1,'2010-03-12 16:30:52',3310504088,1),(664559869,425529661,16401608,4106774,1,'2010-03-12 16:30:52',3310504088,1),(664559870,425529742,16397962,4106774,1,'2010-03-12 16:30:52',3310504088,1),(664559871,425530052,16416436,4106774,1,'2010-03-12 16:30:52',3310504088,1),(664559872,425532139,16412390,4106774,1,'2010-03-12 16:30:52',3310504088,1),(664559873,425534822,16407128,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559874,425536810,16402947,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559875,425537704,16402002,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559876,425538400,16400114,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559877,425538400,16399035,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559878,425538002,16397146,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559879,425537803,16408612,4106774,1,'2010-03-12 16:30:52',3310504089,1);
INSERT INTO `nodes` VALUES (664559880,425501453,16446364,4106774,1,'2010-03-12 16:30:52',3310504079,1),(664559881,425504180,16442055,4106774,1,'2010-03-12 16:30:52',3310504079,1),(664559882,425506948,16438739,4106774,1,'2010-03-12 16:30:52',3310504079,1),(664559883,425509268,16436529,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559884,425510896,16433601,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559885,425512809,16430562,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559886,425504513,16449352,4106774,1,'2010-03-12 16:30:52',3310504079,1),(664559887,425511370,16440583,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559888,425515414,16427136,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559889,425518724,16430736,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559890,425522897,16425475,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559891,425500836,16470800,4106774,1,'2010-03-12 16:30:52',3310504079,1),(664559892,425503420,16474173,4106774,1,'2010-03-12 16:30:52',3310504079,1),(664559893,425506004,16477276,4106774,1,'2010-03-12 16:30:52',3310504079,1),(664559894,425507594,16478759,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559895,425509184,16478759,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559896,425515941,16477006,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559897,425521506,16474847,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559898,425525282,16474038,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559899,425530549,16473768,4106774,1,'2010-03-12 16:30:52',3310504090,1),(664559900,425538201,16473363,4106774,1,'2010-03-12 16:30:52',3310504091,1),(664559901,425544759,16472149,4106774,1,'2010-03-12 16:30:52',3310504091,1),(664559902,425549330,16470396,4106774,1,'2010-03-12 16:30:52',3310504091,1),(664559903,425553206,16468102,4106774,1,'2010-03-12 16:30:52',3310504091,1),(664559904,425555988,16392290,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559905,425559367,16394853,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559906,425563143,16396472,4106774,1,'2010-03-12 16:30:52',3310504092,1),(664559911,425560758,16389727,4106774,1,'2010-03-12 16:30:52',3310504089,1),(664559913,425566620,16387433,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559915,425572384,16385140,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559917,425579737,16382982,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559919,425566521,16398900,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559921,425565825,16401058,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559923,425570694,16400788,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559925,425573179,16402542,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559927,425575166,16405105,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559929,425577253,16407398,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559931,425574868,16407938,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559933,425582519,16408208,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559935,425587487,16382982,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559937,425594542,16384196,4106774,1,'2010-03-12 16:30:53',3310504093,1),(664559939,425600305,16385005,4106774,1,'2010-03-12 16:30:53',3310504093,1),(664559941,425607757,16387433,4106774,1,'2010-03-12 16:30:53',3310504093,1),(664559943,425589077,16414683,4106774,1,'2010-03-12 16:30:53',3310504092,1),(664559945,425597722,16422912,4106774,1,'2010-03-12 16:30:53',3310504093,1),(664559947,425557578,16464325,4106774,1,'2010-03-12 16:30:53',3310504091,1),(664559949,425563043,16459199,4106774,1,'2010-03-12 16:30:53',3310504094,1),(664559951,425569005,16453129,4106774,1,'2010-03-12 16:30:53',3310504094,1),(664559953,425573278,16447058,4106774,1,'2010-03-12 16:30:53',3310504094,1),(664559955,425578147,16441662,4106774,1,'2010-03-12 16:30:54',3310504094,1),(664559957,425581227,16439099,4106774,1,'2010-03-12 16:30:54',3310504094,1),(664559959,425602590,16428173,4106774,1,'2010-03-12 16:30:54',3310504095,1),(664559961,425599411,16443551,4106774,1,'2010-03-12 16:30:54',3310504095,1),(664559963,425586494,16436536,4106774,1,'2010-03-12 16:30:54',3310504094,1),(664559965,425590965,16435052,4106774,1,'2010-03-12 16:30:54',3310504095,1),(664559966,425593350,16435052,4106774,1,'2010-03-12 16:30:54',3310504095,1),(664559968,425595635,16433703,4106774,1,'2010-03-12 16:30:54',3310504095,1),(664559969,425601100,16429791,4106774,1,'2010-03-12 16:30:54',3310504095,1),(664559970,425602888,16428847,4106774,1,'2010-03-12 16:30:54',3310504095,1),(664559971,425436734,16560373,4106774,1,'2010-03-12 16:30:54',3310504099,1),(664559972,425443989,16578854,4106774,1,'2010-03-12 16:30:54',3310504099,1),(664559973,425442697,16575616,4106774,1,'2010-03-12 16:30:54',3310504099,1),(664559974,425441107,16572514,4106774,1,'2010-03-12 16:30:54',3310504099,1),(664559975,425438821,16567387,4106774,1,'2010-03-12 16:30:54',3310504099,1),(664559976,425437827,16563610,4106774,1,'2010-03-12 16:30:54',3310504099,1),(664559977,425437430,16559429,4106774,1,'2010-03-12 16:30:54',3310504099,1),(664559978,425485725,16506933,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559979,425489541,16482219,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559980,425489541,16486860,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559981,425489780,16491500,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559982,425490336,16495277,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559983,425490257,16496788,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559984,425489780,16498623,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559985,425488667,16501105,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559986,425487156,16503911,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559987,425484691,16510926,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559988,425484771,16514703,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559989,425485248,16517401,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559990,425486679,16521070,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559991,425489144,16526358,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559992,425491290,16531430,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559993,425500115,16514379,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559994,425498127,16514919,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559995,425497014,16515782,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559996,425495981,16517293,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559997,425495822,16519235,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559998,425495981,16521286,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664559999,425497094,16523984,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664560000,425499559,16528948,4106774,1,'2010-03-12 16:30:54',3310504101,1),(664560001,425445679,16585734,4106774,1,'2010-03-12 16:30:54',3310504099,1),(664560002,425500041,16589241,4106774,1,'2010-03-12 16:30:54',3310504103,1),(664560003,425493119,16535747,4106774,1,'2010-03-12 16:30:54',3310504103,1),(664560004,425495106,16542546,4106774,1,'2010-03-12 16:30:54',3310504103,1),(664560005,425497650,16548158,4106774,1,'2010-03-12 16:30:54',3310504103,1),(664560006,425492960,16534884,4106774,1,'2010-03-12 16:30:54',3310504103,1),(664560007,425497253,16543625,4106774,1,'2010-03-12 16:30:55',3310504103,1),(664560008,425429081,16605024,4106774,1,'2010-03-12 16:30:55',3310504105,1),(664560009,425423490,16606056,4106774,1,'2010-03-12 16:30:55',3310504104,1),(664560010,425417353,16675846,4106774,1,'2010-03-12 16:30:55',3310504106,1),(664560011,425416061,16681646,4106774,1,'2010-03-12 16:30:55',3310504106,1),(664560012,425415266,16692573,4106774,1,'2010-03-12 16:30:55',3310504106,1),(664560013,425428584,16656555,4106774,1,'2010-03-12 16:30:55',3310504107,1),(664560014,425425702,16659253,4106774,1,'2010-03-12 16:30:55',3310504107,1),(664560015,425424310,16662760,4106774,1,'2010-03-12 16:30:55',3310504106,1),(664560016,425422820,16666538,4106774,1,'2010-03-12 16:30:55',3310504106,1),(664560017,425420434,16669910,4106774,1,'2010-03-12 16:30:55',3310504106,1),(664560018,425442101,16645898,4106774,1,'2010-03-12 16:30:55',3310504107,1),(664560019,425435641,16650620,4106774,1,'2010-03-12 16:30:55',3310504107,1),(664560020,425445083,16647922,4106774,1,'2010-03-12 16:30:55',3310504107,1),(664560021,425444983,16656285,4106774,1,'2010-03-12 16:30:55',3310504107,1),(664560022,425442399,16663030,4106774,1,'2010-03-12 16:30:55',3310504107,1),(664560023,425441405,16667752,4106774,1,'2010-03-12 16:30:55',3310504107,1),(664560024,425434547,16680297,4106774,1,'2010-03-12 16:30:55',3310504107,1),(664560025,425442101,16673687,4106774,1,'2010-03-12 16:30:55',3310504107,1),(664560026,425454127,16605159,4106774,1,'2010-03-12 16:30:55',3310504108,1),(664560027,425447269,16603945,4106774,1,'2010-03-12 16:30:55',3310504105,1),(664560028,425448760,16604350,4106774,1,'2010-03-12 16:30:55',3310504105,1),(664560029,425450251,16604350,4106774,1,'2010-03-12 16:30:55',3310504105,1),(664560030,425451046,16602461,4106774,1,'2010-03-12 16:30:55',3310504105,1),(664560031,425451145,16600707,4106774,1,'2010-03-12 16:30:55',3310504105,1),(664560032,425450052,16599223,4106774,1,'2010-03-12 16:30:55',3310504105,1),(664560033,425448660,16596256,4106774,1,'2010-03-12 16:30:55',3310504105,1),(664560034,425447170,16591264,4106774,1,'2010-03-12 16:30:55',3310504105,1),(664560035,425466152,16597065,4106774,1,'2010-03-12 16:30:55',3310504108,1),(664560036,425466053,16600977,4106774,1,'2010-03-12 16:30:55',3310504108,1),(664560037,425467245,16604484,4106774,1,'2010-03-12 16:30:55',3310504108,1),(664560038,425471121,16611364,4106774,1,'2010-03-12 16:30:55',3310504108,1),(664560039,425445679,16636051,4106774,1,'2010-03-12 16:30:55',3310504105,1),(664560040,425474500,16617974,4106774,1,'2010-03-12 16:30:55',3310504108,1),(664560041,425477581,16626878,4106774,1,'2010-03-12 16:30:55',3310504108,1),(664560043,425481954,16638074,4106774,1,'2010-03-12 16:30:55',3310504109,1),(664560044,425488215,16638479,4106774,1,'2010-03-12 16:30:55',3310504109,1),(664560045,425490202,16628496,4106774,1,'2010-03-12 16:30:55',3310504109,1),(664560046,425491991,16618649,4106774,1,'2010-03-12 16:30:55',3310504109,1),(664560047,425491991,16613388,4106774,1,'2010-03-12 16:30:55',3310504109,1),(664560048,425491892,16607048,4106774,1,'2010-03-12 16:30:56',3310504109,1),(664560049,425491395,16602461,4106774,1,'2010-03-12 16:30:56',3310504109,1),(664560050,425492091,16599898,4106774,1,'2010-03-12 16:30:56',3310504109,1),(664560051,425493681,16597874,4106774,1,'2010-03-12 16:30:56',3310504109,1),(664560052,425496265,16596525,4106774,1,'2010-03-12 16:30:56',3310504109,1),(664560053,425497855,16593018,4106774,1,'2010-03-12 16:30:56',3310504109,1),(664560054,425445579,16652373,4106774,1,'2010-03-12 16:30:56',3310504107,1),(664560055,425447070,16688931,4106774,1,'2010-03-12 16:30:56',3310504107,1),(664560056,425484438,16646573,4106774,1,'2010-03-12 16:30:56',3310504111,1),(664560057,425485730,16649945,4106774,1,'2010-03-12 16:30:56',3310504111,1),(664560058,425486625,16650080,4106774,1,'2010-03-12 16:30:56',3310504111,1),(664560059,425486202,16650168,4106774,1,'2010-03-12 16:30:56',3310504111,1),(664560060,425487519,16649406,4106774,1,'2010-03-12 16:30:56',3310504111,1),(664560061,425487320,16647112,4106774,1,'2010-03-12 16:30:56',3310504111,1),(664560062,425487693,16654484,4106774,1,'2010-03-12 16:30:56',3310504111,1),(664560063,425488686,16659206,4106774,1,'2010-03-12 16:30:56',3310504111,1),(664560064,425490475,16665681,4106774,1,'2010-03-12 16:30:56',3310504111,1),(664560065,425493655,16671616,4106774,1,'2010-03-12 16:30:56',3310504111,1),(664560066,425488488,16659745,4106774,1,'2010-03-12 16:30:56',3310504111,1),(664560067,425488190,16662173,4106774,1,'2010-03-12 16:30:57',3310504111,1),(664560068,425487891,16668649,4106774,1,'2010-03-12 16:30:57',3310504111,1),(664560069,425499718,16680250,4106774,1,'2010-03-12 16:30:57',3310504111,1),(664560070,425487792,16673235,4106774,1,'2010-03-12 16:30:57',3310504111,1),(664560071,425488190,16676608,4106774,1,'2010-03-12 16:30:57',3310504111,1),(664560072,425489084,16679440,4106774,1,'2010-03-12 16:30:57',3310504111,1),(664560073,425490972,16682408,4106774,1,'2010-03-12 16:30:57',3310504111,1),(664560074,425492761,16685646,4106774,1,'2010-03-12 16:30:57',3310504111,1),(664560075,425494450,16689153,4106774,1,'2010-03-12 16:30:57',3310504111,1),(664560076,425495444,16694279,4106774,1,'2010-03-12 16:30:57',3310504111,1),(664560077,425503320,16482267,4106774,1,'2010-03-12 16:30:57',3310504101,1),(664560078,425509879,16488337,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560079,425517034,16492519,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560080,425523692,16494947,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560081,425512676,16519775,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560082,425510053,16518156,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560083,425507747,16516537,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560085,425505203,16515134,4106774,1,'2010-03-12 16:30:57',3310504101,1),(664560086,425502818,16514595,4106774,1,'2010-03-12 16:30:57',3310504101,1),(664560087,425502898,16533373,4106774,1,'2010-03-12 16:30:57',3310504101,1),(664560089,425516651,16519127,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560091,425516969,16520962,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560093,425516890,16522149,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560095,425516651,16522473,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560097,425515856,16522689,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560099,425514982,16521718,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560101,425530350,16495757,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560103,425529754,16495487,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560105,425529853,16500478,4106774,1,'2010-03-12 16:30:57',3310504112,1),(664560107,425541579,16504255,4106774,1,'2010-03-12 16:30:57',3310504113,1),(664560109,425538896,16503716,4106774,1,'2010-03-12 16:30:57',3310504113,1),(664560112,425537803,16503716,4106774,1,'2010-03-12 16:30:57',3310504113,1),(664560114,425537803,16504795,4106774,1,'2010-03-12 16:30:57',3310504113,1),(664560116,425545057,16497106,4106774,1,'2010-03-12 16:30:57',3310504113,1),(664560118,425549927,16497645,4106774,1,'2010-03-12 16:30:57',3310504113,1),(664560121,425549927,16501692,4106774,1,'2010-03-12 16:30:57',3310504113,1),(664560123,425548933,16505469,4106774,1,'2010-03-12 16:30:57',3310504113,1),(664560125,425546846,16505469,4106774,1,'2010-03-12 16:30:58',3310504113,1),(664560127,425544163,16505199,4106774,1,'2010-03-12 16:30:58',3310504113,1),(664560129,425531642,16510056,4106774,1,'2010-03-12 16:30:58',3310504112,1),(664560132,425534127,16517205,4106774,1,'2010-03-12 16:30:58',3310504112,1),(664560134,425537008,16524355,4106774,1,'2010-03-12 16:30:58',3310504113,1),(664560135,425541281,16531774,4106774,1,'2010-03-12 16:30:58',3310504113,1),(664560137,425539095,16508032,4106774,1,'2010-03-12 16:30:58',3310504113,1),(664560140,425545057,16516261,4106774,1,'2010-03-12 16:30:58',3310504113,1),(664560142,425553802,16525164,4106774,1,'2010-03-12 16:30:58',3310504113,1),(664560143,425502818,16557331,4106774,1,'2010-03-12 16:30:58',3310504103,1),(664560145,425500672,16549021,4106774,1,'2010-03-12 16:30:58',3310504103,1),(664560147,425503375,16553014,4106774,1,'2010-03-12 16:30:58',3310504103,1),(664560149,425507191,16557762,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560150,425510848,16561432,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560151,425507032,16537905,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560152,425510291,16541035,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560153,425512199,16542546,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560154,425517049,16544812,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560155,425521262,16546755,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560156,425525476,16548158,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560157,425503221,16587487,4106774,1,'2010-03-12 16:30:58',3310504103,1),(664560158,425506302,16587218,4106774,1,'2010-03-12 16:30:58',3310504103,1),(664560159,425510774,16588836,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560160,425509178,16568015,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560161,425513948,16564453,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560162,425517526,16580749,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560163,425521978,16587979,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560164,425516413,16568662,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560165,425519513,16573842,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560166,425521739,16578483,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560167,425524045,16584526,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560168,425528497,16549884,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560169,425530166,16552043,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560170,425531915,16556575,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560171,425534062,16563050,4106774,1,'2010-03-12 16:30:58',3310504114,1),(664560172,425534618,16568446,4106774,1,'2010-03-12 16:30:58',3310504115,1),(664560173,425536367,16573734,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560174,425537957,16578267,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560175,425538434,16580749,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560177,425538752,16584526,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560178,425538752,16587332,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560179,425555049,16564453,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560180,425552584,16566504,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560182,425550040,16569418,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560183,425547974,16574166,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560185,425546304,16577943,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560186,425546145,16583447,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560187,425555889,16493598,4106774,1,'2010-03-12 16:30:59',3310504113,1),(664560188,425558671,16530021,4106774,1,'2010-03-12 16:30:59',3310504113,1),(664560189,425560360,16531639,4106774,1,'2010-03-12 16:30:59',3310504113,1),(664560190,425561255,16533528,4106774,1,'2010-03-12 16:30:59',3310504113,1),(664560191,425561155,16537305,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560192,425561255,16540273,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560193,425564191,16545460,4106774,1,'2010-03-12 16:30:59',3310504118,1),(664560194,425563316,16551611,4106774,1,'2010-03-12 16:30:59',3310504118,1),(664560195,425562362,16558194,4106774,1,'2010-03-12 16:30:59',3310504118,1),(664560196,425561170,16560352,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560197,425557819,16538501,4108069,1,'2010-03-12 19:04:14',3310504115,2),(664560198,425557751,16563266,4106774,1,'2010-03-12 16:30:59',3310504115,1),(664560199,425564508,16583447,4106774,1,'2010-03-12 16:30:59',3310504118,1),(664560200,425572082,16575010,4107810,1,'2010-03-12 18:34:26',3310504118,2),(664560202,425513854,16591534,4106774,1,'2010-03-12 16:30:59',3310504120,1),(664560203,425517332,16594637,4106774,1,'2010-03-12 16:30:59',3310504120,1),(664560204,425520810,16596256,4106774,1,'2010-03-12 16:30:59',3310504120,1),(664560205,425523792,16599223,4106774,1,'2010-03-12 16:30:59',3310504120,1),(664560206,425524760,16592728,4106774,1,'2010-03-12 16:30:59',3310504120,1),(664560207,425526907,16597260,4106774,1,'2010-03-12 16:30:59',3310504120,1),(664560208,425526430,16591972,4106774,1,'2010-03-12 16:30:59',3310504120,1),(664560209,425528894,16600606,4106774,1,'2010-03-12 16:30:59',3310504120,1),(664560210,425533744,16600282,4106774,1,'2010-03-12 16:31:00',3310504120,1),(664560211,425538434,16590246,4106774,1,'2010-03-12 16:31:00',3310504121,1),(664560212,425537162,16593267,4106774,1,'2010-03-12 16:31:00',3310504121,1),(664560213,425535095,16596181,4106774,1,'2010-03-12 16:31:00',3310504121,1),(664560214,425527965,16604754,4106774,1,'2010-03-12 16:31:00',3310504120,1),(664560215,425530450,16613792,4106774,1,'2010-03-12 16:31:00',3310504120,1),(664560216,425528894,16603628,4106774,1,'2010-03-12 16:31:00',3310504120,1),(664560217,425532392,16613664,4106774,1,'2010-03-12 16:31:00',3310504120,1),(664560218,425531597,16608592,4106774,1,'2010-03-12 16:31:00',3310504120,1),(664560219,425533346,16613125,4106774,1,'2010-03-12 16:31:00',3310504120,1),(664560220,425532869,16603304,4106774,1,'2010-03-12 16:31:00',3310504120,1),(664560221,425532233,16605678,4106774,1,'2010-03-12 16:31:00',3310504120,1),(664560222,425532392,16608484,4106774,1,'2010-03-12 16:31:00',3310504120,1),(664560223,425533108,16611722,4106774,1,'2010-03-12 16:31:00',3310504120,1),(664560224,425540978,16611398,4106774,1,'2010-03-12 16:31:00',3310504121,1),(664560225,425538752,16616470,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560226,425545748,16590246,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560227,425545430,16595102,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560228,425544714,16601361,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560229,425543045,16605894,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560230,425554254,16601685,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560231,425534524,16626338,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560232,425534062,16618952,4106774,1,'2010-03-12 16:31:01',3310504120,1),(664560233,425534062,16630176,4106774,1,'2010-03-12 16:31:01',3310504120,1),(664560234,425534300,16617010,4106774,1,'2010-03-12 16:31:01',3310504120,1),(664560235,425535413,16623269,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560236,425535969,16625319,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560237,425535731,16626830,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560238,425535095,16628125,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560239,425536446,16622837,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560240,425536844,16623701,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560241,425535345,16625581,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560242,425533664,16633089,4106774,1,'2010-03-12 16:31:01',3310504120,1),(664560243,425534698,16636219,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560244,425537162,16642694,4106774,1,'2010-03-12 16:31:01',3310504121,1),(664560245,425508463,16691042,4106774,1,'2010-03-12 16:31:01',3310504122,1),(664560246,425540898,16651328,4106774,1,'2010-03-12 16:31:01',3310504123,1),(664560247,425543919,16658450,4106774,1,'2010-03-12 16:31:01',3310504123,1),(664560248,425545748,16664710,4106774,1,'2010-03-12 16:31:01',3310504123,1),(664560249,425547179,16673451,4106774,1,'2010-03-12 16:31:01',3310504123,1),(664560250,425548133,16679818,4106774,1,'2010-03-12 16:31:01',3310504123,1),(664560251,425550040,16686941,4106774,1,'2010-03-12 16:31:01',3310504123,1),(664560252,425552823,16695358,4106774,1,'2010-03-12 16:31:01',3310504123,1),(664560253,425614116,16390401,4106774,1,'2010-03-12 16:31:01',3310504093,1),(664560254,425618786,16394448,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560255,425621965,16398225,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560256,425623853,16403486,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560257,425625443,16409422,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560258,425626536,16414143,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560259,425627430,16416436,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560260,425628821,16419000,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560261,425629616,16419809,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560262,425631305,16420483,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560263,425633590,16420618,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560264,425636571,16419674,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560265,425640148,16417381,4106774,1,'2010-03-12 16:31:01',3310504136,1),(664560266,425644023,16414413,4106774,1,'2010-03-12 16:31:02',3310504136,1),(664560267,425647699,16412120,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560268,425649984,16411041,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560269,425652766,16410096,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560270,425655448,16410096,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560271,425659025,16410636,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560272,425661708,16410906,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560273,425663695,16411715,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560274,425648494,16422642,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560275,425658330,16418325,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560276,425613619,16431680,4106774,1,'2010-03-12 16:31:02',3310504095,1),(664560277,425627856,16425638,4108069,1,'2010-03-12 19:04:14',3310504138,2),(664560278,425633094,16425205,4106774,1,'2010-03-12 16:31:02',3310504138,1),(664560279,425638956,16424665,4106774,1,'2010-03-12 16:31:02',3310504136,1),(664560280,425666675,16413469,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560281,425669159,16416302,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560282,425665483,16416302,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560283,425670053,16416571,4106774,1,'2010-03-12 16:31:02',3310504137,1),(664560284,425655345,16648058,4106774,1,'2010-03-12 16:31:02',3310504171,1),(664560285,425668459,16653562,4106774,1,'2010-03-12 16:31:02',3310504171,1),(664560286,425666075,16678383,4106774,1,'2010-03-12 16:31:02',3310504171,1),(664560287,425704781,16676873,4106774,1,'2010-03-12 16:31:02',3310504175,1),(664560288,425701125,16673851,4106774,1,'2010-03-12 16:31:02',3310504175,1),(664560289,425697787,16672664,4106774,1,'2010-03-12 16:31:02',3310504174,1),(664560290,425694131,16672988,4106774,1,'2010-03-12 16:31:02',3310504174,1),(664560291,425715828,16690039,4106774,1,'2010-03-12 16:31:02',3310504175,1),(664560292,425709788,16683887,4106774,1,'2010-03-12 16:31:02',3310504175,1),(664560293,425723490,16628206,4106774,1,'2010-03-12 16:31:02',3310504173,1),(664560294,425724443,16628098,4106774,1,'2010-03-12 16:31:02',3310504173,1),(664560295,425735299,16668239,4106774,1,'2010-03-12 16:31:02',3310504186,1),(664560296,425736888,16668671,4106774,1,'2010-03-12 16:31:02',3310504186,1),(664560297,425737921,16665541,4106774,1,'2010-03-12 16:31:02',3310504186,1),(664560298,425739988,16660361,4106774,1,'2010-03-12 16:31:02',3310504186,1),(664560299,425741657,16656476,4106774,1,'2010-03-12 16:31:02',3310504186,1),(664560300,425742849,16653994,4106774,1,'2010-03-12 16:31:02',3310504186,1),(664560301,425744120,16656152,4106774,1,'2010-03-12 16:31:02',3310504186,1),(664560302,425745392,16659282,4106774,1,'2010-03-12 16:31:02',3310504186,1),(664560303,425747299,16666189,4106774,1,'2010-03-12 16:31:02',3310504186,1),(664560304,425733153,16695650,4106774,1,'2010-03-12 16:31:02',3310504186,1),(664560305,425727749,16695435,4106774,1,'2010-03-12 16:31:03',3310504186,1),(664560306,425722265,16693924,4106774,1,'2010-03-12 16:31:03',3310504175,1),(664560307,425746334,16684030,4106774,1,'2010-03-12 16:31:03',3310504186,1),(664560308,425743564,16687772,4106774,1,'2010-03-12 16:31:03',3310504186,1),(664560309,425738398,16693276,4106774,1,'2010-03-12 16:31:03',3310504186,1),(664560310,425748036,16681964,4106774,1,'2010-03-12 16:31:03',3310504186,1),(664560311,425748094,16674067,4106774,1,'2010-03-12 16:31:03',3310504186,1),(664560312,425416359,16701206,4106774,1,'2010-03-12 16:31:03',3310504448,1),(664560313,425418248,16713347,4106774,1,'2010-03-12 16:31:03',3310504448,1),(664560314,425421130,16725623,4106774,1,'2010-03-12 16:31:03',3310504448,1),(664560315,425425106,16744779,4106774,1,'2010-03-12 16:31:03',3310504449,1),(664560316,425427391,16754761,4106774,1,'2010-03-12 16:31:03',3310504451,1),(664560317,425431864,16763529,4106774,1,'2010-03-12 16:31:03',3310504451,1),(664560318,425436635,16773107,4106774,1,'2010-03-12 16:31:03',3310504451,1),(664560319,425441505,16779312,4106774,1,'2010-03-12 16:31:03',3310504451,1),(664560320,425496140,16699945,4106774,1,'2010-03-12 16:31:03',3310504453,1),(664560321,425497134,16704666,4106774,1,'2010-03-12 16:31:03',3310504453,1),(664560322,425497631,16709253,4106774,1,'2010-03-12 16:31:03',3310504453,1),(664560323,425497829,16713030,4106774,1,'2010-03-12 16:31:03',3310504453,1),(664560324,425498426,16718426,4106774,1,'2010-03-12 16:31:03',3310504453,1),(664560325,425499519,16724631,4106774,1,'2010-03-12 16:31:03',3310504453,1),(664560326,425448760,16785653,4106774,1,'2010-03-12 16:31:03',3310504451,1),(664560327,425453630,16787811,4106774,1,'2010-03-12 16:31:03',3310504454,1),(664560328,425459990,16787811,4106774,1,'2010-03-12 16:31:03',3310504454,1),(664560329,425466649,16787541,4106774,1,'2010-03-12 16:31:03',3310504454,1),(664560330,425473606,16789835,4106774,1,'2010-03-12 16:31:03',3310504454,1),(664560331,425480364,16794151,4106774,1,'2010-03-12 16:31:04',3310504455,1),(664560332,425490501,16798603,4106774,1,'2010-03-12 16:31:04',3310504455,1),(664560333,425495668,16799412,4106774,1,'2010-03-12 16:31:04',3310504455,1),(664560334,425515916,16701294,4106774,1,'2010-03-12 16:31:04',3310504464,1),(664560335,425520686,16707499,4106774,1,'2010-03-12 16:31:04',3310504464,1),(664560336,425525058,16713839,4106774,1,'2010-03-12 16:31:04',3310504464,1),(664560337,425501009,16731916,4106774,1,'2010-03-12 16:31:04',3310504453,1),(664560338,425502798,16740010,4106774,1,'2010-03-12 16:31:04',3310504453,1),(664560339,425503693,16744192,4106774,1,'2010-03-12 16:31:04',3310504453,1),(664560340,425504488,16747969,4106774,1,'2010-03-12 16:31:04',3310504453,1),(664560341,425506177,16751746,4106774,1,'2010-03-12 16:31:04',3310504453,1),(664560342,425530226,16722608,4106774,1,'2010-03-12 16:31:04',3310504464,1),(664560343,425533406,16725576,4106774,1,'2010-03-12 16:31:04',3310504464,1),(664560344,425554731,16702157,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560345,425555287,16707014,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560346,425534499,16728004,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560347,425537579,16733400,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560348,425538275,16734884,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560349,425538275,16737312,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560350,425537281,16739605,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560351,425535691,16743112,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560352,425534996,16744731,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560353,425534996,16746350,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560354,425534996,16748508,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560355,425534996,16750262,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560356,425534201,16752960,4106774,1,'2010-03-12 16:31:04',3310504464,1),(664560357,425537977,16730837,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560358,425540362,16735288,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560359,425542945,16740819,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560360,425546523,16748104,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560361,425548113,16749992,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560362,425550001,16750936,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560363,425552584,16750127,4106774,1,'2010-03-12 16:31:04',3310504465,1),(664560364,425509158,16757277,4106774,1,'2010-03-12 16:31:04',3310504466,1),(664560365,425513332,16765101,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560366,425516413,16770632,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560367,425519096,16775893,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560368,425501432,16801436,4106774,1,'2010-03-12 16:31:05',3310504455,1),(664560369,425503807,16800310,4106774,1,'2010-03-12 16:31:05',3310504455,1),(664560370,425512264,16800761,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560371,425514152,16784843,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560372,425518922,16787406,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560373,425521904,16790914,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560374,425522077,16782233,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560375,425524363,16787629,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560376,425526648,16794778,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560377,425516736,16803999,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560378,425519519,16807102,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560379,425521307,16807236,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560380,425521922,16805847,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560381,425524289,16798063,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560382,425523593,16802110,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560383,425524661,16798825,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560384,425527642,16802333,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560385,425527046,16802333,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560386,425523667,16804086,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560387,425532611,16757277,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560388,425531617,16764022,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560389,425531617,16769687,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560390,425532412,16777376,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560391,425533704,16783717,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560392,425535095,16790731,4106774,1,'2010-03-12 16:31:05',3310504467,1),(664560393,425536387,16795992,4106774,1,'2010-03-12 16:31:05',3310504467,1),(664560394,425536884,16799500,4106774,1,'2010-03-12 16:31:05',3310504467,1),(664560395,425537182,16802602,4106774,1,'2010-03-12 16:31:05',3310504467,1),(664560396,425537082,16804356,4106774,1,'2010-03-12 16:31:05',3310504467,1),(664560397,425536685,16805166,4106774,1,'2010-03-12 16:31:05',3310504467,1),(664560398,425528735,16800444,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560399,425531021,16805166,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560400,425534101,16806110,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560401,425535890,16805705,4106774,1,'2010-03-12 16:31:05',3310504467,1),(664560402,425533803,16786280,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560403,425533108,16791811,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560404,425531915,16795992,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560405,425529928,16798690,4106774,1,'2010-03-12 16:31:05',3310504466,1),(664560406,425556321,16710683,4106774,1,'2010-03-12 16:31:05',3310504465,1),(664560407,425556718,16717050,4106774,1,'2010-03-12 16:31:05',3310504465,1),(664560408,425558069,16722986,4106774,1,'2010-03-12 16:31:06',3310504465,1),(664560409,425555963,16748104,4106774,1,'2010-03-12 16:31:06',3310504465,1),(664560410,425559639,16745541,4106774,1,'2010-03-12 16:31:06',3310504465,1),(664560411,425562919,16741763,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560412,425566794,16739470,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560413,425559580,16728058,4106774,1,'2010-03-12 16:31:06',3310504465,1),(664560414,425561647,16731403,4106774,1,'2010-03-12 16:31:06',3310504465,1),(664560415,425563634,16733777,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560416,425566734,16735396,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560417,425572557,16736772,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560418,425572657,16736502,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560419,425577923,16734074,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560420,425582792,16732590,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560421,425570153,16736152,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560422,425573412,16737447,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560423,425576750,16739605,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560424,425579135,16741116,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560425,425581202,16742087,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560426,425582235,16741979,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560427,425582394,16740792,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560428,425581997,16739281,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560429,425581440,16736691,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560430,425581123,16734749,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560431,425581917,16733238,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560432,425583110,16732590,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560433,425584382,16732590,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560434,425588118,16733885,4106774,1,'2010-03-12 16:31:06',3310504468,1),(664560435,425592172,16735072,4106774,1,'2010-03-12 16:31:06',3310504469,1),(664560436,425596544,16737015,4106774,1,'2010-03-12 16:31:06',3310504469,1),(664560437,425601711,16738634,4106774,1,'2010-03-12 16:31:06',3310504469,1),(664560439,425606957,16739065,4106774,1,'2010-03-12 16:31:06',3310504469,1),(664560440,425608388,16738418,4106774,1,'2010-03-12 16:31:06',3310504469,1),(664598393,425608388,16450459,4107810,1,'2010-03-12 18:34:08',3310504095,1),(664598394,425609009,16445906,4107810,1,'2010-03-12 18:34:09',3310504095,1),(664598395,425610127,16442703,4107810,1,'2010-03-12 18:34:09',3310504095,1),(664598396,425609133,16473392,4107810,1,'2010-03-12 18:34:09',3310504095,1),(664598397,425607394,16470357,4107810,1,'2010-03-12 18:34:09',3310504095,1),(664598398,425607022,16465804,4107810,1,'2010-03-12 18:34:09',3310504095,1),(664598399,425606897,16461757,4107810,1,'2010-03-12 18:34:09',3310504095,1),(664598400,425607270,16456361,4107810,1,'2010-03-12 18:34:09',3310504095,1),(664598401,425543399,16535784,4107810,1,'2010-03-12 18:34:09',3310504115,1),(664598402,425595968,16533759,4107810,1,'2010-03-12 18:34:09',3310504117,1),(664598403,425599321,16532747,4107810,1,'2010-03-12 18:34:09',3310504117,1),(664598404,425601308,16531735,4107810,1,'2010-03-12 18:34:09',3310504117,1),(664598405,425604165,16529206,4107810,1,'2010-03-12 18:34:09',3310504117,1),(664598406,425607022,16526171,4107810,1,'2010-03-12 18:34:09',3310504117,1),(664598407,425572244,16581479,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598408,425571872,16584514,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598409,425574535,16588024,4108069,1,'2010-03-12 19:04:14',3310504118,2),(664598410,425571979,16582546,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598411,425570630,16585189,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598412,425570754,16588055,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598413,425572244,16584514,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598414,425573114,16589236,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598415,425587025,16557872,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598416,425586280,16551464,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598417,425584541,16546406,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598418,425584541,16543370,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598419,425585410,16539661,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598420,425587149,16537806,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598421,425588640,16535108,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598422,425592117,16534433,4107810,1,'2010-03-12 18:34:09',3310504117,1),(664598423,425588267,16563942,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598424,425589136,16567483,4107810,1,'2010-03-12 18:34:09',3310504118,1),(664598425,425591745,16573891,4107810,1,'2010-03-12 18:34:09',3310504119,1),(664598426,425593856,16580467,4107810,1,'2010-03-12 18:34:10',3310504119,1),(664598427,425595471,16585526,4107810,1,'2010-03-12 18:34:10',3310504119,1),(664598428,425568642,16601039,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598429,425568021,16603063,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598430,425569139,16607278,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598431,425576219,16591934,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598432,425571002,16590922,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598433,425571872,16594969,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598434,425571748,16597161,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598435,425571002,16600028,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598436,425570381,16612337,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598437,425571748,16616553,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598438,425574729,16594126,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598439,425576095,16600028,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598440,425577461,16606941,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598441,425578827,16614360,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598442,425572369,16621105,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598443,425573735,16627513,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598444,425574232,16632572,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598445,425572741,16635270,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598446,425573114,16639485,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598447,425579945,16621780,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598448,425580194,16626839,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598449,425581808,16633752,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598450,425608557,16639274,4107810,1,'2010-03-12 18:34:10',3310504125,1),(664598451,425583547,16641509,4107810,1,'2010-03-12 18:34:10',3310504124,1),(664598452,425596713,16592102,4107810,1,'2010-03-12 18:34:10',3310504125,1),(664598453,425597707,16597498,4107810,1,'2010-03-12 18:34:10',3310504125,1),(664598454,425599197,16602388,4107810,1,'2010-03-12 18:34:11',3310504125,1),(664598455,425600439,16610482,4107810,1,'2010-03-12 18:34:11',3310504125,1),(664598456,425602178,16617396,4107810,1,'2010-03-12 18:34:11',3310504125,1),(664598457,425604786,16623635,4107810,1,'2010-03-12 18:34:11',3310504125,1),(664598458,425606649,16628188,4107810,1,'2010-03-12 18:34:11',3310504125,1),(664598459,425609257,16633078,4107810,1,'2010-03-12 18:34:11',3310504125,1),(664598460,425573611,16654155,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598461,425573362,16648085,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598462,425573859,16658034,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598463,425573487,16661069,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598464,425574108,16670006,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598465,425574729,16678100,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598466,425574480,16683664,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598467,425574729,16688723,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598468,425575474,16692770,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598469,425580194,16698503,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598470,425609513,16686730,4107810,1,'2010-03-12 18:34:11',3310504127,1),(664598471,425585907,16652132,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598472,425588515,16659889,4107810,1,'2010-03-12 18:34:11',3310504126,1),(664598473,425591372,16670006,4107810,1,'2010-03-12 18:34:11',3310504127,1),(664598474,425592490,16677594,4107810,1,'2010-03-12 18:34:11',3310504127,1),(664598475,425593484,16682484,4107810,1,'2010-03-12 18:34:11',3310504127,1),(664598476,425592863,16685182,4107810,1,'2010-03-12 18:34:11',3310504127,1),(664598477,425592738,16689903,4107810,1,'2010-03-12 18:34:11',3310504127,1),(664598478,425592242,16694625,4107810,1,'2010-03-12 18:34:11',3310504127,1),(664598479,425662164,16424323,4107810,1,'2010-03-12 18:34:11',3310504137,1),(664598480,425611369,16476427,4107810,1,'2010-03-12 18:34:11',3310504095,1),(664598481,425612611,16440173,4107810,1,'2010-03-12 18:34:11',3310504095,1),(664598482,425614970,16439836,4107810,1,'2010-03-12 18:34:11',3310504095,1),(664598483,425617579,16439667,4107810,1,'2010-03-12 18:34:11',3310504138,1),(664598484,425621801,16438318,4107810,1,'2010-03-12 18:34:11',3310504138,1),(664598485,425624658,16437475,4107810,1,'2010-03-12 18:34:11',3310504138,1),(664598486,425627390,16436464,4107810,1,'2010-03-12 18:34:11',3310504138,1),(664598487,425630868,16435958,4107810,1,'2010-03-12 18:34:11',3310504138,1),(664598488,425633973,16435115,4107810,1,'2010-03-12 18:34:12',3310504138,1),(664598489,425637699,16433766,4107810,1,'2010-03-12 18:34:12',3310504138,1),(664598490,425663282,16444389,4107810,1,'2010-03-12 18:34:12',3310504139,1),(664598491,425661544,16448267,4107810,1,'2010-03-12 18:34:12',3310504139,1),(664598492,425659060,16453326,4107810,1,'2010-03-12 18:34:12',3310504139,1),(664598493,425657818,16457204,4107810,1,'2010-03-12 18:34:12',3310504139,1),(664598494,425655707,16462094,4107810,1,'2010-03-12 18:34:12',3310504139,1),(664598495,425653968,16468333,4107810,1,'2010-03-12 18:34:12',3310504139,1),(664598496,425650987,16474910,4107810,1,'2010-03-12 18:34:12',3310504139,1),(664598497,425641300,16432922,4107810,1,'2010-03-12 18:34:12',3310504138,1),(664598499,425646392,16431405,4107810,1,'2010-03-12 18:34:12',3310504139,1),(664598500,425651360,16428876,4107810,1,'2010-03-12 18:34:12',3310504139,1),(664598501,425657445,16426683,4107810,1,'2010-03-12 18:34:12',3310504139,1),(664598503,425689237,16396331,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598504,425672100,16408978,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598505,425674211,16406617,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598506,425677191,16404257,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598507,425671605,16422566,4108069,1,'2010-03-12 19:04:14',3310504137,2),(664598508,425671851,16423480,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598509,425666014,16422299,4107810,1,'2010-03-12 18:34:12',3310504137,1),(664598510,425668374,16419264,4107810,1,'2010-03-12 18:34:12',3310504137,1),(664598511,425669740,16414543,4107810,1,'2010-03-12 18:34:12',3310504137,1),(664598512,425670113,16411676,4107810,1,'2010-03-12 18:34:12',3310504137,1),(664598513,425684022,16399535,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598514,425680325,16422236,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598515,425682869,16422167,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598516,425684649,16421615,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598517,425686124,16420164,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598518,425687650,16418990,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598519,425689634,16418023,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598520,425692483,16417056,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598521,425680224,16422306,4107810,1,'2010-03-12 18:34:12',3310504140,1),(664598522,425683276,16418576,4107810,1,'2010-03-12 18:34:13',3310504140,1),(664598523,425685666,16415606,4107810,1,'2010-03-12 18:34:13',3310504140,1),(664598524,425688617,16412360,4107810,1,'2010-03-12 18:34:13',3310504140,1),(664598525,425692228,16408837,4107810,1,'2010-03-12 18:34:13',3310504140,1),(664598526,425694701,16394139,4107810,1,'2010-03-12 18:34:13',3310504140,1),(664598527,425700041,16393802,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598528,425704388,16393802,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598529,425708237,16395320,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598530,425711342,16396669,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598531,425694924,16406213,4107810,1,'2010-03-12 18:34:13',3310504140,1),(664598532,425697773,16404003,4107810,1,'2010-03-12 18:34:13',3310504140,1),(664598533,425706115,16403394,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598534,425704335,16400700,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598535,425704741,16409252,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598536,425705911,16406696,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598537,425700112,16402000,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598538,425702554,16400273,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598539,425703673,16399997,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598540,425705046,16400411,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598541,425694822,16416642,4107810,1,'2010-03-12 18:34:13',3310504140,1),(664598542,425698230,16415951,4107810,1,'2010-03-12 18:34:13',3310504140,1),(664598543,425701079,16415468,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598544,425704182,16415399,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598545,425701384,16423342,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598546,425701180,16421684,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598547,425700824,16420510,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598548,425700367,16419612,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598549,425700061,16419059,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598550,425699807,16418092,4107810,1,'2010-03-12 18:34:13',3310504141,1),(664598551,425700011,16417471,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598552,425700774,16416089,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598553,425702147,16413672,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598554,425703469,16411324,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598555,425713080,16401727,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598556,425714819,16406449,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598557,425716061,16412350,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598558,425717178,16417072,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598559,425718544,16421119,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598560,425719786,16424323,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598561,425707488,16416228,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598562,425710540,16418023,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598563,425714660,16423203,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598564,425706572,16404693,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598565,425706928,16404072,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598566,425706674,16403036,4107810,1,'2010-03-12 18:34:14',3310504141,1),(664598567,425669740,16428876,4107810,1,'2010-03-12 18:34:14',3310504139,1),(664598568,425668250,16433597,4107810,1,'2010-03-12 18:34:14',3310504139,1),(664598569,425666511,16438487,4107810,1,'2010-03-12 18:34:14',3310504139,1),(664598570,425677935,16436533,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598571,425677019,16432873,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598572,425677477,16429419,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598573,425678647,16425690,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598574,425685260,16425427,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598575,425689481,16451797,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598576,425692483,16448482,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598577,425682309,16451314,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598578,425682106,16449035,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598579,425681088,16445996,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598580,425680173,16442957,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598581,425679257,16440263,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598582,425677440,16476933,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598583,425670255,16468594,4107810,1,'2010-03-12 18:34:14',3310504139,1),(664598584,425671068,16468788,4107810,1,'2010-03-12 18:34:14',3310504139,1),(664598585,425673916,16470100,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598586,425676154,16470998,4107810,1,'2010-03-12 18:34:14',3310504142,1),(664598587,425678036,16471344,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598588,425671627,16468028,4107810,1,'2010-03-12 18:34:15',3310504139,1),(664598589,425674832,16466164,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598590,425677782,16462365,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598591,425682208,16464989,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598592,425682614,16462779,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598593,425683377,16460155,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598594,425684395,16458083,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598595,425685870,16456218,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598596,425680478,16458704,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598597,425681495,16456632,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598598,425682004,16453317,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598599,425687599,16454008,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598600,425679302,16473223,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598601,425680296,16471031,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598602,425682283,16470694,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598603,425679715,16470791,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598604,425680834,16469134,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598605,425681699,16466854,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598606,425718017,16426726,4107810,1,'2010-03-12 18:34:15',3310504143,1),(664598607,425694975,16445720,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598608,425697773,16443233,4107810,1,'2010-03-12 18:34:15',3310504142,1),(664598609,425699858,16442059,4107810,1,'2010-03-12 18:34:15',3310504143,1),(664598610,425701231,16441506,4107810,1,'2010-03-12 18:34:15',3310504143,1),(664598611,425701994,16440056,4107810,1,'2010-03-12 18:34:15',3310504143,1),(664598612,425701943,16438882,4107810,1,'2010-03-12 18:34:15',3310504143,1),(664598613,425701537,16437915,4107810,1,'2010-03-12 18:34:15',3310504143,1),(664598614,425700926,16437224,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598615,425700519,16435497,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598616,425700519,16433702,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598617,425700570,16431630,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598618,425700723,16429558,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598619,425700672,16428038,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598620,425700672,16427002,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598621,425701180,16425275,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598622,425732949,16395825,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598623,425733321,16393465,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598624,425734190,16392959,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598625,425735681,16393633,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598626,425736426,16395825,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598627,425729223,16422636,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598628,425729720,16419939,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598629,425729720,16415892,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598630,425729844,16413025,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598631,425730093,16407460,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598632,425730714,16403919,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598633,425731707,16399198,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598634,425737667,16401896,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598635,425739530,16408304,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598636,425739903,16411170,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598637,425740772,16414711,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598638,425742634,16418252,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598639,425743752,16421456,4107810,1,'2010-03-12 18:34:16',3310504152,1),(664598640,425720904,16426683,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598641,425722394,16431236,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598642,425723635,16434271,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598643,425724629,16435283,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598644,425725250,16435452,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598645,425726616,16434609,4107810,1,'2010-03-12 18:34:16',3310504143,1),(664598646,425727982,16432585,4107810,1,'2010-03-12 18:34:16',3310504154,1),(664598647,425728727,16428538,4107810,1,'2010-03-12 18:34:16',3310504154,1),(664598648,425729099,16425166,4107810,1,'2010-03-12 18:34:16',3310504154,1),(664598649,425744745,16426178,4107810,1,'2010-03-12 18:34:17',3310504154,1),(664598650,425746235,16431742,4107810,1,'2010-03-12 18:34:17',3310504154,1),(664598651,425747353,16434609,4107810,1,'2010-03-12 18:34:17',3310504154,1),(664598652,425720458,16429627,4107810,1,'2010-03-12 18:34:17',3310504143,1),(664598653,425722798,16432320,4107810,1,'2010-03-12 18:34:17',3310504143,1),(664598654,425747850,16437981,4107810,1,'2010-03-12 18:34:17',3310504154,1),(664598655,425748222,16442871,4107810,1,'2010-03-12 18:34:17',3310504154,1),(664598656,425748719,16449447,4107810,1,'2010-03-12 18:34:17',3310504154,1),(664598657,425748843,16456361,4107810,1,'2010-03-12 18:34:17',3310504154,1),(664598658,425749588,16463612,4107810,1,'2010-03-12 18:34:17',3310504154,1),(664598659,425750085,16471200,4107810,1,'2010-03-12 18:34:17',3310504154,1),(664598660,425750457,16476764,4107810,1,'2010-03-12 18:34:17',3310504154,1),(664598661,425768089,16478451,4107810,1,'2010-03-12 18:34:17',3310504155,1),(664598662,425770821,16477776,4107810,1,'2010-03-12 18:34:17',3310504155,1),(664598663,425772435,16477776,4107810,1,'2010-03-12 18:34:17',3310504155,1),(664598665,425773801,16479294,4107810,1,'2010-03-12 18:34:17',3310504155,1),(664598666,425623540,16501889,4107810,1,'2010-03-12 18:34:17',3310504160,1),(664598668,425622298,16498348,4107810,1,'2010-03-12 18:34:17',3310504160,1),(664598670,425621056,16494470,4107810,1,'2010-03-12 18:34:17',3310504160,1),(664598672,425618448,16490254,4107810,1,'2010-03-12 18:34:17',3310504160,1),(664598674,425617082,16486713,4107810,1,'2010-03-12 18:34:17',3310504160,1),(664598676,425614598,16484521,4107810,1,'2010-03-12 18:34:17',3310504117,1),(664598678,425613107,16480474,4107810,1,'2010-03-12 18:34:17',3310504117,1),(664598680,425636829,16498854,4107810,1,'2010-03-12 18:34:17',3310504160,1),(664598682,425624410,16506105,4107810,1,'2010-03-12 18:34:17',3310504160,1),(664598684,425610748,16522461,4107810,1,'2010-03-12 18:34:17',3310504117,1),(664598697,425614598,16519426,4107810,1,'2010-03-12 18:34:18',3310504117,1),(664598698,425618200,16517065,4107810,1,'2010-03-12 18:34:18',3310504160,1),(664598699,425620932,16514367,4107810,1,'2010-03-12 18:34:18',3310504160,1),(664598700,425622919,16512512,4107810,1,'2010-03-12 18:34:18',3310504160,1),(664598701,425626645,16511669,4107810,1,'2010-03-12 18:34:18',3310504160,1),(664598702,425633103,16508128,4107810,1,'2010-03-12 18:34:18',3310504160,1),(664598703,425629626,16512007,4107810,1,'2010-03-12 18:34:18',3310504160,1),(664598704,425626273,16513355,4107810,1,'2010-03-12 18:34:18',3310504160,1),(664598706,425624285,16509646,4107810,1,'2010-03-12 18:34:18',3310504160,1),(664598708,425652478,16534265,4107810,1,'2010-03-12 18:34:18',3310504161,1),(664598709,425653844,16527857,4107810,1,'2010-03-12 18:34:18',3310504161,1),(664598710,425655955,16521449,4107810,1,'2010-03-12 18:34:18',3310504161,1),(664598711,425660550,16516391,4107810,1,'2010-03-12 18:34:18',3310504161,1),(664598712,425664151,16511838,4107810,1,'2010-03-12 18:34:18',3310504161,1),(664598713,425646889,16480980,4107810,1,'2010-03-12 18:34:18',3310504161,1),(664598714,425643411,16488231,4107810,1,'2010-03-12 18:34:18',3310504160,1),(664598715,425640679,16494470,4107810,1,'2010-03-12 18:34:18',3310504160,1),(664598716,425638320,16500372,4107810,1,'2010-03-12 18:34:18',3310504160,1),(664598717,425645895,16583671,4107810,1,'2010-03-12 18:34:18',3310504163,1),(664598718,425653099,16573385,4107810,1,'2010-03-12 18:34:18',3310504163,1),(664598719,425654961,16567652,4107810,1,'2010-03-12 18:34:18',3310504163,1),(664598720,425656576,16560738,4107810,1,'2010-03-12 18:34:18',3310504163,1),(664598721,425655955,16555343,4107810,1,'2010-03-12 18:34:18',3310504163,1),(664598722,425654713,16550621,4107810,1,'2010-03-12 18:34:18',3310504163,1),(664598723,425652726,16544888,4107810,1,'2010-03-12 18:34:18',3310504163,1),(664598724,425651484,16539829,4107810,1,'2010-03-12 18:34:18',3310504163,1),(664598725,425649745,16578612,4107810,1,'2010-03-12 18:34:18',3310504163,1),(664598726,425667380,16506273,4107810,1,'2010-03-12 18:34:18',3310504161,1),(664598727,425670734,16499360,4107810,1,'2010-03-12 18:34:18',3310504161,1),(664598728,425671975,16497168,4107810,1,'2010-03-12 18:34:18',3310504164,1),(664598729,425674087,16495650,4107810,1,'2010-03-12 18:34:18',3310504164,1),(664598730,425676322,16493289,4107810,1,'2010-03-12 18:34:18',3310504164,1),(664598731,425676819,16490423,4107810,1,'2010-03-12 18:34:18',3310504164,1),(664598732,425676819,16486882,4107810,1,'2010-03-12 18:34:19',3310504164,1),(664598733,425676819,16483172,4107810,1,'2010-03-12 18:34:19',3310504164,1),(664598734,425687375,16489242,4107810,1,'2010-03-12 18:34:19',3310504164,1),(664598735,425610623,16634258,4107810,1,'2010-03-12 18:34:19',3310504125,1),(664598736,425612114,16634932,4107810,1,'2010-03-12 18:34:19',3310504125,1),(664598737,425614474,16634258,4107810,1,'2010-03-12 18:34:19',3310504125,1),(664598738,425618324,16632403,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598739,425622298,16630042,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598740,425624037,16628019,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598741,425626148,16627176,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598742,425629253,16625827,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598743,425631986,16623972,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598744,425635463,16620262,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598745,425640803,16595981,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598746,425643287,16590079,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598747,425639313,16614192,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598748,425641549,16609133,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598749,425643908,16605761,4107810,1,'2010-03-12 18:34:19',3310504168,1),(664598750,425644778,16605255,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598751,425646268,16605929,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598752,425648255,16605592,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598753,425650739,16605086,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598754,425653223,16605086,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598755,425656824,16607110,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598756,425661668,16611663,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598757,425653595,16605255,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598758,425656203,16608627,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598759,425658563,16612843,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598760,425659432,16616047,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598761,425660923,16619925,4107810,1,'2010-03-12 18:34:19',3310504169,1),(664598762,425662661,16623466,4107810,1,'2010-03-12 18:34:20',3310504169,1),(664598763,425664524,16626670,4107810,1,'2010-03-12 18:34:20',3310504169,1),(664598764,425610910,16663755,4107810,1,'2010-03-12 18:34:20',3310504127,1),(664598765,425610444,16647104,4107810,1,'2010-03-12 18:34:20',3310504127,1),(664598766,425614015,16654481,4107810,1,'2010-03-12 18:34:20',3310504127,1),(664598767,425614170,16664177,4107810,1,'2010-03-12 18:34:20',3310504127,1),(664598768,425611997,16645629,4107810,1,'2010-03-12 18:34:20',3310504127,1),(664598769,425614170,16649001,4107810,1,'2010-03-12 18:34:20',3310504127,1),(664598770,425620691,16653638,4107810,1,'2010-03-12 18:34:20',3310504170,1),(664598771,425618282,16651507,4107810,1,'2010-03-12 18:34:20',3310504170,1),(664598772,425629384,16662491,4107810,1,'2010-03-12 18:34:20',3310504170,1),(664598773,425629316,16668912,4107810,1,'2010-03-12 18:34:20',3310504170,1),(664598774,425624416,16654903,4107810,1,'2010-03-12 18:34:20',3310504170,1),(664598776,425666387,16616215,4107810,1,'2010-03-12 18:34:20',3310504169,1),(664598777,425671727,16621274,4107810,1,'2010-03-12 18:34:20',3310504169,1),(664598778,425677688,16625152,4107810,1,'2010-03-12 18:34:20',3310504172,1),(664598779,425683773,16628525,4107810,1,'2010-03-12 18:34:20',3310504172,1);
INSERT INTO `nodes` VALUES (664598780,425689486,16631729,4107810,1,'2010-03-12 18:34:20',3310504172,1),(664598781,425667753,16628356,4107810,1,'2010-03-12 18:34:20',3310504169,1),(664598782,425674087,16633246,4107810,1,'2010-03-12 18:34:20',3310504172,1),(664598783,425681414,16638136,4107810,1,'2010-03-12 18:34:20',3310504172,1),(664598784,425686505,16642015,4107810,1,'2010-03-12 18:34:20',3310504172,1),(664598785,425706609,16592049,4107810,1,'2010-03-12 18:34:20',3310504173,1),(664598786,425697930,16635944,4107810,1,'2010-03-12 18:34:20',3310504172,1),(664598787,425703891,16637630,4107810,1,'2010-03-12 18:34:20',3310504173,1),(664598788,425708734,16638811,4107810,1,'2010-03-12 18:34:20',3310504173,1),(664598789,425712832,16638811,4107810,1,'2010-03-12 18:34:20',3310504173,1),(664598790,425716681,16637462,4107810,1,'2010-03-12 18:34:20',3310504173,1),(664598791,425719289,16635607,4107810,1,'2010-03-12 18:34:20',3310504173,1),(664598792,425690355,16644881,4107810,1,'2010-03-12 18:34:20',3310504174,1),(664598793,425693335,16648085,4107810,1,'2010-03-12 18:34:20',3310504174,1),(664598794,425698054,16653481,4107810,1,'2010-03-12 18:34:20',3310504174,1),(664598795,425701035,16656348,4107810,1,'2010-03-12 18:34:20',3310504175,1),(664598796,425703891,16658034,4107810,1,'2010-03-12 18:34:20',3310504175,1),(664598797,425706250,16661406,4107810,1,'2010-03-12 18:34:20',3310504175,1),(664598798,425709852,16664779,4107810,1,'2010-03-12 18:34:20',3310504175,1),(664598799,425713825,16667477,4107810,1,'2010-03-12 18:34:20',3310504175,1),(664598800,425712459,16669500,4107810,1,'2010-03-12 18:34:20',3310504175,1),(664598801,425751078,16483172,4107810,1,'2010-03-12 18:34:21',3310504176,1),(664598802,425751575,16488737,4107810,1,'2010-03-12 18:34:21',3310504176,1),(664598803,425752320,16493289,4107810,1,'2010-03-12 18:34:21',3310504176,1),(664598804,425752941,16495987,4107810,1,'2010-03-12 18:34:21',3310504176,1),(664598805,425753562,16496493,4107810,1,'2010-03-12 18:34:21',3310504176,1),(664598806,425754182,16496493,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598807,425755300,16495987,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598808,425756418,16494638,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598809,425757908,16492278,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598810,425759894,16488568,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598811,425767344,16505093,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598812,425771566,16498685,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598813,425774795,16494638,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598814,425761509,16484690,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598815,425763744,16482160,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598816,425765979,16480137,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598817,425774670,16481149,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598818,425751575,16529375,4107810,1,'2010-03-12 18:34:21',3310504176,1),(664598819,425754803,16519595,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598820,425756293,16514873,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598821,425758156,16513187,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598822,425763371,16509477,4107810,1,'2010-03-12 18:34:21',3310504177,1),(664598823,425745739,16587212,4107810,1,'2010-03-12 18:34:21',3310504178,1),(664598824,425747353,16572542,4107810,1,'2010-03-12 18:34:21',3310504178,1),(664598825,425748098,16560907,4107810,1,'2010-03-12 18:34:21',3310504178,1),(664598826,425749216,16553488,4107810,1,'2010-03-12 18:34:21',3310504178,1),(664598828,425748719,16545394,4107810,1,'2010-03-12 18:34:21',3310504178,1),(664598829,425750581,16537300,4107810,1,'2010-03-12 18:34:21',3310504178,1),(664598831,425775167,16482666,4107810,1,'2010-03-12 18:34:22',3310504177,1),(664598832,425775664,16485195,4107810,1,'2010-03-12 18:34:22',3310504177,1),(664598833,425775664,16486882,4107810,1,'2010-03-12 18:34:22',3310504177,1),(664598834,425775912,16489074,4107810,1,'2010-03-12 18:34:22',3310504177,1),(664598835,425776036,16490086,4107810,1,'2010-03-12 18:34:22',3310504177,1),(664598837,425727733,16638136,4107810,1,'2010-03-12 18:34:22',3310504184,1),(664598838,425742883,16639823,4107810,1,'2010-03-12 18:34:22',3310504184,1),(664598840,425742883,16627682,4107810,1,'2010-03-12 18:34:22',3310504184,1),(664598842,425743876,16609976,4107810,1,'2010-03-12 18:34:22',3310504184,1),(664598843,425721276,16632572,4107810,1,'2010-03-12 18:34:22',3310504173,1),(664598844,425722642,16628693,4107810,1,'2010-03-12 18:34:22',3310504173,1),(664598846,425730217,16648254,4107810,1,'2010-03-12 18:34:22',3310504186,1),(664598848,425732452,16657191,4107810,1,'2010-03-12 18:34:22',3310504186,1),(664598849,425742138,16654999,4107810,1,'2010-03-12 18:34:22',3310504186,1),(664598850,425734066,16663767,4107810,1,'2010-03-12 18:34:22',3310504186,1),(664598852,425735060,16667814,4107810,1,'2010-03-12 18:34:22',3310504186,1),(664598854,425736922,16667814,4107810,1,'2010-03-12 18:34:22',3310504186,1),(664598855,425738412,16665285,4107810,1,'2010-03-12 18:34:22',3310504186,1),(664598857,425740399,16659383,4107810,1,'2010-03-12 18:34:22',3310504186,1),(664598858,425591038,16721720,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598860,425589027,16725875,4107810,1,'2010-03-12 18:34:22',3310504468,1),(664598861,425583050,16703562,4107810,1,'2010-03-12 18:34:22',3310504468,1),(664598863,425587894,16707272,4107810,1,'2010-03-12 18:34:22',3310504468,1),(664598864,425594974,16711993,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598865,425594601,16724808,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598866,425591372,16725651,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598867,425589136,16726663,4107810,1,'2010-03-12 18:34:22',3310504468,1),(664598868,425594105,16699684,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598869,425595595,16701201,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598870,425601440,16700852,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598871,425597210,16700864,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598872,425599321,16701201,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598873,425598949,16714185,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598874,425602426,16716209,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598875,425601308,16722785,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598876,425598452,16725314,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598877,425605942,16715396,4107810,1,'2010-03-12 18:34:22',3310504469,1),(664598878,425604289,16717220,4107810,1,'2010-03-12 18:34:23',3310504469,1),(664598879,425604041,16719581,4107810,1,'2010-03-12 18:34:23',3310504469,1),(664598880,425588764,16728518,4107810,1,'2010-03-12 18:34:23',3310504468,1),(664598881,425593980,16732228,4107810,1,'2010-03-12 18:34:23',3310504469,1),(664598882,425598203,16735263,4107810,1,'2010-03-12 18:34:23',3310504469,1),(664598883,425601557,16736949,4107810,1,'2010-03-12 18:34:23',3310504469,1),(664598884,425604538,16738467,4107810,1,'2010-03-12 18:34:23',3310504469,1),(664598885,425607767,16739479,4107810,1,'2010-03-12 18:34:23',3310504469,1),(664598886,425609506,16736106,4107810,1,'2010-03-12 18:34:23',3310504469,1),(664598887,425628453,16712024,4107810,1,'2010-03-12 18:34:23',3310504512,1),(664598888,425620691,16714975,4107810,1,'2010-03-12 18:34:23',3310504512,1),(664598889,425611686,16714553,4107810,1,'2010-03-12 18:34:23',3310504469,1),(664598890,425613480,16733408,4107810,1,'2010-03-12 18:34:23',3310504469,1),(664598891,425663048,16703644,4107810,1,'2010-03-12 18:34:23',3310504513,1),(664598892,425652205,16703593,4107810,1,'2010-03-12 18:34:23',3310504513,1),(664598893,425662761,16706965,4107810,1,'2010-03-12 18:34:23',3310504513,1),(664598894,425642735,16705279,4107810,1,'2010-03-12 18:34:23',3310504512,1),(664598895,425650808,16708230,4107810,1,'2010-03-12 18:34:23',3310504513,1),(664598896,425657173,16704225,4107810,1,'2010-03-12 18:34:23',3310504513,1),(664605736,425354927,15876138,4108069,1,'2010-03-12 19:03:52',3310493014,1),(664605748,425397563,16307798,4108069,1,'2010-03-12 19:03:54',3310504064,1),(664605750,425485967,16471174,4108069,1,'2010-03-12 19:03:54',3310504079,1),(664605751,425484867,16470013,4108069,1,'2010-03-12 19:03:54',3310504079,1),(664605752,425483768,16469681,4108069,1,'2010-03-12 19:03:54',3310504079,1),(664605753,425483401,16470510,4108069,1,'2010-03-12 19:03:54',3310504079,1),(664605754,425483902,16474158,4108069,1,'2010-03-12 19:03:54',3310504079,1),(664605756,425484416,16479394,4108069,1,'2010-03-12 19:03:54',3310504079,1),(664605757,425498364,16462248,4108069,1,'2010-03-12 19:03:54',3310504079,1),(664605758,425487555,16471671,4108069,1,'2010-03-12 19:03:54',3310504079,1),(664605759,425535187,16417781,4108069,1,'2010-03-12 19:03:54',3310504089,1),(664605760,425506182,16451210,4108069,1,'2010-03-12 19:03:55',3310504079,1),(664605761,425521818,16434336,4108069,1,'2010-03-12 19:03:55',3310504090,1),(664605762,425503368,16455774,4108069,1,'2010-03-12 19:03:55',3310504079,1),(664605764,425568802,16403772,4108069,1,'2010-03-12 19:03:55',3310504092,1),(664605765,425608181,16448161,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605768,425608303,16446006,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605770,425605230,16430410,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605771,425594990,16478341,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605772,425595967,16473201,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605773,425599997,16476683,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605774,425599997,16472537,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605776,425599997,16470050,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605777,425600852,16466899,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605778,425603173,16460598,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605779,425605372,16455126,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605780,425597310,16468889,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605781,425598776,16463251,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605783,425601707,16458442,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605784,425604150,16453634,4108069,1,'2010-03-12 19:03:55',3310504095,1),(664605785,425445530,16532196,4108069,1,'2010-03-12 19:03:55',3310504097,1),(664605786,425444797,16535181,4108069,1,'2010-03-12 19:03:56',3310504099,1),(664605787,425442598,16543306,4108069,1,'2010-03-12 19:03:56',3310504099,1),(664605788,425438933,16557401,4108069,1,'2010-03-12 19:03:56',3310504099,1),(664605790,425437842,16558712,4108069,1,'2010-03-12 19:03:56',3310504099,1),(664605791,425440979,16550844,4108069,1,'2010-03-12 19:03:56',3310504099,1),(664605792,425441978,16546610,4108069,1,'2010-03-12 19:03:56',3310504099,1),(664605793,425443619,16538470,4108069,1,'2010-03-12 19:03:56',3310504099,1),(664605794,425452371,16518101,4108069,1,'2010-03-12 19:03:56',3310504100,1),(664605795,425450905,16517936,4108069,1,'2010-03-12 19:03:56',3310504097,1),(664605796,425449317,16518101,4108069,1,'2010-03-12 19:03:56',3310504097,1),(664605797,425447729,16520423,4108069,1,'2010-03-12 19:03:56',3310504097,1),(664605799,425447362,16522910,4108069,1,'2010-03-12 19:03:56',3310504097,1),(664605800,425446850,16527222,4108069,1,'2010-03-12 19:03:56',3310504097,1),(664605801,425448197,16518729,4108069,1,'2010-03-12 19:03:56',3310504097,1),(664605803,425453700,16517824,4108069,1,'2010-03-12 19:03:56',3310504100,1),(664605804,425454528,16518198,4108069,1,'2010-03-12 19:03:56',3310504100,1),(664605805,425456976,16517995,4108069,1,'2010-03-12 19:03:56',3310504100,1),(664605806,425471551,16509313,4108069,1,'2010-03-12 19:03:56',3310504100,1),(664605807,425466176,16509976,4108069,1,'2010-03-12 19:03:56',3310504100,1),(664605808,425464832,16511966,4108069,1,'2010-03-12 19:03:56',3310504100,1),(664605809,425462267,16515117,4108069,1,'2010-03-12 19:03:56',3310504100,1),(664605811,425459585,16516968,4108069,1,'2010-03-12 19:03:57',3310504100,1),(664605812,425466766,16509234,4108069,1,'2010-03-12 19:03:57',3310504100,1),(664605813,425469276,16508922,4108069,1,'2010-03-12 19:03:57',3310504100,1),(664605814,425485356,16490243,4108069,1,'2010-03-12 19:03:57',3310504101,1),(664605815,425485356,16494886,4108069,1,'2010-03-12 19:03:57',3310504101,1),(664605816,425484256,16501353,4108069,1,'2010-03-12 19:03:57',3310504101,1),(664605817,425484731,16484108,4108069,1,'2010-03-12 19:03:57',3310504101,1),(664605818,425482913,16507489,4108069,1,'2010-03-12 19:03:57',3310504101,1),(664605819,425481447,16510971,4108069,1,'2010-03-12 19:03:57',3310504101,1),(664605820,425478637,16512961,4108069,1,'2010-03-12 19:03:57',3310504100,1),(664605821,425475949,16512132,4108069,1,'2010-03-12 19:03:57',3310504100,1),(664605822,425479130,16513439,4108069,1,'2010-03-12 19:03:57',3310504100,1),(664605823,425480596,16512200,4108069,1,'2010-03-12 19:03:57',3310504101,1),(664605824,425426548,16605671,4133447,1,'2010-03-15 12:47:10',3310504105,2),(664605825,425522452,16526145,4108069,1,'2010-03-12 19:03:57',3310504112,1),(664605826,425526055,16528997,4108069,1,'2010-03-12 19:03:57',3310504112,1),(664605827,425531959,16530763,4108069,1,'2010-03-12 19:03:57',3310504112,1),(664605828,425582409,16503546,4108069,1,'2010-03-12 19:03:57',3310504116,1),(664605829,425582409,16496582,4108069,1,'2010-03-12 19:03:58',3310504116,1),(664605830,425582531,16493763,4108069,1,'2010-03-12 19:03:58',3310504116,1),(664605831,425584485,16490446,4108069,1,'2010-03-12 19:03:58',3310504116,1),(664605832,425586195,16485471,4108069,1,'2010-03-12 19:03:58',3310504116,1),(664605833,425590593,16482984,4108069,1,'2010-03-12 19:03:58',3310504117,1),(664605834,425592913,16481658,4108069,1,'2010-03-12 19:03:58',3310504117,1),(664605836,425604761,16500395,4108069,1,'2010-03-12 19:03:58',3310504117,1),(664605837,425604150,16493597,4108069,1,'2010-03-12 19:03:58',3310504117,1),(664605838,425603051,16486466,4108069,1,'2010-03-12 19:03:58',3310504117,1),(664605839,425601463,16481823,4108069,1,'2010-03-12 19:03:58',3310504117,1),(664605840,425588516,16534057,4108069,1,'2010-03-12 19:03:58',3310504116,1),(664605841,425587173,16529083,4108069,1,'2010-03-12 19:03:58',3310504116,1),(664605842,425586073,16523776,4108069,1,'2010-03-12 19:03:58',3310504116,1),(664605843,425585096,16518802,4108069,1,'2010-03-12 19:03:58',3310504116,1),(664605844,425583875,16511837,4108069,1,'2010-03-12 19:03:58',3310504116,1),(664605846,425608182,16533096,4108069,1,'2010-03-12 19:03:58',3310504117,1),(664605847,425603051,16528585,4108069,1,'2010-03-12 19:03:58',3310504117,1),(664605848,425603051,16522450,4108069,1,'2010-03-12 19:03:58',3310504117,1),(664605849,425604150,16517144,4108069,1,'2010-03-12 19:03:58',3310504117,1),(664605850,425604883,16508852,4108069,1,'2010-03-12 19:03:58',3310504117,1),(664605851,425563379,16541970,4108069,1,'2010-03-12 19:03:58',3310504118,1),(664605853,425565431,16543668,4108069,1,'2010-03-12 19:03:58',3310504118,1),(664605854,425566932,16545910,4108069,1,'2010-03-12 19:03:58',3310504118,1),(664605855,425571134,16569818,4108069,1,'2010-03-12 19:03:58',3310504118,1),(664605856,425592424,16553683,4108069,1,'2010-03-12 19:03:58',3310504119,1),(664605857,425589495,16552166,4108069,1,'2010-03-12 19:03:58',3310504119,1),(664605858,425593035,16554785,4108069,1,'2010-03-12 19:03:58',3310504119,1),(664605860,425598599,16550606,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605861,425603211,16547316,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605864,425606494,16544026,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605866,425607901,16542540,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605869,425610325,16540417,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605871,425597434,16546196,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605874,425602808,16540558,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605876,425601707,16551800,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605878,425608547,16548318,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605886,425589738,16563740,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605888,425593035,16567554,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605890,425595967,16570372,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605891,425600120,16574850,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605892,425606837,16581317,4108069,1,'2010-03-12 19:03:59',3310504119,1),(664605893,425621098,16428287,4108069,1,'2010-03-12 19:03:59',3310504138,1),(664605894,425661555,16474229,4108069,1,'2010-03-12 19:03:59',3310504139,1),(664605895,425664608,16467762,4108069,1,'2010-03-12 19:03:59',3310504139,1),(664605896,425672099,16422794,4108069,1,'2010-03-12 19:03:59',3310504140,1),(664605897,425672064,16422633,4108069,1,'2010-03-12 19:04:00',3310504140,1),(664605898,425670714,16448195,4108069,1,'2010-03-12 19:04:00',3310504139,1),(664605899,425671080,16440899,4108069,1,'2010-03-12 19:04:00',3310504139,1),(664605900,425671447,16433105,4108069,1,'2010-03-12 19:04:00',3310504139,1),(664605901,425671691,16427633,4108069,1,'2010-03-12 19:04:00',3310504139,1),(664605903,425667172,16463119,4108069,1,'2010-03-12 19:04:00',3310504139,1),(664605904,425669493,16455491,4108069,1,'2010-03-12 19:04:00',3310504139,1),(664605905,425621129,16518504,4108069,1,'2010-03-12 19:04:00',3310504160,1),(664605906,425615249,16531503,4108069,1,'2010-03-12 19:04:00',3310504117,1),(664605907,425616969,16528425,4108069,1,'2010-03-12 19:04:00',3310504160,1),(664605908,425612579,16525966,4108069,1,'2010-03-12 19:04:00',3310504117,1),(664605909,425615755,16522815,4108069,1,'2010-03-12 19:04:00',3310504117,1),(664605911,425621033,16525029,4108069,1,'2010-03-12 19:04:00',3310504160,1),(664605912,425620517,16532068,4108069,1,'2010-03-12 19:04:00',3310504160,1),(664605913,425622104,16528917,4108069,1,'2010-03-12 19:04:00',3310504160,1),(664605914,425623570,16526430,4108069,1,'2010-03-12 19:04:00',3310504160,1),(664605915,425629788,16519404,4108069,1,'2010-03-12 19:04:00',3310504160,1),(664605916,425625648,16516016,4108069,1,'2010-03-12 19:04:00',3310504160,1),(664605917,425635338,16515372,4108069,1,'2010-03-12 19:04:01',3310504160,1),(664605918,425632243,16510876,4108069,1,'2010-03-12 19:04:01',3310504160,1),(664605919,425624551,16522482,4108069,1,'2010-03-12 19:04:01',3310504160,1),(664605920,425625524,16525766,4108069,1,'2010-03-12 19:04:01',3310504160,1),(664605921,425627356,16525766,4108069,1,'2010-03-12 19:04:01',3310504160,1),(664605922,425629066,16526595,4108069,1,'2010-03-12 19:04:01',3310504160,1),(664605923,425630776,16530409,4108069,1,'2010-03-12 19:04:01',3310504160,1),(664605924,425633585,16534389,4108069,1,'2010-03-12 19:04:01',3310504160,1),(664605925,425647062,16506563,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605926,425649564,16506139,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605927,425638594,16506730,4108069,1,'2010-03-12 19:04:01',3310504160,1),(664605928,425643602,16501922,4108069,1,'2010-03-12 19:04:01',3310504160,1),(664605929,425647021,16497279,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605930,425649342,16492470,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605931,425652299,16506245,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605933,425655582,16506775,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605934,425657380,16506775,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605935,425660272,16506775,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605936,425662226,16506351,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605937,425664649,16505184,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605939,425652395,16487163,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605940,425656181,16480696,4108069,1,'2010-03-12 19:04:01',3310504161,1),(664605941,425639481,16512188,4108069,1,'2010-03-12 19:04:01',3310504160,1),(664605942,425641278,16510171,4108069,1,'2010-03-12 19:04:02',3310504160,1),(664605943,425644249,16508155,4108069,1,'2010-03-12 19:04:02',3310504160,1),(664605945,425652882,16529414,4108069,1,'2010-03-12 19:04:02',3310504161,1),(664605946,425612122,16538826,4108069,1,'2010-03-12 19:04:02',3310504119,1),(664605948,425613373,16535430,4108069,1,'2010-03-12 19:04:02',3310504119,1),(664605949,425612089,16545665,4108069,1,'2010-03-12 19:04:02',3310504119,1),(664605950,425616242,16541685,4108069,1,'2010-03-12 19:04:02',3310504119,1),(664605951,425617707,16539695,4108069,1,'2010-03-12 19:04:02',3310504162,1),(664605952,425618807,16536711,4108069,1,'2010-03-12 19:04:02',3310504162,1),(664605953,425637127,16538866,4108069,1,'2010-03-12 19:04:02',3310504162,1),(664605954,425615998,16589110,4108069,1,'2010-03-12 19:04:02',3310504119,1),(664605955,425638592,16539695,4108069,1,'2010-03-12 19:04:02',3310504162,1),(664605956,425640180,16539695,4108069,1,'2010-03-12 19:04:02',3310504162,1),(664605958,425643722,16538369,4108069,1,'2010-03-12 19:04:02',3310504162,1),(664605959,425648363,16534721,4108069,1,'2010-03-12 19:04:02',3310504163,1),(664605960,425650625,16561134,4108069,1,'2010-03-12 19:04:02',3310504163,1),(664605961,425651407,16551370,4108069,1,'2010-03-12 19:04:02',3310504163,1),(664605962,425650547,16558268,4108069,1,'2010-03-12 19:04:02',3310504163,1),(664605963,425651954,16542668,4108069,1,'2010-03-12 19:04:02',3310504163,1),(664605964,425645857,16583102,4108069,1,'2010-03-12 19:04:02',3310504163,1),(664605965,425647733,16575992,4108069,1,'2010-03-12 19:04:02',3310504163,1),(664605966,425649765,16568563,4108069,1,'2010-03-12 19:04:02',3310504163,1),(664605968,425645857,16581404,4108069,1,'2010-03-12 19:04:03',3310504163,1),(664605969,425673090,16492236,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605970,425674419,16490432,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605971,425675748,16489371,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605972,425676608,16488840,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605973,425678014,16487779,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605974,425666290,16503592,4108069,1,'2010-03-12 19:04:03',3310504161,1),(664605976,425667775,16501575,4108069,1,'2010-03-12 19:04:03',3310504161,1),(664605977,425668713,16499665,4108069,1,'2010-03-12 19:04:03',3310504161,1),(664605978,425670042,16497118,4108069,1,'2010-03-12 19:04:03',3310504161,1),(664605979,425671214,16495102,4108069,1,'2010-03-12 19:04:03',3310504161,1),(664605980,425679421,16486611,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605981,425680437,16484807,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605982,425681766,16483428,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605983,425682860,16483003,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605984,425683564,16483640,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605985,425685361,16485656,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605986,425686690,16486824,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605987,425688800,16488734,4108069,1,'2010-03-12 19:04:03',3310504164,1),(664605988,425691927,16489901,4108069,1,'2010-03-12 19:04:04',3310504164,1),(664605989,425694740,16490538,4108069,1,'2010-03-12 19:04:04',3310504164,1),(664605990,425699039,16489689,4108069,1,'2010-03-12 19:04:04',3310504164,1),(664605991,425703338,16488840,4108069,1,'2010-03-12 19:04:04',3310504165,1),(664605992,425707245,16487673,4108069,1,'2010-03-12 19:04:04',3310504165,1),(664605993,425709746,16486399,4108069,1,'2010-03-12 19:04:04',3310504165,1),(664605994,425713263,16485126,4108069,1,'2010-03-12 19:04:04',3310504165,1),(664605996,425716155,16485232,4108069,1,'2010-03-12 19:04:05',3310504165,1),(664605997,425719047,16485232,4108069,1,'2010-03-12 19:04:05',3310504165,1),(664605998,425619784,16592427,4108069,1,'2010-03-12 19:04:05',3310504168,1),(664605999,425623204,16595246,4108069,1,'2010-03-12 19:04:05',3310504168,1),(664606000,425624669,16598065,4108069,1,'2010-03-12 19:04:05',3310504168,1),(664606001,425626013,16600055,4108069,1,'2010-03-12 19:04:05',3310504168,1),(664606002,425627723,16601215,4108069,1,'2010-03-12 19:04:05',3310504168,1),(664606004,425629677,16600552,4108069,1,'2010-03-12 19:04:05',3310504168,1),(664606005,425631264,16600055,4108069,1,'2010-03-12 19:04:05',3310504168,1),(664606006,425633829,16599391,4108069,1,'2010-03-12 19:04:05',3310504168,1),(664606007,425635295,16599391,4108069,1,'2010-03-12 19:04:05',3310504168,1),(664606008,425636638,16600718,4108069,1,'2010-03-12 19:04:05',3310504168,1),(664606010,425635928,16679546,4108069,1,'2010-03-12 19:04:05',3310504170,1),(664606011,425634211,16685505,4108069,1,'2010-03-12 19:04:05',3310504170,1),(664606012,425632493,16692760,4108069,1,'2010-03-12 19:04:05',3310504170,1),(664606013,425631158,16698201,4108069,1,'2010-03-12 19:04:05',3310504170,1),(664606014,425642035,16654672,4108069,1,'2010-03-12 19:04:05',3310504170,1),(664606015,425643180,16660373,4108069,1,'2010-03-12 19:04:05',3310504170,1),(664606016,425643180,16665554,4108069,1,'2010-03-12 19:04:05',3310504170,1),(664606018,425642607,16669700,4108069,1,'2010-03-12 19:04:06',3310504170,1),(664606019,425640508,16673587,4108069,1,'2010-03-12 19:04:06',3310504170,1),(664606020,425637837,16677214,4108069,1,'2010-03-12 19:04:06',3310504170,1),(664606021,425721235,16485762,4108069,1,'2010-03-12 19:04:06',3310504165,1),(664606022,425723423,16485762,4108069,1,'2010-03-12 19:04:06',3310504165,1),(664606023,425725455,16485762,4108069,1,'2010-03-12 19:04:06',3310504165,1),(664606024,425728035,16486718,4108069,1,'2010-03-12 19:04:06',3310504176,1),(664606025,425732567,16488309,4108069,1,'2010-03-12 19:04:06',3310504176,1),(664606027,425735225,16489689,4108069,1,'2010-03-12 19:04:06',3310504176,1),(664606028,425739836,16491918,4108069,1,'2010-03-12 19:04:06',3310504176,1),(664606029,425743743,16494465,4108069,1,'2010-03-12 19:04:06',3310504176,1),(664606030,425747260,16496906,4108069,1,'2010-03-12 19:04:06',3310504176,1),(664606031,425751636,16500089,4108069,1,'2010-03-12 19:04:06',3310504176,1),(664606033,425753590,16502106,4108069,1,'2010-03-12 19:04:06',3310504176,1),(664606034,425755075,16503273,4108069,1,'2010-03-12 19:04:06',3310504177,1),(664606035,425756794,16504122,4108069,1,'2010-03-12 19:04:06',3310504177,1),(664606036,425759139,16504441,4108069,1,'2010-03-12 19:04:06',3310504177,1),(664606037,425761405,16504122,4108069,1,'2010-03-12 19:04:06',3310504177,1),(664606039,425764844,16501469,4108069,1,'2010-03-12 19:04:06',3310504177,1),(664606040,425767188,16498710,4108069,1,'2010-03-12 19:04:06',3310504177,1),(664606041,425771721,16492979,4108069,1,'2010-03-12 19:04:06',3310504177,1),(664606042,425774065,16491069,4108069,1,'2010-03-12 19:04:06',3310504177,1),(664606043,425763978,16502523,4108069,1,'2010-03-12 19:04:06',3310504177,1),(664606044,425769721,16495627,4108069,1,'2010-03-12 19:04:07',3310504177,1),(664606045,425768393,16497221,4108069,1,'2010-03-12 19:04:07',3310504177,1),(664606046,425775159,16490432,4108069,1,'2010-03-12 19:04:07',3310504177,1),(664606048,425600852,16712995,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606049,425603103,16715168,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606050,425604954,16716934,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606051,425606855,16718157,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606052,425609357,16718157,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606054,425609307,16732556,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606055,425608706,16736563,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606056,425610757,16718157,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606057,425613209,16718157,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606058,425614359,16718428,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606059,425615260,16719243,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606060,425615010,16721009,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606061,425613759,16722911,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606062,425612008,16725832,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664606063,425631921,16702865,4108069,1,'2010-03-12 19:04:07',3310504512,1),(664606064,425632684,16705974,4108069,1,'2010-03-12 19:04:07',3310504512,1),(664606066,425634211,16707269,4108069,1,'2010-03-12 19:04:07',3310504512,1),(664606067,425636883,16707269,4108069,1,'2010-03-12 19:04:07',3310504512,1),(664606068,425611007,16727598,4108069,1,'2010-03-12 19:04:07',3310504469,1),(664651800,425198662,16949126,4108991,1,'2010-03-12 22:26:21',3310493536,1),(664651806,425191454,16928967,4108991,1,'2010-03-12 22:26:21',3310493536,1),(664651809,425255889,16978902,4108991,1,'2010-03-12 22:26:22',3310493542,1),(664651811,425268783,17005201,4108991,1,'2010-03-12 22:26:22',3310493543,1),(664651813,425258091,16985314,4108991,1,'2010-03-12 22:26:22',3310493542,1),(664651814,425272227,17016123,4108991,1,'2010-03-12 22:26:22',3310493543,1),(664651816,425260587,17132954,4108991,1,'2010-03-12 22:26:22',3310493551,1),(664651818,425298575,16965481,4108991,1,'2010-03-12 22:26:22',3310493552,1),(664651819,425317992,17004329,4108991,1,'2010-03-12 22:26:22',3310493555,1),(664651821,425321754,17009714,4108991,1,'2010-03-12 22:26:22',3310493555,1),(664651823,425214988,17144946,4108991,1,'2010-03-12 22:26:22',3310493633,1),(664651824,425253838,17236284,4108991,1,'2010-03-12 22:26:22',3310493638,1),(664651826,425239571,17224313,4108991,1,'2010-03-12 22:26:22',3310493638,1),(664651828,425280701,17202245,4108991,1,'2010-03-12 22:26:22',3310493639,1),(664651829,425264120,17240557,4108991,1,'2010-03-12 22:26:22',3310493639,1),(664651832,425283581,17200875,4108991,1,'2010-03-12 22:26:22',3310493639,1),(664651834,425319551,17182165,4108991,1,'2010-03-12 22:26:22',3310493649,1),(664651836,425309478,17196318,4108991,1,'2010-03-12 22:26:22',3310493650,1),(664651837,425334272,17269211,4108991,1,'2010-03-12 22:26:22',3310493657,1),(664651839,425347097,17254884,4108991,1,'2010-03-12 22:26:22',3310493660,1),(664651841,425371726,17262329,4108991,1,'2010-03-12 22:26:22',3310493661,1),(665238087,425658572,14464436,4115604,1,'2010-03-13 17:05:52',3310501995,1),(665238091,425664492,14474049,4115604,1,'2010-03-13 17:05:52',3310501995,1),(665238092,425667239,14493523,4115604,1,'2010-03-13 17:05:52',3310501995,1),(665238096,425674197,14507694,4115604,1,'2010-03-13 17:05:52',3310502084,1),(665240662,425672366,14500982,4115657,1,'2010-03-13 17:11:32',3310501998,1),(666793593,425388567,16614420,4133447,1,'2010-03-15 12:47:08',3310493181,1),(666793594,425546210,16163470,4133447,1,'2010-03-15 12:47:08',3310503993,1),(666793595,425547414,16164034,4133447,1,'2010-03-15 12:47:08',3310503993,1),(666793596,425546791,16165105,4133447,1,'2010-03-15 12:47:08',3310503993,1),(666793597,425547360,16162001,4133447,1,'2010-03-15 12:47:09',3310503993,1),(666793598,425489306,16470723,4133447,1,'2010-03-15 12:47:09',3310504079,1),(666793599,425489094,16471502,4133447,1,'2010-03-15 12:47:09',3310504079,1),(666793600,425489626,16471473,4159615,1,'2010-03-18 11:15:41',3310504079,2),(666793601,425488817,16470779,4159615,1,'2010-03-18 11:15:41',3310504079,2),(666793602,425527445,16281598,4159615,1,'2010-03-18 11:15:41',3310504080,2),(666793603,425528151,16283055,4133447,1,'2010-03-15 12:47:09',3310504080,1),(666793604,425464893,16589234,4133447,1,'2010-03-15 12:47:09',3310504102,1),(666793605,425426490,16610980,4133447,1,'2010-03-15 12:47:09',3310504105,1),(666793606,425425321,16606075,4133447,1,'2010-03-15 12:47:09',3310504105,1),(666793607,425426087,16606738,4159615,1,'2010-03-18 11:15:41',3310504105,2),(666793608,425424343,16611182,4133447,1,'2010-03-15 12:47:09',3310504104,1),(666793609,425466097,16591151,4133447,1,'2010-03-15 12:47:09',3310504108,1),(666793610,425544735,16533601,4159615,1,'2010-03-18 11:15:40',3310504113,2),(666793611,425545665,16534503,4133447,1,'2010-03-15 12:47:09',3310504113,1),(666793612,425677646,16410755,4133447,1,'2010-03-15 12:47:09',3310504140,1),(666793613,425678230,16412604,4133447,1,'2010-03-15 12:47:09',3310504140,1),(666793614,425679462,16411107,4133447,1,'2010-03-15 12:47:09',3310504140,1),(666793615,425680500,16414894,4133447,1,'2010-03-15 12:47:09',3310504140,1),(666793616,425648663,16630216,4133447,1,'2010-03-15 12:47:09',3310504169,1),(666793617,425647054,16630216,4133447,1,'2010-03-15 12:47:09',3310504169,1),(666793618,425645757,16641558,4133447,1,'2010-03-15 12:47:09',3310504169,1),(666793619,425642215,16650964,4133447,1,'2010-03-15 12:47:10',3310504170,1),(666793620,425536628,16805993,4133447,1,'2010-03-15 12:47:10',3310504467,1),(666793621,425535997,16806489,4133447,1,'2010-03-15 12:47:10',3310504467,1),(666793622,425608331,16706959,4133447,1,'2010-03-15 12:47:10',3310504469,1),(666793623,425609792,16705471,4133447,1,'2010-03-15 12:47:10',3310504469,1),(668878334,425665203,14449171,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878337,425664136,14456895,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878339,425661173,14457056,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878340,425657855,14462286,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878342,425656077,14464539,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878344,425654773,14466068,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878346,425653944,14468964,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878348,425654003,14471217,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878349,425654536,14474114,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878351,425655544,14478781,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878353,425656314,14483769,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878354,425656788,14488356,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878356,425657203,14492781,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878358,425657440,14494551,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878359,425658210,14496724,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878361,425659514,14498977,4161539,1,'2010-03-18 16:04:13',3310501995,1),(668878362,425662062,14501632,4161539,1,'2010-03-18 16:04:14',3310501995,1),(668878364,425668213,14456626,4161539,1,'2010-03-18 16:04:14',3310501995,1),(668878366,425672935,14457883,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878367,425676917,14459014,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878369,425665559,14463654,4161539,1,'2010-03-18 16:04:14',3310501995,1),(668878371,425667574,14470895,4161539,1,'2010-03-18 16:04:14',3310501995,1),(668878372,425679509,14460146,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878374,425680806,14460146,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878376,425682195,14460146,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878377,425680898,14460523,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878379,425684046,14460900,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878380,425681917,14463792,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878382,425682472,14467438,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878383,425683028,14472592,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878385,425685991,14460774,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878386,425687843,14460774,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878388,425689417,14461655,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878389,425690898,14464672,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878390,425691917,14467312,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878391,425692657,14472592,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878392,425689855,14461642,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878393,425692284,14464056,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878394,425669529,14476769,4161539,1,'2010-03-18 16:04:14',3310501995,1),(668878395,425670892,14480068,4161539,1,'2010-03-18 16:04:14',3310501995,1),(668878396,425673381,14484574,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878397,425675633,14487873,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878398,425676996,14490528,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878399,425677766,14494230,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878400,425678418,14499299,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878401,425684139,14477998,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878402,425686176,14482273,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878403,425688213,14488056,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878404,425689324,14490319,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878405,425689972,14493588,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878406,425690435,14496354,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878407,425690528,14500251,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878408,425693491,14477370,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878409,425693768,14481267,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878410,425693861,14487176,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878411,425694139,14489439,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878412,425694046,14492834,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878413,425694046,14496228,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878414,425694416,14499874,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878415,425694655,14467757,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878416,425696788,14473068,4161539,1,'2010-03-18 16:04:14',3310501998,1),(668878417,425698743,14479746,4161539,1,'2010-03-18 16:04:15',3310501998,1),(668878419,425700462,14485298,4161539,1,'2010-03-18 16:04:15',3310501999,1),(668878420,425702180,14490931,4161539,1,'2010-03-18 16:04:15',3310501999,1),(668878422,425704017,14495356,4161539,1,'2010-03-18 16:04:15',3310501999,1),(668878423,425705617,14499299,4161539,1,'2010-03-18 16:04:15',3310501999,1),(668878425,425664670,14503483,4161539,1,'2010-03-18 16:04:15',3310502081,1),(668878427,425667514,14504207,4161539,1,'2010-03-18 16:04:15',3310502081,1),(668878429,425669885,14505092,4161539,1,'2010-03-18 16:04:15',3310502081,1),(668878430,425672018,14506460,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878432,425673914,14508632,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878434,425675396,14512092,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878435,425677114,14517644,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878437,425678477,14522391,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878439,425685435,14511189,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878440,425684232,14513704,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878442,425679188,14505414,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878444,425679959,14510322,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878446,425680433,14515069,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878447,425690343,14505406,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878449,425692194,14506286,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878450,425689509,14507418,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878452,425687009,14508675,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878454,425691917,14509178,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878456,425691361,14513704,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878457,425692483,14508096,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878459,425683861,14517727,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878461,425683676,14522630,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878462,425683954,14526150,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878464,425680433,14518851,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878465,425680077,14521989,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878467,425691176,14519613,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878469,425690805,14523510,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878471,425684232,14530550,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878472,425684880,14535454,4161539,1,'2010-03-18 16:04:15',3310502084,1),(668878488,425685806,14541488,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878490,425686731,14546894,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878492,425688028,14553432,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878493,425691083,14529796,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878495,425692009,14537465,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878497,425687129,14550151,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878498,425694879,14503394,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878500,425696361,14507669,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878501,425698583,14513452,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878503,425699787,14518607,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878505,425700990,14524264,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878506,425706802,14502115,4161539,1,'2010-03-18 16:04:16',3310501999,1),(668878508,425707810,14506218,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878510,425708461,14511851,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878511,425709113,14519092,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878513,425709647,14528265,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878515,425701638,14530802,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878516,425702564,14537339,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878518,425702935,14541614,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878520,425702935,14544631,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878521,425703490,14551295,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878523,425693491,14544757,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878525,425694324,14548277,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878526,425694509,14550666,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878528,425695435,14554186,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878530,425695805,14556449,4161539,1,'2010-03-18 16:04:16',3310502084,1),(668878531,425706091,14548059,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878533,425704965,14548381,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878534,425704017,14548783,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878536,425703484,14549427,4161539,1,'2010-03-18 16:04:16',3310502085,1),(668878538,425710061,14533576,4161539,1,'2010-03-18 16:04:17',3310502085,1),(668878539,425710595,14537921,4161539,1,'2010-03-18 16:04:17',3310502085,1),(668878541,425711365,14542024,4161539,1,'2010-03-18 16:04:17',3310502085,1),(668878543,425711780,14544760,4161539,1,'2010-03-18 16:04:17',3310502085,1),(668878544,425712669,14547978,4161539,1,'2010-03-18 16:04:17',3310502085,1),(668878546,425712669,14548864,4161539,1,'2010-03-18 16:04:17',3310502085,1),(668878548,425712609,14549910,4161539,1,'2010-03-18 16:04:17',3310502085,1),(668878549,425711898,14550151,4161539,1,'2010-03-18 16:04:17',3310502085,1),(668878551,425710950,14549829,4161539,1,'2010-03-18 16:04:17',3310502085,1),(668878553,425708343,14548542,4161539,1,'2010-03-18 16:04:17',3310502085,1),(668878554,425690250,14561855,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878556,425692102,14569399,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878558,425691040,14592233,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878560,425686655,14558278,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878562,425687129,14564876,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878565,425688551,14573807,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878567,425690921,14584911,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878569,425691040,14593440,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878571,425691632,14600520,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878573,425691751,14605187,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878576,425691988,14608889,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878579,425704231,14558084,4161539,1,'2010-03-18 16:04:17',3310502087,1),(668878580,425705897,14566381,4161539,1,'2010-03-18 16:04:17',3310502087,1),(668878583,425693028,14575056,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878586,425694046,14579834,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878588,425695898,14559592,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878591,425696639,14561604,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878592,425699231,14564747,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878595,425699783,14564899,4161539,1,'2010-03-18 16:04:17',3310502087,1),(668878598,425707101,14572165,4161539,1,'2010-03-18 16:04:17',3310502087,1),(668878599,425708675,14578451,4161539,1,'2010-03-18 16:04:17',3310502087,1),(668878602,425709416,14583102,4161539,1,'2010-03-18 16:04:17',3310502087,1),(668878604,425695157,14586748,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878607,425696083,14592029,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878608,425696639,14594543,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878611,425697892,14590984,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878613,425696906,14590160,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878615,425693055,14594808,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878617,425699789,14594125,4161539,1,'2010-03-18 16:04:17',3310502087,1),(668878620,425701306,14597267,4161539,1,'2010-03-18 16:04:17',3310502087,1),(668878622,425698755,14600120,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878625,425699423,14601586,4161539,1,'2010-03-18 16:04:17',3310502087,1),(668878629,425695603,14598992,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878630,425694299,14599153,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878633,425695484,14601969,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878634,425697677,14606233,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878636,425692758,14611061,4161539,1,'2010-03-18 16:04:17',3310502086,1),(668878638,425699726,14603286,4161539,1,'2010-03-18 16:04:17',3310502087,1),(668878639,425699874,14604764,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878641,425699922,14607220,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878642,425699899,14608609,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878644,425700036,14610412,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878645,425702292,14600099,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878647,425703316,14603034,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878649,425704491,14606433,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878650,425705515,14609368,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878652,425706350,14611325,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878653,425699632,14610900,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878655,425711082,14588006,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878657,425711916,14592029,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878658,425712934,14597686,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878660,425714138,14604852,4161539,1,'2010-03-18 16:04:18',3310502087,1),(668878661,425700128,14612784,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878663,425700343,14614119,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878664,425700877,14617015,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878666,425703365,14623694,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878668,425695247,14616693,4161539,1,'2010-03-18 16:04:18',3310502092,1),(668878669,425697677,14621843,4161539,1,'2010-03-18 16:04:18',3310502092,1),(668878671,425700166,14626993,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878673,425703010,14633510,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878674,425705321,14638901,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878676,425707753,14613951,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878678,425709080,14616526,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878679,425710104,14618998,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878681,425710711,14621212,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878683,425711583,14625332,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878684,425715526,14612522,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878686,425716545,14615539,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878687,425717378,14618682,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878689,425718489,14622831,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878691,425712114,14627495,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878692,425712569,14628988,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878694,425713138,14630636,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878696,425712872,14635116,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878697,425706506,14629406,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878699,425709647,14634878,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878700,425711898,14638257,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878702,425712846,14638257,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878703,425719322,14628488,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878705,425720063,14635277,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878707,425713631,14633005,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878708,425713783,14635940,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878710,425714150,14638177,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878712,425714742,14637131,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878713,425714979,14635843,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878715,425715394,14633993,4161539,1,'2010-03-18 16:04:18',3310502093,1),(668878716,425716520,14631901,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878718,425717764,14630613,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878720,425719127,14631016,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878721,425719779,14631820,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878723,425707513,14643005,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878725,425709824,14647430,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878726,425711069,14651373,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878728,425711957,14658775,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878729,425713380,14666097,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878731,425708521,14643890,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878745,425712017,14647993,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878746,425714565,14652177,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878748,425716402,14657166,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878750,425717764,14663844,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878752,425715098,14674224,4161539,1,'2010-03-18 16:04:19',3310502095,1),(668878753,425717053,14681787,4161539,1,'2010-03-18 16:04:19',3310502095,1),(668878755,425718239,14686535,4161539,1,'2010-03-18 16:04:19',3310502095,1),(668878757,425719187,14690880,4161539,1,'2010-03-18 16:04:19',3310502095,1),(668878759,425718179,14669396,4161539,1,'2010-03-18 16:04:19',3310502095,1),(668878761,425718831,14676075,4161539,1,'2010-03-18 16:04:19',3310502095,1),(668878762,425719305,14682351,4161539,1,'2010-03-18 16:04:19',3310502095,1),(668878764,425719957,14687581,4161539,1,'2010-03-18 16:04:19',3310502095,1),(668878766,425722841,14645587,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878767,425723952,14647724,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878769,425724507,14649484,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878771,425724878,14651496,4161539,1,'2010-03-18 16:04:19',3310502093,1),(668878772,425721382,14640407,4161539,1,'2010-03-18 16:04:20',3310502093,1),(668878774,425721737,14642273,4161539,1,'2010-03-18 16:04:20',3310502093,1),(668878775,425722070,14643575,4161539,1,'2010-03-18 16:04:20',3310502093,1),(668878777,425725537,14654523,4161539,1,'2010-03-18 16:04:20',3310502093,1),(668878779,425725705,14655879,4161539,1,'2010-03-18 16:04:20',3310502093,1),(668878780,425725171,14657246,4161539,1,'2010-03-18 16:04:20',3310502093,1),(668878782,425723571,14659741,4161539,1,'2010-03-18 16:04:20',3310502093,1),(668878783,425722860,14660706,4161539,1,'2010-03-18 16:04:20',3310502093,1),(668878785,425722327,14661913,4161539,1,'2010-03-18 16:04:20',3310502093,1),(668878787,425722683,14664247,4161539,1,'2010-03-18 16:04:20',3310502093,1),(668878788,425728312,14662235,4161539,1,'2010-03-18 16:04:20',3310502104,1),(668878790,425729141,14659178,4161539,1,'2010-03-18 16:04:20',3310502104,1),(668878792,425731571,14661028,4161539,1,'2010-03-18 16:04:20',3310502104,1),(668878794,425733230,14663442,4161539,1,'2010-03-18 16:04:20',3310502104,1),(668878795,425734533,14666017,4161539,1,'2010-03-18 16:04:20',3310502104,1),(668878797,425722979,14668592,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878799,425724045,14676397,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878800,425725053,14682914,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878802,425725645,14686696,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878804,425726830,14690880,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878805,425727719,14693213,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878807,425721024,14692087,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878809,425729793,14667867,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878810,425730563,14672132,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878812,425732223,14676236,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878814,425733645,14681144,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878816,425734474,14685408,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878817,425735600,14689753,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878819,425736311,14671730,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878820,425738563,14678247,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878822,425740222,14683397,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878823,425741525,14686696,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878825,425742533,14688949,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878826,425743718,14689995,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878828,425745732,14692006,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878830,425725722,14706909,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878831,425726830,14698846,4161539,1,'2010-03-18 16:04:20',3310502106,1),(668878833,425726179,14701501,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878834,425725764,14703995,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878836,425720786,14696834,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878837,425722327,14702708,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878839,425723275,14706811,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878840,425722149,14698202,4161539,1,'2010-03-18 16:04:20',3310502095,1),(668878841,425723216,14703271,4161539,1,'2010-03-18 16:04:21',3310502095,1),(668878843,425723512,14704397,4161539,1,'2010-03-18 16:04:21',3310502095,1),(668878845,425723512,14706731,4161539,1,'2010-03-18 16:04:21',3310502095,1),(668878847,425728016,14695225,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878848,425727660,14697317,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878850,425722979,14708421,4161539,1,'2010-03-18 16:04:21',3310502095,1),(668878852,425737141,14694420,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878854,425739274,14699811,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878855,425739925,14700857,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878857,425741762,14702627,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878859,425744073,14704076,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878860,425745673,14703995,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878862,425746977,14703271,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878863,425747806,14694179,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878865,425749524,14697317,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878867,425749998,14698363,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878869,425749998,14699892,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878870,425749347,14700696,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668878872,425747865,14702627,4161539,1,'2010-03-18 16:04:21',3310502106,1),(668901202,426185361,14830769,4161868,1,'2010-03-18 16:47:26',3310502386,1),(668901203,426171038,14827441,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901204,426170671,14825279,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901205,426171159,14824667,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901206,426172674,14823934,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901207,426175267,14822678,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901208,426177706,14822364,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901209,426179220,14822853,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901210,426180068,14824283,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901211,426180992,14826062,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901212,426181955,14826970,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901213,426183118,14827406,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901214,426184001,14827406,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901215,426185926,14826643,4161868,1,'2010-03-18 16:47:27',3310502386,1),(668901216,426195553,14802930,4161868,1,'2010-03-18 16:47:27',3310502387,1),(668901217,426199444,14801676,4161868,1,'2010-03-18 16:47:27',3310502387,1),(668901218,426202132,14800858,4161868,1,'2010-03-18 16:47:27',3310502387,1),(668901219,426204138,14799877,4161868,1,'2010-03-18 16:47:27',3310502387,1),(668901220,426205502,14798514,4161868,1,'2010-03-18 16:47:27',3310502387,1),(668901221,426205822,14796443,4161868,1,'2010-03-18 16:47:27',3310502387,1),(668901222,426206103,14792954,4161868,1,'2010-03-18 16:47:27',3310502387,1),(668901223,426206183,14790555,4161868,1,'2010-03-18 16:47:27',3310502387,1),(668901224,426206825,14788320,4161868,1,'2010-03-18 16:47:27',3310502387,1),(668901225,426207628,14786412,4161868,1,'2010-03-18 16:47:27',3310502387,1),(668901227,426208350,14784995,4161868,1,'2010-03-18 16:47:27',3310502387,1),(668901228,426209473,14784123,4161868,1,'2010-03-18 16:47:28',3310502387,1),(668901229,426211157,14784123,4161868,1,'2010-03-18 16:47:28',3310502387,1),(668901230,426213725,14784123,4161868,1,'2010-03-18 16:47:28',3310502387,1),(668901231,426187565,14827608,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901232,426191482,14824613,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901233,426197236,14821120,4161868,1,'2010-03-18 16:47:28',3310502387,1),(668901234,426188052,14825280,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901235,426190218,14822554,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901236,426191301,14820864,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901237,426191622,14818575,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901238,426190980,14816830,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901239,426190740,14814922,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901240,426190740,14812306,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901241,426190900,14809962,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901242,426191422,14808054,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901243,426192104,14806255,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901244,426193467,14804510,4161868,1,'2010-03-18 16:47:28',3310502386,1),(668901245,426201520,14819290,4161868,1,'2010-03-18 16:47:28',3310502387,1),(668901246,426207886,14817793,4161868,1,'2010-03-18 16:47:28',3310502387,1),(668901247,426212538,14815963,4161868,1,'2010-03-18 16:47:28',3310502387,1),(668901248,426224779,14803652,4161868,1,'2010-03-18 16:47:28',3310502390,1),(668901249,426215169,14784014,4161868,1,'2010-03-18 16:47:28',3310502387,1),(668901250,426216693,14783687,4161868,1,'2010-03-18 16:47:28',3310502387,1),(668901251,426218418,14784723,4161868,1,'2010-03-18 16:47:28',3310502387,1),(668901252,426219782,14785922,4161868,1,'2010-03-18 16:47:28',3310502387,1),(668901253,426221867,14786958,4161868,1,'2010-03-18 16:47:28',3310502390,1),(668901254,426224074,14787666,4161868,1,'2010-03-18 16:47:28',3310502390,1),(668901255,426225437,14788484,4161868,1,'2010-03-18 16:47:28',3310502390,1),(668901256,426228696,14798162,4161868,1,'2010-03-18 16:47:28',3310502390,1),(668901257,426231022,14793172,4161868,1,'2010-03-18 16:47:28',3310502390,1),(668901258,426234572,14790843,4161868,1,'2010-03-18 16:47:28',3310502390,1),(668901259,426229048,14789411,4161868,1,'2010-03-18 16:47:28',3310502390,1),(668901260,426232577,14790501,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901261,426236588,14791155,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901262,426241281,14791046,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901263,426224657,14830769,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901264,426228084,14829105,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901265,426216945,14812802,4161868,1,'2010-03-18 16:47:29',3310502387,1),(668901266,426220495,14808643,4161868,1,'2010-03-18 16:47:29',3310502387,1),(668901267,426231022,14827774,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901268,426233103,14823948,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901269,426234817,14820787,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901270,426236408,14819623,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901271,426238856,14818458,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901272,426254280,14803652,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901273,426254280,14798661,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901274,426255259,14794502,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901275,426244731,14791755,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901276,426248501,14792245,4161868,1,'2010-03-18 16:47:29',3310502390,1),(668901277,426251590,14792245,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901278,426254759,14790991,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901280,426257165,14789738,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901281,426260585,14788210,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901282,426265521,14782747,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901283,426266989,14781416,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901284,426268360,14781949,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901285,426266451,14781941,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901286,426268106,14781532,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901287,426265325,14789002,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901288,426265423,14786074,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901289,426264317,14790344,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901290,426263142,14788073,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901291,426264145,14787324,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901292,426265348,14785757,4161868,1,'2010-03-18 16:47:29',3310502391,1),(668901293,426265749,14783712,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901294,426269144,14784078,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901295,426269144,14786873,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901296,426255924,14793794,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901297,426258176,14793794,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901298,426261114,14795124,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901299,426256850,14792173,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901300,426259910,14791009,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901301,426261869,14790510,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901302,426263268,14799516,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901303,426264835,14802577,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901304,426267969,14801513,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901305,426266500,14794592,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901306,426269242,14790466,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901307,426266765,14791841,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901308,426268968,14795002,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901309,426244242,14816795,4161868,1,'2010-03-18 16:47:30',3310502390,1),(668901310,426250118,14814798,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901311,426252933,14812636,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901312,426254892,14811138,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901313,426254892,14807811,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901314,426254769,14811305,4161868,1,'2010-03-18 16:47:30',3310502391,1);
INSERT INTO `nodes` VALUES (668901315,426266500,14807368,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901316,426267479,14808300,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901317,426268458,14807635,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901318,426269046,14806171,4161868,1,'2010-03-18 16:47:30',3310502391,1),(668901319,426257952,14811305,4161868,1,'2010-03-18 16:47:31',3310502391,1),(668901320,426262113,14811637,4161868,1,'2010-03-18 16:47:31',3310502391,1),(668901321,426265786,14811637,4161868,1,'2010-03-18 16:47:31',3310502391,1),(668901322,426173119,14837589,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901323,426171528,14831767,4161868,1,'2010-03-18 16:47:31',3310502386,1),(668901324,426175568,14848403,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901325,426185606,14844576,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901326,426178016,14853726,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901327,426184137,14854392,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901328,426187075,14855057,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901329,426175568,14847072,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901330,426178506,14845741,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901331,426181444,14843745,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901332,426183035,14841915,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901333,426183770,14837257,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901334,426183770,14832599,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901335,426174955,14844743,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901336,426181861,14863894,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901337,426184120,14863510,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901338,426186610,14863964,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901339,426195399,14840750,4161868,1,'2010-03-18 16:47:31',3310502393,1),(668901340,426190136,14855722,4161868,1,'2010-03-18 16:47:31',3310502392,1),(668901341,426194420,14855722,4161868,1,'2010-03-18 16:47:31',3310502393,1),(668901342,426196868,14856721,4161868,1,'2010-03-18 16:47:31',3310502393,1),(668901343,426198582,14858717,4161868,1,'2010-03-18 16:47:31',3310502393,1),(668901344,426200296,14854558,4161868,1,'2010-03-18 16:47:31',3310502393,1),(668901345,426200051,14847737,4161868,1,'2010-03-18 16:47:31',3310502393,1),(668901347,426200541,14842746,4161868,1,'2010-03-18 16:47:31',3310502393,1),(668901348,426202867,14838255,4161868,1,'2010-03-18 16:47:31',3310502393,1),(668901349,426201031,14858717,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901350,426201031,14856554,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901351,426201643,14839586,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901352,426203846,14837756,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901353,426206172,14837090,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901354,426208988,14837090,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901355,426212170,14836425,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901356,426214252,14834928,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901357,426188639,14864069,4161868,1,'2010-03-18 16:47:32',3310502392,1),(668901358,426190256,14863510,4161868,1,'2010-03-18 16:47:32',3310502392,1),(668901359,426192002,14863789,4161868,1,'2010-03-18 16:47:32',3310502392,1),(668901360,426193260,14864801,4161868,1,'2010-03-18 16:47:32',3310502392,1),(668901361,426193568,14871639,4161868,1,'2010-03-18 16:47:32',3310502392,1),(668901362,426194261,14866092,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901363,426194543,14867592,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901364,426194543,14868953,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901365,426194158,14870348,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901366,426193491,14872965,4161868,1,'2010-03-18 16:47:32',3310502392,1),(668901367,426193799,14874326,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901368,426194672,14876000,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901369,426195981,14877745,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901370,426197727,14879698,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901371,426199627,14881652,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901372,426197553,14880214,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901373,426198630,14885271,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901374,426201809,14883990,4161868,1,'2010-03-18 16:47:32',3310502393,1),(668901375,426199707,14891792,4161868,1,'2010-03-18 16:47:32',3310502395,1),(668901376,426204658,14888246,4161868,1,'2010-03-18 16:47:32',3310502395,1),(668901377,426207174,14891944,4161868,1,'2010-03-18 16:47:32',3310502395,1),(668901378,426201176,14897914,4161868,1,'2010-03-18 16:47:32',3310502395,1),(668901379,426208920,14894770,4161868,1,'2010-03-18 16:47:32',3310502395,1),(668901380,426210666,14897735,4161868,1,'2010-03-18 16:47:32',3310502395,1),(668901381,426211821,14900108,4161868,1,'2010-03-18 16:47:32',3310502395,1),(668901382,426202254,14902705,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901383,426203233,14905234,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901384,426204996,14907497,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901385,426212642,14903073,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901386,426213438,14907295,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901387,426214234,14911830,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901388,426207738,14910691,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901389,426208913,14913086,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901390,426209697,14916280,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901391,426209892,14919874,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901392,426211753,14924532,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901393,426214299,14928258,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901394,426219638,14832266,4161868,1,'2010-03-18 16:47:33',3310502393,1),(668901395,426229329,14854340,4161868,1,'2010-03-18 16:47:33',3310502396,1),(668901396,426230269,14856043,4161868,1,'2010-03-18 16:47:33',3310502396,1),(668901397,426230112,14858279,4161868,1,'2010-03-18 16:47:33',3310502396,1),(668901398,426230817,14861579,4161868,1,'2010-03-18 16:47:33',3310502396,1),(668901399,426232149,14865093,4161868,1,'2010-03-18 16:47:33',3310502396,1),(668901400,426235440,14870629,4161868,1,'2010-03-18 16:47:33',3310502396,1),(668901401,426237712,14873611,4161868,1,'2010-03-18 16:47:33',3310502396,1),(668901402,426239435,14877337,4161868,1,'2010-03-18 16:47:33',3310502396,1),(668901403,426240532,14881489,4161868,1,'2010-03-18 16:47:33',3310502396,1),(668901404,426241080,14887452,4161868,1,'2010-03-18 16:47:33',3310502398,1),(668901405,426241864,14891284,4161868,1,'2010-03-18 16:47:33',3310502398,1),(668901406,426241557,14913577,4161868,1,'2010-03-18 16:47:33',3310502398,1),(668901407,426215261,14915493,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901408,426216159,14918773,4161868,1,'2010-03-18 16:47:33',3310502395,1),(668901409,426217546,14922890,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901410,426218752,14927599,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901411,426223005,14925518,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901412,426224648,14922593,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901413,426225782,14919601,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901414,426226306,14917803,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901415,426227025,14916826,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901416,426227703,14916547,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901417,426219214,14929030,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901418,426219358,14929805,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901419,426219473,14930163,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901420,426219736,14930073,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901421,426219933,14929783,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901422,426220048,14929247,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901423,426220590,14928778,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901424,426221198,14928711,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901425,426217531,14932650,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901426,426218706,14932650,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901427,426219098,14932384,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901428,426219686,14931452,4161868,1,'2010-03-18 16:47:34',3310502395,1),(668901429,426221872,14927885,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901430,426222134,14934114,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901432,426224288,14936509,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901433,426228627,14916547,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901434,426229531,14916659,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901435,426230311,14916714,4161868,1,'2010-03-18 16:47:34',3310502398,1),(668901436,426231400,14916687,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901437,426232652,14916714,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901438,426234809,14916156,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901439,426236370,14915654,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901440,426238649,14914761,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901441,426242255,14895543,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901442,426242569,14899908,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901443,426242882,14903315,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901444,426243587,14905338,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901445,426245389,14906403,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901446,426247426,14908213,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901447,426248993,14910875,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901448,426244412,14912768,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901449,426246445,14912796,4161868,1,'2010-03-18 16:47:35',3310502398,1),(668901450,426248786,14913521,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901451,426250696,14914638,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901452,426252093,14916201,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901453,426253592,14917624,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901454,426254639,14918880,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901455,426256405,14921420,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901456,426257986,14923765,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901457,426259506,14925942,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901458,426261108,14927867,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901459,426262237,14928788,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901460,426263613,14930547,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901461,426265277,14934175,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901462,426266837,14937608,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901463,426268172,14941181,4161868,1,'2010-03-18 16:47:35',3310502399,1),(668901464,426197560,15018516,4161868,1,'2010-03-18 16:47:35',3310502739,1),(668901465,426199566,15013542,4161868,1,'2010-03-18 16:47:35',3310502739,1),(668901466,426201521,15009181,4161868,1,'2010-03-18 16:47:35',3310502739,1),(668901467,426202324,15008704,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901468,426203477,15008363,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901469,426204630,15008772,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901470,426205783,15009862,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901471,426207187,15010680,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901472,426208742,15011157,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901473,426210497,15010680,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901474,426212302,15009317,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901475,426195254,15032757,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901476,426198362,15031463,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901477,426200218,15030713,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901478,426200819,15028805,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901479,426200519,15028055,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901480,426199967,15027306,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901481,426199817,15026488,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901482,426199817,15025125,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901483,426196708,15037595,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901484,426200418,15036982,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901485,426194401,15030917,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901486,426195855,15024444,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901487,426200870,15029895,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901488,426201020,15024717,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901489,426202524,15025466,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901490,426203326,15026556,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901491,426204430,15027919,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901492,426207037,15028669,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901493,426210447,15029214,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901494,426203377,15035619,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901495,426205533,15035210,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901496,426208541,15034256,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901497,426211098,15033098,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901498,426212803,15032008,4161868,1,'2010-03-18 16:47:36',3310502739,1),(668901499,426213806,15030509,4161868,1,'2010-03-18 16:47:37',3310502739,1),(668901500,426227912,14942232,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901501,426232612,14948487,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901502,426236138,14952480,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901503,426238292,14955940,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901504,426221578,14993985,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901505,426222280,14989692,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901506,426222781,14987648,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901507,426223633,14985400,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901508,426225088,14982742,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901510,426227795,14979540,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901511,426229751,14977632,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901512,426232859,14975587,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901513,426237171,14973543,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901514,426240480,14972044,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901515,426244657,14962461,4161868,1,'2010-03-18 16:47:37',3310502740,1),(668901516,426250827,14967386,4161868,1,'2010-03-18 16:47:37',3310502741,1),(668901517,426249706,14968092,4161868,1,'2010-03-18 16:47:37',3310502741,1),(668901518,426254469,14966320,4161868,1,'2010-03-18 16:47:37',3310502741,1),(668901519,426269384,14944334,4161868,1,'2010-03-18 16:47:37',3310502741,1),(668901520,426257678,14964957,4161868,1,'2010-03-18 16:47:37',3310502741,1),(668901521,426261037,14964480,4161868,1,'2010-03-18 16:47:37',3310502741,1),(668901522,426264747,14963799,4161868,1,'2010-03-18 16:47:37',3310502741,1),(668901523,426267254,14964208,4161868,1,'2010-03-18 16:47:37',3310502741,1),(668901524,426269410,14965775,4161868,1,'2010-03-18 16:47:37',3310502741,1),(668901525,426252463,14993985,4161868,1,'2010-03-18 16:47:37',3310502741,1),(668901526,426253416,14992145,4161868,1,'2010-03-18 16:47:37',3310502741,1),(668901527,426254770,14990851,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901528,426244943,14969932,4161868,1,'2010-03-18 16:47:38',3310502740,1),(668901529,426269522,14993838,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901530,426257076,14990033,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901531,426258129,14989488,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901532,426258781,14988398,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901533,426258981,14987308,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901534,426259081,14985331,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901535,426259081,14983628,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901536,426259533,14982197,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901537,426260385,14980902,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901538,426261388,14980902,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901539,426262591,14981175,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901540,426264246,14982265,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901541,426266201,14983832,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901542,426267956,14984991,4161868,1,'2010-03-18 16:47:38',3310502741,1),(668901543,426214859,15007000,4161868,1,'2010-03-18 16:47:38',3310502739,1),(668901544,426217065,15004411,4161868,1,'2010-03-18 16:47:38',3310502739,1),(668901545,426219171,15001958,4161868,1,'2010-03-18 16:47:38',3310502739,1),(668901546,426220274,15000118,4161868,1,'2010-03-18 16:47:38',3310502739,1),(668901547,426220826,14998074,4161868,1,'2010-03-18 16:47:38',3310502739,1),(668901548,426221828,15009589,4161868,1,'2010-03-18 16:47:38',3310502742,1),(668901549,426223333,15007886,4161868,1,'2010-03-18 16:47:38',3310502742,1),(668901550,426225388,15006182,4161868,1,'2010-03-18 16:47:38',3310502742,1),(668901551,426228046,15005024,4161868,1,'2010-03-18 16:47:38',3310502742,1),(668901552,426221026,15021446,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901553,426220575,15019879,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901554,426219873,15016880,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901555,426220124,15014223,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901556,426220976,15011838,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901557,426221578,15023490,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901558,426230302,15004751,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901559,426232157,15004751,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901560,426235717,15006319,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901561,426238023,15007273,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901562,426240129,15007886,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901563,426241734,15008090,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901564,426234865,15022672,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901565,426240039,15023757,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901566,426240289,15021286,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901567,426241417,15018050,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901568,426235817,15021378,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901569,426237973,15019879,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901570,426240330,15018243,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901571,426241884,15017562,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901572,426215009,15029078,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901573,426220124,15029214,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901574,426215711,15028328,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901575,426216714,15027033,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901576,426218569,15026420,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901577,426220224,15025466,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901579,426221076,15024989,4161868,1,'2010-03-18 16:47:39',3310502739,1),(668901580,426226040,15029963,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901581,426239036,15040195,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901582,426239161,15033978,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901583,426239788,15028271,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901584,426228748,15030440,4161868,1,'2010-03-18 16:47:39',3310502742,1),(668901585,426231405,15030440,4161868,1,'2010-03-18 16:47:40',3310502742,1),(668901586,426232558,15030372,4161868,1,'2010-03-18 16:47:40',3310502742,1),(668901587,426233661,15029623,4161868,1,'2010-03-18 16:47:40',3310502742,1),(668901588,426233762,15028396,4161868,1,'2010-03-18 16:47:40',3310502742,1),(668901589,426234012,15027374,4161868,1,'2010-03-18 16:47:40',3310502742,1),(668901590,426234213,15025125,4161868,1,'2010-03-18 16:47:40',3310502742,1),(668901591,426234313,15023831,4161868,1,'2010-03-18 16:47:40',3310502742,1),(668901592,426243589,15007886,4161868,1,'2010-03-18 16:47:40',3310502742,1),(668901593,426245093,15007273,4161868,1,'2010-03-18 16:47:40',3310502742,1),(668901594,426247249,15005705,4161868,1,'2010-03-18 16:47:40',3310502742,1),(668901595,426253074,15009447,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901596,426255519,15008680,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901597,426253253,15007357,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901598,426254986,15004959,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901599,426249104,15004138,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901600,426250508,15002026,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901601,426251611,14999777,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901602,426252313,14996983,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901603,426244864,15014558,4161868,1,'2010-03-18 16:47:40',3310502742,1),(668901604,426249377,15011321,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901605,426250526,15010584,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901606,426259530,15010384,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901607,426264105,15013706,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901608,426266611,15015835,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901609,426267990,15017283,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901610,426256430,15003171,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901611,426257938,15002298,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901612,426259703,15002080,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901613,426261628,15002691,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901614,426263137,15003345,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901615,426264163,15003432,4161868,1,'2010-03-18 16:47:40',3310502743,1),(668901616,426264869,15003127,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901617,426265704,15001775,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901618,426266634,14999769,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901619,426267757,14996804,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901620,426244853,15043378,4161868,1,'2010-03-18 16:47:41',3310502742,1),(668901621,426249652,15047105,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901622,426254254,15048968,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901623,426256898,15048702,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901624,426258954,15046439,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901625,426261402,15043245,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901626,426263361,15040983,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901627,426266592,15039918,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901628,426268943,15041914,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901629,426267328,15026340,4161868,1,'2010-03-18 16:47:41',3310502743,1),(668901630,426324125,14757332,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901631,426323454,14757153,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901632,426322653,14757153,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901633,426321877,14757386,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901634,426321181,14757868,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901635,426320826,14758332,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901636,426320537,14758958,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901637,426320498,14759261,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901638,426320721,14760333,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901639,426321155,14761298,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901640,426321904,14762298,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901641,426322482,14763120,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901642,426323034,14763995,4161868,1,'2010-03-18 16:47:41',3310503073,1),(668901643,426323546,14765156,4161868,1,'2010-03-18 16:47:42',3310503073,1),(668901644,426324190,14767156,4161868,1,'2010-03-18 16:47:42',3310503073,1),(668901645,426269660,14782350,4161868,1,'2010-03-18 16:47:42',3310502391,1),(668901646,426272117,14783781,4161868,1,'2010-03-18 16:47:42',3310502391,1),(668901647,426275977,14783781,4161868,1,'2010-03-18 16:47:42',3310502391,1),(668901648,426281992,14785252,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901649,426278348,14788603,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901650,426280307,14786208,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901651,426282167,14784877,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901652,426282265,14785941,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901653,426282657,14788071,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901654,426278484,14783917,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901655,426281492,14784666,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901656,426270515,14792330,4161868,1,'2010-03-18 16:47:42',3310502391,1),(668901657,426272081,14795790,4161868,1,'2010-03-18 16:47:42',3310502391,1),(668901658,426273158,14799383,4161868,1,'2010-03-18 16:47:42',3310502391,1),(668901659,426274040,14802577,4161868,1,'2010-03-18 16:47:42',3310502391,1),(668901660,426275117,14802843,4161868,1,'2010-03-18 16:47:42',3310502391,1),(668901661,426275704,14803110,4161868,1,'2010-03-18 16:47:42',3310502391,1),(668901662,426271294,14800159,4161868,1,'2010-03-18 16:47:42',3310502391,1),(668901663,426276488,14800980,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901664,426276586,14796988,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901665,426276586,14793261,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901666,426276880,14790999,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901667,426283832,14784477,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901668,426285497,14784744,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901669,426286769,14786740,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901670,426287357,14787938,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901672,426289609,14790200,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901673,426283538,14790466,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901674,426285497,14793660,4161868,1,'2010-03-18 16:47:42',3310503074,1),(668901675,426287847,14795391,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901676,426291959,14791132,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901677,426296463,14792063,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901678,426290197,14798318,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901679,426291959,14800049,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901680,426273619,14805149,4161868,1,'2010-03-18 16:47:43',3310502391,1),(668901681,426275455,14809308,4161868,1,'2010-03-18 16:47:43',3310502391,1),(668901682,426277659,14812636,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901683,426280229,14815630,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901684,426270070,14812303,4161868,1,'2010-03-18 16:47:43',3310502391,1),(668901685,426275088,14813135,4161868,1,'2010-03-18 16:47:43',3310502391,1),(668901686,426279127,14814133,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901687,426293722,14804307,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901688,426295484,14808433,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901689,426284268,14820621,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901690,426287206,14822617,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901691,426290878,14825445,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901692,426293448,14827275,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901693,426295774,14830270,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901694,426299401,14791930,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901695,426301555,14791664,4161868,1,'2010-03-18 16:47:43',3310503074,1),(668901696,426304493,14792729,4161868,1,'2010-03-18 16:47:43',3310503075,1),(668901697,426306353,14794326,4161868,1,'2010-03-18 16:47:43',3310503075,1),(668901698,426307626,14797653,4161868,1,'2010-03-18 16:47:43',3310503075,1),(668901699,426308899,14801513,4161868,1,'2010-03-18 16:47:43',3310503075,1),(668901700,426324243,14791593,4161868,1,'2010-03-18 16:47:43',3310503075,1),(668901701,426323836,14793968,4161868,1,'2010-03-18 16:47:43',3310503075,1),(668901702,426323389,14795201,4161868,1,'2010-03-18 16:47:43',3310503075,1),(668901703,426322797,14796362,4161868,1,'2010-03-18 16:47:43',3310503075,1),(668901704,426321693,14797684,4161868,1,'2010-03-18 16:47:43',3310503075,1),(668901705,426320682,14798738,4161868,1,'2010-03-18 16:47:43',3310503075,1),(668901706,426319775,14799684,4161868,1,'2010-03-18 16:47:43',3310503075,1),(668901707,426319302,14800577,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901708,426318999,14801506,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901709,426318921,14802596,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901710,426318999,14803793,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901711,426310661,14807235,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901712,426297443,14810562,4161868,1,'2010-03-18 16:47:44',3310503074,1),(668901713,426299793,14814156,4161868,1,'2010-03-18 16:47:44',3310503074,1),(668901714,426301555,14818015,4161868,1,'2010-03-18 16:47:44',3310503074,1),(668901715,426302339,14820810,4161868,1,'2010-03-18 16:47:44',3310503074,1),(668901716,426303220,14823206,4161868,1,'2010-03-18 16:47:44',3310503074,1),(668901717,426305276,14826932,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901718,426307430,14828130,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901719,426310564,14827864,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901720,426312228,14810696,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901721,426313403,14814023,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901723,426314774,14815620,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901724,426319236,14805061,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901725,426320261,14808098,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901726,426321417,14811063,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901727,426322443,14813438,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901728,426323047,14814528,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901729,426323389,14815564,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901730,426323507,14816564,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901731,426323270,14817797,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901732,426314406,14825019,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901733,426315459,14818281,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901734,426315459,14821209,4161868,1,'2010-03-18 16:47:44',3310503075,1),(668901735,426315068,14825069,4161868,1,'2010-03-18 16:47:45',3310503075,1),(668901736,426313011,14826666,4161868,1,'2010-03-18 16:47:45',3310503075,1),(668901737,426319598,14825625,4161868,1,'2010-03-18 16:47:45',3310503075,1),(668901738,426322732,14819280,4161868,1,'2010-03-18 16:47:45',3310503075,1),(668901739,426322193,14820476,4161868,1,'2010-03-18 16:47:45',3310503075,1),(668901740,426321115,14822334,4161868,1,'2010-03-18 16:47:45',3310503075,1),(668901741,426320064,14824085,4161868,1,'2010-03-18 16:47:45',3310503075,1),(668901742,426319499,14825103,4161868,1,'2010-03-18 16:47:45',3310503075,1),(668901743,426330682,14756743,4161868,1,'2010-03-18 16:47:45',3310503073,1),(668901744,426330157,14757118,4161868,1,'2010-03-18 16:47:45',3310503073,1),(668901745,426329670,14758172,4161868,1,'2010-03-18 16:47:45',3310503073,1),(668901746,426329145,14759065,4161868,1,'2010-03-18 16:47:45',3310503073,1),(668901747,426328632,14759333,4161868,1,'2010-03-18 16:47:45',3310503073,1),(668901748,426328028,14759315,4161868,1,'2010-03-18 16:47:45',3310503073,1),(668901749,426327134,14759029,4161868,1,'2010-03-18 16:47:45',3310503073,1),(668901750,426325544,14758011,4161868,1,'2010-03-18 16:47:45',3310503073,1),(668901751,426337700,14761691,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901752,426335847,14759279,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901753,426334953,14758118,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901754,426333850,14757296,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901755,426332903,14756885,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901756,426331957,14756689,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901757,426331353,14756618,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901758,426324716,14769050,4161868,1,'2010-03-18 16:47:45',3310503073,1),(668901759,426325058,14771819,4161868,1,'2010-03-18 16:47:45',3310503073,1),(668901760,426325347,14775623,4161868,1,'2010-03-18 16:47:45',3310503073,1),(668901761,426344244,14776356,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901762,426344231,14774534,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901763,426344231,14773230,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901764,426343942,14771872,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901765,426343088,14769872,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901766,426341826,14767657,4161868,1,'2010-03-18 16:47:45',3310503076,1),(668901767,426340552,14765424,4161868,1,'2010-03-18 16:47:46',3310503076,1),(668901768,426339316,14763495,4161868,1,'2010-03-18 16:47:46',3310503076,1),(668901769,426379273,14744837,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901770,426372054,14756230,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901771,426371352,14756639,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901772,426370951,14757048,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901774,426370901,14757934,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901775,426371152,14758888,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901776,426372355,14760796,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901777,426379072,14749825,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901778,426377769,14752074,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901779,426376114,14753982,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901780,426374109,14755549,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901781,426374711,14762567,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901782,426371954,14776264,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901783,426376465,14764543,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901784,426377668,14766588,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901785,426378120,14767405,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901786,426378120,14768019,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901787,426377719,14768496,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901788,426376967,14768496,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901789,426375914,14768496,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901790,426375212,14768768,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901791,426374160,14769518,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901792,426373157,14771085,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901793,426372606,14773470,4161868,1,'2010-03-18 16:47:46',3310503077,1),(668901794,426351722,14790682,4161868,1,'2010-03-18 16:47:46',3310503078,1),(668901795,426351222,14787591,4161868,1,'2010-03-18 16:47:46',3310503078,1),(668901796,426350999,14786216,4161868,1,'2010-03-18 16:47:46',3310503078,1),(668901797,426350605,14785180,4161868,1,'2010-03-18 16:47:46',3310503078,1),(668901798,426349829,14784144,4161868,1,'2010-03-18 16:47:46',3310503078,1),(668901799,426348620,14783018,4161868,1,'2010-03-18 16:47:46',3310503078,1),(668901800,426346965,14781071,4161868,1,'2010-03-18 16:47:47',3310503078,1),(668901801,426344954,14778499,4161868,1,'2010-03-18 16:47:47',3310503078,1),(668901802,426344520,14777713,4161868,1,'2010-03-18 16:47:47',3310503078,1),(668901803,426325491,14778982,4161868,1,'2010-03-18 16:47:47',3310503075,1),(668901804,426325347,14783394,4161868,1,'2010-03-18 16:47:47',3310503075,1),(668901805,426325137,14787002,4161868,1,'2010-03-18 16:47:47',3310503075,1),(668901806,426365187,14796024,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901807,426364786,14798137,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901808,426364034,14800658,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901809,426363432,14802361,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901810,426355863,14803315,4161868,1,'2010-03-18 16:47:47',3310503078,1),(668901811,426355010,14800522,4161868,1,'2010-03-18 16:47:47',3310503078,1),(668901812,426353857,14797796,4161868,1,'2010-03-18 16:47:47',3310503078,1),(668901813,426353055,14795615,4161868,1,'2010-03-18 16:47:47',3310503078,1),(668901814,426352077,14793164,4161868,1,'2010-03-18 16:47:47',3310503078,1),(668901815,426370801,14778580,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901816,426370199,14780897,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901817,426369548,14783282,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901818,426369197,14786212,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901819,426368595,14788052,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901820,426367292,14790778,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901821,426366039,14793367,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901822,426362179,14804201,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901823,426360675,14805632,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901824,426359773,14806177,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901825,426358519,14806382,4161868,1,'2010-03-18 16:47:47',3310503079,1),(668901826,426358068,14806041,4161868,1,'2010-03-18 16:47:48',3310503078,1),(668901827,426357266,14805496,4161868,1,'2010-03-18 16:47:48',3310503078,1),(668901828,426356464,14804133,4161868,1,'2010-03-18 16:47:48',3310503078,1),(668901829,426286946,14861242,4161868,1,'2010-03-18 16:47:48',3310503080,1),(668901831,426289374,14859113,4161868,1,'2010-03-18 16:47:48',3310503080,1),(668901833,426291568,14854854,4161868,1,'2010-03-18 16:47:48',3310503080,1),(668901834,426295171,14847188,4161868,1,'2010-03-18 16:47:48',3310503080,1),(668901835,426296581,14844207,4161868,1,'2010-03-18 16:47:48',3310503080,1),(668901836,426298069,14841652,4161868,1,'2010-03-18 16:47:48',3310503080,1),(668901837,426300028,14840800,4161868,1,'2010-03-18 16:47:48',3310503080,1),(668901838,426304023,14839203,4161868,1,'2010-03-18 16:47:48',3310503081,1),(668901839,426307156,14837180,4161868,1,'2010-03-18 16:47:48',3310503081,1),(668901840,426309584,14834092,4161868,1,'2010-03-18 16:47:48',3310503081,1),(668901842,426298099,14834262,4161868,1,'2010-03-18 16:47:48',3310503080,1),(668901843,426301159,14839087,4161868,1,'2010-03-18 16:47:48',3310503080,1),(668901844,426302383,14842414,4161868,1,'2010-03-18 16:47:48',3310503080,1),(668901845,426303730,14846240,4161868,1,'2010-03-18 16:47:48',3310503081,1),(668901846,426306667,14849733,4161868,1,'2010-03-18 16:47:48',3310503081,1),(668901847,426313697,14833187,4161868,1,'2010-03-18 16:47:48',3310503081,1),(668901848,426312620,14841439,4161868,1,'2010-03-18 16:47:48',3310503081,1),(668901849,426315753,14855013,4161868,1,'2010-03-18 16:47:48',3310503081,1),(668901850,426311196,14854225,4161868,1,'2010-03-18 16:47:48',3310503081,1),(668901851,426314011,14859715,4161868,1,'2010-03-18 16:47:48',3310503081,1),(668901852,426316826,14866203,4161868,1,'2010-03-18 16:47:48',3310503081,1),(668901853,426329052,14910768,4161868,1,'2010-03-18 16:47:48',3310503083,1),(668901854,426330305,14916731,4161868,1,'2010-03-18 16:47:48',3310503083,1),(668901855,426332185,14924077,4161868,1,'2010-03-18 16:47:48',3310503086,1),(668901856,426334221,14931956,4161868,1,'2010-03-18 16:47:48',3310503086,1),(668901857,426380425,14746077,4161868,1,'2010-03-18 16:47:48',3310503077,1),(668901858,426270513,14947125,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901859,426271458,14949330,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901860,426272588,14951172,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901861,426273594,14953545,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901862,426274805,14956587,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901863,426275463,14958485,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901864,426276366,14960411,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901865,426271716,14968296,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901866,426277742,14962979,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901867,426278871,14965239,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901868,426279241,14966412,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901869,426279672,14967974,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901870,426273922,14970886,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901871,426276930,14975383,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901872,426280309,14970096,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901873,426280781,14972887,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901874,426280822,14974645,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901875,426279426,14979027,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901876,426279788,14982401,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901877,426278935,14979131,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901878,426280720,14976459,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901879,426280206,14977966,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901881,426281342,14982333,4161868,1,'2010-03-18 16:47:49',3310503424,1),(668901882,426271383,14990655,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901883,426272923,14988649,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901884,426275458,14986250,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901885,426269610,14985877,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901886,426271967,14986762,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901887,426273521,14986626,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901888,426275977,14985877,4161868,1,'2010-03-18 16:47:49',3310502741,1),(668901889,426277481,14984173,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901890,426278635,14982742,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901891,426286164,14995904,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901892,426287856,14995904,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901893,426288671,14996160,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901894,426283297,14983287,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901895,426285403,14984037,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901896,426286556,14984923,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901897,426287659,14987171,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901898,426288210,14989488,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901899,426289213,14991873,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901900,426290517,14994803,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901901,426291369,14996098,4161868,1,'2010-03-18 16:47:50',3310503424,1),(668901902,426324430,14989236,4161868,1,'2010-03-18 16:47:50',3310503425,1),(668901903,426320043,14989236,4161868,1,'2010-03-18 16:47:50',3310503425,1),(668901904,426316989,14988810,4161868,1,'2010-03-18 16:47:50',3310503425,1),(668901905,426315187,14988917,4161868,1,'2010-03-18 16:47:50',3310503425,1),(668901906,426314404,14989982,4161868,1,'2010-03-18 16:47:50',3310503425,1),(668901907,426313150,14991579,4161868,1,'2010-03-18 16:47:50',3310503425,1),(668901908,426312915,14993814,4161868,1,'2010-03-18 16:47:50',3310503425,1),(668901909,426276998,15022514,4161868,1,'2010-03-18 16:47:50',3310503426,1),(668901910,426269745,15018390,4161868,1,'2010-03-18 16:47:50',3310502743,1),(668901911,426272189,15017539,4161868,1,'2010-03-18 16:47:50',3310502743,1),(668901912,426273505,15016261,4161868,1,'2010-03-18 16:47:50',3310502743,1),(668901913,426274445,15014047,4161868,1,'2010-03-18 16:47:50',3310502743,1),(668901914,426276952,15009362,4161868,1,'2010-03-18 16:47:50',3310503426,1),(668901915,426279584,15004251,4161868,1,'2010-03-18 16:47:50',3310503426,1),(668901916,426282530,14999907,4161868,1,'2010-03-18 16:47:50',3310503426,1),(668901917,426274592,15013899,4161868,1,'2010-03-18 16:47:50',3310502743,1),(668901918,426276806,15011805,4161868,1,'2010-03-18 16:47:50',3310503426,1),(668901919,426279212,15009756,4161868,1,'2010-03-18 16:47:50',3310503426,1),(668901920,426281490,15008622,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901921,426284472,14997437,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901922,426289799,14997437,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901923,426291366,14999567,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901924,426293371,15000674,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901925,426296505,15002037,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901926,426283897,15007619,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901927,426286271,15007052,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901928,426288517,15007052,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901929,426291437,15007357,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901930,426294614,15007575,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901931,426293876,14997392,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901932,426296432,14998346,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901933,426270999,15044443,4161868,1,'2010-03-18 16:47:51',3310502743,1),(668901934,426273153,15045641,4161868,1,'2010-03-18 16:47:51',3310502743,1),(668901935,426275503,15045641,4161868,1,'2010-03-18 16:47:51',3310502743,1),(668901936,426277364,15043644,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901937,426280399,15039252,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901938,426283141,15034594,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901939,426285100,15032465,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901941,426287156,15031800,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901942,426289212,15031933,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901943,426290681,15034861,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901944,426292150,15036458,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901945,426293912,15036458,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901949,426296654,15035659,4161868,1,'2010-03-18 16:47:51',3310503426,1),(668901951,426300408,15009954,4161868,1,'2010-03-18 16:47:52',3310503426,1),(668901953,426299701,15002633,4161868,1,'2010-03-18 16:47:52',3310503426,1),(668901954,426301769,15003144,4161868,1,'2010-03-18 16:47:52',3310503426,1),(668901956,426303210,15003740,4161868,1,'2010-03-18 16:47:52',3310503426,1),(668901957,426297180,15008055,4161868,1,'2010-03-18 16:47:52',3310503426,1),(668901959,426298656,15008578,4161868,1,'2010-03-18 16:47:52',3310503426,1),(668901960,426300293,15009058,4161868,1,'2010-03-18 16:47:52',3310503426,1),(668901962,426301576,15009232,4161868,1,'2010-03-18 16:47:52',3310503426,1),(668901964,426299390,14999368,4161868,1,'2010-03-18 16:47:52',3310503426,1),(668901965,426302699,14998823,4161868,1,'2010-03-18 16:47:52',3310503426,1),(668901966,426310656,15009840,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901968,426304900,15007828,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901972,426308389,15007283,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901973,426304839,15004251,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901975,426307597,15003825,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901976,426309289,15002889,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901978,426306058,14998006,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901979,426309166,14997324,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901980,426310520,14997529,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901982,426303117,15022084,4161868,1,'2010-03-18 16:47:52',3310503426,1),(668901983,426305956,15017559,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901984,426308208,15013966,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901986,426312524,14996476,4161868,1,'2010-03-18 16:47:52',3310503425,1),(668901987,426313072,14999244,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901989,426314012,15000948,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901991,426310793,15002889,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901992,426311921,15003059,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901993,426311623,14998006,4161868,1,'2010-03-18 16:47:52',3310503427,1),(668901994,426312225,14998755,4161868,1,'2010-03-18 16:47:53',3310503427,1),(668901995,426313378,15001004,4161868,1,'2010-03-18 16:47:53',3310503427,1),(668901996,426298906,15031134,4161868,1,'2010-03-18 16:47:53',3310503426,1),(668901998,426301256,15026210,4161868,1,'2010-03-18 16:47:53',3310503426,1),(668901999,426338138,14942177,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902000,426340879,14949523,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902002,426342133,14955698,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902003,426342368,14961448,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902005,426342054,14964642,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902007,426340879,14966771,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902011,426337041,14982635,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902013,426335083,14985616,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902015,426332185,14987852,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902016,426328033,14988704,4161868,1,'2010-03-18 16:47:53',3310503425,1),(668902018,426340253,14969539,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902019,426339939,14972308,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902021,426339939,14975076,4161868,1,'2010-03-18 16:47:53',3310503428,1),(668902022,426339391,14977951,4161868,1,'2010-03-18 16:47:53',3310503428,1),(669985285,426255468,16025472,4184201,1,'2010-03-20 22:04:06',3310504287,2),(669985286,426255539,16025065,4184201,1,'2010-03-20 22:04:06',3310504287,2),(669985287,426255726,16025677,4184201,1,'2010-03-20 22:04:07',3310504287,2),(669985289,426255357,16025354,4184201,1,'2010-03-20 22:04:07',3310504287,2),(669985291,426255467,16025471,4174714,1,'2010-03-19 23:59:12',3310504287,1),(669985299,426228104,16983392,4174714,1,'2010-03-19 23:59:13',3310504822,1),(669985301,426228020,16983740,4174714,1,'2010-03-19 23:59:13',3310504822,1),(669985341,426037316,14419303,4174714,1,'2010-03-19 23:59:16',3310502205,1),(669985348,426150236,14772623,4174714,1,'2010-03-19 23:59:17',3310502373,1),(669985685,425878196,17418899,4174714,1,'2010-03-19 23:59:51',3310504867,1),(669985690,425877973,17418476,4174714,1,'2010-03-19 23:59:51',3310504867,1),(669986979,426496768,15343333,4174714,1,'2010-03-20 00:00:54',3310503530,1),(669986980,426496919,15343575,4174714,1,'2010-03-20 00:00:54',3310503530,1),(669986981,426497055,15343468,4174714,1,'2010-03-20 00:00:54',3310503530,1),(669986982,426496894,15343268,4174714,1,'2010-03-20 00:00:54',3310503530,1),(690708536,425437782,17314963,4375683,1,'2010-04-09 21:07:05',3310504587,1),(769251745,425497543,17040945,4963942,1,'2010-06-11 20:05:20',3310504493,1),(769251759,425424601,17118147,4963942,1,'2010-06-11 20:05:21',3310504491,1),(769251779,425441839,17037443,4963942,1,'2010-06-11 20:05:23',3310504489,1),(769251780,425441601,17041044,4963942,1,'2010-06-11 20:05:23',3310504489,1),(769251784,425513448,16953105,4963942,1,'2010-06-11 20:05:25',3310504496,1),(769251786,425522126,16949892,4963942,1,'2010-06-11 20:05:26',3310504496,1),(769251787,425521374,16947687,4963942,1,'2010-06-11 20:05:26',3310504496,1),(769251788,425518665,16946673,4963942,1,'2010-06-11 20:05:26',3310504496,1),(769251789,425517434,16947655,4963942,1,'2010-06-11 20:05:26',3310504496,1),(769251791,425518542,16953816,4963942,1,'2010-06-11 20:05:27',3310504496,1),(769251793,425430929,17038607,4963942,1,'2010-06-11 20:05:27',3310504489,1),(769251804,425449663,17297929,4963942,1,'2010-06-11 20:05:34',3310504585,1),(769252942,425295139,15714850,4963967,1,'2010-06-11 20:09:40',3310491640,1),(769252948,425292324,15715067,4963967,1,'2010-06-11 20:09:41',3310491640,1),(769252949,425292718,15716811,4963967,1,'2010-06-11 20:09:41',3310491640,1),(769252950,425293615,15717388,4963967,1,'2010-06-11 20:09:41',3310491640,1),(769252951,425294696,15716923,4963967,1,'2010-06-11 20:09:41',3310491640,1),(769252988,425673544,16012998,4963967,1,'2010-06-11 20:09:43',3310504014,1),(769252996,425673029,16012530,4963967,1,'2010-06-11 20:09:44',3310504014,1),(769252999,425672737,16012515,4963967,1,'2010-06-11 20:09:44',3310504014,1),(769253007,425672019,16013480,4963967,1,'2010-06-11 20:09:44',3310504014,1),(769253012,425672717,16014776,4963967,1,'2010-06-11 20:09:44',3310504014,1),(769253015,425673221,16014675,4963967,1,'2010-06-11 20:09:44',3310504014,1),(769253018,425667669,16001347,4963967,1,'2010-06-11 20:09:45',3310504011,1),(769253019,425667626,16001098,4963967,1,'2010-06-11 20:09:45',3310504011,1),(769253020,425667448,16000795,4963967,1,'2010-06-11 20:09:45',3310504011,1),(769253021,425667012,16000670,4963967,1,'2010-06-11 20:09:45',3310504011,1),(769253022,425666695,16000945,4963967,1,'2010-06-11 20:09:46',3310504011,1),(769253024,425666588,16001464,4963967,1,'2010-06-11 20:09:46',3310504011,1),(769253025,425666724,16001881,4963967,1,'2010-06-11 20:09:46',3310504011,1),(769253026,425666872,16002039,4963967,1,'2010-06-11 20:09:46',3310504011,1),(769253028,425667161,16002124,4963967,1,'2010-06-11 20:09:46',3310504011,1),(769253029,425667344,16002064,4963967,1,'2010-06-11 20:09:47',3310504011,1),(769253030,425667606,16001735,4963967,1,'2010-06-11 20:09:47',3310504011,1),(779158284,425707005,16103265,5043123,1,'2010-06-21 17:17:14',3310504039,1),(796030198,425437639,17239695,5107412,1,'2010-06-29 20:14:39',3310504579,1),(796030199,425440643,17269735,5107412,1,'2010-06-29 20:14:39',3310504585,1),(796031914,425467834,16987782,5107412,1,'2010-06-29 20:15:31',3310504486,1),(796031930,425455820,17005162,5107412,1,'2010-06-29 20:15:32',3310504486,1),(796031933,425446492,17036920,5107412,1,'2010-06-29 20:15:32',3310504489,1),(796031937,425442224,17089920,5107412,1,'2010-06-29 20:15:32',3310504491,1),(796031941,425461194,17322521,5107412,1,'2010-06-29 20:15:32',3310504590,1),(796040771,424724830,14934661,5107450,1,'2010-06-29 20:18:46',3310490815,1),(796041497,424486585,14826729,5107450,1,'2010-06-29 20:19:04',3310490102,1),(796044564,424535231,14864280,5107450,1,'2010-06-29 20:20:40',3310490792,1),(796044575,424471187,14815786,5107450,1,'2010-06-29 20:20:40',3310490102,1),(820950476,425768000,16675220,5236475,1,'2010-07-16 20:30:26',3310504187,1),(820952919,425765610,16671820,5236475,1,'2010-07-16 20:31:32',3310504187,1),(820954183,425768070,16665090,5236785,1,'2010-07-16 21:17:52',3310504187,2),(821006310,425767440,16666650,5236785,1,'2010-07-16 21:18:26',3310504187,1),(840392122,426328793,15005308,5363414,1,'2010-07-31 18:32:50',3310503427,1),(840392129,426329740,15007239,5363414,1,'2010-07-31 18:32:50',3310503427,1),(840392132,426330687,15010887,5363414,1,'2010-07-31 18:32:51',3310503427,1),(840392146,426331477,15014749,5363414,1,'2010-07-31 18:32:51',3310503430,1),(840392147,426331950,15021615,5363414,1,'2010-07-31 18:32:51',3310503430,1),(840392149,426332424,15033417,5363414,1,'2010-07-31 18:32:51',3310503430,1),(840392151,426333687,15040713,5363414,1,'2010-07-31 18:32:51',3310503430,1),(840392153,426332897,15047365,5363414,1,'2010-07-31 18:32:51',3310503430,1),(840392156,426333687,15055948,5363414,1,'2010-07-31 18:32:51',3310503436,1),(840392161,426334160,15064102,5363414,1,'2010-07-31 18:32:51',3310503436,1),(840392165,426334160,15073328,5363414,1,'2010-07-31 18:32:52',3310503436,1),(840392168,426332739,15084272,5363414,1,'2010-07-31 18:32:52',3310503436,1),(840392171,426330529,15090065,5363414,1,'2010-07-31 18:32:52',3310503433,1),(840392172,426328793,15095430,5363414,1,'2010-07-31 18:32:52',3310503433,1),(840392174,426327688,15100365,5363414,1,'2010-07-31 18:32:52',3310503433,1),(840392177,426327688,15104442,5363414,1,'2010-07-31 18:32:52',3310503433,1),(840392179,426326741,15110665,5363414,1,'2010-07-31 18:32:52',3310503435,1),(840392182,426325162,15117102,5363414,1,'2010-07-31 18:32:52',3310503435,1),(840392185,426323425,15120321,5363414,1,'2010-07-31 18:45:28',3310503435,3),(840392187,426321373,15119033,5363414,1,'2010-07-31 18:44:40',3310503435,2),(840392190,426320899,15116458,5363414,1,'2010-07-31 18:32:52',3310503435,1),(840392214,426328004,15004235,5363414,1,'2010-07-31 18:32:54',3310503427,1),(840405569,426322005,15119892,5363414,1,'2010-07-31 18:45:05',3310503435,1),(840406394,426324373,15119248,5363414,1,'2010-07-31 18:45:27',3310503435,1),(894217167,425345988,15836955,5671193,1,'2010-09-03 17:32:57',3310493012,1),(894217168,425345692,15831606,5671193,1,'2010-09-03 17:32:57',3310493012,1),(894217170,425348346,15827049,5671193,1,'2010-09-03 17:32:57',3310493012,1),(894217183,425343267,15818827,5671193,1,'2010-09-03 17:32:57',3310491646,1),(894217186,425345464,15833937,5671193,1,'2010-09-03 17:32:57',3310493012,1),(894217188,425344217,15822092,5671193,1,'2010-09-03 17:32:57',3310493012,1),(894217189,425338605,15803705,5671193,1,'2010-09-03 17:32:57',3310491643,1),(894217190,425347958,15829068,5671193,1,'2010-09-03 17:32:57',3310493012,1),(894217191,425347306,15823825,5671193,1,'2010-09-03 17:32:57',3310493012,1),(894217192,425337803,15807019,5671193,1,'2010-09-03 17:32:58',3310491643,1),(894217194,425346939,15830863,5671193,1,'2010-09-03 17:32:58',3310493012,1),(894217204,425347959,15824835,5671193,1,'2010-09-03 17:32:58',3310493012,1),(894217206,425340060,15811613,5671193,1,'2010-09-03 17:32:58',3310491643,1),(894258957,425274169,15761738,5671401,1,'2010-09-03 18:05:34',3310491629,1),(894258960,425177524,15681080,5671401,1,'2010-09-03 18:05:34',3310491618,1),(894258963,425282402,15760328,5671401,1,'2010-09-03 18:05:34',3310491629,1),(894258967,425292595,15789838,5671401,1,'2010-09-03 18:05:34',3310491642,1),(894258969,425182999,15657036,5671401,1,'2010-09-03 18:05:34',3310491618,1),(894258972,425303698,15770095,5671401,1,'2010-09-03 18:05:34',3310491642,1),(894258974,425540029,15898783,5671401,1,'2010-09-03 18:05:34',3310503955,1),(894258982,425297139,15788922,5671401,1,'2010-09-03 18:05:34',3310491642,1),(894258985,425223309,15718295,5671401,1,'2010-09-03 18:05:35',3310491625,1),(894258989,425289685,15763772,5671401,1,'2010-09-03 18:05:35',3310491640,1),(894258992,425383090,15870042,5671401,1,'2010-09-03 18:05:35',3310493013,1),(894258994,425305785,15797714,5671401,1,'2010-09-03 18:05:35',3310491642,1),(894258996,425274728,15786288,5671401,1,'2010-09-03 18:05:35',3310491631,1),(894258997,425379477,15859907,5671401,1,'2010-09-03 18:05:35',3310493013,1),(894258998,425190953,15662303,5671401,1,'2010-09-03 18:05:35',3310491618,1),(894259008,425301055,15760906,5671401,1,'2010-09-03 18:05:35',3310491640,1),(894259010,425393661,15871751,5678739,1,'2010-09-04 16:07:27',3310493013,2),(894259012,425277803,15763801,5671401,1,'2010-09-03 18:05:35',3310491629,1),(894259014,425298821,15790440,5671401,1,'2010-09-03 18:05:35',3310491642,1),(894259017,425512446,15911932,5671401,1,'2010-09-03 18:05:35',3310503954,1),(894259020,425507717,15908486,5671401,1,'2010-09-03 18:05:35',3310503954,1),(894259022,425198848,15671488,5671401,1,'2010-09-03 18:05:35',3310491618,1),(894259030,425288233,15763627,5671401,1,'2010-09-03 18:05:35',3310491640,1),(894259032,425392331,15871558,5671401,1,'2010-09-03 18:05:35',3310493013,1),(894259034,425314984,15812562,5671401,1,'2010-09-03 18:05:35',3310491643,1),(894259037,425268365,15764707,5671401,1,'2010-09-03 18:05:36',3310491629,1),(894259040,425376534,15865961,5671401,1,'2010-09-03 18:05:36',3310493013,1),(894259043,425183091,15647736,5671401,1,'2010-09-03 18:05:36',3310491616,1),(894259046,425376529,15849905,5671401,1,'2010-09-03 18:05:36',3310493013,1),(894259051,425330248,15799070,5671401,1,'2010-09-03 18:05:36',3310491643,1),(894259053,425176660,15665066,5671401,1,'2010-09-03 18:05:36',3310491575,1),(894259057,425287258,15761499,5671401,1,'2010-09-03 18:05:36',3310491640,1),(894259060,425318727,15820444,5671401,1,'2010-09-03 18:05:36',3310491643,1),(894259063,425287205,15793998,5671401,1,'2010-09-03 18:05:36',3310491631,1),(894259067,425206606,15684581,5671401,1,'2010-09-03 18:05:36',3310491619,1),(894259070,425296025,15764922,5671401,1,'2010-09-03 18:05:36',3310491640,1),(894259073,425388744,15860950,5671401,1,'2010-09-03 18:05:36',3310493013,1),(894259083,425270926,15765808,5671401,1,'2010-09-03 18:05:36',3310491631,1),(894259085,425378942,15836114,5671401,1,'2010-09-03 18:05:36',3310493013,1),(894259087,425541482,15905009,5671401,1,'2010-09-03 18:05:36',3310503955,1),(894259089,425303472,15795515,5671401,1,'2010-09-03 18:05:37',3310491642,1),(894259091,425352341,15818739,5671401,1,'2010-09-03 18:05:37',3310491646,1),(894259093,425312829,15785041,5671401,1,'2010-09-03 18:05:37',3310491642,1),(894259096,425271948,15764193,5671401,1,'2010-09-03 18:05:37',3310491629,1),(894259098,425178265,15674838,5671401,1,'2010-09-03 18:05:37',3310491618,1),(894259105,425281148,15766391,5671401,1,'2010-09-03 18:05:37',3310491631,1),(894259107,425386178,15867302,5671401,1,'2010-09-03 18:05:37',3310493013,1),(894259111,425290451,15791055,5671401,1,'2010-09-03 18:05:37',3310491642,1),(894259114,425185252,15649625,5671401,1,'2010-09-03 18:05:37',3310491616,1),(894259118,425187128,15652848,5671401,1,'2010-09-03 18:05:37',3310491616,1),(894259122,425306712,15775023,5671401,1,'2010-09-03 18:05:37',3310491642,1),(894259125,425343680,15820245,5671401,1,'2010-09-03 18:05:37',3310491646,1),(894259135,425180571,15641081,5671401,1,'2010-09-03 18:05:37',3310491616,1),(894259137,425279888,15770357,5671401,1,'2010-09-03 18:05:38',3310491631,1),(894259139,425545395,15904056,5671401,1,'2010-09-03 18:05:38',3310503955,1),(894259141,425295211,15787485,5671401,1,'2010-09-03 18:05:38',3310491642,1),(894259144,425356746,15831908,5671401,1,'2010-09-03 18:05:38',3310493012,1),(894259148,425247744,15746258,5671401,1,'2010-09-03 18:05:38',3310491628,1),(894259152,425290397,15763800,5671401,1,'2010-09-03 18:05:38',3310491640,1),(894259155,425383018,15872493,5671401,1,'2010-09-03 18:05:38',3310493013,1),(894259161,425307931,15800345,5671401,1,'2010-09-03 18:05:38',3310491642,1),(894259164,425278025,15795517,5671401,1,'2010-09-03 18:05:38',3310491631,1),(894259168,425381378,15863413,5671401,1,'2010-09-03 18:05:38',3310493013,1),(894259171,425187029,15658114,5671401,1,'2010-09-03 18:05:38',3310491618,1),(894259174,425299203,15760485,5671401,1,'2010-09-03 18:05:38',3310491640,1),(894259176,425179924,15671316,5671401,1,'2010-09-03 18:05:38',3310491618,1),(894259178,425277377,15765865,5671401,1,'2010-09-03 18:05:38',3310491631,1),(894259187,425299514,15793310,5671401,1,'2010-09-03 18:05:39',3310491642,1),(894259188,425351525,15835466,5671401,1,'2010-09-03 18:05:39',3310493012,1),(894259189,425510880,15911774,5671401,1,'2010-09-03 18:05:39',3310503954,1),(894259193,425510420,15908141,5671401,1,'2010-09-03 18:05:39',3310503954,1),(894259195,425194709,15664366,5671401,1,'2010-09-03 18:05:39',3310491618,1),(894259199,425175105,15682096,5671401,1,'2010-09-03 18:05:39',3310491575,1),(894259202,425298215,15763456,5671401,1,'2010-09-03 18:05:39',3310491640,1),(894259206,425391642,15869559,5671401,1,'2010-09-03 18:05:39',3310493013,1),(894259217,425313871,15805950,5671401,1,'2010-09-03 18:05:39',3310491642,1),(894259219,425184799,15652824,5671401,1,'2010-09-03 18:05:39',3310491616,1),(894259221,425299650,15793587,5671401,1,'2010-09-03 18:05:39',3310491642,1),(894259225,425178265,15657855,5671401,1,'2010-09-03 18:05:39',3310491618,1),(894259228,425332583,15809668,5671401,1,'2010-09-03 18:05:39',3310491643,1),(894259232,425507822,15910005,5671401,1,'2010-09-03 18:05:39',3310503954,1);
INSERT INTO `nodes` VALUES (894259236,425275035,15763719,5671401,1,'2010-09-03 18:05:40',3310491629,1),(894259242,425178798,15682705,5671401,1,'2010-09-03 18:05:40',3310491618,1),(894259245,425283281,15760103,5671401,1,'2010-09-03 18:05:40',3310491629,1),(894259248,425318160,15816754,5671401,1,'2010-09-03 18:05:40',3310491643,1),(894259251,425288203,15792580,5671401,1,'2010-09-03 18:05:40',3310491642,1),(894259254,425356057,15821937,5671401,1,'2010-09-03 18:05:40',3310493012,1),(894259257,425214044,15696253,5671401,1,'2010-09-03 18:05:40',3310491619,1),(894259261,425295660,15764199,5671401,1,'2010-09-03 18:05:40',3310491640,1),(894259262,425389741,15865141,5671401,1,'2010-09-03 18:05:40',3310493013,1),(894259271,425268669,15774836,5671401,1,'2010-09-03 18:05:40',3310491631,1),(894259274,425188125,15689614,5671401,1,'2010-09-03 18:05:40',3310491618,1),(894259276,425370358,15824904,5671401,1,'2010-09-03 18:05:40',3310493013,1),(894259278,425542466,15904179,5671401,1,'2010-09-03 18:05:40',3310503955,1),(894259280,425303123,15793988,5671401,1,'2010-09-03 18:05:40',3310491642,1),(894259282,425273393,15762852,5671401,1,'2010-09-03 18:05:40',3310491629,1),(894259284,425217702,15710386,5671401,1,'2010-09-03 18:05:40',3310491619,1),(894259294,425177011,15672826,5671401,1,'2010-09-03 18:05:40',3310491575,1),(894259295,425281380,15764069,5671401,1,'2010-09-03 18:05:41',3310491629,1),(894259297,425387912,15864303,5671401,1,'2010-09-03 18:05:41',3310493013,1),(894259300,425271817,15782338,5671401,1,'2010-09-03 18:05:41',3310491631,1),(894259303,425361810,15823408,5671401,1,'2010-09-03 18:05:41',3310493012,1),(894259307,425507782,15909421,5671401,1,'2010-09-03 18:05:41',3310503954,1),(894259310,425184846,15653509,5671401,1,'2010-09-03 18:05:41',3310491616,1),(894259313,425301916,15764251,5671401,1,'2010-09-03 18:05:41',3310491640,1),(894259318,425389884,15869430,5671401,1,'2010-09-03 18:05:41',3310493013,1),(894259320,425279508,15768551,5671401,1,'2010-09-03 18:05:41',3310491631,1),(894259324,425364323,15820268,5671401,1,'2010-09-03 18:05:41',3310491646,1),(894259328,425297645,15793041,5671401,1,'2010-09-03 18:05:41',3310491642,1),(894259331,425186302,15653071,5671401,1,'2010-09-03 18:05:41',3310491616,1),(894259334,425358272,15819097,5671401,1,'2010-09-03 18:05:41',3310491646,1),(894259335,425236640,15741184,5671401,1,'2010-09-03 18:05:41',3310491628,1),(894259337,425289032,15763989,5671401,1,'2010-09-03 18:05:41',3310491640,1),(894259344,425306402,15798993,5671401,1,'2010-09-03 18:05:42',3310491642,1),(894259348,425275500,15790922,5671401,1,'2010-09-03 18:05:42',3310491631,1),(894259351,425377414,15852717,5671401,1,'2010-09-03 18:05:42',3310493013,1),(894259353,425181002,15640562,5671401,1,'2010-09-03 18:05:42',3310491616,1),(894259356,425299188,15759268,5671401,1,'2010-09-03 18:05:42',3310491640,1),(894259358,425176422,15663390,5671401,1,'2010-09-03 18:05:42',3310491575,1),(894259360,425276571,15764627,5671401,1,'2010-09-03 18:05:42',3310491629,1),(894259370,425300497,15792359,5671401,1,'2010-09-03 18:05:42',3310491642,1),(894259372,425509808,15910837,5671401,1,'2010-09-03 18:05:42',3310503954,1),(894259375,425202974,15678142,5671401,1,'2010-09-03 18:05:42',3310491618,1),(894259379,425173926,15682164,5671401,1,'2010-09-03 18:05:42',3310491575,1),(894259382,425297804,15762198,5671401,1,'2010-09-03 18:05:42',3310491640,1),(894259386,425392497,15870203,5671401,1,'2010-09-03 18:05:42',3310493013,1),(894259390,425367486,15847716,5671401,1,'2010-09-03 18:05:42',3310493012,1),(894259394,425549048,15908555,5671401,1,'2010-09-03 18:05:42',3310503955,1),(894259398,425180306,15641388,5671401,1,'2010-09-03 18:05:43',3310491616,1),(894259402,425378849,15840837,5671401,1,'2010-09-03 18:05:43',3310493013,1),(894259405,425298726,15794287,5671401,1,'2010-09-03 18:05:43',3310491642,1),(894259408,425177754,15662578,5671401,1,'2010-09-03 18:05:43',3310491618,1),(894259411,425352637,15814848,5671401,1,'2010-09-03 18:05:43',3310491646,1),(894259414,425314528,15794458,5671401,1,'2010-09-03 18:05:43',3310491642,1),(894259417,425274503,15765142,5671401,1,'2010-09-03 18:05:43',3310491629,1),(894259424,425177695,15687674,5671401,1,'2010-09-03 18:05:43',3310491618,1),(894259427,425283733,15761844,5671401,1,'2010-09-03 18:05:43',3310491629,1),(894259431,425291835,15791592,5671401,1,'2010-09-03 18:05:43',3310491642,1),(894259433,425182343,15643125,5671401,1,'2010-09-03 18:05:43',3310491616,1),(894259435,425210741,15692577,5671401,1,'2010-09-03 18:05:43',3310491619,1),(894259437,425293334,15764261,5671401,1,'2010-09-03 18:05:43',3310491640,1),(894259439,425384220,15864233,5671401,1,'2010-09-03 18:05:43',3310493013,1),(894259449,425270124,15773022,5671401,1,'2010-09-03 18:05:44',3310491631,1),(894259451,425336966,15818445,5671401,1,'2010-09-03 18:05:44',3310491643,1),(894259453,425189375,15689562,5671401,1,'2010-09-03 18:05:44',3310491618,1),(894259456,425376344,15829879,5671401,1,'2010-09-03 18:05:44',3310493013,1),(894259459,425545972,15902973,5671401,1,'2010-09-03 18:05:44',3310503955,1),(894259462,425305528,15798390,5671401,1,'2010-09-03 18:05:44',3310491642,1),(894259465,425272268,15766009,5671401,1,'2010-09-03 18:05:44',3310491631,1),(894259468,425215910,15701707,5671401,1,'2010-09-03 18:05:44',3310491619,1),(894259473,425179691,15673239,5671401,1,'2010-09-03 18:05:44',3310491618,1),(894259476,425291089,15764582,5671401,1,'2010-09-03 18:05:44',3310491640,1),(894259480,425384206,15874234,5671401,1,'2010-09-03 18:05:44',3310493013,1),(894259483,425269025,15780323,5671401,1,'2010-09-03 18:05:44',3310491631,1),(894259486,425381971,15864663,5671401,1,'2010-09-03 18:05:44',3310493013,1),(894259489,425364976,15819426,5671401,1,'2010-09-03 18:05:44',3310491646,1),(894259492,425187622,15656154,5671401,1,'2010-09-03 18:05:44',3310491618,1),(894259499,425301471,15768241,5671401,1,'2010-09-03 18:05:44',3310491642,1),(894259503,425389290,15870268,5678739,1,'2010-09-04 16:07:27',3310493013,2),(894259507,425226567,15716967,5678739,1,'2010-09-04 16:07:30',3310491625,2),(894259509,425178322,15668777,5671401,1,'2010-09-03 18:05:45',3310491618,1),(894259511,425278670,15766339,5671401,1,'2010-09-03 18:05:45',3310491631,1),(894259513,425296806,15792694,5671401,1,'2010-09-03 18:05:45',3310491642,1),(894259515,425185446,15653303,5671401,1,'2010-09-03 18:05:45',3310491616,1),(894259525,425361665,15829201,5671401,1,'2010-09-03 18:05:45',3310493012,1),(894259527,425259867,15751024,5671401,1,'2010-09-03 18:05:45',3310491629,1),(894259529,425172644,15680921,5678739,1,'2010-09-04 16:07:26',3310491575,2),(894259531,425289212,15764347,5671401,1,'2010-09-03 18:05:45',3310491640,1),(894259533,425382674,15867785,5671401,1,'2010-09-03 18:05:45',3310493013,1),(894259536,425312200,15800282,5671401,1,'2010-09-03 18:05:45',3310491642,1),(894259540,425283142,15792902,5671401,1,'2010-09-03 18:05:45',3310491631,1),(894259547,425378824,15855917,5671401,1,'2010-09-03 18:05:45',3310493013,1),(894259550,425509554,15907168,5671401,1,'2010-09-03 18:05:45',3310503954,1),(894259553,425265419,15757481,5671401,1,'2010-09-03 18:05:46',3310491629,1),(894259556,425178510,15663755,5671401,1,'2010-09-03 18:05:46',3310491618,1),(894259559,425276161,15763533,5671401,1,'2010-09-03 18:05:46',3310491629,1),(894259562,425287015,15791612,5671401,1,'2010-09-03 18:05:46',3310491631,1),(894259565,425513663,15910594,5671401,1,'2010-09-03 18:05:46',3310503954,1),(894259570,425355422,15826242,5671401,1,'2010-09-03 18:05:46',3310493012,1),(894259572,425508688,15910979,5671401,1,'2010-09-03 18:05:46',3310503954,1),(894259576,425200274,15674454,5671401,1,'2010-09-03 18:05:46',3310491618,1),(894259580,425296618,15763849,5671401,1,'2010-09-03 18:05:46',3310491640,1),(894259582,425390739,15866334,5671401,1,'2010-09-03 18:05:46',3310493013,1),(894259585,425181494,15644109,5671401,1,'2010-09-03 18:05:46',3310491616,1),(894259587,425377736,15845748,5671401,1,'2010-09-03 18:05:46',3310493013,1),(894259590,425544461,15904018,5671401,1,'2010-09-03 18:05:46',3310503955,1),(894259600,425301754,15794504,5671401,1,'2010-09-03 18:05:46',3310491642,1),(894259602,425181328,15657351,5671401,1,'2010-09-03 18:05:46',3310491618,1),(894259604,425319343,15797917,5671401,1,'2010-09-03 18:05:47',3310491643,1),(894259607,425508435,15907310,5671401,1,'2010-09-03 18:05:47',3310503954,1),(894259610,425272982,15761387,5671401,1,'2010-09-03 18:05:47',3310491629,1),(894259613,425178322,15677263,5671401,1,'2010-09-03 18:05:47',3310491618,1),(894259617,425282687,15762295,5671401,1,'2010-09-03 18:05:47',3310491629,1),(894259622,425326770,15827516,5671401,1,'2010-09-03 18:05:47',3310493009,1),(894259624,425289326,15793180,5671401,1,'2010-09-03 18:05:47',3310491642,1),(894259627,425181234,15640280,5671401,1,'2010-09-03 18:05:47',3310491616,1),(894259630,425184769,15654716,5671401,1,'2010-09-03 18:05:47',3310491616,1),(894259633,425293562,15765004,5671401,1,'2010-09-03 18:05:47',3310491640,1),(894259636,425334701,15826747,5671401,1,'2010-09-03 18:05:47',3310493009,1),(894259639,425363296,15821565,5671401,1,'2010-09-03 18:05:47',3310493012,1),(894259641,425304772,15797450,5671401,1,'2010-09-03 18:05:47',3310491642,1),(894259650,425272800,15764998,5671401,1,'2010-09-03 18:05:47',3310491629,1),(894259654,425226895,15724888,5671401,1,'2010-09-03 18:05:47',3310491625,1),(894259658,425177866,15671614,5671401,1,'2010-09-03 18:05:47',3310491618,1),(894259660,425291897,15764687,5671401,1,'2010-09-03 18:05:48',3310491640,1),(894259662,425385014,15870590,5671401,1,'2010-09-03 18:05:48',3310493013,1),(894259664,425306594,15798464,5671401,1,'2010-09-03 18:05:48',3310491642,1),(894259665,425273659,15787497,5671401,1,'2010-09-03 18:05:48',3310491631,1),(894259666,425189667,15654086,5671401,1,'2010-09-03 18:05:48',3310491616,1),(894259676,425300207,15761042,5671401,1,'2010-09-03 18:05:48',3310491640,1),(894259678,425393305,15871009,5671401,1,'2010-09-03 18:05:48',3310493013,1),(894259680,425381827,15875013,5671401,1,'2010-09-03 18:05:48',3310493013,1),(894259682,425177771,15668699,5671401,1,'2010-09-03 18:05:48',3310491618,1),(894259683,425278772,15768519,5671401,1,'2010-09-03 18:05:48',3310491631,1),(894259685,425300365,15789392,5671401,1,'2010-09-03 18:05:48',3310491642,1),(894259687,425361757,15830649,5671401,1,'2010-09-03 18:05:48',3310493012,1),(894259697,425540606,15897700,5671401,1,'2010-09-03 18:05:48',3310503955,1),(894259698,425255448,15745028,5671401,1,'2010-09-03 18:05:48',3310491628,1),(894259699,425288399,15761724,5671401,1,'2010-09-03 18:05:48',3310491640,1),(894259700,425391381,15871074,5671401,1,'2010-09-03 18:05:48',3310493013,1),(894259702,425307885,15798078,5671401,1,'2010-09-03 18:05:48',3310491642,1),(894259703,425279658,15793220,5671401,1,'2010-09-03 18:05:48',3310491631,1),(894259706,425372402,15862025,5671401,1,'2010-09-03 18:05:48',3310493013,1),(894259708,425179007,15664530,5671401,1,'2010-09-03 18:05:48',3310491618,1),(894259720,425510525,15909661,5671401,1,'2010-09-03 18:05:49',3310503954,1),(894259721,425268138,15752407,5671401,1,'2010-09-03 18:05:49',3310491629,1),(894259722,425176643,15665802,5671401,1,'2010-09-03 18:05:49',3310491575,1),(894259724,425285681,15763295,5671401,1,'2010-09-03 18:05:49',3310491629,1),(894259726,425285779,15792934,5671401,1,'2010-09-03 18:05:49',3310491631,1),(894259729,425351525,15825873,5671401,1,'2010-09-03 18:05:49',3310493012,1),(894259732,425208555,15689257,5671401,1,'2010-09-03 18:05:49',3310491619,1),(894259742,425297789,15764385,5671401,1,'2010-09-03 18:05:49',3310491640,1),(894259743,425390478,15868430,5671401,1,'2010-09-03 18:05:49',3310493013,1),(894259746,425268580,15770523,5671401,1,'2010-09-03 18:05:49',3310491631,1),(894259748,425191217,15691376,5671401,1,'2010-09-03 18:05:49',3310491618,1),(894259750,425378200,15832209,5671401,1,'2010-09-03 18:05:49',3310493013,1),(894259753,425544958,15903626,5671401,1,'2010-09-03 18:05:49',3310503955,1),(894259757,425301115,15795907,5671401,1,'2010-09-03 18:05:49',3310491642,1),(894259760,425179286,15656469,5671401,1,'2010-09-03 18:05:49',3310491618,1),(894259773,425348716,15820707,5671401,1,'2010-09-03 18:05:50',3310493012,1),(894259774,425308800,15781793,5671401,1,'2010-09-03 18:05:50',3310491642,1),(894263141,425707227,16073404,5671416,1,'2010-09-03 18:07:15',3310504037,1),(894263144,425707743,16077527,5674807,1,'2010-09-04 01:51:19',3310504037,2),(895601487,425174397,15684365,5678739,1,'2010-09-04 16:07:24',3310491575,1),(895601493,425294753,15764194,5689624,1,'2010-09-05 19:39:54',3310491640,2),(895601494,425346685,15832592,5678739,1,'2010-09-04 16:07:26',3310493012,1),(895601497,425287186,15764638,5689624,1,'2010-09-05 19:39:54',3310491629,2),(895604180,425539600,15897529,5678757,1,'2010-09-04 16:09:45',3310503955,1),(897596948,425291301,15765317,5689624,1,'2010-09-05 19:39:54',3310491640,1),(899525861,426184590,16387810,5709666,1,'2010-09-07 19:40:48',3310504408,2),(899525869,425940070,14605920,5709666,1,'2010-09-07 19:40:47',3310502279,2),(899525876,424825580,16422520,5709666,1,'2010-09-07 19:40:45',3310492877,2),(899525898,426469440,15508330,5702328,1,'2010-09-06 23:22:37',3310503581,1),(899525904,424763610,15650620,5709666,1,'2010-09-07 19:40:50',3310491360,2),(899525912,426081690,14952580,5709666,1,'2010-09-07 19:40:49',3310502720,2),(899525929,426072220,17158330,5709666,1,'2010-09-07 19:40:49',3310504896,2),(899525940,424836000,16122000,5702328,1,'2010-09-06 23:22:38',3310492775,1),(899525948,425901360,14789490,5709666,1,'2010-09-07 19:40:48',3310502310,2),(899525953,424861000,16455000,5702328,1,'2010-09-06 23:22:39',3310492890,1),(899525975,425719980,17206050,5709666,1,'2010-09-07 19:40:49',3310504647,2),(899525984,425777800,14505560,5709666,1,'2010-09-07 19:40:49',3310502097,2),(899525989,425956410,16131340,5702328,1,'2010-09-06 23:22:39',3310504242,1),(899526014,426225220,15641120,5709666,1,'2010-09-07 19:40:47',3310502900,2),(899526022,425813680,14468050,5709666,1,'2010-09-07 19:40:45',3310502015,2),(899526028,425984770,14484790,5709666,1,'2010-09-07 19:40:47',3310502203,2),(899526049,424920840,15945300,5709666,1,'2010-09-07 19:40:45',3310492764,2),(899526058,426382620,15114130,5709666,1,'2010-09-07 19:40:48',3310503439,2),(899526069,426112590,16714670,5709666,1,'2010-09-07 19:40:49',3310504772,2),(899526084,424950030,16563870,5709666,1,'2010-09-07 19:40:46',3310492919,2),(899526090,425170220,16420430,5709666,1,'2010-09-07 19:40:45',3310493085,2),(899526097,424794440,15508330,5709666,1,'2010-09-07 19:40:46',3310491340,2),(899526119,424797410,15782230,5709666,1,'2010-09-07 19:40:46',3310491374,2),(899526127,425659140,16407390,5702328,1,'2010-09-06 23:22:43',3310504137,1),(899526136,424903000,16483000,5702328,1,'2010-09-06 23:22:44',3310492916,1),(899526171,426403520,15613140,5709666,1,'2010-09-07 19:40:46',3310503600,2),(899526182,424898370,16072010,5709666,1,'2010-09-07 19:40:46',3310492785,2),(899526219,425110830,16089280,5709666,1,'2010-09-07 19:40:47',3310492977,2),(899526225,426067770,15504990,5709666,1,'2010-09-07 19:40:48',3310502856,2),(899526237,425536730,16788800,5709666,1,'2010-09-07 19:40:47',3310504467,2),(899526263,426211260,15797730,5709666,1,'2010-09-07 19:40:50',3310502907,2),(899526271,424819000,16286000,5702328,1,'2010-09-06 23:22:46',3310492868,1),(899526282,425966360,17032970,5709666,1,'2010-09-07 19:40:45',3310504760,2),(901125108,425905560,14447220,5709666,1,'2010-09-07 19:40:44',3310502188,1),(901170351,426037248,14419302,5710014,1,'2010-09-07 20:17:59',3310502205,1),(915764943,425039559,17213375,5806005,1,'2010-09-17 21:28:31',3310493574,1),(915765142,425056591,17225403,5806005,1,'2010-09-17 21:28:37',3310493575,1),(915765201,425043596,17214595,5806005,1,'2010-09-17 21:28:38',3310493575,1),(915765239,425026228,17208244,5806005,1,'2010-09-17 21:28:39',3310493574,1),(915765418,425051124,17223931,5806005,1,'2010-09-17 21:28:44',3310493575,1),(915765496,425041325,17214132,5806005,1,'2010-09-17 21:28:46',3310493575,1),(915765630,425054783,17228136,5806005,1,'2010-09-17 21:28:52',3310493575,1),(915765650,425025092,17209170,5806005,1,'2010-09-17 21:28:53',3310493574,1),(915765686,425028078,17208202,5806005,1,'2010-09-17 21:28:54',3310493574,1),(915765778,425054404,17224435,5806005,1,'2010-09-17 21:28:59',3310493575,1),(915765801,425041746,17209548,5806005,1,'2010-09-17 21:29:01',3310493575,1),(915765885,425064077,17229188,5806005,1,'2010-09-17 21:29:06',3310493575,1),(915765906,425067609,17227505,5806005,1,'2010-09-17 21:29:08',3310493586,1),(915765922,425041872,17207235,5806005,1,'2010-09-17 21:29:09',3310493575,1),(915765994,425052680,17221744,5806005,1,'2010-09-17 21:29:14',3310493575,1),(915766018,425041157,17212071,5806005,1,'2010-09-17 21:29:16',3310493575,1),(915766099,425066263,17227463,5806005,1,'2010-09-17 21:29:21',3310493575,1),(915766108,425047801,17220440,5806005,1,'2010-09-17 21:29:22',3310493575,1),(915766135,425043007,17207319,5806005,1,'2010-09-17 21:29:24',3310493575,1),(915766204,425050367,17223426,5806005,1,'2010-09-17 21:29:28',3310493575,1),(915766227,425045993,17216067,5806005,1,'2010-09-17 21:29:29',3310493575,1),(915766317,425049946,17220608,5806005,1,'2010-09-17 21:29:34',3310493575,1),(915766344,425038423,17207530,5806005,1,'2010-09-17 21:29:35',3310493574,1),(915766418,425052638,17228935,5806005,1,'2010-09-17 21:29:39',3310493575,1),(915766445,425045110,17217538,5806005,1,'2010-09-17 21:29:40',3310493575,1),(915766458,425030139,17208749,5806005,1,'2010-09-17 21:29:41',3310493574,1),(915766604,425045825,17218422,5806005,1,'2010-09-17 21:29:45',3310493575,1),(915766632,425040316,17207866,5806005,1,'2010-09-17 21:29:47',3310493575,1),(915766711,425052301,17230702,5806005,1,'2010-09-17 21:29:51',3310493575,1),(915766737,425042376,17214511,5806005,1,'2010-09-17 21:29:53',3310493575,1),(915766750,425034344,17208076,5806005,1,'2010-09-17 21:29:54',3310493574,1),(915766830,425047002,17219347,5806005,1,'2010-09-17 21:29:58',3310493575,1),(924524128,425220136,15721537,5866082,1,'2010-09-24 23:06:23',3310491625,1);
INSERT INTO `relation_members` VALUES (7439,'way',8164186,'',38,1),(7439,'way',23305160,'',38,2),(8647,'way',8164186,'outer',236,2),(8647,'way',23305160,'outer',236,1),(9407,'node',58957648,'capital',9,1),(9407,'way',6165679,'',9,3),(9407,'way',8164186,'',9,2),(9407,'way',45511076,'',9,5),(9407,'way',45511084,'',9,4),(9407,'way',45511090,'',9,6),(82675,'way',23305160,'',72,1),(92863,'way',6165679,'outer',125,4),(92863,'way',23305160,'outer',125,5),(92863,'way',45511076,'outer',125,2),(92863,'way',45511084,'outer',125,3),(92863,'way',45511090,'outer',125,1),(126410,'way',8164186,'',5,1),(343017,'way',45511076,'',2,1),(346346,'way',45511090,'',3,1),(348990,'way',6165679,'',5,5),(348990,'way',23305160,'',5,4),(348990,'way',45511076,'',5,2),(348990,'way',45511084,'',5,1),(348990,'way',45511090,'',5,3),(348990,'relation',343017,'',5,6),(348990,'relation',346346,'',5,7),(349053,'way',6165679,'outer',18,2),(349053,'way',23305160,'outer',18,3),(349053,'way',45511076,'outer',18,5),(349053,'way',45511084,'outer',18,6),(349053,'way',45511090,'outer',18,4),(349053,'relation',348990,'subarea',18,1),(411235,'way',24406326,'inner',1,3),(411235,'way',50568365,'outer',1,1),(411235,'way',50568366,'inner',1,2),(463686,'node',669985285,'',2,1),(463686,'node',669985286,'',2,2),(463686,'node',669985287,'',2,3),(463686,'node',669985289,'',2,4),(463686,'node',669985291,'',2,5),(463692,'node',669985299,'',2,1),(463692,'node',669985301,'',2,2),(463708,'node',669985341,'',2,1),(463712,'node',669985348,'',2,1),(463875,'node',669985685,'',2,1),(463875,'node',669985690,'',2,2),(464189,'node',669986979,'',2,1),(464189,'node',669986980,'',2,2),(464189,'node',669986981,'',2,3),(464189,'node',669986982,'',2,4),(1161383,'way',6593464,'inner',2,2),(1161383,'way',17241049,'outer',2,1),(1181120,'way',77918991,'',2,1);
INSERT INTO `relation_tags` VALUES (7439,'admin_level','6',38),(7439,'boundary','administrative',38),(7439,'converted_by','Editop_2_OSM_v0016',38),(7439,'name','Ariège',38),(7439,'ref','09',38),(7439,'type','boundary',38),(8647,'admin_level','4',236),(8647,'boundary','administrative',236),(8647,'converted_by','Editop_2_OSM_v0016',236),(8647,'name','Midi-Pyrénées',236),(8647,'ref','73',236),(8647,'ref_NUTS','FR62',236),(8647,'type','boundary',236),(9407,'admin_level','2',9),(9407,'boundary','administrative',9),(9407,'ISO3166-1','ad',9),(9407,'name','Andorra',9),(9407,'name:de','Andorra',9),(9407,'name:en','Andorra',9),(9407,'name:fr','Andorre',9),(9407,'name:ru','???????',9),(9407,'type','boundary',9),(82675,'admin_level','2',72),(82675,'boundary','administrative',72),(82675,'name','Spain/France Boundary',72),(82675,'name:de','Frankreich - Spanien',72),(82675,'name:en','France - Spain',72),(82675,'name:es','Frontera España/Francia',72),(82675,'name:fr','Frontières Espagne/France',72),(82675,'name:ru','??????? - ???????',72),(82675,'note','For explanations please read http://wiki.openstreetmap.org/wiki/France_boundary_pyramidal_construction',72),(82675,'type','boundary_segment',72),(82675,'wikipedia:fr','Frontière entre l\'Espagne et la France',72),(92863,'addr:country','ES',125),(92863,'admin_level','2',125),(92863,'boundary','administrative',125),(92863,'currency','EUR',125),(92863,'ISO3166-1','es',125),(92863,'name','España',125),(92863,'name:cs','Špan?lsko',125),(92863,'name:de','Spanien',125),(92863,'name:en','Spain',125),(92863,'name:es','España',125),(92863,'name:eu','Espainia',125),(92863,'name:fr','Espagne',125),(92863,'name:hr','Španjolska',125),(92863,'name:pl','Hiszpania',125),(92863,'name:ru','???????',125),(92863,'name:sk','Španielsko',125),(92863,'name:sv','Spanien',125),(92863,'timezone','Europe/Madrid',125),(92863,'type','boundary',125),(92863,'wikipedia','Spain',125),(126410,'admin_level','2',5),(126410,'boundary','administrative',5),(126410,'name','France/Andorra',5),(126410,'name:de','Frankreich - Andorra',5),(126410,'name:en','France - Andorra',5),(126410,'name:ru','??????? - ???????',5),(126410,'note','For explanations please read http://wiki.openstreetmap.org/wiki/France_boundary_pyramidal_construction',5),(126410,'type','boundary_segment',5),(343017,'admin_level','8',2),(343017,'boundary','administrative',2),(343017,'idee:name','Valls de Valira (Les)',2),(343017,'ine:municipio','25239',2),(343017,'is_in','Lleida, Cataluña, Spain',2),(343017,'is_in:country','Spain',2),(343017,'is_in:province','Lleida',2),(343017,'is_in:region','Cataluña',2),(343017,'name','Les Valls de Valira',2),(343017,'source','BDLL25, EGRN, Instituto Geográfico Nacional',2),(343017,'type','boundary',2),(343017,'wikipedia','es:Les Valls de Valira',2),(346346,'admin_level','8',3),(346346,'boundary','administrative',3),(346346,'idee:name','Lles de Cerdanya',3),(346346,'ine:municipio','25127',3),(346346,'is_in','Lleida, Cataluña, Spain',3),(346346,'is_in:country','Spain',3),(346346,'is_in:province','Lleida',3),(346346,'is_in:region','Cataluña',3),(346346,'name','Lles de Cerdanya',3),(346346,'source','BDLL25, EGRN, Instituto Geográfico Nacional',3),(346346,'type','boundary',3),(346346,'wikipedia:es','Lles de Cerdanya',3),(348990,'admin_level','6',5),(348990,'boundary','administrative',5),(348990,'ine:provincia','25',5),(348990,'is_in','Cataluña, Spain',5),(348990,'is_in:country','Spain',5),(348990,'is_in:region','Cataluña',5),(348990,'name','Lleida',5),(348990,'name:eu','Lleida',5),(348990,'source','BDLL25, EGRN, Instituto Geográfico Nacional',5),(348990,'type','boundary',5),(348990,'wikipedia:es','Lérida',5),(349053,'admin_level','4',18),(349053,'boundary','administrative',18),(349053,'ine:ccaa','69',18),(349053,'is_in','Spain',18),(349053,'is_in:country','Spain',18),(349053,'name','Catalunya',18),(349053,'name:ca','Catalunya',18),(349053,'name:es','Cataluña',18),(349053,'name:eu','Katalunia',18),(349053,'name:hr','Katalonija',18),(349053,'name:sv','Katalonien',18),(349053,'official_name:ca','Catalunya',18),(349053,'official_name:es','Cataluña',18),(349053,'official_name:oc','Catalunha',18),(349053,'source','BDLL25, EGRN, Instituto Geográfico Nacional',18),(349053,'timezone','Europe/Madrid',18),(349053,'type','boundary',18),(349053,'wikipedia:es','Cataluña',18),(349053,'wikipedia:fr','Catalogne',18),(411235,'CLC:code','321',1),(411235,'CLC:id','FR-244978',1),(411235,'CLC:year','2006',1),(411235,'natural','grassland',1),(411235,'source','Union européenne - SOeS, CORINE Land Cover, 2006.',1),(411235,'type','multipolygon',1),(463686,'name','Aston I',2),(463686,'network','NTF-2',2),(463686,'note','Serrhre',2),(463686,'ref','0902401',2),(463686,'site','geodesic',2),(463686,'source','©IGN 2010 dans le cadre de la cartographie réglementaire',2),(463686,'type','site',2),(463686,'url','http://ancien-geodesie.ign.fr/fiche_geodesie.asp?num_site=0902401&X=585217&Y=6170556',2),(463692,'name','Aston VII',2),(463692,'network','NTF-4',2),(463692,'ref','0902407',2),(463692,'site','geodesic',2),(463692,'source','©IGN 2010 dans le cadre de la cartographie réglementaire',2),(463692,'type','site',2),(463692,'url','http://ancien-geodesie.ign.fr/fiche_geodesie.asp?num_site=0902407&X=593082&Y=6170116',2),(463708,'name','Auzat IV',2),(463708,'network','NTF-3',2),(463708,'ref','0903004',2),(463708,'site','geodesic',2),(463708,'source','©IGN 2010 dans le cadre de la cartographie réglementaire',2),(463708,'type','site',2),(463708,'url','http://ancien-geodesie.ign.fr/fiche_geodesie.asp?num_site=0903004&X=571978&Y=6168377',2),(463712,'name','Auzat VIII',2),(463712,'network','NTF-4',2),(463712,'ref','0903008',2),(463712,'site','geodesic',2),(463712,'source','©IGN 2010 dans le cadre de la cartographie réglementaire',2),(463712,'type','site',2),(463712,'url','http://ancien-geodesie.ign.fr/fiche_geodesie.asp?num_site=0903008&X=574905&Y=6169576',2),(463875,'name','L\'Hospitalet-près-l\'Andorre I',2),(463875,'network','NTF-2',2),(463875,'note','Roc Mili',2),(463875,'ref','0913901',2),(463875,'site','geodesic',2),(463875,'source','©IGN 2010 dans le cadre de la cartographie réglementaire',2),(463875,'type','site',2),(463875,'url','http://ancien-geodesie.ign.fr/fiche_geodesie.asp?num_site=0913901&X=596591&Y=6166165',2),(464189,'name','Siguer I',2),(464189,'network','NTF-2',2),(464189,'ref','0929501',2),(464189,'site','geodesic',2),(464189,'source','©IGN 2010 dans le cadre de la cartographie réglementaire',2),(464189,'type','site',2),(464189,'url','http://ancien-geodesie.ign.fr/fiche_geodesie.asp?num_site=0929501&X=579664&Y=6173342',2),(1161383,'type','multipolygon',2),(1181120,'name','GR-107',2),(1181120,'network','GR',2),(1181120,'ref','GR-107',2),(1181120,'route','hiking',2),(1181120,'type','route',2);
INSERT INTO `relations` VALUES (7439,4091122,'2010-03-10 18:50:41',38,1),(8647,5860604,'2010-09-24 10:54:43',236,1),(9407,3882859,'2010-02-15 14:55:48',9,1),(82675,5061350,'2010-06-23 23:00:46',72,1),(92863,5641978,'2010-08-31 06:40:04',125,1),(126410,3882859,'2010-02-15 14:55:34',5,1),(343017,3283462,'2009-12-03 21:55:40',2,1),(346346,3612902,'2010-01-13 23:29:28',3,1),(348990,4072906,'2010-03-08 17:51:40',5,1),(349053,5636480,'2010-08-30 16:59:53',18,1),(411235,3903073,'2010-02-17 20:32:43',1,1),(463686,4475595,'2010-04-20 12:48:43',2,1),(463692,4475595,'2010-04-20 12:48:44',2,1),(463708,4475595,'2010-04-20 12:48:46',2,1),(463712,4475595,'2010-04-20 12:48:47',2,1),(463875,4475595,'2010-04-20 12:49:29',2,1),(464189,4475595,'2010-04-20 12:50:09',2,1),(1161383,5674807,'2010-09-04 01:51:19',2,1),(1181120,5808039,'2010-09-18 01:40:20',2,1);
INSERT INTO `users` VALUES ('osmosis_user_-1@example.com',-1,0,'00000000000000000000000000000000','2010-09-28 10:22:40','Osmosis Anonymous',0,'Osmosis Anonymous',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_10927@example.com',10927,0,'00000000000000000000000000000000','2010-09-28 10:22:40','Skywave',1,'Skywave',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_1297@example.com',1297,0,'00000000000000000000000000000000','2010-09-28 10:22:40','garaolaza',1,'garaolaza',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_34536@example.com',34536,0,'00000000000000000000000000000000','2010-09-28 10:22:40','3ld',1,'3ld',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_213594@example.com',213594,0,'00000000000000000000000000000000','2010-09-28 10:22:40','Hagman',1,'Hagman',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_29084@example.com',29084,0,'00000000000000000000000000000000','2010-09-28 10:22:40','stoecker',1,'stoecker',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_246989@example.com',246989,0,'00000000000000000000000000000000','2010-09-28 10:22:40','Xavier D',1,'Xavier D',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_93506@example.com',93506,0,'00000000000000000000000000000000','2010-09-28 10:22:40','Muro de Aguas',1,'Muro de Aguas',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_25804@example.com',25804,0,'00000000000000000000000000000000','2010-09-28 10:22:40','germin8',1,'germin8',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_84859@example.com',84859,0,'00000000000000000000000000000000','2010-09-28 10:22:41','ONC',1,'ONC',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_119803@example.com',119803,0,'00000000000000000000000000000000','2010-09-28 10:22:41','gbertu',1,'gbertu',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_43280@example.com',43280,0,'00000000000000000000000000000000','2010-09-28 10:22:41','Pieter2',1,'Pieter2',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_275821@example.com',275821,0,'00000000000000000000000000000000','2010-09-28 10:22:41','Ramzes',1,'Ramzes',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_90394@example.com',90394,0,'00000000000000000000000000000000','2010-09-28 10:22:41','petrovsk',1,'petrovsk',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_22398@example.com',22398,0,'00000000000000000000000000000000','2010-09-28 10:22:41','RolandE',1,'RolandE',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_70696@example.com',70696,0,'00000000000000000000000000000000','2010-09-28 10:22:41','xybot',1,'xybot',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_4363@example.com',4363,0,'00000000000000000000000000000000','2010-09-28 10:22:41','Pmz',1,'Pmz',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_10091@example.com',10091,0,'00000000000000000000000000000000','2010-09-28 10:22:41','GwennG',1,'GwennG',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_56597@example.com',56597,0,'00000000000000000000000000000000','2010-09-28 10:22:41','Oberaffe',1,'Oberaffe',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_241566@example.com',241566,0,'00000000000000000000000000000000','2010-09-28 10:22:42','wolodik',1,'wolodik',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_24965@example.com',24965,0,'00000000000000000000000000000000','2010-09-28 10:22:42','Ævar Arnfjörð Bjarmason',1,'Ævar Arnfjörð Bjarmason',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_20502@example.com',20502,0,'00000000000000000000000000000000','2010-09-28 10:22:42','miuet',1,'miuet',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_210115@example.com',210115,0,'00000000000000000000000000000000','2010-09-28 10:22:42','v-na-more',1,'v-na-more',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_6975@example.com',6975,0,'00000000000000000000000000000000','2010-09-28 10:22:42','ulfl',1,'ulfl',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_115019@example.com',115019,0,'00000000000000000000000000000000','2010-09-28 10:22:42','filipepgm',1,'filipepgm',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_29717@example.com',29717,0,'00000000000000000000000000000000','2010-09-28 10:22:42','eumiro',1,'eumiro',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_5657@example.com',5657,0,'00000000000000000000000000000000','2010-09-28 10:22:42','Olivier Boudet',1,'Olivier Boudet',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_25762@example.com',25762,0,'00000000000000000000000000000000','2010-09-28 10:22:42','frodrigo',1,'frodrigo',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_53957@example.com',53957,0,'00000000000000000000000000000000','2010-09-28 10:22:42','Nix46',1,'Nix46',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_86654@example.com',86654,0,'00000000000000000000000000000000','2010-09-28 10:22:42','e1l52',1,'e1l52',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_17497@example.com',17497,0,'00000000000000000000000000000000','2010-09-28 10:22:42','katpatuka',1,'katpatuka',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_91785@example.com',91785,0,'00000000000000000000000000000000','2010-09-28 10:22:42','flomigulau',1,'flomigulau',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_152289@example.com',152289,0,'00000000000000000000000000000000','2010-09-28 10:22:43','cgu66',1,'cgu66',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_26868@example.com',26868,0,'00000000000000000000000000000000','2010-09-28 10:22:43','Geum',1,'Geum',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_143308@example.com',143308,0,'00000000000000000000000000000000','2010-09-28 10:22:43','CLCF06',1,'CLCF06',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_18149@example.com',18149,0,'00000000000000000000000000000000','2010-09-28 10:22:43','Jan Klopper',1,'Jan Klopper',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_103244@example.com',103244,0,'00000000000000000000000000000000','2010-09-28 10:22:43','JamesR',1,'JamesR',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_6367@example.com',6367,0,'00000000000000000000000000000000','2010-09-28 10:22:43','mackerski',1,'mackerski',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_306172@example.com',306172,0,'00000000000000000000000000000000','2010-09-28 10:22:43','Chouloute',1,'Chouloute',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_65148@example.com',65148,0,'00000000000000000000000000000000','2010-09-28 10:22:43','Pirat Michi',1,'Pirat Michi',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_148173@example.com',148173,0,'00000000000000000000000000000000','2010-09-28 10:22:43','orhygine',1,'orhygine',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_45284@example.com',45284,0,'00000000000000000000000000000000','2010-09-28 10:22:43','Eric S',1,'Eric S',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_13409@example.com',13409,0,'00000000000000000000000000000000','2010-09-28 10:22:43','XuRxO',1,'XuRxO',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_682@example.com',682,0,'00000000000000000000000000000000','2010-09-28 10:22:43','SteveC',1,'SteveC',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_120406@example.com',120406,0,'00000000000000000000000000000000','2010-09-28 10:22:43','Toni Guasch',1,'Toni Guasch',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_233341@example.com',233341,0,'00000000000000000000000000000000','2010-09-28 10:22:43','David Lorenzana',1,'David Lorenzana',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_13324@example.com',13324,0,'00000000000000000000000000000000','2010-09-28 10:22:43','Julian Lozano',1,'Julian Lozano',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_12841@example.com',12841,0,'00000000000000000000000000000000','2010-09-28 10:22:43','mateuvic',1,'mateuvic',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_33377@example.com',33377,0,'00000000000000000000000000000000','2010-09-28 10:22:43','Victor LP',1,'Victor LP',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_45027@example.com',45027,0,'00000000000000000000000000000000','2010-09-28 10:22:43','PA94',1,'PA94',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_134812@example.com',134812,0,'00000000000000000000000000000000','2010-09-28 10:22:43','Ziaou',1,'Ziaou',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_231539@example.com',231539,0,'00000000000000000000000000000000','2010-09-28 10:22:44','Xapitoun',1,'Xapitoun',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_3234@example.com',3234,0,'00000000000000000000000000000000','2010-09-28 10:22:44','Jon Burgess',1,'Jon Burgess',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_247520@example.com',247520,0,'00000000000000000000000000000000','2010-09-28 10:22:44','harryA',1,'harryA',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_26299@example.com',26299,0,'00000000000000000000000000000000','2010-09-28 10:22:44','uboot',1,'uboot',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_115995@example.com',115995,0,'00000000000000000000000000000000','2010-09-28 10:22:44','g_slz',1,'g_slz',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_185976@example.com',185976,0,'00000000000000000000000000000000','2010-09-28 10:22:44','johnsdixon',1,'johnsdixon',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_118014@example.com',118014,0,'00000000000000000000000000000000','2010-09-28 10:22:44','benjamin&christel',1,'benjamin&christel',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_61891@example.com',61891,0,'00000000000000000000000000000000','2010-09-28 10:22:44','stephankn',1,'stephankn',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_97036@example.com',97036,0,'00000000000000000000000000000000','2010-09-28 10:22:44','julien76100',1,'julien76100',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_83365@example.com',83365,0,'00000000000000000000000000000000','2010-09-28 10:22:44','bsieper',1,'bsieper',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_92075@example.com',92075,0,'00000000000000000000000000000000','2010-09-28 10:22:44','Art Penteur',1,'Art Penteur',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_276785@example.com',276785,0,'00000000000000000000000000000000','2010-09-28 10:22:44','Chemins',1,'Chemins',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_5265@example.com',5265,0,'00000000000000000000000000000000','2010-09-28 10:22:44','ivansanchez',1,'ivansanchez',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_107257@example.com',107257,0,'00000000000000000000000000000000','2010-09-28 10:22:44','FrViPofm',1,'FrViPofm',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_35074@example.com',35074,0,'00000000000000000000000000000000','2010-09-28 10:22:44','mikeltxo',1,'mikeltxo',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_183561@example.com',183561,0,'00000000000000000000000000000000','2010-09-28 10:22:44','EtienneChoveBot',1,'EtienneChoveBot',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL),('osmosis_user_235264@example.com',235264,0,'00000000000000000000000000000000','2010-09-28 10:22:44','Pere Pujal',1,'Pere Pujal',0,0,3,50,'00000000',NULL,0,0,NULL,1,NULL);
INSERT INTO `way_nodes` VALUES (6165450,51110488,11,1),(6165450,51110489,11,2),(6165450,51110491,11,3),(6165450,51110493,11,4),(6165450,51110495,11,5),(6165450,51110496,11,6),(6165450,51385320,11,7),(6165450,51110498,11,8),(6165450,51110499,11,9),(6165450,51110501,11,10),(6165450,281042725,11,11),(6165450,281042726,11,12),(6165450,281049690,11,13),(6165450,281069194,11,14),(6165450,281042331,11,15),(6165450,281042332,11,16),(6165450,281043016,11,17),(6165450,281049691,11,18),(6165450,51110502,11,19),(6165450,281042336,11,20),(6165450,281042337,11,21),(6165450,51110488,11,22),(6165679,45160958,18,1),(6165679,45160947,18,2),(6165679,45160950,18,3),(6165679,45160897,18,4),(6165679,45160899,18,5),(6165679,45160902,18,6),(6165679,45160904,18,7),(6165679,45160908,18,8),(6165679,45160910,18,9),(6165679,45160875,18,10),(6165679,45160879,18,11),(6165679,45160885,18,12),(6165679,45160890,18,13),(6165679,45160893,18,14),(6165679,579974347,18,15),(6165679,579974346,18,16),(6165877,51121339,7,1),(6165877,51121341,7,2),(6165877,51121342,7,3),(6165877,51120956,7,4),(6165877,51120957,7,5),(6165877,51120959,7,6),(6165877,51120868,7,7),(6165877,51120869,7,8),(6165877,51120871,7,9),(6165877,51120872,7,10),(6165877,51120873,7,11),(6165877,51120874,7,12),(6165877,51120876,7,13),(6165877,51342840,7,14),(6165944,625307,12,1),(6165944,278748317,12,2),(6165944,278748365,12,3),(6165944,51122790,12,4),(6165944,51122791,12,5),(6165944,51122792,12,6),(6165944,52792122,12,7),(6165944,51122793,12,8),(6165944,51122795,12,9),(6165944,51122796,12,10),(6165944,51122797,12,11),(6165944,51122798,12,12),(6165944,51122800,12,13),(6165944,51122801,12,14),(6165944,278748559,12,15),(6165944,51122802,12,16),(6165944,51122803,12,17),(6165944,51122804,12,18),(6165944,51122805,12,19),(6165944,51122806,12,20),(6165944,51122807,12,21),(6165944,278748954,12,22),(6165944,51122808,12,23),(6165944,51122809,12,24),(6165944,51122810,12,25),(6165944,51122811,12,26),(6165944,51122812,12,27),(6165944,51122814,12,28),(6165944,51122815,12,29),(6165944,51122816,12,30),(6165944,51122817,12,31),(6165944,51122819,12,32),(6165944,51122820,12,33),(6165944,51122821,12,34),(6165944,51122822,12,35),(6165944,51122823,12,36),(6165944,51122824,12,37),(6165944,51122825,12,38),(6165944,51122826,12,39),(6165944,51122827,12,40),(6165944,51122828,12,41),(6165944,51122829,12,42),(6165944,51122830,12,43),(6165944,51121951,12,44),(6165944,51121953,12,45),(6165944,51121955,12,46),(6165944,51121956,12,47),(6166082,625294,9,1),(6166082,51123907,9,2),(6166082,51123908,9,3),(6166082,51123909,9,4),(6166082,278748035,9,5),(6166082,51123910,9,6),(6166082,51123911,9,7),(6166082,625295,9,8),(6166082,51123912,9,9),(6166082,51123913,9,10),(6166082,625296,9,11),(6166082,51123914,9,12),(6166082,625297,9,13),(6166082,51123916,9,14),(6166082,51123917,9,15),(6166082,51123918,9,16),(6166082,625298,9,17),(6166082,51123919,9,18),(6166082,51123920,9,19),(6166082,51123921,9,20),(6166082,625299,9,21),(6166082,51123922,9,22),(6166082,625300,9,23),(6166082,51123924,9,24),(6166082,51123925,9,25),(6166082,51123926,9,26),(6166082,625301,9,27),(6166082,278748036,9,28),(6166082,625302,9,29),(6166082,51123262,9,30),(6166082,53274022,9,31),(6166082,625303,9,32),(6166082,51123230,9,33),(6166082,51123231,9,34),(6166082,51123232,9,35),(6166082,51123233,9,36),(6166082,625304,9,37),(6166082,51123235,9,38),(6166082,278748279,9,39),(6166082,625305,9,40),(6166082,51123236,9,41),(6166082,53273834,9,42),(6166123,625277,7,1),(6166123,51124486,7,2),(6166123,51124487,7,3),(6166123,51124488,7,4),(6166123,51124489,7,5),(6166123,51348096,7,6),(6166123,51124490,7,7),(6166123,51124044,7,8),(6166123,51124045,7,9),(6166123,625293,7,10),(6166123,51124046,7,11),(6166123,51124047,7,12),(6166123,51124048,7,13),(6166123,625294,7,14),(6166128,51125344,4,1),(6166128,625261,4,2),(6166128,51349842,4,3),(6166136,51125344,4,1),(6166136,51125330,4,2),(6166136,53274971,4,3),(6166136,53274968,4,4),(6166136,769252988,4,5),(6166136,51125332,4,6),(6166136,769252996,4,7),(6166136,769252999,4,8),(6166136,51125333,4,9),(6166136,51125414,4,10),(6166136,51125335,4,11),(6166136,769253007,4,12),(6166136,51125337,4,13),(6166136,51125340,4,14),(6166136,51125342,4,15),(6166136,769253012,4,16),(6166136,53274970,4,17),(6166136,769253015,4,18),(6166136,51125344,4,19),(6166145,51125478,4,1),(6166145,625260,4,2),(6166145,51125414,4,3),(6166185,51125904,6,1),(6166185,51125905,6,2),(6166185,625245,6,3),(6166185,51361715,6,4),(6166185,51125784,6,5),(6166185,51361716,6,6),(6166185,625246,6,7),(6166185,51125788,6,8),(6166185,51125724,6,9),(6166185,625247,6,10),(6176624,51120876,6,1),(6176624,51342907,6,2),(6176624,51342909,6,3),(6176624,51342910,6,4),(6176624,51342421,6,5),(6176624,51342422,6,6),(6176663,51342838,3,1),(6176663,769251786,3,2),(6176663,51342839,3,3),(6176663,769251787,3,4),(6176663,51342840,3,5),(6176663,51342841,3,6),(6176663,769251788,3,7),(6176663,51342842,3,8),(6176663,769251789,3,9),(6176663,51342843,3,10),(6176663,51343031,3,11),(6176663,51342844,3,12),(6176663,51342855,3,13),(6176663,51342845,3,14),(6176663,769251791,3,15),(6176663,51342846,3,16),(6176663,51342847,3,17),(6176663,51342848,3,18),(6176663,51342838,3,19),(6176681,51344677,5,1),(6176681,51345073,5,2),(6176681,51343103,5,3),(6176681,51342422,5,4),(6176681,51343029,5,5),(6176681,769251784,5,6),(6176681,51343031,5,7),(6176755,51344677,13,1),(6176755,796031914,13,2),(6176755,51344678,13,3),(6176755,796031930,13,4),(6176755,51344679,13,5),(6176755,796031933,13,6),(6176755,51344681,13,7),(6176755,796031937,13,8),(6176755,51344682,13,9),(6176755,51344683,13,10),(6176755,51344685,13,11),(6176755,796030198,13,12),(6176755,51344687,13,13),(6176755,796030199,13,14),(6176755,51344688,13,15),(6176755,769251804,13,16),(6176755,51344690,13,17),(6176755,796031941,13,18),(6177152,625277,8,1),(6177152,625276,8,2),(6177152,625275,8,3),(6177152,625274,8,4),(6177152,51124700,8,5),(6177152,51348571,8,6),(6177152,51124485,8,7),(6177152,51124484,8,8),(6177152,51124483,8,9),(6177152,625273,8,10),(6177152,625272,8,11),(6177152,51124895,8,12),(6177152,51124893,8,13),(6177152,51124892,8,14),(6177152,51348167,8,15),(6177152,625271,8,16),(6177152,51348165,8,17),(6177152,625270,8,18),(6177152,51124891,8,19),(6177152,51124890,8,20),(6177152,51124975,8,21),(6177152,625269,8,22),(6177152,625268,8,23),(6177152,625267,8,24),(6177152,51347752,8,25),(6177152,51125159,8,26),(6177152,51347926,8,27),(6177152,51347750,8,28),(6177152,51347925,8,29),(6177152,625266,8,30),(6177152,625265,8,31),(6177152,51125157,8,32),(6177152,51125155,8,33),(6177152,51125154,8,34),(6177152,51125152,8,35),(6177152,625264,8,36),(6177152,51348517,8,37),(6177152,625263,8,38),(6177152,51349842,8,39),(6177369,625256,5,1),(6177369,625257,5,2),(6177369,262892996,5,3),(6177399,625249,6,1),(6177399,625250,6,2),(6177399,625251,6,3),(6177399,51125733,6,4),(6177399,51350585,6,5),(6177399,51125734,6,6),(6177399,625252,6,7),(6177399,51125737,6,8),(6177399,51931105,6,9),(6177399,625254,6,10),(6177399,51125738,6,11),(6177399,51350385,6,12),(6177399,51350384,6,13),(6177399,625256,6,14),(6177409,625247,4,1),(6177409,625248,4,2),(6177409,51125727,4,3),(6177409,51125728,4,4),(6177409,51125730,4,5),(6177409,51125731,4,6),(6177409,51350698,4,7),(6177409,51350699,4,8),(6177409,51350700,4,9),(6177409,51350702,4,10),(6177409,625249,4,11),(6178503,51349842,7,1),(6178503,51360952,7,2),(6178503,51360953,7,3),(6178503,51360955,7,4),(6178503,51360957,7,5),(6178503,51360958,7,6),(6178503,51360960,7,7),(6178503,51360961,7,8),(6178503,51360963,7,9),(6178503,51360964,7,10),(6178503,51360965,7,11),(6178503,51360967,7,12),(6178503,51360968,7,13),(6178503,51360969,7,14),(6178503,51360970,7,15),(6178503,51360971,7,16),(6178503,51360974,7,17),(6178503,51360975,7,18),(6178503,51360976,7,19),(6178503,51360979,7,20),(6178503,51360980,7,21),(6178503,51360981,7,22),(6178503,51360982,7,23),(6178503,51360984,7,24),(6178503,51360985,7,25),(6178503,51360986,7,26),(6178503,51360987,7,27),(6178503,51360988,7,28),(6178503,51360990,7,29),(6178503,51360991,7,30),(6178503,51360992,7,31),(6178503,51360993,7,32),(6178503,51360994,7,33),(6178503,51360995,7,34),(6178503,51360996,7,35),(6178503,51360998,7,36),(6178503,625277,7,37),(6178632,51126213,6,1),(6178632,51126214,6,2),(6178632,51126215,6,3),(6178632,51126216,6,4),(6178632,625207,6,5),(6178632,51126217,6,6),(6178632,625208,6,7),(6178632,625209,6,8),(6178632,625210,6,9),(6178632,51361816,6,10),(6178632,625211,6,11),(6178632,51361817,6,12),(6178632,51126218,6,13),(6178632,51126219,6,14),(6178632,625243,6,15),(6178632,51126221,6,16),(6178632,51126223,6,17),(6178632,51361728,6,18),(6178632,625244,6,19),(6178632,51126225,6,20),(6178632,51126226,6,21),(6178632,51125904,6,22),(6178685,51362477,6,1),(6178685,51362475,6,2),(6178685,625090,6,3),(6178685,51362474,6,4),(6178685,625089,6,5),(6178685,51362471,6,6),(6178685,51362531,6,7),(6178685,625088,6,8),(6178685,625087,6,9),(6178685,625086,6,10),(6178685,51387092,6,11),(6178685,51362529,6,12),(6178685,51362572,6,13),(6178685,625085,6,14),(6178685,625084,6,15),(6178685,51362570,6,16),(6178685,51362569,6,17),(6178688,51362569,5,1),(6178688,51362612,5,2),(6178688,51362613,5,3),(6178688,51362614,5,4),(6178688,51362854,5,5),(6178688,51362856,5,6),(6178688,51362857,5,7),(6178688,51362858,5,8),(6178688,51362860,5,9),(6178688,51362861,5,10),(6178688,51362863,5,11),(6178688,51362864,5,12),(6178688,51362865,5,13),(6178688,51362867,5,14),(6178688,51362868,5,15),(6178688,51362870,5,16),(6178688,51362871,5,17),(6178688,51362872,5,18),(6178688,51362477,5,19),(6178694,51362477,5,1),(6178694,625091,5,2),(6178694,625198,5,3),(6178694,51362153,5,4),(6178694,894259307,5,5),(6178791,625070,4,1),(6178791,625073,4,2),(6178791,51973538,4,3),(6178791,625074,4,4),(6178791,625075,4,5),(6178791,51363149,4,6),(6178791,625076,4,7),(6178791,51363105,4,8),(6178791,625077,4,9),(6178791,51363107,4,10),(6178791,51363109,4,11),(6178791,51363076,4,12),(6178791,51363078,4,13),(6178791,51363079,4,14),(6178791,51363022,4,15),(6178964,51364728,2,1),(6178964,51364730,2,2),(6178964,51364732,2,3),(6178964,51364733,2,4),(6178964,51364728,2,5),(6178980,51364894,3,1),(6178980,51364896,3,2),(6178980,51364898,3,3),(6178980,51364899,3,4),(6178980,51364894,3,5),(6179103,625033,5,1),(6179103,625071,5,2),(6179103,625034,5,3),(6179103,51366154,5,4),(6179103,51366157,5,5),(6179103,625035,5,6),(6179103,51366010,5,7),(6179103,51366011,5,8),(6179103,625036,5,9),(6179103,51366015,5,10),(6179103,51366017,5,11),(6179103,51386795,5,12),(6179103,625037,5,13),(6179174,259406445,5,1),(6179174,625029,5,2),(6179174,625028,5,3),(6179174,51366776,5,4),(6179174,51366775,5,5),(6179174,51366773,5,6),(6179174,625027,5,7),(6179174,51366772,5,8),(6179174,51366769,5,9),(6179174,625026,5,10),(6179174,625025,5,11),(6179174,51366858,5,12),(6179174,51366854,5,13),(6179174,625024,5,14),(6179174,625023,5,15),(6179174,625022,5,16),(6179174,51366992,5,17),(6179174,51366991,5,18),(6179174,51367842,5,19),(6179174,51367819,5,20),(6179240,51367555,4,1),(6179240,51367558,4,2),(6179240,51367559,4,3),(6179240,51367806,4,4),(6179240,51367563,4,5),(6179240,51367565,4,6),(6179240,51367819,4,7),(6179240,51367555,4,8),(6179270,51384490,4,1),(6179270,51371386,4,2),(6179470,51369359,2,1),(6179470,51369361,2,2),(6179470,51369362,2,3),(6179470,51369364,2,4),(6179470,51369359,2,5),(6179561,51370189,2,1),(6179561,51370191,2,2),(6179561,51370193,2,3),(6179561,51370194,2,4),(6179561,51370196,2,5),(6179561,51370197,2,6),(6179561,51370198,2,7),(6179561,51370199,2,8),(6179561,51370201,2,9),(6179561,51370202,2,10),(6179561,51370203,2,11),(6179561,51370206,2,12),(6179561,51370208,2,13),(6179561,51370210,2,14),(6179561,51370211,2,15),(6179561,51370213,2,16),(6179561,51370260,2,17),(6179561,51370189,2,18),(6179675,52688728,9,1),(6179675,52688859,9,2),(6179675,51369142,9,3),(6179675,51369145,9,4),(6179675,51399321,9,5),(6179675,51369146,9,6),(6179675,51369147,9,7),(6179675,51369148,9,8),(6179675,51400970,9,9),(6179675,51369150,9,10),(6179675,51369153,9,11),(6179675,51369155,9,12),(6179675,51369157,9,13),(6179675,51369159,9,14),(6179675,51369160,9,15),(6179675,51369162,9,16),(6179675,51369164,9,17),(6179675,51369165,9,18),(6179675,51369168,9,19),(6179675,51369170,9,20),(6179675,51369171,9,21),(6179675,51369173,9,22),(6179675,51367748,9,23),(6179675,51367752,9,24),(6179675,51367755,9,25),(6179675,51367756,9,26),(6179675,51367760,9,27),(6179675,51367761,9,28),(6179675,51367762,9,29),(6179675,51367763,9,30),(6179675,51367764,9,31),(6179675,51367767,9,32),(6179675,535386385,9,33),(6179692,51371386,6,1),(6179692,51371387,6,2),(6179692,51371388,6,3),(6179692,51371389,6,4),(6179692,51371391,6,5),(6179692,51371392,6,6),(6179692,51371395,6,7),(6179692,281059700,6,8),(6180790,281050523,8,1),(6180790,51385271,8,2),(6180790,51385267,8,3),(6180790,51385266,8,4),(6180790,51385264,8,5),(6180790,51385261,8,6),(6180790,51385259,8,7),(6180790,51385256,8,8),(6180790,51385251,8,9),(6180790,51110502,8,10),(6180839,51385334,3,1),(6180839,51385336,3,2),(6180840,51386301,3,1),(6180840,51386302,3,2),(6180840,51386304,3,3),(6180840,51386307,3,4),(6180840,51386309,3,5),(6180840,51386312,3,6),(6180840,51386315,3,7),(6180840,51386316,3,8),(6180840,51386319,3,9),(6180840,51386320,3,10),(6180840,51386324,3,11),(6180840,51386327,3,12),(6180840,52252315,3,13),(6180840,51386330,3,14),(6180840,51386331,3,15),(6180840,51386333,3,16),(6180840,51385966,3,17),(6180840,51385967,3,18),(6180840,51385970,3,19),(6180840,51385971,3,20),(6180840,51385973,3,21),(6180840,51385974,3,22),(6180840,51385975,3,23),(6180840,51385976,3,24),(6180840,796040771,3,25),(6180840,51385978,3,26),(6180840,51385979,3,27),(6180840,51385982,3,28),(6180840,51385983,3,29),(6180840,51385985,3,30),(6180840,52009129,3,31),(6180840,51385986,3,32),(6180840,51385988,3,33),(6180840,51385990,3,34),(6180840,51385991,3,35),(6180840,51385994,3,36),(6180840,51385996,3,37),(6180840,51385997,3,38),(6180840,52009156,3,39),(6180840,51386001,3,40),(6180840,51386002,3,41),(6180840,51386005,3,42),(6180840,51386008,3,43),(6180840,51386009,3,44),(6180840,51386011,3,45),(6180840,51386013,3,46),(6180840,51386014,3,47),(6180840,51386018,3,48),(6180840,51386019,3,49),(6180840,51386021,3,50),(6180840,51385349,3,51),(6180840,51385334,3,52),(6180852,51385336,4,1),(6180852,51385320,4,2),(6180968,625037,12,1),(6180968,625038,12,2),(6180968,625039,12,3),(6180968,51366022,12,4),(6180968,51366025,12,5),(6180968,51366028,12,6),(6180968,625040,12,7),(6180968,270729579,12,8),(6180968,51366033,12,9),(6180968,625041,12,10),(6180968,51366035,12,11),(6180968,625042,12,12),(6180968,51366036,12,13),(6180968,51366037,12,14),(6180968,625043,12,15),(6180968,51366039,12,16),(6180968,51365354,12,17),(6180968,51365356,12,18),(6180968,625044,12,19),(6180977,625044,3,1),(6180977,51365357,3,2),(6180977,625045,3,3),(6180985,625045,5,1),(6180985,51364998,5,2),(6180985,51365000,5,3),(6180985,625046,5,4),(6180985,270730270,5,5),(6180985,625047,5,6),(6180985,51365004,5,7),(6180985,625048,5,8),(6180985,625049,5,9),(6180985,51450178,5,10),(6180988,51363022,4,1),(6180988,625078,4,2),(6180988,51363024,4,3),(6180988,625079,4,4),(6180988,625080,4,5),(6180988,51362929,4,6),(6180988,51362931,4,7),(6180988,51362932,4,8),(6180988,625081,4,9),(6180988,625082,4,10),(6180988,625083,4,11),(6180988,51362569,4,12),(6181319,51389997,2,1),(6181319,51389999,2,2),(6181319,51390001,2,3),(6181319,51390003,2,4),(6181319,51390006,2,5),(6181319,51390008,2,6),(6181319,51390010,2,7),(6181319,51390012,2,8),(6181319,51390014,2,9),(6181319,51390016,2,10),(6181357,51392412,3,1),(6181357,51392415,3,2),(6181357,51392416,3,3),(6181357,51392417,3,4),(6181357,51392418,3,5),(6181357,51392420,3,6),(6181357,51392422,3,7),(6181357,51392424,3,8),(6181357,51392426,3,9),(6181357,51392429,3,10),(6181357,51392430,3,11),(6181357,51392432,3,12),(6181357,51392434,3,13),(6181357,51392435,3,14),(6181357,51392436,3,15),(6181357,51392437,3,16),(6181357,51392439,3,17),(6181357,51392441,3,18),(6181357,51392442,3,19),(6181357,51392445,3,20),(6181357,51392447,3,21),(6181419,51391054,2,1),(6181419,51391055,2,2),(6181419,51391057,2,3),(6181419,51391058,2,4),(6181419,51391060,2,5),(6181419,51391063,2,6),(6181419,51391064,2,7),(6181419,51391065,2,8),(6181419,51391067,2,9),(6181836,51396271,3,1),(6181836,51120891,3,2),(6181838,51396983,8,1),(6181838,51396985,8,2),(6181838,51396986,8,3),(6181838,51396989,8,4),(6181838,51396991,8,5),(6181838,51396992,8,6),(6181838,51396993,8,7),(6181838,51396996,8,8),(6181838,51396997,8,9),(6181838,51396999,8,10),(6181838,51397000,8,11),(6181838,51397003,8,12),(6181838,51397004,8,13),(6181838,51397005,8,14),(6181838,51397008,8,15),(6181838,51397009,8,16),(6181838,51397010,8,17),(6181838,51397012,8,18),(6181838,51397013,8,19),(6181838,51397015,8,20),(6181838,51397016,8,21),(6181838,51397017,8,22),(6181838,51397019,8,23),(6181838,51397021,8,24),(6181838,51397022,8,25),(6181838,51397024,8,26),(6181838,51397026,8,27),(6181838,51397027,8,28),(6181838,51397028,8,29),(6181838,51397029,8,30),(6181838,51397032,8,31),(6181838,51396360,8,32),(6181838,51396361,8,33),(6181838,51396363,8,34),(6181838,51397034,8,35),(6181838,51396365,8,36),(6181838,51396367,8,37),(6181838,51396369,8,38),(6181838,51396370,8,39),(6181838,51396371,8,40),(6181838,51396373,8,41),(6181838,51396374,8,42),(6181838,51396375,8,43),(6181838,51396377,8,44),(6181838,51396271,8,45),(6181838,51396378,8,46),(6181838,51396380,8,47),(6181838,51396399,8,48),(6181947,53273756,2,1),(6181947,53273755,2,2),(6181947,53273754,2,3),(6181947,53273753,2,4),(6181947,53273752,2,5),(6181947,53273751,2,6),(6181947,53273750,2,7),(6181947,53273749,2,8),(6181947,53273748,2,9),(6181947,53273747,2,10),(6181947,53273746,2,11),(6181947,53273745,2,12),(6181947,53273744,2,13),(6181947,53273743,2,14),(6181947,53273742,2,15),(6181947,53273741,2,16),(6181947,53273740,2,17),(6181947,53273739,2,18),(6181947,53273738,2,19),(6181947,53273737,2,20),(6181947,53273736,2,21),(6181947,53273735,2,22),(6181947,53273734,2,23),(6181947,53273733,2,24),(6181947,53273732,2,25),(6181947,53273731,2,26),(6181947,53273730,2,27),(6181947,53273729,2,28),(6181947,53273728,2,29),(6181947,53273727,2,30),(6181947,53273726,2,31),(6181947,53273725,2,32),(6181947,53273724,2,33),(6181947,53273723,2,34),(6181947,53273719,2,35),(6181947,53273716,2,36),(6181947,53273715,2,37),(6181947,53273714,2,38),(6181947,53273713,2,39),(6181947,53273712,2,40),(6181947,53273711,2,41),(6181947,53273710,2,42),(6181947,53273709,2,43),(6181947,53273708,2,44),(6181947,53273707,2,45),(6181947,53273706,2,46),(6181947,53273705,2,47),(6181947,53273704,2,48),(6181947,53273703,2,49),(6181947,53273702,2,50),(6181947,53273701,2,51),(6181947,53273700,2,52),(6181947,53273699,2,53),(6181947,53273698,2,54),(6181947,53273697,2,55),(6181947,53273696,2,56),(6181947,53273695,2,57),(6181947,53273694,2,58),(6181947,53273693,2,59),(6181947,53273692,2,60),(6181947,53273691,2,61),(6181947,53273690,2,62),(6181947,53273689,2,63),(6181947,53273688,2,64),(6181947,53273687,2,65),(6181947,53273686,2,66),(6181947,53273685,2,67),(6181947,53273684,2,68),(6181947,53273683,2,69),(6181947,53273682,2,70),(6181947,53273681,2,71),(6181947,53273680,2,72),(6181947,53273679,2,73),(6181947,53273678,2,74),(6181947,53273677,2,75),(6181947,53273676,2,76),(6181947,53273675,2,77),(6181947,53273674,2,78),(6181947,53273673,2,79),(6181947,53273672,2,80),(6181947,53273671,2,81),(6181947,53273670,2,82),(6181947,53273669,2,83),(6181947,53273668,2,84),(6181947,53273667,2,85),(6181947,51398098,2,86),(6181947,51398099,2,87),(6181947,51398048,2,88),(6181947,51398049,2,89),(6181947,51398053,2,90),(6181947,51398054,2,91),(6181947,51398057,2,92),(6181947,51398058,2,93),(6181947,51398059,2,94),(6181947,51398060,2,95),(6181947,51398063,2,96),(6181947,51398065,2,97),(6181947,51398068,2,98),(6181947,51398069,2,99),(6181947,51397727,2,100),(6181947,51397729,2,101),(6181947,51397731,2,102),(6181947,51397732,2,103),(6181947,51397733,2,104),(6181947,51397734,2,105),(6181947,51397737,2,106),(6181947,51397738,2,107),(6181947,51397740,2,108),(6181947,51397742,2,109),(6181947,51397744,2,110),(6181947,51397748,2,111),(6181947,51397749,2,112),(6181947,51397752,2,113),(6181947,51397753,2,114),(6181947,51397756,2,115),(6181947,51397757,2,116),(6181947,51397758,2,117),(6181947,51397762,2,118),(6181947,51397764,2,119),(6181947,51397766,2,120),(6181947,51397769,2,121),(6181947,51397770,2,122),(6181947,51397771,2,123),(6181947,51397772,2,124),(6181947,51397773,2,125),(6181947,51397776,2,126),(6181947,51397777,2,127),(6181947,51397779,2,128),(6181947,51397781,2,129),(6181947,51397782,2,130),(6181947,51397783,2,131),(6181947,51397786,2,132),(6181947,51397788,2,133),(6181947,51397790,2,134),(6181947,51397791,2,135),(6181947,51397794,2,136),(6181947,51397795,2,137),(6181947,51397796,2,138),(6181947,51397798,2,139),(6181947,51397799,2,140),(6181947,51397802,2,141),(6181947,51397803,2,142),(6181947,51397806,2,143),(6181947,51397808,2,144),(6181947,51397810,2,145),(6181947,51397813,2,146),(6181947,51397814,2,147),(6181947,51397815,2,148),(6181947,51397816,2,149),(6181947,51397818,2,150),(6181947,51397819,2,151),(6181947,51397821,2,152),(6181947,51397822,2,153),(6181947,51397824,2,154),(6181947,51397825,2,155),(6181947,51397826,2,156),(6181947,51397828,2,157),(6181947,51397829,2,158),(6181947,51397830,2,159),(6181947,51397831,2,160),(6181947,51397832,2,161),(6181947,51397834,2,162),(6181947,51397835,2,163),(6181947,51397837,2,164),(6182051,51399278,4,1),(6182051,51399409,4,2),(6182051,51399277,4,3),(6182051,51399602,4,4),(6182051,51399275,4,5),(6182051,51410491,4,6),(6182051,51399273,4,7),(6182051,51399272,4,8),(6182051,51399270,4,9),(6182051,51399299,4,10),(6182051,51399309,4,11),(6182051,51399269,4,12),(6182051,51399266,4,13),(6182051,51399265,4,14),(6182051,52688698,4,15),(6182051,52688701,4,16),(6182051,52688703,4,17),(6182052,51399285,4,1),(6182052,51399303,4,2),(6182052,51410792,4,3),(6182052,51399272,4,4),(6182052,51399289,4,5),(6182053,51399296,3,1),(6182053,51399306,3,2),(6182053,51410790,3,3),(6182053,51399299,3,4),(6182054,51399406,2,1),(6182054,51399335,2,2),(6182054,51399409,2,3),(6182054,51399398,2,4),(6182054,51399411,2,5),(6182056,268633715,3,1),(6182056,51399325,3,2),(6182056,51399326,3,3),(6182056,51399327,3,4),(6182056,51399398,3,5),(6182056,51399329,3,6),(6182056,52688876,3,7),(6182056,52688880,3,8),(6182057,51399335,4,1),(6182057,51399337,4,2),(6182057,51410490,4,3),(6182058,51399377,3,1),(6182058,51399304,3,2),(6182058,51410791,3,3),(6182058,51399380,3,4),(6182058,51399270,3,5),(6182058,51446997,3,6),(6182058,51447331,3,7),(6182058,51399381,3,8),(6182065,51399602,4,1),(6182065,52688880,4,2),(6182065,51399601,4,3),(6182097,51441626,7,1),(6182097,51441625,7,2),(6182097,51441623,7,3),(6182097,51441621,7,4),(6182097,51441619,7,5),(6182097,51441616,7,6),(6182097,51443695,7,7),(6182097,51441615,7,8),(6182097,51441611,7,9),(6182097,51441610,7,10),(6182097,51441607,7,11),(6182097,51441603,7,12),(6182097,51441659,7,13),(6182097,51400247,7,14),(6182097,51404720,7,15),(6182097,51400250,7,16),(6182097,51404888,7,17),(6182097,51400253,7,18),(6182097,51400254,7,19),(6182097,51399406,7,20),(6182097,51405087,7,21),(6182097,51400256,7,22),(6182097,268633715,7,23),(6182097,51400257,7,24),(6182097,337767559,7,25),(6182097,337739581,7,26),(6182122,51448405,9,1),(6182122,51448408,9,2),(6182122,278721406,9,3),(6182127,51400970,3,1),(6182127,51400971,3,2),(6182127,51400863,3,3),(6182127,51400866,3,4),(6182127,51400868,3,5),(6182127,51400869,3,6),(6182127,51400870,3,7),(6182159,51401444,5,1),(6182159,51401446,5,2),(6182159,51401447,5,3),(6182159,51401449,5,4),(6182159,51401451,5,5),(6182159,51401452,5,6),(6182159,51405729,5,7),(6182159,51401454,5,8),(6182267,51402983,3,1),(6182267,51402986,3,2),(6182267,51402987,3,3),(6182267,51402989,3,4),(6182278,51403223,4,1),(6182278,646807844,4,2),(6182278,51403224,4,3),(6182278,646807845,4,4),(6182278,51403225,4,5),(6182278,646807846,4,6),(6182278,51403226,4,7),(6182278,646807847,4,8),(6182278,51403228,4,9),(6182278,646807848,4,10),(6182278,51403229,4,11),(6182278,646807849,4,12),(6182278,51403231,4,13),(6182278,51403861,4,14),(6182278,51403232,4,15),(6182278,646807852,4,16),(6182278,646807855,4,17),(6182278,51403234,4,18),(6182278,51403223,4,19),(6182289,51403229,3,1),(6182289,51403654,3,2),(6182289,51403656,3,3),(6182289,51403657,3,4),(6182289,51403659,3,5),(6182289,51403661,3,6),(6182289,268630128,3,7),(6182303,51404073,3,1),(6182303,51403850,3,2),(6182303,51403851,3,3),(6182303,51403852,3,4),(6182303,51403854,3,5),(6182303,51403857,3,6),(6182303,51403858,3,7),(6182303,51403859,3,8),(6182303,51403861,3,9),(6182333,51404062,5,1),(6182333,646807701,5,2),(6182333,51404061,5,3),(6182333,646807706,5,4),(6182333,51404074,5,5),(6182333,646807713,5,6),(6182333,51404073,5,7),(6182333,646807720,5,8),(6182333,51404071,5,9),(6182333,51404069,5,10),(6182333,51404274,5,11),(6182333,51404067,5,12),(6182333,646807752,5,13),(6182333,51404066,5,14),(6182333,51404486,5,15),(6182333,646807770,5,16),(6182333,51404063,5,17),(6182333,646807785,5,18),(6182333,51404062,5,19),(6182349,51404272,2,1),(6182349,51404274,2,2),(6182350,51404282,3,1),(6182350,51404272,3,2),(6182364,51404888,13,1),(6182364,51404887,13,2),(6182364,51404949,13,3),(6182364,264290433,13,4),(6182364,51405091,13,5),(6182364,51404886,13,6),(6182364,264294525,13,7),(6182364,51404884,13,8),(6182364,264305363,13,9),(6182364,51404883,13,10),(6182364,270723120,13,11),(6182364,51404882,13,12),(6182371,51406244,11,1),(6182371,51972984,11,2),(6182371,51972980,11,3),(6182371,51405527,11,4),(6182371,51405528,11,5),(6182371,51405530,11,6),(6182371,51405533,11,7),(6182371,51405534,11,8),(6182371,51405536,11,9),(6182371,51405537,11,10),(6182371,51410094,11,11),(6182386,51400253,4,1),(6182386,277694146,4,2),(6182386,51404947,4,3),(6182386,277694080,4,4),(6182386,51404949,4,5),(6182401,51405087,5,1),(6182401,277694081,5,2),(6182401,51405091,5,3),(6182410,51405261,12,1),(6182410,646808595,12,2),(6182410,51405263,12,3),(6182410,646808596,12,4),(6182410,51405265,12,5),(6182410,51405266,12,6),(6182410,646808597,12,7),(6182410,51409972,12,8),(6182410,646808603,12,9),(6182410,51405268,12,10),(6182410,646808608,12,11),(6182410,51405269,12,12),(6182410,51405270,12,13),(6182410,264330870,12,14),(6182410,51405271,12,15),(6182410,264294716,12,16),(6182410,51405273,12,17),(6182410,646808624,12,18),(6182410,51405344,12,19),(6182410,51405261,12,20),(6182463,51406116,6,1),(6182463,51405712,6,2),(6182463,51405715,6,3),(6182463,51405716,6,4),(6182463,277695167,6,5),(6182505,51406111,4,1),(6182505,646808843,4,2),(6182505,646808846,4,3),(6182505,51406112,4,4),(6182505,51406811,4,5),(6182505,646808852,4,6),(6182505,51406113,4,7),(6182505,646808857,4,8),(6182505,646808861,4,9),(6182505,51406114,4,10),(6182505,646808867,4,11),(6182505,51406244,4,12),(6182505,646808879,4,13),(6182505,51406115,4,14),(6182505,646808882,4,15),(6182505,646808883,4,16),(6182505,51406116,4,17),(6182505,51406117,4,18),(6182505,646808884,4,19),(6182505,51406111,4,20),(6182542,51552500,8,1),(6182542,51552497,8,2),(6182542,52170040,8,3),(6182577,51407218,2,1),(6182577,51407219,2,2),(6182577,51407220,2,3),(6182577,51407222,2,4),(6182577,51407223,2,5),(6182577,51407226,2,6),(6182577,51407227,2,7),(6182577,51407228,2,8),(6182577,51407231,2,9),(6182577,51407232,2,10),(6182577,51407234,2,11),(6182577,51407235,2,12),(6182577,51407236,2,13),(6182577,51407238,2,14),(6182577,51407240,2,15),(6182577,51407243,2,16),(6182577,51407245,2,17),(6182577,51407247,2,18),(6182577,51407708,2,19),(6182577,51407709,2,20),(6182577,51407712,2,21),(6182577,51407714,2,22),(6182577,51407715,2,23),(6182577,51407716,2,24),(6182577,51408917,2,25),(6182577,51407718,2,26),(6182577,51407719,2,27),(6182577,51407720,2,28),(6182577,51407723,2,29),(6182577,51407725,2,30),(6182577,51407726,2,31),(6182577,51407728,2,32),(6182577,51407729,2,33),(6182577,51407731,2,34),(6182577,51407733,2,35),(6182577,51407736,2,36),(6182577,51407738,2,37),(6182577,51407739,2,38),(6182577,51407740,2,39),(6182577,51407742,2,40),(6182577,51407743,2,41),(6182577,51407744,2,42),(6182577,51407746,2,43),(6182577,51407747,2,44),(6182577,51407749,2,45),(6182577,51407751,2,46),(6182577,51407753,2,47),(6182577,51407754,2,48),(6182577,51407756,2,49),(6182577,51407759,2,50),(6182577,51407760,2,51),(6182577,51407764,2,52),(6182577,51407765,2,53),(6182577,51407766,2,54),(6182577,51407767,2,55),(6182577,51407769,2,56),(6182577,51407773,2,57),(6182577,51407774,2,58),(6182577,51407775,2,59),(6182577,51407778,2,60),(6182577,51407779,2,61),(6182577,51407781,2,62),(6182577,51407782,2,63),(6182577,51407784,2,64),(6182577,51407785,2,65),(6182577,51407786,2,66),(6182577,51407787,2,67),(6182577,51407789,2,68),(6182577,51407790,2,69),(6182577,51407791,2,70),(6182577,51408269,2,71),(6182577,51408270,2,72),(6182577,51408271,2,73),(6182577,51408274,2,74),(6182577,51408275,2,75),(6182577,51408278,2,76),(6182577,51408279,2,77),(6182577,51408280,2,78),(6182577,51408281,2,79),(6182577,51408282,2,80),(6182577,51408283,2,81),(6182577,51408284,2,82),(6182577,51408285,2,83),(6182577,51408286,2,84),(6182577,51408287,2,85),(6182577,51408288,2,86),(6182577,51408289,2,87),(6182577,51408290,2,88),(6182577,51408292,2,89),(6182577,51408294,2,90),(6182577,51408296,2,91),(6182577,51408299,2,92),(6182577,51408300,2,93),(6182577,51408302,2,94),(6182577,51408305,2,95),(6182577,51408306,2,96),(6182577,51408307,2,97),(6182577,51408310,2,98),(6182577,51408311,2,99),(6182675,51408485,2,1),(6182675,51408486,2,2),(6182675,51408490,2,3),(6182675,51408491,2,4),(6182675,51408492,2,5),(6182675,51408495,2,6),(6182675,51408496,2,7),(6182675,51408497,2,8),(6182675,51408498,2,9),(6182675,51408499,2,10),(6182675,51407231,2,11),(6182714,51408872,2,1),(6182714,51408873,2,2),(6182714,51408874,2,3),(6182714,51408875,2,4),(6182714,51408876,2,5),(6182714,51408879,2,6),(6182714,51408880,2,7),(6182714,51408883,2,8),(6182714,51408884,2,9),(6182714,51408885,2,10),(6182714,51408887,2,11),(6182714,51408889,2,12),(6182714,51408891,2,13),(6182714,51408892,2,14),(6182714,51408893,2,15),(6182714,51408896,2,16),(6182714,51408897,2,17),(6182714,51408898,2,18),(6182714,51408900,2,19),(6182714,51408902,2,20),(6182714,51408904,2,21),(6182714,51408905,2,22),(6182714,51408906,2,23),(6182714,51408909,2,24),(6182714,51408910,2,25),(6182714,51408911,2,26),(6182714,51408912,2,27),(6182714,51408913,2,28),(6182714,51408914,2,29),(6182714,51408915,2,30),(6182714,51408916,2,31),(6182714,51408917,2,32),(6182761,51409972,9,1),(6182761,51409974,9,2),(6182765,51410094,3,1),(6182765,51410095,3,2),(6182771,51410232,2,1),(6182771,51410233,2,2),(6182773,51410286,3,1),(6182773,51410282,3,2),(6182798,51410490,3,1),(6182798,51410491,3,2),(6182798,51410493,3,3),(6182798,51410494,3,4),(6182798,51410495,3,5),(6182810,51410786,2,1),(6182810,51410787,2,2),(6182810,51410788,2,3),(6182810,51410790,2,4),(6182810,51410791,2,5),(6182810,51410792,2,6),(6182810,51410490,2,7),(6182844,51411056,1,1),(6182844,51411057,1,2),(6182844,51411059,1,3),(6182844,51411060,1,4),(6182844,51411061,1,5),(6182844,51411062,1,6),(6182844,51411056,1,7),(6182932,51369109,4,1),(6182932,51412202,4,2),(6182932,51412201,4,3),(6182932,51412200,4,4),(6182932,51412199,4,5),(6182932,51412198,4,6),(6182932,51412197,4,7),(6182932,51412196,4,8),(6182932,51412195,4,9),(6182932,51412192,4,10),(6182932,51412189,4,11),(6182932,51412187,4,12),(6182932,51412185,4,13),(6182932,51412183,4,14),(6182932,51412181,4,15),(6182932,51412180,4,16),(6182932,51412179,4,17),(6182932,51412176,4,18),(6182932,51412175,4,19),(6182932,51412173,4,20),(6182932,51412171,4,21),(6182932,51412170,4,22),(6182932,51412169,4,23),(6182932,51412168,4,24),(6182932,51412167,4,25),(6182932,51412164,4,26),(6182932,51412163,4,27),(6182932,51412161,4,28),(6182932,51412159,4,29),(6182932,51412158,4,30),(6182932,51412157,4,31),(6182932,51412154,4,32),(6182932,51412152,4,33),(6182932,51412150,4,34),(6182932,51412148,4,35),(6182932,51412147,4,36),(6182932,51412144,4,37),(6182932,51412143,4,38),(6182932,51412142,4,39),(6182932,51412141,4,40),(6182932,51412138,4,41),(6182932,51412137,4,42),(6182932,51412136,4,43),(6182932,51412134,4,44),(6182932,51412132,4,45),(6182932,51412131,4,46),(6182932,51412128,4,47),(6182932,51412126,4,48),(6182932,51412125,4,49),(6182932,51412123,4,50),(6182932,51412122,4,51),(6182932,51412121,4,52),(6182932,51412119,4,53),(6182932,51412117,4,54),(6182932,51412116,4,55),(6182932,51412115,4,56),(6182932,51412112,4,57),(6182932,51412110,4,58),(6182932,51412109,4,59),(6182932,51412107,4,60),(6182932,51412106,4,61),(6182932,51412105,4,62),(6182932,51412103,4,63),(6182932,51412102,4,64),(6182932,51412100,4,65),(6182932,51412099,4,66),(6182932,52733223,4,67),(6182932,51412096,4,68),(6182932,51412095,4,69),(6182932,51412094,4,70),(6182932,51412093,4,71),(6182932,51412092,4,72),(6182932,51412091,4,73),(6182932,51412090,4,74),(6182932,51412087,4,75),(6182932,51412086,4,76),(6182932,51412083,4,77),(6182932,51412082,4,78),(6182932,51413104,4,79),(6182932,51413103,4,80),(6182932,51413100,4,81),(6182932,51413099,4,82),(6182932,51413097,4,83),(6182932,51413096,4,84),(6182932,51413094,4,85),(6182932,51413093,4,86),(6182932,51413091,4,87),(6182932,51413090,4,88),(6182932,51413087,4,89),(6182932,51413086,4,90),(6182932,51413085,4,91),(6182932,51413084,4,92),(6182932,51413083,4,93),(6182932,51413082,4,94),(6182932,51413079,4,95),(6182932,51413078,4,96),(6182932,51413075,4,97),(6182932,51413074,4,98),(6182932,51413073,4,99),(6182932,51413072,4,100),(6182932,51413071,4,101),(6182932,51413068,4,102),(6182932,51413067,4,103),(6182932,51413066,4,104),(6182932,51413065,4,105),(6182932,51413063,4,106),(6182932,51413061,4,107),(6182932,51413060,4,108),(6182932,51413058,4,109),(6182932,51413057,4,110),(6182932,51413055,4,111),(6182932,51413054,4,112),(6182932,51413053,4,113),(6182932,51413052,4,114),(6182932,51413050,4,115),(6182932,51413048,4,116),(6182932,51413047,4,117),(6182932,51413044,4,118),(6182932,51413043,4,119),(6182932,51413042,4,120),(6182932,51413041,4,121),(6182932,51413039,4,122),(6182932,51413038,4,123),(6182932,51413037,4,124),(6182932,51413035,4,125),(6182932,51413034,4,126),(6182932,51413033,4,127),(6182932,51413031,4,128),(6182932,51413029,4,129),(6182932,51413028,4,130),(6182932,51413027,4,131),(6182932,51413026,4,132),(6182932,51413024,4,133),(6182932,51413023,4,134),(6182932,51413021,4,135),(6182932,51413020,4,136),(6182932,51413018,4,137),(6182932,51413017,4,138),(6182932,51413014,4,139),(6182932,51413013,4,140),(6182932,51413011,4,141),(6182932,51413009,4,142),(6182932,51413008,4,143),(6182932,51413007,4,144),(6182932,51413006,4,145),(6182932,51413005,4,146),(6182932,51413004,4,147),(6182932,51413001,4,148),(6182932,51413000,4,149),(6182932,51412999,4,150),(6182932,51412998,4,151),(6182932,51412995,4,152),(6182932,51412994,4,153),(6182932,51413854,4,154),(6182932,51413412,4,155),(6182932,51413411,4,156),(6182932,51414092,4,157),(6182932,51414091,4,158),(6182932,51414090,4,159),(6182932,51414089,4,160),(6182932,51414087,4,161),(6182932,51414085,4,162),(6182932,51414084,4,163),(6182932,51414083,4,164),(6182932,51414082,4,165),(6182932,51414079,4,166),(6182932,51414078,4,167),(6182932,51414077,4,168),(6182932,51414076,4,169),(6182932,51414074,4,170),(6182932,51414072,4,171),(6182932,51414070,4,172),(6182932,51414069,4,173),(6182932,51414067,4,174),(6182932,51414065,4,175),(6182932,51414064,4,176),(6182932,51414063,4,177),(6182932,51414062,4,178),(6182932,51414061,4,179),(6182932,51414060,4,180),(6182932,51414057,4,181),(6182932,51414056,4,182),(6182932,51414055,4,183),(6182932,51414054,4,184),(6182932,51414053,4,185),(6182932,51414052,4,186),(6182932,51414051,4,187),(6182932,51414050,4,188),(6182932,51414049,4,189),(6182932,51414046,4,190),(6182932,51414045,4,191),(6182932,51414044,4,192),(6182932,51414041,4,193),(6182932,51414040,4,194),(6182932,51414036,4,195),(6182932,51414034,4,196),(6182932,51414033,4,197),(6182932,51414032,4,198),(6182932,51414031,4,199),(6182932,51414030,4,200),(6182932,51414028,4,201),(6182932,51414027,4,202),(6182932,51414025,4,203),(6182932,51414024,4,204),(6182932,51414023,4,205),(6182932,51414022,4,206),(6182932,51414021,4,207),(6182932,51414020,4,208),(6182932,51414019,4,209),(6182932,51414018,4,210),(6182932,51414017,4,211),(6182932,51414015,4,212),(6183078,51413826,2,1),(6183078,51413827,2,2),(6183078,51413832,2,3),(6183078,51413833,2,4),(6183078,51413835,2,5),(6183100,535385847,7,1),(6183100,51415016,7,2),(6183100,51415017,7,3),(6183100,51415018,7,4),(6183100,51415019,7,5),(6183100,51415021,7,6),(6183100,51415023,7,7),(6183100,51415024,7,8),(6183100,51415026,7,9),(6183100,51415027,7,10),(6183100,51415028,7,11),(6183100,51415030,7,12),(6183100,51415032,7,13),(6183100,51415033,7,14),(6183100,51415034,7,15),(6183100,51415035,7,16),(6183100,51415036,7,17),(6183100,51415039,7,18),(6183100,51415041,7,19),(6183100,51415042,7,20),(6183100,51415045,7,21),(6183100,51415046,7,22),(6183100,51416264,7,23),(6183100,51415047,7,24),(6183100,51415048,7,25),(6183100,51415049,7,26),(6183100,51415050,7,27),(6183100,51415051,7,28),(6183100,51415052,7,29),(6183100,51415053,7,30),(6183100,51415055,7,31),(6183100,51415249,7,32),(6183100,51415251,7,33),(6183100,51415253,7,34),(6183100,51415255,7,35),(6183100,51415257,7,36),(6183100,51415258,7,37),(6183100,51415781,7,38),(6183100,51415783,7,39),(6183100,51415785,7,40),(6183100,51415788,7,41),(6183100,51415790,7,42),(6183100,51415795,7,43),(6183100,51415796,7,44),(6183100,51415798,7,45),(6183100,51416727,7,46),(6183100,51416729,7,47),(6183100,51416731,7,48),(6183100,51416732,7,49),(6183100,51416733,7,50),(6183100,51416734,7,51),(6183100,51416735,7,52),(6183100,51416736,7,53),(6183100,51416737,7,54),(6183100,51416739,7,55),(6183100,51416740,7,56),(6183100,51416741,7,57),(6183100,51416743,7,58),(6183100,51416744,7,59),(6183100,51416746,7,60),(6183100,51416747,7,61),(6183100,51416748,7,62),(6183100,51416749,7,63),(6183100,51416750,7,64),(6183100,51416753,7,65),(6183100,51416754,7,66),(6183100,51416755,7,67),(6183100,51416756,7,68),(6183100,51416757,7,69),(6183100,51416758,7,70),(6183100,51416760,7,71),(6183100,51416761,7,72),(6183100,51416762,7,73),(6183100,51416763,7,74),(6183100,51416764,7,75),(6183100,51416765,7,76),(6183100,51416767,7,77),(6183100,51416768,7,78),(6183100,51416769,7,79),(6183100,51416770,7,80),(6183100,51416771,7,81),(6183100,51416772,7,82),(6183100,51416774,7,83),(6183100,51416775,7,84),(6183100,51416776,7,85),(6183100,51416779,7,86),(6183100,51416780,7,87),(6183100,51416781,7,88),(6183100,51416782,7,89),(6183100,51416783,7,90),(6183100,51416785,7,91),(6183100,51416786,7,92),(6183100,51416787,7,93),(6183100,51416789,7,94),(6183100,51416790,7,95),(6183100,51417251,7,96),(6183100,51417252,7,97),(6183100,51417253,7,98),(6183100,51417260,7,99),(6183100,51417263,7,100),(6183100,51417265,7,101),(6183100,51417268,7,102),(6183100,51417269,7,103),(6183100,51417272,7,104),(6183100,51417275,7,105),(6183100,51417277,7,106),(6183100,51417284,7,107),(6183100,51417285,7,108),(6183100,51417288,7,109),(6183100,51417289,7,110),(6183100,51417398,7,111),(6183100,51417291,7,112),(6183100,51417294,7,113),(6183100,51417298,7,114),(6183100,51420037,7,115),(6183100,51420038,7,116),(6183100,51420040,7,117),(6183100,51420042,7,118),(6183100,51420044,7,119),(6183100,51420045,7,120),(6183100,51420046,7,121),(6183100,51420048,7,122),(6183100,51420050,7,123),(6183100,51420052,7,124),(6183100,51420054,7,125),(6183100,51420057,7,126),(6183100,51420058,7,127),(6183100,51420059,7,128),(6183100,51420061,7,129),(6183100,51420063,7,130),(6183100,51420066,7,131),(6183100,51420067,7,132),(6183100,51420068,7,133),(6183100,51420072,7,134),(6183100,51420073,7,135),(6183100,51420076,7,136),(6183100,51420078,7,137),(6183100,51420079,7,138),(6183100,51420081,7,139),(6183100,51420084,7,140),(6183100,51420451,7,141),(6183100,51420452,7,142),(6183100,51420453,7,143),(6183100,51420454,7,144),(6183100,51420456,7,145),(6183100,51420457,7,146),(6183100,51420458,7,147),(6183100,51420461,7,148),(6183100,51420462,7,149),(6183100,51420464,7,150),(6183100,51420465,7,151),(6183100,51420466,7,152),(6183100,51420467,7,153),(6183100,51420469,7,154),(6183100,51420471,7,155),(6183100,51420474,7,156),(6183100,51420475,7,157),(6183100,51420476,7,158),(6183100,51420477,7,159),(6183100,51420893,7,160),(6183100,51420894,7,161),(6183100,51420895,7,162),(6183100,51420896,7,163),(6183100,51420899,7,164),(6183100,51420900,7,165),(6183100,51420902,7,166),(6183100,51420906,7,167),(6183100,51420908,7,168),(6183100,51420910,7,169),(6183100,51420912,7,170),(6183100,51420914,7,171),(6183100,51420916,7,172),(6183100,51420919,7,173),(6183100,51420921,7,174),(6183100,51420922,7,175),(6183100,51420926,7,176),(6183100,51420928,7,177),(6183100,51420929,7,178),(6183100,51420932,7,179),(6183100,51420933,7,180),(6183100,51420935,7,181),(6183100,51420938,7,182),(6183100,51420939,7,183),(6183100,51420940,7,184),(6183100,51420942,7,185),(6183100,51420945,7,186),(6183100,51420946,7,187),(6183100,51420950,7,188),(6183100,51420951,7,189),(6183100,51420952,7,190),(6183100,51420955,7,191),(6183100,51420956,7,192),(6183100,51420957,7,193),(6183100,51420958,7,194),(6183100,51420961,7,195),(6183100,51420964,7,196),(6183100,51420967,7,197),(6183100,51420968,7,198),(6183100,51420969,7,199),(6183100,51420970,7,200),(6183127,51414414,2,1),(6183127,51414415,2,2),(6183127,51414416,2,3),(6183127,51414417,2,4),(6183127,51414418,2,5),(6183127,51414419,2,6),(6183127,51414420,2,7),(6183127,51414421,2,8),(6183127,51414422,2,9),(6183127,51414423,2,10),(6183127,51414424,2,11),(6183127,51414425,2,12),(6183127,51414426,2,13),(6183127,51414428,2,14),(6183127,51414429,2,15),(6183127,51414430,2,16),(6183127,51414431,2,17),(6183127,51414432,2,18),(6183127,51414433,2,19),(6183127,51414434,2,20),(6183127,51414436,2,21),(6183127,51414437,2,22),(6183127,51414438,2,23),(6183127,51414439,2,24),(6183127,51414440,2,25),(6183169,51415055,2,1),(6183169,51415057,2,2),(6183169,51415059,2,3),(6183169,51415060,2,4),(6183169,51415061,2,5),(6183169,51415062,2,6),(6183169,51415066,2,7),(6183169,51415068,2,8),(6183169,51415069,2,9),(6183169,51414257,2,10),(6183169,51414258,2,11),(6183169,51414259,2,12),(6183169,51414262,2,13),(6183169,51414263,2,14),(6183169,51414264,2,15),(6183169,51414266,2,16),(6183169,51414267,2,17),(6183169,51414269,2,18),(6183169,51414270,2,19),(6183169,51414271,2,20),(6183169,51414273,2,21),(6183169,51414274,2,22),(6183169,51414276,2,23),(6183169,51414440,2,24),(6183169,51414277,2,25),(6183169,51414278,2,26),(6183169,51414279,2,27),(6183169,51414280,2,28),(6183169,51414283,2,29),(6183169,51414284,2,30),(6183169,51414285,2,31),(6183169,51414286,2,32),(6183169,51414288,2,33),(6183169,51414289,2,34),(6183169,51414290,2,35),(6183169,51414167,2,36),(6183169,51414169,2,37),(6183169,51414015,2,38),(6183270,51416291,2,1),(6183270,51416292,2,2),(6183270,51416294,2,3),(6183270,51416297,2,4),(6183270,51416298,2,5),(6183270,51416299,2,6),(6183273,51415798,3,1),(6183273,51416340,3,2),(6183273,51416343,3,3),(6183273,51416345,3,4),(6183273,51416349,3,5),(6183273,51416351,3,6),(6183273,51416352,3,7),(6183273,51416353,3,8),(6183273,51416354,3,9),(6183273,51416356,3,10),(6183273,51416357,3,11),(6183273,51416359,3,12),(6183273,51416361,3,13),(6183273,51416364,3,14),(6183273,51416365,3,15),(6183273,51416366,3,16),(6183273,51416367,3,17),(6183273,51416370,3,18),(6183273,51416371,3,19),(6183273,51416372,3,20),(6183273,51416375,3,21),(6183273,51416376,3,22),(6183273,51416379,3,23),(6183273,51416380,3,24),(6183273,51416381,3,25),(6183273,51416382,3,26),(6183273,51416299,3,27),(6183273,51416264,3,28),(6183357,51417410,2,1),(6183357,51417414,2,2),(6183357,51417416,2,3),(6183357,51417419,2,4),(6183357,51417420,2,5),(6183357,51417488,2,6),(6183357,51417421,2,7),(6183357,51417398,2,8),(6183360,51417467,2,1),(6183360,51417468,2,2),(6183360,51417469,2,3),(6183360,51417472,2,4),(6183360,51417476,2,5),(6183360,51417481,2,6),(6183360,51417482,2,7),(6183360,51417484,2,8),(6183360,51417488,2,9),(6183573,51421275,2,1),(6183573,51421278,2,2),(6183573,51421280,2,3),(6183573,51421281,2,4),(6183573,51421284,2,5),(6183573,51413835,2,6),(6183573,51421287,2,7),(6183573,51421289,2,8),(6183573,51421291,2,9),(6183573,51421294,2,10),(6183573,51421295,2,11),(6183573,51421296,2,12),(6183573,51421297,2,13),(6183573,51413854,2,14),(6184947,51438191,1,1),(6184947,51438193,1,2),(6184947,51438194,1,3),(6184947,51438195,1,4),(6184947,51438191,1,5),(6185032,51439215,3,1),(6185032,51439216,3,2),(6185060,51440235,2,1),(6185060,51439552,2,2),(6185090,51439943,2,1),(6185090,51439944,2,2),(6185090,51439947,2,3),(6185090,51439949,2,4),(6185090,51439951,2,5),(6185090,51439953,2,6),(6185090,51439955,2,7),(6185090,51439959,2,8),(6185090,51439960,2,9),(6185090,51439962,2,10),(6185090,51439964,2,11),(6185090,51439967,2,12),(6185090,51385276,2,13),(6185110,51441848,7,1),(6185110,52688934,7,2),(6185110,52688931,7,3),(6185110,52688929,7,4),(6185110,51438631,7,5),(6185110,51438632,7,6),(6185110,324270172,7,7),(6185110,324270173,7,8),(6185110,324270174,7,9),(6185122,51441848,11,1),(6185122,51441849,11,2),(6185122,51441850,11,3),(6185149,51440620,2,1),(6185149,51440622,2,2),(6185336,51442349,3,1),(6185336,51442351,3,2),(6185336,51442352,3,3),(6185353,51442529,3,1),(6185353,51442532,3,2),(6185363,51442648,2,1),(6185363,51442649,2,2),(6185363,51442651,2,3),(6185363,51442653,2,4),(6185394,51442942,2,1),(6185394,51442943,2,2),(6185394,51442944,2,3),(6185394,51442946,2,4),(6185394,51442947,2,5),(6185394,51442949,2,6),(6185394,51442951,2,7),(6185394,51442952,2,8),(6185394,51442953,2,9),(6185394,51442955,2,10),(6185394,51442956,2,11),(6185394,51442957,2,12),(6185394,51442958,2,13),(6185394,51442959,2,14),(6185394,51442960,2,15),(6185394,51442961,2,16),(6185421,51443310,2,1),(6185421,51443312,2,2),(6185421,51443313,2,3),(6185421,51443314,2,4),(6185421,51443315,2,5),(6185421,51443317,2,6),(6185421,51443319,2,7),(6185589,51444884,2,1),(6185589,51444885,2,2),(6185589,51445067,2,3),(6185589,51445068,2,4),(6185589,51445069,2,5),(6185589,51445070,2,6),(6185589,51445071,2,7),(6185589,51445073,2,8),(6185611,51445276,3,1),(6185611,51445277,3,2),(6185611,51445278,3,3),(6185611,51445071,3,4),(6185640,51445785,3,1),(6185640,51445766,3,2),(6185640,51445767,3,3),(6185640,51445769,3,4),(6185640,51445772,3,5),(6185640,51445774,3,6),(6185640,51441619,3,7),(6185710,51446293,1,1),(6185710,51446294,1,2),(6185710,51446295,1,3),(6185710,51446297,1,4),(6185710,51446298,1,5),(6185710,51446299,1,6),(6185710,51446300,1,7),(6185710,51446302,1,8),(6185710,51446303,1,9),(6185710,51446306,1,10),(6185710,51446307,1,11),(6185710,51446309,1,12),(6185710,51446312,1,13),(6185710,51446293,1,14),(6185726,51443676,4,1),(6185726,51446677,4,2),(6185726,51446679,4,3),(6185726,51446680,4,4),(6185726,51446682,4,5),(6185726,51446684,4,6),(6185726,51446687,4,7),(6185726,51446688,4,8),(6185726,51446690,4,9),(6185726,51446485,4,10),(6185726,51446486,4,11),(6185726,51446487,4,12),(6185726,51446490,4,13),(6185726,51446491,4,14),(6185726,51446492,4,15),(6185726,51446494,4,16),(6185775,51447331,3,1),(6185775,51399289,3,2),(6185775,51410493,3,3),(6185775,51399292,3,4),(6185775,52688810,3,5),(6185795,51400267,2,1),(6185795,51447714,2,2),(6185800,51400267,13,1),(6185800,51400269,13,2),(6185800,51401461,13,3),(6185800,51400270,13,4),(6185800,51400272,13,5),(6185807,51400263,4,1),(6185807,51400871,4,2),(6185807,51400264,4,3),(6185807,51400768,4,4),(6185807,51400267,4,5),(6185826,270726771,9,1),(6185826,51448127,9,2),(6185826,51447714,9,3),(6185826,270725952,9,4),(6185878,270723459,8,1),(6185878,51448537,8,2),(6185878,51448538,8,3),(6185878,270723936,8,4),(6185878,51448539,8,5),(6185878,51448541,8,6),(6185878,270723937,8,7),(6185878,270725823,8,8),(6185911,51448926,2,1),(6185911,51448928,2,2),(6185911,51448929,2,3),(6185911,51448931,2,4),(6185911,51448934,2,5),(6185911,51449177,2,6),(6185911,51448936,2,7),(6185911,51448937,2,8),(6185911,51450767,2,9),(6185911,51448938,2,10),(6185911,51448940,2,11),(6185926,51449055,2,1),(6185926,51449056,2,2),(6185926,51449057,2,3),(6185926,51449058,2,4),(6185926,51449060,2,5),(6185926,51449062,2,6),(6185926,51449148,2,7),(6185926,51449064,2,8),(6185930,51449177,2,1),(6185930,51449178,2,2),(6185930,51449179,2,3),(6185930,51449130,2,4),(6185930,51449133,2,5),(6185930,51449134,2,6),(6185930,51449137,2,7),(6185930,51449139,2,8),(6185930,51449140,2,9),(6185930,51449148,2,10),(6185971,51363247,5,1),(6185971,51363248,5,2),(6185971,625069,5,3),(6185971,51363250,5,4),(6185971,625070,5,5),(6185986,51450303,8,1),(6185986,625050,8,2),(6185986,51364400,8,3),(6185986,625051,8,4),(6185986,51363884,8,5),(6185986,270733583,8,6),(6185986,625052,8,7),(6185986,625053,8,8),(6185986,625054,8,9),(6185986,270733584,8,10),(6185986,625055,8,11),(6185986,51448830,8,12),(6185986,625056,8,13),(6185986,625057,8,14),(6185986,51363795,8,15),(6185986,894217189,8,16),(6185986,51448926,8,17),(6185986,625058,8,18),(6185986,51363797,8,19),(6185986,625059,8,20),(6185986,894259411,8,21),(6185986,51363800,8,22),(6185986,894259334,8,23),(6185986,625060,8,24),(6185986,894259303,8,25),(6185986,625061,8,26),(6185986,625062,8,27),(6185986,51363565,8,28),(6185986,51363567,8,29),(6185986,625072,8,30),(6185986,51363568,8,31),(6185986,625063,8,32),(6185986,894259390,8,33),(6185986,625064,8,34),(6185986,51363414,8,35),(6185986,625065,8,36),(6185986,625066,8,37),(6185986,51363415,8,38),(6185986,625067,8,39),(6185986,51363244,8,40),(6185986,51363246,8,41),(6185986,625068,8,42),(6185986,259406980,8,43),(6185986,51363248,8,44),(6185988,51363247,5,1),(6185988,51449552,5,2),(6185988,51449553,5,3),(6185988,51449672,5,4),(6185988,51449673,5,5),(6185988,51449675,5,6),(6185988,51449676,5,7),(6185988,51449997,5,8),(6185988,51449998,5,9),(6185988,51449999,5,10),(6185988,51450002,5,11),(6185988,51450003,5,12),(6185988,51450004,5,13),(6185988,51450007,5,14),(6185988,51450008,5,15),(6185988,51450009,5,16),(6185988,51450011,5,17),(6185988,51450013,5,18),(6185988,51450014,5,19),(6185988,51450016,5,20),(6185988,51450017,5,21),(6185988,51450019,5,22),(6186037,51450106,10,1),(6186037,769252942,10,2),(6186037,270730467,10,3),(6186037,51450107,10,4),(6186037,270730923,10,5),(6186037,51450110,10,6),(6186037,51450178,10,7),(6186037,51450111,10,8),(6186037,769252948,10,9),(6186037,51450113,10,10),(6186037,51450114,10,11),(6186037,769252949,10,12),(6186037,51450116,10,13),(6186037,769252950,10,14),(6186037,51450118,10,15),(6186037,769252951,10,16),(6186037,51450303,10,17),(6186037,51450106,10,18),(6186094,51450764,2,1),(6186094,51450766,2,2),(6186094,51450767,2,3),(6195793,51552500,6,1),(6195793,52170032,6,2),(6195793,52170036,6,3),(6195793,52170031,6,4),(6195793,51552507,6,5),(6195793,51552509,6,6),(6195793,51552513,6,7),(6195793,51552516,6,8),(6195793,51552518,6,9),(6195794,51552518,6,1),(6195794,51552546,6,2),(6195794,52170099,6,3),(6195795,51552589,2,1),(6195795,51552592,2,2),(6195796,51552592,2,1),(6195796,51552555,2,2),(6195797,51552592,2,1),(6195797,51552550,2,2),(6195885,51554707,2,1),(6195885,51552875,2,2),(6195885,51554710,2,3),(6195885,51554712,2,4),(6195885,51554715,2,5),(6195885,51554716,2,6),(6195885,51554685,2,7),(6195885,51554688,2,8),(6195885,51554691,2,9),(6195885,51554693,2,10),(6195885,51554694,2,11),(6195885,51554697,2,12),(6195885,51554700,2,13),(6195885,51554703,2,14),(6195885,51554705,2,15),(6195885,51554707,2,16),(6196087,51554700,6,1),(6196087,51557999,6,2),(6196407,51558293,8,1),(6196407,51558295,8,2),(6196407,51558298,8,3),(6196407,51558301,8,4),(6196407,51558304,8,5),(6196407,51558305,8,6),(6196407,51563059,8,7),(6196407,51563061,8,8),(6196407,51563063,8,9),(6196407,51563066,8,10),(6196407,51563071,8,11),(6196407,51563075,8,12),(6196407,51563076,8,13),(6196407,51563080,8,14),(6196407,51563083,8,15),(6196407,51563087,8,16),(6196407,51563090,8,17),(6196407,51563094,8,18),(6196407,51563098,8,19),(6196407,51563100,8,20),(6196407,51563103,8,21),(6196407,51563105,8,22),(6196407,51563108,8,23),(6196407,51563110,8,24),(6196407,51563113,8,25),(6196407,51563115,8,26),(6196407,51563118,8,27),(6196407,51563120,8,28),(6196407,51563122,8,29),(6196407,51563124,8,30),(6196407,51563127,8,31),(6196407,51563130,8,32),(6196407,51563134,8,33),(6196407,51563137,8,34),(6196407,51563140,8,35),(6196407,51563141,8,36),(6196407,51563145,8,37),(6196407,51563148,8,38),(6196407,51563152,8,39),(6196407,51563155,8,40),(6196407,51563159,8,41),(6196407,51563162,8,42),(6196407,51563164,8,43),(6196407,51563168,8,44),(6196407,51563170,8,45),(6196407,51563173,8,46),(6196407,51563176,8,47),(6196407,51563177,8,48),(6196407,51563179,8,49),(6196407,51563181,8,50),(6196407,51563185,8,51),(6196407,51563189,8,52),(6196407,51563192,8,53),(6196407,51563195,8,54),(6196407,51563197,8,55),(6196407,51563199,8,56),(6196407,51563200,8,57),(6196407,51563202,8,58),(6196407,51563205,8,59),(6196407,51563210,8,60),(6196407,51563214,8,61),(6196407,51563216,8,62),(6196407,51563224,8,63),(6196407,51563226,8,64),(6196407,51563230,8,65),(6196407,51563233,8,66),(6196407,51563236,8,67),(6196407,51563238,8,68),(6196407,51563242,8,69),(6196407,51563244,8,70),(6196407,51563247,8,71),(6196407,51563252,8,72),(6196407,51563255,8,73),(6196407,51563257,8,74),(6196407,51563261,8,75),(6196407,51563266,8,76),(6196407,51563268,8,77),(6196407,51563272,8,78),(6196407,51563276,8,79),(6196407,51563279,8,80),(6196407,51563281,8,81),(6196407,53368932,8,82),(6196407,51563284,8,83),(6196407,51563374,8,84),(6196407,51563375,8,85),(6196407,51563437,8,86),(6196407,51563439,8,87),(6196407,51563440,8,88),(6196407,53371129,8,89),(6196407,51563441,8,90),(6196407,51563442,8,91),(6196407,51563443,8,92),(6196407,51563447,8,93),(6196407,51563450,8,94),(6196407,51563451,8,95),(6196407,51563453,8,96),(6196407,51563454,8,97),(6196407,51563456,8,98),(6196407,51563458,8,99),(6196407,51563460,8,100),(6196407,51563462,8,101),(6196407,51563463,8,102),(6196407,51563466,8,103),(6196407,51563470,8,104),(6196407,51563472,8,105),(6196407,51563474,8,106),(6196407,51563477,8,107),(6196407,51563480,8,108),(6196407,51563481,8,109),(6196407,51563484,8,110),(6196407,51563485,8,111),(6196407,51563488,8,112),(6196407,51563490,8,113),(6196407,51563492,8,114),(6196407,51563494,8,115),(6196407,51563496,8,116),(6196407,51563499,8,117),(6196407,53371134,8,118),(6196407,53371138,8,119),(6196407,53371141,8,120),(6196407,53371144,8,121),(6196407,53371154,8,122),(6196407,53371160,8,123),(6196407,53371174,8,124),(6196407,53371181,8,125),(6196407,53371551,8,126),(6196407,53371691,8,127),(6196407,53371748,8,128),(6196407,53371859,8,129),(6196407,53371756,8,130),(6196407,53371761,8,131),(6196407,53371763,8,132),(6196407,53371771,8,133),(6196407,53371778,8,134),(6196407,53371784,8,135),(6196407,53371787,8,136),(6196407,53371793,8,137),(6196407,53371799,8,138),(6196407,53371862,8,139),(6196407,53371868,8,140),(6196407,53371873,8,141),(6196407,53371881,8,142),(6196407,53371890,8,143),(6196407,53371908,8,144),(6196407,53371942,8,145),(6196407,53371951,8,146),(6196407,53371955,8,147),(6196407,53371958,8,148),(6196407,53371963,8,149),(6196407,53371969,8,150),(6196407,53371993,8,151),(6196407,53371998,8,152),(6196407,53372005,8,153),(6196407,53372015,8,154),(6196407,53372021,8,155),(6196407,53372044,8,156),(6196407,53372056,8,157),(6196407,53372063,8,158),(6196407,53372072,8,159),(6196407,53372078,8,160),(6196407,53372086,8,161),(6196407,53372094,8,162),(6196407,53372108,8,163),(6196407,53372121,8,164),(6196407,53372132,8,165),(6196407,53372138,8,166),(6196407,53372143,8,167),(6196407,53372151,8,168),(6196407,53372163,8,169),(6196407,53372180,8,170),(6196407,53372190,8,171),(6196407,53372197,8,172),(6196407,53376964,8,173),(6196407,53372208,8,174),(6196407,53372217,8,175),(6196407,53372225,8,176),(6196407,53372232,8,177),(6196407,53372242,8,178),(6196407,53372246,8,179),(6196407,53372255,8,180),(6196407,53372261,8,181),(6196407,53372271,8,182),(6196407,53372278,8,183),(6196407,53372284,8,184),(6196407,53372290,8,185),(6196407,53372297,8,186),(6196407,53372305,8,187),(6196407,53372352,8,188),(6196407,53372357,8,189),(6196407,53372365,8,190),(6196407,53372381,8,191),(6196407,53372404,8,192),(6196407,53372410,8,193),(6196407,53372412,8,194),(6196407,53372413,8,195),(6196407,53372418,8,196),(6196407,53372422,8,197),(6196407,53372427,8,198),(6196407,53372432,8,199),(6196407,53372437,8,200),(6196407,53372442,8,201),(6196407,53372446,8,202),(6196407,53372456,8,203),(6196407,53372458,8,204),(6196407,53372462,8,205),(6196407,53372466,8,206),(6196407,53372476,8,207),(6196407,53372487,8,208),(6196407,53372493,8,209),(6196407,53372501,8,210),(6196407,53372509,8,211),(6196407,53372513,8,212),(6196407,53372518,8,213),(6196407,53372522,8,214),(6196407,53372527,8,215),(6196407,53372535,8,216),(6196407,53372541,8,217),(6196407,53372544,8,218),(6196407,53372549,8,219),(6196407,53372555,8,220),(6196407,53372562,8,221),(6196407,53372568,8,222),(6196407,53372577,8,223),(6196407,53372587,8,224),(6196407,53372608,8,225),(6196407,53372614,8,226),(6196407,53372629,8,227),(6196407,53372637,8,228),(6196407,53372777,8,229),(6196407,53372794,8,230),(6196407,53372806,8,231),(6196407,53372815,8,232),(6196407,53372828,8,233),(6196407,53372832,8,234),(6196407,53372838,8,235),(6196407,53372843,8,236),(6196407,53372852,8,237),(6196407,53372858,8,238),(6196407,53372863,8,239),(6196407,53372873,8,240),(6196407,53372879,8,241),(6196407,53372887,8,242),(6196407,53372892,8,243),(6196407,53372903,8,244),(6196407,53372912,8,245),(6196407,53372917,8,246),(6196407,53372927,8,247),(6196407,53372935,8,248),(6196407,53372942,8,249),(6196407,53372956,8,250),(6196407,53372965,8,251),(6196407,53372978,8,252),(6196407,53372982,8,253),(6196407,53372991,8,254),(6196407,53373005,8,255),(6196407,53373016,8,256),(6196407,53373029,8,257),(6196407,53373035,8,258),(6196407,53373049,8,259),(6196407,53373068,8,260),(6196407,53373079,8,261),(6196407,53373094,8,262),(6196407,53373107,8,263),(6196407,53373114,8,264),(6196407,53373121,8,265),(6196407,53373130,8,266),(6196407,53373163,8,267),(6196407,53373182,8,268),(6196407,53373197,8,269),(6196407,53373203,8,270),(6196407,53373215,8,271),(6196407,53373224,8,272),(6196407,53373230,8,273),(6196407,53373233,8,274),(6196407,53373241,8,275),(6196407,53373246,8,276),(6196407,53373251,8,277),(6196407,53373259,8,278),(6196407,53373266,8,279),(6196407,53373270,8,280),(6196407,53373275,8,281),(6196407,367680427,8,282),(6196407,53373280,8,283),(6196407,53373289,8,284),(6196407,53373297,8,285),(6196407,53373303,8,286),(6196407,53373308,8,287),(6196407,53373311,8,288),(6196407,53373318,8,289),(6196407,53373327,8,290),(6196407,53373335,8,291),(6196407,53373343,8,292),(6196407,53373348,8,293),(6196407,53373356,8,294),(6196407,53373365,8,295),(6196407,53373376,8,296),(6196407,53373382,8,297),(6196407,53373386,8,298),(6196407,53373392,8,299),(6196407,53373399,8,300),(6196407,53373402,8,301),(6196407,53373406,8,302),(6196407,53373410,8,303),(6196407,53373416,8,304),(6196407,53373457,8,305),(6196407,53373463,8,306),(6196407,53373467,8,307),(6196407,53373472,8,308),(6196407,53373475,8,309),(6196407,53373479,8,310),(6196407,53373480,8,311),(6196407,53373484,8,312),(6196407,53373499,8,313),(6196407,53373501,8,314),(6196407,53373507,8,315),(6196407,53373512,8,316),(6196407,53373516,8,317),(6196407,53373521,8,318),(6196407,53373529,8,319),(6196407,53373532,8,320),(6196407,53373536,8,321),(6196407,53373543,8,322),(6196407,53373545,8,323),(6196407,53373549,8,324),(6196407,53374387,8,325),(6196407,53374403,8,326),(6196407,53374521,8,327),(6196407,53374531,8,328),(6196407,53374534,8,329),(6196407,53374537,8,330),(6196407,53374542,8,331),(6196407,53374635,8,332),(6196407,53374797,8,333),(6196407,53374856,8,334),(6196407,53374862,8,335),(6196407,53374867,8,336),(6196407,53374883,8,337),(6196407,53374887,8,338),(6196407,53374892,8,339),(6196407,53374894,8,340),(6196407,53374897,8,341),(6196407,53374901,8,342),(6196407,53374925,8,343),(6196407,53374929,8,344),(6196407,53375001,8,345),(6196407,53375004,8,346),(6196407,53375007,8,347),(6196407,53375010,8,348),(6196407,53375014,8,349),(6196407,53375016,8,350),(6196407,53375019,8,351),(6196407,53375022,8,352),(6196407,53375026,8,353),(6196407,53375056,8,354),(6196407,53375086,8,355),(6196407,53375126,8,356),(6196407,53375501,8,357),(6196407,53376238,8,358),(6196407,53376244,8,359),(6196407,53376247,8,360),(6196407,53376253,8,361),(6196407,53376257,8,362),(6196407,53376264,8,363),(6196407,53376267,8,364),(6196407,53376272,8,365),(6196407,53376275,8,366),(6196407,53376314,8,367),(6196407,53376323,8,368),(6196407,53376331,8,369),(6196407,53376354,8,370),(6196407,53376363,8,371),(6196407,53376376,8,372),(6196407,53376378,8,373),(6196407,53376383,8,374),(6196407,53376386,8,375),(6196407,53376390,8,376),(6196407,53376392,8,377),(6196407,53376394,8,378),(6196407,53376397,8,379),(6196407,53376399,8,380),(6196407,53376401,8,381),(6196407,53376405,8,382),(6196407,53376408,8,383),(6196407,53376414,8,384),(6196407,53376419,8,385),(6196407,53376421,8,386),(6196407,53376423,8,387),(6196407,53376428,8,388),(6196407,53376431,8,389),(6196407,53376435,8,390),(6196407,53376437,8,391),(6196407,53376438,8,392),(6196407,53376440,8,393),(6196407,53376442,8,394),(6196407,53376444,8,395),(6196407,53376448,8,396),(6196407,53376451,8,397),(6196407,53376626,8,398),(6196407,53376629,8,399),(6196407,53376632,8,400),(6196407,53376634,8,401),(6196407,53376637,8,402),(6196407,53376658,8,403),(6196407,53376660,8,404),(6196407,53376663,8,405),(6196407,53376664,8,406),(6196407,53376666,8,407),(6196407,53376670,8,408),(6196407,53376674,8,409),(6196407,53376677,8,410),(6196407,53376682,8,411),(6196407,53376683,8,412),(6196407,53376686,8,413),(6196407,53376689,8,414),(6196407,53376692,8,415),(6196407,53376695,8,416),(6196407,53376699,8,417),(6196407,53376702,8,418),(6196407,53376704,8,419),(6196407,53376709,8,420),(6196407,53376715,8,421),(6196407,53376719,8,422),(6196407,53376723,8,423),(6196407,53376729,8,424),(6196407,53376733,8,425),(6196407,53376737,8,426),(6196407,53376740,8,427),(6196407,53376743,8,428),(6196407,53376746,8,429),(6196407,53376748,8,430),(6196407,53376750,8,431),(6196407,53376751,8,432),(6196407,53376753,8,433),(6196407,53376754,8,434),(6196407,53376756,8,435),(6196407,53376757,8,436),(6196407,53376761,8,437),(6196407,53376764,8,438),(6196407,53376766,8,439),(6196407,53376768,8,440),(6196407,53376771,8,441),(6196407,53376772,8,442),(6196407,53376775,8,443),(6196407,53376777,8,444),(6196407,53376780,8,445),(6196407,53376782,8,446),(6196407,53376784,8,447),(6196407,53376788,8,448),(6196407,53376797,8,449),(6196407,53376799,8,450),(6196407,53376802,8,451),(6196407,53376806,8,452),(6196407,53376810,8,453),(6196407,53376814,8,454),(6196407,53376816,8,455),(6196407,53376820,8,456),(6196407,53376827,8,457),(6196407,53376830,8,458),(6196407,53376834,8,459),(6196407,53376837,8,460),(6196407,53376840,8,461),(6196407,53376847,8,462),(6196407,53376853,8,463),(6196407,53376856,8,464),(6196407,53376859,8,465),(6196407,53376862,8,466),(6196407,53376864,8,467),(6196407,53376873,8,468);
INSERT INTO `way_nodes` VALUES (6196407,53376881,8,469),(6196407,53376883,8,470),(6196407,53376887,8,471),(6196407,53376891,8,472),(6196407,53376895,8,473),(6196407,53376898,8,474),(6196407,53376899,8,475),(6197719,51581679,5,1),(6197719,51581574,5,2),(6197721,51581675,17,1),(6197721,51581686,17,2),(6197721,51581690,17,3),(6197721,51581692,17,4),(6197721,51581695,17,5),(6197721,354962410,17,6),(6197723,51581762,4,1),(6197723,51581759,4,2),(6197723,51581757,4,3),(6197723,51581754,4,4),(6197723,51581791,4,5),(6197723,51581751,4,6),(6197723,51581783,4,7),(6197723,51581782,4,8),(6197723,51581778,4,9),(6197723,51581776,4,10),(6197723,51581772,4,11),(6197723,51581769,4,12),(6197723,51581766,4,13),(6197723,51581762,4,14),(6197727,51581791,18,1),(6197727,51581788,18,2),(6197727,51581786,18,3),(6197727,51581795,18,4),(6198025,51587707,7,1),(6198025,51587705,7,2),(6198025,51587715,7,3),(6198025,51587703,7,4),(6198025,51587721,7,5),(6198025,51587723,7,6),(6198025,51587694,7,7),(6198025,51587726,7,8),(6198025,51587693,7,9),(6198025,51587729,7,10),(6198025,51587732,7,11),(6198025,51587707,7,12),(6198027,51581769,4,1),(6198027,51587707,4,2),(6198139,51587729,4,1),(6198139,51581759,4,2),(6225803,51587705,14,1),(6225803,51589112,14,2),(6225803,51589115,14,3),(6225803,51589117,14,4),(6225803,266334665,14,5),(6225803,51589119,14,6),(6225803,51589122,14,7),(6225803,51589125,14,8),(6225803,51589128,14,9),(6225803,51589130,14,10),(6225803,51589133,14,11),(6225803,51589136,14,12),(6225803,51589138,14,13),(6225803,51589142,14,14),(6225803,51589144,14,15),(6225803,51589146,14,16),(6225803,51589149,14,17),(6225803,51589152,14,18),(6225803,51589155,14,19),(6225803,51589157,14,20),(6225803,51589158,14,21),(6225803,51589160,14,22),(6225803,51589161,14,23),(6225803,51589162,14,24),(6225803,51589163,14,25),(6225803,51589165,14,26),(6225803,51589169,14,27),(6225803,51589172,14,28),(6225803,51589174,14,29),(6225803,51589177,14,30),(6225803,51589180,14,31),(6225803,51589183,14,32),(6225803,51589185,14,33),(6225803,51589187,14,34),(6225803,51589190,14,35),(6225803,51589192,14,36),(6225803,51589194,14,37),(6225803,51589196,14,38),(6225803,51589198,14,39),(6225803,51589201,14,40),(6225803,51589203,14,41),(6225803,51589205,14,42),(6225803,51589208,14,43),(6225803,51589210,14,44),(6225803,51589213,14,45),(6225803,51589215,14,46),(6225803,51589217,14,47),(6225803,51589220,14,48),(6225803,51589223,14,49),(6225803,51589226,14,50),(6225803,51589229,14,51),(6225803,51589230,14,52),(6225803,51589233,14,53),(6225803,51589236,14,54),(6225803,51589238,14,55),(6225803,51589243,14,56),(6225803,51589247,14,57),(6225803,51589249,14,58),(6225803,51589252,14,59),(6225803,51589254,14,60),(6225803,51589256,14,61),(6225803,51589259,14,62),(6225803,51589262,14,63),(6225803,51589263,14,64),(6225803,51589267,14,65),(6225803,51589270,14,66),(6225803,51589273,14,67),(6225803,51589275,14,68),(6225803,51589278,14,69),(6225803,51589281,14,70),(6225803,51589284,14,71),(6225803,51589288,14,72),(6225803,51589290,14,73),(6225803,51589293,14,74),(6225803,51589296,14,75),(6225803,51589297,14,76),(6225803,51589299,14,77),(6225803,51589302,14,78),(6225803,51589304,14,79),(6225803,51589307,14,80),(6225803,51589310,14,81),(6225803,51589313,14,82),(6225803,51589315,14,83),(6225803,51589320,14,84),(6225803,51589325,14,85),(6225803,51589328,14,86),(6225803,51589334,14,87),(6225803,51589337,14,88),(6225803,51589338,14,89),(6225803,51589340,14,90),(6225803,51589342,14,91),(6225803,51589344,14,92),(6225803,51589348,14,93),(6225803,51589352,14,94),(6225803,51589354,14,95),(6225803,51589357,14,96),(6225803,51589360,14,97),(6225803,51589363,14,98),(6225803,51589366,14,99),(6225803,51589368,14,100),(6225803,51589370,14,101),(6225803,51590535,14,102),(6225803,51590538,14,103),(6225803,51590542,14,104),(6225803,51590544,14,105),(6225803,51590546,14,106),(6225803,51590549,14,107),(6225803,51590551,14,108),(6225803,51590553,14,109),(6225803,51590557,14,110),(6225803,51590560,14,111),(6225803,51590563,14,112),(6225803,51590564,14,113),(6225803,51590567,14,114),(6225803,51590572,14,115),(6225803,51590575,14,116),(6225803,51590578,14,117),(6225803,51590580,14,118),(6225803,51590582,14,119),(6225803,51590585,14,120),(6225803,51590588,14,121),(6225803,51590589,14,122),(6225803,51590592,14,123),(6225803,51590595,14,124),(6225803,51590598,14,125),(6225803,51590600,14,126),(6225803,51590603,14,127),(6225803,51590606,14,128),(6225803,51590608,14,129),(6225803,51590611,14,130),(6225803,51590613,14,131),(6225803,51590616,14,132),(6225803,51590619,14,133),(6225803,51590622,14,134),(6225803,51590623,14,135),(6225803,51590626,14,136),(6225803,51590630,14,137),(6225803,51590631,14,138),(6225803,51590633,14,139),(6225803,51590634,14,140),(6225803,51590635,14,141),(6225803,51590636,14,142),(6225803,51590637,14,143),(6225803,51590638,14,144),(6225803,51590643,14,145),(6225803,51590645,14,146),(6225803,51590646,14,147),(6225803,51590648,14,148),(6225803,264053269,14,149),(6225803,51590650,14,150),(6225803,51590653,14,151),(6225803,51590654,14,152),(6225803,51590657,14,153),(6225803,51590660,14,154),(6225803,51590663,14,155),(6225803,51590665,14,156),(6225803,51590668,14,157),(6225803,51590669,14,158),(6225803,51590671,14,159),(6225803,51590673,14,160),(6225803,51590676,14,161),(6225803,51590679,14,162),(6225803,51590680,14,163),(6225803,51590683,14,164),(6225803,51590686,14,165),(6225803,51590687,14,166),(6225803,51590690,14,167),(6225803,51590691,14,168),(6225803,51590693,14,169),(6225803,51590695,14,170),(6225803,51590699,14,171),(6225803,51590702,14,172),(6225803,51590705,14,173),(6225803,51590707,14,174),(6225803,51590708,14,175),(6225803,51590711,14,176),(6225803,51590714,14,177),(6225803,51590716,14,178),(6225803,51590719,14,179),(6225803,51590722,14,180),(6225803,51590725,14,181),(6225803,51590728,14,182),(6225803,51590730,14,183),(6225803,51929590,14,184),(6225803,51929593,14,185),(6225803,51929595,14,186),(6225803,51929598,14,187),(6225803,51929600,14,188),(6225803,51929603,14,189),(6225803,51929607,14,190),(6225803,51929610,14,191),(6225803,51929614,14,192),(6225803,51929617,14,193),(6225803,51929619,14,194),(6225803,51929620,14,195),(6225803,51929623,14,196),(6225803,51929625,14,197),(6225803,51929626,14,198),(6225803,51929628,14,199),(6225803,51929630,14,200),(6225803,51929632,14,201),(6225803,51929634,14,202),(6225803,51929636,14,203),(6225803,51929638,14,204),(6225803,51929640,14,205),(6225803,51929642,14,206),(6225803,51929644,14,207),(6225803,51929645,14,208),(6225803,51929647,14,209),(6225803,51929649,14,210),(6225803,51929650,14,211),(6225803,51929653,14,212),(6225803,51929656,14,213),(6225803,51929657,14,214),(6225803,51929660,14,215),(6225803,51929661,14,216),(6225803,51929663,14,217),(6225803,51929665,14,218),(6225803,51929667,14,219),(6225803,51929670,14,220),(6225803,51929671,14,221),(6225803,51929673,14,222),(6225803,51929675,14,223),(6225803,51929677,14,224),(6225803,51929678,14,225),(6225803,51929680,14,226),(6225803,51929682,14,227),(6225803,51929684,14,228),(6225803,51929687,14,229),(6225803,51929689,14,230),(6225803,51929690,14,231),(6225803,51929693,14,232),(6225803,51929696,14,233),(6225803,51929700,14,234),(6225803,51929702,14,235),(6225803,51929704,14,236),(6225803,51929707,14,237),(6225803,51929709,14,238),(6225803,51929711,14,239),(6225803,51929713,14,240),(6225803,51929715,14,241),(6225803,51929717,14,242),(6225803,51929720,14,243),(6225803,51929722,14,244),(6225803,51929725,14,245),(6225803,51929728,14,246),(6225812,51930334,2,1),(6225812,51930336,2,2),(6225812,51930338,2,3),(6225812,51930340,2,4),(6225812,51930343,2,5),(6225812,51930345,2,6),(6225812,51930348,2,7),(6225812,51930349,2,8),(6225812,51930352,2,9),(6225812,51930354,2,10),(6225812,51930357,2,11),(6225812,51930359,2,12),(6225812,51930360,2,13),(6225812,51930362,2,14),(6225812,51930364,2,15),(6225812,51930365,2,16),(6225812,51930368,2,17),(6225812,51930371,2,18),(6225812,51930373,2,19),(6225812,51930376,2,20),(6225812,51930378,2,21),(6225812,51930380,2,22),(6225812,51930382,2,23),(6225812,51930388,2,24),(6225812,51930396,2,25),(6225812,51930384,2,26),(6225812,51930390,2,27),(6225812,51930386,2,28),(6227096,51957174,6,1),(6227096,51957172,6,2),(6227096,51957170,6,3),(6227096,51957168,6,4),(6227096,51957166,6,5),(6227096,51957164,6,6),(6227096,51957162,6,7),(6227096,51957160,6,8),(6227096,51957157,6,9),(6227096,51957155,6,10),(6227096,51957153,6,11),(6227096,51957151,6,12),(6227096,51957147,6,13),(6227096,51957146,6,14),(6227096,51957144,6,15),(6227096,51957143,6,16),(6227096,51957141,6,17),(6227096,51957138,6,18),(6227096,51957135,6,19),(6227096,51957134,6,20),(6227096,51957131,6,21),(6227096,51957128,6,22),(6227096,51957125,6,23),(6227096,51957121,6,24),(6227096,51957119,6,25),(6227096,51957117,6,26),(6227096,51957115,6,27),(6227096,51957112,6,28),(6227096,51957110,6,29),(6227096,51957105,6,30),(6227096,51957103,6,31),(6227096,51957101,6,32),(6227096,51957098,6,33),(6227096,51957094,6,34),(6227096,51957092,6,35),(6227096,51957090,6,36),(6227096,51957087,6,37),(6227096,51957085,6,38),(6227096,51957082,6,39),(6227096,51957080,6,40),(6227096,51957077,6,41),(6227096,51957075,6,42),(6227096,51957072,6,43),(6227096,51957069,6,44),(6227096,51957066,6,45),(6227096,51957064,6,46),(6227096,51957063,6,47),(6227096,51957060,6,48),(6227096,51957057,6,49),(6227096,51957055,6,50),(6227096,51957052,6,51),(6227096,51957050,6,52),(6227096,51957048,6,53),(6227096,51957045,6,54),(6227096,51957042,6,55),(6227096,51957040,6,56),(6227096,51957037,6,57),(6227096,51957034,6,58),(6227096,51957031,6,59),(6227096,51957030,6,60),(6227096,51957027,6,61),(6227096,51957025,6,62),(6227096,51957024,6,63),(6227096,51957022,6,64),(6227096,51957020,6,65),(6227096,51957018,6,66),(6227096,51957016,6,67),(6227096,51957013,6,68),(6227096,51957009,6,69),(6227096,51957008,6,70),(6227096,51957005,6,71),(6227096,51957002,6,72),(6227096,51956999,6,73),(6227096,51956997,6,74),(6227096,51956993,6,75),(6227096,51951640,6,76),(6227096,51951645,6,77),(6227096,51951647,6,78),(6227096,51951648,6,79),(6227096,51951650,6,80),(6227096,51951652,6,81),(6227096,51951654,6,82),(6227096,51951657,6,83),(6227096,51951658,6,84),(6227096,51951661,6,85),(6227096,51951665,6,86),(6227096,51951667,6,87),(6227096,51951670,6,88),(6227096,51951673,6,89),(6227096,51951676,6,90),(6227096,51951678,6,91),(6227096,51951680,6,92),(6227096,51951682,6,93),(6227096,51951684,6,94),(6227096,51951686,6,95),(6227096,51951689,6,96),(6227096,51951690,6,97),(6227096,51951692,6,98),(6227096,51951694,6,99),(6227096,51951696,6,100),(6227096,51951700,6,101),(6227096,51951701,6,102),(6227096,51951703,6,103),(6227096,51951706,6,104),(6227096,51951709,6,105),(6227096,51951711,6,106),(6227096,51951713,6,107),(6227096,51951716,6,108),(6227096,51951719,6,109),(6227096,51951723,6,110),(6227096,51951726,6,111),(6227096,51951729,6,112),(6227096,51951731,6,113),(6227096,51951734,6,114),(6227096,51951736,6,115),(6227096,51951739,6,116),(6227096,51951741,6,117),(6227096,51951744,6,118),(6227096,51951747,6,119),(6227096,51951748,6,120),(6227096,51951751,6,121),(6227096,51951755,6,122),(6227096,51951758,6,123),(6227096,51951761,6,124),(6227096,51951763,6,125),(6227096,51951766,6,126),(6227096,51951769,6,127),(6227096,51951772,6,128),(6227096,51951775,6,129),(6227096,51951777,6,130),(6227096,51951780,6,131),(6227096,51951784,6,132),(6227096,51951785,6,133),(6227096,51951788,6,134),(6227096,51951790,6,135),(6227096,51951793,6,136),(6227096,51951796,6,137),(6227096,51951799,6,138),(6227096,51951801,6,139),(6227096,51951805,6,140),(6227096,51951808,6,141),(6227096,51951810,6,142),(6227096,51951813,6,143),(6227096,51951816,6,144),(6227096,51951817,6,145),(6227096,51951819,6,146),(6227096,51951821,6,147),(6227096,51951824,6,148),(6227096,51951827,6,149),(6227096,51951830,6,150),(6227096,51951833,6,151),(6227096,51951836,6,152),(6227096,51951838,6,153),(6227096,51951840,6,154),(6227096,51951843,6,155),(6227096,51951846,6,156),(6227096,51951848,6,157),(6227096,51951851,6,158),(6227096,51951854,6,159),(6227096,51951857,6,160),(6227096,51951858,6,161),(6227096,51951859,6,162),(6227096,51951861,6,163),(6227096,51951864,6,164),(6227096,51951865,6,165),(6227096,51951868,6,166),(6227096,51951872,6,167),(6227096,51951874,6,168),(6227096,51951876,6,169),(6227096,51951879,6,170),(6227096,51951882,6,171),(6227096,51951885,6,172),(6227096,51951886,6,173),(6227096,51951889,6,174),(6227096,51951892,6,175),(6227096,51951895,6,176),(6227096,51951898,6,177),(6227096,51951900,6,178),(6227096,51951903,6,179),(6227096,51951905,6,180),(6227096,51951908,6,181),(6227096,51951911,6,182),(6227096,51951914,6,183),(6227096,51951917,6,184),(6227096,51951920,6,185),(6227096,51951922,6,186),(6227096,51951924,6,187),(6227096,51951927,6,188),(6227096,51951930,6,189),(6227096,51951933,6,190),(6227096,51951935,6,191),(6227096,51951937,6,192),(6227096,51951938,6,193),(6227096,51951941,6,194),(6227096,51951944,6,195),(6227096,51951947,6,196),(6227096,51951950,6,197),(6227096,51951953,6,198),(6227096,51951956,6,199),(6227096,51951957,6,200),(6227096,51951960,6,201),(6227096,51951963,6,202),(6227096,51951965,6,203),(6227096,51951966,6,204),(6227096,51951969,6,205),(6227096,51951970,6,206),(6227096,51951973,6,207),(6227096,51951975,6,208),(6227096,51951978,6,209),(6227096,51951980,6,210),(6227096,51951983,6,211),(6227096,51951985,6,212),(6227096,51951988,6,213),(6227096,51951989,6,214),(6227096,51951992,6,215),(6227096,51951995,6,216),(6227096,51951999,6,217),(6227096,51952002,6,218),(6227096,51952005,6,219),(6227096,51952009,6,220),(6227096,51952013,6,221),(6227096,51952014,6,222),(6227096,51952017,6,223),(6227096,51952019,6,224),(6227096,51952022,6,225),(6227096,51952025,6,226),(6227096,51952028,6,227),(6227096,51952029,6,228),(6227096,51952031,6,229),(6227096,51952034,6,230),(6227096,51952037,6,231),(6227096,51952039,6,232),(6227096,51952042,6,233),(6227096,51952045,6,234),(6227096,51952046,6,235),(6227096,51952048,6,236),(6227096,51952050,6,237),(6227096,51952053,6,238),(6227096,51952055,6,239),(6227096,51952058,6,240),(6227096,51952060,6,241),(6227096,51952063,6,242),(6227096,51952065,6,243),(6227096,51952068,6,244),(6227096,51952069,6,245),(6227096,51952073,6,246),(6227096,51952075,6,247),(6227096,51952078,6,248),(6227096,51952080,6,249),(6227096,51952083,6,250),(6227096,51952084,6,251),(6227096,51952087,6,252),(6227096,51952090,6,253),(6227096,51952093,6,254),(6227096,51952096,6,255),(6227096,51952099,6,256),(6227096,51952101,6,257),(6227096,51952103,6,258),(6227096,51952105,6,259),(6227096,51952107,6,260),(6227097,51952107,6,1),(6227097,51952110,6,2),(6227097,51952111,6,3),(6227097,51952113,6,4),(6227097,51952115,6,5),(6227097,51952118,6,6),(6228283,51974478,2,1),(6228283,51974475,2,2),(6228283,51974472,2,3),(6228283,51974469,2,4),(6228283,51974466,2,5),(6228283,51974462,2,6),(6228283,51974458,2,7),(6228283,51974456,2,8),(6228283,51974455,2,9),(6228283,51974484,2,10),(6228283,51974454,2,11),(6228283,51974481,2,12),(6228283,51974452,2,13),(6228283,51974451,2,14),(6228283,51974446,2,15),(6228283,51974445,2,16),(6228283,51974442,2,17),(6228283,51974439,2,18),(6228283,51974436,2,19),(6228283,51974432,2,20),(6228283,51974430,2,21),(6228283,51974428,2,22),(6228283,51974424,2,23),(6228283,51974422,2,24),(6228283,51974419,2,25),(6228283,51974416,2,26),(6228283,51974414,2,27),(6228283,51974411,2,28),(6228283,51974408,2,29),(6228283,51974405,2,30),(6228283,51974404,2,31),(6228283,51974402,2,32),(6228283,51974400,2,33),(6228283,51974397,2,34),(6228283,51974395,2,35),(6228283,51974394,2,36),(6228283,51974391,2,37),(6228283,51974388,2,38),(6228283,51974385,2,39),(6228283,51974383,2,40),(6228283,51974378,2,41),(6228283,51974376,2,42),(6228283,51974374,2,43),(6228283,51974373,2,44),(6228283,51974371,2,45),(6228283,51974368,2,46),(6228283,51974365,2,47),(6228283,51974363,2,48),(6228283,51974360,2,49),(6228283,51974357,2,50),(6228283,51974353,2,51),(6228283,51974349,2,52),(6228283,51974345,2,53),(6228283,51974341,2,54),(6228283,51974339,2,55),(6228283,51974337,2,56),(6228283,51974334,2,57),(6228283,51974331,2,58),(6228283,51974328,2,59),(6228283,51974326,2,60),(6228283,51974323,2,61),(6228283,51974321,2,62),(6228283,51974319,2,63),(6228283,51974316,2,64),(6228283,51974313,2,65),(6228283,51974309,2,66),(6228283,51974308,2,67),(6228283,51974305,2,68),(6228283,51974301,2,69),(6228283,51974300,2,70),(6228283,51974298,2,71),(6228283,51974296,2,72),(6228283,51974293,2,73),(6228283,51974292,2,74),(6228283,51974291,2,75),(6228283,51974289,2,76),(6228283,51974286,2,77),(6228283,51974284,2,78),(6228283,51974281,2,79),(6228283,51974279,2,80),(6228283,51974278,2,81),(6228283,51974275,2,82),(6228283,51974266,2,83),(6228283,51974264,2,84),(6228283,51974261,2,85),(6228283,51974258,2,86),(6228283,51974256,2,87),(6228283,51974253,2,88),(6228283,51974251,2,89),(6228283,51974249,2,90),(6228283,51974247,2,91),(6228283,51974244,2,92),(6228283,51974242,2,93),(6228283,51974239,2,94),(6228283,51974236,2,95),(6228283,51974233,2,96),(6228283,51974231,2,97),(6228283,51974229,2,98),(6228283,51974226,2,99),(6228283,51974223,2,100),(6228283,51974220,2,101),(6228283,51974217,2,102),(6228283,51974215,2,103),(6228283,51974213,2,104),(6228283,51974211,2,105),(6228283,51974208,2,106),(6228283,51974206,2,107),(6228283,51974204,2,108),(6228283,51974202,2,109),(6228283,51974199,2,110),(6228283,51974197,2,111),(6228283,51974195,2,112),(6228283,51974193,2,113),(6228283,51974191,2,114),(6228283,51974190,2,115),(6228283,51974187,2,116),(6228283,51974185,2,117),(6228283,51974183,2,118),(6228283,51974181,2,119),(6228283,51974176,2,120),(6228283,51974174,2,121),(6228283,51974172,2,122),(6228283,51974169,2,123),(6228283,51974167,2,124),(6228283,51974165,2,125),(6228283,51974164,2,126),(6228283,51974161,2,127),(6228283,51974158,2,128),(6228283,51974155,2,129),(6228283,51974153,2,130),(6228283,51974152,2,131),(6228283,51974149,2,132),(6228283,51974147,2,133),(6228283,51974143,2,134),(6228283,51974140,2,135),(6228283,51974137,2,136),(6228283,51974134,2,137),(6228283,51974133,2,138),(6228283,51974131,2,139),(6228283,51974129,2,140),(6228283,51974126,2,141),(6228283,51974122,2,142),(6228283,51974119,2,143),(6228283,51974115,2,144),(6228283,51974112,2,145),(6228283,51974108,2,146),(6228283,51974107,2,147),(6228283,51974103,2,148),(6228283,51974100,2,149),(6228283,51974097,2,150),(6228283,51974095,2,151),(6228283,51974090,2,152),(6228283,51974089,2,153),(6228283,51974088,2,154),(6228283,51974086,2,155),(6228283,51974085,2,156),(6228283,51974083,2,157),(6228283,51974078,2,158),(6228283,51974074,2,159),(6228283,51974072,2,160),(6228283,51974068,2,161),(6228283,51974065,2,162),(6228283,51974060,2,163),(6228283,51974059,2,164),(6228283,51974057,2,165),(6228283,51974055,2,166),(6228283,51974053,2,167),(6228283,51974050,2,168),(6228283,51974049,2,169),(6228283,51974046,2,170),(6228283,51974044,2,171),(6228283,51974042,2,172),(6228283,51974040,2,173),(6228283,51974039,2,174),(6228283,51974035,2,175),(6228283,51974031,2,176),(6228283,51974028,2,177),(6228283,51974024,2,178),(6228283,51974023,2,179),(6228283,51974019,2,180),(6228283,51974015,2,181),(6228283,51974013,2,182),(6228283,51974011,2,183),(6228283,51974008,2,184),(6228283,51974005,2,185),(6228283,51974002,2,186),(6228283,51973998,2,187),(6228283,51973995,2,188),(6228283,51973992,2,189),(6228283,51973989,2,190),(6228283,51973986,2,191),(6228283,51973983,2,192),(6228283,51973981,2,193),(6228283,51973977,2,194),(6228283,51973975,2,195),(6228283,51973972,2,196),(6228283,51973968,2,197),(6228283,51973967,2,198),(6228283,51973963,2,199),(6228283,51973962,2,200),(6228283,51973958,2,201),(6228283,51973955,2,202),(6228283,51973953,2,203),(6228283,51973952,2,204),(6228283,51973950,2,205),(6228283,51973947,2,206),(6228283,51973942,2,207),(6228283,51973941,2,208),(6228283,51973939,2,209),(6228283,51973937,2,210),(6228283,51973934,2,211),(6228283,51973931,2,212),(6228283,51973929,2,213),(6228283,51973927,2,214),(6228283,51973924,2,215),(6228283,51973922,2,216),(6228283,51973920,2,217),(6228283,51973917,2,218),(6228283,51973915,2,219),(6228283,51973913,2,220),(6228283,51973910,2,221),(6228283,51973907,2,222),(6228283,51973905,2,223),(6228283,51973903,2,224),(6228283,51973898,2,225),(6228283,51973897,2,226),(6228283,51973894,2,227),(6228283,51973891,2,228),(6228283,51973890,2,229),(6228283,51973887,2,230),(6228283,51973884,2,231),(6228283,51973883,2,232),(6228283,51973881,2,233),(6228283,51973878,2,234),(6228283,51973877,2,235),(6228283,51973874,2,236),(6228283,51973871,2,237),(6228283,51973868,2,238),(6228283,51973865,2,239),(6228283,51973862,2,240),(6228283,51973860,2,241),(6228283,51973858,2,242),(6228283,51973855,2,243),(6228283,51973852,2,244),(6228283,51973851,2,245),(6228283,51973849,2,246),(6228283,51973848,2,247),(6228283,51973846,2,248),(6228283,51973844,2,249),(6228283,51973842,2,250),(6228283,51973839,2,251),(6228283,51973836,2,252),(6228283,51973834,2,253),(6228283,51973831,2,254),(6228283,51973820,2,255),(6228283,51973818,2,256),(6228283,51973817,2,257),(6228283,51973815,2,258),(6228283,51973812,2,259),(6228283,51973809,2,260),(6228283,51973807,2,261),(6228283,51973803,2,262),(6228283,51973802,2,263),(6228283,51973799,2,264),(6228283,51973796,2,265),(6228283,51973792,2,266),(6228283,51973790,2,267),(6228283,51973786,2,268),(6228283,51973784,2,269),(6228283,51973782,2,270),(6228283,51973777,2,271),(6228283,51973771,2,272),(6228283,51973770,2,273),(6228283,51973769,2,274),(6228283,51973766,2,275),(6228283,51973764,2,276),(6228283,51973759,2,277),(6228283,51973757,2,278),(6228283,51973755,2,279),(6228283,51973753,2,280),(6228283,51973751,2,281),(6228283,51973749,2,282),(6228283,51973747,2,283),(6228283,51973744,2,284),(6228283,51973741,2,285),(6228283,51973739,2,286),(6228283,51973736,2,287),(6228283,51973733,2,288),(6228283,51973731,2,289),(6228283,51973730,2,290),(6228283,51973728,2,291),(6228283,51973725,2,292),(6228283,51973722,2,293),(6228283,51973720,2,294),(6228283,51973717,2,295),(6228283,51973714,2,296),(6228283,51973711,2,297),(6228283,51973708,2,298),(6228283,51973705,2,299),(6228283,51973703,2,300),(6228283,51973699,2,301),(6228283,51973696,2,302),(6228283,51973694,2,303),(6228283,51973691,2,304),(6228283,51973688,2,305),(6228283,51973686,2,306),(6228283,51973683,2,307),(6228283,51973681,2,308),(6228283,51973679,2,309),(6228283,51973676,2,310),(6228283,51973673,2,311),(6228283,51973669,2,312),(6228283,51973667,2,313),(6228283,51973663,2,314),(6228283,51973660,2,315),(6228283,51973657,2,316),(6228283,51973653,2,317),(6228283,51973651,2,318),(6228283,51973648,2,319),(6228283,51973646,2,320),(6228283,51973643,2,321),(6228283,51973639,2,322),(6228283,51973636,2,323),(6228283,51973633,2,324),(6228283,51973631,2,325),(6228283,51973627,2,326),(6228283,51973624,2,327),(6228283,51973622,2,328),(6228283,51973621,2,329),(6228283,51973619,2,330),(6228283,51973617,2,331),(6228283,51973614,2,332),(6228283,51973611,2,333),(6228283,51973608,2,334),(6228283,51973606,2,335),(6228283,51973604,2,336),(6228283,51973602,2,337),(6228283,51973599,2,338),(6228283,51973598,2,339),(6228283,51973596,2,340),(6228283,51973594,2,341),(6228283,51973591,2,342),(6228283,51973590,2,343),(6228283,51973587,2,344),(6228283,51973582,2,345),(6228283,51973579,2,346),(6228283,51973577,2,347),(6228283,51973575,2,348),(6228283,51973571,2,349),(6228283,51973570,2,350),(6228283,51973567,2,351),(6228283,51973564,2,352),(6228283,51973562,2,353),(6228283,51973561,2,354),(6228283,51973559,2,355),(6228283,51973557,2,356),(6228283,51973554,2,357),(6228283,51973550,2,358),(6228283,51973548,2,359),(6228283,51973546,2,360),(6228283,51973544,2,361),(6228283,51973541,2,362),(6228283,51973514,2,363),(6228283,51973516,2,364),(6228283,51973519,2,365),(6228283,51973521,2,366),(6228283,51973523,2,367),(6228283,51973526,2,368),(6228283,51973528,2,369),(6228283,51973529,2,370),(6228283,51973532,2,371),(6228283,51973534,2,372),(6228283,51973538,2,373),(6230227,52009108,2,1),(6230227,52009109,2,2),(6230227,52009111,2,3),(6230227,52009114,2,4),(6230227,52009117,2,5),(6230227,52009118,2,6),(6230227,52009120,2,7),(6230227,52009122,2,8),(6230227,52009124,2,9),(6230227,52009126,2,10),(6230228,52009126,3,1),(6230228,52009127,3,2),(6230229,52009127,2,1),(6230229,52009129,2,2),(6230231,52009151,4,1),(6230231,52009150,4,2),(6230231,52009147,4,3),(6230231,52009144,4,4),(6230231,52009143,4,5),(6230231,52009197,4,6),(6230231,52009140,4,7),(6230231,52009137,4,8),(6230231,52009134,4,9),(6230231,52009130,4,10),(6230231,52603531,4,11),(6230231,52603533,4,12),(6230231,52603536,4,13),(6230231,52603537,4,14),(6230231,52603540,4,15),(6230231,52603542,4,16),(6230231,52612605,4,17),(6230231,52612609,4,18),(6230231,52612612,4,19),(6230231,52612615,4,20),(6230231,52612616,4,21),(6230231,52612619,4,22),(6230231,52612622,4,23),(6230231,52612624,4,24),(6230231,52612626,4,25),(6230231,52612629,4,26),(6230231,52612634,4,27),(6230231,52612635,4,28),(6230231,52612638,4,29),(6230231,52612640,4,30),(6230231,52612642,4,31),(6230231,52612645,4,32),(6230231,52612646,4,33),(6230231,52612649,4,34),(6230231,52612651,4,35),(6230231,52612653,4,36),(6230231,52612656,4,37),(6230231,52612658,4,38),(6230231,52612660,4,39),(6230231,52612661,4,40),(6230231,52612664,4,41),(6230231,52612665,4,42),(6230231,52612667,4,43),(6230231,52612670,4,44),(6230231,52612672,4,45),(6230231,52612675,4,46),(6230231,52612677,4,47),(6230231,52612678,4,48),(6230231,52612681,4,49),(6230231,52612684,4,50),(6230231,52612686,4,51),(6230231,52612688,4,52),(6230231,52612691,4,53),(6230231,52612692,4,54),(6230231,52612694,4,55),(6230231,52612696,4,56),(6230231,52612699,4,57),(6230231,52612701,4,58),(6230231,52612704,4,59),(6230231,52612708,4,60),(6230231,52612710,4,61),(6230231,52612712,4,62),(6230231,52612716,4,63),(6230231,52612717,4,64),(6230231,52612719,4,65),(6230231,52612720,4,66),(6230231,52612722,4,67),(6230231,52612725,4,68),(6230231,52612728,4,69),(6230231,52612732,4,70),(6230231,52612735,4,71),(6230231,52612738,4,72),(6230231,52612740,4,73),(6230231,52612742,4,74),(6230231,52612744,4,75),(6230231,52612746,4,76),(6230231,52612748,4,77),(6230231,52612750,4,78),(6230231,52612752,4,79),(6230231,52612754,4,80),(6230231,52612756,4,81),(6230231,52612758,4,82),(6230231,52612760,4,83),(6230231,52612761,4,84),(6230231,52612763,4,85),(6230231,52612765,4,86),(6230231,52612768,4,87),(6230231,52612770,4,88),(6230231,52612773,4,89),(6230231,52612776,4,90),(6230231,52612779,4,91),(6230231,52612782,4,92),(6230231,52612786,4,93),(6230231,52612789,4,94),(6230231,52612791,4,95),(6230231,52612794,4,96),(6230231,52612796,4,97),(6230231,52612800,4,98),(6230231,52612803,4,99),(6230231,52612804,4,100),(6230231,52612807,4,101),(6230231,52612810,4,102),(6230231,52612813,4,103),(6230231,52612815,4,104),(6230231,52612817,4,105),(6230231,52612820,4,106),(6230231,52612824,4,107),(6230231,52612827,4,108),(6230231,52612831,4,109),(6230231,52612835,4,110),(6230231,52612840,4,111),(6230231,52612843,4,112),(6230231,52612845,4,113),(6230231,52612849,4,114),(6230231,52612853,4,115),(6230231,52612855,4,116),(6230231,52612859,4,117),(6230231,52612862,4,118),(6230231,52612864,4,119),(6230231,52612867,4,120),(6230231,52612870,4,121),(6230231,52612873,4,122),(6230231,52612877,4,123),(6230231,52612882,4,124),(6230231,52612885,4,125),(6230231,52612888,4,126),(6230231,52612892,4,127),(6230231,52612893,4,128),(6230231,52612895,4,129),(6230231,52612897,4,130),(6230231,52612899,4,131),(6230231,52612900,4,132),(6230231,52612902,4,133),(6230231,52612907,4,134),(6230231,52612909,4,135),(6230231,52612911,4,136),(6230231,52612913,4,137),(6230231,52612916,4,138),(6230231,52612918,4,139),(6230231,52612920,4,140),(6230231,52612923,4,141),(6230231,52612927,4,142),(6230231,52612929,4,143),(6230231,52612932,4,144),(6230231,52612935,4,145),(6230231,52612936,4,146),(6230231,52612939,4,147),(6230231,52612941,4,148),(6230231,52612943,4,149),(6230231,52612946,4,150),(6230231,52612948,4,151),(6230231,52612951,4,152),(6230231,52612954,4,153),(6230231,52612957,4,154),(6230231,52612958,4,155),(6230231,52612962,4,156),(6230231,52612967,4,157),(6230231,52612973,4,158),(6230231,52652273,4,159),(6230231,52612976,4,160),(6230231,52612978,4,161),(6230231,52685723,4,162),(6230231,52612981,4,163),(6230231,52612983,4,164),(6230231,52612986,4,165),(6230231,52612989,4,166),(6230231,52612992,4,167),(6230231,52612994,4,168),(6230231,52612996,4,169),(6230231,52612998,4,170),(6230231,52613000,4,171),(6230231,52613003,4,172),(6230231,52613006,4,173),(6230231,52613008,4,174),(6230231,52613010,4,175),(6230231,52613013,4,176),(6230231,52613016,4,177),(6230231,52613017,4,178),(6230231,52613020,4,179),(6230231,52613021,4,180),(6230231,52613024,4,181),(6230231,52613027,4,182),(6230231,52613030,4,183),(6230231,52613032,4,184),(6230231,52613034,4,185),(6230231,52613037,4,186),(6230231,52613039,4,187),(6230231,52613041,4,188),(6230231,52613044,4,189),(6230231,52613047,4,190),(6230231,52613049,4,191),(6230231,52613052,4,192),(6230231,52613054,4,193),(6230231,52613056,4,194),(6230231,52613058,4,195),(6230231,52613080,4,196),(6230231,52613061,4,197),(6230231,52613062,4,198),(6230231,52613065,4,199),(6230231,52613067,4,200),(6230231,52613070,4,201),(6230231,52613072,4,202),(6230231,52613074,4,203),(6230231,52613076,4,204),(6230231,52613083,4,205),(6230231,52613086,4,206),(6230231,52613088,4,207),(6230231,52613091,4,208),(6230231,52613092,4,209),(6230231,52613094,4,210),(6230231,52613097,4,211),(6230231,52613099,4,212),(6230231,52613101,4,213),(6230231,52613104,4,214),(6230231,52613107,4,215),(6230231,52613110,4,216),(6230231,52613113,4,217),(6230231,52613115,4,218),(6230231,52613117,4,219),(6230231,52613119,4,220),(6230231,52613121,4,221),(6230231,52613124,4,222),(6230231,52613126,4,223),(6230231,52613129,4,224),(6230231,52613132,4,225),(6230231,52613135,4,226),(6230231,52613139,4,227),(6230231,52613142,4,228),(6230231,52613145,4,229),(6230231,52613148,4,230),(6230231,52613149,4,231),(6230231,52613151,4,232),(6230231,264465128,4,233),(6230232,52009154,3,1),(6230232,52009156,3,2),(6230233,52009157,2,1),(6230233,52009159,2,2),(6230233,52009161,2,3),(6230233,52009164,2,4),(6230233,52009157,2,5),(6230234,52009197,3,1),(6230234,52009168,3,2),(6242742,52166959,2,1),(6242742,52166976,2,2),(6242742,52166980,2,3),(6242742,52167010,2,4),(6242742,52167017,2,5),(6242742,52167025,2,6),(6242742,52167030,2,7),(6242742,52167039,2,8),(6242742,52167045,2,9),(6242742,52167049,2,10),(6242742,52167052,2,11),(6242742,52167062,2,12),(6242742,52167066,2,13),(6242742,52167070,2,14),(6242742,52167076,2,15),(6242742,52167082,2,16),(6242742,52167086,2,17),(6242742,52167105,2,18),(6242742,52167111,2,19),(6242742,52167122,2,20),(6242742,52167165,2,21),(6242747,52167128,12,1),(6242747,52167136,12,2),(6242747,52167142,12,3),(6242747,52167150,12,4),(6242747,52167155,12,5),(6242747,52167165,12,6),(6242747,52167175,12,7),(6242747,52167179,12,8),(6242747,52167183,12,9),(6242747,52167190,12,10),(6242747,52167198,12,11),(6242747,52167208,12,12),(6242747,52167211,12,13),(6242747,52167218,12,14),(6242747,52167223,12,15),(6242747,52167232,12,16),(6242747,52167248,12,17),(6242747,52167254,12,18),(6242747,52167257,12,19),(6242747,52167262,12,20),(6242747,52167277,12,21),(6242747,52167279,12,22),(6242747,52167284,12,23),(6242747,52167289,12,24),(6242747,52167293,12,25),(6242747,52167300,12,26),(6242747,52167307,12,27),(6242747,52167309,12,28),(6242747,52167315,12,29),(6242747,52167320,12,30),(6242747,52167323,12,31),(6242747,52167329,12,32),(6242747,52167336,12,33),(6242747,52167345,12,34),(6242747,52167349,12,35),(6242747,52167353,12,36),(6242747,52167358,12,37),(6242747,52167363,12,38),(6242747,52167368,12,39),(6242747,52167372,12,40),(6242747,52167380,12,41),(6242747,52167387,12,42),(6242747,52167389,12,43),(6242747,52167390,12,44),(6242747,52167393,12,45),(6242747,52167396,12,46),(6242747,52167398,12,47),(6242747,52167402,12,48),(6242747,52167406,12,49),(6242747,52167421,12,50),(6242747,52167425,12,51),(6242747,52167428,12,52),(6242747,52167430,12,53),(6242747,52167433,12,54),(6242747,52167436,12,55),(6242747,52167438,12,56),(6242747,52167439,12,57),(6242747,52167444,12,58),(6242747,52167446,12,59),(6242747,52167453,12,60),(6242747,52167457,12,61),(6242747,52167470,12,62),(6242747,52167473,12,63),(6242747,52167477,12,64),(6242747,52167484,12,65),(6242747,52167487,12,66),(6242747,52167490,12,67),(6242747,52167496,12,68),(6242747,52167500,12,69),(6242747,52167503,12,70),(6242747,52167507,12,71),(6242747,52167511,12,72),(6242747,52167513,12,73),(6242747,52167517,12,74),(6242747,52167521,12,75),(6242747,52167525,12,76),(6242747,52167528,12,77),(6242747,52167530,12,78),(6242747,52167534,12,79),(6242747,52167535,12,80),(6242747,52167538,12,81),(6242747,52167540,12,82),(6242747,52167544,12,83),(6242747,52167547,12,84),(6242747,52167551,12,85),(6242747,52167557,12,86),(6242747,52167562,12,87),(6242747,52167568,12,88),(6242747,52167574,12,89),(6242747,52167579,12,90),(6242747,52167581,12,91),(6242747,52167585,12,92),(6242747,52167590,12,93),(6242747,52167593,12,94),(6242747,52167599,12,95),(6242747,52167604,12,96),(6242747,52167607,12,97),(6242747,52167614,12,98),(6242747,52167615,12,99),(6242747,52167619,12,100),(6242747,52167622,12,101),(6242747,52167627,12,102),(6242747,52167632,12,103),(6242747,52167636,12,104),(6242747,52167641,12,105),(6242747,52167645,12,106),(6242747,52167650,12,107),(6242747,52167655,12,108),(6242747,52167660,12,109),(6242747,52167664,12,110),(6242747,52167666,12,111),(6242747,52167669,12,112),(6242747,52167673,12,113),(6242747,52167677,12,114),(6242747,52167683,12,115),(6242747,52167687,12,116),(6242747,52167691,12,117),(6242747,52167695,12,118),(6242747,52167700,12,119),(6242747,52167702,12,120),(6242747,52167707,12,121),(6242747,52167710,12,122),(6242747,52167713,12,123),(6242747,52167714,12,124),(6242747,52167718,12,125),(6242747,52167721,12,126),(6242747,52167725,12,127),(6242747,52167727,12,128),(6242747,52167732,12,129),(6242747,52167736,12,130),(6242747,52167740,12,131),(6242747,52167744,12,132),(6242747,52167747,12,133),(6242747,52167752,12,134),(6242747,52167756,12,135),(6242747,52167758,12,136),(6242747,52167761,12,137),(6242747,52167765,12,138),(6242747,52167769,12,139),(6242747,52167773,12,140),(6242747,52167777,12,141),(6242747,52167781,12,142),(6242747,52167784,12,143),(6242747,52167787,12,144),(6242747,52167790,12,145),(6242747,52167795,12,146),(6242747,52167796,12,147),(6242747,52167799,12,148),(6242747,52167802,12,149),(6242747,52167805,12,150),(6242747,52167807,12,151),(6242747,52167811,12,152),(6242747,52167812,12,153),(6242747,52167815,12,154),(6242747,52167820,12,155),(6242747,52167825,12,156),(6242747,52167828,12,157),(6242747,52167834,12,158),(6242747,52167836,12,159),(6242747,52167839,12,160),(6242747,52167843,12,161),(6242747,52167847,12,162),(6242747,52167849,12,163),(6242747,52167853,12,164),(6242747,52167859,12,165),(6242747,52167860,12,166),(6242747,52167867,12,167),(6242747,52167872,12,168),(6242747,52167883,12,169),(6242747,52167887,12,170),(6242747,52167891,12,171),(6242747,52167896,12,172),(6242747,52167900,12,173),(6242747,52167906,12,174),(6242747,52167911,12,175),(6242747,52167916,12,176),(6242747,52167922,12,177),(6242747,52167924,12,178),(6242747,52167927,12,179),(6242747,52167930,12,180),(6242747,52167932,12,181),(6242747,52167937,12,182),(6242747,52167944,12,183),(6242747,52167948,12,184),(6242747,52167953,12,185),(6242747,52167958,12,186),(6242747,52167963,12,187),(6242747,52167967,12,188),(6242747,52167969,12,189),(6242747,52167970,12,190),(6242747,52167973,12,191),(6242747,52167977,12,192),(6242747,52167981,12,193),(6242747,52167986,12,194),(6242747,52167991,12,195),(6242747,52167995,12,196),(6242747,52168000,12,197),(6242747,52168004,12,198),(6242747,52168009,12,199),(6242747,52168013,12,200),(6242747,52168015,12,201),(6242747,52168018,12,202),(6242747,52168021,12,203),(6242747,52168025,12,204),(6242747,52168028,12,205),(6242747,52168033,12,206),(6242747,52168034,12,207),(6242747,52168038,12,208),(6242747,52168039,12,209),(6242747,52168043,12,210),(6242747,52168046,12,211),(6242747,52168049,12,212),(6242747,52168053,12,213),(6242747,52168055,12,214),(6242747,52168056,12,215),(6242747,52168060,12,216),(6242747,52168063,12,217),(6242747,52168065,12,218),(6242747,52168070,12,219),(6242747,52168071,12,220),(6242747,52168073,12,221),(6242747,52168077,12,222),(6242747,52168080,12,223),(6242747,52168084,12,224),(6242747,52168086,12,225),(6242747,52168090,12,226),(6242747,52168094,12,227),(6242747,52168096,12,228),(6242747,52168100,12,229),(6242747,52168101,12,230),(6242747,52168104,12,231),(6242747,52168108,12,232),(6242747,52168111,12,233),(6242747,52168115,12,234),(6242747,52168118,12,235),(6242747,52168121,12,236),(6242747,52168124,12,237),(6242747,52168127,12,238),(6242747,52168130,12,239),(6242747,52168135,12,240),(6242747,52168138,12,241),(6242747,52168143,12,242),(6242747,52168146,12,243),(6242747,52168149,12,244),(6242747,52168152,12,245),(6242747,52168156,12,246),(6242747,52168160,12,247),(6242747,52168163,12,248),(6242747,52168167,12,249),(6242747,52168171,12,250),(6242747,52168175,12,251),(6242747,52168178,12,252),(6242747,52168181,12,253),(6242747,52168186,12,254),(6242747,52168188,12,255),(6242747,52168191,12,256),(6242747,52168195,12,257),(6242747,52168198,12,258),(6242747,52168203,12,259),(6242747,52168207,12,260),(6242747,52168214,12,261),(6242747,52168217,12,262),(6242747,52168220,12,263),(6242747,52168225,12,264),(6242747,52168231,12,265),(6242747,52168235,12,266),(6242747,52168237,12,267),(6242747,52168240,12,268),(6242747,52168243,12,269),(6242747,52168247,12,270),(6242747,52168248,12,271),(6242747,52168249,12,272),(6242747,52168251,12,273),(6242747,52168254,12,274),(6242747,52168256,12,275),(6242747,52168258,12,276),(6242747,52168261,12,277),(6242747,52168265,12,278),(6242747,52168270,12,279),(6242747,52168274,12,280),(6242747,52168278,12,281),(6242747,52168283,12,282),(6242747,52168286,12,283),(6242747,52168287,12,284),(6242747,52168291,12,285),(6242747,52168296,12,286),(6242747,52168298,12,287),(6242747,52168302,12,288),(6242747,52168305,12,289),(6242747,52168308,12,290),(6242747,52168309,12,291),(6242747,52168314,12,292),(6242747,52168316,12,293),(6242747,52168318,12,294),(6242747,52168321,12,295),(6242747,52168325,12,296),(6242747,52168326,12,297),(6242747,52168329,12,298),(6242747,52168333,12,299),(6242747,52168336,12,300),(6242747,52168338,12,301),(6242747,52168342,12,302),(6242747,52168346,12,303),(6242747,52168347,12,304),(6242747,52168348,12,305),(6242747,52168350,12,306),(6242747,52168356,12,307),(6242747,52168360,12,308),(6242747,52168362,12,309),(6242747,52168414,12,310),(6242747,52168416,12,311),(6242747,52168419,12,312),(6242747,52168423,12,313),(6242747,52168427,12,314),(6242747,52168429,12,315),(6242747,52168432,12,316),(6242747,52168436,12,317),(6242747,52168440,12,318),(6242747,52168442,12,319),(6242747,52168445,12,320),(6242747,52168447,12,321),(6242747,52168452,12,322),(6242747,52168455,12,323),(6242747,52168459,12,324),(6242747,52168461,12,325),(6242747,52168464,12,326),(6242747,52168468,12,327),(6242747,52168470,12,328),(6242747,52168474,12,329),(6242747,52168476,12,330),(6242747,52168479,12,331),(6242747,52168481,12,332),(6242747,52168484,12,333),(6242747,52168486,12,334),(6242747,52168489,12,335),(6242747,52168492,12,336),(6242747,52168495,12,337),(6242747,52168497,12,338),(6242747,52168502,12,339),(6242747,52168506,12,340),(6242747,52168509,12,341),(6242747,52168512,12,342),(6242747,52168516,12,343),(6242747,52168519,12,344),(6242747,52168521,12,345),(6242747,52168523,12,346),(6242747,52168529,12,347),(6242747,52168531,12,348),(6242747,52168534,12,349),(6242747,52168537,12,350),(6242747,52168541,12,351),(6242747,52168543,12,352),(6242747,52168547,12,353),(6242747,52168549,12,354),(6242747,52168553,12,355),(6242747,52168555,12,356),(6242747,52168558,12,357),(6242747,52168561,12,358),(6242747,52168565,12,359),(6242747,52168568,12,360),(6242747,52168569,12,361),(6242747,52168572,12,362),(6242747,52168576,12,363),(6242747,52168579,12,364),(6242747,52168582,12,365),(6242747,52168586,12,366),(6242747,52168589,12,367),(6242747,52168592,12,368),(6242747,52168595,12,369),(6242747,52168596,12,370),(6242747,52168600,12,371),(6242747,52168604,12,372),(6242747,52168607,12,373),(6242747,52168612,12,374),(6242747,52168613,12,375),(6242747,52168616,12,376),(6242747,52168622,12,377),(6242747,52168626,12,378),(6242747,52168631,12,379),(6242747,52168635,12,380),(6242747,52168638,12,381),(6242747,52168640,12,382),(6242747,52168644,12,383),(6242747,52168648,12,384),(6242747,52168654,12,385),(6242747,52168657,12,386),(6242747,52168660,12,387),(6242747,52168663,12,388),(6242747,52168665,12,389),(6242747,52168668,12,390),(6242747,52168671,12,391),(6242747,52168674,12,392),(6242747,52168676,12,393),(6242747,52168679,12,394),(6242747,52168682,12,395),(6242747,52168686,12,396),(6242747,52168687,12,397),(6242747,52168690,12,398),(6242747,52168693,12,399),(6242747,52168695,12,400),(6242747,52168698,12,401),(6242747,52168700,12,402),(6242747,52168702,12,403),(6242747,52168703,12,404),(6242747,52168705,12,405),(6242747,52168708,12,406),(6242747,52168710,12,407),(6242747,52168712,12,408),(6242747,52168714,12,409),(6242747,52168717,12,410),(6242747,52168720,12,411),(6242747,52168722,12,412),(6242747,52168725,12,413),(6242747,52168727,12,414),(6242747,52168729,12,415),(6242747,52168732,12,416),(6242747,52168734,12,417),(6242747,52168736,12,418),(6242747,52168739,12,419),(6242747,52168741,12,420),(6242747,52168744,12,421),(6242747,52168745,12,422),(6242747,52168747,12,423),(6242747,52168750,12,424),(6242747,52168770,12,425),(6242747,52168772,12,426),(6242747,52168773,12,427),(6242747,52168774,12,428),(6242747,52168777,12,429),(6242747,52168779,12,430),(6242747,52168782,12,431),(6242747,52168786,12,432),(6242747,52168788,12,433),(6242747,52168789,12,434),(6242747,52168790,12,435),(6242747,52168794,12,436),(6242747,52168796,12,437),(6242747,52168799,12,438),(6242747,52168802,12,439),(6242747,52168805,12,440),(6242747,52168808,12,441),(6242747,52168810,12,442),(6242747,52168813,12,443),(6242747,52168816,12,444),(6242747,52168819,12,445),(6242747,52168821,12,446),(6242747,52168824,12,447),(6242747,52168828,12,448),(6242747,52168829,12,449),(6242747,52168830,12,450),(6242747,52168834,12,451),(6242747,52168836,12,452),(6242747,52168838,12,453),(6242747,52168842,12,454),(6242747,52168845,12,455),(6242747,52168846,12,456),(6242747,52168849,12,457),(6242747,52168851,12,458),(6242747,52168854,12,459),(6242747,52168856,12,460),(6242747,52168858,12,461),(6242747,52168859,12,462),(6242747,52168862,12,463),(6242747,52168865,12,464),(6242747,52168866,12,465),(6242747,52168867,12,466),(6242747,52168870,12,467),(6242747,52168873,12,468),(6242747,52168875,12,469),(6242747,52168878,12,470),(6242747,52168881,12,471),(6242747,52168883,12,472),(6242747,52168886,12,473),(6242747,52168889,12,474),(6242747,52168892,12,475),(6242747,52168895,12,476),(6242747,52168899,12,477),(6242747,52168901,12,478),(6242747,52168904,12,479),(6242747,52168905,12,480),(6242747,52168909,12,481),(6242747,52168912,12,482),(6242747,52168914,12,483),(6242747,52168917,12,484),(6242747,52168919,12,485),(6242747,52168920,12,486),(6242747,52168921,12,487),(6242747,52168924,12,488),(6242747,52168926,12,489),(6242747,52168929,12,490),(6242747,52168931,12,491),(6242747,52168933,12,492),(6242747,52168936,12,493),(6242747,52168939,12,494),(6242747,52168943,12,495),(6242747,52168945,12,496),(6242747,52168946,12,497),(6242747,52168948,12,498),(6242747,52168952,12,499),(6242747,52168955,12,500),(6242747,52168959,12,501),(6242747,52168961,12,502),(6242747,52168964,12,503),(6242747,52168965,12,504),(6242747,52168967,12,505),(6242747,52168969,12,506),(6242747,52168972,12,507),(6242747,52168974,12,508),(6242747,52168976,12,509),(6242747,52168981,12,510),(6242747,52168984,12,511),(6242747,52168987,12,512),(6242747,52168989,12,513),(6242747,52168992,12,514),(6242747,266326164,12,515),(6242747,52168995,12,516),(6242747,52169000,12,517),(6242747,52169003,12,518),(6242747,52169006,12,519),(6242747,52169008,12,520),(6242747,52169011,12,521),(6242747,52169014,12,522),(6242747,52169016,12,523),(6242747,52169018,12,524),(6242747,52169021,12,525),(6242747,52169022,12,526),(6242747,52169024,12,527),(6242747,52169028,12,528),(6242747,52169032,12,529),(6242747,52169034,12,530),(6242747,52169036,12,531),(6242747,52169041,12,532),(6242747,52169044,12,533),(6242747,52169045,12,534),(6242747,52169048,12,535),(6242747,52169052,12,536),(6242747,52169054,12,537),(6242747,52169055,12,538),(6242747,52169058,12,539),(6242747,52169060,12,540),(6242747,52169061,12,541),(6242747,52169064,12,542),(6242747,52169067,12,543),(6242747,52169070,12,544),(6242747,52169073,12,545),(6242747,52169075,12,546),(6242747,52169076,12,547),(6242747,52169078,12,548),(6242747,52169080,12,549),(6242747,52169083,12,550),(6242747,52169088,12,551),(6242747,52169089,12,552),(6242747,52169092,12,553),(6242747,52169094,12,554),(6242747,52169097,12,555),(6242747,52169100,12,556),(6242747,52169103,12,557),(6242747,52169105,12,558),(6242747,52169109,12,559),(6242747,52169111,12,560),(6242747,52169113,12,561),(6242747,52169115,12,562),(6242747,52169117,12,563),(6242747,52169119,12,564),(6242747,52169121,12,565),(6242747,52169123,12,566),(6242747,52169124,12,567),(6242747,52169125,12,568),(6242747,52169126,12,569),(6242747,52169127,12,570),(6242753,52172181,16,1),(6242753,52172178,16,2),(6242753,52172175,16,3),(6242753,52172172,16,4),(6242753,52172170,16,5),(6242753,52172168,16,6),(6242753,52172166,16,7),(6242753,52172164,16,8),(6242753,52172161,16,9),(6242753,52172158,16,10),(6242753,52172156,16,11),(6242753,52172153,16,12),(6242753,52172150,16,13),(6242753,52172147,16,14),(6242753,52172144,16,15),(6242753,52172141,16,16),(6242753,52172139,16,17),(6242753,52172135,16,18),(6242753,52172133,16,19),(6242753,52172131,16,20),(6242753,52172129,16,21),(6242753,52172128,16,22),(6242753,52172124,16,23),(6242753,52172122,16,24),(6242753,52172111,16,25),(6242753,52172109,16,26),(6242753,52172107,16,27),(6242753,52172106,16,28),(6242753,52172105,16,29),(6242753,52172104,16,30),(6242753,52172102,16,31),(6242753,52172099,16,32),(6242753,52172096,16,33),(6242753,52172092,16,34),(6242753,52172090,16,35),(6242753,52172086,16,36),(6242753,52172050,16,37),(6242753,52172049,16,38),(6242753,52172036,16,39),(6242753,52172033,16,40),(6242753,52172016,16,41),(6242753,52172014,16,42),(6242753,52172012,16,43),(6242753,52172008,16,44),(6242753,52172006,16,45),(6242753,52172001,16,46),(6242753,52171997,16,47),(6242753,52171996,16,48),(6242753,52171995,16,49),(6242753,52171991,16,50),(6242753,52171989,16,51),(6242753,52171988,16,52),(6242753,52171985,16,53),(6242753,52171981,16,54),(6242753,52171979,16,55),(6242753,52171977,16,56),(6242753,52171975,16,57),(6242753,52171972,16,58),(6242753,52171963,16,59),(6242753,52171952,16,60),(6242753,52171949,16,61),(6242753,52171948,16,62),(6242753,52171945,16,63),(6242753,52171942,16,64),(6242753,52171940,16,65),(6242753,52171934,16,66),(6242753,52171932,16,67),(6242753,52171895,16,68),(6242753,52171892,16,69),(6242753,52171888,16,70),(6242753,52171885,16,71),(6242753,52171867,16,72),(6242753,52171863,16,73),(6242753,52171858,16,74),(6242753,52171825,16,75),(6242753,52171822,16,76),(6242753,52171820,16,77),(6242753,52171818,16,78),(6242753,52171815,16,79),(6242753,52171814,16,80),(6242753,52171811,16,81),(6242753,52171810,16,82),(6242753,52171808,16,83),(6242753,52171805,16,84),(6242753,52171801,16,85),(6242753,52171797,16,86),(6242753,52171795,16,87),(6242753,52171790,16,88),(6242753,52171787,16,89),(6242753,52171785,16,90),(6242753,52171781,16,91),(6242753,52171777,16,92),(6242753,52171775,16,93),(6242753,52171771,16,94),(6242753,52206005,16,95),(6242753,52171764,16,96),(6242753,52171665,16,97),(6242753,52171662,16,98),(6242753,52171659,16,99),(6242753,52171656,16,100),(6242753,52171653,16,101),(6242753,52206628,16,102),(6242753,52171649,16,103),(6242753,52171644,16,104),(6242753,52171636,16,105),(6242753,52171633,16,106),(6242753,52171628,16,107),(6242753,52171622,16,108),(6242753,52171616,16,109),(6242753,52171610,16,110),(6242753,52171606,16,111),(6242753,52171601,16,112),(6242753,52171595,16,113),(6242753,52171594,16,114),(6242753,52171590,16,115),(6242753,52171585,16,116),(6242753,52171579,16,117),(6242753,52171574,16,118),(6242753,52171569,16,119),(6242753,52171562,16,120),(6242753,52171557,16,121),(6242753,52171553,16,122),(6242753,52171547,16,123),(6242753,52171542,16,124),(6242753,52171537,16,125),(6242753,52171534,16,126),(6242753,52171531,16,127),(6242753,52171528,16,128),(6242753,52171525,16,129),(6242753,52171521,16,130),(6242753,52171515,16,131),(6242753,52171511,16,132),(6242753,52171506,16,133),(6242753,52171503,16,134),(6242753,52171498,16,135),(6242753,52171494,16,136),(6242753,52171491,16,137),(6242753,52171487,16,138),(6242753,52171485,16,139),(6242753,52171481,16,140),(6242753,52171479,16,141),(6242753,52171474,16,142),(6242753,52171467,16,143),(6242753,52171465,16,144),(6242753,52171458,16,145),(6242753,52171454,16,146),(6242753,52171451,16,147),(6242753,52171449,16,148),(6242753,52171447,16,149),(6242753,52171444,16,150),(6242753,52171443,16,151),(6242753,52171437,16,152),(6242753,52171432,16,153),(6242753,52171426,16,154),(6242753,52171422,16,155),(6242753,52171417,16,156),(6242753,52171413,16,157),(6242753,52171407,16,158),(6242753,52171391,16,159),(6242753,52171385,16,160),(6242753,52171382,16,161),(6242753,52171378,16,162),(6242753,52171373,16,163),(6242753,52171370,16,164),(6242753,52171364,16,165),(6242753,52171351,16,166),(6242753,52171344,16,167),(6242753,52171338,16,168),(6242753,52171330,16,169),(6242753,52171324,16,170),(6242753,52171321,16,171),(6242753,52171317,16,172),(6242753,52171311,16,173),(6242753,52171307,16,174),(6242753,52171305,16,175),(6242753,52171300,16,176),(6242753,52171297,16,177),(6242753,52171295,16,178),(6242753,52171289,16,179),(6242753,52171284,16,180),(6242753,52171280,16,181),(6242753,52171263,16,182),(6242753,52171259,16,183),(6242753,52171256,16,184),(6242753,52171251,16,185),(6242753,52171247,16,186),(6242753,52171188,16,187),(6242753,52171184,16,188),(6242753,52171179,16,189),(6242753,52171173,16,190),(6242753,52171167,16,191),(6242753,52171165,16,192),(6242753,52171156,16,193),(6242753,52171151,16,194),(6242753,52171146,16,195),(6242753,52171140,16,196),(6242753,52171136,16,197),(6242753,52171131,16,198),(6242753,52171129,16,199),(6242753,52171127,16,200),(6242753,52171125,16,201),(6242753,52171121,16,202),(6242753,52171120,16,203),(6242753,52171118,16,204),(6242753,52171114,16,205),(6242753,52171112,16,206),(6242753,52171107,16,207),(6242753,52171100,16,208),(6242753,52171092,16,209),(6242753,52171088,16,210),(6242753,52171084,16,211),(6242753,52171081,16,212),(6242753,52171078,16,213),(6242753,52171075,16,214),(6242753,52171073,16,215),(6242753,52171070,16,216),(6242753,52171060,16,217),(6242753,52171057,16,218),(6242753,52171054,16,219),(6242753,52171050,16,220),(6242753,52171046,16,221),(6242753,52170561,16,222),(6242753,52170544,16,223),(6242753,52170540,16,224),(6242753,52170533,16,225),(6242753,52170525,16,226),(6242753,52170512,16,227),(6242753,52170496,16,228),(6242753,52170441,16,229),(6242753,52170440,16,230),(6242753,52170423,16,231),(6242753,52170418,16,232),(6242753,52170417,16,233),(6242753,52170416,16,234),(6242753,52170415,16,235),(6242753,52170411,16,236),(6242753,52170410,16,237),(6242753,52170406,16,238),(6242753,52170401,16,239),(6242753,52170400,16,240),(6242753,52170397,16,241),(6242753,52170394,16,242),(6242753,52170391,16,243),(6242753,52170388,16,244),(6242753,52170386,16,245),(6242753,52170384,16,246),(6242753,52170381,16,247),(6242753,52170378,16,248),(6242753,52170377,16,249),(6242753,52170374,16,250),(6242753,52170371,16,251),(6242753,258353529,16,252),(6242753,258353530,16,253),(6242753,258353531,16,254),(6242753,258353532,16,255),(6242753,258353533,16,256),(6242753,258353534,16,257),(6242753,258353535,16,258),(6242753,258353536,16,259),(6242753,258353537,16,260),(6242753,258353538,16,261),(6242753,258353539,16,262),(6242756,52170090,6,1),(6242756,52170088,6,2),(6242756,52170080,6,3),(6242756,52170076,6,4),(6242756,52170071,6,5),(6242756,52170065,6,6),(6242756,52170061,6,7),(6242756,52170056,6,8),(6242756,52170048,6,9),(6242756,52170044,6,10),(6242757,52170099,4,1),(6242757,52170096,4,2),(6242757,52170090,4,3),(6242759,52170044,6,1),(6242759,52170042,6,2),(6242759,52170040,6,3),(6244541,52205987,4,1),(6244541,52205985,4,2),(6244541,52205983,4,3),(6244541,52205980,4,4),(6244541,52205977,4,5),(6244541,52205973,4,6),(6244541,52205972,4,7),(6244541,52205967,4,8),(6244541,52205964,4,9),(6244541,52205959,4,10),(6244541,52205955,4,11),(6244541,52205951,4,12),(6244541,52205948,4,13),(6244541,52205945,4,14),(6244541,52205941,4,15),(6244541,52205938,4,16),(6244541,52205937,4,17),(6244541,52205935,4,18),(6244541,52205930,4,19),(6244541,52205929,4,20),(6244541,52205924,4,21),(6244541,52205915,4,22),(6244541,52205913,4,23),(6244541,52205910,4,24),(6244541,52205907,4,25),(6244541,52205904,4,26),(6244541,52205901,4,27),(6244541,52205898,4,28),(6244541,52205896,4,29),(6244541,52205893,4,30),(6244541,52205891,4,31),(6244541,52205888,4,32),(6244541,52205885,4,33),(6244541,52205882,4,34),(6244541,52205880,4,35),(6244541,52205876,4,36),(6244541,52205873,4,37),(6244541,52205869,4,38),(6244541,52205865,4,39),(6244541,52205863,4,40),(6244541,52205859,4,41),(6244541,52205855,4,42),(6244541,52205852,4,43),(6244541,52205849,4,44),(6244541,52205846,4,45),(6244541,52205843,4,46),(6244541,52205839,4,47),(6244541,52205836,4,48),(6244541,52205830,4,49),(6244541,52205828,4,50),(6244541,52205823,4,51),(6244541,52205820,4,52),(6244541,52205813,4,53),(6244541,52205785,4,54),(6244541,52205782,4,55),(6244541,52205774,4,56),(6244541,52205715,4,57),(6244541,52205713,4,58),(6244541,52205712,4,59),(6244541,52205709,4,60),(6244541,52205707,4,61),(6244541,52205703,4,62),(6244541,52205699,4,63),(6244541,52205695,4,64),(6244541,52205693,4,65),(6244541,52205690,4,66),(6244541,52205687,4,67),(6244541,52205685,4,68),(6244541,52205681,4,69),(6244541,52205679,4,70),(6244541,52205678,4,71),(6244541,52205676,4,72),(6244541,52205671,4,73),(6244541,52205641,4,74),(6244541,52205637,4,75),(6244541,52205622,4,76),(6244541,52205496,4,77),(6244541,52205492,4,78),(6244541,52205489,4,79),(6244541,52205485,4,80),(6244541,52205480,4,81),(6244541,52205475,4,82),(6244541,52205473,4,83),(6244541,52205469,4,84),(6244541,52205464,4,85),(6244541,52205461,4,86),(6244541,52205456,4,87),(6244541,52205450,4,88),(6244541,52205438,4,89),(6244541,52205434,4,90),(6244541,52205431,4,91),(6244541,52205427,4,92),(6244541,52205422,4,93),(6244541,52205416,4,94),(6244541,52205404,4,95),(6244541,52205317,4,96),(6244541,52205311,4,97),(6244541,52205309,4,98),(6244541,52205306,4,99),(6244541,52205304,4,100),(6244541,52205301,4,101),(6244541,52205298,4,102),(6244541,52205296,4,103),(6244541,52205290,4,104),(6244541,52205286,4,105),(6244541,52205284,4,106),(6244541,52205280,4,107),(6244541,52205274,4,108),(6244541,52205269,4,109),(6244541,52205266,4,110),(6244541,52205261,4,111),(6244541,52205257,4,112),(6244541,52205252,4,113),(6244541,52205248,4,114),(6244541,52205244,4,115),(6244541,52205242,4,116),(6244541,52205239,4,117),(6244541,52205232,4,118),(6244541,52205230,4,119),(6244541,52205225,4,120),(6244541,52205222,4,121),(6244541,52205218,4,122),(6244541,52205212,4,123),(6244541,52205206,4,124),(6244541,52205200,4,125),(6244541,52205196,4,126),(6244541,52205188,4,127),(6244541,52205186,4,128),(6244541,52205182,4,129),(6244541,52205177,4,130),(6244541,52205176,4,131),(6244541,52205175,4,132),(6244541,52205171,4,133),(6244541,52205166,4,134),(6244541,52205161,4,135),(6244541,52205154,4,136),(6244541,52205150,4,137),(6244541,52205148,4,138),(6244541,52205144,4,139),(6244541,52205141,4,140),(6244541,52205138,4,141),(6244541,52205135,4,142),(6244541,52205132,4,143),(6244541,52205131,4,144),(6244541,52205126,4,145),(6244541,52205123,4,146),(6244541,52205122,4,147),(6244541,52205116,4,148),(6244541,52205113,4,149),(6244541,52205110,4,150),(6244541,52205107,4,151),(6244541,52205105,4,152),(6244541,52205101,4,153),(6244541,52205099,4,154),(6244541,52205096,4,155),(6244541,52205095,4,156),(6244541,52205094,4,157),(6244541,52205093,4,158),(6244541,52205092,4,159),(6244541,52205091,4,160),(6244541,52205090,4,161),(6244541,52205089,4,162),(6244541,52205087,4,163),(6244541,52205086,4,164),(6244541,52205084,4,165),(6244541,52205082,4,166),(6244541,52205080,4,167),(6244541,52205079,4,168),(6244541,52205077,4,169),(6244541,52205075,4,170),(6244541,52205073,4,171),(6244541,52205070,4,172),(6244541,52205065,4,173),(6244541,52205063,4,174),(6244541,52205059,4,175),(6244541,52205055,4,176),(6244541,52205053,4,177),(6244541,52205050,4,178),(6244541,52205046,4,179),(6244541,52205043,4,180),(6244541,52205041,4,181),(6244541,52205038,4,182),(6244541,52205035,4,183),(6244541,52205032,4,184),(6244541,52205029,4,185),(6244541,52205022,4,186),(6244541,52205020,4,187),(6244541,52205014,4,188),(6244541,52205008,4,189),(6244541,52205002,4,190),(6244541,52204983,4,191),(6244541,52204922,4,192),(6244541,52204916,4,193),(6244541,52204912,4,194),(6244541,52204903,4,195),(6244541,52204800,4,196),(6244541,52204798,4,197),(6244541,52204750,4,198),(6244541,52204747,4,199),(6244541,52204670,4,200),(6244541,52204669,4,201),(6244541,52204668,4,202),(6244541,52204665,4,203),(6244541,52204664,4,204),(6244541,52204627,4,205),(6244541,52204624,4,206),(6244541,52204568,4,207),(6244541,52204565,4,208),(6244541,52204553,4,209),(6244541,52204549,4,210),(6244541,52204547,4,211),(6244541,52204544,4,212),(6244541,52204541,4,213),(6244541,52204536,4,214),(6244541,52204534,4,215),(6244541,52204531,4,216),(6244541,52204528,4,217),(6244541,52204525,4,218),(6244541,52204523,4,219),(6244541,52204520,4,220),(6244541,52204516,4,221),(6244541,52204513,4,222),(6244541,52204505,4,223),(6244541,52204504,4,224),(6244541,52204501,4,225),(6244541,52204498,4,226),(6244541,52204495,4,227),(6244541,52204492,4,228),(6244541,52204488,4,229),(6244541,52204485,4,230),(6244541,52204483,4,231),(6244541,52204480,4,232),(6244541,52204478,4,233),(6244541,52204476,4,234),(6244541,52204473,4,235),(6244541,52204470,4,236),(6244541,52204467,4,237),(6244542,52206005,1,1),(6244542,52206003,1,2),(6244542,52206000,1,3),(6244542,52205998,1,4),(6244542,52205990,1,5),(6244542,52205992,1,6),(6244542,52205994,1,7),(6244542,52205996,1,8),(6244542,52206007,1,9),(6244542,52206009,1,10),(6244542,52206010,1,11),(6244542,52206014,1,12),(6244542,52206016,1,13),(6244542,52206018,1,14),(6244542,52206020,1,15),(6244542,52206023,1,16),(6244542,52206025,1,17),(6244542,52206031,1,18),(6244542,52206033,1,19),(6244542,52206036,1,20),(6244542,52206040,1,21),(6244542,52206041,1,22),(6244542,52206044,1,23),(6244542,52206048,1,24),(6244542,52206051,1,25),(6244542,52206054,1,26),(6244542,52206057,1,27),(6244542,52206060,1,28),(6244542,52206063,1,29),(6244542,52206068,1,30),(6244542,52206069,1,31),(6244542,52206072,1,32),(6244542,52206076,1,33),(6244542,52206078,1,34),(6244542,52206165,1,35),(6244542,52206177,1,36),(6244542,52206181,1,37),(6244542,52206185,1,38),(6244542,52206187,1,39),(6244542,52206189,1,40),(6244542,52206193,1,41),(6244542,52206195,1,42),(6244542,52206198,1,43),(6244542,52206202,1,44),(6244542,52206203,1,45),(6244542,52206207,1,46),(6244542,52206209,1,47),(6244542,52206212,1,48),(6244542,52206215,1,49),(6244542,52206218,1,50),(6244542,52206221,1,51),(6244542,52206225,1,52),(6244542,52206228,1,53),(6244542,52206231,1,54),(6244542,52206234,1,55),(6244542,52206238,1,56),(6244542,52206240,1,57),(6244542,52206242,1,58),(6244542,52206244,1,59),(6244542,52206250,1,60),(6244542,52206252,1,61),(6244542,52206254,1,62),(6244542,52206256,1,63),(6244542,52206259,1,64),(6244542,52206262,1,65),(6244542,52206266,1,66),(6244542,52206268,1,67),(6244542,52206271,1,68),(6244542,52206274,1,69),(6244542,52206277,1,70),(6244542,52206280,1,71),(6244542,52206283,1,72),(6244542,52206286,1,73),(6244542,52206290,1,74),(6244542,52206293,1,75),(6244542,52206294,1,76),(6244542,52206299,1,77),(6244542,52206302,1,78),(6244542,52206304,1,79),(6244542,52206306,1,80),(6244542,52206310,1,81),(6244542,52206312,1,82),(6244542,52206315,1,83),(6244542,52206317,1,84),(6244542,52206320,1,85),(6244542,52206321,1,86),(6244542,52206324,1,87),(6244542,52206327,1,88),(6244542,52206333,1,89),(6244542,52206336,1,90),(6244542,52206337,1,91),(6244542,52206340,1,92),(6244542,52206343,1,93),(6244542,52206344,1,94),(6244542,52206347,1,95),(6244542,52206349,1,96),(6244542,52206352,1,97),(6244542,52206354,1,98),(6244542,52206356,1,99),(6244542,52206358,1,100),(6244542,52206359,1,101),(6244542,52206360,1,102),(6244542,52206364,1,103),(6244542,52206366,1,104),(6244542,52206374,1,105),(6244542,52206379,1,106),(6244542,52206383,1,107),(6244542,52206385,1,108),(6244542,52206389,1,109),(6244542,52206395,1,110),(6244542,52206400,1,111),(6244542,52206404,1,112),(6244542,52206407,1,113),(6244542,52206410,1,114),(6244542,52206414,1,115),(6244542,52206419,1,116),(6244542,52206420,1,117),(6244542,52206422,1,118),(6244542,52206425,1,119),(6244542,52206429,1,120),(6244542,52206433,1,121),(6244542,52206435,1,122),(6244542,52206439,1,123),(6244542,52206442,1,124),(6244542,52206446,1,125),(6244542,52206447,1,126),(6244542,52206449,1,127),(6244542,52206453,1,128),(6244542,52206457,1,129),(6244542,52206461,1,130),(6244542,52206468,1,131),(6244542,52206471,1,132),(6244542,52206472,1,133),(6244545,52206476,1,1),(6244545,52206479,1,2),(6244545,52206483,1,3),(6244545,52206486,1,4),(6244545,52206488,1,5),(6244545,52206491,1,6),(6244545,52206495,1,7),(6244545,52206498,1,8),(6244545,52206502,1,9),(6244545,52206505,1,10),(6244545,52206508,1,11),(6244545,52206512,1,12),(6244545,52206580,1,13),(6244545,52206583,1,14),(6244545,52206585,1,15),(6244545,52206588,1,16),(6244545,52206591,1,17),(6244545,52206601,1,18),(6244545,52206604,1,19),(6244545,52206607,1,20),(6244545,52206609,1,21),(6244545,52206611,1,22),(6244545,52206615,1,23),(6244545,52206617,1,24),(6244545,52206619,1,25),(6244545,52206620,1,26),(6244545,52206622,1,27),(6244545,52206625,1,28),(6244545,52206627,1,29),(6244545,52206628,1,30),(6244550,52206676,3,1),(6244550,52206679,3,2),(6244550,52206681,3,3),(6244550,264465130,3,4),(6244551,52206645,2,1),(6244551,52206647,2,2),(6244551,52206650,2,3),(6244551,52206653,2,4),(6244551,52206655,2,5),(6244551,52206657,2,6),(6244551,52206661,2,7),(6244551,52206663,2,8),(6244552,52206663,5,1),(6244552,52206666,5,2),(6244554,52206666,2,1),(6244554,52206669,2,2),(6244554,52206671,2,3),(6244554,52206673,2,4),(6244554,52206676,2,5),(6244556,52206708,2,1),(6244556,52206710,2,2),(6244556,52206647,2,3),(6244558,52206706,4,1),(6244558,52206708,4,2),(6244561,52206691,2,1),(6244561,52206694,2,2),(6244561,52206698,2,3),(6244561,52206701,2,4),(6244561,52206703,2,5),(6244561,52206706,2,6),(6244562,52206714,2,1),(6244562,52206701,2,2),(6244759,52212234,2,1),(6244759,52212307,2,2),(6244759,52212628,2,3),(6244759,52212746,2,4);
INSERT INTO `way_nodes` VALUES (6244759,52212871,2,5),(6244759,52212893,2,6),(6244759,52212906,2,7),(6244759,52212920,2,8),(6244759,52206688,2,9),(6244763,52212916,2,1),(6244763,52212920,2,2),(6247260,52252247,2,1),(6247260,52252315,2,2),(6247267,52252320,2,1),(6247267,52252433,2,2),(6247268,144217502,4,1),(6247268,144217504,4,2),(6247268,144217505,4,3),(6247268,144217506,4,4),(6247268,144217507,4,5),(6247268,144217508,4,6),(6247268,144217510,4,7),(6247268,144217512,4,8),(6247268,144217513,4,9),(6247268,144217514,4,10),(6247268,144217515,4,11),(6247268,144217517,4,12),(6247268,796041497,4,13),(6247268,144217519,4,14),(6247268,51386536,4,15),(6247268,51386538,4,16),(6247268,51386455,4,17),(6247268,51386456,4,18),(6247268,51386457,4,19),(6247268,51386340,4,20),(6247268,51386342,4,21),(6247268,51386346,4,22),(6247268,51386271,4,23),(6247268,51386274,4,24),(6247268,51386275,4,25),(6247268,51386276,4,26),(6247268,51386279,4,27),(6247268,51386281,4,28),(6247268,51386282,4,29),(6247268,51386284,4,30),(6247268,51386286,4,31),(6247268,51386287,4,32),(6247268,51386289,4,33),(6247268,51386290,4,34),(6247268,51386294,4,35),(6247268,51386295,4,36),(6247268,51386296,4,37),(6247268,51386298,4,38),(6247269,52252333,3,1),(6247269,51386298,3,2),(6247270,52252331,3,1),(6247270,52252330,3,2),(6247270,52252328,3,3),(6247270,52252411,3,4),(6247270,52252326,3,5),(6247270,52252325,3,6),(6247270,52252322,3,7),(6247270,52252336,3,8),(6247270,52252333,3,9),(6247270,52252331,3,10),(6247271,52252326,3,1),(6247271,51386301,3,2),(6247273,51386301,3,1),(6247273,52252322,3,2),(6247274,52252411,2,1),(6247274,52252407,2,2),(6247274,52252405,2,3),(6247274,52252404,2,4),(6247274,52252412,2,5),(6247274,52252414,2,6),(6247274,52252416,2,7),(6247274,52252417,2,8),(6247274,52252420,2,9),(6247274,52252422,2,10),(6247274,52252423,2,11),(6247274,52252424,2,12),(6247274,52252426,2,13),(6247274,52252427,2,14),(6247274,52252429,2,15),(6247274,52252430,2,16),(6247274,52252431,2,17),(6247274,52252433,2,18),(6247274,52261890,2,19),(6247274,52322119,2,20),(6247274,52252247,2,21),(6247274,52252434,2,22),(6247274,52252435,2,23),(6247274,52252437,2,24),(6247274,52330668,2,25),(6247274,52252452,2,26),(6247274,52252472,2,27),(6247274,52252473,2,28),(6247274,51385976,2,29),(6247278,52261850,2,1),(6247278,52261860,2,2),(6247278,52261864,2,3),(6247278,52261866,2,4),(6247278,52261869,2,5),(6247278,52261872,2,6),(6247278,52261874,2,7),(6247278,52261878,2,8),(6247278,52261880,2,9),(6247278,52261883,2,10),(6247278,52261907,2,11),(6247279,52262076,2,1),(6247279,52262074,2,2),(6247279,52262072,2,3),(6247279,52262070,2,4),(6247279,52262067,2,5),(6247279,52262065,2,6),(6247279,52262064,2,7),(6247279,52262063,2,8),(6247279,52262060,2,9),(6247279,52262058,2,10),(6247279,52262057,2,11),(6247279,52262054,2,12),(6247279,52262052,2,13),(6247279,52262048,2,14),(6247279,52262047,2,15),(6247279,52262046,2,16),(6247279,52262045,2,17),(6247279,52262044,2,18),(6247279,52262042,2,19),(6247279,52262041,2,20),(6247279,52262039,2,21),(6247279,52262037,2,22),(6247279,52262036,2,23),(6247279,52262034,2,24),(6247279,52262031,2,25),(6247279,52262028,2,26),(6247279,52262025,2,27),(6247279,52261997,2,28),(6247279,52261993,2,29),(6247279,52261991,2,30),(6247279,52261987,2,31),(6247279,52261985,2,32),(6247279,52261982,2,33),(6247279,52261978,2,34),(6247279,52261975,2,35),(6247279,52261972,2,36),(6247279,52261969,2,37),(6247279,52261965,2,38),(6247279,52262022,2,39),(6247279,52261962,2,40),(6247279,52261959,2,41),(6247279,52261955,2,42),(6247279,52261951,2,43),(6247279,52261947,2,44),(6247279,52261946,2,45),(6247279,52261940,2,46),(6247279,52261938,2,47),(6247279,52261934,2,48),(6247279,52261931,2,49),(6247279,52261927,2,50),(6247279,52261926,2,51),(6247279,52261924,2,52),(6247279,52261921,2,53),(6247279,52261918,2,54),(6247279,52261914,2,55),(6247279,52261910,2,56),(6247279,52261907,2,57),(6247279,52261902,2,58),(6247279,52261900,2,59),(6247279,52261896,2,60),(6247279,52261893,2,61),(6247279,52261886,2,62),(6247279,52261888,2,63),(6247279,52261890,2,64),(6247280,52261999,2,1),(6247280,52262003,2,2),(6247280,52262006,2,3),(6247280,52262010,2,4),(6247280,52262016,2,5),(6247280,52262020,2,6),(6247280,52262022,2,7),(6247282,52262332,2,1),(6247282,52262335,2,2),(6247282,52262338,2,3),(6247282,52262341,2,4),(6247282,52262345,2,5),(6247282,52262348,2,6),(6247282,52262350,2,7),(6247282,52262353,2,8),(6247282,52262356,2,9),(6247282,52262360,2,10),(6247282,52262362,2,11),(6247282,52262366,2,12),(6247282,52262369,2,13),(6247282,52262373,2,14),(6247282,52262375,2,15),(6247282,52262379,2,16),(6247282,52262380,2,17),(6247282,52262383,2,18),(6247282,52262389,2,19),(6247282,52262391,2,20),(6247282,52262395,2,21),(6247282,52262397,2,22),(6247282,52262401,2,23),(6247282,52262404,2,24),(6247282,52262408,2,25),(6247282,52262411,2,26),(6247282,52262413,2,27),(6247282,52262417,2,28),(6247282,52262420,2,29),(6247282,52262422,2,30),(6247282,52262426,2,31),(6247282,52262428,2,32),(6247282,52262431,2,33),(6247282,52262434,2,34),(6247282,52262438,2,35),(6247282,52262442,2,36),(6247282,52262448,2,37),(6247282,52262451,2,38),(6247282,52262454,2,39),(6247282,52262457,2,40),(6247282,52262459,2,41),(6247282,52262463,2,42),(6247282,52262466,2,43),(6247282,52262470,2,44),(6247282,52262473,2,45),(6247282,52262476,2,46),(6247282,52262480,2,47),(6247282,52262482,2,48),(6247282,52262485,2,49),(6247283,52262538,2,1),(6247283,52262541,2,2),(6247283,52262544,2,3),(6247283,52262546,2,4),(6247283,52262550,2,5),(6247283,52262552,2,6),(6247283,52262556,2,7),(6247283,52262560,2,8),(6247283,52262563,2,9),(6247283,52262566,2,10),(6247284,52262910,2,1),(6247284,52262913,2,2),(6247284,52262916,2,3),(6247284,52262919,2,4),(6247284,52262921,2,5),(6247284,52262925,2,6),(6247284,52262930,2,7),(6247284,52262934,2,8),(6247284,52262938,2,9),(6247285,52262941,2,1),(6247285,52262944,2,2),(6247285,52262946,2,3),(6247285,52262949,2,4),(6247285,52262954,2,5),(6247285,52262957,2,6),(6247285,52262961,2,7),(6247285,52262963,2,8),(6247285,52262967,2,9),(6247286,52262970,2,1),(6247286,52262973,2,2),(6247286,52262977,2,3),(6247286,52262979,2,4),(6247286,52262981,2,5),(6247286,52263076,2,6),(6247286,52263079,2,7),(6247286,52263083,2,8),(6247287,52263091,2,1),(6247287,52263095,2,2),(6247287,52263098,2,3),(6247288,52263100,2,1),(6247288,52263106,2,2),(6247288,52263109,2,3),(6247288,52263111,2,4),(6247288,52263113,2,5),(6247288,52263117,2,6),(6247288,52263119,2,7),(6247288,52262908,2,8),(6247289,52263162,2,1),(6247289,52263166,2,2),(6247289,52263168,2,3),(6247289,52263171,2,4),(6247289,52263173,2,5),(6247289,52263177,2,6),(6247289,52263180,2,7),(6247289,52263183,2,8),(6247289,52263186,2,9),(6247289,52263190,2,10),(6247289,52263191,2,11),(6247289,52263195,2,12),(6247290,52263546,2,1),(6247290,52263549,2,2),(6247290,52263553,2,3),(6247290,52263554,2,4),(6247290,52263556,2,5),(6247290,52263559,2,6),(6247290,52263560,2,7),(6247290,52263618,2,8),(6247290,52263563,2,9),(6247290,52263566,2,10),(6247290,52263570,2,11),(6247290,52263573,2,12),(6247290,52263575,2,13),(6247290,52263696,2,14),(6247290,52263623,2,15),(6247290,52263625,2,16),(6247290,52263628,2,17),(6247290,52263629,2,18),(6247290,52263632,2,19),(6247290,52263634,2,20),(6247290,52263637,2,21),(6247290,52263639,2,22),(6247290,52263641,2,23),(6247290,52263644,2,24),(6247290,52263646,2,25),(6247290,52263649,2,26),(6247290,52263727,2,27),(6247290,52263650,2,28),(6247290,52263652,2,29),(6247290,52263655,2,30),(6247290,52263657,2,31),(6247290,52263660,2,32),(6247290,52263662,2,33),(6247290,52263665,2,34),(6247290,52263667,2,35),(6247290,52263669,2,36),(6247291,52263621,2,1),(6247291,52263577,2,2),(6247291,52263579,2,3),(6247291,52263581,2,4),(6247291,52263584,2,5),(6247291,52263593,2,6),(6247291,52263586,2,7),(6247291,52263588,2,8),(6247291,52263595,2,9),(6247291,52263598,2,10),(6247291,52263602,2,11),(6247291,52263605,2,12),(6247291,52263608,2,13),(6247291,52263611,2,14),(6247291,52263615,2,15),(6247291,52263617,2,16),(6247291,52263618,2,17),(6247292,52263726,2,1),(6247292,52263724,2,2),(6247292,52263722,2,3),(6247292,52263721,2,4),(6247292,52263718,2,5),(6247292,52263717,2,6),(6247292,52263716,2,7),(6247292,52263713,2,8),(6247292,52263712,2,9),(6247292,52263711,2,10),(6247292,52263708,2,11),(6247292,52263706,2,12),(6247292,52263704,2,13),(6247292,52263702,2,14),(6247292,52263700,2,15),(6247292,52263698,2,16),(6247292,52263670,2,17),(6247292,52263672,2,18),(6247292,52263674,2,19),(6247292,52263681,2,20),(6247292,52263683,2,21),(6247292,52263686,2,22),(6247292,52263687,2,23),(6247292,52263688,2,24),(6247292,52263691,2,25),(6247292,52263693,2,26),(6247292,52263696,2,27),(6247294,52263868,2,1),(6247294,52263854,2,2),(6247294,52263857,2,3),(6247294,52263858,2,4),(6247294,52263860,2,5),(6247294,52263863,2,6),(6247294,52263865,2,7),(6247295,52263870,2,1),(6247295,52263873,2,2),(6247295,52263875,2,3),(6247295,52263876,2,4),(6247295,52263854,2,5),(6247296,52263877,2,1),(6247296,52263876,2,2),(6248150,52286947,2,1),(6248150,52286950,2,2),(6248150,52286951,2,3),(6248150,52286954,2,4),(6248150,52286967,2,5),(6248150,52286970,2,6),(6248150,52286971,2,7),(6248150,52286973,2,8),(6248150,52286974,2,9),(6248150,52286975,2,10),(6248151,52287059,2,1),(6248151,52287063,2,2),(6248151,52287062,2,3),(6248455,52297501,2,1),(6248455,52296455,2,2),(6248455,52296457,2,3),(6248455,52296459,2,4),(6248455,52296460,2,5),(6248455,52296461,2,6),(6248455,52296462,2,7),(6248455,52296464,2,8),(6248455,52296465,2,9),(6248455,52296467,2,10),(6248455,52297542,2,11),(6248455,52296469,2,12),(6248455,52296471,2,13),(6248455,52297285,2,14),(6248455,52296472,2,15),(6248455,52296476,2,16),(6248455,52296478,2,17),(6248455,52296481,2,18),(6248455,52296483,2,19),(6248455,52296485,2,20),(6248455,52296486,2,21),(6248455,52296489,2,22),(6248455,52296490,2,23),(6248455,52296492,2,24),(6248455,52296494,2,25),(6248455,52296495,2,26),(6248455,52296497,2,27),(6248455,52296999,2,28),(6248455,52296975,2,29),(6248455,52296977,2,30),(6248455,52296978,2,31),(6248455,52296979,2,32),(6248455,52288390,2,33),(6248456,52296981,2,1),(6248456,52296982,2,2),(6248456,52296984,2,3),(6248456,52296985,2,4),(6248456,52296987,2,5),(6248456,52297038,2,6),(6248456,52296990,2,7),(6248456,52296992,2,8),(6248456,52296994,2,9),(6248456,52296996,2,10),(6248456,52296999,2,11),(6248458,52297002,2,1),(6248458,52297004,2,2),(6248458,52297007,2,3),(6248458,52297010,2,4),(6248458,52297013,2,5),(6248458,52297015,2,6),(6248458,52297018,2,7),(6248458,52297038,2,8),(6248459,52297041,2,1),(6248459,52297063,2,2),(6248459,52297071,2,3),(6248459,52297255,2,4),(6248459,52297266,2,5),(6248459,52297268,2,6),(6248459,52297272,2,7),(6248459,52297276,2,8),(6248459,52297279,2,9),(6248459,52297281,2,10),(6248459,52297285,2,11),(6248460,52297288,2,1),(6248460,52297290,2,2),(6248460,52297294,2,3),(6248460,52297312,2,4),(6248460,52297297,2,5),(6248460,52297300,2,6),(6248460,52297301,2,7),(6248461,52297305,2,1),(6248461,52297309,2,2),(6248461,52297312,2,3),(6248462,52297314,2,1),(6248462,52297317,2,2),(6248462,52297320,2,3),(6248462,52297324,2,4),(6248462,52297328,2,5),(6248462,52297333,2,6),(6248462,52297339,2,7),(6248462,52297344,2,8),(6248462,52297349,2,9),(6248462,52297354,2,10),(6248462,52297358,2,11),(6248462,52297362,2,12),(6248462,52297366,2,13),(6248462,52297369,2,14),(6248462,52297373,2,15),(6248462,52297375,2,16),(6248462,52297380,2,17),(6248462,52297383,2,18),(6248462,52288377,2,19),(6248463,52297498,2,1),(6248463,52297494,2,2),(6248463,52297492,2,3),(6248463,52297488,2,4),(6248463,52297484,2,5),(6248463,52297482,2,6),(6248463,52297478,2,7),(6248463,52297474,2,8),(6248463,52297470,2,9),(6248463,52297469,2,10),(6248463,52297465,2,11),(6248463,52297462,2,12),(6248463,52297459,2,13),(6248463,52297455,2,14),(6248463,52297450,2,15),(6248463,52297447,2,16),(6248463,52297442,2,17),(6248463,52297440,2,18),(6248463,52297437,2,19),(6248463,52297435,2,20),(6248463,52297432,2,21),(6248463,52297427,2,22),(6248463,52297424,2,23),(6248463,52297422,2,24),(6248463,52297418,2,25),(6248463,52297412,2,26),(6248463,52297410,2,27),(6248463,52297405,2,28),(6248463,52297402,2,29),(6248463,52297386,2,30),(6248463,52297390,2,31),(6248463,52297393,2,32),(6248463,52297397,2,33),(6248464,52297507,2,1),(6248464,52297509,2,2),(6248464,52297515,2,3),(6248464,52297517,2,4),(6248464,52297520,2,5),(6248464,52297521,2,6),(6248464,52297525,2,7),(6248464,52297528,2,8),(6248464,52297532,2,9),(6248464,52297535,2,10),(6248464,52297537,2,11),(6248464,52297540,2,12),(6248464,52297542,2,13),(6248467,52297545,2,1),(6248467,52297547,2,2),(6248467,52297550,2,3),(6248467,52297602,2,4),(6248467,52297554,2,5),(6248467,52297558,2,6),(6248467,52297560,2,7),(6248467,52297563,2,8),(6248467,52297565,2,9),(6248467,52297567,2,10),(6248467,52297571,2,11),(6248467,52297573,2,12),(6248467,52297576,2,13),(6248467,52297580,2,14),(6248467,52288514,2,15),(6248468,52297584,2,1),(6248468,52297587,2,2),(6248468,52297590,2,3),(6248468,52297592,2,4),(6248468,52297595,2,5),(6248468,52297599,2,6),(6248468,52297602,2,7),(6248469,52297606,2,1),(6248469,52297609,2,2),(6248469,52297612,2,3),(6248469,52297615,2,4),(6248469,52297617,2,5),(6248469,52297621,2,6),(6248469,52297623,2,7),(6248469,52297626,2,8),(6248469,52297629,2,9),(6248469,52297633,2,10),(6248469,52297638,2,11),(6248469,52297640,2,12),(6248469,52297643,2,13),(6248469,52297646,2,14),(6248469,52297650,2,15),(6249800,52322119,2,1),(6249800,52322115,2,2),(6249800,52322112,2,3),(6249800,52322122,2,4),(6249800,52322125,2,5),(6249800,52322137,2,6),(6249800,52322143,2,7),(6249800,52322151,2,8),(6249800,52322153,2,9),(6249800,52322155,2,10),(6249800,52322156,2,11),(6249800,52330678,2,12),(6249800,52322157,2,13),(6249800,52322159,2,14),(6249800,52322163,2,15),(6249800,52322165,2,16),(6249800,52322167,2,17),(6249800,52322170,2,18),(6249800,52322171,2,19),(6249800,52322174,2,20),(6249800,52322177,2,21),(6249800,52322180,2,22),(6249800,52322184,2,23),(6249800,52329934,2,24),(6249800,52322185,2,25),(6249800,52322190,2,26),(6249800,52322193,2,27),(6249800,52322196,2,28),(6249800,52322198,2,29),(6249800,52322200,2,30),(6249800,52322203,2,31),(6249800,52322207,2,32),(6249800,52322210,2,33),(6249800,52322213,2,34),(6249800,52322216,2,35),(6249800,52322219,2,36),(6249800,52322222,2,37),(6249800,52322223,2,38),(6249800,52322225,2,39),(6249800,52322228,2,40),(6249800,52322231,2,41),(6249800,52322235,2,42),(6249800,52322237,2,43),(6249800,52322240,2,44),(6249800,52322242,2,45),(6249800,52322244,2,46),(6249800,52322245,2,47),(6249800,52322247,2,48),(6249800,52322249,2,49),(6249800,52322252,2,50),(6249800,52322255,2,51),(6249800,52322256,2,52),(6249800,52322259,2,53),(6249800,52322262,2,54),(6249800,52322266,2,55),(6249800,52322268,2,56),(6249800,52322271,2,57),(6249800,52322273,2,58),(6249800,52322277,2,59),(6249800,52322278,2,60),(6249800,52322279,2,61),(6249800,52322282,2,62),(6249800,52322285,2,63),(6249800,52322286,2,64),(6249800,52322289,2,65),(6249800,52322292,2,66),(6249800,52322293,2,67),(6249800,52322295,2,68),(6249800,52322298,2,69),(6249800,52322299,2,70),(6249800,52322302,2,71),(6249800,52322305,2,72),(6249800,52322308,2,73),(6249800,52322309,2,74),(6249800,52322311,2,75),(6249800,52322313,2,76),(6249800,52322315,2,77),(6249800,52322316,2,78),(6249800,52322318,2,79),(6249800,52322320,2,80),(6249800,52322322,2,81),(6249800,52322324,2,82),(6249800,52322327,2,83),(6249800,52322329,2,84),(6249800,52322331,2,85),(6249800,52322333,2,86),(6249800,52322335,2,87),(6249800,52322336,2,88),(6249800,52322337,2,89),(6249800,52322339,2,90),(6249800,52322341,2,91),(6249800,52322342,2,92),(6249800,52322344,2,93),(6249800,52322345,2,94),(6249800,52322347,2,95),(6249800,52322349,2,96),(6249800,52322351,2,97),(6249800,52322353,2,98),(6249800,52322355,2,99),(6249800,52322357,2,100),(6249800,52322358,2,101),(6249800,52322359,2,102),(6249800,52322361,2,103),(6249800,52322363,2,104),(6249800,52322364,2,105),(6249800,52322365,2,106),(6249800,52322366,2,107),(6249800,52322368,2,108),(6249800,52322370,2,109),(6249800,52322372,2,110),(6249800,52322374,2,111),(6249800,52322376,2,112),(6249800,52322378,2,113),(6249800,52322380,2,114),(6249800,52322382,2,115),(6249800,52322384,2,116),(6249800,52322386,2,117),(6249800,52322388,2,118),(6249800,52322390,2,119),(6249800,52322392,2,120),(6249800,52322395,2,121),(6249800,52322398,2,122),(6249800,52322400,2,123),(6249800,52322402,2,124),(6249800,52322405,2,125),(6249800,52322408,2,126),(6249800,52322411,2,127),(6249800,52322413,2,128),(6249800,52322415,2,129),(6249800,52322419,2,130),(6249800,52322422,2,131),(6249800,52322424,2,132),(6249800,52322429,2,133),(6249800,52322432,2,134),(6249800,52322434,2,135),(6249800,52322437,2,136),(6249800,52322440,2,137),(6249800,52322441,2,138),(6249800,52322443,2,139),(6249800,52322446,2,140),(6249800,52322449,2,141),(6249800,52322451,2,142),(6249800,52322453,2,143),(6249800,52322455,2,144),(6249800,52322458,2,145),(6249800,52322461,2,146),(6249800,52322463,2,147),(6249800,52322465,2,148),(6249800,52322467,2,149),(6249800,52322470,2,150),(6249800,52322473,2,151),(6249800,52322475,2,152),(6249800,52322478,2,153),(6249800,52322481,2,154),(6249800,52322484,2,155),(6249800,52322486,2,156),(6249800,52322488,2,157),(6249800,52322492,2,158),(6249800,52322493,2,159),(6249800,52322496,2,160),(6249800,52322497,2,161),(6249800,52322500,2,162),(6249800,52322502,2,163),(6249800,52322504,2,164),(6249800,52322508,2,165),(6249800,52322510,2,166),(6249800,52322512,2,167),(6249800,52322515,2,168),(6249800,52322516,2,169),(6249800,52322518,2,170),(6249800,52322520,2,171),(6249800,52322523,2,172),(6249800,52322526,2,173),(6249800,52322528,2,174),(6249800,52322530,2,175),(6249800,52322533,2,176),(6249800,52322534,2,177),(6249800,52322537,2,178),(6249800,52322540,2,179),(6249800,52322542,2,180),(6249800,52322544,2,181),(6249800,52322545,2,182),(6249800,52322548,2,183),(6249800,52322551,2,184),(6249800,52322552,2,185),(6249800,52322554,2,186),(6249800,52322557,2,187),(6249800,52322558,2,188),(6249800,52322561,2,189),(6249800,52322562,2,190),(6249800,52322564,2,191),(6249800,52322567,2,192),(6249800,52322570,2,193),(6249800,52322571,2,194),(6249800,52322574,2,195),(6249800,52322578,2,196),(6249800,52322579,2,197),(6249800,52322581,2,198),(6249800,52322583,2,199),(6249800,52322585,2,200),(6249800,52322587,2,201),(6249800,52322589,2,202),(6249800,52322591,2,203),(6249800,52322593,2,204),(6249800,52322595,2,205),(6249800,52322598,2,206),(6249800,52322601,2,207),(6249800,52322602,2,208),(6249800,52322604,2,209),(6249800,52322606,2,210),(6249800,52322611,2,211),(6249800,52322613,2,212),(6249800,52322615,2,213),(6249800,52328367,2,214),(6249800,52322617,2,215),(6249800,52322618,2,216),(6249800,52322623,2,217),(6249800,52322626,2,218),(6249800,52322627,2,219),(6249800,52322630,2,220),(6249800,52322632,2,221),(6249800,52322634,2,222),(6249800,52322713,2,223),(6249800,52322716,2,224),(6249800,52322719,2,225),(6249800,52322722,2,226),(6249800,52322725,2,227),(6249800,52322727,2,228),(6249800,52322729,2,229),(6249800,52322731,2,230),(6249800,52322733,2,231),(6249800,52322736,2,232),(6249800,52322738,2,233),(6249800,52322739,2,234),(6249800,52322741,2,235),(6249800,52322753,2,236),(6249800,52322755,2,237),(6249800,52322758,2,238),(6249800,52322761,2,239),(6249800,52322764,2,240),(6249800,52322765,2,241),(6249800,52322768,2,242),(6249800,52322770,2,243),(6249800,52322773,2,244),(6249800,52322774,2,245),(6249800,52322777,2,246),(6249800,52322780,2,247),(6249800,52322782,2,248),(6249800,52322785,2,249),(6249800,52322787,2,250),(6249800,52322789,2,251),(6249800,52322791,2,252),(6249800,52322793,2,253),(6249800,52322795,2,254),(6249800,52322796,2,255),(6249800,52322799,2,256),(6249800,52322800,2,257),(6249800,52322802,2,258),(6249800,52322804,2,259),(6249800,52322806,2,260),(6249800,52322809,2,261),(6249800,52322810,2,262),(6249800,52322815,2,263),(6249800,52322816,2,264),(6249800,52322819,2,265),(6249800,52322823,2,266),(6249800,52322826,2,267),(6249800,52322827,2,268),(6249800,52322830,2,269),(6249800,52322833,2,270),(6249800,52322836,2,271),(6249800,52322837,2,272),(6249800,52322840,2,273),(6249800,52322842,2,274),(6249800,52322844,2,275),(6249800,52322846,2,276),(6249800,52322847,2,277),(6249800,52322850,2,278),(6249800,52322851,2,279),(6249800,52322855,2,280),(6249800,52322858,2,281),(6249800,52322859,2,282),(6249800,52322863,2,283),(6249800,52322865,2,284),(6249800,52322867,2,285),(6249800,52322871,2,286),(6249800,52322874,2,287),(6249800,52322877,2,288),(6249800,52322879,2,289),(6249800,52322880,2,290),(6249800,52322883,2,291),(6249800,52322887,2,292),(6249800,52322889,2,293),(6249800,52322891,2,294),(6249800,52322893,2,295),(6249800,52322896,2,296),(6249800,52322898,2,297),(6249800,52322902,2,298),(6249800,52322903,2,299),(6249800,52322904,2,300),(6249800,52327417,2,301),(6249800,52322907,2,302),(6249800,52322910,2,303),(6249800,52322911,2,304),(6249800,52322915,2,305),(6249800,52322917,2,306),(6249800,52322919,2,307),(6249800,52322921,2,308),(6249800,52322924,2,309),(6249800,52322927,2,310),(6249800,52322929,2,311),(6249800,52322931,2,312),(6249800,52322934,2,313),(6249800,52322937,2,314),(6249800,52322940,2,315),(6249800,52322942,2,316),(6249800,52322945,2,317),(6249800,52322947,2,318),(6249800,52322950,2,319),(6249800,52322953,2,320),(6249800,52322955,2,321),(6249800,52322957,2,322),(6249800,52322959,2,323),(6249800,52322962,2,324),(6249800,52322964,2,325),(6249800,52322966,2,326),(6249800,52322969,2,327),(6249800,52322972,2,328),(6249800,52322974,2,329),(6249800,52322976,2,330),(6249800,52322977,2,331),(6249800,52322979,2,332),(6249800,52322982,2,333),(6249802,52322636,2,1),(6249802,52322639,2,2),(6249802,52322641,2,3),(6249802,52322644,2,4),(6249802,52322646,2,5),(6249802,52322648,2,6),(6249802,52322651,2,7),(6249802,52322654,2,8),(6249802,52322656,2,9),(6249802,52322657,2,10),(6249802,52322660,2,11),(6249802,52322663,2,12),(6249802,52322665,2,13),(6249802,52322667,2,14),(6249802,52322670,2,15),(6249802,52322673,2,16),(6249802,52322675,2,17),(6249802,52322677,2,18),(6249802,52322678,2,19),(6249802,52322681,2,20),(6249802,52322684,2,21),(6249802,52322685,2,22),(6249802,52322687,2,23),(6249802,52322690,2,24),(6249802,52322692,2,25),(6249802,52322695,2,26),(6249802,52322697,2,27),(6249802,52322712,2,28),(6249802,52322698,2,29),(6249802,52322700,2,30),(6249802,52322701,2,31),(6249802,52322704,2,32),(6249802,52322706,2,33),(6249802,52322382,2,34),(6249803,52322709,2,1),(6249803,52322712,2,2),(6250052,52327233,2,1),(6250052,52327235,2,2),(6250052,52327238,2,3),(6250052,52327241,2,4),(6250052,52327243,2,5),(6250052,52327246,2,6),(6250052,52327247,2,7),(6250052,52327250,2,8),(6250052,52327252,2,9),(6250052,52322962,2,10),(6250053,52327263,2,1),(6250053,52327265,2,2),(6250053,52327268,2,3),(6250053,52327271,2,4),(6250053,52327274,2,5),(6250053,52327277,2,6),(6250053,52327279,2,7),(6250053,52322982,2,8),(6250053,52327281,2,9),(6250053,52327282,2,10),(6250053,52327285,2,11),(6250053,52327287,2,12),(6250053,52327288,2,13),(6250053,52327290,2,14),(6250053,52327292,2,15),(6250053,52327295,2,16),(6250053,52327298,2,17),(6250053,52327300,2,18),(6250053,52327302,2,19),(6250053,52327337,2,20),(6250053,52327303,2,21),(6250053,52327306,2,22),(6250053,52327309,2,23),(6250053,52327310,2,24),(6250053,52327313,2,25),(6250053,52327316,2,26),(6250053,52327317,2,27),(6250053,52327321,2,28),(6250053,52327325,2,29),(6250053,52327328,2,30),(6250053,52327329,2,31),(6250053,52327331,2,32),(6250053,52327333,2,33),(6250055,52327339,2,1),(6250055,52327341,2,2),(6250055,52327342,2,3),(6250055,52327345,2,4),(6250055,52327347,2,5),(6250055,52327351,2,6),(6250055,52327333,2,7),(6250055,52327354,2,8),(6250055,52327358,2,9),(6250055,52327359,2,10),(6250055,52327361,2,11),(6250055,52327362,2,12),(6250055,52327365,2,13),(6250055,52327368,2,14),(6250055,52327371,2,15),(6250055,52327372,2,16),(6250055,52327375,2,17),(6250055,52327378,2,18),(6250055,52327379,2,19),(6250055,52327381,2,20),(6250055,52327383,2,21),(6250055,52327384,2,22),(6250055,52327387,2,23),(6250056,52327388,2,1),(6250056,52327390,2,2),(6250056,52327392,2,3),(6250056,52327393,2,4),(6250056,52327398,2,5),(6250056,52327401,2,6),(6250056,52327403,2,7),(6250056,52327406,2,8),(6250056,52327408,2,9),(6250056,52327411,2,10),(6250056,52327413,2,11),(6250056,52327417,2,12),(6250057,52327418,2,1),(6250057,52327421,2,2),(6250057,52327423,2,3),(6250057,52327427,2,4),(6250057,52327429,2,5),(6250057,52327432,2,6),(6250057,52327434,2,7),(6250057,52322615,2,8),(6250105,52328346,2,1),(6250105,52328347,2,2),(6250105,52328370,2,3),(6250105,52328373,2,4),(6250105,52328348,2,5),(6250105,52328350,2,6),(6250105,52328353,2,7),(6250105,52328354,2,8),(6250105,52328357,2,9),(6250105,52328358,2,10),(6250105,52328360,2,11),(6250105,52328362,2,12),(6250105,52328364,2,13),(6250105,52328365,2,14),(6250105,52328367,2,15),(6250238,52329934,2,1),(6250238,52329937,2,2),(6250238,52329940,2,3),(6250238,52329942,2,4),(6250238,52329943,2,5),(6250238,52329946,2,6),(6250238,52329948,2,7),(6250238,52329951,2,8),(6250239,52322170,2,1),(6250239,52329953,2,2),(6250239,52329956,2,3),(6250239,52329957,2,4),(6250239,52329960,2,5),(6250239,52329962,2,6),(6250239,52329964,2,7),(6250239,52329967,2,8),(6250239,52329968,2,9),(6250239,52329970,2,10),(6250239,52329972,2,11),(6250239,52329974,2,12),(6250239,52329978,2,13),(6250239,52329981,2,14),(6250239,52322216,2,15),(6250280,52330668,2,1),(6250280,52330669,2,2),(6250280,52330670,2,3),(6250280,52330671,2,4),(6250280,52330672,2,5),(6250280,52330673,2,6),(6250280,52330674,2,7),(6250280,52330675,2,8),(6250280,52330676,2,9),(6250280,52330677,2,10),(6250280,52330678,2,11),(6267429,52261850,2,1),(6267429,52261846,2,2),(6267429,52261842,2,3),(6267429,52261839,2,4),(6267429,52261835,2,5),(6267429,52261834,2,6),(6267429,52261829,2,7),(6267429,52252480,2,8),(6267429,52252479,2,9),(6267429,52261857,2,10),(6267429,52252478,2,11),(6267429,52252477,2,12),(6267429,52252476,2,13),(6267429,52261853,2,14),(6267429,52252474,2,15),(6267429,52252475,2,16),(6267429,52252427,2,17),(6267881,52578634,4,1),(6267881,52578637,4,2),(6267882,52578637,3,1),(6267882,51386296,3,2),(6267884,52578800,2,1),(6267884,52578802,2,2),(6267884,52578805,2,3),(6267884,52578801,2,4),(6268924,52579285,2,1),(6268924,52596154,2,2),(6268924,52596149,2,3),(6268924,52596158,2,4),(6268924,52596161,2,5),(6268924,52596163,2,6),(6268924,52596167,2,7),(6268924,52596171,2,8),(6268924,52596178,2,9),(6268924,52596180,2,10),(6268924,52596184,2,11),(6268924,52596186,2,12),(6268924,52596191,2,13),(6268924,52596195,2,14),(6268924,52596197,2,15),(6268924,52596200,2,16),(6268924,52596204,2,17),(6268924,52596208,2,18),(6268924,52596212,2,19),(6268924,52596213,2,20),(6268924,52596216,2,21),(6268924,52596219,2,22),(6268924,52596222,2,23),(6268924,52596226,2,24),(6268924,52596228,2,25),(6268924,52596231,2,26),(6268924,52596234,2,27),(6268924,52596236,2,28),(6268924,52596238,2,29),(6268924,52596241,2,30),(6268924,52596243,2,31),(6268924,52596246,2,32),(6268924,52596249,2,33),(6268924,52596271,2,34),(6268924,52596274,2,35),(6268924,52596277,2,36),(6268924,52596280,2,37),(6268924,52596283,2,38),(6268924,52596285,2,39),(6268924,52596288,2,40),(6268924,52596291,2,41),(6268924,52596295,2,42),(6268924,52596297,2,43),(6268924,52596299,2,44),(6268924,52596300,2,45),(6268924,52596303,2,46),(6268924,52596305,2,47),(6268924,52596308,2,48),(6268924,52596310,2,49),(6268924,52596312,2,50),(6268924,52596314,2,51),(6268924,52596318,2,52),(6268924,52596320,2,53),(6268924,52596326,2,54),(6268924,52596331,2,55),(6268924,52596335,2,56),(6268924,52596339,2,57),(6268924,52596343,2,58),(6268924,52596346,2,59),(6268924,52596351,2,60),(6269464,52623167,2,1),(6269464,52623169,2,2),(6269464,52623170,2,3),(6269464,52623173,2,4),(6269464,52623176,2,5),(6269464,52623178,2,6),(6269464,52623180,2,7),(6269464,52623182,2,8),(6269464,52623185,2,9),(6269464,52623187,2,10),(6269464,52623190,2,11),(6269464,52623193,2,12),(6269464,52623196,2,13),(6269464,52623199,2,14),(6269464,52623201,2,15),(6269464,52623203,2,16),(6269464,52623205,2,17),(6269464,52623207,2,18),(6269464,52623209,2,19),(6269464,52623212,2,20),(6269464,52623215,2,21),(6269464,52623218,2,22),(6269464,52623226,2,23),(6269464,52623229,2,24),(6269464,52623231,2,25),(6269464,52623233,2,26),(6269464,52623236,2,27),(6269464,52623240,2,28),(6269464,52623242,2,29),(6269464,52623245,2,30),(6269464,52623247,2,31),(6269464,52623250,2,32),(6269464,52623252,2,33),(6269464,52623255,2,34),(6269464,52623259,2,35),(6269464,52623261,2,36),(6269464,52623265,2,37),(6269464,52623268,2,38),(6269464,52623273,2,39),(6269464,52623276,2,40),(6269464,52623278,2,41),(6269464,52623282,2,42),(6269464,52623285,2,43),(6269464,52623287,2,44),(6269464,52623290,2,45),(6269464,52623294,2,46),(6269464,52623296,2,47),(6269464,52623299,2,48),(6269464,52623301,2,49),(6269464,52623303,2,50),(6269464,52623305,2,51),(6269464,52623308,2,52),(6269464,52623310,2,53),(6269464,52623315,2,54),(6269464,52623317,2,55),(6269464,52623321,2,56),(6269464,52623324,2,57),(6269464,52623329,2,58),(6269464,52623333,2,59),(6269464,52623334,2,60),(6269464,52623339,2,61),(6269464,52623344,2,62),(6269464,52623348,2,63),(6269464,52623351,2,64),(6269464,52623354,2,65),(6269464,52623358,2,66),(6269464,52623360,2,67),(6269464,52623363,2,68),(6269464,52623364,2,69),(6269464,52623367,2,70),(6269464,52623371,2,71),(6269464,52623373,2,72),(6269464,52623375,2,73),(6269464,52623378,2,74),(6269464,52623383,2,75),(6269464,52623385,2,76),(6269464,52623389,2,77),(6269464,52623392,2,78),(6269464,52623394,2,79),(6269464,52623398,2,80),(6269464,52623402,2,81),(6269464,52623403,2,82),(6269464,52623407,2,83),(6269464,52623413,2,84),(6269464,52623416,2,85),(6269464,52623417,2,86),(6269464,52623420,2,87),(6269464,52623424,2,88),(6269464,52623427,2,89),(6269464,52623431,2,90),(6269464,52623434,2,91),(6269464,52623436,2,92),(6269464,52623438,2,93),(6269464,52623441,2,94),(6269464,52623444,2,95),(6269464,52623446,2,96),(6269464,52623449,2,97),(6269464,52623453,2,98),(6269464,52623457,2,99),(6269464,52623463,2,100),(6269464,52623465,2,101),(6269464,52623471,2,102),(6269464,52623475,2,103),(6269464,52623478,2,104),(6269464,52623482,2,105),(6269464,52623485,2,106),(6269464,52623487,2,107),(6269464,52623489,2,108),(6269464,52623492,2,109),(6269464,52623494,2,110),(6269464,52623497,2,111),(6269464,52623500,2,112),(6269464,52623503,2,113),(6269464,52623506,2,114),(6269464,52623509,2,115),(6269464,52623513,2,116),(6269464,52623516,2,117),(6269464,52623517,2,118),(6269464,52623522,2,119),(6269464,52623526,2,120),(6269464,52623530,2,121),(6269464,52623533,2,122),(6269464,52623535,2,123),(6269464,52623538,2,124),(6269464,52623541,2,125),(6269464,52623543,2,126),(6269464,52623545,2,127),(6269464,52623548,2,128),(6269464,52623550,2,129),(6269464,52623553,2,130),(6269464,52623556,2,131),(6269464,52623559,2,132),(6269464,52623562,2,133),(6269464,52623565,2,134),(6269464,52623567,2,135),(6269464,52623570,2,136),(6269464,52623573,2,137),(6269464,52623576,2,138),(6269464,52623578,2,139),(6269464,52623581,2,140),(6269464,52623584,2,141),(6269464,52623587,2,142),(6269464,52623589,2,143),(6269464,52623590,2,144),(6269464,52623593,2,145),(6269464,52623597,2,146),(6269464,52623599,2,147),(6269464,52623602,2,148),(6269464,52623605,2,149),(6269464,52623610,2,150),(6269464,52623613,2,151),(6269464,52623617,2,152),(6269464,52623618,2,153),(6269464,52623621,2,154),(6269464,52623624,2,155),(6269464,52623627,2,156),(6269464,52623630,2,157),(6269464,52623633,2,158),(6269464,52623636,2,159),(6269464,52623638,2,160),(6269464,52623641,2,161),(6269464,52623644,2,162),(6269464,52623647,2,163),(6269464,52623649,2,164),(6269464,52623653,2,165),(6269464,52623655,2,166),(6269464,52623657,2,167),(6269464,52623660,2,168),(6269464,52623664,2,169),(6269464,52623667,2,170),(6269464,52623670,2,171),(6269464,52623674,2,172),(6269464,52623675,2,173),(6269464,52623679,2,174),(6269464,52623684,2,175),(6269464,52623687,2,176),(6269464,52623690,2,177),(6269464,52623692,2,178),(6269464,52623694,2,179),(6269464,52623698,2,180),(6269464,52623701,2,181),(6269464,52623702,2,182),(6269464,52623705,2,183),(6269464,52623707,2,184),(6269464,52623712,2,185),(6269464,52623713,2,186),(6269464,52623715,2,187),(6269464,52623717,2,188),(6269464,52623719,2,189),(6269464,52623720,2,190),(6269464,52623722,2,191),(6269464,52623725,2,192),(6269464,52623726,2,193),(6269464,52623728,2,194),(6269464,52623730,2,195),(6269464,52623732,2,196),(6269464,52623733,2,197),(6269464,52623736,2,198),(6269464,52623739,2,199),(6269464,52623741,2,200),(6269464,52623743,2,201),(6269464,52623746,2,202),(6269464,52623749,2,203),(6269464,52623750,2,204),(6269464,52623752,2,205),(6269464,52623753,2,206),(6269464,52623755,2,207),(6269464,52623757,2,208),(6269464,52623758,2,209),(6269464,52623759,2,210),(6269464,52623760,2,211),(6269464,52623762,2,212),(6269464,52623763,2,213),(6269464,52623765,2,214),(6269464,52623767,2,215),(6269464,52623768,2,216),(6269464,52623769,2,217),(6269464,52623771,2,218),(6269464,52623772,2,219),(6269464,52623773,2,220),(6269464,52623776,2,221),(6269464,52623777,2,222),(6269464,52623778,2,223),(6269464,52623779,2,224),(6269464,52623780,2,225),(6269464,52623781,2,226),(6269464,52623782,2,227),(6269464,52623783,2,228),(6269464,52623784,2,229),(6269464,52623785,2,230),(6269464,52623786,2,231),(6269464,52623788,2,232),(6269464,52623791,2,233),(6269464,52623792,2,234),(6269464,52623795,2,235),(6269464,52623798,2,236),(6269464,52623800,2,237),(6269464,52623802,2,238),(6269464,52623805,2,239),(6269464,52623806,2,240),(6269464,52623808,2,241),(6269464,52623809,2,242),(6269464,52623811,2,243),(6269464,52623814,2,244),(6269464,52623816,2,245),(6269464,52623819,2,246),(6269464,52623823,2,247),(6269464,52623844,2,248),(6269464,52623846,2,249),(6269464,52623849,2,250),(6269464,52635897,2,251),(6269464,52635898,2,252),(6269464,52635899,2,253),(6269464,52635900,2,254),(6269464,52635902,2,255),(6269464,52635903,2,256),(6269464,52635904,2,257),(6269464,52635905,2,258),(6269464,52635907,2,259),(6269464,52635909,2,260),(6269464,52635910,2,261),(6269464,52635912,2,262),(6269464,52635914,2,263),(6269464,52635916,2,264),(6269464,52635917,2,265),(6269464,52636119,2,266),(6269464,52636120,2,267),(6269464,52636122,2,268),(6269464,52636124,2,269),(6269464,52636127,2,270),(6269464,52636128,2,271),(6269464,52636131,2,272),(6269464,52636132,2,273),(6269464,52636133,2,274),(6269464,52636134,2,275),(6269464,52636135,2,276),(6269464,52636136,2,277),(6269464,52636137,2,278),(6269464,52636139,2,279),(6269464,52636140,2,280),(6269464,52636141,2,281),(6269464,52636142,2,282),(6269464,52648095,2,283),(6269464,52648138,2,284),(6269464,52648149,2,285),(6269464,52648164,2,286),(6269464,59632226,2,287),(6275494,52652273,3,1),(6275494,262893000,3,2),(6275497,52685723,2,1),(6275497,52685717,2,2),(6275497,52685714,2,3),(6275497,52685710,2,4),(6275497,52685707,2,5),(6275497,52685701,2,6),(6275497,52685696,2,7),(6275497,52685727,2,8),(6275497,52685732,2,9),(6275497,52685739,2,10),(6275497,52685761,2,11),(6275497,52685764,2,12),(6275497,52685771,2,13),(6275497,52685779,2,14),(6275497,52685789,2,15),(6275497,52685847,2,16),(6275497,52685851,2,17),(6275497,52685859,2,18),(6275497,52685862,2,19),(6275497,52685869,2,20),(6275497,52685873,2,21),(6275497,52685877,2,22),(6275497,52685881,2,23),(6275497,52685886,2,24),(6275497,52685894,2,25),(6275497,52685905,2,26),(6275497,52685911,2,27),(6275497,52685917,2,28),(6275497,52685920,2,29),(6275497,52685923,2,30),(6275497,52685926,2,31),(6275497,52685929,2,32),(6275497,52685931,2,33),(6275497,52685934,2,34),(6275497,52685939,2,35),(6275497,52685943,2,36),(6275497,52685946,2,37),(6275497,52685950,2,38),(6275497,52685966,2,39),(6275497,52685971,2,40),(6275497,52685975,2,41),(6275497,52685978,2,42),(6275497,52685980,2,43),(6275497,52685982,2,44),(6275497,52685986,2,45),(6275497,52685990,2,46),(6275497,52685993,2,47),(6275497,52685996,2,48),(6275497,52686002,2,49),(6275497,52686474,2,50),(6275497,52686478,2,51),(6275497,52686480,2,52),(6275497,52686486,2,53),(6275497,52686490,2,54),(6275497,52686495,2,55),(6275497,52686501,2,56),(6275497,52686505,2,57),(6275497,52686510,2,58),(6275497,52686511,2,59),(6275497,52686514,2,60),(6275497,52686517,2,61),(6275497,52686518,2,62),(6275497,52686521,2,63),(6275497,52686524,2,64),(6275497,52686527,2,65),(6275497,52686533,2,66),(6275497,52686537,2,67),(6275497,52686542,2,68),(6275497,52686544,2,69),(6275497,52686547,2,70),(6275497,52686551,2,71),(6275497,52686555,2,72),(6275497,52686561,2,73),(6275497,52686569,2,74),(6275497,52686574,2,75),(6275497,52686579,2,76),(6275497,52686586,2,77),(6275497,52686593,2,78),(6275497,52686598,2,79),(6275497,52686601,2,80),(6275497,52686604,2,81),(6275497,52686607,2,82),(6275497,52686610,2,83),(6275497,52686622,2,84),(6275497,52686626,2,85),(6275497,52686632,2,86),(6275497,52686637,2,87),(6275497,52686639,2,88),(6275497,52686644,2,89),(6275497,52686648,2,90),(6275497,52686651,2,91),(6275497,52686654,2,92),(6275497,52686655,2,93),(6275497,52686659,2,94),(6275497,52686660,2,95),(6275497,52686663,2,96),(6275497,52686666,2,97),(6275497,52686668,2,98),(6275497,52686674,2,99),(6275497,52686680,2,100),(6275497,52686682,2,101),(6275497,52686683,2,102),(6275497,52686687,2,103),(6275497,52688384,2,104),(6275497,52688387,2,105),(6275497,52688389,2,106),(6275497,52688391,2,107),(6275497,52688393,2,108),(6275497,52688398,2,109),(6275497,52688401,2,110),(6275497,52688431,2,111),(6275497,52688438,2,112),(6275497,52688454,2,113),(6275497,52688455,2,114),(6275497,52688458,2,115),(6275497,52688531,2,116),(6275497,52688570,2,117),(6275497,52688574,2,118),(6275497,52688576,2,119),(6275497,52688577,2,120),(6275497,52688580,2,121),(6275497,52688582,2,122),(6275497,52688584,2,123),(6275497,52688608,2,124),(6275497,52688609,2,125),(6275497,52688628,2,126),(6275497,52688632,2,127),(6275497,52688642,2,128),(6275497,52688633,2,129),(6275497,52688637,2,130),(6275497,52688639,2,131),(6275497,52688644,2,132),(6275497,52688646,2,133),(6275497,52688648,2,134),(6275497,52688652,2,135),(6275497,52688654,2,136),(6275497,52688655,2,137),(6275498,52685802,2,1),(6275498,52685814,2,2),(6275498,52685832,2,3),(6275498,52685840,2,4),(6275498,52612957,2,5),(6275499,52652319,2,1),(6275499,52652351,2,2),(6275499,52652477,2,3),(6275501,51371237,8,1),(6275501,51371240,8,2),(6275501,51371243,8,3),(6275501,51371246,8,4),(6275501,51369095,8,5),(6275501,51369096,8,6),(6275501,51369098,8,7),(6275501,51369101,8,8),(6275501,51369221,8,9),(6275501,51369102,8,10),(6275501,51369103,8,11),(6275501,51369105,8,12),(6275501,646809720,8,13),(6275501,51369106,8,14),(6275501,268631795,8,15),(6275501,646807552,8,16),(6275503,52688669,1,1),(6275503,52688662,1,2),(6275503,52688663,1,3),(6275503,52688667,1,4),(6275503,52688669,1,5),(6275504,52688692,6,1),(6275504,51369129,6,2),(6275504,646809553,6,3),(6275504,52688688,6,4),(6275504,52688686,6,5),(6275504,52688683,6,6),(6275504,52688680,6,7),(6275504,52688677,6,8),(6275504,51369131,6,9),(6275504,646809558,6,10),(6275504,52688676,6,11),(6275504,646809563,6,12),(6275504,52688703,6,13),(6275504,52688672,6,14),(6275504,646809578,6,15),(6275504,52688697,6,16),(6275504,52688693,6,17),(6275504,52688692,6,18),(6275505,51369131,6,1),(6275505,337733739,6,2),(6275505,51369132,6,3),(6275505,51369133,6,4),(6275505,51446992,6,5),(6275505,51369134,6,6),(6275505,51369136,6,7),(6275505,51399381,6,8),(6275505,51369139,6,9),(6275505,52688706,6,10),(6275506,52688740,4,1),(6275506,51410495,4,2),(6275506,646809672,4,3),(6275506,52688708,4,4),(6275506,646809674,4,5),(6275506,52688711,4,6),(6275506,646809678,4,7),(6275506,52688706,4,8),(6275506,52688716,4,9),(6275506,646809684,4,10),(6275506,52688721,4,11),(6275506,52688724,4,12),(6275506,646809689,4,13),(6275506,52688726,4,14),(6275506,52688728,4,15),(6275506,646809695,4,16),(6275506,52688732,4,17),(6275506,646809706,4,18),(6275506,52688735,4,19),(6275506,52688740,4,20),(6275507,52688807,4,1),(6275507,337779059,4,2),(6275507,52688741,4,3),(6275507,52688744,4,4),(6275507,52688747,4,5),(6275507,52688750,4,6),(6275507,52688753,4,7),(6275507,52688756,4,8),(6275507,52688759,4,9),(6275507,52688763,4,10),(6275507,52688767,4,11),(6275507,52688771,4,12),(6275507,52688773,4,13),(6275507,52688774,4,14),(6275507,52688778,4,15),(6275507,52688781,4,16),(6275507,52688783,4,17),(6275507,52688788,4,18),(6275507,52688790,4,19),(6275507,52688795,4,20),(6275507,52688797,4,21),(6275507,52688801,4,22),(6275507,52688802,4,23),(6275507,52688807,4,24),(6275509,51399367,3,1),(6275509,51399411,3,2),(6275509,51399365,3,3),(6275509,52688816,3,4),(6275510,52688846,4,1),(6275510,646809579,4,2),(6275510,52688810,4,3),(6275510,646809584,4,4),(6275510,52688842,4,5),(6275510,646809589,4,6),(6275510,52688838,4,7),(6275510,52688833,4,8),(6275510,52688829,4,9),(6275510,646809604,4,10),(6275510,52688824,4,11),(6275510,646809608,4,12),(6275510,52688820,4,13),(6275510,52688816,4,14),(6275510,646809614,4,15),(6275510,51399601,4,16),(6275510,52688849,4,17),(6275510,52688846,4,18),(6275512,52688833,5,1),(6275512,52688854,5,2),(6275512,52688859,5,3),(6275513,52688872,4,1),(6275513,52688870,4,2),(6275513,52688868,4,3),(6275513,52688865,4,4),(6275513,52688863,4,5),(6275513,52688860,4,6),(6275513,52688829,4,7),(6275514,51404484,3,1),(6275514,52688882,3,2),(6275514,52688884,3,3),(6275514,52688886,3,4),(6275514,52688888,3,5),(6275514,52688890,3,6),(6275514,51443088,3,7),(6275514,51443089,3,8),(6275516,51403656,3,1),(6275516,52688892,3,2),(6275516,52688894,3,3),(6275516,52688896,3,4),(6275516,52688899,3,5),(6275516,52688903,3,6),(6275516,52688904,3,7),(6275516,52688905,3,8),(6275516,52688908,3,9),(6275516,52688912,3,10),(6275516,52688914,3,11),(6275516,52688916,3,12),(6275516,52688920,3,13),(6275516,52688923,3,14),(6275516,343733031,3,15),(6275517,52689048,2,1),(6275517,52688936,2,2),(6275517,52688938,2,3),(6275517,52688942,2,4),(6275517,52688945,2,5),(6275517,52688948,2,6),(6275517,52688951,2,7),(6275517,52688953,2,8),(6275517,52688956,2,9),(6275517,52688958,2,10),(6275517,52688962,2,11),(6275517,52688963,2,12),(6275517,52688967,2,13),(6275517,52688969,2,14),(6275517,52688973,2,15),(6275517,52688975,2,16),(6275517,52688978,2,17),(6275517,52688981,2,18),(6275517,52689010,2,19),(6275517,52689011,2,20),(6275517,52689013,2,21),(6275517,52689016,2,22),(6275517,52689017,2,23),(6275517,52689019,2,24),(6275517,52689020,2,25),(6275517,52689024,2,26),(6275517,52689026,2,27),(6275517,52689028,2,28),(6275517,52689032,2,29),(6275517,52689035,2,30),(6275517,52689036,2,31),(6275517,52689039,2,32),(6275517,52689041,2,33),(6275517,52689048,2,34),(6275518,52689055,4,1),(6275518,52689060,4,2),(6275518,52689065,4,3),(6275518,52689066,4,4),(6275518,52689073,4,5),(6275518,52689076,4,6),(6275518,52689081,4,7),(6275518,52689083,4,8),(6275518,52689086,4,9),(6275518,52689090,4,10),(6275518,52689092,4,11),(6275518,52689094,4,12),(6275518,52689095,4,13),(6275518,52689097,4,14),(6275518,52689102,4,15),(6275518,52689104,4,16),(6275518,52689106,4,17),(6275518,52689107,4,18),(6275518,52689110,4,19),(6275518,52689111,4,20),(6275518,52689114,4,21),(6275518,52689115,4,22),(6275518,52689118,4,23),(6275518,52689120,4,24),(6275518,52689141,4,25),(6275518,52689142,4,26),(6275518,52689145,4,27),(6275518,52689148,4,28),(6275518,52689150,4,29),(6275518,52689154,4,30),(6275518,52689156,4,31),(6275518,52689157,4,32),(6275518,52689160,4,33),(6275518,52689162,4,34),(6275518,52689165,4,35),(6275518,52689167,4,36),(6275518,52689173,4,37),(6275518,52689178,4,38),(6275518,52689180,4,39),(6275518,52689184,4,40),(6275518,52689187,4,41),(6275518,52689189,4,42),(6275518,52689194,4,43),(6275518,52689197,4,44),(6275518,52689201,4,45),(6275518,52689204,4,46),(6275518,52689208,4,47),(6275518,52689210,4,48),(6275518,52689214,4,49),(6275518,52689217,4,50),(6275518,52689218,4,51),(6275518,52689055,4,52),(6275522,52689226,2,1),(6275522,52689230,2,2),(6275522,52689232,2,3),(6275522,52689236,2,4),(6275522,52689239,2,5),(6275522,52689242,2,6),(6275522,52689243,2,7),(6275522,52689245,2,8),(6275522,52689248,2,9),(6275522,52689249,2,10),(6275522,52689251,2,11),(6275522,52689253,2,12),(6275522,52689255,2,13),(6275522,52689257,2,14),(6275522,52689259,2,15),(6275522,52689262,2,16),(6275522,52689263,2,17),(6275522,52689265,2,18),(6275522,52689267,2,19),(6275522,52689270,2,20),(6275522,52689273,2,21),(6275522,52689275,2,22),(6275522,52689278,2,23),(6275522,52689279,2,24),(6275522,52689280,2,25),(6275522,52689282,2,26),(6275522,52689285,2,27),(6275522,52689288,2,28),(6275522,52689290,2,29),(6275522,52689292,2,30),(6275522,52689294,2,31),(6275522,52689295,2,32),(6275522,52689303,2,33),(6275522,52689304,2,34),(6275522,52689308,2,35),(6275522,52689311,2,36),(6275522,52689316,2,37),(6275522,52689319,2,38),(6275522,52689321,2,39),(6275522,52689323,2,40),(6275522,52689326,2,41),(6275522,52689328,2,42),(6275522,52689330,2,43),(6275522,52689333,2,44),(6275522,52689336,2,45),(6275522,52689338,2,46),(6275522,52689340,2,47),(6275522,52689343,2,48),(6275522,52689345,2,49),(6275522,52689348,2,50),(6275522,52689350,2,51),(6275522,52689351,2,52),(6275522,52689353,2,53),(6275522,52689355,2,54),(6275522,52689358,2,55),(6275522,52689359,2,56),(6275522,52689361,2,57),(6275522,52689363,2,58),(6275522,52689365,2,59),(6275522,52689366,2,60),(6275522,52689367,2,61),(6275522,52689371,2,62),(6275522,52689372,2,63),(6275522,52689375,2,64),(6275522,52689377,2,65),(6275522,52689379,2,66),(6275522,321679776,2,67),(6275522,52689382,2,68),(6275522,52689385,2,69),(6275522,52689387,2,70),(6275522,52689390,2,71),(6275522,52689392,2,72),(6275522,52689394,2,73),(6275522,52689396,2,74),(6275522,52689398,2,75),(6275522,52689402,2,76),(6275522,52689405,2,77),(6275522,52689406,2,78),(6275522,52689409,2,79),(6275522,52689410,2,80),(6275522,52689412,2,81),(6275522,52689414,2,82),(6275522,52689416,2,83),(6275522,52689419,2,84),(6275522,52689420,2,85),(6275522,52689423,2,86),(6275522,52689425,2,87),(6275522,52689427,2,88),(6275522,52689429,2,89),(6275522,52689432,2,90),(6275522,52689433,2,91),(6275522,52689436,2,92),(6275522,52689437,2,93),(6275522,52689440,2,94),(6275522,52689443,2,95),(6275522,52689445,2,96),(6275522,52689447,2,97),(6275522,52689450,2,98),(6275522,52689451,2,99),(6275522,52689452,2,100),(6275522,52689455,2,101),(6275522,52689456,2,102),(6275522,52689459,2,103),(6275522,52689461,2,104),(6275522,52689464,2,105),(6275522,52689484,2,106),(6275522,52689486,2,107),(6275522,52689488,2,108),(6275522,52689491,2,109),(6275522,52689493,2,110),(6275522,52689494,2,111),(6275522,52689496,2,112),(6275522,52689497,2,113),(6275522,52689499,2,114),(6275522,52689501,2,115),(6275522,52689503,2,116),(6275522,52689505,2,117),(6275522,52689508,2,118),(6275522,52689513,2,119),(6275522,52689516,2,120),(6275522,52689518,2,121),(6275522,52689522,2,122),(6275522,52689524,2,123),(6275522,52689527,2,124),(6275522,52689528,2,125),(6275522,52689532,2,126),(6275522,52689534,2,127),(6275522,52689537,2,128),(6275522,52689538,2,129),(6275522,52689540,2,130),(6275522,52689545,2,131),(6275522,52689549,2,132),(6275522,52689552,2,133),(6275522,52689553,2,134),(6275522,52689556,2,135),(6275522,52689558,2,136),(6275522,52689560,2,137),(6275522,52689562,2,138),(6275522,52689755,2,139),(6275522,52689751,2,140),(6275522,52689565,2,141),(6275522,52689748,2,142),(6275522,52689567,2,143),(6275522,52689747,2,144),(6275522,52689743,2,145),(6275522,52689742,2,146),(6275522,52689739,2,147),(6275522,52689737,2,148),(6275522,52689570,2,149),(6275522,52689572,2,150),(6275522,52689573,2,151),(6275522,52689576,2,152),(6275522,52689579,2,153),(6275522,52689580,2,154),(6275522,52689583,2,155),(6275522,52689584,2,156),(6275522,52689585,2,157),(6275522,52689586,2,158),(6275522,52689589,2,159),(6275522,52689591,2,160),(6275522,52689593,2,161),(6275522,52689594,2,162),(6275522,52689596,2,163),(6275522,52689600,2,164),(6275522,52689603,2,165),(6275522,52689604,2,166),(6275522,52689607,2,167),(6275522,52689608,2,168),(6275522,52689609,2,169),(6275522,52689610,2,170),(6275522,52689612,2,171),(6275522,52689613,2,172),(6275522,52689615,2,173),(6275522,52689617,2,174),(6275522,52689618,2,175),(6275522,52689619,2,176),(6275522,52689621,2,177),(6275522,52689624,2,178),(6275522,52689627,2,179),(6275522,52689629,2,180),(6275522,52689631,2,181),(6275522,52743899,2,182),(6275522,51412105,2,183),(6275522,52689635,2,184),(6275522,52689639,2,185),(6275522,52689643,2,186),(6275522,52689647,2,187),(6275522,52689650,2,188),(6275522,52689653,2,189),(6275522,52689656,2,190),(6275522,52689659,2,191),(6275522,52689661,2,192),(6275522,52689663,2,193),(6275522,52689665,2,194),(6275522,52689666,2,195),(6275522,52689670,2,196),(6275522,52689673,2,197),(6275522,52689676,2,198),(6275522,52689679,2,199),(6275522,52689681,2,200),(6275522,52689684,2,201),(6275522,52689687,2,202),(6275522,52689689,2,203),(6275522,52689692,2,204),(6275522,52689696,2,205),(6275522,52689699,2,206),(6275522,52689701,2,207),(6275522,52689705,2,208),(6275522,52689707,2,209),(6275522,52689709,2,210),(6275522,52689713,2,211),(6275522,52689714,2,212),(6275522,52689718,2,213),(6275522,52689720,2,214),(6275522,52689723,2,215),(6275522,52689724,2,216),(6275522,52689728,2,217),(6275522,52689731,2,218),(6275522,52689733,2,219),(6275522,52689226,2,220),(6275851,52733171,2,1),(6275851,52733173,2,2),(6275851,52733177,2,3),(6275851,52733181,2,4),(6275851,52733186,2,5),(6275851,52733193,2,6),(6275851,52733201,2,7),(6275851,52733204,2,8),(6275851,52733206,2,9),(6275851,52733209,2,10),(6275851,52733212,2,11),(6275851,52733215,2,12),(6275851,52733218,2,13),(6275851,52733223,2,14),(6276661,52744177,4,1),(6276661,52744180,4,2),(6276661,52744181,4,3),(6276661,52744184,4,4),(6276661,52744187,4,5),(6276661,52744189,4,6),(6276661,52744190,4,7),(6276661,52744193,4,8),(6276661,52744196,4,9),(6276661,52744198,4,10),(6276661,52744201,4,11),(6276661,52744202,4,12),(6276661,52744205,4,13),(6276661,52744206,4,14),(6276661,52744209,4,15),(6276661,52744212,4,16),(6276661,52744213,4,17),(6276661,52744214,4,18),(6276661,52744218,4,19),(6276661,52744219,4,20),(6276661,52744222,4,21),(6276661,52744223,4,22),(6276661,52744227,4,23),(6276661,52744228,4,24),(6276661,52744231,4,25),(6276661,52744232,4,26),(6276661,52744236,4,27),(6276661,52744237,4,28),(6276661,52744238,4,29),(6276661,52744240,4,30),(6276661,52744241,4,31),(6276661,52744245,4,32),(6276661,52744246,4,33),(6276661,52744249,4,34),(6276661,52744250,4,35),(6276661,52744253,4,36),(6276661,52744254,4,37),(6276661,52744257,4,38),(6276661,52744259,4,39),(6276661,52744260,4,40),(6276661,52744262,4,41),(6276661,52744264,4,42),(6276661,52744265,4,43),(6276661,52744268,4,44),(6276661,52744270,4,45),(6276661,52744272,4,46),(6276661,52744274,4,47),(6276661,52744277,4,48),(6276661,52744279,4,49),(6276661,52744281,4,50),(6276661,52744284,4,51),(6276661,52744286,4,52),(6276661,52744289,4,53),(6276661,52744292,4,54),(6276661,52744294,4,55),(6276661,52744296,4,56),(6276661,52744298,4,57),(6276661,52744301,4,58),(6276661,52744303,4,59),(6276661,52744306,4,60),(6276661,52744308,4,61),(6276661,52744309,4,62),(6276661,52744312,4,63),(6276661,52744313,4,64),(6276661,52744315,4,65),(6276661,52744318,4,66),(6276661,52744320,4,67),(6276661,52744323,4,68),(6276661,52744326,4,69),(6276661,52744329,4,70),(6276661,52744330,4,71),(6276661,52744333,4,72),(6276661,52744334,4,73),(6276661,52744337,4,74),(6276661,52744342,4,75),(6276661,52744339,4,76),(6276661,52744344,4,77),(6276661,52744346,4,78),(6276661,52744349,4,79),(6276661,52744350,4,80),(6276661,52744352,4,81),(6276661,52744356,4,82),(6276661,52744359,4,83),(6276661,52744360,4,84),(6276661,52744364,4,85),(6276661,52744365,4,86),(6276661,52744368,4,87),(6276661,52744370,4,88),(6276661,52744372,4,89),(6276661,52744375,4,90),(6276661,52744378,4,91),(6276661,52744379,4,92),(6276661,52744383,4,93),(6276661,52744385,4,94),(6276661,52744387,4,95),(6276661,52744390,4,96),(6276661,52744392,4,97),(6276661,52744394,4,98),(6276661,52744396,4,99),(6276661,52744399,4,100),(6276661,52744400,4,101),(6276661,52744402,4,102),(6276661,52744405,4,103),(6276661,52744409,4,104),(6276661,52744411,4,105),(6276661,52744413,4,106),(6276661,52744416,4,107),(6276661,52744418,4,108),(6276661,52744420,4,109),(6276661,52744423,4,110),(6276661,52744426,4,111),(6276661,52744429,4,112),(6276661,52744432,4,113),(6276661,52744434,4,114),(6276661,52744437,4,115),(6276661,52744439,4,116),(6276661,52744440,4,117),(6276661,52744443,4,118),(6276661,52744446,4,119),(6276661,52744447,4,120),(6276661,52744450,4,121),(6276661,52744452,4,122),(6276661,52744455,4,123),(6276661,52744457,4,124),(6276661,52744460,4,125),(6276661,52744462,4,126),(6276661,52744464,4,127),(6276661,52744468,4,128),(6276661,52744471,4,129),(6276661,52744473,4,130),(6276661,52744475,4,131),(6276661,52743859,4,132),(6276661,52743862,4,133),(6276661,52743866,4,134),(6276661,52743871,4,135),(6276661,52743874,4,136),(6276661,52743875,4,137),(6276661,52743878,4,138),(6276661,52743880,4,139),(6276661,52743882,4,140),(6276661,52743884,4,141),(6276661,52743887,4,142),(6276661,52744177,4,143),(6277172,52747815,1,1),(6277172,52747820,1,2),(6277172,52747826,1,3),(6277172,52747832,1,4),(6277172,52747838,1,5),(6277172,52747841,1,6),(6277172,52747846,1,7),(6277172,52747849,1,8),(6277172,52747852,1,9),(6277172,52747855,1,10),(6277172,52747857,1,11),(6277172,52747861,1,12),(6277172,52747863,1,13),(6277172,52747865,1,14),(6277172,52747867,1,15),(6277172,52747869,1,16),(6277172,52747872,1,17),(6277172,52747876,1,18),(6277172,52747878,1,19),(6277172,52747881,1,20),(6277172,52747884,1,21),(6277172,52747885,1,22),(6277172,52747888,1,23),(6277172,52747890,1,24),(6277172,52747893,1,25),(6277172,52747898,1,26),(6277172,52747901,1,27),(6277172,52748785,1,28),(6277172,52748790,1,29),(6277172,52748831,1,30),(6277172,52748833,1,31),(6277172,52748835,1,32),(6277172,52748837,1,33),(6277172,52749087,1,34),(6277172,52749143,1,35),(6277172,52749145,1,36),(6277172,52749150,1,37),(6277172,52749155,1,38),(6277172,52749158,1,39),(6277172,52749159,1,40),(6277172,52749162,1,41),(6277172,52749165,1,42),(6277172,52749169,1,43),(6277172,52749171,1,44),(6277172,52749174,1,45),(6277172,52749175,1,46),(6277172,52749183,1,47),(6277172,52749184,1,48),(6277172,52749185,1,49),(6277172,52749189,1,50),(6277172,52749191,1,51),(6277172,52749208,1,52),(6277172,52749211,1,53),(6277172,52749214,1,54),(6277172,52749218,1,55),(6277172,52749220,1,56),(6277172,52749224,1,57),(6277172,52749225,1,58),(6277172,52749228,1,59),(6277172,52749231,1,60),(6277172,52749233,1,61),(6277172,52749238,1,62),(6277172,52749240,1,63),(6277172,52749243,1,64),(6277172,52749244,1,65),(6277172,52749247,1,66),(6277172,52749251,1,67),(6277172,52749255,1,68),(6277172,52749256,1,69),(6277172,52749259,1,70),(6277172,52749261,1,71),(6277172,52749263,1,72),(6277172,52747815,1,73),(6277173,52749266,1,1),(6277173,52749268,1,2),(6277173,52749271,1,3),(6277173,52749275,1,4),(6277173,52749276,1,5),(6277173,52749280,1,6),(6277173,52749282,1,7),(6277173,52749284,1,8),(6277173,52749285,1,9),(6277173,52749288,1,10),(6277173,52749289,1,11),(6277173,52749309,1,12),(6277173,52749310,1,13),(6277173,52749312,1,14),(6277173,52749314,1,15),(6277173,52749316,1,16),(6277173,52749321,1,17),(6277173,52749324,1,18),(6277173,52749326,1,19),(6277173,52749328,1,20),(6277173,52749331,1,21),(6277173,52749334,1,22),(6277173,52749340,1,23),(6277173,52749341,1,24),(6277173,52749343,1,25),(6277173,52749347,1,26),(6277173,52749349,1,27),(6277173,52749352,1,28),(6277173,52749354,1,29),(6277173,52749357,1,30),(6277173,52749359,1,31),(6277173,52749363,1,32),(6277173,52749366,1,33),(6277173,52749368,1,34),(6277173,52749371,1,35),(6277173,52749376,1,36),(6277173,52749379,1,37),(6277173,52749381,1,38),(6277173,52749385,1,39),(6277173,52749386,1,40),(6277173,52749387,1,41),(6277173,52749389,1,42),(6277173,52749391,1,43),(6277173,52749393,1,44),(6277173,52749396,1,45),(6277173,52749398,1,46),(6277173,52749400,1,47),(6277173,52749402,1,48),(6277173,52749404,1,49),(6277173,52749407,1,50),(6277173,52749410,1,51),(6277173,52749412,1,52),(6277173,52749414,1,53),(6277173,52749416,1,54),(6277173,52749419,1,55),(6277173,52749421,1,56),(6277173,52749424,1,57),(6277173,52749428,1,58),(6277173,52749430,1,59),(6277173,52749433,1,60),(6277173,52749436,1,61),(6277173,52749439,1,62),(6277173,52749441,1,63),(6277173,52749443,1,64),(6277173,52749448,1,65),(6277173,52749451,1,66),(6277173,52749455,1,67),(6277173,52749458,1,68),(6277173,52749460,1,69),(6277173,52749462,1,70),(6277173,52749465,1,71),(6277173,52749469,1,72),(6277173,52749472,1,73),(6277173,52749474,1,74),(6277173,52749475,1,75),(6277173,52749479,1,76),(6277173,52749482,1,77),(6277173,52749485,1,78),(6277173,52749487,1,79),(6277173,52749490,1,80),(6277173,52749491,1,81),(6277173,52749492,1,82),(6277173,52749496,1,83),(6277173,52749497,1,84),(6277173,52749499,1,85),(6277173,52749502,1,86),(6277173,52749503,1,87),(6277173,52749505,1,88),(6277173,52749508,1,89),(6277173,52749509,1,90),(6277173,52749511,1,91),(6277173,52749514,1,92),(6277173,52749517,1,93),(6277173,52749266,1,94),(6279235,52769493,1,1),(6279235,52769332,1,2),(6279235,52769338,1,3),(6279235,52769340,1,4),(6279235,52769343,1,5),(6279235,52769346,1,6),(6279235,52769349,1,7),(6279235,52769352,1,8),(6279235,52769355,1,9),(6279235,52769357,1,10),(6279235,52769358,1,11),(6279235,52769361,1,12),(6279235,52769364,1,13),(6279235,52769366,1,14),(6279235,52769367,1,15),(6279235,52769369,1,16),(6279235,52769371,1,17),(6279235,52769373,1,18),(6279235,52769374,1,19),(6279235,52769377,1,20),(6279235,52769380,1,21),(6279235,52769381,1,22),(6279235,52769384,1,23),(6279235,52769387,1,24),(6279235,52769389,1,25),(6279235,52769392,1,26),(6279235,52769395,1,27),(6279235,52769397,1,28),(6279235,52769401,1,29),(6279235,52769406,1,30),(6279235,52769411,1,31),(6279235,52769413,1,32),(6279235,52769415,1,33),(6279235,52769418,1,34),(6279235,52769419,1,35),(6279235,52769420,1,36),(6279235,52769423,1,37),(6279235,52769425,1,38),(6279235,52769427,1,39),(6279235,52769431,1,40),(6279235,52769436,1,41),(6279235,52769439,1,42),(6279235,52769441,1,43),(6279235,52769444,1,44),(6279235,52769447,1,45),(6279235,52769450,1,46),(6279235,52769452,1,47),(6279235,52769456,1,48),(6279235,52769457,1,49),(6279235,52769460,1,50),(6279235,52769465,1,51),(6279235,52769471,1,52),(6279235,52769477,1,53),(6279235,52769479,1,54),(6279235,52769482,1,55),(6279235,52769485,1,56),(6279235,52769488,1,57),(6279235,52769491,1,58),(6279235,52769493,1,59),(6281014,52804805,2,1),(6281014,52804803,2,2),(6281014,52804172,2,3),(6281014,52804167,2,4),(6281014,52804163,2,5),(6281014,52804160,2,6),(6281014,52804150,2,7),(6281014,52804145,2,8),(6281014,52804143,2,9),(6281014,52804142,2,10),(6281014,52804141,2,11),(6281014,52804140,2,12),(6281014,52804139,2,13),(6281014,52804138,2,14),(6281014,52804137,2,15),(6281014,52804136,2,16),(6281014,52804135,2,17),(6281014,52804134,2,18),(6281014,52804133,2,19),(6281014,52804132,2,20),(6281014,52804131,2,21),(6281014,52804130,2,22),(6281014,52804052,2,23),(6281014,52804050,2,24),(6281014,52804046,2,25),(6281014,52804043,2,26),(6281014,52804041,2,27),(6281014,52804038,2,28),(6281014,52804036,2,29),(6281014,52804033,2,30),(6281014,52804030,2,31),(6281014,52804028,2,32),(6281014,52804026,2,33),(6281014,52804024,2,34),(6281014,52804021,2,35),(6281014,52804018,2,36),(6281014,52804014,2,37),(6281014,52804010,2,38),(6281014,52804005,2,39),(6281014,52804002,2,40),(6281014,52803998,2,41),(6281014,52803995,2,42),(6281014,52803992,2,43),(6281014,52803988,2,44),(6281014,52803983,2,45),(6281014,52803396,2,46),(6281014,52803393,2,47),(6281014,52803391,2,48),(6281014,52803388,2,49),(6281014,52803385,2,50),(6281014,52803382,2,51),(6281014,52803378,2,52),(6281014,52803374,2,53),(6281014,52803372,2,54),(6281014,52803370,2,55),(6281014,52803368,2,56),(6281014,52803365,2,57),(6281014,52803363,2,58),(6281014,52803358,2,59),(6281014,52803353,2,60),(6281014,52803351,2,61),(6281014,52801221,2,62),(6281014,52801220,2,63),(6281014,52801218,2,64),(6281014,52801217,2,65),(6281014,52801215,2,66),(6281014,52801212,2,67),(6281014,52801209,2,68),(6281014,52801207,2,69),(6281014,52801203,2,70),(6281014,52801198,2,71),(6281014,52801195,2,72),(6281014,52801192,2,73),(6281014,52801190,2,74),(6281014,52801184,2,75),(6281014,52801182,2,76),(6281014,52801181,2,77),(6281014,52801178,2,78),(6281014,52801176,2,79),(6281014,52801175,2,80),(6281014,52801173,2,81),(6281014,52801172,2,82),(6281014,52801170,2,83),(6281014,52801168,2,84),(6281014,52801167,2,85),(6281014,52801166,2,86),(6281014,52801164,2,87),(6281014,52801158,2,88),(6281014,52801157,2,89),(6281014,52801153,2,90),(6281014,52801010,2,91),(6281014,52801007,2,92),(6281014,52801004,2,93),(6281014,52801001,2,94),(6281014,52800998,2,95),(6281014,52800995,2,96),(6281014,52800993,2,97),(6281014,52800990,2,98),(6281014,52800987,2,99),(6281014,52800985,2,100),(6281014,52800981,2,101),(6281014,52800978,2,102),(6281014,52800974,2,103),(6281014,52800970,2,104),(6281014,52800967,2,105),(6281014,52800964,2,106),(6281014,52800960,2,107),(6281014,52801750,2,108),(6281014,52800952,2,109),(6281014,52800948,2,110),(6281014,52800957,2,111),(6281014,52800944,2,112),(6281014,52800938,2,113),(6281014,52800909,2,114),(6281014,52800845,2,115),(6281014,52800828,2,116),(6281014,52800821,2,117),(6281014,52800813,2,118),(6281014,52800794,2,119),(6281014,52800691,2,120),(6281014,52800686,2,121),(6281014,52800683,2,122),(6281014,52800681,2,123),(6281014,52800677,2,124),(6281014,52800673,2,125),(6281014,52800670,2,126),(6281014,52800668,2,127),(6281014,52800667,2,128),(6281014,52800665,2,129),(6281014,52800664,2,130),(6281014,52800661,2,131),(6281014,52800656,2,132),(6281014,52800652,2,133),(6281014,52800651,2,134),(6281014,52800647,2,135),(6281014,52800645,2,136),(6281014,52800642,2,137),(6281014,52800638,2,138),(6281014,52800634,2,139),(6281014,52800630,2,140),(6281014,52800628,2,141),(6281014,52800626,2,142),(6281014,52800625,2,143),(6281014,52800623,2,144),(6281014,52800622,2,145),(6281014,52800619,2,146),(6281014,52800618,2,147),(6281014,52800614,2,148),(6281014,52800610,2,149),(6281014,52800608,2,150),(6281014,52800606,2,151),(6281014,52800602,2,152),(6281014,52800599,2,153),(6281014,52800596,2,154),(6281014,52800592,2,155),(6281014,52800590,2,156),(6281015,52801741,2,1),(6281015,52801737,2,2),(6281015,52801733,2,3),(6281015,52801729,2,4),(6281015,52801725,2,5),(6281015,52801722,2,6),(6281015,52801719,2,7),(6281015,52801715,2,8),(6281015,52801710,2,9),(6281015,52801707,2,10),(6281015,52801704,2,11),(6281015,52801701,2,12),(6281015,52801699,2,13),(6281015,52801695,2,14),(6281015,52801691,2,15),(6281015,52801688,2,16),(6281015,52801684,2,17),(6281015,52801683,2,18),(6281015,52801679,2,19),(6281015,52801674,2,20),(6281015,52801672,2,21),(6281015,52801668,2,22),(6281015,52801664,2,23),(6281015,52801663,2,24),(6281015,52801660,2,25),(6281015,52801657,2,26),(6281015,52801654,2,27),(6281015,52801652,2,28),(6281015,52801648,2,29),(6281015,52801643,2,30),(6281015,52801640,2,31),(6281015,52801618,2,32),(6281015,52801587,2,33);
INSERT INTO `way_nodes` VALUES (6281015,52801585,2,34),(6281015,52801584,2,35),(6281015,52801581,2,36),(6281015,52801578,2,37),(6281015,52801576,2,38),(6281015,52801573,2,39),(6281015,52801571,2,40),(6281015,52801569,2,41),(6281015,52801566,2,42),(6281015,52801561,2,43),(6281015,52801558,2,44),(6281015,52801555,2,45),(6281015,52801551,2,46),(6281015,52801548,2,47),(6281015,52801545,2,48),(6281015,52801542,2,49),(6281015,52801538,2,50),(6281015,52801534,2,51),(6281015,52801531,2,52),(6281015,52801527,2,53),(6281015,52801526,2,54),(6281015,52801524,2,55),(6281015,52801522,2,56),(6281015,52801520,2,57),(6281015,52801518,2,58),(6281015,52801516,2,59),(6281015,52801514,2,60),(6281015,52801506,2,61),(6281015,52801494,2,62),(6281015,52801487,2,63),(6281015,52801480,2,64),(6281015,52801477,2,65),(6281015,52801475,2,66),(6281015,52801469,2,67),(6281015,52801468,2,68),(6281015,52801465,2,69),(6281015,52801462,2,70),(6281015,52801461,2,71),(6281015,52801456,2,72),(6281015,52801453,2,73),(6281015,52801451,2,74),(6281015,52801447,2,75),(6281015,52801446,2,76),(6281015,52801444,2,77),(6281015,52801441,2,78),(6281015,52801439,2,79),(6281015,52801437,2,80),(6281015,52801435,2,81),(6281015,52801433,2,82),(6281015,52801431,2,83),(6281015,52801429,2,84),(6281015,52801427,2,85),(6281015,52801425,2,86),(6281015,52801422,2,87),(6281015,52801418,2,88),(6281015,52801417,2,89),(6281015,52801413,2,90),(6281015,52801407,2,91),(6281015,52801404,2,92),(6281015,52801402,2,93),(6281015,52801397,2,94),(6281015,52801396,2,95),(6281015,52801392,2,96),(6281015,52801389,2,97),(6281015,52801384,2,98),(6281015,52801380,2,99),(6281015,52801376,2,100),(6281015,52801374,2,101),(6281015,52801372,2,102),(6281015,52801370,2,103),(6281015,52801368,2,104),(6281015,52801366,2,105),(6281015,52801364,2,106),(6281015,52801363,2,107),(6281015,52801362,2,108),(6281015,52801361,2,109),(6281015,52801360,2,110),(6281015,52801359,2,111),(6281015,52801358,2,112),(6281015,52801357,2,113),(6281015,52801356,2,114),(6281015,52801355,2,115),(6281015,52801354,2,116),(6281015,52801353,2,117),(6281015,52801352,2,118),(6281015,52801350,2,119),(6281015,52801348,2,120),(6281015,52801345,2,121),(6281015,52801344,2,122),(6281015,52801341,2,123),(6281015,52801339,2,124),(6281015,52801336,2,125),(6281015,52801333,2,126),(6281015,52801331,2,127),(6281015,52801330,2,128),(6281015,52801328,2,129),(6281015,52801326,2,130),(6281015,52801324,2,131),(6281015,52801323,2,132),(6281015,52801321,2,133),(6281015,52801319,2,134),(6281015,52801317,2,135),(6281015,52801316,2,136),(6281015,52801314,2,137),(6281015,52801313,2,138),(6281015,52801311,2,139),(6281015,52801309,2,140),(6281015,52801307,2,141),(6281015,52801305,2,142),(6281015,52801303,2,143),(6281015,52801301,2,144),(6281015,52801299,2,145),(6281015,52801298,2,146),(6281015,52801295,2,147),(6281015,52801293,2,148),(6281015,52801291,2,149),(6281015,52801289,2,150),(6281015,52801287,2,151),(6281015,52801284,2,152),(6281015,52801283,2,153),(6281015,52801279,2,154),(6281015,52801274,2,155),(6281015,52801273,2,156),(6281015,52801269,2,157),(6281015,52801265,2,158),(6281015,52801262,2,159),(6281015,52801258,2,160),(6281015,52801254,2,161),(6281015,52801251,2,162),(6281015,52801248,2,163),(6281015,52801247,2,164),(6281015,52801234,2,165),(6281015,52801233,2,166),(6281015,52801231,2,167),(6281015,52801228,2,168),(6281015,52801226,2,169),(6281015,52801223,2,170),(6281015,52803399,2,171),(6281015,52803402,2,172),(6281015,52803405,2,173),(6281015,52803937,2,174),(6281015,52803980,2,175),(6281015,52803938,2,176),(6281015,52803940,2,177),(6281015,52803941,2,178),(6281015,52803943,2,179),(6281015,52803944,2,180),(6281015,52803954,2,181),(6281015,52803955,2,182),(6281015,52803956,2,183),(6281015,52803958,2,184),(6281015,52803959,2,185),(6281015,52803961,2,186),(6281015,52803962,2,187),(6281015,52803965,2,188),(6281015,52803969,2,189),(6281015,52803973,2,190),(6281015,52803976,2,191),(6281015,52804055,2,192),(6281015,52804060,2,193),(6281015,52804062,2,194),(6281015,52804065,2,195),(6281015,52804069,2,196),(6281015,52804073,2,197),(6281015,52804077,2,198),(6281015,52804081,2,199),(6281015,52804084,2,200),(6281015,52804087,2,201),(6281015,52804090,2,202),(6281015,52804091,2,203),(6281015,52804093,2,204),(6281015,52804096,2,205),(6281015,52804100,2,206),(6281015,52804101,2,207),(6281015,52804106,2,208),(6281015,52804109,2,209),(6281015,52804112,2,210),(6281015,52804114,2,211),(6281015,52804117,2,212),(6281015,52804118,2,213),(6281015,52804119,2,214),(6281015,52804120,2,215),(6281015,52804121,2,216),(6281015,52804122,2,217),(6281015,52804123,2,218),(6281015,52804124,2,219),(6281015,52804125,2,220),(6281015,52804126,2,221),(6281015,52804127,2,222),(6281015,52804128,2,223),(6281015,52804129,2,224),(6281015,52804173,2,225),(6281015,52804176,2,226),(6281015,52804216,2,227),(6281015,52804228,2,228),(6281015,52804233,2,229),(6281015,52804235,2,230),(6281015,52804237,2,231),(6281015,52804272,2,232),(6281015,52804275,2,233),(6281015,52804279,2,234),(6281015,52804292,2,235),(6281015,52804295,2,236),(6281015,52804297,2,237),(6281015,52804298,2,238),(6281015,52804299,2,239),(6281015,52804736,2,240),(6281015,52804739,2,241),(6281015,52804766,2,242),(6281015,52804772,2,243),(6281015,52804776,2,244),(6281015,52804777,2,245),(6281015,52804778,2,246),(6281015,52804779,2,247),(6281015,52804780,2,248),(6281015,52804788,2,249),(6281015,52804791,2,250),(6281015,52804795,2,251),(6281015,52804796,2,252),(6281015,52804798,2,253),(6281015,52804801,2,254),(6281015,52804807,2,255),(6281015,52804809,2,256),(6281015,52804811,2,257),(6281015,52804813,2,258),(6281015,52804815,2,259),(6281016,52801747,3,1),(6281016,52801744,3,2),(6281016,52801752,3,3),(6281016,52801754,3,4),(6281016,52801756,3,5),(6281016,52801757,3,6),(6281016,52801758,3,7),(6281016,52801759,3,8),(6281016,52801760,3,9),(6281016,52801761,3,10),(6281016,52801762,3,11),(6281016,52801764,3,12),(6281016,52801765,3,13),(6281016,52801768,3,14),(6281016,52801769,3,15),(6281016,52801771,3,16),(6281016,52801772,3,17),(6281016,52801774,3,18),(6281016,52801776,3,19),(6281016,52801777,3,20),(6281016,52801780,3,21),(6281016,52801781,3,22),(6281016,52801783,3,23),(6281016,52801785,3,24),(6281016,52801787,3,25),(6281016,52801788,3,26),(6281016,52801791,3,27),(6281016,52801792,3,28),(6281016,52801794,3,29),(6281016,52801796,3,30),(6281016,52801807,3,31),(6281017,52803309,2,1),(6281017,52803304,2,2),(6281017,52803300,2,3),(6281017,52803297,2,4),(6281017,52803289,2,5),(6281017,52803285,2,6),(6281017,52803283,2,7),(6281017,52803277,2,8),(6281017,52803280,2,9),(6281017,52803311,2,10),(6281017,52803313,2,11),(6281017,52803316,2,12),(6281017,52803319,2,13),(6281017,52803320,2,14),(6281017,52803323,2,15),(6281017,52803325,2,16),(6281017,52803327,2,17),(6281018,52803328,2,1),(6281018,52803331,2,2),(6281018,52803333,2,3),(6281018,52803336,2,4),(6281018,52803337,2,5),(6281018,52803338,2,6),(6281018,52803340,2,7),(6281018,52803343,2,8),(6281018,52803346,2,9),(6281018,52803349,2,10),(6281018,52802158,2,11),(6281019,52800586,3,1),(6281019,52800584,3,2),(6281019,52800580,3,3),(6281019,52800536,3,4),(6281019,52800529,3,5),(6281019,52800416,3,6),(6281019,52800405,3,7),(6281019,52800400,3,8),(6281019,52800388,3,9),(6281019,52800211,3,10),(6281019,52800033,3,11),(6281019,52799985,3,12),(6281019,52799709,3,13),(6281019,52798676,3,14),(6281019,52797555,3,15),(6281019,52797303,3,16),(6281019,52797286,3,17),(6281019,52797278,3,18),(6281019,52797275,3,19),(6281019,52797270,3,20),(6281019,52797269,3,21),(6281019,52797268,3,22),(6281019,52797267,3,23),(6281019,52797105,3,24),(6281019,52797069,3,25),(6281019,52797051,3,26),(6281019,52797049,3,27),(6281019,52796991,3,28),(6281019,52792210,3,29),(6281019,52792205,3,30),(6281019,52792202,3,31),(6281019,52792199,3,32),(6281019,52792196,3,33),(6281019,52792194,3,34),(6281019,52792192,3,35),(6281019,52792189,3,36),(6281019,52792187,3,37),(6281019,52792185,3,38),(6281019,52792182,3,39),(6281019,52792180,3,40),(6281019,52792177,3,41),(6281019,52792159,3,42),(6281019,52792158,3,43),(6281019,52792095,3,44),(6281019,52792098,3,45),(6281019,52792102,3,46),(6281019,52792111,3,47),(6281019,52792113,3,48),(6281019,52792114,3,49),(6281019,52792117,3,50),(6281019,52792122,3,51),(6281020,52800590,3,1),(6281020,52800586,3,2),(6281021,52801750,2,1),(6281021,52801749,2,2),(6281022,52801749,3,1),(6281022,52801747,3,2),(6281358,52812261,4,1),(6281358,52812263,4,2),(6281358,52812266,4,3),(6281358,52812268,4,4),(6281358,52812270,4,5),(6281358,52812274,4,6),(6281358,52812277,4,7),(6281358,52812281,4,8),(6281358,52812284,4,9),(6281358,52812288,4,10),(6281358,52812291,4,11),(6281358,52812295,4,12),(6281358,52812296,4,13),(6281358,52812299,4,14),(6281358,52812303,4,15),(6281358,52812305,4,16),(6281358,52812309,4,17),(6281358,52812311,4,18),(6281358,52812315,4,19),(6281358,52812318,4,20),(6281358,52812321,4,21),(6281358,52812323,4,22),(6281358,52812326,4,23),(6281358,52812329,4,24),(6281358,52812331,4,25),(6281358,52812333,4,26),(6281358,52812335,4,27),(6281358,52812338,4,28),(6281358,52812341,4,29),(6281358,52812343,4,30),(6281358,52812347,4,31),(6281358,52812350,4,32),(6281358,52812353,4,33),(6281358,52812356,4,34),(6281358,52812360,4,35),(6281358,52812363,4,36),(6281358,52812365,4,37),(6281358,52812366,4,38),(6281358,52812367,4,39),(6281358,52812369,4,40),(6281358,52812372,4,41),(6281358,52812376,4,42),(6281358,52812379,4,43),(6281358,52812380,4,44),(6281358,52812383,4,45),(6281358,52812385,4,46),(6281358,52812387,4,47),(6281358,52812389,4,48),(6281358,52812391,4,49),(6281358,52812395,4,50),(6281358,52812397,4,51),(6281358,52812399,4,52),(6281358,52812403,4,53),(6281358,52812405,4,54),(6281358,52812406,4,55),(6281358,52812407,4,56),(6281358,52812410,4,57),(6281358,52812409,4,58),(6281358,52812411,4,59),(6281358,52812413,4,60),(6281358,52812414,4,61),(6281358,52812415,4,62),(6281358,52812417,4,63),(6281358,52812418,4,64),(6281358,52812421,4,65),(6281358,52812425,4,66),(6281358,52812428,4,67),(6281358,52812440,4,68),(6281358,52812444,4,69),(6281358,52812447,4,70),(6281360,52812447,2,1),(6281360,52812450,2,2),(6281360,52812453,2,3),(6281360,52812457,2,4),(6281360,52812460,2,5),(6281360,52812464,2,6),(6281360,52812468,2,7),(6281360,52812472,2,8),(6281360,52812475,2,9),(6281360,52812478,2,10),(6281360,52812481,2,11),(6281360,52812485,2,12),(6281360,52812487,2,13),(6281360,52812491,2,14),(6281360,52812494,2,15),(6281360,52812497,2,16),(6281360,52812501,2,17),(6281360,52812505,2,18),(6281360,52812507,2,19),(6281360,52812511,2,20),(6281360,52812514,2,21),(6281360,52812517,2,22),(6281360,52812520,2,23),(6281360,52812522,2,24),(6281361,52812447,2,1),(6281361,52812526,2,2),(6281361,52812530,2,3),(6281361,52812531,2,4),(6281361,52812534,2,5),(6281361,52812536,2,6),(6281361,52812537,2,7),(6281361,52812540,2,8),(6281361,52812541,2,9),(6281361,52812543,2,10),(6281361,52812545,2,11),(6281361,52812547,2,12),(6281361,52812549,2,13),(6281361,52812551,2,14),(6281361,52812553,2,15),(6281361,52812555,2,16),(6281361,52812558,2,17),(6281361,52812562,2,18),(6281361,52812564,2,19),(6281361,52812566,2,20),(6281361,52812569,2,21),(6281361,52812572,2,22),(6281361,52812574,2,23),(6281361,52812577,2,24),(6281361,52812580,2,25),(6281361,52812582,2,26),(6281361,52812585,2,27),(6281361,52812587,2,28),(6281361,52812590,2,29),(6281361,52812592,2,30),(6281361,52812595,2,31),(6281361,52812597,2,32),(6281361,52812598,2,33),(6281741,52818308,2,1),(6281741,52818311,2,2),(6281741,52818312,2,3),(6281741,52818315,2,4),(6281741,52818317,2,5),(6281741,52818320,2,6),(6281741,52818322,2,7),(6281741,52818324,2,8),(6281741,52818326,2,9),(6281741,52818330,2,10),(6281741,52818332,2,11),(6281741,52818334,2,12),(6281741,52818337,2,13),(6281741,52818340,2,14),(6281741,52818343,2,15),(6281741,52818346,2,16),(6281741,52818348,2,17),(6281741,52818350,2,18),(6281741,52818352,2,19),(6281741,52812315,2,20),(6281751,53273756,2,1),(6281751,53273781,2,2),(6281751,53273780,2,3),(6281751,53273779,2,4),(6281751,53273778,2,5),(6281751,53273777,2,6),(6281751,53273776,2,7),(6281751,53273775,2,8),(6281751,53273774,2,9),(6281751,53273773,2,10),(6281751,53273772,2,11),(6281751,53273771,2,12),(6281751,53273770,2,13),(6281751,53273769,2,14),(6281751,53273768,2,15),(6281751,53273767,2,16),(6281751,53273766,2,17),(6281751,53273765,2,18),(6281751,53273764,2,19),(6281751,53273763,2,20),(6281751,53273762,2,21),(6281751,53273761,2,22),(6281751,53273760,2,23),(6281751,53273759,2,24),(6281751,53273758,2,25),(6281751,53273757,2,26),(6281751,52818355,2,27),(6281751,52818358,2,28),(6281751,52818362,2,29),(6281751,52818365,2,30),(6281751,52818368,2,31),(6281751,52818370,2,32),(6281751,52818373,2,33),(6281751,52818377,2,34),(6281751,52818379,2,35),(6281751,52818382,2,36),(6281751,52818384,2,37),(6281751,52818385,2,38),(6281751,52818387,2,39),(6281751,52818389,2,40),(6281751,52818390,2,41),(6281751,52818391,2,42),(6281751,52818392,2,43),(6281751,52818393,2,44),(6281751,52818394,2,45),(6281751,52818396,2,46),(6281751,52818397,2,47),(6281751,52818398,2,48),(6281751,52818399,2,49),(6281751,52818402,2,50),(6281751,52818404,2,51),(6281751,52818405,2,52),(6281751,52818406,2,53),(6281751,52818407,2,54),(6281751,52818409,2,55),(6281751,52818413,2,56),(6281751,52818415,2,57),(6281751,52818417,2,58),(6281751,52818420,2,59),(6281751,52818424,2,60),(6281751,52818427,2,61),(6281751,52818428,2,62),(6281751,52818432,2,63),(6281751,52818434,2,64),(6281751,52818437,2,65),(6281751,52818440,2,66),(6281751,52818441,2,67),(6281751,52818445,2,68),(6281751,52818446,2,69),(6281751,52818448,2,70),(6281751,52818450,2,71),(6281751,52818451,2,72),(6281751,52818452,2,73),(6281751,52818453,2,74),(6281751,52818454,2,75),(6281751,52818455,2,76),(6281751,52818456,2,77),(6281751,52818457,2,78),(6281751,52818458,2,79),(6281751,52818461,2,80),(6281751,52818463,2,81),(6281751,52818465,2,82),(6281751,52818470,2,83),(6281751,52818472,2,84),(6281751,52818475,2,85),(6281751,52818478,2,86),(6281751,52818479,2,87),(6281751,52818483,2,88),(6281751,52818485,2,89),(6281751,52818487,2,90),(6281751,52818489,2,91),(6281751,52818490,2,92),(6281751,52818491,2,93),(6281751,52818493,2,94),(6281751,52818495,2,95),(6281751,52818498,2,96),(6281751,52818501,2,97),(6281751,52818503,2,98),(6281751,52818505,2,99),(6281751,52818508,2,100),(6281751,52818511,2,101),(6281751,52818514,2,102),(6281751,52818516,2,103),(6281751,52818518,2,104),(6281751,52818520,2,105),(6281751,52818522,2,106),(6281751,52818524,2,107),(6281751,52818527,2,108),(6281751,52818529,2,109),(6281751,52818533,2,110),(6281751,52818536,2,111),(6281751,52818538,2,112),(6281751,52818539,2,113),(6281751,52818542,2,114),(6281751,52818550,2,115),(6281751,52818553,2,116),(6281751,52818555,2,117),(6281751,52818557,2,118),(6281751,52818561,2,119),(6281751,52818563,2,120),(6281751,52818564,2,121),(6281751,52818566,2,122),(6281751,52818567,2,123),(6281751,52818569,2,124),(6281751,52818572,2,125),(6281751,52818574,2,126),(6281751,52818577,2,127),(6281751,52818581,2,128),(6281751,52818582,2,129),(6281751,52818585,2,130),(6281751,52818587,2,131),(6281751,52818590,2,132),(6281751,52818592,2,133),(6281751,52818594,2,134),(6281751,52818598,2,135),(6281751,52818600,2,136),(6281751,52818603,2,137),(6281751,52818605,2,138),(6281751,52818609,2,139),(6281751,52818612,2,140),(6281751,52818615,2,141),(6281751,52818618,2,142),(6281751,52818620,2,143),(6281751,52818622,2,144),(6281751,52818623,2,145),(6281751,52818627,2,146),(6281751,52818629,2,147),(6281751,52818631,2,148),(6281751,52818633,2,149),(6281751,52818635,2,150),(6281751,52818636,2,151),(6281751,52818639,2,152),(6281751,52818641,2,153),(6281751,52818642,2,154),(6281751,52818644,2,155),(6281751,52818647,2,156),(6281751,52818648,2,157),(6281751,52818651,2,158),(6281751,52818652,2,159),(6281751,52818655,2,160),(6281751,52818657,2,161),(6281751,52818659,2,162),(6281751,52818661,2,163),(6281751,52818663,2,164),(6281751,52818669,2,165),(6281751,52818671,2,166),(6281751,52818673,2,167),(6281751,52818675,2,168),(6281751,52818677,2,169),(6281751,52818679,2,170),(6281751,52818681,2,171),(6281751,52818685,2,172),(6281751,52818687,2,173),(6281751,52818690,2,174),(6281751,52818692,2,175),(6281751,52818694,2,176),(6281751,52818720,2,177),(6281751,52818722,2,178),(6281751,52818724,2,179),(6281751,52818727,2,180),(6281751,52818729,2,181),(6281751,52818731,2,182),(6281751,52818733,2,183),(6281751,52818747,2,184),(6281751,52818757,2,185),(6281751,52818771,2,186),(6281751,52818775,2,187),(6281751,52818781,2,188),(6281751,52818791,2,189),(6281751,52818794,2,190),(6281751,52818796,2,191),(6281751,52818800,2,192),(6281751,52818803,2,193),(6281751,52818808,2,194),(6281751,52818809,2,195),(6281751,52818810,2,196),(6281751,52818812,2,197),(6281751,52818813,2,198),(6281751,52818824,2,199),(6281751,52818840,2,200),(6281751,52818846,2,201),(6281751,52818850,2,202),(6281751,52818853,2,203),(6281751,52818857,2,204),(6281751,52818862,2,205),(6281751,52818864,2,206),(6281751,52818867,2,207),(6281774,52818870,1,1),(6281774,52818872,1,2),(6281774,52818874,1,3),(6281774,52818876,1,4),(6281774,52818878,1,5),(6281774,52818879,1,6),(6281774,52818881,1,7),(6281774,52818884,1,8),(6281774,52818810,1,9),(6281908,52824397,2,1),(6281908,52824401,2,2),(6281908,52824404,2,3),(6281908,52824407,2,4),(6281908,52824410,2,5),(6281908,52824414,2,6),(6281908,52824418,2,7),(6281908,52824420,2,8),(6281908,52824423,2,9),(6281908,52824433,2,10),(6281908,52824446,2,11),(6281908,52824449,2,12),(6281908,52824464,2,13),(6281908,52824474,2,14),(6281908,52824478,2,15),(6281908,52824483,2,16),(6281908,52824486,2,17),(6281908,52824489,2,18),(6281908,52824491,2,19),(6281908,52824494,2,20),(6281908,52824496,2,21),(6281908,52824499,2,22),(6281908,52824502,2,23),(6281908,52824509,2,24),(6281908,51121973,2,25),(6281909,52824529,2,1),(6281909,52824530,2,2),(6281909,52824533,2,3),(6281909,52824535,2,4),(6281909,52824538,2,5),(6281909,52824541,2,6),(6281909,52824544,2,7),(6281909,51121970,2,8),(6281910,52824546,2,1),(6281910,52824548,2,2),(6281910,52824552,2,3),(6281910,52824553,2,4),(6281910,52824558,2,5),(6281910,52824561,2,6),(6281910,52824564,2,7),(6281910,52824567,2,8),(6281910,52824569,2,9),(6281910,52824574,2,10),(6281910,52824576,2,11),(6281910,52824579,2,12),(6281910,52824581,2,13),(6281910,52824584,2,14),(6281910,52824586,2,15),(6281916,52824949,2,1),(6281916,52824952,2,2),(6281916,52824953,2,3),(6281916,52824954,2,4),(6281916,52824955,2,5),(6281916,51122830,2,6),(6282443,52831541,4,1),(6282443,52831545,4,2),(6282443,52831548,4,3),(6282443,52831550,4,4),(6282443,52831552,4,5),(6282443,52831554,4,6),(6282443,52831644,4,7),(6282443,52831559,4,8),(6282443,52831563,4,9),(6282443,52831566,4,10),(6282443,51122803,4,11),(6282444,52831569,2,1),(6282444,52831566,2,2),(6282445,52832045,3,1),(6282445,52831574,3,2),(6282445,52831577,3,3),(6282445,52831582,3,4),(6282445,52831585,3,5),(6282445,52831588,3,6),(6282445,52831590,3,7),(6282445,52831593,3,8),(6282445,52831595,3,9),(6282445,52831641,3,10),(6282445,52831598,3,11),(6282445,52831601,3,12),(6282445,52831638,3,13),(6282445,52831603,3,14),(6282446,52831605,2,1),(6282446,52831608,2,2),(6282446,52831611,2,3),(6282446,52831613,2,4),(6282446,52831614,2,5),(6282446,52831615,2,6),(6282446,52831616,2,7),(6282446,52831617,2,8),(6282446,52831601,2,9),(6282447,52831618,2,1),(6282447,52831619,2,2),(6282447,52831620,2,3),(6282447,52831621,2,4),(6282447,52831615,2,5),(6282448,52831620,2,1),(6282448,52831625,2,2),(6282448,52831627,2,3),(6282448,52831630,2,4),(6282448,52831633,2,5),(6282448,52831636,2,6),(6282448,52831638,2,7),(6282449,52831644,3,1),(6282449,52832041,3,2),(6282449,52832042,3,3),(6282449,52832043,3,4),(6282449,52832044,3,5),(6282449,52832045,3,6),(6282449,52832046,3,7),(6282449,52832047,3,8),(6282449,52832471,3,9),(6282449,52831605,3,10),(6282449,52831618,3,11),(6282449,52834371,3,12),(6282449,52834531,3,13),(6282449,52834678,3,14),(6282449,52834735,3,15),(6282449,52834737,3,16),(6282449,52834749,3,17),(6282449,52836042,3,18),(6282449,52836023,3,19),(6282449,52834758,3,20),(6282449,52834763,3,21),(6282449,52836069,3,22),(6282449,52834768,3,23),(6282449,52834775,3,24),(6282449,52834778,3,25),(6282449,52834779,3,26),(6282449,52834783,3,27),(6282449,52834784,3,28),(6282449,52836073,3,29),(6282449,52834785,3,30),(6282449,52834786,3,31),(6282449,52834787,3,32),(6282449,52834788,3,33),(6282449,52834790,3,34),(6282449,52834792,3,35),(6282449,52834794,3,36),(6282449,52834795,3,37),(6282449,52834797,3,38),(6282449,52834799,3,39),(6282449,52834802,3,40),(6282449,52834805,3,41),(6282449,52834808,3,42),(6282449,52834811,3,43),(6282449,52834813,3,44),(6282449,52834816,3,45),(6282449,52834819,3,46),(6282449,52834822,3,47),(6282449,52834825,3,48),(6282449,52835977,3,49),(6282449,52835980,3,50),(6282449,52835984,3,51),(6282449,52835987,3,52),(6282449,52836001,3,53),(6282449,52836004,3,54),(6282449,52836007,3,55),(6282449,52836010,3,56),(6282449,52836012,3,57),(6282449,52836016,3,58),(6282449,52836020,3,59),(6282450,52836042,2,1),(6282450,52836044,2,2),(6282450,52836048,2,3),(6282450,52836052,2,4),(6282450,52836056,2,5),(6282450,52836058,2,6),(6282450,52836061,2,7),(6282450,52836065,2,8),(6282451,52836023,2,1),(6282451,52836027,2,2),(6282451,52836030,2,3),(6282451,52836034,2,4),(6282451,52836036,2,5),(6282451,52836038,2,6),(6282452,52836069,2,1),(6282452,52836038,2,2),(6282452,52836073,2,3),(6541502,53273756,3,1),(6541502,53273782,3,2),(6541502,53273783,3,3),(6541502,53273784,3,4),(6541502,53273785,3,5),(6541502,53273786,3,6),(6541502,53273787,3,7),(6541502,53273788,3,8),(6541502,53273789,3,9),(6541502,53273790,3,10),(6541502,53273791,3,11),(6541502,53273792,3,12),(6541502,53273793,3,13),(6541502,53273794,3,14),(6541502,53273795,3,15),(6541502,53273796,3,16),(6541502,53273797,3,17),(6541502,53273798,3,18),(6541502,53273799,3,19),(6541502,53273800,3,20),(6541502,53273801,3,21),(6541502,53273802,3,22),(6541502,53273803,3,23),(6541502,53273804,3,24),(6541502,53273805,3,25),(6541502,53273806,3,26),(6541502,53273807,3,27),(6541502,53273808,3,28),(6541502,53273810,3,29),(6541502,53273811,3,30),(6541502,53273812,3,31),(6541502,53273813,3,32),(6541502,53273814,3,33),(6541502,53273815,3,34),(6541502,53273816,3,35),(6541502,53273817,3,36),(6541502,53273818,3,37),(6541502,53273819,3,38),(6541502,53273820,3,39),(6541502,53273821,3,40),(6541502,53273822,3,41),(6541502,53273823,3,42),(6541502,53273824,3,43),(6541502,53273825,3,44),(6541502,53273826,3,45),(6541502,53273827,3,46),(6541502,53273828,3,47),(6541502,53273829,3,48),(6541502,53273830,3,49),(6541502,53273831,3,50),(6541502,53273832,3,51),(6541502,53273833,3,52),(6541505,51123237,7,1),(6541505,625306,7,2),(6541505,51123238,7,3),(6541505,278748316,7,4),(6541505,625307,7,5),(6541507,53273834,5,1),(6541507,51123237,5,2),(6541510,53273836,2,1),(6541510,53273838,2,2),(6541510,53273839,2,3),(6541510,52801741,2,4),(6541510,53273841,2,5),(6541510,53273843,2,6),(6541510,53273844,2,7),(6541510,53273833,2,8),(6541510,53273846,2,9),(6541510,53273848,2,10),(6541510,53273849,2,11),(6541510,53273861,2,12),(6541510,53273851,2,13),(6541510,53273852,2,14),(6541510,53273853,2,15),(6541510,53273854,2,16),(6541510,53273855,2,17),(6541510,53273856,2,18),(6541510,53273857,2,19),(6541510,53273858,2,20),(6541510,53273859,2,21),(6541510,53273970,2,22),(6541510,53273860,2,23),(6541510,53273836,2,24),(6541514,53273928,2,1),(6541514,53273927,2,2),(6541514,53273926,2,3),(6541514,53273925,2,4),(6541514,53273924,2,5),(6541514,53273923,2,6),(6541514,53273922,2,7),(6541514,53273921,2,8),(6541514,53273920,2,9),(6541514,53273961,2,10),(6541514,53273919,2,11),(6541514,53273918,2,12),(6541514,53273917,2,13),(6541514,53273916,2,14),(6541514,53273915,2,15),(6541514,53273914,2,16),(6541514,53273913,2,17),(6541514,53273912,2,18),(6541514,53273911,2,19),(6541514,53273910,2,20),(6541514,53273909,2,21),(6541514,53273908,2,22),(6541514,53273907,2,23),(6541514,53273906,2,24),(6541514,53273905,2,25),(6541514,53273904,2,26),(6541514,53273903,2,27),(6541514,53273902,2,28),(6541514,53273901,2,29),(6541514,53273900,2,30),(6541514,53273899,2,31),(6541514,53273898,2,32),(6541514,53273897,2,33),(6541514,53273896,2,34),(6541514,53273895,2,35),(6541514,53273894,2,36),(6541514,53273893,2,37),(6541514,53273892,2,38),(6541514,53273891,2,39),(6541514,53273890,2,40),(6541514,53273889,2,41),(6541514,53273888,2,42),(6541514,53273887,2,43),(6541514,53273886,2,44),(6541514,53273885,2,45),(6541514,53273884,2,46),(6541514,53273883,2,47),(6541514,53273882,2,48),(6541514,53273881,2,49),(6541514,53273880,2,50),(6541514,53273879,2,51),(6541514,53273862,2,52),(6541514,53273863,2,53),(6541514,53273864,2,54),(6541514,53273865,2,55),(6541514,53273866,2,56),(6541514,53273867,2,57),(6541514,53273868,2,58),(6541514,53273869,2,59),(6541514,53273870,2,60),(6541514,53273871,2,61),(6541514,53273872,2,62),(6541514,53273873,2,63),(6541518,53273874,2,1),(6541518,53273875,2,2),(6541518,53273876,2,3),(6541518,53273877,2,4),(6541518,53273878,2,5),(6541518,52796991,2,6),(6541520,53273873,4,1),(6541520,53273874,4,2),(6541522,53273929,2,1),(6541522,53273930,2,2),(6541522,53273931,2,3),(6541522,53273932,2,4),(6541522,53273933,2,5),(6541522,53273934,2,6),(6541522,53273935,2,7),(6541522,53273936,2,8),(6541522,53273937,2,9),(6541522,53273938,2,10),(6541522,53273939,2,11),(6541522,53273940,2,12),(6541522,53273941,2,13),(6541522,53273942,2,14),(6541522,53273943,2,15),(6541522,53273944,2,16),(6541522,53273945,2,17),(6541522,53273946,2,18),(6541522,53273947,2,19),(6541522,53273948,2,20),(6541522,53273949,2,21),(6541522,53273950,2,22),(6541522,53273951,2,23),(6541522,53273952,2,24),(6541522,53273953,2,25),(6541522,53273954,2,26),(6541522,53273955,2,27),(6541522,53273956,2,28),(6541522,53273957,2,29),(6541522,53273958,2,30),(6541522,53273959,2,31),(6541522,53273960,2,32),(6541522,53273961,2,33),(6541525,51123233,2,1),(6541525,53273962,2,2),(6541525,53273963,2,3),(6541525,53273964,2,4),(6541525,53273965,2,5),(6541525,53273966,2,6),(6541525,53273967,2,7),(6541538,52032250,6,1),(6541538,53275670,6,2),(6541538,53275669,6,3),(6541538,53275668,6,4),(6541538,53275667,6,5),(6541538,53275666,6,6),(6541538,53275665,6,7),(6541538,53275664,6,8),(6541538,53275663,6,9),(6541538,53275662,6,10),(6541538,53275661,6,11),(6541538,53275660,6,12),(6541538,53275659,6,13),(6541538,53275658,6,14),(6541538,53275657,6,15),(6541538,53275656,6,16),(6541538,53275655,6,17),(6541538,53275654,6,18),(6541538,53275653,6,19),(6541538,53275652,6,20),(6541538,53275651,6,21),(6541538,53275650,6,22),(6541538,53275649,6,23),(6541538,53275648,6,24),(6541538,53275647,6,25),(6541538,53275646,6,26),(6541538,53275645,6,27),(6541538,53275644,6,28),(6541538,53275643,6,29),(6541538,53275642,6,30),(6541538,53275640,6,31),(6541538,53275639,6,32),(6541538,53275638,6,33),(6541538,53275637,6,34),(6541538,53275636,6,35),(6541538,53275635,6,36),(6541538,53275634,6,37),(6541538,53275633,6,38),(6541538,53275632,6,39),(6541538,53275631,6,40),(6541538,53275630,6,41),(6541538,53275629,6,42),(6541538,53275628,6,43),(6541538,53275627,6,44),(6541538,53275626,6,45),(6541538,53275625,6,46),(6541538,53275624,6,47),(6541538,53275623,6,48),(6541538,53275622,6,49),(6541538,53275621,6,50),(6541538,53275620,6,51),(6541538,53275619,6,52),(6541538,53275618,6,53),(6541538,53275617,6,54),(6541538,53275616,6,55),(6541538,53275615,6,56),(6541538,53275614,6,57),(6541538,53275613,6,58),(6541538,53275612,6,59),(6541538,53275611,6,60),(6541538,53275610,6,61),(6541538,53275609,6,62),(6541538,53275608,6,63),(6541538,53275607,6,64),(6541538,53275606,6,65),(6541538,53275605,6,66),(6541538,53275604,6,67),(6541538,53275603,6,68),(6541538,53275602,6,69),(6541538,53275601,6,70),(6541538,53275600,6,71),(6541538,53275599,6,72),(6541538,53275598,6,73),(6541538,53275597,6,74),(6541538,53275596,6,75),(6541538,53275595,6,76),(6541538,53275594,6,77),(6541538,53275593,6,78),(6541538,53275592,6,79),(6541538,53275591,6,80),(6541538,53275590,6,81),(6541538,53275589,6,82),(6541538,53275588,6,83),(6541538,53275587,6,84),(6541538,53275586,6,85),(6541538,53275585,6,86),(6541538,53275584,6,87),(6541538,53275583,6,88),(6541538,53275582,6,89),(6541538,53275581,6,90),(6541538,53275580,6,91),(6541538,53275579,6,92),(6541538,53275578,6,93),(6541538,53275577,6,94),(6541538,53275576,6,95),(6541538,53275575,6,96),(6541538,53275574,6,97),(6541538,53275573,6,98),(6541538,53275572,6,99),(6541538,53275570,6,100),(6541538,53275569,6,101),(6541538,53275568,6,102),(6541538,53275567,6,103),(6541538,53275565,6,104),(6541538,53275563,6,105),(6541538,53275562,6,106),(6541538,53275561,6,107),(6541538,53275560,6,108),(6541538,53275559,6,109),(6541538,53275558,6,110),(6541538,53275557,6,111),(6541538,53275556,6,112),(6541538,53275555,6,113),(6541538,53275554,6,114),(6541538,53275552,6,115),(6541538,53275551,6,116),(6541538,53275550,6,117),(6541538,53275549,6,118),(6541538,53275548,6,119),(6541538,53275547,6,120),(6541538,53275546,6,121),(6541538,53275545,6,122),(6541538,53275544,6,123),(6541538,53275543,6,124),(6541538,53275542,6,125),(6541538,53275541,6,126),(6541538,53275540,6,127),(6541538,53275539,6,128),(6541538,53275538,6,129),(6541538,53275537,6,130),(6541538,53275536,6,131),(6541538,53275535,6,132),(6541538,53275534,6,133),(6541538,53275533,6,134),(6541538,53277215,6,135),(6541538,53275005,6,136),(6541538,53275004,6,137),(6541538,53275003,6,138),(6541538,53275002,6,139),(6541538,53275001,6,140),(6541538,53274999,6,141),(6541538,53274998,6,142),(6541538,53274967,6,143),(6541538,53274966,6,144),(6541538,53274965,6,145),(6541538,53274964,6,146),(6541538,53274963,6,147),(6541538,53274961,6,148),(6541538,53274960,6,149),(6541538,53274959,6,150),(6541538,53274958,6,151),(6541538,53274957,6,152),(6541538,53274956,6,153),(6541538,53274955,6,154),(6541538,53274954,6,155),(6541538,53274952,6,156),(6541538,53274951,6,157),(6541538,53274950,6,158),(6541538,53274949,6,159),(6541538,53274948,6,160),(6541538,53274947,6,161),(6541538,53274946,6,162),(6541538,53274944,6,163),(6541538,53274943,6,164),(6541538,53274942,6,165),(6541538,53274941,6,166),(6541538,53274940,6,167),(6541538,53274939,6,168),(6541538,53274937,6,169),(6541538,53274936,6,170),(6541538,53274935,6,171),(6541538,53274934,6,172),(6541538,53274933,6,173),(6541538,53274932,6,174),(6541538,53274931,6,175),(6541538,53274929,6,176),(6541538,53274928,6,177),(6541538,53274927,6,178),(6541538,53274926,6,179),(6541538,53274925,6,180),(6541538,53274924,6,181),(6541538,53274922,6,182),(6541538,53274921,6,183),(6541538,53274920,6,184),(6541538,53274919,6,185),(6541538,53274918,6,186),(6541538,53274917,6,187),(6541538,53274916,6,188),(6541538,53274915,6,189),(6541538,53274913,6,190),(6541538,53274912,6,191),(6541538,53274911,6,192),(6541538,53274910,6,193),(6541538,53274909,6,194),(6541538,53274908,6,195),(6541538,53274907,6,196),(6541538,53274906,6,197),(6541538,53274904,6,198),(6541538,53274903,6,199),(6541538,53274902,6,200),(6541538,53274901,6,201),(6541538,53274900,6,202),(6541538,53274899,6,203),(6541538,53274898,6,204),(6541538,53274896,6,205),(6541538,53274895,6,206),(6541538,53274894,6,207),(6541538,53274893,6,208),(6541538,53274892,6,209),(6541538,53274891,6,210),(6541538,53274890,6,211),(6541538,53274888,6,212),(6541538,53274886,6,213),(6541538,53274885,6,214),(6541538,53274884,6,215),(6541538,53274883,6,216),(6541538,53274031,6,217),(6541538,53274030,6,218),(6541538,53274029,6,219),(6541538,53274028,6,220),(6541538,53274027,6,221),(6541538,53274026,6,222),(6541538,53274025,6,223),(6541538,53274024,6,224),(6541538,53274023,6,225),(6541538,53273998,6,226),(6541538,53273997,6,227),(6541538,53273996,6,228),(6541538,53273995,6,229),(6541538,53273994,6,230),(6541538,53273993,6,231),(6541538,53273992,6,232),(6541538,53273991,6,233),(6541538,53273990,6,234),(6541538,53273989,6,235),(6541538,53273988,6,236),(6541538,53273987,6,237),(6541538,53273986,6,238),(6541538,53273985,6,239),(6541538,53273984,6,240),(6541538,53273983,6,241),(6541538,53273982,6,242),(6541538,53273981,6,243),(6541538,53273980,6,244),(6541538,53273979,6,245),(6541538,53273978,6,246),(6541538,53273977,6,247),(6541538,53273976,6,248),(6541538,53273975,6,249),(6541538,53273974,6,250),(6541538,53273973,6,251),(6541538,53273972,6,252),(6541538,53273971,6,253),(6541538,53273968,6,254),(6541538,53273969,6,255),(6541538,53273970,6,256),(6541541,53274000,4,1),(6541541,53274002,4,2),(6541541,53274003,4,3),(6541541,53274004,4,4),(6541541,53274005,4,5),(6541541,53274006,4,6),(6541541,53274007,4,7),(6541541,53274008,4,8),(6541541,53274009,4,9),(6541541,53274010,4,10),(6541541,53274011,4,11),(6541541,53274012,4,12),(6541541,53274013,4,13),(6541541,53274014,4,14),(6541541,53274015,4,15),(6541541,53274016,4,16),(6541541,53274017,4,17),(6541541,53274018,4,18),(6541541,53274019,4,19),(6541541,53274020,4,20),(6541541,53274021,4,21),(6541541,53274022,4,22),(6548812,53275012,2,1),(6548812,53275014,2,2),(6548812,53274973,2,3),(6548812,53274974,2,4),(6548812,53274976,2,5),(6548812,53274977,2,6),(6548812,53274978,2,7),(6548812,53274979,2,8),(6548812,53274980,2,9),(6548812,53274981,2,10),(6548812,53274983,2,11),(6548812,53274984,2,12),(6548812,53274985,2,13),(6548812,53274986,2,14),(6548812,53274987,2,15),(6548812,53274988,2,16),(6548812,53274989,2,17),(6548812,53274990,2,18),(6548812,53274991,2,19),(6548812,53274992,2,20),(6548812,53274993,2,21),(6548812,53274995,2,22),(6548812,53274996,2,23),(6548812,53274997,2,24),(6548814,53275008,2,1),(6548814,53275009,2,2),(6548814,53275016,2,3),(6548814,53275015,2,4),(6548814,53275010,2,5),(6548814,53275011,2,6),(6548814,53275014,2,7),(6548816,53275006,2,1),(6548816,53275017,2,2),(6548816,53275008,2,3),(6548818,53275028,2,1),(6548818,53275036,2,2),(6548818,53275035,2,3),(6548818,53275040,2,4),(6548818,53276316,2,5),(6548820,53275026,4,1),(6548820,769253018,4,2),(6548820,769253019,4,3),(6548820,53275033,4,4),(6548820,769253020,4,5),(6548820,53275032,4,6),(6548820,769253021,4,7),(6548820,53275031,4,8),(6548820,769253022,4,9),(6548820,53275030,4,10),(6548820,769253024,4,11),(6548820,53275028,4,12),(6548820,769253025,4,13),(6548820,769253026,4,14),(6548820,53275027,4,15),(6548820,769253028,4,16),(6548820,769253029,4,17),(6548820,51125478,4,18),(6548820,769253030,4,19),(6548820,53275026,4,20),(6548822,53274972,2,1),(6548822,53275034,2,2),(6548824,53275034,3,1),(6548824,53275012,3,2),(6548826,53275038,3,1),(6548826,53275039,3,2),(6548826,262892998,3,3),(6551314,51931099,4,1),(6551314,53275531,4,2),(6551314,53275530,4,3),(6551314,53275529,4,4),(6551314,53275528,4,5),(6551314,53277181,4,6),(6551314,53275527,4,7),(6551314,53275526,4,8),(6551314,53275525,4,9),(6551314,53275524,4,10),(6551314,53275523,4,11),(6551314,53275522,4,12),(6551314,53275521,4,13),(6551314,53275520,4,14),(6551314,53275506,4,15),(6551314,53275507,4,16),(6551314,53275508,4,17),(6551317,51126211,4,1),(6551317,264465126,4,2),(6551320,264465126,3,1),(6551320,51126212,3,2),(6551320,625205,3,3),(6551320,625206,3,4),(6551320,51126213,3,5),(6553102,53276316,3,1),(6553102,53276317,3,2),(6553108,53276317,2,1),(6553108,53275008,2,2),(6553108,53275018,2,3),(6553108,53275019,2,4),(6553108,53275020,2,5),(6553108,53275022,2,6),(6553108,53275023,2,7),(6553108,53275024,2,8),(6553108,53276347,2,9),(6553108,53276348,2,10),(6553108,53276349,2,11),(6553108,53276350,2,12),(6553108,53276351,2,13),(6553108,53276352,2,14),(6553108,53276353,2,15),(6553108,53276354,2,16),(6553108,53276355,2,17),(6553108,53276356,2,18),(6553108,53276357,2,19),(6553108,53276358,2,20),(6553108,53276359,2,21),(6553108,53276360,2,22),(6553108,53276361,2,23),(6553108,53276362,2,24),(6553108,53276363,2,25),(6553108,53276364,2,26),(6553108,53276365,2,27),(6553108,53276426,2,28),(6553108,53276366,2,29),(6553108,53276367,2,30),(6553108,53276368,2,31),(6553108,53276369,2,32),(6553108,53276370,2,33),(6553108,53276371,2,34),(6553108,53276372,2,35),(6553108,53276373,2,36),(6553108,53276374,2,37),(6553398,53276380,2,1),(6553398,53276381,2,2),(6553398,53276382,2,3),(6553398,53276383,2,4),(6553398,53276384,2,5),(6553398,53276385,2,6),(6553398,53276386,2,7),(6553398,53276387,2,8),(6553398,53276388,2,9),(6553398,53276389,2,10),(6553398,53276390,2,11),(6553516,53277173,2,1),(6553516,53277172,2,2),(6553516,53277171,2,3),(6553516,53277170,2,4),(6553516,53277169,2,5),(6553516,53277168,2,6),(6553516,53277167,2,7),(6553516,53277166,2,8),(6553516,53277165,2,9),(6553516,53277164,2,10),(6553516,53277163,2,11),(6553516,53277162,2,12),(6553516,53277161,2,13),(6553516,53277160,2,14),(6553516,53276588,2,15),(6553516,53276589,2,16),(6553516,53276590,2,17),(6553516,53276592,2,18),(6553516,53276593,2,19),(6553516,53276594,2,20),(6553516,53276595,2,21),(6553516,53276597,2,22),(6553516,53276598,2,23),(6553516,53276599,2,24),(6553516,53276600,2,25),(6553516,53276601,2,26),(6553516,53276602,2,27),(6553516,53276604,2,28),(6553516,53276605,2,29),(6553516,53276606,2,30),(6553516,53276608,2,31),(6553516,53276609,2,32),(6553516,53276610,2,33),(6553516,53276611,2,34),(6553516,53276612,2,35),(6553516,53276613,2,36),(6553516,53276614,2,37),(6553516,53276616,2,38),(6553516,53276617,2,39),(6553516,53276618,2,40),(6553516,53276619,2,41),(6553516,53276620,2,42),(6553516,53276621,2,43),(6553516,53276622,2,44),(6553516,53276623,2,45),(6553516,53276624,2,46),(6553516,53276625,2,47),(6553516,53276627,2,48),(6553516,53276628,2,49),(6553516,53276630,2,50),(6553516,53276631,2,51),(6553516,53276632,2,52),(6553516,53276633,2,53),(6553516,53276634,2,54),(6553516,53276635,2,55),(6553516,53276636,2,56),(6553516,53276637,2,57),(6553516,53276639,2,58),(6553516,53276641,2,59),(6553516,53276643,2,60),(6553516,53276645,2,61),(6553516,53276646,2,62),(6553516,53276647,2,63),(6553516,53276648,2,64),(6553516,53276518,2,65),(6553516,53276519,2,66),(6553516,53276543,2,67),(6553516,53276520,2,68),(6553516,53276521,2,69),(6553516,53276522,2,70),(6553516,53276523,2,71),(6553516,53276524,2,72),(6553516,53276525,2,73),(6553516,53276526,2,74),(6553516,53276527,2,75),(6553516,53276528,2,76),(6553516,53276529,2,77),(6553516,53276530,2,78),(6553516,53276531,2,79),(6553516,53276532,2,80),(6553516,53276533,2,81),(6553516,53276534,2,82),(6553516,53276535,2,83),(6553516,53276536,2,84),(6553516,53276537,2,85),(6553516,53276459,2,86),(6553516,53276460,2,87),(6553516,53276461,2,88),(6553516,53276462,2,89),(6553516,53276463,2,90),(6553516,53276464,2,91),(6553516,53276465,2,92),(6553516,53276466,2,93),(6553516,53276467,2,94),(6553516,53276468,2,95),(6553516,53276469,2,96),(6553516,53276470,2,97),(6553516,53276471,2,98),(6553516,53276472,2,99),(6553516,53276473,2,100),(6553516,53276474,2,101),(6553516,53276475,2,102),(6553516,53276476,2,103),(6553516,53276477,2,104),(6553516,53276478,2,105),(6553516,53276479,2,106),(6553516,53276480,2,107),(6553516,53276481,2,108),(6553516,53276482,2,109),(6553516,53276483,2,110),(6553516,53276484,2,111),(6553516,53276485,2,112),(6553516,53276486,2,113),(6553516,53276487,2,114),(6553516,53276488,2,115),(6553516,53276489,2,116),(6553516,53276490,2,117),(6553516,53276491,2,118),(6553516,53276492,2,119),(6553516,53276493,2,120),(6553516,53276494,2,121),(6553516,53276495,2,122),(6553516,53276496,2,123),(6553516,53276497,2,124),(6553516,53276498,2,125),(6553516,53276499,2,126),(6553516,53276500,2,127),(6553516,53276501,2,128),(6553516,53276502,2,129),(6553516,53276503,2,130),(6553516,53276504,2,131),(6553516,53276505,2,132),(6553516,53276506,2,133),(6553516,53276507,2,134),(6553516,53276508,2,135),(6553516,53276509,2,136),(6553516,53276510,2,137),(6553516,53276511,2,138),(6553516,53276512,2,139),(6553516,53276513,2,140),(6553516,53276514,2,141),(6553516,53276515,2,142),(6553516,53276516,2,143),(6553516,53276517,2,144),(6553516,53276390,2,145),(6553516,53276392,2,146),(6553516,53276393,2,147),(6553516,53276394,2,148),(6553516,53276395,2,149),(6553516,53276396,2,150),(6553516,53276397,2,151),(6553516,53276398,2,152),(6553516,53276399,2,153),(6553516,53276400,2,154),(6553516,53276401,2,155),(6553516,53276402,2,156),(6553516,53276403,2,157),(6553516,53276404,2,158),(6553516,53276406,2,159),(6553516,53276407,2,160),(6553516,53276408,2,161),(6553516,53276410,2,162),(6553516,53276411,2,163),(6553516,53276412,2,164),(6553516,53276413,2,165),(6553516,53276414,2,166),(6553516,53276415,2,167),(6553516,53276416,2,168),(6553516,53276418,2,169),(6553516,53276419,2,170),(6553516,53277174,2,171),(6553516,53277175,2,172),(6553516,53277176,2,173),(6553516,53277177,2,174),(6553516,53277178,2,175),(6553516,53276424,2,176),(6553741,53276538,2,1),(6553741,53276539,2,2),(6553741,53276540,2,3),(6553741,53276541,2,4),(6553741,53276542,2,5),(6553741,53276543,2,6),(6557168,53276424,2,1),(6557168,53276426,2,2),(6557169,53277179,2,1),(6557169,53277180,2,2),(6557169,53277181,2,3),(6557171,53277182,2,1),(6557171,53277183,2,2),(6557171,53277184,2,3),(6557171,53277185,2,4),(6557171,53277189,2,5),(6557171,53277186,2,6),(6557171,53277187,2,7),(6557171,53275506,2,8),(6557173,53277190,2,1),(6557173,53277191,2,2),(6557173,53277192,2,3),(6557173,53275523,2,4),(6557177,53277313,1,1),(6557177,53277312,1,2),(6557177,53277311,1,3),(6557177,53277310,1,4),(6557177,53277309,1,5),(6557177,53277308,1,6),(6557177,53277307,1,7),(6557177,53277306,1,8),(6557177,53277305,1,9),(6557177,53277304,1,10),(6557177,53277303,1,11),(6557177,53277302,1,12),(6557177,53277301,1,13),(6557177,53277300,1,14),(6557177,53277299,1,15),(6557177,53277298,1,16),(6557177,53277297,1,17),(6557177,53277296,1,18),(6557177,53277295,1,19),(6557177,53277294,1,20),(6557177,53277293,1,21),(6557177,53277292,1,22),(6557177,53277291,1,23),(6557177,53277290,1,24),(6557177,53277289,1,25),(6557177,53277288,1,26),(6557177,53277287,1,27),(6557177,53277286,1,28),(6557177,53277285,1,29),(6557177,53277284,1,30),(6557177,53277283,1,31),(6557177,53277282,1,32),(6557177,53277281,1,33),(6557177,53277280,1,34),(6557177,53277279,1,35),(6557177,53277278,1,36),(6557177,53277277,1,37),(6557177,53277276,1,38),(6557177,53277275,1,39),(6557177,53277274,1,40),(6557177,53277273,1,41),(6557177,53277272,1,42),(6557177,53277271,1,43),(6557177,53277270,1,44),(6557177,53277269,1,45),(6557177,53277268,1,46),(6557177,53277267,1,47),(6557177,53277266,1,48),(6557177,53277265,1,49),(6557177,53277264,1,50),(6557177,53277263,1,51),(6557177,53277262,1,52),(6557177,53277261,1,53),(6557177,53277260,1,54),(6557177,53277259,1,55),(6557177,53277258,1,56),(6557177,53277257,1,57),(6557177,53277256,1,58),(6557177,53277255,1,59),(6557177,53277254,1,60),(6557177,53277253,1,61),(6557177,53277252,1,62),(6557177,53277251,1,63),(6557177,53277250,1,64),(6557177,53277249,1,65),(6557177,53277248,1,66),(6557177,53277247,1,67),(6557177,53277246,1,68),(6557177,53277245,1,69),(6557177,53277244,1,70),(6557177,53277243,1,71),(6557177,53277242,1,72),(6557177,53277241,1,73),(6557177,53277240,1,74),(6557177,53277239,1,75),(6557177,53277238,1,76),(6557177,53277237,1,77),(6557177,53277236,1,78),(6557177,53277235,1,79),(6557177,53277234,1,80),(6557177,53277233,1,81),(6557177,53277232,1,82),(6557177,53277231,1,83),(6557177,53277230,1,84),(6557177,53277229,1,85),(6557177,53277228,1,86),(6557177,53277227,1,87),(6557177,53277226,1,88),(6557177,53277225,1,89),(6557177,53277224,1,90),(6557177,53277223,1,91),(6557177,53277222,1,92),(6557177,53277221,1,93),(6557177,53277220,1,94),(6557177,53277219,1,95),(6557177,53277218,1,96),(6557177,53277217,1,97),(6557177,53277216,1,98),(6557177,53277193,1,99),(6557177,53277194,1,100),(6557177,53277195,1,101),(6557177,53277196,1,102),(6557177,53277197,1,103),(6557177,53277198,1,104),(6557177,53277199,1,105),(6557177,53277200,1,106),(6557177,53277201,1,107),(6557177,53277202,1,108),(6557177,53277203,1,109),(6557177,53277204,1,110),(6557177,53277205,1,111),(6557177,53277206,1,112),(6557177,53277207,1,113),(6557177,53277208,1,114),(6557177,53277209,1,115),(6557177,53277210,1,116),(6557177,53277211,1,117),(6557177,53277212,1,118),(6557177,53277213,1,119),(6557177,53277214,1,120),(6557177,53277215,1,121),(6561466,53278161,1,1),(6561466,53278162,1,2),(6561466,53278163,1,3),(6561466,53278164,1,4),(6561466,53278165,1,5),(6561466,53278166,1,6),(6561466,53278167,1,7),(6561466,53278142,1,8),(6561466,53278144,1,9),(6561466,53278146,1,10),(6561466,53278147,1,11),(6561466,53278148,1,12),(6561466,53278149,1,13),(6561466,53278150,1,14),(6561466,53278151,1,15),(6561466,53278152,1,16),(6561466,53278153,1,17),(6561466,53278154,1,18),(6561466,53278155,1,19),(6561466,53278156,1,20),(6561466,53278157,1,21),(6561466,53278158,1,22),(6561466,53278159,1,23),(6561466,53278160,1,24),(6561466,53278161,1,25),(6561468,53278175,6,1),(6561468,53278174,6,2),(6561468,53278173,6,3),(6561468,53278172,6,4),(6561468,53278171,6,5),(6561468,53278170,6,6),(6561468,53278169,6,7),(6561468,53278168,6,8),(6561470,53278178,1,1),(6561470,53278179,1,2),(6561470,53278180,1,3),(6561470,53278181,1,4),(6561470,53278182,1,5),(6561470,53278183,1,6),(6561470,53278185,1,7),(6561470,53278186,1,8),(6561470,53278188,1,9),(6561470,53278190,1,10),(6561470,53278192,1,11),(6561470,53278194,1,12),(6561470,53278196,1,13),(6561470,53278197,1,14),(6561470,53278199,1,15),(6561470,53278200,1,16),(6561470,53278201,1,17),(6561470,53278202,1,18),(6561470,53278203,1,19),(6561470,53278176,1,20),(6561470,53278177,1,21),(6561470,53278178,1,22),(6561682,53278204,1,1),(6561682,53278205,1,2),(6561682,53278206,1,3),(6561682,53278207,1,4),(6561682,53278208,1,5),(6561682,53278210,1,6),(6561682,53278211,1,7),(6561682,53278212,1,8),(6561682,53278213,1,9),(6561682,53278214,1,10),(6561682,53278215,1,11),(6561682,53278216,1,12),(6561682,53278217,1,13),(6561682,53278204,1,14),(6561704,53278235,1,1),(6561704,53278236,1,2),(6561704,53278237,1,3),(6561704,53278238,1,4),(6561704,53278239,1,5),(6561704,53278240,1,6),(6561704,53278241,1,7),(6561704,53278242,1,8),(6561704,53278252,1,9),(6561704,53278253,1,10),(6561704,53278255,1,11),(6561704,53278256,1,12),(6561704,53278257,1,13),(6561704,53278218,1,14),(6561704,53278219,1,15),(6561704,53278220,1,16),(6561704,53278221,1,17),(6561704,53278222,1,18),(6561704,53278223,1,19),(6561704,53278224,1,20),(6561704,53278226,1,21),(6561704,53278232,1,22),(6561704,53278233,1,23),(6561704,53278234,1,24),(6561704,53278235,1,25),(6561708,53278258,3,1),(6561708,53278259,3,2),(6561708,53278261,3,3),(6561708,53278263,3,4),(6561708,53278264,3,5),(6561708,53278265,3,6),(6561708,53278267,3,7),(6561708,53278268,3,8),(6561708,53278269,3,9),(6561708,53278271,3,10),(6561708,53278272,3,11),(6561708,53278273,3,12),(6561708,53278274,3,13),(6561708,53278275,3,14),(6561708,53278276,3,15),(6561708,53278277,3,16),(6561708,53278278,3,17),(6561708,53278280,3,18),(6561708,53278282,3,19),(6561708,53278283,3,20),(6561708,53278285,3,21),(6561708,53278286,3,22),(6561708,53278287,3,23),(6561708,664061745,3,24),(6561708,53278289,3,25),(6561708,53278290,3,26),(6561708,53278291,3,27),(6561708,53278292,3,28),(6561708,53278293,3,29),(6561708,53278294,3,30),(6561708,53278296,3,31),(6561708,53278298,3,32),(6561708,53278299,3,33),(6561708,53278301,3,34),(6561708,53278302,3,35),(6561708,53278304,3,36),(6561708,53278305,3,37),(6561708,53278306,3,38),(6561708,53278308,3,39),(6561708,53278309,3,40),(6561708,53278311,3,41),(6561708,53278312,3,42),(6561708,53278314,3,43),(6561708,53278315,3,44),(6561708,53278316,3,45),(6561708,53278317,3,46),(6561708,53278319,3,47),(6561708,53278321,3,48),(6561708,53278324,3,49),(6561708,53278327,3,50),(6561708,53278328,3,51),(6561708,53278330,3,52),(6561708,53278332,3,53),(6561708,53278333,3,54),(6561708,53278336,3,55),(6561708,53278337,3,56),(6561708,53278338,3,57),(6561708,53278341,3,58),(6561708,53278342,3,59),(6561708,53278343,3,60),(6561708,53278346,3,61),(6561708,53278347,3,62),(6561708,53278348,3,63),(6561708,53278350,3,64),(6561708,53278351,3,65),(6561708,53278353,3,66),(6561708,53278355,3,67),(6561708,53278356,3,68),(6561708,53278358,3,69),(6561708,53278360,3,70),(6561708,53278361,3,71),(6561708,53278362,3,72),(6561708,53278364,3,73),(6561708,53278366,3,74),(6561708,53278367,3,75),(6561708,53278368,3,76),(6561708,53278369,3,77),(6561708,53278371,3,78),(6561708,53278374,3,79),(6561708,53278375,3,80),(6561708,53278376,3,81),(6561708,53278377,3,82),(6561708,53278379,3,83),(6561708,53278383,3,84),(6561708,53278387,3,85),(6561708,779158284,3,86),(6561708,53278390,3,87),(6561708,53278395,3,88),(6561708,53278401,3,89),(6561708,53278404,3,90),(6561708,53278409,3,91),(6561708,53278412,3,92),(6561708,53278418,3,93),(6561708,53278420,3,94),(6561708,53278423,3,95),(6561708,53278426,3,96),(6561708,53278429,3,97),(6561708,53278258,3,98),(6563683,53281403,4,1),(6563683,53281402,4,2),(6563683,53281399,4,3),(6563683,53281395,4,4),(6563683,53281393,4,5),(6563683,53281388,4,6),(6563683,53281386,4,7),(6563683,53281382,4,8),(6563683,53281378,4,9),(6563683,53281374,4,10),(6563683,53281369,4,11),(6563687,53281406,2,1),(6563687,53281412,2,2),(6563687,53281415,2,3),(6563687,53281420,2,4),(6563687,53281424,2,5),(6563687,53281426,2,6),(6563687,53281430,2,7),(6563687,53281433,2,8),(6563687,53281436,2,9),(6563687,53281440,2,10),(6563687,53281444,2,11),(6563687,53282638,2,12),(6563687,53282705,2,13),(6563687,53282708,2,14),(6563687,53282709,2,15),(6563687,53282712,2,16),(6563687,53282714,2,17),(6563687,53282716,2,18),(6563687,53282719,2,19),(6563687,53282721,2,20),(6563687,53282723,2,21),(6563687,53282725,2,22),(6563687,53282727,2,23),(6563687,53282729,2,24),(6563687,53282730,2,25),(6563687,53282731,2,26),(6563687,53282734,2,27),(6563687,53282735,2,28),(6563687,53282738,2,29),(6563687,53282741,2,30),(6563687,53282743,2,31),(6563687,53282745,2,32),(6563687,53282748,2,33),(6563687,53282751,2,34),(6563687,53282753,2,35),(6563687,53282756,2,36),(6563687,53282759,2,37),(6563687,53282761,2,38),(6563687,53282764,2,39),(6563687,53282767,2,40),(6563687,53282768,2,41),(6563687,53282769,2,42),(6563687,53282772,2,43),(6563687,53282773,2,44),(6563687,53282777,2,45),(6563687,53282780,2,46),(6563687,53282784,2,47),(6563687,53282787,2,48),(6563687,53282789,2,49),(6563687,53282791,2,50),(6563687,53282794,2,51),(6563687,53282796,2,52),(6563687,53282803,2,53),(6563687,53282804,2,54),(6563687,53282808,2,55),(6563687,53282811,2,56),(6563687,53282814,2,57),(6563687,53282815,2,58),(6563687,53282817,2,59),(6563687,53282818,2,60),(6563687,53282819,2,61),(6563687,53282820,2,62),(6563687,53282822,2,63),(6563687,53282825,2,64),(6563687,53282827,2,65),(6563687,53282829,2,66),(6563687,53282831,2,67),(6563687,53282834,2,68),(6563687,53282839,2,69),(6563687,53282840,2,70),(6563687,53282842,2,71),(6563687,53282843,2,72),(6563687,53282846,2,73),(6563687,53282849,2,74),(6563687,53282852,2,75),(6563687,53282854,2,76),(6563687,53282856,2,77),(6563687,53282858,2,78),(6563687,53282860,2,79),(6563687,53282920,2,80),(6563687,53282925,2,81),(6563687,53282927,2,82),(6563687,53281406,2,83),(6563690,53282932,3,1),(6563690,53282936,3,2),(6563690,53282940,3,3),(6563690,53282941,3,4),(6563690,53282943,3,5),(6563690,53282946,3,6),(6563690,53282948,3,7),(6563690,53282950,3,8),(6563690,894259087,3,9),(6563690,53282952,3,10),(6563690,53282953,3,11),(6563690,53282957,3,12),(6563690,53282958,3,13),(6563690,53282959,3,14),(6563690,53282960,3,15),(6563690,53282963,3,16),(6563690,53282966,3,17),(6563690,53282968,3,18),(6563690,53282970,3,19),(6563690,53282972,3,20),(6563690,53282974,3,21),(6563690,53282976,3,22),(6563690,53282979,3,23),(6563690,53282983,3,24),(6563690,53282985,3,25),(6563690,53282987,3,26),(6563690,53282989,3,27),(6563690,53282991,3,28),(6563690,53282996,3,29),(6563690,53282998,3,30),(6563690,53283003,3,31),(6563690,53283007,3,32),(6563690,53283011,3,33),(6563690,894259565,3,34),(6563690,894259017,3,35),(6563690,894259189,3,36),(6563690,894259372,3,37),(6566558,53288136,5,1),(6566558,51448824,5,2),(6566558,51448827,5,3),(6566558,51448828,5,4),(6566561,53288128,4,1),(6566561,53288148,4,2),(6566561,53288140,4,3),(6566561,53288138,4,4),(6566561,53288136,4,5),(6566561,53288134,4,6),(6566561,53288131,4,7),(6566561,51448940,4,8),(6566561,53288129,4,9),(6566561,53288128,4,10),(6566571,53288321,2,1),(6566571,53288323,2,2),(6566571,53288326,2,3),(6566571,53288329,2,4),(6566571,53288332,2,5),(6566571,53288334,2,6),(6566571,53288336,2,7),(6566571,53288338,2,8),(6566571,53288339,2,9),(6566571,53288343,2,10),(6566571,53288346,2,11),(6566573,53288348,2,1),(6566573,53288349,2,2),(6566573,53288350,2,3),(6566573,53288351,2,4),(6566573,53288352,2,5),(6566573,53288353,2,6),(6566573,53288354,2,7),(6566573,53288355,2,8),(6566573,53288356,2,9),(6566573,53288357,2,10),(6566573,53288216,2,11),(6566576,53288358,3,1),(6566576,53288360,3,2),(6566576,53288364,3,3),(6566576,53288366,3,4),(6566576,53288368,3,5),(6566576,53288370,3,6),(6566576,53288373,3,7),(6566576,53288375,3,8),(6566576,53288378,3,9),(6566576,53288381,3,10),(6566576,53288383,3,11),(6566576,53288388,3,12),(6566576,53288391,3,13),(6566576,53288393,3,14),(6566576,53288394,3,15),(6566576,53288396,3,16),(6566576,53288399,3,17),(6566576,53288402,3,18),(6566576,53288403,3,19),(6566576,53288404,3,20),(6566576,53288419,3,21),(6566576,53288407,3,22),(6566576,53288410,3,23),(6566576,53288413,3,24),(6566576,53288152,3,25),(6569859,370902435,8,1),(6569859,370902436,8,2),(6569859,370902438,8,3),(6569859,53295391,8,4),(6569859,53295388,8,5),(6569859,53295385,8,6),(6569859,53295382,8,7),(6569859,53295379,8,8),(6569859,53295377,8,9),(6569859,53295375,8,10),(6569859,53295371,8,11),(6569859,53295370,8,12),(6569859,53295365,8,13),(6569859,53295363,8,14),(6569859,53295361,8,15),(6569859,53295359,8,16),(6569859,53295356,8,17),(6569859,53295353,8,18),(6569859,53295349,8,19),(6569859,53295347,8,20),(6569859,53295343,8,21),(6569859,53295339,8,22),(6569859,53295336,8,23),(6569859,53295332,8,24),(6569859,53295329,8,25),(6569859,53295327,8,26),(6569859,53295325,8,27),(6569859,53295321,8,28),(6569859,53295319,8,29),(6569859,53295315,8,30),(6569859,53295314,8,31),(6569859,53295312,8,32),(6569859,53295310,8,33),(6569859,53295308,8,34),(6569859,53295305,8,35),(6569859,53295301,8,36),(6569859,53295299,8,37),(6569859,53295298,8,38),(6569859,53295294,8,39),(6569859,53295292,8,40),(6569859,370904235,8,41),(6569859,53295291,8,42),(6569859,53295287,8,43),(6569859,53295283,8,44),(6569859,53295281,8,45),(6569859,53295277,8,46),(6569859,53295276,8,47),(6569859,53295267,8,48),(6569859,53295272,8,49),(6576845,53306568,2,1),(6576845,53306569,2,2),(6576845,53306573,2,3),(6576845,53306575,2,4),(6576845,53306579,2,5),(6576845,53306582,2,6),(6576845,53306585,2,7),(6576845,53306588,2,8),(6576845,53306590,2,9),(6576845,53306592,2,10),(6576845,53306595,2,11),(6576845,53306597,2,12),(6576845,53306600,2,13),(6576847,53306679,10,1),(6576847,53306677,10,2),(6576847,53306675,10,3),(6576847,53306673,10,4),(6576847,53306672,10,5),(6576847,53306671,10,6),(6576847,53306670,10,7),(6576847,53306668,10,8),(6576853,53306680,7,1),(6576853,53306679,7,2),(6576855,53306695,2,1),(6576855,53306696,2,2),(6576855,53306697,2,3),(6576858,53306808,3,1),(6576858,53306810,3,2),(6576858,53306813,3,3),(6576858,53306814,3,4),(6576858,53306817,3,5),(6576858,441157267,3,6),(6576858,53306819,3,7),(6576858,53306821,3,8),(6576858,53306823,3,9),(6576858,53306825,3,10),(6576858,53306828,3,11),(6576858,53306831,3,12),(6576858,53306833,3,13),(6576858,53306836,3,14),(6576858,53306838,3,15),(6576858,53306841,3,16),(6576858,53306843,3,17),(6576858,53306845,3,18),(6576858,53306846,3,19),(6576858,53306848,3,20),(6576858,53306849,3,21),(6576858,53306852,3,22),(6576858,53306853,3,23),(6576858,53306856,3,24),(6576858,53306858,3,25),(6576858,53306862,3,26),(6576858,53306863,3,27),(6576858,53306866,3,28),(6576861,53306869,2,1),(6576861,53306823,2,2),(6576864,53306984,2,1),(6576864,53306979,2,2),(6576864,53306978,2,3),(6576864,53306975,2,4),(6576864,53306973,2,5),(6576864,53306970,2,6),(6576864,53306966,2,7),(6576864,53306963,2,8),(6576864,53306925,2,9),(6576866,53306980,2,1),(6576866,53306983,2,2),(6576866,53306984,2,3),(6576866,53309392,2,4),(6576866,53306988,2,5),(6576866,53306989,2,6),(6576866,53306991,2,7),(6576866,53306992,2,8),(6576866,53306994,2,9),(6578446,276998391,5,1),(6578446,276998392,5,2),(6578446,276998393,5,3),(6578446,276998394,5,4),(6578446,53309350,5,5),(6578446,53309352,5,6),(6578446,53309354,5,7),(6578446,53309356,5,8),(6578446,53309360,5,9),(6578446,53309365,5,10),(6578446,53309368,5,11),(6578446,277003680,5,12),(6578446,277003681,5,13),(6578446,277003682,5,14),(6578446,277003683,5,15),(6578446,277003684,5,16),(6578449,53309380,3,1),(6578449,264501528,3,2),(6578449,53309382,3,3),(6578451,53309384,6,1),(6578451,277000148,6,2),(6578451,277000149,6,3),(6578451,277001727,6,4),(6578451,276998671,6,5),(6578451,53306913,6,6),(6578454,53309392,2,1),(6578454,53309386,2,2),(6578454,53309389,2,3),(6578454,53309393,2,4),(6578454,53309395,2,5),(6578454,53309397,2,6),(6578454,53309398,2,7),(6578454,53309400,2,8),(6578454,53309402,2,9),(6578454,53309405,2,10),(6578454,53309407,2,11),(6578454,53309419,2,12),(6578454,53309409,2,13),(6578454,53309412,2,14),(6578454,53309414,2,15),(6578454,53309417,2,16),(6578454,53309421,2,17),(6578454,53309423,2,18),(6578454,53309425,2,19),(6578454,53309427,2,20),(6578454,53309431,2,21),(6578454,53309433,2,22),(6578454,53309436,2,23),(6578454,53309438,2,24),(6578454,53309440,2,25),(6578454,53309443,2,26),(6578454,53309446,2,27),(6578454,53309449,2,28),(6578454,53309453,2,29),(6578454,53309457,2,30),(6578454,53309460,2,31),(6578454,53309462,2,32),(6578454,53309464,2,33),(6578454,53309466,2,34),(6578454,53309469,2,35),(6578454,53309473,2,36),(6578454,53309476,2,37),(6578454,53309477,2,38),(6578454,53309480,2,39),(6578454,53309482,2,40),(6578454,53309483,2,41),(6578454,53309485,2,42),(6584903,53316105,6,1),(6584903,53316074,6,2),(6584906,53319479,3,1),(6584906,53319482,3,2),(6584908,53315884,3,1),(6584908,53315943,3,2),(6584908,53315948,3,3),(6584908,53315952,3,4),(6584908,53315955,3,5),(6584908,53316065,3,6),(6584908,53319482,3,7),(6584908,53316068,3,8),(6584908,53316074,3,9),(6584908,53319484,3,10),(6584910,53319489,3,1),(6584910,53319487,3,2),(6584910,266330795,3,3),(6584910,266330794,3,4),(6584910,266330793,3,5),(6584910,266330483,3,6),(6584917,51552726,5,1),(6584917,53330453,5,2),(6584917,53330450,5,3),(6584917,53327626,5,4),(6584920,53319514,3,1),(6584920,53319515,3,2),(6584920,53319517,3,3),(6584920,53319520,3,4),(6584920,53319521,3,5),(6584920,53319523,3,6),(6584920,53319525,3,7),(6584920,53319529,3,8),(6584920,53319532,3,9),(6584920,53319533,3,10),(6584925,53319535,2,1),(6584925,53319536,2,2),(6584925,53319538,2,3),(6584925,53319539,2,4),(6584925,53319541,2,5),(6584925,53319543,2,6),(6584925,53319545,2,7),(6584925,53319547,2,8),(6584925,53319548,2,9),(6584925,53319551,2,10),(6584925,53319552,2,11),(6584925,53319554,2,12),(6584928,53319555,2,1),(6584928,53319557,2,2),(6584939,53319705,3,1),(6584939,53319703,3,2),(6584939,53319702,3,3),(6584939,53319701,3,4),(6584939,53319700,3,5),(6584939,53319697,3,6),(6584939,53319695,3,7),(6584939,53319693,3,8),(6584939,53319690,3,9),(6584939,53319688,3,10),(6584939,53319687,3,11),(6584939,53319686,3,12),(6584939,53325732,3,13),(6584939,53319684,3,14),(6584939,53319682,3,15),(6584939,53319681,3,16),(6584939,53319678,3,17),(6584939,53325674,3,18),(6584939,53319675,3,19),(6584939,53319672,3,20),(6584939,53319670,3,21),(6584939,53319669,3,22),(6584939,53319667,3,23),(6584939,53319666,3,24),(6584939,53319665,3,25),(6584939,53319664,3,26),(6584939,53319663,3,27),(6584939,53325663,3,28),(6584947,53319784,5,1),(6584947,53319782,5,2),(6584947,53319781,5,3),(6584947,53319778,5,4),(6584947,53319777,5,5),(6584947,53319774,5,6),(6584947,53319773,5,7),(6584947,53319770,5,8),(6584947,53319768,5,9),(6584947,53319765,5,10),(6584947,53319761,5,11),(6584947,53319759,5,12),(6584947,53319758,5,13),(6584947,53319756,5,14),(6584947,53319755,5,15),(6584947,53319753,5,16),(6584947,53319752,5,17),(6584947,53319750,5,18),(6584947,53319749,5,19),(6584947,53319747,5,20),(6584951,268082898,4,1),(6584951,268082899,4,2),(6584951,53319786,4,3),(6584951,53319787,4,4),(6584956,53319789,4,1),(6584956,53319790,4,2),(6584956,268082898,4,3),(6584956,53319793,4,4),(6584956,53319796,4,5),(6584956,53319797,4,6),(6584956,53319800,4,7),(6584956,53319801,4,8),(6584956,53319804,4,9),(6584956,53319806,4,10),(6584956,53319807,4,11),(6584961,53319809,2,1),(6584961,53319811,2,2),(6584961,53319813,2,3),(6584961,53319815,2,4),(6584961,53319816,2,5),(6584961,53319817,2,6),(6584961,53319818,2,7),(6584961,53319819,2,8),(6584961,53319820,2,9),(6584961,53319821,2,10),(6584961,53319822,2,11),(6584961,53319823,2,12),(6584961,53319826,2,13),(6584961,53319828,2,14),(6588508,53325664,2,1),(6588508,53325666,2,2),(6588508,53325669,2,3),(6588508,53325671,2,4),(6588508,53325672,2,5),(6588508,53325674,2,6),(6588510,53325677,2,1),(6588510,53325680,2,2),(6588510,53325681,2,3),(6588510,53325699,2,4),(6588510,53325706,2,5),(6588510,53319687,2,6),(6588513,53319720,5,1),(6588513,53325746,5,2),(6588513,53325743,5,3),(6588513,53325742,5,4),(6588513,53325739,5,5),(6588513,53325736,5,6),(6588513,53325817,5,7),(6588513,53325735,5,8),(6588513,53325709,5,9),(6588516,53325748,6,1),(6588516,53325750,6,2),(6588516,53325752,6,3),(6588516,53325792,6,4),(6588516,53325795,6,5),(6588516,53325798,6,6),(6588516,53325801,6,7),(6588516,53325802,6,8),(6588516,53325805,6,9),(6588516,53325807,6,10),(6588516,53325809,6,11),(6588516,53325813,6,12),(6588516,53325815,6,13),(6588519,53325818,5,1),(6588519,261013457,5,2),(6588519,261013458,5,3),(6588519,53325820,5,4),(6588519,261013459,5,5),(6588519,53325815,5,6),(6589890,53327629,4,1),(6589890,53327630,4,2),(6589890,53327633,4,3),(6589890,53327636,4,4),(6589890,53327637,4,5),(6589890,53327639,4,6),(6589890,53327642,4,7),(6589890,53327646,4,8),(6589890,53327649,4,9),(6589890,53327652,4,10),(6589890,53327654,4,11),(6589890,53327657,4,12),(6589890,53327661,4,13),(6589890,53327664,4,14),(6589890,53327667,4,15),(6589890,53327669,4,16),(6589890,53327672,4,17),(6589890,53327675,4,18),(6589890,53327678,4,19),(6589890,53327682,4,20),(6589890,53327685,4,21),(6589890,53327686,4,22),(6589890,53327689,4,23),(6589890,53327693,4,24),(6589890,53327696,4,25),(6589890,53327697,4,26),(6589890,53327700,4,27),(6589890,53327703,4,28),(6589890,53327705,4,29),(6589890,53327706,4,30),(6589890,53327708,4,31),(6589890,53327710,4,32),(6589890,53327712,4,33),(6589890,53327716,4,34),(6589890,53327717,4,35),(6589890,53327720,4,36),(6589890,53327721,4,37),(6589890,53327724,4,38),(6589890,53327726,4,39),(6589890,53327728,4,40),(6589890,53327730,4,41),(6589890,53327733,4,42),(6589890,53327734,4,43),(6589890,53327735,4,44),(6589890,53327736,4,45),(6589890,53327737,4,46),(6589890,53327738,4,47),(6589890,53327739,4,48),(6589890,53327741,4,49),(6589898,53327882,2,1),(6589898,53327880,2,2),(6589898,53327879,2,3),(6589898,53327877,2,4),(6589898,53327875,2,5),(6589898,53327873,2,6),(6589898,53327855,2,7),(6589898,53327853,2,8),(6589898,53327851,2,9),(6589898,53327844,2,10),(6589898,53327838,2,11),(6589898,53327836,2,12),(6589898,53327833,2,13),(6589898,53327830,2,14),(6589898,53327826,2,15),(6589898,53327824,2,16),(6589898,53327821,2,17),(6589898,53327818,2,18),(6589898,53327814,2,19),(6589898,53327815,2,20),(6589898,51552740,2,21),(6590538,53330420,2,1),(6590538,53330432,2,2);
INSERT INTO `way_nodes` VALUES (6590538,53330444,2,3),(6590538,53330446,2,4),(6590538,53330448,2,5),(6590538,53319576,2,6),(6592657,53334410,3,1),(6592657,53334413,3,2),(6592657,53334414,3,3),(6592657,53334417,3,4),(6592657,53334419,3,5),(6592657,53334421,3,6),(6592657,53334422,3,7),(6592657,53334423,3,8),(6592657,53334424,3,9),(6592657,53334427,3,10),(6592657,53334428,3,11),(6592657,53334431,3,12),(6592657,53334432,3,13),(6592657,53334433,3,14),(6592657,53334437,3,15),(6592657,53334441,3,16),(6592657,53334442,3,17),(6592657,53334444,3,18),(6592657,53334448,3,19),(6592657,51581633,3,20),(6593464,53335700,4,1),(6593464,53335702,4,2),(6593464,53335703,4,3),(6593464,53335707,4,4),(6593464,53335710,4,5),(6593464,53335714,4,6),(6593464,53335715,4,7),(6593464,53335717,4,8),(6593464,53335718,4,9),(6593464,53335719,4,10),(6593464,53335720,4,11),(6593464,53335721,4,12),(6593464,53335722,4,13),(6593464,53335723,4,14),(6593464,53335724,4,15),(6593464,53335727,4,16),(6593464,53335730,4,17),(6593464,53335733,4,18),(6593464,53335738,4,19),(6593464,53335740,4,20),(6593464,53335742,4,21),(6593464,53335743,4,22),(6593464,53335744,4,23),(6593464,53335745,4,24),(6593464,53335746,4,25),(6593464,53335747,4,26),(6593464,53335750,4,27),(6593464,53335752,4,28),(6593464,53335755,4,29),(6593464,53335756,4,30),(6593464,53335759,4,31),(6593464,53335762,4,32),(6593464,53335764,4,33),(6593464,53335766,4,34),(6593464,53335768,4,35),(6593464,53335771,4,36),(6593464,53335776,4,37),(6593464,53335779,4,38),(6593464,53335782,4,39),(6593464,53335783,4,40),(6593464,53335700,4,41),(6602616,53352638,3,1),(6602616,53352642,3,2),(6602616,53352645,3,3),(6602616,53352648,3,4),(6602616,53352650,3,5),(6602616,53352704,3,6),(6602616,53352708,3,7),(6602616,53352723,3,8),(6602616,53352737,3,9),(6602616,53352766,3,10),(6602616,53352774,3,11),(6602616,53352779,3,12),(6602616,53352796,3,13),(6602616,53352802,3,14),(6602616,53352807,3,15),(6602616,53352812,3,16),(6602616,53352849,3,17),(6602616,53352853,3,18),(6602616,53352860,3,19),(6602616,53352863,3,20),(6602616,53352868,3,21),(6602616,53352871,3,22),(6602616,53352873,3,23),(6602616,53352876,3,24),(6602616,53352878,3,25),(6602616,53352883,3,26),(6602616,53352887,3,27),(6602616,53352890,3,28),(6602616,53352894,3,29),(6602616,53352896,3,30),(6602616,53352899,3,31),(6602616,53352904,3,32),(6602616,53352906,3,33),(6602616,53352907,3,34),(6602616,53352912,3,35),(6602616,53352934,3,36),(6602616,53352938,3,37),(6602616,53352942,3,38),(6602616,53352946,3,39),(6602616,53352948,3,40),(6602616,53352951,3,41),(6602616,53352954,3,42),(6602616,53352957,3,43),(6602616,53352960,3,44),(6602616,53352963,3,45),(6602616,53352966,3,46),(6602616,53352969,3,47),(6602616,53352974,3,48),(6602616,53352975,3,49),(6602616,53353016,3,50),(6602616,53353021,3,51),(6602616,53353024,3,52),(6602616,53353034,3,53),(6602616,53353040,3,54),(6602616,53353043,3,55),(6602616,53353047,3,56),(6602616,53353051,3,57),(6602616,53353055,3,58),(6602616,53353086,3,59),(6602616,53353092,3,60),(6602616,53353108,3,61),(6602616,53353111,3,62),(6602616,53353121,3,63),(6602616,53353126,3,64),(6602616,53353132,3,65),(6602616,53353137,3,66),(6602616,53352638,3,67),(6620914,51563374,2,1),(6620914,53368914,2,2),(6620914,53368899,2,3),(6620917,53368914,2,1),(6620917,53368953,2,2),(6620920,53368932,2,1),(6620920,53368942,2,2),(6620926,53368973,2,1),(6620926,53368998,2,2),(6620926,53369007,2,3),(6620926,53369015,2,4),(6620926,53369038,2,5),(6620926,53370808,2,6),(6620926,53370819,2,7),(6620926,53370838,2,8),(6620926,53370844,2,9),(6620926,53370871,2,10),(6620926,53370880,2,11),(6620926,53370887,2,12),(6620926,53370890,2,13),(6620926,53370895,2,14),(6620926,53370900,2,15),(6620926,53370906,2,16),(6620926,53370914,2,17),(6620926,53370920,2,18),(6620926,53370935,2,19),(6620926,53370942,2,20),(6620926,53370949,2,21),(6620926,53370956,2,22),(6620926,53370959,2,23),(6620926,53371037,2,24),(6620926,53371050,2,25),(6620926,53371067,2,26),(6620926,53371073,2,27),(6620926,53371079,2,28),(6620926,53371084,2,29),(6620926,53371089,2,30),(6620926,53371093,2,31),(6620926,53371101,2,32),(6620926,53371106,2,33),(6620926,53371115,2,34),(6620926,53371121,2,35),(6620926,53371129,2,36),(6620930,53371804,2,1),(6620930,53371810,2,2),(6620930,53371816,2,3),(6620930,53371823,2,4),(6620930,53371827,2,5),(6620930,53371833,2,6),(6620930,53371840,2,7),(6620930,53371845,2,8),(6620930,53371850,2,9),(6620930,53371856,2,10),(6620930,53371859,2,11),(6620940,53377151,7,1),(6620940,53381779,7,2),(6620940,53381738,7,3),(6620940,53381733,7,4),(6620940,53381723,7,5),(6620940,53381711,7,6),(6620940,53380503,7,7),(6620940,53380499,7,8),(6620940,53380491,7,9),(6620940,53380489,7,10),(6620940,53380485,7,11),(6620940,53380480,7,12),(6620940,53380473,7,13),(6620940,53377195,7,14),(6620940,53377191,7,15),(6620940,53377186,7,16),(6620940,53377183,7,17),(6620940,367683366,7,18),(6620940,53377180,7,19),(6620940,53377178,7,20),(6620940,53377175,7,21),(6620940,53377168,7,22),(6620940,53377163,7,23),(6620940,53377156,7,24),(6620940,53377151,7,25),(6620940,53377146,7,26),(6620940,53377141,7,27),(6620940,53377138,7,28),(6620940,53377133,7,29),(6620940,53377128,7,30),(6620940,53377124,7,31),(6620940,321683544,7,32),(6620940,53377119,7,33),(6620940,53377113,7,34),(6620940,53377104,7,35),(6620940,53377098,7,36),(6620940,53377093,7,37),(6620940,53377090,7,38),(6620940,53377080,7,39),(6620940,53377077,7,40),(6620940,53377070,7,41),(6620940,53377068,7,42),(6620940,53377065,7,43),(6620940,53377061,7,44),(6620940,53377058,7,45),(6620940,53377053,7,46),(6620940,53377051,7,47),(6620940,53377049,7,48),(6620940,53377047,7,49),(6620940,53377045,7,50),(6620940,53377040,7,51),(6620940,53377035,7,52),(6620940,53377032,7,53),(6620940,53377027,7,54),(6620940,53377021,7,55),(6620940,53377018,7,56),(6620940,53377015,7,57),(6620940,53377009,7,58),(6620940,53377006,7,59),(6620940,53377001,7,60),(6620940,53376996,7,61),(6620940,53376989,7,62),(6620940,53376987,7,63),(6620940,53376983,7,64),(6620940,53376979,7,65),(6620940,53376975,7,66),(6620940,53376972,7,67),(6620940,53376968,7,68),(6620940,53376955,7,69),(6620940,53376959,7,70),(6620940,53376962,7,71),(6620940,53376964,7,72),(6620947,53382002,1,1),(6620947,53381787,1,2),(6620947,53381798,1,3),(6620947,53381809,1,4),(6620947,53381818,1,5),(6620947,53381825,1,6),(6620947,53381829,1,7),(6620947,53381832,1,8),(6620947,53381834,1,9),(6620947,53381837,1,10),(6620947,53381842,1,11),(6620947,53381844,1,12),(6620947,53381850,1,13),(6620947,53381892,1,14),(6620947,53381925,1,15),(6620947,53381944,1,16),(6620947,53381947,1,17),(6620947,53381978,1,18),(6620947,53381995,1,19),(6620947,53382002,1,20),(6620952,53383424,1,1),(6620952,53383364,1,2),(6620952,53383369,1,3),(6620952,53383373,1,4),(6620952,53383379,1,5),(6620952,53383384,1,6),(6620952,53383388,1,7),(6620952,53383393,1,8),(6620952,53383398,1,9),(6620952,53383403,1,10),(6620952,53383409,1,11),(6620952,53383415,1,12),(6620952,53383419,1,13),(6620952,53383424,1,14),(6620955,53383474,1,1),(6620955,53383480,1,2),(6620955,53383487,1,3),(6620955,53383494,1,4),(6620955,53383497,1,5),(6620955,53383499,1,6),(6620955,53383505,1,7),(6620955,53383508,1,8),(6620955,53383523,1,9),(6620955,53383429,1,10),(6620955,53383434,1,11),(6620955,53383440,1,12),(6620955,53383445,1,13),(6620955,53383451,1,14),(6620955,53383455,1,15),(6620955,53383459,1,16),(6620955,53383468,1,17),(6620955,53383474,1,18),(6620958,53383582,1,1),(6620958,53383584,1,2),(6620958,53383597,1,3),(6620958,53383600,1,4),(6620958,53383603,1,5),(6620958,53383605,1,6),(6620958,53383606,1,7),(6620958,53383610,1,8),(6620958,53383612,1,9),(6620958,53383614,1,10),(6620958,53383617,1,11),(6620958,53383620,1,12),(6620958,53383622,1,13),(6620958,53383624,1,14),(6620958,53383626,1,15),(6620958,53383628,1,16),(6620958,53383631,1,17),(6620958,53383634,1,18),(6620958,53383636,1,19),(6620958,53383556,1,20),(6620958,53383559,1,21),(6620958,53383561,1,22),(6620958,53383562,1,23),(6620958,53383566,1,24),(6620958,53383579,1,25),(6620958,53383582,1,26),(6620962,53383728,1,1),(6620962,53383735,1,2),(6620962,53383739,1,3),(6620962,53383762,1,4),(6620962,53383772,1,5),(6620962,53383793,1,6),(6620962,53383842,1,7),(6620962,53383953,1,8),(6620962,53383956,1,9),(6620962,53383639,1,10),(6620962,53383643,1,11),(6620962,53383646,1,12),(6620962,53383670,1,13),(6620962,53383680,1,14),(6620962,53383685,1,15),(6620962,53383688,1,16),(6620962,53383691,1,17),(6620962,53383694,1,18),(6620962,53383698,1,19),(6620962,53383728,1,20),(6620964,53384026,1,1),(6620964,53383958,1,2),(6620964,53383961,1,3),(6620964,53383970,1,4),(6620964,53383987,1,5),(6620964,53383990,1,6),(6620964,53384000,1,7),(6620964,53384003,1,8),(6620964,53384008,1,9),(6620964,53384011,1,10),(6620964,53384013,1,11),(6620964,53384016,1,12),(6620964,53384020,1,13),(6620964,53384024,1,14),(6620964,53384026,1,15),(6620969,53384030,1,1),(6620969,53384033,1,2),(6620969,53384036,1,3),(6620969,53384038,1,4),(6620969,53384040,1,5),(6620969,53384065,1,6),(6620969,53384068,1,7),(6620969,53384120,1,8),(6620969,53384283,1,9),(6620969,53384287,1,10),(6620969,53384302,1,11),(6620969,53384325,1,12),(6620969,53384330,1,13),(6620969,53384332,1,14),(6620969,53384335,1,15),(6620969,53384338,1,16),(6620969,53384375,1,17),(6620969,53385461,1,18),(6620969,53385467,1,19),(6620969,53385484,1,20),(6620969,53385511,1,21),(6620969,53387182,1,22),(6620969,53388340,1,23),(6620969,53388543,1,24),(6620969,53389302,1,25),(6620969,53389827,1,26),(6620969,53390266,1,27),(6620969,53390450,1,28),(6620969,53390493,1,29),(6620969,53390505,1,30),(6620969,53390513,1,31),(6620969,53390521,1,32),(6620969,53390534,1,33),(6620969,53390548,1,34),(6620969,53390624,1,35),(6620969,53390658,1,36),(6620969,53390732,1,37),(6620969,53390740,1,38),(6620969,53390749,1,39),(6620969,53390776,1,40),(6620969,53384030,1,41),(6620973,53392141,1,1),(6620973,53390786,1,2),(6620973,53392096,1,3),(6620973,53392102,1,4),(6620973,53392109,1,5),(6620973,53392116,1,6),(6620973,53392136,1,7),(6620973,53392141,1,8),(6620978,53392200,1,1),(6620978,53392203,1,2),(6620978,53392147,1,3),(6620978,53392151,1,4),(6620978,53392160,1,5),(6620978,53392164,1,6),(6620978,53392166,1,7),(6620978,53392168,1,8),(6620978,53392180,1,9),(6620978,53392185,1,10),(6620978,53392195,1,11),(6620978,53392200,1,12),(6620980,53392235,1,1),(6620980,53392239,1,2),(6620980,53392207,1,3),(6620980,53392208,1,4),(6620980,53392215,1,5),(6620980,53392222,1,6),(6620980,53392224,1,7),(6620980,53392227,1,8),(6620980,53392235,1,9),(7934428,59015921,3,1),(7934428,59015924,3,2),(7934428,59015925,3,3),(7934428,59015926,3,4),(7934428,59015927,3,5),(7934428,59015928,3,6),(7934428,59015929,3,7),(7934428,59015930,3,8),(7934428,59015931,3,9),(7934428,59015932,3,10),(7934428,59015933,3,11),(7934428,59015934,3,12),(7934443,59016173,2,1),(7934443,59016174,2,2),(7934443,59016175,2,3),(7934443,59015926,2,4),(8164186,45161333,11,1),(8164186,45161330,11,2),(8164186,45161344,11,3),(8164186,45161251,11,4),(8164186,45161256,11,5),(8164186,45161262,11,6),(8164186,45161227,11,7),(8164186,45161231,11,8),(8164186,45161233,11,9),(8164186,45161238,11,10),(8164186,45161289,11,11),(8164186,45161296,11,12),(8164186,45161302,11,13),(8164186,45161308,11,14),(8164186,45161265,11,15),(8164186,45161269,11,16),(8164186,45161277,11,17),(8164186,45161283,11,18),(8164186,45161067,11,19),(8164186,45161066,11,20),(8164186,45161062,11,21),(8164186,45161058,11,22),(8164186,45161208,11,23),(8164186,45161204,11,24),(8164186,45160922,11,25),(8164186,45160924,11,26),(8164186,45160974,11,27),(8164186,45160977,11,28),(8164186,45160962,11,29),(8164186,45160967,11,30),(8164186,45160954,11,31),(8164186,45160958,11,32),(8164452,52166749,3,1),(8164452,52166950,3,2),(8164478,52263727,2,1),(8164478,52263678,2,2),(8164478,52263677,2,3),(8164597,52650659,3,1),(8164597,52650158,3,2),(8164597,52650131,3,3),(8164597,52652477,3,4),(8164597,52652555,3,5),(8164597,52661498,3,6),(8164597,52672004,3,7),(8164597,52672499,3,8),(8164597,52675912,3,9),(8164597,52676235,3,10),(8164597,52676253,3,11),(8164597,52676260,3,12),(8164597,52676267,3,13),(8164597,52676295,3,14),(8164597,52676338,3,15),(8164597,52676349,3,16),(8164597,52676434,3,17),(8164597,52676891,3,18),(8164597,52676911,3,19),(8164597,52677089,3,20),(8164597,52677154,3,21),(8164597,52677211,3,22),(8164597,52677635,3,23),(8164597,52677662,3,24),(8164597,52677757,3,25),(8164597,52677811,3,26),(8164597,52677844,3,27),(8164597,52677862,3,28),(8164597,52677872,3,29),(8164597,52677878,3,30),(8164597,52677908,3,31),(8164597,52677912,3,32),(8164597,52677918,3,33),(8164597,52677922,3,34),(8164597,52677929,3,35),(8164597,52677934,3,36),(8164597,52677939,3,37),(8164597,52677945,3,38),(8164597,52677993,3,39),(8164597,52678005,3,40),(8164597,52678200,3,41),(8164597,52678225,3,42),(8164597,52678243,3,43),(8164597,52678266,3,44),(8164597,52678278,3,45),(8164597,52678285,3,46),(8164597,52678294,3,47),(8164597,52678450,3,48),(8164597,52678519,3,49),(8164597,52678582,3,50),(8164597,52678634,3,51),(8164597,52678741,3,52),(8164597,52678786,3,53),(8164597,52678860,3,54),(8164597,52679237,3,55),(8164597,52679255,3,56),(8164597,52679261,3,57),(8164597,52679265,3,58),(8164597,52679271,3,59),(8164597,52679365,3,60),(8164597,52679445,3,61),(8164597,52679499,3,62),(8164597,52679531,3,63),(8164597,52679731,3,64),(8164597,52679744,3,65),(8164597,52679804,3,66),(8164597,52679809,3,67),(8164597,52679815,3,68),(8164597,52679821,3,69),(8164597,52679879,3,70),(8164597,52679882,3,71),(8164597,52679888,3,72),(8164597,52679894,3,73),(8164597,52679900,3,74),(8164597,52679906,3,75),(8164597,52679911,3,76),(8164597,52679979,3,77),(8164597,52679994,3,78),(8164597,52680005,3,79),(8164597,52680012,3,80),(8164597,52680017,3,81),(8164597,52680024,3,82),(8164597,52680029,3,83),(8164597,52680039,3,84),(8164597,52680048,3,85),(8164597,52680059,3,86),(8164597,52680077,3,87),(8164597,52680086,3,88),(8164597,52680095,3,89),(8164597,52680105,3,90),(8164597,52680117,3,91),(8164597,52680128,3,92),(8164597,52680141,3,93),(8164597,52680157,3,94),(8164597,52680171,3,95),(8164597,52680195,3,96),(8164597,52680202,3,97),(8164597,52680255,3,98),(8164597,52680269,3,99),(8164597,52680280,3,100),(8164597,52680289,3,101),(8164597,52680402,3,102),(8164597,52680426,3,103),(8164597,52680437,3,104),(8164597,52680448,3,105),(8164597,52680465,3,106),(8164597,52680561,3,107),(8164597,52680566,3,108),(8164597,52680570,3,109),(8164597,52680574,3,110),(8164597,52680577,3,111),(8164597,52680579,3,112),(8164597,52680583,3,113),(8164597,52680592,3,114),(8164597,52680597,3,115),(8164597,52680599,3,116),(8164597,52680606,3,117),(8164597,52680610,3,118),(8164597,52680616,3,119),(8164597,52680618,3,120),(8164597,52680624,3,121),(8164597,52680637,3,122),(8164597,52680643,3,123),(8164597,52680648,3,124),(8164597,52680653,3,125),(8164597,52680657,3,126),(8164597,52680660,3,127),(8164597,52680663,3,128),(8164597,52680674,3,129),(8164597,52680676,3,130),(8164597,52680679,3,131),(8164597,52680683,3,132),(8164597,52680692,3,133),(8164597,52680695,3,134),(8164597,52680698,3,135),(8164597,52680703,3,136),(8164597,52680706,3,137),(8164597,52680712,3,138),(8164597,52680715,3,139),(8164597,52680717,3,140),(8164597,52680719,3,141),(8164597,52680722,3,142),(8164597,52680727,3,143),(8164597,52680731,3,144),(8164597,52680735,3,145),(8164597,52680736,3,146),(8164597,52680739,3,147),(8164597,52680744,3,148),(8164597,52680747,3,149),(8164597,52680751,3,150),(8164597,52680753,3,151),(8164597,52680755,3,152),(8164597,52680757,3,153),(8164597,52680759,3,154),(8164597,52680760,3,155),(8164597,52680763,3,156),(8164597,52680767,3,157),(8164597,52680769,3,158),(8164597,52680773,3,159),(8164597,52680776,3,160),(8164597,52680780,3,161),(8164597,52680782,3,162),(8164597,52680784,3,163),(8164597,52680787,3,164),(8164597,52680789,3,165),(8164597,52680794,3,166),(8164597,52680797,3,167),(8164597,52680799,3,168),(8164597,52680803,3,169),(8164597,52680806,3,170),(8164597,52680810,3,171),(8164597,52680813,3,172),(8164597,52680815,3,173),(8164597,52680818,3,174),(8164597,52680820,3,175),(8164597,52680823,3,176),(8164597,52680825,3,177),(8164597,52680828,3,178),(8164597,52680830,3,179),(8164597,52680832,3,180),(8164597,52680836,3,181),(8164597,52680838,3,182),(8164597,52680839,3,183),(8164597,52680842,3,184),(8164597,52680844,3,185),(8164597,52680847,3,186),(8164597,52680850,3,187),(8164597,52680852,3,188),(8164597,52680855,3,189),(8164597,52680858,3,190),(8164597,52680860,3,191),(8164597,52680866,3,192),(8164597,52680869,3,193),(8164597,52680871,3,194),(8164597,52680874,3,195),(8164597,52680877,3,196),(8164597,52680879,3,197),(8164597,52680883,3,198),(8164597,52680913,3,199),(8164597,52680960,3,200),(8164597,52681009,3,201),(8164597,52681026,3,202),(8164597,52681028,3,203),(8164597,52681343,3,204),(8164597,52681347,3,205),(8164597,52681350,3,206),(8164597,52681355,3,207),(8164597,52681357,3,208),(8164597,52681361,3,209),(8164597,52681362,3,210),(8164597,52681366,3,211),(8164597,52681368,3,212),(8164597,52681372,3,213),(8164597,52681374,3,214),(8164597,52681375,3,215),(8164597,52681378,3,216),(8164597,52681380,3,217),(8164597,52681382,3,218),(8164597,52681384,3,219),(8164597,52681386,3,220),(8164597,52681390,3,221),(8164597,52681392,3,222),(8164597,52681393,3,223),(8164597,52681394,3,224),(8164597,52681395,3,225),(8164597,52681398,3,226),(8164597,52681400,3,227),(8164597,52681405,3,228),(8164597,52681407,3,229),(8164597,52681409,3,230),(8164597,52681412,3,231),(8164597,52681429,3,232),(8164597,52681414,3,233),(8164597,52681416,3,234),(8164597,52681417,3,235),(8164597,52681420,3,236),(8164597,52681422,3,237),(8164597,52681423,3,238),(8164597,52681431,3,239),(8164597,52681425,3,240),(8164597,52681427,3,241),(8164597,52681432,3,242),(8164597,52681434,3,243),(8164597,52681439,3,244),(8164597,52681462,3,245),(8164597,52681464,3,246),(8164597,52681465,3,247),(8164597,52681466,3,248),(8164597,52681468,3,249),(8164597,52681471,3,250),(8164597,52681474,3,251),(8164597,52681476,3,252),(8164597,52681478,3,253),(8164597,52681481,3,254),(8164597,52681484,3,255),(8164597,52681487,3,256),(8164597,52681492,3,257),(8164597,52681493,3,258),(8164597,52681496,3,259),(8164597,52681499,3,260),(8164597,52681500,3,261),(8164597,52681503,3,262),(8164597,52681508,3,263),(8164597,52681510,3,264),(8164597,52681511,3,265),(8164597,52681514,3,266),(8164597,52681516,3,267),(8164597,52681518,3,268),(8164597,52681521,3,269),(8164597,52681526,3,270),(8164597,52681528,3,271),(8164597,52681531,3,272),(8164597,52681533,3,273),(8164597,52681535,3,274),(8164597,52681537,3,275),(8164597,52681539,3,276),(8164597,52681541,3,277),(8164597,52681544,3,278),(8164597,52681547,3,279),(8164597,52681576,3,280),(8164597,52681551,3,281),(8164597,52681571,3,282),(8164597,52681553,3,283),(8164597,52681557,3,284),(8164597,52681568,3,285),(8164597,52681578,3,286),(8164597,52681582,3,287),(8164597,52681586,3,288),(8164597,52681589,3,289),(8164597,52681593,3,290),(8164597,52681596,3,291),(8164597,52681598,3,292),(8164597,52681600,3,293),(8164597,52681603,3,294),(8164597,52681605,3,295),(8164597,52681608,3,296),(8164597,52681610,3,297),(8164597,52681613,3,298),(8164597,52681615,3,299),(8164597,52681619,3,300),(8164597,52681648,3,301),(8164597,52681683,3,302),(8164597,52681949,3,303),(8164597,52682060,3,304),(8164597,52682050,3,305),(8164597,52682055,3,306),(8164597,52682039,3,307),(8164597,52682044,3,308),(8164597,52682047,3,309),(8164597,52682065,3,310),(8164597,52682068,3,311),(8164597,52682070,3,312),(8164597,52682072,3,313),(8164597,52682091,3,314),(8164597,52682096,3,315),(8164597,52682101,3,316),(8164597,52682123,3,317),(8164597,52682126,3,318),(8164597,52682128,3,319),(8164597,52682132,3,320),(8164597,52682135,3,321),(8164597,52682140,3,322),(8164597,52682143,3,323),(8164597,52682146,3,324),(8164597,52682150,3,325),(8164597,52682152,3,326),(8164597,52682156,3,327),(8164597,52682160,3,328),(8164597,52682164,3,329),(8164597,52682168,3,330),(8164597,52682170,3,331),(8164597,52682174,3,332),(8164597,52682178,3,333),(8164597,52682180,3,334),(8164597,52682184,3,335),(8164597,52682186,3,336),(8164597,52682190,3,337),(8164597,52682195,3,338),(8164597,52682197,3,339),(8164597,52682200,3,340),(8164597,52682202,3,341),(8164597,52682215,3,342),(8164597,52682204,3,343),(8164597,52682216,3,344),(8164597,52682207,3,345),(8164597,52682210,3,346),(8164597,52682212,3,347),(8164597,52682221,3,348),(8164597,52682224,3,349),(8164597,52682227,3,350),(8164597,52682231,3,351),(8164597,52682235,3,352),(8164597,52682238,3,353),(8164597,52682240,3,354),(8164597,52682243,3,355),(8164597,52682244,3,356),(8164597,52682247,3,357),(8164597,52682250,3,358),(8164597,52682253,3,359),(8164597,52682255,3,360),(8164597,52682257,3,361),(8164597,52682259,3,362),(8164597,52682262,3,363),(8164597,52682265,3,364),(8164597,52682270,3,365),(8164597,52682272,3,366),(8164597,52682274,3,367),(8164597,52682277,3,368),(8164597,52682524,3,369),(8164597,52682546,3,370),(8164597,52682558,3,371),(8164597,52682617,3,372),(8164597,52682663,3,373),(8164597,52682673,3,374),(8164597,52685135,3,375),(8164597,52685138,3,376),(8164597,52685142,3,377),(8164597,52685145,3,378),(8164597,52685147,3,379),(8164597,52685151,3,380),(8164597,52685154,3,381),(8164597,52685157,3,382),(8164597,52685160,3,383),(8164597,52685162,3,384),(8164597,52685166,3,385),(8164597,52685169,3,386),(8164597,52685171,3,387),(8164597,52685184,3,388),(8164597,52685190,3,389),(8164597,52685195,3,390),(8164597,52685199,3,391),(8164597,52685202,3,392),(8164597,52685204,3,393),(8164597,52685207,3,394),(8164597,52685211,3,395),(8164597,52685217,3,396),(8164597,52685220,3,397),(8164597,52685226,3,398),(8164597,52685229,3,399),(8164597,52685232,3,400),(8164597,52685236,3,401),(8164597,52685238,3,402),(8164597,52685243,3,403),(8164597,52685247,3,404),(8164597,52685258,3,405),(8164597,52685262,3,406),(8164597,52685269,3,407),(8164597,52685275,3,408),(8164597,52685277,3,409),(8164597,52685282,3,410),(8164597,52685296,3,411),(8164597,52685299,3,412),(8164597,52685307,3,413),(8164597,52685313,3,414),(8164653,52801807,3,1),(8164653,52801809,3,2),(8164653,52801813,3,3),(8164653,52801816,3,4),(8164653,52801819,3,5),(8164653,52801824,3,6),(8164653,52801827,3,7),(8164653,52801876,3,8),(8164653,52802034,3,9),(8164653,52802158,3,10),(8164653,52802159,3,11),(8164653,52802160,3,12),(8164653,52802161,3,13),(8164653,52802162,3,14),(8164653,52802163,3,15),(8164653,52802164,3,16),(8164653,52802165,3,17),(8164653,52802166,3,18),(8164653,52802167,3,19),(8164653,52803327,3,20),(8164653,52802168,3,21),(8164653,52802169,3,22),(8164653,52802170,3,23),(8164653,52802171,3,24),(8164653,52802172,3,25),(8164653,52802173,3,26),(8164653,52802183,3,27),(8164653,52802197,3,28),(8164653,52802210,3,29),(8164653,52802216,3,30),(8164653,52802218,3,31),(8164653,52802229,3,32),(8164653,52802260,3,33),(8164653,52803163,3,34),(8164653,52803175,3,35),(8164653,52803179,3,36),(8164653,52803182,3,37),(8164653,52803183,3,38),(8164653,52803186,3,39),(8164653,52803189,3,40),(8164653,52803191,3,41),(8164653,52803194,3,42),(8164653,52803195,3,43),(8164653,52803196,3,44),(8164653,52803197,3,45),(8164653,52803198,3,46),(8164653,52803200,3,47),(8164653,52803201,3,48),(8164653,52803202,3,49),(8164653,52803205,3,50),(8164653,52803207,3,51),(8164653,52803211,3,52),(8164653,52803214,3,53),(8164653,52803216,3,54),(8164653,52803218,3,55),(8164653,52803220,3,56),(8164653,52803222,3,57),(8164653,52803224,3,58),(8164653,52803225,3,59),(8164653,52803228,3,60),(8164653,52803229,3,61),(8164653,52803233,3,62),(8164653,52803235,3,63),(8164653,52803237,3,64),(8164653,52803239,3,65),(8164653,52803241,3,66),(8164653,52803243,3,67),(8164653,52803247,3,68),(8164653,52803251,3,69),(8164653,52803254,3,70),(8164653,52803255,3,71),(8164653,52803259,3,72),(8164653,52803263,3,73),(8164653,52803266,3,74),(8164653,52803269,3,75),(8164653,52803271,3,76),(8164653,52803273,3,77),(8166678,57627518,4,1),(8166678,57627519,4,2),(8166678,57627521,4,3),(8166678,57603545,4,4),(8166678,57603546,4,5),(8166678,57603547,4,6),(8166678,57603548,4,7),(8166678,57603549,4,8),(8166678,57603550,4,9),(8166678,57603551,4,10),(8166678,57603552,4,11),(8166678,57603553,4,12),(8166678,57603554,4,13),(8166678,57603555,4,14),(8166678,57603556,4,15),(8166678,57603557,4,16),(8166678,57603559,4,17),(8166678,57603560,4,18),(8166678,57603561,4,19),(8166678,57603562,4,20),(8166678,57603563,4,21),(8166678,57603564,4,22),(8166678,57603565,4,23),(8166678,57603566,4,24),(8166678,57603567,4,25),(8166678,57603568,4,26),(8166678,57603569,4,27),(8166678,57603570,4,28),(8166678,57603571,4,29),(8166678,57603572,4,30),(8166678,57603573,4,31),(8166678,57603574,4,32),(8166678,57603575,4,33),(8166678,57603994,4,34),(8166678,57603995,4,35),(8166678,57603996,4,36),(8166678,57603997,4,37),(8166678,57603998,4,38),(8166678,57603999,4,39),(8166678,57604000,4,40),(8166678,57604001,4,41),(8166678,57604002,4,42),(8166678,57604003,4,43),(8166678,57604004,4,44),(8166678,57604005,4,45),(8166678,57604006,4,46),(8166678,57607196,4,47),(8166678,57607197,4,48),(8166678,57607198,4,49),(8166678,57607199,4,50),(8166678,57607200,4,51),(8166678,57607201,4,52),(8166678,57607202,4,53),(8166678,57607203,4,54),(8166678,57607204,4,55),(8166678,57607205,4,56),(8166678,57607206,4,57),(8166678,57608723,4,58),(8166678,57608724,4,59),(8166678,57608725,4,60),(8166678,57608726,4,61),(8166678,57608727,4,62),(8166678,57608728,4,63),(8166678,57608729,4,64),(8166678,57608730,4,65),(8166678,57608731,4,66),(8166678,57608732,4,67),(8166678,57608735,4,68),(8166678,57608736,4,69),(8166678,57608737,4,70),(8166678,57608738,4,71),(8166678,57608739,4,72),(8166678,57608740,4,73),(8166678,57608741,4,74),(8166678,57608742,4,75),(8166678,57608743,4,76),(8166678,57608744,4,77),(8166678,57608745,4,78),(8166678,57608746,4,79),(8166678,57608748,4,80),(8166678,57608750,4,81),(8166678,57608751,4,82),(8166678,57608752,4,83),(8166678,57608754,4,84),(8166678,57608755,4,85),(8166678,57608756,4,86),(8166678,57608757,4,87),(8166678,57608758,4,88),(8166678,57608759,4,89),(8166678,57608760,4,90),(8166678,57608761,4,91),(8166678,57608762,4,92),(8166678,57608763,4,93),(8166678,57608764,4,94),(8166678,57608765,4,95),(8166678,57608766,4,96),(8166678,57608767,4,97),(8166678,57608768,4,98),(8166678,57608769,4,99),(8166678,57608770,4,100),(8166678,57608771,4,101),(8166678,57608772,4,102),(8166678,57608774,4,103),(8166678,57608776,4,104),(8166678,57608777,4,105),(8166678,57608778,4,106),(8166678,57611874,4,107),(8166678,57611875,4,108),(8166678,57611876,4,109),(8166678,57611877,4,110),(8166678,57611878,4,111),(8166678,57611879,4,112),(8166678,57611880,4,113),(8166678,57611881,4,114),(8166678,57611882,4,115),(8166678,57611883,4,116),(8166678,57611884,4,117),(8166678,57611885,4,118),(8166678,57611886,4,119),(8166678,57611887,4,120),(8166678,57611888,4,121),(8166678,57611889,4,122),(8166678,57611890,4,123),(8166678,57611891,4,124),(8166678,57611783,4,125),(8561013,52009151,5,1),(8561013,52009154,5,2),(8561432,51386298,3,1),(8561432,52252330,3,2),(8667300,53383297,1,1),(8667300,53383289,1,2),(8667300,53383286,1,3),(8667300,53383280,1,4),(8667300,53383258,1,5),(8667300,53383242,1,6),(8667300,53383168,1,7),(8667300,53382959,1,8),(8667300,53382509,1,9),(8667300,53382504,1,10),(8667300,53382318,1,11),(8667300,53382223,1,12),(8667300,53382156,1,13),(8667300,53382126,1,14),(8667300,53382106,1,15),(8667300,53382089,1,16),(8667300,53382064,1,17),(8667300,53382059,1,18),(8667300,53382055,1,19),(8667300,53382052,1,20),(8667300,53382047,1,21),(8667300,53382044,1,22),(8667300,53382041,1,23),(8667300,53382033,1,24),(8667300,53382028,1,25),(8667300,53382019,1,26),(8667300,53382009,1,27),(8667300,53383356,1,28),(8667300,53383350,1,29),(8667300,53383341,1,30),(8667300,53383336,1,31),(8667300,53383324,1,32),(8667300,53383321,1,33),(8667300,53383310,1,34),(8667300,53383297,1,35),(8880951,51111226,2,1),(8880951,51111228,2,2),(8880951,51111229,2,3),(8880951,51111231,2,4),(8880951,51111232,2,5),(8880951,51111234,2,6),(8880951,51111236,2,7),(8880951,51111238,2,8),(8880951,51111239,2,9),(8880951,51111241,2,10),(8880951,52009107,2,11),(8880951,52009103,2,12),(8880951,52009105,2,13),(8880951,51111244,2,14),(8880951,51111245,2,15),(8880951,51111247,2,16),(8880951,51111248,2,17),(8880951,51111250,2,18),(8880951,51111251,2,19),(8880951,51111253,2,20),(8880951,51111254,2,21),(8880951,51111256,2,22),(8880951,51111257,2,23),(8880951,51111259,2,24),(8880951,52648164,2,25),(8880951,51111260,2,26),(8880951,51111262,2,27),(8880951,51111263,2,28),(8880951,51111265,2,29),(8880951,51111266,2,30),(8880951,51111268,2,31),(8880951,51111270,2,32),(8880951,51111271,2,33),(8880951,51111273,2,34),(8880951,51358786,2,35),(8880951,51358788,2,36),(8880951,51358789,2,37),(8880951,51358791,2,38),(8880951,51358792,2,39),(8880951,51358793,2,40),(8880951,51358794,2,41),(8880951,51358795,2,42),(8880951,51358797,2,43),(8880951,51358798,2,44),(8880951,51358800,2,45),(8880951,51358802,2,46),(8880951,51358803,2,47),(8880951,51357551,2,48),(8880951,51357550,2,49),(8880951,51357549,2,50),(8880951,51357547,2,51),(8880951,51357546,2,52),(8880951,51357544,2,53),(8880951,51357543,2,54),(8880951,51357542,2,55),(8880951,51357540,2,56),(8880951,51357539,2,57),(8880951,51357538,2,58),(8880951,51357335,2,59),(8880951,51357332,2,60),(8880951,51357330,2,61),(8880951,51357329,2,62),(8880951,51357328,2,63),(8880951,51357326,2,64),(8880951,51357323,2,65),(8880951,51357320,2,66),(8880951,51357319,2,67),(8880951,51357317,2,68),(8880951,51357315,2,69),(8880951,59632226,2,70),(8880951,51357313,2,71),(8880951,51357312,2,72),(8880951,51357310,2,73),(8880951,51357309,2,74),(8880951,51357308,2,75),(8880951,51357305,2,76),(8880951,51357303,2,77),(8880951,51357300,2,78),(8880951,51357298,2,79),(8880951,51357297,2,80),(8880951,51357295,2,81),(8880951,51357293,2,82),(8880951,51357292,2,83),(8880951,51357291,2,84),(8880951,51357288,2,85),(8880951,51357287,2,86),(8880951,51357285,2,87),(8880951,51357282,2,88),(8880951,51357281,2,89),(8880951,51357279,2,90),(8880951,51357277,2,91),(8880951,51357276,2,92),(8880951,51357275,2,93),(8880951,51357274,2,94),(8880951,51357272,2,95),(8880951,51357270,2,96),(8880951,51357269,2,97),(8880951,51357268,2,98),(8880951,51357265,2,99),(8880951,51357264,2,100),(8880951,51357261,2,101),(8880951,51357260,2,102),(8880951,51357259,2,103),(8880951,51357256,2,104),(8880951,51357255,2,105),(8880951,51357019,2,106),(8880951,51357018,2,107),(8880951,51357016,2,108),(8880951,51357015,2,109),(8880951,51357013,2,110),(8880951,51357012,2,111),(8880951,51357011,2,112),(8880951,51357010,2,113),(8880951,51357009,2,114),(8880951,51357008,2,115),(8880951,51357007,2,116),(8880951,51357006,2,117),(8880951,51357004,2,118),(8880951,51357003,2,119),(8880951,51357002,2,120),(8880951,51357000,2,121),(8880951,51356999,2,122),(8880951,51356998,2,123),(8880951,51356997,2,124),(8880951,51356995,2,125),(8880951,51356994,2,126),(8880951,51356992,2,127),(8880951,51356991,2,128),(8880951,51356988,2,129),(8880951,51356987,2,130),(8880951,51356986,2,131),(8880951,51356985,2,132),(8880951,51356983,2,133),(8880951,51356982,2,134),(8880951,51356981,2,135),(8880951,51356979,2,136),(8880951,51356978,2,137),(8880951,51356977,2,138),(8880951,51356975,2,139),(8880951,51356974,2,140),(8880951,51356973,2,141),(8880951,51356972,2,142),(8880951,51356970,2,143),(8880951,51356969,2,144),(8880951,51356968,2,145),(8880951,51356967,2,146),(8880951,51356965,2,147),(8880951,52011242,2,148),(8880951,52011244,2,149),(8880951,52011249,2,150),(8880951,52011253,2,151),(8880951,52011256,2,152),(8880951,52011259,2,153),(8880951,51356964,2,154),(8880951,51356432,2,155),(8880951,52011238,2,156),(8880951,52011227,2,157),(8880951,52011234,2,158),(8880951,52011225,2,159),(8880951,52011231,2,160),(8880951,51356433,2,161),(8880951,51356434,2,162),(8880951,51356435,2,163),(8880951,51356437,2,164),(8880951,51356438,2,165),(8880951,51356439,2,166),(8880951,51356440,2,167),(8880951,51356442,2,168),(8880951,51356444,2,169),(8880951,51356445,2,170),(8880951,51356446,2,171),(8880951,51356448,2,172),(8880951,51356450,2,173),(8880951,51356451,2,174),(8880951,51356452,2,175),(8880951,51356454,2,176),(8880951,51356455,2,177),(8880951,51356457,2,178),(8880951,51356458,2,179),(8880951,51356460,2,180),(8880951,51356461,2,181),(8880951,51356462,2,182),(8880951,51356465,2,183),(8880951,51356466,2,184),(8880951,51356468,2,185),(8880951,51356469,2,186),(8880951,51356470,2,187),(8880951,51356471,2,188),(8880951,51356472,2,189),(8880951,51356473,2,190),(8880951,51356474,2,191),(8880951,51356475,2,192),(8880951,51356476,2,193),(8880951,51356477,2,194),(8880951,51356478,2,195),(8880951,51356479,2,196),(8880951,51356480,2,197),(8880951,51356481,2,198),(8880951,51356383,2,199),(8880951,51111214,2,200),(8880951,51111216,2,201),(8880951,51111218,2,202),(8880951,51111220,2,203),(8880951,51111222,2,204),(8880951,51111223,2,205),(8880951,51111226,2,206),(8880952,51357960,8,1),(8880952,52002278,8,2),(8880952,51357962,8,3),(8880952,51357963,8,4),(8880952,51357965,8,5),(8880952,51357966,8,6),(8880952,51357967,8,7),(8880952,51357969,8,8),(8880952,51357971,8,9),(8880952,51357972,8,10),(8880952,51357973,8,11),(8880952,51357975,8,12),(8880952,51357977,8,13),(8880952,51357978,8,14),(8880952,51357980,8,15),(8880952,51357981,8,16),(8880952,51357983,8,17),(8880952,51357984,8,18),(8880952,51357986,8,19),(8880952,51357988,8,20),(8880952,51357989,8,21),(8880952,51357991,8,22),(8880952,51357993,8,23),(8880952,51357994,8,24),(8880952,51357995,8,25),(8880952,51357997,8,26),(8880952,51358000,8,27),(8880952,51358001,8,28),(8880952,51358002,8,29),(8880952,51358003,8,30),(8880952,51358004,8,31),(8880952,51358005,8,32),(8880952,51358007,8,33),(8880952,51358008,8,34),(8880952,51358009,8,35),(8880952,51358011,8,36),(8880952,51358013,8,37),(8880952,51358015,8,38),(8880952,51358016,8,39),(8880952,51358018,8,40),(8880952,51358019,8,41),(8880952,51358021,8,42),(8880952,51358023,8,43),(8880952,51358025,8,44),(8880952,51357573,8,45),(8880952,51357571,8,46),(8880952,51357570,8,47),(8880952,51357568,8,48),(8880952,51357567,8,49),(8880952,51357566,8,50),(8880952,51357564,8,51),(8880952,51357562,8,52),(8880952,51357561,8,53),(8880952,51357560,8,54),(8880952,51357558,8,55),(8880952,51357557,8,56),(8880952,51357556,8,57),(8880952,51357554,8,58),(8880952,51357552,8,59),(8880952,51357551,8,60),(8880952,51358803,8,61),(8880952,51358805,8,62),(8880952,51358806,8,63),(8880952,51358807,8,64),(8880952,51358809,8,65),(8880952,51358810,8,66),(8880952,51358811,8,67),(8880952,51358812,8,68),(8880952,51358813,8,69),(8880952,51358814,8,70),(8880952,51358815,8,71),(8880952,51358816,8,72),(8880952,51358818,8,73),(8880952,51358819,8,74),(8880952,51358820,8,75),(8880952,51358821,8,76),(8880952,51358823,8,77),(8880952,51358824,8,78),(8880952,51358825,8,79),(8880952,51358827,8,80),(8880952,51358829,8,81),(8880952,51358832,8,82),(8880952,51358837,8,83),(8880952,51358838,8,84),(8880952,51358839,8,85),(8880952,51358840,8,86),(8880952,51358841,8,87),(8880952,51358842,8,88),(8880952,51358843,8,89),(8880952,51358845,8,90),(8880952,51358847,8,91),(8880952,51358848,8,92),(8880952,51358849,8,93),(8880952,51358850,8,94),(8880952,51358851,8,95),(8880952,51358852,8,96),(8880952,51358853,8,97),(8880952,51358854,8,98),(8880952,51358856,8,99),(8880952,51358858,8,100),(8880952,52002281,8,101),(8880952,51358859,8,102),(8880952,51358861,8,103),(8880952,51358862,8,104),(8880952,51358863,8,105),(8880952,51359239,8,106),(8880952,51359241,8,107),(8880952,51359242,8,108),(8880952,51359243,8,109),(8880952,51359245,8,110),(8880952,51359246,8,111),(8880952,51359247,8,112),(8880952,51359249,8,113),(8880952,52002275,8,114),(8880952,51359251,8,115),(8880952,52002272,8,116),(8880952,51359252,8,117),(8880952,51359253,8,118),(8880952,52002261,8,119),(8880952,51359255,8,120),(8880952,51359256,8,121),(8880952,52002259,8,122),(8880952,52002258,8,123),(8880952,52002256,8,124),(8880952,51359257,8,125),(8880952,51359259,8,126),(8880952,51359260,8,127),(8880952,51359261,8,128),(8880952,51359262,8,129),(8880952,51359264,8,130),(8880952,51359265,8,131),(8880952,51359266,8,132),(8880952,51359268,8,133),(8880952,51359269,8,134),(8880952,51359271,8,135),(8880952,51359272,8,136),(8880952,52002247,8,137),(8880952,51359274,8,138),(8880952,52002244,8,139),(8880952,51359275,8,140),(8880952,51359276,8,141),(8880952,51359278,8,142),(8880952,52002241,8,143),(8880952,51359279,8,144),(8880952,52002238,8,145),(8880952,52002235,8,146),(8880952,51359280,8,147),(8880952,51359281,8,148),(8880952,51359283,8,149),(8880952,51359284,8,150),(8880952,51359285,8,151),(8880952,51359287,8,152),(8880952,51359288,8,153),(8880952,51359290,8,154),(8880952,51359291,8,155),(8880952,51359292,8,156),(8880952,51359293,8,157),(8880952,51359295,8,158),(8880952,51359296,8,159),(8880952,51359297,8,160),(8880952,51359299,8,161),(8880952,51359302,8,162),(8880952,51359303,8,163),(8880952,51359304,8,164),(8880952,51359305,8,165),(8880952,64796339,8,166),(8880952,64796338,8,167),(8880952,51359307,8,168),(8880952,51359782,8,169),(8880952,51359783,8,170),(8880952,51359784,8,171),(8880952,51359785,8,172),(8880952,51359786,8,173),(8880952,51359787,8,174),(8880952,51359788,8,175),(8880952,51359789,8,176),(8880952,51359790,8,177),(8880952,51359793,8,178),(8880952,51358396,8,179),(8880952,264290442,8,180),(8880952,51358398,8,181),(8880952,51358399,8,182),(8880952,51358401,8,183),(8880952,51358402,8,184),(8880952,51358404,8,185),(8880952,51358405,8,186),(8880952,51358407,8,187),(8880952,51358408,8,188),(8880952,51358409,8,189),(8880952,51358411,8,190),(8880952,51358412,8,191),(8880952,51358414,8,192),(8880952,51358415,8,193),(8880952,52002253,8,194),(8880952,51358417,8,195),(8880952,52002251,8,196),(8880952,51358418,8,197),(8880952,52002248,8,198),(8880952,51358419,8,199),(8880952,51358421,8,200),(8880952,51358423,8,201),(8880952,51358424,8,202),(8880952,51358425,8,203),(8880952,51358427,8,204),(8880952,51358428,8,205),(8880952,51358430,8,206),(8880952,51357949,8,207),(8880952,51357951,8,208),(8880952,51357953,8,209),(8880952,51357954,8,210),(8880952,51357955,8,211),(8880952,51357956,8,212),(8880952,52002266,8,213),(8880952,51357958,8,214),(8880952,52002264,8,215),(8880952,51357959,8,216),(8880952,52002269,8,217),(8880952,51357960,8,218),(8880953,52031077,10,1),(8880953,52031076,10,2),(8880953,52031059,10,3),(8880953,52031056,10,4),(8880953,52031054,10,5),(8880953,52031050,10,6),(8880953,52031046,10,7),(8880953,52031043,10,8),(8880953,52031041,10,9),(8880953,52031039,10,10),(8880953,52031036,10,11),(8880953,52031034,10,12),(8880953,52031030,10,13),(8880953,52031013,10,14),(8880953,52031003,10,15),(8880953,51360246,10,16),(8880953,51359756,10,17),(8880953,52002219,10,18),(8880953,51359758,10,19),(8880953,52002220,10,20),(8880953,52002222,10,21),(8880953,51359760,10,22),(8880953,52002223,10,23),(8880953,52002226,10,24),(8880953,51359761,10,25),(8880953,52002231,10,26),(8880953,51359762,10,27),(8880953,52002229,10,28),(8880953,51359763,10,29),(8880953,51359764,10,30),(8880953,51359766,10,31),(8880953,51359769,10,32),(8880953,51359771,10,33),(8880953,51359772,10,34),(8880953,51359773,10,35),(8880953,51359774,10,36),(8880953,51359775,10,37),(8880953,51359776,10,38),(8880953,51359777,10,39),(8880953,51359778,10,40),(8880953,51359779,10,41),(8880953,51359780,10,42),(8880953,51359781,10,43),(8880953,51359782,10,44),(8880953,51359307,10,45),(8880953,51359308,10,46),(8880953,51359309,10,47),(8880953,51359310,10,48),(8880953,51359312,10,49),(8880953,51359313,10,50),(8880953,51359314,10,51),(8880953,51359316,10,52),(8880953,51359317,10,53),(8880953,51359318,10,54),(8880953,51359320,10,55),(8880953,51359322,10,56),(8880953,51359323,10,57),(8880953,51359324,10,58),(8880953,51359325,10,59),(8880953,51359327,10,60),(8880953,51359328,10,61),(8880953,51359330,10,62),(8880953,51359331,10,63),(8880953,52002204,10,64),(8880953,51359357,10,65),(8880953,52002206,10,66),(8880953,51359358,10,67),(8880953,52002209,10,68),(8880953,52002189,10,69),(8880953,52002211,10,70),(8880953,52002202,10,71),(8880953,52002212,10,72),(8880953,51359948,10,73),(8880953,52002198,10,74),(8880953,51359949,10,75),(8880953,52002214,10,76),(8880953,52002192,10,77),(8880953,52002216,10,78),(8880953,51359951,10,79),(8880953,52002196,10,80),(8880953,51359952,10,81),(8880953,51359953,10,82),(8880953,52031726,10,83),(8880953,52031730,10,84),(8880953,52031732,10,85),(8880953,52031736,10,86),(8880953,52031739,10,87),(8880953,52031742,10,88),(8880953,52031744,10,89),(8880953,52031746,10,90),(8880953,52031747,10,91),(8880953,52031749,10,92),(8880953,52031751,10,93),(8880953,52031756,10,94),(8880953,52031758,10,95),(8880953,52031761,10,96),(8880953,52031764,10,97),(8880953,52031767,10,98),(8880953,52031771,10,99),(8880953,52031774,10,100),(8880953,52031777,10,101),(8880953,52031782,10,102),(8880953,52031785,10,103),(8880953,52031789,10,104),(8880953,52031794,10,105),(8880953,52031798,10,106),(8880953,52031803,10,107),(8880953,52031805,10,108),(8880953,52031809,10,109),(8880953,52031811,10,110),(8880953,52031813,10,111),(8880953,52031815,10,112),(8880953,52031821,10,113),(8880953,52031823,10,114),(8880953,52031827,10,115),(8880953,52031830,10,116),(8880953,52031832,10,117),(8880953,52031834,10,118),(8880953,52031838,10,119),(8880953,52031840,10,120),(8880953,52031844,10,121),(8880953,52031847,10,122),(8880953,52031850,10,123),(8880953,52031855,10,124),(8880953,52031858,10,125),(8880953,52031861,10,126),(8880953,52031865,10,127),(8880953,52031866,10,128),(8880953,52031868,10,129),(8880953,52031871,10,130),(8880953,52031872,10,131),(8880953,52031874,10,132),(8880953,52031876,10,133),(8880953,52031881,10,134),(8880953,52031884,10,135),(8880953,52031886,10,136),(8880953,52031888,10,137),(8880953,52031889,10,138),(8880953,52031893,10,139),(8880953,52031894,10,140),(8880953,52031899,10,141),(8880953,52031901,10,142),(8880953,52031906,10,143),(8880953,52031908,10,144),(8880953,52031911,10,145),(8880953,52031913,10,146),(8880953,52031915,10,147),(8880953,52031919,10,148),(8880953,52031921,10,149),(8880953,52031925,10,150),(8880953,52031927,10,151),(8880953,52031930,10,152),(8880953,52031933,10,153),(8880953,52031936,10,154),(8880953,52031938,10,155),(8880953,52031943,10,156),(8880953,52031946,10,157),(8880953,52031948,10,158),(8880953,52031953,10,159),(8880953,52031956,10,160),(8880953,52031958,10,161),(8880953,52031962,10,162),(8880953,52031966,10,163),(8880953,52031968,10,164),(8880953,52031973,10,165),(8880953,52031976,10,166),(8880953,52031980,10,167),(8880953,52031984,10,168),(8880953,52031987,10,169),(8880953,52031990,10,170),(8880953,52031992,10,171),(8880953,52031995,10,172),(8880953,52031998,10,173),(8880953,52032000,10,174),(8880953,52032003,10,175),(8880953,52032007,10,176),(8880953,52032010,10,177),(8880953,52032012,10,178),(8880953,52032017,10,179),(8880953,52032018,10,180),(8880953,52032021,10,181),(8880953,52032022,10,182),(8880953,52032026,10,183),(8880953,52032029,10,184),(8880953,52032033,10,185),(8880953,52032035,10,186),(8880953,52032039,10,187),(8880953,52032041,10,188),(8880953,52032044,10,189),(8880953,52032047,10,190),(8880953,52032048,10,191),(8880953,52032051,10,192),(8880953,52032054,10,193),(8880953,52032057,10,194),(8880953,52032060,10,195),(8880953,52032064,10,196),(8880953,52032067,10,197),(8880953,52032070,10,198),(8880953,52032071,10,199),(8880953,52032075,10,200),(8880953,52032076,10,201),(8880953,52032078,10,202),(8880953,52032081,10,203),(8880953,52032085,10,204),(8880953,52032087,10,205),(8880953,52032090,10,206),(8880953,52032092,10,207),(8880953,52032093,10,208),(8880953,52032098,10,209),(8880953,52032100,10,210),(8880953,52032103,10,211),(8880953,52032107,10,212),(8880953,52032109,10,213),(8880953,52032112,10,214),(8880953,52032113,10,215),(8880953,52032116,10,216),(8880953,52032119,10,217),(8880953,52032122,10,218),(8880953,52032125,10,219),(8880953,52032127,10,220),(8880953,52032130,10,221),(8880953,52032133,10,222),(8880953,52032135,10,223),(8880953,52032137,10,224),(8880953,52032141,10,225),(8880953,52032145,10,226),(8880953,52032147,10,227),(8880953,52032150,10,228),(8880953,52032153,10,229),(8880953,52032158,10,230),(8880953,52032160,10,231),(8880953,52032162,10,232),(8880953,52032165,10,233),(8880953,52032168,10,234),(8880953,52032171,10,235),(8880953,52032174,10,236),(8880953,52032176,10,237),(8880953,52032179,10,238),(8880953,52032182,10,239),(8880953,52032183,10,240),(8880953,52032186,10,241),(8880953,52032187,10,242),(8880953,52032190,10,243),(8880953,52032192,10,244),(8880953,52032195,10,245),(8880953,52032197,10,246),(8880953,52032200,10,247),(8880953,52032204,10,248),(8880953,52032205,10,249),(8880953,52032208,10,250),(8880953,52032211,10,251),(8880953,52032212,10,252),(8880953,52032216,10,253),(8880953,52032219,10,254),(8880953,52032222,10,255),(8880953,52032225,10,256),(8880953,52032228,10,257),(8880953,52032233,10,258),(8880953,52032238,10,259),(8880953,52032241,10,260),(8880953,52032243,10,261),(8880953,52032246,10,262),(8880953,52032250,10,263),(8880953,52032249,10,264),(8880953,52031723,10,265),(8880953,52031720,10,266),(8880953,52031717,10,267),(8880953,52031715,10,268),(8880953,52031712,10,269),(8880953,52031709,10,270),(8880953,52031705,10,271),(8880953,52031702,10,272),(8880953,52031700,10,273),(8880953,52031695,10,274),(8880953,52031691,10,275),(8880953,52031688,10,276),(8880953,52031686,10,277),(8880953,52031681,10,278),(8880953,52031678,10,279),(8880953,52031676,10,280),(8880953,52031671,10,281),(8880953,52031668,10,282),(8880953,52031665,10,283),(8880953,52031660,10,284),(8880953,52031658,10,285),(8880953,52031656,10,286),(8880953,52031652,10,287),(8880953,52031648,10,288),(8880953,52031645,10,289),(8880953,52031642,10,290),(8880953,52031636,10,291),(8880953,52031634,10,292),(8880953,52031631,10,293),(8880953,52031627,10,294),(8880953,52031626,10,295),(8880953,52031621,10,296),(8880953,52031620,10,297),(8880953,52031617,10,298),(8880953,52031616,10,299),(8880953,52031614,10,300),(8880953,52031611,10,301),(8880953,52031608,10,302),(8880953,52031604,10,303),(8880953,52031600,10,304),(8880953,52031595,10,305),(8880953,52031592,10,306),(8880953,52031590,10,307),(8880953,52031587,10,308),(8880953,52031581,10,309),(8880953,52031580,10,310),(8880953,52031576,10,311),(8880953,52031572,10,312),(8880953,52031567,10,313),(8880953,52031562,10,314),(8880953,52031560,10,315),(8880953,52031554,10,316),(8880953,52031552,10,317),(8880953,52031550,10,318),(8880953,52031545,10,319),(8880953,52031540,10,320),(8880953,52031535,10,321),(8880953,52031532,10,322),(8880953,52031529,10,323),(8880953,52031527,10,324),(8880953,52031523,10,325),(8880953,52031521,10,326),(8880953,52031517,10,327),(8880953,52031514,10,328),(8880953,52031512,10,329),(8880953,52031507,10,330),(8880953,52031504,10,331),(8880953,52031500,10,332),(8880953,52031498,10,333),(8880953,52031494,10,334),(8880953,52031491,10,335),(8880953,52031486,10,336),(8880953,52031483,10,337),(8880953,52031481,10,338),(8880953,52031477,10,339),(8880953,52031471,10,340),(8880953,52031467,10,341),(8880953,52031464,10,342),(8880953,52031461,10,343),(8880953,52031456,10,344),(8880953,52031449,10,345),(8880953,52031446,10,346),(8880953,52031441,10,347),(8880953,52031438,10,348),(8880953,52031433,10,349),(8880953,52031429,10,350),(8880953,52031426,10,351),(8880953,52031424,10,352),(8880953,52031418,10,353),(8880953,52031414,10,354),(8880953,52031410,10,355),(8880953,52031384,10,356),(8880953,52031381,10,357),(8880953,52031373,10,358),(8880953,52031369,10,359),(8880953,52031367,10,360),(8880953,52031364,10,361),(8880953,52031361,10,362),(8880953,52031357,10,363),(8880953,52031355,10,364),(8880953,52031351,10,365),(8880953,52031346,10,366),(8880953,52031340,10,367),(8880953,52031335,10,368),(8880953,52031329,10,369),(8880953,52031325,10,370),(8880953,52031320,10,371),(8880953,52031314,10,372),(8880953,52031309,10,373),(8880953,52031307,10,374),(8880953,52031299,10,375),(8880953,52031295,10,376),(8880953,52031290,10,377),(8880953,52031285,10,378),(8880953,52031281,10,379),(8880953,52031275,10,380),(8880953,52031272,10,381),(8880953,52031267,10,382),(8880953,52031262,10,383),(8880953,52031260,10,384),(8880953,52031255,10,385),(8880953,52031250,10,386),(8880953,52031247,10,387),(8880953,52031244,10,388),(8880953,52031240,10,389),(8880953,52031235,10,390),(8880953,52031232,10,391),(8880953,52031227,10,392),(8880953,52031224,10,393),(8880953,52031221,10,394),(8880953,52031218,10,395),(8880953,52031212,10,396),(8880953,52031205,10,397),(8880953,52031198,10,398),(8880953,52031190,10,399),(8880953,52031186,10,400),(8880953,52031178,10,401),(8880953,52031174,10,402),(8880953,52031171,10,403),(8880953,52031164,10,404),(8880953,52031158,10,405),(8880953,52031156,10,406),(8880953,52031153,10,407),(8880953,52031151,10,408),(8880953,52031147,10,409),(8880953,52031141,10,410),(8880953,52031136,10,411),(8880953,52031131,10,412),(8880953,52031129,10,413),(8880953,52031125,10,414),(8880953,52031121,10,415),(8880953,52031117,10,416),(8880953,52031114,10,417),(8880953,52031109,10,418),(8880953,52031105,10,419),(8880953,52031100,10,420),(8880953,52031099,10,421),(8880953,52031095,10,422),(8880953,52031092,10,423),(8880953,52031089,10,424),(8880953,52031086,10,425),(8880953,52031084,10,426),(8880953,52031082,10,427),(8880953,52031080,10,428),(8880953,52031077,10,429),(8880955,64796296,2,1),(8880955,64796297,2,2),(8880955,64796301,2,3),(8880955,64796302,2,4),(8880955,64796303,2,5),(8880955,64796304,2,6),(8880955,64796308,2,7),(8880955,64796309,2,8),(8880955,64796310,2,9),(8880955,64796311,2,10),(8880955,64796315,2,11),(8880955,64796316,2,12),(8880955,64796338,2,13),(8880955,64796339,2,14),(8880955,64796337,2,15),(8880955,64796335,2,16),(8880955,64796332,2,17),(8880955,64796331,2,18),(8880955,64796330,2,19),(8880955,64796329,2,20),(8880955,64796325,2,21),(8880955,64796324,2,22),(8880955,64796323,2,23),(8880955,64796322,2,24),(8880955,64796318,2,25),(8880955,64796317,2,26),(8880955,64796296,2,27),(8880956,64803169,13,1),(8880956,64801805,13,2),(8880956,64801804,13,3),(8880956,64801803,13,4),(8880956,64801802,13,5),(8880956,64801795,13,6),(8880956,64801785,13,7),(8880956,64801780,13,8),(8880956,64801779,13,9),(8880956,64801778,13,10),(8880956,64801774,13,11),(8880956,64801773,13,12),(8880956,64801725,13,13),(8880956,64801724,13,14),(8880956,64801721,13,15),(8880956,64801719,13,16),(8880956,64801718,13,17),(8880956,64801717,13,18),(8880956,64801714,13,19),(8880956,64801712,13,20),(8880956,64801711,13,21),(8880956,64801710,13,22),(8880956,64801709,13,23),(8880956,64801705,13,24),(8880956,64801704,13,25),(8880956,64801703,13,26),(8880956,64801702,13,27),(8880956,64801697,13,28),(8880956,64801695,13,29),(8880956,64801694,13,30),(8880956,64801693,13,31),(8880956,64801690,13,32),(8880956,64801688,13,33),(8880956,64801686,13,34),(8880956,64801685,13,35),(8880956,64801684,13,36),(8880956,64801681,13,37),(8880956,64801679,13,38),(8880956,64798335,13,39),(8880956,64798333,13,40),(8880956,64798331,13,41),(8880956,64798329,13,42),(8880956,64798328,13,43),(8880956,64798327,13,44),(8880956,64798324,13,45),(8880956,64798323,13,46),(8880956,64798321,13,47),(8880956,64798320,13,48),(8880956,64798319,13,49),(8880956,64798316,13,50),(8880956,64798315,13,51),(8880956,64798313,13,52),(8880956,64798312,13,53),(8880956,64798310,13,54),(8880956,64798308,13,55),(8880956,64798306,13,56),(8880956,64798305,13,57),(8880956,64798304,13,58),(8880956,64798301,13,59),(8880956,64798300,13,60),(8880956,64798298,13,61),(8880956,64798297,13,62),(8880956,64796367,13,63),(8880956,64796366,13,64),(8880956,64796365,13,65),(8880956,64796363,13,66),(8880956,64796360,13,67),(8880956,64796359,13,68),(8880956,64796358,13,69),(8880956,64796356,13,70),(8880956,64796353,13,71),(8880956,64796352,13,72),(8880956,64796351,13,73),(8880956,64796349,13,74),(8880956,64796346,13,75),(8880956,64796345,13,76),(8880956,64796344,13,77),(8880956,64796340,13,78),(8880956,64796296,13,79),(8880956,64796317,13,80),(8880956,64796368,13,81),(8880956,64796372,13,82),(8880956,64796373,13,83),(8880956,64796374,13,84),(8880956,64796375,13,85),(8880956,64796376,13,86),(8880956,64796377,13,87),(8880956,64796381,13,88),(8880956,64796382,13,89),(8880956,64796383,13,90),(8880956,64796385,13,91),(8880956,64796388,13,92),(8880956,64798267,13,93),(8880956,64798268,13,94),(8880956,64798270,13,95),(8880956,64798271,13,96),(8880956,64798274,13,97),(8880956,64798275,13,98),(8880956,64798277,13,99),(8880956,64798278,13,100),(8880956,64798280,13,101),(8880956,64798282,13,102),(8880956,64798283,13,103),(8880956,64798285,13,104),(8880956,64798286,13,105),(8880956,64798289,13,106),(8880956,64798290,13,107),(8880956,64798291,13,108),(8880956,64798293,13,109),(8880956,64798295,13,110),(8880956,64798336,13,111),(8880956,64798337,13,112),(8880956,64798339,13,113),(8880956,64798342,13,114),(8880956,64798343,13,115),(8880956,64798344,13,116),(8880956,64798345,13,117),(8880956,64798347,13,118),(8880956,64798350,13,119),(8880956,64798351,13,120),(8880956,64798352,13,121),(8880956,64801605,13,122),(8880956,64801639,13,123),(8880956,64801640,13,124),(8880956,64801644,13,125),(8880956,64801645,13,126),(8880956,64801646,13,127),(8880956,64801648,13,128),(8880956,64801651,13,129),(8880956,64801652,13,130),(8880956,64801654,13,131),(8880956,64801657,13,132),(8880956,64801659,13,133),(8880956,64801660,13,134),(8880956,64801663,13,135),(8880956,64801667,13,136),(8880956,64801670,13,137),(8880956,64801672,13,138),(8880956,64801673,13,139),(8880956,64801675,13,140),(8880956,64801678,13,141),(8880956,64801729,13,142),(8880956,64801739,13,143),(8880956,64801740,13,144),(8880956,64801741,13,145),(8880956,64801745,13,146),(8880956,64801746,13,147),(8880956,64801747,13,148),(8880956,64801748,13,149),(8880956,64801751,13,150),(8880956,64801753,13,151),(8880956,64801754,13,152),(8880956,64801758,13,153),(8880956,64801759,13,154),(8880956,64801761,13,155),(8880956,64801762,13,156),(8880956,64801766,13,157),(8880956,64801770,13,158),(8880956,64801809,13,159),(8880956,64801810,13,160),(8880956,64801811,13,161),(8880956,64801812,13,162),(8880956,64801816,13,163),(8880956,64801817,13,164),(8880956,64801818,13,165),(8880956,64801819,13,166),(8880956,64803147,13,167),(8880956,64803150,13,168),(8880956,64803152,13,169),(8880956,64803153,13,170),(8880956,64803154,13,171),(8880956,64803157,13,172),(8880956,64803159,13,173),(8880956,64803160,13,174),(8880956,64803168,13,175),(8880956,64803161,13,176),(8880956,64803162,13,177),(8880956,64803165,13,178),(8880956,64803167,13,179),(8880956,64803199,13,180),(8880956,64803198,13,181),(8880956,64803197,13,182),(8880956,64803195,13,183),(8880956,64803192,13,184),(8880956,64803191,13,185),(8880956,64803190,13,186),(8880956,64803188,13,187),(8880956,64803185,13,188),(8880956,64803184,13,189),(8880956,64803183,13,190),(8880956,64803182,13,191),(8880956,64803180,13,192),(8880956,64803177,13,193),(8880956,64803176,13,194),(8880956,64803175,13,195),(8880956,64803174,13,196),(8880956,64803172,13,197),(8880956,64803169,13,198),(8885021,64841074,5,1),(8885021,64841080,5,2),(8885021,64841084,5,3),(8885021,64841088,5,4),(8885021,64841091,5,5),(8885021,64841092,5,6),(8885021,64841148,5,7),(8885021,64841151,5,8),(8885021,64841154,5,9),(8885021,64841158,5,10),(8885021,64841162,5,11),(8885021,64841165,5,12),(8885021,64841166,5,13),(8885021,64841169,5,14),(8885021,64841177,5,15),(8885021,64841180,5,16),(8885021,64841183,5,17),(8885021,64841185,5,18),(8885021,64841188,5,19),(8885021,64841191,5,20),(8885021,64841194,5,21),(8885021,64841197,5,22),(8885021,64841198,5,23),(8885021,64841202,5,24),(8885021,64841205,5,25),(8885021,64841208,5,26),(8885021,64841211,5,27),(8885021,64841215,5,28),(8885021,64841220,5,29),(8885021,64841224,5,30),(8885021,64841229,5,31),(8885021,64841290,5,32),(8885021,64841293,5,33),(8885021,64841297,5,34),(8885021,64841301,5,35),(8885021,64841307,5,36),(8885021,64841311,5,37),(8885021,64841315,5,38),(8885021,64841316,5,39),(8885021,64841319,5,40),(8885021,64841321,5,41),(8885021,64841324,5,42),(8885021,64841329,5,43),(8885021,64841333,5,44),(8885021,64841337,5,45),(8885021,64841341,5,46),(8885021,258353539,5,47),(8885021,64841286,5,48),(8885021,64841282,5,49),(8885021,64841281,5,50),(8885021,64841278,5,51),(8885021,64841274,5,52),(8885021,64841271,5,53),(8885021,64841268,5,54),(8885021,64841266,5,55),(8885021,64841263,5,56),(8885021,64841260,5,57),(8885021,64841257,5,58),(8885021,64841254,5,59),(8885021,64841248,5,60),(8885021,64841245,5,61),(8885021,64841243,5,62),(8885021,64841238,5,63),(8885021,64841236,5,64),(8885021,64841233,5,65),(8885021,64841145,5,66),(8885021,64841139,5,67),(8885021,64841136,5,68),(8885021,64841134,5,69),(8885021,64841132,5,70),(8885021,64841129,5,71),(8885021,64841128,5,72),(8885021,64841125,5,73),(8885021,64841123,5,74),(8885021,64841120,5,75),(8885021,64841119,5,76),(8885021,64841118,5,77),(8885021,64841115,5,78),(8885021,64841113,5,79),(8885021,64841109,5,80),(8885021,64841108,5,81),(8885021,64841106,5,82),(8885021,64841105,5,83),(8885021,64841101,5,84),(8885021,64841100,5,85),(8885021,64841099,5,86),(8885021,64841097,5,87),(8885021,64841094,5,88),(8885021,64841028,5,89),(8885021,64841026,5,90),(8885021,64841023,5,91),(8885021,64841018,5,92),(8885021,64841013,5,93),(8885021,64841008,5,94),(8885021,64841007,5,95),(8885021,64841005,5,96),(8885021,64841000,5,97),(8885021,64840998,5,98),(8885021,64840997,5,99),(8885021,64840996,5,100),(8885021,64840992,5,101),(8885021,64840987,5,102),(8885021,64840985,5,103),(8885021,64840982,5,104),(8885021,64840979,5,105),(8885021,64840975,5,106),(8885021,64840971,5,107),(8885021,64840916,5,108),(8885021,64840911,5,109),(8885021,64840907,5,110),(8885021,64840903,5,111),(8885021,64840899,5,112),(8885021,64840895,5,113),(8885021,64840890,5,114),(8885021,64840886,5,115),(8885021,64840882,5,116),(8885021,64840877,5,117),(8885021,64840872,5,118),(8885021,64840868,5,119),(8885021,64840865,5,120),(8885021,64840861,5,121),(8885021,64840858,5,122),(8885021,64840854,5,123),(8885021,64840778,5,124),(8885021,64840773,5,125),(8885021,64840769,5,126),(8885021,64840767,5,127),(8885021,64840762,5,128),(8885021,64840761,5,129),(8885021,64840759,5,130),(8885021,64840758,5,131),(8885021,64840755,5,132),(8885021,64840753,5,133),(8885021,64840750,5,134),(8885021,64840746,5,135),(8885021,64840744,5,136),(8885021,64840741,5,137),(8885021,64840738,5,138),(8885021,64840732,5,139),(8885021,64840730,5,140),(8885021,64840726,5,141),(8885021,64840721,5,142),(8885021,64840717,5,143),(8885021,64840709,5,144),(8885021,64803167,5,145),(8885021,64803199,5,146),(8885021,64840781,5,147),(8885021,64840785,5,148),(8885021,64840790,5,149),(8885021,64840792,5,150),(8885021,64840793,5,151),(8885021,64840797,5,152),(8885021,64840799,5,153),(8885021,64840802,5,154),(8885021,64840806,5,155),(8885021,64840812,5,156),(8885021,64840816,5,157),(8885021,64840820,5,158),(8885021,64840823,5,159),(8885021,64840828,5,160),(8885021,64840832,5,161),(8885021,64840836,5,162),(8885021,64840839,5,163),(8885021,64840843,5,164),(8885021,64840848,5,165),(8885021,64840849,5,166),(8885021,64840918,5,167),(8885021,64840922,5,168),(8885021,64840923,5,169),(8885021,64840926,5,170),(8885021,64840929,5,171),(8885021,64840932,5,172),(8885021,64840933,5,173),(8885021,64840934,5,174),(8885021,64840936,5,175),(8885021,64840940,5,176),(8885021,64840946,5,177),(8885021,64840950,5,178),(8885021,390336904,5,179),(8885021,64840954,5,180),(8885021,64840959,5,181),(8885021,64840961,5,182),(8885021,64840965,5,183),(8885021,64840968,5,184),(8885021,64841033,5,185),(8885021,64841037,5,186),(8885021,64841039,5,187),(8885021,64841042,5,188),(8885021,64841046,5,189),(8885021,64841049,5,190),(8885021,64841051,5,191),(8885021,64841053,5,192),(8885021,64841057,5,193),(8885021,64841061,5,194),(8885021,64841066,5,195),(8885021,64841070,5,196),(8885021,64841074,5,197),(8885025,64841635,9,1),(8885025,258352118,9,2),(8885025,64841630,9,3),(8885025,64841627,9,4),(8885025,64841623,9,5),(8885025,64841620,9,6),(8885025,64841617,9,7),(8885025,64841612,9,8),(8885025,64841606,9,9),(8885025,64841603,9,10),(8885025,64841600,9,11),(8885025,64841597,9,12),(8885025,64841591,9,13),(8885025,64841587,9,14),(8885025,64841584,9,15),(8885025,64841582,9,16),(8885025,64841579,9,17),(8885025,64841573,9,18),(8885025,64841570,9,19),(8885025,64841566,9,20),(8885025,64841561,9,21),(8885025,64841557,9,22),(8885025,64841553,9,23),(8885025,64841551,9,24),(8885025,64841550,9,25),(8885025,64841547,9,26),(8885025,64841541,9,27),(8885025,64841537,9,28),(8885025,64841532,9,29),(8885025,64841529,9,30),(8885025,64841446,9,31),(8885025,64841444,9,32),(8885025,64841441,9,33),(8885025,64841439,9,34),(8885025,64841436,9,35),(8885025,266380259,9,36),(8885025,64841434,9,37),(8885025,266380260,9,38),(8885025,64841433,9,39),(8885025,64841431,9,40),(8885025,64841424,9,41),(8885025,64841415,9,42),(8885025,64841344,9,43),(8885025,64841346,9,44),(8885025,64841351,9,45),(8885025,64841356,9,46),(8885025,64841197,9,47),(8885025,64841194,9,48),(8885025,64841360,9,49),(8885025,64841365,9,50),(8885025,64841367,9,51),(8885025,64841370,9,52),(8885025,64841373,9,53),(8885025,64841375,9,54),(8885025,64841376,9,55),(8885025,64841379,9,56),(8885025,64841383,9,57),(8885025,64841386,9,58),(8885025,266340072,9,59),(8885025,64841388,9,60),(8885025,64841390,9,61),(8885025,64841393,9,62),(8885025,64841396,9,63),(8885025,64841399,9,64),(8885025,64841407,9,65),(8885025,64841451,9,66),(8885025,64841452,9,67),(8885025,64841454,9,68),(8885025,64841456,9,69),(8885025,64841461,9,70),(8885025,64841463,9,71),(8885025,64841468,9,72),(8885025,64841472,9,73),(8885025,64841473,9,74),(8885025,64841478,9,75),(8885025,64841481,9,76),(8885025,64841483,9,77),(8885025,64841487,9,78),(8885025,64841488,9,79),(8885025,64841491,9,80),(8885025,64841497,9,81),(8885025,64841499,9,82),(8885025,64841502,9,83),(8885025,64841507,9,84),(8885025,64841511,9,85),(8885025,64841514,9,86),(8885025,64841518,9,87),(8885025,64841521,9,88),(8885025,64841525,9,89),(8885025,64841638,9,90),(8885025,64841640,9,91),(8885025,64841645,9,92),(8885025,64841649,9,93),(8885025,64841652,9,94),(8885025,64841654,9,95),(8885025,52169127,9,96),(8885025,64841635,9,97),(17240968,52743887,3,1),(17240968,52743889,3,2),(17240968,52743892,3,3),(17240968,52743895,3,4),(17240968,52689656,3,5),(17240968,52689653,3,6),(17240968,52689650,3,7),(17240968,52689647,3,8),(17240968,52689643,3,9),(17240968,52689639,3,10),(17240968,52689635,3,11),(17240968,51412105,3,12),(17240968,52743899,3,13),(17240968,52743896,3,14),(17240968,52743900,3,15),(17240968,52743901,3,16),(17240968,52743902,3,17),(17240968,52743904,3,18),(17240968,52743907,3,19),(17240968,52743909,3,20),(17240968,52743910,3,21),(17240968,52743913,3,22),(17240968,52743916,3,23),(17240968,52743919,3,24),(17240968,52743921,3,25),(17240968,52743924,3,26),(17240968,52743925,3,27),(17240968,52743927,3,28),(17240968,52743928,3,29),(17240968,52743930,3,30),(17240968,52743933,3,31),(17240968,52743936,3,32),(17240968,52743937,3,33),(17240968,52743940,3,34),(17240968,52743941,3,35),(17240968,52743943,3,36),(17240968,52743946,3,37),(17240968,52743947,3,38);
INSERT INTO `way_nodes` VALUES (17240968,52743950,3,39),(17240968,52743951,3,40),(17240968,52743954,3,41),(17240968,52743955,3,42),(17240968,52743958,3,43),(17240968,52743959,3,44),(17240968,52743961,3,45),(17240968,52743964,3,46),(17240968,52743966,3,47),(17240968,52743967,3,48),(17240968,52743969,3,49),(17240968,52743971,3,50),(17240968,52743972,3,51),(17240968,52743973,3,52),(17240968,52743976,3,53),(17240968,52743980,3,54),(17240968,52743981,3,55),(17240968,52743984,3,56),(17240968,52743986,3,57),(17240968,52743987,3,58),(17240968,52743988,3,59),(17240968,52743991,3,60),(17240968,52743992,3,61),(17240968,52743995,3,62),(17240968,52743997,3,63),(17240968,52744001,3,64),(17240968,52744002,3,65),(17240968,52744005,3,66),(17240968,52744007,3,67),(17240968,52744009,3,68),(17240968,52744012,3,69),(17240968,52744014,3,70),(17240968,52744016,3,71),(17240968,52744019,3,72),(17240968,52744021,3,73),(17240968,52744022,3,74),(17240968,52744025,3,75),(17240968,52744028,3,76),(17240968,52744030,3,77),(17240968,52744032,3,78),(17240968,52744035,3,79),(17240968,52744036,3,80),(17240968,52744038,3,81),(17240968,52744042,3,82),(17240968,52744043,3,83),(17240968,52744046,3,84),(17240968,52744049,3,85),(17240968,52744050,3,86),(17240968,52744052,3,87),(17240968,52744053,3,88),(17240968,52744054,3,89),(17240968,52744056,3,90),(17240968,52744057,3,91),(17240968,52744059,3,92),(17240968,52744062,3,93),(17240968,52744064,3,94),(17240968,52744066,3,95),(17240968,52744067,3,96),(17240968,52744070,3,97),(17240968,52744072,3,98),(17240968,52744073,3,99),(17240968,52744074,3,100),(17240968,52744075,3,101),(17240968,52744078,3,102),(17240968,52744081,3,103),(17240968,52744082,3,104),(17240968,52744084,3,105),(17240968,52744086,3,106),(17240968,52744087,3,107),(17240968,52744089,3,108),(17240968,52744091,3,109),(17240968,52744093,3,110),(17240968,52744094,3,111),(17240968,52744096,3,112),(17240968,52744097,3,113),(17240968,52744099,3,114),(17240968,52744100,3,115),(17240968,52744101,3,116),(17240968,52744102,3,117),(17240968,52744104,3,118),(17240968,52744106,3,119),(17240968,52744108,3,120),(17240968,52744110,3,121),(17240968,52744111,3,122),(17240968,52744114,3,123),(17240968,52744116,3,124),(17240968,52744118,3,125),(17240968,52744120,3,126),(17240968,52744122,3,127),(17240968,52744124,3,128),(17240968,52744126,3,129),(17240968,52744128,3,130),(17240968,52744130,3,131),(17240968,52744133,3,132),(17240968,52744134,3,133),(17240968,52744136,3,134),(17240968,52744138,3,135),(17240968,52744141,3,136),(17240968,52744144,3,137),(17240968,52744147,3,138),(17240968,52744149,3,139),(17240968,52744152,3,140),(17240968,52744155,3,141),(17240968,52744158,3,142),(17240968,52744159,3,143),(17240968,52744161,3,144),(17240968,52744163,3,145),(17240968,52744165,3,146),(17240968,52744166,3,147),(17240968,52744172,3,148),(17240968,52744174,3,149),(17240968,52744177,3,150),(17240968,52743887,3,151),(17241049,53353137,7,1),(17241049,53353141,7,2),(17241049,53353144,7,3),(17241049,53353148,7,4),(17241049,53353151,7,5),(17241049,53353155,7,6),(17241049,53353160,7,7),(17241049,53353163,7,8),(17241049,53353167,7,9),(17241049,53353170,7,10),(17241049,53353174,7,11),(17241049,53353179,7,12),(17241049,53353181,7,13),(17241049,53353183,7,14),(17241049,53353186,7,15),(17241049,53353189,7,16),(17241049,53353193,7,17),(17241049,321679729,7,18),(17241049,321679733,7,19),(17241049,53353198,7,20),(17241049,53353199,7,21),(17241049,53353203,7,22),(17241049,53353205,7,23),(17241049,53353208,7,24),(17241049,53353211,7,25),(17241049,53353223,7,26),(17241049,53353237,7,27),(17241049,53353302,7,28),(17241049,53353307,7,29),(17241049,53353314,7,30),(17241049,53353319,7,31),(17241049,53353324,7,32),(17241049,53353328,7,33),(17241049,53353333,7,34),(17241049,53353340,7,35),(17241049,53353343,7,36),(17241049,53353345,7,37),(17241049,53353350,7,38),(17241049,53353359,7,39),(17241049,53353366,7,40),(17241049,53353369,7,41),(17241049,53353372,7,42),(17241049,53353375,7,43),(17241049,53353383,7,44),(17241049,53353388,7,45),(17241049,53353391,7,46),(17241049,53353393,7,47),(17241049,53353395,7,48),(17241049,53353404,7,49),(17241049,53353407,7,50),(17241049,53353413,7,51),(17241049,53353421,7,52),(17241049,53353427,7,53),(17241049,53353431,7,54),(17241049,53353435,7,55),(17241049,53343318,7,56),(17241049,53343339,7,57),(17241049,53343344,7,58),(17241049,53343348,7,59),(17241049,53343353,7,60),(17241049,53343358,7,61),(17241049,53343364,7,62),(17241049,53343367,7,63),(17241049,53343377,7,64),(17241049,53343553,7,65),(17241049,53344982,7,66),(17241049,53350051,7,67),(17241049,53351880,7,68),(17241049,53352405,7,69),(17241049,53352410,7,70),(17241049,53352414,7,71),(17241049,53352419,7,72),(17241049,53352422,7,73),(17241049,53352426,7,74),(17241049,53352429,7,75),(17241049,53352435,7,76),(17241049,53352441,7,77),(17241049,53352444,7,78),(17241049,53352447,7,79),(17241049,53352452,7,80),(17241049,53352461,7,81),(17241049,53352483,7,82),(17241049,53352488,7,83),(17241049,53352494,7,84),(17241049,53352499,7,85),(17241049,53352505,7,86),(17241049,53352508,7,87),(17241049,53352511,7,88),(17241049,53352516,7,89),(17241049,53352521,7,90),(17241049,53352527,7,91),(17241049,53352530,7,92),(17241049,53352537,7,93),(17241049,53352541,7,94),(17241049,53352546,7,95),(17241049,53352552,7,96),(17241049,53352557,7,97),(17241049,53352561,7,98),(17241049,53352568,7,99),(17241049,53352574,7,100),(17241049,53352578,7,101),(17241049,53352584,7,102),(17241049,53352587,7,103),(17241049,53352594,7,104),(17241049,53352599,7,105),(17241049,53352605,7,106),(17241049,53352619,7,107),(17241049,53352632,7,108),(17241049,53352636,7,109),(17241049,53352638,7,110),(17241049,53353137,7,111),(22746153,51118076,4,1),(22746153,51118077,4,2),(22746153,51118078,4,3),(22746153,51118080,4,4),(22746153,51118081,4,5),(22746153,51118082,4,6),(22746153,51118083,4,7),(22746153,51118085,4,8),(22746153,51118086,4,9),(22746153,51118087,4,10),(22746153,51118088,4,11),(22746153,51118090,4,12),(22746153,51118091,4,13),(22746153,51118092,4,14),(22746154,51118092,4,1),(22746154,51118094,4,2),(22746154,51118095,4,3),(22746154,51118096,4,4),(22746154,51118097,4,5),(22746154,51118099,4,6),(22746154,51118100,4,7),(22746155,51118100,4,1),(22746155,51118102,4,2),(22746155,51118103,4,3),(22746155,51118104,4,4),(22746155,51118105,4,5),(22746155,51118106,4,6),(22746155,51118107,4,7),(22746155,51118108,4,8),(22746155,51118110,4,9),(22746155,51118111,4,10),(22746155,51118113,4,11),(22746156,51118113,4,1),(22746156,51118114,4,2),(22746156,51118115,4,3),(22746156,51118117,4,4),(22746156,51118118,4,5),(22746156,51118119,4,6),(22746156,51118121,4,7),(22746156,51118122,4,8),(22746156,51118123,4,9),(22746156,51118124,4,10),(22746156,51118125,4,11),(22746156,51118127,4,12),(22746156,51118128,4,13),(22746156,51118129,4,14),(22746157,51118129,5,1),(22746157,51118130,5,2),(22746157,51118131,5,3),(22746157,51118132,5,4),(22746157,51118133,5,5),(22746157,51118134,5,6),(22746157,51118135,5,7),(22746159,51118157,5,1),(22746159,51118159,5,2),(22746159,51118160,5,3),(22746159,51118161,5,4),(22746159,51118162,5,5),(22746159,51118164,5,6),(22746160,51118164,7,1),(22746160,51118165,7,2),(22746160,51118166,7,3),(22746160,51118168,7,4),(22746160,51118169,7,5),(22746160,51392412,7,6),(22746160,51118170,7,7),(22746160,51118171,7,8),(22746160,51118173,7,9),(22746160,51118174,7,10),(22746160,51118176,7,11),(22746160,51118177,7,12),(22746160,51118178,7,13),(22746160,51118179,7,14),(22746160,51118180,7,15),(22746160,51118181,7,16),(22746160,51118182,7,17),(22746160,51118183,7,18),(22746160,51118184,7,19),(22746160,51118185,7,20),(22746160,51118186,7,21),(22746160,51118187,7,22),(22746160,51118188,7,23),(22746160,51118189,7,24),(22746160,51391054,7,25),(22746160,51118190,7,26),(22746160,51390016,7,27),(22932948,247046008,1,1),(22932948,247046009,1,2),(22932948,247046010,1,3),(22932948,247046011,1,4),(22932948,247046012,1,5),(22932948,247046013,1,6),(22932948,247046014,1,7),(22932948,247046015,1,8),(22932948,247046016,1,9),(22932948,247046017,1,10),(22932948,247046018,1,11),(22932948,247046019,1,12),(22932948,247046020,1,13),(22932948,247046021,1,14),(22932948,247046022,1,15),(22932948,247046023,1,16),(22932948,247046024,1,17),(22932948,247046025,1,18),(22932948,247046026,1,19),(22932948,247046027,1,20),(22932949,247046028,3,1),(22932949,247046029,3,2),(22932949,247046030,3,3),(22932949,247046031,3,4),(22932949,247046032,3,5),(22932949,247046033,3,6),(22932949,247046034,3,7),(22932949,247046035,3,8),(22932949,247046036,3,9),(22932949,247046037,3,10),(22932949,247046038,3,11),(22932949,247046039,3,12),(22932949,247046040,3,13),(22932949,247046041,3,14),(22932949,247046042,3,15),(22932949,247046043,3,16),(22932949,247046044,3,17),(22932949,247046045,3,18),(22932949,247046046,3,19),(22932949,247046047,3,20),(22932949,247046048,3,21),(22932949,247046072,3,22),(22932949,247046073,3,23),(22932949,247046074,3,24),(22932949,247046075,3,25),(22932949,247046076,3,26),(22932949,247046077,3,27),(22932949,247046078,3,28),(22932949,247046079,3,29),(22932949,247046028,3,30),(23305160,45181716,19,1),(23305160,45160958,19,2),(23840927,51552477,9,1),(23840927,51552476,9,2),(23840927,51552473,9,3),(23840927,51552466,9,4),(23840927,51552468,9,5),(23840928,51552480,8,1),(23840928,51552477,8,2),(23841019,51552744,7,1),(23841019,51552740,7,2),(23841019,51552737,7,3),(23841019,51552736,7,4),(23841019,51581679,7,5),(23841049,51552744,6,1),(23841049,262893002,6,2),(23841094,51581574,6,1),(23841094,260989290,6,2),(23841094,260989291,6,3),(23841094,51552744,6,4),(23841127,51581574,14,1),(23841127,51581577,14,2),(23841127,51581580,14,3),(23841127,51581582,14,4),(23841127,51581587,14,5),(23841127,51581590,14,6),(23841127,51581593,14,7),(23841127,51581596,14,8),(23841127,51581598,14,9),(23841127,264502898,14,10),(23841127,51581602,14,11),(23841127,51581607,14,12),(23841127,51581611,14,13),(23841127,51581613,14,14),(23841127,51581617,14,15),(23841127,277386827,14,16),(23841127,51581620,14,17),(23841127,266380119,14,18),(23841127,266380267,14,19),(23841127,51581622,14,20),(23841127,51581625,14,21),(23841127,51581628,14,22),(23841127,266340199,14,23),(23841127,266341806,14,24),(23841127,51581633,14,25),(23841127,51581643,14,26),(23841127,51581645,14,27),(23841127,51581650,14,28),(23841127,51581654,14,29),(23841127,51581657,14,30),(23841127,51581661,14,31),(23841127,51581663,14,32),(23841423,51581663,7,1),(23841423,51581667,7,2),(23841426,51581667,2,1),(23841426,51581670,2,2),(23841426,51581675,2,3),(23842741,51552468,18,1),(23842741,58865012,18,2),(23842741,58865013,18,3),(23842741,51552471,18,4),(23842741,264906169,18,5),(23842741,51552462,18,6),(23842741,264906170,18,7),(23857062,52170099,14,1),(23857062,51552549,14,2),(23857062,51552550,14,3),(23857062,51552553,14,4),(23857062,51552555,14,5),(23857062,51552557,14,6),(23857062,51552559,14,7),(23857062,51552562,14,8),(23857062,51552565,14,9),(23857062,51552569,14,10),(23857062,51552572,14,11),(23857062,51552608,14,12),(23857062,51552575,14,13),(23857062,51552602,14,14),(23857062,287395969,14,15),(23857066,52170040,7,1),(23857066,51552495,7,2),(23857066,51552492,7,3),(23857066,51552489,7,4),(23857066,51552486,7,5),(23857066,51552483,7,6),(23857066,51552480,7,7),(23857247,51582530,3,1),(23857247,51952530,3,2),(23857247,51952532,3,3),(23857247,51952534,3,4),(23857247,51952536,3,5),(23857247,51952539,3,6),(23857247,51952542,3,7),(23857247,51952545,3,8),(23857247,51952546,3,9),(23857247,51952549,3,10),(23857247,51952552,3,11),(23857247,51952556,3,12),(23857247,51952559,3,13),(23857247,51952562,3,14),(23857247,51952566,3,15),(23857247,51952570,3,16),(23857247,51952573,3,17),(23857247,51952575,3,18),(23857247,51952578,3,19),(23857247,51952580,3,20),(23857247,51952583,3,21),(23857247,51952584,3,22),(23857247,51952586,3,23),(23857247,51952590,3,24),(23857247,51952594,3,25),(23857247,51952597,3,26),(23857247,51952599,3,27),(23857247,51952601,3,28),(23857247,51952604,3,29),(23857247,51952605,3,30),(23857247,51952608,3,31),(23857247,51952610,3,32),(23857247,51952613,3,33),(23857247,51952615,3,34),(23857247,51952618,3,35),(23857247,51952620,3,36),(23857247,51952623,3,37),(23857247,51952627,3,38),(23857247,51952630,3,39),(23857247,51952632,3,40),(23857247,51952634,3,41),(23857247,51952635,3,42),(23857247,51952638,3,43),(23857247,51952640,3,44),(23857247,51952643,3,45),(23877195,51342855,10,1),(23877195,51342559,10,2),(23877195,51120877,10,3),(23877195,51120878,10,4),(23877195,51120879,10,5),(23877195,51120881,10,6),(23877195,51120882,10,7),(23877195,51120883,10,8),(23877195,51120884,10,9),(23877195,51120885,10,10),(23877195,51120887,10,11),(23877195,51120888,10,12),(23877195,51120889,10,13),(23877195,51120890,10,14),(23877195,51396399,10,15),(23877195,51120891,10,16),(23877195,51120892,10,17),(23877195,51120893,10,18),(23877195,51120895,10,19),(23877195,51120896,10,20),(23877195,51120897,10,21),(23877195,51120898,10,22),(23877195,51120899,10,23),(23877195,51120900,10,24),(23877195,51119951,10,25),(23877197,51121332,4,1),(23877197,51121334,4,2),(23877197,51121335,4,3),(23877197,51121337,4,4),(23877197,51121338,4,5),(23877197,51121339,4,6),(23877199,51122009,7,1),(23877199,51122010,7,2),(23877199,51122012,7,3),(23877199,51122014,7,4),(23877199,51122015,7,5),(23877199,51122016,7,6),(23877199,278763284,7,7),(23877199,51122018,7,8),(23877199,51122020,7,9),(23877199,51122022,7,10),(23877199,51122023,7,11),(23877199,51122025,7,12),(23877199,51122027,7,13),(23877199,51122028,7,14),(23877199,51122029,7,15),(23877199,51122030,7,16),(23877199,51122032,7,17),(23877199,51122033,7,18),(23877199,51122034,7,19),(23877199,51122036,7,20),(23877199,51122038,7,21),(23877199,51122039,7,22),(23877199,51122041,7,23),(23877199,51122042,7,24),(23877199,51122044,7,25),(23877199,51122045,7,26),(23877199,51121362,7,27),(23877199,51121363,7,28),(23877199,51121326,7,29),(23877199,51121327,7,30),(23877199,51121329,7,31),(23877199,51121330,7,32),(23877199,51121331,7,33),(23877199,51121332,7,34),(23877200,258823161,11,1),(23877200,51121973,11,2),(23877200,51121974,11,3),(23877200,51121976,11,4),(23877200,51121977,11,5),(23877200,51121979,11,6),(23877200,51121981,11,7),(23877200,51121982,11,8),(23877200,51121984,11,9),(23877200,51121985,11,10),(23877200,51121987,11,11),(23877200,278757467,11,12),(23877200,278757468,11,13),(23877200,51121988,11,14),(23877200,51121989,11,15),(23877200,51121991,11,16),(23877200,51121992,11,17),(23877200,51121993,11,18),(23877200,278757469,11,19),(23877200,51121995,11,20),(23877200,278761002,11,21),(23877200,51121997,11,22),(23877200,51121998,11,23),(23877200,51122000,11,24),(23877200,278760711,11,25),(23877200,278760483,11,26),(23877200,51122001,11,27),(23877200,51122003,11,28),(23877200,51122005,11,29),(23877200,51122006,11,30),(23877200,51122007,11,31),(23877201,51122007,2,1),(23877201,51122009,2,2),(23878263,247045685,1,1),(23878263,247045686,1,2),(23878263,247045688,1,3),(23878263,247045690,1,4),(23878263,247045691,1,5),(23878263,247045693,1,6),(23878263,247045695,1,7),(23878263,247045696,1,8),(23878263,247045698,1,9),(23878263,247045700,1,10),(23878263,247045701,1,11),(23878263,247045703,1,12),(23878263,247045712,1,13),(23878263,247045718,1,14),(23878263,247045724,1,15),(23878263,247045732,1,16),(23878263,247045739,1,17),(23878263,247045741,1,18),(23878263,247045742,1,19),(23878263,247045744,1,20),(23878263,247045685,1,21),(23878462,51442273,5,1),(23878462,51385300,5,2),(23878462,51385299,5,3),(23878462,51385298,5,4),(23878462,51385297,5,5),(23878462,51385296,5,6),(23878462,51385295,5,7),(23878462,51385292,5,8),(23878462,51385291,5,9),(23878462,51385290,5,10),(23878462,51442041,5,11),(23878462,51442282,5,12),(23878462,51442280,5,13),(23878462,51442278,5,14),(23878462,51442349,5,15),(23878462,51442271,5,16),(23878462,51442273,5,17),(23878463,51384490,5,1),(23878463,51384518,5,2),(23878463,51384488,5,3),(23878463,51384487,5,4),(23878463,51384485,5,5),(23878463,51442352,5,6),(23878463,51384482,5,7),(23878463,51385304,5,8),(23878463,51385302,5,9),(23878463,51442273,5,10),(23924998,51929728,9,1),(23924998,51929731,9,2),(23924998,51929734,9,3),(23924998,51929736,9,4),(23924998,51929739,9,5),(23924998,51929741,9,6),(23924998,51929743,9,7),(23924998,51929746,9,8),(23924998,51929749,9,9),(23924998,51929752,9,10),(23924998,51929754,9,11),(23924998,51929757,9,12),(23924998,51929760,9,13),(23924998,51929762,9,14),(23924998,51929764,9,15),(23924998,51929767,9,16),(23924998,51929770,9,17),(23924998,51929771,9,18),(23924998,51929773,9,19),(23924998,51929775,9,20),(23924998,51929777,9,21),(23924998,51929780,9,22),(23924998,51929782,9,23),(23924998,51929784,9,24),(23924998,51929785,9,25),(23924998,51929786,9,26),(23924998,51929788,9,27),(23924998,51929790,9,28),(23924998,51929793,9,29),(23924998,51929796,9,30),(23924998,51929797,9,31),(23924998,51929800,9,32),(23924998,51929802,9,33),(23924998,51929805,9,34),(23924998,51929807,9,35),(23924998,51929810,9,36),(23924998,51929812,9,37),(23924998,51929814,9,38),(23924998,51929818,9,39),(23924998,51929820,9,40),(23924998,51929823,9,41),(23924998,51929825,9,42),(23924998,51929827,9,43),(23924998,51929829,9,44),(23924998,51929833,9,45),(23924998,51929834,9,46),(23924998,51929837,9,47),(23924998,51929840,9,48),(23924998,51929842,9,49),(23924998,51929844,9,50),(23924998,51929846,9,51),(23924998,51929848,9,52),(23924998,51929852,9,53),(23924998,51929854,9,54),(23924998,51929858,9,55),(23924998,51929860,9,56),(23924998,51929862,9,57),(23924998,51929864,9,58),(23924998,51929866,9,59),(23924998,51929869,9,60),(23924998,51929872,9,61),(23924998,51929873,9,62),(23924998,51929875,9,63),(23924998,51929878,9,64),(23924998,51929880,9,65),(23924998,51929883,9,66),(23924998,51929886,9,67),(23924998,51929889,9,68),(23924998,51929892,9,69),(23924998,51929893,9,70),(23924998,51929896,9,71),(23924998,51929899,9,72),(23924998,51929902,9,73),(23924998,51929905,9,74),(23924998,51929907,9,75),(23924998,51929909,9,76),(23924998,51929910,9,77),(23924998,51929913,9,78),(23924998,51929915,9,79),(23924998,51929916,9,80),(23924998,51929918,9,81),(23924998,51929920,9,82),(23924998,51929922,9,83),(23924998,51929923,9,84),(23924998,51929925,9,85),(23924998,51929927,9,86),(23924998,51929930,9,87),(23924998,51929933,9,88),(23924998,51929936,9,89),(23924998,51929938,9,90),(23924998,51929939,9,91),(23924998,51929942,9,92),(23924998,51929943,9,93),(23924998,51929946,9,94),(23924998,51929949,9,95),(23924998,51929950,9,96),(23924998,51929953,9,97),(23924998,51929955,9,98),(23924998,51929957,9,99),(23924998,51929960,9,100),(23924998,51929964,9,101),(23924998,51929966,9,102),(23924998,51929968,9,103),(23924998,51929971,9,104),(23924998,51929974,9,105),(23924998,51929975,9,106),(23924998,51929978,9,107),(23924998,51929980,9,108),(23924998,51929983,9,109),(23924998,51929986,9,110),(23924998,51929988,9,111),(23924998,51929990,9,112),(23924998,51929993,9,113),(23924998,51929999,9,114),(23924998,51930002,9,115),(23924998,51930009,9,116),(23924998,51930014,9,117),(23924998,51930018,9,118),(23924998,51930020,9,119),(23924998,51930022,9,120),(23924998,51930024,9,121),(23924998,51930026,9,122),(23924998,51930027,9,123),(23924998,51930029,9,124),(23924998,51930031,9,125),(23924998,51930033,9,126),(23924998,51930035,9,127),(23924998,51930037,9,128),(23924998,51930040,9,129),(23924998,51930043,9,130),(23924998,51930044,9,131),(23924998,51930047,9,132),(23924998,51930048,9,133),(23924998,51930050,9,134),(23924998,51930052,9,135),(23924998,51930053,9,136),(23924998,51930055,9,137),(23924998,51930058,9,138),(23924998,51930062,9,139),(23924998,51930063,9,140),(23924998,51930066,9,141),(23924998,51930068,9,142),(23924998,51930071,9,143),(23924998,51930073,9,144),(23924998,51930076,9,145),(23924998,51930079,9,146),(23924998,51930080,9,147),(23924998,51930082,9,148),(23924998,51930085,9,149),(23924998,51930088,9,150),(23924998,51930092,9,151),(23924998,51930094,9,152),(23924998,51930096,9,153),(23924998,51930098,9,154),(23924998,51930099,9,155),(23924998,51930102,9,156),(23924998,51930104,9,157),(23924998,51930107,9,158),(23924998,51930108,9,159),(23924998,51930110,9,160),(23924998,51930112,9,161),(23924998,51930113,9,162),(23924998,51930115,9,163),(23924998,51930118,9,164),(23924998,51930119,9,165),(23924998,51930121,9,166),(23924998,51930124,9,167),(23924998,51930125,9,168),(23924998,51930127,9,169),(23924998,51930129,9,170),(23924998,51930132,9,171),(23924998,51930134,9,172),(23924998,51930136,9,173),(23924998,51930138,9,174),(23924998,51930141,9,175),(23924998,51930143,9,176),(23924998,51930145,9,177),(23924998,51930148,9,178),(23924998,51930149,9,179),(23924998,51930152,9,180),(23924998,51930153,9,181),(23924998,51930156,9,182),(23924998,51930158,9,183),(23924998,51930160,9,184),(23924998,51930163,9,185),(23924998,51930165,9,186),(23924998,51930167,9,187),(23924998,51930169,9,188),(23924998,51930171,9,189),(23924998,51930173,9,190),(23924998,51930175,9,191),(23924998,51930177,9,192),(23924998,51930178,9,193),(23924998,51930181,9,194),(23924998,51930184,9,195),(23924998,51930186,9,196),(23925250,259406456,8,1),(23925250,259406455,8,2),(23925250,259406454,8,3),(23925250,259406453,8,4),(23925250,259406452,8,5),(23925250,259406451,8,6),(23925250,259406450,8,7),(23925250,259406449,8,8),(23925250,259406448,8,9),(23925250,259406447,8,10),(23925250,259406446,8,11),(23925250,259406445,8,12),(23925255,259406445,4,1),(23925255,51366554,4,2),(23925255,51366556,4,3),(23925255,625030,4,4),(23925255,51366560,4,5),(23925255,51366562,4,6),(23925255,625031,4,7),(23925255,51366564,4,8),(23925255,625032,4,9),(23925255,625033,4,10),(23925285,259406456,2,1),(23925285,51366854,2,2),(23938547,261004007,5,1),(23938547,261004008,5,2),(23938547,259475446,5,3),(23978189,259984359,5,1),(23978189,260997624,5,2),(23978342,259984359,3,1),(23978342,259985586,3,2),(23978342,259985587,3,3),(23978424,259985587,1,1),(23978424,259985588,1,2),(23978424,259985589,1,3),(23978424,259985590,1,4),(23978424,259985592,1,5),(23978424,259985593,1,6),(23978424,259985594,1,7),(23978424,259985595,1,8),(23978424,259985596,1,9),(23978424,259985597,1,10),(23978424,259985598,1,11),(23978424,259985599,1,12),(23978424,259985600,1,13),(23978424,259985601,1,14),(23978424,259985602,1,15),(23978424,259985603,1,16),(23978424,259985604,1,17),(23978424,259985605,1,18),(23978424,259985606,1,19),(23978424,259983829,1,20),(23978499,259986470,2,1),(23978499,259986747,2,2),(24058474,287401324,2,1),(24058474,260984109,2,2),(24058474,260984110,2,3),(24058474,260984111,2,4),(24058474,260984112,2,5),(24058474,260984113,2,6),(24058474,260984114,2,7),(24058474,260984115,2,8),(24058474,260984116,2,9),(24058474,260984117,2,10),(24058474,260984118,2,11),(24058474,260984120,2,12),(24058474,260984121,2,13),(24058474,260984122,2,14),(24058474,260984123,2,15),(24058474,260984124,2,16),(24058474,260984125,2,17),(24058474,260984126,2,18),(24058474,260984127,2,19),(24058474,260984128,2,20),(24059004,260995478,3,1),(24059004,262151572,3,2),(24059067,260996387,3,1),(24059067,260996388,3,2),(24059067,260996389,3,3),(24059067,260996390,3,4),(24059067,260996391,3,5),(24059067,262151572,3,6),(24059067,260996392,3,7),(24059068,260996392,6,1),(24059068,262151641,6,2),(24059068,260996399,6,3),(24059068,260996400,6,4),(24059068,260996401,6,5),(24059068,260996402,6,6),(24059068,260996403,6,7),(24059068,260996405,6,8),(24059068,260996406,6,9),(24059068,260996407,6,10),(24059068,260996408,6,11),(24059068,260996409,6,12),(24059068,260996410,6,13),(24059068,260996411,6,14),(24059068,260996413,6,15),(24059068,260996414,6,16),(24059068,260996415,6,17),(24059068,260996416,6,18),(24059068,260996417,6,19),(24059068,260996418,6,20),(24059068,260996419,6,21),(24059068,260996421,6,22),(24059068,260996422,6,23),(24059068,260996423,6,24),(24059068,260996425,6,25),(24059068,260996426,6,26),(24059068,260996427,6,27),(24059068,260996429,6,28),(24059068,260996430,6,29),(24059068,260996431,6,30),(24059068,260996432,6,31),(24059068,260996434,6,32),(24059068,260996435,6,33),(24059068,260996436,6,34),(24059068,260996437,6,35),(24059122,260997624,3,1),(24059122,260997625,3,2),(24059295,260997625,4,1),(24059295,260997626,4,2),(24059296,260997626,2,1),(24059296,260997627,2,2),(24059351,260997627,3,1),(24059351,261001744,3,2),(24059351,261001745,3,3),(24059351,261001746,3,4),(24059351,261001747,3,5),(24059351,261001748,3,6),(24059351,261001749,3,7),(24059351,261001750,3,8),(24059351,261001751,3,9),(24059351,261001752,3,10),(24059351,261001753,3,11),(24059379,259475495,2,1),(24059379,259475494,2,2),(24059379,259475493,2,3),(24059379,259475455,2,4),(24059379,260997627,2,5),(24059392,261001753,2,1),(24059392,261002668,2,2),(24059392,261002669,2,3),(24059392,261002671,2,4),(24059392,261002672,2,5),(24059392,261002673,2,6),(24059392,261002674,2,7),(24059392,261002675,2,8),(24059418,261002675,1,1),(24059418,261003171,1,2),(24059418,261003172,1,3),(24059453,259475446,3,1),(24059453,259475447,3,2),(24059453,259475448,3,3),(24059453,259475449,3,4),(24059453,259475450,3,5),(24059453,259475451,3,6),(24059453,259475452,3,7),(24059453,259475453,3,8),(24059453,259475454,3,9),(24059453,259475455,3,10),(24059572,261006066,1,1),(24059572,261006067,1,2),(24059572,261006068,1,3),(24059572,261006069,1,4),(24059572,261006070,1,5),(24059572,261006071,1,6),(24059572,261006072,1,7),(24059572,261006073,1,8),(24059572,261006074,1,9),(24059572,261006075,1,10),(24059572,261006076,1,11),(24059832,53319512,3,1),(24059832,53319557,3,2),(24059832,53319554,3,3),(24059832,53319509,3,4),(24059832,53319505,3,5),(24059832,53319503,3,6),(24059832,53319500,3,7),(24059832,53319497,3,8),(24059832,53319533,3,9),(24059832,53319495,3,10),(24059832,53319492,3,11),(24059832,53319491,3,12),(24059832,51552711,3,13),(24059857,53327626,5,1),(24059857,53327622,5,2),(24059857,53327620,5,3),(24059999,53325815,2,1),(24059999,53325817,2,2),(24060059,53319735,4,1),(24060059,53325843,4,2),(24060059,53325840,4,3),(24060059,53325829,4,4),(24060059,53325827,4,5),(24060059,53325823,4,6),(24060059,261012137,4,7),(24060059,261012136,4,8),(24060059,261012135,4,9),(24060059,261012134,4,10),(24060059,261012133,4,11),(24060059,53325852,4,12),(24060059,53325850,4,13),(24060059,53325848,4,14),(24060059,262459990,4,15),(24060059,53325846,4,16),(24060059,53325709,4,17),(24060059,53325711,4,18),(24060059,53325715,4,19),(24060059,53325718,4,20),(24060059,53325720,4,21),(24060059,53325722,4,22),(24060059,53325723,4,23),(24060059,53325724,4,24),(24060059,53325725,4,25),(24060059,53325726,4,26),(24060059,53325729,4,27),(24060059,53325732,4,28),(24060260,52204446,5,1),(24060260,52204445,5,2),(24060706,53306911,7,1),(24060706,53306910,7,2),(24060706,53306907,7,3),(24060706,53306906,7,4),(24060706,53306904,7,5),(24060706,53306901,7,6),(24060706,53306899,7,7),(24060706,53306897,7,8),(24060706,259983829,7,9),(24060706,53306893,7,10),(24060706,53306892,7,11),(24060706,53306889,7,12),(24060706,415767148,7,13),(24060706,53306888,7,14),(24060706,53306887,7,15),(24060706,53306886,7,16),(24060706,53306885,7,17),(24060706,53306882,7,18),(24060706,53306881,7,19),(24060706,53306878,7,20),(24060706,53306876,7,21),(24060706,53306875,7,22),(24060706,441154951,7,23),(24060706,53306874,7,24),(24060706,53306873,7,25),(24060706,53306871,7,26),(24060706,53306806,7,27),(24060706,53306804,7,28),(24060706,53306803,7,29),(24060706,53306800,7,30),(24060706,53306799,7,31),(24060706,53306796,7,32),(24060706,53306795,7,33),(24060706,53306794,7,34),(24060706,53306792,7,35),(24060706,53306791,7,36),(24060706,53306790,7,37),(24060706,53306866,7,38),(24060706,53306789,7,39),(24060706,53306788,7,40),(24060706,53306787,7,41),(24060781,53295259,5,1),(24060781,53295257,5,2),(24060781,53295253,5,3),(24060781,53295251,5,4),(24060781,53295249,5,5),(24060781,53295245,5,6),(24060781,53295243,5,7),(24060781,53295241,5,8),(24060781,53295236,5,9),(24060781,53295233,5,10),(24060781,53295228,5,11),(24060781,53295224,5,12),(24060781,53295222,5,13),(24060781,53295218,5,14),(24060781,53295211,5,15),(24060781,53295208,5,16),(24060781,53295202,5,17),(24060781,53295197,5,18),(24060781,53295193,5,19),(24060781,53295190,5,20),(24060781,53295188,5,21),(24060781,53295272,5,22),(24060781,53295186,5,23),(24060781,53295182,5,24),(24060781,53295178,5,25),(24060781,53295175,5,26),(24060781,53295172,5,27),(24060781,53295169,5,28),(24060781,53295165,5,29),(24060781,53295161,5,30),(24060781,53295158,5,31),(24060781,53295157,5,32),(24060781,53295153,5,33),(24060781,53295149,5,34),(24060781,53295147,5,35),(24060781,53295143,5,36),(24060781,53295141,5,37),(24060781,53295137,5,38),(24060781,53295133,5,39),(24060781,53295132,5,40),(24060781,53295128,5,41),(24060781,53295125,5,42),(24060781,53295122,5,43),(24060781,53295117,5,44),(24060781,53295113,5,45),(24060781,53295110,5,46),(24060781,53295107,5,47),(24060781,53295103,5,48),(24060781,53295102,5,49),(24060781,53295097,5,50),(24060781,53295093,5,51),(24060781,53295090,5,52),(24060781,53295085,5,53),(24060781,53295083,5,54),(24060781,53295079,5,55),(24060781,53295077,5,56),(24060781,53295073,5,57),(24060781,53295071,5,58),(24060781,53295067,5,59),(24060781,53295063,5,60),(24060781,53295059,5,61),(24060781,53295057,5,62),(24060781,53295054,5,63),(24060781,53295051,5,64),(24060781,53295047,5,65),(24060781,53295045,5,66),(24060781,53295040,5,67),(24060781,53295038,5,68),(24060781,53295035,5,69),(24060781,53295043,5,70),(24060781,53295033,5,71),(24060781,53295029,5,72),(24060781,53295026,5,73),(24060781,53295022,5,74),(24060781,53295019,5,75),(24060781,53295016,5,76),(24060781,53295014,5,77),(24060781,53295011,5,78),(24060781,53295010,5,79),(24060781,53295006,5,80),(24060781,53295004,5,81),(24060781,53295002,5,82),(24060781,53294998,5,83),(24060781,53294994,5,84),(24060840,53306959,17,1),(24060840,335320657,17,2),(24060840,53306956,17,3),(24060840,53306954,17,4),(24060840,53306952,17,5),(24060840,53306949,17,6),(24060840,53306946,17,7),(24060840,53306944,17,8),(24060840,53306943,17,9),(24060840,53306940,17,10),(24060840,53306938,17,11),(24060840,53306936,17,12),(24060840,53306935,17,13),(24060840,53306932,17,14),(24060840,264495953,17,15),(24060840,53306930,17,16),(24060840,53306928,17,17),(24060840,264495540,17,18),(24060840,53306925,17,19),(24060840,53306923,17,20),(24060840,264501521,17,21),(24060840,53306921,17,22),(24060840,53306980,17,23),(24060840,276998391,17,24),(24060840,53306917,17,25),(24060840,53309382,17,26),(24060840,53306913,17,27),(24240688,262459990,3,1),(24240688,262459991,3,2),(24240688,262459992,3,3),(24240688,262459993,3,4),(24240688,262459994,3,5),(24240688,262459995,3,6),(24240688,262459997,3,7),(24240688,262459998,3,8),(24240688,262459999,3,9),(24240699,262460047,3,1),(24240699,262459991,3,2),(24240709,262460177,2,1),(24240709,262460178,2,2),(24240709,262460179,2,3),(24240709,262460180,2,4),(24240709,262460181,2,5),(24240709,262459992,2,6),(24240780,262460920,10,1),(24240780,262460921,10,2),(24240780,262460922,10,3),(24240808,53319512,10,1),(24240808,53319714,10,2),(24240808,53319712,10,3),(24240808,53319710,10,4),(24240808,53319708,10,5),(24240808,53319705,10,6),(24240808,53319707,10,7),(24240808,53319717,10,8),(24240808,53319718,10,9),(24240808,53319720,10,10),(24240808,53319721,10,11),(24240808,53325818,10,12),(24240808,53319724,10,13),(24240808,53319725,10,14),(24240808,53319726,10,15),(24240808,53319727,10,16),(24240808,53319731,10,17),(24240808,53319732,10,18),(24240808,53319735,10,19),(24240808,53319787,10,20),(24240808,53319737,10,21),(24240808,53319740,10,22),(24240808,53319741,10,23),(24240808,53319742,10,24),(24240808,53319744,10,25),(24240808,53319747,10,26),(24240808,262461658,10,27),(24240808,262461659,10,28),(24240808,262461660,10,29),(24240808,262461661,10,30),(24240808,262461662,10,31),(24240808,262461663,10,32),(24240808,262461664,10,33),(24240808,338418931,10,34),(24240808,338418932,10,35),(24240808,262460922,10,36),(24240825,262461792,4,1),(24240825,262460922,4,2),(24240826,262460920,6,1),(24240826,262462281,6,2),(24240826,262461823,6,3),(24240826,262461824,6,4),(24240826,262461825,6,5),(24240826,262461826,6,6),(24240826,262461827,6,7),(24240826,262461828,6,8),(24240835,262460922,6,1),(24240835,262461793,6,2),(24240835,262461794,6,3),(24240835,262461792,6,4),(24240835,262460922,6,5),(24240868,262462280,2,1),(24240868,262462281,2,2),(24241040,262464083,9,1),(24241040,262464084,9,2),(24241040,262464085,9,3),(24241040,262464086,9,4),(24241040,262464087,9,5),(24241040,262464088,9,6),(24241040,262464089,9,7),(24241040,262464090,9,8),(24241040,262464091,9,9),(24241040,262464092,9,10),(24241040,262464093,9,11),(24241040,470357348,9,12),(24241040,262464094,9,13),(24241040,262464095,9,14),(24241040,262464096,9,15),(24241040,262464097,9,16),(24241040,470356873,9,17),(24241040,470352988,9,18),(24241040,262464098,9,19),(24241040,262464099,9,20),(24241040,262464100,9,21),(24241040,262464101,9,22),(24241072,262464083,6,1),(24241072,268081464,6,2),(24241072,262464355,6,3),(24241072,268081234,6,4),(24241072,268081236,6,5),(24241072,268081237,6,6),(24241072,268081238,6,7),(24241072,268081239,6,8),(24241072,268081241,6,9),(24241072,268081242,6,10),(24241072,268081243,6,11),(24241274,262465820,1,1),(24241274,262466981,1,2),(24241274,262466982,1,3),(24241278,262466982,2,1),(24241278,262467014,2,2),(24241281,262467014,2,1),(24241281,262467028,2,2),(24241289,262467028,1,1),(24241289,262467056,1,2),(24241289,262467057,1,3),(24241289,262467058,1,4),(24241289,262467059,1,5),(24241289,262467060,1,6),(24241289,262467061,1,7),(24241364,51930199,12,1),(24241364,51930202,12,2),(24241364,51930206,12,3),(24241364,51930208,12,4),(24241364,51930211,12,5),(24241364,51930213,12,6),(24241364,51930216,12,7),(24241364,51930219,12,8),(24241364,51930222,12,9),(24241364,51930223,12,10),(24241364,51930226,12,11),(24241364,51930228,12,12),(24241364,51930230,12,13),(24241364,51930232,12,14),(24241364,51930235,12,15),(24241364,51930238,12,16),(24241364,51930241,12,17),(24241364,51930242,12,18),(24241364,51930245,12,19),(24241364,51930247,12,20),(24241364,51930250,12,21),(24241364,51930252,12,22),(24241364,51930253,12,23),(24241364,51930255,12,24),(24241364,51930257,12,25),(24241364,51930259,12,26),(24241364,51930262,12,27),(24241364,51930264,12,28),(24241364,51930267,12,29),(24241364,51930270,12,30),(24241364,51930272,12,31),(24241364,51930275,12,32),(24241364,51930278,12,33),(24241364,51930280,12,34),(24241364,51930282,12,35),(24241364,51930284,12,36),(24241364,51930288,12,37),(24241364,51930291,12,38),(24241364,51930293,12,39),(24241364,51930297,12,40),(24241364,51930299,12,41),(24241364,51930302,12,42),(24241364,51930305,12,43),(24241364,51930307,12,44),(24241364,51930309,12,45),(24241364,51930311,12,46),(24241364,51930312,12,47),(24241364,51930313,12,48),(24241364,51930314,12,49),(24241364,51930315,12,50),(24241364,51930319,12,51),(24241364,51930386,12,52),(24241364,51930321,12,53),(24241364,51930324,12,54),(24241364,51930326,12,55),(24241364,51930328,12,56),(24241364,51930331,12,57),(24241364,51930332,12,58),(24241364,51930403,12,59),(24241364,51930405,12,60),(24241364,51930408,12,61),(24241364,51930410,12,62),(24241364,51930412,12,63),(24241364,51930413,12,64),(24241364,51930415,12,65),(24241364,51930416,12,66),(24241364,51930417,12,67),(24241364,51930418,12,68),(24241364,51930420,12,69),(24241364,51930422,12,70),(24241364,51930424,12,71),(24241364,51930426,12,72),(24241364,51930428,12,73),(24241364,51930429,12,74),(24241364,51930433,12,75),(24241364,51930437,12,76),(24241364,51930439,12,77),(24241364,51930441,12,78),(24241364,51930443,12,79),(24241364,51930445,12,80),(24241364,51930447,12,81),(24241364,51930448,12,82),(24241364,51930449,12,83),(24241364,51930450,12,84),(24241364,51930453,12,85),(24241364,51930455,12,86),(24241364,51930457,12,87),(24241364,51930458,12,88),(24241364,51930461,12,89),(24241364,51930462,12,90),(24241364,51930465,12,91),(24241364,51930467,12,92),(24241364,51930469,12,93),(24241364,51930470,12,94),(24241364,51930473,12,95),(24241364,51930475,12,96),(24241364,51930478,12,97),(24241364,51930481,12,98),(24241364,51930483,12,99),(24241364,51930485,12,100),(24241364,51930488,12,101),(24241364,51930492,12,102),(24241364,51930495,12,103),(24241364,51930497,12,104),(24241364,51930500,12,105),(24241364,51930503,12,106),(24241364,51930505,12,107),(24241364,51930507,12,108),(24241364,51930509,12,109),(24241364,51930511,12,110),(24241364,51930513,12,111),(24241364,51930517,12,112),(24241364,51930519,12,113),(24241364,51930521,12,114),(24241364,51930524,12,115),(24241364,51930527,12,116),(24241364,51930531,12,117),(24241364,51930534,12,118),(24241364,51930537,12,119),(24241364,51930540,12,120),(24241364,51930542,12,121),(24241364,51930544,12,122),(24241364,51930548,12,123),(24241364,51930553,12,124),(24241364,51930556,12,125),(24241364,51930560,12,126),(24241364,51930563,12,127),(24241364,51930565,12,128),(24241364,51930567,12,129),(24241364,51930569,12,130),(24241364,51930572,12,131),(24241364,51930573,12,132),(24241364,51930576,12,133),(24241364,51930579,12,134),(24241364,51930582,12,135),(24241364,51930583,12,136),(24241364,51930586,12,137),(24241364,51930588,12,138),(24241364,51930590,12,139),(24241364,51930593,12,140),(24241364,51930595,12,141),(24241364,51930597,12,142),(24241364,51930599,12,143),(24241364,51930602,12,144),(24241364,51930604,12,145),(24241364,51930606,12,146),(24241364,51930609,12,147),(24241364,51930611,12,148),(24241364,51930614,12,149),(24241364,51930616,12,150),(24241364,51930630,12,151),(24241364,51930628,12,152),(24241364,51930619,12,153),(24241364,51930626,12,154),(24241364,51930621,12,155),(24241364,51930623,12,156),(24241364,51930633,12,157),(24241364,51930636,12,158),(24241364,51930638,12,159),(24241364,51930640,12,160),(24241364,51930641,12,161),(24241364,51930643,12,162),(24241364,51930645,12,163),(24241364,51930648,12,164),(24279813,262467026,1,1),(24279813,262467028,1,2),(24279886,262461792,1,1),(24279886,262460920,1,2),(24279950,51401220,4,1),(24279950,51401223,4,2),(24279950,51401224,4,3),(24279950,51401226,4,4),(24279950,51401227,4,5),(24279950,51401228,4,6),(24279950,51400770,4,7),(24279950,51400772,4,8),(24279950,51400773,4,9),(24279950,51400870,4,10),(24279950,51400777,4,11),(24279950,51400778,4,12),(24279950,51400779,4,13),(24279950,51400782,4,14),(24279950,51410282,4,15),(24279950,51400784,4,16),(24279950,51400786,4,17),(24279950,51400787,4,18),(24279950,51410232,4,19),(24279950,51400789,4,20),(24279950,51400791,4,21),(24279950,51400793,4,22),(24279950,51400794,4,23),(24280101,52206645,6,1),(24280101,52206632,6,2),(24280101,52206635,6,3),(24280101,52206639,6,4),(24280101,52206643,6,5),(24280274,51930648,3,1),(24280274,51930650,3,2),(24280275,51930650,4,1),(24280275,51930652,4,2),(24280275,51930653,4,3),(24280275,51930656,4,4),(24280275,51930657,4,5),(24280275,51930661,4,6),(24280275,51930663,4,7),(24280275,51930665,4,8),(24280275,51930668,4,9),(24280275,51930671,4,10),(24280275,51930674,4,11),(24280275,51930676,4,12),(24280275,51930680,4,13),(24280275,51930682,4,14),(24280275,51930684,4,15),(24280275,51930686,4,16),(24280275,51930687,4,17),(24280275,51930689,4,18),(24280275,51930691,4,19),(24280275,51930692,4,20),(24280275,51930695,4,21),(24280275,51930697,4,22),(24280275,51930699,4,23),(24280275,51930702,4,24),(24280275,51930705,4,25),(24280275,51930706,4,26),(24280275,51930709,4,27),(24280275,51930712,4,28),(24280275,51930713,4,29),(24280275,51930716,4,30),(24280275,51930718,4,31),(24280275,51930721,4,32),(24280275,51930723,4,33),(24280275,51930726,4,34),(24280275,51930727,4,35),(24280275,51930729,4,36),(24280275,51930731,4,37),(24280275,51930732,4,38),(24280275,51930734,4,39),(24280275,51930736,4,40),(24280275,51930738,4,41),(24280275,51930741,4,42),(24280275,51930743,4,43),(24280275,51930745,4,44),(24280275,51930748,4,45),(24280275,51930750,4,46),(24280275,51930751,4,47),(24280275,51930754,4,48),(24280275,51930756,4,49),(24280275,51930758,4,50),(24280275,51930761,4,51),(24280275,51930762,4,52),(24280275,51930765,4,53),(24280275,51930768,4,54),(24280275,51930769,4,55),(24280275,51930771,4,56),(24280275,51930775,4,57),(24280275,51930777,4,58),(24280275,51930779,4,59),(24280275,51930781,4,60),(24280275,51930783,4,61),(24280275,51930786,4,62),(24280275,51930788,4,63),(24280275,51930790,4,64),(24280275,51930793,4,65),(24280275,51930794,4,66),(24280275,51930797,4,67),(24280275,51930800,4,68),(24280275,51930802,4,69),(24280275,51930806,4,70),(24280275,51930807,4,71),(24280275,51930808,4,72),(24280275,51930809,4,73),(24280275,51930812,4,74),(24280275,51930814,4,75),(24280275,51930815,4,76),(24280275,51930816,4,77),(24280275,51930818,4,78),(24280275,51930821,4,79),(24280275,51930823,4,80),(24280275,51930826,4,81),(24280275,51930828,4,82),(24280275,51930830,4,83),(24280275,51930831,4,84),(24280275,51930834,4,85),(24280275,51930836,4,86),(24280275,51930839,4,87),(24280275,51930840,4,88),(24280275,51930843,4,89),(24280275,51930844,4,90),(24280275,51930847,4,91),(24280275,51930850,4,92),(24280275,51930851,4,93),(24280275,51930854,4,94),(24280275,51930855,4,95),(24280275,51930858,4,96),(24280275,51930859,4,97),(24280275,51930862,4,98),(24280275,51930864,4,99),(24280275,51930865,4,100),(24280275,51930866,4,101),(24280275,51930867,4,102),(24280275,51930869,4,103),(24280275,51930871,4,104),(24280275,51930873,4,105),(24280275,51930876,4,106),(24280275,51930879,4,107),(24280275,51930882,4,108),(24280275,51930883,4,109),(24280275,51930885,4,110),(24280275,51930887,4,111),(24280275,51930889,4,112),(24280275,51930891,4,113),(24280275,51930893,4,114),(24280275,51930895,4,115),(24280275,51930896,4,116),(24280275,51930898,4,117),(24280275,51930900,4,118),(24280275,51930901,4,119),(24280275,51930905,4,120),(24280275,51930907,4,121),(24280275,51930908,4,122),(24280275,51930909,4,123),(24280275,51930911,4,124),(24280275,51930913,4,125),(24280275,51930915,4,126),(24280275,51930918,4,127),(24280275,51930920,4,128),(24280275,51930923,4,129),(24280275,51930926,4,130),(24280275,51930928,4,131),(24280275,51930930,4,132),(24280275,51930932,4,133),(24280275,51930935,4,134),(24280275,51930937,4,135),(24280275,51930940,4,136),(24280275,51930942,4,137),(24280275,51930944,4,138),(24280275,51930947,4,139),(24280275,51930950,4,140),(24280275,51930952,4,141),(24280275,51930953,4,142),(24280275,51930954,4,143),(24280275,51930956,4,144),(24280275,51930958,4,145),(24280275,51930961,4,146),(24280275,51930962,4,147),(24280275,51930965,4,148),(24280275,51930967,4,149),(24280275,51930968,4,150),(24280275,51930971,4,151),(24280275,51930973,4,152),(24280275,51930974,4,153),(24280275,51930975,4,154),(24280275,51930976,4,155),(24280275,51930978,4,156),(24280275,51930981,4,157),(24280275,51930983,4,158),(24280276,51930983,3,1),(24280276,51930984,3,2),(24280277,51930984,4,1),(24280277,51930985,4,2),(24280277,51930986,4,3),(24280277,51930987,4,4),(24280277,51930990,4,5),(24280277,51930992,4,6),(24280277,51930995,4,7),(24280277,51930998,4,8),(24280277,51930999,4,9),(24280277,51931002,4,10),(24280277,51931005,4,11),(24280277,51931006,4,12),(24280277,51931009,4,13),(24280277,51931012,4,14),(24280277,51931014,4,15),(24280277,51931018,4,16),(24280277,51931020,4,17),(24280277,51931023,4,18),(24280277,51931025,4,19),(24280277,51931026,4,20),(24280277,51931029,4,21),(24280277,51931032,4,22),(24280277,51931036,4,23),(24280277,51931037,4,24),(24280277,51931040,4,25),(24280277,51931043,4,26),(24280277,51931045,4,27),(24280277,51931047,4,28),(24280277,51931050,4,29),(24280277,51931053,4,30),(24280277,51931055,4,31),(24280277,51931057,4,32),(24280277,51931060,4,33),(24280277,51931062,4,34),(24280277,51931065,4,35),(24280277,51931066,4,36),(24280277,51931069,4,37),(24280277,51931070,4,38),(24280277,51931073,4,39),(24280277,51931076,4,40),(24280277,51931077,4,41),(24280277,51931080,4,42),(24280277,51931084,4,43),(24280277,51931087,4,44),(24280277,51931090,4,45),(24280277,51931093,4,46),(24280277,51931095,4,47),(24280277,51931097,4,48),(24280277,51931099,4,49),(24280277,51931101,4,50),(24280277,51931103,4,51),(24280277,51931105,4,52),(24280278,53275508,3,1),(24280278,53275510,3,2),(24280279,53275510,2,1),(24280279,53275511,2,2),(24280279,53275512,2,3),(24280279,53275514,2,4),(24280279,53275515,2,5),(24280279,53275516,2,6),(24280279,53275517,2,7),(24280279,53275518,2,8),(24280279,53275519,2,9),(24280279,53275032,2,10),(24280280,262892996,3,1),(24280280,262892997,3,2),(24280281,262892997,4,1),(24280281,625259,4,2),(24280281,53275032,4,3),(24280282,262892998,3,1),(24280282,262892999,3,2),(24280283,262892999,2,1),(24280283,53275040,2,2),(24280284,52652127,2,1),(24280284,52650659,2,2),(24280285,262893000,3,1),(24280285,52652127,3,2),(24280286,52009168,3,1),(24280286,52009171,3,2),(24280287,52009171,2,1),(24280287,52009174,2,2),(24280287,52009176,2,3),(24280287,52009179,2,4),(24280287,52009182,2,5),(24280287,52009184,2,6),(24280287,52009186,2,7),(24280287,52009189,2,8),(24280287,52009192,2,9),(24280287,52009194,2,10),(24280287,52009196,2,11),(24280288,51557999,3,1),(24280288,51558001,3,2),(24280289,51558001,4,1),(24280289,51558003,4,2),(24280289,51558005,4,3),(24280289,51558007,4,4),(24280289,51558010,4,5),(24280289,51558014,4,6),(24280289,51558017,4,7),(24280289,51558021,4,8),(24280289,51558024,4,9),(24280289,51558026,4,10),(24280289,51558029,4,11),(24280289,51558031,4,12),(24280289,51558033,4,13),(24280289,51558036,4,14),(24280289,51558038,4,15),(24280289,51558040,4,16),(24280289,51558041,4,17),(24280289,51558043,4,18),(24280289,51558045,4,19),(24280289,51558047,4,20),(24280289,51558051,4,21),(24280289,51558054,4,22),(24280289,51558057,4,23),(24280289,51558059,4,24),(24280289,51558060,4,25),(24280289,51558063,4,26),(24280289,51558064,4,27),(24280289,51558067,4,28),(24280289,51558070,4,29),(24280289,51558071,4,30),(24280289,51558074,4,31),(24280289,51558075,4,32),(24280289,51558078,4,33),(24280289,51558083,4,34),(24280289,51558085,4,35),(24280289,51558086,4,36),(24280289,51558089,4,37),(24280289,51558091,4,38),(24280289,51558093,4,39),(24280289,51558095,4,40),(24280289,51558097,4,41),(24280289,51558099,4,42),(24280289,51558103,4,43),(24280289,51558105,4,44),(24280289,51558108,4,45),(24280289,51558111,4,46),(24280289,51558113,4,47),(24280289,51558115,4,48),(24280289,51558118,4,49),(24280289,51558121,4,50),(24280289,51558124,4,51),(24280289,51558125,4,52),(24280289,51558128,4,53),(24280289,51558131,4,54),(24280289,51558246,4,55),(24280289,51558248,4,56),(24280289,51558253,4,57),(24280289,51558257,4,58),(24280289,51558260,4,59),(24280289,51558262,4,60),(24280289,51558265,4,61),(24280289,51558268,4,62),(24280289,51558271,4,63),(24280289,51558273,4,64),(24280289,51558276,4,65),(24280289,51558279,4,66),(24280289,51558282,4,67),(24280289,51558284,4,68),(24280289,51558287,4,69),(24280289,51558293,4,70),(24280290,262893002,3,1),(24280290,51552747,3,2),(24280290,262893001,3,3),(24280291,262893001,2,1),(24280291,51552750,2,2),(24280291,53327812,2,3),(24280291,51552755,2,4),(24280291,51552758,2,5),(24280291,51552761,2,6),(24280291,51552762,2,7),(24280291,51552764,2,8),(24280291,51552766,2,9),(24280291,51552768,2,10),(24280291,51552770,2,11),(24280291,51552773,2,12),(24280291,51552774,2,13),(24280291,51552777,2,14),(24280291,51552779,2,15),(24280291,51552782,2,16),(24280291,51552785,2,17),(24280291,51552787,2,18),(24280291,51552789,2,19),(24280291,51552791,2,20),(24280291,51552793,2,21),(24280291,51552797,2,22),(24280291,51552800,2,23),(24280291,51552802,2,24),(24280291,51552806,2,25),(24280291,51552807,2,26),(24280291,51552811,2,27),(24280291,51552814,2,28),(24280291,51552815,2,29),(24280291,51552818,2,30),(24280291,51552821,2,31),(24280291,51552823,2,32),(24280291,51552824,2,33),(24280291,51552825,2,34),(24280291,51552828,2,35),(24280291,51552830,2,36),(24280291,51552832,2,37),(24280291,51552835,2,38),(24280291,51552838,2,39),(24280291,51552841,2,40),(24280291,51552844,2,41),(24280291,51552847,2,42),(24280291,51552849,2,43),(24280291,51552851,2,44),(24280291,51552852,2,45),(24280291,51552854,2,46),(24280291,51552856,2,47),(24280291,51552859,2,48),(24280291,51552861,2,49),(24280291,51552863,2,50),(24280291,51552865,2,51),(24280291,51552868,2,52),(24280291,51552871,2,53),(24280291,51552873,2,54),(24280291,51552875,2,55),(24280292,52204445,22,1),(24280292,268084313,22,2),(24280292,52204442,22,3),(24280292,52204439,22,4),(24280292,52204436,22,5),(24280292,52204434,22,6),(24280292,52204431,22,7),(24280292,52204428,22,8),(24280292,52204425,22,9),(24280292,52204423,22,10),(24280292,52204420,22,11),(24280292,52204417,22,12),(24280292,52204415,22,13),(24280292,52204401,22,14),(24280292,52204397,22,15),(24280292,52204394,22,16),(24280292,52204391,22,17),(24280292,52204388,22,18),(24280292,52204386,22,19),(24280292,52204383,22,20),(24280292,52204380,22,21),(24280292,52204377,22,22),(24280292,52204375,22,23),(24280292,52204371,22,24),(24280292,52204368,22,25),(24280292,52204366,22,26),(24280292,52204363,22,27),(24280292,52204354,22,28),(24280292,52204353,22,29),(24280292,52204350,22,30),(24280292,52204344,22,31),(24280292,52204328,22,32),(24280292,52204324,22,33),(24280292,52204307,22,34),(24280292,52204296,22,35),(24280292,52204294,22,36),(24280292,52204292,22,37),(24280292,52204291,22,38),(24280292,268134045,22,39),(24280292,52204407,22,40),(24280292,52204288,22,41),(24280292,52204404,22,42),(24280292,52204284,22,43),(24280292,52204280,22,44),(24280292,52204275,22,45),(24280292,52204269,22,46),(24280292,52204267,22,47),(24280292,268132091,22,48),(24280292,52204265,22,49),(24280292,52204261,22,50),(24280292,52204258,22,51),(24280292,52204254,22,52),(24280292,268148594,22,53),(24280292,52204251,22,54),(24280292,52204248,22,55),(24280292,52204246,22,56),(24280292,52204243,22,57),(24280292,268096306,22,58),(24280292,52204239,22,59),(24280292,52203066,22,60),(24280292,52202579,22,61),(24280292,52202571,22,62),(24280292,268123710,22,63),(24280292,268123182,22,64),(24280292,268123711,22,65),(24280292,52202566,22,66),(24280292,52202560,22,67),(24280292,52202553,22,68),(24280292,52202552,22,69),(24280292,52202549,22,70),(24280292,52202545,22,71),(24280292,268093053,22,72),(24280293,52204467,4,1),(24280293,262893003,4,2),(24280294,262893003,5,1),(24280294,52204465,5,2),(24280294,268085831,5,3),(24280294,52204462,5,4),(24280294,52204459,5,5),(24280294,52204456,5,6),(24280294,52204453,5,7),(24280294,52204450,5,8),(24280294,52204446,5,9),(24280295,51121956,3,1),(24280295,51121957,3,2),(24280295,51121958,3,3),(24280296,51121958,4,1),(24280296,51121959,4,2),(24280296,51121960,4,3),(24280296,51121962,4,4),(24280296,51121964,4,5),(24280296,51121965,4,6),(24280296,51121967,4,7),(24280296,51121968,4,8),(24280296,51121970,4,9),(24280296,51121972,4,10),(24280296,258823161,4,11),(24341039,264054001,2,1),(24341039,264054002,2,2),(24341039,264054003,2,3),(24341039,264054004,2,4),(24341039,264054005,2,5),(24341039,264054006,2,6),(24341039,264054007,2,7),(24341039,264054008,2,8),(24341039,264054009,2,9),(24341039,264054010,2,10),(24341039,264054011,2,11),(24341039,264054012,2,12),(24341039,264054013,2,13),(24341039,264054014,2,14),(24341039,264054016,2,15),(24341039,264054017,2,16),(24341039,264054018,2,17),(24341039,264054019,2,18),(24341039,264054020,2,19),(24341039,264054021,2,20),(24341039,264054022,2,21),(24341039,264054023,2,22),(24341039,264054024,2,23),(24341039,264053269,2,24),(24360470,51930447,2,1),(24360470,264271683,2,2),(24360470,264271684,2,3),(24360470,264271685,2,4),(24360470,264271686,2,5),(24360470,264271687,2,6),(24360470,264271688,2,7),(24360470,264271689,2,8),(24360470,264271690,2,9),(24360470,264271691,2,10),(24360470,264271692,2,11),(24360470,264271693,2,12),(24360470,264271694,2,13),(24360470,264271695,2,14),(24360470,264271696,2,15),(24360470,264271697,2,16),(24360470,264271698,2,17),(24360470,264271699,2,18),(24360470,264271700,2,19),(24360470,264271701,2,20),(24360537,264272401,2,1),(24360537,264272402,2,2),(24360537,264272403,2,3),(24360537,51930447,2,4),(24360617,264273116,1,1),(24360617,264273117,1,2),(24360845,264274337,2,1),(24360845,264274336,2,2),(24360845,264274335,2,3),(24360845,264274334,2,4),(24360845,264274333,2,5),(24360845,264274332,2,6),(24360845,264274331,2,7),(24360845,264274330,2,8),(24360845,264274329,2,9),(24360845,264274328,2,10),(24360845,264274327,2,11),(24360845,264274326,2,12),(24360845,264274325,2,13),(24360845,264274324,2,14),(24360845,264274323,2,15),(24360845,264274322,2,16),(24360845,264274321,2,17),(24360845,264274320,2,18),(24360845,264274319,2,19),(24360845,264274318,2,20),(24360845,264274317,2,21),(24360845,264274316,2,22),(24360845,264274315,2,23),(24360845,264274314,2,24),(24360845,264274313,2,25),(24360845,264274312,2,26),(24360845,264274311,2,27),(24360845,264274310,2,28),(24360845,264274309,2,29),(24360845,264274308,2,30),(24360845,264274307,2,31),(24360845,264274306,2,32),(24360845,264274305,2,33),(24360845,264274304,2,34),(24360845,264274303,2,35),(24360845,264273117,2,36),(24360845,264274302,2,37),(24360845,264274301,2,38),(24360845,264274300,2,39),(24360845,264274299,2,40),(24360845,264274298,2,41),(24360845,264274297,2,42),(24360845,264274296,2,43),(24360845,264274295,2,44),(24360845,264274294,2,45),(24360845,264274293,2,46),(24360845,264274292,2,47),(24360845,264274291,2,48),(24360845,264274290,2,49),(24360845,264274289,2,50),(24360845,264274288,2,51),(24361232,264278117,2,1),(24361232,264278118,2,2),(24361232,264278119,2,3),(24361232,264278120,2,4),(24361232,264278121,2,5),(24361232,264278122,2,6),(24361232,264278123,2,7),(24361232,264278124,2,8),(24361241,264278152,2,1),(24361241,264278153,2,2),(24361241,264278154,2,3),(24361241,264278155,2,4),(24361241,264278156,2,5),(24361241,264278157,2,6),(24361241,264278158,2,7),(24361241,264278159,2,8),(24361307,51444392,3,1),(24361307,51444393,3,2),(24361307,51444394,3,3),(24361307,51444395,3,4),(24361318,51444395,4,1),(24361318,51444396,4,2),(24361318,51444397,4,3),(24361318,51444398,4,4),(24361318,51444399,4,5),(24361318,51444401,4,6),(24361367,51444444,2,1),(24361367,51444384,2,2),(24361367,51444386,2,3),(24361367,51444387,2,4),(24361367,51444388,2,5),(24361367,51444391,2,6),(24361367,264279593,2,7),(24361367,51444392,2,8),(24361435,51444408,4,1),(24361435,51444410,4,2),(24361435,51444411,4,3),(24361435,51443662,4,4),(24361435,51443663,4,5),(24361435,51443665,4,6),(24361435,51443668,4,7),(24361435,264283312,4,8),(24361435,51443669,4,9),(24361435,51443670,4,10),(24361435,51443671,4,11),(24361435,51443672,4,12),(24361435,51443673,4,13),(24361435,51443676,4,14),(24361435,51443678,4,15),(24361435,51443679,4,16),(24361435,51443680,4,17),(24361435,51443683,4,18),(24361435,51443685,4,19),(24361435,51445785,4,20),(24361575,51404888,3,1),(24361575,51399285,3,2),(24361575,51404889,3,3),(24361575,51404891,3,4),(24361575,51399377,3,5),(24361575,51404893,3,6),(24361575,51399296,3,7),(24361575,51404642,3,8),(24361575,51404632,3,9),(24361984,264294716,10,1),(24361984,264289240,10,2),(24361984,264289241,10,3),(24361984,264289242,10,4),(24362026,264290433,3,1),(24362026,264290434,3,2),(24362026,264290436,3,3),(24362026,264290437,3,4),(24362026,264290438,3,5),(24362026,264290439,3,6),(24362026,264292670,3,7),(24362252,264292663,5,1),(24362252,264292664,5,2),(24362252,264292665,5,3),(24362252,264292666,5,4),(24362252,264292667,5,5),(24362252,264292669,5,6),(24362252,264292670,5,7),(24362255,264292670,3,1),(24362255,264292671,3,2),(24362255,264292672,3,3),(24362255,264292673,3,4),(24362361,264305363,6,1),(24362361,264304664,6,2),(24362361,264304665,6,3),(24362361,264304666,6,4),(24362714,51446494,2,1),(24362714,51446496,2,2),(24362714,51446497,2,3),(24362714,51446498,2,4),(24362714,51406810,2,5),(24362802,51410094,7,1),(24362802,51405539,7,2),(24362802,51405540,7,3),(24362802,51405542,7,4),(24362802,51405543,7,5),(24362802,51405544,7,6),(24362802,51405547,7,7),(24362802,264292673,7,8),(24362802,51405548,7,9),(24362802,51405550,7,10),(24362802,51404720,7,11),(24364447,264331301,9,1),(24364447,264331302,9,2),(24364447,264331303,9,3),(24364447,535384824,9,4),(24364447,264331304,9,5),(24364447,264331305,9,6),(24364447,264331306,9,7),(24364447,264331307,9,8),(24364447,264331308,9,9),(24364447,264331309,9,10),(24364447,264330869,9,11),(24364513,264330869,9,1),(24364513,264330870,9,2),(24364799,51404720,3,1),(24364799,51404721,3,2),(24364799,51404723,3,3),(24364799,51443319,3,4),(24364799,51404725,3,5),(24364799,51404726,3,6),(24364799,51404727,3,7),(24364799,51404632,3,8),(24364799,51404633,3,9),(24364799,51404481,3,10),(24364799,51404482,3,11),(24364799,51404483,3,12),(24364799,51404484,3,13),(24364799,51443089,3,14),(24364799,51404486,3,15),(24367429,53327741,2,1),(24367429,53327743,2,2),(24367429,53327746,2,3),(24367429,53327748,2,4),(24367429,53327749,2,5),(24367429,53327752,2,6),(24367429,53327753,2,7),(24367429,53327755,2,8),(24367429,53327756,2,9),(24367429,53327757,2,10),(24367429,53327758,2,11),(24367429,53327759,2,12),(24367429,53327760,2,13),(24367429,53327763,2,14),(24367429,53327765,2,15),(24367429,53327768,2,16),(24367429,53327769,2,17),(24367429,53327771,2,18),(24367429,53327772,2,19),(24367429,53327775,2,20),(24367429,53327779,2,21),(24367429,53327782,2,22),(24367429,53327789,2,23),(24367429,53327791,2,24),(24367429,53327794,2,25),(24367429,53327799,2,26),(24367429,53327804,2,27),(24367429,53327808,2,28),(24367429,53327812,2,29),(24374047,264465123,1,1),(24374047,264465124,1,2),(24374048,264465124,6,1),(24374048,51582213,6,2),(24374048,51582216,6,3),(24374048,51582218,6,4),(24374048,51582221,6,5),(24374048,51582224,6,6),(24374048,51582227,6,7),(24374048,51582229,6,8),(24374048,51582231,6,9),(24374048,51582233,6,10),(24374048,51582234,6,11),(24374048,51582237,6,12),(24374048,51582239,6,13),(24374048,51582241,6,14),(24374048,51582242,6,15),(24374048,51582245,6,16),(24374048,51582247,6,17),(24374048,51582251,6,18),(24374048,51582253,6,19),(24374048,51582256,6,20),(24374048,51582258,6,21),(24374048,51582261,6,22),(24374048,51582264,6,23),(24374048,51582267,6,24),(24374048,51582270,6,25),(24374048,51582271,6,26),(24374048,51582274,6,27),(24374048,52168228,6,28),(24374048,51582279,6,29),(24374048,51582282,6,30),(24374048,51582284,6,31),(24374048,51582287,6,32),(24374048,51582290,6,33),(24374048,51582293,6,34),(24374048,51582294,6,35),(24374048,51582297,6,36),(24374048,51582300,6,37),(24374048,316985239,6,38),(24374048,51582303,6,39),(24374048,51582306,6,40),(24374048,51582308,6,41),(24374048,51582309,6,42),(24374048,51582311,6,43),(24374048,51582313,6,44),(24374048,51582315,6,45),(24374048,51582316,6,46),(24374048,51582318,6,47),(24374048,51582320,6,48),(24374048,51582323,6,49),(24374048,51582326,6,50),(24374048,51582329,6,51),(24374048,51582332,6,52),(24374048,51582335,6,53),(24374048,51582338,6,54),(24374048,51582339,6,55),(24374048,51582342,6,56),(24374048,51582345,6,57),(24374048,51582346,6,58),(24374048,51582349,6,59),(24374048,51582352,6,60),(24374048,51582355,6,61),(24374048,51582357,6,62),(24374048,51582360,6,63),(24374048,51582362,6,64),(24374048,51582365,6,65),(24374048,51582368,6,66),(24374048,51582371,6,67),(24374048,51582373,6,68),(24374048,51582377,6,69),(24374048,51582380,6,70),(24374048,51582383,6,71),(24374048,51582385,6,72),(24374048,51582388,6,73),(24374048,51582392,6,74),(24374048,51582395,6,75),(24374048,51582399,6,76),(24374048,51582403,6,77),(24374048,51582405,6,78),(24374048,51582407,6,79),(24374048,51582410,6,80),(24374048,51582413,6,81),(24374048,51582415,6,82),(24374048,51582418,6,83),(24374048,51582421,6,84),(24374048,51582424,6,85),(24374048,51582426,6,86),(24374048,51582429,6,87),(24374048,51582432,6,88),(24374048,51582435,6,89),(24374048,51582437,6,90),(24374048,51582439,6,91),(24374048,51582441,6,92),(24374048,51582444,6,93),(24374048,51582446,6,94),(24374048,51582448,6,95),(24374048,51582451,6,96),(24374048,51582453,6,97),(24374048,51582455,6,98),(24374048,51582459,6,99),(24374048,51582462,6,100),(24374048,51582463,6,101),(24374048,51582465,6,102),(24374048,51582469,6,103),(24374048,51582472,6,104),(24374048,51582474,6,105),(24374048,51582476,6,106),(24374048,51582479,6,107),(24374048,51582482,6,108),(24374048,51582483,6,109),(24374048,51582486,6,110),(24374048,51582489,6,111),(24374048,51582492,6,112),(24374048,51582495,6,113),(24374048,51582496,6,114),(24374048,51582499,6,115),(24374048,51582501,6,116),(24374048,51582502,6,117),(24374048,51582504,6,118),(24374048,51582506,6,119),(24374048,51582508,6,120),(24374048,51582509,6,121),(24374048,51582510,6,122),(24374048,51582512,6,123),(24374048,51582516,6,124),(24374048,51582518,6,125),(24374048,51582521,6,126),(24374048,51582523,6,127),(24374048,51582525,6,128),(24374048,51582527,6,129),(24374048,51952849,6,130),(24374048,51582530,6,131),(24374048,51952527,6,132),(24374048,51952525,6,133),(24374048,51952524,6,134),(24374048,51952523,6,135),(24374048,51952520,6,136),(24374048,51952517,6,137),(24374048,51952515,6,138),(24374048,51952513,6,139),(24374048,51952512,6,140),(24374048,51952510,6,141),(24374048,51952508,6,142),(24374048,51952506,6,143),(24374048,51952504,6,144),(24374048,51952502,6,145),(24374048,51952500,6,146),(24374048,51952498,6,147),(24374048,51952495,6,148),(24374048,51952492,6,149),(24374048,51952490,6,150),(24374048,51952487,6,151),(24374048,51952484,6,152),(24374048,51952481,6,153),(24374048,51952478,6,154),(24374048,51952475,6,155),(24374048,51952472,6,156),(24374048,51952468,6,157),(24374048,51952465,6,158),(24374048,51952463,6,159),(24374048,51952460,6,160),(24374048,51952457,6,161),(24374048,51952455,6,162),(24374048,51952452,6,163),(24374048,51952449,6,164),(24374048,51952446,6,165),(24374048,51952444,6,166),(24374048,51952441,6,167),(24374048,51952430,6,168),(24374048,51952429,6,169),(24374048,51952426,6,170),(24374048,51952433,6,171),(24374048,51952423,6,172),(24374048,51952436,6,173),(24374048,51952420,6,174),(24374048,51952418,6,175),(24374048,51952439,6,176),(24374048,51952416,6,177),(24374048,51952413,6,178),(24374048,51952411,6,179),(24374048,51952408,6,180),(24374048,51952405,6,181),(24374048,51952403,6,182),(24374048,51952399,6,183),(24374048,51952396,6,184),(24374048,51952394,6,185),(24374048,51952390,6,186),(24374048,51952388,6,187),(24374048,51952385,6,188),(24374048,51952382,6,189),(24374048,51952378,6,190),(24374048,51952376,6,191),(24374048,51952373,6,192),(24374048,51952369,6,193),(24374048,51952367,6,194),(24374048,51952365,6,195),(24374048,51952362,6,196),(24374048,51952359,6,197),(24374048,51952354,6,198),(24374048,51952351,6,199),(24374048,51952350,6,200),(24374048,51952347,6,201),(24374048,51952345,6,202),(24374048,51952343,6,203),(24374048,51952341,6,204),(24374048,51952338,6,205),(24374048,51952335,6,206),(24374048,51952333,6,207),(24374048,51952330,6,208),(24374048,51952328,6,209),(24374048,51952325,6,210),(24374048,51952323,6,211),(24374048,51952320,6,212),(24374048,51952316,6,213),(24374048,51952311,6,214),(24374048,51952307,6,215),(24374048,51952306,6,216),(24374048,51952305,6,217),(24374048,51952303,6,218),(24374048,51952300,6,219),(24374048,51952297,6,220),(24374048,51952295,6,221),(24374048,51952292,6,222),(24374048,51952290,6,223),(24374048,51952287,6,224),(24374048,51952284,6,225),(24374048,51952280,6,226),(24374048,51952279,6,227),(24374048,51952276,6,228),(24374048,51952274,6,229),(24374048,51952271,6,230);
INSERT INTO `way_nodes` VALUES (24374048,51952269,6,231),(24374048,51952267,6,232),(24374048,51952264,6,233),(24374048,51952261,6,234),(24374049,51952261,1,1),(24374049,51952259,1,2),(24374050,51952259,4,1),(24374050,51952256,4,2),(24374050,51952255,4,3),(24374050,51952252,4,4),(24374050,51952250,4,5),(24374050,51952248,4,6),(24374050,51952246,4,7),(24374050,51952243,4,8),(24374050,51952240,4,9),(24374050,51952238,4,10),(24374050,51952236,4,11),(24374050,51952233,4,12),(24374050,51952230,4,13),(24374050,51952226,4,14),(24374050,51952223,4,15),(24374050,51952220,4,16),(24374050,51952217,4,17),(24374050,51952215,4,18),(24374050,51952213,4,19),(24374050,51952210,4,20),(24374050,51952207,4,21),(24374050,51952205,4,22),(24374050,51952204,4,23),(24374050,51952201,4,24),(24374050,51952199,4,25),(24374050,51952196,4,26),(24374050,51952195,4,27),(24374050,51952193,4,28),(24374050,51952192,4,29),(24374050,51952190,4,30),(24374050,51952187,4,31),(24374050,51952185,4,32),(24374050,51952183,4,33),(24374050,51952180,4,34),(24374050,51952177,4,35),(24374050,51952176,4,36),(24374050,51952172,4,37),(24374050,51952170,4,38),(24374050,51952167,4,39),(24374050,51952163,4,40),(24374050,51952161,4,41),(24374050,51952159,4,42),(24374050,51952157,4,43),(24374050,51952155,4,44),(24374050,51952152,4,45),(24374050,51952150,4,46),(24374050,51952148,4,47),(24374050,51952145,4,48),(24374050,51952141,4,49),(24374050,51952139,4,50),(24374050,51952136,4,51),(24374050,51952132,4,52),(24374050,51952128,4,53),(24374050,51952126,4,54),(24374050,51952125,4,55),(24374050,51952122,4,56),(24374050,51952120,4,57),(24374050,51952118,4,58),(24374051,264465125,4,1),(24374051,51581874,4,2),(24374052,51581874,21,1),(24374052,51581876,21,2),(24374052,51581877,21,3),(24374052,51581881,21,4),(24374052,51581883,21,5),(24374052,51581886,21,6),(24374052,51581888,21,7),(24374052,51581890,21,8),(24374052,51581895,21,9),(24374052,51581898,21,10),(24374052,51581902,21,11),(24374052,51581904,21,12),(24374052,51581906,21,13),(24374052,51581910,21,14),(24374052,266325399,21,15),(24374052,51581912,21,16),(24374052,51581914,21,17),(24374052,51581916,21,18),(24374052,51581922,21,19),(24374052,51581923,21,20),(24374052,51581926,21,21),(24374052,51581928,21,22),(24374052,51581931,21,23),(24374052,51581932,21,24),(24374052,51581936,21,25),(24374052,51581939,21,26),(24374052,51581941,21,27),(24374052,51581944,21,28),(24374052,266622050,21,29),(24374052,51581946,21,30),(24374052,262465820,21,31),(24374052,51581951,21,32),(24374052,51581955,21,33),(24374052,51581958,21,34),(24374052,51581960,21,35),(24374052,51581962,21,36),(24374052,277375056,21,37),(24374052,51581964,21,38),(24374052,51581967,21,39),(24374052,51581970,21,40),(24374052,51581973,21,41),(24374052,51581976,21,42),(24374052,51581979,21,43),(24374052,51581980,21,44),(24374052,51581983,21,45),(24374052,266322954,21,46),(24374052,51581986,21,47),(24374052,51581990,21,48),(24374052,51581993,21,49),(24374052,51581995,21,50),(24374052,51581997,21,51),(24374052,266622986,21,52),(24374052,51582003,21,53),(24374052,51582007,21,54),(24374052,51582009,21,55),(24374052,51582013,21,56),(24374052,51582019,21,57),(24374052,51582023,21,58),(24374052,51582027,21,59),(24374052,51582031,21,60),(24374052,51582034,21,61),(24374052,268081065,21,62),(24374052,262464083,21,63),(24374052,51582038,21,64),(24374052,51582045,21,65),(24374052,51582060,21,66),(24374052,51582066,21,67),(24374052,51582074,21,68),(24374052,51582077,21,69),(24374052,51582082,21,70),(24374052,51582085,21,71),(24374052,51582086,21,72),(24374052,51582089,21,73),(24374052,51582090,21,74),(24374052,51582091,21,75),(24374052,51582093,21,76),(24374052,51582096,21,77),(24374052,51582098,21,78),(24374052,51582101,21,79),(24374052,51582102,21,80),(24374052,51582105,21,81),(24374052,51582107,21,82),(24374052,51582110,21,83),(24374052,51582111,21,84),(24374052,51582113,21,85),(24374052,51582116,21,86),(24374052,51582118,21,87),(24374052,51582121,21,88),(24374052,51582123,21,89),(24374052,51582125,21,90),(24374052,51582128,21,91),(24374052,51582132,21,92),(24374052,268612922,21,93),(24374052,268612923,21,94),(24374052,51582133,21,95),(24374052,51582135,21,96),(24374052,51582137,21,97),(24374052,268614412,21,98),(24374052,51582139,21,99),(24374052,51582143,21,100),(24374052,51582146,21,101),(24374052,51582148,21,102),(24374052,51582150,21,103),(24374052,51582153,21,104),(24374052,51582156,21,105),(24374052,51582159,21,106),(24374052,51582162,21,107),(24374052,51582166,21,108),(24374052,51582167,21,109),(24374052,51582170,21,110),(24374052,51582173,21,111),(24374052,51582175,21,112),(24374054,264465128,3,1),(24374054,264465129,3,2),(24374055,264465129,3,1),(24374055,52613154,3,2),(24374055,52613157,3,3),(24374055,52613159,3,4),(24374055,52613162,3,5),(24374055,264465127,3,6),(24374056,264465127,3,1),(24374056,52613163,3,2),(24374057,52613163,5,1),(24374057,52613166,5,2),(24374057,52613167,5,3),(24374057,52613170,5,4),(24374057,52613172,5,5),(24374057,52613173,5,6),(24374057,52613175,5,7),(24374057,52613176,5,8),(24374057,52613178,5,9),(24374057,52613179,5,10),(24374057,52613182,5,11),(24374057,52613184,5,12),(24374057,52613186,5,13),(24374057,52613189,5,14),(24374057,52613192,5,15),(24374057,52613196,5,16),(24374057,52613199,5,17),(24374057,52613201,5,18),(24374057,52613204,5,19),(24374057,52613212,5,20),(24374057,52613214,5,21),(24374057,52613217,5,22),(24374057,52613221,5,23),(24374057,52613223,5,24),(24374057,52613224,5,25),(24374057,52613226,5,26),(24374057,52613228,5,27),(24374057,52613231,5,28),(24374057,52613233,5,29),(24374057,52613235,5,30),(24374057,52613237,5,31),(24374057,52613238,5,32),(24374057,52613244,5,33),(24374057,52613246,5,34),(24374057,52613249,5,35),(24374057,52613252,5,36),(24374057,52613256,5,37),(24374057,52613258,5,38),(24374057,52613260,5,39),(24374057,52613262,5,40),(24374057,52613264,5,41),(24374057,52613267,5,42),(24374057,52613270,5,43),(24374057,52613272,5,44),(24374057,52613274,5,45),(24374064,264465130,2,1),(24374064,52206684,2,2),(24374065,52206684,2,1),(24374065,52206686,2,2),(24374065,52206688,2,3),(24376755,264495540,2,1),(24376755,264495541,2,2),(24376755,264495542,2,3),(24376755,264495543,2,4),(24376755,264495544,2,5),(24376812,264495953,2,1),(24376812,264495952,2,2),(24376812,264495951,2,3),(24376812,264495950,2,4),(24376812,264495949,2,5),(24376812,264495948,2,6),(24376812,264495947,2,7),(24376812,264495946,2,8),(24376812,264495945,2,9),(24376812,264495944,2,10),(24376812,264495943,2,11),(24376812,264495942,2,12),(24376812,264495941,2,13),(24376812,264495940,2,14),(24376812,264495939,2,15),(24376812,264495938,2,16),(24377511,264501521,1,1),(24377511,264501522,1,2),(24377511,264501523,1,3),(24377511,264501524,1,4),(24377511,264501525,1,5),(24377511,264501526,1,6),(24377511,264501527,1,7),(24377511,264501528,1,8),(24377558,264501528,1,1),(24377558,264502059,1,2),(24377558,264502060,1,3),(24377558,264502061,1,4),(24377558,264502062,1,5),(24377558,264502063,1,6),(24377558,264502064,1,7),(24377558,264502065,1,8),(24377663,264502898,1,1),(24377663,264502899,1,2),(24377663,264502900,1,3),(24377663,264502901,1,4),(24377663,264502902,1,5),(24377663,264502903,1,6),(24377663,264502904,1,7),(24377663,264502905,1,8),(24377663,264502906,1,9),(24377663,264502907,1,10),(24377663,264502908,1,11),(24377663,264502909,1,12),(24377663,264502910,1,13),(24377663,264502912,1,14),(24377663,264502914,1,15),(24377663,264502916,1,16),(24377663,264502918,1,17),(24377667,264502905,1,1),(24377667,264502985,1,2),(24377667,264502987,1,3),(24377667,264502988,1,4),(24377667,264502989,1,5),(24377667,264502990,1,6),(24405095,264908763,3,1),(24405095,264331301,3,2),(24405096,264908764,4,1),(24405096,264908765,4,2),(24405096,264908766,4,3),(24405096,264910825,4,4),(24405096,264908767,4,5),(24405096,264908768,4,6),(24405096,264908769,4,7),(24405096,264908770,4,8),(24405096,264908771,4,9),(24405096,264908763,4,10),(24405131,264906170,3,1),(24405131,51552459,3,2),(24405131,51552456,3,3),(24405131,51552453,3,4),(24405131,51552451,3,5),(24405131,51552447,3,6),(24405131,51552445,3,7),(24405131,51552444,3,8),(24405131,51552442,3,9),(24405159,268619784,10,1),(24405159,264909492,10,2),(24405159,264909491,10,3),(24405159,264909490,10,4),(24405159,264909489,10,5),(24405159,264909488,10,6),(24405159,264909487,10,7),(24405159,264909486,10,8),(24405159,264909485,10,9),(24405159,264910825,10,10),(24405221,51552442,5,1),(24405221,264908764,5,2),(24405221,51552440,5,3),(24405221,51552437,5,4),(24405221,51552504,5,5),(24405221,51552434,5,6),(24405221,264906764,5,7),(24405221,51552432,5,8),(24405221,51552429,5,9),(24405221,264907017,5,10),(24405221,268619784,5,11),(24405221,264909493,5,12),(24405221,51552422,5,13),(24405221,51552419,5,14),(24405221,51552416,5,15),(24405221,51552413,5,16),(24405221,51552405,5,17),(24405221,264910379,5,18),(24406052,264910379,2,1),(24406052,51552408,2,2),(24406052,51552410,2,3),(24406052,51406783,2,4),(24406052,51406784,2,5),(24406052,51406785,2,6),(24406052,51406787,2,7),(24406052,51406789,2,8),(24406052,51406790,2,9),(24406052,51408311,2,10),(24406052,51406791,2,11),(24406052,51406792,2,12),(24406052,51406793,2,13),(24406052,51406795,2,14),(24406052,51406797,2,15),(24406052,51406798,2,16),(24406052,51406800,2,17),(24406052,51406803,2,18),(24406052,51406805,2,19),(24406052,51406807,2,20),(24406052,51406808,2,21),(24406052,51406810,2,22),(24406052,51406811,2,23),(24406326,264932311,2,1),(24406326,264932343,2,2),(24406326,264932342,2,3),(24406326,264932341,2,4),(24406326,264932340,2,5),(24406326,264932330,2,6),(24406326,264932329,2,7),(24406326,264932328,2,8),(24406326,264932327,2,9),(24406326,264932326,2,10),(24406326,264932325,2,11),(24406326,264932322,2,12),(24406326,264932321,2,13),(24406326,264932319,2,14),(24406326,264932318,2,15),(24406326,264932317,2,16),(24406326,264932316,2,17),(24406326,264932315,2,18),(24406326,264932314,2,19),(24406326,264932311,2,20),(24406327,264932344,2,1),(24406327,264932345,2,2),(24406327,264932347,2,3),(24406327,264932348,2,4),(24406327,264932349,2,5),(24406327,264932350,2,6),(24406327,264932351,2,7),(24406327,264932352,2,8),(24406327,264932353,2,9),(24406327,264932344,2,10),(24406328,264932501,1,1),(24406328,264932354,1,2),(24406328,264932355,1,3),(24406328,264932356,1,4),(24406328,264932357,1,5),(24406328,264932359,1,6),(24406328,264932360,1,7),(24406328,264932361,1,8),(24406328,264932362,1,9),(24406328,264932363,1,10),(24406328,264932364,1,11),(24406328,264932365,1,12),(24406328,264932366,1,13),(24406328,264932367,1,14),(24406328,264932368,1,15),(24406328,264932370,1,16),(24406328,264932371,1,17),(24406328,264932372,1,18),(24406328,264932373,1,19),(24406328,264932374,1,20),(24406328,264932375,1,21),(24406328,264932376,1,22),(24406328,264932377,1,23),(24406328,264932379,1,24),(24406328,264932380,1,25),(24406328,264932381,1,26),(24406328,264932382,1,27),(24406328,264932383,1,28),(24406328,264932384,1,29),(24406328,264932386,1,30),(24406328,264932387,1,31),(24406328,264932388,1,32),(24406328,264932390,1,33),(24406328,264932393,1,34),(24406328,264932395,1,35),(24406328,264932396,1,36),(24406328,264932397,1,37),(24406328,264932398,1,38),(24406328,264932399,1,39),(24406328,264932400,1,40),(24406328,264932401,1,41),(24406328,264932402,1,42),(24406328,264932404,1,43),(24406328,264932405,1,44),(24406328,264932406,1,45),(24406328,264932407,1,46),(24406328,264932408,1,47),(24406328,264932409,1,48),(24406328,264932410,1,49),(24406328,264932411,1,50),(24406328,264932412,1,51),(24406328,264932414,1,52),(24406328,264932415,1,53),(24406328,264932416,1,54),(24406328,264932417,1,55),(24406328,264932420,1,56),(24406328,264932427,1,57),(24406328,264932428,1,58),(24406328,264932429,1,59),(24406328,264932430,1,60),(24406328,264932431,1,61),(24406328,264932432,1,62),(24406328,264932433,1,63),(24406328,264932435,1,64),(24406328,264932436,1,65),(24406328,264932437,1,66),(24406328,264932438,1,67),(24406328,264932439,1,68),(24406328,264932440,1,69),(24406328,264932441,1,70),(24406328,264932442,1,71),(24406328,264932444,1,72),(24406328,264932445,1,73),(24406328,264932446,1,74),(24406328,264932447,1,75),(24406328,264932448,1,76),(24406328,264932449,1,77),(24406328,264932450,1,78),(24406328,264932451,1,79),(24406328,264932452,1,80),(24406328,264932453,1,81),(24406328,264932454,1,82),(24406328,264932456,1,83),(24406328,264932457,1,84),(24406328,264932458,1,85),(24406328,264932459,1,86),(24406328,264932460,1,87),(24406328,264932461,1,88),(24406328,264932462,1,89),(24406328,264932463,1,90),(24406328,264932464,1,91),(24406328,264932465,1,92),(24406328,264932466,1,93),(24406328,264932467,1,94),(24406328,264932469,1,95),(24406328,264932470,1,96),(24406328,264932471,1,97),(24406328,264932472,1,98),(24406328,264932473,1,99),(24406328,264932474,1,100),(24406328,264932475,1,101),(24406328,264932476,1,102),(24406328,264932477,1,103),(24406328,264932478,1,104),(24406328,264932479,1,105),(24406328,264932481,1,106),(24406328,264932482,1,107),(24406328,264932483,1,108),(24406328,264932484,1,109),(24406328,264932486,1,110),(24406328,264932487,1,111),(24406328,264932488,1,112),(24406328,264932489,1,113),(24406328,264932490,1,114),(24406328,264932491,1,115),(24406328,264932492,1,116),(24406328,264932493,1,117),(24406328,264932495,1,118),(24406328,264932496,1,119),(24406328,264932497,1,120),(24406328,264932498,1,121),(24406328,264932499,1,122),(24406328,264932500,1,123),(24406328,264932501,1,124),(24406329,264932526,2,1),(24406329,264932566,2,2),(24406329,366061154,2,3),(24406329,264932565,2,4),(24406329,264932564,2,5),(24406329,264932563,2,6),(24406329,264932561,2,7),(24406329,264932560,2,8),(24406329,264932559,2,9),(24406329,264932558,2,10),(24406329,264932557,2,11),(24406329,264932556,2,12),(24406329,264932555,2,13),(24406329,264932554,2,14),(24406329,264932552,2,15),(24406329,264932503,2,16),(24406329,264932504,2,17),(24406329,264932505,2,18),(24406329,264932506,2,19),(24406329,264932507,2,20),(24406329,264932509,2,21),(24406329,264932510,2,22),(24406329,264932512,2,23),(24406329,264932513,2,24),(24406329,264932515,2,25),(24406329,264932516,2,26),(24406329,264932517,2,27),(24406329,264932518,2,28),(24406329,264932519,2,29),(24406329,264932520,2,30),(24406329,264932521,2,31),(24406329,264932522,2,32),(24406329,264932523,2,33),(24406329,264932524,2,34),(24406329,264932526,2,35),(24406331,264932529,2,1),(24406331,264932531,2,2),(24406331,264932532,2,3),(24406331,264932534,2,4),(24406331,482113773,2,5),(24406331,264932535,2,6),(24406331,264932536,2,7),(24406331,264932537,2,8),(24406331,264932538,2,9),(24406331,264932539,2,10),(24406331,264932540,2,11),(24406331,264932541,2,12),(24406331,264932543,2,13),(24406331,264932544,2,14),(24406331,264932545,2,15),(24406331,264932546,2,16),(24406331,264932547,2,17),(24406331,264932548,2,18),(24406331,264932549,2,19),(24406331,264932550,2,20),(24406331,264932551,2,21),(24406331,264932567,2,22),(24406331,264932568,2,23),(24406331,264932569,2,24),(24406331,264932570,2,25),(24406331,264932572,2,26),(24406331,264932573,2,27),(24406331,264932574,2,28),(24406331,264932575,2,29),(24406331,264932576,2,30),(24406331,264932577,2,31),(24406331,264932578,2,32),(24406331,264932579,2,33),(24406331,264932581,2,34),(24406331,264932582,2,35),(24406331,264932583,2,36),(24406331,264932584,2,37),(24406331,264932585,2,38),(24406331,264932586,2,39),(24406331,264932587,2,40),(24406331,264932589,2,41),(24406331,264932590,2,42),(24406331,264932591,2,43),(24406331,264932592,2,44),(24406331,264932593,2,45),(24406331,264932594,2,46),(24406331,264932595,2,47),(24406331,264932596,2,48),(24406331,264932598,2,49),(24406331,264932599,2,50),(24406331,264932600,2,51),(24406331,264932601,2,52),(24406331,264932602,2,53),(24406331,264932603,2,54),(24406331,264932604,2,55),(24406331,264932605,2,56),(24406331,264932606,2,57),(24406331,264932608,2,58),(24406331,264932609,2,59),(24406331,264932610,2,60),(24406331,264932611,2,61),(24406331,264932612,2,62),(24406331,264932613,2,63),(24406331,264932614,2,64),(24406331,264932615,2,65),(24406331,264932616,2,66),(24406331,264932617,2,67),(24406331,264932529,2,68),(24406332,264932619,1,1),(24406332,264932620,1,2),(24406332,264932621,1,3),(24406332,264932622,1,4),(24406332,264932623,1,5),(24406332,264932624,1,6),(24406332,264932625,1,7),(24406332,264932626,1,8),(24406332,264932627,1,9),(24406332,264932628,1,10),(24406332,264932629,1,11),(24406332,264932631,1,12),(24406332,264932632,1,13),(24406332,264932633,1,14),(24406332,264932634,1,15),(24406332,264932635,1,16),(24406332,264932636,1,17),(24406332,264932637,1,18),(24406332,264932638,1,19),(24406332,264932639,1,20),(24406332,264932641,1,21),(24406332,264932642,1,22),(24406332,264932643,1,23),(24406332,264932644,1,24),(24406332,264932645,1,25),(24406332,264932646,1,26),(24406332,264932647,1,27),(24406332,264932649,1,28),(24406332,264932650,1,29),(24406332,264932651,1,30),(24406332,264932652,1,31),(24406332,264932653,1,32),(24406332,264932654,1,33),(24406332,264932655,1,34),(24406332,264932656,1,35),(24406332,264932657,1,36),(24406332,264932658,1,37),(24406332,264932659,1,38),(24406332,264932660,1,39),(24406332,264932661,1,40),(24406332,264932662,1,41),(24406332,264932619,1,42),(24406333,264932663,1,1),(24406333,264932665,1,2),(24406333,264932666,1,3),(24406333,264932667,1,4),(24406333,264932668,1,5),(24406333,264932669,1,6),(24406333,264932670,1,7),(24406333,264932671,1,8),(24406333,264932672,1,9),(24406333,264932673,1,10),(24406333,264932675,1,11),(24406333,264932676,1,12),(24406333,264932677,1,13),(24406333,264932678,1,14),(24406333,264932679,1,15),(24406333,264932680,1,16),(24406333,264932681,1,17),(24406333,264932682,1,18),(24406333,264932684,1,19),(24406333,264932685,1,20),(24406333,264932686,1,21),(24406333,264932687,1,22),(24406333,264932688,1,23),(24406333,264932689,1,24),(24406333,264932690,1,25),(24406333,264932691,1,26),(24406333,264932693,1,27),(24406333,264932694,1,28),(24406333,264932695,1,29),(24406333,264932696,1,30),(24406333,264932697,1,31),(24406333,264932698,1,32),(24406333,264932699,1,33),(24406333,264932701,1,34),(24406333,264932702,1,35),(24406333,264932703,1,36),(24406333,264932704,1,37),(24406333,264932705,1,38),(24406333,264932706,1,39),(24406333,264932707,1,40),(24406333,264932708,1,41),(24406333,264932710,1,42),(24406333,264932711,1,43),(24406333,264932712,1,44),(24406333,264932713,1,45),(24406333,264932714,1,46),(24406333,264932715,1,47),(24406333,264932716,1,48),(24406333,264932717,1,49),(24406333,264932718,1,50),(24406333,264932719,1,51),(24406333,264932720,1,52),(24406333,264932722,1,53),(24406333,264932723,1,54),(24406333,264932724,1,55),(24406333,264932725,1,56),(24406333,264932726,1,57),(24406333,264932663,1,58),(24406334,264932727,1,1),(24406334,264932728,1,2),(24406334,264932729,1,3),(24406334,264932731,1,4),(24406334,264932732,1,5),(24406334,264932733,1,6),(24406334,264932734,1,7),(24406334,264932735,1,8),(24406334,264932736,1,9),(24406334,264932737,1,10),(24406334,264932738,1,11),(24406334,264932739,1,12),(24406334,264932740,1,13),(24406334,264932742,1,14),(24406334,264932743,1,15),(24406334,264932744,1,16),(24406334,264932745,1,17),(24406334,264932746,1,18),(24406334,264932747,1,19),(24406334,264932748,1,20),(24406334,264932749,1,21),(24406334,264932750,1,22),(24406334,264932752,1,23),(24406334,264932753,1,24),(24406334,264932754,1,25),(24406334,264932755,1,26),(24406334,264932756,1,27),(24406334,264932757,1,28),(24406334,264932759,1,29),(24406334,264932760,1,30),(24406334,264932761,1,31),(24406334,264932762,1,32),(24406334,264932763,1,33),(24406334,264932764,1,34),(24406334,264932727,1,35),(24406335,264932765,1,1),(24406335,264932766,1,2),(24406335,264932767,1,3),(24406335,264932769,1,4),(24406335,264932770,1,5),(24406335,264932771,1,6),(24406335,264932772,1,7),(24406335,264932773,1,8),(24406335,264932774,1,9),(24406335,264932775,1,10),(24406335,264932776,1,11),(24406335,264932777,1,12),(24406335,264932779,1,13),(24406335,264932780,1,14),(24406335,264932781,1,15),(24406335,264932782,1,16),(24406335,264932783,1,17),(24406335,264932784,1,18),(24406335,264932785,1,19),(24406335,264932786,1,20),(24406335,264932787,1,21),(24406335,264932788,1,22),(24406335,264932789,1,23),(24406335,264932791,1,24),(24406335,264932792,1,25),(24406335,264932793,1,26),(24406335,264932794,1,27),(24406335,264932795,1,28),(24406335,264932765,1,29),(24406336,264932796,1,1),(24406336,264932797,1,2),(24406336,264932798,1,3),(24406336,264932800,1,4),(24406336,264932801,1,5),(24406336,264932802,1,6),(24406336,264932803,1,7),(24406336,264932804,1,8),(24406336,264932805,1,9),(24406336,264932806,1,10),(24406336,264932807,1,11),(24406336,264932808,1,12),(24406336,264932809,1,13),(24406336,264932811,1,14),(24406336,264932812,1,15),(24406336,264932813,1,16),(24406336,264932814,1,17),(24406336,264932815,1,18),(24406336,264932816,1,19),(24406336,264932817,1,20),(24406336,264932818,1,21),(24406336,264932820,1,22),(24406336,264932821,1,23),(24406336,264932822,1,24),(24406336,264932823,1,25),(24406336,264932824,1,26),(24406336,264932825,1,27),(24406336,264932826,1,28),(24406336,264932827,1,29),(24406336,264932828,1,30),(24406336,264932829,1,31),(24406336,264932831,1,32),(24406336,264932832,1,33),(24406336,264932833,1,34),(24406336,264932834,1,35),(24406336,264932835,1,36),(24406336,264932836,1,37),(24406336,264932837,1,38),(24406336,264932838,1,39),(24406336,264932839,1,40),(24406336,264932840,1,41),(24406336,264932841,1,42),(24406336,264932842,1,43),(24406336,264932843,1,44),(24406336,264932844,1,45),(24406336,264932846,1,46),(24406336,264932847,1,47),(24406336,264932848,1,48),(24406336,264932849,1,49),(24406336,264932850,1,50),(24406336,264932851,1,51),(24406336,264932852,1,52),(24406336,264932853,1,53),(24406336,264932855,1,54),(24406336,264932856,1,55),(24406336,264932857,1,56),(24406336,264932858,1,57),(24406336,264932859,1,58),(24406336,264932860,1,59),(24406336,264932861,1,60),(24406336,264932862,1,61),(24406336,264932864,1,62),(24406336,264932865,1,63),(24406336,264932866,1,64),(24406336,264932867,1,65),(24406336,264932868,1,66),(24406336,264932869,1,67),(24406336,264932870,1,68),(24406336,264932871,1,69),(24406336,264932796,1,70),(24413463,51410095,2,1),(24413463,265050188,2,2),(24413466,51404882,4,1),(24413466,51405344,4,2),(24413467,264289242,2,1),(24413467,264289243,2,2),(24413467,264289244,2,3),(24413467,264289245,2,4),(24413467,264289246,2,5),(24413467,264289247,2,6),(24413467,264289248,2,7),(24413467,264289249,2,8),(24413467,264289250,2,9),(24413467,264289251,2,10),(24413467,264292663,2,11),(24413469,51409974,2,1),(24413469,264304669,2,2),(24413471,265050188,3,1),(24413471,51405270,3,2),(24430806,265518806,7,1),(24430806,264304669,7,2),(24430806,51409975,7,3),(24430806,51409976,7,4),(24430806,51409978,7,5),(24430806,51409979,7,6),(24430806,51409981,7,7),(24430806,51409983,7,8),(24430806,277695169,7,9),(24430807,264304666,1,1),(24430807,264304667,1,2),(24430807,264304668,1,3),(24430807,265518806,1,4),(24456592,53294994,9,1),(24456592,53294992,9,2),(24456592,53294989,9,3),(24456592,53294986,9,4),(24456592,53294983,9,5),(24456592,53294981,9,6),(24456592,53294979,9,7),(24456592,53294974,9,8),(24456592,53294971,9,9),(24456592,53294968,9,10),(24456592,53294965,9,11),(24456592,53294963,9,12),(24456592,53294961,9,13),(24456592,53294958,9,14),(24456592,53294953,9,15),(24456592,53294950,9,16),(24456592,53294946,9,17),(24456592,53294943,9,18),(24456592,53294939,9,19),(24456592,53294937,9,20),(24456592,53294933,9,21),(24456592,53294930,9,22),(24456592,53294929,9,23),(24456592,53294924,9,24),(24456592,53294922,9,25),(24456592,53294919,9,26),(24456592,53294917,9,27),(24456592,53294913,9,28),(24456592,53294910,9,29),(24456592,53294906,9,30),(24456592,53294904,9,31),(24456592,53294900,9,32),(24456592,53294898,9,33),(24456592,53294894,9,34),(24456592,53294891,9,35),(24456592,53294887,9,36),(24456592,53294884,9,37),(24456592,53294880,9,38),(24456592,53294877,9,39),(24456592,53294874,9,40),(24456592,53294872,9,41),(24456592,53294867,9,42),(24456592,53294866,9,43),(24456592,53294860,9,44),(24456592,53294856,9,45),(24456592,53294855,9,46),(24456592,53294851,9,47),(24456592,53294849,9,48),(24456592,53294847,9,49),(24456592,53294843,9,50),(24456592,53294838,9,51),(24456592,53294834,9,52),(24456592,53294830,9,53),(24456592,53294829,9,54),(24456592,53294826,9,55),(24456592,53294823,9,56),(24456592,53294820,9,57),(24456592,53294816,9,58),(24456592,53294813,9,59),(24456592,53294810,9,60),(24456592,53294807,9,61),(24456592,53294805,9,62),(24456592,53294803,9,63),(24456592,53294800,9,64),(24456592,53294795,9,65),(24456592,53294792,9,66),(24456592,53294790,9,67),(24456592,53294786,9,68),(24456592,53294785,9,69),(24456592,53294782,9,70),(24456592,53294777,9,71),(24456592,53294776,9,72),(24456592,53294770,9,73),(24456592,53294767,9,74),(24456592,53294764,9,75),(24456592,53294761,9,76),(24456592,53294758,9,77),(24456592,53294756,9,78),(24456592,53294755,9,79),(24456592,53294752,9,80),(24456592,53294748,9,81),(24456592,53294745,9,82),(24456592,53294740,9,83),(24456592,53294737,9,84),(24456592,53294735,9,85),(24456592,53294730,9,86),(24456592,53294728,9,87),(24456592,53294721,9,88),(24456592,53294718,9,89),(24456592,53294716,9,90),(24456592,53294714,9,91),(24456592,53294712,9,92),(24456592,53294709,9,93),(24456592,53294704,9,94),(24456592,53294702,9,95),(24456592,53294698,9,96),(24456592,53294695,9,97),(24456592,53294691,9,98),(24456592,53294689,9,99),(24456592,53294684,9,100),(24456592,53294679,9,101),(24456592,53294677,9,102),(24456592,53294675,9,103),(24456592,53294671,9,104),(24456592,53294669,9,105),(24456592,53294665,9,106),(24456592,53294661,9,107),(24456592,53294659,9,108),(24456592,53294655,9,109),(24456592,53294652,9,110),(24456592,53294648,9,111),(24456592,53294645,9,112),(24456592,53294640,9,113),(24456592,53294637,9,114),(24456592,53294634,9,115),(24456592,53294630,9,116),(24456592,53294625,9,117),(24456592,53294623,9,118),(24456592,53294620,9,119),(24456592,53294616,9,120),(24456592,366578105,9,121),(24456592,53294613,9,122),(24456592,53294610,9,123),(24456592,53294607,9,124),(24456592,366578054,9,125),(24456592,53294602,9,126),(24456592,53294601,9,127),(24456592,53294596,9,128),(24456592,53294595,9,129),(24456592,53294591,9,130),(24456592,53294588,9,131),(24456592,53294584,9,132),(24492435,266322954,3,1),(24492435,266322580,3,2),(24492437,266322676,2,1),(24492437,266322582,2,2),(24492459,266322580,4,1),(24492459,266322581,4,2),(24492463,266322581,2,1),(24492463,266322582,2,2),(24492463,266322583,2,3),(24492463,266322584,2,4),(24492463,266322585,2,5),(24492463,266322586,2,6),(24492463,266322587,2,7),(24492463,266322588,2,8),(24492463,266322589,2,9),(24492463,266322590,2,10),(24492623,266325399,3,1),(24492623,266325046,3,2),(24492644,266325224,2,1),(24492644,266325225,2,2),(24492644,266325226,2,3),(24492644,266325227,2,4),(24492644,266325048,2,5),(24492644,266325228,2,6),(24492644,266325428,2,7),(24492644,266325229,2,8),(24492644,266325230,2,9),(24492644,266325231,2,10),(24492644,266325232,2,11),(24492653,266325046,3,1),(24492653,266325047,3,2),(24492657,266325047,2,1),(24492657,266325048,2,2),(24492677,266325427,1,1),(24492677,266325428,1,2),(24492804,264465125,6,1),(24492804,266326319,6,2),(24492831,266326327,1,1),(24492831,266326487,1,2),(24492831,266326488,1,3),(24492831,266326489,1,4),(24492831,266326490,1,5),(24492831,266326491,1,6),(24492831,266326492,1,7),(24492831,266326493,1,8),(24492831,266326494,1,9),(24492831,266326495,1,10),(24492831,266326496,1,11),(24492831,266326497,1,12),(24492831,266326498,1,13),(24492831,266326499,1,14),(24492831,266326500,1,15),(24492831,266326501,1,16),(24492831,266326502,1,17),(24492831,266326503,1,18),(24492831,266326504,1,19),(24492831,266326505,1,20),(24492868,266326319,5,1),(24492868,266326320,5,2),(24492889,266326320,3,1),(24492889,266326321,3,2),(24492889,266326322,3,3),(24492889,266326323,3,4),(24492889,266326324,3,5),(24492889,266326325,3,6),(24492889,266326326,3,7),(24492889,266326327,3,8),(24492889,266326328,3,9),(24492889,266326329,3,10),(24492889,266326330,3,11),(24492889,266326331,3,12),(24492889,266326332,3,13),(24492889,266326333,3,14),(24492889,266326334,3,15),(24492889,266326335,3,16),(24492889,266326336,3,17),(24492889,266326337,3,18),(24492889,266326338,3,19),(24492889,266326339,3,20),(24492889,266326340,3,21),(24492889,266326341,3,22),(24492889,266326342,3,23),(24492889,266326343,3,24),(24492889,266326344,3,25),(24492889,266326345,3,26),(24492889,266326346,3,27),(24492889,266326347,3,28),(24492889,266326348,3,29),(24492889,266326349,3,30),(24492889,266326350,3,31),(24492906,266327106,2,1),(24492906,264465125,2,2),(24492907,266327105,4,1),(24492907,266327106,4,2),(24493028,51581778,3,1),(24493028,266328657,3,2),(24493028,266328658,3,3),(24493028,266328659,3,4),(24493028,266328660,3,5),(24493028,266328661,3,6),(24493028,266328829,3,7),(24493028,266328662,3,8),(24493028,266328663,3,9),(24493028,266328664,3,10),(24493028,266328665,3,11),(24493045,266328829,1,1),(24493045,266328830,1,2),(24493045,266328831,1,3),(24493045,266328832,1,4),(24493045,266328833,1,5),(24493045,266328834,1,6),(24493119,53315705,2,1),(24493119,53315413,2,2),(24493119,266329104,2,3),(24493119,52163588,2,4),(24493121,53315705,7,1),(24493121,266329307,7,2),(24493121,53315884,7,3),(24493121,266329120,7,4),(24493121,266329121,7,5),(24493121,266329122,7,6),(24493121,266329123,7,7),(24493121,266329124,7,8),(24493121,53315705,7,9),(24493187,266329707,4,1),(24493187,266329708,4,2),(24493187,266329709,4,3),(24493187,266329710,4,4),(24493187,266329711,4,5),(24493187,266329712,4,6),(24493187,266329713,4,7),(24493187,266329714,4,8),(24493187,266329715,4,9),(24493187,266329716,4,10),(24493187,266329717,4,11),(24493187,266329718,4,12),(24493187,266329719,4,13),(24493187,266329720,4,14),(24493187,266329721,4,15),(24493187,266329722,4,16),(24493187,266329723,4,17),(24493187,266329724,4,18),(24493187,266329725,4,19),(24493187,266329726,4,20),(24493188,266329121,6,1),(24493188,266329727,6,2),(24493188,266336982,6,3),(24493188,266329728,6,4),(24493188,266329729,6,5),(24493188,266329730,6,6),(24493188,266329731,6,7),(24493188,266329732,6,8),(24493188,266329733,6,9),(24493188,266329734,6,10),(24493188,266329735,6,11),(24493188,266329707,6,12),(24493245,266329713,6,1),(24493245,266330464,6,2),(24493247,266330502,3,1),(24493247,266330518,3,2),(24493247,266330503,3,3),(24493247,266330504,3,4),(24493247,266330505,3,5),(24493247,266330493,3,6),(24493250,266330517,2,1),(24493250,266330518,2,2),(24493261,266330483,1,1),(24493261,266330484,1,2),(24493261,266330485,1,3),(24493261,266330486,1,4),(24493261,266330487,1,5),(24493261,266330488,1,6),(24493261,266330489,1,7),(24493261,266330490,1,8),(24493261,266330491,1,9),(24493261,266330492,1,10),(24493261,266330493,1,11),(24493261,266330494,1,12),(24493261,266330495,1,13),(24493330,53316105,2,1),(24493330,266330955,2,2),(24493330,266330956,2,3),(24493330,266330957,2,4),(24493330,266330958,2,5),(24493330,266330959,2,6),(24493330,266330960,2,7),(24493330,266330961,2,8),(24493330,266330962,2,9),(24493330,266330963,2,10),(24493330,266330964,2,11),(24493330,266330965,2,12),(24493330,266330966,2,13),(24493330,53319479,2,14),(24493335,266331091,4,1),(24493335,266330991,4,2),(24493335,266330992,4,3),(24493335,266330993,4,4),(24493335,266330994,4,5),(24493335,266330995,4,6),(24493335,266330996,4,7),(24493335,266330997,4,8),(24493335,266331609,4,9),(24493335,266330998,4,10),(24493335,266330999,4,11),(24493335,266331000,4,12),(24493335,266331333,4,13),(24493335,266331001,4,14),(24493335,266331002,4,15),(24493335,266331003,4,16),(24493335,266331004,4,17),(24493335,266331005,4,18),(24493335,266331006,4,19),(24493335,266331007,4,20),(24493335,266331008,4,21),(24493335,266331009,4,22),(24493335,266331010,4,23),(24493335,266331011,4,24),(24493335,266331006,4,25),(24493338,266330999,2,1),(24493338,266331017,2,2),(24493338,266331018,2,3),(24493338,266331019,2,4),(24493338,266331020,2,5),(24493338,266331021,2,6),(24493338,266331022,2,7),(24493338,266331023,2,8),(24493362,266331233,1,1),(24493362,266331234,1,2),(24493362,266331235,1,3),(24493362,266331236,1,4),(24493362,266331237,1,5),(24493362,266331238,1,6),(24493362,266331239,1,7),(24493362,266331240,1,8),(24493362,266331241,1,9),(24493362,266331242,1,10),(24493362,266331243,1,11),(24493378,266331332,1,1),(24493378,266331333,1,2),(24493431,266331567,1,1),(24493431,266331568,1,2),(24493431,266331569,1,3),(24493431,266331570,1,4),(24493431,266331567,1,5),(24493439,266330996,1,1),(24493439,266331607,1,2),(24493439,266331608,1,3),(24493439,266331609,1,4),(24493444,266331623,1,1),(24493444,266331624,1,2),(24493444,266331625,1,3),(24493444,266331626,1,4),(24493444,266331627,1,5),(24493444,266331628,1,6),(24493444,266331623,1,7),(24493526,266332075,5,1),(24493526,266332076,5,2),(24493528,266332076,6,1),(24493528,266333982,6,2),(24493528,266332077,6,3),(24493528,266332078,6,4),(24493528,266332079,6,5),(24493528,266332080,6,6),(24493528,266332081,6,7),(24493528,266332082,6,8),(24493528,266332083,6,9),(24493528,266332084,6,10),(24493528,266332085,6,11),(24493528,266332086,6,12),(24493528,266332087,6,13),(24493570,266332790,2,1),(24493570,266331986,2,2),(24493570,266331987,2,3),(24493570,266331988,2,4),(24493570,266331989,2,5),(24493584,51587726,2,1),(24493584,266331984,2,2),(24493584,266332950,2,3),(24493584,266332790,2,4),(24493584,266332075,2,5),(24493641,266333823,1,1),(24493641,51581745,1,2),(24493647,266333914,1,1),(24493647,266333915,1,2),(24493647,266333916,1,3),(24493647,266333917,1,4),(24493659,266333981,1,1),(24493659,266333982,1,2),(24493664,266334276,2,1),(24493664,266334277,2,2),(24493664,266334278,2,3),(24493664,266334279,2,4),(24493664,266334280,2,5),(24493664,266334281,2,6),(24493664,266334282,2,7),(24493664,266334283,2,8),(24493664,266334284,2,9),(24493664,266334285,2,10),(24493664,266334286,2,11),(24493664,266334287,2,12),(24493664,266334288,2,13),(24493664,266334289,2,14),(24493664,266334290,2,15),(24493664,266334276,2,16),(24493679,266334665,1,1),(24493679,266334666,1,2),(24493679,266334668,1,3),(24493679,266334669,1,4),(24493679,266334670,1,5),(24493679,266334671,1,6),(24493679,266334672,1,7),(24493789,266329719,2,1),(24493789,266336448,2,2),(24493890,266337369,2,1),(24493890,266337370,2,2),(24493890,266337371,2,3),(24493890,266337372,2,4),(24493890,266337373,2,5),(24493890,266337374,2,6),(24493890,266337375,2,7),(24493890,266337377,2,8),(24493890,266337378,2,9),(24493890,266337379,2,10),(24493890,266337380,2,11),(24493890,266337381,2,12),(24493890,266337382,2,13),(24493890,266337384,2,14),(24493890,266337386,2,15),(24493890,266337388,2,16),(24493890,266337389,2,17),(24493890,266337390,2,18),(24493890,266337391,2,19),(24493890,266337392,2,20),(24493890,266337393,2,21),(24493890,266337394,2,22),(24493890,266337395,2,23),(24493890,266337396,2,24),(24493890,266337397,2,25),(24493895,266336448,3,1),(24493895,266336449,3,2),(24493896,266336449,1,1),(24493896,266336450,1,2),(24493896,266336451,1,3),(24493896,266336452,1,4),(24493896,266336453,1,5),(24493896,266336454,1,6),(24493896,266336455,1,7),(24493896,266336456,1,8),(24493896,266336457,1,9),(24493896,266330466,1,10),(24493927,266330483,3,1),(24493927,266330482,3,2),(24493927,266330481,3,3),(24493927,266330480,3,4),(24493927,266330479,3,5),(24493927,266330478,3,6),(24493927,266330477,3,7),(24493927,266330476,3,8),(24493927,266330475,3,9),(24493967,52166950,4,1),(24493967,51581810,4,2),(24493967,51581813,4,3),(24493967,51581814,4,4),(24493967,51581818,4,5),(24493967,51581821,4,6),(24493967,51581823,4,7),(24493967,51581826,4,8),(24493967,51581828,4,9),(24493967,51581829,4,10),(24493967,51581832,4,11),(24493967,51581835,4,12),(24493967,51581837,4,13),(24493967,51581840,4,14),(24493967,51581843,4,15),(24493967,51581846,4,16),(24493967,51581849,4,17),(24493967,51581852,4,18),(24493967,51581854,4,19),(24493967,51581857,4,20),(24493967,51581861,4,21),(24493967,51581863,4,22),(24493967,51581868,4,23),(24493967,266327105,4,24),(24494051,266341806,3,1),(24494051,266340717,3,2),(24494073,266340993,1,1),(24494073,266340994,1,2),(24494073,266340995,1,3),(24494073,266340996,1,4),(24494073,266340998,1,5),(24494073,266340999,1,6),(24494073,266341000,1,7),(24494073,266341001,1,8),(24494073,266341002,1,9),(24494073,266341003,1,10),(24494073,266341004,1,11),(24494073,266341005,1,12),(24494073,266341006,1,13),(24494073,266341007,1,14),(24494073,266340993,1,15),(24494162,266340717,3,1),(24494162,266340718,3,2),(24494164,266340718,1,1),(24494164,266340719,1,2),(24494164,266340720,1,3),(24494164,266340721,1,4),(24494164,266340722,1,5),(24497076,266380266,1,1),(24497076,266380267,1,2),(24497077,266380268,2,1),(24497077,266380266,2,2),(24512879,266326345,1,1),(24512879,266326393,1,2),(24512879,266326394,1,3),(24512879,266326395,1,4),(24512879,266326396,1,5),(24512879,266326397,1,6),(24512879,266326398,1,7),(24512879,266326399,1,8),(24517626,51581670,2,1),(24517626,266619895,2,2),(24517626,266619896,2,3),(24517626,266619897,2,4),(24517626,266619898,2,5),(24517626,266619899,2,6),(24517626,266619900,2,7),(24517626,266619901,2,8),(24517626,266619902,2,9),(24517626,266619903,2,10),(24517626,266619904,2,11),(24517626,266619905,2,12),(24517626,266619906,2,13),(24517626,266619907,2,14),(24517626,266619908,2,15),(24517626,266619909,2,16),(24517633,266619906,2,1),(24517633,266619955,2,2),(24517633,266619956,2,3),(24517644,266619897,2,1),(24517644,266620044,2,2),(24517644,266620043,2,3),(24517644,266620042,2,4),(24517644,266620041,2,5),(24517644,266620040,2,6),(24517841,266622050,1,1),(24517841,266622051,1,2),(24517841,266622052,1,3),(24517841,266622053,1,4),(24517841,266622054,1,5),(24517841,266622055,1,6),(24517841,266622056,1,7),(24517841,266622057,1,8),(24517841,266622058,1,9),(24517841,266622059,1,10),(24517841,266622060,1,11),(24517841,266622061,1,12),(24517841,266622062,1,13),(24517875,266622366,6,1),(24517875,354968366,6,2),(24517875,266622365,6,3),(24517875,266622364,6,4),(24517875,266622363,6,5),(24517875,266622362,6,6),(24517875,266622361,6,7),(24517875,266622360,6,8),(24517875,266622359,6,9),(24517875,266622358,6,10),(24517875,266622357,6,11),(24517875,266622356,6,12),(24517875,266622355,6,13),(24517875,266622354,6,14),(24517875,266622353,6,15),(24517875,266622352,6,16),(24517875,266622351,6,17),(24517875,266622350,6,18),(24517875,266622461,6,19),(24517875,266622349,6,20),(24517875,266622348,6,21),(24517889,266622460,1,1),(24517889,266622461,1,2),(24517907,266622567,1,1),(24517907,266622568,1,2),(24517907,266622569,1,3),(24517907,266622570,1,4),(24517907,266622572,1,5),(24517907,266622573,1,6),(24517907,266622567,1,7),(24518086,266623545,3,1),(24518086,266623546,3,2),(24518086,266623547,3,3),(24518086,266623548,3,4),(24518086,266623549,3,5),(24518086,266623550,3,6),(24518086,266623551,3,7),(24518086,266623552,3,8),(24518086,266623553,3,9),(24518086,266623554,3,10),(24518086,266623555,3,11),(24518088,266622986,3,1),(24518088,266623590,3,2),(24518088,266623591,3,3),(24518088,266623592,3,4),(24518088,266623545,3,5),(24518115,266623555,4,1),(24518115,266623556,4,2),(24518115,266623557,4,3),(24518115,266623558,4,4),(24518115,266623559,4,5),(24518115,266623560,4,6),(24518124,266623560,2,1),(24518124,266623561,2,2),(24518124,266623562,2,3),(24518124,266623563,2,4),(24518124,266623564,2,5),(24518124,266623565,2,6),(24518124,266623566,2,7),(24518124,266623567,2,8),(24518124,266623568,2,9),(24518124,266623569,2,10),(24518124,266623570,2,11),(24518124,266623571,2,12),(24518124,266623572,2,13),(24518124,266623573,2,14),(24518124,266623574,2,15),(24518124,266623575,2,16),(24518124,266623576,2,17),(24518124,266623577,2,18),(24518124,266623578,2,19),(24518124,266623579,2,20),(24518124,266623580,2,21),(24518124,266623581,2,22),(24518124,266623582,2,23),(24518124,266623583,2,24),(24518124,266623584,2,25),(24518124,266623585,2,26),(24518124,266623586,2,27),(24518124,266623587,2,28),(24518124,266623588,2,29),(24518124,266623589,2,30),(24663518,268081244,1,1),(24663518,268081245,1,2),(24663518,268081246,1,3),(24663520,268081243,2,1),(24663520,268081244,2,2),(24663786,53327620,2,1),(24663786,53319578,2,2),(24663786,53319576,2,3),(24663786,53319573,2,4),(24663786,53319571,2,5),(24663786,53319570,2,6),(24663786,53319568,2,7),(24663786,53319566,2,8),(24663786,53319564,2,9),(24663786,53319563,2,10),(24663786,53319560,2,11),(24663786,332125718,2,12),(24663786,53319512,2,13),(24663894,52206643,3,1),(24663894,52204450,3,2),(24664831,268092812,3,1),(24664831,268091938,3,2),(24664831,268091940,3,3),(24664831,268091942,3,4),(24664831,268091944,3,5),(24664831,268091946,3,6),(24664831,268091948,3,7),(24664831,268091950,3,8),(24664867,268093053,7,1),(24664867,268092433,7,2),(24664867,268092434,7,3),(24664867,268092435,7,4),(24664867,268092812,7,5),(24664867,268092436,7,6),(24664867,268092437,7,7),(24664867,268092438,7,8),(24664867,268092439,7,9),(24664867,268092441,7,10),(24664867,268092442,7,11),(24664867,268092443,7,12),(24664867,268092444,7,13),(24664867,268092445,7,14),(24664867,268092446,7,15),(24664867,268092447,7,16),(24664867,268092448,7,17),(24664867,268093279,7,18),(24664867,268092449,7,19),(24664867,268092450,7,20),(24664867,268092451,7,21),(24664867,268092452,7,22),(24664867,268092453,7,23),(24664867,268092454,7,24),(24664867,268092455,7,25),(24664880,268093279,3,1),(24664880,268093281,3,2),(24664880,268092682,3,3),(24664880,268092683,3,4),(24664880,268092684,3,5),(24664880,268092685,3,6),(24664880,268092686,3,7),(24664880,268092687,3,8),(24664880,268092688,3,9),(24664880,268092689,3,10),(24664880,268092691,3,11),(24664880,268092692,3,12),(24664880,268092693,3,13),(24664880,268092694,3,14),(24664880,268092695,3,15),(24664880,268092696,3,16),(24665224,268096306,2,1),(24665224,268095978,2,2),(24665224,268095979,2,3),(24665224,268095980,2,4),(24665224,268095981,2,5),(24665224,268095982,2,6),(24665224,268095983,2,7),(24665224,268095984,2,8),(24665224,268095985,2,9),(24665224,268095986,2,10),(24665224,268095987,2,11),(24665257,268096149,1,1),(24665257,268096150,1,2),(24665257,268096151,1,3),(24665257,268096152,1,4),(24665257,268096153,1,5),(24665257,268096154,1,6),(24665257,268096149,1,7),(24665737,268148594,8,1),(24665737,268100719,8,2),(24665737,268100720,8,3),(24665737,268100721,8,4),(24665737,268100722,8,5),(24665737,268100723,8,6),(24665737,268101444,8,7),(24665737,268100724,8,8),(24665737,268100725,8,9),(24665737,268100727,8,10),(24665737,268100728,8,11),(24665737,268103842,8,12),(24665737,268101670,8,13),(24665737,268100729,8,14),(24665737,268100730,8,15),(24665737,268100731,8,16),(24665737,268100732,8,17),(24665737,268100733,8,18),(24665737,268100735,8,19),(24665737,268100736,8,20),(24665737,268100737,8,21),(24665737,268104831,8,22),(24665737,268100738,8,23),(24665737,268100739,8,24),(24665737,268100740,8,25),(24665737,268100741,8,26),(24665737,268100742,8,27),(24665737,268100743,8,28),(24665737,268100744,8,29),(24665737,268100746,8,30),(24665737,268100747,8,31),(24665737,268100748,8,32),(24665737,268100749,8,33),(24665737,268100750,8,34),(24665737,268100752,8,35),(24665737,268100753,8,36),(24665737,268100754,8,37),(24665737,268100755,8,38),(24665737,268100757,8,39),(24665737,268100758,8,40),(24665737,268100759,8,41),(24665737,268100760,8,42),(24665737,268100761,8,43),(24665737,268103434,8,44),(24665737,268100762,8,45),(24665737,268100764,8,46),(24665737,268100765,8,47),(24665737,268100766,8,48),(24665737,268100767,8,49),(24665737,268100768,8,50),(24665737,268100769,8,51),(24665737,268100771,8,52),(24665737,268100772,8,53),(24665737,268100773,8,54),(24665737,268100775,8,55),(24665737,268100776,8,56),(24665737,268100777,8,57),(24665737,268100778,8,58),(24665737,268100779,8,59),(24665737,268100781,8,60),(24665737,268100782,8,61),(24665737,268100783,8,62),(24665737,268100784,8,63),(24665737,268100785,8,64),(24665737,268100786,8,65),(24665737,268100787,8,66),(24665737,268100789,8,67),(24665737,268100790,8,68),(24665737,268100791,8,69),(24665737,268100792,8,70),(24665737,268100793,8,71),(24665737,268100794,8,72),(24665785,268101444,1,1),(24665785,268101446,1,2),(24665785,268101448,1,3),(24665785,268101451,1,4),(24665785,268101453,1,5),(24665785,268101454,1,6),(24665785,268101456,1,7),(24665811,268101669,1,1),(24665811,268101670,1,2),(24666049,268100733,1,1),(24666049,268103219,1,2),(24666049,268103220,1,3),(24666099,268103434,1,1),(24666099,268103435,1,2),(24666099,268103436,1,3),(24666099,268103437,1,4),(24666099,268103438,1,5),(24666136,268103842,2,1),(24666136,268103843,2,2),(24666136,268103844,2,3),(24666136,268103845,2,4),(24666136,268103846,2,5),(24666136,268103847,2,6),(24666136,268103848,2,7),(24666136,268103850,2,8),(24666136,268101669,2,9),(24666186,268104321,1,1),(24666186,268104322,1,2),(24666186,268104323,1,3),(24666186,268104324,1,4),(24666186,268104325,1,5),(24666186,268104326,1,6),(24666186,268104327,1,7),(24666186,268104328,1,8),(24666186,268104329,1,9),(24666186,268104321,1,10),(24668180,268123180,4,1),(24668180,268123181,4,2),(24668181,268123183,3,1),(24668181,268123184,3,2),(24668181,268123185,3,3),(24668181,268123186,3,4),(24668181,268123187,3,5),(24668181,268123188,3,6),(24668181,268123189,3,7),(24668181,268123190,3,8),(24668181,268123192,3,9),(24668181,268123180,3,10),(24668187,268123181,2,1),(24668187,268123182,2,2),(24668361,268124663,4,1),(24668361,268124664,4,2),(24668361,268124667,4,3),(24668361,268124759,4,4),(24668372,268124757,2,1),(24668372,268124758,2,2),(24668373,268124759,2,1),(24668373,268124757,2,2),(24668885,268134045,6,1),(24668885,268129594,6,2),(24668954,268129612,2,1),(24668954,268130240,2,2),(24669163,268131748,3,1),(24669163,268131749,3,2),(24669163,268131750,3,3),(24669163,268131751,3,4),(24669163,268133883,3,5),(24669163,268131752,3,6),(24669163,268131753,3,7),(24669163,268131755,3,8),(24669163,268131756,3,9),(24669163,268131757,3,10),(24669163,268131758,3,11),(24669163,268131759,3,12),(24669163,268131760,3,13),(24669163,268131761,3,14),(24669163,268131762,3,15),(24669163,268131763,3,16),(24669245,268132090,1,1),(24669245,268132091,1,2),(24669247,268132095,3,1),(24669247,268132096,3,2),(24669247,268132097,3,3),(24669247,268132098,3,4),(24669247,268132099,3,5),(24669247,268132100,3,6),(24669248,268132100,2,1),(24669248,268132090,2,2),(24669306,268132455,1,1),(24669306,268132456,1,2),(24669306,268132457,1,3),(24669306,268132458,1,4),(24669306,268132459,1,5),(24669306,268132460,1,6),(24669306,268132461,1,7),(24669306,268132462,1,8),(24669306,268132463,1,9),(24669306,268132464,1,10),(24669306,268132465,1,11),(24669306,268132466,1,12),(24669306,268132467,1,13),(24669306,268132468,1,14),(24669306,268132469,1,15),(24669306,268132455,1,16),(24669321,268132982,2,1),(24669321,268132983,2,2),(24669321,268132985,2,3),(24669321,268132986,2,4),(24669321,268132987,2,5),(24669321,268132989,2,6),(24669321,268132990,2,7),(24669321,268132991,2,8),(24669321,268132992,2,9),(24669321,268132993,2,10),(24669321,268132095,2,11),(24669321,268132994,2,12),(24669321,268132996,2,13),(24669321,268132997,2,14),(24669321,268132998,2,15),(24669321,268132982,2,16),(24669352,268133215,2,1),(24669352,268133216,2,2),(24669352,268133217,2,3),(24669352,268133218,2,4),(24669352,268133219,2,5),(24669352,268133221,2,6),(24669352,268133222,2,7),(24669352,268133223,2,8),(24669352,268133224,2,9),(24669352,268133225,2,10),(24669352,268133215,2,11),(24669376,268133712,1,1),(24669376,268133714,1,2),(24669376,268133715,1,3),(24669376,268133716,1,4),(24669376,268133717,1,5),(24669376,268133718,1,6),(24669376,268133719,1,7),(24669376,268133712,1,8),(24669430,268129597,1,1),(24669430,268133883,1,2),(24669444,268129594,3,1),(24669444,268129595,3,2),(24669444,268129596,3,3),(24669444,268129597,3,4),(24669444,268129598,3,5),(24669444,268129599,3,6),(24669444,268129600,3,7),(24669444,268129601,3,8),(24669444,268129602,3,9),(24669444,268129603,3,10),(24669444,268129605,3,11),(24669444,268129607,3,12),(24669444,268131748,3,13),(24669444,268129608,3,14),(24669444,268129609,3,15),(24669444,268129610,3,16),(24669444,268129611,3,17),(24669444,268129612,3,18),(24669444,268129614,3,19),(24669444,268129615,3,20),(24669444,268129616,3,21),(24669444,268129618,3,22),(24669444,268129619,3,23),(24669444,268129620,3,24),(24669444,268129621,3,25),(24669444,268130240,3,26),(24669444,268129622,3,27),(24669444,268129624,3,28),(24669444,268129625,3,29),(24669444,268129626,3,30),(24669444,268129627,3,31),(24669444,268129608,3,32),(24713155,268614412,4,1),(24713155,268613131,4,2),(24713155,268613132,4,3),(24713155,268613133,4,4),(24713155,268613134,4,5),(24713155,268613135,4,6),(24713155,268613136,4,7),(24713155,268613137,4,8),(24713155,268613138,4,9),(24713155,268613139,4,10),(24713155,268613140,4,11),(24713182,268081246,5,1),(24713182,470362088,5,2),(24713182,470362090,5,3),(24713182,470362091,5,4),(24713182,470362096,5,5),(24713182,470362099,5,6),(24713182,470362102,5,7),(24713182,470362105,5,8),(24713182,470362109,5,9),(24713182,470362112,5,10),(24713182,470362115,5,11),(24713182,470362117,5,12),(24713182,470362120,5,13),(24713182,470362123,5,14),(24713182,470362131,5,15),(24713182,470362132,5,16),(24713182,470362134,5,17),(24713182,470362136,5,18),(24713182,470362138,5,19),(24713182,470362140,5,20),(24713182,470362142,5,21),(24713182,470362143,5,22),(24713182,470362144,5,23),(24713182,470362145,5,24),(24713182,470362147,5,25),(24713182,470362152,5,26),(24713182,470362154,5,27),(24713182,470362156,5,28),(24713182,470362158,5,29),(24713182,470362160,5,30),(24713182,470362162,5,31),(24713182,470362163,5,32),(24713182,470362164,5,33),(24713182,268613536,5,34),(24713182,268613537,5,35),(24713182,268613538,5,36),(24713182,268613147,5,37),(24713182,268613539,5,38),(24713182,268613540,5,39),(24713182,268613541,5,40),(24713182,268613542,5,41),(24713182,268613543,5,42),(24713182,268613544,5,43),(24713182,268613545,5,44),(24713182,268613546,5,45),(24713182,268613547,5,46),(24713182,268613548,5,47),(24713182,268613549,5,48),(24713182,268613550,5,49),(24713182,268613551,5,50),(24713182,268613552,5,51),(24713182,268613553,5,52),(24713182,268613554,5,53),(24713182,268613555,5,54),(24713182,268613556,5,55),(24713182,268613557,5,56),(24713182,268613558,5,57),(24713182,268613559,5,58),(24713182,268613560,5,59),(24713182,268613561,5,60),(24713182,268613562,5,61),(24713182,268613563,5,62),(24713182,268613564,5,63),(24713189,268615558,3,1),(24713189,268613691,3,2),(24713189,268613692,3,3),(24713189,268613693,3,4),(24713189,268613694,3,5),(24713189,268613695,3,6),(24713189,268613696,3,7),(24713189,268613697,3,8),(24713189,268613698,3,9),(24713189,268613699,3,10),(24713189,268613700,3,11),(24713189,268613701,3,12),(24713189,268613703,3,13),(24713210,268613146,3,1),(24713210,268613147,3,2),(24713222,268613140,3,1),(24713222,268613141,3,2),(24713222,268613142,3,3),(24713222,268613143,3,4),(24713222,268613144,3,5),(24713222,268613145,3,6),(24713246,268613145,3,1),(24713246,268613146,3,2),(24713303,268613704,1,1),(24713303,268613563,1,2),(24713305,268613703,2,1),(24713305,268613704,2,2),(24713352,51582184,5,1),(24713352,268615700,5,2),(24713352,268615701,5,3),(24713352,268616487,5,4),(24713352,268615702,5,5),(24713352,268615703,5,6),(24713352,268615704,5,7),(24713352,268615705,5,8),(24713352,458765020,5,9),(24713352,268615706,5,10),(24713352,268615707,5,11),(24713362,268615706,3,1),(24713362,268615782,3,2),(24713362,268615783,3,3),(24713362,268615784,3,4),(24713362,268615786,3,5),(24713362,268615787,3,6),(24713447,268615787,3,1),(24713447,268616479,3,2),(24713447,268616480,3,3),(24713447,268616481,3,4),(24713447,268616482,3,5),(24713447,268616483,3,6),(24713447,268616484,3,7),(24713447,268616485,3,8),(24713447,268616486,3,9),(24713447,268616487,3,10),(24713483,268616713,1,1),(24713483,268616714,1,2),(24713483,268616715,1,3),(24713483,268616716,1,4),(24713483,268616717,1,5),(24713483,268616718,1,6),(24713483,268616719,1,7),(24713483,268616713,1,8),(24713502,268616892,1,1),(24713502,268616893,1,2),(24713502,268616894,1,3),(24713502,268616895,1,4),(24713502,268616892,1,5),(24713566,268617677,2,1),(24713566,268617407,2,2),(24713566,268617408,2,3),(24713566,268617409,2,4),(24713566,268617410,2,5),(24713566,268617411,2,6),(24713566,268617412,2,7),(24713566,268617413,2,8),(24713566,268617414,2,9),(24713566,268617415,2,10),(24713566,268617416,2,11),(24713566,268617417,2,12),(24713566,268617418,2,13),(24713566,268617419,2,14),(24713566,268617420,2,15),(24713566,268617421,2,16),(24713566,268617422,2,17),(24713578,268617414,3,1),(24713578,268617505,3,2),(24713578,268617504,3,3),(24713578,268617503,3,4),(24713578,268617502,3,5),(24713578,268617501,3,6),(24713578,268617500,3,7),(24713578,268617499,3,8),(24713578,268617498,3,9),(24713578,268617497,3,10),(24713578,268617496,3,11),(24713578,268617495,3,12),(24713578,268617494,3,13),(24713578,268617493,3,14),(24713611,268617808,1,1),(24713611,268617809,1,2),(24713692,268618417,1,1),(24713692,51554716,1,2),(24713704,268093053,1,1),(24713704,52202541,1,2),(24713704,52202539,1,3),(24713704,268124758,1,4),(24713704,52202534,1,5),(24713704,52202533,1,6),(24713704,52202528,1,7),(24713704,52202526,1,8),(24713704,52202523,1,9),(24713704,52202521,1,10),(24713704,52202517,1,11),(24713704,52202511,1,12),(24713704,52202507,1,13),(24713704,52202499,1,14),(24713704,52202493,1,15),(24713704,52202488,1,16),(24713704,52202485,1,17),(24713704,52202476,1,18),(24713704,52202473,1,19),(24713704,52202468,1,20),(24713704,52202465,1,21),(24713704,52202460,1,22),(24713704,52202455,1,23),(24713704,52202451,1,24),(24713704,52202389,1,25),(24713704,52202283,1,26),(24713704,52202293,1,27),(24713704,52202298,1,28),(24713704,52202362,1,29),(24713704,51554688,1,30),(24713904,51444885,3,1),(24713904,51444886,3,2),(24713918,51445071,9,1),(24713918,51445209,9,2),(24713918,51445210,9,3),(24713936,51445785,2,1),(24713936,51443686,2,2),(24713936,51443687,2,3),(24713936,51443688,2,4),(24713936,51443690,2,5),(24713936,51443691,2,6),(24713936,51443692,2,7),(24713936,51443693,2,8),(24713936,51443694,2,9),(24713936,51443695,2,10),(24714294,51399308,3,1),(24714294,51410788,3,2),(24714294,51399309,3,3),(24714736,51441228,4,1),(24714736,51441229,4,2),(24714736,51441230,4,3),(24714736,51441232,4,4),(24714736,51441233,4,5),(24714736,51441235,4,6),(24714736,51441237,4,7),(24714736,51441239,4,8),(24714736,51441242,4,9),(24714736,51441244,4,10),(24714736,51441246,4,11),(24714736,51441249,4,12),(24714743,51441249,10,1),(24714743,51441250,10,2),(24714743,51441254,10,3),(24714743,51441258,10,4),(24714743,51441261,10,5),(24714743,51441262,10,6),(24714743,51441263,10,7),(24714743,51441266,10,8),(24714743,51441267,10,9),(24714743,51441269,10,10),(24714743,51438666,10,11),(24714743,281070673,10,12),(24714743,51440320,10,13),(24714743,51440321,10,14),(24714743,51440622,10,15),(24714743,281063471,10,16),(24714743,281063857,10,17),(24714743,51439552,10,18),(24714743,281063913,10,19),(24714743,281063929,10,20),(24714743,51439215,10,21),(24714743,51442533,10,22),(24714743,51442653,10,23),(24714743,281064124,10,24),(24714743,51385297,10,25),(24714892,51444894,2,1),(24714892,51444896,2,2),(24714892,51444897,2,3),(24714892,51444898,2,4),(24714892,51444899,2,5),(24714892,51444902,2,6),(24714892,51444652,2,7),(24714892,51444653,2,8),(24714892,51444401,2,9),(24714892,51444403,2,10),(24714892,51444404,2,11),(24714892,51444405,2,12),(24714892,51444406,2,13),(24714892,51444408,2,14),(24714892,51444468,2,15),(24714892,264281365,2,16),(24714892,51444470,2,17),(24714892,51444471,2,18),(24714892,51444444,2,19),(24714892,51444383,2,20),(24714892,51444381,2,21),(24714892,264279592,2,22),(24714892,51444379,2,23),(24714892,51444377,2,24),(24714892,51444375,2,25),(24714892,51444374,2,26),(24714892,51444373,2,27),(24714892,51444371,2,28),(24714892,51444370,2,29),(24714892,51444368,2,30),(24714892,51444366,2,31),(24714892,264278159,2,32),(24714892,51444365,2,33),(24714892,264278124,2,34),(24714892,51444364,2,35),(24714892,51444362,2,36),(24714892,51444359,2,37),(24714892,51444358,2,38),(24715008,51402989,2,1),(24715008,51402991,2,2),(24715008,51402994,2,3),(24715008,51402995,2,4),(24715008,51402997,2,5),(24715008,51403000,2,6),(24715008,51403225,2,7),(24715064,268630128,3,1),(24715064,51403663,3,2),(24715064,268631096,3,3),(24715064,51403665,3,4),(24715082,51403665,6,1),(24715082,646807552,6,2),(24715082,268630910,6,3),(24715082,646807563,6,4),(24715082,646807568,6,5),(24715082,268630911,6,6),(24715082,646807575,6,7),(24715082,646807589,6,8),(24715082,51369109,6,9),(24715082,646807600,6,10),(24715082,268630913,6,11),(24715082,646807608,6,12),(24715082,646807611,6,13),(24715082,268630914,6,14),(24715082,646807615,6,15),(24715082,646807618,6,16),(24715082,646807620,6,17),(24715082,51403665,6,18),(24715152,51369109,5,1),(24715152,51369110,5,2),(24715152,51369112,5,3),(24715152,51369114,5,4),(24715152,51404282,5,5),(24715152,51369115,5,6),(24715152,51369118,5,7),(24715152,51369120,5,8),(24715152,51442961,5,9),(24715152,51369123,5,10),(24715152,51369125,5,11),(24715152,337742674,5,12),(24715152,51369126,5,13),(24715152,337729044,5,14),(24715152,51369129,5,15),(24715185,268631096,3,1),(24715185,646809729,3,2),(24715185,268631795,3,3),(24715324,51410490,1,1),(24715324,51399339,1,2),(24715324,51399303,1,3),(24715324,51399304,1,4),(24715324,51399306,1,5),(24715324,51399308,1,6),(24913724,259475455,2,1),(24913724,270716339,2,2),(24913724,270716340,2,3),(24913724,270716341,2,4),(24913724,270716342,2,5),(24913724,270716343,2,6),(24913724,270716344,2,7),(24913724,270716346,2,8),(24913724,270716347,2,9),(24913724,270716348,2,10),(24913724,270716349,2,11),(24913724,270716350,2,12),(24913724,270716351,2,13),(24913724,270716352,2,14),(24913724,270716353,2,15),(24913724,270716354,2,16),(24913802,270716347,1,1),(24913802,270717286,1,2),(24913802,270717287,1,3),(24913802,270717288,1,4),(24913802,270717289,1,5),(24913861,53319503,1,1),(24913861,270717898,1,2),(24913861,270717899,1,3),(24914526,51405265,3,1),(24914526,270723241,3,2),(24914526,270723242,3,3),(24914526,270723243,3,4),(24914526,270723244,3,5),(24914526,270723368,3,6),(24914534,51448409,7,1),(24914534,51400766,7,2),(24914534,270726765,7,3),(24914563,270723368,5,1),(24914563,270723369,5,2),(24914563,51448409,5,3),(24914563,270723912,5,4),(24914563,270723459,5,5),(24914563,270723325,5,6),(24914563,270723412,5,7),(24914563,270723413,5,8),(24914563,270723368,5,9),(24914660,51447737,4,1),(24914660,270725839,4,2),(24914768,270724708,2,1),(24914768,51367558,2,2),(24914779,270724742,2,1),(24914779,51366991,2,2),(24914843,270725821,6,1),(24914843,646809632,6,2),(24914843,270725822,6,3),(24914843,646809636,6,4),(24914843,270725823,6,5),(24914843,646809642,6,6),(24914843,270725825,6,7),(24914843,646809643,6,8),(24914843,270725952,6,9),(24914843,646809644,6,10),(24914843,270725826,6,11),(24914843,646809645,6,12),(24914843,270725827,6,13),(24914843,646809646,6,14),(24914843,270725828,6,15),(24914843,646809647,6,16),(24914843,270725839,6,17),(24914843,646809648,6,18),(24914843,270725821,6,19),(24914870,270726768,5,1),(24914870,270726179,5,2),(24914870,51400768,5,3),(24914870,51400770,5,4),(24914903,270726764,6,1),(24914903,646809649,6,2),(24914903,270726765,6,3),(24914903,646809650,6,4),(24914903,270726766,6,5),(24914903,646809651,6,6),(24914903,646809652,6,7),(24914903,270726767,6,8),(24914903,646809653,6,9),(24914903,646809654,6,10),(24914903,270726768,6,11),(24914903,646809655,6,12),(24914903,646809656,6,13),(24914903,270726770,6,14),(24914903,646809657,6,15),(24914903,270726771,6,16),(24914903,646809658,6,17),(24914903,270726764,6,18),(24914989,270726767,5,1),(24914989,337781593,5,2),(24914989,270727242,5,3),(24915114,51400281,2,1),(24915114,51400283,2,2),(24915114,51400284,2,3),(24915114,270724218,2,4),(24915114,51400285,2,5),(24915114,51400286,2,6),(24915114,51400290,2,7),(24915114,51400293,2,8),(24915114,51400296,2,9),(24915114,51400299,2,10),(24915114,51400301,2,11),(24915114,51400303,2,12),(24915114,51400305,2,13),(24915114,270724708,2,14),(24915114,51367559,2,15),(24915502,51450019,2,1),(24915502,51450116,2,2),(24915504,51450114,3,1),(24915504,51450019,3,2),(24915554,270731115,5,1),(24915554,53288152,5,2),(24915554,53288150,5,3),(24915554,53288119,5,4),(24915554,59015934,5,5),(24915554,53288123,5,6),(24915554,53288126,5,7),(24915554,53288141,5,8),(24915554,53288143,5,9),(24915554,53288147,5,10),(24915554,53288148,5,11),(24915566,270731143,5,1),(24915566,270731114,5,2),(24915566,270731115,5,3),(24915566,270731116,5,4),(24915566,270731117,5,5),(24915566,270731118,5,6),(24915566,270731119,5,7),(24915566,270731143,5,8),(24915617,270730925,4,1),(24915617,270730926,4,2),(24915624,51450106,3,1),(24915624,270730924,3,2),(24915624,270730925,3,3),(24915706,270730925,2,1),(24915706,51450107,2,2),(24915763,270733631,1,1),(24915763,51448830,1,2),(24915772,51448828,2,1),(24915772,270733631,2,2),(24915834,270730926,1,1),(24915834,270730927,1,2),(24915834,270730928,1,3),(24915834,270730929,1,4),(24915834,270730930,1,5),(24915834,270730931,1,6),(24915834,270730932,1,7),(24915834,270730933,1,8),(24915834,270730934,1,9),(24915834,270730935,1,10),(24915834,270730936,1,11),(24915834,270730937,1,12),(24915834,270730938,1,13),(24915834,270730939,1,14),(24915834,270730940,1,15),(24915834,270730941,1,16),(24915834,270730942,1,17),(24915834,270730943,1,18),(24915834,270730944,1,19),(24915834,270730945,1,20),(24915834,270731143,1,21),(25014753,51441626,4,1),(25014753,271938772,4,2),(25014753,271938773,4,3),(25014753,271938774,4,4),(25014753,271938778,4,5),(25014753,51404061,4,6),(25014777,206332846,1,1),(25014777,271939032,1,2),(25014777,271939033,1,3),(25014777,271939034,1,4),(25415705,276995290,6,1),(25415705,276995291,6,2),(25415705,276995292,6,3),(25415705,276995293,6,4),(25415705,276995294,6,5),(25416126,259986460,3,1),(25416126,259986459,3,2),(25416126,259986458,3,3),(25416126,259986457,3,4),(25416126,259986456,3,5),(25416126,259986455,3,6),(25416126,259986454,3,7),(25416126,259986453,3,8),(25416126,276999219,3,9),(25416126,53309384,3,10),(25416128,259986470,2,1),(25416128,259986469,2,2),(25416227,277001703,4,1),(25416227,277001727,4,2),(25416308,277001727,3,1),(25416308,277000665,3,2),(25416308,277000666,3,3),(25416308,277000667,3,4),(25416308,277000669,3,5),(25416308,264502063,3,6),(25416371,53309368,3,1),(25416371,277003121,3,2),(25416371,53309369,3,3),(25416371,53309370,3,4),(25416371,53309371,3,5),(25416371,53309374,3,6),(25416371,53309376,3,7),(25416371,277003126,3,8),(25416371,53309379,3,9),(25453236,277375056,2,1),(25453236,277375057,2,2),(25453308,277375057,3,1),(25453308,277375058,3,2),(25453310,277375058,1,1),(25453310,277375059,1,2),(25453310,277375060,1,3),(25453310,277375061,1,4),(25453310,277375062,1,5),(25453310,277375063,1,6),(25453310,277375064,1,7),(25453310,262467026,1,8),(25454372,260997624,2,1),(25454372,277386816,2,2),(25454372,277386817,2,3),(25454372,277386818,2,4),(25454372,277386819,2,5),(25454372,277386820,2,6),(25454378,277386820,4,1),(25454378,277386821,4,2),(25454378,277386822,4,3),(25454378,277386823,4,4),(25454378,277386824,4,5),(25454378,277386825,4,6),(25454378,277386826,4,7),(25454378,277386827,4,8),(25454381,277386818,2,1),(25454381,277386930,2,2),(25454381,277386931,2,3),(25484821,277694081,2,1),(25484821,277694080,2,2),(25484883,277695163,4,1);
INSERT INTO `way_nodes` VALUES (25484883,277695545,4,2),(25484883,51405720,4,3),(25484883,51405722,4,4),(25484883,51405723,4,5),(25484883,51405725,4,6),(25484883,51448405,4,7),(25484883,51405727,4,8),(25484883,51405728,4,9),(25484883,51405729,4,10),(25484912,277695169,6,1),(25484912,646808885,6,2),(25484912,646808886,6,3),(25484912,277695163,6,4),(25484912,646808887,6,5),(25484912,646808888,6,6),(25484912,277695164,6,7),(25484912,646808889,6,8),(25484912,646808890,6,9),(25484912,277695165,6,10),(25484912,646808892,6,11),(25484912,277695167,6,12),(25484912,646808893,6,13),(25484912,646808895,6,14),(25484912,646808896,6,15),(25484912,277695168,6,16),(25484912,646808900,6,17),(25484912,646808903,6,18),(25484912,277695169,6,19),(25485099,51110493,5,1),(25485099,277697847,5,2),(25485099,277697265,5,3),(25485099,277697266,5,4),(25485099,277697267,5,5),(25485099,277697268,5,6),(25485099,277697269,5,7),(25485099,277697270,5,8),(25485099,277697271,5,9),(25485099,277697272,5,10),(25485099,277697273,5,11),(25485099,277697274,5,12),(25485119,277697274,1,1),(25485119,277697480,1,2),(25485119,277697481,1,3),(25485119,277697482,1,4),(25485119,277697483,1,5),(25485119,277697484,1,6),(25485119,277697485,1,7),(25485130,277697485,4,1),(25485130,277697277,4,2),(25485130,277697278,4,3),(25485130,277697279,4,4),(25485130,277697280,4,5),(25485130,277697281,4,6),(25485130,277697282,4,7),(25485130,281039653,4,8),(25485130,277697283,4,9),(25485130,277697284,4,10),(25485130,277697285,4,11),(25485130,277697286,4,12),(25485130,277697287,4,13),(25485130,277697288,4,14),(25485130,277697289,4,15),(25485130,281039984,4,16),(25485131,277697274,2,1),(25485131,277697275,2,2),(25485131,277697276,2,3),(25485131,277697485,2,4),(25569661,51409632,3,1),(25569661,51409633,3,2),(25569661,51409634,3,3),(25569661,51409635,3,4),(25569661,51409636,3,5),(25569661,51409638,3,6),(25569661,51409639,3,7),(25569661,51409640,3,8),(25569661,51409641,3,9),(25569661,51409642,3,10),(25569661,51409644,3,11),(25569661,51409645,3,12),(25569661,51409646,3,13),(25569661,51409647,3,14),(25569661,51409648,3,15),(25569661,51409649,3,16),(25569661,51409651,3,17),(25569661,51409652,3,18),(25569661,51409653,3,19),(25569661,51409655,3,20),(25569661,51409656,3,21),(25569661,51409657,3,22),(25569661,51409658,3,23),(25569661,51409659,3,24),(25569661,51409660,3,25),(25569661,51409662,3,26),(25569661,51409663,3,27),(25569661,51409664,3,28),(25569661,51409665,3,29),(25569661,51409666,3,30),(25569661,51409667,3,31),(25569661,51409668,3,32),(25569661,51409669,3,33),(25569661,51409670,3,34),(25569661,51409671,3,35),(25569661,51409672,3,36),(25569661,51409673,3,37),(25569661,51409674,3,38),(25569661,51409675,3,39),(25569661,51409676,3,40),(25569661,51409677,3,41),(25569661,51409678,3,42),(25569661,51973033,3,43),(25569665,51406803,2,1),(25569665,51972990,2,2),(25569665,51972993,2,3),(25569665,51972999,2,4),(25569665,51973000,2,5),(25569665,51973004,2,6),(25569665,51973007,2,7),(25569665,51973010,2,8),(25569665,51973014,2,9),(25569665,51973017,2,10),(25569665,51973021,2,11),(25569665,51973026,2,12),(25569665,51973027,2,13),(25569665,51973030,2,14),(25569665,51973033,2,15),(25569665,51409679,2,16),(25569665,51409680,2,17),(25569665,51973038,2,18),(25569665,51973045,2,19),(25569665,51973049,2,20),(25569665,51973052,2,21),(25569665,51973055,2,22),(25569665,51973058,2,23),(25569665,51973061,2,24),(25569665,51973066,2,25),(25569665,51973069,2,26),(25569665,51973073,2,27),(25569665,51973078,2,28),(25569665,51973082,2,29),(25569665,51973084,2,30),(25569665,51973088,2,31),(25569665,51973091,2,32),(25569665,51973096,2,33),(25569665,51973099,2,34),(25569745,278721406,4,1),(25569745,278721797,4,2),(25569748,278721797,1,1),(25569748,270723325,1,2),(25569755,278722158,2,1),(25569755,51401456,2,2),(25569755,51447737,2,3),(25569755,51401457,2,4),(25569755,51401461,2,5),(25569755,51401224,2,6),(25569775,51401454,3,1),(25569775,278722158,3,2),(25572114,278748954,2,1),(25572114,278752060,2,2),(25572121,278752325,2,1),(25572121,278752327,2,2),(25572121,278752328,2,3),(25572121,278752329,2,4),(25572121,278752325,2,5),(25572130,278752060,3,1),(25572130,278752061,3,2),(25572131,278752061,1,1),(25572131,278752062,1,2),(25572131,278752063,1,3),(25572131,278752064,1,4),(25572131,278752066,1,5),(25572131,278752067,1,6),(25572131,278752068,1,7),(25572131,278752069,1,8),(25572131,278752070,1,9),(25572131,278752071,1,10),(25572131,278752072,1,11),(25572131,278752073,1,12),(25572131,278752074,1,13),(25572131,278752075,1,14),(25572131,278752076,1,15),(25572131,278752077,1,16),(25572131,278752078,1,17),(25572131,278752079,1,18),(25572131,278752080,1,19),(25572131,278752081,1,20),(25572131,278752083,1,21),(25572131,278752084,1,22),(25572131,278752085,1,23),(25572572,278757469,1,1),(25572572,278759738,1,2),(25572572,278759739,1,3),(25572572,278759740,1,4),(25572572,278759742,1,5),(25572572,278759743,1,6),(25572572,278759744,1,7),(25572572,278759745,1,8),(25572572,278759746,1,9),(25572572,278759747,1,10),(25572572,278759748,1,11),(25572572,278759749,1,12),(25572572,278759750,1,13),(25572572,278759752,1,14),(25572572,278759753,1,15),(25572572,278759754,1,16),(25572572,278759755,1,17),(25572572,278759756,1,18),(25572572,278759757,1,19),(25572572,278759758,1,20),(25572572,278759759,1,21),(25572731,278760711,4,1),(25572731,278760995,4,2),(25572731,278761684,4,3),(25572741,278761001,1,1),(25572741,278761189,1,2),(25572741,278761190,1,3),(25572746,278760998,3,1),(25572746,278761435,3,2),(25572746,278761436,3,3),(25572746,278761437,3,4),(25572746,278761438,3,5),(25572746,278761439,3,6),(25572746,278760996,3,7),(25572749,278760995,2,1),(25572749,278760996,2,2),(25572749,278760997,2,3),(25572749,278760998,2,4),(25572749,278760999,2,5),(25572749,278761000,2,6),(25572749,278761001,2,7),(25572749,278761002,2,8),(25572883,278762963,1,1),(25572883,278762964,1,2),(25572883,278762965,1,3),(25572883,278762966,1,4),(25572883,278762967,1,5),(25572883,278762968,1,6),(25572883,278762969,1,7),(25572883,278762970,1,8),(25572883,278762971,1,9),(25572883,278762972,1,10),(25572883,278762973,1,11),(25572883,278762974,1,12),(25572883,278762975,1,13),(25572883,278762976,1,14),(25572883,278762963,1,15),(25573596,51930186,2,1),(25573596,51930188,2,2),(25573596,51930191,2,3),(25573596,51930193,2,4),(25573596,51930195,2,5),(25573596,51930198,2,6),(25573596,51930199,2,7),(25767814,281040020,4,1),(25767814,281040156,4,2),(25767814,281039980,4,3),(25767814,281040022,4,4),(25767814,281039982,4,5),(25767814,281039983,4,6),(25767814,281039984,4,7),(25767814,281040020,4,8),(25767827,281040439,2,1),(25767827,281041274,2,2),(25767827,281040441,2,3),(25767827,281039982,2,4),(25767891,281041761,1,1),(25767891,281041762,1,2),(25767891,281041763,1,3),(25767891,281041764,1,4),(25767891,281041765,1,5),(25767891,281041766,1,6),(25767891,281041767,1,7),(25767891,281041761,1,8),(25768003,281042331,12,1),(25768003,281043351,12,2),(25768003,281043353,12,3),(25768003,281043354,12,4),(25768003,281044538,12,5),(25768003,281043356,12,6),(25768003,281048956,12,7),(25768003,281044540,12,8),(25768003,281049120,12,9),(25768018,281042332,12,1),(25768018,281044597,12,2),(25768018,281048992,12,3),(25768018,281044599,12,4),(25768018,281053935,12,5),(25768018,281043618,12,6),(25768018,281043619,12,7),(25768018,281043621,12,8),(25768018,281043622,12,9),(25768677,281049691,4,1),(25768677,281050352,4,2),(25768677,281050354,4,3),(25768677,281051136,4,4),(25768677,281050357,4,5),(25768677,281051138,4,6),(25768677,281051139,4,7),(25768681,281051766,6,1),(25768681,51385273,6,2),(25768681,51385276,6,3),(25768681,51385277,6,4),(25768681,51385279,6,5),(25768681,51385284,6,6),(25768681,51385285,6,7),(25768681,51385287,6,8),(25768681,51385289,6,9),(25768681,51442041,6,10),(25768760,281051966,3,1),(25768760,281051967,3,2),(25768760,281051968,3,3),(25768760,281051762,3,4),(25768760,281050523,3,5),(25768760,281051139,3,6),(25768760,281051969,3,7),(25768760,281051764,3,8),(25768760,281051765,3,9),(25768760,281051766,3,10),(25768760,281051966,3,11),(25768838,51385273,3,1),(25768838,281057175,3,2),(25768852,281052233,6,1),(25768852,281052234,6,2),(25768852,281052341,6,3),(25768852,281052236,6,4),(25768852,281052237,6,5),(25768852,281052509,6,6),(25768852,281052458,6,7),(25768852,281056804,6,8),(25768868,281052458,5,1),(25768868,281044641,5,2),(25769024,51371387,5,1),(25769024,281055773,5,2),(25769024,281056115,5,3),(25769024,281055776,5,4),(25769024,281056116,5,5),(25769024,281055778,5,6),(25769024,281052233,5,7),(25769049,281057175,3,1),(25769049,281052343,3,2),(25769050,281052343,1,1),(25769050,281052233,1,2),(25769069,281049120,4,1),(25769069,281043360,4,2),(25769071,281043360,4,1),(25769071,281053833,4,2),(25769071,281052580,4,3),(25769071,281053771,4,4),(25769071,281052582,4,5),(25769071,281053946,4,6),(25769071,281052585,4,7),(25769071,281053773,4,8),(25769071,281058251,4,9),(25769071,281053836,4,10),(25769071,281053776,4,11),(25769071,281053777,4,12),(25769071,281053945,4,13),(25769071,51371388,4,14),(25769112,281044619,6,1),(25769112,281043795,6,2),(25769112,281043794,6,3),(25769112,281044620,6,4),(25769112,281043792,6,5),(25769112,281043790,6,6),(25769112,281043789,6,7),(25769112,281048516,6,8),(25769112,281043016,6,9),(25769116,281044641,3,1),(25769116,281044619,3,2),(25769122,281043623,3,1),(25769122,281055053,3,2),(25769122,281056804,3,3),(25769122,281057998,3,4),(25769122,281053938,3,5),(25769122,281053939,3,6),(25769122,281053940,3,7),(25769122,281053941,3,8),(25769122,281053942,3,9),(25769122,281053943,3,10),(25769122,281053944,3,11),(25769122,281053945,3,12),(25769124,281043622,3,1),(25769124,281043623,3,2),(25769182,281059704,3,1),(25769182,51371400,3,2),(25769182,51371401,3,3),(25769182,51371402,3,4),(25769182,51371403,3,5),(25769182,51371404,3,6),(25769182,51371406,3,7),(25769182,51371408,3,8),(25769182,51371409,3,9),(25769182,51371411,3,10),(25769182,51371413,3,11),(25769182,51371415,3,12),(25769182,51371418,3,13),(25769182,51371421,3,14),(25769182,51371422,3,15),(25769182,51371423,3,16),(25769182,51371425,3,17),(25769182,51371428,3,18),(25769182,51371430,3,19),(25769182,51371237,3,20),(25769229,281059700,3,1),(25769229,281059701,3,2),(25769229,281060136,3,3),(25769229,281059703,3,4),(25769229,281059704,3,5),(25769229,281060138,3,6),(25769229,281060139,3,7),(25769229,281059700,3,8),(25769702,281063471,3,1),(25769702,281063820,3,2),(25769702,281063821,3,3),(25769702,281063822,3,4),(25769702,281063857,3,5),(25769709,281063913,2,1),(25769709,281063895,2,2),(25769726,281063929,2,1),(25769726,281064107,2,2),(25769803,281064124,6,1),(25769803,281066356,6,2),(25769803,281064784,6,3),(25769803,281064525,6,4),(25769803,281064526,6,5),(25769803,281064785,6,6),(25769803,281064529,6,7),(25769803,281065980,6,8),(25769803,281064270,6,9),(25769803,281064271,6,10),(25769803,281064259,6,11),(25769803,281064260,6,12),(25769803,281064261,6,13),(25769803,281064262,6,14),(25769803,281064263,6,15),(25769822,281064535,1,1),(25769822,281065006,1,2),(25769829,281064785,3,1),(25769829,281065304,3,2),(25769829,281066086,3,3),(25769829,281065306,3,4),(25769829,281066349,3,5),(25769829,281065308,3,6),(25769891,281064262,1,1),(25769891,281065961,1,2),(25769891,281065962,1,3),(25769891,281065963,1,4),(25769891,281065964,1,5),(25769893,281064259,3,1),(25769893,281065978,3,2),(25769893,281066192,3,3),(25769893,281064533,3,4),(25769893,281064788,3,5),(25769893,281064535,3,6),(25769893,281064537,3,7),(25769893,281064789,3,8),(25769893,281064540,3,9),(25769893,281066153,3,10),(25769893,281064542,3,11),(25769893,51442532,3,12),(25769893,51442533,3,13),(25769922,281066192,2,1),(25769922,281066279,2,2),(25769970,281066356,4,1),(25769970,281066881,4,2),(25769970,281066882,4,3),(25769970,281066883,4,4),(25769970,281066884,4,5),(25769970,281066600,4,6),(25769970,281067340,4,7),(25769970,281067291,4,8),(25769970,281067341,4,9),(25769970,281066604,4,10),(25769970,281066666,4,11),(25769970,281067272,4,12),(25769970,281067342,4,13),(25769970,281066671,4,14),(25769970,281067274,4,15),(25769970,281066673,4,16),(25769970,281067343,4,17),(25769970,281066675,4,18),(25769970,281066676,4,19),(25769974,51385292,2,1),(25769974,281066629,2,2),(25769974,281069787,2,3),(25769974,281066631,2,4),(25769974,281069788,2,5),(25769974,281066633,2,6),(25770088,281066604,2,1),(25770088,281067289,2,2),(25770088,281066606,2,3),(25770088,281066607,2,4),(25770088,281066608,2,5),(25770088,281066609,2,6),(25770088,281066610,2,7),(25770088,281066889,2,8),(25770088,281066612,2,9),(25770088,281066613,2,10),(25770088,281066614,2,11),(25770088,51385295,2,12),(25770391,281064107,1,1),(25770391,281064789,1,2),(25770445,281070673,2,1),(25770445,281070966,2,2),(25770445,281071349,2,3),(25770445,281070968,2,4),(25770728,281073498,1,1),(25770728,281073499,1,2),(25770728,281073500,1,3),(25770728,281073501,1,4),(25770728,281073502,1,5),(25770728,281073503,1,6),(25770728,281073504,1,7),(25770728,281073498,1,8),(25770737,51444892,1,1),(25770737,51444894,1,2),(25770744,51444886,1,1),(25770744,51444888,1,2),(25770744,51444889,1,3),(25770744,281072460,1,4),(25770744,51444891,1,5),(25770744,51444892,1,6),(25770744,281073607,1,7),(25770744,281072602,1,8),(25770744,281073608,1,9),(25770744,281072600,1,10),(25770744,281072599,1,11),(25770744,51441623,1,12),(25770745,51445210,2,1),(25770745,51445113,2,2),(25770745,51444886,2,3),(25771015,51441850,1,1),(25771015,281076210,1,2),(25771015,281076211,1,3),(25771015,281076212,1,4),(25771015,281076213,1,5),(25771079,51441853,1,1),(25771079,281076688,1,2),(25771079,281076689,1,3),(25771079,281076690,1,4),(25771079,281076691,1,5),(25771079,281076692,1,6),(25771241,281080244,4,1),(25771241,281080196,4,2),(25771241,281079396,4,3),(25771241,281076912,4,4),(25771241,281079387,4,5),(25771241,281076910,4,6),(25771241,281079386,4,7),(25771241,281076908,4,8),(25771241,51441850,4,9),(25771241,281076692,4,10),(25771241,51441852,4,11),(25771241,51441853,4,12),(25771241,51441855,4,13),(25771241,51441857,4,14),(25771241,51441361,4,15),(25771241,51441364,4,16),(25771241,51441228,4,17),(25825533,51581795,1,1),(25825533,51581796,1,2),(25825533,51581799,1,3),(25825533,51581803,1,4),(25825533,51581807,1,5),(25825533,52166950,1,6),(26001987,52163588,2,1),(26001987,52163595,2,2),(26001987,52163602,2,3),(26001987,52163609,2,4),(26001987,52163613,2,5),(26001987,52163621,2,6),(26001987,52163631,2,7),(26001987,52163644,2,8),(26001987,52163664,2,9),(26001987,52164958,2,10),(26001987,52166749,2,11),(26002036,51587694,2,1),(26002036,266328982,2,2),(26002036,52163550,2,3),(26002036,266331233,2,4),(26002036,266331091,2,5),(26002036,52163556,2,6),(26002036,52163563,2,7),(26002036,52163574,2,8),(26002036,52163581,2,9),(26002036,52163588,2,10),(26243488,287396015,5,1),(26243488,51552605,5,2),(26243488,51552578,5,3),(26243488,51552581,5,4),(26243488,51552599,5,5),(26243488,51552583,5,6),(26243488,51552595,5,7),(26243488,51552587,5,8),(26243488,51552671,5,9),(26243488,51552612,5,10),(26243488,51552615,5,11),(26243488,51552619,5,12),(26243488,51552659,5,13),(26243488,51552622,5,14),(26243488,51552656,5,15),(26243488,51552664,5,16),(26243488,51552625,5,17),(26243488,51552628,5,18),(26243488,51552630,5,19),(26243488,51552633,5,20),(26243488,51552660,5,21),(26243488,51552635,5,22),(26243488,51552637,5,23),(26243488,51552667,5,24),(26243488,51552640,5,25),(26243488,287401324,5,26),(26243488,51552643,5,27),(26243488,51552645,5,28),(26243488,51552648,5,29),(26243488,51552651,5,30),(26243488,51552653,5,31),(26243488,51552672,5,32),(26243488,51552675,5,33),(26243488,51552679,5,34),(26243488,51552682,5,35),(26243488,51552686,5,36),(26243488,51552688,5,37),(26243488,51552691,5,38),(26243488,51552693,5,39),(26243488,51552694,5,40),(26243488,51552699,5,41),(26243488,51552702,5,42),(26243488,51552705,5,43),(26243488,51552707,5,44),(26243488,259475446,5,45),(26243488,51552709,5,46),(26243488,51552710,5,47),(26243488,51552711,5,48),(26243488,51552712,5,49),(26243488,51552715,5,50),(26243488,51552717,5,51),(26243488,51552720,5,52),(26243488,316951001,5,53),(26243488,51552722,5,54),(26243488,51552723,5,55),(26243488,270717289,5,56),(26243488,51552726,5,57),(26243488,51552727,5,58),(26243488,51552728,5,59),(26243488,51552731,5,60),(26243488,270716354,5,61),(26243488,51552733,5,62),(26243488,51581679,5,63),(26243580,287396015,4,1),(26243580,287397030,4,2),(26243580,287399092,4,3),(26243580,287395969,4,4),(26243580,287397028,4,5),(26243580,287399091,4,6),(26243580,287397023,4,7),(26243580,287399090,4,8),(26243580,287396015,4,9),(26243608,53306680,3,1),(26243608,53306683,3,2),(26243608,53306685,3,3),(26243608,53306687,3,4),(26243608,370003141,3,5),(26243681,53325663,1,1),(26243681,53319661,1,2),(26243681,53319659,1,3),(26243681,53319658,1,4),(26243681,53319657,1,5),(26243681,53319652,1,6),(26243681,53319651,1,7),(26243681,53319649,1,8),(26243681,53319648,1,9),(26243681,53319645,1,10),(26243681,53319643,1,11),(26243681,53319646,1,12),(26243681,53319642,1,13),(26243681,53319639,1,14),(26243681,53319638,1,15),(26243681,53319636,1,16),(26243681,53319634,1,17),(26243681,53319632,1,18),(26243681,53319631,1,19),(26243681,53319629,1,20),(26243681,53319627,1,21),(26243681,53319625,1,22),(26243681,53319624,1,23),(26243681,53319621,1,24),(26243681,53319619,1,25),(26243681,53319617,1,26),(26243681,53319616,1,27),(26243681,53319613,1,28),(26243681,53319612,1,29),(26243681,53319611,1,30),(26243681,53319610,1,31),(26243681,53319609,1,32),(26243681,53319607,1,33),(26243681,53319605,1,34),(26243681,53319603,1,35),(26243681,53319601,1,36),(26243681,53319600,1,37),(26243681,53319598,1,38),(26243681,53319596,1,39),(26243681,53319593,1,40),(26243681,53319592,1,41),(26243681,53319589,1,42),(26243681,53319587,1,43),(26243681,53319584,1,44),(26243681,53319581,1,45),(26243681,53319582,1,46),(26243681,51552599,1,47),(26243895,287403168,1,1),(26243895,287403171,1,2),(26243895,287403173,1,3),(26243895,287403175,1,4),(26243895,287403179,1,5),(26243895,287403168,1,6),(26455183,53294584,2,1),(26455183,53294581,2,2),(26455183,53294577,2,3),(26455183,53294573,2,4),(26455183,53294570,2,5),(26455183,53294566,2,6),(26455183,53294562,2,7),(26455183,53294560,2,8),(26455183,53294557,2,9),(26455183,53294552,2,10),(26455183,53294548,2,11),(26455183,53294545,2,12),(26455183,53294541,2,13),(26455183,53294540,2,14),(26455183,53294537,2,15),(26455183,53294534,2,16),(26455183,53294531,2,17),(26455183,53294530,2,18),(26455183,53294526,2,19),(26455183,53294523,2,20),(26455183,53294520,2,21),(26455183,53294515,2,22),(26455183,53294512,2,23),(26455183,53294508,2,24),(26455183,53294503,2,25),(26455183,53294500,2,26),(26455183,53294496,2,27),(26455183,53294493,2,28),(26455183,53294490,2,29),(26455183,53294487,2,30),(26455183,53294483,2,31),(26455183,53294479,2,32),(26455183,53294475,2,33),(26455183,53294474,2,34),(26455183,53294469,2,35),(26455183,53294466,2,36),(26455183,53294463,2,37),(26455183,53294458,2,38),(26455183,53294455,2,39),(26455183,53294450,2,40),(26455183,53294448,2,41),(26455183,53294444,2,42),(26455183,53294443,2,43),(26455183,53294436,2,44),(26455183,53294434,2,45),(26455183,53294433,2,46),(26455183,53294430,2,47),(26455183,53294429,2,48),(26455183,53294425,2,49),(26455183,53294423,2,50),(26455183,53294420,2,51),(26455183,53294418,2,52),(26455183,53294416,2,53),(26455183,53294411,2,54),(26455183,53294409,2,55),(26455183,53294404,2,56),(26455183,53294401,2,57),(26455183,53294396,2,58),(26455183,53294394,2,59),(26455183,53294392,2,60),(26455183,53294389,2,61),(26455183,53294385,2,62),(26455183,53294382,2,63),(26455183,53294377,2,64),(26455183,53294374,2,65),(26455183,53294371,2,66),(26455183,53294366,2,67),(26455183,53294364,2,68),(26455183,53294362,2,69),(26455183,53294357,2,70),(26455183,53294354,2,71),(26455183,53294352,2,72),(26455183,53294350,2,73),(26455183,53294347,2,74),(26455183,53294344,2,75),(26455183,53294341,2,76),(26455183,53294337,2,77),(26455183,53294335,2,78),(26455183,53294331,2,79),(26455183,53294327,2,80),(26455183,53294323,2,81),(26455183,53294320,2,82),(26455183,53294317,2,83),(26455183,53294314,2,84),(26455183,53294311,2,85),(26455183,53294308,2,86),(26455183,53294304,2,87),(26455183,53294300,2,88),(26455183,53294297,2,89),(26455183,53294293,2,90),(26455183,53294290,2,91),(26455183,53294285,2,92),(26455183,53294284,2,93),(26455183,53294279,2,94),(26455183,53294277,2,95),(26455183,53294273,2,96),(26455183,53294270,2,97),(26455183,53294268,2,98),(26455183,53294267,2,99),(26455183,53294264,2,100),(26455183,53294262,2,101),(26455183,53294260,2,102),(26455183,53294258,2,103),(26455183,53294255,2,104),(26455183,53294253,2,105),(26455183,53294251,2,106),(26455183,53294248,2,107),(26455183,53294245,2,108),(26455183,53294244,2,109),(26455183,53294241,2,110),(26455183,53294239,2,111),(26455183,53294236,2,112),(26455183,53294235,2,113),(26455183,53294233,2,114),(26455183,53294231,2,115),(26455183,53294228,2,116),(26455183,53294226,2,117),(26455183,53294221,2,118),(26455183,53294219,2,119),(26455183,53294218,2,120),(26455183,53294215,2,121),(26455183,53294213,2,122),(26455183,53294223,2,123),(26455183,53294212,2,124),(26455183,53294209,2,125),(26455183,53294207,2,126),(26455183,53294205,2,127),(26455183,53294202,2,128),(26455183,53294199,2,129),(26455183,53294197,2,130),(26455183,53294195,2,131),(26455183,53294194,2,132),(26455183,53294192,2,133),(26455183,53294189,2,134),(26455183,53294186,2,135),(26455183,53294184,2,136),(26455183,53294181,2,137),(26455183,53294180,2,138),(26455183,53294177,2,139),(26455183,53294174,2,140),(26455183,53294171,2,141),(26455183,53294170,2,142),(26455183,53294169,2,143),(26455183,53294168,2,144),(26455183,53294166,2,145),(26455183,53294165,2,146),(26455183,53294162,2,147),(26455183,53294160,2,148),(26455183,53294157,2,149),(26455183,53294154,2,150),(26455183,53294152,2,151),(26455183,53294149,2,152),(26455183,53294147,2,153),(26455183,53294144,2,154),(26455183,53294141,2,155),(26455183,53293510,2,156),(26455183,53293507,2,157),(26455183,53293505,2,158),(26455183,53293500,2,159),(26455183,53293232,2,160),(26455183,53293220,2,161),(26455183,53293217,2,162),(26455183,53293212,2,163),(26455183,53293205,2,164),(26455183,53293202,2,165),(26455183,53293200,2,166),(26455183,53293198,2,167),(26455183,53293197,2,168),(26455183,53293193,2,169),(26455183,53293192,2,170),(26455183,53293189,2,171),(26455183,53293188,2,172),(26455183,53293185,2,173),(26455183,53293183,2,174),(26455183,53293179,2,175),(26455183,53293177,2,176),(26455183,53293174,2,177),(26455183,53293172,2,178),(26455183,53293169,2,179),(26455183,53293167,2,180),(26455183,53293164,2,181),(26455183,53293162,2,182),(26455183,53293158,2,183),(26455183,53293157,2,184),(26455183,53293155,2,185),(26455183,53293153,2,186),(26455183,53293150,2,187),(26455183,53293148,2,188),(26455183,53293147,2,189),(26455183,53293144,2,190),(26455183,53293142,2,191),(26455183,53293137,2,192),(26455183,53293136,2,193),(26455183,53293132,2,194),(26455183,53293130,2,195),(26455183,53293127,2,196),(26455183,53293124,2,197),(26455183,53293123,2,198),(26455183,53293119,2,199),(26455183,53293117,2,200),(26455183,53293114,2,201),(26455183,53293111,2,202),(26455183,53293109,2,203),(26455183,53293108,2,204),(26455183,53293105,2,205),(26455183,53293102,2,206),(26455183,53293098,2,207),(26455183,53293097,2,208),(26455183,53293095,2,209),(26455183,53293092,2,210),(26455183,53293089,2,211),(26455183,53293087,2,212),(26455183,53293083,2,213),(26455183,53293082,2,214),(26455183,53293080,2,215),(26455183,53293077,2,216),(26455183,53293076,2,217),(26455183,53293073,2,218),(26455183,53293069,2,219),(26455183,53293067,2,220),(26455183,53293066,2,221),(26455183,53293063,2,222),(26455183,53293062,2,223),(26455183,53293060,2,224),(26455183,53293058,2,225),(26455183,53293046,2,226),(26455183,53293043,2,227),(26455183,53293039,2,228),(26455183,53293037,2,229),(26455183,53293034,2,230),(26455183,53293032,2,231),(26455183,53293029,2,232),(26455183,53293027,2,233),(26455183,53293025,2,234),(26455183,53293022,2,235),(26455183,53293018,2,236),(26455183,53293017,2,237),(26455183,53293015,2,238),(26455183,53293011,2,239),(26455183,53293010,2,240),(26455183,53293007,2,241),(26455183,53293003,2,242),(26455183,53293001,2,243),(26455183,53292997,2,244),(26455183,53292938,2,245),(26455183,53292901,2,246),(26455183,53288318,2,247),(26455183,53288317,2,248),(26455183,53288313,2,249),(26455183,53288310,2,250),(26455183,53288309,2,251),(26455183,53288308,2,252),(26455183,53288305,2,253),(26455183,53288303,2,254),(26455183,53288302,2,255),(26455183,53288300,2,256),(26455183,53288298,2,257),(26455183,53288296,2,258),(26455183,53288294,2,259),(26455183,53288292,2,260),(26455183,53288290,2,261),(26455183,53288286,2,262),(26455183,53288282,2,263),(26455183,53288281,2,264),(26455183,53288280,2,265),(26455183,53288278,2,266),(26455183,53288276,2,267),(26455183,53288273,2,268),(26455183,53288271,2,269),(26455183,53288269,2,270),(26455183,53288266,2,271),(26455183,53288263,2,272),(26455183,53288262,2,273),(26455183,53288261,2,274),(26455183,53288346,2,275),(26455183,53288259,2,276),(26455183,53288257,2,277),(26455183,53288255,2,278),(26455183,53288253,2,279),(26455183,53288250,2,280),(26455183,53288247,2,281),(26455183,53288245,2,282),(26455183,53288242,2,283),(26455183,53288239,2,284),(26455183,53288238,2,285),(26455183,53288235,2,286),(26455183,53288231,2,287),(26455183,53288229,2,288),(26455183,53288228,2,289),(26455183,53288227,2,290),(26455183,53288225,2,291),(26455183,53288223,2,292),(26455183,53288220,2,293),(26455183,53288219,2,294),(26455183,53288216,2,295),(26455183,53288213,2,296),(26455183,53288210,2,297),(26455183,53288209,2,298),(26455183,53288206,2,299),(26455183,53288203,2,300),(26455183,53288201,2,301),(26455183,53288199,2,302),(26455183,53288198,2,303),(26455183,53288196,2,304),(26455183,53288194,2,305),(26455183,53288191,2,306),(26455183,53288189,2,307),(26455183,53288187,2,308),(26455183,53288184,2,309),(26455183,53288182,2,310),(26455183,53288180,2,311),(26455183,53288178,2,312),(26455183,53288176,2,313),(26455183,53288174,2,314),(26455183,53288173,2,315),(26455183,53288171,2,316),(26455183,53288168,2,317),(26455183,53288166,2,318),(26455183,53288164,2,319),(26455183,53288161,2,320),(26455183,53288160,2,321),(26455183,53288157,2,322),(26455183,270731119,2,323),(26553947,51952643,3,1),(26553947,51952647,3,2),(26553947,51952649,3,3),(26553947,51952652,3,4),(26553947,51952653,3,5),(26553947,51952656,3,6),(26553947,51952659,3,7),(26553947,51952662,3,8),(26553947,51952665,3,9),(26553947,51952667,3,10),(26553947,51952668,3,11),(26553947,51952671,3,12),(26553947,51952672,3,13),(26553947,51952675,3,14),(26553947,51952677,3,15),(26553947,51952682,3,16),(26553947,51952684,3,17),(26553947,51952686,3,18),(26553947,51952689,3,19),(26553947,51952690,3,20),(26553947,51952692,3,21),(26553947,51952694,3,22),(26553947,51952695,3,23),(26553947,51952699,3,24),(26553947,51952701,3,25),(26553947,51952702,3,26),(26553947,51952705,3,27),(26553947,51952706,3,28),(26553947,51952709,3,29),(26553947,51952712,3,30),(26553947,51952714,3,31),(26553947,51952715,3,32),(26553947,51952717,3,33),(26553947,51952719,3,34),(26553947,51952722,3,35),(26553947,51952724,3,36),(26553947,51952727,3,37),(26553947,51952729,3,38),(26553947,51952732,3,39),(26553947,51952733,3,40),(26553947,51952737,3,41),(26553947,51952740,3,42),(26553947,51952742,3,43),(26553947,51952745,3,44),(26553947,51952748,3,45),(26553947,51952751,3,46),(26553947,51952754,3,47),(26553947,51952756,3,48),(26553947,51952758,3,49),(26553947,51952761,3,50),(26553947,51952764,3,51),(26553947,51952767,3,52),(26553947,51952770,3,53),(26553947,51952772,3,54),(26553947,51952775,3,55),(26553947,51952777,3,56),(26553947,51952780,3,57),(26553947,51952782,3,58),(26553947,51952784,3,59),(26553947,51952786,3,60),(26553947,51952788,3,61),(26553947,51952790,3,62),(26553947,51952792,3,63),(26553947,51952795,3,64),(26553947,51952797,3,65),(26553947,51952800,3,66),(26553947,51952802,3,67),(26553947,51952804,3,68),(26553947,51952807,3,69),(26553947,51952811,3,70),(26553947,51952813,3,71),(26553947,51952815,3,72),(26553947,51952818,3,73),(26553947,51952820,3,74),(26553947,51952824,3,75),(26553947,51952827,3,76),(26553947,51952829,3,77),(26553947,51952831,3,78),(26553947,51952832,3,79),(26553947,51952834,3,80),(26553947,51952837,3,81),(26553947,51952840,3,82),(26553947,51952842,3,83),(26553947,51952844,3,84),(26554007,291063328,1,1),(26554007,291063330,1,2),(26554007,291063331,1,3),(26554007,291063333,1,4),(26554007,291063334,1,5),(26554007,291063335,1,6),(26554007,291063336,1,7),(26554007,291063337,1,8),(26554007,291063338,1,9),(26554007,291063328,1,10),(26668563,51390016,4,1),(26668563,51118191,4,2),(26668563,51391067,4,3),(26668563,51118192,4,4),(26668563,51118193,4,5),(26668563,51118194,4,6),(27826413,52613274,2,1),(27826413,52613277,2,2),(27826413,52613279,2,3),(27826413,52613282,2,4),(27826413,52613285,2,5),(27826413,52613288,2,6),(27826413,52613289,2,7),(27826413,52613292,2,8),(27826413,52613295,2,9),(27826413,52613297,2,10),(27826413,52613300,2,11),(27826413,52613301,2,12),(27826413,52613303,2,13),(27826413,52613304,2,14),(27826413,52613306,2,15),(27826413,52613309,2,16),(27826413,52613310,2,17),(27826413,52613312,2,18),(27826413,52613314,2,19),(27826413,52613317,2,20),(27826413,52613318,2,21),(27826413,52613320,2,22),(27826413,52613323,2,23),(27826413,52613325,2,24),(27826413,52613330,2,25),(27826413,52613332,2,26),(28828385,316946989,1,1),(28828385,316946990,1,2),(28828385,316946991,1,3),(28828385,316946992,1,4),(28828388,316946992,2,1),(28828388,316947014,2,2),(28828388,316947015,2,3),(28828388,316947016,2,4),(28828388,316947017,2,5),(28828789,316949605,1,1),(28828789,316949604,1,2),(28828789,316949603,1,3),(28828789,316947017,1,4),(28828789,316950996,1,5),(28828789,316950997,1,6),(28828789,316950998,1,7),(28828789,316950999,1,8),(28828789,316951000,1,9),(28828789,316951001,1,10),(28829736,316961219,1,1),(28829736,316961221,1,2),(28829736,316961223,1,3),(28829736,316961225,1,4),(28829748,316961289,6,1),(28829748,316961291,6,2),(28829748,316961294,6,3),(28829748,319543646,6,4),(28829748,316961244,6,5),(28829748,319541450,6,6),(28829748,316961245,6,7),(28829748,316961246,6,8),(28829748,316961247,6,9),(28829753,316961244,5,1),(28829753,316961331,5,2),(28829753,316961332,5,3),(28829753,316961335,5,4),(28829753,316961337,5,5),(28829753,316961339,5,6),(28829753,316961341,5,7),(28829753,316961342,5,8),(28829753,316961343,5,9),(28829753,316961219,5,10),(28829753,316961344,5,11),(28829753,316961345,5,12),(28829753,316961346,5,13),(28829766,316961407,7,1),(28829766,319538722,7,2),(28829766,319538724,7,3),(28829766,319538726,7,4),(28829766,319538728,7,5),(28829766,319538731,7,6),(28829766,319538733,7,7),(28829766,319538735,7,8),(28829766,316961518,7,9),(28829766,316961289,7,10),(28829766,316963054,7,11),(28829773,316961406,2,1),(28829773,316961375,2,2),(28829773,316961407,2,3),(28829773,316961408,2,4),(28829773,316961409,2,5),(28829773,316961410,2,6),(28829773,316961411,2,7),(28829773,316961412,2,8),(28829773,316961413,2,9),(28829773,316961414,2,10),(28829773,316961415,2,11),(28829773,316961416,2,12),(28829773,316961417,2,13),(28829773,316961418,2,14),(28829773,316961419,2,15),(28829773,316961420,2,16),(28829773,316961421,2,17),(28829779,316961468,1,1),(28829779,316961469,1,2),(28829779,316961471,1,3),(28829779,316961421,1,4),(28829779,316961473,1,5),(28829779,316961475,1,6),(28829779,316961477,1,7),(28829779,316961478,1,8),(28829779,316961480,1,9),(28829779,316961481,1,10),(28829779,316961483,1,11),(28829779,316961484,1,12),(28829779,316961410,1,13),(28829779,316961486,1,14),(28829910,316961346,1,1),(28829910,316962617,1,2),(28829910,316962618,1,3),(28829910,316962619,1,4),(28829910,316962620,1,5),(28829910,316962621,1,6),(28829910,316962622,1,7),(28829910,316962623,1,8),(28829910,316962624,1,9),(28829910,316962625,1,10),(28829910,316962626,1,11),(28829910,316962627,1,12),(28829910,316962628,1,13),(28829910,316961406,1,14),(28829964,316961352,1,1),(28829964,316962619,1,2),(28829967,316963054,3,1),(28829967,316961349,3,2),(28829967,316961350,3,3),(28829967,316961351,3,4),(28829967,316961352,3,5),(28832922,316985238,1,1),(28832922,316985239,1,2),(28832923,316961247,2,1),(28832923,316985238,2,2),(28833468,259986469,4,1),(28833468,259986468,4,2),(28833468,259986467,4,3),(28833468,259986466,4,4),(28833468,259986465,4,5),(28833468,259986464,4,6),(28833468,259986463,4,7),(28833468,259986462,4,8),(28833468,259986461,4,9),(28833468,259986460,4,10),(28833770,51118205,4,1),(28833770,51118206,4,2),(28833770,51118207,4,3),(28833770,51118208,4,4),(28833770,51118209,4,5),(28833770,51118210,4,6),(28833770,51118211,4,7),(28833880,51118135,4,1),(28833880,51118136,4,2),(28833880,51118137,4,3),(28833880,51118138,4,4),(28833880,51118140,4,5),(28833880,51118141,4,6),(28833880,51118142,4,7),(28833880,51118143,4,8),(28833880,51118144,4,9),(28833880,51118145,4,10),(28833880,51118146,4,11),(28833880,51118148,4,12),(28833880,51118149,4,13),(28833880,51118150,4,14),(28833880,51118151,4,15),(28833880,51118152,4,16),(28833880,51118153,4,17),(28833880,51118155,4,18),(28833880,51118156,4,19),(28833880,51118157,4,20),(28833924,51118654,2,1),(28833924,51118655,2,2),(28833924,51118656,2,3),(28833924,51118658,2,4),(28833924,51118659,2,5),(28833924,51118661,2,6),(28833924,51118662,2,7),(28833924,51118663,2,8),(28833924,51118664,2,9),(28833924,51118666,2,10),(28833924,51118667,2,11),(28833924,51118668,2,12),(28833924,51118669,2,13),(28833924,51118671,2,14),(28833924,51118263,2,15),(28833924,51118071,2,16),(28833924,51118073,2,17),(28833924,51118074,2,18),(28833924,51118076,2,19),(28833927,206333343,3,1),(28833927,206333352,3,2),(28833927,206333048,3,3),(28833927,206333355,3,4),(28833927,206333356,3,5),(28833927,206333118,3,6),(28833927,206333124,3,7),(28833927,206333120,3,8),(28833927,206333119,3,9),(28833927,206333194,3,10),(28833927,206333041,3,11),(28833927,206333043,3,12),(28833927,206333618,3,13),(28833927,206333525,3,14),(28833927,206330752,3,15),(28833927,206333534,3,16),(28833927,206333353,3,17),(28833927,206333344,3,18),(28833927,206333171,3,19),(28833927,206333617,3,20),(28833927,51118653,3,21),(28833927,51118654,3,22),(28833935,51119127,2,1),(28833935,51119128,2,2),(28833935,51119129,2,3),(28833935,51119130,2,4),(28833935,51119131,2,5),(28833935,51118641,2,6),(28833935,51118642,2,7),(28833935,206332846,2,8),(28833935,206330773,2,9),(28833935,206333191,2,10),(28833935,206333347,2,11),(28833935,206333343,2,12),(28833936,51119121,3,1),(28833936,51119123,3,2),(28833936,51119124,3,3),(28833936,51119125,3,4),(28833936,51119126,3,5),(28833936,51119127,3,6),(28833957,51119112,2,1),(28833957,51119113,2,2),(28833957,51119114,2,3),(28833957,51119116,2,4),(28833957,51119117,2,5),(28833957,51119118,2,6),(28833957,51119119,2,7),(28833957,51119120,2,8),(28833957,51119121,2,9),(28833958,51119105,3,1),(28833958,51119106,3,2),(28833958,51119107,3,3),(28833958,51119108,3,4),(28833958,51119109,3,5),(28833958,51119110,3,6),(28833958,51119111,3,7),(28833958,51119112,3,8),(29051459,316961518,6,1),(29051459,319543280,6,2),(29051459,319541439,6,3),(29051459,319541441,6,4),(29051459,319541444,6,5),(29051459,319541446,6,6),(29051459,319541448,6,7),(29051459,316961244,6,8),(29249135,321679128,2,1),(29249135,321679131,2,2),(29249135,321679133,2,3),(29249135,321679135,2,4),(29249135,321679137,2,5),(29249135,321679139,2,6),(29249135,321679141,2,7),(29249135,321679143,2,8),(29249135,321679145,2,9),(29249135,321679147,2,10),(29249135,321679148,2,11),(29249135,321679150,2,12),(29249135,321679151,2,13),(29249135,321679152,2,14),(29249135,321679154,2,15),(29249135,321679155,2,16),(29249135,321679156,2,17),(29249135,321679157,2,18),(29249135,321679159,2,19),(29249135,321679160,2,20),(29249135,321679161,2,21),(29249135,321679162,2,22),(29249135,321679163,2,23),(29249135,321679164,2,24),(29249135,321679165,2,25),(29249135,321679166,2,26),(29249135,321679170,2,27),(29249135,321679176,2,28),(29249135,321679180,2,29),(29249135,321679181,2,30),(29249135,321679182,2,31),(29249135,321679183,2,32),(29249135,321679184,2,33),(29249135,321679185,2,34),(29249135,321679186,2,35),(29249135,321679188,2,36),(29249135,321679189,2,37),(29249135,321679190,2,38),(29249135,321679191,2,39),(29249135,321679196,2,40),(29249135,321679197,2,41),(29249135,321679198,2,42),(29249135,321679199,2,43),(29249135,321679200,2,44),(29249135,321679202,2,45),(29249135,321679203,2,46),(29249135,321679204,2,47),(29249135,321679205,2,48),(29249135,321679206,2,49),(29249135,321679207,2,50),(29249135,321679208,2,51),(29249135,321679209,2,52),(29249135,321679210,2,53),(29249135,321679212,2,54),(29249135,321679213,2,55),(29249135,321679214,2,56),(29249135,321679215,2,57),(29249135,321679216,2,58),(29249135,321679217,2,59),(29249135,321679218,2,60),(29249135,321679219,2,61),(29249135,321679220,2,62),(29249135,321679221,2,63),(29249135,321679223,2,64),(29249135,321679224,2,65),(29249135,321679225,2,66),(29249135,321679226,2,67),(29249135,321679227,2,68),(29249135,321679228,2,69),(29249135,321679229,2,70),(29249135,321679230,2,71),(29249135,321679231,2,72),(29249135,321679233,2,73),(29249135,321679234,2,74),(29249135,321679236,2,75),(29249135,321679237,2,76),(29249135,321679238,2,77),(29249135,321679240,2,78),(29249135,321679242,2,79),(29249135,321679245,2,80),(29249135,321679247,2,81),(29249135,321679250,2,82),(29249135,321679252,2,83),(29249135,321679254,2,84),(29249135,321679255,2,85),(29249135,321679257,2,86),(29249135,321679260,2,87),(29249135,321679263,2,88),(29249135,321679266,2,89),(29249135,321679268,2,90),(29249135,321679271,2,91),(29249135,321679273,2,92),(29249135,321679275,2,93),(29249135,321679278,2,94),(29249135,321679281,2,95),(29249135,321679283,2,96),(29249135,321679286,2,97),(29249135,321679288,2,98),(29249135,321679290,2,99),(29249135,321679293,2,100),(29249135,321679295,2,101),(29249135,321679296,2,102),(29249135,321679298,2,103),(29249135,321679300,2,104),(29249135,321679302,2,105),(29249135,321679304,2,106),(29249135,321679306,2,107),(29249135,321679308,2,108),(29249135,321679309,2,109),(29249135,321679311,2,110),(29249135,321679313,2,111),(29249135,321679316,2,112),(29249135,321679318,2,113),(29249135,321679320,2,114),(29249135,321679322,2,115),(29249135,321679324,2,116),(29249135,321679326,2,117),(29249136,321679489,2,1),(29249136,321679518,2,2),(29249136,321679519,2,3),(29249136,321679520,2,4),(29249136,321679521,2,5),(29249136,321679522,2,6),(29249136,321679523,2,7),(29249136,321679524,2,8),(29249136,321679525,2,9),(29249136,321679526,2,10),(29249136,321679527,2,11),(29249136,321679528,2,12),(29249136,321679529,2,13),(29249136,321679530,2,14),(29249136,321679536,2,15),(29249136,321679543,2,16),(29249136,321679544,2,17),(29249136,321679545,2,18),(29249136,321679546,2,19),(29249136,321679549,2,20),(29249136,321679550,2,21),(29249136,321679551,2,22),(29249136,321679552,2,23),(29249136,321679553,2,24),(29249136,321679554,2,25),(29249136,321679555,2,26),(29249136,321679556,2,27),(29249136,321679557,2,28),(29249136,321679558,2,29),(29249136,321679559,2,30),(29249136,321679560,2,31),(29249136,321679561,2,32),(29249136,321679562,2,33),(29249136,321679563,2,34),(29249136,321679564,2,35),(29249136,321679565,2,36),(29249136,321679566,2,37),(29249136,321679567,2,38),(29249136,321679568,2,39),(29249700,262461660,3,1),(29249700,321683315,3,2),(29249700,321683317,3,3),(29249700,321683319,3,4),(29249700,321683321,3,5),(29249700,321683323,3,6),(29249700,321683326,3,7),(29249700,321683328,3,8),(29249700,321683330,3,9),(29249700,321683332,3,10),(29249700,321683334,3,11),(29249700,321683336,3,12),(29249700,321683338,3,13),(29249700,321683341,3,14),(29249700,321683343,3,15),(29249700,321683345,3,16),(29249700,321683347,3,17),(29249700,321683349,3,18),(29249700,321683351,3,19),(29249700,321683353,3,20),(29249700,321683355,3,21),(29249700,321683357,3,22),(29249700,321683358,3,23),(29249700,321683359,3,24),(29249700,321683360,3,25),(29249700,321683361,3,26),(29249700,321683362,3,27),(29249700,321683363,3,28),(29249700,321683364,3,29),(29249700,321683365,3,30),(29249700,321683366,3,31),(29249700,321683367,3,32),(29249700,321683368,3,33),(29249700,321683369,3,34),(29249700,321683370,3,35),(29249700,321683371,3,36),(29249700,321683372,3,37),(29249700,321683373,3,38),(29249700,321683374,3,39),(29249700,321683375,3,40),(29249700,321683376,3,41),(29249700,321683377,3,42),(29249700,321683378,3,43),(29249700,321683379,3,44),(29249700,321683380,3,45),(29249700,321683381,3,46),(29249700,321683382,3,47),(29249700,321683383,3,48),(29249700,321683384,3,49),(29249700,321683385,3,50),(29249700,321683386,3,51),(29249700,321683387,3,52),(29249700,321683388,3,53),(29249700,321683389,3,54),(29249700,321683390,3,55),(29249700,321683391,3,56),(29249700,321683392,3,57),(29249700,321683393,3,58),(29249700,321683394,3,59),(29249700,321683395,3,60),(29249700,321683396,3,61),(29249700,321683397,3,62),(29249700,321683398,3,63),(29249700,321683399,3,64),(29249700,321683400,3,65),(29249700,321683401,3,66),(29249700,321683402,3,67),(29249700,321683403,3,68),(29249700,321683405,3,69),(29249700,321683407,3,70),(29249700,321683408,3,71),(29249700,321683409,3,72),(29249700,321683410,3,73),(29249700,321683411,3,74),(29249700,321683412,3,75),(29249700,321683413,3,76),(29249700,321683414,3,77),(29249700,321683415,3,78),(29249700,321683416,3,79),(29249700,321683417,3,80),(29249700,321683418,3,81),(29249700,321683419,3,82),(29249700,321683420,3,83),(29249700,321683421,3,84),(29249700,321683422,3,85),(29249700,321683423,3,86),(29249700,321683424,3,87),(29249700,321683425,3,88),(29249700,321683426,3,89),(29249700,321683427,3,90),(29249700,321683428,3,91),(29249700,321683429,3,92),(29249700,321683430,3,93),(29249700,321683431,3,94),(29249700,321683432,3,95),(29249700,321683434,3,96),(29249700,321683436,3,97),(29249700,321683438,3,98),(29249700,321683440,3,99),(29249700,321683441,3,100),(29249700,321683443,3,101),(29249700,321683445,3,102),(29249700,321683447,3,103),(29249700,321683448,3,104),(29249700,321683449,3,105),(29249700,321683450,3,106),(29249700,321683451,3,107),(29249700,321683452,3,108),(29249700,321683453,3,109),(29249700,321683454,3,110),(29249700,321683455,3,111),(29249700,321683456,3,112),(29249700,321683457,3,113),(29249700,321683458,3,114),(29249700,321683459,3,115),(29249700,321683460,3,116),(29249700,321683461,3,117),(29249700,321683462,3,118),(29249700,321683463,3,119),(29249700,321683464,3,120),(29249700,321683465,3,121),(29249700,321683466,3,122),(29249700,321683467,3,123),(29249700,321683468,3,124),(29249700,321683469,3,125),(29249700,321683470,3,126),(29249700,321683471,3,127),(29249700,321683472,3,128),(29249700,321683473,3,129),(29249700,321683474,3,130),(29249700,321683475,3,131),(29249700,321683476,3,132),(29249700,321683477,3,133),(29249700,321683478,3,134),(29249700,321683479,3,135),(29249700,321683480,3,136),(29249700,321683481,3,137),(29249700,321683482,3,138),(29249700,321683483,3,139),(29249700,321683484,3,140),(29249700,321683485,3,141),(29249700,321683486,3,142),(29249700,321683487,3,143),(29249700,321683488,3,144),(29249700,321683489,3,145),(29249700,321683490,3,146),(29249700,321683491,3,147),(29249700,321683492,3,148),(29249700,321683493,3,149),(29249700,321683494,3,150),(29249700,321683495,3,151),(29249700,321683496,3,152),(29249700,321683497,3,153),(29249700,321683498,3,154),(29249700,321683499,3,155),(29249700,321683500,3,156),(29249700,321683501,3,157),(29249700,321683502,3,158),(29249700,321683503,3,159),(29249700,321683504,3,160),(29249700,321683505,3,161),(29249700,321683506,3,162),(29249700,321683507,3,163),(29249700,321683508,3,164),(29249700,321683509,3,165),(29249700,321683510,3,166),(29249700,321683511,3,167),(29249700,321683512,3,168),(29249700,321683513,3,169),(29249700,321683514,3,170),(29249700,321683515,3,171),(29249700,321683516,3,172),(29249700,321683517,3,173),(29249700,321683518,3,174),(29249700,321683519,3,175),(29249700,321683520,3,176),(29249700,321683521,3,177),(29249700,321683522,3,178),(29249700,321683523,3,179),(29249700,321683524,3,180),(29249700,321683525,3,181),(29249700,321683526,3,182),(29249700,321683527,3,183),(29249700,321683528,3,184),(29249700,321683529,3,185),(29249700,321683530,3,186),(29249700,321683532,3,187),(29249700,321683533,3,188),(29249700,321683534,3,189),(29249700,321683535,3,190),(29249700,321683536,3,191),(29249700,321683537,3,192),(29249700,321683538,3,193),(29249700,321683539,3,194),(29249700,321683540,3,195),(29249700,321683541,3,196),(29249700,321683542,3,197),(29249700,321683543,3,198),(29249700,321683544,3,199),(29376254,323129883,3,1),(29376254,323129885,3,2),(29376356,323130871,4,1),(29376356,323130873,4,2),(29376448,323131766,1,1),(29376448,323131768,1,2),(29422567,51438632,2,1),(29422567,51438634,2,2),(29422567,51438635,2,3),(29422567,51438636,2,4),(29422567,51438638,2,5),(29422567,51438639,2,6),(29422567,51438642,2,7),(29422567,51438643,2,8),(29422567,51438645,2,9),(29422567,51438646,2,10),(29422567,51438647,2,11),(29422567,51438648,2,12),(29422567,51438650,2,13),(29422567,51438812,2,14),(29422567,51438651,2,15),(29422567,51438652,2,16),(29422567,51438654,2,17),(29422567,51438655,2,18),(29422567,51438656,2,19),(29422567,51438658,2,20),(29422567,51438659,2,21),(29422567,51438660,2,22),(29422567,51438661,2,23),(29422567,51438662,2,24),(29422567,51438663,2,25),(29422567,51438665,2,26),(29422567,51438666,2,27),(30139079,266332083,1,1),(30139079,332119286,1,2),(30139079,332119287,1,3),(30139079,332119288,1,4),(30139079,332119289,1,5),(30139079,332119290,1,6),(30139079,332119070,1,7),(30139093,266332087,2,1),(30139093,332119414,2,2),(30139093,332119415,2,3),(30139093,332119416,2,4),(30139093,332119417,2,5),(30139093,332119418,2,6),(30139093,332119076,2,7),(30139242,332119070,1,1),(30139242,332119071,1,2),(30139242,332119072,1,3),(30139242,332119073,1,4),(30139242,332119074,1,5),(30139242,332119075,1,6),(30139242,332119076,1,7),(30139242,332122179,1,8),(30139242,332122180,1,9),(30139242,332122181,1,10),(30139242,332122182,1,11),(30139242,332122183,1,12),(30139242,332122184,1,13),(30139242,332122185,1,14),(30139242,332122186,1,15),(30139242,332122187,1,16),(30139242,332122188,1,17),(30139242,332122189,1,18),(30139242,332121137,1,19),(30139403,332126612,1,1),(30139403,332126613,1,2),(30139403,332126614,1,3),(30139403,332126615,1,4),(30139403,332125718,1,5),(30139408,316946992,1,1),(30139408,332126684,1,2),(30139408,332126685,1,3),(30139408,332126688,1,4),(30139408,332126689,1,5),(30139408,332126612,1,6),(30567238,337742674,1,1),(30567238,337775423,1,2),(30567238,337775425,1,3),(30567238,337775428,1,4),(30567542,51405263,2,1),(30567542,337782221,2,2),(30567542,337782224,2,3),(30567542,337781593,2,4),(30567542,337767559,2,5),(30571624,337833707,2,1),(30571624,337833711,2,2),(30571624,337833715,2,3),(30572100,337840780,1,1),(30572100,337840784,1,2),(30572100,337840789,1,3),(30572100,337840791,1,4),(30572100,337840797,1,5),(30572100,337840800,1,6),(30572100,337840804,1,7),(30572100,337840809,1,8),(30572100,337840812,1,9),(30572100,337840815,1,10),(30572100,337840821,1,11),(30572100,337833715,1,12),(30572104,337833715,2,1),(30572104,337840888,2,2),(30572116,337840888,2,1),(30572116,337840981,2,2),(30572116,337840986,2,3),(30572116,337840989,2,4),(30572138,337840989,1,1),(30572138,337841272,1,2),(30572138,337841280,1,3),(30572145,337841280,2,1),(30572145,337841383,2,2),(30572187,337841643,1,1),(30572187,337841646,1,2),(30572187,337841651,1,3),(30572187,337841655,1,4),(30572187,337841658,1,5),(30572187,337841661,1,6),(30605340,338420420,3,1),(30605340,338420421,3,2),(30605340,338420422,3,3),(30605340,338420423,3,4),(30605340,338420424,3,5),(30605340,338420425,3,6),(30605340,338420426,3,7),(30605340,338420420,3,8),(30605380,338418932,2,1),(30605380,338420688,2,2),(30605380,338420689,2,3),(30605380,338420690,2,4),(30605380,338420691,2,5),(30605380,338420692,2,6),(30605380,338420693,2,7),(30605380,338420694,2,8),(30605380,338420695,2,9),(30605380,338420696,2,10),(30605380,338420697,2,11),(30605380,338420698,2,12),(30605380,338420699,2,13),(30605380,338420700,2,14),(30605380,338420701,2,15),(30605380,338420702,2,16),(30605457,262462280,2,1),(30605457,338422550,2,2),(30605457,338422551,2,3),(30605650,338425045,1,1),(30605650,338425046,1,2),(30605670,338425186,3,1),(30605670,338425409,3,2),(30605670,338425046,3,3),(30605680,338425484,2,1),(30605680,338425485,2,2),(30605680,338425486,2,3),(30605683,338425484,2,1),(30605683,338425556,2,2),(30605683,338425045,2,3),(30605683,338425558,2,4),(30605683,338425560,2,5),(30605683,338425561,2,6),(30605683,338425186,2,7),(30605683,338425562,2,8),(30605683,53327626,2,9),(30605686,338425046,1,1),(30605686,338425567,1,2),(30605686,338425484,1,3),(30605697,338425636,1,1),(30605697,338425637,1,2),(30605697,338425638,1,3),(30605697,338425639,1,4),(30605697,338425640,1,5),(30605697,338425642,1,6),(30605697,338425643,1,7),(30605697,338425644,1,8),(30605697,338425645,1,9),(30605697,338425647,1,10),(30605697,338425648,1,11),(30605698,338425648,1,1),(30605698,338425715,1,2),(30605698,338425717,1,3),(30605698,338425046,1,4),(30605769,338422551,1,1),(30605769,338426328,1,2),(30605769,338426330,1,3),(30605769,338426331,1,4),(30605769,338426332,1,5),(30605769,338426338,1,6),(30605769,338426339,1,7),(30605769,338426340,1,8),(30605769,338426341,1,9),(30605769,338426342,1,10),(30605769,338426343,1,11),(30605769,338426344,1,12),(30605769,338426345,1,13),(30605769,338426346,1,14),(30605769,338426347,1,15),(30605769,338425636,1,16),(30772650,340304066,1,1),(30772650,340304067,1,2),(30772650,340304068,1,3),(30772650,340304069,1,4),(30772650,340304066,1,5),(30772702,340304325,1,1),(30772702,340304326,1,2),(30772702,340304327,1,3),(30772702,340304328,1,4),(30772702,340304329,1,5),(30772702,340304325,1,6),(30922493,337739581,2,1),(30922493,51400259,2,2),(30922493,51410233,2,3),(30922493,51410286,2,4),(30922493,51400263,2,5),(30922528,51400272,1,1),(30922528,51400273,1,2),(30922528,51400276,1,3),(30922528,51400277,1,4),(30922528,51400280,1,5),(30922528,51400281,1,6),(31348544,52579373,5,1),(31348544,52579376,5,2),(31348544,52579377,5,3),(31348544,52579379,5,4),(31348544,52579381,5,5),(31348544,52579383,5,6),(31348544,52579386,5,7),(31348544,52579387,5,8),(31348544,52579389,5,9),(31348544,52579390,5,10),(31348544,52579393,5,11),(31348544,52579395,5,12),(31348544,52579397,5,13),(31348544,52579399,5,14),(31348544,52579401,5,15),(31348544,52579402,5,16),(31348544,52579405,5,17),(31348544,52579406,5,18),(31348544,52579409,5,19),(31348544,52579410,5,20),(31348544,52579413,5,21),(31348544,52579415,5,22),(31348544,52579416,5,23),(31348544,52579418,5,24),(31348544,52579420,5,25),(31348544,52594915,5,26),(31348544,52594920,5,27),(31348544,52594929,5,28),(31348544,52594931,5,29),(31348544,52594940,5,30),(31348544,52594946,5,31),(31348544,52594954,5,32),(31348544,52594957,5,33),(31348544,52594959,5,34),(31348544,52594963,5,35),(31348544,52594965,5,36),(31348544,52594968,5,37),(31348544,52594974,5,38),(31348544,52594977,5,39),(31348544,52594982,5,40),(31348544,52594985,5,41),(31348544,52594988,5,42),(31348544,52594989,5,43),(31348544,52594992,5,44),(31348544,52594994,5,45),(31348544,52594997,5,46),(31348544,52594999,5,47),(31348544,52595005,5,48),(31348544,52595009,5,49),(31348544,52595015,5,50),(31348544,52595021,5,51),(31348544,52595029,5,52),(31348544,52595034,5,53),(31348544,52595041,5,54),(31348544,52595042,5,55),(31348544,52595047,5,56),(31348544,52595051,5,57),(31348544,52595054,5,58),(31348544,52595059,5,59),(31348544,52595062,5,60),(31348544,52595064,5,61),(31348544,52595067,5,62),(31348544,52595070,5,63),(31348544,52595073,5,64),(31348544,52595074,5,65),(31348544,52595077,5,66),(31348544,52595079,5,67),(31348544,52595082,5,68),(31348544,52595084,5,69),(31348544,52595087,5,70),(31348544,52595090,5,71),(31348544,52595093,5,72),(31348544,52595096,5,73),(31348544,52595100,5,74),(31348544,52595103,5,75),(31348544,52595106,5,76),(31348544,52595107,5,77),(31348544,52595115,5,78),(31348544,52595118,5,79),(31348544,52595122,5,80),(31348544,52595125,5,81),(31348633,349146313,2,1),(31348633,349146314,2,2),(31348633,349146315,2,3),(31348633,349146316,2,4),(31726348,354962604,4,1),(31726348,51581699,4,2),(31726372,354962603,3,1),(31726372,354962622,3,2),(31726372,354962620,3,3),(31726372,354962618,3,4),(31726372,354962614,3,5),(31726372,354962612,3,6),(31726372,354962610,3,7),(31726372,354962608,3,8),(31726372,354962605,3,9),(31726372,354962604,3,10),(31726372,354962603,3,11),(31726416,51581699,3,1),(31726416,354962622,3,2),(31726467,354962410,2,1),(31726467,354962612,2,2),(31726482,354962618,2,1),(31726482,354962410,2,2),(31726492,53306959,3,1),(31726492,354962605,3,2),(31726507,354962610,2,1),(31726507,53306959,2,2),(31726661,266622367,6,1),(31726661,354966294,6,2),(31726661,51581715,6,3),(31726661,51581711,6,4),(31726661,51581708,6,5),(31726661,51581705,6,6),(31726661,332121137,6,7),(31726661,51581702,6,8),(31726661,332121136,6,9),(31726661,51581699,6,10),(31726701,354966710,5,1),(31726701,354966711,5,2),(31726701,51581724,5,3),(31726701,51581727,5,4),(31726701,51581729,5,5),(31726701,51581732,5,6),(31726701,51581737,5,7),(31726701,51581739,5,8),(31726701,51581743,5,9),(31726701,51581745,5,10),(31726701,51581748,5,11),(31726701,266333917,5,12),(31726701,266334931,5,13),(31726701,266334932,5,14),(31726701,51581782,5,15),(31726779,354966915,10,1),(31726779,354966931,10,2),(31726779,354966929,10,3),(31726779,354966927,10,4),(31726779,354966925,10,5),(31726779,354966923,10,6),(31726779,354966921,10,7),(31726779,354966919,10,8),(31726779,354966917,10,9),(31726779,354966915,10,10),(31726812,354966931,2,1),(31726812,354966710,2,2),(31726812,354966917,2,3),(31726851,354966927,3,1),(31726851,266622367,3,2),(31726851,354966923,3,3),(31726898,354966921,2,1),(31726898,266622366,2,2),(31726898,354966919,2,3),(32211744,51400870,2,1),(32211744,51400871,2,2),(32549432,51957018,2,1),(32549432,366060792,2,2),(32549432,366060794,2,3),(32549432,366060795,2,4),(32549432,366060796,2,5),(32549432,366060797,2,6),(32549432,366060798,2,7),(32549432,366060800,2,8),(32549432,366060801,2,9),(32549432,366060803,2,10),(32549432,366060804,2,11),(32549432,366060805,2,12),(32549432,366060807,2,13),(32549432,366060808,2,14),(32549432,366060810,2,15),(32549432,366060811,2,16),(32549432,366060812,2,17),(32549432,366060813,2,18),(32549432,366060815,2,19),(32549432,366060816,2,20),(32549432,366060818,2,21),(32549432,366060819,2,22),(32549432,366060820,2,23),(32549432,366060821,2,24),(32549432,366060822,2,25),(32549432,366060823,2,26),(32549432,366060824,2,27),(32549432,366060825,2,28),(32549432,366060826,2,29),(32549432,366060827,2,30),(32549432,366060828,2,31),(32549432,366060829,2,32),(32549432,366060830,2,33),(32549432,366060833,2,34),(32549432,366060834,2,35),(32549432,366060836,2,36),(32549432,366060838,2,37),(32549432,366060840,2,38),(32549432,366060841,2,39),(32549432,366060843,2,40),(32549432,366060845,2,41),(32549432,366060846,2,42),(32549432,366060848,2,43),(32549432,366060850,2,44),(32549432,366060852,2,45),(32549432,366060854,2,46),(32549432,366060856,2,47),(32549432,366060857,2,48),(32549432,366060858,2,49),(32549432,366060859,2,50),(32549432,366060861,2,51),(32549432,366060862,2,52),(32549432,366060863,2,53),(32549432,366060864,2,54),(32549432,366060865,2,55),(32549432,366060866,2,56),(32549432,366060867,2,57),(32549432,366060868,2,58),(32549432,366060869,2,59),(32549432,366060870,2,60),(32549432,366060871,2,61),(32549432,366060820,2,62),(32549444,366061154,2,1),(32549444,366060968,2,2),(32549444,366060970,2,3),(32549444,366060971,2,4),(32549444,366060973,2,5),(32549444,366060975,2,6),(32549444,366060977,2,7),(32549444,366060978,2,8),(32549444,366060980,2,9),(32549444,366060982,2,10),(32549444,366060984,2,11),(32549444,366060986,2,12),(32549444,366060987,2,13),(32549444,366060989,2,14),(32549444,366060992,2,15),(32549444,366060994,2,16),(32549444,366060995,2,17),(32549444,366060997,2,18),(32549444,366060999,2,19),(32549444,366061000,2,20),(32549444,366061002,2,21),(32549444,366061004,2,22),(32549444,366061007,2,23),(32549444,366061009,2,24),(32549444,366061012,2,25),(32549444,366061015,2,26),(32549444,366061016,2,27),(32549444,366061018,2,28),(32549444,366061020,2,29),(32549444,366061021,2,30),(32549444,366061023,2,31),(32549444,366061025,2,32),(32549444,366061027,2,33),(32549444,366061029,2,34),(32549444,366061031,2,35),(32549444,366061032,2,36),(32549444,366061034,2,37),(32549444,366061036,2,38),(32549444,366061037,2,39),(32549444,366061038,2,40),(32549444,366061040,2,41),(32549444,366061042,2,42),(32549444,366061044,2,43),(32549444,366061045,2,44),(32549444,366061047,2,45),(32549444,366061049,2,46),(32549444,366061050,2,47),(32549444,366061051,2,48),(32549444,366061052,2,49),(32549444,366061054,2,50),(32549444,366061055,2,51),(32549444,366061056,2,52),(32549444,366061057,2,53),(32549444,366061058,2,54),(32549444,366061060,2,55),(32549444,366061061,2,56),(32549444,366061063,2,57),(32549444,366061065,2,58),(32549444,366061067,2,59),(32549444,366061071,2,60),(32549444,366061073,2,61),(32549444,366061076,2,62),(32549444,366061079,2,63),(32549444,366061081,2,64),(32549444,366061083,2,65),(32549444,366061085,2,66),(32549444,366061087,2,67),(32549444,366061088,2,68),(32549444,366061090,2,69),(32549444,366061092,2,70),(32549444,366061094,2,71),(32549444,366061095,2,72),(32549444,366061097,2,73),(32549444,366061099,2,74),(32549444,366061101,2,75),(32549444,366061102,2,76),(32549444,366061104,2,77),(32549444,366061106,2,78),(32549444,366061109,2,79),(32549444,366061111,2,80),(32549444,366061113,2,81),(32549444,366061115,2,82),(32549444,366061117,2,83),(32549444,366061119,2,84),(32549444,366061122,2,85),(32549444,366061124,2,86),(32549444,366061126,2,87),(32549444,366061128,2,88),(32549444,366061130,2,89),(32549444,366061132,2,90),(32549444,366061135,2,91),(32549444,366061137,2,92),(32549444,366061139,2,93),(32549444,366061141,2,94),(32549444,366061144,2,95),(32549444,366061145,2,96),(32549444,366061147,2,97),(32549444,366061148,2,98),(32549444,366061149,2,99),(32551123,366076279,1,1),(32551123,366076280,1,2),(32551123,366076281,1,3),(32551123,366076282,1,4),(32551123,366076283,1,5),(32551123,366076284,1,6),(32551123,366076286,1,7),(32551123,366076287,1,8),(32551123,366076288,1,9),(32551123,366076289,1,10),(32551123,366076290,1,11),(32551123,366076291,1,12),(32551123,366076292,1,13),(32551123,366076293,1,14),(32551123,366076294,1,15),(32551123,366076295,1,16),(32551123,366076296,1,17),(32551123,366076297,1,18),(32551123,366076298,1,19),(32551123,366076299,1,20),(32551123,366076300,1,21),(32551123,366076301,1,22),(32551123,366076302,1,23),(32551123,366076303,1,24),(32551123,366076304,1,25),(32551123,366076305,1,26),(32551123,366076306,1,27),(32551123,366076307,1,28),(32551123,366076308,1,29),(32551123,366076309,1,30),(32551123,366076310,1,31),(32551123,366076311,1,32),(32551123,366076312,1,33),(32551123,366076313,1,34),(32551123,366076314,1,35),(32551123,366076315,1,36),(32551123,366076316,1,37),(32551123,366076317,1,38),(32551123,366076318,1,39),(32551123,366076319,1,40),(32551123,366076320,1,41),(32551123,366076321,1,42),(32551123,366076322,1,43),(32551123,366076323,1,44),(32551123,366076324,1,45),(32551123,366076325,1,46),(32551123,366076326,1,47),(32551123,366076327,1,48),(32551123,366076328,1,49),(32551123,366076329,1,50),(32551123,366076331,1,51),(32551123,366076332,1,52),(32551123,366076333,1,53),(32551123,366076334,1,54),(32551123,366076335,1,55),(32551123,366076336,1,56),(32551123,366076337,1,57),(32551123,366076338,1,58),(32551123,366076339,1,59),(32551123,366076340,1,60),(32551123,366076341,1,61),(32551123,366076342,1,62),(32551123,366076343,1,63),(32551123,366076344,1,64),(32551123,366076345,1,65),(32551123,366076346,1,66),(32551123,366076347,1,67),(32551123,366076348,1,68),(32551123,366076349,1,69),(32551123,366076350,1,70),(32551123,366076351,1,71),(32551123,366076352,1,72),(32551123,366076353,1,73),(32551123,366076354,1,74),(32551123,366076355,1,75),(32551123,366076356,1,76),(32551123,366076357,1,77),(32551123,366076358,1,78),(32551123,366076359,1,79),(32551123,366076360,1,80),(32551123,366076361,1,81),(32551123,366076362,1,82),(32551123,366076363,1,83),(32551123,366076364,1,84),(32551123,366076365,1,85),(32551123,366076366,1,86),(32551123,366076367,1,87),(32551123,366076368,1,88),(32551123,366076369,1,89),(32551123,366076370,1,90),(32551123,366076371,1,91),(32551123,366076372,1,92),(32551123,366076373,1,93),(32551123,366076374,1,94),(32551123,366076375,1,95),(32551123,366076376,1,96),(32551123,366076378,1,97),(32551123,366076379,1,98),(32551123,366076380,1,99),(32551123,366076381,1,100),(32551123,366076382,1,101),(32551123,366076383,1,102),(32551123,366076384,1,103),(32551123,366076385,1,104),(32551123,366076386,1,105),(32551123,366076387,1,106),(32551123,366076388,1,107),(32551123,366076389,1,108),(32551123,366076390,1,109),(32551123,366076391,1,110),(32551123,366076392,1,111),(32551123,366076393,1,112),(32551123,366076394,1,113),(32551123,366076395,1,114),(32551123,366076396,1,115),(32551123,366076397,1,116),(32551123,366076398,1,117),(32551123,366076399,1,118),(32551123,366076400,1,119),(32551123,366076401,1,120),(32551123,366076402,1,121),(32551123,366076403,1,122),(32551123,366076404,1,123),(32551123,366076405,1,124),(32551123,366076406,1,125),(32551123,366076407,1,126),(32551123,366076408,1,127),(32551123,366076409,1,128),(32551123,366076410,1,129),(32551123,366076411,1,130),(32551123,366076412,1,131),(32551123,366076413,1,132),(32551123,366076414,1,133),(32551123,366076415,1,134),(32551123,366076416,1,135),(32551123,366076417,1,136),(32551123,366076418,1,137),(32551123,366076419,1,138),(32551123,366076420,1,139),(32551123,366076421,1,140),(32551123,366076422,1,141),(32551123,366076423,1,142),(32551123,366076424,1,143),(32551123,366076425,1,144),(32551123,366076426,1,145),(32551123,366076427,1,146),(32551123,366076428,1,147),(32551123,366076429,1,148),(32551123,366076430,1,149),(32551123,366076431,1,150),(32551123,366076432,1,151),(32551123,366076433,1,152),(32551123,366076434,1,153),(32551123,366076436,1,154),(32551123,366076437,1,155),(32551123,366076438,1,156),(32551123,366076439,1,157),(32551123,366076440,1,158),(32551123,366076441,1,159),(32551123,366076442,1,160),(32551123,366076443,1,161),(32551123,366076444,1,162),(32551123,366076445,1,163),(32551123,366076446,1,164),(32551123,366076447,1,165),(32551123,366076448,1,166),(32551123,366076449,1,167),(32551125,52204291,3,1),(32551125,366076544,3,2),(32551125,366076545,3,3),(32551125,366076546,3,4),(32551125,366076547,3,5),(32551125,366076548,3,6),(32551125,366076549,3,7),(32551125,366076550,3,8),(32551125,366076551,3,9),(32551125,366076552,3,10),(32551125,366076553,3,11),(32551125,366076554,3,12),(32551125,366076555,3,13),(32551125,366076556,3,14),(32551125,366076557,3,15),(32551125,366076558,3,16),(32551125,366076559,3,17),(32551125,366076560,3,18),(32551125,366076561,3,19),(32551125,366076562,3,20),(32551125,366076563,3,21),(32551125,366076564,3,22),(32551125,366076565,3,23),(32551125,366076566,3,24),(32551125,366076567,3,25),(32551125,366076568,3,26),(32551125,366076569,3,27),(32551125,366076570,3,28);
INSERT INTO `way_nodes` VALUES (32551125,366076571,3,29),(32551125,366076572,3,30),(32551125,366076573,3,31),(32551125,366076574,3,32),(32551125,366076575,3,33),(32551125,366076576,3,34),(32551125,366076577,3,35),(32551125,366076578,3,36),(32551125,366076579,3,37),(32551125,366076580,3,38),(32551125,366076581,3,39),(32551125,366076582,3,40),(32551125,366076583,3,41),(32551125,366076584,3,42),(32551125,366076585,3,43),(32551125,366076586,3,44),(32551125,366076587,3,45),(32551125,366076588,3,46),(32551125,366076589,3,47),(32551125,366076590,3,48),(32551125,366076591,3,49),(32551125,366076592,3,50),(32551125,366076593,3,51),(32551125,366076594,3,52),(32551125,366076595,3,53),(32551125,366076596,3,54),(32551125,366076597,3,55),(32551125,366076598,3,56),(32551125,366076599,3,57),(32551125,366076600,3,58),(32551125,366076601,3,59),(32551125,366076602,3,60),(32551125,366076603,3,61),(32551125,366076604,3,62),(32551125,366076605,3,63),(32551125,366076606,3,64),(32551125,366076607,3,65),(32551125,366076608,3,66),(32551125,366076609,3,67),(32551125,366076610,3,68),(32551125,366076611,3,69),(32551125,366076612,3,70),(32551125,366076613,3,71),(32551125,366076614,3,72),(32551125,366076615,3,73),(32551125,366076617,3,74),(32551125,366076618,3,75),(32551125,366076619,3,76),(32551125,366076620,3,77),(32551125,366076621,3,78),(32551125,366076622,3,79),(32551125,366076623,3,80),(32551125,366076624,3,81),(32551125,366076625,3,82),(32551125,366076626,3,83),(32551125,366076627,3,84),(32551125,366076628,3,85),(32551125,366076629,3,86),(32551125,366076630,3,87),(32551125,366076631,3,88),(32551125,366076632,3,89),(32551125,366076633,3,90),(32551125,366076634,3,91),(32551125,366076635,3,92),(32551125,366076636,3,93),(32551125,366076637,3,94),(32551125,366076638,3,95),(32551125,366076639,3,96),(32551125,366076640,3,97),(32551125,366076641,3,98),(32551125,366076642,3,99),(32551125,366076643,3,100),(32551125,366076644,3,101),(32551125,366076645,3,102),(32551125,366076646,3,103),(32551125,366076647,3,104),(32551125,366076648,3,105),(32551125,366076649,3,106),(32551125,366076650,3,107),(32551125,366076651,3,108),(32551125,366076652,3,109),(32551125,366076653,3,110),(32551125,366076654,3,111),(32551125,366076655,3,112),(32551125,366076656,3,113),(32551125,366076657,3,114),(32551125,366076658,3,115),(32551125,366076659,3,116),(32551125,366076660,3,117),(32551125,366076661,3,118),(32551125,366076662,3,119),(32551125,366076663,3,120),(32551125,366076664,3,121),(32551125,366076665,3,122),(32551125,366076666,3,123),(32551125,366076667,3,124),(32551125,366076668,3,125),(32551125,366076669,3,126),(32551125,366076670,3,127),(32551125,366076671,3,128),(32551125,366076672,3,129),(32551125,366076673,3,130),(32551125,366076674,3,131),(32551125,366076675,3,132),(32551125,366076676,3,133),(32551125,366076677,3,134),(32551125,366076678,3,135),(32551125,366076679,3,136),(32551125,366076680,3,137),(32551125,366076681,3,138),(32551125,366076682,3,139),(32551125,366076683,3,140),(32551125,366076684,3,141),(32551125,366076685,3,142),(32551125,366076687,3,143),(32551125,366076688,3,144),(32551125,366076689,3,145),(32551125,366076690,3,146),(32551125,366076691,3,147),(32551125,366076692,3,148),(32551125,366076693,3,149),(32551125,366076694,3,150),(32551125,366076695,3,151),(32551125,366076696,3,152),(32551125,366076697,3,153),(32551125,366076698,3,154),(32551125,366076700,3,155),(32551125,366076701,3,156),(32551125,366076702,3,157),(32551125,366076704,3,158),(32551125,366076705,3,159),(32551125,366076279,3,160),(32594779,51930177,2,1),(32594779,366538118,2,2),(32594779,366538119,2,3),(32594779,366538120,2,4),(32594779,366538122,2,5),(32594779,366538124,2,6),(32594779,366538127,2,7),(32594779,366538128,2,8),(32594779,366538130,2,9),(32594779,366538131,2,10),(32594779,366538133,2,11),(32594779,366538134,2,12),(32594779,366538135,2,13),(32594779,366538137,2,14),(32594779,366538138,2,15),(32594779,366538139,2,16),(32594779,366538140,2,17),(32594779,366538141,2,18),(32594779,366538142,2,19),(32594779,366538144,2,20),(32594779,366538145,2,21),(32594779,366538146,2,22),(32594779,366538147,2,23),(32594779,366538148,2,24),(32594779,366538152,2,25),(32594779,366538153,2,26),(32594779,366538154,2,27),(32594779,366538155,2,28),(32594779,366538156,2,29),(32594779,366538157,2,30),(32594779,366538159,2,31),(32594779,366538160,2,32),(32594779,366538161,2,33),(32594779,366538162,2,34),(32594779,366538163,2,35),(32594779,366538164,2,36),(32594779,366538165,2,37),(32594779,366538166,2,38),(32594779,366538168,2,39),(32594779,366538169,2,40),(32594779,366538170,2,41),(32594779,366538171,2,42),(32594779,366538172,2,43),(32594779,366538173,2,44),(32594779,366538175,2,45),(32594779,366538176,2,46),(32594779,366538177,2,47),(32594779,366538178,2,48),(32594779,366538180,2,49),(32594779,366538181,2,50),(32594779,366538182,2,51),(32594779,366538183,2,52),(32594779,366538185,2,53),(32594779,366538186,2,54),(32594779,366538187,2,55),(32594779,366538188,2,56),(32594779,366538190,2,57),(32594779,366538192,2,58),(32594779,366538193,2,59),(32594779,366538194,2,60),(32594779,366538195,2,61),(32594779,366538196,2,62),(32594779,366538198,2,63),(32594779,366538199,2,64),(32594779,366538200,2,65),(32594779,366538201,2,66),(32594779,366538203,2,67),(32594779,366538204,2,68),(32594779,366538206,2,69),(32594779,366538207,2,70),(32594779,366538208,2,71),(32594984,51952844,2,1),(32594984,366540716,2,2),(32594984,366540717,2,3),(32594984,366540718,2,4),(32594984,366540719,2,5),(32594984,366540720,2,6),(32594984,366540721,2,7),(32594984,366540722,2,8),(32594984,366540723,2,9),(32594984,366540724,2,10),(32594984,366540725,2,11),(32594984,366540726,2,12),(32594984,366540727,2,13),(32594984,366540728,2,14),(32594984,366540730,2,15),(32594984,366540731,2,16),(32594984,366540732,2,17),(32594984,366540733,2,18),(32594984,366540734,2,19),(32594984,366540735,2,20),(32594984,366540736,2,21),(32594984,366540737,2,22),(32594984,366540738,2,23),(32594984,366540739,2,24),(32594984,366540740,2,25),(32594984,366540741,2,26),(32594984,366540742,2,27),(32594984,366540743,2,28),(32594984,366540744,2,29),(32594984,366540745,2,30),(32594984,366540746,2,31),(32594984,366540747,2,32),(32594984,366540748,2,33),(32594984,366540749,2,34),(32594984,366540750,2,35),(32594984,366540751,2,36),(32594984,366540752,2,37),(32594984,366540754,2,38),(32594984,366540755,2,39),(32594984,366540756,2,40),(32594984,366540757,2,41),(32594984,366540758,2,42),(32594984,366540759,2,43),(32594984,366540760,2,44),(32594984,366540761,2,45),(32594984,366540762,2,46),(32594984,366540763,2,47),(32594984,366540764,2,48),(32594984,366540765,2,49),(32594984,366540766,2,50),(32594984,366540767,2,51),(32594984,366540768,2,52),(32594984,366540769,2,53),(32594984,366540770,2,54),(32594984,366540771,2,55),(32594984,366540772,2,56),(32594984,366540773,2,57),(32594984,366540774,2,58),(32594984,366540775,2,59),(32594984,366540776,2,60),(32594984,366540777,2,61),(32594984,366540778,2,62),(32594984,366540779,2,63),(32594984,366540780,2,64),(32594984,366540782,2,65),(32594984,366540783,2,66),(32594984,366540784,2,67),(32594984,366540785,2,68),(32594984,366540786,2,69),(32594984,366540787,2,70),(32594984,366540788,2,71),(32594984,366540789,2,72),(32594984,366540792,2,73),(32594984,366540793,2,74),(32594984,366540794,2,75),(32594984,366540795,2,76),(32594984,366540796,2,77),(32594984,366540798,2,78),(32594984,366540800,2,79),(32594984,366540801,2,80),(32594984,366540802,2,81),(32594984,366540803,2,82),(32594984,366540804,2,83),(32594984,366540805,2,84),(32594984,366540806,2,85),(32594984,366540807,2,86),(32594984,366540808,2,87),(32594984,366540809,2,88),(32594984,366540810,2,89),(32594984,366540811,2,90),(32594984,366540812,2,91),(32594984,366540813,2,92),(32594984,366540814,2,93),(32594984,366540815,2,94),(32594984,366540816,2,95),(32594984,366540817,2,96),(32594984,366540818,2,97),(32594984,366540820,2,98),(32594984,366540821,2,99),(32594984,366540822,2,100),(32594984,366540823,2,101),(32594984,366540824,2,102),(32594984,366540825,2,103),(32594984,366540826,2,104),(32594984,366540827,2,105),(32594984,366540828,2,106),(32594984,366540829,2,107),(32594984,366540830,2,108),(32594984,366540831,2,109),(32594984,366540832,2,110),(32594984,366540833,2,111),(32594984,366540834,2,112),(32594984,366540835,2,113),(32594984,366540836,2,114),(32594984,366540837,2,115),(32594984,366540838,2,116),(32594984,366540839,2,117),(32594984,366540840,2,118),(32594984,366540841,2,119),(32594984,366540842,2,120),(32594984,366540843,2,121),(32594984,366540845,2,122),(32594984,366540846,2,123),(32594984,366540847,2,124),(32594984,366540848,2,125),(32594984,366540849,2,126),(32594984,366540850,2,127),(32594984,366540851,2,128),(32594984,366540852,2,129),(32594984,366540853,2,130),(32594984,366540854,2,131),(32594984,366540855,2,132),(32594984,366540856,2,133),(32594984,366540857,2,134),(32594984,366540858,2,135),(32594984,366540859,2,136),(32594984,366540860,2,137),(32594984,366540861,2,138),(32594984,366540862,2,139),(32594984,366540863,2,140),(32594984,366540864,2,141),(32594984,366540865,2,142),(32594984,366540866,2,143),(32594984,366540867,2,144),(32594984,366540868,2,145),(32594984,366540869,2,146),(32594984,366540870,2,147),(32594984,366540871,2,148),(32594984,366540873,2,149),(32594984,366540874,2,150),(32594984,366540875,2,151),(32594984,366540876,2,152),(32594985,366540876,1,1),(32594985,366540883,1,2),(32594985,366540884,1,3),(32594985,366540885,1,4),(32594985,366540886,1,5),(32594985,366540887,1,6),(32594985,366540888,1,7),(32594985,366540889,1,8),(32594985,366540890,1,9),(32594985,366540891,1,10),(32594985,366540892,1,11),(32594985,366540893,1,12),(32594985,366540894,1,13),(32594985,366540895,1,14),(32594985,366540896,1,15),(32594985,366540897,1,16),(32594985,366540898,1,17),(32594985,366540899,1,18),(32594985,366540900,1,19),(32594985,366540901,1,20),(32594985,366540902,1,21),(32594985,366540903,1,22),(32594985,366540904,1,23),(32594985,366540905,1,24),(32594985,366540906,1,25),(32594985,366540907,1,26),(32594985,366540908,1,27),(32594985,366540909,1,28),(32594985,366540910,1,29),(32594985,366540911,1,30),(32594985,366540912,1,31),(32594985,366540913,1,32),(32594985,366540914,1,33),(32594985,366540915,1,34),(32594985,366540916,1,35),(32594985,366540917,1,36),(32594985,366540918,1,37),(32594985,366540920,1,38),(32594985,366540921,1,39),(32594985,366540922,1,40),(32594985,366540923,1,41),(32594985,366540762,1,42),(32598297,366578105,4,1),(32598297,366577779,4,2),(32598297,366577781,4,3),(32598297,366577782,4,4),(32598297,366577783,4,5),(32598297,366577784,4,6),(32598297,366577785,4,7),(32598297,366577786,4,8),(32598297,366577787,4,9),(32598297,366577788,4,10),(32598297,366577789,4,11),(32598297,366577790,4,12),(32598297,366577792,4,13),(32598297,366577793,4,14),(32598297,366577794,4,15),(32598297,366577795,4,16),(32598297,366577796,4,17),(32598297,366577797,4,18),(32598297,366577798,4,19),(32598297,366577799,4,20),(32598297,366577800,4,21),(32598297,366577802,4,22),(32598297,366577803,4,23),(32598297,366577804,4,24),(32598297,366577805,4,25),(32598297,366577806,4,26),(32598297,366577807,4,27),(32598297,366577808,4,28),(32598297,366577809,4,29),(32598297,366577810,4,30),(32598297,366577812,4,31),(32598297,366577813,4,32),(32598297,366577814,4,33),(32598297,366577815,4,34),(32598297,366577816,4,35),(32598297,366577817,4,36),(32598297,370906892,4,37),(32598300,53294709,3,1),(32598300,366577907,3,2),(32598300,366577908,3,3),(32598300,366577910,3,4),(32598300,366577912,3,5),(32598300,366577913,3,6),(32598300,366577914,3,7),(32598300,366577915,3,8),(32598300,366577917,3,9),(32598300,366577918,3,10),(32598300,366577919,3,11),(32598300,366577920,3,12),(32598300,366577922,3,13),(32598300,366577924,3,14),(32598300,366577925,3,15),(32598300,366577926,3,16),(32598300,366577927,3,17),(32598300,366577928,3,18),(32598300,366577929,3,19),(32598300,366577930,3,20),(32598300,366577931,3,21),(32598300,366577932,3,22),(32598300,366577934,3,23),(32598300,366577935,3,24),(32598300,366577936,3,25),(32598300,366577937,3,26),(32598300,366577938,3,27),(32598300,366577939,3,28),(32598300,366577940,3,29),(32598300,366577941,3,30),(32598300,366577943,3,31),(32598300,366577944,3,32),(32598300,366577945,3,33),(32598300,366577946,3,34),(32598300,366577947,3,35),(32598300,366577948,3,36),(32598300,366577949,3,37),(32598300,366577950,3,38),(32598300,366577952,3,39),(32598300,366577953,3,40),(32598300,366577954,3,41),(32598300,366577955,3,42),(32598300,51930027,3,43),(32598313,51930169,3,1),(32598313,366577980,3,2),(32598313,366577981,3,3),(32598313,366577982,3,4),(32598313,366577983,3,5),(32598313,366577984,3,6),(32598313,366577985,3,7),(32598313,366577987,3,8),(32598313,366577988,3,9),(32598313,366577989,3,10),(32598313,366577990,3,11),(32598313,366577991,3,12),(32598313,366577992,3,13),(32598313,366577994,3,14),(32598313,366577996,3,15),(32598313,366577997,3,16),(32598313,366577998,3,17),(32598313,366578000,3,18),(32598313,366578001,3,19),(32598313,366578003,3,20),(32598313,366578004,3,21),(32598313,366578006,3,22),(32598313,366578007,3,23),(32598313,366578014,3,24),(32598338,366578338,2,1),(32598338,366578013,2,2),(32598338,366578014,2,3),(32598345,366578014,1,1),(32598345,366578016,1,2),(32598345,366578018,1,3),(32598345,366578019,1,4),(32598345,366578020,1,5),(32598345,366578021,1,6),(32598345,366578022,1,7),(32598345,366578024,1,8),(32598345,366578025,1,9),(32598345,366578026,1,10),(32598345,366578027,1,11),(32598345,366578029,1,12),(32598345,366578031,1,13),(32598345,366578032,1,14),(32598345,366578033,1,15),(32598345,366578035,1,16),(32598345,366578036,1,17),(32598345,366578037,1,18),(32598345,366578040,1,19),(32598345,366578041,1,20),(32598345,366578042,1,21),(32598345,366578043,1,22),(32598345,366578044,1,23),(32598345,366578045,1,24),(32598345,366578046,1,25),(32598345,366578048,1,26),(32598345,366578049,1,27),(32598345,366578050,1,28),(32598345,366578052,1,29),(32598345,366578053,1,30),(32598345,366578054,1,31),(32676714,321682237,6,1),(32676714,321682236,6,2),(32676714,321682235,6,3),(32676714,321682234,6,4),(32676714,321682233,6,5),(32676714,321682232,6,6),(32676714,321682231,6,7),(32676714,321682230,6,8),(32676714,321682229,6,9),(32676714,321682228,6,10),(32676714,321682227,6,11),(32676714,321682226,6,12),(32676714,321682225,6,13),(32676714,321682224,6,14),(32676714,321682223,6,15),(32676714,321682222,6,16),(32676714,321682221,6,17),(32676714,321682220,6,18),(32676714,321682219,6,19),(32676714,321682218,6,20),(32676714,321682217,6,21),(32676714,321682216,6,22),(32676714,321682215,6,23),(32676714,321682214,6,24),(32676714,321682213,6,25),(32676714,321682212,6,26),(32676714,321682211,6,27),(32676714,321682210,6,28),(32676714,321682209,6,29),(32676714,321682208,6,30),(32676714,321682207,6,31),(32676714,321682206,6,32),(32676714,321682205,6,33),(32676714,321682204,6,34),(32676714,321682203,6,35),(32676714,321682202,6,36),(32676714,321682201,6,37),(32676714,321682200,6,38),(32676714,321682199,6,39),(32676714,321682198,6,40),(32676714,321682197,6,41),(32676714,321682196,6,42),(32676714,321682195,6,43),(32676714,321682194,6,44),(32676714,321682193,6,45),(32676714,321682192,6,46),(32676714,321682191,6,47),(32676714,321682190,6,48),(32676714,321682189,6,49),(32676714,321682188,6,50),(32676714,321682187,6,51),(32676714,321682186,6,52),(32676714,321682185,6,53),(32676714,321682184,6,54),(32676714,321682182,6,55),(32676714,321682180,6,56),(32676714,321682179,6,57),(32676714,321682178,6,58),(32676714,321682174,6,59),(32676714,321682172,6,60),(32676714,321682170,6,61),(32676714,321682169,6,62),(32676714,321682168,6,63),(32676714,321682167,6,64),(32676714,321682166,6,65),(32676714,321682165,6,66),(32676714,321682164,6,67),(32676714,321682163,6,68),(32676714,321682162,6,69),(32676714,321682161,6,70),(32676714,321682160,6,71),(32676714,321682159,6,72),(32676714,321682158,6,73),(32676714,321682157,6,74),(32676714,321682156,6,75),(32676714,321682155,6,76),(32676714,321682154,6,77),(32676714,321682152,6,78),(32676714,321682151,6,79),(32676714,321682150,6,80),(32676714,321682149,6,81),(32676714,321682146,6,82),(32676714,321682143,6,83),(32676714,321682142,6,84),(32676714,321682141,6,85),(32676714,321682140,6,86),(32676714,321682139,6,87),(32676714,321682138,6,88),(32676714,321682137,6,89),(32676714,321682136,6,90),(32676714,321682135,6,91),(32676714,321682134,6,92),(32676714,321682133,6,93),(32676714,321682131,6,94),(32676714,321682130,6,95),(32676714,321682129,6,96),(32676714,321682128,6,97),(32676714,321682127,6,98),(32676714,321682126,6,99),(32676714,321682125,6,100),(32676714,321682124,6,101),(32676714,321682123,6,102),(32676739,367676808,4,1),(32676739,367676825,4,2),(32676739,367676852,4,3),(32676739,367676869,4,4),(32676739,367676884,4,5),(32676739,367676899,4,6),(32676739,367676910,4,7),(32676739,367676924,4,8),(32676739,367676937,4,9),(32676739,367676948,4,10),(32676739,367676960,4,11),(32676739,367676970,4,12),(32676739,367676981,4,13),(32676743,367677101,2,1),(32676743,367677116,2,2),(32676743,367677123,2,3),(32676743,367677127,2,4),(32676743,367677134,2,5),(32676743,367677152,2,6),(32676743,367677173,2,7),(32676743,367677207,2,8),(32676743,367677224,2,9),(32676743,367677245,2,10),(32676743,367677261,2,11),(32676743,367677271,2,12),(32676743,367677289,2,13),(32676743,367677308,2,14),(32676743,367677322,2,15),(32676743,367677341,2,16),(32676743,367677395,2,17),(32676743,367677405,2,18),(32676743,367677418,2,19),(32676743,367677434,2,20),(32676743,367677448,2,21),(32676743,367677464,2,22),(32676743,367677476,2,23),(32676743,367677490,2,24),(32676743,367677502,2,25),(32676743,367677515,2,26),(32676743,367677526,2,27),(32676743,367677538,2,28),(32676743,367677639,2,29),(32676743,367677777,2,30),(32676743,367677784,2,31),(32676743,367677801,2,32),(32676746,367676981,1,1),(32676746,367677010,1,2),(32676746,367677022,1,3),(32676746,367677032,1,4),(32676746,367677043,1,5),(32676746,367677058,1,6),(32676746,367677076,1,7),(32676746,367677090,1,8),(32676746,367677101,1,9),(32676749,367677801,2,1),(32676749,367677832,2,2),(32676749,367677910,2,3),(32676749,367677917,2,4),(32676749,367677926,2,5),(32676749,367677937,2,6),(32676749,367677977,2,7),(32676749,367677996,2,8),(32676749,367678009,2,9),(32676749,367678022,2,10),(32676749,367678041,2,11),(32676749,367678052,2,12),(32676749,367678060,2,13),(32676749,367678071,2,14),(32676749,367678076,2,15),(32676749,367678085,2,16),(32676749,367678093,2,17),(32676749,367678136,2,18),(32676749,367678147,2,19),(32676749,367678187,2,20),(32676749,367678204,2,21),(32676749,367678210,2,22),(32676749,367678218,2,23),(32676749,367678223,2,24),(32676749,367678236,2,25),(32676749,367678270,2,26),(32676749,367678278,2,27),(32676749,367678291,2,28),(32676749,367678297,2,29),(32676749,367678306,2,30),(32676749,367678312,2,31),(32676749,367678321,2,32),(32676749,367678325,2,33),(32676749,367678340,2,34),(32676749,367678352,2,35),(32676749,367678376,2,36),(32676749,367678479,2,37),(32676749,367678487,2,38),(32676749,367678495,2,39),(32676749,367678507,2,40),(32676749,367678516,2,41),(32676749,367678522,2,42),(32676749,367678531,2,43),(32676749,367678537,2,44),(32676749,367678542,2,45),(32676749,367678550,2,46),(32676749,367678557,2,47),(32676749,367678565,2,48),(32676749,367678572,2,49),(32676749,367678591,2,50),(32676749,367678599,2,51),(32676749,367678605,2,52),(32676749,367678629,2,53),(32676749,367678634,2,54),(32676749,367678639,2,55),(32676749,367678644,2,56),(32676749,367678654,2,57),(32676749,367678663,2,58),(32676749,367678669,2,59),(32676749,367678677,2,60),(32676749,367678702,2,61),(32676749,367678712,2,62),(32676749,367678720,2,63),(32676749,367678727,2,64),(32676749,367678735,2,65),(32676749,367678745,2,66),(32676749,367678755,2,67),(32676749,367678769,2,68),(32676749,367678779,2,69),(32676749,367678793,2,70),(32676749,367678802,2,71),(32676749,367678814,2,72),(32676749,367678847,2,73),(32676749,367678865,2,74),(32676749,367678880,2,75),(32676749,367678890,2,76),(32676749,367678906,2,77),(32676749,367678922,2,78),(32676749,367678939,2,79),(32676749,367678954,2,80),(32676749,367678966,2,81),(32676749,367678977,2,82),(32676749,367678987,2,83),(32676749,367678996,2,84),(32676749,367679008,2,85),(32676749,367679021,2,86),(32676749,367679030,2,87),(32676749,367679046,2,88),(32676749,367679058,2,89),(32676749,367679071,2,90),(32676749,367679081,2,91),(32676749,367679089,2,92),(32676749,367679104,2,93),(32676749,367679117,2,94),(32676749,367679128,2,95),(32676749,367679147,2,96),(32676749,367679155,2,97),(32676749,367679176,2,98),(32676749,367679191,2,99),(32676749,367679205,2,100),(32676749,367679214,2,101),(32676749,367679221,2,102),(32676749,367679236,2,103),(32676749,367679246,2,104),(32676749,367679257,2,105),(32676749,367679266,2,106),(32676749,367679278,2,107),(32676749,367679287,2,108),(32676749,367679292,2,109),(32676749,367679302,2,110),(32676749,367679315,2,111),(32676749,367679329,2,112),(32676749,367679336,2,113),(32676749,367679344,2,114),(32676749,367679349,2,115),(32676749,367679356,2,116),(32676749,367679361,2,117),(32676749,367679371,2,118),(32676749,367679385,2,119),(32676749,367679611,2,120),(32676749,367679614,2,121),(32676749,367679617,2,122),(32676749,367679635,2,123),(32676749,367679639,2,124),(32676749,367679650,2,125),(32676749,367679669,2,126),(32676749,367679673,2,127),(32676749,367679679,2,128),(32676749,367679681,2,129),(32676749,367679684,2,130),(32676749,367679690,2,131),(32676749,367679748,2,132),(32676749,367679754,2,133),(32676749,367679763,2,134),(32676749,367679770,2,135),(32676749,367679774,2,136),(32676749,367679778,2,137),(32676749,367679786,2,138),(32676749,367679794,2,139),(32676749,367679801,2,140),(32676749,367679813,2,141),(32676749,367679818,2,142),(32676749,367679826,2,143),(32676749,367679843,2,144),(32676749,367679850,2,145),(32676749,367679856,2,146),(32676749,367679861,2,147),(32676749,367679877,2,148),(32676749,367679892,2,149),(32676749,367679899,2,150),(32676749,367679904,2,151),(32676749,367679910,2,152),(32676749,367679915,2,153),(32676749,367679927,2,154),(32676749,367679934,2,155),(32676749,367679939,2,156),(32676749,367679943,2,157),(32676749,367679962,2,158),(32676749,367679973,2,159),(32676749,367679979,2,160),(32676749,367679988,2,161),(32676749,367679994,2,162),(32676749,367680003,2,163),(32676749,367680016,2,164),(32676749,367680026,2,165),(32676749,367680034,2,166),(32676749,367680039,2,167),(32676749,367680045,2,168),(32676749,367680054,2,169),(32676749,367680063,2,170),(32676749,367680074,2,171),(32676749,367680085,2,172),(32676749,367680092,2,173),(32676749,367680095,2,174),(32676749,367680103,2,175),(32676749,367680112,2,176),(32676749,367680121,2,177),(32676749,367680135,2,178),(32676749,367680145,2,179),(32676749,367680154,2,180),(32676749,367680180,2,181),(32676749,367680191,2,182),(32676749,367680197,2,183),(32676749,367680206,2,184),(32676749,367680220,2,185),(32676749,367680228,2,186),(32676749,367680235,2,187),(32676749,367680239,2,188),(32676749,367680244,2,189),(32676749,367680258,2,190),(32676749,367680266,2,191),(32676749,367680270,2,192),(32676749,367680273,2,193),(32676749,367680291,2,194),(32676749,367680297,2,195),(32676749,367683372,2,196),(32676749,367680427,2,197),(32676753,367683372,3,1),(32676753,367680440,3,2),(32676753,367680443,3,3),(32676753,367680445,3,4),(32676753,367680449,3,5),(32676753,367680460,3,6),(32676753,367680463,3,7),(32676753,367680466,3,8),(32676753,367680470,3,9),(32676753,367680475,3,10),(32676753,367680481,3,11),(32676753,367680486,3,12),(32676753,367680498,3,13),(32676753,367680503,3,14),(32676753,367680513,3,15),(32676753,367680522,3,16),(32676753,367680528,3,17),(32676753,367680536,3,18),(32676753,367680577,3,19),(32676753,367680583,3,20),(32676753,367680601,3,21),(32676753,367680690,3,22),(32676753,367680699,3,23),(32676753,367680708,3,24),(32676753,367680716,3,25),(32676753,367680726,3,26),(32676753,367680747,3,27),(32676753,367680753,3,28),(32676753,367680901,3,29),(32676753,367680914,3,30),(32676753,367680923,3,31),(32676753,367680933,3,32),(32676753,367680940,3,33),(32676753,367680947,3,34),(32676753,367680956,3,35),(32676753,367680960,3,36),(32676753,367680964,3,37),(32676753,367680970,3,38),(32676753,367680975,3,39),(32676753,367680978,3,40),(32676753,367680983,3,41),(32676753,367680990,3,42),(32676753,367681000,3,43),(32676753,367681004,3,44),(32676753,367681008,3,45),(32676753,367681012,3,46),(32676753,367681029,3,47),(32676753,367681033,3,48),(32676753,367681059,3,49),(32676753,367681064,3,50),(32676753,367681082,3,51),(32676753,367681083,3,52),(32676753,367681084,3,53),(32676753,367681087,3,54),(32676753,367681092,3,55),(32676753,367681096,3,56),(32676753,367681118,3,57),(32676753,367681124,3,58),(32676753,367681129,3,59),(32676753,367681130,3,60),(32676753,367681143,3,61),(32676753,367681147,3,62),(32676753,367681150,3,63),(32676753,367681156,3,64),(32676753,367681162,3,65),(32676753,367681174,3,66),(32676753,367681183,3,67),(32676753,367681190,3,68),(32676753,367681198,3,69),(32676753,367681204,3,70),(32676753,367681212,3,71),(32676753,367681216,3,72),(32676753,367681225,3,73),(32676753,367681230,3,74),(32676753,367681236,3,75),(32676753,367681256,3,76),(32676753,367681261,3,77),(32676753,367681429,3,78),(32676753,367681439,3,79),(32676753,367681447,3,80),(32676753,367681453,3,81),(32676753,367681456,3,82),(32676753,367681461,3,83),(32676753,367681465,3,84),(32676753,367681477,3,85),(32676753,367681482,3,86),(32676753,367681490,3,87),(32676753,367681497,3,88),(32676753,367681504,3,89),(32676753,367681514,3,90),(32676753,367681521,3,91),(32676753,367681533,3,92),(32676753,367681539,3,93),(32676753,367681545,3,94),(32676753,367681552,3,95),(32676753,367681555,3,96),(32676753,367681560,3,97),(32676753,367681574,3,98),(32676753,367681579,3,99),(32676753,367681584,3,100),(32676753,367681590,3,101),(32676753,367681596,3,102),(32676753,367681601,3,103),(32676753,367681607,3,104),(32676753,367681613,3,105),(32676753,367681617,3,106),(32676753,367681624,3,107),(32676753,367681630,3,108),(32676753,367681635,3,109),(32676753,367681640,3,110),(32676753,367681644,3,111),(32676753,367681647,3,112),(32676753,367681651,3,113),(32676753,367681655,3,114),(32676753,367681663,3,115),(32676753,367681671,3,116),(32676753,367681676,3,117),(32676753,367681681,3,118),(32676753,367681687,3,119),(32676753,367681691,3,120),(32676753,367681694,3,121),(32676753,367681697,3,122),(32676753,367681701,3,123),(32676753,367681708,3,124),(32676753,367681722,3,125),(32676753,367681730,3,126),(32676753,367681735,3,127),(32676753,367681739,3,128),(32676753,367681745,3,129),(32676753,367681753,3,130),(32676753,367681758,3,131),(32676753,367681766,3,132),(32676753,367681773,3,133),(32676753,367681779,3,134),(32676753,367681894,3,135),(32676753,367681900,3,136),(32676753,367681907,3,137),(32676753,367681915,3,138),(32676753,367681939,3,139),(32676753,367681946,3,140),(32676753,367681956,3,141),(32676753,367681967,3,142),(32676753,367681972,3,143),(32676753,367681980,3,144),(32676753,367681989,3,145),(32676753,367681997,3,146),(32676753,367682006,3,147),(32676753,367682014,3,148),(32676753,367682022,3,149),(32676753,367682032,3,150),(32676753,367682040,3,151),(32676753,367682054,3,152),(32676753,367682060,3,153),(32676753,367682068,3,154),(32676753,367682073,3,155),(32676753,367682101,3,156),(32676753,367682111,3,157),(32676753,367682123,3,158),(32676753,367682130,3,159),(32676753,367682139,3,160),(32676753,367682148,3,161),(32676753,367682156,3,162),(32676753,367682164,3,163),(32676753,367682172,3,164),(32676753,367682183,3,165),(32676753,367682193,3,166),(32676753,367682230,3,167),(32676753,367682241,3,168),(32676753,367682252,3,169),(32676753,367682263,3,170),(32676753,367682269,3,171),(32676753,367682279,3,172),(32676753,367682505,3,173),(32676753,367682512,3,174),(32676753,367682529,3,175),(32676753,367682541,3,176),(32676753,367682547,3,177),(32676753,367682550,3,178),(32676753,367682554,3,179),(32676753,367682560,3,180),(32676753,367682567,3,181),(32676753,367682571,3,182),(32676753,367682574,3,183),(32676753,367682578,3,184),(32676753,367682582,3,185),(32676753,367682587,3,186),(32676753,367682591,3,187),(32676753,367682595,3,188),(32676753,367682600,3,189),(32676753,367682607,3,190),(32676753,367682612,3,191),(32676753,367682618,3,192),(32676753,367682624,3,193),(32676753,367682629,3,194),(32676753,367682636,3,195),(32676753,367682639,3,196),(32676753,367682645,3,197),(32676753,367682650,3,198),(32676753,367682653,3,199),(32676753,367682657,3,200),(32676753,367682670,3,201),(32676753,367682675,3,202),(32676753,367682678,3,203),(32676753,367682684,3,204),(32676753,367682688,3,205),(32676753,367682691,3,206),(32676753,367682694,3,207),(32676753,367682698,3,208),(32676753,367682700,3,209),(32676753,664115894,3,210),(32676753,367682704,3,211),(32676753,367682708,3,212),(32676753,664115899,3,213),(32676753,367682711,3,214),(32676753,367682716,3,215),(32676753,367682724,3,216),(32676753,367682732,3,217),(32676753,367682739,3,218),(32676753,367682743,3,219),(32676753,367682748,3,220),(32676753,367682754,3,221),(32676753,367682760,3,222),(32676753,367682767,3,223),(32676753,367682772,3,224),(32676753,367682777,3,225),(32676753,367682784,3,226),(32676755,367682784,2,1),(32676755,367682789,2,2),(32676755,367682795,2,3),(32676755,367682800,2,4),(32676755,367682806,2,5),(32676755,367682813,2,6),(32676755,367682819,2,7),(32676755,367682825,2,8),(32676755,367682830,2,9),(32676755,367682837,2,10),(32676755,367682842,2,11),(32676755,367682845,2,12),(32676755,367682852,2,13),(32676755,367682859,2,14),(32676755,367682865,2,15),(32676755,367682873,2,16),(32676755,367682879,2,17),(32676755,367682885,2,18),(32676755,367682891,2,19),(32676755,367682900,2,20),(32676755,367682906,2,21),(32676755,367682911,2,22),(32676755,367682916,2,23),(32676755,367682920,2,24),(32676755,367682927,2,25),(32676755,367682932,2,26),(32676755,367682940,2,27),(32676755,367682947,2,28),(32676755,367682953,2,29),(32676755,367682961,2,30),(32676755,367682968,2,31),(32676755,367682978,2,32),(32676755,367682985,2,33),(32676755,367682989,2,34),(32676755,367682996,2,35),(32676755,367683000,2,36),(32676755,367683005,2,37),(32676755,367683011,2,38),(32676755,367683017,2,39),(32676755,367683026,2,40),(32676755,367683034,2,41),(32676755,367683042,2,42),(32676755,367683051,2,43),(32676755,367683060,2,44),(32676755,367683065,2,45),(32676755,367683069,2,46),(32676755,367683074,2,47),(32676755,367683080,2,48),(32676755,367683084,2,49),(32676755,367683091,2,50),(32676755,367683097,2,51),(32676755,367683102,2,52),(32676755,367683107,2,53),(32676755,367683114,2,54),(32676755,367683120,2,55),(32676755,367683128,2,56),(32676755,367683134,2,57),(32676755,367683139,2,58),(32676755,367683144,2,59),(32676755,367683147,2,60),(32676755,367683155,2,61),(32676755,367683161,2,62),(32676755,367683168,2,63),(32676755,367683176,2,64),(32676755,367683182,2,65),(32676755,367683188,2,66),(32676755,367683198,2,67),(32676755,367683208,2,68),(32676755,367683212,2,69),(32676755,367683222,2,70),(32676755,367683232,2,71),(32676755,367683242,2,72),(32676755,367683249,2,73),(32676755,367683260,2,74),(32676755,367683266,2,75),(32676755,367683274,2,76),(32676755,367683286,2,77),(32676755,367683291,2,78),(32676755,367683298,2,79),(32676755,367683303,2,80),(32676755,367683309,2,81),(32676755,367683318,2,82),(32676755,367683330,2,83),(32676755,367683340,2,84),(32676755,367683346,2,85),(32676755,367683352,2,86),(32676755,367683359,2,87),(32676755,367683366,2,88),(32722266,53332079,4,1),(32722266,53332078,4,2),(32722266,53332075,4,3),(32722266,53332072,4,4),(32722266,53332070,4,5),(32722266,53332068,4,6),(32722266,53332065,4,7),(32722266,53332062,4,8),(32722266,53332059,4,9),(32722266,53332056,4,10),(32722266,53319829,4,11),(32722266,53319832,4,12),(32722266,53319833,4,13),(32722266,53319835,4,14),(32722447,368207292,2,1),(32722447,368207293,2,2),(32722447,368207294,2,3),(32722447,368207295,2,4),(32722447,368207296,2,5),(32722447,368207297,2,6),(32722447,368207298,2,7),(32722447,368207299,2,8),(32722447,368207300,2,9),(32722447,368207301,2,10),(32722447,368207302,2,11),(32722447,368207303,2,12),(32722447,368207305,2,13),(32722447,368207306,2,14),(32722447,52579373,2,15),(32722447,52579371,2,16),(32722447,52579369,2,17),(32722447,52579367,2,18),(32722447,52579365,2,19),(32722447,52579363,2,20),(32722447,52579361,2,21),(32722447,52579359,2,22),(32722447,52579357,2,23),(32722447,52579355,2,24),(32722447,52579353,2,25),(32722447,52579350,2,26),(32722447,52579349,2,27),(32722447,52579347,2,28),(32722447,52579345,2,29),(32722447,52579343,2,30),(32722447,52579342,2,31),(32722447,52579340,2,32),(32722447,52579339,2,33),(32722447,52579336,2,34),(32722447,52579335,2,35),(32722447,52579332,2,36),(32722447,52579331,2,37),(32722447,52579328,2,38),(32722447,52579327,2,39),(32722447,52579324,2,40),(32722447,52579323,2,41),(32722447,52579321,2,42),(32722447,52579319,2,43),(32722447,52579317,2,44),(32722447,52579315,2,45),(32722447,52579313,2,46),(32722447,52579312,2,47),(32722447,52579310,2,48),(32722447,52579308,2,49),(32722447,52579306,2,50),(32722447,52579303,2,51),(32722447,52579301,2,52),(32722447,52579299,2,53),(32722447,52579297,2,54),(32722447,52579296,2,55),(32722447,52579293,2,56),(32722447,52579292,2,57),(32722447,52579290,2,58),(32722447,52579287,2,59),(32722447,52579285,2,60),(32722447,52579282,2,61),(32722447,52579281,2,62),(32722447,52579279,2,63),(32722447,52579277,2,64),(32722447,52579275,2,65),(32722447,52579274,2,66),(32722447,52579271,2,67),(32722447,52579270,2,68),(32722447,52579269,2,69),(32722447,52579266,2,70),(32722447,52579265,2,71),(32722447,52579262,2,72),(32722447,52579261,2,73),(32722447,52579258,2,74),(32722447,52579257,2,75),(32722447,52579254,2,76),(32722447,52579252,2,77),(32722447,52579250,2,78),(32722447,52579248,2,79),(32722447,52579246,2,80),(32722447,52579243,2,81),(32722447,52579242,2,82),(32722447,52579240,2,83),(32722447,52579238,2,84),(32722447,52579236,2,85),(32722447,52579235,2,86),(32722447,52579233,2,87),(32722447,52579230,2,88),(32722447,52579229,2,89),(32722447,52579228,2,90),(32722447,52579227,2,91),(32722447,52579226,2,92),(32722447,52579225,2,93),(32722447,52579224,2,94),(32722447,52579222,2,95),(32722447,52579219,2,96),(32722447,52579216,2,97),(32722447,52579213,2,98),(32722447,52579211,2,99),(32722447,52579210,2,100),(32722447,52579208,2,101),(32722447,52579206,2,102),(32722447,52579203,2,103),(32722447,52579201,2,104),(32722447,52579199,2,105),(32722447,52579194,2,106),(32722447,52579190,2,107),(32722447,52579188,2,108),(32722447,52579184,2,109),(32722447,52579183,2,110),(32722447,52579179,2,111),(32722447,52579177,2,112),(32722447,52579173,2,113),(32722447,52579171,2,114),(32722447,52579167,2,115),(32722447,52579165,2,116),(32722447,52579163,2,117),(32722447,52579160,2,118),(32722447,52579159,2,119),(32722447,52579155,2,120),(32722447,52579153,2,121),(32722447,52579151,2,122),(32722447,52579149,2,123),(32722447,52579146,2,124),(32722447,52579145,2,125),(32722447,52579142,2,126),(32722447,52579140,2,127),(32722447,52579138,2,128),(32722447,52579135,2,129),(32722447,52579133,2,130),(32722447,52579131,2,131),(32722447,52579129,2,132),(32722447,52579126,2,133),(32722447,52579125,2,134),(32722447,52579122,2,135),(32722447,52579121,2,136),(32722447,52579118,2,137),(32722447,52579117,2,138),(32722447,52579115,2,139),(32722447,52579113,2,140),(32722447,52579111,2,141),(32722447,52579108,2,142),(32722447,52579107,2,143),(32722447,52579104,2,144),(32722447,52579103,2,145),(32722447,52579100,2,146),(32722447,52579099,2,147),(32722447,52579096,2,148),(32722447,52579092,2,149),(32722447,52579091,2,150),(32722447,52579089,2,151),(32722447,52579087,2,152),(32722447,52579084,2,153),(32722447,52579083,2,154),(32722447,52579081,2,155),(32722447,52579079,2,156),(32722447,52579077,2,157),(32722447,52579075,2,158),(32722447,52579074,2,159),(32722447,52579071,2,160),(32722447,52579069,2,161),(32722447,52579067,2,162),(32722447,52578877,2,163),(32722447,52578875,2,164),(32722447,52578872,2,165),(32722447,52578871,2,166),(32722447,52578867,2,167),(32722447,52578863,2,168),(32722447,52578861,2,169),(32722447,52578858,2,170),(32722447,52578856,2,171),(32722447,52578852,2,172),(32722447,52578848,2,173),(32722447,52578845,2,174),(32722447,52578843,2,175),(32722447,52578841,2,176),(32722447,52578839,2,177),(32722447,52578837,2,178),(32722447,52578835,2,179),(32722447,52578833,2,180),(32722447,52578830,2,181),(32722447,52578829,2,182),(32722447,52578826,2,183),(32722447,52578825,2,184),(32722447,52578822,2,185),(32722447,52578820,2,186),(32722447,52578818,2,187),(32722447,52578817,2,188),(32722447,52578814,2,189),(32722447,52578813,2,190),(32722447,52578810,2,191),(32722447,52578809,2,192),(32722447,52578806,2,193),(32722447,52578793,2,194),(32722447,52578792,2,195),(32722447,52578790,2,196),(32722447,52578788,2,197),(32722447,52578794,2,198),(32722447,52578786,2,199),(32722447,52578797,2,200),(32722447,52578783,2,201),(32722447,52578782,2,202),(32722447,52578780,2,203),(32722447,52578778,2,204),(32722447,52578776,2,205),(32722447,52578775,2,206),(32722447,52578800,2,207),(32722447,52578774,2,208),(32722447,52578773,2,209),(32722447,52578770,2,210),(32722447,52578769,2,211),(32722447,52578767,2,212),(32722447,52578764,2,213),(32722447,52578761,2,214),(32722447,52578760,2,215),(32722447,52578757,2,216),(32722447,52578754,2,217),(32722447,52578753,2,218),(32722447,52578750,2,219),(32722447,52578748,2,220),(32722447,52578746,2,221),(32722447,52578743,2,222),(32722447,52578740,2,223),(32722447,52578738,2,224),(32722447,52578735,2,225),(32722447,52578733,2,226),(32722447,52578730,2,227),(32722447,52578728,2,228),(32722447,52578727,2,229),(32722447,52578725,2,230),(32722447,52578724,2,231),(32722447,52578722,2,232),(32722447,52578720,2,233),(32722447,52578719,2,234),(32722447,52578716,2,235),(32722447,52578715,2,236),(32722447,52578713,2,237),(32722447,52578711,2,238),(32722447,52578708,2,239),(32722447,52578707,2,240),(32722447,52578705,2,241),(32722447,52578703,2,242),(32722447,52578701,2,243),(32722447,52578699,2,244),(32722447,52578697,2,245),(32722447,52578693,2,246),(32722447,52578690,2,247),(32722447,52578689,2,248),(32722447,52578686,2,249),(32722447,52578685,2,250),(32722447,52578682,2,251),(32722447,52578680,2,252),(32722447,52578679,2,253),(32722447,52578678,2,254),(32722447,52578677,2,255),(32722447,52578676,2,256),(32722447,52578675,2,257),(32722447,52578674,2,258),(32722447,52578673,2,259),(32722447,52578672,2,260),(32722447,52578671,2,261),(32722447,52578669,2,262),(32722447,52578668,2,263),(32722447,52578666,2,264),(32722447,52578665,2,265),(32722447,52578663,2,266),(32722447,52578662,2,267),(32722447,52578659,2,268),(32722447,52578657,2,269),(32722447,52578656,2,270),(32722447,52578654,2,271),(32722447,52578653,2,272),(32722447,52578651,2,273),(32722447,52578650,2,274),(32722447,52578648,2,275),(32722447,52578646,2,276),(32722447,52578644,2,277),(32722447,52578642,2,278),(32722447,52578640,2,279),(32722447,52578638,2,280),(32722447,52578581,2,281),(32722447,52578583,2,282),(32722447,52578586,2,283),(32722447,52578587,2,284),(32722447,52578590,2,285),(32722447,52578592,2,286),(32722447,52578594,2,287),(32722447,52578597,2,288),(32722447,52578598,2,289),(32722447,52578600,2,290),(32722447,52578601,2,291),(32722447,52578604,2,292),(32722447,52578605,2,293),(32722447,52578607,2,294),(32722447,52578610,2,295),(32722447,52578612,2,296),(32722447,52578614,2,297),(32722447,52578616,2,298),(32722447,52578617,2,299),(32722447,52578620,2,300),(32722447,52578621,2,301),(32722447,52578624,2,302),(32722447,52578626,2,303),(32722447,52578628,2,304),(32722447,52578630,2,305),(32722447,52578632,2,306),(32722447,52578634,2,307),(32722515,52595125,2,1),(32722515,349145208,2,2),(32722515,349145210,2,3),(32722515,349145211,2,4),(32722515,349145213,2,5),(32722515,349145214,2,6),(32722515,349145215,2,7),(32722515,349145217,2,8),(32722515,349145218,2,9),(32722515,349145220,2,10),(32722515,349145221,2,11),(32722515,349145223,2,12),(32722515,349145224,2,13),(32722515,349145226,2,14),(32722515,349145227,2,15),(32722515,349145229,2,16),(32722515,349145230,2,17),(32722515,349145232,2,18),(32722515,349145233,2,19),(32722515,349145235,2,20),(32722515,349145236,2,21),(32722515,349145237,2,22),(32722515,349145239,2,23),(32722515,349145240,2,24),(32722515,349145242,2,25),(32722515,349145243,2,26),(32722515,349145245,2,27),(32722515,349145246,2,28),(32722515,349145248,2,29),(32722515,349145249,2,30),(32722515,349145250,2,31),(32722515,349145281,2,32),(32722515,349145282,2,33),(32722515,349145283,2,34),(32722515,349145284,2,35),(32722515,349145285,2,36),(32722544,52595880,1,1),(32722544,52595878,1,2),(32722544,52595874,1,3),(32722544,52595872,1,4),(32722544,52595868,1,5),(32722544,52595865,1,6),(32722544,52595861,1,7),(32722544,52595860,1,8),(32722544,52595856,1,9),(32722544,52595854,1,10),(32722544,52595489,1,11),(32722544,52595486,1,12),(32722544,52595483,1,13),(32722544,52595203,1,14),(32722544,52595201,1,15),(32722544,52595198,1,16),(32722544,52595193,1,17),(32722544,52595191,1,18),(32722544,52595188,1,19),(32722544,52595187,1,20),(32722544,52595184,1,21),(32722544,52595181,1,22),(32722544,52595176,1,23),(32722544,52595173,1,24),(32722544,52595169,1,25),(32722544,52595168,1,26),(32722544,52595162,1,27),(32722544,52595161,1,28),(32722544,52595157,1,29),(32722544,52595155,1,30),(32722544,52595154,1,31),(32722544,52595153,1,32),(32722544,52595151,1,33),(32722544,52595148,1,34),(32722544,52595145,1,35),(32722544,52595144,1,36),(32722544,52595140,1,37),(32722544,52595137,1,38),(32722544,52595134,1,39),(32722544,52595131,1,40),(32722544,52595125,1,41),(32722657,52262163,1,1),(32722657,52262161,1,2),(32722657,52262158,1,3),(32722657,52262155,1,4),(32722657,52262152,1,5),(32722657,52262150,1,6),(32722657,52262146,1,7),(32722657,52262143,1,8),(32722657,52262139,1,9),(32722657,52262137,1,10),(32722657,52262136,1,11),(32722657,52262133,1,12),(32722657,52262131,1,13),(32722657,52262119,1,14),(32722657,52262117,1,15),(32722657,52262115,1,16),(32722657,52262114,1,17),(32722657,52262111,1,18),(32722657,52262109,1,19),(32722657,52262106,1,20),(32722657,52262103,1,21),(32722657,52262101,1,22),(32722657,52262097,1,23),(32722657,52262095,1,24),(32722657,52262092,1,25),(32722657,52262089,1,26),(32722657,52262087,1,27),(32722657,52262079,1,28),(32722657,52262081,1,29),(32722657,52262084,1,30),(32722657,52262086,1,31),(32722657,52262064,1,32),(32722658,52262168,3,1),(32722658,52262166,3,2),(32722658,52262163,3,3),(32722762,52286625,4,1),(32722762,52286623,4,2),(32722762,52286619,4,3),(32722762,52286617,4,4),(32722762,52286615,4,5),(32722762,52286613,4,6),(32722762,52286612,4,7),(32722762,52286610,4,8),(32722762,52286608,4,9),(32722762,52286605,4,10),(32722762,52286604,4,11),(32722762,52286599,4,12),(32722762,52286596,4,13),(32722762,52286593,4,14),(32722762,52286590,4,15),(32722762,52286588,4,16),(32722762,52286585,4,17),(32722762,52286582,4,18),(32722762,52286581,4,19),(32722762,52286579,4,20),(32722762,52286577,4,21),(32722762,52286574,4,22),(32722762,52286568,4,23),(32722762,52286566,4,24),(32722762,52286564,4,25),(32722762,52286561,4,26),(32722762,52286560,4,27),(32722762,52286556,4,28),(32722762,52286554,4,29),(32722762,52286552,4,30),(32722762,52286549,4,31),(32722762,52286547,4,32),(32722762,52286545,4,33),(32722762,52286542,4,34),(32722762,52286541,4,35),(32722762,52286538,4,36),(32722762,52286537,4,37),(32722762,52286534,4,38),(32722762,52286531,4,39),(32722762,52286528,4,40),(32722762,52286527,4,41),(32722762,52286524,4,42),(32722762,52286521,4,43),(32722762,52286520,4,44),(32722762,52286505,4,45),(32722762,52286504,4,46),(32722762,52286502,4,47),(32722762,52286500,4,48),(32722762,52286497,4,49),(32722762,52286496,4,50),(32722762,52286493,4,51),(32722762,52286490,4,52),(32722762,52286488,4,53),(32722762,52286485,4,54),(32722762,52286483,4,55),(32722762,52286479,4,56),(32722762,52286476,4,57),(32722762,52286473,4,58),(32722762,52286470,4,59),(32722762,52286468,4,60),(32722762,52286465,4,61),(32722762,52286462,4,62),(32722762,52286458,4,63),(32722762,52286456,4,64),(32722762,52286451,4,65),(32722762,52286448,4,66),(32722762,52286445,4,67),(32722762,52286441,4,68),(32722762,52286440,4,69),(32722762,52286438,4,70),(32722762,52286433,4,71),(32722762,52286430,4,72),(32722762,52286422,4,73),(32722762,52286419,4,74),(32722762,52286415,4,75),(32722762,52286411,4,76),(32722762,52286408,4,77),(32722762,52285017,4,78),(32722762,52285012,4,79),(32722762,52285005,4,80),(32722762,52285000,4,81),(32722762,52284996,4,82),(32722762,52284990,4,83),(32722762,52284986,4,84),(32722762,52284983,4,85),(32722762,52284979,4,86),(32722762,52284974,4,87),(32722762,52284971,4,88),(32722762,52284966,4,89),(32722762,52284960,4,90),(32722762,52284957,4,91),(32722762,52284953,4,92),(32722762,52284949,4,93),(32722762,52284942,4,94),(32722762,52284939,4,95),(32722762,52284936,4,96),(32722762,52284933,4,97),(32722762,52284929,4,98),(32722762,52284922,4,99),(32722762,52284919,4,100),(32722762,52284916,4,101),(32722762,52284910,4,102),(32722762,52284906,4,103),(32722762,52284901,4,104),(32722762,52284894,4,105),(32722762,52284889,4,106),(32722762,52284886,4,107),(32722762,52284881,4,108),(32722762,52284876,4,109),(32722762,52284871,4,110),(32722762,52284867,4,111),(32722762,52284863,4,112),(32722762,52284857,4,113),(32722762,52284852,4,114),(32722762,52284849,4,115),(32722762,52284845,4,116),(32722762,52284842,4,117),(32722762,52284840,4,118),(32722762,52284838,4,119),(32722762,52284836,4,120),(32722762,52284832,4,121),(32722762,52284826,4,122),(32722762,52284823,4,123),(32722762,52284821,4,124),(32722762,52284816,4,125),(32722762,52284813,4,126),(32722762,52284810,4,127),(32722762,52284806,4,128),(32722762,52284802,4,129),(32722762,52284798,4,130),(32722762,52284796,4,131),(32722762,52284790,4,132),(32722762,52284787,4,133),(32722762,52284730,4,134),(32722762,52284528,4,135),(32722762,52284519,4,136),(32722762,52284516,4,137),(32722762,52284514,4,138),(32722762,52284511,4,139),(32722762,52284509,4,140),(32722762,52284506,4,141),(32722762,52284498,4,142),(32722762,52284494,4,143),(32722762,52284492,4,144),(32722762,52284491,4,145),(32722762,52284488,4,146),(32722762,52284484,4,147),(32722762,52284478,4,148),(32722762,52284474,4,149),(32722762,52284467,4,150),(32722762,52284446,4,151),(32722762,52284434,4,152),(32722762,52284408,4,153),(32722762,52284388,4,154),(32722762,52284383,4,155),(32722762,52284375,4,156),(32722762,52284371,4,157),(32722762,52284354,4,158),(32722762,52284351,4,159),(32722762,52284345,4,160),(32722762,52284281,4,161),(32722762,52284228,4,162),(32722762,52283881,4,163),(32722762,52283862,4,164),(32722762,52283856,4,165),(32722762,52283852,4,166),(32722762,52283844,4,167),(32722762,52283841,4,168),(32722762,52283839,4,169),(32722762,52283821,4,170),(32722762,52283304,4,171),(32722762,52283115,4,172),(32722762,52283101,4,173),(32722762,52283094,4,174),(32722762,52283089,4,175),(32722762,52268166,4,176),(32722762,52268163,4,177),(32722762,52268160,4,178),(32722762,52268156,4,179),(32722762,52268151,4,180),(32722762,52268147,4,181),(32722762,52268141,4,182),(32722762,52268137,4,183),(32722762,52268133,4,184),(32722762,52268128,4,185),(32722762,52268120,4,186),(32722762,52268118,4,187),(32722762,52268116,4,188),(32722762,52268039,4,189),(32722762,52268014,4,190),(32722762,52268011,4,191),(32722762,52268007,4,192),(32722762,52267852,4,193),(32722762,52267772,4,194),(32722762,52267141,4,195),(32722762,52266974,4,196),(32722762,52266970,4,197),(32722762,52266951,4,198),(32722762,52266950,4,199),(32722762,52266938,4,200),(32722762,52266924,4,201),(32722762,52266920,4,202),(32722762,52266907,4,203),(32722762,52266758,4,204),(32722762,52266755,4,205),(32722762,52266753,4,206),(32722762,52266751,4,207),(32722762,52266744,4,208),(32722762,52266660,4,209),(32722762,52266649,4,210),(32722762,52266636,4,211),(32722762,52266609,4,212),(32722762,52265659,4,213),(32722762,52265126,4,214),(32722762,52265123,4,215),(32722762,52265098,4,216),(32722762,52265093,4,217),(32722762,52265091,4,218),(32722762,52265090,4,219),(32722762,52265087,4,220),(32722762,52265086,4,221),(32722762,52265083,4,222),(32722762,52265080,4,223),(32722762,52265070,4,224),(32722762,52265067,4,225),(32722762,52265066,4,226),(32722762,52265063,4,227),(32722762,52265062,4,228),(32722762,52265060,4,229),(32722762,52265058,4,230),(32722762,52265056,4,231),(32722762,52265054,4,232),(32722762,52265051,4,233),(32722762,52265050,4,234),(32722762,52265047,4,235),(32722762,52265046,4,236),(32722762,52265045,4,237),(32722762,52265042,4,238),(32722762,52265039,4,239),(32722762,52265038,4,240),(32722762,52265037,4,241),(32722762,52265035,4,242),(32722762,52265034,4,243),(32722762,52265032,4,244),(32722762,52265031,4,245),(32722762,52265029,4,246),(32722762,52265028,4,247),(32722762,52265026,4,248),(32722762,52265025,4,249),(32722762,52265024,4,250),(32722762,52265022,4,251),(32722762,52265020,4,252),(32722762,52265016,4,253),(32722762,52264090,4,254),(32722762,52264070,4,255),(32722762,52264068,4,256),(32722762,52264067,4,257),(32722762,52264051,4,258),(32722762,52264041,4,259),(32722762,52264034,4,260),(32722762,52264022,4,261),(32722762,52264020,4,262),(32722762,52264018,4,263),(32722762,52264015,4,264),(32722762,52264013,4,265),(32722762,52264009,4,266),(32722762,52264006,4,267),(32722762,52264003,4,268),(32722762,52263999,4,269),(32722762,52263997,4,270),(32722762,52263996,4,271),(32722762,52263994,4,272),(32722762,52263993,4,273),(32722762,52263992,4,274),(32722762,52263990,4,275),(32722762,52263989,4,276),(32722762,52263987,4,277),(32722762,52263986,4,278),(32722762,52263985,4,279),(32722762,52263984,4,280),(32722762,52263982,4,281),(32722762,52263981,4,282),(32722762,52263979,4,283),(32722762,52263978,4,284),(32722762,52263977,4,285),(32722762,52263975,4,286),(32722762,52263973,4,287),(32722762,52263972,4,288),(32722762,52263969,4,289),(32722762,52263968,4,290),(32722762,52263965,4,291),(32722762,52263964,4,292),(32722762,52263962,4,293),(32722762,52263961,4,294),(32722762,52263959,4,295),(32722762,52263957,4,296),(32722762,52263955,4,297),(32722762,52263954,4,298),(32722762,52263952,4,299),(32722762,52263951,4,300),(32722762,52263950,4,301),(32722762,52263948,4,302),(32722762,52263947,4,303),(32722762,52263945,4,304),(32722762,52263944,4,305),(32722762,52263941,4,306),(32722762,52263938,4,307),(32722762,52263937,4,308),(32722762,52263935,4,309),(32722762,52263932,4,310),(32722762,52263929,4,311),(32722762,52263926,4,312),(32722762,52263924,4,313),(32722762,52263921,4,314),(32722762,52263919,4,315),(32722762,52263917,4,316),(32722762,52263914,4,317),(32722762,52263913,4,318),(32722762,52263910,4,319),(32722762,52263908,4,320),(32722762,52263906,4,321),(32722762,52263903,4,322),(32722762,52263901,4,323),(32722762,52263898,4,324),(32722762,52263896,4,325),(32722762,52263893,4,326),(32722762,52263891,4,327),(32722762,52263888,4,328),(32722762,52263887,4,329),(32722762,52263883,4,330),(32722762,52263882,4,331),(32722762,52263852,4,332),(32722762,52263850,4,333),(32722762,52263849,4,334),(32722762,52263846,4,335),(32722762,52263843,4,336),(32722762,52263839,4,337),(32722762,52263837,4,338),(32722762,52263835,4,339),(32722762,52263868,4,340),(32722762,52263832,4,341),(32722762,52263829,4,342),(32722762,52263827,4,343),(32722762,52263825,4,344),(32722762,52263823,4,345),(32722762,52263820,4,346),(32722762,52263818,4,347),(32722762,52263817,4,348),(32722762,52263815,4,349),(32722762,52263813,4,350),(32722762,52263811,4,351),(32722762,52263808,4,352),(32722762,52263806,4,353),(32722762,52263803,4,354),(32722762,52263802,4,355),(32722762,52263800,4,356),(32722762,52263798,4,357),(32722762,52263797,4,358),(32722762,52263796,4,359),(32722762,52263795,4,360),(32722762,52263794,4,361),(32722762,52263793,4,362),(32722762,52263792,4,363),(32722762,52263790,4,364),(32722762,52263788,4,365),(32722762,52263787,4,366),(32722762,52263785,4,367),(32722762,52263784,4,368),(32722762,52263782,4,369),(32722762,52263781,4,370),(32722762,52263779,4,371),(32722762,52263777,4,372),(32722762,52263775,4,373),(32722762,52263774,4,374),(32722762,52263772,4,375),(32722762,52263771,4,376),(32722762,52263769,4,377),(32722762,52263767,4,378),(32722762,52263766,4,379),(32722762,52263765,4,380),(32722762,52263763,4,381),(32722762,52263762,4,382),(32722762,52263760,4,383),(32722762,52263757,4,384),(32722762,52263755,4,385),(32722762,52263754,4,386),(32722762,52263750,4,387),(32722762,52263749,4,388),(32722762,52263747,4,389),(32722762,52263746,4,390),(32722762,52263744,4,391),(32722762,52263743,4,392),(32722762,52263742,4,393),(32722762,52263739,4,394),(32722762,52263738,4,395),(32722762,52263736,4,396),(32722762,52263734,4,397),(32722762,52263732,4,398),(32722762,52263731,4,399),(32722762,52263730,4,400),(32722762,52263543,4,401),(32722762,52263541,4,402),(32722762,52263537,4,403),(32722762,52263533,4,404),(32722762,52263530,4,405),(32722762,52263527,4,406),(32722762,52263524,4,407),(32722762,52263520,4,408),(32722762,52263519,4,409),(32722762,52263621,4,410),(32722762,52263516,4,411),(32722762,52263513,4,412),(32722762,52263512,4,413),(32722762,52263509,4,414),(32722762,52263507,4,415),(32722762,52263506,4,416),(32722762,52263504,4,417),(32722762,52263502,4,418),(32722762,52263498,4,419),(32722762,52263416,4,420),(32722762,52263414,4,421),(32722762,52263411,4,422),(32722762,52263546,4,423),(32722762,52263234,4,424),(32722762,52263233,4,425),(32722762,371357928,4,426),(32722762,52263231,4,427),(32722762,52263227,4,428),(32722762,52263224,4,429),(32722762,52263220,4,430),(32722762,52263217,4,431),(32722762,52263213,4,432),(32722762,52263209,4,433),(32722762,52263208,4,434),(32722762,52263203,4,435),(32722762,52263200,4,436),(32722762,52263158,4,437),(32722762,52263155,4,438),(32722762,52263152,4,439),(32722762,52263149,4,440),(32722762,52263144,4,441),(32722762,52263142,4,442),(32722762,52263140,4,443),(32722762,52263136,4,444),(32722762,52263133,4,445),(32722762,52263195,4,446),(32722762,52263130,4,447),(32722762,52263126,4,448),(32722762,52263124,4,449),(32722762,52263122,4,450),(32722762,52262908,4,451),(32722762,52262905,4,452),(32722762,52262903,4,453),(32722762,52262901,4,454),(32722762,52262898,4,455),(32722762,52263086,4,456),(32722762,52262896,4,457),(32722762,52263090,4,458),(32722762,52262967,4,459),(32722762,52262893,4,460),(32722762,52262892,4,461),(32722762,52262889,4,462),(32722762,52262887,4,463),(32722762,52262884,4,464),(32722762,52262883,4,465),(32722762,52262878,4,466),(32722762,52262874,4,467),(32722762,52262869,4,468),(32722762,52262866,4,469),(32722762,52262862,4,470),(32722762,52262858,4,471),(32722762,52262854,4,472),(32722762,52262850,4,473),(32722762,52262848,4,474),(32722762,52262845,4,475),(32722762,52262842,4,476),(32722762,52262838,4,477),(32722762,52262836,4,478),(32722762,52262833,4,479),(32722762,52262830,4,480),(32722762,52262826,4,481),(32722762,52262824,4,482),(32722762,52262821,4,483),(32722762,52262938,4,484),(32722762,52262817,4,485),(32722762,52262814,4,486),(32722762,52262809,4,487),(32722762,52262805,4,488),(32722762,52262802,4,489),(32722762,52262798,4,490),(32722762,52262796,4,491),(32722762,52262792,4,492),(32722762,52262788,4,493),(32722762,52262784,4,494),(32722762,52262781,4,495),(32722762,52262776,4,496),(32722762,52262773,4,497),(32722762,52262768,4,498),(32722762,52262764,4,499),(32722762,52262760,4,500),(32722762,52262757,4,501),(32722762,52262752,4,502),(32722762,52262748,4,503),(32722762,52262746,4,504),(32722762,52262742,4,505),(32722762,52262738,4,506),(32722762,52262736,4,507),(32722762,52262732,4,508),(32722762,52262729,4,509),(32722762,52262727,4,510),(32722762,52262725,4,511),(32722762,52262723,4,512),(32722762,52262718,4,513),(32722762,52262713,4,514),(32722762,52262710,4,515),(32722762,52262706,4,516),(32722762,52262703,4,517),(32722762,52262700,4,518),(32722762,52262698,4,519),(32722762,52262695,4,520),(32722762,52262691,4,521),(32722762,52262688,4,522),(32722762,52262684,4,523),(32722762,52262678,4,524),(32722762,52262675,4,525),(32722762,52262671,4,526),(32722762,52262666,4,527),(32722762,52262664,4,528),(32722762,52262661,4,529),(32722762,52262659,4,530),(32722762,52262654,4,531),(32722762,52262650,4,532),(32722762,52262646,4,533),(32722762,52262644,4,534),(32722762,52262641,4,535),(32722762,52262637,4,536),(32722762,52262636,4,537),(32722762,52262632,4,538),(32722762,52262629,4,539),(32722762,52262625,4,540),(32722762,52262622,4,541),(32722762,52262618,4,542),(32722762,52262616,4,543),(32722762,52262612,4,544),(32722762,52262609,4,545),(32722762,52262607,4,546),(32722762,52262605,4,547),(32722762,52262602,4,548),(32722762,52262598,4,549),(32722762,52262594,4,550),(32722762,52262590,4,551),(32722762,52262586,4,552),(32722762,52262583,4,553),(32722762,52262579,4,554),(32722762,52262575,4,555),(32722762,52262573,4,556),(32722762,52262570,4,557),(32722762,52262535,4,558),(32722762,52262566,4,559),(32722762,52262531,4,560),(32722762,52262527,4,561),(32722762,52262523,4,562),(32722762,52262521,4,563),(32722762,52262515,4,564),(32722762,52262512,4,565),(32722762,52262509,4,566),(32722762,52262504,4,567),(32722762,52262500,4,568),(32722762,52262498,4,569),(32722762,52262495,4,570),(32722762,52262492,4,571),(32722762,52262488,4,572),(32722762,52262328,4,573),(32722762,52262325,4,574),(32722762,52262321,4,575),(32722762,52262317,4,576),(32722762,52262485,4,577),(32722762,52262316,4,578),(32722762,52262313,4,579),(32722762,52262310,4,580),(32722762,52262306,4,581),(32722762,52262303,4,582),(32722762,52262300,4,583),(32722762,52262297,4,584),(32722762,52262293,4,585),(32722762,52262290,4,586),(32722762,52262287,4,587),(32722762,52262283,4,588),(32722762,52262279,4,589),(32722762,52262275,4,590),(32722762,52262271,4,591),(32722762,52262265,4,592),(32722762,52262263,4,593),(32722762,52262259,4,594),(32722762,52262257,4,595),(32722762,52262252,4,596),(32722762,52262251,4,597),(32722762,52262247,4,598),(32722762,52262245,4,599),(32722762,52262244,4,600),(32722762,52262240,4,601),(32722762,52262239,4,602),(32722762,52262236,4,603),(32722762,52262233,4,604),(32722762,52262231,4,605),(32722762,52262229,4,606),(32722762,52262225,4,607),(32722762,52262221,4,608),(32722762,52262217,4,609),(32722762,52262215,4,610),(32722762,52262213,4,611),(32722762,52262210,4,612),(32722762,52262207,4,613),(32722762,52262204,4,614),(32722762,52262201,4,615),(32722762,52262198,4,616),(32722762,52262193,4,617),(32722762,52262191,4,618),(32722762,52262187,4,619),(32722762,52262183,4,620),(32722762,52262179,4,621),(32722762,52262176,4,622),(32722762,52262168,4,623),(32722815,52268166,3,1),(32722815,368212962,3,2),(32722815,368212966,3,3),(32722815,368212967,3,4),(32722815,52286643,3,5),(32722815,52286640,3,6),(32722815,52286636,3,7),(32722815,52286651,3,8),(32722815,52286652,3,9),(32722815,52286655,3,10),(32722815,52286658,3,11),(32722815,52286661,3,12),(32722815,52286663,3,13),(32722815,52286665,3,14),(32722815,52286667,3,15),(32722815,52286668,3,16),(32722815,52286671,3,17),(32722815,52286674,3,18),(32722815,52286677,3,19),(32722815,52286679,3,20),(32722815,52286681,3,21),(32722815,52286683,3,22),(32722815,52286685,3,23),(32722815,52286688,3,24),(32722815,52286691,3,25),(32722815,52286694,3,26),(32722815,52286697,3,27),(32722815,52286698,3,28),(32722815,52286701,3,29),(32722815,52286702,3,30),(32722815,52286705,3,31),(32722815,52286706,3,32),(32722815,52286709,3,33),(32722815,52286712,3,34),(32722815,52286715,3,35),(32722815,52286719,3,36),(32722815,52286721,3,37),(32722815,52286723,3,38),(32722815,52286725,3,39),(32722815,52286728,3,40),(32722815,52286730,3,41),(32722815,52286733,3,42),(32722815,52286735,3,43),(32722815,52286740,3,44),(32722815,52286743,3,45),(32722815,52286746,3,46),(32722815,52286750,3,47),(32722815,52286751,3,48),(32722815,52286754,3,49),(32722815,52286757,3,50),(32722815,52286759,3,51),(32722815,52286763,3,52),(32722815,52286765,3,53),(32722815,52286769,3,54),(32722815,52286770,3,55),(32722815,52286772,3,56),(32722815,52286774,3,57),(32722815,52286776,3,58),(32722815,52286777,3,59),(32722815,52286779,3,60),(32722815,52286781,3,61),(32722815,52286783,3,62),(32722815,52286785,3,63),(32722815,52286787,3,64),(32722815,52286789,3,65),(32722815,52286792,3,66),(32722815,52286793,3,67),(32722815,52286795,3,68),(32722815,52286798,3,69),(32722815,52286802,3,70),(32722815,52286807,3,71),(32722815,52286809,3,72),(32722815,52286812,3,73),(32722815,52286814,3,74),(32722815,52286817,3,75),(32722815,52286820,3,76),(32722815,52286823,3,77),(32722815,52286825,3,78),(32722815,52286826,3,79),(32722815,52286829,3,80),(32722815,52286831,3,81),(32722815,52286835,3,82),(32722815,52286836,3,83),(32722815,52286838,3,84),(32722815,52286841,3,85),(32722815,52286845,3,86),(32722815,52286847,3,87),(32722815,52286850,3,88),(32722815,52286853,3,89),(32722815,52286855,3,90),(32722815,52286856,3,91),(32722815,52286860,3,92),(32722815,52286861,3,93),(32722815,52286865,3,94),(32722815,52286867,3,95),(32722815,52286868,3,96),(32722815,52286871,3,97),(32722815,52286874,3,98),(32722815,52286876,3,99),(32722815,52286880,3,100),(32722815,52286883,3,101),(32722815,52286885,3,102),(32722815,52286889,3,103),(32722815,52286892,3,104),(32722815,52286895,3,105),(32722815,52286896,3,106),(32722815,52286899,3,107),(32722815,52286902,3,108),(32722815,52286904,3,109),(32722815,52286906,3,110),(32722815,52286908,3,111),(32722815,52286910,3,112),(32722815,52286912,3,113),(32722815,52286914,3,114),(32722815,52286917,3,115),(32722815,52286920,3,116),(32722815,52286923,3,117),(32722815,52286924,3,118),(32722815,52286926,3,119),(32722815,52286929,3,120),(32722815,52286932,3,121),(32722815,52286935,3,122),(32722815,52286936,3,123),(32722815,52286938,3,124),(32722815,52286941,3,125),(32722815,52286944,3,126),(32722815,52286975,3,127),(32722815,52286977,3,128),(32722815,52286979,3,129),(32722815,52286981,3,130),(32722815,52286982,3,131),(32722815,52286983,3,132),(32722815,52286986,3,133),(32722815,52286987,3,134),(32722815,52286990,3,135),(32722815,52286991,3,136),(32722815,52286994,3,137),(32722815,52286997,3,138),(32722815,52287000,3,139),(32722815,52287003,3,140),(32722815,52287005,3,141),(32722815,52287008,3,142),(32722815,52287010,3,143),(32722815,52287013,3,144),(32722815,52287015,3,145),(32722815,52287018,3,146),(32722815,52287019,3,147),(32722815,52287022,3,148),(32722815,52287024,3,149),(32722815,52287027,3,150),(32722815,52287029,3,151),(32722815,52287030,3,152),(32722815,52287033,3,153),(32722815,52287034,3,154),(32722815,52287037,3,155),(32722815,52287040,3,156),(32722815,52287043,3,157),(32722815,52287045,3,158),(32722815,52287048,3,159),(32722815,52287051,3,160),(32722815,52287053,3,161),(32722815,52287056,3,162),(32722815,52287066,3,163),(32722815,52287068,3,164),(32722815,52287071,3,165),(32722815,52287074,3,166),(32722815,52287076,3,167),(32722815,52287078,3,168),(32722815,52287082,3,169),(32722815,52287084,3,170),(32722815,52287085,3,171),(32722815,52287089,3,172),(32722815,52287092,3,173),(32722815,52287095,3,174),(32722815,52287098,3,175),(32722815,52287101,3,176);
INSERT INTO `way_nodes` VALUES (32722815,52287103,3,177),(32722815,52287106,3,178),(32722815,52287110,3,179),(32722815,52287111,3,180),(32722815,52287114,3,181),(32722815,52287116,3,182),(32722815,52287117,3,183),(32722815,52287119,3,184),(32722815,52287120,3,185),(32722815,52287123,3,186),(32722815,52287127,3,187),(32722815,52287129,3,188),(32722815,52287132,3,189),(32722815,52287135,3,190),(32722815,52287138,3,191),(32722815,52287140,3,192),(32722815,52287142,3,193),(32722815,52287144,3,194),(32722815,52287147,3,195),(32722815,52287150,3,196),(32722815,52287153,3,197),(32722815,52287156,3,198),(32722815,52287159,3,199),(32722815,52287160,3,200),(32722815,52287163,3,201),(32722815,52287165,3,202),(32722815,52287167,3,203),(32722815,52287170,3,204),(32722815,52287173,3,205),(32722815,52287174,3,206),(32722815,52287177,3,207),(32722815,52287181,3,208),(32722815,52287183,3,209),(32722815,52287186,3,210),(32722815,52287188,3,211),(32722815,52287191,3,212),(32722815,52287192,3,213),(32722815,52287193,3,214),(32722815,52287194,3,215),(32722815,52287196,3,216),(32722815,52287198,3,217),(32722815,52287200,3,218),(32722815,52287202,3,219),(32722815,52287205,3,220),(32722815,52287208,3,221),(32722815,52287210,3,222),(32722815,52287212,3,223),(32722815,52287216,3,224),(32722815,52287217,3,225),(32722815,52287220,3,226),(32722815,52287223,3,227),(32722815,52287225,3,228),(32722815,52287228,3,229),(32722815,52287231,3,230),(32722815,52287234,3,231),(32722815,52287238,3,232),(32722815,52287239,3,233),(32722815,52287243,3,234),(32722815,52287244,3,235),(32722815,52287247,3,236),(32722815,52287251,3,237),(32722815,52287254,3,238),(32722815,52287255,3,239),(32722815,52287257,3,240),(32722815,52287260,3,241),(32722815,52287262,3,242),(32722815,52287265,3,243),(32722815,52287268,3,244),(32722815,52287271,3,245),(32722815,52287274,3,246),(32722815,52287276,3,247),(32722815,52287278,3,248),(32722815,52287283,3,249),(32722815,52287286,3,250),(32722815,52287289,3,251),(32722815,52287292,3,252),(32722815,52287295,3,253),(32722815,52287299,3,254),(32722815,52287301,3,255),(32722815,52287305,3,256),(32722815,52287308,3,257),(32722815,52287311,3,258),(32722815,52287315,3,259),(32722815,52287317,3,260),(32722815,52287320,3,261),(32722815,52287323,3,262),(32722815,52287326,3,263),(32722815,52287329,3,264),(32722815,52287331,3,265),(32722815,52287335,3,266),(32722815,52287354,3,267),(32722815,52287357,3,268),(32722815,52287360,3,269),(32722815,52287362,3,270),(32722815,52287364,3,271),(32722815,52287369,3,272),(32722815,52287371,3,273),(32722815,52287373,3,274),(32722815,52287378,3,275),(32722815,52287380,3,276),(32722815,52287384,3,277),(32722815,52287387,3,278),(32722815,52287392,3,279),(32722815,52287393,3,280),(32722815,52287395,3,281),(32722815,52287399,3,282),(32722815,52287400,3,283),(32722815,52287403,3,284),(32722815,52287408,3,285),(32722815,52287411,3,286),(32722815,52287414,3,287),(32722815,52287417,3,288),(32722815,52287422,3,289),(32722815,52287426,3,290),(32722815,52287428,3,291),(32722815,52287430,3,292),(32722815,52287433,3,293),(32722815,52287436,3,294),(32722815,52287441,3,295),(32722815,52287443,3,296),(32722815,52287444,3,297),(32722815,52287447,3,298),(32722815,52287449,3,299),(32722815,52287453,3,300),(32722815,52287457,3,301),(32722815,52287459,3,302),(32722815,52287462,3,303),(32722815,52287464,3,304),(32722815,52287467,3,305),(32722815,52287470,3,306),(32722815,52287473,3,307),(32722815,52287477,3,308),(32722815,52287480,3,309),(32722815,52287483,3,310),(32722815,52287486,3,311),(32722815,52287489,3,312),(32722815,52287492,3,313),(32722815,52287495,3,314),(32722815,52287499,3,315),(32722815,52287501,3,316),(32722815,52287504,3,317),(32722815,52287506,3,318),(32722815,52287509,3,319),(32722815,52287511,3,320),(32722815,52287512,3,321),(32722815,52287515,3,322),(32722815,52287517,3,323),(32722815,52287519,3,324),(32722815,52287522,3,325),(32722815,52287524,3,326),(32722815,52287527,3,327),(32722815,52287528,3,328),(32722815,52287532,3,329),(32722815,52287534,3,330),(32722815,52287536,3,331),(32722815,52287538,3,332),(32722815,52287542,3,333),(32722815,52287544,3,334),(32722815,52287548,3,335),(32722815,52287551,3,336),(32722815,52287552,3,337),(32722815,52287555,3,338),(32722815,52287560,3,339),(32722815,52287562,3,340),(32722815,52287565,3,341),(32722815,52287568,3,342),(32722815,52287570,3,343),(32722815,52287572,3,344),(32722815,52287575,3,345),(32722815,52287578,3,346),(32722815,52287580,3,347),(32722815,52287583,3,348),(32722815,52287584,3,349),(32722815,52287588,3,350),(32722815,52287591,3,351),(32722815,52287592,3,352),(32722815,52287594,3,353),(32722815,52287600,3,354),(32722815,52287603,3,355),(32722815,52287605,3,356),(32722815,52287608,3,357),(32722815,52287622,3,358),(32722815,52287609,3,359),(32722815,52287612,3,360),(32722815,52287616,3,361),(32722815,52287619,3,362),(32722815,52287624,3,363),(32722815,52287627,3,364),(32722815,52287629,3,365),(32722815,52287631,3,366),(32722815,52287633,3,367),(32722815,52287634,3,368),(32722815,52287636,3,369),(32722815,52287638,3,370),(32722815,52287640,3,371),(32722815,52287642,3,372),(32722815,52287643,3,373),(32722815,52287644,3,374),(32722815,52287645,3,375),(32722815,52287648,3,376),(32722815,52287649,3,377),(32722815,52287651,3,378),(32722815,52287653,3,379),(32722815,52287654,3,380),(32722815,52288116,3,381),(32722815,52288118,3,382),(32722815,52288119,3,383),(32722815,52288121,3,384),(32722815,52288122,3,385),(32722815,52288125,3,386),(32722815,52288128,3,387),(32722815,52288131,3,388),(32722815,52288133,3,389),(32722815,52288136,3,390),(32722815,52288137,3,391),(32722815,52288139,3,392),(32722815,52288141,3,393),(32722815,52288142,3,394),(32722815,52288145,3,395),(32722815,52288146,3,396),(32722815,52288150,3,397),(32722815,52288153,3,398),(32722815,52288155,3,399),(32722815,52288157,3,400),(32722815,52288161,3,401),(32722815,52288163,3,402),(32722815,52288165,3,403),(32722815,52288167,3,404),(32722815,52288170,3,405),(32722815,52288173,3,406),(32722815,52288175,3,407),(32722815,52288178,3,408),(32722815,52288179,3,409),(32722815,52288181,3,410),(32722815,52288183,3,411),(32722815,52288184,3,412),(32722815,52288185,3,413),(32722815,52288188,3,414),(32722815,52288190,3,415),(32722815,52288194,3,416),(32722815,52288196,3,417),(32722815,52288199,3,418),(32722815,52288203,3,419),(32722815,52288204,3,420),(32722815,52288207,3,421),(32722815,52288210,3,422),(32722815,52288211,3,423),(32722815,52288215,3,424),(32722815,52288216,3,425),(32722815,52288218,3,426),(32722815,52288221,3,427),(32722815,52288223,3,428),(32722815,52288225,3,429),(32722815,52288227,3,430),(32722815,52288231,3,431),(32722815,52288233,3,432),(32722815,52288235,3,433),(32722815,52288238,3,434),(32722815,52288241,3,435),(32722815,52288244,3,436),(32722815,52288248,3,437),(32722815,52288251,3,438),(32722815,52288253,3,439),(32722815,52288256,3,440),(32722815,52288258,3,441),(32722815,52288261,3,442),(32722815,52288265,3,443),(32722815,52288269,3,444),(32722815,52288266,3,445),(32722815,52288273,3,446),(32722815,52288275,3,447),(32722815,52288277,3,448),(32722815,52288281,3,449),(32722815,52288284,3,450),(32722815,52288285,3,451),(32722815,52288287,3,452),(32722815,52288289,3,453),(32722815,52288291,3,454),(32722815,52288293,3,455),(32722815,52288297,3,456),(32722815,52288298,3,457),(32722815,52288301,3,458),(32722815,52288304,3,459),(32722815,52288307,3,460),(32722815,52288310,3,461),(32722815,52288313,3,462),(32722815,52288317,3,463),(32722815,52288319,3,464),(32722815,52288321,3,465),(32722815,52288325,3,466),(32722815,52288327,3,467),(32722815,52288330,3,468),(32722815,52288331,3,469),(32722815,52288335,3,470),(32722815,52288337,3,471),(32722815,52288339,3,472),(32722815,52288341,3,473),(32722815,52288343,3,474),(32722815,52288345,3,475),(32722815,52288348,3,476),(32722815,52288350,3,477),(32722815,52288353,3,478),(32722815,52288357,3,479),(32722815,52288360,3,480),(32722815,52288361,3,481),(32722815,52288365,3,482),(32722815,52288368,3,483),(32722815,52288371,3,484),(32722815,52288375,3,485),(32722815,52288377,3,486),(32722815,52288381,3,487),(32722815,52288383,3,488),(32722815,52288387,3,489),(32722815,52297301,3,490),(32722815,52288388,3,491),(32722815,52288390,3,492),(32722815,52288393,3,493),(32722815,52288395,3,494),(32722815,52288398,3,495),(32722815,52288400,3,496),(32722815,52288403,3,497),(32722815,52288406,3,498),(32722815,52288407,3,499),(32722815,52288412,3,500),(32722815,52288413,3,501),(32722815,52288415,3,502),(32722815,52288417,3,503),(32722815,52288419,3,504),(32722815,52288423,3,505),(32722815,52288426,3,506),(32722815,52288429,3,507),(32722815,52288434,3,508),(32722815,52288435,3,509),(32722815,52288439,3,510),(32722815,52288442,3,511),(32722815,52288444,3,512),(32722815,52288448,3,513),(32722815,52288450,3,514),(32722815,52288453,3,515),(32722815,52288455,3,516),(32722815,52288458,3,517),(32722815,52297397,3,518),(32722815,52288460,3,519),(32722815,52288461,3,520),(32722815,52288465,3,521),(32722815,52288466,3,522),(32722815,52288469,3,523),(32722815,52288471,3,524),(32722815,52288474,3,525),(32722815,52288478,3,526),(32722815,52288494,3,527),(32722815,52288479,3,528),(32722815,52288482,3,529),(32722815,52288484,3,530),(32722815,52288487,3,531),(32722815,52288489,3,532),(32722815,52288491,3,533),(32722815,52288497,3,534),(32722815,52288498,3,535),(32722815,52297501,3,536),(32722815,52288501,3,537),(32722815,52288503,3,538),(32722815,52288504,3,539),(32722815,52288507,3,540),(32722815,52288509,3,541),(32722815,52288511,3,542),(32722815,52288514,3,543),(32722815,52288515,3,544),(32722815,52288518,3,545),(32722815,52288521,3,546),(32722815,52288524,3,547),(32722815,52288527,3,548),(32722815,52288529,3,549),(32722815,52288533,3,550),(32722815,52288535,3,551),(32722815,52288537,3,552),(32722815,52288541,3,553),(32722815,52288542,3,554),(32722815,52288545,3,555),(32722815,52288549,3,556),(32722815,52288552,3,557),(32722815,52288555,3,558),(32722815,52288558,3,559),(32722815,52288561,3,560),(32722815,52288565,3,561),(32722815,52288567,3,562),(32722815,52288570,3,563),(32722815,52288573,3,564),(32722815,52288575,3,565),(32722815,52288577,3,566),(32722815,52288578,3,567),(32722815,52288581,3,568),(32722815,52288583,3,569),(32722815,52288586,3,570),(32722815,52288588,3,571),(32722815,52288591,3,572),(32722815,52288594,3,573),(32722815,52297650,3,574),(32722815,52288597,3,575),(32722815,52288599,3,576),(32722815,52288601,3,577),(32722815,52288603,3,578),(32722815,52288606,3,579),(32722815,52288607,3,580),(32722815,52288610,3,581),(32722815,52288612,3,582),(32722815,52288614,3,583),(32722815,52288615,3,584),(32722815,52288619,3,585),(32722815,52288621,3,586),(32722815,52288624,3,587),(32722815,52288625,3,588),(32722815,52288627,3,589),(32722815,52288630,3,590),(32722815,52288632,3,591),(32722815,52288633,3,592),(32722815,52288636,3,593),(32722815,52288637,3,594),(32722815,52288639,3,595),(32722815,52288642,3,596),(32722815,52288644,3,597),(32722815,52288647,3,598),(32722815,52288650,3,599),(32722815,52288651,3,600),(32722815,52288653,3,601),(32722815,52288655,3,602),(32722815,52288658,3,603),(32722815,52288659,3,604),(32722815,52288665,3,605),(32722815,52288669,3,606),(32722815,52288672,3,607),(32722815,52288675,3,608),(32722815,52288684,3,609),(32722815,52288687,3,610),(32722815,52288689,3,611),(32722815,52288691,3,612),(32722815,52288695,3,613),(32722815,52288696,3,614),(32722815,52288697,3,615),(32722815,52288702,3,616),(32722815,52262076,3,617),(32819051,53319835,2,1),(32819051,53319838,2,2),(32819051,53319828,2,3),(32819051,53319839,2,4),(32819051,53325641,2,5),(32819051,53325645,2,6),(32819051,53325649,2,7),(32819051,53325657,2,8),(32819051,53325659,2,9),(32819051,53325663,2,10),(32819142,321682002,4,1),(32819142,321682000,4,2),(32819142,321681999,4,3),(32819142,321681998,4,4),(32819142,321681997,4,5),(32819142,321681996,4,6),(32819142,321681995,4,7),(32819142,321681994,4,8),(32819142,321681993,4,9),(32819142,321681992,4,10),(32819142,321681991,4,11),(32819142,321681990,4,12),(32819142,321681989,4,13),(32819142,321681988,4,14),(32819142,321681987,4,15),(32819142,321681986,4,16),(32819142,321681982,4,17),(32819142,321681981,4,18),(32819142,321681980,4,19),(32819142,321681979,4,20),(32819142,321681978,4,21),(32819142,321681977,4,22),(32819142,321681976,4,23),(32819142,321681975,4,24),(32819142,321681974,4,25),(32819142,321681972,4,26),(32819142,321681971,4,27),(32819142,321681970,4,28),(32819142,321681969,4,29),(32819142,321681968,4,30),(32819142,321681967,4,31),(32819142,321681966,4,32),(32819142,321681965,4,33),(32819142,321681964,4,34),(32819142,321681963,4,35),(32819142,321681962,4,36),(32819142,321681961,4,37),(32819142,321681958,4,38),(32819142,321681957,4,39),(32819142,321681953,4,40),(32819142,321681951,4,41),(32819142,321681950,4,42),(32819142,321681949,4,43),(32819142,321681947,4,44),(32819142,321681946,4,45),(32819142,321681945,4,46),(32819142,321681944,4,47),(32819142,321681943,4,48),(32819142,321681942,4,49),(32819142,53332123,4,50),(32819142,53332120,4,51),(32819142,53332117,4,52),(32819142,321682640,4,53),(32819142,53332113,4,54),(32819142,53332111,4,55),(32819142,53332109,4,56),(32819142,53332107,4,57),(32819142,53332105,4,58),(32819142,53332102,4,59),(32819142,53332100,4,60),(32819142,53332097,4,61),(32819142,53332094,4,62),(32819142,53332091,4,63),(32819142,53332089,4,64),(32819142,53332086,4,65),(32819142,53332083,4,66),(32819142,53332081,4,67),(32819142,53332079,4,68),(32845037,53295259,3,1),(32845037,53295264,3,2),(32845037,53306761,3,3),(32845037,53306758,3,4),(32845037,53306755,3,5),(32845037,53306752,3,6),(32845037,366577821,3,7),(32845037,370909276,3,8),(32845037,53306749,3,9),(32845037,53306746,3,10),(32845037,53306743,3,11),(32845037,53306742,3,12),(32845037,53306740,3,13),(32845037,53306738,3,14),(32845037,53306737,3,15),(32845037,53306734,3,16),(32845037,53306733,3,17),(32845037,53306730,3,18),(32845037,53306727,3,19),(32845037,53306726,3,20),(32845037,53306724,3,21),(32845037,53306723,3,22),(32845037,53306720,3,23),(32845037,53306717,3,24),(32845037,53306715,3,25),(32845037,53306713,3,26),(32845037,53306712,3,27),(32845037,53306710,3,28),(32845037,53306708,3,29),(32845037,53306706,3,30),(32845037,53306704,3,31),(32845037,53306702,3,32),(32845037,53306699,3,33),(32845037,53306527,3,34),(32845037,53306532,3,35),(32845037,53306534,3,36),(32845037,53306537,3,37),(32845037,53306540,3,38),(32845037,53306542,3,39),(32845037,53306543,3,40),(32845037,53306545,3,41),(32845037,53306547,3,42),(32845037,53306550,3,43),(32845037,53306552,3,44),(32845037,53306554,3,45),(32845037,53306556,3,46),(32845037,53306559,3,47),(32845037,53306562,3,48),(32845037,53306564,3,49),(32845037,53306565,3,50),(32845037,53306566,3,51),(32845037,53306568,3,52),(32845037,53306603,3,53),(32845037,53306606,3,54),(32845037,53306607,3,55),(32845037,53306609,3,56),(32845037,53306611,3,57),(32845037,53306613,3,58),(32845037,53306617,3,59),(32845037,53306620,3,60),(32845037,53306623,3,61),(32845037,53306626,3,62),(32845037,53306628,3,63),(32845037,53306631,3,64),(32845037,53306633,3,65),(32845037,53306635,3,66),(32845037,53306638,3,67),(32845037,53306641,3,68),(32845037,53306644,3,69),(32845037,53306647,3,70),(32845037,53306650,3,71),(32845037,53306652,3,72),(32845037,53306654,3,73),(32845037,53306657,3,74),(32845037,53306660,3,75),(32845037,53306662,3,76),(32845037,53306697,3,77),(32845037,53306665,3,78),(32845037,53306668,3,79),(32845037,370003845,3,80),(32845056,370003845,3,1),(32845056,370003846,3,2),(32845056,370003848,3,3),(32845056,370003849,3,4),(32845056,370003853,3,5),(32845063,370003853,1,1),(32845063,370003141,1,2),(32845063,53306689,1,3),(32845063,53306691,1,4),(32845063,53306693,1,5),(32845063,287397098,1,6),(32845063,287397484,1,7),(32845063,287396438,1,8),(32845063,287397486,1,9),(32845063,287397023,1,10),(32936885,53295356,2,1),(32936885,370903026,2,2),(32936885,370903027,2,3),(32936885,370903028,2,4),(32936885,370903029,2,5),(32936885,370903030,2,6),(32936960,53295310,1,1),(32936960,370903788,1,2),(32936960,370903791,1,3),(32936960,370903794,1,4),(32936960,370903796,1,5),(32937000,53295291,1,1),(32937000,370904334,1,2),(32937000,370904336,1,3),(32937000,370904339,1,4),(32937000,370904341,1,5),(32937225,370906892,3,1),(32937225,370908030,3,2),(32937225,370908032,3,3),(32937225,366577818,3,4),(32937225,370908035,3,5),(32937225,366577819,3,6),(32937225,366577820,3,7),(32937225,370909129,3,8),(32937225,370909130,3,9),(32937225,366577821,3,10),(32937397,370909282,1,1),(32937397,370909283,1,2),(32937397,370909284,1,3),(32937397,370909285,1,4),(32937397,370909286,1,5),(32937397,370909287,1,6),(32937397,370909276,1,7),(32937466,370909951,1,1),(32937466,370909953,1,2),(32937466,370909956,1,3),(32937466,370909959,1,4),(32937466,370909951,1,5),(32973912,371358341,2,1),(32973912,371358401,2,2),(32973912,371358405,2,3),(32973912,371358406,2,4),(32973912,371358407,2,5),(32973912,371358408,2,6),(32973912,371358409,2,7),(32973912,371358410,2,8),(32973912,371358411,2,9),(32973912,371358412,2,10),(32973912,371358413,2,11),(32973912,371358414,2,12),(32973912,371358415,2,13),(32973912,371358416,2,14),(32973912,371358419,2,15),(32973912,371358420,2,16),(32973912,371358421,2,17),(32973912,371358422,2,18),(32973912,371358423,2,19),(32973912,371358424,2,20),(32973912,371358425,2,21),(32973912,371358426,2,22),(32973912,371358429,2,23),(32973912,371358430,2,24),(32973912,371358431,2,25),(32973912,371358432,2,26),(32973912,371358433,2,27),(32973912,371358434,2,28),(32973912,371358435,2,29),(32973912,371358436,2,30),(32973912,371358437,2,31),(32973912,371358439,2,32),(32973912,371358441,2,33),(32973912,371358442,2,34),(32973912,371358443,2,35),(32973912,371358444,2,36),(32973912,371358445,2,37),(32973912,371357928,2,38),(33184240,321651052,1,1),(33184240,321651053,1,2),(33184240,321651054,1,3),(33184240,321651055,1,4),(33184240,321651056,1,5),(33184240,321651057,1,6),(33184240,321651059,1,7),(33184240,321651060,1,8),(33184240,321651080,1,9),(33184240,321651081,1,10),(33184240,321651082,1,11),(33184240,321651083,1,12),(33184240,321651084,1,13),(33184240,321651085,1,14),(33184240,321651086,1,15),(33184240,321651088,1,16),(33184240,321651089,1,17),(33184240,321651090,1,18),(33184240,321651091,1,19),(33184240,321651092,1,20),(33184240,321651093,1,21),(33184240,321651094,1,22),(33184240,321651095,1,23),(33184240,321651096,1,24),(33184240,321651097,1,25),(33184240,321651098,1,26),(33184240,321651099,1,27),(33184240,321651100,1,28),(33184240,321651101,1,29),(33184240,321651103,1,30),(33184240,321651104,1,31),(33184240,321651105,1,32),(33184240,321651106,1,33),(33184240,321651107,1,34),(33184240,321651108,1,35),(33184244,321679489,1,1),(33184244,321679490,1,2),(33184244,321679491,1,3),(33184244,321679492,1,4),(33184244,321679493,1,5),(33184244,321679494,1,6),(33184244,321679495,1,7),(33184244,321679496,1,8),(33184244,321679497,1,9),(33184244,321679498,1,10),(33184244,321679499,1,11),(33184244,321679500,1,12),(33184244,321679501,1,13),(33184244,321679502,1,14),(33184244,321679503,1,15),(33184244,321679505,1,16),(33184244,321679507,1,17),(33184244,321679508,1,18),(33184244,321679509,1,19),(33184244,321679510,1,20),(33184244,321679511,1,21),(33184244,321679512,1,22),(33184244,321679513,1,23),(33184244,321679514,1,24),(33184244,321679515,1,25),(33184244,321679516,1,26),(33184244,321679517,1,27),(33184247,321679568,1,1),(33184247,321679569,1,2),(33184247,321679570,1,3),(33184247,321679571,1,4),(33184247,321679572,1,5),(33184247,321679573,1,6),(33184247,321679574,1,7),(33184247,321679575,1,8),(33184247,321679576,1,9),(33184247,321679577,1,10),(33184247,321679578,1,11),(33184247,321679579,1,12),(33184247,321679580,1,13),(33184247,321679581,1,14),(33184247,321679582,1,15),(33184247,321679583,1,16),(33184247,321679584,1,17),(33184247,321679586,1,18),(33184247,321679587,1,19),(33184247,321679588,1,20),(33184247,321679589,1,21),(33184247,321679590,1,22),(33184247,321679591,1,23),(33184247,321679592,1,24),(33184247,321679593,1,25),(33184247,321679594,1,26),(33184247,321679595,1,27),(33184247,321679596,1,28),(33184247,321679597,1,29),(33184247,321679598,1,30),(33184247,321679599,1,31),(33184247,321679600,1,32),(33184247,321679601,1,33),(33184247,321679602,1,34),(33184247,321679603,1,35),(33184247,321679604,1,36),(33184247,321679605,1,37),(33184247,321679606,1,38),(33184247,321679607,1,39),(33184247,321679608,1,40),(33184247,321679609,1,41),(33184247,321679610,1,42),(33184247,321679611,1,43),(33184247,321679612,1,44),(33184247,321679613,1,45),(33184247,321679614,1,46),(33184247,321679615,1,47),(33184247,321679616,1,48),(33184247,321679617,1,49),(33184247,321679618,1,50),(33184247,321679619,1,51),(33184247,321679620,1,52),(33184247,321679621,1,53),(33184247,321679622,1,54),(33184247,321679623,1,55),(33184247,321679624,1,56),(33184247,321679626,1,57),(33184247,321679627,1,58),(33184247,321679628,1,59),(33184247,321679629,1,60),(33184247,321679630,1,61),(33184247,321679631,1,62),(33184247,321679632,1,63),(33184247,321679633,1,64),(33184247,321679634,1,65),(33184247,321679635,1,66),(33184247,321679636,1,67),(33184247,321679637,1,68),(33184247,321679638,1,69),(33184247,321679639,1,70),(33184247,321679640,1,71),(33184247,321679641,1,72),(33184247,321679642,1,73),(33184247,321679643,1,74),(33184247,321679644,1,75),(33184247,321679645,1,76),(33184247,321679646,1,77),(33184247,321679647,1,78),(33184247,321679648,1,79),(33184247,321679649,1,80),(33184247,321679650,1,81),(33184247,321679651,1,82),(33184247,321679652,1,83),(33184247,321679653,1,84),(33184247,321679654,1,85),(33184247,321679655,1,86),(33184247,321679656,1,87),(33184247,321679657,1,88),(33184247,321679658,1,89),(33184247,321679659,1,90),(33184247,321679660,1,91),(33184247,321679661,1,92),(33184247,321679662,1,93),(33184247,321679663,1,94),(33184247,321679664,1,95),(33184247,321679665,1,96),(33184247,321679666,1,97),(33184247,321679667,1,98),(33184247,321679668,1,99),(33184247,321679669,1,100),(33184247,321679670,1,101),(33184247,321679671,1,102),(33184247,321679672,1,103),(33184247,321679673,1,104),(33184247,321679674,1,105),(33184247,321679675,1,106),(33184247,321679676,1,107),(33184247,321679677,1,108),(33184247,321679678,1,109),(33184247,321679679,1,110),(33184247,321679681,1,111),(33184247,321679682,1,112),(33184247,321679683,1,113),(33184247,321679684,1,114),(33184247,321679685,1,115),(33184247,321679686,1,116),(33184247,321679687,1,117),(33184247,321679688,1,118),(33184247,321679689,1,119),(33184247,321679690,1,120),(33184247,321679691,1,121),(33184247,321679692,1,122),(33184247,321679693,1,123),(33184247,321679694,1,124),(33184247,321679695,1,125),(33184247,321679696,1,126),(33184252,321679696,1,1),(33184252,321679697,1,2),(33184252,321679698,1,3),(33184252,321679699,1,4),(33184252,321679700,1,5),(33184252,321679701,1,6),(33184252,321679702,1,7),(33184252,321679703,1,8),(33184252,321679704,1,9),(33184252,321679710,1,10),(33184252,321679711,1,11),(33184252,321679712,1,12),(33184252,321679713,1,13),(33184252,321679714,1,14),(33184252,321679715,1,15),(33184252,321679716,1,16),(33184252,321679717,1,17),(33184252,321679718,1,18),(33184252,321679719,1,19),(33184252,321679720,1,20),(33184252,321679721,1,21),(33184252,321679722,1,22),(33184252,321679723,1,23),(33184252,321679724,1,24),(33184252,321679725,1,25),(33184252,321679726,1,26),(33184252,321679727,1,27),(33184252,321679728,1,28),(33184252,321679729,1,29),(33184252,321679731,1,30),(33184252,321679732,1,31),(33184252,321679733,1,32),(33184252,321679734,1,33),(33184252,321679735,1,34),(33184252,321679738,1,35),(33184252,321679745,1,36),(33184252,321679746,1,37),(33184252,321679747,1,38),(33184252,321679748,1,39),(33184252,321679749,1,40),(33184252,321679750,1,41),(33184252,321679751,1,42),(33184252,321679752,1,43),(33184252,321679753,1,44),(33184252,321679754,1,45),(33184252,321679755,1,46),(33184252,321679756,1,47),(33184252,321679757,1,48),(33184252,321679759,1,49),(33184252,321679761,1,50),(33184252,321679762,1,51),(33184252,321679764,1,52),(33184252,321679766,1,53),(33184252,321679767,1,54),(33184252,321679769,1,55),(33184252,321679771,1,56),(33184252,321679773,1,57),(33184252,321679774,1,58),(33184252,321679776,1,59),(33184266,321679326,1,1),(33184266,321679328,1,2),(33184266,321679330,1,3),(33184266,321679332,1,4),(33184266,321679334,1,5),(33184266,321679336,1,6),(33184266,321679340,1,7),(33184266,321679342,1,8),(33184266,321679344,1,9),(33184266,321679346,1,10),(33184266,321679348,1,11),(33184266,321679349,1,12),(33184266,321679350,1,13),(33184266,321679351,1,14),(33184266,321679353,1,15),(33184266,321679355,1,16),(33184266,321679357,1,17),(33184266,321679359,1,18),(33184266,321679361,1,19),(33184266,321679362,1,20),(33184266,321679365,1,21),(33184266,321679367,1,22),(33184266,321679369,1,23),(33184266,321679371,1,24),(33184266,321679373,1,25),(33184266,321679375,1,26),(33184266,321679378,1,27),(33184266,321679381,1,28),(33184266,321679383,1,29),(33184266,321679385,1,30),(33184266,321679387,1,31),(33184266,321679389,1,32),(33184266,321679391,1,33),(33184266,321679393,1,34),(33184266,321679394,1,35),(33184266,321679397,1,36),(33184266,321679398,1,37),(33184266,321679400,1,38),(33184266,321679402,1,39),(33184266,321679405,1,40),(33184266,321679408,1,41),(33184266,321679411,1,42),(33184266,321679413,1,43),(33184266,321679416,1,44),(33184266,321679418,1,45),(33184266,321679421,1,46),(33184266,321679422,1,47),(33184266,321679424,1,48),(33184266,321679426,1,49),(33184266,321679429,1,50),(33184266,321679431,1,51),(33184266,321679433,1,52),(33184266,321679435,1,53),(33184266,321679436,1,54),(33184266,321679437,1,55),(33184266,321679438,1,56),(33184266,321679439,1,57),(33184266,321679440,1,58),(33184266,321679441,1,59),(33184266,321679442,1,60),(33184266,321679443,1,61),(33184266,321679444,1,62),(33184266,321679445,1,63),(33184266,321679446,1,64),(33184266,321679447,1,65),(33184266,321679448,1,66),(33184266,321679449,1,67),(33184266,321679450,1,68),(33184266,321679451,1,69),(33184266,321679452,1,70),(33184266,321679453,1,71),(33184266,321679454,1,72),(33184266,321679455,1,73),(33184266,321679457,1,74),(33184266,321679458,1,75),(33184266,321679459,1,76),(33184266,321679460,1,77),(33184266,321679462,1,78),(33184266,321679465,1,79),(33184266,321679466,1,80),(33184266,321679467,1,81),(33184266,321679468,1,82),(33184266,321679469,1,83),(33184266,321679470,1,84),(33184266,321679471,1,85),(33184266,321679472,1,86),(33184266,321679473,1,87),(33184266,321679474,1,88),(33184266,321679478,1,89),(33184266,321679479,1,90),(33184266,321679480,1,91),(33184266,321679481,1,92),(33184266,321679482,1,93),(33184266,321679483,1,94),(33184266,321679484,1,95),(33184266,321679485,1,96),(33184266,321679486,1,97),(33184266,321679487,1,98),(33184266,321679488,1,99),(33184266,321679489,1,100),(33184270,321682123,1,1),(33184270,321682122,1,2),(33184270,321682121,1,3),(33184270,321682120,1,4),(33184270,321682119,1,5),(33184270,321682118,1,6),(33184270,321682117,1,7),(33184270,321682116,1,8),(33184270,321682115,1,9),(33184270,321682114,1,10),(33184270,321682113,1,11),(33184270,321682112,1,12),(33184270,321682111,1,13),(33184270,321682110,1,14),(33184270,321682109,1,15),(33184270,321682108,1,16),(33184270,321682107,1,17),(33184270,321682106,1,18),(33184270,321682105,1,19),(33184270,321682104,1,20),(33184270,321682103,1,21),(33184270,321682102,1,22),(33184270,321682101,1,23),(33184270,321682100,1,24),(33184270,321682099,1,25),(33184270,321682098,1,26),(33184270,321682097,1,27),(33184270,321682096,1,28),(33184270,321682095,1,29),(33184270,321682094,1,30),(33184270,321682093,1,31),(33184270,321682092,1,32),(33184270,321682091,1,33),(33184270,321682090,1,34),(33184270,321682089,1,35),(33184270,321682088,1,36),(33184270,321682087,1,37),(33184270,321682086,1,38),(33184270,321682085,1,39),(33184270,321682084,1,40),(33184270,321682083,1,41),(33184270,321682082,1,42),(33184270,321682081,1,43),(33184270,321682080,1,44),(33184270,321682079,1,45),(33184270,321682078,1,46),(33184270,321682077,1,47),(33184270,321682076,1,48),(33184270,321682075,1,49),(33184270,321682074,1,50),(33184270,321682073,1,51),(33184270,321682072,1,52),(33184270,321682071,1,53),(33184270,321682070,1,54),(33184270,321682069,1,55),(33184270,321682068,1,56),(33184270,321682067,1,57),(33184270,321682066,1,58),(33184270,321682065,1,59),(33184270,321682064,1,60),(33184270,321682063,1,61),(33184270,321682062,1,62),(33184270,321682061,1,63),(33184270,321682059,1,64),(33184270,321682055,1,65),(33184270,321682054,1,66),(33184270,321682053,1,67),(33184270,321682052,1,68),(33184270,321682051,1,69),(33184270,321682050,1,70),(33184270,321682049,1,71),(33184270,321682048,1,72),(33184270,321682047,1,73),(33184270,321682046,1,74),(33184270,321682045,1,75),(33184270,321682044,1,76),(33184270,321682043,1,77),(33184270,321682042,1,78),(33184270,321682041,1,79),(33184270,321682040,1,80),(33184270,321682039,1,81),(33184270,321682038,1,82),(33184270,321682035,1,83),(33184270,321682028,1,84),(33184270,321682024,1,85),(33184270,321682021,1,86),(33184270,321682018,1,87),(33184270,321682016,1,88),(33184270,321682012,1,89),(33184270,321682009,1,90),(33184270,321682007,1,91),(33184270,321682005,1,92),(33184270,321682003,1,93),(33184270,321682002,1,94),(33713550,51441626,2,1),(33713550,51441629,2,2),(33713550,51441630,2,3),(33713550,51445073,2,4),(33713550,51441632,2,5),(33713550,51441635,2,6),(33713550,51441636,2,7),(33713550,51441228,2,8),(33721575,385582099,1,1),(33721575,385582100,1,2),(33721575,385582101,1,3),(33721575,385582102,1,4),(33721575,385582103,1,5),(33721575,385582104,1,6),(33721575,385582105,1,7),(33721575,385582099,1,8),(33733175,53295059,2,1),(33733175,385743984,2,2),(33733175,385743985,2,3),(33733175,385743986,2,4),(33733175,385743987,2,5),(33733175,385743988,2,6),(33733175,385743989,2,7),(33733175,385743990,2,8),(33733175,385743991,2,9),(33733175,385743992,2,10),(33733175,385743993,2,11),(34062547,390336072,5,1),(34062547,390336073,5,2),(34062547,53306715,5,3),(34062881,390327159,4,1),(34062881,390327162,4,2),(34062881,390327165,4,3),(34062881,390327166,4,4),(34062881,390327168,4,5),(34062881,390327171,4,6),(34062881,390327172,4,7),(34062881,390327175,4,8),(34062881,390327177,4,9),(34062881,390327179,4,10),(34062881,390327180,4,11),(34062881,390327181,4,12),(34062881,390327182,4,13),(34062881,390327183,4,14),(34062881,390327184,4,15),(34062881,390327185,4,16),(34062881,390327186,4,17),(34062881,390327187,4,18),(34062881,390327188,4,19),(34062881,390327189,4,20),(34062881,390327190,4,21),(34062881,390327191,4,22),(34062881,390327192,4,23),(34062881,390327193,4,24),(34062881,390327194,4,25),(34062881,390327195,4,26),(34062881,390327196,4,27),(34062881,390327197,4,28),(34062881,390327198,4,29),(34062881,390327199,4,30),(34062881,390327200,4,31),(34062881,390327202,4,32),(34062881,390327204,4,33),(34062881,390327205,4,34),(34062881,390327207,4,35),(34062881,390327208,4,36),(34062881,390327210,4,37),(34062881,390327212,4,38),(34062881,390327214,4,39),(34062881,390327215,4,40),(34062881,390327217,4,41),(34062881,390327219,4,42),(34062881,390327220,4,43),(34062881,390327222,4,44),(34062881,390327223,4,45),(34062881,390327224,4,46),(34062881,390327225,4,47),(34062881,390327227,4,48),(34062881,390327229,4,49),(34062881,390327231,4,50),(34062881,390327232,4,51),(34062881,390327233,4,52),(34062881,390327234,4,53),(34062881,390327236,4,54),(34063687,370909285,1,1),(34063687,390336447,1,2),(34063687,390336448,1,3),(34063687,390336449,1,4),(34063687,390336450,1,5),(34063687,390336451,1,6),(34063687,390336452,1,7),(34063687,390336072,1,8),(34063687,390336453,1,9),(34063687,390336454,1,10),(34063687,390336455,1,11),(34063687,390336456,1,12),(34063687,390336457,1,13),(34063687,390336458,1,14),(34063687,390336459,1,15),(34063687,390336460,1,16),(34063687,390336461,1,17),(34063687,390336462,1,18),(34063687,390336463,1,19),(34063687,390336464,1,20),(34063687,390336465,1,21),(34063687,390336466,1,22),(34063687,390336467,1,23),(34063687,390336468,1,24),(34063687,390336469,1,25),(34063687,390336470,1,26),(34063687,390336471,1,27),(34063687,390336472,1,28),(34063687,390336473,1,29),(34063687,390336474,1,30),(34063687,390336475,1,31),(34063687,390336476,1,32),(34063687,390336477,1,33),(34063687,390336479,1,34),(34063687,390336481,1,35),(34063687,390336483,1,36),(34063687,390336485,1,37),(34063687,390336487,1,38),(34063687,390336489,1,39),(34063687,390336491,1,40),(34063687,390336493,1,41),(34063687,390336494,1,42),(34063687,390336495,1,43),(34063704,390336495,1,1),(34063704,390327234,1,2),(34063735,390336904,2,1),(34063735,390336730,2,2),(34063735,390336731,2,3),(34063735,390336732,2,4),(34063735,390336733,2,5),(34063735,390336734,2,6),(34063735,390336735,2,7),(34063735,390336737,2,8),(34063735,390336738,2,9),(34063735,390336740,2,10),(34063735,390336742,2,11),(34063735,390336745,2,12),(34063735,390336747,2,13),(34063735,390336748,2,14),(34063735,390336750,2,15),(34063735,390336752,2,16),(34063735,390336754,2,17),(34063735,390336755,2,18),(34063735,390336757,2,19),(34063769,53306787,3,1),(34063769,390337187,3,2),(34063769,53306786,3,3),(34063770,53306786,1,1),(34063770,53306782,1,2),(34063770,53306781,1,3),(34063770,53306780,1,4),(34063770,53306778,1,5),(34063770,53306775,1,6),(34063770,53306774,1,7),(34063770,53306771,1,8),(34063770,53306769,1,9),(34063770,53306767,1,10),(34063770,53306764,1,11),(34063770,53295264,1,12),(34064472,390346965,2,1),(34064472,390346966,2,2),(34064472,390346967,2,3),(34064472,390346968,2,4),(34064472,390346969,2,5),(34064472,390346970,2,6),(34064472,390346971,2,7),(34064472,390346972,2,8),(34064472,390346973,2,9),(34064472,390346974,2,10),(34064472,390346975,2,11),(34064472,390346976,2,12),(34064472,390346977,2,13),(34064472,390346978,2,14),(34064472,390346979,2,15),(34064472,390346980,2,16),(34064813,53295133,2,1),(34064813,390351766,2,2),(34064813,390351767,2,3),(34064813,390351768,2,4),(34064813,390351769,2,5),(34064813,390351770,2,6),(34064813,390351771,2,7),(34064813,390351772,2,8),(34064813,390351773,2,9),(34064813,390351774,2,10),(34064813,390351775,2,11),(34064813,390351776,2,12),(34064813,390346965,2,13),(34064907,53295141,1,1),(34064907,390353660,1,2),(34064907,390353661,1,3),(34064907,390353662,1,4),(34064907,390353663,1,5),(34064907,390353664,1,6),(34064907,390353665,1,7),(34064907,390353666,1,8),(34064907,390353667,1,9),(34064907,390353668,1,10),(34064907,390353669,1,11),(34064907,390353670,1,12),(34064907,390353671,1,13),(34064907,390353672,1,14),(34064907,390353673,1,15),(34064907,390353674,1,16),(34064907,390353675,1,17),(34064907,390353676,1,18),(34064907,390353677,1,19),(34065105,390353677,1,1),(34065105,390356561,1,2),(34065105,390356562,1,3),(34065105,390356563,1,4),(34065105,390356564,1,5),(34065105,390356565,1,6),(34065105,390356566,1,7),(34065105,390356567,1,8),(34065105,390356568,1,9),(34065105,390356569,1,10),(34065105,390356570,1,11),(34065105,390356571,1,12),(34065105,390356572,1,13),(34065105,390356573,1,14),(34065105,390356574,1,15),(34065105,390356575,1,16),(34065105,390356576,1,17),(34065105,385743993,1,18),(34065105,390356578,1,19),(34065105,390356579,1,20),(34065671,53306910,2,1),(34065671,390361836,2,2),(34065671,390361837,2,3),(34065671,390361838,2,4),(34065671,390361839,2,5),(34065671,390361840,2,6),(34065671,259986455,2,7),(34065735,53306913,3,1),(34065735,53306912,3,2),(34065735,277001703,3,3),(34065735,53306911,3,4),(34387676,52262641,1,1),(34387676,394815197,1,2),(34387676,394815198,1,3),(34387676,394815199,1,4),(34387676,394815200,1,5),(34387821,394816282,2,1),(34387821,394816283,2,2),(34387821,394816284,2,3),(34387821,394816285,2,4),(34387821,394816286,2,5),(34387821,394816287,2,6),(34387821,394816288,2,7),(34387821,394816289,2,8),(34387821,394816290,2,9),(34387821,394816825,2,10),(34388549,394820724,3,1),(34388549,394820725,3,2),(34388549,394820726,3,3),(34388549,394820727,3,4),(34388549,394820728,3,5),(34388549,394820729,3,6),(34388549,394820721,3,7),(34388549,394820722,3,8),(34388549,394822862,3,9),(34389528,394831767,1,1),(34389528,394832384,1,2),(34389528,394832388,1,3),(34389528,394832391,1,4),(34389528,394832396,1,5),(34389528,394832401,1,6),(34389528,394832404,1,7),(34389528,394832407,1,8),(34389528,394832411,1,9),(34389528,394832416,1,10),(34389528,394832428,1,11),(34390093,394840530,1,1),(34390093,394840531,1,2),(34390093,394840532,1,3),(34390093,394840533,1,4),(34390093,394840534,1,5),(34390103,394815200,3,1),(34390103,394816825,3,2),(34390103,394816826,3,3),(34390103,394816827,3,4),(34390103,394816828,3,5),(34390103,394816829,3,6),(34390103,394816830,3,7),(34390103,394816831,3,8),(34390103,394823920,3,9),(34390103,394816832,3,10),(34390103,394823921,3,11),(34390103,394822862,3,12),(34390103,394823922,3,13),(34390103,394823923,3,14),(34390103,394823924,3,15),(34390103,394823925,3,16),(34390103,394823926,3,17),(34390103,394823927,3,18),(34390103,394823928,3,19),(34390103,394831766,3,20),(34390103,394831767,3,21),(34390103,394831768,3,22),(34390103,394840995,3,23),(34390103,394840996,3,24),(34390103,394840997,3,25),(34390103,394840998,3,26),(34390103,394840999,3,27),(34390103,394841000,3,28),(34390103,394841001,3,29),(34390103,394841002,3,30),(34390103,394841006,3,31),(34390103,394841007,3,32),(34390103,394841008,3,33),(34390103,394841009,3,34),(34390103,394841010,3,35),(34390103,394841011,3,36),(34390103,394840530,3,37),(34390103,394841012,3,38),(34390103,394841013,3,39),(34390103,394841014,3,40),(34390103,394841015,3,41),(34390103,394841016,3,42),(34390103,394841017,3,43),(34390103,394841018,3,44),(34390103,394841019,3,45),(34390103,394841020,3,46),(34390103,394841021,3,47),(34390103,394841022,3,48),(34390103,394841023,3,49),(34390103,394841024,3,50),(34390103,394841026,3,51),(34390103,394841027,3,52),(34390103,394841028,3,53),(34390103,394841029,3,54),(34390103,394841030,3,55),(34390103,394845193,3,56),(34390103,394841031,3,57),(34390499,394845193,1,1),(34390499,394847583,1,2),(34390499,394847585,1,3),(34390499,394847587,1,4),(34390499,394847589,1,5),(34390499,394847590,1,6),(34390499,394847591,1,7),(34390499,394847592,1,8),(34390499,394847593,1,9),(34390581,394847593,1,1),(34390581,394848317,1,2),(34390581,394848319,1,3),(34390594,394841031,2,1),(34390594,394841032,2,2),(34390594,394841033,2,3),(34390594,394841034,2,4),(34390594,394841035,2,5),(34390594,394841036,2,6),(34876322,408986116,3,1),(34876322,408986118,3,2),(34876322,408986121,3,3),(34876322,408986124,3,4),(34876322,408986126,3,5),(34876322,408986129,3,6),(34876322,408986131,3,7),(34876322,408986116,3,8),(34876405,408987613,1,1),(34876405,266326328,1,2),(35444733,390327159,1,1),(35444733,415767154,1,2),(35444733,415767166,1,3),(35444733,415767158,1,4),(35444733,415767172,1,5),(35444733,415767153,1,6),(35444733,415767146,1,7),(35444733,415767142,1,8),(35444733,415767150,1,9),(35444733,415767171,1,10),(35444733,415767161,1,11),(35444733,415767163,1,12),(35444733,415767167,1,13),(35444733,415767156,1,14),(35444733,415767140,1,15),(35444733,415767145,1,16),(35444733,415767165,1,17),(35444733,415767162,1,18),(35444733,415767159,1,19),(35444733,415767169,1,20),(35444733,415767152,1,21),(35444733,415767147,1,22),(35444733,415767143,1,23),(35444733,415767157,1,24),(35444733,415767170,1,25),(35444733,415767160,1,26),(35444733,415767164,1,27),(35444733,415767168,1,28),(35444733,415767155,1,29),(35444733,415767141,1,30),(35444733,415767144,1,31),(35444733,415767149,1,32),(35444733,415767151,1,33),(35444733,415767148,1,34),(37633206,441154305,1,1),(37633206,441154306,1,2),(37633206,441154307,1,3),(37633206,441154308,1,4),(37633275,441154951,1,1),(37633275,441154982,1,2),(37633275,441154983,1,3),(37633275,441154984,1,4),(37633275,441154305,1,5),(37633404,441154982,1,1),(37633404,441157250,1,2),(37633404,441157251,1,3),(37633404,441157252,1,4),(37633404,441157253,1,5),(37633404,441157255,1,6),(37633404,441157257,1,7),(37633404,441157259,1,8),(37633404,441157261,1,9),(37633404,441157265,1,10),(37633404,441157267,1,11),(37756343,277001703,2,1),(37756343,442880086,2,2),(37756386,442880684,1,1),(37756386,442880685,1,2),(37756386,442880686,1,3),(37756386,442880687,1,4),(37756386,442880684,1,5),(37865954,51973501,2,1),(37865954,51973504,2,2),(37865954,51973507,2,3),(37865954,51973901,2,4),(37865954,51973511,2,5),(37865954,51973903,2,6),(38706653,470343713,4,1),(38706653,470347019,4,2),(38706653,458761931,4,3),(38706653,458761932,4,4),(38706653,458761933,4,5),(38706653,458761934,4,6),(38706653,458761935,4,7),(38706653,458761937,4,8),(38706653,458761938,4,9),(38706653,458761939,4,10),(38706653,458761940,4,11),(38706653,458761941,4,12),(38706653,458761942,4,13),(38706653,458761943,4,14),(38706653,458761944,4,15),(38706653,458761945,4,16),(38706653,458761946,4,17),(38706653,458761947,4,18),(38706653,458761948,4,19),(38706653,458761949,4,20),(38706653,458761950,4,21),(38706653,458761951,4,22),(38706653,458761952,4,23),(38706653,458761953,4,24),(38706653,458761954,4,25),(38706653,458761955,4,26),(38706653,458761956,4,27),(38706653,458761957,4,28),(38706653,458761958,4,29),(38706653,458761959,4,30),(38706653,458761960,4,31),(38706653,458761961,4,32),(38706653,458761962,4,33),(38706653,458761963,4,34),(38706653,458761964,4,35),(38706653,458761965,4,36),(38706653,458761966,4,37),(38706653,458761967,4,38),(38706653,458761968,4,39),(38706653,458761969,4,40),(38706653,458761970,4,41),(38706653,458761971,4,42),(38706653,458761972,4,43),(38706653,458761973,4,44),(38706653,458761974,4,45),(38706653,458761975,4,46),(38706653,458761977,4,47),(38706653,458761978,4,48),(38706653,458761979,4,49),(38706653,458761980,4,50),(38706653,458761981,4,51),(38706653,458761982,4,52),(38706653,458761983,4,53),(38706653,458761984,4,54),(38706653,458764071,4,55),(38706653,458764072,4,56),(38706653,458764073,4,57),(38706653,458764074,4,58),(38706653,458764075,4,59),(38706653,458764076,4,60),(38706653,458764077,4,61),(38706653,458764078,4,62),(38706653,458764079,4,63),(38706653,458764080,4,64),(38706653,458764081,4,65),(38706653,458764082,4,66),(38706653,458764083,4,67),(38706653,458764084,4,68),(38706653,458764085,4,69),(38706653,458764086,4,70),(38706653,458764087,4,71),(38706653,458764088,4,72),(38706653,458764089,4,73),(38706653,458764090,4,74),(38706653,458764091,4,75),(38706653,458764092,4,76),(38706653,458764093,4,77),(38706653,458764094,4,78),(38706653,458764095,4,79),(38706653,458764096,4,80),(38706653,458764097,4,81),(38706653,458764098,4,82),(38706653,458764099,4,83),(38706653,458764100,4,84),(38706653,458764101,4,85),(38706653,458764102,4,86),(38706653,458764103,4,87),(38706653,458764104,4,88),(38706653,458764105,4,89),(38706653,458764106,4,90),(38706653,458764107,4,91),(38706653,458764108,4,92),(38706653,458764109,4,93),(38706653,458764110,4,94),(38706653,458764111,4,95),(38706653,458764112,4,96),(38706653,458764113,4,97),(38706653,458764114,4,98),(38706653,458764115,4,99),(38706653,458764116,4,100),(38706653,458764118,4,101),(38706653,458764119,4,102),(38706653,458764120,4,103),(38706653,458764121,4,104),(38706653,458764122,4,105),(38706653,458764123,4,106),(38706653,458764124,4,107),(38706653,458764125,4,108),(38706653,458764126,4,109),(38706653,458764127,4,110),(38706653,458764128,4,111),(38706653,458764129,4,112),(38706653,458764130,4,113),(38706653,458764131,4,114),(38706653,458764132,4,115),(38706653,458764133,4,116),(38706653,458764134,4,117),(38706653,458764135,4,118),(38706653,458764136,4,119),(38706653,458764139,4,120),(38706653,458764150,4,121),(38706653,458764156,4,122),(38706653,458764162,4,123),(38706653,458764166,4,124),(38706653,458764167,4,125),(38706653,458764168,4,126),(38706653,458764169,4,127),(38706653,458764170,4,128),(38706653,458764171,4,129),(38706653,458764172,4,130),(38706653,458764173,4,131),(38706653,458764174,4,132),(38706653,458764175,4,133),(38706653,458764176,4,134),(38706653,458764177,4,135),(38706653,458764178,4,136),(38706653,458764179,4,137),(38706925,268615704,1,1),(38706925,458765127,1,2),(38706925,458765128,1,3),(38706927,458765312,3,1),(38706927,458765314,3,2),(38706928,470348213,7,1),(38706928,470348216,7,2),(38706928,470351662,7,3),(38706928,470351674,7,4),(38706928,470351687,7,5),(38706928,470351695,7,6),(38706928,470351696,7,7),(38706928,470351698,7,8),(38706928,470351699,7,9),(38706928,470351700,7,10),(38706928,470351702,7,11),(38706928,470351703,7,12),(38706928,470351704,7,13),(38706928,470351705,7,14),(38706928,470351706,7,15),(38706928,470353011,7,16),(38706928,470353010,7,17),(38706928,470353009,7,18),(38706928,470353008,7,19),(38706928,470353007,7,20),(38706928,470353006,7,21),(38706928,470353005,7,22),(38706928,470353004,7,23),(38706928,470353003,7,24),(38706928,470353002,7,25),(38706928,470353001,7,26),(38706928,470353000,7,27),(38706928,470352999,7,28),(38706928,470352998,7,29),(38706928,470352997,7,30),(38706928,470352996,7,31),(38706928,470352995,7,32),(38706928,470352993,7,33),(38706928,470352992,7,34),(38706928,470352991,7,35),(38706928,470352990,7,36),(38706928,470352989,7,37),(38706928,470352988,7,38),(38706936,458765314,1,1),(38706936,458765317,1,2),(38706936,458765319,1,3),(38706936,458765321,1,4),(38706936,458765020,1,5),(39258136,470349572,3,1),(39258136,470349573,3,2),(39258136,470349575,3,3),(39258136,470349576,3,4),(39258136,470349578,3,5),(39258137,470349632,1,1),(39258137,470349572,1,2),(39258144,470349578,1,1),(39258144,470349580,1,2),(39258144,470349603,1,3),(39258742,470348216,2,1),(39258742,470348218,2,2),(39258742,470348220,2,3),(39258742,470348222,2,4),(39258742,470348224,2,5),(39258742,470348227,2,6),(39258742,470348228,2,7),(39258742,470348229,2,8),(39258742,470348231,2,9),(39258742,470348233,2,10),(39258742,470348236,2,11),(39258742,470348239,2,12),(39258742,470348241,2,13),(39258742,470348244,2,14),(39258742,470348245,2,15),(39258742,470348248,2,16),(39258742,470348249,2,17),(39258742,470348250,2,18),(39258742,470348254,2,19),(39258742,470348257,2,20),(39258742,470348260,2,21),(39258742,470348263,2,22),(39258742,470348264,2,23),(39258742,470348269,2,24),(39258742,470348271,2,25),(39258742,470348272,2,26),(39258742,470348273,2,27),(39258742,470348274,2,28),(39258742,470348275,2,29),(39258742,470348277,2,30),(39258742,470348279,2,31),(39258742,470348280,2,32),(39258742,470348281,2,33),(39258742,470348282,2,34),(39258742,470348283,2,35),(39258742,470348286,2,36),(39258742,470348288,2,37),(39258742,470348290,2,38),(39258742,470348292,2,39),(39258742,470348294,2,40),(39258742,470348299,2,41),(39258742,470348301,2,42),(39258742,470348302,2,43),(39258742,470348303,2,44),(39258742,470348304,2,45),(39258742,470348305,2,46),(39258742,470348306,2,47),(39258742,470348307,2,48),(39258742,470348308,2,49),(39258742,470348309,2,50),(39258742,470348310,2,51),(39258742,470348311,2,52),(39258742,470348312,2,53),(39258742,470348314,2,54),(39258742,470348315,2,55),(39258742,470348316,2,56),(39258742,470348318,2,57),(39258742,470348319,2,58),(39258742,470348321,2,59),(39258742,470348322,2,60),(39258742,470348325,2,61),(39258742,470348326,2,62),(39258742,470348327,2,63),(39258742,470348328,2,64),(39258742,470348329,2,65),(39258742,470348330,2,66),(39258742,470348332,2,67),(39258742,470348333,2,68),(39258742,470348335,2,69),(39258742,470348337,2,70),(39258742,470348338,2,71),(39258742,470348339,2,72),(39258742,470348341,2,73),(39258742,470343713,2,74),(39258742,470343719,2,75),(39258742,470343724,2,76),(39258742,470343733,2,77),(39258742,470343737,2,78),(39258742,470343746,2,79),(39258742,470343752,2,80),(39258742,470343759,2,81),(39258742,470343766,2,82),(39258742,470343771,2,83),(39258742,470343785,2,84),(39258742,470343793,2,85),(39258742,470343798,2,86),(39258742,470343805,2,87),(39258742,470343810,2,88),(39258742,470343811,2,89),(39258742,470343812,2,90),(39258742,470343814,2,91),(39258742,470343816,2,92),(39258742,470343817,2,93),(39258742,470343819,2,94),(39258742,470343820,2,95),(39258742,470343822,2,96),(39258742,470343823,2,97),(39258742,470343825,2,98),(39258742,470343827,2,99),(39258742,470343828,2,100),(39258742,470343830,2,101),(39258742,470343831,2,102),(39258742,470343832,2,103),(39258742,470343833,2,104),(39258742,470343834,2,105),(39258742,470343835,2,106),(39258742,470343836,2,107),(39258742,470343837,2,108),(39258742,470343838,2,109),(39258742,470343839,2,110),(39258742,470343840,2,111),(39258742,470343841,2,112),(39258742,470343842,2,113),(39258742,470343844,2,114),(39258742,470343850,2,115),(39258742,470343852,2,116),(39258742,470343853,2,117),(39258742,470343854,2,118),(39258742,470343856,2,119),(39258742,470343857,2,120),(39258742,470343858,2,121),(39258742,470343859,2,122),(39258742,470343860,2,123),(39258742,470343861,2,124),(39258742,470343862,2,125),(39258742,470343863,2,126),(39258742,470343864,2,127),(39258742,470343865,2,128),(39258742,470343866,2,129),(39258742,470343867,2,130),(39258742,470343868,2,131),(39258742,470343869,2,132),(39258742,470343870,2,133),(39258742,470343871,2,134),(39258742,470343872,2,135),(39258742,470343873,2,136),(39258742,470343874,2,137),(39258742,470343875,2,138),(39258742,470343876,2,139),(39258742,470343877,2,140),(39258742,470343878,2,141),(39258742,470343879,2,142),(39258742,470343880,2,143),(39258742,470343881,2,144),(39258742,470343882,2,145),(39258742,470343883,2,146),(39258742,458765361,2,147),(39258742,458764179,2,148),(39258742,458765365,2,149),(39258742,458765368,2,150),(39258742,458765373,2,151),(39258742,458765375,2,152),(39258742,458765377,2,153),(39258742,458765379,2,154),(39258742,458765381,2,155),(39258742,458765383,2,156),(39258742,458765386,2,157),(39258742,458765388,2,158),(39258742,458765312,2,159),(39259019,470357335,1,1),(39259019,470357336,1,2),(39259019,470357338,1,3),(39259019,470357340,1,4),(39259019,470357348,1,5),(39259022,470356873,1,1),(39259022,470357335,1,2),(39259088,470358230,2,1),(39259088,470358231,2,2),(39259088,470358232,2,3),(39259088,262464086,2,4),(39259092,262464091,1,1),(39259092,470358240,1,2),(39259092,470358241,1,3),(39259092,470358242,1,4),(39259092,470358230,1,5),(39259147,470358581,1,1),(39259147,470358582,1,2),(39259147,470358583,1,3),(39259147,470358584,1,4),(39259147,470358581,1,5),(39259506,268615787,2,1),(39259506,268615788,2,2),(39259506,268615789,2,3),(39259506,268615790,2,4),(39259506,470363726,2,5),(39259506,470363727,2,6),(39259506,470363728,2,7),(39259506,470363729,2,8),(39259506,470363730,2,9),(39259506,470363731,2,10),(39259666,470364482,1,1),(39259666,470364483,1,2),(39259666,470364484,1,3),(39259666,470364486,1,4),(39259666,470364482,1,5),(39259759,470365699,3,1),(39259759,470365700,3,2),(39259759,470365701,3,3),(39259759,470365703,3,4),(39259759,470365704,3,5),(39259759,470365706,3,6),(39259759,470365708,3,7),(39259759,470365709,3,8),(39259759,470365710,3,9),(39259759,470365711,3,10),(39259759,470365712,3,11),(39259759,470365713,3,12),(39259759,470365714,3,13),(39259759,470365715,3,14),(39259759,470365716,3,15),(39259759,470365717,3,16),(39259759,470365193,3,17),(39259759,470365194,3,18),(39259759,470365195,3,19),(39259759,470365202,3,20),(39259759,470365211,3,21),(39259759,470365221,3,22),(39259759,470365232,3,23),(39259759,470365242,3,24),(39259759,52168516,3,25),(39259769,470365262,1,1),(39259769,51582178,1,2),(39259769,51582181,1,3),(39259769,268615558,1,4),(39259769,51582184,1,5),(39259769,268615948,1,6),(39259769,51582186,1,7),(39259769,51582188,1,8),(39259769,470363731,1,9),(39259769,51582191,1,10),(39259769,51582194,1,11),(39259769,51582198,1,12),(39259769,51582201,1,13),(39259769,268617677,1,14),(39259769,268617809,1,15),(39259769,51582204,1,16),(39259769,51582207,1,17),(39259769,51582209,1,18),(39259769,51582211,1,19),(39259769,264465123,1,20),(39259770,51582175,2,1),(39259770,470365262,2,2),(40064501,482113340,1,1),(40064501,482113341,1,2),(40064501,482113342,1,3),(40064501,482113343,1,4),(40064501,482113344,1,5),(40064501,482113345,1,6),(40064876,482113739,2,1),(40064876,482113740,2,2),(40064876,482113741,2,3),(40064876,482113742,2,4),(40064876,482113743,2,5),(40064876,482114101,2,6),(40064876,482113744,2,7),(40064876,482113745,2,8),(40064876,482113746,2,9),(40064876,482114102,2,10),(40064876,482113747,2,11),(40064876,482113748,2,12),(40064876,482113749,2,13),(40064876,482113750,2,14),(40064876,482113751,2,15),(40064876,482113752,2,16),(40064876,482113753,2,17),(40064876,482114103,2,18),(40064876,482113754,2,19),(40064876,482113755,2,20),(40064876,482113756,2,21),(40064876,482113757,2,22),(40064876,482113758,2,23),(40064876,482113759,2,24),(40064876,482113760,2,25),(40064876,482113761,2,26),(40064876,482113762,2,27),(40064876,482113763,2,28),(40064876,482113764,2,29),(40064876,482113765,2,30),(40064876,482113766,2,31),(40064876,482113767,2,32),(40064876,482113768,2,33),(40064876,482113769,2,34),(40064876,482113770,2,35),(40064876,482113771,2,36),(40064876,482113772,2,37),(40064876,482113340,2,38),(40065172,482114225,1,1),(40065172,482114227,1,2),(40065172,482114229,1,3),(40065172,482114231,1,4),(40065172,482114232,1,5),(40065172,482114235,1,6),(40065172,482113739,1,7),(40065172,482114237,1,8),(40065349,482124370,2,1),(40065349,482124371,2,2),(40065349,482124373,2,3),(40065349,482124375,2,4),(40065349,482124378,2,5),(40065349,482124380,2,6),(40065349,482124381,2,7),(40065349,482124383,2,8),(40065349,482124388,2,9),(40065349,482124389,2,10),(40065349,482124392,2,11),(40065349,482124395,2,12),(40065349,482124397,2,13),(40065349,482124398,2,14),(40065349,482124399,2,15),(40065349,482124402,2,16),(40065349,482124404,2,17),(40065349,482124407,2,18),(40065349,482124408,2,19),(40065349,482124409,2,20),(40065349,482124415,2,21),(40065349,482124418,2,22),(40065349,482124421,2,23),(40065349,482124424,2,24),(40065349,482124425,2,25),(40065349,482124427,2,26),(40065349,482124430,2,27),(40065349,482124432,2,28),(40065349,482124434,2,29),(40065349,482124435,2,30),(40065349,482124441,2,31),(40065349,482124443,2,32),(40065349,482124445,2,33),(40065349,482124448,2,34),(40065349,482124450,2,35),(40065349,482124451,2,36),(40065349,482124454,2,37),(40065349,482124457,2,38),(40065349,482124459,2,39),(40065349,482124460,2,40),(40065349,482124466,2,41),(40065349,482124468,2,42),(40065349,482124470,2,43),(40065349,482124473,2,44),(40065349,482124475,2,45),(40065810,482143961,1,1),(40065810,482143969,1,2),(40065810,482143974,1,3),(40065810,482143976,1,4),(40065810,482143978,1,5),(40065810,482143984,1,6),(40065810,482143987,1,7),(40065810,482143992,1,8),(40065810,482143997,1,9),(40065810,482144000,1,10),(40065810,482144005,1,11),(40065810,482144009,1,12),(40065810,482144019,1,13),(40065810,482144023,1,14),(40065810,482144027,1,15),(40065810,482144030,1,16),(40065810,482144032,1,17),(40065810,482144036,1,18),(40065810,482144040,1,19),(40065810,482144044,1,20),(40065810,482144048,1,21),(40065810,482144052,1,22),(40065810,482144069,1,23),(40065810,482144078,1,24),(40065810,482144087,1,25),(40065893,482148188,1,1),(40065893,482148191,1,2),(40065893,482148194,1,3),(40065893,482148198,1,4),(40065893,482148201,1,5),(40065893,482148204,1,6),(40065893,482148213,1,7),(40065893,482148217,1,8),(40065893,482148220,1,9),(40065893,482148223,1,10),(40065893,482148226,1,11),(40065893,482148228,1,12),(40065893,482148231,1,13),(40065893,482148234,1,14),(40067891,482159051,3,1),(40067891,482159053,3,2),(40067891,482158226,3,3),(40067891,482158227,3,4),(40067891,482158228,3,5),(40067891,482158229,3,6),(40067891,482158230,3,7),(40067891,482158231,3,8),(40067891,482158232,3,9),(40067891,482158233,3,10),(40067891,482158234,3,11),(40067891,482158235,3,12),(40067891,482158236,3,13),(40067891,482158237,3,14),(40067891,482158238,3,15),(40067891,482158239,3,16),(40067891,482158240,3,17),(40067891,482158241,3,18),(40067891,482158243,3,19),(40067891,482158246,3,20),(40067891,482158248,3,21),(40067891,482158251,3,22),(40067891,482158252,3,23),(40067891,482158253,3,24),(40067891,482158254,3,25),(40067891,482158255,3,26),(40067891,482158256,3,27),(40067891,482158257,3,28),(40067891,482158258,3,29),(40067891,482158259,3,30),(40067891,482158260,3,31),(40067891,482158261,3,32),(40067891,482158262,3,33),(40067891,482158263,3,34),(40067891,482158872,3,35),(40067891,482158264,3,36),(40067891,482158265,3,37),(40067891,482158873,3,38),(40067891,482158266,3,39),(40067891,482158267,3,40),(40067891,482158268,3,41),(40067891,482158269,3,42),(40067891,268615707,3,43),(40137318,337767559,1,1),(40137318,51399367,1,2),(40137318,51399320,1,3),(40137318,51400794,1,4),(40137318,52688872,1,5),(40137318,51399321,1,6),(40264409,485577918,1,1),(40264409,485577920,1,2),(40264409,485577921,1,3),(40264409,485577922,1,4),(40264409,485577923,1,5),(40264409,485577924,1,6),(40264409,485577925,1,7),(40264409,485577926,1,8),(40264409,485577927,1,9),(40264409,485577928,1,10),(40264409,485577929,1,11),(40264409,485577930,1,12),(40264409,485577931,1,13),(40264409,485577932,1,14),(40264409,485577933,1,15),(40264409,485577934,1,16),(40264409,485577936,1,17),(40264409,485577937,1,18),(40264409,485577938,1,19),(40264409,485577939,1,20),(40264409,485577940,1,21),(40264409,485577941,1,22),(40264409,485577942,1,23),(40264409,485577943,1,24),(40264409,485577944,1,25),(40264409,485577945,1,26),(40264409,485577946,1,27),(40264409,485577947,1,28),(40264409,485577948,1,29),(40264409,485577949,1,30),(40264409,485577950,1,31),(40264409,485577951,1,32),(40264409,485577953,1,33),(40264409,485577954,1,34),(40264409,485577955,1,35),(40264409,485577956,1,36),(40264409,485577957,1,37),(40264409,485577958,1,38),(40264409,485577959,1,39),(40264409,485577960,1,40),(40264409,485577961,1,41),(40264409,485577962,1,42),(40264409,485577963,1,43),(40264409,485577964,1,44),(40264409,485577965,1,45),(40264410,485577965,1,1),(40264410,485577966,1,2),(40264410,485577968,1,3),(40264410,485577969,1,4),(40264410,485577970,1,5),(40264410,485577971,1,6),(40264410,485577972,1,7),(40264410,485577973,1,8),(40264410,485577974,1,9),(40264410,485577975,1,10),(40264410,485577976,1,11),(40264410,485577977,1,12),(40264410,485577978,1,13),(40264410,485577979,1,14),(40264410,485577981,1,15),(40264410,485577982,1,16),(40264410,485577984,1,17),(40264410,485577985,1,18),(40264410,485577986,1,19),(40264410,485577987,1,20),(40264410,485577988,1,21),(40264410,485577989,1,22),(40264410,485577990,1,23),(40264410,485577991,1,24),(40264410,485577992,1,25),(40264410,485577993,1,26),(40264410,485577994,1,27),(40264410,485577995,1,28),(40264410,485577996,1,29),(40264410,485577997,1,30),(40264410,485577998,1,31),(40264410,485577999,1,32),(40264410,485578000,1,33),(40264410,485578001,1,34),(40264410,485578003,1,35),(40264410,485578004,1,36),(40264410,485578005,1,37),(40264410,485578006,1,38),(40264410,485578007,1,39),(40264410,485578008,1,40),(40264410,485578009,1,41),(40264410,485578010,1,42),(40264410,485578011,1,43),(40264410,485578012,1,44),(40264410,485578013,1,45),(40264410,485578014,1,46),(40264410,485578016,1,47),(40264410,485578017,1,48),(40264410,485578018,1,49),(40264410,485578019,1,50),(40264410,485578020,1,51),(40264410,485578021,1,52),(40264410,485578022,1,53),(40264410,485578023,1,54),(40264410,485578024,1,55),(40264410,485578025,1,56),(40264410,485578026,1,57),(40264410,485578027,1,58),(40264410,485578028,1,59),(40264410,485578029,1,60),(40264410,485578030,1,61),(40264410,485578031,1,62),(40264410,485578032,1,63),(40264410,485578033,1,64),(40264410,485578035,1,65),(40264410,485578036,1,66),(40264410,485578037,1,67),(40264410,485578038,1,68),(40264410,485578039,1,69),(40264410,485578040,1,70),(40264410,485578041,1,71),(40264410,485578042,1,72),(40264410,485578043,1,73),(40264410,485578044,1,74),(40264410,485578045,1,75),(40264410,485578046,1,76),(40264410,485578048,1,77),(40264410,485578049,1,78),(40264410,485578050,1,79),(40264410,485578051,1,80),(40264410,485578052,1,81),(40264410,485578053,1,82),(40264410,485578054,1,83),(40264410,485578055,1,84),(40264410,485578056,1,85),(40264410,485578057,1,86),(40264410,485578058,1,87),(40264410,485578059,1,88),(40264410,485578060,1,89),(40264410,485578062,1,90),(40264410,485578063,1,91),(40264410,485578064,1,92),(40264410,485578065,1,93),(40264410,485578066,1,94),(40264410,485578067,1,95),(40264410,485578068,1,96),(40264410,485578070,1,97),(40264410,485578071,1,98),(40264410,485578072,1,99),(40264410,485578073,1,100),(40264410,485578074,1,101),(40264410,485578075,1,102),(40264410,485578076,1,103),(40264410,485578077,1,104),(40264410,485578079,1,105),(40264410,485578080,1,106),(40264410,485578081,1,107),(40264410,485578082,1,108),(40264410,485578083,1,109),(40264410,485578084,1,110),(40264410,485578085,1,111),(40264410,485578086,1,112),(40264410,485578087,1,113),(40264410,485578088,1,114),(40264410,485578089,1,115),(40264410,485578090,1,116),(40264410,485578091,1,117),(40264410,485578092,1,118),(40264410,485578093,1,119),(40264410,485578095,1,120),(40264410,485578096,1,121),(40264410,485578097,1,122),(40264410,485578098,1,123),(40264410,485578099,1,124),(40264410,485578100,1,125),(40264410,485578101,1,126),(40264410,485578102,1,127),(40264410,485578103,1,128),(40264410,485578104,1,129),(40264410,485578105,1,130),(40264410,485578106,1,131),(40264410,485578107,1,132),(40264410,485578108,1,133),(40264410,485578109,1,134),(40264410,485578111,1,135),(40264410,485578112,1,136),(40264410,485578113,1,137),(40264410,485578114,1,138),(40264410,485578115,1,139),(40264410,485578116,1,140),(40264410,485578117,1,141),(40264410,485578118,1,142),(40264410,485578119,1,143),(40264410,485578120,1,144),(40264410,485578121,1,145),(40264410,485578122,1,146),(40264410,485578124,1,147),(40264410,485578125,1,148),(40264410,485578126,1,149),(40264410,485578127,1,150),(40264410,485578128,1,151),(40264410,485578129,1,152),(40264410,485578130,1,153),(40264410,485578133,1,154),(40264410,485578134,1,155),(40264410,485578135,1,156),(40264410,485578136,1,157),(40264410,485578137,1,158),(40264410,485578138,1,159),(40264410,485578139,1,160),(40264410,485578140,1,161),(40264410,485578142,1,162),(40264410,485578143,1,163),(40264410,485578146,1,164),(40264410,485578159,1,165),(40264410,485578160,1,166),(40264410,485578161,1,167),(40264410,485578162,1,168),(40264410,485578163,1,169),(40264410,485578164,1,170),(41785125,515429490,1,1),(41785125,515429491,1,2),(41785125,515429492,1,3),(41785125,515429493,1,4),(41785125,515429494,1,5),(41785125,515429495,1,6),(41785125,515429496,1,7),(41785125,515429497,1,8),(41935429,519515756,1,1),(41935429,519515757,1,2),(41935429,519515758,1,3),(41935429,519515759,1,4),(41935429,519515760,1,5),(41935429,519515761,1,6),(41935429,519515762,1,7),(41935429,519515763,1,8),(41935429,519515764,1,9),(41935429,519515765,1,10),(41935429,519515766,1,11),(41935429,519515767,1,12),(41935429,519515768,1,13),(41935429,519515769,1,14),(41935429,519515770,1,15),(41935429,519515771,1,16),(41935429,519515772,1,17),(41935429,519515756,1,18),(42014211,521153185,2,1),(42014211,664225514,2,2),(42014211,664225476,2,3),(42014211,664225519,2,4),(42014211,664225516,2,5),(42014211,664225525,2,6),(42014211,664225523,2,7),(42014211,664225521,2,8),(42014211,664225529,2,9),(42014211,664225527,2,10),(42014211,664225531,2,11),(42014211,521153188,2,12),(42021998,521349887,1,1),(42021998,521349888,1,2),(42021998,521349889,1,3),(42021998,521349890,1,4),(42021998,521349907,1,5),(42021998,521349908,1,6);
INSERT INTO `way_nodes` VALUES (42021998,521349887,1,7),(42055725,522254633,1,1),(42055725,522254634,1,2),(42055725,522254635,1,3),(42055725,522254636,1,4),(42055725,522254637,1,5),(42055725,522254638,1,6),(42055725,522254639,1,7),(42055725,522254640,1,8),(42055725,522254641,1,9),(42055725,522254642,1,10),(42055725,522254643,1,11),(42055725,522254644,1,12),(42055725,522254645,1,13),(42055725,522254646,1,14),(42055725,522254647,1,15),(42055725,522254648,1,16),(42055725,522254649,1,17),(42055725,522254650,1,18),(42055725,522254633,1,19),(42055772,522256224,1,1),(42055772,522256225,1,2),(42055772,522256226,1,3),(42055772,522256227,1,4),(42055772,522256228,1,5),(42055772,522256229,1,6),(42055772,522256230,1,7),(42055772,522256231,1,8),(42055772,522256232,1,9),(42055772,522256233,1,10),(42055772,522256234,1,11),(42055772,522256235,1,12),(42055772,522256236,1,13),(42055772,522256237,1,14),(42055772,522256238,1,15),(42055772,522256239,1,16),(42055772,522256240,1,17),(42055772,522256241,1,18),(42055772,522256242,1,19),(42055772,522256243,1,20),(42055772,522256245,1,21),(42055772,522256224,1,22),(42235196,526428059,1,1),(42235196,526428060,1,2),(42235196,526428062,1,3),(42235196,526428066,1,4),(42235196,526428067,1,5),(42235196,526428069,1,6),(42235196,526428070,1,7),(42235196,526428071,1,8),(42235196,526428073,1,9),(42235196,526428074,1,10),(42235196,526428076,1,11),(42235196,526428077,1,12),(42235196,526428078,1,13),(42235196,526428080,1,14),(42235196,526428081,1,15),(42235196,526428083,1,16),(42235196,526428084,1,17),(42235196,526428086,1,18),(42235196,526428090,1,19),(42235196,526428091,1,20),(42235209,643575027,2,1),(42235209,643575028,2,2),(42235209,526429982,2,3),(42235209,526429983,2,4),(42235209,526429985,2,5),(42235209,526429986,2,6),(42235209,526429988,2,7),(42235209,526429992,2,8),(42235209,526429993,2,9),(42235226,526431633,1,1),(42235226,526431634,1,2),(42235226,526431636,1,3),(42235226,526431637,1,4),(42235226,526431639,1,5),(42235226,526431640,1,6),(42235226,526431642,1,7),(42235226,526431643,1,8),(42235226,526431645,1,9),(42235226,526431646,1,10),(42235226,526431648,1,11),(42235226,526431649,1,12),(42235226,526431651,1,13),(42235226,526431652,1,14),(42235226,526431654,1,15),(42235226,526431655,1,16),(42235226,526431656,1,17),(42235226,526431658,1,18),(42235226,526431663,1,19),(42235226,526431664,1,20),(42235226,526431666,1,21),(42235226,526431667,1,22),(42235226,526431669,1,23),(42235226,526431671,1,24),(42235226,526431672,1,25),(42235226,526431674,1,26),(42235229,526431798,1,1),(42235229,526431800,1,2),(42235229,526431801,1,3),(42235229,526431803,1,4),(42235229,526431804,1,5),(42235229,526431806,1,6),(42235229,526431807,1,7),(42235229,526431809,1,8),(42235229,526431810,1,9),(42235229,526431812,1,10),(42235229,526431813,1,11),(42235229,526431817,1,12),(42235229,526431818,1,13),(42235229,526431820,1,14),(42235229,526431821,1,15),(42235229,526431823,1,16),(42235229,526431824,1,17),(42235229,526431826,1,18),(42235229,526431827,1,19),(42235229,526431828,1,20),(42235229,526431830,1,21),(42235229,526431831,1,22),(42235229,526431833,1,23),(42235229,526431834,1,24),(42235229,526431836,1,25),(42235229,526431837,1,26),(42235229,526431839,1,27),(42235229,526431840,1,28),(42235229,526431842,1,29),(42235229,526431858,1,30),(42235229,526431859,1,31),(42235229,526431860,1,32),(42235229,526431861,1,33),(42235229,526431863,1,34),(42235229,526431865,1,35),(42235229,526431866,1,36),(42235229,526431868,1,37),(42235229,526431869,1,38),(42235229,526431870,1,39),(42235229,526431872,1,40),(42235229,526431873,1,41),(42235229,526431875,1,42),(42235229,526431876,1,43),(42235229,526431878,1,44),(42235229,526431879,1,45),(42235229,526431881,1,46),(42235229,526431882,1,47),(42235229,526431884,1,48),(42235229,526431885,1,49),(42235229,526431887,1,50),(42235229,526431888,1,51),(42235229,526431892,1,52),(42235229,526431893,1,53),(42235229,526431895,1,54),(42235229,526431896,1,55),(42235229,526431898,1,56),(42235229,526431899,1,57),(42235229,526431901,1,58),(42235229,526431902,1,59),(42235229,526431903,1,60),(42235229,526431930,1,61),(42235229,526431932,1,62),(42235229,526431933,1,63),(42235229,526431935,1,64),(42235229,526432055,1,65),(42235229,526432057,1,66),(42235229,526432058,1,67),(42235229,526432060,1,68),(42235229,526432061,1,69),(42235229,526432063,1,70),(42235229,526432064,1,71),(42235229,526432067,1,72),(42235229,526432069,1,73),(42235229,526432070,1,74),(42235229,526432072,1,75),(42235229,526432073,1,76),(42235229,526432075,1,77),(42235229,526432076,1,78),(42235229,526432078,1,79),(42235229,526432079,1,80),(42235229,526432081,1,81),(42235229,526432082,1,82),(42235229,526432084,1,83),(42235229,526432085,1,84),(42235229,526432087,1,85),(42235229,526432088,1,86),(42235229,526432089,1,87),(42235229,526432091,1,88),(42235229,526432092,1,89),(42235229,526432096,1,90),(42235229,526432097,1,91),(42235229,526432099,1,92),(42235229,526432100,1,93),(42235229,526432102,1,94),(42235229,526432103,1,95),(42235229,526432105,1,96),(42235229,526432106,1,97),(42235229,526432108,1,98),(42235229,526432109,1,99),(42235229,526432111,1,100),(42235229,526432112,1,101),(42235229,526432114,1,102),(42235229,526432115,1,103),(42235229,526432117,1,104),(42235229,526432118,1,105),(42235229,526432120,1,106),(42235229,526432121,1,107),(42235229,526432122,1,108),(42235229,526432126,1,109),(42235229,526432127,1,110),(42235229,526432129,1,111),(42235229,526432130,1,112),(42235229,526432132,1,113),(42235229,526432133,1,114),(42235229,526432135,1,115),(42235229,526432136,1,116),(42235229,526432137,1,117),(42235229,526432139,1,118),(42235229,526432140,1,119),(42235229,526432142,1,120),(42235229,526432143,1,121),(42235229,526432145,1,122),(42235229,526432146,1,123),(42235229,526432148,1,124),(42235229,526432149,1,125),(42235229,526432151,1,126),(42235229,526432154,1,127),(42235229,526432156,1,128),(42235229,526432157,1,129),(42235229,526432159,1,130),(42235229,526432160,1,131),(42235229,526432162,1,132),(42235229,526432163,1,133),(42235229,526432165,1,134),(42235229,526432166,1,135),(42235229,526432168,1,136),(42235229,526432169,1,137),(42235229,526432171,1,138),(42235229,526432172,1,139),(42235229,526432174,1,140),(42235229,526432175,1,141),(42235229,526432176,1,142),(42235229,526432178,1,143),(42235229,526432179,1,144),(42235229,526432183,1,145),(42235229,526432185,1,146),(42235229,526432186,1,147),(42235229,526432188,1,148),(42235229,526432189,1,149),(42235229,526432190,1,150),(42235229,526432192,1,151),(42235229,526432193,1,152),(42235229,526432195,1,153),(42235229,526432196,1,154),(42235229,526432198,1,155),(42235229,526432199,1,156),(42235229,526432200,1,157),(42235229,526432202,1,158),(42235229,526432203,1,159),(42235229,526432205,1,160),(42235229,526432206,1,161),(42235229,526432208,1,162),(42235229,526432212,1,163),(42235229,526432213,1,164),(42235229,526432214,1,165),(42235229,526432216,1,166),(42235229,526432217,1,167),(42235229,526432219,1,168),(42235229,526432220,1,169),(42235229,526432222,1,170),(42235229,526432223,1,171),(42235229,526432225,1,172),(42235229,526432226,1,173),(42235229,526432228,1,174),(42235229,526432229,1,175),(42235229,526432231,1,176),(42235229,526432232,1,177),(42235229,526432234,1,178),(42235229,526432235,1,179),(42235229,526432237,1,180),(42235229,526432240,1,181),(42235229,526432242,1,182),(42235229,526432243,1,183),(42235229,526432245,1,184),(42235229,526432246,1,185),(42235229,526432248,1,186),(42235229,526432249,1,187),(42235229,526432251,1,188),(42235229,526432252,1,189),(42235229,526432254,1,190),(42235229,526432255,1,191),(42235229,526432257,1,192),(42235229,526432258,1,193),(42235229,526432260,1,194),(42235229,526432261,1,195),(42235229,526432263,1,196),(42235229,526432264,1,197),(42235229,526432266,1,198),(42235229,526432269,1,199),(42235229,526432271,1,200),(42235229,526432272,1,201),(42235229,526432274,1,202),(42235229,526432275,1,203),(42235229,526432277,1,204),(42235229,526432278,1,205),(42235229,526432279,1,206),(42235229,526432281,1,207),(42235229,526432282,1,208),(42235229,526432284,1,209),(42235229,526432286,1,210),(42235229,526432287,1,211),(42235229,526432289,1,212),(42235229,526432290,1,213),(42235229,526432292,1,214),(42235229,526432293,1,215),(42235229,526432295,1,216),(42235229,526432296,1,217),(42235229,526432300,1,218),(42235229,526432302,1,219),(42235229,526432303,1,220),(42235229,526432304,1,221),(42235229,526432306,1,222),(42235229,526432307,1,223),(42235229,526432309,1,224),(42235229,526432311,1,225),(42235229,526432312,1,226),(42235229,526432314,1,227),(42235229,526432315,1,228),(42235229,526432317,1,229),(42235229,526432318,1,230),(42235229,526432320,1,231),(42235229,526432321,1,232),(42235229,526432323,1,233),(42235229,526432324,1,234),(42235229,526432326,1,235),(42235229,526432328,1,236),(42235229,526432329,1,237),(42235229,526432330,1,238),(42235229,526432331,1,239),(42235229,526432332,1,240),(42235229,526432333,1,241),(42235229,526432334,1,242),(42235229,526432335,1,243),(42235229,526432336,1,244),(42235229,526432337,1,245),(42235229,526432338,1,246),(42235229,526432339,1,247),(42235229,526432340,1,248),(42235229,526432341,1,249),(42235229,526432342,1,250),(42235229,526432343,1,251),(42235229,526432344,1,252),(42235229,526432345,1,253),(42235229,526432349,1,254),(42235229,526432350,1,255),(42235229,526432352,1,256),(42235229,526432353,1,257),(42235229,526432355,1,258),(42235229,526432356,1,259),(42235229,526432358,1,260),(42235229,526432359,1,261),(42235229,526432361,1,262),(42235229,526432363,1,263),(42235229,526432364,1,264),(42235229,526432366,1,265),(42235229,526432367,1,266),(42235229,526432369,1,267),(42235229,526432370,1,268),(42235229,526432372,1,269),(42235229,526432373,1,270),(42235229,526432374,1,271),(42235229,526432378,1,272),(42235229,526432380,1,273),(42235229,526432381,1,274),(42235229,526432383,1,275),(42235229,526432384,1,276),(42235229,526432385,1,277),(42235229,526432387,1,278),(42235229,526432389,1,279),(42235229,526432390,1,280),(42235229,526432391,1,281),(42235229,526432393,1,282),(42235229,526432395,1,283),(42235229,526432396,1,284),(42235229,526432398,1,285),(42235229,526432399,1,286),(42235229,526432401,1,287),(42235229,526432402,1,288),(42235229,526432404,1,289),(42235229,526432408,1,290),(42235229,526432409,1,291),(42235229,526432411,1,292),(42235229,526432412,1,293),(42235229,526432414,1,294),(42235229,526432415,1,295),(42235229,526432417,1,296),(42235229,526432418,1,297),(42235229,526432420,1,298),(42235229,526432421,1,299),(42235229,526432423,1,300),(42235229,526432424,1,301),(42235229,526432426,1,302),(42235229,526432427,1,303),(42235229,526432429,1,304),(42235229,526432430,1,305),(42235229,526432432,1,306),(42235229,526432433,1,307),(42235229,526432435,1,308),(42235229,526432438,1,309),(42235229,526432440,1,310),(42235229,526432441,1,311),(42235229,526432443,1,312),(42235229,526432444,1,313),(42235229,526432446,1,314),(42235229,526432447,1,315),(42235229,526432449,1,316),(42235229,526432450,1,317),(42235229,526432452,1,318),(42235229,526432453,1,319),(42235229,526432455,1,320),(42235229,526432456,1,321),(42235229,526432458,1,322),(42235229,526432459,1,323),(42235229,526432461,1,324),(42235229,526432462,1,325),(42235229,526432464,1,326),(42235229,526432467,1,327),(42235229,526432469,1,328),(42235229,526432470,1,329),(42235229,526432472,1,330),(42235229,526432473,1,331),(42235229,526432475,1,332),(42235229,526432476,1,333),(42235229,526432478,1,334),(42235229,526432479,1,335),(42235229,526432481,1,336),(42235229,526432482,1,337),(42235229,526432484,1,338),(42235229,526432485,1,339),(42235229,526432486,1,340),(42235229,526432488,1,341),(42235229,526432489,1,342),(42235229,526432491,1,343),(42235229,526432492,1,344),(42235229,526432496,1,345),(42235229,526432497,1,346),(42235229,526432499,1,347),(42235229,526432500,1,348),(42235229,526432502,1,349),(42235229,526432503,1,350),(42235229,526432505,1,351),(42235229,526432506,1,352),(42235229,526432507,1,353),(42235229,526432509,1,354),(42235229,526432511,1,355),(42235229,526432527,1,356),(42235229,526432529,1,357),(42235229,526432530,1,358),(42235229,526432531,1,359),(42235229,526432532,1,360),(42235229,526432534,1,361),(42235229,526432537,1,362),(42235229,526432538,1,363),(42235229,526432539,1,364),(42235229,526432540,1,365),(42235229,526432541,1,366),(42235229,526432543,1,367),(42235229,526432544,1,368),(42235229,526432546,1,369),(42235229,526432547,1,370),(42235229,526432549,1,371),(42235229,526432550,1,372),(42235229,526432552,1,373),(42235229,526432553,1,374),(42235229,526432555,1,375),(42235229,526432556,1,376),(42235229,526432558,1,377),(42235229,526432559,1,378),(42235229,526432561,1,379),(42235229,526432564,1,380),(42235229,526432566,1,381),(42235229,526432567,1,382),(42235229,526432569,1,383),(42235229,526432570,1,384),(42235229,526432572,1,385),(42235229,526432573,1,386),(42235229,526432575,1,387),(42235229,526432576,1,388),(42235229,526432578,1,389),(42235229,526432579,1,390),(42235229,526432581,1,391),(42235229,526432582,1,392),(42235229,526432584,1,393),(42235229,526432585,1,394),(42235229,526432587,1,395),(42235229,526432588,1,396),(42235229,526432590,1,397),(42235229,526432593,1,398),(42235229,526432595,1,399),(42235229,526432596,1,400),(42235229,526432598,1,401),(42235229,526432600,1,402),(42235229,526432601,1,403),(42235229,526432603,1,404),(42235229,526432604,1,405),(42235229,526432606,1,406),(42235229,526432607,1,407),(42235229,526432609,1,408),(42235229,526432610,1,409),(42235229,526432611,1,410),(42235229,526432613,1,411),(42235229,526432614,1,412),(42235229,526432616,1,413),(42235229,526432618,1,414),(42235229,526432619,1,415),(42235229,526432642,1,416),(42235229,526432643,1,417),(42235229,526432645,1,418),(42235229,526432647,1,419),(42235229,526432648,1,420),(42235235,526433326,1,1),(42235235,526433329,1,2),(42235235,526433330,1,3),(42235235,526433332,1,4),(42235235,526433334,1,5),(42235235,526433335,1,6),(42235235,526433336,1,7),(42235235,526433338,1,8),(42235235,526433339,1,9),(42235235,526433343,1,10),(42235235,526433344,1,11),(42235235,526433351,1,12),(42235235,526433352,1,13),(42235235,526433354,1,14),(42235235,526432069,1,15),(42235235,526432067,1,16),(42235235,526432064,1,17),(42235235,526433355,1,18),(42235235,526433357,1,19),(42235235,526433358,1,20),(42235235,526433360,1,21),(42235255,526435772,1,1),(42235255,526435773,1,2),(42235255,526435775,1,3),(42235255,526435776,1,4),(42235255,526435778,1,5),(42235255,526435779,1,6),(42235255,526435781,1,7),(42235255,526435783,1,8),(42235255,526435784,1,9),(42235255,526435785,1,10),(42235255,526435787,1,11),(42235255,526435788,1,12),(42235255,526435790,1,13),(42235255,526435791,1,14),(42235255,526435793,1,15),(42235255,526435794,1,16),(42235255,526435796,1,17),(42235255,526435798,1,18),(42235255,526435800,1,19),(42235255,526435802,1,20),(42235255,526435808,1,21),(42235255,526435811,1,22),(42235255,526435812,1,23),(42235255,526435815,1,24),(42235255,526435816,1,25),(42235255,526435818,1,26),(42235255,526435820,1,27),(42235255,526435821,1,28),(42235255,526435824,1,29),(42235255,526435826,1,30),(42235255,526435827,1,31),(42235255,526435828,1,32),(42235255,526435830,1,33),(42235255,526435831,1,34),(42235255,526435851,1,35),(42235255,526435853,1,36),(42235255,526435854,1,37),(42235255,526435856,1,38),(42235255,526435858,1,39),(42235255,526435859,1,40),(42235255,526435861,1,41),(42235255,526435862,1,42),(42235255,526435864,1,43),(42235255,526435865,1,44),(42235255,526435867,1,45),(42235255,526435880,1,46),(42235255,526435881,1,47),(42235255,526435883,1,48),(42235255,526435884,1,49),(42235255,526435885,1,50),(42235255,526435887,1,51),(42235255,526435888,1,52),(42235255,526435889,1,53),(42235255,526435891,1,54),(42235255,526435892,1,55),(42235255,526435894,1,56),(42235255,526435895,1,57),(42235255,526435896,1,58),(42235255,526435898,1,59),(42235255,526435899,1,60),(42235255,526435901,1,61),(42235255,526435902,1,62),(42235255,526435903,1,63),(42235255,526435905,1,64),(42235255,526435906,1,65),(42235255,526435907,1,66),(42235255,526435908,1,67),(42235255,526435909,1,68),(42235255,526435910,1,69),(42235255,526435912,1,70),(42235255,526435913,1,71),(42235255,526435914,1,72),(42235255,526435916,1,73),(42235255,526435917,1,74),(42235255,526435918,1,75),(42235255,526435920,1,76),(42235255,526435921,1,77),(42235255,526435923,1,78),(42235255,526435924,1,79),(42235255,526435926,1,80),(42235255,522256224,1,81),(42235255,522256245,1,82),(42235255,522256243,1,83),(42235255,522256242,1,84),(42235255,526435927,1,85),(42235255,526435928,1,86),(42235255,526435930,1,87),(42235255,526435931,1,88),(42235255,526435933,1,89),(42235255,526435934,1,90),(42235255,526435935,1,91),(42235255,526435937,1,92),(42235255,526435953,1,93),(42235255,526435954,1,94),(42235255,526435955,1,95),(42235255,526435956,1,96),(42235256,526436136,1,1),(42235256,526436137,1,2),(42235256,526436139,1,3),(42235256,526436141,1,4),(42235256,526436142,1,5),(42235256,526436144,1,6),(42235256,526436145,1,7),(42235256,526436146,1,8),(42235256,526436148,1,9),(42235256,526436149,1,10),(42235256,526436151,1,11),(42235256,526436152,1,12),(42235256,526436154,1,13),(42235256,526436155,1,14),(42235256,526436157,1,15),(42235256,526436158,1,16),(42235256,526436160,1,17),(42235256,526436161,1,18),(42235256,526436162,1,19),(42235256,526436163,1,20),(42235256,526436164,1,21),(42235256,526436165,1,22),(42235256,526436167,1,23),(42235256,526436168,1,24),(42235256,526436169,1,25),(42235256,526436136,1,26),(42252195,526826196,3,1),(42252195,526826197,3,2),(42252195,526826198,3,3),(42252195,526826199,3,4),(42252195,526826200,3,5),(42252243,526827378,1,1),(42252243,526827379,1,2),(42252243,526827380,1,3),(42252243,526827381,1,4),(42252243,526827382,1,5),(42252243,526827383,1,6),(42252243,526827384,1,7),(42252243,526827385,1,8),(42252243,526827386,1,9),(42252243,526827387,1,10),(42252243,526827388,1,11),(42252243,526827389,1,12),(42252243,526827390,1,13),(42252243,526827391,1,14),(42252243,526827392,1,15),(42252243,526827393,1,16),(42252243,526827394,1,17),(42252243,526827395,1,18),(42252243,526827396,1,19),(42252243,526827397,1,20),(42252243,526827398,1,21),(42252243,526827399,1,22),(42252243,526827400,1,23),(42252243,526827401,1,24),(42252243,526827402,1,25),(42252243,526827403,1,26),(42252243,526827405,1,27),(42252243,526827406,1,28),(42252243,526827407,1,29),(42252243,526827410,1,30),(42252243,526827411,1,31),(42252243,526827412,1,32),(42252243,526827413,1,33),(42252243,526827414,1,34),(42252243,526827415,1,35),(42252243,526827416,1,36),(42252243,526827417,1,37),(42252243,526827418,1,38),(42252243,526827419,1,39),(42252243,526827420,1,40),(42252243,526827421,1,41),(42252243,526827422,1,42),(42252243,526827424,1,43),(42252243,526827425,1,44),(42252243,526827426,1,45),(42252243,526827378,1,46),(42252251,526827410,1,1),(42252251,526827607,1,2),(42252251,526827608,1,3),(42252251,526827609,1,4),(42252251,526827610,1,5),(42252251,526827611,1,6),(42252251,526827612,1,7),(42252251,526827613,1,8),(42252251,526827614,1,9),(42252251,526827615,1,10),(42252251,526827616,1,11),(42252251,526827417,1,12),(42252251,526827416,1,13),(42252251,526827415,1,14),(42252251,526827414,1,15),(42252251,526827413,1,16),(42252251,526827412,1,17),(42252251,526827411,1,18),(42252251,526827410,1,19),(42252272,526827609,1,1),(42252272,526828351,1,2),(42252272,526828352,1,3),(42252272,526828354,1,4),(42252272,526828355,1,5),(42252272,526828356,1,6),(42252272,526828357,1,7),(42252272,526828358,1,8),(42252272,526828359,1,9),(42252272,526828360,1,10),(42252272,526828361,1,11),(42252272,526828362,1,12),(42252272,526828363,1,13),(42252272,526828364,1,14),(42252272,526828365,1,15),(42252272,526828366,1,16),(42252272,526828367,1,17),(42252272,526828368,1,18),(42252272,526828369,1,19),(42252272,526828370,1,20),(42252272,526828371,1,21),(42252272,526828372,1,22),(42252272,526828373,1,23),(42252272,526827615,1,24),(42252272,526827614,1,25),(42252272,526827613,1,26),(42252272,526827612,1,27),(42252272,526827611,1,28),(42252272,526827610,1,29),(42252272,526827609,1,30),(42252309,526829149,1,1),(42252309,526829150,1,2),(42252309,526829151,1,3),(42252309,526829153,1,4),(42252309,526829154,1,5),(42252309,526829155,1,6),(42252309,526829156,1,7),(42252309,526829157,1,8),(42252309,526829158,1,9),(42252309,526829159,1,10),(42252309,526829161,1,11),(42252309,526829168,1,12),(42252309,526829170,1,13),(42252309,526829171,1,14),(42252326,526432193,1,1),(42252326,526829550,1,2),(42252326,526829551,1,3),(42252326,526829552,1,4),(42252326,526829553,1,5),(42252326,526829554,1,6),(42252326,526829555,1,7),(42252326,526829556,1,8),(42252326,526829557,1,9),(42252326,526829559,1,10),(42252326,526829560,1,11),(42252326,526829562,1,12),(42252326,526829563,1,13),(42252326,519515756,1,14),(42252326,519515772,1,15),(42252326,519515771,1,16),(42252326,526829564,1,17),(42252326,526829565,1,18),(42252326,526829566,1,19),(42252326,526829567,1,20),(42252326,526829569,1,21),(42252326,526829570,1,22),(42252326,526829571,1,23),(42252326,526829574,1,24),(42252326,526829575,1,25),(42252326,526829576,1,26),(42252326,526829577,1,27),(42252326,526829578,1,28),(42252326,526829579,1,29),(42252326,526829580,1,30),(42252326,526829581,1,31),(42252326,526829582,1,32),(42252326,526829584,1,33),(42252326,526829585,1,34),(42252326,526829586,1,35),(42252326,526829587,1,36),(42252326,526829589,1,37),(42252326,526829590,1,38),(42252326,526829591,1,39),(42252326,526829592,1,40),(42252326,526829594,1,41),(42252326,526829595,1,42),(42252326,526829596,1,43),(42252326,526829597,1,44),(42252326,526829598,1,45),(42252326,526829599,1,46),(42252326,526829600,1,47),(42252326,526829601,1,48),(42252326,526829603,1,49),(42252326,526829604,1,50),(42252326,526432206,1,51),(42252326,526432205,1,52),(42252326,526432203,1,53),(42252326,526432202,1,54),(42252326,526432200,1,55),(42252326,526432199,1,56),(42252326,526432198,1,57),(42252326,526432196,1,58),(42252326,526432195,1,59),(42252326,526432193,1,60),(42252348,526830271,1,1),(42252348,526830272,1,2),(42252348,526830274,1,3),(42252348,526830275,1,4),(42252348,526830276,1,5),(42252348,526830277,1,6),(42252348,526830278,1,7),(42252348,526830279,1,8),(42252348,526830280,1,9),(42252348,526830281,1,10),(42252348,526830283,1,11),(42252348,526830284,1,12),(42252348,526830285,1,13),(42252348,526830286,1,14),(42252348,526830287,1,15),(42252348,526830288,1,16),(42252348,526830289,1,17),(42252348,526830290,1,18),(42252348,526830291,1,19),(42252348,526830292,1,20),(42252348,526830293,1,21),(42252348,526830294,1,22),(42252348,526830295,1,23),(42252348,526830297,1,24),(42252348,526830298,1,25),(42252348,526830299,1,26),(42252348,526830300,1,27),(42252348,526830301,1,28),(42252348,526830302,1,29),(42252348,526830303,1,30),(42252348,526830304,1,31),(42252348,526830305,1,32),(42252348,526830306,1,33),(42252348,526830307,1,34),(42252348,526830308,1,35),(42252348,526830309,1,36),(42252348,526830310,1,37),(42252348,526830312,1,38),(42252348,526830313,1,39),(42252348,526830314,1,40),(42252348,526830315,1,41),(42252348,526830271,1,42),(42252384,526831529,1,1),(42252384,526831530,1,2),(42252384,522254646,1,3),(42252384,522254645,1,4),(42252384,522254644,1,5),(42252384,522254643,1,6),(42252384,522254642,1,7),(42252384,522254641,1,8),(42252384,522254640,1,9),(42252384,522254639,1,10),(42252384,522254638,1,11),(42252384,522254637,1,12),(42252384,522254636,1,13),(42252384,526831531,1,14),(42252384,526831532,1,15),(42252384,526831533,1,16),(42252384,526831534,1,17),(42252384,526831535,1,18),(42252384,526831536,1,19),(42252384,526831537,1,20),(42252384,526831538,1,21),(42252384,526831539,1,22),(42252384,526831540,1,23),(42252384,526831541,1,24),(42252384,526831542,1,25),(42252384,526831543,1,26),(42252384,526831544,1,27),(42252384,526831545,1,28),(42252384,526831546,1,29),(42252384,526831547,1,30),(42252384,526831548,1,31),(42252384,526831549,1,32),(42252384,526831550,1,33),(42252384,526831551,1,34),(42252384,526831552,1,35),(42252384,526831553,1,36),(42252384,526831529,1,37),(42451011,266330475,2,1),(42451011,266329457,2,2),(42451011,53319484,2,3),(42451016,266330464,2,1),(42451016,266330465,2,2),(42451016,266330466,2,3),(42451016,266330467,2,4),(42451016,266330468,2,5),(42451016,266330469,2,6),(42451016,266330470,2,7),(42451016,266330471,2,8),(42451016,266330472,2,9),(42451016,266330473,2,10),(42451016,266330475,2,11),(42451892,266330483,3,1),(42451892,529948761,3,2),(42451892,529948762,3,3),(42451892,529948763,3,4),(42451892,529948764,3,5),(42451892,529948765,3,6),(42809904,529948765,2,1),(42809904,529948766,2,2),(42810813,51415013,1,1),(42810813,51367769,1,2),(42810813,51367770,1,3),(42810813,51367772,1,4),(42810813,51367774,1,5),(42810813,51367776,1,6),(42810813,51367779,1,7),(42810813,51367783,1,8),(42810813,51367785,1,9),(42810813,51367787,1,10),(42810813,51367788,1,11),(42810813,270724742,1,12),(42810813,51367806,1,13),(42811127,535387283,2,1),(42811127,51415013,2,2),(42811127,535387288,2,3),(42811127,535387292,2,4),(42811127,535387294,2,5),(42811127,535386385,2,6),(42811127,535387296,2,7),(42811127,535385847,2,8),(42811127,535387283,2,9),(45511076,579974233,1,1),(45511076,579974236,1,2),(45511076,579974239,1,3),(45511076,579974243,1,4),(45511076,579974248,1,5),(45511076,579974253,1,6),(45511076,579974258,1,7),(45511076,579974267,1,8),(45511076,579974272,1,9),(45511076,579974276,1,10),(45511076,579974280,1,11),(45511076,579974361,1,12),(45511076,579972081,1,13),(45511076,579972127,1,14),(45511076,579972135,1,15),(45511076,579972136,1,16),(45511076,579972138,1,17),(45511076,579972142,1,18),(45511076,579972040,1,19),(45511076,579972062,1,20),(45511076,579971967,1,21),(45511076,579971988,1,22),(45511076,579971916,1,23),(45511076,579971917,1,24),(45511076,579971921,1,25),(45511076,579971959,1,26),(45511076,579971887,1,27),(45511076,579971891,1,28),(45511076,579971895,1,29),(45511076,579971896,1,30),(45511076,579971897,1,31),(45511076,579971898,1,32),(45511076,579971902,1,33),(45511076,579971909,1,34),(45511076,579971802,1,35),(45511076,579971757,1,36),(45511076,579971697,1,37),(45511076,579971713,1,38),(45511076,579971721,1,39),(45511076,579971414,1,40),(45511076,579971423,1,41),(45511076,579971445,1,42),(45511076,579971453,1,43),(45511076,579971472,1,44),(45511076,579971480,1,45),(45511076,579971484,1,46),(45511076,579971485,1,47),(45511076,579971493,1,48),(45511076,579971494,1,49),(45511076,579971492,1,50),(45511076,579972190,1,51),(45511076,579972196,1,52),(45511076,579972201,1,53),(45511076,579972206,1,54),(45511076,579972215,1,55),(45511076,579972234,1,56),(45511076,579972248,1,57),(45511076,579972256,1,58),(45511076,579972263,1,59),(45511076,579972270,1,60),(45511076,579972277,1,61),(45511076,579972294,1,62),(45511076,579972301,1,63),(45511076,579972312,1,64),(45511076,579972313,1,65),(45511076,579972314,1,66),(45511076,579972316,1,67),(45511076,579972323,1,68),(45511076,579972329,1,69),(45511076,579972335,1,70),(45511076,579972342,1,71),(45511076,579972344,1,72),(45511076,579972264,1,73),(45511076,579972345,1,74),(45511076,579972349,1,75),(45511084,579974346,1,1),(45511084,579974336,1,2),(45511084,579974311,1,3),(45511084,579974316,1,4),(45511084,579974321,1,5),(45511084,579974288,1,6),(45511084,579974296,1,7),(45511084,579974298,1,8),(45511084,579974308,1,9),(45511084,579974284,1,10),(45511084,579974160,1,11),(45511084,579974175,1,12),(45511084,579974193,1,13),(45511084,579974203,1,14),(45511084,579974208,1,15),(45511084,579974213,1,16),(45511090,579972407,1,1),(45511090,579972412,1,2),(45511090,579972420,1,3),(45511090,579972426,1,4),(45511090,579972437,1,5),(45511090,579972439,1,6),(45511090,579972444,1,7),(45511090,579972446,1,8),(45511090,579972453,1,9),(45511090,579972459,1,10),(45511090,579972466,1,11),(45511090,579972473,1,12),(45511090,579972478,1,13),(45511090,579972488,1,14),(45511090,579972496,1,15),(45511090,579972502,1,16),(45511090,579972508,1,17),(45511090,579972515,1,18),(45511090,579972533,1,19),(45511090,579972520,1,20),(45511090,579972522,1,21),(45511090,579972524,1,22),(45511090,579972528,1,23),(45511090,579972529,1,24),(45511090,579972530,1,25),(45511090,579972540,1,26),(45511090,579972544,1,27),(45511090,579972545,1,28),(45511090,579972546,1,29),(45511090,579972547,1,30),(45511090,579972553,1,31),(45511090,579972562,1,32),(45511090,579972575,1,33),(45511090,579972579,1,34),(45511090,579972589,1,35),(45511090,579972599,1,36),(45511090,579972612,1,37),(45511090,579972640,1,38),(45511090,579972651,1,39),(45511090,579972662,1,40),(45511090,579972678,1,41),(45511090,579972691,1,42),(45511090,579972712,1,43),(45511090,579972748,1,44),(45511090,579972759,1,45),(45511090,579972893,1,46),(45511090,579972911,1,47),(45511090,579972934,1,48),(45511090,579973009,1,49),(45511090,579973010,1,50),(45511090,579973012,1,51),(45511090,579973015,1,52),(45511090,579973018,1,53),(45511090,579973019,1,54),(45511090,579973021,1,55),(45511090,579973023,1,56),(45511090,579973025,1,57),(45511090,579973026,1,58),(45511090,579973027,1,59),(45511090,579973028,1,60),(45511090,579973029,1,61),(45511090,579973030,1,62),(45511090,579973031,1,63),(45511090,579973032,1,64),(45511090,579973033,1,65),(45511090,579973034,1,66),(45511090,579973454,1,67),(45511090,579973464,1,68),(45511090,579973477,1,69),(48271354,613344821,2,1),(48271354,613344822,2,2),(48271355,613344823,3,1),(48271355,613345211,3,2),(48271355,613344824,3,3),(48271356,613344825,2,1),(48271356,613344826,2,2),(48271356,613344827,2,3),(48928224,664598450,2,1),(48928224,664598768,2,2),(48928224,664598769,2,3),(48928224,664598771,2,4),(48928224,664598770,2,5),(48928224,664598774,2,6),(48928224,620937058,2,7),(48928224,664598772,2,8),(48928224,664598773,2,9),(48928224,620937061,2,10),(48928224,620937063,2,11),(48928224,620937064,2,12),(48928224,620937151,2,13),(48928224,620937156,2,14),(48928225,664598410,4,1),(48928225,664598411,4,2),(48928225,664598412,4,3),(48928225,664598432,4,4),(48928225,664598433,4,5),(48928225,664598434,4,6),(48928225,664598435,4,7),(48928225,664598428,4,8),(48928225,664598429,4,9),(48928225,664598430,4,10),(48928225,664598436,4,11),(48928225,664598437,4,12),(48928225,664598442,4,13),(48928225,664598443,4,14),(48928225,664598444,4,15),(48928225,664598445,4,16),(48928225,664598446,4,17),(48928225,664598461,4,18),(48928225,664598460,4,19),(48928225,664598462,4,20),(48928225,664598463,4,21),(48928225,664598464,4,22),(48928225,664598465,4,23),(48928225,664598466,4,24),(48928225,664598467,4,25),(48928225,664598468,4,26),(48928225,664598469,4,27),(48928225,664598861,4,28),(48928225,664598863,4,29),(48928225,664598864,4,30),(48928225,664598873,4,31),(48928225,664598874,4,32),(48928225,664598878,4,33),(48928225,664598879,4,34),(48928225,664598875,4,35),(48928225,664598876,4,36),(48928225,664598865,4,37),(48928225,664598866,4,38),(48928225,664598867,4,39),(48928225,664598880,4,40),(48928225,664598881,4,41),(48928225,664598882,4,42),(48928225,664598883,4,43),(48928225,664598884,4,44),(48928225,664598885,4,45),(48928225,664598886,4,46),(48928225,664598890,4,47),(48928225,620937182,4,48),(48928225,620937183,4,49),(48928225,620937185,4,50),(48928225,620937186,4,51),(48928225,664598895,4,52),(48928225,664598896,4,53),(48928225,664598891,4,54),(48928225,620937195,4,55),(48928225,620937196,4,56),(48928225,620937198,4,57),(48928225,620937114,4,58),(48928225,620937122,4,59),(48928225,620937124,4,60),(48928225,621166567,4,61),(48928225,620937120,4,62),(48928225,620937125,4,63),(48928225,620937127,4,64),(48928225,664560293,4,65),(48928225,620937130,4,66),(48928225,620937132,4,67),(48928225,620937136,4,68),(48928225,620937138,4,69),(48928225,664560295,4,70),(48928225,664560296,4,71),(48928225,664560297,4,72),(48928225,664560298,4,73),(48928225,664560299,4,74),(48928225,664560300,4,75),(48928225,664560301,4,76),(48928225,664560302,4,77),(48928225,664560303,4,78),(48928225,664560311,4,79),(48928225,664560310,4,80),(48928226,620937187,2,1),(48928226,664598877,2,2),(48928226,664598889,2,3),(48928226,664598888,2,4),(48928226,664598887,2,5),(48928226,664598894,2,6),(48928226,664598892,2,7),(48928226,620937188,2,8),(48928226,664598893,2,9),(48928226,620937199,2,10),(48928226,620937201,2,11),(48928226,620937203,2,12),(48928226,620937189,2,13),(48928226,620937190,2,14),(48928226,620937191,2,15),(48928226,620937192,2,16),(48928226,620937193,2,17),(48928226,620937204,2,18),(48928226,620937206,2,19),(48928226,620937211,2,20),(48928226,620937212,2,21),(48928226,620937214,2,22),(48928226,620937216,2,23),(48928226,620937143,2,24),(48928226,620937144,2,25),(48928226,620937149,2,26),(48928227,620937181,1,1),(48928227,620937040,1,2),(48928228,620937047,1,1),(48928228,620937044,1,2),(48928229,620937046,1,1),(48928229,620937036,1,2),(48928230,620937041,1,1),(48928230,620937034,1,2),(48928231,620937043,1,1),(48928231,620937038,1,2),(48928232,620937139,1,1),(48928232,620937072,1,2),(48928233,620937076,4,1),(48928233,620937078,4,2),(48928233,620937079,4,3),(48928233,620937081,4,4),(48928233,620937082,4,5),(48928233,620937084,4,6),(48928233,620937086,4,7),(48928233,620937087,4,8),(48928233,664560284,4,9),(48928233,620937092,4,10),(48928233,664560285,4,11),(48928233,620937097,4,12),(48928233,620937099,4,13),(48928233,620937100,4,14),(48928233,620937116,4,15),(48928233,620937117,4,16),(48928233,620937119,4,17),(48928233,620937135,4,18),(48928233,620937141,4,19),(48928233,620937146,4,20),(48928234,620937133,4,1),(48928234,620937049,4,2),(48928234,620937051,4,3),(48928234,620937056,4,4),(48928235,620937081,2,1),(48928235,620937089,2,2),(48928235,620937091,2,3),(48928235,620937094,2,4),(48928235,620937095,2,5),(48928235,620937102,2,6),(48928235,664560286,2,7),(48928235,620937108,2,8),(48928235,620937109,2,9),(48928235,620937111,2,10),(48928235,620937113,2,11),(48928235,664560290,2,12),(48928235,664560289,2,13),(48928235,664560288,2,14),(48928235,664560287,2,15),(48928235,664560292,2,16),(48928235,664560291,2,17),(48928235,664560306,2,18),(48928235,664560305,2,19),(48928235,664560304,2,20),(48928235,664560309,2,21),(48928235,664560308,2,22),(48928235,664560307,2,23),(48928236,620937066,5,1),(48928236,620937068,5,2),(48928236,620937069,5,3),(48928236,620937071,5,4),(48957244,621165050,2,1),(48957244,621165051,2,2),(48957244,621165052,2,3),(48957244,621165040,2,4),(48957244,621165041,2,5),(48957244,621165042,2,6),(48957244,621165043,2,7),(48957244,621165044,2,8),(48957244,621165045,2,9),(48957244,621165046,2,10),(48957244,621165047,2,11),(48957244,621165048,2,12),(48957244,621165053,2,13),(48957244,621165054,2,14),(48957244,621165055,2,15),(48957244,621165056,2,16),(48957244,621165057,2,17),(48957244,621164974,2,18),(48957244,621164975,2,19),(48957244,621164976,2,20),(48957244,621164977,2,21),(48957244,621164978,2,22),(48957244,621164979,2,23),(48957244,621164980,2,24),(48957244,621164981,2,25),(48957244,621164982,2,26),(48957245,621165003,2,1),(48957245,621165004,2,2),(48957245,621165005,2,3),(48957245,621165006,2,4),(48957245,621165061,2,5),(48957245,621165062,2,6),(48957245,621165063,2,7),(48957245,621165064,2,8),(48957245,621165065,2,9),(48957245,621165066,2,10),(48957245,621165069,2,11),(48957245,664560369,2,12),(48957245,621165070,2,13),(48957245,621165071,2,14),(48957246,621164973,1,1),(48957246,621165001,1,2),(48957247,621165018,1,1),(48957247,621165002,1,2),(48957248,621165019,1,1),(48957248,621165010,1,2),(48957249,621165020,1,1),(48957249,621165030,1,2),(48957250,621165007,1,1),(48957250,621165008,1,2),(48957250,621165009,1,3),(48957250,621164991,1,4),(48957250,621164992,1,5),(48957250,621164993,1,6),(48957250,621164994,1,7),(48957250,621164995,1,8),(48957250,621164996,1,9),(48957250,621164997,1,10),(48957250,621164983,1,11),(48957250,621164984,1,12),(48957250,621164985,1,13),(48957250,621164986,1,14),(48957250,621164987,1,15),(48957250,621164988,1,16),(48957250,621164989,1,17),(48957250,621164990,1,18),(48957250,621164998,1,19),(48957250,621164963,1,20),(48957250,621164964,1,21),(48957250,621164965,1,22),(48957250,621164966,1,23),(48957250,621164967,1,24),(48957250,621164968,1,25),(48957250,621164969,1,26),(48957250,621164970,1,27),(48957250,621164971,1,28),(48957250,621164972,1,29),(48957250,621164999,1,30),(48957251,621164999,1,1),(48957251,621165000,1,2),(48957252,621165022,1,1),(48957252,621165021,1,2),(48957253,621165000,1,1),(48957253,621165022,1,2),(48957254,621165031,1,1),(48957254,621165032,1,2),(48957254,621165033,1,3),(48957254,621165034,1,4),(48957254,621165035,1,5),(48957254,621165036,1,6),(48957254,621165037,1,7),(48957254,621165038,1,8),(48957254,621165039,1,9),(48957254,621165016,1,10),(48957254,621165011,1,11),(48957254,621165012,1,12),(48957254,621165013,1,13),(48957254,621165014,1,14),(48957254,621165015,1,15),(48957254,621165026,1,16),(48957254,621165023,1,17),(48957254,621165024,1,18),(48957255,621165016,1,1),(48957255,621165017,1,2),(48957255,621165027,1,3),(48957255,621165028,1,4),(48957255,621165029,1,5),(48957255,621165025,1,6),(48957256,621165067,1,1),(48957256,621165058,1,2),(48957257,621165068,1,1),(48957257,621165049,1,2),(48957258,621165059,4,1),(48957258,621165060,4,2),(48969498,621413194,3,1),(48969498,621413197,3,2),(48969498,664605757,3,3),(48969498,621413198,3,4),(48969498,664605762,3,5),(48969498,664605760,3,6),(48969498,621413199,3,7),(48969498,621413200,3,8),(48969498,664605761,3,9),(48969498,621413201,3,10),(48969498,621413202,3,11),(48969498,664605759,3,12),(48969498,664559879,3,13),(48969498,621413203,3,14),(48969498,621413204,3,15),(48969498,664559865,3,16),(48969498,621413211,3,17),(48969498,621413212,3,18),(48969498,664559921,3,19),(48969498,664605764,3,20),(48969498,664559931,3,21),(48969498,621413213,3,22),(48969498,664559933,3,23),(48969498,664559943,3,24),(48969498,664559945,3,25),(48969498,664559959,3,26),(48969498,664605770,3,27),(48969498,621413210,3,28),(48969498,664560276,3,29),(48969498,664605893,3,30),(48969498,664560277,3,31),(48969498,664560278,3,32),(48969498,664560279,3,33),(48969498,664560274,3,34),(48969498,664560275,3,35),(48969498,664560282,3,36),(48969498,664560283,3,37),(48969498,621413223,3,38),(48969499,621413214,2,1),(48969499,621413215,2,2),(48969499,621413216,2,3),(48969499,621413217,2,4),(48969499,621413218,2,5),(48969499,621413219,2,6),(48969499,664560077,2,7),(48969499,664560078,2,8),(48969499,664560079,2,9),(48969499,664560080,2,10),(48969499,664560101,2,11),(48969499,621413220,2,12),(48969499,664560116,2,13),(48969499,621413221,2,14),(48969499,664560187,2,15),(48969499,621413222,2,16),(48969499,621413205,2,17),(48969499,621413206,2,18),(48969499,621413207,2,19),(48969499,621413208,2,20),(48969499,621413209,2,21),(48969499,664559961,2,22),(48969499,621413210,2,23),(48979047,621467570,2,1),(48979047,664598766,2,2),(48979047,664598767,2,3),(48979047,621467571,2,4),(48979047,664598470,2,5),(48979047,621467603,2,6),(48979047,621467612,2,7),(48979050,621467424,3,1),(48979050,621467427,3,2),(48979050,621467428,3,3),(48979050,621467429,3,4),(48979050,621467436,3,5),(48979050,621467437,3,6),(48979050,621467438,3,7),(48979050,621467439,3,8),(48979050,621467441,3,9),(48979050,621467442,3,10),(48979050,621467443,3,11),(48979050,621467444,3,12),(48979050,621467445,3,13),(48979050,621467446,3,14),(48979050,621467586,3,15),(48979050,621467587,3,16),(48979050,621467589,3,17),(48979050,621467590,3,18),(48979051,621467416,2,1),(48979051,664560020,2,2),(48979051,664560054,2,3),(48979051,664560021,2,4),(48979051,664560022,2,5),(48979051,664560023,2,6),(48979051,664560025,2,7),(48979051,621467417,2,8),(48979051,664560055,2,9),(48979051,621467592,2,10),(48979051,621467593,2,11),(48979052,621467416,2,1),(48979052,621467419,2,2),(48979052,621467420,2,3),(48979052,664560024,2,4),(48979052,621467421,2,5),(48979052,621467582,2,6),(48979052,621467598,2,7),(48979052,621467593,2,8),(48979052,621467595,2,9),(48979052,621467590,2,10),(48979052,621467596,2,11),(48979052,621467599,2,12),(48979052,664560371,2,13),(48979052,664560372,2,14),(48979052,664560373,2,15),(48979052,664560381,2,16),(48979052,664560382,2,17),(48979052,664560380,2,18),(48979055,621467468,1,1),(48979055,621467469,1,2),(48979055,621467470,1,3),(48979055,621467471,1,4),(48979055,621467472,1,5),(48979055,621467473,1,6),(48979055,621467519,1,7),(48979055,621467520,1,8),(48979055,621467521,1,9),(48979055,621467522,1,10),(48979055,621467523,1,11),(48979055,621467524,1,12),(48979055,621467526,1,13),(48979055,621467527,1,14),(48979055,621467529,1,15),(48979055,621467530,1,16),(48979055,621467531,1,17),(48979056,621467463,3,1),(48979056,621467464,3,2),(48979056,664560199,3,3),(48979056,621467492,3,4),(48979056,621467482,3,5),(48979056,664560230,3,6),(48979056,621467483,3,7),(48979056,621467484,3,8),(48979056,621467485,3,9),(48979056,621467481,3,10),(48979056,621467486,3,11),(48979056,621467487,3,12),(48979056,621467488,3,13),(48979056,621467502,3,14),(48979056,621467503,3,15),(48979056,621467504,3,16),(48979056,621467505,3,17),(48979056,621467506,3,18),(48979056,621467507,3,19),(48979056,621467600,3,20),(48979056,621467601,3,21),(48979056,621467615,3,22),(48979056,664598858,3,23),(48979056,664598860,3,24),(48979057,621467411,2,1),(48979057,621467412,2,2),(48979057,621467422,2,3),(48979057,621467423,2,4),(48979057,664560026,2,5),(48979057,621467424,2,6),(48979058,621165050,2,1),(48979058,621467413,2,2),(48979058,621467414,2,3),(48979058,621467415,2,4),(48979058,621467425,2,5),(48979058,621467426,2,6),(48979058,621467424,2,7),(48979058,621467430,2,8),(48979058,664560039,2,9),(48979058,621467416,2,10),(48979059,664598401,3,1),(48979059,621467452,3,2),(48979059,621467453,3,3),(48979059,621467454,3,4),(48979059,621467455,3,5),(48979059,621467456,3,6),(48979059,621467477,3,7),(48979059,621467478,3,8),(48979059,621467479,3,9),(48979059,621467480,3,10),(48979059,621467490,3,11),(48979059,664560241,3,12),(48979060,621467422,1,1),(48979060,621467431,1,2),(48979060,621467432,1,3),(48979060,621467433,1,4),(48979060,621467434,1,5),(48979060,621467435,1,6),(48979060,621467450,1,7),(48979060,621467451,1,8),(48979060,621467474,1,9),(48979060,621467475,1,10),(48979060,621467476,1,11),(48979060,621467489,1,12),(48979060,621467490,1,13),(48979062,621413194,6,1),(48979062,621467407,6,2),(48979062,621467409,6,3),(48979062,621467447,6,4),(48979062,621467448,6,5),(48979062,664605825,6,6),(48979062,664605826,6,7),(48979062,664605827,6,8),(48979062,621467449,6,9),(48979062,621453850,6,10),(48979062,621467457,6,11),(48979062,664560197,6,12),(48979062,664605851,6,13),(48979062,664605853,6,14),(48979062,664605854,6,15),(48979062,621467461,6,16),(48979062,621467462,6,17),(48979062,664605855,6,18),(48979062,664560200,6,19),(48979062,664598407,6,20),(48979062,664598408,6,21),(48979062,664598409,6,22),(48979062,664598431,6,23),(48979062,621467491,6,24),(48979062,621467493,6,25),(48979062,621467494,6,26),(48979062,621467495,6,27),(48979062,621467496,6,28),(48979062,621467497,6,29),(48979062,621467508,6,30),(48979062,621467509,6,31),(48979062,621467510,6,32),(48979062,621467499,6,33),(48979062,621467501,6,34),(48979062,621467563,6,35),(48979062,621467565,6,36),(48979062,621467566,6,37),(48979062,621467568,6,38),(48979062,621467569,6,39),(48979062,620937059,6,40),(48979062,664598745,6,41),(48979062,664598746,6,42),(48979062,664598717,6,43),(48979062,664598725,6,44),(48979062,664598718,6,45),(48979062,664598719,6,46),(48979062,664598720,6,47),(48979062,664598721,6,48),(48979062,664598722,6,49),(48979062,664598723,6,50),(48979062,664598724,6,51),(48979062,664598708,6,52),(48979062,664598709,6,53),(48979062,664598710,6,54),(48979062,664598711,6,55),(48979062,664598712,6,56),(48979062,664598726,6,57),(48979062,664598727,6,58),(48979062,664598728,6,59),(48979062,664598729,6,60),(48979062,664598730,6,61),(48979062,664598731,6,62),(48979062,664598732,6,63),(48979062,664598733,6,64),(48979062,664598582,6,65),(48979062,664598600,6,66),(48979062,664598601,6,67),(48979062,664598602,6,68),(48979062,621467513,6,69),(48979062,621467540,6,70),(48979062,664598734,6,71),(48979062,621467541,6,72),(48979062,621467543,6,73),(48979062,621467544,6,74),(48979062,621467545,6,75),(48979062,621467546,6,76),(48979062,621467547,6,77),(48979062,621467549,6,78),(48979062,621467550,6,79),(48979062,621467552,6,80),(48979062,621467554,6,81),(48979062,621467555,6,82),(48979062,621467557,6,83),(48979062,621467558,6,84),(48979062,621467559,6,85),(48979062,621467560,6,86),(48979062,621467572,6,87),(48979062,621467573,6,88),(48979062,664598785,6,89),(48979062,621467574,6,90),(48979062,621467575,6,91),(48979062,621467576,6,92),(48979062,621467577,6,93),(48979062,621473083,6,94),(48979062,664560294,6,95),(48979062,664598837,6,96),(48979062,664598846,6,97),(48979062,664598848,6,98),(48979062,664598850,6,99),(48979062,664598852,6,100),(48979062,664598854,6,101),(48979062,664598855,6,102),(48979062,664598857,6,103),(48979062,664598849,6,104),(48979062,664598838,6,105),(48979062,664598840,6,106),(48979062,664598842,6,107),(48979062,664598823,6,108),(48979062,664598824,6,109),(48979062,664598825,6,110),(48979062,664598826,6,111),(48979062,664598828,6,112),(48979062,664598829,6,113),(48979062,664598818,6,114),(48979062,664598819,6,115),(48979062,664598820,6,116),(48979062,664598821,6,117),(48979062,664598822,6,118),(48979062,664598811,6,119),(48979062,664598812,6,120),(48979062,664598813,6,121),(48979062,664598835,6,122),(48979063,621467561,1,1),(48979063,621467562,1,2),(48979063,620937076,1,3),(50568365,643575502,2,1),(50568365,643575498,2,2),(50568365,643575500,2,3),(50568365,643575190,2,4),(50568365,643575192,2,5),(50568365,643575187,2,6),(50568365,643575186,2,7),(50568365,643575167,2,8),(50568365,643575169,2,9),(50568365,643575181,2,10),(50568365,643575184,2,11),(50568365,643575180,2,12),(50568365,643575177,2,13),(50568365,643575176,2,14),(50568365,643575179,2,15),(50568365,643575178,2,16),(50568365,643575173,2,17),(50568365,643575171,2,18),(50568365,643575174,2,19),(50568365,643575165,2,20),(50568365,643575159,2,21),(50568365,643575156,2,22),(50568365,643575163,2,23),(50568365,643575160,2,24),(50568365,643575150,2,25),(50568365,643575147,2,26),(50568365,643575154,2,27),(50568365,643575152,2,28),(50568365,643575120,2,29),(50568365,643575122,2,30),(50568365,643575124,2,31),(50568365,643575126,2,32),(50568365,643575118,2,33),(50568365,643575134,2,34),(50568365,643575135,2,35),(50568365,643575138,2,36),(50568365,643575127,2,37),(50568365,643575129,2,38),(50568365,643575131,2,39),(50568365,643575204,2,40),(50568365,643575203,2,41),(50568365,643575196,2,42),(50568365,643575199,2,43),(50568365,643575200,2,44),(50568365,643575096,2,45),(50568365,643575092,2,46),(50568365,643575094,2,47),(50568365,643575061,2,48),(50568365,643575062,2,49),(50568365,643575063,2,50),(50568365,643575065,2,51),(50568365,643575075,2,52),(50568365,643575077,2,53),(50568365,643575080,2,54),(50568365,643575074,2,55),(50568365,643575066,2,56),(50568365,643575069,2,57),(50568365,643575071,2,58),(50568365,643575042,2,59),(50568365,643575040,2,60),(50568365,643575035,2,61),(50568365,643575043,2,62),(50568365,643575025,2,63),(50568365,643575023,2,64),(50568365,643575021,2,65),(50568365,643575026,2,66),(50568365,643575031,2,67),(50568365,643575030,2,68),(50568365,643575029,2,69),(50568365,643575034,2,70),(50568365,643575032,2,71),(50568365,643575028,2,72),(50568365,643575027,2,73),(50568366,643575264,1,1),(50734991,366076279,1,1),(50734991,366076706,1,2),(50734991,366076707,1,3),(50734991,366076708,1,4),(50734991,366076709,1,5),(50734991,366076710,1,6),(50734991,366076711,1,7),(50734991,366076712,1,8),(50734991,366076713,1,9),(50734991,366076714,1,10),(50734991,366076715,1,11),(50734991,366076716,1,12),(50734991,366076717,1,13),(50734991,366076718,1,14),(50734991,366076719,1,15),(50734991,366076720,1,16),(50734991,366076721,1,17),(50734991,366076722,1,18),(50734991,366076723,1,19),(50734991,52206691,1,20),(52008425,663075946,2,1),(52008425,663075945,2,2),(52008767,663078911,1,1),(52008767,663078912,1,2),(52009081,663080313,1,1),(52009081,663080312,1,2),(52009565,663084328,1,1),(52009565,663084327,1,2),(52010630,663092389,1,1),(52010630,663092390,1,2),(52010729,663093430,1,1),(52010729,663093429,1,2),(52010876,663095052,1,1),(52035289,663339199,1,1),(52035289,663339197,1,2),(52036011,663345421,2,1),(52036011,663345420,2,2),(52038527,663372540,1,1),(52038527,663372539,1,2),(52038627,663373402,2,1),(52038627,664236928,2,2),(52038627,664236926,2,3),(52038627,664236927,2,4),(52038627,664236925,2,5),(52038627,664236924,2,6),(52038627,663373401,2,7),(52083535,663802645,1,1),(52083535,663802644,1,2),(52083655,663803594,1,1),(52083655,663803593,1,2),(52084359,663810390,2,1),(52084359,663810391,2,2),(52084359,663810387,2,3),(52084359,663810389,2,4),(52084359,663810393,2,5),(52084359,663810392,2,6),(52084359,663810394,2,7),(52084359,668901629,2,8),(52084359,668901909,2,9),(52084359,663810395,2,10),(52084359,668901951,2,11),(52084359,668901968,2,12),(52084359,668901972,2,13),(52084359,663810396,2,14),(52098923,663952666,1,1),(52098923,663952667,1,2),(52099062,663953551,1,1),(52099062,663953552,1,2),(52099062,663953553,1,3),(52099251,663955434,2,1),(52099251,668901847,2,2),(52099251,668901848,2,3),(52099251,668901849,2,4),(52099251,663955435,2,5),(52099251,663955433,2,6),(52099251,663955443,2,7),(52099251,663955446,2,8),(52099251,663955445,2,9),(52099251,663955444,2,10),(52099251,663955447,2,11),(52099251,663955466,2,12),(52099251,663955464,2,13),(52099251,663955463,2,14),(52099251,663955465,2,15),(52099251,663955462,2,16),(52099251,663955459,2,17),(52099251,663955441,2,18),(52099251,663955442,2,19),(52099251,663955440,2,20),(52099251,663955438,2,21),(52099251,663955436,2,22),(52099251,663955437,2,23),(52099251,663955439,2,24),(52099251,663955456,2,25),(52099251,663955460,2,26),(52099251,663955461,2,27),(52099251,663955458,2,28),(52099251,663955457,2,29),(52099251,663955450,2,30),(52099251,663955449,2,31),(52099251,663955448,2,32),(52099251,663955451,2,33),(52099251,663955453,2,34),(52099251,663955452,2,35),(52099251,663955454,2,36),(52099251,663955455,2,37),(52099335,663956152,1,1),(52099335,663956153,1,2),(52099335,663956154,1,3),(52099335,663956155,1,4),(52099335,663956167,1,5),(52099335,663956156,1,6),(52099335,663956157,1,7),(52099335,663956158,1,8),(52099335,663956159,1,9),(52099335,663956160,1,10),(52099335,663956161,1,11),(52099335,663956162,1,12),(52099335,663956163,1,13),(52099335,663956164,1,14),(52099335,663956166,1,15),(52099335,663956165,1,16),(52099335,663956168,1,17),(52099335,663956169,1,18),(52099335,663956170,1,19),(52099379,663956738,2,1),(52099379,663956739,2,2),(52099379,663956740,2,3),(52099379,663956742,2,4),(52099379,663956743,2,5),(52099379,663956744,2,6),(52099379,663956745,2,7),(52099379,663956746,2,8),(52099379,663956747,2,9),(52099379,663956748,2,10),(52099379,663956749,2,11),(52099379,663956750,2,12),(52099379,663956751,2,13),(52099379,663956753,2,14),(52099379,663956752,2,15),(52099379,663956754,2,16),(52099379,663956755,2,17),(52099379,663956756,2,18),(52099485,663957562,2,1),(52099485,668901395,2,2),(52099485,668901396,2,3),(52099485,668901397,2,4),(52099485,668901398,2,5),(52099485,668901399,2,6),(52099485,668901400,2,7),(52099485,668901401,2,8),(52099485,668901402,2,9),(52099485,668901403,2,10),(52099485,668901404,2,11),(52099485,668901405,2,12),(52099485,668901441,2,13),(52099485,668901442,2,14),(52099485,668901443,2,15),(52099485,668901444,2,16),(52099485,668901445,2,17),(52099485,668901446,2,18),(52099485,668901447,2,19),(52099485,663957559,2,20),(52110420,664061747,2,1),(52110420,664061744,2,2),(52110421,664061748,3,1),(52110421,664061746,3,2),(52112644,664085286,2,1),(52112644,664085290,2,2),(52112644,664085291,2,3),(52112644,664085292,2,4),(52112644,664085297,2,5),(52112644,664085298,2,6),(52112644,664085308,2,7),(52112644,664085309,2,8),(52112644,664085310,2,9),(52112644,664085311,2,10),(52112644,664085276,2,11),(52112644,664085277,2,12),(52112644,664085278,2,13),(52112644,664085279,2,14),(52112645,664085287,2,1),(52112645,664085293,2,2),(52112645,664085294,2,3),(52112645,664085296,2,4),(52112645,664085299,2,5),(52112645,664085275,2,6),(52112645,664085280,2,7),(52112645,664085281,2,8),(52112645,664085282,2,9),(52112646,664085283,2,1),(52112646,664085288,2,2),(52112647,664085390,1,1),(52112647,664085392,1,2),(52112647,664085375,1,3),(52112647,664085376,1,4),(52112647,664085380,1,5),(52112647,664085368,1,6),(52112647,664085369,1,7),(52112647,664085371,1,8),(52112647,664085372,1,9),(52112648,664085382,2,1),(52112648,664085383,2,2),(52112648,664085384,2,3),(52112648,664085385,2,4),(52112648,664085386,2,5),(52112648,664085387,2,6),(52112648,664085388,2,7),(52112648,664085389,2,8),(52112648,664085393,2,9),(52112649,664085381,1,1),(52112649,664085345,1,2),(52112649,664085346,1,3),(52112649,664085377,1,4),(52112649,664085379,1,5),(52112649,664085365,1,6),(52112649,664085367,1,7),(52112649,664085373,1,8),(52112650,664085344,1,1),(52112650,664085348,1,2),(52112650,664085354,1,3),(52112650,664085339,1,4),(52112650,664085340,1,5),(52112650,664085341,1,6),(52112650,664085342,1,7),(52112650,664085324,1,8),(52112650,664085325,1,9),(52112650,664085326,1,10),(52112650,664085327,1,11),(52112650,664085316,1,12),(52112650,664085317,1,13),(52112650,664085318,1,14),(52112650,664085319,1,15),(52112650,664085320,1,16),(52112650,664085328,1,17),(52112650,664085329,1,18),(52112650,664085330,1,19),(52112650,664085334,1,20),(52112650,664085358,1,21),(52112650,664085360,1,22),(52112650,664085364,1,23),(52112651,664085284,1,1),(52112651,664085285,1,2),(52112651,664085289,1,3),(52112651,664085300,1,4),(52112651,664085301,1,5),(52112651,664085302,1,6),(52112651,664085303,1,7),(52112651,664085307,1,8),(52112651,664085323,1,9),(52112651,664085335,1,10),(52112651,664085336,1,11),(52112651,664085337,1,12),(52112651,664085338,1,13),(52112651,664085355,1,14),(52112651,664085357,1,15),(52112651,664085361,1,16),(52112651,664085362,1,17),(52112652,664085304,1,1),(52112652,664085305,1,2),(52112652,664085306,1,3),(52112652,664085312,1,4),(52112652,664085313,1,5),(52112652,664085314,1,6),(52112652,664085315,1,7),(52112652,664085321,1,8),(52112652,664085322,1,9),(52112652,664085331,1,10),(52112652,664085332,1,11),(52112652,664085333,1,12),(52114934,664115832,1,1),(52114934,664116115,1,2),(52114934,664116116,1,3),(52114934,664116117,1,4),(52114934,664116118,1,5),(52114934,664116119,1,6),(52114934,664116120,1,7),(52114934,664116121,1,8),(52114934,664116122,1,9),(52114934,664116125,1,10),(52114934,664116126,1,11),(52114934,664116127,1,12),(52114935,664115833,1,1),(52114935,664115834,1,2),(52114935,664115835,1,3),(52114935,664115836,1,4),(52114935,664116093,1,5),(52114935,664116094,1,6),(52114935,664116095,1,7),(52114935,664116096,1,8),(52114935,664116097,1,9),(52114935,664116098,1,10),(52114935,664116099,1,11),(52114935,664116100,1,12),(52114935,664116103,1,13),(52114935,664116104,1,14),(52114935,664116105,1,15),(52114935,664116106,1,16),(52114935,664116130,1,17),(52114935,664116131,1,18),(52114935,664116132,1,19),(52114935,664116133,1,20),(52114935,664116134,1,21),(52114935,664116139,1,22),(52114935,664116140,1,23),(52114935,664116144,1,24),(52114935,664116145,1,25),(52114935,664116146,1,26),(52114935,664116147,1,27),(52114935,664116148,1,28),(52114935,664116149,1,29),(52114935,664116160,1,30),(52114936,664115822,1,1),(52114936,664115823,1,2),(52114936,664115824,1,3),(52114936,664115825,1,4),(52114936,664115826,1,5),(52114936,664115827,1,6),(52114936,664115828,1,7),(52114936,664115829,1,8),(52114936,664115830,1,9),(52114936,664115831,1,10),(52114936,664115837,1,11),(52114936,664116109,1,12),(52114936,664116110,1,13),(52114936,664116111,1,14),(52114936,664116112,1,15),(52114936,664116113,1,16),(52114936,664116114,1,17),(52114936,664116123,1,18),(52114936,664116124,1,19),(52114936,664116128,1,20),(52114936,664116129,1,21),(52114936,664116150,1,22),(52114936,664116151,1,23),(52114936,664116152,1,24),(52114936,664116153,1,25),(52114936,664116154,1,26),(52114936,664116155,1,27),(52114936,664116156,1,28),(52114936,664116157,1,29),(52114936,664116158,1,30),(52114936,664116159,1,31),(52114936,664116141,1,32),(52114936,664116142,1,33),(52114936,664116143,1,34),(52114936,664116136,1,35),(52114936,664116137,1,36),(52114936,664116138,1,37),(52114936,664116135,1,38),(52114936,664116066,1,39),(52114936,664116067,1,40),(52114936,664116068,1,41),(52114936,664116069,1,42),(52114936,664116058,1,43),(52114936,664116080,1,44),(52114936,664116081,1,45),(52114936,664116082,1,46),(52114936,664116083,1,47),(52114936,664116084,1,48),(52114936,664116090,1,49),(52114937,664116020,1,1),(52114937,664116018,1,2),(52114937,664116019,1,3),(52114937,664115917,1,4),(52114937,664115918,1,5),(52114937,664115919,1,6),(52114937,664115920,1,7),(52114937,664115905,1,8),(52114937,664115938,1,9),(52114937,664115940,1,10),(52114937,664115941,1,11),(52114937,664115943,1,12),(52114937,664115945,1,13),(52114937,664115947,1,14),(52114937,664115927,1,15),(52114937,664115928,1,16),(52114937,664115929,1,17),(52114937,664115933,1,18),(52114937,664115935,1,19),(52114937,664115936,1,20),(52114937,664115957,1,21),(52114937,664115958,1,22),(52114937,664115960,1,23),(52114937,664115961,1,24),(52114937,664115965,1,25),(52114937,664115966,1,26),(52114937,664115967,1,27),(52114937,664115968,1,28),(52114937,664115970,1,29),(52114937,664115971,1,30),(52114937,664115878,1,31),(52114937,664115879,1,32),(52114937,664115880,1,33),(52114937,664115881,1,34),(52114937,664115882,1,35),(52114937,664115883,1,36),(52114937,664115973,1,37),(52114937,664115974,1,38),(52114937,664115976,1,39),(52114937,664116008,1,40),(52114937,664116009,1,41),(52114937,664116011,1,42),(52114937,664116012,1,43),(52114938,664115765,1,1),(52114938,664115766,1,2),(52114938,664115767,1,3),(52114938,664115844,1,4),(52114938,664115845,1,5),(52114938,664115846,1,6),(52114938,664115847,1,7),(52114938,664115848,1,8),(52114938,664115849,1,9),(52114938,664115850,1,10),(52114938,664115853,1,11),(52114938,664115854,1,12),(52114938,664115855,1,13),(52114938,664115863,1,14),(52114938,664115864,1,15),(52114938,664115865,1,16),(52114938,664115866,1,17),(52114938,664115872,1,18),(52114938,664115873,1,19),(52114938,664115874,1,20),(52114938,664115909,1,21),(52114938,664115910,1,22),(52114938,664115930,1,23),(52114938,664115931,1,24),(52114938,664115955,1,25),(52114939,664115932,1,1),(52114940,664115763,1,1),(52114940,664115800,1,2),(52114940,664115804,1,3),(52114940,664115805,1,4),(52114940,664115806,1,5),(52114940,664115807,1,6),(52114942,664115810,1,1),(52114943,664115756,1,1),(52114943,664115768,1,2),(52114943,664115770,1,3),(52114943,664115769,1,4),(52114943,664115773,1,5),(52114943,664115772,1,6),(52114943,664115777,1,7),(52114943,664115776,1,8),(52114943,664115775,1,9),(52114943,664115774,1,10),(52114943,664115781,1,11),(52114943,664115780,1,12),(52114943,664115779,1,13),(52114943,664115778,1,14),(52114943,664115771,1,15),(52114943,664115869,1,16),(52114943,367682694,1,17),(52114943,664115894,1,18),(52114943,664115899,1,19),(52114943,664115900,1,20),(52114944,664115789,1,1),(52114944,664115790,1,2),(52114944,664115791,1,3),(52114944,664115817,1,4),(52114944,664115818,1,5),(52114944,664115819,1,6),(52114944,664115801,1,7),(52114944,664115802,1,8),(52114944,664115803,1,9),(52114944,664115811,1,10),(52114944,664115812,1,11),(52114944,664115813,1,12),(52114944,664115814,1,13),(52114944,664115815,1,14),(52114944,664115816,1,15),(52114944,664115851,1,16),(52114944,664115852,1,17),(52114944,664115858,1,18),(52114944,664115859,1,19),(52114944,664115856,1,20),(52114944,664115857,1,21),(52114944,664115867,1,22),(52114944,664115868,1,23),(52114944,664115870,1,24),(52114944,664115871,1,25),(52114944,664115892,1,26),(52114944,664115895,1,27),(52114944,664115901,1,28),(52114944,664115902,1,29),(52114944,664115911,1,30),(52114944,664115912,1,31),(52114944,664115913,1,32),(52114944,664115914,1,33),(52114944,664115915,1,34),(52114944,664115916,1,35),(52114944,664116015,1,36),(52114944,664116016,1,37),(52114944,664116017,1,38),(52114944,664116021,1,39),(52114946,664115893,1,1),(52114946,664115903,1,2),(52114946,664115904,1,3),(52114946,664115921,1,4),(52114946,664115922,1,5),(52114946,664115923,1,6),(52114946,664115924,1,7),(52114946,664115925,1,8),(52114946,664115926,1,9),(52114946,664115981,1,10),(52114946,664115983,1,11),(52114946,664115984,1,12),(52114946,664115985,1,13),(52114946,664115986,1,14),(52114946,664115987,1,15),(52114946,664115988,1,16),(52114946,664115989,1,17),(52114946,664115990,1,18),(52114946,664115991,1,19),(52114946,664116013,1,20),(52114947,664115890,1,1),(52114947,664115891,1,2),(52114947,664115896,1,3),(52114947,664115897,1,4),(52114947,664115898,1,5),(52114947,664115906,1,6),(52114947,664115907,1,7),(52114947,664115908,1,8),(52114947,664115948,1,9),(52114947,664115950,1,10),(52114947,664115952,1,11),(52114947,664115953,1,12),(52114947,664115962,1,13),(52114947,664115963,1,14),(52114947,664115964,1,15),(52114947,664115977,1,16),(52114947,664115978,1,17),(52114947,664115980,1,18),(52114947,664115992,1,19),(52114947,664115993,1,20),(52114947,664116014,1,21),(52114948,664115808,1,1),(52114948,664115809,1,2),(52114948,664115860,1,3),(52114948,664115861,1,4),(52114948,664115862,1,5),(52114948,664115875,1,6),(52114948,664115876,1,7),(52114948,664115877,1,8),(52114948,664115884,1,9),(52114948,664115885,1,10),(52114948,664115886,1,11),(52114948,664115887,1,12),(52114949,664115792,1,1),(52114949,664115793,1,2),(52114949,664115838,1,3),(52114949,664115839,1,4),(52114949,664115840,1,5),(52114949,664115841,1,6),(52114949,664115842,1,7),(52114949,664115843,1,8),(52114949,664115996,1,9),(52114949,664116004,1,10),(52114949,664116005,1,11),(52114949,664116006,1,12),(52114949,664116007,1,13),(52114949,664115997,1,14),(52114949,664115998,1,15),(52114949,664115999,1,16),(52114949,664116000,1,17),(52114949,664115994,1,18),(52114949,664115995,1,19),(52114949,664116001,1,20),(52114949,664116002,1,21),(52114949,664116003,1,22),(52114949,664115888,1,23),(52114949,664115889,1,24),(52114950,664116022,1,1),(52114950,664116023,1,2),(52114950,664116024,1,3),(52114950,664116025,1,4),(52114950,664116026,1,5),(52114950,664116027,1,6),(52114950,664116028,1,7),(52114950,664116029,1,8),(52114950,367683084,1,9),(52114950,664116030,1,10),(52114950,664116031,1,11),(52114950,664116032,1,12),(52114950,664116033,1,13),(52114950,664116034,1,14),(52114950,664116035,1,15),(52114950,664116036,1,16),(52114950,664116037,1,17),(52114950,664116038,1,18),(52114950,664116039,1,19),(52114950,664116040,1,20),(52114951,664116101,1,1),(52114951,664116102,1,2),(52114951,664116107,1,3),(52114951,664116108,1,4),(52114951,664116041,1,5),(52114951,664116042,1,6),(52114951,664116043,1,7),(52114951,664116044,1,8),(52114951,664116045,1,9),(52114951,664116046,1,10),(52114951,664116047,1,11),(52114951,664116048,1,12),(52114951,664116049,1,13),(52114951,664116050,1,14),(52114951,664116051,1,15),(52114951,664116052,1,16),(52114951,664116053,1,17),(52114951,664116054,1,18),(52114951,664116055,1,19),(52114951,664116056,1,20),(52114951,664116057,1,21),(52114951,664116059,1,22),(52114951,664116060,1,23),(52114951,664116061,1,24),(52114951,664116062,1,25),(52114951,664116063,1,26),(52114951,664116064,1,27),(52114951,664116065,1,28),(52114951,664116070,1,29),(52114951,664116071,1,30),(52114951,664116072,1,31);
INSERT INTO `way_nodes` VALUES (52114951,664116073,1,32),(52114951,664116074,1,33),(52114951,664116075,1,34),(52114951,664116076,1,35),(52114951,664116077,1,36),(52114951,664116078,1,37),(52114951,664116079,1,38),(52114951,664116085,1,39),(52114951,664116086,1,40),(52114951,664116087,1,41),(52114951,664116088,1,42),(52114951,664116089,1,43),(52114952,664116161,2,1),(52114952,664192681,2,2),(52114952,664192679,2,3),(52114952,664192680,2,4),(52114952,664116091,2,5),(52121995,664195007,1,1),(52121995,664195008,1,2),(52122469,664198471,1,1),(52122469,664198472,1,2),(52122469,664198473,1,3),(52122469,664198474,1,4),(52122469,664198475,1,5),(52122469,664198476,1,6),(52122469,664198477,1,7),(52122469,664198478,1,8),(52122469,664198479,1,9),(52122469,664198480,1,10),(52123370,664205638,1,1),(52123370,664205644,1,2),(52123370,664205641,1,3),(52123370,664205635,1,4),(52123370,664205633,1,5),(52123370,664205630,1,6),(52123370,664205627,1,7),(52123370,664205624,1,8),(52123370,664205621,1,9),(52123370,664205619,1,10),(52123370,664205614,1,11),(52123917,664211795,1,1),(52123917,664211796,1,2),(52123917,664211797,1,3),(52123917,664211798,1,4),(52123917,664211799,1,5),(52123917,664211800,1,6),(52123917,664211801,1,7),(52123917,664211802,1,8),(52123917,664211803,1,9),(52123917,664211804,1,10),(52123917,664211810,1,11),(52123917,664211805,1,12),(52123917,664211806,1,13),(52123917,664211807,1,14),(52123917,664211811,1,15),(52123917,664211812,1,16),(52123917,664211813,1,17),(52123917,664211814,1,18),(52123917,664211808,1,19),(52123917,664211809,1,20),(52123917,664211815,1,21),(52123917,664211816,1,22),(52123917,664211817,1,23),(52123917,664211818,1,24),(52123917,664211819,1,25),(52123917,664211832,1,26),(52123917,664211833,1,27),(52123917,664211820,1,28),(52123917,664211821,1,29),(52123917,664211822,1,30),(52123917,664211823,1,31),(52123917,664211834,1,32),(52123917,664211835,1,33),(52123917,664211836,1,34),(52123917,664211837,1,35),(52123917,664211838,1,36),(52123917,664211839,1,37),(52123917,664211840,1,38),(52123917,664211841,1,39),(52123917,664211842,1,40),(52123917,664211843,1,41),(52123917,664211844,1,42),(52123917,664211845,1,43),(52123917,664211846,1,44),(52123917,664211847,1,45),(52123917,664211848,1,46),(52123917,664211849,1,47),(52123917,664211824,1,48),(52123917,664211828,1,49),(52123917,664211825,1,50),(52123917,664211826,1,51),(52123917,664211827,1,52),(52123917,664211831,1,53),(52123917,664211829,1,54),(52123917,664211830,1,55),(52163682,664559648,1,1),(52163682,664560009,1,2),(52163683,664559650,1,1),(52163683,664559649,1,2),(52163684,664560018,1,1),(52163684,664560019,1,2),(52163684,664560013,1,3),(52163684,664560014,1,4),(52163684,664560015,1,5),(52163684,664560016,1,6),(52163684,664560017,1,7),(52163684,664560010,1,8),(52163684,664560011,1,9),(52163684,664560012,1,10),(52163684,664560312,1,11),(52163684,664560313,1,12),(52163684,664560314,1,13),(52163684,664560315,1,14),(52163684,664560316,1,15),(52163684,664560317,1,16),(52163684,664560318,1,17),(52163684,664560319,1,18),(52163684,664560326,1,19),(52163684,664560327,1,20),(52163684,664560328,1,21),(52163684,664560329,1,22),(52163684,664560330,1,23),(52163684,664560331,1,24),(52163684,664560332,1,25),(52163684,664560333,1,26),(52163684,664560368,1,27),(52163691,664560066,1,1),(52163691,664560067,1,2),(52163691,664560068,1,3),(52163691,664560070,1,4),(52163691,664560071,1,5),(52163691,664560072,1,6),(52163691,664560073,1,7),(52163691,664560074,1,8),(52163691,664560075,1,9),(52163691,664560076,1,10),(52163691,664560320,1,11),(52163691,664560321,1,12),(52163691,664560322,1,13),(52163691,664560323,1,14),(52163691,664560324,1,15),(52163691,664560325,1,16),(52163691,664560337,1,17),(52163691,664560338,1,18),(52163691,664560339,1,19),(52163691,664560340,1,20),(52163691,664560341,1,21),(52163691,664560364,1,22),(52163691,664560365,1,23),(52163691,664560366,1,24),(52163691,664560367,1,25),(52163691,664560374,1,26),(52163691,664560375,1,27),(52163691,664560376,1,28),(52163691,664560398,1,29),(52163693,664560059,1,1),(52163693,664560062,1,2),(52163693,664560063,1,3),(52163693,664560064,1,4),(52163693,664560065,1,5),(52163693,664560069,1,6),(52163693,664560245,1,7),(52163693,664560334,1,8),(52163693,664560335,1,9),(52163693,664560336,1,10),(52163693,664560342,1,11),(52163693,664560346,1,12),(52163693,664560347,1,13),(52163693,664560348,1,14),(52163693,664560349,1,15),(52163693,664560350,1,16),(52163693,664560351,1,17),(52163693,664560352,1,18),(52163693,664560353,1,19),(52163693,664560354,1,20),(52163693,664560355,1,21),(52163693,664560356,1,22),(52163693,664560387,1,23),(52163693,664560388,1,24),(52163693,664560389,1,25),(52163693,664560390,1,26),(52163693,664560391,1,27),(52163693,664560392,1,28),(52163693,664560393,1,29),(52163693,664560394,1,30),(52163693,664560395,1,31),(52163693,664560396,1,32),(52163693,664560397,1,33),(52163695,664560003,2,1),(52163695,664560004,2,2),(52163695,664560005,2,3),(52163695,664560143,2,4),(52163695,664560160,2,5),(52163695,664560162,2,6),(52163695,664560163,2,7),(52163695,664560206,2,8),(52163695,664560207,2,9),(52163695,664560216,2,10),(52163695,664560217,2,11),(52163695,664560232,2,12),(52163695,664560235,2,13),(52163695,664560236,2,14),(52163695,664560237,2,15),(52163695,664560238,2,16),(52163695,664560233,2,17),(52163695,664560242,2,18),(52163695,664560243,2,19),(52163695,664560244,2,20),(52163695,664560246,2,21),(52163695,664560247,2,22),(52163695,664560248,2,23),(52163695,664560249,2,24),(52163695,664560250,2,25),(52163695,664560251,2,26),(52163695,664560252,2,27),(52163695,664560344,2,28),(52163695,664560345,2,29),(52163695,664560406,2,30),(52163695,664560407,2,31),(52163695,664560408,2,32),(52163695,664560413,2,33),(52163695,664560414,2,34),(52163695,664560415,2,35),(52163695,664560416,2,36),(52163695,664560421,2,37),(52163695,664560422,2,38),(52163695,664560423,2,39),(52163695,664560424,2,40),(52163695,664560425,2,41),(52163695,664560426,2,42),(52163695,664560427,2,43),(52163695,664560428,2,44),(52163695,664560429,2,45),(52163695,664560430,2,46),(52163695,664560431,2,47),(52163695,664560432,2,48),(52163695,664560433,2,49),(52163695,664560434,2,50),(52163695,664560435,2,51),(52163695,664560436,2,52),(52163695,664560437,2,53),(52163695,664560439,2,54),(52163695,664560440,2,55),(52163698,664559797,1,1),(52163698,664559798,1,2),(52163698,664559766,1,3),(52163698,664559767,1,4),(52163698,664559768,1,5),(52163698,664559772,1,6),(52163698,664559773,1,7),(52163698,664559774,1,8),(52163698,664559775,1,9),(52163698,664559776,1,10),(52163698,664559777,1,11),(52163698,664559763,1,12),(52163698,664559757,1,13),(52163698,664559758,1,14),(52163698,664559765,1,15),(52163698,664559764,1,16),(52163698,664559759,1,17),(52163698,664559760,1,18),(52163698,664559761,1,19),(52163698,664559762,1,20),(52163698,664559740,1,21),(52163698,664559741,1,22),(52163698,664559742,1,23),(52163698,664559743,1,24),(52163698,664559744,1,25),(52163698,664559745,1,26),(52163698,664559731,1,27),(52163698,664559732,1,28),(52163698,664559733,1,29),(52163698,664559734,1,30),(52163698,664559724,1,31),(52163700,664559799,1,1),(52163700,664559800,1,2),(52163700,664559801,1,3),(52163700,664559802,1,4),(52163700,664559803,1,5),(52163700,664559791,1,6),(52163700,664559792,1,7),(52163700,664559793,1,8),(52163700,664559769,1,9),(52163700,664559770,1,10),(52163700,664559771,1,11),(52163700,664559690,1,12),(52163700,664559691,1,13),(52163700,664559692,1,14),(52163700,664559693,1,15),(52163700,664559694,1,16),(52163700,664559695,1,17),(52163700,664559696,1,18),(52163700,664559697,1,19),(52163700,664559688,1,20),(52163700,664559689,1,21),(52163700,664559668,1,22),(52163700,664559669,1,23),(52163700,664559670,1,24),(52163700,664559671,1,25),(52163700,664559672,1,26),(52163700,664559657,1,27),(52163700,664559658,1,28),(52163700,664559659,1,29),(52163700,664559660,1,30),(52163700,664559661,1,31),(52163700,664559662,1,32),(52163700,664559663,1,33),(52163700,664559664,1,34),(52163700,664559665,1,35),(52163700,664559666,1,36),(52163700,664559667,1,37),(52163700,664559673,1,38),(52163700,664559674,1,39),(52163700,664559675,1,40),(52163700,664559676,1,41),(52163700,664559677,1,42),(52163700,664559678,1,43),(52163700,664559679,1,44),(52163700,664559680,1,45),(52163700,664559681,1,46),(52163700,664559682,1,47),(52163700,664559687,1,48),(52163700,664559683,1,49),(52163700,664559684,1,50),(52163700,664559685,1,51),(52163700,664559686,1,52),(52163700,664559698,1,53),(52163700,664559699,1,54),(52163700,664559700,1,55),(52163700,664559651,1,56),(52163700,664559652,1,57),(52163700,664559653,1,58),(52163700,664559654,1,59),(52163700,664559655,1,60),(52163700,664559656,1,61),(52163700,664559701,1,62),(52163700,664559702,1,63),(52163700,664559703,1,64),(52163700,664559704,1,65),(52163700,664559705,1,66),(52163700,664559706,1,67),(52163700,664559707,1,68),(52163700,664559708,1,69),(52163700,664559709,1,70),(52163700,664559710,1,71),(52163700,664559711,1,72),(52163700,664559712,1,73),(52163700,664559713,1,74),(52163700,664559714,1,75),(52163700,664559715,1,76),(52163700,664559716,1,77),(52163700,664559717,1,78),(52163700,664559718,1,79),(52163700,664559725,1,80),(52163700,664559726,1,81),(52163700,664559727,1,82),(52163700,664559728,1,83),(52163704,664559723,1,1),(52163704,664559794,1,2),(52163705,664559847,1,1),(52163705,664559848,1,2),(52163705,664559857,1,3),(52163705,664559858,1,4),(52163705,664559863,1,5),(52163705,664559864,1,6),(52163705,664559911,1,7),(52163705,664559913,1,8),(52163705,664559915,1,9),(52163705,664559917,1,10),(52163705,664559935,1,11),(52163705,664559937,1,12),(52163705,664559939,1,13),(52163705,664559941,1,14),(52163705,664560253,1,15),(52163705,664560254,1,16),(52163705,664560255,1,17),(52163705,664560256,1,18),(52163705,664560257,1,19),(52163705,664560258,1,20),(52163705,664560259,1,21),(52163705,664560260,1,22),(52163705,664560261,1,23),(52163705,664560262,1,24),(52163705,664560263,1,25),(52163705,664560264,1,26),(52163705,664560265,1,27),(52163705,664560266,1,28),(52163705,664560267,1,29),(52163705,664560268,1,30),(52163705,664560269,1,31),(52163705,664560270,1,32),(52163705,664560271,1,33),(52163705,664560272,1,34),(52163705,664560273,1,35),(52163705,664560280,1,36),(52163705,664560281,1,37),(52163710,664559729,1,1),(52163710,664559747,1,2),(52163712,664559748,1,1),(52163712,664559749,1,2),(52163712,664559750,1,3),(52163712,664559751,1,4),(52163712,664559752,1,5),(52163712,664559753,1,6),(52163712,664559754,1,7),(52163712,664559755,1,8),(52163712,664559756,1,9),(52163712,664559746,1,10),(52163712,664559736,1,11),(52163712,664559737,1,12),(52163712,664559738,1,13),(52163712,664559739,1,14),(52163712,664559735,1,15),(52163712,664559719,1,16),(52163712,664559720,1,17),(52163712,664559721,1,18),(52163712,664559722,1,19),(52163712,664559730,1,20),(52163714,664559866,1,1),(52163714,664559778,1,2),(52163716,664559779,1,1),(52163716,664559780,1,2),(52163716,664559781,1,3),(52163716,664559880,1,4),(52163716,664559881,1,5),(52163716,664559882,1,6),(52163716,664559883,1,7),(52163716,664559884,1,8),(52163716,664559885,1,9),(52163716,664559888,1,10),(52163716,664559817,1,11),(52163716,664559818,1,12),(52163716,664559819,1,13),(52163716,664559820,1,14),(52163716,664559821,1,15),(52163716,664559867,1,16),(52163716,664559868,1,17),(52163716,664559869,1,18),(52163716,664559870,1,19),(52163716,664559827,1,20),(52163716,664559828,1,21),(52163716,664559829,1,22),(52163716,664559830,1,23),(52163716,664559831,1,24),(52163716,664559832,1,25),(52163719,664559785,1,1),(52163719,664559782,1,2),(52163719,664559783,1,3),(52163719,664559784,1,4),(52163719,664559886,1,5),(52163719,664559887,1,6),(52163719,664559889,1,7),(52163719,664559890,1,8),(52163719,664559822,1,9),(52163719,664559823,1,10),(52163719,664559871,1,11),(52163719,664559872,1,12),(52163719,664559873,1,13),(52163719,664559874,1,14),(52163719,664559875,1,15),(52163719,664559876,1,16),(52163719,664559877,1,17),(52163719,664559878,1,18),(52163719,664559841,1,19),(52163719,664559842,1,20),(52163719,664559836,1,21),(52163719,664559837,1,22),(52163719,664559838,1,23),(52163719,664559839,1,24),(52163719,664559840,1,25),(52163719,664559843,1,26),(52163719,664559844,1,27),(52163719,664559845,1,28),(52163719,664559846,1,29),(52163719,664559849,1,30),(52163719,664559850,1,31),(52163719,664559851,1,32),(52163719,664559852,1,33),(52163719,664559853,1,34),(52163719,664559854,1,35),(52163719,664559855,1,36),(52163719,664559856,1,37),(52163719,664559859,1,38),(52163719,664559860,1,39),(52163719,664559861,1,40),(52163719,664559862,1,41),(52163719,664559904,1,42),(52163719,664559905,1,43),(52163719,664559906,1,44),(52163719,664559919,1,45),(52163719,664559923,1,46),(52163719,664559925,1,47),(52163719,664559927,1,48),(52163719,664559929,1,49),(52163722,664559786,1,1),(52163722,664559788,1,2),(52163722,664559789,1,3),(52163722,664559790,1,4),(52163722,664559891,1,5),(52163722,664559892,1,6),(52163722,664559893,1,7),(52163722,664559894,1,8),(52163722,664559895,1,9),(52163722,664559896,1,10),(52163722,664559897,1,11),(52163722,664559898,1,12),(52163722,664559899,1,13),(52163722,664559900,1,14),(52163722,664559901,1,15),(52163722,664559902,1,16),(52163722,664559903,1,17),(52163722,664559947,1,18),(52163722,664559949,1,19),(52163722,664559951,1,20),(52163722,664559953,1,21),(52163722,664559955,1,22),(52163722,664559957,1,23),(52163722,664559963,1,24),(52163722,664559965,1,25),(52163722,664559966,1,26),(52163722,664559968,1,27),(52163722,664559969,1,28),(52163722,664559970,1,29),(52163729,664560035,1,1),(52163729,664560036,1,2),(52163729,664560037,1,3),(52163729,664560038,1,4),(52163729,664560040,1,5),(52163729,664560041,1,6),(52163729,664560043,1,7),(52163729,664560056,1,8),(52163729,664560057,1,9),(52163729,664560058,1,10),(52163729,664560060,1,11),(52163729,664560061,1,12),(52163729,664560044,1,13),(52163729,664560045,1,14),(52163729,664560046,1,15),(52163729,664560047,1,16),(52163729,664560048,1,17),(52163729,664560049,1,18),(52163729,664560050,1,19),(52163729,664560051,1,20),(52163729,664560052,1,21),(52163729,664560053,1,22),(52163729,664560002,1,23),(52163729,664560157,1,24),(52163729,664560158,1,25),(52163729,664560159,1,26),(52163729,664560202,1,27),(52163729,664560203,1,28),(52163729,664560204,1,29),(52163729,664560205,1,30),(52163729,664560214,1,31),(52163729,664560215,1,32),(52163729,664560231,1,33),(52163731,664559787,1,1),(52163731,664559979,1,2),(52163731,664559980,1,3),(52163731,664559981,1,4),(52163731,664559982,1,5),(52163731,664559983,1,6),(52163731,664559984,1,7),(52163731,664559985,1,8),(52163731,664559986,1,9),(52163731,664559978,1,10),(52163731,664559987,1,11),(52163731,664559988,1,12),(52163731,664559989,1,13),(52163731,664559990,1,14),(52163731,664559991,1,15),(52163731,664559992,1,16),(52163731,664560006,1,17),(52163731,664560007,1,18),(52163731,664560145,1,19),(52163731,664560147,1,20),(52163731,664560149,1,21),(52163731,664560150,1,22),(52163731,664560161,1,23),(52163731,664560164,1,24),(52163731,664560165,1,25),(52163731,664560166,1,26),(52163731,664560167,1,27),(52163731,664560208,1,28),(52163731,664560209,1,29),(52163731,664560218,1,30),(52163731,664560219,1,31),(52163733,664560089,1,1),(52163733,664560091,1,2),(52163733,664560093,1,3),(52163733,664560095,1,4),(52163733,664560097,1,5),(52163733,664560099,1,6),(52163733,664560081,1,7),(52163733,664560082,1,8),(52163733,664560083,1,9),(52163733,664560085,1,10),(52163733,664560086,1,11),(52163733,664559993,1,12),(52163733,664559994,1,13),(52163733,664559995,1,14),(52163733,664559996,1,15),(52163733,664559997,1,16),(52163733,664559998,1,17),(52163733,664559999,1,18),(52163733,664560000,1,19),(52163733,664560087,1,20),(52163733,664560151,1,21),(52163733,664560152,1,22),(52163733,664560153,1,23),(52163733,664560154,1,24),(52163733,664560155,1,25),(52163733,664560156,1,26),(52163733,664560168,1,27),(52163733,664560169,1,28),(52163733,664560170,1,29),(52163733,664560171,1,30),(52163733,664560172,1,31),(52163733,664560173,1,32),(52163733,664560174,1,33),(52163733,664560175,1,34),(52163733,664560177,1,35),(52163733,664560178,1,36),(52163733,664560211,1,37),(52163733,664560212,1,38),(52163733,664560213,1,39),(52163733,664560210,1,40),(52163733,664560220,1,41),(52163733,664560221,1,42),(52163733,664560222,1,43),(52163733,664560223,1,44),(52163733,664560234,1,45),(52163733,664560239,1,46),(52163736,664559795,1,1),(52163736,664559826,1,2),(52163738,664559833,1,1),(52163738,664559834,1,2),(52163738,664559835,1,3),(52163738,664559824,1,4),(52163738,664559825,1,5),(52163738,664559815,1,6),(52163738,664559816,1,7),(52163738,664559812,1,8),(52163738,664559813,1,9),(52163738,664559814,1,10),(52163738,664559804,1,11),(52163738,664559805,1,12),(52163738,664559806,1,13),(52163738,664559807,1,14),(52163738,664559808,1,15),(52163738,664559809,1,16),(52163738,664559810,1,17),(52163738,664559811,1,18),(52163738,664559796,1,19),(52163739,664559971,1,1),(52163739,664560008,1,2),(52163740,664560027,1,1),(52163740,664560028,1,2),(52163740,664560029,1,3),(52163740,664560030,1,4),(52163740,664560031,1,5),(52163740,664560032,1,6),(52163740,664560033,1,7),(52163740,664560034,1,8),(52163740,664560001,1,9),(52163740,664559972,1,10),(52163740,664559973,1,11),(52163740,664559974,1,12),(52163740,664559975,1,13),(52163740,664559976,1,14),(52163740,664559977,1,15),(52163743,664560135,1,1),(52163743,664560134,1,2),(52163743,664560132,1,3),(52163743,664560129,1,4),(52163743,664560105,1,5),(52163743,664560103,1,6),(52163745,664560192,1,1),(52163745,664560191,1,2),(52163745,664560190,1,3),(52163745,664560189,1,4),(52163745,664560188,1,5),(52163745,664560142,1,6),(52163745,664560140,1,7),(52163745,664560137,1,8),(52163745,664560114,1,9),(52163745,664560112,1,10),(52163745,664560109,1,11),(52163745,664560107,1,12),(52163745,664560127,1,13),(52163745,664560125,1,14),(52163745,664560123,1,15),(52163745,664560121,1,16),(52163745,664560118,1,17),(52163746,664560193,1,1),(52163746,664560194,1,2),(52163746,664560195,1,3),(52163746,664560196,1,4),(52163746,664560198,1,5),(52163746,664560179,1,6),(52163746,664560180,1,7),(52163746,664560182,1,8),(52163746,664560183,1,9),(52163746,664560185,1,10),(52163746,664560186,1,11),(52163746,664560226,1,12),(52163746,664560227,1,13),(52163746,664560228,1,14),(52163746,664560229,1,15),(52163746,664560224,1,16),(52163746,664560225,1,17),(52163746,664560240,1,18),(52163748,664560369,1,1),(52163748,664560370,1,2),(52163748,664560377,1,3),(52163748,664560378,1,4),(52163748,664560379,1,5),(52163750,664560383,1,1),(52163750,664560384,1,2),(52163750,664560399,1,3),(52163750,664560400,1,4),(52163750,664560401,1,5),(52163751,664560402,1,1),(52163751,664560403,1,2),(52163751,664560404,1,3),(52163751,664560405,1,4),(52163751,664560385,1,5),(52163751,664560386,1,6),(52163753,664560343,1,1),(52163753,664560357,1,2),(52163753,664560358,1,3),(52163753,664560359,1,4),(52163753,664560360,1,5),(52163753,664560361,1,6),(52163753,664560362,1,7),(52163753,664560363,1,8),(52163753,664560409,1,9),(52163753,664560410,1,10),(52163753,664560411,1,11),(52163753,664560412,1,12),(52163753,664560417,1,13),(52163754,664560418,1,1),(52163754,664560419,1,2),(52163754,664560420,1,3),(52171935,664598870,1,1),(52171935,664598764,1,2),(52171935,664598765,1,3),(52171936,664598413,1,1),(52171936,664598414,1,2),(52171936,664598438,1,3),(52171936,664598439,1,4),(52171936,664598440,1,5),(52171936,664598441,1,6),(52171936,664598447,1,7),(52171936,664598448,1,8),(52171936,664598449,1,9),(52171936,664598451,1,10),(52171936,664598471,1,11),(52171936,664598472,1,12),(52171936,664598473,1,13),(52171936,664598474,1,14),(52171936,664598475,1,15),(52171936,664598476,1,16),(52171936,664598477,1,17),(52171936,664598478,1,18),(52171936,664598868,1,19),(52171936,664598869,1,20),(52171936,664598871,1,21),(52171936,664598872,1,22),(52171936,621467612,1,23),(52171937,664598415,1,1),(52171937,664598423,1,2),(52171937,664598424,1,3),(52171937,664598425,1,4),(52171937,664598426,1,5),(52171937,664598427,1,6),(52171937,664598452,1,7),(52171937,664598453,1,8),(52171937,664598454,1,9),(52171937,664598455,1,10),(52171937,664598456,1,11),(52171937,664598457,1,12),(52171937,664598458,1,13),(52171937,664598459,1,14),(52171937,664598735,1,15),(52171937,664598736,1,16),(52171937,664598737,1,17),(52171937,664598738,1,18),(52171937,664598739,1,19),(52171937,664598740,1,20),(52171937,664598741,1,21),(52171937,664598742,1,22),(52171937,664598743,1,23),(52171937,664598744,1,24),(52171937,664598747,1,25),(52171937,664598748,1,26),(52171937,664598749,1,27),(52171938,664598416,1,1),(52171938,664598417,1,2),(52171938,664598418,1,3),(52171938,664598419,1,4),(52171938,664598420,1,5),(52171938,664598421,1,6),(52171938,664598422,1,7),(52171938,664598402,1,8),(52171938,664598403,1,9),(52171938,664598404,1,10),(52171938,664598405,1,11),(52171938,664598406,1,12),(52171938,664598684,1,13),(52171938,664598697,1,14),(52171938,664598698,1,15),(52171938,664598699,1,16),(52171938,664598700,1,17),(52171938,664598706,1,18),(52171938,664598682,1,19),(52171938,664598666,1,20),(52171938,664598668,1,21),(52171938,664598670,1,22),(52171938,664598672,1,23),(52171938,664598674,1,24),(52171938,664598676,1,25),(52171938,664598678,1,26),(52171938,664598480,1,27),(52171938,664598396,1,28),(52171938,664598397,1,29),(52171938,664598398,1,30),(52171938,664598399,1,31),(52171938,664598400,1,32),(52171938,664598393,1,33),(52171938,664598394,1,34),(52171938,664598395,1,35),(52171938,664598481,1,36),(52171938,664598482,1,37),(52171938,664598483,1,38),(52171938,664598484,1,39),(52171938,664598485,1,40),(52171938,664598486,1,41),(52171938,664598487,1,42),(52171938,664598488,1,43),(52171938,664598489,1,44),(52171938,664598497,1,45),(52171938,664598499,1,46),(52171938,664598500,1,47),(52171938,664598501,1,48),(52171938,664598479,1,49),(52171938,664598509,1,50),(52171938,664598510,1,51),(52171938,664598511,1,52),(52171938,664598512,1,53),(52171938,664598504,1,54),(52171938,664598505,1,55),(52171938,664598506,1,56),(52171938,664598513,1,57),(52171938,664598503,1,58),(52171938,664598526,1,59),(52171938,664598527,1,60),(52171938,664598528,1,61),(52171938,664598529,1,62),(52171938,664598530,1,63),(52171938,664598555,1,64),(52171938,664598556,1,65),(52171938,664598557,1,66),(52171938,664598558,1,67),(52171938,664598559,1,68),(52171938,664598560,1,69),(52171938,664598640,1,70),(52171938,664598641,1,71),(52171938,664598642,1,72),(52171938,664598643,1,73),(52171938,664598644,1,74),(52171938,664598645,1,75),(52171938,664598646,1,76),(52171938,664598647,1,77),(52171938,664598648,1,78),(52171938,664598627,1,79),(52171938,664598628,1,80),(52171938,664598629,1,81),(52171938,664598630,1,82),(52171938,664598631,1,83),(52171938,664598632,1,84),(52171938,664598633,1,85),(52171938,664598622,1,86),(52171938,664598623,1,87),(52171938,664598624,1,88),(52171938,664598625,1,89),(52171938,664598626,1,90),(52171938,664598634,1,91),(52171938,664598635,1,92),(52171938,664598636,1,93),(52171938,664598637,1,94),(52171938,664598638,1,95),(52171938,664598639,1,96),(52171938,664598649,1,97),(52171938,664598650,1,98),(52171938,664598651,1,99),(52171938,664598654,1,100),(52171938,664598655,1,101),(52171938,664598656,1,102),(52171938,664598657,1,103),(52171938,664598658,1,104),(52171938,664598659,1,105),(52171938,664598660,1,106),(52171938,664598801,1,107),(52171938,664598802,1,108),(52171938,664598803,1,109),(52171938,664598804,1,110),(52171938,664598805,1,111),(52171938,664598806,1,112),(52171938,664598807,1,113),(52171938,664598808,1,114),(52171938,664598809,1,115),(52171938,664598810,1,116),(52171938,664598814,1,117),(52171938,664598815,1,118),(52171938,664598816,1,119),(52171938,664598661,1,120),(52171938,664598662,1,121),(52171938,664598663,1,122),(52171938,664598665,1,123),(52171938,664598817,1,124),(52171938,664598831,1,125),(52171938,664598832,1,126),(52171938,664598833,1,127),(52171938,664598834,1,128),(52171938,664598835,1,129),(52171939,664598750,1,1),(52171939,664598751,1,2),(52171939,664598752,1,3),(52171939,664598753,1,4),(52171939,664598754,1,5),(52171939,664598755,1,6),(52171939,664598756,1,7),(52171939,664598776,1,8),(52171939,664598777,1,9),(52171939,664598778,1,10),(52171939,664598779,1,11),(52171939,664598780,1,12),(52171939,664598786,1,13),(52171939,664598787,1,14),(52171939,664598788,1,15),(52171939,664598789,1,16),(52171939,664598790,1,17),(52171939,664598791,1,18),(52171939,664598843,1,19),(52171939,664598844,1,20),(52171940,664598507,1,1),(52171940,664598680,1,2),(52171940,664598701,1,3),(52171941,664598704,2,1),(52171941,664598703,2,2),(52171941,664598702,2,3),(52171941,664598716,2,4),(52171941,664598715,2,5),(52171941,664598714,2,6),(52171941,664598713,2,7),(52171941,664598496,2,8),(52171941,664598495,2,9),(52171941,664598494,2,10),(52171941,664598493,2,11),(52171941,664598492,2,12),(52171941,664598491,2,13),(52171941,664598490,2,14),(52171941,664598569,2,15),(52171941,664598568,2,16),(52171941,664598567,2,17),(52171941,664598508,2,18),(52171942,664598514,1,1),(52171942,664598515,1,2),(52171942,664598516,1,3),(52171942,664598517,1,4),(52171942,664598518,1,5),(52171942,664598519,1,6),(52171942,664598520,1,7),(52171942,664598541,1,8),(52171942,664598542,1,9),(52171942,664598543,1,10),(52171942,664598544,1,11),(52171942,664598561,1,12),(52171942,664598562,1,13),(52171942,664598563,1,14),(52171942,664598606,1,15),(52171942,664598652,1,16),(52171942,664598653,1,17),(52171943,664598533,1,1),(52171943,664598583,1,2),(52171944,664598534,1,1),(52171944,664598574,1,2),(52171945,664598584,1,1),(52171945,664598585,1,2),(52171945,664598586,1,3),(52171945,664598587,1,4),(52171945,664598603,1,5),(52171945,664598604,1,6),(52171945,664598605,1,7),(52171945,664598591,1,8),(52171945,664598592,1,9),(52171945,664598593,1,10),(52171945,664598594,1,11),(52171945,664598595,1,12),(52171945,664598599,1,13),(52171945,664598575,1,14),(52171945,664598576,1,15),(52171945,664598607,1,16),(52171945,664598608,1,17),(52171945,664598609,1,18),(52171945,664598610,1,19),(52171945,664598611,1,20),(52171945,664598612,1,21),(52171945,664598613,1,22),(52171945,664598614,1,23),(52171945,664598615,1,24),(52171945,664598616,1,25),(52171945,664598617,1,26),(52171945,664598618,1,27),(52171945,664598619,1,28),(52171945,664598620,1,29),(52171945,664598621,1,30),(52171945,664598545,1,31),(52171945,664598546,1,32),(52171945,664598547,1,33),(52171945,664598548,1,34),(52171945,664598549,1,35),(52171945,664598550,1,36),(52171945,664598551,1,37),(52171945,664598552,1,38),(52171945,664598553,1,39),(52171945,664598554,1,40),(52171945,664598535,1,41),(52171945,664598536,1,42),(52171945,664598564,1,43),(52171945,664598565,1,44),(52171945,664598566,1,45),(52171946,664598588,1,1),(52171946,664598589,1,2),(52171946,664598590,1,3),(52171946,664598596,1,4),(52171946,664598597,1,5),(52171946,664598598,1,6),(52171946,664598577,1,7),(52171946,664598578,1,8),(52171946,664598579,1,9),(52171946,664598580,1,10),(52171946,664598581,1,11),(52171946,664598570,1,12),(52171946,664598571,1,13),(52171946,664598572,1,14),(52171946,664598573,1,15),(52171946,664598521,1,16),(52171946,664598522,1,17),(52171946,664598523,1,18),(52171946,664598524,1,19),(52171946,664598525,1,20),(52171946,664598531,1,21),(52171946,664598532,1,22),(52171946,664598537,1,23),(52171946,664598538,1,24),(52171946,664598539,1,25),(52171946,664598540,1,26),(52171947,664598757,1,1),(52171947,664598758,1,2),(52171947,664598759,1,3),(52171947,664598760,1,4),(52171947,664598761,1,5),(52171947,664598762,1,6),(52171947,664598763,1,7),(52171947,664598781,1,8),(52171947,664598782,1,9),(52171947,664598783,1,10),(52171947,664598784,1,11),(52171947,664598792,1,12),(52171947,664598793,1,13),(52171947,664598794,1,14),(52171947,664598795,1,15),(52171947,664598796,1,16),(52171947,664598797,1,17),(52171947,664598798,1,18),(52171947,664598799,1,19),(52172905,664605736,1,1),(52172905,664605748,1,2),(52172905,664605824,1,3),(52172907,664606014,1,1),(52172907,664606015,1,2),(52172907,664606016,1,3),(52172907,664606018,1,4),(52172907,664606019,1,5),(52172907,664606020,1,6),(52172907,664606010,1,7),(52172907,664606011,1,8),(52172907,664606012,1,9),(52172907,664606013,1,10),(52172907,664606063,1,11),(52172907,664606064,1,12),(52172907,664606066,1,13),(52172907,664606067,1,14),(52172909,664605856,1,1),(52172909,664605860,1,2),(52172909,664605861,1,3),(52172909,664605864,1,4),(52172909,664605866,1,5),(52172909,664605869,1,6),(52172909,664605946,1,7),(52172909,664605948,1,8),(52172909,664605906,1,9),(52172909,664605907,1,10),(52172909,664605911,1,11),(52172909,664605919,1,12),(52172909,664605915,1,13),(52172909,664605917,1,14),(52172909,664605941,1,15),(52172909,664605942,1,16),(52172909,664605943,1,17),(52172909,664605925,1,18),(52172909,664605926,1,19),(52172909,664605931,1,20),(52172909,664605933,1,21),(52172909,664605934,1,22),(52172909,664605935,1,23),(52172909,664605936,1,24),(52172909,664605937,1,25),(52172909,664605974,1,26),(52172909,664605976,1,27),(52172909,664605977,1,28),(52172909,664605978,1,29),(52172909,664605979,1,30),(52172909,664605969,1,31),(52172909,664605970,1,32),(52172909,664605971,1,33),(52172909,664605972,1,34),(52172909,664605973,1,35),(52172909,664605980,1,36),(52172909,664605981,1,37),(52172909,664605982,1,38),(52172909,664605983,1,39),(52172909,664605984,1,40),(52172909,664605985,1,41),(52172909,664605986,1,42),(52172909,664605987,1,43),(52172909,664605988,1,44),(52172909,664605989,1,45),(52172909,664605990,1,46),(52172909,664605991,1,47),(52172909,664605992,1,48),(52172909,664605993,1,49),(52172909,664605994,1,50),(52172909,664605996,1,51),(52172909,664605997,1,52),(52172909,664606021,1,53),(52172909,664606022,1,54),(52172909,664606023,1,55),(52172909,664606024,1,56),(52172909,664606025,1,57),(52172909,664606027,1,58),(52172909,664606028,1,59),(52172909,664606029,1,60),(52172909,664606030,1,61),(52172909,664606031,1,62),(52172909,664606033,1,63),(52172909,664606034,1,64),(52172909,664606035,1,65),(52172909,664606036,1,66),(52172909,664606037,1,67),(52172909,664606043,1,68),(52172909,664606039,1,69),(52172909,664606040,1,70),(52172909,664606045,1,71),(52172909,664606044,1,72),(52172909,664606041,1,73),(52172909,664606042,1,74),(52172909,664606046,1,75),(52172911,664605857,1,1),(52172911,664605871,1,2),(52172911,664605874,1,3),(52172911,664605846,1,4),(52172911,664605908,1,5),(52172911,664605909,1,6),(52172911,664605905,1,7),(52172911,664605916,1,8),(52172911,664605918,1,9),(52172911,664605927,1,10),(52172911,664605928,1,11),(52172911,664605929,1,12),(52172911,664605930,1,13),(52172911,664605939,1,14),(52172911,664605940,1,15),(52172911,664605894,1,16),(52172911,664605895,1,17),(52172911,664605903,1,18),(52172911,664605904,1,19),(52172911,664605898,1,20),(52172911,664605899,1,21),(52172911,664605900,1,22),(52172911,664605901,1,23),(52172911,664605896,1,24),(52172911,664605897,1,25),(52172913,664605858,1,1),(52172913,664605876,1,2),(52172913,664605878,1,3),(52172913,664605949,1,4),(52172913,664605950,1,5),(52172913,664605951,1,6),(52172913,664605952,1,7),(52172913,664605912,1,8),(52172913,664605913,1,9),(52172913,664605914,1,10),(52172913,664605920,1,11),(52172913,664605921,1,12),(52172913,664605922,1,13),(52172913,664605923,1,14),(52172913,664605924,1,15),(52172913,664605953,1,16),(52172913,664605955,1,17),(52172913,664605956,1,18),(52172913,664605958,1,19),(52172913,664605959,1,20),(52172913,664605945,1,21),(52172914,664605886,1,1),(52172914,664605888,1,2),(52172914,664605890,1,3),(52172914,664605891,1,4),(52172914,664605892,1,5),(52172914,664605954,1,6),(52172914,664605998,1,7),(52172914,664605999,1,8),(52172914,664606000,1,9),(52172914,664606001,1,10),(52172914,664606002,1,11),(52172914,664606004,1,12),(52172914,664606005,1,13),(52172914,664606006,1,14),(52172914,664606007,1,15),(52172914,664606008,1,16),(52172915,664605847,1,1),(52172915,664605848,1,2),(52172915,664605849,1,3),(52172915,664605850,1,4),(52172915,664605836,1,5),(52172915,664605837,1,6),(52172915,664605838,1,7),(52172915,664605839,1,8),(52172915,664605773,1,9),(52172915,664605774,1,10),(52172915,664605776,1,11),(52172915,664605777,1,12),(52172915,664605778,1,13),(52172915,664605779,1,14),(52172915,664605765,1,15),(52172916,664605840,1,1),(52172916,664605841,1,2),(52172916,664605842,1,3),(52172916,664605843,1,4),(52172916,664605844,1,5),(52172916,664605828,1,6),(52172916,664605829,1,7),(52172916,664605830,1,8),(52172916,664605831,1,9),(52172916,664605832,1,10),(52172916,664605833,1,11),(52172916,664605834,1,12),(52172916,664605771,1,13),(52172916,664605772,1,14),(52172916,664605780,1,15),(52172916,664605781,1,16),(52172916,664605783,1,17),(52172916,664605784,1,18),(52172916,664605768,1,19),(52172918,664605758,1,1),(52172918,664605750,1,2),(52172918,664605751,1,3),(52172918,664605752,1,4),(52172918,664605753,1,5),(52172918,664605754,1,6),(52172918,664605756,1,7),(52172918,664605817,1,8),(52172918,664605814,1,9),(52172918,664605815,1,10),(52172918,664605816,1,11),(52172918,664605818,1,12),(52172918,664605819,1,13),(52172918,664605823,1,14),(52172918,664605822,1,15),(52172918,664605820,1,16),(52172918,664605821,1,17),(52172918,664605806,1,18),(52172918,664605813,1,19),(52172918,664605812,1,20),(52172918,664605807,1,21),(52172918,664605808,1,22),(52172918,664605809,1,23),(52172918,664605811,1,24),(52172918,664605805,1,25),(52172918,664605804,1,26),(52172918,664605803,1,27),(52172918,664605794,1,28),(52172918,664605795,1,29),(52172918,664605796,1,30),(52172918,664605801,1,31),(52172918,664605797,1,32),(52172918,664605799,1,33),(52172918,664605800,1,34),(52172918,664605785,1,35),(52172918,664605786,1,36),(52172918,664605793,1,37),(52172918,664605787,1,38),(52172918,664605792,1,39),(52172918,664605791,1,40),(52172918,664605788,1,41),(52172918,664605790,1,42),(52172919,664605964,1,1),(52172919,664605965,1,2),(52172919,664605966,1,3),(52172919,664605960,1,4),(52172919,664605961,1,5),(52172919,664605963,1,6),(52172920,664605968,1,1),(52172920,664605962,1,2),(52172921,664606048,1,1),(52172921,664606049,1,2),(52172921,664606050,1,3),(52172921,664606051,1,4),(52172921,664606052,1,5),(52172921,664606056,1,6),(52172921,664606057,1,7),(52172921,664606058,1,8),(52172921,664606059,1,9),(52172921,664606060,1,10),(52172921,664606061,1,11),(52172921,664606062,1,12),(52172921,664606068,1,13),(52172921,664606054,1,14),(52172921,664606055,1,15),(52174944,664651839,1,1),(52174946,664651828,1,1),(52174948,664651837,1,1),(52174950,664651829,1,1),(52174952,664651816,1,1),(52174952,664651823,1,2),(52174953,664651819,1,1),(52174953,664651832,1,2),(52174956,664651821,1,1),(52174956,664651834,1,2),(52174958,664651809,1,1),(52174958,664651800,1,2),(52174958,664651806,1,3),(52174959,664651811,1,1),(52174959,664651813,1,2),(52174960,664651818,1,1),(52174960,664651814,1,2),(52174962,664651824,1,1),(52174962,664651826,1,2),(52174963,664651841,1,1),(52174963,664651836,1,2),(52268017,665238087,2,1),(52268017,665238091,2,2),(52268017,665238092,2,3),(52268017,665240662,2,4),(52268017,665238096,2,5),(52692955,668878377,1,1),(52692955,668878380,1,2),(52692955,668878382,1,3),(52692955,668878383,1,4),(52692955,668878401,1,5),(52692955,668878402,1,6),(52692955,668878403,1,7),(52692955,668878404,1,8),(52692955,668878405,1,9),(52692955,668878406,1,10),(52692955,668878407,1,11),(52692955,668878447,1,12),(52692956,668878364,1,1),(52692956,668878366,1,2),(52692956,668878367,1,3),(52692956,668878372,1,4),(52692956,668878374,1,5),(52692956,668878376,1,6),(52692956,668878379,1,7),(52692956,668878385,1,8),(52692956,668878386,1,9),(52692956,668878388,1,10),(52692956,668878389,1,11),(52692956,668878390,1,12),(52692956,668878391,1,13),(52692956,668878408,1,14),(52692956,668878409,1,15),(52692956,668878410,1,16),(52692956,668878411,1,17),(52692956,668878412,1,18),(52692956,668878413,1,19),(52692956,668878414,1,20),(52692956,668878498,1,21),(52692956,668878500,1,22),(52692956,668878501,1,23),(52692956,668878503,1,24),(52692956,668878505,1,25),(52692956,668878515,1,26),(52692956,668878516,1,27),(52692956,668878518,1,28),(52692956,668878520,1,29),(52692956,668878521,1,30),(52692956,668878579,1,31),(52692956,668878580,1,32),(52692956,668878598,1,33),(52692956,668878599,1,34),(52692956,668878602,1,35),(52692956,668878655,1,36),(52692956,668878657,1,37),(52692956,668878658,1,38),(52692956,668878660,1,39),(52692956,668878684,1,40),(52692956,668878686,1,41),(52692956,668878687,1,42),(52692956,668878689,1,43),(52692956,668878703,1,44),(52692956,668878705,1,45),(52692956,668878772,1,46),(52692956,668878774,1,47),(52692956,668878775,1,48),(52692956,668878766,1,49),(52692956,668878767,1,50),(52692956,668878769,1,51),(52692956,668878771,1,52),(52692956,668878777,1,53),(52692956,668878779,1,54),(52692956,668878780,1,55),(52692956,668878782,1,56),(52692956,668878783,1,57),(52692956,668878785,1,58),(52692956,668878787,1,59),(52692956,668878797,1,60),(52692956,668878799,1,61),(52692956,668878800,1,62),(52692956,668878802,1,63),(52692956,668878804,1,64),(52692956,668878805,1,65),(52692956,668878847,1,66),(52692956,668878848,1,67),(52692956,668878831,1,68),(52692956,668878833,1,69),(52692956,668878834,1,70),(52692956,668878830,1,71),(52692957,668878392,2,1),(52692957,668878393,2,2),(52692957,668878415,2,3),(52692957,668878416,2,4),(52692957,668878417,2,5),(52692957,668878419,2,6),(52692957,668878420,2,7),(52692957,668878422,2,8),(52692957,668878423,2,9),(52692957,668878506,2,10),(52692957,668878508,2,11),(52692957,668878510,2,12),(52692957,668878511,2,13),(52692957,668878513,2,14),(52692957,668878538,2,15),(52692957,668878539,2,16),(52692957,668878541,2,17),(52692957,668878543,2,18),(52692957,668878544,2,19),(52692957,668878546,2,20),(52692957,668878548,2,21),(52692957,668878549,2,22),(52692957,668878551,2,23),(52692957,668878553,2,24),(52692957,668878531,2,25),(52692957,668878533,2,26),(52692957,668878534,2,27),(52692957,668878536,2,28),(52692958,668878629,1,1),(52692958,668878334,1,2),(52692959,668878337,1,1),(52692959,668878369,1,2),(52692959,668878371,1,3),(52692959,668878394,1,4),(52692959,668878395,1,5),(52692959,668878396,1,6),(52692959,668878397,1,7),(52692959,668878398,1,8),(52692959,668878399,1,9),(52692959,668878400,1,10),(52692959,668878442,1,11),(52692959,668878444,1,12),(52692959,668878446,1,13),(52692959,668878464,1,14),(52692959,668878465,1,15),(52692960,668878339,1,1),(52692960,668878340,1,2),(52692960,668878342,1,3),(52692960,668878344,1,4),(52692960,668878346,1,5),(52692960,668878348,1,6),(52692960,668878349,1,7),(52692960,668878351,1,8),(52692960,668878353,1,9),(52692960,668878354,1,10),(52692960,668878356,1,11),(52692960,668878358,1,12),(52692960,668878359,1,13),(52692960,668878361,1,14),(52692960,668878362,1,15),(52692960,668878425,1,16),(52692960,668878427,1,17),(52692960,668878429,1,18),(52692960,668878430,1,19),(52692960,668878432,1,20),(52692960,668878434,1,21),(52692960,668878435,1,22),(52692960,668878437,1,23),(52692961,668878850,1,1),(52692961,668878558,1,2),(52692962,668878569,1,1),(52692962,668878571,1,2),(52692962,668878573,1,3),(52692962,668878576,1,4),(52692962,668878636,1,5),(52692962,668878668,1,6),(52692962,668878669,1,7),(52692962,668878671,1,8),(52692962,668878673,1,9),(52692962,668878674,1,10),(52692962,668878723,1,11),(52692962,668878725,1,12),(52692962,668878726,1,13),(52692962,668878728,1,14),(52692962,668878729,1,15),(52692962,668878752,1,16),(52692962,668878753,1,17),(52692962,668878755,1,18),(52692962,668878757,1,19),(52692962,668878836,1,20),(52692962,668878837,1,21),(52692962,668878839,1,22),(52692963,668878731,1,1),(52692963,668878745,1,2),(52692963,668878746,1,3),(52692963,668878748,1,4),(52692963,668878750,1,5),(52692963,668878759,1,6),(52692963,668878761,1,7),(52692963,668878762,1,8),(52692963,668878764,1,9),(52692963,668878807,1,10),(52692963,668878840,1,11),(52692963,668878841,1,12),(52692963,668878843,1,13),(52692963,668878845,1,14),(52692964,668878454,1,1),(52692964,668878456,1,2),(52692964,668878467,1,3),(52692964,668878469,1,4),(52692964,668878493,1,5),(52692964,668878495,1,6),(52692964,668878523,1,7),(52692964,668878525,1,8),(52692964,668878526,1,9),(52692964,668878528,1,10),(52692964,668878530,1,11),(52692964,668878588,1,12),(52692964,668878591,1,13),(52692964,668878592,1,14),(52692965,668878595,1,1),(52692965,668878457,1,2),(52692966,668878449,1,1),(52692966,668878450,1,2),(52692966,668878452,1,3),(52692966,668878439,1,4),(52692966,668878440,1,5),(52692966,668878459,1,6),(52692966,668878461,1,7),(52692966,668878462,1,8),(52692966,668878471,1,9),(52692966,668878472,1,10),(52692966,668878488,1,11),(52692966,668878490,1,12),(52692966,668878492,1,13),(52692966,668878554,1,14),(52692966,668878556,1,15),(52692966,668878583,1,16),(52692966,668878586,1,17),(52692966,668878604,1,18),(52692966,668878607,1,19),(52692966,668878608,1,20),(52692966,668878622,1,21),(52692966,668878625,1,22),(52692966,668878638,1,23),(52692966,668878639,1,24),(52692966,668878641,1,25),(52692966,668878642,1,26),(52692966,668878644,1,27),(52692966,668878661,1,28),(52692967,668878611,1,1),(52692967,668878617,1,2),(52692967,668878620,1,3),(52692967,668878645,1,4),(52692967,668878647,1,5),(52692967,668878649,1,6),(52692967,668878650,1,7),(52692967,668878652,1,8),(52692967,668878676,1,9),(52692967,668878678,1,10),(52692967,668878679,1,11),(52692967,668878681,1,12),(52692967,668878683,1,13),(52692967,668878691,1,14),(52692967,668878692,1,15),(52692967,668878694,1,16),(52692967,668878707,1,17),(52692967,668878708,1,18),(52692968,668878696,1,1),(52692968,668878613,1,2),(52692969,668878497,1,1),(52692969,668878560,1,2),(52692969,668878562,1,3),(52692969,668878565,1,4),(52692969,668878567,1,5),(52692969,668878615,1,6),(52692969,668878630,1,7),(52692969,668878633,1,8),(52692969,668878634,1,9),(52692969,668878653,1,10),(52692969,668878663,1,11),(52692969,668878664,1,12),(52692969,668878666,1,13),(52692969,668878697,1,14),(52692969,668878699,1,15),(52692969,668878700,1,16),(52692969,668878702,1,17),(52692969,668878710,1,18),(52692969,668878712,1,19),(52692969,668878713,1,20),(52692969,668878715,1,21),(52692969,668878716,1,22),(52692969,668878718,1,23),(52692969,668878720,1,24),(52692969,668878721,1,25),(52692970,668878788,1,1),(52692970,668878809,1,2),(52692970,668878810,1,3),(52692970,668878812,1,4),(52692970,668878814,1,5),(52692970,668878816,1,6),(52692970,668878817,1,7),(52692970,668878852,1,8),(52692970,668878854,1,9),(52692970,668878855,1,10),(52692970,668878857,1,11),(52692970,668878859,1,12),(52692970,668878860,1,13),(52692971,668878790,1,1),(52692971,668878792,1,2),(52692971,668878794,1,3),(52692971,668878795,1,4),(52692971,668878819,1,5),(52692971,668878820,1,6),(52692971,668878822,1,7),(52692971,668878823,1,8),(52692971,668878825,1,9),(52692971,668878826,1,10),(52692971,668878828,1,11),(52692971,668878863,1,12),(52692971,668878865,1,13),(52692971,668878867,1,14),(52692971,668878869,1,15),(52692971,668878870,1,16),(52692971,668878872,1,17),(52692971,668878862,1,18),(52697930,668901336,1,1),(52697930,668901337,1,2),(52697930,668901338,1,3),(52697930,668901357,1,4),(52697930,668901358,1,5),(52697930,668901359,1,6),(52697930,668901360,1,7),(52697930,668901362,1,8),(52697930,668901363,1,9),(52697930,668901364,1,10),(52697930,668901365,1,11),(52697930,668901361,1,12),(52697930,668901366,1,13),(52697930,668901367,1,14),(52697930,668901368,1,15),(52697930,668901369,1,16),(52697930,668901370,1,17),(52697930,668901371,1,18),(52697930,668901374,1,19),(52697930,668901376,1,20),(52697930,668901377,1,21),(52697930,668901379,1,22),(52697930,668901380,1,23),(52697930,668901381,1,24),(52697930,668901385,1,25),(52697930,668901386,1,26),(52697930,668901387,1,27),(52697930,668901407,1,28),(52697930,668901408,1,29),(52697930,668901409,1,30),(52697930,668901410,1,31),(52697930,668901417,1,32),(52697930,668901418,1,33),(52697930,668901419,1,34),(52697930,668901420,1,35),(52697930,668901421,1,36),(52697930,668901422,1,37),(52697930,668901423,1,38),(52697930,668901424,1,39),(52697930,668901429,1,40),(52697930,668901411,1,41),(52697930,668901412,1,42),(52697930,668901413,1,43),(52697930,668901414,1,44),(52697930,668901415,1,45),(52697930,668901416,1,46),(52697930,668901433,1,47),(52697930,668901434,1,48),(52697930,668901435,1,49),(52697930,668901436,1,50),(52697930,668901437,1,51),(52697930,668901438,1,52),(52697930,668901439,1,53),(52697930,668901440,1,54),(52697930,668901406,1,55),(52697930,668901448,1,56),(52697930,668901449,1,57),(52697930,668901450,1,58),(52697930,668901451,1,59),(52697930,668901452,1,60),(52697930,668901453,1,61),(52697930,668901454,1,62),(52697930,668901455,1,63),(52697930,668901456,1,64),(52697930,668901457,1,65),(52697930,668901458,1,66),(52697930,668901459,1,67),(52697930,668901460,1,68),(52697930,668901461,1,69),(52697930,668901462,1,70),(52697930,668901463,1,71),(52697930,668901519,1,72),(52697930,668901858,1,73),(52697930,668901859,1,74),(52697930,668901860,1,75),(52697930,668901861,1,76),(52697930,668901862,1,77),(52697930,668901863,1,78),(52697930,668901864,1,79),(52697930,668901866,1,80),(52697930,668901867,1,81),(52697930,668901868,1,82),(52697930,668901869,1,83),(52697930,668901872,1,84),(52697930,668901873,1,85),(52697930,668901874,1,86),(52697930,668901878,1,87),(52697930,668901879,1,88),(52697930,668901875,1,89),(52697931,668901296,1,1),(52697931,668901297,1,2),(52697931,668901298,1,3),(52697931,668901302,1,4),(52697931,668901303,1,5),(52697931,668901315,1,6),(52697931,668901316,1,7),(52697931,668901317,1,8),(52697931,668901318,1,9),(52697931,668901304,1,10),(52697931,668901305,1,11),(52697931,668901287,1,12),(52697931,668901288,1,13),(52697931,668901282,1,14),(52697931,668901283,1,15),(52697931,668901284,1,16),(52697931,668901294,1,17),(52697931,668901295,1,18),(52697931,668901306,1,19),(52697931,668901656,1,20),(52697931,668901657,1,21),(52697931,668901658,1,22),(52697931,668901659,1,23),(52697931,668901660,1,24),(52697931,668901661,1,25),(52697931,668901663,1,26),(52697931,668901664,1,27),(52697931,668901665,1,28),(52697931,668901666,1,29),(52697931,668901649,1,30),(52697931,668901650,1,31),(52697931,668901651,1,32),(52697931,668901667,1,33),(52697931,668901668,1,34),(52697931,668901669,1,35),(52697931,668901670,1,36),(52697931,668901672,1,37),(52697931,668901676,1,38),(52697931,668901677,1,39),(52697931,668901694,1,40),(52697931,668901695,1,41),(52697931,668901696,1,42),(52697931,668901697,1,43),(52697931,668901698,1,44),(52697931,668901699,1,45),(52697931,668901711,1,46),(52697931,668901720,1,47),(52697931,668901721,1,48),(52697931,668901723,1,49),(52697931,668901733,1,50),(52697931,668901734,1,51),(52697931,668901735,1,52),(52697932,668901326,1,1),(52697932,668901327,1,2),(52697932,668901328,1,3),(52697932,668901340,1,4),(52697932,668901341,1,5),(52697932,668901342,1,6),(52697932,668901343,1,7),(52697932,668901349,1,8),(52697932,668901350,1,9),(52697932,668901344,1,10),(52697932,668901345,1,11),(52697932,668901347,1,12),(52697932,668901351,1,13),(52697932,668901352,1,14),(52697932,668901353,1,15),(52697932,668901354,1,16),(52697932,668901355,1,17),(52697932,668901356,1,18),(52697932,668901394,1,19),(52697932,668901263,1,20),(52697932,668901264,1,21),(52697932,668901267,1,22),(52697932,668901268,1,23),(52697932,668901269,1,24),(52697932,668901270,1,25),(52697932,668901271,1,26),(52697932,668901309,1,27),(52697932,668901310,1,28),(52697932,668901311,1,29),(52697932,668901312,1,30),(52697932,668901313,1,31),(52697932,668901272,1,32),(52697932,668901273,1,33),(52697932,668901274,1,34),(52697932,668901299,1,35),(52697932,668901300,1,36),(52697932,668901301,1,37),(52697932,668901289,1,38),(52697932,668901307,1,39),(52697932,668901308,1,40),(52697932,668901662,1,41),(52697932,668901680,1,42),(52697932,668901681,1,43),(52697932,668901682,1,44),(52697932,668901683,1,45),(52697932,668901689,1,46),(52697932,668901690,1,47),(52697932,668901691,1,48),(52697932,668901692,1,49),(52697932,668901693,1,50),(52697932,668901842,1,51),(52697932,668901843,1,52),(52697932,668901844,1,53),(52697932,668901845,1,54),(52697932,668901846,1,55),(52697932,668901850,1,56),(52697932,668901851,1,57),(52697932,668901852,1,58),(52697934,668901314,1,1),(52697934,668901319,1,2),(52697934,668901320,1,3),(52697934,668901321,1,4),(52697934,668901684,1,5),(52697934,668901685,1,6),(52697934,668901686,1,7),(52697935,668901335,1,1),(52697935,668901322,1,2),(52697935,668901323,1,3),(52697935,668901203,1,4),(52697935,668901204,1,5),(52697935,668901205,1,6),(52697935,668901206,1,7),(52697935,668901207,1,8),(52697935,668901208,1,9),(52697935,668901209,1,10),(52697935,668901210,1,11),(52697935,668901211,1,12),(52697935,668901212,1,13),(52697935,668901213,1,14),(52697935,668901214,1,15),(52697935,668901215,1,16),(52697935,668901234,1,17),(52697935,668901235,1,18),(52697935,668901236,1,19),(52697935,668901237,1,20),(52697935,668901238,1,21),(52697935,668901239,1,22),(52697935,668901240,1,23),(52697935,668901241,1,24),(52697935,668901242,1,25),(52697935,668901243,1,26),(52697935,668901244,1,27),(52697935,668901216,1,28),(52697935,668901217,1,29),(52697935,668901218,1,30),(52697935,668901219,1,31),(52697935,668901220,1,32),(52697935,668901221,1,33),(52697935,668901222,1,34),(52697935,668901223,1,35),(52697935,668901224,1,36),(52697935,668901225,1,37),(52697935,668901227,1,38),(52697935,668901228,1,39),(52697935,668901229,1,40),(52697935,668901230,1,41),(52697935,668901249,1,42),(52697935,668901250,1,43),(52697935,668901251,1,44),(52697935,668901252,1,45),(52697935,668901253,1,46),(52697935,668901254,1,47),(52697935,668901255,1,48),(52697935,668901259,1,49),(52697935,668901260,1,50),(52697935,668901261,1,51),(52697935,668901262,1,52),(52697935,668901275,1,53),(52697935,668901276,1,54),(52697935,668901277,1,55),(52697935,668901278,1,56),(52697935,668901280,1,57),(52697935,668901281,1,58),(52697935,668901290,1,59),(52697935,668901291,1,60),(52697935,668901292,1,61),(52697935,668901293,1,62),(52697935,668901285,1,63),(52697935,668901286,1,64),(52697935,668901645,1,65),(52697935,668901646,1,66),(52697935,668901647,1,67),(52697935,668901654,1,68),(52697935,668901655,1,69),(52697936,668901620,1,1),(52697936,668901621,1,2),(52697936,668901622,1,3),(52697936,668901623,1,4),(52697936,668901624,1,5),(52697936,668901625,1,6),(52697936,668901626,1,7),(52697936,668901627,1,8),(52697936,668901628,1,9),(52697936,668901933,1,10),(52697936,668901934,1,11),(52697936,668901935,1,12),(52697936,668901936,1,13),(52697936,668901937,1,14),(52697936,668901938,1,15),(52697936,668901939,1,16),(52697936,668901941,1,17),(52697936,668901942,1,18),(52697936,668901943,1,19),(52697936,668901944,1,20),(52697936,668901945,1,21),(52697936,668901949,1,22),(52697936,668901996,1,23),(52697936,668901998,1,24),(52697936,668901982,1,25),(52697936,668901983,1,26),(52697936,668901984,1,27),(52697936,668901966,1,28),(52697937,668901581,1,1),(52697937,668901582,1,2),(52697937,668901583,1,3),(52697937,668901565,1,4),(52697937,668901566,1,5),(52697937,668901567,1,6),(52697937,668901603,1,7),(52697937,668901604,1,8),(52697937,668901595,1,9),(52697937,668901596,1,10),(52697937,668901606,1,11),(52697937,668901607,1,12),(52697937,668901608,1,13),(52697937,668901609,1,14),(52697937,668901910,1,15),(52697937,668901911,1,16),(52697937,668901912,1,17),(52697937,668901913,1,18),(52697937,668901914,1,19),(52697937,668901915,1,20),(52697937,668901916,1,21),(52697937,668901921,1,22),(52697937,668901891,1,23),(52697937,668901892,1,24),(52697937,668901893,1,25),(52697937,668901922,1,26),(52697937,668901923,1,27),(52697937,668901924,1,28),(52697937,668901925,1,29),(52697937,668901953,1,30),(52697937,668901954,1,31),(52697937,668901956,1,32),(52697937,668901973,1,33),(52697937,668901975,1,34),(52697937,668901976,1,35),(52697937,668901991,1,36),(52697937,668901992,1,37),(52697938,668901605,1,1),(52697938,668901597,1,2),(52697938,668901598,1,3),(52697938,668901610,1,4),(52697938,668901611,1,5),(52697938,668901612,1,6),(52697938,668901613,1,7),(52697938,668901614,1,8),(52697938,668901615,1,9),(52697938,668901616,1,10),(52697938,668901617,1,11),(52697938,668901618,1,12),(52697938,668901619,1,13),(52697938,668901529,1,14),(52697938,668901882,1,15),(52697938,668901883,1,16),(52697938,668901884,1,17),(52697939,668901483,1,1),(52697939,668901484,1,2),(52697939,668901494,1,3),(52697939,668901495,1,4),(52697939,668901496,1,5),(52697939,668901497,1,6),(52697939,668901498,1,7),(52697939,668901499,1,8),(52697939,668901574,1,9),(52697939,668901575,1,10),(52697939,668901576,1,11),(52697939,668901577,1,12),(52697939,668901579,1,13),(52697939,668901557,1,14),(52697939,668901552,1,15),(52697939,668901553,1,16),(52697939,668901554,1,17),(52697939,668901555,1,18),(52697939,668901556,1,19),(52697939,668901548,1,20),(52697939,668901549,1,21),(52697939,668901550,1,22),(52697939,668901551,1,23),(52697939,668901558,1,24),(52697939,668901559,1,25),(52697939,668901560,1,26),(52697939,668901561,1,27),(52697939,668901562,1,28),(52697939,668901563,1,29),(52697939,668901592,1,30),(52697939,668901593,1,31),(52697939,668901594,1,32),(52697939,668901599,1,33),(52697939,668901600,1,34),(52697939,668901601,1,35),(52697939,668901602,1,36),(52697939,668901525,1,37),(52697939,668901526,1,38),(52697939,668901527,1,39),(52697939,668901530,1,40),(52697939,668901531,1,41),(52697939,668901532,1,42),(52697939,668901533,1,43),(52697939,668901534,1,44),(52697939,668901535,1,45),(52697939,668901536,1,46),(52697939,668901537,1,47),(52697939,668901538,1,48),(52697939,668901539,1,49),(52697939,668901540,1,50),(52697939,668901541,1,51),(52697939,668901542,1,52),(52697939,668901885,1,53),(52697939,668901886,1,54),(52697939,668901887,1,55),(52697939,668901888,1,56),(52697939,668901889,1,57),(52697939,668901890,1,58),(52697939,668901876,1,59),(52697939,668901881,1,60),(52697939,668901894,1,61),(52697939,668901895,1,62),(52697939,668901896,1,63),(52697939,668901897,1,64),(52697939,668901898,1,65),(52697939,668901899,1,66),(52697939,668901900,1,67),(52697939,668901901,1,68),(52697939,668901931,1,69),(52697939,668901932,1,70),(52697939,668901964,1,71),(52697939,668901965,1,72),(52697939,668901978,1,73),(52697939,668901979,1,74),(52697939,668901980,1,75),(52697939,668901993,1,76),(52697939,668901994,1,77),(52697939,668901995,1,78),(52697940,668901485,1,1),(52697940,668901486,1,2),(52697940,668901464,1,3),(52697940,668901465,1,4),(52697940,668901466,1,5),(52697940,668901467,1,6),(52697940,668901468,1,7),(52697940,668901469,1,8),(52697940,668901470,1,9),(52697940,668901471,1,10),(52697940,668901472,1,11),(52697940,668901473,1,12),(52697940,668901474,1,13),(52697940,668901543,1,14),(52697940,668901544,1,15),(52697940,668901545,1,16),(52697940,668901546,1,17),(52697940,668901547,1,18),(52697940,668901504,1,19),(52697940,668901505,1,20),(52697940,668901506,1,21),(52697940,668901507,1,22),(52697940,668901508,1,23),(52697940,668901510,1,24),(52697940,668901511,1,25),(52697940,668901512,1,26),(52697940,668901513,1,27),(52697940,668901514,1,28),(52697940,668901528,1,29),(52697940,668901517,1,30),(52697940,668901518,1,31),(52697940,668901520,1,32),(52697940,668901521,1,33),(52697940,668901522,1,34),(52697940,668901523,1,35),(52697940,668901524,1,36),(52697940,668901865,1,37),(52697940,668901870,1,38),(52697940,668901871,1,39),(52697940,668901877,1,40),(52697941,668901428,1,1),(52697941,668901430,1,2),(52697941,668901432,1,3),(52697941,668901500,1,4),(52697941,668901501,1,5),(52697941,668901502,1,6),(52697941,668901503,1,7),(52697941,668901515,1,8),(52697941,668901516,1,9),(52697942,668901324,1,1),(52697942,668901325,1,2),(52697942,668901339,1,3),(52697942,668901348,1,4),(52697943,668901329,1,1),(52697943,668901330,1,2),(52697943,668901331,1,3),(52697943,668901332,1,4),(52697943,668901333,1,5),(52697943,668901334,1,6),(52697943,668901202,1,7),(52697943,668901231,1,8),(52697943,668901232,1,9),(52697943,668901233,1,10),(52697943,668901245,1,11),(52697943,668901246,1,12),(52697943,668901247,1,13),(52697943,668901265,1,14),(52697943,668901266,1,15),(52697943,668901248,1,16),(52697943,668901256,1,17),(52697943,668901257,1,18),(52697943,668901258,1,19),(52697944,668901372,1,1),(52697944,668901373,1,2),(52697944,668901375,1,3),(52697944,668901378,1,4),(52697944,668901382,1,5),(52697944,668901383,1,6),(52697944,668901384,1,7),(52697944,668901388,1,8),(52697944,668901389,1,9),(52697944,668901390,1,10),(52697944,668901391,1,11),(52697944,668901392,1,12),(52697944,668901393,1,13),(52697944,668901425,1,14),(52697944,668901426,1,15),(52697944,668901427,1,16),(52697944,668901419,1,17),(52697945,668901475,1,1),(52697945,668901476,1,2),(52697945,668901477,1,3),(52697945,668901487,1,4),(52697945,668901478,1,5),(52697945,668901479,1,6),(52697945,668901480,1,7),(52697945,668901481,1,8),(52697945,668901482,1,9),(52697945,668901488,1,10),(52697945,668901489,1,11),(52697945,668901490,1,12),(52697945,668901491,1,13),(52697945,668901492,1,14),(52697945,668901493,1,15),(52697945,668901572,1,16),(52697945,668901573,1,17),(52697945,668901580,1,18),(52697945,668901584,1,19),(52697945,668901585,1,20),(52697945,668901586,1,21),(52697945,668901587,1,22),(52697945,668901588,1,23),(52697945,668901589,1,24),(52697945,668901590,1,25),(52697945,668901591,1,26),(52697945,668901564,1,27),(52697945,668901568,1,28),(52697945,668901569,1,29),(52697945,668901570,1,30),(52697945,668901571,1,31),(52697946,668901853,1,1),(52697946,668901854,1,2),(52697946,668901855,1,3),(52697946,668901856,1,4),(52697946,668901999,1,5),(52697946,668902000,1,6),(52697946,668902002,1,7),(52697946,668902003,1,8),(52697946,668902005,1,9),(52697946,668902007,1,10),(52697946,668902018,1,11),(52697946,668902019,1,12),(52697946,668902021,1,13),(52697946,668902022,1,14),(52697946,668902011,1,15),(52697946,668902013,1,16),(52697946,668902015,1,17),(52697946,668902016,1,18),(52697946,668901902,1,19),(52697946,668901903,1,20),(52697946,668901904,1,21),(52697946,668901905,1,22),(52697946,668901906,1,23),(52697946,668901907,1,24),(52697946,668901908,1,25),(52697946,668901986,1,26),(52697946,668901987,1,27),(52697946,668901989,1,28),(52697947,668901737,1,1),(52697947,668901769,1,2),(52697948,668901857,1,1),(52697948,668901777,1,2),(52697948,668901778,1,3),(52697948,668901779,1,4),(52697948,668901780,1,5),(52697948,668901770,1,6),(52697948,668901771,1,7),(52697948,668901772,1,8),(52697948,668901774,1,9),(52697948,668901775,1,10),(52697948,668901776,1,11),(52697948,668901781,1,12),(52697948,668901783,1,13),(52697948,668901784,1,14),(52697948,668901785,1,15),(52697948,668901786,1,16),(52697948,668901787,1,17),(52697948,668901788,1,18),(52697948,668901789,1,19),(52697948,668901790,1,20),(52697948,668901791,1,21),(52697948,668901792,1,22),(52697948,668901793,1,23),(52697948,668901782,1,24),(52697948,668901815,1,25),(52697948,668901816,1,26),(52697948,668901817,1,27),(52697948,668901818,1,28),(52697948,668901819,1,29),(52697948,668901820,1,30),(52697948,668901821,1,31),(52697948,668901806,1,32),(52697948,668901807,1,33),(52697948,668901808,1,34),(52697948,668901809,1,35),(52697948,668901822,1,36),(52697948,668901823,1,37),(52697948,668901824,1,38),(52697948,668901825,1,39),(52697948,668901826,1,40),(52697948,668901827,1,41),(52697948,668901828,1,42),(52697948,668901810,1,43),(52697948,668901811,1,44),(52697948,668901812,1,45),(52697948,668901813,1,46),(52697948,668901814,1,47),(52697948,668901794,1,48),(52697948,668901795,1,49),(52697948,668901796,1,50),(52697948,668901797,1,51),(52697948,668901798,1,52),(52697948,668901799,1,53),(52697948,668901800,1,54),(52697948,668901801,1,55),(52697948,668901802,1,56),(52697948,668901761,1,57),(52697948,668901762,1,58),(52697948,668901763,1,59),(52697948,668901764,1,60),(52697948,668901765,1,61),(52697948,668901766,1,62),(52697948,668901767,1,63),(52697948,668901768,1,64),(52697948,668901751,1,65),(52697948,668901752,1,66),(52697948,668901753,1,67),(52697948,668901754,1,68),(52697948,668901755,1,69),(52697948,668901756,1,70),(52697948,668901757,1,71),(52697948,668901743,1,72),(52697948,668901744,1,73),(52697948,668901745,1,74),(52697948,668901746,1,75),(52697948,668901747,1,76),(52697948,668901748,1,77),(52697948,668901749,1,78),(52697948,668901750,1,79),(52697948,668901630,1,80),(52697948,668901631,1,81),(52697948,668901632,1,82),(52697948,668901633,1,83),(52697948,668901634,1,84),(52697948,668901635,1,85),(52697948,668901636,1,86),(52697948,668901637,1,87),(52697948,668901638,1,88),(52697948,668901639,1,89),(52697948,668901640,1,90),(52697948,668901641,1,91),(52697948,668901642,1,92),(52697948,668901643,1,93),(52697948,668901644,1,94),(52697948,668901758,1,95),(52697948,668901759,1,96),(52697948,668901760,1,97),(52697948,668901803,1,98),(52697948,668901804,1,99),(52697948,668901805,1,100),(52697948,668901700,1,101),(52697948,668901701,1,102),(52697948,668901702,1,103),(52697948,668901703,1,104),(52697948,668901704,1,105),(52697948,668901705,1,106),(52697948,668901706,1,107),(52697948,668901707,1,108),(52697948,668901708,1,109),(52697948,668901709,1,110),(52697948,668901710,1,111),(52697948,668901724,1,112),(52697948,668901725,1,113),(52697948,668901726,1,114),(52697948,668901727,1,115),(52697948,668901728,1,116),(52697948,668901729,1,117),(52697948,668901730,1,118),(52697948,668901731,1,119),(52697948,668901738,1,120),(52697948,668901739,1,121),(52697948,668901740,1,122),(52697948,668901741,1,123),(52697948,668901742,1,124),(52697949,668901732,1,1),(52697949,668901648,1,2),(52697950,668901829,1,1),(52697950,668901831,1,2),(52697950,668901833,1,3),(52697950,668901834,1,4),(52697950,668901835,1,5),(52697950,668901836,1,6),(52697950,668901837,1,7),(52697950,668901838,1,8),(52697950,668901839,1,9),(52697950,668901840,1,10),(52697951,668901652,1,1),(52697951,668901653,1,2),(52697951,668901673,1,3),(52697951,668901674,1,4),(52697951,668901675,1,5),(52697951,668901678,1,6),(52697951,668901679,1,7),(52697951,668901687,1,8),(52697951,668901688,1,9),(52697951,668901712,1,10),(52697951,668901713,1,11),(52697951,668901714,1,12),(52697951,668901715,1,13),(52697951,668901716,1,14),(52697951,668901717,1,15),(52697951,668901718,1,16),(52697951,668901719,1,17),(52697951,668901736,1,18),(52697951,668901732,1,19),(52697952,668901917,1,1),(52697952,668901918,1,2),(52697952,668901919,1,3),(52697952,668901920,1,4),(52697952,668901926,1,5),(52697952,668901927,1,6),(52697952,668901928,1,7),(52697952,668901929,1,8),(52697952,668901930,1,9),(52697952,668901957,1,10),(52697952,668901959,1,11),(52697952,668901960,1,12),(52697952,668901962,1,13),(54858984,690708536,1,1),(54858984,690708536,1,2),(61736197,769251745,2,1),(61736197,51119556,2,2),(61736197,51119558,2,3),(61736197,51119559,2,4),(61736197,51119560,2,5),(61736197,51119407,2,6),(61736197,51119409,2,7),(61736197,51119410,2,8),(61736197,51119411,2,9),(61736197,51119413,2,10),(61736197,51119414,2,11),(61736197,51119416,2,12),(61736197,51119417,2,13),(61736197,51119419,2,14),(61736197,51119420,2,15),(61736197,51119421,2,16),(61736197,51119422,2,17),(61736197,51119424,2,18),(61736197,51119425,2,19),(61736197,51119426,2,20),(61736197,51119427,2,21),(61736197,51119428,2,22),(61736197,51119430,2,23),(61736197,51119431,2,24),(61736197,51119432,2,25),(61736197,51119433,2,26),(61736197,51119058,2,27),(61736197,51119435,2,28),(61736197,51119060,2,29),(61736197,51119061,2,30),(61736197,51119062,2,31),(61736197,51119064,2,32);
INSERT INTO `way_nodes` VALUES (61736197,51119065,2,33),(61736199,51119065,2,1),(61736199,51119066,2,2),(61736199,51119067,2,3),(61736199,51119069,2,4),(61736199,51119070,2,5),(61736199,51119071,2,6),(61736199,51119072,2,7),(61736200,51119072,2,1),(61736200,51119073,2,2),(61736200,51119075,2,3),(61736200,51119076,2,4),(61736200,51119077,2,5),(61736200,51119078,2,6),(61736200,51119079,2,7),(61736200,51119081,2,8),(61736200,51119082,2,9),(61736200,51119083,2,10),(61736200,769251759,2,11),(61736202,769251759,2,1),(61736202,51119085,2,2),(61736202,51119086,2,3),(61736202,51119088,2,4),(61736202,51119089,2,5),(61736202,51119090,2,6),(61736202,51119091,2,7),(61736203,51119091,2,1),(61736203,51119093,2,2),(61736203,51119094,2,3),(61736203,51119096,2,4),(61736203,51119097,2,5),(61736203,51119098,2,6),(61736203,51119099,2,7),(61736203,51119101,2,8),(61736203,51119102,2,9),(61736203,51119103,2,10),(61736203,51119104,2,11),(61736203,51119105,2,12),(61736208,51119548,3,1),(61736208,51119547,3,2),(61736208,51119546,3,3),(61736208,51119545,3,4),(61736208,51119543,3,5),(61736208,51119542,3,6),(61736208,51119541,3,7),(61736208,51119617,3,8),(61736208,51119616,3,9),(61736208,51119615,3,10),(61736208,51119614,3,11),(61736208,51119613,3,12),(61736208,51119994,3,13),(61736208,51119993,3,14),(61736208,51119992,3,15),(61736208,51119991,3,16),(61736208,51119990,3,17),(61736208,51119989,3,18),(61736208,51119988,3,19),(61736208,51119987,3,20),(61736208,51119986,3,21),(61736208,51119984,3,22),(61736208,51119983,3,23),(61736208,51119981,3,24),(61736208,51119980,3,25),(61736208,51119979,3,26),(61736208,51119978,3,27),(61736208,51119977,3,28),(61736208,51119976,3,29),(61736208,51119974,3,30),(61736208,51119973,3,31),(61736208,51119972,3,32),(61736208,51119970,3,33),(61736208,51119969,3,34),(61736208,769251780,3,35),(61736208,51119968,3,36),(61736208,51119966,3,37),(61736208,51119965,3,38),(61736208,51119964,3,39),(61736208,51119962,3,40),(61736208,769251779,3,41),(61736208,51119961,3,42),(61736208,51119960,3,43),(61736208,51119959,3,44),(61736208,51119958,3,45),(61736208,769251793,3,46),(61736208,51119957,3,47),(61736208,51119956,3,48),(61736208,51119954,3,49),(61736208,51119953,3,50),(61736208,51119952,3,51),(61736208,51119951,3,52),(61736209,51119548,2,1),(61736209,51119550,2,2),(61736209,51119551,2,3),(61736209,51119553,2,4),(61736209,51119554,2,5),(61736209,51119555,2,6),(61736209,769251745,2,7),(70427100,840392122,2,1),(70427100,840392129,2,2),(70427114,51952060,2,1),(70427114,840392214,2,2),(70427114,840392122,2,3),(70427179,840392129,4,1),(70427179,840392132,4,2),(70427179,840392146,4,3),(70427179,840392147,4,4),(70427179,840392149,4,5),(70427179,840392151,4,6),(70427179,840392153,4,7),(70427179,840392156,4,8),(70427179,840392161,4,9),(70427179,840392165,4,10),(70427179,840392168,4,11),(70427179,840392171,4,12),(70427179,840392172,4,13),(70427179,840392174,4,14),(70427179,840392177,4,15),(70427179,840392179,4,16),(70427179,840392182,4,17),(70427179,840406394,4,18),(70427179,840392185,4,19),(70427179,840405569,4,20),(70427179,840392187,4,21),(70427179,840392190,4,22),(70427179,51952269,4,23),(70428387,840392129,1,1),(70428387,840392122,1,2),(75744715,894217189,2,1),(75744715,894217192,2,2),(75744715,894217206,2,3),(75744715,894217183,2,4),(75744715,894259125,2,5),(75744715,894217188,2,6),(75744715,894217191,2,7),(75744715,894217204,2,8),(75744715,894217170,2,9),(75744715,894217190,2,10),(75744715,894217194,2,11),(75744715,894217168,2,12),(75744715,894217186,2,13),(75744715,894217167,2,14),(75746393,894259639,1,1),(75746393,894259324,1,2),(75746394,894259087,1,1),(75746394,894259278,1,2),(75746394,894259590,1,3),(75746394,894259753,1,4),(75746395,894259636,2,1),(75746395,894259622,2,2),(75746395,894259060,2,3),(75746395,894259248,2,4),(75746395,894259034,2,5),(75746395,894259217,2,6),(75746395,894259536,2,7),(75746395,894259702,2,8),(75746395,894259161,2,9),(75746395,894259344,2,10),(75746395,894259664,2,11),(75746395,894258994,2,12),(75746395,894259462,2,13),(75746395,894259641,2,14),(75746395,894259089,2,15),(75746395,894259280,2,16),(75746395,894259600,2,17),(75746395,894259757,2,18),(75746395,894259221,2,19),(75746395,894259405,2,20),(75746395,894259187,2,21),(75746395,894259370,2,22),(75746395,894259685,2,23),(75746395,894259014,2,24),(75746395,894259328,2,25),(75746395,894259513,2,26),(75746395,894258982,2,27),(75746395,894259141,2,28),(75746395,894258967,2,29),(75746395,894259111,2,30),(75746395,894259431,2,31),(75746395,894259624,2,32),(75746395,894259063,2,33),(75746395,894259251,2,34),(75746395,894259562,2,35),(75746395,894259726,2,36),(75746395,894259540,2,37),(75746395,894259703,2,38),(75746395,894259164,2,39),(75746395,894259348,2,40),(75746395,894259665,2,41),(75746395,894258996,2,42),(75746395,894259300,2,43),(75746395,894259483,2,44),(75746395,894259271,2,45),(75746395,894259449,2,46),(75746395,894259746,2,47),(75746395,894259083,2,48),(75746396,894259570,1,1),(75746396,894259525,1,2),(75746396,894259687,1,3),(75746396,894259144,1,4),(75746397,894258985,2,1),(75746397,894259284,2,2),(75746397,894259468,2,3),(75746397,894259257,2,4),(75746397,894259435,2,5),(75746397,894259732,2,6),(75746397,894259067,2,7),(75746397,894259375,2,8),(75746397,894259576,2,9),(75746397,894259022,2,10),(75746397,894259195,2,11),(75746397,894258998,2,12),(75746397,894259171,2,13),(75746397,894259492,2,14),(75746397,894259666,2,15),(75746397,894259118,2,16),(75746397,894259331,2,17),(75746398,894259193,1,1),(75746398,51362129,1,2),(75746398,625199,1,3),(75746398,625200,1,4),(75746398,51362133,1,5),(75746398,51362135,1,6),(75746398,51362009,1,7),(75746398,625202,1,8),(75746398,51362011,1,9),(75746398,625203,1,10),(75746398,51362012,1,11),(75746398,625204,1,12),(75746398,51126211,1,13),(75746399,894259331,2,1),(75746399,894259515,2,2),(75746400,894259324,1,1),(75746400,894259489,1,2),(75746400,894259276,1,3),(75746400,894259456,1,4),(75746400,894259750,1,5),(75746400,894259085,1,6),(75746400,894259402,1,7),(75746400,894259587,1,8),(75746400,894259046,1,9),(75746400,894259351,1,10),(75746400,894259547,1,11),(75746400,894258997,1,12),(75746400,894259168,1,13),(75746400,894259486,1,14),(75746400,894259533,1,15),(75746400,894258992,1,16),(75746400,894259155,1,17),(75746400,894259480,1,18),(75746400,894259662,1,19),(75746400,894259107,1,20),(75746400,894259297,1,21),(75746400,894259073,1,22),(75746400,894259262,1,23),(75746400,894259582,1,24),(75746400,894259743,1,25),(75746400,894259206,1,26),(75746400,894259386,1,27),(75746400,894259700,1,28),(75746400,894259032,1,29),(75746400,894259678,1,30),(75746400,894259010,1,31),(75746401,894259722,1,1),(75746401,894259053,1,2),(75746401,894259358,1,3),(75746401,894259556,1,4),(75746402,894217191,1,1),(75746402,894259773,1,2),(75746402,894259091,1,3),(75746402,894259411,1,4),(75746403,894259390,1,1),(75746403,894259706,1,2),(75746403,894259040,1,3),(75746403,894259680,1,4),(75746404,894259509,1,1),(75746404,894259682,1,2),(75746404,894259473,1,3),(75746404,894259658,1,4),(75746404,894259098,1,5),(75746404,894259294,1,6),(75746404,894259613,1,7),(75746404,894258960,1,8),(75746404,894259242,1,9),(75746404,894259424,1,10),(75746404,894259199,1,11),(75746404,894259379,1,12),(75746405,894259118,2,1),(75746405,894259114,2,2),(75746405,894259433,2,3),(75746405,894259627,2,4),(75746405,894259353,2,5),(75746406,894259125,1,1),(75746406,894259451,1,2),(75746406,894259636,1,3),(75746409,51420970,2,1),(75746409,894259379,2,2),(75746409,51973102,2,3),(75746409,51973105,2,4),(75746409,51973108,2,5),(75746409,51973112,2,6),(75746409,51973113,2,7),(75746409,51973117,2,8),(75746409,51973120,2,9),(75746409,51973122,2,10),(75746409,894259722,2,11),(75746409,894259509,2,12),(75746409,894259176,2,13),(75746409,51973125,2,14),(75746409,894259274,2,15),(75746409,51973128,2,16),(75746409,51973131,2,17),(75746409,51973135,2,18),(75746409,51973138,2,19),(75746409,924524128,2,20),(75746409,51973141,2,21),(75746409,51973144,2,22),(75746409,51973147,2,23),(75746409,51973150,2,24),(75746409,51973154,2,25),(75746409,51973156,2,26),(75746409,51973158,2,27),(75746409,51973161,2,28),(75746409,51973163,2,29),(75746409,51973166,2,30),(75746409,51973170,2,31),(75746409,51973172,2,32),(75746409,51973175,2,33),(75746409,51973177,2,34),(75746409,51973179,2,35),(75746409,51973183,2,36),(75746409,51973186,2,37),(75746409,51973190,2,38),(75746409,51973193,2,39),(75746409,51973196,2,40),(75746409,51973198,2,41),(75746409,51973201,2,42),(75746409,51973203,2,43),(75746409,51973206,2,44),(75746409,51973208,2,45),(75746409,51973210,2,46),(75746409,51973213,2,47),(75746409,51973215,2,48),(75746409,51973219,2,49),(75746409,51973221,2,50),(75746409,51973223,2,51),(75746409,51973225,2,52),(75746409,51973228,2,53),(75746409,51973234,2,54),(75746409,51973237,2,55),(75746409,51973241,2,56),(75746409,51973243,2,57),(75746409,51973247,2,58),(75746409,51973249,2,59),(75746409,51973253,2,60),(75746409,51973256,2,61),(75746409,51973260,2,62),(75746409,51973264,2,63),(75746409,51973268,2,64),(75746409,51973269,2,65),(75746409,51973273,2,66),(75746409,51973276,2,67),(75746409,51973278,2,68),(75746409,51973281,2,69),(75746409,51973284,2,70),(75746409,51973287,2,71),(75746409,51973290,2,72),(75746409,51973293,2,73),(75746409,51973296,2,74),(75746409,51973300,2,75),(75746409,51973302,2,76),(75746409,51973306,2,77),(75746409,51973310,2,78),(75746409,51973313,2,79),(75746409,51973316,2,80),(75746409,51973320,2,81),(75746409,51973324,2,82),(75746409,51973326,2,83),(75746409,51973327,2,84),(75746409,51973329,2,85),(75746409,51973334,2,86),(75746409,51973336,2,87),(75746409,51973339,2,88),(75746409,51973341,2,89),(75746409,51973344,2,90),(75746409,51973346,2,91),(75746409,51973348,2,92),(75746409,51973351,2,93),(75746409,51973352,2,94),(75746409,51973353,2,95),(75746409,51973354,2,96),(75746409,51973356,2,97),(75746409,51973357,2,98),(75746409,51973359,2,99),(75746409,51973361,2,100),(75746409,51973362,2,101),(75746409,51973363,2,102),(75746409,51973364,2,103),(75746409,51973366,2,104),(75746409,51973369,2,105),(75746409,51973370,2,106),(75746409,51973373,2,107),(75746409,51973375,2,108),(75746409,51973378,2,109),(75746409,51973380,2,110),(75746409,51973384,2,111),(75746409,51973387,2,112),(75746409,51973390,2,113),(75746409,51973394,2,114),(75746409,51973396,2,115),(75746409,51973398,2,116),(75746409,51973400,2,117),(75746409,51973403,2,118),(75746409,51973405,2,119),(75746409,51973407,2,120),(75746409,51973409,2,121),(75746409,51973413,2,122),(75746409,51973416,2,123),(75746409,51973417,2,124),(75746409,51973419,2,125),(75746409,51973424,2,126),(75746409,51973426,2,127),(75746409,51973428,2,128),(75746409,51973430,2,129),(75746409,51973432,2,130),(75746409,51973436,2,131),(75746409,51973439,2,132),(75746409,51973441,2,133),(75746409,51973444,2,134),(75746409,51973448,2,135),(75746409,51973451,2,136),(75746409,51973454,2,137),(75746409,51973456,2,138),(75746409,51973459,2,139),(75746409,51973462,2,140),(75746409,51973467,2,141),(75746409,51973470,2,142),(75746409,51973471,2,143),(75746409,51973475,2,144),(75746409,51973478,2,145),(75746409,51973481,2,146),(75746409,51973484,2,147),(75746409,51973487,2,148),(75746409,51973489,2,149),(75746409,51973491,2,150),(75746409,51973494,2,151),(75746409,51973497,2,152),(75746409,51973499,2,153),(75746409,51973501,2,154),(75746410,894259451,1,1),(75746410,894259228,1,2),(75746410,894259051,1,3),(75746410,894259604,1,4),(75746410,894259414,1,5),(75746410,894259093,1,6),(75746410,894259774,1,7),(75746410,894259122,1,8),(75746410,894258972,1,9),(75746410,894259499,1,10),(75746410,894259313,1,11),(75746410,894259008,1,12),(75746410,894259676,1,13),(75746410,894259356,1,14),(75746410,894259174,1,15),(75746410,894259382,1,16),(75746410,894259202,1,17),(75746410,894259742,1,18),(75746410,894259580,1,19),(75746410,894259261,1,20),(75746410,894259070,1,21),(75746410,894259633,1,22),(75746410,894259437,1,23),(75746410,894259660,1,24),(75746410,894259476,1,25),(75746410,894259152,1,26),(75746410,894258989,1,27),(75746410,894259531,1,28),(75746410,894259337,1,29),(75746410,894259030,1,30),(75746410,894259699,1,31),(75746410,894259057,1,32),(75746410,894259724,1,33),(75746410,894259427,1,34),(75746410,894259245,1,35),(75746410,894258963,1,36),(75746410,894259617,1,37),(75746410,894259295,1,38),(75746410,894259105,1,39),(75746410,894259320,1,40),(75746410,894259137,1,41),(75746410,894259683,1,42),(75746410,894259511,1,43),(75746410,894259178,1,44),(75746410,894259012,1,45),(75746410,894259559,1,46),(75746410,894259360,1,47),(75746410,894259417,1,48),(75746410,894259236,1,49),(75746410,894258957,1,50),(75746410,894259610,1,51),(75746410,894259282,1,52),(75746410,894259096,1,53),(75746410,894259650,1,54),(75746410,894259465,1,55),(75746410,894259083,1,56),(75746410,894259037,1,57),(75746410,894259553,1,58),(75746410,894259721,1,59),(75746410,894259527,1,60),(75746410,894259698,1,61),(75746410,894259148,1,62),(75746410,894259335,1,63),(75746410,894259654,1,64),(75746410,894258985,1,65),(75746411,894259254,1,1),(75746411,894259334,1,2),(75746412,894259135,2,1),(75746412,894259398,2,2),(75746412,894259585,2,3),(75746412,894259043,2,4),(75746412,894259219,2,5),(75746412,894259310,2,6),(75746414,894259297,1,1),(75746414,894259439,1,2),(75746414,894259486,1,3),(75746415,894259572,1,1),(75746415,894259232,1,2),(75746415,894259307,1,3),(75746415,894259020,1,4),(75746415,894259607,1,5),(75746415,894259550,1,6),(75746415,894259193,1,7),(75746415,894259720,1,8),(75746415,894259372,1,9),(75746415,894259572,1,10),(75746416,894259091,1,1),(75746416,894259254,1,2),(75746416,894259570,1,3),(75746416,894259729,1,4),(75746416,894217170,1,5),(75746417,894259729,1,1),(75746417,894259188,1,2),(75746418,894259353,2,1),(75746418,894259135,2,2),(75746419,894259515,2,1),(75746419,894259310,2,2),(75746419,894259630,2,3),(75746419,894258969,2,4),(75746419,894259602,2,5),(75746419,894259760,2,6),(75746419,894259225,2,7),(75746419,894259408,2,8),(75746419,894259556,2,9),(75746419,894259708,2,10),(75746419,53335702,2,11),(75746419,53335700,2,12),(75746421,894259697,1,1),(75746421,894258974,1,2),(75746421,894259753,1,3),(75746421,894259139,1,4),(75746421,894259459,1,5),(75746421,894259697,1,6),(75746422,894259303,1,1),(75746422,894259639,1,2),(75746423,894259274,1,1),(75746423,894259453,1,2),(75746423,894259748,1,3),(75746424,894259700,1,1),(75746424,894259318,1,2),(75746424,894259503,1,3),(75871448,895601493,2,1),(75871448,897596948,2,2),(75871448,895601497,2,3),(77918991,915765650,1,1),(77918991,915765239,1,2),(77918991,915765686,1,3),(77918991,915766458,1,4),(77918991,915766750,1,5),(77918991,915766344,1,6),(77918991,915766632,1,7),(77918991,915765922,1,8),(77918991,915766135,1,9),(77918991,915765801,1,10),(77918991,915766018,1,11),(77918991,915764943,1,12),(77918991,915765496,1,13),(77918991,915766737,1,14),(77918991,915765201,1,15),(77918991,915766227,1,16),(77918991,915766445,1,17),(77918991,915766604,1,18),(77918991,915766830,1,19),(77918991,915766108,1,20),(77918991,915766317,1,21),(77918991,915765994,1,22),(77918991,915766204,1,23),(77918991,915765418,1,24),(77918991,915765778,1,25),(77918991,915765142,1,26),(77918991,915765630,1,27),(77918991,915766418,1,28),(77918991,915766711,1,29),(77918991,915765885,1,30),(77918991,915766099,1,31),(77918991,915765906,1,32),(79126612,924524128,1,1),(79126612,894258985,1,2);
INSERT INTO `way_tags` VALUES (6165450,'created_by','Potlatch 0.10',11),(6165450,'highway','primary',11),(6165450,'junction','roundabout',11),(6165679,'admin_level','2',18),(6165679,'border_type','nation',18),(6165679,'boundary','administrative',18),(6165679,'left:country','Andorra',18),(6165679,'name','ES, FR',18),(6165679,'right:country','Spain',18),(6165679,'source','CIA World Database II',18),(6165877,'highway','primary',7),(6165877,'maxspeed','60',7),(6165877,'ref','CG-2',7),(6165877,'source','yahoo',7),(6165944,'created_by','Potlatch 0.9c',12),(6165944,'highway','primary',12),(6165944,'ref','CG-2',12),(6165944,'source','yahoo',12),(6166082,'created_by','Potlatch 0.9c',9),(6166082,'highway','primary',9),(6166082,'ref','CG-2',9),(6166082,'source','yahoo',9),(6166123,'created_by','Potlatch 0.9c',7),(6166123,'highway','primary',7),(6166123,'ref','CG-2',7),(6166123,'source','yahoo',7),(6166128,'created_by','Potlatch 0.9a',4),(6166128,'highway','primary',4),(6166128,'ref','CG-2',4),(6166128,'source','yahoo',4),(6166136,'highway','primary',4),(6166136,'junction','roundabout',4),(6166145,'created_by','Potlatch 0.9a',4),(6166145,'highway','primary',4),(6166145,'ref','CG-2',4),(6166145,'source','yahoo',4),(6166185,'created_by','Potlatch 0.9a',6),(6166185,'highway','primary',6),(6166185,'ref','CG-2',6),(6166185,'source','yahoo',6),(6176624,'highway','primary',6),(6176624,'oneway','yes',6),(6176663,'highway','primary',3),(6176663,'junction','roundabout',3),(6176681,'highway','primary',5),(6176681,'ref','CG-2',5),(6176681,'source','yahoo',5),(6176681,'toll','yes',5),(6176755,'highway','primary',13),(6176755,'layer','-1',13),(6176755,'name','Túnel d\' Envalira',13),(6176755,'ref','CG-2',13),(6176755,'source','yahoo and guess',13),(6176755,'toll','yes',13),(6176755,'tunnel','yes',13),(6177152,'created_by','Potlatch 0.9a',8),(6177152,'highway','primary',8),(6177152,'oneway','yes',8),(6177152,'ref','CG-2',8),(6177152,'source','yahoo',8),(6177369,'created_by','Potlatch 0.9a',5),(6177369,'highway','primary',5),(6177369,'ref','CG-2',5),(6177369,'source','yahoo',5),(6177399,'created_by','Potlatch 0.9a',6),(6177399,'highway','primary',6),(6177399,'ref','CG-2',6),(6177399,'source','yahoo',6),(6177409,'created_by','Potlatch 0.8c',4),(6177409,'highway','primary',4),(6177409,'ref','CG-2',4),(6177409,'source','yahoo',4),(6178503,'created_by','Potlatch 0.9a',7),(6178503,'highway','primary',7),(6178503,'oneway','yes',7),(6178503,'ref','CG-2',7),(6178503,'source','yahoo',7),(6178632,'created_by','Potlatch 0.9a',6),(6178632,'highway','primary',6),(6178632,'ref','CG-2',6),(6178632,'source','yahoo',6),(6178685,'created_by','Potlatch 0.9a',6),(6178685,'highway','primary',6),(6178685,'oneway','yes',6),(6178685,'ref','CG-2',6),(6178685,'source','yahoo',6),(6178688,'created_by','Potlatch 0.9a',5),(6178688,'highway','primary',5),(6178688,'oneway','yes',5),(6178688,'ref','CG-2',5),(6178688,'source','yahoo',5),(6178694,'highway','primary',5),(6178694,'ref','CG-2',5),(6178694,'source','yahoo',5),(6178791,'created_by','Potlatch 0.9a',4),(6178791,'highway','primary',4),(6178791,'ref','CG-2',4),(6178791,'source','yahoo',4),(6178964,'leisure','pitch',2),(6178964,'sport','soccer',2),(6178980,'created_by','Potlatch 0.8a',3),(6178980,'leisure','pitch',3),(6178980,'sport','tennis',3),(6179103,'highway','primary',5),(6179103,'ref','CG-2',5),(6179103,'source','yahoo',5),(6179174,'created_by','Potlatch 0.9a',5),(6179174,'highway','primary',5),(6179174,'oneway','yes',5),(6179174,'ref','CG-2',5),(6179174,'source','yahoo',5),(6179240,'created_by','Potlatch 0.9c',4),(6179240,'highway','primary',4),(6179240,'junction','roundabout',4),(6179270,'bridge','yes',4),(6179270,'created_by','Potlatch 0.9a',4),(6179270,'highway','primary',4),(6179270,'layer','3',4),(6179270,'ref','CG-2',4),(6179270,'source','yahoo',4),(6179470,'layer','1',2),(6179470,'leisure','pitch',2),(6179470,'sport','soccer',2),(6179561,'created_by','Potlatch 0.8a',2),(6179561,'leisure','track',2),(6179561,'sport','athletics',2),(6179675,'highway','primary',9),(6179675,'ref','CG-2',9),(6179675,'source','yahoo',9),(6179692,'created_by','Potlatch 0.10',6),(6179692,'highway','primary',6),(6179692,'lanes','3',6),(6179692,'ref','CG-2',6),(6179692,'source','yahoo',6),(6180790,'created_by','Potlatch 0.10',8),(6180790,'highway','primary',8),(6180790,'oneway','yes',8),(6180790,'ref','CG-1',8),(6180790,'source','yahoo',8),(6180839,'bridge','yes',3),(6180839,'created_by','Potlatch alpha',3),(6180839,'highway','primary',3),(6180839,'layer','3',3),(6180839,'ref','CG-2',3),(6180839,'source','yahoo',3),(6180840,'highway','primary',3),(6180840,'ref','CG-1',3),(6180840,'source','yahoo',3),(6180852,'created_by','Potlatch 0.10',4),(6180852,'highway','primary',4),(6180852,'ref','CG-1',4),(6180852,'source','yahoo',4),(6180968,'highway','primary',12),(6180968,'ref','CG-2',12),(6180968,'source','yahoo',12),(6180977,'created_by','Potlatch 0.9c',3),(6180977,'highway','primary',3),(6180977,'ref','CG-2',3),(6180977,'source','yahoo',3),(6180985,'created_by','Potlatch 0.9c',5),(6180985,'highway','primary',5),(6180985,'ref','CG-2',5),(6180985,'source','yahoo',5),(6180988,'created_by','Potlatch 0.9a',4),(6180988,'highway','primary',4),(6180988,'ref','CG-2',4),(6180988,'source','yahoo',4),(6181319,'created_by','Potlatch alpha',2),(6181319,'highway','secondary',2),(6181319,'name','Carrer de Sant Jordi',2),(6181357,'created_by','Potlatch alpha',3),(6181357,'highway','residential',3),(6181357,'name','Carrer Solana',3),(6181419,'created_by','Potlatch alpha',2),(6181419,'highway','service',2),(6181836,'highway','secondary',3),(6181838,'created_by','Potlatch 0.8c',8),(6181838,'highway','secondary',8),(6181838,'ref','CS-280',8),(6181947,'boat','no',2),(6181947,'created_by','Potlatch 0.8a',2),(6181947,'waterway','stream',2),(6182051,'created_by','Potlatch 0.10f',4),(6182051,'highway','tertiary',4),(6182051,'name','Carrer Bonaventura Riberaygua',4),(6182051,'oneway','yes',4),(6182051,'source','yahoo',4),(6182052,'FIXME','Missing name',4),(6182052,'highway','residential',4),(6182052,'name','Carrer de Joan Maragall',4),(6182052,'source','yahoo',4),(6182053,'created_by','Potlatch 0.9c',3),(6182053,'highway','residential',3),(6182053,'name','Carrer Pere d\'Urg',3),(6182053,'source','yahoo',3),(6182054,'FIXME','Missing name',2),(6182054,'highway','residential',2),(6182054,'source','yahoo',2),(6182056,'created_by','Potlatch 0.9c',3),(6182056,'highway','residential',3),(6182056,'name','Carrer de la Borda',3),(6182056,'source','yahoo',3),(6182057,'created_by','Potlatch 0.9c',4),(6182057,'highway','pedestrian',4),(6182057,'name','Carrer de l\'Aigüeta',4),(6182057,'source','yahoo',4),(6182058,'created_by','Potlatch 0.9c',3),(6182058,'highway','tertiary',3),(6182058,'name','Carrer de la Sardana',3),(6182058,'source','yahoo',3),(6182065,'created_by','Potlatch 0.10f',4),(6182065,'highway','tertiary',4),(6182065,'name','Carrer Verge del Pilar',4),(6182065,'oneway','yes',4),(6182097,'highway','secondary',7),(6182097,'name','Avinguda Meritxell',7),(6182097,'oneway','yes',7),(6182122,'highway','tertiary',9),(6182122,'name','Carrer de la Constituciò',9),(6182122,'source','survey',9),(6182127,'created_by','Potlatch 0.10f',3),(6182127,'highway','tertiary',3),(6182127,'name','Carrer Ciutat de Sabadell',3),(6182127,'source','yahoo',3),(6182159,'highway','secondary',5),(6182159,'name','Avinguda de les Escoles',5),(6182159,'source','survey',5),(6182267,'FIXME','Missing name',3),(6182267,'highway','residential',3),(6182267,'source','yahoo',3),(6182278,'highway','secondary',4),(6182278,'junction','roundabout',4),(6182278,'source','yahoo',4),(6182289,'created_by','Potlatch 0.9c',3),(6182289,'highway','secondary',3),(6182289,'name','Baixada del molí',3),(6182303,'created_by','Potlatch 0.10f',3),(6182303,'highway','primary',3),(6182303,'name','Avinguda Prat de la Creu',3),(6182303,'ref','CG3a',3),(6182333,'highway','primary',5),(6182333,'junction','roundabout',5),(6182333,'source','yahoo',5),(6182349,'created_by','Potlatch 0.9c',2),(6182349,'highway','tertiary',2),(6182349,'name','Carrer Doctor Vilanova',2),(6182349,'source','yahoo',2),(6182350,'bridge','yes',3),(6182350,'created_by','Potlatch 0.9c',3),(6182350,'highway','tertiary',3),(6182350,'layer','1',3),(6182350,'name','Carrer Doctor Vilanova',3),(6182350,'source','yahoo',3),(6182364,'created_by','Potlatch 0.9c',13),(6182364,'highway','primary',13),(6182364,'name','Avinguda Consell d\'Europa',13),(6182364,'oneway','yes',13),(6182364,'source','yahoo',13),(6182371,'created_by','Potlatch 0.9c',11),(6182371,'highway','primary',11),(6182371,'name','Avinguda Fiter i Rossell',11),(6182371,'oneway','yes',11),(6182371,'ref','CG-3a',11),(6182371,'source','yahoo',11),(6182386,'created_by','Potlatch 0.9c',4),(6182386,'highway','tertiary',4),(6182386,'name','Carrer Pau Casals',4),(6182386,'source','survey',4),(6182401,'created_by','Potlatch 0.10f',5),(6182401,'highway','tertiary',5),(6182401,'name','Carrer Josep Rossell i Calva',5),(6182401,'source','yahoo',5),(6182410,'highway','primary',12),(6182410,'junction','roundabout',12),(6182410,'layer','2',12),(6182463,'FIXME','Missing name',6),(6182463,'highway','residential',6),(6182463,'source','yahoo',6),(6182505,'highway','primary',4),(6182505,'junction','roundabout',4),(6182542,'created_by','Potlatch 0.8a',8),(6182542,'highway','primary',8),(6182542,'layer','2',8),(6182542,'oneway','yes',8),(6182542,'ref','CG3i4',8),(6182542,'source','yahoo',8),(6182577,'FIXME','Missing name',2),(6182577,'highway','residential',2),(6182577,'source','yahoo',2),(6182675,'FIXME','Missing name',2),(6182675,'highway','residential',2),(6182675,'source','yahoo',2),(6182714,'FIXME','Missing name',2),(6182714,'highway','residential',2),(6182714,'source','yahoo',2),(6182761,'highway','primary_link',9),(6182761,'layer','2',9),(6182761,'oneway','yes',9),(6182761,'source','yahoo',9),(6182765,'created_by','Potlatch 0.9a',3),(6182765,'highway','primary_link',3),(6182765,'source','yahoo',3),(6182771,'created_by','Potlatch 0.9c',2),(6182771,'highway','tertiary',2),(6182771,'name','Carrer Sant Antoni',2),(6182771,'oneway','yes',2),(6182771,'source','yahoo',2),(6182773,'created_by','Potlatch 0.9c',3),(6182773,'highway','tertiary',3),(6182773,'name','Carrer Isabelle Sandy',3),(6182773,'oneway','yes',3),(6182773,'source','yahoo',3),(6182798,'created_by','Potlatch 0.10f',3),(6182798,'highway','residential',3),(6182798,'name','Carrer Ciutat de Consuegra',3),(6182798,'oneway','yes',3),(6182798,'source','yahoo',3),(6182810,'created_by','Potlatch 0.9c',2),(6182810,'highway','residential',2),(6182810,'name','Carrer Callueta',2),(6182810,'source','yahoo',2),(6182844,'amenity','parking',1),(6182844,'created_by','Potlatch alpha',1),(6182932,'created_by','Potlatch alpha',4),(6182932,'highway','secondary',4),(6182932,'ref','CS-101',4),(6183078,'FIXME','Missing name',2),(6183078,'highway','residential',2),(6183100,'highway','secondary',7),(6183100,'name','Carretera d\'Engolasters',7),(6183100,'ref','CS-200',7),(6183127,'FIXME','Missing name',2),(6183127,'highway','residential',2),(6183169,'created_by','Potlatch 0.10d',2),(6183169,'highway','secondary',2),(6183169,'name','Carretera de la Comella',2),(6183169,'ref','CS-101',2),(6183270,'FIXME','Missing name',2),(6183270,'highway','residential',2),(6183273,'FIXME','Missing name',3),(6183273,'highway','residential',3),(6183357,'FIXME','Missing name',2),(6183357,'highway','residential',2),(6183360,'FIXME','Missing name',2),(6183360,'highway','residential',2),(6183573,'FIXME','Missing name',2),(6183573,'highway','residential',2),(6184947,'amenity','parking',1),(6184947,'created_by','Potlatch alpha',1),(6185032,'created_by','Potlatch 0.10',3),(6185032,'highway','tertiary',3),(6185032,'name','Carrer Prat Salit',3),(6185060,'FIXME','Missing name',2),(6185060,'highway','residential',2),(6185090,'FIXME','Missing name',2),(6185090,'highway','residential',2),(6185110,'created_by','Potlatch 0.10f',7),(6185110,'highway','unclassified',7),(6185110,'name','Carrer Bonnavista',7),(6185122,'created_by','Potlatch 0.10',11),(6185122,'highway','unclassified',11),(6185122,'name','Carrer Castellà de Sucarà',11),(6185149,'FIXME','Missing name',2),(6185149,'highway','residential',2),(6185336,'access','permissive',3),(6185336,'created_by','Potlatch 0.10',3),(6185336,'highway','primary',3),(6185336,'oneway','yes',3),(6185336,'ref','CG-2',3),(6185336,'source','yahoo',3),(6185353,'FIXME','Missing name',3),(6185353,'highway','residential',3),(6185363,'FIXME','Missing name',2),(6185363,'highway','residential',2),(6185394,'created_by','Potlatch 0.9c',2),(6185394,'highway','residential',2),(6185394,'name','Carrer Esteve Dolsa Pujol',2),(6185394,'source','yahoo',2),(6185421,'created_by','Potlatch 0.9a',2),(6185421,'highway','residential',2),(6185421,'name','Carrer Fiter i Rossell',2),(6185589,'created_by','Potlatch 0.9c',2),(6185589,'highway','residential',2),(6185589,'name','Carrer de l\'Alzinaret',2),(6185589,'source','yahoo',2),(6185611,'created_by','Potlatch 0.9c',3),(6185611,'highway','residential',3),(6185611,'name','Carrer del Carubell',3),(6185611,'source','yahoo',3),(6185640,'FIXME','Missing name',3),(6185640,'highway','residential',3),(6185640,'name','Carrer del Doctor Molines',3),(6185640,'source','yahoo',3),(6185710,'amenity','parking',1),(6185710,'created_by','Potlatch alpha',1),(6185726,'created_by','Potlatch 0.9c',4),(6185726,'highway','tertiary',4),(6185726,'name','Carrer Sant Andreu',4),(6185726,'source','yahoo',4),(6185775,'created_by','Potlatch 0.9c',3),(6185775,'highway','tertiary',3),(6185775,'name','Carrer Maria Plà',3),(6185775,'oneway','yes',3),(6185775,'source','yahoo',3),(6185795,'FIXME','Missing name',2),(6185795,'highway','residential',2),(6185795,'source','yahoo',2),(6185800,'created_by','Potlatch 0.10f',13),(6185800,'highway','secondary',13),(6185800,'name','Avinguda Carlemany',13),(6185800,'oneway','yes',13),(6185800,'source','yahoo',13),(6185807,'created_by','Potlatch 0.10f',4),(6185807,'highway','secondary',4),(6185807,'name','Avinguda Carlemany',4),(6185807,'oneway','yes',4),(6185807,'source','yahoo',4),(6185826,'created_by','Potlatch 0.9c',9),(6185826,'highway','tertiary',9),(6185826,'name','Carrer Prat Gran',9),(6185826,'source','survey',9),(6185878,'created_by','Potlatch 0.9c',8),(6185878,'highway','tertiary',8),(6185878,'name','Carrer de Parnal',8),(6185878,'source','survey',8),(6185911,'FIXME','Missing name',2),(6185911,'highway','residential',2),(6185911,'source','yahoo',2),(6185926,'FIXME','Missing name',2),(6185926,'highway','residential',2),(6185926,'source','yahoo',2),(6185930,'FIXME','Missing name',2),(6185930,'highway','residential',2),(6185930,'source','yahoo',2),(6185971,'created_by','Potlatch 0.9a',5),(6185971,'highway','primary',5),(6185971,'ref','CG-2',5),(6185971,'source','yahoo',5),(6185986,'FIXME','Missing name',8),(6185986,'highway','secondary',8),(6185986,'ref','FIXME',8),(6185986,'source','yahoo',8),(6185988,'created_by','Potlatch 0.9c',5),(6185988,'highway','primary',5),(6185988,'ref','CG-2',5),(6185988,'source','yahoo',5),(6186037,'highway','primary',10),(6186037,'junction','roundabout',10),(6186094,'FIXME','Missing name',2),(6186094,'highway','residential',2),(6195793,'created_by','Potlatch 0.8c',6),(6195793,'highway','primary',6),(6195793,'layer','-1',6),(6195793,'name','Avinguda Sant Antoni',6),(6195793,'oneway','yes',6),(6195793,'ref','CG-3',6),(6195793,'tunnel','yes',6),(6195794,'created_by','Potlatch 0.8a',6),(6195794,'highway','primary',6),(6195794,'oneway','yes',6),(6195794,'ref','CG3i4',6),(6195795,'FIXME','Missing name',2),(6195795,'highway','residential',2),(6195796,'FIXME','Missing name',2),(6195796,'highway','residential',2),(6195797,'FIXME','Missing name',2),(6195797,'highway','residential',2),(6195885,'created_by','Potlatch 0.8a',2),(6195885,'highway','primary',2),(6195885,'junction','roundabout',2),(6196087,'created_by','Potlatch 0.8a',6),(6196087,'highway','primary',6),(6196087,'ref','CG-4',6),(6196407,'created_by','Potlatch 0.10b',8),(6196407,'highway','primary',8),(6196407,'ref','CG-4',8),(6197719,'created_by','Potlatch 0.8a',5),(6197719,'highway','primary',5),(6197719,'oneway','yes',5),(6197719,'source','yahoo',5),(6197721,'highway','primary',17),(6197721,'ref','CG-3',17),(6197721,'source','yahoo',17),(6197723,'created_by','Potlatch 0.9a',4),(6197723,'highway','primary',4),(6197723,'junction','roundabout',4),(6197727,'bridge','yes',18),(6197727,'created_by','Potlatch 0.10',18),(6197727,'highway','primary',18),(6197727,'layer','1',18),(6197727,'name','Travessia d\'Ordino',18),(6197727,'ref','CG-3',18),(6197727,'source','user 3ld',18),(6198025,'created_by','Potlatch 0.9a',7),(6198025,'highway','secondary',7),(6198025,'junction','roundabout',7),(6198027,'created_by','Potlatch 0.9a',4),(6198027,'highway','secondary',4),(6198027,'ref','CS-340',4),(6198139,'created_by','Potlatch 0.9a',4),(6198139,'highway','secondary',4),(6198139,'ref','CS-340',4),(6225803,'created_by','Potlatch 0.9a',14),(6225803,'highway','secondary',14),(6225803,'name','Carretera Coll d\'Ordino',14),(6225803,'ref','CS-340',14),(6225812,'access','private',2),(6225812,'created_by','Potlatch 0.9a',2),(6225812,'highway','residential',2),(6227096,'highway','primary',6),(6227096,'name','Carretera General',6),(6227096,'ref','CG-3',6),(6227097,'highway','primary',6),(6227097,'layer','-1',6),(6227097,'name','Carretera General',6),(6227097,'ref','CG-3',6),(6227097,'tunnel','yes',6),(6228283,'created_by','Potlatch 0.10b',2),(6228283,'highway','secondary',2),(6228283,'ref','CS-220',2),(6230227,'FIXME','Missing name',2),(6230227,'highway','residential',2),(6230228,'bridge','yes',3),(6230228,'FIXME','Missing name',3),(6230228,'highway','residential',3),(6230228,'layer','2',3),(6230229,'FIXME','Missing name',2),(6230229,'highway','residential',2),(6230231,'created_by','Potlatch 0.10',4),(6230231,'highway','primary',4),(6230231,'ref','CG-6',4),(6230231,'source','yahoo',4),(6230232,'FIXME','Missing name',3),(6230232,'highway','primary',3),(6230232,'ref','CG-6',3),(6230233,'leisure','pitch',2),(6230233,'sport','soccer',2),(6230234,'FIXME','Missing name',3),(6230234,'highway','residential',3),(6242742,'created_by','Potlatch 0.9',2),(6242742,'waterway','stream',2),(6242747,'boat','no',12),(6242747,'created_by','Potlatch 0.9c',12),(6242747,'history','Retrieved from v3',12),(6242747,'name','Valira del Nord',12),(6242747,'waterway','river',12),(6242753,'boat','no',16),(6242753,'created_by','Potlatch 0.9c',16),(6242753,'name:ca','Riu d\'Arinsal',16),(6242753,'waterway','river',16),(6242756,'created_by','Potlatch 0.8c',6),(6242756,'highway','primary',6),(6242756,'layer','-1',6),(6242756,'name','Avinguda Sant Antoni',6),(6242756,'oneway','yes',6),(6242756,'ref','CG-3',6),(6242756,'tunnel','yes',6),(6242757,'created_by','Potlatch 0.8a',4),(6242757,'highway','primary',4),(6242757,'oneway','yes',4),(6242757,'ref','CG3i4',4),(6242759,'created_by','Potlatch 0.8a',6),(6242759,'highway','primary',6),(6242759,'layer','2',6),(6242759,'oneway','yes',6),(6242759,'ref','CG3i4',6),(6242759,'source','yahoo',6),(6244541,'created_by','Potlatch 0.9c',4),(6244541,'highway','secondary',4),(6244541,'ref','CS-413',4),(6244542,'created_by','JOSM',1),(6244542,'source','yahoo',1),(6244542,'waterway','stream',1),(6244545,'created_by','JOSM',1),(6244545,'waterway','stream',1),(6244550,'FIXME','Missing name',3),(6244550,'highway','residential',3),(6244550,'source','Yahoo and guess',3),(6244551,'FIXME','Missing name',2),(6244551,'highway','residential',2),(6244551,'source','YAHOO',2),(6244552,'bridge','yes',5),(6244552,'FIXME','Missing name',5),(6244552,'highway','residential',5),(6244552,'layer','1',5),(6244554,'FIXME','Missing name',2),(6244554,'highway','residential',2),(6244554,'source','YAHOO',2),(6244556,'FIXME','Missing name',2),(6244556,'highway','residential',2),(6244556,'source','yahoo',2),(6244558,'bridge','yes',4),(6244558,'FIXME','Missing name',4),(6244558,'highway','residential',4),(6244558,'layer','1',4),(6244561,'FIXME','Missing name',2),(6244561,'highway','residential',2),(6244561,'source','YAHOO',2),(6244562,'FIXME','Missing name',2),(6244562,'highway','residential',2),(6244562,'source','YAHOO',2),(6244759,'FIXME','Missing name',2),(6244759,'highway','residential',2),(6244763,'FIXME','Missing name',2),(6244763,'highway','residential',2),(6247260,'FIXME','Missing name',2),(6247260,'highway','secondary',2),(6247260,'oneway','true',2),(6247267,'FIXME','Missing name',2),(6247267,'highway','secondary',2),(6247267,'oneway','true',2),(6247268,'highway','primary',4),(6247268,'ref','CG-1',4),(6247269,'highway','primary_link',3),(6247269,'oneway','yes',3),(6247270,'highway','primary_link',3),(6247270,'junction','roundabout',3),(6247271,'highway','primary_link',3),(6247271,'oneway','yes',3),(6247273,'highway','primary_link',3),(6247273,'oneway','yes',3),(6247274,'FIXME','Missing name',2),(6247274,'highway','secondary',2),(6247274,'oneway','true',2),(6247278,'FIXME','Missing name',2),(6247278,'highway','residential',2),(6247279,'created_by','Potlatch 0.10f',2),(6247279,'highway','secondary',2),(6247279,'name','Carretera de la Rabassa',2),(6247279,'ref','CS-131',2),(6247280,'FIXME','Missing name',2),(6247280,'highway','residential',2),(6247282,'alt_name','Camì d\'Aubinya',2),(6247282,'created_by','Potlatch 0.10f',2),(6247282,'highway','residential',2),(6247282,'name','Camì d\'Auvinya',2),(6247283,'FIXME','Missing name',2),(6247283,'highway','residential',2),(6247284,'FIXME','Missing name',2),(6247284,'highway','residential',2),(6247285,'FIXME','Missing name',2),(6247285,'highway','residential',2),(6247286,'FIXME','Missing name',2),(6247286,'highway','residential',2),(6247287,'FIXME','Missing name',2),(6247287,'highway','residential',2),(6247288,'FIXME','Missing name',2),(6247288,'highway','residential',2),(6247289,'FIXME','Missing name',2),(6247289,'highway','residential',2),(6247289,'source','YAHOO',2),(6247290,'FIXME','Missing name',2),(6247290,'highway','residential',2),(6247291,'FIXME','Missing name',2),(6247291,'highway','residential',2),(6247292,'FIXME','Missing name',2),(6247292,'highway','residential',2),(6247294,'FIXME','Missing name',2),(6247294,'highway','residential',2),(6247294,'source','YAHOO',2),(6247295,'FIXME','Missing name',2),(6247295,'highway','residential',2),(6247296,'FIXME','Missing name',2),(6247296,'highway','residential',2),(6248150,'FIXME','Missing name',2),(6248150,'highway','residential',2),(6248151,'FIXME','Missing name',2),(6248151,'highway','residential',2),(6248455,'FIXME','Missing name',2),(6248455,'highway','residential',2),(6248456,'FIXME','Missing name',2),(6248456,'highway','residential',2),(6248456,'source','YAHOO',2),(6248458,'FIXME','Missing name',2),(6248458,'highway','residential',2),(6248458,'source','YAHOO',2),(6248459,'FIXME','Missing name',2),(6248459,'highway','residential',2),(6248459,'source','yahoo',2),(6248460,'FIXME','Missing name',2),(6248460,'highway','residential',2),(6248460,'source','yahoo',2),(6248461,'FIXME','Missing name',2),(6248461,'highway','residential',2),(6248461,'source','yahoo',2),(6248462,'FIXME','Missing name',2),(6248462,'highway','residential',2),(6248462,'source','yahoo',2),(6248463,'FIXME','Missing name',2),(6248463,'highway','residential',2),(6248463,'source','yahoo',2),(6248464,'FIXME','Missing name',2),(6248464,'highway','residential',2),(6248464,'source','yahoo',2),(6248467,'FIXME','Missing name',2),(6248467,'highway','residential',2),(6248467,'source','yahoo',2),(6248468,'FIXME','Missing name',2),(6248468,'highway','residential',2),(6248468,'source','YAHOO',2),(6248469,'FIXME','Missing name',2),(6248469,'highway','residential',2),(6248469,'source','YAHOO',2),(6249800,'FIXME','Missing name',2),(6249800,'highway','secondary',2),(6249800,'source','YAHOO',2),(6249802,'FIXME','Missing name',2),(6249802,'highway','residential',2),(6249802,'source','YAHOO',2),(6249803,'FIXME','Missing name',2),(6249803,'highway','residential',2),(6249803,'source','yahoo',2),(6250052,'FIXME','Missing name',2),(6250052,'highway','residential',2),(6250052,'source','yahoo',2),(6250053,'FIXME','Missing name',2),(6250053,'highway','residential',2),(6250053,'source','yahoo',2),(6250055,'FIXME','Missing name',2),(6250055,'highway','residential',2),(6250055,'source','yahoo',2),(6250056,'FIXME','Missing name',2),(6250056,'highway','residential',2),(6250056,'source','yahoo',2),(6250057,'FIXME','Missing name',2),(6250057,'highway','residential',2),(6250057,'source','yahoo',2),(6250105,'FIXME','Missing name',2),(6250105,'highway','residential',2),(6250105,'source','yahoo',2),(6250238,'FIXME','Missing name',2),(6250238,'highway','residential',2),(6250238,'source','yahoo',2),(6250239,'FIXME','Missing name',2),(6250239,'highway','residential',2),(6250239,'source','yahoo',2),(6250280,'FIXME','Missing name',2),(6250280,'highway','residential',2),(6250280,'source','yahoo',2),(6267429,'FIXME','Missing name',2),(6267429,'highway','residential',2),(6267881,'bridge','yes',4),(6267881,'highway','secondary',4),(6267881,'layer','1',4),(6267881,'name','Carretera de Fontaneda',4),(6267881,'ref','CS-140',4),(6267882,'FIXME','Missing name',3),(6267882,'highway','secondary',3),(6267882,'name','Carretera de Fontaneda',3),(6267882,'ref','CS-140',3),(6267882,'source','yahoo',3),(6267884,'FIXME','Missing name',2),(6267884,'highway','residential',2),(6268924,'FIXME','Missing name',2),(6268924,'highway','secondary',2),(6268924,'ref','fixme',2),(6269464,'FIXME','Missing name',2),(6269464,'source','yahoo',2),(6269464,'waterway','river',2),(6275494,'FIXME','Missing name',3),(6275494,'highway','secondary',3),(6275494,'source','yahoo',3),(6275497,'FIXME','Missing name',2),(6275497,'highway','secondary',2),(6275497,'source','YAHOO',2),(6275498,'FIXME','Missing name',2),(6275498,'highway','residential',2),(6275498,'source','yahoo',2),(6275499,'FIXME','Missing name',2),(6275499,'highway','residential',2),(6275499,'source','yahoo',2),(6275501,'highway','primary',8),(6275501,'name','Avinguda de Tarragona',8),(6275501,'ref','CG-2',8),(6275501,'source','yahoo',8),(6275503,'amenity','parking',1),(6275503,'created_by','JOSM',1),(6275504,'highway','primary',6),(6275504,'junction','roundabout',6),(6275505,'created_by','Potlatch 0.10f',6),(6275505,'highway','primary',6),(6275505,'name','Avinguda de Tarragona',6),(6275505,'ref','CG-2',6),(6275505,'source','yahoo',6),(6275506,'highway','primary',4),(6275506,'junction','roundabout',4),(6275507,'leisure','park',4),(6275507,'name','Parc Central',4),(6275509,'created_by','Potlatch 0.10f',3),(6275509,'highway','tertiary',3),(6275509,'name','Carrer Maria Plà',3),(6275509,'oneway','yes',3),(6275509,'source','yahoo',3),(6275510,'highway','residential',4),(6275510,'junction','roundabout',4),(6275512,'FIXME','Missing name',5),(6275512,'highway','residential',5),(6275512,'oneway','yes',5),(6275513,'created_by','Potlatch 0.10f',4),(6275513,'highway','tertiary',4),(6275513,'name','Avinguda del Fener',4),(6275513,'oneway','yes',4),(6275514,'highway','residential',3),(6275514,'name','Carrer Prada Casadet',3),(6275516,'created_by','Potlatch 0.10f',3),(6275516,'highway','residential',3),(6275516,'name','Carrer de la Grau',3),(6275516,'source','yahoo',3),(6275517,'created_by','JOSM',2),(6275517,'natural','wood',2),(6275518,'natural','wood',4),(6275522,'created_by','Potlatch alpha',2),(6275522,'natural','wood',2),(6275851,'FIXME','Missing name',2),(6275851,'highway','residential',2),(6276661,'created_by','Potlatch 0.10',4),(6276661,'natural','wood',4),(6277172,'created_by','JOSM',1),(6277172,'natural','wood',1),(6277173,'created_by','JOSM',1),(6277173,'natural','wood',1),(6279235,'created_by','JOSM',1),(6279235,'natural','wood',1),(6281014,'FIXME','Missing name',2),(6281014,'highway','secondary',2),(6281014,'source','yahoo',2),(6281015,'created_by','Potlatch 0.8a',2),(6281015,'waterway','stream',2),(6281016,'FIXME','Missing name',3),(6281016,'highway','secondary',3),(6281016,'source','yahoo',3),(6281017,'FIXME','Missing name',2),(6281017,'highway','residential',2),(6281018,'FIXME','Missing name',2),(6281018,'highway','residential',2),(6281019,'FIXME','Missing name',3),(6281019,'highway','secondary',3),(6281019,'source','yahoo',3),(6281020,'bridge','yes',3),(6281020,'FIXME','Missing name',3),(6281020,'highway','secondary',3),(6281020,'layer','1',3),(6281020,'source','yahoo',3),(6281021,'FIXME','Missing name',2),(6281021,'highway','secondary',2),(6281021,'source','yahoo',2),(6281022,'bridge','yes',3),(6281022,'FIXME','Missing name',3),(6281022,'highway','secondary',3),(6281022,'layer','1',3),(6281022,'source','yahoo',3),(6281358,'created_by','Potlatch 0.8b',4),(6281358,'highway','secondary',4),(6281358,'ref','CS-270',4),(6281358,'source','GPS survey',4),(6281360,'FIXME','Missing name',2),(6281360,'highway','residential',2),(6281361,'FIXME','Missing name',2),(6281361,'highway','secondary',2),(6281361,'source','yahoo',2),(6281741,'FIXME','Missing name',2),(6281741,'highway','residential',2),(6281751,'created_by','Potlatch 0.8a',2),(6281751,'waterway','stream',2),(6281774,'created_by','JOSM',1),(6281774,'waterway','stream',1),(6281908,'FIXME','Missing name',2),(6281908,'highway','residential',2),(6281909,'FIXME','Missing name',2),(6281909,'highway','residential',2),(6281910,'FIXME','Missing name',2),(6281910,'highway','residential',2),(6281910,'source','yahoo',2),(6281916,'FIXME','Missing name',2),(6281916,'highway','residential',2),(6281916,'source','yahoo',2),(6282443,'FIXME','Missing name',4),(6282443,'highway','residential',4),(6282444,'FIXME','Missing name',2),(6282444,'highway','residential',2),(6282445,'FIXME','Missing name',3),(6282445,'highway','residential',3),(6282446,'FIXME','Missing name',2),(6282446,'highway','residential',2),(6282447,'FIXME','Missing name',2),(6282447,'highway','residential',2),(6282448,'FIXME','Missing name',2),(6282448,'highway','residential',2),(6282449,'FIXME','Missing name',3),(6282449,'highway','residential',3),(6282450,'FIXME','Missing name',2),(6282450,'highway','residential',2),(6282451,'FIXME','Missing name',2),(6282451,'highway','residential',2),(6282452,'FIXME','Missing name',2),(6282452,'highway','residential',2),(6541502,'name','Río Valira',3),(6541502,'waterway','river',3),(6541505,'created_by','Potlatch 0.9c',7),(6541505,'highway','primary',7),(6541505,'ref','CG-2',7),(6541505,'source','yahoo',7),(6541507,'bridge','yes',5),(6541507,'created_by','Potlatch 0.8c',5),(6541507,'highway','primary',5),(6541507,'layer','1',5),(6541507,'ref','CG-2',5),(6541507,'source','yahoo',5),(6541510,'created_by','JOSM',2),(6541510,'natural','water',2),(6541514,'FIXME','Missing name',2),(6541514,'highway','residential',2),(6541518,'FIXME','Missing name',2),(6541518,'highway','residential',2),(6541520,'bridge','yes',4),(6541520,'FIXME','Missing name',4),(6541520,'highway','residential',4),(6541520,'layer','1',4),(6541522,'FIXME','Missing name',2),(6541522,'highway','residential',2),(6541525,'FIXME','Missing name',2),(6541525,'highway','residential',2),(6541538,'name','Río Valira',6),(6541538,'waterway','river',6),(6541541,'FIXME','Missing name',4),(6541541,'highway','residential',4),(6548812,'FIXME','Missing name',2),(6548812,'highway','residential',2),(6548814,'FIXME','Missing name',2),(6548814,'highway','residential',2),(6548816,'FIXME','Missing name',2),(6548816,'highway','residential',2),(6548818,'FIXME','Missing name',2),(6548818,'highway','residential',2),(6548820,'highway','primary',4),(6548820,'junction','roundabout',4),(6548822,'FIXME','Missing name',2),(6548822,'highway','residential',2),(6548824,'bridge','yes',3),(6548824,'FIXME','Missing name',3),(6548824,'highway','residential',3),(6548824,'layer','2',3),(6548826,'FIXME','Missing name',3),(6548826,'highway','residential',3),(6551314,'FIXME','Missing name',4),(6551314,'highway','residential',4),(6551317,'bridge','true',4),(6551317,'created_by','Potlatch 0.9a',4),(6551317,'highway','primary',4),(6551317,'layer','1',4),(6551317,'ref','CG-2',4),(6551317,'source','yahoo',4),(6551320,'highway','primary',3),(6551320,'ref','CG-2',3),(6551320,'source','yahoo',3),(6553102,'bridge','yes',3),(6553102,'FIXME','Missing name',3),(6553102,'highway','residential',3),(6553102,'layer','2',3),(6553108,'FIXME','Missing name',2),(6553108,'highway','residential',2),(6553398,'FIXME','Missing name',2),(6553398,'highway','residential',2),(6553516,'FIXME','Missing name',2),(6553516,'highway','tertiary',2),(6553741,'FIXME','Missing name',2),(6553741,'highway','residential',2),(6557168,'FIXME','Missing name',2),(6557168,'highway','tertiary',2),(6557169,'FIXME','Missing name',2),(6557169,'highway','residential',2),(6557171,'FIXME','Missing name',2),(6557171,'highway','residential',2),(6557173,'FIXME','Missing name',2),(6557173,'highway','residential',2),(6557177,'created_by','JOSM',1),(6557177,'waterway','stream',1),(6561466,'created_by','JOSM',1),(6561466,'natural','wood',1),(6561468,'aerialway','cable_car',6),(6561468,'aerialway:occupancy','8',6),(6561468,'name','Soldeu',6),(6561470,'created_by','JOSM',1),(6561470,'natural','wood',1),(6561682,'created_by','JOSM',1),(6561682,'natural','wood',1),(6561704,'created_by','JOSM',1),(6561704,'natural','wood',1),(6561708,'natural','wood',3),(6563683,'aerialway','cable_car',4),(6563683,'aerialway:occupancy','8',4),(6563683,'name','TC8 Canillo',4),(6563683,'oneway','no',4),(6563687,'created_by','Potlatch 0.10f',2),(6563687,'natural','wood',2),(6563690,'FIXME','Missing name',3),(6563690,'highway','residential',3),(6566558,'created_by','Potlatch 0.9c',5),(6566558,'highway','secondary',5),(6566558,'ref','CS-310',5),(6566558,'source','yahoo',5),(6566561,'highway','secondary',4),(6566561,'junction','roundabout',4),(6566571,'created_by','Potlatch 0.10b',2),(6566571,'highway','residential',2),(6566573,'created_by','Potlatch 0.10b',2),(6566573,'highway','residential',2),(6566576,'FIXME','Missing name',3),(6566576,'highway','residential',3),(6569859,'created_by','Potlatch 0.10f',8),(6569859,'highway','residential',8),(6569859,'name','Urb. l\'Oriosos',8),(6576845,'created_by','Potlatch 0.10b',2),(6576845,'highway','unclassified',2),(6576847,'created_by','Potlatch 0.10f',10),(6576847,'highway','unclassified',10),(6576847,'source','yahoo',10),(6576853,'bridge','yes',7),(6576853,'created_by','Potlatch 0.10f',7),(6576853,'highway','unclassified',7),(6576853,'layer','1',7),(6576853,'name','Pont d\'Anyos',7),(6576853,'source','yahoo',7),(6576855,'created_by','Potlatch 0.10b',2),(6576855,'highway','residential',2),(6576855,'name','Carretera de les Moles',2),(6576858,'FIXME','Missing name',3),(6576858,'highway','residential',3),(6576861,'FIXME','Missing name',2),(6576861,'highway','residential',2),(6576864,'FIXME','Missing name',2),(6576864,'highway','residential',2),(6576866,'FIXME','Missing name',2),(6576866,'highway','residential',2),(6578446,'created_by','Potlatch 0.9c',5),(6578446,'highway','residential',5),(6578446,'name','Carretera de les Boigues',5),(6578449,'FIXME','Missing name',3),(6578449,'highway','residential',3),(6578451,'created_by','Potlatch 0.9c',6),(6578451,'highway','residential',6),(6578451,'name','Carretera de l\'Aldosa',6),(6578454,'created_by','Potlatch 0.9c',2),(6578454,'highway','unclassified',2),(6578454,'name','Carretera de la Gonarda',2),(6584903,'created_by','Potlatch 0.9a',6),(6584903,'highway','residential',6),(6584903,'name','Carrer del Puiet',6),(6584906,'created_by','Potlatch 0.10',3),(6584906,'highway','residential',3),(6584908,'highway','residential',3),(6584908,'name','Carrer Antoni Fiter i Rossell',3),(6584910,'highway','residential',3),(6584910,'name','Carrer Manual Digest',3),(6584910,'oneway','yes',3),(6584917,'created_by','Potlatch 0.8c',5),(6584917,'highway','secondary',5),(6584917,'name','Carrer Major',5),(6584917,'ref','CS-330',5),(6584920,'created_by','Potlatch 0.9c',3),(6584920,'highway','residential',3),(6584920,'name','Carrer Josep Areny',3),(6584925,'created_by','Potlatch 0.9c',2),(6584925,'highway','residential',2),(6584925,'name','Carrer Guillem Areny',2),(6584928,'created_by','Potlatch 0.10f',2),(6584928,'highway','residential',2),(6584939,'created_by','Potlatch 0.10b',3),(6584939,'highway','tertiary',3),(6584947,'created_by','Potlatch 0.9c',5),(6584947,'highway','residential',5),(6584947,'name','Urb. El Salze',5),(6584951,'created_by','Potlatch 0.9c',4),(6584951,'highway','residential',4),(6584951,'name','Urb. Borda Rutllan',4),(6584956,'created_by','Potlatch 0.9c',4),(6584956,'highway','residential',4),(6584956,'name','Urb. Borda Rutllan',4),(6584961,'FIXME','Missing name',2),(6584961,'highway','residential',2),(6588508,'created_by','Potlatch 0.10f',2),(6588508,'highway','residential',2),(6588508,'name','Carretera de les Agudes',2),(6588510,'created_by','Potlatch 0.10f',2),(6588510,'highway','residential',2),(6588510,'name','Les Canadilles',2),(6588513,'FIXME','Missing name',5),(6588513,'highway','residential',5),(6588516,'FIXME','Missing name',6),(6588516,'highway','residential',6),(6588519,'FIXME','Missing name',5),(6588519,'highway','residential',5),(6589890,'created_by','Potlatch 0.9a',4),(6589890,'highway','residential',4),(6589890,'name','Carrer Coma Del Colat',4),(6589898,'created_by','Potlatch 0.9c',2),(6589898,'highway','residential',2),(6589898,'name','Carrer dels Hortals',2),(6590538,'created_by','Potlatch 0.10f',2),(6590538,'highway','residential',2),(6590538,'name','Carrer Dr Vilanova',2),(6592657,'FIXME','Missing name',3),(6592657,'highway','residential',3),(6593464,'layer','2',4),(6593464,'name','Lac d\'Engolasters',4),(6593464,'natural','water',4),(6602616,'created_by','Potlatch 0.5d',3),(6602616,'natural','wood',3),(6620914,'FIXME','Missing name',2),(6620914,'highway','residential',2),(6620917,'FIXME','Missing name',2),(6620917,'highway','residential',2),(6620920,'FIXME','Missing name',2),(6620920,'highway','residential',2),(6620926,'FIXME','Missing name',2),(6620926,'highway','residential',2),(6620930,'FIXME','Missing name',2),(6620930,'highway','residential',2),(6620940,'created_by','Potlatch 0.9a',7),(6620940,'highway','secondary',7),(6620940,'ref','CS-420',7),(6620947,'amenity','parking',1),(6620947,'created_by','JOSM',1),(6620952,'created_by','JOSM',1),(6620952,'landuse','opm:piste',1),(6620955,'created_by','JOSM',1),(6620955,'natural','wood',1),(6620958,'created_by','JOSM',1),(6620958,'natural','wood',1),(6620962,'created_by','JOSM',1),(6620962,'natural','wood',1),(6620964,'created_by','JOSM',1),(6620964,'natural','wood',1),(6620969,'created_by','JOSM',1),(6620969,'landuse','opm:piste',1),(6620973,'created_by','JOSM',1),(6620973,'natural','wood',1),(6620978,'created_by','JOSM',1),(6620978,'natural','wood',1),(6620980,'created_by','JOSM',1),(6620980,'natural','wood',1),(7934428,'FIXME','Missing name',3),(7934428,'highway','residential',3),(7934443,'FIXME','Missing name',2),(7934443,'highway','residential',2),(8164186,'admin_level','2',11),(8164186,'border_type','nation',11),(8164186,'boundary','administrative',11),(8164186,'left:country','Andorra',11),(8164186,'note','This border is so wrong - User:3ld',11),(8164186,'right:country','France',11),(8164186,'right:departement','Ariège',11),(8164186,'right:region','Midi-Pyrénées',11),(8164186,'source','CIA World Database II',11),(8164452,'FIXME','Missing name',3),(8164452,'highway','residential',3),(8164478,'FIXME','Missing name',2),(8164478,'highway','residential',2),(8164597,'FIXME','Missing name',3),(8164597,'highway','secondary',3),(8164597,'source','yahoo',3),(8164653,'FIXME','Missing name',3),(8164653,'highway','secondary',3),(8164653,'source','yahoo',3),(8166678,'FIXME','Way is not circular, and should be',4),(8166678,'natural','wood',4),(8561013,'bridge','yes',5),(8561013,'FIXME','Missing name',5),(8561013,'highway','primary',5),(8561013,'ref','CG-6',5),(8561432,'highway','primary_link',3),(8561432,'oneway','yes',3),(8667300,'created_by','JOSM',1),(8667300,'natural','wood',1),(8880951,'source','YAHOO',2),(8880951,'waterway','riverbank',2),(8880952,'source','YAHOO',8),(8880952,'waterway','riverbank',8),(8880953,'name','Río Valira',10),(8880953,'waterway','riverbank',10),(8880955,'waterway','riverbank',2),(8880956,'waterway','riverbank',13),(8885021,'source','yahoo',5),(8885021,'waterway','riverbank',5),(8885025,'waterway','riverbank',9),(17240968,'created_by','Potlatch 0.5d',3),(17240968,'natural','wood',3),(17241049,'created_by','Potlatch 0.9c',7),(17241049,'natural','wood',7),(22746153,'highway','primary',4),(22746153,'maxspeed','30',4),(22746153,'name','Port d\'Envalira',4),(22746153,'ref','CG-2',4),(22746153,'source','yahoo',4),(22746154,'highway','primary',4),(22746154,'maxspeed','90',4),(22746154,'name','Port d\'Envalira',4),(22746154,'ref','CG-2',4),(22746154,'source','yahoo',4),(22746155,'highway','primary',4),(22746155,'maxspeed','30',4),(22746155,'name','Port d\'Envalira',4),(22746155,'ref','CG-2',4),(22746155,'source','yahoo',4),(22746156,'highway','primary',4),(22746156,'maxspeed','90',4),(22746156,'name','Port d\'Envalira',4),(22746156,'ref','CG-2',4),(22746156,'source','yahoo',4),(22746157,'highway','primary',5),(22746157,'maxspeed','30',5),(22746157,'name','Port d\'Envalira',5),(22746157,'ref','CG-2',5),(22746157,'source','yahoo',5),(22746159,'highway','primary',5),(22746159,'maxspeed','30',5),(22746159,'name','Port d\'Envalira',5),(22746159,'ref','CG-2',5),(22746159,'source','yahoo',5),(22746160,'highway','primary',7),(22746160,'maxspeed','90',7),(22746160,'name','Port d\'Envalira',7),(22746160,'ref','CG-2',7),(22746160,'source','yahoo',7),(22932948,'created_by','JOSM',1),(22932948,'natural','wood',1),(22932949,'created_by','Potlatch 0.8a',3),(22932949,'layer','-4',3),(22932949,'natural','wood',3),(22932949,'source','Landsat IR',3),(23305160,'admin_level','2',19),(23305160,'border_type','nation',19),(23305160,'boundary','administrative',19),(23305160,'history','Retrieved from v6',19),(23305160,'left:country','France',19),(23305160,'left:departement','Ariège',19),(23305160,'left:region','Midi-Pyrénées',19),(23305160,'right:country','Spain',19),(23305160,'source','CIA World Databank II',19),(23840927,'created_by','Potlatch 0.9a',9),(23840927,'highway','primary',9),(23840927,'name','Avingunda Sant Antoni',9),(23840927,'ref','CG-3',9),(23840927,'source','yahoo',9),(23840928,'bridge','yes',8),(23840928,'created_by','Potlatch 0.9a',8),(23840928,'highway','primary',8),(23840928,'layer','2',8),(23840928,'name','Pont de Sant Antoni',8),(23840928,'ref','CG3i4',8),(23840928,'source','yahoo',8),(23841019,'created_by','Potlatch 0.8c',7),(23841019,'highway','primary',7),(23841019,'oneway','yes',7),(23841019,'ref','CG-4',7),(23841049,'created_by','Potlatch 0.8c',6),(23841049,'highway','primary',6),(23841049,'name','Avinguda del Ravel',6),(23841049,'ref','CG-4',6),(23841094,'created_by','Potlatch 0.8c',6),(23841094,'highway','primary',6),(23841094,'oneway','yes',6),(23841127,'created_by','Potlatch 0.9c',14),(23841127,'highway','primary',14),(23841127,'name','Avinguda el Travès',14),(23841127,'ref','CG-3',14),(23841127,'source','yahoo',14),(23841423,'bridge','yes',7),(23841423,'created_by','Potlatch 0.9c',7),(23841423,'highway','primary',7),(23841423,'layer','1',7),(23841423,'name','Pont de Santa Caterina',7),(23841423,'ref','CG-3',7),(23841423,'source','survey',7),(23841426,'created_by','Potlatch 0.8a',2),(23841426,'highway','primary',2),(23841426,'ref','CG-3',2),(23841426,'source','yahoo',2),(23842741,'created_by','Potlatch 0.9a',18),(23842741,'highway','primary',18),(23842741,'layer','-1',18),(23842741,'name','Avigunda Sant Antoni; Avinguda Fiter i Rossell',18),(23842741,'ref','CG-3',18),(23842741,'source','yahoo',18),(23842741,'tunnel','yes',18),(23857062,'created_by','Potlatch 0.10b',14),(23857062,'highway','primary',14),(23857062,'name','Avinguda Sant Antoni',14),(23857062,'ref','CG-3',14),(23857066,'highway','primary',7),(23857066,'name','Avinguda Sant Antoni',7),(23857066,'ref','CG-3',7),(23857066,'source','yahoo',7),(23857247,'created_by','Potlatch 0.10b',3),(23857247,'highway','secondary',3),(23857247,'source','YAHOO',3),(23877195,'highway','primary',10),(23877195,'maxspeed','90',10),(23877195,'name','Port d\'Envalira',10),(23877195,'ref','CG-2',10),(23877195,'source','yahoo',10),(23877197,'created_by','Potlatch 0.8c',4),(23877197,'highway','primary',4),(23877197,'maxspeed','90',4),(23877197,'ref','CG-2',4),(23877197,'source','yahoo',4),(23877199,'created_by','Potlatch 0.9c',7),(23877199,'highway','primary',7),(23877199,'maxspeed','60',7),(23877199,'ref','CG-2',7),(23877199,'source','yahoo',7),(23877200,'created_by','Potlatch 0.9c',11),(23877200,'highway','primary',11),(23877200,'maxspeed','50',11),(23877200,'ref','CG-2',11),(23877200,'source','yahoo',11),(23877201,'created_by','Potlatch alpha',2),(23877201,'highway','primary',2),(23877201,'ref','CG-2',2),(23877201,'source','yahoo',2),(23878263,'created_by','Potlatch 0.8a',1),(23878263,'history','Retrieved from v2',1),(23878263,'natural','wood',1),(23878263,'source','Landsat IR',1),(23878462,'created_by','Potlatch 0.10',5),(23878462,'highway','primary',5),(23878462,'ref','CG-2',5),(23878462,'source','yahoo',5),(23878463,'created_by','Potlatch 0.10',5),(23878463,'highway','primary',5),(23878463,'oneway','yes',5),(23878463,'ref','CG-2',5),(23878463,'source','yahoo',5),(23924998,'created_by','Potlatch 0.9c',9),(23924998,'highway','secondary',9),(23924998,'ref','CS-340',9),(23925250,'created_by','Potlatch 0.9a',8),(23925250,'highway','primary',8),(23925250,'oneway','yes',8),(23925250,'ref','CG-2',8),(23925250,'source','yahoo',8),(23925255,'created_by','Potlatch 0.9a',4),(23925255,'highway','primary',4),(23925255,'ref','CG-2',4),(23925255,'source','yahoo',4),(23925285,'created_by','Potlatch 0.8b',2),(23925285,'highway','primary',2),(23925285,'oneway','yes',2),(23925285,'ref','CG-2',2),(23925285,'source','yahoo',2),(23938547,'created_by','Potlatch 0.10b',5),(23938547,'highway','service',5),(23978189,'bridge','yes',5),(23978189,'created_by','Potlatch 0.9',5),(23978189,'highway','residential',5),(23978189,'history','Retrieved from v3',5),(23978189,'layer','2',5),(23978342,'created_by','Potlatch 0.8b',3),(23978342,'highway','residential',3),(23978342,'name','Cami de les Gravades',3),(23978424,'created_by','Potlatch 0.8b',1),(23978424,'foot','yes',1),(23978424,'highway','bridleway',1),(23978424,'name','Cami de les Gravades',1),(23978499,'created_by','Potlatch 0.8b',2),(23978499,'foot','yes',2),(23978499,'highway','residential',2),(23978499,'name','Cami de les Molleres',2),(24058474,'created_by','Potlatch 0.10b',2),(24058474,'highway','residential',2),(24058474,'name','Urb Sorribes',2),(24059004,'created_by','Potlatch 0.8c',3),(24059004,'highway','unclassified',3),(24059004,'history','Retrieved from v1',3),(24059004,'name','Massana Parc',3),(24059067,'created_by','Potlatch 0.8c',3),(24059067,'highway','secondary',3),(24059067,'name','Carretera Comes de Banyàs',3),(24059067,'ref','CS-430',3),(24059068,'created_by','Potlatch 0.8c',6),(24059068,'highway','secondary',6),(24059068,'name','Cerretera del Collet dels Colls',6),(24059068,'ref','CS-430',6),(24059122,'created_by','Potlatch 0.8c',3),(24059122,'highway','residential',3),(24059122,'name','Carrer de les Palanques',3),(24059295,'bridge','yes',4),(24059295,'created_by','Potlatch 0.8c',4),(24059295,'highway','residential',4),(24059295,'name','Pont de les Palanques',4),(24059296,'created_by','Potlatch 0.8c',2),(24059296,'highway','residential',2),(24059296,'name','Carrer de les Palanques',2),(24059351,'created_by','Potlatch 0.9',3),(24059351,'highway','residential',3),(24059351,'name','Cami Ral',3),(24059379,'created_by','Potlatch 0.9',2),(24059379,'highway','residential',2),(24059379,'name','Carrer de les Palanques',2),(24059392,'created_by','Potlatch 0.9a',2),(24059392,'foot','yes',2),(24059392,'highway','track',2),(24059392,'name','Cami Ral',2),(24059418,'created_by','Potlatch 0.8c',1),(24059418,'highway','residential',1),(24059418,'name','Cami Ral',1),(24059453,'created_by','Potlatch 0.8c',3),(24059453,'highway','unclassified',3),(24059572,'created_by','Potlatch 0.8c',1),(24059572,'foot','yes',1),(24059572,'highway','footway',1),(24059572,'name','Cami del Pou',1),(24059832,'created_by','Potlatch 0.10f',3),(24059832,'highway','residential',3),(24059832,'name','Urb. Besillosa i Costes Teixidor',3),(24059857,'created_by','Potlatch 0.9c',5),(24059857,'highway','secondary',5),(24059857,'name','Carrer Major',5),(24059857,'ref','CS-330',5),(24059999,'FIXME','Missing name',2),(24059999,'highway','residential',2),(24060059,'highway','residential',4),(24060059,'name','Carrer dels Plans',4),(24060260,'bridge','yes',5),(24060260,'created_by','Potlatch 0.8c',5),(24060260,'highway','primary',5),(24060260,'layer','1',5),(24060260,'name','Carretera d\'Arinsal',5),(24060260,'ref','CG-5',5),(24060706,'created_by','Potlatch 0.8c',7),(24060706,'highway','secondary',7),(24060706,'name','Carretera de la Creu Blanca',7),(24060706,'ref','CS-335',7),(24060706,'source','yahoo',7),(24060781,'created_by','Potlatch 0.8c',5),(24060781,'highway','secondary',5),(24060781,'name','Carretera de Beixalis',5),(24060781,'ref','CS-310',5),(24060781,'source','yahoo',5),(24060840,'created_by','Potlatch 0.10f',17),(24060840,'highway','secondary',17),(24060840,'name','Carretera de l\'Aldosa',17),(24060840,'ref','CS-335',17),(24060840,'source','yahoo',17),(24240688,'highway','residential',3),(24240699,'created_by','Potlatch 0.8c',3),(24240699,'highway','residential',3),(24240709,'created_by','Potlatch 0.8c',2),(24240709,'highway','residential',2),(24240780,'created_by','Potlatch 0.10f',10),(24240780,'highway','secondary',10),(24240780,'name','Carratera dels Plans',10),(24240780,'ref','CS-330',10),(24240808,'created_by','Potlatch 0.10f',10),(24240808,'highway','secondary',10),(24240808,'name','Carretera dels Plans',10),(24240808,'ref','CS-330',10),(24240825,'amenity','parking',4),(24240825,'created_by','Potlatch 0.8c',4),(24240826,'created_by','Potlatch 0.10f',6),(24240826,'highway','residential',6),(24240826,'name','Urb. Girault',6),(24240835,'amenity','parking',6),(24240835,'created_by','Potlatch 0.10f',6),(24240868,'created_by','Potlatch 0.10f',2),(24240868,'highway','residential',2),(24241040,'created_by','Potlatch 0.9c',9),(24241040,'highway','secondary',9),(24241040,'ref','CS-360',9),(24241072,'created_by','Potlatch 0.9c',6),(24241072,'highway','residential',6),(24241274,'created_by','Potlatch 0.8c',1),(24241274,'highway','residential',1),(24241278,'bridge','yes',2),(24241278,'created_by','Potlatch 0.8c',2),(24241278,'highway','residential',2),(24241278,'layer','1',2),(24241281,'highway','residential',2),(24241289,'created_by','Potlatch 0.8c',1),(24241289,'highway','residential',1),(24241364,'created_by','Potlatch 0.9a',12),(24241364,'highway','secondary',12),(24241364,'name','Carretera de Montaup',12),(24241364,'ref','CS-240',12),(24279813,'created_by','JOSM',1),(24279813,'highway','residential',1),(24279886,'created_by','JOSM',1),(24279886,'highway','service',1),(24279950,'created_by','Potlatch 0.10f',4),(24279950,'highway','tertiary',4),(24279950,'name','Avinguda del Fener',4),(24279950,'oneway','yes',4),(24279950,'source','yahoo',4),(24280101,'FIXME','Missing name',6),(24280101,'highway','residential',6),(24280101,'layer','-1',6),(24280101,'tunnel','yes',6),(24280274,'bridge','yes',3),(24280274,'created_by','Potlatch 0.8c',3),(24280274,'highway','secondary',3),(24280274,'layer','1',3),(24280274,'name','Carretera de Montaup',3),(24280274,'ref','CS-240',3),(24280275,'created_by','Potlatch 0.9a',4),(24280275,'highway','secondary',4),(24280275,'name','Carretera de Montaup',4),(24280275,'ref','CS-240',4),(24280276,'bridge','yes',3),(24280276,'created_by','Potlatch 0.8c',3),(24280276,'highway','secondary',3),(24280276,'layer','1',3),(24280276,'name','Carretera de Montaup',3),(24280276,'ref','CS-240',3),(24280277,'created_by','Potlatch 0.9a',4),(24280277,'highway','secondary',4),(24280277,'name','Carretera de Montaup',4),(24280277,'ref','CS-240',4),(24280278,'bridge','yes',3),(24280278,'FIXME','Missing name',3),(24280278,'highway','residential',3),(24280278,'layer','1',3),(24280279,'FIXME','Missing name',2),(24280279,'highway','residential',2),(24280280,'bridge','yes',3),(24280280,'created_by','Potlatch alpha',3),(24280280,'highway','primary',3),(24280280,'layer','1',3),(24280280,'ref','CG-2',3),(24280280,'source','yahoo',3),(24280281,'created_by','Potlatch 0.9a',4),(24280281,'highway','primary',4),(24280281,'ref','CG-2',4),(24280281,'source','yahoo',4),(24280282,'bridge','yes',3),(24280282,'FIXME','Missing name',3),(24280282,'highway','residential',3),(24280282,'layer','1',3),(24280283,'FIXME','Missing name',2),(24280283,'highway','residential',2),(24280284,'FIXME','Missing name',2),(24280284,'highway','secondary',2),(24280284,'source','yahoo',2),(24280285,'bridge','yes',3),(24280285,'FIXME','Missing name',3),(24280285,'highway','secondary',3),(24280285,'layer','1',3),(24280285,'source','yahoo',3),(24280286,'bridge','yes',3),(24280286,'FIXME','Missing name',3),(24280286,'highway','residential',3),(24280286,'layer','1',3),(24280287,'FIXME','Missing name',2),(24280287,'highway','residential',2),(24280288,'bridge','yes',3),(24280288,'created_by','Potlatch 0.8a',3),(24280288,'highway','primary',3),(24280288,'layer','1',3),(24280288,'ref','CG-4',3),(24280289,'created_by','Potlatch 0.9a',4),(24280289,'highway','primary',4),(24280289,'ref','CG-4',4),(24280290,'bridge','yes',3),(24280290,'created_by','Potlatch 0.8c',3),(24280290,'highway','primary',3),(24280290,'layer','1',3),(24280290,'name','Avinguda del Ravel',3),(24280290,'ref','CG-4',3),(24280291,'created_by','Potlatch 0.9a',2),(24280291,'highway','primary',2),(24280291,'name','Avinguda del Ravel',2),(24280291,'ref','CG-4',2),(24280292,'created_by','Potlatch 0.9c',22),(24280292,'highway','primary',22),(24280292,'name','Carretera d\'Arinsal',22),(24280292,'ref','CG-5',22),(24280293,'bridge','yes',4),(24280293,'FIXME','Missing name',4),(24280293,'highway','secondary',4),(24280293,'layer','1',4),(24280293,'ref','CS-413',4),(24280294,'highway','secondary',5),(24280294,'ref','CS-413',5),(24280295,'bridge','yes',3),(24280295,'created_by','Potlatch 0.8c',3),(24280295,'highway','primary',3),(24280295,'layer','1',3),(24280295,'ref','CG-2',3),(24280295,'source','yahoo',3),(24280296,'created_by','Potlatch 0.9a',4),(24280296,'highway','primary',4),(24280296,'ref','CG-2',4),(24280296,'source','yahoo',4),(24341039,'highway','unclassified',2),(24341039,'name','Cami de Redort',2),(24341039,'tracktype','grade2',2),(24360470,'created_by','Potlatch 0.9a',2),(24360470,'foot','yes',2),(24360470,'highway','footway',2),(24360470,'name','Cami del Grau',2),(24360537,'created_by','Potlatch 0.9a',2),(24360537,'highway','service',2),(24360617,'created_by','Potlatch 0.9a',1),(24360617,'highway','unclassified',1),(24360845,'created_by','Potlatch 0.9a',2),(24360845,'highway','unclassified',2),(24360845,'name','Cami de les Bordes de Mereig',2),(24361232,'created_by','Potlatch 0.9a',2),(24361232,'highway','residential',2),(24361241,'created_by','Potlatch 0.9a',2),(24361241,'highway','residential',2),(24361307,'created_by','Potlatch 0.9a',3),(24361307,'foot','permissive',3),(24361307,'highway','footway',3),(24361307,'source','yahoo',3),(24361318,'FIXME','Missing name',4),(24361318,'highway','residential',4),(24361318,'source','yahoo',4),(24361367,'created_by','Potlatch 0.9a',2),(24361367,'highway','residential',2),(24361367,'name','Carrer Parc Guillemó',2),(24361367,'source','survey',2),(24361435,'created_by','Potlatch 0.9c',4),(24361435,'highway','tertiary',4),(24361435,'name','Carrer de la Creu Grossa',4),(24361435,'source','survey',4),(24361575,'created_by','Potlatch 0.9a',3),(24361575,'highway','primary',3),(24361575,'name','Carrer Bonaventura Armengol',3),(24361575,'source','yahoo',3),(24361984,'created_by','Potlatch 0.9c',10),(24361984,'highway','primary',10),(24361984,'layer','2',10),(24361984,'name','Avinguda Consell d\'Europa',10),(24361984,'oneway','yes',10),(24361984,'ref','CG3i4',10),(24362026,'bridge','yes',3),(24362026,'created_by','Potlatch 0.9a',3),(24362026,'highway','primary',3),(24362026,'layer','1',3),(24362026,'name','Pont de Paris',3),(24362252,'bridge','yes',5),(24362252,'created_by','Potlatch 0.9a',5),(24362252,'highway','primary',5),(24362252,'layer','1',5),(24362252,'name','Pont de Paris',5),(24362252,'oneway','yes',5),(24362252,'ref','CG3i4',5),(24362255,'created_by','Potlatch 0.9a',3),(24362255,'highway','primary_link',3),(24362255,'name','Avinguda Consell d\'Europa',3),(24362255,'oneway','yes',3),(24362255,'ref','CG3i4',3),(24362361,'created_by','Potlatch 0.9c',6),(24362361,'highway','secondary',6),(24362361,'name','Avinguda Consell d\'Europa',6),(24362361,'source','yahoo',6),(24362714,'created_by','Potlatch 0.9a',2),(24362714,'highway','residential',2),(24362714,'name','Carrer dels Escalls',2),(24362714,'source','yahoo',2),(24362802,'created_by','Potlatch 0.10f',7),(24362802,'highway','primary',7),(24362802,'name','Avinguda Doctor Mitjavila',7),(24362802,'oneway','yes',7),(24362802,'ref','CG-3a',7),(24362802,'source','yahoo',7),(24364447,'highway','primary',9),(24364447,'layer','-1',9),(24364447,'name','Tunèl del Pont Pla',9),(24364447,'ref','CG-3i4',9),(24364447,'tunnel','yes',9),(24364513,'bridge','yes',9),(24364513,'created_by','Potlatch 0.9c',9),(24364513,'highway','primary',9),(24364513,'layer','2',9),(24364513,'name','Vial de la Uniò',9),(24364513,'ref','CG-3i4',9),(24364799,'created_by','Potlatch 0.9a',3),(24364799,'highway','primary',3),(24364799,'name','Avinguda Prat de la Creu',3),(24364799,'ref','CG3a',3),(24364799,'source','yahoo',3),(24367429,'created_by','Potlatch 0.10f',2),(24367429,'highway','residential',2),(24367429,'name','Carrer del Pui',2),(24374047,'bridge','true',1),(24374047,'created_by','Potlatch 0.8c',1),(24374047,'highway','primary',1),(24374047,'layer','1',1),(24374047,'name','Carretera General',1),(24374047,'ref','CG-3',1),(24374047,'source','user 3ld',1),(24374048,'created_by','Potlatch 0.10f',6),(24374048,'highway','primary',6),(24374048,'name','Carretera General',6),(24374048,'ref','CG-3',6),(24374048,'source','user 3ld',6),(24374049,'bridge','true',1),(24374049,'created_by','Potlatch 0.8c',1),(24374049,'highway','primary',1),(24374049,'layer','1',1),(24374049,'name','Carretera General',1),(24374049,'ref','CG-3',1),(24374049,'source','user 3ld',1),(24374050,'highway','primary',4),(24374050,'name','Carretera General',4),(24374050,'ref','CG-3',4),(24374051,'created_by','Potlatch 0.9a',4),(24374051,'highway','primary',4),(24374051,'name','Carretera General',4),(24374051,'ref','CG-3',4),(24374051,'source','user 3ld',4),(24374052,'created_by','Potlatch 0.9c',21),(24374052,'highway','primary',21),(24374052,'name','Carretera General',21),(24374052,'ref','CG-3',21),(24374052,'source','user 3ld',21),(24374054,'bridge','true',3),(24374054,'created_by','JOSM',3),(24374054,'highway','primary',3),(24374054,'layer','1',3),(24374054,'source','yahoo',3),(24374055,'created_by','JOSM',3),(24374055,'highway','primary',3),(24374055,'ref','CG-6',3),(24374055,'source','yahoo',3),(24374056,'bridge','true',3),(24374056,'created_by','JOSM',3),(24374056,'highway','primary',3),(24374056,'layer','1',3),(24374056,'source','yahoo',3),(24374057,'highway','primary',5),(24374057,'ref','CG-6',5),(24374057,'source','yahoo',5),(24374064,'bridge','true',2),(24374064,'FIXME','Missing name',2),(24374064,'highway','residential',2),(24374064,'layer','1',2),(24374064,'source','Yahoo and guess',2),(24374065,'FIXME','Missing name',2),(24374065,'highway','residential',2),(24374065,'source','Yahoo and guess',2),(24376755,'access','permissive',2),(24376755,'created_by','Potlatch 0.9a',2),(24376755,'highway','residential',2),(24376755,'name','Urbanització Giberga',2),(24376812,'access','permissive',2),(24376812,'created_by','Potlatch 0.9a',2),(24376812,'highway','residential',2),(24376812,'name','Urbanització Giberga',2),(24377511,'created_by','Potlatch 0.9a',1),(24377511,'highway','residential',1),(24377511,'oneway','yes',1),(24377558,'created_by','Potlatch 0.9a',1),(24377558,'highway','residential',1),(24377663,'created_by','Potlatch 0.9a',1),(24377663,'highway','residential',1),(24377663,'name','Carrer el Travès',1),(24377667,'created_by','Potlatch 0.9a',1),(24377667,'highway','service',1),(24405095,'bridge','yes',3),(24405095,'created_by','Potlatch 0.9a',3),(24405095,'highway','primary',3),(24405095,'layer','1',3),(24405095,'ref','CG3i4',3),(24405096,'created_by','Potlatch 0.9a',4),(24405096,'highway','primary',4),(24405096,'ref','CG3i4',4),(24405131,'created_by','Potlatch 0.9a',3),(24405131,'highway','primary',3),(24405131,'name','Avigunda Sant Antoni; Avinguda Fiter i Rossell',3),(24405131,'ref','CG-3',3),(24405131,'source','survey',3),(24405159,'created_by','Potlatch 0.9c',10),(24405159,'highway','primary',10),(24405159,'name','Avinguda Sant Antoni',10),(24405159,'oneway','yes',10),(24405159,'ref','CG-3',10),(24405221,'created_by','Potlatch 0.9c',5),(24405221,'highway','primary_link',5),(24405221,'name','Avigunda Sant Antoni; Avinguda Fiter i Rossell',5),(24405221,'oneway','yes',5),(24405221,'ref','CG-3',5),(24405221,'source','yahoo',5),(24406052,'created_by','Potlatch 0.9a',2),(24406052,'highway','primary_link',2),(24406052,'name','Avigunda Sant Antoni; Avinguda Fiter i Rossell',2),(24406052,'ref','CG-3',2),(24406052,'source','yahoo',2),(24406326,'natural','water',2),(24406327,'created_by','Potlatch 0.9c',2),(24406327,'natural','water',2),(24406328,'created_by','JOSM',1),(24406328,'natural','wood',1),(24406329,'created_by','Potlatch 0.10f',2),(24406329,'natural','wood',2),(24406331,'natural','wood',2),(24406332,'created_by','JOSM',1),(24406332,'natural','wood',1),(24406333,'created_by','JOSM',1),(24406333,'natural','wood',1),(24406334,'created_by','JOSM',1),(24406334,'natural','wood',1),(24406335,'created_by','JOSM',1),(24406335,'natural','wood',1),(24406336,'created_by','JOSM',1),(24406336,'natural','wood',1),(24413463,'bridge','true',2),(24413463,'created_by','Potlatch 0.9a',2),(24413463,'highway','primary_link',2),(24413463,'layer','1',2),(24413463,'source','yahoo',2),(24413466,'highway','primary',4),(24413466,'layer','2',4),(24413466,'name','Avinguda Consell d\'Europa',4),(24413466,'oneway','yes',4),(24413467,'created_by','Potlatch 0.9c',2),(24413467,'highway','primary',2),(24413467,'name','Avinguda Consell d\'Europa',2),(24413467,'oneway','yes',2),(24413467,'ref','CG3i4',2),(24413469,'highway','primary_link',2),(24413469,'oneway','yes',2),(24413469,'source','yahoo',2),(24413471,'created_by','Potlatch 0.9a',3),(24413471,'highway','primary_link',3),(24413471,'layer','2',3),(24413471,'source','yahoo',3),(24430806,'created_by','Potlatch 0.9c',7),(24430806,'highway','secondary',7),(24430806,'name','Avinguda Consell d\'Europa',7),(24430806,'oneway','yes',7),(24430806,'source','yahoo',7),(24430807,'created_by','Potlatch 0.9a',1),(24430807,'highway','secondary',1),(24430807,'layer','-1',1),(24430807,'name','Avinguda Consell d\'Europa',1),(24430807,'source','yahoo',1),(24456592,'created_by','Potlatch 0.10f',9),(24456592,'highway','secondary',9),(24456592,'name','Carretera de Beixalis',9),(24456592,'ref','CS-310',9),(24456592,'source','yahoo',9),(24492435,'created_by','Potlatch 0.9a',3),(24492435,'highway','unclassified',3),(24492435,'name','Cami Ral',3),(24492437,'created_by','Potlatch 0.9a',2),(24492437,'highway','unclassified',2),(24492437,'name','Cami Ral',2),(24492459,'bridge','yes',4),(24492459,'created_by','Potlatch 0.9a',4),(24492459,'highway','unclassified',4),(24492459,'layer','1',4),(24492459,'name','Cami Ral',4),(24492463,'created_by','Potlatch 0.9a',2);
INSERT INTO `way_tags` VALUES (24492463,'highway','unclassified',2),(24492623,'created_by','Potlatch 0.9a',3),(24492623,'highway','residential',3),(24492644,'created_by','Potlatch 0.9a',2),(24492644,'highway','residential',2),(24492644,'name','Cami Ral',2),(24492653,'bridge','yes',3),(24492653,'created_by','Potlatch 0.9a',3),(24492653,'highway','residential',3),(24492653,'layer','1',3),(24492653,'name','Pont d\'Ansalonga',3),(24492657,'created_by','Potlatch 0.9a',2),(24492657,'highway','residential',2),(24492677,'created_by','Potlatch 0.9a',1),(24492677,'highway','residential',1),(24492804,'created_by','Potlatch 0.9a',6),(24492804,'highway','secondary',6),(24492804,'name','Carrer de Sornás',6),(24492804,'ref','CS-350',6),(24492831,'created_by','Potlatch 0.9a',1),(24492831,'highway','residential',1),(24492831,'maxspeed','20',1),(24492868,'bridge','yes',5),(24492868,'created_by','Potlatch 0.9a',5),(24492868,'highway','secondary',5),(24492868,'layer','1',5),(24492868,'name','Carrer de Sornás',5),(24492868,'ref','CS-350',5),(24492889,'created_by','Potlatch 0.9a',3),(24492889,'highway','secondary',3),(24492889,'name','Carrer de Sornás',3),(24492889,'ref','CS-350',3),(24492906,'created_by','Potlatch 0.9a',2),(24492906,'highway','primary',2),(24492906,'name','Carretera General',2),(24492906,'ref','CG-3',2),(24492906,'source','user 3ld',2),(24492907,'bridge','yes',4),(24492907,'created_by','Potlatch 0.9a',4),(24492907,'highway','primary',4),(24492907,'layer','1',4),(24492907,'name','Carretera General',4),(24492907,'ref','CG-3',4),(24492907,'source','user 3ld',4),(24493028,'created_by','Potlatch 0.9a',3),(24493028,'highway','tertiary',3),(24493028,'name','Carrer de l\'Anglada',3),(24493045,'created_by','Potlatch 0.9a',1),(24493045,'highway','residential',1),(24493119,'FIXME','Missing name',2),(24493119,'highway','residential',2),(24493121,'highway','secondary',7),(24493121,'junction','roundabout',7),(24493187,'created_by','Potlatch 0.9a',4),(24493187,'highway','secondary',4),(24493187,'name','Carretera de Segudet',4),(24493187,'ref','CS-345',4),(24493188,'created_by','Potlatch 0.9a',6),(24493188,'highway','secondary',6),(24493188,'name','Cami de Segudet',6),(24493188,'ref','CS-345',6),(24493245,'bridge','yes',6),(24493245,'created_by','Potlatch 0.9a',6),(24493245,'highway','tertiary',6),(24493245,'layer','1',6),(24493245,'name','La Carrera Nova',6),(24493245,'oneway','yes',6),(24493247,'created_by','Potlatch 0.9a',3),(24493247,'highway','residential',3),(24493250,'created_by','Potlatch 0.9a',2),(24493250,'highway','residential',2),(24493261,'created_by','Potlatch 0.9a',1),(24493261,'highway','tertiary',1),(24493261,'name','La Carrera Nova',1),(24493330,'created_by','Potlatch 0.9a',2),(24493330,'highway','residential',2),(24493330,'name','La Callisa',2),(24493335,'created_by','Potlatch 0.9a',4),(24493335,'highway','residential',4),(24493338,'created_by','Potlatch 0.9a',2),(24493338,'highway','residential',2),(24493362,'created_by','Potlatch 0.9a',1),(24493362,'highway','residential',1),(24493378,'created_by','Potlatch 0.9a',1),(24493378,'highway','service',1),(24493431,'amenity','parking',1),(24493431,'created_by','Potlatch 0.9a',1),(24493439,'created_by','Potlatch 0.9a',1),(24493439,'highway','service',1),(24493444,'amenity','parking',1),(24493444,'created_by','Potlatch 0.9a',1),(24493526,'created_by','Potlatch 0.10',5),(24493526,'highway','tertiary',5),(24493526,'name','Cami de Santa Bàrbara',5),(24493528,'created_by','Potlatch 0.10f',6),(24493528,'highway','tertiary',6),(24493528,'name','Cami de Santa Bàrbara',6),(24493570,'created_by','Potlatch 0.9a',2),(24493570,'highway','residential',2),(24493570,'name','Cami Peu de la Grau',2),(24493584,'created_by','Potlatch 0.9a',2),(24493584,'highway','tertiary',2),(24493584,'name','Cami de Santa Bàrbara',2),(24493641,'created_by','Potlatch 0.9a',1),(24493641,'highway','service',1),(24493647,'created_by','Potlatch 0.9a',1),(24493647,'highway','service',1),(24493659,'created_by','Potlatch 0.9a',1),(24493659,'highway','service',1),(24493664,'amenity','parking',2),(24493664,'created_by','Potlatch 0.9a',2),(24493679,'created_by','Potlatch 0.9a',1),(24493679,'highway','residential',1),(24493789,'created_by','Potlatch 0.9a',2),(24493789,'highway','residential',2),(24493890,'boat','no',2),(24493890,'created_by','Potlatch 0.9a',2),(24493890,'name','Riu de Segudet',2),(24493890,'waterway','stream',2),(24493895,'bridge','yes',3),(24493895,'created_by','Potlatch 0.9a',3),(24493895,'highway','residential',3),(24493895,'layer','1',3),(24493896,'created_by','Potlatch 0.9a',1),(24493896,'highway','residential',1),(24493927,'highway','tertiary',3),(24493927,'name','La Carrera Nova',3),(24493927,'oneway','yes',3),(24493967,'highway','primary',4),(24493967,'name','Carretera General',4),(24493967,'ref','CG-3',4),(24493967,'source','user 3ld',4),(24494051,'highway','residential',3),(24494073,'amenity','parking',1),(24494073,'created_by','Potlatch 0.9a',1),(24494162,'bridge','yes',3),(24494162,'highway','residential',3),(24494162,'layer','1',3),(24494164,'created_by','Potlatch 0.9a',1),(24494164,'highway','residential',1),(24497076,'created_by','Potlatch 0.9a',1),(24497076,'highway','unclassified',1),(24497077,'bridge','yes',2),(24497077,'created_by','Potlatch 0.9a',2),(24497077,'highway','unclassified',2),(24497077,'layer','1',2),(24512879,'created_by','Potlatch 0.9a',1),(24512879,'highway','residential',1),(24517626,'created_by','Potlatch 0.9a',2),(24517626,'highway','residential',2),(24517626,'name','Carrer de la Pleta de l\'Aldosa',2),(24517633,'created_by','Potlatch 0.9a',2),(24517633,'highway','service',2),(24517644,'created_by','Potlatch 0.9a',2),(24517644,'highway','service',2),(24517841,'created_by','Potlatch 0.9a',1),(24517841,'highway','residential',1),(24517875,'created_by','Potlatch 0.10f',6),(24517875,'highway','residential',6),(24517889,'created_by','Potlatch 0.9a',1),(24517889,'highway','service',1),(24517907,'amenity','parking',1),(24517907,'created_by','Potlatch 0.9a',1),(24518086,'created_by','Potlatch 0.9a',3),(24518086,'highway','track',3),(24518086,'maxspeed','30',3),(24518086,'tracktype','grade3',3),(24518088,'created_by','Potlatch 0.9a',3),(24518088,'highway','track',3),(24518088,'maxspeed','30',3),(24518088,'tracktype','grade1',3),(24518115,'created_by','Potlatch 0.9a',4),(24518115,'highway','track',4),(24518115,'maxspeed','30',4),(24518115,'tracktype','grade1',4),(24518124,'created_by','Potlatch 0.9a',2),(24518124,'highway','track',2),(24518124,'maxspeed','30',2),(24518124,'tracktype','grade3',2),(24663518,'created_by','Potlatch 0.9c',1),(24663518,'highway','residential',1),(24663520,'bridge','yes',2),(24663520,'created_by','Potlatch 0.9c',2),(24663520,'highway','residential',2),(24663520,'layer','1',2),(24663786,'created_by','Potlatch 0.10f',2),(24663786,'highway','secondary',2),(24663786,'name','Carrer de les Escoles',2),(24663786,'ref','CS-330',2),(24663894,'FIXME','Missing name',3),(24663894,'highway','residential',3),(24664831,'created_by','Potlatch 0.9c',3),(24664831,'highway','unclassified',3),(24664867,'created_by','Potlatch 0.9c',7),(24664867,'highway','secondary',7),(24664867,'ref','CS-411',7),(24664880,'created_by','Potlatch 0.9c',3),(24664880,'highway','residential',3),(24665224,'created_by','Potlatch 0.9c',2),(24665224,'highway','residential',2),(24665224,'name','Carretera l\'Escaladella',2),(24665257,'access','private',1),(24665257,'amenity','parking',1),(24665257,'created_by','Potlatch 0.9c',1),(24665737,'created_by','Potlatch 0.9c',8),(24665737,'highway','secondary',8),(24665737,'name','Carretera Mas Ribafeta',8),(24665737,'ref','CS-412',8),(24665785,'created_by','Potlatch 0.9c',1),(24665785,'highway','residential',1),(24665785,'name','Els Formantals Parc',1),(24665811,'created_by','Potlatch 0.9c',1),(24665811,'highway','residential',1),(24666049,'created_by','Potlatch 0.9c',1),(24666049,'highway','residential',1),(24666099,'created_by','Potlatch 0.9c',1),(24666099,'highway','residential',1),(24666099,'name','Carretera les Feixes',1),(24666136,'created_by','Potlatch 0.9c',2),(24666136,'highway','service',2),(24666186,'amenity','parking',1),(24666186,'created_by','Potlatch 0.9c',1),(24668180,'bridge','yes',4),(24668180,'created_by','Potlatch 0.9c',4),(24668180,'highway','residential',4),(24668180,'layer','1',4),(24668181,'created_by','Potlatch 0.9c',3),(24668181,'highway','residential',3),(24668187,'created_by','Potlatch 0.9c',2),(24668187,'highway','residential',2),(24668361,'created_by','Potlatch 0.9c',4),(24668361,'highway','residential',4),(24668372,'created_by','Potlatch 0.9c',2),(24668372,'highway','residential',2),(24668373,'bridge','yes',2),(24668373,'created_by','Potlatch 0.9c',2),(24668373,'highway','residential',2),(24668373,'layer','1',2),(24668885,'highway','service',6),(24668954,'created_by','Potlatch 0.9c',2),(24668954,'highway','service',2),(24669163,'created_by','Potlatch 0.9c',3),(24669163,'highway','service',3),(24669245,'created_by','Potlatch 0.9c',1),(24669245,'highway','service',1),(24669247,'highway','service',3),(24669248,'bridge','yes',2),(24669248,'created_by','Potlatch 0.9c',2),(24669248,'highway','service',2),(24669248,'layer','1',2),(24669306,'amenity','parking',1),(24669306,'created_by','Potlatch 0.9c',1),(24669321,'amenity','parking',2),(24669352,'amenity','parking',2),(24669352,'created_by','Potlatch 0.10f',2),(24669376,'amenity','parking',1),(24669376,'created_by','Potlatch 0.9c',1),(24669430,'created_by','Potlatch 0.9c',1),(24669430,'highway','service',1),(24669444,'highway','service',3),(24713155,'created_by','Potlatch 0.9c',4),(24713155,'highway','residential',4),(24713182,'created_by','Potlatch 0.9c',5),(24713182,'highway','track',5),(24713182,'name','Camí Ral d\'Ordino',5),(24713182,'tracktype','grade3',5),(24713189,'created_by','Potlatch 0.9c',3),(24713189,'highway','unclassified',3),(24713210,'created_by','Potlatch 0.9c',3),(24713210,'highway','track',3),(24713210,'tracktype','grade2',3),(24713222,'created_by','Potlatch 0.9c',3),(24713222,'highway','track',3),(24713222,'tracktype','grade3',3),(24713246,'bridge','yes',3),(24713246,'created_by','Potlatch 0.9c',3),(24713246,'highway','track',3),(24713246,'layer','1',3),(24713246,'tracktype','grade1',3),(24713303,'created_by','Potlatch 0.9c',1),(24713303,'highway','unclassified',1),(24713305,'bridge','yes',2),(24713305,'created_by','Potlatch 0.9c',2),(24713305,'highway','unclassified',2),(24713305,'layer','1',2),(24713352,'created_by','Potlatch 0.9c',5),(24713352,'highway','residential',5),(24713362,'created_by','Potlatch 0.9c',3),(24713362,'highway','footway',3),(24713447,'created_by','Potlatch 0.9c',3),(24713447,'highway','footway',3),(24713483,'amenity','parking',1),(24713483,'created_by','Potlatch 0.9c',1),(24713502,'amenity','parking',1),(24713502,'created_by','Potlatch 0.9c',1),(24713566,'created_by','Potlatch 0.9c',2),(24713566,'highway','residential',2),(24713578,'created_by','Potlatch 0.9c',3),(24713578,'highway','residential',3),(24713611,'created_by','Potlatch 0.9c',1),(24713611,'highway','unclassified',1),(24713692,'created_by','Potlatch 0.9c',1),(24713692,'highway','residential',1),(24713692,'name','Carrer Sant Romà',1),(24713704,'created_by','Potlatch 0.9c',1),(24713704,'highway','primary',1),(24713704,'name','Carretera d\'Erts',1),(24713704,'ref','CG-5',1),(24713904,'created_by','Potlatch 0.9c',3),(24713904,'highway','residential',3),(24713904,'name','Carrer Mossèn Enric Marfany',3),(24713904,'source','yahoo survey',3),(24713918,'created_by','Potlatch 0.10',9),(24713918,'highway','tertiary',9),(24713918,'name','Carrer Doctor Nequi',9),(24713918,'source','yahoo survey',9),(24713936,'created_by','Potlatch 0.9c',2),(24713936,'highway','tertiary',2),(24713936,'name','Carrer Bisbe Príncep Iglésias',2),(24713936,'source','survey',2),(24714294,'created_by','Potlatch 0.9c',3),(24714294,'highway','residential',3),(24714294,'name','Carrer Roger Bernat III',3),(24714294,'source','yahoo',3),(24714736,'created_by','Potlatch 0.9c',4),(24714736,'highway','secondary',4),(24714736,'name','Avinguda de Santa Coloma',4),(24714743,'created_by','Potlatch 0.10',10),(24714743,'highway','secondary',10),(24714743,'name','Avinguda d\'Enclar',10),(24714892,'highway','tertiary',2),(24714892,'name','Carrer dels Canals',2),(24714892,'source','yahoo survey',2),(24715008,'created_by','Potlatch 0.9c',2),(24715008,'highway','secondary',2),(24715008,'name','Baixada del Molì',2),(24715008,'source','yahoo',2),(24715064,'bridge','yes',3),(24715064,'created_by','Potlatch 0.9c',3),(24715064,'highway','secondary',3),(24715064,'layer','1',3),(24715064,'name','Pont de Tobira; Carrer de Tobira',3),(24715064,'source','yahoo',3),(24715082,'highway','primary',6),(24715082,'junction','roundabout',6),(24715082,'name','Avinguda de Tarragona',6),(24715082,'source','yahoo',6),(24715152,'created_by','Potlatch 0.10f',5),(24715152,'highway','primary',5),(24715152,'name','Avinguda de Tarragona',5),(24715152,'ref','CG-2',5),(24715152,'source','yahoo',5),(24715185,'highway','primary_link',3),(24715185,'oneway','yes',3),(24715324,'created_by','Potlatch 0.9c',1),(24715324,'highway','residential',1),(24715324,'name','Carrer de l\'Aigüeta',1),(24715324,'oneway','yes',1),(24715324,'source','yahoo',1),(24913724,'created_by','Potlatch 0.9c',2),(24913724,'highway','residential',2),(24913724,'name','Cami Ral',2),(24913802,'created_by','Potlatch 0.9c',1),(24913802,'highway','residential',1),(24913802,'name','Peu del Carrer',1),(24913861,'created_by','Potlatch 0.9c',1),(24913861,'highway','residential',1),(24913861,'name','Carrer dels Ocells',1),(24914526,'created_by','Potlatch 0.9c',3),(24914526,'highway','tertiary',3),(24914526,'lanes','2',3),(24914526,'name','Avinguda de les Nacions Unides',3),(24914534,'created_by','Potlatch 0.9c',7),(24914534,'highway','tertiary',7),(24914534,'name','Carrer de la Constituciò',7),(24914534,'source','survey',7),(24914563,'created_by','Potlatch 0.9c',5),(24914563,'highway','tertiary',5),(24914563,'junction','roundabout',5),(24914563,'source','survey',5),(24914660,'created_by','Potlatch 0.9c',4),(24914660,'highway','tertiary',4),(24914660,'name','Carrer de Parnal',4),(24914660,'source','survey',4),(24914768,'FIXME','Missing name',2),(24914768,'highway','residential',2),(24914768,'source','yahoo',2),(24914779,'created_by','Potlatch 0.9c',2),(24914779,'highway','primary',2),(24914779,'oneway','yes',2),(24914843,'highway','tertiary',6),(24914843,'junction','roundabout',6),(24914870,'created_by','Potlatch 0.9c',5),(24914870,'highway','tertiary',5),(24914870,'name','Carrer de la Constituciò',5),(24914870,'source','survey',5),(24914903,'highway','tertiary',6),(24914903,'junction','roundabout',6),(24914989,'created_by','Potlatch 0.10f',5),(24914989,'highway','tertiary',5),(24914989,'name','Avinguda Consell de la Terra',5),(24915114,'FIXME','Missing name',2),(24915114,'highway','residential',2),(24915114,'source','yahoo',2),(24915502,'created_by','Potlatch 0.9c',2),(24915502,'highway','primary',2),(24915502,'ref','CG-2',2),(24915502,'source','yahoo',2),(24915504,'created_by','Potlatch 0.9c',3),(24915504,'highway','primary',3),(24915504,'oneway','yes',3),(24915504,'ref','CG-2',3),(24915504,'source','yahoo',3),(24915554,'created_by','Potlatch 0.9c',5),(24915554,'highway','secondary',5),(24915554,'name','Carretera de Beixalis',5),(24915554,'ref','CS-310',5),(24915554,'source','yahoo',5),(24915566,'created_by','Potlatch 0.9c',5),(24915566,'highway','secondary',5),(24915566,'junction','roundabout',5),(24915617,'bridge','yes',4),(24915617,'created_by','Potlatch 0.9c',4),(24915617,'highway','secondary',4),(24915617,'layer','1',4),(24915617,'name','Carretera de les Riberaigües',4),(24915624,'created_by','Potlatch 0.9c',3),(24915624,'highway','secondary',3),(24915624,'oneway','yes',3),(24915706,'created_by','Potlatch 0.9c',2),(24915706,'highway','secondary',2),(24915706,'name','Carretera de les Riberaigües',2),(24915706,'oneway','yes',2),(24915763,'created_by','Potlatch 0.9c',1),(24915763,'highway','secondary',1),(24915763,'ref','CS-310',1),(24915763,'source','yahoo',1),(24915772,'bridge','yes',2),(24915772,'created_by','Potlatch 0.9c',2),(24915772,'highway','secondary',2),(24915772,'layer','1',2),(24915772,'ref','CS-310',2),(24915772,'source','yahoo',2),(24915834,'created_by','Potlatch 0.9c',1),(24915834,'highway','secondary',1),(24915834,'name','Carretera de les Riberaigües',1),(25014753,'created_by','JOSM',4),(25014753,'highway','unclassified',4),(25014753,'name','Carrer Doctor Vilanova',4),(25014777,'created_by','JOSM',1),(25014777,'highway','track',1),(25014777,'tracktype','grade4',1),(25415705,'admin_level','2',6),(25415705,'border_type','nation',6),(25415705,'boundary','administrative',6),(25415705,'left:country','Andorra',6),(25415705,'right:country','France',6),(25415705,'source','GPS Survey',6),(25416126,'created_by','Potlatch 0.9c',3),(25416126,'highway','residential',3),(25416126,'name','Cami de les Molleres',3),(25416128,'created_by','Potlatch 0.10f',2),(25416128,'foot','yes',2),(25416128,'highway','footway',2),(25416128,'name','Cami de les Molleres',2),(25416227,'highway','service',4),(25416308,'highway','residential',3),(25416371,'created_by','Potlatch 0.9c',3),(25416371,'highway','residential',3),(25453236,'created_by','Potlatch 0.9c',2),(25453236,'highway','track',2),(25453236,'tracktype','grade1',2),(25453308,'bridge','yes',3),(25453308,'created_by','Potlatch 0.9c',3),(25453308,'highway','track',3),(25453308,'layer','1',3),(25453308,'tracktype','grade1',3),(25453310,'created_by','Potlatch 0.9c',1),(25453310,'highway','track',1),(25453310,'tracktype','grade1',1),(25454372,'created_by','Potlatch 0.9c',2),(25454372,'highway','residential',2),(25454372,'name','Cami de Santa Caterina',2),(25454378,'created_by','Potlatch 0.10f',4),(25454378,'foot','yes',4),(25454378,'highway','path',4),(25454378,'name','Cami de Santa Caterina',4),(25454381,'created_by','Potlatch 0.9c',2),(25454381,'highway','unclassified',2),(25484821,'created_by','Potlatch 0.10f',2),(25484821,'highway','tertiary',2),(25484821,'oneway','yes',2),(25484883,'created_by','Potlatch 0.9c',4),(25484883,'highway','residential',4),(25484883,'name','Carrer Josep Viladomat',4),(25484883,'source','survey',4),(25484912,'highway','secondary',6),(25484912,'junction','roundabout',6),(25485099,'created_by','Potlatch 0.9c',5),(25485099,'highway','tertiary',5),(25485099,'name','Carretera de la Margineda',5),(25485119,'created_by','Potlatch 0.9c',1),(25485119,'highway','residential',1),(25485119,'name','Carrer dels Castanyers',1),(25485130,'created_by','Potlatch 0.10',4),(25485130,'highway','tertiary',4),(25485130,'name','Carrer Tossalet i Vinyols',4),(25485131,'created_by','Potlatch 0.9c',2),(25485131,'highway','tertiary',2),(25485131,'name','Carrer de i\'Aern',2),(25569661,'FIXME','Missing name',3),(25569661,'highway','residential',3),(25569661,'source','yahoo',3),(25569665,'created_by','Potlatch 0.9c',2),(25569665,'highway','secondary',2),(25569665,'name','Avinguda del Pessebre',2),(25569665,'source','survey',2),(25569745,'bridge','yes',4),(25569745,'highway','tertiary',4),(25569745,'layer','1',4),(25569745,'name','Carrer de la Constituciò',4),(25569745,'source','survey',4),(25569748,'created_by','Potlatch 0.9c',1),(25569748,'highway','tertiary',1),(25569748,'name','Carrer de la Constituciò',1),(25569748,'source','survey',1),(25569755,'created_by','Potlatch 0.10f',2),(25569755,'highway','secondary',2),(25569755,'name','Avinguda de les Escoles',2),(25569755,'oneway','yes',2),(25569755,'source','survey',2),(25569775,'bridge','yes',3),(25569775,'highway','secondary',3),(25569775,'name','Avinguda de les Escoles',3),(25569775,'source','survey',3),(25572114,'created_by','Potlatch 0.9c',2),(25572114,'highway','residential',2),(25572121,'amenity','parking',2),(25572121,'created_by','Potlatch 0.9c',2),(25572130,'bridge','yes',3),(25572130,'created_by','Potlatch 0.9c',3),(25572130,'highway','residential',3),(25572130,'layer','1',3),(25572131,'created_by','Potlatch 0.9c',1),(25572131,'highway','residential',1),(25572572,'created_by','Potlatch 0.9c',1),(25572572,'highway','residential',1),(25572731,'created_by','Potlatch 0.9c',4),(25572731,'highway','residential',4),(25572741,'created_by','Potlatch 0.9c',1),(25572741,'highway','service',1),(25572746,'created_by','Potlatch 0.9c',3),(25572746,'highway','service',3),(25572749,'created_by','Potlatch 0.9c',2),(25572749,'highway','service',2),(25572883,'amenity','parking',1),(25572883,'created_by','Potlatch 0.9c',1),(25573596,'created_by','Potlatch 0.9c',2),(25573596,'highway','secondary',2),(25573596,'ref','CS-240',2),(25767814,'created_by','Potlatch 0.10',4),(25767814,'highway','tertiary',4),(25767814,'junction','roundabout',4),(25767827,'access','permissive',2),(25767827,'created_by','Potlatch 0.10',2),(25767827,'highway','service',2),(25767827,'name','Carrer Tossalet i Vinyols',2),(25767891,'created_by','Potlatch 0.10',1),(25768003,'access','no',12),(25768003,'bicycle','yes',12),(25768003,'created_by','Potlatch 0.10',12),(25768003,'highway','primary',12),(25768003,'motorcycle','yes',12),(25768003,'oneway','yes',12),(25768003,'psv','yes',12),(25768003,'ref','CG-1',12),(25768018,'created_by','Potlatch 0.10',12),(25768018,'highway','primary',12),(25768018,'oneway','yes',12),(25768018,'ref','CG-1',12),(25768677,'created_by','Potlatch 0.10',4),(25768677,'highway','primary',4),(25768677,'oneway','yes',4),(25768677,'ref','CG-1',4),(25768677,'source','yahoo',4),(25768681,'created_by','Potlatch 0.10',6),(25768681,'highway','primary',6),(25768681,'ref','CG-1',6),(25768681,'source','yahoo',6),(25768760,'highway','primary',3),(25768760,'junction','roundabout',3),(25768838,'created_by','Potlatch 0.10',3),(25768838,'highway','tertiary',3),(25768852,'created_by','Potlatch 0.10',6),(25768852,'highway','primary',6),(25768852,'oneway','yes',6),(25768852,'ref','CG-1',6),(25768868,'access','no',5),(25768868,'bicycle','yes',5),(25768868,'created_by','Potlatch 0.10',5),(25768868,'highway','primary',5),(25768868,'motorcycle','yes',5),(25768868,'oneway','yes',5),(25768868,'psv','yes',5),(25768868,'ref','CG-1',5),(25769024,'access','no',5),(25769024,'bicycle','yes',5),(25769024,'created_by','Potlatch 0.10',5),(25769024,'highway','primary',5),(25769024,'motorcycle','yes',5),(25769024,'oneway','yes',5),(25769024,'psv','yes',5),(25769024,'ref','CG-1',5),(25769049,'bridge','yes',3),(25769049,'created_by','Potlatch 0.10',3),(25769049,'highway','tertiary',3),(25769049,'layer','1',3),(25769049,'oneway','yes',3),(25769050,'created_by','Potlatch 0.10',1),(25769050,'highway','tertiary',1),(25769069,'access','no',4),(25769069,'bicycle','yes',4),(25769069,'bridge','yes',4),(25769069,'created_by','Potlatch 0.10f',4),(25769069,'highway','primary',4),(25769069,'layer','1',4),(25769069,'motorcycle','yes',4),(25769069,'name','Pont de Madrid',4),(25769069,'oneway','yes',4),(25769069,'psv','yes',4),(25769069,'ref','CG-1',4),(25769071,'access','no',4),(25769071,'bicycle','yes',4),(25769071,'created_by','Potlatch 0.10',4),(25769071,'highway','primary',4),(25769071,'motorcycle','yes',4),(25769071,'oneway','yes',4),(25769071,'psv','yes',4),(25769071,'ref','CG-1',4),(25769112,'created_by','Potlatch 0.10f',6),(25769112,'highway','primary',6),(25769112,'oneway','yes',6),(25769112,'ref','CG-1',6),(25769116,'bridge','yes',3),(25769116,'created_by','Potlatch 0.10f',3),(25769116,'highway','primary',3),(25769116,'layer','1',3),(25769116,'name','Pont de Madrid',3),(25769116,'oneway','yes',3),(25769116,'ref','CG-1',3),(25769122,'created_by','Potlatch 0.10',3),(25769122,'highway','primary',3),(25769122,'oneway','yes',3),(25769122,'ref','CG-1',3),(25769124,'bridge','yes',3),(25769124,'created_by','Potlatch 0.10f',3),(25769124,'highway','primary',3),(25769124,'layer','1',3),(25769124,'name','Pont de Madrid',3),(25769124,'oneway','yes',3),(25769124,'ref','CG-1',3),(25769182,'created_by','Potlatch 0.10',3),(25769182,'highway','primary',3),(25769182,'ref','CG-2',3),(25769182,'source','yahoo',3),(25769229,'highway','primary',3),(25769229,'junction','roundabout',3),(25769702,'highway','residential',3),(25769702,'name','Carrer Camp Bastida',3),(25769702,'oneway','yes',3),(25769709,'created_by','Potlatch 0.10',2),(25769709,'highway','tertiary',2),(25769709,'name','Carrer Camp Pauet',2),(25769726,'created_by','Potlatch 0.10',2),(25769726,'highway','service',2),(25769726,'name','Passatge de Cedre',2),(25769803,'created_by','Potlatch 0.10',6),(25769803,'highway','unclassified',6),(25769803,'name','Carrer Mossèn Lluis Pujol',6),(25769822,'created_by','Potlatch 0.10',1),(25769822,'highway','residential',1),(25769822,'name','El Contrapàs',1),(25769829,'created_by','Potlatch 0.10',3),(25769829,'highway','unclassified',3),(25769829,'name','Carrer Roureda Tapada',3),(25769891,'created_by','Potlatch 0.10',1),(25769891,'highway','residential',1),(25769891,'name','Carrer R',1),(25769893,'created_by','Potlatch 0.10',3),(25769893,'highway','unclassified',3),(25769893,'name','Carrer de Cedre',3),(25769922,'created_by','Potlatch 0.10',2),(25769922,'highway','unclassified',2),(25769922,'name','Carrer de Cedre',2),(25769970,'created_by','Potlatch 0.10',4),(25769970,'highway','unclassified',4),(25769970,'name','Carrer del Barrers',4),(25769974,'created_by','Potlatch 0.10',2),(25769974,'highway','unclassified',2),(25769974,'name','Carrer de la Tartera',2),(25770088,'created_by','Potlatch 0.10',2),(25770088,'highway','unclassified',2),(25770088,'name','Cami Ral',2),(25770391,'created_by','Potlatch 0.10',1),(25770391,'highway','service',1),(25770391,'name','Passatge de Cedre',1),(25770445,'created_by','Potlatch 0.10',2),(25770445,'highway','unclassified',2),(25770445,'name','Carrer de la Closa',2),(25770728,'area','yes',1),(25770728,'created_by','Potlatch 0.10',1),(25770728,'highway','pedestrian',1),(25770728,'name','Plaça Guillemó',1),(25770737,'created_by','Potlatch 0.10',1),(25770737,'highway','tertiary',1),(25770737,'name','Carrer Mossèn Tremosa',1),(25770737,'source','yahoo survey',1),(25770744,'created_by','Potlatch 0.10',1),(25770744,'highway','tertiary',1),(25770744,'name','Carrer Mossèn Tremosa',1),(25770744,'source','yahoo survey',1),(25770745,'created_by','Potlatch 0.10',2),(25770745,'highway','tertiary',2),(25770745,'name','Plaça Guillemó',2),(25770745,'source','yahoo survey',2),(25771015,'created_by','Potlatch 0.10',1),(25771015,'highway','unclassified',1),(25771015,'name','Carrer Roc de l\'Aldias',1),(25771079,'created_by','Potlatch 0.10',1),(25771079,'highway','unclassified',1),(25771079,'name','Carrer Font del Pujal',1),(25771241,'created_by','Potlatch 0.10',4),(25771241,'highway','unclassified',4),(25771241,'name','Carrer Mestre Xavier Plana',4),(25825533,'created_by','Potlatch 0.10',1),(25825533,'highway','primary',1),(25825533,'name','Travessia d\'Ordino',1),(25825533,'ref','CG-3',1),(25825533,'source','user 3ld',1),(26001987,'created_by','Potlatch 0.10b',2),(26001987,'highway','pedestrian',2),(26001987,'name','Carrer Major',2),(26002036,'created_by','Potlatch 0.10b',2),(26002036,'highway','residential',2),(26243488,'created_by','Potlatch 0.10f',5),(26243488,'highway','primary',5),(26243488,'name','Avinguda Sant Antoni',5),(26243488,'ref','CG-3',5),(26243580,'highway','primary',4),(26243580,'junction','roundabout',4),(26243608,'created_by','Potlatch 0.10f',3),(26243608,'highway','unclassified',3),(26243608,'source','yahoo',3),(26243681,'created_by','Potlatch 0.10b',1),(26243681,'highway','secondary',1),(26243681,'name','Carretera de Sispony',1),(26243681,'ref','CS-320',1),(26243895,'access','permissive',1),(26243895,'amenity','parking',1),(26243895,'area','yes',1),(26243895,'created_by','Potlatch 0.10b',1),(26243895,'landuse','commercial',1),(26455183,'created_by','Potlatch 0.10b',2),(26455183,'highway','secondary',2),(26455183,'name','Carretera de Vila-Beixalis',2),(26455183,'ref','CS-210',2),(26455183,'source','yahoo',2),(26553947,'highway','secondary',3),(26553947,'tracktype','grade2',3),(26554007,'amenity','parking',1),(26554007,'created_by','Potlatch 0.10b',1),(26668563,'created_by','Potlatch 0.10f',4),(26668563,'highway','primary',4),(26668563,'maxspeed','90',4),(26668563,'name','Avingunda del Consell General',4),(26668563,'ref','CG-2',4),(26668563,'source','yahoo',4),(27826413,'highway','unclassified',2),(27826413,'source','yahoo',2),(28828385,'created_by','Potlatch 0.10f',1),(28828385,'highway','residential',1),(28828385,'name','Carrer de les Entrades',1),(28828388,'created_by','Potlatch 0.10f',2),(28828388,'highway','residential',2),(28828388,'name','Carrer de Josep Rossel',2),(28828789,'created_by','Potlatch 0.10f',1),(28828789,'highway','residential',1),(28828789,'name','Carrer de Josep Rossel',1),(28829736,'created_by','Potlatch 0.10f',1),(28829736,'highway','unclassified',1),(28829748,'created_by','Potlatch 0.10f',6),(28829748,'highway','unclassified',6),(28829753,'created_by','Potlatch 0.10f',5),(28829753,'highway','unclassified',5),(28829766,'created_by','Potlatch 0.10f',7),(28829766,'highway','unclassified',7),(28829773,'created_by','Potlatch 0.10f',2),(28829773,'highway','unclassified',2),(28829779,'created_by','Potlatch 0.10f',1),(28829779,'highway','unclassified',1),(28829910,'created_by','Potlatch 0.10f',1),(28829910,'highway','track',1),(28829910,'tracktype','grade2',1),(28829964,'access','designated',1),(28829964,'created_by','Potlatch 0.10f',1),(28829964,'highway','track',1),(28829967,'created_by','Potlatch 0.10f',3),(28829967,'highway','track',3),(28829967,'tracktype','grade2',3),(28832922,'created_by','Potlatch 0.10f',1),(28832922,'highway','unclassified',1),(28832923,'bridge','yes',2),(28832923,'created_by','Potlatch 0.10f',2),(28832923,'highway','unclassified',2),(28832923,'layer','1',2),(28833468,'bicycle','no',4),(28833468,'created_by','Potlatch 0.10f',4),(28833468,'foot','yes',4),(28833468,'highway','steps',4),(28833468,'motorcycle','no',4),(28833468,'name','Cami de les Molleres',4),(28833468,'step_count','75',4),(28833770,'highway','primary',4),(28833770,'maxspeed','50',4),(28833770,'name','Avingunda del Consell General',4),(28833770,'ref','CG-2',4),(28833770,'source','yahoo',4),(28833880,'highway','primary',4),(28833880,'maxspeed','90',4),(28833880,'name','Port d\'Envalira',4),(28833880,'ref','CG-2',4),(28833880,'source','yahoo',4),(28833924,'highway','primary',2),(28833924,'maxspeed','90',2),(28833924,'name','Port d\'Envalira',2),(28833924,'ref','CG-2',2),(28833924,'source','yahoo',2),(28833927,'highway','primary',3),(28833927,'maxspeed','30',3),(28833927,'name','Port d\'Envalira',3),(28833927,'ref','CG-2',3),(28833927,'source','yahoo',3),(28833935,'highway','primary',2),(28833935,'maxspeed','90',2),(28833935,'name','Port d\'Envalira',2),(28833935,'ref','CG-2',2),(28833935,'source','yahoo',2),(28833936,'highway','primary',3),(28833936,'maxspeed','30',3),(28833936,'name','Port d\'Envalira',3),(28833936,'ref','CG-2',3),(28833936,'source','yahoo',3),(28833957,'highway','primary',2),(28833957,'maxspeed','90',2),(28833957,'name','Port d\'Envalira',2),(28833957,'ref','CG-2',2),(28833957,'source','yahoo',2),(28833958,'highway','primary',3),(28833958,'maxspeed','30',3),(28833958,'name','Port d\'Envalira',3),(28833958,'ref','CG-2',3),(28833958,'source','yahoo',3),(29051459,'access','private',6),(29051459,'created_by','Potlatch 0.10f',6),(29051459,'highway','unclassified',6),(29249135,'highway','path',2),(29249135,'mtb:scale','2',2),(29249135,'mtb:scale:uphill','4',2),(29249135,'sac_scale','alpine_hiking',2),(29249136,'highway','path',2),(29249136,'mtb:scale','1',2),(29249136,'mtb:scale:uphill','4',2),(29249136,'sac_scale','demanding_alpine_hiking',2),(29249700,'highway','path',3),(29249700,'mtb:scale','3',3),(29249700,'mtb:scale:uphill','5',3),(29249700,'name','Mountainbike Downhill',3),(29249700,'surface','unpaved',3),(29376254,'aerialway','cable_car',3),(29376254,'aerialway:occupancy','16',3),(29376254,'name','La Massana',3),(29376356,'aerialway','gondola',4),(29376356,'name','Els Orriols',4),(29376448,'bridge','yes',1),(29376448,'created_by','Potlatch 0.10f',1),(29376448,'foot','yes',1),(29376448,'highway','footway',1),(29376448,'layer','1',1),(29422567,'created_by','Potlatch 0.10f',2),(29422567,'highway','unclassified',2),(29422567,'name','Carrer Gil Torres',2),(30139079,'created_by','Potlatch 0.10f',1),(30139079,'foot','yes',1),(30139079,'highway','path',1),(30139093,'created_by','Potlatch 0.10f',2),(30139093,'highway','track',2),(30139093,'name','Cami de Santa Bàrbara',2),(30139093,'tracktype','grade3',2),(30139242,'created_by','Potlatch 0.10f',1),(30139242,'highway','track',1),(30139242,'name','Cami Ral',1),(30139242,'tracktype','grade3',1),(30139403,'created_by','Potlatch 0.10f',1),(30139403,'highway','steps',1),(30139408,'created_by','Potlatch 0.10f',1),(30139408,'highway','footway',1),(30567238,'created_by','Potlatch 0.10f',1),(30567238,'highway','service',1),(30567542,'created_by','Potlatch 0.10f',2),(30567542,'highway','secondary',2),(30567542,'name','Vial de la Uniò',2),(30567542,'oneway','yes',2),(30571624,'created_by','Potlatch 0.10f',2),(30571624,'foot','yes',2),(30571624,'highway','footway',2),(30572100,'created_by','Potlatch 0.10f',1),(30572100,'foot','yes',1),(30572100,'highway','footway',1),(30572100,'name','Cami del Barranc de la font del Mosquit',1),(30572104,'created_by','Potlatch 0.10f',2),(30572104,'foot','yes',2),(30572104,'highway','footway',2),(30572104,'name','Cami del Barranc de la font del Mosquit',2),(30572116,'created_by','Potlatch 0.10f',2),(30572116,'foot','yes',2),(30572116,'highway','steps',2),(30572116,'name','Cami del Barranc de la font del Mosquit',2),(30572116,'step_count','52',2),(30572138,'created_by','Potlatch 0.10f',1),(30572138,'foot','yes',1),(30572138,'highway','footway',1),(30572138,'name','Cami del Barranc de la font del Mosquit',1),(30572145,'created_by','Potlatch 0.10f',2),(30572145,'foot','yes',2),(30572145,'highway','steps',2),(30572145,'name','Cami del Barranc de la font del Mosquit',2),(30572145,'step_count','16',2),(30572187,'created_by','Potlatch 0.10f',1),(30572187,'foot','yes',1),(30572187,'highway','footway',1),(30605340,'created_by','Potlatch 0.10f',3),(30605340,'landuse','residential',3),(30605340,'name','Residencial Barraca',3),(30605380,'created_by','Potlatch 0.10f',2),(30605380,'highway','service',2),(30605457,'created_by','Potlatch 0.10f',2),(30605457,'foot','yes',2),(30605457,'highway','footway',2),(30605650,'created_by','Potlatch 0.10f',1),(30605650,'foot','yes',1),(30605650,'highway','footway',1),(30605670,'created_by','Potlatch 0.10f',3),(30605670,'foot','yes',3),(30605670,'highway','footway',3),(30605680,'created_by','Potlatch 0.10f',2),(30605683,'created_by','Potlatch 0.10f',2),(30605683,'foot','yes',2),(30605683,'highway','footway',2),(30605686,'created_by','Potlatch 0.10f',1),(30605686,'foot','yes',1),(30605686,'highway','footway',1),(30605697,'created_by','Potlatch 0.10f',1),(30605697,'foot','yes',1),(30605697,'highway','steps',1),(30605697,'name','Cami del Solanell',1),(30605697,'step_count','64',1),(30605698,'created_by','Potlatch 0.10f',1),(30605698,'foot','yes',1),(30605698,'highway','footway',1),(30605698,'name','Cami del Solanell',1),(30605769,'created_by','Potlatch 0.10f',1),(30605769,'highway','track',1),(30605769,'name','Cami del Solanell',1),(30605769,'surface','dirt',1),(30772650,'amenity','police',1),(30772650,'created_by','Potlatch 0.10f',1),(30772702,'amenity','parking',1),(30772702,'created_by','Potlatch 0.10f',1),(30922493,'created_by','Potlatch 0.10f',2),(30922493,'highway','secondary',2),(30922493,'name','Avinguda Carlemany',2),(30922493,'oneway','yes',2),(30922493,'source','yahoo',2),(30922528,'created_by','Potlatch 0.10f',1),(30922528,'highway','secondary',1),(30922528,'name','Avinguda Carlemany',1),(30922528,'source','survey',1),(31348544,'created_by','Potlatch 0.10f',5),(31348544,'highway','secondary',5),(31348544,'name','Carretera de Canòlich',5),(31348544,'ref','CS-111',5),(31348633,'highway','unclassified',2),(31726348,'created_by','Potlatch 0.10f',4),(31726348,'highway','primary',4),(31726348,'oneway','yes',4),(31726348,'ref','CG-3',4),(31726348,'source','yahoo',4),(31726372,'created_by','Potlatch 0.10f',3),(31726372,'highway','primary',3),(31726372,'junction','roundabout',3),(31726416,'created_by','Potlatch 0.10f',3),(31726416,'highway','primary',3),(31726416,'oneway','yes',3),(31726416,'ref','CG-3',3),(31726416,'source','yahoo',3),(31726467,'created_by','Potlatch 0.10f',2),(31726467,'highway','primary',2),(31726467,'oneway','yes',2),(31726467,'ref','CG-3',2),(31726467,'source','yahoo',2),(31726482,'created_by','Potlatch 0.10f',2),(31726482,'highway','primary',2),(31726482,'oneway','yes',2),(31726482,'ref','CG-3',2),(31726482,'source','yahoo',2),(31726492,'created_by','Potlatch 0.10f',3),(31726492,'highway','secondary',3),(31726492,'name','Carretera de l\'Aldosa',3),(31726492,'oneway','yes',3),(31726492,'ref','CS-335',3),(31726492,'source','yahoo',3),(31726507,'created_by','Potlatch 0.10f',2),(31726507,'highway','secondary',2),(31726507,'name','Carretera de l\'Aldosa',2),(31726507,'oneway','yes',2),(31726507,'ref','CS-335',2),(31726661,'created_by','Potlatch 0.10f',6),(31726661,'highway','primary',6),(31726661,'ref','CG-3',6),(31726661,'source','yahoo',6),(31726701,'created_by','Potlatch 0.10f',5),(31726701,'highway','primary',5),(31726701,'ref','CG-3',5),(31726701,'source','yahoo',5),(31726779,'highway','primary',10),(31726779,'junction','roundabout',10),(31726779,'source','yahoo',10),(31726812,'created_by','Potlatch 0.10f',2),(31726812,'highway','primary',2),(31726812,'ref','CG-3',2),(31726812,'source','yahoo',2),(31726851,'created_by','Potlatch 0.10f',3),(31726851,'highway','primary',3),(31726851,'ref','CG-3',3),(31726851,'source','yahoo',3),(31726898,'created_by','Potlatch 0.10f',2),(31726898,'highway','residential',2),(32211744,'created_by','Potlatch 0.10f',2),(32211744,'highway','tertiary',2),(32211744,'name','Carrer Ciutat de Sabadell',2),(32211744,'oneway','yes',2),(32211744,'source','yahoo',2),(32549432,'created_by','Potlatch 0.10f',2),(32549432,'highway','track',2),(32549444,'created_by','Potlatch 0.10f',2),(32549444,'natural','wood',2),(32551123,'created_by','Potlatch 0.10f',1),(32551123,'highway','track',1),(32551125,'highway','track',3),(32594779,'highway','track',2),(32594984,'highway','track',2),(32594985,'created_by','Potlatch 0.10f',1),(32594985,'highway','track',1),(32598297,'created_by','Potlatch 0.10f',4),(32598297,'highway','track',4),(32598297,'name','Cami de Padern',4),(32598300,'created_by','Potlatch 0.10f',3),(32598300,'highway','track',3),(32598313,'created_by','Potlatch 0.10f',3),(32598313,'highway','track',3),(32598338,'created_by','Potlatch 0.10f',2),(32598338,'highway','track',2),(32598345,'created_by','Potlatch 0.10f',1),(32598345,'highway','track',1),(32676714,'highway','path',6),(32676714,'mtb:scale','2',6),(32676714,'mtb:scale:uphill','4',6),(32676714,'ref','CS-320',6),(32676739,'highway','track',4),(32676739,'mtb:scale','0',4),(32676739,'mtb:scale:uphill','0',4),(32676739,'tracktype','grade3',4),(32676743,'highway','path',2),(32676743,'mtb:scale','3',2),(32676743,'mtb:scale:uphill','5',2),(32676746,'highway','path',1),(32676749,'highway','track',2),(32676749,'mtb:scale','0',2),(32676749,'mtb:scale:uphill','0',2),(32676749,'tracktype','grade2',2),(32676753,'highway','path',3),(32676753,'mtb:scale','0',3),(32676753,'mtb:scale:uphill','1',3),(32676755,'highway','track',2),(32676755,'mtb:scale','0',2),(32676755,'mtb:scale:uphill','0',2),(32676755,'tracktype','grade2',2),(32722266,'created_by','Potlatch 0.10f',4),(32722266,'highway','secondary',4),(32722266,'name','Carretera dels Cortals',4),(32722266,'ref','CS-320',4),(32722447,'created_by','Potlatch 0.10f',2),(32722447,'highway','secondary',2),(32722447,'name','Carretera de Fontaneda',2),(32722447,'ref','CS-140',2),(32722515,'created_by','Potlatch 0.10f',2),(32722515,'highway','track',2),(32722515,'name','Carretera de Canòlich',2),(32722515,'ref','CS-111',2),(32722515,'tracktype','grade3',2),(32722544,'created_by','Potlatch 0.10f',1),(32722544,'highway','secondary',1),(32722544,'name','Carretera de Mas d\'Alins',1),(32722544,'ref','CS-142',1),(32722657,'created_by','Potlatch 0.10f',1),(32722657,'highway','secondary',1),(32722657,'name','Carretera Secundaria de la Rabassa',1),(32722657,'ref','CS-130',1),(32722658,'bridge','yes',3),(32722658,'created_by','Potlatch 0.10f',3),(32722658,'highway','secondary',3),(32722658,'layer','1',3),(32722658,'name','Carretera Secundaria de la Rabassa',3),(32722658,'ref','CS-130',3),(32722762,'created_by','Potlatch 0.10f',4),(32722762,'highway','secondary',4),(32722762,'name','Carretera Secundaria de la Rabassa',4),(32722762,'ref','CS-130',4),(32722815,'created_by','Potlatch 0.10f',3),(32722815,'highway','secondary',3),(32722815,'name','Carretera de la Rabassa',3),(32722815,'ref','CS-131',3),(32819051,'created_by','Potlatch 0.10f',2),(32819051,'highway','secondary',2),(32819051,'name','Carrer Major',2),(32819051,'ref','CS-320',2),(32819142,'created_by','Potlatch 0.10f',4),(32819142,'highway','secondary',4),(32819142,'maxweight','2.1',4),(32819142,'name','Carretera dels Cortals',4),(32819142,'ref','CS-320',4),(32845037,'created_by','Potlatch 0.10f',3),(32845037,'highway','secondary',3),(32845037,'name','Carretera Sant Cristofol',3),(32845037,'ref','CS-310',3),(32845037,'source','yahoo',3),(32845056,'bridge','yes',3),(32845056,'created_by','Potlatch 0.10f',3),(32845056,'highway','secondary',3),(32845056,'layer','1',3),(32845056,'name','Pont d\'Anyos',3),(32845056,'ref','CS-310',3),(32845056,'source','yahoo',3),(32845063,'created_by','Potlatch 0.10f',1),(32845063,'highway','secondary',1),(32845063,'name','Carretera Sant Cristofol',1),(32845063,'ref','CS-310',1),(32845063,'source','yahoo',1),(32936885,'created_by','Potlatch 0.10f',2),(32936885,'highway','residential',2),(32936960,'created_by','Potlatch 0.10f',1),(32936960,'highway','residential',1),(32937000,'created_by','Potlatch 0.10f',1),(32937000,'highway','unclassified',1),(32937225,'created_by','Potlatch 0.10f',3),(32937225,'highway','residential',3),(32937225,'name','Cami de Padern',3),(32937397,'created_by','Potlatch 0.10f',1),(32937397,'highway','residential',1),(32937466,'created_by','Potlatch 0.10f',1),(32937466,'landuse','cemetery',1),(32973912,'created_by','Potlatch 0.10f',2),(32973912,'highway','track',2),(33184240,'created_by','Potlatch 0.10f',1),(33184240,'highway','track',1),(33184240,'mtb:scale','0',1),(33184240,'mtb:scale:uphill','3',1),(33184240,'surface','ground',1),(33184240,'tracktype','grade5',1),(33184244,'highway','path',1),(33184244,'mtb:scale','1',1),(33184244,'mtb:scale:uphill','1',1),(33184244,'sac_scale','alpine_hiking',1),(33184247,'highway','path',1),(33184247,'mtb:scale','5',1),(33184247,'mtb:scale:uphill','5',1),(33184247,'sac_scale','demanding_alpine_hiking',1),(33184252,'highway','track',1),(33184252,'mtb:scale','2',1),(33184252,'mtb:scale:uphill','2',1),(33184252,'sac_scale','demanding_alpine_hiking',1),(33184252,'tracktype','grade5',1),(33184266,'highway','path',1),(33184266,'mtb:scale','1',1),(33184266,'mtb:scale:uphill','2',1),(33184266,'sac_scale','alpine_hiking',1),(33184270,'created_by','Potlatch 0.10f',1),(33184270,'highway','track',1),(33184270,'mtb:scale','0',1),(33184270,'mtb:scale:uphill','0',1),(33184270,'ref','CS-320',1),(33184270,'tracktype','grade2',1),(33713550,'created_by','Potlatch 0.10',2),(33713550,'highway','secondary',2),(33713550,'name','Avinguda Príncep Benlloch',2),(33721575,'amenity','parking',1),(33733175,'highway','residential',2),(34062547,'created_by','Potlatch 0.10f',5),(34062547,'highway','path',5),(34062547,'name','Cami de Rebolians',5),(34062547,'note','This trace needs some work. Not that accurate!',5),(34062881,'created_by','Potlatch 0.10f',4),(34062881,'highway','path',4),(34062881,'name','Cami de les Barreres',4),(34062881,'sac_scale','mountain_hiking',4),(34062881,'source','Fixed by User:3ld with GPS, May 4 2009',4),(34062881,'trail_visibility','intermediate',4),(34063687,'highway','path',1),(34063687,'name','Cami de Rebolians',1),(34063687,'sac_scale','hiking',1),(34063687,'source','Fixed by User:3ld with GPS, May 4 2009',1),(34063687,'trail_visibility','intermediate',1),(34063704,'bridge','yes',1),(34063704,'highway','path',1),(34063704,'layer','1',1),(34063704,'name','Cami de Rebolians',1),(34063704,'source','Fixed by User:3ld with GPS, May 4 2009',1),(34063704,'trail_visibility','intermediate',1),(34063735,'boat','no',2),(34063735,'waterway','stream',2),(34063769,'bridge','yes',3),(34063769,'created_by','Potlatch 0.8c',3),(34063769,'highway','secondary',3),(34063769,'layer','1',3),(34063769,'name','Carretera de la Creu Blanca',3),(34063769,'ref','CS-335',3),(34063769,'source','yahoo',3),(34063770,'created_by','Potlatch 0.8c',1),(34063770,'highway','secondary',1),(34063770,'name','Carretera de la Creu Blanca',1),(34063770,'ref','CS-335',1),(34063770,'source','yahoo',1),(34064472,'highway','track',2),(34064472,'tracktype','grade4',2),(34064472,'vehicle','agricultural',2),(34064813,'foot','yes',2),(34064813,'highway','track',2),(34064813,'tracktype','grade4',2),(34064813,'vehicle','agricultural',2),(34064907,'highway','unclassified',1),(34065105,'highway','track',1),(34065105,'tracktype','grade3',1),(34065671,'highway','footway',2),(34065671,'name','Carrer Cal Giberga',2),(34065735,'highway','secondary',3),(34065735,'name','Carretera de la Creu Blanca',3),(34065735,'ref','CS-335',3),(34065735,'source','yahoo',3),(34387676,'highway','residential',1),(34387676,'name','Termes de Tarteres',1),(34387821,'highway','residential',2),(34387821,'name','Marge i Terres No.3',2),(34388549,'highway','residential',3),(34388549,'name','Marge i Terres No.2',3),(34389528,'highway','residential',1),(34389528,'name','Tarteres del Mig Carretera 2',1),(34390093,'highway','unclassified',1),(34390103,'highway','residential',3),(34390103,'name','Termes de Tarteres',3),(34390499,'highway','residential',1),(34390499,'name','Terme Camp dels Mare de Deu',1),(34390581,'access','private',1),(34390581,'highway','unclassified',1),(34390594,'highway','residential',2),(34390594,'name','Terra Hortells tambe Caubella',2),(34876322,'amenity','parking',3),(34876405,'highway','service',1),(35444733,'highway','path',1),(35444733,'name','Camì de les Barreres',1),(35444733,'sac_scale','mountain_hiking',1),(35444733,'trail_visibility','intermediate',1),(37633206,'access','private',1),(37633206,'highway','service',1),(37633275,'highway','residential',1),(37633404,'access','yes',1),(37633404,'highway','track',1),(37633404,'surface','dirt',1),(37756343,'highway','service',2),(37756386,'amenity','parking',1),(37865954,'created_by','Potlatch 0.10b',2),(37865954,'highway','service',2),(37865954,'name','Camì de les Pardines',2),(38706653,'highway','path',4),(38706653,'name','Cami del Roc de Castell',4),(38706653,'sac_scale','alpine_hiking',4),(38706653,'trail_visibility','good',4),(38706925,'highway','service',1),(38706927,'bridge','yes',3),(38706927,'highway','path',3),(38706927,'layer','1',3),(38706927,'name','Cami de Sedornet',3),(38706927,'sac_scale','alpine_hiking',3),(38706927,'trail_visibility','good',3),(38706928,'highway','path',7),(38706928,'name','Cami de Coll de les Cases',7),(38706928,'sac_scale','alpine_hiking',7),(38706928,'trail_visibility','good',7),(38706936,'highway','path',1),(38706936,'name','Cami de Sedornet',1),(38706936,'sac_scale','alpine_hiking',1),(38706936,'trail_visibility','good',1),(39258136,'boat','no',3),(39258136,'natural','waterfall',3),(39258136,'waterway','stream',3),(39258137,'boat','no',1),(39258137,'waterway','stream',1),(39258144,'boat','no',1),(39258144,'waterway','stream',1),(39258742,'highway','path',2),(39258742,'name','Cami de Sedornet',2),(39258742,'sac_scale','mountain_hiking',2),(39258742,'trail_visibility','good',2),(39259019,'highway','path',1),(39259019,'trail_visibility','good',1),(39259022,'highway','steps',1),(39259022,'step_count','6',1),(39259088,'highway','service',2),(39259092,'highway','footway',1),(39259147,'access','private',1),(39259147,'amenity','parking',1),(39259506,'created_by','Potlatch 0.9c',2),(39259506,'highway','unclassified',2),(39259666,'amenity','parking',1),(39259759,'boat','no',3),(39259759,'layer','0',3),(39259759,'waterway','stream',3),(39259769,'created_by','Potlatch 0.9c',1),(39259769,'highway','primary',1),(39259769,'name','Carretera General',1),(39259769,'ref','CG-3',1),(39259769,'source','user 3ld',1),(39259770,'bridge','yes',2),(39259770,'created_by','Potlatch 0.9c',2),(39259770,'highway','primary',2),(39259770,'layer','1',2),(39259770,'name','Carretera General',2),(39259770,'ref','CG-3',2),(39259770,'source','user 3ld',2),(40064501,'sport','skiing',1),(40064876,'sport','skiing',2),(40065172,'sport','skiing',1),(40065349,'highway','path',2),(40065349,'sac_scale','mountain_hiking',2),(40065349,'trail_visibility','intermediate',2),(40065810,'highway','path',1),(40065810,'sac_scale','mountain_hiking',1),(40065810,'trail_visibility','intermediate',1),(40065893,'boat','no',1),(40065893,'name','Riu d\'Angonella',1),(40065893,'waterway','stream',1),(40067891,'highway','path',3),(40067891,'name','Cami del Llacs d\'Angonella',3),(40067891,'sac_scale','mountain_hiking',3),(40067891,'trail_visibility','good',3),(40137318,'highway','secondary',1),(40137318,'name','Vial de la Uniò',1),(40137318,'source','yahoo',1),(40264409,'highway','path',1),(40264409,'sac_scale','demanding_mountain_hiking',1),(40264410,'highway','path',1),(40264410,'sac_scale','mountain_hiking',1),(41785125,'CLC:code','112',1),(41785125,'CLC:id','FR-245890',1),(41785125,'CLC:year','2006',1),(41785125,'landuse','residential',1),(41785125,'source','Union européenne - SOeS, CORINE Land Cover, 2006.',1),(41935429,'CLC:code','231',1),(41935429,'CLC:id','FR-245641',1),(41935429,'CLC:year','2006',1),(41935429,'landuse','meadow',1),(41935429,'source','Union européenne - SOeS, CORINE Land Cover, 2006.',1),(42014211,'aerialway','chair_lift',2),(42014211,'aerialway:occupancy','6',2),(42014211,'name','Arinsal',2),(42021998,'CLC:code','312',1),(42021998,'CLC:id','FR-245775',1),(42021998,'CLC:year','2006',1),(42021998,'landuse','forest',1),(42021998,'source','Union européenne - SOeS, CORINE Land Cover, 2006.',1),(42021998,'wood','coniferous',1),(42055725,'CLC:code','312',1),(42055725,'CLC:id','FR-245763',1),(42055725,'CLC:year','2006',1),(42055725,'landuse','forest',1),(42055725,'source','Union européenne - SOeS, CORINE Land Cover, 2006.',1),(42055725,'wood','coniferous',1),(42055772,'CLC:code','312',1),(42055772,'CLC:id','FR-246005',1),(42055772,'CLC:year','2006',1),(42055772,'landuse','forest',1),(42055772,'source','Union européenne - SOeS, CORINE Land Cover, 2006.',1),(42055772,'wood','coniferous',1),(42235196,'CLC:code','321',1),(42235196,'CLC:id','FR-244995',1),(42235196,'CLC:year','2006',1),(42235196,'natural','grassland',1),(42235196,'source','Union européenne - SOeS, CORINE Land Cover, 2006.',1),(42235209,'CLC:code','332',2),(42235209,'CLC:id','FR-245065',2),(42235209,'CLC:year','2006',2),(42235209,'natural','rock',2),(42235209,'source','Union européenne - SOeS, CORINE Land Cover, 2006.',2),(42235226,'CLC:code','321',1),(42235226,'CLC:id','FR-245362',1),(42235226,'CLC:year','2006',1),(42235226,'natural','grassland',1),(42235226,'source','Union européenne - SOeS, CORINE Land Cover, 2006.',1),(42235229,'CLC:code','332',1),(42235229,'CLC:id','FR-245404',1),(42235229,'CLC:year','2006',1),(42235229,'natural','rock',1),(42235229,'source','Union européenne - SOeS, CORINE Land Cover, 2006.',1),(42235235,'CLC:code','321',1),(42235235,'CLC:id','FR-245529',1),(42235235,'CLC:year','2006',1),(42235235,'natural','grassland',1),(42235235,'source','Union européenne - SOeS, CORINE Land Cover, 2006.',1),(42235255,'CLC:code','332',1),(42235255,'CLC:id','FR-245865',1),(42235255,'CLC:year','2006',1),(42235255,'natural','rock',1),(42235255,'source','Union européenne - SOeS, CORINE Land Cover, 2006.',1),(42235256,'CLC:code','321',1),(42235256,'CLC:id','FR-245777',1),(42235256,'CLC:year','2006',1),(42235256,'natural','grassland',1),(42235256,'source','Union européenne - SOeS, CORINE Land Cover, 2006.',1),(42252195,'CLC:code','321',3),(42252195,'CLC:id','FR-245139',3),(42252195,'CLC:year','2006',3),(42252195,'natural','grassland',3),(42252195,'source','Union européenne - SOeS, CORINE Land Cover, 2006.',3),(42252243,'CLC:code','321',1),(42252243,'CLC:id','FR-245313',1),(42252243,'CLC:year','2006',1),(42252243,'natural','grassland',1),(42252243,'source','Union européenne - SOeS, CORINE Land Cover, 2006.',1),(42252251,'CLC:code','322',1),(42252251,'CLC:id','FR-245372',1),(42252251,'CLC:year','2006',1),(42252251,'natural','heath',1),(42252251,'source','Union européenne - SOeS, CORINE Land Cover, 2006.',1),(42252272,'CLC:code','332',1),(42252272,'CLC:id','FR-245397',1),(42252272,'CLC:year','2006',1),(42252272,'natural','rock',1),(42252272,'source','Union européenne - SOeS, CORINE Land Cover, 2006.',1),(42252309,'CLC:code','512',1),(42252309,'CLC:id','FR-245454',1),(42252309,'CLC:year','2006',1),(42252309,'natural','water',1),(42252309,'source','Union européenne - SOeS, CORINE Land Cover, 2006.',1),(42252326,'CLC:code','321',1),(42252326,'CLC:id','FR-245517',1),(42252326,'CLC:year','2006',1),(42252326,'natural','grassland',1),(42252326,'source','Union européenne - SOeS, CORINE Land Cover, 2006.',1),(42252348,'CLC:code','321',1),(42252348,'CLC:id','FR-245597',1),(42252348,'CLC:year','2006',1),(42252348,'natural','grassland',1),(42252348,'source','Union européenne - SOeS, CORINE Land Cover, 2006.',1),(42252384,'CLC:code','321',1),(42252384,'CLC:id','FR-245738',1),(42252384,'CLC:year','2006',1),(42252384,'natural','grassland',1),(42252384,'source','Union européenne - SOeS, CORINE Land Cover, 2006.',1),(42451011,'highway','residential',2),(42451011,'name','Carrer Antoni Fiter i Rossell',2),(42451011,'oneway','yes',2),(42451016,'highway','tertiary',2),(42451016,'name','La Carrera Nova',2),(42451016,'oneway','yes',2),(42451892,'highway','residential',3),(42451892,'name','El Buners d\'Ordino',3),(42809904,'highway','track',2),(42809904,'tracktype','grade2',2),(42810813,'highway','primary',1),(42810813,'ref','CG-2',1),(42810813,'source','yahoo',1),(42811127,'highway','primary',2),(42811127,'oneway','yes',2),(42811127,'ref','CG-2',2),(45511076,'admin_level','2',1),(45511076,'boundary','administrative',1),(45511076,'source','BDLL25, EGRN, Instituto Geográfico Nacional',1),(45511084,'admin_level','2',1),(45511084,'boundary','administrative',1),(45511084,'source','BDLL25, EGRN, Instituto Geográfico Nacional',1),(45511090,'admin_level','2',1),(45511090,'boundary','administrative',1),(45511090,'source','BDLL25, EGRN, Instituto Geográfico Nacional',1),(48271354,'aerialway','chair_lift',2),(48271354,'aerialway:occupancy','6',2),(48271354,'name','La Coma',2),(48271355,'aerialway','chair_lift',3),(48271355,'aerialway:occupancy','4',3),(48271355,'name','La Basera',3),(48271356,'aerialway','platter',2),(48271356,'name','L\'Abarsetar',2),(48928224,'name','Astoret',2),(48928224,'piste:difficulty','easy',2),(48928224,'piste:type','downhill',2),(48928225,'name','Os',4),(48928225,'piste:difficulty','easy',4),(48928225,'piste:type','downhill',4),(48928226,'name','Bosc Fosc',2),(48928226,'piste:difficulty','easy',2),(48928226,'piste:type','downhill',2),(48928227,'aerialway','chair_lift',1),(48928227,'aerialway:occupancy','6',1),(48928227,'name','Solana del Forn',1),(48928228,'aerialway','chair_lift',1),(48928228,'aerialway:occupancy','6',1),(48928228,'name','Tosa Espiolets',1),(48928229,'aerialway','chair_lift',1),(48928229,'aerialway:occupancy','6',1),(48928229,'name','Llosada',1),(48928230,'aerialway','chair_lift',1),(48928230,'aerialway:occupancy','4',1),(48928230,'name','Assalador',1),(48928231,'aerialway','chair_lift',1),(48928231,'aerialway:occupancy','4',1),(48928231,'name','Solanelles',1),(48928232,'aerialway','chair_lift',1),(48928232,'aerialway:capacity','2000',1),(48928232,'aerialway:occupancy','6',1),(48928232,'name','Soldeu',1),(48928233,'name','Avet',4),(48928233,'piste:difficulty','advanced',4),(48928233,'piste:type','downhill',4),(48928234,'aerialway','platter',4),(48928234,'aerialway:occupancy','1',4),(48928234,'name','Bosc',4),(48928234,'piste:lift','platter',4),(48928235,'name','Eslalom',2),(48928235,'piste:difficulty','advanced',2),(48928235,'piste:type','downhill',2),(48928236,'aerialway','platter',5),(48928236,'aerialway:occupancy','1',5),(48928236,'name','Bassots',5),(48928236,'piste:lift','platter',5),(48957244,'name','Colibri',2),(48957244,'piste:difficulty','intermediate',2),(48957244,'piste:type','downhill',2),(48957245,'name','Serrat Pinos',2),(48957245,'piste:difficulty','intermediate',2),(48957245,'piste:type','downhill',2),(48957246,'aerialway','chair_lift',1),(48957246,'aerialway:occupancy','4',1),(48957246,'name','Llac del Cubil',1),(48957247,'aerialway','chair_lift',1),(48957247,'aerialway:occupancy','4',1),(48957247,'name','Cubil',1),(48957248,'aerialway','chair_lift',1),(48957248,'aerialway:occupancy','6',1),(48957248,'name','Coma Blanca',1),(48957249,'aerialway','chair_lift',1),(48957249,'aerialway:occupancy','6',1),(48957249,'name','Pic Blanc',1),(48957250,'name','Cami de Pessons',1),(48957250,'piste:difficulty','intermediate',1),(48957250,'piste:type','downhill',1),(48957251,'name','Tortuga',1),(48957251,'piste:difficulty','easy',1),(48957251,'piste:type','downhill',1),(48957252,'piste:difficulty','easy',1),(48957252,'piste:type','downhill',1),(48957253,'name','mirador',1),(48957253,'piste:difficulty','advanced',1),(48957253,'piste:type','downhill',1),(48957254,'name','Pala Nova',1),(48957254,'piste:difficulty','intermediate',1),(48957254,'piste:type','downhill',1),(48957255,'name','Menera',1),(48957255,'piste:difficulty','intermediate',1),(48957255,'piste:type','downhill',1),(48957256,'aerialway','chair_lift',1),(48957256,'aerialway:occupancy','6',1),(48957256,'name','Pla de les Pedres Soldeu',1),(48957257,'aerialway','chair_lift',1),(48957257,'aerialway:occupancy','6',1),(48957257,'name','Pla de les Pedres Grau Roig',1),(48957258,'aerialway','platter',4),(48957258,'aerialway:occupancy','1',4),(48957258,'name','Escola',4),(48957258,'piste:lift','platter',4),(48969498,'name','Guineu',3),(48969498,'piste:difficulty','easy',3),(48969498,'piste:type','downhill',3),(48969499,'name','Miquel',2),(48969499,'piste:difficulty','intermediate',2),(48969499,'piste:type','downhill',2),(48979047,'name','Paniquera',2),(48979047,'piste:difficulty','easy',2),(48979047,'piste:type','downhill',2),(48979047,'sport','skiing',2),(48979050,'name','Riu De Les Solanelles',3),(48979050,'piste:difficulty','easy',3),(48979050,'piste:type','downhill',3),(48979051,'name','Ayelen',2),(48979051,'piste:difficulty','easy',2),(48979051,'piste:type','downhill',2),(48979052,'name','Solanella',2),(48979052,'piste:difficulty','easy',2),(48979052,'piste:type','downhill',2),(48979055,'name','Falco',1),(48979055,'piste:difficulty','advanced',1),(48979055,'piste:type','downhill',1),(48979056,'name','Fura',3),(48979056,'piste:difficulty','easy',3),(48979056,'piste:type','downhill',3),(48979057,'piste:difficulty','easy',2),(48979057,'piste:type','downhill',2),(48979057,'sport','skiing',2),(48979058,'name','Diagonal d\'Enllac',2),(48979058,'piste:difficulty','easy',2),(48979058,'piste:type','downhill',2),(48979059,'name','Trencalès',3),(48979059,'piste:difficulty','advanced',3),(48979059,'piste:type','downhill',3),(48979060,'name','Obagot',1),(48979060,'piste:difficulty','intermediate',1),(48979060,'piste:type','downhill',1),(48979062,'name','Gall de Bosc',6),(48979062,'piste:difficulty','easy',6),(48979062,'piste:type','downhill',6),(48979063,'piste:difficulty','intermediate',1),(48979063,'piste:type','downhill',1),(50568365,'CLC:code','321',2),(50568365,'CLC:id','FR-244978',2),(50568365,'CLC:year','2006',2),(50568365,'natural','grassland',2),(50568365,'source','Union européenne - SOeS, CORINE Land Cover, 2006.',2),(50734991,'highway','track',1),(52008425,'aerialway','chair_lift',2),(52008425,'aerialway:occupancy','2',2),(52008425,'name','La Caubella',2),(52008767,'aerialway','chair_lift',1),(52008767,'aerialway:occupancy','2',1),(52008767,'name','La Serra',1),(52009081,'aerialway','chair_lift',1),(52009081,'aerialway:occupancy','4',1),(52009081,'name','La Carbonera',1),(52009565,'aerialway','chair_lift',1),(52009565,'aerialway:occupancy','4',1),(52009565,'name','La Serra II',1),(52010630,'aerialway','chair_lift',1),(52010630,'aerialway:occupancy','4',1),(52010630,'name','La Botella',1),(52010729,'aerialway','chair_lift',1),(52010729,'aerialway:occupancy','4',1),(52010729,'name','Setúria',1),(52010876,'aerialway','chair_lift',1),(52010876,'aerialway:occupancy','6',1),(52010876,'name','El Cubil',1),(52035289,'aerialway','platter',1),(52035289,'name','L\'Hortell',1),(52036011,'aerialway','chair_lift',2),(52036011,'aerialway:occupancy','4',2),(52036011,'name','L\'Abarsetar',2),(52038527,'aerialway','chair_lift',1),(52038527,'aerialway:occupancy','6',1),(52038527,'name','Les Fonts',1),(52038627,'aerialway','chair_lift',2),(52038627,'aerialway:occupancy','4',2),(52038627,'name','El Cortal',2),(52083535,'aerialway','platter',1),(52083535,'name','Els Vailets',1),(52083655,'aerialway','platter',1),(52083655,'name','Els Vailets',1),(52084359,'name','L\'Estadi',2),(52084359,'piste:difficulty','intermediate',2),(52084359,'piste:type','downhill',2),(52098923,'aerialway','platter',1),(52098923,'name','Els Feixans',1),(52099062,'piste:difficulty','freeride',1),(52099062,'piste:type','downhill',1),(52099251,'name','La Basera',2),(52099251,'piste:difficulty','novice',2),(52099251,'piste:type','downhill',2),(52099335,'name','Els Feixans',1),(52099335,'piste:difficulty','freeride',1),(52099335,'piste:type','downhill',1),(52099379,'name','La Balma',2),(52099379,'piste:difficulty','intermediate',2),(52099379,'piste:type','downhill',2),(52099485,'name','La Portella d\'Arcalis',2),(52099485,'piste:difficulty','advanced',2),(52099485,'piste:grooming','backcountry',2),(52099485,'piste:type','downhill',2),(52110420,'aerialway','cable_car',2),(52110420,'aerialway:occupancy','10',2),(52110420,'name','TC10 Tarter',2),(52110421,'aerialway','chair_lift',3),(52110421,'aerialway:occupancy','4',3),(52110421,'name','TSD4 Tarter',3),(52112644,'name','Corpalanca',2),(52112644,'piste:difficulty','intermediate',2),(52112644,'piste:type','downhill',2),(52112644,'sport','skiing',2),(52112645,'name','Estadi Eslalom',2),(52112645,'piste:difficulty','intermediate',2),(52112645,'piste:type','downhill',2),(52112645,'sport','skiing',2),(52112646,'aerialway','drag_lift',2),(52112646,'name','La Serra',2),(52112647,'name','El Bec',1),(52112647,'piste:difficulty','easy',1),(52112647,'piste:type','downhill',1),(52112647,'sport','skiing',1),(52112648,'name','El Planell',2),(52112648,'piste:difficulty','novice',2),(52112648,'piste:type','downhill',2),(52112648,'sport','skiing',2),(52112649,'name','Els Avets',1),(52112649,'piste:difficulty','easy',1),(52112649,'piste:type','downhill',1),(52112649,'sport','skiing',1),(52112650,'name','Transversal',1),(52112650,'piste:difficulty','novice',1),(52112650,'piste:type','downhill',1),(52112650,'sport','skiing',1),(52112651,'name','El Besurt II',1),(52112651,'piste:difficulty','easy',1),(52112651,'piste:type','downhill',1),(52112651,'sport','skiing',1),(52112652,'name','El Besurt',1),(52112652,'piste:difficulty','intermediate',1),(52112652,'piste:type','downhill',1),(52112652,'sport','skiing',1),(52114934,'piste:difficulty','intermediate',1),(52114934,'piste:type','downhill',1),(52114934,'sport','skiing',1),(52114935,'name','Poselletes',1);
INSERT INTO `way_tags` VALUES (52114935,'piste:difficulty','intermediate',1),(52114935,'piste:type','downhill',1),(52114935,'sport','skiing',1),(52114936,'name','Coll De La Botella',1),(52114936,'piste:difficulty','easy',1),(52114936,'piste:type','downhill',1),(52114936,'sport','skiing',1),(52114937,'name','El Gall',1),(52114937,'piste:difficulty','easy',1),(52114937,'piste:type','downhill',1),(52114937,'sport','skiing',1),(52114938,'name','Fontanals De Les Roques',1),(52114938,'piste:difficulty','intermediate',1),(52114938,'piste:type','downhill',1),(52114938,'sport','skiing',1),(52114939,'aerialway','drag_lift',1),(52114939,'name','El Cubil',1),(52114940,'name','Cubil',1),(52114940,'piste:difficulty','intermediate',1),(52114940,'piste:type','downhill',1),(52114940,'sport','skiing',1),(52114942,'aerialway','drag_lift',1),(52114942,'name','Els Coms',1),(52114943,'name','La Serra',1),(52114943,'piste:difficulty','intermediate',1),(52114943,'piste:type','downhill',1),(52114943,'sport','skiing',1),(52114944,'name','Cami Superior',1),(52114944,'piste:difficulty','easy',1),(52114944,'piste:type','downhill',1),(52114944,'sport','skiing',1),(52114946,'name','Fontanals',1),(52114946,'piste:difficulty','intermediate',1),(52114946,'piste:type','downhill',1),(52114946,'sport','skiing',1),(52114947,'name','La Cot',1),(52114947,'piste:difficulty','intermediate',1),(52114947,'piste:type','downhill',1),(52114947,'sport','skiing',1),(52114948,'name','Coms',1),(52114948,'piste:difficulty','intermediate',1),(52114948,'piste:type','downhill',1),(52114948,'sport','skiing',1),(52114949,'name','La Comellada',1),(52114949,'piste:difficulty','advanced',1),(52114949,'piste:type','downhill',1),(52114949,'sport','skiing',1),(52114950,'name','La Serra',1),(52114950,'piste:difficulty','easy',1),(52114950,'piste:type','downhill',1),(52114950,'sport','skiing',1),(52114951,'name','Font Roja',1),(52114951,'piste:difficulty','intermediate',1),(52114951,'piste:type','downhill',1),(52114951,'sport','skiing',1),(52114952,'aerialway','gondola',2),(52114952,'name','Arinsal-Pal',2),(52114952,'oneway','no',2),(52121995,'aerialway','platter',1),(52121995,'name','La Capa',1),(52122469,'name','La Capa',1),(52122469,'piste:difficulty','advanced',1),(52122469,'piste:grooming','classic',1),(52122469,'piste:type','downhill',1),(52123370,'aerialway','platter',1),(52123370,'name','El Coll',1),(52123917,'name','Les Marrades',1),(52123917,'piste:difficulty','easy',1),(52123917,'piste:grooming','classic',1),(52123917,'piste:type','downhill',1),(52163682,'aerialway','chair_lift',1),(52163683,'aerialway','chair_lift',1),(52163683,'aerialway:occupancy','4',1),(52163683,'name','TSF4 Enradort',1),(52163684,'name','Riu Del Cubill',1),(52163684,'piste:difficulty','intermediate',1),(52163684,'piste:type','downhill',1),(52163684,'sport','skiing',1),(52163691,'name','Pla De Les Pedres',1),(52163691,'piste:difficulty','intermediate',1),(52163691,'piste:type','downhill',1),(52163691,'sport','skiing',1),(52163693,'name','Serra De Les Solanelles',1),(52163693,'piste:difficulty','easy',1),(52163693,'piste:type','downhill',1),(52163693,'sport','skiing',1),(52163695,'name','Obaga',2),(52163695,'piste:difficulty','easy',2),(52163695,'piste:type','downhill',2),(52163695,'sport','skiing',2),(52163698,'name','Gaig',1),(52163698,'piste:difficulty','advanced',1),(52163698,'piste:type','downhill',1),(52163698,'sport','skiing',1),(52163700,'name','Rossinyol',1),(52163700,'piste:difficulty','easy',1),(52163700,'piste:type','downhill',1),(52163700,'sport','skiing',1),(52163704,'aerialway','chair_lift',1),(52163704,'aerialway:occupancy','4',1),(52163704,'name','TSD4 Portella',1),(52163705,'name','Tamarro',1),(52163705,'piste:difficulty','intermediate',1),(52163705,'piste:type','downhill',1),(52163705,'sport','skiing',1),(52163710,'aerialway','chair_lift',1),(52163710,'aerialway:occupancy','4',1),(52163710,'name','TSF4 Junior',1),(52163712,'name','Junior',1),(52163712,'piste:difficulty','novice',1),(52163712,'piste:type','downhill',1),(52163712,'sport','skiing',1),(52163714,'aerialway','drag_lift',1),(52163714,'name','TK Llosada',1),(52163716,'name','Oreneta',1),(52163716,'piste:difficulty','easy',1),(52163716,'piste:type','downhill',1),(52163716,'sport','skiing',1),(52163719,'name','Teixo',1),(52163719,'piste:difficulty','easy',1),(52163719,'piste:type','downhill',1),(52163719,'sport','skiing',1),(52163722,'name','Llop',1),(52163722,'piste:difficulty','intermediate',1),(52163722,'piste:type','downhill',1),(52163722,'sport','skiing',1),(52163729,'name','Obac Solana',1),(52163729,'piste:difficulty','easy',1),(52163729,'piste:type','downhill',1),(52163729,'sport','skiing',1),(52163731,'name','Solana',1),(52163731,'piste:difficulty','easy',1),(52163731,'piste:type','downhill',1),(52163731,'sport','skiing',1),(52163733,'name','Marmota',1),(52163733,'piste:difficulty','easy',1),(52163733,'piste:type','downhill',1),(52163733,'sport','skiing',1),(52163736,'aerialway','chair_lift',1),(52163736,'aerialway:occupancy','4',1),(52163736,'name','TSF4 Els Clots',1),(52163738,'name','Daina',1),(52163738,'piste:difficulty','easy',1),(52163738,'piste:type','downhill',1),(52163738,'sport','skiing',1),(52163739,'aerialway','chair_lift',1),(52163739,'aerialway:occupancy','4',1),(52163739,'name','TSF4 Colibri',1),(52163740,'piste:difficulty','easy',1),(52163740,'piste:type','downhill',1),(52163740,'sport','skiing',1),(52163743,'piste:difficulty','intermediate',1),(52163743,'piste:type','downhill',1),(52163743,'sport','skiing',1),(52163745,'piste:difficulty','intermediate',1),(52163745,'piste:type','downhill',1),(52163745,'sport','skiing',1),(52163746,'name','Cucut',1),(52163746,'piste:difficulty','advanced',1),(52163746,'piste:type','downhill',1),(52163746,'sport','skiing',1),(52163748,'piste:difficulty','intermediate',1),(52163748,'piste:type','downhill',1),(52163748,'sport','skiing',1),(52163750,'piste:difficulty','easy',1),(52163750,'piste:type','downhill',1),(52163750,'sport','skiing',1),(52163751,'piste:difficulty','easy',1),(52163751,'piste:type','downhill',1),(52163751,'sport','skiing',1),(52163753,'name','Serrat De La Posa',1),(52163753,'piste:difficulty','intermediate',1),(52163753,'piste:type','downhill',1),(52163753,'sport','skiing',1),(52163754,'piste:difficulty','advanced',1),(52163754,'piste:type','downhill',1),(52163754,'sport','skiing',1),(52171935,'aerialway','drag_lift',1),(52171935,'name','TK Espiolets',1),(52171936,'name','Duc',1),(52171936,'piste:difficulty','easy',1),(52171936,'piste:type','downhill',1),(52171936,'sport','skiing',1),(52171937,'name','Llebre',1),(52171937,'piste:difficulty','intermediate',1),(52171937,'piste:type','downhill',1),(52171937,'sport','skiing',1),(52171938,'name','Esquirol',1),(52171938,'piste:difficulty','easy',1),(52171938,'piste:type','downhill',1),(52171938,'sport','skiing',1),(52171939,'name','Torrallardona',1),(52171939,'piste:difficulty','intermediate',1),(52171939,'piste:type','downhill',1),(52171939,'sport','skiing',1),(52171940,'aerialway','drag_lift',1),(52171940,'name','TK Font Roges',1),(52171941,'name','Mussol',2),(52171941,'piste:difficulty','intermediate',2),(52171941,'piste:type','downhill',2),(52171941,'sport','skiing',2),(52171942,'name','Pardal',1),(52171942,'piste:difficulty','easy',1),(52171942,'piste:type','downhill',1),(52171942,'sport','skiing',1),(52171943,'aerialway','chair_lift',1),(52171943,'aerialway:occupancy','4',1),(52171943,'name','TSF4 Pi De Migdia',1),(52171944,'aerialway','chair_lift',1),(52171944,'name','TSF2 Riba',1),(52171945,'piste:difficulty','easy',1),(52171945,'piste:type','downhill',1),(52171945,'sport','skiing',1),(52171946,'piste:difficulty','easy',1),(52171946,'piste:type','downhill',1),(52171946,'sport','skiing',1),(52171947,'name','Salvans',1),(52171947,'piste:difficulty','intermediate',1),(52171947,'piste:type','downhill',1),(52171947,'sport','skiing',1),(52172905,'aerialway','cable_car',1),(52172905,'name','Funicamp',1),(52172907,'name','Fagina',1),(52172907,'piste:difficulty','intermediate',1),(52172907,'piste:type','downhill',1),(52172907,'sport','skiing',1),(52172909,'name','Aliga',1),(52172909,'piste:difficulty','advanced',1),(52172909,'piste:type','downhill',1),(52172909,'sport','skiing',1),(52172911,'name','Esparver',1),(52172911,'piste:difficulty','intermediate',1),(52172911,'piste:type','downhill',1),(52172911,'sport','skiing',1),(52172913,'name','Muflo',1),(52172913,'piste:difficulty','advanced',1),(52172913,'piste:type','downhill',1),(52172913,'sport','skiing',1),(52172914,'name','Cabirol',1),(52172914,'piste:difficulty','advanced',1),(52172914,'piste:type','downhill',1),(52172914,'sport','skiing',1),(52172915,'name','Voltor',1),(52172915,'piste:difficulty','advanced',1),(52172915,'piste:type','downhill',1),(52172915,'sport','skiing',1),(52172916,'name','Corb',1),(52172916,'piste:difficulty','advanced',1),(52172916,'piste:type','downhill',1),(52172916,'sport','skiing',1),(52172918,'name','Cortalets',1),(52172918,'piste:difficulty','easy',1),(52172918,'piste:type','downhill',1),(52172918,'sport','skiing',1),(52172919,'piste:difficulty','easy',1),(52172919,'piste:type','downhill',1),(52172919,'sport','skiing',1),(52172920,'aerialway','rope_tow',1),(52172921,'piste:difficulty','easy',1),(52172921,'piste:type','downhill',1),(52172921,'sport','skiing',1),(52174944,'aerialway','chair_lift',1),(52174944,'aerialway:occupancy','4',1),(52174944,'name','TSF4 Solana',1),(52174946,'aerialway','chair_lift',1),(52174946,'aerialway:occupancy','4',1),(52174946,'name','TSD4 Pas De La Casa',1),(52174948,'aerialway','chair_lift',1),(52174948,'aerialway:occupancy','2',1),(52174948,'name','TSF2 Coll Blanc',1),(52174950,'aerialway','chair_lift',1),(52174950,'aerialway:occupancy','6',1),(52174950,'name','TSD6 Font Negre',1),(52174952,'aerialway','drag_lift',1),(52174952,'name','TK Coma Blanca III',1),(52174953,'aerialway','chair_lift',1),(52174953,'aerialway:occupancy','2',1),(52174953,'name','TSF2 Riberal',1),(52174956,'aerialway','chair_lift',1),(52174956,'aerialway:occupancy','4',1),(52174956,'name','TSD4 Antenes',1),(52174958,'aerialway','drag_lift',1),(52174958,'name','TK Montmalus',1),(52174959,'aerialway','drag_lift',1),(52174959,'name','TK Clot',1),(52174960,'aerialway','chair_lift',1),(52174960,'aerialway:occupancy','4',1),(52174960,'name','TSF4 Xavi',1),(52174962,'aerialway','drag_lift',1),(52174962,'name','TK Pic Blanc',1),(52174963,'aerialway','chair_lift',1),(52174963,'aerialway:occupancy','4',1),(52174963,'name','TSF4 Costa Rodona',1),(52268017,'name','Tub del Coll',2),(52268017,'piste:difficulty','advanced',2),(52268017,'piste:grooming','backcountry',2),(52268017,'piste:type','downhill',2),(52692955,'name','Bony Vaques',1),(52692955,'piste:difficulty','advanced',1),(52692955,'piste:type','downhill',1),(52692955,'sport','skiing',1),(52692956,'name','Les Fonts',1),(52692956,'piste:difficulty','easy',1),(52692956,'piste:type','downhill',1),(52692956,'sport','skiing',1),(52692957,'name','La Solana',2),(52692957,'piste:difficulty','easy',2),(52692957,'piste:type','downhill',2),(52692957,'sport','skiing',2),(52692958,'aerialway','chair_lift',1),(52692958,'aerialway:occupancy','4',1),(52692958,'name','Port Negre',1),(52692959,'name','Tub Estadi',1),(52692959,'piste:difficulty','intermediate',1),(52692959,'piste:type','downhill',1),(52692959,'sport','skiing',1),(52692960,'name','La Pala',1),(52692960,'piste:difficulty','intermediate',1),(52692960,'piste:type','downhill',1),(52692960,'sport','skiing',1),(52692961,'aerialway','chair_lift',1),(52692961,'aerialway:occupancy','4',1),(52692961,'name','La Tossa',1),(52692962,'name','La Tossa',1),(52692962,'piste:difficulty','intermediate',1),(52692962,'piste:type','downhill',1),(52692962,'sport','skiing',1),(52692963,'name','Estadi',1),(52692963,'piste:difficulty','intermediate',1),(52692963,'piste:type','downhill',1),(52692963,'sport','skiing',1),(52692964,'name','Planelles',1),(52692964,'piste:difficulty','easy',1),(52692964,'piste:type','downhill',1),(52692964,'sport','skiing',1),(52692965,'aerialway','drag_lift',1),(52692965,'name','Els Planels',1),(52692966,'name','Port Vell',1),(52692966,'piste:difficulty','easy',1),(52692966,'piste:type','downhill',1),(52692966,'sport','skiing',1),(52692967,'name','Salador',1),(52692967,'piste:difficulty','easy',1),(52692967,'piste:type','downhill',1),(52692967,'sport','skiing',1),(52692968,'aerialway','drag_lift',1),(52692968,'name','Salador',1),(52692969,'name','Margarida',1),(52692969,'piste:difficulty','easy',1),(52692969,'piste:type','downhill',1),(52692969,'sport','skiing',1),(52692970,'name','El Cortal',1),(52692970,'piste:difficulty','novice',1),(52692970,'piste:type','downhill',1),(52692970,'sport','skiing',1),(52692971,'piste:difficulty','novice',1),(52692971,'piste:type','downhill',1),(52692971,'sport','skiing',1),(52697930,'name','La Portella del Mig',1),(52697930,'piste:difficulty','intermediate',1),(52697930,'piste:type','downhill',1),(52697930,'sport','skiing',1),(52697931,'name','Els Orris',1),(52697931,'piste:difficulty','novice',1),(52697931,'piste:type','downhill',1),(52697931,'sport','skiing',1),(52697932,'name','La Coma',1),(52697932,'piste:difficulty','easy',1),(52697932,'piste:type','downhill',1),(52697932,'sport','skiing',1),(52697934,'name','El Mur',1),(52697934,'piste:difficulty','intermediate',1),(52697934,'piste:type','downhill',1),(52697934,'sport','skiing',1),(52697935,'name','El Tunel',1),(52697935,'piste:difficulty','novice',1),(52697935,'piste:type','downhill',1),(52697935,'sport','skiing',1),(52697936,'name','Woodpark',1),(52697936,'piste:difficulty','freeride',1),(52697936,'piste:type','downhill',1),(52697936,'sport','skiing',1),(52697937,'name','L\'Hortell',1),(52697937,'piste:difficulty','intermediate',1),(52697937,'piste:type','downhill',1),(52697937,'sport','skiing',1),(52697938,'name','El Bosc',1),(52697938,'piste:difficulty','intermediate',1),(52697938,'piste:type','downhill',1),(52697938,'sport','skiing',1),(52697939,'name','La Font',1),(52697939,'piste:difficulty','easy',1),(52697939,'piste:type','downhill',1),(52697939,'sport','skiing',1),(52697940,'name','Les Canals',1),(52697940,'piste:difficulty','easy',1),(52697940,'piste:type','downhill',1),(52697940,'sport','skiing',1),(52697941,'name','La Canal Gran',1),(52697941,'piste:difficulty','advanced',1),(52697941,'piste:type','downhill',1),(52697941,'sport','skiing',1),(52697942,'name','Els Terragals',1),(52697942,'piste:difficulty','easy',1),(52697942,'piste:type','downhill',1),(52697942,'sport','skiing',1),(52697943,'name','ECOA',1),(52697943,'piste:difficulty','easy',1),(52697943,'piste:type','downhill',1),(52697943,'sport','skiing',1),(52697944,'name','Les Tarteres',1),(52697944,'piste:difficulty','intermediate',1),(52697944,'piste:type','downhill',1),(52697944,'sport','skiing',1),(52697945,'name','Les Congestes',1),(52697945,'piste:difficulty','intermediate',1),(52697945,'piste:type','downhill',1),(52697945,'sport','skiing',1),(52697946,'name','La Canaleta',1),(52697946,'piste:difficulty','intermediate',1),(52697946,'piste:type','downhill',1),(52697946,'sport','skiing',1),(52697947,'aerialway','chair_lift',1),(52697947,'aerialway:occupancy','4',1),(52697947,'name','Creussans',1),(52697948,'name','L\'Estany',1),(52697948,'piste:difficulty','intermediate',1),(52697948,'piste:type','downhill',1),(52697948,'sport','skiing',1),(52697949,'aerialway','chair_lift',1),(52697949,'aerialway:occupancy','6',1),(52697949,'name','La Coma',1),(52697950,'name','La Bassa',1),(52697950,'piste:difficulty','easy',1),(52697950,'piste:type','downhill',1),(52697950,'sport','skiing',1),(52697951,'name','El Riu',1),(52697951,'piste:difficulty','novice',1),(52697951,'piste:type','downhill',1),(52697951,'sport','skiing',1),(52697952,'name','L\'Avetar',1),(52697952,'piste:difficulty','intermediate',1),(52697952,'piste:type','downhill',1),(52697952,'sport','skiing',1),(54858984,'name','Pyrénées Hyper-Centre',1),(54858984,'shop','supermarket',1),(61736197,'highway','primary',2),(61736197,'maxspeed','90',2),(61736197,'name','Port d\'Envalira',2),(61736197,'ref','CG-2',2),(61736197,'source','yahoo',2),(61736199,'highway','primary',2),(61736199,'maxspeed','30',2),(61736199,'name','Port d\'Envalira',2),(61736199,'ref','CG-2',2),(61736199,'source','yahoo',2),(61736200,'highway','primary',2),(61736200,'maxspeed','90',2),(61736200,'name','Port d\'Envalira',2),(61736200,'ref','CG-2',2),(61736200,'source','yahoo',2),(61736202,'highway','primary',2),(61736202,'maxspeed','30',2),(61736202,'name','Port d\'Envalira',2),(61736202,'ref','CG-2',2),(61736202,'source','yahoo',2),(61736203,'highway','primary',2),(61736203,'maxspeed','90',2),(61736203,'name','Port d\'Envalira',2),(61736203,'ref','CG-2',2),(61736203,'source','yahoo',2),(61736208,'highway','primary',3),(61736208,'maxspeed','90;30;90;30;90;30',3),(61736208,'name','Port d\'Envalira',3),(61736208,'ref','CG-2',3),(61736208,'source','yahoo',3),(61736209,'highway','primary',2),(61736209,'maxspeed','30',2),(61736209,'name','Port d\'Envalira',2),(61736209,'ref','CG-2',2),(61736209,'source','yahoo',2),(70427100,'highway','unclassified',2),(70427114,'highway','unclassified',2),(70427114,'tracktype','grade1',2),(70427179,'highway','unclassified',4),(70427179,'tracktype','grade1',4),(70428387,'bridge','yes',1),(70428387,'highway','unclassified',1),(70428387,'layer','1',1),(75744715,'highway','residential',2),(75746393,'bridge','yes',1),(75746393,'highway','footway',1),(75746394,'highway','service',1),(75746395,'highway','track',2),(75746395,'name','Cami del Ferrer de l\'Olla',2),(75746396,'highway','residential',1),(75746397,'highway','track',2),(75746398,'highway','primary',1),(75746398,'ref','CG-2',1),(75746398,'source','yahoo',1),(75746399,'bridge','yes',2),(75746399,'highway','track',2),(75746400,'highway','footway',1),(75746401,'highway','track',1),(75746402,'highway','residential',1),(75746403,'highway','tertiary',1),(75746404,'highway','track',1),(75746405,'highway','track',2),(75746406,'highway','residential',1),(75746409,'highway','track',2),(75746409,'name','Camì de les Pardines',2),(75746409,'tracktype','grade2',2),(75746410,'highway','track',1),(75746410,'ref','GR-11',1),(75746411,'highway','residential',1),(75746412,'highway','track',2),(75746414,'highway','footway',1),(75746415,'highway','primary',1),(75746415,'junction','roundabout',1),(75746416,'highway','residential',1),(75746417,'highway','residential',1),(75746418,'bridge','yes',2),(75746418,'highway','track',2),(75746419,'highway','track',2),(75746421,'amenity','parking',1),(75746422,'highway','footway',1),(75746423,'highway','track',1),(75746424,'highway','footway',1),(75871448,'waterway','stream',2),(77918991,'highway','path',1),(77918991,'name','GR-107',1),(77918991,'sac_scale','alpine_hiking',1),(79126612,'highway','track',1);
INSERT INTO `ways` VALUES (6165450,592895,'2008-07-25 23:38:32',11,1),(6165679,3283462,'2009-12-03 21:55:01',18,1),(6165877,4963967,'2010-06-11 20:09:52',7,1),(6165944,495907,'2008-07-15 19:53:29',12,1),(6166082,495907,'2008-07-15 19:50:23',9,1),(6166123,495907,'2008-07-15 19:46:04',7,1),(6166128,531541,'2008-05-27 10:39:41',4,1),(6166136,4963967,'2010-06-11 20:09:44',4,1),(6166145,531541,'2008-05-27 10:39:56',4,1),(6166185,531541,'2008-05-27 10:39:55',6,1),(6176624,5107412,'2010-06-29 20:15:57',6,1),(6176663,4963942,'2010-06-11 20:05:27',3,1),(6176681,4963942,'2010-06-11 20:05:26',5,1),(6176755,5107412,'2010-06-29 20:15:32',13,1),(6177152,531541,'2008-05-27 10:39:46',8,1),(6177369,531541,'2008-05-27 10:39:53',5,1),(6177399,531541,'2008-05-27 10:39:55',6,1),(6177409,531541,'2008-05-27 10:39:45',4,1),(6178503,531541,'2008-05-27 10:39:44',7,1),(6178632,531541,'2008-05-27 10:39:40',6,1),(6178685,531541,'2008-05-27 10:39:47',6,1),(6178688,531541,'2008-05-27 10:39:52',5,1),(6178694,5671401,'2010-09-03 18:06:00',5,1),(6178791,531541,'2008-05-27 10:39:46',4,1),(6178964,189418,'2008-04-19 22:43:10',2,1),(6178980,198831,'2008-04-20 16:27:47',3,1),(6179103,2895121,'2009-10-19 19:23:28',5,1),(6179174,531541,'2008-05-27 10:39:54',5,1),(6179240,188228,'2008-06-16 18:52:21',4,1),(6179270,531541,'2008-05-27 10:40:04',4,1),(6179470,189418,'2008-04-19 22:47:07',2,1),(6179561,198831,'2008-04-20 16:28:09',2,1),(6179675,2895121,'2009-10-19 19:18:34',9,1),(6179692,592895,'2008-07-25 22:38:46',6,1),(6180790,592895,'2008-07-25 23:36:49',8,1),(6180839,531541,'2008-05-27 10:39:59',3,1),(6180840,5107450,'2010-06-29 20:18:46',3,1),(6180852,592895,'2008-07-25 23:37:03',4,1),(6180968,2895121,'2009-10-19 19:23:46',12,1),(6180977,188228,'2008-06-16 19:38:45',3,1),(6180985,188228,'2008-06-16 19:39:37',5,1),(6180988,531541,'2008-05-27 10:39:56',4,1),(6181319,478731,'2008-08-31 13:57:01',2,1),(6181357,478731,'2008-08-31 13:57:00',3,1),(6181419,478731,'2008-08-31 13:57:00',2,1),(6181836,4963942,'2010-06-11 20:05:35',3,1),(6181838,553642,'2008-05-31 01:43:48',8,1),(6181947,198831,'2008-04-20 16:20:28',2,1),(6182051,305941,'2009-02-09 21:25:15',4,1),(6182052,3878347,'2010-02-14 22:47:46',4,1),(6182053,56648,'2008-06-05 19:59:58',3,1),(6182054,3100730,'2009-11-12 21:12:52',2,1),(6182056,56648,'2008-06-05 20:46:25',3,1),(6182057,56648,'2008-06-05 20:39:41',4,1),(6182058,56648,'2008-06-05 19:45:08',3,1),(6182065,981922,'2009-04-27 01:40:07',4,1),(6182097,3916355,'2010-02-19 17:32:01',7,1),(6182122,2369688,'2009-09-04 17:16:29',9,1),(6182127,820251,'2009-03-16 23:49:43',3,1),(6182159,2369688,'2009-09-04 17:16:28',5,1),(6182267,3100730,'2009-11-12 21:12:49',3,1),(6182278,3916355,'2010-02-19 17:32:05',4,1),(6182289,951833,'2009-04-25 18:47:58',3,1),(6182303,978767,'2009-04-26 22:29:09',3,1),(6182333,3916355,'2010-02-19 17:32:00',5,1),(6182349,56648,'2008-06-05 20:14:45',2,1),(6182350,56648,'2008-06-05 20:18:20',3,1),(6182364,188228,'2008-06-16 18:36:30',13,1),(6182371,1276166,'2009-05-21 17:14:30',11,1),(6182386,462438,'2008-07-11 12:59:48',4,1),(6182401,820251,'2009-03-16 23:48:46',5,1),(6182410,3916355,'2010-02-19 17:33:05',12,1),(6182463,3100730,'2009-11-12 21:12:52',6,1),(6182505,3916355,'2010-02-19 17:33:24',4,1),(6182542,225225,'2008-04-23 00:46:13',8,1),(6182577,3100730,'2009-11-12 21:12:48',2,1),(6182675,3100730,'2009-11-12 21:12:49',2,1),(6182714,3100730,'2009-11-12 21:12:55',2,1),(6182761,3916355,'2010-02-19 17:33:05',9,1),(6182765,462689,'2008-05-17 12:18:56',3,1),(6182771,56648,'2008-06-05 19:39:48',2,1),(6182773,56648,'2008-06-05 20:47:28',3,1),(6182798,305941,'2009-02-09 21:27:05',3,1),(6182810,56648,'2008-06-05 20:40:00',2,1),(6182844,427965,'2007-09-14 21:16:04',1,1),(6182932,553642,'2008-05-31 01:43:44',4,1),(6183078,3100730,'2009-11-12 21:12:50',2,1),(6183100,5671401,'2010-09-03 18:06:02',7,1),(6183127,3100730,'2009-11-12 21:12:53',2,1),(6183169,258874,'2008-10-11 17:23:03',2,1),(6183270,3100730,'2009-11-12 21:12:55',2,1),(6183273,3100730,'2009-11-12 21:12:55',3,1),(6183357,3100730,'2009-11-12 21:12:54',2,1),(6183360,3100730,'2009-11-12 21:12:55',2,1),(6183573,3100730,'2009-11-12 21:12:50',2,1),(6184947,427965,'2007-09-14 22:01:04',1,1),(6185032,592895,'2008-07-25 22:36:09',3,1),(6185060,3100730,'2009-11-12 21:12:50',2,1),(6185090,3100730,'2009-11-12 21:12:48',2,1),(6185110,697263,'2009-01-01 16:45:35',7,1),(6185122,592895,'2008-07-26 00:32:16',11,1),(6185149,3100730,'2009-11-12 21:12:50',2,1),(6185336,592895,'2008-07-25 22:17:50',3,1),(6185353,3100730,'2009-11-12 21:12:49',3,1),(6185363,3100730,'2009-11-12 21:12:49',2,1),(6185394,56648,'2008-06-05 20:02:45',2,1),(6185421,437032,'2008-05-13 22:22:44',2,1),(6185589,56648,'2008-06-05 20:21:41',2,1),(6185611,91018,'2008-06-07 20:24:45',3,1),(6185640,3878347,'2010-02-14 22:47:46',3,1),(6185710,427965,'2007-09-14 22:11:53',1,1),(6185726,56648,'2008-06-05 19:30:56',4,1),(6185775,56648,'2008-06-05 19:44:23',3,1),(6185795,3100730,'2009-11-12 21:12:54',2,1),(6185800,305941,'2009-02-09 21:21:16',13,1),(6185807,305941,'2009-02-09 21:20:13',4,1),(6185826,495907,'2008-07-15 17:28:34',9,1),(6185878,495907,'2008-07-15 17:27:38',8,1),(6185911,3100730,'2009-11-12 21:12:56',2,1),(6185926,3100730,'2009-11-12 21:12:56',2,1),(6185930,3100730,'2009-11-12 21:12:56',2,1),(6185971,531541,'2008-05-27 10:39:52',5,1),(6185986,5671401,'2010-09-03 18:06:00',8,1),(6185988,188228,'2008-06-16 19:41:47',5,1),(6186037,4963967,'2010-06-11 20:09:41',10,1),(6186094,3100730,'2009-11-12 21:12:56',2,1),(6195793,1276166,'2009-05-21 17:09:44',6,1),(6195794,225225,'2008-04-23 00:45:56',6,1),(6195795,3100730,'2009-11-12 21:12:53',2,1),(6195796,3100730,'2009-11-12 21:12:53',2,1),(6195797,3100730,'2009-11-12 21:12:53',2,1),(6195885,183661,'2008-04-18 18:59:28',2,1),(6196087,531541,'2008-05-27 10:40:02',6,1),(6196407,870814,'2009-03-31 00:59:11',8,1),(6197719,197512,'2008-04-20 03:21:28',5,1),(6197721,4804396,'2010-05-25 17:58:16',17,1),(6197723,1684788,'2009-06-30 11:19:40',4,1),(6197727,615859,'2008-07-28 13:59:33',18,1),(6198025,1684788,'2009-06-30 11:19:40',7,1),(6198027,553642,'2008-05-31 01:43:45',4,1),(6198139,553642,'2008-05-31 01:43:48',4,1),(6225803,553642,'2008-05-31 01:43:38',14,1),(6225812,437032,'2008-05-13 19:47:14',2,1),(6227096,5025308,'2010-06-19 19:17:26',6,1),(6227097,5025308,'2010-06-19 19:17:30',6,1),(6228283,210114,'2008-08-12 23:25:46',2,1),(6230227,3100730,'2009-11-12 21:12:36',2,1),(6230228,3100730,'2009-11-12 21:12:43',3,1),(6230229,3100730,'2009-11-12 21:12:43',2,1),(6230231,433922,'2008-10-19 02:57:33',4,1),(6230232,3100730,'2009-11-12 21:12:43',3,1),(6230233,189418,'2008-04-19 22:45:34',2,1),(6230234,3100730,'2009-11-12 21:12:43',3,1),(6242742,373445,'2008-05-09 19:04:04',2,1),(6242747,19873,'2008-06-02 18:30:23',12,1),(6242753,56648,'2008-06-05 19:20:19',16,1),(6242756,1276166,'2009-05-21 17:09:55',6,1),(6242757,225225,'2008-04-23 00:46:07',4,1),(6242759,225225,'2008-04-23 00:46:13',6,1),(6244541,21109,'2008-06-02 23:03:50',4,1),(6244542,435967,'2007-09-15 23:04:41',1,1),(6244545,435967,'2007-09-15 23:04:42',1,1),(6244550,3132766,'2009-11-16 17:27:53',3,1),(6244551,3132766,'2009-11-16 17:27:53',2,1),(6244552,3132766,'2009-11-16 17:27:53',5,1),(6244554,3132766,'2009-11-16 17:27:53',2,1),(6244556,3132766,'2009-11-16 17:27:53',2,1),(6244558,3132766,'2009-11-16 17:27:53',4,1),(6244561,3132766,'2009-11-16 17:27:53',2,1),(6244562,3132766,'2009-11-16 17:27:53',2,1),(6244759,3132766,'2009-11-16 17:27:53',2,1),(6244763,3132766,'2009-11-16 17:27:52',2,1),(6247260,3100730,'2009-11-12 21:12:40',2,1),(6247267,3100730,'2009-11-12 21:12:40',2,1),(6247268,5107450,'2010-06-29 20:19:04',4,1),(6247269,5107450,'2010-06-29 20:18:44',3,1),(6247270,5107450,'2010-06-29 20:18:45',3,1),(6247271,5107450,'2010-06-29 20:18:44',3,1),(6247273,5107450,'2010-06-29 20:18:45',3,1),(6247274,3100730,'2009-11-12 21:12:40',2,1),(6247278,3100730,'2009-11-12 21:12:40',2,1),(6247279,27626,'2009-04-01 15:50:51',2,1),(6247280,3100730,'2009-11-12 21:12:46',2,1),(6247282,27626,'2009-04-01 15:42:42',2,1),(6247283,3132766,'2009-11-16 17:27:48',2,1),(6247284,3132766,'2009-11-16 17:27:47',2,1),(6247285,3132766,'2009-11-16 17:27:47',2,1),(6247286,3132766,'2009-11-16 17:27:47',2,1),(6247287,3132766,'2009-11-16 17:27:47',2,1),(6247288,3132766,'2009-11-16 17:27:47',2,1),(6247289,3132766,'2009-11-16 17:27:47',2,1),(6247290,3132766,'2009-11-16 17:27:46',2,1),(6247291,3132766,'2009-11-16 17:27:48',2,1),(6247292,3132766,'2009-11-16 17:27:47',2,1),(6247294,3132766,'2009-11-16 17:27:48',2,1),(6247295,3132766,'2009-11-16 17:27:48',2,1),(6247296,3132766,'2009-11-16 17:27:48',2,1),(6248150,3132766,'2009-11-16 17:27:51',2,1),(6248151,3132766,'2009-11-16 17:27:52',2,1),(6248455,3132766,'2009-11-16 17:27:50',2,1),(6248456,3132766,'2009-11-16 17:27:51',2,1),(6248458,3132766,'2009-11-16 17:27:49',2,1),(6248459,3132766,'2009-11-16 17:27:51',2,1),(6248460,3132766,'2009-11-16 17:27:50',2,1),(6248461,3132766,'2009-11-16 17:27:51',2,1),(6248462,3132766,'2009-11-16 17:27:51',2,1),(6248463,3132766,'2009-11-16 17:27:51',2,1),(6248464,3132766,'2009-11-16 17:27:49',2,1),(6248467,3132766,'2009-11-16 17:27:49',2,1),(6248468,3132766,'2009-11-16 17:27:49',2,1),(6248469,3100730,'2009-11-12 21:12:46',2,1),(6249800,3100730,'2009-11-12 21:12:34',2,1),(6249802,3100730,'2009-11-12 21:12:46',2,1),(6249803,3100730,'2009-11-12 21:12:47',2,1),(6250052,3100730,'2009-11-12 21:12:47',2,1),(6250053,3100730,'2009-11-12 21:12:47',2,1),(6250055,3100730,'2009-11-12 21:12:48',2,1),(6250056,3100730,'2009-11-12 21:12:46',2,1),(6250057,3100730,'2009-11-12 21:12:46',2,1),(6250105,3100730,'2009-11-12 21:12:46',2,1),(6250238,3100730,'2009-11-12 21:12:45',2,1),(6250239,3100730,'2009-11-12 21:12:45',2,1),(6250280,3100730,'2009-11-12 21:12:31',2,1),(6267429,3100730,'2009-11-12 21:12:40',2,1),(6267881,5107450,'2010-06-29 20:18:45',4,1),(6267882,5107450,'2010-06-29 20:18:48',3,1),(6267884,3132766,'2009-11-16 17:27:48',2,1),(6268924,3132766,'2009-11-16 17:27:46',2,1),(6269464,3100730,'2009-11-12 21:12:31',2,1),(6275494,3100730,'2009-11-12 21:12:42',3,1),(6275497,3100730,'2009-11-12 21:12:41',2,1),(6275498,3100730,'2009-11-12 21:12:43',2,1),(6275499,3100730,'2009-11-12 21:12:43',2,1),(6275501,3916355,'2010-02-19 17:34:23',8,1),(6275503,443749,'2007-09-16 21:49:38',1,1),(6275504,3916355,'2010-02-19 17:34:14',6,1),(6275505,840745,'2009-01-26 19:28:31',6,1),(6275506,3916355,'2010-02-19 17:34:22',4,1),(6275507,4312140,'2010-04-03 14:51:37',4,1),(6275509,305941,'2009-02-09 21:23:22',3,1),(6275510,3916355,'2010-02-19 17:34:16',4,1),(6275512,3100730,'2009-11-12 21:12:52',5,1),(6275513,981922,'2009-04-27 01:41:06',4,1),(6275514,4652669,'2010-05-09 21:59:04',3,1),(6275516,305941,'2009-02-09 21:34:27',3,1),(6275517,370566,'2008-05-09 02:01:19',2,1),(6275518,3916355,'2010-02-19 17:31:56',4,1),(6275522,621592,'2008-12-26 01:06:21',2,1),(6275851,3100730,'2009-11-12 21:12:50',2,1),(6276661,592895,'2008-07-25 22:14:24',4,1),(6277172,443749,'2007-09-16 22:48:07',1,1),(6277173,443749,'2007-09-16 22:48:09',1,1),(6279235,443749,'2007-09-16 23:40:13',1,1),(6281014,3132766,'2009-11-16 17:28:04',2,1),(6281015,198831,'2008-04-20 16:19:47',2,1),(6281016,3132766,'2009-11-16 17:28:04',3,1),(6281017,3132766,'2009-11-16 17:27:54',2,1),(6281018,3132766,'2009-11-16 17:28:05',2,1),(6281019,3132766,'2009-11-16 17:27:54',3,1),(6281020,3132766,'2009-11-16 17:28:05',3,1),(6281021,3132766,'2009-11-16 17:28:05',2,1),(6281022,3132766,'2009-11-16 17:28:05',3,1),(6281358,553642,'2008-05-31 01:43:35',4,1),(6281360,3132766,'2009-11-16 17:28:07',2,1),(6281361,3132766,'2009-11-16 17:28:07',2,1),(6281741,3132766,'2009-11-16 17:28:05',2,1),(6281751,198831,'2008-04-20 16:20:33',2,1),(6281774,443749,'2007-09-17 01:24:13',1,1),(6281908,3132766,'2009-11-16 17:28:02',2,1),(6281909,3132766,'2009-11-16 17:28:03',2,1),(6281910,3132766,'2009-11-16 17:27:55',2,1),(6281916,3132766,'2009-11-16 17:28:03',2,1),(6282443,3132766,'2009-11-16 17:28:03',4,1),(6282444,3132766,'2009-11-16 17:28:03',2,1),(6282445,3132766,'2009-11-16 17:28:03',3,1),(6282446,3132766,'2009-11-16 17:28:03',2,1),(6282447,3132766,'2009-11-16 17:28:03',2,1),(6282448,3132766,'2009-11-16 17:28:02',2,1),(6282449,3132766,'2009-11-16 17:28:02',3,1),(6282450,3132766,'2009-11-16 17:28:02',2,1),(6282451,3132766,'2009-11-16 17:28:03',2,1),(6282452,3132766,'2009-11-16 17:28:03',2,1),(6541502,5043123,'2010-06-21 17:17:45',3,1),(6541505,495907,'2008-07-15 19:50:57',7,1),(6541507,531541,'2008-05-27 10:39:51',5,1),(6541510,307506,'2009-02-09 17:14:28',2,1),(6541514,3132766,'2009-11-16 17:28:01',2,1),(6541518,3132766,'2009-11-16 17:28:02',2,1),(6541520,3132766,'2009-11-16 17:28:00',4,1),(6541522,3132766,'2009-11-16 17:28:00',2,1),(6541525,3132766,'2009-11-16 17:28:01',2,1),(6541538,5043123,'2010-06-21 17:17:10',6,1),(6541541,3132766,'2009-11-16 17:28:00',4,1),(6548812,3132766,'2009-11-16 17:27:58',2,1),(6548814,3132766,'2009-11-16 17:27:58',2,1),(6548816,3132766,'2009-11-16 17:27:59',2,1),(6548818,3132766,'2009-11-16 17:27:58',2,1),(6548820,4963967,'2010-06-11 20:09:47',4,1),(6548822,3132766,'2009-11-16 17:28:00',2,1),(6548824,3132766,'2009-11-16 17:27:59',3,1),(6548826,3132766,'2009-11-16 17:27:59',3,1),(6551314,3132766,'2009-11-16 17:27:58',4,1),(6551317,531541,'2008-05-27 10:39:54',4,1),(6551320,4963967,'2010-06-11 20:09:48',3,1),(6553102,3132766,'2009-11-16 17:27:58',3,1),(6553108,3132766,'2009-11-16 17:27:56',2,1),(6553398,3132766,'2009-11-16 17:27:58',2,1),(6553516,3132766,'2009-11-16 17:27:56',2,1),(6553741,3132766,'2009-11-16 17:27:58',2,1),(6557168,3132766,'2009-11-16 17:27:59',2,1),(6557169,3132766,'2009-11-16 17:27:59',2,1),(6557171,3132766,'2009-11-16 17:28:00',2,1),(6557173,3132766,'2009-11-16 17:28:00',2,1),(6557177,454632,'2007-09-17 19:11:34',1,1),(6561466,454632,'2007-09-17 19:30:45',1,1),(6561468,3724172,'2010-01-27 00:45:34',6,1),(6561470,454632,'2007-09-17 19:30:48',1,1),(6561682,454632,'2007-09-17 19:33:24',1,1),(6561704,454632,'2007-09-17 19:33:35',1,1),(6561708,5043123,'2010-06-21 17:17:14',3,1),(6563683,4106774,'2010-03-12 16:31:17',4,1),(6563687,320551,'2008-12-11 14:24:02',2,1),(6563690,5671401,'2010-09-03 18:05:59',3,1),(6566558,188228,'2008-06-16 20:03:07',5,1),(6566561,3936411,'2010-02-21 19:45:24',4,1),(6566571,353783,'2008-08-21 18:35:35',2,1),(6566573,369842,'2008-08-22 02:13:49',2,1),(6566576,3100730,'2009-11-12 21:12:55',3,1),(6569859,327248,'2009-04-08 23:18:55',8,1),(6576845,210114,'2008-08-12 23:33:50',2,1),(6576847,226881,'2009-04-05 17:13:36',10,1),(6576853,226881,'2009-04-05 17:13:57',7,1),(6576855,210114,'2008-08-12 23:33:18',2,1),(6576858,3100730,'2009-11-12 21:12:52',3,1),(6576861,3100730,'2009-11-12 21:12:53',2,1),(6576864,3100730,'2009-11-12 21:12:58',2,1),(6576866,3100730,'2009-11-12 21:12:58',2,1),(6578446,423843,'2008-07-08 00:20:56',5,1),(6578449,3100730,'2009-11-12 21:12:58',3,1),(6578451,1075389,'2009-05-04 18:53:55',6,1),(6578454,423843,'2008-07-08 00:22:31',2,1),(6584903,498434,'2008-05-22 18:56:22',6,1),(6584906,615859,'2008-07-28 13:59:42',3,1),(6584908,2836771,'2009-10-13 18:40:57',3,1),(6584910,2836771,'2009-10-13 18:39:07',3,1),(6584917,553642,'2008-05-31 01:43:36',5,1),(6584920,19873,'2008-06-02 18:37:03',3,1),(6584925,19873,'2008-06-02 18:38:06',2,1),(6584928,327248,'2009-04-08 23:43:27',2,1),(6584939,210114,'2008-08-12 23:47:35',3,1),(6584947,19873,'2008-06-02 18:41:19',5,1),(6584951,19873,'2008-06-02 18:40:07',4,1),(6584956,19873,'2008-06-02 18:40:29',4,1),(6584961,3100730,'2009-11-12 21:12:52',2,1),(6588508,104780,'2009-02-04 00:33:00',2,1),(6588510,104780,'2009-02-04 00:29:51',2,1),(6588513,3100730,'2009-11-12 21:12:58',5,1),(6588516,3100730,'2009-11-12 21:12:57',6,1),(6588519,3100730,'2009-11-12 21:12:58',5,1),(6589890,441677,'2008-05-14 00:29:55',4,1),(6589898,19873,'2008-06-02 18:34:56',2,1),(6590538,725665,'2009-03-02 22:10:41',2,1),(6592657,3100730,'2009-11-12 21:12:58',3,1),(6593464,5694915,'2010-09-06 09:25:22',4,1),(6602616,363778,'2007-12-19 18:35:38',3,1),(6620914,3100730,'2009-11-12 21:12:57',2,1),(6620917,3100730,'2009-11-12 21:12:57',2,1),(6620920,3100730,'2009-11-12 21:12:57',2,1),(6620926,3100730,'2009-11-12 21:12:57',2,1),(6620930,3100730,'2009-11-12 21:12:57',2,1),(6620940,870814,'2009-03-31 00:59:28',7,1),(6620947,454632,'2007-09-18 01:05:12',1,1),(6620952,454632,'2007-09-18 01:05:14',1,1),(6620955,454632,'2007-09-18 01:05:15',1,1),(6620958,454632,'2007-09-18 01:05:16',1,1),(6620962,454632,'2007-09-18 01:05:18',1,1),(6620964,454632,'2007-09-18 01:05:19',1,1),(6620969,454632,'2007-09-18 01:05:20',1,1),(6620973,454632,'2007-09-18 01:05:22',1,1),(6620978,454632,'2007-09-18 01:05:22',1,1),(6620980,454632,'2007-09-18 01:05:23',1,1),(7934428,3100730,'2009-11-12 21:12:56',3,1),(7934443,3100730,'2009-11-12 21:12:56',2,1),(8164186,3882859,'2010-02-15 14:55:30',11,1),(8164452,3132766,'2009-11-16 17:27:54',3,1),(8164478,3132766,'2009-11-16 17:27:47',2,1),(8164597,3100730,'2009-11-12 21:12:36',3,1),(8164653,3132766,'2009-11-16 17:27:55',3,1),(8166678,3916410,'2010-02-19 17:39:40',4,1),(8561013,3100730,'2009-11-12 21:12:43',5,1),(8561432,5107450,'2010-06-29 20:18:48',3,1),(8667300,73843,'2007-10-09 23:08:12',1,1),(8880951,3124867,'2009-11-15 19:58:13',2,1),(8880952,3124867,'2009-11-15 19:58:11',8,1),(8880953,4963967,'2010-06-11 20:09:34',10,1),(8880955,3124867,'2009-11-15 19:58:06',2,1),(8880956,3124867,'2009-11-15 19:58:05',13,1),(8885021,3124867,'2009-11-15 19:58:02',5,1),(8885025,3124867,'2009-11-15 19:58:01',9,1),(17240968,557925,'2008-01-06 22:29:17',3,1),(17241049,621592,'2008-12-26 01:06:19',7,1),(22746153,5107412,'2010-06-29 20:14:48',4,1),(22746154,5107412,'2010-06-29 20:14:48',4,1),(22746155,5107412,'2010-06-29 20:14:46',4,1),(22746156,5107412,'2010-06-29 20:14:46',4,1),(22746157,5107412,'2010-06-29 20:14:47',5,1),(22746159,5107412,'2010-06-29 20:14:47',5,1),(22746160,5107412,'2010-06-29 20:14:44',7,1),(22932948,91631,'2008-02-10 16:54:29',1,1),(22932949,433922,'2008-10-19 02:12:05',3,1),(23305160,4159744,'2010-03-18 11:56:45',19,1),(23840927,1276166,'2009-05-21 17:10:34',9,1),(23840928,461502,'2008-05-16 18:35:59',8,1),(23841019,531541,'2008-05-27 10:39:58',7,1),(23841049,531541,'2008-05-27 10:40:16',6,1),(23841094,306164,'2008-05-01 17:05:59',6,1),(23841127,441038,'2008-07-09 18:15:09',14,1),(23841423,423843,'2008-07-08 00:26:53',7,1),(23841426,531541,'2008-05-27 10:39:52',2,1),(23842741,1276166,'2009-05-21 17:10:49',18,1),(23857062,1276166,'2009-05-21 17:09:30',14,1),(23857066,2895121,'2009-10-19 19:12:51',7,1),(23857247,404186,'2008-08-26 00:20:19',3,1),(23877195,5107412,'2010-06-29 20:14:37',10,1),(23877197,531541,'2008-05-27 10:39:45',4,1),(23877199,495907,'2008-07-15 20:26:14',7,1),(23877200,495907,'2008-07-15 20:26:37',11,1),(23877201,531541,'2008-05-27 10:39:42',2,1),(23878263,198831,'2008-04-20 16:36:30',1,1),(23878462,592895,'2008-07-25 22:15:37',5,1),(23878463,592895,'2008-07-25 22:18:15',5,1),(23924998,495907,'2008-07-15 21:08:53',9,1),(23925250,531541,'2008-05-27 10:39:39',8,1),(23925255,531541,'2008-05-27 10:39:40',4,1),(23925285,531541,'2008-05-27 10:40:09',2,1),(23938547,210114,'2008-08-12 23:50:39',5,1),(23978189,362976,'2008-05-08 16:10:19',5,1),(23978342,263367,'2008-04-26 15:38:08',3,1),(23978424,263367,'2008-04-26 15:40:27',1,1),(23978499,263367,'2008-04-26 15:50:01',2,1),(24058474,210114,'2008-08-12 23:49:35',2,1),(24059004,329152,'2008-05-04 19:09:05',3,1),(24059067,553642,'2008-05-31 01:43:50',3,1),(24059068,553642,'2008-05-31 01:43:49',6,1),(24059122,306164,'2008-05-01 17:48:42',3,1),(24059295,306164,'2008-05-01 17:47:55',4,1),(24059296,306164,'2008-05-01 17:49:41',2,1),(24059351,362976,'2008-05-08 16:09:54',3,1),(24059379,362976,'2008-05-08 16:09:46',2,1),(24059392,448710,'2008-05-14 17:05:11',2,1),(24059418,306164,'2008-05-01 17:53:35',1,1),(24059453,370566,'2008-05-09 02:14:33',3,1),(24059572,306164,'2008-05-01 18:03:49',1,1),(24059832,174860,'2008-12-06 16:03:50',3,1),(24059857,19873,'2008-06-02 18:48:24',5,1),(24059999,3100730,'2009-11-12 21:12:58',2,1),(24060059,2369688,'2009-09-04 17:16:28',4,1),(24060260,370566,'2008-05-09 02:22:37',5,1),(24060706,1816161,'2009-07-13 15:53:33',7,1),(24060781,553642,'2008-05-31 01:43:47',5,1),(24060840,1075389,'2009-05-04 18:52:11',17,1),(24240688,2369688,'2009-09-04 17:16:29',3,1),(24240699,352026,'2008-05-06 16:03:01',3,1),(24240709,352026,'2008-05-06 16:02:50',2,1),(24240780,844916,'2009-01-27 19:53:21',10,1),(24240808,844916,'2009-01-27 19:52:23',10,1),(24240825,370566,'2008-05-09 01:42:21',4,1),(24240826,844916,'2009-01-27 19:52:46',6,1),(24240835,844916,'2009-01-27 19:52:38',6,1),(24240868,844916,'2009-01-27 19:51:27',2,1),(24241040,2191053,'2009-08-18 19:10:28',9,1),(24241072,19873,'2008-06-02 18:31:20',6,1),(24241274,352026,'2008-05-06 16:49:21',1,1),(24241278,443527,'2008-05-14 12:04:03',2,1),(24241281,370566,'2008-05-09 01:38:47',2,1),(24241289,352026,'2008-05-06 16:50:08',1,1),(24241364,553642,'2008-05-31 01:43:30',12,1),(24279813,370566,'2008-05-09 01:38:47',1,1),(24279886,370566,'2008-05-09 01:42:20',1,1),(24279950,305941,'2009-02-09 21:22:14',4,1),(24280101,3132766,'2009-11-16 17:27:52',6,1),(24280274,553642,'2008-05-31 01:43:43',3,1),(24280275,553642,'2008-05-31 01:43:42',4,1),(24280276,553642,'2008-05-31 01:43:44',3,1),(24280277,553642,'2008-05-31 01:43:43',4,1),(24280278,3132766,'2009-11-16 17:27:59',3,1),(24280279,3132766,'2009-11-16 17:27:59',2,1),(24280280,531541,'2008-05-27 10:39:40',3,1),(24280281,531541,'2008-05-27 10:39:39',4,1),(24280282,3132766,'2009-11-16 17:27:59',3,1),(24280283,3132766,'2009-11-16 17:27:59',2,1),(24280284,3100730,'2009-11-12 21:12:42',2,1),(24280285,3100730,'2009-11-12 21:12:42',3,1),(24280286,3100730,'2009-11-12 21:12:43',3,1),(24280287,3100730,'2009-11-12 21:12:43',2,1),(24280288,531541,'2008-05-27 10:40:10',3,1),(24280289,531541,'2008-05-27 10:40:10',4,1),(24280290,531541,'2008-05-27 10:40:09',3,1),(24280291,441677,'2008-05-14 00:31:10',2,1),(24280292,56648,'2008-06-05 19:16:08',22,1),(24280293,3373175,'2009-12-14 18:51:01',4,1),(24280294,3373175,'2009-12-14 18:51:01',5,1),(24280295,531541,'2008-05-27 10:39:52',3,1),(24280296,531541,'2008-05-27 10:39:49',4,1),(24341039,412437,'2008-07-07 00:56:27',2,1),(24360470,443527,'2008-05-14 12:04:17',2,1),(24360537,443527,'2008-05-14 12:04:03',2,1),(24360617,437032,'2008-05-13 19:42:40',1,1),(24360845,437032,'2008-05-13 20:08:01',2,1),(24361232,437032,'2008-05-13 20:42:08',2,1),(24361241,437032,'2008-05-13 20:39:44',2,1),(24361307,461502,'2008-05-16 19:16:30',3,1),(24361318,3100730,'2009-11-12 21:12:51',4,1),(24361367,437032,'2008-05-13 20:32:39',2,1),(24361435,56648,'2008-06-05 19:30:45',4,1),(24361575,443527,'2008-05-14 12:04:11',3,1),(24361984,188228,'2008-06-16 18:36:11',10,1),(24362026,437032,'2008-05-13 21:22:13',3,1),(24362252,459604,'2008-05-16 20:57:19',5,1),(24362255,459604,'2008-05-16 20:57:19',3,1),(24362361,188228,'2008-06-16 18:36:12',6,1),(24362714,437032,'2008-05-13 21:50:35',2,1),(24362802,1276166,'2009-05-21 17:14:38',7,1),(24364447,2895121,'2009-10-19 19:15:15',9,1),(24364513,462438,'2008-07-11 13:10:22',9,1),(24364799,459604,'2008-05-16 20:57:20',3,1),(24367429,174860,'2008-12-06 15:53:58',2,1),(24374047,443527,'2008-05-14 12:03:48',1,1),(24374048,206510,'2008-12-06 19:38:24',6,1),(24374049,443527,'2008-05-14 12:03:49',1,1),(24374050,5025265,'2010-06-19 19:15:29',4,1),(24374051,1276166,'2009-05-21 17:03:39',4,1),(24374052,2191328,'2009-08-18 19:42:50',21,1),(24374054,433922,'2008-10-19 02:57:31',3,1),(24374055,433922,'2008-10-19 02:57:31',3,1),(24374056,433922,'2008-10-19 02:57:32',3,1),(24374057,5430086,'2010-08-08 10:43:43',5,1),(24374064,3132766,'2009-11-16 17:27:52',2,1),(24374065,3132766,'2009-11-16 17:27:52',2,1),(24376755,448710,'2008-05-14 17:02:22',2,1),(24376812,448710,'2008-05-14 17:02:52',2,1),(24377511,448710,'2008-05-14 18:16:46',1,1),(24377558,448710,'2008-05-14 18:24:01',1,1),(24377663,448710,'2008-05-14 18:40:23',1,1),(24377667,448710,'2008-05-14 18:41:02',1,1),(24405095,459604,'2008-05-16 20:57:21',3,1),(24405096,459604,'2008-05-16 20:57:21',4,1),(24405131,1276166,'2009-05-21 17:11:01',3,1),(24405159,1276166,'2009-05-21 17:11:27',10,1),(24405221,1276166,'2009-05-21 17:11:19',5,1),(24406052,1276166,'2009-05-21 17:11:41',2,1),(24406326,3956455,'2010-02-23 21:29:46',2,1),(24406327,423843,'2008-07-08 01:18:41',2,1),(24406328,459604,'2008-05-16 21:21:30',1,1),(24406329,862435,'2009-03-27 00:59:25',2,1),(24406331,2357182,'2009-09-03 12:37:32',2,1),(24406332,459604,'2008-05-16 21:21:32',1,1),(24406333,459604,'2008-05-16 21:21:32',1,1),(24406334,459604,'2008-05-16 21:21:32',1,1),(24406335,459604,'2008-05-16 21:21:33',1,1),(24406336,459604,'2008-05-16 21:21:33',1,1),(24413463,462689,'2008-05-17 12:19:49',2,1),(24413466,3916355,'2010-02-19 17:33:03',4,1),(24413467,188228,'2008-06-16 18:35:49',2,1),(24413469,3916355,'2010-02-19 17:33:06',2,1),(24413471,462689,'2008-05-17 12:20:13',3,1),(24430806,462438,'2008-07-11 13:09:45',7,1),(24430807,470312,'2008-05-18 12:17:17',1,1),(24456592,864892,'2009-03-28 17:17:00',9,1),(24492435,498434,'2008-05-22 17:18:57',3,1),(24492437,498434,'2008-05-22 17:19:26',2,1),(24492459,498434,'2008-05-22 17:19:08',4,1),(24492463,498434,'2008-05-22 17:19:50',2,1),(24492623,498434,'2008-05-22 17:37:33',3,1),(24492644,498434,'2008-05-22 17:38:53',2,1),(24492653,498434,'2008-05-22 17:36:59',3,1),(24492657,498434,'2008-05-22 17:38:39',2,1),(24492677,498434,'2008-05-22 17:38:53',1,1),(24492804,553642,'2008-05-31 01:43:48',6,1),(24492831,498434,'2008-05-22 18:00:45',1,1),(24492868,553642,'2008-05-31 01:43:44',5,1),(24492889,553642,'2008-05-31 01:43:44',3,1),(24492906,498434,'2008-05-22 18:10:41',2,1),(24492907,531541,'2008-05-27 10:39:52',4,1),(24493028,498434,'2008-05-22 19:29:26',3,1),(24493045,498434,'2008-05-22 18:25:06',1,1),(24493119,3132766,'2009-11-16 17:27:54',2,1),(24493121,2736717,'2009-10-04 17:29:51',7,1),(24493187,553642,'2008-05-31 01:43:36',4,1),(24493188,553642,'2008-05-31 01:43:35',6,1),(24493245,498434,'2008-05-22 19:43:19',6,1),(24493247,498434,'2008-05-22 18:50:44',3,1),(24493250,498434,'2008-05-22 18:50:53',2,1),(24493261,498434,'2008-05-22 18:51:57',1,1),(24493330,502306,'2008-05-23 10:54:10',2,1),(24493335,498434,'2008-05-22 19:09:02',4,1),(24493338,498434,'2008-05-22 19:02:39',2,1),(24493362,498434,'2008-05-22 19:03:35',1,1),(24493378,498434,'2008-05-22 19:04:03',1,1),(24493431,498434,'2008-05-22 19:07:44',1,1),(24493439,498434,'2008-05-22 19:09:02',1,1),(24493444,498434,'2008-05-22 19:09:45',1,1),(24493526,615859,'2008-07-28 13:58:22',5,1),(24493528,787878,'2009-01-15 00:13:53',6,1),(24493570,498434,'2008-05-22 19:22:39',2,1),(24493584,498434,'2008-05-22 19:21:47',2,1),(24493641,498434,'2008-05-22 19:24:02',1,1),(24493647,498434,'2008-05-22 19:24:40',1,1),(24493659,498434,'2008-05-22 19:25:06',1,1),(24493664,498434,'2008-05-22 19:30:08',2,1),(24493679,498434,'2008-05-22 19:28:13',1,1),(24493789,498434,'2008-05-22 19:41:16',2,1),(24493890,498434,'2008-05-22 19:46:28',2,1),(24493895,498434,'2008-05-22 19:41:45',3,1),(24493896,498434,'2008-05-22 19:41:22',1,1),(24493927,2836771,'2009-10-13 18:41:42',3,1),(24493967,2836771,'2009-10-13 18:46:13',4,1),(24494051,2369688,'2009-09-04 17:16:30',3,1),(24494073,498434,'2008-05-22 19:57:05',1,1),(24494162,2369688,'2009-09-04 17:16:30',3,1),(24494164,498434,'2008-05-22 20:01:08',1,1),(24497076,501202,'2008-05-22 22:31:58',1,1),(24497077,501202,'2008-05-22 22:32:38',2,1),(24512879,508355,'2008-05-24 02:27:42',1,1),(24517626,513066,'2008-05-24 16:04:48',2,1),(24517633,513066,'2008-05-24 15:59:44',2,1),(24517644,513066,'2008-05-24 16:06:38',2,1),(24517841,513066,'2008-05-24 16:12:30',1,1),(24517875,725665,'2009-03-02 22:31:54',6,1),(24517889,513066,'2008-05-24 16:17:44',1,1),(24517907,513066,'2008-05-24 16:19:47',1,1),(24518086,513066,'2008-05-24 16:36:12',3,1),(24518088,513066,'2008-05-24 16:35:58',3,1),(24518115,513066,'2008-05-24 16:36:22',4,1),(24518124,513066,'2008-05-24 16:36:37',2,1),(24663518,19873,'2008-06-02 18:31:12',1,1),(24663520,19873,'2008-06-02 18:32:27',2,1),(24663786,787878,'2009-01-15 00:29:04',2,1),(24663894,3132766,'2009-11-16 17:27:52',3,1),(24664831,21109,'2008-06-02 23:10:19',3,1),(24664867,25362,'2008-06-03 01:06:15',7,1),(24664880,21109,'2008-06-02 23:10:32',3,1),(24665224,21109,'2008-06-02 23:23:02',2,1),(24665257,21109,'2008-06-02 23:21:47',1,1),(24665737,33354,'2008-06-03 03:20:23',8,1),(24665785,21109,'2008-06-02 23:35:16',1,1),(24665811,21109,'2008-06-02 23:36:16',1,1),(24666049,21109,'2008-06-02 23:43:12',1,1),(24666099,21109,'2008-06-02 23:44:43',1,1),(24666136,21109,'2008-06-02 23:46:16',2,1),(24666186,21109,'2008-06-02 23:48:21',1,1),(24668180,25362,'2008-06-03 01:00:46',4,1),(24668181,25362,'2008-06-03 01:00:56',3,1),(24668187,25362,'2008-06-03 01:00:39',2,1),(24668361,25362,'2008-06-03 01:03:49',4,1),(24668372,25362,'2008-06-03 01:04:19',2,1),(24668373,25362,'2008-06-03 01:03:32',2,1),(24668885,2369619,'2009-09-04 17:10:07',6,1),(24668954,25362,'2008-06-03 01:42:20',2,1),(24669163,25362,'2008-06-03 01:42:44',3,1),(24669245,25362,'2008-06-03 01:33:07',1,1),(24669247,2369737,'2009-09-04 17:22:14',3,1),(24669248,25362,'2008-06-03 01:33:26',2,1),(24669306,25362,'2008-06-03 01:36:54',1,1),(24669321,2369737,'2009-09-04 17:22:19',2,1),(24669352,675187,'2008-12-30 16:02:49',2,1),(24669376,25362,'2008-06-03 01:42:02',1,1),(24669430,25362,'2008-06-03 01:42:43',1,1),(24669444,2369688,'2009-09-04 17:16:29',3,1),(24713155,56648,'2008-06-05 18:44:20',4,1),(24713182,2213421,'2009-08-20 19:12:28',5,1),(24713189,56648,'2008-06-05 18:49:46',3,1),(24713210,2191249,'2009-08-18 19:26:22',3,1),(24713222,2191215,'2009-08-18 19:23:39',3,1),(24713246,2191215,'2009-08-18 19:24:01',3,1),(24713303,56648,'2008-06-05 18:48:46',1,1),(24713305,56648,'2008-06-05 18:49:17',2,1),(24713352,2213421,'2009-08-20 19:09:03',5,1),(24713362,2191328,'2009-08-18 19:35:54',3,1),(24713447,2191328,'2009-08-18 19:38:01',3,1),(24713483,56648,'2008-06-05 19:01:56',1,1),(24713502,56648,'2008-06-05 19:03:54',1,1),(24713566,56648,'2008-06-05 19:09:23',2,1),(24713578,56648,'2008-06-05 19:10:29',3,1),(24713611,56648,'2008-06-05 19:10:24',1,1),(24713692,56648,'2008-06-05 19:14:47',1,1),(24713704,56648,'2008-06-05 19:15:46',1,1),(24713904,56648,'2008-06-05 20:23:16',3,1),(24713918,592895,'2008-07-26 00:00:32',9,1),(24713936,56648,'2008-06-05 19:30:31',2,1),(24714294,56648,'2008-06-05 19:58:43',3,1),(24714736,56648,'2008-06-05 20:11:57',4,1),(24714743,592895,'2008-07-25 23:43:01',10,1),(24714892,3100730,'2009-11-12 21:12:51',2,1),(24715008,56648,'2008-06-05 20:26:06',2,1),(24715064,56648,'2008-06-05 20:30:42',3,1),(24715082,3916355,'2010-02-19 17:31:55',6,1),(24715152,840745,'2009-01-26 20:00:24',5,1),(24715185,3916355,'2010-02-19 17:34:27',3,1),(24715324,56648,'2008-06-05 20:39:31',1,1),(24913724,188228,'2008-06-16 18:00:09',2,1),(24913802,188228,'2008-06-16 17:58:16',1,1),(24913861,188228,'2008-06-16 18:02:15',1,1),(24914526,495907,'2008-07-15 17:31:50',3,1),(24914534,495907,'2008-07-15 17:30:04',7,1),(24914563,188228,'2008-06-16 19:09:56',5,1),(24914660,495907,'2008-07-15 17:27:52',4,1),(24914768,3100730,'2009-11-12 21:12:55',2,1),(24914779,188228,'2008-06-16 18:55:07',2,1),(24914843,3916355,'2010-02-19 17:34:18',6,1),(24914870,495907,'2008-07-15 17:30:21',5,1),(24914903,3916355,'2010-02-19 17:34:20',6,1),(24914989,840745,'2009-01-26 20:10:50',5,1),(24915114,3100730,'2009-11-12 21:12:54',2,1),(24915502,188228,'2008-06-16 19:42:28',2,1),(24915504,188228,'2008-06-16 19:42:36',3,1),(24915554,188228,'2008-06-16 20:04:59',5,1),(24915566,188228,'2008-06-16 20:05:18',5,1),(24915617,188228,'2008-06-16 20:06:21',4,1),(24915624,188228,'2008-06-16 19:57:51',3,1),(24915706,188228,'2008-06-16 20:00:07',2,1),(24915763,188228,'2008-06-16 20:02:58',1,1),(24915772,188228,'2008-06-16 20:03:40',2,1),(24915834,188228,'2008-06-16 20:05:47',1,1),(25014753,978767,'2009-04-26 22:35:02',4,1),(25014777,258909,'2008-06-22 19:28:24',1,1),(25415705,2318266,'2009-08-30 23:11:18',6,1),(25416126,1075389,'2009-05-04 18:49:38',3,1),(25416128,206510,'2008-12-06 19:49:43',2,1),(25416227,2369619,'2009-09-04 17:10:08',4,1),(25416308,2369619,'2009-09-04 17:10:07',3,1),(25416371,423843,'2008-07-08 00:20:44',3,1),(25453236,440632,'2008-07-09 16:36:29',2,1),(25453308,440632,'2008-07-09 16:37:16',3,1),(25453310,440632,'2008-07-09 16:36:32',1,1),(25454372,441038,'2008-07-09 18:16:13',2,1),(25454378,844916,'2009-01-27 20:20:59',4,1),(25454381,441038,'2008-07-09 18:18:23',2,1),(25484821,305941,'2009-02-09 21:18:56',2,1),(25484883,495907,'2008-07-15 17:34:41',4,1),(25484912,3916355,'2010-02-19 17:33:27',6,1),(25485099,462438,'2008-07-11 13:31:19',5,1),(25485119,462438,'2008-07-11 13:28:00',1,1),(25485130,592895,'2008-07-25 21:12:34',4,1),(25485131,462438,'2008-07-11 13:29:03',2,1),(25569661,3100730,'2009-11-12 21:12:54',3,1),(25569665,495907,'2008-07-15 17:37:17',2,1),(25569745,2369688,'2009-09-04 17:16:29',4,1),(25569748,495907,'2008-07-15 17:42:48',1,1),(25569755,305941,'2009-02-09 21:21:42',2,1),(25569775,2369688,'2009-09-04 17:16:30',3,1),(25572114,495907,'2008-07-15 20:01:27',2,1),(25572121,495907,'2008-07-15 20:02:55',2,1),(25572130,495907,'2008-07-15 20:02:02',3,1),(25572131,495907,'2008-07-15 20:01:31',1,1),(25572572,495907,'2008-07-15 20:16:37',1,1),(25572731,495907,'2008-07-15 20:24:53',4,1),(25572741,495907,'2008-07-15 20:20:20',1,1),(25572746,495907,'2008-07-15 20:22:38',3,1),(25572749,495907,'2008-07-15 20:22:15',2,1),(25572883,495907,'2008-07-15 20:24:16',1,1),(25573596,495907,'2008-07-15 21:10:05',2,1),(25767814,592895,'2008-07-25 21:11:42',4,1),(25767827,592895,'2008-07-25 21:17:55',2,1),(25767891,592895,'2008-07-25 21:21:32',1,1),(25768003,592895,'2008-07-25 23:31:50',12,1),(25768018,592895,'2008-07-25 23:32:42',12,1),(25768677,592895,'2008-07-25 23:41:05',4,1),(25768681,592895,'2008-07-25 23:27:21',6,1),(25768760,2736717,'2009-10-04 17:29:50',3,1),(25768838,592895,'2008-07-25 22:27:53',3,1),(25768852,592895,'2008-07-25 23:29:46',6,1),(25768868,592895,'2008-07-25 23:30:03',5,1),(25769024,592895,'2008-07-25 23:28:18',5,1),(25769049,592895,'2008-07-25 22:29:13',3,1),(25769050,592895,'2008-07-25 22:27:57',1,1),(25769069,305941,'2009-02-09 21:30:44',4,1),(25769071,592895,'2008-07-25 23:31:04',4,1),(25769112,305941,'2009-02-09 21:29:38',6,1),(25769116,305941,'2009-02-09 21:29:11',3,1),(25769122,592895,'2008-07-25 23:28:00',3,1),(25769124,305941,'2009-02-09 21:30:35',3,1),(25769182,592895,'2008-07-25 22:39:03',3,1),(25769229,2736717,'2009-10-04 17:29:51',3,1),(25769702,3916355,'2010-02-19 17:32:02',3,1),(25769709,592895,'2008-07-25 23:03:33',2,1),(25769726,592895,'2008-07-25 23:40:36',2,1),(25769803,592895,'2008-07-25 23:20:15',6,1),(25769822,592895,'2008-07-25 23:11:46',1,1),(25769829,592895,'2008-07-25 23:20:09',3,1),(25769891,592895,'2008-07-25 23:16:12',1,1),(25769893,592895,'2008-07-25 23:18:32',3,1),(25769922,592895,'2008-07-25 23:19:17',2,1),(25769970,592895,'2008-07-25 23:25:50',4,1),(25769974,592895,'2008-07-25 23:39:24',2,1),(25770088,592895,'2008-07-25 23:26:06',2,1),(25770391,592895,'2008-07-25 23:40:36',1,1),(25770445,592895,'2008-07-25 23:48:10',2,1),(25770728,592895,'2008-07-25 23:57:57',1,1),(25770737,592895,'2008-07-25 23:58:43',1,1),(25770744,592895,'2008-07-25 23:58:57',1,1),(25770745,592895,'2008-07-26 00:01:23',2,1),(25771015,592895,'2008-07-26 00:12:01',1,1),(25771079,592895,'2008-07-26 00:15:23',1,1),(25771241,592895,'2008-07-26 00:33:05',4,1),(25825533,615859,'2008-07-28 13:58:35',1,1),(26001987,72964,'2008-08-05 20:21:08',2,1),(26002036,72964,'2008-08-05 20:37:36',2,1),(26243488,1276166,'2009-05-21 17:09:17',5,1),(26243580,3933161,'2010-02-21 15:14:37',4,1),(26243608,226881,'2009-04-05 17:13:03',3,1),(26243681,210114,'2008-08-12 23:46:32',1,1),(26243895,210114,'2008-08-12 23:52:59',1,1),(26455183,353783,'2008-08-21 18:34:10',2,1),(26553947,565034,'2008-09-07 20:42:42',3,1),(26554007,404186,'2008-08-26 00:23:21',1,1),(26668563,206510,'2008-12-06 20:09:53',4,1),(27826413,3916410,'2010-02-19 17:39:35',2,1),(28828385,174860,'2008-12-06 15:58:00',1,1),(28828388,174860,'2008-12-06 16:20:04',2,1),(28828789,174860,'2008-12-06 16:19:26',1,1),(28829736,174860,'2008-12-06 17:05:28',1,1),(28829748,437534,'2008-12-17 19:04:10',6,1),(28829753,437534,'2008-12-17 18:58:15',5,1),(28829766,437534,'2008-12-17 19:00:45',7,1),(28829773,174860,'2008-12-06 17:07:28',2,1),(28829779,174860,'2008-12-06 17:07:15',1,1),(28829910,174860,'2008-12-06 17:15:19',1,1),(28829964,174860,'2008-12-06 17:17:23',1,1),(28829967,174860,'2008-12-06 17:18:43',3,1),(28832922,206510,'2008-12-06 19:28:04',1,1),(28832923,206510,'2008-12-06 19:28:52',2,1),(28833468,327248,'2009-04-08 23:42:55',4,1),(28833770,4963942,'2010-06-11 20:05:29',4,1),(28833880,5107412,'2010-06-29 20:14:47',4,1),(28833924,5107412,'2010-06-29 20:14:48',2,1),(28833927,5107412,'2010-06-29 20:14:44',3,1),(28833935,5107412,'2010-06-29 20:14:44',2,1),(28833936,5107412,'2010-06-29 20:14:39',3,1),(28833957,5107412,'2010-06-29 20:14:43',2,1),(28833958,5107412,'2010-06-29 20:14:42',3,1),(29051459,437534,'2008-12-17 19:01:56',6,1),(29249135,537461,'2009-04-14 23:04:12',2,1),(29249136,537461,'2009-04-14 23:03:39',2,1),(29249700,537461,'2009-04-14 23:03:33',3,1),(29376254,4099888,'2010-03-11 20:07:08',3,1),(29376356,4083396,'2010-03-09 20:59:22',4,1),(29376448,675187,'2008-12-30 16:00:59',1,1),(29422567,2688289,'2009-09-30 17:08:19',2,1),(30139079,787878,'2009-01-15 00:12:01',1,1),(30139093,787878,'2009-01-15 00:14:32',2,1),(30139242,787878,'2009-01-15 00:22:38',1,1),(30139403,787878,'2009-01-15 00:31:07',1,1),(30139408,787878,'2009-01-15 00:31:30',1,1),(30567238,840745,'2009-01-26 20:04:34',1,1),(30567542,104780,'2009-02-04 00:33:41',2,1),(30571624,840745,'2009-01-26 21:16:49',2,1),(30572100,840745,'2009-01-26 21:17:35',1,1),(30572104,840745,'2009-01-26 21:18:10',2,1),(30572116,844916,'2009-01-27 20:17:20',2,1),(30572138,840745,'2009-01-26 21:18:20',1,1),(30572145,844916,'2009-01-27 20:17:54',2,1),(30572187,840745,'2009-01-26 21:18:53',1,1),(30605340,104780,'2009-02-04 00:28:27',3,1),(30605380,844916,'2009-01-27 19:52:15',2,1),(30605457,844916,'2009-01-27 19:58:51',2,1),(30605650,844916,'2009-01-27 20:05:23',1,1),(30605670,844916,'2009-01-27 20:08:49',3,1),(30605680,844916,'2009-01-27 20:11:15',2,1),(30605683,844916,'2009-01-27 20:10:20',2,1),(30605686,844916,'2009-01-27 20:10:15',1,1),(30605697,844916,'2009-01-27 20:11:39',1,1),(30605698,844916,'2009-01-27 20:11:54',1,1),(30605769,844916,'2009-01-27 20:16:08',1,1),(30772650,104780,'2009-02-04 00:39:24',1,1),(30772702,104780,'2009-02-04 00:41:34',1,1),(30922493,305941,'2009-02-09 21:19:42',2,1),(30922528,305941,'2009-02-09 21:20:30',1,1),(31348544,27626,'2009-04-01 15:32:42',5,1),(31348633,3916410,'2010-02-19 17:39:32',2,1),(31726348,725665,'2009-03-02 22:21:27',4,1),(31726372,1684788,'2009-06-30 11:19:40',3,1),(31726416,725665,'2009-03-02 22:21:19',3,1),(31726467,725665,'2009-03-02 22:21:42',2,1),(31726482,725665,'2009-03-02 22:21:34',2,1),(31726492,725665,'2009-03-02 22:22:38',3,1),(31726507,725665,'2009-03-02 22:22:10',2,1),(31726661,725665,'2009-03-02 22:29:57',6,1),(31726701,725665,'2009-03-02 22:27:42',5,1),(31726779,2736717,'2009-10-04 17:29:50',10,1),(31726812,725665,'2009-03-02 22:34:24',2,1),(31726851,725665,'2009-03-02 22:33:51',3,1),(31726898,725665,'2009-03-02 22:33:31',2,1),(32211744,820251,'2009-03-16 23:50:06',2,1),(32549432,864892,'2009-03-28 14:33:32',2,1),(32549444,862435,'2009-03-27 00:59:14',2,1),(32551123,863220,'2009-03-27 04:33:46',1,1),(32551125,3916410,'2010-02-19 17:39:35',3,1),(32594779,2369737,'2009-09-04 17:22:15',2,1),(32594984,2369737,'2009-09-04 17:22:14',2,1),(32594985,864892,'2009-03-28 14:44:37',1,1),(32598297,327248,'2009-04-08 23:29:12',4,1),(32598300,864892,'2009-03-28 17:17:44',3,1),(32598313,864892,'2009-03-28 17:18:57',3,1),(32598338,864892,'2009-03-28 17:18:39',2,1),(32598345,864892,'2009-03-28 17:18:39',1,1),(32676714,3283462,'2009-12-03 21:54:55',6,1),(32676739,2369619,'2009-09-04 17:10:10',4,1),(32676743,537461,'2009-04-14 23:04:01',2,1),(32676746,870814,'2009-03-31 00:58:28',1,1),(32676749,537461,'2009-04-14 23:03:57',2,1),(32676753,4099383,'2010-03-11 19:09:03',3,1),(32676755,537461,'2009-04-14 23:03:48',2,1),(32722266,181856,'2009-04-04 22:08:21',4,1),(32722447,27626,'2009-04-01 15:29:35',2,1),(32722515,27626,'2009-04-01 15:33:10',2,1),(32722544,27626,'2009-04-01 15:35:06',1,1),(32722657,27626,'2009-04-01 15:43:48',1,1),(32722658,27626,'2009-04-01 15:48:56',3,1),(32722762,372139,'2009-04-10 12:07:13',4,1),(32722815,27626,'2009-04-01 16:02:41',3,1),(32819051,181856,'2009-04-04 22:09:21',2,1),(32819142,181856,'2009-04-04 22:25:06',4,1),(32845037,327248,'2009-04-08 23:30:37',3,1),(32845056,226881,'2009-04-05 17:11:58',3,1),(32845063,226881,'2009-04-05 17:09:50',1,1),(32936885,327248,'2009-04-08 23:14:41',2,1),(32936960,327248,'2009-04-08 23:16:01',1,1),(32937000,327248,'2009-04-08 23:18:02',1,1),(32937225,327248,'2009-04-08 23:29:59',3,1),(32937397,327248,'2009-04-08 23:30:41',1,1),(32937466,327248,'2009-04-08 23:32:52',1,1),(32973912,372139,'2009-04-10 12:07:13',2,1),(33184240,537461,'2009-04-14 23:02:59',1,1),(33184244,537461,'2009-04-14 23:03:02',1,1),(33184247,537461,'2009-04-14 23:03:05',1,1),(33184252,537461,'2009-04-14 23:03:11',1,1),(33184266,537461,'2009-04-14 23:03:26',1,1),(33184270,537461,'2009-04-14 23:03:30',1,1),(33713550,978767,'2009-04-26 22:43:21',2,1),(33721575,981792,'2009-04-27 01:28:18',1,1),(33733175,986514,'2009-04-27 12:35:32',2,1),(34062547,1074615,'2009-05-04 17:28:49',5,1),(34062881,1074615,'2009-05-04 17:26:21',4,1),(34063687,1074615,'2009-05-04 17:29:53',1,1),(34063704,1074615,'2009-05-04 17:30:48',1,1),(34063735,1074615,'2009-05-04 17:33:11',2,1),(34063769,1074615,'2009-05-04 17:35:08',3,1),(34063770,1074615,'2009-05-04 17:34:23',1,1),(34064472,1075282,'2009-05-04 18:32:18',2,1),(34064813,1075282,'2009-05-04 18:32:26',2,1),(34064907,1075235,'2009-05-04 18:23:51',1,1),(34065105,1075282,'2009-05-04 18:32:04',1,1),(34065671,1075389,'2009-05-04 18:51:49',2,1),(34065735,2369619,'2009-09-04 17:10:08',3,1),(34387676,1165666,'2009-05-12 19:50:14',1,1),(34387821,1166143,'2009-05-12 20:31:29',2,1),(34388549,1166143,'2009-05-12 20:30:50',3,1),(34389528,1166268,'2009-05-12 20:58:51',1,1),(34390093,1166650,'2009-05-12 21:14:35',1,1),(34390103,1166792,'2009-05-12 21:24:24',3,1),(34390499,1166792,'2009-05-12 21:23:22',1,1),(34390581,1166792,'2009-05-12 21:24:15',1,1),(34390594,1166792,'2009-05-12 21:26:00',2,1),(34876322,1276166,'2009-05-21 17:06:39',3,1),(34876405,1276166,'2009-05-21 17:07:30',1,1),(35444733,1423654,'2009-06-04 22:58:39',1,1),(37633206,1816099,'2009-07-13 15:48:59',1,1),(37633275,1816161,'2009-07-13 15:54:18',1,1),(37633404,1816208,'2009-07-13 16:02:06',1,1),(37756343,2369619,'2009-09-04 17:10:10',2,1),(37756386,1851615,'2009-07-17 11:55:48',1,1),(37865954,1882243,'2009-07-20 12:44:23',2,1),(38706653,2190495,'2009-08-18 18:22:39',4,1),(38706925,2074369,'2009-08-08 14:56:31',1,1),(38706927,2074369,'2009-08-08 14:57:43',3,1),(38706928,2190826,'2009-08-18 19:02:45',7,1),(38706936,2074369,'2009-08-08 14:56:50',1,1),(39258136,2190594,'2009-08-18 18:34:38',3,1),(39258137,2190594,'2009-08-18 18:33:16',1,1),(39258144,2190594,'2009-08-18 18:33:20',1,1),(39258742,2369737,'2009-09-04 17:22:16',2,1),(39259019,2191053,'2009-08-18 19:10:26',1,1),(39259022,2191053,'2009-08-18 19:10:32',1,1),(39259088,2191112,'2009-08-18 19:16:02',2,1),(39259092,2191112,'2009-08-18 19:15:03',1,1),(39259147,2191112,'2009-08-18 19:17:21',1,1),(39259506,2191328,'2009-08-18 19:37:00',2,1),(39259666,2191328,'2009-08-18 19:39:29',1,1),(39259759,2213421,'2009-08-20 19:10:17',3,1),(39259769,2191328,'2009-08-18 19:42:42',1,1),(39259770,2191328,'2009-08-18 19:43:37',2,1),(40064501,2357182,'2009-09-03 12:35:53',1,1),(40064876,2357182,'2009-09-03 12:40:31',2,1),(40065172,2357182,'2009-09-03 12:41:47',1,1),(40065349,2357481,'2009-09-03 13:10:51',2,1),(40065810,2357481,'2009-09-03 13:05:05',1,1),(40065893,2357481,'2009-09-03 13:08:12',1,1),(40067891,2357704,'2009-09-03 13:39:08',3,1),(40137318,2369688,'2009-09-04 17:16:28',1,1),(40264409,2387382,'2009-09-06 10:39:45',1,1),(40264410,2387382,'2009-09-06 10:39:46',1,1),(41785125,2695454,'2009-10-01 05:43:21',1,1),(41935429,2730324,'2009-10-04 02:19:41',1,1),(42014211,4101446,'2010-03-11 22:58:46',2,1),(42021998,2747796,'2009-10-05 13:48:01',1,1),(42055725,2756081,'2009-10-06 02:46:59',1,1),(42055772,2756091,'2009-10-06 02:48:31',1,1),(42235196,2788592,'2009-10-09 02:31:38',1,1),(42235209,3956455,'2010-02-23 21:29:40',2,1),(42235226,2788608,'2009-10-09 02:33:39',1,1),(42235229,2788613,'2009-10-09 02:34:09',1,1),(42235235,2788617,'2009-10-09 02:34:39',1,1),(42235255,2788624,'2009-10-09 02:36:17',1,1),(42235256,2788624,'2009-10-09 02:36:20',1,1),(42252195,3956455,'2010-02-23 21:29:44',3,1),(42252243,2791237,'2009-10-09 12:39:56',1,1),(42252251,2791237,'2009-10-09 12:40:06',1,1),(42252272,2791248,'2009-10-09 12:40:54',1,1),(42252309,2791251,'2009-10-09 12:41:48',1,1),(42252326,2791253,'2009-10-09 12:42:14',1,1),(42252348,2791257,'2009-10-09 12:42:52',1,1),(42252384,2791267,'2009-10-09 12:44:08',1,1),(42451011,2836771,'2009-10-13 18:41:35',2,1),(42451016,2836771,'2009-10-13 18:42:17',2,1),(42451892,2895121,'2009-10-19 19:04:20',3,1),(42809904,2895121,'2009-10-19 19:08:15',2,1),(42810813,2895121,'2009-10-19 19:18:01',1,1),(42811127,2895121,'2009-10-19 19:21:14',2,1),(45511076,3283462,'2009-12-03 21:53:48',1,1),(45511084,3283462,'2009-12-03 21:54:05',1,1),(45511090,3283462,'2009-12-03 21:54:09',1,1),(48271354,4092807,'2010-03-10 21:54:57',2,1),(48271355,4083044,'2010-03-09 20:12:51',3,1),(48271356,4083024,'2010-03-09 20:10:06',2,1),(48928224,4107810,'2010-03-12 18:34:29',2,1),(48928225,4107810,'2010-03-12 18:34:29',4,1),(48928226,4107810,'2010-03-12 18:34:28',2,1),(48928227,3724172,'2010-01-27 00:45:33',1,1),(48928228,3724172,'2010-01-27 00:45:33',1,1),(48928229,3724172,'2010-01-27 00:45:33',1,1),(48928230,3724172,'2010-01-27 00:45:33',1,1),(48928231,3724172,'2010-01-27 00:45:33',1,1),(48928232,3724172,'2010-01-27 00:45:33',1,1),(48928233,4138831,'2010-03-15 23:33:40',4,1),(48928234,3831437,'2010-02-09 14:01:03',4,1),(48928235,4106774,'2010-03-12 16:31:19',2,1),(48928236,3831437,'2010-02-09 14:01:03',5,1),(48957244,3731738,'2010-01-27 23:25:26',2,1),(48957245,4106774,'2010-03-12 16:31:16',2,1),(48957246,3727238,'2010-01-27 14:00:46',1,1),(48957247,3727238,'2010-01-27 14:00:46',1,1),(48957248,3727238,'2010-01-27 14:00:46',1,1),(48957249,3727238,'2010-01-27 14:00:46',1,1),(48957250,3727238,'2010-01-27 14:00:46',1,1),(48957251,3727238,'2010-01-27 14:00:46',1,1),(48957252,3727238,'2010-01-27 14:00:47',1,1),(48957253,3727238,'2010-01-27 14:00:47',1,1),(48957254,3727238,'2010-01-27 14:00:47',1,1),(48957255,3727238,'2010-01-27 14:00:47',1,1),(48957256,3727238,'2010-01-27 14:00:47',1,1),(48957257,3727238,'2010-01-27 14:00:47',1,1),(48957258,3831437,'2010-02-09 14:01:03',4,1),(48969498,4108069,'2010-03-12 19:04:16',3,1),(48969499,4106774,'2010-03-12 16:31:18',2,1),(48979047,4107810,'2010-03-12 18:34:29',2,1),(48979050,4106774,'2010-03-12 16:31:17',3,1),(48979051,4106774,'2010-03-12 16:31:16',2,1),(48979052,4106774,'2010-03-12 16:31:16',2,1),(48979055,3731738,'2010-01-27 23:25:24',1,1),(48979056,4107810,'2010-03-12 18:34:28',3,1),(48979057,4106774,'2010-03-12 16:31:18',2,1),(48979058,4106774,'2010-03-12 16:31:18',2,1),(48979059,4107810,'2010-03-12 18:34:30',3,1),(48979060,3731738,'2010-01-27 23:25:25',1,1),(48979062,4138831,'2010-03-15 23:33:39',6,1),(48979063,3731738,'2010-01-27 23:25:25',1,1),(50568365,3956455,'2010-02-23 21:29:42',2,1),(50568366,3903073,'2010-02-17 20:32:43',1,1),(50734991,3916410,'2010-02-19 17:39:37',1,1),(52008425,4098931,'2010-03-11 18:10:57',2,1),(52008767,4076872,'2010-03-09 00:33:55',1,1),(52009081,4076934,'2010-03-09 00:40:43',1,1),(52009565,4077060,'2010-03-09 00:55:20',1,1),(52010630,4077213,'2010-03-09 01:15:07',1,1),(52010729,4077244,'2010-03-09 01:19:16',1,1),(52010876,4077310,'2010-03-09 01:28:44',1,1),(52035289,4082908,'2010-03-09 19:56:15',1,1),(52036011,4083737,'2010-03-09 21:36:34',2,1),(52038527,4083476,'2010-03-09 21:09:02',1,1),(52038627,4101592,'2010-03-11 23:12:19',2,1),(52083535,4092743,'2010-03-10 21:47:17',1,1),(52083655,4092770,'2010-03-10 21:50:21',1,1),(52084359,4161868,'2010-03-18 16:48:01',2,1),(52098923,4096040,'2010-03-11 10:54:37',1,1),(52099062,4096095,'2010-03-11 11:05:32',1,1),(52099251,4161868,'2010-03-18 16:48:02',2,1),(52099335,4096186,'2010-03-11 11:22:32',1,1),(52099379,4138831,'2010-03-15 23:33:39',2,1),(52099485,4161868,'2010-03-18 16:48:02',2,1),(52110420,4108069,'2010-03-12 19:04:18',2,1),(52110421,4108069,'2010-03-12 19:04:18',3,1),(52112644,4099383,'2010-03-11 19:09:05',2,1),(52112645,4099383,'2010-03-11 19:09:05',2,1),(52112646,4099383,'2010-03-11 19:09:05',2,1),(52112647,4098931,'2010-03-11 18:10:56',1,1),(52112648,4138831,'2010-03-15 23:33:39',2,1),(52112649,4098931,'2010-03-11 18:10:56',1,1),(52112650,4098931,'2010-03-11 18:10:57',1,1),(52112651,4098931,'2010-03-11 18:10:57',1,1),(52112652,4098931,'2010-03-11 18:10:57',1,1),(52114934,4099383,'2010-03-11 19:09:00',1,1),(52114935,4099383,'2010-03-11 19:09:00',1,1),(52114936,4099383,'2010-03-11 19:09:00',1,1),(52114937,4099383,'2010-03-11 19:09:01',1,1),(52114938,4099383,'2010-03-11 19:09:01',1,1),(52114939,4099383,'2010-03-11 19:09:01',1,1),(52114940,4099383,'2010-03-11 19:09:01',1,1),(52114942,4099383,'2010-03-11 19:09:01',1,1),(52114943,4099383,'2010-03-11 19:09:01',1,1),(52114944,4099383,'2010-03-11 19:09:01',1,1),(52114946,4099383,'2010-03-11 19:09:02',1,1),(52114947,4099383,'2010-03-11 19:09:02',1,1),(52114948,4099383,'2010-03-11 19:09:02',1,1),(52114949,4099383,'2010-03-11 19:09:02',1,1),(52114950,4099383,'2010-03-11 19:09:02',1,1),(52114951,4099383,'2010-03-11 19:09:02',1,1),(52114952,4100909,'2010-03-11 22:03:01',2,1),(52121995,4100978,'2010-03-11 22:09:38',1,1),(52122469,4101078,'2010-03-11 22:19:38',1,1),(52123370,4101245,'2010-03-11 22:37:04',1,1),(52123917,4101313,'2010-03-11 22:45:12',1,1),(52163682,4106774,'2010-03-12 16:31:06',1,1),(52163683,4106774,'2010-03-12 16:31:06',1,1),(52163684,4106774,'2010-03-12 16:31:06',1,1),(52163691,4106774,'2010-03-12 16:31:07',1,1),(52163693,4106774,'2010-03-12 16:31:07',1,1),(52163695,4107810,'2010-03-12 18:34:28',2,1),(52163698,4106774,'2010-03-12 16:31:08',1,1),(52163700,4106774,'2010-03-12 16:31:08',1,1),(52163704,4106774,'2010-03-12 16:31:08',1,1),(52163705,4106774,'2010-03-12 16:31:08',1,1),(52163710,4106774,'2010-03-12 16:31:09',1,1),(52163712,4106774,'2010-03-12 16:31:09',1,1),(52163714,4106774,'2010-03-12 16:31:09',1,1),(52163716,4106774,'2010-03-12 16:31:09',1,1),(52163719,4106774,'2010-03-12 16:31:09',1,1),(52163722,4106774,'2010-03-12 16:31:09',1,1),(52163729,4106774,'2010-03-12 16:31:10',1,1),(52163731,4106774,'2010-03-12 16:31:10',1,1),(52163733,4106774,'2010-03-12 16:31:11',1,1),(52163736,4106774,'2010-03-12 16:31:11',1,1),(52163738,4106774,'2010-03-12 16:31:11',1,1),(52163739,4106774,'2010-03-12 16:31:11',1,1),(52163740,4106774,'2010-03-12 16:31:11',1,1),(52163743,4106774,'2010-03-12 16:31:11',1,1),(52163745,4106774,'2010-03-12 16:31:11',1,1),(52163746,4106774,'2010-03-12 16:31:11',1,1),(52163748,4106774,'2010-03-12 16:31:11',1,1),(52163750,4106774,'2010-03-12 16:31:11',1,1),(52163751,4106774,'2010-03-12 16:31:12',1,1),(52163753,4106774,'2010-03-12 16:31:12',1,1),(52163754,4106774,'2010-03-12 16:31:12',1,1),(52171935,4107810,'2010-03-12 18:34:23',1,1),(52171936,4107810,'2010-03-12 18:34:23',1,1),(52171937,4107810,'2010-03-12 18:34:24',1,1),(52171938,4107810,'2010-03-12 18:34:24',1,1),(52171939,4107810,'2010-03-12 18:34:24',1,1),(52171940,4107810,'2010-03-12 18:34:25',1,1),(52171941,4108069,'2010-03-12 19:04:19',2,1),(52171942,4107810,'2010-03-12 18:34:25',1,1),(52171943,4107810,'2010-03-12 18:34:25',1,1),(52171944,4107810,'2010-03-12 18:34:25',1,1),(52171945,4107810,'2010-03-12 18:34:25',1,1),(52171946,4107810,'2010-03-12 18:34:26',1,1),(52171947,4107810,'2010-03-12 18:34:26',1,1),(52172905,4108069,'2010-03-12 19:04:08',1,1),(52172907,4108069,'2010-03-12 19:04:10',1,1),(52172909,4108069,'2010-03-12 19:04:10',1,1),(52172911,4108069,'2010-03-12 19:04:11',1,1),(52172913,4108069,'2010-03-12 19:04:11',1,1),(52172914,4108069,'2010-03-12 19:04:12',1,1),(52172915,4108069,'2010-03-12 19:04:12',1,1),(52172916,4108069,'2010-03-12 19:04:12',1,1),(52172918,4108069,'2010-03-12 19:04:12',1,1),(52172919,4108069,'2010-03-12 19:04:13',1,1),(52172920,4108069,'2010-03-12 19:04:13',1,1),(52172921,4108069,'2010-03-12 19:04:13',1,1),(52174944,4108991,'2010-03-12 22:26:22',1,1),(52174946,4108991,'2010-03-12 22:26:22',1,1),(52174948,4108991,'2010-03-12 22:26:22',1,1),(52174950,4108991,'2010-03-12 22:26:22',1,1),(52174952,4108991,'2010-03-12 22:26:22',1,1),(52174953,4108991,'2010-03-12 22:26:22',1,1),(52174956,4108991,'2010-03-12 22:26:23',1,1),(52174958,4108991,'2010-03-12 22:26:23',1,1),(52174959,4108991,'2010-03-12 22:26:23',1,1),(52174960,4108991,'2010-03-12 22:26:23',1,1),(52174962,4108991,'2010-03-12 22:26:23',1,1),(52174963,4108991,'2010-03-12 22:26:23',1,1),(52268017,4138831,'2010-03-15 23:33:39',2,1),(52692955,4161539,'2010-03-18 16:04:21',1,1),(52692956,4161539,'2010-03-18 16:04:21',1,1),(52692957,4161911,'2010-03-18 16:53:24',2,1),(52692958,4161539,'2010-03-18 16:04:22',1,1),(52692959,4161539,'2010-03-18 16:04:22',1,1),(52692960,4161539,'2010-03-18 16:04:22',1,1),(52692961,4161539,'2010-03-18 16:04:22',1,1),(52692962,4161539,'2010-03-18 16:04:22',1,1),(52692963,4161539,'2010-03-18 16:04:22',1,1),(52692964,4161539,'2010-03-18 16:04:22',1,1),(52692965,4161539,'2010-03-18 16:04:22',1,1),(52692966,4161539,'2010-03-18 16:04:22',1,1),(52692967,4161539,'2010-03-18 16:04:23',1,1),(52692968,4161539,'2010-03-18 16:04:23',1,1),(52692969,4161539,'2010-03-18 16:04:23',1,1),(52692970,4161539,'2010-03-18 16:04:23',1,1),(52692971,4161539,'2010-03-18 16:04:23',1,1),(52697930,4161868,'2010-03-18 16:47:53',1,1),(52697931,4161868,'2010-03-18 16:47:54',1,1),(52697932,4161868,'2010-03-18 16:47:54',1,1),(52697934,4161868,'2010-03-18 16:47:55',1,1),(52697935,4161868,'2010-03-18 16:47:55',1,1),(52697936,4161868,'2010-03-18 16:47:56',1,1),(52697937,4161868,'2010-03-18 16:47:56',1,1),(52697938,4161868,'2010-03-18 16:47:56',1,1),(52697939,4161868,'2010-03-18 16:47:56',1,1),(52697940,4161868,'2010-03-18 16:47:57',1,1),(52697941,4161868,'2010-03-18 16:47:57',1,1),(52697942,4161868,'2010-03-18 16:47:57',1,1),(52697943,4161868,'2010-03-18 16:47:57',1,1),(52697944,4161868,'2010-03-18 16:47:58',1,1),(52697945,4161868,'2010-03-18 16:47:58',1,1),(52697946,4161868,'2010-03-18 16:47:58',1,1),(52697947,4161868,'2010-03-18 16:47:58',1,1),(52697948,4161868,'2010-03-18 16:47:58',1,1),(52697949,4161868,'2010-03-18 16:47:59',1,1),(52697950,4161868,'2010-03-18 16:47:59',1,1),(52697951,4161868,'2010-03-18 16:47:59',1,1),(52697952,4161868,'2010-03-18 16:48:00',1,1),(54858984,4375683,'2010-04-09 21:07:11',1,1),(61736197,5107412,'2010-06-29 20:14:45',2,1),(61736199,5107412,'2010-06-29 20:14:45',2,1),(61736200,5107412,'2010-06-29 20:14:41',2,1),(61736202,5107412,'2010-06-29 20:14:42',2,1),(61736203,5107412,'2010-06-29 20:14:42',2,1),(61736208,5430086,'2010-08-08 10:43:44',3,1),(61736209,5107412,'2010-06-29 20:14:40',2,1),(70427100,5363414,'2010-07-31 18:33:05',2,1),(70427114,5363414,'2010-07-31 18:41:19',2,1),(70427179,5363414,'2010-07-31 18:45:28',4,1),(70428387,5363414,'2010-07-31 18:38:08',1,1),(75744715,5671401,'2010-09-03 18:05:58',2,1),(75746393,5671401,'2010-09-03 18:05:50',1,1),(75746394,5671401,'2010-09-03 18:05:50',1,1),(75746395,5678739,'2010-09-04 16:07:27',2,1),(75746396,5671401,'2010-09-03 18:05:51',1,1),(75746397,5866046,'2010-09-24 23:01:57',2,1),(75746398,5671401,'2010-09-03 18:05:51',1,1),(75746399,5866046,'2010-09-24 23:01:58',2,1),(75746400,5671401,'2010-09-03 18:05:52',1,1),(75746401,5671401,'2010-09-03 18:05:52',1,1),(75746402,5671401,'2010-09-03 18:05:52',1,1),(75746403,5671401,'2010-09-03 18:05:52',1,1),(75746404,5671401,'2010-09-03 18:05:53',1,1),(75746405,5866046,'2010-09-24 23:01:58',2,1),(75746406,5671401,'2010-09-03 18:05:53',1,1),(75746409,5866082,'2010-09-24 23:06:23',2,1),(75746410,5671401,'2010-09-03 18:05:55',1,1),(75746411,5671401,'2010-09-03 18:05:56',1,1),(75746412,5866046,'2010-09-24 23:01:57',2,1),(75746414,5671401,'2010-09-03 18:05:56',1,1),(75746415,5671401,'2010-09-03 18:05:57',1,1),(75746416,5671401,'2010-09-03 18:05:57',1,1),(75746417,5671401,'2010-09-03 18:05:57',1,1),(75746418,5866046,'2010-09-24 23:01:58',2,1),(75746419,5866046,'2010-09-24 23:01:58',2,1),(75746421,5671401,'2010-09-03 18:05:57',1,1),(75746422,5671401,'2010-09-03 18:05:58',1,1),(75746423,5671401,'2010-09-03 18:05:58',1,1),(75746424,5671401,'2010-09-03 18:05:58',1,1),(75871448,5689624,'2010-09-05 19:39:54',2,1),(77918991,5806005,'2010-09-17 21:30:10',1,1),(79126612,5866082,'2010-09-24 23:06:25',1,1);
